-- MySQL dump 10.13  Distrib 5.7.28, for Linux (x86_64)
--
-- Host: localhost    Database: crossmatch_catalogues
-- ------------------------------------------------------
-- Server version	5.7.28

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `tcs_cat_ned_d_v13_1_0`
--

DROP TABLE IF EXISTS `tcs_cat_ned_d_v13_1_0`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tcs_cat_ned_d_v13_1_0` (
  `primaryId` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'An internal counter',
  `Method` varchar(150) DEFAULT NULL,
  `dateCreated` datetime DEFAULT CURRENT_TIMESTAMP,
  `dateLastModified` datetime DEFAULT CURRENT_TIMESTAMP,
  `updated` varchar(45) DEFAULT '0',
  `dist_derived_from_sn` varchar(150) DEFAULT NULL,
  `dist_in_ned_flag` varchar(10) DEFAULT NULL,
  `dist_index_id` mediumint(9) DEFAULT NULL,
  `dist_mod` double DEFAULT NULL,
  `dist_mod_err` double DEFAULT NULL,
  `dist_mpc` double DEFAULT NULL,
  `galaxy_index_id` mediumint(9) DEFAULT NULL,
  `hubble_const` double DEFAULT NULL,
  `lmc_mod` double DEFAULT NULL,
  `notes` varchar(500) DEFAULT NULL,
  `primary_ned_id` varchar(150) DEFAULT NULL,
  `redshift` double DEFAULT NULL,
  `ref` varchar(150) DEFAULT NULL,
  `ref_date` int(11) DEFAULT NULL,
  `master_row` tinyint(4) DEFAULT '0',
  `major_diameter_arcmin` double DEFAULT NULL,
  `ned_notes` varchar(700) DEFAULT NULL,
  `object_type` varchar(100) DEFAULT NULL,
  `redshift_err` double DEFAULT NULL,
  `redshift_quality` varchar(100) DEFAULT NULL,
  `magnitude_filter` varchar(10) DEFAULT NULL,
  `minor_diameter_arcmin` double DEFAULT NULL,
  `morphology` varchar(50) DEFAULT NULL,
  `hierarchy` varchar(50) DEFAULT NULL,
  `galaxy_morphology` varchar(50) DEFAULT NULL,
  `radio_morphology` varchar(50) DEFAULT NULL,
  `activity_type` varchar(50) DEFAULT NULL,
  `in_ned` tinyint(4) DEFAULT NULL,
  `raDeg` double DEFAULT NULL,
  `decDeg` double DEFAULT NULL,
  `eb_v` double DEFAULT NULL,
  `sdss_coverage` tinyint(4) DEFAULT NULL,
  `htm16ID` bigint(20) DEFAULT NULL,
  `htm13ID` int(11) DEFAULT NULL,
  `htm10ID` int(11) DEFAULT NULL,
  `magnitude` double DEFAULT NULL,
  PRIMARY KEY (`primaryId`),
  UNIQUE KEY `galaxy_index_id_dist_index_id` (`galaxy_index_id`,`dist_index_id`),
  KEY `idx_htm10ID` (`htm10ID`),
  KEY `idx_htm13ID` (`htm13ID`),
  KEY `idx_htm16ID` (`htm16ID`),
  KEY `idx_dist` (`dist_mpc`),
  KEY `idx_redshift` (`redshift`),
  KEY `idx_major_diameter` (`major_diameter_arcmin`),
  KEY `idx_master_name` (`master_row`),
  KEY `idx_magnitude` (`magnitude`),
  KEY `idx_in_ned` (`in_ned`),
  KEY `idx_type` (`object_type`),
  KEY `idx_dist_from_sn` (`dist_derived_from_sn`)
) ENGINE=MyISAM AUTO_INCREMENT=0 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tcs_cat_ned_d_v13_1_0`
--

LOCK TABLES `tcs_cat_ned_d_v13_1_0` WRITE;
/*!40000 ALTER TABLE `tcs_cat_ned_d_v13_1_0` DISABLE KEYS */;
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (1,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13651','RN',1,41.64,0.17,1700,1,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13651',0.249917,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13651','RN',2,42.1,0.21,2110,1,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13651',0.249917,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,3,34.16,0.4,68,2,NULL,NULL,'mean','UGC 12889',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.00003,NULL,'13.4',1.8,'SB(rs)b','in a pair',NULL,NULL,NULL,1,0.00695833333333,47.27478,0.481,NULL,65768857836,1027638403,16056850,13.4),(4,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,4,34.66,0.45,85.6,2,NULL,NULL,'K','UGC 12889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(5,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,5,34.68,0.47,86.1,2,NULL,NULL,'H','UGC 12889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(6,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,6,34.7,0.46,86.9,2,NULL,NULL,'J','UGC 12889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,7,33.52,0.2,50.6,3,74.4,NULL,NULL,'KUG 2357+228',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000007,NULL,'16:',0.2,'Spiral',NULL,NULL,NULL,NULL,1,0.014625,23.08753,0.149,NULL,67176111066,1049626735,16400417,16),(8,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,8,33.73,0.37,55.8,3,NULL,NULL,NULL,'KUG 2357+228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(9,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,9,34.11,0.31,66.3,3,NULL,NULL,'Malmquist cor.','KUG 2357+228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(10,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,10,35.65,0.2,135,4,74.4,NULL,NULL,'KUG 2357+257',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000013,NULL,'16  :',0.3,'Spiral',NULL,NULL,NULL,NULL,1,0.0150833333333,26.01378,0.129,NULL,67186262239,1049785347,16402896,16),(11,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480',NULL,11,40.19,0.3,1090,5,70,NULL,'SN photometric redshift distance, z photo =0.298 +/- 0.054','SDSS-II SN 14480',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.3g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,0.0175417,0.02294,0.105,NULL,66571993739,1040187402,16252928,22.3),(12,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480','R',12,41.2,0.33,1300,5,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14480',0.330796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(13,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480','R',13,41.3,0.32,1370,5,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14480',0.330796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(14,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480',NULL,14,41.07,0.22,1640,5,70,NULL,'SALT 2','SDSS-II SN 14480',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(15,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 14480',NULL,15,41.11,0.22,1670,5,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14480',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(16,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',16,34.91,0.46,96.1,6,70,NULL,NULL,'ARK 590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000107,NULL,'15.6',0.2,'E','Pair member (points to parent)',NULL,NULL,NULL,1,0.0185,-0.08336,0.105,NULL,34359752829,536871137,8388611,15.6),(17,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',17,38.12,0.46,420,7,70,NULL,NULL,'2MASX J00000735+1354360',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,0.030625,13.91017,0.129,NULL,66725093145,1042579580,16290305,18.3),(18,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',18,34.63,0.49,84.3,8,75,NULL,'IR','MCG -01-01-016',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000027,NULL,'14',0.3,'Sa pec?',NULL,NULL,NULL,NULL,1,0.036,-6.374,0.086,NULL,34385298716,537270292,8394848,14),(19,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',19,37.31,0.33,289,9,70,NULL,NULL,'2MASX J00001412-1028463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000094,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,0.0587083,-10.47942,0.091,NULL,34377107298,537142301,8392848,17.1),(20,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,20,34.09,0.43,65.8,10,75,NULL,'3.6 micron, color + selection bias corrected','2MFGC 00003',NULL,'2014MNRAS.444..527S',2014,1,0.89,NULL,'G',NULL,NULL,'11.9K',0.11,'Spiral LSB',NULL,NULL,NULL,NULL,1,0.05975,70.033,NULL,NULL,65567476511,1024491820,16007684,11.9),(21,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,21,36.21,0.65,175,11,70,NULL,NULL,'2MASX J00001440-7652248',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.00015,NULL,'17.0b',0.24,NULL,NULL,NULL,NULL,NULL,1,0.0598333333333,-76.87364,0.217,NULL,35586991773,556046746,8688230,17),(22,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03872','RN',22,43.11,0.34,2950,12,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03872',0.416837,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(23,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03872','RN',23,44.58,0.49,5820,12,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03872',0.416837,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(24,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03706','RN',24,43.55,0.28,3560,13,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03706',0.440239,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(25,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03706','RN',25,43.64,0.36,3720,13,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03706',0.440239,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(26,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,26,35.6,0.48,132,14,70,NULL,NULL,'2MASX J00002213-0137463',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.69',0.2,NULL,NULL,NULL,NULL,NULL,1,0.0922917,-1.62947,0.069,NULL,34361334334,536895848,8388997,16.69),(27,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,27,29.64,NULL,8.47,15,NULL,NULL,NULL,'UGC 12894',NULL,'2013AJ....145..101K',2013,1,0.9,NULL,'G',0.000013,NULL,'17.',0.9,'Im',NULL,NULL,NULL,NULL,1,0.0939583,39.49542,0.433,NULL,67113068615,1048641697,16385026,17),(28,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,28,35.86,0.54,149,16,70,NULL,NULL,'MCG -01-01-018',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.0001,NULL,'14.5',0.3,NULL,NULL,NULL,NULL,NULL,1,0.0979583333333,-6.93625,0.103,NULL,34388583470,537321616,8395650,14.5),(29,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,29,36.2,0.53,174,17,70,NULL,NULL,'2MFGC 00007',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.28',0.2,'S',NULL,NULL,NULL,NULL,1,0.1045417,-26.0445,0.047,NULL,34769089693,543267026,8488547,16.28),(30,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',30,37.58,0.46,328,18,70,NULL,NULL,'SDSS J000027.97-002653.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.116583,-0.44819,0.093,NULL,34359868155,536872939,8388639,17.9),(31,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',31,37.9,0.46,380,19,70,NULL,NULL,'2MASX J00003098+1535090',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,0.1289583,15.58594,0.069,NULL,66731704173,1042682877,16291919,17.6),(32,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',32,37.23,0.46,279,20,70,NULL,NULL,'2MASX J00003136-0927563',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,0.1307083,-9.46558,0.101,NULL,34379094679,537173354,8393333,17.2),(33,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,33,35.43,0.58,122,21,70,NULL,NULL,'CGCG 382-017',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000033,NULL,'15.3',0.45,'poss. LINER?',NULL,NULL,NULL,NULL,1,0.1485,-1.76317,0.069,NULL,34361418120,536897158,8389018,15.3),(34,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,34,36.88,0.77,238,22,70,NULL,NULL,'ESO 293-IG 028 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.98',0.12,NULL,NULL,NULL,NULL,NULL,1,0.1489583,-40.57561,NULL,NULL,34636889595,541201399,8456271,16.98),(35,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,35,34.34,0.2,73.8,23,74.4,NULL,NULL,'UGC 12898',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'16.5',0.4,'Scd:',NULL,NULL,NULL,NULL,1,0.156,33.60128,0.169,NULL,67209538004,1050149031,16408578,16.5),(36,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,36,34.61,0.47,83.5,23,NULL,NULL,NULL,'UGC 12898',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(37,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,37,34.62,0.47,84.1,23,NULL,NULL,'Malmquist cor.','UGC 12898',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(38,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,38,35.3,0.8,115,24,75,NULL,'W91PP, r','UGC 12897',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00003,NULL,'14.84',0.4,'Sab','in a triple',NULL,NULL,NULL,1,0.158083333333,28.38456,0.145,NULL,67213941110,1050217829,16409653,14.84),(39,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,39,35.42,0.38,121,24,75,NULL,'W91PP, r, raw','UGC 12897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(40,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,40,35.49,0.4,125,24,NULL,NULL,'mean','UGC 12897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(41,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,41,35.51,0.46,127,24,NULL,NULL,'J','UGC 12897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(42,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,42,35.53,0.47,128,24,NULL,NULL,'H','UGC 12897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(43,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,43,35.58,0.45,131,24,NULL,NULL,'K','UGC 12897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(44,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,44,35.6,0.38,132,24,75,NULL,'W91PP, r, cor','UGC 12897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(45,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,45,35.74,0.38,141,24,75,NULL,'W91PP, r, inv','UGC 12897',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(46,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',46,36.16,0.46,171,25,70,NULL,NULL,'2MASX J00003983-1109277',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000083,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,0.166083,-11.15769,0.107,NULL,34594630489,540541101,8445954,16.8),(47,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',47,37.92,0.46,384,26,70,NULL,NULL,'2MASX J00004004+1433070',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000211,NULL,'16.1g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,0.166833,14.55214,0.081,NULL,66732611915,1042697061,16292141,16.1),(48,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',48,38.33,0.33,464,27,70,NULL,NULL,'SDSS J000040.27+005634.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.167833,0.94281,0.101,NULL,66572752478,1040199257,16253113,18.3),(49,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',49,36.45,0.46,195,28,70,NULL,NULL,'2MASX J00004214+0001357',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,0.175625,0.02664,0.093,NULL,66572050820,1040188294,16252942,17.4),(50,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,50,36.07,0.56,164,29,70,NULL,NULL,'2MASX J00004283-7217148',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.2b',0.33,NULL,NULL,NULL,NULL,NULL,1,0.178333,-72.28742,0.117,NULL,35572536865,555820888,8684701,16.2),(51,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',51,37.88,0.33,376,30,70,NULL,NULL,'2MASX J00004518+0004329',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,0.18825,0.07586,0.093,NULL,66572021859,1040187841,16252935,18.1),(52,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,52,36.3,0.6,182,31,70,NULL,NULL,'AM 2358-821 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.6b',0.22,NULL,NULL,NULL,NULL,NULL,1,0.191667,-81.96753,0.393,NULL,35473428272,554272316,8660504,16.6),(53,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',53,37.88,0.33,376,32,70,NULL,NULL,'2MASX J00004634+0003548',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,0.193,0.06525,0.093,NULL,66572020548,1040187821,16252934,17.3),(54,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',54,38.33,0.33,464,33,70,NULL,NULL,'2MASX J00005154+0053239',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,0.214833333333,0.88997,0.101,NULL,66572771048,1040199547,16253117,17.6),(55,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,55,36.79,0.57,228,34,70,NULL,NULL,'QP 085',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'14.2R',0.33,NULL,NULL,NULL,NULL,NULL,1,0.218041666667,-35.84367,NULL,NULL,34663634604,541619290,8462801,14.2),(56,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,56,36.39,0.54,190,35,70,NULL,NULL,'QP 086',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'14.5R',0.32,NULL,NULL,NULL,NULL,NULL,1,0.221625,-35.98631,NULL,NULL,34662971414,541608928,8462639,14.5),(57,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',57,37.19,0.46,274,36,70,NULL,NULL,'2MASX J00005350-0106551',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,0.2229583,-1.11528,0.085,NULL,34360032581,536875509,8388679,17.3),(58,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',58,38.98,0.46,624,37,70,NULL,NULL,'SDSS J000055.69+140106.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,0.232083,14.01842,0.153,NULL,66736675101,1042760548,16293133,18.1),(59,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,59,36.48,0.51,198,38,70,NULL,NULL,'2MASX J00005579-2554210',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.39',0.4,NULL,NULL,NULL,NULL,NULL,1,0.232375,-25.90581,0.047,NULL,34769657513,543275898,8488685,16.39),(60,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',60,34.76,0.49,89.4,39,75,NULL,'IR','UGC 12900',NULL,'2011yCatp016004901K',2011,1,2.02,NULL,'G',0.000009,NULL,'15.50',0.17,'Sc',NULL,NULL,NULL,NULL,1,0.2334583,20.338,0.249,NULL,66708168629,1042315134,16286173,15.5),(61,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,61,34.82,NULL,92.1,39,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12900',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(62,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,62,34.83,NULL,92.5,39,NULL,NULL,'Dipole + Quadrupole','UGC 12900',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(63,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,63,34.83,NULL,92.6,39,NULL,NULL,'Dipole','UGC 12900',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(64,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,64,34.87,NULL,94.4,39,NULL,NULL,NULL,'UGC 12900',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(65,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,65,35.23,0.42,111,39,NULL,NULL,'Malmquist cor.','UGC 12900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(66,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,66,35.35,0.2,117,39,74.4,NULL,NULL,'UGC 12900',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(67,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,67,35.43,0.39,122,39,NULL,NULL,NULL,'UGC 12900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(68,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',68,37.98,0.46,394,40,70,NULL,NULL,'2MASX J00005758+1516420',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,0.239875,15.27825,0.049,NULL,66735075126,1042735548,16292742,18.2),(69,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,69,32.89,1.28,37.8,41,NULL,NULL,'Malmquist cor.','ESO 349- G 017',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'13.8R',0.65,'Sc','in a pair',NULL,NULL,NULL,1,0.244083333333,-33.61194,NULL,NULL,34846331036,544473922,8507405,13.8),(70,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,70,33.1,1.16,41.7,41,NULL,NULL,NULL,'ESO 349- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(71,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,71,34.81,0.8,91.4,42,75,NULL,'W91PP, r','UGC 12901',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.60',0.6,'SBb',NULL,NULL,NULL,NULL,1,0.2455,28.91172,0.201,NULL,67214338741,1050224042,16409750,14.6),(72,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,72,34.55,0.38,81.4,42,75,NULL,'W91PP, r, raw','UGC 12901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(73,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,73,34.74,0.38,88.7,42,75,NULL,'W91PP, r, inv','UGC 12901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(74,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,74,34.76,0.38,89.4,42,75,NULL,'W91PP, r, cor','UGC 12901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(75,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,75,34.8,0.45,91,42,NULL,NULL,'Malmquist cor.','UGC 12901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(76,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,76,34.83,0.45,92.3,42,NULL,NULL,NULL,'UGC 12901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(77,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,77,34.95,0.2,97.7,42,74.4,NULL,NULL,'UGC 12901',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(78,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,78,34.99,0.4,99.5,42,NULL,NULL,'mean','UGC 12901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(79,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,79,35.18,0.47,108,42,NULL,NULL,'H','UGC 12901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(80,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,80,35.29,0.46,114,42,NULL,NULL,'J','UGC 12901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(81,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,81,36.28,0.61,180,43,70,NULL,NULL,'2MASX J00010098-4345156',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.43',0.28,NULL,NULL,NULL,NULL,NULL,1,0.254125,-43.75431,NULL,NULL,34628749003,541074203,8454284,16.43),(82,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,82,37.58,0.72,328,44,70,NULL,NULL,'2MASX J00010107-4351356',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.53',0.43,NULL,NULL,NULL,NULL,NULL,1,0.254417,-43.85992,NULL,NULL,34628938009,541077156,8454330,16.53),(83,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17527',NULL,83,39.71,1.31,874,45,70,NULL,'SN photometric redshift distance, z photo =0.230 +/- 0.250','SDSS-II SN 17527',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,0.270541666667,-0.17442,0.093,NULL,34359961624,536874400,8388662,NULL),(84,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13647','RN',84,40.33,0.24,933,46,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13647',0.247602,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(85,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13647','RN',85,40.64,0.24,1070,46,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13647',0.247602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(86,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,86,35.43,0.47,122,47,70,NULL,NULL,'ESO 149- GA011',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'14.52',1.3,'SAB(s)b:',NULL,NULL,NULL,NULL,1,359.8455,-56.33286,0,NULL,48737827021,761528547,11898883,14.52),(87,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19787','R',87,39.81,0.2,766,48,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19787',0.197292,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.281125,-0.09814,0.093,NULL,34359966568,536874477,8388663,NULL),(88,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19787','R',88,39.94,0.26,811,48,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19787',0.197292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(89,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 07383','RN',89,43.78,0.26,3760,49,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07383',0.517065,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(90,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',90,36.27,0.49,179,50,75,NULL,'IR','UGC 12903',NULL,'2011yCatp016004901K',2011,1,1,'The position in 1998PNAOJ...5...75M is -18 arcsec in error.','G',NULL,NULL,'15.56',0.2,'Sbc',NULL,NULL,NULL,NULL,1,0.2844583,6.33717,0.149,NULL,66610351031,1040786734,16262292,15.56),(91,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 06225','R',91,41.55,0.27,1530,51,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06225',0.337597,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.2875,-1.00039,0.081,NULL,34360246114,536878845,8388731,NULL),(92,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 06225','R',92,41.82,0.21,1730,51,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06225',0.337597,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(93,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19323','R',93,39.06,0.12,596,52,70,NULL,'SDSS CAND. SNIb; MLCS2K2; SN 2007nc','SN 2007nc',0.086794,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib?',NULL,NULL,NULL,NULL,1,0.28875,1.06847,0.093,NULL,66572552573,1040196133,16253064,NULL),(94,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19323','R',94,39.34,0.21,680,52,70,NULL,'SDSS CAND. SNIb; SALT 2; SN 2007nc','SN 2007nc',0.086794,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(95,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',95,37.62,0.46,333,53,70,NULL,NULL,'2MASX J00010974-1032350',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,0.2905,-10.54303,0.091,NULL,34377386079,537146657,8392916,17.6),(96,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',96,38.55,0.46,512,54,70,NULL,NULL,'SDSS J000112.64-011341.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.302666666667,-1.22831,0.085,NULL,34363451702,536928932,8389514,18.5),(97,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13087','RN',97,42.56,0.15,2450,55,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13087',0.328875,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(98,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 13087','RN',98,42.57,0.2,2460,55,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13087',0.328875,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(99,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',99,38.56,0.46,515,56,70,NULL,NULL,'SDSS J000114.39+150701.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,0.309958333333,15.11714,0.049,NULL,66733164519,1042705695,16292276,18.6),(100,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,100,34.08,0.8,65.4,57,75,NULL,'W91PP, r','IC 5376',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000013,NULL,'14.59',0.3,'Sab','Group member',NULL,NULL,NULL,1,0.332375,34.52572,0.209,NULL,67126260905,1048847826,16388247,14.59),(101,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,101,34.19,0.38,68.8,57,75,NULL,'W91PP, r, raw','IC 5376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(102,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,102,34.2,0.4,69.1,57,NULL,NULL,'mean','IC 5376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(103,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,103,34.32,0.47,73.2,57,NULL,NULL,'H','IC 5376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(104,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,104,34.36,0.45,74.4,57,NULL,NULL,'K','IC 5376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(105,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,105,34.36,0.46,74.5,57,NULL,NULL,'J','IC 5376',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(106,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,106,34.37,0.38,74.9,57,75,NULL,'W91PP, r, inv','IC 5376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(107,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,107,34.37,0.38,74.9,57,75,NULL,'W91PP, r, cor','IC 5376',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(108,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',108,38.02,0.46,402,58,70,NULL,NULL,'2MASX J00012634-0012327',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,0.359833,-0.20919,0.093,NULL,34359910673,536873604,8388650,17.1),(109,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15756','R',109,42.1,0.28,1890,59,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nf','SDSS J000129.96+001633.5',0.39,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.374833333333,0.27597,0.081,NULL,66572076371,1040188693,16252948,NULL),(110,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15756','R',110,42.65,0.33,2440,59,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nf','SDSS J000129.96+001633.5',0.39,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(111,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006nf',NULL,111,42.04,0.19,2560,59,70,NULL,'SALT 2','SDSS J000129.96+001633.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(112,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SN 2006nf',NULL,112,42.1,0.19,2630,59,70,NULL,'SALT 2, Malmquist cor.','SDSS J000129.96+001633.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(113,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,113,34.04,0.4,64.2,60,NULL,NULL,'mean','NGC 7806',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.31',0.8,'SA(rs)bc? pec','Pair member (points to parent)',NULL,NULL,NULL,1,0.3752083,31.44186,0.161,NULL,67211459616,1050179056,16409047,14.31),(114,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,114,34.16,0.47,67.9,60,NULL,NULL,'H','NGC 7806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,115,34.16,0.45,68.1,60,NULL,NULL,'K','NGC 7806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,116,34.25,0.46,70.9,60,NULL,NULL,'J','NGC 7806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',117,38.26,0.46,448,61,70,NULL,NULL,'2MASX J00013148-1028548',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,0.381167,-10.48181,0.091,NULL,34377501447,537148460,8392944,18),(118,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',118,38.3,0.46,457,62,70,NULL,NULL,'2MASX J00013224+1411079',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000204,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,0.384375,14.18553,0.229,NULL,66732533521,1042695836,16292122,17.6),(119,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,119,35.31,0.53,116,63,70,NULL,NULL,'2MASX J00013295-0726099',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.15',0.61,NULL,NULL,NULL,NULL,NULL,1,0.38725,-7.43619,0.167,NULL,34386970097,537296407,8395256,16.15),(120,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,120,35.61,0.49,132,64,70,NULL,NULL,'6dF J0001340-361900',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,0.39225,-36.31675,NULL,NULL,34662796728,541606198,8462596,14.3),(121,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',121,35.65,0.46,135,65,70,NULL,NULL,'2MASX J00013460+0016281',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,0.3942917,0.27444,0.081,NULL,66572078099,1040188720,16252948,16.4),(122,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 05705','RN',122,41.22,0.12,1400,66,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05705',0.245801,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 05705','RN',123,41.71,0.19,1760,66,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05705',0.245801,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',124,37.54,0.46,322,67,70,NULL,NULL,'2MASX J00013555+1439339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000121,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,0.398333,14.65939,0.085,NULL,66733447883,1042710123,16292345,18.2),(125,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 01127','RN',125,38.42,0.1,447,68,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01127',0.077374,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 01127','RN',126,39.62,0.24,779,68,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01127',0.077374,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,127,36.08,0.51,165,69,70,NULL,NULL,'MCG -03-01-014',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.0001,NULL,'15.30',0.7,NULL,NULL,NULL,NULL,NULL,1,0.40025,-14.74875,0.053,NULL,34467692948,538557702,8414964,15.3),(128,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',128,34.33,0.49,73.6,70,75,NULL,'IR','UGC 12913',NULL,'2011yCatp016004901K',2011,1,1.34,NULL,'G',0.000013,NULL,'16.0',0.17,'Sbc',NULL,NULL,NULL,NULL,1,0.402917,3.50558,0.085,NULL,66582236628,1040347447,16255428,16),(129,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,129,34.5,NULL,79.4,70,NULL,NULL,'Dipole','UGC 12913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,130,34.5,NULL,79.5,70,NULL,NULL,'Dipole + Quadrupole','UGC 12913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,131,34.5,NULL,79.6,70,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,132,34.56,0.2,81.7,70,74.4,NULL,NULL,'UGC 12913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,133,34.61,0.44,83.6,70,NULL,NULL,'Malmquist cor.','UGC 12913',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,134,34.63,0.44,84.1,70,NULL,NULL,NULL,'UGC 12913',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,135,34.79,NULL,90.8,70,NULL,NULL,NULL,'UGC 12913',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136,'Ring Diameter','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,136,32.3,0.84,29,71,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 12914',NULL,'1981ApJS...45..541P',1981,1,2.3,NULL,'G',0.000027,NULL,'13.07',1.3,'(R)S(r)cd: pec LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,0.409667,23.48364,0.145,NULL,67176719875,1049636248,16400566,13.07),(137,'Sosies','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,137,33.57,0.2,51.8,71,NULL,NULL,NULL,'UGC 12914',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,138,33.66,0.47,53.9,71,NULL,NULL,'H','UGC 12914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,139,33.68,0.45,54.5,71,NULL,NULL,'K','UGC 12914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,140,33.73,0.46,55.6,71,NULL,NULL,'J','UGC 12914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,141,33.89,0.4,60,71,NULL,NULL,'mean','UGC 12914',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,142,33.88,0.4,59.7,72,NULL,NULL,'mean','UGC 12915',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000023,NULL,'13.95',0.5,'Sc             LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,0.4247083,23.49589,0.145,NULL,67176651731,1049635183,16400549,13.95),(143,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,143,34.7,0.45,87.2,72,NULL,NULL,'K','UGC 12915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,144,34.72,0.47,87.9,72,NULL,NULL,'H','UGC 12915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,145,34.81,0.46,91.6,72,NULL,NULL,'J','UGC 12915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',146,36.99,0.46,250,73,70,NULL,NULL,'2MASX J00014440+1512150',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,0.4350417,15.20419,0.049,NULL,66735292090,1042738938,16292795,17.2),(147,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',147,37.52,0.46,319,74,70,NULL,NULL,'2MASX J00014456+1453510',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,0.4357083,14.89764,0.049,NULL,66733131336,1042705177,16292268,17.1),(148,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 19550','RN',148,42.38,0.2,2050,75,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19550',0.460945,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,149,36.37,0.54,188,76,70,NULL,NULL,'MCG -01-01-022',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16',0.5,'Sab',NULL,NULL,NULL,NULL,1,0.4387083,-4.34694,0.135,NULL,34364639801,536947496,8389804,16),(150,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 16551','RN',150,40.64,0.27,1030,77,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16551',0.300106,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 16551','RN',151,40.85,0.24,1140,77,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16551',0.300106,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 16551','N',152,40.46,0.19,1240,77,70,NULL,'SALT 2','SDSS-II SN 16551',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 16551','N',153,40.49,0.19,1250,77,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16551',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',154,37.28,0.46,286,78,70,NULL,NULL,'2MASX J00014957-0941379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000089,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,0.4565417,-9.69383,0.085,NULL,34380158874,537189982,8393593,16.6),(155,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',155,37.55,0.46,324,79,70,NULL,NULL,'2MASX J00014953+0034011',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000129,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,0.4565417,0.56694,0.093,NULL,66573020339,1040203442,16253178,16.2),(156,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',156,38.41,0.46,481,80,70,NULL,NULL,'2MASX J00014976+1430480',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,0.457417,14.51333,0.093,NULL,66733420756,1042709699,16292339,17.7),(157,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 10963','RN',157,38.99,0.11,577,81,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10963',0.086122,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 10963','RN',158,39.53,0.21,743,81,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10963',0.086122,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',159,37.54,0.46,322,82,70,NULL,NULL,'2MASX J00015033+0101551',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000095,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,0.459667,1.03203,0.085,NULL,66575513409,1040242397,16253787,16),(160,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,160,35.54,0.32,128,83,NULL,NULL,'Malmquist cor.','ESO 409- G 004',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.4r',0.5,'SA(s)bc',NULL,NULL,NULL,NULL,1,0.48875,-27.99933,0.041,NULL,34821361317,544083770,8501308,14.4),(161,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,161,35.6,0.31,132,83,NULL,NULL,NULL,'ESO 409- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,162,35.64,0.2,134,83,74.4,NULL,NULL,'ESO 409- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163,'Brightest Stars','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,163,24.65,0.46,0.85,84,NULL,NULL,'WLM 15','WLM',NULL,'2003AJ....126.1326V',2003,1,11.5,'Position is for superposed star close to center.','G',0.000007,NULL,'11.03',4,'IB(s)m','Group member',NULL,NULL,NULL,1,0.492333,-15.46092,0.093,0,34468116869,538564326,8415067,11.03),(164,'Brightest Stars','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,164,24.77,NULL,0.9,84,NULL,NULL,'WLM 31','WLM',NULL,'2003AJ....126.1326V',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165,'Brightest Stars','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,165,25.54,NULL,1.28,84,NULL,NULL,'Photographic','WLM',NULL,'1982ApJ...256..339S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,166,24.8,0.06,0.912,84,NULL,18.47,'15, B, Photographic','WLM',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(167,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,167,24.81,0.04,0.916,84,NULL,18.52,NULL,'WLM',NULL,'2011A&A...531A.134T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(168,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,168,24.84,0.14,0.929,84,NULL,NULL,'4','WLM',NULL,'2007A&A...466..501V',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(169,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,169,24.85,0.11,0.933,84,NULL,NULL,'29, JHKs, GAL PL','WLM',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(170,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,170,24.88,0.08,0.946,84,NULL,NULL,'29, JHKs, LMC PL','WLM',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(171,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',171,24.89,0.07,0.951,84,NULL,NULL,'4.5 micron','WLM',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(172,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,172,24.9,0.18,0.955,84,NULL,NULL,'JK(W)','WLM',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(173,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,173,24.92,0.05,0.96,84,74.4,NULL,NULL,'WLM',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(174,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,174,24.92,0.07,0.964,84,NULL,NULL,'29, JHKs, GAL+LMC PL','WLM',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(175,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,175,24.92,NULL,0.964,84,NULL,NULL,NULL,'WLM',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(176,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,176,24.92,0.21,0.964,84,NULL,NULL,'LMC VIHJK','WLM',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(177,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,177,24.92,0.04,0.966,84,NULL,NULL,'31, VIJK','WLM',NULL,'2008ApJ...683..611G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(178,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,178,24.93,NULL,0.968,84,NULL,NULL,'15, B','WLM',NULL,'1985AJ.....90.1464S',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(179,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',179,24.97,0.1,0.986,84,NULL,NULL,'3.6 micron','WLM',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(180,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,180,25.01,0.04,1.01,84,NULL,NULL,'V','WLM',NULL,'2008ApJ...683..611G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(181,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,181,25.08,0.11,1.04,84,NULL,NULL,'VI(W)','WLM',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(182,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,182,25.1,0.15,1.05,84,NULL,NULL,'I','WLM',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(183,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,183,25.14,0.03,1.07,84,NULL,NULL,'60, VI(W)','WLM',NULL,'2007AJ....134..594P',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(184,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',184,25.14,0.03,1.07,84,NULL,NULL,'60, VI(W)','WLM',NULL,'2009RMxAC..35..309G',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(185,'Cepheids','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,185,25.15,NULL,1.07,84,NULL,NULL,'Photographic, APPARENT BLUE m-M','WLM',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(186,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,186,24.73,0.07,0.883,84,NULL,NULL,NULL,'WLM',NULL,'1999ApJ...521..577H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(187,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,187,24.88,0.09,0.946,84,NULL,NULL,NULL,'WLM',NULL,'2000ApJ...531..804D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(188,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,188,24.89,NULL,0.951,84,NULL,NULL,NULL,'WLM',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(189,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,189,24.89,NULL,0.951,84,NULL,NULL,NULL,'WLM',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(190,'CMD','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,190,24.95,0.13,0.977,84,NULL,NULL,NULL,'WLM',NULL,'2000AJ....120..801R',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(191,'FGLR','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,191,24.99,0.1,0.995,84,NULL,NULL,'Flux-Weighted Grav.-Luminosity','WLM',NULL,'2008ApJ...684..118U',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(192,'PNLF','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,192,27.9,0.42,3.8,84,NULL,NULL,NULL,'WLM',NULL,'1981AJ.....86..185J',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(193,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,193,24.75,0.1,0.891,84,NULL,NULL,'I','WLM',NULL,'1997AJ....114..147M',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(194,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,194,24.77,0.09,0.899,84,NULL,NULL,NULL,'WLM',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(195,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,195,24.8,0.05,0.91,84,NULL,NULL,NULL,'WLM',NULL,'1996ApJ...467L..13M',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(196,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,196,24.81,0.1,0.916,84,NULL,NULL,'I','WLM',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(197,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,197,24.82,0.1,0.92,84,NULL,NULL,NULL,'WLM',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(198,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,198,24.84,0.12,0.929,84,NULL,NULL,'HST KP Calibrated','WLM',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(199,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,199,24.85,0.08,0.932,84,NULL,NULL,NULL,'WLM',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(200,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',200,24.85,0.12,0.933,84,NULL,NULL,NULL,'WLM',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(201,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',201,24.89,0.25,0.951,84,NULL,NULL,'K','WLM',NULL,'2011ASPC..445..547T',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(202,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,202,24.92,0.05,0.96,84,74.4,NULL,NULL,'WLM',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(203,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,203,24.93,0.04,0.968,84,NULL,NULL,'I','WLM',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(204,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,204,24.95,0.09,0.977,84,NULL,NULL,'I','WLM',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(205,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,205,24.97,NULL,0.986,84,NULL,NULL,NULL,'WLM',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(206,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,206,24.97,NULL,0.986,84,NULL,NULL,'DA90','WLM',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(207,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,207,24.99,NULL,0.995,84,NULL,NULL,'theory','WLM',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(208,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,208,25.03,NULL,1.01,84,NULL,NULL,'Yale','WLM',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(209,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,209,25.08,NULL,1.04,84,NULL,NULL,'K97','WLM',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(210,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,210,25.12,0.08,1.06,84,NULL,NULL,'K','WLM',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(211,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,211,25.14,0.09,1.07,84,NULL,NULL,'J','WLM',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(212,'Tully est','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,212,25,0.8,1,84,75,NULL,'B','WLM',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(213,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',213,25.88,NULL,1.5,84,NULL,NULL,'LEDA [April 2006]','WLM',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(214,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',214,37.23,0.46,280,85,70,NULL,NULL,'2MASX J00015894-1033259',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,0.4957083,-10.55719,0.082,NULL,34376605956,537134468,8392726,17.4),(215,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','PTF10ubm','N',215,37.24,0.02,262,86,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10ubm',0.0701,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(216,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,216,33.94,NULL,61.3,87,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12905',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',NULL,NULL,'16.5',0.1,'Scd:',NULL,NULL,NULL,NULL,1,0.501667,80.64222,0.925,NULL,65517548075,1023711688,15995495,16.5),(217,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,217,33.95,NULL,61.6,87,NULL,NULL,'Dipole + Quadrupole','UGC 12905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(218,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,218,33.96,NULL,61.8,87,NULL,NULL,'Dipole','UGC 12905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(219,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,219,34.15,NULL,67.6,87,NULL,NULL,NULL,'UGC 12905',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(220,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',220,35.62,0.46,133,88,70,NULL,NULL,'2MASX J00020084+1501320',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.1g',0.32,'S0',NULL,NULL,NULL,NULL,1,0.5034583,15.02564,0.049,NULL,66735151451,1042736741,16292761,16.1),(221,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',221,38.57,0.46,518,89,70,NULL,NULL,'2MASX J00020156-0057403',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.99',0.23,NULL,NULL,NULL,NULL,NULL,1,0.5065417,-0.96131,0.077,NULL,34363566964,536930733,8389542,17.99),(222,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04211','RN',222,41.99,0.32,2000,90,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04211',0.250225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(223,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04211','RN',223,42.37,0.42,2390,90,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04211',0.250225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(224,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',224,37.56,0.23,325,91,70,NULL,NULL,'2MASX J00020361+0037549',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'15.93',0.24,NULL,NULL,NULL,NULL,NULL,1,0.5150417,0.63186,0.093,NULL,66572806323,1040200098,16253126,15.93),(225,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03475','RN',225,40.66,0.32,1040,92,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03475',0.301106,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(226,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 03475','RN',226,41.15,0.3,1300,92,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03475',0.301106,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(227,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',227,36.4,0.46,190,93,70,NULL,NULL,'2MASX J00021021+1408106',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,0.5425,14.13622,0.229,NULL,66732547821,1042696059,16292125,16.6),(228,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,228,25.42,0.08,1.21,94,NULL,NULL,NULL,'Andromeda XVIII',NULL,'2012ApJ...758...11C',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.560417,45.08889,0.445,0,67645954387,1056968037,16515125,NULL),(229,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,229,25.59,0.1,1.31,94,74.4,NULL,NULL,'Andromeda XVIII',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(230,'TRGB','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,230,25.66,0.13,1.36,94,NULL,NULL,'I','Andromeda XVIII',NULL,'2008ApJ...688.1009M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(231,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 04343','RN',231,42.76,0.96,3250,95,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04343',0.094565,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(232,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,232,36.96,0.63,246,96,70,NULL,NULL,'2MASX J00021772-4345168',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.39',0.18,NULL,NULL,NULL,NULL,NULL,1,0.573833333333,-43.75467,NULL,NULL,34628860921,541075951,8454311,17.39),(233,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',233,37.56,0.23,325,97,70,NULL,NULL,'2MASX J00021889+0025270',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,0.5787083,0.42428,0.093,NULL,66573008380,1040203255,16253175,16.9),(234,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,234,37.25,0.8,282,98,70,NULL,NULL,'2MASX J00021977-4352198',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.91',0.28,NULL,NULL,NULL,NULL,NULL,1,0.5825,-43.87211,NULL,NULL,34628873716,541076151,8454314,16.91),(235,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',235,37.8,0.46,363,99,70,NULL,NULL,'2MASX J00022235+0039400',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,0.593125,0.66108,0.105,NULL,66572787521,1040199805,16253121,18.1),(236,'IRAS','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,236,35.02,0.8,101,100,75,NULL,'W91PP, r','UGC 12920',NULL,'1997ApJS..109..333W',1997,1,1.68,NULL,'G',0.000003,NULL,'15.48',0.19,'Sbc',NULL,NULL,NULL,NULL,1,0.59625,27.21067,0.117,NULL,67185397648,1049771838,16402684,15.48),(237,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,237,34.29,NULL,72,100,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(238,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,238,34.3,NULL,72.3,100,NULL,NULL,'Dipole','UGC 12920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(239,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,239,34.3,NULL,72.5,100,NULL,NULL,'Dipole + Quadrupole','UGC 12920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(240,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,240,34.48,NULL,78.6,100,NULL,NULL,NULL,'UGC 12920',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(241,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,241,34.56,0.38,81.7,100,75,NULL,'W91PP, r, raw','UGC 12920',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(242,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,242,34.6,0.38,83.1,100,75,NULL,'W91PP, r, inv','UGC 12920',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(243,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,243,34.68,0.2,86.3,100,74.4,NULL,NULL,'UGC 12920',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(244,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',244,34.74,0.49,88.8,100,75,NULL,'IR','UGC 12920',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(245,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,245,34.77,0.38,89.8,100,75,NULL,'W91PP, r, cor','UGC 12920',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(246,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,246,34.81,0.46,91.6,100,NULL,NULL,NULL,'UGC 12920',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(247,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,247,34.81,0.46,91.7,100,NULL,NULL,'Malmquist cor.','UGC 12920',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(248,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,248,36.71,0.61,220,101,70,NULL,NULL,'2MASX J00022478-5445592',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.60',0.33,NULL,NULL,NULL,NULL,NULL,1,0.6032083,-54.76653,0,NULL,35989504604,562336009,8786500,16.6),(249,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15239',NULL,249,40.38,0.12,1190,102,70,NULL,'SN photometric redshift distance, z photo =0.331 +/- 0.023','SDSS-II SN 15239',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.6g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,0.60625,-0.91847,0.073,NULL,34363601628,536931275,8389551,20.6),(250,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15239','R',250,41.1,0.28,1240,102,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15239',0.334228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(251,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15239','R',251,41.27,0.33,1340,102,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15239',0.334228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(252,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 17900','RN',252,44.18,0.3,4900,103,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17900',0.398526,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(253,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',253,37.53,0.46,320,104,70,NULL,NULL,'2MASX J00023441+1358006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,0.6435,13.96692,0.253,NULL,66736812781,1042762699,16293167,18.3),(254,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,254,34.81,0.4,91.6,105,NULL,NULL,'mean','MCG -01-01-024',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.49',0.8,'SB(s)bc?       HII',NULL,NULL,NULL,NULL,1,0.645041666667,-3.71072,0.133,NULL,34367528567,536992633,8390509,14.49),(255,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,255,34.83,0.41,92.4,105,NULL,NULL,'Malmquist cor.','MCG -01-01-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(256,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,256,35.03,0.38,101,105,NULL,NULL,NULL,'MCG -01-01-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(257,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,257,35.07,0.2,103,105,74.4,NULL,NULL,'MCG -01-01-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(258,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,258,35.11,0.47,105,105,NULL,NULL,'H','MCG -01-01-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(259,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,259,35.2,0.46,109,105,NULL,NULL,'J','MCG -01-01-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(260,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',260,38.04,0.33,405,106,70,NULL,NULL,'2MASX J00023624+0025165',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000094,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,0.650833,0.42119,0.105,NULL,66572815153,1040200236,16253128,17.5),(261,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 01761','RN',261,40.84,0.18,1140,107,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01761',0.291061,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(262,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',262,37.56,0.23,325,108,70,NULL,NULL,'2MASX J00023637+0029445',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,0.6515,0.49572,0.105,NULL,66572817879,1040200279,16253129,18.1),(263,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11382','RN',263,40.46,0.31,1110,109,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11382',0.113498,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(264,'SNIa SDSS','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 11382','RN',264,40.57,0.27,1170,109,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11382',0.113498,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(265,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',265,38.04,0.33,405,110,70,NULL,NULL,'2MASX J00023871+0023105',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000094,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,0.66125,0.38608,0.105,NULL,66572992799,1040203012,16253172,17),(266,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,266,36.93,0.71,243,111,70,NULL,NULL,'LCRS B000005.7-390310',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00012,NULL,'17.00',0.25,NULL,NULL,NULL,NULL,NULL,1,0.6630417,-38.77414,NULL,NULL,34666879270,541669988,8463593,17),(267,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,267,34.26,0.2,71.1,112,74.4,NULL,NULL,'CGCG 408-013',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000834,NULL,'15.83',0.1,'S?',NULL,NULL,NULL,NULL,1,0.66625,8.737,0.213,NULL,66607545527,1040742898,16261607,15.83),(268,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',268,34.34,0.49,73.7,112,75,NULL,'IR','CGCG 408-013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(269,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,269,34.39,0.41,75.3,112,NULL,NULL,NULL,'CGCG 408-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(270,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,270,34.4,0.4,76,112,NULL,NULL,'Malmquist cor.','CGCG 408-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(271,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15850','R',271,40.48,0.21,996,113,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15850 HOST',0.2502,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0.6675,-1.16522,0.069,NULL,34363504302,536929754,8389527,NULL),(272,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15850','R',272,40.76,0.17,1130,113,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15850 HOST',0.2502,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(273,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15850',NULL,273,40.38,0.12,1190,113,70,NULL,'SALT 2','SDSS-II SN 15850 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(274,'SNIa','2016-12-15 15:13:30','2016-12-16 11:18:31','1','SDSS-II SN 15850',NULL,274,40.4,0.12,1200,113,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15850 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(275,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,275,35.81,0.46,145,114,NULL,NULL,NULL,'2MASX J00024069+0846251',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',NULL,NULL,'16.9',0.17,NULL,NULL,NULL,NULL,NULL,1,0.669541666667,8.77367,0.213,NULL,66607531329,1040742677,16261604,16.9),(276,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,276,35.91,0.2,152,114,74.4,NULL,NULL,'2MASX J00024069+0846251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(277,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,277,36.06,0.41,163,114,NULL,NULL,'Malmquist cor.','2MASX J00024069+0846251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(278,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',278,37.56,0.23,325,115,70,NULL,NULL,'2MASX J00024310+0034195',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000089,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,0.6795417,0.572,0.105,NULL,66572791107,1040199861,16253122,17.3),(279,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,'R',279,37.29,0.46,287,116,70,NULL,NULL,'2MASX J00024327-1043148',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,0.680333,-10.72092,0.082,NULL,34594762207,540543159,8445986,17.4),(280,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,280,35.99,0.52,158,117,70,NULL,NULL,'FAIRALL 0626',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.31',0.38,'S0',NULL,NULL,NULL,NULL,1,0.6837917,-43.96717,NULL,NULL,34628990127,541077970,8454343,16.31),(281,'Tully est','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,281,31.84,0.8,23.4,118,75,NULL,NULL,'ESO 012- G 014',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'14.83',1.1,'SB(s)m',NULL,NULL,NULL,NULL,1,0.684083,-80.34653,0.329,NULL,35468662707,554197854,8659341,14.83),(282,'FP','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,282,36.32,0.51,184,119,70,NULL,NULL,'2MASX J00024429-5344549',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.52',0.6,'(RL)SB0/a',NULL,NULL,NULL,NULL,1,0.6845,-53.74858,0,NULL,35989373697,562333964,8786468,15.52),(283,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,283,34.89,0.41,95.1,120,NULL,NULL,'Malmquist cor.','UGC 00003',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000017,NULL,'14.37',0.9,'SBa','Parent (of companion) galaxy',NULL,NULL,NULL,1,0.6932083,18.88622,0.077,NULL,66713409210,1042397018,16287453,14.37),(284,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,284,35.04,0.38,102,120,NULL,NULL,NULL,'UGC 00003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(285,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,285,35.3,0.4,115,120,NULL,NULL,'mean','UGC 00003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(286,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,286,35.32,0.2,116,120,74.4,NULL,NULL,'UGC 00003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(287,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,287,35.44,0.47,122,120,NULL,NULL,'H','UGC 00003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(288,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,288,35.56,0.46,129,120,NULL,NULL,'J','UGC 00003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(289,'Tully-Fisher','2016-12-15 15:13:30','2016-12-16 11:18:31','1',NULL,NULL,289,35.58,0.45,131,120,NULL,NULL,'K','UGC 00003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114861,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114861,32.89,0.8,37.8,50242,75,NULL,'B','NGC 5362',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'13.14',1,'Sb? pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.722083,41.31353,0,NULL,59273807960,926153249,14471144,13.14),(114862,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114862,31.92,0.4,24.2,50242,NULL,NULL,NULL,'NGC 5362',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114863,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114863,32.17,0.43,27.2,50242,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5362',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114864,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114864,32.21,0.43,27.6,50242,75,NULL,'3.6 micron, color corrected','NGC 5362',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114865,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114865,32.21,0.2,27.7,50242,74.4,NULL,NULL,'NGC 5362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114866,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114866,32.28,0.58,28.5,50242,NULL,NULL,NULL,'NGC 5362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114867,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114867,32.32,0.57,29.1,50242,NULL,NULL,'Malmquist cor.','NGC 5362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114868,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114868,32.59,0.46,33,50242,NULL,NULL,'J','NGC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114869,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114869,32.6,0.47,33.2,50242,NULL,NULL,'H','NGC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114870,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114870,32.63,0.4,33.6,50242,NULL,NULL,'mean','NGC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114871,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114871,32.64,0.45,33.8,50242,NULL,NULL,'K','NGC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114872,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114872,36.79,0.46,228,50243,70,NULL,NULL,'LCRS B135220.0-030156',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000113,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.73125,-3.27703,0.093,NULL,43597725547,681214461,10643975,17.5),(114873,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114873,35.29,0.25,114,50244,74.4,NULL,NULL,'IC 4343',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.00007,NULL,'14.8g',0.56,'E/S0           AGN','Group member',NULL,NULL,NULL,1,208.7325,25.12264,0,NULL,59999206937,937487608,14648243,14.8),(114874,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114874,35.5,0.17,126,50244,70,NULL,NULL,'IC 4343',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114875,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114875,35.67,0.16,136,50244,70,NULL,NULL,'IC 4343',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114876,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114876,35.66,0.5,135,50245,70,NULL,NULL,'2MASX J13545583-2717507',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.7b',NULL,'E',NULL,NULL,NULL,NULL,1,208.732667,-27.2975,0.245,NULL,46977330230,734020784,11469074,15.7),(114877,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114877,36.65,0.27,213,50246,70,NULL,NULL,'2MASX J13545710+3309137',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.25',0.17,NULL,NULL,NULL,NULL,NULL,1,208.737875,33.15381,0,NULL,59181926104,924717595,14448712,18.25),(114878,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114878,37.63,0.46,336,50247,70,NULL,NULL,'2MASX J13545807+0946304',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.47',0.13,NULL,NULL,NULL,NULL,NULL,1,208.742,9.77517,0.031,NULL,58465236106,913519314,14273739,18.47),(114879,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114879,35.69,0.51,137,50248,70,NULL,NULL,'2MASX J13545843-1937073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,208.743416667,-19.61883,0.237,NULL,43633884171,681779440,10652803,15.77),(114880,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114880,31.45,0.4,19.5,50249,NULL,NULL,NULL,'NGC 5356',NULL,'2009AJ....138..323T',2009,1,3.71,NULL,'G',0.000017,NULL,'13.3g',0.76,'SABbc: sp      HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.743583,5.33372,0.029,NULL,58435942779,913061605,14266587,13.3),(114881,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114881,31.45,NULL,19.5,50249,72,NULL,NULL,'NGC 5356',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114882,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114882,31.91,0.4,24.1,50249,75,NULL,NULL,'NGC 5356',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114883,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114883,31.95,0.47,24.5,50249,NULL,NULL,'Malmquist cor.','NGC 5356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114884,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114884,31.96,0.4,24.7,50249,NULL,NULL,'mean','NGC 5356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114885,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114885,32.01,0.49,25.2,50249,75,NULL,'IR','NGC 5356',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114886,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114886,32.1,0.46,26.4,50249,NULL,NULL,'J','NGC 5356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114887,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114887,32.11,0.47,26.4,50249,NULL,NULL,'H','NGC 5356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114888,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114888,32.15,0.45,26.9,50249,NULL,NULL,'K','NGC 5356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114889,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114889,32.21,0.41,27.7,50249,NULL,NULL,NULL,'NGC 5356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114890,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114890,32.25,0.2,28.2,50249,74.4,NULL,NULL,'NGC 5356',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114891,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114891,35.98,0.46,157,50250,70,NULL,NULL,'LCRS B135223.4-021916',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'15.9g',0.43,'SB0a',NULL,NULL,NULL,NULL,1,208.7437917,-2.56558,0.105,NULL,43592698786,681135918,10642748,15.9),(114892,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114892,36.04,0.6,161,50250,70,NULL,NULL,'LCRS B135223.4-021916',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114893,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114893,34.67,0.46,85.9,50251,70,NULL,NULL,'CGCG 246-025',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000169,NULL,'15.3g',0.45,'S0',NULL,NULL,NULL,NULL,1,208.745,46.94444,0.007,NULL,59241386326,925646661,14463229,15.3),(114894,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114894,37.15,0.46,269,50252,70,NULL,NULL,'2MASX J13550026+1541164',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.12,NULL,NULL,NULL,NULL,NULL,1,208.7512917,15.68778,0,NULL,58382393269,912224894,14253513,18.43),(114895,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114895,37.25,0.27,281,50253,70,NULL,NULL,'2MASX J13550056+5359421',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,208.75225,53.99508,0,NULL,57285242901,895081920,13985655,16.4),(114896,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114896,37.06,0.33,259,50254,70,NULL,NULL,'2MASX J13550062+1756526',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.15,NULL,NULL,NULL,NULL,NULL,1,208.7525417,17.94803,0,NULL,58373206489,912081351,14251271,18.26),(114897,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114897,37.59,0.46,329,50255,70,NULL,NULL,'2MASX J13550135+4550066',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.755833,45.835,0,NULL,59232944274,925514754,14461168,16.4),(114898,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114898,36.56,0.46,205,50256,70,NULL,NULL,'2MASX J13550168+2442524',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.757083,24.71458,0,NULL,59999045063,937485079,14648204,17),(114899,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114899,37.83,0.46,368,50257,70,NULL,NULL,'SDSS J135503.22+524708.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.7635,52.78558,0,NULL,59218925167,925295705,14457745,17.8),(114900,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114900,37.53,0.19,321,50258,70,NULL,NULL,'2MASX J13550388+2646344',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.76625,26.77611,0.006,NULL,59998030496,937469226,14647956,18.5),(114901,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114901,38.1,0.46,417,50259,70,NULL,NULL,'2MASX J13550399+0542549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.7667083,5.71519,0.021,NULL,58435243119,913050673,14266416,17.6),(114902,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114902,36.6,0.46,209,50260,70,NULL,NULL,'2MASX J13550414+3410108',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,208.767416667,34.16958,0,NULL,59151639007,924244359,14441318,16.3),(114903,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114903,38.09,0.46,416,50261,70,NULL,NULL,'2MASX J13550420+0822404',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000186,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.767625,8.37778,0.023,NULL,58459305256,913426644,14272291,17.2),(114904,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114904,37.88,0.46,376,50262,70,NULL,NULL,'SDSS J135504.46+161139.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.768625,16.19431,0.033,NULL,58384315506,912254929,14253983,17.3),(114905,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114905,30.85,NULL,14.8,50263,72,NULL,NULL,'SDSS J135504.50+051122.2',NULL,'2014Ap.....57..457K',2014,1,0.39,NULL,'G',0.000006,NULL,'16.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,208.768791667,5.18953,0.034,NULL,58435656395,913057131,14266517,16.7),(114906,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114906,37.06,0.33,259,50264,70,NULL,NULL,'2MASX J13550581+1755266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.96',0.15,NULL,NULL,NULL,NULL,NULL,1,208.77425,17.92419,0.008,NULL,58373210096,912081407,14251271,17.96),(114907,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114907,37.2,0.21,275,50265,70,NULL,NULL,'2MASX J13550682+2020186',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,208.7785,20.33856,0.043,NULL,58331884699,911435698,14241182,18.16),(114908,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114908,38.48,0.33,497,50266,70,NULL,NULL,'SDSS J135507.19+531210.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.78,53.20281,0,NULL,59218870904,925294857,14457732,18.5),(114909,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114909,37.07,0.46,259,50267,70,NULL,NULL,'2MASX J13550792+5653401',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.783083333,56.89436,0.009,NULL,57309415034,895459609,13991556,17.6),(114910,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114910,37.24,0.46,280,50268,70,NULL,NULL,'2MASX J13550878+0008379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.786667,0.14381,0.061,NULL,58410807938,912668874,14260451,16.7),(114911,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114911,37.21,0.46,277,50269,70,NULL,NULL,'2MASX J13550898+4007077',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,208.787333,40.11889,0,NULL,59271766802,926121356,14470646,16.8),(114912,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114912,36.42,0.46,192,50270,70,NULL,NULL,'2MASX J13550932+3559417',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,208.788833,35.99508,0,NULL,59152650437,924260163,14441565,16.3),(114913,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114913,36.11,0.46,167,50271,70,NULL,NULL,'2MASX J13551020+5817501',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'15.5g',0.42,'E0',NULL,NULL,NULL,NULL,1,208.792375,58.29739,0.005,NULL,57296419242,895256550,13988383,15.5),(114914,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114914,37.07,0.46,260,50272,70,NULL,NULL,'2MASX J13551124+5831031',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000187,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,208.796667,58.51772,0,NULL,57266062265,894782222,13980972,16),(114915,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114915,35.59,0.46,131,50273,70,NULL,NULL,'CGCG 074-005 NED01',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'15.49',0.37,NULL,NULL,NULL,NULL,NULL,1,208.796958333,10.02197,0.054,NULL,58464869869,913513591,14273649,15.49),(114916,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114916,36.4,0.27,190,50274,70,NULL,NULL,'2MASX J13551133+1436085',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,208.7972917,14.60228,0,NULL,58371039751,912047496,14250742,16.3),(114917,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114917,37.26,0.11,283,50275,70,NULL,NULL,'2MASX J13551211+4620006',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000218,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,208.800333,46.33358,0,NULL,59240429413,925631709,14462995,16),(114918,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114918,36.36,0.61,187,50276,70,NULL,NULL,'ESO 384- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1,'RC3 gives V = 14380 +- 60 km/sec.','G',0.000033,NULL,'15.03',0.7,'S?',NULL,NULL,NULL,NULL,1,208.8022083,-36.31828,0.237,NULL,46892069778,732688590,11448259,15.03),(114919,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114919,35.9,0.41,151,50276,NULL,NULL,'Malmquist cor.','ESO 384- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114920,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114920,36.12,0.37,168,50276,NULL,NULL,NULL,'ESO 384- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114921,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114921,36.16,0.2,171,50276,74.4,NULL,NULL,'ESO 384- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114922,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114922,35.3,0.25,115,50277,74.4,NULL,NULL,'IC 4344',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.00008,NULL,'14.6g',0.7,'SB             AGN','Group member',NULL,NULL,NULL,1,208.8024583,25.02144,0,NULL,59999248173,937488252,14648253,14.6),(114923,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114923,35.5,0.17,126,50277,70,NULL,NULL,'IC 4344',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114924,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114924,37.73,0.46,351,50278,70,NULL,NULL,'2MASX J13551316+2610405',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.53',0.13,NULL,NULL,NULL,NULL,NULL,1,208.8050417,26.17806,0,NULL,59998592328,937478005,14648093,18.53),(114925,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114925,35.3,0.25,115,50279,74.4,NULL,NULL,'IC 4345',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000107,NULL,'14.0g',0.93,'E/S0','Group member',NULL,NULL,NULL,1,208.805791667,25.05181,0,NULL,59999244785,937488199,14648253,14),(114926,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114926,35.5,0.17,126,50279,70,NULL,NULL,'IC 4345',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114927,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114927,35.67,0.16,136,50279,70,NULL,NULL,'IC 4345',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114928,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114928,37.2,0.21,275,50280,70,NULL,NULL,'2MASX J13551530+2028466',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.813667,20.47969,0.043,NULL,58332099066,911439047,14241235,17.4),(114929,'Ring Diameter','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114929,32.7,0.84,34,50281,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5376',NULL,'1981ApJS...45..541P',1981,1,1.74,NULL,'G',0.000003,NULL,'12.9g',0.9,'SAB(r)b?','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.8169583,59.50661,0,NULL,57273905660,894904775,13982887,12.9),(114930,'Sosies','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114930,33.72,0.15,55.5,50281,NULL,NULL,NULL,'NGC 5376',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114931,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114931,32.63,0.8,33.6,50281,75,NULL,'B','NGC 5376',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114932,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114932,32.63,0.43,33.6,50281,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5376',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114933,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114933,32.69,0.43,34.6,50281,75,NULL,'3.6 micron, color corrected','NGC 5376',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114934,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114934,32.82,0.2,36.6,50281,74.4,NULL,NULL,'NGC 5376',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114935,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114935,36.24,0.55,177,50282,70,NULL,NULL,'2MASX J13551657-5025389',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,208.819,-50.42753,1.009,NULL,46821218596,731581540,11430961,17),(114936,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114936,37.25,0.27,281,50283,70,NULL,NULL,'2MASX J13551803+5402151',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.825083,54.03769,0,NULL,57285279486,895082491,13985663,17),(114937,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114937,36.91,0.46,241,50284,70,NULL,NULL,'2MASX J13551816+3410148',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,208.82575,34.17089,0,NULL,59151639040,924244360,14441318,16),(114938,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114938,37.79,0.46,362,50285,70,NULL,NULL,'2MASX J13551844+2124086',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.82675,21.40244,0.011,NULL,58319732197,911245815,14238215,17.2),(114939,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114939,37.85,0.33,372,50286,70,NULL,NULL,'2MASX J13551953+3525428',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.8314583,35.42856,0,NULL,59152566436,924258850,14441544,17.3),(114940,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114940,37.53,0.19,321,50287,70,NULL,NULL,'2MASX J13551957+2645535',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.831625,26.76481,0.006,NULL,59998042886,937469420,14647959,17.2),(114941,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114941,37.74,0.46,354,50288,70,NULL,NULL,'2MASX J13551971+2346566',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.8322917,23.78231,0,NULL,59462115191,929095549,14517117,17.8),(114942,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114942,37.53,0.19,321,50289,70,NULL,NULL,'2MASX J13552046+2649435',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.835458333,26.82883,0.006,NULL,59998040353,937469380,14647959,17.9),(114943,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114943,37.53,0.19,321,50290,70,NULL,NULL,'2MASX J13552135+2641315',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.839167,26.69217,0.006,NULL,59998155885,937471185,14647987,18.1),(114944,'IRAS','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114944,32.16,0.8,27,50291,75,NULL,'MAT, I','ESO 271- G 004',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.59',0.6,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.842625,-44.47839,0.337,NULL,46917772916,733090201,11454534,14.59),(114945,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114945,30.85,0.32,14.8,50291,85,NULL,'I, inv','ESO 271- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114946,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114946,30.89,0.32,15.1,50291,85,NULL,'I, raw','ESO 271- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114947,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114947,31.22,0.43,17.5,50291,75,NULL,'MAT, I, inv','ESO 271- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114948,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114948,31.3,0.43,18.2,50291,75,NULL,'MAT, I, raw','ESO 271- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114949,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114949,31.67,0.43,21.5,50291,75,NULL,'MAT, I, cor','ESO 271- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114950,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114950,32.44,0.49,30.7,50291,75,NULL,'IR','ESO 271- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114951,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114951,37.12,0.33,266,50292,70,NULL,NULL,'2MASX J13552295+2328110',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,208.845625,23.46986,0,NULL,59462420700,929100323,14517192,18.51),(114952,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114952,37.2,0.21,275,50293,70,NULL,NULL,'2MASX J13552314+2025010',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.98',0.18,NULL,NULL,NULL,NULL,NULL,1,208.846417,20.41714,0.043,NULL,58332095696,911438995,14241234,17.98),(114953,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114953,38.63,0.46,531,50294,70,NULL,NULL,'SDSS J135524.15+074630.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.850667,7.77506,0,NULL,58459859136,913435299,14272426,18.5),(114954,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114954,31.73,0.4,22.2,50295,75,NULL,'B','UGC 08839',NULL,'1988NBGC.C....0000T',1988,1,4,NULL,'G',0.000008,NULL,'13.6',2.7,'Im',NULL,NULL,NULL,NULL,1,208.854,17.79494,0.008,NULL,58373276181,912082440,14251288,13.6),(114955,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114955,37,0.46,251,50296,70,NULL,NULL,'2MASX J13552492+3735536',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.85375,37.59814,0,NULL,59155367138,924302611,14442228,16.6),(114956,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114956,37.53,0.19,321,50297,70,NULL,NULL,'MCG +05-33-019',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,208.853875,26.79408,0.006,NULL,59998040730,937469386,14647959,15.6),(114957,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114957,37.41,0.46,303,50298,70,NULL,NULL,'2MASX J13552611+1847510',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.31',0.16,NULL,NULL,NULL,NULL,NULL,1,208.85875,18.79739,0.043,NULL,58329002491,911390663,14240479,18.31),(114958,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114958,37.85,0.33,372,50299,70,NULL,NULL,'2MASX J13552621+3525443',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000154,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.859167,35.42892,0,NULL,59152577999,924259031,14441547,17),(114959,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114959,37.11,0.46,264,50300,70,NULL,NULL,'2MASX J13552785+2506555',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.865917,25.11544,0,NULL,59999080908,937485639,14648213,16.9),(114960,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114960,37.72,0.19,351,50301,70,NULL,NULL,'SDSS J135528.70+193432.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.869625,19.57567,0.051,NULL,58328626400,911384787,14240387,18.1),(114961,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114961,37.34,0.46,294,50302,70,NULL,NULL,'2MASX J13552908+2101350',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.871167,21.02653,0.031,NULL,58331258513,911425914,14241029,17.2),(114962,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114962,35.65,0.47,135,50303,NULL,NULL,'H','UGC 08842 NED02',NULL,'2007A&A...465...71T',2007,1,1.58,'Component \'b)\' in UGC notes.','G',0.00016,NULL,'15.93',0.37,'Sc             PAS','Compact group member',NULL,NULL,NULL,1,208.874,25.07367,0,NULL,59999109142,937486080,14648220,15.93),(114963,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114963,35.71,0.4,139,50303,NULL,NULL,'mean','UGC 08842 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114964,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114964,35.75,0.45,141,50303,NULL,NULL,'K','UGC 08842 NED02',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114965,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114965,37.77,0.46,359,50304,70,NULL,NULL,'2MASXi J1355299+401229',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.875041667,40.20825,0,NULL,59271693343,926120208,14470628,17.7),(114966,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114966,36.34,0.46,186,50305,70,NULL,NULL,'2MASX J13553328+5439341',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000173,NULL,'16.2g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,208.888625,54.65956,0,NULL,57285372595,895083946,13985686,16.2),(114967,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114967,37.47,0.46,311,50306,70,NULL,NULL,'2MASX J13553359+1722209',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.46',0.16,NULL,NULL,NULL,NULL,NULL,1,208.8900417,17.37264,0.014,NULL,58381396658,912209322,14253270,18.46),(114968,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114968,36.4,0.27,190,50307,70,NULL,NULL,'CGCG 103-008',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000093,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,208.890541667,14.76464,0,NULL,58371062696,912047854,14250747,15.7),(114969,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114969,36.44,0.46,194,50308,70,NULL,NULL,'2MASX J13553422+2309020',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.42',0.2,NULL,NULL,NULL,NULL,NULL,1,208.8927083,23.15047,0,NULL,59462492669,929101447,14517210,17.42),(114970,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114970,30.55,0.2,12.9,50309,74.4,NULL,NULL,'NGC 5379',NULL,'2013AJ....146...86T',2013,1,1.88,NULL,'G',0.000017,NULL,'13.9g',0.61,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,208.893,59.74281,0,NULL,57276723698,894948807,13983575,13.9),(114971,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114971,30.95,0.45,15.5,50309,NULL,NULL,'K','NGC 5379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114972,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114972,32.26,0.4,28.3,50309,NULL,NULL,'mean','NGC 5379',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114973,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114973,35.29,0.25,114,50310,74.4,NULL,NULL,'CGCG 132-048',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.00009,NULL,'15.4g',0.38,'SBb','Group member',NULL,NULL,NULL,1,208.8932917,25.04978,0,NULL,59999101867,937485966,14648218,15.4),(114974,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114974,35.5,0.17,126,50310,70,NULL,NULL,'CGCG 132-048',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114975,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114975,38.89,0.46,600,50311,70,NULL,NULL,'2MASX J13553562+2210060',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.36',0.15,NULL,NULL,NULL,NULL,NULL,1,208.89825,22.16817,0,NULL,59460538521,929070914,14516733,18.36),(114976,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114976,36.49,0.46,198,50312,70,NULL,NULL,'2MASX J13553600+0635374',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.900083333,6.59367,0.023,NULL,58456236192,913378690,14271542,16.6),(114977,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114977,37.2,0.21,275,50313,70,NULL,NULL,'2MASX J13553609+2011570',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.9002917,20.19928,0.048,NULL,58331861723,911435339,14241177,17.7),(114978,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114978,38.24,0.46,445,50314,70,NULL,NULL,'SDSS J135537.04+035949.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,208.904333,3.99697,0.063,NULL,58407365252,912615082,14259610,18.5),(114979,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114979,37.14,0.46,268,50315,70,NULL,NULL,'SDSS J135537.61+500624.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,208.9067083,50.10672,0,NULL,59219604521,925306320,14457911,18),(114980,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114980,37.83,0.33,368,50316,70,NULL,NULL,'2MASX J13553774+4333387',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.90725,43.56089,0,NULL,59264207086,926003235,14468800,17.1),(114981,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114981,37.84,0.46,370,50317,70,NULL,NULL,'2MASX J13553819+4938051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.909167,49.63492,0,NULL,59212247339,925191364,14456115,17.7),(114982,'Tully est','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114982,31.8,0.8,22.9,50318,75,NULL,'B','NGC 5360',NULL,'1988NBGC.C....0000T',1988,1,2.2,'Identification as IC 0958 is not certain.','G',0.00003,NULL,'14.1B',0.8,'I0','in a pair',NULL,NULL,NULL,1,208.9114583,4.98506,0.061,NULL,58435668768,913057324,14266520,14.1),(114983,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114983,31.66,NULL,21.5,50318,72,NULL,NULL,'NGC 5360',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114984,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114984,37.59,0.46,330,50319,70,NULL,NULL,'2MASX J13553903+6339266',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.912833333,63.65742,0.029,NULL,57932621198,905197206,14143706,17.3),(114985,'Sosies','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114985,32.57,0.36,32.7,50320,NULL,NULL,NULL,'NGC 5371',NULL,'2002A&A...393...57T',2002,1,4.4,'Identification as NGC 5390 is not certain.','G',0.00001,NULL,'11.32',3.5,'SAB(rs)bc;Sy?  LINER','in a radial-velocity based grouping',NULL,NULL,'Sy ?',1,208.916416667,40.46175,0,NULL,59271117469,926111210,14470487,11.32),(114986,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114986,31.8,0.45,23,50320,NULL,NULL,'K','NGC 5371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114987,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114987,31.82,0.47,23.1,50320,NULL,NULL,'H','NGC 5371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114988,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114988,31.85,0.46,23.4,50320,NULL,NULL,'J','NGC 5371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114989,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114989,32.39,NULL,30.1,50320,NULL,NULL,'LEDA [April 2006]','NGC 5371',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114990,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114990,32.84,0.4,36.9,50320,NULL,NULL,'mean','NGC 5371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114991,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114991,32.89,0.4,37.8,50320,75,NULL,'B','NGC 5371',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114992,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114992,38.28,0.46,454,50321,70,NULL,NULL,'2MASX J13554045+3052363',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,208.91875,30.87683,0,NULL,59127713177,923870518,14435476,17.7),(114993,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114993,37.11,0.46,264,50322,70,NULL,NULL,'2MASX J13554159+0251529',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,208.9234583,2.86475,0.049,NULL,58414121461,912720647,14261260,17.3),(114994,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114994,37.7,0.46,346,50323,70,NULL,NULL,'2MASX J13554172+0530529',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000168,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,208.923917,5.51464,0.038,NULL,58435229024,913050453,14266413,16.6),(114995,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114995,31.89,0.25,23.9,50324,74.4,NULL,NULL,'ESO 384- G 013',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000063,NULL,'13.94',1.1,'SA(r)0^0^?',NULL,NULL,NULL,NULL,1,208.924041667,-33.72486,0.209,NULL,46883625944,732556655,11446197,13.94),(114996,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114996,33.28,0.45,45.3,50324,NULL,NULL,'K','ESO 384- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114997,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,114997,33.68,0.4,54.4,50324,NULL,NULL,'mean','ESO 384- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(114998,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114998,38.56,0.33,516,50325,70,NULL,NULL,'LCRS B135307.7-021933',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,208.9285417,-2.56994,0.113,NULL,43592551229,681133612,10642712,18.5),(114999,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',114999,37.83,0.33,368,50326,70,NULL,NULL,'2MASX J13554409+4333257',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.9337917,43.55722,0,NULL,59264218154,926003408,14468803,17.4),(115000,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115000,34.81,0.46,91.7,50327,70,NULL,NULL,'CGCG 103-011',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.57',0.36,NULL,NULL,NULL,NULL,NULL,1,208.934708333,15.06131,0,NULL,58370685084,912041954,14250655,16.57),(115001,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115001,36.11,0.46,167,50328,70,NULL,NULL,'IC 4348',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00009,NULL,'15.0g',0.61,NULL,'Group member',NULL,NULL,NULL,1,208.937875,25.20311,0,NULL,59999118425,937486225,14648222,15),(115002,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115002,37.38,0.46,300,50329,70,NULL,NULL,'2MASX J13554515+1922150',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.23',0.19,NULL,NULL,NULL,NULL,NULL,1,208.938167,19.37092,0.09,NULL,58328655989,911385249,14240394,18.23),(115003,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115003,37.08,0.27,261,50330,70,NULL,NULL,'2MASX J13554535+1910480',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.13',0.17,NULL,NULL,NULL,NULL,NULL,1,208.9390417,19.17994,0.09,NULL,58328873304,911388645,14240447,18.13),(115004,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115004,37.68,0.33,343,50331,70,NULL,NULL,'2MASX J13554581+2126480',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.61',0.13,NULL,NULL,NULL,NULL,NULL,1,208.940917,21.44683,0.03,NULL,59459542020,929055344,14516489,18.61),(115005,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115005,37.7,0.46,347,50332,70,NULL,NULL,'2MASX J13554613+5540312',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,208.942125,55.67519,0,NULL,57300572009,895321437,13989397,17.2),(115006,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115006,36.23,0.33,177,50333,70,NULL,NULL,'2MASX J13554769+1422309',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,208.94875,14.37531,0,NULL,58370379314,912037176,14250580,17.2),(115007,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,115007,35.5,0.17,126,50334,70,NULL,NULL,'GIN 331',NULL,'2001MNRAS.321..277C',2001,1,0.3,NULL,'G',0.000178,NULL,'14.92',0.25,'S',NULL,NULL,NULL,NULL,1,208.951333,24.80528,0,NULL,59999012200,937484565,14648196,14.92),(115008,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115008,36.84,0.33,233,50334,70,NULL,NULL,'GIN 331',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115009,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115009,38.1,0.46,417,50335,70,NULL,NULL,'2MASX J13555001+2040398',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,208.9585,20.67753,0.042,NULL,58331392643,911428010,14241062,17.8),(115010,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115010,37.68,0.33,343,50336,70,NULL,NULL,'2MASX J13555018+2126520',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.959167,21.44794,0.03,NULL,59459540467,929055319,14516489,17.7),(115011,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115011,36.97,0.46,247,50337,70,NULL,NULL,'2MASX J13555092+2508340',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.962083,25.14272,0,NULL,59999124533,937486320,14648223,17.2),(115012,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115012,37.23,0.33,279,50338,70,NULL,NULL,'LCRS B135316.6-030647',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.0001,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,208.9675,-3.35717,0.081,NULL,43597903518,681217242,10644019,16.1),(115013,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115013,36.23,0.33,177,50339,70,NULL,NULL,'2MASX J13555260+1422427',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'17.08',0.28,NULL,NULL,NULL,NULL,NULL,1,208.969333,14.37844,0,NULL,58370378917,912037170,14250580,17.08),(115014,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115014,36.55,0.46,204,50340,70,NULL,NULL,'2MASX J13555338+2341208',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.9725,23.68917,0,NULL,59462064325,929094755,14517105,17.2),(115015,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115015,34.53,0.46,80.7,50341,70,NULL,NULL,'UGC 08854',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000087,NULL,'14.2g',0.65,'S0',NULL,NULL,NULL,NULL,1,208.972666667,37.19658,0,NULL,59154696881,924292138,14442064,14.2),(115016,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115016,37.84,0.46,369,50342,70,NULL,NULL,'2MASX J13555410+2348408',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,208.97525,23.81122,0,NULL,59462119106,929095611,14517118,17.1),(115017,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115017,39.17,0.46,684,50343,70,NULL,NULL,'SDSS J135554.61+303520.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,208.977583,30.58917,0,NULL,59127863235,923872863,14435513,18.4),(115018,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115018,38.56,0.33,516,50344,70,NULL,NULL,'LCRS B135319.7-022945',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,208.979167,-2.73986,0.077,NULL,43600017675,681250276,10644535,18),(115019,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115019,37.32,0.46,291,50345,70,NULL,NULL,'2MASX J13555523+2227318',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.93',0.2,NULL,NULL,NULL,NULL,NULL,1,208.980167,22.45883,0,NULL,59460340330,929067817,14516684,17.93),(115020,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115020,37.72,0.27,350,50346,70,NULL,NULL,'2MASX J13555531+0713448',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000216,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,208.980625,7.22903,0,NULL,58456359627,913380619,14271572,16.4),(115021,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115021,38.25,0.46,446,50347,70,NULL,NULL,'SDSS J135556.15+634348.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000089,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.984,63.73011,0.029,NULL,57932611957,905197061,14143704,18.2),(115022,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,115022,35.29,0.25,114,50348,74.4,NULL,NULL,'GIN 332',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000154,NULL,'15.8g',0.45,'S',NULL,NULL,NULL,NULL,1,208.984,24.95106,0,NULL,59999094945,937485858,14648216,15.8),(115023,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,NULL,115023,35.5,0.17,126,50348,70,NULL,NULL,'GIN 332',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115024,'Tully-Fisher','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115024,31.75,NULL,22.4,50349,72,NULL,NULL,'LSBC D721-10',NULL,'2014Ap.....57..457K',2014,1,0.8,NULL,'G',0.000075,NULL,NULL,NULL,'dI',NULL,NULL,NULL,NULL,1,208.98625,9.01417,0.034,NULL,58457982015,913405968,14271968,NULL),(115025,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115025,37.72,0.27,350,50350,70,NULL,NULL,'2MASX J13555760+0713238',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,208.9900417,7.22336,0,NULL,58456359908,913380623,14271572,17.2),(115026,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115026,38.43,0.46,484,50351,70,NULL,NULL,'2MASX J13555776+0848008',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,208.990667,8.80014,0.03,NULL,58458013310,913406457,14271975,17.4),(115027,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115027,37.72,0.27,350,50352,70,NULL,NULL,'SDSS J135558.25+071556.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,208.99275,7.26572,0,NULL,58456360706,913380636,14271572,18.1),(115028,'FP','2016-12-15 15:15:19','2016-12-16 11:20:32','1',NULL,'R',115028,38.06,0.46,409,50353,70,NULL,NULL,'2MASX J13555948+3513063',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,208.9977917,35.21842,0,NULL,59150748452,924230444,14441100,18.3),(115029,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115029,34.52,0.2,80.2,50354,74.4,NULL,NULL,'UGC 08844',NULL,'2013AJ....146...86T',2013,1,1.27,NULL,'G',0.000017,NULL,'14.7g',0.56,'SB(s)bc:',NULL,NULL,NULL,NULL,1,208.997917,-1.26172,0.193,NULL,43595167379,681174490,10643351,14.7),(115030,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115030,34.71,0.41,87.6,50354,NULL,NULL,NULL,'UGC 08844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115031,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115031,34.88,0.38,94.8,50354,NULL,NULL,'Malmquist cor.','UGC 08844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115032,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115032,33.45,0.4,48.9,50355,75,NULL,'Edat, raw','NGC 5357',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000014,NULL,'12.96',1.3,'E        poss. LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,208.998125,-30.34144,0.177,NULL,46850675870,732041810,11438153,12.96),(115033,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115033,33.7,0.4,54.9,50355,75,NULL,'Edat, cor','NGC 5357',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115034,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115034,33.24,0.25,44.5,50355,74.4,NULL,NULL,'NGC 5357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115035,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115035,33.53,0.46,50.9,50355,70,NULL,NULL,'NGC 5357',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115036,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115036,33.69,0.45,54.6,50355,NULL,NULL,'K','NGC 5357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115037,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115037,34.06,0.4,65,50355,NULL,NULL,'mean','NGC 5357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115038,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115038,37.08,0.27,261,50356,70,NULL,NULL,'SDSS J135600.20+190657.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.000875,19.11586,0.054,NULL,58328869770,911388590,14240446,18.4),(115039,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115039,37.25,0.15,282,50357,70,NULL,NULL,'2MASX J13560061+2258478',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.04',0.17,NULL,NULL,NULL,NULL,NULL,1,209.002625,22.97992,0,NULL,59462511507,929101742,14517214,18.04),(115040,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115040,37.08,0.27,261,50358,70,NULL,NULL,'2MASX J13560174+1907078',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.17,NULL,NULL,NULL,NULL,NULL,1,209.007167,19.11881,0.054,NULL,58328869295,911388582,14240446,18.32),(115041,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115041,35.5,0.17,126,50359,70,NULL,NULL,'GIN 334',NULL,'2001MNRAS.321..277C',2001,1,0.31,NULL,'G',0.000157,NULL,'14.68',0.24,'E',NULL,NULL,NULL,NULL,1,209.008083333,24.67542,0,NULL,59996936961,937452140,14647689,14.68),(115042,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115042,36.84,0.33,233,50359,70,NULL,NULL,'GIN 334',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115043,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115043,37.12,0.33,266,50360,70,NULL,NULL,'2MASX J13560285+2329348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.05',0.17,NULL,NULL,NULL,NULL,NULL,1,209.011917,23.49311,0,NULL,59462548292,929102317,14517223,18.05),(115044,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115044,36.85,0.76,235,50361,70,NULL,NULL,'2MASX J13560316-4334319',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.0132917,-43.57556,0.309,NULL,46919327035,733114484,11454913,15.4),(115045,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115045,34,0.69,63,50362,100,NULL,'mid-IR','IC 0959',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000033,NULL,'13.83',1,'Sa','Group member of poor cluster',NULL,NULL,NULL,1,209.014167,13.50583,0,NULL,58342300280,911598441,14243725,13.83),(115046,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115046,34.89,0.47,95,50362,NULL,NULL,'H','IC 0959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115047,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115047,34.92,0.47,96.4,50362,NULL,NULL,'Malmquist cor.','IC 0959',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115048,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115048,34.93,0.45,96.6,50362,NULL,NULL,'K','IC 0959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115049,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115049,35,0.46,99.9,50362,NULL,NULL,'J','IC 0959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115050,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115050,35.02,0.4,101,50362,NULL,NULL,'mean','IC 0959',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115051,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115051,35.39,0.38,120,50362,NULL,NULL,NULL,'IC 0959',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115052,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115052,35.43,0.2,122,50362,74.4,NULL,NULL,'IC 0959',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115053,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115053,37.3,0.46,289,50363,70,NULL,NULL,'SDSS J135603.52+194752.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.014708333,19.79794,0.06,NULL,58327353772,911364902,14240076,NULL),(115054,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115054,37.8,0.46,363,50364,70,NULL,NULL,'2MASX J13560446+6156135',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.018917,61.93728,0.013,NULL,57261375543,894708992,13979828,17.7),(115055,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115055,38.83,0.46,583,50365,70,NULL,NULL,'SDSS J135606.29+143006.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.02625,14.50172,0,NULL,58370856144,912044627,14250697,18.5),(115056,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115056,31.75,0.8,22.4,50366,75,NULL,'B','NGC 5363',NULL,'1988NBGC.C....0000T',1988,1,4.1,NULL,'G',0.000017,NULL,'11.05',2.6,'I0?            LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.0300417,5.25478,0.038,NULL,58406077204,912594956,14259296,11.05),(115057,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115057,31.1,NULL,16.6,50366,72,NULL,NULL,'NGC 5363',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115058,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115058,35.96,0.76,155,50367,70,NULL,NULL,'2MASX J13560869-2718222',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.0362917,-27.30617,0.225,NULL,46991752464,734246132,11472595,15.8),(115059,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115059,37.32,0.46,291,50368,70,NULL,NULL,'2MASX J13560921+4341570',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.038417,43.69931,0,NULL,59263806022,925996969,14468702,16.7),(115060,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115060,35.29,0.25,114,50369,74.4,NULL,NULL,'CGCG 132-055',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000057,NULL,'15.4g',0.54,'E/S0','Group member',NULL,NULL,NULL,1,209.0387917,25.19544,0,NULL,59999121662,937486275,14648223,15.4),(115061,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115061,35.5,0.17,126,50369,70,NULL,NULL,'CGCG 132-055',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115062,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115062,35.67,0.16,136,50369,70,NULL,NULL,'CGCG 132-055',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115063,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115063,30.89,NULL,15.1,50370,72,NULL,NULL,'SDSS J135609.35+053233.2',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'G',0.000023,NULL,'17.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,209.039,5.54258,0.032,NULL,58435202649,913050041,14266406,17.2),(115064,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115064,37.5,0.46,317,50371,70,NULL,NULL,'2MASX J13560939+2026078',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.039083333,20.43556,0.04,NULL,58327106662,911361041,14240016,NULL),(115065,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115065,34.8,0.57,91.4,50372,NULL,NULL,NULL,'ESO 510- G 019',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.96',0.4,'Sb             HII',NULL,NULL,NULL,NULL,1,209.044083,-23.77139,0.205,NULL,46510227492,726722304,11355036,14.96),(115066,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115066,34.81,0.56,91.8,50372,NULL,NULL,'Malmquist cor.','ESO 510- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115067,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115067,34.84,0.2,92.9,50372,74.4,NULL,NULL,'ESO 510- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115068,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115068,35.9,0.2,151,50373,74.4,NULL,NULL,'UGC 08855',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.3g',0.26,'S?',NULL,NULL,NULL,NULL,1,209.044208333,24.49383,0,NULL,59996956676,937452448,14647694,15.3),(115069,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115069,36.85,0.46,234,50374,70,NULL,NULL,'2MASX J13561082+1351187',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.0452083,13.85525,0,NULL,58370304410,912036006,14250562,16.6),(115070,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115070,37.79,0.33,361,50375,70,NULL,NULL,'2MASX J13561093+0539538',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.0455417,5.66489,0.032,NULL,58435191101,913049860,14266404,18),(115071,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115071,36.48,0.46,198,50376,70,NULL,NULL,'2MASX J13561182+3414333',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000184,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,209.049083,34.24264,0,NULL,59151667791,924244809,14441325,15.9),(115072,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115072,37.67,0.46,341,50377,70,NULL,NULL,'2MASX J13561190+1522247',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.31',0.17,NULL,NULL,NULL,NULL,NULL,1,209.04975,15.37344,0,NULL,58382074545,912219914,14253436,18.31),(115073,'Sosies','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115073,31.05,0.22,16.2,50378,NULL,NULL,NULL,'NGC 5364',NULL,'2002A&A...393...57T',2002,1,6.8,'NGC 5348 may also contribute to the HIPASS detection.','G',0.000013,NULL,'11.17',4.4,'SA(rs)bc pec   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.05,5.01447,0.061,NULL,58406103063,912595360,14259302,11.17),(115074,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115074,32.03,0.8,25.5,50378,75,NULL,'B','NGC 5364',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115075,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115075,31.23,0.46,17.6,50378,NULL,NULL,'J','NGC 5364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115076,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115076,31.24,NULL,17.7,50378,NULL,NULL,'B','NGC 5364',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115077,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115077,31.29,0.47,18.1,50378,NULL,NULL,'H','NGC 5364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115078,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115078,31.3,0.45,18.2,50378,NULL,NULL,'K','NGC 5364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115079,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115079,31.45,NULL,19.5,50378,72,NULL,NULL,'NGC 5364',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115080,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115080,31.55,NULL,20.4,50378,NULL,NULL,'LEDA [April 2006]','NGC 5364',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115081,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115081,31.63,0.3,21.2,50378,55,NULL,'B','NGC 5364',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115082,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115082,31.67,0.4,21.6,50378,NULL,NULL,'mean','NGC 5364',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115083,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115083,36.97,0.46,248,50379,70,NULL,NULL,'2MASX J13561238+3459533',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.051667,34.99828,0,NULL,59150913120,924233017,14441140,17.6),(115084,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115084,37.33,0.46,292,50380,70,NULL,NULL,'2MASX J13561442+5543230',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000143,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.0602083,55.72303,0,NULL,57300580481,895321570,13989399,16.9),(115085,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115085,38.48,0.33,497,50381,70,NULL,NULL,'2MASX J13561446+5302201',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.060375,53.039,0,NULL,59219107204,925298550,14457789,17.7),(115086,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115086,37.25,0.15,282,50382,70,NULL,NULL,'2MASX J13561532+2304508',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.59',0.2,NULL,NULL,NULL,NULL,NULL,1,209.063917,23.08072,0,NULL,59462480264,929101254,14517207,17.59),(115087,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115087,37.75,0.46,354,50383,70,NULL,NULL,'2MASX J13561550+2234138',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.06475,22.57039,0,NULL,59460345345,929067896,14516685,17.4),(115088,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115088,37.25,0.15,282,50384,70,NULL,NULL,'2MASX J13561590+2304308',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.0664583,23.07508,0,NULL,59462478411,929101225,14517206,17.5),(115089,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115089,38.1,0.46,417,50385,70,NULL,NULL,'2MASX J13561594+4751420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.066625,47.86169,0,NULL,59243790222,925684222,14463815,17.4),(115090,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115090,36.95,0.46,246,50386,70,NULL,NULL,'2MASX J13561598+2206338',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.23',0.15,NULL,NULL,NULL,NULL,NULL,1,209.066667,22.10953,0,NULL,59460499763,929070308,14516723,18.23),(115091,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 1992H',NULL,115091,31.53,0.74,20.2,50387,NULL,NULL,'EPM','NGC 5377',NULL,'1996AJ....111.1286C',1996,1,3.92,NULL,'G',0.00002,NULL,'12.5g',0.98,'(R)SB(s)a      AGN','Isolated galaxy',NULL,NULL,NULL,1,209.0694583,47.23569,0.006,NULL,59241164394,925643193,14463174,12.5),(115092,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 1992H',NULL,115092,32.46,0.25,31,50387,NULL,NULL,NULL,'NGC 5377',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115093,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 1992H',NULL,115093,33.12,0.14,42.1,50387,NULL,NULL,'SCM','NGC 5377',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115094,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115094,32.46,0.8,31,50387,75,NULL,'B','NGC 5377',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115095,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115095,31.82,0.49,23.2,50387,NULL,NULL,'Malmquist cor.','NGC 5377',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115096,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115096,31.96,0.2,24.7,50387,74.4,NULL,NULL,'NGC 5377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115097,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115097,32.03,0.43,25.5,50387,75,NULL,'3.6 micron, color corrected','NGC 5377',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115098,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115098,32.05,0.45,25.7,50387,NULL,NULL,NULL,'NGC 5377',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115099,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115099,32.09,0.47,26.2,50387,NULL,NULL,'H','NGC 5377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115100,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115100,32.09,0.45,26.2,50387,NULL,NULL,'K','NGC 5377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115101,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115101,32.11,0.46,26.4,50387,NULL,NULL,'J','NGC 5377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115102,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115102,32.16,0.43,27.1,50387,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5377',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115103,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115103,32.2,0.3,27.5,50387,NULL,18.45,'SN 1992H host','NGC 5377',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115104,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115104,32.4,0.4,30.3,50387,NULL,NULL,'mean','NGC 5377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115105,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115105,37.3,0.46,289,50388,70,NULL,NULL,'2MASX J13561707+1818408',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.071125,18.31119,0.017,NULL,58328214258,911378347,14240286,17.7),(115106,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115106,35.57,0.46,130,50389,70,NULL,NULL,'VV 158a',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000077,NULL,'14.9g',0.63,NULL,'Group member',NULL,NULL,NULL,1,209.080166667,28.53636,0,NULL,60005727303,937589489,14649835,14.9),(115107,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115107,38.36,0.46,469,50390,70,NULL,NULL,'2MASX J13561943+5742363',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.080875,57.70997,0.005,NULL,57296945037,895264766,13988511,18),(115108,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115108,37.26,0.46,283,50391,70,NULL,NULL,'2MASX J13562006+2110528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000014,NULL,'17.54',0.21,NULL,NULL,NULL,NULL,NULL,1,209.083583,21.18122,0.031,NULL,58319700930,911245327,14238208,17.54),(115109,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115109,37.23,0.33,279,50392,70,NULL,NULL,'LCRS B135345.2-030542',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00014,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.0865,-3.33878,0.081,NULL,43597858460,681216538,10644008,16.7),(115110,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115110,35.7,0.46,138,50393,70,NULL,NULL,'2MASX J13562098+3825467',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000187,NULL,'15.9g',0.47,NULL,NULL,NULL,NULL,NULL,1,209.087333333,38.42964,0,NULL,59154593630,924290525,14442039,15.9),(115111,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115111,37.72,0.46,351,50394,70,NULL,NULL,'SDSS J135621.48+074851.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.089541667,7.81428,0,NULL,58459923098,913436298,14272442,18.2),(115112,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115112,37.62,0.46,335,50395,70,NULL,NULL,'2MASX J13562419+2152321',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.14,NULL,NULL,NULL,NULL,NULL,1,209.1007917,21.87572,0.011,NULL,59459700894,929057826,14516528,18.66),(115113,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115113,37.94,0.46,387,50396,70,NULL,NULL,'SDSS J135625.11+525540.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000134,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.104625,52.92794,0,NULL,59219060092,925297813,14457778,18),(115114,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115114,37.04,0.46,256,50397,70,NULL,NULL,'2MASX J13562715+2507485',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.32',0.23,NULL,NULL,NULL,NULL,NULL,1,209.113125,25.13017,0,NULL,59999113650,937486150,14648221,17.32),(115115,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115115,32.13,0.49,26.6,50398,75,NULL,'IR','ESO 384- G 015',NULL,'2011yCatp016004901K',2011,1,1.25,NULL,'G',0.00015,NULL,'15.69',0.17,'SBdm? sp',NULL,NULL,NULL,NULL,1,209.1159583,-33.06894,0.241,NULL,46880179708,732502807,11445356,15.69),(115116,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115116,37.81,0.46,365,50399,70,NULL,NULL,'2MASX J13562784+1420025',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.115917,14.33403,0,NULL,58370419764,912037808,14250590,18.1),(115117,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115117,32.85,0.43,37.1,50399,75,NULL,'3.6 micron, color + selection bias corrected','ESO 384- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115118,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115118,38.03,0.46,404,50400,70,NULL,NULL,'2MASX J13562861+3135472',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.51',0.17,NULL,NULL,NULL,NULL,NULL,1,209.119375,31.59642,0,NULL,59127190427,923862350,14435349,18.51),(115119,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115119,37.25,0.15,282,50401,70,NULL,NULL,'SDSS J135630.58+232146.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.1274583,23.36289,0,NULL,59462558350,929102474,14517226,18),(115120,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115120,39.03,0.46,641,50402,70,NULL,NULL,'2MASX J13563223+2203052',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.134291667,22.0515,0.009,NULL,59460466100,929069782,14516715,18.1),(115121,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115121,37.52,0.46,320,50403,70,NULL,NULL,'2MASX J13563232+3802336',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.134875,38.04275,0,NULL,59155248667,924300760,14442199,17.5),(115122,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115122,37.62,0.46,334,50404,70,NULL,NULL,'2MASX J13563270+4937110',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.136,49.61972,0,NULL,59212261689,925191588,14456118,16.7),(115123,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115123,37.36,0.46,297,50405,70,NULL,NULL,'SDSS J135633.22+310654.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.09',0.12,NULL,NULL,NULL,NULL,NULL,1,209.138458333,31.11528,0,NULL,59128016106,923875251,14435550,19.09),(115124,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115124,37.79,0.33,361,50406,70,NULL,NULL,'SDSS J135634.35+054029.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.143125,5.67486,0.032,NULL,58405701243,912589081,14259204,18.1),(115125,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115125,34.28,0.2,71.8,50407,74.4,NULL,NULL,'UGC 08861',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000013,NULL,'16.0g',0.5,'Sdm',NULL,NULL,NULL,NULL,1,209.144,10.19122,0.025,NULL,58462928660,913483260,14273175,16),(115126,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115126,37.43,0.46,306,50408,70,NULL,NULL,'2MASX J13563457+1316545',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,209.144167,13.28194,0,NULL,58339068069,911547938,14242936,16.8),(115127,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115127,35.91,0.55,152,50409,70,NULL,NULL,'LCRS B135353.9-121721',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,209.144458333,-12.53311,0.205,NULL,43663171953,682237061,10659954,16.8),(115128,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115128,37.2,0.21,275,50410,70,NULL,NULL,'2MASX J13563472+2028332',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.59',0.11,NULL,NULL,NULL,NULL,NULL,1,209.144833,20.47606,0.045,NULL,58327166707,911361979,14240030,18.59),(115129,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115129,33.75,0.47,56.2,50411,NULL,NULL,'H','ESO 445- G 081',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.21',0.3,'Sbc: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.145125,-32.62975,0.241,NULL,46896646879,732760107,11449376,14.21),(115130,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115130,33.76,0.46,56.5,50411,NULL,NULL,'J','ESO 445- G 081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115131,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115131,33.77,0.45,56.6,50411,NULL,NULL,'K','ESO 445- G 081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115132,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115132,33.9,0.4,60.2,50411,NULL,NULL,'mean','ESO 445- G 081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115133,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115133,33.92,0.49,60.8,50411,75,NULL,'IR','ESO 445- G 081',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115134,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115134,34.2,0.12,69.3,50411,NULL,NULL,NULL,'ESO 445- G 081',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115135,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115135,34.78,0.43,90.5,50411,75,NULL,'3.6 micron, color corrected','ESO 445- G 081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115136,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115136,34.82,0.43,92,50411,75,NULL,'3.6 micron, color + selection bias corrected','ESO 445- G 081',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115137,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115137,34.87,0.2,94.2,50411,74.4,NULL,NULL,'ESO 445- G 081',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115138,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115138,35.91,0.33,152,50412,70,NULL,NULL,'2MASX J13563554+4948460',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.148125,49.81269,0,NULL,59212279112,925191861,14456122,16.7),(115139,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115139,36.54,0.55,203,50413,70,NULL,NULL,'2MASX J13563714-2731191',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.1547083,-27.52197,0.225,NULL,46991769029,734246391,11472599,15.3),(115140,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115140,37.22,0.46,278,50414,70,NULL,NULL,'2MASX J13563717+3852516',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.154917,38.88106,0,NULL,59140790897,924074857,14438669,16.7),(115141,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115141,36.84,0.56,234,50415,70,NULL,NULL,'2MASX J13563729-4615571',NULL,'2014MNRAS.445.2677S',2014,1,0.11,NULL,'G',0.00015,NULL,'17.3b',NULL,'E?',NULL,NULL,NULL,NULL,1,209.1555,-46.26592,0.457,NULL,46796258884,731191545,11424867,17.3),(115142,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115142,37.97,0.46,392,50416,70,NULL,NULL,'2MASX J13563748+2159092',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.1562083,21.98586,0.009,NULL,59460453541,929069586,14516712,17.7),(115143,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115143,33.33,0.5,46.3,50417,70,NULL,NULL,'NGC 5369',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.38',0.7,'E0/S0-?',NULL,NULL,NULL,NULL,1,209.15675,-5.46989,0.061,NULL,43595778241,681184035,10643500,14.38),(115144,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115144,36.35,0.46,186,50418,70,NULL,NULL,'2MASX J13563780+1042498',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.157625,10.71381,0,NULL,58463433504,913491148,14273299,16.4),(115145,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115145,37.25,0.15,282,50419,70,NULL,NULL,'2MASX J13563841+2321512',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.5V',NULL,'AGN',NULL,NULL,NULL,NULL,1,209.159583,23.36417,0,NULL,59462561155,929102518,14517226,17.5),(115146,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115146,36.5,0.46,199,50420,70,NULL,NULL,'2MASX J13563884+2221372',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.16',0.25,NULL,NULL,NULL,NULL,NULL,1,209.1619583,22.3605,0,NULL,59460516030,929070562,14516727,17.16),(115147,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115147,35.38,0.55,119,50421,70,NULL,NULL,'2MASX J13563891-2709581',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',NULL,'S0',NULL,NULL,NULL,NULL,1,209.162083,-27.16611,0.225,NULL,46991479064,734241860,11472529,16.4),(115148,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115148,32.36,0.46,29.7,50422,NULL,NULL,'J','NGC 5365A',NULL,'2007A&A...465...71T',2007,1,2.6,NULL,'G',0.000027,NULL,'13.58',0.5,'SAb: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.1647083,-44.00925,0.333,NULL,46919285822,733113840,11454903,13.58),(115149,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115149,32.36,0.47,29.7,50422,NULL,NULL,'H','NGC 5365A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115150,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115150,32.45,0.45,30.9,50422,NULL,NULL,'K','NGC 5365A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115151,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115151,32.53,0.49,32,50422,75,NULL,'IR','NGC 5365A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115152,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115152,32.53,0.4,32.1,50422,75,NULL,NULL,'NGC 5365A',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115153,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115153,32.9,0.4,38,50422,NULL,NULL,'mean','NGC 5365A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115154,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115154,35.04,NULL,102,50423,NULL,NULL,NULL,'UGC 08862',NULL,'2000BSAO...50....5K',2000,1,1.06,NULL,'G',0.000017,NULL,'16.00',0.12,'Sc',NULL,NULL,NULL,NULL,1,209.16925,20.17156,0.01,NULL,58327983944,911374749,14240230,16),(115155,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115155,35.06,NULL,103,50423,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115156,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115156,35.09,NULL,104,50423,NULL,NULL,'Dipole + Quadrupole','UGC 08862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115157,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115157,35.1,0.49,104,50423,75,NULL,'IR','UGC 08862',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115158,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115158,35.12,NULL,106,50423,NULL,NULL,'Dipole','UGC 08862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115159,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115159,35.24,0.2,112,50423,74.4,NULL,NULL,'UGC 08862',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115160,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115160,36.27,0.46,180,50424,70,NULL,NULL,'2MASX J13564179+2203052',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.20',0.23,NULL,NULL,NULL,NULL,NULL,1,209.174208333,22.05147,0.009,NULL,59460468584,929069821,14516715,17.2),(115161,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115161,36.39,0.46,189,50425,70,NULL,NULL,'2MASX J13564209+1834372',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.07',0.24,NULL,NULL,NULL,NULL,NULL,1,209.175625,18.57708,0.042,NULL,58329096840,911392138,14240502,17.07),(115162,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115162,37.25,0.15,282,50426,70,NULL,NULL,'2MASX J13564247+2313192',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.177,23.22203,0,NULL,59462586011,929102906,14517232,17.3),(115163,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115163,38.16,0.46,428,50427,70,NULL,NULL,'2MASX J13564292+0711308',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.17875,7.19197,0.023,NULL,58456449084,913382016,14271594,18),(115164,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115164,38.39,0.46,477,50428,70,NULL,NULL,'2MASX J13564356+3440450',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000129,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.181375,34.67928,0,NULL,59151350818,924239856,14441247,18.1),(115165,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115165,36.98,0.19,249,50429,70,NULL,NULL,'2MASX J13564382+5836374',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.182625,58.61044,0.005,NULL,57266128534,894783258,13980988,17),(115166,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115166,36.17,0.46,171,50430,70,NULL,NULL,'2MASX J13564406+0556588',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.44',0.16,NULL,NULL,NULL,NULL,NULL,1,209.183625,5.94956,0,NULL,58405696810,912589012,14259203,17.44),(115167,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115167,37.46,0.46,310,50431,70,NULL,NULL,'2MASX J13564475+2831594',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.186375,28.53314,0,NULL,60005729432,937589522,14649836,16.7),(115168,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115168,37.72,0.46,351,50432,70,NULL,NULL,'2MASX J13564572+4800220',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.1904583,48.00619,0,NULL,59243799520,925684367,14463818,17),(115169,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115169,36.96,0.46,246,50433,70,NULL,NULL,'2MASX J13564614+1316005',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.1925,13.26686,0,NULL,58339075429,911548053,14242938,17.4),(115170,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115170,37.48,0.46,313,50434,70,NULL,NULL,'2MASX J13564667+2520144',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.06',0.18,NULL,NULL,NULL,NULL,NULL,1,209.1945,25.33742,0,NULL,59999060432,937485319,14648208,18.06),(115171,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115171,35.66,0.46,135,50435,70,NULL,NULL,'CGCG 046-012',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00009,NULL,'15.5g',0.45,'S0',NULL,NULL,NULL,NULL,1,209.198125,5.52631,0.032,NULL,58405917221,912592456,14259257,15.5),(115172,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115172,36.21,0.61,175,50436,70,NULL,NULL,'2MASX J13564883-1804238',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.10',NULL,NULL,NULL,NULL,NULL,NULL,1,209.203458333,-18.07342,0.269,NULL,43681651926,682525811,10664465,16.1),(115173,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115173,38.5,0.46,501,50437,70,NULL,NULL,'2MASX J13564899+1955572',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.204125,19.93258,0.06,NULL,58327510944,911367358,14240114,17.5),(115174,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115174,35.22,0.46,111,50438,70,NULL,NULL,'2MASX J13564917+3818514',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000155,NULL,'15.8g',0.41,'AGN+SF',NULL,NULL,NULL,NULL,1,209.2047917,38.31411,0,NULL,59154548947,924289827,14442028,15.8),(115175,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115175,36.68,0.61,216,50439,70,NULL,NULL,'2MASX J13564916-4308181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.204875,-43.13833,0.245,NULL,46919467991,733116687,11454948,15.8),(115176,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115176,37.96,0.46,392,50440,70,NULL,NULL,'2MASX J13564944+1402165',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.2059583,14.03811,0,NULL,58371375132,912052736,14250824,17.4),(115177,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115177,35.3,0.55,115,50441,70,NULL,NULL,'2MASX J13565043-2848332',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.5b',NULL,'Sp',NULL,NULL,NULL,NULL,1,209.210083333,-28.80917,0.221,NULL,46983542113,734117845,11470591,15.5),(115178,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115178,35.65,0.46,135,50442,70,NULL,NULL,'2MASX J13565156+1633327',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.74',0.19,NULL,NULL,NULL,NULL,NULL,1,209.214916667,16.55903,0.013,NULL,58384054951,912250858,14253919,17.74),(115179,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115179,37.25,0.15,282,50443,70,NULL,NULL,'UGC 08864',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',NULL,NULL,'16.0',0.7,'Sa',NULL,NULL,NULL,NULL,1,209.218375,23.23008,0,NULL,59462550496,929102351,14517224,16),(115180,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115180,37.29,0.46,287,50444,70,NULL,NULL,'2MASX J13565246+1635377',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.28',0.18,NULL,NULL,NULL,NULL,NULL,1,209.2187083,16.594,0,NULL,58384046282,912250723,14253917,18.28),(115181,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115181,37.24,0.46,280,50445,70,NULL,NULL,'2MASX J13565426+3309560',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.34',0.14,NULL,NULL,NULL,NULL,NULL,1,209.226125,33.16547,0,NULL,59148695632,924198369,14440599,18.34),(115182,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115182,35.91,0.33,152,50446,70,NULL,NULL,'2MASX J13565459+4936491',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000184,NULL,'15.5g',0.42,NULL,NULL,NULL,NULL,NULL,1,209.227375,49.61358,0,NULL,59212265057,925191641,14456119,15.5),(115183,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115183,37.13,0.46,266,50447,70,NULL,NULL,'2MASX J13565460+4626024',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000126,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.227625,46.43389,0,NULL,59240748822,925636700,14463073,17.1),(115184,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115184,37.25,0.15,282,50448,70,NULL,NULL,'2MASX J13565492+2321489',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.15',0.15,NULL,NULL,NULL,NULL,NULL,1,209.2289583,23.36356,0,NULL,59462562392,929102537,14517227,18.15),(115185,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115185,36.36,0.46,187,50449,70,NULL,NULL,'2MASX J13565565+1749177',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.73',0.21,NULL,NULL,NULL,NULL,NULL,1,209.23175,17.82164,0.022,NULL,58374049431,912094522,14251476,16.73),(115186,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115186,32.88,0.4,37.6,50450,NULL,NULL,'mean','NGC 5375',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000013,NULL,'13.2g',2.8,'SB(r)ab','Isolated galaxy',NULL,NULL,NULL,1,209.233333,29.16436,0,NULL,60005452299,937585192,14649768,13.2),(115187,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115187,32.89,0.4,37.8,50450,75,NULL,'B','NGC 5375',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115188,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115188,33.17,0.47,43.1,50450,NULL,NULL,'H','NGC 5375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115189,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115189,33.27,0.45,45,50450,NULL,NULL,'K','NGC 5375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115190,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115190,33.32,0.46,46.1,50450,NULL,NULL,'J','NGC 5375',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115191,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115191,37.25,0.15,282,50451,70,NULL,NULL,'2MASX J13565611+2310489',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.233666667,23.18019,0,NULL,59461763292,929090051,14517032,18),(115192,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115192,37.22,0.46,278,50452,70,NULL,NULL,'2MASX J13565633+2424564',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.2347917,24.41578,0,NULL,59996923755,937451933,14647686,17),(115193,'Faber-Jackson','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115193,31.25,0.9,17.8,50453,95,NULL,'Weighted Mean','NGC 5380',NULL,'1984ApJS...56...91D',1984,1,1.7,NULL,'G',0.000077,NULL,'13.25',1.7,'SA0-','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.236208333,37.61039,0,NULL,59155172478,924299569,14442180,13.25),(115194,'Faber-Jackson','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115194,31.25,0.9,17.8,50453,95,NULL,'de Vaucouleurs','NGC 5380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115195,'Tertiary','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115195,32.81,0.27,36.5,50453,95,NULL,NULL,'NGC 5380',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115196,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115196,33.33,0.4,46.3,50453,NULL,NULL,'mean','NGC 5380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115197,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115197,33.42,0.45,48.3,50453,NULL,NULL,'K','NGC 5380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115198,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115198,37.69,0.46,346,50454,70,NULL,NULL,'2MASXi J1356567-002252',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000078,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.236417,-0.38147,0.097,NULL,43592073277,681126144,10642596,16.9),(115199,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115199,37.33,0.46,293,50455,70,NULL,NULL,'2MASX J13565853+2442564',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.243875,24.71575,0,NULL,59997116061,937454938,14647733,17.7),(115200,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115200,37.3,0.33,289,50456,70,NULL,NULL,'2MASX J13565912+1340168',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.86',0.18,NULL,NULL,NULL,NULL,NULL,1,209.2465,13.67133,0,NULL,58368468111,912007314,14250114,17.86),(115201,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115201,36.7,0.46,219,50457,70,NULL,NULL,'2MASX J13565935+2723184',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000153,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.2474583,27.38861,0,NULL,60009924944,937655077,14650860,16.6),(115202,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115202,37.64,0.46,337,50458,70,NULL,NULL,'SDSS J135659.74+273628.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.2489583,27.60797,0,NULL,60009953922,937655530,14650867,18.3),(115203,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115203,37.61,0.46,333,50459,70,NULL,NULL,'2MASX J13570026+3632234',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,209.251083333,36.53992,0,NULL,59156438584,924319352,14442489,16.7),(115204,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115204,37.3,0.33,289,50460,70,NULL,NULL,'2MASX J13570036+1340428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.2515,13.67864,0,NULL,58371348918,912052326,14250817,17.9),(115205,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115205,38.15,0.27,426,50461,70,NULL,NULL,'2MASX J13570063+1742348',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.72',0.16,NULL,NULL,NULL,NULL,NULL,1,209.252625,17.70969,0.022,NULL,58374141047,912095953,14251499,18.72),(115206,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115206,37.55,0.46,324,50462,70,NULL,NULL,'2MASX J13570117+2746334',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'18.32',0.17,NULL,NULL,NULL,NULL,NULL,1,209.255083,27.77606,0,NULL,60009839960,937653749,14650839,18.32),(115207,'SBF','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115207,27.85,NULL,3.72,50463,NULL,NULL,NULL,'ESO 384- G 016',NULL,'2000AJ....119..166J',2000,1,1.3,NULL,'G',0.000107,NULL,'15.1B',0.9,'dS0/Im',NULL,NULL,NULL,NULL,1,209.2557083,-35.33297,0.217,NULL,46881061024,732516578,11445571,15.1),(115208,'SBF','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115208,28.13,0.1,4.23,50463,NULL,NULL,'R','ESO 384- G 016',NULL,'2000AJ....119..166J',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115209,'TRGB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115209,28.18,0.1,4.33,50463,NULL,NULL,NULL,'ESO 384- G 016',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115210,'TRGB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115210,28.23,0.03,4.43,50463,NULL,NULL,'I','ESO 384- G 016',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115211,'TRGB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115211,28.26,0.1,4.49,50463,74.4,NULL,NULL,'ESO 384- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115212,'TRGB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115212,28.28,NULL,4.53,50463,NULL,NULL,NULL,'ESO 384- G 016',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115213,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115213,34.84,0.8,92.9,50464,75,NULL,'HMCL, I','CGCG 074-012',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.1',0.3,'Sdm',NULL,NULL,NULL,NULL,1,209.25575,10.86736,0,NULL,58464332433,913505194,14273518,15.1),(115214,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115214,34.98,0.42,99.1,50464,NULL,NULL,'Malmquist cor.','CGCG 074-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115215,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115215,35.2,0.38,110,50464,NULL,NULL,NULL,'CGCG 074-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115216,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115216,35.21,0.4,110,50464,75,NULL,'HMCL, I, raw','CGCG 074-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115217,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115217,35.24,0.2,112,50464,74.4,NULL,NULL,'CGCG 074-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115218,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115218,35.32,0.4,116,50464,75,NULL,'HMCL, I, inv','CGCG 074-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115219,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115219,35.32,0.4,116,50464,75,NULL,'HMCL, I, cor','CGCG 074-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115220,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115220,35.34,0.46,117,50465,70,NULL,NULL,'SDSS J135701.83-030859.3',NULL,'2015arXiv151105856S',2015,1,0.44,'The APM image includes a superposed star.','G',0.00015,NULL,'16.0g',0.33,'E0',NULL,NULL,NULL,NULL,1,209.257667,-3.14981,0.085,NULL,43598552058,681227375,10644177,16),(115221,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115221,37.61,0.46,332,50466,70,NULL,NULL,'2MASX J13570207+2500474',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.258666667,25.01311,0,NULL,59997090980,937454546,14647727,16.8),(115222,'SNIa','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2001gy',NULL,115222,41.66,0.09,1420,50467,74.2,NULL,'SALT 2','SCP J135704.54+043059.8',0.511,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.268917,4.51661,0.048,NULL,58409501591,912648462,14260132,NULL),(115223,'Ring Diameter','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115223,30.2,0.84,11,50468,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5383',NULL,'1981ApJS...45..541P',1981,1,3.2,NULL,'G',0.00001,NULL,'12.0B',2.7,'(R\')SB(rs)b:pecSbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.2707083,41.84625,0,NULL,59272599223,926134362,14470849,12),(115224,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115224,32.89,0.8,37.8,50468,75,NULL,'B','NGC 5383',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115225,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115225,32.69,0.4,34.5,50468,NULL,NULL,'mean','NGC 5383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115226,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115226,32.89,0.45,37.9,50468,NULL,NULL,'K','NGC 5383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115227,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115227,32.92,0.47,38.4,50468,NULL,NULL,'H','NGC 5383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115228,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115228,32.99,0.46,39.6,50468,NULL,NULL,'J','NGC 5383',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115229,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115229,37.73,0.46,351,50469,70,NULL,NULL,'2MASX J13570573+1223408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.27375,12.39456,0,NULL,58339188065,911549813,14242965,17.6),(115230,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115230,36.99,0.27,250,50470,70,NULL,NULL,'2MASX J13570614+3253159',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.2754583,32.88778,0,NULL,59148938351,924202161,14440658,17),(115231,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003cx',NULL,115231,36.17,0.44,171,50471,NULL,NULL,'SCM, B','NEAT J135706.53-170220.0',NULL,'2010ApJ...715..833O',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.2772083,-17.03889,0.265,NULL,43684159847,682564997,10665078,NULL),(115232,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003cx',NULL,115232,36.2,0.29,174,50471,NULL,NULL,'SCM, BVI','NEAT J135706.53-170220.0',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115233,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003cx',NULL,115233,36.23,0.55,176,50471,NULL,NULL,'SCM, V','NEAT J135706.53-170220.0',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115234,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003cx',NULL,115234,36.23,0.54,176,50471,NULL,NULL,'SCM, I','NEAT J135706.53-170220.0',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115235,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115235,42.97,NULL,3930,50472,71,NULL,NULL,'GRB 080825B',NULL,'2011A&A...526A.153K',2011,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Fermi',NULL,NULL,NULL,NULL,1,209.280917,-68.94278,NULL,NULL,44949663581,702338493,10974038,NULL),(115236,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115236,36.83,0.46,232,50473,70,NULL,NULL,'2MASX J13570717+2730284',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'17.18',0.27,NULL,NULL,NULL,NULL,NULL,1,209.2800417,27.50794,0,NULL,60009943632,937655369,14650865,17.18),(115237,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115237,38.33,0.33,464,50474,70,NULL,NULL,'SDSS J135708.03+075445.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.2835,7.91256,0,NULL,58457631277,913400488,14271882,18),(115238,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115238,37.28,0.33,285,50475,70,NULL,NULL,'2MASX J13570896+2431469',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.2874583,24.52978,0,NULL,59996920653,937451885,14647685,17.1),(115239,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115239,37.28,0.33,285,50476,70,NULL,NULL,'2MASX J13570942+2424230',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000038,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.28925,24.40639,0,NULL,59460846639,929075728,14516808,17.4),(115240,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115240,38.18,0.46,433,50477,70,NULL,NULL,'2MASX J13570955+1133062',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.2897083,11.55172,0,NULL,58464017956,913500280,14273441,17.4),(115241,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115241,38.09,0.33,416,50478,70,NULL,NULL,'2MASX J13570990+3547489',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.291375,35.79706,0,NULL,59155991638,924312369,14442380,17),(115242,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115242,37.99,0.33,396,50479,70,NULL,NULL,'2MASX J13571061+1557148',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.294208333,15.95411,0,NULL,58384628613,912259822,14254059,18),(115243,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115243,38.09,0.33,416,50480,70,NULL,NULL,'2MASX J13571072+3549529',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.2945417,35.8315,0,NULL,59155989146,924312330,14442380,18),(115244,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115244,38.16,0.46,428,50481,70,NULL,NULL,'2MASX J13571122+4144094',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.296667,41.73608,0,NULL,59272474072,926132407,14470818,17.1),(115245,'SNIa','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2001hb',NULL,115245,43.52,0.14,2490,50482,74.2,NULL,'SALT 2','SCP J135711.96+042026.9',1.03,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.299833,4.34081,0.038,NULL,58409612344,912650192,14260159,NULL),(115246,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115246,38.38,0.46,473,50483,70,NULL,NULL,'2MASX J13571215+3401579',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.30075,34.03278,0,NULL,59152041701,924250651,14441416,18),(115247,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115247,36.77,0.33,225,50484,70,NULL,NULL,'2MASX J13571220+3846084',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.300958333,38.76892,0,NULL,59140972751,924077699,14438714,17.8),(115248,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115248,38.46,0.46,491,50485,70,NULL,NULL,'2MASX J13571274+3855374',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.303083,38.92694,0,NULL,59140781883,924074716,14438667,18.3),(115249,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115249,37.99,0.33,396,50486,70,NULL,NULL,'2MASX J13571372+1554558',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.52',0.14,NULL,NULL,NULL,NULL,NULL,1,209.307125,15.91539,0,NULL,58383754345,912246161,14253846,18.52),(115250,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115250,34.14,0.46,67.2,50487,70,NULL,NULL,'IC 4350',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00006,NULL,'13.15',0.8,'(R:)SAB(r)0/a  HII','in a pair',NULL,NULL,NULL,1,209.308,-25.24581,0.317,NULL,46978631599,734041118,11469392,13.15),(115251,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115251,18.35,0.01,0.0468,50488,NULL,NULL,NULL,'Bootes III',NULL,'2009ApJ...693.1118G',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.3,26.8,0,1,60009431662,937647369,14650740,NULL),(115252,'Red Clump','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115252,18.58,0.05,0.052,50488,NULL,NULL,NULL,'Bootes III',NULL,'2009MNRAS.397L..26C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115253,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115253,18.31,0.09,0.046,50488,NULL,NULL,NULL,'Bootes III',NULL,'2014ApJ...793..135S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115254,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115254,37.35,0.46,295,50489,70,NULL,NULL,'2MASX J13571408+2150350',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.308625,21.84308,0.018,NULL,59459631669,929056744,14516511,17.2),(115255,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115255,37.81,0.46,364,50490,70,NULL,NULL,'2MASX J13571426+3129029',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.28',0.17,NULL,NULL,NULL,NULL,NULL,1,209.309291667,31.48417,0,NULL,59127360894,923865013,14435390,18.28),(115256,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115256,37.23,0.46,279,50491,70,NULL,NULL,'2MASX J13571434+0143171',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.309875,1.72139,0.041,NULL,58412753687,912699276,14260926,18),(115257,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115257,36.68,0.46,217,50492,70,NULL,NULL,'2MASX J13571465+2403000',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.57',0.21,NULL,NULL,NULL,NULL,NULL,1,209.311167,24.04986,0,NULL,59461056857,929079013,14516859,17.57),(115258,'SBF','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115258,29.6,0.2,8.3,50493,NULL,NULL,'R','UGC 08882',NULL,'2005A&A...437..823R',2005,1,1.1,NULL,'G',NULL,NULL,'16.0',0.8,'dE, N',NULL,NULL,NULL,NULL,1,209.31125,54.10089,0,NULL,57285122665,895080041,13985625,16),(115259,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115259,36.98,0.46,249,50494,70,NULL,NULL,'2MASX J13571480+2129140',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,209.311625,21.48714,0.025,NULL,59473180890,929268451,14519819,18.28),(115260,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115260,35.87,0.76,149,50495,70,NULL,NULL,'2MASX J13571505-1853052',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,209.312583333,-18.88475,0.257,NULL,43626802178,681668784,10651074,16.26),(115261,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115261,35.32,0.49,116,50496,75,NULL,'IR','UGC 08873',NULL,'2011yCatp016004901K',2011,1,1.5,'Holmberg 559b is a star.','G',0.000033,NULL,'15.04',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,209.31425,24.25758,0,NULL,59460854075,929075844,14516810,15.04),(115262,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115262,35.88,0.2,150,50497,74.4,NULL,NULL,'UGC 08873',NULL,'2013AJ....146...86T',2013,1,1.5,'Holmberg 559b is a star.','G',0.000033,NULL,'15.04',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,209.31425,24.25758,0,NULL,59460854075,929075844,14516810,15.04),(115263,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115263,38.11,0.27,420,50498,70,NULL,NULL,'SDSS J135716.59+035058.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.319166667,3.84972,0.029,NULL,58407398234,912615597,14259618,18.5),(115264,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115264,36.61,0.46,210,50499,70,NULL,NULL,'2MASX J13571749+1445168',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.322917,14.75469,0,NULL,58370706830,912042294,14250660,16.6),(115265,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115265,36.46,0.46,196,50500,70,NULL,NULL,'2MASX J13571822+3951005',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.326083333,39.85031,0,NULL,59259357877,925927466,14467616,16.5),(115266,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115266,33.52,0.49,50.7,50501,75,NULL,'IR','ESO 445- G 083',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.000033,NULL,'16.06',0.17,'Scd',NULL,NULL,NULL,NULL,1,209.326875,-28.19447,0.217,NULL,46983086183,734110721,11470480,16.06),(115267,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115267,34.18,0.2,68.6,50501,74.4,NULL,NULL,'ESO 445- G 083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115268,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115268,34.25,0.5,70.8,50501,NULL,NULL,'Malmquist cor.','ESO 445- G 083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115269,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115269,34.26,0.5,71,50501,NULL,NULL,NULL,'ESO 445- G 083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115270,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115270,34.57,NULL,81.9,50501,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 445- G 083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115271,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115271,34.58,NULL,82.3,50501,NULL,NULL,'Dipole + Quadrupole','ESO 445- G 083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115272,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115272,34.59,NULL,82.9,50501,NULL,NULL,'Dipole','ESO 445- G 083',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115273,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,NULL,115273,34.63,NULL,84.2,50501,NULL,NULL,NULL,'ESO 445- G 083',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115274,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115274,37.98,0.46,394,50502,70,NULL,NULL,'2MASX J13572442+3303080',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.351667,33.05217,0,NULL,59148974336,924202724,14440667,18.2),(115275,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115275,38.34,0.46,465,50503,70,NULL,NULL,'SDSS J135725.05+121743.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.354417,12.29544,0,NULL,58339228739,911550449,14242975,18.2),(115276,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115276,38.57,0.46,518,50504,70,NULL,NULL,'2MASX J13572687+5630532',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.361625,56.51475,0,NULL,57309906673,895467291,13991676,18.2),(115277,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115277,38.63,0.46,533,50505,70,NULL,NULL,'SDSS J135726.86+360206.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.361917,36.03514,0,NULL,59156174701,924315229,14442425,17.9),(115278,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115278,35.2,0.46,110,50506,70,NULL,NULL,'CGCG 074-017',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000093,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,209.373041667,9.95089,0.053,NULL,58463187865,913487310,14273239,15.5),(115279,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115279,37.57,0.46,326,50507,70,NULL,NULL,'SDSS J135729.55+065644.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.373167,6.94572,0.057,NULL,58511141265,914236582,14284946,18.6),(115280,'FP','2016-12-15 15:15:20','2016-12-16 11:20:32','1',NULL,'R',115280,37.89,0.46,379,50508,70,NULL,NULL,'2MASX J13572958+4032047',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000924,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.373167,40.53447,0,NULL,59271240205,926113128,14470517,18.4),(115281,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003bl',NULL,115281,33.95,0.45,61.7,50509,NULL,NULL,'SCM, B','NGC 5374',NULL,'2010ApJ...715..833O',2010,1,1.7,NULL,'G',0.000023,NULL,'13.27',1.5,'SB(r)bc?','in a radial-velocity based grouping',NULL,NULL,NULL,1,209.3734583,6.097,0.023,NULL,58510568467,914227632,14284806,13.27),(115282,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003bl',NULL,115282,33.99,0.09,62.8,50509,NULL,NULL,'I, photospheric magnitude method','NGC 5374',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115283,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:32','1','SN 2003bl',NULL,115283,34,0.16,63.1,50509,NULL,NULL,'V, photospheric magnitude method','NGC 5374',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115284,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 2003bl',NULL,115284,34.07,0.3,65.2,50509,NULL,NULL,'SCM, BVI','NGC 5374',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115285,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 2003bl',NULL,115285,34.09,0.57,65.8,50509,NULL,NULL,'SCM, V','NGC 5374',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115286,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 2003bl',NULL,115286,34.23,0.55,70.1,50509,NULL,NULL,'SCM, I','NGC 5374',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115287,'SNII optical','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 2003bl',NULL,115287,34.83,0.31,92.4,50509,NULL,NULL,'EPM D05','NGC 5374',NULL,'2009ApJ...696.1176J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115288,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115288,38.11,0.27,420,50510,70,NULL,NULL,'2MASX J13573054+0343381',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.377208333,3.72731,0.057,NULL,58407533848,912617716,14259651,17.1),(115289,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115289,38.33,0.33,464,50511,70,NULL,NULL,'SDSS J135731.04+075641.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.379375,7.94489,0,NULL,58457611727,913400183,14271877,18.4),(115290,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115290,38.38,0.33,473,50512,70,NULL,NULL,'SDSS J135732.90+154621.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.387125,15.77261,0,NULL,58383781874,912246591,14253852,18.5),(115291,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115291,36.7,0.46,219,50513,70,NULL,NULL,'2MASX J13573416+0953527',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,209.392208333,9.89803,0.053,NULL,58463184858,913487263,14273238,18.3),(115292,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115292,37.29,0.27,287,50514,70,NULL,NULL,'2MASX J13573420+3615277',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.392667,36.25767,0,NULL,59156034213,924313034,14442391,17.4),(115293,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115293,33.89,0.47,59.9,50515,NULL,NULL,'H','ESO 174- G 003',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000019,NULL,'14.1',1.1,'SB(s)cd',NULL,NULL,NULL,NULL,1,209.395083,-52.77178,NULL,NULL,46816606339,731509474,11429835,14.1),(115294,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115294,33.91,0.4,60.6,50515,NULL,NULL,'mean','ESO 174- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115295,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115295,34.03,0.45,64,50515,NULL,NULL,'K','ESO 174- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115296,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115296,34.14,0.46,67.2,50515,NULL,NULL,'J','ESO 174- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115297,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115297,37.04,0.46,256,50516,70,NULL,NULL,'2MASX J13573529+2744240',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0002,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,209.397083,27.73992,0,NULL,60009857216,937654019,14650844,16.1),(115298,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115298,31.75,0.43,22.4,50517,75,NULL,'3.6 micron, color + selection bias corrected','ESO 510- G 026',NULL,'2014MNRAS.444..527S',2014,1,1.3,'Confused HIPASS source','G',0.000022,NULL,'15.43',0.8,'SB(rs)m',NULL,NULL,NULL,NULL,1,209.397333,-25.79175,0.297,NULL,46979452699,734053948,11469592,15.43),(115299,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115299,36.99,0.27,250,50518,70,NULL,NULL,'2MASX J13573537+3246010',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.3974583,32.76686,0,NULL,59148215233,924190863,14440482,16.5),(115300,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115300,37.69,0.46,344,50519,70,NULL,NULL,'2MASX J13573672+0820437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.403041667,8.34558,0,NULL,58457657345,913400896,14271889,17.9),(115301,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115301,37.8,0.46,362,50520,70,NULL,NULL,'2MASX J13573706+5234488',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.404667,52.58006,0,NULL,59219354492,925302413,14457850,18),(115302,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115302,36.77,0.33,225,50521,70,NULL,NULL,'2MASX J13573721+3845247',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,209.40525,38.75694,0,NULL,59140983846,924077872,14438716,16.4),(115303,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115303,38.47,0.46,494,50522,70,NULL,NULL,'2MASX J13573906+3059349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.41275,30.99294,0,NULL,60004630704,937572354,14649568,17.6),(115304,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115304,37.53,0.46,320,50523,70,NULL,NULL,'2MASX J13573911+4203530',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.412917,42.06475,0,NULL,59272635014,926134922,14470858,17.1),(115305,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115305,33.26,0.4,44.9,50524,75,NULL,'Edat, raw','ESO 384- G 019',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00005,NULL,'12.8',1.2,'(R)SA(rl)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.413333,-34.219,0.209,NULL,46883910562,732561102,11446267,12.8),(115306,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115306,33.44,0.4,48.7,50524,75,NULL,'Edat, cor','ESO 384- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115307,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115307,32.77,0.25,35.8,50524,74.4,NULL,NULL,'ESO 384- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115308,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115308,32.89,0.48,37.8,50524,70,NULL,NULL,'ESO 384- G 019',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115309,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115309,33.79,0.45,57.2,50524,NULL,NULL,'K','ESO 384- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115310,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115310,33.84,0.4,58.6,50524,NULL,NULL,'mean','ESO 384- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115311,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115311,37.59,0.23,330,50525,70,NULL,NULL,'2MASX J13573943+2250469',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.32',0.27,NULL,NULL,NULL,NULL,NULL,1,209.414417,22.84633,0,NULL,59461760428,929090006,14517031,17.32),(115312,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115312,37.29,0.27,287,50526,70,NULL,NULL,'2MASX J13573966+3620077',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00011,NULL,'15.1g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,209.415333,36.33561,0,NULL,59156031157,924312986,14442390,15.1),(115313,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115313,35.12,NULL,105,50527,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08879',NULL,'2010Ap&SS.325..163P',2010,1,1.65,NULL,'G',0.000014,NULL,'15.3g',0.3,'Sc',NULL,NULL,NULL,NULL,1,209.415375,25.77469,0,NULL,59998620967,937478452,14648100,15.3),(115314,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115314,35.12,NULL,106,50527,NULL,NULL,'Dipole + Quadrupole','UGC 08879',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115315,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115315,35.13,NULL,106,50527,NULL,NULL,'Dipole','UGC 08879',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115316,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115316,35.2,NULL,110,50527,NULL,NULL,NULL,'UGC 08879',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115317,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115317,35.27,0.49,113,50527,75,NULL,'IR','UGC 08879',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115318,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115318,35.6,0.39,132,50527,NULL,NULL,'Malmquist cor.','UGC 08879',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115319,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115319,35.78,0.36,143,50527,NULL,NULL,NULL,'UGC 08879',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115320,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115320,35.83,0.2,147,50527,74.4,NULL,NULL,'UGC 08879',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115321,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115321,37.44,0.46,307,50528,70,NULL,NULL,'2MASX J13574014+2231379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.07',0.16,'AGN',NULL,NULL,NULL,NULL,1,209.417417,22.52714,0,NULL,59459972246,929062066,14516594,18.07),(115322,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115322,38.16,0.46,429,50529,70,NULL,NULL,'2MASX J13574027-0027164',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.4177083,-0.4545,0.113,NULL,43595058133,681172783,10643324,18.2),(115323,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115323,37.56,0.46,325,50530,70,NULL,NULL,'2MASX J13574024+5000158',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.417833,50.00447,0.009,NULL,59212042510,925188164,14456065,17.4),(115324,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115324,36.92,0.46,242,50531,70,NULL,NULL,'2MASX J13574054+2124579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.00',0.18,NULL,NULL,NULL,NULL,NULL,1,209.419,21.41608,0.028,NULL,59473177037,929268391,14519818,18),(115325,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115325,32.37,0.4,29.7,50532,75,NULL,'B','UGC 08892',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GTrpl',0.000037,NULL,NULL,NULL,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.42125,57.00167,0,NULL,57309938205,895467784,13991684,NULL),(115326,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115326,37.26,0.46,283,50533,70,NULL,NULL,'2MASX J13574167+2006339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.01',0.19,NULL,NULL,NULL,NULL,NULL,1,209.4237917,20.10933,0.05,NULL,58328075742,911376183,14240252,18.01),(115327,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115327,37.17,0.46,272,50534,70,NULL,NULL,'2MASX J13574275+4628099',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000179,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,209.42825,46.46958,0,NULL,59240772058,925637063,14463079,16.3),(115328,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115328,36.91,0.46,241,50535,70,NULL,NULL,'2MASX J13574328+0633497',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.69',NULL,NULL,NULL,NULL,NULL,NULL,1,209.43025,6.56383,0.035,NULL,58510710508,914229851,14284841,17.69),(115329,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115329,38.38,0.33,473,50536,70,NULL,NULL,'SDSS J135744.21+154258.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.43425,15.71636,0,NULL,58383772281,912246441,14253850,18.3),(115330,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115330,38.16,0.46,428,50537,70,NULL,NULL,'SDSS J135744.72+023055.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000077,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.436375,2.5155,0.025,NULL,58415114695,912736167,14261502,18.5),(115331,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115331,37.76,0.46,356,50538,70,NULL,NULL,'2MASX J13574485+0247447',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.436917,2.79583,0.033,NULL,58414980139,912734064,14261469,16.9),(115332,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115332,36.99,0.27,250,50539,70,NULL,NULL,'2MASX J13574520+3235010',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.438375,32.58375,0,NULL,59148264554,924191633,14440494,16.5),(115333,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115333,36.96,0.23,247,50540,70,NULL,NULL,'2MASX J13574552+2032319',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,209.4397917,20.54231,0.055,NULL,58327221377,911362834,14240044,18.42),(115334,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115334,38.11,0.27,420,50541,70,NULL,NULL,'2MASX J13574609+0344147',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,209.441916667,3.73731,0.057,NULL,58407521724,912617526,14259648,16.8),(115335,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115335,37.26,0.46,283,50542,70,NULL,NULL,'SDSS J135746.79-002152.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.7g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,209.4449583,-0.36467,0.113,NULL,43594851323,681169551,10643274,17.7),(115336,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115336,38.43,0.46,486,50543,70,NULL,NULL,'2MASX J13574731+5456322',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.447125,54.94228,0,NULL,57283231119,895050486,13985163,17.1),(115337,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115337,35.21,0.46,110,50544,70,NULL,NULL,'IC 0965',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00018,NULL,'15.2',0.6,NULL,'Group member',NULL,NULL,NULL,1,209.447917,17.51053,0.029,NULL,58374179780,912096559,14251508,15.2),(115338,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115338,32.37,0.8,29.8,50545,75,NULL,NULL,'UGC 08894',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000037,NULL,'16.5',1.1,'Sm',NULL,NULL,NULL,NULL,1,209.4485417,63.39742,0.029,NULL,57932702752,905198480,14143726,16.5),(115339,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115339,38.57,0.46,518,50546,70,NULL,NULL,'SDSS J135747.80+305444.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.449167,30.91225,0,NULL,60004109210,937564206,14649440,18.5),(115340,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115340,32.4,0.8,30.3,50547,75,NULL,NULL,'ESO 008- G 004',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'13.6',1.9,'SAB(rs)cd',NULL,NULL,NULL,NULL,1,209.4500417,-83.08017,0.417,NULL,44068466504,688569789,10758902,13.6),(115341,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115341,38.42,0.46,483,50548,70,NULL,NULL,'SDSS J135748.04+460939.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.450167,46.16111,0,NULL,59232571673,925508932,14461077,18.4),(115342,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115342,37.29,0.27,287,50549,70,NULL,NULL,'2MASX J13574884+3618467',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.8g',0.25,'AGN',NULL,NULL,NULL,NULL,1,209.45375,36.31289,0,NULL,59156032985,924313015,14442390,16.8),(115343,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115343,34.79,0.47,91,50550,NULL,NULL,'H','UGC 08878',NULL,'2007A&A...465...71T',2007,1,1.02,NULL,'G',0.00002,NULL,'14.3g',0.87,'SBb','Group member',NULL,NULL,NULL,1,209.4559583,9.87339,0.053,NULL,58462471934,913476123,14273064,14.3),(115344,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115344,34.97,0.45,98.6,50550,NULL,NULL,'K','UGC 08878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115345,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115345,34.99,0.4,99.3,50550,NULL,NULL,'mean','UGC 08878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115346,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115346,35.01,0.46,100,50550,NULL,NULL,'J','UGC 08878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115347,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115347,34.75,0.56,89.2,50551,70,NULL,NULL,'ESO 384- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.37',0.3,'Sa-b',NULL,NULL,NULL,NULL,1,209.456166667,-36.03839,0.245,NULL,46891754741,732683667,11448182,15.37),(115348,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115348,38.85,0.46,588,50552,70,NULL,NULL,'2MASX J13574973+3146240',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,209.457333,31.77344,0,NULL,59127126010,923861343,14435333,18.2),(115349,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115349,37.18,0.23,273,50553,70,NULL,NULL,'2MASXi J1357499+213622',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,209.457833,21.60617,0.025,NULL,59473349001,929271078,14519860,17.4),(115350,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115350,37.98,0.46,394,50554,70,NULL,NULL,'2MASX J13575043+1155599',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.460083333,11.93322,0,NULL,58460651221,913447675,14272619,17.8),(115351,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115351,32.13,0.4,26.7,50555,75,NULL,'Edat, raw','NGC 5365',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000113,NULL,'12.45',1.9,'(L)SB(s)0^-','in a pair',NULL,NULL,NULL,1,209.461,-43.93131,0.333,NULL,46919311345,733114239,11454909,12.45),(115352,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115352,32.47,0.4,31.1,50555,75,NULL,'Edat, cor','NGC 5365',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115353,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115353,32,0.5,25.1,50555,70,NULL,NULL,'NGC 5365',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115354,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115354,32.59,0.8,33,50555,75,NULL,'B','NGC 5365',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115355,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115355,32.48,0.45,31.4,50555,NULL,NULL,'K','NGC 5365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115356,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115356,32.68,0.4,34.4,50555,NULL,NULL,'mean','NGC 5365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115357,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115357,38.15,0.27,426,50556,70,NULL,NULL,'2MASX J13575070+1743531',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.80',0.23,NULL,NULL,NULL,NULL,NULL,1,209.461208333,17.73158,0.033,NULL,58374198375,912096849,14251513,17.8),(115358,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115358,37.85,0.16,372,50557,70,NULL,NULL,'SDSS J135753.38+493303.9',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.4724583,49.55111,0,NULL,59242548579,925664821,14463512,17.2),(115359,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115359,38.23,0.46,443,50558,70,NULL,NULL,'SDSS J135753.87+061920.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.4744583,6.32228,0.035,NULL,58510791787,914231121,14284861,17.9),(115360,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115360,31.77,0.5,22.6,50559,70,NULL,NULL,'IC 4351',NULL,'2014MNRAS.445.2677S',2014,1,7.56,NULL,'G',0.00001,NULL,'12.63',1.01,'SA(s)b: sp     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.476083,-29.31572,0.165,NULL,46982881114,734107517,11470429,12.63),(115361,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115361,32.64,0.8,33.7,50559,75,NULL,'A82, H','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115362,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115362,32.64,0.8,33.7,50559,75,NULL,'HMCL, I','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115363,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115363,31.97,NULL,24.8,50559,NULL,NULL,'B','IC 4351',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115364,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115364,32.06,NULL,25.8,50559,NULL,NULL,NULL,'IC 4351',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115365,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115365,32.2,0.35,27.5,50559,NULL,NULL,NULL,'IC 4351',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115366,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115366,32.22,NULL,27.7,50559,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115367,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115367,32.23,NULL,27.9,50559,NULL,NULL,'Dipole + Quadrupole','IC 4351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115368,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115368,32.24,NULL,28.1,50559,NULL,NULL,'Dipole','IC 4351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115369,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115369,32.31,0.47,28.9,50559,75,NULL,'A82, H, raw','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115370,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115370,32.31,0.46,29,50559,NULL,NULL,'J','IC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115371,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115371,32.32,0.47,29.1,50559,NULL,NULL,'H','IC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115372,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115372,32.37,0.45,29.8,50559,NULL,NULL,'K','IC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115373,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115373,32.54,0.47,32.2,50559,75,NULL,'A82, H, inv','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115374,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115374,32.6,0.4,33,50559,75,NULL,'HMCL, I, raw','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115375,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115375,32.61,0.43,33.2,50559,75,NULL,'3.6 micron, color corrected','IC 4351',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115376,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115376,32.64,0.43,33.7,50559,75,NULL,'3.6 micron, color + selection bias corrected','IC 4351',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115377,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115377,32.66,0.47,34.1,50559,75,NULL,'A82, H, cor','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115378,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115378,32.68,0.2,34.4,50559,74.4,NULL,NULL,'IC 4351',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115379,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115379,32.86,0.4,37.2,50559,75,NULL,'HMCL, I, cor','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115380,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115380,32.86,0.4,37.3,50559,75,NULL,'HMCL, I, inv','IC 4351',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115381,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115381,32.86,0.4,37.3,50559,75,NULL,'B','IC 4351',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115382,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115382,32.89,0.4,37.8,50559,NULL,NULL,'mean','IC 4351',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115383,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115383,36.78,0.46,227,50560,70,NULL,NULL,'2MASX J13575478+0844097',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.478375,8.73611,0.017,NULL,58457284671,913395072,14271798,17.3),(115384,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115384,36.73,0.46,222,50561,70,NULL,NULL,'2MASX J13575602+2121115',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,209.483416667,21.35317,0.028,NULL,59473155639,929268056,14519813,18.6),(115385,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115385,37.22,0.33,278,50562,70,NULL,NULL,'2MASX J13575663+1620221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.94',0.2,NULL,NULL,NULL,NULL,NULL,1,209.4860417,16.33947,0,NULL,58384149868,912252341,14253942,17.94),(115386,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115386,35.97,0.46,157,50563,70,NULL,NULL,'2MASX J13575722+3718259',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.488458333,37.30728,0,NULL,59155047715,924297620,14442150,16.5),(115387,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115387,37.18,0.46,272,50564,70,NULL,NULL,'2MASX J13575827+3200271',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.52',0.22,NULL,NULL,NULL,NULL,NULL,1,209.492833,32.00744,0,NULL,59181685590,924713837,14448653,17.52),(115388,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115388,37.33,0.46,292,50565,70,NULL,NULL,'2MASX J13575963-0210524',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.498417,-2.18133,0.153,NULL,43600411931,681256436,10644631,17.6),(115389,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115389,37.48,0.46,313,50566,70,NULL,NULL,'2MASX J13575973+3425101',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.499083,34.41953,0,NULL,59152219801,924253434,14441459,18.1),(115390,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115390,36.72,0.72,221,50567,70,NULL,NULL,'2MASX J13575987-1540465',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.4995417,-15.67956,0.249,NULL,43686979004,682609046,10665766,15.5),(115391,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115391,18.1,0.06,0.042,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2008ApJ...688..245W',2008,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'dSph',NULL,NULL,NULL,NULL,1,209.5,12.85,0,1,58339521530,911555023,14243047,NULL),(115392,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115392,18.3,0.2,0.046,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2009ApJ...690..453K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115393,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115393,18.9,0.5,0.06,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115394,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115394,18.9,0.5,0.06,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2007ApJ...662L..83W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115395,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115395,17.96,0.11,0.039,50568,NULL,NULL,NULL,'BOOTES II',NULL,'2014ApJ...793..135S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115396,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115396,37.55,0.33,323,50569,70,NULL,NULL,'2MASXi J1357599+585513',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.500083,58.92056,0.005,NULL,57273402148,894896908,13982764,17.6),(115397,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115397,35.83,0.46,146,50570,70,NULL,NULL,'2MASX J13580023+5843183',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00016,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.50075,58.72192,0,NULL,57265897991,894779656,13980932,16.3),(115398,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115398,38.55,0.33,514,50571,70,NULL,NULL,'SDSS J135800.28+312943.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.5012083,31.49544,0,NULL,59127319205,923864362,14435380,17.9),(115399,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115399,38.03,0.33,403,50572,70,NULL,NULL,'2MASX J13580066+0953027',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,209.50275,9.88408,0.053,NULL,58463174698,913487104,14273236,18.48),(115400,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115400,37.59,0.23,330,50573,70,NULL,NULL,'2MASX J13580181+2254136',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'17.62',0.18,NULL,NULL,NULL,NULL,NULL,1,209.5074583,22.90392,0,NULL,59461815060,929090860,14517044,17.62),(115401,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115401,37.06,0.46,258,50574,70,NULL,NULL,'MCG +09-23-022',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000232,NULL,'15.3g',0.44,'E0',NULL,NULL,NULL,NULL,1,209.508833,53.01708,0,NULL,59219036957,925297452,14457772,15.3),(115402,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115402,36.95,0.46,246,50575,70,NULL,NULL,'2MASX J13580235+3811549',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000199,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,209.5099583,38.19872,0,NULL,59154497943,924289030,14442016,16.3),(115403,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115403,34.86,0.63,93.9,50576,NULL,NULL,'Malmquist cor.','ESO 325- G 038',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.90',0.8,'Sc',NULL,NULL,NULL,NULL,1,209.5097917,-40.82722,0.265,NULL,46924357226,733193081,11456141,14.9),(115404,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115404,34.96,0.6,98.2,50576,NULL,NULL,NULL,'ESO 325- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115405,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115405,35,0.2,100,50576,74.4,NULL,NULL,'ESO 325- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115406,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115406,38.17,0.46,431,50577,70,NULL,NULL,'2MASX J13580248+0956427',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.51025,9.94522,0.042,NULL,58463291039,913488922,14273264,17.6),(115407,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115407,35.31,0.63,115,50578,70,NULL,NULL,'2MASX J13580257-1542555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,209.510625,-15.71558,0.249,NULL,43686981257,682609082,10665766,16),(115408,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115408,37.59,0.23,330,50579,70,NULL,NULL,'2MASX J13580258+2301116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.36',0.17,NULL,NULL,NULL,NULL,NULL,1,209.510833,23.01981,0,NULL,59461822701,929090979,14517046,18.36),(115409,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115409,38.15,0.27,426,50580,70,NULL,NULL,'2MASX J13580316+1744311',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.41',0.16,NULL,NULL,NULL,NULL,NULL,1,209.5132083,17.74203,0.033,NULL,58374206797,912096981,14251515,18.41),(115410,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115410,36.96,0.23,247,50581,70,NULL,NULL,'UGC 08888 NED03',NULL,'2015arXiv151105856S',2015,1,2.29,NULL,'G',0.0002,NULL,'13.9',0.69,'AGN',NULL,NULL,NULL,NULL,1,209.513625,20.61903,0.056,NULL,58327197993,911362468,14240038,13.9),(115411,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115411,38.03,0.33,403,50582,70,NULL,NULL,'SDSS J135803.65+094800.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.51525,9.80006,0.053,NULL,58462504926,913476639,14273072,18),(115412,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115412,37.87,0.15,374,50583,70,NULL,NULL,'2MASX J13580373+2804371',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.5157917,28.07681,0,NULL,60009551236,937649238,14650769,16.5),(115413,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115413,37.22,0.33,278,50584,70,NULL,NULL,'2MASX J13580456+1631421',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.16,NULL,NULL,NULL,NULL,NULL,1,209.519125,16.52839,0.01,NULL,58383975059,912249610,14253900,18.7),(115414,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115414,36.98,0.19,249,50585,70,NULL,NULL,'2MASX J13580505+5816443',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000209,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,209.520875,58.27897,0,NULL,57296332288,895255192,13988362,16.1),(115415,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115415,35.78,0.2,143,50586,74.4,NULL,NULL,'UGC 08889',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'14.70',0.7,'S?',NULL,NULL,NULL,NULL,1,209.523625,21.7975,0.018,NULL,59473322803,929270668,14519854,14.7),(115416,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115416,38.53,0.46,508,50587,70,NULL,NULL,'SDSS J135805.94+033007.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.5247917,3.50211,0.057,NULL,58407122043,912611281,14259551,17.9),(115417,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115417,37.18,0.23,273,50588,70,NULL,NULL,'2MASX J13580605+2140206',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.0002,NULL,'15.6g',0.49,NULL,NULL,NULL,'radio jet',NULL,1,209.52525,21.67258,0.025,NULL,59473293834,929270216,14519847,15.6),(115418,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115418,36.42,0.46,192,50589,70,NULL,NULL,'SDSS J135806.55+143505.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.34',0.16,NULL,NULL,NULL,NULL,NULL,1,209.5272917,14.58492,0,NULL,58371166823,912049481,14250773,18.34),(115419,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115419,37.84,0.33,370,50590,70,NULL,NULL,'2MASX J13580810+0601417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.533667,6.02825,0.023,NULL,58477134216,913705222,14276644,17.4),(115420,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115420,37.86,0.23,374,50591,70,NULL,NULL,'2MASX J13580829+0814327',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.534625,8.24239,0,NULL,58457662804,913400981,14271890,17.9),(115421,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115421,37.11,0.46,265,50592,70,NULL,NULL,'2MASX J13580936+6143013',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000201,NULL,'16.1g',0.32,'S0',NULL,NULL,NULL,NULL,1,209.538833,61.71717,0,NULL,57264263060,894754110,13980532,16.1),(115422,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115422,37.18,0.23,273,50593,70,NULL,NULL,'2MASX J13580943+2136277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,209.539333,21.60769,0.028,NULL,59473356370,929271193,14519862,18.33),(115423,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115423,43.15,0.22,2510,50594,73,NULL,'H const./H=100','GRB 020405',0.7,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Ulysses/MO/SAX',NULL,NULL,NULL,NULL,1,209.541667,-31.38333,0.289,NULL,46850475236,732038675,11438104,NULL),(115424,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115424,43.99,0.67,2700,50594,73,NULL,'H const./H=100','GRB 020405',0.7,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115425,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115425,43.47,0.46,2910,50594,69.7,NULL,'Calibrated','GRB 020405',0.7,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115426,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115426,43.48,0.52,2920,50594,69.7,NULL,'Fiducial','GRB 020405',0.7,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115427,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115427,43.55,0.52,3020,50594,72,NULL,NULL,'GRB 020405',0.7,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115428,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115428,43.68,0.51,3200,50594,70,NULL,NULL,'GRB 020405',0.7,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115429,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115429,38.55,0.33,514,50595,70,NULL,NULL,'SDSS J135810.48+313009.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.543666667,31.50258,0,NULL,59127319873,923864373,14435380,18.3),(115430,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115430,37.59,0.33,329,50596,70,NULL,NULL,'2MASX J13581472+1820457',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000067,NULL,'13.9',0.22,NULL,NULL,NULL,NULL,NULL,1,209.5614583,18.34617,0.037,NULL,58328575881,911383998,14240374,13.9),(115431,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115431,37.99,0.46,396,50597,70,NULL,NULL,'2MASX J13581505+0254306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.562583333,2.90842,0.037,NULL,58414725891,912730092,14261407,17.1),(115432,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115432,37.85,0.16,372,50598,70,NULL,NULL,'SDSS J135815.49+492900.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.564583,49.48336,0,NULL,59242554545,925664914,14463514,18.1),(115433,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115433,38.8,0.46,575,50599,70,NULL,NULL,'SDSS J135815.69-015014.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.565375,-1.83742,0.149,NULL,43600333491,681255210,10644612,17.9),(115434,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115434,37.38,0.46,299,50600,70,NULL,NULL,'2MASX J13581600+3848369',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00012,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,209.566833,38.81022,0,NULL,59140989645,924077963,14438718,15.7),(115435,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115435,33.31,0.4,45.9,50601,NULL,NULL,'mean','NGC 5402',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00012,NULL,'14.72',0.3,'S?',NULL,NULL,NULL,NULL,1,209.5689583,59.81456,0.005,NULL,57277178276,894955910,13983686,14.72),(115436,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115436,33.36,0.49,46.9,50601,75,NULL,'IR','NGC 5402',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115437,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115437,33.55,0.47,51.4,50601,NULL,NULL,'H','NGC 5402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115438,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115438,36.86,0.46,235,50602,70,NULL,NULL,'2MASX J13581766+2728491',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.26',0.2,NULL,NULL,NULL,NULL,NULL,1,209.5735417,27.48022,0,NULL,60009959622,937655619,14650869,18.26),(115439,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115439,37.86,0.23,374,50603,70,NULL,NULL,'2MASX J13581820+0804128',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.5759583,8.07019,0,NULL,58513058343,914266536,14285414,17.5),(115440,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115440,37.59,0.33,329,50604,70,NULL,NULL,'2MASX J13581851+1822327',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.577083,18.37575,0.037,NULL,58328605841,911384466,14240382,17.4),(115441,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115441,35.58,0.46,131,50605,70,NULL,NULL,'2MASX J13581903+6515290',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000078,NULL,'15.9g',0.38,'S0',NULL,NULL,NULL,NULL,1,209.579125,65.25806,0.053,NULL,57865856531,904154008,14127406,15.9),(115442,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115442,38.31,0.46,460,50606,70,NULL,NULL,'2MASX J13581954+3900039',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.5815,39.00111,0,NULL,59140898669,924076541,14438695,17.8),(115443,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115443,38.05,0.46,408,50607,70,NULL,NULL,'SDSS J135819.80-010411.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.5825,-1.07,0.177,NULL,43594663580,681166618,10643228,18.4),(115444,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115444,37.79,0.46,362,50608,70,NULL,NULL,'2MASX J13582076+2343417',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.5865,23.72833,0,NULL,59461351000,929083609,14516931,17.4),(115445,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115445,36.8,0.46,230,50609,70,NULL,NULL,'2MASX J13582077+5912204',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.586625,59.20578,0.005,NULL,57274214785,894909606,13982962,16.6),(115446,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115446,35.8,0.49,144,50610,75,NULL,'IR','ESO 325- G 039',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.000033,NULL,'16.50',0.11,'Scd',NULL,NULL,NULL,NULL,1,209.5935417,-41.55169,0.217,NULL,46923241742,733175652,11455869,16.5),(115447,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115447,35.97,0.38,156,50610,NULL,NULL,'Malmquist cor.','ESO 325- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115448,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115448,36.12,NULL,167,50610,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 325- G 039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115449,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115449,36.13,NULL,168,50610,NULL,NULL,NULL,'ESO 325- G 039',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115450,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115450,36.13,NULL,169,50610,NULL,NULL,'Dipole + Quadrupole','ESO 325- G 039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115451,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115451,36.16,NULL,171,50610,NULL,NULL,'Dipole','ESO 325- G 039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115452,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115452,36.24,0.34,177,50610,NULL,NULL,NULL,'ESO 325- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115453,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115453,36.28,0.2,180,50610,74.4,NULL,NULL,'ESO 325- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115454,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115454,33.7,0.2,55,50611,74.4,NULL,NULL,'IC 0967',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00003,NULL,'14.7',0.3,'Spiral',NULL,NULL,NULL,NULL,1,209.595625,14.45725,0,NULL,58371166102,912049470,14250772,14.7),(115455,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115455,32.44,0.4,30.8,50612,75,NULL,NULL,'KUG 1356+257',NULL,'2008Ap.....51..336K',2008,1,0.83,NULL,'G',0.00001,NULL,'15.3g',0.25,'S?',NULL,NULL,NULL,NULL,1,209.5990417,25.54986,0,NULL,59996752362,937449255,14647644,15.3),(115456,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115456,33.23,0.58,44.2,50612,NULL,NULL,NULL,'KUG 1356+257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115457,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115457,33.29,0.2,45.5,50612,74.4,NULL,NULL,'KUG 1356+257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115458,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115458,33.48,0.49,49.6,50612,75,NULL,'IR','KUG 1356+257',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115459,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115459,33.59,0.49,52.3,50612,NULL,NULL,'Malmquist cor.','KUG 1356+257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115460,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115460,37.84,0.33,370,50613,70,NULL,NULL,'SDSS J135824.09+055548.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.600375,5.93006,0.023,NULL,58477209158,913706393,14276662,18.2),(115461,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115461,33.91,0.49,60.5,50614,75,NULL,'IR','NGC 5387',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.000033,NULL,'14.64',0.3,'Sbc: sp',NULL,NULL,NULL,NULL,1,209.603291667,6.07128,0.023,NULL,58510653543,914228961,14284827,14.64),(115462,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115462,34.26,0.2,71.1,50614,74.4,NULL,NULL,'NGC 5387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115463,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115463,34.38,0.47,75.3,50614,NULL,NULL,NULL,'NGC 5387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115464,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115464,34.46,0.4,78,50614,NULL,NULL,'mean','NGC 5387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115465,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115465,34.47,0.47,78.3,50614,NULL,NULL,'H','NGC 5387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115466,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115466,34.5,0.45,79.3,50614,NULL,NULL,'Malmquist cor.','NGC 5387',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115467,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115467,34.57,0.45,82,50614,NULL,NULL,'K','NGC 5387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115468,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115468,34.61,0.46,83.5,50614,NULL,NULL,'J','NGC 5387',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115469,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115469,37.64,0.46,337,50615,70,NULL,NULL,'2MASX J13582506+2046468',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,209.6045,20.77981,0.056,NULL,59464854573,929138352,14517786,18.43),(115470,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115470,32.96,0.46,39.1,50616,70,NULL,NULL,'IC 4352',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000087,NULL,'13.57',0.7,'Sab:',NULL,NULL,NULL,NULL,1,209.604667,-34.51733,0.217,NULL,46883845764,732560090,11446251,13.57),(115471,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115471,35.66,0.79,136,50617,70,NULL,NULL,'2MASX J13582540-1517135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.605917,-15.28703,0.249,NULL,43685051352,682578927,10665295,15.1),(115472,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115472,34.06,0.49,64.9,50618,75,NULL,'IR','ESO 445- G 085',NULL,'2011yCatp016004901K',2011,1,1.62,NULL,'G',0.000023,NULL,'16.30',0.11,'Scd',NULL,NULL,NULL,NULL,1,209.616167,-31.77622,0.289,NULL,46850435837,732038059,11438094,16.3),(115473,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115473,34.16,NULL,67.9,50618,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 445- G 085',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115474,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115474,34.17,NULL,68.3,50618,NULL,NULL,'Dipole + Quadrupole','ESO 445- G 085',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115475,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115475,34.19,NULL,68.7,50618,NULL,NULL,'Dipole','ESO 445- G 085',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115476,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115476,34.2,0.14,69.3,50618,NULL,NULL,NULL,'ESO 445- G 085',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115477,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115477,34.24,NULL,70.4,50618,NULL,NULL,NULL,'ESO 445- G 085',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115478,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115478,34.3,0.43,72.6,50618,75,NULL,'3.6 micron, color + selection bias corrected','ESO 445- G 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115479,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115479,34.45,0.43,77.5,50618,75,NULL,'3.6 micron, color corrected','ESO 445- G 085',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115480,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115480,34.47,0.2,78.3,50618,74.4,NULL,NULL,'ESO 445- G 085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115481,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115481,36.96,0.23,247,50619,70,NULL,NULL,'2MASX J13582835+2037015',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.77',0.18,NULL,NULL,NULL,NULL,NULL,1,209.618167,20.61711,0.056,NULL,59464819313,929137801,14517778,17.77),(115482,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115482,37.86,0.23,374,50620,70,NULL,NULL,'2MASX J13582855+0814373',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,209.618833,8.24375,0,NULL,58513046736,914266355,14285411,18.58),(115483,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115483,36.34,0.46,185,50621,70,NULL,NULL,'2MASX J13582851-0141166',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000178,NULL,'16.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,209.618875,-1.68806,0.153,NULL,43592766224,681136972,10642765,16.1),(115484,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115484,37.28,0.46,286,50622,70,NULL,NULL,'2MASX J13582875+0656353',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.83',0.18,NULL,NULL,NULL,NULL,NULL,1,209.619916667,6.94311,0.038,NULL,58511278029,914238719,14284979,17.83),(115485,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115485,37.85,0.16,372,50623,70,NULL,NULL,'SDSS J135829.01+493446.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,209.620875,49.57961,0.021,NULL,59242689913,925667029,14463547,17.6),(115486,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115486,35.2,0.46,109,50624,70,NULL,NULL,'CGCG 103-032',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000197,NULL,'15.2',1,NULL,'Group member',NULL,NULL,NULL,1,209.6222917,17.39192,0.042,NULL,58373535276,912086488,14251351,15.2),(115487,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115487,36.29,0.33,181,50625,70,NULL,NULL,'2MASX J13582939+5541534',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.6224583,55.69833,0,NULL,57301527785,895336371,13989630,16.3),(115488,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115488,37.86,0.23,374,50626,70,NULL,NULL,'2MASX J13583037+0808373',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.6265417,8.14381,0,NULL,58513091417,914267053,14285422,17.5),(115489,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115489,35.71,0.63,138,50627,70,NULL,NULL,'IC 4354',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.7b',0.2,NULL,NULL,NULL,NULL,NULL,1,209.62875,-12.60536,0.177,NULL,43663576790,682243387,10660052,15.7),(115490,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115490,37.76,0.46,357,50628,70,NULL,NULL,'2MASX J13583138+3534213',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,209.630583,35.57258,0,NULL,59153903297,924279739,14441870,18.3),(115491,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115491,38.91,0.46,606,50629,70,NULL,NULL,'2MASX J13583266+3844554',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.636083,38.74864,0,NULL,59140938345,924077161,14438705,18.2),(115492,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115492,38.59,0.46,522,50630,70,NULL,NULL,'2MASX J13583287+1515271',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.6370417,15.25753,0,NULL,58383165643,912236963,14253702,17.3),(115493,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115493,32.58,0.69,32.9,50631,100,NULL,'mid-IR','NGC 5394',NULL,'2013ApJ...771...88L',2013,1,1.7,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'13.7',1,'SB(s)b pec;HII LIRG','Pair member (points to parent)',NULL,NULL,NULL,1,209.6402083,37.45347,0,NULL,59155119786,924298746,14442167,13.7),(115494,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115494,37.49,0.46,314,50632,70,NULL,NULL,'2MASX J13583379+5829423',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,209.6405,58.49506,0,NULL,57265890079,894779532,13980930,16.5),(115495,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115495,37.85,0.16,372,50633,70,NULL,NULL,'2MASX J13583401+4935497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.641625,49.59719,0.021,NULL,59242690420,925667037,14463547,17.2),(115496,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115496,32.32,0.8,29.1,50634,75,NULL,'MAT, I','ESO 221- G 021',NULL,'1997ApJS..109..333W',1997,1,1.6,'Confused HIPASS source','G',0.000033,NULL,'14.90',0.5,'S.../Irr',NULL,NULL,NULL,NULL,1,209.641791667,-48.525,0.737,NULL,46826959863,731671247,11432363,14.9),(115497,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115497,32.85,0.4,37.1,50634,NULL,NULL,'mean','ESO 221- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115498,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115498,33.04,0.47,40.6,50634,NULL,NULL,'H','ESO 221- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115499,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115499,33.04,0.32,40.6,50634,85,NULL,'I, raw','ESO 221- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115500,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115500,33.07,0.32,41.1,50634,85,NULL,'I, inv','ESO 221- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115501,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115501,33.08,0.45,41.2,50634,NULL,NULL,'K','ESO 221- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115502,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115502,33.12,0.43,42.1,50634,75,NULL,'MAT, I, raw','ESO 221- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115503,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115503,33.13,0.46,42.3,50634,NULL,NULL,'J','ESO 221- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115504,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115504,33.28,0.43,45.3,50634,75,NULL,'MAT, I, inv','ESO 221- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115505,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115505,33.32,0.49,46.1,50634,75,NULL,'IR','ESO 221- G 021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115506,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115506,33.36,0.43,46.9,50634,75,NULL,'MAT, I, cor','ESO 221- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115507,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115507,38.09,0.46,414,50635,70,NULL,NULL,'SDSS J135835.94+142622.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.6497917,14.43972,0,NULL,58371276862,912051200,14250800,18),(115508,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115508,38.57,0.46,518,50636,70,NULL,NULL,'2MASX J13583598-0142216',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.6499583,-1.70597,0.153,NULL,43600371752,681255808,10644622,17.8),(115509,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115509,37.4,0.46,302,50637,70,NULL,NULL,'SDSS J135836.56+192517.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.96',0.2,NULL,NULL,NULL,NULL,NULL,1,209.652375,19.42156,0.06,NULL,58330053836,911407091,14240735,17.96),(115510,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115510,38.48,0.33,497,50638,70,NULL,NULL,'2MASX J13583670+3520513',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.652875,35.34739,0,NULL,59149451079,924210173,14440783,18.2),(115511,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115511,37.87,0.15,374,50639,70,NULL,NULL,'2MASX J13583678+2808231',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.6532917,28.13975,0,NULL,60009602350,937650036,14650781,17.7),(115512,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115512,36.96,0.23,247,50640,70,NULL,NULL,'2MASXi J1358368+205249',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.12',0.16,NULL,NULL,NULL,NULL,NULL,1,209.653583,20.88058,0.038,NULL,59464979975,929140312,14517817,18.12),(115513,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115513,33.6,0.4,52.5,50641,NULL,NULL,'mean','NGC 5395',NULL,'2007A&A...465...71T',2007,1,3.31,'The Bologna position is 9 arcsec west of the nucleus.','G',0.00001,NULL,'12.8g',1.03,'SA(s)b pec     Sy2','Pair member (points to parent)',NULL,NULL,'Sy 2',1,209.65825,37.42447,0,NULL,59155119337,924298739,14442167,12.8),(115514,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115514,33.8,0.46,57.6,50641,NULL,NULL,'J','NGC 5395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115515,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115515,33.8,0.47,57.6,50641,NULL,NULL,'H','NGC 5395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115516,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115516,33.81,0.45,57.8,50641,NULL,NULL,'K','NGC 5395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115517,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115517,37.42,0.46,305,50642,70,NULL,NULL,'2MASX J13583814+2538041',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.658917,25.63442,0,NULL,59996885199,937451331,14647677,16.7),(115518,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115518,37.2,0.46,276,50643,70,NULL,NULL,'2MASX J13583855+3850234',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.660583,38.83981,0,NULL,59140907655,924076682,14438698,17.1),(115519,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115519,33.89,0.49,60,50644,75,NULL,'IR','UGC 08896',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00003,NULL,'15.06',0.2,'S?','Group member',NULL,NULL,NULL,1,209.660666667,7.21656,0.026,NULL,58511100883,914235951,14284936,15.06),(115520,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115520,37.86,0.46,374,50645,70,NULL,NULL,'2MASX J13583994+5709253',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.666083,57.15697,0.009,NULL,57310139314,895470926,13991733,17.9),(115521,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115521,37.87,0.46,375,50646,70,NULL,NULL,'SDSS J135840.02+053000.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.66675,5.50011,0.013,NULL,58477113594,913704899,14276639,18.4),(115522,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115522,37.59,0.23,330,50647,70,NULL,NULL,'2MASX J13584021+2303045',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,209.667583,23.05119,0,NULL,59461836840,929091200,14517050,18.38),(115523,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115523,33.3,0.23,45.7,50648,74.4,NULL,NULL,'ABELL S0753:[WFC91] 010',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.0001,NULL,'15.29',0.5,'S0',NULL,NULL,NULL,NULL,1,209.6704583,-33.46844,0.217,NULL,46880582757,732509105,11445454,15.29),(115524,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115524,34.18,0.55,68.4,50648,70,NULL,NULL,'ABELL S0753:[WFC91] 010',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115525,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115525,34.73,NULL,88.2,50649,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08897',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000007,NULL,'15.90',0.13,'Sbc',NULL,NULL,NULL,NULL,1,209.671833,12.59447,0,NULL,58338656806,911541512,14242836,15.9),(115526,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115526,34.74,NULL,88.9,50649,NULL,NULL,'Dipole + Quadrupole','UGC 08897',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115527,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115527,34.75,NULL,89.2,50649,NULL,NULL,'Dipole','UGC 08897',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115528,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115528,34.78,0.42,90.2,50649,NULL,NULL,NULL,'UGC 08897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115529,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115529,34.79,0.49,90.9,50649,75,NULL,'IR','UGC 08897',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115530,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115530,34.83,0.41,92.4,50649,NULL,NULL,'Malmquist cor.','UGC 08897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115531,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115531,34.86,0.2,93.8,50649,74.4,NULL,NULL,'UGC 08897',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115532,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115532,37.88,0.46,376,50650,70,NULL,NULL,'2MASX J13584181+0843073',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.674208333,8.71881,0.01,NULL,58512867419,914263553,14285368,17.1),(115533,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115533,36.97,0.46,248,50651,70,NULL,NULL,'2MASX J13584220+4307279',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.676,43.12439,0,NULL,59264296224,926004628,14468822,16.9),(115534,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115534,37.39,0.33,300,50652,70,NULL,NULL,'2MASX J13584315+2816071',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.6797917,28.2685,0,NULL,60005182541,937580977,14649702,17.9),(115535,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115535,37.95,0.46,388,50653,70,NULL,NULL,'2MASX J13584313+6623087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.679917,66.38583,0.045,NULL,57871784800,904246637,14128853,17.6),(115536,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115536,36.95,0.46,245,50654,70,NULL,NULL,'2MASX J13584390+2018056',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.94',0.2,NULL,NULL,NULL,NULL,NULL,1,209.6830417,20.30161,0.047,NULL,58327903988,911373499,14240210,17.94),(115537,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115537,35.11,NULL,105,50655,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08895',NULL,'2010Ap&SS.325..163P',2010,1,1.52,NULL,'G',0.000018,NULL,'15.9g',0.22,'Sd(f)',NULL,NULL,NULL,NULL,1,209.686083,2.45672,0.053,NULL,58414916610,912733072,14261454,15.9),(115538,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115538,35.12,0.49,106,50655,75,NULL,'IR','UGC 08895',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115539,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115539,35.13,NULL,106,50655,NULL,NULL,'Dipole','UGC 08895',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115540,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115540,35.13,NULL,106,50655,NULL,NULL,'Dipole + Quadrupole','UGC 08895',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115541,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115541,35.19,NULL,109,50655,NULL,NULL,NULL,'UGC 08895',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115542,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115542,35.24,0.41,112,50655,NULL,NULL,'Malmquist cor.','UGC 08895',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115543,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115543,35.4,0.2,120,50655,74.4,NULL,NULL,'UGC 08895',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115544,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115544,35.55,0.35,129,50655,NULL,NULL,NULL,'UGC 08895',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115545,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115545,36.06,0.46,163,50656,70,NULL,NULL,'IC 4356',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000167,NULL,'15.7g',0.39,'S0',NULL,NULL,NULL,NULL,1,209.687917,37.49067,0,NULL,59155109348,924298583,14442165,15.7),(115546,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115546,34.44,0.46,77.3,50657,70,NULL,NULL,'CGCG 046-028',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000083,NULL,'14.6g',0.67,'E',NULL,NULL,NULL,NULL,1,209.690083,2.84425,0.033,NULL,58414830076,912731719,14261433,14.6),(115547,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115547,37.05,0.23,257,50658,70,NULL,NULL,'2MASX J13584576+2757058',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000083,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.690625,27.95161,0,NULL,60009568149,937649502,14650773,16.9),(115548,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115548,38.48,0.33,497,50659,70,NULL,NULL,'2MASX J13584636+3526232',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000187,NULL,'16.1g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,209.693125,35.43981,0,NULL,59149424204,924209753,14440777,16.1),(115549,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115549,37.66,0.46,341,50660,70,NULL,NULL,'2MASX J13584647+4230319',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.693583,42.50897,0,NULL,59272778449,926137163,14470893,17.1),(115550,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115550,38.14,0.33,425,50661,70,NULL,NULL,'SDSS J135847.16+561704.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.696541667,56.28456,0,NULL,57309303438,895457866,13991529,17.6),(115551,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115551,37.99,0.46,396,50662,70,NULL,NULL,'2MASX J13584790+3705184',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000135,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.699625,37.0885,0,NULL,59155656712,924307136,14442299,17.8),(115552,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115552,37.08,0.46,260,50663,70,NULL,NULL,'2MASX J13584828+1519581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.7010417,15.33281,0,NULL,58383380172,912240315,14253754,17.7),(115553,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115553,36.07,0.33,164,50664,70,NULL,NULL,'2MASX J13584864+0019292',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,209.702667,0.32483,0.117,NULL,58411679320,912682489,14260663,16.3),(115554,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115554,37.49,0.21,314,50665,70,NULL,NULL,'2MASX J13584877+2835288',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000013,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,209.703125,28.59136,0,NULL,60005236037,937581813,14649715,15.9),(115555,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115555,36.02,0.46,160,50666,70,NULL,NULL,'2MASX J13584964+6455341',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'16.0g',0.29,'S0',NULL,NULL,NULL,NULL,1,209.706625,64.92611,0.021,NULL,57934228957,905222327,14144098,16),(115556,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115556,38.14,0.33,425,50667,70,NULL,NULL,'2MASX J13584719+5617042',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.708833,56.28608,0,NULL,57309306639,895457916,13991529,18.3),(115557,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115557,38.04,0.46,405,50668,70,NULL,NULL,'2MASX J13585017+0351412',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.709125,3.8615,0.053,NULL,58409713139,912651767,14260183,16.8),(115558,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115558,37.18,0.23,273,50669,70,NULL,NULL,'2MASX J13585100+2136456',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000127,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.712583333,21.61261,0.021,NULL,59473337775,929270902,14519857,16.4),(115559,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115559,37.78,0.46,360,50670,70,NULL,NULL,'2MASX J13585101+2527188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000219,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.712625,25.45517,0,NULL,59996718346,937448724,14647636,16.6),(115560,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115560,36.13,0.46,168,50671,70,NULL,NULL,'2MASX J13585107+1604081',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.17,NULL,NULL,NULL,NULL,NULL,1,209.712917,16.06897,0,NULL,58383007225,912234487,14253663,18.51),(115561,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115561,33.91,0.23,60.5,50672,74.4,NULL,NULL,'ABELL S0753:[WFC91] 012',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000043,NULL,'14.84',0.9,'S0',NULL,NULL,NULL,NULL,1,209.713583,-33.48989,0.217,NULL,46880580362,732509068,11445454,14.84),(115562,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115562,37.61,0.46,332,50673,70,NULL,NULL,'SDSS J135851.28+080010.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.7137083,8.003,0,NULL,58513075566,914266805,14285418,17.6),(115563,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115563,35.22,0.51,110,50674,70,NULL,NULL,'2MASX J13585173-4937302',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.7b',0.22,NULL,NULL,NULL,NULL,NULL,1,209.7152083,-49.62506,0.977,NULL,46826479102,731663735,11432245,16.7),(115564,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115564,37.55,0.33,323,50675,70,NULL,NULL,'2MASX J13585199+5855225',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.71675,58.92308,0,NULL,57273477589,894898087,13982782,16.9),(115565,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115565,38.05,0.46,407,50676,70,NULL,NULL,'2MASXi J1358521-021335',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000189,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.716833,-2.22658,0.149,NULL,43600486116,681257595,10644649,17.8),(115566,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115566,37.87,0.15,374,50677,70,NULL,NULL,'2MASX J13585257+2748348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000127,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.718917,27.80967,0,NULL,60009563656,937649432,14650772,17.7),(115567,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115567,38.51,0.46,503,50678,70,NULL,NULL,'2MASX J13585299+2942568',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.720667,29.71586,0,NULL,60007590074,937618594,14650290,18.1),(115568,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115568,37.61,0.46,332,50679,70,NULL,NULL,'2MASX J13585401+4501210',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.7250417,45.02256,0,NULL,59235858079,925560282,14461879,17.6),(115569,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115569,36.29,0.33,181,50680,70,NULL,NULL,'2MASX J13585433+5533426',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000189,NULL,'15.5g',0.44,'S0',NULL,NULL,NULL,NULL,1,209.726167,55.56181,0,NULL,57301484058,895335688,13989620,15.5),(115570,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115570,37.64,0.33,337,50681,70,NULL,NULL,'2MASX J13585435+6100450',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.7265417,61.01258,0.017,NULL,57263513446,894742397,13980349,17.3),(115571,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115571,34.61,0.46,83.6,50682,70,NULL,NULL,'MCG +06-31-037',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000168,NULL,'15.2g',0.57,NULL,NULL,NULL,NULL,NULL,1,209.727125,35.25556,0,NULL,59149409361,924209521,14440773,15.2),(115572,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115572,36.43,0.46,193,50683,70,NULL,NULL,'2MASX J13585450+3352111',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.7272083,33.86972,0,NULL,59151887037,924248234,14441378,16.4),(115573,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115573,33.41,0.2,48.1,50684,74.4,NULL,NULL,'UGC 08899',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'15.16',0.5,'Sbc',NULL,NULL,NULL,NULL,1,209.7305,21.9885,0.006,NULL,59474000930,929281264,14520019,15.16),(115574,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115574,33.45,0.43,48.9,50684,75,NULL,'3.6 micron, color corrected','UGC 08899',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115575,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115575,33.46,0.43,49.2,50684,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08899',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115576,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115576,37.85,0.16,372,50685,70,NULL,NULL,'SDSS J135855.45+493059.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.731083,49.51656,0.021,NULL,59242698772,925667168,14463549,18.4),(115577,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115577,37.3,0.46,289,50686,70,NULL,NULL,'2MASX J13585798+5354146',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.741416667,53.90422,0,NULL,57282373684,895037088,13984954,17.4),(115578,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115578,37.94,0.46,388,50687,70,NULL,NULL,'2MASX J13585829+6230170',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000194,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.743125,62.50464,0.021,NULL,57747652014,902307062,14098547,17.1),(115579,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115579,36.98,0.19,249,50688,70,NULL,NULL,'2MASX J13585854+5819486',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,209.743666667,58.33008,0,NULL,57296328359,895255130,13988361,16.3),(115580,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115580,37.87,0.15,374,50689,70,NULL,NULL,'2MASX J13585859+2758568',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.744125,27.98242,0,NULL,60009595410,937649928,14650780,18.1),(115581,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115581,37.8,0.46,363,50690,70,NULL,NULL,'2MASX J13585955+2256399',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.17,NULL,NULL,NULL,NULL,NULL,1,209.7482083,22.94442,0,NULL,59461637121,929088080,14517001,18.4),(115582,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115582,36.19,0.46,173,50691,70,NULL,NULL,'LCRS B135624.4-022300',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00009,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,209.7482917,-2.62561,0.141,NULL,43600141082,681252204,10644565,16.3),(115583,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115583,36.22,0.65,175,50691,70,NULL,NULL,'LCRS B135624.4-022300',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115584,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115584,36.98,0.19,249,50692,70,NULL,NULL,'2MASX J13585980+5823596',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000217,NULL,'15.5g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,209.748917,58.4,0,NULL,57296344237,895255378,13988365,15.5),(115585,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115585,37.87,0.15,374,50693,70,NULL,NULL,'SDSS J135859.98+275613.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.749916667,27.93714,0,NULL,60009569730,937649527,14650773,17.9),(115586,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115586,37.07,0.46,259,50694,70,NULL,NULL,'2MASX J13590023+1848059',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.750917,18.80156,0.048,NULL,58329575092,911399610,14240618,17.5),(115587,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115587,36.07,0.33,164,50695,70,NULL,NULL,'2MASX J13590151+0014283',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000213,NULL,'16.05',0.47,NULL,NULL,NULL,NULL,NULL,1,209.7562917,0.24122,0.117,NULL,58411698668,912682791,14260668,16.05),(115588,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115588,36.34,0.82,185,50696,70,NULL,NULL,'2MASX J13590199-3543446',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,209.758333,-35.72906,0.233,NULL,46890524746,732664449,11447882,14.7),(115589,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115589,34.27,0.47,71.4,50697,NULL,NULL,'H','UGC 08902',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000083,NULL,'14.62',0.4,'Sb:','in a pair',NULL,NULL,NULL,1,209.7615417,15.56567,0,NULL,58383312036,912239250,14253738,14.62),(115590,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115590,34.42,0.45,76.4,50697,NULL,NULL,'K','UGC 08902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115591,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115591,34.46,0.46,78,50697,NULL,NULL,'J','UGC 08902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115592,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115592,35.25,0.4,112,50697,NULL,NULL,'mean','UGC 08902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115593,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115593,35.59,0.44,131,50698,NULL,NULL,'Malmquist cor.','ESO 578- G 011',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.26',0.5,'SB?            HII',NULL,NULL,NULL,NULL,1,209.762375,-19.05856,0.229,NULL,43629133767,681705215,10651643,14.26),(115594,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115594,35.65,0.43,135,50698,NULL,NULL,NULL,'ESO 578- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115595,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115595,35.7,0.2,138,50698,74.4,NULL,NULL,'ESO 578- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115596,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115596,37.6,0.46,332,50699,70,NULL,NULL,'SDSS J135904.06+002818.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.766958333,0.47192,0.121,NULL,58411631682,912681745,14260652,18),(115597,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115597,37.05,0.23,257,50700,70,NULL,NULL,'2MASX J13590432+2756388',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000087,NULL,'17.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,209.7680417,27.94419,0,NULL,60009566941,937649483,14650773,17.4),(115598,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115598,38.1,0.46,416,50701,70,NULL,NULL,'SDSS J135904.47+025333.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000094,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,209.768625,2.89256,0.033,NULL,58414835149,912731799,14261434,18.3),(115599,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115599,37.28,0.33,286,50702,70,NULL,NULL,'2MASX J13590518+0551551',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.55',0.24,NULL,NULL,NULL,NULL,NULL,1,209.7715,5.86519,0.029,NULL,58477155906,913705561,14276649,17.55),(115600,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115600,36.98,0.19,249,50703,70,NULL,NULL,'2MASX J13590565+5815476',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.7732917,58.26317,0,NULL,57296323664,895255057,13988360,16.4),(115601,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115601,37.57,0.27,327,50704,70,NULL,NULL,'2MASX J13590574+0150221',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.5g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,209.7740417,1.83933,0.065,NULL,58414366133,912724470,14261319,17.5),(115602,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115602,38.07,0.46,411,50705,70,NULL,NULL,'SDSS J135905.94+534607.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000185,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,209.77475,53.76875,0,NULL,57282150582,895033602,13984900,18.7),(115603,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115603,37.1,0.46,263,50706,70,NULL,NULL,'2MASX J13590652+0303281',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000075,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,209.777083,3.05767,0.025,NULL,58407041949,912610030,14259531,16.6),(115604,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115604,36,0.5,159,50707,70,NULL,NULL,'CGCG 018-012',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.000083,NULL,'15.4g',0.31,'S0',NULL,NULL,NULL,NULL,1,209.77775,-2.38481,0.149,NULL,43600587573,681259180,10644674,15.4),(115605,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115605,37.08,0.46,260,50708,70,NULL,NULL,'2MASX J13590686-0129180',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,209.7785417,-1.48839,0.157,NULL,43594547592,681164806,10643200,17),(115606,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115606,37.52,0.19,319,50709,70,NULL,NULL,'2MASX J13590705+3937355',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'16.4g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,209.779375,39.62672,0,NULL,59260222493,925940976,14467827,16.4),(115607,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115607,37.52,0.19,319,50710,70,NULL,NULL,'2MASX J13590748+3936255',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000172,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.781208333,39.60706,0,NULL,59260222054,925940969,14467827,18.2),(115608,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115608,36.76,0.46,225,50711,70,NULL,NULL,'2MASX J13590797+4606049',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,209.783291667,46.1015,0,NULL,59232740405,925511568,14461118,16.2),(115609,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115609,37.87,0.15,374,50712,70,NULL,NULL,'2MASX J13590826+2810458',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,209.7845,28.17947,0,NULL,60009593429,937649897,14650779,16.6),(115610,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115610,38.09,0.46,414,50713,70,NULL,NULL,'SDSS J135908.32+104301.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.7847083,10.717,0,NULL,58463655796,913494621,14273353,17.8),(115611,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115611,37.05,0.23,257,50714,70,NULL,NULL,'CGCG 162-039',NULL,'2015arXiv151105856S',2015,1,0.95,'87GB source with large sky, narrow minor axis, or very bad confusion.','G',0.000047,NULL,'15.3g',0.41,'BrClG','Group member',NULL,NULL,NULL,1,209.7865,28.02261,0,NULL,60009587574,937649805,14650778,15.3),(115612,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115612,36.02,0.52,160,50715,70,NULL,NULL,'2MASX J13590918-1514179',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,209.7882083,-15.23842,0.261,NULL,43685203751,682581308,10665332,16.09),(115613,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115613,37.9,0.46,380,50716,70,NULL,NULL,'2MASX J13591008+6527249',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.792208333,65.45706,0.053,NULL,57865702249,904151597,14127368,17),(115614,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115614,36.45,0.46,195,50717,70,NULL,NULL,'2MASX J13591165+2557348',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000161,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,209.798625,25.95978,0,NULL,59996678336,937448099,14647626,16),(115615,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115615,37.77,0.46,357,50718,70,NULL,NULL,'2MASX J13591234+3813035',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.80125,38.21778,0,NULL,59141657161,924088393,14438881,18.1),(115616,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115616,38.58,0.46,521,50719,70,NULL,NULL,'2MASX J13591382+1525021',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.8077083,15.41719,0,NULL,58383344181,912239752,14253746,17.4),(115617,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115617,38.07,0.46,411,50720,70,NULL,NULL,'2MASX J13591438+3325262',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.14',0.16,NULL,NULL,NULL,NULL,NULL,1,209.809958333,33.42381,0,NULL,59148900481,924201570,14440649,18.14),(115618,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115618,37.39,0.33,300,50721,70,NULL,NULL,'2MASX J13591439+2816358',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000087,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,209.810125,28.27672,0,NULL,60005174488,937580851,14649700,17.8),(115619,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115619,37.49,0.21,314,50722,70,NULL,NULL,'2MASX J13591495+2832198',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,209.812167,28.53883,0,NULL,60005282299,937582535,14649727,16.5),(115620,'BCG','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115620,37.55,0.35,301,50723,60,NULL,'ABELL 1831, BCG','CGCG 162-041',0.0749,'1980ApJ...241..486H',1980,1,0.95,NULL,'G',0.00009,NULL,'15.7',0.85,'cD;BrClG','Group member',NULL,NULL,NULL,1,209.812875,27.97625,0,NULL,60009685027,937651328,14650802,15.7),(115621,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115621,37.87,0.15,374,50724,70,NULL,NULL,'SDSS J135915.54+275702.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000183,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.81475,27.95075,0,NULL,60009685991,937651343,14650802,18.2),(115622,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115622,38.01,0.46,400,50725,70,NULL,NULL,'2MASX J13591721+1932509',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.8217917,19.5475,0.058,NULL,58329791535,911402992,14240671,18.1),(115623,'BCG','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115623,37.55,0.35,301,50726,60,NULL,NULL,'ABELL 1831',0.0749,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,209.822917,27.97278,0,NULL,60009730161,937652033,14650813,NULL),(115624,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115624,37.52,0.19,319,50727,70,NULL,NULL,'2MASX J13591847+3940176',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,209.827083,39.67164,0,NULL,59260220204,925940940,14467827,17.1),(115625,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115625,36.98,0.19,249,50728,70,NULL,NULL,'2MASX J13591876+5805305',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000162,NULL,'15.8g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,209.828583,58.09181,0,NULL,57307935006,895436484,13991195,15.8),(115626,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115626,36.75,0.6,224,50729,70,NULL,NULL,'2MASX J13591933-1818015',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.830583,-18.30053,0.257,NULL,43626591220,681665487,10651023,15.4),(115627,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115627,37.85,0.16,372,50730,70,NULL,NULL,'2MASX J13592079+4926508',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.5g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,209.8365417,49.44756,0.021,NULL,59242705139,925667267,14463551,16.5),(115628,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115628,37.58,0.46,328,50731,70,NULL,NULL,'SDSS J135921.22+134757.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.838416667,13.79939,0,NULL,58371882151,912060658,14250947,17.5),(115629,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115629,37.85,0.16,372,50732,70,NULL,NULL,'SDSS J135921.37+492835.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.8390417,49.47647,0.021,NULL,59242705697,925667276,14463551,18.1),(115630,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115630,37.05,0.23,257,50733,70,NULL,NULL,'SDSS J135921.84+275538.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.1g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.8410417,27.92725,0,NULL,60009688369,937651380,14650802,18.1),(115631,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115631,36.35,0.63,186,50734,70,NULL,NULL,'2MASX J13592246-1459053',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.8435417,-14.98478,0.261,NULL,43673962432,682405663,10662588,15.3),(115632,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115632,33.79,0.2,57.3,50735,74.4,NULL,NULL,'UGC 08906',NULL,'2013AJ....146...86T',2013,1,1.5,'HOLM 564B is a star.','G',0.000203,NULL,'15.0g',0.44,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.84475,5.53867,0.013,NULL,58477952682,913718010,14276843,15),(115633,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115633,36.49,0.7,198,50736,70,NULL,NULL,'LCRS B135643.0-111801',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,209.847667,-11.54231,0.161,NULL,43693006212,682703222,10667237,16.4),(115634,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115634,35.65,0.46,135,50737,70,NULL,NULL,'2MASX J13592355+1242505',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,209.84825,12.71408,0,NULL,58338696537,911542133,14242845,16.4),(115635,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115635,38.18,0.33,433,50738,70,NULL,NULL,'2MASX J13592380+0811412',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.849125,8.19478,0,NULL,58513607769,914275121,14285548,17.5),(115636,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115636,37.87,0.15,374,50739,70,NULL,NULL,'SDSS J135924.49+275705.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.852083,27.95161,0,NULL,60009730543,937652039,14650813,18.1),(115637,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115637,36.09,0.27,165,50740,70,NULL,NULL,'2MASX J13592448+5915345',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,209.852083,59.25967,0.021,NULL,57274229732,894909839,13982966,16.3),(115638,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115638,35.35,0.69,117,50741,100,NULL,'mid-IR','UGC 08907',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000183,NULL,'15.2',0.9,NULL,NULL,NULL,NULL,NULL,1,209.858458333,12.78847,0,NULL,58368070335,912001098,14250017,15.2),(115639,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115639,36.09,0.27,165,50742,70,NULL,NULL,'2MASX J13592616+5914125',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000166,NULL,'16.1g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,209.85925,59.23678,0.021,NULL,57274261512,894910336,13982974,16.1),(115640,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115640,36.36,0.46,187,50743,70,NULL,NULL,'2MASX J13592665+4722324',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,209.861125,47.37556,0,NULL,59244306656,925692291,14463942,16.2),(115641,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115641,37.82,0.46,366,50744,70,NULL,NULL,'2MASX J13592724+1723325',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'18.01',0.22,NULL,NULL,NULL,NULL,NULL,1,209.863666667,17.39242,0.042,NULL,58373507334,912086052,14251344,18.01),(115642,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115642,37.52,0.19,319,50745,70,NULL,NULL,'2MASX J13592816+3933196',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.867583333,39.55547,0,NULL,59260184322,925940380,14467818,17.2),(115643,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115643,38.21,0.23,438,50746,70,NULL,NULL,'2MASX J13592822+4915258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.867625,49.25731,0.02,NULL,59242644229,925666316,14463536,17.8),(115644,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115644,37.16,0.46,271,50747,70,NULL,NULL,'2MASX J13593041-0217020',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.876583,-2.28381,0.149,NULL,43600576869,681259013,10644672,18.1),(115645,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115645,37.52,0.19,319,50748,70,NULL,NULL,'2MASX J13593051+3940166',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,209.8772917,39.67122,0,NULL,59260213072,925940829,14467825,16.6),(115646,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115646,37.57,0.27,327,50749,70,NULL,NULL,'SDSS J135930.72+015023.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.878,1.83994,0.065,NULL,58417778157,912777783,14262152,18),(115647,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115647,33.64,0.47,53.4,50750,NULL,NULL,'H','NGC 5399',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000047,NULL,'14.2g',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,209.880917,34.77358,0,NULL,59151366402,924240100,14441251,14.2),(115648,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115648,33.68,0.45,54.6,50750,NULL,NULL,'K','NGC 5399',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115649,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115649,33.7,0.46,55,50750,NULL,NULL,'J','NGC 5399',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115650,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115650,33.73,0.4,55.8,50750,NULL,NULL,'mean','NGC 5399',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115651,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115651,34.11,0.49,66.3,50750,75,NULL,'IR','NGC 5399',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115652,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115652,34.24,0.44,70.6,50750,NULL,NULL,'Malmquist cor.','NGC 5399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115653,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115653,34.32,0.2,73.1,50750,74.4,NULL,NULL,'NGC 5399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115654,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115654,34.37,0.42,74.9,50750,NULL,NULL,NULL,'NGC 5399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115655,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115655,37.16,0.46,270,50751,70,NULL,NULL,'2MASX J13593224+5842224',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.884083,58.70611,0,NULL,57273284986,894895077,13982735,17.7),(115656,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115656,37.52,0.19,319,50752,70,NULL,NULL,'2MASX J13593518+3936326',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.896625,39.60922,0,NULL,59260214631,925940853,14467825,17.7),(115657,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115657,37.88,0.46,376,50753,70,NULL,NULL,'2MASX J13593572+5257134',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,209.8985417,52.95358,0,NULL,59215514510,925242414,14456912,17.8),(115658,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115658,37.85,0.16,372,50754,70,NULL,NULL,'2MASX J13593594+4927304',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.8995,49.45856,0.021,NULL,59242703225,925667237,14463550,18.1),(115659,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115659,37.87,0.15,374,50755,70,NULL,NULL,'2MASX J13593664+2805310',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000107,NULL,'16.3g',0.44,NULL,NULL,NULL,NULL,NULL,1,209.902625,28.09208,0,NULL,60009724720,937651948,14650811,16.3),(115660,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115660,38.21,0.23,438,50756,70,NULL,NULL,'2MASX J13593667+4909194',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,209.902791667,49.15536,0.02,NULL,59243430555,925678602,14463728,16.5),(115661,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115661,38.18,0.33,433,50757,70,NULL,NULL,'2MASX J13593741+0805593',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,209.9057917,8.09986,0,NULL,58513647350,914275739,14285558,16.8),(115662,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115662,38.16,0.46,430,50758,70,NULL,NULL,'2MASX J13593890+5059255',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.911875,50.99044,0.069,NULL,59217404391,925271943,14457374,17.3),(115663,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115663,36.3,0.7,182,50759,70,NULL,NULL,'2MASX J13593890-2720164',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,209.912125,-27.33783,0.201,NULL,46991686432,734245100,11472579,15.8),(115664,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115664,35.31,0.2,115,50760,74.4,NULL,NULL,'UGC 08911',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000037,NULL,'15.3g',0.6,'Scd:','Group member',NULL,NULL,NULL,1,209.9139583,28.06122,0,NULL,60009725210,937651956,14650811,15.3),(115665,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115665,37.61,0.33,332,50761,70,NULL,NULL,'2MASX J13593938-0153531',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,209.914,-1.89797,0.157,NULL,43603299259,681301550,10645336,16.6),(115666,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115666,37.61,0.33,332,50762,70,NULL,NULL,'2MASX J13594045-0153091',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.5g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,209.918416667,-1.88583,0.157,NULL,43603429196,681303581,10645368,16.5),(115667,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115667,37.64,0.33,337,50763,70,NULL,NULL,'SDSS J135941.23+610658.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,209.921833,61.11636,0.017,NULL,57263459775,894741558,13980336,18.4),(115668,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115668,37.28,0.33,286,50764,70,NULL,NULL,'2MASX J13594152+0557117',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,209.922917,5.95314,0.028,NULL,58477852573,913716446,14276819,17.8),(115669,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115669,37.49,0.21,314,50765,70,NULL,NULL,'2MASX J13594194+2827050',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000185,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,209.924916667,28.45147,0,NULL,60005242559,937581914,14649717,17),(115670,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115670,37.92,0.46,383,50766,70,NULL,NULL,'2MASX J13594213+4201193',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,209.925417,42.02203,0,NULL,59272723336,926136302,14470879,17.2),(115671,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115671,36.37,0.33,188,50767,70,NULL,NULL,'CGCG 074-028',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000163,NULL,'14.7g',0.66,NULL,NULL,NULL,NULL,NULL,1,209.927583,12.73683,0,NULL,58368093482,912001460,14250022,14.7),(115672,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115672,37.57,0.27,327,50768,70,NULL,NULL,'2MASX J13594299+0152447',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000085,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.9292917,1.87914,0.065,NULL,58417957062,912780579,14262196,16.6),(115673,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115673,37.12,0.46,266,50769,70,NULL,NULL,'2MASX J13594357+1218096',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000161,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,209.9314583,12.30258,0,NULL,58338801987,911543781,14242871,16.6),(115674,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115674,36.07,0.46,163,50770,70,NULL,NULL,'2MASX J13594436+1748146',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.78',0.21,NULL,NULL,NULL,NULL,NULL,1,209.935,17.80417,0.037,NULL,58373850054,912091407,14251428,16.78),(115675,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115675,38.15,0.33,427,50771,70,NULL,NULL,'2MASX J13594747+3800506',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,209.9479583,38.01417,0,NULL,59141152312,924080504,14438757,17.7),(115676,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115676,33.34,0.49,46.6,50772,75,NULL,'IR','UGC 08917',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.000137,NULL,'15.1',0.17,'Scd',NULL,NULL,NULL,NULL,1,209.9487917,40.38236,0,NULL,59260003496,925937554,14467774,15.1),(115677,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115677,33.53,0.63,50.9,50772,NULL,NULL,NULL,'UGC 08917',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115678,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115678,33.54,NULL,51.1,50772,NULL,NULL,NULL,'UGC 08917',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115679,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115679,33.58,0.2,52,50772,74.4,NULL,NULL,'UGC 08917',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115680,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115680,33.66,0.59,53.9,50772,NULL,NULL,'Malmquist cor.','UGC 08917',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115681,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115681,33.76,NULL,56.5,50772,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115682,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115682,33.77,NULL,56.8,50772,NULL,NULL,'Dipole + Quadrupole','UGC 08917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115683,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115683,33.78,NULL,57,50772,NULL,NULL,'Dipole','UGC 08917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115684,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115684,33.89,0.49,59.9,50772,75,NULL,'IR','UGC 08917',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115685,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115685,38.12,0.46,421,50773,70,NULL,NULL,'2MASX J13594849+4336533',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,209.952083,43.61472,0,NULL,59264345903,926005404,14468834,17.5),(115686,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115686,38.21,0.23,438,50774,70,NULL,NULL,'2MASX J13594983+4905165',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,209.957417,49.088,0.02,NULL,59243444050,925678813,14463731,16.9),(115687,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115687,38.32,0.46,461,50775,70,NULL,NULL,'SDSS J135950.26+065456.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,209.959458333,6.91569,0.083,NULL,58514016479,914281507,14285648,18.6),(115688,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115688,38.65,0.46,537,50776,70,NULL,NULL,'2MASX J13595026+1226076',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,209.959458333,12.43539,0,NULL,58338815420,911543990,14242874,18.4),(115689,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115689,37.81,0.27,365,50777,70,NULL,NULL,'2MASX J13595115+0350147',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,209.963291667,3.83753,0.057,NULL,58409803054,912653172,14260205,17.1),(115690,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115690,33.06,0.23,40.9,50778,74.4,NULL,NULL,'ABELL S0753:[WFC91] 017',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'15.17',NULL,'E',NULL,NULL,NULL,NULL,1,209.96425,-34.31725,0.217,NULL,46883320585,732551884,11446123,15.17),(115691,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115691,35.79,0.46,144,50779,70,NULL,NULL,'2MASX J13595148+3216104',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.66',0.21,NULL,NULL,NULL,NULL,NULL,1,209.964583,32.26944,0,NULL,60033110743,938017355,14656521,16.66),(115692,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115692,35.53,0.51,127,50780,70,NULL,NULL,'2MASX J13595165-1650502',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.15',NULL,NULL,NULL,NULL,NULL,NULL,1,209.965083,-16.84753,0.277,NULL,43682669528,682541711,10664714,16.15),(115693,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115693,34.13,0.49,66.9,50781,75,NULL,'IR','2MFGC 11312',NULL,'2011yCatp016004901K',2011,1,NULL,'This is the southeastern part of the galaxy NGC 5403.','PofG',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,209.968875,38.17656,0,NULL,59141173973,924080843,14438763,NULL),(115694,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115694,37.68,0.46,343,50782,70,NULL,NULL,'2MASX J13595354+5807231',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,209.973125,58.12311,0,NULL,57308061080,895438454,13991225,17.7),(115695,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115695,39.22,NULL,697,50783,NULL,NULL,NULL,'NSCS J135935+623032',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',0.003,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,209.97125,62.52111,0.037,NULL,57747528962,902305140,14098517,NULL),(115696,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115696,39.54,0.69,810,50783,NULL,NULL,'Isotherm., r < 100 kpc','NSCS J135935+623032',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115697,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115697,39.69,NULL,866,50783,NULL,NULL,NULL,'NSCS J135935+623032',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115698,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115698,39.93,NULL,970,50783,NULL,NULL,NULL,'NSCS J135935+623032',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115699,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115699,40.23,0.68,1110,50783,NULL,NULL,'Isotherm.','NSCS J135935+623032',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115700,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115700,40.27,0.18,1130,50783,NULL,NULL,'Hydrost. Eq.','NSCS J135935+623032',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115701,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115701,40.6,NULL,1320,50783,NULL,NULL,'3.1 (red) calibration','NSCS J135935+623032',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115702,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115702,40.84,NULL,1470,50783,NULL,NULL,'4.2 (black) calibration','NSCS J135935+623032',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115703,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115703,41.09,NULL,1650,50783,NULL,NULL,'4.1 (blue) calibration','NSCS J135935+623032',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115704,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115704,38.15,0.33,427,50784,70,NULL,NULL,'SDSS J135955.59+380147.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.981667,38.02989,0,NULL,59141177931,924080905,14438764,18.1),(115705,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115705,36.08,0.4,165,50785,NULL,NULL,'mean','ESO 325- G 043',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00004,NULL,'14.35',1.2,'SA(rs:)b:',NULL,NULL,NULL,NULL,1,209.9902083,-37.86358,0.297,NULL,46878393699,732474901,11444920,14.35),(115706,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115706,36.19,0.47,173,50785,NULL,NULL,'H','ESO 325- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115707,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115707,36.28,0.45,180,50785,NULL,NULL,'K','ESO 325- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115708,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115708,36.34,0.46,186,50785,NULL,NULL,'J','ESO 325- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115709,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115709,37.39,0.46,300,50786,70,NULL,NULL,'2MASX J13595867+2144087',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.91',0.17,NULL,NULL,NULL,NULL,NULL,1,209.9942917,21.73569,0.006,NULL,59474119496,929283117,14520048,17.91),(115710,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115710,38.59,0.46,523,50787,70,NULL,NULL,'2MASX J13595936+5819261',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,209.9975,58.32389,0,NULL,57307883090,895435673,13991182,17.7),(115711,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115711,37.67,0.46,342,50788,70,NULL,NULL,'2MASX J14000080+1457338',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.13',0.18,NULL,NULL,NULL,NULL,NULL,1,210.0035417,14.95944,0,NULL,58369420887,912022201,14250346,18.13),(115712,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115712,38.21,0.23,438,50789,70,NULL,NULL,'2MASX J14000197+4915335',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.008125,49.25931,0.02,NULL,59242612166,925665815,14463528,18),(115713,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115713,36.09,0.27,165,50790,70,NULL,NULL,'CGCG 295-031',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.00012,NULL,'14.8g',0.67,'E?',NULL,NULL,NULL,NULL,1,210.010875,59.26522,0.021,NULL,57274160805,894908762,13982949,14.8),(115714,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115714,37.81,0.27,365,50791,70,NULL,NULL,'2MASX J14000271+0348057',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.011333333,3.80161,0.057,NULL,58409755497,912652429,14260194,18.1),(115715,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115715,36.61,0.53,210,50792,70,NULL,NULL,'2MASX J14000319-0504007',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.0132917,-5.06683,0.069,NULL,43726253222,683222706,10675354,16.7),(115716,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115716,35.55,0.49,129,50793,75,NULL,'IR','ESO 578- G 013',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.54',0.2,'S              HII',NULL,NULL,NULL,NULL,1,210.016166667,-21.54375,0.193,NULL,46520952641,726889885,11357654,16.54),(115717,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115717,35.83,0.42,147,50793,NULL,NULL,'Malmquist cor.','ESO 578- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115718,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115718,36.01,0.39,159,50793,NULL,NULL,NULL,'ESO 578- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115719,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115719,36.05,0.2,162,50793,74.4,NULL,NULL,'ESO 578- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115720,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115720,37.49,0.46,314,50794,70,NULL,NULL,'SDSS J140003.95+035526.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.0165,3.92417,0.057,NULL,58409807112,912653236,14260206,17.9),(115721,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115721,36.84,0.46,234,50795,70,NULL,NULL,'2MASX J14000425+2043058',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.03',0.15,NULL,NULL,NULL,NULL,NULL,1,210.017875,20.7185,0.039,NULL,59465711108,929151736,14517995,18.03),(115722,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115722,35.45,0.46,123,50796,70,NULL,NULL,'MCG +10-20-060',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00017,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,210.018667,58.37033,0,NULL,57307883991,895435687,13991182,15.8),(115723,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115723,36.86,0.27,235,50797,70,NULL,NULL,'2MASX J14000513+3309003',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.0214583,33.15014,0,NULL,59149020665,924203447,14440678,17.4),(115724,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115724,18.8,0.2,0.0575,50798,NULL,NULL,NULL,'Bootes Satellite',NULL,'2008AJ....135.1361D',2008,1,NULL,NULL,'G',0.000007,NULL,'11.5K',NULL,'Dwarf Spheroidal?',NULL,NULL,NULL,NULL,1,210.025,14.5,0,1,58369312415,912020506,14250320,11.5),(115725,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115725,18.9,0.2,0.06,50798,NULL,NULL,NULL,'Bootes Satellite',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115726,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115726,18.9,0.2,0.06,50798,NULL,NULL,'CMD','Bootes Satellite',NULL,'2006ApJ...647L.111B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115727,'CMD','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115727,19.06,NULL,0.065,50798,NULL,NULL,NULL,'Bootes Satellite',NULL,'2014MNRAS.439..788H',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115728,'Horizontal Branch','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115728,18.95,0.08,0.0617,50798,NULL,NULL,'Probability > 0.5','Bootes Satellite',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115729,'Horizontal Branch','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115729,18.95,0.12,0.0617,50798,NULL,NULL,'Red HB','Bootes Satellite',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115730,'Horizontal Branch','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115730,19.07,0.11,0.065,50798,NULL,NULL,NULL,'Bootes Satellite',NULL,'2012ApJ...744...96O',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115731,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115731,18.85,NULL,0.059,50798,NULL,NULL,'4, V','Bootes Satellite',NULL,'2015AJ....150..160B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115732,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115732,18.96,0.12,0.062,50798,NULL,NULL,'15','Bootes Satellite',NULL,'2006ApJ...649L..83S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115733,'RR Lyrae','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115733,19.11,0.08,0.066,50798,NULL,NULL,'11 RR Lyrae','Bootes Satellite',NULL,'2006ApJ...653L.109D',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115734,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115734,37.62,0.56,334,50799,70,NULL,NULL,'LCRS B135730.3-031215',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00012,NULL,'16.52',0.33,NULL,NULL,NULL,NULL,NULL,1,210.025041667,-3.44606,0.105,NULL,43598969405,681233896,10644279,16.52),(115735,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115735,36.03,0.65,161,50800,70,NULL,NULL,'2MASX J14000664-1733262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,210.027625,-17.55747,0.309,NULL,43683085660,682548213,10664815,16.45),(115736,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115736,38.26,0.46,449,50801,70,NULL,NULL,'SDSS J140007.54+305609.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.0314583,30.93594,0,NULL,60004709680,937573588,14649587,18),(115737,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115737,37.81,0.27,365,50802,70,NULL,NULL,'2MASX J14000844+0348050',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,210.035333,3.8015,0.057,NULL,58409758415,912652475,14260194,17.1),(115738,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115738,38,0.46,397,50803,70,NULL,NULL,'SDSS J140009.00+010340.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.0375,1.06111,0.065,NULL,58411415429,912678366,14260599,18.1),(115739,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115739,37.49,0.21,314,50804,70,NULL,NULL,'SDSS J140009.78+283124.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.04075,28.52342,0,NULL,60005044972,937578827,14649669,18.4),(115740,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115740,36.86,0.27,235,50805,70,NULL,NULL,'2MASX J14000990+3313463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.37',0.23,NULL,NULL,NULL,NULL,NULL,1,210.04125,33.22964,0,NULL,59148508066,924195438,14440553,17.37),(115741,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115741,37.16,0.46,271,50806,70,NULL,NULL,'2MASX J14000998+1757538',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,210.0415,17.96492,0.039,NULL,58375859912,912122811,14251918,16),(115742,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115742,37.62,0.46,334,50807,70,NULL,NULL,'2MASX J14001028+2735121',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000093,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,210.0427083,27.58667,0,NULL,60009673159,937651143,14650799,16.6),(115743,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115743,38.2,0.46,436,50808,70,NULL,NULL,'SDSS J140010.40+135341.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.043375,13.89478,0,NULL,58371780030,912059062,14250922,18.4),(115744,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115744,38.09,0.46,415,50809,70,NULL,NULL,'2MASX J14001127+5738251',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.0470417,57.64033,0.005,NULL,57308823610,895450368,13991412,17.5),(115745,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115745,38,0.46,398,50810,70,NULL,NULL,'2MASX J14001160+0649023',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.15,NULL,NULL,NULL,NULL,NULL,1,210.048333,6.8175,0.042,NULL,58514342758,914286605,14285728,18.41),(115746,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115746,32.62,0.8,33.4,50811,75,NULL,'MAT, I','ESO 221- G 022',NULL,'1997ApJS..109..333W',1997,1,2.91,'Star superposed.','G',0.000018,NULL,'14.13',0.36,'SBd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.048667,-48.26994,0.753,NULL,46829207897,731706373,11432912,14.13),(115747,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115747,32.9,0.8,38.1,50811,75,NULL,NULL,'ESO 221- G 022',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115748,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115748,32.12,0.4,26.6,50811,75,NULL,NULL,'ESO 221- G 022',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115749,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115749,32.56,0.43,32.5,50811,75,NULL,'MAT, I, raw','ESO 221- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115750,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115750,32.63,0.32,33.6,50811,85,NULL,'I, raw','ESO 221- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115751,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115751,32.65,0.2,33.9,50811,74.4,NULL,NULL,'ESO 221- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115752,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115752,32.66,0.32,34.1,50811,85,NULL,'I, inv','ESO 221- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115753,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115753,32.67,0.4,34.2,50811,NULL,NULL,NULL,'ESO 221- G 022',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115754,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115754,32.72,0.43,34.9,50811,75,NULL,'MAT, I, inv','ESO 221- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115755,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115755,32.8,0.49,36.4,50811,75,NULL,'IR','ESO 221- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115756,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115756,32.86,0.43,37.4,50811,75,NULL,'MAT, I, cor','ESO 221- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115757,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115757,33.01,0.4,40,50811,NULL,NULL,'mean','ESO 221- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115758,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115758,33.04,0.47,40.5,50811,NULL,NULL,'H','ESO 221- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115759,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115759,33.08,0.45,41.4,50811,NULL,NULL,'K','ESO 221- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115760,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115760,33.11,0.46,42,50811,NULL,NULL,'J','ESO 221- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115761,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115761,33.13,NULL,42.2,50811,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 221- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115762,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115762,33.13,NULL,42.3,50811,NULL,NULL,'Dipole + Quadrupole','ESO 221- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115763,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115763,33.13,NULL,42.3,50811,NULL,NULL,'Dipole','ESO 221- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115764,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115764,33.39,NULL,47.6,50811,NULL,NULL,NULL,'ESO 221- G 022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115765,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115765,37.29,0.46,287,50812,70,NULL,NULL,'2MASX J14001301+5428581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.054417,54.48289,0,NULL,57281959563,895030618,13984853,18),(115766,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115766,37.37,0.46,298,50813,70,NULL,NULL,'2MASX J14001323+4625563',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000199,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,210.0549583,46.43222,0,NULL,59232493087,925507704,14461057,16.6),(115767,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115767,35.18,0.46,108,50814,70,NULL,NULL,'CGCG 018-016',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000062,NULL,'15.6g',0.37,'HII',NULL,NULL,NULL,NULL,1,210.055291667,-0.96272,0.125,NULL,43594130347,681158286,10643098,15.6),(115768,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115768,35.74,0.46,140,50815,70,NULL,NULL,'CGCG 103-040',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'15.7',0.28,NULL,NULL,NULL,NULL,NULL,1,210.055583,16.72764,0,NULL,58375294663,912113979,14251780,15.7),(115769,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115769,37.34,0.46,294,50816,70,NULL,NULL,'2MASX J14001388+4752043',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.0580417,47.86794,0.031,NULL,59244434276,925694285,14463973,17.2),(115770,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115770,37.1,0.46,264,50817,70,NULL,NULL,'SDSS J140014.44+351214.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.060167,35.20406,0,NULL,59149593301,924212395,14440818,18.2),(115771,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115771,33.84,0.25,58.6,50818,74.4,NULL,NULL,'ESO 384- G 026',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000093,NULL,'14.20',0.4,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.060916667,-34.03797,0.213,NULL,46883395868,732553060,11446141,14.2),(115772,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115772,33.37,0.45,47.3,50818,NULL,NULL,'K','ESO 384- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115773,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115773,33.84,0.4,58.6,50818,NULL,NULL,'mean','ESO 384- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115774,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115774,33.74,0.8,55.9,50819,75,NULL,'HMCL, I','UGC 08918',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000013,NULL,'15.05',0.4,'S?',NULL,NULL,NULL,NULL,1,210.060833,8.9675,0.014,NULL,58514776468,914293382,14285834,15.05),(115775,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115775,33.77,0.2,56.8,50819,74.4,NULL,NULL,'UGC 08918',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115776,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115776,33.77,0.4,56.8,50819,75,NULL,'HMCL, I, raw','UGC 08918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115777,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115777,33.89,0.4,60,50819,75,NULL,'HMCL, I, inv','UGC 08918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115778,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115778,33.9,0.35,60.3,50819,NULL,NULL,NULL,'UGC 08918',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115779,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115779,34.15,0.49,67.6,50819,75,NULL,'IR','UGC 08918',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115780,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115780,34.15,0.32,67.7,50819,NULL,NULL,'Malmquist cor.','UGC 08918',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115781,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115781,34.17,0.4,68.1,50819,75,NULL,'HMCL, I, cor','UGC 08918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115782,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115782,34.5,0.51,79.6,50820,NULL,NULL,NULL,'CGCG 074-032',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000033,NULL,'15.6',0.2,'Sc',NULL,NULL,NULL,NULL,1,210.06725,9.28928,0.014,NULL,58507629989,914181718,14284089,15.6),(115783,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115783,34.55,0.2,81.3,50820,74.4,NULL,NULL,'CGCG 074-032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115784,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115784,34.62,0.49,84,50820,75,NULL,'IR','CGCG 074-032',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115785,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115785,34.68,0.47,86.2,50820,NULL,NULL,'Malmquist cor.','CGCG 074-032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115786,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115786,36.77,0.62,226,50821,70,NULL,NULL,'2MASX J14001783-4234450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.0742917,-42.57925,0.245,NULL,46922928549,733170758,11455793,15.1),(115787,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115787,37.85,0.46,372,50822,70,NULL,NULL,'SDSS J140018.80+233443.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.078333,23.57872,0.019,NULL,59461285339,929082583,14516915,18),(115788,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115788,36.37,0.33,188,50823,70,NULL,NULL,'2MASX J14001886+1250288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.67',0.21,NULL,NULL,NULL,NULL,NULL,1,210.0785,12.84133,0,NULL,58368107534,912001680,14250026,17.67),(115789,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115789,36.86,0.27,235,50824,70,NULL,NULL,'2MASX J14001938+3310013',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,210.0807917,33.16703,0,NULL,59148505223,924195394,14440553,18.18),(115790,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115790,34.28,0.45,71.8,50825,NULL,NULL,'K','NGC 5406',NULL,'2007A&A...465...71T',2007,1,2.04,NULL,'G',0.00013,NULL,'13.1g',1.1,'SAB(rs)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.083833,38.91542,0,NULL,59141642173,924088158,14438877,13.1),(115791,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115791,34.29,0.47,72,50825,NULL,NULL,'H','NGC 5406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115792,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115792,34.35,0.46,74,50825,NULL,NULL,'J','NGC 5406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115793,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115793,34.47,0.4,78.5,50825,NULL,NULL,'mean','NGC 5406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115794,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115794,35.99,0.46,158,50826,70,NULL,NULL,'2MASX J14002018+2919218',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00011,NULL,'14.95',0.27,'S0',NULL,NULL,NULL,NULL,1,210.084083,29.32275,0,NULL,60007762134,937621283,14650332,14.95),(115795,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115795,37.68,0.33,343,50827,70,NULL,NULL,'2MASX J14002082+1318223',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.086875,13.30633,0,NULL,58368934968,912014608,14250228,18),(115796,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115796,37.71,0.23,348,50828,70,NULL,NULL,'2MASX J14002165+6204285',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.0905417,62.07467,0.029,NULL,57750851019,902357047,14099328,17.4),(115797,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115797,37.71,0.23,348,50829,70,NULL,NULL,'2MASX J14002333+6207215',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.096875,62.12272,0.029,NULL,57747445763,902303840,14098497,17.6),(115798,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115798,38.21,0.27,438,50830,70,NULL,NULL,'2MASX J14002624+0818158',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.44',0.16,'BrClG',NULL,NULL,NULL,NULL,1,210.109416667,8.30453,0,NULL,58513517028,914273703,14285526,18.44),(115799,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115799,36.06,0.46,163,50831,70,NULL,NULL,'CGCG 103-041',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000117,NULL,'15.4g',0.51,NULL,NULL,NULL,NULL,NULL,1,210.1100417,17.85925,0.039,NULL,58375848472,912122632,14251916,15.4),(115800,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115800,36.95,0.46,246,50832,70,NULL,NULL,'2MASX J14002807+4456217',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.1170417,44.93944,0,NULL,59235717761,925558090,14461845,17.1),(115801,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115801,33.68,0.49,54.4,50833,75,NULL,'IR','ESO 384- G 027',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000027,NULL,'14.62',0.4,'Sb:',NULL,NULL,NULL,NULL,1,210.120333,-34.62031,0.217,NULL,46882162892,732533795,11445840,14.62),(115802,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115802,33.7,0.2,55,50833,74.4,NULL,NULL,'ESO 384- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115803,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115803,33.98,0.42,62.6,50833,NULL,NULL,'Malmquist cor.','ESO 384- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115804,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115804,34.04,0.41,64.3,50833,NULL,NULL,NULL,'ESO 384- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115805,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115805,37.55,0.46,323,50834,70,NULL,NULL,'2MASX J14002987+3504201',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.1245,35.07233,0,NULL,59149483800,924210684,14440791,17),(115806,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115806,35.08,0.33,104,50835,70,NULL,NULL,'CGCG 018-018',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000077,NULL,'15.2g',0.37,'S0^-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.12525,-2.81064,0.121,NULL,43603520121,681305001,10645390,15.2),(115807,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115807,37.46,0.46,311,50836,70,NULL,NULL,'2MASX J14003073+5236008',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000209,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,210.127875,52.60031,0,NULL,59218713386,925292396,14457693,16.3),(115808,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115808,37.48,0.46,313,50837,70,NULL,NULL,'2MASX J14003088+1543333',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.45',0.14,NULL,NULL,NULL,NULL,NULL,1,210.128583,15.72597,0,NULL,58383573439,912243334,14253802,18.45),(115809,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115809,33.95,0.8,61.5,50838,75,NULL,'HMCL, I','CGCG 074-035',NULL,'1997ApJS..109..333W',1997,1,1.16,NULL,'G',0.000027,NULL,'15.4',0.11,'Sdm',NULL,NULL,NULL,NULL,1,210.129417,8.64981,0,NULL,58514848214,914294503,14285851,15.4),(115810,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115810,34.27,NULL,71.5,50838,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 074-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115811,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115811,34.28,0.2,71.8,50838,74.4,NULL,NULL,'CGCG 074-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115812,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115812,34.29,NULL,72.1,50838,NULL,NULL,'Dipole + Quadrupole','CGCG 074-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115813,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115813,34.3,NULL,72.4,50838,NULL,NULL,'Dipole','CGCG 074-035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115814,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115814,34.32,NULL,73,50838,NULL,NULL,NULL,'CGCG 074-035',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115815,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115815,34.86,0.4,93.6,50838,75,NULL,'HMCL, I, raw','CGCG 074-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115816,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115816,34.88,0.4,94.8,50838,75,NULL,'HMCL, I, inv','CGCG 074-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115817,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115817,35,0.4,99.8,50838,75,NULL,'HMCL, I, cor','CGCG 074-035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115818,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115818,37.68,0.33,343,50839,70,NULL,NULL,'2MASX J14003177+1331553',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,210.132333333,13.53197,0,NULL,58368314110,912004907,14250076,18.18),(115819,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115819,33.08,0.48,41.3,50840,70,NULL,NULL,'NGC 5393',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000087,NULL,'13.97',0.7,'(R_1R\'_2)SB(r)b: HII',NULL,NULL,NULL,NULL,1,210.1335,-28.87458,0.177,NULL,46983657041,734119641,11470619,13.97),(115820,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115820,37.71,0.23,348,50841,70,NULL,NULL,'2MASX J14003208+6153066',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.133583333,61.88511,0.021,NULL,57263052686,894735198,13980237,17.6),(115821,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115821,38.1,0.46,417,50842,70,NULL,NULL,'SDSS J140032.06+223631.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.133625,22.60869,0,NULL,59473722461,929276913,14519951,18.5),(115822,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115822,36.34,0.46,185,50843,70,NULL,NULL,'2MASX J14003276+1205213',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.90',0.25,NULL,NULL,NULL,NULL,NULL,1,210.1364583,12.08931,0,NULL,58460271803,913441746,14272527,16.9),(115823,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115823,34.99,0.49,99.4,50844,70,NULL,NULL,'2MASX J14003360-2014231',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.21',NULL,NULL,NULL,NULL,NULL,NULL,1,210.14,-20.23989,0.185,NULL,46516638309,726822473,11356601,15.21),(115824,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115824,36.09,0.46,165,50845,70,NULL,NULL,'2MASX J14003448+2546069',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000182,NULL,'15.6g',0.4,NULL,NULL,NULL,NULL,NULL,1,210.143583,25.76856,0,NULL,60010633334,937666145,14651033,15.6),(115825,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115825,37.33,0.33,292,50846,70,NULL,NULL,'2MASX J14003466+2735519',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.1442917,27.59794,0,NULL,60009668897,937651076,14650798,17.3),(115826,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115826,38.18,0.46,432,50847,70,NULL,NULL,'2MASX J14003469+4354487',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.144333,43.91344,0,NULL,59233871032,925529234,14461394,18),(115827,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115827,37.73,0.46,352,50848,70,NULL,NULL,'2MASX J14003512+4549327',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.1465,45.82569,0,NULL,59235477939,925554342,14461786,17),(115828,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115828,37.85,0.46,372,50849,70,NULL,NULL,'2MASX J14003659-0131171',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.152333333,-1.52156,0.145,NULL,43603345570,681302274,10645348,17.8),(115829,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115829,35.25,0.51,112,50850,70,NULL,NULL,'IC 0968 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000053,NULL,'15.83',0.46,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.1525417,-2.90911,0.121,NULL,43601372935,681271452,10644866,15.83),(115830,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115830,34.83,0.58,92.4,50851,70,NULL,NULL,'2MASX J14003696-1917231',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.57',0.3,NULL,NULL,NULL,NULL,NULL,1,210.1539583,-19.28983,0.225,NULL,43628471722,681694870,10651482,15.57),(115831,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115831,35.08,0.33,104,50852,70,NULL,NULL,'NGC 5400',NULL,'2015arXiv151105856S',2015,1,1.17,NULL,'G',0.00005,NULL,'13.9g',1.04,'(R\')S0-?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.155,-2.85781,0.121,NULL,43603465019,681304140,10645377,13.9),(115832,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115832,35.23,0.4,111,50852,NULL,NULL,'mean','NGC 5400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115833,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115833,35.94,0.45,154,50852,NULL,NULL,'K','NGC 5400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115834,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115834,34.69,0.49,86.7,50853,75,NULL,'IR','ESO 510- G 038',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.29',0.2,'S...',NULL,NULL,NULL,NULL,1,210.156083,-25.05008,0.329,NULL,46979172026,734049562,11469524,16.29),(115835,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115835,34.8,0.53,91.2,50853,NULL,NULL,'Malmquist cor.','ESO 510- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115836,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115836,34.82,0.52,92,50853,NULL,NULL,NULL,'ESO 510- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115837,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115837,34.86,0.2,93.8,50853,74.4,NULL,NULL,'ESO 510- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115838,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115838,36.34,NULL,185,50854,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1700',NULL,'2010Ap&SS.325..163P',2010,1,0.81,NULL,'G',0.000087,NULL,'16.6g',0.2,'Scd',NULL,NULL,NULL,NULL,1,210.1672917,49.79072,0.018,NULL,59253999232,925843738,14466308,16.6),(115839,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115839,36.34,NULL,186,50854,NULL,NULL,NULL,'FGC 1700',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115840,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115840,36.36,NULL,187,50854,NULL,NULL,'Dipole + Quadrupole','FGC 1700',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115841,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115841,36.39,NULL,190,50854,NULL,NULL,'Dipole','FGC 1700',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115842,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115842,35.84,0.4,147,50855,NULL,NULL,'Malmquist cor.','ESO 510- G 039',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.06',0.3,'S...',NULL,NULL,NULL,NULL,1,210.1734583,-23.18828,0.189,NULL,46507791593,726684243,11354441,16.06),(115843,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115843,35.94,0.39,154,50855,NULL,NULL,NULL,'ESO 510- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115844,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115844,35.98,0.2,157,50855,74.4,NULL,NULL,'ESO 510- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115845,'Faber-Jackson','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115845,31.61,0.65,21,50856,95,NULL,'Weighted Mean','NGC 5422',NULL,'1984ApJS...56...91D',1984,1,2.19,'HOLM 567B is a star.','G',0.000017,NULL,'12.9g',0.7,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.175167,55.16447,0.005,NULL,57300771668,895324557,13989446,12.9),(115846,'Faber-Jackson','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115846,32.97,0.81,39.3,50856,55,NULL,'Visvanathan & Sandage 1979','NGC 5422',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115847,'Tertiary','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115847,31.87,0.29,23.7,50856,95,NULL,NULL,'NGC 5422',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115848,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115848,32.45,0.8,30.9,50856,75,NULL,'B','NGC 5422',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115849,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115849,31.76,0.45,22.5,50856,NULL,NULL,'K','NGC 5422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115850,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115850,32.45,0.4,30.9,50856,NULL,NULL,'mean','NGC 5422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115851,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115851,38.21,0.27,438,50857,70,NULL,NULL,'2MASX J14004240+0806378',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.17675,8.11053,0.013,NULL,58513536540,914274008,14285531,NULL),(115852,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115852,36.19,0.46,173,50858,70,NULL,NULL,'2MASX J14004291+5850501',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.178625,58.84722,0,NULL,57273452875,894897701,13982776,17),(115853,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115853,37.16,0.33,271,50859,70,NULL,NULL,'2MASX J14004291+2022590',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.65',0.21,NULL,NULL,NULL,NULL,NULL,1,210.1787917,20.38297,0.037,NULL,59465184890,929143513,14517867,16.65),(115854,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115854,37.88,0.46,377,50860,70,NULL,NULL,'2MASX J14004293+0315155',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.178875,3.25425,0.037,NULL,58408348198,912630440,14259850,17),(115855,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115855,37.22,0.33,279,50861,70,NULL,NULL,'2MASX J14004472+0600005',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.16,NULL,NULL,NULL,NULL,NULL,1,210.18625,6.00006,0,NULL,58477622771,913712855,14276763,18.4),(115856,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115856,37.81,0.46,364,50862,70,NULL,NULL,'2MASX J14004483+1157083',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.186708333,11.95236,0,NULL,58460254524,913441476,14272523,17.3),(115857,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115857,37.2,0.33,275,50863,70,NULL,NULL,'MCG +10-20-063',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,210.186833,59.62706,0.021,NULL,57273591593,894899868,13982810,15.8),(115858,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115858,38.04,0.46,405,50864,70,NULL,NULL,'2MASXi J1400449+125327',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.187375,12.89083,0,NULL,58368031753,912000496,14250007,18.1),(115859,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115859,38.21,0.27,438,50865,70,NULL,NULL,'2MASX J14004510+0814128',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.1880417,8.23706,0,NULL,58513552065,914274251,14285535,17.7),(115860,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115860,32.44,0.69,30.7,50866,100,NULL,'mid-IR','NGC 5430',NULL,'2013ApJ...771...88L',2013,1,2.63,'HOLM 569B is a part of NGC 5430.','G',0.000017,NULL,'13.0g',1.03,'SB(s)b;HII;WR? Sbrst','Group member',NULL,NULL,'Starburst',1,210.190583,59.32828,0.005,NULL,57274165081,894908829,13982950,13),(115861,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115861,32.81,0.45,36.4,50866,NULL,NULL,'K','NGC 5430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115862,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115862,32.84,0.47,36.9,50866,NULL,NULL,'H','NGC 5430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115863,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115863,32.9,0.48,37.9,50866,NULL,NULL,'Malmquist cor.','NGC 5430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115864,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115864,32.92,0.46,38.4,50866,NULL,NULL,'J','NGC 5430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115865,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115865,33.01,0.43,40,50866,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115866,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115866,33.12,0.43,42,50866,75,NULL,'3.6 micron, color corrected','NGC 5430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115867,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115867,33.23,0.4,44.2,50866,NULL,NULL,'mean','NGC 5430',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115868,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115868,33.26,0.2,44.9,50866,74.4,NULL,NULL,'NGC 5430',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115869,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115869,33.29,0.4,45.5,50866,NULL,NULL,NULL,'NGC 5430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115870,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115870,33.5,0.2,50.1,50867,74.4,NULL,NULL,'UGC 08924',NULL,'2013AJ....146...86T',2013,1,1.64,NULL,'G',0.000007,NULL,'14.8g',0.35,'Scd(f)',NULL,NULL,NULL,NULL,1,210.190708333,2.02203,0.061,NULL,58418034979,912781796,14262215,14.8),(115871,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115871,33.53,0.49,50.8,50867,75,NULL,'IR','UGC 08924',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115872,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115872,33.59,0.47,52.2,50867,NULL,NULL,NULL,'UGC 08924',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115873,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115873,33.63,NULL,53.3,50867,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08924',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115874,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115874,33.64,NULL,53.5,50867,NULL,NULL,'Dipole + Quadrupole','UGC 08924',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115875,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115875,33.65,NULL,53.7,50867,NULL,NULL,'Dipole','UGC 08924',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115876,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115876,33.73,NULL,55.8,50867,NULL,NULL,NULL,'UGC 08924',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115877,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115877,33.9,0.41,60.3,50867,NULL,NULL,'Malmquist cor.','UGC 08924',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115878,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115878,30.99,0.8,15.8,50868,75,NULL,'MAT, I','ESO 271- G 010',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000019,NULL,'12.75',1.8,'SA(s)c',NULL,NULL,NULL,NULL,1,210.1935,-45.41856,0.233,NULL,46799832369,731247380,11425740,12.75),(115879,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115879,30.25,0.32,11.2,50868,85,NULL,'I, inv','ESO 271- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115880,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115880,30.27,0.32,11.3,50868,85,NULL,'I, raw','ESO 271- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115881,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115881,31,0.43,15.9,50868,75,NULL,'MAT, I, raw','ESO 271- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115882,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115882,31.02,0.43,16,50868,75,NULL,'MAT, I, inv','ESO 271- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115883,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115883,31.34,0.43,18.6,50868,75,NULL,'MAT, I, cor','ESO 271- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115884,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115884,31.51,0.47,20.1,50868,NULL,NULL,'H','ESO 271- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115885,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115885,31.52,0.46,20.2,50868,NULL,NULL,'J','ESO 271- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115886,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115886,31.56,0.45,20.5,50868,NULL,NULL,'K','ESO 271- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115887,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115887,31.61,0.4,21,50868,75,NULL,'B','ESO 271- G 010',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115888,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115888,31.7,0.4,21.9,50868,NULL,NULL,'mean','ESO 271- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115889,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115889,33.38,0.25,47.4,50869,74.4,NULL,NULL,'ESO 384- G 029',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00009,NULL,'13.87',1.2,'(R\'_2)SB(s)0/a',NULL,NULL,NULL,NULL,1,210.1964583,-34.22478,0.229,NULL,46883367963,732552624,11446134,13.87),(115890,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115890,33.51,0.4,50.5,50869,NULL,NULL,'mean','ESO 384- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115891,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115891,34.04,0.45,64.2,50869,NULL,NULL,'K','ESO 384- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115892,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115892,37.28,0.46,286,50870,70,NULL,NULL,'2MASX J14004709+4945008',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.196333,49.75017,0.018,NULL,59254211285,925847051,14466360,17.9),(115893,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115893,38.02,0.46,401,50871,70,NULL,NULL,'2MASX J14004727+3944183',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.1970417,39.73831,0,NULL,59260045428,925938209,14467784,17.8),(115894,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115894,37.23,0.46,279,50872,70,NULL,NULL,'2MASX J14004758+3611263',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.198166667,36.19067,0,NULL,59154127065,924283235,14441925,17.8),(115895,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115895,38.41,0.46,481,50873,70,NULL,NULL,'SDSS J140047.62+093851.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.1984583,9.64756,0.023,NULL,58508387852,914193560,14284274,17.6),(115896,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115896,32.14,0.4,26.7,50874,75,NULL,NULL,'NGC 5425',NULL,'2008Ap.....51..336K',2008,1,1.9,NULL,'G',0.000023,NULL,'14.21',0.5,'Sd             HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.198625,48.44386,0.034,NULL,59243114778,925673668,14463651,14.21),(115897,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115897,32.52,0.2,31.9,50874,74.4,NULL,NULL,'NGC 5425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115898,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115898,32.54,0.43,32.2,50874,75,NULL,'3.6 micron, color corrected','NGC 5425',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115899,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115899,32.57,0.43,32.7,50874,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5425',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115900,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115900,32.62,0.49,33.4,50874,75,NULL,'IR','NGC 5425',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115901,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115901,32.66,0.4,34.1,50874,NULL,NULL,'mean','NGC 5425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115902,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115902,33.18,0.47,43.2,50874,NULL,NULL,'H','NGC 5425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115903,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115903,38.43,0.46,485,50875,70,NULL,NULL,'2MASX J14004826+5730401',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.2014583,57.51117,0.009,NULL,57308178748,895440292,13991254,17.9),(115904,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115904,34.61,0.46,83.7,50876,70,NULL,NULL,'NGC 5407',NULL,'2015arXiv151105856S',2015,1,1.21,NULL,'G',0.000143,NULL,'14.2g',0.69,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.20875,39.15622,0,NULL,59141334446,924083350,14438802,14.2),(115905,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115905,37.2,0.46,276,50877,70,NULL,NULL,'2MASX J14005251+3221172',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.07',0.17,NULL,NULL,NULL,NULL,NULL,1,210.218875,32.35478,0,NULL,60033293334,938020208,14656565,18.07),(115906,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115906,37.16,0.33,271,50878,70,NULL,NULL,'2MASX J14005331+2018581',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.2222917,20.31603,0.037,NULL,59465211863,929143935,14517873,17.2),(115907,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115907,34.99,0.54,99.3,50879,70,NULL,NULL,'2MASX J14005337-2120290',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000133,NULL,'15.44',0.6,NULL,NULL,NULL,NULL,NULL,1,210.222333,-21.34156,0.189,NULL,46520930053,726889532,11357648,15.44),(115908,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115908,38.29,0.46,456,50880,70,NULL,NULL,'2MASX J14005335+0333155',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000199,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.222375,3.55444,0.041,NULL,58408495645,912632744,14259886,17),(115909,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115909,37.49,0.21,314,50881,70,NULL,NULL,'2MASX J14005362+2838237',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.2235,28.64003,0,NULL,60006892663,937607697,14650120,17.7),(115910,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115910,38.16,0.46,428,50882,70,NULL,NULL,'2MASX J14005381+3836541',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.223917,38.61508,0,NULL,59141761699,924090026,14438906,18.5),(115911,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115911,37.17,0.46,272,50883,70,NULL,NULL,'2MASX J14005433+1713002',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,210.226291667,17.21686,0,NULL,58376266532,912129164,14252018,18.44),(115912,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115912,37.42,0.46,304,50884,70,NULL,NULL,'2MASX J14005492+1727152',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.92',0.12,NULL,NULL,NULL,NULL,NULL,1,210.22875,17.45422,0.025,NULL,58375881585,912123149,14251924,18.92),(115913,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115913,37.39,0.46,300,50885,70,NULL,NULL,'2MASX J14005503+2754027',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000097,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,210.229333,27.90072,0,NULL,60009515861,937648685,14650760,16.5),(115914,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115914,38.6,0.46,524,50886,70,NULL,NULL,'2MASX J14005693+3428562',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.237125,34.48228,0,NULL,59149804420,924215694,14440870,18.7),(115915,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115915,37.57,0.46,326,50887,70,NULL,NULL,'2MASX J14005694+0134005',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.23725,1.56686,0.061,NULL,58417845543,912778836,14262169,17.8),(115916,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115916,37.77,0.46,357,50888,70,NULL,NULL,'2MASX J14005723+6230575',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.238625,62.516,0.021,NULL,57747556212,902305565,14098524,17.3),(115917,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115917,36.54,0.93,203,50889,70,NULL,NULL,'2MASX J14005766-2115340',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,210.24025,-21.25947,0.189,NULL,46516798348,726824974,11356640,13.8),(115918,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115918,37.71,0.23,348,50890,70,NULL,NULL,'2MASX J14005767+6151215',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,210.240417,61.85617,0.021,NULL,57263053005,894735203,13980237,16.4),(115919,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115919,37.75,0.46,355,50891,70,NULL,NULL,'2MASX J14005813+0006588',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.242167,0.11644,0.113,NULL,58411784354,912684130,14260689,17.5),(115920,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115920,35.3,0.49,115,50892,75,NULL,'IR','FGC 1699',NULL,'2011yCatp016004901K',2011,1,1.22,NULL,'G',0.000067,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,210.244541667,-16.61672,0.269,NULL,43680904177,682514127,10664283,16.5),(115921,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115921,35.58,NULL,131,50892,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115922,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115922,35.59,NULL,131,50892,NULL,NULL,'Dipole + Quadrupole','FGC 1699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115923,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115923,35.59,NULL,131,50892,NULL,NULL,'Dipole','FGC 1699',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115924,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115924,35.63,NULL,134,50892,NULL,NULL,NULL,'FGC 1699',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115925,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115925,37.97,0.33,392,50893,70,NULL,NULL,'2MASX J14005877+3639321',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.244875,36.65881,0,NULL,59153668473,924276069,14441813,17.3),(115926,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115926,37.35,0.27,295,50894,70,NULL,NULL,'2MASX J14005912+1951048',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,210.246375,19.85142,0.047,NULL,59465019044,929140922,14517826,18.18),(115927,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115927,39.19,0.46,690,50895,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 1835',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,210.259583,2.88,0.065,NULL,58416494261,912757722,14261839,NULL),(115928,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115928,39.21,NULL,695,50895,NULL,NULL,'3.1 (red) calibration','ABELL 1835',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115929,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115929,39.54,NULL,810,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115930,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115930,39.64,NULL,847,50895,NULL,NULL,'4.2 (black) calibration','ABELL 1835',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115931,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115931,39.84,NULL,931,50895,NULL,NULL,'4.1 (blue) calibration','ABELL 1835',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115932,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115932,39.88,NULL,946,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115933,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115933,39.96,0.33,980,50895,NULL,NULL,'Isotherm.','ABELL 1835',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115934,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115934,40.02,0.6,1010,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2000ApJ...538..505M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115935,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115935,40.06,NULL,1030,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115936,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115936,40.15,0.15,1070,50895,NULL,NULL,'Hydrost. Eq.','ABELL 1835',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115937,'SZ effect','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115937,40.26,0.52,1130,50895,NULL,NULL,NULL,'ABELL 1835',NULL,'2000ApJ...538..505M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115938,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115938,32.8,0.8,36.3,50896,75,NULL,NULL,'UGCA 378',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000013,NULL,'13.10',2.2,'SB(s)d pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.266833,-30.32722,0.109,NULL,46980731612,734073931,11469905,13.1),(115939,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115939,35.72,0.68,139,50897,70,NULL,NULL,'LCRS B135823.6-114909',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'16.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,210.2682083,-12.06047,0.217,NULL,43692072922,682688639,10667009,16.6),(115940,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115940,38.09,0.46,416,50898,70,NULL,NULL,'SDSS J140104.41+633525.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,210.268417,63.59044,0.025,NULL,57932075935,905188686,14143573,18.6),(115941,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115941,37.45,0.46,309,50899,70,NULL,NULL,'2MASX J14010504+3200472',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,210.271083333,32.01325,0,NULL,60049889493,938279523,14660617,18.08),(115942,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115942,37.35,0.46,295,50900,70,NULL,NULL,'2MASX J14010596+0919186',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,210.275,9.32164,0.013,NULL,58507485759,914179464,14284054,18.42),(115943,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115943,37.11,0.46,264,50901,70,NULL,NULL,'2MASX J14010750+4450158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.281291667,44.83753,0,NULL,59235759100,925558735,14461855,17.7),(115944,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115944,37.22,0.33,279,50902,70,NULL,NULL,'2MASX J14010778+0557093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.282333333,5.95258,0,NULL,58477753692,913714901,14276795,17.1),(115945,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115945,35.39,0.49,120,50903,70,NULL,NULL,'2MASX J14010939-4152081',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000167,NULL,'13.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.289083333,-41.869,0.237,NULL,46911785652,732996650,11453072,13.6),(115946,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115946,37.97,0.33,392,50904,70,NULL,NULL,'2MASX J14010949+3639262',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000198,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.2897083,36.65717,0,NULL,59153786053,924277907,14441842,17.9),(115947,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115947,37.43,0.46,306,50905,70,NULL,NULL,'2MASX J14011017+5738040',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000144,NULL,'16.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.2922917,57.63453,0.009,NULL,57308657405,895447771,13991371,16.8),(115948,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115948,37.4,0.46,302,50906,70,NULL,NULL,'2MASX J14011016+0950546',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.84',0.12,NULL,NULL,NULL,NULL,NULL,1,210.292417,9.84844,0.012,NULL,58508201577,914190649,14284228,18.84),(115949,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115949,33.26,0.4,44.9,50907,75,NULL,'Edat, raw','NGC 5397',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000057,NULL,'12.73',1,'SAB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.293583,-33.94583,0.229,NULL,46883175782,732549621,11446087,12.73),(115950,'D-Sigma','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115950,33.44,0.4,48.7,50907,75,NULL,'Edat, cor','NGC 5397',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115951,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115951,33.49,0.49,49.8,50907,70,NULL,NULL,'NGC 5397',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115952,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115952,34.31,0.25,72.8,50907,74.4,NULL,NULL,'NGC 5397',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115953,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115953,33.84,0.4,58.5,50907,NULL,NULL,'mean','NGC 5397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115954,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115954,34.63,0.45,84.2,50907,NULL,NULL,'K','NGC 5397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115955,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115955,34.93,0.8,96.8,50908,75,NULL,'HMCL, I','UGC 08927',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'15.10',0.4,'Sbc',NULL,NULL,NULL,NULL,1,210.2937083,7.48214,0.04,NULL,58513759383,914277490,14285585,15.1),(115956,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115956,34.49,0.4,79.1,50908,75,NULL,'HMCL, I, raw','UGC 08927',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115957,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115957,34.6,0.4,83.4,50908,75,NULL,'HMCL, I, inv','UGC 08927',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115958,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115958,34.68,0.46,86.4,50908,NULL,NULL,NULL,'UGC 08927',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115959,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115959,34.72,0.2,87.9,50908,74.4,NULL,NULL,'UGC 08927',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115960,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115960,34.78,0.4,90.4,50908,75,NULL,'HMCL, I, cor','UGC 08927',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115961,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115961,34.82,0.43,91.9,50908,NULL,NULL,'Malmquist cor.','UGC 08927',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115962,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115962,37.09,0.46,262,50909,70,NULL,NULL,'2MASX J14011097+2032498',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.295583,20.54725,0.047,NULL,59465748217,929152315,14518004,16.7),(115963,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115963,36.93,0.46,243,50910,70,NULL,NULL,'2MASX J14011223+3849432',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.300875,38.82864,0,NULL,59141621738,924087839,14438872,16.9),(115964,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115964,38.03,0.46,403,50911,70,NULL,NULL,'SDSS J140113.02+414513.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.3042917,41.75375,0,NULL,59258573916,925915217,14467425,18),(115965,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115965,37.6,0.46,332,50912,70,NULL,NULL,'2MASX J14011327+6501210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,210.305417,65.02261,0.017,NULL,57934792436,905231131,14144236,17.2),(115966,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115966,38.47,0.46,493,50913,70,NULL,NULL,'SDSS J140113.47+580502.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,210.306166667,58.08406,0,NULL,57308026323,895437911,13991217,18.5),(115967,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115967,37.74,0.46,354,50914,70,NULL,NULL,'2MASX J14011438+2924278',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000133,NULL,'15.15',0.22,'S0',NULL,NULL,NULL,NULL,1,210.309958333,29.40769,0,NULL,60007854956,937622733,14650355,15.15),(115968,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115968,37.33,0.33,292,50915,70,NULL,NULL,'2MASX J14011480+6221240',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.311625,62.35664,0.029,NULL,57747456809,902304012,14098500,16.9),(115969,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115969,36.25,0.49,178,50916,75,NULL,'IR','UGC 08934 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000223,NULL,'17.21',0.1,'Sbc',NULL,NULL,NULL,NULL,1,210.31375,10.48842,0.008,NULL,58510066305,914219786,14284684,17.21),(115970,'SNIa','2016-12-15 15:15:20','2016-12-16 11:20:33','1','SN 1975G','R',115970,34.11,NULL,66.4,50917,NULL,NULL,'Photographic','CGCG 272-018',NULL,'1988SSRv...48....1R',1988,1,0.94,NULL,'G',0.000127,NULL,'14.5g',0.45,NULL,NULL,NULL,NULL,NULL,1,210.316833,54.41872,0,NULL,57282428977,895037952,13984968,14.5),(115971,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115971,37.73,0.23,352,50918,70,NULL,NULL,'2MASX J14011623+3942562',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000213,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.317666667,39.71564,0,NULL,59259571699,925930807,14467668,16.3),(115972,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115972,37.73,0.23,352,50919,70,NULL,NULL,'2MASX J14011796+3945512',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.3247917,39.76428,0,NULL,59259570274,925930785,14467668,17.1),(115973,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115973,35.42,0.2,121,50920,74.4,NULL,NULL,'CGCG 074-039',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00002,NULL,'15.1',0.9,'Sc','Group member of poor cluster',NULL,NULL,NULL,1,210.325417,10.11881,0,NULL,58508074159,914188658,14284197,15.1),(115974,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115974,37.2,0.46,275,50921,70,NULL,NULL,'2MASX J14011822+0620121',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,210.325875,6.33683,0.032,NULL,58510834337,914231786,14284871,17),(115975,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115975,37.66,0.46,341,50922,70,NULL,NULL,'2MASX J14011862+1558213',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.52',0.16,NULL,NULL,NULL,NULL,NULL,1,210.3275417,15.97264,0,NULL,58374816697,912106510,14251664,18.52),(115976,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115976,37.55,0.46,323,50923,70,NULL,NULL,'2MASX J14011865+3924152',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.327833,39.40425,0,NULL,59259667900,925932310,14467692,17.6),(115977,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115977,37.35,0.27,295,50924,70,NULL,NULL,'2MASX J14011909+1931528',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.12',0.23,NULL,NULL,NULL,NULL,NULL,1,210.329583,19.53119,0.049,NULL,58326261057,911347829,14239809,17.12),(115978,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115978,35.79,0.57,144,50925,70,NULL,NULL,'2MASX J14011913-4146251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.32975,-41.77358,0.237,NULL,46911796055,732996813,11453075,14.5),(115979,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115979,35.24,0.62,112,50926,70,NULL,NULL,'2MFGC 11346',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.3304583,-15.76147,0.345,NULL,43684864574,682576008,10665250,15.9),(115980,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115980,37.8,0.33,363,50927,70,NULL,NULL,'2MASX J14011959+1404463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,210.3317917,14.07956,0,NULL,58369720469,912026882,14250420,16.9),(115981,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115981,37.36,0.46,297,50928,70,NULL,NULL,'SDSS J140119.83+270859.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.332625,27.14997,0,NULL,60011966372,937686974,14651358,17.8),(115982,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115982,37.32,0.46,291,50929,70,NULL,NULL,'SDSS J140120.14+242848.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.3339583,24.48019,0,NULL,59460656817,929072762,14516761,17.9),(115983,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115983,34.64,0.8,84.6,50930,75,NULL,'MAT, I','ESO 510- G 040',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.75',1,'SB(s)cd',NULL,NULL,NULL,NULL,1,210.336125,-26.19794,0.193,NULL,46990335835,734223997,11472249,14.75),(115984,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115984,33.58,0.32,52,50930,85,NULL,'I, raw','ESO 510- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115985,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115985,33.58,0.32,52.1,50930,85,NULL,'I, inv','ESO 510- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115986,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115986,33.88,0.46,59.7,50930,NULL,NULL,NULL,'ESO 510- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115987,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115987,33.9,0.43,60.1,50930,75,NULL,'MAT, I, raw','ESO 510- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115988,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115988,33.92,0.2,60.8,50930,74.4,NULL,NULL,'ESO 510- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115989,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115989,33.98,0.43,62.4,50930,75,NULL,'MAT, I, inv','ESO 510- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115990,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115990,33.99,0.43,62.9,50930,NULL,NULL,'Malmquist cor.','ESO 510- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115991,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115991,34.17,0.43,68.1,50930,75,NULL,'MAT, I, cor','ESO 510- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115992,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',115992,37.73,0.23,352,50931,70,NULL,NULL,'2MASX J14012160+3942482',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.3397917,39.71336,0,NULL,59259572116,925930814,14467668,18.1),(115993,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115993,30.61,0.8,13.3,50932,75,NULL,'MAT, I','NGC 5398',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'12.78',1.7,'SB(rs)dm',NULL,NULL,NULL,NULL,1,210.339833,-33.06378,0.233,NULL,47001778335,734402786,11475043,12.78),(115994,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115994,28.66,0.32,5.39,50932,85,NULL,'I, inv','NGC 5398',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115995,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115995,28.74,0.32,5.57,50932,85,NULL,'I, raw','NGC 5398',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115996,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115996,29.09,0.2,6.58,50932,74.4,NULL,NULL,'NGC 5398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115997,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115997,29.11,0.43,6.64,50932,75,NULL,'MAT, I, inv','NGC 5398',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115998,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115998,29.31,0.43,7.27,50932,75,NULL,'MAT, I, raw','NGC 5398',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(115999,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,115999,29.42,0.67,7.66,50932,NULL,NULL,'Malmquist cor.','NGC 5398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116000,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116000,29.54,NULL,8.09,50932,NULL,NULL,NULL,'NGC 5398',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116001,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116001,29.55,0.63,8.11,50932,NULL,NULL,NULL,'NGC 5398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116002,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116002,29.6,0.43,8.33,50932,75,NULL,'MAT, I, cor','NGC 5398',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116003,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116003,29.65,0.4,8.5,50932,73,NULL,'opt','NGC 5398',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116004,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116004,29.65,0.4,8.51,50932,NULL,NULL,NULL,'NGC 5398',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116005,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116005,31.31,0.4,18.3,50932,75,NULL,'B','NGC 5398',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116006,'Tully est','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116006,33.1,0.8,41.7,50933,75,NULL,'B','MRK 0465',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000104,NULL,'14.5g',0.69,'S0/a',NULL,NULL,NULL,'Starburst',1,210.350083,36.80008,0,NULL,59153839063,924278735,14441855,14.5),(116007,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116007,37.33,0.33,292,50934,70,NULL,NULL,'2MASX J14012471+6222210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.352958333,62.37264,0.029,NULL,57747456016,902304000,14098500,17.1),(116008,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116008,37.66,0.46,340,50935,70,NULL,NULL,'2MASX J14012490+6239090',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.3537917,62.65269,0.021,NULL,57747512962,902304890,14098513,17.8),(116009,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116009,37.2,0.33,275,50936,70,NULL,NULL,'2MASX J14012526+5938168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,210.35525,59.63797,0.021,NULL,57273728951,894902014,13982843,17.1),(116010,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116010,37.35,0.27,295,50937,70,NULL,NULL,'2MASX J14012531+1931497',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.96',0.23,NULL,NULL,NULL,NULL,NULL,1,210.355417,19.5305,0.049,NULL,58326259011,911347797,14239809,16.96),(116011,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116011,34.64,0.48,84.8,50938,70,NULL,NULL,'CGCG 018-026',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.000073,NULL,'15.0g',0.55,NULL,NULL,NULL,NULL,NULL,1,210.3555,-0.62392,0.125,NULL,43593639708,681150620,10642978,15),(116012,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116012,37.03,0.46,254,50939,70,NULL,NULL,'2MASX J14012549+5655188',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,210.356083333,56.92206,0,NULL,57310894935,895482733,13991917,16.3),(116013,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116013,37.8,0.33,363,50940,70,NULL,NULL,'2MASX J14012612+1406153',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.3589583,14.10436,0,NULL,58369724309,912026942,14250420,17.7),(116014,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'N',116014,37.75,NULL,354,50941,65,NULL,'L = 10e57 photons/s','GRB 790307',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116015,'GRB','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'N',116015,40.79,NULL,1440,50941,65,NULL,'L = 2 x 10e58 photons/s','GRB 790307',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116016,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116016,36.59,0.46,208,50942,70,NULL,NULL,'2MASX J14012807+4625119',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000176,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,210.366875,46.42003,0,NULL,59235371617,925552681,14461760,16.4),(116017,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116017,37.38,0.46,300,50943,70,NULL,NULL,'2MASX J14012928+1009502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.372083,10.16394,0,NULL,58508081137,914188767,14284199,17.2),(116018,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116018,36.41,0.46,191,50944,70,NULL,NULL,'2MASX J14012954+3432432',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.37325,34.54533,0,NULL,59149830345,924216099,14440876,16.7),(116019,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116019,33.35,0.45,46.7,50945,NULL,NULL,'K','ESO 384- G 033',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00007,NULL,'14.66',0.8,'SB(rl)0^+',NULL,NULL,NULL,NULL,1,210.3740417,-34.24219,0.229,NULL,46883179947,732549686,11446088,14.66),(116020,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116020,33.62,0.4,53,50945,NULL,NULL,'mean','ESO 384- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116021,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116021,36.02,0.46,160,50946,70,NULL,NULL,'2MASX J14013116+1342173',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.38,13.70489,0,NULL,58371644819,912056950,14250889,17),(116022,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116022,36.57,0.46,206,50947,70,NULL,NULL,'2MASX J14013130+2027009',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.50',0.22,NULL,NULL,NULL,NULL,NULL,1,210.380333333,20.45022,0.047,NULL,59465092135,929142064,14517844,17.5),(116023,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116023,37.93,0.46,385,50948,70,NULL,NULL,'2MASX J14013143+3409022',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.381083333,34.15058,0,NULL,59151777250,924246519,14441351,17.3),(116024,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116024,37,0.46,251,50949,70,NULL,NULL,'2MASX J14013151+2842345',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.14',0.18,NULL,NULL,NULL,NULL,NULL,1,210.381291667,28.70975,0,NULL,60006900382,937607818,14650122,18.14),(116025,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116025,37.16,0.46,271,50950,70,NULL,NULL,'2MASX J14013159+5625538',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,210.381625,56.43175,0.005,NULL,57309377489,895459023,13991547,16.4),(116026,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116026,37.06,0.55,258,50951,70,NULL,NULL,'LCRS B135851.5-112459',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.3837083,-11.65728,0.165,NULL,43746812731,683543948,10680374,16.2),(116027,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116027,38.15,0.46,426,50952,70,NULL,NULL,'SDSS J140132.51+054933.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.3855,5.82603,0.032,NULL,58477728099,913714501,14276789,18.2),(116028,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116028,37.33,0.33,292,50953,70,NULL,NULL,'SDSS J140132.98+274202.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.387416667,27.70067,0,NULL,60011821092,937684704,14651323,18.3),(116029,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116029,36.4,0.64,190,50954,70,NULL,NULL,'2MASX J14013315-1120541',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00012,NULL,'16.3b',0.3,NULL,NULL,NULL,NULL,NULL,1,210.388041667,-11.34853,0.165,NULL,43747503236,683554738,10680542,16.3),(116030,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116030,37.36,0.27,296,50955,70,NULL,NULL,'2MASX J14013395+2459095',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.44',0.2,NULL,NULL,NULL,NULL,NULL,1,210.3915,24.98611,0,NULL,59996579558,937446555,14647602,17.44),(116031,'BCG','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116031,37.06,0.35,249,50956,60,NULL,'ABELL 1837, BCG','2MASX J14013635-1107431',0.0376,'1980ApJ...241..486H',1980,1,1.4,NULL,'G',0.00001,NULL,'14.59',NULL,'cD','Brightest group member',NULL,NULL,NULL,1,210.401583,-11.12872,0.113,NULL,43747476515,683554320,10680536,14.59),(116032,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116032,36.77,0.75,226,50957,70,NULL,NULL,'2MASX J14013657-2117063',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.93',0.3,NULL,NULL,NULL,NULL,NULL,1,210.4022083,-21.28528,0.185,NULL,46516280310,726816879,11356513,15.93),(116033,'BCG','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116033,37.06,0.35,249,50958,60,NULL,NULL,'ABELL 1837',0.0376,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.00041,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,210.402917,-11.12444,0.113,NULL,43747199075,683549985,10680468,NULL),(116034,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116034,37.22,0.57,277,50959,70,NULL,NULL,'2MASX J14013848-0225589',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000127,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,210.41025,-2.433,0.157,NULL,43603581519,681305961,10645405,16.1),(116035,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116035,36.99,0.33,250,50960,70,NULL,NULL,'2MASX J14013876+3833549',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,210.4114583,38.56519,0,NULL,59141550129,924086720,14438855,16.2),(116036,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116036,36.41,0.46,191,50961,70,NULL,NULL,'2MASX J14013883+2418095',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,210.411875,24.30267,0.01,NULL,59460637560,929072461,14516757,16.4),(116037,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116037,37.36,0.27,296,50962,70,NULL,NULL,'2MASX J14013983+2500025',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.415875,25.00072,0,NULL,59996459556,937444680,14647573,17.3),(116038,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116038,38.42,0.46,483,50963,70,NULL,NULL,'2MASX J14014094+0910072',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000134,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.420625,9.16875,0,NULL,58507464233,914179128,14284048,17.7),(116039,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116039,38.48,0.46,495,50964,70,NULL,NULL,'2MASX J14014149+6250551',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.423,62.84867,0.037,NULL,57747870546,902310477,14098601,17.7),(116040,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116040,38.07,0.46,410,50965,70,NULL,NULL,'2MASX J14014226+4045379',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.426,40.76044,0,NULL,59260533861,925945841,14467903,17.5),(116041,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116041,38.32,0.46,461,50966,70,NULL,NULL,'2MASX J14014303+6341531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.42925,63.69819,0.025,NULL,57932110625,905189228,14143581,18.1);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (116042,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116042,37.96,0.46,391,50967,70,NULL,NULL,'2MASX J14014397+2832545',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.95',0.11,NULL,NULL,NULL,NULL,NULL,1,210.43325,28.54858,0,NULL,60006913921,937608030,14650125,18.95),(116043,'FP','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,'R',116043,38.13,0.46,422,50968,70,NULL,NULL,'SDSS J140144.81+151735.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.43675,15.29328,0,NULL,58382768688,912230760,14253605,18.5),(116044,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116044,34.57,0.8,81.9,50969,75,NULL,'W91CL, r','NGC 5409',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'14.06',1.1,'(R\')SAB(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.442,9.49028,0.013,NULL,58508343373,914192865,14284263,14.06),(116045,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116045,34.57,0.8,81.9,50969,75,NULL,'HMCL, I','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116046,'IRAS','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116046,34.6,0.8,83.1,50969,75,NULL,'CF, r','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116047,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116047,34.17,0.4,68.3,50969,75,NULL,'HMCL, I, raw','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116048,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116048,34.21,0.38,69.5,50969,75,NULL,'CF, r, raw','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116049,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116049,34.23,0.38,70.1,50969,75,NULL,'W91CL, r, raw','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116050,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116050,34.35,0.38,74.2,50969,75,NULL,'CF, r, inv','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116051,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116051,34.36,0.4,74.6,50969,75,NULL,'HMCL, I, inv','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116052,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116052,34.38,0.38,75.3,50969,75,NULL,'W91CL, r, inv','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116053,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116053,34.51,0.4,79.7,50969,75,NULL,'HMCL, I, cor','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116054,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116054,34.51,0.38,80,50969,75,NULL,'CF, r, cor','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116055,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116055,34.53,0.38,80.6,50969,75,NULL,'W91CL, r, cor','NGC 5409',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116056,'Tully-Fisher','2016-12-15 15:15:20','2016-12-16 11:20:33','1',NULL,NULL,116056,34.63,0.5,84.1,50969,NULL,NULL,NULL,'NGC 5409',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116057,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116057,34.67,0.2,85.9,50969,74.4,NULL,NULL,'NGC 5409',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116058,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116058,34.71,0.48,87.3,50969,NULL,NULL,'Malmquist cor.','NGC 5409',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116059,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116059,34.81,0.4,91.7,50969,NULL,NULL,'mean','NGC 5409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116060,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116060,34.91,0.47,95.7,50969,NULL,NULL,'H','NGC 5409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116061,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116061,35.02,0.46,101,50969,NULL,NULL,'J','NGC 5409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116062,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116062,35.06,0.45,103,50969,NULL,NULL,'K','NGC 5409',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116063,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116063,36,0.46,159,50970,70,NULL,NULL,'2MASX J14014610+1848280',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.52',0.23,NULL,NULL,NULL,NULL,NULL,1,210.442167,18.80772,0.049,NULL,58326828290,911356692,14239948,17.52),(116064,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116064,35.49,0.62,126,50971,70,NULL,NULL,'IC 0969',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.79',NULL,NULL,NULL,NULL,NULL,NULL,1,210.4425,-4.18039,0.089,NULL,43597189774,681206090,10643845,15.79),(116065,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116065,36.99,0.33,250,50972,70,NULL,NULL,'2MASX J14014626+3834349',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000187,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,210.442875,38.5765,0,NULL,59141549005,924086703,14438854,16.1),(116066,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116066,37.29,0.64,287,50973,70,NULL,NULL,'LCRS B135905.8-112006',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000143,NULL,'15.8b',0.6,NULL,NULL,NULL,NULL,NULL,1,210.442917,-11.57583,0.165,NULL,43746795000,683543671,10680369,15.8),(116067,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116067,35.13,0.46,106,50974,70,NULL,NULL,'CGCG 191-035',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.00008,NULL,'14.3g',0.79,NULL,NULL,NULL,NULL,NULL,1,210.444375,34.66781,0,NULL,59149824954,924216014,14440875,14.3),(116068,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116068,38.03,0.46,404,50975,70,NULL,NULL,'2MASX J14014843+4803158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.4515417,48.05447,0.036,NULL,59243592334,925681130,14463767,17.6),(116069,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116069,37.73,0.23,352,50976,70,NULL,NULL,'2MASX J14015048+3943089',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000204,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,210.460417,39.71914,0,NULL,59259575058,925930860,14467669,16.1),(116070,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116070,38.47,0.46,494,50977,70,NULL,NULL,'2MASX J14015133+3255583',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.4639583,32.93297,0,NULL,60033934626,938030228,14656722,17.4),(116071,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2001gq',NULL,116071,42.26,0.12,1690,50978,74.2,NULL,'SALT 2','SDSS J140151.41+045312.5',0.671,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'21.5g',0.04,NULL,NULL,NULL,NULL,NULL,1,210.46425,4.88681,0.036,NULL,58480883103,913763798,14277559,21.5),(116072,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116072,38.22,0.33,441,50979,70,NULL,NULL,'2MASX J14015236+4245415',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,210.4682083,42.76164,0,NULL,59271858789,926122793,14470668,16.9),(116073,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116073,37.25,0.46,282,50980,70,NULL,NULL,'2MASX J14015249+2401275',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.468833333,24.02442,0.022,NULL,59460719918,929073748,14516777,16.9),(116074,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116074,36.95,0.46,245,50981,70,NULL,NULL,'2MASX J14015257+2250520',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.30',0.22,NULL,NULL,NULL,NULL,NULL,1,210.469125,22.84797,0,NULL,59474221006,929284703,14520073,17.3),(116075,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116075,34.96,0.27,98.3,50982,70,NULL,NULL,'CGCG 074-046 NED01',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'15.63',0.33,NULL,NULL,NULL,NULL,NULL,1,210.4697917,9.63036,0.009,NULL,58508228417,914191069,14284235,15.63),(116076,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116076,37.51,0.63,317,50983,70,NULL,NULL,'2MASX J14015321-3629135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.471667,-36.48703,0.217,NULL,46891109345,732673583,11448024,15.8),(116077,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116077,37.48,0.46,313,50984,70,NULL,NULL,'2MASX J14015514+3902439',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.479625,39.04553,0,NULL,59141366347,924083849,14438810,17),(116078,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116078,38.22,0.33,441,50985,70,NULL,NULL,'2MASX J14015681+4247075',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.486791667,42.78531,0,NULL,59271870442,926122975,14470671,18),(116079,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr','R',116079,41.42,NULL,1250,50986,65,NULL,'SALT','SCP J140157.75+044342.4',0.543,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.490625,4.72844,0.037,NULL,58480705950,913761030,14277516,NULL),(116080,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr',NULL,116080,41.77,0.1,1460,50986,74.2,NULL,'SALT 2','SCP J140157.75+044342.4',0.543,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116081,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr',NULL,116081,42.39,0.14,1950,50986,70,NULL,'SALT','SCP J140157.75+044342.4',0.543,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116082,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr',NULL,116082,42.56,0.11,2100,50986,65,NULL,'SALT','SCP J140157.75+044342.4',0.543,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116083,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2000fr',NULL,116083,42.68,0.19,2230,50986,65,NULL,NULL,'SCP J140157.75+044342.4',0.543,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116084,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116084,35.4,0.65,120,50987,NULL,NULL,'Malmquist cor.','ESO 578- G 016',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.98',0.7,'SAB(r)bc',NULL,NULL,NULL,NULL,1,210.4959583,-22.36361,0.165,NULL,46520441977,726881905,11357529,14.98),(116085,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116085,35.63,0.58,134,50987,NULL,NULL,NULL,'ESO 578- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116086,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116086,35.67,0.2,136,50987,74.4,NULL,NULL,'ESO 578- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116087,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2001gn',NULL,116087,43.85,0.2,2770,50988,74.2,NULL,'SALT 2','SCP J140159.90+050459.6',1.124,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.499583,5.08322,0.039,NULL,58480847432,913763241,14277550,NULL),(116088,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116088,36.59,0.46,208,50989,70,NULL,NULL,'2MASX J14015991+2651506',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.43',0.22,NULL,NULL,NULL,NULL,NULL,1,210.49975,26.86397,0,NULL,60012004115,937687564,14651368,17.43),(116089,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116089,36.68,0.46,217,50990,70,NULL,NULL,'2MASX J14020006+4533425',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000193,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,210.500375,45.56186,0,NULL,59236108667,925564197,14461940,15.8),(116090,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116090,36.46,0.46,196,50991,70,NULL,NULL,'2MASX J14020009+1927413',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.5005,19.46136,0.053,NULL,58326290804,911348293,14239817,16.6),(116091,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116091,36.41,0.55,191,50992,70,NULL,NULL,'2MASX J14020028-3302384',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.6b',NULL,'E',NULL,NULL,NULL,NULL,1,210.501083333,-33.04406,0.241,NULL,47001774449,734402725,11475042,16.6),(116092,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116092,37.36,0.46,297,50993,70,NULL,NULL,'SDSS J140200.41+592932.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,210.50175,59.49231,0.005,NULL,57273740812,894902200,13982846,18.5),(116093,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:33','1','SN 2001go',NULL,116093,41.8,0.11,1480,50994,74.2,NULL,'SALT 2','SCP J140200.95+050059.2',0.552,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.5039583,5.01644,0.036,NULL,58480838808,913763106,14277548,NULL),(116094,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116094,36.23,0.81,176,50995,70,NULL,NULL,'2MASX J14020167-2211235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.507,-22.18989,0.169,NULL,46520407935,726881373,11357521,14.7),(116095,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116095,38.07,0.46,411,50996,70,NULL,NULL,'2MASX J14020319+1054518',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.513333,10.91447,0.032,NULL,58506706524,914167289,14283863,17.7),(116096,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116096,34.22,0.46,70,50997,NULL,NULL,NULL,'NGC 5414',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000013,NULL,'13.8',0.8,'PECULR','Group member of poor cluster',NULL,NULL,NULL,1,210.514708333,9.92933,0.006,NULL,58508064657,914188510,14284195,13.8),(116097,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116097,34.27,0.2,71.5,50997,74.4,NULL,NULL,'NGC 5414',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116098,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116098,34.36,0.43,74.5,50997,NULL,NULL,'Malmquist cor.','NGC 5414',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116099,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116099,36.85,0.46,235,50998,70,NULL,NULL,'2MASX J14020473+3342063',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.519625,33.70175,0,NULL,59148393865,924193654,14440525,17.2),(116100,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116100,37.67,0.46,341,50999,70,NULL,NULL,'SDSS J140204.91+491250.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.5204583,49.21403,0.041,NULL,59243301809,925676590,14463696,18),(116101,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116101,35.05,0.46,102,51000,70,NULL,NULL,'CGCG 018-029',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000093,NULL,'14.9g',0.66,'E','in a triple',NULL,NULL,NULL,1,210.5260417,-1.39647,0.133,NULL,43602689219,681292019,10645187,14.9),(116102,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116102,38.33,0.33,463,51001,70,NULL,NULL,'2MASX J14020803+1534068',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,210.533417,15.56861,0,NULL,58382850050,912232032,14253625,NULL),(116103,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116103,36.08,0.46,164,51002,70,NULL,NULL,'2MASX J14020834+1830164',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.99',0.21,NULL,NULL,NULL,NULL,NULL,1,210.534875,18.50478,0.076,NULL,58326600111,911353126,14239892,17.99),(116104,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116104,36.62,0.33,211,51003,70,NULL,NULL,'2MASX J14020849+1557168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.77',0.22,NULL,NULL,NULL,NULL,NULL,1,210.535583,15.95464,0,NULL,58375103397,912110990,14251734,17.77),(116105,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116105,37.27,0.46,285,51004,70,NULL,NULL,'SDSS J140208.71+460340.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.536333,46.06122,0,NULL,59235596691,925556198,14461815,18.2),(116106,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116106,38.49,0.46,499,51005,70,NULL,NULL,'2MASX J14020922+1024097',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.5382917,10.40261,0.007,NULL,58510218923,914222170,14284721,18),(116107,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116107,36.55,0.46,205,51006,70,NULL,NULL,'B3 1400+379',NULL,'2015arXiv151105856S',2015,1,0.42,'TXS codes: confusion(W);lobes(C)','G',0.000171,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,210.542333,37.72322,0,NULL,59142877605,924107462,14439179,16.3),(116108,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116108,36.52,0.92,202,51007,70,NULL,NULL,'CGCG 018-032',NULL,'2014MNRAS.445.2677S',2014,1,1.05,NULL,'G',0.000074,NULL,'15.3g',0.42,'Sc','Isolated galaxy',NULL,NULL,NULL,1,210.544083,-0.23622,0.113,NULL,43593747480,681152304,10643004,15.3),(116109,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116109,33.95,0.23,61.7,51008,74.4,NULL,NULL,'ABELL S0753:[WFC91] 037',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'14.93',NULL,'S0',NULL,NULL,NULL,NULL,1,210.544708333,-33.79072,0.233,NULL,46880272537,732504258,11445379,14.93),(116110,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116110,34.04,0.51,64.1,51008,70,NULL,NULL,'ABELL S0753:[WFC91] 037',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116111,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116111,34.56,0.8,81.5,51009,75,NULL,'HMCL, I','NGC 5416',NULL,'1997ApJS..109..333W',1997,1,1.37,NULL,'G',0.00002,NULL,'13.8g',0.75,'Scd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.547167,9.44011,0,NULL,58507824257,914184754,14284136,13.8),(116112,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116112,34.56,0.8,81.5,51009,75,NULL,'W91CL, r','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116113,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116113,34.57,0.8,82.2,51009,75,NULL,'CF, r','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116114,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116114,33.76,0.69,56.4,51009,100,NULL,'mid-IR','NGC 5416',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116115,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116115,34.23,0.38,70.1,51009,75,NULL,'CF, r, raw','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116116,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116116,34.33,0.38,73.3,51009,75,NULL,'W91CL, r, raw','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116117,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116117,34.38,0.47,75.1,51009,NULL,NULL,'H','NGC 5416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116118,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116118,34.39,0.38,75.4,51009,75,NULL,'CF, r, inv','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116119,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116119,34.49,0.45,79.2,51009,NULL,NULL,'K','NGC 5416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116120,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116120,34.5,0.38,79.3,51009,75,NULL,'W91CL, r, inv','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116121,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116121,34.5,0.2,79.4,51009,74.4,NULL,NULL,'NGC 5416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116122,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116122,34.51,0.46,79.8,51009,NULL,NULL,'J','NGC 5416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116123,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116123,34.53,0.08,80.5,51009,71,NULL,'ZW 74-23 Cluster  ','NGC 5416',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116124,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116124,34.53,0.48,80.5,51009,NULL,NULL,NULL,'NGC 5416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116125,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116125,34.53,0.38,80.6,51009,75,NULL,'CF, r, cor','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116126,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116126,34.61,0.38,83.5,51009,75,NULL,'W91CL, r, cor','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116127,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116127,34.61,0.47,83.6,51009,NULL,NULL,'Malmquist cor.','NGC 5416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116128,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116128,34.73,0.4,88.1,51009,75,NULL,'HMCL, I, raw','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116129,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116129,34.79,0.16,90.8,51009,70,NULL,'ZW 74-23 Cluster  ','NGC 5416',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116130,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116130,34.81,0.4,91.4,51009,NULL,NULL,'mean','NGC 5416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116131,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116131,34.9,0.4,95.4,51009,75,NULL,'HMCL, I, cor','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116132,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116132,34.97,0.4,98.5,51009,75,NULL,'HMCL, I, inv','NGC 5416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116133,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116133,35.91,0.49,152,51010,70,NULL,NULL,'2MASX J14021131-2212375',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000143,NULL,'15.50',0.6,NULL,NULL,NULL,NULL,NULL,1,210.547167,-22.21036,0.169,NULL,46520415174,726881487,11357523,15.5),(116134,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116134,35.64,0.46,135,51011,70,NULL,NULL,'2MASX J14021137+3339305',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,210.5472917,33.65842,0,NULL,59148377785,924193402,14440521,16.3),(116135,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116135,35.28,0.49,114,51012,75,NULL,'IR','ESO 578- G 017',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.01',0.2,'Sb             HII',NULL,NULL,NULL,NULL,1,210.5475417,-18.75425,0.249,NULL,43625988186,681656065,10650876,16.01),(116136,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116136,35.35,0.55,118,51012,NULL,NULL,'Malmquist cor.','ESO 578- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116137,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116137,35.4,0.54,120,51012,NULL,NULL,NULL,'ESO 578- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116138,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116138,35.45,0.2,123,51012,74.4,NULL,NULL,'ESO 578- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116139,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116139,32.38,0.2,29.9,51013,74.4,NULL,NULL,'NGC 5443',NULL,'2013AJ....146...86T',2013,1,2.28,'HOLM 578B is a star.','G',0.000027,NULL,'12.9g',0.8,'SB(s)b?','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.549167,55.81403,0,NULL,57301204516,895331320,13989551,12.9),(116140,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116140,32.41,0.4,30.4,51013,NULL,NULL,'mean','NGC 5443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116141,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116141,32.43,0.46,30.7,51013,NULL,NULL,'J','NGC 5443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116142,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116142,32.44,0.43,30.8,51013,75,NULL,'3.6 micron, color corrected','NGC 5443',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116143,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116143,32.45,0.47,30.9,51013,NULL,NULL,'H','NGC 5443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116144,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116144,32.5,0.45,31.6,51013,NULL,NULL,'K','NGC 5443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116145,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116145,32.6,0.43,33.1,51013,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5443',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116146,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116146,37.26,0.46,283,51014,70,NULL,NULL,'2MASX J14021215+2444176',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.550541667,24.73831,0,NULL,59996591502,937446742,14647605,17.9),(116147,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116147,37.63,0.46,336,51015,70,NULL,NULL,'2MASX J14021278+6257487',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000187,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.55325,62.96358,0.037,NULL,57747877349,902310583,14098602,17.1),(116148,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116148,37.34,0.46,293,51016,70,NULL,NULL,'2MASX J14021297+1808324',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.33',0.16,NULL,NULL,NULL,NULL,NULL,1,210.5540417,18.14231,0.024,NULL,58372549359,912071083,14251110,18.33),(116149,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116149,34.32,0.4,73.2,51017,NULL,NULL,'mean','NGC 5417',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000032,NULL,'13.86',0.6,'Sa','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.554333,8.03711,0.033,NULL,58513262332,914269723,14285464,13.86),(116150,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116150,34.39,0.47,75.5,51017,NULL,NULL,'H','NGC 5417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116151,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116151,34.4,0.46,75.8,51017,NULL,NULL,'J','NGC 5417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116152,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116152,34.41,0.45,76.1,51017,NULL,NULL,'K','NGC 5417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116153,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116153,34.58,0.46,82.5,51017,NULL,NULL,'Malmquist cor.','NGC 5417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116154,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116154,34.64,0.45,84.7,51017,NULL,NULL,NULL,'NGC 5417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116155,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116155,34.94,0.2,97.3,51017,74.4,NULL,NULL,'NGC 5417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116156,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116156,35.61,0.54,132,51018,70,NULL,NULL,'2MASX J14021301-1155477',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.8b',0.5,NULL,NULL,NULL,NULL,NULL,1,210.5542083,-11.93011,0.217,NULL,43713083812,683016934,10672139,15.8),(116157,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116157,33.31,0.47,45.9,51019,NULL,NULL,'H','ESO 174- G 005',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00002,NULL,'15.84',0.9,'SAB(s)cd;asymm.disk',NULL,NULL,NULL,NULL,1,210.557167,-53.54083,NULL,NULL,46813534358,731461474,11429085,15.84),(116158,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116158,33.42,0.45,48.3,51019,NULL,NULL,'K','ESO 174- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116159,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116159,33.5,0.46,50.1,51019,NULL,NULL,'J','ESO 174- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116160,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116160,33.67,0.4,54.1,51019,NULL,NULL,'mean','ESO 174- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116161,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116161,34.96,0.27,98.3,51020,70,NULL,NULL,'2MASX J14021471+0946557',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00007,NULL,'15.82',0.29,NULL,NULL,NULL,NULL,NULL,1,210.561417,9.78228,0.009,NULL,58508191048,914190485,14284226,15.82),(116162,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116162,35.81,0.6,145,51021,70,NULL,NULL,'LCRS B135935.2-111945',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000097,NULL,'16.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,210.565667,-11.56964,0.129,NULL,43746797066,683543704,10680370,16.6),(116163,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116163,37.73,0.46,352,51022,70,NULL,NULL,'2MASX J14021598+1735548',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.13,NULL,NULL,NULL,NULL,NULL,1,210.5665,17.5985,0.005,NULL,58372467250,912069800,14251090,18.66),(116164,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116164,37.57,0.46,327,51023,70,NULL,NULL,'2MASX J14021638+0518186',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.568333333,5.30525,0.052,NULL,58480466319,913757286,14277457,16.7),(116165,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116165,38.18,0.46,433,51024,70,NULL,NULL,'2MASX J14021647+4146262',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.56875,41.77403,0,NULL,59259120951,925923764,14467558,17.5),(116166,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116166,37.36,0.27,296,51025,70,NULL,NULL,'2MASX J14021677+2456346',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.93',0.17,NULL,NULL,NULL,NULL,NULL,1,210.570041667,24.94294,0,NULL,59996608264,937447004,14647609,17.93),(116167,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116167,33.07,0.97,41,51026,NULL,NULL,NULL,'NGC 5418',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.42',0.5,'SB?','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.5732917,7.68417,0.029,NULL,58513209180,914268893,14285451,14.42),(116168,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116168,33.1,0.96,41.7,51026,NULL,NULL,'Malmquist cor.','NGC 5418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116169,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116169,33.11,0.2,41.9,51026,74.4,NULL,NULL,'NGC 5418',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116170,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116170,33.62,0.47,53,51026,NULL,NULL,'H','NGC 5418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116171,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116171,33.8,0.45,57.6,51026,NULL,NULL,'K','NGC 5418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116172,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116172,33.81,0.46,57.9,51026,NULL,NULL,'J','NGC 5418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116173,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116173,34.11,0.4,66.5,51026,NULL,NULL,'mean','NGC 5418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116174,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116174,36.14,0.55,169,51027,70,NULL,NULL,'2MASX J14021759-2159006',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,210.573375,-21.98356,0.201,NULL,46520868381,726888568,11357633,14.1),(116175,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116175,37.61,0.46,333,51028,70,NULL,NULL,'SDSS J140218.84+195519.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.21',0.18,NULL,NULL,NULL,NULL,NULL,1,210.5785,19.92203,0.042,NULL,59466093758,929157714,14518089,18.21),(116176,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116176,37.77,0.46,359,51029,70,NULL,NULL,'2MASX J14022013+2128565',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.49',0.15,NULL,NULL,NULL,NULL,NULL,1,210.5839583,21.48242,0.014,NULL,59473579510,929274679,14519916,18.49),(116177,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116177,37.09,0.46,262,51030,70,NULL,NULL,'2MASX J14022028+2014225',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.46',0.26,NULL,NULL,NULL,NULL,NULL,1,210.5845,20.23969,0.041,NULL,59465120969,929142515,14517851,17.46),(116178,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116178,37.1,0.46,263,51031,70,NULL,NULL,'2MASX J14022031+2950536',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.13',0.2,NULL,NULL,NULL,NULL,NULL,1,210.584667,29.84817,0,NULL,60007217231,937612769,14650199,17.13),(116179,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116179,36.74,0.46,223,51032,70,NULL,NULL,'2MASX J14022087+0543436',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,210.587083,5.72886,0.031,NULL,58480425532,913756648,14277447,16.6),(116180,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116180,37.33,0.46,292,51033,70,NULL,NULL,'2MASX J14022187+2751026',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.591,27.85058,0,NULL,60011626599,937681665,14651276,17.7),(116181,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116181,38.64,0.46,534,51034,70,NULL,NULL,'SDSS J140222.21+545228.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.592583333,54.87458,0.009,NULL,57298933096,895295829,13988997,18.2),(116182,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116182,37.32,0.46,291,51035,70,NULL,NULL,'2MASX J14022234+2811316',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.14',0.19,NULL,NULL,NULL,NULL,NULL,1,210.59325,28.19211,0,NULL,60008170550,937627664,14650432,18.14),(116183,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116183,38.33,0.33,463,51036,70,NULL,NULL,'2MASX J14022284+1532045',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.5952083,15.53469,0,NULL,58382847903,912231998,14253624,17.7),(116184,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116184,36.98,0.46,248,51037,70,NULL,NULL,'SDSS J140223.79+043724.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000063,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.599167,4.62356,0.073,NULL,58480674007,913760531,14277508,17.7),(116185,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116185,35.11,0.46,105,51038,70,NULL,NULL,'SBS 1400+519',NULL,'2015arXiv151105856S',2015,1,0.57,'Two MAPS entries for the same object.','G',0.000163,NULL,'15.3g',0.49,'E',NULL,NULL,NULL,NULL,1,210.602167,51.68697,0.009,NULL,59217577763,925274652,14457416,15.3),(116186,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116186,35.05,0.49,102,51039,75,NULL,'IR','CGCG 074-054',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',0.000044,NULL,'15.1g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,210.608166667,10.40564,0.007,NULL,58510190484,914221726,14284714,15.1),(116187,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116187,38.77,0.46,568,51040,70,NULL,NULL,'SDSS J140226.19-013358.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,210.609167,-1.56633,0.133,NULL,43603012407,681297068,10645266,18.5),(116188,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116188,36.62,0.46,210,51041,70,NULL,NULL,'2MASX J14022700+2546096',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000107,NULL,'15.3g',0.58,NULL,NULL,NULL,NULL,NULL,1,210.61275,25.76925,0,NULL,60010902072,937670344,14651099,15.3),(116189,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116189,35.62,0.56,133,51042,70,NULL,NULL,'2MASX J14022715-2159415',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,210.613083,-21.99508,0.201,NULL,46520868262,726888566,11357633,16.05),(116190,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116190,35.98,0.46,157,51043,70,NULL,NULL,'2MASX J14023016+2922093',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00021,NULL,'15.14',0.29,'S0',NULL,NULL,NULL,NULL,1,210.625583,29.36933,0,NULL,60007838430,937622475,14650351,15.14),(116191,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116191,34.47,0.8,78.3,51044,75,NULL,'HMCL, I','UGC 08948',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000013,NULL,'15.37',0.6,'SBb','Group member of poor cluster',NULL,NULL,NULL,1,210.6372083,9.07972,0.009,NULL,58515379727,914302808,14285981,15.37),(116192,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116192,34.47,0.8,78.3,51044,75,NULL,'CF, r','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116193,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116193,34.47,0.8,78.3,51044,75,NULL,'W91CL, r','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116194,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116194,33.36,0.49,46.9,51044,NULL,NULL,NULL,'UGC 08948',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116195,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116195,33.4,0.2,47.9,51044,74.4,NULL,NULL,'UGC 08948',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116196,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116196,33.81,0.4,57.8,51044,NULL,NULL,'Malmquist cor.','UGC 08948',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116197,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116197,34.35,0.38,74.2,51044,75,NULL,'W91CL, r, raw','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116198,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116198,34.47,0.4,78.3,51044,75,NULL,'HMCL, I, raw','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116199,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116199,34.47,0.38,78.3,51044,75,NULL,'W91CL, r, inv','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116200,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116200,34.62,0.4,83.9,51044,75,NULL,'HMCL, I, inv','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116201,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116201,34.63,0.38,84.2,51044,75,NULL,'W91CL, r, cor','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116202,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116202,34.73,0.38,88.3,51044,75,NULL,'CF, r, raw','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116203,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116203,34.73,0.4,88.4,51044,75,NULL,'HMCL, I, cor','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116204,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116204,34.88,0.38,94.6,51044,75,NULL,'CF, r, inv','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116205,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116205,34.89,0.38,95.1,51044,75,NULL,'CF, r, cor','UGC 08948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116206,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116206,32.73,0.46,35.1,51045,NULL,NULL,'J','ESO 384- G 035',NULL,'2007A&A...465...71T',2007,1,1.5,'Star superposed.','G',0.000013,NULL,'13.55',1.2,'I?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.638125,-33.39942,0.241,NULL,47001861137,734404080,11475063,13.55),(116207,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116207,32.79,0.47,36.1,51045,NULL,NULL,'H','ESO 384- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116208,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116208,32.93,0.45,38.5,51045,NULL,NULL,'K','ESO 384- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116209,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116209,33.75,0.4,56.1,51045,NULL,NULL,'mean','ESO 384- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116210,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116210,37.64,0.23,337,51046,70,NULL,NULL,'2MASX J14023314+0538565',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.6382083,5.64903,0.061,NULL,58480637640,913759963,14277499,17),(116211,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116211,37.71,0.46,348,51047,70,NULL,NULL,'SDSS J140233.43+020440.5',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.00008,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,210.639333333,2.07792,0.061,NULL,58417342774,912770980,14262046,18.7),(116212,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116212,32.76,0.49,35.7,51048,75,NULL,'IR','IC 0970',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.00009,NULL,'14.2g',0.39,'S0/a','Pair member (points to parent)',NULL,NULL,NULL,1,210.6425417,14.55256,0,NULL,58369840483,912028757,14250449,14.2),(116213,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116213,34.84,0.49,92.8,51049,75,NULL,'IR','CGCG 074-056',NULL,'2011yCatp016004901K',2011,1,0.77,NULL,'G',0.000107,NULL,'16.6g',0.22,'S','Group member',NULL,NULL,NULL,1,210.647917,9.11922,0.009,NULL,58515378411,914302787,14285981,16.6),(116214,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116214,33.92,0.49,60.8,51050,75,NULL,'IR','NGC 5433',NULL,'2011yCatp016004901K',2011,1,1.6,'HOLM 574B is a star.','G',0.000017,NULL,'14.10',0.4,'Sdm:           HII','Possible field galaxy',NULL,NULL,NULL,1,210.650333333,32.51044,0,NULL,60033269949,938019842,14656560,14.1),(116215,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116215,36.37,0.46,188,51051,70,NULL,NULL,'2MASX J14023664+2832074',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.99',0.25,NULL,NULL,NULL,NULL,NULL,1,210.652583,28.53547,0,NULL,60006388295,937599817,14649997,16.99),(116216,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116216,36.63,0.76,212,51052,70,NULL,NULL,'2MASX J14023758-0435589',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.72',0.23,NULL,NULL,NULL,NULL,NULL,1,210.656833,-4.59981,0.069,NULL,43729243586,683269431,10676084,16.72),(116217,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116217,37.53,0.46,321,51053,70,NULL,NULL,'2MASX J14023738+0342465',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','16.77',0.24,NULL,NULL,NULL,NULL,NULL,1,210.6582083,3.70881,0.021,NULL,58408727505,912636367,14259943,16.77),(116218,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116218,34.86,0.49,93.9,51054,75,NULL,'IR','UGC 08953',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.68',0.2,'S?',NULL,NULL,NULL,NULL,1,210.659708333,18.52311,0.052,NULL,58326886891,911357607,14239962,15.68),(116219,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116219,35.14,0.4,107,51054,NULL,NULL,'mean','UGC 08953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116220,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116220,35.22,0.2,111,51054,74.4,NULL,NULL,'UGC 08953',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116221,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116221,35.36,0.47,118,51054,NULL,NULL,'H','UGC 08953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116222,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116222,37.92,0.46,384,51055,70,NULL,NULL,'2MASX J14023829+5759006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,210.659583,57.9835,0,NULL,57308704531,895448508,13991382,18.3),(116223,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116223,37.19,0.46,274,51056,70,NULL,NULL,'2MASX J14023928+5049524',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.6637083,50.83119,0.01,NULL,59250669249,925791707,14465495,17.1),(116224,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116224,37.05,0.33,258,51057,70,NULL,NULL,'2MASX J14023980+5509026',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000187,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.665917,55.15086,0.005,NULL,57301817802,895340903,13989701,16.2),(116225,'GRB','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116225,43.06,NULL,4090,51058,72,NULL,'Pseudo-Redshift D, zD = 9.4','GRB 090429B',NULL,'2011ApJ...736....7C',2011,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,210.667125,32.17053,0,NULL,60033194217,938018659,14656541,NULL),(116226,'FP','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,'R',116226,38.16,0.46,429,51059,70,NULL,NULL,'SDSS J140242.14+162349.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.675583,16.39719,0,NULL,58375060870,912110326,14251723,17.9),(116227,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116227,34.42,0.8,76.7,51060,75,NULL,'HMCL, I','UGC 08950',NULL,'1997ApJS..109..333W',1997,1,1.48,NULL,'G',0.00002,NULL,'16.5g',0.14,'Scd','Group member',NULL,NULL,NULL,1,210.675875,9.16414,0.009,NULL,58507816742,914184636,14284134,16.5),(116228,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116228,34.43,0.8,76.7,51060,75,NULL,'W91CL, r','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116229,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116229,33.74,NULL,55.9,51060,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08950',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116230,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:33','1',NULL,NULL,116230,33.76,NULL,56.4,51060,NULL,NULL,'Dipole + Quadrupole','UGC 08950',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116231,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116231,33.77,NULL,56.6,51060,NULL,NULL,'Dipole','UGC 08950',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116232,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116232,33.8,NULL,57.6,51060,NULL,NULL,NULL,'UGC 08950',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116233,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116233,34.18,0.38,68.6,51060,75,NULL,'W91CL, r, inv','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116234,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116234,34.2,0.6,69.3,51060,NULL,NULL,NULL,'UGC 08950',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116235,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116235,34.24,0.38,70.4,51060,75,NULL,'W91CL, r, raw','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116236,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116236,34.24,0.2,70.5,51060,74.4,NULL,NULL,'UGC 08950',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116237,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116237,34.27,0.4,71.3,51060,75,NULL,'HMCL, I, inv','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116238,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116238,34.27,0.4,71.3,51060,75,NULL,'HMCL, I, raw','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116239,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116239,34.54,0.51,80.9,51060,NULL,NULL,'Malmquist cor.','UGC 08950',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116240,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116240,34.54,0.38,80.9,51060,75,NULL,'W91CL, r, cor','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116241,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116241,34.59,0.4,82.7,51060,75,NULL,'HMCL, I, cor','UGC 08950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116242,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116242,37.72,0.46,350,51061,70,NULL,NULL,'2MASX J14024224+3210505',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.55',0.14,NULL,NULL,NULL,NULL,NULL,1,210.675875,32.18064,0,NULL,60033194141,938018658,14656541,18.55),(116243,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116243,37.64,0.23,337,51062,70,NULL,NULL,'2MASX J14024379+0544055',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000195,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,210.682583,5.73492,0.027,NULL,58480446736,913756980,14277452,16.1),(116244,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116244,33.26,0.25,44.9,51063,74.4,NULL,NULL,'ABELL S0753:[WFC91] 045',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000107,NULL,'16.6b',NULL,'S0',NULL,NULL,NULL,NULL,1,210.686125,-34.96258,0.241,NULL,46882773380,732543334,11445989,16.6),(116245,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116245,37.05,0.33,258,51064,70,NULL,NULL,'2MASX J14024473+5513335',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.686583,55.22589,0.005,NULL,57302044647,895344447,13989756,17.7),(116246,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116246,37.58,0.46,328,51065,70,NULL,NULL,'2MASX J14024628+2337332',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.692875,23.626,0.048,NULL,59472487539,929257617,14519650,17.6),(116247,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116247,37.89,0.46,378,51066,70,NULL,NULL,'2MASX J14024638+1111443',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.91',0.17,NULL,NULL,NULL,NULL,NULL,1,210.693167,11.1955,0,NULL,58507366768,914177605,14284025,17.91),(116248,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116248,37.37,0.46,298,51067,70,NULL,NULL,'2MASX J14024647+0510575',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000106,NULL,'16.2g',0.37,'AGN',NULL,NULL,NULL,NULL,1,210.693833333,5.18253,0.039,NULL,58480982613,913765353,14277583,16.2),(116249,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116249,36.98,0.46,249,51068,70,NULL,NULL,'2MASX J14024673+4435374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.694917,44.59369,0,NULL,59233807950,925528249,14461378,17.4),(116250,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116250,35.81,0.59,145,51069,70,NULL,NULL,'LCRS B140006.5-112637',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.0001,NULL,'16.1b',0.3,NULL,NULL,NULL,NULL,NULL,1,210.6962917,-11.68389,0.129,NULL,43746696166,683542127,10680345,16.1),(116251,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116251,36.62,0.33,211,51070,70,NULL,NULL,'SDSS J140248.05+154743.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.0g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.70025,15.79542,0,NULL,58374430674,912100479,14251569,16),(116252,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116252,37.71,0.33,348,51071,70,NULL,NULL,'2MASX J14024809+5952455',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,210.7004583,59.87928,0.021,NULL,57276953961,894952405,13983631,16.5),(116253,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116253,37.27,0.46,285,51072,70,NULL,NULL,'2MASX J14024822+4607214',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000205,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,210.700875,46.12267,0,NULL,59235582061,925555969,14461812,16.4),(116254,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116254,38.4,0.46,478,51073,70,NULL,NULL,'2MASX J14024840+2758175',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.71',0.14,NULL,NULL,NULL,NULL,NULL,1,210.701583,27.97158,0,NULL,60011617315,937681520,14651273,18.71),(116255,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116255,34.48,0.25,78.7,51074,74.4,NULL,NULL,'NGC 5423',NULL,'2013AJ....146...86T',2013,1,1.31,NULL,'G',0.000073,NULL,'13.7g',0.89,'S0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.702583,9.34139,0,NULL,58507912179,914186127,14284158,13.7),(116256,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116256,34.96,0.27,98.3,51074,70,NULL,NULL,'NGC 5423',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116257,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116257,34.44,0.45,77.1,51074,NULL,NULL,'K','NGC 5423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116258,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116258,34.72,0.4,87.9,51074,NULL,NULL,'mean','NGC 5423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116259,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116259,34.84,0.56,93.1,51075,70,NULL,NULL,'2MASX J14024898-4138174',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,210.7042083,-41.63817,0.225,NULL,46912080143,733001252,11453144,13.9),(116260,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116260,37.22,0.46,278,51076,70,NULL,NULL,'2MASX J14024936+2440235',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.705833,24.67322,0,NULL,59996416750,937444011,14647562,16.9),(116261,'Ring Diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116261,30.7,0.98,14,51077,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5448',NULL,'1981ApJS...45..541P',1981,1,1.49,NULL,'G',0.000033,NULL,'13.0g',1.02,'(R)SAB(r)a     AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.7084583,49.17269,0.041,NULL,59243046770,925672605,14463634,13),(116262,'Ring Diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116262,31,0.76,16,51077,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5448',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116263,'Sosies','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116263,32.71,0.18,34.8,51077,NULL,NULL,NULL,'NGC 5448',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116264,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116264,32.57,0.8,32.6,51077,75,NULL,'B','NGC 5448',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116265,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116265,32.57,0.2,32.7,51077,74.4,NULL,NULL,'NGC 5448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116266,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116266,32.58,0.43,32.8,51077,75,NULL,'3.6 micron, color corrected','NGC 5448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116267,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116267,32.68,0.43,34.4,51077,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116268,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116268,32.71,0.4,34.8,51077,NULL,NULL,'mean','NGC 5448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116269,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116269,32.92,0.45,38.3,51077,NULL,NULL,'K','NGC 5448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116270,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116270,32.93,0.47,38.5,51077,NULL,NULL,'H','NGC 5448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116271,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116271,32.94,0.46,38.8,51077,NULL,NULL,'J','NGC 5448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116272,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116272,36.56,0.69,205,51078,70,NULL,NULL,'2MASX J14025013-1027263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.709,-10.45736,0.081,NULL,43750089641,683595150,10681174,16.8),(116273,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116273,36.37,0.46,188,51079,70,NULL,NULL,'2MASX J14025018+2157352',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.26',0.15,NULL,NULL,NULL,NULL,NULL,1,210.7092083,21.95992,0.028,NULL,59473467345,929272927,14519889,18.26),(116274,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116274,36.66,0.46,215,51080,70,NULL,NULL,'2MASXi J1402503+571239',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.7097917,57.21092,0.013,NULL,57310837960,895481843,13991903,17.6),(116275,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116275,37.9,0.46,379,51081,70,NULL,NULL,'SDSS J140250.88+102447.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.7120417,10.41319,0.007,NULL,58510304784,914223512,14284742,18.4),(116276,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116276,34.43,0.8,76.9,51082,75,NULL,'HMCL, I','UGC 08951',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00002,NULL,'16.24',0.2,'Scd:','Group member',NULL,NULL,NULL,1,210.712125,8.77981,0.018,NULL,58515623610,914306618,14286040,16.24),(116277,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116277,34.43,0.8,76.9,51082,75,NULL,'W91CL, r','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116278,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116278,34.52,0.53,80.1,51082,NULL,NULL,NULL,'UGC 08951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116279,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116279,34.56,0.2,81.7,51082,74.4,NULL,NULL,'UGC 08951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116280,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116280,34.72,0.48,88,51082,NULL,NULL,'Malmquist cor.','UGC 08951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116281,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116281,34.82,0.4,92.2,51082,75,NULL,'HMCL, I, raw','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116282,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116282,34.92,0.4,96.3,51082,75,NULL,'HMCL, I, inv','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116283,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116283,34.94,0.38,97.4,51082,75,NULL,'W91CL, r, raw','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116284,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116284,34.98,0.4,98.9,51082,75,NULL,'HMCL, I, cor','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116285,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116285,34.99,0.38,99.6,51082,75,NULL,'W91CL, r, inv','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116286,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116286,35.04,0.38,102,51082,75,NULL,'W91CL, r, cor','UGC 08951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116287,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116287,36.46,0.46,196,51083,70,NULL,NULL,'2MASX J14025091+3840496',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,210.712125,38.68036,0,NULL,59141455854,924085247,14438831,16.2),(116288,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116288,37.64,0.23,337,51084,70,NULL,NULL,'2MASX J14025129+0542045',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,210.71375,5.70144,0.027,NULL,58480435356,913756802,14277450,18.18),(116289,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116289,36.23,0.46,177,51085,70,NULL,NULL,'2MASX J14025185+2956431',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.66',0.29,NULL,NULL,NULL,NULL,NULL,1,210.715917,29.94528,0,NULL,60007371508,937615179,14650237,16.66),(116290,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116290,37.02,0.33,254,51086,70,NULL,NULL,'2MASX J14025250+1649599',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.76',0.33,NULL,NULL,NULL,NULL,NULL,1,210.7187917,16.83347,0,NULL,58375691948,912120186,14251877,16.76),(116291,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116291,38.11,0.46,420,51087,70,NULL,NULL,'SDSS J140252.56+132444.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,210.7190417,13.41236,0,NULL,58360120735,911876886,14248076,18.7),(116292,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116292,38.09,0.46,415,51088,70,NULL,NULL,'SDSS J140253.04+531436.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000203,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.7210417,53.24356,0,NULL,59216230872,925253607,14457087,17.9),(116293,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116293,36.65,0.46,214,51089,70,NULL,NULL,'2MASX J14025316+4951175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.721667,49.85467,0.049,NULL,59254192857,925846763,14466355,17.5),(116294,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116294,37.56,0.33,326,51090,70,NULL,NULL,'2MASX J14025438+1552599',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,210.726667,15.88325,0,NULL,58374426564,912100415,14251568,18.3),(116295,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116295,33.17,0.23,43.1,51091,74.4,NULL,NULL,'ABELL S0753:[WFC91] 047',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000047,NULL,'15.05',NULL,'S0',NULL,NULL,NULL,NULL,1,210.7317083,-34.25564,0.241,NULL,46882158679,732533729,11445839,15.05),(116296,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116296,34.44,0.4,77.4,51092,75,NULL,'Edat, raw','NGC 5424',NULL,'1997ApJS..109..333W',1997,1,1.6,'Often incorrectly called \\\"NGC 5724\\\" in the literature.','G',0.00005,NULL,'14.00',1.3,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.732083,9.42067,0,NULL,58507908505,914186070,14284157,14),(116297,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116297,34.78,0.4,90.3,51092,75,NULL,'Edat, cor','NGC 5424',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116298,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116298,34.33,0.25,73.5,51092,74.4,NULL,NULL,'NGC 5424',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116299,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116299,34.74,0.45,88.7,51092,NULL,NULL,'K','NGC 5424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116300,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116300,34.78,0.4,90.5,51092,NULL,NULL,'mean','NGC 5424',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116301,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116301,38.04,0.19,406,51093,70,NULL,NULL,'SDSS J140259.13+153702.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.746417,15.61733,0,NULL,58374446238,912100722,14251573,18.2),(116302,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116302,37.23,0.33,279,51094,70,NULL,NULL,'2MASX J14025924+2859325',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.37',0.17,'E',NULL,NULL,NULL,NULL,1,210.746958333,28.99233,0,NULL,60006964861,937608825,14650137,18.37),(116303,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116303,36.89,0.55,239,51095,70,NULL,NULL,'2MASX J14025990-4625480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.749666667,-46.43006,0.393,NULL,46797474391,731210537,11425164,17),(116304,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116304,38.18,0.46,432,51096,70,NULL,NULL,'2MASX J14030033+1535549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.7514583,15.59864,0,NULL,58374446978,912100734,14251573,17.3),(116305,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1998D',NULL,116305,31.3,0.17,18.2,51097,70.8,NULL,NULL,'NGC 5440',NULL,'2008MNRAS.389.1577T',2008,1,2.64,NULL,'G',0.00002,NULL,'13.0g',0.87,'Sa','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.754333333,34.75786,0,NULL,59149746093,924214782,14440855,13),(116306,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1998D',NULL,116306,33.67,0.31,53.6,51097,72,NULL,NULL,'NGC 5440',0.0123,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116307,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1998D',NULL,116307,33.79,0.08,57.3,51097,74.4,NULL,NULL,'NGC 5440',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116308,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1998D',NULL,116308,34.09,0.63,64.2,51097,65,NULL,'MLCS2k2','NGC 5440',0.0123,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116309,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116309,33.74,0.4,56,51097,NULL,NULL,'mean','NGC 5440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116310,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116310,33.79,0.08,57.3,51097,74.4,NULL,NULL,'NGC 5440',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116311,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116311,34.01,0.47,63.4,51097,NULL,NULL,'H','NGC 5440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116312,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116312,34.02,0.46,63.8,51097,NULL,NULL,'J','NGC 5440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116313,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116313,34.04,0.45,64.4,51097,NULL,NULL,'K','NGC 5440',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116314,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116314,34.67,0.4,85.9,51097,75,NULL,'HOSTS SN 1998D','NGC 5440',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116315,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116315,36.6,0.46,209,51098,70,NULL,NULL,'2MASX J14030113+1905483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.17,NULL,NULL,NULL,NULL,NULL,1,210.75475,19.09686,0.037,NULL,58326445151,911350705,14239854,18.4),(116316,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116316,37.71,0.33,348,51099,70,NULL,NULL,'2MASX J14030181+5947013',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.757875,59.78381,0.021,NULL,57276928097,894952001,13983625,17.8),(116317,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116317,36.82,0.46,232,51100,70,NULL,NULL,'2MASX J14030190+2648342',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000191,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,210.757917,26.80964,0,NULL,60012023032,937687859,14651372,16.2),(116318,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116318,37.11,0.46,264,51101,70,NULL,NULL,'2MASX J14030201+2820402',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,210.758417,28.34444,0,NULL,60006339475,937599054,14649985,16),(116319,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116319,36.67,0.46,216,51102,70,NULL,NULL,'2MASX J14030242-0020082',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000103,NULL,'16.1g',0.34,'S0',NULL,NULL,NULL,NULL,1,210.760125,-0.33556,0.145,NULL,43601918439,681279975,10644999,16.1),(116320,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116320,38.14,0.46,425,51103,70,NULL,NULL,'2MASXi J1403035-004947',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,210.76475,-0.82983,0.141,NULL,43602770746,681293292,10645207,18),(116321,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116321,33.88,0.47,59.6,51104,NULL,NULL,'H','UGC 08961',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.87',0.3,'S?',NULL,NULL,NULL,NULL,1,210.76725,28.03342,0,NULL,60008197990,937628093,14650438,14.87),(116322,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116322,33.92,0.45,60.8,51104,NULL,NULL,'K','UGC 08961',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116323,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116323,33.94,0.46,61.5,51104,NULL,NULL,'J','UGC 08961',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116324,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116324,34.13,0.4,67,51104,NULL,NULL,'mean','UGC 08961',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116325,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116325,34.27,0.49,71.3,51104,75,NULL,'IR','UGC 08961',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116326,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116326,34.35,0.2,74.1,51104,74.4,NULL,NULL,'UGC 08961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116327,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116327,34.36,0.46,74.4,51105,70,NULL,NULL,'CGCG 074-064',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000097,NULL,'15.1',0.6,NULL,'Group member',NULL,NULL,NULL,1,210.768583,8.9475,0.009,NULL,58515374919,914302733,14285980,15.1),(116328,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116328,37.02,0.33,254,51106,70,NULL,NULL,'2MASX J14030448+1653059',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.21',0.19,NULL,NULL,NULL,NULL,NULL,1,210.76875,16.88489,0,NULL,58375760338,912121255,14251894,18.21),(116329,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116329,36.64,0.46,212,51107,70,NULL,NULL,'2MASX J14030448+2446252',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000113,NULL,'15.3g',0.51,NULL,NULL,NULL,NULL,NULL,1,210.768833,24.77364,0,NULL,59996425007,937444140,14647564,15.3),(116330,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116330,38.25,0.46,446,51108,70,NULL,NULL,'2MASX J14030455+6536206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.7689583,65.60569,0.049,NULL,57945383176,905396612,14146822,18.3),(116331,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116331,37.64,0.23,337,51109,70,NULL,NULL,'SDSS J140305.44+054718.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.7727083,5.78853,0.027,NULL,58480434180,913756784,14277449,17.7),(116332,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116332,37.3,0.46,289,51110,70,NULL,NULL,'2MASX J14030685+2248473',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,210.778667,22.81322,0,NULL,59474404973,929287577,14520118,18.5),(116333,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116333,38.24,0.46,444,51111,70,NULL,NULL,'2MASX J14030692+3857035',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.7787917,38.95108,0,NULL,59141484677,924085698,14438839,17.3),(116334,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116334,34.18,0.5,68.4,51112,70,NULL,NULL,'2MASX J14030755-0442102',NULL,'2014MNRAS.445.2677S',2014,1,0.91,NULL,'G',0.000093,NULL,'15.07',0.46,NULL,NULL,NULL,NULL,NULL,1,210.781291667,-4.70286,0.069,NULL,43729208827,683268887,10676076,15.07),(116335,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116335,34.37,0.23,74.8,51113,74.4,NULL,NULL,'ABELL S0753:[WFC91] 049',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'14.57',0.9,'S0',NULL,NULL,NULL,NULL,1,210.782917,-34.03286,0.233,NULL,47002944717,734421011,11475328,14.57),(116336,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116336,34.87,0.47,94,51113,70,NULL,NULL,'ABELL S0753:[WFC91] 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116337,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116337,34.13,0.23,67,51114,74.4,NULL,NULL,'ABELL S0753:[WFC91] 051',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000043,NULL,'14.67',NULL,'E',NULL,NULL,NULL,NULL,1,210.783667,-34.09864,0.241,NULL,46882104915,732532889,11445826,14.67),(116338,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116338,36.34,0.33,185,51115,70,NULL,NULL,'2MASX J14030823+3517020',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.78425,35.28389,0,NULL,59150074398,924219912,14440936,16.4),(116339,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116339,37.47,0.46,312,51116,70,NULL,NULL,'2MASX J14030859+5343394',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.785916667,53.72758,0,NULL,59215257066,925238391,14456849,17.7),(116340,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116340,37.72,0.33,349,51117,70,NULL,NULL,'2MASX J14030912+0606264',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,210.787917,6.10739,0.052,NULL,58512171298,914252676,14285198,17.1),(116341,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116341,37.38,0.46,300,51118,70,NULL,NULL,'2MASX J14030966+3309180',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.27',0.15,NULL,NULL,NULL,NULL,NULL,1,210.7902917,33.15494,0,NULL,60033804193,938028190,14656690,18.27),(116342,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116342,36.42,0.46,192,51119,70,NULL,NULL,'2MASX J14030976+1811033',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.17,NULL,NULL,NULL,NULL,NULL,1,210.790833,18.18419,0.04,NULL,58373046376,912078849,14251232,18.41),(116343,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116343,36.8,0.46,230,51120,70,NULL,NULL,'2MASX J14030979+5856123',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,210.790917,58.93672,0,NULL,57271307828,894864184,13982252,16.9),(116344,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116344,35.75,0.46,141,51121,70,NULL,NULL,'SDSS J140309.90+121504.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.1g',0.33,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.7912917,12.25117,0.021,NULL,58359656989,911869640,14247963,16.1),(116345,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116345,37.54,0.46,322,51122,70,NULL,NULL,'2MASX J14031049+1214188',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.7937083,12.23858,0.021,NULL,58359651334,911869552,14247961,17.6),(116346,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116346,37.17,0.46,272,51123,70,NULL,NULL,'2MASX J14031052+1545188',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.70',0.13,NULL,NULL,NULL,NULL,NULL,1,210.7937917,15.75514,0,NULL,58374477396,912101209,14251581,18.7),(116347,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116347,28.4,NULL,4.79,51124,NULL,NULL,'M supergiants','MESSIER 101',NULL,'1986AJ.....91..808H',1986,1,28.8,'M102 may be a duplicate obs. of M101; see Sawyer, JRASC 41, Nos 7&8, 1947.','G',0.000007,NULL,'8.31',26.9,'SAB(rs)cd      HII','Isolated galaxy',NULL,NULL,NULL,1,210.80225,54.34894,0,NULL,57282582663,895040354,13985005,8.31),(116348,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116348,28.9,NULL,6.03,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1980A&A....83..354C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116349,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116349,29.2,NULL,6.92,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1983AJ.....88.1569S',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116350,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116350,29.3,NULL,7.24,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1980ApJ...241..598H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116351,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116351,28.46,0.12,4.92,51124,73,NULL,'Cepheids periods Gaussian, Data 1','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116352,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116352,28.66,0.09,5.4,51124,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 1','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116353,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116353,28.73,0.03,5.57,51124,73,NULL,'Cepheids periods Gaussian, Data 2','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116354,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116354,28.79,0.06,5.73,51124,73,NULL,'Mean of Cepheids magnitudes and periods Gaussian, Data 2','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116355,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116355,28.85,0.09,5.89,51124,73,NULL,'Cepheids magnitudes Gaussian, Data 2','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116356,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116356,28.87,0.06,5.94,51124,73,NULL,'Cepheids magnitudes Gaussian, Data 1','MESSIER 101',NULL,'2009RoAJ...19...35A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116357,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116357,28.89,0.17,6,51124,NULL,18.45,'LMC ZP','MESSIER 101',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116358,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116358,28.96,0.11,6.19,51124,NULL,NULL,'VI(W), Z, 619','MESSIER 101',NULL,'2013ApJ...777...79M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116359,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116359,29.04,0.08,6.43,51124,NULL,NULL,'8, H','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116360,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116360,29.04,0.08,6.43,51124,NULL,NULL,'8, H','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116361,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116361,29.04,0.05,6.43,51124,NULL,18.41,'235, VI','MESSIER 101',NULL,'2011ApJ...733..124S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116362,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116362,29.05,0.14,6.46,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1998ApJ...508..491S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116363,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116363,29.06,0.11,6.49,51124,NULL,NULL,'29, VI +Z','MESSIER 101',NULL,'2001ApJ...553..562N',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116364,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116364,29.13,0.11,6.7,51124,NULL,NULL,'25, VI, +Z, KEY PROJECT','MESSIER 101',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116365,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116365,29.13,0.11,6.7,51124,NULL,NULL,'25, VI, KEY PROJECT','MESSIER 101',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116366,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116366,29.14,0.09,6.73,51124,NULL,NULL,'LMC VIHJK','MESSIER 101',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116367,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116367,29.16,0.09,6.79,51124,NULL,NULL,'29, VI','MESSIER 101',NULL,'2001ApJ...553..562N',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116368,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116368,29.18,0.08,6.85,51124,NULL,18.54,'LMC ZP','MESSIER 101',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116369,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116369,29.2,0.08,6.91,51124,NULL,NULL,'LMC W01','MESSIER 101',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116370,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116370,29.2,0.07,6.92,51124,NULL,NULL,'50, VI, inner field','MESSIER 101',NULL,'1998ApJ...498..181K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116371,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116371,29.21,0.17,6.95,51124,NULL,NULL,'61, VI','MESSIER 101',NULL,'1998ApJ...508..491S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116372,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116372,29.21,0.09,6.95,51124,NULL,NULL,'30, VI, inner field, log P > 1.2 days','MESSIER 101',NULL,'1998ApJ...498..181K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116373,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116373,29.21,0.06,6.95,51124,74.4,NULL,NULL,'MESSIER 101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116374,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116374,29.23,0.07,7.01,51124,NULL,NULL,'MW HIPP','MESSIER 101',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116375,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116375,29.24,0.08,7.05,51124,NULL,NULL,'LMC VIHJK','MESSIER 101',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116376,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116376,29.26,0.15,7.11,51124,NULL,NULL,'MW P02','MESSIER 101',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116377,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116377,29.27,NULL,7.14,51124,NULL,18.47,'2, R, Photographic','MESSIER 101',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116378,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116378,29.29,0.2,7.21,51124,NULL,18.45,'LMC ZP','MESSIER 101',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116379,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116379,29.3,0.07,7.24,51124,NULL,NULL,'MW GFG','MESSIER 101',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116380,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116380,29.3,NULL,7.24,51124,NULL,NULL,'2, R, for LMC m-M = 18.50','MESSIER 101',NULL,'1986ApJ...301L..45C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116381,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116381,29.3,0.07,7.24,51124,NULL,NULL,'102, VI','MESSIER 101',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116382,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116382,29.34,0.1,7.38,51124,NULL,NULL,'HST KP Calibrated','MESSIER 101',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116383,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116383,29.34,0.08,7.38,51124,NULL,NULL,'24, VI, outer field, log P > 1.2 days','MESSIER 101',NULL,'1998ApJ...498..181K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116384,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116384,29.34,0.1,7.38,51124,NULL,NULL,'61, VI','MESSIER 101',NULL,'1996ApJ...463...26K',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116385,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116385,29.37,0.01,7.48,51124,NULL,NULL,'8, I','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116386,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116386,29.37,0.1,7.48,51124,NULL,NULL,'8, I','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116387,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116387,29.39,0.18,7.5,51124,NULL,NULL,'29, VIB','MESSIER 101',NULL,'1994AAS...185.2406K',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116388,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116388,29.38,NULL,7.52,51124,NULL,NULL,'2, R','MESSIER 101',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116389,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116389,29.39,0.07,7.55,51124,NULL,NULL,'29, VI, outer field','MESSIER 101',NULL,'1998ApJ...498..181K',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116390,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116390,29.45,0.08,7.76,51124,NULL,NULL,'8, H','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116391,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116391,29.45,0.08,7.76,51124,NULL,NULL,'8, H','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116392,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116392,29.58,0.09,8.24,51124,NULL,NULL,'8, I','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116393,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116393,29.58,0.09,8.24,51124,NULL,NULL,'8, I','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116394,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116394,29.59,NULL,8.28,51124,NULL,NULL,'31, VI','MESSIER 101',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116395,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116395,29.6,0.04,8.32,51124,NULL,NULL,'BVRI+','MESSIER 101',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116396,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116396,29.61,0.04,8.36,51124,NULL,NULL,'BVRI','MESSIER 101',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116397,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116397,29.71,0.18,8.75,51124,NULL,NULL,'8, V','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116398,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116398,29.71,0.18,8.75,51124,NULL,NULL,'8, V','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116399,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116399,29.77,0.09,8.99,51124,NULL,NULL,'8, V','MESSIER 101',NULL,'2001ApJ...549..721M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116400,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116400,29.77,0.09,8.99,51124,NULL,NULL,'8, V','MESSIER 101',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116401,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116401,30.13,NULL,10.6,51124,NULL,18.48,'R(V) = 1.1450, Z fixed at gamma = -0.23 mag/dex','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116402,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116402,30.14,NULL,10.7,51124,NULL,18.48,'R(V) = 1.2899, Z fixed at gamma = -0.23 mag/dex','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116403,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116403,30.14,0.01,10.7,51124,NULL,18.48,'R(V) = 1.1450, Z any','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116404,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116404,30.14,NULL,10.7,51124,NULL,18.48,'R(V) = 1.4695, Z fixed at gamma = -0.23 mag/dex','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116405,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116405,30.15,0.01,10.7,51124,NULL,18.48,'R(V) = 1.2899, Z any','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116406,'Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116406,30.15,0.01,10.7,51124,NULL,18.48,'R(V) = 1.4695, Z any','MESSIER 101',NULL,'2015MNRAS.449.1171N',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116407,'M Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116407,28.6,0.2,5.25,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1983ApJ...264..458H',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116408,'PNLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116408,29.36,0.15,7.45,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1997ApJ...479..231F',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116409,'PNLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116409,29.42,0.13,7.66,51124,NULL,NULL,'HST KP Calibrated','MESSIER 101',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116410,'PNLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116410,29.42,0.15,7.7,51124,NULL,NULL,'27','MESSIER 101',NULL,'1996ApJ...461L..25F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116411,'RSV Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116411,29.35,0.24,7.4,51124,NULL,NULL,'19 RSGV','MESSIER 101',NULL,'2006AAS...208.1303J',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116412,'RSV Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116412,29.4,0.16,7.59,51124,NULL,NULL,'42, I,RSGV','MESSIER 101',NULL,'2000MNRAS.313..868J',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116413,'RSV Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116413,29.4,0.16,7.59,51124,NULL,NULL,'RSV','MESSIER 101',NULL,'1998PhDT.........5J',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116414,'S Doradus Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116414,28.6,NULL,5.25,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1989A&A...217...87W',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116415,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116415,28.86,0.12,5.92,51124,72,NULL,'H, Mandel et al. (2009)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116416,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116416,28.87,0.17,5.94,51124,72,NULL,'J, Mandel et al. (2009)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116417,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116417,28.91,0.33,6.05,51124,72,NULL,'J, Wood-Vasey et al. (2008)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116418,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116418,28.93,0.2,6.11,51124,72,NULL,'Ks, Mandel et al. (2009)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116419,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116419,28.93,0.16,6.11,51124,72,NULL,'H, Wood-Vasey et al. (2008)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116420,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116420,28.94,0.18,6.14,51124,72,NULL,'J, Folatelli et al. (2010) [2]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116421,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116421,28.94,0.13,6.14,51124,72,NULL,'J, Burns et al. (2011)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116422,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116422,28.98,0.27,6.25,51124,72,NULL,'Ks, Folatelli et al. (2010) [1]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116423,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116423,28.99,0.19,6.28,51124,72,NULL,'H, Krisciunas et al. (2004)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116424,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116424,29,0.26,6.31,51124,72,NULL,'Ks, Wood-Vasey et al. (2008)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116425,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116425,29.01,0.11,6.34,51124,72,NULL,'H, Burns et al. (2011)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116426,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116426,29.01,NULL,6.34,51124,72,NULL,'MEAN OF 19','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116427,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116427,29.04,0.18,6.43,51124,72,NULL,'J, Folatelli et al. (2010) [1]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116428,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116428,29.05,0.08,6.46,51124,73,NULL,'SALT2, all data','MESSIER 101',NULL,'2012A&A...546A..12V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116429,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116429,29.06,0.13,6.49,51124,72,NULL,'Ks, Krisciunas et al. (2004)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116430,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116430,29.08,0.14,6.55,51124,72,NULL,'J, Krisciunas et al. (2004)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116431,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116431,29.08,0.19,6.55,51124,72,NULL,'H, Folatelli et al. (2010) [1]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116432,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116432,29.08,0.15,6.55,51124,72,NULL,'J, Kattner et al. (2012)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116433,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116433,29.1,0.08,6.61,51124,73,NULL,'SALT2, -7 to +40 days','MESSIER 101',NULL,'2012A&A...546A..12V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116434,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116434,29.11,NULL,6.64,51124,NULL,NULL,'B','MESSIER 101',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116435,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116435,29.11,0.27,6.64,51124,72,NULL,'Ks, Folatelli et al. (2010) [2]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116436,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116436,29.13,0.01,6.69,51124,70,NULL,'SiFTO+SALT2, SN PTF11kly, SN 2011fe','MESSIER 101',0.000804,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116437,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116437,29.17,0.19,6.82,51124,72,NULL,'H, Folatelli et al. (2010) [2]','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116438,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116438,29.17,0.15,6.82,51124,72,NULL,'H, Kattner et al. (2012)','MESSIER 101',NULL,'2012ApJ...754...19M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116439,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116439,29.23,0.07,7.01,51124,73,NULL,'MLCS2k2, -7 to +40 days','MESSIER 101',NULL,'2012A&A...546A..12V',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116440,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116440,29.3,NULL,7.24,51124,NULL,NULL,'Rc','MESSIER 101',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116441,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116441,29.33,NULL,7.35,51124,NULL,NULL,'Ic','MESSIER 101',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116442,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2011fe',NULL,116442,29.38,NULL,7.52,51124,NULL,NULL,'V','MESSIER 101',NULL,'2013NewA...20...30M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116443,'SNII radio','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1970G',NULL,116443,29.35,0.38,7.4,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116444,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116444,29.05,0.06,6.46,51124,NULL,NULL,'I','MESSIER 101',NULL,'2011ApJ...733..124S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116445,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116445,29.12,0.14,6.68,51124,NULL,NULL,'Field 1','MESSIER 101',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116446,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116446,29.17,0.13,6.81,51124,NULL,NULL,'Field 2','MESSIER 101',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116447,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116447,29.19,0.14,6.89,51124,NULL,NULL,'Field 3','MESSIER 101',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116448,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116448,29.21,0.06,6.95,51124,74.4,NULL,NULL,'MESSIER 101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116449,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116449,29.3,0.01,7.24,51124,NULL,NULL,'I, 0.12 mag systematic error','MESSIER 101',NULL,'2012ApJ...760L..14L',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116450,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116450,29.3,0.01,7.24,51124,NULL,NULL,'HOST SN 2011fe','MESSIER 101',NULL,'2013AAS...22143202J',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116451,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116451,29.34,0.09,7.38,51124,NULL,NULL,'I','MESSIER 101',NULL,'2007ApJ...661..815R',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116452,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116452,29.39,0.05,7.55,51124,NULL,NULL,'I','MESSIER 101',NULL,'2011arXiv1112.0439T',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116453,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116453,29.42,0.11,7.66,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116454,'Type II Cepheids','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116454,29.03,0.32,6.4,51124,NULL,18.45,'LMC ZP','MESSIER 101',NULL,'2009AcA....59..403M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116455,'Statistical','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116455,29.35,0.01,7.42,51124,NULL,NULL,'21 estimates','MESSIER 101',NULL,'2014arXiv1410.7843C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116456,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116456,28.18,0.28,4.33,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1982ApJ...255L..29L',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116457,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116457,28.8,NULL,5.75,51124,NULL,NULL,'Photographic','MESSIER 101',NULL,'1980A&A....83..354C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116458,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116458,29.19,0.14,6.9,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116459,'SNII optical','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1970G',NULL,116459,29.06,0.83,6.5,51124,NULL,NULL,'EPM, first use of','MESSIER 101',NULL,'1974ApJ...193...27K',1974,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116460,'SNII optical','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1970G',NULL,116460,29.35,0.4,7.4,51124,NULL,NULL,NULL,'MESSIER 101',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116461,'SNII optical','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1970G',NULL,116461,29.4,0.58,7.6,51124,NULL,NULL,'EPM','MESSIER 101',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116462,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116462,27.07,NULL,2.6,51124,75,NULL,'CO','MESSIER 101',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116463,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116463,27.96,NULL,3.9,51124,75,NULL,'HI','MESSIER 101',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116464,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116464,28.65,0.4,5.4,51124,75,NULL,'B','MESSIER 101',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116465,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116465,29.2,0.5,6.92,51124,NULL,18.45,'SN 1970G host','MESSIER 101',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116466,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116466,29.24,NULL,7.05,51124,NULL,NULL,'B','MESSIER 101',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116467,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116467,29.37,NULL,7.48,51124,NULL,NULL,'I','MESSIER 101',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116468,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116468,29.62,0.41,8.39,51124,53.9,NULL,'MESSIER 101 Group','MESSIER 101',NULL,'1984A&A...132..253R',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116469,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116469,30.91,NULL,15.2,51124,NULL,NULL,'LEDA [April 2006]','MESSIER 101',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116470,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116470,33.88,0.25,59.7,51125,74.4,NULL,NULL,'ESO 384- G 036',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000047,NULL,'14.05',0.9,'SA0-',NULL,NULL,NULL,NULL,1,210.80425,-33.35778,0.241,NULL,47001892255,734404566,11475071,14.05),(116471,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116471,34.01,0.4,63.3,51125,NULL,NULL,'mean','ESO 384- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116472,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116472,34.31,0.45,72.9,51125,NULL,NULL,'K','ESO 384- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116473,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116473,36.26,0.75,179,51126,70,NULL,NULL,'2MASX J14031312-1357499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.804833,-13.96383,0.241,NULL,43643545378,681930396,10655162,16.7),(116474,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116474,37.72,0.33,349,51127,70,NULL,NULL,'2MASX J14031331+0610081',NULL,'2015arXiv151105856S',2015,1,0.45,'TXS codes: lobes(C)','G',0.000223,NULL,'16.2g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,210.805375,6.16897,0.052,NULL,58512135231,914252112,14285189,16.2),(116475,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116475,37.59,0.46,329,51128,70,NULL,NULL,'2MASX J14031338+4942240',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000151,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.805666667,49.7065,0.049,NULL,59254066085,925844782,14466324,16.8),(116476,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116476,37.81,0.46,364,51129,70,NULL,NULL,'SDSS J140314.49+091245.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.810375,9.21264,0.009,NULL,58507873428,914185522,14284148,18.2),(116477,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116477,37.31,0.46,290,51130,70,NULL,NULL,'2MASX J14031499+0609111',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,210.812333,6.15297,0.052,NULL,58512142561,914252227,14285191,18.32),(116478,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116478,36.44,0.46,194,51131,70,NULL,NULL,'2MASX J14031592+2627573',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,210.8165,26.46594,0,NULL,60011970729,937687042,14651360,16),(116479,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116479,38.01,0.46,400,51132,70,NULL,NULL,'2MASX J14031648+4314213',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.818583,43.23922,0,NULL,59233071514,925516742,14461199,17.7),(116480,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116480,34.9,0.8,95.6,51133,75,NULL,'MAT, I','ESO 446- G 001',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.21',0.9,'SA(s)bc:       HII',NULL,NULL,NULL,NULL,1,210.818666667,-31.34811,0.321,NULL,47035836037,734934938,11483358,14.21),(116481,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116481,34.28,0.43,71.9,51133,75,NULL,'MAT, I, raw','ESO 446- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116482,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116482,34.3,0.32,72.4,51133,85,NULL,'I, raw','ESO 446- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116483,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116483,34.35,0.57,74.2,51133,NULL,NULL,'Malmquist cor.','ESO 446- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116484,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116484,34.35,0.32,74.3,51133,85,NULL,'I, inv','ESO 446- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116485,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116485,34.51,0.43,80,51133,75,NULL,'MAT, I, cor','ESO 446- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116486,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116486,34.54,0.43,80.9,51133,75,NULL,'MAT, I, inv','ESO 446- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116487,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116487,34.57,0.51,82.2,51133,NULL,NULL,NULL,'ESO 446- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116488,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116488,34.65,0.2,85.1,51133,74.4,NULL,NULL,'ESO 446- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116489,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116489,35.06,0.47,103,51133,NULL,NULL,'H','ESO 446- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116490,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116490,35.22,0.4,110,51133,NULL,NULL,'mean','ESO 446- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116491,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116491,35.26,0.46,113,51133,NULL,NULL,'J','ESO 446- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116492,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116492,35.29,0.45,114,51133,NULL,NULL,'K','ESO 446- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116493,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116493,36.34,0.33,185,51134,70,NULL,NULL,'2MASX J14031702+3519373',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000193,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,210.82075,35.327,0,NULL,59149206130,924206345,14440724,15.9),(116494,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116494,35.95,0.53,155,51135,70,NULL,NULL,'2MASX J14031748-1419479',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.82275,-14.32992,0.229,NULL,43643386177,681927909,10655123,16.1),(116495,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116495,37.54,0.46,322,51136,70,NULL,NULL,'2MASX J14031889+1342080',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.8287083,13.70231,0,NULL,58361930636,911905166,14248518,17.5),(116496,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116496,38.04,0.19,406,51137,70,NULL,NULL,'2MASX J14031950+1531230',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.58',0.15,'BrClG',NULL,NULL,NULL,NULL,1,210.831208333,15.52297,0,NULL,58374278927,912098108,14251532,18.58),(116497,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116497,38.09,0.46,415,51138,70,NULL,NULL,'2MASX J14032000+2759154',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.833291667,27.98764,0,NULL,60008199519,937628117,14650439,17.8),(116498,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116498,37.83,0.46,367,51139,70,NULL,NULL,'2MASX J14032012+0341584',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000101,NULL,'16.8g',0.28,'AGN',NULL,NULL,NULL,NULL,1,210.83375,3.69958,0.021,NULL,58408712163,912636127,14259939,16.8),(116499,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116499,32.6,0.43,33.1,51140,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08988',NULL,'2014MNRAS.444..527S',2014,1,1.62,NULL,'G',0.000142,NULL,'15.1g',0.3,'Sc',NULL,NULL,NULL,NULL,1,210.83425,60.99019,0,NULL,57262881897,894732529,13980195,15.1),(116500,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116500,32.66,0.43,34.1,51140,75,NULL,'3.6 micron, color corrected','UGC 08988',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116501,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116501,32.74,0.4,35.3,51140,75,NULL,NULL,'UGC 08988',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116502,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116502,32.76,0.2,35.7,51140,74.4,NULL,NULL,'UGC 08988',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116503,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116503,32.99,0.44,39.7,51140,NULL,NULL,'Malmquist cor.','UGC 08988',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116504,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116504,33.06,0.43,40.9,51140,NULL,NULL,NULL,'UGC 08988',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116505,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116505,33.13,0.49,42.3,51140,75,NULL,'IR','UGC 08988',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116506,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116506,33.32,NULL,46.2,51140,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116507,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116507,33.33,NULL,46.4,51140,NULL,NULL,'Dipole + Quadrupole','UGC 08988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116508,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116508,33.34,NULL,46.6,51140,NULL,NULL,'Dipole','UGC 08988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116509,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116509,37.23,0.33,279,51141,70,NULL,NULL,'2MASX J14032036+2857224',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'18.05',0.17,'S0',NULL,NULL,NULL,NULL,1,210.834917,28.95619,0,NULL,60006493980,937601468,14650022,18.05),(116510,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116510,28.4,NULL,4.8,51142,NULL,NULL,NULL,'NGC 5408',NULL,'2002A&A...385...21K',2002,1,1.6,NULL,'G',0.00001,NULL,'12.5B',0.8,'IB(s)m         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.837125,-41.37769,0.265,NULL,46911885554,732998211,11453097,12.5),(116511,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116511,28.45,0.1,4.9,51142,NULL,NULL,NULL,'NGC 5408',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116512,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116512,28.63,0.1,5.32,51142,74.4,NULL,NULL,'NGC 5408',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116513,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116513,28.43,0.8,4.9,51142,75,NULL,NULL,'NGC 5408',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116514,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116514,37.41,0.33,303,51143,70,NULL,NULL,'SDSS J140320.95+232556.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.837333333,23.43225,0.008,NULL,59472525888,929258217,14519659,18.1),(116515,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116515,34.36,0.49,74.5,51144,75,NULL,'IR','ESO 510- G 051',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000063,NULL,'16.46',0.1,'S...',NULL,NULL,NULL,NULL,1,210.838083,-26.56008,0.149,NULL,46992788034,734262313,11472848,16.46),(116516,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116516,36.64,0.46,213,51145,70,NULL,NULL,'2MASX J14032155+1253430',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00019,NULL,'16.1g',0.31,'E0',NULL,NULL,NULL,NULL,1,210.839625,12.89544,0,NULL,58360565297,911883832,14248184,16.1),(116517,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116517,27.88,1.22,3.77,51146,NULL,NULL,NULL,'NGC 5434',NULL,'2009ApJS..182..474S',2009,1,1.13,'UZC has V = 4651 +- 37 km/sec.','G',0.000058,NULL,'14.1g',1.11,'SAc','Pair member (points to parent)',NULL,NULL,NULL,1,210.846417,9.44808,0,NULL,58507900236,914185941,14284155,14.1),(116518,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116518,27.9,1.21,3.8,51146,NULL,NULL,'Malmquist cor.','NGC 5434',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116519,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116519,35.95,0.61,155,51147,70,NULL,NULL,'2MASX J14032369-1422097',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.848833333,-14.36947,0.229,NULL,43643635870,681931810,10655184,16.4),(116520,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116520,38.63,0.46,533,51148,70,NULL,NULL,'SDSS J140323.99+082013.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.85,8.33706,0.029,NULL,58515088119,914298251,14285910,18.2),(116521,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116521,33.39,0.4,47.6,51149,75,NULL,'Edat, raw','NGC 5444',NULL,'1997ApJS..109..333W',1997,1,1.62,NULL,'G',0.000033,NULL,'12.8g',1.25,'E+:','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.8505417,35.13211,0,NULL,59150007667,924218869,14440919,12.8),(116522,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116522,33.72,0.4,55.5,51149,75,NULL,'Edat, cor','NGC 5444',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116523,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116523,33.69,0.45,54.7,51149,NULL,NULL,'K','NGC 5444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116524,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116524,33.83,0.4,58.3,51149,NULL,NULL,'mean','NGC 5444',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116525,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116525,37.41,0.46,303,51150,70,NULL,NULL,'2MASX J14032483+1628571',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.17,NULL,NULL,NULL,NULL,NULL,1,210.8535417,16.48253,0,NULL,58374738421,912105287,14251645,18.62),(116526,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116526,32.77,0.8,35.9,51151,75,NULL,'B','NGC 5426',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000017,NULL,'12.68',1.6,'SA(s)c pec','Pair member (points to parent)',NULL,NULL,NULL,1,210.8535417,-6.06911,0.081,NULL,43727217793,683237778,10675590,12.68),(116527,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116527,33,0.4,39.9,51151,NULL,NULL,'mean','NGC 5426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116528,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116528,33.04,0.46,40.5,51151,NULL,NULL,'J','NGC 5426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116529,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116529,33.04,0.47,40.6,51151,NULL,NULL,'H','NGC 5426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116530,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116530,33.09,0.45,41.5,51151,NULL,NULL,'K','NGC 5426',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116531,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116531,38.04,0.19,406,51152,70,NULL,NULL,'2MASX J14032506+1520201',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.854291667,15.33892,0,NULL,58374235417,912097428,14251522,17.9),(116532,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116532,37.56,0.33,326,51153,70,NULL,NULL,'2MASX J14032504+1556131',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.82',0.19,NULL,NULL,NULL,NULL,NULL,1,210.854417,15.93706,0,NULL,58374319827,912098747,14251542,17.82),(116533,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116533,38.04,0.19,406,51154,70,NULL,NULL,'2MASX J14032581+1525541',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.857416667,15.43181,0,NULL,58374288002,912098250,14251535,17.7),(116534,'Sosies','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116534,32.34,0.83,29.4,51155,NULL,NULL,NULL,'NGC 5427',NULL,'2002A&A...393...57T',2002,1,2.8,'The APM position is 11 arcsec northwest of the nucleus.','G',0.00001,NULL,'11.93',2.4,'SA(s)c pec;Sy2 HII','Pair member (points to parent)',NULL,NULL,'Sy 2',1,210.8585417,-6.03081,0.081,NULL,43727217945,683237780,10675590,11.93),(116535,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116535,32.91,0.8,38.1,51155,75,NULL,'B','NGC 5427',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116536,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116536,37.41,0.33,303,51156,70,NULL,NULL,'2MASX J14032621+2326033',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.859333333,23.43417,0.008,NULL,59472512851,929258013,14519656,17.2),(116537,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116537,36.1,0.46,166,51157,70,NULL,NULL,'2MASX J14032713+4514074',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000174,NULL,'15.7g',0.45,'S0^-',NULL,NULL,NULL,NULL,1,210.862875,45.23533,0,NULL,59235303445,925551616,14461744,15.7),(116538,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116538,34.34,0.8,73.9,51158,75,NULL,'HMCL, I','NGC 5434B',NULL,'1997ApJS..109..333W',1997,1,1.81,'Declination in 1996ApJS..107...97M is -5 degrees in error.','G',0.00002,NULL,'14.9g',0.33,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,210.8629583,9.46728,0,NULL,58507889310,914185770,14284152,14.9),(116539,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116539,34.35,0.8,74,51158,75,NULL,'W91CL, r','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116540,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116540,34.03,0.38,63.8,51158,75,NULL,'W91CL, r, raw','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116541,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116541,34.13,0.38,67.1,51158,75,NULL,'W91CL, r, inv','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116542,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116542,34.36,0.38,74.4,51158,75,NULL,'W91CL, r, cor','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116543,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116543,34.46,0.49,77.9,51158,75,NULL,'IR','NGC 5434B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116544,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116544,34.48,0.2,78.7,51158,74.4,NULL,NULL,'NGC 5434B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116545,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116545,34.61,0.4,83.4,51158,75,NULL,'HMCL, I, raw','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116546,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116546,34.62,0.45,83.9,51158,NULL,NULL,NULL,'NGC 5434B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116547,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116547,34.63,0.4,84.4,51158,NULL,NULL,'mean','NGC 5434B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116548,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116548,34.71,0.43,87.5,51158,NULL,NULL,'Malmquist cor.','NGC 5434B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116549,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116549,34.76,0.4,89.6,51158,75,NULL,'HMCL, I, inv','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116550,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116550,34.81,0.47,91.5,51158,NULL,NULL,'H','NGC 5434B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116551,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116551,34.82,0.4,92,51158,75,NULL,'HMCL, I, cor','NGC 5434B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116552,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116552,37.52,0.46,319,51159,70,NULL,NULL,'2MASX J14032757+2931184',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000113,NULL,'18.64',0.15,NULL,NULL,NULL,NULL,NULL,1,210.864833,29.52178,0,NULL,60007307189,937614174,14650221,18.64),(116553,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116553,38.06,0.33,409,51160,70,NULL,NULL,'2MASX J14032908+1547001',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.86',0.13,NULL,NULL,NULL,NULL,NULL,1,210.8712083,15.78339,0,NULL,58374341601,912099087,14251548,18.86),(116554,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116554,37.97,0.46,393,51161,70,NULL,NULL,'2MASX J14032925+1457451',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.51',0.16,NULL,NULL,NULL,NULL,NULL,1,210.871875,14.96239,0,NULL,58369022236,912015972,14250249,18.51),(116555,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116555,33,0.45,39.8,51162,NULL,NULL,'K','NGC 5445',NULL,'2007A&A...465...71T',2007,1,1.65,NULL,'G',0.000073,NULL,'13.6g',0.53,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,210.88125,35.02531,0,NULL,59150038666,924219354,14440927,13.6),(116556,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116556,33.76,0.4,56.4,51162,NULL,NULL,'mean','NGC 5445',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116557,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116557,35.29,0.2,114,51163,74.4,NULL,NULL,'UGC 08966',NULL,'2013AJ....146...86T',2013,1,1,'Position in 1991ApJ...377..349F is incorrect.','G',0.000011,NULL,'14.93',0.5,'Scd:',NULL,NULL,NULL,NULL,1,210.8825,6.77008,0.028,NULL,58512388600,914256071,14285251,14.93),(116558,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116558,38.06,0.33,409,51164,70,NULL,NULL,'2MASX J14033234+1546231',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.884667,15.77319,0,NULL,58374341065,912099079,14251548,17.4),(116559,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116559,37.34,0.33,294,51165,70,NULL,NULL,'2MASX J14033277+4958071',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000159,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,210.886625,49.96867,0.049,NULL,59254160652,925846260,14466347,15.9),(116560,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116560,38.64,0.46,535,51166,70,NULL,NULL,'2MASX J14033320+0432132',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000098,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.888458333,4.53697,0.061,NULL,58478694953,913729608,14277025,17.9),(116561,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116561,37.49,0.46,315,51167,70,NULL,NULL,'2MASX J14033345+2750090',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000192,NULL,'15.9g',0.52,NULL,NULL,NULL,NULL,NULL,1,210.890125,27.83092,0,NULL,60011724965,937683202,14651300,15.9),(116562,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116562,33.58,0.2,52,51168,74.4,NULL,NULL,'IC 4358',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'14.92',0.3,'Sbc pec sp',NULL,NULL,NULL,NULL,1,210.892417,-10.15125,0.101,NULL,43750784737,683606011,10681343,14.92),(116563,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116563,37.54,0.33,322,51169,70,NULL,NULL,'2MASX J14033470+2440401',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.8945,24.67786,0,NULL,59996427308,937444176,14647565,16.9),(116564,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116564,38.98,0.46,626,51170,70,NULL,NULL,'SDSS J140336.67+383003.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,210.902791667,38.50092,0,NULL,59143437632,924116213,14439315,18.3),(116565,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116565,33.26,0.4,44.9,51171,75,NULL,'Edat, raw','NGC 5419',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.00005,NULL,'11.9',3.3,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.911375,-33.97825,0.233,NULL,47002953689,734421151,11475330,11.9),(116566,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116566,33.44,0.4,48.7,51171,75,NULL,'Edat, cor','NGC 5419',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116567,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116567,33.5,0.11,50.1,51171,72,NULL,'ABELL S0753, 18 galaxies','NGC 5419',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116568,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116568,33.74,0.19,56,51171,NULL,NULL,'ABELL S0753, 16 galaxies','NGC 5419',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116569,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116569,33.48,0.18,49.7,51171,NULL,NULL,'ABELL S0753, 16 galaxies','NGC 5419',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116570,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116570,33.58,0.2,52,51171,NULL,NULL,'ABELL S0753, 16 galaxies','NGC 5419',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116571,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116571,33.69,0.23,54.7,51171,74.4,NULL,NULL,'NGC 5419',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116572,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116572,36.81,0.46,230,51172,70,NULL,NULL,'2MASX J14033949+5151240',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,210.914625,51.85664,0,NULL,59250370561,925787040,14465422,17.6),(116573,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116573,33.78,0.25,57,51173,74.4,NULL,NULL,'ABELL S0753:[WFC91] 065',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00006,NULL,'16.01',NULL,'S0',NULL,NULL,NULL,NULL,1,210.9187917,-34.18272,0.229,NULL,47003002377,734421912,11475342,16.01),(116574,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116574,37.34,0.75,294,51174,70,NULL,NULL,'2MASX J14034094-4238276',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,210.92075,-42.641,0.233,NULL,46911244478,732988194,11452940,15.6),(116575,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116575,36.56,0.68,205,51175,70,NULL,NULL,'2MASX J14034219-1100439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.925917,-11.01225,0.141,NULL,43747064549,683547883,10680435,16.7),(116576,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116576,36.06,0.46,163,51176,70,NULL,NULL,'2MASX J14034253-0108147',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000092,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,210.9270417,-1.13733,0.141,NULL,43602616763,681290886,10645170,16.1),(116577,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116577,33.53,0.8,50.7,51177,75,NULL,'MAT, I','ESO 446- G 002',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00003,NULL,'14.69',0.3,'Sab: sp        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,210.928083,-32.71686,0.313,NULL,47002418936,734412795,11475199,14.69),(116578,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116578,32.41,0.49,30.3,51177,75,NULL,'IR','ESO 446- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116579,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116579,32.89,0.47,37.9,51177,NULL,NULL,'H','ESO 446- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116580,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116580,32.92,0.45,38.4,51177,NULL,NULL,'K','ESO 446- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116581,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116581,33.13,0.46,42.2,51177,NULL,NULL,'J','ESO 446- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116582,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116582,33.22,0.32,44.1,51177,85,NULL,'I, raw','ESO 446- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116583,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116583,33.27,0.32,45,51177,85,NULL,'I, inv','ESO 446- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116584,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116584,33.48,0.43,49.7,51177,75,NULL,'MAT, I, raw','ESO 446- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116585,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116585,33.69,0.4,54.6,51177,NULL,NULL,'mean','ESO 446- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116586,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116586,33.7,0.43,55,51177,75,NULL,'MAT, I, inv','ESO 446- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116587,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116587,33.72,0.43,55.4,51177,75,NULL,'MAT, I, cor','ESO 446- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116588,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116588,33.87,0.41,59.5,51177,NULL,NULL,'Malmquist cor.','ESO 446- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116589,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116589,33.95,0.39,61.7,51177,NULL,NULL,NULL,'ESO 446- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116590,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116590,33.99,0.2,62.8,51177,74.4,NULL,NULL,'ESO 446- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116591,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116591,37.03,0.46,255,51178,70,NULL,NULL,'2MASX J14034305+2957491',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.63',0.16,NULL,NULL,NULL,NULL,NULL,1,210.929375,29.96375,0,NULL,60007367605,937615118,14650236,18.63),(116592,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116592,38.36,0.46,469,51179,70,NULL,NULL,'2MASXi J1403442+185013',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.95',0.13,NULL,NULL,NULL,NULL,NULL,1,210.93425,18.83714,0.045,NULL,58326063311,911344739,14239761,18.95),(116593,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116593,38.21,0.33,439,51180,70,NULL,NULL,'SDSS J140344.34+314105.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.93475,31.68492,0,NULL,60050732341,938292692,14660823,18.7),(116594,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116594,37.94,0.46,387,51181,70,NULL,NULL,'2MASX J14034471+2726351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000145,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,210.93625,27.44314,0,NULL,60011762372,937683787,14651309,17.5),(116595,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116595,38.12,0.27,422,51182,70,NULL,NULL,'SDSS J140345.14+100409.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000128,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.938125,10.06939,0,NULL,58510487691,914226370,14284787,18.4),(116596,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116596,38.32,0.46,460,51183,70,NULL,NULL,'2MASX J14034567+1507342',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,210.94025,15.12617,0,NULL,58361646213,911900722,14248448,18.77),(116597,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116597,38.45,0.46,489,51184,70,NULL,NULL,'SDSS J140346.10+072056.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.942125,7.34894,0.023,NULL,58511914735,914248667,14285135,17.9),(116598,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116598,37.54,0.33,322,51185,70,NULL,NULL,'2MASX J14034651+2448171',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,210.9437083,24.80469,0,NULL,59996430386,937444224,14647566,17.8),(116599,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116599,38.07,0.46,411,51186,70,NULL,NULL,'2MASX J14034697+5453450',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,210.945583333,54.89578,0,NULL,57299173235,895299581,13989055,17.2),(116600,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116600,37.27,0.23,284,51187,70,NULL,NULL,'SDSS J140347.13+241943.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,210.946417,24.32881,0,NULL,59460591030,929071734,14516745,18),(116601,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116601,35.16,0.2,108,51188,74.4,NULL,NULL,'UGC 08978',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.53',0.3,'S?','Group member',NULL,NULL,NULL,1,210.946917,15.7285,0,NULL,58374336944,912099014,14251547,15.53),(116602,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116602,35.16,0.25,108,51189,74.4,NULL,NULL,'NGC 5437',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000093,NULL,'15.1',0.4,'AGN','Group member',NULL,NULL,NULL,1,210.94725,9.52369,0,NULL,58509708811,914214200,14284596,15.1),(116603,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116603,36.55,0.46,204,51190,70,NULL,NULL,'2MASX J14034745+2943381',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.87',0.19,'Sb',NULL,NULL,NULL,NULL,1,210.947875,29.72722,0,NULL,60007274981,937613671,14650213,17.87),(116604,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116604,34.64,0.25,84.7,51191,74.4,NULL,NULL,'NGC 5438',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000087,NULL,'14.7',0.3,NULL,'Group member of poor cluster',NULL,NULL,NULL,1,210.95,9.61058,0,NULL,58509719109,914214361,14284599,14.7),(116605,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116605,36.99,0.46,250,51192,70,NULL,NULL,'2MASX J14034831+0933120',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000107,NULL,'17.46',0.25,NULL,NULL,NULL,NULL,NULL,1,210.95125,9.55336,0,NULL,58509708464,914214194,14284596,17.46),(116606,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116606,36.6,0.46,209,51193,70,NULL,NULL,'2MASX J14034843+0054272',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000075,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,210.9517917,0.90747,0.125,NULL,58416042514,912750664,14261729,17.5),(116607,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116607,34.7,0.2,87.1,51194,74.4,NULL,NULL,'UGC 08977',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000033,NULL,'14.90',0.7,'S?',NULL,NULL,NULL,NULL,1,210.9525,15.40231,0,NULL,58374283367,912098177,14251534,14.9),(116608,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116608,38.74,0.46,560,51195,70,NULL,NULL,'2MASX J14034874+1322063',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,210.953041667,13.36836,0,NULL,58363186250,911924785,14248824,18),(116609,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116609,38.12,0.27,422,51196,70,NULL,NULL,'2MASX J14034903+1004230',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,210.9542083,10.07303,0,NULL,58510481366,914226271,14284785,17.3),(116610,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116610,37.93,0.46,386,51197,70,NULL,NULL,'2MASX J14034918+1238403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,210.954875,12.64458,0,NULL,58360588133,911884189,14248190,17.5),(116611,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116611,36.36,0.46,187,51198,70,NULL,NULL,'2MASX J14034931+0544512',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00009,NULL,'16.24',0.31,NULL,NULL,NULL,NULL,NULL,1,210.955583,5.74753,0.027,NULL,58479590606,913743603,14277243,16.24),(116612,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116612,37.27,0.23,284,51199,70,NULL,NULL,'2MASX J14034990+2416081',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000187,NULL,'18.40',0.14,NULL,NULL,NULL,NULL,NULL,1,210.957833,24.26897,0,NULL,59472114903,929251795,14519559,18.4),(116613,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116613,38.92,0.46,609,51200,70,NULL,NULL,'SDSS J140350.02+651941.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000083,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,210.9584583,65.32828,0.041,NULL,57934004550,905218821,14144044,18.7),(116614,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116614,34.75,0.48,89.3,51201,70,NULL,NULL,'ESO 446- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00008,NULL,'14.42',0.8,'S0?',NULL,NULL,NULL,NULL,1,210.9630417,-31.94958,0.257,NULL,47034997546,734921836,11483153,14.42),(116615,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116615,32.48,0.69,31.3,51202,100,NULL,'mid-IR','IC 0971',NULL,'2013ApJ...771...88L',2013,1,2.2,NULL,'G',0.000013,NULL,'13.26',1.2,'SB(s)c',NULL,NULL,NULL,NULL,1,210.9699583,-10.14058,0.093,NULL,43750776099,683605876,10681341,13.26),(116616,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116616,32.58,0.66,32.8,51202,NULL,NULL,'Malmquist cor.','IC 0971',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116617,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116617,32.71,0.2,34.8,51202,74.4,NULL,NULL,'IC 0971',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116618,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116618,32.79,0.6,36.2,51202,NULL,NULL,NULL,'IC 0971',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116619,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116619,33.44,0.47,48.7,51202,NULL,NULL,'H','IC 0971',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116620,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116620,33.51,0.4,50.5,51202,NULL,NULL,'mean','IC 0971',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116621,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116621,33.56,0.46,51.4,51202,NULL,NULL,'J','IC 0971',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116622,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116622,38.04,0.19,406,51203,70,NULL,NULL,'SDSS J140353.35+151951.0',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,210.972333,15.33086,0,NULL,58356412106,911818939,14247170,16.8),(116623,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116623,36.74,0.46,223,51204,70,NULL,NULL,'2MASX J14035370+1651474',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.75',0.3,NULL,NULL,NULL,NULL,NULL,1,210.973667,16.86311,0,NULL,58375588525,912118570,14251852,16.75),(116624,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116624,38.04,0.19,406,51205,70,NULL,NULL,'2MASX J14035339+1519514',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'PHOT','18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,210.976917,15.328,0,NULL,58356412256,911818941,14247170,18.29),(116625,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116625,36.75,0.46,223,51206,70,NULL,NULL,'2MASX J14035482+2142035',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,210.978417,21.70097,0.017,NULL,59473627945,929275436,14519928,18.22),(116626,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116626,38.21,0.33,439,51207,70,NULL,NULL,'2MASX J14035562+3143299',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.62',0.16,NULL,NULL,NULL,NULL,NULL,1,210.981833,31.72497,0,NULL,60050731363,938292677,14660823,18.62),(116627,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116627,36.16,0.71,170,51208,70,NULL,NULL,'2MASX J14035583-1032350',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,210.9827917,-10.54319,0.125,NULL,43750457192,683600893,10681263,16.8),(116628,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116628,38.62,0.46,530,51209,70,NULL,NULL,'2MASX J14035753+4842400',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,210.98975,48.711,0.044,NULL,59242993127,925671767,14463621,18.1),(116629,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116629,38.12,0.27,422,51210,70,NULL,NULL,'2MASX J14035858+1003160',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,210.994083333,10.05456,0,NULL,58510482942,914226295,14284785,16.7),(116630,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116630,36.06,0.57,163,51211,70,NULL,NULL,'2MASX J14035876-2920103',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000103,NULL,'15.2b',NULL,'S0',NULL,NULL,NULL,NULL,1,210.994833,-29.33617,0.173,NULL,46982104719,734095386,11470240,15.2),(116631,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116631,37.2,0.33,276,51212,70,NULL,NULL,'2MASX J14035954+2356061',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,210.99825,23.93503,0.013,NULL,59472200229,929253128,14519580,16.6),(116632,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116632,36.99,0.33,250,51213,70,NULL,NULL,'MCG +11-17-015',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000125,NULL,'15.1g',0.61,'E0',NULL,NULL,NULL,NULL,1,211.000875,64.68272,0.021,NULL,57934625168,905228518,14144195,15.1),(116633,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116633,37.64,0.46,337,51214,70,NULL,NULL,'SDSS J140400.24+324012.1',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.001,32.67006,0,NULL,60034115492,938033054,14656766,16.7),(116634,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116634,37.09,0.46,261,51215,70,NULL,NULL,'2MASX J14040065+6052516',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,211.0024583,60.88106,0,NULL,57274341208,894911581,13982993,16.3),(116635,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116635,36.97,0.87,247,51216,70,NULL,NULL,'2MASX J14040140-3254236',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.005791667,-32.90658,0.245,NULL,47002199088,734409360,11475146,15.6),(116636,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116636,38.06,0.46,410,51217,70,NULL,NULL,'2MASX J14040201+3744015',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.0085,37.73381,0,NULL,59142947227,924108550,14439196,17.1),(116637,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116637,37.93,0.27,386,51218,70,NULL,NULL,'2MASX J14040210+5942461',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000205,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.008833,59.71286,0.013,NULL,57273494300,894898348,13982786,17.3),(116638,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116638,36.98,0.46,249,51219,70,NULL,NULL,'SDSS J140402.64+165327.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.0110417,16.89106,0,NULL,58375563339,912118177,14251846,17.8),(116639,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116639,33.81,0.25,57.8,51220,74.4,NULL,NULL,'ESO 510- G 054',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000011,NULL,'14.11',0.9,'SAB0^0^: pec',NULL,NULL,NULL,NULL,1,211.013333,-26.21614,0.169,NULL,46990647355,734228864,11472326,14.11),(116640,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116640,35.08,NULL,104,51221,NULL,NULL,NULL,'UGC 08983',NULL,'2000BSAO...50....5K',2000,1,1.17,NULL,'G',0.000046,NULL,'16.2g',0.2,'Sc',NULL,NULL,NULL,NULL,1,211.015083333,12.00467,0,NULL,58489737275,913902144,14279721,16.2),(116641,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116641,35.1,NULL,105,51221,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08983',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116642,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116642,35.11,NULL,105,51221,NULL,NULL,'Dipole + Quadrupole','UGC 08983',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116643,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116643,35.12,NULL,106,51221,NULL,NULL,'Dipole','UGC 08983',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116644,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116644,35.31,0.49,115,51221,75,NULL,'IR','UGC 08983',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116645,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116645,35.77,0.2,143,51221,74.4,NULL,NULL,'UGC 08983',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116646,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116646,37.34,0.33,294,51222,70,NULL,NULL,'2MASX J14040521+4958470',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,211.021833333,49.97978,0.102,NULL,59254861478,925857210,14466518,16.2),(116647,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116647,37.91,0.46,382,51223,70,NULL,NULL,'2MASX J14040621+0434426',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000115,NULL,'16.0g',0.46,'E0',NULL,NULL,NULL,NULL,1,211.02575,4.57853,0.053,NULL,58480984989,913765390,14277584,16),(116648,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116648,36.11,0.63,167,51224,70,NULL,NULL,'2MASX J14040658-1655547',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.027417,-16.93183,0.261,NULL,43683192709,682549886,10664841,15.4),(116649,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116649,34.93,NULL,97,51225,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08979',NULL,'2010Ap&SS.325..163P',2010,1,1.74,NULL,'G',0.000027,NULL,'16.0',0.22,'Sbc',NULL,NULL,NULL,NULL,1,211.031917,6.48589,0.059,NULL,58512393176,914256143,14285252,16),(116650,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116650,34.94,NULL,97.3,51225,NULL,NULL,'Dipole','UGC 08979',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116651,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116651,34.95,NULL,97.8,51225,NULL,NULL,'Dipole + Quadrupole','UGC 08979',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116652,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116652,34.99,NULL,99.6,51225,NULL,NULL,NULL,'UGC 08979',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116653,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116653,35.07,0.49,103,51225,75,NULL,'IR','UGC 08979',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116654,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116654,35.24,0.38,112,51225,NULL,NULL,'Malmquist cor.','UGC 08979',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116655,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116655,35.47,0.2,124,51225,74.4,NULL,NULL,'UGC 08979',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116656,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116656,35.59,0.33,131,51225,NULL,NULL,NULL,'UGC 08979',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116657,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116657,37.97,0.46,392,51226,70,NULL,NULL,'2MASX J14040800+1629114',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.91',0.21,NULL,NULL,NULL,NULL,NULL,1,211.03325,16.4865,0,NULL,58374529466,912102022,14251594,17.91),(116658,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116658,37.2,0.33,276,51227,70,NULL,NULL,'2MASXi J1404081+235636',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.0342917,23.94328,0.013,NULL,59472171991,929252687,14519573,17.8),(116659,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116659,37.46,0.46,311,51228,70,NULL,NULL,'2MASX J14040832+3215370',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.0345417,32.26017,0,NULL,60034006827,938031356,14656739,17.4),(116660,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116660,36.06,0.2,163,51229,74.4,NULL,NULL,'KUG 1401+133',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000094,NULL,'15.4g',0.34,'Spiral',NULL,NULL,NULL,NULL,1,211.038125,13.06725,0,NULL,58360261538,911879086,14248110,15.4),(116661,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116661,35.91,0.73,152,51230,70,NULL,NULL,'2MASX J14040946-2305454',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.0394583,-23.09594,0.189,NULL,46521788490,726902945,11357858,15.4),(116662,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116662,37.6,0.15,331,51231,70,NULL,NULL,'2MASX J14040979+0624040',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.040917,6.40103,0.075,NULL,58512199383,914253115,14285204,16.8),(116663,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116663,36.79,0.46,228,51232,70,NULL,NULL,'2MASX J14041010+4620405',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.0422917,46.34461,0,NULL,59234580111,925540314,14461567,17),(116664,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116664,35.83,0.64,146,51233,70,NULL,NULL,'2MASX J14041200-1809434',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.34',NULL,NULL,NULL,NULL,NULL,NULL,1,211.050125,-18.16231,0.285,NULL,43679640807,682494387,10663974,16.34),(116665,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116665,38.16,0.46,428,51234,70,NULL,NULL,'2MASX J14041243+0407316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.0517083,4.12544,0.033,NULL,58479064409,913735381,14277115,17.3),(116666,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116666,36.98,0.27,249,51235,70,NULL,NULL,'2MASX J14041286+3844005',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,211.053833,38.73364,0,NULL,59143464238,924116628,14439322,16.7),(116667,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116667,37.96,0.46,391,51236,70,NULL,NULL,'2MASX J14041342+1308294',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.056,13.14156,0,NULL,58360225849,911878528,14248102,17.7),(116668,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116668,38.22,0.46,441,51237,70,NULL,NULL,'2MASX J14041379+1202224',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,211.0575,12.03967,0,NULL,58490429434,913912959,14279889,18.2),(116669,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116669,35.55,0.46,129,51238,70,NULL,NULL,'CGCG 191-048',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000097,NULL,'14.8g',0.57,'E0',NULL,NULL,NULL,NULL,1,211.064625,35.80067,0,NULL,59153531066,924273922,14441780,14.8),(116670,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116670,35.24,0.59,112,51239,70,NULL,NULL,'MCG -01-36-005',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'MCG declination is -53 arcmin in error.','G',0.000147,NULL,'14.51',0.5,NULL,NULL,NULL,NULL,NULL,1,211.075583,-7.04825,0.061,NULL,43745269722,683519839,10679997,14.51),(116671,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116671,36.96,0.46,247,51240,70,NULL,NULL,'2MASX J14041850+5456431',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00019,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,211.076875,54.94542,0,NULL,57299166171,895299471,13989054,16.2),(116672,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116672,36.93,0.46,243,51241,70,NULL,NULL,'LCRS B140144.2-024508',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000147,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.0820417,-2.99117,0.125,NULL,43600989846,681265466,10644772,17.2),(116673,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116673,37.4,0.46,302,51242,70,NULL,NULL,'2MASX J14042036+4120064',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.084875,41.33522,0,NULL,59258968671,925921385,14467521,17.6),(116674,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116674,38.59,0.46,522,51243,70,NULL,NULL,'SDSS J140420.77+240529.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.086583333,24.09144,0,NULL,59472326704,929255104,14519611,18.3),(116675,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116675,37.3,0.46,289,51244,70,NULL,NULL,'2MASX J14042139+1817107',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.96',0.2,NULL,NULL,NULL,NULL,NULL,1,211.089,18.28622,0.035,NULL,58326153433,911346147,14239783,17.96),(116676,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116676,37.05,0.46,257,51245,70,NULL,NULL,'2MASX J14042222+0526355',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.0925,5.44314,0.034,NULL,58479421213,913740956,14277202,16.8),(116677,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116677,37.25,0.46,282,51246,70,NULL,NULL,'2MASX J14042252+6631309',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.093625,66.52522,0.057,NULL,57871316244,904239316,14128739,17.3),(116678,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116678,38.43,0.46,485,51247,70,NULL,NULL,'2MASX J14042252+5048050',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.093916667,50.80156,0,NULL,59250830987,925794234,14465534,18),(116679,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116679,37.62,0.46,334,51248,70,NULL,NULL,'2MASX J14042320+3358109',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.096833333,33.96961,0,NULL,60036518624,938070603,14657353,17.8),(116680,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116680,37.92,0.46,384,51249,70,NULL,NULL,'2MASX J14042622+0635397',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.109375,6.5945,0.059,NULL,58512616759,914259636,14285306,17.4),(116681,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116681,37.97,0.46,393,51250,70,NULL,NULL,'2MASX J14042632+3239516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.1097083,32.66444,0,NULL,60034088277,938032629,14656759,17.4),(116682,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116682,35.65,0.5,135,51251,70,NULL,NULL,'2MASX J14042762-1432517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.82',NULL,NULL,NULL,NULL,NULL,NULL,1,211.1152083,-14.54769,0.229,NULL,43642993161,681921768,10655027,15.82),(116683,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116683,37.82,0.46,367,51252,70,NULL,NULL,'2MASXi J1404276+241323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.115458333,24.22311,0,NULL,59472105825,929251653,14519557,17.5),(116684,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116684,34.48,0.43,78.8,51253,75,NULL,'3.6 micron, color + selection bias corrected','ESO 384- G 043',NULL,'2014MNRAS.444..527S',2014,1,1.79,NULL,'G',0.00015,NULL,'15.78',0.22,'Scd',NULL,NULL,NULL,NULL,1,211.1160417,-33.51714,0.237,NULL,47005073436,734454272,11475848,15.78),(116685,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116685,35.99,0.2,158,51254,74.4,NULL,NULL,'UGC 08998',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000033,NULL,'16.3g',0.22,'Scd:',NULL,NULL,NULL,NULL,1,211.116875,25.79828,0,NULL,60010943181,937670987,14651109,16.3),(116686,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116686,35.12,0.2,106,51255,74.4,NULL,NULL,'KUG 1402+341',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000107,NULL,'15.4g',0.28,'Spiral',NULL,NULL,NULL,NULL,1,211.121833333,33.95336,0,NULL,60036521465,938070647,14657353,15.4),(116687,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116687,36.69,0.46,218,51256,70,NULL,NULL,'2MASXi J1404310-004522',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000067,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.129167,-0.75622,0.137,NULL,43589174857,681080857,10641888,17.5),(116688,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116688,35.16,0.49,108,51257,75,NULL,'IR','MCG -02-36-010',NULL,'2011yCatp016004901K',2011,1,1.27,NULL,'G',0.000057,NULL,'16.3b',0.18,'Sbc',NULL,NULL,NULL,NULL,1,211.1320417,-15.20386,0.269,NULL,43648061573,682000962,10656265,16.3),(116689,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116689,35.5,NULL,126,51257,NULL,NULL,'Dipole + Quadrupole','MCG -02-36-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116690,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116690,35.51,NULL,126,51257,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-36-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116691,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116691,35.51,NULL,126,51257,NULL,NULL,'Dipole','MCG -02-36-010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116692,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116692,36.97,0.46,247,51258,70,NULL,NULL,'2MASX J14043245+1812526',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.53',0.14,NULL,NULL,NULL,NULL,NULL,1,211.135291667,18.21469,0.012,NULL,58326139586,911345931,14239780,18.53),(116693,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116693,38,0.46,399,51259,70,NULL,NULL,'2MASX J14043313+4531061',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.138,45.51844,0,NULL,59235177502,925549648,14461713,17.5),(116694,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116694,36.87,0.46,236,51260,70,NULL,NULL,'2MASX J14043398+3109577',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.62',0.22,NULL,NULL,NULL,NULL,NULL,1,211.141416667,31.16603,0,NULL,60050277891,938285592,14660712,17.62),(116695,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116695,36.89,0.46,238,51261,70,NULL,NULL,'2MASX J14043418+3710404',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000178,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,211.1425,37.17781,0,NULL,59142508138,924101689,14439088,16.2),(116696,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116696,33.78,0.23,57,51262,74.4,NULL,NULL,'MCG -06-31-020',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000057,NULL,'14.01',0.9,'S0',NULL,NULL,NULL,NULL,1,211.143083,-33.96075,0.237,NULL,47005066950,734454171,11475846,14.01),(116697,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116697,33.66,0.4,53.9,51262,NULL,NULL,'mean','MCG -06-31-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116698,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116698,34.33,0.45,73.3,51262,NULL,NULL,'K','MCG -06-31-020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116699,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116699,37.5,0.46,316,51263,70,NULL,NULL,'2MASX J14043498+3518157',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000036,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.145625,35.30428,0,NULL,59149304483,924207882,14440748,17.9),(116700,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116700,37.24,0.46,280,51264,70,NULL,NULL,'SDSS J140435.95+265407.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000095,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,211.1497917,26.902,0,NULL,60011514587,937679915,14651248,18),(116701,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116701,37.77,0.46,358,51265,70,NULL,NULL,'2MASX J14043692+2159026',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,211.1537083,21.98417,0,NULL,59474624553,929291008,14520172,18.32),(116702,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116702,36.46,0.55,196,51266,70,NULL,NULL,'2MASX J14043719-2229263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.1550417,-22.49064,0.177,NULL,46523167227,726924487,11358195,14.2),(116703,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116703,37.65,0.46,339,51267,70,NULL,NULL,'SDSS J140438.21-015601.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.15925,-1.93386,0.157,NULL,43601328907,681270764,10644855,18),(116704,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116704,37.88,0.46,377,51268,70,NULL,NULL,'2MASX J14043862+0757517',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.161,7.96436,0.064,NULL,58518659920,914354061,14286782,17.1),(116705,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116705,35.5,0.59,126,51269,70,NULL,NULL,'2MASX J14043929-2051283',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.92',NULL,NULL,NULL,NULL,NULL,NULL,1,211.16375,-20.858,0.185,NULL,46518130866,726845794,11356965,15.92),(116706,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116706,38.3,0.46,457,51270,70,NULL,NULL,'2MASX J14044008+2520400',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000177,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.1669583,25.34453,0,NULL,60010090832,937657669,14650901,17),(116707,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116707,36.64,0.62,213,51271,70,NULL,NULL,'2MFGC 11401',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,211.167917,-14.44917,0.221,NULL,43643732033,681933313,10655208,15.9),(116708,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116708,36.42,0.46,193,51272,70,NULL,NULL,'2MASX J14044080+4444052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.99',0.14,NULL,NULL,NULL,NULL,NULL,1,211.17,44.73483,0,NULL,59233372180,925521440,14461272,17.99),(116709,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116709,37.6,0.15,331,51273,70,NULL,NULL,'2MASX J14044228+0611198',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.32',0.14,NULL,NULL,NULL,NULL,NULL,1,211.176083,6.18872,0.041,NULL,58512185215,914252893,14285201,18.32),(116710,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116710,37.93,0.27,386,51274,70,NULL,NULL,'SDSS J140442.26+594036.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.176083,59.67692,0.013,NULL,57271652625,894869572,13982337,17.7),(116711,'Faber-Jackson','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116711,30.82,0.65,14.6,51275,95,NULL,'Weighted Mean','NGC 5473',NULL,'1984ApJS...56...91D',1984,1,1.9,NULL,'G',0.000017,NULL,'12.3g',1.46,'SAB(s)0-:','in a radial-velocity based grouping',NULL,NULL,NULL,1,211.180125,54.89264,0,NULL,57299122467,895298788,13989043,12.3),(116712,'Faber-Jackson','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116712,32,0.81,25.1,51275,55,NULL,'Visvanathan & Sandage 1979','NGC 5473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116713,'Tertiary','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116713,31.87,0.29,23.7,51275,95,NULL,NULL,'NGC 5473',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116714,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116714,32.59,0.8,33,51275,75,NULL,'B','NGC 5473',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116715,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116715,32.35,0.4,29.5,51275,NULL,NULL,'mean','NGC 5473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116716,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116716,32.88,0.45,37.7,51275,NULL,NULL,'K','NGC 5473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116717,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116717,34.71,NULL,87.5,51276,NULL,NULL,'Dipole','UGC 08996',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000008,NULL,'15.5g',0.25,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,211.18025,14.28042,0,NULL,58362631256,911916113,14248689,15.5),(116718,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116718,34.72,NULL,88.1,51276,NULL,NULL,'Dipole + Quadrupole','UGC 08996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116719,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116719,34.73,NULL,88.2,51276,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 08996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116720,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116720,34.9,NULL,95.7,51276,NULL,NULL,NULL,'UGC 08996',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116721,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116721,35.13,0.49,106,51276,75,NULL,'IR','UGC 08996',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116722,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116722,35.33,0.2,116,51276,74.4,NULL,NULL,'UGC 08996',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116723,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116723,37.99,0.46,396,51277,70,NULL,NULL,'2MASX J14044380+6243172',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,211.1827083,62.72144,0.029,NULL,57751120512,902361258,14099394,17.9),(116724,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116724,37.64,0.46,337,51278,70,NULL,NULL,'2MASX J14044417+2218136',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.1839583,22.30375,0,NULL,59475123193,929298799,14520293,17.8),(116725,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116725,36.9,0.46,240,51279,70,NULL,NULL,'2MASX J14044455+4909213',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.1854583,49.15589,0.047,NULL,59254444135,925850689,14466417,16.3),(116726,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116726,34.88,0.46,94.7,51280,70,NULL,NULL,'NGC 5454',NULL,'2015arXiv151105856S',2015,1,1.29,NULL,'G',0.000103,NULL,'14.1g',0.71,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,211.1904583,14.38206,0,NULL,58362628515,911916070,14248688,14.1),(116727,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116727,34.48,0.45,78.7,51280,NULL,NULL,'K','NGC 5454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116728,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116728,35.24,0.4,112,51280,NULL,NULL,'mean','NGC 5454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116729,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116729,37.33,0.46,292,51281,70,NULL,NULL,'2MASX J14044588-0049092',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000097,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,211.19125,-0.81919,0.137,NULL,43588659647,681072806,10641762,16.4),(116730,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116730,32.63,0.8,33.6,51282,75,NULL,NULL,'UGCA 383',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000027,NULL,'13.61',2.1,'SB(s)cd','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,211.193125,-24.82717,0.325,NULL,46989845099,734216329,11472130,13.61),(116731,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116731,37.45,0.46,310,51283,70,NULL,NULL,'2MASX J14044691+1853146',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.41',0.16,NULL,NULL,NULL,NULL,NULL,1,211.195667,18.88733,0.048,NULL,59462834068,929106782,14517293,18.41),(116732,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116732,31.49,0.43,19.8,51284,75,NULL,'3.6 micron, color + selection bias corrected','UGC 08995',NULL,'2014MNRAS.444..527S',2014,1,2.05,NULL,'G',0.000022,NULL,'14.2g',0.76,'SABdm',NULL,NULL,NULL,NULL,1,211.19725,8.80092,0.022,NULL,58518174349,914346474,14286663,14.2),(116733,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116733,31.61,0.43,21,51284,75,NULL,'3.6 micron, color corrected','UGC 08995',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116734,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116734,31.7,0.2,21.9,51284,74.4,NULL,NULL,'UGC 08995',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116735,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116735,31.7,0.53,21.9,51284,NULL,NULL,'Malmquist cor.','UGC 08995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116736,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116736,31.86,NULL,23.6,51284,72,NULL,NULL,'UGC 08995',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116737,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116737,31.87,0.4,23.7,51284,75,NULL,'B','UGC 08995',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116738,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116738,31.88,0.37,23.8,51284,NULL,NULL,NULL,'UGC 08995',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116739,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116739,31.98,0.46,24.9,51284,NULL,NULL,NULL,'UGC 08995',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116740,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116740,37.63,0.46,335,51285,70,NULL,NULL,'2MASX J14044805+1716256',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,211.200333333,17.27375,0,NULL,58372768232,912074503,14251164,16.2),(116741,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116741,37.6,0.15,331,51286,70,NULL,NULL,'2MASX J14044845+0609078',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.20175,6.15214,0.041,NULL,58512192180,914253002,14285203,17.6),(116742,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116742,35.55,0.46,129,51287,70,NULL,NULL,'2MASX J14044887+1557476',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.2035417,15.96311,0,NULL,58356996559,911828071,14247313,16.1),(116743,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116743,33.87,0.46,59.6,51288,70,NULL,NULL,'CGCG 074-086',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000083,NULL,'14.6g',0.56,NULL,NULL,NULL,NULL,NULL,1,211.206125,11.3955,0,NULL,58490010311,913906411,14279787,14.6),(116744,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116744,36.26,0.46,179,51289,70,NULL,NULL,'2MASX J14045011+4454382',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,211.208917,44.91064,0,NULL,59235323312,925551926,14461748,16),(116745,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116745,37.27,0.23,284,51290,70,NULL,NULL,'2MASX J14045022+2410490',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.77',0.28,NULL,NULL,NULL,NULL,NULL,1,211.209333,24.18022,0,NULL,59472302879,929254732,14519605,16.77),(116746,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116746,38.45,0.46,489,51291,70,NULL,NULL,'2MASX J14045099+6558361',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.5g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,211.2120417,65.97658,0.057,NULL,57941402394,905334412,14145850,17.5),(116747,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116747,34.76,0.49,89.4,51292,70,NULL,NULL,'2MASX J14045120-3240336',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.6b',NULL,'S0',NULL,NULL,NULL,NULL,1,211.213333,-32.67597,0.273,NULL,47002174604,734408978,11475140,16.6),(116748,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116748,36.08,NULL,165,51293,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09000',NULL,'2010Ap&SS.325..163P',2010,1,1.1,'Springob et al. (2005ApJS..160..149S) give v= 11495 km/sec.','G',0.00004,NULL,'15.30',0.13,'SB?',NULL,NULL,NULL,NULL,1,211.214125,10.80856,0,NULL,58506921512,914170648,14283916,15.3),(116749,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116749,36.09,NULL,165,51293,NULL,NULL,'Dipole + Quadrupole','UGC 09000',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116750,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116750,36.1,NULL,166,51293,NULL,NULL,'Dipole','UGC 09000',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116751,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116751,36.72,0.59,221,51294,70,NULL,NULL,'2MASX J14045187-1005280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,211.216125,-10.09119,0.089,NULL,43750330472,683598913,10681233,16.9),(116752,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116752,38.67,0.46,541,51295,70,NULL,NULL,'SDSS J140452.20+141735.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.2175,14.29322,0,NULL,58362636996,911916203,14248690,18.3),(116753,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116753,34.98,0.43,99,51296,NULL,NULL,NULL,'UGC 08994',NULL,'2009ApJS..182..474S',2009,1,1.12,NULL,'G',0.000023,NULL,'14.5g',0.64,'SAB(s)bc pec:','Pair member (points to parent)',NULL,NULL,NULL,1,211.21925,-0.61128,0.129,NULL,43589226767,681081668,10641901,14.5),(116754,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116754,35.01,0.42,100,51296,NULL,NULL,'Malmquist cor.','UGC 08994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116755,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116755,35.02,0.2,101,51296,74.4,NULL,NULL,'UGC 08994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116756,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116756,37.23,0.46,279,51297,70,NULL,NULL,'SDSS J140452.60+104422.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.2192083,10.73953,0,NULL,58506916535,914170570,14283915,17.8),(116757,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116757,37.51,0.46,317,51298,70,NULL,NULL,'SDSS J140452.86+291844.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.03',0.22,NULL,NULL,NULL,NULL,NULL,1,211.2202917,29.31242,0,NULL,60006142049,937595969,14649937,17.03),(116758,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116758,36.02,0.49,160,51299,75,NULL,'IR','UGC 09001',NULL,'2011yCatp016004901K',2011,1,1,'Called \'MCG +02-36-032b\' in UGC.','G',0.00012,NULL,'15.1',0.4,'SB?',NULL,NULL,NULL,NULL,1,211.2232917,10.801,0,NULL,58506921555,914170649,14283916,15.1),(116759,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116759,37.93,0.27,386,51300,70,NULL,NULL,'2MASX J14045384+5940594',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.224291667,59.68328,0.013,NULL,57271654087,894869595,13982337,16.7),(116760,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116760,36.98,0.27,249,51301,70,NULL,NULL,'2MASX J14045451+3836244',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.227166667,38.60667,0,NULL,59143445420,924116334,14439317,17.3),(116761,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116761,37.12,0.33,266,51302,70,NULL,NULL,'2MASX J14045488+5144303',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.228417,51.74181,0.005,NULL,59250345962,925786655,14465416,16.9),(116762,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116762,37.35,0.33,296,51303,70,NULL,NULL,'2MASX J14045570+5424104',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000191,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,211.2317917,54.40297,0,NULL,57281686297,895026348,13984786,16),(116763,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116763,35.52,0.57,127,51304,70,NULL,NULL,'2MASX J14045594-1406231',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.2b',0.5,NULL,NULL,NULL,NULL,NULL,1,211.23325,-14.10658,0.245,NULL,43643814330,681934598,10655228,16.2),(116764,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116764,39.31,0.46,728,51305,70,NULL,NULL,'2MASX J14045615+0803288',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.234,8.05817,0.064,NULL,58518585226,914352894,14286763,NULL),(116765,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116765,38.11,0.46,418,51306,70,NULL,NULL,'2MASX J14045713+3933454',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.238083,39.56258,0,NULL,59260547656,925946057,14467907,17.9),(116766,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116766,34.38,0.56,75.3,51307,70,NULL,NULL,'MCG -02-36-012',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000113,NULL,'15.06',0.3,'SB(s)b? sp',NULL,NULL,NULL,NULL,1,211.239666667,-14.27814,0.221,NULL,43643772655,681933947,10655217,15.06),(116767,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116767,36.98,0.27,249,51308,70,NULL,NULL,'SDSS J140458.35+383803.3',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000207,NULL,'15.7g',0.49,NULL,NULL,NULL,NULL,NULL,1,211.243125,38.63422,0,NULL,59143562913,924118170,14439346,15.7),(116768,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116768,34.11,0.46,66.4,51309,70,NULL,NULL,'NGC 5456',NULL,'2015arXiv151105856S',2015,1,1.21,NULL,'G',0.000113,NULL,'13.8g',0.92,'S0','Group member of poor cluster',NULL,NULL,NULL,1,211.245375,11.87164,0,NULL,58490470264,913913597,14279899,13.8),(116769,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116769,34.75,0.46,89.2,51310,70,NULL,NULL,'NGC 5459',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000083,NULL,'14.0g',0.84,'S0','Group member of poor cluster',NULL,NULL,NULL,1,211.2507917,13.13189,0,NULL,58363486263,911929472,14248898,14),(116770,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116770,34.53,0.4,80.6,51310,NULL,NULL,'mean','NGC 5459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116771,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116771,35.09,0.45,104,51310,NULL,NULL,'K','NGC 5459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116772,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116772,36.99,0.33,250,51311,70,NULL,NULL,'2MASX J14050084+6439005',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.253625,64.65006,0.029,NULL,57934495070,905226485,14144163,17.2),(116773,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116773,28.9,0.9,6.03,51312,NULL,NULL,'3, B, blue stars','NGC 5474',NULL,'1994MNRAS.271..530R',1994,1,4.8,'Highly asymmetrical.','G',0.00003,NULL,'11.28',4.3,'SA(s)cd pec    HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,211.256708333,53.66222,0,NULL,59215392004,925240500,14456882,11.28),(116774,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116774,28.9,0.9,6.03,51312,NULL,NULL,'3, B, blue stars','NGC 5474',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116775,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116775,29.15,NULL,6.8,51312,NULL,NULL,NULL,'NGC 5474',NULL,'2000A&AS..142..425D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116776,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116776,29.29,NULL,7.2,51312,NULL,NULL,NULL,'NGC 5474',NULL,'1994BSAO...38....5K',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116777,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116777,29.4,NULL,7.59,51312,NULL,NULL,'Photographic','NGC 5474',NULL,'1980A&A....83..354C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116778,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116778,29.17,0.13,6.82,51312,NULL,NULL,NULL,'NGC 5474',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116779,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116779,29.22,0.1,6.98,51312,74.4,NULL,NULL,'NGC 5474',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116780,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116780,28.32,0.16,4.61,51312,NULL,NULL,'Method 2','NGC 5474',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116781,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116781,28.85,0.09,5.89,51312,NULL,NULL,'Method 1','NGC 5474',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116782,'Magnitude','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116782,28.33,0.16,4.63,51312,NULL,NULL,NULL,'NGC 5474',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116783,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116783,28.87,0.4,6,51312,75,NULL,'B','NGC 5474',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116784,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116784,37.12,0.33,266,51313,70,NULL,NULL,'2MASX J14050263+5143503',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.260916667,51.73053,0.005,NULL,59250345509,925786648,14465416,16.8),(116785,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116785,36.36,0.62,187,51314,70,NULL,NULL,'2MASX J14050288-2100542',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.20',0.3,NULL,NULL,NULL,NULL,NULL,1,211.262167,-21.01514,0.185,NULL,46518019498,726844054,11356938,16.2),(116786,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116786,37.27,0.23,284,51315,70,NULL,NULL,'2MASX J14050294+2413500',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000186,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,211.26225,24.23047,0,NULL,59472127357,929251989,14519562,16.4),(116787,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116787,35.21,0.46,110,51316,70,NULL,NULL,'CGCG 103-066',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000157,NULL,'14.9',1,NULL,NULL,NULL,NULL,NULL,1,211.267458333,16.58208,0,NULL,58356940723,911827198,14247299,14.9),(116788,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116788,36.95,0.46,246,51317,70,NULL,NULL,'2MASX J14050552+1128318',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000191,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,211.2730417,11.47542,0,NULL,58490569054,913915141,14279924,16.2),(116789,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116789,35.51,0.33,127,51318,70,NULL,NULL,'2MASX J14050556+2100438',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.35',0.2,NULL,NULL,NULL,NULL,NULL,1,211.273166667,21.01206,0.038,NULL,59465816857,929153388,14518021,17.35),(116790,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116790,37.42,0.46,305,51319,70,NULL,NULL,'2MASX J14050631+5115243',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000204,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.276333333,51.25672,0.014,NULL,59250482303,925788785,14465449,16.5),(116791,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116791,35.34,0.2,117,51320,74.4,NULL,NULL,'UGC 09009',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.52',0.3,'S?',NULL,NULL,NULL,NULL,1,211.2772917,15.77467,0,NULL,58357313049,911833016,14247390,15.52),(116792,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116792,37.56,0.21,326,51321,70,NULL,NULL,'2MASX J14050661+4631501',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,211.277583,46.53061,0,NULL,59234502688,925539104,14461548,16.3),(116793,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116793,37.56,0.21,326,51322,70,NULL,NULL,'2MASX J14050796+4632561',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.283291667,46.54903,0,NULL,59234509846,925539216,14461550,17.3),(116794,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116794,37.54,0.46,323,51323,70,NULL,NULL,'2MASX J14050807+3349001',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.283541667,33.81681,0,NULL,60036700653,938073447,14657397,18.4),(116795,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116795,35.21,0.5,110,51324,70,NULL,NULL,'2MASX J14050967-3245513',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.4b',0.3,'S0',NULL,NULL,NULL,NULL,1,211.290333,-32.76425,0.249,NULL,47002189321,734409208,11475143,16.4),(116796,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116796,37.2,0.33,275,51325,70,NULL,NULL,'2MASX J14051020+0322233',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.292417,3.37325,0.057,NULL,58478077415,913719959,14276874,16.4),(116797,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116797,37.8,0.46,363,51326,70,NULL,NULL,'2MASX J14051042+2431232',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.2934583,24.52311,0.012,NULL,59467906413,929186037,14518531,17.3),(116798,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116798,37.3,0.46,288,51327,70,NULL,NULL,'2MASXi J1405106+223543',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.294417,22.59592,0,NULL,59475202203,929300034,14520313,17.5),(116799,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116799,37.54,0.46,322,51328,70,NULL,NULL,'SDSS J140511.06+375030.6',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.6g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.296125,37.84183,0,NULL,59143803016,924121922,14439405,16.6),(116800,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116800,30.51,0.69,12.6,51329,100,NULL,'mid-IR','CGCG 018-043',NULL,'2013ApJ...771...88L',2013,1,1.8,NULL,'G',0.00001,NULL,'14.50',1.1,'(R)Sa pec?',NULL,NULL,NULL,NULL,1,211.296791667,-3.36983,0.077,NULL,43727740000,683245937,10675717,14.5),(116801,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116801,32.45,NULL,30.9,51329,72,NULL,NULL,'CGCG 018-043',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116802,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116802,37.35,0.33,296,51330,70,NULL,NULL,'2MASX J14051220+5425444',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,211.301167,54.42897,0,NULL,57281687096,895026360,13984786,18.2),(116803,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116803,39.03,0.46,639,51331,70,NULL,NULL,'SDSS J140513.84+482034.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.3077083,48.343,0.048,NULL,59243505316,925679770,14463746,18.3),(116804,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116804,38.5,0.46,502,51332,70,NULL,NULL,'SDSS J140514.78+174913.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.311583,17.82028,0,NULL,58372281197,912066893,14251045,18.5),(116805,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116805,37.56,0.21,326,51333,70,NULL,NULL,'2MASX J14051478+4621451',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.311583,46.36258,0,NULL,59234493873,925538966,14461546,17.6),(116806,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116806,38.26,0.46,449,51334,70,NULL,NULL,'2MASX J14051550+5244352',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.314875,52.74297,0,NULL,59249157855,925768091,14465126,17.7),(116807,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116807,35.51,0.33,127,51335,70,NULL,NULL,'CGCG 132-074',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000077,NULL,'15.6',0.36,NULL,NULL,NULL,NULL,NULL,1,211.319875,21.04428,0.038,NULL,59465815761,929153371,14518021,15.6),(116808,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116808,36.24,0.46,177,51336,70,NULL,NULL,'2MASX J14051707+2441283',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.321125,24.69108,0,NULL,60001621388,937525334,14648833,16.6),(116809,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116809,38.01,0.46,400,51337,70,NULL,NULL,'2MASX J14051930+2637013',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.90',0.15,NULL,NULL,NULL,NULL,NULL,1,211.330417,26.61708,0,NULL,60011541753,937680339,14651255,17.9),(116810,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116810,37.98,0.46,394,51338,70,NULL,NULL,'SDSS J140519.80+240515.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.3325,24.08778,0,NULL,59472307532,929254805,14519606,18.1),(116811,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116811,38.01,0.46,400,51339,70,NULL,NULL,'2MASX J14052020+0926117',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,211.3339583,9.43647,0,NULL,58509002985,914203171,14284424,18.42),(116812,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116812,38.5,0.46,502,51340,70,NULL,NULL,'2MASX J14052181+3317161',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.340833,33.28775,0,NULL,60036554965,938071171,14657362,17.7),(116813,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116813,37.75,0.46,355,51341,70,NULL,NULL,'2MASX J14052179+4357332',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.340833,43.95917,0,NULL,59233927229,925530112,14461408,17.5),(116814,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116814,36.82,0.46,231,51342,70,NULL,NULL,'2MASX J14052194+1718308',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.39',0.16,NULL,NULL,NULL,NULL,NULL,1,211.341375,17.30861,0,NULL,58372727610,912073868,14251154,18.39),(116815,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116815,31.45,0.8,19.5,51343,75,NULL,'MAT, I','IC 4362',NULL,'1997ApJS..109..333W',1997,1,1.7,'This is a part of the galaxy IC 4362.','G',0.000033,NULL,'13.40',0.7,'SBc',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,211.342583333,-41.81897,0.249,NULL,46912140468,733002194,11453159,13.4),(116816,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116816,31.2,0.32,17.4,51343,85,NULL,'I, inv','IC 4362',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116817,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116817,31.22,0.32,17.5,51343,85,NULL,'I, raw','IC 4362',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116818,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116818,31.27,0.2,18,51343,74.4,NULL,NULL,'IC 4362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116819,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116819,31.55,0.43,20.4,51343,75,NULL,'MAT, I, raw','IC 4362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116820,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116820,31.57,0.43,20.6,51343,75,NULL,'MAT, I, inv','IC 4362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116821,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116821,31.76,0.54,22.4,51343,NULL,NULL,NULL,'IC 4362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116822,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116822,31.91,0.43,24.1,51343,75,NULL,'MAT, I, cor','IC 4362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116823,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116823,31.97,0.49,24.7,51343,NULL,NULL,'Malmquist cor.','IC 4362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116824,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116824,32.21,0.49,27.7,51343,75,NULL,'IR','IC 4362',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116825,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116825,33.93,0.47,61.2,51344,70,NULL,NULL,'2MASX J14052251-2908282',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000037,NULL,'15.2b',0.7,'E',NULL,NULL,NULL,NULL,1,211.343791667,-29.14111,0.165,NULL,46982286118,734098220,11470284,15.2),(116826,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116826,38.67,0.46,542,51345,70,NULL,NULL,'2MASX J14052250+5915474',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.343916667,59.26317,0,NULL,57271733223,894870831,13982356,18),(116827,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116827,37.94,0.46,388,51346,70,NULL,NULL,'2MASX J14052279+1153257',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.344875,11.89053,0,NULL,58490177294,913909020,14279828,17.5),(116828,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116828,33.72,0.47,55.5,51347,NULL,NULL,'H','IC 4359',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'13.82',0.9,'SA(rs)bc',NULL,NULL,NULL,NULL,1,211.3472083,-45.26978,0.273,NULL,46799222763,731237855,11425591,13.82),(116829,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116829,33.82,0.46,58.2,51347,NULL,NULL,'J','IC 4359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116830,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116830,33.83,0.45,58.3,51347,NULL,NULL,'K','IC 4359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116831,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116831,33.86,0.4,59.1,51347,NULL,NULL,'mean','IC 4359',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116832,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116832,36.42,0.69,192,51348,70,NULL,NULL,'CGCG 018-045',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000097,NULL,'15.5g',0.35,'NLAGN',NULL,NULL,NULL,NULL,1,211.35525,-0.81133,0.141,NULL,43588684571,681073196,10641768,15.5),(116833,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116833,37.2,0.33,275,51349,70,NULL,NULL,'2MASX J14052671+0315416',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.36125,3.26158,0.057,NULL,58478091322,913720176,14276877,16.9),(116834,'CMD','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116834,16.1,NULL,0.0166,51350,NULL,NULL,NULL,'NGC 5466',NULL,'2008A&A...477..139L',2008,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.364,28.5345,0,0,60006465394,937601021,14650015,NULL),(116835,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116835,35.38,0.46,119,51351,70,NULL,NULL,'UGC 09012',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000097,NULL,'15.5',0.6,'S0            AGN?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,211.3680417,30.76722,0,NULL,60050354108,938286782,14660730,15.5),(116836,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116836,35.23,0.49,111,51352,75,NULL,'IR','UGC 09014',NULL,'2011yCatp016004901K',2011,1,1.64,'RC3 gives an HI velocity of 9,991 km/sec.','G',0.000093,NULL,'14.9g',0.29,'S?',NULL,NULL,NULL,NULL,1,211.369833333,34.92197,0,NULL,60036097240,938064019,14657250,14.9),(116837,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116837,35.68,0.47,137,51352,NULL,NULL,'H','UGC 09014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116838,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116838,35.81,0.45,145,51352,NULL,NULL,'K','UGC 09014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116839,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116839,35.82,0.4,146,51352,NULL,NULL,'mean','UGC 09014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116840,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116840,35.91,0.46,152,51352,NULL,NULL,'J','UGC 09014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116841,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116841,37.46,0.46,311,51353,70,NULL,NULL,'2MASX J14052932+3703451',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.372375,37.0625,0,NULL,59142814981,924106484,14439163,17.2),(116842,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116842,36.86,0.46,236,51354,70,NULL,NULL,'2MASX J14053105+2932303',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.42',0.16,'E',NULL,NULL,NULL,NULL,1,211.379333333,29.54186,0,NULL,60006277262,937598082,14649970,18.42),(116843,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116843,36.63,0.53,212,51355,70,NULL,NULL,'ESO 578- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.53',0.5,'S0',NULL,NULL,NULL,NULL,1,211.3797083,-22.23975,0.201,NULL,46522977367,726921521,11358148,15.53),(116844,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116844,33.76,0.2,56.5,51356,74.4,NULL,NULL,'CGCG 074-095',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000103,NULL,'15.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.380041667,12.44653,0,NULL,58360068638,911876072,14248063,15.6),(116845,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116845,37.79,0.46,361,51357,70,NULL,NULL,'2MASX J14053137+4325092',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.3805417,43.41928,0,NULL,59237459938,925585311,14462270,17.5),(116846,'Brightest Stars','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116846,29.43,NULL,7.7,51358,NULL,NULL,NULL,'NGC 5477',NULL,'1994BSAO...38....5K',1994,1,1.7,'May be associated with MESSIER 101. Multiple SDSS entries describe this object.','G',0.000017,NULL,'14.36',1.3,'SA(s)m','in a radial-velocity based grouping',NULL,NULL,NULL,1,211.38875,54.46114,0,NULL,57298523957,895289436,13988897,14.36),(116847,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116847,29.15,0.1,6.76,51358,74.4,NULL,NULL,'NGC 5477',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116848,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116848,29.15,0.13,6.77,51358,NULL,NULL,NULL,'NGC 5477',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116849,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116849,28.71,0.16,5.52,51358,NULL,NULL,'Method 2','NGC 5477',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116850,'HII region diameter','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116850,29,0.09,6.31,51358,NULL,NULL,'Method 1','NGC 5477',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116851,'Magnitude','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116851,30.39,0.16,12,51358,NULL,NULL,NULL,'NGC 5477',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116852,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116852,29.01,0.8,6.4,51358,75,NULL,'B','NGC 5477',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116853,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116853,37.71,0.46,348,51359,70,NULL,NULL,'2MASX J14053333+3415314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.388917,34.25864,0,NULL,60035685715,938057589,14657149,17.6),(116854,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116854,37.84,0.46,371,51360,70,NULL,NULL,'2MASX J14053418+1812087',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,211.392458333,18.20253,0.012,NULL,58372133489,912064585,14251009,18.77),(116855,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116855,37.6,0.15,331,51361,70,NULL,NULL,'2MASX J14053453+0615077',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.394083333,6.25206,0.05,NULL,58511774700,914246479,14285101,17.2),(116856,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116856,37.64,0.33,337,51362,70,NULL,NULL,'SDSS J140535.06+355735.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,211.396083333,35.96,0,NULL,59153380191,924271565,14441743,18.4),(116857,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116857,36.95,0.46,246,51363,70,NULL,NULL,'2MASX J14053517+2421183',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000164,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.3964583,24.35522,0,NULL,59467916579,929186196,14518534,16.8),(116858,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116858,36.65,0.46,214,51364,70,NULL,NULL,'2MASX J14053661+2024567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.27',0.16,NULL,NULL,NULL,NULL,NULL,1,211.4024583,20.41592,0.045,NULL,59466789020,929168578,14518259,17.27),(116859,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116859,37.6,0.15,331,51365,70,NULL,NULL,'2MASX J14053662+0619377',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.402583,6.32719,0.041,NULL,58511759958,914246249,14285097,17.2),(116860,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116860,37.56,0.21,326,51366,70,NULL,NULL,'2MASX J14053826+4623281',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000185,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.409291667,46.39114,0,NULL,59234499846,925539060,14461547,16.5),(116861,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116861,37.23,0.46,279,51367,70,NULL,NULL,'2MASX J14053933+0138446',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000073,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.4139583,1.64564,0.081,NULL,58402823873,912544123,14258501,17.1),(116862,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116862,38.73,0.33,556,51368,70,NULL,NULL,'SDSS J140540.19+034710.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000104,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.4175,3.78636,0.049,NULL,58478125113,913720704,14276886,18.6),(116863,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116863,37.78,0.46,360,51369,70,NULL,NULL,'2MASX J14054062+5906584',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000187,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.419417,59.11617,0,NULL,57272144831,894877262,13982457,17.3),(116864,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116864,37.69,0.46,345,51370,70,NULL,NULL,'SDSS J140543.17+365537.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.429917,36.92714,0,NULL,59142775129,924105861,14439154,18.4),(116865,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116865,35.48,0.27,124,51371,70,NULL,NULL,'2MASX J14054358+6534315',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000095,NULL,'15.9g',0.29,'E0',NULL,NULL,NULL,NULL,1,211.43125,65.57553,0.053,NULL,57945594896,905399920,14146873,15.9),(116866,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116866,37.46,0.46,311,51372,70,NULL,NULL,'2MASX J14054484+4147567',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.437,41.79894,0,NULL,59258795730,925918683,14467479,17.2),(116867,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116867,37.06,0.56,258,51373,70,NULL,NULL,'2MASX J14054546-2718126',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'15.3',0.4,'E',NULL,NULL,NULL,NULL,1,211.439375,-27.30353,0.201,NULL,46989126293,734205098,11471954,15.3),(116868,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116868,37.01,0.46,252,51374,70,NULL,NULL,'SDSS J140546.66+094151.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.80',0.2,NULL,NULL,NULL,NULL,NULL,1,211.444458333,9.69775,0,NULL,58509155959,914205561,14284461,17.8),(116869,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116869,38.21,0.46,439,51375,70,NULL,NULL,'SDSS J140548.71+095446.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.453,9.913,0,NULL,58508777586,914199649,14284369,18.4),(116870,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116870,37.38,0.46,299,51376,70,NULL,NULL,'2MASX J14055076+0303553',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.4615,3.06533,0.057,NULL,58478035246,913719300,14276864,17.4),(116871,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116871,35.87,0.46,149,51377,70,NULL,NULL,'CGCG 272-026',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000103,NULL,'15.0g',0.48,'E0',NULL,NULL,NULL,NULL,1,211.468333,53.129,0,NULL,59215318525,925239351,14456864,15),(116872,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116872,35.48,0.27,124,51378,70,NULL,NULL,'SDSS J140553.34+654227.7',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.4g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.4722917,65.70772,0.053,NULL,57945577086,905399641,14146869,15.4),(116873,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116873,36.75,0.46,223,51379,70,NULL,NULL,'2MASX J14055348+3310145',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.31',0.25,NULL,NULL,NULL,NULL,NULL,1,211.4730417,33.17086,0,NULL,60036549405,938071084,14657360,16.31),(116874,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116874,36.58,0.46,207,51380,70,NULL,NULL,'2MASX J14055380+4821555',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'15.4g',0.53,NULL,NULL,NULL,NULL,NULL,1,211.474208333,48.36558,0.057,NULL,59241674497,925651164,14463299,15.4),(116875,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116875,36.64,0.46,212,51381,70,NULL,NULL,'2MASX J14055393-0044435',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00009,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.474666667,-0.74542,0.141,NULL,43589076697,681079323,10641864,16.5),(116876,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116876,38.07,0.46,411,51382,70,NULL,NULL,'2MASX J14055604+1751548',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.483583333,17.86511,0,NULL,58355368682,911802635,14246916,NULL),(116877,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116877,35.05,0.57,102,51383,70,NULL,NULL,'MCG -02-36-016',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.2b',0.3,NULL,NULL,NULL,NULL,NULL,1,211.487083,-15.29867,0.325,NULL,43648215175,682003362,10656302,15.2),(116878,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116878,36.28,0.46,181,51384,70,NULL,NULL,'2MASX J14055724+2648530',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,211.488625,26.81475,0,NULL,60011556261,937680566,14651258,16.4),(116879,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116879,35.48,0.27,124,51385,70,NULL,NULL,'NGC 5479',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000093,NULL,'14.6g',0.77,'E0             AGN',NULL,NULL,NULL,NULL,1,211.4890417,65.69075,0.053,NULL,57945606963,905400108,14146876,14.6),(116880,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116880,37.28,0.46,285,51386,70,NULL,NULL,'2MASX J14055761+1127404',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.490167,11.46131,0,NULL,58490367616,913911994,14279874,17.5),(116881,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116881,35.39,0.65,120,51387,70,NULL,NULL,'MCG -02-36-015',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000127,NULL,'14.61',0.6,NULL,NULL,NULL,NULL,NULL,1,211.491916667,-12.07275,0.157,NULL,43713518177,683023721,10672245,14.61),(116882,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116882,38.01,0.46,400,51388,70,NULL,NULL,'2MASX J14055834+2438390',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.493167,24.64414,0,NULL,60001644286,937525691,14648838,17.2),(116883,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116883,37.27,0.46,284,51389,70,NULL,NULL,'2MASX J14055940+6251209',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.497333,62.85575,0.025,NULL,57750680270,902354379,14099287,17.3),(116884,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116884,36.24,0.46,177,51390,70,NULL,NULL,'2MASX J14060177+2715220',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.507375,27.25625,0,NULL,60008624042,937634750,14650542,16.9),(116885,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116885,38.26,0.46,448,51391,70,NULL,NULL,'2MASX J14060191+0944394',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.508083333,9.74414,0,NULL,58509288142,914207627,14284494,17.2),(116886,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116886,37.64,0.33,337,51392,70,NULL,NULL,'2MASX J14060222+3559167',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.5092917,35.98789,0,NULL,59153325167,924270705,14441729,17.8),(116887,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116887,36.59,0.46,208,51393,70,NULL,NULL,'2MASX J14060254+1856068',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.84',0.21,NULL,NULL,NULL,NULL,NULL,1,211.510583,18.93519,0.034,NULL,59462848432,929107006,14517296,16.84),(116888,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116888,37.36,0.46,297,51394,70,NULL,NULL,'2MASX J14060369+1701538',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.90',0.22,NULL,NULL,NULL,NULL,NULL,1,211.5155,17.03164,0,NULL,58355871369,911810490,14247038,17.9),(116889,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116889,36.15,0.46,170,51395,70,NULL,NULL,'2MASX J14060375+1230158',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.59',0.23,NULL,NULL,NULL,NULL,NULL,1,211.5157083,12.5045,0,NULL,58359827637,911872306,14248004,17.59),(116890,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116890,34.05,0.2,64.6,51396,74.4,NULL,NULL,'KUG 1403+120',NULL,'2013AJ....146...86T',2013,1,1.06,NULL,'G',0.00012,NULL,'15.2g',0.48,'Spiral',NULL,NULL,NULL,NULL,1,211.527041667,11.78883,0,NULL,58490266220,913910409,14279850,15.2),(116891,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116891,37.1,0.46,263,51397,70,NULL,NULL,'2MASX J14060665+5824104',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.5280417,58.40297,0,NULL,57304499058,895382797,13990356,17.7),(116892,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116892,33.26,0.4,44.9,51398,75,NULL,'Edat, raw','ESO 384- G 049',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00004,NULL,'14.06',0.7,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,211.5290417,-33.92344,0.213,NULL,47005155088,734455548,11475867,14.06),(116893,'D-Sigma','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116893,33.44,0.4,48.7,51398,75,NULL,'Edat, cor','ESO 384- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116894,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116894,33.77,0.23,56.8,51398,74.4,NULL,NULL,'ESO 384- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116895,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116895,33.95,0.47,61.6,51398,70,NULL,NULL,'ESO 384- G 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116896,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116896,32.98,0.25,39.5,51399,74.4,NULL,NULL,'ABELL S0753:[WFC91] 083',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000077,NULL,'16.0b',NULL,'S0',NULL,NULL,NULL,NULL,1,211.5295417,-33.20431,0.261,NULL,47005185446,734456022,11475875,16),(116897,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116897,36.6,0.46,209,51400,70,NULL,NULL,'2MASX J14060795+1812361',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.59',0.15,NULL,NULL,NULL,NULL,NULL,1,211.533125,18.21,0,NULL,58325991609,911343618,14239744,18.59),(116898,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116898,37.56,0.21,326,51401,70,NULL,NULL,'2MASX J14060821+4636095',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,211.5340417,46.60256,0,NULL,59234467401,925538553,14461539,16.4),(116899,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116899,36.74,0.46,223,51402,70,NULL,NULL,'2MASX J14060819+4711235',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.53425,47.18986,0.021,NULL,59242422112,925662845,14463481,16.6),(116900,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116900,37.01,0.46,252,51403,70,NULL,NULL,'2MASX J14061004+0547483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.541917,5.79689,0.029,NULL,58479174666,913737104,14277142,17.6),(116901,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116901,37.16,0.46,271,51404,70,NULL,NULL,'2MASX J14061033+2205061',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,211.543,22.08519,0.005,NULL,59474572700,929290198,14520159,18.44),(116902,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116902,37.63,0.46,336,51405,70,NULL,NULL,'SDSS J140610.61+645241.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,211.54425,64.87814,0.017,NULL,57934546095,905227282,14144176,18.7),(116903,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116903,34.66,0.47,85.5,51406,70,NULL,NULL,'2MASX J14061234-2712454',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000087,NULL,'15.3b',NULL,'S0',NULL,NULL,NULL,NULL,1,211.5514583,-27.21261,0.201,NULL,46989153408,734205522,11471961,15.3),(116904,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116904,37.6,0.46,330,51407,70,NULL,NULL,'2MASX J14061335+0651292',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,211.555625,6.85808,0.024,NULL,58516636782,914322449,14286288,17),(116905,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116905,38.73,0.33,556,51408,70,NULL,NULL,'2MASX J14061432+0346503',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.5597917,3.78058,0.033,NULL,58478104092,913720376,14276880,17.6),(116906,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116906,37.93,0.46,385,51409,70,NULL,NULL,'2MASX J14061436+0633382',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.5597917,6.56056,0.036,NULL,58511718967,914245608,14285087,17.1),(116907,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116907,36.25,0.2,178,51410,74.4,NULL,NULL,'UGC 09019',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'15.26',0.4,'Sbc',NULL,NULL,NULL,NULL,1,211.56275,20.14122,0.039,NULL,59466612530,929165820,14518215,15.26),(116908,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116908,37.6,0.15,331,51411,70,NULL,NULL,'2MASX J14061557+0615372',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000181,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,211.565041667,6.26036,0.05,NULL,58511810729,914247042,14285110,16.4),(116909,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116909,37.97,0.46,392,51412,70,NULL,NULL,'2MASX J14061566+0359393',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000103,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.565417,3.99433,0.025,NULL,58478488401,913726381,14276974,16.8),(116910,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116910,38.54,0.46,509,51413,70,NULL,NULL,'2MASX J14061581+6351211',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.565917,63.856,0,NULL,57935646787,905244481,14144445,17.7),(116911,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116911,37.68,0.46,344,51414,70,NULL,NULL,'2MASX J14061599-0038274',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.566833,-0.64108,0.137,NULL,43589086137,681079470,10641866,17),(116912,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116912,34.87,0.25,94.2,51415,74.4,NULL,NULL,'ESO 510- G 063',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000028,NULL,'14.76',0.5,'SAB(s)0-',NULL,NULL,NULL,NULL,1,211.5669583,-25.79931,0.213,NULL,46990436791,734225574,11472274,14.76),(116913,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116913,37.07,0.96,259,51416,70,NULL,NULL,'2MASX J14061694-3949188',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.570625,-39.82192,0.057,NULL,46909589882,732962341,11452536,15.5),(116914,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116914,37.75,0.46,355,51417,70,NULL,NULL,'2MASX J14061694+2909296',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.83',0.12,NULL,NULL,NULL,NULL,NULL,1,211.570791667,29.15819,0.011,NULL,60006825637,937606650,14650103,18.83),(116915,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116915,37.98,0.46,395,51418,70,NULL,NULL,'2MASX J14061798+4006378',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.574833333,40.1105,0,NULL,59260637596,925947462,14467929,17.7),(116916,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116916,35.37,0.47,119,51419,NULL,NULL,'H','MCG -03-36-006',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.00002,NULL,'15.15',0.5,'Sbc',NULL,NULL,NULL,NULL,1,211.5755,-16.64119,0.277,NULL,43649353607,682021150,10656580,15.15),(116917,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116917,35.51,0.45,126,51419,NULL,NULL,'K','MCG -03-36-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116918,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116918,35.52,0.4,127,51419,NULL,NULL,'mean','MCG -03-36-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116919,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116919,35.53,0.46,128,51419,NULL,NULL,'J','MCG -03-36-006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116920,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116920,37.17,0.46,272,51420,70,NULL,NULL,'2MASX J14061927+4833279',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000194,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.580125,48.55767,0.042,NULL,59256093307,925876457,14466819,16.5),(116921,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116921,37.55,0.33,324,51421,70,NULL,NULL,'2MASX J14061990+5612522',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,211.582833,56.21447,0,NULL,57299756496,895308695,13989198,16.8),(116922,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116922,32.52,0.8,31.9,51422,75,NULL,'CF, r','NGC 5480',NULL,'1997ApJS..109..333W',1997,1,1.63,'UGC misprints dec as +50d39\', as is evident in the UGC notes.','G',0.000017,NULL,'12.8g',1.22,'SA(s)c:','Pair member (points to parent)',NULL,NULL,NULL,1,211.589917,50.72511,0.013,NULL,59250247103,925785110,14465392,12.8),(116923,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116923,32.52,0.8,31.9,51422,75,NULL,'B','NGC 5480',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116924,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116924,31.75,0.38,22.4,51422,75,NULL,'CF, r, raw','NGC 5480',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116925,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116925,31.79,0.38,22.8,51422,75,NULL,'CF, r, inv','NGC 5480',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116926,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116926,32.02,0.38,25.3,51422,75,NULL,'CF, r, cor','NGC 5480',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116927,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116927,32.43,0.45,30.6,51422,NULL,NULL,'K','NGC 5480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116928,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116928,32.44,0.47,30.7,51422,NULL,NULL,'H','NGC 5480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116929,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116929,32.45,0.46,30.9,51422,NULL,NULL,'J','NGC 5480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116930,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116930,32.47,0.4,31.2,51422,NULL,NULL,'mean','NGC 5480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116931,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116931,37.27,0.46,284,51423,70,NULL,NULL,'2MASX J14062279-0013253',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00011,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,211.594875,-0.22367,0.113,NULL,43589162454,681080663,10641885,16.7),(116932,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116932,36.73,0.23,222,51424,70,NULL,NULL,'2MASX J14062318+1539001',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.80',0.19,NULL,NULL,NULL,NULL,NULL,1,211.596667,15.65019,0,NULL,58357410681,911834541,14247414,17.8),(116933,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116933,37.5,0.46,317,51425,70,NULL,NULL,'2MASX J14062534+1303271',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.605583,13.05756,0.036,NULL,58363585784,911931027,14248922,17),(116934,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116934,37.64,0.46,338,51426,70,NULL,NULL,'2MASX J14062529+4858129',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000142,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.605583,48.97022,0.027,NULL,59254261450,925847835,14466372,17.1),(116935,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116935,37.8,0.46,364,51427,70,NULL,NULL,'2MASX J14062588+2232222',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.17,NULL,NULL,NULL,NULL,NULL,1,211.6080417,22.53956,0,NULL,59474987102,929296673,14520260,18.13),(116936,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116936,37.55,0.33,324,51428,70,NULL,NULL,'2MASX J14062760+5608293',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.614917,56.1415,0,NULL,57299728023,895308250,13989191,17.2),(116937,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116937,37.22,0.33,278,51429,70,NULL,NULL,'2MASX J14062816+2622446',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.6174583,26.37906,0,NULL,60010289103,937660767,14650949,17.5),(116938,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116938,37.89,0.46,378,51430,70,NULL,NULL,'2MASX J14062885+1143132',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.6202083,11.72039,0,NULL,58490251479,913910179,14279846,17.8),(116939,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116939,38.76,0.46,565,51431,70,NULL,NULL,'2MASX J14062911+1613181',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.6215417,16.22181,0,NULL,58359126116,911861345,14247833,18.2),(116940,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116940,34.64,0.46,84.6,51432,70,NULL,NULL,'CGCG 219-051',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000143,NULL,'15.0g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,211.6242917,39.49619,0,NULL,59257678514,925901226,14467206,15),(116941,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116941,38.01,0.33,400,51433,70,NULL,NULL,'2MASX J14063028+4156380',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,211.626125,41.94378,0,NULL,59258820512,925919070,14467485,16.1),(116942,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116942,37.6,0.15,331,51434,70,NULL,NULL,'2MASX J14063033+0614452',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,211.626333,6.24592,0.05,NULL,58511813479,914247085,14285110,16.7),(116943,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116943,38.02,0.46,402,51435,70,NULL,NULL,'2MASX J14063131+6104501',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000128,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.630583,61.08067,0,NULL,57262949971,894733593,13980212,17.9),(116944,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116944,37.93,0.46,386,51436,70,NULL,NULL,'2MASX J14063159+0604128',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.6317917,6.07033,0.034,NULL,58479183455,913737241,14277144,17),(116945,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116945,31.54,0.43,20.3,51437,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5470',NULL,'2014MNRAS.444..527S',2014,1,1.52,NULL,'G',0.00003,NULL,'13.8g',0.6,'Sb','Group member of poor cluster',NULL,NULL,NULL,1,211.6329583,6.02969,0.034,NULL,58479197191,913737456,14277147,13.8),(116946,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116946,31.61,0.4,21,51437,75,NULL,NULL,'NGC 5470',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116947,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116947,31.68,0.4,21.7,51437,NULL,NULL,'mean','NGC 5470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116948,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116948,31.96,NULL,24.7,51437,72,NULL,NULL,'NGC 5470',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116949,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116949,32.04,0.46,25.5,51437,NULL,NULL,'J','NGC 5470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116950,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116950,32.04,0.47,25.6,51437,NULL,NULL,'H','NGC 5470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116951,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116951,32.08,0.45,26,51437,NULL,NULL,'K','NGC 5470',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116952,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116952,32.11,0.49,26.5,51437,75,NULL,'IR','NGC 5470',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116953,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116953,37.91,0.46,382,51438,70,NULL,NULL,'2MASX J14063220+1906172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.634083,19.10489,0.032,NULL,59463613992,929118968,14517483,17.7),(116954,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116954,34.66,0.2,85.5,51439,74.4,NULL,NULL,'UGC 09021',NULL,'2013AJ....146...86T',2013,1,1.29,NULL,'G',0.000033,NULL,'16.1g',0.26,'Sd',NULL,NULL,NULL,NULL,1,211.6345,12.71194,0,NULL,58363477747,911929339,14248895,16.1),(116955,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116955,37.56,0.33,325,51440,70,NULL,NULL,'2MASX J14063361+2502526',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.86',0.2,NULL,NULL,NULL,NULL,NULL,1,211.6400417,25.04783,0,NULL,60001873542,937529274,14648894,17.86),(116956,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116956,36.08,0.53,165,51441,70,NULL,NULL,'ESO 384-IG 052 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000123,NULL,'15.85',NULL,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,211.641416667,-33.58731,0.221,NULL,47005238602,734456853,11475888,15.85),(116957,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116957,35.8,0.46,144,51442,70,NULL,NULL,'2MASX J14063440-0111133',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000106,NULL,'15.4g',0.43,NULL,NULL,NULL,NULL,NULL,1,211.643375,-1.18703,0.161,NULL,43590610700,681103292,10642238,15.4),(116958,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116958,38.03,0.46,404,51443,70,NULL,NULL,'2MASX J14063454+5607553',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.644083333,56.13203,0,NULL,57299727726,895308245,13989191,17.4),(116959,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116959,32.54,0.22,31.9,51444,74.2,NULL,'SALT 2','NGC 5468',0.00948,'2010ApJ...716..712A',2010,1,2.6,'The APM position is 8 arcsec northeast of the nucleus.','G',0.000013,NULL,'12.7B',2.4,'SAB(rs)cd','in a pair',NULL,NULL,NULL,1,211.645375,-5.45311,0.077,NULL,43727637169,683244330,10675692,12.7),(116960,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116960,32.62,0.26,33.1,51444,74.2,NULL,'SALT 2','NGC 5468',0.00948,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116961,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116961,32.9,0.16,37.7,51444,72,NULL,NULL,'NGC 5468',0.00948,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116962,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116962,32.94,0.14,38.4,51444,72,NULL,NULL,'NGC 5468',0.00948,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116963,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116963,33.06,0.04,40.9,51444,72,NULL,'M(H) = -18.317 mag','NGC 5468',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116964,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116964,33.12,0.25,41.7,51444,70,NULL,'SALT 2','NGC 5468',0.00948,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116965,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116965,33.12,0.04,41.7,51444,72,NULL,NULL,'NGC 5468',0.00948,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116966,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116966,33.17,0.28,42.6,51444,72,NULL,NULL,'NGC 5468',0.00948,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116967,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116967,33.2,0.08,43.7,51444,74.4,NULL,NULL,'NGC 5468',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116968,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116968,33.23,0.22,43.8,51444,70,NULL,'SALT','NGC 5468',0.00948,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116969,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116969,33.23,0.03,43.8,51444,72,NULL,'MLCS17','NGC 5468',0.00948,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116970,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116970,33.21,0.17,43.9,51444,70.8,NULL,NULL,'NGC 5468',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116971,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116971,33.3,0.23,45.2,51444,73.8,NULL,'SALT 2 (SNANA)','NGC 5468',0.0103,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116972,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116972,33.3,0.25,45.3,51444,70,NULL,'SALT 2','NGC 5468',0.00948,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116973,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116973,33.36,0.23,46.5,51444,73.8,NULL,'SALT 2 (SNANA)','NGC 5468',0.0105,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116974,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116974,33.41,0.31,47.7,51444,65,NULL,'SALT2','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116975,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116975,33.44,0.3,48.3,51444,65,NULL,'MLCS17','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116976,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116976,33.45,0.03,48.6,51444,72,NULL,NULL,'NGC 5468',0.00948,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116977,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116977,33.46,0.29,48.7,51444,65,NULL,'MLCS17','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116978,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116978,33.49,0.31,49.4,51444,65,NULL,'SALT2','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116979,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116979,33.5,0.29,49.6,51444,65,NULL,'MLCS31','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116980,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116980,33.52,0.1,49.6,51444,65,NULL,'MLCS2k2','NGC 5468',0.00948,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116981,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 2002cr',NULL,116981,33.51,0.29,49.8,51444,65,NULL,'MLCS31','NGC 5468',0.00948,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116982,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116982,33.56,0.13,51,51444,70,NULL,NULL,'NGC 5468',0.00948,'2000ApJ...539..658K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116983,'SNIa','2016-12-15 15:15:21','2016-12-16 11:20:34','1','SN 1999cp',NULL,116983,33.56,0.31,51,51444,65,NULL,NULL,'NGC 5468',0.00948,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116984,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116984,33.09,0.4,41.5,51444,75,NULL,'B','NGC 5468',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116985,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116985,38.01,0.33,400,51445,70,NULL,NULL,'2MASX J14063491+4157445',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.6455,41.96214,0,NULL,59258775960,925918374,14467474,18),(116986,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116986,33.79,0.48,57.2,51446,70,NULL,NULL,'ESO 384- G 053',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000013,NULL,'12.94',2,'SAB(rs)b',NULL,NULL,NULL,NULL,1,211.647875,-34.31161,0.213,NULL,47003120164,734423752,11475371,12.94),(116987,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116987,34.15,0.8,67.5,51446,75,NULL,'MAT, I','ESO 384- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116988,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116988,30.89,0.32,15.1,51446,85,NULL,'I, raw','ESO 384- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116989,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116989,30.89,0.32,15.1,51446,85,NULL,'I, inv','ESO 384- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116990,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116990,31.18,0.43,17.2,51446,75,NULL,'MAT, I, raw','ESO 384- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116991,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116991,31.24,0.43,17.7,51446,75,NULL,'MAT, I, inv','ESO 384- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116992,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116992,31.5,0.43,20,51446,75,NULL,'MAT, I, cor','ESO 384- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116993,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116993,32.22,0.47,27.8,51446,NULL,NULL,'H','ESO 384- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116994,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116994,32.44,0.45,30.7,51446,NULL,NULL,'K','ESO 384- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116995,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116995,32.44,0.46,30.7,51446,NULL,NULL,'J','ESO 384- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116996,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116996,34.07,0.4,65.2,51446,NULL,NULL,'mean','ESO 384- G 053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(116997,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',116997,37.56,0.33,325,51447,70,NULL,NULL,'SDSS J140636.29+245947.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.65125,24.99644,0,NULL,60001872905,937529264,14648894,18.3),(116998,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116998,36.22,0.25,175,51448,74.4,NULL,NULL,'GIN 339',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000053,NULL,'14.61',NULL,'E/S0',NULL,NULL,NULL,NULL,1,211.6520417,-9.22894,0.069,NULL,43748062059,683563469,10680679,14.61),(116999,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,116999,36.44,0.24,194,51448,70,NULL,NULL,'GIN 339',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117000,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117000,38.3,0.46,458,51449,70,NULL,NULL,'SDSS J140639.23+110149.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000165,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.663458333,11.03039,0,NULL,58493466549,913960414,14280631,18.6),(117001,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117001,37.6,0.15,331,51450,70,NULL,NULL,'2MASX J14064026+0616582',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,211.667625,6.28286,0.05,NULL,58511837524,914247461,14285116,16.5),(117002,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117002,38.48,0.46,496,51451,70,NULL,NULL,'SDSS J140640.23+192633.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.667625,19.44261,0.029,NULL,59463470470,929116726,14517448,NULL),(117003,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117003,37.79,0.46,361,51452,70,NULL,NULL,'2MASX J14064047+5923053',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.6687083,59.38483,0.009,NULL,57271824114,894872251,13982378,17.3),(117004,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117004,33.67,0.4,54.1,51453,NULL,NULL,'mean','ESO 175- G 001',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00003,NULL,'13.85',1.2,'(R\')SA(rs)b',NULL,NULL,NULL,NULL,1,211.668625,-55.35731,NULL,NULL,44757211896,699331435,10927053,13.85),(117005,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117005,33.83,0.46,58.3,51453,NULL,NULL,'J','ESO 175- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117006,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117006,33.85,0.47,58.9,51453,NULL,NULL,'H','ESO 175- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117007,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117007,33.91,0.45,60.5,51453,NULL,NULL,'K','ESO 175- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117008,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117008,31.58,0.2,20.7,51454,74.4,NULL,NULL,'UGC 09024',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.000004,NULL,'16.0',2,'S?',NULL,NULL,NULL,NULL,1,211.668917,22.07011,0.027,NULL,59474566750,929290105,14520157,16),(117009,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117009,31.93,0.43,24.4,51454,75,NULL,'3.6 micron, color corrected','UGC 09024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117010,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117010,32.24,0.43,28.1,51454,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09024',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117011,'GCLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117011,31.84,0.56,23.3,51455,NULL,NULL,'HST KP Calibrated, V','NGC 5481',NULL,'2000ApJ...529..745F',2000,1,1.8,NULL,'G',0.000017,NULL,'13.25',1.5,'E+','Pair member (points to parent)',NULL,NULL,NULL,1,211.671958333,50.72333,0.013,NULL,59250261371,925785333,14465395,13.25),(117012,'GCLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117012,31.9,0.5,24,51455,NULL,NULL,NULL,'NGC 5481',NULL,'2000ApJS..128..431F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117013,'GCLF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117013,32.2,0.4,27.5,51455,NULL,NULL,NULL,'NGC 5481',NULL,'1995A&A...297..660M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117014,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117014,32.76,0.8,35.6,51455,75,NULL,'B','NGC 5481',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117015,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117015,32.44,0.4,30.7,51455,NULL,NULL,'mean','NGC 5481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117016,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117016,33.21,0.45,43.8,51455,NULL,NULL,'K','NGC 5481',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117017,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117017,38.37,0.33,472,51456,70,NULL,NULL,'2MASX J14064311+3559340',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000133,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.6797083,35.99281,0,NULL,59141784996,924090390,14438912,17.7),(117018,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117018,36.76,0.46,225,51457,70,NULL,NULL,'2MASX J14064772+2330581',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.54',0.2,NULL,NULL,NULL,NULL,NULL,1,211.6987917,23.51633,0,NULL,59472696396,929260881,14519701,17.54),(117019,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117019,37.76,0.46,356,51458,70,NULL,NULL,'SDSS J140648.10-013844.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.7004583,-1.64567,0.153,NULL,43590024465,681094132,10642095,17.9),(117020,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117020,36.59,0.27,208,51459,70,NULL,NULL,'2MASX J14064878+1842121',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.57',0.14,NULL,NULL,NULL,NULL,NULL,1,211.703417,18.70333,0.02,NULL,59462892409,929107693,14517307,18.57),(117021,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117021,36.59,0.27,208,51460,70,NULL,NULL,'2MASX J14064907+1857541',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.85',0.23,'AGN',NULL,NULL,NULL,NULL,1,211.704583,18.96517,0.032,NULL,59462740646,929105322,14517270,16.85),(117022,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117022,36.59,0.27,208,51461,70,NULL,NULL,'2MASX J14065055+1857201',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.00',0.34,'AGN',NULL,NULL,NULL,NULL,1,211.7107917,18.95558,0.022,NULL,59462740981,929105327,14517270,17),(117023,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117023,37.38,0.46,299,51462,70,NULL,NULL,'2MASX J14065093+0959392',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000162,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.712333,9.99428,0,NULL,58508904340,914201630,14284400,16.7),(117024,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117024,34.96,0.8,98.1,51463,75,NULL,'HMCL, I','UGC 09023',NULL,'1997ApJS..109..333W',1997,1,1.08,NULL,'G',0.00002,NULL,'15.7g',0.38,'Scd:',NULL,NULL,NULL,NULL,1,211.7127917,9.32119,0,NULL,58509092769,914204574,14284446,15.7),(117025,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117025,34.99,0.8,99.4,51463,75,NULL,'CF, r','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117026,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117026,34.46,0.38,78.1,51463,75,NULL,'CF, r, inv','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117027,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117027,34.47,0.38,78.2,51463,75,NULL,'CF, r, raw','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117028,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117028,34.72,0.38,87.8,51463,75,NULL,'CF, r, cor','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117029,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117029,34.81,0.4,91.4,51463,75,NULL,'HMCL, I, raw','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117030,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117030,34.88,0.4,94.7,51463,75,NULL,'HMCL, I, inv','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117031,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117031,34.97,0.4,98.5,51463,75,NULL,'HMCL, I, cor','UGC 09023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117032,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117032,34.98,0.41,99,51463,NULL,NULL,'Malmquist cor.','UGC 09023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117033,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117033,35.04,0.4,102,51463,NULL,NULL,NULL,'UGC 09023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117034,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117034,35.08,0.2,104,51463,74.4,NULL,NULL,'UGC 09023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117035,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117035,33.65,0.23,53.7,51464,74.4,NULL,NULL,'ABELL S0753:[WFC91] 095',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000047,NULL,'14.90',0.6,'E',NULL,NULL,NULL,NULL,1,211.713583,-34.49186,0.197,NULL,47003223182,734425362,11475396,14.9),(117036,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117036,34.28,0.56,71.7,51464,70,NULL,NULL,'ABELL S0753:[WFC91] 095',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117037,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117037,38.53,0.33,509,51465,70,NULL,NULL,'2MASX J14065141+1906181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.714125,19.10508,0.032,NULL,59463603387,929118802,14517481,18.1),(117038,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117038,35.24,0.46,112,51466,70,NULL,NULL,'CGCG 018-049',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000093,NULL,'14.9g',0.61,'E0',NULL,NULL,NULL,NULL,1,211.7147083,-1.54075,0.153,NULL,43590017998,681094031,10642094,14.9),(117039,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117039,33.01,0.47,39.9,51467,NULL,NULL,'H','NGC 5472',NULL,'2007A&A...465...71T',2007,1,1.3,'6dF final data release has z = 0.023299 +- 0.000150.','G',0.000057,NULL,'14.76',0.4,'SA(r)ab? sp','in a pair',NULL,NULL,NULL,1,211.72925,-5.46047,0.077,NULL,43727642179,683244409,10675693,14.76),(117040,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117040,33.14,0.45,42.4,51467,NULL,NULL,'K','NGC 5472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117041,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117041,33.16,0.4,42.9,51467,NULL,NULL,'mean','NGC 5472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117042,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117042,33.22,0.46,44.1,51467,NULL,NULL,'J','NGC 5472',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117043,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117043,37.6,0.15,331,51468,70,NULL,NULL,'SDSS J140655.73+062809.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.73225,6.46928,0.051,NULL,58511688436,914245131,14285080,17.7),(117044,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117044,35.35,0.46,117,51469,70,NULL,NULL,'2MASX J14065594+1024512',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.76',0.21,NULL,NULL,NULL,NULL,NULL,1,211.733,10.41417,0,NULL,58491172547,913924571,14280071,16.76),(117045,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117045,35.38,0.49,119,51470,75,NULL,'IR','UGC 09039',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000027,NULL,'15.32',0.17,'Sc',NULL,NULL,NULL,NULL,1,211.735833,72.12247,0.025,NULL,57896409431,904631397,14134865,15.32),(117046,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117046,35.57,NULL,130,51470,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117047,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117047,35.58,NULL,131,51470,NULL,NULL,'Dipole + Quadrupole','UGC 09039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117048,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117048,35.59,NULL,131,51470,NULL,NULL,'Dipole','UGC 09039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117049,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117049,35.6,NULL,132,51470,NULL,NULL,NULL,'UGC 09039',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117050,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117050,35.97,0.44,156,51470,NULL,NULL,'Malmquist cor.','UGC 09039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117051,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117051,36.4,0.36,191,51470,NULL,NULL,NULL,'UGC 09039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117052,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117052,36.44,0.2,194,51470,74.4,NULL,NULL,'UGC 09039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117053,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117053,36.22,0.46,176,51471,70,NULL,NULL,'2MASX J14065656+0100442',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.735833,1.01211,0.089,NULL,58404759464,912574366,14258974,17.1),(117054,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117054,38.17,0.46,430,51472,70,NULL,NULL,'2MASX J14065723+1014032',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000117,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.738458333,10.23442,0,NULL,58508932392,914202068,14284407,16.8),(117055,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117055,35.06,0.57,103,51473,70,NULL,NULL,'2MASX J14065741-2155309',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.49',NULL,NULL,NULL,NULL,NULL,NULL,1,211.739333333,-21.92544,0.213,NULL,46519401791,726865652,11357275,15.49),(117056,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117056,37.07,0.2,259,51474,74.4,NULL,NULL,'UGC 09025',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.000033,NULL,'15.4g',0.56,'SAB(s)bc',NULL,NULL,NULL,NULL,1,211.7455417,12.56078,0,NULL,58363239812,911925622,14248837,15.4),(117057,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117057,37.37,0.46,297,51475,70,NULL,NULL,'2MASX J14065950+1247387',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.748,12.79406,0,NULL,58363331207,911927050,14248860,17.1),(117058,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117058,37.58,0.46,328,51476,70,NULL,NULL,'2MASX J14070092+0649382',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.7537083,6.82733,0.024,NULL,58515962056,914311907,14286123,17.6),(117059,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117059,37.96,0.46,391,51477,70,NULL,NULL,'2MASX J14070180+1845271',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.7575,18.75764,0.02,NULL,59462760137,929105627,14517275,18),(117060,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117060,37.37,0.33,297,51478,70,NULL,NULL,'2MASX J14070301+4008376',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.762375,40.14378,0,NULL,59257841680,925903776,14467246,16.9),(117061,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117061,37.58,0.46,328,51479,70,NULL,NULL,'2MASX J14070343+4127426',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,211.76425,41.46183,0,NULL,59258742273,925917848,14467466,16.9),(117062,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117062,37.87,0.46,376,51480,70,NULL,NULL,'SDSS J140703.65+232224.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.7652083,23.37344,0,NULL,59472860863,929263450,14519741,18.4),(117063,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117063,37.08,0.33,261,51481,70,NULL,NULL,'2MASX J14070369+0812502',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.76525,8.214,0.02,NULL,58517951110,914342986,14286609,17.4),(117064,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117064,37.18,0.46,272,51482,70,NULL,NULL,'2MASX J14070372+3200401',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.06',0.15,NULL,NULL,NULL,NULL,NULL,1,211.765375,32.01122,0,NULL,60050613692,938290838,14660794,18.06),(117065,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117065,34.82,0.8,92,51483,75,NULL,'HMCL, I','UGC 09027',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000033,NULL,'15.8g',0.24,'S?',NULL,NULL,NULL,NULL,1,211.76675,10.64294,0,NULL,58491189657,913924838,14280075,15.8),(117066,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117066,35.02,0.49,101,51483,75,NULL,'IR','UGC 09027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117067,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117067,35.03,0.43,101,51483,NULL,NULL,'Malmquist cor.','UGC 09027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117068,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117068,35.1,0.4,105,51483,75,NULL,'HMCL, I, raw','UGC 09027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117069,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117069,35.18,0.4,109,51483,75,NULL,'HMCL, I, inv','UGC 09027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117070,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117070,35.2,0.4,110,51483,75,NULL,'HMCL, I, cor','UGC 09027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117071,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117071,35.25,0.39,112,51483,NULL,NULL,NULL,'UGC 09027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117072,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117072,35.29,0.2,114,51483,74.4,NULL,NULL,'UGC 09027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117073,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117073,38.37,0.33,472,51484,70,NULL,NULL,'2MASX J14070400+3600296',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000053,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.7667083,36.00819,0,NULL,60029941326,937967833,14655747,18.4),(117074,'IRAS','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117074,32.65,0.8,33.8,51485,75,NULL,'HMCL, I','NGC 5464',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000022,NULL,'13.33',0.8,'IB(s)m?        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,211.768333,-30.01711,0.229,NULL,47037328038,734958250,11483722,13.33),(117075,'Tully est','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117075,32.87,0.8,37.5,51485,75,NULL,'B','NGC 5464',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117076,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117076,32.13,0.4,26.7,51485,NULL,NULL,NULL,'NGC 5464',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117077,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117077,32.6,0.4,33.2,51485,75,NULL,'HMCL, I, raw','NGC 5464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117078,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117078,32.67,0.4,34.2,51485,75,NULL,'HMCL, I, inv','NGC 5464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117079,'Tully-Fisher','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117079,32.85,0.4,37.2,51485,75,NULL,'HMCL, I, cor','NGC 5464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117080,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117080,36.33,0.46,184,51486,70,NULL,NULL,'2MASX J14070780+2437101',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,211.782625,24.61958,0,NULL,59468042226,929188159,14518564,17.9),(117081,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117081,36.12,0.62,168,51487,70,NULL,NULL,'2MASX J14070813-1231015',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,211.78425,-12.51728,0.157,NULL,43645189822,681956090,10655563,15.8),(117082,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117082,38.53,0.46,508,51488,70,NULL,NULL,'SDSS J140708.82+502453.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.7867917,50.41475,0,NULL,59250199715,925784370,14465380,18.3),(117083,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117083,36.73,0.23,222,51489,70,NULL,NULL,'IC 0975',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00011,NULL,'15.6',0.27,NULL,NULL,NULL,NULL,NULL,1,211.786833,15.31808,0,NULL,58356847727,911825745,14247277,15.6),(117084,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117084,38.12,0.46,420,51490,70,NULL,NULL,'2MASX J14070917+5356584',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.788333,53.94969,0,NULL,59215244654,925238197,14456846,18.1),(117085,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117085,37.76,0.14,356,51491,70,NULL,NULL,'2MASX J14070976+0520132',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'FoF','17.90',0.19,NULL,NULL,NULL,NULL,NULL,1,211.790708333,5.33694,0.029,NULL,58479945661,913749150,14277330,17.9),(117086,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117086,37.22,0.33,278,51492,70,NULL,NULL,'2MASX J14070983+2618481',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000205,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,211.790917,26.31344,0,NULL,60010322302,937661285,14650957,16),(117087,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117087,38.23,0.27,442,51493,70,NULL,NULL,'2MASX J14071031+0820297',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,211.7929583,8.34164,0.02,NULL,58517947155,914342924,14286608,18.4),(117088,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117088,26.39,NULL,1.9,51494,NULL,NULL,NULL,'KKR 03',NULL,'2004AJ....127.2031K',2004,1,0.6,NULL,'G',0.000001,NULL,'17.90',0.5,'dwarf Irr',NULL,NULL,NULL,NULL,1,211.793833333,35.06036,0,1,60035369656,938052650,14657072,17.9),(117089,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117089,26.42,NULL,1.92,51494,NULL,NULL,NULL,'KKR 03',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117090,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117090,26.47,0.1,1.97,51494,NULL,NULL,NULL,'KKR 03',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117091,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117091,26.47,0.06,1.97,51494,NULL,NULL,'I','KKR 03',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117092,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117092,26.48,0.18,1.98,51494,NULL,NULL,NULL,'KKR 03',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117093,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117093,26.55,0.27,2.04,51494,NULL,NULL,NULL,'KKR 03',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117094,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117094,26.64,0.08,2.12,51494,74.4,NULL,NULL,'KKR 03',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117095,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117095,26.65,0.08,2.14,51494,NULL,NULL,NULL,'KKR 03',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117096,'TRGB','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117096,26.7,0.12,2.19,51494,NULL,NULL,'I','KKR 03',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117097,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117097,37.59,0.27,330,51495,70,NULL,NULL,'2MASX J14071082+2948071',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.11',0.17,NULL,NULL,NULL,NULL,NULL,1,211.7949583,29.80197,0,NULL,60051522396,938305037,14661016,18.11),(117098,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117098,36.73,0.23,222,51496,70,NULL,NULL,'2MASX J14071096+1516057',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,211.795667,15.26831,0,NULL,58356799472,911824991,14247265,17.7),(117099,'FP','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,'R',117099,36.79,0.19,228,51497,70,NULL,NULL,'2MASX J14071109-0052429',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000087,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,211.796291667,-0.87864,0.137,NULL,43591211441,681112678,10642385,16.1),(117100,'SBF','2016-12-15 15:15:21','2016-12-16 11:20:34','1',NULL,NULL,117100,32.07,0.34,25.9,51498,NULL,NULL,'I','NGC 5485',NULL,'2001ApJ...546..681T',2001,1,2.13,NULL,'G',0.000017,NULL,'12.4g',1.51,'SA0 pec','in a radial-velocity based grouping',NULL,NULL,NULL,1,211.7972917,55.00169,0,NULL,57299227918,895300436,13989069,12.4),(117101,'SBF','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117101,32.07,0.34,25.9,51498,NULL,NULL,NULL,'NGC 5485',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117102,'SBF','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117102,32.13,0.14,26.7,51498,74.4,NULL,NULL,'NGC 5485',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117103,'SBF','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117103,32.3,0.34,28.8,51498,NULL,NULL,'Malmquist cor.','NGC 5485',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117104,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117104,31.99,0.4,25,51498,75,NULL,'Edat, raw','NGC 5485',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117105,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117105,32.32,0.4,29.2,51498,75,NULL,'Edat, cor','NGC 5485',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117106,'Faber-Jackson','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117106,31.64,0.65,21.3,51498,95,NULL,'Weighted Mean','NGC 5485',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117107,'Faber-Jackson','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117107,33.01,0.81,40,51498,55,NULL,'Visvanathan & Sandage 1979','NGC 5485',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117108,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117108,31.93,0.41,24.3,51498,NULL,NULL,NULL,'NGC 5485',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117109,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117109,32.23,0.41,28,51498,NULL,NULL,'Malmquist cor.','NGC 5485',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117110,'Tertiary','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117110,31.87,0.29,23.7,51498,95,NULL,NULL,'NGC 5485',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117111,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117111,32.58,0.8,32.8,51498,75,NULL,'B','NGC 5485',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117112,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117112,32.35,0.4,29.5,51498,NULL,NULL,'mean','NGC 5485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117113,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117113,32.39,0.45,30,51498,NULL,NULL,'K','NGC 5485',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117114,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117114,37.76,0.14,356,51499,70,NULL,NULL,'2MASX J14071183+0515522',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.7992917,5.26439,0.037,NULL,58479678771,913744980,14277265,17.1),(117115,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117115,38.01,0.46,400,51500,70,NULL,NULL,'SDSS J140711.94+003112.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,211.79975,0.52019,0.097,NULL,58403974276,912562098,14258782,17.8),(117116,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117116,37.37,0.33,297,51501,70,NULL,NULL,'2MASX J14071296+4001556',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000198,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,211.803875,40.03203,0,NULL,59257832753,925903636,14467244,16.4),(117117,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117117,38.23,0.27,442,51502,70,NULL,NULL,'2MASX J14071449+0822177',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PHOT','18.34',0.14,'BrClG',NULL,NULL,NULL,NULL,1,211.8104583,8.37161,0.02,NULL,58517488215,914335753,14286496,18.34),(117118,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117118,37.35,0.46,295,51503,70,NULL,NULL,'2MASX J14071462+4905373',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.811125,49.09361,0.057,NULL,59256227980,925878562,14466852,16.6),(117119,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117119,38.08,0.46,413,51504,70,NULL,NULL,'2MASX J14071483+4331480',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.811916667,43.53003,0,NULL,59238158323,925596223,14462440,17.7),(117120,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','PS1 SN PS10jl','N',117120,42.05,0.22,1680,51505,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jl HOST',0.5304,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117121,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117121,36.85,0.46,234,51506,70,NULL,NULL,'2MASX J14071502+1248567',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,211.8125417,12.81569,0,NULL,58363346321,911927286,14248863,16.5),(117122,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117122,37.08,0.33,261,51507,70,NULL,NULL,'2MASX J14071538+0801107',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.814125,8.01969,0.01,NULL,58517969574,914343274,14286613,17.5),(117123,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117123,34.71,0.25,87.5,51508,74.4,NULL,NULL,'ESO 510- G 066',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000017,NULL,'14.15',1,'SA(rs)0-',NULL,NULL,NULL,NULL,1,211.815333,-27.158,0.193,NULL,46989302747,734207855,11471997,14.15),(117124,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117124,35.17,0.4,108,51508,NULL,NULL,'mean','ESO 510- G 066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117125,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117125,35.27,0.45,113,51508,NULL,NULL,'K','ESO 510- G 066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117126,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117126,38.39,0.23,477,51509,70,NULL,NULL,'SDSS J140716.57+073206.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.8190417,7.53511,0.011,NULL,58516165957,914315093,14286173,18.6),(117127,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117127,37.35,0.46,295,51510,70,NULL,NULL,'2MASX J14071740+2929587',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.822375,29.49967,0,NULL,60006268731,937597948,14649967,17.3),(117128,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117128,37.59,0.27,330,51511,70,NULL,NULL,'2MASX J14071761+2939157',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.9g',0.32,'E',NULL,NULL,NULL,NULL,1,211.823375,29.65447,0,NULL,60006233620,937597400,14649959,16.9),(117129,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117129,38.23,0.27,442,51512,70,NULL,NULL,'2MASX J14071800+0822247',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.824958333,8.37356,0.02,NULL,58517490949,914335796,14286496,17.7),(117130,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117130,35.21,0.46,110,51513,70,NULL,NULL,'CGCG 074-113',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00017,NULL,'15.4g',0.5,'S0',NULL,NULL,NULL,NULL,1,211.826208333,12.88722,0,NULL,58363287390,911926365,14248849,15.4),(117131,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117131,37.11,0.46,264,51514,70,NULL,NULL,'2MASX J14071870+2517317',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.35',0.21,NULL,NULL,NULL,NULL,NULL,1,211.827917,25.29217,0,NULL,60002494263,937538972,14649046,17.35),(117132,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117132,37.86,0.46,373,51515,70,NULL,NULL,'2MASX J14071890+0711457',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000205,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.828833,7.19606,0,NULL,58516798354,914324974,14286327,16.9),(117133,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117133,34.51,0.48,79.8,51516,70,NULL,NULL,'ESO 446- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00008,NULL,'15.5',0.4,'Sa-b',NULL,NULL,NULL,NULL,1,211.833917,-28.96981,0.153,NULL,46982432837,734100513,11470320,15.5),(117134,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117134,35.07,0.25,103,51517,74.4,NULL,NULL,'2MASX J14072087-2700403',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000022,NULL,'14.6',NULL,'E',NULL,NULL,NULL,NULL,1,211.8369583,-27.01131,0.177,NULL,46989288999,734207640,11471994,14.6),(117135,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117135,37.59,0.27,330,51518,70,NULL,NULL,'2MASX J14072167+2938397',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00012,NULL,'16.6g',0.33,'E',NULL,NULL,NULL,NULL,1,211.8402083,29.64425,0,NULL,60006229265,937597332,14649958,16.6),(117136,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117136,38.01,0.46,400,51519,70,NULL,NULL,'2MASX J14072403+0239092',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000092,NULL,'17.7g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,211.850041667,2.65264,0.057,NULL,58470930554,913608289,14275129,17.7),(117137,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117137,37.5,0.46,316,51520,70,NULL,NULL,'SDSS J140724.72+541059.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,211.8530417,54.18322,0,NULL,57281634748,895025542,13984774,18.1),(117138,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117138,31.95,0.8,24.5,51521,75,NULL,'A82, H','NGC 5486',NULL,'1997ApJS..109..333W',1997,1,1.68,NULL,'G',0.000017,NULL,'14.0g',0.95,'SA(s)m:','in a pair',NULL,NULL,NULL,1,211.854,55.10308,0,NULL,57298721786,895292527,13988945,14),(117139,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117139,32.04,0.4,25.6,51521,75,NULL,'B','NGC 5486',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117140,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117140,32.96,0.47,39.1,51521,75,NULL,'A82, H, inv','NGC 5486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117141,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117141,33,0.47,39.8,51521,75,NULL,'A82, H, raw','NGC 5486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117142,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117142,33.13,0.47,42.2,51521,75,NULL,'A82, H, cor','NGC 5486',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117143,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','PS1 SN PS10ig','N',117143,40.66,0.15,1070,51522,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ig HOST',0.2604,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117144,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117144,36.64,0.46,213,51523,70,NULL,NULL,'2MASX J14072768+1619272',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.10',0.17,NULL,NULL,NULL,NULL,NULL,1,211.865417,16.32439,0,NULL,58359107123,911861048,14247828,18.1),(117145,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117145,34.85,0.21,93.5,51524,70,NULL,NULL,'ABELL 3581',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];RI [A]',NULL,NULL,NULL,NULL,1,211.867083,-27.01528,0.177,NULL,46989287878,734207623,11471994,NULL),(117146,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117146,35.17,0.46,108,51525,70,NULL,NULL,'2MASX J14072916+2408408',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000164,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,211.8714583,24.14458,0,NULL,59467983577,929187243,14518550,15.6),(117147,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117147,35.12,0.25,106,51526,74.4,NULL,NULL,'IC 4374',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000025,NULL,'13.59',1.2,'SA(rs)0-:;BrClG','Brightest group member',NULL,NULL,'Flat-Spectrum Radio Source',1,211.874,-27.01786,0.177,NULL,46989288349,734207630,11471994,13.59),(117148,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117148,34.82,0.4,92.1,51526,NULL,NULL,'mean','IC 4374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117149,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117149,34.83,0.45,92.4,51526,NULL,NULL,'K','IC 4374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117150,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117150,34.85,0.21,93.5,51526,70,NULL,'ABELL 3581, BGC','IC 4374',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117151,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117151,38.65,0.46,538,51527,70,NULL,NULL,'2MASX J14073123+4017552',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000191,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.880333333,40.29864,0,NULL,59257928693,925905135,14467267,17.5),(117152,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','SN 2008cf','R',117152,36.33,0.07,185,51528,NULL,NULL,'MLCS2k2, R(V) = 1.8','[WLF2008] J140732.38-263305.6',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,211.884916667,-26.55156,0.165,NULL,46992459625,734257181,11472768,NULL),(117153,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','SN 2008cf','R',117153,36.38,0.07,189,51528,NULL,NULL,'MLCS2k2, R(V) = 3.1','[WLF2008] J140732.38-263305.6',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117154,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:34','1','SN 2008cf',NULL,117154,36.72,0.22,211,51528,73.8,NULL,'SALT 2 (SNANA)','[WLF2008] J140732.38-263305.6',0.0472,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117155,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117155,37.57,0.46,326,51529,70,NULL,NULL,'2MASX J14073295+0741157',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.8872083,7.68769,0.011,NULL,58518044085,914344438,14286631,17.6),(117156,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117156,36.95,0.46,245,51530,70,NULL,NULL,'2MASX J14073311+2924128',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000145,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,211.8879583,29.40361,0,NULL,60006215080,937597110,14649954,17.4),(117157,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117157,35.4,0.33,120,51531,70,NULL,NULL,'CGCG 046-053',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00018,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,211.889625,7.17786,0,NULL,58516785530,914324773,14286324,15.6),(117158,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117158,38.39,0.23,477,51532,70,NULL,NULL,'2MASX J14073436+0726287',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.89',0.17,NULL,NULL,NULL,NULL,NULL,1,211.893041667,7.44122,0.011,NULL,58516162889,914315045,14286172,17.89),(117159,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117159,37.28,0.46,286,51533,70,NULL,NULL,'2MASX J14073437+0601522',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.893083,6.03117,0.034,NULL,58479144311,913736629,14277134,16.9),(117160,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117160,38.39,0.23,477,51534,70,NULL,NULL,'SDSS J140734.69+072621.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,211.894541667,7.43942,0.011,NULL,58516162932,914315045,14286172,18.7),(117161,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117161,34.86,0.49,93.7,51535,75,NULL,'IR','UGC 09030',NULL,'2011yCatp016004901K',2011,1,1.19,NULL,'G',0.000014,NULL,'15.6g',0.25,'Sbc',NULL,NULL,NULL,NULL,1,211.909375,9.67536,0,NULL,58509405805,914209465,14284522,15.6),(117162,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117162,35.37,0.2,119,51535,74.4,NULL,NULL,'UGC 09030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117163,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117163,35.59,NULL,131,51535,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117164,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117164,35.6,NULL,132,51535,NULL,NULL,'Dipole + Quadrupole','UGC 09030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117165,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117165,35.62,NULL,133,51535,NULL,NULL,'Dipole','UGC 09030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117166,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117166,35.63,NULL,134,51535,NULL,NULL,NULL,'UGC 09030',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117167,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117167,36.79,0.19,228,51536,70,NULL,NULL,'CGCG 018-053',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00012,NULL,'15.2g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,211.9119583,-0.95533,0.161,NULL,43591227247,681112925,10642389,15.2),(117168,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117168,36.5,0.46,200,51537,70,NULL,NULL,'2MASX J14073933+2431428',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,211.914125,24.52869,0,NULL,59468073401,929188646,14518572,16.5),(117169,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117169,36.41,0.49,191,51538,75,NULL,'IR','UGC 09031',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.001182,NULL,'15.62',0.2,'S?',NULL,NULL,NULL,NULL,1,211.914,14.86447,0,NULL,58364628977,911947327,14249176,15.62),(117170,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117170,37.21,0.46,277,51539,70,NULL,NULL,'2MASX J14073971+0732181',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000146,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.915625,7.53822,0.011,NULL,58516160188,914315002,14286171,17.1),(117171,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117171,35.57,0.47,130,51540,70,NULL,NULL,'ESO 384- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.08',0.9,'E+3 pec',NULL,NULL,NULL,NULL,1,211.919125,-37.28597,0.285,NULL,46877313918,732458029,11444656,14.08),(117172,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117172,36.27,0.46,179,51541,70,NULL,NULL,'VIII Zw 367 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.921083333,9.80997,0,NULL,58509424165,914209752,14284527,17),(117173,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117173,36.22,0.46,176,51542,70,NULL,NULL,'2MASX J14074110+3840073',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000182,NULL,'16.1g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,211.921125,38.66878,0,NULL,59140017597,924062774,14438480,16.1),(117174,'FP','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117174,37.28,0.46,285,51543,70,NULL,NULL,'2MASX J14074183+2801528',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,211.924291667,28.03142,0,NULL,60008872580,937638634,14650603,16.7),(117175,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117175,33.91,NULL,60.4,51544,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 325- G 055',NULL,'2010Ap&SS.325..163P',2010,1,1.99,NULL,'G',0.000033,NULL,'15.72',0.22,'Sbc',NULL,NULL,NULL,NULL,1,211.92475,-38.16628,0.285,NULL,46879387348,732490427,11445162,15.72),(117176,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117176,33.92,NULL,60.7,51544,NULL,NULL,'Dipole','ESO 325- G 055',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117177,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117177,33.92,NULL,60.8,51544,NULL,NULL,'Dipole + Quadrupole','ESO 325- G 055',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117178,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117178,34.05,0.43,64.5,51544,75,NULL,'3.6 micron, color + selection bias corrected','ESO 325- G 055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117179,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,'R',117179,34.27,0.49,71.5,51544,75,NULL,'IR','ESO 325- G 055',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117180,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117180,35.47,NULL,124,51545,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1129',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000023,NULL,'16.2',0.1,'Sbc',NULL,NULL,NULL,NULL,1,211.9279583,-27.43,0.201,NULL,46989217716,734206526,11471976,16.2),(117181,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117181,35.49,NULL,125,51545,NULL,NULL,'Dipole + Quadrupole','FGCE 1129',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117182,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117182,35.51,NULL,126,51545,NULL,NULL,'Dipole','FGCE 1129',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117183,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117183,36.14,0.42,169,51545,NULL,NULL,NULL,'FGCE 1129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117184,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:34','1',NULL,NULL,117184,36.19,0.2,173,51545,74.4,NULL,NULL,'FGCE 1129',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117185,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117185,36.2,0.41,174,51545,NULL,NULL,'Malmquist cor.','FGCE 1129',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117186,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117186,37.5,0.46,316,51546,70,NULL,NULL,'2MASX J14074323+0624571',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.93,6.41572,0.038,NULL,58515826962,914309796,14286090,17.3),(117187,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117187,38.39,0.23,477,51547,70,NULL,NULL,'SDSS J140743.24+073034.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.930167,7.5095,0.011,NULL,58516155455,914314928,14286170,17.8),(117188,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117188,38.34,0.46,466,51548,70,NULL,NULL,'2MASX J14074383+0636191',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000209,NULL,'17.0g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,211.932625,6.60536,0.033,NULL,58516044034,914313188,14286143,17),(117189,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117189,36.73,0.23,222,51549,70,NULL,NULL,'2MASX J14074401+1507513',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.00',0.19,NULL,NULL,NULL,NULL,NULL,1,211.9332917,15.13086,0,NULL,58364367977,911943249,14249113,18),(117190,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117190,35.4,0.33,120,51550,70,NULL,NULL,'CGCG 046-054',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000172,NULL,'15.1g',0.53,NULL,NULL,NULL,NULL,NULL,1,211.936125,7.216,0,NULL,58516209757,914315777,14286184,15.1),(117191,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117191,34.61,0.25,83.6,51551,74.4,NULL,NULL,'2MASX J14074475-2704573',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000014,NULL,'15.0b',NULL,'E','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,211.936208333,-27.08289,0.177,NULL,46989297938,734207780,11471996,15),(117192,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117192,37.77,0.46,358,51552,70,NULL,NULL,'2MASX J14074517+3220496',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,211.938208333,32.34717,0,NULL,60033399830,938021872,14656591,17.2),(117193,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117193,36.86,0.66,235,51553,70,NULL,NULL,'2MASX J14074600-4231266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,211.941583333,-42.52411,0.245,NULL,46793578835,731149669,11424213,15.9),(117194,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117194,38.07,0.46,411,51554,70,NULL,NULL,'SDSS J140746.28-010052.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,211.942833,-1.01444,0.161,NULL,43591345802,681114778,10642418,18.1),(117195,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117195,37.36,0.46,297,51555,70,NULL,NULL,'2MASX J14074664+2854453',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.944375,28.91261,0,NULL,60005893100,937592079,14649876,17.6),(117196,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117196,38.22,0.46,440,51556,70,NULL,NULL,'SDSS J140747.22+002414.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.946791667,0.404,0.117,NULL,58403956108,912561814,14258778,18.4),(117197,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117197,36.79,0.19,228,51557,70,NULL,NULL,'2MASX J14074853-0055531',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.95225,-0.93133,0.161,NULL,43591254703,681113354,10642396,17.3),(117198,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117198,36.82,0.33,231,51558,70,NULL,NULL,'2MASX J14074875+4138113',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,211.953167,41.63664,0,NULL,59258732382,925917693,14467463,17.2),(117199,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117199,37.62,0.23,335,51559,70,NULL,NULL,'2MASX J14074883+5241222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,211.9535417,52.68944,0,NULL,59249672387,925776131,14465252,17.1),(117200,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117200,37.76,0.14,356,51560,70,NULL,NULL,'2MASX J14074913+0508110',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000072,NULL,'16.7g',0.35,'AGN',NULL,NULL,NULL,NULL,1,211.9547083,5.13633,0.029,NULL,58481586238,913774784,14277731,16.7),(117201,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117201,37.57,0.46,327,51561,70,NULL,NULL,'2MASX J14074968+2419443',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,211.957041667,24.32906,0,NULL,59468089184,929188893,14518576,17.4),(117202,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117202,36.29,0.33,181,51562,70,NULL,NULL,'2MASX J14075000+5808043',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000188,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,211.958416667,58.13464,0,NULL,57304059404,895375928,13990248,15.9),(117203,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117203,38.7,0.46,549,51563,70,NULL,NULL,'SDSS J140750.68+025328.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000078,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,211.961208333,2.89131,0.053,NULL,58470850091,913607032,14275109,18.7),(117204,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117204,37.76,0.14,356,51564,70,NULL,NULL,'2MASX J14075133+0524580',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,211.963833,5.41617,0.033,NULL,58481255690,913769620,14277650,17.5),(117205,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117205,37.49,0.46,315,51565,70,NULL,NULL,'VIII Zw 366',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,211.964125,0.74939,0.089,NULL,58405064876,912579138,14259049,17.4),(117206,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117206,37.63,0.46,336,51566,70,NULL,NULL,'2MASX J14075244+3705193',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,211.968666667,37.08878,0,NULL,59142214634,924097103,14439017,17.6),(117207,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117207,36.82,0.33,231,51567,70,NULL,NULL,'2MASX J14075285+4138213',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.79',0.33,NULL,NULL,NULL,NULL,NULL,1,211.97025,41.63919,0,NULL,59258732098,925917689,14467463,15.79),(117208,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117208,37.04,0.33,256,51568,70,NULL,NULL,'2MASX J14075333-0019281',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000086,NULL,'16.0g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,211.97225,-0.32436,0.133,NULL,43589009139,681078267,10641847,16),(117209,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117209,38.53,0.33,509,51569,70,NULL,NULL,'2MASX J14075353+1911434',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.54',0.17,NULL,NULL,NULL,NULL,NULL,1,211.973166667,19.19547,0.027,NULL,59463050889,929110170,14517346,18.54),(117210,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117210,37.88,0.46,376,51570,70,NULL,NULL,'2MASX J14075427+1058591',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,211.976083,10.98303,0,NULL,58493324095,913958188,14280596,16.8),(117211,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117211,36.13,0.46,168,51571,70,NULL,NULL,'2MASX J14075480+5530136',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000185,NULL,'15.9g',0.3,'S0/a',NULL,NULL,NULL,NULL,1,211.978167,55.50386,0.005,NULL,57302139086,895345923,13989780,15.9),(117212,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117212,33.53,0.25,50.8,51572,74.4,NULL,NULL,'ABELL S0753:[WFC91] 103',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000057,NULL,'15.73',0.4,'S0',NULL,NULL,NULL,NULL,1,211.9805,-34.30269,0.197,NULL,47003260871,734425951,11475405,15.73),(117213,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117213,35.34,0.53,117,51573,NULL,NULL,'Malmquist cor.','ESO 510- G 072',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00003,NULL,'15.09',0.6,'SB(r)cd',NULL,NULL,NULL,NULL,1,211.982208333,-26.76719,0.177,NULL,46989060289,734204067,11471938,15.09),(117214,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117214,35.45,0.5,123,51573,NULL,NULL,NULL,'ESO 510- G 072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117215,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117215,35.49,0.2,125,51573,74.4,NULL,NULL,'ESO 510- G 072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117216,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117216,36.81,0.46,230,51574,70,NULL,NULL,'VIII Zw 367 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.91',0.18,NULL,NULL,NULL,NULL,NULL,1,211.982875,9.83111,0,NULL,58509373601,914208962,14284515,17.91),(117217,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117217,36.74,0.46,223,51575,70,NULL,NULL,'2MASX J14075761+0810571',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0001,NULL,'16.81',0.25,NULL,NULL,NULL,NULL,NULL,1,211.99,8.18264,0,NULL,58517514660,914336166,14286502,16.81),(117218,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117218,37.96,0.46,391,51576,70,NULL,NULL,'SDSS J140758.15+320529.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,211.9922917,32.09142,0,NULL,60050433352,938288021,14660750,18.5),(117219,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117219,33.25,0.5,44.7,51577,70,NULL,NULL,'ESO 446- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.9,'Marginal HIPASS detection.','G',0.000013,NULL,'13.54',1.3,'(R)SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,211.996166667,-32.05133,0.285,NULL,47035251057,734925797,11483215,13.54),(117220,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117220,33.76,0.8,56.4,51577,75,NULL,'HMCL, I','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117221,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117221,33.76,0.8,56.5,51577,75,NULL,'MAT, I','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117222,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117222,32.46,0.57,31.1,51577,NULL,NULL,NULL,'ESO 446- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117223,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117223,32.48,0.32,31.4,51577,85,NULL,'I, raw','ESO 446- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117224,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117224,32.52,0.32,31.9,51577,85,NULL,'I, inv','ESO 446- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117225,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117225,32.61,0.53,33.2,51577,NULL,NULL,'Malmquist cor.','ESO 446- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117226,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117226,32.64,0.2,33.7,51577,74.4,NULL,NULL,'ESO 446- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117227,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117227,32.66,0.43,34,51577,75,NULL,'MAT, I, raw','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117228,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117228,32.78,0.4,36.1,51577,75,NULL,'HMCL, I, raw','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117229,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117229,32.84,0.43,36.9,51577,75,NULL,'MAT, I, inv','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117230,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117230,32.94,0.4,38.7,51577,75,NULL,'HMCL, I, inv','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117231,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117231,32.98,0.43,39.4,51577,75,NULL,'MAT, I, cor','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117232,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117232,33.07,0.4,41.2,51577,75,NULL,'HMCL, I, cor','ESO 446- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117233,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117233,33.12,0.47,42.1,51577,NULL,NULL,'H','ESO 446- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117234,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117234,33.19,0.69,43.4,51577,100,NULL,'mid-IR','ESO 446- G 017',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117235,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117235,33.19,0.45,43.4,51577,NULL,NULL,'K','ESO 446- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117236,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117236,33.19,0.46,43.5,51577,NULL,NULL,'J','ESO 446- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117237,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117237,33.78,0.4,57.1,51577,NULL,NULL,'mean','ESO 446- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117238,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117238,36.33,0.64,185,51578,70,NULL,NULL,'2MASX J14075970-0900353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,211.998875,-9.00978,0.049,NULL,43752692244,683635816,10681809,16.7),(117239,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117239,36.79,0.19,228,51579,70,NULL,NULL,'VIII Zw 368',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000099,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,212.002166667,-0.82181,0.133,NULL,43591253320,681113333,10642395,16),(117240,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117240,37.04,0.33,256,51580,70,NULL,NULL,'2MASX J14080159-0013321',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.006583333,-0.22561,0.133,NULL,43588997571,681078087,10641845,18.1),(117241,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117241,38.78,0.46,570,51581,70,NULL,NULL,'SDSS J140802.02+351507.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.008458333,35.25214,0,NULL,60035325751,938051964,14657061,18.2),(117242,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117242,33.68,0.47,54.4,51582,70,NULL,NULL,'NGC 5488',NULL,'2014MNRAS.445.2677S',2014,1,3.4,NULL,'G',0.000097,NULL,'12.72',1,'SABbc?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.0129583,-33.31492,0.205,NULL,47005523318,734461301,11475957,12.72),(117243,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117243,37.39,0.33,300,51583,70,NULL,NULL,'2MASX J14080330+0657481',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.0135417,6.96336,0.028,NULL,58516763606,914324431,14286319,17.6),(117244,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117244,37.58,0.46,328,51584,70,NULL,NULL,'2MASX J14080346+3120103',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.15',0.17,NULL,NULL,NULL,NULL,NULL,1,212.014375,31.33614,0,NULL,60053336928,938333389,14661459,18.15),(117245,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117245,38.21,0.46,438,51585,70,NULL,NULL,'2MASX J14080415+4548401',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.017291667,45.81106,0,NULL,59234675861,925541810,14461590,17.7),(117246,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117246,36.44,0.24,194,51586,70,NULL,NULL,'GIN 342',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00007,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,212.017458333,-9.15242,0.085,NULL,43747718148,683558096,10680595,16.3),(117247,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117247,37.94,0.27,387,51587,70,NULL,NULL,'2MASX J14080477+1021387',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.13,NULL,NULL,NULL,NULL,NULL,1,212.019833333,10.36072,0,NULL,58491351512,913927367,14280115,18.67),(117248,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117248,37.76,0.14,356,51588,70,NULL,NULL,'2MASX J14080526+0525030',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00009,NULL,'16.0g',0.33,'cD;BrClG',NULL,NULL,NULL,NULL,1,212.0220417,5.41756,0.033,NULL,58481307669,913770432,14277663,16),(117249,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117249,36.85,0.46,234,51589,70,NULL,NULL,'VIII Zw 369',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000078,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.024625,0.74928,0.089,NULL,58405067006,912579171,14259049,16.8),(117250,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117250,36.44,0.24,194,51590,70,NULL,NULL,'GIN 338',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00009,NULL,'14.75',NULL,'E/S0',NULL,NULL,NULL,NULL,1,212.025833,-9.07819,0.049,NULL,43751978319,683624661,10681635,14.75),(117251,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117251,37.02,0.6,253,51591,70,NULL,NULL,'2MASX J14080637-4239516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.0265,-42.66433,0.265,NULL,46793693784,731151465,11424241,15.6),(117252,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117252,37.4,0.46,301,51592,70,NULL,NULL,'2MASX J14080644+4957521',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.026875,49.9645,0.051,NULL,59254730424,925855162,14466486,17.2),(117253,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117253,36.21,0.25,175,51593,74.4,NULL,NULL,'MCG -01-36-010',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000077,NULL,'13.38',0.2,'cD;E/S0',NULL,NULL,NULL,NULL,1,212.0285,-9.07169,0.049,NULL,43751978758,683624668,10681635,13.38),(117254,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117254,36.44,0.24,194,51593,70,NULL,NULL,'MCG -01-36-010',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117255,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117255,36.44,0.24,194,51594,70,NULL,NULL,'GIN 337',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000063,NULL,'14.86',NULL,'E/S0',NULL,NULL,NULL,NULL,1,212.030958333,-9.06169,0.049,NULL,43751978703,683624667,10681635,14.86),(117256,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117256,34.78,0.64,90.3,51595,NULL,NULL,NULL,'2MASX J14080804-2712260',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000023,NULL,'16.0',NULL,'Sc',NULL,NULL,NULL,NULL,1,212.033583,-27.20728,0.177,NULL,46989271858,734207372,11471990,16),(117257,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117257,34.8,0.64,91.3,51595,NULL,NULL,'Malmquist cor.','2MASX J14080804-2712260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117258,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117258,34.82,0.2,92,51595,74.4,NULL,NULL,'2MASX J14080804-2712260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117259,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117259,36.37,0.46,188,51596,70,NULL,NULL,'MCG +10-20-075',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000183,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,212.034833333,60.335,0.041,NULL,57270523489,894851929,13982061,15.7),(117260,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117260,37.62,0.23,335,51597,70,NULL,NULL,'2MASX J14081050+5240481',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000188,NULL,'15.9g',0.44,'AGN',NULL,NULL,NULL,NULL,1,212.043583,52.68006,0,NULL,59249738040,925777156,14465268,15.9),(117261,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117261,37.55,0.46,324,51598,70,NULL,NULL,'2MASX J14081285+4059228',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.0534583,40.98964,0,NULL,59260831628,925950494,14467976,16.7),(117262,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117262,38.2,0.46,437,51599,70,NULL,NULL,'LCRS B140537.6-024515',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.0545417,-2.99061,0.105,NULL,43722551226,683164862,10674450,17.9),(117263,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117263,36.39,0.46,190,51600,70,NULL,NULL,'CGCG 272-033',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000204,NULL,'15.1g',0.58,'E0',NULL,NULL,NULL,NULL,1,212.057375,53.88347,0,NULL,59248744876,925761638,14465025,15.1),(117264,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117264,37.76,0.14,356,51601,70,NULL,NULL,'SDSS J140814.57+052508.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.0607083,5.41917,0.033,NULL,58481311238,913770488,14277663,18.1),(117265,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117265,38.22,0.46,441,51602,70,NULL,NULL,'2MASX J14081459+1751288',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,212.0607083,17.85803,0,NULL,59483853320,929435208,14522425,18.2),(117266,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117266,34.43,0.5,76.9,51603,70,NULL,NULL,'ESO 578- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'15.05',0.4,'Sa:',NULL,NULL,NULL,NULL,1,212.0647083,-20.00544,0.229,NULL,46518478158,726851221,11357050,15.05),(117267,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117267,33.54,0.5,51,51604,70,NULL,NULL,'2MASX J14081669-3256366',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'15.1b',0.8,'E',NULL,NULL,NULL,NULL,1,212.069625,-32.94353,0.257,NULL,47004986934,734452920,11475826,15.1),(117268,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117268,37.94,0.27,387,51605,70,NULL,NULL,'2MASX J14081785+1023357',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.074333,10.39336,0,NULL,58491344940,913927264,14280113,17.5),(117269,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117269,37.67,0.46,342,51606,70,NULL,NULL,'2MASX J14081791+6237228',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'16.7g',0.27,'AGN',NULL,NULL,NULL,NULL,1,212.0747917,62.62308,0.037,NULL,57751311364,902364240,14099441,16.7),(117270,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117270,37.58,0.33,328,51607,70,NULL,NULL,'2MASX J14081814+2321003',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,212.0754583,23.35008,0,NULL,59472641110,929260017,14519687,18.37),(117271,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117271,38.09,0.46,414,51608,70,NULL,NULL,'2MASX J14081875+0726457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.078125,7.44603,0.014,NULL,58516286859,914316982,14286202,17.6),(117272,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117272,36.79,0.19,228,51609,70,NULL,NULL,'2MASX J14081925-0038540',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.08025,-0.64828,0.133,NULL,43590965921,681108842,10642325,17.7),(117273,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117273,38.46,0.46,492,51610,70,NULL,NULL,'2MASX J14081975+5705338',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.0822917,57.09283,0,NULL,57307167183,895424487,13991007,18.1),(117274,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117274,37.46,0.27,310,51611,70,NULL,NULL,'2MASX J14082240+0954327',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000131,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.0934583,9.90922,0,NULL,58490749143,913917955,14279968,17.7),(117275,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117275,37.59,0.46,329,51612,70,NULL,NULL,'2MASX J14082276+0834577',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.09475,8.58275,0,NULL,58517870801,914341731,14286589,17.8),(117276,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117276,37.23,0.46,280,51613,70,NULL,NULL,'2MASX J14082311+1336277',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000132,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.0962083,13.60769,0,NULL,58360871154,911888611,14248259,17.4),(117277,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117277,37.99,0.46,397,51614,70,NULL,NULL,'2MASX J14082312-0102520',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000297,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.09625,-1.04789,0.153,NULL,43591364783,681115074,10642423,17.1),(117278,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117278,37.94,0.27,387,51615,70,NULL,NULL,'SDSS J140823.62+102007.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000096,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.098417,10.33544,0,NULL,58491342719,913927229,14280112,17.8),(117279,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117279,30.28,0.4,11.4,51616,75,NULL,'Edat, raw','ESO 221- G 026',NULL,'1997ApJS..109..333W',1997,1,2.8,'Di Nella, et al. (1997,MNRAS,287,472) give v = 9300: +/- 70 km/sec.','G',0.000103,NULL,'12.10',1.7,'E',NULL,NULL,NULL,NULL,1,212.0992917,-47.97047,0.681,NULL,46839293685,731863963,11435374,12.1),(117280,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117280,30.62,0.4,13.3,51616,75,NULL,'Edat, cor','ESO 221- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117281,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117281,31.4,0.45,19.1,51616,NULL,NULL,'K','ESO 221- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117282,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117282,33.04,0.4,40.6,51616,NULL,NULL,'mean','ESO 221- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117283,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117283,36.33,0.33,185,51617,70,NULL,NULL,'2MASX J14082395+5306516',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000198,NULL,'15.7g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,212.09975,53.11425,0,NULL,59249703071,925776610,14465259,15.7),(117284,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117284,37.58,0.33,328,51618,70,NULL,NULL,'2MASX J14082490+2319013',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.10',0.15,NULL,NULL,NULL,NULL,NULL,1,212.103875,23.31711,0,NULL,59472638420,929259975,14519687,18.1),(117285,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117285,37.22,0.46,278,51619,70,NULL,NULL,'SDSS J140826.34+534543.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.1097917,53.76219,0,NULL,59248798905,925762482,14465038,17.9),(117286,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117286,38.39,0.46,477,51620,70,NULL,NULL,'SDSS J140826.63+051404.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.1109583,5.23464,0.033,NULL,58482154546,913783664,14277869,18),(117287,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117287,36.32,0.66,184,51621,70,NULL,NULL,'2MASX J14082671-1407105',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,212.1115417,-14.11967,0.241,NULL,43650862299,682044723,10656948,17),(117288,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117288,36.33,0.33,185,51622,70,NULL,NULL,'2MASX J14082696+5304077',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000169,NULL,'15.8g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,212.1125,53.06897,0,NULL,59249704139,925776627,14465259,15.8),(117289,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117289,37.65,0.27,338,51623,70,NULL,NULL,'2MASX J14082746+1218067',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000186,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,212.114583,12.30172,0,NULL,58361361797,911896278,14248379,16),(117290,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117290,37.45,0.46,309,51624,70,NULL,NULL,'2MASX J14082785+1854273',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.86',0.2,NULL,NULL,NULL,NULL,NULL,1,212.1160417,18.90769,0.038,NULL,59517316307,929958067,14530594,17.86),(117291,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117291,36.79,0.46,228,51625,70,NULL,NULL,'2MASX J14082783+4812007',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,212.116167,48.20017,0.033,NULL,59255789285,925871707,14466745,16.4),(117292,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117292,35.51,0.2,126,51626,74.4,NULL,NULL,'CGCG 074-116',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000099,NULL,'15.8g',0.25,'Sc',NULL,NULL,NULL,NULL,1,212.116583,13.59831,0,NULL,58360871711,911888620,14248259,15.8),(117293,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117293,35.26,0.49,113,51627,75,NULL,'IR','CGCG 074-116',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000099,NULL,'15.8g',0.25,'Sc',NULL,NULL,NULL,NULL,1,212.116583,13.59831,0,NULL,58360871711,911888620,14248259,15.8),(117294,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117294,37.53,0.15,320,51628,70,NULL,NULL,'2MASX J14082824+5533017',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.1179583,55.55042,0.005,NULL,57302154347,895346161,13989783,17.9),(117295,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117295,37.53,0.15,320,51629,70,NULL,NULL,'2MASX J14082880+5524197',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.1202917,55.40539,0,NULL,57302230777,895347355,13989802,18),(117296,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117296,34.45,0.8,77.6,51630,75,NULL,'CF, r','UGC 09037',NULL,'1997ApJS..109..333W',1997,1,1.34,'HOLM 591B is a star.','G',0.00003,NULL,'14.4g',0.64,'Scd:','Group member of poor cluster',NULL,NULL,NULL,1,212.1215,7.05792,0.028,NULL,58516231956,914316124,14286189,14.4),(117297,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117297,34.22,0.38,69.9,51630,75,NULL,'CF, r, raw','UGC 09037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117298,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117298,34.24,0.2,70.5,51630,74.4,NULL,NULL,'UGC 09037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117299,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117299,34.31,0.46,72.8,51630,NULL,NULL,NULL,'UGC 09037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117300,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117300,34.32,0.38,73.2,51630,75,NULL,'CF, r, inv','UGC 09037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117301,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117301,34.44,0.44,77.3,51630,NULL,NULL,'Malmquist cor.','UGC 09037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117302,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117302,34.58,0.38,82.4,51630,75,NULL,'CF, r, cor','UGC 09037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117303,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117303,36.79,0.19,228,51631,70,NULL,NULL,'2MASX J14082925-0050290',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.122041667,-0.84147,0.153,NULL,43591371613,681115181,10642424,17.1),(117304,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117304,37.55,0.46,324,51632,70,NULL,NULL,'2MASX J14082983+4120158',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.124375,41.33789,0,NULL,59260803293,925950051,14467969,17.2),(117305,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117305,38.78,0.46,569,51633,70,NULL,NULL,'SDSS J140830.59+030854.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.1275,3.14844,0.049,NULL,58483160854,913799388,14278115,18.2),(117306,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117306,34.84,0.33,92.9,51634,70,NULL,NULL,'NGC 5482',NULL,'2015arXiv151105856S',2015,1,1.39,NULL,'G',0.000073,NULL,'13.6g',0.87,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,212.127917,8.93192,0.045,NULL,58516926352,914326974,14286358,13.6),(117307,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117307,34.96,0.45,98,51634,NULL,NULL,'K','NGC 5482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117308,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117308,35.06,0.4,103,51634,NULL,NULL,'mean','NGC 5482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117309,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117309,37.76,0.14,356,51635,70,NULL,NULL,'2MASX J14083075+0527142',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.128083333,5.45397,0.037,NULL,58481270518,913769851,14277653,17.8),(117310,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117310,37.89,0.46,379,51636,70,NULL,NULL,'2MASX J14083124+5724247',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.129917,57.40675,0,NULL,57310483446,895476303,13991817,17.3),(117311,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117311,37.39,0.33,300,51637,70,NULL,NULL,'2MASX J14083166+0651257',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.132125,6.85719,0.028,NULL,58516704166,914323502,14286304,17.7),(117312,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117312,37.76,0.14,356,51638,70,NULL,NULL,'SDSS J140832.02+052726.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.133458333,5.45722,0.037,NULL,58481270442,913769850,14277653,18.5),(117313,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117313,37.46,0.27,310,51639,70,NULL,NULL,'2MASX J14083207+0955317',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000176,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.133667,9.92564,0,NULL,58491471577,913929243,14280144,16.5),(117314,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117314,38.16,0.46,428,51640,70,NULL,NULL,'SDSS J140832.43+255912.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00013,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.135166667,25.98694,0,NULL,60002388171,937537315,14649020,18.3),(117315,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117315,33.6,0.69,52.4,51641,100,NULL,'mid-IR','UGC 09041',NULL,'2013ApJ...771...88L',2013,1,1.04,NULL,'G',0.000108,NULL,'14.4g',0.64,'SBa',NULL,NULL,NULL,NULL,1,212.137416667,11.81622,0,NULL,58492030247,913937972,14280280,14.4),(117316,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117316,34.62,0.2,84,51641,74.4,NULL,NULL,'UGC 09041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117317,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117317,37.65,0.27,338,51642,70,NULL,NULL,'2MASX J14083306+1224257',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.137708333,12.407,0,NULL,58361370992,911896421,14248381,16.6),(117318,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117318,34.84,0.33,92.9,51643,70,NULL,NULL,'CGCG 074-117',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000057,NULL,'15.3g',0.47,NULL,'Group member',NULL,NULL,NULL,1,212.14075,9.03794,0.023,NULL,58516962796,914327543,14286367,15.3),(117319,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117319,37.53,0.15,320,51644,70,NULL,NULL,'2MASX J14083554+5532247',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000188,NULL,'15.8g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,212.147917,55.54008,0.005,NULL,57302154199,895346159,13989783,15.8),(117320,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117320,37.35,0.46,295,51645,70,NULL,NULL,'2MASX J14083554+1757044',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.1480417,17.95119,0,NULL,59483870638,929435478,14522429,18.3),(117321,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117321,37.57,0.46,326,51646,70,NULL,NULL,'SDSS J140835.55+071311.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.148125,7.21978,0.025,NULL,58516200936,914315639,14286181,17.9),(117322,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117322,38.06,0.46,409,51647,70,NULL,NULL,'2MASX J14083561+1943254',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.20',0.17,NULL,NULL,NULL,NULL,NULL,1,212.1485,19.72367,0.035,NULL,59462934310,929108348,14517317,18.2),(117323,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117323,38.08,0.46,413,51648,70,NULL,NULL,'SDSS J140836.36+452022.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,212.1515417,45.33953,0,NULL,59236451992,925569562,14462024,18.6),(117324,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117324,35.71,0.46,139,51649,70,NULL,NULL,'2MASX J14083682+1259347',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000165,NULL,'15.8g',0.3,'S0',NULL,NULL,NULL,NULL,1,212.1535,12.993,0,NULL,58360950246,911889847,14248278,15.8),(117325,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117325,35.37,0.57,118,51650,NULL,NULL,NULL,'ESO 384- G 060',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.40',0.2,'S...',NULL,NULL,NULL,NULL,1,212.154625,-34.20392,0.197,NULL,47002752817,734418012,11475281,16.4),(117326,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117326,35.41,0.2,121,51650,74.4,NULL,NULL,'ESO 384- G 060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117327,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117327,35.45,0.55,123,51650,NULL,NULL,'Malmquist cor.','ESO 384- G 060',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117328,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117328,37.16,0.46,271,51651,70,NULL,NULL,'2MASX J14083738+1944444',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.155667,19.74564,0.035,NULL,59462933673,929108338,14517317,18),(117329,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117329,34.08,0.8,65.5,51652,75,NULL,'MAT, I','ESO 446- G 018',NULL,'1997ApJS..109..333W',1997,1,3.11,NULL,'G',0.000005,NULL,'14.86',0.31,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.1595,-29.57203,0.205,NULL,47037426806,734959793,11483746,14.86),(117330,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117330,33.78,0.49,57.1,51652,75,NULL,'IR','ESO 446- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117331,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117331,33.87,0.43,59.4,51652,75,NULL,'MAT, I, raw','ESO 446- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117332,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117332,33.91,0.47,60.7,51652,NULL,NULL,'H','ESO 446- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117333,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117333,33.95,0.45,61.7,51652,NULL,NULL,'K','ESO 446- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117334,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117334,34.03,0.46,63.9,51652,NULL,NULL,'J','ESO 446- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117335,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117335,34.05,0.32,64.5,51652,85,NULL,'I, raw','ESO 446- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117336,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117336,34.09,0.4,65.8,51652,NULL,NULL,'mean','ESO 446- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117337,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117337,34.1,0.43,66,51652,75,NULL,'MAT, I, inv','ESO 446- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117338,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117338,34.1,0.32,66.1,51652,85,NULL,'I, inv','ESO 446- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117339,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117339,34.11,0.43,66.3,51652,75,NULL,'MAT, I, cor','ESO 446- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117340,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117340,34.21,0.2,69.5,51652,74.4,NULL,NULL,'ESO 446- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117341,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117341,34.23,NULL,70.1,51652,NULL,NULL,NULL,'ESO 446- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117342,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117342,34.26,NULL,71.2,51652,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 446- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117343,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117343,34.27,NULL,71.3,51652,NULL,NULL,'Dipole','ESO 446- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117344,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117344,34.27,NULL,71.4,51652,NULL,NULL,'Dipole + Quadrupole','ESO 446- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117345,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117345,34.29,0.16,72.3,51652,NULL,NULL,NULL,'ESO 446- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117346,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117346,36.2,0.46,174,51653,70,NULL,NULL,'2MASX J14083854+1343527',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000152,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,212.16075,13.73144,0,NULL,58367412004,911990812,14249856,16.2),(117347,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117347,37.47,0.33,312,51654,70,NULL,NULL,'SDSS J140838.57+295823.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.16075,29.97322,0,NULL,60051625880,938306654,14661041,18.2),(117348,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117348,37.27,0.46,284,51655,70,NULL,NULL,'2MASX J14083878+0427232',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000099,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.161625,4.45656,0.033,NULL,58485077419,913829334,14278583,16.4),(117349,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117349,37.53,0.15,320,51656,70,NULL,NULL,'2MASX J14083928+5527577',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.164,55.46611,0,NULL,57302269869,895347966,13989811,17.7),(117350,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117350,37.59,0.46,330,51657,70,NULL,NULL,'2MASX J14084049+1029241',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.1687083,10.49019,0,NULL,58491327309,913926989,14280109,17.5),(117351,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117351,37.76,0.14,356,51658,70,NULL,NULL,'2MASX J14084073+0529552',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.169667,5.49861,0.037,NULL,58481389026,913771703,14277682,17.9),(117352,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117352,35.64,0.4,134,51659,NULL,NULL,'mean','ESO 578- G 026',NULL,'2007A&A...465...71T',2007,1,1.8,'RC3 has V = 2781 +- 11 km/s.','G',0.00003,NULL,'15.05',1.2,'SB(rl)c','in a pair',NULL,NULL,NULL,1,212.174916667,-21.59725,0.237,NULL,46519484260,726866941,11357295,15.05),(117353,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117353,35.76,0.47,142,51659,NULL,NULL,'H','ESO 578- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117354,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117354,35.87,0.45,149,51659,NULL,NULL,'K','ESO 578- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117355,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117355,35.92,0.46,153,51659,NULL,NULL,'J','ESO 578- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117356,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117356,38.29,0.46,455,51660,70,NULL,NULL,'2MASX J14084266+5359547',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.177875,53.99844,0,NULL,59248738994,925761546,14465024,17.6),(117357,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117357,38.02,0.46,402,51661,70,NULL,NULL,'SDSS J140844.88+085309.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.1870417,8.88589,0.045,NULL,58516930464,914327038,14286359,18.3),(117358,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117358,37.29,0.46,287,51662,70,NULL,NULL,'2MASXi J1408460+522115',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.1920417,52.35422,0,NULL,59249073165,925766768,14465105,17.8),(117359,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117359,35.49,0.46,125,51663,70,NULL,NULL,'2MASX J14084664+1153181',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.194458333,11.8885,0,NULL,58492163519,913940054,14280313,16.2),(117360,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117360,37.42,0.46,304,51664,70,NULL,NULL,'2MASX J14084709+2645114',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000144,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.196375,26.75317,0,NULL,60000885965,937513843,14648653,17.2),(117361,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117361,35.22,0.49,111,51665,75,NULL,'IR','KUG 1406+274',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.00005,NULL,'15.9g',0.25,'Spiral',NULL,NULL,NULL,NULL,1,212.203625,27.25492,0,NULL,60008535232,937633363,14650521,15.9),(117362,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117362,37.46,0.27,310,51666,70,NULL,NULL,'2MASX J14084977+0955491',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.2075,9.93044,0,NULL,58491477405,913929334,14280145,17.4),(117363,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117363,36.27,0.76,179,51667,70,NULL,NULL,'2MASX J14085154-3006378',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,212.21475,-30.11053,0.217,NULL,47037399851,734959372,11483740,14.5),(117364,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117364,37.65,0.27,338,51668,70,NULL,NULL,'2MASX J14085245+1220458',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.218583,12.34614,0,NULL,58361228660,911894197,14248346,17.6),(117365,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117365,35.58,0.2,131,51669,74.4,NULL,NULL,'UGC 09048',NULL,'2013AJ....146...86T',2013,1,1.91,NULL,'G',0.000033,NULL,'14.8g',0.32,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,212.22025,33.53211,0,NULL,60037217736,938081527,14657523,14.8),(117366,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117366,35.96,0.4,156,51669,NULL,NULL,'mean','UGC 09048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117367,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117367,36.18,0.47,172,51669,NULL,NULL,'H','UGC 09048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117368,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117368,37.53,0.46,320,51670,70,NULL,NULL,'2MASX J14085321+2252352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.221833,22.8765,0.016,NULL,59474743419,929292865,14520201,17.7),(117369,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117369,37.53,0.15,320,51671,70,NULL,NULL,'SDSS J140853.27+553616.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.222,55.6045,0,NULL,57302181104,895346579,13989790,18),(117370,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117370,37.43,0.46,306,51672,70,NULL,NULL,'2MASX J14085391+1011561',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.90',0.18,NULL,NULL,NULL,NULL,NULL,1,212.224583,10.19897,0,NULL,58491515909,913929936,14280155,17.9),(117371,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117371,37.53,0.15,320,51673,70,NULL,NULL,'2MASX J14085406+5526265',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000194,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,212.225375,55.44075,0,NULL,57302259106,895347798,13989809,16),(117372,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117372,37.64,0.27,337,51674,70,NULL,NULL,'2MASX J14085473+1054511',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,212.228,10.91414,0,NULL,58493627914,913962936,14280670,18.09),(117373,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117373,38.07,0.46,410,51675,70,NULL,NULL,'2MASX J14085494+1131031',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.228833333,11.51753,0,NULL,58493118598,913954978,14280546,17.2),(117374,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117374,37.08,0.46,261,51676,70,NULL,NULL,'2MASX J14085561+1911442',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.77',0.25,NULL,NULL,NULL,NULL,NULL,1,212.2317917,19.19553,0.034,NULL,59517774726,929965230,14530706,16.77),(117375,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117375,38.54,0.46,510,51677,70,NULL,NULL,'SDSS J140856.47-012312.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000135,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,212.2352917,-1.38686,0.161,NULL,43590837850,681106841,10642294,18.4),(117376,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117376,33.95,0.75,61.7,51678,NULL,NULL,NULL,'AGC 540216',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',0.000043,NULL,'15.00',NULL,'Sbc',NULL,NULL,NULL,NULL,1,212.238333,-27.04886,0.161,NULL,46987313313,734176770,11471512,15),(117377,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117377,33.99,0.2,62.8,51678,74.4,NULL,NULL,'AGC 540216',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117378,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117378,34.2,0.67,69.1,51678,NULL,NULL,'Malmquist cor.','AGC 540216',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117379,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117379,31.67,NULL,21.6,51679,72,NULL,NULL,'IC 0978',NULL,'2014Ap.....57..457K',2014,1,0.89,NULL,'G',0.000037,NULL,'15.0g',0.49,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,212.242083,-2.97378,0.105,NULL,43722869736,683169839,10674528,15),(117380,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117380,37.47,0.46,312,51680,70,NULL,NULL,'SDSS J140858.65+092233.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000125,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.244417,9.37586,0,NULL,58508703152,914198486,14284351,17.8),(117381,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117381,37.84,0.46,369,51681,70,NULL,NULL,'2MASX J14090127+3404109',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.2552083,34.06972,0,NULL,60036293049,938067078,14657298,16.6),(117382,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117382,38.41,0.46,480,51682,70,NULL,NULL,'SDSS J140901.89+242101.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.257917,24.35039,0,NULL,59468764905,929199451,14518741,18.3),(117383,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117383,34.55,0.4,81.3,51683,NULL,NULL,'mean','UGC 09044',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.54',0.6,'S?',NULL,NULL,NULL,NULL,1,212.259583,14.31694,0,NULL,58367548533,911992945,14249889,14.54),(117384,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117384,34.83,0.47,92.5,51683,NULL,NULL,'H','UGC 09044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117385,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117385,37.03,0.63,254,51684,70,NULL,NULL,'LCRS B140625.4-061107',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.8b',0.32,NULL,NULL,NULL,NULL,NULL,1,212.262625,-6.42181,0.061,NULL,43739487287,683429488,10678585,16.8),(117386,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117386,34.54,0.46,81,51685,70,NULL,NULL,'CGCG 103-086',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00022,NULL,'15.1',0.25,NULL,NULL,NULL,NULL,NULL,1,212.266417,17.76622,0,NULL,59483712009,929433000,14522390,15.1),(117387,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117387,38.15,0.46,427,51686,70,NULL,NULL,'2MASXi J1409041+120325',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000181,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.267667,12.05725,0,NULL,58492153383,913939896,14280310,18.1),(117388,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117388,37.48,0.46,313,51687,70,NULL,NULL,'2MASX J14090438+2342223',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.268375,23.70608,0,NULL,59468357339,929193083,14518641,17.7),(117389,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117389,38.02,0.33,401,51688,70,NULL,NULL,'SDSS J140904.90+582623.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.2704583,58.43983,0,NULL,57304649703,895385151,13990392,17.8),(117390,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117390,37.93,0.46,385,51689,70,NULL,NULL,'2MASX J14090551+0611303',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.272917,6.19175,0.033,NULL,58504271785,914129246,14283269,18),(117391,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117391,37.8,0.46,363,51690,70,NULL,NULL,'2MASX J14090623+4944426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.2760417,49.74506,0.051,NULL,59256706576,925886040,14466969,17.6),(117392,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117392,37.39,0.46,300,51691,70,NULL,NULL,'2MASX J14090688+5327486',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.278625,53.46353,0,NULL,59248998060,925765594,14465087,16.6),(117393,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117393,37.69,0.46,345,51692,70,NULL,NULL,'2MASX J14090710+0515013',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.2797083,5.25028,0.037,NULL,58482167617,913783869,14277872,17.2),(117394,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117394,37.34,0.46,294,51693,70,NULL,NULL,'2MASX J14090739+3213569',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.15',0.15,NULL,NULL,NULL,NULL,NULL,1,212.28075,32.23233,0,NULL,60033335420,938020865,14656576,18.15),(117395,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117395,37.94,0.46,387,51694,70,NULL,NULL,'2MASX J14090767+1931463',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.60',0.15,NULL,NULL,NULL,NULL,NULL,1,212.282041667,19.52947,0.054,NULL,59462946076,929108532,14517320,18.6),(117396,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117396,37.8,0.46,362,51695,70,NULL,NULL,'2MASX J14090856+2450182',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.285583,24.83833,0,NULL,60002548495,937539820,14649059,18.2),(117397,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117397,38.04,0.33,406,51696,70,NULL,NULL,'2MASX J14090884+0557233',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.286916667,5.9565,0.013,NULL,58473905253,913654769,14275855,17.7),(117398,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117398,36.7,0.46,218,51697,70,NULL,NULL,'2MASX J14091134+2708352',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.67',0.2,NULL,NULL,NULL,NULL,NULL,1,212.297375,27.14317,0,NULL,60000991136,937515486,14648679,17.67),(117399,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117399,37.45,0.46,309,51698,70,NULL,NULL,'SDSS J140911.85+043015.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.299416667,4.50433,0.029,NULL,58485042711,913828792,14278574,17.8),(117400,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117400,35.7,0.53,138,51699,70,NULL,NULL,'2MASX J14091203-4732599',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,212.300125,-47.54994,0.581,NULL,46827452872,731678951,11432483,16.7),(117401,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117401,37.64,0.27,337,51700,70,NULL,NULL,'2MASX J14091153+1059193',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,212.300333,10.99222,0,NULL,58492880578,913951259,14280488,18.33),(117402,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117402,36.02,0.46,160,51701,70,NULL,NULL,'I Zw 082',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000199,NULL,'15.1g',0.62,'E0',NULL,NULL,NULL,NULL,1,212.300458333,56.39892,0.037,NULL,57299857129,895310267,13989222,15.1),(117403,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117403,37.76,0.14,356,51702,70,NULL,NULL,'2MASX J14091233+0526103',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.301417,5.43606,0.033,NULL,58481354608,913771165,14277674,17.9),(117404,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117404,37.48,0.46,313,51703,70,NULL,NULL,'2MASX J14091264+3159348',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.3027917,31.99308,0,NULL,60053264329,938332255,14661441,17.5),(117405,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117405,37.64,0.27,337,51704,70,NULL,NULL,'2MASX J14091330+1052043',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.305417,10.86783,0,NULL,58492899868,913951560,14280493,17.8),(117406,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117406,37.44,0.46,308,51705,70,NULL,NULL,'2MASX J14091466+2614402',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.3112083,26.24461,0,NULL,60002694967,937542108,14649095,17.3),(117407,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117407,38.1,0.46,417,51706,70,NULL,NULL,'2MASX J14091518+6251146',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.313667,62.85406,0.025,NULL,57751266292,902363535,14099430,17.9),(117408,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117408,37.75,0.46,355,51707,70,NULL,NULL,'2MASX J14091701+3844053',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000203,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.320875,38.73469,0,NULL,59140500478,924070319,14438598,16.7),(117409,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117409,38.02,0.33,401,51708,70,NULL,NULL,'2MASX J14091804+5827545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.325125,58.46506,0,NULL,57304645710,895385089,13990392,17.6),(117410,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117410,37.22,0.46,278,51709,70,NULL,NULL,'2MASX J14091833+4505270',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000211,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.3265417,45.09083,0,NULL,59236446374,925569474,14462023,16.8),(117411,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117411,36.42,0.46,192,51710,70,NULL,NULL,'2MASX J14091865+3509368',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.327917,35.16025,0,NULL,60035307947,938051686,14657057,16.4),(117412,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117412,35.53,0.52,128,51711,70,NULL,NULL,'MCG -03-36-008',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00004,NULL,'15.80',0.2,'E',NULL,NULL,NULL,NULL,1,212.331375,-17.87917,0.273,NULL,46544391694,727256120,11363376,15.8),(117413,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117413,37.59,0.17,329,51712,70,NULL,NULL,'2MASX J14092041+2549322',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.335125,25.82547,0,NULL,60002324306,937536317,14649004,18.2),(117414,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117414,38.01,0.46,400,51713,70,NULL,NULL,'2MASX J14092106+0953563',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.337583,9.89883,0,NULL,58490788863,913918575,14279977,17.7),(117415,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117415,37.8,0.46,363,51714,70,NULL,NULL,'SDSS J140921.34+450827.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,212.338917,45.14114,0,NULL,59236439710,925569370,14462021,18.5),(117416,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117416,31.97,0.43,24.8,51715,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09056',NULL,'2014MNRAS.444..527S',2014,1,1.18,NULL,'G',0.000015,NULL,'14.4g',0.43,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.3407083,49.03756,0.055,NULL,59256278893,925879357,14466864,14.4),(117417,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117417,32,0.4,25.2,51715,75,NULL,NULL,'UGC 09056',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117418,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117418,32.1,0.43,26.3,51715,75,NULL,'3.6 micron, color corrected','UGC 09056',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117419,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117419,32.19,0.2,27.4,51715,74.4,NULL,NULL,'UGC 09056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117420,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117420,32.7,0.49,34.6,51715,75,NULL,'IR','UGC 09056',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117421,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117421,37.76,0.46,356,51716,70,NULL,NULL,'SDSS J140923.36+285718.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.347333,28.95517,0,NULL,60005922652,937592541,14649883,18.3),(117422,'BL Lac Luminosity','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117422,42.15,NULL,1800,51717,NULL,NULL,NULL,'SDSS J140923.49+593940.8',0.495845,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000205,NULL,'19.2g',NULL,'HBLLAC',NULL,NULL,NULL,'BL Lac',1,212.347875,59.66133,0.005,NULL,57272378073,894880907,13982514,19.2),(117423,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117423,38.04,0.33,406,51718,70,NULL,NULL,'2MASX J14092480+0557485',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.85',0.18,NULL,NULL,NULL,NULL,NULL,1,212.3532083,5.96339,0.049,NULL,58473885583,913654462,14275850,17.85),(117424,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117424,37.05,0.33,257,51719,70,NULL,NULL,'2MASX J14092509+2200086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.354583,22.00225,0.036,NULL,59472062708,929250979,14519546,17.4),(117425,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117425,35.25,0.53,112,51720,NULL,NULL,'Malmquist cor.','ESO 510- G 075',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000027,NULL,'15.96',0.4,'Sb:',NULL,NULL,NULL,NULL,1,212.357375,-27.47561,0.141,NULL,46989184930,734206014,11471968,15.96),(117426,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117426,35.25,0.53,112,51720,NULL,NULL,NULL,'ESO 510- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117427,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117427,35.29,0.2,114,51720,74.4,NULL,NULL,'ESO 510- G 075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117428,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117428,37.79,0.46,362,51721,70,NULL,NULL,'2MASX J14092579+5113537',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.35775,51.23164,0.009,NULL,59252057382,925813396,14465834,17.2),(117429,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117429,37.59,0.17,329,51722,70,NULL,NULL,'SDSS J140926.66+255519.6',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'15.9g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.361083,25.92214,0,NULL,60002300433,937535944,14648999,15.9),(117430,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117430,37.72,0.46,351,51723,70,NULL,NULL,'2MASX J14093229+4437109',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.384541667,44.61997,0,NULL,59240068601,925626071,14462907,18.3),(117431,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117431,36.71,0.46,219,51724,70,NULL,NULL,'2MASX J14093322+1329351',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.388291667,13.49322,0,NULL,58365337467,911958397,14249349,16.7),(117432,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117432,38.35,0.46,467,51725,70,NULL,NULL,'2MASX J14093410+1037365',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.39225,10.62692,0,NULL,58490956263,913921191,14280018,17.3),(117433,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117433,37.67,0.46,342,51726,70,NULL,NULL,'SDSS J140934.78-004911.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.394917,-0.81994,0.157,NULL,43591153055,681111766,10642371,18.2),(117434,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117434,38.91,0.46,607,51727,70,NULL,NULL,'2MASX J14093643+4136283',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.401833333,41.60781,0,NULL,59225935958,925405249,14459457,18.1),(117435,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117435,37.82,0.46,366,51728,70,NULL,NULL,'2MASX J14093697+5825536',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.1g',0.23,'AGN',NULL,NULL,NULL,NULL,1,212.404083333,58.43147,0,NULL,57304436057,895381813,13990340,17.1),(117436,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117436,37.93,0.46,386,51729,70,NULL,NULL,'2MASX J14093746+0126595',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000086,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.4060417,1.45,0.057,NULL,58405186454,912581038,14259078,17.7),(117437,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117437,37.53,0.15,320,51730,70,NULL,NULL,'2MASX J14093813+5538506',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.408833,55.64736,0.005,NULL,57302178485,895346538,13989789,17.5),(117438,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117438,37.47,0.33,312,51731,70,NULL,NULL,'2MASX J14093849+2959463',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.20',0.18,NULL,NULL,NULL,NULL,NULL,1,212.410333333,29.99636,0,NULL,60051601438,938306272,14661035,18.2),(117439,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117439,37.18,0.46,272,51732,70,NULL,NULL,'2MASX J14093915+1228401',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.413167,12.47778,0,NULL,58361510115,911898595,14248415,16.9),(117440,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117440,38.43,0.46,485,51733,70,NULL,NULL,'2MASXi J1409396+174133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.414875,17.69256,0,NULL,59484581914,929446592,14522603,17.7),(117441,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117441,37.76,0.14,356,51734,70,NULL,NULL,'2MASX J14093974+0532245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000079,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.4155,5.54019,0.033,NULL,58481339052,913770922,14277670,17.6),(117442,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117442,38.45,0.46,490,51735,70,NULL,NULL,'2MASX J14094004+4036023',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.416875,40.60075,0,NULL,59257600191,925900002,14467187,17.3),(117443,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117443,38.95,0.46,616,51736,70,NULL,NULL,'SDSS J140940.84+103846.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.4202083,10.64625,0,NULL,58490999772,913921871,14280029,17.9),(117444,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117444,37.53,0.15,320,51737,70,NULL,NULL,'2MASX J14094210+5527386',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,212.425417,55.46061,0,NULL,57302317517,895348711,13989823,16.4),(117445,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117445,37.99,0.46,396,51738,70,NULL,NULL,'2MASX J14094241+1859040',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.52',0.16,NULL,NULL,NULL,NULL,NULL,1,212.426667,18.9845,0.038,NULL,59518068881,929969826,14530778,18.52),(117446,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117446,37.59,0.17,329,51739,70,NULL,NULL,'2MASX J14094330+2556478',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.430375,25.94653,0,NULL,60002297130,937535892,14648998,17.3),(117447,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117447,37.33,0.27,292,51740,70,NULL,NULL,'2MASX J14094357+0618275',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0002,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.4314583,6.30753,0.042,NULL,58504499612,914132806,14283325,16.7),(117448,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117448,36.78,0.46,227,51741,70,NULL,NULL,'2MASX J14094388-0134220',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.433,-1.57286,0.153,NULL,43589626324,681087911,10641998,17.7),(117449,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117449,37.33,0.27,292,51742,70,NULL,NULL,'SDSS J140945.62+062324.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.440125,6.39019,0.042,NULL,58504460056,914132188,14283315,17.6),(117450,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117450,32.96,NULL,39,51743,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 221- G 029',NULL,'2010Ap&SS.325..163P',2010,1,1.43,'Stars superposed.','G',0.000038,NULL,'16.24',0.17,'Sdm',NULL,NULL,NULL,NULL,1,212.440291667,-48.33094,0.753,NULL,46839192238,731862378,11435349,16.24),(117451,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117451,32.96,NULL,39.1,51743,NULL,NULL,'Dipole + Quadrupole','ESO 221- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117452,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117452,32.98,NULL,39.4,51743,NULL,NULL,'Dipole','ESO 221- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117453,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117453,38.39,0.33,476,51744,70,NULL,NULL,'SDSS J140946.32+574110.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.443,57.68614,0,NULL,57305737064,895402141,13990658,18),(117454,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117454,37.53,0.15,320,51745,70,NULL,NULL,'2MASX J14094668+5529147',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000202,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.444625,55.48739,0,NULL,57302309817,895348590,13989821,16.3),(117455,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117455,35.88,0.46,150,51746,70,NULL,NULL,'CGCG 074-124',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.0001,NULL,'14.7g',0.65,NULL,NULL,NULL,NULL,NULL,1,212.445083,11.58486,0,NULL,58492464412,913944756,14280386,14.7),(117456,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117456,37,0.46,251,51747,70,NULL,NULL,'2MASX J14094738+5108428',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,212.447625,51.14517,0.005,NULL,59252088563,925813883,14465841,16.6),(117457,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117457,37.33,0.27,292,51748,70,NULL,NULL,'2MASX J14094753+0618015',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000194,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,212.448,6.30056,0.042,NULL,58504454305,914132098,14283314,16.2),(117458,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117458,37.64,0.33,337,51749,70,NULL,NULL,'2MASX J14094826+3354422',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.4510417,33.91172,0,NULL,60036337165,938067768,14657308,17.5),(117459,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117459,35.01,0.36,100,51750,NULL,NULL,'Malmquist cor.','UGC 09054',NULL,'2009ApJS..182..474S',2009,1,0.84,NULL,'G',0.000033,NULL,'15.3g',0.4,'SB?',NULL,NULL,NULL,NULL,1,212.4525417,9.85847,0,NULL,58490818293,913919035,14279984,15.3),(117460,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117460,35.07,0.35,103,51750,NULL,NULL,NULL,'UGC 09054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117461,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117461,35.11,0.2,105,51750,74.4,NULL,NULL,'UGC 09054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117462,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117462,38.36,0.46,469,51751,70,NULL,NULL,'SDSS J140948.65+473028.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.45275,47.50781,0.033,NULL,59255165025,925861953,14466593,18.3),(117463,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117463,38.18,0.46,433,51752,70,NULL,NULL,'2MASX J14094869+2711408',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.4529583,27.19461,0,NULL,60001023792,937515996,14648687,17.1),(117464,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117464,37.85,0.46,371,51753,70,NULL,NULL,'2MASX J14094952+1420515',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.4565,14.34767,0,NULL,58367734742,911995855,14249935,17.7),(117465,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117465,37.64,0.33,337,51754,70,NULL,NULL,'2MASX J14095033+3349252',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.001086,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.4597917,33.82369,0,NULL,60036305599,938067274,14657301,17.6),(117466,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117466,36.41,0.55,191,51755,70,NULL,NULL,'2MASX J14095066-4235006',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.461083,-42.58353,0.245,NULL,46793539118,731149048,11424203,14.9),(117467,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117467,37.65,0.46,338,51756,70,NULL,NULL,'2MASX J14095071+0348490',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000093,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,212.461125,3.81344,0.053,NULL,58485186045,913831031,14278609,16.8),(117468,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117468,37.7,0.46,347,51757,70,NULL,NULL,'2MASX J14095076+5859257',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.46175,58.99058,0.005,NULL,57271587866,894868560,13982321,17.1),(117469,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117469,36.92,0.46,242,51758,70,NULL,NULL,'2MASX J14095174-0004590',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.4654583,-0.08303,0.101,NULL,43587523777,681055059,10641485,17),(117470,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117470,37.07,0.7,259,51759,70,NULL,NULL,'LCRS B140714.2-055516',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.9b',0.16,NULL,NULL,NULL,NULL,NULL,1,212.4654583,-6.15689,0.061,NULL,43739413074,683428329,10678567,16.9),(117471,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117471,37.05,0.33,257,51760,70,NULL,NULL,'2MASX J14095272+2157330',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.89',0.26,NULL,NULL,NULL,NULL,NULL,1,212.469667,21.95925,0.035,NULL,59472076525,929251195,14519549,16.89),(117472,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117472,33.43,NULL,48.5,51761,NULL,NULL,NULL,'FGC 1717',NULL,'2000BSAO...50....5K',2000,1,0.9,NULL,'G',0.00002,NULL,'17.82',0.1,'Sdm',NULL,NULL,NULL,NULL,1,212.473417,20.30994,0.03,NULL,59464441327,929131895,14517685,17.82),(117473,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117473,33.46,NULL,49.2,51761,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117474,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117474,33.48,NULL,49.6,51761,NULL,NULL,'Dipole + Quadrupole','FGC 1717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117475,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117475,33.49,NULL,50,51761,NULL,NULL,'Dipole','FGC 1717',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117476,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117476,37.62,0.46,334,51762,70,NULL,NULL,'2MASX J14095360+2033000',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,212.473375,20.55017,0.024,NULL,59464424159,929131627,14517681,18.16),(117477,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117477,35.8,0.66,144,51763,70,NULL,NULL,'2MASX J14095364-3523287',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.4735,-35.39131,0.181,NULL,47006794907,734481170,11476268,15.6),(117478,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117478,36.44,0.24,194,51764,70,NULL,NULL,'GIN 341',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00009,NULL,'14.96',NULL,'E/S0',NULL,NULL,NULL,NULL,1,212.4744583,-8.82244,0.057,NULL,43752078757,683626230,10681659,14.96),(117479,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117479,37.03,0.25,255,51764,74.4,NULL,NULL,'GIN 341',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117480,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117480,37.82,0.46,366,51765,70,NULL,NULL,'2MASX J14095412+0358110',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.4755417,3.96981,0.041,NULL,58485228620,913831697,14278620,17.4),(117481,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117481,38.09,0.23,415,51766,70,NULL,NULL,'SDSS J140954.76+085055.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.85',0.12,NULL,NULL,NULL,NULL,NULL,1,212.478208333,8.84869,0.01,NULL,58517061021,914329078,14286391,18.85),(117482,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117482,35.19,0.68,109,51767,70,NULL,NULL,'2MASX J14095516-1747230',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.94',NULL,NULL,NULL,NULL,NULL,NULL,1,212.479875,-17.78975,0.273,NULL,46545187853,727268560,11363571,15.94),(117483,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117483,37.71,0.46,349,51768,70,NULL,NULL,'2MASX J14095540+1048535',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.14',0.14,NULL,NULL,NULL,NULL,NULL,1,212.480916667,10.81503,0,NULL,58492870102,913951095,14280485,18.14),(117484,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117484,37.62,0.23,335,51769,70,NULL,NULL,'2MASX J14095567+5233108',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.482,52.55308,0.017,NULL,59249583827,925774747,14465230,16.6),(117485,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117485,36.44,0.24,194,51770,70,NULL,NULL,'GIN 340',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000107,NULL,'15.24',NULL,'S',NULL,NULL,NULL,NULL,1,212.4824583,-9.08214,0.085,NULL,43751889274,683623269,10681613,15.24),(117486,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117486,37.12,0.25,265,51770,74.4,NULL,NULL,'GIN 340',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117487,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117487,36.94,0.46,244,51771,70,NULL,NULL,'2MASX J14095601+6141202',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000192,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,212.4832083,61.68897,0.021,NULL,57748310524,902317351,14098708,16),(117488,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117488,34.2,0.09,69.2,51772,74.4,NULL,NULL,'NGC 5490',NULL,'2013AJ....146...86T',2013,1,1.74,'One of two 6cm sources associated with [WB92] 1407+1748','G',0.00008,NULL,'12.9g',1.12,'E','Possible field galaxy',NULL,'radio jet',NULL,1,212.4887083,17.54556,0,NULL,59484564236,929446316,14522598,12.9),(117489,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117489,34.33,0.28,72.3,51772,72,NULL,NULL,'NGC 5490',0.0162,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117490,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117490,34.43,0.19,75.5,51772,65,NULL,'MLCS17','NGC 5490',0.0162,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117491,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117491,34.44,0.06,75.9,51772,72,NULL,NULL,'NGC 5490',0.0162,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117492,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117492,34.53,0.07,78.1,51772,65,NULL,'MLCS2k2','NGC 5490',0.0162,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117493,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117493,34.52,0.25,78.9,51772,65,NULL,NULL,'NGC 5490',0.0162,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117494,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117494,34.55,0.2,79.9,51772,65,NULL,'MLCS31','NGC 5490',0.0162,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117495,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','SN 1997cn',NULL,117495,34.64,0.15,83.4,51772,70,NULL,'SALT','NGC 5490',0.0162,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117496,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117496,34.21,0.4,69.5,51772,75,NULL,'Edat, raw','NGC 5490',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117497,'D-Sigma','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117497,34.55,0.4,81.2,51772,75,NULL,'Edat, cor','NGC 5490',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117498,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117498,34.38,0.4,75.3,51772,NULL,NULL,'mean','NGC 5490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117499,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117499,34.41,0.45,76.2,51772,NULL,NULL,'K','NGC 5490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117500,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117500,38.2,0.46,437,51773,70,NULL,NULL,'2MASX J14095764+1040005',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.49025,10.66681,0,NULL,58490985296,913921645,14280025,17.7),(117501,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117501,35.02,0.5,101,51774,70,NULL,NULL,'2MASX J14095802-1453230',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,212.491833,-14.89,0.245,NULL,43653844536,682091320,10657676,15.77),(117502,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117502,37.97,0.46,392,51775,70,NULL,NULL,'2MASX J14100080+5325228',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000139,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.5034583,53.42306,0,NULL,59248890671,925763916,14465061,17.7),(117503,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117503,37.85,0.46,372,51776,70,NULL,NULL,'2MASX J14100115+2426406',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000188,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,212.504917,24.44467,0,NULL,59468506983,929195421,14518678,18.09),(117504,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117504,36.68,0.27,217,51777,70,NULL,NULL,'CGCG 272-037',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000087,NULL,'14.4g',0.72,'S0^-',NULL,NULL,NULL,NULL,1,212.506583333,54.88172,0.013,NULL,57298818196,895294034,13988969,14.4),(117505,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117505,38.09,0.23,415,51778,70,NULL,NULL,'2MASX J14100169+0849118',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,212.507,8.81994,0.01,NULL,58517046538,914328852,14286388,18.22),(117506,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117506,37.59,0.17,329,51779,70,NULL,NULL,'2MASX J14100245+2601426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.510291667,26.02856,0,NULL,60002778545,937543414,14649115,17.4),(117507,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117507,32.31,0.4,29,51780,75,NULL,NULL,'UGC 09071',NULL,'2008Ap.....51..336K',2008,1,1.92,NULL,'G',0.00002,NULL,'14.6g',0.45,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.512875,54.21831,0.005,NULL,57252313272,894567394,13977615,14.6),(117508,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117508,32.42,0.43,30.5,51780,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09071',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117509,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117509,32.44,0.4,30.8,51780,NULL,NULL,NULL,'UGC 09071',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117510,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117510,32.47,0.43,31.2,51780,75,NULL,'3.6 micron, color corrected','UGC 09071',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117511,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117511,32.51,0.2,31.8,51780,74.4,NULL,NULL,'UGC 09071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117512,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117512,32.69,0.51,34.5,51780,NULL,NULL,'Malmquist cor.','UGC 09071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117513,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117513,32.7,0.5,34.7,51780,NULL,NULL,NULL,'UGC 09071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117514,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117514,32.71,0.49,34.8,51780,75,NULL,'IR','UGC 09071',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117515,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117515,37.92,0.46,384,51781,70,NULL,NULL,'2MASX J14100316+0621288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.5132917,6.358,0.042,NULL,58504346302,914130410,14283287,17.8),(117516,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117516,37.6,0.46,330,51782,70,NULL,NULL,'2MASX J14100347-0021210',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000091,NULL,'16.4g',0.4,NULL,NULL,NULL,NULL,NULL,1,212.5145,-0.35586,0.117,NULL,43587704960,681057890,10641529,16.4),(117517,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117517,37.82,0.46,366,51783,70,NULL,NULL,'2MASX J14100357+3401431',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.514917,34.02856,0,NULL,60036330810,938067668,14657307,18),(117518,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117518,32.73,0.8,35.2,51784,75,NULL,NULL,'ESO 271- G 018',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000028,NULL,'15.30',1.2,'SBm',NULL,NULL,NULL,NULL,1,212.515375,-46.22253,0.389,NULL,46797020043,731203438,11425053,15.3),(117519,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117519,37.47,0.33,312,51785,70,NULL,NULL,'2MASX J14100386+4831468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.516375,48.52961,0.03,NULL,59255745267,925871019,14466734,17.4),(117520,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117520,36.29,0.33,181,51786,70,NULL,NULL,'CGCG 295-038',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000077,NULL,'14.9g',0.65,'E0',NULL,NULL,NULL,NULL,1,212.517291667,58.03939,0,NULL,57304001471,895375022,13990234,14.9),(117521,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117521,37.82,0.33,367,51787,70,NULL,NULL,'2MASX J14100418+4145208',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000198,NULL,'15.8g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,212.517458333,41.75581,0,NULL,59227014345,925422099,14459720,15.8),(117522,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117522,37.38,0.46,299,51788,70,NULL,NULL,'2MASX J14100416+2356236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.5175,23.94011,0,NULL,59468716734,929198698,14518729,17.6),(117523,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117523,37.82,0.33,367,51789,70,NULL,NULL,'SDSS J141004.51+414355.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,212.518833,41.73203,0,NULL,59227027657,925422307,14459723,18.5),(117524,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117524,37.47,0.33,312,51790,70,NULL,NULL,'SDSS J141004.74+482321.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.5197917,48.38933,0.03,NULL,59255730393,925870787,14466731,18.1),(117525,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117525,37.43,0.46,306,51791,70,NULL,NULL,'LCRS B140729.9-024441',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000127,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.52225,-2.98,0.157,NULL,43722884805,683170075,10674532,16.9),(117526,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117526,37.99,0.46,396,51792,70,NULL,NULL,'SDSS J141005.99+241411.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.524958333,24.23644,0,NULL,59468908717,929201698,14518776,18.1),(117527,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117527,38.16,0.46,429,51793,70,NULL,NULL,'2MASX J14100609+0429480',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.5255417,4.49675,0.033,NULL,58485115284,913829926,14278592,17.7),(117528,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117528,38.4,0.46,479,51794,70,NULL,NULL,'2MASX J14100681-0021590',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000089,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,212.52825,-0.36631,0.117,NULL,43587705168,681057893,10641529,18.5),(117529,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117529,34.87,0.49,94.2,51795,75,NULL,'IR','UGC 09066',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000093,NULL,'15.9g',0.18,'Sd',NULL,NULL,NULL,NULL,1,212.529625,46.43953,0.01,NULL,59234284001,925535687,14461495,15.9),(117530,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117530,34.93,NULL,96.6,51795,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09066',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117531,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117531,34.94,NULL,97.3,51795,NULL,NULL,'Dipole + Quadrupole','UGC 09066',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117532,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117532,34.95,NULL,97.6,51795,NULL,NULL,'Dipole','UGC 09066',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117533,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117533,34.98,NULL,99,51795,NULL,NULL,NULL,'UGC 09066',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117534,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117534,33.7,0.49,54.9,51796,75,NULL,'IR','IC 0984',NULL,'2011yCatp016004901K',2011,1,0.79,'HOLM 596B is a star.','G',0.00003,NULL,'14.2g',0.5,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,212.532333333,18.36467,0,NULL,59517254720,929957105,14530579,14.2),(117535,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117535,33.77,0.4,56.7,51796,NULL,NULL,NULL,'IC 0984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117536,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117536,33.81,0.2,57.8,51796,74.4,NULL,NULL,'IC 0984',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117537,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117537,33.98,0.47,62.6,51796,NULL,NULL,'H','IC 0984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117538,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117538,33.99,0.36,62.9,51796,NULL,NULL,'Malmquist cor.','IC 0984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117539,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117539,34.08,0.46,65.4,51796,NULL,NULL,'J','IC 0984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117540,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117540,34.1,0.45,66.1,51796,NULL,NULL,'K','IC 0984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117541,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117541,34.44,0.4,77.1,51796,NULL,NULL,'mean','IC 0984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117542,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117542,38.05,0.33,407,51797,70,NULL,NULL,'2MASX J14100839+3214132',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000187,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.534875,32.23706,0,NULL,60034653453,938041460,14656897,18.1),(117543,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117543,35.38,0.49,119,51798,75,NULL,'IR','CGCG 074-127',NULL,'2011yCatp016004901K',2011,1,0.87,NULL,'G',0.000105,NULL,'15.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.54175,11.93436,0,NULL,58492611523,913947055,14280422,15.7),(117544,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117544,35.55,0.2,129,51799,74.4,NULL,NULL,'CGCG 074-127',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000105,NULL,'15.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.54175,11.93436,0,NULL,58492611523,913947055,14280422,15.7),(117545,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117545,37.89,0.46,378,51800,70,NULL,NULL,'2MASX J14101021+1313325',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.54275,13.22558,0,NULL,58365417418,911959647,14249369,17.5),(117546,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117546,35.96,0.46,156,51801,70,NULL,NULL,'2MASX J14101058+5707596',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'15.8g',0.43,'E',NULL,NULL,NULL,NULL,1,212.543917,57.13317,0,NULL,57307247292,895425738,13991027,15.8),(117547,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117547,37.93,0.46,386,51802,70,NULL,NULL,'2MASX J14101095+0818448',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,':','17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.545583,8.31239,0.011,NULL,58503596811,914118700,14283104,17.3),(117548,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117548,35.25,0.5,112,51803,70,NULL,NULL,'FAIRALL 0475',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,212.552166667,-47.54908,0.733,NULL,46838963433,731858803,11435293,16.2),(117549,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117549,32.13,0.4,26.6,51804,75,NULL,'B','UGC 09057',NULL,'1988NBGC.C....0000T',1988,1,2.4,'Diameter includes companions or long extensions.','G',0.000017,NULL,'14.5g',0.55,'SB(rs)d?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.553708333,-2.57581,0.217,NULL,43722831814,683169247,10674519,14.5),(117550,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117550,32.13,NULL,26.7,51804,72,NULL,NULL,'UGC 09057',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117551,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117551,32.24,0.2,28.1,51804,74.4,NULL,NULL,'UGC 09057',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117552,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117552,32.34,0.43,29.4,51804,75,NULL,'3.6 micron, color corrected','UGC 09057',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117553,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117553,32.42,0.43,30.5,51804,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09057',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117554,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117554,32.87,0.2,37.5,51805,74.4,NULL,NULL,'UGC 09068',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.00002,NULL,'15.8g',0.58,'SAdm',NULL,NULL,NULL,NULL,1,212.5550417,48.31775,0.03,NULL,59255733023,925870828,14466731,15.8),(117555,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117555,37.12,0.46,266,51806,70,NULL,NULL,'2MASX J14101364+3723488',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.556791667,37.39692,0,NULL,60030483442,937976303,14655879,17.3),(117556,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117556,37.75,0.46,354,51807,70,NULL,NULL,'SDSS J141014.78+262031.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.561625,26.342,0,NULL,60002912637,937545509,14649148,18),(117557,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117557,37.5,0.46,316,51808,70,NULL,NULL,'2MASX J14101544+1938384',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.30',0.17,NULL,NULL,NULL,NULL,NULL,1,212.564417,19.64397,0.054,NULL,59517763268,929965051,14530703,18.3),(117558,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117558,39.76,0.46,894,51809,70,NULL,NULL,'SDSS J141015.65+234127.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.56525,23.69106,0.007,NULL,59468262830,929191606,14518618,18.7),(117559,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117559,36.68,0.27,217,51810,70,NULL,NULL,'2MASX J14101729+5451136',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.5719583,54.85367,0.013,NULL,57298836698,895294323,13988973,17.1),(117560,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117560,36.97,0.46,248,51811,70,NULL,NULL,'2MASX J14101790+6237033',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000195,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,212.5745417,62.61756,0.029,NULL,57750408522,902350133,14099220,16.1),(117561,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117561,36.71,0.46,220,51812,70,NULL,NULL,'2MASX J14101851+1300554',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,212.577208333,13.0155,0.007,NULL,58361003890,911890685,14248291,16.3),(117562,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117562,37.59,0.33,330,51813,70,NULL,NULL,'SDSS J141019.66+531754.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,212.581917,53.29839,0,NULL,59248924880,925764451,14465069,18.2),(117563,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117563,36.82,0.33,231,51814,70,NULL,NULL,'2MASX J14102058+6422043',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000095,NULL,'15.6g',0.45,'BrClG          NLAGN',NULL,NULL,NULL,NULL,1,212.585625,64.36792,0.021,NULL,57935035621,905234931,14144295,15.6),(117564,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117564,37.86,0.46,374,51815,70,NULL,NULL,'2MASX J14102136+3632407',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.588833,36.54458,0,NULL,60030796872,937981201,14655956,17.9),(117565,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117565,37.49,0.46,315,51816,70,NULL,NULL,'2MASX J14102250+2918036',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00018,NULL,'16.72',0.15,NULL,NULL,NULL,NULL,NULL,1,212.593625,29.30108,0,NULL,60051075379,938298052,14660907,16.72),(117566,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117566,34.69,0.49,86.7,51817,75,NULL,'IR','UGC 09064',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.71',0.2,'Sb',NULL,NULL,NULL,NULL,1,212.595625,16.33583,0,NULL,58358908540,911857945,14247780,15.71),(117567,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117567,37.19,0.46,274,51818,70,NULL,NULL,'2MASX J14102406+2119564',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.600166667,21.33244,0.036,NULL,59464622990,929134734,14517730,17.8),(117568,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117568,31.96,0.4,24.7,51819,75,NULL,'B','NGC 5483',NULL,'1988NBGC.C....0000T',1988,1,3.7,'Extended HIPASS source','G',0.000007,NULL,'11.93',3.4,'SB(s)c pec',NULL,NULL,NULL,NULL,1,212.604291667,-43.32461,0.273,NULL,46806971992,731358937,11427483,11.93),(117569,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117569,36.87,0.46,236,51820,70,NULL,NULL,'VIII Zw 372',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.610333,0.44408,0.053,NULL,58402188235,912534191,14258346,17.3),(117570,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117570,37.59,0.33,330,51821,70,NULL,NULL,'2MASX J14102659+5322067',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.610625,53.3685,0,NULL,59248932141,925764564,14465071,17.1),(117571,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117571,37.66,0.46,341,51822,70,NULL,NULL,'2MASX J14102724+5721574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.613125,57.36603,0,NULL,57307086547,895423227,13990987,17.5),(117572,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117572,37.59,0.17,329,51823,70,NULL,NULL,'2MASX J14102785+2613079',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.61625,26.21892,0,NULL,60002917120,937545580,14649149,17.6),(117573,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117573,35.87,0.46,149,51824,70,NULL,NULL,'MCG +10-20-081',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000176,NULL,'15.4g',0.5,'E0',NULL,NULL,NULL,NULL,1,212.619875,59.25972,0.005,NULL,57271463651,894866619,13982290,15.4),(117574,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117574,36.64,0.56,212,51825,70,NULL,NULL,'ESO 271- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.5',1,'S              WLRG',NULL,NULL,NULL,NULL,1,212.620375,-42.78211,0.249,NULL,46793176093,731143376,11424115,15.5),(117575,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117575,36.68,0.27,217,51826,70,NULL,NULL,'2MASX J14103050+5449274',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000183,NULL,'15.8g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,212.62725,54.82422,0.013,NULL,57298790601,895293603,13988962,15.8),(117576,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117576,37.2,0.46,275,51827,70,NULL,NULL,'2MASX J14103079+2116024',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.31',0.14,NULL,NULL,NULL,NULL,NULL,1,212.628291667,21.26733,0.031,NULL,59464651576,929135180,14517737,18.31),(117577,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117577,36.76,0.21,225,51828,70,NULL,NULL,'2MASX J14103087+1908564',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.16,NULL,NULL,NULL,NULL,NULL,1,212.628625,19.14894,0.053,NULL,59517894935,929967108,14530736,18.62),(117578,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117578,38.28,0.46,453,51829,70,NULL,NULL,'2MASX J14103146+1115333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.631208333,11.25919,0,NULL,58492373106,913943329,14280364,17.7),(117579,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117579,38.07,0.46,412,51830,70,NULL,NULL,'2MASX J14103225+0038119',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,212.634458333,0.63653,0.081,NULL,58402335669,912536494,14258382,17),(117580,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117580,38.05,0.46,408,51831,70,NULL,NULL,'SDSS J141032.35+044649.5',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.634833,4.78044,0.009,NULL,58481880137,913779377,14277802,17.6),(117581,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117581,38.09,0.23,415,51832,70,NULL,NULL,'2MASX J14103263+0844333',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000181,NULL,'18.03',0.17,NULL,NULL,NULL,NULL,NULL,1,212.635916667,8.74256,0,NULL,58503434026,914116156,14283064,18.03),(117582,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117582,36.76,0.21,225,51833,70,NULL,NULL,'2MASX J14103306+1909294',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.39',0.29,NULL,NULL,NULL,NULL,NULL,1,212.6377917,19.15808,0.053,NULL,59517898247,929967160,14530736,17.39),(117583,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117583,36.96,0.46,246,51834,70,NULL,NULL,'2MASX J14103320+2531239',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.638458333,25.52322,0,NULL,60002412403,937537693,14649026,16.9),(117584,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117584,38.06,0.46,410,51835,70,NULL,NULL,'2MASX J14103396+4045178',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.64175,40.755,0,NULL,59257541801,925899090,14467173,18.4),(117585,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117585,37.32,0.46,291,51836,70,NULL,NULL,'2MASX J14103470+5127528',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,212.644333,51.46461,0.009,NULL,59252848595,925825759,14466027,16.6),(117586,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117586,37.26,0.46,284,51837,70,NULL,NULL,'2MASX J14103467+3758308',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.644375,37.97533,0,NULL,59140226969,924066046,14438531,16.6),(117587,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117587,33.12,0.4,42.1,51838,NULL,NULL,'mean','NGC 5492',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.00002,NULL,'13.63',0.7,'Sb pec?','Field galaxy',NULL,NULL,NULL,1,212.646667,19.61233,0.037,NULL,59517761542,929965024,14530703,13.63),(117588,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117588,33.41,0.47,48.1,51838,NULL,NULL,'H','NGC 5492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117589,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117589,33.44,0.46,48.8,51838,NULL,NULL,'J','NGC 5492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117590,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117590,33.51,0.45,50.2,51838,NULL,NULL,'K','NGC 5492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117591,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117591,33.78,0.49,57,51838,75,NULL,'IR','NGC 5492',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117592,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117592,37.35,0.46,295,51839,70,NULL,NULL,'2MASX J14103526+3909508',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.647,39.16406,0,NULL,59140645936,924072592,14438634,17.4),(117593,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117593,37.68,0.46,344,51840,70,NULL,NULL,'2MASX J14103585+2402459',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.649333,24.04614,0,NULL,59468739473,929199054,14518735,17.8),(117594,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117594,32.97,NULL,39.2,51841,NULL,NULL,NULL,'UGC 09080',NULL,'2000BSAO...50....5K',2000,1,1.66,NULL,'G',0.000123,NULL,'15.3g',0.26,'Sb(f)',NULL,NULL,NULL,NULL,1,212.649625,59.35797,0.005,NULL,57272579187,894884049,13982563,15.3),(117595,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117595,33.05,NULL,40.7,51841,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09080',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117596,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117596,33.08,NULL,41.4,51841,NULL,NULL,'Dipole + Quadrupole','UGC 09080',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117597,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117597,33.1,NULL,41.7,51841,NULL,NULL,'Dipole','UGC 09080',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117598,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117598,36.62,0.33,211,51842,70,NULL,NULL,'2MASX J14103632+2339114',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.651291667,23.65303,0.007,NULL,59468266890,929191670,14518619,16.9),(117599,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117599,38.36,0.46,470,51843,70,NULL,NULL,'SDSS J141038.32+092930.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.659708333,9.49172,0.017,NULL,58490649351,913916396,14279943,18.3),(117600,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117600,37.59,0.17,329,51844,70,NULL,NULL,'2MASX J14103894+2556290',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.6625,25.94128,0,NULL,60002792021,937543625,14649119,17.6),(117601,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117601,38.11,0.46,418,51845,70,NULL,NULL,'SDSS J141039.16+103838.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.663208333,10.64397,0,NULL,58490899700,913920307,14280004,18.3),(117602,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117602,38.05,0.33,407,51846,70,NULL,NULL,'2MASX J14103922+3215171',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.663333,32.25492,0,NULL,60034671041,938041735,14656902,17.7),(117603,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS10kv','N',117603,42.52,0.15,2090,51847,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kv HOST',0.5304,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117604,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117604,37.78,0.46,360,51848,70,NULL,NULL,'2MASX J14103937+1324195',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.6642083,13.40547,0,NULL,58365524608,911961322,14249395,17.2),(117605,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117605,34.46,0.46,78.2,51849,70,NULL,NULL,'2MASX J14103977-0241003',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000027,NULL,'14.8g',0.5,'SABa',NULL,NULL,NULL,NULL,1,212.665625,-2.68353,0.113,NULL,43722969430,683171397,10674553,14.8),(117606,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117606,37.93,0.46,385,51850,70,NULL,NULL,'2MASX J14103978+6610359',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.665708333,66.17692,0.037,NULL,57942144852,905346013,14146031,17.8),(117607,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117607,36.53,0.46,202,51851,70,NULL,NULL,'2MASX J14104105+3510181',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000167,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,212.670875,35.17172,0,NULL,60044486762,938195105,14659298,15.9),(117608,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117608,31.79,0.43,22.8,51852,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 074-129',NULL,'2014MNRAS.444..527S',2014,1,0.82,NULL,'G',0.000117,NULL,'15.0g',0.53,'Sy2',NULL,NULL,NULL,'LINER',1,212.6722917,13.558,0,NULL,58365496464,911960882,14249388,15),(117609,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117609,32.29,0.43,28.8,51852,75,NULL,'3.6 micron, color corrected','CGCG 074-129',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117610,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117610,38.4,0.46,479,51853,70,NULL,NULL,'2MASX J14104175+0808453',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.673875,8.14608,0.014,NULL,58503634292,914119285,14283113,17.3),(117611,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117611,36.39,0.46,189,51854,70,NULL,NULL,'SDSS J141042.08+215724.4',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',NULL,NULL,'14.9g',0.52,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.675375,21.95681,0.032,NULL,59472023291,929250363,14519536,14.9),(117612,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117612,37.62,0.23,335,51855,70,NULL,NULL,'2MASX J14104302+5228248',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.679083333,52.47369,0,NULL,59249450065,925772657,14465197,18.1),(117613,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117613,36.62,0.33,211,51856,70,NULL,NULL,'2MASX J14104339+2338446',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000192,NULL,'16.52',0.26,NULL,NULL,NULL,NULL,NULL,1,212.680916667,23.64575,0.007,NULL,59468266421,929191662,14518619,16.52),(117614,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117614,37.58,0.46,327,51857,70,NULL,NULL,'2MASX J14104343+5831035',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.7g',0.27,'AGN',NULL,NULL,NULL,NULL,1,212.681125,58.51753,0,NULL,57304358282,895380598,13990321,16.7),(117615,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117615,38.15,0.46,426,51858,70,NULL,NULL,'2MASX J14104405+6242021',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.683416667,62.70058,0.029,NULL,57750416975,902350265,14099222,17.5),(117616,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117616,38.09,0.23,415,51859,70,NULL,NULL,'2MASX J14104423+0854213',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.6842083,8.90581,0.006,NULL,58503259961,914113436,14283022,17.2),(117617,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117617,35.51,0.48,127,51860,70,NULL,NULL,'LCRS B140807.3-054511',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00011,NULL,'15.46',0.46,NULL,NULL,NULL,NULL,NULL,1,212.686417,-5.9885,0.061,NULL,43731981542,683312211,10676753,15.46),(117618,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117618,34.97,0.2,98.6,51861,74.4,NULL,NULL,'UGC 09067',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000007,NULL,'14.42',0.7,'Sab',NULL,NULL,NULL,NULL,1,212.689417,15.20942,0,NULL,58366138601,911970915,14249545,14.42),(117619,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117619,35.31,0.4,115,51861,NULL,NULL,'mean','UGC 09067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117620,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117620,35.46,0.47,124,51861,NULL,NULL,'H','UGC 09067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117621,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117621,35.56,0.45,130,51861,NULL,NULL,'K','UGC 09067',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117622,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117622,37.85,0.46,371,51862,70,NULL,NULL,'2MASX J14104597+0545389',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.6915417,5.76083,0.069,NULL,58474008373,913656380,14275880,17.4),(117623,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117623,36.71,0.46,219,51863,70,NULL,NULL,'2MASX J14104713+5900195',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.696833,59.00536,0,NULL,57271632915,894869264,13982332,17),(117624,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117624,37.17,0.46,272,51864,70,NULL,NULL,'2MASX J14104759+4336270',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.698417,43.60753,0,NULL,59237720037,925589375,14462333,16.4),(117625,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117625,37.81,0.46,365,51865,70,NULL,NULL,'2MASX J14104821+0851363',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000195,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.701,8.86022,0,NULL,58503222280,914112848,14283013,16.9),(117626,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117626,36.55,0.46,205,51866,70,NULL,NULL,'2MASX J14104913+4836288',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.704625,48.608,0.046,NULL,59255686436,925870100,14466720,16.5),(117627,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117627,36.97,0.74,248,51867,70,NULL,NULL,'2MASX J14104930-2912086',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.3b',NULL,'S0',NULL,NULL,NULL,NULL,1,212.705333,-29.20244,0.177,NULL,47037230544,734956727,11483698,16.3),(117628,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117628,39.03,0.46,640,51868,70,NULL,NULL,'SDSS J141049.31+404509.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,212.7055,40.75272,0,NULL,59257578637,925899666,14467182,18.5),(117629,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117629,37.71,0.46,348,51869,70,NULL,NULL,'2MASX J14104958+1256419',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.7067083,12.94497,0,NULL,58364920749,911951886,14249248,18.1),(117630,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117630,36.94,0.46,244,51870,70,NULL,NULL,'2MASX J14105036+1903186',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000137,NULL,'16.92',0.42,NULL,NULL,NULL,NULL,NULL,1,212.709917,19.05519,0.006,NULL,59517977916,929968404,14530756,16.92),(117631,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117631,36.59,0.46,208,51871,70,NULL,NULL,'2MASX J14105152+2130496',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.25',0.23,NULL,NULL,NULL,NULL,NULL,1,212.7147083,21.51392,0.032,NULL,59463771012,929121422,14517522,17.25),(117632,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117632,37.52,0.33,319,51872,70,NULL,NULL,'2MASX J14105164+2444340',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000191,NULL,'18.02',0.16,NULL,NULL,NULL,NULL,NULL,1,212.715291667,24.74283,0,NULL,60002038834,937531856,14648935,18.02),(117633,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117633,37.84,0.46,369,51873,70,NULL,NULL,'2MASX J14105435+4031098',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.726417,40.51944,0,NULL,59258049401,925907021,14467297,17.9),(117634,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117634,35.73,0.46,140,51874,70,NULL,NULL,'CGCG 162-066',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000077,NULL,'14.9g',0.63,NULL,NULL,NULL,NULL,NULL,1,212.7270417,26.81439,0,NULL,60000945040,937514766,14648668,14.9),(117635,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117635,36.66,0.33,215,51875,70,NULL,NULL,'2MASX J14105460+2211066',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.03',0.17,NULL,NULL,NULL,NULL,NULL,1,212.7275,22.18514,0.032,NULL,59472018883,929250295,14519535,18.03),(117636,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117636,36.76,0.21,225,51876,70,NULL,NULL,'2MASX J14105586+1902017',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'17.07',0.2,NULL,NULL,NULL,NULL,NULL,1,212.7327083,19.03392,0.006,NULL,59517991693,929968620,14530759,17.07),(117637,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117637,37.87,0.46,374,51877,70,NULL,NULL,'2MASX J14105707+4942468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00014,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.73775,49.71306,0,NULL,59256815488,925887742,14466995,17.6),(117638,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117638,35.8,0.4,145,51878,NULL,NULL,'mean','NGC 5008',NULL,'2007A&A...465...71T',2007,1,1.01,NULL,'G',0.00003,NULL,'14.4g',0.83,'Scd:           AGN','Compact group member',NULL,NULL,NULL,1,212.7385,25.49722,0,NULL,60001959243,937530613,14648915,14.4),(117639,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117639,35.98,0.47,157,51878,NULL,NULL,'H','NGC 5008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117640,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117640,36.05,0.45,162,51878,NULL,NULL,'K','NGC 5008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117641,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117641,36.08,0.46,164,51878,NULL,NULL,'J','NGC 5008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117642,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117642,34.66,0.45,85.6,51879,NULL,NULL,'K','NGC 5491',NULL,'2007A&A...465...71T',2007,1,1.4,'HOLM 596C is a star.','G',0.00003,NULL,'13.80',0.8,'S?             HII','Possible field galaxy',NULL,NULL,NULL,1,212.7389583,6.36486,0.033,NULL,58505229511,914144211,14283503,13.8),(117643,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117643,34.67,0.47,85.8,51879,NULL,NULL,'H','NGC 5491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117644,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117644,34.68,0.4,86.2,51879,NULL,NULL,'mean','NGC 5491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117645,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117645,34.69,0.46,86.6,51879,NULL,NULL,'J','NGC 5491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117646,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117646,34.93,0.41,97,51879,NULL,NULL,'Malmquist cor.','NGC 5491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117647,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117647,35.03,0.39,102,51879,NULL,NULL,NULL,'NGC 5491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117648,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117648,35.07,0.2,103,51879,74.4,NULL,NULL,'NGC 5491',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117649,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117649,36.68,0.15,217,51880,70,NULL,NULL,'2MASX J14105893+2501032',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.70',0.19,NULL,NULL,NULL,NULL,NULL,1,212.7454583,25.01758,0.008,NULL,60002135999,937533374,14648958,17.7),(117650,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117650,37.11,0.33,264,51881,70,NULL,NULL,'2MASX J14105901+1809207',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.27',0.29,NULL,NULL,NULL,NULL,NULL,1,212.746,18.15569,0,NULL,59484483180,929445049,14522578,17.27),(117651,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117651,37.17,0.46,272,51882,70,NULL,NULL,'2MASX J14105927+2726232',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.747083,27.43972,0,NULL,60001541176,937524080,14648813,17.3),(117652,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117652,37.59,0.17,329,51883,70,NULL,NULL,'2MASX J14105957+2559252',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000208,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.748166667,25.99039,0,NULL,60002789206,937543581,14649118,16.6),(117653,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117653,37.35,0.46,295,51884,70,NULL,NULL,'LCRS B140824.8-022409',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,212.750333,-2.63736,0.121,NULL,43722847359,683169489,10674523,16.8),(117654,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117654,37.93,0.46,385,51885,70,NULL,NULL,'SDSS J141100.41+005608.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.75175,0.93575,0.065,NULL,58401958826,912530606,14258290,18.3),(117655,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117655,37.52,0.33,319,51886,70,NULL,NULL,'2MASX J14110079+2444192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.7532083,24.73872,0,NULL,60002028422,937531694,14648932,17),(117656,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117656,37.24,0.27,281,51887,70,NULL,NULL,'2MASX J14110145+3020461',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000103,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.756,30.34617,0,NULL,60051240184,938300627,14660947,17.7),(117657,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117657,36.66,0.33,215,51888,70,NULL,NULL,'2MASX J14110244+2210376',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,212.7604583,22.17722,0.032,NULL,59472008507,929250132,14519533,17.97),(117658,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117658,37.6,0.46,331,51889,70,NULL,NULL,'2MASX J14110581+4109202',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.7744583,41.15567,0,NULL,59224338071,925380282,14459066,17.1),(117659,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117659,37.59,0.46,330,51890,70,NULL,NULL,'SDSS J141105.91+024100.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.774625,2.68342,0.041,NULL,58471436190,913616190,14275252,17.8),(117660,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117660,37.36,0.21,296,51891,70,NULL,NULL,'2MASX J14110734+5302307',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.780583,53.04189,0,NULL,59249644871,925775701,14465245,17),(117661,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117661,37.47,0.46,311,51892,70,NULL,NULL,'2MASX J14110782+0656194',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,212.782667,6.93869,0.039,NULL,58504917217,914139331,14283427,16.7),(117662,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117662,37.21,0.46,277,51893,70,NULL,NULL,'2MASX J14110822+2415272',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.784375,24.25756,0,NULL,59468592028,929196750,14518699,17.6),(117663,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117663,34.02,0.49,63.8,51894,70,NULL,NULL,'ESO 326-IG 006',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00015,NULL,'15.0',0.7,'N',NULL,NULL,NULL,NULL,1,212.785083,-40.10533,0.093,NULL,46909260430,732957194,11452456,15),(117664,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117664,36.82,0.33,231,51895,70,NULL,NULL,'2MASX J14110910+6417429',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000087,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.7877917,64.29542,0.013,NULL,57933141369,905205333,14143833,16.4),(117665,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117665,37.42,0.46,305,51896,70,NULL,NULL,'2MASX J14110906+2625522',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.787875,26.43133,0,NULL,60002845196,937544456,14649132,18),(117666,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117666,35.5,0.53,126,51897,70,NULL,NULL,'2MASX J14110975-2752528',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.2b',NULL,'S0',NULL,NULL,NULL,NULL,1,212.790583,-27.88142,0.145,NULL,46986913776,734170527,11471414,16.2),(117667,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117667,35.53,0.46,128,51898,70,NULL,NULL,'2MASX J14110981+2601332',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.790708333,26.02578,0,NULL,60002757219,937543081,14649110,16.3),(117668,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117668,37.42,0.33,305,51899,70,NULL,NULL,'2MASX J14110983+5715324',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.790833,57.25911,0,NULL,57307259944,895425936,13991030,17.1),(117669,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117669,35.12,0.5,106,51900,70,NULL,NULL,'2MASX J14111154-2859478',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.7980417,-28.99653,0.141,NULL,47037268912,734957326,11483708,14.6),(117670,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117670,37.59,0.46,329,51901,70,NULL,NULL,'2MASX J14111171+4444410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,212.798875,44.74469,0,NULL,59240028565,925625446,14462897,18),(117671,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117671,37.78,0.46,360,51902,70,NULL,NULL,'2MASX J14111209+0532187',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.800625,5.53836,0.021,NULL,58474802626,913668791,14276074,17.4),(117672,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117672,34.75,0.2,89.1,51903,74.4,NULL,NULL,'CGCG 074-130',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000093,NULL,'16.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.805791667,11.3725,0,NULL,58492273844,913941778,14280340,16.3),(117673,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117673,38.05,0.46,408,51904,70,NULL,NULL,'2MASX J14111349+4012373',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'17.0g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,212.806166667,40.21044,0,NULL,59257218082,925894032,14467094,17),(117674,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117674,37.23,0.59,280,51905,70,NULL,NULL,'AM 1408-271',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.000103,NULL,'15.5R',NULL,'COMPACT',NULL,NULL,NULL,NULL,1,212.808125,-27.55781,0.177,NULL,46986860860,734169700,11471401,15.5),(117675,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117675,36.76,0.21,225,51906,70,NULL,NULL,'CGCG 103-110 NED01',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000123,NULL,'16.49',0.27,NULL,NULL,NULL,NULL,NULL,1,212.811667,19.18361,0,NULL,59517867996,929966687,14530729,16.49),(117676,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117676,37.11,0.33,264,51907,70,NULL,NULL,'2MASX J14111569+1819576',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.14',0.16,NULL,NULL,NULL,NULL,NULL,1,212.815333,18.33272,0,NULL,59517573256,929962082,14530657,18.14),(117677,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117677,38.39,0.33,476,51908,70,NULL,NULL,'2MASX J14111587+5736088',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00017,NULL,'16.4g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,212.81625,57.6025,0,NULL,57305256473,895394632,13990541,16.4),(117678,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117678,37.5,0.46,316,51909,70,NULL,NULL,'2MASX J14111629-0057352',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.817791667,-0.95978,0.121,NULL,43587981679,681062213,10641597,17.9),(117679,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117679,34.73,0.4,88.2,51910,NULL,NULL,'Malmquist cor.','ESO 511- G 007',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15',0.4,'Sb             HII',NULL,NULL,NULL,NULL,1,212.821916667,-25.03639,0.269,NULL,46986427468,734162929,11471295,15),(117680,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117680,34.78,0.39,90.4,51910,NULL,NULL,NULL,'ESO 511- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117681,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117681,34.82,0.2,92,51910,74.4,NULL,NULL,'ESO 511- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117682,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117682,34.86,0.47,93.9,51910,NULL,NULL,'H','ESO 511- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117683,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117683,34.99,0.4,99.7,51910,NULL,NULL,'mean','ESO 511- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117684,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117684,35.02,0.45,101,51910,NULL,NULL,'K','ESO 511- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117685,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117685,35.07,0.46,103,51910,NULL,NULL,'J','ESO 511- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117686,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117686,37.01,0.46,253,51911,70,NULL,NULL,'2MASX J14111756+0705214',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.823,7.08914,0.039,NULL,58505420679,914147198,14283549,17.1),(117687,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117687,34.9,0.33,95.4,51912,70,NULL,NULL,'MRK 1374',NULL,'2015arXiv151105856S',2015,1,0.6,'Foreground star 18\\\" to the east.','G',0.000069,NULL,'15.3g',0.33,'NLAGN',NULL,NULL,NULL,NULL,1,212.823833333,1.27528,0.049,NULL,58469147909,913580436,14274694,15.3),(117688,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117688,33.9,0.2,60.3,51913,74.4,NULL,NULL,'UGC 09078',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000033,NULL,'14.10',1.1,'(R\')SB(s)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.824417,17.50644,0,NULL,59483965661,929436963,14522452,14.1),(117689,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117689,34.31,0.4,72.7,51913,NULL,NULL,'mean','UGC 09078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117690,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117690,34.44,0.47,77.2,51913,NULL,NULL,'H','UGC 09078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117691,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117691,34.56,0.45,81.7,51913,NULL,NULL,'K','UGC 09078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117692,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117692,34.58,0.46,82.3,51913,NULL,NULL,'J','UGC 09078',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117693,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117693,35.93,0.33,154,51914,70,NULL,NULL,'2MASX J14111792+5517169',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000174,NULL,'16.0g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,212.824583,55.28808,0.005,NULL,57298674106,895291782,13988934,16),(117694,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117694,37.84,0.46,370,51915,70,NULL,NULL,'SDSS J141118.33+232544.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.36',0.18,NULL,NULL,NULL,NULL,NULL,1,212.826417,23.42903,0.028,NULL,59470206901,929221982,14519093,18.36),(117695,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117695,35.13,0.48,106,51916,70,NULL,NULL,'2MASX J14111849-2744058',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'16.3b',NULL,'S0',NULL,NULL,NULL,NULL,1,212.827083,-27.73492,0.189,NULL,46986863326,734169739,11471402,16.3),(117696,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117696,37.85,0.46,371,51917,70,NULL,NULL,'2MASX J14111958+0626544',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.831667,6.44839,0.037,NULL,58505184000,914143500,14283492,17.4),(117697,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117697,37.49,0.46,314,51918,70,NULL,NULL,'2MASX J14112009+2534372',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000196,NULL,'17.75',0.18,NULL,NULL,NULL,NULL,NULL,1,212.8339583,25.57697,0,NULL,60003072160,937548002,14649187,17.75),(117698,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117698,36.34,0.46,185,51919,70,NULL,NULL,'2MASX J14112433+1402036',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.851417,14.03442,0,NULL,58367769690,911996401,14249943,17.2),(117699,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117699,37.42,0.33,305,51920,70,NULL,NULL,'2MASX J14112458+5714559',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,212.8525417,57.24881,0,NULL,57307199930,895424998,13991015,16.6),(117700,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117700,36.43,0.53,193,51921,70,NULL,NULL,'2MASX J14112616-1957112',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.38',NULL,NULL,NULL,NULL,NULL,NULL,1,212.858875,-19.95333,0.249,NULL,46562595392,727540553,11367821,16.38),(117701,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117701,34.9,0.33,95.4,51922,70,NULL,NULL,'IC 0986',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000094,NULL,'14.4g',0.78,'S0             AGN',NULL,NULL,NULL,NULL,1,212.8592917,1.28653,0.049,NULL,58469151478,913580491,14274695,14.4),(117702,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117702,37.12,0.46,265,51923,70,NULL,NULL,'2MASX J14112636+2418142',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,212.8599583,24.30389,0,NULL,59468595666,929196807,14518700,17.5),(117703,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117703,32.52,0.4,31.9,51924,75,NULL,'B','UGC 09083',NULL,'1988NBGC.C....0000T',1988,1,0.97,NULL,'G',0.000013,NULL,'15.3g',0.58,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.862417,50.20906,0.02,NULL,59256642915,925885045,14466953,15.3),(117704,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117704,35.75,0.47,141,51925,NULL,NULL,'Malmquist cor.','ESO 326- G 007',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.57',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,212.864083,-38.87222,0.209,NULL,46876520948,732445639,11444463,14.57),(117705,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117705,35.79,0.46,144,51925,NULL,NULL,NULL,'ESO 326- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117706,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117706,35.83,0.2,147,51925,74.4,NULL,NULL,'ESO 326- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117707,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117707,38.43,0.33,486,51926,70,NULL,NULL,'SDSS J141127.48+093601.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,212.864541667,9.60033,0,NULL,58498111064,914032985,14281765,18.5),(117708,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117708,36.88,0.74,237,51927,70,NULL,NULL,'2MASX J14112805-4241467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,212.866833333,-42.69631,0.249,NULL,46793081910,731141904,11424092,15.7),(117709,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117709,38.37,0.23,472,51928,70,NULL,NULL,'2MASX J14112838+0450597',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0001,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,212.868125,4.84997,0.013,NULL,58481943952,913780374,14277818,17.3),(117710,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117710,35.9,0.46,151,51929,70,NULL,NULL,'2MASX J14112879+3553516',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000196,NULL,'15.0g',0.65,'E0',NULL,NULL,NULL,NULL,1,212.870125,35.89775,0,NULL,60043704206,938182878,14659107,15),(117711,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117711,38.43,0.33,486,51930,70,NULL,NULL,'SDSS J141129.12+093719.8',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,'PHOT','17.7r',0.35,'BrClG',NULL,NULL,NULL,NULL,1,212.871375,9.62219,0,NULL,58498141053,914033453,14281772,17.7),(117712,'Faber-Jackson','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117712,29.58,0.65,8.24,51931,95,NULL,'Weighted Mean','NGC 5493',NULL,'1984ApJS...56...91D',1984,1,1.6,NULL,'G',0.000017,NULL,'12.27',1.3,'S0 pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,212.872417,-5.04361,0.073,NULL,43732548174,683321065,10676891,12.27),(117713,'Faber-Jackson','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117713,30.46,0.81,12.4,51931,55,NULL,'Visvanathan & Sandage 1979','NGC 5493',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117714,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117714,32.95,0.8,38.9,51931,75,NULL,'B','NGC 5493',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117715,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117715,36.68,0.15,217,51932,70,NULL,NULL,'2MASX J14112963+2450263',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.30',0.24,NULL,NULL,NULL,NULL,NULL,1,212.873417,24.84067,0,NULL,60002092842,937532700,14648948,17.3),(117716,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117716,37.75,0.27,355,51933,70,NULL,NULL,'2MASX J14113038+2810153',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000204,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.876583,28.17094,0,NULL,60000630606,937509853,14648591,16.6),(117717,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS10ia','N',117717,41.6,0.31,1480,51934,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ia HOST',0.4094,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117718,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117718,38.95,0.46,617,51935,70,NULL,NULL,'SDSS J141132.00+364229.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.883333,36.70808,0,NULL,60030954476,937983663,14655994,18.4),(117719,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117719,38.37,0.23,472,51936,70,NULL,NULL,'2MASX J14113246+0452077',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.885333333,4.86883,0.013,NULL,58481947722,913780433,14277819,17.2),(117720,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117720,38.37,0.23,472,51937,70,NULL,NULL,'SDSS J141132.51+045519.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.8855,4.92206,0,NULL,58481938201,913780284,14277816,18),(117721,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117721,36.76,0.21,225,51938,70,NULL,NULL,'2MASX J14113272+1902456',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.63',0.21,'AGN',NULL,NULL,NULL,NULL,1,212.886291667,19.04617,0,NULL,59518020773,929969074,14530766,17.63),(117722,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117722,38.29,0.46,456,51939,70,NULL,NULL,'2MASX J14113316+2102596',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.64',0.12,NULL,NULL,NULL,NULL,NULL,1,212.88825,21.04992,0.023,NULL,59463875543,929123055,14517547,18.64),(117723,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117723,36.87,0.46,236,51940,70,NULL,NULL,'2MASX J14113355+1846086',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.07',0.17,NULL,NULL,NULL,NULL,NULL,1,212.889791667,18.76908,0,NULL,59517993681,929968651,14530760,18.07),(117724,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117724,38.15,0.46,427,51941,70,NULL,NULL,'2MASX J14113395+0715466',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.892875,7.25789,0.047,NULL,58505504731,914148511,14283570,17.6),(117725,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117725,36.96,0.46,247,51942,70,NULL,NULL,'2MASX J14113467+5723580',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.894625,57.39939,0,NULL,57305220743,895394074,13990532,16.7),(117726,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117726,37.17,0.27,272,51943,70,NULL,NULL,'2MASX J14113606+2759343',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,212.9002917,27.99278,0,NULL,60000808261,937512629,14648634,17.8),(117727,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117727,34.83,0.8,92.7,51944,75,NULL,'MAT, I','ESO 446- G 023',NULL,'1997ApJS..109..333W',1997,1,1.88,NULL,'G',0.000027,NULL,'15.34',0.22,'Sb',NULL,NULL,NULL,NULL,1,212.9004583,-30.40192,0.289,NULL,47038189818,734971715,11483933,15.34),(117728,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117728,34.82,0.43,92,51944,75,NULL,'MAT, I, raw','ESO 446- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117729,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117729,34.84,0.49,92.7,51944,75,NULL,'IR','ESO 446- G 023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117730,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117730,34.9,NULL,95.4,51944,NULL,NULL,NULL,'ESO 446- G 023',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117731,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117731,35.05,0.43,102,51944,75,NULL,'MAT, I, cor','ESO 446- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117732,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117732,35.08,0.4,104,51944,NULL,NULL,'mean','ESO 446- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117733,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117733,35.1,0.43,105,51944,75,NULL,'MAT, I, inv','ESO 446- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117734,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117734,35.12,0.32,106,51944,85,NULL,'I, raw','ESO 446- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117735,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117735,35.14,0.47,107,51944,NULL,NULL,'H','ESO 446- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117736,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117736,35.19,0.32,109,51944,85,NULL,'I, inv','ESO 446- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117737,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117737,35.21,NULL,110,51944,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 446- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117738,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117738,35.23,NULL,111,51944,NULL,NULL,'Dipole + Quadrupole','ESO 446- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117739,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117739,35.26,NULL,113,51944,NULL,NULL,'Dipole','ESO 446- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117740,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117740,35.28,0.45,114,51944,NULL,NULL,'K','ESO 446- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117741,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117741,35.29,0.2,114,51944,74.4,NULL,NULL,'ESO 446- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117742,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117742,35.3,0.43,115,51944,75,NULL,'3.6 micron, color corrected','ESO 446- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117743,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117743,35.33,0.46,116,51944,NULL,NULL,'J','ESO 446- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117744,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117744,35.41,0.5,121,51944,NULL,NULL,'Malmquist cor.','ESO 446- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117745,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117745,35.48,0.43,125,51944,75,NULL,'3.6 micron, color + selection bias corrected','ESO 446- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117746,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117746,35.52,0.48,127,51944,NULL,NULL,NULL,'ESO 446- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117747,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117747,35.12,0.33,106,51945,70,NULL,NULL,'CGCG 074-132',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000093,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,212.901167,8.80972,0,NULL,58503237203,914113081,14283016,15.4),(117748,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117748,36.68,0.15,217,51946,70,NULL,NULL,'2MASX J14113647+2445504',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,212.9020417,24.76408,0,NULL,60001911587,937529868,14648904,16.6),(117749,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117749,37.78,0.33,360,51947,70,NULL,NULL,'2MASX J14113655+5413429',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,212.9025417,54.22856,0,NULL,57252495155,894570236,13977659,16.7),(117750,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117750,37.75,0.27,355,51948,70,NULL,NULL,'2MASX J14113696+2805093',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,212.903916667,28.08594,0,NULL,60000588033,937509188,14648581,18),(117751,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117751,31.88,0.8,23.7,51949,75,NULL,'MAT, I','NGC 5496',NULL,'1997ApJS..109..333W',1997,1,5.49,NULL,'G',0.000007,NULL,'12.7B',0.73,'SBcd','Isolated galaxy',NULL,NULL,NULL,1,212.90775,-1.15911,0.157,NULL,43721900370,683154693,10674292,12.7),(117752,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117752,31.88,0.8,23.8,51949,75,NULL,'A82, H','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117753,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117753,31.43,0.4,19.3,51949,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5496',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117754,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117754,31.43,NULL,19.3,51949,NULL,NULL,NULL,'NGC 5496',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117755,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117755,31.47,NULL,19.6,51949,NULL,NULL,'Dipole','NGC 5496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117756,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117756,31.48,NULL,19.7,51949,NULL,NULL,'Dipole + Quadrupole','NGC 5496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117757,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117757,31.48,NULL,19.8,51949,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5496',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117758,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117758,31.5,0.54,20,51949,NULL,NULL,'Malmquist cor.','NGC 5496',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117759,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117759,31.51,0.2,20,51949,74.4,NULL,NULL,'NGC 5496',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117760,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117760,31.58,0.52,20.7,51949,NULL,NULL,NULL,'NGC 5496',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117761,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117761,31.58,0.32,20.7,51949,85,NULL,'I, raw','NGC 5496',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117762,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117762,31.58,0.32,20.7,51949,85,NULL,'I, inv','NGC 5496',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117763,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117763,31.63,0.47,21.2,51949,75,NULL,'A82, H, inv','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117764,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117764,31.67,0.47,21.6,51949,75,NULL,'A82, H, raw','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117765,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117765,31.68,0.38,21.7,51949,NULL,NULL,NULL,'NGC 5496',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117766,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117766,31.71,0.43,21.9,51949,75,NULL,'MAT, I, raw','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117767,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117767,31.77,0.43,22.6,51949,75,NULL,'3.6 micron, color corrected','NGC 5496',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117768,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117768,31.78,0.43,22.7,51949,75,NULL,'MAT, I, inv','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117769,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117769,31.91,NULL,24.1,51949,72,NULL,NULL,'NGC 5496',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117770,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117770,31.93,0.43,24.3,51949,75,NULL,'MAT, I, cor','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117771,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117771,31.93,0.47,24.3,51949,75,NULL,'A82, H, cor','NGC 5496',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117772,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117772,31.97,0.43,24.8,51949,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5496',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117773,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117773,32.11,0.4,26.4,51949,75,NULL,'B','NGC 5496',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117774,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117774,32.34,0.4,29.4,51949,NULL,NULL,'mean','NGC 5496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117775,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117775,32.67,0.46,34.2,51949,NULL,NULL,'J','NGC 5496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117776,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117776,32.68,0.47,34.3,51949,NULL,NULL,'H','NGC 5496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117777,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117777,32.87,0.45,37.6,51949,NULL,NULL,'K','NGC 5496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117778,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117778,36.68,0.15,217,51950,70,NULL,NULL,'2MASX J14113806+2501034',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000187,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,212.90875,25.01767,0.008,NULL,60002127498,937533242,14648956,16.4),(117779,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117779,37.16,0.46,271,51951,70,NULL,NULL,'2MASX J14113852+2556274',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,212.9105,25.94103,0,NULL,60003622503,937556601,14649321,15.9),(117780,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117780,38.58,0.46,520,51952,70,NULL,NULL,'2MASX J14113939+5919440',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.914375,59.32894,0,NULL,57272622138,894884720,13982573,17.7),(117781,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117781,36.68,0.15,217,51953,70,NULL,NULL,'2MASX J14113990+2504164',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,212.91625,25.07139,0.008,NULL,60002118546,937533102,14648954,16.3),(117782,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117782,37.83,0.46,369,51954,70,NULL,NULL,'2MASX J14114120+5813210',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.921791667,58.2225,0,NULL,57303957757,895374339,13990224,18),(117783,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117783,38.2,0.46,436,51955,70,NULL,NULL,'SDSS J141141.42+030609.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000081,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.922625,3.10264,0.053,NULL,58483804606,913809446,14278272,18.3),(117784,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117784,37.52,0.46,320,51956,70,NULL,NULL,'2MASX J14114263+0511538',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000094,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.9277083,5.19853,0.013,NULL,58474278293,913660598,14275946,16.8),(117785,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117785,35.7,0.66,138,51957,70,NULL,NULL,'2MASX J14114384-3425080',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.2b',NULL,'S0',NULL,NULL,NULL,NULL,1,212.932625,-34.41892,0.189,NULL,47002729731,734417652,11475275,16.2),(117786,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117786,37.47,0.46,312,51958,70,NULL,NULL,'2MASX J14114413+4123436',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.934041667,41.39536,0,NULL,59224313169,925379893,14459060,17),(117787,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117787,37.78,0.33,360,51959,70,NULL,NULL,'2MASX J14114452+5409309',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.935666667,54.1585,0.005,NULL,57252479789,894569996,13977656,17.8),(117788,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117788,37.84,0.33,369,51960,70,NULL,NULL,'2MASX J14114555+4022146',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,212.93975,40.37083,0,NULL,59257200630,925893759,14467089,17.6),(117789,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117789,37.17,0.27,272,51961,70,NULL,NULL,'2MASX J14114603+2758474',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.46',0.16,NULL,NULL,NULL,NULL,NULL,1,212.941916667,27.97986,0,NULL,60000813543,937512711,14648636,18.46),(117790,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117790,37.76,0.46,357,51962,70,NULL,NULL,'2MASX J14114708+5311415',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,212.946,53.19475,0.005,NULL,59249594189,925774909,14465232,16.8),(117791,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117791,36.48,0.67,197,51963,70,NULL,NULL,'2MASX J14114753-2149439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,'(RL)SA0^+',NULL,NULL,NULL,NULL,1,212.9480417,-21.82897,0.221,NULL,46519276592,726863696,11357245,15.2),(117792,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117792,38.32,0.46,460,51964,70,NULL,NULL,'2MASX J14114790+6302426',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.9497083,63.04528,0.029,NULL,57749609622,902337650,14099025,18.2),(117793,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117793,37.73,0.46,351,51965,70,NULL,NULL,'2MASX J14114842+1247309',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000209,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.9517083,12.79183,0,NULL,58364971340,911952677,14249260,17.3),(117794,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117794,37.17,0.27,272,51966,70,NULL,NULL,'2MASX J14114844+2758594',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000267,NULL,'15.2g',0.55,'cD',NULL,NULL,NULL,NULL,1,212.951917,27.98325,0,NULL,60000813403,937512709,14648636,15.2),(117795,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117795,36.78,0.46,227,51967,70,NULL,NULL,'2MASX J14114869+0220248',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000092,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,212.952917,2.34028,0.093,NULL,58471836081,913622438,14275350,16.7),(117796,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117796,37.36,0.21,296,51968,70,NULL,NULL,'2MASX J14114896+5250265',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,212.954167,52.84075,0.017,NULL,59249357355,925771208,14465175,16.7),(117797,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117797,37.84,0.46,369,51969,70,NULL,NULL,'2MASX J14114917+1154307',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,212.955083,11.90856,0,NULL,58491923406,913936303,14280254,18.1),(117798,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117798,37.36,0.21,296,51970,70,NULL,NULL,'SBS 1410+530',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000189,NULL,'15.6g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,212.956,52.81672,0.017,NULL,59249351196,925771112,14465173,15.6),(117799,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117799,38.02,0.46,402,51971,70,NULL,NULL,'2MASX J14114959+0517448',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,212.956583333,5.29583,0.021,NULL,58474270666,913660479,14275944,17.1),(117800,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117800,37.76,0.46,356,51972,70,NULL,NULL,'2MASX J14114955+5457329',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,212.956625,54.95925,0.017,NULL,57252873847,894576153,13977752,16.7),(117801,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117801,36.96,0.33,247,51973,70,NULL,NULL,'2MASX J14114996+5427129',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,212.958167,54.45356,0,NULL,57252422931,894569108,13977642,16.9),(117802,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117802,38.07,0.46,411,51974,70,NULL,NULL,'SDSS J141150.44+062335.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,212.9602083,6.39319,0.045,NULL,58504722815,914136293,14283379,18.4),(117803,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117803,38.31,0.46,459,51975,70,NULL,NULL,'2MASX J14115114+2114589',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,212.963208333,21.24978,0.031,NULL,59463903478,929123491,14517554,18.4),(117804,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117804,38.37,0.23,472,51976,70,NULL,NULL,'SDSS J141152.11+045430.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.967125,4.90861,0,NULL,58474139340,913658427,14275912,17.7),(117805,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117805,36.68,0.15,217,51977,70,NULL,NULL,'2MASX J14115211+2455194',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000113,NULL,'16.35',0.33,NULL,NULL,NULL,NULL,NULL,1,212.9672083,24.92194,0.008,NULL,60001922739,937530042,14648906,16.35),(117806,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117806,38.54,0.46,510,51978,70,NULL,NULL,'SDSS J141153.19+572719.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,212.971625,57.45528,0,NULL,57305225641,895394150,13990533,18.3),(117807,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117807,38.74,0.46,559,51979,70,NULL,NULL,'2MASX J14115346+2315069',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'18.06',0.14,NULL,NULL,NULL,NULL,NULL,1,212.972833333,23.25183,0.012,NULL,59470232132,929222377,14519099,18.06),(117808,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117808,37.46,0.46,311,51980,70,NULL,NULL,'2MASX J14115361+0504558',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,212.973333,5.08211,0.013,NULL,58474327868,913661372,14275958,17.3),(117809,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117809,36.19,0.46,173,51981,70,NULL,NULL,'2MASX J14115391+0013228',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000093,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,212.9745,0.22297,0.089,NULL,58402402898,912537545,14258399,15.6),(117810,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117810,37.1,0.33,263,51982,70,NULL,NULL,'SDSS J141154.61+002952.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,212.9775417,0.49778,0.109,NULL,58402479680,912538745,14258417,17.8),(117811,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117811,37.06,0.46,259,51983,70,NULL,NULL,'2MASX J14115529+1930149',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.63',0.44,NULL,NULL,NULL,NULL,NULL,1,212.980458333,19.50425,0.011,NULL,59520682623,930010665,14531416,16.63),(117812,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117812,35.99,0.46,157,51984,70,NULL,NULL,'2MASX J14115540+4614170',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000162,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,212.980833,46.23806,0,NULL,59236405792,925568840,14462013,16.4),(117813,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117813,36.29,0.83,181,51985,70,NULL,NULL,'2MASX J14115588-0710238',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.5b',0.37,NULL,NULL,NULL,NULL,NULL,1,212.982833,-7.17353,0.065,NULL,43741513669,683461151,10679080,16.5),(117814,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117814,35.98,0.27,157,51986,70,NULL,NULL,'IC 4384',NULL,'2015arXiv151105856S',2015,1,1.16,NULL,'G',0.000083,NULL,'14.3g',0.75,'S0/a',NULL,NULL,NULL,NULL,1,212.983416667,27.11392,0,NULL,60001573849,937524591,14648821,14.3),(117815,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS10kf','N',117815,41.82,0.18,1600,51987,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kf HOST',0.4504,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117816,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117816,35.93,0.33,154,51988,70,NULL,NULL,'CGCG 272-042',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000097,NULL,'15.2g',0.47,'E0',NULL,NULL,NULL,NULL,1,212.99175,55.40978,0,NULL,57302062619,895344728,13989761,15.2),(117817,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117817,37.75,0.27,355,51989,70,NULL,NULL,'2MASX J14115859+2810463',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.86',0.13,NULL,NULL,NULL,NULL,NULL,1,212.994083333,28.17953,0,NULL,60000622774,937509730,14648589,18.86),(117818,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117818,39.28,NULL,718,51990,65,NULL,'L = 10e57 photons/s','GRB 790613',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,212.990333,78.68858,0.061,NULL,57166637682,893228713,13956698,NULL),(117819,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117819,39.86,NULL,938,51990,75,NULL,NULL,'GRB 790613',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117820,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117820,41.39,NULL,1900,51990,NULL,NULL,NULL,'GRB 790613',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117821,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117821,41.81,NULL,2300,51990,65,NULL,'L = 2 x 10e58 photons/s','GRB 790613',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117822,'SGRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117822,38.01,0.48,400,51990,NULL,NULL,NULL,'GRB 790613',NULL,'2006ApJ...640..849N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117823,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117823,37.24,0.27,281,51991,70,NULL,NULL,'2MASX J14115915+3013554',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,212.9965,30.23208,0,NULL,60051277784,938301215,14660956,16.6),(117824,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117824,32.99,0.8,39.7,51992,75,NULL,NULL,'NGC 5489',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00017,NULL,'13.14',1,'SA(s)0^+',NULL,NULL,NULL,NULL,1,213.003,-46.08872,0.353,NULL,46804411501,731318929,11426858,13.14),(117825,'SGRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117825,38.73,NULL,557,51993,71,NULL,NULL,'GRB 060801',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,213.005375,16.98167,0,NULL,59487334726,929489605,14523275,NULL),(117826,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117826,35.95,0.46,155,51994,70,NULL,NULL,'2MASX J14120213+2441391',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.18',0.38,NULL,NULL,NULL,NULL,NULL,1,213.00875,24.69411,0,NULL,59468447595,929194493,14518663,16.18),(117827,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117827,35.95,0.2,155,51995,74.4,NULL,NULL,'CGCG 074-133',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.00014,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,213.011333333,10.37547,0,NULL,58498503815,914039122,14281861,15.8),(117828,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117828,38.05,0.33,407,51996,70,NULL,NULL,'VIII Zw 377 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.016625,-0.02011,0.089,NULL,43587601174,681056268,10641504,17.5),(117829,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117829,38.66,0.46,540,51997,70,NULL,NULL,'LCRS B140928.9-023426',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.01775,-2.80806,0.129,NULL,43724631620,683197369,10674958,18.3),(117830,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117830,37.8,0.46,363,51998,70,NULL,NULL,'SDSS J141204.27+053257.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.0177917,5.54931,0.021,NULL,58474865511,913669773,14276090,18.2),(117831,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117831,37.44,0.27,308,51999,70,NULL,NULL,'2MASX J14120514+4945084',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.021417,49.75242,0.022,NULL,59256797802,925887465,14466991,18),(117832,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117832,37.32,0.46,292,52000,70,NULL,NULL,'2MASX J14120594+5604535',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.02475,56.0815,0.013,NULL,57300483378,895320052,13989375,17.3),(117833,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117833,38,0.46,398,52001,70,NULL,NULL,'2MASX J14120631+1854159',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.026375,18.90458,0,NULL,59517526918,929961358,14530646,17.6),(117834,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117834,37.45,0.46,309,52002,70,NULL,NULL,'2MASX J14120722+3726597',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.0302917,37.44994,0,NULL,60032565968,938008843,14656388,17.4),(117835,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117835,37.13,0.46,266,52003,70,NULL,NULL,'SDSS J141207.73+034447.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.03225,3.7465,0.045,NULL,58484394322,913818661,14278416,17.6),(117836,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117836,39.06,0.46,647,52004,70,NULL,NULL,'SDSS J141207.78+131328.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.0324583,13.22472,0,NULL,58365830322,911966098,14249470,18.7),(117837,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117837,38.05,0.33,407,52005,70,NULL,NULL,'VIII Zw 377 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000096,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.0344583,-0.02767,0.089,NULL,43588125617,681064462,10641632,17.2),(117838,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117838,32.93,0.8,38.5,52006,75,NULL,NULL,'ESO 221- G 032',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000013,NULL,'12.76',1.9,'SA(r)c',NULL,NULL,NULL,NULL,1,213.037875,-49.38964,1.045,NULL,46841776400,731902756,11435980,12.76),(117839,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117839,36.63,0.46,212,52007,70,NULL,NULL,'2MASX J14120955+0537516',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.039833,5.63097,0.025,NULL,58474858651,913669666,14276088,17.4),(117840,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117840,36.88,0.46,238,52008,70,NULL,NULL,'2MASX J14120960+3104324',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000149,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.039917,31.07578,0,NULL,60053122458,938330038,14661406,17),(117841,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117841,36.55,0.46,204,52009,70,NULL,NULL,'2MASX J14120955+3228354',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.039917,32.47658,0.01,NULL,60034753460,938043022,14656922,16.5),(117842,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117842,36.51,0.46,200,52010,70,NULL,NULL,'SDSS J141209.60+044924.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000062,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.040041667,4.82361,0,NULL,58474143677,913658494,14275913,17.5),(117843,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117843,38.18,0.46,432,52011,70,NULL,NULL,'SDSS J141209.89+023907.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000076,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.04125,2.65206,0.097,NULL,58471961183,913624393,14275381,18.5),(117844,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117844,37.07,0.46,259,52012,70,NULL,NULL,'2MASX J14120999+3245194',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000191,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,213.0417083,32.7555,0,NULL,60034812871,938043951,14656936,15.9),(117845,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117845,37.57,0.46,327,52013,70,NULL,NULL,'2MASX J14121020+2636262',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.042583,26.60731,0,NULL,60002797455,937543710,14649120,17.2),(117846,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117846,37.84,0.33,369,52014,70,NULL,NULL,'2MASX J14121040+4021246',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.0435,40.35683,0,NULL,59257202800,925893793,14467090,17.3),(117847,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117847,36.91,0.46,241,52015,70,NULL,NULL,'2MASX J14121203+3929266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.05025,39.49086,0,NULL,59139921211,924061268,14438457,17.5),(117848,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117848,34.36,0.79,74.6,52016,NULL,NULL,NULL,'UGC 09084',NULL,'2009ApJS..182..474S',2009,1,1.08,'HOLM 600C is a star.','G',0.000103,NULL,'14.5g',0.89,'Sb',NULL,NULL,NULL,NULL,1,213.053041667,8.66183,0.01,NULL,58495966186,913999471,14281241,14.5),(117849,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117849,34.4,0.2,75.9,52016,74.4,NULL,NULL,'UGC 09084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117850,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117850,34.69,0.68,86.9,52016,NULL,NULL,'Malmquist cor.','UGC 09084',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117851,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117851,37.36,0.21,296,52017,70,NULL,NULL,'2MASX J14121314+5247194',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.054625,52.78867,0,NULL,59249349240,925771081,14465173,16.8),(117852,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117852,35.98,0.27,157,52018,70,NULL,NULL,'2MASX J14121311+2634522',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.054708333,26.58114,0,NULL,60002810373,937543912,14649123,16.4),(117853,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117853,37.24,0.27,281,52019,70,NULL,NULL,'2MASX J14121339+3002314',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.055833,30.04219,0,NULL,60051367013,938302609,14660978,17.5),(117854,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117854,38.05,0.46,407,52020,70,NULL,NULL,'2MASX J14121404+0759192',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.058667,7.98869,0,NULL,58504010608,914125165,14283205,17.2),(117855,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117855,38.54,0.46,512,52021,70,NULL,NULL,'SDSS J141214.71+082215.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.061333,8.37111,0.014,NULL,58504110280,914126723,14283230,18.7),(117856,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117856,37.68,0.46,343,52022,70,NULL,NULL,'2MASX J14121488+1437180',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.061916667,14.62175,0,NULL,58366632568,911978633,14249666,17.6),(117857,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117857,37.22,0.46,278,52023,70,NULL,NULL,'2MASX J14121591+1502150',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.20',0.18,NULL,NULL,NULL,NULL,NULL,1,213.066208333,15.03742,0,NULL,58366286319,911973223,14249581,18.2),(117858,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117858,34.2,NULL,69.2,52024,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09091',NULL,'2010Ap&SS.325..163P',2010,1,1.11,NULL,'G',0.000011,NULL,'16.6g',0.16,'Sbc',NULL,NULL,NULL,NULL,1,213.067833333,29.90744,0,NULL,60051327336,938301989,14660968,16.6),(117859,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117859,34.22,NULL,69.8,52024,NULL,NULL,'Dipole + Quadrupole','UGC 09091',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117860,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117860,34.23,NULL,70.1,52024,NULL,NULL,'Dipole','UGC 09091',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117861,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117861,34.29,NULL,72.1,52024,NULL,NULL,NULL,'UGC 09091',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117862,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117862,34.75,0.2,89.1,52024,74.4,NULL,NULL,'UGC 09091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117863,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117863,38.58,0.33,521,52025,70,NULL,NULL,'2MASX J14121663+4103378',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000136,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.069333333,41.06047,0,NULL,59224302929,925379733,14459058,17.6),(117864,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117864,36.52,0.53,202,52026,70,NULL,NULL,'ESO 578- G 034',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000123,NULL,'15.40',0.5,'SA0-',NULL,NULL,NULL,NULL,1,213.069833333,-21.18642,0.249,NULL,46517179080,726830923,11356733,15.4),(117865,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117865,37.06,0.46,258,52027,70,NULL,NULL,'2MASX J14121770+2427362',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000207,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.0737083,24.46,0,NULL,59468634320,929197411,14518709,16.4),(117866,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117866,36.37,0.64,188,52028,70,NULL,NULL,'2MASX J14121779-3418097',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.6b',NULL,'E',NULL,NULL,NULL,NULL,1,213.0740417,-34.30278,0.161,NULL,47002693438,734417084,11475266,16.6),(117867,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117867,37.09,0.46,262,52029,70,NULL,NULL,'2MASX J14121785+0602466',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.074333,6.04625,0.049,NULL,58474478269,913663722,14275995,17),(117868,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117868,36.87,0.46,236,52030,70,NULL,NULL,'2MASX J14121844+5007204',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.077041667,50.12242,0.022,NULL,59253214735,925831480,14466116,16.7),(117869,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117869,37.84,0.46,370,52031,70,NULL,NULL,'2MASX J14121897+5757295',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.079125,57.95842,0,NULL,57305899043,895404672,13990698,17.2),(117870,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117870,37.61,0.46,332,52032,70,NULL,NULL,'2MASX J14121966+5722135',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.082166667,57.37047,0,NULL,57305433116,895397392,13990584,16.9),(117871,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117871,35.35,0.51,118,52033,70,NULL,NULL,'2MASX J14121985-3658093',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.0827917,-36.96933,0.185,NULL,46995432087,734303626,11473494,14.4),(117872,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117872,37.36,0.21,296,52034,70,NULL,NULL,'2MASX J14121998+5246383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.083375,52.77717,0,NULL,59249467636,925772931,14465202,16.8),(117873,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117873,38.37,0.46,472,52035,70,NULL,NULL,'SDSS J141220.08+051032.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.0837083,5.17558,0.021,NULL,58474311539,913661117,14275954,18.4),(117874,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117874,34.84,0.8,93,52036,75,NULL,'HMCL, I','CGCG 074-135',NULL,'1997ApJS..109..333W',1997,1,1.13,NULL,'G',0.000027,NULL,'14.8g',0.47,NULL,NULL,NULL,NULL,NULL,1,213.087833,8.50861,0.014,NULL,58503337844,914114653,14283041,14.8),(117875,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117875,35.38,0.4,119,52036,75,NULL,'HMCL, I, raw','CGCG 074-135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117876,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117876,35.49,0.4,125,52036,75,NULL,'HMCL, I, cor','CGCG 074-135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117877,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117877,35.61,0.4,133,52036,75,NULL,'HMCL, I, inv','CGCG 074-135',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117878,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117878,36.47,0.87,197,52037,70,NULL,NULL,'2MASX J14122107-4750215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,213.0877083,-47.83936,0.793,NULL,46839723466,731870679,11435479,16.7),(117879,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117879,37.1,0.33,263,52038,70,NULL,NULL,'2MASX J14122164+0031496',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000081,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.09025,0.53042,0.077,NULL,58402444565,912538196,14258409,16.6),(117880,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117880,32.45,0.8,30.8,52039,75,NULL,'CF, r','NGC 5520',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'13.25',1.1,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,213.094958333,50.34842,0,NULL,59253247110,925831986,14466124,13.25),(117881,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117881,31.38,0.69,18.9,52039,100,NULL,'mid-IR','NGC 5520',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117882,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117882,32.48,0.4,31.4,52039,NULL,NULL,'mean','NGC 5520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117883,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117883,32.76,0.43,35.6,52039,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5520',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117884,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117884,32.92,0.43,38.4,52039,75,NULL,'3.6 micron, color corrected','NGC 5520',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117885,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117885,32.98,0.37,39.4,52039,NULL,NULL,NULL,'NGC 5520',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117886,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117886,32.98,0.45,39.5,52039,NULL,NULL,'K','NGC 5520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117887,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117887,33.02,0.47,40.3,52039,NULL,NULL,'H','NGC 5520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117888,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117888,33.05,0.46,40.7,52039,NULL,NULL,'J','NGC 5520',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117889,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117889,33.11,0.38,41.8,52039,75,NULL,'CF, r, raw','NGC 5520',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117890,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117890,33.13,0.2,42.3,52039,74.4,NULL,NULL,'NGC 5520',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117891,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117891,33.14,0.38,42.5,52039,75,NULL,'CF, r, cor','NGC 5520',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117892,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117892,33.22,0.38,44,52039,75,NULL,'CF, r, inv','NGC 5520',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117893,'Sosies','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117893,33.47,0.78,49.4,52040,NULL,NULL,NULL,'NGC 5494',NULL,'2002A&A...393...57T',2002,1,2.2,NULL,'G',0.000007,NULL,'12.59',1.9,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,213.10075,-30.64408,0.273,NULL,47038324001,734973812,11483965,12.59),(117894,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117894,37.69,0.46,346,52041,70,NULL,NULL,'2MASX J14122420+4043538',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.100875,40.73142,0,NULL,59224434379,925381787,14459090,17.1),(117895,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117895,34.64,0.56,84.8,52042,NULL,NULL,'Malmquist cor.','ESO 511- G 011',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.08',0.6,'SB(r)b:',NULL,NULL,NULL,NULL,1,213.1015417,-27.41433,0.217,NULL,46987680500,734182507,11471601,15.08),(117896,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117896,34.65,0.56,85.2,52042,NULL,NULL,NULL,'ESO 511- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117897,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117897,34.69,0.2,86.7,52042,74.4,NULL,NULL,'ESO 511- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117898,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117898,34.57,0.46,82.1,52043,70,NULL,NULL,'UGC 09090',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000163,NULL,'14.56',0.8,'S0-:',NULL,NULL,NULL,NULL,1,213.1017917,18.41178,0,NULL,59517598480,929962476,14530663,14.56),(117899,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117899,37.4,0.46,302,52044,70,NULL,NULL,'2MASX J14122452+5403025',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.102167,54.05061,0,NULL,59194375161,924912111,14451751,17.1),(117900,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117900,37.93,0.46,386,52045,70,NULL,NULL,'SDSS J141225.09+533756.6',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.1045417,53.63239,0,NULL,59194300174,924910940,14451733,17.5),(117901,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117901,37.23,0.46,279,52046,70,NULL,NULL,'2MASX J14122528+4704564',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.1052083,47.08242,0.028,NULL,59255037722,925859964,14466561,16.7),(117902,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117902,37.19,0.33,274,52047,70,NULL,NULL,'2MASX J14122538+4028308',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.105833,40.47533,0,NULL,59223718115,925370595,14458915,17.5),(117903,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117903,38.18,0.27,432,52048,70,NULL,NULL,'2MASX J14122642+0720202',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.0g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,213.1099583,7.33886,0.038,NULL,58506176721,914159011,14283734,17),(117904,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117904,37.1,0.46,264,52049,70,NULL,NULL,'2MASX J14122678+1838554',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.90',0.19,NULL,NULL,NULL,NULL,NULL,1,213.111625,18.64878,0,NULL,59517645039,929963203,14530675,17.9),(117905,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117905,37.19,0.33,274,52050,70,NULL,NULL,'2MASX J14122853+4030018',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,'PRED','18.42',0.18,NULL,NULL,NULL,NULL,NULL,1,213.1190417,40.50058,0,NULL,59223718767,925370605,14458915,18.42),(117906,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117906,36.87,0.46,236,52051,70,NULL,NULL,'2MASX J14122864+4525294',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.1192083,45.42472,0,NULL,59236992096,925578001,14462156,16.8),(117907,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117907,36.02,0.62,160,52052,70,NULL,NULL,'2MASX J14122917-3417417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.1215417,-34.29494,0.161,NULL,47002691272,734417051,11475266,15.2),(117908,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117908,35.23,0.46,111,52053,70,NULL,NULL,'CGCG 317-018',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000083,NULL,'15.3g',0.38,'S0',NULL,NULL,NULL,NULL,1,213.12225,64.37681,0.013,NULL,57933273615,905207400,14143865,15.3),(117909,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117909,35.12,0.33,106,52054,70,NULL,NULL,'NGC 5469',NULL,'2015arXiv151105856S',2015,1,0.79,'Identification as NGC 5469 is uncertain.','G',0.000097,NULL,'14.7g',0.62,NULL,NULL,NULL,NULL,NULL,1,213.124583,8.64794,0.01,NULL,58495982538,913999727,14281245,14.7),(117910,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117910,38.18,0.27,432,52055,70,NULL,NULL,'2MASX J14123055+0718446',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.127333,7.31239,0.038,NULL,58506172320,914158942,14283733,17.8),(117911,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117911,35.85,0.46,148,52056,70,NULL,NULL,'2MASX J14123068+6135366',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.12775,61.59367,0.017,NULL,57748328600,902317634,14098713,16.6),(117912,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117912,37.19,0.33,274,52057,70,NULL,NULL,'2MASX J14123270+2627392',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,213.136291667,26.46072,0,NULL,60003523817,937555059,14649297,18.28),(117913,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117913,38.11,0.27,418,52058,70,NULL,NULL,'2MASX J14123405+5400345',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.1419583,54.00967,0,NULL,59194367044,924911985,14451749,17.8),(117914,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117914,35.98,0.27,157,52059,70,NULL,NULL,'2MASX J14123417+2645561',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000207,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,213.142333,26.76561,0,NULL,60001369098,937521392,14648771,15.7),(117915,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117915,37.19,0.33,274,52060,70,NULL,NULL,'2MASX J14123487+2628161',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.145125,26.47103,0,NULL,60003523077,937555048,14649297,17.8),(117916,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117916,37.41,0.33,304,52061,70,NULL,NULL,'2MASX J14123487+4946112',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,213.14525,49.76983,0.022,NULL,59256793714,925887401,14466990,16.6),(117917,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117917,36.96,0.33,247,52062,70,NULL,NULL,'2MASX J14123609+5424085',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.1502083,54.40225,0.005,NULL,57252448600,894569509,13977648,17.2),(117918,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117918,37.96,0.46,392,52063,70,NULL,NULL,'2MASX J14123642+0536357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.151667,5.61,0.025,NULL,58474534960,913664608,14276009,17.2),(117919,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117919,37.33,0.46,292,52064,70,NULL,NULL,'SDSS J141237.25+545256.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,213.15525,54.88239,0.013,NULL,57252890115,894576408,13977756,18.3),(117920,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117920,35.97,0.2,156,52065,74.4,NULL,NULL,'UGC 09093',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'16.0g',0.28,'Scd:',NULL,NULL,NULL,NULL,1,213.158,12.02017,0,NULL,58491722115,913933158,14280205,16),(117921,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117921,37.31,0.46,290,52066,70,NULL,NULL,'2MASX J14123824+2251114',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,213.15925,22.85317,0.013,NULL,59469674750,929213667,14518963,18.18),(117922,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117922,35.4,0.46,120,52067,70,NULL,NULL,'NGC 5509',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00021,NULL,'15.2',0.6,'E/S0',NULL,NULL,NULL,NULL,1,213.164916667,20.387,0.008,NULL,59519709141,929995455,14531178,15.2),(117923,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117923,37.77,0.46,357,52068,70,NULL,NULL,'2MASX J14124174+2035556',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.59',0.12,NULL,NULL,NULL,NULL,NULL,1,213.174041667,20.59875,0.017,NULL,59519676145,929994939,14531170,18.59),(117924,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117924,37.49,0.46,314,52069,70,NULL,NULL,'2MASX J14124256+5415594',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.1775,54.26653,0.005,NULL,57252367978,894568249,13977628,16.9),(117925,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117925,37.41,0.33,304,52070,70,NULL,NULL,'2MASX J14124301+4948116',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.1792917,49.80325,0.022,NULL,59256794562,925887415,14466990,16.9),(117926,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117926,37.44,0.27,308,52071,70,NULL,NULL,'2MASX J14124382+4952066',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000215,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,213.182667,49.86847,0.024,NULL,59256758964,925886858,14466982,15.7),(117927,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117927,37.73,0.46,352,52072,70,NULL,NULL,'2MASX J14124406+3628498',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000241,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,213.1835,36.48058,0,NULL,60030927026,937983234,14655988,16),(117928,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117928,36.65,0.46,213,52073,70,NULL,NULL,'SDSS J141245.43+162251.7',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.1892917,16.38106,0,NULL,59485436302,929459942,14522811,16.8),(117929,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117929,37.94,0.46,388,52074,70,NULL,NULL,'SDSS J141245.48+592417.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.1895417,59.40492,0,NULL,57272600380,894884380,13982568,18.2),(117930,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117930,38.22,0.46,441,52075,70,NULL,NULL,'SDSS J141245.58+050353.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.1899583,5.06483,0.029,NULL,58474339212,913661550,14275961,17.6),(117931,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117931,37.25,0.33,282,52076,70,NULL,NULL,'2MASX J14124563+4757347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.1899583,47.95964,0.021,NULL,59255998416,925874975,14466796,16.8),(117932,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117932,37.74,0.46,353,52077,70,NULL,NULL,'2MASX J14124565+4109348',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.190125,41.15961,0,NULL,59224273976,925379280,14459051,17.4),(117933,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117933,37.94,0.46,388,52078,70,NULL,NULL,'2MASX J14124627+2001096',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'18.10',0.13,NULL,NULL,NULL,NULL,NULL,1,213.192958333,20.01928,0.009,NULL,59519634406,929994287,14531160,18.1),(117934,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117934,36.04,0.52,161,52079,70,NULL,NULL,'2MASX J14124688-3749123',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,213.19525,-37.82008,0.213,NULL,46996408856,734318888,11473732,13.7),(117935,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117935,37.56,0.46,325,52080,70,NULL,NULL,'SDSS J141249.59+055628.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000123,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.206667,5.94133,0.049,NULL,58474606887,913665732,14276027,18),(117936,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117936,36.3,0.46,182,52081,70,NULL,NULL,'2MASX J14125010+0452247',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000083,NULL,'15.7g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,213.2087083,4.8735,0,NULL,58474135230,913658362,14275911,15.7),(117937,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117937,38.58,0.33,521,52082,70,NULL,NULL,'2MASX J14125132+4108094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.21375,41.13586,0,NULL,59224263609,925379118,14459048,18.1),(117938,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117938,36.92,0.46,242,52083,70,NULL,NULL,'2MASX J14125329+2006037',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.93',0.3,NULL,NULL,NULL,NULL,NULL,1,213.222208333,20.10103,0.009,NULL,59519641096,929994392,14531162,16.93),(117939,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117939,36.72,0.46,221,52084,70,NULL,NULL,'2MASX J14125378+4805567',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,213.2239583,48.09922,0,NULL,59255979307,925874676,14466791,16.3),(117940,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117940,37.8,0.46,364,52085,70,NULL,NULL,'2MASX J14125408+1349424',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.22525,13.82864,0,NULL,58367105199,911986018,14249781,17),(117941,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117941,37.14,0.46,267,52086,70,NULL,NULL,'2MASX J14125428+2239577',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.84',0.22,NULL,NULL,NULL,NULL,NULL,1,213.226291667,22.66603,0.012,NULL,59469825409,929216022,14519000,17.84),(117942,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117942,37.63,0.46,336,52087,70,NULL,NULL,'2MASX J14125434+0659516',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.2265,6.99767,0.042,NULL,58506307055,914161047,14283766,17.3),(117943,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117943,36.81,0.46,231,52088,70,NULL,NULL,'2MASX J14125472+3540316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.227917,35.67542,0,NULL,60044450649,938194541,14659289,17),(117944,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117944,37,0.46,251,52089,70,NULL,NULL,'2MASX J14125547+2118077',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.18,'AGN',NULL,NULL,NULL,NULL,1,213.231166667,21.30217,0.026,NULL,59463738898,929120920,14517514,18.2),(117945,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117945,34.74,0.47,88.6,52090,70,NULL,NULL,'ESO 446- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.68',0.7,'Sab: pec',NULL,NULL,NULL,NULL,1,213.233833,-28.77408,0.189,NULL,47039140326,734986567,11484165,14.68),(117946,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117946,38.11,0.46,419,52091,70,NULL,NULL,'2MASX J14125678+2809271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.236417,28.15761,0,NULL,60056161494,938377523,14662148,17.5),(117947,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS11fi','N',117947,37.74,0.15,326,52092,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11fi HOST',0.0822,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117948,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117948,36.26,0.46,179,52093,70,NULL,NULL,'2MASX J14125722+2844501',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.238333,28.74736,0,NULL,60058288615,938410759,14662668,16.4),(117949,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117949,37.58,0.46,329,52094,70,NULL,NULL,'2MASX J14125843+3027497',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000196,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.243625,30.46378,0,NULL,60053032204,938328628,14661384,16.6),(117950,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117950,37.52,0.46,319,52095,70,NULL,NULL,'LCRS B141024.3-025351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.2495417,-3.13106,0.121,NULL,43735534122,683367720,10677620,17.3),(117951,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117951,37.44,0.27,308,52096,70,NULL,NULL,'2MASX J14130016+4953087',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.250583,49.88569,0.024,NULL,59253298093,925832782,14466137,17.3),(117952,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117952,37.36,0.46,296,52097,70,NULL,NULL,'VIII Zw 379 NED03',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000083,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.25525,-1.12408,0.133,NULL,43722359026,683161859,10674404,16.7),(117953,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117953,37.81,0.46,365,52098,70,NULL,NULL,'SDSS J141301.80+160438.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.257541667,16.07742,0,NULL,59485267172,929457299,14522770,18.2),(117954,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117954,38.21,0.46,438,52099,70,NULL,NULL,'2MASX J14130301+4057104',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.2625417,40.95283,0,NULL,59224458730,925382167,14459096,17.7),(117955,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117955,37.07,0.46,259,52100,70,NULL,NULL,'2MASX J14130450+4448329',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.269,44.80919,0,NULL,59240152531,925627383,14462927,17.8),(117956,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117956,36.01,0.52,159,52101,70,NULL,NULL,'2MASX J14130649-3405476',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.7b',0.7,'E',NULL,NULL,NULL,NULL,1,213.2769583,-34.09667,0.137,NULL,47003992395,734437381,11475584,15.7),(117957,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117957,37.74,0.33,354,52102,70,NULL,NULL,'2MASX J14130662+0820019',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.2777083,8.33378,0.029,NULL,58503792924,914121764,14283152,17.6),(117958,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117958,37.52,0.46,319,52103,70,NULL,NULL,'2MASX J14130799+3125147',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,213.283417,31.42081,0,NULL,60052739879,938324060,14661313,16.4),(117959,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117959,38.18,0.27,432,52104,70,NULL,NULL,'2MASX J14130840+0718199',NULL,'2015arXiv151105856S',2015,1,0.31,'May contribute to the IR source IRAS F14106+0732.','G',0.000167,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.284958333,7.30553,0.039,NULL,58506197662,914159338,14283739,17),(117960,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117960,37.5,0.46,316,52105,70,NULL,NULL,'SDSS J141308.52+210320.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.59',0.14,NULL,NULL,NULL,NULL,NULL,1,213.285583,21.05581,0.032,NULL,59519383788,929990371,14531099,18.59),(117961,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117961,33.76,0.33,56.4,52106,70,NULL,NULL,'NGC 5513',NULL,'2015arXiv151105856S',2015,1,1.9,NULL,'G',0.000103,NULL,'13.64',1.1,'S0',NULL,NULL,NULL,NULL,1,213.285958333,20.41628,0.008,NULL,59519698198,929995284,14531176,13.64),(117962,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117962,36.93,0.27,243,52107,70,NULL,NULL,'2MASX J14130965+2722135',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000123,NULL,'16.64',0.29,NULL,NULL,NULL,NULL,NULL,1,213.290333,27.37036,0,NULL,60001470169,937522971,14648796,16.64),(117963,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117963,28.11,0.8,4.2,52108,75,NULL,'B','Circinus Galaxy',NULL,'1988NBGC.C....0000T',1988,1,6.9,'Within 10 degrees of the galactic plane.','G',0.00001,NULL,'12.1',3,'SA(s)b:        Sy2','Pair member (points to parent)',NULL,NULL,'Sy 1 h',1,213.2914583,-65.33922,NULL,NULL,45078986730,704359167,11005611,12.1),(117964,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117964,28.12,NULL,4.21,52108,NULL,NULL,NULL,'Circinus Galaxy',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117965,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117965,28.12,0.36,4.21,52108,NULL,NULL,NULL,'Circinus Galaxy',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117966,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117966,37.16,0.46,271,52109,70,NULL,NULL,'2MASX J14131048+0146169',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000132,NULL,'15.8g',0.37,'S0',NULL,NULL,NULL,NULL,1,213.29375,1.77142,0.065,NULL,58472588716,913634198,14275534,15.8),(117967,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117967,35.38,0.46,119,52110,70,NULL,NULL,'2MASX J14131087+1056419',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000161,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.295417,10.94511,0,NULL,58500568996,914071390,14282365,15.8),(117968,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117968,37.76,0.46,356,52111,70,NULL,NULL,'SDSS J141311.05+052825.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.296083,5.47383,0.025,NULL,58474506752,913664168,14276002,17.8),(117969,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117969,38.04,0.46,406,52112,70,NULL,NULL,'2MASX J14131122+1939517',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.1g',0.24,'AGN',NULL,NULL,NULL,NULL,1,213.296667,19.66436,0,NULL,59520785125,930012267,14531441,17.1),(117970,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117970,38.31,0.27,459,52113,70,NULL,NULL,'SDSS J141312.28+053300.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.3012083,5.55,0.025,NULL,58474558384,913664974,14276015,18),(117971,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117971,38.11,0.27,418,52114,70,NULL,NULL,'2MASX J14131235+5359343',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.3014583,53.99286,0.005,NULL,59194395659,924912432,14451756,16.9),(117972,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117972,36.68,0.15,217,52115,70,NULL,NULL,'2MASX J14131259+2432235',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.3025,24.53997,0,NULL,59470537512,929227148,14519174,17.2),(117973,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117973,38.21,0.46,438,52116,70,NULL,NULL,'LCRS B141037.5-022019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.303375,-2.57206,0.149,NULL,43724207671,683190744,10674855,18.4),(117974,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117974,38.06,0.46,409,52117,70,NULL,NULL,'SDSS J141313.16+051304.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.304875,5.218,0.073,NULL,58474179740,913659058,14275922,18.3),(117975,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117975,36.79,0.59,228,52118,70,NULL,NULL,'2MASX J14131352-2024065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,213.306417,-20.40192,0.269,NULL,46562627496,727541054,11367828,16.37),(117976,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117976,36.93,0.27,243,52119,70,NULL,NULL,'2MASX J14131386+2719135',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.307875,27.32047,0,NULL,60001462939,937522858,14648794,16.6),(117977,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117977,37.44,0.46,308,52120,70,NULL,NULL,'2MASX J14131485+2151444',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.23',0.17,NULL,NULL,NULL,NULL,NULL,1,213.311875,21.86244,0.024,NULL,59471066391,929235412,14519303,18.23),(117978,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117978,32.29,0.8,28.7,52121,75,NULL,NULL,'NGC 5506',NULL,'1988NBGC.C....0000T',1988,1,3.16,NULL,'G',0.000027,NULL,'12.8g',0.75,'Sa pec sp      Sy1.9','Pair member (points to parent)',NULL,NULL,'Sy 1 i',1,213.312041667,-3.20758,0.121,NULL,43735471042,683366735,10677605,12.8),(117979,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117979,31.1,0.45,16.6,52121,NULL,NULL,'K','NGC 5506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117980,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117980,31.48,0.47,19.8,52121,NULL,NULL,'H','NGC 5506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117981,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117981,31.68,0.46,21.7,52121,NULL,NULL,'J','NGC 5506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117982,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117982,31.88,NULL,23.8,52121,72,NULL,NULL,'NGC 5506',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117983,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117983,32.04,0.49,25.6,52121,75,NULL,'IR','NGC 5506',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117984,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117984,32.17,0.4,27.2,52121,NULL,NULL,'mean','NGC 5506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117985,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117985,32.31,0.3,29,52121,55,NULL,'B','NGC 5506',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117986,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117986,37.87,0.23,376,52122,70,NULL,NULL,'2MASX J14131550+4340109',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.314583,43.66961,0,NULL,59239352085,925614876,14462732,17),(117987,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',117987,37.67,0.46,341,52123,70,NULL,NULL,'2MASX J14131589+4316109',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.31625,43.26964,0,NULL,59226197793,925409340,14459520,17),(117988,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117988,34.29,0.8,71.9,52124,75,NULL,'HMCL, I','UGC 09101',NULL,'1997ApJS..109..333W',1997,1,1.72,NULL,'G',0.00001,NULL,'14.2g',0.75,'Sb',NULL,NULL,NULL,NULL,1,213.3170417,27.00808,0,NULL,60001383462,937521616,14648775,14.2),(117989,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117989,34.29,0.8,72,52124,75,NULL,'CF, r','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117990,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117990,33.5,0.69,50.2,52124,100,NULL,'mid-IR','UGC 09101',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117991,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117991,34.36,0.4,74.3,52124,75,NULL,'HMCL, I, raw','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117992,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117992,34.42,0.4,76.7,52124,NULL,NULL,'mean','UGC 09101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117993,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117993,34.55,0.4,81.2,52124,75,NULL,'HMCL, I, inv','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117994,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117994,34.58,0.4,82.5,52124,75,NULL,'HMCL, I, cor','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117995,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117995,34.6,0.38,83,52124,75,NULL,'CF, r, raw','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117996,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117996,34.75,0.66,88.9,52124,NULL,NULL,'Malmquist cor.','UGC 09101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117997,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117997,34.76,0.38,89.6,52124,75,NULL,'CF, r, inv','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117998,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117998,34.78,0.2,90.4,52124,74.4,NULL,NULL,'UGC 09101',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(117999,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,117999,34.88,0.47,94.7,52124,NULL,NULL,'H','UGC 09101',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118000,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118000,34.91,0.38,95.9,52124,75,NULL,'CF, r, cor','UGC 09101',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118001,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118001,34.91,0.61,96.1,52124,NULL,NULL,NULL,'UGC 09101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118002,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118002,36.68,0.15,217,52125,70,NULL,NULL,'2MASX J14131846+2429545',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.327083,24.49836,0,NULL,59470539444,929227178,14519174,16.9),(118003,'Tully est','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118003,32.68,0.8,34.3,52126,75,NULL,NULL,'NGC 5507',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'13.55',0.9,'SAB(r)0^0^','Pair member (points to parent)',NULL,NULL,NULL,1,213.3327917,-3.14889,0.121,NULL,43735473187,683366768,10677605,13.55),(118004,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118004,37.94,0.33,387,52127,70,NULL,NULL,'2MASX J14132088+5241174',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.336667,52.68808,0,NULL,59249501674,925773463,14465210,18.2),(118005,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118005,38.11,0.27,418,52128,70,NULL,NULL,'2MASX J14132142+5359193',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.339083,53.98872,0.005,NULL,59194407631,924912619,14451759,17.4),(118006,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118006,37.46,0.46,311,52129,70,NULL,NULL,'2MASX J14132245+0838159',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.343667,8.63781,0.023,NULL,58496826876,914012919,14281451,17.2),(118007,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118007,34.94,0.8,97.1,52130,75,NULL,'HMCL, I','MCG +02-36-054',NULL,'1997ApJS..109..333W',1997,1,0.27,'Holmberg 608b includes the star just northeast.','G',0.000083,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.34475,8.96297,0.006,NULL,58496028691,914000448,14281257,17.2),(118008,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118008,35.11,0.4,105,52130,75,NULL,'HMCL, I, raw','MCG +02-36-054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118009,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118009,35.23,0.4,111,52130,75,NULL,'HMCL, I, cor','MCG +02-36-054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118010,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118010,35.28,0.4,114,52130,75,NULL,'HMCL, I, inv','MCG +02-36-054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118011,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118011,36.68,0.15,217,52131,70,NULL,NULL,'CGCG 133-012',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000117,NULL,'15.1g',0.6,NULL,NULL,NULL,NULL,NULL,1,213.346375,24.53242,0,NULL,59470573063,929227704,14519182,15.1),(118012,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118012,37.29,0.46,287,52132,70,NULL,NULL,'2MASX J14132390+1851414',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.3497083,18.86153,0,NULL,59517540981,929961577,14530649,16.5),(118013,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118013,35.69,0.46,137,52133,70,NULL,NULL,'2MASX J14132439+0623049',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000181,NULL,'15.4g',0.46,NULL,NULL,NULL,NULL,NULL,1,213.351667,6.38464,0.037,NULL,58505605863,914150091,14283595,15.4),(118014,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118014,37.78,0.46,360,52134,70,NULL,NULL,'2MASX J14132440+1709102',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.15,NULL,NULL,NULL,NULL,NULL,1,213.351833,17.15283,0,NULL,59487492587,929492071,14523313,18.62),(118015,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118015,38.4,0.46,478,52135,70,NULL,NULL,'SDSS J141326.32+065857.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.3597083,6.98269,0.029,NULL,58506129322,914158270,14283722,18.7),(118016,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118016,35.24,0.2,112,52136,74.4,NULL,NULL,'CGCG 074-145',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000027,NULL,'15.0',0.4,'Sy2',NULL,NULL,NULL,NULL,1,213.364083,8.98089,0.006,NULL,58496717656,914011213,14281425,15),(118017,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118017,35.24,0.49,112,52137,75,NULL,'IR','CGCG 074-145',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000027,NULL,'15.0',0.4,'Sy2',NULL,NULL,NULL,NULL,1,213.364083,8.98089,0.006,NULL,58496717656,914011213,14281425,15),(118018,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118018,37.59,0.46,330,52138,70,NULL,NULL,'2MASX J14132877+0929363',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'18.04',0.13,NULL,NULL,NULL,NULL,NULL,1,213.37,9.4935,0,NULL,58498906423,914045412,14281959,18.04),(118019,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118019,37.06,0.46,258,52139,70,NULL,NULL,'2MASX J14132880+2825345',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000184,NULL,'18.04',0.18,NULL,NULL,NULL,NULL,NULL,1,213.37,28.42614,0,NULL,60056188500,938377945,14662155,18.04),(118020,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118020,32.75,0.8,35.5,52140,75,NULL,'MAT, I','ESO 271- G 022',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00001,NULL,'14.02',0.4,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,213.3754583,-45.41358,0.421,NULL,46805065118,731329142,11427017,14.02),(118021,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118021,32.57,0.43,32.7,52140,75,NULL,'MAT, I, raw','ESO 271- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118022,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118022,32.64,0.32,33.7,52140,85,NULL,'I, raw','ESO 271- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118023,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118023,32.68,0.32,34.3,52140,85,NULL,'I, inv','ESO 271- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118024,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118024,32.74,0.49,35.3,52140,75,NULL,'IR','ESO 271- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118025,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118025,32.75,0.43,35.4,52140,75,NULL,'MAT, I, inv','ESO 271- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118026,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118026,32.84,0.43,36.9,52140,75,NULL,'MAT, I, cor','ESO 271- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118027,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118027,32.93,0.2,38.6,52140,74.4,NULL,NULL,'ESO 271- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118028,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118028,33.03,0.43,40.4,52140,75,NULL,'3.6 micron, color corrected','ESO 271- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118029,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118029,33.08,0.49,41.4,52140,NULL,NULL,NULL,'ESO 271- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118030,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118030,33.12,0.43,42.1,52140,75,NULL,'3.6 micron, color + selection bias corrected','ESO 271- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118031,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118031,33.14,0.47,42.4,52140,NULL,NULL,'Malmquist cor.','ESO 271- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118032,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118032,37.74,0.33,354,52141,70,NULL,NULL,'2MASX J14133032+0812143',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0002,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,213.3765,8.20386,0.035,NULL,58503798826,914121856,14283154,18.18),(118033,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118033,38.19,0.46,434,52142,70,NULL,NULL,'SDSS J141332.57+430713.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.3857083,43.12036,0,NULL,59226730633,925417666,14459651,18.4),(118034,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118034,36.95,0.46,245,52143,70,NULL,NULL,'2MASXi J1413340+400908',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00012,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.391916667,40.15247,0,NULL,59223606256,925368847,14458888,17.6),(118035,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118035,37.44,0.46,308,52144,70,NULL,NULL,'SDSS J141334.17+314345.1',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'15.9g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.392375,31.72922,0,NULL,60052948179,938327315,14661364,15.9),(118036,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118036,36.72,0.55,221,52145,70,NULL,NULL,'2MASX J14133582-4534105',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.8b',0.3,NULL,NULL,NULL,NULL,NULL,1,213.39925,-45.56964,0.421,NULL,46805059872,731329060,11427016,16.8),(118037,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118037,37.91,0.46,382,52146,70,NULL,NULL,'SDSS J141335.98+472108.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.3999583,47.35233,0.017,NULL,59246854788,925732106,14464564,17.9),(118038,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118038,36.93,0.27,243,52147,70,NULL,NULL,'2MASX J14133652+2722365',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'18.06',0.18,NULL,NULL,NULL,NULL,NULL,1,213.4020417,27.37681,0,NULL,60001475018,937523047,14648797,18.06),(118039,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118039,37.49,0.27,314,52148,70,NULL,NULL,'2MASX J14133699+1950224',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.4040417,19.83961,0.035,NULL,59520778091,930012157,14531439,17.7),(118040,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118040,37.59,0.33,329,52149,70,NULL,NULL,'2MASX J14133714+3105084',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.404917,31.08572,0,NULL,60052632466,938322382,14661287,17.4),(118041,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118041,36.04,0.46,161,52150,70,NULL,NULL,'2MASX J14133814+5415511',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.409041667,54.26428,0,NULL,57252374640,894568353,13977630,16.6),(118042,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118042,36.12,0.46,168,52151,70,NULL,NULL,'2MASX J14133979+4141251',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000183,NULL,'15.6g',0.46,'E0',NULL,NULL,NULL,NULL,1,213.4160417,41.69036,0,NULL,59227514379,925429912,14459842,15.6),(118043,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118043,38.37,0.46,472,52152,70,NULL,NULL,'2MASX J14134008+0530581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000187,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.417083,5.51617,0.025,NULL,58476581044,913696578,14276509,17.6),(118044,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118044,37.69,0.33,345,52153,70,NULL,NULL,'2MASX J14134035+2553462',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.41825,25.89608,0.024,NULL,60003495686,937554620,14649290,17),(118045,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118045,37.49,0.27,314,52154,70,NULL,NULL,'2MASX J14134082+1953254',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.420083,19.89031,0.035,NULL,59520773195,930012081,14531438,16.7),(118046,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118046,37.87,0.23,376,52155,70,NULL,NULL,'2MASX J14134091+4345420',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00011,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.4202917,43.76175,0,NULL,59239324989,925614452,14462725,17.8),(118047,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118047,38.31,0.27,459,52156,70,NULL,NULL,'SDSS J141341.14+053608.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.4214583,5.60244,0.025,NULL,58476566748,913696355,14276505,18.4),(118048,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118048,36.66,0.46,215,52157,70,NULL,NULL,'SBS 1411+497',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,213.4260417,49.50106,0,NULL,59256420802,925881575,14466899,16.5),(118049,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118049,37.87,0.23,376,52158,70,NULL,NULL,'2MASX J14134352+4338410',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00006,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,213.43125,43.64478,0,NULL,59239359720,925614995,14462734,16.6),(118050,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118050,37.87,0.23,376,52159,70,NULL,NULL,'2MASX J14134379+4339450',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'18.4',0.15,'cD;BLRG       blazar',NULL,NULL,NULL,'Sy ?',1,213.432167,43.66253,0,NULL,59239322625,925614416,14462725,18.4),(118051,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118051,36.34,0.46,185,52160,70,NULL,NULL,'2MASX J14134472+2634583',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000097,NULL,'15.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,213.4362917,26.58281,0,NULL,60003309235,937551706,14649245,15.5),(118052,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118052,37.33,0.46,292,52161,70,NULL,NULL,'2MASX J14134757+2231555',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.79',0.18,NULL,NULL,NULL,NULL,NULL,1,213.448333,22.532,0.013,NULL,59469932045,929217688,14519026,17.79),(118053,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118053,33.76,0.33,56.4,52162,70,NULL,NULL,'NGC 5518',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000147,NULL,'15.0',0.4,NULL,NULL,NULL,NULL,NULL,1,213.448667,20.84831,0.021,NULL,59519365562,929990086,14531095,15),(118054,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118054,36.83,0.12,232,52163,70,NULL,NULL,'2MASX J14134858+0155281',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,'FoF','18.11',0.21,NULL,NULL,NULL,NULL,NULL,1,213.4522917,1.92425,0.077,NULL,58472353347,913630521,14275476,18.11),(118055,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118055,37.87,0.33,374,52164,70,NULL,NULL,'SDSS J141348.66+065726.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.452791667,6.95747,0.033,NULL,58506148097,914158564,14283727,17.5),(118056,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118056,37.94,0.33,387,52165,70,NULL,NULL,'2MASX J14134939+5247115',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.4559583,52.78658,0,NULL,59249492727,925773323,14465208,17.5),(118057,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118057,38.09,0.46,415,52166,70,NULL,NULL,'2MASX J14134988+1345123',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.45775,13.75356,0,NULL,58366895418,911982740,14249730,17.5),(118058,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118058,37.41,0.46,303,52167,70,NULL,NULL,'SDSS J141350.16+035247.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000059,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.459,3.87992,0.041,NULL,58483718031,913808094,14278251,18.4),(118059,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118059,37.69,0.33,345,52168,70,NULL,NULL,'SDSS J141351.41+254408.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.46425,25.73572,0,NULL,60003490023,937554531,14649289,18),(118060,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118060,37.16,0.46,270,52169,70,NULL,NULL,'2MASX J14135226+2601164',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000217,NULL,'17.11',0.27,NULL,NULL,NULL,NULL,NULL,1,213.467833,26.02136,0,NULL,60003474823,937554294,14649285,17.11),(118061,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118061,37.33,0.46,293,52170,70,NULL,NULL,'2MASX J14135241+0713093',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000165,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,213.4685,7.21933,0.035,NULL,58505999448,914156241,14283691,16.5),(118062,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118062,31.39,0.49,19,52171,75,NULL,'IR','NGC 5526 NED02',NULL,'2011yCatp016004901K',2011,1,2.56,NULL,'G',0.00008,NULL,'14.1g',0.39,'Scd','Pair member (points to parent)',NULL,NULL,NULL,1,213.474,57.77133,0,NULL,57305835546,895403680,13990682,14.1),(118063,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118063,31.95,0.43,24.6,52171,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5526 NED02',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118064,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118064,32.26,0.43,28.3,52171,75,NULL,'3.6 micron, color corrected','NGC 5526 NED02',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118065,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118065,32.56,0.2,32.5,52171,74.4,NULL,NULL,'NGC 5526 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118066,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118066,33.05,NULL,40.7,52171,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5526 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118067,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118067,33.06,NULL,41,52171,NULL,NULL,'Dipole + Quadrupole','NGC 5526 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118068,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118068,33.08,NULL,41.3,52171,NULL,NULL,'Dipole','NGC 5526 NED02',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118069,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118069,37.57,0.46,327,52172,70,NULL,NULL,'2MASX J14135437+4537330',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.476583,45.62592,0,NULL,59237040895,925578763,14462168,17.9),(118070,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118070,35.51,0.55,126,52173,NULL,NULL,'Malmquist cor.','ESO 446- G 033',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.82',0.6,'Sb',NULL,NULL,NULL,NULL,1,213.481125,-32.60944,0.177,NULL,47004450558,734444539,11475695,15.82),(118071,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118071,35.56,0.53,130,52173,NULL,NULL,NULL,'ESO 446- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118072,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118072,35.6,0.2,132,52173,74.4,NULL,NULL,'ESO 446- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118073,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118073,38.25,0.21,447,52174,70,NULL,NULL,'2MASX J14135607+0648485',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.483583333,6.81358,0.037,NULL,58505683299,914151301,14283614,18),(118074,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118074,36.83,0.12,232,52175,70,NULL,NULL,'CGCG 018-085',NULL,'2015arXiv151105856S',2015,1,0.57,'UZC has V = 16026 +- 47 km/sec.','G',0.000095,NULL,'16.0g',0.31,'S0','Group member',NULL,NULL,NULL,1,213.497666667,1.83181,0.077,NULL,58472479371,913632490,14275507,16),(118075,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118075,36.69,0.46,218,52176,70,NULL,NULL,'2MASX J14140022-0259299',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.500833,-2.99169,0.129,NULL,43724122480,683189413,10674834,16.9),(118076,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118076,37.76,0.46,356,52177,70,NULL,NULL,'2MASX J14140067+4845564',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.5027083,48.76572,0.091,NULL,59256488903,925882639,14466916,17.5),(118077,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118077,37.59,0.33,329,52178,70,NULL,NULL,'2MASX J14140145+3108537',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,213.505916667,31.14822,0,NULL,60052652740,938322699,14661292,18.33),(118078,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118078,37.99,0.46,397,52179,70,NULL,NULL,'2MASX J14140149+1239404',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.5062083,12.66117,0,NULL,58353437897,911772467,14246444,18.2),(118079,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118079,37.41,0.46,304,52180,70,NULL,NULL,'SDSS J141401.96+190403.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,213.5082083,19.06772,0,NULL,59521038357,930016224,14531503,NULL),(118080,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118080,37.25,0.33,282,52181,70,NULL,NULL,'2MASX J14140222+4753520',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.5092083,47.89786,0.034,NULL,59255948571,925874196,14466784,17.7),(118081,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118081,37.15,0.46,270,52182,70,NULL,NULL,'SDSS J141402.27+241633.2',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000213,NULL,'16.0g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.5094583,24.27592,0,NULL,59470772059,929230813,14519231,16),(118082,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118082,36.05,0.46,162,52183,70,NULL,NULL,'CGCG 018-086',NULL,'2015arXiv151105856S',2015,1,0.45,'Beers et al (1995AJ....109..874B) have V = 16064 +- 50 km/s.','G',0.00009,NULL,'15.9g',0.35,'S0a','Group member',NULL,NULL,NULL,1,213.509625,1.84789,0.077,NULL,58472480629,913632509,14275507,15.9),(118083,'SNIa','2016-12-15 15:15:22','2016-12-16 11:20:35','1','PS1 SN PS10kl','N',118083,41.82,0.16,1600,52184,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kl HOST',0.4434,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118084,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118084,35.85,0.6,148,52185,70,NULL,NULL,'2MASX J14140548-0744061',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.2b',0.3,NULL,NULL,NULL,NULL,NULL,1,213.522917,-7.73525,0.093,NULL,43740583273,683446613,10678853,16.2),(118085,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118085,38.25,0.21,447,52186,70,NULL,NULL,'2MASX J14140580+0653395',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00013,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.52425,6.89444,0.033,NULL,58506095777,914157746,14283714,17.5),(118086,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118086,37.58,0.27,327,52187,70,NULL,NULL,'2MASX J14140648+0843195',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,213.526875,8.72219,0.017,NULL,58496900375,914014068,14281469,17.98),(118087,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118087,37.06,0.46,258,52188,70,NULL,NULL,'2MASX J14140900+4311510',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000195,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,213.537375,43.19736,0,NULL,59224890434,925388913,14459201,15.8),(118088,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118088,38.25,0.21,447,52189,70,NULL,NULL,'2MASX J14141231+0652025',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.6g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,213.551333,6.86747,0.033,NULL,58506093735,914157714,14283714,16.6),(118089,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118089,37.79,0.46,361,52190,70,NULL,NULL,'2MASX J14141245+1837255',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,213.551917,18.62381,0,NULL,59517462200,929960346,14530630,NULL),(118090,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118090,37.17,0.46,272,52191,70,NULL,NULL,'VIII Zw 384',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.5519583,1.07553,0.065,NULL,58469612727,913587698,14274807,17.4),(118091,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118091,38.14,0.46,425,52192,70,NULL,NULL,'2MASX J14141263+0816335',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.552541667,8.27614,0.036,NULL,58496298172,914004658,14281322,17.4),(118092,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118092,34.26,0.4,71.1,52193,NULL,NULL,'mean','UGC 09110',NULL,'2007A&A...465...71T',2007,1,1.85,NULL,'G',0.000031,NULL,'13.9g',0.62,'SBb','Group member',NULL,NULL,NULL,1,213.555833,15.62242,0,NULL,58357550171,911836721,14247448,13.9),(118093,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118093,34.45,0.47,77.6,52193,NULL,NULL,'H','UGC 09110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118094,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118094,34.56,0.46,81.5,52193,NULL,NULL,'J','UGC 09110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118095,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118095,34.58,0.45,82.4,52193,NULL,NULL,'K','UGC 09110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118096,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118096,37.19,0.46,275,52194,70,NULL,NULL,'2MASX J14141406+0314360',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000087,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.558416667,3.24325,0.049,NULL,58484184239,913815378,14278365,16.4),(118097,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118097,37.61,0.46,332,52195,70,NULL,NULL,'2MASX J14141461+5057121',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.561,50.95347,0,NULL,59251558930,925805608,14465712,17.3),(118098,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118098,38.31,0.27,459,52196,70,NULL,NULL,'2MASX J14141479+0523490',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.561583,5.39711,0.037,NULL,58476555164,913696174,14276502,17.7),(118099,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118099,37.58,0.27,327,52197,70,NULL,NULL,'2MASX J14141579+0836405',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.565667,8.61131,0.017,NULL,58496895690,914013995,14281468,16.6),(118100,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118100,38.25,0.21,447,52198,70,NULL,NULL,'2MASX J14141601+0652365',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000057,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.566625,6.87686,0.033,NULL,58506097913,914157779,14283715,17.4),(118101,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118101,36.6,0.46,209,52199,70,NULL,NULL,'VII Zw 540 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000065,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.568417,63.5505,0.021,NULL,57749669667,902338588,14099040,17.4),(118102,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118102,35.72,0.76,139,52200,70,NULL,NULL,'LCRS B141143.7-025714',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000094,NULL,'16.4b',0.3,'HII',NULL,NULL,NULL,'Post Starburst (E+A) or (a+k) Galaxy',1,213.580417,-3.18653,0.125,NULL,43735989603,683374837,10677731,16.4),(118103,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118103,37.69,0.46,344,52201,70,NULL,NULL,'2MASX J14141946+2831428',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.581125,28.52856,0,NULL,60056292104,938379564,14662180,17.8),(118104,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118104,38.24,0.46,445,52202,70,NULL,NULL,'SDSS J141419.61+302241.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.58175,30.37811,0,NULL,60051168877,938299513,14660929,18.6),(118105,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118105,37.49,0.27,314,52203,70,NULL,NULL,'2MASX J14141983+1949010',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,213.5825417,19.81697,0.035,NULL,59521241836,930019403,14531553,16.2),(118106,'IRAS','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118106,35.03,0.8,102,52204,75,NULL,'HMCL, I','NGC 5519',NULL,'1997ApJS..109..333W',1997,1,1.24,'Identification as NGC 5570 is uncertain.','G',0.00001,NULL,'14.4g',0.75,'Sa',NULL,NULL,NULL,NULL,1,213.5869583,7.51592,0.042,NULL,58505844089,914153813,14283653,14.4),(118107,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118107,34.19,0.69,69,52204,100,NULL,'mid-IR','NGC 5519',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118108,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118108,34.48,0.49,78.8,52204,NULL,NULL,NULL,'NGC 5519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118109,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118109,34.57,0.47,82,52204,NULL,NULL,'Malmquist cor.','NGC 5519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118110,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118110,34.97,0.2,98.6,52204,74.4,NULL,NULL,'NGC 5519',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118111,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118111,35.1,0.4,105,52204,75,NULL,'HMCL, I, raw','NGC 5519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118112,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118112,35.17,0.4,108,52204,NULL,NULL,'mean','NGC 5519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118113,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118113,35.23,0.4,111,52204,75,NULL,'HMCL, I, cor','NGC 5519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118114,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118114,35.33,0.4,117,52204,75,NULL,'HMCL, I, inv','NGC 5519',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118115,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118115,35.47,0.47,124,52204,NULL,NULL,'H','NGC 5519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118116,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118116,37.29,0.46,286,52205,70,NULL,NULL,'2MASX J14142188+2302340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.591125,23.04272,0,NULL,59469737103,929214642,14518978,17.7),(118117,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118117,35.15,0.2,107,52206,74.4,NULL,NULL,'SDSS J141423.26+103445.5',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000073,NULL,'16.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.5969583,10.57933,0.009,NULL,58501507326,914086051,14282594,16.9),(118118,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118118,35.62,0.54,133,52207,70,NULL,NULL,'2MASX J14142455-1931470',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'16.02',0.3,'(R)SB0^0:',NULL,NULL,NULL,NULL,1,213.602417,-19.52978,0.277,NULL,46565135618,727580244,11368441,16.02),(118119,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118119,36.91,0.33,241,52208,70,NULL,NULL,'2MASX J14142455+0446040',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.6025,4.76767,0.073,NULL,58476187675,913690432,14276413,17),(118120,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118120,38.4,NULL,480,52209,65,NULL,'L = 10e57 photons/s','GRB 910219',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,213.6,58.91667,0.009,NULL,57272438506,894881851,13982528,NULL),(118121,'GRB','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,NULL,118121,41.24,NULL,1770,52209,65,NULL,'L = 2 x 10e58 photons/s','GRB 910219',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118122,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118122,36.88,0.46,237,52210,70,NULL,NULL,'2MASX J14142539+0128230',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000095,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.605875,1.47308,0.061,NULL,58468973979,913577718,14274651,16.9),(118123,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118123,37.52,0.46,320,52211,70,NULL,NULL,'2MASX J14142555+2144450',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.78',0.15,NULL,NULL,NULL,NULL,NULL,1,213.606583,21.74594,0.032,NULL,59468952275,929202379,14518787,18.78),(118124,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118124,37.75,0.46,354,52212,70,NULL,NULL,'2MASX J14142854+4321236',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000116,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.619083,43.35672,0,NULL,59238784298,925606004,14462593,18),(118125,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118125,37.14,0.46,268,52213,70,NULL,NULL,'SDSS J141428.93+161440.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.6205417,16.24472,0,NULL,59485566516,929461976,14522843,18.3),(118126,'FP','2016-12-15 15:15:22','2016-12-16 11:20:35','1',NULL,'R',118126,37.69,0.46,346,52214,70,NULL,NULL,'SDSS J141429.06+065951.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000135,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.621083,6.99767,0.033,NULL,58505969319,914155770,14283683,18.3),(118127,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118127,36.66,0.46,215,52215,70,NULL,NULL,'2MASX J14142997+2459019',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.62475,24.984,0,NULL,60000100173,937501565,14648461,17),(118128,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118128,36.91,0.33,241,52216,70,NULL,NULL,'2MASX J14143037+0440070',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000098,NULL,'16.1g',0.37,'S0/a',NULL,NULL,NULL,NULL,1,213.62675,4.66861,0.045,NULL,58476045610,913688212,14276378,16.1),(118129,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118129,34.52,0.51,80.2,52217,70,NULL,NULL,'2MASX J14143086-4826542',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.23',0.46,NULL,NULL,NULL,NULL,NULL,1,213.629041667,-48.44861,0.861,NULL,46839626328,731869161,11435455,15.23),(118130,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118130,37.41,0.46,303,52218,70,NULL,NULL,'2MASX J14143267+2852289',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.1g',0.23,'S0',NULL,NULL,NULL,NULL,1,213.6360417,28.87478,0,NULL,60058445386,938413209,14662706,17.1),(118131,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118131,35.53,0.46,128,52219,70,NULL,NULL,'2MASX J14143324+4045228',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000084,NULL,'16.1g',0.3,'SF',NULL,NULL,NULL,NULL,1,213.638458333,40.75636,0,NULL,59224556966,925383702,14459120,16.1),(118132,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118132,34.41,NULL,76.2,52220,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1731',NULL,'2010Ap&SS.325..163P',2010,1,0.76,'2dF final data release has z = 0.02310 +- 0.00030.','G',0.000027,NULL,'17.0',0.08,'Sd',NULL,NULL,NULL,NULL,1,213.642208333,-4.41728,0.077,NULL,43731360977,683302515,10676601,17),(118133,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118133,34.42,NULL,76.4,52220,NULL,NULL,'Dipole + Quadrupole','FGC 1731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118134,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118134,34.44,NULL,77.3,52220,NULL,NULL,'Dipole','FGC 1731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118135,'Tully-Fisher','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118135,34.46,NULL,77.9,52220,NULL,NULL,NULL,'FGC 1731',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118136,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118136,37.78,0.46,360,52221,70,NULL,NULL,'2MASX J14143435+1445491',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.80',0.13,NULL,NULL,NULL,NULL,NULL,1,213.643041667,14.76356,0,NULL,58366019571,911969055,14249516,18.8),(118137,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118137,37.58,0.27,327,52222,70,NULL,NULL,'SDSS J141434.46+084357.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.643583,8.73272,0.017,NULL,58496880548,914013758,14281464,18.1),(118138,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118138,38.25,0.21,447,52223,70,NULL,NULL,'SDSS J141434.66+065240.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,213.644458333,6.87783,0.033,NULL,58506084440,914157569,14283712,18.6),(118139,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118139,38.3,0.33,458,52224,70,NULL,NULL,'SDSS J141435.50+455320.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.6479583,45.889,0,NULL,59237019419,925578428,14462162,18.3),(118140,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118140,37.15,0.46,269,52225,70,NULL,NULL,'2MASX J14143713+1242201',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.654667,12.7055,0,NULL,58354136657,911783385,14246615,16.6),(118141,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,NULL,118141,35.63,0.51,133,52226,70,NULL,NULL,'2MASX J14143796-4035499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.658125,-40.59728,0.297,NULL,46791853570,731122712,11423792,14.6),(118142,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118142,37.88,0.46,376,52227,70,NULL,NULL,'2MASX J14143822+0846072',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.6592083,8.76867,0.017,NULL,58496877452,914013710,14281464,17),(118143,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118143,38.05,0.46,407,52228,70,NULL,NULL,'2MASX J14143840+2431099',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.659917,24.51942,0,NULL,59467130078,929173907,14518342,18.2),(118144,'FP','2016-12-15 15:15:22','2016-12-16 11:20:36','1',NULL,'R',118144,37.04,0.46,256,52229,70,NULL,NULL,'2MASX J14143863+4744476',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,213.660833,47.74661,0.026,NULL,59246774806,925730856,14464544,16.4),(118145,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118145,37.97,0.46,392,52230,70,NULL,NULL,'2MASX J14143913+3906110',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.663,39.10306,0,NULL,60029129446,937955147,14655549,16.7),(118146,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118146,37.88,0.46,376,52231,70,NULL,NULL,'2MASX J14144087+0602352',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.670333,6.04306,0.025,NULL,58473064934,913641639,14275650,18),(118147,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118147,37.69,0.46,345,52232,70,NULL,NULL,'SDSS J141441.14+193001.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.6714583,19.50047,0,NULL,59521361912,930021279,14531582,17.9),(118148,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118148,37.65,0.46,338,52233,70,NULL,NULL,'2MASX J14144215+1405101',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.675791667,14.08617,0,NULL,58352681004,911760640,14246260,17.6),(118149,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118149,38.3,0.33,458,52234,70,NULL,NULL,'2MASX J14144222+4552196',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000202,NULL,'18.1g',0.13,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,213.675791667,45.87208,0,NULL,59237015842,925578372,14462162,18.1),(118150,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118150,37.29,0.46,287,52235,70,NULL,NULL,'2MASX J14144260+4124290',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.677333333,41.40806,0,NULL,59223906666,925373541,14458961,17.2),(118151,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118151,35.54,0.68,128,52236,70,NULL,NULL,'2MASX J14144300-1707456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,213.679167,-17.12944,0.281,NULL,46548286555,727316977,11364327,16.26),(118152,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118152,38.07,0.46,412,52237,70,NULL,NULL,'2MASX J14144350+6501080',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000081,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.681,65.01883,0.057,NULL,57947502916,905429733,14147339,17.6),(118153,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118153,36.92,0.87,242,52238,70,NULL,NULL,'2MASX J14144364-3951539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.681875,-39.86497,0.097,NULL,46791658556,731119664,11423744,15.6),(118154,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118154,37.65,0.46,340,52239,70,NULL,NULL,'2MASX J14144399+3159406',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,213.6834583,31.99456,0,NULL,60052920447,938326881,14661357,18.18),(118155,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118155,38.23,0.46,443,52240,70,NULL,NULL,'2MASX J14144600+3706400',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00019,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.69175,37.111,0,NULL,60032931036,938014547,14656477,16.8),(118156,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118156,37.34,0.46,293,52241,70,NULL,NULL,'2MASX J14144643+5900340',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.693416667,59.00944,0.009,NULL,57272439581,894881868,13982529,18.1),(118157,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118157,37.35,0.46,295,52242,70,NULL,NULL,'2MASX J14144704+3548246',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.696,35.80692,0,NULL,60044330871,938192669,14659260,17.3),(118158,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118158,38.19,0.46,435,52243,70,NULL,NULL,'SDSS J141448.30-004113.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000073,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,213.70125,-0.68719,0.085,NULL,43721594037,683149906,10674217,18.8),(118159,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118159,37.78,0.46,360,52244,70,NULL,NULL,'2MASX J14144864+2759473',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,213.702625,27.99664,0,NULL,60056239792,938378746,14662167,18.28),(118160,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118160,35.41,0.46,121,52245,70,NULL,NULL,'2MASX J14144876+3608410',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000164,NULL,'15.6g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,213.703,36.14481,0,NULL,60030235772,937972433,14655819,15.6),(118161,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118161,37.73,0.46,352,52246,70,NULL,NULL,'2MASX J14144931+0641443',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.705375,6.69567,0.033,NULL,58502820703,914106573,14282915,17.3),(118162,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118162,33.79,0.47,57.2,52247,NULL,NULL,'H','NGC 5522',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00003,NULL,'14.27',0.4,'Sb','Group member',NULL,NULL,NULL,1,213.709875,15.14689,0,NULL,58365864320,911966630,14249478,14.27),(118163,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118163,33.82,0.45,58,52247,NULL,NULL,'K','NGC 5522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118164,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118164,33.84,0.46,58.7,52247,NULL,NULL,'J','NGC 5522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118165,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118165,34.01,0.33,63.3,52247,NULL,NULL,NULL,'NGC 5522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118166,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118166,34.05,0.2,64.6,52247,74.4,NULL,NULL,'NGC 5522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118167,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118167,34.09,0.49,65.6,52247,75,NULL,'IR','NGC 5522',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118168,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118168,34.13,0.31,66.9,52247,NULL,NULL,'Malmquist cor.','NGC 5522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118169,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118169,34.22,0.4,69.9,52247,NULL,NULL,'mean','NGC 5522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118170,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118170,37.34,0.46,294,52248,70,NULL,NULL,'2MASXi J1414505-003233',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000068,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.71025,-0.54264,0.085,NULL,43721577047,683149641,10674213,18),(118171,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118171,37.68,0.46,343,52249,70,NULL,NULL,'2MASX J14145101+4009180',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.712667,40.15514,0,NULL,59223594530,925368664,14458885,18),(118172,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118172,34.45,0.46,77.6,52250,70,NULL,NULL,'IC 0989',NULL,'2015arXiv151105856S',2015,1,1.09,'UGC misprints name as \'MCG +00-36-(27)\'.','G',0.000103,NULL,'13.9g',0.94,'E              LINER','in a pair',NULL,NULL,'Flat-Spectrum Radio Source',1,213.713917,3.13089,0.081,NULL,58483421600,913803462,14278179,13.9),(118173,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118173,34.56,0.45,81.6,52250,NULL,NULL,'K','IC 0989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118174,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118174,35.22,0.4,110,52250,NULL,NULL,'mean','IC 0989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118175,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118175,36.34,0.33,185,52251,70,NULL,NULL,'2MASX J14145153+4012270',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.71475,40.20739,0,NULL,59223593704,925368651,14458885,16.8),(118176,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118176,37.68,0.19,343,52252,70,NULL,NULL,'2MASX J14145163+5024086',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'15.9g',0.49,'E0',NULL,NULL,NULL,NULL,1,213.715291667,50.40231,0.005,NULL,59253390063,925834219,14466159,15.9),(118177,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118177,36.85,0.33,235,52253,70,NULL,NULL,'2MASX J14145190+0328452',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.7162917,3.47936,0.045,NULL,58484229638,913816088,14278376,16.7),(118178,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118178,33.27,0.69,45,52254,100,NULL,'mid-IR','UGC 09117',NULL,'2013ApJ...771...88L',2013,1,1.44,NULL,'G',0.000004,NULL,'14.0g',0.79,'Sa','in a pair',NULL,NULL,NULL,1,213.716833,14.12586,0,NULL,58352618719,911759667,14246244,14),(118179,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118179,34.31,0.37,72.8,52254,NULL,NULL,NULL,'UGC 09117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118180,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118180,34.32,0.2,73.1,52254,74.4,NULL,NULL,'UGC 09117',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118181,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118181,34.35,0.37,74,52254,NULL,NULL,'Malmquist cor.','UGC 09117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118182,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118182,34.41,0.4,76.1,52254,NULL,NULL,'mean','UGC 09117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118183,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118183,34.7,0.47,87.3,52254,NULL,NULL,'H','UGC 09117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118184,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118184,34.74,0.45,88.5,52254,NULL,NULL,'K','UGC 09117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118185,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118185,34.77,0.46,89.9,52254,NULL,NULL,'J','UGC 09117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118186,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118186,37.68,0.19,343,52255,70,NULL,NULL,'2MASX J14145213+5030186',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.717,50.50506,0.005,NULL,59253387083,925834173,14466158,17.2),(118187,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118187,31.44,0.8,19.4,52256,75,NULL,'A82, H','NGC 5523',NULL,'1997ApJS..109..333W',1997,1,4.6,NULL,'G',0.000018,NULL,'12.75',1.3,'SA(s)cd:','Isolated galaxy',NULL,NULL,NULL,1,213.718,25.31761,0,NULL,60000194344,937503036,14648484,12.75),(118188,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118188,31.18,0.4,17.2,52256,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5523',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118189,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118189,31.38,0.4,18.9,52256,75,NULL,NULL,'NGC 5523',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118190,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118190,31.41,0.45,19.2,52256,NULL,NULL,'Malmquist cor.','NGC 5523',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118191,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118191,31.43,0.47,19.3,52256,75,NULL,'A82, H, inv','NGC 5523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118192,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118192,31.44,0.47,19.4,52256,75,NULL,'A82, H, raw','NGC 5523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118193,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118193,31.57,0.36,20.6,52256,NULL,NULL,NULL,'NGC 5523',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118194,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118194,31.59,0.47,20.8,52256,75,NULL,'A82, H, cor','NGC 5523',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118195,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118195,31.61,0.2,21,52256,74.4,NULL,NULL,'NGC 5523',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118196,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118196,31.66,0.4,21.5,52256,75,NULL,'B','NGC 5523',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118197,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118197,31.71,0.43,22,52256,75,NULL,'3.6 micron, color corrected','NGC 5523',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118198,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118198,31.75,0.38,22.4,52256,NULL,NULL,NULL,'NGC 5523',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118199,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118199,31.82,0.43,23.1,52256,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5523',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118200,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118200,32.2,0.49,27.5,52256,75,NULL,'IR','NGC 5523',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118201,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118201,38.13,0.33,423,52257,70,NULL,NULL,'2MASX J14145228+5654340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000105,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.717917,56.9095,0,NULL,57306879268,895419988,13990937,18),(118202,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118202,37.01,0.58,253,52258,70,NULL,NULL,'2MASX J14145257-2222033',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,213.719,-22.36778,0.305,NULL,46511864213,726747878,11355435,16.37),(118203,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118203,38.24,0.46,445,52259,70,NULL,NULL,'SDSS J141453.39+550319.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.7225,55.05542,0.025,NULL,57252990871,894577982,13977780,18.3),(118204,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118204,38.17,0.46,431,52260,70,NULL,NULL,'2MASX J14145358+6045141',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.723083,60.75403,0.025,NULL,57753546944,902399171,14099987,18.3),(118205,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118205,37.73,0.46,351,52261,70,NULL,NULL,'2MASX J14145375+5924130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.723833,59.40356,0.037,NULL,57272526958,894883233,13982550,17.3),(118206,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118206,31.81,NULL,23,52262,NULL,NULL,NULL,'SDSS J1414-0208',NULL,'2014A&A...562A..49M',2014,1,0.34,NULL,'G',0.000011,NULL,'18.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,213.725625,-2.13969,0.157,NULL,43723901967,683185968,10674780,18),(118207,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118207,36.25,0.33,178,52263,70,NULL,NULL,'NGC 5540',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000073,NULL,'14.5g',0.7,'E0',NULL,NULL,NULL,NULL,1,213.7267917,60.01111,0.037,NULL,57272802309,894887536,13982617,14.5),(118208,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118208,36.53,0.46,202,52264,70,NULL,NULL,'2MASX J14145472+3053216',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,213.728,30.88933,0,NULL,60052513653,938320525,14661258,15.7),(118209,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118209,37.17,0.68,272,52265,70,NULL,NULL,'LCRS B141219.6-031320',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00009,NULL,'16.7b',0.34,NULL,NULL,NULL,NULL,NULL,1,213.7307083,-3.45467,0.097,NULL,43735220553,683362821,10677544,16.7),(118210,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118210,36.69,0.33,217,52266,70,NULL,NULL,'2MASX J14145536+1656490',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.57',0.15,NULL,NULL,NULL,NULL,NULL,1,213.7307083,16.94686,0,NULL,59487625479,929494148,14523346,18.57),(118211,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118211,36.57,0.27,206,52267,70,NULL,NULL,'ARK 442',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'15.7',0.17,NULL,NULL,NULL,NULL,NULL,1,213.732208333,18.52206,0,NULL,59520857744,930013402,14531459,15.7),(118212,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118212,38.13,0.33,423,52268,70,NULL,NULL,'2MASX J14145631+5654080',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.734375,56.90225,0,NULL,57306889492,895420148,13990939,18.1),(118213,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118213,37.24,0.46,280,52269,70,NULL,NULL,'2MASX J14145756+2221479',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.18',0.17,NULL,NULL,NULL,NULL,NULL,1,213.739833333,22.36333,0.009,NULL,59469030683,929203604,14518806,18.18),(118214,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118214,36.83,0.46,232,52270,70,NULL,NULL,'2MASX J14145772+2020539',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.7405,20.34856,0,NULL,59520081082,930001266,14531269,17.3),(118215,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118215,37.53,0.33,321,52271,70,NULL,NULL,'2MASX J14145870+2621594',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000209,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.744667,26.36661,0,NULL,60003447367,937553865,14649279,16.6),(118216,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118216,36.25,0.33,178,52272,70,NULL,NULL,'2MASX J14150016+5958061',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.750917,59.9685,0.037,NULL,57272806234,894887597,13982618,17),(118217,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118217,35.82,0.46,146,52273,70,NULL,NULL,'CGCG 018-093',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00008,NULL,'15.1g',0.48,'E0',NULL,NULL,NULL,NULL,1,213.752625,-0.79694,0.085,NULL,43722285038,683160703,10674385,15.1),(118218,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118218,37.76,0.46,357,52274,70,NULL,NULL,'LCRS B141225.4-023440',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.7535417,-2.81003,0.129,NULL,43724434961,683194296,10674910,17.8),(118219,'Tully est','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118219,32.08,0.8,26,52275,75,NULL,NULL,'IC 4386',NULL,'1988NBGC.C....0000T',1988,1,3,'The 2MASX position refers to a knot northwest of the nucleus.','G',0.000027,NULL,'12.74',1.8,'SB(s)d pec','Pair member (points to parent)',NULL,NULL,NULL,1,213.759875,-43.96133,0.337,NULL,46805653913,731338342,11427161,12.74),(118220,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118220,31.54,0.36,20.3,52275,NULL,NULL,NULL,'IC 4386',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118221,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118221,32.1,0.2,26.3,52275,74.4,NULL,NULL,'IC 4386',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118222,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118222,33.6,0.49,52.5,52275,75,NULL,'IR','IC 4386',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118223,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118223,38.19,0.46,434,52276,70,NULL,NULL,'2MASX J14150249+0526414',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.760541667,5.44478,0.025,NULL,58476636146,913697439,14276522,17.5),(118224,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118224,37.79,0.46,361,52277,70,NULL,NULL,'2MASX J14150254+2842284',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.760541667,28.70797,0,NULL,60058369487,938412023,14662687,17.1),(118225,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118225,38.18,0.46,433,52278,70,NULL,NULL,'2MASX J14150364+5204336',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,213.765083333,52.07619,0,NULL,59251125463,925798835,14465606,17.3),(118226,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118226,36.89,0.46,239,52279,70,NULL,NULL,'2MASX J14150416+0543304',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000156,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,213.767458333,5.72519,0.021,NULL,58476495715,913695245,14276488,16.8),(118227,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118227,37.53,0.33,321,52280,70,NULL,NULL,'2MASX J14150436+2622184',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,213.7682083,26.37192,0,NULL,60003447429,937553866,14649279,18.5),(118228,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118228,36.34,0.33,185,52281,70,NULL,NULL,'2MASX J14150507+4014059',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.2g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,213.771083333,40.23506,0,NULL,59223812041,925372063,14458938,16.2),(118229,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118229,37.61,0.46,333,52282,70,NULL,NULL,'2MASX J14150607+1629580',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.34',0.18,NULL,NULL,NULL,NULL,NULL,1,213.775583,16.49942,0,NULL,59485481015,929460640,14522822,18.34),(118230,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118230,38.39,0.46,477,52283,70,NULL,NULL,'2MASX J14150755+4407480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.781625,44.13014,0,NULL,59239377540,925615274,14462738,17.4),(118231,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118231,36.2,0.46,174,52284,70,NULL,NULL,'2MASX J14150778+1105026',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.782333333,11.08397,0,NULL,58500662141,914072845,14282388,16.4),(118232,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118232,35.14,0.4,107,52285,NULL,NULL,'mean','UGC 09118',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00009,NULL,'15.5g',0.36,'Sb(f)',NULL,NULL,NULL,NULL,1,213.783417,3.11272,0.081,NULL,58483469707,913804214,14278190,15.5),(118233,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118233,35.61,0.45,132,52285,NULL,NULL,'K','UGC 09118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118234,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118234,35.65,0.47,135,52285,NULL,NULL,'H','UGC 09118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118235,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118235,37.71,0.46,349,52286,70,NULL,NULL,'2MASX J14150801+4027149',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,213.783333,40.45414,0,NULL,59223658548,925369664,14458901,18.2),(118236,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118236,37.44,0.33,308,52287,70,NULL,NULL,'2MASX J14150819+0435044',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.784083333,4.58442,0.045,NULL,58476011883,913687685,14276370,17.3),(118237,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118237,37.78,0.33,360,52288,70,NULL,NULL,'SDSS J141509.09+131647.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.787917,13.27989,0,NULL,58354007499,911781367,14246583,18.5),(118238,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118238,29.74,0.1,8.87,52289,74.4,NULL,NULL,'KUG 1413+573',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000003,NULL,'16.5:',0.3,'Ir',NULL,NULL,NULL,NULL,1,213.7887917,57.08761,0,NULL,57304820129,895387814,13990434,16.5),(118239,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118239,29.86,0.14,9.4,52289,NULL,NULL,NULL,'KUG 1413+573',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118240,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118240,29.29,NULL,7.21,52289,NULL,NULL,NULL,'KUG 1413+573',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118241,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118241,36.42,0.46,193,52290,70,NULL,NULL,'2MASX J14150986+0428404',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000069,NULL,'16.2g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,213.791,4.47792,0.045,NULL,58475604578,913681321,14276270,16.2),(118242,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118242,36.96,0.46,246,52291,70,NULL,NULL,'MRK 0807',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,213.797,58.96181,0.009,NULL,57269563685,894836932,13981827,16.1),(118243,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118243,35.28,0.46,114,52292,70,NULL,NULL,'2MASX J14151157+3704389',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000166,NULL,'15.5g',0.49,'E',NULL,NULL,NULL,NULL,1,213.798416667,37.07758,0,NULL,60032937144,938014642,14656478,15.5),(118244,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118244,34.27,0.8,71.4,52293,75,NULL,'CF, r','UGC 09121',NULL,'1997ApJS..109..333W',1997,1,1.4,'HOLM 617B is a double star.','G',0.00002,NULL,'14.47',0.7,'Sbc',NULL,NULL,NULL,NULL,1,213.7989583,15.74208,0,NULL,59484923622,929451931,14522686,14.47),(118245,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118245,34.58,0.38,82.5,52293,75,NULL,'CF, r, raw','UGC 09121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118246,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118246,34.63,0.47,84.2,52293,NULL,NULL,'Malmquist cor.','UGC 09121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118247,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118247,34.66,0.2,85.5,52293,74.4,NULL,NULL,'UGC 09121',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118248,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118248,34.66,0.46,85.7,52293,NULL,NULL,NULL,'UGC 09121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118249,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118249,34.71,0.38,87.6,52293,75,NULL,'CF, r, inv','UGC 09121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118250,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118250,34.76,0.38,89.5,52293,75,NULL,'CF, r, cor','UGC 09121',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118251,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118251,37.74,0.33,352,52294,70,NULL,NULL,'2MASX J14151372+4140278',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000195,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,213.8070417,41.67433,0,NULL,59227433846,925428653,14459822,16),(118252,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118252,36.67,0.46,216,52295,70,NULL,NULL,'2MASX J14151368+0450044',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.807125,4.83475,0.041,NULL,58476910662,913701729,14276589,17.4),(118253,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118253,35.71,0.46,139,52296,70,NULL,NULL,'2MASX J14151509+4752240',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000187,NULL,'15.5g',0.39,'S0a',NULL,NULL,NULL,NULL,1,213.813083333,47.87333,0.036,NULL,59247237126,925738080,14464657,15.5),(118254,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118254,37.41,0.46,304,52297,70,NULL,NULL,'2MASX J14151553+1342286',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.5r',NULL,NULL,NULL,NULL,NULL,NULL,1,213.81475,13.70794,0,NULL,58354340404,911786568,14246665,16.5),(118255,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118255,36.7,0.46,219,52298,70,NULL,NULL,'2MASX J14151668+4701000',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,213.819417,47.01675,0,NULL,59246742762,925730355,14464536,16.2),(118256,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118256,37.87,0.33,374,52299,70,NULL,NULL,'2MASX J14151673+0704026',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.819625,7.06731,0.025,NULL,58502523218,914101925,14282842,17.6),(118257,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118257,34.16,0.43,68,52300,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J14151678-0421318',NULL,'2014MNRAS.444..527S',2014,1,1.07,'HOLM 615B is a star.','G',0.000019,NULL,'14.99',0.41,'SBd',NULL,NULL,NULL,NULL,1,213.820083,-4.35886,0.089,NULL,43731218509,683300289,10676567,14.99),(118258,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118258,36.58,0.51,207,52301,70,NULL,NULL,'CGCG 018-095',NULL,'2014MNRAS.445.2677S',2014,1,1.05,NULL,'G',0.000103,NULL,'15.2g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,213.824917,-2.44475,0.157,NULL,43724532373,683195818,10674934,15.2),(118259,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118259,37.84,0.46,369,52302,70,NULL,NULL,'2MASX J14151885+4231080',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.8284583,42.51881,0,NULL,59226861035,925419703,14459682,17.7),(118260,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118260,36.69,0.33,217,52303,70,NULL,NULL,'CGCG 103-130',NULL,'2015arXiv151105856S',2015,1,0.3,'HOLM 619B is a star.','G',0.000217,NULL,'15.4',0.25,NULL,NULL,NULL,NULL,NULL,1,213.828917,16.88797,0,NULL,59487620115,929494064,14523344,15.4),(118261,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118261,35.09,0.68,104,52304,70,NULL,NULL,'2MASX J14151916-4451403',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.8299583,-44.86128,0.349,NULL,46808165188,731377581,11427774,15.1),(118262,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118262,37.24,0.33,281,52305,70,NULL,NULL,'2MASX J14152031+5220446',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000207,NULL,'15.6g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,213.834833,52.34589,0,NULL,59252148998,925814828,14465856,15.6),(118263,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118263,37.69,0.46,345,52306,70,NULL,NULL,'2MASX J14152044+0844526',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.835333,8.74794,0.033,NULL,58496560451,914008757,14281386,17.3),(118264,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118264,36.93,0.46,243,52307,70,NULL,NULL,'2MASX J14152109+0343044',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000072,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.838083,3.71797,0.049,NULL,58483345557,913802274,14278160,16.9),(118265,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118265,37.44,0.33,308,52308,70,NULL,NULL,'SDSS J141522.25+043947.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.84275,4.66317,0.041,NULL,58476017735,913687777,14276371,17.9),(118266,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118266,36.94,0.46,244,52309,70,NULL,NULL,'2MASX J14152382+6254261',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,213.849083333,62.90725,0,NULL,57750002563,902343790,14099121,16.5),(118267,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118267,35.04,0.8,102,52310,75,NULL,'HMCL, I','KUG 1412+082',NULL,'1997ApJS..109..333W',1997,1,0.99,NULL,'G',0.00007,NULL,'15.9g',0.26,'Spiral',NULL,NULL,NULL,NULL,1,213.850083,8.01117,0.065,NULL,58496352782,914005512,14281336,15.9),(118268,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118268,35.12,0.4,105,52310,75,NULL,'HMCL, I, raw','KUG 1412+082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118269,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118269,35.22,0.4,111,52310,75,NULL,'HMCL, I, inv','KUG 1412+082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118270,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118270,35.24,0.4,112,52310,75,NULL,'HMCL, I, cor','KUG 1412+082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118271,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118271,37.32,0.46,292,52311,70,NULL,NULL,'2MASX J14152524+3033534',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.855083333,30.56486,0,NULL,60052472916,938319889,14661248,17),(118272,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118272,37.47,0.46,311,52312,70,NULL,NULL,'2MASX J14152548+1833537',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.8560417,18.56492,0,NULL,59520848552,930013258,14531457,17.7),(118273,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118273,38.01,0.33,400,52313,70,NULL,NULL,'2MASX J14152649+4406419',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.860333,44.11147,0,NULL,59238914538,925608039,14462625,18.3),(118274,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118274,37.78,0.33,360,52314,70,NULL,NULL,'2MASX J14152822+1316296',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.867541667,13.27486,0,NULL,58353927926,911780123,14246564,17.6),(118275,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118275,37.75,0.46,354,52315,70,NULL,NULL,'2MASX J14152833+0501234',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.8680417,5.02328,0.037,NULL,58476949901,913702342,14276599,17.5),(118276,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118276,37.24,0.33,281,52316,70,NULL,NULL,'2MASX J14152908+5221538',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,213.871125,52.36497,0,NULL,59252149534,925814836,14465856,17),(118277,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118277,37.27,0.46,284,52317,70,NULL,NULL,'2MASX J14152975+4640029',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,213.8740417,46.6675,0.01,NULL,59229017769,925453402,14460209,16.9),(118278,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118278,37.85,0.46,372,52318,70,NULL,NULL,'2MASX J14153019+6331071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,213.8757917,63.51856,0.025,NULL,57750205556,902346961,14099171,17.2),(118279,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118279,37.08,0.33,261,52319,70,NULL,NULL,'2MASX J14153017+5129549',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000195,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,213.8759583,51.49856,0,NULL,59251656567,925807133,14465736,15.8),(118280,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118280,37.85,0.46,372,52320,70,NULL,NULL,'2MASX J14153036+5412550',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.876625,54.21536,0,NULL,59194805127,924918830,14451856,18),(118281,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118281,37.89,0.46,379,52321,70,NULL,NULL,'SDSS J141531.79+205410.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.8825,20.90303,0.008,NULL,59519458167,929991533,14531117,18.5),(118282,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118282,36.57,0.27,206,52322,70,NULL,NULL,'CGCG 103-131',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,213.883083,18.52092,0,NULL,59518758018,929980594,14530946,15.7),(118283,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118283,37.22,0.27,278,52323,70,NULL,NULL,'2MASX J14153196+5155079',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.88325,51.91889,0,NULL,59251339227,925802175,14465658,17.4),(118284,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118284,38.46,0.46,492,52324,70,NULL,NULL,'2MASX J14153203+4900009',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.883291667,49.00031,0,NULL,59256402985,925881296,14466895,17.7),(118285,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118285,37.8,0.46,362,52325,70,NULL,NULL,'2MASX J14153210+2333437',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.8837917,23.56217,0,NULL,59470447909,929225748,14519152,17.6),(118286,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118286,37.9,0.46,380,52326,70,NULL,NULL,'2MASX J14153245+0457026',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,213.885,4.95078,0.037,NULL,58476878291,913701223,14276581,17.5),(118287,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118287,33.76,0.8,56.5,52327,75,NULL,'HMCL, I','ESO 385- G 002',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.00015,NULL,'14.79',0.4,'S?',NULL,NULL,NULL,NULL,1,213.8864583,-35.53214,0.153,NULL,47006989363,734484208,11476315,14.79),(118288,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118288,33.43,0.4,48.6,52327,75,NULL,'HMCL, I, raw','ESO 385- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118289,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118289,33.45,0.4,49,52327,75,NULL,'HMCL, I, inv','ESO 385- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118290,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118290,33.65,0.4,53.7,52327,75,NULL,'HMCL, I, cor','ESO 385- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118291,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118291,36.23,0.46,176,52328,70,NULL,NULL,'CGCG 247-016',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000198,NULL,'15.5g',0.4,'S0',NULL,NULL,NULL,NULL,1,213.887167,50.18103,0.029,NULL,59253867849,925841685,14466276,15.5),(118292,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118292,37.08,0.33,261,52329,70,NULL,NULL,'2MASX J14153331+5123159',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,213.8889583,51.38792,0,NULL,59251664776,925807262,14465738,16.3),(118293,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118293,34,0.8,63.2,52330,75,NULL,'MAT, I','ESO 579- G 009',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'15.39',0.7,'SAB:(r)d:',NULL,NULL,NULL,NULL,1,213.8912917,-20.66242,0.281,NULL,46562998798,727546856,11367919,15.39),(118294,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118294,33.65,0.32,53.6,52330,85,NULL,'I, raw','ESO 579- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118295,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118295,33.65,0.32,53.8,52330,85,NULL,'I, inv','ESO 579- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118296,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118296,33.93,0.43,61,52330,75,NULL,'MAT, I, raw','ESO 579- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118297,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118297,34,0.43,63.2,52330,75,NULL,'MAT, I, inv','ESO 579- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118298,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118298,34.05,0.2,64.6,52330,74.4,NULL,NULL,'ESO 579- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118299,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118299,34.21,0.43,69.4,52330,75,NULL,'MAT, I, cor','ESO 579- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118300,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118300,34.25,0.53,70.7,52330,NULL,NULL,NULL,'ESO 579- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118301,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118301,34.39,0.5,75.6,52330,NULL,NULL,'Malmquist cor.','ESO 579- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118302,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118302,33.17,0.8,43,52331,75,NULL,'A82, H','NGC 5529',NULL,'1997ApJS..109..333W',1997,1,6.35,NULL,'G',0.000001,NULL,'12.9g',0.64,'Sc','in a radial-velocity based grouping',NULL,NULL,NULL,1,213.8919583,36.22658,0,NULL,60030254314,937972723,14655823,12.9),(118303,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118303,32.82,0.46,36.6,52331,NULL,NULL,'J','NGC 5529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118304,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118304,32.85,0.47,37.1,52331,NULL,NULL,'H','NGC 5529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118305,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118305,32.94,0.45,38.6,52331,NULL,NULL,'K','NGC 5529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118306,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118306,32.96,0.4,39.1,52331,75,NULL,NULL,'NGC 5529',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118307,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118307,32.99,NULL,39.7,52331,NULL,NULL,'Dipole','NGC 5529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118308,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118308,33,NULL,39.7,52331,NULL,NULL,'Dipole + Quadrupole','NGC 5529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118309,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118309,33,NULL,39.8,52331,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5529',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118310,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118310,33.06,NULL,40.9,52331,NULL,NULL,NULL,'NGC 5529',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118311,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118311,33.15,0.4,42.7,52331,NULL,NULL,'mean','NGC 5529',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118312,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118312,33.21,0.4,43.9,52331,75,NULL,'B','NGC 5529',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118313,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118313,33.24,0.35,44.5,52331,NULL,NULL,NULL,'NGC 5529',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118314,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118314,33.25,0.49,44.7,52331,75,NULL,'IR','NGC 5529',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118315,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118315,33.36,0.4,46.9,52331,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5529',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118316,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118316,33.56,0.47,51.6,52331,75,NULL,'A82, H, raw','NGC 5529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118317,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118317,33.83,0.47,58.3,52331,75,NULL,'A82, H, cor','NGC 5529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118318,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118318,33.84,0.47,58.6,52331,75,NULL,'A82, H, inv','NGC 5529',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118319,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118319,38.01,0.33,400,52332,70,NULL,NULL,'2MASX J14153418+4406520',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.892208333,44.11453,0,NULL,59238914742,925608042,14462625,17.1),(118320,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118320,37.22,0.27,278,52333,70,NULL,NULL,'2MASX J14153522+5151529',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.89675,51.86483,0,NULL,59251337315,925802145,14465658,17.7),(118321,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118321,37.34,0.27,294,52334,70,NULL,NULL,'2MASX J14153685+2920151',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'16.8g',0.31,'S0',NULL,NULL,NULL,NULL,1,213.903458333,29.33756,0,NULL,60059262030,938425969,14662905,16.8),(118322,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118322,37.34,0.27,294,52335,70,NULL,NULL,'2MASX J14153717+2928420',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.904833,29.47825,0,NULL,60059127143,938423861,14662872,17.6),(118323,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118323,37.52,0.46,318,52336,70,NULL,NULL,'2MASX J14153900-0027396',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'17.0g',0.26,'AGN',NULL,NULL,NULL,NULL,1,213.912416667,-0.46108,0.077,NULL,43503432682,679741135,10620955,17),(118324,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118324,34.12,0.45,66.6,52337,NULL,NULL,'K','NGC 5525',NULL,'2007A&A...465...71T',2007,1,1.44,NULL,'G',0.000087,NULL,'13.6g',0.92,'S0','in a pair',NULL,NULL,NULL,1,213.913458333,14.28261,0,NULL,58353181578,911768462,14246382,13.6),(118325,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118325,34.61,0.4,83.7,52337,NULL,NULL,'mean','NGC 5525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118326,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118326,37.31,0.46,290,52338,70,NULL,NULL,'2MASX J14153942+0236436',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.914083,2.61211,0.069,NULL,58470518299,913601848,14275028,17.6),(118327,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118327,37.39,0.46,300,52339,70,NULL,NULL,'SDSS J141539.42+051328.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000067,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,213.9142917,5.22467,0.033,NULL,58476787693,913699807,14276559,18.5),(118328,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118328,37.68,0.19,343,52340,70,NULL,NULL,'2MASX J14154008+5021189',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,213.916875,50.35525,0.005,NULL,59253874763,925841793,14466278,18.3),(118329,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118329,35.11,0.57,105,52341,70,NULL,NULL,'2MASX J14154044-0754348',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,213.9184583,-7.90983,0.089,NULL,43712541956,683008468,10672007,16),(118330,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118330,32.78,0.4,36,52342,75,NULL,'B','UGC 09126',NULL,'1988NBGC.C....0000T',1988,1,1.8,'Multiple SDSS entries describe this source.','G',0.000017,NULL,'15.0',1.7,'Im:','Group member',NULL,NULL,NULL,1,213.91875,16.55,0,NULL,59485510461,929461100,14522829,15),(118331,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118331,37.39,0.46,301,52343,70,NULL,NULL,'2MASX J14154189+0516146',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00009,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,213.924583,5.27053,0.025,NULL,58476785625,913699775,14276558,16.3),(118332,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118332,38.29,0.46,455,52344,70,NULL,NULL,'SDSS J141543.00+054413.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.9292083,5.73697,0.021,NULL,58473291089,913645173,14275705,17.8),(118333,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118333,33.76,0.49,56.5,52345,75,NULL,'IR','ESO 511- G 016',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.93',0.3,'S...',NULL,NULL,NULL,NULL,1,213.9312083,-24.423,0.257,NULL,46511315387,726739302,11355301,15.93),(118334,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118334,33.85,0.62,58.9,52345,NULL,NULL,NULL,'ESO 511- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118335,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118335,33.89,0.2,60,52345,74.4,NULL,NULL,'ESO 511- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118336,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118336,34.02,0.57,63.8,52345,NULL,NULL,'Malmquist cor.','ESO 511- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118337,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118337,36.94,0.46,244,52346,70,NULL,NULL,'2MASX J14154412+2433010',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,213.93375,24.55028,0,NULL,59467343936,929177249,14518394,16.7),(118338,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118338,37.74,0.33,352,52347,70,NULL,NULL,'2MASX J14154422+4136013',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.934333,41.60058,0,NULL,59227401758,925428152,14459814,18),(118339,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118339,33.35,0.51,46.8,52348,70,NULL,NULL,'ESO 271- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'1984MNRAS.210...69F has V = 6800 +- 200 km/s.','G',0.00015,NULL,'14.44',0.8,'(R)SAB(rl)0^+:',NULL,NULL,NULL,NULL,1,213.9407917,-47.64114,0.749,NULL,46835603111,731806298,11434473,14.44),(118340,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118340,36.42,0.95,192,52349,70,NULL,NULL,'2MASX J14154590-1643168',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,213.9412917,-16.72136,0.273,NULL,46546958161,727296221,11364003,15.6),(118341,'G Lens','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118341,42.63,0.12,3360,52350,NULL,NULL,NULL,'[HB89] 1413+117',NULL,'2010ApJ...708..995G',2010,1,NULL,'This quasar is lensed into four images by a z=0.8(PHOT) galaxy.','QSO',0.000247,NULL,'17.0g',NULL,'ULIRG          BAL',NULL,NULL,NULL,'QSO',1,213.942667,11.49544,0,NULL,58487356724,913864948,14279139,17),(118342,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118342,37.78,0.46,360,52351,70,NULL,NULL,'2MASX J14154621+4140553',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.942583,41.68211,0,NULL,59227402367,925428161,14459815,17.1),(118343,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118343,37.93,0.46,385,52352,70,NULL,NULL,'2MASX J14154654+2526530',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.943917,25.44808,0,NULL,60000238982,937503734,14648495,17.5),(118344,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118344,37.66,0.46,341,52353,70,NULL,NULL,'2MASX J14154680+0657505',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,213.945,6.96411,0.025,NULL,58502502612,914101603,14282837,17.8),(118345,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118345,35.45,0.46,123,52354,70,NULL,NULL,'2MASX J14154699+0854365',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000067,NULL,'15.3g',0.43,'AGN',NULL,NULL,NULL,NULL,1,213.945916667,8.91019,0.033,NULL,58496427543,914006680,14281354,15.3),(118346,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118346,38.1,0.46,417,52355,70,NULL,NULL,'SDSS J141547.08+263820.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.9462083,26.63906,0,NULL,60003215930,937550248,14649222,18.4),(118347,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118347,38.2,0.46,437,52356,70,NULL,NULL,'2MASX J14154758+0525336',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,213.9482917,5.42592,0.025,NULL,58476606022,913696969,14276515,17),(118348,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118348,37.22,0.27,278,52357,70,NULL,NULL,'SDSS J141548.94+515542.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.953916667,51.92833,0,NULL,59251343798,925802246,14465660,17.8),(118349,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118349,37.93,0.46,385,52358,70,NULL,NULL,'SDSS J141548.95+291310.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,213.9539583,29.21964,0,NULL,60059283973,938426312,14662911,18.3),(118350,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118350,35.22,0.46,111,52359,70,NULL,NULL,'IC 0990',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000147,NULL,'15.0g',0.57,'E0',NULL,NULL,NULL,NULL,1,213.954958333,39.79792,0,NULL,59945000218,936640628,14635009,15),(118351,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118351,37.32,0.46,291,52360,70,NULL,NULL,'2MASX J14155042+5255269',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.960083333,52.92428,0,NULL,59194715580,924917430,14451834,17.3),(118352,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118352,36.62,0.46,211,52361,70,NULL,NULL,'2MASX J14155123+0843054',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,213.9635417,8.71828,0.033,NULL,58496548271,914008566,14281383,16.5),(118353,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118353,37.32,0.46,292,52362,70,NULL,NULL,'2MASX J14155149+5335079',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000197,NULL,'16.0g',0.33,'E0',NULL,NULL,NULL,NULL,1,213.964833333,53.58556,0,NULL,59195244987,924925702,14451964,16),(118354,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118354,36.52,0.46,201,52363,70,NULL,NULL,'VII Zw 541',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,213.967375,62.79211,0.025,NULL,57750058096,902344657,14099135,16.3),(118355,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118355,37.01,0.46,252,52364,70,NULL,NULL,'2MASX J14155265+4028352',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,213.969167,40.47642,0,NULL,59223693426,925370209,14458909,17),(118356,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118356,37.34,0.27,294,52365,70,NULL,NULL,'2MASX J14155304+2931310',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,213.971166667,29.52528,0,NULL,60058927329,938420739,14662824,18.1),(118357,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118357,34.12,0.4,66.6,52366,75,NULL,'Edat, raw','NGC 5516',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000067,NULL,'13.00',1.2,'E','Pair member (points to parent)',NULL,NULL,NULL,1,213.977875,-48.11486,0.853,NULL,46835091486,731798304,11434348,13),(118358,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118358,34.45,0.4,77.8,52366,75,NULL,'Edat, cor','NGC 5516',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118359,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118359,34.03,0.45,64.1,52366,NULL,NULL,'K','NGC 5516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118360,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118360,34.08,0.4,65.4,52366,NULL,NULL,'mean','NGC 5516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118361,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118361,37.68,0.19,343,52367,70,NULL,NULL,'2MASX J14155512+5019079',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000194,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,213.97975,50.31892,0.005,NULL,59253877019,925841828,14466278,17.4),(118362,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118362,37.5,0.46,316,52368,70,NULL,NULL,'2MASX J14155608-0158356',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,213.983583333,-1.97667,0.169,NULL,43724003200,683187550,10674805,17.5),(118363,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118363,26.2,NULL,1.74,52369,NULL,NULL,'1, V8 AGB star','UGC 09128',NULL,'1998AJ....116.1679H',1998,1,1.7,NULL,'G',0.000002,NULL,'14.38',1.3,'ImIV-V','Possible field galaxy',NULL,NULL,NULL,1,213.9855,23.05528,0,1,59469435593,929209931,14518905,14.38),(118364,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118364,26.7,NULL,2.19,52369,NULL,NULL,'1, V8, Kinman et al 1987','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118365,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118365,27.6,NULL,3.31,52369,NULL,NULL,'1, V5','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118366,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118366,27.75,NULL,3.55,52369,NULL,NULL,'LF','UGC 09128',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118367,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118367,28.18,NULL,4.33,52369,NULL,NULL,'Blue','UGC 09128',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118368,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118368,28.2,0.6,4.4,52369,NULL,NULL,NULL,'UGC 09128',NULL,'1988A&AS...74..367A',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118369,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118369,28.55,NULL,5.13,52369,NULL,NULL,'Red + Blue','UGC 09128',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118370,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118370,28.55,0.4,5.13,52369,NULL,NULL,'3B + 3R mean','UGC 09128',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118371,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118371,28.67,NULL,5.42,52369,NULL,NULL,'Red','UGC 09128',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118372,'Brightest Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118372,29.29,NULL,7.21,52369,NULL,NULL,'1, V8, Red Variable','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118373,'Cepheids','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118373,28.91,NULL,6.05,52369,NULL,NULL,'5, V2, 3, 9, 19, 12','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118374,'Cepheids','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118374,29.24,0.33,7.05,52369,NULL,NULL,'2, V9, V12','UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118375,'CMD','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118375,26.7,0.04,2.19,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118376,'Miras','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118376,28.26,NULL,4.49,52369,NULL,NULL,NULL,'UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118377,'Red Clump','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118377,26.12,NULL,1.68,52369,NULL,NULL,'V, M RC(V) = +0.73 mag','UGC 09128',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118378,'Red Clump','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118378,26.52,NULL,2.01,52369,NULL,NULL,'I, M RC(I) = -0.50 mag','UGC 09128',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118379,'RSV Stars','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118379,29.4,0.5,7.59,52369,NULL,NULL,NULL,'UGC 09128',NULL,'1998AJ....116.1679H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118380,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118380,26.68,0.1,2.17,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118381,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118381,26.71,0.1,2.2,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118382,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118382,26.72,0.06,2.21,52369,NULL,NULL,'I','UGC 09128',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118383,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118383,26.75,0.05,2.24,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118384,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118384,26.75,NULL,2.24,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2009ysc..conf...42U',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118385,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118385,26.78,0.08,2.27,52369,74.4,NULL,NULL,'UGC 09128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118386,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118386,26.79,0.07,2.28,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2013AstBu..68..125M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118387,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118387,26.8,NULL,2.29,52369,NULL,NULL,'I, M TRGB(I) = -4.05 mag','UGC 09128',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118388,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118388,26.8,0.04,2.29,52369,NULL,NULL,'I','UGC 09128',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118389,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118389,26.99,0.45,2.5,52369,NULL,NULL,NULL,'UGC 09128',NULL,'2000AJ....119..177A',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118390,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118390,26.68,0.4,2.2,52369,75,NULL,'B','UGC 09128',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118391,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118391,37.68,0.19,343,52370,70,NULL,NULL,'SDSS J141558.60+501751.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000192,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,213.9942083,50.29772,0.005,NULL,59253877660,925841838,14466278,18.1),(118392,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118392,36.68,0.56,216,52371,70,NULL,NULL,'2MASX J14155775-2235251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.19',NULL,'E int',NULL,NULL,NULL,NULL,1,213.9952917,-22.59083,0.345,NULL,46512546207,726758534,11355602,16.19),(118393,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118393,37.68,0.19,343,52372,70,NULL,NULL,'2MASX J14155910+5021189',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,213.996083333,50.35519,0.005,NULL,59253907788,925842309,14466286,17.9),(118394,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118394,36.34,0.46,185,52373,70,NULL,NULL,'2MASX J14155989+2435230',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,213.9995417,24.58969,0,NULL,59467363799,929177559,14518399,16.2),(118395,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118395,36.83,0.12,232,52374,70,NULL,NULL,'SDSS J141601.79+015459.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.0074583,1.91658,0.013,NULL,58470410083,913600157,14275002,17.6),(118396,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118396,36.84,0.46,233,52375,70,NULL,NULL,'SDSS J141602.71+090640.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.0112917,9.11122,0.025,NULL,58496392234,914006128,14281345,17.4),(118397,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118397,37.63,0.46,336,52376,70,NULL,NULL,'SDSS J141603.37+155705.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.014083333,15.95156,0,NULL,59484766201,929449471,14522647,18),(118398,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118398,38.12,0.46,421,52377,70,NULL,NULL,'SDSS J141603.44+481110.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.014375,48.18614,0.039,NULL,59247273428,925738647,14464666,17.8),(118399,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118399,38.36,0.46,469,52378,70,NULL,NULL,'2MASX J14160380+5905520',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.0160417,59.09772,0.009,NULL,57269597719,894837464,13981835,17.4),(118400,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118400,36.83,0.12,232,52379,70,NULL,NULL,'2MASX J14160424+0127299',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000103,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,214.01775,1.45822,0.037,NULL,58468862795,913575981,14274624,16.1),(118401,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118401,36.58,0.46,207,52380,70,NULL,NULL,'2MASX J14160599+6139190',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.0252083,61.65531,0.021,NULL,57762733272,902542707,14102229,16.6),(118402,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118402,38.28,0.46,453,52381,70,NULL,NULL,'2MASX J14160659+1307040',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000201,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.0274583,13.11781,0,NULL,58353914878,911779919,14246561,17),(118403,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118403,35.04,0.2,102,52382,74.4,NULL,NULL,'UGC 09132',NULL,'2013AJ....146...86T',2013,1,1.04,NULL,'G',0.000033,NULL,'16.2g',0.22,'Scd:',NULL,NULL,NULL,NULL,1,214.0300417,33.72764,0,NULL,60042072755,938157386,14658709,16.2),(118404,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118404,35.46,0.49,124,52382,75,NULL,'IR','UGC 09132',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118405,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118405,33.7,0.8,55,52383,75,NULL,'CF, r','NGC 5533',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000017,NULL,'12.7',1.9,'SA(rs)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,214.03225,35.34383,0,NULL,60044737408,938199022,14659359,12.7),(118406,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118406,32.81,0.69,36.4,52383,100,NULL,'mid-IR','NGC 5533',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118407,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118407,33.02,0.42,40.2,52383,NULL,NULL,'Malmquist cor.','NGC 5533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118408,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118408,33.14,0.4,42.5,52383,NULL,NULL,NULL,'NGC 5533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118409,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118409,33.23,0.2,44.3,52383,74.4,NULL,NULL,'NGC 5533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118410,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118410,33.33,0.43,46.4,52383,75,NULL,'3.6 micron, color corrected','NGC 5533',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118411,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118411,33.34,0.38,46.5,52383,75,NULL,'CF, r, raw','NGC 5533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118412,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118412,33.46,0.43,49.3,52383,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5533',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118413,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118413,33.52,0.38,50.5,52383,75,NULL,'CF, r, cor','NGC 5533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118414,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118414,33.56,0.38,51.5,52383,75,NULL,'CF, r, inv','NGC 5533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118415,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118415,33.74,0.47,55.9,52383,NULL,NULL,'H','NGC 5533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118416,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118416,33.74,0.45,56.1,52383,NULL,NULL,'K','NGC 5533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118417,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118417,33.77,0.46,56.8,52383,NULL,NULL,'J','NGC 5533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118418,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118418,33.79,0.4,57.2,52383,NULL,NULL,'mean','NGC 5533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118419,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118419,36.85,0.33,235,52384,70,NULL,NULL,'SDSS J141607.69+034146.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.032083,3.69622,0.041,NULL,58475070539,913672977,14276140,17.5),(118420,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118420,35.31,0.19,115,52385,70,NULL,NULL,'2MASX J14160880+1020043',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.0367917,10.3345,0,NULL,58501303442,914082866,14282544,16.2),(118421,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118421,36.57,0.27,206,52386,70,NULL,NULL,'2MASX J14160909+1835497',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.57',0.42,NULL,NULL,NULL,NULL,NULL,1,214.037833,18.59728,0,NULL,59518810157,929981408,14530959,16.57),(118422,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118422,37.46,0.46,310,52387,70,NULL,NULL,'2MASX J14161001+2718310',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.041625,27.30864,0,NULL,60056626385,938384787,14662262,17.2),(118423,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118423,37.12,0.46,265,52388,70,NULL,NULL,'2MASX J14161025+0541468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.0427083,5.69628,0.021,NULL,58473142598,913642853,14275669,17),(118424,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118424,36.97,0.13,247,52389,70,NULL,NULL,'2MASX J14161077+0802383',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.26',0.22,NULL,NULL,NULL,NULL,NULL,1,214.045,8.04414,0.047,NULL,58497323484,914020679,14281573,17.26),(118425,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118425,36.18,0.46,172,52390,70,NULL,NULL,'2MASX J14161194+0216358',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.049875,2.27658,0.073,NULL,58470241131,913597517,14274961,17),(118426,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118426,37.13,0.46,267,52391,70,NULL,NULL,'2MASX J14161309+2546020',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.054625,25.76708,0,NULL,60000314550,937504914,14648514,16.3),(118427,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118427,37.74,0.46,353,52392,70,NULL,NULL,'2MASX J14161360+6201280',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.0569583,62.02469,0.033,NULL,57762619175,902540924,14102201,17.8),(118428,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118428,36.88,0.46,237,52393,70,NULL,NULL,'2MASX J14161367+3612344',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000188,NULL,'16.2g',0.39,'AGN',NULL,NULL,NULL,NULL,1,214.057,36.20942,0,NULL,60030195494,937971804,14655809,16.2),(118429,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118429,36.68,0.46,217,52394,70,NULL,NULL,'2MASX J14161389+3031435',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.03',0.15,NULL,NULL,NULL,NULL,NULL,1,214.057875,30.52869,0,NULL,60060604048,938446938,14663233,18.03),(118430,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118430,34.24,0.8,70.4,52395,75,NULL,'HMCL, I','KUG 1413+257',NULL,'1997ApJS..109..333W',1997,1,0.94,NULL,'G',0.00002,NULL,'15.1g',0.3,'Spiral',NULL,NULL,NULL,NULL,1,214.0597083,25.54561,0,NULL,60000309252,937504832,14648513,15.1),(118431,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118431,34.39,0.4,75.5,52395,75,NULL,'HMCL, I, raw','KUG 1413+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118432,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118432,34.49,0.4,78.9,52395,75,NULL,'HMCL, I, inv','KUG 1413+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118433,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118433,34.59,0.4,82.9,52395,75,NULL,'HMCL, I, cor','KUG 1413+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118434,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118434,37.27,0.46,284,52396,70,NULL,NULL,'2MASX J14161776+0408568',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000089,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,214.074167,4.14922,0.037,NULL,58475892997,913685828,14276341,16.3),(118435,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118435,36.95,0.46,246,52397,70,NULL,NULL,'2MASX J14161803+2712556',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.6g',0.31,'AGN',NULL,NULL,NULL,NULL,1,214.075,27.21536,0,NULL,60056618327,938384661,14662260,16.6),(118436,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc','R',118436,42.64,NULL,1860,52398,65,NULL,'MLCS17','[HSP2005] J141618.22+521626.09',0.817,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.075916667,52.27392,0,NULL,59195791648,924934244,14452097,NULL),(118437,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118437,42.95,0.21,2140,52398,74.2,NULL,'SALT 2','[HSP2005] J141618.22+521626.09',0.817,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118438,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118438,43.24,0.06,2450,52398,70,NULL,'MLCS17','[HSP2005] J141618.22+521626.09',0.817,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118439,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118439,43.57,0.31,2850,52398,70,NULL,'SALT','[HSP2005] J141618.22+521626.09',0.817,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118440,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118440,43.65,0.25,2960,52398,70,NULL,NULL,'[HSP2005] J141618.22+521626.09',0.817,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118441,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118441,43.7,0.21,3020,52398,65,NULL,'MLCS17','[HSP2005] J141618.22+521626.09',0.817,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118442,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118442,43.72,0.18,3050,52398,65,NULL,'MLCS2k2','[HSP2005] J141618.22+521626.09',0.817,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118443,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118443,43.72,0.29,3050,52398,65,NULL,'SALT','[HSP2005] J141618.22+521626.09',0.817,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118444,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118444,43.72,0.19,3060,52398,65,NULL,'MLCS2k2','[HSP2005] J141618.22+521626.09',0.817,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118445,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118445,43.73,0.19,3060,52398,65,NULL,'MLCS31','[HSP2005] J141618.22+521626.09',0.817,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118446,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118446,43.73,0.22,3070,52398,70,NULL,'SALT 2','[HSP2005] J141618.22+521626.09',0.817,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118447,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118447,43.77,0.15,3120,52398,NULL,NULL,'SIFTO','[HSP2005] J141618.22+521626.09',0.817,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118448,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118448,43.78,0.27,3130,52398,65,NULL,'SALT2','[HSP2005] J141618.22+521626.09',0.817,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118449,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118449,43.89,0.44,3290,52398,65,NULL,'SALT2','[HSP2005] J141618.22+521626.09',0.817,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118450,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118450,43.92,0.2,3340,52398,65,NULL,'SALT','[HSP2005] J141618.22+521626.09',0.817,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118451,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3nc',NULL,118451,45.56,0.17,7130,52398,NULL,NULL,'SALT2','[HSP2005] J141618.22+521626.09',0.817,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118452,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118452,36.76,0.46,225,52399,70,NULL,NULL,'2MASX J14161955-0025519',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,214.0815417,-0.43103,0.069,NULL,43503418487,679740913,10620951,17.1),(118453,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118453,37.46,0.46,311,52400,70,NULL,NULL,'2MASX J14162012+0436398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.083875,4.61125,0.037,NULL,58476335404,913692740,14276449,17.8),(118454,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118454,36.83,0.12,232,52401,70,NULL,NULL,'2MASX J14162214+0203368',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.092333,2.06017,0.077,NULL,58470281923,913598155,14274971,16.6),(118455,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118455,34.72,0.49,88.1,52402,NULL,NULL,NULL,'ESO 579- G 010',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000033,NULL,'15.39',0.6,'Sb:',NULL,NULL,NULL,NULL,1,214.098625,-21.33078,0.373,NULL,46569575482,727649616,11369525,15.39),(118456,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118456,34.73,0.49,88.4,52402,NULL,NULL,'Malmquist cor.','ESO 579- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118457,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118457,34.76,0.2,89.5,52402,74.4,NULL,NULL,'ESO 579- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118458,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118458,37.08,0.46,261,52403,70,NULL,NULL,'2MASX J14162436+2826196',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.1014583,28.43867,0,NULL,60057010127,938390783,14662355,16.8),(118459,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118459,36,0.75,159,52404,70,NULL,NULL,'2MASX J14162654-4821203',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.9b',0.2,NULL,NULL,NULL,NULL,NULL,1,214.110667,-48.35569,0.853,NULL,46835123215,731798800,11434356,16.9),(118460,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118460,37.35,0.46,295,52405,70,NULL,NULL,'2MASX J14162767+0457405',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000105,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.1152917,4.96136,0.033,NULL,58476288092,913692001,14276437,16.3),(118461,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118461,37.06,0.46,259,52406,70,NULL,NULL,'2MASX J14162771+3104586',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.115333,31.08286,0,NULL,60052576506,938321507,14661273,17.8),(118462,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','PS1 SN PS10iy','N',118462,42.49,0.19,2180,52407,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10iy HOST',0.4434,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118463,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118463,36.23,0.71,177,52408,70,NULL,NULL,'2MASX J14162872-4525137',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.1b',0.3,NULL,NULL,NULL,NULL,NULL,1,214.119583,-45.42056,0.321,NULL,46804551219,731321112,11426892,17.1),(118464,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118464,36.95,0.46,246,52409,70,NULL,NULL,'SDSS J141629.50+245053.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000125,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.122958333,24.84819,0,NULL,60000142516,937502226,14648472,17.6),(118465,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118465,37.85,0.46,371,52410,70,NULL,NULL,'2MASX J14163046+2740416',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0002,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,214.127041667,27.67833,0,NULL,60057079238,938391863,14662372,16.8),(118466,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118466,37.09,0.33,262,52411,70,NULL,NULL,'2MASX J14163054+0913440',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000193,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,214.1272917,9.229,0.035,NULL,58501629804,914087965,14282624,15.8),(118467,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118467,37.7,0.46,346,52412,70,NULL,NULL,'2MASX J14163054+3017156',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.1274583,30.28786,0,NULL,60061710058,938464219,14663503,17.8),(118468,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118468,33.29,0.49,45.6,52413,75,NULL,'IR','IC 0995',NULL,'2011yCatp016004901K',2011,1,1.75,NULL,'G',0.000023,NULL,'14.6g',0.39,'Sdm:',NULL,NULL,NULL,NULL,1,214.129625,57.81011,0,NULL,57306122337,895408161,13990752,14.6),(118469,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118469,37.98,0.46,394,52414,70,NULL,NULL,'2MASX J14163185+1859042',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.1327083,18.9845,0,NULL,59518902713,929982854,14530982,NULL),(118470,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118470,36.97,0.13,247,52415,70,NULL,NULL,'2MASX J14163303+0754110',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.137625,7.903,0.047,NULL,58497429700,914022339,14281599,17.1),(118471,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118471,38.08,0.46,414,52416,70,NULL,NULL,'SDSS J141633.17-001735.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.13825,-0.29322,0.069,NULL,43503532123,679742689,10620979,17.9),(118472,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118472,37.85,0.46,372,52417,70,NULL,NULL,'SDSS J141633.42+271700.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000149,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.13925,27.2835,0,NULL,60056630057,938384844,14662263,18.5),(118473,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118473,40.09,0.15,807,52418,74.2,NULL,'SALT 2','LSSP J141633.45+522030.5',0.291,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',0.000006,NULL,'21.1g',0.05,'AGN',NULL,NULL,NULL,NULL,1,214.1392917,52.34183,0,NULL,59195800943,924934389,14452099,21.1),(118474,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118474,40.55,0.31,996,52418,65,NULL,'SNLS 03D3ba, MLCS31','LSSP J141633.45+522030.5',0.291,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118475,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118475,40.57,0.3,1000,52418,65,NULL,'SNLS 03D3ba, MLCS2k2','LSSP J141633.45+522030.5',0.291,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118476,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118476,40.62,0.2,1030,52418,65,NULL,'SNLS 03D3ba, MLCS2k2','LSSP J141633.45+522030.5',0.291,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118477,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn','R',118477,40.68,NULL,1060,52418,65,NULL,'SNLS 03D3ba, MLCS31','LSSP J141633.45+522030.5',0.291,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118478,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118478,40.79,0.13,1110,52418,70,NULL,'SNLS 03D3ba, SALT','LSSP J141633.45+522030.5',0.291,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118479,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118479,40.83,0.14,1130,52418,70,NULL,'SNLS 03D3ba, SALT 2','LSSP J141633.45+522030.5',0.291,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118480,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118480,40.87,0.15,1160,52418,NULL,NULL,'SNLS 03D3ba, SIFTO','LSSP J141633.45+522030.5',0.291,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118481,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118481,40.88,0.14,1160,52418,65,NULL,'SNLS 03D3ba, SALT2','LSSP J141633.45+522030.5',0.291,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118482,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118482,40.89,0.1,1170,52418,65,NULL,'SNLS 03D3ba, SALT','LSSP J141633.45+522030.5',0.291,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118483,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118483,40.89,0.24,1170,52418,65,NULL,'SNLS 03D3ba, MLCS17','LSSP J141633.45+522030.5',0.291,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118484,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118484,40.95,0.18,1200,52418,65,NULL,'SNLS 03D3ba, SALT2','LSSP J141633.45+522030.5',0.291,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118485,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118485,41,0.03,1230,52418,70,NULL,'SNLS 03D3ba','LSSP J141633.45+522030.5',0.291,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118486,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118486,41.26,0.05,1390,52418,65,NULL,'SNLS 03D3ba, SALT','LSSP J141633.45+522030.5',0.291,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118487,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118487,41.54,0.05,1570,52418,70,NULL,'SNLS 03D3ba, MLCS31','LSSP J141633.45+522030.5',0.291,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118488,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fn',NULL,118488,42.01,0.17,1950,52418,NULL,NULL,'SNLS 03D3ba, SALT2','LSSP J141633.45+522030.5',0.291,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118489,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118489,36.33,0.46,185,52419,70,NULL,NULL,'2MASX J14163404+0748000',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.60',0.2,NULL,NULL,NULL,NULL,NULL,1,214.141916667,7.79997,0.047,NULL,58497413255,914022082,14281595,17.6),(118490,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118490,37.53,0.46,321,52420,70,NULL,NULL,'2MASX J14163441+1844462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.143416667,18.74611,0,NULL,59518974599,929983978,14530999,17.4),(118491,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118491,36.33,0.46,184,52421,70,NULL,NULL,'2MASX J14163505+0400355',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,214.1459583,4.00981,0.033,NULL,58475930367,913686411,14276350,16.6),(118492,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr','R',118492,40.49,NULL,939,52422,65,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0002,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.14975,52.47894,0.005,NULL,59197889120,924967017,14452609,NULL),(118493,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118493,40.59,0.14,981,52422,74.2,NULL,'SALT 2','[HSP2005] J141635.93+522844.20',0.337,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118494,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118494,40.98,0.03,1170,52422,70,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118495,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118495,41.18,0.12,1290,52422,70,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118496,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118496,41.26,0.01,1340,52422,70,NULL,NULL,'[HSP2005] J141635.93+522844.20',0.337,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118497,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118497,41.33,0.09,1380,52422,65,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118498,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118498,41.35,0.15,1400,52422,NULL,NULL,'SIFTO','[HSP2005] J141635.93+522844.20',0.337,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118499,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118499,41.39,0.14,1420,52422,65,NULL,'MLCS17','[HSP2005] J141635.93+522844.20',0.337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118500,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118500,41.41,0.09,1430,52422,65,NULL,'SALT2','[HSP2005] J141635.93+522844.20',0.337,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118501,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118501,41.44,0.16,1450,52422,65,NULL,'MLCS31','[HSP2005] J141635.93+522844.20',0.337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118502,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118502,41.46,0.08,1460,52422,65,NULL,'MLCS2k2','[HSP2005] J141635.93+522844.20',0.337,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118503,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118503,41.46,0.14,1460,52422,65,NULL,'MLCS2k2','[HSP2005] J141635.93+522844.20',0.337,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118504,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118504,41.46,0.17,1460,52422,65,NULL,'SALT2','[HSP2005] J141635.93+522844.20',0.337,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118505,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118505,41.52,0.01,1510,52422,65,NULL,'SALT','[HSP2005] J141635.93+522844.20',0.337,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118506,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3kr',NULL,118506,42.79,0.17,2700,52422,NULL,NULL,'SALT2','[HSP2005] J141635.93+522844.20',0.337,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118507,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118507,37.69,0.46,345,52423,70,NULL,NULL,'SDSS J141636.21-005258.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000062,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.150917,-0.88281,0.085,NULL,43503756967,679746202,10621034,18.1),(118508,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118508,36.04,0.2,161,52424,74.4,NULL,NULL,'UGC 09135',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.16',0.5,'SB?            AGN',NULL,NULL,NULL,'Sy ?',1,214.153833333,24.50253,0,NULL,59467316986,929176827,14518387,15.16),(118509,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml','R',118509,42.82,NULL,1880,52425,65,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.1629583,53.09325,0,NULL,59194584506,924915382,14451802,NULL),(118510,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118510,43.27,0.3,2310,52425,74.2,NULL,'SALT 2','[HSP2005] J141639.10+530535.66',0.95,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118511,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118511,43.36,0.08,2410,52425,70,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118512,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118512,43.78,0.42,2920,52425,70,NULL,'SALT','[HSP2005] J141639.10+530535.66',0.95,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118513,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118513,43.84,0.4,3010,52425,65,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118514,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118514,43.91,0.45,3110,52425,65,NULL,'SALT','[HSP2005] J141639.10+530535.66',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118515,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118515,43.95,0.27,3170,52425,70,NULL,NULL,'[HSP2005] J141639.10+530535.66',0.95,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118516,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118516,44.06,0.25,3330,52425,65,NULL,'MLCS2k2','[HSP2005] J141639.10+530535.66',0.95,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118517,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118517,44.08,0.15,3350,52425,NULL,NULL,'SIFTO','[HSP2005] J141639.10+530535.66',0.95,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118518,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118518,44.11,0.29,3400,52425,65,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118519,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118519,44.12,0.17,3410,52425,65,NULL,'MLCS17','[HSP2005] J141639.10+530535.66',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118520,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118520,44.14,0.12,3440,52425,65,NULL,'MLCS2k2','[HSP2005] J141639.10+530535.66',0.95,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118521,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118521,44.15,0.15,3470,52425,65,NULL,'MLCS31','[HSP2005] J141639.10+530535.66',0.95,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118522,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118522,44.16,0.22,3480,52425,70,NULL,'SALT 2','[HSP2005] J141639.10+530535.66',0.95,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118523,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118523,44.22,0.17,3580,52425,65,NULL,'SALT','[HSP2005] J141639.10+530535.66',0.95,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118524,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3ml',NULL,118524,45.51,0.17,6490,52425,NULL,NULL,'SALT2','[HSP2005] J141639.10+530535.66',0.95,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118525,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118525,36.97,0.13,247,52426,70,NULL,NULL,'2MASX J14164065+0812510',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00019,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,214.169541667,8.21425,0.044,NULL,58497885869,914029466,14281710,15.8),(118526,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118526,37.41,0.46,303,52427,70,NULL,NULL,'2MASX J14164132+3557548',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.1722917,35.96514,0,NULL,60044096644,938189010,14659203,16.4),(118527,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118527,37.65,0.46,339,52428,70,NULL,NULL,'2MASX J14164253+4300262',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.1772083,43.00725,0,NULL,59225089342,925392020,14459250,16.9),(118528,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118528,33.96,0.8,62.1,52429,75,NULL,'HMCL, I','UGC 09138',NULL,'1997ApJS..109..333W',1997,1,1.99,NULL,'G',0.000007,NULL,'15.22',0.22,'Sc',NULL,NULL,NULL,NULL,1,214.1967083,23.00247,0,NULL,59469447715,929210120,14518908,15.22),(118529,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118529,33.84,NULL,58.5,52429,NULL,NULL,NULL,'UGC 09138',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118530,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118530,33.84,NULL,58.5,52429,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09138',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118531,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118531,33.86,NULL,59.1,52429,NULL,NULL,'Dipole + Quadrupole','UGC 09138',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118532,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118532,33.87,NULL,59.5,52429,NULL,NULL,'Dipole','UGC 09138',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118533,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118533,34.02,0.4,63.7,52429,75,NULL,'HMCL, I, raw','UGC 09138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118534,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118534,34.13,0.4,66.9,52429,75,NULL,'HMCL, I, inv','UGC 09138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118535,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118535,34.15,0.49,67.5,52429,75,NULL,'IR','UGC 09138',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118536,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118536,34.21,0.32,69.5,52429,NULL,NULL,'Malmquist cor.','UGC 09138',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118537,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118537,34.21,0.4,69.5,52429,75,NULL,'HMCL, I, cor','UGC 09138',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118538,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118538,34.25,0.2,70.8,52429,74.4,NULL,NULL,'UGC 09138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118539,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118539,34.32,0.31,73,52429,NULL,NULL,NULL,'UGC 09138',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118540,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jk',NULL,118540,42.56,0.05,1880,52430,70,NULL,'SIFTO','SNLS 05D3jk',0.736,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.19775,52.5925,0.005,NULL,59197937663,924967775,14452621,NULL),(118541,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jk',NULL,118541,43.21,0.15,2520,52430,NULL,NULL,'SIFTO','SNLS 05D3jk',0.736,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118542,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jk',NULL,118542,43.31,0.17,2640,52430,70,NULL,'SALT 2','SNLS 05D3jk',0.736,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118543,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jk',NULL,118543,44.53,0.17,4630,52430,NULL,NULL,'SALT2','SNLS 05D3jk',0.736,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118544,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118544,36.61,0.46,210,52431,70,NULL,NULL,'2MASX J14164778+1740150',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.17,NULL,NULL,NULL,NULL,NULL,1,214.199167,17.67094,0,NULL,59487172241,929487066,14523235,18.4),(118545,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118545,37.59,0.46,329,52432,70,NULL,NULL,'2MASX J14164881+0509565',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000077,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.203375,5.16567,0.033,NULL,58476274583,913691790,14276434,17),(118546,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118546,42.3,0.19,1690,52433,74.2,NULL,'SALT 2','[AGR2006] J141651.96+524845.7',0.71,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.2165417,52.81269,0,NULL,59197916761,924967449,14452616,NULL),(118547,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118547,42.65,0.24,1980,52433,65,NULL,'MLCS2k2','[AGR2006] J141651.96+524845.7',0.71,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118548,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is','R',118548,42.82,NULL,2140,52433,65,NULL,'MLCS17','[AGR2006] J141651.96+524845.7',0.71,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118549,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118549,42.91,0.15,2230,52433,65,NULL,'SALT2','[AGR2006] J141651.96+524845.7',0.71,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118550,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118550,43.03,0.19,2360,52433,70,NULL,'SALT','[AGR2006] J141651.96+524845.7',0.71,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118551,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118551,43.09,0.37,2430,52433,65,NULL,'MLCS17','[AGR2006] J141651.96+524845.7',0.71,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118552,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118552,43.13,0.16,2470,52433,65,NULL,'SALT','[AGR2006] J141651.96+524845.7',0.71,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118553,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118553,43.18,0.08,2530,52433,70,NULL,NULL,'[AGR2006] J141651.96+524845.7',0.71,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118554,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118554,43.19,0.2,2540,52433,65,NULL,'SALT2','[AGR2006] J141651.96+524845.7',0.71,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118555,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118555,43.44,0.05,2850,52433,65,NULL,'SALT','[AGR2006] J141651.96+524845.7',0.71,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118556,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118556,43.71,0.33,3230,52433,65,NULL,'MLCS2k2','[AGR2006] J141651.96+524845.7',0.71,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118557,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3is',NULL,118557,43.72,0.34,3240,52433,65,NULL,'MLCS31','[AGR2006] J141651.96+524845.7',0.71,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118558,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118558,36.84,0.46,233,52434,70,NULL,NULL,'SDSS J141651.97+052141.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000072,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.216583333,5.36158,0.021,NULL,58473586479,913649788,14275777,18.2),(118559,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118559,33.17,0.3,43.1,52435,95,NULL,'Weighted Mean','NGC 5532',NULL,'1984ApJS...56...91D',1984,1,1.32,NULL,'G',0.00007,NULL,'14.05',1.02,'FRI            LEG','Possible field galaxy',NULL,'FR I','Flat-Spectrum Radio Source',1,214.220625,10.80739,0,NULL,58500644492,914072570,14282383,14.05),(118560,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118560,33.25,0.46,44.7,52435,95,NULL,'Michard 1979a','NGC 5532',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118561,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118561,33.39,0.41,47.6,52435,95,NULL,'de Vaucouleurs','NGC 5532',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118562,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118562,33.54,0.63,51.1,52435,95,NULL,'Michard 1979b, c','NGC 5532',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118563,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118563,35.31,0.19,115,52435,70,NULL,NULL,'NGC 5532',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118564,'Tertiary','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118564,34.3,0.5,72.4,52435,95,NULL,NULL,'NGC 5532',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118565,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118565,34.44,0.45,77.3,52435,NULL,NULL,'K','NGC 5532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118566,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118566,35.11,0.4,105,52435,NULL,NULL,'mean','NGC 5532',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118567,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118567,37.07,0.46,260,52436,70,NULL,NULL,'2MASX J14165303+3023034',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.11',0.26,NULL,NULL,NULL,NULL,NULL,1,214.220833,30.38428,0,NULL,60061684840,938463825,14663497,17.11),(118568,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118568,38.26,0.19,450,52437,70,NULL,NULL,'SDSS J141653.32+432304.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.222208333,43.38467,0,NULL,59225040303,925391254,14459238,18.5),(118569,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cf',NULL,118569,41.93,0.17,1720,52438,NULL,NULL,'SALT2','DEEP2 11044756',0.418732,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.000011,NULL,'22.4V',NULL,'a',NULL,NULL,NULL,NULL,1,214.2225417,52.34511,0,NULL,59195795504,924934304,14452098,22.4),(118570,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cf',NULL,118570,41.95,0.12,1730,52438,70,NULL,'SALT 2','DEEP2 11044756',0.418732,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118571,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cf',NULL,118571,41.99,0.15,1760,52438,NULL,NULL,'SIFTO','DEEP2 11044756',0.418732,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118572,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cf',NULL,118572,42.36,0.03,2090,52438,70,NULL,'SIFTO','DEEP2 11044756',0.418732,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118573,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118573,36.97,0.13,247,52439,70,NULL,NULL,'2MASX J14165359+0822324',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,214.22325,8.37567,0.073,NULL,58497866751,914029167,14281705,16.4),(118574,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118574,36.67,0.46,215,52440,70,NULL,NULL,'2MASX J14165378+2415244',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.223917,24.25672,0,NULL,59467666333,929182286,14518473,17.8),(118575,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118575,38.02,0.46,402,52441,70,NULL,NULL,'2MASX J14165555+4232052',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.23125,42.53483,0,NULL,59225408599,925397009,14459328,17.5),(118576,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118576,37.88,0.46,376,52442,70,NULL,NULL,'2MASX J14165639+1521031',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.235,15.35092,0,NULL,59488924910,929514451,14523663,18.2),(118577,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118577,36.16,0.46,171,52443,70,NULL,NULL,'2MASX J14165678+4538352',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.236583,45.64328,0,NULL,59229110970,925454858,14460232,16.3),(118578,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118578,37.03,0.46,255,52444,70,NULL,NULL,'2MASX J14165705+2815144',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00009,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.2377917,28.25406,0,NULL,60057032585,938391134,14662361,16.6),(118579,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118579,35.84,0.46,147,52445,70,NULL,NULL,'CGCG 018-102',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00009,NULL,'15.7g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,214.2395,2.17764,0.069,NULL,58286554269,910727410,14230115,15.7),(118580,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118580,42.58,0.2,1900,52446,74.2,NULL,'SALT 2','[HSP2005] J141657.90+522246.53',0.73,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,'22.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.2412083,52.37978,0,NULL,59195795964,924934311,14452098,22.5),(118581,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq','R',118581,42.59,NULL,1910,52446,65,NULL,'MLCS17','[HSP2005] J141657.90+522246.53',0.73,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118582,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118582,43.29,0.08,2630,52446,70,NULL,NULL,'[HSP2005] J141657.90+522246.53',0.73,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118583,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118583,43.29,0.05,2630,52446,70,NULL,'SALT 2','[HSP2005] J141657.90+522246.53',0.73,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118584,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118584,43.31,0.17,2650,52446,70,NULL,'SALT','[HSP2005] J141657.90+522246.53',0.73,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118585,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118585,43.31,0.17,2650,52446,NULL,NULL,'SALT2','[HSP2005] J141657.90+522246.53',0.73,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118586,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118586,43.32,0.24,2660,52446,70,NULL,'SALT 2','[HSP2005] J141657.90+522246.53',0.73,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118587,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118587,43.36,0.15,2720,52446,NULL,NULL,'SIFTO','[HSP2005] J141657.90+522246.53',0.73,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118588,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118588,43.43,0.25,2810,52446,65,NULL,'MLCS17','[HSP2005] J141657.90+522246.53',0.73,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118589,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118589,43.44,0.16,2820,52446,65,NULL,'MLCS2k2','[HSP2005] J141657.90+522246.53',0.73,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118590,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118590,43.44,0.2,2820,52446,65,NULL,'SALT2','[HSP2005] J141657.90+522246.53',0.73,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118591,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118591,43.45,0.15,2840,52446,65,NULL,'SALT2','[HSP2005] J141657.90+522246.53',0.73,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118592,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118592,43.47,0.14,2860,52446,65,NULL,'SALT','[HSP2005] J141657.90+522246.53',0.73,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118593,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118593,43.55,0.06,2970,52446,65,NULL,'SALT','[HSP2005] J141657.90+522246.53',0.73,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118594,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118594,43.57,0.24,2990,52446,65,NULL,'MLCS2k2','[HSP2005] J141657.90+522246.53',0.73,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118595,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fq',NULL,118595,43.57,0.26,2990,52446,65,NULL,'MLCS31','[HSP2005] J141657.90+522246.53',0.73,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118596,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118596,31.52,0.43,20.1,52447,75,NULL,'3.6 micron, color + selection bias corrected','IC 4390',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000667,NULL,'13.78',0.6,'SA(s)b         HII',NULL,NULL,NULL,NULL,1,214.246667,-44.97733,0.373,NULL,46807935172,731373987,11427718,13.78),(118597,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3do',NULL,118597,42.84,0.05,2140,52448,70,NULL,'SIFTO','SNLS 06D3do',0.726,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.2474583,52.88256,0,NULL,59194491039,924913922,14451780,NULL),(118598,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3do',NULL,118598,43.34,0.21,2690,52448,70,NULL,'SALT 2','SNLS 06D3do',0.726,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118599,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3do',NULL,118599,43.35,0.15,2720,52448,NULL,NULL,'SIFTO','SNLS 06D3do',0.726,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118600,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3do',NULL,118600,44.31,0.17,4230,52448,NULL,NULL,'SALT2','SNLS 06D3do',0.726,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118601,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118601,35.31,0.19,115,52449,70,NULL,NULL,'2MASX J14165944+1047224',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.247666667,10.78947,0,NULL,58500640971,914072515,14282383,16.1),(118602,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118602,35.34,0.46,117,52450,70,NULL,NULL,'CGCG 074-157',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000147,NULL,'15.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,214.248875,9.10589,0.033,NULL,58495086848,913985732,14281027,15.2),(118603,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118603,35.04,0.8,102,52451,75,NULL,'HMCL, I','CGCG 046-079',NULL,'1997ApJS..109..333W',1997,1,0.84,NULL,'G',0.000027,NULL,'15.4',0.37,NULL,NULL,NULL,NULL,NULL,1,214.254291667,7.26014,0.045,NULL,58494522128,913976908,14280889,15.4),(118604,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118604,35.18,0.4,109,52451,75,NULL,'HMCL, I, raw','CGCG 046-079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118605,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118605,35.3,0.4,115,52451,75,NULL,'HMCL, I, cor','CGCG 046-079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118606,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118606,35.37,0.4,118,52451,75,NULL,'HMCL, I, inv','CGCG 046-079',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118607,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3el',NULL,118607,41.75,0.04,1480,52452,70,NULL,'SIFTO','SNLS 06D3el',0.519,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.2545417,52.23239,0,NULL,59195844314,924935067,14452110,NULL),(118608,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3el',NULL,118608,42.41,0.15,2000,52452,NULL,NULL,'SIFTO','SNLS 06D3el',0.519,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118609,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3el',NULL,118609,42.54,0.12,2120,52452,70,NULL,'SALT 2','SNLS 06D3el',0.519,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118610,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3el',NULL,118610,43.71,0.17,3640,52452,NULL,NULL,'SALT2','SNLS 06D3el',0.519,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118611,'CMD','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118611,30.7,0.04,13.8,52453,NULL,NULL,NULL,'SBS 1415+437',NULL,'2010ApJ...721..297M',2010,1,0.75,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'15.6',0.15,'BlueCG         HII',NULL,NULL,NULL,NULL,1,214.255875,43.50153,0,NULL,59238881186,925607518,14462617,15.6),(118612,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118612,30.66,NULL,13.6,52453,NULL,NULL,'BlueCG, HII','SBS 1415+437',NULL,'2005ApJ...631L..45A',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118613,'TRGB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118613,30.67,0.21,13.6,52453,NULL,NULL,NULL,'SBS 1415+437',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118614,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118614,35.31,0.19,115,52454,70,NULL,NULL,'2MASX J14170154+1047274',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000067,NULL,'16.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.256417,10.79086,0,NULL,58500638929,914072483,14282382,16),(118615,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118615,36.55,0.46,204,52455,70,NULL,NULL,'2MASX J14170289+0838554',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.261875,8.64878,0.073,NULL,58497171404,914018303,14281535,16.7),(118616,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gx',NULL,118616,42.75,0.06,2020,52456,70,NULL,NULL,'SNLS 06D3gx HOST',0.76,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.02,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.264,52.93939,0,NULL,59194573786,924915215,14451800,NULL),(118617,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gx',NULL,118617,43.48,0.25,2830,52456,70,NULL,'SALT 2','SNLS 06D3gx HOST',0.76,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118618,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118618,31.82,NULL,23.1,52457,72,NULL,NULL,'GALEXASC J141703.59-013013.2',NULL,'2014Ap.....57..457K',2014,1,0.66,NULL,'G',0.000007,NULL,'17.58',0.3,'Ir',NULL,NULL,NULL,NULL,1,214.264833,-1.50444,0.145,NULL,43507016461,679797132,10621830,17.58),(118619,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118619,37.6,0.46,330,52458,70,NULL,NULL,'2MASX J14170384+4616442',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.2659583,46.27908,0,NULL,59229757141,925464955,14460389,17.4),(118620,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118620,36.49,0.46,199,52459,70,NULL,NULL,'[HB89] 1414+092',NULL,'2015arXiv151105856S',2015,1,0.35,'HB89 calls this a QSO with z = 2.35.','G',0.000167,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.267083333,8.96858,0.033,NULL,58495131656,913986432,14281038,16.7),(118621,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118621,32.88,0.47,37.6,52460,NULL,NULL,'H','NGC 5545',NULL,'2007A&A...465...71T',2007,1,0.08,'Multiple SDSS entries describe this object.','G',0.000033,NULL,'18.5g',0.08,'SA(s)bc:','Pair member (points to parent)',NULL,NULL,NULL,1,214.2715,36.57511,0,NULL,60032265904,938004154,14656314,18.5),(118622,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118622,32.96,0.46,39.1,52460,NULL,NULL,'J','NGC 5545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118623,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118623,33.04,0.45,40.6,52460,NULL,NULL,'K','NGC 5545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118624,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118624,33.33,0.4,46.4,52460,NULL,NULL,'mean','NGC 5545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118625,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118625,37.76,0.46,356,52461,70,NULL,NULL,'2MASX J14170704+1643082',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.279375,16.71894,0,NULL,59485037917,929453717,14522714,18.3),(118626,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118626,37.78,0.46,359,52462,70,NULL,NULL,'SDSS J141708.01-010526.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,214.283417,-1.09064,0.137,NULL,43503813939,679747092,10621048,18.5),(118627,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118627,36.97,0.46,248,52463,70,NULL,NULL,'2MASX J14170836+5251555',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.284875,52.86553,0,NULL,59197915736,924967433,14452616,16.8),(118628,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118628,37.09,0.33,262,52464,70,NULL,NULL,'2MASX J14170931+0915074',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.2887083,9.252,0.038,NULL,58499593826,914056153,14282127,16.8),(118629,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118629,36.64,0.46,212,52465,70,NULL,NULL,'2MASX J14170959+1707012',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.23',0.17,NULL,NULL,NULL,NULL,NULL,1,214.2899583,17.11692,0,NULL,59486966974,929483858,14523185,18.23),(118630,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118630,37.45,0.46,310,52466,70,NULL,NULL,'2MASX J14170991+5246586',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.291375,52.78294,0.005,NULL,59197928724,924967636,14452619,16.6),(118631,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3bz',NULL,118631,43.07,0.17,2390,52467,NULL,NULL,'SALT2','SNLS 06D3bz HOST',0.72,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'23.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.29175,53.02472,0,NULL,59194587739,924915433,14451803,23.1),(118632,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3bz',NULL,118632,43.1,0.06,2420,52467,70,NULL,'SALT2','SNLS 06D3bz HOST',0.72,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118633,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3bz',NULL,118633,43.14,0.15,2460,52467,NULL,NULL,'SIFTO','SNLS 06D3bz HOST',0.72,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118634,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3bz',NULL,118634,43.31,0.22,2670,52467,70,NULL,'SALT 2','SNLS 06D3bz HOST',0.72,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118635,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118635,37.63,0.33,336,52468,70,NULL,NULL,'SDSS J141711.44+063609.3',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,'PHOT','16.6g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.297667,6.60261,0.029,NULL,58503117176,914111205,14282987,16.6),(118636,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118636,35.95,0.41,155,52469,NULL,NULL,'Malmquist cor.','MCG +06-31-092',NULL,'2009ApJS..182..474S',2009,1,0.84,NULL,'G',0.000023,NULL,'15.3g',0.3,'SABc(r)',NULL,NULL,NULL,NULL,1,214.29925,35.40933,0,NULL,60044861025,938200953,14659389,15.3),(118637,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118637,36.27,0.36,180,52469,NULL,NULL,NULL,'MCG +06-31-092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118638,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118638,36.31,0.2,183,52469,74.4,NULL,NULL,'MCG +06-31-092',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118639,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118639,35.31,0.19,115,52470,70,NULL,NULL,'2MASX J14171192+1036424',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000157,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.299541667,10.61178,0,NULL,58501109568,914079837,14282497,16.1),(118640,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118640,36.83,0.12,232,52471,70,NULL,NULL,'2MASX J14171277+0142504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000099,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.303208333,1.714,0.013,NULL,58286645788,910728840,14230138,16.7),(118641,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118641,36.36,0.46,187,52472,70,NULL,NULL,'2MASX J14171303+0721454',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000168,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.3045417,7.36264,0.045,NULL,58494543997,913977249,14280894,16.2),(118642,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118642,36.83,0.12,232,52473,70,NULL,NULL,'SDSS J141713.19+022051.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000062,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.305,2.34769,0.073,NULL,58286216659,910722135,14230033,17.4),(118643,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118643,38.83,0.46,583,52474,70,NULL,NULL,'2MASX J14171320-0134336',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.3050417,-1.57597,0.145,NULL,43504942158,679764721,10621323,18.1),(118644,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118644,36.43,0.46,193,52475,70,NULL,NULL,'2MASX J14171324+3112094',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00011,NULL,'16.30',0.35,NULL,NULL,NULL,NULL,NULL,1,214.305083,31.20267,0,NULL,60060734637,938448978,14663265,16.3),(118645,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118645,36.81,0.33,230,52476,70,NULL,NULL,'2MASX J14171357+0118064',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000103,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.306583,1.30189,0.065,NULL,58287478236,910741847,14230341,16.4),(118646,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118646,38.41,0.46,481,52477,70,NULL,NULL,'SDSS J141714.52+431041.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,214.3105417,43.17833,0,NULL,59225058056,925391532,14459242,18.4),(118647,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118647,36.96,0.46,247,52478,70,NULL,NULL,'2MASX J14171550+2843544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,214.314583,28.73175,0,NULL,60058693716,938417089,14662767,16.7),(118648,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118648,37.88,0.46,377,52479,70,NULL,NULL,'2MASX J14171549+2531114',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.3147083,25.51989,0,NULL,60000326395,937505099,14648517,17.5),(118649,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118649,37.39,0.15,300,52480,70,NULL,NULL,'2MASX J14171595+2619524',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.3164583,26.33128,0,NULL,59999803157,937496924,14648389,16.9),(118650,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118650,36.43,0.46,193,52481,70,NULL,NULL,'2MASX J14171627-0135216',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,214.317875,-1.58922,0.145,NULL,43504940393,679764693,10621323,16),(118651,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118651,36.41,0.46,191,52482,70,NULL,NULL,'2MASX J14171637+1933532',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.3182083,19.56478,0,NULL,59520472645,930007385,14531365,NULL),(118652,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118652,37.63,0.33,336,52483,70,NULL,NULL,'2MASX J14171764+0633374',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.3234583,6.56053,0.025,NULL,58503104344,914111005,14282984,17.9),(118653,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118653,36.81,0.33,230,52484,70,NULL,NULL,'2MASX J14171777+0113174',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.3239583,1.22153,0.065,NULL,58287474486,910741788,14230340,17.1),(118654,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118654,37.57,0.46,327,52485,70,NULL,NULL,'2MASX J14171791+2041032',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.77',0.15,NULL,NULL,NULL,NULL,NULL,1,214.324583,20.68422,0.016,NULL,59521765909,930027592,14531681,17.77),(118655,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118655,37.18,0.46,273,52486,70,NULL,NULL,'2MASX J14171828+1248319',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.326166667,12.80894,0,NULL,58354756962,911793077,14246766,17.7),(118656,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118656,37.04,0.46,256,52487,70,NULL,NULL,'2MASX J14171855+1809462',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,214.327417,18.16294,0,NULL,59486240711,929472511,14523007,18.18),(118657,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','PS1 SN PS10jp','N',118657,41.36,0.18,1350,52488,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jp HOST',0.3874,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118658,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118658,36.79,0.16,228,52489,70,NULL,NULL,'2MASX J14171867+0005403',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000105,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,214.327833,0.09456,0.057,NULL,58284126819,910689481,14229523,16.4),(118659,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118659,36.83,0.12,232,52490,70,NULL,NULL,'2MASX J14171918+0233044',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000098,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.329875,2.55131,0.077,NULL,58286257949,910722780,14230043,16.5),(118660,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118660,37.39,0.15,300,52491,70,NULL,NULL,'2MASX J14171930+2618544',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'17.97',0.13,NULL,NULL,NULL,NULL,NULL,1,214.3305417,26.31506,0,NULL,59999805032,937496953,14648389,17.97),(118661,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118661,36.73,0.72,221,52492,70,NULL,NULL,'2MASX J14172004-3451191',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.333458333,-34.85528,0.173,NULL,47009732322,734527067,11476985,15.8),(118662,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118662,38.74,0.46,560,52493,70,NULL,NULL,'LCRS B141444.3-030150',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.33375,-3.26133,0.109,NULL,43730918987,683295609,10676493,17.9),(118663,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118663,37.18,0.23,273,52494,70,NULL,NULL,'2MASX J14172122+3014261',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.49',0.32,NULL,NULL,NULL,NULL,NULL,1,214.3384583,30.24069,0,NULL,60061892803,938467075,14663548,16.49),(118664,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3dt',NULL,118664,40.94,0.15,1200,52495,NULL,NULL,'SIFTO','SNLS 06D3dt',0.282,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.34025,52.45281,0,NULL,59195822236,924934722,14452105,NULL),(118665,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3dt',NULL,118665,40.95,0.11,1210,52495,70,NULL,'SALT 2','SNLS 06D3dt',0.282,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118666,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3dt',NULL,118666,41.28,0.17,1400,52495,NULL,NULL,'SALT2','SNLS 06D3dt',0.282,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118667,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3dt',NULL,118667,41.77,0.03,1760,52495,70,NULL,'SIFTO','SNLS 06D3dt',0.282,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118668,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118668,36.83,0.12,232,52496,70,NULL,NULL,'2MASX J14172244+0202074',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000094,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.3435,2.03536,0.057,NULL,58286579310,910727801,14230121,16.4),(118669,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118669,38.99,0.46,628,52497,70,NULL,NULL,'SDSS J141722.56+025217.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000096,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.3440417,2.87158,0.073,NULL,58286150082,910721095,14230017,18.3),(118670,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118670,37.13,0.46,267,52498,70,NULL,NULL,'VIII Zw 395',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000099,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,214.348583,1.64469,0.013,NULL,58286651233,910728925,14230139,16.3),(118671,'SGRB','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118671,42.6,NULL,3310,52499,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 050717',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,214.352041667,-50.5335,1.109,NULL,46837934237,731842722,11435042,NULL),(118672,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118672,36.29,0.33,181,52500,70,NULL,NULL,'CGCG 046-081',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000203,NULL,'15.5',0.27,NULL,NULL,NULL,NULL,NULL,1,214.35425,8.05,0.044,NULL,58497923375,914030052,14281719,15.5),(118673,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118673,35.01,0.48,101,52501,70,NULL,NULL,'2MASX J14172504-3516311',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,214.3544583,-35.27525,0.161,NULL,47008908682,734514198,11476784,13.5),(118674,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jh',NULL,118674,42.73,0.17,2050,52502,NULL,NULL,'SALT2','SNLS 05D3jh',0.718,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.35575,52.61878,0.005,NULL,59197934100,924967720,14452620,NULL),(118675,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jh',NULL,118675,42.76,0.05,2080,52502,70,NULL,'SALT2','SNLS 05D3jh',0.718,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118676,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jh',NULL,118676,43.12,0.15,2450,52502,NULL,NULL,'SIFTO','SNLS 05D3jh',0.718,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118677,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3jh',NULL,118677,43.18,0.18,2520,52502,70,NULL,'SALT 2','SNLS 05D3jh',0.718,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118678,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118678,37.39,0.15,300,52503,70,NULL,NULL,'2MASX J14172547+2620534',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000196,NULL,'17.52',0.25,NULL,NULL,NULL,NULL,NULL,1,214.356291667,26.34814,0,NULL,59999832441,937497381,14648396,17.52),(118679,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118679,36.83,0.12,232,52504,70,NULL,NULL,'2MASX J14172681+0202488',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000101,NULL,'15.8g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,214.3617083,2.04689,0.057,NULL,58286579070,910727797,14230121,15.8),(118680,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118680,37.39,0.15,300,52505,70,NULL,NULL,'2MASX J14172770+2620435',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.3655,26.34547,0,NULL,59999833477,937497398,14648396,17.1),(118681,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118681,37.72,0.46,350,52506,70,NULL,NULL,'2MASX J14172774+4141249',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.3657083,41.69036,0,NULL,59227282485,925426288,14459785,18.1),(118682,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118682,36.79,0.16,228,52507,70,NULL,NULL,'CGCG 018-107',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000093,NULL,'15.5g',0.48,'NLAGN',NULL,NULL,NULL,NULL,1,214.366541667,0.48278,0.073,NULL,58285093912,910704592,14229759,15.5),(118683,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118683,37.18,0.23,273,52508,70,NULL,NULL,'2MASX J14173001+3017351',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.82',0.21,NULL,NULL,NULL,NULL,NULL,1,214.374917,30.29308,0,NULL,60061867827,938466684,14663541,17.82),(118684,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118684,36.79,0.16,228,52509,70,NULL,NULL,'CGCG 018-108',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000104,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,214.3777083,0.35053,0.073,NULL,58284986780,910702918,14229733,15.7),(118685,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118685,38.26,0.19,450,52510,70,NULL,NULL,'2MASX J14173091+4320537',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000063,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.378583,43.34817,0,NULL,59225074441,925391788,14459246,17.3),(118686,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118686,36.97,0.13,247,52511,70,NULL,NULL,'NGC 5535',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0002,NULL,'15.7g',0.5,'E',NULL,NULL,'radio jet',NULL,1,214.3802917,8.20839,0.044,NULL,58497904679,914029760,14281715,15.7),(118687,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118687,37.05,0.46,257,52512,70,NULL,NULL,'2MASX J14173150+0046178',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,214.381167,0.77164,0.069,NULL,58284743998,910699124,14229673,16.5),(118688,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3cc',NULL,118688,43.18,0.07,2280,52513,70,NULL,'SIFTO','SNLS 06D3cc HOST',0.9,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'23.5R',NULL,'a',NULL,NULL,NULL,NULL,1,214.381416667,52.91233,0,NULL,59198031379,924969240,14452644,23.5),(118689,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3cc',NULL,118689,43.31,0.31,2420,52513,70,NULL,'SALT 2','SNLS 06D3cc HOST',0.9,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118690,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3cc',NULL,118690,43.33,0.15,2440,52513,NULL,NULL,'SIFTO','SNLS 06D3cc HOST',0.9,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118691,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3cc',NULL,118691,44.45,0.17,4090,52513,NULL,NULL,'SALT2','SNLS 06D3cc HOST',0.9,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118692,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118692,42.96,0.17,2370,52514,70,NULL,'SALT 2','SNLS 05D3lb HOST',0.647,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,214.382375,53.16789,0,NULL,59194593730,924915527,14451805,NULL),(118693,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118693,43.05,NULL,2480,52514,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D3lb HOST',0.647,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118694,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118694,43.06,0.15,2480,52514,NULL,NULL,'SIFTO','SNLS 05D3lb HOST',0.647,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118695,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118695,43.16,0.04,2600,52514,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D3lb HOST',0.647,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118696,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3lb',NULL,118696,43.62,0.17,3210,52514,NULL,NULL,'SALT2','SNLS 05D3lb HOST',0.647,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118697,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118697,37.1,0.46,262,52515,70,NULL,NULL,'2MASX J14173337+1908133',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.389041667,19.13708,0,NULL,59519023168,929984737,14531011,17.2),(118698,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118698,37.24,0.46,281,52516,70,NULL,NULL,'2MASX J14173402+4850375',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.39175,48.84378,0,NULL,59245855881,925716498,14464320,17.1),(118699,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118699,36.97,0.13,247,52517,70,NULL,NULL,'2MASX J14173411+0813258',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.88',0.14,NULL,NULL,NULL,NULL,NULL,1,214.392125,8.22397,0.044,NULL,58497903427,914029741,14281714,17.88),(118700,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118700,37.55,0.46,323,52518,70,NULL,NULL,'2MASXi J1417346+405430',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.394583,40.90861,0,NULL,59945594213,936649909,14635154,17.7),(118701,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118701,38.14,0.33,425,52519,70,NULL,NULL,'2MASX J14173576-0029023',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.8g',0.15,'BrClG',NULL,NULL,NULL,NULL,1,214.3989583,-0.48422,0.085,NULL,43504347734,679755433,10621178,17.8),(118702,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118702,36.97,0.13,247,52520,70,NULL,NULL,'CGCG 046-084 NED02',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000175,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.4005,8.17914,0.044,NULL,58497953935,914030530,14281727,17.4),(118703,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118703,36.55,0.46,204,52521,70,NULL,NULL,'2MASX J14173629+0146058',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000098,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.40125,1.76817,0.065,NULL,58286659135,910729048,14230141,16.2),(118704,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118704,36.97,0.13,247,52522,70,NULL,NULL,'NGC 5539',NULL,'2015arXiv151105856S',2015,1,0.9,'Called NGC 5535/5539 in CGCG and MCG.','G',0.000147,NULL,'14.20',0.72,'cD;BrClG',NULL,NULL,NULL,NULL,1,214.407375,8.17961,0.044,NULL,58497947525,914030430,14281725,14.2),(118705,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118705,36.73,0.46,222,52523,70,NULL,NULL,'2MASX J14173776+2452325',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.4074583,24.87567,0.009,NULL,60000118614,937501853,14648466,17.5),(118706,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118706,37.24,0.46,280,52524,70,NULL,NULL,'2MASX J14173805+0458408',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.408583333,4.978,0.033,NULL,58473533103,913648954,14275764,17.5),(118707,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118707,38.14,0.33,425,52525,70,NULL,NULL,'2MASX J14173817-0028553',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000101,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.409041667,-0.48222,0.085,NULL,43504347710,679755432,10621178,17.9),(118708,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118708,37.07,0.46,260,52526,70,NULL,NULL,'2MASX J14173847+2304143',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.66',0.23,NULL,NULL,NULL,NULL,NULL,1,214.4104583,23.07056,0,NULL,59469257670,929207151,14518861,17.66),(118709,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118709,38.19,0.23,435,52527,70,NULL,NULL,'SDSS J141738.58+052057.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000071,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,214.4107917,5.34939,0.033,NULL,58473595568,913649930,14275780,18.6),(118710,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118710,38.3,0.46,458,52528,70,NULL,NULL,'2MASX J14173904+4157097',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000199,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.412375,41.95269,0,NULL,59227274141,925426158,14459783,17),(118711,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118711,35.22,0.2,111,52529,74.4,NULL,NULL,'CGCG 074-159',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000127,NULL,'15.1',0.3,NULL,NULL,NULL,NULL,NULL,1,214.4152083,12.95917,0,NULL,58354736001,911792750,14246761,15.1),(118712,'SNII optical','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2001bq',NULL,118712,32.55,0.13,31.8,52530,NULL,NULL,'SEAM','NGC 5534',0.008748,'2009ApJ...694.1067P',2009,1,1.4,NULL,'G',0.000021,NULL,'12.8B',0.8,'(R\')SAB(s)abpecHII',NULL,NULL,NULL,'Starburst',1,214.41775,-7.41742,0.121,NULL,43709198507,682956226,10671191,12.8),(118713,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118713,37.09,0.46,262,52531,70,NULL,NULL,'2MASX J14174029+1829403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.418041667,18.49458,0,NULL,59518858533,929982164,14530971,16.9),(118714,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118714,34.72,0.49,87.8,52532,75,NULL,'IR','FGC 1738',NULL,'2011yCatp016004901K',2011,1,1.38,NULL,'G',0.00015,NULL,'15.00',0.26,'Sc             HII',NULL,NULL,NULL,NULL,1,214.421333,-5.46317,0.105,NULL,43730828888,683294201,10676471,15),(118715,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118715,35.77,0.46,142,52533,70,NULL,NULL,'2MASX J14174126+4527568',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000177,NULL,'15.8g',0.45,'S0',NULL,NULL,NULL,NULL,1,214.422125,45.46583,0,NULL,59229131048,925455172,14460237,15.8),(118716,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118716,36.97,0.13,247,52534,70,NULL,NULL,'2MASX J14174159+0813068',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.423417,8.21844,0.043,NULL,58497904020,914029750,14281714,17.9),(118717,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3hq',NULL,118717,41.14,0.17,1260,52535,NULL,NULL,'SALT2','[NSB2006] J141743.05+521122.6',0.34,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'20.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.42925,52.18953,0,NULL,59195809724,924934526,14452101,20.4),(118718,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3hq',NULL,118718,41.32,0.15,1370,52535,NULL,NULL,'SIFTO','[NSB2006] J141743.05+521122.6',0.34,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118719,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118719,38.04,0.46,406,52536,70,NULL,NULL,'2MASX J14174332+0611538',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.430541667,6.19822,0.025,NULL,58502345790,914099152,14282799,17.5),(118720,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118720,36.83,0.12,232,52537,70,NULL,NULL,'SDSS J141744.37+020336.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.434917,2.06028,0.057,NULL,58287092513,910735820,14230247,17.9),(118721,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gn',NULL,118721,40.05,0.17,818,52538,NULL,NULL,'SALT2','SNLS 06D3gn',0.25,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.4359583,52.36119,0,NULL,59195830527,924934851,14452107,NULL),(118722,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gn',NULL,118722,40.49,0.15,1000,52538,NULL,NULL,'SIFTO','SNLS 06D3gn',0.25,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118723,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gn',NULL,118723,41.68,0.03,1730,52538,70,NULL,'SALT2','SNLS 06D3gn',0.25,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118724,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118724,38.27,0.33,451,52539,70,NULL,NULL,'2MASX J14174547+2444065',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,214.4395,24.73525,0,NULL,59467247550,929175742,14518370,18.4),(118725,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do','R',118725,42.02,NULL,1580,52540,65,NULL,'MLCS17','[AGR2006] J141746.11+521603.3',0.61,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,'22.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.44175,52.26747,0,NULL,59195838210,924934972,14452108,22.6),(118726,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118726,42.18,0.16,1700,52540,74.2,NULL,'SALT 2','[AGR2006] J141746.11+521603.3',0.61,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118727,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118727,42.24,0.17,1740,52540,NULL,NULL,'SALT2','[AGR2006] J141746.11+521603.3',0.61,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118728,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118728,42.61,0.04,2070,52540,70,NULL,'MLCS17','[AGR2006] J141746.11+521603.3',0.61,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118729,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118729,42.72,0.23,2180,52540,65,NULL,'MLCS17','[AGR2006] J141746.11+521603.3',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118730,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118730,42.8,0.04,2250,52540,70,NULL,NULL,'[AGR2006] J141746.11+521603.3',0.61,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118731,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118731,42.82,0.27,2270,52540,65,NULL,'MLCS2k2','[AGR2006] J141746.11+521603.3',0.61,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118732,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118732,42.82,0.28,2270,52540,65,NULL,'MLCS31','[AGR2006] J141746.11+521603.3',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118733,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118733,42.87,0.12,2320,52540,65,NULL,'MLCS2k2','[AGR2006] J141746.11+521603.3',0.61,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118734,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118734,42.88,0.15,2340,52540,70,NULL,'SALT','[AGR2006] J141746.11+521603.3',0.61,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118735,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118735,42.91,0.12,2370,52540,65,NULL,'SALT2','[AGR2006] J141746.11+521603.3',0.61,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118736,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118736,42.91,0.14,2370,52540,70,NULL,'SALT 2','[AGR2006] J141746.11+521603.3',0.61,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118737,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118737,42.99,0.15,2460,52540,NULL,NULL,'SIFTO','[AGR2006] J141746.11+521603.3',0.61,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118738,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118738,43.03,0.18,2510,52540,65,NULL,'SALT2','[AGR2006] J141746.11+521603.3',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118739,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118739,43.06,0.03,2540,52540,65,NULL,'SALT','[AGR2006] J141746.11+521603.3',0.61,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118740,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3do',NULL,118740,43.07,0.12,2550,52540,65,NULL,'SALT','[AGR2006] J141746.11+521603.3',0.61,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118741,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118741,36.97,0.13,247,52541,70,NULL,NULL,'2MASX J14174617+0810418',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.442375,8.17819,0.044,NULL,58497949351,914030458,14281725,17.6),(118742,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118742,37.23,0.46,279,52542,70,NULL,NULL,'2MASX J14174629+4952231',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000197,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.443041667,49.87294,0.005,NULL,59253834776,925841168,14466268,16.2),(118743,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118743,43.31,0.38,2280,52543,74.2,NULL,'SALT 2','GSS 074_5532',1.01,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.02,NULL,'26.2V',NULL,NULL,NULL,NULL,NULL,NULL,1,214.4517083,52.47047,0,NULL,59197908814,924967325,14452614,26.2),(118744,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd','R',118744,43.56,NULL,2570,52543,65,NULL,'MLCS17','GSS 074_5532',1.01,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118745,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118745,44.24,0.15,3500,52543,70,NULL,'SALT 2','GSS 074_5532',1.01,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118746,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118746,44.33,0.33,3650,52543,65,NULL,'SALT2','GSS 074_5532',1.01,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118747,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118747,44.67,0.53,4280,52543,70,NULL,NULL,'GSS 074_5532',1.01,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118748,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118748,44.68,0.19,4290,52543,65,NULL,'MLCS17','GSS 074_5532',1.01,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118749,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118749,44.69,0.2,4310,52543,65,NULL,'MLCS2k2','GSS 074_5532',1.01,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118750,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118750,44.69,0.91,4310,52543,70,NULL,'SALT','GSS 074_5532',1.01,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118751,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118751,44.7,0.16,4320,52543,65,NULL,'MLCS31','GSS 074_5532',1.01,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118752,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118752,44.7,0.14,4330,52543,65,NULL,'MLCS2k2','GSS 074_5532',1.01,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118753,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118753,44.88,0.86,4700,52543,65,NULL,'SALT','GSS 074_5532',1.01,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118754,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118754,44.92,0.15,4790,52543,NULL,NULL,'SIFTO','GSS 074_5532',1.01,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118755,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118755,44.92,0.58,4800,52543,65,NULL,'SALT2','GSS 074_5532',1.01,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118756,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118756,44.94,0.33,4840,52543,65,NULL,'SALT','GSS 074_5532',1.01,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118757,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3dd',NULL,118757,45.22,0.17,5510,52543,NULL,NULL,'SALT2','GSS 074_5532',1.01,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118758,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118758,33.22,0.69,44.1,52544,100,NULL,'mid-IR','IC 0991',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000017,NULL,'13.84',0.9,'SB(s)c:        HII',NULL,NULL,NULL,NULL,1,214.452416667,-13.87294,0.213,NULL,43640022407,681875350,10654302,13.84),(118759,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118759,33.63,0.57,53.1,52544,NULL,NULL,'Malmquist cor.','IC 0991',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118760,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118760,33.89,0.47,59.9,52544,NULL,NULL,'H','IC 0991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118761,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118761,33.92,0.2,60.8,52544,74.4,NULL,NULL,'IC 0991',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118762,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118762,34,0.46,63,52544,NULL,NULL,'J','IC 0991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118763,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118763,34,0.45,63,52544,NULL,NULL,'K','IC 0991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118764,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118764,34.02,0.47,63.7,52544,NULL,NULL,NULL,'IC 0991',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118765,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118765,34.07,0.4,65.1,52544,NULL,NULL,'mean','IC 0991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118766,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118766,36.98,0.46,249,52545,70,NULL,NULL,'2MASX J14174881+4802231',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.4535417,48.03969,0.039,NULL,59247343467,925739741,14464683,17.8),(118767,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118767,32.71,0.8,34.9,52546,75,NULL,'MAT, I','IC 4393',NULL,'1997ApJS..109..333W',1997,1,2.49,'Confused HIPASS source','G',0.00002,NULL,'14.55',0.28,'Scd            HII',NULL,NULL,NULL,NULL,1,214.4539583,-31.34908,0.269,NULL,47041035841,735016185,11484627,14.55),(118768,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118768,32.48,0.4,31.4,52546,75,NULL,NULL,'IC 4393',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118769,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118769,32.99,0.43,39.5,52546,75,NULL,'3.6 micron, color + selection bias corrected','IC 4393',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118770,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118770,33.02,0.4,40.3,52546,NULL,NULL,'mean','IC 4393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118771,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118771,33.1,0.43,41.7,52546,75,NULL,'MAT, I, raw','IC 4393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118772,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118772,33.15,0.32,42.6,52546,85,NULL,'I, raw','IC 4393',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118773,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118773,33.18,0.32,43.2,52546,85,NULL,'I, inv','IC 4393',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118774,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118774,33.18,0.49,43.3,52546,75,NULL,'IR','IC 4393',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118775,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118775,33.19,0.43,43.5,52546,75,NULL,'3.6 micron, color corrected','IC 4393',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118776,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118776,33.23,0.44,44.3,52546,NULL,NULL,NULL,'IC 4393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118777,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118777,33.24,0.2,44.5,52546,74.4,NULL,NULL,'IC 4393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118778,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118778,33.25,0.43,44.7,52546,75,NULL,'MAT, I, inv','IC 4393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118779,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118779,33.3,0.47,45.7,52546,NULL,NULL,'H','IC 4393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118780,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118780,33.35,0.45,46.8,52546,NULL,NULL,'K','IC 4393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118781,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118781,33.4,0.46,47.9,52546,NULL,NULL,'J','IC 4393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118782,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118782,33.41,0.43,48.1,52546,75,NULL,'MAT, I, cor','IC 4393',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118783,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118783,33.45,0.39,49,52546,NULL,NULL,'Malmquist cor.','IC 4393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118784,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118784,33.73,NULL,55.7,52546,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4393',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118785,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118785,33.75,NULL,56.2,52546,NULL,NULL,'Dipole + Quadrupole','IC 4393',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118786,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118786,33.76,NULL,56.5,52546,NULL,NULL,'Dipole','IC 4393',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118787,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118787,33.81,NULL,57.9,52546,NULL,NULL,NULL,'IC 4393',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118788,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118788,37.85,0.46,372,52547,70,NULL,NULL,'2MASX J14174896+4149130',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.4540417,41.82033,0,NULL,59227305342,925426645,14459791,17.9),(118789,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118789,38.26,0.19,450,52548,70,NULL,NULL,'2MASX J14174934+4323008',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.455667,43.3835,0,NULL,59225019679,925390932,14459233,17.7),(118790,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118790,35.64,0.49,134,52549,NULL,NULL,'Malmquist cor.','ESO 511- G 019',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.92',0.4,'S...',NULL,NULL,NULL,NULL,1,214.457125,-26.37947,0.277,NULL,46985139259,734142800,11470981,15.92),(118791,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118791,35.69,0.48,138,52549,NULL,NULL,NULL,'ESO 511- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118792,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118792,35.73,0.2,140,52549,74.4,NULL,NULL,'ESO 511- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118793,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118793,36.79,0.16,228,52550,70,NULL,NULL,'CGCG 018-112',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000124,NULL,'15.6g',0.44,'BrClG          AGN',NULL,NULL,NULL,NULL,1,214.45775,0.51094,0.085,NULL,58284877217,910701206,14229706,15.6),(118794,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118794,36.97,0.13,247,52551,70,NULL,NULL,'2MASX J14174996+0816044',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000191,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.4582917,8.26806,0.043,NULL,58497785807,914027903,14281685,16.3),(118795,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118795,42.26,0.17,1750,52552,NULL,NULL,'SALT2','[AGR2006] J141750.03+525748.9',0.62,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.4584583,52.96358,0,NULL,59198044975,924969452,14452647,NULL),(118796,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co','R',118796,42.29,NULL,1780,52552,65,NULL,'MLCS31','[AGR2006] J141750.03+525748.9',0.62,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118797,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118797,42.31,0.17,1790,52552,74.2,NULL,'SALT 2','[AGR2006] J141750.03+525748.9',0.62,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118798,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118798,42.71,0.15,2150,52552,NULL,NULL,'SIFTO','[AGR2006] J141750.03+525748.9',0.62,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118799,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118799,42.86,0.17,2310,52552,70,NULL,'SALT 2','[AGR2006] J141750.03+525748.9',0.62,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118800,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118800,43.03,0.06,2490,52552,70,NULL,NULL,'[AGR2006] J141750.03+525748.9',0.62,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118801,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118801,43.1,0.15,2570,52552,70,NULL,'SALT','[AGR2006] J141750.03+525748.9',0.62,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118802,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118802,43.12,0.05,2590,52552,70,NULL,'SALT2','[AGR2006] J141750.03+525748.9',0.62,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118803,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118803,43.16,0.15,2640,52552,65,NULL,'SALT2','[AGR2006] J141750.03+525748.9',0.62,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118804,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118804,43.2,0.24,2700,52552,65,NULL,'MLCS2k2','[AGR2006] J141750.03+525748.9',0.62,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118805,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118805,43.21,0.25,2700,52552,65,NULL,'MLCS31','[AGR2006] J141750.03+525748.9',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118806,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118806,43.24,0.17,2740,52552,65,NULL,'MLCS2k2','[AGR2006] J141750.03+525748.9',0.62,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118807,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118807,43.23,0.24,2740,52552,65,NULL,'MLCS17','[AGR2006] J141750.03+525748.9',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118808,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118808,43.26,0.12,2780,52552,65,NULL,'SALT','[AGR2006] J141750.03+525748.9',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118809,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118809,43.3,0.05,2820,52552,65,NULL,'SALT','[AGR2006] J141750.03+525748.9',0.62,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118810,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3co',NULL,118810,43.3,0.19,2830,52552,65,NULL,'SALT2','[AGR2006] J141750.03+525748.9',0.62,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118811,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118811,36.29,0.33,181,52553,70,NULL,NULL,'2MASX J14175003+0812504',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.17',0.21,NULL,NULL,NULL,NULL,NULL,1,214.458583333,8.21394,0.043,NULL,58497900638,914029697,14281714,17.17),(118812,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118812,36.79,0.16,228,52554,70,NULL,NULL,'SDSS J141750.34+001940.5',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000072,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.4597917,0.32792,0.073,NULL,58284997753,910703089,14229735,17.4),(118813,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','PS1 SN PS10iw','N',118813,41.96,0.19,1710,52555,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10iw HOST',0.4474,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118814,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118814,32.24,NULL,28,52556,72,NULL,NULL,'AGC 243881',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000127,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.460833,6.83528,0.029,NULL,58493897371,913967146,14280736,NULL),(118815,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118815,37.53,0.46,321,52557,70,NULL,NULL,'2MASXi J1417509+370434',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.4624583,37.07619,0,NULL,60032995677,938015557,14656493,17.5),(118816,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118816,38.26,0.19,450,52558,70,NULL,NULL,'SDSS J141751.46+431449.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.464417,43.24711,0,NULL,59225067841,925391685,14459245,18.3),(118817,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118817,38.26,0.19,450,52559,70,NULL,NULL,'2MASX J14175154+4325058',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.464666667,43.41825,0,NULL,59225021206,925390956,14459233,16.9),(118818,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118818,37.63,0.46,335,52560,70,NULL,NULL,'2MASX J14175250+2842364',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.4687083,28.71003,0,NULL,60058661771,938416590,14662759,17.8),(118819,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118819,36.97,0.13,247,52561,70,NULL,NULL,'2MASX J14175266+0759324',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,214.469583,7.99247,0.017,NULL,58497717012,914026828,14281669,16.1),(118820,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118820,38.26,0.19,450,52562,70,NULL,NULL,'2MASX J14175420+4323168',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00006,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,214.475833,43.38806,0,NULL,59225028878,925391076,14459235,16.8),(118821,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118821,36.12,0.56,168,52563,70,NULL,NULL,'2MASX J14175456-2126503',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000083,NULL,'16.24',0.3,NULL,NULL,NULL,NULL,NULL,1,214.477333333,-21.44739,0.361,NULL,46569449674,727647651,11369494,16.24),(118822,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118822,37.18,0.23,273,52564,70,NULL,NULL,'2MASX J14175467+3016062',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.77',0.24,NULL,NULL,NULL,NULL,NULL,1,214.477667,30.26847,0,NULL,60061870102,938466720,14663542,16.77),(118823,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3ht',NULL,118823,43.16,0.07,2260,52565,70,NULL,'SIFTO','SNLS 05D3ht',0.901,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.477917,53.16758,0,NULL,59198018532,924969039,14452641,NULL),(118824,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3ht',NULL,118824,44.04,0.22,3380,52565,70,NULL,'SALT 2','SNLS 05D3ht',0.901,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118825,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3ht',NULL,118825,44.1,0.15,3470,52565,NULL,NULL,'SIFTO','SNLS 05D3ht',0.901,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118826,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3ht',NULL,118826,45.23,0.17,5850,52565,NULL,NULL,'SALT2','SNLS 05D3ht',0.901,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118827,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118827,37.39,0.15,300,52566,70,NULL,NULL,'2MASX J14175502+2631494',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000193,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.4792083,26.53053,0,NULL,59999790014,937496718,14648386,16.2),(118828,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118828,37.39,0.15,300,52567,70,NULL,NULL,'2MASX J14175564+2619384',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,214.481833,26.32758,0,NULL,59999825133,937497267,14648394,17.7),(118829,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118829,36.12,0.53,168,52568,70,NULL,NULL,'2MASX J14175574-3452096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.482333,-34.86933,0.173,NULL,47009756710,734527448,11476991,13.3),(118830,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118830,36.97,0.13,247,52569,70,NULL,NULL,'2MASX J14175576+0758374',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.0002,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.482375,7.97708,0.017,NULL,58497719998,914026874,14281669,16.5),(118831,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118831,36.83,0.12,232,52570,70,NULL,NULL,'2MASX J14175577+0152096',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000069,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.4825,1.86944,0.057,NULL,58286490050,910726407,14230100,17),(118832,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118832,36.83,0.12,232,52571,70,NULL,NULL,'SDSS J141756.20+021827.8',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000118,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,214.484167,2.30772,0.049,NULL,58286230511,910722351,14230036,16),(118833,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118833,37.27,0.46,285,52572,70,NULL,NULL,'2MASX J14175654+1730004',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,214.4857083,17.50028,0,NULL,59486379368,929474677,14523041,18.52),(118834,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118834,37.15,0.46,269,52573,70,NULL,NULL,'2MASX J14175717+0137507',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.488291667,1.63072,0.065,NULL,58286517077,910726829,14230106,17.4),(118835,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118835,38.03,0.46,403,52574,70,NULL,NULL,'2MASX J14175746+4137230',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.489417,41.62319,0,NULL,59223892856,925373325,14458958,17.2),(118836,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay','R',118836,40.71,NULL,1010,52575,65,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2010arXiv1006.2112L',2010,1,0.09,NULL,'G',0.000011,NULL,'20.5g',0.07,NULL,NULL,NULL,NULL,NULL,1,214.493333,52.48275,0,NULL,59197912107,924967376,14452615,20.5),(118837,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118837,40.94,0.16,1120,52575,74.2,NULL,'SALT 2','[AGR2006] J141758.44+522857.6',0.371,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118838,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118838,41.37,0.05,1370,52575,70,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118839,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118839,41.49,0.03,1450,52575,70,NULL,NULL,'[AGR2006] J141758.44+522857.6',0.371,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118840,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118840,41.5,0.13,1460,52575,70,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118841,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118841,41.59,0.14,1520,52575,70,NULL,'SALT 2','[AGR2006] J141758.44+522857.6',0.371,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118842,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118842,41.63,0.15,1550,52575,NULL,NULL,'SIFTO','[AGR2006] J141758.44+522857.6',0.371,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118843,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118843,41.66,0.14,1570,52575,65,NULL,'SALT2','[AGR2006] J141758.44+522857.6',0.371,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118844,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118844,41.68,0.1,1580,52575,65,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118845,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118845,41.75,0.03,1640,52575,65,NULL,'SALT','[AGR2006] J141758.44+522857.6',0.371,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118846,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118846,41.8,0.21,1670,52575,65,NULL,'MLCS2k2','[AGR2006] J141758.44+522857.6',0.371,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118847,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118847,41.8,0.22,1670,52575,65,NULL,'MLCS31','[AGR2006] J141758.44+522857.6',0.371,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118848,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118848,41.81,0.19,1680,52575,65,NULL,'SALT2','[AGR2006] J141758.44+522857.6',0.371,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118849,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118849,41.84,0.19,1710,52575,65,NULL,'MLCS17','[AGR2006] J141758.44+522857.6',0.371,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118850,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118850,41.89,0.19,1740,52575,65,NULL,'MLCS2k2','[AGR2006] J141758.44+522857.6',0.371,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118851,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 03D3ay',NULL,118851,42.33,0.17,2140,52575,NULL,NULL,'SALT2','[AGR2006] J141758.44+522857.6',0.371,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118852,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118852,37.7,0.46,347,52576,70,NULL,NULL,'SDSS J141758.43+035516.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000083,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.4934583,3.92114,0.041,NULL,58475297440,913676522,14276195,18.6),(118853,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118853,37.65,0.17,339,52577,70,NULL,NULL,'2MASX J14175939+5624560',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.497208333,56.41556,0,NULL,57254405543,894600086,13978126,17.5),(118854,'AGN time lag','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118854,34.83,0.03,92.5,52578,NULL,NULL,NULL,'NGC 5548',NULL,'2014ApJ...784L..11Y',2014,1,1.4,NULL,'G',0.000023,NULL,'13.3',1.3,'(R\')SA(s)0/a   Sy1.5','Group member, radial-velocity confirmed',NULL,'radio jet','Sy 1.5',1,214.4980417,25.13678,0,NULL,60000427142,937506674,14648541,13.3),(118855,'AGN time lag','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118855,37.66,0.36,341,52578,44,NULL,NULL,'NGC 5548',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118856,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118856,36.79,0.16,228,52579,70,NULL,NULL,'2MASX J14175958+0016027',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000098,NULL,'15.9g',0.41,'E0',NULL,NULL,NULL,NULL,1,214.498333,0.26742,0.073,NULL,58284992381,910703005,14229734,15.9),(118857,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118857,36.67,0.46,216,52580,70,NULL,NULL,'SDSS J141759.65+014225.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.4985417,1.70717,0.065,NULL,58286524918,910726951,14230108,17.9),(118858,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118858,38.29,0.46,456,52581,70,NULL,NULL,'2MASX J14175997+1841392',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.499916667,18.69439,0,NULL,59518835042,929981797,14530965,17.5),(118859,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118859,36.92,0.61,243,52582,70,NULL,NULL,'2MASX J14180176-3449486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.507375,-34.83008,0.173,NULL,47009756275,734527441,11476991,15.7),(118860,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118860,35.24,0.68,112,52583,70,NULL,NULL,'2MASX J14180256-1923253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.510791667,-19.39031,0.321,NULL,46563781146,727559080,11368110,14.4),(118861,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118861,38.2,0.33,437,52584,70,NULL,NULL,'2MASX J14180273+1435224',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'19.00',0.09,NULL,NULL,NULL,NULL,NULL,1,214.511333333,14.58953,0,NULL,59477408088,929334501,14520851,19),(118862,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118862,39.18,0.46,687,52585,70,NULL,NULL,'2MASX J14180309+3717290',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.5129583,37.29139,0,NULL,60032970075,938015157,14656486,17.9),(118863,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118863,36.79,0.16,228,52586,70,NULL,NULL,'2MASX J14180405+0016257',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000074,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.517,0.27383,0.073,NULL,58284480721,910695011,14229609,17),(118864,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118864,36.61,0.5,210,52587,70,NULL,NULL,'2MASX J14180446-3823280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.5185,-38.39114,0.257,NULL,46993448766,734272636,11473009,14),(118865,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118865,38.27,0.33,451,52588,70,NULL,NULL,'2MASX J14180445+2442414',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.518625,24.71164,0,NULL,59467767739,929183870,14518497,17.4),(118866,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118866,38.19,0.23,435,52589,70,NULL,NULL,'SDSS J141805.25+052111.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.521875,5.35328,0.037,NULL,58473677945,913651217,14275800,18.5),(118867,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118867,37.39,0.15,300,52590,70,NULL,NULL,'2MASX J14180561+2630294',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.89',0.17,NULL,NULL,NULL,NULL,NULL,1,214.523333,26.50825,0,NULL,60054593582,938353024,14661766,17.89),(118868,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118868,37.18,0.23,273,52591,70,NULL,NULL,'2MASX J14180841+3016323',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.535125,30.27561,0,NULL,60061871412,938466740,14663542,NULL),(118869,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118869,37.22,0.46,278,52592,70,NULL,NULL,'2MASX J14180889+4458523',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.537125,44.98119,0,NULL,59238576532,925602758,14462543,17.3),(118870,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118870,35.09,0.23,104,52593,70,NULL,NULL,'NGC 5546',NULL,'2015arXiv151105856S',2015,1,1.47,NULL,'G',0.000103,NULL,'13.4g',1.17,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,214.538458333,7.56456,0.049,NULL,58494551807,913977371,14280896,13.4),(118871,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118871,35.04,0.45,102,52593,NULL,NULL,'K','NGC 5546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118872,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118872,35.14,0.4,106,52593,NULL,NULL,'mean','NGC 5546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118873,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118873,38.11,0.46,418,52594,70,NULL,NULL,'2MASX J14180940+5731071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.53925,57.51858,0,NULL,57305497884,895398404,13990600,17.4),(118874,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118874,37.65,0.17,339,52595,70,NULL,NULL,'2MASX J14180951+5627571',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.53975,56.46578,0,NULL,57254406370,894600099,13978126,18.1),(118875,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118875,36.83,0.12,232,52596,70,NULL,NULL,'2MASX J14180984+0206407',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000118,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.541,2.11111,0.049,NULL,58287133649,910736463,14230257,16.2),(118876,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118876,40.09,0.17,711,52597,NULL,NULL,'SALT2','[AGR2006] J141810.04+521639.8',0.47,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.541833,52.27772,0,NULL,59196002883,924937545,14452149,NULL),(118877,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118877,41.41,0.15,1300,52597,74.2,NULL,'SALT 2','[AGR2006] J141810.04+521639.8',0.47,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118878,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118878,41.95,0.18,1670,52597,65,NULL,'MLCS17','[AGR2006] J141810.04+521639.8',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118879,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118879,41.99,0.13,1700,52597,70,NULL,'SALT 2','[AGR2006] J141810.04+521639.8',0.47,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118880,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118880,41.99,0.12,1700,52597,65,NULL,'MLCS2k2','[AGR2006] J141810.04+521639.8',0.47,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118881,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118881,42,0.2,1710,52597,65,NULL,'MLCS31','[AGR2006] J141810.04+521639.8',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118882,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118882,42.03,0.18,1730,52597,65,NULL,'MLCS2k2','[AGR2006] J141810.04+521639.8',0.47,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118883,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118883,42.06,0.14,1750,52597,65,NULL,'SALT2','[AGR2006] J141810.04+521639.8',0.47,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118884,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118884,42.14,0.15,1820,52597,NULL,NULL,'SIFTO','[AGR2006] J141810.04+521639.8',0.47,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118885,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df','R',118885,42.16,NULL,1840,52597,65,NULL,'MLCS17','[AGR2006] J141810.04+521639.8',0.47,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118886,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118886,42.27,0.03,1930,52597,70,NULL,NULL,'[AGR2006] J141810.04+521639.8',0.47,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118887,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118887,42.3,0.15,1960,52597,70,NULL,'SALT','[AGR2006] J141810.04+521639.8',0.47,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118888,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118888,42.37,0.19,2020,52597,65,NULL,'SALT2','[AGR2006] J141810.04+521639.8',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118889,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118889,42.44,0.12,2100,52597,65,NULL,'SALT','[AGR2006] J141810.04+521639.8',0.47,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118890,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118890,42.54,0.03,2190,52597,65,NULL,'SALT','[AGR2006] J141810.04+521639.8',0.47,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118891,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3df',NULL,118891,43.37,0.03,3210,52597,70,NULL,'SALT2','[AGR2006] J141810.04+521639.8',0.47,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118892,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118892,37.54,0.46,322,52598,70,NULL,NULL,'2MASX J14181016+1426394',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.542208333,14.44411,0,NULL,59477721728,929339402,14520928,17.2),(118893,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118893,37.12,0.46,266,52599,70,NULL,NULL,'2MASX J14181063+0244497',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.544291667,2.74706,0.073,NULL,58286193642,910721775,14230027,16.4),(118894,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118894,37.76,0.46,357,52600,70,NULL,NULL,'SDSS J141811.59+212937.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.548333,21.49386,0.035,NULL,59521552740,930024261,14531629,18.2),(118895,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118895,37.97,0.33,394,52601,70,NULL,NULL,'2MASX J14181179+4400063',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.549125,44.00186,0,NULL,59239273521,925613648,14462713,17.8),(118896,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118896,37.04,0.46,256,52602,70,NULL,NULL,'2MASX J14181197+0456467',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.549916667,4.94644,0.033,NULL,58473357521,913646211,14275722,16.7),(118897,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118897,36.79,0.16,228,52603,70,NULL,NULL,'2MASX J14181212+0021317',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000079,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.550541667,0.35892,0.085,NULL,58284508088,910695438,14229616,16.8),(118898,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy','R',118898,42.28,NULL,1740,52604,65,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.551875,52.65844,0,NULL,59198123736,924970683,14452666,NULL),(118899,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118899,42.29,0.17,1750,52604,74.2,NULL,'SALT 2','[AGR2006] J141812.45+523930.4',0.643,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118900,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118900,42.92,0.21,2330,52604,70,NULL,'SALT 2','[AGR2006] J141812.45+523930.4',0.643,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118901,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118901,42.98,0.17,2400,52604,NULL,NULL,'SALT2','[AGR2006] J141812.45+523930.4',0.643,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118902,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118902,43.01,0.06,2430,52604,70,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118903,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118903,43.01,0.16,2430,52604,70,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118904,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118904,43.02,0.06,2450,52604,70,NULL,NULL,'[AGR2006] J141812.45+523930.4',0.643,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118905,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118905,43.04,0.15,2470,52604,NULL,NULL,'SIFTO','[AGR2006] J141812.45+523930.4',0.643,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118906,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118906,43.15,0.13,2600,52604,65,NULL,'SALT2','[AGR2006] J141812.45+523930.4',0.643,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118907,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118907,43.16,0.13,2610,52604,65,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118908,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118908,43.16,0.2,2610,52604,65,NULL,'MLCS2k2','[AGR2006] J141812.45+523930.4',0.643,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118909,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118909,43.22,0.19,2680,52604,65,NULL,'SALT2','[AGR2006] J141812.45+523930.4',0.643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118910,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118910,43.29,0.05,2770,52604,65,NULL,'SALT','[AGR2006] J141812.45+523930.4',0.643,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118911,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118911,43.33,0.21,2820,52604,65,NULL,'MLCS31','[AGR2006] J141812.45+523930.4',0.643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118912,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118912,43.34,0.19,2830,52604,65,NULL,'MLCS2k2','[AGR2006] J141812.45+523930.4',0.643,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118913,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3cy',NULL,118913,43.42,0.19,2940,52604,65,NULL,'MLCS17','[AGR2006] J141812.45+523930.4',0.643,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118914,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118914,36.83,0.12,232,52605,70,NULL,NULL,'2MASX J14181317+0206507',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'FoF','17.90',0.28,NULL,NULL,NULL,NULL,NULL,1,214.554917,2.11411,0.049,NULL,58287136472,910736507,14230257,17.9),(118915,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118915,37.67,0.46,342,52606,70,NULL,NULL,'SDSS J141813.36+220329.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.555666667,22.05828,0.028,NULL,59514980584,929921571,14530024,18.3),(118916,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118916,38.19,0.23,435,52607,70,NULL,NULL,'2MASX J14181371+0527187',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.55725,5.45517,0.037,NULL,58473694331,913651473,14275804,17.9),(118917,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118917,34.72,0.25,87.9,52608,74.4,NULL,NULL,'ESO 511- G 021',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000087,NULL,'14.35',0.6,'E?',NULL,NULL,NULL,NULL,1,214.560167,-27.41517,0.273,NULL,47032463756,734882246,11482535,14.35),(118918,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118918,35.21,0.47,110,52608,70,NULL,NULL,'ESO 511- G 021',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118919,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118919,34.07,0.2,65.2,52609,74.4,NULL,NULL,'IC 0992',NULL,'2013AJ....146...86T',2013,1,1.03,'CGCG misprints name as \'IC 0942\'; corrected in vol III (errata).','G',0.000066,NULL,'14.6g',0.73,'SAB(r)c:',NULL,NULL,NULL,NULL,1,214.562125,0.89108,0.065,NULL,58287537756,910742777,14230355,14.6),(118920,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118920,38.19,0.23,435,52610,70,NULL,NULL,'2MASX J14181578+0526267',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000096,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.565917,5.44072,0.037,NULL,58473707762,913651683,14275807,17.6),(118921,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118921,34.07,0.4,65.1,52611,NULL,NULL,'mean','IC 4403',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.82',0.5,'Sa','Isolated galaxy',NULL,NULL,NULL,1,214.5702917,31.65383,0,NULL,60060465228,938444769,14663199,14.82),(118922,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118922,34.27,0.47,71.5,52611,NULL,NULL,'H','IC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118923,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118923,34.3,0.45,72.4,52611,NULL,NULL,'K','IC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118924,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118924,34.35,0.46,74.1,52611,NULL,NULL,'J','IC 4403',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118925,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118925,37.7,0.46,347,52612,70,NULL,NULL,'SDSS J141817.40+045736.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000103,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,214.5725,4.96028,0.033,NULL,58473553991,913649281,14275770,18.2),(118926,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118926,37.91,0.46,382,52613,70,NULL,NULL,'2MASX J14181745+5347201',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.572833,53.78897,0,NULL,59194917655,924920588,14451884,16.7),(118927,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118927,36.64,0.46,213,52614,70,NULL,NULL,'2MASX J14182025+0314467',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000104,NULL,'17.1g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,214.584333333,3.24622,0.073,NULL,58293731455,910839553,14231868,17.1),(118928,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118928,38.18,0.27,432,52615,70,NULL,NULL,'2MASX J14182089+5937150',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.58725,59.62081,0.033,NULL,57269408834,894834513,13981789,17.4),(118929,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118929,38,0.46,398,52616,70,NULL,NULL,'2MASX J14182097+4109362',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.587541667,41.16003,0,NULL,59945750254,936652347,14635192,17.2),(118930,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118930,35.09,0.23,104,52617,70,NULL,NULL,'2MASX J14182164+0741144',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000148,NULL,'15.7g',0.39,NULL,NULL,NULL,NULL,NULL,1,214.5902083,7.68739,0.053,NULL,58497567248,914024488,14281632,15.7),(118931,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118931,37.28,0.46,286,52618,70,NULL,NULL,'2MASX J14182195+0548027',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.591583,5.80075,0.037,NULL,58473004779,913640699,14275635,16.5),(118932,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118932,36.76,0.46,225,52619,70,NULL,NULL,'2MASX J14182196+5527150',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.591667,55.45422,0,NULL,57254683090,894604423,13978194,17.3),(118933,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118933,36.21,0.33,175,52620,70,NULL,NULL,'2MASX J14182208+0527297',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.591875,5.45822,0.037,NULL,58473709467,913651710,14275807,16.2),(118934,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118934,36.83,0.46,233,52621,70,NULL,NULL,'2MASXi J1418222+204402',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.15,NULL,NULL,NULL,NULL,NULL,1,214.592833333,20.73392,0.016,NULL,59521804707,930028198,14531690,18.67),(118935,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118935,38.18,0.27,432,52622,70,NULL,NULL,'SDSS J141822.46+593648.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.593583333,59.61361,0.033,NULL,57269416132,894834627,13981791,18.6),(118936,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118936,36.17,0.46,171,52623,70,NULL,NULL,'CGCG 046-091',NULL,'2015arXiv151105856S',2015,1,0.58,'Stellar object superposed 10\\\" northeast.','G',0.00016,NULL,'15.4g',0.52,NULL,NULL,NULL,NULL,NULL,1,214.593625,8.0975,0.021,NULL,58497797147,914028080,14281688,15.4),(118937,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118937,38.2,0.33,437,52624,70,NULL,NULL,'2MASX J14182349+1438348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.14',0.18,NULL,NULL,NULL,NULL,NULL,1,214.597833,14.64292,0,NULL,59477398092,929334345,14520849,18.14),(118938,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118938,37.85,0.33,372,52625,70,NULL,NULL,'SDSS J141823.88+493654.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000173,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,214.5995417,49.61519,0.045,NULL,59253584613,925837259,14466207,18.6),(118939,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118939,35.88,0.2,150,52626,74.4,NULL,NULL,'IC 4399',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.000033,NULL,'15.3g',0.55,'Sb','Group member',NULL,NULL,NULL,1,214.599833333,26.38589,0,NULL,59999814706,937497104,14648392,15.3),(118940,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118940,33.9,0.8,60.4,52627,75,NULL,'HMCL, I','KUG 1416+257',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000023,NULL,'15.7',0.2,'Spiral',NULL,NULL,NULL,NULL,1,214.605833,25.50111,0,NULL,60000507622,937507931,14648561,15.7),(118941,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118941,33.88,0.4,59.6,52627,75,NULL,'HMCL, I, raw','KUG 1416+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118942,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118942,33.89,0.4,60.1,52627,75,NULL,'HMCL, I, inv','KUG 1416+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118943,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118943,34.1,0.4,66,52627,75,NULL,'HMCL, I, cor','KUG 1416+257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118944,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118944,34.46,0.49,78,52627,75,NULL,'IR','KUG 1416+257',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118945,'SBF','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118945,32.58,0.3,32.8,52628,NULL,NULL,NULL,'NGC 5557',NULL,'2001MNRAS.327.1004B',2001,1,1.93,NULL,'G',0.000017,NULL,'12.2g',1.58,'E1','in a radial-velocity based grouping',NULL,NULL,NULL,1,214.607166667,36.49356,0,NULL,60031715188,937995549,14656180,12.2),(118946,'SBF','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118946,32.78,0.3,36.1,52628,NULL,NULL,'Malmquist cor.','NGC 5557',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118947,'SBF','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118947,33.4,0.15,47.9,52628,NULL,NULL,NULL,'NGC 5557',NULL,'2005ApJ...634..239C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118948,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118948,32.65,0.4,33.9,52628,75,NULL,'Edat, raw','NGC 5557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118949,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118949,32.98,0.4,39.5,52628,75,NULL,'Edat, cor','NGC 5557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118950,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118950,31.7,0.37,21.9,52628,95,NULL,'Weighted Mean','NGC 5557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118951,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118951,31.85,0.63,23.4,52628,95,NULL,'Michard 1979b, c','NGC 5557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118952,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118952,32.17,0.46,27.2,52628,95,NULL,'Michard 1979a','NGC 5557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118953,'Faber-Jackson','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118953,32.98,0.81,39.4,52628,55,NULL,'Visvanathan & Sandage 1979','NGC 5557',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118954,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118954,32.92,0.41,38.3,52628,NULL,NULL,NULL,'NGC 5557',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118955,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118955,33.19,0.41,43.4,52628,NULL,NULL,'Malmquist cor.','NGC 5557',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118956,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118956,33.3,0.45,45.8,52628,NULL,NULL,'K','NGC 5557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118957,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118957,33.43,0.4,48.6,52628,NULL,NULL,'mean','NGC 5557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118958,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118958,37.85,0.33,372,52629,70,NULL,NULL,'2MASX J14182596+4938426',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.608333,49.64514,0.045,NULL,59253583959,925837249,14466207,17.7),(118959,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118959,40.69,0.14,1010,52630,74.2,NULL,'SALT 2','[AGR2006] J141826.19+523142.7',0.358,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.00001,NULL,'20.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.609167,52.52853,0,NULL,59197902583,924967227,14452612,20.4),(118960,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118960,41.04,0.17,1190,52630,NULL,NULL,'SALT2','[AGR2006] J141826.19+523142.7',0.358,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118961,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk','R',118961,41.14,NULL,1250,52630,65,NULL,'MLCS31','[AGR2006] J141826.19+523142.7',0.358,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118962,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118962,41.3,0.11,1340,52630,70,NULL,'SALT 2','[AGR2006] J141826.19+523142.7',0.358,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118963,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118963,41.34,0.15,1360,52630,NULL,NULL,'SIFTO','[AGR2006] J141826.19+523142.7',0.358,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118964,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118964,41.39,0.13,1400,52630,70,NULL,'SALT','[AGR2006] J141826.19+523142.7',0.358,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118965,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118965,41.39,0.2,1400,52630,65,NULL,'MLCS31','[AGR2006] J141826.19+523142.7',0.358,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118966,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118966,41.41,0.18,1410,52630,65,NULL,'MLCS2k2','[AGR2006] J141826.19+523142.7',0.358,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118967,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118967,41.42,0.07,1420,52630,65,NULL,'SALT2','[AGR2006] J141826.19+523142.7',0.358,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118968,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118968,41.47,0.01,1450,52630,70,NULL,NULL,'[AGR2006] J141826.19+523142.7',0.358,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118969,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118969,41.51,0.1,1470,52630,65,NULL,'SALT','[AGR2006] J141826.19+523142.7',0.358,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118970,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118970,41.51,0.09,1480,52630,65,NULL,'MLCS2k2','[AGR2006] J141826.19+523142.7',0.358,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118971,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118971,41.58,0.16,1530,52630,65,NULL,'MLCS17','[AGR2006] J141826.19+523142.7',0.358,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118972,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118972,41.59,0.17,1530,52630,65,NULL,'SALT2','[AGR2006] J141826.19+523142.7',0.358,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118973,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118973,41.74,0.01,1640,52630,65,NULL,'SALT','[AGR2006] J141826.19+523142.7',0.358,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118974,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 04D3fk',NULL,118974,42.15,0.03,1980,52630,70,NULL,'SALT 2','[AGR2006] J141826.19+523142.7',0.358,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118975,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118975,37.94,0.46,387,52631,70,NULL,NULL,'SDSS J141826.43+253122.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.610167,25.52278,0,NULL,60000506114,937507908,14648561,18.6),(118976,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118976,34.55,0.4,81.4,52632,75,NULL,'Edat, raw','ESO 511- G 023',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'13.79',1,'SAB(s)0-',NULL,NULL,NULL,NULL,1,214.6107083,-27.37883,0.273,NULL,47032461203,734882206,11482534,13.79),(118977,'D-Sigma','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118977,34.89,0.4,95,52632,75,NULL,'Edat, cor','ESO 511- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118978,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118978,34.53,0.25,80.5,52632,74.4,NULL,NULL,'ESO 511- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118979,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118979,34.67,0.45,86.1,52632,NULL,NULL,'K','ESO 511- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118980,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118980,34.96,0.4,98.3,52632,NULL,NULL,'mean','ESO 511- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118981,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118981,30.16,0.43,10.8,52633,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5530',NULL,'2014MNRAS.444..527S',2014,1,4.2,NULL,'G',0.000007,NULL,'11.87',1.9,'SA(rs)c',NULL,NULL,NULL,NULL,1,214.613125,-43.38858,0.397,NULL,46794344040,731161625,11424400,11.87),(118982,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118982,30.32,0.43,11.6,52633,75,NULL,'3.6 micron, color corrected','NGC 5530',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118983,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118983,30.35,0.36,11.7,52633,NULL,NULL,NULL,'NGC 5530',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118984,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118984,30.34,0.39,11.7,52633,73,NULL,'opt','NGC 5530',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118985,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118985,30.45,0.2,12.3,52633,74.4,NULL,NULL,'NGC 5530',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118986,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118986,31.14,0.4,16.9,52633,75,NULL,'B','NGC 5530',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118987,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118987,35.23,0.4,111,52634,NULL,NULL,'mean','NGC 5550',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000163,NULL,'14.05',0.8,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,214.616541667,12.88308,0,NULL,58354662230,911791597,14246743,14.05),(118988,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118988,35.4,0.47,120,52634,NULL,NULL,'H','NGC 5550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118989,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118989,35.45,0.46,123,52634,NULL,NULL,'J','NGC 5550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118990,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118990,35.49,0.45,125,52634,NULL,NULL,'K','NGC 5550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(118991,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118991,37.15,0.27,269,52635,70,NULL,NULL,'2MASX J14182808+5557200',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.616875,55.95553,0.009,NULL,57255306438,894614163,13978346,17),(118992,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118992,37.42,0.46,304,52636,70,NULL,NULL,'SDSS J141828.24+043945.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000071,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.6177083,4.66267,0.029,NULL,58473319005,913645609,14275712,18.5),(118993,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118993,36.83,0.46,232,52637,70,NULL,NULL,'2MASX J14182853+2352032',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.618875,23.86767,0,NULL,59467622442,929181600,14518462,17.3),(118994,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118994,36.89,0.76,239,52638,70,NULL,NULL,'2MASX J14182907-2045422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.6212083,-20.76178,0.373,NULL,46569968904,727655764,11369621,15.7),(118995,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118995,37.28,0.46,286,52639,70,NULL,NULL,'2MASX J14182937+1724438',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,214.6225417,17.41214,0,NULL,59486401009,929475015,14523047,18.42),(118996,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118996,36.85,0.46,235,52640,70,NULL,NULL,'2MASX J14183029+5254107',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.6260417,52.90306,0.005,NULL,59198136705,924970886,14452670,17),(118997,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,118997,36.74,0.71,223,52641,70,NULL,NULL,'ESO 579- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000103,NULL,'14.6R',0.5,'Sa',NULL,NULL,NULL,NULL,1,214.626583,-19.039,0.309,NULL,46563895663,727560869,11368138,14.6),(118998,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118998,35.1,0.46,105,52642,70,NULL,NULL,'CGCG 163-026',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000153,NULL,'15.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,214.6282083,29.17008,0,NULL,60058619595,938415931,14662748,15.1),(118999,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',118999,37.35,0.46,295,52643,70,NULL,NULL,'2MASX J14183128+1911182',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.630417,19.18847,0,NULL,59519047678,929985119,14531017,17.5),(119000,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119000,43.02,0.06,2340,52644,70,NULL,'SIFTO','SNLS 06D3gh',0.72,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.630917,52.44292,0,NULL,59195818642,924934666,14452104,NULL),(119001,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119001,43.15,0.15,2490,52644,NULL,NULL,'SIFTO','SNLS 06D3gh',0.72,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119002,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119002,43.25,NULL,2590,52644,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 06D3gh',0.72,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119003,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119003,43.28,0.23,2630,52644,70,NULL,'SALT 2','SNLS 06D3gh',0.72,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119004,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3gh',NULL,119004,43.91,0.17,3520,52644,NULL,NULL,'SALT2','SNLS 06D3gh',0.72,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119005,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119005,37.05,0.46,256,52645,70,NULL,NULL,'2MASX J14183167+2359545',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000207,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,214.631917,23.99842,0,NULL,59467566201,929180721,14518448,15.9),(119006,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119006,34.18,0.49,68.4,52646,75,NULL,'IR','FGC 1741',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.00015,NULL,'16.4',0.1,'Sd',NULL,NULL,NULL,NULL,1,214.639833333,-5.15325,0.113,NULL,43730258235,683285284,10676332,16.4),(119007,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119007,38.18,0.27,432,52647,70,NULL,NULL,'2MASX J14183385+5940559',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.641166667,59.68222,0.033,NULL,57269392437,894834256,13981785,17.7),(119008,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119008,37.97,0.33,394,52648,70,NULL,NULL,'2MASX J14183413+4402454',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.6420417,44.04603,0,NULL,59239300424,925614069,14462719,17.5),(119009,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119009,38.58,0.46,521,52649,70,NULL,NULL,'SDSS J141834.18+441615.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000138,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,214.642458333,44.27089,0,NULL,59239254845,925613356,14462708,18.6),(119010,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119010,37.39,0.15,300,52650,70,NULL,NULL,'2MASX J14183499+2630245',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.6457083,26.50686,0,NULL,60054595807,938353059,14661766,18),(119011,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119011,38.13,0.46,423,52651,70,NULL,NULL,'2MASX J14183503-0226266',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.645875,-2.44064,0.141,NULL,43504488348,679757630,10621212,17.3),(119012,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119012,35.77,0.46,142,52652,70,NULL,NULL,'2MASX J14183551+0240516',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000067,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.647833333,2.68114,0.065,NULL,58297910189,910904846,14232888,16.8),(119013,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119013,35.12,0.68,106,52653,70,NULL,NULL,'2MASX J14183552-1923091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.83',NULL,NULL,NULL,NULL,NULL,NULL,1,214.648166667,-19.38586,0.321,NULL,46563764668,727558822,11368106,15.83),(119014,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119014,34.93,0.2,96.8,52654,74.4,NULL,NULL,'UGC 09159',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.28',0.3,'Sbc',NULL,NULL,NULL,NULL,1,214.6482917,14.2785,0,NULL,59477778463,929340288,14520942,15.28),(119015,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119015,37.85,0.46,372,52655,70,NULL,NULL,'2MASX J14183605+6137475',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.650583,61.62978,0.013,NULL,57762867730,902544808,14102262,17.6),(119016,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119016,37.34,0.46,294,52656,70,NULL,NULL,'2MASX J14183647+2903445',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.6520417,29.06231,0,NULL,60058735003,938417734,14662777,17.7),(119017,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119017,38.22,0.46,440,52657,70,NULL,NULL,'2MASX J14183787+5603127',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.6580417,56.05364,0.009,NULL,57254429672,894600463,13978132,17.5),(119018,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119018,37.51,0.46,318,52658,70,NULL,NULL,'2MASX J14183836+1433457',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.01',0.16,NULL,NULL,NULL,NULL,NULL,1,214.659833,14.56256,0,NULL,59478258630,929347791,14521059,18.01),(119019,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119019,37.73,0.46,352,52659,70,NULL,NULL,'2MASX J14183843-0128326',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.66,-1.47569,0.121,NULL,43507069185,679797956,10621843,17.5),(119020,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119020,35.09,0.23,104,52660,70,NULL,NULL,'NGC 5549',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.000077,NULL,'13.5g',0.75,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,214.661708333,7.37733,0.049,NULL,58494606289,913978223,14280909,13.5),(119021,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119021,37.65,0.46,339,52661,70,NULL,NULL,'2MASX J14183877+4304054',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.661708333,43.06825,0,NULL,59225588229,925399816,14459372,17.2),(119022,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119022,36.26,0.56,178,52662,70,NULL,NULL,'2MASX J14183922-1951141',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,214.663375,-19.85411,0.345,NULL,46564139065,727564672,11368198,16.12),(119023,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi','R',119023,40.98,NULL,1070,52663,65,NULL,'SNLS 03D3cd, MLCS17','SDSS J141839.84+523644.9',0.461,'2010arXiv1006.2112L',2010,1,0.08,NULL,'G',0.000016,NULL,'20.8g',0.03,NULL,NULL,NULL,NULL,NULL,1,214.6660417,52.6125,0,NULL,59198127312,924970739,14452667,20.8),(119024,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119024,41.37,0.18,1290,52663,74.2,NULL,'SALT 2','SDSS J141839.84+523644.9',0.461,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119025,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119025,41.55,0.06,1400,52663,70,NULL,'SNLS 03D3cd, MLCS17','SDSS J141839.84+523644.9',0.461,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119026,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119026,41.97,0.26,1700,52663,70,NULL,'SNLS 03D3cd, SALT','SDSS J141839.84+523644.9',0.461,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119027,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119027,42.03,0.06,1740,52663,70,NULL,'SNLS 03D3cd','SDSS J141839.84+523644.9',0.461,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119028,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119028,42.03,0.16,1750,52663,70,NULL,'SNLS 03D3cd, SALT 2','SDSS J141839.84+523644.9',0.461,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119029,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119029,42.04,0.15,1750,52663,NULL,NULL,'SNLS 03D3cd, SIFTO','SDSS J141839.84+523644.9',0.461,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119030,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119030,42.05,0.17,1760,52663,65,NULL,'SNLS 03D3cd, MLCS17','SDSS J141839.84+523644.9',0.461,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119031,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119031,42.06,0.15,1770,52663,65,NULL,'SNLS 03D3cd, MLCS2k2','SDSS J141839.84+523644.9',0.461,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119032,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119032,42.09,0.23,1790,52663,65,NULL,'SNLS 03D3cd, SALT2','SDSS J141839.84+523644.9',0.461,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119033,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119033,42.13,0.15,1820,52663,65,NULL,'SNLS 03D3cd, MLCS2k2','SDSS J141839.84+523644.9',0.461,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119034,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119034,42.13,0.17,1820,52663,65,NULL,'SNLS 03D3cd, MLCS31','SDSS J141839.84+523644.9',0.461,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119035,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119035,42.13,0.27,1830,52663,65,NULL,'SNLS 03D3cd, SALT','SDSS J141839.84+523644.9',0.461,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119036,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119036,42.2,0.23,1890,52663,65,NULL,'SNLS 03D3cd, SALT2','SDSS J141839.84+523644.9',0.461,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119037,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119037,42.3,0.05,1970,52663,65,NULL,'SNLS 03D3cd, SALT','SDSS J141839.84+523644.9',0.461,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119038,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SN 2003fi',NULL,119038,44.36,0.17,5090,52663,NULL,NULL,'SNLS 03D3cd, SALT2','SDSS J141839.84+523644.9',0.461,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119039,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','PS1 SN PS11zd','N',119039,38.4,0.11,436,52664,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zd HOST',0.1004,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119040,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119040,37.48,0.46,314,52665,70,NULL,NULL,'SDSS J141840.19+311308.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.667458333,31.21917,0,NULL,60061304943,938457889,14663404,17.5),(119041,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119041,37.65,0.17,339,52666,70,NULL,NULL,'2MASX J14184015+5628107',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000177,NULL,'15.5g',0.63,'E0',NULL,NULL,NULL,NULL,1,214.667458333,56.46956,0,NULL,57254403606,894600056,13978125,15.5),(119042,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119042,37.39,0.15,300,52667,70,NULL,NULL,'2MASX J14184051+2642105',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,214.668833333,26.70308,0,NULL,60054606088,938353220,14661769,16.6),(119043,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119043,35.13,0.46,106,52668,70,NULL,NULL,'2MASX J14184086+0949084',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000164,NULL,'15.5g',0.52,NULL,NULL,NULL,NULL,NULL,1,214.670375,9.81894,0.035,NULL,58500019461,914062804,14282231,15.5),(119044,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119044,37.08,0.46,261,52669,70,NULL,NULL,'2MASX J14184099+0219516',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.670625,2.33089,0.053,NULL,58286316721,910723698,14230057,17.2),(119045,'Tully est','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119045,32.96,0.8,39,52670,75,NULL,'B','VV 557',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.00002,NULL,'14.80',0.8,'S?','Group member of poor cluster',NULL,NULL,NULL,1,214.680625,21.81758,0.036,NULL,59514955061,929921172,14530018,14.8),(119046,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119046,36.87,0.46,236,52671,70,NULL,NULL,'2MASX J14184486+1144484',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.36',0.19,NULL,NULL,NULL,NULL,NULL,1,214.686833,11.74675,0.046,NULL,58489146465,913892913,14279576,17.36),(119047,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119047,43.2,0.05,2490,52672,70,NULL,'SIFTO','SNLS 05D3mn HOST',0.76,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'23.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.6880417,52.32294,0,NULL,59196013937,924937717,14452151,23),(119048,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119048,43.27,0.18,2560,52672,70,NULL,'SALT 2','SNLS 05D3mn HOST',0.76,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119049,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119049,43.28,0.15,2570,52672,NULL,NULL,'SIFTO','SNLS 05D3mn HOST',0.76,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119050,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119050,43.31,NULL,2600,52672,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D3mn HOST',0.76,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119051,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3mn',NULL,119051,43.69,0.17,3110,52672,NULL,NULL,'SALT2','SNLS 05D3mn HOST',0.76,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119052,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119052,37.15,0.27,269,52673,70,NULL,NULL,'2MASX J14184523+5552277',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000213,NULL,'15.8g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,214.688333,55.87422,0.009,NULL,57255391146,894615486,13978366,15.8),(119053,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cq',NULL,119053,43.01,0.06,2120,52674,70,NULL,'SALT2','SNLS 05D3cq HOST',0.89,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,214.692375,53.13208,0,NULL,59198068095,924969813,14452653,NULL),(119054,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cq',NULL,119054,43.05,0.17,2160,52674,NULL,NULL,'SALT2','SNLS 05D3cq HOST',0.89,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119055,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cq',NULL,119055,43.83,0.21,3090,52674,70,NULL,'SALT 2','SNLS 05D3cq HOST',0.89,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119056,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 05D3cq',NULL,119056,43.89,0.15,3170,52674,NULL,NULL,'SIFTO','SNLS 05D3cq HOST',0.89,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119057,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119057,36.94,0.33,245,52675,70,NULL,NULL,'2MASX J14184663-0108146',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'17.0b',0.25,NULL,NULL,NULL,NULL,NULL,1,214.694375,-1.13733,0.165,NULL,43507482871,679804419,10621944,17),(119058,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119058,36.94,0.33,245,52676,70,NULL,NULL,'2MASX J14184763-0110556',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,214.6985417,-1.18197,0.165,NULL,43507355170,679802424,10621912,17.4),(119059,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3ed',NULL,119059,41.73,0.17,1580,52677,NULL,NULL,'SALT2','SNLS 06D3ed',0.404,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.699167,52.75656,0,NULL,59198142864,924970982,14452671,NULL),(119060,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3ed',NULL,119060,41.76,0.03,1600,52677,70,NULL,'SALT2','SNLS 06D3ed',0.404,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119061,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3ed',NULL,119061,41.84,0.11,1660,52677,70,NULL,'SALT 2','SNLS 06D3ed',0.404,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119062,'SNIa','2016-12-15 15:15:23','2016-12-16 11:20:36','1','SNLS 06D3ed',NULL,119062,41.88,0.15,1700,52677,NULL,NULL,'SIFTO','SNLS 06D3ed',0.404,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119063,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119063,34.26,0.8,71.3,52678,75,NULL,'HMCL, I','UGC 09165',NULL,'1997ApJS..109..333W',1997,1,1.3,'The position in 1992ApJS...79..157F is incorrect.','G',0.000027,NULL,'15.18',0.3,'S?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,214.699375,24.94042,0.009,NULL,59999664678,937494760,14648355,15.18),(119064,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119064,33.93,0.49,61.1,52678,75,NULL,'IR','UGC 09165',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119065,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119065,34.12,0.4,66.7,52678,75,NULL,'HMCL, I, raw','UGC 09165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119066,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119066,34.13,0.45,66.9,52678,NULL,NULL,'K','UGC 09165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119067,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119067,34.17,0.47,68.1,52678,NULL,NULL,'H','UGC 09165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119068,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119068,34.28,0.4,71.7,52678,75,NULL,'HMCL, I, cor','UGC 09165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119069,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119069,34.29,0.4,72.2,52678,75,NULL,'HMCL, I, inv','UGC 09165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119070,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119070,34.41,0.4,76.1,52678,NULL,NULL,'mean','UGC 09165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119071,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119071,34.42,0.46,76.4,52678,NULL,NULL,'J','UGC 09165',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119072,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119072,35.79,0.39,144,52679,NULL,NULL,'Malmquist cor.','NGC 5555',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.03',0.5,'Sb             HII',NULL,NULL,NULL,NULL,1,214.700333333,-19.13892,0.309,NULL,46563876008,727560562,11368133,15.03),(119073,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119073,35.92,0.37,153,52679,NULL,NULL,NULL,'NGC 5555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119074,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119074,35.96,0.2,156,52679,74.4,NULL,NULL,'NGC 5555',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119075,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119075,34.58,0.49,82.2,52680,70,NULL,NULL,'2MASX J14184871-2723387',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.4b',NULL,'E',NULL,NULL,NULL,NULL,1,214.702875,-27.39403,0.273,NULL,47034506917,734914170,11483033,16.4),(119076,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119076,35.13,0.25,106,52680,74.4,NULL,NULL,'2MASX J14184871-2723387',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119077,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119077,36.77,0.46,226,52681,70,NULL,NULL,'2MASX J14184873+0808508',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000166,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.703208333,8.14747,0.029,NULL,58497558067,914024344,14281630,16.5),(119078,'Tully est','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,NULL,119078,31.24,0.8,17.7,52682,75,NULL,NULL,'ESO 222- G 001',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000013,NULL,'11.7',1.5,'IBm:',NULL,NULL,NULL,NULL,1,214.704333,-47.73839,0.749,NULL,46835460152,731804064,11434438,11.7),(119079,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119079,36.81,0.46,230,52683,70,NULL,NULL,'2MASX J14184934+2329483',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.70575,23.49669,0,NULL,59467427227,929178550,14518414,17.6),(119080,'FP','2016-12-15 15:15:23','2016-12-16 11:20:36','1',NULL,'R',119080,37.28,0.46,286,52684,70,NULL,NULL,'2MASX J14184948+2020273',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.07',0.14,NULL,NULL,NULL,NULL,NULL,1,214.706125,20.34094,0.02,NULL,59521685582,930026337,14531661,17.07),(119081,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119081,36.01,0.46,159,52685,70,NULL,NULL,'VIII Zw 398',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.9b',0.32,NULL,NULL,NULL,NULL,NULL,1,214.709291667,-2.39375,0.141,NULL,43504496915,679757764,10621215,16.9),(119082,'IRAS','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119082,35,0.8,99.8,52686,75,NULL,'HMCL, I','UGC 09163',NULL,'1997ApJS..109..333W',1997,1,1.36,NULL,'G',0.00004,NULL,'15.8g',0.26,'Scd:',NULL,NULL,NULL,NULL,1,214.7115,11.28878,0.005,NULL,58489377761,913896527,14279633,15.8),(119083,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119083,34.7,0.2,87.1,52686,74.4,NULL,NULL,'UGC 09163',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119084,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119084,34.86,0.4,93.7,52686,75,NULL,'HMCL, I, raw','UGC 09163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119085,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119085,34.95,0.4,97.9,52686,75,NULL,'HMCL, I, inv','UGC 09163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119086,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119086,35.04,0.4,102,52686,75,NULL,'HMCL, I, cor','UGC 09163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119087,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119087,35.39,0.49,120,52686,75,NULL,'IR','UGC 09163',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119088,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119088,35.08,0.25,104,52687,74.4,NULL,NULL,'ESO 511- G 026',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000097,NULL,'15',0.8,'S0',NULL,NULL,NULL,NULL,1,214.711667,-27.41044,0.273,NULL,47034503665,734914119,11483033,15),(119089,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119089,35.41,0.52,121,52687,70,NULL,NULL,'ESO 511- G 026',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119090,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119090,36.21,0.33,175,52688,70,NULL,NULL,'2MASX J14185096+0525546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000061,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.7125417,5.43175,0.037,NULL,58473658810,913650918,14275795,16.9),(119091,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119091,35.41,0.54,121,52689,NULL,NULL,'Malmquist cor.','ESO 385- G 007',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.55',0.3,'Sb:',NULL,NULL,NULL,NULL,1,214.716875,-34.36306,0.177,NULL,47009051492,734516429,11476819,15.55),(119092,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119092,35.49,0.52,125,52689,NULL,NULL,NULL,'ESO 385- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119093,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119093,35.53,0.2,128,52689,74.4,NULL,NULL,'ESO 385- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119094,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,NULL,119094,34.59,0.25,82.8,52690,74.4,NULL,NULL,'2MASX J14185286-2729517',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00015,NULL,'16.0b',NULL,'Sp',NULL,NULL,NULL,NULL,1,214.7202083,-27.49764,0.273,NULL,47034474955,734913671,11483026,16),(119095,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119095,37.82,0.33,367,52691,70,NULL,NULL,'LCRS B141617.4-023441',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,214.720625,-2.80767,0.101,NULL,43518249331,679972645,10624572,17.5),(119096,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119096,37.44,0.46,307,52692,70,NULL,NULL,'2MASX J14185326-0055161',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000086,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,214.721875,-0.92111,0.117,NULL,43507312030,679801750,10621902,16.5),(119097,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119097,37.95,0.46,389,52693,70,NULL,NULL,'2MASX J14185335+0919579',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,214.722333,9.33278,0.057,NULL,58499866708,914060417,14282194,17.1),(119098,'Tully-Fisher','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119098,31.34,NULL,18.5,52694,72,NULL,NULL,'SDSS J141853.47+091728.6',NULL,'2014Ap.....57..457K',2014,1,0.26,NULL,'G',0.000022,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.722833333,9.29131,0.057,NULL,58499604279,914056316,14282129,17.9),(119099,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119099,37.52,0.46,318,52695,70,NULL,NULL,'2MASX J14185377+1844323',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.53',0.14,NULL,NULL,NULL,NULL,NULL,1,214.724,18.74231,0,NULL,59519114493,929986163,14531033,18.53),(119100,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119100,39.43,0.46,768,52696,70,NULL,NULL,'SDSS J141854.15+191105.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.725667,19.18497,0,NULL,59519055627,929985244,14531019,18.6),(119101,'FP','2016-12-15 15:15:23','2016-12-16 11:20:37','1',NULL,'R',119101,36.42,0.46,192,52697,70,NULL,NULL,'2MASX J14185445+0440137',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.7269583,4.67036,0.029,NULL,58292711691,910823620,14231619,17.1),(119102,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119102,42.65,0.22,1870,52698,74.2,NULL,'SALT 2','[HSP2005] J141856.33+521115.06',0.81,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.734708333,52.18753,0.005,NULL,59196046984,924938234,14452159,NULL),(119103,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny','R',119103,42.65,NULL,1870,52698,65,NULL,'MLCS17','[HSP2005] J141856.33+521115.06',0.81,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119104,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119104,43.35,0.24,2590,52698,70,NULL,'SALT 2','[HSP2005] J141856.33+521115.06',0.81,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119105,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119105,43.43,0.17,2680,52698,NULL,NULL,'SALT2','[HSP2005] J141856.33+521115.06',0.81,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119106,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119106,43.46,0.26,2720,52698,65,NULL,'MLCS17','[HSP2005] J141856.33+521115.06',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119107,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119107,43.47,0.08,2730,52698,70,NULL,'SALT 2','[HSP2005] J141856.33+521115.06',0.81,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119108,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119108,43.55,0.15,2840,52698,NULL,NULL,'SIFTO','[HSP2005] J141856.33+521115.06',0.81,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119109,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119109,43.64,0.25,2950,52698,65,NULL,'MLCS2k2','[HSP2005] J141856.33+521115.06',0.81,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119110,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119110,43.65,0.26,2960,52698,65,NULL,'MLCS31','[HSP2005] J141856.33+521115.06',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119111,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119111,43.69,0.3,3020,52698,70,NULL,NULL,'[HSP2005] J141856.33+521115.06',0.81,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119112,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119112,43.73,0.49,3080,52698,70,NULL,'SALT','[HSP2005] J141856.33+521115.06',0.81,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119113,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119113,43.93,0.48,3370,52698,65,NULL,'SALT','[HSP2005] J141856.33+521115.06',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119114,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119114,43.96,0.22,3420,52698,65,NULL,'SALT','[HSP2005] J141856.33+521115.06',0.81,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119115,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ny',NULL,119115,44,0.46,3480,52698,65,NULL,'SALT2','[HSP2005] J141856.33+521115.06',0.81,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119116,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119116,38.15,0.46,427,52699,70,NULL,NULL,'2MASX J14185759+2853469',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.739875,28.89642,0,NULL,60058750285,938417973,14662780,17.6),(119117,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119117,34.81,0.43,91.8,52700,NULL,NULL,'Malmquist cor.','ESO 511- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.42',0.2,'S...',NULL,NULL,NULL,NULL,1,214.744375,-27.21633,0.221,NULL,47034636371,734916193,11483065,15.42),(119118,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119118,34.9,0.41,95.4,52700,NULL,NULL,NULL,'ESO 511- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119119,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119119,34.94,0.2,97.3,52700,74.4,NULL,NULL,'ESO 511- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119120,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119120,36.08,0.46,165,52701,70,NULL,NULL,'2MASX J14185924+0600497',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,214.746791667,6.01389,0.029,NULL,58472820933,913637827,14275591,16.6),(119121,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mh',NULL,119121,43.1,0.2,2490,52702,70,NULL,'SALT 2','SDSS J141859.88+524004.3',0.67,'2013MNRAS.433.2240G',2013,1,0.11,NULL,'G',NULL,'PHOT','21.6g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.7495,52.66789,0,NULL,59198119140,924970611,14452665,21.6),(119122,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mh',NULL,119122,43.31,0.15,2750,52702,NULL,NULL,'SIFTO','SDSS J141859.88+524004.3',0.67,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119123,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mh',NULL,119123,43.37,0.06,2820,52702,70,NULL,'SIFTO','SDSS J141859.88+524004.3',0.67,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119124,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mh',NULL,119124,44.55,0.17,4870,52702,NULL,NULL,'SALT2','SDSS J141859.88+524004.3',0.67,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119125,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119125,37.65,0.17,339,52703,70,NULL,NULL,'2MASX J14190006+5629558',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.750541667,56.49886,0,NULL,57256448152,894632002,13978625,17.4),(119126,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119126,39.75,0.17,719,52704,NULL,NULL,'SALT2','[NSB2006] J141900.39+522306.8',0.24,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,214.751667,52.38522,0,NULL,59196000395,924937506,14452148,NULL),(119127,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119127,40.47,0.12,1000,52704,70,NULL,'SALT 2','[NSB2006] J141900.39+522306.8',0.24,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119128,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119128,40.49,NULL,1010,52704,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[NSB2006] J141900.39+522306.8',0.24,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119129,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119129,40.48,0.15,1010,52704,NULL,NULL,'SIFTO','[NSB2006] J141900.39+522306.8',0.24,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119130,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mq',NULL,119130,40.96,0.03,1260,52704,70,NULL,'SALT2','[NSB2006] J141900.39+522306.8',0.24,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119131,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119131,34.3,0.8,72.6,52705,75,NULL,'HMCL, I','CGCG 133-031',NULL,'1997ApJS..109..333W',1997,1,0.82,NULL,'G',0.000027,NULL,'15.8g',0.36,'Sbc',NULL,NULL,NULL,NULL,1,214.755791667,24.94372,0.009,NULL,59999664385,937494756,14648355,15.8),(119132,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119132,34.14,0.4,67.3,52705,75,NULL,'HMCL, I, raw','CGCG 133-031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119133,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119133,34.14,0.4,67.3,52705,75,NULL,'HMCL, I, inv','CGCG 133-031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119134,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119134,34.29,0.4,72.2,52705,75,NULL,'HMCL, I, cor','CGCG 133-031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119135,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119135,34.81,0.25,91.6,52706,74.4,NULL,NULL,'MCG -04-34-008',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000083,NULL,'15.5',0.4,'E',NULL,NULL,NULL,NULL,1,214.758417,-27.38997,0.221,NULL,47034522016,734914406,11483037,15.5),(119136,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119136,37.53,0.46,320,52707,70,NULL,NULL,'2MASX J14190212+4052305',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.7590417,40.87514,0,NULL,59945613587,936650212,14635159,17),(119137,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119137,34.56,0.25,81.7,52708,74.4,NULL,NULL,'2MASX J14190223-2727348',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00015,NULL,'15.9b',NULL,'E',NULL,NULL,NULL,NULL,1,214.759333,-27.45969,0.273,NULL,47034523149,734914424,11483037,15.9),(119138,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119138,37.23,0.46,279,52709,70,NULL,NULL,'2MASX J14190250+3440577',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000193,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,214.76025,34.68258,0,NULL,60045411057,938209547,14659524,16.1),(119139,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119139,37.82,0.33,367,52710,70,NULL,NULL,'LCRS B141627.6-022909',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.762875,-2.71533,0.101,NULL,43518225875,679972279,10624566,17.9),(119140,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119140,33.46,0.8,49.3,52711,75,NULL,'MAT, I','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'15.38',0.2,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,214.7682917,-34.85153,0.169,NULL,47009659933,734525936,11476967,15.38),(119141,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119141,33.47,0.8,49.5,52711,75,NULL,'HMCL, I','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119142,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119142,33.11,0.4,42,52711,75,NULL,'HMCL, I, raw','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119143,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119143,33.14,0.4,42.4,52711,75,NULL,'HMCL, I, inv','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119144,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119144,33.41,0.4,48,52711,75,NULL,'HMCL, I, cor','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119145,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119145,33.73,0.43,55.6,52711,75,NULL,'3.6 micron, color + selection bias corrected','ESO 385- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119146,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119146,33.78,0.32,56.9,52711,85,NULL,'I, raw','ESO 385- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119147,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119147,33.78,0.35,56.9,52711,NULL,NULL,NULL,'ESO 385- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119148,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119148,33.78,0.2,57,52711,74.4,NULL,NULL,'ESO 385- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119149,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119149,33.79,0.32,57.3,52711,85,NULL,'I, inv','ESO 385- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119150,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119150,33.82,0.43,58.1,52711,75,NULL,'3.6 micron, color corrected','ESO 385- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119151,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119151,33.83,0.43,58.2,52711,75,NULL,'MAT, I, raw','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119152,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119152,33.85,0.34,59,52711,NULL,NULL,'Malmquist cor.','ESO 385- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119153,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119153,33.9,0.49,60.4,52711,75,NULL,'IR','ESO 385- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119154,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119154,33.94,0.43,61.5,52711,75,NULL,'MAT, I, inv','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119155,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119155,33.99,0.43,62.8,52711,75,NULL,'MAT, I, cor','ESO 385- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119156,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119156,34.02,NULL,63.8,52711,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 385- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119157,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119157,34.03,NULL,64,52711,NULL,NULL,'Dipole + Quadrupole','ESO 385- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119158,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119158,34.04,NULL,64.4,52711,NULL,NULL,'Dipole','ESO 385- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119159,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119159,34.17,NULL,68.2,52711,NULL,NULL,NULL,'ESO 385- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119160,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119160,37.49,0.46,315,52712,70,NULL,NULL,'2MASX J14190484+5302506',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000191,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.7702917,53.04739,0,NULL,59198058689,924969667,14452651,16.3),(119161,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119161,37.16,NULL,270,52713,NULL,NULL,NULL,'CGCG 247-017',NULL,'1996PASJ...48..657S',1996,1,0.45,NULL,'G',0.000097,NULL,'15.7g',0.34,'SBcd',NULL,NULL,NULL,NULL,1,214.7779583,47.75411,0.034,NULL,59247484213,925741940,14464717,15.7),(119162,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119162,39.52,0.17,634,52714,NULL,NULL,'SALT2','[AGR2006] J141907.89+530419.1',0.263,'2010A&A...523A...7G',2010,1,0.06,NULL,'G',0.0005,NULL,'21.1g',0.05,NULL,NULL,NULL,NULL,NULL,1,214.78275,53.07192,0,NULL,59198052275,924969566,14452649,21.1),(119163,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119163,39.9,0.14,756,52714,74.2,NULL,'SALT 2','[AGR2006] J141907.89+530419.1',0.263,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119164,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez','R',119164,40.3,NULL,908,52714,65,NULL,'MLCS31','[AGR2006] J141907.89+530419.1',0.263,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119165,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119165,40.4,0.15,952,52714,NULL,NULL,'SIFTO','[AGR2006] J141907.89+530419.1',0.263,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119166,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119166,40.46,NULL,977,52714,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J141907.89+530419.1',0.263,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119167,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119167,40.48,0.11,989,52714,70,NULL,'SALT 2','[AGR2006] J141907.89+530419.1',0.263,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119168,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119168,40.64,0.08,1060,52714,65,NULL,'SALT2','[AGR2006] J141907.89+530419.1',0.263,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119169,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119169,40.64,0.12,1060,52714,70,NULL,'SALT','[AGR2006] J141907.89+530419.1',0.263,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119170,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119170,40.68,0.01,1080,52714,70,NULL,NULL,'[AGR2006] J141907.89+530419.1',0.263,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119171,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119171,40.71,0.09,1100,52714,65,NULL,'MLCS2k2','[AGR2006] J141907.89+530419.1',0.263,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119172,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119172,40.74,0.2,1110,52714,65,NULL,'MLCS31','[AGR2006] J141907.89+530419.1',0.263,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119173,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119173,40.78,0.09,1130,52714,65,NULL,'SALT','[AGR2006] J141907.89+530419.1',0.263,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119174,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119174,40.76,0.17,1130,52714,65,NULL,'MLCS17','[AGR2006] J141907.89+530419.1',0.263,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119175,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119175,40.77,0.18,1130,52714,65,NULL,'MLCS2k2','[AGR2006] J141907.89+530419.1',0.263,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119176,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119176,40.79,0.17,1140,52714,65,NULL,'SALT2','[AGR2006] J141907.89+530419.1',0.263,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119177,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119177,40.95,0.01,1230,52714,65,NULL,'SALT','[AGR2006] J141907.89+530419.1',0.263,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119178,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ez',NULL,119178,41.34,0.03,1470,52714,70,NULL,'SALT2','[AGR2006] J141907.89+530419.1',0.263,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119179,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hh',NULL,119179,43.49,0.06,2820,52715,70,NULL,'SIFTO','SNLS 05D3hh',0.766,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,214.7922917,52.95933,0,NULL,59198056307,924969629,14452650,NULL),(119180,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hh',NULL,119180,43.5,0.23,2840,52715,70,NULL,'SALT 2','SNLS 05D3hh',0.766,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119181,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hh',NULL,119181,43.57,0.15,2940,52715,NULL,NULL,'SIFTO','SNLS 05D3hh',0.766,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119182,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hh',NULL,119182,44.44,0.17,4370,52715,NULL,NULL,'SALT2','SNLS 05D3hh',0.766,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119183,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119183,34.34,0.25,73.8,52716,74.4,NULL,NULL,'2MASX J14191109-2726168',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.79625,-27.43797,0.221,NULL,47034521390,734914396,11483037,NULL),(119184,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119184,38.78,0.46,570,52717,70,NULL,NULL,'2MASX J14191127+1709038',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.796917,17.15106,0,NULL,59486280853,929473138,14523017,18.2),(119185,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119185,37.92,0.46,384,52718,70,NULL,NULL,'2MASX J14191170+3005198',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.81',0.2,NULL,NULL,NULL,NULL,NULL,1,214.798667,30.08875,0,NULL,60061811707,938465807,14663528,17.81),(119186,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119186,36.78,0.46,227,52719,70,NULL,NULL,'2MASX J14191193+2422300',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.799875,24.37506,0,NULL,59467834530,929184914,14518514,17.3),(119187,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119187,36.72,0.27,221,52720,70,NULL,NULL,'2MASX J14191237+2843370',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.801541667,28.72697,0,NULL,60058547520,938414805,14662731,16.9),(119188,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119188,34.23,0.8,70,52721,75,NULL,'HMCL, I','NGC 5559',NULL,'1997ApJS..109..333W',1997,1,1.69,NULL,'G',0.000033,NULL,'14.3g',0.46,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,214.80325,24.79872,0,NULL,59466917932,929170592,14518290,14.3),(119189,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119189,33.96,0.4,62,52721,75,NULL,'HMCL, I, raw','NGC 5559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119190,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119190,34,0.49,63.2,52721,75,NULL,'IR','NGC 5559',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119191,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119191,34.14,0.4,67.2,52721,75,NULL,'HMCL, I, inv','NGC 5559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119192,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119192,34.16,0.47,67.8,52721,NULL,NULL,'H','NGC 5559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119193,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119193,34.16,0.4,67.9,52721,75,NULL,'HMCL, I, cor','NGC 5559',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119194,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119194,34.21,0.45,69.6,52721,NULL,NULL,'K','NGC 5559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119195,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119195,34.28,0.46,71.8,52721,NULL,NULL,'J','NGC 5559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119196,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119196,34.38,0.4,75.1,52721,NULL,NULL,'mean','NGC 5559',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119197,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119197,38.03,0.23,404,52722,70,NULL,NULL,'2MASX J14191304+2104164',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.84',0.15,NULL,NULL,NULL,NULL,NULL,1,214.8044583,21.07128,0.015,NULL,59522373232,930037081,14531829,18.84),(119198,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119198,35.61,0.33,132,52723,70,NULL,NULL,'ARK 447',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00009,NULL,'14.7g',0.65,'S0^-',NULL,NULL,NULL,NULL,1,214.813,35.33889,0,NULL,60044744270,938199129,14659361,14.7),(119199,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119199,37.09,0.46,262,52724,70,NULL,NULL,'2MASX J14191607+1900144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.63',0.19,NULL,NULL,NULL,NULL,NULL,1,214.817083333,19.00406,0,NULL,59519269416,929988584,14531071,16.63),(119200,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119200,35.61,0.33,132,52725,70,NULL,NULL,'2MASXi J1419175+350752',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000159,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.822791667,35.13153,0,NULL,60045464908,938210389,14659537,16.3),(119201,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ax',NULL,119201,42.62,0.06,2040,52726,70,NULL,'SALT2','EGSIRAC J141917.71+524115.5',0.643,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'23.6L',NULL,'a',NULL,NULL,NULL,NULL,1,214.823791667,52.68764,0,NULL,59198116457,924970569,14452665,23.6),(119202,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ax',NULL,119202,42.97,0.15,2390,52726,NULL,NULL,'SIFTO','EGSIRAC J141917.71+524115.5',0.643,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119203,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ax',NULL,119203,43,0.22,2430,52726,70,NULL,'SALT 2','EGSIRAC J141917.71+524115.5',0.643,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119204,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ax',NULL,119204,43.88,0.17,3630,52726,NULL,NULL,'SALT2','EGSIRAC J141917.71+524115.5',0.643,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119205,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119205,37.35,0.46,295,52727,70,NULL,NULL,'2MASX J14191781+1932205',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'16.9E',NULL,NULL,NULL,NULL,NULL,NULL,1,214.8242917,19.53894,0,NULL,59518746565,929980415,14530943,16.9),(119206,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119206,37.79,0.46,361,52728,70,NULL,NULL,'2MASX J14191802+0600217',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.825125,6.00594,0.029,NULL,58472852068,913638313,14275598,17.8),(119207,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119207,36.42,0.27,192,52729,70,NULL,NULL,'2MASX J14192059+5208200',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000166,NULL,'17.0g',NULL,NULL,NULL,NULL,NULL,NULL,1,214.835917,52.13892,0.005,NULL,59195994185,924937409,14452147,17),(119208,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119208,36.4,0.46,190,52730,70,NULL,NULL,'2MASX J14192180+0856224',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.840917,8.93947,0.039,NULL,58495787920,913996686,14281198,16.7),(119209,'Ring Diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119209,32.7,0.84,34,52731,NULL,NULL,'Published at H = 100 km/s/Mpc','ESO 511- G 030',NULL,'1981ApJS...45..541P',1981,1,2.5,NULL,'G',0.000013,NULL,'12.7r',1.8,'SA(rs)c pec    Sy1',NULL,NULL,NULL,'Sy 1',1,214.843417,-26.64472,0.301,NULL,47031015574,734859618,11482181,12.7),(119210,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119210,33.96,0.47,61.9,52731,NULL,NULL,'H','ESO 511- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119211,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119211,33.99,0.45,62.8,52731,NULL,NULL,'K','ESO 511- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119212,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119212,34.13,0.46,67,52731,NULL,NULL,'J','ESO 511- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119213,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119213,34.89,0.4,94.9,52731,NULL,NULL,'mean','ESO 511- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119214,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119214,37.16,0.19,270,52732,70,NULL,NULL,'2MASX J14192310+1836064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.39',0.24,NULL,NULL,NULL,NULL,NULL,1,214.8462083,18.60192,0,NULL,59519090287,929985785,14531027,16.39),(119215,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3em',NULL,119215,42.96,0.21,2320,52733,70,NULL,'SALT 2','SNLS 06D3em',0.69,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,214.847583,53.02303,0,NULL,59198061728,924969714,14452651,NULL),(119216,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3em',NULL,119216,43.17,0.15,2540,52733,NULL,NULL,'SIFTO','SNLS 06D3em',0.69,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119217,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3em',NULL,119217,43.2,0.17,2580,52733,NULL,NULL,'SALT2','SNLS 06D3em',0.69,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119218,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3em',NULL,119218,44.05,0.05,3820,52733,70,NULL,'SIFTO','SNLS 06D3em',0.69,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119219,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119219,37.78,0.46,360,52734,70,NULL,NULL,'SDSS J141923.79+051930.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.849125,5.32511,0.033,NULL,58293355157,910833674,14231776,18.5),(119220,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119220,34.76,0.46,89.7,52735,70,NULL,NULL,'CGCG 247-019',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00006,NULL,'15.4g',0.47,'S0',NULL,NULL,NULL,NULL,1,214.854667,45.86425,0,NULL,59229190792,925456106,14460251,15.4),(119221,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119221,43.24,0.06,2450,52736,70,NULL,'SALT2','[HSP2005] J141925.83+530949.56',0.813,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.857625,53.16378,0,NULL,59198169170,924971393,14452678,NULL),(119222,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119222,43.69,0.17,3010,52736,NULL,NULL,'SALT2','[HSP2005] J141925.83+530949.56',0.813,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119223,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119223,43.76,0.21,3110,52736,70,NULL,'SALT 2','[HSP2005] J141925.83+530949.56',0.813,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119224,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119224,43.76,0.15,3120,52736,NULL,NULL,'SIFTO','[HSP2005] J141925.83+530949.56',0.813,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119225,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3mk',NULL,119225,43.76,NULL,3120,52736,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[HSP2005] J141925.83+530949.56',0.813,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119226,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119226,37.47,0.07,312,52737,70,NULL,NULL,'2MASX J14192777+4835590',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.865625,48.59969,0.022,NULL,59247937073,925749016,14464828,16.9),(119227,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119227,36.42,0.27,192,52738,70,NULL,NULL,'MCG +09-23-061',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000097,NULL,'15.2g',0.56,'E0',NULL,NULL,NULL,NULL,1,214.868,52.13542,0.005,NULL,59195994461,924937413,14452147,15.2),(119228,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119228,36.63,0.46,212,52739,70,NULL,NULL,'2MASX J14192845+5857254',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,214.868708333,58.957,0.021,NULL,57302999813,895359372,13989990,16.2),(119229,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119229,37.37,0.46,298,52740,70,NULL,NULL,'2MASX J14192857+3611464',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.869,36.19628,0,NULL,60031732010,937995812,14656184,17.2),(119230,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jr',NULL,119230,40.6,0.17,961,52741,NULL,NULL,'SALT2','[NSB2006] J141928.76+525153.3',0.37,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.869875,52.86481,0,NULL,59198092935,924970202,14452659,NULL),(119231,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jr',NULL,119231,41.4,0.11,1390,52741,70,NULL,'SALT 2','[NSB2006] J141928.76+525153.3',0.37,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119232,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jr',NULL,119232,41.41,0.15,1390,52741,NULL,NULL,'SIFTO','[NSB2006] J141928.76+525153.3',0.37,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119233,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jr',NULL,119233,42.31,0.03,2120,52741,70,NULL,'SALT2','[NSB2006] J141928.76+525153.3',0.37,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119234,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119234,37.27,0.33,284,52742,70,NULL,NULL,'2MASX J14193027+3234097',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,214.8760417,32.56942,0,NULL,60041468373,938147943,14658561,16.3),(119235,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119235,34.53,0.46,80.4,52743,70,NULL,NULL,'ESO 511- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000067,NULL,'14.37',1,'S0?','Pair member (points to parent)',NULL,NULL,NULL,1,214.87675,-27.37622,0.221,NULL,47034529579,734914524,11483039,14.37),(119236,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119236,34.86,0.25,93.8,52743,74.4,NULL,NULL,'ESO 511- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119237,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119237,37.53,0.27,321,52744,70,NULL,NULL,'2MASX J14193076+5622474',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000223,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.878166667,56.37992,0,NULL,57254382621,894599728,13978120,17.1),(119238,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119238,36.98,0.46,249,52745,70,NULL,NULL,'2MASX J14193116+0223100',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000102,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.879875,2.38619,0.061,NULL,58297758990,910902484,14232851,16.6),(119239,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119239,35.56,0.63,130,52746,70,NULL,NULL,'2MASX J14193136-0409118',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.4b',0.37,NULL,NULL,NULL,NULL,NULL,1,214.880625,-4.15344,0.117,NULL,43510106629,679845416,10622584,16.4),(119240,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119240,37.16,0.19,270,52747,70,NULL,NULL,'2MASX J14193162+1833544',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,214.881667,18.56506,0,NULL,59519075626,929985556,14531024,18.32),(119241,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119241,37.85,0.21,372,52748,70,NULL,NULL,'2MASX J14193188+0503460',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000102,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.882917,5.06294,0.037,NULL,58292894762,910826480,14231663,16.7),(119242,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119242,38.46,0.46,492,52749,70,NULL,NULL,'2MASX J14193206+1515498',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.883667,15.26389,0,NULL,59477460045,929335313,14520864,17.9),(119243,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119243,35.88,0.57,150,52750,70,NULL,NULL,'2MASX J14193260-3503103',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000113,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,214.88575,-35.05286,0.169,NULL,47009634049,734525532,11476961,14.1),(119244,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119244,34.34,0.46,73.9,52751,70,NULL,NULL,'IC 0999',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000063,NULL,'14.86',0.4,'S0?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,214.886125,17.87531,0,NULL,59486749738,929480464,14523132,14.86),(119245,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119245,37.38,0.46,299,52752,70,NULL,NULL,'2MASX J14193323+1651258',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.72',0.22,NULL,NULL,NULL,NULL,NULL,1,214.888416667,16.85717,0,NULL,59484930383,929452037,14522688,17.72),(119246,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119246,37.53,0.27,321,52753,70,NULL,NULL,'2MASXi J1419333+561724',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.888875,56.29011,0,NULL,57254573846,894602716,13978167,17.7),(119247,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119247,37.16,0.19,270,52754,70,NULL,NULL,'2MASX J14193344+1834154',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.75',0.21,NULL,NULL,NULL,NULL,NULL,1,214.889375,18.57097,0,NULL,59519089250,929985769,14531027,17.75),(119248,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119248,37.85,0.21,372,52755,70,NULL,NULL,'2MASX J14193355+0507570',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.889791667,5.13267,0.037,NULL,58292885482,910826335,14231661,17.6),(119249,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119249,37.41,0.46,304,52756,70,NULL,NULL,'2MASX J14193376+0243450',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.89075,2.72925,0.065,NULL,58297892040,910904563,14232883,18.1),(119250,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119250,36.62,0.46,211,52757,70,NULL,NULL,'2MASX J14193439+2636584',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00007,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,214.8932917,26.61639,0,NULL,60054796728,938356198,14661815,15.5),(119251,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119251,37.16,0.19,270,52758,70,NULL,NULL,'2MASX J14193443+1833054',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.893583,18.55139,0,NULL,59519076132,929985564,14531024,17.5),(119252,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119252,42.83,0.29,1910,52759,74.2,NULL,'SALT 2','[AGR2006] J141934.59+521732.6',0.93,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.894167,52.29239,0.005,NULL,59195936811,924936512,14452133,NULL),(119253,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki','R',119253,43.33,NULL,2400,52759,65,NULL,'MLCS17','[AGR2006] J141934.59+521732.6',0.93,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119254,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119254,43.5,0.23,2590,52759,65,NULL,'MLCS2k2','[AGR2006] J141934.59+521732.6',0.93,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119255,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119255,43.67,0.31,2810,52759,65,NULL,'SALT2','[AGR2006] J141934.59+521732.6',0.93,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119256,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119256,44.2,0.24,3590,52759,65,NULL,'MLCS17','[AGR2006] J141934.59+521732.6',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119257,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119257,44.43,0.16,3990,52759,65,NULL,'MLCS2k2','[AGR2006] J141934.59+521732.6',0.93,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119258,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119258,44.43,0.43,3990,52759,70,NULL,NULL,'[AGR2006] J141934.59+521732.6',0.93,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119259,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119259,44.44,0.18,4000,52759,65,NULL,'MLCS31','[AGR2006] J141934.59+521732.6',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119260,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119260,44.64,0.69,4390,52759,70,NULL,'SALT','[AGR2006] J141934.59+521732.6',0.93,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119261,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119261,44.7,0.28,4500,52759,65,NULL,'SALT','[AGR2006] J141934.59+521732.6',0.93,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119262,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119262,44.76,0.55,4650,52759,65,NULL,'SALT2','[AGR2006] J141934.59+521732.6',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119263,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3ki',NULL,119263,44.88,0.64,4910,52759,65,NULL,'SALT','[AGR2006] J141934.59+521732.6',0.93,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119264,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119264,37.65,0.17,339,52760,70,NULL,NULL,'2MASX J14193577+5630284',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.899041667,56.50775,0,NULL,57256502962,894632858,13978638,18.1),(119265,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119265,37.16,0.19,270,52761,70,NULL,NULL,'2MASX J14193612+1835054',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.85',0.21,NULL,NULL,NULL,NULL,NULL,1,214.9005417,18.58486,0,NULL,59519089644,929985775,14531027,17.85),(119266,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119266,35.91,0.46,152,52762,70,NULL,NULL,'CGCG 047-009 NED02',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.9087083,6.13481,0.033,NULL,58502156277,914096191,14282752,16.2),(119267,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119267,37.53,0.46,320,52763,70,NULL,NULL,'2MASX J14193923+2328104',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,214.913583,23.46972,0,NULL,59513297731,929895277,14529613,16.8),(119268,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe','R',119268,42.47,NULL,1780,52764,65,NULL,'MLCS31','[HSP2005] J141939.38+523314.21',0.756,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,'22.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,214.913791667,52.55381,0,NULL,59197995302,924968676,14452635,22.8),(119269,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119269,42.89,0.06,2160,52764,70,NULL,'MLCS31','[HSP2005] J141939.38+523314.21',0.756,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119270,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119270,43.07,0.17,2340,52764,NULL,NULL,'SALT2','[HSP2005] J141939.38+523314.21',0.756,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119271,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119271,43.11,0.19,2380,52764,74.2,NULL,'SALT 2','[HSP2005] J141939.38+523314.21',0.756,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119272,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119272,43.45,0.06,2790,52764,70,NULL,NULL,'[HSP2005] J141939.38+523314.21',0.756,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119273,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119273,43.54,0.22,2900,52764,65,NULL,'MLCS2k2','[HSP2005] J141939.38+523314.21',0.756,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119274,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119274,43.54,0.15,2910,52764,NULL,NULL,'SIFTO','[HSP2005] J141939.38+523314.21',0.756,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119275,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119275,43.54,0.23,2910,52764,65,NULL,'MLCS31','[HSP2005] J141939.38+523314.21',0.756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119276,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119276,43.58,0.21,2970,52764,65,NULL,'MLCS17','[HSP2005] J141939.38+523314.21',0.756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119277,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119277,43.67,0.2,3090,52764,70,NULL,'SALT','[HSP2005] J141939.38+523314.21',0.756,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119278,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119278,43.72,0.06,3160,52764,65,NULL,'SALT','[HSP2005] J141939.38+523314.21',0.756,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119279,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119279,43.79,0.21,3260,52764,70,NULL,'SALT 2','[HSP2005] J141939.38+523314.21',0.756,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119280,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119280,43.91,0.17,3440,52764,65,NULL,'SALT','[HSP2005] J141939.38+523314.21',0.756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119281,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3oe',NULL,119281,44.02,0.21,3620,52764,65,NULL,'SALT2','[HSP2005] J141939.38+523314.21',0.756,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119282,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119282,37.6,0.21,331,52765,70,NULL,NULL,'2MASX J14193956+2527414',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000199,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,214.9147917,25.46153,0,NULL,59999614740,937493980,14648343,16.6),(119283,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119283,37.02,0.46,254,52766,70,NULL,NULL,'SDSS J141939.73+075606.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,214.915541667,7.93514,0.041,NULL,58497678942,914026233,14281659,17.8),(119284,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119284,34.5,0.46,79.3,52767,70,NULL,NULL,'CGCG 104-005',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'15.4',0.2,'E','Isolated galaxy',NULL,NULL,NULL,1,214.916416667,19.94478,0.026,NULL,59522947557,930046055,14531969,15.4),(119285,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119285,38.59,0.46,522,52768,70,NULL,NULL,'SDSS J141940.19+125402.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.917458333,12.90058,0,NULL,58351816663,911747135,14246048,18.3),(119286,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119286,35.09,0.23,104,52769,70,NULL,NULL,'2MASX J14194026+0732184',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,214.917583,7.53833,0.049,NULL,58494256580,913972759,14280824,16),(119287,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119287,37.27,0.33,284,52770,70,NULL,NULL,'2MASX J14194030+3235442',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.918041667,32.59575,0,NULL,60039373136,938115205,14658050,17.7),(119288,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119288,36.31,0.76,183,52771,70,NULL,NULL,'2MASX J14194129-4743532',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,214.9220417,-47.73139,0.749,NULL,46835356340,731802442,11434413,17),(119289,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119289,36.72,0.27,221,52772,70,NULL,NULL,'2MASX J14194153+2848334',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.5g',0.27,'S0',NULL,NULL,NULL,NULL,1,214.922917,28.80925,0,NULL,60058565353,938415083,14662735,16.5),(119290,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119290,37.16,0.19,270,52773,70,NULL,NULL,'2MASX J14194223+1832354',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,214.926,18.54328,0,NULL,59518356366,929974318,14530848,17.6),(119291,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119291,35.31,0.19,115,52774,70,NULL,NULL,'CGCG 075-009',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00016,NULL,'15.1g',0.46,NULL,NULL,NULL,NULL,NULL,1,214.926833333,11.62467,0,NULL,58489247424,913894491,14279601,15.1),(119292,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119292,37.85,0.21,372,52775,70,NULL,NULL,'SDSS J141942.95+050347.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,214.929,5.06322,0.037,NULL,58292885554,910826336,14231661,17.9),(119293,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119293,36.72,0.27,221,52776,70,NULL,NULL,'MCG +05-34-021',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'16.38',0.3,'E',NULL,NULL,NULL,NULL,1,214.9305,28.87397,0,NULL,60058552523,938414883,14662732,16.38),(119294,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119294,37.31,0.46,289,52777,70,NULL,NULL,'2MASX J14194349+2724344',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.93125,27.40958,0,NULL,60057639368,938400615,14662509,18.1),(119295,'BL Lac Luminosity','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119295,40.01,NULL,1000,52778,NULL,NULL,'Min. z = 0.27','1FGL J1419.7+7731',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.933,77.524,0.065,NULL,57118613186,892478331,13944973,NULL),(119296,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119296,29.78,NULL,9.04,52779,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09169',NULL,'2010Ap&SS.325..163P',2010,1,5.15,NULL,'G',0.00001,NULL,'13.5',0.69,'Sdm','Group member of poor cluster',NULL,NULL,NULL,1,214.935875,9.36236,0.041,NULL,58499178085,914049657,14282025,13.5),(119297,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119297,29.8,NULL,9.13,52779,NULL,NULL,'Dipole + Quadrupole','UGC 09169',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119298,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119298,29.81,NULL,9.16,52779,NULL,NULL,'Dipole','UGC 09169',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119299,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119299,29.9,NULL,9.53,52779,NULL,NULL,NULL,'UGC 09169',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119300,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119300,30.96,0.4,15.6,52779,NULL,NULL,NULL,'UGC 09169',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119301,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119301,31.53,NULL,20.2,52779,72,NULL,NULL,'UGC 09169',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119302,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119302,31.9,0.4,24,52779,75,NULL,'B','UGC 09169',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119303,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119303,41.33,0.15,1260,52780,74.2,NULL,'SALT 2','SDSS J141945.34+523224.8',0.463,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0003,NULL,'22.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,214.9389583,52.54022,0,NULL,59197987466,924968554,14452633,22.9),(119304,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119304,42.08,0.17,1780,52780,65,NULL,'SNLS 03D3cc, SALT2','SDSS J141945.34+523224.8',0.463,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119305,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119305,42.09,0.03,1790,52780,70,NULL,'SNLS 03D3cc','SDSS J141945.34+523224.8',0.463,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119306,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119306,42.09,0.1,1790,52780,70,NULL,'SNLS 03D3cc, SALT','SDSS J141945.34+523224.8',0.463,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119307,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119307,42.1,0.15,1800,52780,65,NULL,'SNLS 03D3cc, MLCS2k2','SDSS J141945.34+523224.8',0.463,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119308,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119308,42.17,0.2,1860,52780,65,NULL,'SNLS 03D3cc, SALT2','SDSS J141945.34+523224.8',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119309,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119309,42.2,0.17,1890,52780,65,NULL,'SNLS 03D3cc, MLCS17','SDSS J141945.34+523224.8',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119310,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119310,42.25,0.14,1930,52780,65,NULL,'SNLS 03D3cc, MLCS2k2','SDSS J141945.34+523224.8',0.463,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119311,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119311,42.26,0.16,1940,52780,65,NULL,'SNLS 03D3cc, MLCS31','SDSS J141945.34+523224.8',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119312,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fj',NULL,119312,42.35,0.15,2010,52780,65,NULL,'SNLS 03D3cc, SALT','SDSS J141945.34+523224.8',0.463,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119313,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119313,37.53,0.27,321,52781,70,NULL,NULL,'2MASX J14194557+5625085',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000193,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,214.94,56.41889,0,NULL,57256462541,894632227,13978628,16.6),(119314,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119314,37.14,0.46,268,52782,70,NULL,NULL,'2MASX J14194567+2943334',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.84',0.2,'E',NULL,NULL,NULL,NULL,1,214.940333,29.72611,0,NULL,60062192830,938471762,14663621,17.84),(119315,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119315,36.42,0.27,192,52783,70,NULL,NULL,'MCG +09-23-062',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000177,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,214.9405,52.11322,0.005,NULL,59195995421,924937428,14452147,15.8),(119316,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119316,36.38,0.46,189,52784,70,NULL,NULL,'2MASX J14194586+3117402',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000063,NULL,'16.25',0.35,NULL,NULL,NULL,NULL,NULL,1,214.9410417,31.29456,0,NULL,60061334850,938458357,14663411,16.25),(119317,'BL Lac Luminosity','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119317,39.26,NULL,617,52785,NULL,NULL,NULL,'[HB89] 1418+546',0.152561,'2005ApJ...635..173S',2005,1,NULL,'May be associated with 2EG J1430+5356.','QSO',0.000281,NULL,'15.9g',NULL,'Opt.var.       BLLAC',NULL,NULL,'radio jet','BL Lac',1,214.944167,54.38744,0.005,NULL,57252566402,894571350,13977677,15.9),(119318,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119318,28.78,NULL,5.7,52786,NULL,NULL,NULL,'NGC 5585',NULL,'1994BSAO...38....5K',1994,1,5.8,NULL,'G',0.000007,NULL,'11.20',3.7,'SAB(s)d        HII','Possible field galaxy',NULL,NULL,NULL,1,214.950833,56.72906,0,NULL,57249167209,894518237,13976847,11.2),(119319,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119319,29.4,0.9,7.59,52786,NULL,NULL,'3, B, blue stars','NGC 5585',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119320,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119320,29.4,0.9,7.59,52786,NULL,NULL,'3, B, blue stars','NGC 5585',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119321,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119321,29.7,NULL,8.7,52786,NULL,NULL,NULL,'NGC 5585',NULL,'2000A&AS..142..425D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119322,'Brightest Stars','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119322,29.7,NULL,8.71,52786,NULL,NULL,'Photographic','NGC 5585',NULL,'1980A&A....83..354C',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119323,'HII region diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119323,29.11,0.16,6.64,52786,NULL,NULL,'Method 2','NGC 5585',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119324,'HII region diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119324,29.18,0.09,6.85,52786,NULL,NULL,'Method 1','NGC 5585',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119325,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119325,29.8,0.8,9.12,52786,75,NULL,'A82, H','NGC 5585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119326,'Magnitude','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119326,28.36,0.16,4.7,52786,NULL,NULL,NULL,'NGC 5585',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119327,'Sosies','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119327,30.11,0.52,10.5,52786,NULL,NULL,NULL,'NGC 5585',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119328,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119328,27.9,0.69,3.8,52786,100,NULL,'mid-IR','NGC 5585',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119329,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119329,29.22,0.4,7,52786,75,NULL,'B','NGC 5585',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119330,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119330,29.23,0.4,7,52786,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5585',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119331,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119331,29.33,NULL,7.35,52786,NULL,NULL,'LEDA [April 2006]','NGC 5585',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119332,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119332,29.47,0.43,7.8,52786,75,NULL,'3.6 micron, color corrected','NGC 5585',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119333,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119333,29.46,0.43,7.8,52786,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5585',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119334,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119334,29.48,0.2,7.87,52786,74.4,NULL,NULL,'NGC 5585',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119335,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119335,29.62,NULL,8.39,52786,NULL,NULL,'IR','NGC 5585',NULL,'1980ApJ...237..655A',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119336,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119336,29.65,0.47,8.52,52786,75,NULL,'A82, H, inv','NGC 5585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119337,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119337,29.66,0.35,8.55,52786,NULL,NULL,NULL,'NGC 5585',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119338,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119338,29.67,0.39,8.6,52786,73,NULL,'opt','NGC 5585',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119339,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119339,29.75,0.64,8.9,52786,NULL,NULL,NULL,'NGC 5585',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119340,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119340,29.78,0.47,9.05,52786,75,NULL,'A82, H, raw','NGC 5585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119341,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119341,29.86,0.61,9.39,52786,NULL,NULL,'Malmquist cor.','NGC 5585',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119342,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119342,30.11,0.47,10.5,52786,75,NULL,'A82, H, cor','NGC 5585',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119343,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119343,38.03,0.23,404,52787,70,NULL,NULL,'2MASX J14194828+2050574',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.60',0.16,NULL,NULL,NULL,NULL,NULL,1,214.951083,20.84911,0.024,NULL,59521721827,930026903,14531670,18.6),(119344,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119344,36.94,0.46,244,52788,70,NULL,NULL,'2MASX J14194869+1729314',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.71',0.23,NULL,NULL,NULL,NULL,NULL,1,214.952833,17.49211,0,NULL,59486448605,929475759,14523058,17.71),(119345,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119345,38.15,0.46,426,52789,70,NULL,NULL,'SDSS J141948.84+185750.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,214.9535417,18.96389,0,NULL,59519218518,929987789,14531059,18.1),(119346,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119346,37.4,0.15,302,52790,70,NULL,NULL,'2MASX J14194965+3006252',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.44',0.14,NULL,NULL,NULL,NULL,NULL,1,214.9567917,30.10719,0,NULL,60062333267,938473957,14663655,18.44),(119347,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119347,38.25,0.46,446,52791,70,NULL,NULL,'2MASX J14194992+1952284',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,214.9579583,19.8745,0.026,NULL,59522965563,930046336,14531974,17.3),(119348,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119348,37.19,0.46,274,52792,70,NULL,NULL,'2MASX J14195013+0816582',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,214.9589583,8.28269,0.041,NULL,58495517904,913992467,14281132,16.7),(119349,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119349,37.29,0.46,288,52793,70,NULL,NULL,'2MASX J14195071+3558296',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000145,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,214.9614583,35.97494,0,NULL,60043001436,938171897,14658935,17.4),(119350,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119350,42.48,0.17,1580,52794,NULL,NULL,'SALT2','[HSP2005] J141950.92+523011.85',0.983,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.9622083,52.50331,0,NULL,59195942442,924936600,14452134,NULL),(119351,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp','R',119351,43.33,NULL,2340,52794,65,NULL,'SALT','[HSP2005] J141950.92+523011.85',0.983,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119352,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119352,43.46,0.44,2480,52794,74.2,NULL,'SALT 2','[HSP2005] J141950.92+523011.85',0.983,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119353,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119353,43.94,0.5,3100,52794,70,NULL,NULL,'[HSP2005] J141950.92+523011.85',0.983,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119354,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119354,43.97,0.87,3140,52794,70,NULL,'SALT','[HSP2005] J141950.92+523011.85',0.983,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119355,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119355,44.03,0.32,3230,52794,70,NULL,'SALT 2','[HSP2005] J141950.92+523011.85',0.983,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119356,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119356,44.13,0.82,3380,52794,65,NULL,'SALT','[HSP2005] J141950.92+523011.85',0.983,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119357,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119357,44.17,0.15,3440,52794,NULL,NULL,'SIFTO','[HSP2005] J141950.92+523011.85',0.983,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119358,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119358,44.21,0.32,3500,52794,65,NULL,'SALT','[HSP2005] J141950.92+523011.85',0.983,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119359,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119359,44.35,0.14,3740,52794,70,NULL,'SALT2','[HSP2005] J141950.92+523011.85',0.983,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119360,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119360,44.39,0.42,3810,52794,65,NULL,'SALT2','[HSP2005] J141950.92+523011.85',0.983,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119361,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119361,44.43,0.29,3880,52794,65,NULL,'MLCS2k2','[HSP2005] J141950.92+523011.85',0.983,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119362,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lp',NULL,119362,44.7,0.16,4400,52794,65,NULL,'MLCS2k2','[HSP2005] J141950.92+523011.85',0.983,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119363,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119363,37.85,0.21,372,52795,70,NULL,NULL,'2MASX J14195143+0503395',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00009,NULL,'16.1g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,214.9642083,5.06111,0.037,NULL,58292868586,910826071,14231657,16.1),(119364,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119364,35.67,0.67,136,52796,70,NULL,NULL,'2MASX J14195259-0912045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.00',NULL,NULL,NULL,NULL,NULL,NULL,1,214.969167,-9.2015,0.165,NULL,43719404164,683115690,10673682,16),(119365,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kt',NULL,119365,42.61,0.17,2020,52797,NULL,NULL,'SALT2','DEEP2 12027456',0.647341,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.000032,NULL,'23.7R',NULL,'a',NULL,NULL,NULL,NULL,1,214.9739583,52.74303,0,NULL,59197969943,924968280,14452629,23.7),(119366,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kt',NULL,119366,42.83,0.15,2240,52797,NULL,NULL,'SIFTO','DEEP2 12027456',0.647341,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119367,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kt',NULL,119367,42.85,0.17,2250,52797,70,NULL,'SALT 2','DEEP2 12027456',0.647341,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119368,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kt',NULL,119368,43.47,0.05,3000,52797,70,NULL,'SALT2','DEEP2 12027456',0.647341,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119369,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119369,37.85,0.21,372,52798,70,NULL,NULL,'2MASX J14195464+0458595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,214.977667,4.98325,0.029,NULL,58292872584,910826134,14231658,17.2),(119370,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119370,37.05,0.46,257,52799,70,NULL,NULL,'2MASX J14195491+6309366',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,214.978667,63.16025,0.041,NULL,57749419406,902334678,14098979,16),(119371,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119371,38.03,0.23,404,52800,70,NULL,NULL,'2MASX J14195496+2051281',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.16,NULL,NULL,NULL,NULL,NULL,1,214.979,20.85789,0.024,NULL,59521724399,930026943,14531670,18.7),(119372,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119372,38.03,0.23,404,52801,70,NULL,NULL,'2MASX J14195560+2054091',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.35',0.19,'BrClG',NULL,NULL,NULL,NULL,1,214.9815417,20.90256,0.024,NULL,59522194927,930034295,14531785,17.35),(119373,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119373,37.19,0.46,274,52802,70,NULL,NULL,'LCRS B141720.6-021854',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00012,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.983083333,-2.54372,0.137,NULL,43518879159,679982486,10624726,17.8),(119374,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 03D3bl',NULL,119374,41.37,0.15,1380,52803,NULL,NULL,'SIFTO','LSSP J141956.04+530553.5',0.3553,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,214.9835,53.09819,0,NULL,59198175019,924971484,14452679,NULL),(119375,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 03D3bl',NULL,119375,41.39,NULL,1400,52803,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','LSSP J141956.04+530553.5',0.3553,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119376,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 03D3bl',NULL,119376,41.83,0.17,1710,52803,NULL,NULL,'SALT2','LSSP J141956.04+530553.5',0.3553,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119377,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 03D3bl',NULL,119377,42.92,0.03,2830,52803,70,NULL,'SIFTO','LSSP J141956.04+530553.5',0.3553,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119378,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119378,35.7,0.25,138,52804,74.4,NULL,NULL,'2MASX J14195603-2728185',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00015,NULL,'15.9b',NULL,'E',NULL,NULL,NULL,NULL,1,214.9835417,-27.47175,0.221,NULL,47034490933,734913920,11483030,15.9),(119379,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119379,38.21,0.46,438,52805,70,NULL,NULL,'2MASX J14195626+4508052',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,214.984291667,45.13467,0,NULL,59230439161,925475611,14460556,17.8),(119380,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119380,38.31,0.46,460,52806,70,NULL,NULL,'2MASX J14195678+0122155',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,214.986583,1.37106,0.065,NULL,58287322578,910739415,14230303,17.5),(119381,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119381,35.57,0.46,130,52807,70,NULL,NULL,'2MASX J14195689+3007022',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.52',0.22,NULL,NULL,NULL,NULL,NULL,1,214.987083,30.11736,0,NULL,60062325766,938473840,14663653,17.52),(119382,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119382,37.65,0.17,339,52808,70,NULL,NULL,'2MASX J14195713+5623285',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.98825,56.39117,0,NULL,57256460848,894632200,13978628,17.3),(119383,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119383,38.08,0.46,413,52809,70,NULL,NULL,'SDSS J141957.43+030404.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000065,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,214.9892917,3.06786,0.049,NULL,58293554172,910836783,14231824,18.3),(119384,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119384,34.97,0.8,98.4,52810,75,NULL,'HMCL, I','CGCG 075-010',NULL,'1997ApJS..109..333W',1997,1,0.98,NULL,'G',0.00007,NULL,'16.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.991416667,11.96208,0,NULL,58485669211,913838581,14278727,16.3),(119385,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119385,35.05,0.49,102,52810,75,NULL,'IR','CGCG 075-010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119386,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119386,35.07,0.4,103,52810,75,NULL,'HMCL, I, raw','CGCG 075-010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119387,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119387,35.15,0.4,107,52810,75,NULL,'HMCL, I, inv','CGCG 075-010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119388,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119388,35.23,0.4,111,52810,75,NULL,'HMCL, I, cor','CGCG 075-010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119389,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119389,37.84,0.46,369,52811,70,NULL,NULL,'2MASX J14195986-0059254',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,214.999208333,-0.99044,0.149,NULL,43507454691,679803979,10621937,17.1),(119390,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119390,35.32,0.46,116,52812,70,NULL,NULL,'2MASX J14200010+1018122',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,215.0002917,10.30342,0,NULL,58488195309,913878051,14279344,16.1),(119391,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119391,37.93,0.46,385,52813,70,NULL,NULL,'2MASX J14200027+3600155',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.0010417,36.00444,0,NULL,60042999032,938171859,14658935,18),(119392,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119392,37.4,0.15,302,52814,70,NULL,NULL,'2MASX J14200099+3019552',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.004333333,30.33206,0,NULL,60062310263,938473597,14663649,16.9),(119393,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119393,36.71,0.65,220,52815,70,NULL,NULL,'2MASX J14200206-3458403',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,215.008625,-34.97794,0.169,NULL,47009114427,734517412,11476834,14),(119394,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kp',NULL,119394,42.91,0.06,2060,52816,70,NULL,'SIFTO','SNLS 05D3kp HOST',0.85,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.0122917,52.27092,0.005,NULL,59195959655,924936869,14452138,NULL),(119395,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kp',NULL,119395,43.78,0.19,3080,52816,70,NULL,'SALT 2','SNLS 05D3kp HOST',0.85,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119396,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kp',NULL,119396,43.79,0.15,3090,52816,NULL,NULL,'SIFTO','SNLS 05D3kp HOST',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119397,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kp',NULL,119397,45.47,0.17,6710,52816,NULL,NULL,'SALT2','SNLS 05D3kp HOST',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119398,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119398,37.15,0.27,269,52817,70,NULL,NULL,'2MASX J14200390+5548354',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.016375,55.80981,0.005,NULL,57255376699,894615260,13978363,17.1),(119399,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119399,31.37,0.47,18.8,52818,NULL,NULL,'H','NGC 5560',NULL,'2007A&A...465...71T',2007,1,3.7,NULL,'G',0.00001,NULL,'13.2',0.7,'SB(s)b pec','in an interacting triple',NULL,NULL,NULL,1,215.018708333,3.99247,0.057,NULL,58294199971,910846874,14231982,13.2),(119400,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119400,31.43,0.46,19.3,52818,NULL,NULL,'J','NGC 5560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119401,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119401,31.44,0.45,19.4,52818,NULL,NULL,'K','NGC 5560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119402,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119402,31.56,NULL,20.5,52818,72,NULL,NULL,'NGC 5560',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119403,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119403,31.59,0.49,20.8,52818,75,NULL,'IR','NGC 5560',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119404,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119404,31.97,0.4,24.8,52818,NULL,NULL,'mean','NGC 5560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119405,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119405,36.77,0.46,226,52819,70,NULL,NULL,'2MASX J14200682+6209117',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.0287083,62.15333,0.029,NULL,57763019468,902547179,14102299,16.9),(119406,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119406,38.4,0.46,478,52820,70,NULL,NULL,'SDSS J142009.20+214351.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.038375,21.731,0.036,NULL,59514446435,929913225,14529894,17.7),(119407,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119407,37.05,0.46,257,52821,70,NULL,NULL,'2MASX J14200918+2143521',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.97',0.31,NULL,NULL,NULL,NULL,NULL,1,215.043375,21.73564,0.036,NULL,59514446366,929913224,14529894,16.97),(119408,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119408,37.47,0.46,312,52822,70,NULL,NULL,'SDSS J142010.53+184121.9',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.043875,18.68942,0,NULL,59518391193,929974862,14530857,17.1),(119409,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119409,37.82,0.46,366,52823,70,NULL,NULL,'2MASX J14201204+2130151',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.13',0.2,NULL,NULL,NULL,NULL,NULL,1,215.050333,21.50419,0.028,NULL,59522009177,930031393,14531740,18.13),(119410,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119410,37.4,0.15,302,52824,70,NULL,NULL,'2MASX J14201230+3023258',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.0512917,30.39061,0,NULL,60062317638,938473713,14663651,17.4),(119411,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119411,35.22,0.46,111,52825,70,NULL,NULL,'NGC 5563',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.00017,NULL,'14.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,215.0545417,7.05542,0.045,NULL,58494211107,913972048,14280813,14.8),(119412,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx','R',119412,43.13,NULL,2210,52826,65,NULL,'MLCS17','[HSP2005] J142013.67+521658.60',0.91,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.057,52.28294,0.005,NULL,59195959501,924936867,14452138,NULL),(119413,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119413,43.6,0.27,2750,52826,74.2,NULL,'SALT 2','[HSP2005] J142013.67+521658.60',0.91,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119414,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119414,43.61,0.08,2760,52826,70,NULL,'MLCS17','[HSP2005] J142013.67+521658.60',0.91,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119415,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119415,43.73,0.17,2920,52826,NULL,NULL,'SALT2','[HSP2005] J142013.67+521658.60',0.91,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119416,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119416,44.11,0.23,3480,52826,70,NULL,'SALT 2','[HSP2005] J142013.67+521658.60',0.91,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119417,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119417,44.17,0.19,3570,52826,65,NULL,'MLCS17','[HSP2005] J142013.67+521658.60',0.91,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119418,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119418,44.18,0.15,3590,52826,NULL,NULL,'SIFTO','[HSP2005] J142013.67+521658.60',0.91,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119419,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119419,44.19,0.17,3610,52826,65,NULL,'MLCS2k2','[HSP2005] J142013.67+521658.60',0.91,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119420,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119420,44.21,0.15,3630,52826,65,NULL,'MLCS2k2','[HSP2005] J142013.67+521658.60',0.91,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119421,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119421,44.21,0.17,3630,52826,65,NULL,'MLCS31','[HSP2005] J142013.67+521658.60',0.91,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119422,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119422,44.26,0.35,3720,52826,70,NULL,NULL,'[HSP2005] J142013.67+521658.60',0.91,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119423,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119423,44.41,0.39,3990,52826,70,NULL,'SALT','[HSP2005] J142013.67+521658.60',0.91,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119424,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119424,44.44,0.27,4050,52826,65,NULL,'SALT2','[HSP2005] J142013.67+521658.60',0.91,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119425,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119425,44.53,0.23,4210,52826,65,NULL,'SALT','[HSP2005] J142013.67+521658.60',0.91,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119426,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119426,44.63,0.36,4420,52826,65,NULL,'SALT','[HSP2005] J142013.67+521658.60',0.91,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119427,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3gx',NULL,119427,44.7,0.47,4560,52826,65,NULL,'SALT2','[HSP2005] J142013.67+521658.60',0.91,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119428,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119428,38.63,0.46,532,52827,70,NULL,NULL,'2MASX J14201374+2112381',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,215.0572917,21.2105,0.028,NULL,59522173606,930033962,14531780,18.31),(119429,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119429,38.82,0.46,581,52828,70,NULL,NULL,'2MASX J14201385+2153371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.2E',NULL,NULL,NULL,NULL,NULL,NULL,1,215.057667,21.89378,0.036,NULL,59514472175,929913627,14529900,16.2),(119430,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119430,37.91,0.46,381,52829,70,NULL,NULL,'2MASX J14201426+0544455',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.67',0.16,NULL,NULL,NULL,NULL,NULL,1,215.059583,5.74597,0.033,NULL,58292487074,910820110,14231564,18.67),(119431,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119431,32.74,0.4,35.3,52830,75,NULL,'Edat, raw','ESO 446- G 049',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.03',1,'SA(r)0^+:',NULL,NULL,NULL,NULL,1,215.0602083,-29.74747,0.397,NULL,47043271605,735051118,11485173,14.03),(119432,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119432,33.07,0.4,41.2,52830,75,NULL,'Edat, cor','ESO 446- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119433,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119433,33.03,0.51,40.3,52830,70,NULL,NULL,'ESO 446- G 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119434,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119434,33.67,0.45,54.3,52830,NULL,NULL,'K','ESO 446- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119435,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119435,33.69,0.4,54.6,52830,NULL,NULL,'mean','ESO 446- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119436,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119436,36.82,0.46,231,52831,70,NULL,NULL,'2MASX J14201586+6019147',NULL,'2015arXiv151105856S',2015,1,0.36,'This galaxy lenses a z = 0.535 object.','G',0.000174,NULL,'16.6g',0.26,'S0',NULL,NULL,NULL,NULL,1,215.066083333,60.32075,0,NULL,57753788688,902402948,14100046,16.6),(119437,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119437,37.86,0.46,373,52832,70,NULL,NULL,'2MASX J14201619+0051205',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000082,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.067583333,0.85583,0.057,NULL,58288101386,910751584,14230493,17.3),(119438,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119438,36.36,0.46,187,52833,70,NULL,NULL,'2MASX J14201651+0307595',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00007,NULL,'16.3g',0.36,'S0',NULL,NULL,NULL,NULL,1,215.068791667,3.13319,0.049,NULL,58294404270,910850066,14232032,16.3),(119439,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119439,38.01,0.46,400,52834,70,NULL,NULL,'2MASX J14201682+6248546',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00012,NULL,'16.7g',0.31,'HII',NULL,NULL,NULL,NULL,1,215.0704583,62.81508,0.041,NULL,57761223460,902519116,14101861,16.7),(119440,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119440,37.26,0.46,284,52835,70,NULL,NULL,'SDSS J142017.23-003911.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000066,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.071833333,-0.65317,0.137,NULL,43506904306,679795379,10621802,18.4),(119441,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119441,37.47,0.07,312,52836,70,NULL,NULL,'2MASX J14201838+4848032',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.076417,48.80097,0.031,NULL,59247851568,925747680,14464807,16.9),(119442,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119442,40.58,0.15,1030,52837,NULL,NULL,'SIFTO','SNLS 06D3fp',0.268,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.0775,52.89717,0,NULL,59197966698,924968229,14452628,NULL),(119443,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119443,40.61,0.11,1040,52837,70,NULL,'SALT 2','SNLS 06D3fp',0.268,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119444,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119444,40.62,NULL,1050,52837,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 06D3fp',0.268,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119445,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119445,40.82,0.17,1150,52837,NULL,NULL,'SALT2','SNLS 06D3fp',0.268,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119446,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3fp',NULL,119446,41.29,0.03,1430,52837,70,NULL,'SIFTO','SNLS 06D3fp',0.268,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119447,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119447,38.62,0.46,529,52838,70,NULL,NULL,'SDSS J142018.91+013102.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000086,NULL,'18.2g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,215.078833,1.51736,0.061,NULL,58287292869,910738951,14230296,18.2),(119448,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nq',NULL,119448,40.25,0.15,919,52839,NULL,NULL,'SIFTO','[HSP2005] J142019.19+530915.90',0.22,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.0799583,53.15442,0,NULL,59198168099,924971376,14452677,NULL),(119449,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nq',NULL,119449,41.07,0.17,1340,52839,NULL,NULL,'SALT2','[HSP2005] J142019.19+530915.90',0.22,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119450,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119450,35.57,0.2,130,52840,74.4,NULL,NULL,'KUG 1417+091',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000098,NULL,'15.9g',0.38,'Spiral',NULL,NULL,NULL,NULL,1,215.08,8.9275,0.038,NULL,58494906769,913982918,14280983,15.9),(119451,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119451,36.1,0.46,166,52841,70,NULL,NULL,'2MASX J14201947+2355229',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.081167,23.92306,0,NULL,59513376934,929896514,14529633,17.1),(119452,'Ring Diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119452,31.2,0.76,17,52842,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5566',NULL,'1981ApJS...45..541P',1981,1,6.6,NULL,'G',0.000013,NULL,'11.46',2.2,'SB(r)ab        LINER','in an interacting triple',NULL,NULL,NULL,1,215.082875,3.93375,0.057,NULL,58294148928,910846077,14231969,11.46),(119453,'Ring Diameter','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119453,31.4,0.6,19,52842,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5566',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119454,'Tully est','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119454,32.11,0.8,26.4,52842,75,NULL,'B','NGC 5566',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119455,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119455,31.52,0.38,20.1,52842,NULL,NULL,NULL,'NGC 5566',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119456,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119456,31.69,NULL,21.8,52842,72,NULL,NULL,'NGC 5566',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119457,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119457,31.85,0.3,23.5,52842,55,NULL,'B','NGC 5566',NULL,'2000A&A...355..835E',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119458,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119458,37.06,0.46,259,52843,70,NULL,NULL,'2MASX J14202116+3412598',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000195,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,215.0880417,34.21667,0,NULL,60041824989,938153515,14658648,16),(119459,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119459,37.36,0.46,296,52844,70,NULL,NULL,'2MASX J14202129+0750181',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.088583333,7.83833,0.041,NULL,58497458829,914022794,14281606,17.2),(119460,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119460,35.13,0.8,106,52845,75,NULL,'HMCL, I','CGCG 075-013',NULL,'1997ApJS..109..333W',1997,1,0.83,NULL,'G',0.00007,NULL,'16.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.0947917,11.38447,0,NULL,58489334352,913895849,14279622,16.3),(119461,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119461,35.41,0.4,121,52845,75,NULL,'HMCL, I, raw','CGCG 075-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119462,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119462,35.49,0.2,125,52845,74.4,NULL,NULL,'CGCG 075-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119463,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119463,35.51,0.4,126,52845,75,NULL,'HMCL, I, inv','CGCG 075-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119464,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119464,35.57,0.4,130,52845,75,NULL,'HMCL, I, cor','CGCG 075-013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119465,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119465,35.33,0.62,116,52846,70,NULL,NULL,'2MASX J14202327-1707260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.097041667,-17.12386,0.317,NULL,46553129435,727392647,11365510,15.3),(119466,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119466,37.4,0.15,302,52847,70,NULL,NULL,'2MASX J14202359+3011448',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.72',0.34,NULL,NULL,NULL,NULL,NULL,1,215.098417,30.19594,0,NULL,60062366245,938474472,14663663,16.72),(119467,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp','R',119467,42.57,NULL,1790,52848,65,NULL,'MLCS31','[AGR2006] J142023.95+524915.4',0.83,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.0997917,52.82094,0,NULL,59197978349,924968411,14452631,NULL),(119468,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119468,42.69,0.06,1880,52848,70,NULL,'MLCS31','[AGR2006] J142023.95+524915.4',0.83,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119469,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119469,43.33,0.21,2530,52848,74.2,NULL,'SALT 2','[AGR2006] J142023.95+524915.4',0.83,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119470,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119470,43.61,0.15,2880,52848,65,NULL,'MLCS31','[AGR2006] J142023.95+524915.4',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119471,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119471,43.62,0.13,2890,52848,65,NULL,'MLCS2k2','[AGR2006] J142023.95+524915.4',0.83,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119472,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119472,43.66,0.16,2950,52848,65,NULL,'MLCS17','[AGR2006] J142023.95+524915.4',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119473,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119473,43.87,0.15,3250,52848,NULL,NULL,'SIFTO','[AGR2006] J142023.95+524915.4',0.83,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119474,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119474,43.9,0.09,3290,52848,65,NULL,'MLCS2k2','[AGR2006] J142023.95+524915.4',0.83,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119475,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119475,43.97,NULL,3410,52848,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J142023.95+524915.4',0.83,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119476,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119476,44.07,0.21,3550,52848,70,NULL,'SALT 2','[AGR2006] J142023.95+524915.4',0.83,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119477,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119477,44.3,0.18,3960,52848,65,NULL,'SALT2','[AGR2006] J142023.95+524915.4',0.83,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119478,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119478,44.41,0.35,4170,52848,70,NULL,NULL,'[AGR2006] J142023.95+524915.4',0.83,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119479,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119479,44.68,0.24,4720,52848,65,NULL,'SALT','[AGR2006] J142023.95+524915.4',0.83,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119480,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119480,44.69,0.46,4740,52848,70,NULL,'SALT','[AGR2006] J142023.95+524915.4',0.83,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119481,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119481,44.84,0.5,5090,52848,65,NULL,'SALT2','[AGR2006] J142023.95+524915.4',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119482,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119482,45.01,0.44,5480,52848,65,NULL,'SALT','[AGR2006] J142023.95+524915.4',0.83,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119483,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3cp',NULL,119483,45.05,0.17,5580,52848,NULL,NULL,'SALT2','[AGR2006] J142023.95+524915.4',0.83,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119484,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119484,36.81,0.46,231,52849,70,NULL,NULL,'2MASX J14202526+5440162',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.105166667,54.67114,0.013,NULL,57256138693,894627167,13978549,16.5),(119485,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119485,37.6,0.21,331,52850,70,NULL,NULL,'2MASX J14202592+2530249',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.107833,25.50694,0,NULL,59999648460,937494507,14648351,17.7),(119486,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119486,32.64,0.53,33.8,52851,NULL,NULL,NULL,'NGC 5579',NULL,'2009ApJS..182..474S',2009,1,1.22,NULL,'G',0.00002,NULL,'14.5g',0.93,'SABcd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,215.110333,35.18881,0,NULL,60043166344,938174474,14658976,14.5),(119487,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119487,32.77,0.5,35.7,52851,NULL,NULL,'Malmquist cor.','NGC 5579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119488,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119488,38.07,0.46,410,52852,70,NULL,NULL,'2MASX J14202896+1213397',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.12075,12.22767,0,NULL,58351780845,911746575,14246040,17.1),(119489,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119489,38.15,0.46,428,52853,70,NULL,NULL,'SDSS J142030.05+024620.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.12525,2.77231,0.049,NULL,58298594792,910915543,14233055,18.1),(119490,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119490,36.73,0.46,221,52854,70,NULL,NULL,'I Zw 083',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.132416667,51.48208,0,NULL,59195457293,924929020,14452015,16.3),(119491,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119491,37.24,0.46,281,52855,70,NULL,NULL,'2MASX J14203206+0203514',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.0g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,215.133625,2.06431,0.057,NULL,58298102188,910907846,14232935,17),(119492,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119492,31.2,0.4,17.4,52856,NULL,NULL,NULL,'NGC 5569',NULL,'2009AJ....138..323T',2009,1,1.7,NULL,'G',0.00001,NULL,'14.9g',1.4,'SAB(rs)cd:','in an interacting triple',NULL,NULL,NULL,1,215.1337083,3.98322,0.057,NULL,58296184193,910877878,14232466,14.9),(119493,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119493,36.8,0.46,229,52857,70,NULL,NULL,'2MASX J14203280+0506384',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000085,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.136833,5.11064,0.021,NULL,58293445427,910835084,14231798,16.6),(119494,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119494,37.6,0.21,331,52858,70,NULL,NULL,'2MASX J14203287+2520390',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00008,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,215.137083,25.34411,0,NULL,59999752624,937496134,14648377,15.9),(119495,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119495,35.05,0.5,103,52859,NULL,NULL,'Malmquist cor.','ESO 385- G 011',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.9b',0.8,'Sb',NULL,NULL,NULL,NULL,1,215.13925,-33.34606,0.249,NULL,47005705220,734464144,11476002,14.9),(119496,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119496,35.23,0.46,111,52859,NULL,NULL,NULL,'ESO 385- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119497,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119497,35.27,0.2,113,52859,74.4,NULL,NULL,'ESO 385- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119498,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119498,35.28,0.4,114,52859,NULL,NULL,'mean','ESO 385- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119499,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119499,35.55,0.47,129,52859,NULL,NULL,'H','ESO 385- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119500,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119500,34.8,0.47,91,52860,70,NULL,NULL,'2MASX J14203344-2854292',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.0001,NULL,'14.9b',NULL,'*+E',NULL,NULL,NULL,NULL,1,215.139375,-28.90811,0.309,NULL,47042585469,735040397,11485006,14.9),(119501,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119501,36.49,0.46,199,52861,70,NULL,NULL,'2MASX J14203397+0322114',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000078,NULL,'17.2g',0.22,'E2',NULL,NULL,NULL,NULL,1,215.141625,3.36989,0.037,NULL,58293915262,910842425,14231912,17.2),(119502,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119502,31.03,0.2,16.1,52862,74.4,NULL,NULL,'NGC 5556',NULL,'2013AJ....146...86T',2013,1,4,NULL,'G',0.000007,NULL,'12.43',3.2,'SAB(rs)d','Parent (of companion) galaxy',NULL,NULL,NULL,1,215.1420417,-29.24178,0.309,NULL,47042774052,735043344,11485052,12.43),(119503,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119503,31.1,0.4,16.6,52862,NULL,NULL,NULL,'NGC 5556',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119504,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119504,31.61,0.4,20.9,52862,75,NULL,'B','NGC 5556',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119505,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119505,37.64,0.46,337,52863,70,NULL,NULL,'2MASX J14203409+2049016',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.57',0.16,NULL,NULL,NULL,NULL,NULL,1,215.142166667,20.81717,0.024,NULL,59521708168,930026690,14531667,18.57),(119506,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119506,37.99,0.27,396,52864,70,NULL,NULL,'SDSS J142034.61+430825.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.1442083,43.14028,0,NULL,59224831457,925387991,14459187,18.4),(119507,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119507,37.12,0.46,266,52865,70,NULL,NULL,'2MASX J14203519-0124486',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.146541667,-1.41344,0.125,NULL,43506694843,679792106,10621751,16.6),(119508,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119508,37.6,0.21,331,52866,70,NULL,NULL,'2MASX J14203525+2509201',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.69',0.23,NULL,NULL,NULL,NULL,NULL,1,215.147,25.15556,0,NULL,59999766771,937496355,14648380,17.69),(119509,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119509,37.82,0.46,367,52867,70,NULL,NULL,'2MASX J14203565+1456517',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.148667,14.94758,0,NULL,59478226713,929347292,14521051,17.9),(119510,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119510,37.04,0.58,256,52868,70,NULL,NULL,'2MASX J14203601-1918296',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,215.150333333,-19.30825,0.321,NULL,46563660797,727557199,11368081,16.2),(119511,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119511,37.23,0.33,280,52869,70,NULL,NULL,'2MASX J14203749+4709384',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000191,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.156125,47.16078,0.061,NULL,59246939576,925733430,14464584,16.4),(119512,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119512,38.04,0.19,405,52870,70,NULL,NULL,'SDSS J142038.29+402445.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,215.159583,40.41258,0,NULL,59946008094,936656376,14635255,18.7),(119513,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119513,37.88,0.46,377,52871,70,NULL,NULL,'2MASX J14203876+5111451',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.161667,51.196,0,NULL,59195408533,924928258,14452004,17.5),(119514,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119514,37.4,0.15,302,52872,70,NULL,NULL,'2MASX J14203974+3037089',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,215.165583,30.61922,0,NULL,60061007006,938453234,14663331,18.38),(119515,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119515,38.04,0.19,405,52873,70,NULL,NULL,'2MASX J14203971+4025468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.165583,40.42975,0,NULL,59946008228,936656378,14635255,17.8),(119516,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119516,37.47,0.07,312,52874,70,NULL,NULL,'2MASX J14203980+4815111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.16575,48.25308,0,NULL,59247812715,925747073,14464798,17.4),(119517,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119517,37.4,0.15,302,52875,70,NULL,NULL,'2MASX J14204147+3024169',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.1729583,30.40461,0,NULL,60061457300,938460270,14663441,17.8),(119518,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119518,37.3,0.46,288,52876,70,NULL,NULL,'2MASX J14204159+3811528',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.17325,38.19803,0,NULL,60062704079,938479751,14663746,16.9),(119519,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119519,37.76,0.46,357,52877,70,NULL,NULL,'2MASX J14204177+0549294',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.174083,5.82486,0.033,NULL,58300855342,910950864,14233607,17.2),(119520,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119520,34.91,0.49,96,52878,75,NULL,'IR','ESO 511- G 033',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000037,NULL,'14.93',0.3,'SAb? sp        HII',NULL,NULL,NULL,NULL,1,215.174666667,-27.38542,0.245,NULL,47034774958,734918358,11483099,14.93),(119521,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119521,34.92,0.47,96.4,52878,NULL,NULL,'H','ESO 511- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119522,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119522,34.96,0.45,98.3,52878,NULL,NULL,'K','ESO 511- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119523,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119523,35.18,0.46,109,52878,NULL,NULL,'J','ESO 511- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119524,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119524,35.32,0.4,116,52878,NULL,NULL,'mean','ESO 511- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119525,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119525,32.24,0.14,28.1,52879,74.4,NULL,NULL,'NGC 5582',NULL,'2013AJ....146...86T',2013,1,2.8,NULL,'G',0.000017,NULL,'12.48',1.7,'E','Field galaxy',NULL,NULL,NULL,1,215.179667,39.69358,0,NULL,60063296142,938489002,14663890,12.48),(119526,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119526,32.27,0.23,28.4,52879,NULL,NULL,'I','NGC 5582',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119527,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119527,32.27,0.23,28.4,52879,NULL,NULL,NULL,'NGC 5582',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119528,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119528,32.42,0.23,30.5,52879,NULL,NULL,'Malmquist cor.','NGC 5582',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119529,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119529,32.35,0.4,29.5,52879,75,NULL,'Edat, raw','NGC 5582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119530,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119530,32.68,0.4,34.4,52879,75,NULL,'Edat, cor','NGC 5582',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119531,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119531,32.28,0.41,28.6,52879,NULL,NULL,NULL,'NGC 5582',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119532,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119532,32.65,0.41,33.9,52879,NULL,NULL,'Malmquist cor.','NGC 5582',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119533,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119533,32.13,0.4,26.6,52879,NULL,NULL,'mean','NGC 5582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119534,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119534,32.36,0.45,29.6,52879,NULL,NULL,'K','NGC 5582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119535,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3cb',NULL,119535,44.9,0.17,4680,52880,NULL,NULL,'SALT2','SNLS 06D3cb HOST',1.037,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,'PHOT','23.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.181667,52.19081,0,NULL,59195950087,924936720,14452136,23.9),(119536,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119536,35.52,0.66,127,52881,70,NULL,NULL,'2MASX J14204359-4800051',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,215.181667,-48.00142,0.797,NULL,46837335269,731833363,11434896,16.9),(119537,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119537,37.79,0.46,362,52882,70,NULL,NULL,'2MASX J14204371+0533514',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.182333,5.56436,0.033,NULL,58292658795,910822793,14231606,16.7),(119538,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119538,35.91,0.46,152,52883,70,NULL,NULL,'CGCG 075-016',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000187,NULL,'15.4g',0.47,NULL,NULL,NULL,NULL,NULL,1,215.1837083,8.984,0.031,NULL,58495046465,913985101,14281017,15.4);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (119539,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119539,32,NULL,25.1,52884,72,NULL,NULL,'SDSS J142044.53+083735.8',NULL,'2014Ap.....57..457K',2014,1,0.76,NULL,'G',0.000039,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.1855417,8.62664,0.041,NULL,58495693157,913995205,14281175,16.5),(119540,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119540,36.9,0.46,240,52885,70,NULL,NULL,'2MASX J14204528+2258486',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.188833,22.98025,0.047,NULL,59516884556,929951321,14530489,17.4),(119541,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119541,36.65,0.46,214,52886,70,NULL,NULL,'2MASX J14204569+5841562',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,215.190375,58.69894,0.005,NULL,57303583231,895368487,13990132,16.4),(119542,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119542,39.11,0.46,663,52887,70,NULL,NULL,'LCRS B141810.3-023743',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.191375,-2.85692,0.137,NULL,43518976040,679984000,10624750,18.3),(119543,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119543,37.48,0.46,313,52888,70,NULL,NULL,'2MASX J14204595+2656141',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.86',0.24,NULL,NULL,NULL,NULL,NULL,1,215.191625,26.93719,0,NULL,60057583492,938399742,14662495,17.86),(119544,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119544,33.24,0.49,44.5,52889,75,NULL,'IR','UGC 09182',NULL,'2011yCatp016004901K',2011,1,2.02,'HOLM 633B is a star.','G',0.000022,NULL,'14.3g',0.47,'Sd','Isolated galaxy',NULL,NULL,NULL,1,215.192167,21.93575,0.014,NULL,59514544773,929914762,14529918,14.3),(119545,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119545,33.27,0.2,45.1,52889,74.4,NULL,NULL,'UGC 09182',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119546,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119546,33.45,0.47,48.9,52889,NULL,NULL,NULL,'UGC 09182',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119547,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119547,33.69,0.42,54.6,52889,NULL,NULL,'Malmquist cor.','UGC 09182',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119548,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119548,34.04,0.47,64.4,52889,NULL,NULL,'H','UGC 09182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119549,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119549,34.23,0.4,70,52889,NULL,NULL,'mean','UGC 09182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119550,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119550,34.29,0.46,72.2,52889,NULL,NULL,'J','UGC 09182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119551,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119551,34.34,0.45,73.9,52889,NULL,NULL,'K','UGC 09182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119552,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119552,37.47,0.07,312,52890,70,NULL,NULL,'SDSS J142046.48+484429.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.1937083,48.74147,0.028,NULL,59247870520,925747976,14464812,17.6),(119553,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119553,36.05,0.49,162,52891,70,NULL,NULL,'2MASX J14204764-1947456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.66',NULL,NULL,NULL,NULL,NULL,NULL,1,215.198667,-19.79592,0.329,NULL,46571944000,727686625,11370103,15.66),(119554,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119554,38.44,0.46,488,52892,70,NULL,NULL,'SDSS J142049.58+511026.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.206667,51.17408,0,NULL,59195293874,924926466,14451976,18.4),(119555,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119555,37.47,0.07,312,52893,70,NULL,NULL,'2MASX J14204999+4823042',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.2082083,48.3845,0,NULL,59247785285,925746645,14464791,17.3),(119556,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dh',NULL,119556,42.98,0.23,2190,52894,70,NULL,'SALT 2','SNLS 05D3dh',0.8,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,215.21,52.66272,0,NULL,59197954014,924968031,14452625,NULL),(119557,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dh',NULL,119557,43.27,0.15,2500,52894,NULL,NULL,'SIFTO','SNLS 05D3dh',0.8,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119558,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dh',NULL,119558,43.42,0.17,2690,52894,NULL,NULL,'SALT2','SNLS 05D3dh',0.8,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119559,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dh',NULL,119559,43.65,0.06,2980,52894,70,NULL,'SIFTO','SNLS 05D3dh',0.8,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119560,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ha',NULL,119560,43.16,0.22,2380,52895,70,NULL,'SALT 2','SNLS 05D3ha',0.805,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.210125,52.83403,0,NULL,59198250425,924972662,14452697,NULL),(119561,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ha',NULL,119561,43.29,0.17,2520,52895,NULL,NULL,'SALT2','SNLS 05D3ha',0.805,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119562,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ha',NULL,119562,43.3,0.15,2540,52895,NULL,NULL,'SIFTO','SNLS 05D3ha',0.805,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119563,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ha',NULL,119563,43.92,0.07,3370,52895,70,NULL,'SALT2','SNLS 05D3ha',0.805,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119564,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119564,37.4,0.46,302,52896,70,NULL,NULL,'2MASX J14205119+6254495',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000145,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.21325,62.91364,0.041,NULL,57761258032,902519656,14101869,17.4),(119565,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119565,38.04,0.19,405,52897,70,NULL,NULL,'2MASX J14205198+4021439',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000193,NULL,'16.0g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,215.216625,40.36214,0,NULL,59945994479,936656163,14635252,16),(119566,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119566,37.47,0.07,312,52898,70,NULL,NULL,'2MASX J14205223+4849092',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.217458333,48.81928,0.031,NULL,59247849701,925747651,14464807,16.9),(119567,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119567,37.03,0.71,254,52899,70,NULL,NULL,'2MASX J14205248-4535086',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,215.21875,-45.58581,0.305,NULL,46803445024,731303828,11426622,17.3),(119568,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119568,35.81,0.2,145,52900,74.4,NULL,NULL,'UGC 09185',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,215.2222917,15.00075,0,NULL,59478213674,929347088,14521048,15.2),(119569,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp','R',119569,40.99,NULL,1090,52901,65,NULL,'SNLS 03D3aw, MLCS17','LSSP J142053.55+523620.4',0.449,'2010arXiv1006.2112L',2010,1,0.06,NULL,'G',0.001,NULL,'21.7g',0.03,NULL,NULL,NULL,NULL,NULL,1,215.22275,52.60561,0,NULL,59197963923,924968186,14452627,21.7),(119570,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119570,41.29,0.16,1250,52901,74.2,NULL,'SALT 2','LSSP J142053.55+523620.4',0.449,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119571,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119571,41.6,0.05,1450,52901,70,NULL,'SNLS 03D3aw, MLCS17','LSSP J142053.55+523620.4',0.449,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119572,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119572,41.87,0.03,1630,52901,70,NULL,'SNLS 03D3aw','LSSP J142053.55+523620.4',0.449,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119573,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119573,41.9,0.15,1660,52901,70,NULL,'SNLS 03D3aw, SALT','LSSP J142053.55+523620.4',0.449,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119574,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119574,41.97,0.15,1710,52901,65,NULL,'SNLS 03D3aw, SALT2','LSSP J142053.55+523620.4',0.449,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119575,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119575,42.06,0.21,1780,52901,65,NULL,'SNLS 03D3aw, MLCS17','LSSP J142053.55+523620.4',0.449,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119576,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119576,42.07,0.16,1790,52901,70,NULL,'SNLS 03D3aw, SALT 2','LSSP J142053.55+523620.4',0.449,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119577,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119577,42.07,0.2,1790,52901,65,NULL,'SNLS 03D3aw, MLCS2k2','LSSP J142053.55+523620.4',0.449,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119578,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119578,42.07,0.22,1790,52901,65,NULL,'SNLS 03D3aw, MLCS2k2','LSSP J142053.55+523620.4',0.449,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119579,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119579,42.07,0.23,1790,52901,65,NULL,'SNLS 03D3aw, MLCS31','LSSP J142053.55+523620.4',0.449,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119580,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119580,42.08,0.12,1800,52901,65,NULL,'SNLS 03D3aw, SALT','LSSP J142053.55+523620.4',0.449,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119581,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119581,42.13,0.03,1840,52901,65,NULL,'SNLS 03D3aw, SALT','LSSP J142053.55+523620.4',0.449,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119582,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119582,42.15,0.15,1860,52901,NULL,NULL,'SNLS 03D3aw, SIFTO','LSSP J142053.55+523620.4',0.449,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119583,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119583,42.18,0.19,1880,52901,65,NULL,'SNLS 03D3aw, SALT2','LSSP J142053.55+523620.4',0.449,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119584,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fp',NULL,119584,42.94,0.17,2670,52901,NULL,NULL,'SNLS 03D3aw, SALT2','LSSP J142053.55+523620.4',0.449,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119585,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119585,34.94,0.8,97.2,52902,75,NULL,'MAT, I','ESO 446- G 051',NULL,'1997ApJS..109..333W',1997,1,1.52,NULL,'G',0.000023,NULL,'16.14',0.21,'Sc',NULL,NULL,NULL,NULL,1,215.224125,-29.02197,0.325,NULL,47042578963,735040296,11485004,16.14),(119586,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119586,34.12,0.32,66.6,52902,85,NULL,'I, raw','ESO 446- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119587,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119587,34.13,0.32,67,52902,85,NULL,'I, inv','ESO 446- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119588,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119588,34.17,0.43,68.2,52902,75,NULL,'MAT, I, raw','ESO 446- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119589,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119589,34.27,0.43,71.5,52902,75,NULL,'MAT, I, inv','ESO 446- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119590,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119590,34.38,NULL,75.2,52902,NULL,NULL,NULL,'ESO 446- G 051',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119591,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119591,34.5,0.43,79.3,52902,75,NULL,'MAT, I, cor','ESO 446- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119592,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119592,34.63,NULL,84.5,52902,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 446- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119593,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119593,34.64,NULL,84.7,52902,NULL,NULL,'Dipole + Quadrupole','ESO 446- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119594,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119594,34.66,NULL,85.6,52902,NULL,NULL,'Dipole','ESO 446- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119595,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119595,34.71,0.49,87.3,52902,75,NULL,'IR','ESO 446- G 051',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119596,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119596,34.89,0.44,95.2,52902,NULL,NULL,'Malmquist cor.','ESO 446- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119597,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119597,34.96,0.2,98.2,52902,74.4,NULL,NULL,'ESO 446- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119598,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119598,34.98,0.42,99,52902,NULL,NULL,NULL,'ESO 446- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119599,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119599,35.06,0.43,103,52902,75,NULL,'3.6 micron, color corrected','ESO 446- G 051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119600,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119600,35.2,0.43,110,52902,75,NULL,'3.6 micron, color + selection bias corrected','ESO 446- G 051',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119601,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119601,33.94,0.8,61.3,52903,75,NULL,'HMCL, I','UGC 09186',NULL,'1997ApJS..109..333W',1997,1,0.95,NULL,'G',0.000027,NULL,'15.3g',0.34,'Sa',NULL,NULL,NULL,NULL,1,215.2252083,23.60275,0,NULL,59513499920,929898436,14529663,15.3),(119602,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119602,34,0.2,63.1,52903,74.4,NULL,NULL,'UGC 09186',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119603,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119603,34.14,0.4,67.2,52903,75,NULL,'HMCL, I, raw','UGC 09186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119604,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119604,34.2,0.4,69.3,52903,75,NULL,'HMCL, I, inv','UGC 09186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119605,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119605,34.29,0.4,72.2,52903,75,NULL,'HMCL, I, cor','UGC 09186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119606,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119606,37.37,0.46,298,52904,70,NULL,NULL,'2MASX J14205406+0151427',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.225417,1.86194,0.061,NULL,58297978396,910905912,14232904,16.4),(119607,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119607,38.34,0.46,466,52905,70,NULL,NULL,'SDSS J142055.00+011629.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000076,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.229167,1.275,0.065,NULL,58287442324,910741286,14230332,18.7),(119608,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119608,37.47,0.07,312,52906,70,NULL,NULL,'2MASX J14205581+4818352',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.232417,48.30972,0,NULL,59247781401,925746584,14464790,17.4),(119609,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119609,31.89,0.62,23.9,52907,NULL,NULL,'I','NGC 5574',NULL,'2001ApJ...546..681T',2001,1,1.6,NULL,'G',0.000017,NULL,'13.0g',1,'SB0-? sp','in a triple',NULL,NULL,NULL,1,215.2332083,3.238,0.037,NULL,58293931531,910842680,14231916,13),(119610,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119610,31.93,0.14,24.3,52907,74.4,NULL,NULL,'NGC 5574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119611,'Tully est','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119611,32.29,0.8,28.7,52907,75,NULL,'B','NGC 5574',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119612,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119612,31.2,0.45,17.4,52907,NULL,NULL,'K','NGC 5574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119613,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119613,32.06,0.4,25.8,52907,NULL,NULL,'mean','NGC 5574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119614,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119614,37.99,0.46,397,52908,70,NULL,NULL,'2MASX J14205619+1710220',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.23425,17.17289,0,NULL,59488122543,929501914,14523467,18.4),(119615,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119615,37.73,0.46,352,52909,70,NULL,NULL,'2MASX J14205677+3505120',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.2365,35.08675,0,NULL,60043173073,938174579,14658977,17.3),(119616,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119616,38.06,0.46,408,52910,70,NULL,NULL,'2MASX J14205729+2102105',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.36',0.18,NULL,NULL,NULL,NULL,NULL,1,215.238833,21.03619,0.019,NULL,59522033223,930031769,14531746,18.36),(119617,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119617,36.36,0.88,187,52911,70,NULL,NULL,'2MASX J14205760-8016096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,215.240167,-80.26931,0.433,NULL,44246902164,691357846,10802466,17.1),(119618,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119618,38.57,0.33,517,52912,70,NULL,NULL,'SDSS J142058.51+020542.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000085,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,215.2437917,2.09519,0.057,NULL,58298196801,910909325,14232958,18.8),(119619,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119619,36.43,0.56,193,52913,70,NULL,NULL,'2MASX J14205883-1955257',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'15.95',0.4,NULL,NULL,NULL,NULL,NULL,1,215.245125,-19.92389,0.329,NULL,46571737219,727683394,11370053,15.95),(119620,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119620,36.69,0.6,217,52914,70,NULL,NULL,'2MASX J14205921-1557545',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,215.2467083,-15.96517,0.261,NULL,46555529051,727430141,11366095,14.3),(119621,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3gv',NULL,119621,42.51,0.17,1850,52915,NULL,NULL,'SALT2','SNLS 05D3gv',0.715,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.246875,53.17889,0,NULL,59198390713,924974854,14452732,NULL),(119622,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3gv',NULL,119622,43.2,0.05,2550,52915,70,NULL,'SIFTO','SNLS 05D3gv',0.715,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119623,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3gv',NULL,119623,43.21,0.15,2550,52915,NULL,NULL,'SIFTO','SNLS 05D3gv',0.715,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119624,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3gv',NULL,119624,43.21,0.22,2550,52915,70,NULL,'SALT 2','SNLS 05D3gv',0.715,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119625,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119625,35.16,0.46,108,52916,70,NULL,NULL,'NGC 5575',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000067,NULL,'14.1g',0.9,'S0','Group member',NULL,NULL,NULL,1,215.2475417,6.20267,0.021,NULL,58271704073,910495376,14226490,14.1),(119626,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119626,36.79,0.65,229,52917,70,NULL,NULL,'2MASX J14210050-1635405',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,215.252125,-16.59461,0.241,NULL,46556023377,727437865,11366216,14.7),(119627,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119627,37.44,0.46,308,52918,70,NULL,NULL,'2MASX J14210114+1907035',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.254833,19.11758,0,NULL,59519148223,929986690,14531042,16.9),(119628,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119628,38.04,0.19,405,52919,70,NULL,NULL,'2MASX J14210169+4020159',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.25725,40.33789,0,NULL,59945928504,936655132,14635236,18),(119629,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119629,36.94,0.27,244,52920,70,NULL,NULL,'IC 1004',NULL,'2015arXiv151105856S',2015,1,0.3,'HOLM 634B is a star.','G',NULL,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,215.2595,17.70058,0,NULL,59486578234,929477784,14523090,15.4),(119630,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119630,37.89,0.17,324,52921,NULL,NULL,'SALT2','SDSS J142102.53+522942.7',0.169221,'2010A&A...523A...7G',2010,1,0.19,NULL,'G',0.000177,NULL,'18.1g',0.18,'a',NULL,NULL,NULL,NULL,1,215.260583,52.49519,0.005,NULL,59195931606,924936431,14452131,18.1),(119631,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119631,39.26,0.04,610,52921,70,NULL,'SALT2','SDSS J142102.53+522942.7',0.169221,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119632,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119632,39.63,0.15,720,52921,NULL,NULL,'SIFTO','SDSS J142102.53+522942.7',0.169221,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119633,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119633,39.64,0.12,724,52921,70,NULL,'SALT 2','SDSS J142102.53+522942.7',0.169221,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119634,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ne',NULL,119634,39.65,NULL,728,52921,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SDSS J142102.53+522942.7',0.169221,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119635,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119635,37.2,0.46,276,52922,70,NULL,NULL,'2MASX J14210319+0131247',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.2634583,1.5235,0.061,NULL,58287218753,910737793,14230278,17.5),(119636,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119636,37.01,0.46,252,52923,70,NULL,NULL,'2MASX J14210354+0602387',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.76',0.24,NULL,NULL,NULL,NULL,NULL,1,215.264708333,6.04419,0.033,NULL,58300871953,910951124,14233611,17.76),(119637,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119637,32.03,0.14,25.5,52924,74.4,NULL,NULL,'NGC 5576',NULL,'2013AJ....146...86T',2013,1,3.5,NULL,'G',0.000017,NULL,'11.85',2.2,'E3','in a triple',NULL,NULL,NULL,1,215.265333,3.271,0.037,NULL,58293949270,910842957,14231921,11.85),(119638,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119638,32.03,0.14,25.5,52924,NULL,NULL,'I','NGC 5576',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119639,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119639,32.03,0.14,25.5,52924,NULL,NULL,NULL,'NGC 5576',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119640,'SBF','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119640,32.05,0.14,25.7,52924,NULL,NULL,'Malmquist cor.','NGC 5576',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119641,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119641,31.39,0.4,19,52924,75,NULL,'Edat, raw','NGC 5576',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119642,'D-Sigma','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119642,31.61,0.4,21,52924,75,NULL,'Edat, cor','NGC 5576',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119643,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119643,30.02,0.63,10.1,52924,95,NULL,'Michard 1979b, c','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119644,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119644,30.18,0.81,10.9,52924,55,NULL,'Visvanathan & Sandage 1979','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119645,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119645,30.38,0.31,11.9,52924,95,NULL,'Weighted Mean','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119646,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119646,31.02,0.46,16,52924,95,NULL,'Michard 1979a','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119647,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119647,31.06,0.58,16.3,52924,95,NULL,'de Vaucouleurs','NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119648,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119648,31.74,0.41,22.3,52924,NULL,NULL,NULL,'NGC 5576',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119649,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119649,31.91,0.41,24.1,52924,NULL,NULL,'Malmquist cor.','NGC 5576',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119650,'Tertiary','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119650,30.95,0.21,15.5,52924,95,NULL,NULL,'NGC 5576',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119651,'Tully est','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119651,32.11,0.8,26.4,52924,75,NULL,'B','NGC 5576',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119652,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119652,31.9,0.45,24,52924,NULL,NULL,'K','NGC 5576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119653,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119653,32.06,0.4,25.8,52924,NULL,NULL,'mean','NGC 5576',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119654,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119654,37.47,0.07,312,52925,70,NULL,NULL,'2MASX J14210594+4818292',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000202,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.274833,48.30814,0,NULL,59248646793,925760106,14465001,16.5),(119655,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119655,37.23,0.33,280,52926,70,NULL,NULL,'2MASX J14210656+4713156',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.277417,47.22108,0.061,NULL,59246948807,925733575,14464587,16.9),(119656,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3cx',NULL,119656,42.71,0.06,1930,52927,70,NULL,'SIFTO','SNLS 05D3cx HOST',0.805,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'22.9R',NULL,'a',NULL,NULL,NULL,NULL,1,215.277625,52.75042,0,NULL,59198218434,924972163,14452690,22.9),(119657,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3cx',NULL,119657,43.51,0.15,2790,52927,NULL,NULL,'SIFTO','SNLS 05D3cx HOST',0.805,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119658,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3cx',NULL,119658,43.55,0.19,2840,52927,70,NULL,'SALT 2','SNLS 05D3cx HOST',0.805,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119659,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3cx',NULL,119659,44.54,0.17,4490,52927,NULL,NULL,'SALT2','SNLS 05D3cx HOST',0.805,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119660,'G Lens','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119660,45.68,0.17,7580,52927,NULL,NULL,'SNLS 05D3cx HOST','SNLS 05D3cx HOST',0.805,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119661,'Faber-Jackson','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119661,45.67,0.17,7540,52927,NULL,NULL,'SNLS 05D3cx HOST','SNLS 05D3cx HOST',0.805,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119662,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119662,37.88,0.46,377,52928,70,NULL,NULL,'SDSS J142106.81+443904.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.278375,44.65119,0,NULL,59230459012,925475922,14460561,18.1),(119663,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119663,33.11,0.58,41.8,52929,NULL,NULL,NULL,'MCG +06-32-004',NULL,'2009ApJS..182..474S',2009,1,0.65,NULL,'G',0.000008,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.283167,35.29539,0,NULL,60043302899,938176607,14659009,16.4),(119664,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119664,33.15,0.2,42.7,52929,74.4,NULL,NULL,'MCG +06-32-004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119665,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119665,33.41,0.51,48.1,52929,NULL,NULL,'Malmquist cor.','MCG +06-32-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119666,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu','R',119666,42.73,NULL,1930,52930,65,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0002,NULL,'23.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.283333,52.97531,0,NULL,59198253025,924972703,14452698,23.4),(119667,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119667,43.09,0.22,2280,52930,74.2,NULL,'SALT 2','[HSP2005] J142108.00+525829.74',0.822,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119668,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119668,43.37,0.17,2590,52930,NULL,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119669,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119669,43.41,0.06,2640,52930,70,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119670,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119670,43.53,0.35,2790,52930,65,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119671,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119671,43.54,0.35,2800,52930,70,NULL,'SALT','[HSP2005] J142108.00+525829.74',0.822,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119672,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119672,43.54,0.22,2810,52930,70,NULL,NULL,'[HSP2005] J142108.00+525829.74',0.822,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119673,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119673,43.63,0.17,2920,52930,65,NULL,'MLCS2k2','[HSP2005] J142108.00+525829.74',0.822,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119674,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119674,43.69,0.32,3000,52930,65,NULL,'SALT','[HSP2005] J142108.00+525829.74',0.822,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119675,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119675,43.74,0.21,3070,52930,70,NULL,'SALT 2','[HSP2005] J142108.00+525829.74',0.822,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119676,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119676,43.76,0.18,3100,52930,65,NULL,'SALT2','[HSP2005] J142108.00+525829.74',0.822,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119677,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119677,43.76,0.19,3100,52930,65,NULL,'MLCS2k2','[HSP2005] J142108.00+525829.74',0.822,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119678,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119678,43.77,0.21,3110,52930,65,NULL,'MLCS31','[HSP2005] J142108.00+525829.74',0.822,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119679,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119679,43.79,0.15,3140,52930,NULL,NULL,'SIFTO','[HSP2005] J142108.00+525829.74',0.822,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119680,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119680,43.79,0.22,3150,52930,65,NULL,'MLCS17','[HSP2005] J142108.00+525829.74',0.822,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119681,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3lu',NULL,119681,43.81,0.16,3170,52930,65,NULL,'SALT','[HSP2005] J142108.00+525829.74',0.822,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119682,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119682,36.48,0.19,198,52931,70,NULL,NULL,'2MASX J14210828+6116476',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000106,NULL,'16.1g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,215.284166667,61.27986,0.009,NULL,57754104699,902407885,14100123,16.1),(119683,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119683,38.04,0.19,405,52932,70,NULL,NULL,'SDSS J142108.93+402028.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.28725,40.34133,0,NULL,59945930437,936655163,14635236,18.4),(119684,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119684,36.48,0.19,198,52933,70,NULL,NULL,'2MASX J14210907+6134566',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.1g',0.3,'E0',NULL,NULL,NULL,NULL,1,215.287833,61.58236,0,NULL,57762332464,902536444,14102131,16.1),(119685,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119685,36.67,0.46,216,52934,70,NULL,NULL,'2MASX J14210958+2610243',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.33',0.18,NULL,NULL,NULL,NULL,NULL,1,215.290083333,26.17353,0,NULL,60054945684,938358526,14661851,17.33),(119686,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119686,37.45,0.46,309,52935,70,NULL,NULL,'SDSS J142109.85+315826.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'18.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,215.291208333,31.97408,0,NULL,60046935901,938233373,14659896,18.1),(119687,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119687,37.58,0.27,328,52936,70,NULL,NULL,'2MASX J14210993+1831375',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.2915,18.52731,0,NULL,59518384120,929974751,14530855,17.1),(119688,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119688,37.6,0.21,331,52937,70,NULL,NULL,'2MASX J14211042+2522443',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.293583,25.37908,0,NULL,59999749715,937496089,14648376,17.4),(119689,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119689,37.2,0.46,275,52938,70,NULL,NULL,'2MASX J14211046+2312376',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000203,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,215.293666667,23.21061,0.019,NULL,59516875819,929951184,14530487,16.2),(119690,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119690,35.98,0.46,157,52939,70,NULL,NULL,'2MASX J14211168+0244067',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000056,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.298833,2.73508,0.037,NULL,58298288631,910910759,14232980,17.2),(119691,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119691,38.35,0.46,467,52940,70,NULL,NULL,'SDSS J142112.33+171737.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.301375,17.29364,0,NULL,59488291762,929504558,14523508,18.6),(119692,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119692,31.23,0.8,17.7,52941,75,NULL,'MAT, I','IC 4402',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.000022,NULL,'12.5b',0.9,'Sb:',NULL,NULL,NULL,NULL,1,215.3045417,-46.29789,0.445,NULL,46803599303,731306239,11426659,12.5),(119693,'Tully est','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119693,31.8,0.8,22.9,52941,75,NULL,NULL,'IC 4402',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119694,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119694,31.13,0.4,16.8,52941,73,NULL,'IR','IC 4402',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119695,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119695,31.13,0.4,16.8,52941,75,NULL,NULL,'IC 4402',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119696,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119696,31.15,0.4,17,52941,73,NULL,'opt','IC 4402',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119697,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119697,31.17,0.36,17.1,52941,NULL,NULL,NULL,'IC 4402',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119698,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119698,31.21,0.43,17.5,52941,75,NULL,'MAT, I, raw','IC 4402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119699,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119699,31.24,0.46,17.7,52941,NULL,NULL,'J','IC 4402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119700,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119700,31.24,0.47,17.7,52941,NULL,NULL,'H','IC 4402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119701,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119701,31.3,0.32,18.2,52941,85,NULL,'I, raw','IC 4402',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119702,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119702,31.31,0.45,18.2,52941,NULL,NULL,'K','IC 4402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119703,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119703,31.34,0.32,18.5,52941,85,NULL,'I, inv','IC 4402',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119704,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119704,31.4,0.49,19.1,52941,75,NULL,'IR','IC 4402',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119705,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119705,31.4,0.43,19.1,52941,75,NULL,'MAT, I, inv','IC 4402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119706,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119706,31.56,0.43,20.5,52941,75,NULL,'MAT, I, cor','IC 4402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119707,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119707,31.7,0.4,21.9,52941,NULL,NULL,'mean','IC 4402',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119708,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119708,31.89,0.8,23.9,52942,75,NULL,'A82, H','NGC 5577',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000013,NULL,'13.05',1,'SA(rs)bc:      HII','in a triple',NULL,NULL,NULL,1,215.304625,3.43578,0.045,NULL,58293833772,910841152,14231893,13.05),(119709,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119709,31.02,0.4,16,52942,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5577',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119710,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119710,31.42,0.36,19.2,52942,NULL,NULL,NULL,'NGC 5577',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119711,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119711,31.47,0.47,19.7,52942,75,NULL,'A82, H, inv','NGC 5577',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119712,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119712,31.51,0.47,20.1,52942,75,NULL,'A82, H, raw','NGC 5577',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119713,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119713,31.78,0.57,22.7,52942,NULL,NULL,'Malmquist cor.','NGC 5577',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119714,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119714,31.8,0.47,23,52942,75,NULL,'A82, H, cor','NGC 5577',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119715,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119715,31.81,NULL,23,52942,72,NULL,NULL,'NGC 5577',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119716,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119716,31.91,0.46,24.1,52942,NULL,NULL,'J','NGC 5577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119717,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119717,31.99,0.47,25,52942,NULL,NULL,'H','NGC 5577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119718,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119718,32.07,0.4,25.9,52942,75,NULL,'B','NGC 5577',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119719,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119719,32.07,0.5,25.9,52942,NULL,NULL,NULL,'NGC 5577',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119720,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119720,32.1,0.45,26.3,52942,NULL,NULL,'K','NGC 5577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119721,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119721,32.11,0.2,26.4,52942,74.4,NULL,NULL,'NGC 5577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119722,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119722,32.15,0.4,27,52942,NULL,NULL,'mean','NGC 5577',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119723,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119723,35.46,0.47,124,52943,NULL,NULL,'H','IC 4408',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000113,NULL,'15.03',0.4,'S?',NULL,NULL,NULL,NULL,1,215.3045417,29.9935,0,NULL,60062381857,938474716,14663667,15.03),(119724,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119724,35.57,0.45,130,52943,NULL,NULL,'K','IC 4408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119725,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119725,35.64,0.4,135,52943,NULL,NULL,'mean','IC 4408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119726,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119726,35.66,0.46,135,52943,NULL,NULL,'J','IC 4408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119727,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119727,37.99,0.27,396,52944,70,NULL,NULL,'2MASX J14211315+4303276',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.304833,43.05772,0,NULL,59224793953,925387405,14459178,17.1),(119728,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119728,34.6,0.47,83.4,52945,NULL,NULL,'H','ESO 511- G 034',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000063,NULL,'13.99',1.1,'(R\')SB(rs)b? pec',NULL,NULL,NULL,NULL,1,215.3055417,-27.26156,0.245,NULL,47034680325,734916880,11483076,13.99),(119729,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119729,34.65,0.45,85.3,52945,NULL,NULL,'K','ESO 511- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119730,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119730,34.73,0.46,88.3,52945,NULL,NULL,'J','ESO 511- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119731,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119731,34.75,0.4,89,52945,NULL,NULL,'mean','ESO 511- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119732,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3en',NULL,119732,43.03,0.17,1960,52946,NULL,NULL,'SALT2','SNLS 06D3en',1.06,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,215.305583,52.45608,0.005,NULL,59195930407,924936412,14452131,NULL),(119733,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3en',NULL,119733,43.73,0.13,2700,52946,70,NULL,'SALT2','SNLS 06D3en',1.06,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119734,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3en',NULL,119734,44.22,0.15,3390,52946,NULL,NULL,'SIFTO','SNLS 06D3en',1.06,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119735,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119735,37.86,0.33,372,52947,70,NULL,NULL,'2MASX J14211345-0027596',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000102,NULL,'17.1g',0.27,'NLAGN',NULL,NULL,NULL,NULL,1,215.3060417,-0.46656,0.137,NULL,43505791711,679777995,10621531,17.1),(119736,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hs',NULL,119736,42.2,0.05,1660,52948,70,NULL,'SIFTO','SNLS 05D3hs',0.664,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.3065,52.90381,0,NULL,59198255181,924972737,14452699,NULL),(119737,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hs',NULL,119737,43.16,0.15,2580,52948,NULL,NULL,'SIFTO','SNLS 05D3hs',0.664,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119738,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hs',NULL,119738,43.25,0.17,2690,52948,70,NULL,'SALT 2','SNLS 05D3hs',0.664,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119739,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3hs',NULL,119739,44.06,0.17,3890,52948,NULL,NULL,'SALT2','SNLS 05D3hs',0.664,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119740,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119740,37.86,0.33,372,52949,70,NULL,NULL,'2MASX J14211365-0026506',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.306833333,-0.44753,0.137,NULL,43505794867,679778044,10621531,17.6),(119741,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119741,41.85,0.17,1530,52950,74.2,NULL,'SALT 2','LSSP J142114.54+523218.1',0.532,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',0.0005,NULL,'21.4g',0.04,NULL,NULL,NULL,NULL,NULL,1,215.310333333,52.53839,0.005,NULL,59195918146,924936221,14452128,21.4),(119742,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff','R',119742,42.06,NULL,1690,52950,65,NULL,'SNLS 03D3af, MLCS17','LSSP J142114.54+523218.1',0.532,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119743,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119743,42.56,0.17,2120,52950,NULL,NULL,'SNLS 03D3af, SALT2','LSSP J142114.54+523218.1',0.532,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119744,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119744,42.59,0.08,2150,52950,70,NULL,'SNLS 03D3af','LSSP J142114.54+523218.1',0.532,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119745,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119745,42.65,0.2,2210,52950,70,NULL,'SNLS 03D3af, SALT','LSSP J142114.54+523218.1',0.532,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119746,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119746,42.67,0.14,2240,52950,65,NULL,'SNLS 03D3af, SALT2','LSSP J142114.54+523218.1',0.532,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119747,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119747,42.8,0.17,2370,52950,65,NULL,'SNLS 03D3af, SALT','LSSP J142114.54+523218.1',0.532,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119748,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119748,42.81,0.21,2380,52950,65,NULL,'SNLS 03D3af, MLCS2k2','LSSP J142114.54+523218.1',0.532,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119749,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119749,42.83,0.19,2400,52950,65,NULL,'SNLS 03D3af, SALT2','LSSP J142114.54+523218.1',0.532,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119750,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119750,42.83,0.29,2400,52950,65,NULL,'SNLS 03D3af, MLCS31','LSSP J142114.54+523218.1',0.532,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119751,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119751,42.85,0.24,2420,52950,65,NULL,'SNLS 03D3af, MLCS17','LSSP J142114.54+523218.1',0.532,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119752,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119752,42.84,0.27,2420,52950,65,NULL,'SNLS 03D3af, MLCS2k2','LSSP J142114.54+523218.1',0.532,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119753,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003ff',NULL,119753,42.93,0.05,2510,52950,65,NULL,'SNLS 03D3af, SALT','LSSP J142114.54+523218.1',0.532,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119754,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119754,38.57,0.33,517,52951,70,NULL,NULL,'2MASX J14211534+0201587',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.313875,2.03292,0.057,NULL,58298203764,910909433,14232959,17.3),(119755,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119755,33.42,0.8,48.2,52952,75,NULL,'MAT, I','ESO 385- G 012',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'16',1.2,'S.../Irr','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,215.315375,-36.22661,0.197,NULL,46994429933,734287967,11473249,16),(119756,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119756,32.94,0.32,38.8,52952,85,NULL,'I, raw','ESO 385- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119757,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119757,32.94,0.32,38.8,52952,85,NULL,'I, inv','ESO 385- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119758,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119758,33.19,0.43,43.5,52952,75,NULL,'MAT, I, raw','ESO 385- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119759,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119759,33.24,0.43,44.6,52952,75,NULL,'MAT, I, inv','ESO 385- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119760,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119760,33.5,0.43,50.1,52952,75,NULL,'MAT, I, cor','ESO 385- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119761,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119761,33.77,0.14,56.9,52952,NULL,NULL,NULL,'ESO 385- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119762,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119762,34.25,0.33,70.8,52953,70,NULL,NULL,'NGC 5581',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.0001,NULL,'14.3g',0.73,NULL,NULL,NULL,NULL,NULL,1,215.317958333,23.48003,0.041,NULL,59513478637,929898103,14529657,14.3),(119763,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119763,37.99,0.27,396,52954,70,NULL,NULL,'2MASX J14211625+4304155',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.317958333,43.07083,0,NULL,59224793258,925387394,14459178,17.3),(119764,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119764,37.93,0.33,386,52955,70,NULL,NULL,'2MASX J14211666+4329226',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.319375,43.4895,0,NULL,59224851228,925388300,14459192,17.6),(119765,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119765,31,0.8,15.8,52956,75,NULL,'MAT, I','ESO 446- G 053',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'14.63',0.7,'IB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,215.321333,-29.26319,0.309,NULL,47042750595,735042978,11485046,14.63),(119766,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119766,29.75,0.32,8.91,52956,85,NULL,'I, inv','ESO 446- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119767,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119767,29.84,0.32,9.27,52956,85,NULL,'I, raw','ESO 446- G 053',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119768,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119768,30.31,0.43,11.5,52956,75,NULL,'MAT, I, inv','ESO 446- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119769,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119769,30.55,0.43,12.9,52956,75,NULL,'MAT, I, raw','ESO 446- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119770,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119770,30.84,0.43,14.7,52956,75,NULL,'MAT, I, cor','ESO 446- G 053',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119771,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119771,31.17,0.4,17.1,52956,NULL,NULL,NULL,'ESO 446- G 053',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119772,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119772,32.51,0.6,31.8,52956,NULL,NULL,NULL,'ESO 446- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119773,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119773,32.55,0.2,32.4,52956,74.4,NULL,NULL,'ESO 446- G 053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119774,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119774,32.64,0.57,33.8,52956,NULL,NULL,'Malmquist cor.','ESO 446- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119775,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119775,38.02,0.19,402,52957,70,NULL,NULL,'2MASX J14211718+4438036',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000172,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.321417,44.63417,0,NULL,59230461555,925475961,14460561,18),(119776,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119776,37.47,0.07,312,52958,70,NULL,NULL,'2MASX J14211721+4825551',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.3219583,48.43192,0.027,NULL,59248640470,925760007,14465000,17.4),(119777,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119777,38.02,0.19,402,52959,70,NULL,NULL,'2MASX J14211738+4446426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.322333,44.77842,0,NULL,59230475325,925476176,14460565,17.3),(119778,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119778,37.26,0.46,283,52960,70,NULL,NULL,'2MASX J14211739+2657394',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,215.3225,26.96097,0,NULL,60057525987,938398843,14662481,17.84),(119779,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119779,37.76,0.46,357,52961,70,NULL,NULL,'SDSS J142117.62+301347.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.3234583,30.22975,0,NULL,60061475931,938460561,14663446,18.3),(119780,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119780,36.57,0.46,206,52962,70,NULL,NULL,'2MASX J14211836+3221328',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,215.326667,32.35925,0,NULL,60046740066,938230313,14659848,16.3),(119781,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119781,37.22,0.46,277,52963,70,NULL,NULL,'2MASX J14211885+5211261',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00018,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,215.328417,52.19064,0,NULL,59196076950,924938702,14452167,16.3),(119782,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119782,37.78,0.46,360,52964,70,NULL,NULL,'2MASX J14211901+5232341',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.329167,52.54281,0.005,NULL,59195917921,924936217,14452128,17),(119783,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119783,36.48,0.19,198,52965,70,NULL,NULL,'CGCG 295-046 NED02',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000211,NULL,'15.2g',0.54,'E0',NULL,NULL,NULL,NULL,1,215.32975,61.57925,0.009,NULL,57762329398,902536396,14102131,15.2),(119784,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119784,37.47,0.07,312,52966,70,NULL,NULL,'2MASX J14211921+4825331',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.330041667,48.42572,0.027,NULL,59248640481,925760007,14465000,17.2),(119785,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119785,37.56,0.85,324,52967,70,NULL,NULL,'2MASX J14211953-1003156',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,215.331291667,-10.05436,0.197,NULL,43706695434,682917116,10670579,16.25),(119786,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119786,36.48,0.19,198,52968,70,NULL,NULL,'2MASX J14211957+6131306',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,215.3317083,61.52511,0.009,NULL,57762320657,902536260,14102129,16.8),(119787,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119787,38.14,0.46,424,52969,70,NULL,NULL,'2MASX J14211962+0351513',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.33175,3.86431,0.049,NULL,58296440579,910881884,14232529,17.7),(119788,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119788,37.89,0.46,379,52970,70,NULL,NULL,'2MASX J14211979+2140536',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.332416667,21.68156,0.023,NULL,59521909245,930029831,14531716,17.8),(119789,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119789,37.22,0.46,278,52971,70,NULL,NULL,'2MASX J14212124+0548083',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.338375,5.80244,0.033,NULL,58301068114,910954189,14233659,17.5),(119790,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119790,32.68,0.43,34.3,52972,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-37-003',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.00001,NULL,'14.95',0.3,'Sc',NULL,NULL,NULL,NULL,1,215.3427917,-3.75886,0.129,NULL,43510732078,679855188,10622737,14.95),(119791,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119791,37.88,0.46,377,52973,70,NULL,NULL,'2MASX J14212287+3209358',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.345375,32.16006,0,NULL,60046950886,938233607,14659900,17.7),(119792,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119792,37.4,0.15,302,52974,70,NULL,NULL,'SDSS J142123.08+302158.7',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.3462083,30.36633,0,NULL,60061508896,938461076,14663454,16.4),(119793,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119793,37.47,0.07,312,52975,70,NULL,NULL,'2MASX J14212317+4755065',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000189,NULL,'15.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,215.3465417,47.91842,0.006,NULL,59248137605,925752150,14464877,15.8),(119794,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119794,36.5,0.46,200,52976,70,NULL,NULL,'2MASX J14212374+0045543',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.348833333,0.76506,0.065,NULL,58285424911,910709764,14229840,16.9),(119795,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119795,37,0.33,251,52977,70,NULL,NULL,'2MASX J14212464+2929054',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000186,NULL,'18.29',0.18,NULL,NULL,NULL,NULL,NULL,1,215.3527083,29.48475,0,NULL,60061996516,938468695,14663573,18.29),(119796,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119796,37.65,0.17,339,52978,70,NULL,NULL,'2MASX J14212522+5628486',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.354875,56.48022,0,NULL,57256704634,894636009,13978687,16.9),(119797,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3la',NULL,119797,43.49,0.07,2580,52979,70,NULL,'SALT2','SNLS 05D3la',0.936,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,215.355917,52.35797,0,NULL,59196055342,924938364,14452161,NULL),(119798,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3la',NULL,119798,43.87,0.17,3070,52979,NULL,NULL,'SALT2','SNLS 05D3la',0.936,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119799,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3la',NULL,119799,43.87,0.15,3070,52979,NULL,NULL,'SIFTO','SNLS 05D3la',0.936,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119800,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3la',NULL,119800,43.9,0.21,3110,52979,70,NULL,'SALT 2','SNLS 05D3la',0.936,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119801,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119801,37.47,0.07,312,52980,70,NULL,NULL,'2MASX J14212548+4829335',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00007,NULL,'16.2g',0.36,'Elliptical',NULL,NULL,NULL,NULL,1,215.356333,48.49258,0.028,NULL,59248558113,925758720,14464980,16.2),(119802,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119802,37.92,0.16,383,52981,70,NULL,NULL,'2MASX J14212607+4931025',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.358458333,49.51728,0.005,NULL,59246540902,925727201,14464487,18.1),(119803,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119803,37.21,0.46,277,52982,70,NULL,NULL,'2MASX J14212619+4906295',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.35925,49.10828,0.037,NULL,59245980683,925718448,14464350,17.1),(119804,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119804,37.47,0.07,312,52983,70,NULL,NULL,'2MASX J14212705+4816305',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.362541667,48.27528,0,NULL,59248652534,925760195,14465003,17.7),(119805,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119805,36.55,0.33,204,52984,70,NULL,NULL,'2MASX J14212711+2631204',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'17.28',0.24,NULL,NULL,NULL,NULL,NULL,1,215.363,26.52219,0,NULL,60054737451,938355272,14661801,17.28),(119806,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119806,36.8,0.46,229,52985,70,NULL,NULL,'2MASX J14212723+3136498',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.82',0.21,NULL,NULL,NULL,NULL,NULL,1,215.363333,31.61381,0,NULL,60060480004,938445000,14663203,17.82),(119807,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119807,36.8,0.53,229,52986,70,NULL,NULL,'2MASX J14212788-0426057',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.4b',0.45,NULL,NULL,NULL,NULL,NULL,1,215.3660417,-4.43492,0.117,NULL,43511457126,679866517,10622914,16.4),(119808,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119808,37.84,0.46,369,52987,70,NULL,NULL,'2MASX J14212821+2546554',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.367666667,25.78222,0,NULL,60054231368,938347365,14661677,17.9),(119809,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119809,37.93,0.33,386,52988,70,NULL,NULL,'2MASX J14212822+4327173',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.367666667,43.45489,0,NULL,59224853400,925388334,14459192,17.7),(119810,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119810,38.42,0.46,483,52989,70,NULL,NULL,'2MASX J14212857+2529064',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.3689583,25.48519,0,NULL,60054195269,938346801,14661668,18.2),(119811,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119811,37.92,0.16,383,52990,70,NULL,NULL,'SDSS J142129.39+493205.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.3725,49.53483,0.005,NULL,59246533578,925727087,14464485,18.5),(119812,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119812,36.1,0.46,166,52991,70,NULL,NULL,'2MASX J14212956+1336183',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00018,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,215.373375,13.60522,0,NULL,59475819181,929309674,14520463,15.6),(119813,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119813,35.22,0.33,111,52992,NULL,NULL,'Malmquist cor.','IC 1003',NULL,'2009ApJS..182..474S',2009,1,1.37,NULL,'G',0.000033,NULL,'15.2g',0.39,'cE0 pec:       NLAGN',NULL,NULL,NULL,NULL,1,215.374,5.07319,0.021,NULL,58293331070,910833297,14231770,15.2),(119814,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119814,35.34,0.31,117,52992,NULL,NULL,NULL,'IC 1003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119815,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119815,35.49,0.2,125,52992,74.4,NULL,NULL,'IC 1003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119816,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119816,36.58,0.89,207,52993,70,NULL,NULL,'2MASX J14213028-4723339',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,215.37625,-47.39281,0.597,NULL,46835215086,731800235,11434378,17.3),(119817,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119817,37.47,0.07,312,52994,70,NULL,NULL,'2MASX J14213084+4820336',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.3785,48.34258,0.027,NULL,59248653632,925760213,14465003,17.2),(119818,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119818,36.56,0.8,205,52995,75,NULL,'CF, r','UGC 09195',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.000014,NULL,'15.0g',0.45,'Sb',NULL,NULL,NULL,NULL,1,215.3805417,23.94831,0.009,NULL,59513955297,929905551,14529774,15),(119819,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119819,36.85,0.2,234,52995,74.4,NULL,NULL,'UGC 09195',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119820,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119820,36.91,0.38,241,52995,75,NULL,'CF, r, raw','UGC 09195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119821,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119821,37.15,0.38,269,52995,75,NULL,'CF, r, cor','UGC 09195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119822,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119822,37.22,0.38,278,52995,75,NULL,'CF, r, inv','UGC 09195',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119823,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119823,37.92,0.46,383,52996,70,NULL,NULL,'2MASX J14213307+3006078',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.07',0.19,NULL,NULL,NULL,NULL,NULL,1,215.3877917,30.10211,0,NULL,60062335179,938473987,14663656,18.07),(119824,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119824,37.56,0.46,326,52997,70,NULL,NULL,'2MASX J14213329+2122360',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.388625,21.37681,0,NULL,59522116262,930033066,14531766,16.9),(119825,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119825,37.58,0.27,328,52998,70,NULL,NULL,'2MASX J14213327+1827060',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,215.388708333,18.45172,0,NULL,59485817092,929465892,14522904,16.1),(119826,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119826,36.99,0.46,250,52999,70,NULL,NULL,'2MASX J14213336+1914330',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.56',0.2,NULL,NULL,NULL,NULL,NULL,1,215.389083333,19.24239,0,NULL,59518291808,929973309,14530832,16.56),(119827,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119827,37.58,0.27,328,53000,70,NULL,NULL,'SDSS J142134.89+182753.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.395417,18.46481,0,NULL,59485815344,929465864,14522904,18.3),(119828,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119828,37.92,0.16,383,53001,70,NULL,NULL,'2MASX J14213541+4930136',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000197,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,215.3977083,49.50372,0.005,NULL,59246601440,925728147,14464502,16.2),(119829,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119829,37.92,0.16,383,53002,70,NULL,NULL,'MCG +08-26-021',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000189,NULL,'15.7g',0.54,'cD;BrClG',NULL,NULL,NULL,NULL,1,215.399291667,49.55122,0.005,NULL,59246533104,925727079,14464485,15.7),(119830,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119830,36.48,0.19,198,53003,70,NULL,NULL,'SDSS J142135.83+613502.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.399333,61.584,0.009,NULL,57762326698,902536354,14102130,17.7),(119831,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh','R',119831,39.69,NULL,694,53004,65,NULL,'SNLS 03D3bh, SALT','SDSS J142135.88+523138.9',0.249,'2010arXiv1006.2112L',2010,1,0.11,NULL,'G',0.0003,NULL,'19.2g',0.09,'AGN',NULL,NULL,NULL,NULL,1,215.3995417,52.5275,0.005,NULL,59195917076,924936204,14452128,19.2),(119832,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119832,39.9,0.16,765,53004,74.2,NULL,'SALT 2','SDSS J142135.88+523138.9',0.249,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119833,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119833,40.57,0.02,1040,53004,70,NULL,'SNLS 03D3bh','SDSS J142135.88+523138.9',0.249,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119834,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119834,40.63,0.14,1070,53004,70,NULL,'SNLS 03D3bh, SALT','SDSS J142135.88+523138.9',0.249,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119835,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119835,40.72,0.21,1110,53004,65,NULL,'SNLS 03D3bh, SALT2','SDSS J142135.88+523138.9',0.249,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119836,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119836,40.82,0.16,1170,53004,65,NULL,'SNLS 03D3bh, SALT','SDSS J142135.88+523138.9',0.249,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119837,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119837,40.83,0.24,1170,53004,65,NULL,'SNLS 03D3bh, MLCS2k2','SDSS J142135.88+523138.9',0.249,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119838,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119838,40.84,0.03,1180,53004,65,NULL,'SNLS 03D3bh, SALT','SDSS J142135.88+523138.9',0.249,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119839,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2003fh',NULL,119839,42.18,0.06,2180,53004,65,NULL,'SNLS 03D3bh, MLCS2k2','SDSS J142135.88+523138.9',0.249,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119840,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119840,38.02,0.19,402,53005,70,NULL,NULL,'2MASX J14213598+4442293',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000207,NULL,'16.1g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,215.3997083,44.70806,0,NULL,59230479122,925476236,14460566,16.1),(119841,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119841,38.67,0.46,543,53006,70,NULL,NULL,'2MASX J14213593+0141313',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000103,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.3997917,1.69208,0.061,NULL,58297952888,910905513,14232898,17.8),(119842,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119842,36.48,0.19,198,53007,70,NULL,NULL,'2MASX J14213634+6127089',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.401125,61.45253,0.009,NULL,57762342421,902536600,14102134,16.2),(119843,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119843,37.36,0.46,297,53008,70,NULL,NULL,'2MASX J14213636+3940154',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.4015417,39.671,0,NULL,60063050216,938485159,14663830,17.7),(119844,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119844,37.39,0.46,301,53009,70,NULL,NULL,'2MASX J14213636+1718193',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.35',0.15,NULL,NULL,NULL,NULL,NULL,1,215.4017083,17.30547,0,NULL,59488298504,929504664,14523510,18.35),(119845,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119845,37.92,0.16,383,53010,70,NULL,NULL,'2MASX J14213685+4928096',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,215.403458333,49.46933,0.005,NULL,59246594633,925728041,14464500,16.8),(119846,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119846,38.04,0.19,405,53011,70,NULL,NULL,'SDSS J142137.99+403433.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.4082917,40.57586,0,NULL,59945817742,936653402,14635209,18.5),(119847,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119847,38.02,0.19,402,53012,70,NULL,NULL,'2MASX J14213850+4437063',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.4105,44.61844,0,NULL,59230724918,925480076,14460626,17.3),(119848,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119848,38.48,0.33,495,53013,70,NULL,NULL,'2MASX J14213983-0139467',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000177,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.415958333,-1.66292,0.133,NULL,43518541168,679977205,10624643,18.4),(119849,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119849,37.46,0.46,310,53014,70,NULL,NULL,'2MASX J14214087+0101243',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000081,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.420333,1.02342,0.065,NULL,58285473657,910710525,14229851,17.3),(119850,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119850,36.94,0.27,244,53015,70,NULL,NULL,'MCG +03-37-008',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.84',0.17,NULL,NULL,NULL,NULL,NULL,1,215.4239583,17.75236,0,NULL,59486568757,929477636,14523088,16.84),(119851,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119851,37.92,0.16,383,53016,70,NULL,NULL,'2MASX J14214188+4932306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.424583,49.54192,0.005,NULL,59246601947,925728155,14464502,17.2),(119852,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119852,38.48,0.33,495,53017,70,NULL,NULL,'2MASX J14214209-0141147',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'17.2b',0.26,'BrClG',NULL,NULL,NULL,NULL,1,215.425333333,-1.68736,0.133,NULL,43518538680,679977166,10624643,17.2),(119853,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119853,37.57,0.33,326,53018,70,NULL,NULL,'2MASX J14214253+0414123',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.12',0.23,NULL,NULL,NULL,NULL,NULL,1,215.427375,4.23675,0.045,NULL,58296393260,910881144,14232517,17.12),(119854,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119854,37.29,0.46,287,53019,70,NULL,NULL,'2MASX J14214420+0110223',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.4342083,1.17289,0.065,NULL,58285376840,910709013,14229828,17.2),(119855,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119855,37.92,0.16,383,53020,70,NULL,NULL,'SDSS J142144.49+492854.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.435375,49.48183,0.005,NULL,59246606138,925728220,14464503,18.6),(119856,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jq',NULL,119856,42.42,0.04,1930,53021,70,NULL,'SIFTO','[NSB2006] J142145.46+530147.5',0.58,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,'20.7R',NULL,'a',NULL,NULL,NULL,NULL,1,215.439375,53.02947,0,NULL,59198394434,924974913,14452733,20.7),(119857,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jq',NULL,119857,42.59,0.13,2080,53021,70,NULL,'SALT 2','[NSB2006] J142145.46+530147.5',0.58,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119858,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jq',NULL,119858,42.64,0.15,2130,53021,NULL,NULL,'SIFTO','[NSB2006] J142145.46+530147.5',0.58,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119859,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jq',NULL,119859,44.41,0.17,4830,53021,NULL,NULL,'SALT2','[NSB2006] J142145.46+530147.5',0.58,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119860,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119860,37.02,0.46,253,53022,70,NULL,NULL,'2MASX J14214663+2528463',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000154,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.4445,25.47947,0,NULL,60054260635,938347822,14661684,16.6),(119861,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119861,37.39,0.46,300,53023,70,NULL,NULL,'SDSS J142147.36+423046.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000137,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.447375,42.51297,0,NULL,59947497340,936679645,14635619,17.8),(119862,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119862,38.13,0.46,423,53024,70,NULL,NULL,'2MASX J14214745+3636214',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.447583333,36.606,0,NULL,60031872669,937998010,14656218,17.7),(119863,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119863,37.4,0.15,302,53025,70,NULL,NULL,'2MASX J14214746+3025518',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.80',0.14,NULL,NULL,NULL,NULL,NULL,1,215.44775,30.43089,0,NULL,60061500459,938460944,14663452,18.8),(119864,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119864,38.17,0.46,431,53026,70,NULL,NULL,'2MASX J14214792-0132030',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.44975,-1.53425,0.133,NULL,43504632022,679759875,10621248,17.9),(119865,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ci',NULL,119865,42.43,0.15,2020,53027,NULL,NULL,'SIFTO','[NSB2006] J142148.08+522643.3',0.51,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'21.8R',NULL,'a',NULL,NULL,NULL,NULL,1,215.4505417,52.44514,0,NULL,59196048698,924938260,14452160,21.8),(119866,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ci',NULL,119866,43.05,0.07,2690,53027,70,NULL,'SIFTO','[NSB2006] J142148.08+522643.3',0.51,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119867,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3ci',NULL,119867,45.11,0.17,6970,53027,NULL,NULL,'SALT2','[NSB2006] J142148.08+522643.3',0.51,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119868,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119868,37.51,0.46,318,53028,70,NULL,NULL,'2MASX J14214866+2042111',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.4527083,20.70297,0.016,NULL,59525223249,930081613,14532525,17.8),(119869,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kx',NULL,119869,39.93,0.03,794,53029,70,NULL,'SIFTO','[NSB2006] J142150.02+530813.4',0.22,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.458416667,53.13708,0,NULL,59198403583,924975055,14452735,NULL),(119870,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kx',NULL,119870,40.16,0.11,884,53029,70,NULL,'SALT 2','[NSB2006] J142150.02+530813.4',0.22,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119871,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kx',NULL,119871,40.25,0.15,918,53029,NULL,NULL,'SIFTO','[NSB2006] J142150.02+530813.4',0.22,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119872,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3kx',NULL,119872,41.19,0.17,1420,53029,NULL,NULL,'SALT2','[NSB2006] J142150.02+530813.4',0.22,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119873,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119873,37.34,0.46,293,53030,70,NULL,NULL,'2MASX J14215013+2145541',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.4587083,21.76508,0.021,NULL,59514337756,929911527,14529867,17.6),(119874,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119874,37.47,0.07,312,53031,70,NULL,NULL,'2MASX J14215011+4827176',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.458917,48.45486,0.027,NULL,59248675962,925760561,14465008,18.1),(119875,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119875,36.45,0.46,195,53032,70,NULL,NULL,'2MASX J14215062+0620159',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,215.461125,6.33764,0.041,NULL,58271558712,910493104,14226454,16.6),(119876,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119876,35.51,0.46,127,53033,70,NULL,NULL,'I Zw 084',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000175,NULL,'15.5g',0.45,'S0/a',NULL,NULL,NULL,NULL,1,215.4619583,46.73019,0.014,NULL,59229373219,925458956,14460296,15.5),(119877,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119877,38.05,0.46,407,53034,70,NULL,NULL,'2MASX J14215111+5633494',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.463125,56.56375,0,NULL,57256667837,894635434,13978678,18.3),(119878,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119878,38.02,0.19,402,53035,70,NULL,NULL,'2MASX J14215121+4430522',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,215.463333,44.51439,0,NULL,59230728725,925480136,14460627,18.4),(119879,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119879,37.7,0.27,346,53036,70,NULL,NULL,'2MASX J14215173+2058251',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.76',0.29,NULL,NULL,NULL,NULL,NULL,1,215.465541667,20.97347,0.039,NULL,59524856910,930075889,14532435,16.76),(119880,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119880,34.25,0.33,70.8,53037,70,NULL,NULL,'MRK 0678',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000178,NULL,'15.0g',0.41,'Compact',NULL,NULL,NULL,NULL,1,215.46775,23.517,0.041,NULL,59513359325,929896239,14529628,15),(119881,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119881,37.47,0.07,312,53038,70,NULL,NULL,'2MASX J14215359+4840586',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.47325,48.68289,0.038,NULL,59247858420,925747787,14464809,17.8),(119882,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119882,37.7,0.27,346,53039,70,NULL,NULL,'SDSS J142153.62+205730.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.473417,20.95842,0.039,NULL,59524856790,930075887,14532435,18.5),(119883,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119883,36.58,0.44,207,53040,NULL,NULL,'Malmquist cor.','CGCG 019-007',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000013,NULL,'15.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,215.480417,-0.55658,0.137,NULL,43506241882,679785029,10621641,15.8),(119884,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119884,36.79,0.4,228,53040,NULL,NULL,NULL,'CGCG 019-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119885,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119885,36.83,0.2,232,53040,74.4,NULL,NULL,'CGCG 019-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119886,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119886,37.02,0.46,253,53041,70,NULL,NULL,'2MASX J14215581+5248465',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.4827917,52.81311,0,NULL,59198270145,924972971,14452702,17.8),(119887,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119887,37.47,0.07,312,53042,70,NULL,NULL,'MCG +08-26-023',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000182,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,215.489583,48.49836,0.027,NULL,59248559292,925758738,14464980,16),(119888,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119888,37.11,0.46,264,53043,70,NULL,NULL,'2MASX J14215773+4441401',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,215.490625,44.69444,0,NULL,59230756549,925480571,14460633,16.7),(119889,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119889,36.07,0.59,164,53044,70,NULL,NULL,'2MASX J14215787-1953100',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.4912083,-19.88603,0.337,NULL,46571966852,727686982,11370109,15.8),(119890,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119890,34.75,0.49,89.3,53045,75,NULL,'IR','UGC 09199',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.33',0.2,'S?',NULL,NULL,NULL,NULL,1,215.4995417,11.10011,0,NULL,58488895289,913888988,14279515,15.33),(119891,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119891,34.98,0.2,99.1,53045,74.4,NULL,NULL,'UGC 09199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119892,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119892,35.01,0.38,100,53045,NULL,NULL,'Malmquist cor.','UGC 09199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119893,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119893,35.01,0.38,101,53045,NULL,NULL,NULL,'UGC 09199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119894,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119894,35.3,0.4,115,53045,NULL,NULL,'mean','UGC 09199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119895,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119895,35.48,0.47,125,53045,NULL,NULL,'H','UGC 09199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119896,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119896,38,0.33,398,53046,70,NULL,NULL,'2MASX J14220006+1238202',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.500333,12.639,0,NULL,58352142018,911752219,14246128,17),(119897,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119897,37.47,0.07,312,53047,70,NULL,NULL,'2MASX J14220188+4827315',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000202,NULL,'16.3g',0.35,'S0',NULL,NULL,NULL,NULL,1,215.507917,48.45886,0.027,NULL,59248686519,925760726,14465011,16.3),(119898,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119898,35.7,0.61,138,53048,70,NULL,NULL,'2MASX J14220343-1809480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.72',NULL,'(L)SB0^0',NULL,NULL,NULL,NULL,1,215.514417,-18.16356,0.313,NULL,46545474882,727273045,11363641,15.72),(119899,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3et',NULL,119899,41.28,0.17,1140,53049,NULL,NULL,'SALT2','SNLS 06D3et',0.576,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.519875,52.33836,0,NULL,59196057995,924938406,14452162,NULL),(119900,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3et',NULL,119900,42.6,0.15,2100,53049,NULL,NULL,'SIFTO','SNLS 06D3et',0.576,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119901,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3et',NULL,119901,42.65,0.14,2150,53049,70,NULL,'SALT 2','SNLS 06D3et',0.576,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119902,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3et',NULL,119902,42.79,0.04,2300,53049,70,NULL,'SALT2','SNLS 06D3et',0.576,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119903,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119903,37.7,0.27,346,53050,70,NULL,NULL,'2MASX J14220569+2057280',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.20',0.19,NULL,NULL,NULL,NULL,NULL,1,215.523833,20.95772,0.039,NULL,59524848765,930075761,14532433,18.2),(119904,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119904,37.47,0.07,312,53051,70,NULL,NULL,'2MASX J14220656+4827510',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'16.9g',0.19,'S0',NULL,NULL,NULL,NULL,1,215.527333333,48.46406,0.027,NULL,59248687055,925760735,14465011,16.9),(119905,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2005ch',NULL,119905,35.27,0.11,110,53052,72,NULL,'z lit','APMUKS(BJ) B141934.25+021314.0',0.026527,'2009ApJ...704..629M',2009,1,0.13,NULL,'G',NULL,NULL,'20.40',0.1,NULL,NULL,NULL,NULL,NULL,1,215.5275,1.99308,0.057,NULL,58298041807,910906903,14232920,20.4),(119906,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2005ch',NULL,119906,35.27,0.41,110,53052,72,NULL,'z lit','APMUKS(BJ) B141934.25+021314.0',0.026527,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119907,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2005ch',NULL,119907,35.27,0.02,110,53052,72,NULL,'z lit','APMUKS(BJ) B141934.25+021314.0',0.026527,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119908,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2005ch',NULL,119908,35.31,0.07,116,53052,72,NULL,'M(H) = -18.317 mag','APMUKS(BJ) B141934.25+021314.0',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119909,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119909,41.56,0.15,1320,53053,74.2,NULL,'SALT 2','[HSP2005] J142206.87+521343.46',0.552,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0003,NULL,'22.0g',0.04,NULL,NULL,NULL,NULL,NULL,1,215.528583,52.22869,0,NULL,59196111012,924939234,14452175,22),(119910,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119910,41.89,0.17,1540,53053,NULL,NULL,'SALT2','[HSP2005] J142206.87+521343.46',0.552,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119911,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119911,41.94,0.14,1570,53053,65,NULL,'MLCS2k2','[HSP2005] J142206.87+521343.46',0.552,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119912,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn','R',119912,41.99,NULL,1610,53053,65,NULL,'MLCS31','[HSP2005] J142206.87+521343.46',0.552,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119913,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119913,42.1,0.1,1700,53053,65,NULL,'SALT2','[HSP2005] J142206.87+521343.46',0.552,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119914,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119914,42.2,0.38,1770,53053,65,NULL,'MLCS31','[HSP2005] J142206.87+521343.46',0.552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119915,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119915,42.26,0.29,1820,53053,65,NULL,'MLCS17','[HSP2005] J142206.87+521343.46',0.552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119916,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119916,42.27,0.14,1830,53053,70,NULL,'SALT 2','[HSP2005] J142206.87+521343.46',0.552,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119917,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119917,42.28,0.4,1840,53053,65,NULL,'MLCS2k2','[HSP2005] J142206.87+521343.46',0.552,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119918,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119918,42.31,0.15,1870,53053,NULL,NULL,'SIFTO','[HSP2005] J142206.87+521343.46',0.552,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119919,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119919,42.41,0.15,1950,53053,70,NULL,'SALT','[HSP2005] J142206.87+521343.46',0.552,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119920,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119920,42.43,0.17,1970,53053,65,NULL,'SALT2','[HSP2005] J142206.87+521343.46',0.552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119921,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119921,42.46,0.04,2000,53053,70,NULL,NULL,'[HSP2005] J142206.87+521343.46',0.552,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119922,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119922,42.53,0.12,2060,53053,65,NULL,'SALT','[HSP2005] J142206.87+521343.46',0.552,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119923,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119923,42.73,0.03,2260,53053,65,NULL,'SALT','[HSP2005] J142206.87+521343.46',0.552,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119924,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3hn',NULL,119924,43.11,0.04,2690,53053,70,NULL,'SALT 2','[HSP2005] J142206.87+521343.46',0.552,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119925,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119925,37.99,0.33,397,53054,70,NULL,NULL,'2MASX J14220733-0059150',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'17.2b',0.27,'BrClG',NULL,NULL,NULL,NULL,1,215.530625,-0.98761,0.129,NULL,43506196946,679784327,10621630,17.2),(119926,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119926,37.99,0.33,397,53055,70,NULL,NULL,'SDSS J142207.75-010001.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000075,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.5322917,-1.00039,0.109,NULL,43506200064,679784376,10621630,18.6),(119927,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119927,37.47,0.07,312,53056,70,NULL,NULL,'2MASX J14220777+4828060',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.532417,48.46847,0.027,NULL,59248686941,925760733,14465011,17.4),(119928,'BCG','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119928,37.38,0.35,279,53057,60,NULL,NULL,'ABELL 1904',0.0719,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,215.5327917,48.55619,0.027,NULL,59248573883,925758966,14464983,NULL),(119929,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119929,38.12,0.33,422,53058,70,NULL,NULL,'2MASX J14220786+1845330',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.5329583,18.75917,0,NULL,59518460478,929975944,14530874,17.4),(119930,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119930,37,0.33,251,53059,70,NULL,NULL,'2MASX J14220813+2937250',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'16.2g',0.32,'E',NULL,NULL,NULL,NULL,1,215.53375,29.62372,0,NULL,60061979164,938468424,14663569,16.2),(119931,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119931,37.47,0.07,312,53060,70,NULL,NULL,'2MASX J14220858+4825560',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.535667,48.43211,0.027,NULL,59248688998,925760765,14465011,17.1),(119932,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mx',NULL,119932,40.69,0.17,937,53061,NULL,NULL,'SALT2','[NSB2006] J142209.07+521309.3',0.47,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,215.537833,52.21928,0,NULL,59196097637,924939025,14452172,NULL),(119933,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mx',NULL,119933,42.17,0.14,1850,53061,70,NULL,'SALT 2','[NSB2006] J142209.07+521309.3',0.47,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119934,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mx',NULL,119934,42.18,0.15,1860,53061,NULL,NULL,'SIFTO','[NSB2006] J142209.07+521309.3',0.47,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119935,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3mx',NULL,119935,42.31,0.04,1970,53061,70,NULL,'SALT2','[NSB2006] J142209.07+521309.3',0.47,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119936,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119936,36.1,0.46,166,53062,70,NULL,NULL,'2MASX J14220972+0431157',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000099,NULL,'16.0g',0.39,'NLAGN',NULL,NULL,NULL,NULL,1,215.5404583,4.52114,0.045,NULL,58295967261,910874488,14232413,16),(119937,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jb',NULL,119937,42.93,0.05,2210,53063,70,NULL,'SIFTO','SNLS 05D3jb',0.745,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.541667,52.87814,0,NULL,59198268568,924972946,14452702,NULL),(119938,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jb',NULL,119938,43.32,0.15,2650,53063,NULL,NULL,'SIFTO','SNLS 05D3jb',0.745,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119939,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jb',NULL,119939,43.35,0.18,2680,53063,70,NULL,'SALT 2','SNLS 05D3jb',0.745,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119940,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3jb',NULL,119940,44.62,0.17,4810,53063,NULL,NULL,'SALT2','SNLS 05D3jb',0.745,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119941,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119941,37.12,0.33,266,53064,70,NULL,NULL,'SDSS J142209.92+045136.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.541375,4.86008,0.021,NULL,58293164657,910830697,14231729,17.5),(119942,'BCG','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119942,37.38,0.35,279,53065,60,NULL,'ABELL 1904, BCG','MCG +08-26-024',0.0719,'1980ApJ...241..486H',1980,1,0.81,NULL,'G',0.000237,NULL,'15.2g',0.57,'BrClG','Brightest group member',NULL,NULL,NULL,1,215.5425,48.57072,0.027,NULL,59248573808,925758965,14464983,15.2),(119943,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119943,37.47,0.07,312,53065,70,NULL,NULL,'MCG +08-26-024',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119944,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119944,38.06,0.46,410,53066,70,NULL,NULL,'SDSS J142210.49+083027.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,215.5437083,8.50778,0.033,NULL,58273690440,910526413,14226975,18.5),(119945,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119945,36.65,0.46,214,53067,70,NULL,NULL,'2MASX J14221066+4223022',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.544417,42.38392,0,NULL,59947536933,936680264,14635629,16.8),(119946,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119946,37.91,0.46,382,53068,70,NULL,NULL,'2MASX J14221173+0716169',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.549041667,7.27128,0.029,NULL,58274889816,910545153,14227268,17.8),(119947,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119947,36.37,0.46,188,53069,70,NULL,NULL,'2MASX J14221204+1702175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.05',0.19,NULL,NULL,NULL,NULL,NULL,1,215.550167,17.03819,0,NULL,59488311515,929504867,14523513,17.05),(119948,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lr',NULL,119948,42.67,0.17,2140,53070,70,NULL,'SALT 2','SNLS 05D3lr',0.6,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.550583333,53.18428,0,NULL,59198398978,924974984,14452734,NULL),(119949,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lr',NULL,119949,42.79,0.15,2260,53070,NULL,NULL,'SIFTO','SNLS 05D3lr',0.6,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119950,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lr',NULL,119950,43.15,0.17,2670,53070,NULL,NULL,'SALT2','SNLS 05D3lr',0.6,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119951,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lr',NULL,119951,43.34,0.05,2910,53070,70,NULL,'SIFTO','SNLS 05D3lr',0.6,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119952,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119952,37.48,0.46,314,53071,70,NULL,NULL,'2MASX J14221322+1051074',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.54',0.14,NULL,NULL,NULL,NULL,NULL,1,215.5550417,10.85217,0,NULL,58489000100,913890626,14279541,18.54),(119953,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119953,37.07,0.46,260,53072,70,NULL,NULL,'LCRS B141937.7-024721',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000133,NULL,'16.8b',0.29,NULL,NULL,NULL,NULL,NULL,1,215.555791667,-3.01636,0.149,NULL,43518304104,679973501,10624585,16.8),(119954,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119954,38,0.33,398,53073,70,NULL,NULL,'SDSS J142214.52+124046.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.5605,12.67964,0,NULL,58352122075,911751907,14246123,18.6),(119955,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119955,37.35,0.33,295,53074,70,NULL,NULL,'2MASX J14221519+3038186',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.2,NULL,NULL,NULL,NULL,NULL,1,215.563333,30.63856,0,NULL,60061009246,938453269,14663332,18.13),(119956,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119956,37.29,0.67,287,53075,70,NULL,NULL,'2MASX J14221524-3458422',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,215.5635,-34.97839,0.189,NULL,47008157861,734502466,11476601,14.4),(119957,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119957,36.94,0.27,244,53076,70,NULL,NULL,'2MASX J14221552+1750036',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.25',0.14,NULL,NULL,NULL,NULL,NULL,1,215.564625,17.83422,0,NULL,59487889193,929498268,14523410,18.25),(119958,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119958,37.47,0.07,312,53077,70,NULL,NULL,'2MASX J14221570+4833441',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000182,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.5654583,48.56228,0.027,NULL,59248570895,925758920,14464983,17.9),(119959,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119959,38.12,0.33,422,53078,70,NULL,NULL,'2MASX J14221624+1842300',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.567917,18.70847,0,NULL,59518271514,929972992,14530828,17.4),(119960,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119960,37.4,0.15,302,53079,70,NULL,NULL,'2MASX J14221656+3020106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.71',0.14,NULL,NULL,NULL,NULL,NULL,1,215.569125,30.33622,0,NULL,60061618253,938462785,14663481,18.71),(119961,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119961,36.55,0.33,204,53080,70,NULL,NULL,'2MASXi J1422166+263158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.569333333,26.53306,0,NULL,60054893302,938357707,14661839,17.3),(119962,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119962,38.25,0.46,446,53081,70,NULL,NULL,'2MASX J14221691+2203090',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.17',0.19,NULL,NULL,NULL,NULL,NULL,1,215.5705417,22.05258,0.022,NULL,59514309835,929911091,14529860,18.17),(119963,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3df',NULL,119963,41.79,0.03,1580,53082,70,NULL,'SIFTO','SNLS 06D3df',0.442,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.571708333,52.95769,0,NULL,59198242050,924972532,14452695,NULL),(119964,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3df',NULL,119964,41.98,0.12,1720,53082,70,NULL,'SALT 2','SNLS 06D3df',0.442,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119965,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3df',NULL,119965,41.99,0.15,1730,53082,NULL,NULL,'SIFTO','SNLS 06D3df',0.442,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119966,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 06D3df',NULL,119966,43.43,0.17,3370,53082,NULL,NULL,'SALT2','SNLS 06D3df',0.442,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119967,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119967,37.47,0.07,312,53083,70,NULL,NULL,'2MASX J14221731+4832441',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.5722917,48.54567,0.027,NULL,59248564783,925758824,14464981,16.6),(119968,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119968,37.84,0.46,369,53084,70,NULL,NULL,'2MASX J14221770+2215020',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.16',0.19,NULL,NULL,NULL,NULL,NULL,1,215.573875,22.25047,0.033,NULL,59516287643,929941994,14530343,18.16),(119969,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119969,37.17,0.46,272,53085,70,NULL,NULL,'SDSS J142218.35+505111.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000165,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.5764583,50.85308,0.005,NULL,59195264151,924926002,14451968,18.2),(119970,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119970,37.33,0.46,293,53086,70,NULL,NULL,'2MASX J14221910+1747516',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.05',0.18,NULL,NULL,NULL,NULL,NULL,1,215.5795417,17.79767,0,NULL,59487895113,929498361,14523411,18.05),(119971,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119971,37.35,0.33,295,53087,70,NULL,NULL,'2MASX J14221957+3038282',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.88',0.21,NULL,NULL,NULL,NULL,NULL,1,215.581625,30.64122,0,NULL,60061009569,938453274,14663332,16.88),(119972,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119972,36.21,0.46,174,53088,70,NULL,NULL,'2MASX J14221965+5148391',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.582,51.81094,0.005,NULL,59196250980,924941421,14452209,17.3),(119973,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119973,37.3,0.46,289,53089,70,NULL,NULL,'2MASX J14221967+3128132',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.01',0.19,NULL,NULL,NULL,NULL,NULL,1,215.582125,31.47039,0,NULL,60047098330,938235911,14659936,18.01),(119974,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119974,37.3,0.46,289,53090,70,NULL,NULL,'2MASX J14222181+1758336',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.79',0.12,NULL,NULL,NULL,NULL,NULL,1,215.590917,17.97603,0,NULL,59485876024,929466812,14522918,17.79),(119975,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',119975,37.47,0.07,312,53091,70,NULL,NULL,'SDSS J142221.91+483205.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.5912917,48.53486,0.027,NULL,59248565313,925758833,14464981,18.3),(119976,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lc',NULL,119976,41.58,0.17,1420,53092,NULL,NULL,'SALT2','SNLS 05D3lc',0.461,'2010A&A...523A...7G',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,215.5955,52.47886,0,NULL,59195603823,924931309,14452051,NULL),(119977,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lc',NULL,119977,42.11,0.11,1810,53092,70,NULL,'SALT 2','SNLS 05D3lc',0.461,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119978,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lc',NULL,119978,42.12,0.15,1820,53092,NULL,NULL,'SIFTO','SNLS 05D3lc',0.461,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119979,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3lc',NULL,119979,42.25,0.03,1930,53092,70,NULL,'SALT2','SNLS 05D3lc',0.461,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119980,'Cepheids','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119980,31.71,0.04,22,53093,NULL,NULL,'V, I, NIR (W), 78, Syst. +/- 0.32 mag','NGC 5584',NULL,'2013MNRAS.434.2866F',2013,1,2.45,'The APM image refers to part of the galaxy east of the nucleus.','G',0.000013,NULL,'13.3g',1.63,'SAB(rs)cd','Isolated galaxy',NULL,NULL,NULL,1,215.5990417,-0.38767,0.145,NULL,43506417829,679787778,10621684,13.3),(119981,'Cepheids','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119981,31.72,0.07,22.1,53093,NULL,NULL,'SNIa calibrated','NGC 5584',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119982,'Cepheids','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119982,31.76,0.07,22.5,53093,74.4,NULL,NULL,'NGC 5584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119983,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119983,31.34,0.37,18.4,53093,74.2,NULL,'SALT 2','NGC 5584',0.005464,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119984,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119984,31.72,0.07,22.1,53093,NULL,NULL,'MLCS2k2, Cepheids calibrated','NGC 5584',NULL,'2011ApJ...730..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119985,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119985,31.76,0.07,22.5,53093,74.4,NULL,NULL,'NGC 5584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119986,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119986,31.9,NULL,24,53093,72,NULL,'Malmquist cor.','NGC 5584',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119987,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119987,31.93,0.01,24.3,53093,72,NULL,'M(H) = -18.317 mag','NGC 5584',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119988,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119988,32.29,0.1,28.6,53093,72,NULL,'MLCS2k2, R(V) = 3.1','NGC 5584',0.005464,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119989,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SN 2007af',NULL,119989,32.3,0.08,28.7,53093,72,NULL,'MLCS2k2, R(V) = 1.7','NGC 5584',0.005464,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119990,'TRGB','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119990,31.76,0.04,22.5,53093,NULL,NULL,'I','NGC 5584',NULL,'2015ApJ...807..133J',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119991,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119991,30.69,0.69,13.7,53093,100,NULL,'mid-IR','NGC 5584',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119992,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119992,31.28,0.43,18,53093,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119993,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119993,31.29,0.43,18.1,53093,75,NULL,'3.6 micron, color corrected','NGC 5584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119994,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119994,31.36,0.4,18.7,53093,75,NULL,'HOSTS SN 2007af','NGC 5584',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119995,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119995,31.36,0.4,18.7,53093,75,NULL,'HOSTS SN 2007af','NGC 5584',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119996,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119996,31.41,0.42,19.1,53093,NULL,18.48,'3.6 micron','NGC 5584',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119997,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119997,31.48,0.52,19.7,53093,NULL,NULL,'Malmquist cor.','NGC 5584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119998,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119998,31.59,0.49,20.8,53093,NULL,NULL,NULL,'NGC 5584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(119999,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,119999,31.76,0.07,22.5,53093,74.4,NULL,NULL,'NGC 5584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120000,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120000,32.12,0.4,26.5,53093,NULL,NULL,'mean','NGC 5584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120001,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120001,32.19,0.4,27.4,53093,75,NULL,'B','NGC 5584',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120002,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120002,32.5,0.47,31.7,53093,NULL,NULL,'H','NGC 5584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120003,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120003,32.66,0.45,34,53093,NULL,NULL,'K','NGC 5584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120004,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120004,32.67,0.46,34.3,53093,NULL,NULL,'J','NGC 5584',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120005,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120005,37.49,0.46,315,53094,70,NULL,NULL,'2MASX J14222401+6431110',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.600417,64.51961,0.041,NULL,57947446496,905428851,14147325,16.9),(120006,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120006,33.66,0.48,53.8,53095,70,NULL,NULL,'ESO 385- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000047,NULL,'13.84',0.7,'(R\')SA:(r)b','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,215.60575,-34.36539,0.237,NULL,47008979983,734515312,11476801,13.84),(120007,'IRAS','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120007,33.69,0.8,54.7,53095,75,NULL,'HMCL, I','ESO 385- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120008,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120008,32.9,0.4,38,53095,75,NULL,'HMCL, I, raw','ESO 385- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120009,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120009,33.05,0.4,40.7,53095,75,NULL,'HMCL, I, inv','ESO 385- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120010,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120010,33.18,0.4,43.2,53095,75,NULL,'HMCL, I, cor','ESO 385- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120011,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120011,33.41,0.47,48.1,53095,NULL,NULL,'H','ESO 385- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120012,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120012,33.52,0.46,50.6,53095,NULL,NULL,'J','ESO 385- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120013,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120013,33.54,0.45,51,53095,NULL,NULL,'K','ESO 385- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120014,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120014,33.7,0.4,55.1,53095,NULL,NULL,'mean','ESO 385- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120015,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120015,33.75,0.2,56.2,53095,74.4,NULL,NULL,'ESO 385- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120016,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120016,37.57,0.33,326,53096,70,NULL,NULL,'2MASX J14222595+0407387',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000114,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.608083,4.12744,0.045,NULL,58296585039,910884141,14232564,16.9),(120017,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120017,38.02,0.19,402,53097,70,NULL,NULL,'2MASX J14222601+4443152',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,215.608333,44.72083,0,NULL,59230759652,925480619,14460634,17.8),(120018,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120018,37.47,0.07,312,53098,70,NULL,NULL,'2MASX J14222623+4752552',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.609208333,47.88197,0.006,NULL,59248155917,925752436,14464881,17.6),(120019,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120019,40.63,0.14,997,53099,74.2,NULL,'SALT 2','[HSP2005] J142226.72+522000.92',0.34,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.0002,NULL,'22.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.611083,52.33339,0,NULL,59196101564,924939086,14452173,22.6),(120020,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh','R',120020,40.69,NULL,1030,53099,65,NULL,'SALT','[HSP2005] J142226.72+522000.92',0.34,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120021,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120021,41.26,0.12,1330,53099,70,NULL,'SALT','[HSP2005] J142226.72+522000.92',0.34,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120022,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120022,41.3,0.03,1360,53099,70,NULL,'SALT 2','[HSP2005] J142226.72+522000.92',0.34,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120023,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120023,41.32,0.01,1370,53099,70,NULL,NULL,'[HSP2005] J142226.72+522000.92',0.34,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120024,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120024,41.36,0.11,1400,53099,70,NULL,'SALT 2','[HSP2005] J142226.72+522000.92',0.34,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120025,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120025,41.39,0.07,1410,53099,65,NULL,'SALT2','[HSP2005] J142226.72+522000.92',0.34,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120026,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120026,41.4,0.15,1420,53099,NULL,NULL,'SIFTO','[HSP2005] J142226.72+522000.92',0.34,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120027,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120027,41.41,0.09,1430,53099,65,NULL,'SALT','[HSP2005] J142226.72+522000.92',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120028,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120028,41.41,NULL,1430,53099,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[HSP2005] J142226.72+522000.92',0.34,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120029,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120029,41.49,0.16,1480,53099,65,NULL,'SALT2','[HSP2005] J142226.72+522000.92',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120030,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120030,41.54,0.08,1510,53099,65,NULL,'MLCS2k2','[HSP2005] J142226.72+522000.92',0.34,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120031,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120031,41.57,0.15,1530,53099,65,NULL,'MLCS17','[HSP2005] J142226.72+522000.92',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120032,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120032,41.6,0.01,1560,53099,65,NULL,'SALT','[HSP2005] J142226.72+522000.92',0.34,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120033,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120033,41.61,0.16,1570,53099,65,NULL,'MLCS31','[HSP2005] J142226.72+522000.92',0.34,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120034,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120034,41.64,0.14,1580,53099,65,NULL,'MLCS2k2','[HSP2005] J142226.72+522000.92',0.34,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120035,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 04D3nh',NULL,120035,42.2,0.17,2060,53099,NULL,NULL,'SALT2','[HSP2005] J142226.72+522000.92',0.34,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120036,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120036,38.46,0.46,492,53100,70,NULL,NULL,'2MASX J14222730+4553302',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.613917,45.89183,0,NULL,59231909773,925498590,14460915,18),(120037,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120037,31.01,0.43,16,53101,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09206',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000005,NULL,'14.9',0.4,'Pec','Group member',NULL,NULL,NULL,1,215.6140417,15.08683,0,NULL,59478100626,929345322,14521020,14.9),(120038,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120038,34.11,0.33,66.5,53102,70,NULL,NULL,'NGC 5598',NULL,'2015arXiv151105856S',2015,1,1.24,NULL,'G',0.000103,NULL,'13.7g',0.85,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,215.617833333,40.31981,0,NULL,59945462497,936647851,14635122,13.7),(120039,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120039,34.57,0.4,82,53102,NULL,NULL,'mean','NGC 5598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120040,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120040,34.73,0.45,88.2,53102,NULL,NULL,'K','NGC 5598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120041,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120041,38.42,0.46,482,53103,70,NULL,NULL,'2MASX J14222842+0445077',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000094,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.6185,4.75203,0.053,NULL,58293183167,910830986,14231734,17.2),(120042,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120042,33.63,0.46,53.2,53104,70,NULL,NULL,'NGC 5596',NULL,'2015arXiv151105856S',2015,1,1.13,NULL,'G',0.000043,NULL,'14.0g',0.74,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,215.61975,37.12219,0,NULL,60031416406,937990881,14656107,14),(120043,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120043,33.43,0.4,48.5,53104,NULL,NULL,'mean','NGC 5596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120044,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,NULL,120044,34.09,0.45,65.8,53104,NULL,NULL,'K','NGC 5596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120045,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120045,37.11,0.46,265,53105,70,NULL,NULL,'2MASX J14222923+4039313',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000166,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,215.621833333,40.65886,0,NULL,59945327774,936645746,14635089,16.3),(120046,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120046,36.66,0.23,215,53106,70,NULL,NULL,'SDSS J142230.16+285804.3',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000187,NULL,'15.6g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.625667,28.96786,0,NULL,60059856890,938435263,14663050,15.6),(120047,'FP','2016-12-15 15:15:24','2016-12-16 11:20:37','1',NULL,'R',120047,37.47,0.07,312,53107,70,NULL,NULL,'2MASX J14223041+4836331',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.626417,48.60925,0.039,NULL,59248593137,925759267,14464988,17.4),(120048,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dd',NULL,120048,42.12,0.11,1800,53108,70,NULL,'SALT 2','[NSB2006] J142230.41+523624.7',0.48,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.6267083,52.60689,0,NULL,59197504353,924961005,14452515,NULL),(120049,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dd',NULL,120049,42.12,0.04,1800,53108,70,NULL,'SALT2','[NSB2006] J142230.41+523624.7',0.48,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120050,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:37','1','SNLS 05D3dd',NULL,120050,42.12,0.17,1800,53108,NULL,NULL,'SALT2','[NSB2006] J142230.41+523624.7',0.48,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120051,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 05D3dd',NULL,120051,42.18,0.15,1850,53108,NULL,NULL,'SIFTO','[NSB2006] J142230.41+523624.7',0.48,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120052,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120052,34.93,0.46,96.7,53109,70,NULL,NULL,'CGCG 075-021',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00016,NULL,'14.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,215.62825,11.30489,0,NULL,58486075195,913844924,14278826,14.8),(120053,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120053,37.29,0.33,287,53110,70,NULL,NULL,'2MASX J14223184+2312067',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000192,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.6327917,23.20189,0.043,NULL,59516791062,929949860,14530466,17),(120054,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120054,37.7,0.46,347,53111,70,NULL,NULL,'2MASX J14223199+2826079',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'18.20',0.13,NULL,NULL,NULL,NULL,NULL,1,215.633333,28.43542,0,NULL,60055376968,938365265,14661957,18.2),(120055,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120055,36.68,0.46,217,53112,70,NULL,NULL,'SDSS J142232.07+121748.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.633625,12.29681,0,NULL,58351346954,911739796,14245934,17.5),(120056,'Tully-Fisher','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,NULL,120056,30.84,0.4,14.7,53113,75,NULL,'B','UGC 09211',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000003,NULL,'15.0',1.4,'Im:',NULL,NULL,NULL,NULL,1,215.6340417,45.38386,0,NULL,59230989903,925484217,14460690,15),(120057,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120057,37.92,0.46,383,53114,70,NULL,NULL,'2MASX J14223225+2629179',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.634333,26.48833,0,NULL,60054886644,938357603,14661837,18),(120058,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120058,38.23,0.46,442,53115,70,NULL,NULL,'SDSS J142232.35+143003.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.634833,14.50111,0,NULL,59479297781,929364027,14521312,18.4),(120059,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120059,34.61,0.33,83.5,53116,70,NULL,NULL,'CGCG 220-008',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000173,NULL,'15.2g',0.45,'E0',NULL,NULL,NULL,NULL,1,215.635291667,39.58494,0,NULL,60063163865,938486935,14663858,15.2),(120060,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120060,41.07,0.14,1130,53117,74.2,NULL,'SALT 2','[AGR2006] J142232.61+523849.3',0.451,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',0.001,NULL,'22.0g',0.06,NULL,NULL,NULL,NULL,NULL,1,215.63575,52.64697,0,NULL,59197505509,924961023,14452515,22),(120061,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120061,41.35,0.21,1280,53117,65,NULL,'MLCS2k2','[AGR2006] J142232.61+523849.3',0.451,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120062,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120062,41.34,0.23,1280,53117,65,NULL,'MLCS31','[AGR2006] J142232.61+523849.3',0.451,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120063,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120063,41.65,0.17,1470,53117,NULL,NULL,'SALT2','[AGR2006] J142232.61+523849.3',0.451,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120064,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120064,41.66,0.1,1480,53117,65,NULL,'MLCS2k2','[AGR2006] J142232.61+523849.3',0.451,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120065,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120065,41.7,0.12,1510,53117,70,NULL,'SALT 2','[AGR2006] J142232.61+523849.3',0.451,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120066,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120066,41.71,0.15,1510,53117,NULL,NULL,'SIFTO','[AGR2006] J142232.61+523849.3',0.451,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120067,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120067,41.75,0.08,1540,53117,65,NULL,'SALT2','[AGR2006] J142232.61+523849.3',0.451,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120068,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120068,41.8,0.17,1580,53117,65,NULL,'MLCS17','[AGR2006] J142232.61+523849.3',0.451,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120069,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120069,41.85,0.14,1620,53117,70,NULL,'SALT','[AGR2006] J142232.61+523849.3',0.451,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120070,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt','R',120070,41.87,NULL,1630,53117,65,NULL,'MLCS31','[AGR2006] J142232.61+523849.3',0.451,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120071,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120071,41.91,0.11,1660,53117,65,NULL,'SALT','[AGR2006] J142232.61+523849.3',0.451,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120072,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120072,41.92,0.17,1670,53117,65,NULL,'SALT2','[AGR2006] J142232.61+523849.3',0.451,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120073,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120073,42.04,0.03,1760,53117,70,NULL,NULL,'[AGR2006] J142232.61+523849.3',0.451,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120074,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120074,42.3,0.03,1990,53117,65,NULL,'SALT','[AGR2006] J142232.61+523849.3',0.451,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120075,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3gt',NULL,120075,43.21,0.03,3020,53117,70,NULL,'SALT 2','[AGR2006] J142232.61+523849.3',0.451,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120076,'SNII optical','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SN 2003ga',NULL,120076,41.22,0.79,1050,53118,NULL,NULL,'SEAM','LSSP J142233.04+522253.9',0.29,'2009ApJ...694.1067P',2009,1,NULL,NULL,'G',NULL,NULL,'23.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.637666667,52.38164,0,NULL,59195593307,924931145,14452049,23),(120077,'SNII optical','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SN 2003ga',NULL,120077,41.1,0.4,1660,53118,NULL,NULL,'SNLS 03D3ce','LSSP J142233.04+522253.9',NULL,'2006ApJ...645..841N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120078,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120078,36.28,0.46,181,53119,70,NULL,NULL,'2MASX J14223306+3333042',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.63775,33.55133,0,NULL,60040017161,938125268,14658207,16.6),(120079,'FP','2016-12-15 15:15:24','2016-12-16 11:20:38','1',NULL,'R',120079,37.47,0.07,312,53120,70,NULL,NULL,'2MASX J14223317+4817221',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.638583,48.28947,0.027,NULL,59248731691,925761432,14465022,17.7),(120080,'SNIa','2016-12-15 15:15:24','2016-12-16 11:20:38','1','SNLS 04D3ks','R',120080,42.2,NULL,1570,53121,65,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.6395,52.18539,0,NULL,59196096220,924939003,14452171,NULL),(120081,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120081,42.61,0.21,1900,53121,74.2,NULL,'SALT 2','[AGR2006] J142233.47+521107.4',0.752,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120082,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120082,42.87,0.06,2140,53121,70,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120083,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120083,43.14,0.18,2420,53121,70,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120084,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120084,43.17,0.09,2460,53121,70,NULL,NULL,'[AGR2006] J142233.47+521107.4',0.752,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120085,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120085,43.2,0.23,2490,53121,70,NULL,'SALT 2','[AGR2006] J142233.47+521107.4',0.752,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120086,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120086,43.26,0.15,2560,53121,NULL,NULL,'SIFTO','[AGR2006] J142233.47+521107.4',0.752,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120087,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120087,43.31,0.15,2610,53121,65,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120088,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120088,43.3,0.23,2610,53121,65,NULL,'MLCS2k2','[AGR2006] J142233.47+521107.4',0.752,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120089,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120089,43.32,0.24,2640,53121,65,NULL,'MLCS17','[AGR2006] J142233.47+521107.4',0.752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120090,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120090,43.36,0.21,2680,53121,65,NULL,'MLCS2k2','[AGR2006] J142233.47+521107.4',0.752,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120091,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120091,43.36,0.22,2680,53121,65,NULL,'MLCS31','[AGR2006] J142233.47+521107.4',0.752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120092,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120092,43.44,0.08,2780,53121,65,NULL,'SALT','[AGR2006] J142233.47+521107.4',0.752,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120093,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120093,43.44,0.18,2780,53121,65,NULL,'SALT2','[AGR2006] J142233.47+521107.4',0.752,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120094,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120094,43.48,0.21,2830,53121,65,NULL,'SALT2','[AGR2006] J142233.47+521107.4',0.752,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120095,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3ks',NULL,120095,44.06,0.17,3700,53121,NULL,NULL,'SALT2','[AGR2006] J142233.47+521107.4',0.752,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120096,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120096,37.47,0.07,312,53122,70,NULL,NULL,'2MASX J14223480+4755080',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000197,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.645041667,47.91894,0.006,NULL,59248154831,925752419,14464881,17.1),(120097,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120097,37.8,0.46,363,53123,70,NULL,NULL,'2MASX J14223494+1050555',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.52',0.13,NULL,NULL,NULL,NULL,NULL,1,215.645667,10.84867,0,NULL,58488834938,913888045,14279500,18.52),(120098,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120098,36.66,0.23,215,53124,70,NULL,NULL,'2MASX J14223518+2848149',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000264,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,215.6465,28.80411,0,NULL,60059838522,938434976,14663046,16.3),(120099,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120099,38.19,0.46,435,53125,70,NULL,NULL,'2MASX J14223539+2758349',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.6475417,27.97622,0,NULL,60057372832,938396450,14662444,18),(120100,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120100,36.08,0.74,164,53126,70,NULL,NULL,'2MASX J14223556-3317226',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.2b',0.3,'Sp',NULL,NULL,NULL,NULL,1,215.648166667,-33.28956,0.265,NULL,46999201100,734362517,11474414,16.2),(120101,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120101,37.47,0.07,312,53127,70,NULL,NULL,'2MASX J14223646+4835180',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000192,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.652083,48.58836,0.039,NULL,59248593359,925759271,14464988,16.5),(120102,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120102,37.31,0.33,290,53128,70,NULL,NULL,'2MASX J14223701+2013437',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.12',0.17,NULL,NULL,NULL,NULL,NULL,1,215.654125,20.22886,0,NULL,59525165586,930080712,14532511,17.12),(120103,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120103,37.31,0.33,290,53129,70,NULL,NULL,'SDSS J142237.78+201604.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.6575,20.26783,0,NULL,59525168859,930080763,14532511,17.7),(120104,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3km',NULL,120104,43.56,0.08,2620,53130,70,NULL,'SIFTO','SNLS 05D3km HOST',0.97,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'a',NULL,NULL,NULL,NULL,1,215.659583,53.06697,0,NULL,59198343729,924974120,14452720,NULL),(120105,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3km',NULL,120105,44.36,0.21,3780,53130,70,NULL,'SALT 2','SNLS 05D3km HOST',0.97,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120106,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3km',NULL,120106,44.44,0.15,3920,53130,NULL,NULL,'SIFTO','SNLS 05D3km HOST',0.97,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120107,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3km',NULL,120107,45.11,0.17,5350,53130,NULL,NULL,'SALT2','SNLS 05D3km HOST',0.97,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120108,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr','R',120108,42.79,NULL,1850,53131,65,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.6605417,52.64886,0,NULL,59197504837,924961013,14452515,NULL),(120109,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120109,42.89,0.28,1930,53131,74.2,NULL,'SALT 2','[HSP2005] J142238.52+523855.89',0.96,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120110,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120110,43.59,0.43,2670,53131,70,NULL,'SALT','[HSP2005] J142238.52+523855.89',0.96,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120111,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120111,43.62,0.23,2710,53131,70,NULL,NULL,'[HSP2005] J142238.52+523855.89',0.96,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120112,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120112,43.66,0.28,2750,53131,65,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120113,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120113,43.7,0.25,2810,53131,70,NULL,'SALT 2','[HSP2005] J142238.52+523855.89',0.96,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120114,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120114,43.71,0.34,2810,53131,65,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120115,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120115,43.72,0.15,2830,53131,NULL,NULL,'SIFTO','[HSP2005] J142238.52+523855.89',0.96,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120116,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120116,43.72,0.4,2830,53131,65,NULL,'SALT','[HSP2005] J142238.52+523855.89',0.96,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120117,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120117,43.83,0.08,2970,53131,70,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120118,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120118,43.89,0.17,3060,53131,65,NULL,'SALT','[HSP2005] J142238.52+523855.89',0.96,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120119,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120119,43.9,0.28,3070,53131,65,NULL,'MLCS2k2','[HSP2005] J142238.52+523855.89',0.96,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120120,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120120,44.22,0.17,3560,53131,NULL,NULL,'SALT2','[HSP2005] J142238.52+523855.89',0.96,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120121,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120121,44.29,0.13,3680,53131,65,NULL,'MLCS2k2','[HSP2005] J142238.52+523855.89',0.96,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120122,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120122,44.29,0.22,3680,53131,65,NULL,'MLCS17','[HSP2005] J142238.52+523855.89',0.96,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120123,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 04D3nr',NULL,120123,44.34,0.18,3770,53131,65,NULL,'MLCS31','[HSP2005] J142238.52+523855.89',0.96,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120124,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120124,38.26,0.46,449,53132,70,NULL,NULL,'2MASX J14224086+4629161',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.670333,46.48789,0.01,NULL,59231686783,925495105,14460861,18),(120125,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120125,36.66,0.23,215,53133,70,NULL,NULL,'2MASX J14224096+2851238',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'16.76',0.28,'S0',NULL,NULL,NULL,NULL,1,215.670583333,28.85669,0,NULL,60059833952,938434905,14663045,16.76),(120126,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120126,37.12,0.33,266,53134,70,NULL,NULL,'2MASX J14224153+0424207',NULL,'2015arXiv151105856S',2015,1,0.62,'Two MAPS entries for the same object.','G',0.00014,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,215.6732083,4.40581,0.049,NULL,58295951528,910874242,14232410,15.5),(120127,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3gp',NULL,120127,42.33,0.17,1850,53135,NULL,NULL,'SALT2','[NSB2006] J142242.33+524328.7',0.58,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,'23.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,215.676167,52.72442,0,NULL,59197499884,924960935,14452514,23.7),(120128,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3gp',NULL,120128,42.64,0.06,2130,53135,70,NULL,'SALT2','[NSB2006] J142242.33+524328.7',0.58,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120129,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3gp',NULL,120129,42.79,0.17,2280,53135,70,NULL,'SALT 2','[NSB2006] J142242.33+524328.7',0.58,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120130,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SNLS 05D3gp',NULL,120130,42.82,0.15,2320,53135,NULL,NULL,'SIFTO','[NSB2006] J142242.33+524328.7',0.58,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120131,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120131,37.47,0.07,312,53136,70,NULL,NULL,'2MASX J14224339+4833180',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,215.680667,48.555,0.039,NULL,59248591561,925759243,14464988,16.7),(120132,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120132,36.49,0.46,199,53137,70,NULL,NULL,'2MASX J14224345+3049582',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.53',0.3,NULL,NULL,NULL,NULL,NULL,1,215.68125,30.83294,0,NULL,60061108600,938454821,14663356,16.53),(120133,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120133,36.73,0.46,222,53138,70,NULL,NULL,'2MASX J14224384+2526448',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,215.6827917,25.44567,0,NULL,60054291360,938348302,14661692,16.5),(120134,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120134,37.85,0.33,372,53139,70,NULL,NULL,'2MASX J14224558+1702525',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.689833333,17.04792,0,NULL,59488191737,929502995,14523484,17.9),(120135,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120135,38.04,0.23,406,53140,70,NULL,NULL,'2MASX J14224593+5639532',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,215.69125,56.66469,0,NULL,57256601927,894634405,13978662,18.4),(120136,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120136,37.76,0.46,356,53141,70,NULL,NULL,'2MASX J14224587+1836586',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.6912917,18.61625,0,NULL,59518278184,929973096,14530829,17.8),(120137,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120137,37.25,0.27,282,53142,70,NULL,NULL,'2MASX J14224602+4507501',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.691667,45.13069,0,NULL,59230556362,925477443,14460585,17.9),(120138,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120138,37.95,0.46,389,53143,70,NULL,NULL,'SDSS J142246.18+055339.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.692458333,5.89417,0.037,NULL,58301738421,910964662,14233822,18.2),(120139,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120139,37.39,0.33,301,53144,70,NULL,NULL,'2MASX J14224657+1552275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.04',0.17,NULL,NULL,NULL,NULL,NULL,1,215.694125,15.8745,0,NULL,59489229280,929519207,14523737,18.04),(120140,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120140,35.32,0.47,116,53145,NULL,NULL,'H','UGC 09213',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000047,NULL,'14.4g',0.59,'Sb',NULL,NULL,NULL,NULL,1,215.694541667,37.99525,0,NULL,60064059988,938500937,14664077,14.4),(120141,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120141,35.39,0.4,120,53145,NULL,NULL,'mean','UGC 09213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120142,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120142,35.49,0.46,125,53145,NULL,NULL,'J','UGC 09213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120143,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120143,35.49,0.45,125,53145,NULL,NULL,'K','UGC 09213',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120144,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120144,35.72,0.46,139,53146,70,NULL,NULL,'2MASX J14224716+3342452',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'15.5g',0.51,NULL,NULL,NULL,NULL,NULL,1,215.696583,33.71256,0,NULL,60040125427,938126959,14658233,15.5),(120145,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120145,37.85,0.33,372,53147,70,NULL,NULL,'2MASX J14224788+1706185',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.6995,17.10525,0,NULL,59488194436,929503038,14523484,16.8),(120146,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120146,36.66,0.23,215,53148,70,NULL,NULL,'2MASX J14224819+2853358',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000186,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,215.700833,28.89339,0,NULL,60059833241,938434894,14663045,15.9),(120147,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120147,37.69,0.46,344,53149,70,NULL,NULL,'2MASX J14224860+4326521',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.702375,43.44783,0,NULL,59224682664,925385666,14459151,17.8),(120148,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120148,37.87,0.46,375,53150,70,NULL,NULL,'LCRS B142013.6-023356',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.704667,-2.79242,0.149,NULL,43518289756,679973277,10624582,17.5),(120149,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120149,37.47,0.07,312,53151,70,NULL,NULL,'2MASX J14224965+4834062',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.7065417,48.56836,0.039,NULL,59248591179,925759237,14464988,17.1),(120150,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120150,37.25,0.27,282,53152,70,NULL,NULL,'2MASX J14225074+4509211',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.7115,45.15589,0,NULL,59230527529,925476992,14460578,17.4),(120151,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120151,37.54,0.33,323,53153,70,NULL,NULL,'2MASX J14225144+5603513',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.714333333,56.06417,0.005,NULL,57256852314,894638317,13978723,17.4),(120152,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120152,37.44,0.46,307,53154,70,NULL,NULL,'2MASX J14225239+4455131',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.7182917,44.92042,0,NULL,59230667784,925479184,14460612,17.1),(120153,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120153,38.27,0.46,452,53155,70,NULL,NULL,'2MASX J14225465+5902383',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.727416667,59.044,0.033,NULL,57269165546,894830711,13981729,17.9),(120154,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120154,37.25,0.27,282,53156,70,NULL,NULL,'2MASX J14225490+4508521',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.72875,45.14783,0,NULL,59230654485,925478976,14460609,17.4),(120155,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120155,35.64,0.47,134,53157,NULL,NULL,'H','UGC 09214',NULL,'2007A&A...465...71T',2007,1,0.89,NULL,'G',0.00002,NULL,'14.3g',0.6,'SBa            Sy1.8',NULL,NULL,NULL,'Sy 2',1,215.7307083,32.85075,0,NULL,60039448867,938116388,14658068,14.3),(120156,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120156,35.79,0.45,144,53157,NULL,NULL,'K','UGC 09214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120157,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120157,35.82,0.46,146,53157,NULL,NULL,'J','UGC 09214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120158,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120158,35.84,0.4,147,53157,NULL,NULL,'mean','UGC 09214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120159,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120159,37.47,0.07,312,53158,70,NULL,NULL,'2MASX J14225553+4747141',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000219,NULL,'16.3g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,215.7314583,47.78722,0,NULL,59248210299,925753285,14464895,16.3),(120160,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120160,37.54,0.33,323,53159,70,NULL,NULL,'2MASX J14225585+5606343',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.1g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,215.73275,56.10958,0.005,NULL,57256840005,894638125,13978720,16.1),(120161,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120161,37.39,0.33,301,53160,70,NULL,NULL,'2MASX J14225717+1551425',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.73825,15.86178,0,NULL,59491116233,929548691,14524198,NULL),(120162,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120162,35.65,0.46,135,53161,70,NULL,NULL,'IC 4413',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000185,NULL,'15.3g',0.54,'E',NULL,NULL,NULL,NULL,1,215.738833,37.52742,0,NULL,60031386466,937990413,14656100,15.3),(120163,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120163,38.1,0.46,417,53162,70,NULL,NULL,'2MASX J14225811+4401471',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.74225,44.02994,0,NULL,59230078133,925469970,14460468,17.7),(120164,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120164,38.19,0.46,434,53163,70,NULL,NULL,'2MASX J14230088+0054190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000085,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.7537083,0.90522,0.081,NULL,58285540992,910711578,14229868,17.5),(120165,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120165,36.64,0.46,213,53164,70,NULL,NULL,'VIII Zw 406',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000104,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,215.754083,0.79436,0.081,NULL,58285529702,910711401,14229865,15.8),(120166,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120166,36.54,0.46,204,53165,70,NULL,NULL,'SDSS J142301.14+204356.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.7547917,20.73225,0.008,NULL,59525320759,930083136,14532549,17.4),(120167,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120167,34.11,0.33,66.5,53166,70,NULL,NULL,'NGC 5603',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000067,NULL,'13.9g',0.93,'S0','Possible field galaxy',NULL,NULL,NULL,1,215.756375,40.37742,0,NULL,59945489291,936648270,14635129,13.9),(120168,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120168,36.19,0.46,173,53167,70,NULL,NULL,'2MASX J14230197-0126204',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.75825,-1.43906,0.129,NULL,43517245948,679956967,10624327,17.2),(120169,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120169,32.97,0.4,39.2,53168,75,NULL,'Edat, raw','ESO 385- G 017',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000113,NULL,'14.03',0.9,'E4','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,215.760333,-34.29192,0.237,NULL,47006089857,734470154,11476096,14.03),(120170,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120170,33.3,0.4,45.7,53168,75,NULL,'Edat, cor','ESO 385- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120171,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120171,35.22,0.46,111,53169,70,NULL,NULL,'UGC 09212',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00019,NULL,'14.56',0.6,'S0',NULL,NULL,NULL,NULL,1,215.766291667,18.27917,0,NULL,59485756432,929464944,14522889,14.56),(120172,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120172,36.63,0.27,212,53170,70,NULL,NULL,'SDSS J142305.73+023013.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,215.773916667,2.50364,0.049,NULL,58300411310,910943926,14233498,17.9),(120173,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120173,36.28,0.15,180,53171,70,NULL,NULL,'2MASX J14230578+2617358',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,215.7742917,26.29328,0,NULL,60055046717,938360104,14661876,16.7),(120174,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120174,37.5,0.46,317,53172,70,NULL,NULL,'2MASX J14230610+0542060',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000204,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,215.775375,5.70169,0.037,NULL,58301862008,910966593,14233853,16.3),(120175,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120175,36.8,0.46,229,53173,70,NULL,NULL,'2MASX J14230685+5356533',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.7785417,53.94825,0,NULL,59196801197,924950018,14452344,17.7),(120176,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120176,37.98,0.46,395,53174,70,NULL,NULL,'LCRS B142031.5-021523',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.778625,-2.48289,0.157,NULL,43519464972,679991640,10624869,18.7),(120177,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120177,36.66,0.46,215,53175,70,NULL,NULL,'2MASX J14230813+1604475',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.17',0.17,NULL,NULL,NULL,NULL,NULL,1,215.783875,16.07986,0,NULL,59491147469,929549179,14524205,18.17),(120178,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120178,37.47,0.07,312,53176,70,NULL,NULL,'SDSS J142308.37+474757.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.784875,47.79928,0,NULL,59248203028,925753172,14464893,17.7),(120179,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120179,37.04,0.46,256,53177,70,NULL,NULL,'2MASX J14230871+2052593',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,215.7862917,20.88311,0.008,NULL,59525346584,930083540,14532555,18),(120180,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120180,34.67,0.46,85.7,53178,70,NULL,NULL,'CGCG 019-010',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000083,NULL,'14.8g',0.59,'S0^-',NULL,NULL,NULL,NULL,1,215.78725,1.67158,0.045,NULL,58300019245,910937800,14233403,14.8),(120181,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120181,36.28,0.15,180,53179,70,NULL,NULL,'SDSS J142309.29+261601.5',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000178,NULL,'16.2g',0.39,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.78875,26.26711,0,NULL,60055057481,938360273,14661879,16.2),(120182,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120182,37.29,0.33,287,53180,70,NULL,NULL,'2MASX J14230974+2308534',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,215.790583,23.14808,0.058,NULL,59516971106,929952673,14530510,16.4),(120183,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120183,37.54,0.33,322,53181,70,NULL,NULL,'2MASX J14231043+2532397',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.793375,25.54447,0,NULL,60054279575,938348118,14661689,17.2),(120184,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120184,37.92,0.16,383,53182,70,NULL,NULL,'2MASX J14231085+4922493',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.7950417,49.38044,0.005,NULL,59246402079,925725032,14464453,16.8),(120185,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120185,37.47,0.07,312,53183,70,NULL,NULL,'2MASX J14231172+4838123',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,215.799041667,48.63678,0.039,NULL,59248579615,925759056,14464985,16.3),(120186,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120186,35.88,0.51,150,53184,70,NULL,NULL,'MCG -02-37-001',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.000137,NULL,'15.5',0.1,NULL,NULL,NULL,NULL,NULL,1,215.8029583,-10.851,0.249,NULL,43704917615,682889337,10670145,15.5),(120187,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120187,37.54,0.33,322,53185,70,NULL,NULL,'2MASX J14231285+2534512',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000201,NULL,'16.90',0.27,NULL,NULL,NULL,NULL,NULL,1,215.8035417,25.58086,0,NULL,60054282083,938348157,14661689,16.9),(120188,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120188,35.53,0.55,128,53186,70,NULL,NULL,'ESO 222- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.3b',0.4,'S...',NULL,NULL,NULL,NULL,1,215.80675,-49.32903,0.929,NULL,46836527777,731820746,11434699,15.3),(120189,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120189,37.47,0.07,312,53187,70,NULL,NULL,'2MASX J14231385+4843393',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.807625,48.72767,0.039,NULL,59248595748,925759308,14464989,17.4),(120190,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120190,38.04,0.23,406,53188,70,NULL,NULL,'2MASX J14231420+5639363',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,215.809083,56.66,0,NULL,57256636341,894634942,13978670,16.9),(120191,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120191,36.52,0.46,202,53189,70,NULL,NULL,'2MASX J14231540+0418082',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00006,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.81425,4.30239,0.049,NULL,58296104791,910876637,14232447,16.8),(120192,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120192,37.92,0.16,383,53190,70,NULL,NULL,'2MASX J14231573+4005293',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.815417,40.09161,0,NULL,59945483216,936648175,14635127,17.1),(120193,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120193,37.78,0.46,359,53191,70,NULL,NULL,'2MASX J14231573+1115096',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000201,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,215.815583,11.25264,0,NULL,58486104105,913845376,14278834,16.5),(120194,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120194,36.63,0.27,212,53192,70,NULL,NULL,'2MASX J14231586+0231392',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,215.816,2.52753,0.049,NULL,58300535107,910945861,14233529,16.7),(120195,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120195,36.95,0.46,245,53193,70,NULL,NULL,'2MASXi J1423163+323551',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.818125,32.59783,0,NULL,60039435429,938116178,14658065,17.9),(120196,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120196,29.87,0.4,9.4,53194,73,NULL,'opt','NGC 5608',NULL,'2011A&A...532A.104N',2011,1,2.6,NULL,'G',0.00002,NULL,'13.9',1.3,'Im:            HII','Isolated galaxy',NULL,NULL,NULL,1,215.8245417,41.77589,0,NULL,59947455046,936678985,14635609,13.9),(120197,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120197,30.52,0.4,12.7,53194,75,NULL,'B','NGC 5608',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120198,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120198,31.24,0.4,17.7,53194,NULL,NULL,NULL,'NGC 5608',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120199,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120199,36.67,0.33,216,53195,70,NULL,NULL,'2MASX J14231866+1718352',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.83',0.17,NULL,NULL,NULL,NULL,NULL,1,215.8277083,17.30992,0,NULL,59488636861,929509950,14523592,17.83),(120200,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120200,37.92,0.16,383,53196,70,NULL,NULL,'2MASX J14231913+4003424',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.829833,40.06181,0,NULL,59945469050,936647953,14635124,17.5),(120201,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120201,36.63,0.27,212,53197,70,NULL,NULL,'2MASX J14231960+0223382',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000064,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,215.831583,2.39392,0.049,NULL,58300389277,910943582,14233493,16.6),(120202,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120202,37.92,0.16,383,53198,70,NULL,NULL,'2MASX J14232024+4020144',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.83425,40.3375,0,NULL,59945489744,936648277,14635129,17.2),(120203,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120203,38.04,0.46,406,53199,70,NULL,NULL,'2MASX J14232078+5356172',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.836583333,53.93808,0,NULL,59196801291,924950020,14452344,18.1),(120204,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120204,38.21,0.46,438,53200,70,NULL,NULL,'2MASX J14232112+1805023',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.838125,18.08383,0,NULL,59488058407,929500912,14523451,17.5),(120205,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120205,37.5,0.33,316,53201,70,NULL,NULL,'2MASX J14232177+4605314',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000194,NULL,'16.2g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,215.840625,46.09206,0,NULL,59231941584,925499087,14460923,16.2),(120206,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120206,37.05,0.33,257,53202,70,NULL,NULL,'2MASX J14232320+2055503',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.846667,20.93078,0.011,NULL,59525333342,930083333,14532552,17.9),(120207,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120207,36.67,0.46,216,53203,70,NULL,NULL,'2MASX J14232328+2004463',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.42',0.14,NULL,NULL,NULL,NULL,NULL,1,215.846875,20.07956,0.014,NULL,59523074722,930048042,14532000,18.42),(120208,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120208,38.03,0.46,403,53204,70,NULL,NULL,'2MASX J14232423+3656244',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000187,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.851083333,36.94014,0,NULL,60031955462,937999304,14656239,17.7),(120209,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120209,37.99,0.46,396,53205,70,NULL,NULL,'2MASX J14232523+4314295',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,215.855166667,43.24144,0,NULL,59947119098,936673735,14635527,17),(120210,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120210,38.04,0.23,406,53206,70,NULL,NULL,'2MASX J14232522+5638112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.855166667,56.63656,0,NULL,57256637362,894634958,13978671,17.4),(120211,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120211,36.28,0.15,180,53207,70,NULL,NULL,'2MASX J14232704+2612012',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.86275,26.20033,0,NULL,60054994398,938359287,14661863,16.7),(120212,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120212,31.82,0.4,23.1,53208,NULL,NULL,NULL,'UGC 09215',NULL,'2009AJ....138..323T',2009,1,2.2,'One APM position refers to the eastern side of the galaxy.','G',0.000005,NULL,'14.0g',1.3,'SB(s)d','in a radial-velocity based grouping',NULL,NULL,NULL,1,215.863,1.72631,0.045,NULL,58299863234,910935363,14233365,14),(120213,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120213,31.85,0.58,23.4,53208,NULL,NULL,'Malmquist cor.','UGC 09215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120214,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120214,31.96,0.2,24.7,53208,74.4,NULL,NULL,'UGC 09215',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120215,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120215,32.01,0.43,25.2,53208,75,NULL,'3.6 micron, color corrected','UGC 09215',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120216,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120216,32.01,0.43,25.3,53208,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09215',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120217,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120217,32.06,0.53,25.8,53208,NULL,NULL,NULL,'UGC 09215',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120218,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120218,32.06,NULL,25.8,53208,72,NULL,NULL,'UGC 09215',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120219,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120219,32.27,0.4,28.4,53208,NULL,NULL,'mean','UGC 09215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120220,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120220,33.03,0.47,40.3,53208,NULL,NULL,'H','UGC 09215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120221,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120221,37.47,0.07,312,53209,70,NULL,NULL,'2MASX J14232740+4844182',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,215.8639583,48.73839,0.039,NULL,59248578795,925759043,14464985,17),(120222,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120222,38.35,0.46,469,53210,70,NULL,NULL,'SDSS J142328.11+082026.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.867125,8.34058,0.021,NULL,58274446394,910538224,14227159,18.4),(120223,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120223,38.01,0.33,399,53211,70,NULL,NULL,'2MASX J14232848+2440372',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,215.868791667,24.67697,0,NULL,59513018161,929890908,14529545,17.5),(120224,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120224,37.78,0.46,360,53212,70,NULL,NULL,'2MASX J14232871+5155062',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.869666667,51.9185,0.005,NULL,59196207156,924940736,14452199,18),(120225,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120225,37.44,0.33,308,53213,70,NULL,NULL,'2MASX J14232888+2955332',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.29',0.17,NULL,NULL,NULL,NULL,NULL,1,215.8704583,29.92606,0,NULL,60061540969,938461577,14663462,18.29),(120226,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120226,37.05,0.33,257,53214,70,NULL,NULL,'2MASX J14232910+2056130',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.35',0.26,NULL,NULL,NULL,NULL,NULL,1,215.87125,20.93708,0.011,NULL,59525333193,930083331,14532552,17.35),(120227,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120227,37.89,0.46,379,53215,70,NULL,NULL,'2MASX J14232963+2503562',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000201,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.8734583,25.06558,0,NULL,60020506174,937820408,14653443,17.1),(120228,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120228,37.5,0.33,316,53216,70,NULL,NULL,'2MASX J14233044+4600275',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.8767917,46.00778,0,NULL,59231946046,925499156,14460924,16.7),(120229,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120229,37.63,0.46,336,53217,70,NULL,NULL,'SDSS J142330.76+082131.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,215.8782083,8.35883,0.021,NULL,58274445276,910538207,14227159,18.6),(120230,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120230,38.04,0.23,406,53218,70,NULL,NULL,'2MASX J14233123+5643431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.880166667,56.72861,0,NULL,57249181427,894518459,13976850,18.2),(120231,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120231,36.28,0.46,181,53219,70,NULL,NULL,'2MASX J14233194+2017180',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.05',0.23,NULL,NULL,NULL,NULL,NULL,1,215.883125,20.28833,0,NULL,59525379589,930084056,14532563,16.05),(120232,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120232,36.67,0.33,216,53220,70,NULL,NULL,'2MASX J14233199+1726582',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.13',0.17,NULL,NULL,NULL,NULL,NULL,1,215.883458333,17.4495,0,NULL,59488824382,929512880,14523638,17.13),(120233,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120233,37.21,0.46,276,53221,70,NULL,NULL,'2MASX J14233272+4238325',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.886208333,42.64242,0,NULL,59948047074,936688235,14635753,17.2),(120234,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120234,37.27,0.46,284,53222,70,NULL,NULL,'SDSS J142332.79+023604.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000076,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,215.886625,2.60119,0.049,NULL,58300551087,910946110,14233532,18.6),(120235,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120235,37.62,0.46,334,53223,70,NULL,NULL,'2MASX J14233311+3313519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,215.887917,33.23119,0,NULL,60040387271,938131051,14658297,17.7),(120236,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120236,39.36,0.46,745,53224,70,NULL,NULL,'SDSS J142333.42+004353.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.88925,0.73144,0.081,NULL,58286022650,910719103,14229985,18.5),(120237,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120237,37.86,0.46,374,53225,70,NULL,NULL,'SDSS J142333.89+052503.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.89125,5.41756,0.029,NULL,58301646922,910963233,14233800,18),(120238,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120238,37.56,0.46,325,53226,70,NULL,NULL,'2MASX J14233410+0927046',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,215.89225,9.45133,0.025,NULL,58268575828,910446497,14225726,17),(120239,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120239,37.7,0.46,347,53227,70,NULL,NULL,'2MASX J14233451+1407162',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.07',0.15,NULL,NULL,NULL,NULL,NULL,1,215.893625,14.12111,0,NULL,59478721055,929355016,14521172,18.07),(120240,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120240,37.92,0.16,383,53228,70,NULL,NULL,'2MASXi J1423353+401123',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000175,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.897417,40.18975,0,NULL,59945500811,936648450,14635132,18),(120241,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120241,37.47,0.07,312,53229,70,NULL,NULL,'2MASX J14233661+4826104',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00007,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,215.902416667,48.43619,0.039,NULL,59248719545,925761242,14465019,15.9),(120242,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120242,33.37,0.43,47.2,53230,75,NULL,'3.6 micron, color + selection bias corrected','IC 4407',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00001,NULL,'14.59',0.7,'SB(s)m IV:',NULL,NULL,NULL,NULL,1,215.903583,-5.98322,0.101,NULL,43537331571,680270805,10629231,14.59),(120243,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120243,38.11,0.11,418,53231,70,NULL,NULL,'2MASX J14233793+1739382',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.908125,17.66064,0,NULL,59488778196,929512159,14523627,17.2),(120244,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120244,37.04,0.46,256,53232,70,NULL,NULL,'2MASX J14233814+1246582',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,215.9089583,12.78292,0,NULL,59475420187,929303440,14520366,16.1),(120245,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120245,34.98,0.4,99.2,53233,NULL,NULL,'mean','MCG -02-37-002',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000047,NULL,'15.00',0.4,'Sc             HII',NULL,NULL,NULL,NULL,1,215.910875,-13.33797,0.293,NULL,46540931511,727202054,11362532,15),(120246,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120246,35.11,0.47,105,53233,NULL,NULL,'H','MCG -02-37-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120247,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120247,35.22,0.45,111,53233,NULL,NULL,'K','MCG -02-37-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120248,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120248,35.25,0.46,112,53233,NULL,NULL,'J','MCG -02-37-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120249,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120249,37.97,0.46,394,53234,70,NULL,NULL,'2MASX J14233885+4005097',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0001,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,215.911791667,40.08617,0,NULL,59945297814,936645278,14635082,16.8),(120250,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120250,36.67,0.46,216,53235,70,NULL,NULL,'2MASX J14234007+0346023',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.917125,3.76736,0.033,NULL,58295193126,910862392,14232224,17.4),(120251,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120251,31.62,0.8,21.1,53236,75,NULL,NULL,'ESO 222-IG 004',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.00001,NULL,'14.7',1.6,'SB(s)m',NULL,NULL,NULL,NULL,1,215.917791667,-49.65503,0.929,NULL,46836635188,731822424,11434725,14.7),(120252,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120252,37.47,0.07,312,53237,70,NULL,NULL,'2MASX J14234096+4816575',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,215.920583333,48.28261,0.027,NULL,59248526218,925758222,14464972,17.3),(120253,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120253,35.95,0.74,155,53238,70,NULL,NULL,'2MASX J14234133-1922399',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.88',NULL,NULL,NULL,NULL,NULL,NULL,1,215.922333,-19.37778,0.353,NULL,46572405485,727693835,11370216,15.88),(120254,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120254,37.44,0.33,308,53239,70,NULL,NULL,'2MASX J14234259+2954179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.9275417,29.905,0,NULL,60059652950,938432077,14663001,17.2),(120255,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120255,36.87,0.46,237,53240,70,NULL,NULL,'2MASX J14234295+2030350',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.53',0.32,'AGN',NULL,NULL,NULL,NULL,1,215.928916667,20.50967,0.017,NULL,59525415668,930084619,14532572,16.53),(120256,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120256,38.19,0.33,434,53241,70,NULL,NULL,'2MASX J14234302+2100550',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.90',0.14,NULL,NULL,NULL,NULL,NULL,1,215.9292917,21.01533,0.011,NULL,59524974321,930077723,14532464,18.9),(120257,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120257,38.11,0.11,418,53242,70,NULL,NULL,'SDSS J142343.86+173225.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.9327917,17.54053,0,NULL,59488854766,929513355,14523646,17.9),(120258,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120258,36.28,0.15,180,53243,70,NULL,NULL,'2MASX J14234386+2622414',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,215.932833,26.37828,0,NULL,60054503709,938351620,14661744,16.4),(120259,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120259,38.06,0.21,409,53244,70,NULL,NULL,'2MASX J14234407+2500544',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,215.9337917,25.01503,0,NULL,60020497626,937820275,14653441,17.9),(120260,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120260,36.71,0.46,220,53245,70,NULL,NULL,'2MASX J14234471+0634197',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,215.936417,6.57228,0.037,NULL,58271843488,910497554,14226524,17.1),(120261,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120261,34.61,0.33,83.5,53246,70,NULL,NULL,'UGC 09223',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000167,NULL,'14.1g',0.5,'S0',NULL,NULL,NULL,NULL,1,215.9370417,40.02386,0,NULL,59945303274,936645363,14635083,14.1),(120262,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120262,37.92,0.16,383,53247,70,NULL,NULL,'2MASX J14234498+4019567',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000185,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.9375417,40.33242,0,NULL,59945499779,936648434,14635131,17.9),(120263,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120263,38.01,0.33,399,53248,70,NULL,NULL,'2MASX J14234515+2441194',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000127,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.938083,24.68889,0,NULL,59513018791,929890918,14529545,17.3),(120264,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120264,36.83,0.46,232,53249,70,NULL,NULL,'2MASX J14234576+2429004',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000172,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,215.940541667,24.4835,0,NULL,59513206749,929893855,14529591,16),(120265,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120265,35.7,0.2,138,53250,74.4,NULL,NULL,'KUG 1421+094',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000084,NULL,'16.0g',0.46,'Spiral',NULL,NULL,NULL,NULL,1,215.9417917,9.2365,0.013,NULL,58268551118,910446111,14225720,16),(120266,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120266,34.07,0.2,65.2,53251,74.4,NULL,NULL,'UGC 09222',NULL,'2013AJ....146...86T',2013,1,1.22,NULL,'G',0.00002,NULL,'14.7g',0.34,'S0/a','Pair member (points to parent)',NULL,NULL,NULL,1,215.943,34.017,0,NULL,60039945108,938124142,14658189,14.7),(120267,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120267,37.53,0.46,320,53252,70,NULL,NULL,'2MASX J14234665+3657417',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000134,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.944541667,36.96161,0,NULL,60031905176,937998518,14656226,17.7),(120268,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120268,37.47,0.07,312,53253,70,NULL,NULL,'2MASX J14234687+4816475',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,215.945333,48.27992,0.027,NULL,59248525688,925758213,14464972,17.2),(120269,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120269,35.59,0.46,131,53254,70,NULL,NULL,'2MASX J14234786+4833165',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.94925,48.55461,0.039,NULL,59248576871,925759013,14464984,16.5),(120270,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120270,40.87,0.08,1490,53255,NULL,NULL,'Hydrost. Eq.','MACS J1423.8+2404',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,215.948583,24.07781,0.027,NULL,59513860886,929904076,14529751,NULL),(120271,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120271,41.16,0.76,1710,53255,NULL,NULL,'Isotherm., r < 100 kpc','MACS J1423.8+2404',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120272,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120272,41.75,NULL,2240,53255,NULL,NULL,'3.1 (red) calibration','MACS J1423.8+2404',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120273,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120273,41.76,NULL,2250,53255,NULL,NULL,'4.2 (black) calibration','MACS J1423.8+2404',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120274,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120274,42.01,0.68,2520,53255,NULL,NULL,'Isotherm.','MACS J1423.8+2404',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120275,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120275,42.01,NULL,2520,53255,NULL,NULL,'4.1 (blue) calibration','MACS J1423.8+2404',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120276,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120276,37.52,0.33,318,53256,70,NULL,NULL,'2MASX J14234917+2447324',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,215.9547917,24.7925,0,NULL,59496263487,929629116,14525454,17.2),(120277,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120277,38,0.46,399,53257,70,NULL,NULL,'2MASX J14234912+2202470',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.30',0.19,NULL,NULL,NULL,NULL,NULL,1,215.954833,22.04642,0.028,NULL,59516152669,929939885,14530310,18.3),(120278,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120278,35.13,0.8,106,53258,75,NULL,'HMCL, I','NGC 5600',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000021,NULL,'12.66',1.4,'Sc pec         HII','Group member',NULL,NULL,NULL,1,215.956333333,14.63878,0,NULL,59478471470,929351116,14521111,12.66),(120279,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120279,32.87,0.8,37.5,53258,75,NULL,'B','NGC 5600',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120280,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120280,34.84,0.4,92.7,53258,75,NULL,'HMCL, I, raw','NGC 5600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120281,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120281,35.03,0.4,101,53258,75,NULL,'HMCL, I, inv','NGC 5600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120282,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120282,35.04,0.4,102,53258,75,NULL,'HMCL, I, cor','NGC 5600',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120283,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120283,32.42,0.8,30.5,53259,75,NULL,'MAT, I','ESO 041- G 006',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'13.16',2,'SB(s)m',NULL,NULL,NULL,NULL,1,215.960166667,-75.32203,0.893,NULL,44205051576,690703930,10792248,13.16),(120284,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120284,32.53,0.8,32,53259,75,NULL,NULL,'ESO 041- G 006',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120285,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120285,30.9,0.43,15.1,53259,75,NULL,'MAT, I, inv','ESO 041- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120286,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120286,30.92,0.32,15.3,53259,85,NULL,'I, inv','ESO 041- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120287,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120287,30.98,0.32,15.7,53259,85,NULL,'I, raw','ESO 041- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120288,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120288,31.04,0.43,16.1,53259,75,NULL,'MAT, I, raw','ESO 041- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120289,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120289,31.21,0.4,17.5,53259,NULL,NULL,NULL,'ESO 041- G 006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120290,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120290,31.32,0.43,18.4,53259,75,NULL,'MAT, I, cor','ESO 041- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120291,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120291,34.91,0.8,95.9,53260,75,NULL,'HMCL, I','NGC 5599',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.42',0.5,'Sb',NULL,NULL,NULL,NULL,1,215.960875,6.57611,0.037,NULL,58271838442,910497475,14226523,14.42),(120292,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120292,34.93,0.8,96.7,53260,75,NULL,'CF, r','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120293,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120293,34.08,0.4,65.5,53260,75,NULL,'HMCL, I, raw','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120294,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120294,34.26,0.4,71.2,53260,75,NULL,'HMCL, I, inv','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120295,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120295,34.45,0.38,77.8,53260,75,NULL,'CF, r, raw','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120296,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120296,34.53,0.4,80.5,53260,75,NULL,'HMCL, I, cor','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120297,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120297,34.61,0.38,83.7,53260,75,NULL,'CF, r, inv','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120298,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120298,34.83,0.47,92.6,53260,NULL,NULL,'H','NGC 5599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120299,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120299,34.85,0.38,93.5,53260,75,NULL,'CF, r, cor','NGC 5599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120300,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120300,34.89,0.37,95.2,53260,NULL,NULL,NULL,'NGC 5599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120301,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120301,34.92,0.2,96.4,53260,74.4,NULL,NULL,'NGC 5599',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120302,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120302,34.97,0.35,98.7,53260,NULL,NULL,'Malmquist cor.','NGC 5599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120303,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120303,34.99,0.45,99.4,53260,NULL,NULL,'K','NGC 5599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120304,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120304,34.99,0.46,99.6,53260,NULL,NULL,'J','NGC 5599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120305,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120305,35.09,0.4,104,53260,NULL,NULL,'mean','NGC 5599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120306,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120306,36.99,0.46,250,53261,70,NULL,NULL,'2MASX J14235098+0738128',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.962375,7.63672,0.029,NULL,58273891143,910529549,14227024,17.7),(120307,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120307,37.92,0.16,383,53262,70,NULL,NULL,'2MASX J14235155+4015318',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000213,NULL,'15.8g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,215.96475,40.25883,0,NULL,59945494063,936648344,14635130,15.8),(120308,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120308,37.52,0.33,318,53263,70,NULL,NULL,'2MASX J14235172+2459054',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,215.965541667,24.98492,0,NULL,60020497767,937820277,14653441,18),(120309,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120309,38.11,0.11,418,53264,70,NULL,NULL,'SDSS J142352.24+172649.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.967667,17.44722,0,NULL,59488859154,929513424,14523647,18.5),(120310,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120310,38.11,0.11,418,53265,70,NULL,NULL,'SDSS J142352.33+173703.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,215.968083,17.61756,0,NULL,59488811406,929512678,14523635,18.4),(120311,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120311,36.93,0.46,243,53266,70,NULL,NULL,'SDSS J142352.97+050759.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.9707083,5.13325,0.033,NULL,58301341384,910958459,14233725,17.7),(120312,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120312,38.01,0.46,400,53267,70,NULL,NULL,'SDSS J142354.16+053208.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,215.975708333,5.53567,0.037,NULL,58301634123,910963033,14233797,18.1),(120313,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120313,35.37,NULL,119,53268,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09224',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',0.00001,NULL,'16.8g',0.15,'Sc',NULL,NULL,NULL,NULL,1,215.977,34.72353,0,NULL,60043064611,938172884,14658951,16.8),(120314,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120314,35.37,NULL,119,53268,NULL,NULL,'Dipole + Quadrupole','UGC 09224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120315,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120315,35.38,NULL,119,53268,NULL,NULL,'Dipole','UGC 09224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120316,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120316,35.48,NULL,125,53268,NULL,NULL,NULL,'UGC 09224',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120317,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120317,35.91,0.2,152,53268,74.4,NULL,NULL,'UGC 09224',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120318,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120318,33.85,0.8,58.9,53269,75,NULL,'MAT, I','NGC 5592',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.53',0.8,'SB(s)bc?       HII','in a triple',NULL,NULL,NULL,1,215.979375,-28.68806,0.333,NULL,47033454156,734897721,11482776,13.53),(120319,'Sosies','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120319,33.57,0.15,51.8,53269,NULL,NULL,NULL,'NGC 5592',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120320,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120320,33.11,0.69,42,53269,100,NULL,'mid-IR','NGC 5592',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120321,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120321,33.54,0.45,51.2,53269,NULL,NULL,'K','NGC 5592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120322,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120322,33.57,0.47,51.8,53269,NULL,NULL,'H','NGC 5592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120323,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120323,33.6,0.46,52.6,53269,NULL,NULL,'J','NGC 5592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120324,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120324,33.72,0.32,55.4,53269,85,NULL,'I, raw','NGC 5592',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120325,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120325,33.72,0.43,55.6,53269,75,NULL,'MAT, I, raw','NGC 5592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120326,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120326,33.79,0.32,57.2,53269,85,NULL,'I, inv','NGC 5592',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120327,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120327,33.9,0.4,60.1,53269,NULL,NULL,'mean','NGC 5592',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120328,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120328,33.95,NULL,61.7,53269,NULL,NULL,'I','NGC 5592',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120329,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120329,33.97,NULL,62.2,53269,NULL,NULL,'B','NGC 5592',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120330,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120330,34,0.43,63,53269,75,NULL,'MAT, I, cor','NGC 5592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120331,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120331,34,0.2,63.1,53269,74.4,NULL,NULL,'NGC 5592',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120332,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120332,34.02,0.43,63.6,53269,75,NULL,'MAT, I, inv','NGC 5592',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120333,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120333,34.08,0.06,65.6,53269,NULL,NULL,NULL,'NGC 5592',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120334,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120334,38.11,0.11,418,53270,70,NULL,NULL,'2MASX J14235508+1734194',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.36',0.16,NULL,NULL,NULL,NULL,NULL,1,215.979667,17.57219,0,NULL,59488802137,929512533,14523633,18.36),(120335,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120335,38.36,0.46,469,53271,70,NULL,NULL,'2MASX J14235536+1532534',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.89',0.12,NULL,NULL,NULL,NULL,NULL,1,215.9807083,15.54836,0,NULL,59490967713,929546370,14524162,18.89),(120336,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120336,37.14,0.27,268,53272,70,NULL,NULL,'2MASX J14235543+2246100',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.62',0.23,NULL,NULL,NULL,NULL,NULL,1,215.980875,22.76961,0.062,NULL,59517063382,929954115,14530533,17.62),(120337,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120337,38.11,0.11,418,53273,70,NULL,NULL,'2MASX J14235557+1733574',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.59',0.13,NULL,NULL,NULL,NULL,NULL,1,215.9814583,17.56606,0,NULL,59488802772,929512543,14523633,18.59),(120338,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120338,35.76,0.46,142,53274,70,NULL,NULL,'CGCG 163-036',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000083,NULL,'15.3g',0.48,NULL,NULL,NULL,NULL,NULL,1,215.9869583,28.98497,0,NULL,60060017228,938437769,14663090,15.3),(120339,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120339,38.19,0.33,434,53275,70,NULL,NULL,'2MASX J14235779+2106017',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.99',0.21,'BrClG',NULL,NULL,NULL,NULL,1,215.990875,21.10064,0.011,NULL,59524978955,930077796,14532465,17.99),(120340,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120340,38.41,0.33,480,53276,70,NULL,NULL,'2MASX J14235784+2434035',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,215.990958333,24.56758,0,NULL,59513012963,929890827,14529544,17.2),(120341,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120341,37.58,0.46,329,53277,70,NULL,NULL,'2MASX J14235826+1524474',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.992791667,15.41325,0,NULL,59489139215,929517800,14523715,17.2),(120342,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120342,37.51,0.33,318,53278,70,NULL,NULL,'2MASX J14235852+0746148',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000203,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,215.9937083,7.77089,0.021,NULL,58274355977,910536812,14227137,17.3),(120343,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120343,36.28,0.15,180,53279,70,NULL,NULL,'2MASXi J1424007+260918',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00009,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.003333,26.15503,0,NULL,60054987767,938359183,14661862,16.6),(120344,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120344,37.9,0.33,380,53280,70,NULL,NULL,'SDSS J142401.98+444002.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.0082917,44.66733,0,NULL,59230854544,925482102,14460657,18.3),(120345,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120345,38.02,0.46,402,53281,70,NULL,NULL,'SDSS J142403.11+445221.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.013,44.87275,0,NULL,59230876265,925482441,14460663,18.1),(120346,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120346,37.92,0.16,383,53282,70,NULL,NULL,'2MASX J14240395+4014418',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.016375,40.24492,0,NULL,59945279372,936644990,14635077,17.9),(120347,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120347,38.38,0.46,474,53283,70,NULL,NULL,'2MASX J14240444+2108337',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.018583,21.14267,0,NULL,59524976787,930077762,14532465,18.2),(120348,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120348,37.55,0.46,323,53284,70,NULL,NULL,'2MASX J14240451+2813195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.019,28.222,0,NULL,60055444830,938366325,14661973,17.3),(120349,'SBF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120349,32.01,0.46,25.2,53285,NULL,NULL,'I','NGC 5611',NULL,'2001ApJ...546..681T',2001,1,1.4,NULL,'G',0.000017,NULL,'13.63',0.68,'S0','Brightest group member',NULL,NULL,NULL,1,216.019917,33.04739,0,NULL,60040406964,938131358,14658302,13.63),(120350,'SBF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120350,32.07,0.14,25.9,53285,74.4,NULL,NULL,'NGC 5611',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120351,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120351,37.39,0.27,300,53286,70,NULL,NULL,'2MASX J14240546+4807444',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000184,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.022583,48.12908,0.027,NULL,59248513518,925758023,14464969,17.6),(120352,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120352,38.11,0.11,418,53287,70,NULL,NULL,'2MASX J14240556+1729414',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.023333,17.49483,0,NULL,59488861963,929513468,14523647,17.7),(120353,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120353,36.99,0.46,250,53288,70,NULL,NULL,'2MASX J14240643+4900154',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.0269583,49.00442,0.013,NULL,59246305326,925723520,14464430,16.7),(120354,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120354,38.68,0.33,544,53289,70,NULL,NULL,'2MASX J14240788+0934478',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.17,NULL,NULL,NULL,NULL,NULL,1,216.0327917,9.58003,0.029,NULL,58269306174,910457908,14225904,18.38),(120355,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120355,38.15,0.46,427,53290,70,NULL,NULL,'SDSS J142408.09+222917.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.03375,22.48833,0.047,NULL,59516218176,929940909,14530326,18),(120356,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120356,34.99,0.2,99.5,53291,74.4,NULL,NULL,'KUG 1421+124',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00052,NULL,'15.6',0.2,'Compact',NULL,NULL,NULL,NULL,1,216.0377917,12.25853,0,NULL,58351167953,911736999,14245890,15.6),(120357,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120357,37.51,0.33,318,53292,70,NULL,NULL,'2MASX J14240915+0746128',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.038125,7.77019,0.021,NULL,58274230027,910534844,14227106,17.9),(120358,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120358,38.68,0.33,544,53293,70,NULL,NULL,'SDSS J142409.64+093504.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,216.040166667,9.58447,0.029,NULL,58269305198,910457893,14225904,18.5),(120359,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120359,36.2,0.46,174,53294,70,NULL,NULL,'2MASX J14241034+3556250',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.043083,35.94022,0,NULL,60042596696,938165573,14658837,16.6),(120360,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120360,37.14,0.27,268,53295,70,NULL,NULL,'2MASX J14241145+2248397',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.047667,22.81114,0.062,NULL,59517066367,929954161,14530533,17.1),(120361,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120361,38.41,0.33,480,53296,70,NULL,NULL,'SDSS J142412.02+243338.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,216.050083333,24.56078,0,NULL,59513126951,929892608,14529572,18.51),(120362,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120362,35.42,0.53,121,53297,NULL,NULL,'Malmquist cor.','MCG +06-32-024',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.00001,NULL,'15.2g',0.5,'Sa',NULL,NULL,NULL,NULL,1,216.0505,35.14611,0,NULL,60043161895,938174404,14658975,15.2),(120363,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120363,35.58,0.49,130,53297,NULL,NULL,NULL,'MCG +06-32-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120364,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120364,35.62,0.2,133,53297,74.4,NULL,NULL,'MCG +06-32-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120365,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120365,36.12,0.46,167,53298,70,NULL,NULL,'2MASX J14241214+1927547',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.0507083,19.46517,0,NULL,59523377101,930052767,14532074,17.1),(120366,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120366,37.03,0.23,255,53299,70,NULL,NULL,'2MASX J14241259+0244513',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000088,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.0525,2.74761,0.053,NULL,58296911684,910889245,14232644,17.1),(120367,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120367,32.89,0.8,37.9,53300,75,NULL,'MAT, I','NGC 5595',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000013,NULL,'13.12',1.2,'SAB(rs)c       HII','in a pair',NULL,NULL,NULL,1,216.055167,-16.723,0.349,NULL,46556574614,727446478,11366351,13.12),(120368,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120368,32.93,0.8,38.5,53300,75,NULL,'B','NGC 5595',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120369,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120369,32.18,0.43,27.2,53300,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120370,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120370,32.37,0.43,29.8,53300,75,NULL,'3.6 micron, color corrected','NGC 5595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120371,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120371,32.48,0.32,31.3,53300,85,NULL,'I, raw','NGC 5595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120372,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120372,32.52,0.32,31.9,53300,85,NULL,'I, inv','NGC 5595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120373,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120373,32.57,0.43,32.6,53300,75,NULL,'MAT, I, raw','NGC 5595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120374,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120374,32.58,0.2,32.8,53300,74.4,NULL,NULL,'NGC 5595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120375,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120375,32.77,0.43,35.8,53300,75,NULL,'MAT, I, inv','NGC 5595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120376,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120376,32.78,0.43,36,53300,75,NULL,'MAT, I, cor','NGC 5595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120377,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120377,38.06,0.21,409,53301,70,NULL,NULL,'2MASX J14241327+2501474',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.5g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,216.055417,25.02983,0,NULL,60020551171,937821112,14653454,16.5),(120378,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120378,37.74,0.46,353,53302,70,NULL,NULL,'2MASX J14241387+0413233',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000114,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.0579583,4.22289,0.049,NULL,58294814124,910856470,14232132,16.4),(120379,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120379,38.06,0.21,409,53303,70,NULL,NULL,'2MASX J14241518+2504233',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'16.4g',0.38,'BrClG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,216.0632917,25.07331,0,NULL,60020548800,937821075,14653454,16.4),(120380,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120380,37.14,0.27,268,53304,70,NULL,NULL,'2MASX J14241542+2250377',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.12',0.19,NULL,NULL,NULL,NULL,NULL,1,216.064417,22.84386,0.062,NULL,59517074364,929954286,14530535,18.12),(120381,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120381,38.11,0.11,418,53305,70,NULL,NULL,'2MASX J14241552+1732046',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.0647083,17.53456,0,NULL,59488851738,929513308,14523645,17.9),(120382,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120382,38.52,0.46,505,53306,70,NULL,NULL,'2MASX J14241623+3637099',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.067583333,36.61936,0,NULL,60031182182,937987221,14656050,17.4),(120383,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120383,35.32,0.46,116,53307,70,NULL,NULL,'2MASX J14241630+3336450',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'15.3g',0.44,NULL,NULL,NULL,NULL,NULL,1,216.067958333,33.61258,0,NULL,60040061121,938125955,14658218,15.3),(120384,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120384,37.88,0.33,377,53308,70,NULL,NULL,'2MASX J14241644-0137380',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.068666667,-1.62719,0.125,NULL,43519190452,679987350,10624802,17.8),(120385,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120385,37.03,0.23,255,53309,70,NULL,NULL,'2MASX J14241653+0247263',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000104,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.068791667,2.7905,0.053,NULL,58297132873,910892701,14232698,16.6),(120386,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120386,37.16,0.46,270,53310,70,NULL,NULL,'2MASX J14241749+2954370',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,216.072958333,29.91019,0,NULL,60059658413,938432162,14663002,16.4),(120387,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120387,35.53,0.46,128,53311,70,NULL,NULL,'MCG +06-32-025',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000181,NULL,'15.4g',0.43,'E0',NULL,NULL,NULL,NULL,1,216.0767083,35.24286,0,NULL,60043105081,938173516,14658961,15.4),(120388,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120388,38.59,0.46,523,53312,70,NULL,NULL,'SDSS J142419.39+020506.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.0807917,2.08514,0.049,NULL,58300810193,910950159,14233596,18.7),(120389,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120389,36.81,0.57,230,53313,70,NULL,NULL,'2MASX J14241981-4525512',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.3b',0.4,NULL,NULL,NULL,NULL,NULL,1,216.082458333,-45.43086,0.453,NULL,46803789149,731309205,11426706,17.3),(120390,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120390,38.06,0.21,409,53314,70,NULL,NULL,'2MASX J14242026+2504333',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.084583,25.07592,0,NULL,60020516894,937820576,14653446,17.5),(120391,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120391,38.13,0.46,422,53315,70,NULL,NULL,'2MASX J14242049+0820395',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.085333,8.34439,0.017,NULL,58274428163,910537940,14227155,17.8),(120392,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120392,34.76,0.49,89.5,53316,75,NULL,'IR','NGC 5616',NULL,'2011yCatp016004901K',2011,1,1.17,NULL,'G',0.00002,NULL,'14.0g',0.51,'Sbc',NULL,NULL,NULL,NULL,1,216.08625,36.46142,0,NULL,60031230653,937987978,14656062,14),(120393,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120393,35.08,0.2,104,53316,74.4,NULL,NULL,'NGC 5616',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120394,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120394,35.09,0.4,104,53316,NULL,NULL,'Malmquist cor.','NGC 5616',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120395,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120395,35.21,0.38,110,53316,NULL,NULL,NULL,'NGC 5616',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120396,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120396,38.31,0.46,458,53317,70,NULL,NULL,'2MASX J14242077+6249166',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000095,NULL,'17.5g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,216.0865417,62.82125,0.033,NULL,57761639115,902525611,14101962,17.5),(120397,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120397,36.93,0.46,243,53318,70,NULL,NULL,'2MASX J14242114+1122045',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00011,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,216.088125,11.36783,0.008,NULL,58267666771,910432293,14225504,16.4),(120398,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120398,36.81,0.19,231,53319,70,NULL,NULL,'2MASX J14242114+2935213',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,216.088167,29.58939,0,NULL,60060131121,938439548,14663117,18.52),(120399,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120399,37.61,0.46,332,53320,70,NULL,NULL,'2MASX J14242129+3804170',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.0887917,38.07136,0,NULL,60066201864,938534404,14664600,17.5),(120400,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120400,36.91,0.46,241,53321,70,NULL,NULL,'2MASX J14242153+5207278',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.089541667,52.12439,0.005,NULL,59195696564,924932758,14452074,17),(120401,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120401,36.28,0.15,180,53322,70,NULL,NULL,'2MASX J14242263+2638543',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000105,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.094333,26.64839,0,NULL,60054541770,938352215,14661753,16.5),(120402,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120402,34.18,0.8,68.5,53323,75,NULL,'HMCL, I','NGC 5610',NULL,'1997ApJS..109..333W',1997,1,2.03,NULL,'G',0.000073,NULL,'13.6g',0.67,'SB(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,216.095583,24.61414,0,NULL,59496435187,929631799,14525496,13.6),(120403,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120403,33.83,0.4,58.3,53323,75,NULL,'HMCL, I, raw','NGC 5610',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120404,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120404,34,0.2,63.1,53323,74.4,NULL,NULL,'NGC 5610',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120405,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120405,34.02,0.4,63.8,53323,75,NULL,'HMCL, I, inv','NGC 5610',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120406,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120406,34.08,0.4,65.6,53323,75,NULL,'HMCL, I, cor','NGC 5610',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120407,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120407,38.06,0.21,409,53324,70,NULL,NULL,'2MASX J14242306+2504023',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.096,25.06747,0,NULL,60020517040,937820578,14653446,17.8),(120408,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120408,34.04,0.52,64.3,53325,70,NULL,NULL,'2MFGC 11695',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,216.0969583,-80.46592,0.481,NULL,44247406009,691365718,10802589,16.2),(120409,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120409,32.03,NULL,25.5,53326,72,NULL,NULL,'UGC 09225',NULL,'2014Ap.....57..457K',2014,1,1.04,NULL,'G',0.000013,NULL,'15.6g',0.49,'Sm',NULL,NULL,NULL,NULL,1,216.101333,8.27614,0.021,NULL,58274424607,910537884,14227154,15.6),(120410,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120410,37.34,0.46,294,53327,70,NULL,NULL,'2MASX J14242442+2536073',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,216.101875,25.60194,0,NULL,60020649961,937822655,14653478,16.5),(120411,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120411,38.48,0.46,498,53328,70,NULL,NULL,'SDSS J142424.67+033513.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.1027917,3.58697,0.025,NULL,58295348943,910864827,14232262,18),(120412,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120412,36.57,0.59,206,53329,70,NULL,NULL,'2MASX J14242509-2045363',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'14.0I',0.5,'(R)SA(r)b pec',NULL,NULL,NULL,NULL,1,216.1045,-20.76014,0.325,NULL,46573404696,727709448,11370460,14),(120413,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120413,35.03,0.4,101,53330,NULL,NULL,'mean','ESO 446- G 059',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'15.28',0.4,'Sb             HII','in a triple',NULL,NULL,NULL,1,216.104417,-28.63408,0.313,NULL,47033463360,734897865,11482779,15.28),(120414,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120414,35.25,0.55,112,53330,NULL,NULL,'Malmquist cor.','ESO 446- G 059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120415,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120415,35.25,0.47,112,53330,NULL,NULL,'H','ESO 446- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120416,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120416,35.32,0.45,116,53330,NULL,NULL,'K','ESO 446- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120417,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120417,35.34,0.46,117,53330,NULL,NULL,'J','ESO 446- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120418,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120418,35.44,0.5,122,53330,NULL,NULL,NULL,'ESO 446- G 059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120419,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120419,35.48,0.2,125,53330,74.4,NULL,NULL,'ESO 446- G 059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120420,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120420,37.37,0.46,298,53331,70,NULL,NULL,'2MASX J14242566+2711054',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,216.1067917,27.18486,0,NULL,60057975728,938405870,14662591,16.5),(120421,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120421,36.83,0.46,232,53332,70,NULL,NULL,'2MASX J14242575+0444503',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000119,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,216.107333333,4.74744,0.057,NULL,58304503874,911007873,14234498,15.8),(120422,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120422,37.31,0.46,289,53333,70,NULL,NULL,'2MASX J14242620+0535293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,216.109125,5.59158,0.037,NULL,58301536765,910961511,14233773,16.3),(120423,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120423,37.89,0.46,378,53334,70,NULL,NULL,'2MASX J14242710+0913045',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.1130417,9.21786,0.013,NULL,58268442225,910444409,14225693,17.1),(120424,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120424,32.93,0.8,38.6,53335,75,NULL,'B','NGC 5597',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000017,NULL,'12.60',1.7,'SAB(s)cd       HII','in a pair',NULL,NULL,'H II',1,216.114333,-16.76275,0.349,NULL,46556517901,727445592,11366337,12.6),(120425,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120425,37.31,0.46,290,53336,70,NULL,NULL,'2MASX J14242791-0149240',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.7b',0.32,NULL,NULL,NULL,NULL,NULL,1,216.116417,-1.82328,0.133,NULL,43519952065,679999251,10624988,16.7),(120426,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120426,35.94,0.7,154,53337,70,NULL,NULL,'2MASX J14242834-0820234',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,216.1180417,-8.33989,0.149,NULL,43530454776,680163355,10627552,14),(120427,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120427,37.92,0.16,383,53338,70,NULL,NULL,'2MASX J14242902+4024231',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.121,40.40639,0,NULL,59948696471,936698382,14635912,18.1),(120428,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120428,38.11,0.11,418,53339,70,NULL,NULL,'SDSS J142429.98+173020.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.124958333,17.50561,0,NULL,59488835072,929513048,14523641,18.3),(120429,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120429,38.08,0.46,414,53340,70,NULL,NULL,'2MASX J14243115+1349076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000191,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.12975,13.81886,0,NULL,59479163630,929361931,14521280,17.4),(120430,'HII LF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120430,48.81,0.4,10000,53341,71,NULL,NULL,'[PBW92] B1422+231 D081',3.107,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.001,NULL,'23.41',NULL,'LBG',NULL,NULL,NULL,NULL,1,216.131,22.99764,0.062,NULL,59516584571,929946633,14530416,23.41),(120431,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120431,37.4,0.46,302,53342,70,NULL,NULL,'2MASX J14243247+6425273',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.135125,64.42422,0.041,NULL,57947370308,905427661,14147307,17.1),(120432,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120432,37.69,0.33,345,53343,70,NULL,NULL,'2MASX J14243247+2120397',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.135291667,21.34431,0,NULL,59524989809,930077965,14532468,17.4),(120433,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120433,38.39,0.46,476,53344,70,NULL,NULL,'2MASX J14243346+2732114',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.139333333,27.5365,0,NULL,60057834456,938403663,14662557,17.4),(120434,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120434,36.81,0.19,231,53345,70,NULL,NULL,'2MASX J14243356+2935414',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00013,NULL,'16.6g',0.23,'E',NULL,NULL,NULL,NULL,1,216.1400417,29.59489,0,NULL,60060112619,938439259,14663113,16.6),(120435,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120435,37.82,0.46,366,53346,70,NULL,NULL,'2MASX J14243478+1342416',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.1449583,13.71158,0,NULL,59476021116,929312829,14520512,17.8),(120436,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120436,35.11,0.46,105,53347,NULL,NULL,NULL,'UGC 09233',NULL,'2009ApJS..182..474S',2009,1,1.35,NULL,'G',0.000153,NULL,'14.6g',0.47,'S',NULL,NULL,NULL,NULL,1,216.1457917,35.27983,0,NULL,60043372380,938177693,14659026,14.6),(120437,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120437,35.12,0.46,106,53347,NULL,NULL,'Malmquist cor.','UGC 09233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120438,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120438,35.18,0.2,109,53347,74.4,NULL,NULL,'UGC 09233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120439,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120439,38,0.46,398,53348,70,NULL,NULL,'2MASX J14243566+3638071',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.1485417,36.63506,0,NULL,60031181685,937987213,14656050,17.9),(120440,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120440,37.33,0.46,292,53349,70,NULL,NULL,'2MASX J14243561+6402593',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.148667,64.04994,0.053,NULL,57946437661,905413088,14147079,17.4),(120441,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120441,37.03,0.23,255,53350,70,NULL,NULL,'2MASX J14243629+0244423',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00012,NULL,'15.5g',0.49,'AGN',NULL,NULL,NULL,NULL,1,216.151083,2.74514,0.053,NULL,58297128028,910892625,14232697,15.5),(120442,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120442,36.81,0.19,231,53351,70,NULL,NULL,'2MASX J14243624+2936284',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.70',0.22,'E',NULL,NULL,NULL,NULL,1,216.151125,29.60789,0,NULL,60060114550,938439289,14663113,17.7),(120443,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120443,38.51,0.46,503,53352,70,NULL,NULL,'SDSS J142436.61+110332.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.1525417,11.05892,0.049,NULL,58267705358,910432896,14225514,18.6),(120444,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120444,37.31,0.46,290,53353,70,NULL,NULL,'2MASX J14243687+1139075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000107,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,216.1537083,11.652,0.007,NULL,58267375515,910427742,14225433,16.8),(120445,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120445,36.33,0.46,184,53354,70,NULL,NULL,'2MASX J14243712+2841203',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000197,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,216.154625,28.68914,0,NULL,60055511756,938367371,14661990,15.7),(120446,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120446,37.65,0.46,339,53355,70,NULL,NULL,'2MASX J14243759+0104483',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.1565,1.08022,0.077,NULL,58299745700,910933526,14233336,17.5),(120447,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120447,35.53,0.33,127,53356,70,NULL,NULL,'2MASX J14243758+3601491',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.0g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,216.1567917,36.03019,0,NULL,60042746224,938167909,14658873,16),(120448,'G Lens','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120448,43.62,2.5,5300,53357,NULL,NULL,NULL,'SDSS J142438.77+225555.7',NULL,'2007ApJ...660....1O',2007,1,0.06,NULL,'G',0.0001,NULL,'21.8',0.05,NULL,NULL,NULL,NULL,NULL,1,216.161541667,22.93214,0.062,NULL,59516555002,929946171,14530408,21.8),(120449,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120449,37.9,0.33,380,53358,70,NULL,NULL,'2MASX J14243907+4436356',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000152,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.162667,44.60989,0,NULL,59230819550,925481555,14460649,17.1),(120450,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120450,37.69,0.33,345,53359,70,NULL,NULL,'SDSS J142439.59+212133.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.1649583,21.35933,0,NULL,59524923447,930076928,14532452,17.4),(120451,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120451,35.71,0.54,138,53360,70,NULL,NULL,'2MASX J14243961-0441080',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.9b',0.53,NULL,NULL,NULL,NULL,NULL,1,216.1652083,-4.68558,0.133,NULL,43540288711,680317011,10629953,15.9),(120452,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120452,35.37,0.17,114,53361,74.2,NULL,'SALT 2','CGCG 163-041',0.037152,'2010ApJ...716..712A',2010,1,0.96,NULL,'G',0.000067,NULL,'14.9g',0.66,'S?','Group member of poor cluster',NULL,'radio jet',NULL,1,216.168875,26.62517,0,NULL,60054547383,938352302,14661754,14.9),(120453,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120453,36.01,0.09,159,53361,74.4,NULL,NULL,'CGCG 163-041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120454,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120454,36.24,0.17,170,53361,70,NULL,'SALT 2','CGCG 163-041',0.037152,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120455,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120455,36.25,0.18,172,53361,65,NULL,'MLCS17','CGCG 163-041',0.037152,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120456,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2002bz',NULL,120456,36.38,0.25,182,53361,65,NULL,'SALT2','CGCG 163-041',0.037152,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120457,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120457,36.28,0.15,180,53361,70,NULL,NULL,'CGCG 163-041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120458,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120458,36.33,0.46,185,53362,70,NULL,NULL,'CGCG 273-005',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000107,NULL,'15.0g',0.68,'E0',NULL,NULL,NULL,NULL,1,216.17325,55.70561,0,NULL,57254930219,894608284,13978254,15),(120459,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120459,38.11,0.11,418,53363,70,NULL,NULL,'2MASX J14244233+1735464',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.1764583,17.59636,0,NULL,59488686486,929510726,14523605,17.4),(120460,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120460,32.09,0.69,26.2,53364,100,NULL,'mid-IR','NGC 5604',NULL,'2013ApJ...771...88L',2013,1,1.8,NULL,'G',0.000013,NULL,'13.57',1,'Sa',NULL,NULL,NULL,NULL,1,216.178333,-3.21217,0.161,NULL,43508978075,679827782,10622309,13.57),(120461,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120461,33,0.45,39.8,53364,NULL,NULL,'K','NGC 5604',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120462,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120462,33.02,0.47,40.1,53364,NULL,NULL,'H','NGC 5604',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120463,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120463,33.11,0.46,41.9,53364,NULL,NULL,'J','NGC 5604',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120464,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120464,33.12,0.4,42,53364,NULL,NULL,'mean','NGC 5604',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120465,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120465,33.13,0.57,42.2,53364,NULL,NULL,'Malmquist cor.','NGC 5604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120466,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120466,33.21,0.43,43.8,53364,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5604',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120467,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120467,33.26,0.54,44.8,53364,NULL,NULL,NULL,'NGC 5604',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120468,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120468,33.32,0.43,46.2,53364,75,NULL,'3.6 micron, color corrected','NGC 5604',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120469,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120469,33.36,0.2,47,53364,74.4,NULL,NULL,'NGC 5604',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120470,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120470,27.17,0.1,2.72,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2012A&A...540A..49M',2012,1,1.8,NULL,'G',0.000012,NULL,'13.25',1.8,'IAm','Field galaxy',NULL,NULL,NULL,1,216.180833,44.52578,0,1,59230819065,925481547,14460649,13.25),(120471,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120471,27.23,0.2,2.79,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120472,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120472,27.23,0.03,2.79,53365,NULL,NULL,'I','UGC 09240',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120473,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120473,27.23,0.12,2.79,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120474,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120474,27.24,0.04,2.8,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120475,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120475,27.25,0.08,2.82,53365,74.4,NULL,NULL,'UGC 09240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120476,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120476,27.26,0.03,2.83,53365,NULL,NULL,'I','UGC 09240',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120477,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120477,27.31,0.14,2.9,53365,NULL,NULL,NULL,'UGC 09240',NULL,'2000AJ....119.2183A',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120478,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120478,27.82,0.4,3.7,53365,75,NULL,'B','UGC 09240',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120479,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120479,36.64,0.46,213,53366,70,NULL,NULL,'2MASX J14244342-0134127',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000175,NULL,'16.2g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,216.181,-1.57031,0.129,NULL,43519643197,679994424,10624912,16.2),(120480,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120480,36.17,0.46,172,53367,70,NULL,NULL,'2MASX J14244357+4701577',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000187,NULL,'15.8g',0.38,'S0',NULL,NULL,NULL,NULL,1,216.181417,47.03267,0.016,NULL,59228081191,925438768,14459980,15.8),(120481,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120481,36.38,0.46,189,53368,70,NULL,NULL,'2MASX J14244449+2308237',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,216.185333333,23.13992,0.06,NULL,59516476762,929944949,14530389,17.3),(120482,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120482,36.81,0.19,231,53369,70,NULL,NULL,'CGCG 163-042',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000191,NULL,'15.2g',0.51,NULL,NULL,NULL,NULL,NULL,1,216.190625,29.46017,0,NULL,60060126532,938439477,14663116,15.2),(120483,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120483,37.27,0.46,284,53370,70,NULL,NULL,'2MASX J14244575+5130178',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.190833,51.50486,0.005,NULL,59202739817,925042809,14453793,16.7),(120484,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120484,37.87,0.46,375,53371,70,NULL,NULL,'2MASX J14244582-0117197',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.1910417,-1.28872,0.117,NULL,43517795425,679965553,10624461,17.8),(120485,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120485,37.88,0.33,377,53372,70,NULL,NULL,'2MASX J14244588-0135567',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.1912083,-1.59906,0.125,NULL,43519640659,679994385,10624912,18),(120486,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120486,36.28,0.15,180,53373,70,NULL,NULL,'2MASX J14244724+2617176',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000117,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,216.196791667,26.28819,0,NULL,60054489780,938351402,14661740,15.8),(120487,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120487,37.03,0.23,255,53374,70,NULL,NULL,'2MASX J14244743+0239520',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000114,NULL,'15.2g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,216.1975417,2.66444,0.053,NULL,58297000892,910890638,14232666,15.2),(120488,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120488,38.02,0.46,401,53375,70,NULL,NULL,'2MASX J14244751+2824296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.197875,28.40839,0,NULL,60055533246,938367706,14661995,17.4),(120489,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120489,36.66,0.46,215,53376,70,NULL,NULL,'2MASX J14244762+0729567',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.1985,7.49897,0.029,NULL,58274742141,910542845,14227231,17),(120490,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120490,35.71,0.46,139,53377,70,NULL,NULL,'VIII Zw 413',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00019,NULL,'15.4g',0.55,'E0',NULL,NULL,NULL,NULL,1,216.202375,-2.21553,0.133,NULL,43519846494,679997601,10624962,15.4),(120491,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120491,33.84,0.2,58.6,53378,74.4,NULL,NULL,'UGC 09238',NULL,'2013AJ....146...86T',2013,1,1.11,NULL,'G',0.000087,NULL,'15.5g',0.4,'Scd:',NULL,NULL,NULL,NULL,1,216.207208333,35.28492,0,NULL,60043364558,938177571,14659024,15.5),(120492,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120492,34.04,0.44,64.2,53378,NULL,NULL,'Malmquist cor.','UGC 09238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120493,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120493,34.08,0.43,65.5,53378,NULL,NULL,NULL,'UGC 09238',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120494,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120494,37.24,0.46,280,53379,70,NULL,NULL,'LCRS B142215.1-022545',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.210833,-2.65469,0.169,NULL,43516579964,679946561,10624165,17.4),(120495,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120495,36.81,0.19,231,53380,70,NULL,NULL,'2MASX J14245111+2920467',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'15.37',0.3,'Sb',NULL,NULL,NULL,NULL,1,216.2130417,29.34617,0,NULL,60060313154,938442393,14663162,15.37),(120496,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120496,38.11,0.11,418,53381,70,NULL,NULL,'2MASX J14245219+1739425',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.2175417,17.66194,0,NULL,59488694283,929510848,14523607,17.8),(120497,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120497,37.32,0.27,292,53382,70,NULL,NULL,'2MASX J14245257+3451474',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.2190417,34.86322,0,NULL,60038740639,938105322,14657895,17.8),(120498,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120498,36.86,0.09,235,53383,70,NULL,NULL,'IC 4417',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'15.5',0.2,'S0/D','Group member',NULL,NULL,NULL,1,216.223708333,17.03792,0,NULL,59488481871,929507529,14523555,15.5),(120499,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120499,37.31,0.46,290,53384,70,NULL,NULL,'2MASX J14245382+5457169',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.224375,54.95481,0.005,NULL,57254095606,894595243,13978050,17.6),(120500,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120500,33.9,0.8,60.3,53385,75,NULL,'HMCL, I','UGC 09236',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.000027,NULL,'14.9g',0.39,'SBbc?',NULL,NULL,NULL,NULL,1,216.235875,25.02478,0,NULL,60020510550,937820477,14653444,14.9),(120501,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120501,34.01,0.4,63.5,53385,75,NULL,'HMCL, I, raw','UGC 09236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120502,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120502,34.11,0.4,66.3,53385,75,NULL,'HMCL, I, inv','UGC 09236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120503,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120503,34.2,0.4,69.1,53385,75,NULL,'HMCL, I, cor','UGC 09236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120504,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120504,34.26,0.2,71.1,53385,74.4,NULL,NULL,'UGC 09236',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120505,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120505,37.39,0.27,300,53386,70,NULL,NULL,'SDSS J142456.97+475355.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.237416667,47.89872,0.024,NULL,59248070740,925751105,14464861,17.4),(120506,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120506,35.58,0.45,130,53387,NULL,NULL,NULL,'2MASX J14245831+3521164',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.00001,NULL,'16.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.242917,35.35456,0,NULL,60043364283,938177566,14659024,16.5),(120507,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120507,35.57,0.45,130,53387,NULL,NULL,'Malmquist cor.','2MASX J14245831+3521164',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120508,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120508,35.62,0.2,133,53387,74.4,NULL,NULL,'2MASX J14245831+3521164',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120509,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120509,37.39,0.46,301,53388,70,NULL,NULL,'2MASX J14245842+5229370',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.2435417,52.49369,0,NULL,59195766250,924933847,14452091,17.2),(120510,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120510,36.18,0.74,172,53389,70,NULL,NULL,'CGCG 019-018 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.04,'Often confused with CGCG 019-018 NED02 at z = 0.031.','G',0.00012,NULL,'16.6b',0.3,'Sc',NULL,NULL,NULL,NULL,1,216.246375,-3.06703,0.153,NULL,43508985587,679827899,10622310,16.6),(120511,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120511,38.06,0.46,409,53390,70,NULL,NULL,'2MASX J14250106+5703549',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.254375,57.06525,0,NULL,57250112826,894533012,13977078,17.9),(120512,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120512,37.15,0.46,269,53391,70,NULL,NULL,'2MASX J14250113+1142417',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,216.254625,11.71172,0,NULL,58267506029,910429781,14225465,17),(120513,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120513,36.81,0.19,231,53392,70,NULL,NULL,'2MASX J14250112+2950478',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000173,NULL,'16.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.2547917,29.84664,0,NULL,60059758086,938433720,14663026,16.5),(120514,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120514,37.39,0.27,300,53393,70,NULL,NULL,'2MASX J14250144+4757128',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000221,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,216.256083,47.9535,0.024,NULL,59248029482,925750460,14464850,15.8),(120515,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120515,37.78,0.46,360,53394,70,NULL,NULL,'2MASX J14250156+2415298',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000188,NULL,'17.3g',0.23,'AGN',NULL,NULL,NULL,NULL,1,216.25675,24.25844,0.024,NULL,59513124995,929892578,14529571,17.3),(120516,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120516,36.31,0.46,183,53395,70,NULL,NULL,'2MASX J14250306+0435110',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000064,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.2627083,4.58639,0.033,NULL,58304520279,911008129,14234502,16.7),(120517,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120517,35.52,0.54,127,53396,70,NULL,NULL,'2MASX J14250311-4449336',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.2b',0.2,NULL,NULL,NULL,NULL,NULL,1,216.263083,-44.82606,0.365,NULL,46801992061,731281125,11426267,17.2),(120518,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120518,38.18,0.46,433,53397,70,NULL,NULL,'SDSS J142503.46+343748.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'18.1g',0.16,'E/S0',NULL,NULL,NULL,NULL,1,216.264458333,34.63028,0,NULL,60038796043,938106188,14657909,18.1),(120519,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120519,38.09,0.46,415,53398,70,NULL,NULL,'2MASX J14250368+0552080',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.265375,5.86881,0.033,NULL,58301398715,910959354,14233739,17.7),(120520,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120520,37.5,0.46,316,53399,70,NULL,NULL,'2MASX J14250379+4418108',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.2657917,44.30292,0,NULL,59229984825,925468512,14460445,17.6),(120521,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120521,39.16,0.46,681,53400,70,NULL,NULL,'SDSS J142504.63+180937.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.269333,18.16053,0,NULL,59488026631,929500416,14523444,18.2),(120522,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120522,36.86,0.09,235,53401,70,NULL,NULL,'2MASX J14250562+1709335',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.273375,17.15928,0,NULL,59488525241,929508206,14523565,17.5),(120523,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120523,38.11,0.11,418,53402,70,NULL,NULL,'2MASX J14250618+1740215',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.87',0.13,NULL,NULL,NULL,NULL,NULL,1,216.275625,17.67275,0,NULL,59488724479,929511319,14523614,18.87),(120524,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120524,38.78,0.46,571,53403,70,NULL,NULL,'SDSS J142506.81+253257.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.278416667,25.54919,0,NULL,60020671834,937822997,14653484,18.4),(120525,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120525,36.65,0.46,214,53404,70,NULL,NULL,'2MASX J14250749+3603270',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000174,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,216.28125,36.05742,0,NULL,60042753719,938168026,14658875,16),(120526,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120526,33.58,0.4,52.1,53405,NULL,NULL,'mean','NGC 5605',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000023,NULL,'13.19',1.3,'(R\')SAB(rs)c   HII',NULL,NULL,NULL,NULL,1,216.281541667,-13.163,0.309,NULL,46540988822,727202950,11362546,13.19),(120527,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120527,33.87,0.47,59.4,53405,NULL,NULL,'H','NGC 5605',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120528,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120528,33.88,0.45,59.6,53405,NULL,NULL,'K','NGC 5605',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120529,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120529,33.89,0.46,60.1,53405,NULL,NULL,'J','NGC 5605',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120530,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120530,38.25,0.46,446,53406,70,NULL,NULL,'2MASX J14250811+4219208',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.283583,42.32233,0,NULL,59948116530,936689320,14635770,17.3),(120531,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120531,37.54,0.33,322,53407,70,NULL,NULL,'2MASX J14250982+1348143',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.290833,13.80411,0,NULL,59479046377,929360099,14521251,17.8),(120532,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120532,37.13,0.46,267,53408,70,NULL,NULL,'2MASX J14251004+6040455',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,216.2917917,60.67939,0.009,NULL,57755493588,902429587,14100462,16.7),(120533,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120533,36.18,0.46,172,53409,70,NULL,NULL,'2MASX J14251252+3328254',NULL,'2015arXiv151105856S',2015,1,0.51,'Sanchez-Blazquez et al (2009MNRAS.400.1264S) give z=0.133.','G',0.000188,NULL,'16.0g',0.39,'E/S0',NULL,NULL,NULL,NULL,1,216.3022083,33.47372,0,NULL,60040031698,938125495,14658210,16),(120534,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120534,37.49,0.46,315,53410,70,NULL,NULL,'2MASX J14251327+2949348',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000185,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,216.30525,29.82639,0,NULL,60059755912,938433686,14663026,16.2),(120535,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120535,34.49,0.49,79,53411,75,NULL,'IR','UGC 09239',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000033,NULL,'16.6g',0.21,'Sbc',NULL,NULL,NULL,NULL,1,216.3055,13.74581,0,NULL,59475572434,929305819,14520403,16.6),(120536,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120536,34.97,0.2,98.6,53411,74.4,NULL,NULL,'UGC 09239',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120537,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120537,35.08,0.37,104,53411,NULL,NULL,'Malmquist cor.','UGC 09239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120538,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120538,35.2,0.35,109,53411,NULL,NULL,NULL,'UGC 09239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120539,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120539,36.8,0.46,229,53412,70,NULL,NULL,'2MASX J14251406+1120334',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.3085,11.34264,0.008,NULL,58268231727,910441120,14225642,16.7),(120540,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120540,38.05,0.46,407,53413,70,NULL,NULL,'2MASX J14251447+2448558',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000193,NULL,'18.22',0.16,NULL,NULL,NULL,NULL,NULL,1,216.3102917,24.81544,0.006,NULL,59496428360,929631693,14525495,18.22),(120541,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120541,38.13,0.46,424,53414,70,NULL,NULL,'2MASX J14251479-0018286',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000297,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.311667,-0.308,0.105,NULL,43505454263,679772722,10621448,17.8),(120542,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120542,37.7,0.46,347,53415,70,NULL,NULL,'SDSS J142514.87+143440.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.311958333,14.57806,0,NULL,59479254783,929363355,14521302,18.4),(120543,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120543,37.35,0.46,295,53416,70,NULL,NULL,'2MASX J14251520+4404388',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.3132917,44.07739,0,NULL,59954643523,936791305,14637364,16.9),(120544,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120544,36.86,0.09,235,53417,70,NULL,NULL,'2MASX J14251593+1641303',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.60',0.13,NULL,NULL,NULL,NULL,NULL,1,216.316417,16.69189,0,NULL,59491318969,929551858,14524247,18.6),(120545,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120545,35.76,0.51,142,53418,70,NULL,NULL,'2MASX J14251727-1455467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,216.3219583,-14.92967,0.293,NULL,46543373963,727240218,11363128,14.3),(120546,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120546,37.95,0.46,389,53419,70,NULL,NULL,'2MASX J14251742+1609303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.32275,16.15836,0,NULL,59491049636,929547650,14524182,17.3),(120547,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120547,37.11,0.46,264,53420,70,NULL,NULL,'2MASX J14251850+2314177',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,216.327167,23.23822,0.06,NULL,59516623578,929947243,14530425,16.4),(120548,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120548,37.44,0.46,307,53421,70,NULL,NULL,'2MASX J14251861+4029230',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,216.327417,40.48978,0,NULL,59948883107,936701298,14635957,16.5),(120549,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120549,37.68,0.33,343,53422,70,NULL,NULL,'2MASX J14251945+0020535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.331083333,0.34817,0.101,NULL,58298764975,910918202,14233096,17.4),(120550,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120550,37.54,0.46,322,53423,70,NULL,NULL,'SDSS J142520.09+054512.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.3337083,5.75347,0.033,NULL,58304253251,911003957,14234436,17.8),(120551,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120551,37.63,0.46,335,53424,70,NULL,NULL,'2MASX J14252017+2332007',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.3340417,23.53347,0.051,NULL,59513726211,929901972,14529718,17),(120552,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120552,30.69,NULL,13.8,53425,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09242',NULL,'2010Ap&SS.325..163P',2010,1,5.69,NULL,'G',0.00001,NULL,'14.0B',0.36,'Sc',NULL,NULL,NULL,NULL,1,216.337583,39.53958,0.028,NULL,60065859518,938529054,14664516,14),(120553,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120553,30.72,NULL,13.9,53425,NULL,NULL,'Dipole + Quadrupole','UGC 09242',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120554,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120554,30.72,NULL,13.9,53425,NULL,NULL,'Dipole','UGC 09242',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120555,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120555,30.85,NULL,14.8,53425,NULL,NULL,NULL,'UGC 09242',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120556,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120556,31.68,0.36,21.7,53425,NULL,NULL,NULL,'UGC 09242',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120557,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120557,32.07,0.2,25.9,53425,74.4,NULL,NULL,'UGC 09242',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120558,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120558,32.1,0.4,26.3,53425,75,NULL,'B','UGC 09242',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120559,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120559,32.15,0.43,26.9,53425,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09242',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120560,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120560,32.17,0.43,27.1,53425,75,NULL,'3.6 micron, color corrected','UGC 09242',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120561,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120561,38.15,0.46,427,53426,70,NULL,NULL,'2MASX J14252121+2605163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.55',0.16,NULL,NULL,NULL,NULL,NULL,1,216.3384583,26.08783,0,NULL,60021092114,937829564,14653586,18.55),(120562,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120562,36.86,0.09,235,53427,70,NULL,NULL,'CGCG 104-018',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000207,NULL,'15.5',0.6,'S0','Group member',NULL,NULL,NULL,1,216.3410417,17.29081,0,NULL,59488504796,929507887,14523560,15.5),(120563,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120563,37.76,0.46,356,53428,70,NULL,NULL,'2MASX J14252265+1403223',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.344417,14.05633,0,NULL,59479071703,929360495,14521257,16.9),(120564,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120564,36.28,0.15,180,53429,70,NULL,NULL,'2MASX J14252442+2556314',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000197,NULL,'17.04',0.32,NULL,NULL,NULL,NULL,NULL,1,216.351916667,25.94217,0,NULL,60021094545,937829602,14653587,17.04),(120565,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120565,37.94,0.46,387,53430,70,NULL,NULL,'2MASX J14252572+4711442',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.357,47.19561,0,NULL,59228063365,925438490,14459976,17.5),(120566,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120566,38.53,0.46,509,53431,70,NULL,NULL,'2MASX J14252610+3303504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.6g',0.2,'E/S0',NULL,NULL,NULL,NULL,1,216.358625,33.06411,0,NULL,60040184873,938127888,14658248,17.6),(120567,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120567,37.54,0.33,322,53432,70,NULL,NULL,'2MASX J14252623+1348373',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.35925,13.81047,0,NULL,59479039471,929359991,14521249,17.1),(120568,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120568,37.36,0.33,296,53433,70,NULL,NULL,'2MASX J14252645+4408092',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.360375,44.13583,0,NULL,59954580597,936790321,14637348,16.7),(120569,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120569,31.04,0.43,16.2,53434,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09245',NULL,'2014MNRAS.444..527S',2014,1,1.65,NULL,'G',0.000013,NULL,'15.5g',0.34,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,216.361917,56.32017,0,NULL,57257478376,894648099,13978876,15.5),(120570,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120570,31.07,0.63,16.4,53434,NULL,NULL,NULL,'UGC 09245',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120571,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120571,31.17,0.2,17.1,53434,74.4,NULL,NULL,'UGC 09245',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120572,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120572,31.22,0.43,17.5,53434,75,NULL,'3.6 micron, color corrected','UGC 09245',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120573,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120573,31.23,0.58,17.6,53434,NULL,NULL,'Malmquist cor.','UGC 09245',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120574,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120574,36.34,0.46,186,53435,70,NULL,NULL,'2MASX J14253013+0655214',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.375583,6.92269,0.029,NULL,58275473679,910554276,14227410,16.7),(120575,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120575,38.11,0.11,418,53436,70,NULL,NULL,'2MASX J14253096+1749243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.379,17.82336,0,NULL,59487955500,929499304,14523426,17.8),(120576,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120576,36.66,0.46,215,53437,70,NULL,NULL,'2MASX J14253276+0746344',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.3864583,7.77622,0.021,NULL,58274131608,910533306,14227082,16.9),(120577,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120577,33.29,0.2,45.5,53438,74.4,NULL,NULL,'UGC 09243',NULL,'2013AJ....146...86T',2013,1,1.19,NULL,'G',0.000033,NULL,'15.4g',0.53,'Scd:',NULL,NULL,NULL,NULL,1,216.388458333,33.84811,0,NULL,60040521118,938133142,14658330,15.4),(120578,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120578,33.59,0.49,52.4,53438,NULL,NULL,NULL,'UGC 09243',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120579,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120579,33.72,0.46,55.4,53438,NULL,NULL,'Malmquist cor.','UGC 09243',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120580,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120580,37.18,0.46,273,53439,70,NULL,NULL,'2MASX J14253327+3935298',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000167,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,216.38875,39.59167,0.028,NULL,60065873398,938529271,14664519,16.2),(120581,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120581,37.68,0.33,343,53440,70,NULL,NULL,'2MASX J14253432+0019565',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000081,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.393167,0.33247,0.101,NULL,58298777204,910918393,14233099,16.9),(120582,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120582,38.11,0.11,418,53441,70,NULL,NULL,'2MASX J14253628+1743433',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.13',0.18,'BrClG',NULL,NULL,NULL,NULL,1,216.40125,17.72867,0,NULL,59488680228,929510628,14523603,18.13),(120583,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120583,37.34,0.46,294,53442,70,NULL,NULL,'2MASX J14253648+2620574',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000127,NULL,'18.14',0.2,NULL,NULL,NULL,NULL,NULL,1,216.401917,26.34928,0,NULL,60054457793,938350903,14661732,18.14),(120584,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120584,38.11,0.11,418,53443,70,NULL,NULL,'2MASX J14253914+1742219',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.413208333,17.70614,0,NULL,59488681343,929510645,14523603,17.3),(120585,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120585,33.87,0.8,59.6,53444,75,NULL,'HMCL, I','IC 4420',NULL,'1997ApJS..109..333W',1997,1,0.88,NULL,'G',0.000027,NULL,'15.6g',0.32,'SB(b)',NULL,NULL,NULL,NULL,1,216.4142083,25.37836,0,NULL,60020703027,937823484,14653491,15.6),(120586,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120586,33.6,0.4,52.4,53444,75,NULL,'HMCL, I, raw','IC 4420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120587,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120587,33.61,0.4,52.8,53444,75,NULL,'HMCL, I, inv','IC 4420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120588,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120588,33.92,0.4,60.8,53444,75,NULL,'HMCL, I, cor','IC 4420',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120589,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120589,37.03,0.46,255,53445,70,NULL,NULL,'2MASX J14253952+2709384',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.4147917,27.16067,0,NULL,60057740556,938402196,14662534,16.7),(120590,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120590,38.52,0.46,505,53446,70,NULL,NULL,'2MASX J14254036+2345131',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.418125,23.75367,0.043,NULL,59513740978,929902202,14529721,18.3),(120591,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120591,36.99,0.46,250,53447,70,NULL,NULL,'2MASX J14254059+1454440',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.16,NULL,NULL,NULL,NULL,NULL,1,216.4190417,14.91206,0,NULL,59478526942,929351983,14521124,18.26),(120592,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120592,37.8,0.33,363,53448,70,NULL,NULL,'2MASX J14254111+3222225',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.421417,32.37297,0,NULL,60047358077,938239969,14659999,17),(120593,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120593,37.78,0.46,360,53449,70,NULL,NULL,'SDSS J142541.49+035914.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.422875,3.98736,0.049,NULL,58294986644,910859166,14232174,18.2),(120594,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120594,37.36,0.33,296,53450,70,NULL,NULL,'2MASX J14254271+4411222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.428,44.18939,0,NULL,59954593298,936790520,14637351,17),(120595,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120595,36.86,0.09,235,53451,70,NULL,NULL,'2MASX J14254279+1644450',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.01',0.2,'S0/E','Group member',NULL,NULL,NULL,1,216.428333,16.746,0,NULL,59491308287,929551691,14524245,17.01),(120596,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120596,37.61,0.27,333,53452,70,NULL,NULL,'2MASX J14254280+2542404',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.428333,25.71133,0,NULL,60021400529,937834383,14653662,18.1),(120597,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120597,37.7,0.46,347,53453,70,NULL,NULL,'2MASX J14254294+5538494',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.429,55.64703,0.005,NULL,57254872973,894607390,13978240,17),(120598,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120598,37.8,0.33,363,53454,70,NULL,NULL,'2MASX J14254459+3221395',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,216.435833,32.36089,0,NULL,60047358137,938239970,14659999,16.2),(120599,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120599,37.25,0.46,282,53455,70,NULL,NULL,'SDSS J142544.65+221207.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.75',0.14,NULL,NULL,NULL,NULL,NULL,1,216.436083,22.20214,0.017,NULL,59515773118,929933954,14530218,18.75),(120600,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120600,30.79,0.43,14.4,53456,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-37-006',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00001,NULL,'13.88',0.6,'I0 pec?        HII',NULL,NULL,NULL,NULL,1,216.439125,-5.40192,0.125,NULL,43540715303,680323676,10630057,13.88),(120601,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120601,36.86,0.09,235,53457,70,NULL,NULL,'2MASX J14254612+1702300',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.62',0.13,'S0','Group member',NULL,NULL,NULL,1,216.4422083,17.04161,0,NULL,59488501408,929507834,14523559,18.62),(120602,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120602,36.95,0.46,246,53458,70,NULL,NULL,'2MASX J14254690+1752420',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.4452917,17.87847,0,NULL,59487951465,929499241,14523425,17.5),(120603,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120603,36.23,0.46,176,53459,70,NULL,NULL,'2MASX J14254760+2814104',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000173,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.448333,28.23625,0,NULL,60056102260,938376597,14662134,16.1),(120604,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120604,38.51,0.33,504,53460,70,NULL,NULL,'LCRS B142312.9-021859',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.4515,-2.54108,0.173,NULL,43516721623,679948775,10624199,18.2),(120605,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120605,37.77,0.46,358,53461,70,NULL,NULL,'2MASX J14254893+1204520',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.453667,12.08103,0,NULL,59357852016,927466437,14491663,18),(120606,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120606,37.05,0.46,258,53462,70,NULL,NULL,'2MASX J14254913+2008481',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.79',0.2,NULL,NULL,NULL,NULL,NULL,1,216.454667,20.14664,0.023,NULL,59522777802,930043403,14531928,16.79),(120607,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120607,33.94,0.48,61.3,53463,70,NULL,NULL,'2MASX J14255221-4221512',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,216.4675417,-42.36425,0.401,NULL,47078852464,735607069,11493860,14),(120608,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120608,34.06,0.2,64.9,53464,74.4,NULL,NULL,'ESO 511- G 040',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000017,NULL,'15.5',1.2,'Sc',NULL,NULL,NULL,NULL,1,216.475333333,-23.97872,0.257,NULL,46565614499,727587726,11368558,15.5),(120609,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120609,37.48,0.46,313,53465,70,NULL,NULL,'2MASX J14255504+3532176',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.5g',0.22,'E/S0',NULL,NULL,NULL,NULL,1,216.479375,35.53817,0,NULL,60042666229,938166659,14658854,17.5),(120610,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120610,38.11,0.11,418,53466,70,NULL,NULL,'2MASX J14255545+1749340',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.4809583,17.82631,0,NULL,59487947922,929499186,14523424,17.7),(120611,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120611,37.74,0.33,353,53467,70,NULL,NULL,'2MASX J14255592+0405321',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.483125,4.09211,0.037,NULL,58302502813,910976606,14234009,17.1),(120612,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120612,38,0.46,398,53468,70,NULL,NULL,'2MASX J14255605+1426180',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,216.483666667,14.43831,0,NULL,59479285455,929363835,14521309,NULL),(120613,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120613,37.15,0.46,269,53469,70,NULL,NULL,'2MASX J14255631-0215101',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000158,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,216.484667,-2.25283,0.169,NULL,43516236066,679941188,10624081,16.9),(120614,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120614,37.86,0.33,373,53470,70,NULL,NULL,'2MASX J14255640+0614557',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.485083333,6.24867,0.025,NULL,58273093387,910517084,14226829,17.1),(120615,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120615,38,0.46,399,53471,70,NULL,NULL,'SDSS J142556.45+234221.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.4852083,23.70594,0.043,NULL,59513745744,929902277,14529723,18.4),(120616,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120616,38.65,0.46,538,53472,70,NULL,NULL,'2MASX J14255682+1341510',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.486833,13.69758,0,NULL,59475621932,929306592,14520415,18.1),(120617,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120617,38.51,0.33,504,53473,70,NULL,NULL,'LCRS B142322.6-021610',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,216.4915417,-2.49417,0.173,NULL,43516711265,679948613,10624197,18.5),(120618,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120618,39.3,0.46,726,53474,70,NULL,NULL,'2MASXi J1425579+250504',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000183,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.491583333,25.08461,0.036,NULL,60020601697,937821901,14653467,17.9),(120619,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120619,37.48,0.33,313,53475,70,NULL,NULL,'2MASX J14255962+0621557',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.498417,6.36542,0.025,NULL,58273087486,910516991,14226827,17.8),(120620,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120620,38.61,0.46,527,53476,70,NULL,NULL,'2MASX J14260114+3651190',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.504958333,36.85517,0,NULL,60063645026,938494453,14663975,18.1),(120621,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120621,37.76,0.46,357,53477,70,NULL,NULL,'2MASX J14260173+3508546',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.5g',0.17,'S0',NULL,NULL,NULL,NULL,1,216.5072083,35.14856,0,NULL,60039240324,938113130,14658017,17.5),(120622,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120622,37.04,0.46,256,53478,70,NULL,NULL,'2MASX J14260190+3007256',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000165,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.507917,30.12372,0,NULL,60059764098,938433814,14663028,16.8),(120623,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120623,37.99,0.46,396,53479,70,NULL,NULL,'2MASX J14260214+0128251',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.5089583,1.47361,0.065,NULL,58299221514,910925336,14233208,17.5),(120624,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120624,35.39,0.46,120,53480,70,NULL,NULL,'CGCG 047-039',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000177,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,216.509667,8.11125,0.037,NULL,58282436742,910663074,14229110,15.5),(120625,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120625,38.22,0.23,440,53481,NULL,NULL,'Hydrost. Eq.','ABELL 1914',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,216.506667,37.82722,0,NULL,60064174811,938502731,14664105,NULL),(120626,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120626,38.88,NULL,596,53481,NULL,NULL,'3.1 (red) calibration','ABELL 1914',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120627,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120627,39.13,0.39,670,53481,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 1914',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120628,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120628,39.16,NULL,678,53481,NULL,NULL,'4.2 (black) calibration','ABELL 1914',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120629,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120629,39.16,0.38,680,53481,NULL,NULL,'Isotherm.','ABELL 1914',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120630,'SZ effect','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120630,39.55,NULL,812,53481,NULL,NULL,'4.1 (blue) calibration','ABELL 1914',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120631,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120631,38.3,0.27,458,53482,70,NULL,NULL,'2MASX J14260298+2255233',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.5125417,22.92308,0.056,NULL,59516547771,929946058,14530407,17.9),(120632,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120632,37.86,0.33,373,53483,70,NULL,NULL,'SDSS J142603.05+061445.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.5127083,6.24608,0.025,NULL,58273103134,910517236,14226831,18),(120633,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120633,36.13,0.57,169,53484,70,NULL,NULL,'LCRS B142321.0-122145',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,216.5142917,-12.58736,0.313,NULL,46674444929,729288202,11395128,16.05),(120634,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120634,37.41,0.33,303,53485,70,NULL,NULL,'2MASX J14260359+2434519',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.514958333,24.58114,0.019,NULL,59496286198,929629471,14525460,17.4),(120635,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120635,38.21,0.46,439,53486,70,NULL,NULL,'2MASX J14260431+3022206',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000205,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.517958333,30.37219,0,NULL,60048302751,938254730,14660230,17.3),(120636,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120636,37.78,0.46,359,53487,70,NULL,NULL,'2MASX J14260478+1940123',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.5199583,19.67017,0.034,NULL,59522872830,930044887,14531951,17.8),(120637,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120637,37.54,0.33,322,53488,70,NULL,NULL,'2MASX J14260486-0132201',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.520167,-1.53894,0.101,NULL,43519590499,679993601,10624900,17.4),(120638,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120638,36.83,0.46,232,53489,70,NULL,NULL,'2MASX J14260572+2448159',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.523833,24.80447,0.036,NULL,59496382962,929630983,14525484,16.8),(120639,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120639,37.54,0.46,321,53490,70,NULL,NULL,'2MASX J14260646+1232510',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000189,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.526791667,12.54747,0,NULL,59542554477,930352413,14536756,16.8),(120640,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120640,38.14,0.33,425,53491,70,NULL,NULL,'2MASX J14260717+5717225',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000192,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.529916667,57.28972,0,NULL,57249950093,894530470,13977038,17.2),(120641,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120641,34.62,0.69,83.8,53492,100,NULL,'mid-IR','UGC 09244',NULL,'2013ApJ...771...88L',2013,1,1.22,NULL,'G',0.000033,NULL,'14.4g',0.68,'SBbc',NULL,NULL,NULL,NULL,1,216.534958333,5.23792,0.045,NULL,58304800084,911012501,14234570,14.4),(120642,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120642,35.15,0.2,107,53492,74.4,NULL,NULL,'UGC 09244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120643,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120643,35.41,0.4,121,53492,NULL,NULL,'mean','UGC 09244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120644,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120644,35.43,0.47,122,53492,NULL,NULL,'H','UGC 09244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120645,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120645,35.56,0.45,129,53492,NULL,NULL,'K','UGC 09244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120646,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120646,35.62,0.46,133,53492,NULL,NULL,'J','UGC 09244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120647,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120647,37.48,0.33,313,53493,70,NULL,NULL,'2MASX J14260905+0630469',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.537625,6.51308,0,NULL,58273186893,910518545,14226852,17.1),(120648,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120648,38.19,0.46,434,53494,70,NULL,NULL,'2MASX J14261029+2634419',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.542875,26.57856,0,NULL,60054345991,938349156,14661705,18.2),(120649,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120649,37.41,0.33,303,53495,70,NULL,NULL,'2MASX J14261034+2437089',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.543083,24.61922,0.019,NULL,59496402346,929631286,14525488,18.2),(120650,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120650,35.93,0.46,153,53496,70,NULL,NULL,'SBS 1424+497',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.0g',0.28,'S0^-',NULL,NULL,NULL,NULL,1,216.54325,49.49283,0,NULL,59246224444,925722256,14464410,16),(120651,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120651,35.12,0.5,106,53497,NULL,NULL,'Malmquist cor.','UGC 09244 NOTES01',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.00009,NULL,'16.2g',0.33,'S',NULL,NULL,NULL,NULL,1,216.544208333,5.25653,0.045,NULL,58304804020,911012562,14234571,16.2),(120652,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120652,35.34,0.45,117,53497,NULL,NULL,NULL,'UGC 09244 NOTES01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120653,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120653,35.38,0.2,119,53497,74.4,NULL,NULL,'UGC 09244 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120654,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120654,37.12,0.23,265,53498,70,NULL,NULL,'2MASX J14261125+4353564',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.547,43.89897,0.006,NULL,59954676365,936791818,14637372,17.3),(120655,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120655,37.32,0.27,292,53499,70,NULL,NULL,'2MASX J14261138+3453015',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'16.5g',0.29,'S0',NULL,NULL,NULL,NULL,1,216.5475,34.88386,0,NULL,60038757963,938105593,14657899,16.5),(120656,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120656,33.73,0.8,55.7,53500,75,NULL,'CF, r','NGC 5622',NULL,'1997ApJS..109..333W',1997,1,1.56,NULL,'G',0.000007,NULL,'13.9g',0.78,'Sb','Isolated galaxy',NULL,NULL,NULL,1,216.5507917,48.564,0.033,NULL,59248368499,925755757,14464933,13.9),(120657,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120657,32.91,0.69,38.2,53500,100,NULL,'mid-IR','NGC 5622',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120658,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120658,33.85,0.38,58.8,53500,75,NULL,'CF, r, raw','NGC 5622',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120659,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120659,33.96,0.38,62,53500,75,NULL,'CF, r, inv','NGC 5622',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120660,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120660,34.04,0.4,64.3,53500,NULL,NULL,'mean','NGC 5622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120661,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120661,34.05,0.38,64.6,53500,75,NULL,'CF, r, cor','NGC 5622',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120662,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120662,34.28,0.2,71.8,53500,74.4,NULL,NULL,'NGC 5622',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120663,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120663,34.32,0.47,73.1,53500,NULL,NULL,'H','NGC 5622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120664,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120664,34.34,0.46,73.8,53500,NULL,NULL,'J','NGC 5622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120665,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120665,34.38,0.45,75.1,53500,NULL,NULL,'K','NGC 5622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120666,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120666,38.24,0.46,444,53501,70,NULL,NULL,'2MASX J14261225+2111414',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.85',0.23,NULL,NULL,NULL,NULL,NULL,1,216.551083,21.19475,0.045,NULL,59523850873,930060169,14532190,17.85),(120667,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120667,38.14,0.33,425,53502,70,NULL,NULL,'2MASX J14261233+5721415',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.5515,57.36164,0,NULL,57249771099,894527673,13976994,18.5),(120668,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120668,37.88,0.46,377,53503,70,NULL,NULL,'2MASX J14261314+4508175',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.5549583,45.13814,0,NULL,59230388078,925474813,14460543,18.1),(120669,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120669,37.41,0.46,303,53504,70,NULL,NULL,'2MASX J14261353+1623058',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.59',0.13,NULL,NULL,NULL,NULL,NULL,1,216.556417,16.38497,0,NULL,59491363112,929552548,14524258,18.59),(120670,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120670,37.54,0.33,322,53505,70,NULL,NULL,'2MASX J14261377-0111237',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000078,NULL,'16.9b',0.31,NULL,NULL,NULL,NULL,NULL,1,216.55725,-1.19003,0.105,NULL,43517684812,679963825,10624434,16.9),(120671,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120671,38.34,0.46,465,53506,70,NULL,NULL,'2MASX J14261457+4600494',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.560583,46.01383,0,NULL,59231304538,925489133,14460767,17.8),(120672,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120672,35.63,0.46,134,53507,70,NULL,NULL,'2MASX J14261468+3531050',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000166,NULL,'15.7g',0.36,'E/S0',NULL,NULL,NULL,NULL,1,216.5610417,35.51814,0,NULL,60038438145,938100596,14657821,15.7),(120673,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120673,38.3,0.27,458,53508,70,NULL,NULL,'2MASX J14261617+2245314',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.93',0.13,NULL,NULL,NULL,NULL,NULL,1,216.5675417,22.75886,0.056,NULL,59515413091,929928329,14530130,18.93),(120674,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120674,37.74,0.33,353,53509,70,NULL,NULL,'SDSS J142616.38+040234.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.568291667,4.04297,0.041,NULL,58302526249,910976972,14234015,18),(120675,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120675,35.9,0.75,152,53510,70,NULL,NULL,'2MASX J14261664-1630034',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.07',0.3,NULL,NULL,NULL,NULL,NULL,1,216.56925,-16.50106,0.353,NULL,46556367710,727443245,11366300,16.07),(120676,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120676,38.3,0.27,458,53511,70,NULL,NULL,'2MASX J14261724+2253574',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.571916667,22.89931,0.056,NULL,59516548941,929946077,14530407,17.4),(120677,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120677,35.19,0.18,106,53512,74.2,NULL,'SALT 2','IC 4423',0.03024,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000033,NULL,'15.00',0.6,'S?             AGN',NULL,NULL,NULL,NULL,1,216.573916667,26.24614,0,NULL,60021122659,937830041,14653594,15),(120678,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120678,35.75,0.22,137,53512,72,NULL,NULL,'IC 4423',0.03024,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120679,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120679,35.72,0.08,139,53512,74.4,NULL,NULL,'IC 4423',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120680,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120680,35.93,0.1,145,53512,65,NULL,'MLCS2k2','IC 4423',0.03024,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120681,'SNIa','2016-12-15 15:15:25','2016-12-16 11:20:38','1','SN 2001ay',NULL,120681,35.98,0.17,152,53512,73.8,NULL,'SALT 2 (SNANA)','IC 4423',0.0312,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120682,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120682,35.72,0.08,139,53512,74.4,NULL,NULL,'IC 4423',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120683,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120683,35.91,0.43,152,53512,75,NULL,'3.6 micron, color corrected','IC 4423',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120684,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120684,36.04,0.43,161,53512,75,NULL,'3.6 micron, color + selection bias corrected','IC 4423',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120685,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120685,36.06,0.4,163,53512,75,NULL,'HOSTS SN 2001ay','IC 4423',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120686,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120686,37.41,0.64,303,53513,70,NULL,NULL,'2MASX J14261770-0930423',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.99',NULL,NULL,NULL,NULL,NULL,NULL,1,216.573833333,-9.51175,0.209,NULL,43522974094,680046470,10625726,15.99),(120687,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120687,36.74,0.46,223,53514,70,NULL,NULL,'2MASX J14261795+0009157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.5747917,0.15433,0.149,NULL,58298736077,910917751,14233089,17.6),(120688,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120688,35.56,0.46,130,53515,70,NULL,NULL,'2MASX J14261833+3024110',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.54',0.27,NULL,NULL,NULL,NULL,NULL,1,216.5762917,30.40325,0,NULL,60048336033,938255250,14660238,16.54),(120689,'BCG','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120689,37.49,0.35,299,53516,60,NULL,'ABELL 1913, BCG','CGCG 104-021',0.0533,'1980ApJ...241..486H',1980,1,0.8,NULL,'G',NULL,NULL,'15.7',0.5,'SBab','Group member',NULL,NULL,NULL,1,216.58275,16.79728,0,NULL,59491456254,929554003,14524281,15.7),(120690,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120690,36.5,0.46,200,53517,70,NULL,NULL,'2MASX J14261996+3132421',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000168,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.583166667,31.54497,0,NULL,60047039272,938234988,14659921,16.4),(120691,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120691,37.12,0.23,265,53518,70,NULL,NULL,'2MASX J14262004+4354395',NULL,'2015arXiv151105856S',2015,1,0.51,'The MAPS image includes a superposed star.','G',0.000185,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,216.5835417,43.91119,0.022,NULL,59954679746,936791871,14637372,16.1),(120692,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120692,37.61,0.27,333,53519,70,NULL,NULL,'SDSS J142620.17+254433.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.5840417,25.74267,0,NULL,60021394557,937834289,14653660,18.1),(120693,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120693,37.5,0.46,316,53520,70,NULL,NULL,'2MASX J14262043+1458448',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,216.585125,14.97922,0,NULL,59476651607,929322681,14520666,18.3),(120694,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120694,37.45,0.46,309,53521,70,NULL,NULL,'2MASX J14262103-0123308',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000145,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.587583,-1.39181,0.105,NULL,43517696711,679964011,10624437,17),(120695,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120695,37.96,0.46,390,53522,70,NULL,NULL,'2MASX J14262200+1633168',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.59175,16.55483,0,NULL,59491402155,929553158,14524268,17.4),(120696,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120696,35.78,0.46,143,53523,70,NULL,NULL,'2MASX J14262266+2528368',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00012,NULL,'15.8g',0.46,NULL,NULL,NULL,NULL,NULL,1,216.5942083,25.47697,0,NULL,60021474181,937835534,14653680,15.8),(120697,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120697,37.61,0.27,333,53524,70,NULL,NULL,'2MASX J14262525+2542358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.6049583,25.70994,0,NULL,60021394703,937834292,14653660,17.9),(120698,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120698,38.29,0.46,455,53525,70,NULL,NULL,'SDSS J142625.28+475936.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.605333333,47.99342,0.053,NULL,59245338567,925708415,14464193,18.5),(120699,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120699,38.21,0.46,439,53526,70,NULL,NULL,'2MASX J14262586+1203078',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.607875,12.05225,0,NULL,59357831772,927466121,14491658,18),(120700,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120700,38.11,0.46,419,53527,70,NULL,NULL,'2MASX J14262595+5450456',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.608083,54.84589,0.005,NULL,57254322874,894598794,13978106,17.3),(120701,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120701,36.86,0.09,235,53528,70,NULL,NULL,'2MASX J14262644+1644418',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'18.05',0.3,'S0','Group member',NULL,NULL,NULL,1,216.6102083,16.74494,0,NULL,59491482301,929554410,14524287,18.05),(120702,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120702,36.4,0.33,191,53529,70,NULL,NULL,'2MASX J14262649+2934198',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'16.71',0.33,'E',NULL,NULL,NULL,NULL,1,216.610458333,29.57217,0,NULL,60060233774,938441152,14663143,16.71),(120703,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120703,37.85,0.46,371,53530,70,NULL,NULL,'2MASX J14262665+3304391',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.18,'AGN',NULL,NULL,NULL,NULL,1,216.6109583,33.07764,0,NULL,60039744548,938121008,14658140,17.8),(120704,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120704,37.48,0.46,313,53531,70,NULL,NULL,'2MASX J14262677+2501468',NULL,'2015arXiv151105856S',2015,1,0.28,'1999ApJS..122..415A has z = 0.022 +- 0.004.','G',0.000177,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,216.611667,25.02964,0,NULL,60020609147,937822017,14653469,17.2),(120705,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120705,35.02,0.23,101,53532,70,NULL,NULL,'CGCG 075-031 NED01',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000077,NULL,'15.8g',0.37,NULL,NULL,NULL,NULL,NULL,1,216.615833,11.18925,0.044,NULL,58268166105,910440095,14225626,15.8),(120706,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120706,36.86,0.09,235,53533,70,NULL,NULL,'CGCG 104-023',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',NULL,NULL,'15.7',0.6,'SB0','Group member',NULL,NULL,NULL,1,216.622667,16.81764,0,NULL,59491461703,929554089,14524282,15.7),(120707,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120707,36.86,0.09,235,53534,70,NULL,NULL,'2MASX J14262943+1645458',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00025,NULL,'15.9g',0.46,'E','Group member',NULL,NULL,NULL,1,216.62275,16.76281,0,NULL,59491468677,929554198,14524284,15.9),(120708,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120708,35.98,0.5,157,53535,70,NULL,NULL,'ESO 579- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'15.77',0.9,'S0',NULL,NULL,NULL,NULL,1,216.6234583,-20.19442,0.317,NULL,46572532792,727695824,11370247,15.77),(120709,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120709,37.98,0.46,395,53536,70,NULL,NULL,'2MASX J14263013+2205464',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,216.625625,22.09622,0.041,NULL,59515806744,929934480,14530226,18.37),(120710,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120710,36.45,0.46,195,53537,70,NULL,NULL,'2MASX J14263019+0502437',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.6257083,5.04553,0.045,NULL,58305009775,911015777,14234621,16.9),(120711,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120711,36.86,0.09,235,53538,70,NULL,NULL,'2MASX J14263014+1636238',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000367,NULL,'16.56',0.5,'E/S0','Group member',NULL,NULL,NULL,1,216.62575,16.60667,0,NULL,59491442861,929553794,14524278,16.56),(120712,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120712,36.86,0.09,235,53539,70,NULL,NULL,'2MASX J14263055+1641428',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'17.70',0.3,'E','Group member',NULL,NULL,NULL,1,216.627167,16.69536,0,NULL,59491481206,929554393,14524287,17.7),(120713,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120713,34.89,0.39,94.9,53540,NULL,NULL,NULL,'UGC 09246',NULL,'2009ApJS..182..474S',2009,1,0.99,NULL,'G',0.000033,NULL,'15.4g',0.39,'S?',NULL,NULL,NULL,NULL,1,216.627583,5.97636,0.053,NULL,58303235375,910988052,14234188,15.4),(120714,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120714,35.01,0.37,100,53540,NULL,NULL,'Malmquist cor.','UGC 09246',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120715,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120715,35.02,0.2,101,53540,74.4,NULL,NULL,'UGC 09246',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120716,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120716,37.49,0.46,315,53541,70,NULL,NULL,'2MASX J14263114+1417098',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.6299583,14.28603,0,NULL,59479017537,929359649,14521244,17.9),(120717,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120717,37.64,0.46,338,53542,70,NULL,NULL,'2MASX J14263141+1422238',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.631,14.37322,0,NULL,59479026798,929359793,14521246,18.2),(120718,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120718,35.84,0.46,147,53543,70,NULL,NULL,'CGCG 133-056',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000077,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,216.6330417,21.55717,0.043,NULL,59523903195,930060987,14532202,15.6),(120719,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120719,36.86,0.09,235,53544,70,NULL,NULL,'2MASX J14263306+1650478',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'18.21',0.2,'E','Group member',NULL,NULL,NULL,1,216.637917,16.84664,0,NULL,59491460405,929554068,14524282,18.21),(120720,'SBF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120720,32.22,0.24,27.8,53545,NULL,NULL,'I','NGC 5631',NULL,'2001ApJ...546..681T',2001,1,1.86,NULL,'G',0.000017,NULL,'12.3g',1.62,'SA(s)0^0^      Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,216.63875,56.58264,0,NULL,57257063975,894641624,13978775,12.3),(120721,'SBF','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120721,32.27,0.14,28.4,53545,74.4,NULL,NULL,'NGC 5631',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120722,'Faber-Jackson','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120722,30.67,0.63,13.6,53545,95,NULL,'Michard 1979b, c','NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120723,'Faber-Jackson','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120723,30.87,0.37,14.9,53545,95,NULL,'Weighted Mean','NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120724,'Faber-Jackson','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120724,31.52,0.46,20.1,53545,95,NULL,'Michard 1979a','NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120725,'Faber-Jackson','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120725,31.78,0.81,22.7,53545,55,NULL,'Visvanathan & Sandage 1979','NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120726,'Tertiary','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120726,31.87,0.29,23.7,53545,95,NULL,NULL,'NGC 5631',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120727,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120727,32.57,0.8,32.7,53545,75,NULL,'B','NGC 5631',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120728,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120728,32.17,0.4,27.1,53545,NULL,NULL,'mean','NGC 5631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120729,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120729,32.49,0.45,31.5,53545,NULL,NULL,'K','NGC 5631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120730,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120730,36.86,0.09,235,53546,70,NULL,NULL,'CGCG 104-025',NULL,'2015arXiv151105856S',2015,1,2.5,NULL,'G',0.0002,NULL,'15.6',0.4,'E','Group member',NULL,NULL,NULL,1,216.639791667,16.75967,0,NULL,59491468774,929554199,14524284,15.6),(120731,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120731,35.53,0.33,127,53547,70,NULL,NULL,'2MASX J14263391+3548541',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.6412917,35.81517,0,NULL,60042543367,938164740,14658824,16.5),(120732,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120732,36.86,0.09,235,53548,70,NULL,NULL,'CGCG 104-026',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0003,NULL,'15.6g',0.4,'S0/E','Group member',NULL,NULL,NULL,1,216.6435417,16.81917,0,NULL,59491461771,929554090,14524282,15.6),(120733,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120733,36.62,0.46,211,53549,70,NULL,NULL,'2MASX J14263458+0623237',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.644125,6.39003,0,NULL,58273298267,910520285,14226879,16.6),(120734,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120734,36.49,0.46,198,53550,70,NULL,NULL,'2MASX J14263750+6428163',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000101,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,216.6567083,64.47114,0.041,NULL,57947331191,905427049,14147297,16.1),(120735,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120735,36.89,0.46,238,53551,70,NULL,NULL,'2MASX J14263796+1210199',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.6582917,12.17225,0,NULL,59357826084,927466032,14491656,16.9),(120736,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120736,36.86,0.09,235,53552,70,NULL,NULL,'2MASX J14263884+1716379',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.16,'S0/E','Group member',NULL,NULL,NULL,1,216.661791667,17.27708,0,NULL,59488584848,929509138,14523580,18.13),(120737,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120737,37.64,0.46,337,53553,70,NULL,NULL,'SDSS J142638.82+543323.5',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.661791667,54.55656,0,NULL,57253895824,894592122,13978001,17.5),(120738,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120738,36.86,0.09,235,53554,70,NULL,NULL,'CGCG 104-027',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000287,NULL,'15.7',0.8,'E','Group member',NULL,NULL,NULL,1,216.66425,16.68728,0,NULL,59491476519,929554320,14524286,15.7),(120739,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120739,36.86,0.09,235,53555,70,NULL,NULL,'2MASX J14263994+1723299',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.93',0.2,'S0','Group member',NULL,NULL,NULL,1,216.666375,17.39158,0,NULL,59488446176,929506971,14523546,17.93),(120740,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120740,36.57,0.61,206,53556,70,NULL,NULL,'2MASX J14264068-3610534',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,216.669541667,-36.18161,0.265,NULL,47007673495,734494898,11476482,14.3),(120741,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120741,37.81,0.46,365,53557,70,NULL,NULL,'2MASX J14264079+4703233',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000175,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.669833,47.05658,0,NULL,59228180891,925440326,14460005,17.7),(120742,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120742,37.37,0.46,298,53558,70,NULL,NULL,'2MASX J14264199+2229466',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.06',0.2,NULL,NULL,NULL,NULL,NULL,1,216.6750417,22.49633,0.052,NULL,59515925222,929936331,14530255,18.06),(120743,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120743,38.18,0.46,433,53559,70,NULL,NULL,'2MASX J14264384+1808036',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.6827917,18.13428,0,NULL,59480571290,929383926,14521623,17),(120744,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120744,36.66,0.46,215,53560,70,NULL,NULL,'2MASX J14264471+0910447',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000203,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,216.6862917,9.17925,0.017,NULL,58268618375,910447162,14225736,15.6),(120745,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120745,35.47,0.46,124,53561,70,NULL,NULL,'VIII Zw 420',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000068,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,216.69175,4.57594,0.029,NULL,58302535688,910977120,14234017,16.2),(120746,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120746,36.93,0.46,243,53562,70,NULL,NULL,'2MASX J14264606+3008571',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00019,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,216.691833,30.14925,0,NULL,60048376516,938255883,14660248,16.2),(120747,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120747,36.35,0.16,186,53563,70,NULL,NULL,'2MASX J14264737+5413454',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.6972917,54.22919,0.005,NULL,59196756118,924949314,14452333,16.9),(120748,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120748,38.18,0.46,433,53564,70,NULL,NULL,'2MASX J14264755+0441592',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000092,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.6980417,4.69969,0.029,NULL,58304832642,911013010,14234578,17.7),(120749,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120749,37.77,0.33,357,53565,70,NULL,NULL,'2MASX J14264807+2356096',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.70025,23.93597,0.031,NULL,59496618572,929634665,14525541,17.1),(120750,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120750,36.86,0.09,235,53566,70,NULL,NULL,'2MASX J14264820+1640459',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.25',0.2,'S0','Group member',NULL,NULL,NULL,1,216.700833,16.67939,0,NULL,59491447720,929553870,14524279,18.25),(120751,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120751,37.92,0.46,384,53567,70,NULL,NULL,'SDSS J142649.02+185405.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.7042917,18.90164,0,NULL,59511093237,929860831,14529075,17.4),(120752,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120752,38.05,0.46,408,53568,70,NULL,NULL,'2MASX J14264919+6210063',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00018,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,216.705167,62.16831,0.013,NULL,57763733505,902558336,14102474,16.6),(120753,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120753,37.74,0.46,353,53569,70,NULL,NULL,'2MASX J14264992+2732376',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,216.708,27.54392,0,NULL,60055871446,938372991,14662077,18.3),(120754,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120754,36.63,0.46,212,53570,70,NULL,NULL,'2MASX J14265017+3335072',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,216.708875,33.58517,0,NULL,60041342880,938145982,14658530,16.5),(120755,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120755,38.41,0.15,480,53571,70,NULL,NULL,'2MASX J14265170+5655248',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.715333,56.92367,0,NULL,57249538790,894524043,13976938,18.6),(120756,'BCG','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120756,37.49,0.35,299,53572,60,NULL,NULL,'ABELL 1913',0.0533,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,216.715833,16.676,0,NULL,59491447605,929553868,14524279,NULL),(120757,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120757,37.77,0.33,357,53573,70,NULL,NULL,'2MASXi J1426530+235611',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.720916667,23.93661,0.031,NULL,59496618951,929634671,14525541,17.9),(120758,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120758,32.13,0.8,26.7,53574,75,NULL,NULL,'ESO 272- G 009',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000022,NULL,'15.00',0.9,'SAB(s)d',NULL,NULL,NULL,NULL,1,216.7309583,-45.87769,0.549,NULL,46803929792,731311403,11426740,15),(120759,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120759,37.71,0.46,348,53575,70,NULL,NULL,'B3 1424+423',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.16',0.21,'BrClG',NULL,NULL,NULL,NULL,1,216.7315,42.09608,0,NULL,59947815802,936684621,14635697,17.16),(120760,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120760,36.64,0.54,213,53576,70,NULL,NULL,'2MASX J14265706-2120143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'16.29',NULL,NULL,NULL,NULL,NULL,NULL,1,216.737917,-21.33758,0.321,NULL,46571212771,727675199,11369924,16.29),(120761,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120761,36.86,0.09,235,53577,70,NULL,NULL,'2MASX J14265794+1636019',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000227,NULL,'18.16',0.2,'S0','Group member',NULL,NULL,NULL,1,216.7414583,16.60056,0,NULL,59491443712,929553808,14524278,18.16),(120762,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120762,36.4,0.33,191,53578,70,NULL,NULL,'2MASX J14265818+2935542',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.7422917,29.59844,0,NULL,60060265414,938441647,14663150,17.5),(120763,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120763,33.35,0.2,46.8,53579,74.4,NULL,NULL,'UGC 09253',NULL,'2013AJ....146...86T',2013,1,2.07,'HOLM 646B is a star.','G',0.00002,NULL,'14.4g',0.43,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,216.7437917,31.51703,0,NULL,60047035663,938234932,14659920,14.4),(120764,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120764,33.44,0.49,48.9,53579,75,NULL,'IR','UGC 09253',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120765,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120765,33.45,0.47,49.1,53579,NULL,NULL,NULL,'UGC 09253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120766,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120766,33.58,0.45,52,53579,NULL,NULL,'Malmquist cor.','UGC 09253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120767,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120767,37.15,0.57,269,53580,70,NULL,NULL,'2MASX J14265933-1550176',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.98',0.4,NULL,NULL,NULL,NULL,NULL,1,216.747208333,-15.83836,0.273,NULL,46553987482,727406054,11365719,15.98),(120768,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120768,33.73,0.8,55.8,53581,75,NULL,'HMCL, I','IC 4427',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000117,NULL,'15.46',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,216.7482083,26.86397,0,NULL,60023898902,937873420,14654272,15.46),(120769,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120769,33.65,0.4,53.8,53581,75,NULL,'HMCL, I, inv','IC 4427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120770,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120770,33.7,0.4,55.1,53581,75,NULL,'HMCL, I, raw','IC 4427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120771,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120771,33.97,0.4,62.1,53581,75,NULL,'HMCL, I, cor','IC 4427',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120772,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120772,37.13,0.33,267,53582,70,NULL,NULL,'2MASX J14265968+1255509',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.7487917,12.93075,0,NULL,59542473330,930351145,14536736,17.3),(120773,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120773,31.16,NULL,17.1,53583,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09249',NULL,'2010Ap&SS.325..163P',2010,1,2.2,NULL,'G',0.000009,NULL,'15.0g',0.36,'Sdm',NULL,NULL,NULL,NULL,1,216.749083,8.68361,0.021,NULL,58282670226,910666722,14229167,15),(120774,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120774,31.19,NULL,17.3,53583,NULL,NULL,'Dipole + Quadrupole','UGC 09249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120775,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120775,31.21,NULL,17.4,53583,NULL,NULL,'Dipole','UGC 09249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120776,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120776,31.42,NULL,19.2,53583,72,NULL,NULL,'UGC 09249',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120777,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120777,31.47,NULL,19.6,53583,NULL,NULL,NULL,'UGC 09249',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120778,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120778,31.97,0.4,24.8,53583,75,NULL,'B','UGC 09249',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120779,'BL Lac Luminosity','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120779,41.37,NULL,1880,53584,70,NULL,NULL,'FBQS J142700.4+234800',NULL,'2013ApJ...768L..31F',2013,1,NULL,NULL,'QSO',NULL,'TENT','14.6V',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,216.751625,23.8,0.031,NULL,59496499630,929632806,14525512,14.6),(120780,'GeV TeV ratio','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120780,39.73,NULL,882,53584,72,NULL,NULL,'FBQS J142700.4+234800',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120781,'GeV TeV ratio','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120781,41.39,0.28,1900,53584,70,NULL,'z =0.61 +/- 0.10','FBQS J142700.4+234800',NULL,'2014A&A...567A.135A',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120782,'GeV TeV ratio','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120782,41.55,0.15,2040,53584,70,NULL,'z(photo) = 0.68 +/- 0.08','FBQS J142700.4+234800',NULL,'2015MNRAS.447.2810Y',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120783,'GeV TeV ratio','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120783,41.99,0.34,2500,53584,70,NULL,'z(photo) = 0.95 +/- 0.35','FBQS J142700.4+234800',NULL,'2015MNRAS.449.1018Y',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120784,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120784,37.4,0.46,302,53585,70,NULL,NULL,'2MASX J14270131+2557052',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00014,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.755458333,25.95144,0,NULL,60021097082,937829641,14653588,17.4),(120785,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120785,38.48,0.33,497,53586,70,NULL,NULL,'SDSS J142702.03+251153.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.7585,25.19811,0,NULL,60020560402,937821256,14653457,18.5),(120786,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120786,37.9,0.46,380,53587,70,NULL,NULL,'2MASX J14270255+4511574',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000213,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,216.760583,45.19947,0,NULL,59230167532,925471367,14460490,16.2),(120787,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120787,37.71,0.46,348,53588,70,NULL,NULL,'SDSS J142702.69+214913.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.7612083,21.82031,0.073,NULL,59515675438,929932428,14530194,18.4),(120788,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120788,37.32,0.27,292,53589,70,NULL,NULL,'2MASX J14270324+3451342',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000159,NULL,'16.5g',0.34,'E/S0',NULL,NULL,NULL,NULL,1,216.7634583,34.85964,0,NULL,60039316457,938114319,14658036,16.5),(120789,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120789,37.24,0.46,280,53590,70,NULL,NULL,'2MASX J14270529+1116182',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.7720417,11.27183,0.022,NULL,58267868874,910435451,14225553,17.8),(120790,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120790,36.86,0.09,235,53591,70,NULL,NULL,'2MASXi J1427079+164830',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.783291667,16.80844,0,NULL,59491271080,929551110,14524236,17.6),(120791,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120791,38.09,0.65,415,53592,70,NULL,NULL,'2MASX J14270852-1942349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,216.785541667,-19.70972,0.313,NULL,46558235861,727472435,11366756,15.5),(120792,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120792,37.12,0.23,265,53593,70,NULL,NULL,'2MASX J14270862+4343064',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.7857917,43.71833,0.011,NULL,59954530639,936789541,14637336,17.6),(120793,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120793,33.73,0.2,55.7,53594,74.4,NULL,NULL,'IC 1012',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000033,NULL,'14.7g',0.64,'S?',NULL,NULL,NULL,NULL,1,216.789583,30.94822,0,NULL,60049050207,938266409,14660412,14.7),(120794,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120794,33.85,0.45,58.8,53594,NULL,NULL,NULL,'IC 1012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120795,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120795,33.88,0.44,59.7,53594,NULL,NULL,'Malmquist cor.','IC 1012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120796,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120796,31.46,NULL,19.6,53595,72,NULL,NULL,'UGC 09252',NULL,'2014Ap.....57..457K',2014,1,1,NULL,'G',0.000017,NULL,'15.67',0.2,'Irr(f)',NULL,NULL,NULL,NULL,1,216.7949583,5.13294,0.041,NULL,58304932832,911014575,14234602,15.67),(120797,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120797,37.13,0.33,267,53596,70,NULL,NULL,'2MASX J14271104+1301246',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000212,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.7959583,13.02347,0,NULL,59543193914,930362404,14536912,16.7),(120798,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120798,37.36,0.46,296,53597,70,NULL,NULL,'2MASX J14271160+1448226',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,216.7982083,14.80619,0,NULL,59477073981,929329280,14520770,18.47),(120799,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120799,34.47,0.69,78.4,53598,NULL,NULL,'Malmquist cor.','NGC 5618',NULL,'2009ApJS..182..474S',2009,1,1.57,NULL,'G',0.000023,NULL,'13.8b',1.03,'SB(rs)c',NULL,NULL,NULL,NULL,1,216.7992083,-2.26242,0.157,NULL,43516337230,679942769,10624105,13.8),(120800,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120800,34.56,0.66,81.8,53598,NULL,NULL,NULL,'NGC 5618',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120801,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120801,34.6,0.2,83.2,53598,74.4,NULL,NULL,'NGC 5618',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120802,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120802,35.07,0.47,103,53598,NULL,NULL,'H','NGC 5618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120803,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120803,35.1,0.4,105,53598,NULL,NULL,'mean','NGC 5618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120804,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120804,35.22,0.46,111,53598,NULL,NULL,'J','NGC 5618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120805,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120805,35.22,0.45,111,53598,NULL,NULL,'K','NGC 5618',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120806,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120806,39.2,0.46,693,53599,70,NULL,NULL,'SDSS J142712.72+181833.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.803,18.30919,0,NULL,59480651097,929385173,14521643,18.4),(120807,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120807,37.8,0.46,364,53600,70,NULL,NULL,'2MASX J14271272+5700599',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000211,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.803083,57.01664,0,NULL,57249575236,894524613,13976947,17.9),(120808,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120808,36.96,0.46,246,53601,70,NULL,NULL,'2MASX J14271283+4052195',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.8034583,40.87203,0,NULL,59948734169,936698971,14635921,16.8),(120809,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120809,37.12,0.23,265,53602,70,NULL,NULL,'2MASX J14271287+4344054',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,216.8035417,43.73467,0.025,NULL,59954531182,936789549,14637336,16.6),(120810,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120810,35.85,0.46,148,53603,70,NULL,NULL,'2MASX J14271381+0250483',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000093,NULL,'15.4g',0.41,'E0',NULL,NULL,NULL,NULL,1,216.807417,2.84683,0.045,NULL,58296882118,910888783,14232637,15.4),(120811,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120811,34.57,0.69,82.1,53604,100,NULL,'mid-IR','CGCG 075-035',NULL,'2013ApJ...771...88L',2013,1,1.09,NULL,'G',0.000098,NULL,'14.6g',0.69,'SBa',NULL,NULL,NULL,NULL,1,216.8107083,11.33908,0.022,NULL,58267874805,910435543,14225555,14.6),(120812,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120812,35.78,0.27,143,53605,70,NULL,NULL,'2MASX J14271494+3726539',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000151,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.812125,37.44822,0,NULL,60064524969,938508202,14664190,16.3),(120813,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120813,37.75,0.33,355,53606,70,NULL,NULL,'2MASX J14271582+6308213',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.8160417,63.13914,0.025,NULL,57761720522,902526883,14101982,17.6),(120814,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120814,37.98,0.46,395,53607,70,NULL,NULL,'SDSS J142716.97+421209.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.82075,42.2025,0,NULL,59947821311,936684707,14635698,18.2),(120815,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120815,36.86,0.09,235,53608,70,NULL,NULL,'IC 4426',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000294,NULL,'15.50',0.5,'E','Group member',NULL,NULL,NULL,1,216.8212083,16.83097,0,NULL,59491273858,929551154,14524236,15.5),(120816,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120816,36.86,0.09,235,53609,70,NULL,NULL,'2MASX J14271731+1633176',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.0002,NULL,'14.2',0.5,'S0','Group member',NULL,NULL,NULL,1,216.82225,16.55492,0,NULL,59491371364,929552677,14524260,14.2),(120817,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120817,35.35,0.8,117,53610,75,NULL,'CF, r','NGC 5619',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00002,NULL,'13.6g',1.2,'SAB(rs)b','Possible field galaxy',NULL,NULL,NULL,1,216.8259583,4.80283,0.029,NULL,58304848263,911013254,14234582,13.6),(120818,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120818,34.75,0.47,89.2,53610,NULL,NULL,'H','NGC 5619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120819,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120819,34.76,0.46,89.7,53610,NULL,NULL,'J','NGC 5619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120820,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120820,34.84,0.45,92.9,53610,NULL,NULL,'K','NGC 5619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120821,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120821,34.91,0.38,96.1,53610,75,NULL,'CF, r, raw','NGC 5619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120822,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120822,35.11,0.3,105,53610,NULL,NULL,'Malmquist cor.','NGC 5619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120823,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120823,35.1,0.3,105,53610,NULL,NULL,NULL,'NGC 5619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120824,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120824,35.14,0.2,107,53610,74.4,NULL,NULL,'NGC 5619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120825,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120825,35.16,0.38,107,53610,75,NULL,'CF, r, cor','NGC 5619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120826,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120826,35.22,0.38,111,53610,75,NULL,'CF, r, inv','NGC 5619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120827,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120827,35.4,0.4,120,53610,NULL,NULL,'mean','NGC 5619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120828,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120828,37.73,0.46,352,53611,70,NULL,NULL,'LCRS B142444.2-022526',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000119,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.832125,-2.6475,0.169,NULL,43516001089,679937517,10624023,18),(120829,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120829,36.35,0.16,186,53612,70,NULL,NULL,'2MASX J14272001+5417199',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000201,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,216.833291667,54.28892,0,NULL,59197234250,924956785,14452449,15.2),(120830,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120830,32.13,0.8,26.6,53613,75,NULL,'MAT, I','ESO 001- G 006',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000017,NULL,'13.89',0.7,'SA:(rs)bc:',NULL,NULL,NULL,NULL,1,216.83525,-87.77225,0.377,NULL,44037540533,688086570,10751352,13.89),(120831,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120831,32.19,0.8,27.5,53613,75,NULL,NULL,'ESO 001- G 006',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120832,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120832,31.96,0.32,24.7,53613,85,NULL,'I, raw','ESO 001- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120833,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120833,31.98,0.32,24.9,53613,85,NULL,'I, inv','ESO 001- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120834,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120834,32.15,0.43,27,53613,75,NULL,'MAT, I, raw','ESO 001- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120835,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120835,32.28,0.43,28.5,53613,75,NULL,'MAT, I, inv','ESO 001- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120836,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120836,32.4,0.43,30.3,53613,75,NULL,'MAT, I, cor','ESO 001- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120837,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120837,32.41,0.43,30.4,53613,75,NULL,'3.6 micron, color corrected','ESO 001- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120838,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120838,32.42,0.43,30.5,53613,75,NULL,'3.6 micron, color + selection bias corrected','ESO 001- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120839,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120839,32.43,0.2,30.6,53613,74.4,NULL,NULL,'ESO 001- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120840,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120840,32.55,0.4,32.3,53613,73,NULL,'opt','ESO 001- G 006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120841,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120841,32.63,0.52,33.6,53613,NULL,NULL,'Malmquist cor.','ESO 001- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120842,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120842,32.64,0.52,33.7,53613,NULL,NULL,NULL,'ESO 001- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120843,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120843,36.86,0.09,235,53614,70,NULL,NULL,'2MASX J14272162+1635366',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,216.8402917,16.59333,0,NULL,59491369939,929552655,14524260,18.22),(120844,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120844,36.42,0.54,192,53615,70,NULL,NULL,'2MASX J14272388-1435248',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000097,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,216.849625,-14.59022,0.265,NULL,46542428861,727225450,11362897,13.7),(120845,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120845,35.78,0.27,143,53616,70,NULL,NULL,'IC 4435',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.0001,NULL,'14.6g',0.62,'E0',NULL,NULL,NULL,NULL,1,216.851166667,37.47144,0,NULL,60064526157,938508221,14664190,14.6),(120846,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120846,36.35,0.16,186,53617,70,NULL,NULL,'2MASX J14272490+5413328',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,216.853875,54.22581,0,NULL,59197286908,924957607,14452462,16.4),(120847,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120847,37.01,0.46,252,53618,70,NULL,NULL,'2MASX J14272548+2406551',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,216.856333,24.11547,0.015,NULL,59496662016,929635344,14525552,17.1),(120848,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120848,34.05,0.8,64.5,53619,75,NULL,'HMCL, I','UGC 09265',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.000033,NULL,'14.9g',0.45,'S?',NULL,NULL,NULL,NULL,1,216.858166667,25.51447,0,NULL,60021531522,937836430,14653694,14.9),(120849,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120849,33.68,0.4,54.4,53619,75,NULL,'HMCL, I, raw','UGC 09265',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120850,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120850,33.77,0.4,56.9,53619,75,NULL,'HMCL, I, inv','UGC 09265',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120851,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120851,33.98,0.4,62.4,53619,75,NULL,'HMCL, I, cor','UGC 09265',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120852,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120852,36.72,0.33,221,53620,70,NULL,NULL,'2MASX J14272685+0618302',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000192,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,216.862,6.30842,0.005,NULL,58273125427,910517584,14226837,15.6),(120853,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120853,32.85,0.8,37.1,53621,75,NULL,'B','NGC 5633',NULL,'1988NBGC.C....0000T',1988,1,1.56,NULL,'G',0.00002,NULL,'12.9g',0.97,'(R)SA(rs)b','Isolated galaxy',NULL,NULL,NULL,1,216.86825,46.14653,0.039,NULL,59228473583,925444899,14460076,12.9),(120854,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120854,31.8,0.69,22.9,53621,100,NULL,'mid-IR','NGC 5633',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120855,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120855,32.72,0.45,35,53621,NULL,NULL,'K','NGC 5633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120856,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120856,32.75,0.47,35.5,53621,NULL,NULL,'H','NGC 5633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120857,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120857,32.77,0.46,35.9,53621,NULL,NULL,'J','NGC 5633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120858,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120858,32.78,0.4,36,53621,NULL,NULL,'mean','NGC 5633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120859,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120859,32.81,0.4,36.5,53621,NULL,NULL,NULL,'NGC 5633',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120860,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120860,33.54,0.56,51,53621,NULL,NULL,'Malmquist cor.','NGC 5633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120861,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120861,33.63,0.53,53.3,53621,NULL,NULL,NULL,'NGC 5633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120862,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120862,33.68,0.2,54.5,53621,74.4,NULL,NULL,'NGC 5633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120863,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120863,34.61,0.69,83.6,53622,100,NULL,'mid-IR','UGC 09259',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000033,NULL,'14.98',0.5,'S?',NULL,NULL,NULL,NULL,1,216.868916667,11.04072,0.026,NULL,58268045390,910438209,14225597,14.98),(120864,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120864,36.68,0.33,217,53623,70,NULL,NULL,'2MASX J14272903+0427333',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.8710417,4.45914,0.029,NULL,58302208390,910972006,14233937,16.9),(120865,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120865,37.59,0.46,329,53624,70,NULL,NULL,'2MASX J14272923+1930123',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.871667,19.50344,0.04,NULL,59511493653,929867088,14529173,17.9),(120866,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120866,38.08,0.33,412,53625,70,NULL,NULL,'2MASX J14273023+5409238',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.5g',0.34,'candidate      BLLAC',NULL,NULL,NULL,'BL Lac ?',1,216.876166667,54.15658,0,NULL,59197290065,924957657,14452463,16.5),(120867,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120867,36.08,0.46,164,53626,70,NULL,NULL,'CGCG 075-038',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000157,NULL,'15.4g',0.52,NULL,NULL,NULL,NULL,NULL,1,216.878083333,13.23633,0,NULL,59542966341,930358849,14536857,15.4),(120868,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120868,35.35,0.4,117,53627,NULL,NULL,'mean','ESO 385- G 025',NULL,'2007A&A...465...71T',2007,1,1.5,'Star superposed?','G',0.00002,NULL,'14.19',1.1,'SAB(r)c:',NULL,NULL,NULL,NULL,1,216.880166667,-33.94422,0.285,NULL,47001272652,734394885,11474920,14.19),(120869,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120869,35.43,0.47,122,53627,NULL,NULL,'H','ESO 385- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120870,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120870,35.54,0.46,128,53627,NULL,NULL,'J','ESO 385- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120871,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120871,34.32,0.49,73.2,53628,75,NULL,'IR','ESO 447- G 005',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.000073,NULL,'16.98',0.11,'Sd',NULL,NULL,NULL,NULL,1,216.883166667,-31.23878,0.313,NULL,47029810390,734840787,11481887,16.98),(120872,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120872,34.98,NULL,98.9,53628,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 447- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120873,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120873,34.99,NULL,99.6,53628,NULL,NULL,'Dipole + Quadrupole','ESO 447- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120874,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120874,35.01,NULL,100,53628,NULL,NULL,'Dipole','ESO 447- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120875,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120875,35.03,NULL,101,53628,NULL,NULL,NULL,'ESO 447- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120876,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120876,36.87,0.46,237,53629,70,NULL,NULL,'2MASX J14273266+1531305',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.10',0.32,NULL,NULL,NULL,NULL,NULL,1,216.886208333,15.52497,0,NULL,59490565010,929540078,14524063,17.1),(120877,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120877,38.48,0.33,497,53630,70,NULL,NULL,'2MASX J14273290+2512302',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.886958333,25.20842,0,NULL,60021420625,937834697,14653667,17.7),(120878,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120878,36.47,0.33,197,53631,70,NULL,NULL,'2MASX J14273316+1506535',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.76',0.22,NULL,NULL,NULL,NULL,NULL,1,216.88825,15.11486,0,NULL,59476707466,929323554,14520680,17.76),(120879,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120879,37.62,0.33,334,53632,70,NULL,NULL,'2MASX J14273393+1416165',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.8912083,14.27108,0,NULL,59479002746,929359417,14521240,17.7),(120880,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120880,37.97,0.33,392,53633,70,NULL,NULL,'2MASX J14273403+0209559',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.0g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,216.891916667,2.16564,0.045,NULL,58297283204,910895050,14232735,17),(120881,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120881,37.49,0.46,315,53634,70,NULL,NULL,'SDSS J142734.32+015001.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,216.893,1.83378,0.081,NULL,58297186101,910893532,14232711,17.6),(120882,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120882,38.41,0.15,480,53635,70,NULL,NULL,'SDSS J142734.58+565935.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.894083333,56.99317,0,NULL,57249622163,894525346,13976958,18.4),(120883,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120883,35.02,0.23,101,53636,70,NULL,NULL,'CGCG 075-037',NULL,'2015arXiv151105856S',2015,1,1.18,NULL,'G',0.000087,NULL,'14.2g',0.59,'SAB0^+^',NULL,NULL,NULL,NULL,1,216.894583,11.33061,0.022,NULL,59358190215,927471722,14491745,14.2),(120884,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120884,37.43,0.23,306,53637,70,NULL,NULL,'2MASX J14273492+2322263',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.85',0.23,NULL,NULL,NULL,NULL,NULL,1,216.8954583,23.37408,0.033,NULL,59516390855,929943607,14530368,17.85),(120885,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120885,37.97,0.46,393,53638,70,NULL,NULL,'2MASX J14273517+5425487',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000197,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.896625,54.43036,0,NULL,59197227403,924956678,14452448,16.8),(120886,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120886,35.11,0.8,105,53639,75,NULL,'HMCL, I','CGCG 047-050',NULL,'1997ApJS..109..333W',1997,1,0.86,NULL,'G',0.000027,NULL,'15.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,216.8987917,8.12475,0.049,NULL,58283455680,910678995,14229359,15.4),(120887,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120887,34.67,0.4,85.9,53639,75,NULL,'HMCL, I, raw','CGCG 047-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120888,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120888,34.78,0.4,90.3,53639,75,NULL,'HMCL, I, inv','CGCG 047-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120889,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120889,35.01,0.4,100,53639,75,NULL,'HMCL, I, cor','CGCG 047-050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120890,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120890,33.05,0.8,40.7,53640,75,NULL,'A82, H','NGC 5630',NULL,'1997ApJS..109..333W',1997,1,2.05,'HOLM 649B is a star.','G',0.000017,NULL,'13.6g',0.65,'Sdm:','Field galaxy',NULL,NULL,NULL,1,216.9025417,41.25775,0,NULL,59948308246,936692316,14635817,13.6),(120891,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120891,32.08,0.47,26,53640,75,NULL,'A82, H, inv','NGC 5630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120892,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120892,32.16,0.47,27,53640,75,NULL,'A82, H, raw','NGC 5630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120893,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120893,32.37,0.43,29.8,53640,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5630',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120894,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120894,32.38,0.43,29.9,53640,75,NULL,'3.6 micron, color corrected','NGC 5630',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120895,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120895,32.41,0.2,30.3,53640,74.4,NULL,NULL,'NGC 5630',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120896,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120896,32.48,0.38,31.3,53640,NULL,NULL,NULL,'NGC 5630',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120897,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120897,32.59,0.47,33,53640,75,NULL,'A82, H, cor','NGC 5630',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120898,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120898,33.08,0.4,41.3,53640,75,NULL,'B','NGC 5630',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120899,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120899,38.12,0.46,420,53641,70,NULL,NULL,'2MASX J14273733+5537427',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,216.905541667,55.62861,0,NULL,57260118766,894689355,13979521,17.7),(120900,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120900,36.86,0.09,235,53642,70,NULL,NULL,'IC 4429',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000157,NULL,'15.19',0.7,'E','Group member',NULL,NULL,NULL,1,216.9057083,16.89986,0,NULL,59491283903,929551310,14524239,15.19),(120901,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120901,36.47,0.33,197,53643,70,NULL,NULL,'SDSS J142737.41+150702.9',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.0g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.905916667,15.11747,0,NULL,59476707951,929323561,14520680,16),(120902,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120902,36.68,0.33,217,53644,70,NULL,NULL,'2MASX J14273825+0427369',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000084,NULL,'16.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,216.909291667,4.46033,0.029,NULL,58302209868,910972029,14233937,16.1),(120903,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120903,37.22,0.46,278,53645,70,NULL,NULL,'2MASX J14273919+3749361',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.91325,37.82678,0,NULL,60064308566,938504821,14664137,16.8),(120904,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120904,34.99,0.2,99.5,53646,74.4,NULL,NULL,'UGC 09264',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000033,NULL,'16.0g',0.26,'Scd:',NULL,NULL,NULL,NULL,1,216.916875,6.04136,0.049,NULL,58303375120,910990236,14234222,16),(120905,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120905,35.2,0.49,109,53646,75,NULL,'IR','UGC 09264',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120906,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120906,36.86,0.09,235,53647,70,NULL,NULL,'2MASX J14274102+1637086',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.94',0.2,'S0','Group member',NULL,NULL,NULL,1,216.921,16.61917,0,NULL,59490189734,929534214,14523972,17.94),(120907,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120907,38.19,0.46,435,53648,70,NULL,NULL,'2MASX J14274171+1144058',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.923667,11.73489,0.036,NULL,59357881750,927466902,14491670,17.5),(120908,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120908,37.62,0.33,334,53649,70,NULL,NULL,'2MASX J14274181+1417166',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.99',0.16,NULL,NULL,NULL,NULL,NULL,1,216.924291667,14.28794,0,NULL,59476953362,929327396,14520740,17.99),(120909,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120909,35.15,0.47,107,53650,NULL,NULL,'H','NGC 5671',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000143,NULL,'14.10',1.2,'SB(r)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,216.925,69.69417,0.041,NULL,57922577860,905040279,14141254,14.1),(120910,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120910,35.21,0.43,110,53650,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5671',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120911,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120911,35.29,0.46,114,53650,NULL,NULL,'J','NGC 5671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120912,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120912,35.29,0.45,114,53650,NULL,NULL,'K','NGC 5671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120913,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120913,35.39,0.4,120,53650,NULL,NULL,'mean','NGC 5671',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120914,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120914,36.68,0.27,216,53651,70,NULL,NULL,'2MASX J14274201-0145202',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.0002,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,216.925,-1.75572,0.105,NULL,43514359330,679911864,10623622,15.9),(120915,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120915,36.86,0.09,235,53652,70,NULL,NULL,'SDSS J142742.91+165455.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.928833333,16.91556,0,NULL,59491280944,929551264,14524238,17.7),(120916,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120916,38.03,0.46,404,53653,70,NULL,NULL,'2MASX J14274302+4242305',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.929167,42.70842,0.013,NULL,59959021124,936859705,14638432,17.6),(120917,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120917,37.58,0.46,328,53654,70,NULL,NULL,'2MASX J14274320-0044002',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,216.93,-0.73339,0.101,NULL,43513703796,679901621,10623462,18.2),(120918,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120918,37.97,0.33,392,53655,70,NULL,NULL,'2MASX J14274451+0205509',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.935333333,2.09758,0.045,NULL,58297259576,910894680,14232729,17.3),(120919,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120919,37.47,0.33,312,53656,70,NULL,NULL,'2MASX J14274480+0344519',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000079,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,216.936833,3.74781,0.025,NULL,58302051765,910969558,14233899,16.9),(120920,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120920,37.75,0.33,355,53657,70,NULL,NULL,'2MASX J14274597+6306410',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.941416667,63.11147,0.025,NULL,57761671650,902526119,14101970,17.4),(120921,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120921,38.41,0.15,480,53658,70,NULL,NULL,'SDSS J142746.10+563836.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.942125,56.64339,0,NULL,57257218639,894644041,13978813,18.5),(120922,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120922,38.2,0.46,437,53659,70,NULL,NULL,'2MASX J14274657+2644102',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000193,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,216.944083333,26.73625,0,NULL,60023958510,937874351,14654286,17),(120923,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120923,37.32,0.46,290,53660,70,NULL,NULL,'2MASX J14274780+1833243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.94925,18.55686,0,NULL,59480619354,929384677,14521635,17.8),(120924,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120924,37.41,0.46,304,53661,70,NULL,NULL,'2MASX J14274828+4303255',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.951167,43.05694,0.012,NULL,59958717916,936854967,14638358,17.4),(120925,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120925,35.88,0.33,150,53662,70,NULL,NULL,'2MASX J14274888+2629002',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000133,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,216.9537083,26.48353,0,NULL,60021050520,937828914,14653576,16.1),(120926,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120926,37.48,0.46,314,53663,70,NULL,NULL,'2MASX J14274934+0340259',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00007,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,216.955667,3.67389,0.025,NULL,58302077208,910969956,14233905,16.8),(120927,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120927,36.56,0.46,205,53664,70,NULL,NULL,'2MASX J14274959+2324463',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000175,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,216.956833,23.41294,0.033,NULL,59497775108,929652736,14525824,16),(120928,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120928,38.08,0.33,412,53665,70,NULL,NULL,'2MASX J14274988+5405548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.957833,54.09869,0,NULL,59197279821,924957497,14452460,17.9),(120929,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120929,38.41,0.15,480,53666,70,NULL,NULL,'2MASX J14275132+5653568',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,216.963583,56.89925,0,NULL,57249588480,894524820,13976950,17.4),(120930,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120930,37.74,0.46,354,53667,70,NULL,NULL,'SDSS J142752.52+462605.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000162,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,216.968875,46.43472,0,NULL,59228582150,925446596,14460103,18.2),(120931,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120931,36.67,0.46,216,53668,70,NULL,NULL,'2MASX J14275258+2811112',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.13',0.29,NULL,NULL,NULL,NULL,NULL,1,216.9690417,28.18639,0,NULL,60055272322,938363630,14661931,17.13),(120932,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120932,38.32,0.46,461,53669,70,NULL,NULL,'2MASX J14275348+4640496',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.9730417,46.68028,0,NULL,59228772686,925449573,14460149,17.9),(120933,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120933,37.04,0.46,255,53670,70,NULL,NULL,'2MASX J14275375+0034109',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000078,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,216.974,0.56961,0.093,NULL,58291214049,910800219,14231253,16.8),(120934,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120934,36.09,0.46,165,53671,70,NULL,NULL,'2MASX J14275389+0658209',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,216.974625,6.9725,0.025,NULL,58272950882,910514857,14226794,16.4),(120935,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120935,36.71,0.46,220,53672,70,NULL,NULL,'2MASX J14275397+1316416',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,216.97475,13.27825,0,NULL,59542975147,930358986,14536859,16.4),(120936,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120936,35.75,0.46,141,53673,70,NULL,NULL,'SDSS J142754.73+161226.0',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',NULL,NULL,'15.1g',0.54,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,216.978083,16.20725,0,NULL,59490736638,929542759,14524105,15.1),(120937,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120937,37.55,0.33,324,53674,70,NULL,NULL,'2MASX J14275542+4100488',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,216.981,41.01356,0,NULL,59948992293,936703004,14635984,17.7),(120938,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120938,36.23,0.27,176,53675,70,NULL,NULL,'2MASX J14275560+2424052',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000189,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,216.981833,24.40144,0.022,NULL,59497209458,929643897,14525685,15.5),(120939,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120939,38.4,0.46,478,53676,70,NULL,NULL,'LCRS B142520.5-024552',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,216.984375,-2.98767,0.177,NULL,43515942517,679936601,10624009,18.2),(120940,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120940,36.59,0.46,208,53677,70,NULL,NULL,'2MASX J14275761+5220538',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000182,NULL,'15.9g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,216.9897917,52.34833,0,NULL,59203189982,925049843,14453903,15.9),(120941,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120941,37.84,0.46,370,53678,70,NULL,NULL,'2MASX J14275804+1853532',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,216.991875,18.89814,0.008,NULL,59511837810,929872465,14529257,18),(120942,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120942,36.72,0.33,221,53679,70,NULL,NULL,'2MASX J14275805+0617499',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,216.991916667,6.29731,0.005,NULL,58273374964,910521483,14226898,17.5),(120943,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120943,36.11,0.6,167,53680,70,NULL,NULL,'2MASX J14275808-0703054',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.15',0.46,NULL,NULL,NULL,NULL,NULL,1,216.992125,-7.05175,0.149,NULL,43531226721,680175417,10627740,16.15),(120944,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120944,35.88,0.33,150,53681,70,NULL,NULL,'IC 4436',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000087,NULL,'14.5g',0.8,'E?',NULL,NULL,NULL,NULL,1,216.992417,26.5045,0,NULL,60023917021,937873703,14654276,14.5),(120945,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120945,37.25,0.27,282,53682,70,NULL,NULL,'SDSS J142758.90+123509.9',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000197,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,216.995417,12.58608,0,NULL,59542422003,930350343,14536724,16.6),(120946,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120946,37.71,0.46,348,53683,70,NULL,NULL,'2MASX J14275993+3441290',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,216.999583,34.69153,0,NULL,60039158393,938111849,14657997,18),(120947,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120947,36.87,0.46,236,53684,70,NULL,NULL,'2MASX J14280059+3724038',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000184,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,217.002417,37.40092,0,NULL,60064449294,938507020,14664172,15.8),(120948,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120948,38.41,0.15,480,53685,70,NULL,NULL,'2MASX J14280084+5700458',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000185,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.003416667,57.01286,0,NULL,57249618463,894525288,13976957,17.7),(120949,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120949,35.25,0.2,112,53686,74.4,NULL,NULL,'CGCG 075-041',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00005,NULL,'15.2g',0.43,NULL,NULL,NULL,NULL,NULL,1,217.004667,11.69083,0.036,NULL,59358747648,927480432,14491881,15.2),(120950,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120950,35.78,0.27,143,53687,70,NULL,NULL,'2MASX J14280173+3730558',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,217.0072917,37.51556,0,NULL,60064422823,938506606,14664165,15.8),(120951,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120951,36.23,0.27,176,53688,70,NULL,NULL,'2MASX J14280181+2423426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.0077083,24.39531,0.022,NULL,59497209154,929643893,14525685,17),(120952,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120952,37.06,0.33,258,53689,70,NULL,NULL,'LCRS B142527.3-021600',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.011167,-2.48975,0.157,NULL,43516026397,679937912,10624029,17.5),(120953,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120953,31.01,0.49,15.9,53690,75,NULL,'IR','UGC 09274',NULL,'2011yCatp016004901K',2011,1,1.3,'Noted as a possible \\\"nest\\\" in MCG.','G',0.000033,NULL,'14.35',0.8,'SB?',NULL,NULL,NULL,NULL,1,217.0114583,21.30381,0.068,NULL,59524513310,930070520,14532351,14.35),(120954,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120954,37.42,0.33,304,53691,70,NULL,NULL,'2MASX J14280354+2036463',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.0147917,20.61303,0.047,NULL,59524206749,930065730,14532277,16.3),(120955,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120955,27.74,0.23,3.53,53692,NULL,NULL,'I','UKS 1424-460',NULL,'2009AJ....138..332J',2009,1,2.4,NULL,'G',0.000007,NULL,'16.50',0.9,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.015417,-46.30167,0.549,NULL,46800404475,731256319,11425879,16.5),(120956,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120956,27.78,NULL,3.6,53692,NULL,NULL,NULL,'UKS 1424-460',NULL,'2002A&A...385...21K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120957,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120957,27.79,0.1,3.61,53692,74.4,NULL,NULL,'UKS 1424-460',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120958,'TRGB','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120958,27.79,0.11,3.62,53692,NULL,NULL,NULL,'UKS 1424-460',NULL,'2015ApJ...802L..25T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120959,'Tully est','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120959,27.48,0.8,3.1,53692,75,NULL,NULL,'UKS 1424-460',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120960,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120960,37.85,0.46,372,53693,70,NULL,NULL,'2MASX J14280424+1812054',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.61',0.15,NULL,NULL,NULL,NULL,NULL,1,217.017667,18.20161,0,NULL,59481466596,929397915,14521842,18.61),(120961,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120961,33.99,0.43,62.9,53694,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09279',NULL,'2014MNRAS.444..527S',2014,1,0.93,NULL,'G',0.000033,NULL,'16.2g',0.3,'Scd:',NULL,NULL,NULL,NULL,1,217.024708333,33.81828,0,NULL,60041409197,938147018,14658547,16.2),(120962,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120962,37,0.46,251,53695,70,NULL,NULL,'2MASX J14280681+0321318',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000066,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.028416667,3.35878,0.049,NULL,58301920043,910967500,14233867,17.4),(120963,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120963,37.25,0.27,282,53696,70,NULL,NULL,'SDSS J142806.93+123737.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.028916667,12.62706,0,NULL,59543290065,930363907,14536936,17.4),(120964,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120964,36.58,0.46,207,53697,70,NULL,NULL,'SDSS J142806.97+254332.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.0290417,25.72556,0,NULL,60021318170,937833096,14653642,17.2),(120965,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120965,36.86,0.09,235,53698,70,NULL,NULL,'2MASX J14280741+1654115',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.031,16.90325,0,NULL,59491231177,929550487,14524226,17.7),(120966,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120966,38.21,0.46,439,53699,70,NULL,NULL,'2MASX J14280800+1513401',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.03325,15.22769,0,NULL,59476725893,929323842,14520685,17.7),(120967,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120967,37.29,0.46,287,53700,70,NULL,NULL,'2MASX J14280801+0648349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.033583,6.80981,0.013,NULL,58273460667,910522822,14226919,17.3),(120968,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120968,37.53,0.46,321,53701,70,NULL,NULL,'VII Zw 550',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.040417,58.19114,0.009,NULL,57248403291,894506301,13976660,17),(120969,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120969,36.87,0.46,236,53702,70,NULL,NULL,'2MASX J14280988+5657078',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.041083333,56.95222,0,NULL,57249614674,894525229,13976956,16.7),(120970,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120970,33.88,0.8,59.7,53703,75,NULL,'HMCL, I','KUG 1425+271',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000027,NULL,'15.38',0.4,'S?',NULL,NULL,NULL,NULL,1,217.042083,26.93583,0,NULL,60022874776,937857418,14654022,15.38),(120971,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120971,34.47,0.4,78.3,53703,75,NULL,'HMCL, I, raw','KUG 1425+271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120972,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120972,34.53,0.4,80.5,53703,75,NULL,'HMCL, I, inv','KUG 1425+271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120973,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120973,34.75,0.4,89.1,53703,75,NULL,'HMCL, I, cor','KUG 1425+271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120974,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120974,36.7,0.33,218,53704,70,NULL,NULL,'2MASX J14281005+5953268',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.042208333,59.89089,0,NULL,57752419920,902381561,14099711,17.4),(120975,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120975,37.34,0.46,293,53705,70,NULL,NULL,'LCRS B142534.5-024337',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00013,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.0427083,-2.95014,0.173,NULL,43515966047,679936969,10624015,17.2),(120976,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120976,37.25,0.27,282,53706,70,NULL,NULL,'SDSS J142810.35+123711.7',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'15.8g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.043125,12.61994,0,NULL,59543290719,930363917,14536936,15.8),(120977,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120977,30.25,0.2,11.2,53707,74.4,NULL,NULL,'UGC 09273',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000017,NULL,'15.4g',0.47,'Irr;WR?        HII',NULL,NULL,NULL,NULL,1,217.04525,13.55158,0,NULL,59475531797,929305184,14520393,15.4),(120978,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120978,37.47,0.33,312,53708,70,NULL,NULL,'SDSS J142810.89+034606.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000064,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.045417,3.76858,0.025,NULL,58301957475,910968085,14233876,18.3),(120979,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120979,37.55,0.33,323,53709,70,NULL,NULL,'2MASX J14281149+0244488',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,217.0479583,2.747,0.049,NULL,58296666182,910885409,14232584,16.6),(120980,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120980,38.31,0.46,459,53710,70,NULL,NULL,'2MASX J14281151+0957069',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.048125,9.95192,0.049,NULL,58271343985,910489749,14226402,17.7),(120981,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120981,36.72,0.46,220,53711,70,NULL,NULL,'2MASX J14281154+1500532',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.16,'AGN',NULL,NULL,NULL,NULL,1,217.048125,15.01467,0,NULL,59477280939,929332514,14520820,18.26),(120982,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120982,38.06,0.33,409,53712,70,NULL,NULL,'SDSS J142812.35+201138.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.0515,20.19394,0.042,NULL,59511406842,929865731,14529152,NULL),(120983,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120983,37.06,0.33,258,53713,70,NULL,NULL,'LCRS B142537.1-021749',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.0522083,-2.52,0.165,NULL,43516007194,679937612,10624025,16.6),(120984,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120984,37.08,0.46,260,53714,70,NULL,NULL,'2MASX J14281367+1008479',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.056875,10.14658,0.049,NULL,58270866794,910482293,14226285,17),(120985,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120985,34.92,0.8,96.4,53715,75,NULL,'MAT, I','ESO 511- G 042',NULL,'1997ApJS..109..333W',1997,1,3.14,NULL,'G',0.00003,NULL,'16.12',0.34,'Sbc',NULL,NULL,NULL,NULL,1,217.058625,-23.87303,0.281,NULL,46532360465,727068132,11360439,16.12),(120986,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120986,34.46,NULL,77.9,53715,NULL,NULL,'Dipole','ESO 511- G 042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120987,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120987,34.46,NULL,78,53715,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 511- G 042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120988,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120988,34.47,NULL,78.4,53715,NULL,NULL,'Dipole + Quadrupole','ESO 511- G 042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120989,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120989,34.58,NULL,82.5,53715,NULL,NULL,NULL,'ESO 511- G 042',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120990,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120990,35.27,0.49,113,53715,75,NULL,'IR','ESO 511- G 042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120991,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120991,35.31,0.43,115,53715,75,NULL,'MAT, I, raw','ESO 511- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120992,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120992,35.47,0.32,124,53715,85,NULL,'I, raw','ESO 511- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120993,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120993,35.53,0.32,128,53715,85,NULL,'I, inv','ESO 511- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120994,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120994,35.58,0.43,130,53715,75,NULL,'MAT, I, inv','ESO 511- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120995,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120995,35.64,0.43,134,53715,75,NULL,'MAT, I, cor','ESO 511- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(120996,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120996,37.55,0.33,324,53716,70,NULL,NULL,'2MASX J14281426+4052199',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.059333,40.87217,0,NULL,59946698429,936667162,14635424,16.9),(120997,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',120997,36.68,0.27,216,53717,70,NULL,NULL,'CGCG 019-037',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'16.0g',0.28,'S0',NULL,NULL,NULL,NULL,1,217.064917,-1.9825,0.137,NULL,43514439802,679913121,10623642,16),(120998,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120998,35.32,0.4,116,53718,NULL,NULL,'mean','ESO 385- G 026',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.67',0.6,'SB(r)bc',NULL,NULL,NULL,NULL,1,217.065708333,-33.3085,0.257,NULL,47000936375,734389630,11474837,14.67),(120999,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,120999,35.51,0.54,127,53718,NULL,NULL,'Malmquist cor.','ESO 385- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121000,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121000,35.53,0.47,128,53718,NULL,NULL,'H','ESO 385- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121001,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121001,35.64,0.46,134,53718,NULL,NULL,'J','ESO 385- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121002,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121002,35.66,0.5,136,53718,NULL,NULL,NULL,'ESO 385- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121003,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121003,35.7,0.2,138,53718,74.4,NULL,NULL,'ESO 385- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121004,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121004,34,0.4,63.1,53719,75,NULL,'Edat, raw','NGC 5629',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00008,NULL,'13.03',1.8,'S0             RET','in a pair',NULL,NULL,NULL,1,217.0682083,25.84878,0,NULL,60021335427,937833366,14653646,13.03),(121005,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121005,34.34,0.4,73.7,53719,75,NULL,'Edat, cor','NGC 5629',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121006,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121006,34.18,0.4,68.6,53719,NULL,NULL,'mean','NGC 5629',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121007,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121007,34.73,0.45,88.2,53719,NULL,NULL,'K','NGC 5629',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121008,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121008,36.23,0.27,176,53720,70,NULL,NULL,'2MASX J14281791+2424107',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000185,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,217.074833333,24.40303,0,NULL,59497029773,929641090,14525642,15.8),(121009,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121009,38.74,0.46,560,53721,70,NULL,NULL,'2MASX J14281802+5334079',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.074917,53.56883,0,NULL,59196918265,924951847,14452372,17.4),(121010,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121010,31.92,0.4,24.2,53722,75,NULL,'B','IC 1014',NULL,'1988NBGC.C....0000T',1988,1,1.59,NULL,'G',0.000019,NULL,'13.8g',1.07,'Sdm','in a pair',NULL,NULL,NULL,1,217.0767917,13.78022,0,NULL,59475505697,929304776,14520387,13.8),(121011,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121011,37.65,0.46,339,53723,70,NULL,NULL,'2MASX J14281920+2918437',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000196,NULL,'16.5g',0.27,'Sa',NULL,NULL,NULL,NULL,1,217.080125,29.31225,0,NULL,60059396390,938428068,14662938,16.5),(121012,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121012,38.53,0.46,507,53724,70,NULL,NULL,'SDSS J142819.60+490043.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.0817083,49.01217,0.025,NULL,59244809964,925700155,14464064,18.3),(121013,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121013,36.68,0.27,216,53725,70,NULL,NULL,'2MASX J14281988-0148460',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.082917,-1.81272,0.133,NULL,43514570881,679915170,10623674,16.9),(121014,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121014,37.48,0.21,313,53726,70,NULL,NULL,'2MASX J14281992+4559098',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.2g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,217.082917,45.986,0.014,NULL,59228511444,925445491,14460085,16.2),(121015,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121015,37.92,0.46,383,53727,70,NULL,NULL,'2MASX J14282020+4646568',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.084,46.78253,0,NULL,59228778426,925449662,14460150,18.1),(121016,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,NULL,121016,34.04,0.2,64.3,53728,74.4,NULL,NULL,'CGCG 075-043',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00006,NULL,'15.4',0.5,'S','Group member',NULL,NULL,NULL,1,217.08625,11.35944,0.017,NULL,59358238858,927472482,14491757,15.4),(121017,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121017,36.86,0.46,235,53729,70,NULL,NULL,'2MASXi J1428208+142746',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,217.086833,14.46289,0,NULL,59476976557,929327758,14520746,17.5),(121018,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121018,36.18,0.33,172,53730,70,NULL,NULL,'2MASX J14282141+3629529',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.089375,36.49814,0,NULL,60077150671,938705479,14667273,17.2),(121019,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121019,36.51,0.46,200,53731,70,NULL,NULL,'2MASX J14282210+1247022',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.092167,12.78392,0,NULL,59543215504,930362742,14536917,17.2),(121020,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121020,37.48,0.21,313,53732,70,NULL,NULL,'2MASX J14282213+4557098',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.092541667,45.95283,0.014,NULL,59228510573,925445477,14460085,17.2),(121021,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121021,38.41,0.15,480,53733,70,NULL,NULL,'2MASX J14282237+5646437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.0932917,56.77883,0,NULL,57256984965,894640390,13978756,18),(121022,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121022,37.28,0.46,286,53734,70,NULL,NULL,'2MASX J14282249+4412318',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000126,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.093667,44.20881,0,NULL,59955416027,936803375,14637552,17.5),(121023,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121023,36.52,0.21,201,53735,70,NULL,NULL,'2MASX J14282314+1729332',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.14,NULL,NULL,NULL,NULL,NULL,1,217.0965,17.49258,0,NULL,59480984354,929390380,14521724,18.42),(121024,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121024,37.55,0.33,323,53736,70,NULL,NULL,'2MASX J14282470+0250018',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000086,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.103,2.83386,0.065,NULL,58296672023,910885500,14232585,17),(121025,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121025,34.87,0.46,94.3,53737,70,NULL,NULL,'NGC 5628',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00007,NULL,'14.33',0.7,'E',NULL,NULL,NULL,NULL,1,217.107458333,17.92436,0,NULL,59481486611,929398228,14521847,14.33),(121026,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121026,37.48,0.21,313,53738,70,NULL,NULL,'2MASX J14282587+4558098',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000206,NULL,'16.2g',0.37,'AGN',NULL,NULL,NULL,NULL,1,217.107875,45.96944,0.014,NULL,59228512211,925445503,14460085,16.2),(121027,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121027,36.52,0.21,201,53739,70,NULL,NULL,'SDSS J142826.09+173552.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.10875,17.59792,0,NULL,59480991932,929390498,14521726,17.4),(121028,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121028,37.24,0.46,280,53740,70,NULL,NULL,'2MASX J14282652+4538348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.11075,45.64294,0,NULL,59228301281,925442207,14460034,18.1),(121029,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121029,36.7,0.33,218,53741,70,NULL,NULL,'2MASX J14282689+5956413',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,217.1122917,59.94472,0,NULL,57752377160,902380893,14099701,16.6),(121030,'FP','2016-12-15 15:15:25','2016-12-16 11:20:38','1',NULL,'R',121030,36.52,0.21,201,53742,70,NULL,NULL,'2MASX J14282726+1735012',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00009,NULL,'11.6K',NULL,NULL,NULL,NULL,NULL,NULL,1,217.113625,17.58364,0,NULL,59480994212,929390534,14521727,11.6),(121031,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121031,38.41,0.15,480,53743,70,NULL,NULL,'2MASX J14282822+5659180',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.1174583,56.98831,0,NULL,57249613481,894525210,13976956,17.9),(121032,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121032,36.46,0.56,195,53744,70,NULL,NULL,'2MASX J14282931-0319260',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'The APM image includes a superposed star (or compact companion galaxy?).','G',0.000117,NULL,'15.22',0.49,NULL,NULL,NULL,NULL,NULL,1,217.122083,-3.32386,0.217,NULL,43539036957,680297452,10629647,15.22),(121033,'IRAS','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121033,33.68,0.8,54.3,53745,75,NULL,'HMCL, I','KUG 1426+274A',NULL,'1997ApJS..109..333W',1997,1,0.68,NULL,'G',0.000027,NULL,'15.1g',0.32,'S?','Group member of poor cluster',NULL,NULL,NULL,1,217.1285,27.26592,0,NULL,60023075532,937860555,14654071,15.1),(121034,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121034,34.96,0.4,98,53745,75,NULL,'HMCL, I, raw','KUG 1426+274A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121035,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121035,35.07,0.4,103,53745,75,NULL,'HMCL, I, inv','KUG 1426+274A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121036,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121036,35.39,0.4,120,53745,75,NULL,'HMCL, I, cor','KUG 1426+274A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121037,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121037,33.24,0.47,44.5,53746,NULL,NULL,'H','ESO 385- G 028',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000017,NULL,'14.5',1.5,'S(r)a',NULL,NULL,NULL,NULL,1,217.1295,-34.71064,0.261,NULL,47000115381,734376802,11474637,14.5),(121038,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121038,33.4,0.46,47.9,53746,NULL,NULL,'J','ESO 385- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121039,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121039,33.41,0.45,48.1,53746,NULL,NULL,'K','ESO 385- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121040,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121040,33.77,0.4,56.7,53746,NULL,NULL,'mean','ESO 385- G 028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121041,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121041,33.08,0.4,41.2,53747,75,NULL,'Edat, raw','IC 4421',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000047,NULL,'13.36',1,'E?',NULL,NULL,NULL,NULL,1,217.1304583,-37.58375,0.325,NULL,47214069531,737719836,11526872,13.36),(121042,'D-Sigma','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121042,33.41,0.4,48.1,53747,75,NULL,'Edat, cor','IC 4421',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121043,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121043,33.56,0.4,51.5,53747,NULL,NULL,'mean','IC 4421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121044,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121044,33.83,0.45,58.4,53747,NULL,NULL,'K','IC 4421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121045,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121045,34.13,0.4,67.1,53748,NULL,NULL,'mean','NGC 5635',NULL,'2007A&A...465...71T',2007,1,2.23,NULL,'G',0.00002,NULL,'13.1g',0.84,'S pec;LINER    Sy3','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,217.132333333,27.40894,0,NULL,60023003896,937859435,14654053,13.1),(121046,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121046,34.47,0.46,78.3,53748,NULL,NULL,'J','NGC 5635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121047,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121047,34.48,0.47,78.9,53748,NULL,NULL,'H','NGC 5635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121048,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121048,34.57,0.45,81.9,53748,NULL,NULL,'K','NGC 5635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121049,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121049,34.73,0.44,88.5,53749,NULL,NULL,'Malmquist cor.','ESO 447- G 006',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.25',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,217.135541667,-31.66347,0.281,NULL,47030114031,734845531,11481961,15.25),(121050,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121050,34.79,0.43,91,53749,NULL,NULL,NULL,'ESO 447- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121051,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121051,34.83,0.2,92.5,53749,74.4,NULL,NULL,'ESO 447- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121052,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121052,37.68,0.46,343,53750,70,NULL,NULL,'2MASX J14283247+5446000',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000198,NULL,'16.2g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,217.135417,54.76681,0,NULL,57254170127,894596408,13978068,16.2),(121053,'BL Lac Luminosity','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121053,38.88,NULL,529,53751,NULL,NULL,NULL,'2MASX J14283260+4240210',0.129139,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000165,NULL,'16.8g',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,217.136083,42.67239,0.011,NULL,59959071776,936860496,14638445,16.8),(121054,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121054,34.14,0.39,67.4,53752,NULL,NULL,'Malmquist cor.','UGC 09277',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000033,NULL,'14.5g',0.34,'Sb(f)','Group member',NULL,NULL,NULL,1,217.138791667,3.262,0.049,NULL,58301934421,910967725,14233870,14.5),(121055,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121055,34.22,0.38,69.9,53752,NULL,NULL,NULL,'UGC 09277',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121056,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121056,34.26,0.2,71.1,53752,74.4,NULL,NULL,'UGC 09277',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121057,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121057,34.87,0.47,94.2,53752,NULL,NULL,'H','UGC 09277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121058,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121058,35.07,0.45,103,53752,NULL,NULL,'K','UGC 09277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121059,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121059,35.09,0.46,104,53752,NULL,NULL,'J','UGC 09277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121060,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121060,35.36,0.4,118,53752,NULL,NULL,'mean','UGC 09277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121061,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121061,36.67,0.46,216,53753,70,NULL,NULL,'2MASX J14283377+2559386',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.10',0.21,NULL,NULL,NULL,NULL,NULL,1,217.140708333,25.99397,0,NULL,60021154113,937830533,14653602,18.1),(121062,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121062,36.16,0.68,170,53754,70,NULL,NULL,'2MASX J14283425-2946213',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,217.1427083,-29.77264,0.349,NULL,47028516495,734820570,11481571,14.5),(121063,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121063,38.33,0.46,464,53755,70,NULL,NULL,'2MASXi J1428356+450234',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000192,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.148708333,45.04294,0,NULL,59954977168,936796518,14637445,17.4),(121064,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121064,37.48,0.21,313,53756,70,NULL,NULL,'2MASX J14283581+4600421',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000155,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.149375,46.01164,0.014,NULL,59228539156,925445924,14460092,17.1),(121065,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121065,32.21,0.69,27.6,53757,100,NULL,'mid-IR','UGC 09291',NULL,'2013ApJ...771...88L',2013,1,2.03,NULL,'G',0.000037,NULL,'13.7g',0.9,'Sd','Field galaxy',NULL,NULL,NULL,1,217.1537083,38.99914,0,NULL,60066510513,938539226,14664675,13.7),(121066,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121066,32.71,0.2,34.8,53757,74.4,NULL,NULL,'UGC 09291',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121067,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121067,32.84,0.43,37,53757,75,NULL,'3.6 micron, color corrected','UGC 09291',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121068,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121068,32.87,0.46,37.5,53757,NULL,NULL,NULL,'UGC 09291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121069,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121069,32.95,0.45,38.9,53757,NULL,NULL,'Malmquist cor.','UGC 09291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121070,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121070,33.04,0.43,40.5,53757,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09291',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121071,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121071,33.19,0.4,43.5,53757,NULL,NULL,'mean','UGC 09291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121072,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,NULL,121072,33.75,0.47,56.2,53757,NULL,NULL,'H','UGC 09291',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121073,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121073,38.32,0.33,462,53758,70,NULL,NULL,'2MASX J14283711+2557126',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.64',0.16,NULL,NULL,NULL,NULL,NULL,1,217.1547083,25.95353,0,NULL,60021281424,937832522,14653633,18.64),(121074,'Tully-Fisher','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121074,32.08,NULL,26.1,53759,72,NULL,NULL,'CGCG 019-041',NULL,'2014Ap.....57..457K',2014,1,0.86,NULL,'G',0.000063,NULL,'14.96',0.32,NULL,NULL,NULL,NULL,NULL,1,217.157667,0.55314,0.105,NULL,58291375688,910802745,14231292,14.96),(121075,'FP','2016-12-15 15:15:25','2016-12-16 11:20:39','1',NULL,'R',121075,35.21,0.46,110,53760,70,NULL,NULL,'CGCG 075-049',NULL,'2015arXiv151105856S',2015,1,0.45,'CGCG position is incorrect (B. Skiff).','G',0.00009,NULL,'15.5',0.29,NULL,NULL,NULL,NULL,NULL,1,217.157667,13.46606,0,NULL,59542887194,930357612,14536837,15.5),(121076,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121076,38.11,0.46,419,53761,70,NULL,NULL,'SDSS J142838.37+164909.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.159917,16.81928,0,NULL,59490227262,929534800,14523981,17.8),(121077,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121077,36.71,0.46,220,53762,70,NULL,NULL,'2MASX J14283845-0049501',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.160333333,-0.83067,0.101,NULL,43513115086,679892423,10623319,16.7),(121078,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121078,38.28,0.46,453,53763,70,NULL,NULL,'SDSS J142838.49+144147.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.160417,14.69661,0,NULL,59477083900,929329435,14520772,18),(121079,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121079,36.52,0.21,201,53764,70,NULL,NULL,'SDSS J142838.60+173425.3',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.3g',0.45,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.160875,17.57372,0,NULL,59480986892,929390420,14521725,15.3),(121080,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121080,38.32,0.33,462,53765,70,NULL,NULL,'SDSS J142838.91+255734.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000184,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.162166667,25.95972,0,NULL,60021284153,937832564,14653633,18.7),(121081,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121081,38.02,0.46,402,53766,70,NULL,NULL,'2MASX J14284015+0136323',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.1672917,1.60908,0.081,NULL,58289784919,910777889,14230904,17.7),(121082,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121082,37.95,0.46,389,53767,70,NULL,NULL,'2MASX J14284041+3116187',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.1685,31.27186,0,NULL,60049684897,938276326,14660567,17.5),(121083,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121083,37.81,0.46,365,53768,70,NULL,NULL,'2MASX J14284045+5203242',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.16875,52.05675,0.009,NULL,59203347184,925052299,14453942,17.1),(121084,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121084,37.64,0.46,338,53769,70,NULL,NULL,'2MASX J14284267+3031317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'18.12',0.17,NULL,NULL,NULL,NULL,NULL,1,217.177875,30.52547,0,NULL,60048471907,938257373,14660271,18.12),(121085,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121085,36.78,0.46,227,53770,70,NULL,NULL,'2MASX J14284385+2902027',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000173,NULL,'16.4g',0.31,'E',NULL,NULL,NULL,NULL,1,217.182625,29.03408,0,NULL,60059534330,938430223,14662972,16.4),(121086,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121086,36.52,0.21,201,53771,70,NULL,NULL,'2MASX J14284401+1720074',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.28,'S0','Group member',NULL,NULL,NULL,1,217.1835,17.33536,0,NULL,59480787031,929387297,14521676,16.6),(121087,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121087,38.13,0.46,423,53772,70,NULL,NULL,'SDSS J142844.30+004410.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000071,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.184583,0.73617,0.113,NULL,58291152333,910799255,14231238,18.8),(121088,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121088,37.34,0.46,293,53773,70,NULL,NULL,'2MASX J14284513+5031472',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.188167,50.52989,0,NULL,59201401773,925021902,14453467,17.7),(121089,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121089,33.81,0.8,57.7,53774,75,NULL,'HMCL, I','IC 4442',NULL,'1997ApJS..109..333W',1997,1,1.02,'HOLM 652B is a star.','G',0.000033,NULL,'14.6g',0.61,'SBa',NULL,NULL,NULL,NULL,1,217.188625,28.96425,0,NULL,60059505210,938429768,14662965,14.6),(121090,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121090,32.96,0.69,39,53774,100,NULL,'mid-IR','IC 4442',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121091,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121091,34.09,0.4,65.7,53774,NULL,NULL,'mean','IC 4442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121092,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121092,34.1,0.4,66.1,53774,75,NULL,'HMCL, I, raw','IC 4442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121093,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121093,34.24,0.4,70.5,53774,75,NULL,'HMCL, I, inv','IC 4442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121094,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121094,34.27,0.4,71.6,53774,75,NULL,'HMCL, I, cor','IC 4442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121095,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121095,34.4,0.47,75.8,53774,NULL,NULL,'H','IC 4442',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121096,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121096,38.1,0.46,416,53775,70,NULL,NULL,'SDSS J142846.06+192328.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.1919583,19.39111,0.039,NULL,59511687745,929870121,14529220,18.1),(121097,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121097,37.06,0.23,258,53776,70,NULL,NULL,'2MASX J14284608+3023147',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.77',0.14,NULL,NULL,NULL,NULL,NULL,1,217.19225,30.38744,0,NULL,60048452210,938257065,14660266,17.77),(121098,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121098,37.48,0.21,313,53777,70,NULL,NULL,'2MASX J14284637+4600312',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.193375,46.00878,0.014,NULL,59228540730,925445948,14460092,17.7),(121099,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121099,33.8,0.4,57.5,53778,NULL,NULL,'mean','NGC 5639',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'14.24',0.9,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.1939583,30.41294,0,NULL,60048451670,938257057,14660266,14.24),(121100,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121100,34.13,0.47,66.8,53778,NULL,NULL,'H','NGC 5639',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121101,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121101,36.14,NULL,169,53779,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1757',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000189,NULL,'16.9g',0.13,'Sd(f)',NULL,NULL,NULL,NULL,1,217.199833,59.2625,0,NULL,57751377142,902365267,14099457,16.9),(121102,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121102,36.17,NULL,171,53779,NULL,NULL,'Dipole + Quadrupole','FGC 1757',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121103,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121103,36.17,NULL,171,53779,NULL,NULL,NULL,'FGC 1757',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121104,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121104,36.18,0.49,173,53779,75,NULL,'IR','FGC 1757',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121105,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121105,36.2,NULL,174,53779,NULL,NULL,'Dipole','FGC 1757',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121106,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121106,36.96,0.46,247,53780,70,NULL,NULL,'SDSS J142850.16+310329.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000131,NULL,'17.4g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.209,31.05819,0,NULL,60049753852,938277403,14660584,17.4),(121107,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121107,37.42,0.33,304,53781,70,NULL,NULL,'2MASX J14285036+2021245',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.27',0.17,NULL,NULL,NULL,NULL,NULL,1,217.209708333,20.35686,0.042,NULL,59510107538,929845430,14528834,18.27),(121108,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121108,38.35,0.33,467,53782,70,NULL,NULL,'2MASX J14285100+1524484',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.87',0.13,NULL,NULL,NULL,NULL,NULL,1,217.212667,15.41339,0,NULL,59476345737,929317902,14520592,18.87),(121109,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121109,37.71,0.33,349,53783,70,NULL,NULL,'2MASX J14285390+5527111',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.224666667,55.45311,0,NULL,57258258011,894660281,13979066,17.8),(121110,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121110,38.01,0.11,400,53784,70,NULL,NULL,'2MASX J14285504+2521567',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.2292917,25.36564,0.01,NULL,60020925588,937826962,14653546,18),(121111,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121111,37.24,0.46,281,53785,70,NULL,NULL,'2MASX J14285613+4624573',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000189,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.234125,46.41583,0,NULL,59228652325,925447692,14460120,16.2),(121112,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121112,33.76,0.8,56.4,53786,75,NULL,'HMCL, I','UGC 09294',NULL,'1997ApJS..109..333W',1997,1,1.18,NULL,'G',0.000033,NULL,'14.7g',0.65,'SAB(s)bc',NULL,NULL,NULL,NULL,1,217.2375417,25.55342,0,NULL,60020835610,937825556,14653524,14.7),(121113,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121113,33.78,0.4,56.9,53786,75,NULL,'HMCL, I, raw','UGC 09294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121114,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121114,33.86,0.4,59,53786,75,NULL,'HMCL, I, inv','UGC 09294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121115,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121115,34.04,0.4,64.2,53786,75,NULL,'HMCL, I, cor','UGC 09294',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121116,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121116,35.23,0.2,111,53787,74.4,NULL,NULL,'UGC 09286',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'14.76',0.6,'SBb',NULL,NULL,NULL,NULL,1,217.2372917,11.19683,0,NULL,59358307957,927473561,14491774,14.76),(121117,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121117,35.28,0.4,114,53787,NULL,NULL,'mean','UGC 09286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121118,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121118,35.62,0.47,133,53787,NULL,NULL,'H','UGC 09286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121119,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121119,35.7,0.45,138,53787,NULL,NULL,'K','UGC 09286',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121120,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121120,38.48,0.46,496,53788,70,NULL,NULL,'2MASX J14285719+3123007',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.238291667,31.38353,0,NULL,60049703851,938276622,14660572,17.7),(121121,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121121,36.51,0.46,201,53789,70,NULL,NULL,'2MASX J14285794+1032088',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000097,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.2415417,10.53589,0.049,NULL,58270735993,910480249,14226253,16.9),(121122,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121122,36.88,0.46,238,53790,70,NULL,NULL,'2MASX J14285812+0543253',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.2422083,5.72361,0.049,NULL,58303913277,910998644,14234353,17.2),(121123,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121123,33.79,0.46,57.3,53791,70,NULL,NULL,'UGC 09288',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.00004,NULL,'13.85',1.2,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.242625,13.86189,0,NULL,59476803614,929325056,14520704,13.85),(121124,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121124,37.48,0.46,314,53792,70,NULL,NULL,'SDSS J142858.93+072542.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.245583333,7.42858,0.033,NULL,58280553926,910633655,14228650,17.8),(121125,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121125,34.25,0.8,70.9,53793,75,NULL,'HMCL, I','NGC 5637',NULL,'1997ApJS..109..333W',1997,1,0.88,NULL,'G',0.000027,NULL,'14.1g',0.63,'Sc',NULL,NULL,NULL,NULL,1,217.248333,23.1915,0.06,NULL,59497804603,929653196,14525831,14.1),(121126,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121126,33.84,0.4,58.7,53793,75,NULL,'HMCL, I, raw','NGC 5637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121127,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121127,33.98,0.4,62.6,53793,75,NULL,'HMCL, I, inv','NGC 5637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121128,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121128,34.11,0.4,66.5,53793,75,NULL,'HMCL, I, cor','NGC 5637',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121129,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121129,38.01,0.11,400,53794,70,NULL,NULL,'2MASX J14290013+2521577',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0001,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.250625,25.36589,0.01,NULL,60020956094,937827438,14653553,17.2),(121130,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121130,38.35,0.33,467,53795,70,NULL,NULL,'2MASX J14290069+1526254',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.2527917,15.44053,0,NULL,59490042170,929531908,14523936,17.4),(121131,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121131,38.06,0.33,409,53796,70,NULL,NULL,'2MASX J14290128+1957544',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.98',0.12,NULL,NULL,NULL,NULL,NULL,1,217.255458333,19.96522,0.041,NULL,59511957161,929874330,14529286,18.98),(121132,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121132,38.52,0.46,505,53797,70,NULL,NULL,'2MASX J14290251+1434494',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.15,NULL,NULL,NULL,NULL,NULL,1,217.260541667,14.58044,0,NULL,59477002642,929328166,14520752,18.66),(121133,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121133,37.71,0.33,349,53798,70,NULL,NULL,'2MASX J14290344+5531031',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.264167,55.5175,0,NULL,57258234745,894659917,13979061,16.8),(121134,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121134,31.84,0.2,23.3,53799,74.4,NULL,NULL,'UGC 09285',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000073,NULL,'15.07',0.3,'Sc(f)','Group member',NULL,NULL,NULL,1,217.266166667,3.14903,0.049,NULL,58315516036,911179938,14237186,15.07),(121135,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121135,31.91,0.63,24.1,53799,NULL,NULL,'Malmquist cor.','UGC 09285',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121136,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121136,32.04,NULL,25.6,53799,72,NULL,NULL,'UGC 09285',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121137,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121137,32.17,0.56,27.2,53799,NULL,NULL,NULL,'UGC 09285',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121138,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121138,37.88,0.46,377,53800,70,NULL,NULL,'2MASX J14290500+3525529',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.5g',0.16,'S0',NULL,NULL,NULL,NULL,1,217.270667,35.43131,0,NULL,60038503000,938101609,14657837,17.5),(121139,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121139,38.41,0.15,480,53801,70,NULL,NULL,'2MASX J14290533+5645170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.2725,56.75478,0,NULL,57257000364,894640630,13978759,17.9),(121140,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121140,34.63,0.43,84.3,53802,75,NULL,'3.6 micron, color corrected','UGC 09303',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000027,NULL,'15.8g',0.24,'S?',NULL,NULL,NULL,NULL,1,217.2827917,32.91017,0,NULL,60040727303,938136364,14658380,15.8),(121141,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121141,34.63,0.43,84.3,53802,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09303',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121142,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121142,34.66,0.2,85.5,53802,74.4,NULL,NULL,'UGC 09303',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121143,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121143,37.49,0.46,315,53803,70,NULL,NULL,'2MASX J14290911+3716093',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,217.2877917,37.26933,0,NULL,60064413316,938506458,14664163,17),(121144,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121144,38.14,0.23,425,53804,70,NULL,NULL,'SDSS J142909.63+145545.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.290125,14.92928,0,NULL,59477272682,929332385,14520818,18),(121145,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121145,33.21,0.2,43.9,53805,74.4,NULL,NULL,'UGC 09302',NULL,'2013AJ....146...86T',2013,1,1.26,NULL,'G',0.000043,NULL,'15.7g',0.28,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.29075,31.79867,0,NULL,60049534777,938273980,14660530,15.7),(121146,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121146,33.51,0.49,50.3,53805,75,NULL,'IR','UGC 09302',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121147,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121147,37.57,0.46,327,53806,70,NULL,NULL,'SDSS J142909.86+362250.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.291083333,36.38083,0,NULL,60077175810,938705872,14667279,18),(121148,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121148,36.16,0.56,171,53807,70,NULL,NULL,'2MASX J14290988-4649556',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,217.2912917,-46.83217,0.617,NULL,46801037286,731266207,11426034,16.8),(121149,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121149,35.28,0.4,114,53808,NULL,NULL,'mean','UGC 09292',NULL,'2007A&A...465...71T',2007,1,1.66,NULL,'G',0.000067,NULL,'14.7g',0.34,'SABb',NULL,NULL,NULL,NULL,1,217.294375,2.287,0.081,NULL,58290242604,910785040,14231016,14.7),(121150,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121150,35.45,0.49,123,53808,75,NULL,'IR','UGC 09292',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121151,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121151,35.62,0.47,133,53808,NULL,NULL,'H','UGC 09292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121152,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121152,35.67,0.46,136,53808,NULL,NULL,'J','UGC 09292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121153,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121153,35.7,0.45,138,53808,NULL,NULL,'K','UGC 09292',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121154,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121154,36.62,0.46,211,53809,70,NULL,NULL,'2MASX J14291093+5659240',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,217.2955417,56.99011,0,NULL,57249389974,894521718,13976901,16.7),(121155,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121155,37.53,0.46,321,53810,70,NULL,NULL,'2MASX J14291095+4315393',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.295833,43.26089,0.012,NULL,59959494536,936867102,14638548,17.4),(121156,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121156,37.5,0.46,316,53811,70,NULL,NULL,'2MASX J14291313+2616589',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.68',0.23,NULL,NULL,NULL,NULL,NULL,1,217.30475,26.28311,0,NULL,60024019680,937875307,14654301,17.68),(121157,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121157,33.97,0.45,62.1,53812,NULL,NULL,'K','NGC 5642',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00007,NULL,'13.64',1.3,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.3062083,30.02644,0,NULL,60048651803,938260184,14660315,13.64),(121158,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121158,33.97,0.4,62.4,53812,NULL,NULL,'mean','NGC 5642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121159,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121159,38.3,0.46,458,53813,70,NULL,NULL,'SDSS J142914.03+303514.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.3085,30.58733,0,NULL,60048421472,938256585,14660259,18.5),(121160,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121160,38.14,0.23,425,53814,70,NULL,NULL,'2MASX J14291441+1459396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.309916667,14.99431,0,NULL,59477277954,929332468,14520819,17.7),(121161,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121161,37.88,0.46,376,53815,70,NULL,NULL,'SDSS J142914.76+191615.7',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.3115,19.27103,0.055,NULL,59511721019,929870640,14529228,NULL),(121162,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121162,34.62,0.2,84,53816,74.4,NULL,NULL,'KUG 1426+119',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'15.7g',0.28,'Spiral',NULL,NULL,NULL,NULL,1,217.3127083,11.69475,0.011,NULL,59358836485,927481820,14491903,15.7),(121163,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121163,37.52,0.46,319,53817,70,NULL,NULL,'2MASX J14291547+3609444',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.3145,36.16233,0,NULL,60068762866,938574419,14665225,17.2),(121164,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121164,37.01,0.46,252,53818,70,NULL,NULL,'SDSS J142915.72-000500.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000064,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.315541667,-0.08336,0.093,NULL,43513362768,679896293,10623379,17.7),(121165,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121165,34.69,0.57,86.6,53819,NULL,NULL,'Malmquist cor.','ESO 511- G 043',NULL,'2009ApJS..182..474S',2009,1,1.1,'FLASH project (2003MNRAS.339..652K) gives v = 8591 +/- 108 km/sec.','G',0.000033,NULL,'15.67',0.7,'Sb',NULL,NULL,NULL,NULL,1,217.317125,-27.13806,0.269,NULL,47015750087,734621095,11478454,15.67),(121166,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121166,34.72,0.56,88,53819,NULL,NULL,NULL,'ESO 511- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121167,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121167,34.76,0.2,89.5,53819,74.4,NULL,NULL,'ESO 511- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121168,'Ring Diameter','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121168,32.8,0.84,37,53820,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5641',NULL,'1981ApJS...45..541P',1981,1,2.36,NULL,'G',0.00003,NULL,'13.0g',1.1,'(R\')SAB(r)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.31925,28.82189,0,NULL,60059328471,938427007,14662921,13),(121169,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121169,33.87,0.8,59.4,53820,75,NULL,'HMCL, I','NGC 5641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121170,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121170,34.05,0.46,64.6,53820,NULL,NULL,'J','NGC 5641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121171,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121171,34.06,0.4,65,53820,75,NULL,'HMCL, I, raw','NGC 5641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121172,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121172,34.08,0.47,65.4,53820,NULL,NULL,'H','NGC 5641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121173,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121173,34.1,0.45,66.2,53820,NULL,NULL,'K','NGC 5641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121174,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121174,34.13,0.4,67.1,53820,NULL,NULL,'mean','NGC 5641',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121175,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121175,34.23,0.4,70.2,53820,75,NULL,'HMCL, I, cor','NGC 5641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121176,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121176,34.34,0.4,73.7,53820,75,NULL,'HMCL, I, inv','NGC 5641',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121177,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121177,37.43,0.23,306,53821,70,NULL,NULL,'SDSS J142916.60+231745.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.319166667,23.29603,0.07,NULL,59497826073,929653532,14525836,18.2),(121178,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121178,37.06,0.23,258,53822,70,NULL,NULL,'2MASX J14291793+3016179',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00018,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,217.324667,30.27181,0,NULL,60048558958,938258733,14660292,16),(121179,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SCP 06G04',NULL,121179,44.82,0.05,3910,53823,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','SDWFS J142918.75+343837.8',1.35,'2012ApJ...746...85S',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia*',NULL,NULL,NULL,NULL,1,217.328083333,34.64372,0,NULL,60039009943,938109530,14657961,NULL),(121180,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121180,38.14,0.27,424,53824,70,NULL,NULL,'SDSS J142919.46+102002.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.331083333,10.33392,0.049,NULL,58269662064,910463469,14225991,18.4),(121181,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121181,36.75,0.46,224,53825,70,NULL,NULL,'2MASX J14292009+1345226',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.333833,13.75614,0,NULL,59545761899,930402529,14537539,17.3),(121182,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121182,38.41,0.15,480,53826,70,NULL,NULL,'2MASX J14292076+5636011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.3365417,56.60036,0,NULL,57257187895,894643560,13978805,17.6),(121183,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121183,37.07,0.46,260,53827,70,NULL,NULL,'2MASX J14292146+4913173',NULL,'2015arXiv151105856S',2015,1,0.33,'1987ApJ...314..493K has z = 0.070164 +- 0.000334.','G',0.000158,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.339583,49.22161,0.025,NULL,59201824941,925028514,14453570,17),(121184,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121184,37.63,0.46,335,53828,70,NULL,NULL,'2MASX J14292188+3345020',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.341375,33.75067,0,NULL,60041437640,938147463,14658554,17.9),(121185,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121185,34.56,0.49,81.7,53829,75,NULL,'IR','ESO 511- G 044',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000037,NULL,'14.95',0.5,'SBb            HII',NULL,NULL,NULL,NULL,1,217.341667,-22.92869,0.333,NULL,46534124762,727095699,11360870,14.95),(121186,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121186,35.21,0.47,110,53829,NULL,NULL,'H','ESO 511- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121187,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121187,35.26,0.4,113,53829,NULL,NULL,'mean','ESO 511- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121188,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121188,35.28,0.45,114,53829,NULL,NULL,'K','ESO 511- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121189,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121189,35.37,0.46,118,53829,NULL,NULL,'J','ESO 511- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121190,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121190,38.14,0.27,424,53830,70,NULL,NULL,'2MASX J14292204+1016253',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,217.341833333,10.27381,0.049,NULL,58269873588,910466774,14226043,16.6),(121191,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121191,38.07,0.33,412,53831,70,NULL,NULL,'2MASX J14292263+2457219',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.344167,24.95619,0.029,NULL,59496838815,929638106,14525595,17.6),(121192,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121192,37.43,0.23,306,53832,70,NULL,NULL,'2MASX J14292386+2254436',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.3495417,22.91189,0.041,NULL,59497879948,929654374,14525849,17.8),(121193,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121193,37.06,0.23,258,53833,70,NULL,NULL,'2MASX J14292403+3016369',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.350333,30.27689,0,NULL,60048569797,938258903,14660295,17.5),(121194,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121194,38.49,0.46,500,53834,70,NULL,NULL,'2MASX J14292533+1938396',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.76',0.14,NULL,NULL,NULL,NULL,NULL,1,217.355583,19.64433,0.042,NULL,59511566446,929868225,14529191,18.76),(121195,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121195,37.83,0.46,368,53835,70,NULL,NULL,'2MASX J14292564+0738393',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.3567917,7.64411,0.033,NULL,58283330007,910677031,14229328,17),(121196,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121196,37.9,0.23,380,53836,70,NULL,NULL,'SDSS J142925.83+234116.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000131,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.357667,23.68781,0.041,NULL,59500090014,929688906,14526389,18.2),(121197,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121197,37.93,0.33,386,53837,70,NULL,NULL,'SDSS J142926.73+345727.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000155,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.361416667,34.95778,0,NULL,60039204088,938112563,14658008,18.7),(121198,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121198,38.21,0.46,438,53838,70,NULL,NULL,'2MASX J14292682+3453079',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.26,'E/S0',NULL,NULL,NULL,NULL,1,217.361833,34.88567,0,NULL,60039200967,938112515,14658008,17.2),(121199,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121199,38.01,0.11,400,53839,70,NULL,NULL,'2MASX J14292751+2526259',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'18.32',0.17,NULL,NULL,NULL,NULL,NULL,1,217.364708333,25.44053,0.01,NULL,60020960044,937827500,14653554,18.32),(121200,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121200,37.78,0.46,360,53840,70,NULL,NULL,'SDSS J142927.64+002236.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.3652083,0.37675,0.117,NULL,58290799436,910793741,14231152,18.2),(121201,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121201,37.76,0.46,356,53841,70,NULL,NULL,'LCRS B142653.0-022825',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0002,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.368833,-2.69558,0.161,NULL,43513824640,679903510,10623492,17.1),(121202,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121202,37.43,0.23,306,53842,70,NULL,NULL,'CGCG 133-074',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000103,NULL,'15.2g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,217.3722917,23.30675,0.07,NULL,59497819558,929653430,14525834,15.2),(121203,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121203,37.93,0.33,386,53843,70,NULL,NULL,'2MASX J14293016+3457239',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000191,NULL,'17.1g',0.26,'E/S0',NULL,NULL,NULL,NULL,1,217.375875,34.95656,0,NULL,60039202122,938112533,14658008,17.1),(121204,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121204,38.14,0.27,424,53844,70,NULL,NULL,'2MASX J14293165+1016079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.381875,10.26894,0.049,NULL,58269871251,910466738,14226042,18),(121205,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121205,32.84,0.43,37,53845,75,NULL,'3.6 micron, color + selection bias corrected','ESO 385- G 031',NULL,'2014MNRAS.444..527S',2014,1,1.14,'Star superposed.','G',0.00015,NULL,'16.53',0.11,'Scd',NULL,NULL,NULL,NULL,1,217.382166667,-34.62436,0.261,NULL,46999659570,734369680,11474526,16.53),(121206,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121206,38.03,0.46,405,53846,70,NULL,NULL,'2MASX J14293180+1808176',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.3825,18.13831,0,NULL,59481279535,929394992,14521796,17.9),(121207,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121207,37.78,0.46,360,53847,70,NULL,NULL,'2MASX J14293300+1712346',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.387416667,17.20969,0,NULL,59482626916,929416045,14522125,17.2),(121208,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121208,35.51,0.57,127,53848,70,NULL,NULL,'2MASX J14293327-0933405',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00011,NULL,'15.54',0.5,'poss. LINER',NULL,NULL,NULL,NULL,1,217.388917,-9.56117,0.225,NULL,43521492760,680023324,10625364,15.54),(121209,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121209,34.79,0.49,90.8,53849,75,NULL,'IR','NGC 5646',NULL,'2011yCatp016004901K',2011,1,1.33,NULL,'G',0.000033,NULL,'14.6g',0.47,'SBb:',NULL,NULL,NULL,NULL,1,217.3917083,35.46194,0,NULL,60038506594,938101665,14657838,14.6),(121210,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121210,36.39,0.46,190,53850,70,NULL,NULL,'2MASX J14293440+1434496',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.393333,14.58039,0,NULL,59476898213,929326534,14520727,NULL),(121211,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121211,31.89,0.8,23.9,53851,75,NULL,'CF, r','UGC 09299',NULL,'1997ApJS..109..333W',1997,1,1.31,NULL,'G',0.00001,NULL,'14.6g',0.64,'SAB(s)d pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.394167,-0.01822,0.093,NULL,43513360071,679896251,10623378,14.6),(121212,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121212,32.29,0.2,28.7,53851,74.4,NULL,NULL,'UGC 09299',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121213,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121213,32.32,0.62,29.1,53851,NULL,NULL,'Malmquist cor.','UGC 09299',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121214,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121214,32.33,0.43,29.3,53851,75,NULL,'3.6 micron, color corrected','UGC 09299',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121215,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121215,32.34,0.43,29.3,53851,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09299',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121216,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121216,32.44,NULL,30.8,53851,72,NULL,NULL,'UGC 09299',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121217,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121217,32.47,0.58,31.2,53851,NULL,NULL,NULL,'UGC 09299',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121218,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121218,32.58,0.38,32.9,53851,75,NULL,'CF, r, inv','UGC 09299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121219,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121219,32.63,0.38,33.6,53851,75,NULL,'CF, r, raw','UGC 09299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121220,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121220,32.68,0.38,34.3,53851,75,NULL,'CF, r, cor','UGC 09299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121221,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121221,37.39,0.46,301,53852,70,NULL,NULL,'2MASX J14293560+5151284',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.3982083,51.85781,0.005,NULL,59203313293,925051770,14453933,17.7),(121222,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121222,38.07,0.21,412,53853,70,NULL,NULL,'SDSS J142936.33+571721.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000121,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,217.401375,57.28919,0,NULL,57251382532,894552852,13977388,18.7),(121223,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121223,35.74,0.8,140,53854,75,NULL,'CF, r','UGC 09309',NULL,'1997ApJS..109..333W',1997,1,1.22,NULL,'G',0.00004,NULL,'14.9g',0.43,'Sbc',NULL,NULL,NULL,NULL,1,217.4105,10.58408,0.053,NULL,59359369242,927490144,14492033,14.9),(121224,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121224,34.87,0.38,94,53854,75,NULL,'CF, r, raw','UGC 09309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121225,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121225,34.97,0.38,98.7,53854,75,NULL,'CF, r, inv','UGC 09309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121226,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121226,35.1,0.38,105,53854,75,NULL,'CF, r, cor','UGC 09309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121227,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121227,35.28,0.2,114,53854,74.4,NULL,NULL,'UGC 09309',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121228,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121228,38.09,0.33,415,53855,70,NULL,NULL,'2MASX J14293888+3013309',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.411875,30.22531,0,NULL,60048570435,938258913,14660295,17.9),(121229,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121229,37,0.46,251,53856,70,NULL,NULL,'2MASX J14293949+2058462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.04',0.22,NULL,NULL,NULL,NULL,NULL,1,217.4145417,20.97947,0.059,NULL,59524067900,930063560,14532243,18.04),(121230,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121230,38.07,0.33,412,53857,70,NULL,NULL,'2MASX J14294040+2452044',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000133,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,217.4182917,24.86803,0.029,NULL,59496963660,929640057,14525625,16.8),(121231,'SBF','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121231,32.1,0.24,26.3,53858,NULL,NULL,'I','NGC 5638',NULL,'2001ApJ...546..681T',2001,1,1.91,NULL,'G',0.000014,NULL,'12.2g',1.55,'E1','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.41825,3.23331,0.045,NULL,58315744104,911183501,14237242,12.2),(121232,'SBF','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121232,32.1,0.24,26.3,53858,NULL,NULL,NULL,'NGC 5638',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121233,'SBF','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121233,32.12,0.14,26.6,53858,74.4,NULL,NULL,'NGC 5638',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121234,'SBF','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121234,32.15,0.24,26.9,53858,NULL,NULL,'Malmquist cor.','NGC 5638',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121235,'D-Sigma','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121235,31.39,0.4,19,53858,75,NULL,'Edat, raw','NGC 5638',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121236,'D-Sigma','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121236,31.61,0.4,21,53858,75,NULL,'Edat, cor','NGC 5638',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121237,'Faber-Jackson','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121237,31.4,0.58,19.1,53858,95,NULL,'de Vaucouleurs','NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121238,'Faber-Jackson','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121238,31.68,0.35,21.7,53858,95,NULL,'Weighted Mean','NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121239,'Faber-Jackson','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121239,31.91,0.63,24.1,53858,95,NULL,'Michard 1979b, c','NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121240,'Faber-Jackson','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121240,32.3,0.46,28.8,53858,95,NULL,'Michard 1979a','NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121241,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121241,31.69,0.41,21.8,53858,NULL,NULL,NULL,'NGC 5638',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121242,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121242,31.9,0.41,23.9,53858,NULL,NULL,'Malmquist cor.','NGC 5638',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121243,'Tertiary','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121243,30.95,0.21,15.5,53858,95,NULL,NULL,'NGC 5638',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121244,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121244,32.27,0.8,28.4,53858,75,NULL,'B','NGC 5638',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121245,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121245,32.14,0.4,26.8,53858,NULL,NULL,'mean','NGC 5638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121246,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121246,32.24,0.45,28,53858,NULL,NULL,'K','NGC 5638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121247,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121247,36.82,0.17,231,53859,70,NULL,NULL,'CGCG 019-045',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000135,NULL,'15.4g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,217.4192917,0.36639,0.117,NULL,58290800806,910793762,14231152,15.4),(121248,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121248,38.5,0.46,502,53860,70,NULL,NULL,'2MASX J14294071+1207079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000203,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.419583,12.11892,0.009,NULL,59358387004,927474796,14491793,18),(121249,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121249,36.67,0.46,216,53861,70,NULL,NULL,'2MASX J14294077+0414123',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000067,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.4199583,4.23661,0.037,NULL,58316046944,911188233,14237316,17.1),(121250,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121250,37.5,0.46,316,53862,70,NULL,NULL,'2MASX J14294079+1414330',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.62',0.13,NULL,NULL,NULL,NULL,NULL,1,217.420125,14.24244,0,NULL,59476821650,929325338,14520708,18.62),(121251,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121251,37.9,0.23,380,53863,70,NULL,NULL,'2MASX J14294090+2353374',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.4202917,23.89386,0.033,NULL,59500027024,929687922,14526373,18.5),(121252,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121252,38.08,0.46,413,53864,70,NULL,NULL,'SDSS J142941.22-003148.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.42175,-0.53,0.093,NULL,43513470248,679897972,10623405,18.2),(121253,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121253,35.68,0.48,137,53865,70,NULL,NULL,'2MASX J14294200-0352226',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00014,NULL,'15.30',0.47,NULL,NULL,NULL,NULL,NULL,1,217.4252083,-3.87303,0.185,NULL,43550916150,680483064,10632547,15.3),(121254,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121254,36.56,0.23,205,53866,70,NULL,NULL,'CGCG 047-064',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00017,NULL,'15.1g',0.57,NULL,NULL,NULL,NULL,NULL,1,217.4295417,7.25356,0.029,NULL,58280879165,910638736,14228730,15.1),(121255,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121255,38.22,0.46,440,53867,70,NULL,NULL,'SDSS J142943.53+091552.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000132,NULL,'18.2g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.431375,9.26469,0.025,NULL,58270000410,910468756,14226074,18.2),(121256,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121256,38.02,0.46,403,53868,70,NULL,NULL,'2MASX J14294367+2319312',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.49',0.17,NULL,NULL,NULL,NULL,NULL,1,217.432125,23.32542,0.07,NULL,59497817944,929653405,14525834,18.49),(121257,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121257,37.9,0.23,380,53869,70,NULL,NULL,'2MASX J14294408+2343552',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000193,NULL,'16.1g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,217.43375,23.73206,0.041,NULL,59500120288,929689379,14526396,16.1),(121258,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121258,36.35,0.16,186,53870,70,NULL,NULL,'2MASX J14294457+5349414',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000176,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,217.435917,53.82825,0,NULL,59197189379,924956084,14452438,15.4),(121259,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121259,36.82,0.17,231,53871,70,NULL,NULL,'2MASX J14294491+0014014',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000056,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.437,0.23372,0.105,NULL,58290777835,910793403,14231146,17.6),(121260,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121260,36.56,0.23,205,53872,70,NULL,NULL,'2MASX J14294591+0710039',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000188,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,217.4412083,7.16783,0.029,NULL,58280884541,910638820,14228731,16.2),(121261,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121261,36.86,0.27,236,53873,70,NULL,NULL,'2MASX J14294598+4933304',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000182,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,217.441667,49.55833,0.005,NULL,59200995381,925015552,14453368,15.9),(121262,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121262,37.66,0.46,340,53874,70,NULL,NULL,'2MASX J14294699+2045572',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.15,NULL,NULL,NULL,NULL,NULL,1,217.4457917,20.76586,0.066,NULL,59510255484,929847741,14528870,18.68),(121263,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121263,37.9,0.23,380,53875,70,NULL,NULL,'2MASX J14294801+2346532',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.4500417,23.7815,0.041,NULL,59500096400,929689006,14526390,17.6),(121264,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121264,36.82,0.17,231,53876,70,NULL,NULL,'2MASX J14294824+0016584',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000068,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.4510417,0.28289,0.117,NULL,58290805308,910793832,14231153,17),(121265,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121265,36.55,0.46,204,53877,70,NULL,NULL,'2MASX J14294845+1759082',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.451833333,17.98553,0,NULL,59481320566,929395633,14521806,17.4),(121266,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121266,36.35,0.16,186,53878,70,NULL,NULL,'IC 1027',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000107,NULL,'14.8g',0.7,'BrClG',NULL,NULL,NULL,NULL,1,217.452083,53.96503,0.021,NULL,59196474446,924944913,14452264,14.8),(121267,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121267,38.06,0.46,410,53879,70,NULL,NULL,'SDSS J142948.91+335620.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.4537917,33.93906,0,NULL,60041297959,938145280,14658520,17.9),(121268,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121268,36.35,0.16,186,53880,70,NULL,NULL,'2MASX J14294909+5359342',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000177,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,217.454833,53.99297,0.021,NULL,59196474720,924944917,14452264,16.5),(121269,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121269,32.85,0.4,37.2,53881,75,NULL,'B','NGC 5660',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000023,NULL,'12.4',2.5,'SAB(rs)c','Parent (of companion) galaxy',NULL,NULL,NULL,1,217.457541667,49.62267,0,NULL,59200868121,925013564,14453336,12.4),(121270,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121270,36.52,0.46,202,53882,70,NULL,NULL,'2MASX J14294984+0039534',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.457541667,0.66486,0.109,NULL,58290681238,910791894,14231123,17.3),(121271,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121271,37.6,0.46,331,53883,70,NULL,NULL,'SDSS J142950.07+151548.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.458625,15.26356,0,NULL,59476403298,929318801,14520606,18.4),(121272,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121272,34.44,0.2,77.3,53884,74.4,NULL,NULL,'KUG 1427+140',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000108,NULL,'15.5g',0.25,'Spiral',NULL,NULL,NULL,NULL,1,217.460666667,13.79967,0,NULL,59545758064,930402469,14537538,15.5),(121273,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121273,33.13,0.4,42.3,53885,75,NULL,'B','UGC 09324',NULL,'1988NBGC.C....0000T',1988,1,2.3,'Coordinates for VV 152 are incorrect in VV Atlas.','G',0.00002,NULL,'14.9',1.4,'SBm',NULL,NULL,NULL,NULL,1,217.4614583,44.44783,0,NULL,59955455660,936803994,14637562,14.9),(121274,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121274,36.82,0.17,231,53886,70,NULL,NULL,'2MASX J14295104+0020564',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.462625,0.34892,0.117,NULL,58290808293,910793879,14231154,17.1),(121275,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121275,36.35,0.16,186,53887,70,NULL,NULL,'2MASX J14295195+5404552',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,217.46675,54.08194,0.021,NULL,59196507515,924945429,14452272,16.6),(121276,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121276,38.72,0.33,554,53888,70,NULL,NULL,'2MASX J14295239+1850222',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.4682083,18.83953,0.018,NULL,59511317349,929864333,14529130,17.2),(121277,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121277,38.07,0.46,412,53889,70,NULL,NULL,'2MASX J14295255+2426185',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.469,24.43844,0.041,NULL,59496868043,929638563,14525602,17.7),(121278,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121278,37.43,0.46,307,53890,70,NULL,NULL,'2MASX J14295295+2515215',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.470833,25.256,0.01,NULL,60020970563,937827665,14653557,17.6),(121279,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121279,34.52,0.51,80.3,53891,70,NULL,NULL,'2MASX J14295422-2937094',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.2b',NULL,'E',NULL,NULL,NULL,NULL,1,217.476,-29.61928,0.377,NULL,47027681577,734807524,11481367,15.2),(121280,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121280,38.09,0.33,415,53892,70,NULL,NULL,'2MASX J14295454+3011519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.47725,30.19778,0,NULL,60048777473,938262148,14660346,17.8),(121281,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121281,36.56,0.23,205,53893,70,NULL,NULL,'CGCG 047-067',NULL,'2015arXiv151105856S',2015,1,0.93,'One of two 6cm sources associated with [WB92] 1427+0728','G',0.000203,NULL,'14.9g',0.6,NULL,NULL,NULL,NULL,NULL,1,217.48075,7.25358,0.017,NULL,58280878555,910638727,14228730,14.9),(121282,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121282,37.06,0.23,258,53894,70,NULL,NULL,'2MASX J14295608+3016279',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.4837917,30.27447,0,NULL,60048561751,938258777,14660293,17.4),(121283,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121283,37.15,0.46,269,53895,70,NULL,NULL,'2MASX J14295673+0756329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.73',0.16,NULL,NULL,NULL,NULL,NULL,1,217.486375,7.9425,0.033,NULL,58283689812,910682653,14229416,18.73),(121284,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121284,37.59,0.46,329,53896,70,NULL,NULL,'2MASX J14295700-0044506',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.487667,-0.74742,0.081,NULL,43515447281,679928863,10623888,16.9),(121285,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121285,34.13,0.59,66.9,53897,70,NULL,NULL,'AM 1427-263',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.0',NULL,'S0',NULL,NULL,NULL,NULL,1,217.494875,-26.81017,0.289,NULL,47017734257,734652097,11478939,15),(121286,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121286,38.14,0.23,425,53898,70,NULL,NULL,'SDSS J142958.96+145146.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.4957083,14.86303,0,NULL,59477158128,929330595,14520790,17),(121287,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121287,37.19,0.46,275,53899,70,NULL,NULL,'2MASX J14295894+1656291',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.78',0.2,NULL,NULL,NULL,NULL,NULL,1,217.4957083,16.94153,0,NULL,59482089485,929407648,14521994,17.78),(121288,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121288,37.66,0.46,341,53900,70,NULL,NULL,'2MASX J14295944+2918045',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,217.497666667,29.30139,0,NULL,60047981560,938249711,14660151,16.8),(121289,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121289,38.72,0.33,554,53901,70,NULL,NULL,'2MASX J14295943+1850102',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.55',0.15,NULL,NULL,NULL,NULL,NULL,1,217.4977917,18.83611,0.018,NULL,59511316543,929864320,14529130,18.55),(121290,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121290,36.82,0.17,231,53902,70,NULL,NULL,'2MASX J14295965+0012010',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.4984583,0.20033,0.117,NULL,58290856881,910794638,14231166,17.3),(121291,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121291,37.6,0.46,331,53903,70,NULL,NULL,'2MASX J14300069+2054442',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.52',0.25,NULL,NULL,NULL,NULL,NULL,1,217.503,20.91228,0.066,NULL,59510233478,929847398,14528865,17.52),(121292,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121292,31.63,NULL,21.2,53904,72,NULL,NULL,'UGC 09310',NULL,'2014Ap.....57..457K',2014,1,2,NULL,'G',0.000013,NULL,'14.50',0.6,'SBdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.504583,3.22056,0.057,NULL,58315740596,911183446,14237241,14.5),(121293,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121293,32.4,0.4,30.2,53904,75,NULL,'B','UGC 09310',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121294,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121294,37.64,0.33,337,53905,70,NULL,NULL,'2MASX J14300174+0607060',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,217.507375,6.11822,0.057,NULL,58272548578,910508571,14226696,16.7),(121295,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121295,32.86,NULL,37.3,53906,72,NULL,NULL,'IC 1022',NULL,'2014Ap.....57..457K',2014,1,1.25,NULL,'G',0.00003,NULL,'14.7g',0.43,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.507667,3.77286,0.045,NULL,58316411163,911193924,14237405,14.7),(121296,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121296,32.86,0.2,37.3,53906,74.4,NULL,NULL,'IC 1022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121297,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121297,33.14,0.79,42.5,53906,NULL,NULL,NULL,'IC 1022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121298,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121298,33.19,0.78,43.4,53906,NULL,NULL,'Malmquist cor.','IC 1022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121299,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121299,38.85,0.33,588,53907,70,NULL,NULL,'2MASX J14300188+2037122',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.76',0.15,NULL,NULL,NULL,NULL,NULL,1,217.5077917,20.62,0.058,NULL,59510318852,929848732,14528886,18.76),(121300,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121300,38.07,0.21,412,53908,70,NULL,NULL,'2MASX J14300211+5722531',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.508875,57.38139,0,NULL,57251380152,894552814,13977387,18.1),(121301,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121301,38.47,0.27,494,53909,70,NULL,NULL,'2MASX J14300246+1949002',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.5102083,19.81675,0.042,NULL,59512039347,929875614,14529306,17.8),(121302,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121302,37.44,0.46,307,53910,70,NULL,NULL,'2MASX J14300284+5839361',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.512125,58.66019,0,NULL,57248228963,894503577,13976618,17),(121303,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121303,38.34,0.46,466,53911,70,NULL,NULL,'2MASX J14300307+5654171',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.512833,56.90478,0,NULL,57249428319,894522317,13976911,17.9),(121304,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121304,36.76,0.16,225,53912,70,NULL,NULL,'2MASX J14300558+5239217',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.523083,52.65589,0.005,NULL,59206056244,925094628,14454603,16.4),(121305,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121305,38.85,0.33,588,53913,70,NULL,NULL,'SDSS J143006.22+203016.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.5259583,20.50461,0.057,NULL,59510344658,929849135,14528892,18.4),(121306,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121306,36.67,0.46,215,53914,70,NULL,NULL,'2MASX J14300641+3045249',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,217.526833333,30.75697,0,NULL,60049721005,938276890,14660576,16.1),(121307,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121307,35.51,0.54,127,53915,70,NULL,NULL,'FGC 1758',NULL,'2014MNRAS.445.2677S',2014,1,1.46,NULL,'G',0.000097,NULL,'14.08',0.17,'Sbc',NULL,NULL,NULL,NULL,1,217.52975,-6.42856,0.165,NULL,43530619222,680165925,10627592,14.08),(121308,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121308,38.14,0.23,425,53916,70,NULL,NULL,'2MASX J14301012+1502067',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,217.542,15.03517,0,NULL,59476446558,929319477,14520616,18.43),(121309,'Sosies','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121309,33.3,0.4,45.7,53917,NULL,NULL,NULL,'NGC 5653',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000017,NULL,'12.86',1.3,'(R\')SA(rs)b;HIILIRG','Pair member, wide',NULL,NULL,NULL,1,217.543417,31.2155,0,NULL,60049812073,938278313,14660598,12.86),(121310,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121310,33.41,0.2,48.1,53917,74.4,NULL,NULL,'NGC 5653',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121311,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121311,33.59,0.45,52.2,53917,NULL,NULL,'K','NGC 5653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121312,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121312,33.65,0.47,53.6,53917,NULL,NULL,'H','NGC 5653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121313,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121313,33.71,0.46,55.1,53917,NULL,NULL,'J','NGC 5653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121314,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121314,33.76,0.4,56.5,53917,NULL,NULL,'mean','NGC 5653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121315,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121315,36.56,0.23,205,53918,70,NULL,NULL,'2MASX J14301090+0716440',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,217.5454583,7.27894,0.017,NULL,58280685244,910635706,14228682,18.5),(121316,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121316,34.37,0.46,75,53919,70,NULL,NULL,'MRK 0683',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000012,NULL,'14.7g',0.64,'Compact        HII',NULL,NULL,NULL,NULL,1,217.5457083,23.02628,0.055,NULL,59497889975,929654530,14525852,14.7),(121317,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121317,38.47,0.27,494,53920,70,NULL,NULL,'2MASX J14301136+1936377',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.14,NULL,NULL,NULL,NULL,NULL,1,217.547416667,19.61061,0.044,NULL,59512008503,929875132,14529298,18.62),(121318,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121318,38.01,0.11,400,53921,70,NULL,NULL,'SDSS J143011.44+253920.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.5477083,25.65561,0.019,NULL,60020856161,937825877,14653529,18.3),(121319,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121319,32.71,0.8,34.9,53922,75,NULL,'MAT, I','ESO 385- G 032',NULL,'1997ApJS..109..333W',1997,1,2.2,'Lawrence, et al. (1999MNRAS.308..897L) also give v=29379km/sec (cosmic ray?).','G',0.00002,NULL,'13.30',1.3,'SAB(r)c        HII?',NULL,NULL,NULL,NULL,1,217.5497917,-36.96436,0.313,NULL,47224843067,737888172,11529502,13.3),(121320,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121320,31.8,0.69,22.9,53922,100,NULL,'mid-IR','ESO 385- G 032',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121321,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121321,32.63,0.47,33.6,53922,NULL,NULL,'H','ESO 385- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121322,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121322,32.68,0.4,34.4,53922,NULL,NULL,NULL,'ESO 385- G 032',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121323,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121323,32.7,0.32,34.6,53922,85,NULL,'I, raw','ESO 385- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121324,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121324,32.74,0.32,35.3,53922,85,NULL,'I, inv','ESO 385- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121325,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121325,32.75,0.45,35.5,53922,NULL,NULL,'K','ESO 385- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121326,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121326,32.76,0.46,35.6,53922,NULL,NULL,'J','ESO 385- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121327,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121327,32.8,0.43,36.2,53922,75,NULL,'MAT, I, raw','ESO 385- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121328,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121328,32.96,0.43,39.1,53922,75,NULL,'3.6 micron, color + selection bias corrected','ESO 385- G 032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121329,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121329,32.98,0.43,39.5,53922,75,NULL,'3.6 micron, color corrected','ESO 385- G 032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121330,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121330,32.99,0.43,39.6,53922,75,NULL,'MAT, I, inv','ESO 385- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121331,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121331,33.01,0.4,40.1,53922,NULL,NULL,'mean','ESO 385- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121332,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121332,33.07,0.2,41.1,53922,74.4,NULL,NULL,'ESO 385- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121333,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121333,33.1,0.43,41.6,53922,75,NULL,'MAT, I, cor','ESO 385- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121334,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121334,33.27,0.42,45.2,53922,NULL,NULL,NULL,'ESO 385- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121335,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121335,33.49,0.38,49.8,53922,NULL,NULL,'Malmquist cor.','ESO 385- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121336,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121336,38.47,0.27,494,53923,70,NULL,NULL,'2MASX J14301249+1935217',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.552166667,19.58936,0.044,NULL,59512008269,929875129,14529298,NULL),(121337,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121337,38.07,0.21,412,53924,70,NULL,NULL,'2MASX J14301306+5729337',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000128,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.554375,57.49286,0,NULL,57252076504,894563695,13977557,18.2),(121338,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121338,38.01,0.11,400,53925,70,NULL,NULL,'SDSS J143013.47+254720.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000147,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.556125,25.78897,0,NULL,60024296380,937879630,14654369,18.7),(121339,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121339,37.24,0.46,280,53926,70,NULL,NULL,'2MASX J14301357+1754497',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.556417,17.91389,0,NULL,59481275019,929394922,14521795,17.4),(121340,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121340,37.98,0.46,395,53927,70,NULL,NULL,'2MASX J14301400-0050341',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.5584583,-0.84286,0.081,NULL,43515762478,679933788,10623965,17.4),(121341,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121341,38.98,0.46,625,53928,70,NULL,NULL,'SDSS J143015.58+013857.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.5649583,1.64936,0.109,NULL,58290092457,910782694,14230979,18.6),(121342,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121342,32.92,0.8,38.4,53929,75,NULL,'MAT, I','ESO 385- G 033',NULL,'1997ApJS..109..333W',1997,1,2.3,'The 6dF data apply to a knot 7 arcsec southwest of the galaxy\'s center.','G',0.000007,NULL,'13.26',1.8,'SAB(s)d pec:   HII',NULL,NULL,NULL,NULL,1,217.565375,-34.23592,0.265,NULL,47000739383,734386552,11474789,13.26),(121343,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121343,33.08,0.8,41.3,53929,75,NULL,'B','ESO 385- G 033',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121344,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121344,32.04,0.32,25.6,53929,85,NULL,'I, raw','ESO 385- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121345,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121345,32.04,0.32,25.6,53929,85,NULL,'I, inv','ESO 385- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121346,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121346,32.12,0.4,26.5,53929,NULL,NULL,NULL,'ESO 385- G 033',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121347,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121347,32.71,0.43,34.8,53929,75,NULL,'MAT, I, raw','ESO 385- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121348,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121348,32.81,0.43,36.5,53929,75,NULL,'MAT, I, inv','ESO 385- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121349,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121349,32.99,0.43,39.7,53929,75,NULL,'MAT, I, cor','ESO 385- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121350,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121350,36.92,0.27,242,53930,70,NULL,NULL,'2MASX J14301628-0135371',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.567875,-1.59369,0.105,NULL,43514596743,679915574,10623680,16.9),(121351,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121351,37.75,0.46,354,53931,70,NULL,NULL,'SDSS J143017.14+153448.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.5714583,15.58019,0,NULL,59490064036,929532250,14523941,17.5),(121352,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121352,37.33,0.46,293,53932,70,NULL,NULL,'2MASX J14301758+1451318',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.76',0.11,NULL,NULL,NULL,NULL,NULL,1,217.5732917,14.85881,0,NULL,59477189018,929331078,14520798,18.76),(121353,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121353,34.44,0.49,77.3,53933,70,NULL,NULL,'2MASX J14301781-0514571',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00008,NULL,'14.95',0.47,NULL,NULL,NULL,NULL,NULL,1,217.574333,-5.24939,0.109,NULL,43538322904,680286295,10629473,14.95),(121354,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121354,38.29,0.46,456,53934,70,NULL,NULL,'2MASX J14301801+3657574',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.15,NULL,NULL,NULL,NULL,NULL,1,217.5752083,36.96594,0,NULL,60077301343,938707833,14667309,18.32),(121355,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121355,35.17,0.2,108,53935,74.4,NULL,NULL,'UGC 09316',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000047,NULL,'14.80',0.5,'S0?',NULL,NULL,NULL,NULL,1,217.575417,21.74678,0.099,NULL,59523708175,930057940,14532155,14.8),(121356,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121356,35.6,0.46,132,53936,70,NULL,NULL,'CGCG 247-037',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000063,NULL,'15.2g',0.51,NULL,NULL,NULL,NULL,NULL,1,217.577208333,48.0685,0.057,NULL,59245516788,925711199,14464237,15.2),(121357,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121357,38.28,0.46,453,53937,70,NULL,NULL,'SDSS J143018.88+355159.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.5787083,35.86656,0,NULL,60068975250,938577738,14665277,18.4),(121358,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121358,37.42,0.23,305,53938,70,NULL,NULL,'2MASX J14301951+2305097',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,217.58125,23.08614,0.055,NULL,59497983329,929655989,14525874,16.4),(121359,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121359,36.82,0.17,231,53939,70,NULL,NULL,'2MASX J14301972+0007090',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000084,NULL,'16.3g',0.33,'E0',NULL,NULL,NULL,NULL,1,217.582125,0.11914,0.093,NULL,58290830503,910794226,14231159,16.3),(121360,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121360,37.64,0.33,337,53940,70,NULL,NULL,'2MASX J14302004+0607570',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000177,NULL,'16.3g',0.43,NULL,NULL,NULL,NULL,NULL,1,217.583417,6.13239,0.057,NULL,58272554486,910508663,14226697,16.3),(121361,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121361,37.5,0.46,316,53941,70,NULL,NULL,'2MASX J14302008+4115565',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,217.5837917,41.26564,0,NULL,59946537742,936664652,14635385,16.9),(121362,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121362,37.42,0.23,305,53942,70,NULL,NULL,'2MASX J14302038+2302077',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.585083,23.03553,0.055,NULL,59497861799,929654090,14525845,17.6),(121363,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121363,38.85,0.46,590,53943,70,NULL,NULL,'SDSS J143021.84-000950.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000082,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.591,-0.16406,0.093,NULL,43513522810,679898793,10623418,18.5),(121364,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121364,37.99,0.33,395,53944,70,NULL,NULL,'SDSS J143021.87+194338.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.591125,19.72731,0.044,NULL,59512060903,929875951,14529311,17.9),(121365,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121365,37.65,0.46,339,53945,70,NULL,NULL,'SDSS J143022.34+583740.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.593167,58.62794,0,NULL,57248235251,894503675,13976619,17.7),(121366,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121366,37.77,0.46,359,53946,70,NULL,NULL,'2MASX J14302324+1129060',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.59675,11.48494,0.013,NULL,59358629972,927478593,14491853,17.3),(121367,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121367,38.39,0.46,477,53947,70,NULL,NULL,'SDSS J143023.33+544408.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.5972917,54.73581,0,NULL,57253550017,894586719,13977917,18.3),(121368,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121368,38.01,0.11,400,53948,70,NULL,NULL,'2MASX J14302408+2533316',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.6005417,25.55883,0.019,NULL,60020853332,937825833,14653528,18.5),(121369,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121369,37.99,0.33,395,53949,70,NULL,NULL,'2MASX J14302417+1947187',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,217.600667,19.78844,0.034,NULL,59512049193,929875768,14529308,18.51),(121370,'Sosies','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121370,33.92,0.28,60.8,53950,NULL,NULL,NULL,'NGC 5656',NULL,'2002A&A...393...57T',2002,1,1.66,'Jangren et al. (2005AJ....130.2571J) give v = 8694 km/sec.','G',0.00002,NULL,'12.8g',1.12,'SAab           LINER','Group member',NULL,NULL,NULL,1,217.606291667,35.32103,0,NULL,60039168966,938112015,14658000,12.8),(121371,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121371,32.37,0.69,29.8,53950,100,NULL,'mid-IR','NGC 5656',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121372,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121372,33.46,0.4,49.2,53950,NULL,NULL,'mean','NGC 5656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121373,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121373,33.63,0.45,53.2,53950,NULL,NULL,'K','NGC 5656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121374,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121374,33.67,0.47,54.1,53950,NULL,NULL,'H','NGC 5656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121375,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121375,33.73,0.46,55.8,53950,NULL,NULL,'J','NGC 5656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121376,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121376,33.88,0.43,59.7,53950,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5656',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121377,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121377,33.97,0.43,62.1,53950,75,NULL,'3.6 micron, color corrected','NGC 5656',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121378,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121378,34.17,0.2,68.2,53950,74.4,NULL,NULL,'NGC 5656',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121379,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121379,35.02,0.23,101,53951,70,NULL,NULL,'NGC 5644',NULL,'2015arXiv151105856S',2015,1,1.24,NULL,'G',0.000073,NULL,'13.5g',1.08,'S0',NULL,NULL,NULL,NULL,1,217.606583,11.928,0,NULL,59358398222,927474972,14491796,13.5),(121380,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121380,37.42,0.23,305,53952,70,NULL,NULL,'2MASX J14302589+2302257',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.6079583,23.04047,0.055,NULL,59497864488,929654132,14525845,17.3),(121381,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121381,34.91,0.46,96,53953,70,NULL,NULL,'2MASX J14302773+4913108',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'15.6g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,217.615583333,49.21956,0.025,NULL,59201843962,925028811,14453575,15.6),(121382,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121382,36.82,0.17,231,53954,70,NULL,NULL,'SDSS J143028.95+001823.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000065,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.620625,0.30644,0.117,NULL,58290847422,910794490,14231163,18.1),(121383,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121383,38,0.46,398,53955,70,NULL,NULL,'2MASX J14303078+2334487',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000139,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.628333,23.58025,0.057,NULL,59499980451,929687194,14526362,17.4),(121384,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121384,38.01,0.11,400,53956,70,NULL,NULL,'2MASX J14303131+2521446',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00012,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.6305,25.36239,0.01,NULL,60020991507,937827992,14653562,18.1),(121385,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121385,39,0.46,630,53957,70,NULL,NULL,'SDSS J143031.55+101719.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000136,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.6315,10.28875,0.017,NULL,59359461498,927491585,14492056,18.8),(121386,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121386,38.16,0.46,428,53958,70,NULL,NULL,'2MASX J14303235+3253260',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.6347917,32.89056,0,NULL,60037838074,938091219,14657675,17.9),(121387,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121387,33.89,0.2,60,53959,74.4,NULL,NULL,'NGC 5648',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000004,NULL,'14.06',0.8,'S?','Possible field galaxy',NULL,NULL,NULL,1,217.635833,14.02306,0,NULL,59544719810,930386247,14537285,14.06),(121388,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121388,38.07,0.46,412,53960,70,NULL,NULL,'2MASX J14303329+4652151',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.6385417,46.87097,0.006,NULL,59227933570,925436462,14459944,17.8),(121389,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121389,38.01,0.11,400,53961,70,NULL,NULL,'2MASX J14303442+2533195',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.0001,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.643375,25.55531,0.019,NULL,60020854560,937825852,14653528,17.7),(121390,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121390,38.24,0.46,444,53962,70,NULL,NULL,'2MASX J14303483+1455457',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.645,14.92944,0,NULL,59476448989,929319515,14520617,17.9),(121391,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121391,37.44,0.33,308,53963,70,NULL,NULL,'2MASX J14303483+4215011',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000213,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,217.6452083,42.25025,0.015,NULL,59958938645,936858416,14638412,16.4),(121392,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121392,36.86,0.27,236,53964,70,NULL,NULL,'2MASX J14303597+4936257',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000173,NULL,'15.8g',0.5,'E0',NULL,NULL,NULL,NULL,1,217.649916667,49.60714,0.009,NULL,59201976741,925030886,14453607,15.8),(121393,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121393,38.12,0.46,422,53965,70,NULL,NULL,'2MASX J14303603+0131506',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.6502917,1.53058,0.109,NULL,58289947689,910780432,14230944,17.7),(121394,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121394,36.85,0.46,234,53966,70,NULL,NULL,'2MASX J14303856+2825102',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.660666667,28.41967,0,NULL,60022609859,937853279,14653957,17),(121395,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121395,38.45,0.23,489,53967,70,NULL,NULL,'SDSS J143038.63+602337.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.6609583,60.39367,0,NULL,57755202048,902425032,14100391,18.3),(121396,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121396,30.3,0.69,11.5,53968,100,NULL,'mid-IR','NGC 5645',NULL,'2013ApJ...771...88L',2013,1,2.64,NULL,'G',0.000005,NULL,'12.8g',1.04,'SB(s)d','Group member',NULL,NULL,NULL,1,217.6639583,7.27508,0.021,NULL,58280674303,910635535,14228680,12.8),(121397,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121397,30.85,0.43,14.8,53968,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5645',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121398,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121398,30.88,0.43,15,53968,75,NULL,'3.6 micron, color corrected','NGC 5645',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121399,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121399,30.9,0.2,15.1,53968,74.4,NULL,NULL,'NGC 5645',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121400,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121400,31.14,0.39,16.9,53968,NULL,NULL,NULL,'NGC 5645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121401,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121401,31.2,0.38,17.4,53968,NULL,NULL,'Malmquist cor.','NGC 5645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121402,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121402,31.73,NULL,22.2,53968,72,NULL,NULL,'NGC 5645',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121403,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121403,31.82,0.46,23.2,53968,NULL,NULL,'J','NGC 5645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121404,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121404,31.88,0.45,23.8,53968,NULL,NULL,'K','NGC 5645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121405,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121405,31.9,0.47,24,53968,NULL,NULL,'H','NGC 5645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121406,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121406,31.97,0.4,24.8,53968,75,NULL,'B','NGC 5645',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121407,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121407,32.01,0.4,25.3,53968,NULL,NULL,'mean','NGC 5645',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121408,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121408,38.01,0.11,400,53969,70,NULL,NULL,'2MASX J14303952+2538472',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.6647083,25.64653,0.019,NULL,60024321103,937880017,14654375,17.7),(121409,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121409,37.7,0.46,346,53970,70,NULL,NULL,'SDSS J143041.27+141358.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.671958333,14.23278,0,NULL,59544921597,930389399,14537334,17.3),(121410,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121410,35.02,0.23,101,53971,70,NULL,NULL,'2MASX J14304163+1159130',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000077,NULL,'15.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,217.673417,11.98703,0,NULL,59358402975,927475046,14491797,15.8),(121411,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121411,37.27,0.33,285,53972,70,NULL,NULL,'2MASX J14304169+2240108',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.87',0.21,'AGN',NULL,NULL,NULL,NULL,1,217.67375,22.66989,0.061,NULL,59498103914,929657873,14525904,17.87),(121412,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121412,37.43,0.46,306,53973,70,NULL,NULL,'2MASX J14304276+1828278',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.678083,18.47433,0,NULL,59481238116,929394345,14521786,17.6),(121413,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121413,37.42,0.23,305,53974,70,NULL,NULL,'2MASX J14304289+2303038',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.6787917,23.05119,0.055,NULL,59497871372,929654240,14525847,18),(121414,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121414,38.23,0.46,443,53975,70,NULL,NULL,'2MASX J14304289+0408196',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.678833333,4.13872,0.049,NULL,58316255903,911191498,14237367,17.8),(121415,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121415,37.44,0.33,308,53976,70,NULL,NULL,'2MASX J14304293+4216131',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.678833333,42.27019,0.015,NULL,59958937945,936858405,14638412,16.8),(121416,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121416,33.88,0.8,59.7,53977,75,NULL,'MAT, I','ESO 511- G 046',NULL,'1997ApJS..109..333W',1997,1,1.8,'Fairall, et al. (1992,AJ,103,11) give v=6989 +/- 80 km/sec.','G',0.000013,NULL,'15',1.4,'SA(r)dm',NULL,NULL,NULL,NULL,1,217.680333,-27.45419,0.289,NULL,47016032014,734625500,11478523,15),(121417,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121417,32.57,0.32,32.7,53977,85,NULL,'I, raw','ESO 511- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121418,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121418,32.57,0.32,32.7,53977,85,NULL,'I, inv','ESO 511- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121419,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121419,32.85,0.43,37.2,53977,75,NULL,'MAT, I, raw','ESO 511- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121420,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121420,32.92,0.43,38.4,53977,75,NULL,'MAT, I, inv','ESO 511- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121421,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121421,33.09,0.43,41.4,53977,75,NULL,'MAT, I, cor','ESO 511- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121422,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121422,33.27,0.2,45.1,53977,74.4,NULL,NULL,'ESO 511- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121423,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121423,33.54,0.59,51,53977,NULL,NULL,NULL,'ESO 511- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121424,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121424,33.72,0.54,55.5,53977,NULL,NULL,'Malmquist cor.','ESO 511- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121425,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121425,33.66,0.8,54,53978,75,NULL,'HMCL, I','NGC 5657',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00003,NULL,'14.05',0.8,'SBb:           Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'Starburst',1,217.681667,29.18083,0,NULL,60047805198,938246956,14660108,14.05),(121426,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121426,33.43,0.4,48.5,53978,75,NULL,'HMCL, I, raw','NGC 5657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121427,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121427,33.57,0.4,51.8,53978,75,NULL,'HMCL, I, inv','NGC 5657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121428,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121428,33.7,0.4,54.9,53978,75,NULL,'HMCL, I, cor','NGC 5657',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121429,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121429,33.99,0.4,62.7,53978,NULL,NULL,'mean','NGC 5657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121430,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121430,34.23,0.47,70.2,53978,NULL,NULL,'H','NGC 5657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121431,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121431,34.24,0.45,70.4,53978,NULL,NULL,'K','NGC 5657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121432,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121432,34.3,0.46,72.5,53978,NULL,NULL,'J','NGC 5657',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121433,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121433,37.91,0.46,383,53979,70,NULL,NULL,'SDSS J143045.59+432038.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.6899583,43.34411,0.016,NULL,59959525341,936867583,14638555,17.9),(121434,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121434,38.06,0.46,410,53980,70,NULL,NULL,'2MASX J14304680+3455064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.7g',0.17,'E/S0',NULL,NULL,NULL,NULL,1,217.695083,34.91844,0,NULL,60038955920,938108686,14657948,17.7),(121435,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121435,37.67,0.46,342,53981,70,NULL,NULL,'2MASX J14304785+2053219',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.86',0.21,NULL,NULL,NULL,NULL,NULL,1,217.6994583,20.88936,0.076,NULL,59510235440,929847428,14528866,17.86),(121436,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121436,38.06,0.46,408,53982,70,NULL,NULL,'SDSS J143048.18+485550.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.700833,48.93067,0.041,NULL,59199148727,924986698,14452917,18.4),(121437,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121437,37.7,0.46,346,53983,70,NULL,NULL,'2MASX J14304826+3456064',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'17.1g',0.23,'E/S0           LINER',NULL,NULL,NULL,NULL,1,217.701167,34.93503,0,NULL,60038958736,938108730,14657948,17.1),(121438,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121438,38.01,0.46,400,53984,70,NULL,NULL,'2MASX J14304833+3503354',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.2g',0.14,'E/S0',NULL,NULL,NULL,NULL,1,217.701333,35.05992,0,NULL,60038967839,938108872,14657951,18.2),(121439,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121439,37.34,0.46,294,53985,70,NULL,NULL,'2MASX J14305007+5515488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.7084583,55.26361,0,NULL,57258107752,894657933,13979030,17.2),(121440,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121440,36.16,0.2,171,53986,74.4,NULL,NULL,'CGCG 104-039',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000103,NULL,'15.3',0.4,NULL,NULL,NULL,NULL,NULL,1,217.710875,14.50319,0,NULL,59544837287,930388082,14537313,15.3),(121441,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121441,37.21,0.43,276,53986,75,NULL,'3.6 micron, color corrected','CGCG 104-039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121442,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121442,38.58,0.43,521,53986,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 104-039',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121443,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121443,38.19,0.27,435,53987,70,NULL,NULL,'2MASX J14305086+2438493',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.711917,24.64714,0.053,NULL,59496874336,929638661,14525604,17.3),(121444,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121444,36.35,0.16,186,53988,70,NULL,NULL,'2MASX J14305102+5354278',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000161,NULL,'15.5g',0.5,'AGN+SF',NULL,NULL,NULL,NULL,1,217.7127917,53.90778,0.013,NULL,59196505547,924945399,14452271,15.5),(121445,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121445,37.56,0.46,325,53989,70,NULL,NULL,'2MASX J14305138+2421073',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.714167,24.35225,0.081,NULL,59499680804,929682512,14526289,17.3),(121446,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121446,37.69,0.46,346,53990,70,NULL,NULL,'SDSS J143055.52+120644.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000138,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,217.731375,12.11242,0,NULL,59358424670,927475385,14491802,18.7),(121447,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121447,36.86,0.27,236,53991,70,NULL,NULL,'2MASX J14305554+4934088',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.731417,49.56919,0.009,NULL,59202036027,925031812,14453622,17.5),(121448,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121448,37.65,0.33,339,53992,70,NULL,NULL,'SDSS J143055.62+341428.1',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.7317917,34.24117,0,NULL,60041182482,938143476,14658491,16.7),(121449,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121449,38.53,0.46,508,53993,70,NULL,NULL,'SDSS J143056.29+262844.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.734583,26.479,0,NULL,60024571755,937883933,14654436,18.6),(121450,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121450,37.65,0.33,339,53994,70,NULL,NULL,'2MASX J14305649+3416334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.5g',0.19,'S0',NULL,NULL,NULL,NULL,1,217.7354583,34.27594,0,NULL,60041181828,938143466,14658491,17.5),(121451,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121451,38.45,0.23,489,53995,70,NULL,NULL,'SDSS J143057.82+602044.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.740917,60.34578,0,NULL,57755191970,902424874,14100388,18.3),(121452,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121452,35.32,0.46,116,53996,70,NULL,NULL,'2MASX J14305852+2856563',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000162,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,217.7437083,28.94889,0,NULL,60047759502,938246242,14660097,15.9),(121453,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121453,36.92,0.27,242,53997,70,NULL,NULL,'2MASX J14305967-0149232',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.74875,-1.82317,0.105,NULL,43514279675,679910619,10623603,17),(121454,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121454,37.38,0.46,299,53998,70,NULL,NULL,'2MASX J14310000+2322258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.7499583,23.37381,0.057,NULL,59497964691,929655698,14525870,17.5),(121455,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121455,36.86,0.46,236,53999,70,NULL,NULL,'2MASX J14310016+3544274',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,217.750875,35.741,0,NULL,60068822398,938575349,14665239,16.7),(121456,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121456,34.18,0.69,68.5,54000,100,NULL,'mid-IR','NGC 5650',NULL,'2013ApJ...771...88L',2013,1,2,'HOLM 656B is a star.','G',0.00002,NULL,'13.26',1.4,'SABbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.7545,5.97842,0.041,NULL,58302934794,910983356,14234114,13.26),(121457,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121457,34.84,0.47,92.7,54000,NULL,NULL,'H','NGC 5650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121458,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121458,34.92,0.46,96.4,54000,NULL,NULL,'J','NGC 5650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121459,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121459,35.02,0.45,101,54000,NULL,NULL,'K','NGC 5650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121460,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121460,35.14,0.4,106,54000,NULL,NULL,'mean','NGC 5650',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121461,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121461,35.13,0.2,106,54000,74.4,NULL,NULL,'NGC 5650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121462,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121462,35.15,0.41,107,54000,NULL,NULL,'Malmquist cor.','NGC 5650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121463,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121463,35.27,0.38,113,54000,NULL,NULL,NULL,'NGC 5650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121464,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121464,38.45,0.23,489,54001,70,NULL,NULL,'2MASX J14310131+6017364',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.755458333,60.2935,0,NULL,57751735307,902370864,14099544,18.2),(121465,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121465,36.18,0.33,172,54002,70,NULL,NULL,'2MASX J14310209+3607114',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,217.758666667,36.11981,0,NULL,60068880022,938576250,14665253,16),(121466,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121466,38.01,0.11,400,54003,70,NULL,NULL,'2MASX J14310252+2541263',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000097,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.760541667,25.69053,0.021,NULL,60024314462,937879913,14654373,17.7),(121467,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121467,37.99,0.33,397,54004,70,NULL,NULL,'2MASX J14310296+1907408',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,217.7625,19.12797,0.034,NULL,59511255687,929863370,14529115,17.8),(121468,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121468,36.37,0.46,188,54005,70,NULL,NULL,'2MASX J14310297+5532080',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000198,NULL,'15.4g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,217.762583,55.53556,0,NULL,57258198556,894659352,13979052,15.4),(121469,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121469,38.01,0.11,400,54006,70,NULL,NULL,'2MASX J14310510+2536443',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.771125,25.61231,0.019,NULL,60024376249,937880878,14654388,17.1),(121470,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121470,33.92,0.8,60.9,54007,75,NULL,'HMCL, I','NGC 5659',NULL,'1997ApJS..109..333W',1997,1,1.82,NULL,'G',0.00002,NULL,'14.2g',0.52,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,217.775583,25.35511,0.048,NULL,60020780041,937824688,14653510,14.2),(121471,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121471,33.69,0.4,54.8,54007,75,NULL,'HMCL, I, raw','NGC 5659',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121472,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121472,33.71,0.49,55.2,54007,75,NULL,'IR','NGC 5659',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121473,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121473,33.85,0.4,58.9,54007,75,NULL,'HMCL, I, inv','NGC 5659',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121474,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121474,33.93,0.47,61.1,54007,NULL,NULL,'H','NGC 5659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121475,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121475,33.94,0.2,61.4,54007,74.4,NULL,NULL,'NGC 5659',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121476,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121476,33.99,0.4,62.8,54007,75,NULL,'HMCL, I, cor','NGC 5659',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121477,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121477,34.04,0.46,64.1,54007,NULL,NULL,'J','NGC 5659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121478,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121478,34.07,0.25,65.1,54007,NULL,NULL,'Malmquist cor.','NGC 5659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121479,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121479,34.08,0.45,65.6,54007,NULL,NULL,'K','NGC 5659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121480,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121480,34.15,0.24,67.6,54007,NULL,NULL,NULL,'NGC 5659',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121481,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121481,34.19,0.4,68.9,54007,NULL,NULL,'mean','NGC 5659',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121482,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121482,35.68,0.46,137,54008,70,NULL,NULL,'2MASX J14310622+5110168',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.776083333,51.17144,0,NULL,59203122353,925048786,14453887,16.4),(121483,'BCG','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121483,38.2,0.35,406,54009,60,NULL,'ABELL 1927, BCG','2MASX J14310681+2538013',0.074,'1980ApJ...241..486H',1980,1,0.61,NULL,'G',0.000067,NULL,'16.70',0.29,'BrClG;cD','Brightest group member',NULL,NULL,NULL,1,217.778333,25.63369,0.019,NULL,60024375528,937880867,14654388,16.7),(121484,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121484,37.76,0.46,357,54010,70,NULL,NULL,'SDSS J143106.88+443217.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.7787917,44.53817,0.011,NULL,59955276692,936801198,14637518,18.6),(121485,'BCG','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121485,38.2,0.35,406,54011,60,NULL,NULL,'ABELL 1927',0.074,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000327,NULL,NULL,NULL,'I-II:  [BM]',NULL,NULL,NULL,NULL,1,217.779583,25.63889,0.019,NULL,60024375359,937880864,14654388,NULL),(121486,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121486,38.07,0.21,412,54012,70,NULL,NULL,'2MASX J14310744+5721030',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.781333,57.35089,0,NULL,57251400426,894553131,13977392,17.7),(121487,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121487,38.18,0.46,432,54013,70,NULL,NULL,'SDSS J143108.31+182641.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.784625,18.44475,0,NULL,59481243698,929394432,14521788,17.9),(121488,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121488,38.16,0.27,428,54014,70,NULL,NULL,'2MASX J14310908+2256492',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.18',0.19,NULL,NULL,NULL,NULL,NULL,1,217.7877917,22.94708,0.05,NULL,59498150903,929658607,14525915,18.18),(121489,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121489,38.01,0.11,400,54015,70,NULL,NULL,'2MASX J14310926+2539532',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.788667,25.66472,0.021,NULL,60024382611,937880978,14654390,17.6),(121490,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121490,38.19,0.21,435,54016,70,NULL,NULL,'2MASX J14311011+4229501',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.791917,42.49733,0.015,NULL,59959123143,936861299,14638457,17.9),(121491,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121491,38.19,0.21,435,54017,70,NULL,NULL,'2MASX J14311056+4234247',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.793875,42.57353,0,NULL,59959120081,936861251,14638457,18.3),(121492,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121492,36.11,0.46,167,54018,70,NULL,NULL,'2MASX J14311063+1431091',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.88',0.27,NULL,NULL,NULL,NULL,NULL,1,217.79425,14.51931,0,NULL,59544842549,930388164,14537315,16.88),(121493,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121493,38.01,0.11,400,54019,70,NULL,NULL,'2MASX J14311062+2530342',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000067,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.794417,25.50947,0.048,NULL,60024196551,937878071,14654344,17.7),(121494,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121494,38.19,0.21,435,54020,70,NULL,NULL,'SDSS J143110.76+423601.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.794875,42.60028,0.047,NULL,59959001123,936859392,14638428,18.3),(121495,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121495,35.3,0.34,115,54021,NULL,NULL,'Malmquist cor.','UGC 09338',NULL,'2009ApJS..182..474S',2009,1,1.16,NULL,'G',0.000033,NULL,'15.1g',0.41,'Sb',NULL,NULL,NULL,NULL,1,217.7987083,5.30733,0.041,NULL,58315386293,911177910,14237154,15.1),(121496,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121496,35.37,0.2,119,54021,74.4,NULL,NULL,'UGC 09338',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121497,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121497,35.41,0.32,121,54021,NULL,NULL,NULL,'UGC 09338',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121498,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121498,35.95,0.46,155,54022,70,NULL,NULL,'MCG +06-32-055',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000178,NULL,'15.3g',0.6,'E/S0',NULL,NULL,NULL,NULL,1,217.803083,35.33197,0,NULL,60069131503,938580179,14665315,15.3),(121499,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121499,37.53,0.46,321,54023,70,NULL,NULL,'2MASX J14311463+3550173',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,217.811,35.83803,0,NULL,60068924377,938576943,14665264,16.6),(121500,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121500,38.16,0.27,428,54024,70,NULL,NULL,'2MASX J14311523+2258482',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.813417,22.97994,0.05,NULL,59498138780,929658418,14525912,17.8),(121501,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121501,38.16,0.27,428,54025,70,NULL,NULL,'2MASX J14311522+2302282',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.813458333,23.04108,0.055,NULL,59498135677,929658369,14525912,17.5),(121502,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121502,38.2,0.46,436,54026,70,NULL,NULL,'2MASX J14311534+1031016',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.814041667,10.51706,0.021,NULL,59359583984,927493499,14492085,17.6),(121503,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121503,37.99,0.33,397,54027,70,NULL,NULL,'2MASX J14311609+1904112',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.8169583,19.06981,0.019,NULL,59511245803,929863215,14529112,18.1),(121504,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121504,38.07,0.21,412,54028,70,NULL,NULL,'SDSS J143116.11+572041.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.8172083,57.34481,0,NULL,57251411851,894553310,13977395,17.9),(121505,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121505,38.45,0.23,489,54029,70,NULL,NULL,'SDSS J143116.60+602354.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,217.819208333,60.39853,0,NULL,57755257074,902425891,14100404,18.6),(121506,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121506,38.19,0.21,435,54030,70,NULL,NULL,'2MASX J14311697+4241307',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.820708333,42.69183,0.047,NULL,59958974378,936858974,14638421,18),(121507,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121507,38.19,0.21,435,54031,70,NULL,NULL,'2MASX J14311699+4235357',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.4g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,217.82075,42.59322,0,NULL,59959001205,936859393,14638428,17.4),(121508,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121508,37.26,0.33,284,54032,70,NULL,NULL,'2MASX J14311741+1742572',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.8224583,17.71581,0,NULL,59483430674,929428604,14522321,17.6),(121509,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121509,35.04,0.35,102,54033,NULL,NULL,NULL,'UGC 09339',NULL,'2009ApJS..182..474S',2009,1,0.99,NULL,'G',0.000033,NULL,'14.6g',0.49,'S?',NULL,NULL,NULL,NULL,1,217.824917,7.94464,0.037,NULL,58283755717,910683683,14229432,14.6),(121510,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121510,35.08,0.2,104,54033,74.4,NULL,NULL,'UGC 09339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121511,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121511,35.09,0.34,104,54033,NULL,NULL,'Malmquist cor.','UGC 09339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121512,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121512,35.36,0.4,118,54033,NULL,NULL,'mean','UGC 09339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121513,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121513,35.45,0.47,123,54033,NULL,NULL,'H','UGC 09339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121514,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121514,35.57,0.45,130,54033,NULL,NULL,'K','UGC 09339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121515,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121515,36.74,0.46,223,54034,70,NULL,NULL,'2MASX J14311873+1340452',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.21',0.16,NULL,NULL,NULL,NULL,NULL,1,217.828,13.67933,0,NULL,59545971661,930405807,14537590,18.21),(121516,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121516,35.43,0.46,122,54035,70,NULL,NULL,'CGCG 047-074',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.00006,NULL,'14.9g',0.41,'S0/a',NULL,NULL,NULL,NULL,1,217.828291667,3.50717,0.049,NULL,58316517770,911195590,14237431,14.9),(121517,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121517,37.26,0.33,284,54036,70,NULL,NULL,'SDSS J143120.05+174232.9',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.833583,17.70917,0,NULL,59483430622,929428603,14522321,16.9),(121518,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121518,36.92,0.27,242,54037,70,NULL,NULL,'SDSS J143120.11-014503.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.833833,-1.75092,0.105,NULL,43514322033,679911281,10623613,17),(121519,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121519,38.16,0.46,429,54038,70,NULL,NULL,'2MASX J14312078+1835482',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.836833,18.59683,0,NULL,59481025073,929391016,14521734,18.1),(121520,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121520,38.19,0.27,435,54039,70,NULL,NULL,'2MASX J14312098+2441523',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.8372917,24.69794,0.07,NULL,59499630379,929681724,14526276,17.4),(121521,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121521,35.7,0.46,138,54040,70,NULL,NULL,'SDSS J143121.04+213203.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.8377083,21.53431,0.125,NULL,59523500367,930054693,14532104,16.2),(121522,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121522,38.01,0.11,400,54041,70,NULL,NULL,'SDSS J143121.37+254820.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.8390417,25.80583,0.021,NULL,60024333307,937880207,14654378,18.6),(121523,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121523,38.01,0.11,400,54042,70,NULL,NULL,'2MASX J14312139+2556483',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.83925,25.94675,0.021,NULL,60024339089,937880298,14654379,17.9),(121524,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121524,38.16,0.46,428,54043,70,NULL,NULL,'SDSS J143121.82+605648.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.841,60.94669,0.013,NULL,57752748333,902386692,14099792,17.8),(121525,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121525,37.54,0.46,322,54044,70,NULL,NULL,'2MASX J14312187+2358033',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.8410417,23.96772,0.093,NULL,59500165274,929690082,14526407,17.3),(121526,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121526,36.18,0.46,173,54045,70,NULL,NULL,'2MASX J14312186+2812033',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.8412083,28.20097,0,NULL,60022842556,937856914,14654014,16.6),(121527,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121527,37.85,0.33,371,54046,70,NULL,NULL,'2MASX J14312201-0139501',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,217.841625,-1.66386,0.101,NULL,43514304856,679911013,10623609,17.5),(121528,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121528,34.71,0.8,87.3,54047,75,NULL,'MAT, I','ESO 447- G 017',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'14.02',0.6,'SA(s)bc',NULL,NULL,NULL,NULL,1,217.84375,-28.74961,0.321,NULL,47022357623,734724337,11480067,14.02),(121529,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121529,34.32,0.47,73.3,54047,NULL,NULL,'H','ESO 447- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121530,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121530,34.36,0.46,74.5,54047,NULL,NULL,'J','ESO 447- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121531,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121531,34.41,0.45,76.2,54047,NULL,NULL,'K','ESO 447- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121532,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121532,34.43,0.43,76.8,54047,75,NULL,'MAT, I, raw','ESO 447- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121533,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121533,34.47,0.32,78.3,54047,85,NULL,'I, raw','ESO 447- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121534,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121534,34.55,0.32,81.4,54047,85,NULL,'I, inv','ESO 447- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121535,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121535,34.57,0.49,82,54047,NULL,NULL,'Malmquist cor.','ESO 447- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121536,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121536,34.72,0.43,88,54047,75,NULL,'MAT, I, cor','ESO 447- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121537,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121537,34.77,0.43,90.1,54047,75,NULL,'MAT, I, inv','ESO 447- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121538,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121538,34.79,0.4,90.8,54047,NULL,NULL,'mean','ESO 447- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121539,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121539,34.81,0.43,91.7,54047,NULL,NULL,NULL,'ESO 447- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121540,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121540,34.94,0.2,97.3,54047,74.4,NULL,NULL,'ESO 447- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121541,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121541,34.73,0.63,88.3,54048,70,NULL,NULL,'2MASX J14312433-0808456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,217.8514583,-8.14622,0.129,NULL,43535148426,680236694,10628698,15.95),(121542,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121542,36.94,0.46,244,54049,70,NULL,NULL,'2MASX J14312482+6419226',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000111,NULL,'17.0g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,217.853667,64.32303,0.049,NULL,57939039049,905297485,14145273,17),(121543,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121543,38.01,0.11,400,54050,70,NULL,NULL,'2MASX J14312509+2551553',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'16.6g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,217.8547083,25.86547,0.021,NULL,60024334116,937880220,14654378,16.6),(121544,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121544,35.51,0.61,126,54051,NULL,NULL,'Malmquist cor.','ESO 447- G 016',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.16',0.4,'S...',NULL,NULL,NULL,NULL,1,217.855583,-32.41622,0.257,NULL,47027299494,734801554,11481274,16.16),(121545,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121545,35.59,0.59,131,54051,NULL,NULL,NULL,'ESO 447- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121546,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121546,35.63,0.2,134,54051,74.4,NULL,NULL,'ESO 447- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121547,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121547,34.26,0.2,71.1,54052,74.4,NULL,NULL,'KUG 1429+334',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000111,NULL,'14.7g',0.42,'Spiral         Sbrst',NULL,NULL,NULL,NULL,1,217.855667,33.23053,0,NULL,60037984339,938093505,14657711,14.7),(121548,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121548,37.56,0.33,324,54053,70,NULL,NULL,'2MASX J14312560+6230356',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.856625,62.51003,0.025,NULL,57763475335,902554302,14102410,17),(121549,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121549,36.88,0.46,237,54054,70,NULL,NULL,'2MASXi J1431269+241146',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.862458333,24.19608,0.074,NULL,59500173227,929690206,14526409,17.5),(121550,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121550,31.77,NULL,22.6,54055,72,NULL,NULL,'IC 1024',NULL,'2014Ap.....57..457K',2014,1,1.6,NULL,'G',0.000017,NULL,'13.87',0.6,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.863333,3.00908,0.053,NULL,58307251667,911050807,14235168,13.87),(121551,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121551,36.95,0.46,246,54056,70,NULL,NULL,'2MASX J14312731+0015187',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000095,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,217.8637917,0.25514,0.093,NULL,58291706732,910807917,14231373,16.3),(121552,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121552,35.53,0.46,128,54057,70,NULL,NULL,'CGCG 220-026',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000063,NULL,'14.7g',0.47,'SB0',NULL,NULL,NULL,NULL,1,217.865625,39.25925,0,NULL,60065347696,938521057,14664391,14.7),(121553,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121553,38.01,0.11,400,54058,70,NULL,NULL,'2MASX J14312894+2534383',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000067,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,217.870666667,25.57719,0.053,NULL,60024388014,937881062,14654391,16.8),(121554,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121554,37.27,0.46,284,54059,70,NULL,NULL,'2MASX J14312909+3714360',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.871167,37.24344,0,NULL,60078002792,938718793,14667481,18),(121555,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121555,36.46,0.46,196,54060,70,NULL,NULL,'2MASX J14312905+1635062',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000057,NULL,'16.64',0.29,NULL,NULL,NULL,NULL,NULL,1,217.8712083,16.58519,0,NULL,59482142525,929408476,14522007,16.64),(121556,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121556,34.91,0.8,95.8,54061,75,NULL,'MAT, I','ESO 579- G 025',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00001,NULL,'15',1.2,'Sb',NULL,NULL,NULL,NULL,1,217.873791667,-22.36717,0.337,NULL,46533817730,727090902,11360795,15),(121557,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121557,34.38,0.32,75.1,54061,85,NULL,'I, raw','ESO 579- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121558,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121558,34.41,0.32,76.3,54061,85,NULL,'I, inv','ESO 579- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121559,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121559,34.45,0.43,77.5,54061,75,NULL,'MAT, I, raw','ESO 579- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121560,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121560,34.62,0.43,83.8,54061,75,NULL,'MAT, I, inv','ESO 579- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121561,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121561,34.81,0.43,91.5,54061,NULL,NULL,'Malmquist cor.','ESO 579- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121562,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121562,34.85,0.43,93.2,54061,75,NULL,'MAT, I, cor','ESO 579- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121563,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121563,34.89,0.41,95,54061,NULL,NULL,NULL,'ESO 579- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121564,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121564,34.91,0.2,95.9,54061,74.4,NULL,NULL,'ESO 579- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121565,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121565,38.01,0.11,400,54062,70,NULL,NULL,'2MASX J14313019+2533253',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.8757083,25.55714,0.048,NULL,60024379579,937880930,14654389,17.9),(121566,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121566,38.32,0.15,462,54063,70,NULL,NULL,'2MASX J14313023+2001173',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.8760417,20.02156,0.047,NULL,59512107420,929876678,14529323,17.5),(121567,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121567,37.27,0.33,285,54064,70,NULL,NULL,'2MASX J14313059+2230543',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.16',0.21,NULL,NULL,NULL,NULL,NULL,1,217.877583,22.51519,0.054,NULL,59497434121,929647408,14525740,17.16),(121568,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121568,32.63,0.8,33.5,54065,75,NULL,'A82, H','NGC 5673',NULL,'1997ApJS..109..333W',1997,1,2.57,NULL,'G',0.000023,NULL,'14.0g',0.54,'SBc? sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,217.8787917,49.95872,0,NULL,59202471514,925038617,14453728,14),(121569,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121569,32.21,0.4,27.7,54065,75,NULL,NULL,'NGC 5673',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121570,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121570,32.72,0.2,35,54065,74.4,NULL,NULL,'NGC 5673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121571,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121571,32.83,0.43,36.8,54065,75,NULL,'3.6 micron, color corrected','NGC 5673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121572,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121572,32.88,0.38,37.7,54065,NULL,NULL,NULL,'NGC 5673',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121573,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121573,32.92,0.43,38.4,54065,NULL,NULL,NULL,'NGC 5673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121574,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121574,32.94,0.43,38.7,54065,NULL,NULL,'Malmquist cor.','NGC 5673',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121575,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121575,33,0.43,39.8,54065,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5673',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121576,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121576,33.04,0.49,40.6,54065,75,NULL,'IR','NGC 5673',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121577,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121577,33.08,0.47,41.2,54065,75,NULL,'A82, H, raw','NGC 5673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121578,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121578,33.08,0.47,41.3,54065,75,NULL,'A82, H, inv','NGC 5673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121579,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121579,33.21,0.47,43.9,54065,75,NULL,'A82, H, cor','NGC 5673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121580,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121580,37.56,0.33,324,54066,70,NULL,NULL,'2MASX J14313149+6234227',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,217.881083333,62.57306,0.025,NULL,57763493157,902554580,14102415,17.3),(121581,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121581,37.39,0.46,300,54067,70,NULL,NULL,'2MASX J14313312+1212473',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.888,12.21322,0,NULL,59358331348,927473927,14491780,18.2),(121582,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121582,37.48,0.46,313,54068,70,NULL,NULL,'2MASX J14313438+1017159',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.893416667,10.28781,0.017,NULL,59359478616,927491853,14492060,17.3),(121583,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121583,38.47,0.46,494,54069,70,NULL,NULL,'2MASX J14313472+2230171',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,217.8947917,22.50467,0.054,NULL,59497434306,929647411,14525740,16.8),(121584,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121584,38.37,0.46,471,54070,70,NULL,NULL,'2MASX J14313481+3306185',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.7g',0.2,'E/S0',NULL,NULL,NULL,NULL,1,217.895,33.10511,0,NULL,60037975655,938093369,14657708,17.7),(121585,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121585,36.99,0.46,250,54071,70,NULL,NULL,'2MASX J14313552+1649030',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,217.8980417,16.81769,0,NULL,59482222181,929409721,14522026,18.48),(121586,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121586,38.41,0.46,480,54072,70,NULL,NULL,'SDSS J143136.63+025056.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.902625,2.84917,0.061,NULL,58308028780,911062949,14235358,18.5),(121587,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121587,38.62,0.46,530,54073,70,NULL,NULL,'SDSS J143137.00+580159.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,217.90425,58.03308,0.009,NULL,57248718530,894511227,13976737,18.5),(121588,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121588,37.87,0.46,375,54074,70,NULL,NULL,'2MASX J14313818+2615432',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000215,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.909125,26.26206,0,NULL,60024670120,937885470,14654460,16.4),(121589,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121589,34.93,0.46,96.9,54075,70,NULL,NULL,'VIII Zw 429',NULL,'2015arXiv151105856S',2015,1,0.38,'VIII Zw -5\' Dec error.','G',0.000161,NULL,'16.2g',0.3,'E0',NULL,NULL,NULL,NULL,1,217.910375,-1.35133,0.101,NULL,43515339549,679927180,10623862,16.2),(121590,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121590,36.15,NULL,170,54076,NULL,NULL,NULL,'FGC 1764',NULL,'2000BSAO...50....5K',2000,1,0.92,NULL,'G',0.000067,NULL,'16.8g',0.13,'Sc',NULL,NULL,NULL,NULL,1,217.910583,52.74944,0.009,NULL,59205060525,925079070,14454360,16.8),(121591,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121591,36.36,NULL,187,54076,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121592,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121592,36.38,NULL,189,54076,NULL,NULL,'Dipole + Quadrupole','FGC 1764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121593,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121593,36.42,NULL,192,54076,NULL,NULL,'Dipole','FGC 1764',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121594,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121594,30.64,0.45,13.5,54077,NULL,NULL,'K','IC 4441',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000018,NULL,'12.00',1.4,'(R\')SA:(s)bc',NULL,NULL,NULL,NULL,1,217.910917,-43.41844,0.433,NULL,47091988129,735812314,11497067,12),(121595,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121595,30.66,0.47,13.6,54077,NULL,NULL,'H','IC 4441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121596,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121596,30.68,0.46,13.7,54077,NULL,NULL,'J','IC 4441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121597,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121597,31.77,0.4,22.6,54077,NULL,NULL,'mean','IC 4441',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121598,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121598,32.15,0.4,26.9,54077,75,NULL,'B','IC 4441',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121599,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121599,37.74,0.33,354,54078,70,NULL,NULL,'2MASX J14313892+4400187',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000186,NULL,'16.5g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,217.9120417,44.00528,0.026,NULL,59954867966,936794811,14637418,16.5),(121600,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121600,35.27,0.46,113,54079,70,NULL,NULL,'2MASX J14313915-2109189',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.18',NULL,NULL,NULL,NULL,NULL,NULL,1,217.9130417,-21.15522,0.329,NULL,46559058094,727485282,11366957,15.18),(121601,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121601,38.09,0.46,415,54080,70,NULL,NULL,'SDSS J143140.54+253923.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.9189583,25.65661,0.021,NULL,60024383501,937880992,14654390,18.8),(121602,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'RN',121602,43.07,1.24,2120,54081,NULL,NULL,NULL,'GRB 080319B HOST',0.937,'2010JCAP...08..020W',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121603,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'N',121603,43.07,NULL,4110,54081,NULL,NULL,NULL,'GRB 080319B HOST',NULL,'2011MNRAS.410.1611C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121604,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'N',121604,43.09,NULL,4150,54081,NULL,NULL,NULL,'GRB 080319B HOST',NULL,'2011MNRAS.410.1611C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121605,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'RN',121605,43.82,0.08,5810,54081,NULL,NULL,NULL,'GRB 080319B HOST',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121606,'GRB','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'RN',121606,45.36,0.17,11800,54081,NULL,NULL,NULL,'GRB 080319B HOST',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121607,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121607,37.85,0.33,371,54082,70,NULL,NULL,'2MASX J14314093-0129526',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,217.9205,-1.49803,0.101,NULL,43515331148,679927049,10623860,16.9),(121608,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121608,35.72,0.46,139,54083,70,NULL,NULL,'2MASX J14314130+2841033',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000157,NULL,'16.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.922208333,28.68414,0,NULL,60024689874,937885779,14654465,16.3),(121609,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121609,38.22,0.46,440,54084,70,NULL,NULL,'2MASX J14314312+2626463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,217.9295417,26.44639,0,NULL,60024676518,937885570,14654462,17.6),(121610,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121610,37.03,0.84,255,54085,70,NULL,NULL,'2MASX J14314339-0114196',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000116,NULL,'16.3g',0.21,'Sab',NULL,NULL,NULL,NULL,1,217.93075,-1.23881,0.101,NULL,43515327055,679926985,10623859,16.3),(121611,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121611,38.33,0.33,464,54086,70,NULL,NULL,'2MASX J14314352+5635229',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.931333333,56.58981,0,NULL,57259901464,894685960,13979468,17.8),(121612,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121612,37.57,0.46,326,54087,70,NULL,NULL,'2MASX J14314355+3535555',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000194,NULL,'16.6g',0.3,'E/S0',NULL,NULL,NULL,NULL,1,217.931417,35.59889,0,NULL,60069680351,938588755,14665449,16.6),(121613,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121613,36.62,0.46,210,54088,70,NULL,NULL,'2MASX J14314407+1236400',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.9337917,12.61111,0.019,NULL,59542838293,930356848,14536825,16.8),(121614,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121614,33.85,NULL,58.9,54089,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09345',NULL,'2010Ap&SS.325..163P',2010,1,1.43,NULL,'G',0.000053,NULL,'15.5g',0.27,'Scd','Group member',NULL,NULL,NULL,1,217.934041667,6.15814,0.045,NULL,58277764964,910590077,14227969,15.5),(121615,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121615,33.87,NULL,59.3,54089,NULL,NULL,'Dipole + Quadrupole','UGC 09345',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121616,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121616,33.87,NULL,59.4,54089,NULL,NULL,'Dipole','UGC 09345',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121617,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121617,34.1,0.43,66.2,54089,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09345',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121618,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121618,37.84,0.46,369,54090,70,NULL,NULL,'2MASX J14314433+2123022',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.83',0.15,NULL,NULL,NULL,NULL,NULL,1,217.93475,21.38406,0.125,NULL,59510064378,929844755,14528824,18.83),(121619,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121619,37.8,0.46,362,54091,70,NULL,NULL,'SDSS J143144.39+203558.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.935,20.59947,0.07,NULL,59510654568,929853977,14528968,18.5),(121620,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121620,37.33,0.46,292,54092,70,NULL,NULL,'SDSS J143145.05+332931.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.93775,33.492,0.115,NULL,60038056346,938094630,14657728,18.2),(121621,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121621,37.4,0.46,302,54093,70,NULL,NULL,'2MASX J14314517+0917279',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,217.938333,9.29119,0.057,NULL,58269521510,910461273,14225957,17.2),(121622,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121622,37.65,0.46,338,54094,70,NULL,NULL,'2MASX J14314524+1608520',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,217.938417,16.14761,0,NULL,59481712777,929401762,14521902,17.8),(121623,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121623,38.32,0.15,462,54095,70,NULL,NULL,'2MASX J14314564+2000362',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.12',0.19,'BrClG',NULL,NULL,NULL,NULL,1,217.9402083,20.01019,0.047,NULL,59512101384,929876584,14529321,18.12),(121624,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121624,38.13,0.33,422,54096,70,NULL,NULL,'2MASX J14314624+6222567',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,217.942417,62.38242,0.025,NULL,57763577976,902555905,14102436,17.9),(121625,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121625,34.9,0.46,95.7,54097,70,NULL,NULL,'2MASX J14314788+2822204',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000167,NULL,'15.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,217.9495417,28.37242,0,NULL,60022623623,937853494,14653960,15.4),(121626,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121626,37.34,0.33,294,54098,70,NULL,NULL,'2MASX J14314877+2115132',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.68',0.2,NULL,NULL,NULL,NULL,NULL,1,217.953125,21.25369,0.091,NULL,59509948902,929842951,14528796,17.68),(121627,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121627,38.05,0.27,408,54099,70,NULL,NULL,'LCRS B142913.4-025250',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,217.955125,-3.10111,0.209,NULL,43551110501,680486101,10632595,18),(121628,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121628,37.12,0.46,266,54100,70,NULL,NULL,'2MASX J14314932+0637259',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000084,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,217.955541667,6.62378,0.069,NULL,58277916085,910592438,14228006,18),(121629,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121629,37.34,0.46,293,54101,70,NULL,NULL,'2MASX J14315038+5454520',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000153,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.9600417,54.91447,0,NULL,57257653874,894650841,13978919,16.8),(121630,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121630,37.92,0.23,384,54102,70,NULL,NULL,'SDSS J143151.63+260707.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00014,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,217.965125,26.11878,0,NULL,60024653106,937885204,14654456,18.6),(121631,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121631,38.19,0.27,435,54103,70,NULL,NULL,'SDSS J143151.82+243816.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,217.965958333,24.63781,0.07,NULL,59499850909,929685170,14526330,18.4),(121632,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121632,38.05,0.27,408,54104,70,NULL,NULL,'LCRS B142916.0-025425',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.4g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,217.9660417,-3.12761,0.209,NULL,43551109760,680486090,10632595,16.4),(121633,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121633,38.11,0.46,418,54105,70,NULL,NULL,'2MASX J14315206+0421227',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000066,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,217.967083,4.35628,0.049,NULL,58316811551,911200180,14237502,17.5),(121634,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121634,33.58,0.2,52,54106,74.4,NULL,NULL,'CGCG 075-061',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.00013,NULL,'15.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,217.968666667,8.933,0.037,NULL,58280997684,910640588,14228759,15.4),(121635,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121635,36.66,0.46,215,54107,70,NULL,NULL,'2MASX J14315414+4616131',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000159,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,217.975417,46.27028,0,NULL,59953786717,936777917,14637154,16.3),(121636,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121636,36.22,0.46,175,54108,70,NULL,NULL,'CGCG 104-041',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'15.5',0.32,NULL,NULL,NULL,NULL,NULL,1,217.985833,16.77097,0,NULL,59482225156,929409768,14522027,15.5),(121637,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121637,33.21,0.4,43.9,54109,NULL,NULL,NULL,'NGC 5661',NULL,'2009AJ....138..323T',2009,1,1.46,NULL,'G',0.000007,NULL,'14.2g',0.53,'SBb:','Group member',NULL,NULL,NULL,1,217.989125,6.25042,0.045,NULL,58277808846,910590763,14227980,14.2),(121638,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121638,33.39,0.72,47.7,54109,NULL,NULL,NULL,'NGC 5661',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121639,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121639,33.43,0.2,48.5,54109,74.4,NULL,NULL,'NGC 5661',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121640,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121640,33.67,0.63,54.1,54109,NULL,NULL,'Malmquist cor.','NGC 5661',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121641,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121641,38.05,0.27,408,54110,70,NULL,NULL,'LCRS B142922.0-024923',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,217.990667,-3.04358,0.205,NULL,43546712257,680417379,10631521,17.3),(121642,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121642,38.77,0.46,568,54111,70,NULL,NULL,'2MASX J14315889+2228042',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,217.995167,22.46786,0.054,NULL,59497504990,929648515,14525758,18),(121643,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121643,33.04,0.8,40.6,54112,75,NULL,NULL,'ESO 175- G 009',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000023,NULL,'15.44',1.2,'Dwarf spiral',NULL,NULL,NULL,NULL,1,217.9954583,-55.46664,NULL,NULL,44710017243,698594019,10915531,15.44),(121644,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121644,37.34,0.33,294,54113,70,NULL,NULL,'2MASX J14315915+2116232',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,217.996417,21.27319,0.091,NULL,59509940264,929842816,14528794,NULL),(121645,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121645,38.32,0.15,462,54114,70,NULL,NULL,'2MASX J14320018+1954032',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.000875,19.90097,0.047,NULL,59512800745,929887511,14529492,NULL),(121646,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121646,36.64,0.46,213,54115,70,NULL,NULL,'2MASX J14320291+0719546',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'16.7g',0.31,'AGN',NULL,NULL,NULL,NULL,1,218.012167,7.33175,0.029,NULL,58280151384,910627365,14228552,16.7),(121647,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121647,35.27,0.59,113,54116,70,NULL,NULL,'LCRS B142924.9-060137',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.07',0.4,NULL,NULL,NULL,NULL,NULL,1,218.012833,-6.24747,0.145,NULL,43525391971,680084249,10626316,16.07),(121648,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121648,38.35,0.46,468,54117,70,NULL,NULL,'2MASX J14320347+3516234',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.5g',0.22,'E/S0',NULL,NULL,NULL,NULL,1,218.014625,35.27319,0,NULL,60069174054,938580844,14665325,17.5),(121649,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121649,37.73,0.46,351,54118,70,NULL,NULL,'2MASX J14320353+0400366',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0001,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,218.01475,4.01003,0.053,NULL,58316625037,911197266,14237457,16.6),(121650,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121650,38.22,0.46,441,54119,70,NULL,NULL,'2MASX J14320432-0018589',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.018,-0.31617,0.073,NULL,43515414522,679928351,10623880,17.6),(121651,'Sosies','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121651,32.26,0.13,28.3,54120,NULL,NULL,NULL,'NGC 5678',NULL,'2002A&A...393...57T',2002,1,1.34,'The 2MASS position is 6 arcsec northwest of the optical nucleus.','G',0.00001,NULL,'12.6g',1.19,'SAB(rs)b       LINER','Parent (of companion) galaxy',NULL,NULL,NULL,1,218.023375,57.92144,0.017,NULL,57251593565,894556149,13977439,12.6),(121652,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121652,32.76,0.8,35.6,54120,75,NULL,'B','NGC 5678',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121653,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121653,31.94,0.47,24.5,54120,NULL,NULL,'H','NGC 5678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121654,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121654,31.96,0.45,24.6,54120,NULL,NULL,'K','NGC 5678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121655,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121655,31.96,0.46,24.7,54120,NULL,NULL,'J','NGC 5678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121656,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121656,32.17,0.4,27.1,54120,NULL,NULL,'mean','NGC 5678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121657,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121657,32.33,0.4,29.2,54120,NULL,NULL,NULL,'NGC 5678',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121658,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121658,32.51,NULL,31.8,54120,NULL,NULL,'LEDA [April 2006]','NGC 5678',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121659,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121659,32.64,0.43,33.7,54120,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5678',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121660,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121660,32.68,0.43,34.3,54120,75,NULL,'3.6 micron, color corrected','NGC 5678',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121661,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121661,32.73,0.36,35.1,54120,NULL,NULL,'Malmquist cor.','NGC 5678',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121662,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121662,32.76,0.2,35.7,54120,74.4,NULL,NULL,'NGC 5678',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121663,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121663,32.79,0.35,36.1,54120,NULL,NULL,NULL,'NGC 5678',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121664,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121664,37.36,0.46,297,54121,70,NULL,NULL,'2MASX J14320578+1951135',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.25',0.16,'BrClG',NULL,NULL,NULL,NULL,1,218.0240417,19.85372,0.047,NULL,59512916219,929889315,14529520,18.25),(121665,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121665,36.85,0.46,235,54122,70,NULL,NULL,'2MASX J14320592+0651586',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.97',0.26,NULL,NULL,NULL,NULL,NULL,1,218.024625,6.86631,0.065,NULL,58278611309,910603301,14228176,16.97),(121666,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121666,37.57,0.46,327,54123,70,NULL,NULL,'2MASX J14320619+3231274',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.4g',0.31,'S0',NULL,NULL,NULL,NULL,1,218.02575,32.52419,0,NULL,60046068936,938219827,14659684,16.4),(121667,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121667,37.92,0.23,384,54124,70,NULL,NULL,'2MASX J14320693+2604224',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.028875,26.07289,0.012,NULL,60024523073,937883173,14654424,17.2),(121668,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121668,36.92,0.33,243,54125,70,NULL,NULL,'2MASX J14320705+1933545',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.74',0.22,NULL,NULL,NULL,NULL,NULL,1,218.029458333,19.56508,0.037,NULL,59512870352,929888599,14529509,17.74),(121669,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121669,36.01,0.46,159,54126,70,NULL,NULL,'2MASX J14320736+3320344',NULL,'2015arXiv151105856S',2015,1,0.43,'Jangren et al. (2005AJ....130.2571J) give z=0.0701 +/- 0.0028.','G',0.000177,NULL,'16.3g',0.34,'S',NULL,NULL,NULL,NULL,1,218.030833,33.343,0.115,NULL,60038061671,938094713,14657729,16.3),(121670,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121670,38.7,0.33,548,54127,70,NULL,NULL,'2MASX J14320762+4707362',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.031625,47.12661,0.025,NULL,59227807752,925434496,14459914,17.8),(121671,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121671,38.33,0.33,464,54128,70,NULL,NULL,'2MASX J14320761+5637051',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.0317917,56.61822,0,NULL,57259902553,894685977,13979468,17.5),(121672,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121672,37.92,0.23,384,54129,70,NULL,NULL,'2MASX J14320767+2600364',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000133,NULL,'17.75',0.23,NULL,NULL,NULL,NULL,NULL,1,218.031917,26.01025,0.012,NULL,60024242703,937878792,14654356,17.75),(121673,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121673,37.58,0.33,329,54130,70,NULL,NULL,'2MASX J14320800+0457036',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000102,NULL,'17.5g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,218.033333,4.95086,0.053,NULL,58315285572,911176337,14237130,17.5),(121674,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121674,37.3,0.46,289,54131,70,NULL,NULL,'2MASX J14320834+2714224',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000194,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,218.0347083,27.23958,0.021,NULL,60023282944,937863796,14654121,16.1),(121675,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121675,37.58,0.33,329,54132,70,NULL,NULL,'SDSS J143208.85+045853.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.036916667,4.98144,0.053,NULL,58315463574,911179118,14237173,18.2),(121676,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121676,37.77,0.46,358,54133,70,NULL,NULL,'2MASX J14320920+4049148',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,'FoF','17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.038333,40.82083,0,NULL,59947008596,936672009,14635500,17.6),(121677,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121677,36.51,0.46,201,54134,70,NULL,NULL,'2MASX J14320976+4609001',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.040833,46.15014,0,NULL,59953813104,936778329,14637161,16.4),(121678,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121678,37.99,0.46,396,54135,70,NULL,NULL,'2MASX J14321016+2633254',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.042417,26.55706,0,NULL,60024602289,937884410,14654443,18.1),(121679,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121679,36.5,0.46,199,54136,70,NULL,NULL,'2MASX J14321060+0811216',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'17.38',0.24,NULL,NULL,NULL,NULL,NULL,1,218.04425,8.18939,0.033,NULL,58281677582,910651212,14228925,17.38),(121680,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121680,37.74,0.33,354,54137,70,NULL,NULL,'2MASX J14321112+4351412',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.046291667,43.86161,0,NULL,59954846590,936794477,14637413,17.6),(121681,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121681,35.82,0.38,146,54138,NULL,NULL,'Malmquist cor.','ESO 385- G 038',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.33',0.3,'Sb:',NULL,NULL,NULL,NULL,1,218.048375,-36.93081,0.293,NULL,47225706270,737901660,11529713,15.33),(121682,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121682,35.94,0.36,154,54138,NULL,NULL,NULL,'ESO 385- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121683,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121683,35.98,0.2,157,54138,74.4,NULL,NULL,'ESO 385- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121684,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121684,39.18,0.46,686,54139,70,NULL,NULL,'SDSS J143211.62+230249.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.048458333,23.047,0.037,NULL,59498278671,929660604,14525946,18.5),(121685,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121685,37.88,0.46,376,54140,70,NULL,NULL,'2MASX J14321177+2657441',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.19',0.19,NULL,NULL,NULL,NULL,NULL,1,218.049041667,26.96228,0,NULL,60023249088,937863267,14654113,18.19),(121686,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121686,38,0.33,398,54141,70,NULL,NULL,'2MASX J14321315+0530576',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.33',0.21,'BrClG',NULL,NULL,NULL,NULL,1,218.054875,5.51611,0.049,NULL,58314629974,911166093,14236970,18.33),(121687,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121687,37.41,0.46,304,54142,70,NULL,NULL,'2MASX J14321388+1806346',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.17,NULL,NULL,NULL,NULL,NULL,1,218.0579583,18.10956,0,NULL,59483329075,929427016,14522297,18.37),(121688,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121688,38.01,0.11,400,54143,70,NULL,NULL,'2MASX J14321419+2548241',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.059125,25.80681,0.021,NULL,60024368467,937880757,14654386,17.6),(121689,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121689,37.92,0.23,384,54144,70,NULL,NULL,'2MASX J14321432+2603161',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.58',0.22,NULL,NULL,NULL,NULL,NULL,1,218.05975,26.05453,0.012,NULL,60024522081,937883157,14654424,17.58),(121690,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121690,37.17,0.46,271,54145,70,NULL,NULL,'2MASX J14321590+2319196',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.066208333,23.32211,0.058,NULL,59498050062,929657032,14525891,17.1),(121691,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121691,38,0.33,398,54146,70,NULL,NULL,'SDSS J143216.68+053036.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.069541667,5.51017,0.049,NULL,58314629729,911166089,14236970,18.3),(121692,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121692,38.21,0.33,438,54147,70,NULL,NULL,'SDSS J143217.47+104716.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.072833,10.78786,0.013,NULL,59361570963,927524546,14492571,18),(121693,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121693,36.99,0.46,250,54148,70,NULL,NULL,'2MASX J14321892+2202377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,218.079041667,22.04381,0.091,NULL,59497262149,929644721,14525698,18.18),(121694,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121694,38.32,0.15,462,54149,70,NULL,NULL,'2MASX J14321932+1946547',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.15,NULL,NULL,NULL,NULL,NULL,1,218.080417,19.78189,0.033,NULL,59512927178,929889487,14529523,18.6),(121695,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121695,37.19,0.46,275,54150,70,NULL,NULL,'2MASX J14322002+5619341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.083625,56.32622,0,NULL,57260052084,894688313,13979504,17.3),(121696,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121696,37.04,0.46,256,54151,70,NULL,NULL,'2MASX J14322015+4157468',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,218.084208333,41.963,0.042,NULL,59960746726,936886667,14638854,16.4),(121697,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121697,38.13,0.33,422,54152,70,NULL,NULL,'2MASX J14322029+6225129',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.084375,62.42025,0.021,NULL,57760042349,902500661,14101572,16.4),(121698,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121698,38.27,0.46,450,54153,70,NULL,NULL,'2MASX J14322151+0448205',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.08975,4.80569,0.049,NULL,58315300173,911176565,14237133,18.1),(121699,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121699,37.41,0.46,304,54154,70,NULL,NULL,'2MASX J14322157+2347427',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.089833,23.79528,0.08,NULL,59500252388,929691443,14526428,17.5),(121700,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121700,38.2,0.46,436,54155,70,NULL,NULL,'2MASX J14322214+4120408',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.12',0.2,NULL,NULL,NULL,NULL,NULL,1,218.092167,41.34483,0.017,NULL,59946465991,936663531,14635367,18.12),(121701,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121701,33.56,0.8,51.5,54156,75,NULL,'MAT, I','ESO 447- G 019',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.68',0.3,'(R\')SB(s)a:    HII',NULL,NULL,NULL,NULL,1,218.093583333,-28.37892,0.389,NULL,47022555791,734727434,11480116,14.68),(121702,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121702,33.08,0.49,41.2,54156,75,NULL,'IR','ESO 447- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121703,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121703,33.13,0.43,42.2,54156,75,NULL,'MAT, I, raw','ESO 447- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121704,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121704,33.15,0.32,42.6,54156,85,NULL,'I, raw','ESO 447- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121705,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121705,33.18,0.32,43.3,54156,85,NULL,'I, inv','ESO 447- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121706,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121706,33.2,0.43,43.6,54156,75,NULL,'3.6 micron, color + selection bias corrected','ESO 447- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121707,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121707,33.2,0.43,43.7,54156,75,NULL,'3.6 micron, color corrected','ESO 447- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121708,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121708,33.3,0.47,45.7,54156,NULL,NULL,'H','ESO 447- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121709,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121709,33.32,0.43,46,54156,75,NULL,'MAT, I, inv','ESO 447- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121710,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121710,33.38,0.45,47.4,54156,NULL,NULL,'K','ESO 447- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121711,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121711,33.38,0.43,47.4,54156,75,NULL,'MAT, I, cor','ESO 447- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121712,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121712,33.4,0.2,47.9,54156,74.4,NULL,NULL,'ESO 447- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121713,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121713,33.41,0.46,48,54156,NULL,NULL,'J','ESO 447- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121714,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121714,33.67,0.4,54.3,54156,NULL,NULL,'mean','ESO 447- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121715,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121715,33.8,0.41,57.6,54156,NULL,NULL,'Malmquist cor.','ESO 447- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121716,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121716,33.85,0.41,58.8,54156,NULL,NULL,NULL,'ESO 447- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121717,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121717,38.7,0.33,548,54157,70,NULL,NULL,'2MASX J14322280+4706381',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'17.0g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,218.094916667,47.11064,0.033,NULL,59227811173,925434549,14459914,17),(121718,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121718,37.44,0.46,308,54158,70,NULL,NULL,'2MASX J14322297+0638486',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.095708333,6.64692,0.065,NULL,58277941765,910592840,14228013,17.7),(121719,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121719,37.79,0.46,361,54159,70,NULL,NULL,'2MASX J14322306+4658441',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.0960417,46.97903,0.021,NULL,59227981219,925437206,14459956,17.1),(121720,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121720,37.25,0.46,282,54160,70,NULL,NULL,'2MASX J14322308+3010134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.0962083,30.17036,0,NULL,60048190863,938252982,14660202,17.3),(121721,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121721,36.92,0.33,243,54161,70,NULL,NULL,'2MASX J14322318+1933587',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.38',0.14,NULL,NULL,NULL,NULL,NULL,1,218.096667,19.56625,0.037,NULL,59512879201,929888737,14529511,18.38),(121722,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121722,37.88,0.46,376,54162,70,NULL,NULL,'SDSS J143223.69+073846.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.09875,7.64631,0.021,NULL,58283524733,910680073,14229376,17.7),(121723,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121723,38.17,0.46,431,54163,70,NULL,NULL,'SDSS J143223.93+343137.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.0997083,34.52719,0,NULL,60038895442,938107741,14657933,18.5),(121724,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121724,38.19,0.46,435,54164,70,NULL,NULL,'SDSS J143224.38+034045.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.101625,3.67942,0.061,NULL,58315847171,911185112,14237267,17.9),(121725,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121725,32.74,0.8,35.4,54165,75,NULL,'B','NGC 5665',NULL,'1988NBGC.C....0000T',1988,1,2.06,NULL,'G',0.000017,NULL,'12.7g',1.08,'SAB(rs)c pec?  HII','Pair member (points to parent)',NULL,NULL,NULL,1,218.10725,8.07864,0.037,NULL,58281672537,910651133,14228923,12.7),(121726,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121726,30.87,0.43,14.9,54165,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5665',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121727,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121727,31.09,0.43,16.5,54165,75,NULL,'3.6 micron, color corrected','NGC 5665',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121728,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121728,31.3,0.2,18.2,54165,74.4,NULL,NULL,'NGC 5665',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121729,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121729,31.48,0.4,19.8,54165,NULL,NULL,NULL,'NGC 5665',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121730,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121730,32.11,0.47,26.4,54165,NULL,NULL,'H','NGC 5665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121731,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121731,32.13,0.45,26.6,54165,NULL,NULL,'K','NGC 5665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121732,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121732,32.13,0.46,26.7,54165,NULL,NULL,'J','NGC 5665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121733,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121733,32.48,0.4,31.3,54165,NULL,NULL,'mean','NGC 5665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121734,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121734,38.53,0.46,509,54166,70,NULL,NULL,'2MASX J14322598+0003269',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000102,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.10825,0.05756,0.089,NULL,58288826674,910762916,14230670,17.5),(121735,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121735,37.41,0.33,304,54167,70,NULL,NULL,'2MASX J14322625+2416482',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.1092917,24.28003,0.081,NULL,59499774339,929683974,14526312,17.9),(121736,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121736,32.87,0.8,37.5,54168,75,NULL,'A82, H','IC 1029',NULL,'1997ApJS..109..333W',1997,1,3.34,NULL,'G',0.000023,NULL,'13.3g',0.61,'SAb: sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,218.113583333,49.90461,0,NULL,59202531765,925039558,14453743,13.3),(121737,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121737,32.46,0.4,31.1,54168,75,NULL,NULL,'IC 1029',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121738,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121738,32.87,0.4,37.5,54168,NULL,NULL,'mean','IC 1029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121739,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121739,33,0.47,39.7,54168,75,NULL,'A82, H, raw','IC 1029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121740,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121740,33.04,0.46,40.5,54168,NULL,NULL,'J','IC 1029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121741,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121741,33.05,0.47,40.7,54168,NULL,NULL,'H','IC 1029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121742,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121742,33.14,0.49,42.4,54168,75,NULL,'IR','IC 1029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121743,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121743,33.14,0.47,42.5,54168,75,NULL,'A82, H, cor','IC 1029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121744,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121744,33.16,0.45,42.8,54168,NULL,NULL,'K','IC 1029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121745,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121745,33.18,0.47,43.3,54168,75,NULL,'A82, H, inv','IC 1029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121746,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121746,33.53,0.43,50.7,54168,75,NULL,'3.6 micron, color corrected','IC 1029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121747,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121747,33.58,0.2,52,54168,74.4,NULL,NULL,'IC 1029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121748,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121748,33.61,0.43,52.6,54168,75,NULL,'3.6 micron, color + selection bias corrected','IC 1029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121749,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121749,35.11,0.38,105,54168,NULL,NULL,NULL,'IC 1029',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121750,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121750,32.69,0.8,34.5,54169,75,NULL,NULL,'NGC 5665A',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'PofG',NULL,NULL,NULL,NULL,NULL,'Pair member (points to parent)',NULL,NULL,NULL,1,218.113917,8.07872,0.037,NULL,58281671932,910651123,14228923,NULL),(121751,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121751,31.82,0.4,23.1,54170,75,NULL,NULL,'UGC 09348',NULL,'2008Ap.....51..336K',2008,1,1.8,'NGC 5658 is a star.','G',0.00003,NULL,'16.58',0.3,'S0^0^: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.118791667,0.294,0.093,NULL,58288994345,910765536,14230711,16.58),(121752,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121752,31.89,NULL,23.9,54170,72,NULL,NULL,'UGC 09348',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121753,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121753,32.46,0.49,31.1,54170,75,NULL,'IR','UGC 09348',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121754,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121754,34.82,0.8,92.1,54171,75,NULL,'MAT, I','ESO 447- G 021',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.74',0.5,'(R\'_1)SB(r)b   HII',NULL,NULL,NULL,NULL,1,218.1190417,-29.92281,0.373,NULL,47028181781,734815340,11481489,14.74),(121755,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121755,34.57,0.43,81.9,54171,75,NULL,'MAT, I, raw','ESO 447- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121756,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121756,34.61,0.32,83.7,54171,85,NULL,'I, raw','ESO 447- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121757,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121757,34.67,0.32,86,54171,85,NULL,'I, inv','ESO 447- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121758,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121758,34.79,0.41,90.7,54171,NULL,NULL,'Malmquist cor.','ESO 447- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121759,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121759,34.82,0.43,92.1,54171,75,NULL,'MAT, I, cor','ESO 447- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121760,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121760,34.82,0.43,92.2,54171,75,NULL,'MAT, I, inv','ESO 447- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121761,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121761,34.98,0.4,98.9,54171,NULL,NULL,'mean','ESO 447- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121762,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121762,34.99,0.38,99.6,54171,NULL,NULL,NULL,'ESO 447- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121763,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121763,35.03,0.2,101,54171,74.4,NULL,NULL,'ESO 447- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121764,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121764,35.16,0.47,108,54171,NULL,NULL,'H','ESO 447- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121765,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121765,37.77,0.46,358,54172,70,NULL,NULL,'2MASX J14322881+3539277',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000123,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.119916667,35.65775,0,NULL,60069712648,938589260,14665457,18.1),(121766,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SCP 06F12',NULL,121766,45.05,0.07,4850,54173,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','[EBG2008] ser J143228.7+333210',1.11,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.1197917,33.53611,0.115,NULL,60037599620,938087494,14657617,NULL),(121767,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121767,37.19,0.46,274,54174,70,NULL,NULL,'LCRS B142953.2-023659',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.1202083,-2.83631,0.205,NULL,43546751942,680417999,10631531,18),(121768,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121768,37.99,0.46,397,54175,70,NULL,NULL,'2MASX J14323012+3220037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.1254583,32.33444,0,NULL,60046090461,938220163,14659690,17.5),(121769,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121769,33.55,0.46,51.4,54176,70,NULL,NULL,'KUG 1430+264',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00011,NULL,'14.6g',0.44,'Spiral',NULL,NULL,NULL,NULL,1,218.125625,26.18603,0.017,NULL,60024532232,937883316,14654426,14.6),(121770,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121770,37.58,0.46,328,54177,70,NULL,NULL,'SDSS J143230.96+432412.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.129041667,43.40342,0,NULL,59959355424,936864928,14638514,18.3),(121771,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121771,37.38,0.46,299,54178,70,NULL,NULL,'2MASX J14323153+1623468',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.1315,16.39644,0,NULL,59482397926,929412467,14522069,17.7),(121772,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121772,37.38,0.46,299,54179,70,NULL,NULL,'SDSS J143232.21+104011.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.134208333,10.66972,0.013,NULL,59359551895,927492998,14492078,18.1),(121773,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121773,34.48,NULL,78.7,54180,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09351',NULL,'2010Ap&SS.325..163P',2010,1,1.16,NULL,'G',0.00002,NULL,'16.5g',0.18,'Sdm',NULL,NULL,NULL,NULL,1,218.1364583,5.67122,0.041,NULL,58310362745,911099417,14235928,16.5),(121774,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121774,34.48,NULL,78.9,54180,NULL,NULL,'Dipole + Quadrupole','UGC 09351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121775,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121775,34.49,NULL,79.2,54180,NULL,NULL,'Dipole','UGC 09351',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121776,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121776,37.96,0.46,391,54181,70,NULL,NULL,'2MASX J14323273+0439189',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000092,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.136375,4.65539,0.053,NULL,58314786730,911168542,14237008,17.4),(121777,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121777,37.08,0.46,261,54182,70,NULL,NULL,'2MASX J14323283+2741541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.136708333,27.69828,0.019,NULL,60023495403,937867115,14654173,17.3),(121778,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121778,36.55,0.46,204,54183,70,NULL,NULL,'2MASX J14323285+1953577',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.13675,19.89936,0.047,NULL,59512803711,929887557,14529493,17.2),(121779,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121779,37.85,0.33,372,54184,70,NULL,NULL,'2MASX J14323379+2420261',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.140708333,24.34056,0.081,NULL,59499776810,929684012,14526312,17.4),(121780,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121780,37.83,0.46,368,54185,70,NULL,NULL,'2MASXi J1432343+210027',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.1432083,21.00789,0.097,NULL,59510820443,929856569,14529008,17.8),(121781,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121781,37.02,0.46,254,54186,70,NULL,NULL,'2MASX J14323491+5933550',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000183,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,218.1457083,59.56542,0,NULL,57768343892,902630373,14103599,15.9),(121782,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121782,37.85,0.46,371,54187,70,NULL,NULL,'2MASX J14323573+2305207',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.148875,23.08914,0.037,NULL,59498078627,929657478,14525898,17.2),(121783,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121783,38.32,0.15,462,54188,70,NULL,NULL,'SDSS J143236.44+194724.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.151875,19.79011,0.033,NULL,59512968980,929890140,14529533,18.6),(121784,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121784,36.72,0.46,221,54189,70,NULL,NULL,'2MASX J14323672+2044547',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.1529583,20.74856,0.036,NULL,59510869940,929857342,14529020,17.6),(121785,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121785,36.35,0.46,186,54190,70,NULL,NULL,'2MASX J14323755-0131481',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00016,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,218.1565,-1.53011,0.101,NULL,43514075542,679907430,10623553,17.5),(121786,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121786,37.82,0.46,366,54191,70,NULL,NULL,'SDSS J143237.55+154835.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.1565,15.80992,0,NULL,59481570627,929399541,14521867,17.9),(121787,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121787,33.75,0.4,56.1,54192,NULL,NULL,'mean','NGC 5672',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000017,NULL,'14.08',0.6,'Sb? sp         HII','Pair member, wide',NULL,NULL,NULL,1,218.15975,31.67017,0,NULL,60046457674,938225901,14659779,14.08),(121788,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121788,34.55,0.47,81.3,54192,NULL,NULL,'H','NGC 5672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121789,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121789,37.26,0.46,283,54193,70,NULL,NULL,'2MASX J14323892+2327334',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.162083,23.45939,0.069,NULL,59497581911,929649717,14525776,17.7),(121790,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121790,38.33,0.46,464,54194,70,NULL,NULL,'2MASX J14323919+4332560',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.163291667,43.54875,0,NULL,59959383375,936865365,14638521,18.1),(121791,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121791,37.93,0.33,386,54195,70,NULL,NULL,'2MASX J14324066+5610165',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.169583,56.17131,0,NULL,57260600365,894696880,13979638,18.1),(121792,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121792,31.14,0.4,16.9,54196,75,NULL,'B','NGC 5643',NULL,'1988NBGC.C....0000T',1988,1,4.6,NULL,'G',0.000007,NULL,'10.74',4,'SAB(rs)c       Sy2',NULL,NULL,NULL,'Sy 2',1,218.16975,-44.17442,0.501,NULL,47083937867,735686529,11495102,10.74),(121793,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121793,36.44,0.46,194,54197,70,NULL,NULL,'2MASX J14324203+5442335',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.1752917,54.70922,0.005,NULL,57253326809,894583231,13977862,16.8),(121794,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121794,36.22,0.68,175,54198,70,NULL,NULL,'2MASX J14324228-3837105',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,218.1762083,-38.61956,0.409,NULL,47212441875,737694404,11526475,14.6),(121795,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121795,37.69,0.33,346,54199,70,NULL,NULL,'2MASX J14324231+1430498',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.94',0.18,NULL,NULL,NULL,NULL,NULL,1,218.17625,14.51389,0,NULL,59545396075,930396813,14537450,17.94),(121796,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121796,37.97,0.33,393,54200,70,NULL,NULL,'2MASX J14324234+1913594',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.46',0.14,NULL,NULL,NULL,NULL,NULL,1,218.1765,19.23317,0.027,NULL,59512451476,929882054,14529407,18.46),(121797,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121797,37.79,0.46,361,54201,70,NULL,NULL,'2MASX J14324285+2616451',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.178375,26.279,0,NULL,60024510082,937882970,14654421,17.6),(121798,'SNII optical','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SN 2013ab',NULL,121798,31.85,0.07,23.5,54202,NULL,NULL,'EPM + Explosion Epoch','NGC 5669',NULL,'2015MNRAS.450.2373B',2015,1,4,NULL,'G',0.000007,NULL,'12.03',2.8,'SAB(rs)cd','in a pair',NULL,NULL,NULL,1,218.1812083,9.89044,0.021,NULL,59359023834,927484747,14491949,12.03),(121799,'SNII optical','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SN 2013ab',NULL,121799,31.92,0.09,24.3,54202,NULL,NULL,'EPM','NGC 5669',NULL,'2015MNRAS.450.2373B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121800,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121800,30.8,0.43,14.5,54202,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5669',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121801,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121801,30.85,0.43,14.8,54202,75,NULL,'3.6 micron, color corrected','NGC 5669',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121802,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121802,30.97,0.2,15.6,54202,74.4,NULL,NULL,'NGC 5669',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121803,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121803,31.24,0.49,17.7,54202,NULL,NULL,'Malmquist cor.','NGC 5669',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121804,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121804,31.33,0.47,18.5,54202,NULL,NULL,NULL,'NGC 5669',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121805,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121805,31.47,0.37,19.7,54202,NULL,NULL,NULL,'NGC 5669',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121806,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121806,31.47,NULL,19.7,54202,72,NULL,NULL,'NGC 5669',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121807,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121807,31.98,0.4,24.9,54202,75,NULL,'B','NGC 5669',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121808,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121808,32.01,0.4,25.2,54202,NULL,NULL,'mean','NGC 5669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121809,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121809,32.44,0.47,30.8,54202,NULL,NULL,'H','NGC 5669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121810,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121810,32.47,0.46,31.2,54202,NULL,NULL,'J','NGC 5669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121811,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121811,32.51,0.45,31.7,54202,NULL,NULL,'K','NGC 5669',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121812,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121812,38.1,0.46,416,54203,70,NULL,NULL,'SDSS J143244.56+470947.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.1857083,47.16336,0.033,NULL,59227830437,925434850,14459919,18.7),(121813,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121813,37.95,0.46,390,54204,70,NULL,NULL,'2MASX J14324501+5327451',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.18725,53.46264,0,NULL,59205667542,925088555,14454508,18),(121814,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121814,36.27,0.46,180,54205,70,NULL,NULL,'2MASX J14324630-0206170',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000213,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,218.192958333,-2.10492,0.133,NULL,43547038599,680422478,10631601,16),(121815,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121815,36.39,0.46,189,54206,70,NULL,NULL,'SDSS J143246.36+143517.6',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',NULL,NULL,'15.4g',0.47,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.193167,14.58822,0,NULL,59545400852,930396888,14537451,15.4),(121816,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121816,37.85,0.33,372,54207,70,NULL,NULL,'2MASX J14324674+2423304',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.82',0.23,NULL,NULL,NULL,NULL,NULL,1,218.194667,24.39192,0.081,NULL,59499783676,929684119,14526314,17.82),(121817,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121817,37.94,0.27,387,54208,70,NULL,NULL,'SDSS J143246.87+171802.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.195333,17.30072,0.018,NULL,59483543306,929430364,14522349,18.3),(121818,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121818,32.66,0.8,34,54209,75,NULL,'A82, H','NGC 5676',NULL,'1997ApJS..109..333W',1997,1,4.01,NULL,'G',0.000017,NULL,'12.3g',1.05,'SA(rs)bc       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,218.1952083,49.45789,0.025,NULL,59201912389,925029881,14453591,12.3),(121819,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121819,32.07,0.47,26,54209,NULL,NULL,'H','NGC 5676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121820,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121820,32.11,0.45,26.4,54209,NULL,NULL,'K','NGC 5676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121821,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121821,32.14,0.46,26.8,54209,NULL,NULL,'J','NGC 5676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121822,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121822,32.18,0.4,27.3,54209,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5676',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121823,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121823,32.54,0.4,32.3,54209,NULL,NULL,'mean','NGC 5676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121824,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121824,32.6,0.47,33.1,54209,75,NULL,'A82, H, raw','NGC 5676',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121825,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121825,32.61,0.43,33.3,54209,75,NULL,'3.6 micron, color corrected','NGC 5676',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121826,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121826,32.61,0.43,33.3,54209,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5676',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121827,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121827,32.69,0.4,34.5,54209,75,NULL,'B','NGC 5676',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121828,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121828,32.7,0.2,34.7,54209,74.4,NULL,NULL,'NGC 5676',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121829,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121829,32.72,0.36,35,54209,NULL,NULL,NULL,'NGC 5676',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121830,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121830,32.77,0.35,35.9,54209,NULL,NULL,'Malmquist cor.','NGC 5676',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121831,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121831,32.82,0.47,36.7,54209,75,NULL,'A82, H, inv','NGC 5676',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121832,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121832,32.83,0.47,36.8,54209,75,NULL,'A82, H, cor','NGC 5676',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121833,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121833,32.85,0.34,37.1,54209,NULL,NULL,NULL,'NGC 5676',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121834,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121834,38.32,0.15,462,54210,70,NULL,NULL,'2MASX J14324729+1945494',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.1970417,19.76375,0.033,NULL,59512977898,929890279,14529535,NULL),(121835,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121835,36.11,NULL,167,54211,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1766',NULL,'2010Ap&SS.325..163P',2010,1,0.85,NULL,'G',0.000167,NULL,'16.7g',0.15,'Sbc',NULL,NULL,NULL,NULL,1,218.198,28.39258,0,NULL,60024929212,937889518,14654523,16.7),(121836,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121836,36.12,NULL,168,54211,NULL,NULL,'Dipole + Quadrupole','FGC 1766',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121837,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121837,36.13,NULL,168,54211,NULL,NULL,'Dipole','FGC 1766',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121838,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121838,38.49,0.46,499,54212,70,NULL,NULL,'2MASX J14324801+0845444',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.200083333,8.76242,0.029,NULL,58281083063,910641922,14228780,18.2),(121839,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121839,37.69,0.33,346,54213,70,NULL,NULL,'SDSS J143249.80+142657.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.2075,14.44936,0,NULL,59545444964,930397577,14537462,18.4),(121840,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121840,37.94,0.27,387,54214,70,NULL,NULL,'2MASX J14325077+1721139',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,218.211708333,17.35389,0,NULL,59483552551,929430508,14522351,18.68),(121841,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121841,38.64,0.46,536,54215,70,NULL,NULL,'2MASXi J1432519+270645',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.216625,27.11286,0,NULL,60023294555,937863977,14654124,18.1),(121842,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121842,37.77,0.46,358,54216,70,NULL,NULL,'2MASX J14325222+2653034',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.217458333,26.88431,0,NULL,60023757097,937871204,14654237,17.9),(121843,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121843,38.21,0.33,438,54217,70,NULL,NULL,'2MASX J14325269+1051544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.219667,10.86503,0.005,NULL,59361587092,927524798,14492574,17.2),(121844,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121844,33.79,0.8,57.3,54218,75,NULL,'MAT, I','MCG -02-37-006',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00001,NULL,'14.90',1,'SB(rs)bc',NULL,NULL,NULL,NULL,1,218.2204583,-12.97558,0.285,NULL,46677717701,729339339,11395927,14.9),(121845,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121845,34.42,0.32,76.7,54218,85,NULL,'I, raw','MCG -02-37-006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121846,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121846,34.46,0.32,77.9,54218,85,NULL,'I, inv','MCG -02-37-006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121847,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121847,35.22,0.43,111,54218,75,NULL,'MAT, I, raw','MCG -02-37-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121848,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121848,35.47,0.43,124,54218,75,NULL,'MAT, I, inv','MCG -02-37-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121849,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121849,35.49,0.43,125,54218,75,NULL,'MAT, I, cor','MCG -02-37-006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121850,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121850,36.92,0.46,242,54219,70,NULL,NULL,'2MASX J14325296+4040453',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000148,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.220583333,40.67933,0.02,NULL,59946993117,936671767,14635496,16.8),(121851,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121851,38.48,0.46,497,54220,70,NULL,NULL,'2MASX J14325418+1500429',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.225667,15.01181,0,NULL,59544676535,930385570,14537274,17.2),(121852,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121852,37.94,0.27,387,54221,70,NULL,NULL,'2MASX J14325419+1720099',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.22575,17.33597,0.018,NULL,59483553268,929430519,14522351,17.2),(121853,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121853,35.88,0.33,150,54222,70,NULL,NULL,'CGCG 273-011',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000117,NULL,'15.1g',0.57,'E0',NULL,NULL,NULL,NULL,1,218.2335,55.72653,0,NULL,57260442554,894694414,13979600,15.1),(121854,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121854,38.05,0.17,406,54223,70,NULL,NULL,'2MASX J14325605+0952108',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000182,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.233625,9.86956,0.021,NULL,59359008767,927484511,14491945,18),(121855,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121855,37.97,0.33,393,54224,70,NULL,NULL,'SDSS J143256.61+191744.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.235917,19.29567,0.03,NULL,59512400697,929881260,14529394,18),(121856,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121856,38.17,0.33,430,54225,70,NULL,NULL,'2MASX J14325694+0436044',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.0001,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.237333,4.60133,0.053,NULL,58315116179,911173690,14237088,17.3),(121857,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121857,37.41,0.33,304,54226,70,NULL,NULL,'2MASX J14325713+2425084',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000113,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.238125,24.41908,0.081,NULL,59499784545,929684133,14526314,16),(121858,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121858,37.13,0.46,266,54227,70,NULL,NULL,'2MASX J14325748+2303214',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000144,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.2397083,23.05614,0.037,NULL,59498265527,929660398,14525943,17),(121859,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121859,38.04,0.46,406,54228,70,NULL,NULL,'2MASX J14325778+1949164',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.240708333,19.82142,0.033,NULL,59512952498,929889882,14529529,17.9),(121860,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121860,38.17,0.33,430,54229,70,NULL,NULL,'2MASX J14325781+0437154',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000111,NULL,'16.9g',0.25,'AGN',NULL,NULL,NULL,NULL,1,218.240917,4.62086,0.053,NULL,58315116495,911173695,14237088,16.9),(121861,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121861,37.96,0.46,392,54230,70,NULL,NULL,'2MASX J14325896+2148014',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.44',0.17,NULL,NULL,NULL,NULL,NULL,1,218.245875,21.80044,0.094,NULL,59502509041,929726703,14526979,18.44),(121862,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121862,37.95,0.46,389,54231,70,NULL,NULL,'2MASX J14330136+2322434',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.255625,23.37886,0.066,NULL,59497584087,929649751,14525777,17.6),(121863,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121863,38.08,0.46,414,54232,70,NULL,NULL,'2MASX J14330202+1540360',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.258417,15.67681,0,NULL,59481532582,929398946,14521858,17.8),(121864,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121864,36.53,0.46,203,54233,70,NULL,NULL,'2MASX J14330323+5809376',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.26375,58.16056,0.017,NULL,57248801487,894512523,13976758,16.4),(121865,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121865,37.18,0.46,272,54234,70,NULL,NULL,'2MASX J14330356+0605398',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.26475,6.09461,0.053,NULL,58310423732,911100370,14235943,17.1),(121866,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121866,38.05,0.17,406,54235,70,NULL,NULL,'2MASX J14330391+0936218',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.266375,9.60606,0.025,NULL,59359065390,927485396,14491959,18.1),(121867,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121867,37.58,0.46,328,54236,70,NULL,NULL,'2MASX J14330411+4309210',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.267208333,43.15589,0,NULL,59959344221,936864753,14638511,17.1),(121868,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121868,36.31,0.46,183,54237,70,NULL,NULL,'2MASX J14330414+3318465',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.26725,33.31289,0,NULL,60038106813,938095418,14657740,16.8),(121869,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121869,36.99,0.33,250,54238,70,NULL,NULL,'2MASX J14330452+2336114',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.268917,23.60322,0.069,NULL,59499490290,929679535,14526242,16.9),(121870,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121870,35.79,0.1,144,54239,70,NULL,NULL,'2MASX J14330467+0409134',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000068,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.269417,4.15369,0.049,NULL,58317548301,911211692,14237682,16.5),(121871,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121871,38.32,0.15,462,54240,70,NULL,NULL,'2MASX J14330529+1946284',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.272125,19.77456,0.033,NULL,59512957138,929889955,14529530,17.8),(121872,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121872,38.05,0.17,406,54241,70,NULL,NULL,'2MASX J14330593+0940098',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000194,NULL,'15.9g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,218.274583,9.66933,0.025,NULL,59359061778,927485340,14491958,15.9),(121873,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121873,37.24,0.46,280,54242,70,NULL,NULL,'2MASX J14330623+0532224',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.275875,5.53958,0.045,NULL,58310338867,911099044,14235922,17.1),(121874,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121874,38.05,0.17,406,54243,70,NULL,NULL,'SDSS J143306.47+094528.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.277,9.758,0.021,NULL,59359019949,927484686,14491948,18.3),(121875,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121875,31.53,NULL,20.2,54244,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 326- G 029',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000029,NULL,'16.4',0.16,'Sdm',NULL,NULL,NULL,NULL,1,218.277083,-41.75889,0.389,NULL,47090782933,735793483,11496773,16.4),(121876,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121876,31.56,NULL,20.5,54244,NULL,NULL,'Dipole + Quadrupole','ESO 326- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121877,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121877,31.6,NULL,20.9,54244,NULL,NULL,'Dipole','ESO 326- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121878,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121878,38.05,0.17,406,54245,70,NULL,NULL,'SDSS J143306.76+094021.2',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.278166667,9.67258,0.025,NULL,59359061694,927485338,14491958,17.3),(121879,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121879,38.45,0.46,490,54246,70,NULL,NULL,'2MASX J14330737+1413386',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.1E',NULL,NULL,NULL,NULL,NULL,NULL,1,218.280667,14.22742,0,NULL,59545266671,930394791,14537418,17.1),(121880,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121880,35.87,0.46,149,54247,70,NULL,NULL,'MCG +09-24-015',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000191,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,218.285667,56.29189,0,NULL,57260021814,894687840,13979497,15.2),(121881,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121881,38.32,0.15,462,54248,70,NULL,NULL,'2MASX J14330884+1946166',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.286916667,19.77117,0.033,NULL,59512957818,929889965,14529530,17.8),(121882,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121882,37.83,0.46,367,54249,70,NULL,NULL,'SDSS J143309.32+104030.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.288875,10.67522,0.005,NULL,59359509490,927492335,14492067,18.1),(121883,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121883,38.21,0.46,438,54250,70,NULL,NULL,'2MASX J14330964+5532296',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.290166667,55.54161,0,NULL,57258340935,894661577,13979087,17.5),(121884,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121884,35.52,0.4,127,54251,NULL,NULL,'mean','CGCG 047-086',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000183,NULL,'14.9',0.8,'Sc','Group member',NULL,NULL,NULL,1,218.2904583,3.94667,0.065,NULL,58317495687,911210870,14237669,14.9),(121885,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121885,35.78,0.47,143,54251,NULL,NULL,'H','CGCG 047-086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121886,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121886,38.05,0.17,406,54252,70,NULL,NULL,'2MASX J14330972+0947188',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.2905,9.78842,0.021,NULL,59359011487,927484554,14491946,17.6),(121887,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121887,36.76,0.16,225,54253,70,NULL,NULL,'CGCG 273-013',NULL,'2015arXiv151105856S',2015,1,1.25,NULL,'G',0.0001,NULL,'14.4g',0.8,'E0',NULL,NULL,NULL,NULL,1,218.290833,53.23269,0,NULL,59205698981,925089046,14454516,14.4),(121888,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121888,37.85,0.46,372,54254,70,NULL,NULL,'2MASX J14331007+2406014',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000206,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.2920417,24.10036,0.104,NULL,59500318448,929692475,14526444,16.5),(121889,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121889,37.68,0.46,344,54255,70,NULL,NULL,'SDSS J143310.85+384728.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,218.2952083,38.79131,0,NULL,60065285301,938520082,14664376,18.6),(121890,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121890,36.41,0.46,191,54256,70,NULL,NULL,'2MASX J14331123+3622163',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.296958333,36.37108,0,NULL,60077510082,938711095,14667360,16.9),(121891,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121891,37.85,0.46,371,54257,70,NULL,NULL,'SDSS J143311.63+071652.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.2985,7.28122,0.069,NULL,58278323279,910598801,14228106,17.7),(121892,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121892,36.5,0.46,199,54258,70,NULL,NULL,'2MASX J14331281+2748404',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.303208333,27.81119,0,NULL,60023442245,937866285,14654160,17.6),(121893,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121893,36.76,0.16,225,54259,70,NULL,NULL,'MCG +09-24-014',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000229,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,218.304,52.96314,0,NULL,59205083305,925079426,14454366,16),(121894,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121894,36.28,0.46,180,54260,70,NULL,NULL,'2MASX J14331302+0841438',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.30425,8.69544,0.029,NULL,58281066040,910641656,14228775,16.8),(121895,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121895,38.22,0.33,441,54261,70,NULL,NULL,'SDSS J143313.73+564407.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.30725,56.73556,0,NULL,57258862571,894669727,13979214,18.5),(121896,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121896,37.93,0.33,386,54262,70,NULL,NULL,'2MASX J14331382+5608236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.30775,56.13981,0,NULL,57260630068,894697344,13979646,17.4),(121897,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121897,36.76,0.16,225,54263,70,NULL,NULL,'2MASX J14331403+5306120',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.3084583,53.10328,0,NULL,59205532151,925086439,14454475,16.7),(121898,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121898,35.88,0.33,150,54264,70,NULL,NULL,'2MASX J14331423+5531376',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000175,NULL,'15.6g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,218.30925,55.52708,0,NULL,57258343739,894661620,13979087,15.6),(121899,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121899,37.67,0.46,342,54265,70,NULL,NULL,'2MASX J14331438+2003156',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.38',0.14,NULL,NULL,NULL,NULL,NULL,1,218.3100417,20.05444,0.044,NULL,59512820644,929887822,14529497,18.38),(121900,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121900,37.92,0.46,384,54266,70,NULL,NULL,'SDSS J143314.47+250305.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.310333333,25.0515,0.077,NULL,59498570466,929665163,14526018,18.6),(121901,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121901,34.52,0.2,80.2,54267,74.4,NULL,NULL,'KUG 1430+140',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00013,NULL,'15.5',0.2,'Sc','Isolated galaxy',NULL,NULL,NULL,1,218.310625,13.84272,0.01,NULL,59545879282,930404363,14537568,15.5),(121902,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121902,35.15,0.49,107,54267,75,NULL,'IR','KUG 1430+140',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121903,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121903,37.53,0.46,321,54268,70,NULL,NULL,'2MASX J14331505-0049289',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.312833,-0.82461,0.101,NULL,43512403567,679881305,10623145,17),(121904,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121904,37.4,0.46,302,54269,70,NULL,NULL,'2MASX J14331549+2804169',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000135,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.314375,28.07122,0,NULL,60024759581,937886868,14654482,17.7),(121905,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121905,33.81,NULL,57.8,54270,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09359',NULL,'2010Ap&SS.325..163P',2010,1,1.11,'There is a star superposed north of the nucleus.','G',0.000015,NULL,'16.5g',0.18,'Scd',NULL,NULL,NULL,NULL,1,218.3159583,-1.14014,0.093,NULL,43512453566,679882086,10623157,16.5),(121906,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121906,33.82,NULL,58.2,54270,NULL,NULL,'Dipole','UGC 09359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121907,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121907,33.83,NULL,58.2,54270,NULL,NULL,'Dipole + Quadrupole','UGC 09359',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121908,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121908,34.29,0.2,72.1,54270,74.4,NULL,NULL,'UGC 09359',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121909,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121909,36.2,0.46,174,54271,70,NULL,NULL,'CGCG 248-004',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000207,NULL,'15.0g',0.58,'E0',NULL,NULL,NULL,NULL,1,218.316125,45.78108,0,NULL,59953760509,936777507,14637148,15),(121910,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121910,38.13,0.23,422,54272,70,NULL,NULL,'SDSS J143315.87+572950.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.316166667,57.49753,0,NULL,57252131271,894564551,13977571,18.5),(121911,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121911,38.44,0.46,487,54273,70,NULL,NULL,'2MASX J14331606+5936546',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.316916667,59.61522,0,NULL,57768317153,902629955,14103593,17.7),(121912,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121912,37.74,0.46,354,54274,70,NULL,NULL,'SDSS J143316.30+125340.1',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.317917,12.89447,0,NULL,59546214245,930409597,14537649,17.3),(121913,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121913,39.03,0.46,640,54275,70,NULL,NULL,'SDSS J143316.30+241835.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.8g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.317958333,24.30975,0.081,NULL,59499778858,929684044,14526313,18.8),(121914,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121914,37.46,0.46,311,54276,70,NULL,NULL,'2MASX J14331642+3528146',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.3185417,35.47086,0,NULL,60069725504,938589461,14665460,18.2),(121915,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121915,38.08,0.46,414,54277,70,NULL,NULL,'SDSS J143316.88+111154.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.320375,11.19856,0.013,NULL,59361962123,927530658,14492666,18.1),(121916,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121916,38.05,0.33,407,54278,70,NULL,NULL,'2MASX J14331755+2336016',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.323083333,23.60044,0.084,NULL,59499540656,929680322,14526255,18),(121917,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121917,38.16,0.46,429,54279,70,NULL,NULL,'SDSS J143319.41+484242.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.330875,48.71175,0.069,NULL,59199424619,924991009,14452984,18.5),(121918,'IRAS','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121918,34.06,0.8,65,54280,75,NULL,'HMCL, I','KUG 1431+264',NULL,'1997ApJS..109..333W',1997,1,0.18,NULL,'G',0.00001,NULL,'15.4g',0.17,'Spiral',NULL,NULL,NULL,NULL,1,218.3325417,26.19906,0.017,NULL,60024547810,937883559,14654430,15.4),(121919,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121919,33.78,0.4,57.1,54280,75,NULL,'HMCL, I, raw','KUG 1431+264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121920,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121920,33.83,0.4,58.4,54280,75,NULL,'HMCL, I, inv','KUG 1431+264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121921,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121921,34.03,0.4,64,54280,75,NULL,'HMCL, I, cor','KUG 1431+264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121922,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121922,36.71,0.51,220,54281,70,NULL,NULL,'2MASX J14332008-3344390',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,218.3337917,-33.74422,0.253,NULL,46997955189,734343049,11474110,14.1),(121923,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121923,37.92,0.46,384,54282,70,NULL,NULL,'SDSS J143321.63+460613.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.340167,46.10364,0,NULL,59954317081,936786204,14637284,17.8),(121924,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121924,36.19,0.53,173,54283,70,NULL,NULL,'2MASX J14332272-1847443',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'6dF DR2 has z = 0.035279.','G',0.00013,NULL,'15.28',NULL,NULL,NULL,NULL,NULL,NULL,1,218.344666667,-18.79569,0.349,NULL,46557043909,727453811,11366465,15.28),(121925,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121925,38.82,0.46,582,54284,70,NULL,NULL,'SDSS J143323.00+605742.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.345875,60.96167,0.009,NULL,57753231937,902394249,14099910,18.3),(121926,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121926,36.33,0.46,185,54285,70,NULL,NULL,'2MASX J14332309+1952236',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.00',0.19,NULL,NULL,NULL,NULL,NULL,1,218.34625,19.87322,0.033,NULL,59512947881,929889810,14529528,18),(121927,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121927,38.05,0.17,406,54286,70,NULL,NULL,'2MASX J14332330+0940350',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.347167,9.67647,0.021,NULL,59359062461,927485350,14491958,17.7),(121928,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:39','1','SN 1954B','R',121928,32.15,NULL,26.9,54287,NULL,NULL,'Photographic','NGC 5668',NULL,'1988SSRv...48....1R',1988,1,3.3,'2MASS position refers to a superposed star.','G',0.000003,NULL,'13.4g',3,'SA(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.351417,4.45044,0.053,NULL,58317203748,911206308,14237598,13.4),(121929,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121929,32.15,0.4,26.9,54287,75,NULL,'B','NGC 5668',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121930,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121930,36.69,0.46,218,54288,70,NULL,NULL,'2MASX J14332453+1924116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.17,NULL,NULL,NULL,NULL,NULL,1,218.3524583,19.40308,0.03,NULL,59512288013,929879500,14529367,18.37),(121931,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121931,36.91,0.46,241,54289,70,NULL,NULL,'2MASX J14332506+2304316',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.3544583,23.0755,0.037,NULL,59498251256,929660175,14525940,17.1),(121932,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121932,36.99,0.33,250,54290,70,NULL,NULL,'2MASX J14332527+2337576',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0002,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.3554583,23.63281,0.084,NULL,59499544020,929680375,14526255,17),(121933,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121933,35.24,0.49,112,54291,75,NULL,'IR','ESO 385- G 042',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.51',0.2,'S...',NULL,NULL,NULL,NULL,1,218.35575,-33.75581,0.253,NULL,46997957907,734343092,11474110,16.51),(121934,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121934,35.36,0.6,118,54291,NULL,NULL,'Malmquist cor.','ESO 385- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121935,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121935,35.49,0.57,125,54291,NULL,NULL,NULL,'ESO 385- G 042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121936,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121936,35.53,0.2,128,54291,74.4,NULL,NULL,'ESO 385- G 042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121937,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121937,37.41,0.33,303,54292,70,NULL,NULL,'2MASX J14332579+3626333',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.357667,36.44269,0,NULL,60077520509,938711257,14667363,17.1),(121938,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121938,36.76,0.16,225,54293,70,NULL,NULL,'2MASX J14332584+5250530',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,218.357917,52.84808,0,NULL,59205040460,925078757,14454355,16.5),(121939,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121939,37.51,0.46,318,54294,70,NULL,NULL,'2MASX J14332706+5718363',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000156,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.362917,57.31019,0,NULL,57251320408,894551881,13977373,16.6),(121940,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121940,37.6,0.46,331,54295,70,NULL,NULL,'2MASX J14332716+1858346',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.46',0.15,NULL,NULL,NULL,NULL,NULL,1,218.3632917,18.97647,0.021,NULL,59512219034,929878422,14529350,18.46),(121941,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121941,35.56,0.46,129,54296,70,NULL,NULL,'CGCG 075-070',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000172,NULL,'15.4g',0.54,NULL,NULL,NULL,NULL,NULL,1,218.363416667,9.24536,0.029,NULL,58269383627,910459119,14225923,15.4),(121942,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121942,38.05,0.33,407,54297,70,NULL,NULL,'2MASX J14332772+2325546',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.3655,23.43172,0.066,NULL,59497635579,929650555,14525789,17.2),(121943,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121943,38.9,0.46,602,54298,70,NULL,NULL,'2MASX J14332874+1834536',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.369833333,18.58147,0,NULL,59479700075,929370313,14521411,17.7),(121944,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121944,36.61,0.46,210,54299,70,NULL,NULL,'2MASX J14332894+3655003',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000149,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,218.3705417,36.91678,0,NULL,60078127573,938720743,14667511,17.1),(121945,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121945,37.2,0.46,275,54300,70,NULL,NULL,'2MASX J14332899+0208103',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000097,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.370791667,2.13619,0.057,NULL,58307453536,911053961,14235218,18),(121946,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121946,38.32,0.15,462,54301,70,NULL,NULL,'2MASX J14332953+1947386',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.372917,19.79406,0.033,NULL,59512960203,929890003,14529531,18.1),(121947,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121947,37.64,0.33,337,54302,70,NULL,NULL,'2MASX J14332989+0354193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.3747083,3.90531,0.065,NULL,58317556969,911211827,14237684,17.7),(121948,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121948,36.81,0.46,230,54303,70,NULL,NULL,'2MASX J14332993+1906126',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.34',0.23,NULL,NULL,NULL,NULL,NULL,1,218.374833333,19.10364,0.021,NULL,59512425234,929881644,14529400,17.34),(121949,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121949,35.84,0.46,147,54304,70,NULL,NULL,'CGCG 296-011',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000192,NULL,'15.1g',0.5,'S0','Isolated galaxy',NULL,NULL,NULL,1,218.381125,57.71178,0.013,NULL,57251636498,894556820,13977450,15.1),(121950,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121950,37.55,0.46,324,54305,70,NULL,NULL,'2MASX J14333188+1631356',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.3827917,16.52664,0,NULL,59482530425,929414537,14522102,17.2),(121951,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121951,34.62,0.57,83.8,54306,NULL,NULL,'Malmquist cor.','ESO 385- G 043',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.24',0.9,'Sb',NULL,NULL,NULL,NULL,1,218.3835,-33.80444,0.253,NULL,46997955868,734343060,11474110,15.24),(121952,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121952,34.7,0.55,86.9,54306,NULL,NULL,NULL,'ESO 385- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121953,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121953,34.74,0.2,88.7,54306,74.4,NULL,NULL,'ESO 385- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121954,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121954,36.76,0.16,225,54307,70,NULL,NULL,'2MASX J14333472+5243099',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000211,NULL,'15.6g',0.38,'E0',NULL,NULL,NULL,NULL,1,218.394583,52.71953,0,NULL,59206141283,925095957,14454624,15.6),(121955,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121955,37.85,0.46,371,54308,70,NULL,NULL,'LCRS B143059.5-022313',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.39575,-2.606,0.205,NULL,43546684330,680416942,10631514,17.2),(121956,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121956,36.69,0.46,218,54309,70,NULL,NULL,'2MASX J14333602+5832293',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000181,NULL,'15.7g',0.48,'E0',NULL,NULL,NULL,NULL,1,218.3999583,58.54142,0,NULL,57248647196,894510112,13976720,15.7),(121957,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121957,36.76,0.16,225,54310,70,NULL,NULL,'2MASX J14333619+5300449',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.401,53.01258,0,NULL,59205538434,925086538,14454477,17),(121958,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121958,37.41,0.33,303,54311,70,NULL,NULL,'2MASX J14333648+3623432',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.402166667,36.39553,0,NULL,60077522362,938711286,14667363,16.9),(121959,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121959,35.61,0.46,132,54312,70,NULL,NULL,'2MASX J14333652+2138205',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.68',0.2,NULL,NULL,NULL,NULL,NULL,1,218.4022083,21.63894,0.085,NULL,59502525990,929726968,14526983,17.68),(121960,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121960,35.79,0.1,144,54313,70,NULL,NULL,'2MASX J14333824+0341463',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00008,NULL,'15.8g',0.42,'BLAGN',NULL,NULL,NULL,'Sy 1',1,218.409375,3.69617,0.069,NULL,58317027829,911203559,14237555,15.8),(121961,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121961,38.66,0.21,539,54314,70,NULL,NULL,'2MASX J14333901+6122037',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,218.4127917,61.36761,0.013,NULL,57752851219,902388300,14099817,17),(121962,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121962,37.85,0.46,371,54315,70,NULL,NULL,'2MASX J14333948+2341529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000019,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.414583,23.69792,0.084,NULL,59499523000,929680046,14526250,17.8),(121963,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121963,35.38,0.46,119,54316,70,NULL,NULL,'ARK 452',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000169,NULL,'14.8g',0.74,'E0',NULL,NULL,NULL,NULL,1,218.414833333,35.31203,0,NULL,60069070256,938579222,14665300,14.8),(121964,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121964,38.51,0.46,503,54317,70,NULL,NULL,'SDSS J143339.79+264020.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.415833,26.6725,0,NULL,60023887488,937873242,14654269,18.5),(121965,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121965,36.7,0.46,219,54318,70,NULL,NULL,'2MASX J14334023+0615530',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.4177083,6.26458,0.053,NULL,58278686217,910604472,14228194,16.7),(121966,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121966,35.09,0.49,104,54319,75,NULL,'IR','UGC 09478',NULL,'2011yCatp016004901K',2011,1,1.24,NULL,'G',0.000087,NULL,'17.',0.1,'Sd',NULL,NULL,NULL,NULL,1,218.41875,85.29206,0.229,NULL,56971675804,890182434,13909100,17),(121967,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121967,35.59,NULL,131,54319,NULL,NULL,NULL,'UGC 09478',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121968,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121968,35.61,NULL,132,54319,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121969,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121969,35.61,NULL,132,54319,NULL,NULL,'Dipole + Quadrupole','UGC 09478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121970,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121970,35.62,NULL,133,54319,NULL,NULL,'Dipole','UGC 09478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121971,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121971,38.53,0.46,508,54320,70,NULL,NULL,'2MASX J14334064+0825240',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.419417,8.42333,0.013,NULL,58276781399,910574709,14227729,17.2),(121972,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121972,35.2,0.46,110,54321,70,NULL,NULL,'CGCG 163-079',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000083,NULL,'14.7g',0.68,NULL,NULL,NULL,NULL,NULL,1,218.42225,28.05414,0,NULL,60024756810,937886825,14654481,14.7),(121973,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121973,38.26,0.46,450,54322,70,NULL,NULL,'2MASX J14334183+1700428',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.424417,17.01186,0,NULL,59481863060,929404110,14521939,18.3),(121974,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121974,36.68,0.46,217,54323,70,NULL,NULL,'2MASX J14334194+1124490',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.42475,11.41361,0.033,NULL,59361938552,927530289,14492660,17.5),(121975,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121975,37.64,0.33,337,54324,70,NULL,NULL,'2MASX J14334246+0356473',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.427083,3.94656,0.065,NULL,58317383294,911209113,14237642,17),(121976,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121976,35.46,0.46,124,54325,70,NULL,NULL,'SDSS J143343.45+145527.8',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.1g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.4310417,14.92442,0,NULL,59544658552,930385289,14537270,16.1),(121977,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121977,37.98,0.16,395,54326,70,NULL,NULL,'2MASX J14334354+1854259',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.4315417,18.90722,0.021,NULL,59509347649,929833557,14528649,NULL),(121978,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121978,38.22,0.33,441,54327,70,NULL,NULL,'2MASX J14334359+5651014',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.431625,56.85047,0,NULL,57258843934,894669436,13979209,17.4),(121979,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121979,32.93,0.47,38.5,54328,NULL,NULL,'H','NGC 5664',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000023,NULL,'14.52',0.25,'Sa             Sy2',NULL,NULL,NULL,'Sy 2',1,218.43175,-14.61969,0.329,NULL,46676227446,729316053,11395563,14.52),(121980,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121980,33.11,0.45,41.9,54328,NULL,NULL,'K','NGC 5664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121981,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121981,33.16,0.46,42.9,54328,NULL,NULL,'J','NGC 5664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121982,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121982,33.73,0.4,55.7,54328,NULL,NULL,'mean','NGC 5664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121983,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121983,37.98,0.16,395,54329,70,NULL,NULL,'SDSS J143344.49+185226.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.435417,18.874,0.021,NULL,59509365163,929833830,14528653,18.3),(121984,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121984,37.24,0.46,280,54330,70,NULL,NULL,'2MASX J14334454+5158297',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.435583,51.97494,0,NULL,59206764544,925105696,14454776,17.9),(121985,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121985,36.6,0.46,209,54331,70,NULL,NULL,'2MASX J14334496+4207044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.437333,42.11786,0.017,NULL,59960963585,936890056,14638907,17.1),(121986,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121986,33.19,NULL,43.4,54332,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09377',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.00005,NULL,'16.7g',0.15,'Sd',NULL,NULL,NULL,NULL,1,218.439333333,44.08219,0.02,NULL,59954714862,936792419,14637381,16.7),(121987,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121987,33.21,NULL,43.9,54332,NULL,NULL,'Dipole + Quadrupole','UGC 09377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121988,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121988,33.23,NULL,44.2,54332,NULL,NULL,'Dipole','UGC 09377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121989,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,121989,33.31,NULL,45.8,54332,NULL,NULL,NULL,'UGC 09377',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(121990,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121990,37.22,0.46,278,54333,70,NULL,NULL,'2MASX J14334584+2423269',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.441083,24.39092,0.111,NULL,59499753516,929683648,14526307,16.9),(121991,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121991,37.81,0.46,365,54334,70,NULL,NULL,'2MASX J14334704+2248209',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000176,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,218.446083333,22.80569,0.059,NULL,59498229854,929659841,14525935,16.3),(121992,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121992,37.5,0.46,316,54335,70,NULL,NULL,'2MASX J14334727+1821049',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.56',0.15,NULL,NULL,NULL,NULL,NULL,1,218.446875,18.35144,0.01,NULL,59479706011,929370406,14521412,18.56),(121993,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121993,37.98,0.16,395,54336,70,NULL,NULL,'SDSS J143347.44+185034.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.4477083,18.84286,0.015,NULL,59509365299,929833832,14528653,18.4),(121994,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121994,38.19,0.46,435,54337,70,NULL,NULL,'SDSS J143347.55+115231.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.448125,11.87531,0.025,NULL,59361415753,927522121,14492533,18.4),(121995,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121995,37.98,0.16,395,54338,70,NULL,NULL,'2MASX J14334762+1832069',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,218.4485,18.53528,0,NULL,59479747084,929371048,14521422,18.37),(121996,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121996,37.25,0.46,281,54339,70,NULL,NULL,'2MASX J14334776+5636294',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00017,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,218.449083,56.60811,0,NULL,57259033172,894672393,13979256,16.4),(121997,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121997,37.47,0.33,312,54340,70,NULL,NULL,'SDSS J143347.91+092047.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.449666667,9.34661,0.029,NULL,59358851286,927482051,14491907,17.5),(121998,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121998,37.64,0.46,338,54341,70,NULL,NULL,'2MASX J14334810+0111142',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000076,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.450417,1.18722,0.077,NULL,58288551684,910758620,14230603,17.3),(121999,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',121999,37.47,0.33,312,54342,70,NULL,NULL,'SDSS J143348.10+091946.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.450417,9.32972,0.029,NULL,59358851924,927482061,14491907,18.2),(122000,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122000,37.62,0.27,334,54343,70,NULL,NULL,'2MASX J14334861+0621410',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.452625,6.36125,0.053,NULL,58278739321,910605301,14228207,17.5),(122001,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122001,37.62,0.27,334,54344,70,NULL,NULL,'2MASX J14334921+0623240',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000197,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.455167,6.39003,0.053,NULL,58278739089,910605298,14228207,17.1),(122002,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122002,37.73,0.46,352,54345,70,NULL,NULL,'2MASX J14334985+5413454',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.457667,54.22947,0,NULL,59204760660,925074385,14454287,17.3),(122003,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122003,37.28,0.33,286,54346,70,NULL,NULL,'2MASX J14334989+2440028',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.4580417,24.6675,0.091,NULL,59498662595,929666603,14526040,16.8),(122004,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122004,37.98,0.16,395,54347,70,NULL,NULL,'2MASX J14335017+1850209',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.68',0.15,NULL,NULL,NULL,NULL,NULL,1,218.4592083,18.83933,0.015,NULL,59509373224,929833956,14528655,18.68),(122005,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122005,37.28,0.33,286,54348,70,NULL,NULL,'2MASX J14335105+2447498',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000137,NULL,'17.53',0.26,NULL,NULL,NULL,NULL,NULL,1,218.462667,24.79733,0.091,NULL,59498800570,929668758,14526074,17.53),(122006,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122006,35.79,0.1,144,54349,70,NULL,NULL,'CGCG 047-095',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000057,NULL,'15.2g',0.3,'S0','Group member',NULL,NULL,NULL,1,218.46425,3.6795,0.069,NULL,58317022491,911203476,14237554,15.2),(122007,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122007,37.38,0.46,299,54350,70,NULL,NULL,'2MASX J14335158+3214500',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.465083,32.24728,0,NULL,60046601067,938228141,14659814,17.5),(122008,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122008,38,0.27,398,54351,70,NULL,NULL,'2MASX J14335159+2835168',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,218.465125,28.58789,0,NULL,60024885484,937888835,14654513,16.7),(122009,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122009,37.98,0.16,395,54352,70,NULL,NULL,'2MASX J14335164+1844449',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.4652083,18.74603,0.015,NULL,59509370260,929833910,14528654,17.7),(122010,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122010,38.13,0.23,422,54353,70,NULL,NULL,'2MASX J14335199+5729394',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.466916667,57.49436,0,NULL,57252119914,894564373,13977568,17.5),(122011,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,122011,34.26,0.47,71.2,54354,NULL,NULL,'H','NGC 5674',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00003,NULL,'13.70',1,'SABc           Sy1.9','in a radial-velocity based grouping',NULL,NULL,'Sy 1.9',1,218.467667,5.45822,0.057,NULL,58311234611,911113040,14236141,13.7),(122012,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,122012,34.34,0.45,73.8,54354,NULL,NULL,'K','NGC 5674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122013,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,122013,34.42,0.46,76.4,54354,NULL,NULL,'J','NGC 5674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122014,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,NULL,122014,35.1,0.4,105,54354,NULL,NULL,'mean','NGC 5674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122015,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122015,37.47,0.46,312,54355,70,NULL,NULL,'2MASX J14335221+2418248',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,218.467625,24.307,0.111,NULL,59499751252,929683613,14526306,16.4),(122016,'FP','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122016,37.69,0.46,345,54356,70,NULL,NULL,'2MASX J14335234+0752284',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.93',0.15,NULL,NULL,NULL,NULL,NULL,1,218.468083,7.87461,0.021,NULL,58277224261,910581629,14227837,18.93),(122017,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:39','1',NULL,'R',122017,35.85,0.49,148,54357,75,NULL,'IR','UGC 09375',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.000033,NULL,'15.5g',0.24,'Sb',NULL,NULL,NULL,NULL,1,218.4704583,28.40208,0,NULL,60024895297,937888989,14654515,15.5),(122018,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122018,36.05,0.2,162,54357,74.4,NULL,NULL,'UGC 09375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122019,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122019,31.87,NULL,23.7,54358,72,NULL,NULL,'SDSS J143353.30+012905.6',NULL,'2014Ap.....57..457K',2014,1,1,NULL,'G',0.00001,NULL,'17.4',0.2,'dI',NULL,NULL,NULL,NULL,1,218.471333,1.48803,0.101,NULL,58305598150,911024971,14234765,17.4),(122020,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122020,37.98,0.16,395,54359,70,NULL,NULL,'2MASX J14335347+1845209',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,218.472917,18.75581,0.015,NULL,59509370762,929833918,14528654,17.84),(122021,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122021,36.99,0.46,250,54360,70,NULL,NULL,'2MASX J14335388+5508234',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,'Group non-member, foreground',NULL,NULL,NULL,1,218.474666667,55.13992,0,NULL,57258443011,894663172,13979112,17.2),(122022,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122022,37.25,0.27,282,54361,70,NULL,NULL,'SDSS J143354.01+281234.7',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.3g',0.34,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.475083333,28.20964,0,NULL,60024778016,937887156,14654486,16.3),(122023,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122023,38.01,0.46,400,54362,70,NULL,NULL,'2MASX J14335435+3051309',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.476667,30.85867,0,NULL,60049124216,938267565,14660430,18),(122024,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122024,36.48,0.46,198,54363,70,NULL,NULL,'2MASX J14335491+4946138',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.47875,49.77053,0.033,NULL,59202598508,925040601,14453759,16.2),(122025,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122025,37.03,0.46,254,54364,70,NULL,NULL,'2MASX J14335501+0709514',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,218.47925,7.16419,0.061,NULL,58278910007,910607968,14228249,16.3),(122026,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122026,35.79,0.1,144,54365,70,NULL,NULL,'2MASX J14335534+0350028',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000078,NULL,'16.0g',0.28,'S0',NULL,NULL,NULL,NULL,1,218.480541667,3.83414,0.065,NULL,58317387810,911209184,14237643,16),(122027,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122027,34.7,0.52,86.9,54366,70,NULL,NULL,'NGC 5663',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00012,NULL,'15.31',1.3,'SA0-:',NULL,NULL,NULL,NULL,1,218.484583,-16.58106,0.321,NULL,46550332598,727348946,11364827,15.31),(122028,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122028,37.62,0.27,334,54367,70,NULL,NULL,'2MASX J14335653+0621585',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.4855417,6.36625,0.053,NULL,58278733265,910605207,14228206,18),(122029,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122029,37.52,0.46,319,54368,70,NULL,NULL,'2MASX J14335685+2542338',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.486833,25.70947,0.061,NULL,60022252675,937847698,14653870,17.8),(122030,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122030,37.98,0.16,395,54369,70,NULL,NULL,'SDSS J143357.09+183830.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.487917,18.64186,0.015,NULL,59479741241,929370956,14521421,18),(122031,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122031,38,0.27,398,54370,70,NULL,NULL,'SDSS J143357.39+283350.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000124,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.4892083,28.56392,0,NULL,60024885872,937888841,14654513,18.3),(122032,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122032,38.66,0.21,539,54371,70,NULL,NULL,'2MASX J14335779+6121456',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,218.491333333,61.36256,0.013,NULL,57753363437,902396303,14099942,18.3),(122033,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122033,34.89,0.17,92.3,54372,74.2,NULL,'SALT 2','SDSS J143358.05+034750.3',0.030002,'2010ApJ...716..712A',2010,1,0.33,NULL,'G',0.00006,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.491916667,3.79731,0.065,NULL,58316912547,911201758,14237527,17.3),(122034,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122034,35.5,0.16,122,54372,70,NULL,'SALT 2','SDSS J143358.05+034750.3',0.030002,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122035,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122035,35.51,0.07,123,54372,72,NULL,'MLCS17','SDSS J143358.05+034750.3',0.030002,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122036,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122036,35.47,0.09,124,54372,74.4,NULL,NULL,'SDSS J143358.05+034750.3',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122037,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122037,35.66,0.18,132,54372,65,NULL,'MLCS17','SDSS J143358.05+034750.3',0.030002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122038,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122038,35.68,0.21,133,54372,65,NULL,'MLCS31','SDSS J143358.05+034750.3',0.030002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122039,'SNIa','2016-12-15 15:15:26','2016-12-16 11:20:40','1','SN 2006bw',NULL,122039,35.78,0.21,139,54372,65,NULL,'SALT2','SDSS J143358.05+034750.3',0.030002,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122040,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122040,36.75,0.46,224,54373,70,NULL,NULL,'2MASX J14335858+2003259',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.09',0.2,NULL,NULL,NULL,NULL,NULL,1,218.494167,20.05719,0.025,NULL,59512542709,929883479,14529429,18.09),(122041,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122041,37.25,0.27,282,54374,70,NULL,NULL,'2MASX J14335868+2810108',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.494458333,28.16967,0,NULL,60024775495,937887117,14654486,17.3),(122042,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122042,38.26,0.46,449,54375,70,NULL,NULL,'SDSS J143359.34+294837.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.49725,29.81033,0,NULL,60017992567,937781133,14652830,18.6),(122043,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122043,38.25,0.46,446,54376,70,NULL,NULL,'2MASX J14335971+5924304',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.498583,59.40847,0,NULL,57768237093,902628704,14103573,17.1),(122044,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122044,36.44,0.33,194,54377,70,NULL,NULL,'SDSS J143359.84+175432.7',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.4g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.499375,17.90911,0,NULL,59483279528,929426242,14522285,16.4),(122045,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122045,37.63,0.46,335,54378,70,NULL,NULL,'2MASX J14340119+1634048',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.45',0.22,NULL,NULL,NULL,NULL,NULL,1,218.505083,16.56794,0,NULL,59482470768,929413605,14522087,17.45),(122046,'Tully est','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122046,32.7,0.8,34.6,54379,75,NULL,'B','NGC 5612',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000137,NULL,'13.04',1,'SAB(s)b',NULL,NULL,NULL,NULL,1,218.5052083,-78.3875,0.453,NULL,44286275092,691973048,10812078,13.04),(122047,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122047,35.79,0.1,144,54380,70,NULL,NULL,'2MASX J14340149+0347508',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00008,NULL,'15.9g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,218.506125,3.79742,0.065,NULL,58316907907,911201686,14237526,15.9),(122048,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122048,34.99,0.68,99.6,54381,70,NULL,NULL,'2MASX J14340257-1720279',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,218.510625,-17.34108,0.337,NULL,46552150348,727377349,11365271,16.14),(122049,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122049,38.2,0.27,436,54382,70,NULL,NULL,'2MASX J14340363+2947578',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.515083333,29.79947,0,NULL,60017991792,937781121,14652830,17.1),(122050,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122050,35.79,0.1,144,54383,70,NULL,NULL,'CGCG 047-100',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000057,NULL,'15.3g',0.44,'E','Group member',NULL,NULL,NULL,1,218.516541667,3.74764,0.065,NULL,58316911246,911201738,14237527,15.3),(122051,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122051,36.76,0.16,225,54384,70,NULL,NULL,'2MASX J14340431+5239098',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000202,NULL,'16.1g',0.33,'S0',NULL,NULL,NULL,NULL,1,218.5177917,52.65283,0,NULL,59206679044,925104360,14454755,16.1),(122052,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122052,38.13,0.23,422,54385,70,NULL,NULL,'2MASX J14340425+5725134',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.517958333,57.42056,0,NULL,57251268938,894551077,13977360,17.8),(122053,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122053,34.61,0.55,83.5,54386,70,NULL,NULL,'MCG -01-37-008',NULL,'2014MNRAS.445.2677S',2014,1,1,'Diameter includes companions or long extensions.','G',0.0001,NULL,'14.91',0.5,'SBc            HII',NULL,NULL,NULL,NULL,1,218.518791667,-7.67567,0.153,NULL,43527065580,680110399,10626724,14.91),(122054,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122054,34.44,0.47,77.1,54386,NULL,NULL,'H','MCG -01-37-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122055,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122055,34.67,0.45,85.8,54386,NULL,NULL,'K','MCG -01-37-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122056,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122056,34.68,0.46,86.3,54386,NULL,NULL,'J','MCG -01-37-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122057,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122057,35.01,0.4,101,54386,NULL,NULL,'mean','MCG -01-37-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122058,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122058,34.58,NULL,82.6,54387,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 272- G 017',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000029,NULL,'16.23',0.13,'Sc',NULL,NULL,NULL,NULL,1,218.5217917,-43.17708,0.417,NULL,47091914840,735811169,11497049,16.23),(122059,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122059,34.58,NULL,82.6,54387,NULL,NULL,'Dipole + Quadrupole','ESO 272- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122060,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122060,34.59,NULL,82.6,54387,NULL,NULL,'Dipole','ESO 272- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122061,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122061,38.66,0.21,539,54388,70,NULL,NULL,'SDSS J143405.22+611943.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000166,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.5217917,61.32867,0.013,NULL,57753365170,902396330,14099942,18.5),(122062,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122062,35.48,0.46,125,54389,70,NULL,NULL,'CGCG 019-063',NULL,'2015arXiv151105856S',2015,1,1.16,NULL,'G',0.000113,NULL,'14.3g',0.77,'E0',NULL,NULL,NULL,NULL,1,218.524375,0.62008,0.089,NULL,58289254674,910769604,14230775,14.3),(122063,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122063,35.59,0.46,132,54390,70,NULL,NULL,'2MASX J14340627+5907044',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'15.4g',0.43,'S0',NULL,NULL,NULL,NULL,1,218.526167,59.11792,0,NULL,57722164436,901908819,14092325,15.4),(122064,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122064,37.87,0.46,376,54391,70,NULL,NULL,'2MASX J14340691+2536488',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.528833,25.61361,0.061,NULL,60022218490,937847163,14653861,17.9),(122065,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122065,38.18,0.19,432,54392,70,NULL,NULL,'SDSS J143406.96+171157.1',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.5290417,17.19922,0,NULL,59483027005,929422296,14522223,16.5),(122066,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122066,37.25,0.27,282,54393,70,NULL,NULL,'2MASX J14340707+2810348',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.529458333,28.17625,0,NULL,60025639540,937900617,14654697,17.5),(122067,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122067,38.13,0.46,423,54394,70,NULL,NULL,'SDSS J143407.80+312132.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.89',0.12,NULL,NULL,NULL,NULL,NULL,1,218.5325,31.35894,0,NULL,60046402195,938225034,14659766,18.89),(122068,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122068,35.79,0.1,144,54395,70,NULL,NULL,'2MASX J14340823+0354058',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000073,NULL,'15.9g',0.42,'S0',NULL,NULL,NULL,NULL,1,218.534416667,3.90156,0.065,NULL,58317396979,911209327,14237645,15.9),(122069,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122069,37.46,0.46,311,54396,70,NULL,NULL,'2MASX J14340971+5504153',NULL,'2015arXiv151105856S',2015,1,0.27,'1977AJ.....82..187F has z = 0.094198 +- 0.000334, with z flagged uncertain.','G',0.000161,NULL,'17.6g',0.2,NULL,'Group non-member, foreground',NULL,NULL,NULL,1,218.540417,55.07106,0,NULL,57257588813,894649825,13978903,17.6),(122070,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122070,38,0.27,398,54397,70,NULL,NULL,'2MASX J14340989+2832298',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.541208333,28.54178,0,NULL,60024858279,937888410,14654506,18.1),(122071,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122071,37.85,0.46,372,54398,70,NULL,NULL,'2MASX J14340991+2909508',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'18.21',0.17,'Sc',NULL,NULL,NULL,NULL,1,218.541333,29.16406,0.01,NULL,60017441095,937772517,14652695,18.21),(122072,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122072,38.66,0.21,539,54399,70,NULL,NULL,'SDSS J143409.95+613506.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.5415,61.58508,0.021,NULL,57760351658,902505494,14101648,18.5),(122073,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122073,38.17,0.46,430,54400,70,NULL,NULL,'2MASX J14341090+2002199',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.07',0.19,NULL,NULL,NULL,NULL,NULL,1,218.545417,20.03878,0.025,NULL,59512543713,929883495,14529429,18.07),(122074,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122074,34.85,0.69,93.2,54401,100,NULL,'mid-IR','UGC 09374',NULL,'2013ApJ...771...88L',2013,1,1.04,NULL,'G',0.000033,NULL,'15.0g',0.56,'BrClG;S?',NULL,NULL,NULL,NULL,1,218.545667,10.21217,0.033,NULL,59359849276,927497644,14492150,15),(122075,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122075,35.81,0.4,145,54401,NULL,NULL,'mean','UGC 09374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122076,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122076,36.09,0.47,165,54401,NULL,NULL,'H','UGC 09374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122077,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122077,36.11,0.45,167,54401,NULL,NULL,'K','UGC 09374',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122078,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122078,38.28,0.46,453,54402,70,NULL,NULL,'2MASX J14341166+1452377',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.548667,14.87722,0,NULL,59544620016,930384687,14537260,17.9),(122079,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122079,37.12,0.46,265,54403,70,NULL,NULL,'2MASX J14341172+2711468',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,218.5487917,27.19622,0.038,NULL,60023329191,937864518,14654133,18.32),(122080,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122080,38.25,0.46,447,54404,70,NULL,NULL,'2MASX J14341235+5303557',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.551541667,53.06558,0,NULL,59205549683,925086713,14454479,17.2),(122081,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122081,38.18,0.19,432,54405,70,NULL,NULL,'2MASX J14341245+1739357',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.5519583,17.65981,0,NULL,59483395437,929428053,14522313,17.6),(122082,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122082,34.14,0.47,67.4,54406,NULL,NULL,'H','NGC 5677',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'14.69',0.7,'S?             AGN',NULL,NULL,NULL,NULL,1,218.553083,25.46803,0.061,NULL,60022318929,937848733,14653886,14.69),(122083,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122083,34.22,0.46,69.7,54406,NULL,NULL,'J','NGC 5677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122084,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122084,34.25,0.45,70.8,54406,NULL,NULL,'K','NGC 5677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122085,'Tully-Fisher','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,NULL,122085,34.31,0.4,72.7,54406,NULL,NULL,'mean','NGC 5677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122086,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122086,37.66,0.46,341,54407,70,NULL,NULL,'2MASX J14341270+0858375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.5529583,8.97708,0.029,NULL,58276717283,910573707,14227714,17.5),(122087,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122087,37.52,0.46,320,54408,70,NULL,NULL,'2MASX J14341386+1243047',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.557833333,12.71797,0,NULL,59546241537,930410024,14537656,17.4),(122088,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122088,38.06,0.27,410,54409,70,NULL,NULL,'2MASXi J1434147+261731',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.5615,26.29208,0.023,NULL,60023827436,937872303,14654254,17.7),(122089,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122089,38.13,0.23,422,54410,70,NULL,NULL,'2MASX J14341565+5728163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.565417,57.47131,0,NULL,57252118621,894564353,13977568,18),(122090,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122090,37.07,0.46,260,54411,70,NULL,NULL,'2MASX J14341572+1255247',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.6g',0.12,'2MASS Extended Ver.2',NULL,NULL,NULL,NULL,1,218.565541667,12.92367,0,NULL,59546126610,930408228,14537628,17.6),(122091,'FP','2016-12-15 15:15:26','2016-12-16 11:20:40','1',NULL,'R',122091,37.83,0.46,367,54412,70,NULL,NULL,'2MASX J14341602+4212487',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.566708333,42.21361,0.017,NULL,59960927178,936889487,14638898,18.4),(122092,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122092,36.91,0.46,241,54413,70,NULL,NULL,'SDSS J143416.32+504835.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.5680417,50.80997,0,NULL,59201568313,925024504,14453507,17.1),(122093,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122093,35.56,0.46,129,54414,70,NULL,NULL,'2MASX J14341647+4012572',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'15.8g',0.34,'S0',NULL,NULL,NULL,NULL,1,218.5685,40.21586,0.029,NULL,59946256752,936660261,14635316,15.8),(122094,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122094,34.61,0.57,83.5,54415,70,NULL,NULL,'LCRS B143138.2-063929',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00009,NULL,'15.55',0.5,NULL,NULL,NULL,NULL,NULL,1,218.57,-6.87711,0.181,NULL,43526137678,680095901,10626498,15.55),(122095,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122095,38.17,0.27,431,54416,70,NULL,NULL,'2MASX J14341859+1343286',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.577583,13.72478,0,NULL,59545611506,930400179,14537502,18.2),(122096,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122096,37.73,0.46,352,54417,70,NULL,NULL,'2MASX J14341969+1718546',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.582125,17.31506,0.018,NULL,59483008472,929422007,14522218,17.9),(122097,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122097,38.2,0.27,436,54418,70,NULL,NULL,'2MASX J14342051+3005030',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,218.585541667,30.08431,0,NULL,60017977059,937780891,14652826,16.9),(122098,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122098,38.17,0.27,431,54419,70,NULL,NULL,'SDSS J143420.62+134512.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.585917,13.75333,0.01,NULL,59545612723,930400198,14537503,18.5),(122099,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122099,38.2,0.27,436,54420,70,NULL,NULL,'2MASX J14342074+2956010',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.5865417,29.93353,0,NULL,60017986456,937781038,14652828,17.7),(122100,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122100,36.35,0.46,186,54421,70,NULL,NULL,'2MASX J14342163+2318199',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000187,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.5902917,23.3055,0.066,NULL,59497746714,929652292,14525817,16),(122101,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122101,37.54,0.46,322,54422,70,NULL,NULL,'2MASXi J1434221+292011',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.5925,29.33658,0.01,NULL,60018328553,937786383,14652912,17.8),(122102,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122102,35.62,0.46,133,54423,70,NULL,NULL,'IC 1031',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000195,NULL,'15.0g',0.57,NULL,'Group member',NULL,NULL,NULL,1,218.599917,48.03744,0.033,NULL,59198658185,924979034,14452797,15),(122103,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122103,35.79,0.1,144,54424,70,NULL,NULL,'CGCG 047-102',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000083,NULL,'15.1g',0.58,'E0',NULL,NULL,NULL,NULL,1,218.603291667,2.79894,0.057,NULL,58308224587,911066009,14235406,15.1),(122104,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122104,38.17,0.27,431,54425,70,NULL,NULL,'2MASX J14342519+1347596',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,218.604917,13.79983,0.01,NULL,59545605466,930400085,14537501,18.27),(122105,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122105,37.91,0.46,382,54426,70,NULL,NULL,'2MASX J14342516+1410236',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.605,14.17331,0,NULL,59545140449,930392819,14537387,17.7),(122106,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122106,38.06,0.27,409,54427,70,NULL,NULL,'SDSS J143425.38+090750.7',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000158,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.6057917,9.13078,0.029,NULL,59364095724,927563995,14493187,18.7),(122107,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122107,37.5,0.33,316,54428,70,NULL,NULL,'2MASX J14342739+1349056',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.34',0.15,NULL,NULL,NULL,NULL,NULL,1,218.614125,13.81839,0,NULL,59545608046,930400125,14537501,18.34),(122108,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122108,37.2,0.33,276,54429,70,NULL,NULL,'2MASX J14342818+1438296',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,218.617541667,14.64156,0,NULL,59545349404,930396084,14537438,18.48),(122109,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122109,31.7,0.4,21.9,54430,75,NULL,'Edat, raw','IC 4453',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00004,NULL,'13.17',1,'SAB(rs)0^0^: sp',NULL,NULL,NULL,NULL,1,218.619375,-27.51856,0.389,NULL,47015414386,734615849,11478372,13.17),(122110,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122110,32.04,0.4,25.6,54430,75,NULL,'Edat, cor','IC 4453',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122111,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122111,32.61,0.45,33.3,54430,NULL,NULL,'K','IC 4453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122112,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122112,33.51,0.4,50.4,54430,NULL,NULL,'mean','IC 4453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122113,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SCP 06H03',NULL,122113,43.59,0.04,2830,54431,70,NULL,'SALT2, M(B) -19.307 mag, Alpha 0.124, Beta 1.460, Delta 0.023','FLX J143429.18+342739.0',0.85,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',0.0005,NULL,'16.9V',NULL,NULL,NULL,NULL,NULL,NULL,1,218.621708333,34.46086,0,NULL,60070042933,938594420,14665537,16.9),(122114,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SCP 06H05',NULL,122114,45.1,0.11,4690,54432,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','FLX J143430.10+342657.0',1.231,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',0.01,NULL,'15.9V',NULL,'Ia',NULL,NULL,NULL,NULL,1,218.625625,34.44922,0,NULL,60067163661,938549432,14664834,15.9),(122115,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122115,37.13,0.46,266,54433,70,NULL,NULL,'2MASX J14343020+1052340',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000159,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,218.626,10.876,0.005,NULL,59361124326,927517567,14492461,16.7),(122116,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122116,37.58,0.46,329,54434,70,NULL,NULL,'2MASX J14343154+0907300',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000186,NULL,'18.00',0.18,NULL,NULL,NULL,NULL,NULL,1,218.6315,9.12506,0.029,NULL,59364092949,927563952,14493186,18),(122117,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122117,34.46,0.49,78.1,54435,75,NULL,'IR','CGCG 104-044',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00004,NULL,'15.28',0.5,'S?',NULL,NULL,NULL,NULL,1,218.631833,19.74206,0.018,NULL,59512623418,929884740,14529449,15.28),(122118,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122118,38.18,0.19,432,54436,70,NULL,NULL,'2MASX J14343376+1712298',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.640833333,17.20825,0,NULL,59482985981,929421655,14522213,18.2),(122119,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122119,36.15,0.46,170,54437,70,NULL,NULL,'2MASX J14343440+2924424',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'15.03',0.32,'Sa',NULL,NULL,NULL,NULL,1,218.6435,29.41183,0.01,NULL,60018340955,937786577,14652915,15.03),(122120,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122120,37.09,0.23,261,54438,70,NULL,NULL,'2MASX J14343511+0951130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000188,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.646375,9.85372,0.017,NULL,59358931000,927483296,14491926,17.2),(122121,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122121,33.52,0.8,50.5,54439,75,NULL,'MAT, I','ESO 447- G 023',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000017,NULL,'13.0B',1.1,'SAB(rs)cd:     HII',NULL,NULL,NULL,NULL,1,218.646541667,-27.99528,0.389,NULL,47023249029,734738266,11480285,13),(122122,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122122,32.7,0.69,34.6,54439,100,NULL,'mid-IR','ESO 447- G 023',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122123,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122123,33.35,0.32,46.7,54439,85,NULL,'I, raw','ESO 447- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122124,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122124,33.38,0.32,47.5,54439,85,NULL,'I, inv','ESO 447- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122125,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122125,33.44,0.43,48.8,54439,75,NULL,'MAT, I, raw','ESO 447- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122126,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122126,33.55,0.43,51.4,54439,75,NULL,'3.6 micron, color corrected','ESO 447- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122127,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122127,33.56,0.43,51.6,54439,75,NULL,'3.6 micron, color + selection bias corrected','ESO 447- G 023',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122128,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122128,33.59,0.2,52.2,54439,74.4,NULL,NULL,'ESO 447- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122129,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122129,33.62,0.4,53,54439,NULL,NULL,'mean','ESO 447- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122130,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122130,33.63,0.43,53.3,54439,75,NULL,'MAT, I, inv','ESO 447- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122131,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122131,33.69,0.43,54.8,54439,75,NULL,'MAT, I, cor','ESO 447- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122132,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122132,33.72,0.4,55.6,54439,NULL,NULL,'Malmquist cor.','ESO 447- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122133,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122133,33.73,0.4,55.8,54439,NULL,NULL,NULL,'ESO 447- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122134,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122134,33.8,0.47,57.5,54439,NULL,NULL,'H','ESO 447- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122135,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122135,33.81,0.45,57.7,54439,NULL,NULL,'K','ESO 447- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122136,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122136,33.84,0.46,58.5,54439,NULL,NULL,'J','ESO 447- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122137,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122137,37.5,0.33,316,54440,70,NULL,NULL,'SDSS J143435.22+135006.2',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.64675,13.83508,0,NULL,59545607449,930400116,14537501,16.8),(122138,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122138,32.1,0.36,26.1,54441,74.2,NULL,'SALT 2','UGC 09391',0.00638,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000013,NULL,'14.6B',1,'SBdm','Dwarf, possible member',NULL,NULL,NULL,1,218.65425,59.33781,0,NULL,57768273004,902629265,14103582,14.6),(122139,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122139,32.61,0.17,33.1,54441,72,NULL,NULL,'UGC 09391',0.00638,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122140,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122140,32.63,0.16,33.4,54441,72,NULL,NULL,'UGC 09391',0.00638,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122141,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122141,32.73,0.05,35.2,54441,72,NULL,'M(H) = -18.317 mag','UGC 09391',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122142,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122142,32.77,0.04,35.6,54441,72,NULL,NULL,'UGC 09391',0.00638,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122143,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122143,32.79,0.15,36.1,54441,72,NULL,'VJHK','UGC 09391',0.00638,'2007A&A...469..645S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122144,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122144,32.83,0.1,36.8,54441,74.4,NULL,NULL,'UGC 09391',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122145,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122145,32.89,0.4,37.6,54441,NULL,NULL,NULL,'UGC 09391',0.00638,'2005A&A...429..667A',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122146,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122146,32.99,0.19,39.4,54441,72,NULL,NULL,'UGC 09391',0.00638,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122147,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2003du',NULL,122147,33.19,0.05,42.9,54441,65,NULL,'MLCS2k2','UGC 09391',0.00638,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122148,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122148,32.51,0.4,31.8,54441,75,NULL,'B','UGC 09391',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122149,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122149,32.6,0.4,33.1,54441,75,NULL,'HOSTS SN 2003du','UGC 09391',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122150,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122150,32.98,0.4,39.5,54442,75,NULL,'Edat, raw','IC 4451',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000107,NULL,'12.0',1.1,'E+:',NULL,NULL,NULL,NULL,1,218.65475,-36.28583,0.253,NULL,47220943619,737827244,11528550,12),(122151,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122151,33.34,0.4,46.6,54442,75,NULL,'Edat, cor','IC 4451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122152,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122152,33.53,0.47,50.7,54442,70,NULL,NULL,'IC 4451',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122153,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122153,33.73,0.4,55.8,54442,NULL,NULL,'mean','IC 4451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122154,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122154,33.91,0.45,60.5,54442,NULL,NULL,'K','IC 4451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122155,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122155,37.97,0.46,393,54443,70,NULL,NULL,'2MASX J14343819+1828128',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,218.659,18.47011,0.01,NULL,59479933855,929373966,14521468,18.68),(122156,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122156,37.35,0.46,295,54444,70,NULL,NULL,'2MASX J14343856+1445448',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.34',0.17,NULL,NULL,NULL,NULL,NULL,1,218.66075,14.76242,0,NULL,59544579070,930384047,14537250,18.34),(122157,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122157,31.68,0.4,21.7,54445,NULL,NULL,NULL,'UGC 09380',NULL,'2009AJ....138..323T',2009,1,1.9,'Multiple SDSS entries describe this object.','G',0.00002,NULL,'14.2',1,'Im; LSBG       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.663333,4.26278,0.065,NULL,58317334066,911208344,14237630,14.2),(122158,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122158,31.68,NULL,21.7,54445,72,NULL,NULL,'UGC 09380',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122159,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122159,32.27,0.4,28.5,54445,75,NULL,'B','UGC 09380',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122160,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122160,37.2,0.33,276,54446,70,NULL,NULL,'2MASX J14344001+1439478',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,218.6667083,14.66344,0,NULL,59545296888,930395263,14537425,18.44),(122161,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122161,38.06,0.27,410,54447,70,NULL,NULL,'SDSS J143440.62+262632.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.66925,26.44242,0.023,NULL,60023798869,937871857,14654247,18.5),(122162,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122162,38.06,0.27,410,54448,70,NULL,NULL,'2MASX J14344081+2620284',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.669917,26.34136,0.023,NULL,60023795515,937871804,14654246,16.8),(122163,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122163,37.51,0.46,318,54449,70,NULL,NULL,'SDSS J143441.26+253011.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.671958333,25.50328,0.061,NULL,60022265638,937847900,14653873,18.5),(122164,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122164,36.52,0.46,202,54450,70,NULL,NULL,'2MASX J14344213+0054500',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.675667,0.91386,0.093,NULL,58288693815,910760840,14230638,16.5),(122165,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122165,38.04,0.33,405,54451,70,NULL,NULL,'SDSS J143442.56+245323.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.677375,24.88978,0.085,NULL,59498817297,929669020,14526078,18.4),(122166,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122166,37.72,0.46,351,54452,70,NULL,NULL,'2MASX J14344275+0947470',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,218.678208333,9.79631,0.017,NULL,59358954767,927483668,14491932,18.24),(122167,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122167,38.18,0.19,432,54453,70,NULL,NULL,'SDSS J143442.88+172154.5',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,218.6787083,17.36514,0,NULL,59483037280,929422457,14522225,16.5),(122168,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122168,34.8,0.8,91.1,54454,75,NULL,'MAT, I','ESO 512- G 005',NULL,'1997ApJS..109..333W',1997,1,1.74,NULL,'G',0.00002,NULL,'16.61',0.09,'Sc',NULL,NULL,NULL,NULL,1,218.68,-25.44389,0.309,NULL,47016514593,734633040,11478641,16.61),(122169,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122169,34.36,0.32,74.5,54454,85,NULL,'I, raw','ESO 512- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122170,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122170,34.36,0.32,74.6,54454,85,NULL,'I, inv','ESO 512- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122171,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122171,34.46,NULL,78,54454,NULL,NULL,NULL,'ESO 512- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122172,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122172,34.49,0.43,79.2,54454,75,NULL,'MAT, I, raw','ESO 512- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122173,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122173,34.56,0.43,81.5,54454,75,NULL,'MAT, I, inv','ESO 512- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122174,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122174,34.62,NULL,84.1,54454,NULL,NULL,'Dipole + Quadrupole','ESO 512- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122175,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122175,34.63,NULL,84.3,54454,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 512- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122176,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122176,34.64,NULL,84.6,54454,NULL,NULL,'Dipole','ESO 512- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122177,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122177,34.83,0.43,92.6,54454,75,NULL,'MAT, I, cor','ESO 512- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122178,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122178,34.93,0.45,96.7,54454,NULL,NULL,'Malmquist cor.','ESO 512- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122179,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122179,34.99,0.2,99.5,54454,74.4,NULL,NULL,'ESO 512- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122180,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122180,35.01,0.44,101,54454,NULL,NULL,NULL,'ESO 512- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122181,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122181,38.06,0.27,409,54455,70,NULL,NULL,'2MASX J14344316+0907060',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.68,9.11836,0.029,NULL,59364092220,927563940,14493186,17.7),(122182,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122182,38.04,0.33,405,54456,70,NULL,NULL,'2MASX J14344330+2448354',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,218.680541667,24.80989,0.091,NULL,59498819774,929669058,14526079,17.1),(122183,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122183,38.42,0.46,484,54457,70,NULL,NULL,'2MASX J14344458+1040260',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.6859583,10.67381,0.009,NULL,59359220077,927487813,14491997,17.8),(122184,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122184,32.8,0.8,36.3,54458,75,NULL,'B','NGC 5682',NULL,'1988NBGC.C....0000T',1988,1,2.13,NULL,'G',0.000012,NULL,'14.5g',0.47,'SB(s)b         Sy1','in a pair',NULL,NULL,NULL,1,218.687416667,48.67025,0.129,NULL,59199421925,924990967,14452983,14.5),(122185,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122185,32.55,0.2,32.4,54458,74.4,NULL,NULL,'NGC 5682',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122186,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122186,37.09,0.23,261,54459,70,NULL,NULL,'SDSS J143445.22+095525.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,218.688458333,9.92383,0.017,NULL,59358929740,927483277,14491926,18),(122187,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122187,33.69,0.8,54.7,54460,75,NULL,'MAT, I','ESO 385- G 047',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00001,NULL,'15.09',1.6,'SB.../Irr',NULL,NULL,NULL,NULL,1,218.6897083,-32.97928,0.233,NULL,46998142075,734345969,11474155,15.09),(122188,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122188,30.85,0.32,14.8,54460,85,NULL,'I, inv','ESO 385- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122189,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122189,30.92,0.32,15.3,54460,85,NULL,'I, raw','ESO 385- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122190,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122190,31.85,0.43,23.4,54460,75,NULL,'MAT, I, inv','ESO 385- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122191,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122191,31.98,0.43,24.9,54460,75,NULL,'MAT, I, raw','ESO 385- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122192,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122192,32.28,0.43,28.6,54460,75,NULL,'MAT, I, cor','ESO 385- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122193,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122193,32.96,0.94,39.1,54460,NULL,NULL,NULL,'ESO 385- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122194,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122194,33,0.2,39.8,54460,74.4,NULL,NULL,'ESO 385- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122195,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122195,33.55,0.71,51.2,54460,NULL,NULL,'Malmquist cor.','ESO 385- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122196,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122196,37.16,0.46,271,54461,70,NULL,NULL,'2MASX J14344669+2255336',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,218.6945,22.92589,0.062,NULL,59497705538,929651649,14525807,16.5),(122197,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122197,37.47,0.46,312,54462,70,NULL,NULL,'2MASX J14344727+0815100',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.6970417,8.25267,0.017,NULL,58277704154,910589127,14227955,16.8),(122198,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122198,37.65,0.46,339,54463,70,NULL,NULL,'2MASX J14344775+5625194',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.6987917,56.422,0,NULL,57259987668,894687307,13979489,17.6),(122199,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122199,37.32,0.46,291,54464,70,NULL,NULL,'SDSS J143447.91+051753.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.699666667,5.29811,0.057,NULL,58310691285,911104551,14236008,18),(122200,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122200,35.95,0.2,155,54465,74.4,NULL,NULL,'CGCG 075-078',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00017,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,218.7002083,10.02558,0.033,NULL,59359812716,927497073,14492141,15.9),(122201,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122201,38.25,0.46,446,54466,70,NULL,NULL,'2MASX J14344878+2316016',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.7032917,23.26719,0.069,NULL,59497760214,929652503,14525820,18),(122202,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122202,38.66,0.21,539,54467,70,NULL,NULL,'2MASX J14345056+6136478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.711167,61.6135,0.021,NULL,57760613660,902509588,14101712,17.8),(122203,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122203,38.18,0.19,432,54468,70,NULL,NULL,'2MASX J14345071+1740047',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.45',0.14,NULL,NULL,NULL,NULL,NULL,1,218.7112917,17.668,0,NULL,59482959849,929421247,14522206,18.45),(122204,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122204,37.78,0.46,359,54469,70,NULL,NULL,'2MASX J14345178+4307539',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.7157917,43.13172,0.024,NULL,59961355365,936896177,14639002,17.6),(122205,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122205,38.25,0.46,446,54470,70,NULL,NULL,'2MASX J14345233+0653213',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000185,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.7182083,6.88944,0.045,NULL,58279723289,910620676,14228448,17.8),(122206,'SBF','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122206,32.23,0.51,27.9,54471,NULL,NULL,'I','NGC 5687',NULL,'2001ApJ...546..681T',2001,1,2.13,NULL,'G',0.000017,NULL,'12.8g',1.08,'S0-?','Isolated galaxy',NULL,NULL,NULL,1,218.718333,54.47586,0,NULL,59191082462,924860663,14450947,12.8),(122207,'SBF','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122207,32.3,0.14,28.8,54471,74.4,NULL,NULL,'NGC 5687',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122208,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122208,32.68,0.8,34.4,54471,75,NULL,'B','NGC 5687',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122209,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122209,32.69,0.4,34.5,54471,NULL,NULL,'mean','NGC 5687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122210,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122210,33.23,0.45,44.4,54471,NULL,NULL,'K','NGC 5687',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122211,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122211,38.49,0.46,498,54472,70,NULL,NULL,'2MASX J14345404+1154297',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,218.725167,11.90819,0.025,NULL,59360379574,927505930,14492280,18.5),(122212,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122212,38.45,0.46,490,54473,70,NULL,NULL,'2MASX J14345434+2407348',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.726375,24.1265,0.096,NULL,59499425110,929678517,14526226,18.6),(122213,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122213,38.32,0.27,461,54474,70,NULL,NULL,'2MASX J14345436+2254086',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.7265417,22.90231,0.062,NULL,59497649772,929650777,14525793,17.9),(122214,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122214,37.61,0.46,332,54475,70,NULL,NULL,'2MASX J14345505+0818153',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.729416667,8.30442,0.017,NULL,58277582996,910587234,14227925,17.4),(122215,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122215,36.44,0.46,194,54476,70,NULL,NULL,'2MASX J14345520+0851123',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000083,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,218.729917,8.85347,0.025,NULL,59364101975,927564093,14493188,15.6),(122216,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122216,34.92,0.49,96.5,54477,75,NULL,'IR','MCG -01-37-009',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00015,NULL,'16',0.2,'S?             HII',NULL,NULL,NULL,NULL,1,218.737333,-8.84106,0.189,NULL,46465584468,726024757,11344136,16),(122217,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122217,35,0.4,99.9,54477,NULL,NULL,'mean','MCG -01-37-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122218,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122218,35.13,0.47,106,54477,NULL,NULL,'H','MCG -01-37-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122219,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122219,35.26,0.45,113,54477,NULL,NULL,'K','MCG -01-37-009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122220,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122220,35.48,0.2,125,54477,74.4,NULL,NULL,'MCG -01-37-009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122221,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122221,35.53,0.5,128,54477,NULL,NULL,'Malmquist cor.','MCG -01-37-009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122222,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122222,35.71,0.46,138,54477,NULL,NULL,NULL,'MCG -01-37-009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122223,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122223,37.02,0.46,254,54478,70,NULL,NULL,'2MASX J14345715+4039520',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.73825,40.66439,0.011,NULL,59946155898,936658685,14635291,17.2),(122224,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122224,37.11,0.46,264,54479,70,NULL,NULL,'2MASX J14345797+0237403',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000094,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.7415,2.62794,0.089,NULL,58308386407,911068537,14235445,17.1),(122225,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122225,38.08,0.46,414,54480,70,NULL,NULL,'SDSS J143459.57+304433.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000166,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.7482083,30.7425,0,NULL,60016558218,937758722,14652480,18.3),(122226,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122226,35.96,0.46,156,54481,70,NULL,NULL,'2MASX J14350112+2950248',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.754833,29.84019,0,NULL,60017954537,937780539,14652820,16.4),(122227,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122227,38.77,0.46,568,54482,70,NULL,NULL,'2MASX J14350197+4652529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.758333,46.88139,0.013,NULL,59953610043,936775156,14637111,17.8),(122228,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122228,37.69,0.46,345,54483,70,NULL,NULL,'SDSS J143502.29+463040.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,218.759583,46.51125,0.009,NULL,59953548903,936774201,14637096,18.6),(122229,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122229,28.82,NULL,5.81,54484,NULL,NULL,NULL,'ESO 222- G 010',NULL,'2013AJ....145..101K',2013,1,1,NULL,'G',0.000017,NULL,'16.33',0.5,'cl.to br.*',NULL,NULL,NULL,NULL,1,218.76075,-49.42064,0.869,NULL,46782571338,730977677,11421526,16.33),(122230,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122230,38.37,0.46,473,54485,70,NULL,NULL,'2MASX J14350331+5603423',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.763833,56.06169,0.005,NULL,57259687822,894682622,13979415,17.2),(122231,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122231,38.29,0.46,454,54486,70,NULL,NULL,'SDSS J143503.58+061145.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.764917,6.19608,0.053,NULL,58278182344,910596599,14228071,18.5),(122232,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122232,37.96,0.46,391,54487,70,NULL,NULL,'2MASX J14350563-0045358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.7734583,-0.76006,0.089,NULL,43512564009,679883812,10623184,17.6),(122233,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122233,37.09,0.23,261,54488,70,NULL,NULL,'2MASX J14350737+0945443',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.7807083,9.76236,0.025,NULL,59358960959,927483764,14491933,17.6),(122234,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122234,38.15,0.46,426,54489,70,NULL,NULL,'SDSS J143507.55+214818.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.7814583,21.80517,0.086,NULL,59502647307,929728864,14527013,NULL),(122235,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122235,37.4,0.46,302,54490,70,NULL,NULL,'2MASX J14350784+1600445',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.12',0.16,NULL,NULL,NULL,NULL,NULL,1,218.782833,16.01225,0,NULL,59551959172,930499362,14539052,18.12),(122236,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122236,39.23,0.46,701,54491,70,NULL,NULL,'SDSS J143508.78+461816.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,218.786625,46.30447,0.025,NULL,59954376359,936787130,14637298,18.7),(122237,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122237,37.94,0.46,388,54492,70,NULL,NULL,'2MASX J14350926+2422068',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.78875,24.36858,0.095,NULL,59499102129,929673470,14526147,18),(122238,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122238,37.3,0.46,289,54493,70,NULL,NULL,'2MASX J14350959+2442368',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.42',0.17,NULL,NULL,NULL,NULL,NULL,1,218.790041667,24.71019,0.095,NULL,59498760196,929668128,14526064,18.42),(122239,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122239,37.54,0.46,323,54494,70,NULL,NULL,'2MASX J14351191+0741364',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.7997917,7.69356,0.041,NULL,58277037630,910578712,14227792,17.1),(122240,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122240,37.65,0.46,338,54495,70,NULL,NULL,'2MASX J14351191+2310026',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000186,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.799833,23.16728,0.069,NULL,59497742076,929652219,14525815,17),(122241,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122241,38.34,0.46,465,54496,70,NULL,NULL,'SDSS J143512.88+242557.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.803708333,24.43272,0.095,NULL,59499097154,929673393,14526146,17.4),(122242,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122242,36.71,0.46,220,54497,70,NULL,NULL,'2MASX J14351323+0826074',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.64',0.22,NULL,NULL,NULL,NULL,NULL,1,218.8052083,8.43544,0.021,NULL,58276893308,910576457,14227757,17.64),(122243,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122243,37.99,0.46,397,54498,70,NULL,NULL,'2MASX J14351374+4300519',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.807333,43.01467,0.022,NULL,59961333409,936895834,14638997,17.7),(122244,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122244,37.53,0.46,321,54499,70,NULL,NULL,'2MASX J14351472+2439208',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,218.8112917,24.65564,0.095,NULL,59498658876,929666544,14526039,16.5),(122245,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122245,38.06,0.27,409,54500,70,NULL,NULL,'2MASX J14351483+0913094',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.811667,9.21919,0.025,NULL,59372497948,927695280,14495238,17.1),(122246,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122246,37.77,0.46,358,54501,70,NULL,NULL,'2MASX J14351692+0419304',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000094,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,218.8205417,4.32506,0.065,NULL,58317126439,911205100,14237579,16.4),(122247,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122247,34.63,0.8,84.3,54502,75,NULL,'HMCL, I','UGC 09387',NULL,'1997ApJS..109..333W',1997,1,0.91,NULL,'G',0.00007,NULL,'15.2g',0.42,'SB0(ring)',NULL,NULL,NULL,NULL,1,218.821333,22.96264,0.062,NULL,59497672462,929651132,14525798,15.2),(122248,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122248,34.65,0.4,85,54502,75,NULL,'HMCL, I, raw','UGC 09387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122249,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122249,34.78,0.4,90.3,54502,75,NULL,'HMCL, I, inv','UGC 09387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122250,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122250,34.94,0.4,97.5,54502,75,NULL,'HMCL, I, cor','UGC 09387',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122251,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122251,37.65,0.46,338,54503,70,NULL,NULL,'2MASX J14351724+1713025',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.82175,17.21747,0,NULL,59483060828,929422825,14522231,17.8),(122252,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122252,37.7,0.33,346,54504,70,NULL,NULL,'SDSS J143517.81+183545.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.82425,18.59603,0.027,NULL,59479913523,929373648,14521463,17.5),(122253,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122253,38.32,0.27,461,54505,70,NULL,NULL,'SDSS J143517.87+225339.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.8245,22.89419,0.062,NULL,59505189084,929768579,14527634,18.3),(122254,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122254,38.03,0.33,404,54506,70,NULL,NULL,'2MASX J14351799+2823137',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,218.825041667,28.38722,0,NULL,60025559424,937899366,14654677,18.42),(122255,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122255,37.36,0.46,296,54507,70,NULL,NULL,'SDSS J143518.43+195154.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.826833,19.86503,0.018,NULL,59512609994,929884531,14529445,18),(122256,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122256,36.48,0.46,198,54508,70,NULL,NULL,'2MASX J14351962+1643535',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,218.83175,16.73147,0,NULL,59482006364,929406349,14521974,18.29),(122257,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122257,38.03,0.33,404,54509,70,NULL,NULL,'SDSS J143519.91+282241.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.8g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.833,28.37819,0,NULL,60025677407,937901209,14654706,16.8),(122258,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122258,38.6,0.46,525,54510,70,NULL,NULL,'2MASX J14352103+2355206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,218.837458333,23.92247,0.099,NULL,59499449239,929678894,14526232,18.77),(122259,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122259,37.9,0.46,381,54511,70,NULL,NULL,'2MASX J14352162+2354376',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.840167,23.9105,0.078,NULL,59499448710,929678886,14526232,17.1),(122260,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122260,38.1,0.46,416,54512,70,NULL,NULL,'2MASX J14352162+5051233',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,218.840333,50.85636,0,NULL,59199778907,924996545,14453071,17.3),(122261,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122261,36.95,0.46,246,54513,70,NULL,NULL,'2MASX J14352193+0757497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'18.11',0.19,NULL,NULL,NULL,NULL,NULL,1,218.841375,7.96367,0.041,NULL,58277526867,910586357,14227911,18.11),(122262,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122262,37.59,0.46,330,54514,70,NULL,NULL,'SDSS J143522.58+122411.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.844125,12.40314,0.009,NULL,59543935435,930373991,14537093,17.2),(122263,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122263,32.22,0.8,27.8,54515,75,NULL,NULL,'UGC 09385',NULL,'1988NBGC.C....0000T',1988,1,0.51,NULL,'G',0.000013,NULL,'17.3g',0.37,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.844958333,5.27656,0.069,NULL,58310620116,911103439,14235991,17.3),(122264,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122264,37.76,0.33,357,54516,70,NULL,NULL,'2MASX J14352351+2058446',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.847791667,20.97917,0.065,NULL,59502894475,929732726,14527073,16.6),(122265,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122265,34.99,0.2,99.5,54517,74.4,NULL,NULL,'KUG 1432+096',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00008,NULL,'15.3g',0.4,'Sa',NULL,NULL,NULL,NULL,1,218.8489583,9.46492,0.025,NULL,59372689934,927698280,14495285,15.3),(122266,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122266,37.08,0.27,261,54518,70,NULL,NULL,'2MASX J14352435+5756139',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,218.851208333,57.93733,0.013,NULL,57251515438,894554928,13977420,16.1),(122267,'Brightest Stars','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122267,29.52,0.2,8.02,54519,NULL,NULL,NULL,'UGC 09405',NULL,'1998A&AS..133..181M',1998,1,1.17,NULL,'G',0.00002,NULL,'15.1g',0.71,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.850333,57.25594,0,NULL,57250853601,894544587,13977259,15.1),(122268,'TRGB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122268,28.82,0.1,5.81,54519,74.4,NULL,NULL,'UGC 09405',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122269,'TRGB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122269,29,0.13,6.3,54519,NULL,NULL,NULL,'UGC 09405',NULL,'2015AstL...41..239T',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122270,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122270,28.79,0.8,5.7,54519,75,NULL,NULL,'UGC 09405',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122271,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122271,37.55,0.33,323,54520,70,NULL,NULL,'2MASX J14352483+1358096',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,218.8535,13.96936,0,NULL,59545177017,930393390,14537396,18.42),(122272,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122272,36.4,0.46,191,54521,70,NULL,NULL,'2MASX J14352496+5504369',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.4g',0.29,NULL,'Group non-member, foreground',NULL,NULL,NULL,1,218.854041667,55.07694,0,NULL,57257620440,894650319,13978911,16.4),(122273,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122273,38.32,0.27,461,54522,70,NULL,NULL,'2MASX J14352510+2256056',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,218.854833,22.93506,0.062,NULL,59505218400,929769037,14527641,17.3),(122274,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122274,37.06,0.46,258,54523,70,NULL,NULL,'2MASX J14352557-0123564',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.856667,-1.39908,0.109,NULL,43545653601,680400837,10631263,17.4),(122275,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122275,35.92,0.46,153,54524,70,NULL,NULL,'2MASX J14352601+5157503',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,218.8585417,51.96414,0.005,NULL,59206654404,925103975,14454749,16.1),(122276,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122276,37.62,0.46,335,54525,70,NULL,NULL,'2MASX J14352638+3021087',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.859917,30.35256,0,NULL,60017913925,937779905,14652811,17.6),(122277,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122277,37.76,0.33,357,54526,70,NULL,NULL,'2MASX J14352643+2948565',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.860125,29.81569,0,NULL,60018033468,937781772,14652840,17.7),(122278,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122278,36.27,0.46,179,54527,70,NULL,NULL,'2MASX J14352709+5842389',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,218.8629583,58.71069,0,NULL,57722980414,901921568,14092524,16.7),(122279,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122279,36.64,0.46,213,54528,70,NULL,NULL,'2MASX J14352715+2101146',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.37',0.28,NULL,NULL,NULL,NULL,NULL,1,218.8630417,21.02064,0.065,NULL,59502902579,929732852,14527075,17.37),(122280,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122280,37.7,0.33,346,54529,70,NULL,NULL,'2MASX J14352715+1833126',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.84',0.12,NULL,NULL,NULL,NULL,NULL,1,218.8632083,18.55358,0.027,NULL,59479909896,929373592,14521462,18.84),(122281,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122281,35.3,0.46,115,54530,70,NULL,NULL,'CGCG 133-091',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000165,NULL,'15.4g',0.47,NULL,NULL,NULL,NULL,NULL,1,218.865583333,23.53878,0.078,NULL,59499388815,929677950,14526217,15.4),(122282,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122282,37.76,0.33,357,54531,70,NULL,NULL,'SDSS J143528.08+210254.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.867,21.04856,0.065,NULL,59502903138,929732861,14527075,18.2),(122283,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122283,34.73,NULL,88.2,54532,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09390',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000017,NULL,'17.2g',0.09,'Sd',NULL,NULL,NULL,NULL,1,218.872583,22.40631,0.063,NULL,59504769095,929762017,14527531,17.2),(122284,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122284,34.75,NULL,89.2,54532,NULL,NULL,'Dipole + Quadrupole','UGC 09390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122285,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122285,34.75,NULL,89.3,54532,NULL,NULL,'Dipole','UGC 09390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122286,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122286,32.76,0.8,35.6,54533,75,NULL,'B','NGC 5689',NULL,'1988NBGC.C....0000T',1988,1,3.5,NULL,'G',0.000033,NULL,'12.8',1,'SB(s)0/a:','in a radial-velocity based grouping',NULL,NULL,NULL,1,218.8737083,48.74164,0.121,NULL,59199406320,924990723,14452980,12.8),(122287,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122287,38.19,0.46,435,54534,70,NULL,NULL,'2MASX J14353154+3235317',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,218.881416667,32.59214,0,NULL,60045758704,938214979,14659609,18.1),(122288,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122288,37.33,0.46,293,54535,70,NULL,NULL,'2MASX J14353216+4337170',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.883875,43.62133,0.095,NULL,59961252632,936894572,14638977,17.9),(122289,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122289,35.61,0.46,132,54536,70,NULL,NULL,'2MASX J14353261+6331475',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000076,NULL,'15.8g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,218.886167,63.52994,0.049,NULL,57757420256,902459691,14100932,15.8),(122290,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122290,32.31,0.4,29,54537,75,NULL,NULL,'UGC 09389',NULL,'2008Ap.....51..336K',2008,1,2.31,NULL,'G',0.00002,NULL,'14.1g',0.57,'SBb','Pair member (points to parent)',NULL,NULL,NULL,1,218.888666667,12.90825,0.021,NULL,59544049023,930375765,14537121,14.1),(122291,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122291,32.33,0.2,29.2,54537,74.4,NULL,NULL,'UGC 09389',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122292,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122292,32.59,0.43,32.9,54537,75,NULL,'3.6 micron, color corrected','UGC 09389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122293,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122293,32.88,0.43,37.6,54537,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09389',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122294,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122294,33.24,0.49,44.5,54537,75,NULL,'IR','UGC 09389',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122295,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122295,34.57,0.8,82.2,54538,75,NULL,'HMCL, I','CGCG 133-090',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000047,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,218.89175,22.73247,0.062,NULL,59505188267,929768566,14527633,15.5),(122296,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122296,33.84,0.2,58.6,54538,74.4,NULL,NULL,'CGCG 133-090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122297,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122297,34.27,0.4,71.5,54538,75,NULL,'HMCL, I, raw','CGCG 133-090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122298,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122298,34.36,0.4,74.5,54538,75,NULL,'HMCL, I, inv','CGCG 133-090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122299,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122299,34.45,0.4,77.7,54538,75,NULL,'HMCL, I, cor','CGCG 133-090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122300,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122300,36.98,0.46,249,54539,70,NULL,NULL,'SDSS J143535.34+501123.9',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000201,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,218.89725,50.19,0.029,NULL,59201740017,925027187,14453549,15.7),(122301,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122301,37.76,0.33,357,54540,70,NULL,NULL,'SDSS J143535.71+295130.4',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.8987917,29.85844,0,NULL,60018035448,937781803,14652840,16.9),(122302,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122302,31.88,0.4,23.7,54541,75,NULL,'Edat, raw','NGC 5670',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00005,NULL,'12.95',1,'SAB(s:)0^0',NULL,NULL,NULL,NULL,1,218.900125,-45.96697,0.613,NULL,47081897943,735654655,11494603,12.95),(122303,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122303,32.21,0.4,27.7,54541,75,NULL,'Edat, cor','NGC 5670',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122304,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122304,32.96,0.8,39,54541,75,NULL,NULL,'NGC 5670',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122305,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122305,31.89,0.45,23.8,54541,NULL,NULL,'K','NGC 5670',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122306,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122306,32.88,0.4,37.7,54541,NULL,NULL,'mean','NGC 5670',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122307,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122307,38.18,0.19,432,54542,70,NULL,NULL,'SDSS J143536.14+173755.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.900625,17.63206,0,NULL,59482937141,929420892,14522201,16.9),(122308,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122308,37.65,0.33,339,54543,70,NULL,NULL,'2MASX J14353637+4317060',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,218.90175,43.28525,0.024,NULL,59961486419,936898225,14639034,17.4),(122309,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122309,37.97,0.78,393,54544,70,NULL,NULL,'2MASX J14353644-0523104',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.37',0.18,NULL,NULL,NULL,NULL,NULL,1,218.901875,-5.38631,0.177,NULL,43543957917,680374342,10630849,17.37),(122310,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122310,37.01,0.46,252,54545,70,NULL,NULL,'2MASX J14353673+5915279',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.903,59.25783,0,NULL,57768230062,902628594,14103571,17.1),(122311,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122311,37.76,0.27,357,54546,70,NULL,NULL,'2MASX J14353710-0027384',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.9045417,-0.46069,0.105,NULL,43511893244,679873331,10623020,17.7),(122312,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122312,32.03,0.75,25.4,54547,NULL,NULL,'Malmquist cor.','UGC 09394',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'GTrpl',0.00003,NULL,NULL,NULL,'Scd?','Pair member (points to parent)',NULL,NULL,NULL,1,218.912083,13.16556,0,NULL,59545619559,930400305,14537504,NULL),(122313,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122313,32.21,0.2,27.7,54547,74.4,NULL,NULL,'UGC 09394',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122314,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122314,32.22,0.43,27.8,54547,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122315,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122315,32.24,0.43,28,54547,75,NULL,'3.6 micron, color corrected','UGC 09394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122316,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122316,32.3,0.4,28.8,54547,NULL,NULL,NULL,'UGC 09394',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122317,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122317,32.41,0.63,30.3,54547,NULL,NULL,NULL,'UGC 09394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122318,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122318,37.78,0.46,360,54548,70,NULL,NULL,'2MASX J14353920+1930585',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.9135,19.51636,0.024,NULL,59509119070,929829985,14528593,17.7),(122319,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122319,37.55,0.33,323,54549,70,NULL,NULL,'2MASX J14354210+1356316',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.01',0.19,NULL,NULL,NULL,NULL,NULL,1,218.9255417,13.94208,0,NULL,59545174278,930393348,14537396,18.01),(122320,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122320,37.18,0.46,273,54550,70,NULL,NULL,'2MASX J14354218+2135508',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.39',0.27,NULL,NULL,NULL,NULL,NULL,1,218.925833,21.59731,0.069,NULL,59502691551,929729555,14527024,17.39),(122321,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122321,38.85,0.46,589,54551,70,NULL,NULL,'2MASX J14354241+1554186',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,218.926833333,15.90514,0,NULL,59551979937,930499686,14539057,NULL),(122322,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122322,37.09,0.23,261,54552,70,NULL,NULL,'2MASX J14354248+0943268',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,218.927166667,9.72394,0.025,NULL,59372662702,927697854,14495278,17.4),(122323,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122323,34.35,0.69,74.1,54553,100,NULL,'mid-IR','NGC 5681',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000133,NULL,'14.3P',0.6,'SA:(rs)bc II',NULL,NULL,NULL,NULL,1,218.928625,8.30061,0.021,NULL,58277571322,910587051,14227922,14.3),(122324,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122324,35.3,0.4,115,54553,NULL,NULL,'mean','NGC 5681',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122325,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122325,35.56,0.47,129,54553,NULL,NULL,'H','NGC 5681',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122326,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122326,37.66,0.46,340,54554,70,NULL,NULL,'2MASX J14354323+5220043',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,218.930375,52.33461,0,NULL,59205910571,925092352,14454568,17.3),(122327,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122327,36.54,0.19,204,54555,70,NULL,NULL,'2MASX J14354331+6004394',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'16.8g',0.29,'NLAGN',NULL,NULL,NULL,NULL,1,218.930375,60.07761,0,NULL,57768911715,902639245,14103738,16.8),(122328,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122328,34.73,0.46,88.1,54556,70,NULL,NULL,'CGCG 192-045',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000111,NULL,'15.2g',0.45,'Sy2',NULL,NULL,NULL,'Sy 2',1,218.934,35.07614,0,NULL,60070229191,938597331,14665583,15.2),(122329,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122329,35.48,0.46,125,54557,70,NULL,NULL,'2MASX J14354434+0459348',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.12',0.31,NULL,NULL,NULL,NULL,NULL,1,218.934875,4.99308,0.065,NULL,58310757772,911105590,14236024,16.12),(122330,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122330,38.03,0.46,404,54558,70,NULL,NULL,'2MASX J14354476+2552015',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,218.936541667,25.867,0.065,NULL,60022378076,937849657,14653900,17.1),(122331,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122331,36.44,0.33,194,54559,70,NULL,NULL,'2MASX J14354629+1755236',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.17',0.23,NULL,NULL,NULL,NULL,NULL,1,218.943041667,17.92325,0,NULL,59480217792,929378403,14521537,17.17),(122332,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122332,37.86,0.46,373,54560,70,NULL,NULL,'2MASX J14354651+3833582',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.9437083,38.56606,0.009,NULL,60076535324,938695864,14667122,17.3),(122333,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122333,37.53,0.46,321,54561,70,NULL,NULL,'2MASX J14354657+0219563',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,218.9442917,2.33225,0.089,NULL,58308350705,911067979,14235437,18),(122334,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122334,37.76,0.27,357,54562,70,NULL,NULL,'2MASX J14354663-0022164',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000111,NULL,'16.8g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,218.944417,-0.37125,0.121,NULL,43511930960,679873921,10623030,16.8),(122335,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122335,37.34,0.46,294,54563,70,NULL,NULL,'2MASX J14354687+4305358',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000185,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,218.9452917,43.0935,0.024,NULL,59961452819,936897700,14639026,16.1),(122336,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122336,37.76,0.27,357,54564,70,NULL,NULL,'2MASX J14354723-0028374',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000091,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,218.947,-0.47714,0.105,NULL,43511867401,679872928,10623014,16.6),(122337,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122337,37.36,0.46,297,54565,70,NULL,NULL,'2MASX J14354744+4509188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,218.9475417,45.15539,0.024,NULL,59957356402,936833693,14638026,16.7),(122338,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122338,31.35,NULL,18.6,54566,72,NULL,NULL,'UGC 09392',NULL,'2014Ap.....57..457K',2014,1,0.87,NULL,'G',0.000019,NULL,'17.5g',0.19,'Irr(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,218.9517917,3.03825,0.061,NULL,58306543817,911039747,14234996,17.5),(122339,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122339,31.63,NULL,21.2,54567,72,NULL,NULL,'SDSS J143549.94+023618.4',NULL,'2014Ap.....57..457K',2014,1,0.7,NULL,'G',0.000067,NULL,'16.8',0.2,'Irr(f)',NULL,NULL,NULL,NULL,1,218.9587917,2.60547,0.097,NULL,58306443959,911038186,14234971,16.8),(122340,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122340,37.28,0.46,285,54568,70,NULL,NULL,'SDSS J143550.36-003651.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00006,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,218.959833,-0.61442,0.105,NULL,43545338544,680395914,10631186,18.2),(122341,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122341,36.55,0.46,204,54569,70,NULL,NULL,'MCG +05-34-079',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.00009,NULL,'15.1g',0.63,NULL,NULL,NULL,NULL,NULL,1,218.960833,28.14686,0.023,NULL,60025696303,937901504,14654711,15.1),(122342,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122342,38.11,0.46,419,54570,70,NULL,NULL,'2MASX J14355174-0053191',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.965583,-0.88869,0.089,NULL,43546246962,680410108,10631407,17.9),(122343,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122343,36.93,0.46,243,54571,70,NULL,NULL,'2MASX J14355225+2403034',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,218.967625,24.05083,0.096,NULL,59498985826,929671653,14526119,18),(122344,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122344,37.2,0.46,275,54572,70,NULL,NULL,'SDSS J143552.23+192749.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.967667,19.46361,0.024,NULL,59509583295,929837238,14528706,18.1),(122345,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122345,38.37,0.46,472,54573,70,NULL,NULL,'SDSS J143553.22+134340.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.971791667,13.72786,0,NULL,59545726920,930401983,14537530,18.3),(122346,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122346,37.94,0.11,387,54574,70,NULL,NULL,'2MASX J14355455+2433164',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,218.977166667,24.55444,0.095,NULL,59499130081,929673907,14526154,17.3),(122347,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122347,34.33,0.46,73.3,54575,70,NULL,NULL,'CGCG 192-047',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00009,NULL,'14.7g',0.58,'S0^-',NULL,NULL,NULL,NULL,1,218.9817917,36.71956,0,NULL,60077615312,938712739,14667386,14.7),(122348,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122348,37.47,0.46,312,54576,70,NULL,NULL,'2MASX J14355669+5626097',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00013,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,218.986167,56.43592,0.009,NULL,57258876805,894669950,13979217,17.7),(122349,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122349,37.23,0.46,280,54577,70,NULL,NULL,'2MASX J14355760+1606156',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,218.99,16.10422,0,NULL,59552654243,930510222,14539222,18.31),(122350,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122350,37.39,0.33,300,54578,70,NULL,NULL,'2MASX J14355957+1654286',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.18,NULL,NULL,NULL,NULL,NULL,1,218.998083,16.90808,0,NULL,59481825937,929403530,14521930,18.16),(122351,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122351,38.43,0.46,486,54579,70,NULL,NULL,'SDSS J143559.90+132312.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,218.999625,13.38675,0.005,NULL,59545643043,930400672,14537510,17.2),(122352,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122352,38.99,0.46,628,54580,70,NULL,NULL,'SDSS J143600.19+282740.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.0007917,28.46128,0.032,NULL,60025580340,937899692,14654682,18.4),(122353,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122353,36.45,0.46,195,54581,70,NULL,NULL,'LCRS B143324.7-023710',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000158,NULL,'16.4g',0.26,'E0',NULL,NULL,NULL,NULL,1,219.0014583,-2.83669,0.189,NULL,43548146536,680439789,10631871,16.4),(122354,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122354,38.16,0.33,428,54582,70,NULL,NULL,'SDSS J143600.67+392800.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.0027917,39.46681,0,NULL,60076168303,938690129,14667033,18.3),(122355,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122355,35.45,0.74,123,54583,70,NULL,NULL,'CGCG 019-069',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'15.87',0.34,NULL,NULL,NULL,NULL,NULL,1,219.002875,-3.24311,0.197,NULL,43549901044,680467203,10632300,15.87),(122356,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122356,37.65,0.33,339,54584,70,NULL,NULL,'2MASX J14360072+4321369',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.002958333,43.36025,0.058,NULL,59961294934,936895233,14638988,17.9),(122357,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122357,36.82,0.46,231,54585,70,NULL,NULL,'2MASX J14360093-0006371',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.003833,-0.11044,0.069,NULL,43511952741,679874261,10623035,17.1),(122358,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122358,37.96,0.46,392,54586,70,NULL,NULL,'2MASX J14360147+1847226',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,219.0062917,18.78953,0.04,NULL,59509431253,929834863,14528669,18.68),(122359,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122359,38,0.46,398,54587,70,NULL,NULL,'SDSS J143601.99+202358.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.0082917,20.39956,0.022,NULL,59510414574,929850227,14528909,18.3),(122360,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122360,37.56,0.33,325,54588,70,NULL,NULL,'2MASX J14360283+0716155',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.0117083,7.27081,0.053,NULL,58279699654,910620307,14228442,16.9),(122361,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122361,38.08,0.33,413,54589,70,NULL,NULL,'2MASX J14360288-0107111',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000072,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,219.011917,-1.11986,0.105,NULL,43546278273,680410598,10631415,18.3),(122362,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122362,37.94,0.11,387,54590,70,NULL,NULL,'2MASX J14360313+2433059',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000195,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.0132083,24.55153,0.095,NULL,59499130649,929673916,14526154,16.8),(122363,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122363,37.94,0.11,387,54591,70,NULL,NULL,'2MASX J14360345+2417389',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000204,NULL,'17.78',0.22,NULL,NULL,NULL,NULL,NULL,1,219.0145417,24.29408,0.095,NULL,59498995108,929671798,14526121,17.78),(122364,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122364,34.93,0.46,96.9,54592,70,NULL,NULL,'2MASX J14360368+2150456',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.59',0.35,NULL,NULL,NULL,NULL,NULL,1,219.015375,21.84597,0.049,NULL,59502684531,929729445,14527022,16.59),(122365,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122365,36.33,0.33,184,54593,70,NULL,NULL,'2MASX J14360415+2335556',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.017083333,23.59864,0.076,NULL,59499358408,929677475,14526210,16.7),(122366,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122366,37.23,0.46,279,54594,70,NULL,NULL,'2MASX J14360520+5615178',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.021833333,56.25486,0.005,NULL,57259657228,894682144,13979408,17.5),(122367,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122367,38.73,0.46,557,54595,70,NULL,NULL,'2MASX J14360828+1614070',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.034625,16.23542,0,NULL,59552639201,930509987,14539218,17.7),(122368,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122368,32.66,0.2,34,54596,74.4,NULL,NULL,'HARO 43',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'16.1',0.2,'S?',NULL,NULL,NULL,NULL,1,219.03675,28.44972,0.032,NULL,60025580554,937899696,14654682,16.1),(122369,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122369,37.66,0.46,340,54597,70,NULL,NULL,'2MASX J14360911+0456153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.038041667,4.93756,0.065,NULL,58312576673,911134010,14236468,17.7),(122370,'Sosies','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122370,35.29,0.42,114,54598,NULL,NULL,NULL,'UGC 09401',NULL,'2002A&A...393...57T',2002,1,1.5,NULL,'G',0.000033,NULL,'14.32',0.7,'S?',NULL,NULL,NULL,NULL,1,219.038583,21.79353,0.049,NULL,59502687041,929729485,14527023,14.32),(122371,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122371,34.24,0.29,70.6,54598,NULL,NULL,'Malmquist cor.','UGC 09401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122372,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122372,34.41,0.47,76.2,54598,NULL,NULL,'H','UGC 09401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122373,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122373,34.42,0.46,76.7,54598,NULL,NULL,'J','UGC 09401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122374,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122374,34.5,0.45,79.5,54598,NULL,NULL,'K','UGC 09401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122375,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122375,34.51,0.26,79.8,54598,NULL,NULL,NULL,'UGC 09401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122376,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122376,34.57,0.4,82.2,54598,NULL,NULL,'mean','UGC 09401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122377,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122377,34.73,0.2,88.3,54598,74.4,NULL,NULL,'UGC 09401',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122378,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122378,36.68,0.58,217,54599,70,NULL,NULL,'LCRS B143330.8-063439',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.83',0.34,NULL,NULL,NULL,NULL,NULL,1,219.039375,-6.79486,0.165,NULL,43528162158,680127533,10626992,16.83),(122379,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122379,37.86,0.46,373,54600,70,NULL,NULL,'2MASX J14360951+0353493',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.03975,3.89697,0.069,NULL,58313753723,911152401,14236756,17.4),(122380,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122380,36.09,0.46,165,54601,70,NULL,NULL,'2MASX J14360988+0904315',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.041208333,9.07542,0.021,NULL,59364308052,927567313,14493239,16),(122381,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122381,35.4,0.49,120,54602,75,NULL,'IR','FGC 1774',NULL,'2011yCatp016004901K',2011,1,0.92,NULL,'G',0.00002,NULL,'17.1g',0.13,'Sd',NULL,NULL,NULL,NULL,1,219.0415,-2.88064,0.189,NULL,43548122845,680439419,10631865,17.1),(122382,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122382,35.79,0.1,144,54603,70,NULL,NULL,'2MASX J14361098+0321153',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'FoF','17.82',0.24,NULL,NULL,NULL,NULL,NULL,1,219.045916667,3.35428,0.057,NULL,58314016018,911156500,14236820,17.82),(122383,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122383,38.36,0.46,470,54604,70,NULL,NULL,'2MASX J14361177+2951019',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.049083,29.85064,0,NULL,60018040432,937781881,14652841,18.2),(122384,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122384,36.33,0.33,184,54605,70,NULL,NULL,'CGCG 133-094',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000194,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,219.055708333,23.57719,0.076,NULL,59499360574,929677508,14526211,15.6),(122385,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122385,37.58,0.46,329,54606,70,NULL,NULL,'2MASX J14361346+2540419',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.0559583,25.67825,0.059,NULL,60022567789,937852621,14653947,17.5),(122386,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122386,35.97,0.49,157,54607,75,NULL,'IR','FGC 1782',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',NULL,NULL,'16.5',0.1,'Sc',NULL,NULL,NULL,NULL,1,219.059875,73.50603,0.017,NULL,57881721806,904401903,14131279,16.5),(122387,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122387,36.26,NULL,179,54607,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122388,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122388,36.28,NULL,180,54607,NULL,NULL,'Dipole + Quadrupole','FGC 1782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122389,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122389,36.28,NULL,181,54607,NULL,NULL,NULL,'FGC 1782',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122390,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122390,36.31,NULL,183,54607,NULL,NULL,'Dipole','FGC 1782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122391,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122391,37.21,0.33,277,54608,70,NULL,NULL,'2MASX J14361504+2807529',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,219.062583333,28.13142,0.023,NULL,60025688741,937901386,14654709,NULL),(122392,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122392,37.57,0.46,326,54609,70,NULL,NULL,'SDSS J143615.06+524911.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.062833,52.81972,0.005,NULL,59205380061,925084063,14454438,17.6),(122393,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122393,38.01,0.46,400,54610,70,NULL,NULL,'2MASX J14361539+1337540',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.064041667,13.63167,0,NULL,59545705977,930401655,14537525,17.6),(122394,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122394,35.37,0.46,119,54611,70,NULL,NULL,'NGC 5685',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000097,NULL,'14.3g',0.8,'E:',NULL,NULL,NULL,NULL,1,219.064041667,29.90839,0,NULL,60018055332,937782114,14652845,14.3),(122395,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122395,37.81,0.46,365,54612,70,NULL,NULL,'SDSS J143615.50+364141.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.064583,36.69489,0,NULL,60077616974,938712765,14667386,18),(122396,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122396,37.51,0.46,317,54613,70,NULL,NULL,'2MASX J14361608+4623579',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000138,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.0669583,46.39936,0.009,NULL,59954293297,936785832,14637278,17.7),(122397,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122397,38.16,0.33,428,54614,70,NULL,NULL,'2MASX J14361622+3935513',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.0675417,39.59781,0.007,NULL,60076166021,938690094,14667032,17.4),(122398,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122398,37.88,0.46,376,54615,70,NULL,NULL,'2MASX J14361645+1636270',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.0685417,16.60758,0,NULL,59552414396,930506474,14539163,17.4),(122399,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122399,37.12,0.46,266,54616,70,NULL,NULL,'2MASX J14361666+4947173',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.0694583,49.78831,0.045,NULL,59202170007,925033906,14453654,17),(122400,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122400,37.94,0.11,387,54617,70,NULL,NULL,'2MASX J14361669+2426449',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.069666667,24.44581,0.095,NULL,59499110233,929673597,14526149,17.5),(122401,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122401,38.36,0.33,470,54618,70,NULL,NULL,'SDSS J143617.35+045403.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000083,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,219.0722917,4.90094,0.065,NULL,58312587867,911134185,14236471,18.8),(122402,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122402,38.36,0.33,470,54619,70,NULL,NULL,'2MASX J14361750+0457067',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.073041667,4.95178,0.065,NULL,58312575814,911133997,14236468,17.2),(122403,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122403,38.01,0.46,400,54620,70,NULL,NULL,'2MASX J14361853+3624323',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.077083,36.40892,0,NULL,60077423509,938709742,14667339,17.1),(122404,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122404,36.79,0.27,229,54621,70,NULL,NULL,'2MASX J14361902+0536387',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,219.079125,5.61072,0.065,NULL,58310945125,911108517,14236070,16.6),(122405,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122405,38.08,0.33,413,54622,70,NULL,NULL,'SDSS J143620.06-010748.8',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0001,NULL,'16.5g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,219.083583,-1.13025,0.097,NULL,43546296539,680410883,10631420,16.5),(122406,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122406,37.85,0.46,371,54623,70,NULL,NULL,'2MASX J14362031+1557480',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.084625,15.96317,0,NULL,59552645680,930510088,14539220,17.1),(122407,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122407,35.6,0.46,132,54624,70,NULL,NULL,'UGC 09400',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000187,NULL,'14.3g',0.81,'S0',NULL,NULL,NULL,NULL,1,219.0849583,5.33097,0.065,NULL,58312491145,911132674,14236448,14.3),(122408,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122408,37.56,0.33,325,54625,70,NULL,NULL,'2MASX J14362177+0718492',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.14',0.2,NULL,NULL,NULL,NULL,NULL,1,219.090666667,7.31369,0.045,NULL,58279415062,910615860,14228372,18.14),(122409,'AGN time lag','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122409,35.16,0.19,108,54626,NULL,NULL,NULL,'UGC 09412',NULL,'2014ApJ...784L..11Y',2014,1,0.6,NULL,'G',0.000117,NULL,'14.6r',0.6,'SBc            Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,219.0919583,58.79428,0.005,NULL,57723055678,901922744,14092542,14.6),(122410,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122410,37.66,0.46,341,54627,70,NULL,NULL,'2MASX J14362329+4405424',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.096916667,44.09511,0.031,NULL,59956555677,936821182,14637830,17.1),(122411,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122411,36.54,0.19,204,54628,70,NULL,NULL,'SBS 1435+606',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000183,NULL,'15.3g',0.49,'BrClG',NULL,NULL,NULL,NULL,1,219.097875,60.47128,0.009,NULL,57770517574,902664337,14104130,15.3),(122412,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122412,37.35,0.46,295,54629,70,NULL,NULL,'2MASX J14362469+1023032',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.102875,10.38419,0.009,NULL,59359327920,927489498,14492023,17.9),(122413,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122413,38.48,0.46,498,54630,70,NULL,NULL,'2MASX J14362472+5655209',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.103166667,56.92253,0.017,NULL,57250779788,894543434,13977241,18.2),(122414,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122414,37.39,0.33,300,54631,70,NULL,NULL,'2MASX J14362508+1650520',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.73',0.19,NULL,NULL,NULL,NULL,NULL,1,219.1045,16.84789,0,NULL,59481832252,929403628,14521931,17.73),(122415,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122415,37.96,0.33,391,54632,70,NULL,NULL,'2MASX J14362569+4504254',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.1070417,45.07378,0.024,NULL,59957529492,936836398,14638068,17.6),(122416,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122416,36.52,0.46,201,54633,70,NULL,NULL,'2MASX J14362765+1708200',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.89',0.17,NULL,NULL,NULL,NULL,NULL,1,219.11525,17.13906,0,NULL,59482842065,929419407,14522178,17.89),(122417,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122417,37.23,0.46,279,54634,70,NULL,NULL,'2MASX J14362852+5518169',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.18,NULL,'Group non-member, foreground',NULL,NULL,NULL,1,219.118708333,55.30461,0,NULL,57257896905,894654639,13978978,17.4),(122418,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122418,37.95,0.46,389,54635,70,NULL,NULL,'SDSS J143628.96+461534.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,219.120708333,46.25964,0.009,NULL,59954272214,936785503,14637273,18.6),(122419,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122419,37.21,0.33,277,54636,70,NULL,NULL,'2MASX J14362975+2803408',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.82',0.21,NULL,NULL,NULL,NULL,NULL,1,219.123791667,28.06122,0.023,NULL,60025514707,937898667,14654666,17.82),(122420,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122420,36.79,0.27,229,54637,70,NULL,NULL,'2MASX J14362974+0534468',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,219.1239583,5.57967,0.065,NULL,58312987370,911140427,14236569,16.4),(122421,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122421,38.45,0.27,489,54638,70,NULL,NULL,'2MASX J14363181+1924190',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.132667,19.40522,0.033,NULL,59509615447,929837741,14528714,18.3),(122422,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122422,37.54,0.46,321,54639,70,NULL,NULL,'2MASX J14363273+1700468',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.15,NULL,NULL,NULL,NULL,NULL,1,219.136417,17.013,0,NULL,59481838688,929403729,14521933,18.54),(122423,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122423,36.96,0.33,246,54640,70,NULL,NULL,'2MASX J14363301+0040347',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000104,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,219.137416667,0.67636,0.097,NULL,58305197945,911018717,14234667,16.3),(122424,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122424,37.45,0.46,309,54641,70,NULL,NULL,'2MASX J14363301+0025577',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.137625,0.43286,0.093,NULL,58305235645,911019306,14234676,16.9),(122425,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122425,36.85,0.46,234,54642,70,NULL,NULL,'2MASX J14363325+2030580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.45',0.22,NULL,NULL,NULL,NULL,NULL,1,219.1385,20.51622,0.034,NULL,59510415592,929850243,14528910,17.45),(122426,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122426,35.84,0.46,147,54643,70,NULL,NULL,'2MASX J14363339+2004420',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.40',0.21,NULL,NULL,NULL,NULL,NULL,1,219.139083333,20.07833,0.007,NULL,59509072370,929829255,14528582,17.4),(122427,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122427,36.79,0.27,229,54644,70,NULL,NULL,'2MASX J14363430+0530037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.26',0.3,NULL,NULL,NULL,NULL,NULL,1,219.143,5.50111,0.065,NULL,58312958470,911139976,14236562,17.26),(122428,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122428,35.78,0.2,143,54645,74.4,NULL,NULL,'CGCG 075-091',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000133,NULL,'15.5g',0.45,NULL,NULL,NULL,NULL,NULL,1,219.14675,11.93842,0,NULL,59360349392,927505459,14492272,15.5),(122429,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122429,31.34,NULL,18.6,54646,NULL,NULL,NULL,'FGC 1775',NULL,'2000BSAO...50....5K',2000,1,0.72,NULL,'G',0.000033,NULL,'17.1',0.1,'Sm',NULL,NULL,NULL,NULL,1,219.147666667,49.41772,0.077,NULL,59202298523,925035914,14453686,17.1),(122430,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122430,31.81,NULL,23,54646,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1775',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122431,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122431,31.85,NULL,23.4,54646,NULL,NULL,'Dipole + Quadrupole','FGC 1775',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122432,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122432,31.91,NULL,24.1,54646,NULL,NULL,'Dipole','FGC 1775',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122433,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122433,37.38,0.46,300,54647,70,NULL,NULL,'2MASX J14363543+3043429',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.147666667,30.72856,0,NULL,60020005816,937812590,14653321,17.6),(122434,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122434,37.18,0.23,272,54648,70,NULL,NULL,'SDSS J143635.47+095416.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.1477917,9.90456,0.029,NULL,59373338117,927708408,14495443,17.7),(122435,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122435,34.49,0.55,79.2,54649,NULL,NULL,NULL,'ESO 447- G 027',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.48',0.2,'Sb:',NULL,NULL,NULL,NULL,1,219.150083333,-29.05672,0.469,NULL,47020893475,734701460,11479710,16.48),(122436,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122436,34.53,0.2,80.5,54649,74.4,NULL,NULL,'ESO 447- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122437,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122437,34.54,0.49,80.9,54649,75,NULL,'IR','ESO 447- G 027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122438,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122438,34.55,0.53,81.2,54649,NULL,NULL,'Malmquist cor.','ESO 447- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122439,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122439,38.45,0.27,489,54650,70,NULL,NULL,'2MASX J14363604+1912030',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.150083333,19.20075,0.036,NULL,59509814950,929840858,14528763,18.2),(122440,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122440,37.08,0.27,261,54651,70,NULL,NULL,'2MASX J14363973+5749118',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,219.165583,57.82014,0,NULL,57250447271,894538238,13977159,16),(122441,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122441,36.98,0.46,249,54652,70,NULL,NULL,'2MASX J14363985+0640312',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.165958333,6.67542,0.053,NULL,58279317694,910614338,14228349,17.2),(122442,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122442,36.54,0.19,204,54653,70,NULL,NULL,'2MASX J14363995+6025016',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000089,NULL,'15.8g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,219.1664583,60.41708,0.009,NULL,57770523483,902664429,14104131,15.8),(122443,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122443,37.78,0.33,359,54654,70,NULL,NULL,'2MASX J14364065+2643358',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.169375,26.72672,0.036,NULL,60021857611,937841525,14653773,17.9),(122444,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122444,36.54,0.19,204,54655,70,NULL,NULL,'2MASX J14364124+6039395',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000212,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.171791667,60.66092,0.009,NULL,57752976106,902390251,14099847,16.3),(122445,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122445,37.61,0.46,333,54656,70,NULL,NULL,'2MASX J14364119+1616559',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.171833,16.28236,0,NULL,59552669531,930510461,14539225,17.9),(122446,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122446,37.96,0.33,391,54657,70,NULL,NULL,'2MASX J14364202+4508175',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000204,NULL,'16.1g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,219.175083333,45.13825,0.024,NULL,59957526674,936836354,14638068,16.1),(122447,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122447,37.08,0.27,261,54658,70,NULL,NULL,'2MASX J14364215+5753158',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.17575,57.88772,0,NULL,57250439839,894538122,13977158,17),(122448,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122448,38.49,0.46,499,54659,70,NULL,NULL,'SDSS J143642.23+171634.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.175958333,17.27617,0,NULL,59482840579,929419384,14522177,17.9),(122449,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122449,34.93,0.46,96.6,54660,70,NULL,NULL,'CGCG 220-034',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00009,NULL,'15.0g',0.46,'E1',NULL,NULL,NULL,NULL,1,219.177667,39.94356,0,NULL,60076069084,938688579,14667009,15),(122450,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122450,36.47,0.33,197,54661,70,NULL,NULL,'2MASX J14364273+3418379',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.1779583,34.31044,0,NULL,60067306757,938551668,14664869,16.4),(122451,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122451,38.29,0.46,455,54662,70,NULL,NULL,'SDSS J143645.69+223517.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.190417,22.58808,0.054,NULL,59505613793,929775215,14527737,18.4),(122452,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122452,37.78,0.46,359,54663,70,NULL,NULL,'SDSS J143645.76+203501.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.190708333,20.58381,0.034,NULL,59502794271,929731160,14527049,17.9),(122453,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122453,33.85,0.55,59,54664,NULL,NULL,NULL,'ESO 447- G 028',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'15.48',0.5,'Sb',NULL,NULL,NULL,NULL,1,219.191333333,-27.84611,0.493,NULL,47023036297,734734942,11480233,15.48),(122454,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122454,33.9,0.2,60.3,54664,74.4,NULL,NULL,'ESO 447- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122455,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122455,33.96,0.53,61.9,54664,NULL,NULL,'Malmquist cor.','ESO 447- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122456,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122456,38.45,0.27,489,54665,70,NULL,NULL,'SDSS J143646.05+190857.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.25',0.1,NULL,NULL,NULL,NULL,NULL,1,219.191916667,19.14931,0.06,NULL,59509815685,929840870,14528763,19.25),(122457,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122457,37.6,0.46,331,54666,70,NULL,NULL,'2MASX J14364653+2136241',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.67',0.15,NULL,NULL,NULL,NULL,NULL,1,219.193917,21.60686,0.026,NULL,59503367265,929740113,14527189,18.67),(122458,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122458,36.96,0.33,246,54667,70,NULL,NULL,'2MASX J14364683+0043113',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000114,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.195,0.71983,0.101,NULL,58305217162,911019018,14234672,16.4),(122459,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122459,37.78,0.33,359,54668,70,NULL,NULL,'SDSS J143647.49+264313.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.197875,26.72047,0.036,NULL,60021838225,937841222,14653769,18.2),(122460,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122460,38.11,0.46,419,54669,70,NULL,NULL,'SDSS J143647.59+170407.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.198333,17.06872,0,NULL,59481800138,929403127,14521923,18.5),(122461,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122461,35.95,0.46,155,54670,70,NULL,NULL,'2MASX J14364762+5556105',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000179,NULL,'15.7g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,219.1984583,55.93628,0,NULL,57259830631,894684853,13979450,15.7),(122462,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122462,36.21,0.75,174,54671,70,NULL,NULL,'2MASX J14364777-0540132',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.88',0.29,NULL,NULL,NULL,NULL,NULL,1,219.199,-5.67039,0.161,NULL,43544626760,680384793,10631012,16.88),(122463,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122463,36.94,0.46,245,54672,70,NULL,NULL,'2MASX J14364777-0155532',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.199125,-1.93128,0.125,NULL,43548847802,680450746,10632042,17),(122464,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122464,37.32,0.46,292,54673,70,NULL,NULL,'SDSS J143648.31+445333.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.201333,44.89261,0,NULL,59957507995,936836062,14638063,18),(122465,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122465,37.59,0.46,330,54674,70,NULL,NULL,'LCRS B143413.4-022516',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.203916667,-2.63786,0.169,NULL,43548053201,680438331,10631848,17.9),(122466,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122466,37.92,0.46,384,54675,70,NULL,NULL,'2MASX J14364896+4437205',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000191,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.203916667,44.62228,0.02,NULL,59956651692,936822682,14637854,17.1),(122467,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122467,36.54,0.19,204,54676,70,NULL,NULL,'2MASX J14364892+6031305',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.204167,60.52517,0.009,NULL,57770561980,902665030,14104141,17.7),(122468,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122468,36.49,0.65,199,54677,70,NULL,NULL,'2MASX J14365049-0037192',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.000081,NULL,'16.2g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,219.210375,-0.62211,0.121,NULL,43545476792,680398074,10631219,16.2),(122469,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122469,37.72,0.46,350,54678,70,NULL,NULL,'2MASX J14365065+2740008',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.26',0.16,NULL,NULL,NULL,NULL,NULL,1,219.2110417,27.66703,0.03,NULL,60025057086,937891516,14654554,18.26),(122470,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122470,36.47,0.33,197,54679,70,NULL,NULL,'MCG +06-32-076',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000189,NULL,'15.1g',0.62,'E0',NULL,NULL,NULL,NULL,1,219.211417,34.29269,0,NULL,60067304424,938551631,14664869,15.1),(122471,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122471,37.61,0.46,333,54680,70,NULL,NULL,'SDSS J143650.98+094726.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,219.212416667,9.79067,0.029,NULL,59373380938,927709077,14495454,18.7),(122472,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122472,38.15,0.46,426,54681,70,NULL,NULL,'2MASXi J1436519+263423',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.216667,26.57303,0.036,NULL,60021847664,937841369,14653771,18),(122473,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122473,38.38,0.46,474,54682,70,NULL,NULL,'2MASX J14365343+2051362',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.77',0.14,NULL,NULL,NULL,NULL,NULL,1,219.2227083,20.86011,0.044,NULL,59503011794,929734559,14527102,18.77),(122474,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122474,37.33,0.46,292,54683,70,NULL,NULL,'2MASX J14365359+0154194',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000071,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.2232083,1.90553,0.097,NULL,58308895624,911076494,14235570,17.4),(122475,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122475,35.38,0.46,119,54684,70,NULL,NULL,'CGCG 133-096',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000073,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,219.2232083,21.2975,0.029,NULL,59503505283,929742270,14527222,15.7),(122476,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122476,35.65,0.46,135,54685,70,NULL,NULL,'IC 4467',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'16.55',0.27,NULL,NULL,NULL,NULL,NULL,1,219.223625,18.37064,0.049,NULL,59480366083,929380720,14521573,16.55),(122477,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122477,37.51,0.46,318,54686,70,NULL,NULL,'2MASX J14365469+2230302',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.19,NULL,NULL,NULL,NULL,NULL,1,219.227833,22.50839,0.038,NULL,59505630038,929775469,14527741,18.26),(122478,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122478,36.31,0.46,183,54687,70,NULL,NULL,'2MASX J14365627+1609239',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000497,NULL,'17.11',0.22,NULL,NULL,NULL,NULL,NULL,1,219.234375,16.15664,0,NULL,59552670571,930510477,14539226,17.11),(122479,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122479,38.09,0.33,414,54688,70,NULL,NULL,'2MASX J14365651+4517185',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.235417,45.28836,0.024,NULL,59956886446,936826350,14637911,18),(122480,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122480,38.59,0.46,523,54689,70,NULL,NULL,'2MASX J14365649+3038227',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.2355417,30.63981,0,NULL,60020013047,937812703,14653323,18.2),(122481,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122481,37.47,0.46,311,54690,70,NULL,NULL,'2MASX J14365657+0226504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.235875,2.44744,0.077,NULL,58306912107,911045501,14235085,17.3),(122482,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122482,36.54,0.19,204,54691,70,NULL,NULL,'2MASX J14365661+6028334',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.236,60.47581,0.009,NULL,57770518659,902664354,14104130,16.9),(122483,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122483,35.98,0.46,157,54692,70,NULL,NULL,'2MASX J14365688+1213359',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000081,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.2370417,12.22656,0,NULL,59360341373,927505333,14492270,16.1),(122484,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122484,35.53,0.46,128,54693,70,NULL,NULL,'2MASX J14365694+0331064',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000097,NULL,'15.4g',0.48,'S0/a',NULL,NULL,NULL,NULL,1,219.237375,3.51847,0.061,NULL,58314401979,911162530,14236914,15.4),(122485,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122485,34.61,0.4,83.7,54694,NULL,NULL,'mean','NGC 5696',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000017,NULL,'13.9g',1.5,'Sbc','in a radial-velocity based grouping',NULL,NULL,NULL,1,219.237833333,41.82811,0,NULL,59960468819,936882325,14638786,13.9),(122486,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122486,34.69,0.47,86.9,54694,NULL,NULL,'H','NGC 5696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122487,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122487,34.72,0.46,87.9,54694,NULL,NULL,'J','NGC 5696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122488,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122488,34.76,0.45,89.7,54694,NULL,NULL,'K','NGC 5696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122489,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122489,34.79,0.59,91,54694,NULL,NULL,'Malmquist cor.','NGC 5696',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122490,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122490,34.92,0.2,96.4,54694,74.4,NULL,NULL,'NGC 5696',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122491,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122491,35.06,0.52,103,54694,NULL,NULL,NULL,'NGC 5696',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122492,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122492,38.03,0.46,404,54695,70,NULL,NULL,'2MASX J14365711+5245412',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.238208333,52.76164,0.005,NULL,59205848544,925091383,14454552,17.2),(122493,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122493,36.42,0.46,192,54696,70,NULL,NULL,'2MASX J14365757-0123542',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,219.24,-1.3985,0.105,NULL,43545971696,680405807,10631340,16.3),(122494,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122494,38.46,0.46,492,54697,70,NULL,NULL,'2MASX J14365770-0104002',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.240417,-1.06678,0.097,NULL,43546281118,680410642,10631416,17.7),(122495,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122495,35.72,0.46,140,54698,70,NULL,NULL,'2MASX J14370076+5951436',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000085,NULL,'16.1g',0.25,'E0',NULL,NULL,NULL,NULL,1,219.253125,59.86206,0,NULL,57768852678,902638323,14103723,16.1),(122496,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122496,37.94,0.11,387,54699,70,NULL,NULL,'2MASX J14370106+2437017',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.254583,24.61725,0.115,NULL,59499344810,929677262,14526207,17.5),(122497,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122497,37.41,0.33,303,54700,70,NULL,NULL,'2MASX J14370377+4836132',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.2659583,48.60372,0.161,NULL,59198865040,924982266,14452847,16.8),(122498,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122498,37.57,0.46,327,54701,70,NULL,NULL,'2MASX J14370410+0023004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.267166667,0.38336,0.097,NULL,58305237027,911019328,14234677,17.6),(122499,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122499,37.03,0.46,255,54702,70,NULL,NULL,'2MASX J14370473+0940274',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.269875,9.67436,0.025,NULL,59373353515,927708648,14495447,18),(122500,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122500,33.86,0.8,59.1,54703,75,NULL,'HMCL, I','CGCG 133-097',NULL,'1997ApJS..109..333W',1997,1,1.23,NULL,'G',0.000027,NULL,'15.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.2715417,24.97811,0.082,NULL,59499228312,929675442,14526178,15.3),(122501,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122501,34.09,0.4,65.8,54703,75,NULL,'HMCL, I, raw','CGCG 133-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122502,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122502,34.19,0.4,68.9,54703,75,NULL,'HMCL, I, inv','CGCG 133-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122503,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122503,34.28,0.4,71.7,54703,75,NULL,'HMCL, I, cor','CGCG 133-097',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122504,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122504,34.52,0.2,80.2,54703,74.4,NULL,NULL,'CGCG 133-097',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122505,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122505,34.81,0.49,91.6,54703,75,NULL,'IR','CGCG 133-097',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122506,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122506,38.75,0.46,561,54704,70,NULL,NULL,'2MASX J14370542+1005464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.2725417,10.09636,0.017,NULL,59373124849,927705075,14495391,17.8),(122507,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122507,45.42,1.12,4480,54705,72,NULL,NULL,'GRB 050802',1.71,'2008JCAP...07..004M',2008,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,219.27425,27.78683,0.024,NULL,60025077628,937891837,14654559,NULL),(122508,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122508,45.5,0.66,4650,54705,69.7,NULL,'Fiducial','GRB 050802',1.71,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122509,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122509,45.52,0.98,4690,54705,69.7,NULL,'Calibrated','GRB 050802',1.71,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122510,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122510,45.59,1.05,4840,54705,70,NULL,NULL,'GRB 050802',1.71,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122511,'GRB','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122511,45.64,1.32,4940,54705,NULL,NULL,NULL,'GRB 050802',1.71,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122512,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122512,37.94,0.11,387,54706,70,NULL,NULL,'SDSS J143705.96+242907.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.274875,24.48553,0.115,NULL,59499322615,929676915,14526201,18.4),(122513,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122513,37.96,0.33,391,54707,70,NULL,NULL,'SDSS J143705.98+005318.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.274958333,0.88836,0.101,NULL,58305988478,911031069,14234860,18.3),(122514,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122514,38.23,0.46,443,54708,70,NULL,NULL,'SDSS J143706.03+205738.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.275167,20.96078,0.036,NULL,59502965601,929733837,14527091,18),(122515,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122515,37.38,0.33,299,54709,70,NULL,NULL,'2MASX J14370636+2324242',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.276625,23.40661,0.06,NULL,59505129446,929767647,14527619,16.5),(122516,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122516,37.18,0.23,272,54710,70,NULL,NULL,'2MASX J14370732+1003254',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.280458333,10.05706,0.021,NULL,59373123191,927705049,14495391,16.3),(122517,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122517,37.69,0.23,346,54711,70,NULL,NULL,'2MASX J14370761+2140411',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.2,NULL,NULL,NULL,NULL,NULL,1,219.281667,21.67806,0.026,NULL,59503407803,929740746,14527199,18.08),(122518,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122518,37.55,0.33,323,54712,70,NULL,NULL,'2MASX J14370762+5622426',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.282,56.37839,0,NULL,57259388203,894677940,13979342,18.2),(122519,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122519,36.65,0.46,214,54713,70,NULL,NULL,'2MASX J14370813+0548464',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000173,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,219.284,5.81292,0.065,NULL,58312936343,911139630,14236556,16.5),(122520,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122520,37.36,0.46,296,54714,70,NULL,NULL,'2MASX J14370881+4201056',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.286583,42.01822,0.009,NULL,59961116071,936892438,14638944,17.9),(122521,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122521,37.62,0.46,334,54715,70,NULL,NULL,'2MASX J14370953+4604517',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.289875,46.08094,0.009,NULL,59954002159,936781283,14637207,17.4),(122522,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122522,37.71,0.46,349,54716,70,NULL,NULL,'SDSS J143709.68+451808.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.290375,45.30247,0.024,NULL,59956878211,936826222,14637909,18.3),(122523,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122523,37.94,0.11,387,54717,70,NULL,NULL,'2MASX J14371014+2448398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00067,NULL,'17.75',0.1,NULL,NULL,NULL,NULL,NULL,1,219.29225,24.81117,0.082,NULL,59499260053,929675938,14526186,17.75),(122524,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122524,38.23,0.46,442,54718,70,NULL,NULL,'2MASX J14371012+5318242',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000149,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.292375,53.30681,0,NULL,59205337751,925083402,14454428,17.1),(122525,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122525,37.8,0.46,363,54719,70,NULL,NULL,'2MASXi J1437106+282038',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.49',0.13,NULL,NULL,NULL,NULL,NULL,1,219.294375,28.34411,0.016,NULL,60025374417,937896475,14654632,18.49),(122526,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122526,37.96,0.33,391,54720,70,NULL,NULL,'2MASX J14371129+0049444',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.296958333,0.829,0.105,NULL,58305976309,911030879,14234857,17.1),(122527,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122527,38.04,0.46,406,54721,70,NULL,NULL,'2MASX J14371144+1942341',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.297583,19.7095,0.017,NULL,59509256301,929832129,14528627,17.7),(122528,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122528,37.69,0.23,346,54722,70,NULL,NULL,'2MASX J14371295+2141492',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.50',0.14,NULL,NULL,NULL,NULL,NULL,1,219.304083333,21.69706,0.026,NULL,59503400390,929740631,14527197,18.5),(122529,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122529,38.77,0.46,567,54723,70,NULL,NULL,'2MASX J14371320+2916438',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000198,NULL,'17.1g',0.25,'S0',NULL,NULL,NULL,NULL,1,219.305083,29.27903,0,NULL,60017818805,937778418,14652787,17.1),(122530,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122530,33.49,0.2,49.9,54724,74.4,NULL,NULL,'UGC 09422',NULL,'2013AJ....146...86T',2013,1,2.69,NULL,'G',0.000023,NULL,'14.8g',0.27,'Scd',NULL,NULL,NULL,NULL,1,219.306583,43.69594,0.031,NULL,59957892531,936842070,14638157,14.8),(122531,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122531,33.5,0.52,50.1,54724,NULL,NULL,NULL,'UGC 09422',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122532,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122532,33.5,0.49,50.2,54724,75,NULL,'IR','UGC 09422',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122533,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122533,33.6,0.5,52.5,54724,NULL,NULL,'Malmquist cor.','UGC 09422',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122534,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122534,33.77,NULL,56.8,54724,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122535,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122535,33.79,NULL,57.4,54724,NULL,NULL,'Dipole + Quadrupole','UGC 09422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122536,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122536,33.8,NULL,57.7,54724,NULL,NULL,'Dipole','UGC 09422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122537,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122537,35.35,0.2,117,54725,74.4,NULL,NULL,'UGC 09410',NULL,'2013AJ....146...86T',2013,1,1.04,NULL,'G',0.000063,NULL,'15.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,219.307917,8.64603,0.025,NULL,59365042743,927578792,14493418,15.4),(122538,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122538,37.94,0.11,387,54726,70,NULL,NULL,'2MASX J14371395+2456288',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.86',0.19,NULL,NULL,NULL,NULL,NULL,1,219.3082083,24.94136,0.082,NULL,59499225795,929675403,14526178,17.86),(122539,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122539,38.61,0.46,527,54727,70,NULL,NULL,'SDSS J143714.18+391624.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.309125,39.27356,0,NULL,60076150464,938689851,14667028,18.5),(122540,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122540,38.71,0.46,553,54728,70,NULL,NULL,'2MASX J14371443+2536078',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.310083,25.60214,0.034,NULL,60022531078,937852048,14653938,18.2),(122541,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2005bc',NULL,122541,33.95,0.22,61,54729,70,NULL,'SALT 2','NGC 5698',0.012272,'2013MNRAS.433.2240G',2013,1,2.07,NULL,'G',0.00002,NULL,'13.6g',0.78,'SBb            HII','Field galaxy',NULL,NULL,NULL,1,219.31125,38.45428,0.013,NULL,60076398861,938693732,14667089,13.6),(122542,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122542,32.74,0.69,35.3,54729,100,NULL,'mid-IR','NGC 5698',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122543,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122543,32.97,0.43,39.2,54729,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5698',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122544,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122544,33.52,0.47,50.6,54729,NULL,NULL,'H','NGC 5698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122545,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122545,33.6,0.45,52.6,54729,NULL,NULL,'K','NGC 5698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122546,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122546,33.61,0.46,52.7,54729,NULL,NULL,'J','NGC 5698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122547,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122547,33.65,0.4,53.7,54729,NULL,NULL,'mean','NGC 5698',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122548,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122548,37.94,0.11,387,54730,70,NULL,NULL,'2MASX J14371499+2445318',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.3125417,24.75894,0.091,NULL,59499259260,929675925,14526186,17.2),(122549,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122549,35.33,0.8,117,54731,75,NULL,'CF, r','CGCG 075-092',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'Sbc',NULL,NULL,NULL,NULL,1,219.312917,8.65333,0.025,NULL,59365041412,927578772,14493418,NULL),(122550,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122550,34.93,0.38,97,54731,75,NULL,'CF, r, raw','CGCG 075-092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122551,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122551,35.01,0.38,101,54731,75,NULL,'CF, r, inv','CGCG 075-092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122552,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122552,35.21,0.38,110,54731,75,NULL,'CF, r, cor','CGCG 075-092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122553,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122553,35.26,0.36,113,54731,NULL,NULL,'Malmquist cor.','CGCG 075-092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122554,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122554,35.31,0.36,115,54731,NULL,NULL,NULL,'CGCG 075-092',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122555,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122555,38.4,0.46,479,54732,70,NULL,NULL,'SDSS J143715.35+145648.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.3139583,14.94683,0,NULL,59557012222,930578315,14540286,18.4),(122556,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122556,36.14,0.46,169,54733,70,NULL,NULL,'2MASX J14371570+0812334',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000107,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.315625,8.20922,0.025,NULL,59364497254,927570269,14493285,16.5),(122557,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122557,37.41,0.33,303,54734,70,NULL,NULL,'2MASX J14371597+4836381',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.316708333,48.61069,0.161,NULL,59198858603,924982165,14452846,18),(122558,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122558,37.98,0.46,395,54735,70,NULL,NULL,'2MASX J14371621-0005589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.317458333,-0.09981,0.121,NULL,43545278681,680394979,10631171,17.7),(122559,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122559,38.23,0.46,443,54736,70,NULL,NULL,'2MASX J14371648+0010384',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000085,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.318583,0.17731,0.093,NULL,58305030323,911016098,14234626,17.1),(122560,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122560,37.94,0.11,387,54737,70,NULL,NULL,'2MASX J14371682+2452098',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000204,NULL,'15.2',0.5,NULL,NULL,NULL,NULL,NULL,1,219.320083,24.86922,0.082,NULL,59499255344,929675864,14526185,15.2),(122561,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122561,37.52,0.46,320,54738,70,NULL,NULL,'2MASX J14371754+1638578',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.14,NULL,NULL,NULL,NULL,NULL,1,219.3232083,16.64953,0,NULL,59552548693,930508573,14539196,18.68),(122562,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122562,35.65,0.46,135,54739,70,NULL,NULL,'VIII Zw 440',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000088,NULL,'15.8g',0.36,'S0',NULL,NULL,NULL,NULL,1,219.32325,1.20372,0.101,NULL,58305494266,911023347,14234739,15.8),(122563,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122563,34.58,0.5,82.4,54740,70,NULL,NULL,'ESO 385- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000093,NULL,'15.09',0.3,'S0',NULL,NULL,NULL,NULL,1,219.33075,-36.12706,0.189,NULL,47220813212,737825206,11528518,15.09),(122564,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122564,33.9,0.49,60.1,54741,75,NULL,'IR','IC 4469',NULL,'2011yCatp016004901K',2011,1,1.99,NULL,'G',0.000006,NULL,'15.58',0.17,'Scd',NULL,NULL,NULL,NULL,1,219.335375,18.24933,0.019,NULL,59480468605,929382321,14521598,15.58),(122565,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122565,34.29,NULL,72.1,54741,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122566,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122566,34.3,NULL,72.4,54741,NULL,NULL,'Dipole','IC 4469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122567,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122567,34.3,NULL,72.4,54741,NULL,NULL,'Dipole + Quadrupole','IC 4469',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122568,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122568,34.36,NULL,74.4,54741,NULL,NULL,NULL,'IC 4469',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122569,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122569,34.38,0.43,75.3,54741,NULL,NULL,'Malmquist cor.','IC 4469',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122570,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122570,34.41,0.2,76.2,54741,74.4,NULL,NULL,'IC 4469',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122571,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122571,34.46,0.41,78.1,54741,NULL,NULL,NULL,'IC 4469',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122572,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122572,37.55,0.33,323,54742,70,NULL,NULL,'2MASX J14372087+5623116',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.337167,56.38653,0,NULL,57259388511,894677945,13979342,17.6),(122573,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122573,37.38,0.33,299,54743,70,NULL,NULL,'2MASX J14372098+2323112',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,219.337541667,23.3865,0.06,NULL,59505124885,929767576,14527618,16.5),(122574,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122574,37.53,0.33,321,54744,70,NULL,NULL,'2MASX J14372109+1916372',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.98',0.19,NULL,NULL,NULL,NULL,NULL,1,219.337875,19.27694,0.057,NULL,59509831220,929841112,14528767,17.98),(122575,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122575,33.54,0.45,51,54745,NULL,NULL,'K','NGC 5695',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'13.4g',0.93,'SBb            Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,219.342167,36.56781,0,NULL,60077436223,938709940,14667342,13.4),(122576,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122576,33.56,0.47,51.6,54745,NULL,NULL,'H','NGC 5695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122577,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122577,33.57,0.46,51.7,54745,NULL,NULL,'J','NGC 5695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122578,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122578,33.88,0.4,59.8,54745,NULL,NULL,'mean','NGC 5695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122579,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122579,36.31,0.27,183,54746,70,NULL,NULL,'2MASX J14372295+0803487',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000188,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,219.345625,8.06353,0.025,NULL,59364560818,927571262,14493300,15.9),(122580,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122580,37.94,0.11,387,54747,70,NULL,NULL,'2MASX J14372365+2452128',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.3487083,24.87028,0.082,NULL,59499257619,929675900,14526185,17.3),(122581,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122581,37.6,0.33,331,54748,70,NULL,NULL,'2MASX J14372400+2405418',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.349875,24.09489,0.095,NULL,59499057559,929672774,14526137,17.9),(122582,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122582,37.69,0.23,346,54749,70,NULL,NULL,'SDSS J143724.53+213754.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.35225,21.63194,0.026,NULL,59503383612,929740368,14527193,18.4),(122583,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122583,37.94,0.33,386,54750,70,NULL,NULL,'SDSS J143724.93+310536.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.353917,31.09344,0,NULL,60016816194,937762753,14652543,18.1),(122584,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122584,36.75,0.46,224,54751,70,NULL,NULL,'2MASX J14372598+1926142',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.358333,19.43719,0.033,NULL,59509786828,929840419,14528756,16.8),(122585,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122585,35.12,0.46,106,54752,70,NULL,NULL,'2MASX J14372624+3857328',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000165,NULL,'16.0g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,219.359416667,38.959,0.021,NULL,60077107910,938704811,14667262,16),(122586,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122586,37.6,0.33,331,54753,70,NULL,NULL,'2MASX J14372714+2412468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.68',0.23,NULL,NULL,NULL,NULL,NULL,1,219.363,24.21286,0.095,NULL,59498912880,929670513,14526101,17.68),(122587,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122587,36.26,0.46,179,54754,70,NULL,NULL,'VIII Zw 441',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.363833,4.60947,0.085,NULL,58312464521,911132258,14236441,16.8),(122588,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122588,37.94,0.33,386,54755,70,NULL,NULL,'2MASX J14372800+3106561',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.366708333,31.1155,0,NULL,60016814202,937762721,14652542,17.5),(122589,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122589,37.53,0.33,321,54756,70,NULL,NULL,'2MASX J14372829+1912212',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,219.3679583,19.20583,0.057,NULL,59509778505,929840289,14528754,18.4),(122590,'L(H{beta})-{sigma}','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122590,46.05,NULL,1605,54757,74.3,NULL,NULL,'WISP 064_0210',2.177,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,219.368083,-1.83178,0.133,NULL,43548900137,680451564,10632055,NULL),(122591,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122591,32.83,0.8,36.9,54758,75,NULL,NULL,'UGC 09426',NULL,'1988NBGC.C....0000T',1988,1,0.71,NULL,'G',0.000017,NULL,'16.3g',0.41,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.371417,48.62375,0.137,NULL,59198826974,924981671,14452838,16.3),(122592,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122592,37.18,0.23,272,54759,70,NULL,NULL,'2MASX J14372974+0958317',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.3739583,9.97556,0.021,NULL,59373085821,927704465,14495382,17.3),(122593,'L(H{beta})-{sigma}','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122593,45.24,NULL,1642,54760,74.3,NULL,NULL,'WISP 064_2056',1.61,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,219.375833,-1.84761,0.133,NULL,43548899942,680451561,10632055,NULL),(122594,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122594,37.7,0.46,347,54761,70,NULL,NULL,'2MASX J14373023+3021321',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.375875,30.35903,0,NULL,60020219851,937815935,14653373,16.7),(122595,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122595,37.78,0.46,360,54762,70,NULL,NULL,'2MASX J14373049+1000468',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.377083,10.01292,0.017,NULL,59373092583,927704571,14495383,17.6),(122596,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122596,32.99,0.2,39.6,54763,74.4,NULL,NULL,'NGC 5707',NULL,'2013AJ....146...86T',2013,1,2.5,NULL,'G',0.00001,NULL,'13.1g',0.61,'Sab: sp','Line-of-sight pair member',NULL,NULL,NULL,1,219.3782083,51.56186,0.009,NULL,59204348144,925067939,14454186,13.1),(122597,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122597,33.14,0.43,42.5,54763,75,NULL,'3.6 micron, color corrected','NGC 5707',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122598,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122598,33.42,0.43,48.4,54763,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5707',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122599,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122599,36.85,0.46,234,54764,70,NULL,NULL,'2MASX J14373083-0157509',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.3784583,-1.96419,0.133,NULL,43548821814,680450340,10632036,16.7),(122600,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122600,37.94,0.11,387,54765,70,NULL,NULL,'2MASX J14373113+2446522',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.379625,24.78111,0.091,NULL,59499263263,929675988,14526187,18),(122601,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122601,38.17,0.46,430,54766,70,NULL,NULL,'2MASX J14373139+4541177',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.380875,45.68831,0.021,NULL,59954068205,936782315,14637223,17.7),(122602,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122602,37.84,0.33,370,54767,70,NULL,NULL,'2MASX J14373209+2922322',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.383625,29.37564,0,NULL,60017696559,937776508,14652757,17.2),(122603,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122603,37.17,0.46,271,54768,70,NULL,NULL,'2MASX J14373271+1643248',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.386333333,16.72361,0,NULL,59552518350,930508099,14539189,17.1),(122604,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122604,37.94,0.11,387,54769,70,NULL,NULL,'2MASX J14373281+2450362',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.386833,24.84331,0.091,NULL,59499256686,929675885,14526185,17.2),(122605,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122605,36.31,0.27,183,54770,70,NULL,NULL,'2MASX J14373292+0804427',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000171,NULL,'16.0g',0.34,'SF',NULL,NULL,NULL,NULL,1,219.387291667,8.07861,0.025,NULL,59364572213,927571440,14493303,16),(122606,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122606,37.23,0.46,280,54771,70,NULL,NULL,'2MASX J14373312+2330052',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.388167,23.50153,0.056,NULL,59508012913,929812701,14528323,17.3),(122607,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122607,37.69,0.23,346,54772,70,NULL,NULL,'2MASX J14373325+2141222',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.3885,21.68958,0.026,NULL,59503382818,929740356,14527193,17.4),(122608,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122608,36.21,0.46,175,54773,70,NULL,NULL,'2MASX J14373353+6112171',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000146,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.389791667,61.20475,0.025,NULL,57753302268,902395347,14099927,16.4),(122609,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122609,37.94,0.11,387,54774,70,NULL,NULL,'SDSS J143734.80+245258.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.395041667,24.883,0.082,NULL,59498391042,929662360,14525974,18.2),(122610,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122610,38.09,0.33,414,54775,70,NULL,NULL,'SDSS J143735.04+452743.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.3960417,45.46208,0.061,NULL,59956897492,936826523,14637914,18.4),(122611,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122611,37.26,0.46,283,54776,70,NULL,NULL,'2MASX J14373591+2736022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.3994583,27.60064,0.025,NULL,60028511318,937945489,14655398,18.1),(122612,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122612,34.53,0.46,80.4,54777,70,NULL,NULL,'2MASX J14373754+0520474',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000163,NULL,'15.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,219.406417,5.34667,0.065,NULL,58313245631,911144462,14236632,15.6),(122613,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122613,37.94,0.11,387,54778,70,NULL,NULL,'2MASX J14373788+2447262',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.407917,24.79061,0.091,NULL,59499251184,929675799,14526184,17),(122614,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122614,38.47,0.46,495,54779,70,NULL,NULL,'SDSS J143737.94+603808.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.408125,60.63567,0.009,NULL,57770543649,902664744,14104136,17.8),(122615,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122615,37.85,0.46,372,54780,70,NULL,NULL,'2MASX J14373834+4740186',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000146,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.409833,47.672,0.021,NULL,59932663263,936447863,14631997,17.1),(122616,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122616,36.94,0.46,245,54781,70,NULL,NULL,'2MASX J14373977+2315031',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.415667,23.251,0.06,NULL,59505154836,929768044,14527625,17.7),(122617,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122617,37.72,0.46,350,54782,70,NULL,NULL,'2MASX J14374062+1838151',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.87',0.19,NULL,NULL,NULL,NULL,NULL,1,219.41925,18.6375,0.043,NULL,59479505830,929367278,14521363,17.87),(122618,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122618,32.2,0.8,27.6,54783,75,NULL,'A82, H','NGC 5690',NULL,'1997ApJS..109..333W',1997,1,2.35,NULL,'G',0.000013,NULL,'12.7g',0.96,'Sc? sp         HII','Isolated galaxy',NULL,NULL,NULL,1,219.421125,2.29083,0.117,NULL,58306757841,911043091,14235048,12.7),(122619,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122619,30.97,0.4,15.6,54783,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5690',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122620,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122620,31.24,0.47,17.7,54783,75,NULL,'A82, H, raw','NGC 5690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122621,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122621,31.27,0.47,17.9,54783,75,NULL,'A82, H, inv','NGC 5690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122622,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122622,31.33,0.43,18.5,54783,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5690',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122623,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122623,31.41,0.4,19.1,54783,75,NULL,NULL,'NGC 5690',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122624,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122624,31.41,0.43,19.1,54783,75,NULL,'3.6 micron, color corrected','NGC 5690',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122625,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122625,31.51,0.2,20,54783,74.4,NULL,NULL,'NGC 5690',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122626,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122626,31.53,0.36,20.2,54783,NULL,NULL,NULL,'NGC 5690',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122627,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122627,31.53,NULL,20.2,54783,72,NULL,NULL,'NGC 5690',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122628,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122628,31.63,0.47,21.2,54783,75,NULL,'A82, H, cor','NGC 5690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122629,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122629,31.91,0.49,24.1,54783,75,NULL,'IR','NGC 5690',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122630,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122630,32.3,0.4,28.8,54783,75,NULL,'B','NGC 5690',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122631,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122631,37.91,0.46,381,54784,70,NULL,NULL,'2MASX J14374141+4234400',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000178,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.422625,42.57778,0.01,NULL,59961554271,936899285,14639051,17.9),(122632,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122632,37.02,0.46,253,54785,70,NULL,NULL,'2MASX J14374144+5908565',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000102,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.422666667,59.14914,0.005,NULL,57722608782,901915762,14092433,16.5),(122633,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122633,37.97,0.46,392,54786,70,NULL,NULL,'2MASX J14374184+4619250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,219.424333,46.32378,0.009,NULL,59953977230,936780894,14637201,18.1),(122634,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122634,37.5,0.46,316,54787,70,NULL,NULL,'2MASX J14374292+6128241',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.428625,61.47342,0.021,NULL,57752536602,902383384,14099740,17.5),(122635,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122635,37.33,0.46,292,54788,70,NULL,NULL,'2MASX J14374341+3737479',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000193,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,219.4309583,37.62997,0,NULL,60079205614,938737587,14667774,16.2),(122636,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122636,37,0.46,251,54789,70,NULL,NULL,'2MASX J14374441+0351020',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.435083333,3.8505,0.085,NULL,58313802177,911153159,14236768,17.5),(122637,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122637,37.43,0.46,306,54790,70,NULL,NULL,'2MASX J14374491+1853208',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.4370417,18.88925,0.043,NULL,59508924921,929826951,14528546,17.7),(122638,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122638,35.79,0.1,144,54791,70,NULL,NULL,'2MASX J14374543+0318310',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000091,NULL,'16.1g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,219.4392917,3.30861,0.113,NULL,58313586224,911149784,14236715,16.1),(122639,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122639,37.94,0.46,387,54792,70,NULL,NULL,'SDSS J143745.65+214323.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.44025,21.72314,0.026,NULL,59503108270,929736066,14527126,18),(122640,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122640,35.8,0.46,144,54793,70,NULL,NULL,'2MASX J14374580+2803313',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000267,NULL,'16.7',0.26,NULL,NULL,NULL,NULL,NULL,1,219.440917,28.05864,0.02,NULL,60025485703,937898214,14654659,16.7),(122641,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122641,38.38,0.23,474,54794,70,NULL,NULL,'2MASX J14374651+1632359',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.443833333,16.54336,0,NULL,59552558367,930508724,14539198,17.9),(122642,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122642,37.94,0.11,387,54795,70,NULL,NULL,'2MASX J14374779+2451273',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'16.73',0.3,'BrClG',NULL,NULL,NULL,NULL,1,219.449167,24.85753,0.091,NULL,59498395470,929662429,14525975,16.73),(122643,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122643,36.14,0.56,169,54796,70,NULL,NULL,'2MASX J14374892-1901548',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.06',NULL,NULL,NULL,NULL,NULL,NULL,1,219.454,-19.03208,0.365,NULL,46557740288,727464692,11366635,16.06),(122644,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122644,32.98,0.4,39.5,54797,75,NULL,'Edat, raw','IC 4464',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000107,NULL,'12.59',0.6,'SAB(r)0^0^:',NULL,NULL,NULL,NULL,1,219.454167,-36.878,0.285,NULL,47227579934,737930936,11530170,12.59),(122645,'D-Sigma','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122645,33.34,0.4,46.6,54797,75,NULL,'Edat, cor','IC 4464',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122646,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122646,33.09,0.47,41.5,54797,70,NULL,NULL,'IC 4464',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122647,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122647,32.95,0.45,38.9,54797,NULL,NULL,'K','IC 4464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122648,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122648,33.89,0.4,60,54797,NULL,NULL,'mean','IC 4464',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122649,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122649,38.94,0.46,614,54798,70,NULL,NULL,'2MASX J14374911+5713246',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.454625,57.22347,0.017,NULL,57251173020,894549578,13977337,18.2),(122650,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122650,38.07,0.21,410,54799,70,NULL,NULL,'2MASX J14374924+2100518',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.45525,21.01433,0.027,NULL,59502843696,929731932,14527061,17.7),(122651,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122651,38.56,0.46,516,54800,70,NULL,NULL,'2MASX J14374932+1619540',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.455625,16.33181,0,NULL,59552466456,930507288,14539176,17.7),(122652,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122652,35.02,0.47,101,54801,70,NULL,NULL,'2MASX J14375074-2136438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.53',NULL,NULL,NULL,NULL,NULL,NULL,1,219.461583,-21.61228,0.321,NULL,46529410997,727022046,11359719,15.53),(122653,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2001ck','R',122653,35.89,0.06,151,54802,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 09425',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,'GPair',0.00011,NULL,NULL,NULL,'Sb',NULL,NULL,NULL,NULL,1,219.4619583,30.48122,0,NULL,60020223305,937815989,14653374,NULL),(122654,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2001ck',NULL,122654,35.96,0.15,151,54802,70,NULL,'SALT 2','UGC 09425',0.034717,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122655,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SN 2001ck','R',122655,35.93,0.06,153,54802,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 09425',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122656,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122656,38.38,0.23,474,54803,70,NULL,NULL,'2MASX J14375096+1632340',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.462416667,16.54272,0,NULL,59552555725,930508683,14539198,17.4),(122657,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122657,37.71,0.46,349,54804,70,NULL,NULL,'2MASX J14375161-0040209',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000077,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.4649583,-0.67244,0.105,NULL,43545408053,680397000,10631203,17.5),(122658,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122658,32.4,0.8,30.2,54805,75,NULL,'B','NGC 5691',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000027,NULL,'12.52',1.4,'SAB(s)a: pec   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.47225,-0.39889,0.121,NULL,43490837501,679544335,10617880,12.52),(122659,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122659,32.01,NULL,25.2,54805,72,NULL,NULL,'NGC 5691',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122660,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122660,37.7,0.46,347,54806,70,NULL,NULL,'2MASX J14375334+1952568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.16',0.13,NULL,NULL,NULL,NULL,NULL,1,219.472208333,19.88242,0.013,NULL,59509275660,929832432,14528631,18.16),(122661,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122661,37.84,0.33,370,54807,70,NULL,NULL,'2MASX J14375435+2922523',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'18.02',0.18,'Sb',NULL,NULL,NULL,NULL,1,219.476417,29.38128,0,NULL,60017713737,937776777,14652762,18.02),(122662,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122662,37.58,0.46,329,54808,70,NULL,NULL,'2MASX J14375520+1507440',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.480167,15.12908,0,NULL,59556867628,930576056,14540250,16.6),(122663,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122663,37.78,0.27,360,54809,70,NULL,NULL,'2MASX J14375681+2351403',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000133,NULL,'18.78',0.14,NULL,NULL,NULL,NULL,NULL,1,219.486875,23.86133,0.08,NULL,59506984614,929796634,14528072,18.78),(122664,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122664,37.59,0.46,329,54810,70,NULL,NULL,'SDSS J143757.21+335517.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.488417,33.92144,0,NULL,60067644447,938556944,14664952,17.7),(122665,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122665,37.82,0.46,366,54811,70,NULL,NULL,'2MASX J14375745+1838438',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.16',0.19,NULL,NULL,NULL,NULL,NULL,1,219.48925,18.64553,0.043,NULL,59479503841,929367247,14521363,18.16),(122666,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122666,37.94,0.11,387,54812,70,NULL,NULL,'2MASX J14375828+2409063',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.12',0.23,'BrClG',NULL,NULL,NULL,NULL,1,219.492833,24.15164,0.095,NULL,59498939506,929670929,14526108,17.12),(122667,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122667,38.38,0.23,474,54813,70,NULL,NULL,'SDSS J143758.45+163119.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.493583,16.52194,0,NULL,59552501976,930507843,14539185,17.5),(122668,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122668,36.99,0.46,250,54814,70,NULL,NULL,'2MASX J14375878+0352120',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'16.8g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,219.495,3.87008,0.085,NULL,58312167297,911127614,14236368,16.8),(122669,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122669,35.21,0.54,110,54815,70,NULL,NULL,'2MASX J14375967-1644049',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.24',0.3,NULL,NULL,NULL,NULL,NULL,1,219.4985417,-16.73467,0.337,NULL,46681007117,729390736,11396730,16.24),(122670,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122670,37.86,0.46,374,54816,70,NULL,NULL,'SDSS J143759.65+333948.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,219.498583,33.66353,0,NULL,60067506237,938554784,14664918,18.6),(122671,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122671,38.38,0.23,474,54817,70,NULL,NULL,'2MASX J14375847+1631190',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.4989583,16.51914,0,NULL,59552501906,930507842,14539185,18.1),(122672,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122672,36.57,0.46,206,54818,70,NULL,NULL,'2MASX J14375993+5114561',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.4997917,51.24894,0.013,NULL,59204259959,925066561,14454165,16.3),(122673,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122673,37.94,0.11,387,54819,70,NULL,NULL,'SDSS J143800.23+245409.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.7g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.5009583,24.90272,0.091,NULL,59498394609,929662415,14525975,18.7),(122674,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122674,35.66,0.46,136,54820,70,NULL,NULL,'CGCG 075-096',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00013,NULL,'15.5g',0.46,'AGN',NULL,NULL,NULL,NULL,1,219.50425,10.18097,0.017,NULL,59373245833,927706966,14495421,15.5),(122675,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122675,36.23,0.46,176,54821,70,NULL,NULL,'2MASX J14380121+1954428',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.16',0.17,NULL,NULL,NULL,NULL,NULL,1,219.505167,19.912,0.013,NULL,59509263960,929832249,14528628,18.16),(122676,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122676,36.07,0.46,164,54822,70,NULL,NULL,'SDSS J143801.30+033011.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.505458333,3.50322,0.081,NULL,58313496418,911148381,14236693,17),(122677,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122677,37.78,0.27,360,54823,70,NULL,NULL,'2MASX J14380153+2343158',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.506417,23.72114,0.083,NULL,59507005599,929796962,14528077,17),(122678,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122678,37.18,0.23,272,54824,70,NULL,NULL,'2MASX J14380153+1013393',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,219.5065,10.22756,0.017,NULL,59373254979,927707109,14495423,16.4),(122679,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122679,37.61,0.33,332,54825,70,NULL,NULL,'2MASX J14380189+2338478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.5077917,23.64658,0.056,NULL,59507012079,929797063,14528079,17.1),(122680,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122680,37.48,0.46,313,54826,70,NULL,NULL,'2MASX J14380257+1757258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.510833,17.95717,0,NULL,59480316904,929379951,14521561,17.5),(122681,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122681,37.71,0.46,348,54827,70,NULL,NULL,'2MASX J14380368+3108444',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.515167,31.14581,0,NULL,60016757487,937761835,14652528,18),(122682,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122682,38.07,0.21,410,54828,70,NULL,NULL,'2MASX J14380366+2054298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.515417,20.90819,0.027,NULL,59502865474,929732273,14527066,17.3),(122683,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122683,37.78,0.27,360,54829,70,NULL,NULL,'2MASX J14380429+2342088',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.518083,23.70244,0.056,NULL,59507014642,929797103,14528079,17.6),(122684,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122684,38.07,0.21,410,54830,70,NULL,NULL,'2MASX J14380452+2058248',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.518917,20.97353,0.027,NULL,59502873810,929732403,14527068,17.5),(122685,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122685,35.5,0.46,126,54831,70,NULL,NULL,'2MASX J14380603+2221458',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000161,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,219.525167,22.36269,0.018,NULL,59505410627,929772041,14527688,16.1),(122686,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122686,37.62,0.46,335,54832,70,NULL,NULL,'SDSS J143808.03+133921.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,219.5335,13.65589,0.021,NULL,59543707018,930370422,14537037,NULL),(122687,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122687,37.96,0.46,390,54833,70,NULL,NULL,'2MASX J14380841+3510004',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'17.3g',0.23,'E/S0',NULL,NULL,NULL,NULL,1,219.534958333,35.16678,0,NULL,60070813969,938606468,14665726,17.3),(122688,'SNIa','2016-12-15 15:15:27','2016-12-16 11:20:40','1','SCP 06K00',NULL,122688,44.59,0.09,3420,54834,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','FLX J143808.38+341417.6',1.415,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,'17.4J',NULL,NULL,NULL,NULL,NULL,NULL,1,219.534916667,34.23825,0,NULL,60067438712,938553729,14664902,17.4),(122689,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122689,36.14,0.46,169,54835,70,NULL,NULL,'2MASX J14380968+3629202',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.1g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,219.540166667,36.48894,0,NULL,60078426938,938725420,14667584,16.1),(122690,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122690,35.53,0.46,127,54836,70,NULL,NULL,'IC 1035',NULL,'2015arXiv151105856S',2015,1,0.86,'HOLM 664B is the star superposed on the northeast side.','G',0.00017,NULL,'14.8g',0.62,NULL,NULL,NULL,NULL,NULL,1,219.5425417,9.33603,0.029,NULL,59373400709,927709386,14495459,14.8),(122691,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122691,36.77,0.46,226,54837,70,NULL,NULL,'2MASX J14381129+0522248',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.547083,5.37367,0.069,NULL,58313055620,911141494,14236585,16.9),(122692,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122692,32.34,0.4,29.4,54838,75,NULL,NULL,'NGC 5714',NULL,'2008Ap.....51..336K',2008,1,1.73,NULL,'G',0.000023,NULL,'13.9g',0.48,'Sc','Group member',NULL,NULL,NULL,1,219.548,46.63825,0.009,NULL,59987866847,937310419,14645475,13.9),(122693,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122693,32.71,0.4,34.8,54838,NULL,NULL,'mean','NGC 5714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122694,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122694,32.78,0.4,36.1,54838,75,NULL,'B','NGC 5714',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122695,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122695,32.89,0.43,37.9,54838,75,NULL,'3.6 micron, color corrected','NGC 5714',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122696,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122696,32.9,0.46,38,54838,NULL,NULL,'J','NGC 5714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122697,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122697,32.9,0.43,38.1,54838,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5714',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122698,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122698,32.91,0.47,38.2,54838,NULL,NULL,'H','NGC 5714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122699,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122699,32.94,0.2,38.7,54838,74.4,NULL,NULL,'NGC 5714',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122700,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122700,32.97,0.49,39.2,54838,75,NULL,'IR','NGC 5714',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122701,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122701,33.04,0.45,40.6,54838,NULL,NULL,'K','NGC 5714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122702,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122702,33.08,0.47,41.3,54838,NULL,NULL,'Malmquist cor.','NGC 5714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122703,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122703,33.16,0.45,42.9,54838,NULL,NULL,NULL,'NGC 5714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122704,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122704,33.28,NULL,45.2,54838,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122705,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122705,33.28,NULL,45.3,54838,NULL,NULL,NULL,'NGC 5714',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122706,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122706,33.28,NULL,45.3,54838,NULL,NULL,'Dipole + Quadrupole','NGC 5714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122707,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122707,33.28,NULL,45.4,54838,NULL,NULL,'Dipole','NGC 5714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122708,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122708,37.18,0.46,273,54839,70,NULL,NULL,'2MASX J14381196+1422285',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.5499583,14.37456,0,NULL,59556475232,930569925,14540155,17.3),(122709,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122709,37.52,0.46,319,54840,70,NULL,NULL,'2MASX J14381234+0806513',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000136,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.551333,8.11431,0.033,NULL,59364592680,927571760,14493308,17.2),(122710,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122710,37.61,0.46,333,54841,70,NULL,NULL,'2MASX J14381310+2708029',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,219.5545417,27.13403,0.044,NULL,60028377092,937943392,14655365,18.4),(122711,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122711,37.9,0.46,381,54842,70,NULL,NULL,'SDSS J143813.39+164718.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.555833,16.78839,0,NULL,59552335203,930505237,14539144,18.3),(122712,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122712,37.25,0.46,282,54843,70,NULL,NULL,'2MASX J14381342+5056402',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,219.5559583,50.94444,0.005,NULL,59199876013,924998062,14453094,16.3),(122713,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122713,35.13,0.46,106,54844,70,NULL,NULL,'2MASX J14381411+1338215',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.13',0.28,NULL,NULL,NULL,NULL,NULL,1,219.558875,13.63933,0.021,NULL,59543688930,930370139,14537033,16.13),(122714,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122714,38.2,0.46,436,54845,70,NULL,NULL,'2MASX J14381472+2331264',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.561333,23.524,0.056,NULL,59508036581,929813071,14528329,18.1),(122715,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122715,37.29,0.46,287,54846,70,NULL,NULL,'2MASX J14381551+5704455',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000198,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.5644583,57.07922,0.021,NULL,57251058718,894547792,13977309,17),(122716,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122716,38.32,0.46,461,54847,70,NULL,NULL,'SDSS J143815.67+240311.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000147,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,219.565333,24.05325,0.08,NULL,59498936405,929670881,14526107,18.8),(122717,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122717,32.36,0.43,29.7,54848,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5704',NULL,'2014MNRAS.444..527S',2014,1,1.85,'Identification as NGC 5704 is not certain.','G',0.000057,NULL,'13.7g',0.6,'Sdm:','Field galaxy',NULL,NULL,NULL,1,219.567833333,40.45675,0.02,NULL,59951325126,936739455,14636553,13.7),(122718,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122718,32.44,0.43,30.8,54848,75,NULL,'3.6 micron, color corrected','NGC 5704',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122719,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122719,32.54,0.2,32.2,54848,74.4,NULL,NULL,'NGC 5704',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122720,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122720,37.95,0.46,388,54849,70,NULL,NULL,'2MASX J14381669+0244168',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,219.569666667,2.73806,0.081,NULL,58306154066,911033657,14234900,17.5),(122721,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122721,38.05,0.46,407,54850,70,NULL,NULL,'2MASX J14381689+4721110',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.5702917,47.35297,0,NULL,59987098950,937298421,14645287,17.2),(122722,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122722,37.72,0.46,350,54851,70,NULL,NULL,'2MASX J14381685+0539468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.570333,5.66297,0.065,NULL,58309575875,911087123,14235736,17.3),(122723,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122723,34.84,0.2,92.9,54852,74.4,NULL,NULL,'CGCG 075-099',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000088,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.573875,12.03433,0,NULL,59360860976,927513452,14492397,16.4),(122724,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122724,35.24,0.49,112,54852,75,NULL,'IR','CGCG 075-099',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122725,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122725,32.36,0.8,29.7,54853,75,NULL,'B','NGC 5692',NULL,'1988NBGC.C....0000T',1988,1,1.04,NULL,'G',0.000079,NULL,'13.5g',0.64,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.5754583,3.41033,0.081,NULL,58313659239,911150925,14236733,13.5),(122726,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122726,31.56,NULL,20.5,54853,72,NULL,NULL,'NGC 5692',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122727,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122727,37.14,0.46,267,54854,70,NULL,NULL,'2MASX J14381813+1433445',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.39',0.15,NULL,NULL,NULL,NULL,NULL,1,219.5755,14.56244,0,NULL,59556319565,930567493,14540117,18.39),(122728,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122728,36.3,0.33,182,54855,70,NULL,NULL,'2MASX J14381862+1736335',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000117,NULL,'10.9K',NULL,NULL,NULL,NULL,NULL,NULL,1,219.5775417,17.60939,0,NULL,59480050137,929375783,14521496,10.9),(122729,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122729,38.07,0.21,410,54856,70,NULL,NULL,'2MASX J14382136+2105285',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.5889583,21.09114,0.027,NULL,59502879286,929732488,14527070,17.6),(122730,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122730,37.29,0.46,288,54857,70,NULL,NULL,'2MASX J14382289+3012245',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'18.03',0.16,NULL,NULL,NULL,NULL,NULL,1,219.595375,30.20681,0,NULL,60020050556,937813289,14653332,18.03),(122731,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122731,37.29,0.46,287,54858,70,NULL,NULL,'2MASX J14382314+3042245',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.596583,30.70681,0,NULL,60020125157,937814455,14653350,17.1),(122732,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122732,38.13,0.27,423,54859,70,NULL,NULL,'2MASX J14382443+0850174',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000189,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.60175,8.83822,0.041,NULL,59364978464,927577788,14493402,17.6),(122733,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122733,38.19,0.46,435,54860,70,NULL,NULL,'2MASX J14382475+2140125',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.6032083,21.67,0,NULL,59503106660,929736041,14527125,16.9),(122734,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122734,37.54,0.46,322,54861,70,NULL,NULL,'2MASX J14382488+5201182',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.603417,52.02172,0,NULL,59204036694,925063073,14454110,17.4),(122735,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122735,36.48,0.46,198,54862,70,NULL,NULL,'2MASX J14382500+1458045',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.00',0.19,NULL,NULL,NULL,NULL,NULL,1,219.604125,14.96792,0,NULL,59556781351,930574708,14540229,18),(122736,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122736,37.26,0.46,284,54863,70,NULL,NULL,'2MASX J14382512+1928435',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.34',0.16,NULL,NULL,NULL,NULL,NULL,1,219.604667,19.47878,0.03,NULL,59509763578,929840055,14528750,18.34),(122737,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122737,37.91,0.46,382,54864,70,NULL,NULL,'2MASX J14382567+1834205',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,219.607125,18.57256,0.042,NULL,59479554002,929368031,14521375,18.48),(122738,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122738,35.66,0.46,136,54865,70,NULL,NULL,'2MASX J14382571+2320185',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,219.6072917,23.3385,0.028,NULL,59508019508,929812804,14528325,16.3),(122739,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122739,38.3,0.33,457,54866,70,NULL,NULL,'2MASX J14382644+2717529',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.610083,27.29806,0.044,NULL,60028615338,937947114,14655423,17.9),(122740,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122740,32.59,0.8,32.9,54867,75,NULL,'MAT, I','IC 4468',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'13.75',0.6,'SB(s)c         HII','Pair member (points to parent)',NULL,NULL,NULL,1,219.611416667,-22.36761,0.297,NULL,46536495062,727132735,11361448,13.75),(122741,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122741,31.69,0.4,21.8,54867,75,NULL,NULL,'IC 4468',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122742,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122742,32.13,0.43,26.7,54867,75,NULL,'3.6 micron, color + selection bias corrected','IC 4468',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122743,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122743,32.14,0.49,26.8,54867,75,NULL,'IR','IC 4468',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122744,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122744,32.2,0.43,27.5,54867,75,NULL,'3.6 micron, color corrected','IC 4468',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122745,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122745,32.36,0.2,29.7,54867,74.4,NULL,NULL,'IC 4468',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122746,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122746,32.41,0.32,30.3,54867,85,NULL,'I, raw','IC 4468',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122747,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122747,32.44,0.32,30.7,54867,85,NULL,'I, inv','IC 4468',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122748,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122748,32.5,0.46,31.6,54867,NULL,NULL,'J','IC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122749,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122749,32.52,0.47,31.9,54867,NULL,NULL,'H','IC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122750,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122750,32.53,0.43,32.1,54867,75,NULL,'MAT, I, raw','IC 4468',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122751,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122751,32.61,0.45,33.3,54867,NULL,NULL,'K','IC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122752,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122752,32.68,0.43,34.3,54867,75,NULL,'MAT, I, inv','IC 4468',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122753,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122753,32.7,0.4,34.7,54867,NULL,NULL,'mean','IC 4468',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122754,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122754,32.74,0.51,35.3,54867,NULL,NULL,NULL,'IC 4468',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122755,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122755,32.78,0.43,35.9,54867,75,NULL,'MAT, I, cor','IC 4468',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122756,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122756,32.88,0.48,37.6,54867,NULL,NULL,'Malmquist cor.','IC 4468',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122757,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122757,38,0.46,399,54868,70,NULL,NULL,'2MASX J14382813+3501435',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.6170417,35.02883,0,NULL,60070777145,938605892,14665717,17.2),(122758,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122758,36.31,0.46,183,54869,70,NULL,NULL,'2MASX J14382948+1459206',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,219.622917,14.98914,0,NULL,59556780968,930574702,14540229,18.16),(122759,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122759,37.61,0.33,332,54870,70,NULL,NULL,'2MASX J14382963+2336495',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.31',0.14,NULL,NULL,NULL,NULL,NULL,1,219.623333,23.61381,0.056,NULL,59506979244,929796550,14528071,18.31),(122760,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122760,38.13,0.27,423,54871,70,NULL,NULL,'SDSS J143830.09+085709.3',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,'PHOT','16.5g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,219.625417,8.95258,0.037,NULL,59364990431,927577975,14493405,16.5),(122761,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122761,37.45,0.46,309,54872,70,NULL,NULL,'2MASX J14383051+3511084',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.627,35.18581,0,NULL,60070816334,938606505,14665726,17.5),(122762,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122762,38.13,0.27,423,54873,70,NULL,NULL,'2MASX J14383009+0857094',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'PHOT','17.88',0.18,NULL,NULL,NULL,NULL,NULL,1,219.6285,8.95786,0.037,NULL,59364990444,927577975,14493405,17.88),(122763,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122763,36.42,0.33,192,54874,70,NULL,NULL,'2MASX J14383118+0619304',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.629833,6.325,0.057,NULL,58276388974,910568577,14227634,17.1),(122764,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122764,37.16,0.46,271,54875,70,NULL,NULL,'SDSS J143831.60-003557.9',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000098,NULL,'17.2g',0.22,'ELG',NULL,NULL,NULL,NULL,1,219.631667,-0.59944,0.109,NULL,43490808449,679543882,10617873,17.2),(122765,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122765,38.52,0.46,507,54876,70,NULL,NULL,'SDSS J143831.76+245343.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.632333333,24.89536,0.078,NULL,59498504554,929664133,14526002,18.7),(122766,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122766,37.59,0.46,330,54877,70,NULL,NULL,'2MASX J14383209-0058202',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.633625,-0.97228,0.105,NULL,43491158999,679549359,10617958,17.3),(122767,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122767,37.66,0.46,341,54878,70,NULL,NULL,'2MASX J14383219+4447212',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.634083,44.78925,0.024,NULL,59956924156,936826939,14637920,17.6),(122768,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122768,36.42,0.33,192,54879,70,NULL,NULL,'2MASX J14383259+0622084',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.6357083,6.36917,0.057,NULL,58276390422,910568600,14227634,16.7),(122769,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122769,35.29,0.47,114,54880,NULL,NULL,'H','NGC 5720',NULL,'2007A&A...465...71T',2007,1,1.46,NULL,'G',0.00002,NULL,'14.0g',0.86,'Sb',NULL,NULL,NULL,NULL,1,219.638708333,50.81522,0.013,NULL,59199911973,924998624,14453103,14),(122770,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122770,35.31,0.4,115,54880,NULL,NULL,'mean','NGC 5720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122771,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122771,35.34,0.2,117,54880,74.4,NULL,NULL,'NGC 5720',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122772,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122772,35.34,0.43,117,54880,75,NULL,'3.6 micron, color corrected','NGC 5720',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122773,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122773,35.4,0.46,120,54880,NULL,NULL,'J','NGC 5720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122774,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122774,35.4,0.45,120,54880,NULL,NULL,'K','NGC 5720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122775,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122775,35.5,0.43,126,54880,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5720',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122776,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122776,36.3,0.33,182,54881,70,NULL,NULL,'SDSS J143833.36+174615.4',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.0g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.639041667,17.77097,0.008,NULL,59480070727,929376105,14521501,16),(122777,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122777,37.92,0.46,384,54882,70,NULL,NULL,'2MASX J14383362+1827375',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.99',0.12,NULL,NULL,NULL,NULL,NULL,1,219.640083333,18.46053,0.042,NULL,59479522198,929367534,14521367,18.99),(122778,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122778,36.85,0.46,235,54883,70,NULL,NULL,'2MASX J14383383-0127302',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.641125,-1.45839,0.093,NULL,43545803431,680403178,10631299,16.9),(122779,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122779,38.51,0.46,504,54884,70,NULL,NULL,'SDSS J143834.68+553939.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000168,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,219.644541667,55.66089,0.005,NULL,57257808184,894653252,13978957,18.8),(122780,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122780,37.6,0.46,331,54885,70,NULL,NULL,'2MASX J14383558+2132565',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.648375,21.54917,0.018,NULL,59503216332,929737755,14527152,18),(122781,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122781,38.46,0.46,491,54886,70,NULL,NULL,'2MASX J14383563+4640132',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.648375,46.67031,0,NULL,59987864201,937310378,14645474,18.3),(122782,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122782,36.31,0.27,183,54887,70,NULL,NULL,'2MASX J14383583+0816194',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.54',0.27,NULL,NULL,NULL,NULL,NULL,1,219.649291667,8.27203,0.041,NULL,59364552192,927571128,14493298,17.54),(122783,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122783,38.25,0.46,446,54888,70,NULL,NULL,'2MASX J14383658+2441295',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00018,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.652333333,24.69164,0.091,NULL,59498479181,929663737,14525995,18.3),(122784,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122784,38.06,0.46,410,54889,70,NULL,NULL,'2MASX J14383753+4220462',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.6564583,42.34631,0.01,NULL,59961194752,936893668,14638963,18.1),(122785,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122785,37.26,0.46,283,54890,70,NULL,NULL,'2MASX J14383889+4917291',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.6620417,49.29167,0.109,NULL,59202088199,925032628,14453634,18),(122786,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122786,38.27,0.46,451,54891,70,NULL,NULL,'2MASX J14383989+1725268',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.666375,17.42425,0.024,NULL,59551037311,930484957,14538827,17.9),(122787,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122787,38.65,0.46,537,54892,70,NULL,NULL,'SDSS J143840.06-021447.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.666916667,-2.24653,0.169,NULL,43547808259,680434504,10631789,17.9),(122788,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122788,37.44,0.46,308,54893,70,NULL,NULL,'SDSS J143841.17+001025.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.1g',0.13,'AGN',NULL,NULL,NULL,'Post Starburst (E+A) or (a+k) Galaxy',1,219.671583,0.17367,0.105,NULL,58259122357,910298786,14223418,18.1),(122789,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122789,35.43,0.2,122,54894,74.4,NULL,NULL,'CGCG 075-100',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000101,NULL,'15.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.671833,9.54219,0.021,NULL,59373419496,927709679,14495463,15.6),(122790,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122790,37.71,0.46,348,54895,70,NULL,NULL,'SDSS J143841.34+184210.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.6722917,18.70289,0.042,NULL,59479531469,929367679,14521369,18.5),(122791,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122791,35.23,0.33,111,54896,70,NULL,NULL,'2MASX J14384182+1957055',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.10',0.27,NULL,NULL,NULL,NULL,NULL,1,219.6744583,19.95153,0,NULL,59501151945,929705499,14526648,17.1),(122792,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122792,36.72,0.46,221,54897,70,NULL,NULL,'2MASX J14384205+5105561',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.6752083,51.09886,0.005,NULL,59204296421,925067131,14454173,16.6),(122793,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122793,38.37,0.33,471,54898,70,NULL,NULL,'SDSS J143842.18+451432.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.675791667,45.24239,0.046,NULL,59957013167,936828330,14637942,18),(122794,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122794,37.12,0.46,265,54899,70,NULL,NULL,'2MASX J14384347+2218319',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.681166667,22.30897,0.018,NULL,59505063828,929766622,14527603,17.2),(122795,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122795,35.88,0.46,150,54900,70,NULL,NULL,'2MASX J14384372+2235449',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.682208333,22.59589,0.015,NULL,59505389327,929771708,14527682,16.5),(122796,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122796,36.48,0.46,198,54901,70,NULL,NULL,'2MASX J14384436+4732162',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.6850417,47.538,0.009,NULL,59932531711,936445807,14631965,16.5),(122797,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122797,38.07,0.21,410,54902,70,NULL,NULL,'2MASX J14384570+2108379',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.6905,21.14389,0.027,NULL,59503289391,929738896,14527170,17.5),(122798,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122798,37.75,0.46,354,54903,70,NULL,NULL,'2MASX J14384599+1557328',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.6915417,15.95908,0,NULL,59552121413,930501897,14539092,17.2),(122799,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122799,38.37,0.33,471,54904,70,NULL,NULL,'2MASX J14384605+4515172',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,219.692,45.255,0.057,NULL,59957014936,936828358,14637943,18.6),(122800,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122800,37.05,0.33,257,54905,70,NULL,NULL,'CGCG 075-101',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000157,NULL,'15.3g',0.46,NULL,NULL,NULL,NULL,NULL,1,219.698333,10.12147,0.017,NULL,59373175091,927705860,14495404,15.3),(122801,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122801,37.53,0.46,320,54906,70,NULL,NULL,'2MASX J14384868+0413186',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.702917,4.22178,0.057,NULL,58312118362,911126849,14236357,16.9),(122802,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122802,33.85,0.4,58.9,54907,NULL,NULL,'mean','NGC 5703',NULL,'2007A&A...465...71T',2007,1,1.45,NULL,'G',0.00003,NULL,'14.1g',0.56,'SBa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.708416667,30.44253,0,NULL,60020144587,937814759,14653355,14.1),(122803,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122803,33.89,0.47,59.9,54907,NULL,NULL,'H','NGC 5703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122804,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122804,33.96,0.46,61.9,54907,NULL,NULL,'J','NGC 5703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122805,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122805,34.02,0.45,63.7,54907,NULL,NULL,'K','NGC 5703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122806,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122806,37.66,0.46,341,54908,70,NULL,NULL,'SDSS J143852.06+553233.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000129,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.716916667,55.54269,0.005,NULL,57246514808,894476793,13976199,18),(122807,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122807,36.81,0.46,230,54909,70,NULL,NULL,'2MASX J14385282+3103288',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,219.7202083,31.05783,0,NULL,60016649970,937760155,14652502,16.4),(122808,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122808,36.05,0.33,163,54910,70,NULL,NULL,'NGC 5721',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.0002,NULL,'16.4g',0.25,NULL,'Group member',NULL,NULL,NULL,1,219.720667,46.67444,0,NULL,59987907789,937311059,14645485,16.4),(122809,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122809,32.3,0.8,28.8,54911,75,NULL,NULL,'DDO 195',NULL,'1988NBGC.C....0000T',1988,1,2.9,'MCG R.A.=14h35.2m is presumably a misprint.','G',0.000017,NULL,'14',0.7,'IB(s)m',NULL,NULL,NULL,NULL,1,219.7249583,-8.62861,0.181,NULL,46466376473,726037132,11344330,14),(122810,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122810,36.05,0.33,163,54912,70,NULL,NULL,'NGC 5722',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000093,NULL,'15.0g',0.64,NULL,NULL,NULL,NULL,NULL,1,219.7267083,46.66561,0,NULL,59987907821,937311059,14645485,15),(122811,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122811,38.18,0.19,432,54913,70,NULL,NULL,'2MASX J14385471+1743398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.23',0.19,'BrClG',NULL,NULL,NULL,NULL,1,219.728125,17.72783,0.008,NULL,59480052607,929375821,14521497,18.23),(122812,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122812,34.25,0.45,70.7,54914,NULL,NULL,'K','NGC 5702',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000103,NULL,'14.32',0.8,'S0','in a pair',NULL,NULL,NULL,1,219.7295,20.50672,0.009,NULL,59503825492,929747273,14527301,14.32),(122813,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122813,34.49,0.4,79,54914,NULL,NULL,'mean','NGC 5702',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122814,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122814,37.93,0.46,386,54915,70,NULL,NULL,'2MASX J14385520+5602028',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.72975,56.03406,0,NULL,57259109813,894673590,13979274,18.3),(122815,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122815,38.2,0.46,437,54916,70,NULL,NULL,'2MASX J14385564+1810120',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.95',0.2,NULL,NULL,NULL,NULL,NULL,1,219.7317917,18.17014,0.01,NULL,59479593090,929368642,14521385,17.95),(122816,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122816,38.1,0.46,416,54917,70,NULL,NULL,'2MASX J14385631+2525516',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000205,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.734833,25.43094,0.054,NULL,60021798426,937840600,14653759,16.9),(122817,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122817,37.92,0.46,383,54918,70,NULL,NULL,'2MASX J14385675+2014100',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,219.736583,20.23619,0.016,NULL,59500963324,929702551,14526602,18.4),(122818,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122818,37.05,0.33,257,54919,70,NULL,NULL,'2MASX J14385680+1007349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.736625,10.12631,0.017,NULL,59373178831,927705919,14495404,17.2),(122819,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122819,37.05,0.46,257,54920,70,NULL,NULL,'2MASX J14385683+2821116',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.85',0.25,NULL,NULL,NULL,NULL,NULL,1,219.736791667,28.35319,0.024,NULL,60025359081,937896235,14654628,16.85),(122820,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122820,37.08,0.33,260,54921,70,NULL,NULL,'2MASX J14385748+4949586',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.7395,49.83308,0.037,NULL,59200202306,925003161,14453174,17.8),(122821,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122821,37.08,0.33,260,54922,70,NULL,NULL,'2MASX J14385882+4953006',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,219.745083,49.88344,0.037,NULL,59200131717,925002058,14453157,16.7),(122822,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122822,33.13,0.4,42.3,54923,75,NULL,NULL,'UGC 09448',NULL,'2008Ap.....51..336K',2008,1,1.54,NULL,'G',0.000027,NULL,'14.9g',0.33,'Sbc',NULL,NULL,NULL,NULL,1,219.7464583,51.12069,0.005,NULL,59204249762,925066402,14454162,14.9),(122823,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122823,33.32,NULL,46.2,54923,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09448',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122824,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122824,33.35,NULL,46.7,54923,NULL,NULL,'Dipole + Quadrupole','UGC 09448',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122825,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122825,33.37,NULL,47.1,54923,NULL,NULL,'Dipole','UGC 09448',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122826,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122826,33.61,0.49,52.7,54923,75,NULL,'IR','UGC 09448',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122827,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122827,38.06,0.46,410,54924,70,NULL,NULL,'2MASX J14385947+2219460',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.7479583,22.32953,0.015,NULL,59505061472,929766585,14527602,17.7),(122828,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122828,35.31,0.2,115,54925,74.4,NULL,NULL,'CGCG 164-007',NULL,'2013AJ....146...86T',2013,1,0.76,'Noted in MCG as possibly interacting.','G',0.000091,NULL,'15.3g',0.42,'SB?',NULL,NULL,NULL,NULL,1,219.7500417,30.814,0,NULL,60016634885,937759920,14652498,15.3),(122829,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122829,39.01,0.46,634,54926,70,NULL,NULL,'2MASX J14390013+4855476',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,219.7505,48.93011,0.133,NULL,59932960560,936452508,14632070,18.4),(122830,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122830,38.08,0.46,412,54927,70,NULL,NULL,'2MASX J14390167+2626256',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.756875,26.44044,0.037,NULL,60026344456,937911632,14654869,17.4),(122831,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122831,37.74,0.46,354,54928,70,NULL,NULL,'SDSS J143902.50+220327.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000132,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.7604583,22.05758,0,NULL,59505075443,929766803,14527606,18.6),(122832,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122832,38.18,0.19,432,54929,70,NULL,NULL,'SDSS J143902.99+173801.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.7625,17.63383,0.008,NULL,59551153885,930486779,14538855,18.4),(122833,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122833,36.89,0.46,239,54930,70,NULL,NULL,'2MASX J14390368+3122027',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000126,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.7655417,31.36736,0,NULL,60017306698,937770417,14652662,17.8),(122834,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122834,32.13,0.4,26.7,54931,75,NULL,'B','UGC 09432',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000023,NULL,'14.60',0.8,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.767917,2.94917,0.089,NULL,58306092129,911032689,14234885,14.6),(122835,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122835,37.51,0.46,318,54932,70,NULL,NULL,'LCRS B143629.3-023620',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.7710417,-2.82053,0.201,NULL,43547610734,680431417,10631740,17.8),(122836,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122836,29.92,0.8,9.6,54933,75,NULL,NULL,'MRK 0475',NULL,'1988NBGC.C....0000T',1988,1,0.36,NULL,'G',0.000007,NULL,'16.2g',0.27,'BCD            WR',NULL,NULL,NULL,NULL,1,219.77275,36.80608,0,NULL,60078443232,938725675,14667588,16.2),(122837,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122837,29.82,NULL,9.2,54933,NULL,NULL,NULL,'MRK 0475',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122838,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122838,37.66,0.46,340,54934,70,NULL,NULL,'2MASX J14390562+2333220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0001,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.7735417,23.55619,0.052,NULL,59506967411,929796365,14528068,18.1),(122839,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122839,35.98,0.46,157,54935,70,NULL,NULL,'2MASX J14390570-0206569',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000103,NULL,'16.2g',0.28,'S0',NULL,NULL,NULL,NULL,1,219.773708333,-2.11569,0.161,NULL,43547812205,680434565,10631790,16.2),(122840,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122840,38.06,0.46,409,54936,70,NULL,NULL,'SDSS J143906.58+061756.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.7774583,6.29908,0.069,NULL,58276307405,910567303,14227614,17.9),(122841,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122841,35.81,0.46,145,54937,70,NULL,NULL,'CGCG 192-051',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000192,NULL,'15.2g',0.58,'E0',NULL,NULL,NULL,NULL,1,219.783333,38.13422,0.049,NULL,60078817011,938731515,14667679,15.2),(122842,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122842,35.58,0.58,131,54938,70,NULL,NULL,'2MASX J14390888-0212515',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.787083,-2.2145,0.161,NULL,43547770331,680433911,10631779,16.3),(122843,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122843,37.44,0.27,308,54939,70,NULL,NULL,'2MASX J14390952+1416465',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.7897083,14.27942,0.017,NULL,59558285258,930598207,14540596,17.8),(122844,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122844,37.97,0.46,393,54940,70,NULL,NULL,'2MASX J14390989+1654105',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.791125,16.90281,0,NULL,59554636494,930541195,14539706,18),(122845,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122845,37.51,0.46,317,54941,70,NULL,NULL,'2MASX J14391007+2353290',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.792,23.89131,0.052,NULL,59507207856,929800122,14528126,17.4),(122846,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122846,36.92,0.43,242,54942,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09437',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',NULL,NULL,'16.0',0.5,'SB?',NULL,NULL,NULL,NULL,1,219.7939583,18.71314,0.024,NULL,59479527256,929367613,14521368,16),(122847,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122847,37.44,0.27,308,54943,70,NULL,NULL,'2MASX J14391083+1417245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.7952083,14.29028,0.017,NULL,59558284708,930598198,14540596,16.7),(122848,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122848,37.71,0.46,348,54944,70,NULL,NULL,'2MASX J14391093+3755163',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.795625,37.92108,0.053,NULL,60078770958,938730796,14667668,17.1),(122849,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122849,32.08,0.4,26.1,54945,75,NULL,'B','NGC 5701',NULL,'1988NBGC.C....0000T',1988,1,4.3,NULL,'G',0.000003,NULL,'11.76',4.1,'(R)SB(rs)0/a   LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.796167,5.36347,0.089,NULL,58310000721,911093761,14235840,11.76),(122850,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122850,37.45,0.46,309,54946,70,NULL,NULL,'2MASX J14391122+5644427',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.796625,56.74536,0,NULL,57259514301,894679910,13979373,18.4),(122851,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122851,37.45,0.46,310,54947,70,NULL,NULL,'SDSS J143911.45+171717.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.7977083,17.28806,0.024,NULL,59551013145,930484580,14538821,18.1),(122852,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122852,36.26,0.46,179,54948,70,NULL,NULL,'2MASX J14391180+3347067',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000178,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,219.799,33.78531,0,NULL,60067616442,938556506,14664945,15.4),(122853,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122853,37.44,0.27,308,54949,70,NULL,NULL,'2MASX J14391186+1415215',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.799458333,14.25611,0.017,NULL,59558282582,930598165,14540596,17.2),(122854,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122854,37.96,0.46,391,54950,70,NULL,NULL,'SDSS J143912.31+164750.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,219.801333,16.79747,0,NULL,59554643413,930541303,14539707,17.2),(122855,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122855,32.21,NULL,27.7,54951,72,NULL,NULL,'SDSS J143912.44+090805.7',NULL,'2014Ap.....57..457K',2014,1,0.5,NULL,'G',0.000177,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.801833,9.13494,0.037,NULL,59364728482,927573882,14493341,16.4),(122856,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122856,37.9,0.46,380,54952,70,NULL,NULL,'2MASX J14391245+2732390',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.8019583,27.54408,0,NULL,60028521517,937945648,14655400,17.8),(122857,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122857,34.12,0.46,66.8,54953,70,NULL,NULL,'IC 4478',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'15.3',0.35,NULL,NULL,NULL,NULL,NULL,1,219.802875,15.87739,0.008,NULL,59552251062,930503922,14539123,15.3),(122858,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122858,38.01,0.46,400,54954,70,NULL,NULL,'2MASX J14391326+4246007',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.805333,42.76694,0.027,NULL,59961065470,936891647,14638931,17.8),(122859,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122859,38.72,0.46,556,54955,70,NULL,NULL,'2MASX J14391340+5458046',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.805708333,54.96803,0,NULL,57246955408,894483678,13976307,17.6),(122860,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122860,37.44,0.15,308,54956,70,NULL,NULL,'2MASX J14391394+2306040',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000194,NULL,'17.74',0.21,NULL,NULL,NULL,NULL,NULL,1,219.80825,23.10122,0.015,NULL,59508113788,929814277,14528348,17.74),(122861,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122861,38.46,0.46,491,54957,70,NULL,NULL,'SDSS J143914.46-021640.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.81025,-2.27792,0.161,NULL,43547758043,680433719,10631776,18.5),(122862,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122862,36.2,0.46,174,54958,70,NULL,NULL,'2MASX J14391521+1237035',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000163,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,219.813375,12.61772,0,NULL,59543554956,930368046,14537000,15.9),(122863,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122863,36.33,0.46,185,54959,70,NULL,NULL,'2MASX J14391540+2715230',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.46',0.18,NULL,NULL,NULL,NULL,NULL,1,219.814083333,27.25631,0.024,NULL,60028440975,937944390,14655381,17.46),(122864,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122864,35.44,0.46,122,54960,70,NULL,NULL,'CGCG 047-126',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000053,NULL,'14.5g',0.66,'E0',NULL,NULL,NULL,NULL,1,219.814666667,2.72803,0.085,NULL,58306297405,911035896,14234935,14.5),(122865,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122865,35.79,0.1,144,54961,70,NULL,NULL,'VIII Zw 443',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00006,NULL,'15.6g',0.58,'S0^-',NULL,NULL,NULL,NULL,1,219.8152917,3.6775,0.077,NULL,58311515260,911117425,14236209,15.6),(122866,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122866,38.25,0.46,447,54962,70,NULL,NULL,'SDSS J143916.00+324733.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.816667,32.79261,0,NULL,60066643449,938541303,14664707,18.3),(122867,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122867,38.12,0.46,420,54963,70,NULL,NULL,'2MASX J14391603+2057046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.13',0.16,NULL,NULL,NULL,NULL,NULL,1,219.816791667,20.95128,0.029,NULL,59503940744,929749074,14527329,18.13),(122868,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122868,35.23,0.33,111,54964,70,NULL,NULL,'NGC 5710',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000103,NULL,'14.00',1.1,'E','in a pair',NULL,NULL,NULL,1,219.817458333,20.04369,0.027,NULL,59501172924,929705826,14526653,14),(122869,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122869,35.64,0.45,134,54964,NULL,NULL,'K','NGC 5710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122870,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122870,35.69,0.4,138,54964,NULL,NULL,'mean','NGC 5710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122871,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122871,36.96,0.46,247,54965,70,NULL,NULL,'2MASX J14391710+1729505',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.8212917,17.49739,0.016,NULL,59551214234,930487722,14538870,17.2),(122872,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122872,37.99,0.27,397,54966,70,NULL,NULL,'2MASX J14391742+2712210',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.20',0.17,'BrClG',NULL,NULL,NULL,NULL,1,219.822583,27.20594,0.024,NULL,60028472877,937944888,14655388,18.2),(122873,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122873,37.81,0.46,365,54967,70,NULL,NULL,'SDSS J143917.46+495257.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.822791667,49.88264,0.037,NULL,59200201304,925003145,14453174,18.3),(122874,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122874,37.5,0.46,317,54968,70,NULL,NULL,'2MASX J14391875+4458237',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000208,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,219.828291667,44.97336,0.029,NULL,59955844044,936810063,14637657,16.4),(122875,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122875,37.46,0.46,311,54969,70,NULL,NULL,'2MASX J14391911+6012097',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,219.829917,60.20283,0,NULL,57771798591,902684352,14104443,17),(122876,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122876,38.18,0.19,432,54970,70,NULL,NULL,'2MASX J14392045+1744345',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'BrClG',NULL,NULL,NULL,NULL,1,219.835333,17.74283,0.008,NULL,59551181078,930487204,14538862,NULL),(122877,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122877,38.18,0.19,432,54971,70,NULL,NULL,'SDSS J143920.69+174347.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.83625,17.72992,0.008,NULL,59551182213,930487222,14538862,17.5),(122878,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122878,37.99,0.46,397,54972,70,NULL,NULL,'SDSS J143920.91+201252.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.837167,20.21447,0.016,NULL,59501149594,929705462,14526647,17.9),(122879,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122879,38.18,0.19,432,54973,70,NULL,NULL,'VIII Zw 445 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.838083,17.71064,0.008,NULL,59551182030,930487219,14538862,17.9),(122880,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122880,37.44,0.15,308,54974,70,NULL,NULL,'SDSS J143921.27+232146.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.838625,23.36292,0.028,NULL,59508222803,929815981,14528374,17.7),(122881,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122881,37.5,0.46,317,54975,70,NULL,NULL,'2MASX J14392168+5601528',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.840333,56.03144,0,NULL,57259117949,894673717,13979276,17.8),(122882,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122882,38.18,0.19,432,54976,70,NULL,NULL,'SDSS J143922.15+174111.0',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.842333,17.68642,0.008,NULL,59551180209,930487190,14538862,17),(122883,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122883,37.01,0.46,252,54977,70,NULL,NULL,'2MASX J14392247+5716449',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.8435,57.27936,0.021,NULL,57251137471,894549022,13977328,17.5),(122884,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122884,38.3,0.33,457,54978,70,NULL,NULL,'2MASX J14392245+2712100',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.843667,27.20286,0.024,NULL,60028472952,937944889,14655388,17.9),(122885,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122885,35.28,0.2,114,54979,74.4,NULL,NULL,'NGC 5711',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.88',0.6,'S?',NULL,NULL,NULL,NULL,1,219.844,19.99089,0.027,NULL,59501171455,929705803,14526653,14.88),(122886,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122886,35.68,0.4,137,54979,NULL,NULL,'mean','NGC 5711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122887,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122887,35.89,0.47,151,54979,NULL,NULL,'H','NGC 5711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122888,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122888,38.2,0.46,437,54980,70,NULL,NULL,'SDSS J143924.30+170347.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.85125,17.06333,0.007,NULL,59554433131,930538017,14539656,18),(122889,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122889,37.44,0.15,308,54981,70,NULL,NULL,'2MASX J14392642+2241546',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.860083,22.69839,0.008,NULL,59508395523,929818680,14528416,17),(122890,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122890,37.01,0.46,252,54982,70,NULL,NULL,'2MASX J14392879+1342055',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.90',0.21,NULL,NULL,NULL,NULL,NULL,1,219.869916667,13.70153,0.005,NULL,59557781528,930590336,14540474,16.9),(122891,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122891,37.2,0.46,275,54983,70,NULL,NULL,'2MASX J14392888+1759036',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.870333,17.98425,0.011,NULL,59479556682,929368073,14521376,17.4),(122892,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122892,37.99,0.27,397,54984,70,NULL,NULL,'2MASX J14393047+2713540',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,'PHOT','18.48',0.16,NULL,NULL,NULL,NULL,NULL,1,219.877,27.23158,0.024,NULL,60028472125,937944876,14655388,18.48),(122893,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122893,37.47,0.46,312,54985,70,NULL,NULL,'2MASX J14393063+5636139',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000195,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,219.8777083,56.60383,0,NULL,57259539830,894680309,13979379,17.2),(122894,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122894,37.83,0.33,369,54986,70,NULL,NULL,'2MASX J14393132+0657194',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.880667,6.95558,0.041,NULL,58276109245,910564206,14227565,17.4),(122895,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122895,37.99,0.27,397,54987,70,NULL,NULL,'2MASX J14393152+2714240',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,219.881375,27.24014,0.024,NULL,60028472282,937944879,14655388,17.9),(122896,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122896,35.99,0.2,158,54988,74.4,NULL,NULL,'UGC 09443',NULL,'2013AJ....146...86T',2013,1,1.14,NULL,'G',0.000033,NULL,'15.1g',0.38,'S?',NULL,NULL,NULL,NULL,1,219.8822083,9.23497,0.037,NULL,59372892071,927701438,14495334,15.1),(122897,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122897,36.45,0.33,195,54989,70,NULL,NULL,'2MASX J14393202+1220415',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.883375,12.34475,0.013,NULL,59543551502,930367992,14536999,17.4),(122898,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122898,36.61,0.46,210,54990,70,NULL,NULL,'2MASX J14393368+2942500',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000169,NULL,'16.2g',0.42,'Sa',NULL,NULL,NULL,NULL,1,219.890416667,29.71375,0,NULL,60019619332,937806552,14653227,16.2),(122899,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122899,38.09,0.33,415,54991,70,NULL,NULL,'2MASX J14393502+0642504',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,219.8957917,6.71408,0.057,NULL,58276627272,910572301,14227692,17.3),(122900,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122900,37.48,0.46,313,54992,70,NULL,NULL,'2MASX J14393502+0113499',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,219.8959583,1.23056,0.105,NULL,58259440864,910303763,14223496,17.5),(122901,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122901,32.58,0.8,32.8,54993,75,NULL,'MAT, I','NGC 5688',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.00001,NULL,'12.3b',2.5,'SAB(r)bc',NULL,NULL,NULL,NULL,1,219.8964583,-45.019,0.469,NULL,47082792301,735668629,11494822,12.3),(122902,'Tully est','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122902,32.88,0.8,37.7,54993,75,NULL,NULL,'NGC 5688',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122903,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122903,32.45,0.36,30.9,54993,NULL,NULL,NULL,'NGC 5688',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122904,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122904,32.58,0.46,32.8,54993,NULL,NULL,'J','NGC 5688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122905,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122905,32.61,0.47,33.2,54993,NULL,NULL,'H','NGC 5688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122906,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122906,32.69,0.45,34.5,54993,NULL,NULL,'K','NGC 5688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122907,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122907,32.77,0.43,35.8,54993,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5688',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122908,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122908,32.78,0.43,36,54993,75,NULL,'MAT, I, raw','NGC 5688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122909,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122909,32.81,0.4,36.5,54993,NULL,NULL,'mean','NGC 5688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122910,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122910,32.83,0.43,36.9,54993,75,NULL,'3.6 micron, color corrected','NGC 5688',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122911,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122911,32.87,0.32,37.5,54993,85,NULL,'I, raw','NGC 5688',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122912,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122912,32.94,0.32,38.8,54993,85,NULL,'I, inv','NGC 5688',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122913,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122913,32.95,0.2,38.9,54993,74.4,NULL,NULL,'NGC 5688',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122914,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122914,33.03,0.43,40.4,54993,75,NULL,'MAT, I, cor','NGC 5688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122915,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122915,33.09,0.43,41.4,54993,75,NULL,'MAT, I, inv','NGC 5688',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122916,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122916,37.75,0.46,355,54994,70,NULL,NULL,'2MASX J14393554+1523073',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,219.8982917,15.38547,0,NULL,59556731528,930573930,14540217,17.4),(122917,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122917,33.91,0.8,60.7,54995,75,NULL,'HMCL, I','UGC 09449',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000027,NULL,'15.4g',0.26,'Sbc',NULL,NULL,NULL,NULL,1,219.905291667,24.5385,0.089,NULL,59498435526,929663055,14525985,15.4),(122918,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122918,33.82,0.4,57.9,54995,75,NULL,'HMCL, I, raw','UGC 09449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122919,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122919,33.87,0.4,59.3,54995,75,NULL,'HMCL, I, inv','UGC 09449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122920,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122920,34.02,0.2,63.7,54995,74.4,NULL,NULL,'UGC 09449',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122921,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122921,34.02,0.49,63.7,54995,75,NULL,'IR','UGC 09449',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122922,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122922,34.09,0.4,65.7,54995,75,NULL,'HMCL, I, cor','UGC 09449',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122923,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122923,37.44,0.15,308,54996,70,NULL,NULL,'SDSS J143937.60+231125.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.9067083,23.19036,0.015,NULL,59508206812,929815731,14528370,18),(122924,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122924,37.9,0.46,380,54997,70,NULL,NULL,'2MASX J14393851+1426444',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.9105417,14.44578,0.005,NULL,59558258501,930597789,14540590,17.6),(122925,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122925,37.87,0.46,375,54998,70,NULL,NULL,'2MASX J14393992+1514044',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,219.916333333,15.2345,0,NULL,59556753644,930574275,14540223,17.2),(122926,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122926,36.45,0.33,195,54999,70,NULL,NULL,'2MASX J14394015+1217104',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0001,NULL,'16.83',0.3,'BrClG',NULL,NULL,NULL,NULL,1,219.917167,12.28633,0.013,NULL,59360000055,927500000,14492187,16.83),(122927,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122927,38.09,0.33,415,55000,70,NULL,NULL,'2MASX J14394046+0639344',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.9185417,6.65969,0.057,NULL,58276618740,910572167,14227690,18.1),(122928,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122928,38.14,0.46,424,55001,70,NULL,NULL,'2MASX J14394126+1857095',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.922083,18.95286,0.029,NULL,59509033375,929828646,14528572,17.9),(122929,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122929,37.3,0.46,289,55002,70,NULL,NULL,'2MASX J14394160+0219183',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000074,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,219.9234583,2.32183,0.081,NULL,58261060174,910329065,14223891,17.1),(122930,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122930,37.52,0.46,319,55003,70,NULL,NULL,'2MASX J14394479+2208404',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,219.9365,22.14442,0,NULL,59505070988,929766734,14527605,17.7),(122931,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122931,38.04,0.46,405,55004,70,NULL,NULL,'SDSS J143944.91+555321.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.937166667,55.88942,0,NULL,57259072242,894673003,13979265,18),(122932,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122932,37.44,0.15,308,55005,70,NULL,NULL,'2MASX J14394527+2255039',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.62',0.23,NULL,NULL,NULL,NULL,NULL,1,219.9385417,22.91778,0.018,NULL,59508531611,929820806,14528450,17.62),(122933,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122933,33.9,0.8,60.4,55006,75,NULL,'HMCL, I','UGC 09450',NULL,'1997ApJS..109..333W',1997,1,0.66,NULL,'G',0.000013,NULL,'16.6g',0.16,'Sdm:',NULL,NULL,NULL,NULL,1,219.93875,23.39658,0.028,NULL,59508151003,929814859,14528357,16.6),(122934,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122934,34.14,0.2,67.3,55006,74.4,NULL,NULL,'UGC 09450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122935,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122935,34.59,0.4,82.9,55006,75,NULL,'HMCL, I, raw','UGC 09450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122936,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122936,34.61,0.4,83.6,55006,75,NULL,'HMCL, I, inv','UGC 09450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122937,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122937,34.88,0.4,94.6,55006,75,NULL,'HMCL, I, cor','UGC 09450',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122938,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122938,37.46,0.46,311,55007,70,NULL,NULL,'2MASX J14394549+2252449',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,219.939583,22.87911,0.018,NULL,59508532869,929820826,14528450,17.8),(122939,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122939,37.17,0.46,272,55008,70,NULL,NULL,'2MASX J14394573+3226125',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.9405,32.43678,0,NULL,60016304633,937754759,14652418,17),(122940,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122940,37.03,0.46,255,55009,70,NULL,NULL,'2MASX J14394691+4616284',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,219.945417,46.27464,0.009,NULL,59987353505,937302398,14645349,18),(122941,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122941,37.27,0.46,285,55010,70,NULL,NULL,'2MASX J14394760+0544283',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.9482083,5.74131,0.077,NULL,58310162443,911096288,14235879,17),(122942,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122942,36.8,0.46,230,55011,70,NULL,NULL,'VIII Zw 446 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.8g',0.25,'AGN',NULL,NULL,NULL,NULL,1,219.950708333,14.73875,0.009,NULL,59556758476,930574351,14540224,16.8),(122943,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122943,37.94,0.27,387,55012,70,NULL,NULL,'2MASX J14394823+2119569',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.61',0.21,NULL,NULL,NULL,NULL,NULL,1,219.950917,21.33253,0.02,NULL,59503154164,929736783,14527137,17.61),(122944,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122944,36.85,0.46,235,55013,70,NULL,NULL,'2MASX J14394845+3048165',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00013,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,219.952,30.80444,0,NULL,60017083385,937766927,14652608,18.1),(122945,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122945,32.17,0.8,27.1,55014,75,NULL,'MAT, I','NGC 5705',NULL,'1997ApJS..109..333W',1997,1,2.9,'Confused HIPASS source','G',0.000013,NULL,'13.3',1.7,'SB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,219.957041667,-0.71847,0.109,NULL,43491560475,679555632,10618056,13.3),(122946,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122946,32.18,0.8,27.3,55014,75,NULL,'A82, H','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122947,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122947,31.46,0.2,19.6,55014,74.4,NULL,NULL,'NGC 5705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122948,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122948,31.55,0.32,20.4,55014,85,NULL,'I, inv','NGC 5705',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122949,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122949,31.56,0.32,20.5,55014,85,NULL,'I, raw','NGC 5705',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122950,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122950,31.6,0.38,20.9,55014,NULL,NULL,NULL,'NGC 5705',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122951,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122951,31.95,0.43,24.6,55014,75,NULL,'MAT, I, raw','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122952,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122952,31.98,0.43,24.9,55014,75,NULL,'MAT, I, inv','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122953,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122953,32.07,0.4,26,55014,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5705',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122954,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122954,32.16,0.43,27,55014,75,NULL,'MAT, I, cor','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122955,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122955,32.21,NULL,27.7,55014,72,NULL,NULL,'NGC 5705',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122956,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122956,32.29,0.4,28.8,55014,75,NULL,'B','NGC 5705',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122957,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122957,32.55,0.47,32.3,55014,75,NULL,'A82, H, inv','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122958,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122958,32.55,0.47,32.4,55014,75,NULL,'A82, H, raw','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122959,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122959,32.62,0.47,33.4,55014,75,NULL,'A82, H, cor','NGC 5705',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122960,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122960,37.63,0.46,336,55015,70,NULL,NULL,'2MASX J14395125+3447075',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'16.2g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,219.9635,34.78528,0,NULL,60070467542,938601055,14665641,16.2),(122961,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122961,37.77,0.46,358,55016,70,NULL,NULL,'SDSS J143951.42+535432.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.96425,53.90906,0,NULL,59192074501,924876164,14451190,18.2),(122962,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,NULL,122962,33.35,0.48,46.8,55017,70,NULL,NULL,'IC 4476',NULL,'2014MNRAS.445.2677S',2014,1,1,'6dF DR2 has z = 0.013824.','G',0.000143,NULL,'15.43',0.8,NULL,NULL,NULL,NULL,NULL,1,219.9660417,-16.24475,0.373,NULL,46681163198,729393174,11396768,15.43),(122963,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122963,32.21,0.4,27.6,55018,75,NULL,NULL,'NGC 5730',NULL,'2008Ap.....51..336K',2008,1,1.42,NULL,'G',0.000017,NULL,'14.2g',0.44,'Im:            Sbrst','Pair member (points to parent)',NULL,NULL,NULL,1,219.967333,42.74236,0.014,NULL,59958235876,936847435,14638241,14.2),(122964,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122964,33.06,0.49,41,55018,75,NULL,'IR','NGC 5730',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122965,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122965,37.05,0.46,257,55019,70,NULL,NULL,'2MASX J14395246+0931401',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000174,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,219.9685,9.52783,0.009,NULL,59372944940,927702264,14495347,16.5),(122966,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122966,37.1,0.46,263,55020,70,NULL,NULL,'2MASX J14395384+1007551',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,219.9745417,10.13186,0.013,NULL,59373593061,927712391,14495506,16.1),(122967,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122967,38.44,0.46,487,55021,70,NULL,NULL,'2MASX J14395474+2859314',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,219.9782917,28.99214,0,NULL,60017621991,937775343,14652739,18.2),(122968,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122968,36.43,0.46,193,55022,70,NULL,NULL,'2MASX J14395484+6138046',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,219.978458333,61.63461,0.017,NULL,57759808158,902497002,14101515,16.6),(122969,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122969,37.48,0.46,313,55023,70,NULL,NULL,'2MASX J14395508+4220074',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,219.979375,42.33533,0.034,NULL,59961224157,936894127,14638970,16.6),(122970,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122970,35.79,0.1,144,55024,70,NULL,NULL,'2MASX J14395699+0349323',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00007,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,219.987416667,3.82561,0.069,NULL,58312265765,911129152,14236393,16.5),(122971,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122971,36.26,0.33,179,55025,70,NULL,NULL,'2MASX J14395703+2133420',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,219.987667,21.56158,0.02,NULL,59503233057,929738016,14527156,16.1),(122972,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122972,37.94,0.27,387,55026,70,NULL,NULL,'2MASX J14395803+2119260',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.62',0.14,NULL,NULL,NULL,NULL,NULL,1,219.991916667,21.32397,0.02,NULL,59503616893,929744013,14527250,18.62),(122973,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122973,38.03,0.46,403,55027,70,NULL,NULL,'2MASXi J1439587+140926',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.994541667,14.15733,0.017,NULL,59558329117,930598892,14540607,17.9),(122974,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122974,36.33,0.46,185,55028,70,NULL,NULL,'SDSS J143958.78+130127.0',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,219.994917,13.02419,0,NULL,59543455718,930366495,14536976,16.3),(122975,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122975,37.91,0.33,383,55029,70,NULL,NULL,'2MASX J14395900+1806430',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.41',0.16,'BrClG',NULL,NULL,NULL,NULL,1,219.995833,18.11186,0,NULL,59550802186,930481284,14538770,18.41),(122976,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122976,37.28,0.46,285,55030,70,NULL,NULL,'2MASX J14395920+3744525',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,219.996625,37.74808,0,NULL,60078865831,938732278,14667691,16.7),(122977,'FP','2016-12-15 15:15:27','2016-12-16 11:20:40','1',NULL,'R',122977,38.13,0.16,422,55031,70,NULL,NULL,'2MASX J14395939+3703534',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,219.997666667,37.06494,0,NULL,60078528781,938727012,14667609,18.5),(122978,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122978,38.13,0.16,422,55032,70,NULL,NULL,'SDSS J144000.64+370547.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.0027083,37.09661,0,NULL,60078527059,938726985,14667609,18.5),(122979,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122979,37.79,0.46,361,55033,70,NULL,NULL,'2MASX J14400147+5034064',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.006083,50.56853,0.025,NULL,59200496579,925007759,14453246,17.8),(122980,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122980,38.34,0.46,466,55034,70,NULL,NULL,'SDSS J144001.60+525530.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.006708333,52.92508,0,NULL,59191330880,924864545,14451008,18.6),(122981,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122981,36.81,0.46,230,55035,70,NULL,NULL,'2MASX J14400208+1101081',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000179,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,220.008708333,11.01897,0.013,NULL,59371931800,927686434,14495100,16),(122982,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122982,37.83,0.33,369,55036,70,NULL,NULL,'2MASX J14400267+0700231',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.011083333,7.00644,0.041,NULL,58276059541,910563430,14227553,17.3),(122983,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122983,38.13,0.16,422,55037,70,NULL,NULL,'2MASX J14400273+3711035',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.011417,37.1845,0,NULL,60078498349,938726536,14667602,17.3),(122984,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122984,38.13,0.16,422,55038,70,NULL,NULL,'LCSB S2067P',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.6g',0.38,'BrClG',NULL,NULL,NULL,'USS',1,220.014375,37.12428,0,NULL,60078526571,938726977,14667609,16.6),(122985,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,122985,34.8,0.46,91,55039,70,NULL,NULL,'ESO 386- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15',1.3,'S0',NULL,NULL,NULL,NULL,1,220.016166667,-36.62742,0.249,NULL,47223980855,737874700,11529292,15),(122986,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122986,38.13,0.16,422,55040,70,NULL,NULL,'2MASX J14400390+3706555',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.95',0.19,NULL,NULL,NULL,NULL,NULL,1,220.0162083,37.11547,0,NULL,60078526663,938726979,14667609,17.95),(122987,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122987,37.91,0.33,383,55041,70,NULL,NULL,'SDSS J144005.13+181509.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.021417,18.25258,0,NULL,59479583749,929368496,14521382,17.9),(122988,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122988,37.94,0.27,387,55042,70,NULL,NULL,'2MASX J14400555+2127240',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.43',0.14,NULL,NULL,NULL,NULL,NULL,1,220.023208333,21.45658,0.02,NULL,59503178933,929737170,14527143,18.43),(122989,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122989,37.29,0.46,287,55043,70,NULL,NULL,'2MASX J14400569+5003023',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.023583,50.05056,0.037,NULL,59200178782,925002793,14453168,17.3),(122990,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122990,38.26,0.46,450,55044,70,NULL,NULL,'2MASX J14400687+2021290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.32',0.16,NULL,NULL,NULL,NULL,NULL,1,220.028583,20.35806,0.012,NULL,59503909769,929748590,14527321,18.32),(122991,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122991,37.04,0.46,256,55045,70,NULL,NULL,'2MASX J14400697+3109476',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.029167,31.16308,0,NULL,60017111571,937767368,14652615,16.3),(122992,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122992,36.91,0.46,241,55046,70,NULL,NULL,'SDSS J144007.11+522401.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.029667,52.40047,0,NULL,59203932331,925061442,14454085,17.8),(122993,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122993,38.19,0.46,434,55047,70,NULL,NULL,'2MASXi J1440079+123918',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.032917,12.65486,0,NULL,59543638397,930369349,14537021,17.6),(122994,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122994,38.02,0.46,402,55048,70,NULL,NULL,'2MASX J14400922+1630578',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.45',0.16,NULL,NULL,NULL,NULL,NULL,1,220.0385,16.51614,0.008,NULL,59554468433,930538569,14539665,18.45),(122995,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122995,38.09,0.27,415,55049,70,NULL,NULL,'2MASX J14400936+3633425',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.039,36.56164,0,NULL,60075562802,938680668,14666885,17.9),(122996,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122996,38.71,0.46,551,55050,70,NULL,NULL,'2MASX J14401066+2244149',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000177,NULL,'17.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.0445417,22.73753,0.008,NULL,59508403871,929818810,14528418,17.4),(122997,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,122997,32.66,0.8,34,55051,75,NULL,'MAT, I','IC 4472',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000024,NULL,'13.92',0.5,'Sc? sp',NULL,NULL,NULL,NULL,1,220.045167,-44.31458,0.501,NULL,47082930342,735670786,11494856,13.92),(122998,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',122998,32.15,0.4,26.9,55051,75,NULL,NULL,'IC 4472',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(122999,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,122999,32.25,0.43,28.2,55051,75,NULL,'MAT, I, raw','IC 4472',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123000,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123000,32.3,0.32,28.8,55051,85,NULL,'I, raw','IC 4472',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123001,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123001,32.33,0.4,29.2,55051,NULL,NULL,NULL,'IC 4472',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123002,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123002,32.33,0.32,29.3,55051,85,NULL,'I, inv','IC 4472',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123003,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123003,32.44,0.43,30.8,55051,75,NULL,'MAT, I, inv','IC 4472',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123004,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123004,32.53,0.43,32.1,55051,75,NULL,'MAT, I, cor','IC 4472',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123005,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123005,32.69,0.49,34.6,55051,75,NULL,'IR','IC 4472',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123006,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123006,33.31,0.8,45.9,55052,75,NULL,'MAT, I','ESO 512- G 012',NULL,'1997ApJS..109..333W',1997,1,3.02,'ESO-LV has V = 1839 +- 10 km/sec.','G',0.000033,NULL,'14.32',0.34,'Sbc            HII',NULL,NULL,NULL,NULL,1,220.0475417,-25.77661,0.461,NULL,47024553548,734758649,11480603,14.32),(123007,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123007,32.44,NULL,30.8,55052,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 512- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123008,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123008,32.45,NULL,30.8,55052,NULL,NULL,'Dipole + Quadrupole','ESO 512- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123009,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123009,32.46,NULL,31,55052,NULL,NULL,'Dipole','ESO 512- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123010,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123010,32.48,NULL,31.4,55052,NULL,NULL,NULL,'ESO 512- G 012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123011,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123011,33.56,0.43,51.5,55052,75,NULL,'MAT, I, raw','ESO 512- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123012,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123012,33.65,0.32,53.7,55052,85,NULL,'I, raw','ESO 512- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123013,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123013,33.72,0.32,55.5,55052,85,NULL,'I, inv','ESO 512- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123014,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123014,33.73,0.42,55.7,55052,NULL,NULL,'Malmquist cor.','ESO 512- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123015,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123015,33.74,0.2,56,55052,74.4,NULL,NULL,'ESO 512- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123016,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123016,33.78,0.43,57,55052,75,NULL,'MAT, I, cor','ESO 512- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123017,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123017,33.86,0.43,59.1,55052,75,NULL,'MAT, I, inv','ESO 512- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123018,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123018,33.92,0.38,60.7,55052,NULL,NULL,NULL,'ESO 512- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123019,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123019,32.33,0.8,29.3,55053,75,NULL,'MAT, I','NGC 5713',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000023,NULL,'12.18',2.5,'SAB(rs)bc pec  HII','in a pair',NULL,NULL,NULL,1,220.0479583,-0.28897,0.105,NULL,43491640322,679556880,10618076,12.18),(123020,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123020,30.67,NULL,13.6,55053,65.2,NULL,'CO','NGC 5713',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123021,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123021,31.31,0.43,18.3,55053,75,NULL,'MAT, I, raw','NGC 5713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123022,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123022,31.42,0.32,19.2,55053,85,NULL,'I, raw','NGC 5713',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123023,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123023,31.45,0.32,19.5,55053,85,NULL,'I, inv','NGC 5713',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (123024,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123024,31.46,0.43,19.6,55053,75,NULL,'MAT, I, inv','NGC 5713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123025,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123025,31.65,0.43,21.4,55053,75,NULL,'MAT, I, cor','NGC 5713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123026,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123026,31.65,NULL,21.4,55053,54,NULL,'HI','NGC 5713',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123027,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123027,32.42,0.4,30.4,55053,75,NULL,'B','NGC 5713',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123028,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123028,35.41,0.62,121,55054,70,NULL,NULL,'2MASX J14401261-4220215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,220.052625,-42.33931,0.357,NULL,47093340809,735833450,11497397,14.4),(123029,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123029,36.27,0.46,180,55055,70,NULL,NULL,'2MASX J14401291+2657362',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.96',0.24,NULL,NULL,NULL,NULL,NULL,1,220.053917,26.96014,0.031,NULL,60026401342,937912520,14654883,16.96),(123030,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123030,36.9,0.46,240,55056,70,NULL,NULL,'2MASX J14401299+3409566',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000209,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,220.054083333,34.16578,0,NULL,60066972949,938546452,14664788,15.8),(123031,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123031,36.28,0.46,180,55057,70,NULL,NULL,'2MASX J14401309+1953309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.71',0.22,NULL,NULL,NULL,NULL,NULL,1,220.054708333,19.89183,0.015,NULL,59501005427,929703209,14526612,16.71),(123032,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123032,38.13,0.16,422,55058,70,NULL,NULL,'2MASX J14401410+3701385',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.05875,37.02742,0,NULL,60075698832,938682794,14666918,16.8),(123033,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123033,38.7,0.46,550,55059,70,NULL,NULL,'2MASX J14401450+0315491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000091,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,220.060583,3.26367,0.077,NULL,58255773864,910246466,14222601,17.4),(123034,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123034,37.52,0.46,319,55060,70,NULL,NULL,'2MASX J14401550+0504101',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000084,NULL,'17.0g',0.25,'NLAGN',NULL,NULL,NULL,'Sy 2',1,220.064666667,5.06964,0.089,NULL,58309900498,911092195,14235815,17),(123035,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123035,35.79,0.1,144,55061,70,NULL,NULL,'2MASX J14401636+0331121',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00006,NULL,'16.2g',0.32,'S0',NULL,NULL,NULL,NULL,1,220.068333333,3.52014,0.077,NULL,58311412843,911115825,14236184,16.2),(123036,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123036,37.44,0.15,308,55062,70,NULL,NULL,'2MASX J14401781+2252273',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.0742917,22.87444,0,NULL,59508585264,929821644,14528463,16.9),(123037,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123037,36.66,0.33,215,55063,70,NULL,NULL,'2MASX J14401795+0556341',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000205,NULL,'15.5g',0.51,'BrClG;Cand.grav.lens',NULL,NULL,NULL,NULL,1,220.074917,5.94281,0.069,NULL,58309284093,911082563,14235665,15.5),(123038,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123038,38.24,0.46,445,55064,70,NULL,NULL,'SDSS J144018.08-022633.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.075375,-2.44269,0.189,NULL,43491959479,679561866,10618154,18.4),(123039,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123039,35.3,0.38,115,55065,NULL,NULL,'Malmquist cor.','IC 4483',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00003,NULL,'14.71',0.5,'Sb',NULL,NULL,NULL,NULL,1,220.081291667,16.68522,0,NULL,59554495687,930538995,14539671,14.71),(123040,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123040,35.37,0.37,118,55065,NULL,NULL,NULL,'IC 4483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123041,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123041,35.53,0.2,128,55065,74.4,NULL,NULL,'IC 4483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123042,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123042,37.9,0.46,381,55066,70,NULL,NULL,'2MASX J14402062+3826595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.085917,38.44981,0,NULL,60076816290,938700254,14667191,17.3),(123043,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123043,38.12,0.46,421,55067,70,NULL,NULL,'SDSS J144024.32+131851.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.101375,13.31433,0.005,NULL,59557667377,930588552,14540446,17.8),(123044,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123044,37.44,0.15,308,55068,70,NULL,NULL,'SDSS J144024.92+231605.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.103875,23.26833,0,NULL,59508177950,929815280,14528363,18.3),(123045,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123045,38.2,0.46,436,55069,70,NULL,NULL,'2MASX J14402525+5524390',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.105417,55.41075,0.005,NULL,57246706053,894479782,13976246,18.3),(123046,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123046,32.15,0.4,26.9,55070,75,NULL,'B','NGC 5727',NULL,'1988NBGC.C....0000T',1988,1,1.91,NULL,'G',0.000006,NULL,'14.1g',0.81,'SABdm','Isolated galaxy',NULL,NULL,NULL,1,220.108833,33.98911,0,NULL,60067055337,938547739,14664808,14.1),(123047,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123047,33.17,0.4,43.1,55070,NULL,NULL,NULL,'NGC 5727',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123048,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123048,38.11,0.33,419,55071,70,NULL,NULL,'2MASX J14402663+2337293',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.1110417,23.62478,0.034,NULL,59507072633,929798009,14528093,17.8),(123049,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123049,35.86,0.33,148,55072,70,NULL,NULL,'CGCG 104-065',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'16.70',0.34,NULL,NULL,NULL,NULL,NULL,1,220.1169583,14.82725,0.013,NULL,59558671873,930604248,14540691,16.7),(123050,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123050,38.13,0.16,422,55073,70,NULL,NULL,'2MASX J14402823+3713416',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.117625,37.22817,0,NULL,60075677899,938682467,14666913,17.6),(123051,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123051,36.95,0.46,245,55074,70,NULL,NULL,'2MASX J14402823+2624302',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,220.117666667,26.40836,0.039,NULL,60026757016,937918078,14654969,18.27),(123052,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123052,36.66,0.33,215,55075,70,NULL,NULL,'2MASX J14402854+0558131',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.118875,5.97025,0.069,NULL,58309340285,911083441,14235678,16.6),(123053,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123053,36.75,0.67,223,55076,70,NULL,NULL,'2MASX J14402883-2926485',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.3b',0.4,'E',NULL,NULL,NULL,NULL,1,220.120167,-29.44678,0.497,NULL,47021512559,734711133,11479861,15.3),(123054,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123054,35.69,0.46,138,55077,70,NULL,NULL,'2MASX J14402974+0230101',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000066,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.123875,2.50286,0.085,NULL,58261231386,910331740,14223933,16.3),(123055,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123055,37.52,0.46,319,55078,70,NULL,NULL,'2MASX J14403083+0645539',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.128375,6.76483,0.065,NULL,58275740796,910558449,14227475,17.4),(123056,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123056,36.6,0.46,209,55079,70,NULL,NULL,'2MASX J14403092+1123259',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.73',0.22,NULL,NULL,NULL,NULL,NULL,1,220.128833,11.39056,0.009,NULL,59371825108,927684767,14495074,17.73),(123057,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123057,38.11,0.33,419,55080,70,NULL,NULL,'SDSS J144030.94+233340.3',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'16.3g',0.35,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.1289583,23.56122,0.028,NULL,59507023950,929797249,14528082,16.3),(123058,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123058,38.09,0.27,415,55081,70,NULL,NULL,'2MASX J14403114+3637516',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.129625,36.63094,0,NULL,60075778819,938684044,14666938,17.6),(123059,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123059,36.8,0.2,229,55082,74.4,NULL,NULL,'IC 4485',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00014,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,220.131083333,28.66886,0,NULL,60028146896,937939795,14655309,15.7),(123060,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123060,37.44,0.15,308,55083,70,NULL,NULL,'SDSS J144031.68+231629.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.1320417,23.27497,0,NULL,59508177905,929815279,14528363,18.4),(123061,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123061,35.79,0.1,144,55084,70,NULL,NULL,'SDSS J144032.44+033334.3',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00005,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.135166667,3.55953,0.069,NULL,58255894279,910248348,14222630,16.8),(123062,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123062,37.68,0.46,344,55085,70,NULL,NULL,'SDSS J144032.53+530301.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000124,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.135541667,53.05033,0,NULL,59191334897,924864607,14451009,18.7),(123063,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123063,37.32,0.46,291,55086,70,NULL,NULL,'2MASX J14403342+5508190',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.139125,55.13867,0,NULL,57246767128,894480736,13976261,17.3),(123064,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123064,37.03,0.46,255,55087,70,NULL,NULL,'2MASX J14403552+2644011',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.47',0.21,NULL,NULL,NULL,NULL,NULL,1,220.1479583,26.73353,0.036,NULL,60026578439,937915288,14654926,17.47),(123065,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123065,35.79,0.1,144,55088,70,NULL,NULL,'2MASX J14403693+0327531',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00005,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.1540417,3.46469,0.077,NULL,58255886227,910248222,14222628,16.8),(123066,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123066,38.3,0.46,458,55089,70,NULL,NULL,'2MASX J14403758+2932051',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'19.04',0.12,NULL,NULL,NULL,NULL,NULL,1,220.1565,29.53475,0,NULL,60019676700,937807448,14653241,19.04),(123067,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123067,36.97,0.46,248,55090,70,NULL,NULL,'SDSS J144038.57+124336.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.16075,12.72683,0.005,NULL,59543495744,930367121,14536986,17.8),(123068,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123068,37.8,0.46,363,55091,70,NULL,NULL,'SDSS J144038.75+032356.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.1615,3.39908,0.077,NULL,58255952944,910249264,14222644,18),(123069,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123069,33.65,0.8,53.7,55092,75,NULL,'CF, r','NGC 5732',NULL,'1997ApJS..109..333W',1997,1,1.45,NULL,'G',0.000053,NULL,'14.1g',0.71,'Sbc','in a pair',NULL,NULL,NULL,1,220.1622917,38.63781,0,NULL,60076849812,938700778,14667199,14.1),(123070,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123070,33.85,0.38,58.8,55092,75,NULL,'CF, r, raw','NGC 5732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123071,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123071,33.92,0.38,60.9,55092,75,NULL,'CF, r, inv','NGC 5732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123072,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123072,34.04,0.38,64.4,55092,75,NULL,'CF, r, cor','NGC 5732',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123073,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123073,34.08,0.45,65.6,55093,NULL,NULL,'K','IC 1042',NULL,'2007A&A...465...71T',2007,1,0.98,NULL,'G',0.000043,NULL,'14.5g',0.87,'S0?','Pair member (points to parent)',NULL,NULL,NULL,1,220.162583333,3.46972,0.077,NULL,58255899215,910248425,14222631,14.5),(123074,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123074,35.22,0.4,111,55093,NULL,NULL,'mean','IC 1042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123075,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123075,38.04,0.46,405,55094,70,NULL,NULL,'2MASX J14403998+0137415',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.1667083,1.62803,0.105,NULL,58261370988,910333921,14223967,17.8),(123076,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123076,38.81,0.46,578,55095,70,NULL,NULL,'SDSS J144040.04+202609.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.166875,20.43597,0.015,NULL,59503925022,929748828,14527325,18.2),(123077,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123077,35.85,0.46,148,55096,70,NULL,NULL,'MRK 0821',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',NULL,NULL,'16.0',0.5,'Compact',NULL,NULL,NULL,NULL,1,220.167791667,16.66308,0.008,NULL,59554760653,930543135,14539736,16),(123078,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123078,37.44,0.15,308,55097,70,NULL,NULL,'2MASX J14404114+2310503',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.58',0.14,NULL,NULL,NULL,NULL,NULL,1,220.171541667,23.18069,0,NULL,59508674254,929823035,14528484,18.58),(123079,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123079,36.14,0.46,169,55098,70,NULL,NULL,'2MASX J14404122+6019379',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000074,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.171791667,60.32722,0,NULL,57771709137,902682955,14104421,17),(123080,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123080,37.04,0.33,256,55099,70,NULL,NULL,'2MASX J14404276+3311259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.1782917,33.19061,0,NULL,60121304020,939395375,14678052,17.2),(123081,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123081,34.5,0.45,79.3,55100,NULL,NULL,'K','NGC 5718',NULL,'2007A&A...465...71T',2007,1,1.43,NULL,'G',0.00004,NULL,'13.8g',0.98,'S0-:;BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,220.1785,3.46542,0.069,NULL,58255898715,910248417,14222631,13.8),(123082,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123082,35.3,0.4,115,55100,NULL,NULL,'mean','NGC 5718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123083,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123083,35.79,0.1,144,55101,70,NULL,NULL,'IC 1043',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000073,NULL,'15.5g',0.3,'Sa',NULL,NULL,NULL,NULL,1,220.180625,3.37403,0.077,NULL,58255964863,910249450,14222647,15.5),(123084,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123084,38.13,0.16,422,55102,70,NULL,NULL,'2MASX J14404332+3700537',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.1807083,37.015,0,NULL,60075723343,938683177,14666924,17),(123085,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123085,35.79,0.1,144,55103,70,NULL,NULL,'CGCG 047-136',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000057,NULL,'15.3g',0.51,'Sa','Group member',NULL,NULL,NULL,1,220.1812917,3.25406,0.113,NULL,58255780102,910246564,14222602,15.3),(123086,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123086,35.43,0.49,122,55104,75,NULL,'IR','FGC 1792',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000008,NULL,'16.5',0.1,'Sbc',NULL,NULL,NULL,NULL,1,220.1852917,14.36342,0.017,NULL,59558235388,930597427,14540584,16.5),(123087,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123087,35.89,NULL,151,55104,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123088,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123088,35.9,NULL,152,55104,NULL,NULL,'Dipole + Quadrupole','FGC 1792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123089,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123089,35.92,NULL,152,55104,NULL,NULL,NULL,'FGC 1792',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123090,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123090,35.93,NULL,154,55104,NULL,NULL,'Dipole','FGC 1792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123091,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123091,36.29,0.2,181,55104,74.4,NULL,NULL,'FGC 1792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123092,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123092,37.04,0.46,256,55105,70,NULL,NULL,'2MASX J14404549+0522495',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,220.1895,5.38042,0.097,NULL,58310100300,911095317,14235864,16.2),(123093,'IRAS','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123093,33.93,0.8,61.2,55106,75,NULL,'MAT, I','ESO 386- G 006',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.86',0.3,'SAab pec:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,220.189666667,-35.14806,0.237,NULL,47223052052,737860188,11529065,14.86),(123094,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123094,33.32,0.32,46.2,55106,85,NULL,'I, raw','ESO 386- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123095,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123095,33.35,0.32,46.8,55106,85,NULL,'I, inv','ESO 386- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123096,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123096,33.46,0.2,49.2,55106,74.4,NULL,NULL,'ESO 386- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123097,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123097,33.54,0.43,51,55106,75,NULL,'MAT, I, raw','ESO 386- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123098,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123098,33.64,0.39,53.5,55106,NULL,NULL,NULL,'ESO 386- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123099,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123099,33.68,0.43,54.5,55106,75,NULL,'MAT, I, inv','ESO 386- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123100,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123100,33.79,0.37,57.3,55106,NULL,NULL,'Malmquist cor.','ESO 386- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123101,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123101,33.82,0.43,58,55106,75,NULL,'MAT, I, cor','ESO 386- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123102,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123102,33.97,0.4,62.4,55106,NULL,NULL,'mean','ESO 386- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123103,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123103,34.24,0.47,70.6,55106,NULL,NULL,'H','ESO 386- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123104,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123104,35.79,0.1,144,55107,70,NULL,NULL,'CGCG 047-138',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000083,NULL,'15.5g',0.38,'S0/a','Group member',NULL,NULL,NULL,1,220.192125,3.09883,0.137,NULL,58255794645,910246791,14222606,15.5),(123105,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123105,37.79,0.33,361,55108,70,NULL,NULL,'2MASX J14404653+1822341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.1939583,18.37631,0.053,NULL,59550745540,930480399,14538756,17.3),(123106,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123106,37.58,0.46,329,55109,70,NULL,NULL,'LCRS B143811.4-022307',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000147,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.1957083,-2.59886,0.189,NULL,43492029427,679562959,10618171,17.1),(123107,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123107,36.93,0.46,243,55110,70,NULL,NULL,'2MASX J14404847+1840441',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.201875,18.67889,0.035,NULL,59479484505,929366945,14521358,17.6),(123108,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123108,37.75,0.46,355,55111,70,NULL,NULL,'2MASX J14404870+5455229',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.202917,54.92319,0,NULL,57246898686,894482791,13976293,16.6),(123109,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123109,38.13,0.46,422,55112,70,NULL,NULL,'2MASX J14404965+2225441',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.206917,22.42903,0.03,NULL,59508487609,929820118,14528439,18.3),(123110,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123110,37.79,0.33,361,55113,70,NULL,NULL,'2MASX J14404983+1823101',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.2077083,18.38608,0.053,NULL,59550745359,930480396,14538756,18.2),(123111,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123111,37.9,0.46,380,55114,70,NULL,NULL,'2MASX J14405053+5539239',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.2102083,55.65658,0,NULL,57247064371,894485380,13976334,17.5),(123112,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123112,37.44,0.15,308,55115,70,NULL,NULL,'2MASX J14405062+2325501',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'18.19',0.15,NULL,NULL,NULL,NULL,NULL,1,220.211,23.43058,0,NULL,59508140403,929814693,14528354,18.19),(123113,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123113,36.57,0.33,206,55116,70,NULL,NULL,'2MASX J14405080+1033032',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,220.211833,10.55078,0,NULL,59373690936,927713920,14495530,16.2),(123114,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123114,35.79,0.1,144,55117,70,NULL,NULL,'CGCG 047-140',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00006,NULL,'15.3g',0.38,'S0^-','Group member',NULL,NULL,NULL,1,220.219541667,3.41831,0.069,NULL,58255959680,910249370,14222646,15.3),(123115,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123115,37.95,0.46,389,55118,70,NULL,NULL,'SDSS J144054.29+340841.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.2262083,34.14481,0,NULL,60067102072,938548469,14664819,18.2),(123116,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123116,37.94,0.33,387,55119,70,NULL,NULL,'2MASX J14405444+1850562',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.227,18.84889,0.04,NULL,59508795615,929824931,14528514,18),(123117,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123117,37.94,0.46,387,55120,70,NULL,NULL,'2MASX J14405490+2813350',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.228916667,28.22636,0.017,NULL,60028349809,937942965,14655358,17.7),(123118,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123118,37.13,0.46,267,55121,70,NULL,NULL,'2MASX J14405496+0935322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.229125,9.59225,0.037,NULL,59372832790,927700512,14495320,17),(123119,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123119,37.92,0.46,384,55122,70,NULL,NULL,'2MASX J14405530-0124364',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.230417,-1.41008,0.101,NULL,43494537888,679602154,10618783,17),(123120,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123120,38.09,0.27,415,55123,70,NULL,NULL,'2MASX J14405540+3637587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.23075,36.63303,0,NULL,60075783079,938684110,14666939,17.8),(123121,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123121,38.35,0.33,468,55124,70,NULL,NULL,'2MASX J14405633+2543550',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.234833,25.732,0.053,NULL,60025958548,937905602,14654775,18.1),(123122,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123122,31.92,0.45,24.2,55125,NULL,NULL,'K','NGC 5719',NULL,'2007A&A...465...71T',2007,1,3.01,'One APM position is on the eastern end of the bulge.','G',0.00001,NULL,'12.8g',1,'SAB(s)ab pec   NLAGN','in a pair',NULL,NULL,NULL,1,220.234833,-0.31822,0.105,NULL,43491472799,679554262,10618035,12.8),(123123,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123123,31.94,0.47,24.5,55125,NULL,NULL,'H','NGC 5719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123124,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123124,32.01,0.43,25.3,55125,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5719',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123125,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123125,32.05,0.46,25.7,55125,NULL,NULL,'J','NGC 5719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123126,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123126,32.08,0.49,26,55125,NULL,NULL,'Malmquist cor.','NGC 5719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123127,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123127,32.07,NULL,26,55125,72,NULL,NULL,'NGC 5719',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123128,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123128,32.14,0.4,26.8,55125,NULL,NULL,'mean','NGC 5719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123129,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123129,32.14,0.43,26.8,55125,75,NULL,'3.6 micron, color corrected','NGC 5719',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123130,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123130,32.15,0.4,26.9,55125,NULL,NULL,NULL,'NGC 5719',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123131,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123131,32.22,0.46,27.8,55125,NULL,NULL,NULL,'NGC 5719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123132,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,NULL,123132,32.23,0.2,27.9,55125,74.4,NULL,NULL,'NGC 5719',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123133,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123133,38.23,0.46,442,55126,70,NULL,NULL,'SDSS J144056.61+030910.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.235917,3.153,0.137,NULL,58255766133,910246345,14222599,17.9),(123134,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123134,35.79,0.1,144,55127,70,NULL,NULL,'2MASX J14405803+0327055',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000073,NULL,'15.7g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,220.241916667,3.45156,0.069,NULL,58255889260,910248269,14222629,15.7),(123135,'Tully-Fisher','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123135,31.94,NULL,24.4,55128,72,NULL,NULL,'NGC 5725',NULL,'2014Ap.....57..457K',2014,1,1.1,NULL,'G',0.00002,NULL,'14.25',0.7,'SB(s)d:','in a radial-velocity based grouping',NULL,NULL,NULL,1,220.243,2.18656,0.097,NULL,58261976432,910343381,14224115,14.25),(123136,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123136,37.37,0.46,298,55129,70,NULL,NULL,'2MASX J14405867+4628073',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.244625,46.46872,0,NULL,59987397747,937303089,14645360,16.8),(123137,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123137,37.02,0.46,253,55130,70,NULL,NULL,'2MASX J14405878+4507503',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.244708333,45.13081,0.017,NULL,59955981085,936812204,14637690,16.3),(123138,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123138,38.44,0.46,487,55131,70,NULL,NULL,'2MASX J14405941+0033415',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000084,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.2475417,0.56158,0.125,NULL,58259271121,910301111,14223454,17.4),(123139,'FP','2016-12-15 15:15:27','2016-12-16 11:20:41','1',NULL,'R',123139,36.6,0.33,209,55132,70,NULL,NULL,'2MASX J14410063+1429402',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.69',0.17,NULL,NULL,NULL,NULL,NULL,1,220.2525417,14.49456,0.029,NULL,59558949259,930608582,14540759,17.69),(123140,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123140,38.42,0.46,484,55133,70,NULL,NULL,'LCRS B143826.7-022940',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.259916667,-2.70792,0.189,NULL,43491803756,679559433,10618116,18.5),(123141,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123141,37.42,0.46,305,55134,70,NULL,NULL,'2MASX J14410373+1959102',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.265583,19.98625,0,NULL,59501213825,929706466,14526663,17.5),(123142,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123142,37.94,0.33,387,55135,70,NULL,NULL,'2MASX J14410486+1851152',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.26',0.17,'BrClG',NULL,NULL,NULL,NULL,1,220.270417,18.85433,0.04,NULL,59508798159,929824971,14528515,18.26),(123143,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123143,32.95,0.47,38.9,55136,NULL,NULL,'H','NGC 5716',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00001,NULL,'13.25',1.3,'SB(rs)c?       HII','in a pair',NULL,NULL,NULL,1,220.273,-17.47697,0.341,NULL,46679225420,729362897,11396295,13.25),(123144,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123144,33.01,0.46,40.1,55136,NULL,NULL,'J','NGC 5716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123145,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123145,33.03,0.45,40.3,55136,NULL,NULL,'K','NGC 5716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123146,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123146,33.64,0.4,53.6,55136,NULL,NULL,'mean','NGC 5716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123147,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123147,37.04,0.46,256,55137,70,NULL,NULL,'2MASX J14410575+3002089',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.274083,30.03578,0,NULL,60020411133,937818923,14653420,16.8),(123148,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123148,38.21,0.46,438,55138,70,NULL,NULL,'2MASXi J1441061+501521',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.275583,50.25617,0.049,NULL,59200345337,925005395,14453209,17.7),(123149,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123149,38.52,0.46,505,55139,70,NULL,NULL,'2MASX J14410619+0124209',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.275833,1.40569,0.105,NULL,58262483659,910351307,14224239,17.6),(123150,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123150,33.19,0.8,43.5,55140,75,NULL,'MAT, I','ESO 327- G 007',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000026,NULL,'12.60',1.2,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,220.276167,-39.98642,0.261,NULL,47217492604,737773321,11527708,12.6),(123151,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123151,32.72,0.32,35,55140,85,NULL,'I, raw','ESO 327- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123152,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123152,32.73,0.32,35.2,55140,85,NULL,'I, inv','ESO 327- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123153,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123153,32.8,0.43,36.3,55140,75,NULL,'MAT, I, raw','ESO 327- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123154,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123154,32.88,0.43,37.6,55140,75,NULL,'MAT, I, inv','ESO 327- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123155,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123155,33.1,0.43,41.6,55140,75,NULL,'MAT, I, cor','ESO 327- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123156,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123156,32.44,0.43,30.7,55141,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-37-011',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000033,NULL,'14.04',0.9,'SAB(rs)a pec?',NULL,NULL,NULL,NULL,1,220.2767083,-8.87522,0.257,NULL,46466042569,726031915,11344248,14.04),(123157,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123157,37.97,0.46,393,55142,70,NULL,NULL,'SDSS J144106.63+471647.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.277667,47.27975,0.013,NULL,59987799836,937309372,14645458,18),(123158,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123158,38.35,0.33,468,55143,70,NULL,NULL,'2MASX J14410691+2541150',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.278875,25.68758,0.053,NULL,60025953820,937905528,14654773,17.6),(123159,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123159,36.73,0.46,222,55144,70,NULL,NULL,'2MASX J14410837+2112302',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.284916667,21.20836,0.015,NULL,59503637997,929744343,14527255,16.8),(123160,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123160,37.67,0.46,342,55145,70,NULL,NULL,'SDSS J144110.53+081846.7',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.293917,8.313,0.033,NULL,59366107339,927595427,14493678,16.8),(123161,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123161,31.43,NULL,19.3,55146,NULL,NULL,NULL,'FGC 1793',NULL,'2000BSAO...50....5K',2000,1,0.65,'Matthews (2000A&AS..143..421M) detects another feature at v=4140 km/sec.','G',0.000013,'?','17.1',0.09,'Sd',NULL,NULL,NULL,NULL,1,220.300458333,-17.64606,0.341,NULL,46679439702,729366245,11396347,17.1),(123162,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123162,35.86,0.33,148,55147,70,NULL,NULL,'2MASX J14411233+1453242',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000934,NULL,'17.50',0.24,NULL,NULL,NULL,NULL,NULL,1,220.3014583,14.89014,0.005,NULL,59558710317,930604848,14540700,17.5),(123163,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123163,37.38,0.46,300,55148,70,NULL,NULL,'SDSS J144113.04+095057.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.304375,9.84919,0.017,NULL,59373973915,927718342,14495599,18),(123164,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123164,36.6,0.33,209,55149,70,NULL,NULL,'2MASX J14411329+1432032',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.77',0.18,NULL,NULL,NULL,NULL,NULL,1,220.305333,14.53417,0.029,NULL,59558972312,930608942,14540764,17.77),(123165,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123165,37.59,0.46,329,55150,70,NULL,NULL,'2MASX J14411340+0908555',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.305708333,9.14861,0.041,NULL,59364633066,927572391,14493318,16.7),(123166,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123166,36.53,NULL,202,55151,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09468',NULL,'2010Ap&SS.325..163P',2010,1,0.85,NULL,'G',0.000027,NULL,'16.9g',0.16,'Sbc',NULL,NULL,NULL,NULL,1,220.311625,10.05672,0.017,NULL,59374496763,927726511,14495726,16.9),(123167,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123167,36.54,NULL,203,55151,NULL,NULL,'Dipole + Quadrupole','UGC 09468',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123168,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123168,36.55,NULL,204,55151,NULL,NULL,'Dipole','UGC 09468',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123169,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123169,36.69,NULL,217,55151,NULL,NULL,NULL,'UGC 09468',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123170,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123170,36.74,0.49,223,55151,75,NULL,'IR','UGC 09468',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123171,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123171,37.58,0.46,328,55152,70,NULL,NULL,'2MASX J14411535+2522450',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.314,25.37919,0.067,NULL,60025744382,937902255,14654722,18),(123172,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123172,36.85,0.46,235,55153,70,NULL,NULL,'2MASX J14411541+1108305',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.314167,11.14192,0.009,NULL,59371847836,927685122,14495080,16.7),(123173,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123173,37.95,0.46,389,55154,70,NULL,NULL,'2MASX J14411551+1900372',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.16',0.14,NULL,NULL,NULL,NULL,NULL,1,220.31475,19.0105,0.037,NULL,59500433712,929694276,14526473,18.16),(123174,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123174,36.69,0.46,218,55155,70,NULL,NULL,'2MASX J14411557+2156382',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'16.1g',0.42,NULL,NULL,NULL,NULL,NULL,1,220.3147917,21.94378,0.03,NULL,59503019704,929734682,14527104,16.1),(123175,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123175,37.08,0.46,261,55156,70,NULL,NULL,'2MASX J14411650+0750165',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,220.318708333,7.83792,0.045,NULL,59365509576,927586087,14493532,17),(123176,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123176,37.16,0.46,271,55157,70,NULL,NULL,'2MASX J14411672+2340026',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.3197917,23.66739,0.034,NULL,59507487801,929804496,14528195,17.7),(123177,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123177,37.73,0.46,352,55158,70,NULL,NULL,'SDSS J144118.00+033519.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000087,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.325041667,3.58883,0.065,NULL,58255905471,910248522,14222633,18.3),(123178,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123178,32.84,0.8,37,55159,75,NULL,NULL,'UGC 09477',NULL,'1988NBGC.C....0000T',1988,1,0.59,NULL,'G',0.000017,NULL,'16.5g',0.44,'Im:',NULL,NULL,NULL,NULL,1,220.327125,59.30142,0,NULL,57768458955,902632171,14103627,16.5),(123179,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123179,32.07,NULL,25.9,55160,72,NULL,NULL,'KUG 1438+080',NULL,'2014Ap.....57..457K',2014,1,0.49,NULL,'G',0.000005,NULL,'16.1g',0.31,'Spiral',NULL,NULL,NULL,NULL,1,220.329917,7.793,0.045,NULL,59365521947,927586280,14493535,16.1),(123180,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123180,36.57,0.33,206,55161,70,NULL,NULL,'CGCG 075-110',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000173,NULL,'14.8g',0.59,NULL,NULL,NULL,NULL,NULL,1,220.334833,10.79719,0.009,NULL,59371803274,927684426,14495069,14.8),(123181,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123181,36.05,0.46,162,55162,70,NULL,NULL,'2MASX J14412105+1940556',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.90',0.18,NULL,NULL,NULL,NULL,NULL,1,220.3377083,19.68225,0.016,NULL,59501271166,929707361,14526677,16.9),(123182,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123182,36.39,0.46,189,55163,70,NULL,NULL,'2MASX J14412117+0911355',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000198,NULL,'15.4g',0.48,NULL,NULL,NULL,NULL,NULL,1,220.3380417,9.19322,0.041,NULL,59364630778,927572355,14493318,15.4),(123183,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123183,36.26,0.33,179,55164,70,NULL,NULL,'2MASX J14412133+2139316',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.70',0.25,NULL,NULL,NULL,NULL,NULL,1,220.338833,21.65889,0.027,NULL,59503593530,929743648,14527244,16.7),(123184,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123184,36.98,0.46,249,55165,70,NULL,NULL,'SDSS J144121.41+534458.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.33925,53.74956,0,NULL,59191420056,924865938,14451030,18.2),(123185,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123185,37.74,0.46,353,55166,70,NULL,NULL,'2MASX J14412172+3019598',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,220.3405,30.33342,0,NULL,60019901238,937810956,14653296,18.4),(123186,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123186,35.82,0.46,146,55167,70,NULL,NULL,'2MASX J14412228+1150225',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.3429583,11.83953,0.009,NULL,59371523148,927680049,14495000,16.1),(123187,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123187,38.12,0.46,420,55168,70,NULL,NULL,'2MASX J14412242+0733285',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.343417,7.55783,0.041,NULL,59362702965,927542233,14492847,17.8),(123188,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123188,35.5,0.46,126,55169,70,NULL,NULL,'2MASX J14412360+1229432',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000143,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.348417,12.49542,0.005,NULL,59543446702,930366354,14536974,16.3),(123189,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123189,37.45,0.46,309,55170,70,NULL,NULL,'2MASX J14412402+1413472',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.350041667,14.22978,0.017,NULL,59559032884,930609888,14540779,17.4),(123190,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123190,38.19,0.46,434,55171,70,NULL,NULL,'SDSS J144124.03+002421.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,220.350166667,0.40594,0.109,NULL,58259251984,910300812,14223450,18.3),(123191,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123191,37.54,0.46,321,55172,70,NULL,NULL,'2MASX J14412484+3247068',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.353583,32.78533,0,NULL,60121392274,939396754,14678074,17.4),(123192,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123192,37.55,0.46,323,55173,70,NULL,NULL,'SDSS J144126.53+560023.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000135,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.360583333,56.00656,0,NULL,57245213948,894456467,13975882,18.5),(123193,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123193,37.71,0.27,348,55174,70,NULL,NULL,'2MASX J14412686+4635144',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.361833,46.58744,0,NULL,59987756861,937308700,14645448,17.9),(123194,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123194,37.48,0.46,313,55175,70,NULL,NULL,'2MASX J14412724+1709172',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.73',0.14,NULL,NULL,NULL,NULL,NULL,1,220.363666667,17.15467,0.031,NULL,59554530439,930539538,14539680,18.73),(123195,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123195,37.21,0.46,277,55176,70,NULL,NULL,'2MASX J14412907+2906481',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00012,NULL,'17.0g',NULL,'S0',NULL,NULL,NULL,NULL,1,220.371167,29.11328,0,NULL,60018981812,937796590,14653071,17),(123196,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123196,36.54,0.46,203,55177,70,NULL,NULL,'2MASX J14412999+4618564',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.374875,46.31572,0.005,NULL,59987448135,937303877,14645373,17.1),(123197,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123197,37.69,0.46,345,55178,70,NULL,NULL,'SDSS J144130.40+273511.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.3767083,27.58658,0.033,NULL,60028828410,937950443,14655475,18.3),(123198,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123198,35.73,0.19,140,55179,70,NULL,NULL,'2MASX J14413067+0845055',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'15.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.377667,8.75144,0.033,NULL,59365232058,927581750,14493464,15.7),(123199,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123199,37.61,0.46,332,55180,70,NULL,NULL,'2MASX J14413135+2258186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.380583,22.97186,0.032,NULL,59508769818,929824528,14528508,17.5),(123200,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123200,38.14,0.15,425,55181,70,NULL,NULL,'2MASX J14413172+2206286',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.56',0.15,NULL,NULL,NULL,NULL,NULL,1,220.3822083,22.10789,0.03,NULL,59508276987,929816827,14528387,18.56),(123201,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123201,38.01,0.17,400,55182,70,NULL,NULL,'2MASX J14413173+2005566',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,220.3822917,20.09903,0,NULL,59501246199,929706971,14526671,18.48),(123202,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123202,32.86,0.2,37.3,55183,74.4,NULL,NULL,'UGC 09476',NULL,'2013AJ....146...86T',2013,1,1.64,NULL,'G',0.000027,NULL,'13.6g',0.97,'SAB(rs)c','Pair member (points to parent)',NULL,NULL,NULL,1,220.383416667,44.51275,0.037,NULL,59956512989,936820515,14637820,13.6),(123203,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123203,33.49,0.4,49.9,55183,NULL,NULL,'mean','UGC 09476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123204,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123204,33.53,0.47,50.9,55183,NULL,NULL,'H','UGC 09476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123205,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123205,33.57,0.45,51.7,55183,NULL,NULL,'K','UGC 09476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123206,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123206,33.59,0.46,52.2,55183,NULL,NULL,'J','UGC 09476',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123207,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123207,35.79,0.1,144,55184,70,NULL,NULL,'CGCG 047-143',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000083,NULL,'15.4g',0.33,'S0/a','Group member',NULL,NULL,NULL,1,220.3837917,3.59922,0.065,NULL,58256616177,910259627,14222806,15.4),(123208,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123208,37.59,0.46,330,55185,70,NULL,NULL,'2MASX J14413253+4529293',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,220.385625,45.49158,0.017,NULL,59955750166,936808596,14637634,17.2),(123209,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123209,33.92,0.45,60.8,55186,NULL,NULL,'K','UGC 09473',NULL,'2007A&A...465...71T',2007,1,1.23,NULL,'G',0.00008,NULL,'13.6g',0.95,'S0:','in a radial-velocity based grouping',NULL,NULL,NULL,1,220.387333333,38.85136,0,NULL,60076691038,938698297,14667160,13.6),(123210,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123210,34.11,0.4,66.3,55186,NULL,NULL,'mean','UGC 09473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123211,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123211,38.01,0.27,401,55187,70,NULL,NULL,'2MASX J14413641+2403331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.7g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,220.4017083,24.05931,0.087,NULL,59507721641,929808150,14528252,17.7),(123212,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123212,36.3,0.46,182,55188,70,NULL,NULL,'2MASX J14413639+2505011',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.40',0.23,NULL,NULL,NULL,NULL,NULL,1,220.4017083,25.08378,0.076,NULL,59506691061,929792047,14528000,17.4),(123213,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123213,37.71,0.27,348,55189,70,NULL,NULL,'2MASX J14413689+4654307',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.403583,46.90858,0,NULL,59987965454,937311960,14645499,17.2),(123214,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123214,36.19,0.46,173,55190,70,NULL,NULL,'MCG +10-21-025',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000193,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,220.407667,62.33822,0.045,NULL,57758564574,902477571,14101212,15.6),(123215,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123215,33.95,0.8,61.5,55191,75,NULL,'MAT, I','ESO 386- G 009',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15',1.2,'Sb             HII',NULL,NULL,NULL,NULL,1,220.409333,-33.31106,0.269,NULL,47227990693,737937354,11530271,15),(123216,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123216,33.99,0.4,62.9,55191,NULL,NULL,'mean','ESO 386- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123217,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123217,34.12,0.45,66.8,55191,NULL,NULL,'K','ESO 386- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123218,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123218,34.13,0.32,67.1,55191,85,NULL,'I, raw','ESO 386- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123219,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123219,34.14,0.43,67.3,55191,75,NULL,'MAT, I, raw','ESO 386- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123220,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123220,34.16,0.47,67.9,55191,NULL,NULL,'H','ESO 386- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123221,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123221,34.19,0.46,69,55191,NULL,NULL,'J','ESO 386- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123222,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123222,34.21,0.32,69.5,55191,85,NULL,'I, inv','ESO 386- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123223,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123223,34.41,0.43,76.1,55191,75,NULL,'MAT, I, cor','ESO 386- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123224,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123224,34.47,0.43,78.2,55191,75,NULL,'MAT, I, inv','ESO 386- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123225,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123225,36.26,0.46,179,55192,70,NULL,NULL,'2MASXi J1441383-002729',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000213,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.409708333,-0.45819,0.105,NULL,43491425909,679553529,10618023,16.2),(123226,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123226,38.14,0.15,425,55193,70,NULL,NULL,'2MASX J14413848+2203526',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.410166667,22.06467,0.03,NULL,59508262182,929816596,14528384,18.5),(123227,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123227,38.01,0.46,399,55194,70,NULL,NULL,'2MASX J14413890+3159539',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.4120417,31.99825,0,NULL,60087721081,938870641,14669853,18.4),(123228,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123228,38.08,0.33,412,55195,70,NULL,NULL,'2MASX J14413900+1623565',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.4125,16.39908,0,NULL,59554745501,930542898,14539732,17.5),(123229,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123229,37.71,0.27,348,55196,70,NULL,NULL,'2MASX J14414065+4635127',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000192,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.419167,46.58692,0,NULL,59987769592,937308899,14645451,16.6),(123230,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123230,35.49,0.33,125,55197,70,NULL,NULL,'IC 4486',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00008,NULL,'15.2',0.26,NULL,NULL,NULL,NULL,NULL,1,220.4199583,18.55722,0.036,NULL,59550787832,930481059,14538766,15.2),(123231,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123231,37.58,0.46,328,55198,70,NULL,NULL,'2MASX J14414160+1238596',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.4235,12.64992,0,NULL,59557067316,930579176,14540299,17.5),(123232,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123232,37.04,0.33,256,55199,70,NULL,NULL,'2MASX J14414253+3318099',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,220.42725,33.30283,0,NULL,60121349448,939396085,14678063,16.2),(123233,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123233,33.52,0.85,50.5,55200,NULL,NULL,'Malmquist cor.','UGC 09471',NULL,'2009ApJS..182..474S',2009,1,1.33,NULL,'G',0.000033,NULL,'14.7g',0.54,'SBb',NULL,NULL,NULL,NULL,1,220.4289583,5.95275,0.069,NULL,58309235651,911081807,14235653,14.7),(123234,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123234,33.54,0.85,51,55200,NULL,NULL,NULL,'UGC 09471',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123235,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123235,33.58,0.2,52,55200,74.4,NULL,NULL,'UGC 09471',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123236,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123236,38.08,0.33,412,55201,70,NULL,NULL,'2MASX J14414345+1631026',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.4309583,16.5175,0,NULL,59554869167,930544830,14539762,17.7),(123237,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123237,38.21,0.46,438,55202,70,NULL,NULL,'2MASX J14414432+5319336',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.434583,53.32608,0,NULL,59191559165,924868111,14451064,18.3),(123238,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123238,38.05,0.46,407,55203,70,NULL,NULL,'2MASX J14414447+1237596',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.4355,12.63336,0,NULL,59557067393,930579178,14540299,17.1),(123239,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123239,35.71,0.46,139,55204,70,NULL,NULL,'CGCG 104-069',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000157,NULL,'15.5',0.29,NULL,NULL,NULL,NULL,NULL,1,220.444583,19.25194,0.037,NULL,59500643701,929697557,14526524,15.5),(123240,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123240,35.79,0.1,144,55205,70,NULL,NULL,'2MASX J14414691+0327195',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00006,NULL,'16.2g',0.29,'S0',NULL,NULL,NULL,NULL,1,220.4454583,3.45542,0.089,NULL,58256605411,910259459,14222804,16.2),(123241,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123241,35.33,0.46,116,55206,70,NULL,NULL,'MCG +10-21-024',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'14.9g',0.58,'E0',NULL,NULL,NULL,NULL,1,220.445625,56.91789,0.017,NULL,57258774243,894668347,13979192,14.9),(123242,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123242,37.62,0.46,334,55207,70,NULL,NULL,'2MASX J14414729+0259195',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.447167,2.98872,0.113,NULL,58263239250,910363113,14224423,17.2),(123243,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123243,37.78,0.27,359,55208,70,NULL,NULL,'2MASX J14414754+2829232',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.4482917,28.48978,0.01,NULL,60027060701,937922823,14655044,18),(123244,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123244,38.14,0.15,425,55209,70,NULL,NULL,'2MASX J14414829+2220231',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.45125,22.33969,0.068,NULL,59508285185,929816956,14528389,17.7),(123245,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123245,37.39,0.46,300,55210,70,NULL,NULL,'2MASX J14414853+2202391',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.452166667,22.04408,0.028,NULL,59508262017,929816594,14528384,18.2),(123246,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123246,31.58,NULL,20.7,55211,72,NULL,NULL,'UGC 09470',NULL,'2014Ap.....57..457K',2014,1,1.26,NULL,'G',0.000017,NULL,'14.9g',0.64,'SB(rs)dm pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.452833,0.68697,0.145,NULL,58262739952,910355311,14224301,14.9),(123247,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123247,36.79,0.46,228,55212,70,NULL,NULL,'2MASX J14414911+1719405',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.23',0.16,NULL,NULL,NULL,NULL,NULL,1,220.4545,17.32808,0.036,NULL,59551527306,930492614,14538947,18.23),(123248,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123248,37.84,0.46,369,55213,70,NULL,NULL,'2MASX J14414955+3035559',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000199,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.456625,30.59897,0,NULL,60019810612,937809540,14653274,17.1),(123249,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123249,35.65,0.52,135,55214,70,NULL,NULL,'2MASX J14414968-3645593',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,220.456917,-36.76642,0.301,NULL,47224134538,737877102,11529329,13.7),(123250,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123250,37.99,0.46,396,55215,70,NULL,NULL,'SDSS J144150.70+182803.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.4612917,18.46753,0.053,NULL,59550778771,930480918,14538764,18.2),(123251,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123251,32.45,NULL,30.9,55216,72,NULL,NULL,'UGC 09472',NULL,'2014Ap.....57..457K',2014,1,1,NULL,'G',0.000017,NULL,'15.59',0.5,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.461917,-1.39244,0.133,NULL,43494742768,679605355,10618833,15.59),(123252,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123252,37.14,0.46,268,55217,70,NULL,NULL,'2MASX J14415146+1259395',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.4644583,12.99419,0,NULL,59557193085,930581141,14540330,16.8),(123253,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123253,38.1,0.46,416,55218,70,NULL,NULL,'SDSS J144151.57+311136.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.464916667,31.19339,0,NULL,60017028490,937766070,14652594,18.3),(123254,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123254,37.08,0.46,261,55219,70,NULL,NULL,'2MASX J14415194+1936221',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.4665,19.60633,0.016,NULL,59501347475,929708554,14526696,17.7),(123255,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123255,38.01,0.27,401,55220,70,NULL,NULL,'2MASX J14415229+2405173',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000136,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.467875,24.08828,0.087,NULL,59507709109,929807954,14528249,17.9),(123256,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123256,37.12,0.46,265,55221,70,NULL,NULL,'2MASX J14415260+2052461',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.55',0.14,NULL,NULL,NULL,NULL,NULL,1,220.469125,20.87964,0.024,NULL,59504589025,929759203,14527487,18.55),(123257,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123257,36.3,0.51,182,55222,70,NULL,NULL,'2MASX J14415280-1456548',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,220.470125,-14.94867,0.337,NULL,46690463187,729538487,11399038,16.14),(123258,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123258,37.64,0.33,337,55223,70,NULL,NULL,'2MASX J14415424+2738383',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.476083,27.64406,0.033,NULL,60028796051,937949938,14655467,18),(123259,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123259,38.02,0.46,402,55224,70,NULL,NULL,'2MASX J14415445+2100431',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.477083,21.01194,0.024,NULL,59504537464,929758397,14527474,17.5),(123260,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123260,38.14,0.15,425,55225,70,NULL,NULL,'SDSS J144154.59+222820.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.4775,22.47242,0.068,NULL,59508495383,929820240,14528441,18.3),(123261,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123261,35.87,0.46,150,55226,70,NULL,NULL,'CGCG 075-112',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000147,NULL,'14.8g',0.58,NULL,'Group member',NULL,NULL,NULL,1,220.479,9.38269,0.037,NULL,59372736614,927699009,14495297,14.8),(123262,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123262,37.61,0.46,332,55227,70,NULL,NULL,'2MASX J14415621+3400408',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.484083,34.01136,0,NULL,60067042797,938547543,14664805,17.2),(123263,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123263,38.62,0.33,531,55228,70,NULL,NULL,'2MASX J14415746+1356415',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,220.4895,13.94489,0,NULL,59558137281,930595895,14540560,NULL),(123264,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123264,35.79,0.1,144,55229,70,NULL,NULL,'CGCG 047-145',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000047,NULL,'15.0g',0.57,'E0','Group member',NULL,NULL,NULL,1,220.494708333,3.38997,0.101,NULL,58256688818,910260762,14222824,15),(123265,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123265,35.49,0.33,125,55230,70,NULL,NULL,'2MASX J14420105+1838292',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.74',0.26,NULL,NULL,NULL,NULL,NULL,1,220.504291667,18.64156,0.036,NULL,59550738374,930480287,14538754,16.74),(123266,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123266,37.67,0.46,341,55231,70,NULL,NULL,'SDSS J144201.28+000611.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00007,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.505333,0.10317,0.105,NULL,58259188427,910299819,14223434,18.3),(123267,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123267,38.18,0.46,432,55232,70,NULL,NULL,'2MASX J14420258+4614197',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.51075,46.23892,0,NULL,59987433638,937303650,14645369,17.6),(123268,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123268,37.78,0.27,359,55233,70,NULL,NULL,'2MASX J14420263+2830423',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00012,NULL,'17.10',0.26,'cD',NULL,NULL,NULL,NULL,1,220.510916667,28.51169,0.01,NULL,60027275952,937926186,14655096,17.1),(123269,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123269,39.12,0.46,666,55234,70,NULL,NULL,'2MASX J14420262-0044089',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.511,-0.73581,0.085,NULL,43494242216,679597534,10618711,18.4),(123270,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123270,38.06,0.27,409,55235,70,NULL,NULL,'2MASX J14420278+2219391',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.5115,22.3275,0.068,NULL,59508291885,929817060,14528391,17.7),(123271,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123271,37.53,0.46,321,55236,70,NULL,NULL,'SDSS J144202.77+303520.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.5115417,30.58894,0,NULL,60019941202,937811581,14653305,18.7),(123272,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123272,34.82,0.46,91.9,55237,70,NULL,NULL,'CGCG 220-048',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000161,NULL,'15.1g',0.45,'S0',NULL,NULL,NULL,NULL,1,220.5120417,43.89828,0.063,NULL,59955612945,936806452,14637600,15.1),(123273,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123273,37.08,0.46,261,55238,70,NULL,NULL,'2MASX J14420306+4806467',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.512917,48.11308,0.069,NULL,59933241939,936456905,14632139,16.8),(123274,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123274,34.91,NULL,95.8,55239,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09475',NULL,'2010Ap&SS.325..163P',2010,1,1.44,NULL,'G',0.000033,NULL,'15.9g',0.2,'Sc',NULL,NULL,NULL,NULL,1,220.513916667,12.06986,0.013,NULL,59371482839,927679419,14494990,15.9),(123275,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123275,34.92,NULL,96.3,55239,NULL,NULL,'Dipole + Quadrupole','UGC 09475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123276,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123276,34.92,NULL,96.5,55239,NULL,NULL,'Dipole','UGC 09475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123277,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123277,34.97,NULL,98.5,55239,NULL,NULL,NULL,'UGC 09475',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123278,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123278,35.19,0.49,109,55239,75,NULL,'IR','UGC 09475',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123279,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123279,35.39,0.2,120,55239,74.4,NULL,NULL,'UGC 09475',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123280,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123280,35.71,0.2,139,55240,74.4,NULL,NULL,'CGCG 075-115',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000354,NULL,'16.1g',0.35,NULL,'Group member',NULL,NULL,NULL,1,220.52,9.38261,0.037,NULL,59373790148,927715471,14495554,16.1),(123281,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123281,36.69,0.46,218,55241,70,NULL,NULL,'2MASX J14420507+2331071',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.52125,23.51861,0.032,NULL,59507817615,929809650,14528275,17.5),(123282,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123282,37.28,0.46,286,55242,70,NULL,NULL,'2MASX J14420556+3033229',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.523166667,30.55631,0,NULL,60019939050,937811547,14653305,16.8),(123283,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123283,38.31,0.46,459,55243,70,NULL,NULL,'2MASX J14420589+1508537',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.44',0.12,NULL,NULL,NULL,NULL,NULL,1,220.5244583,15.14814,0.013,NULL,59558641711,930603776,14540684,18.44),(123284,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123284,38.14,0.15,425,55244,70,NULL,NULL,'2MASX J14420688+2212071',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.5287083,22.20206,0.068,NULL,59508286318,929816973,14528390,17.7),(123285,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123285,31.95,0.46,24.6,55245,NULL,NULL,'J','NGC 5729',NULL,'2007A&A...465...71T',2007,1,2.6,NULL,'G',0.000003,NULL,'12.99',0.7,'Sb pec:',NULL,NULL,NULL,NULL,1,220.528667,-9.00944,0.269,NULL,46467699598,726057806,11344653,12.99),(123286,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123286,31.97,0.49,24.8,55245,75,NULL,'IR','NGC 5729',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123287,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123287,32.01,0.45,25.2,55245,NULL,NULL,'K','NGC 5729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123288,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123288,32.09,0.47,26.2,55245,NULL,NULL,'H','NGC 5729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123289,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123289,32.18,0.4,27.3,55245,NULL,NULL,'mean','NGC 5729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123290,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123290,36.66,0.71,214,55246,70,NULL,NULL,'2MASX J14420746-1742136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.58',NULL,NULL,NULL,NULL,NULL,NULL,1,220.531125,-17.70381,0.349,NULL,46679451441,729366428,11396350,16.58),(123291,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123291,38.62,0.33,531,55247,70,NULL,NULL,'SDSS J144208.06+135113.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.533583,13.85378,0,NULL,59557807764,930590746,14540480,18.4),(123292,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123292,37.64,0.33,337,55248,70,NULL,NULL,'2MASX J14420839+2734513',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.46',0.24,NULL,NULL,NULL,NULL,NULL,1,220.534958333,27.58086,0.033,NULL,60027914542,937936164,14655252,17.46),(123293,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123293,37.36,0.46,297,55249,70,NULL,NULL,'2MASX J14420866+2552533',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.5360417,25.88153,0.051,NULL,60025851451,937903928,14654748,17.7),(123294,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123294,38.13,0.46,422,55250,70,NULL,NULL,'2MASX J14420884+2744043',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.69',0.14,NULL,NULL,NULL,NULL,NULL,1,220.536833,27.73442,0.033,NULL,60028786396,937949787,14655465,18.69),(123295,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123295,35.84,0.69,147,55251,70,NULL,NULL,'2MASX J14420926-3526576',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,220.538625,-35.44928,0.237,NULL,47221906637,737842291,11528785,14.1),(123296,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123296,35.9,0.53,151,55252,70,NULL,NULL,'2MASX J14420941-1633566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.74',NULL,NULL,NULL,NULL,NULL,NULL,1,220.5392917,-16.56581,0.361,NULL,46682592930,729415514,11397117,15.74),(123297,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123297,37.78,0.27,359,55253,70,NULL,NULL,'2MASX J14421015+2834113',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.542208333,28.56969,0.01,NULL,60027282877,937926294,14655098,17.7),(123298,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123298,38.14,0.15,425,55254,70,NULL,NULL,'2MASX J14421141+2211221',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.5475417,22.1895,0.068,NULL,59508285566,929816961,14528390,17.7),(123299,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123299,37.87,0.46,376,55255,70,NULL,NULL,'2MASX J14421183+2708203',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.5495,27.13903,0.031,NULL,60028020522,937937820,14655278,18.1),(123300,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123300,37.46,0.69,310,55256,70,NULL,NULL,'2MASX J14421212-1624146',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.68',NULL,NULL,NULL,NULL,NULL,NULL,1,220.5507083,-16.40408,0.365,NULL,46682424977,729412890,11397076,16.68),(123301,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123301,38.35,0.19,467,55257,70,NULL,NULL,'2MASX J14421242+5517546',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.5520417,55.29833,0,NULL,57246625958,894478530,13976227,18.1),(123302,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123302,35.59,0.48,131,55258,70,NULL,NULL,'2MASX J14421266-3752452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,220.552875,-37.87925,0.329,NULL,47224226762,737878543,11529352,14),(123303,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123303,38.14,0.15,425,55259,70,NULL,NULL,'2MASX J14421337+2217201',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000208,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.555666667,22.28892,0.068,NULL,59508291210,929817050,14528391,17.6),(123304,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123304,37.16,0.46,270,55260,70,NULL,NULL,'2MASX J14421426+3528139',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000173,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,220.5595417,35.47056,0,NULL,60068343466,938567866,14665122,16.2),(123305,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123305,36.97,0.46,248,55261,70,NULL,NULL,'2MASX J14421460+2918093',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000047,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.560958333,29.30247,0,NULL,60019143088,937799110,14653111,17.2),(123306,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123306,38.27,0.46,451,55262,70,NULL,NULL,'SDSS J144217.68+181942.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.573667,18.32856,0.042,NULL,59550955977,930483687,14538807,18.1),(123307,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123307,37.54,0.46,321,55263,70,NULL,NULL,'2MASX J14421805+2902216',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00013,NULL,'16.9g',0.28,'S0',NULL,NULL,NULL,NULL,1,220.575125,29.03919,0,NULL,60018940743,937795949,14653061,16.9),(123308,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123308,38.14,0.15,425,55264,70,NULL,NULL,'2MASX J14421860+2225162',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.5772917,22.42125,0.073,NULL,59508491526,929820180,14528440,17.7),(123309,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123309,37.9,0.46,380,55265,70,NULL,NULL,'2MASX J14421855+5633316',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.57775,56.55878,0.029,NULL,57258733985,894667718,13979183,18.1),(123310,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123310,38.14,0.15,425,55266,70,NULL,NULL,'SDSS J144218.76+222131.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.578166667,22.35886,0.068,NULL,59508279138,929816861,14528388,18.4),(123311,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123311,35.31,0.46,115,55267,70,NULL,NULL,'CGCG 134-017',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'15.5',0.22,NULL,NULL,NULL,NULL,NULL,1,220.580833,26.23922,0.056,NULL,60026715435,937917428,14654959,15.5),(123312,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123312,38.06,0.27,409,55268,70,NULL,NULL,'2MASX J14421950+2217082',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.581208333,22.28564,0.068,NULL,59508291490,929817054,14528391,17.8),(123313,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123313,37.05,0.46,257,55269,70,NULL,NULL,'SDSS J144221.70+034157.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.590417,3.69931,0.077,NULL,58256762250,910261910,14222842,17.7),(123314,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123314,38.01,0.27,401,55270,70,NULL,NULL,'2MASX J14422248+2400496',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.593875,24.01389,0.081,NULL,59507707761,929807933,14528248,17.7),(123315,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123315,38.06,0.27,409,55271,70,NULL,NULL,'2MASX J14422281+2219073',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.595,22.31867,0.068,NULL,59508279967,929816874,14528388,17.3),(123316,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123316,37.35,0.46,295,55272,70,NULL,NULL,'2MASX J14422328+4800198',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.597125,48.00558,0.057,NULL,59932756881,936449326,14632020,17.2),(123317,'SNIa','2016-12-15 15:15:28','2016-12-16 11:20:41','1','SN 2009Y',NULL,123317,32.98,0.26,39,55273,73.8,NULL,'SALT 2 (SNANA)','NGC 5728',0.0101,'2014ApJ...795...44R',2014,1,3.1,NULL,'G',0.000067,NULL,'12.81',1.8,'(R_1)SAB(r)a;HII Sy2','in a pair',NULL,NULL,'Sy 1.9',1,220.599583,-17.25308,0.349,NULL,46678751728,729355495,11396179,12.81),(123318,'Sosies','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123318,32.4,0.25,30.2,55273,NULL,NULL,NULL,'NGC 5728',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123319,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123319,33.13,0.8,42.2,55273,75,NULL,'B','NGC 5728',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123320,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123320,31.9,0.55,24,55273,NULL,NULL,'Malmquist cor.','NGC 5728',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123321,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123321,31.95,0.4,24.5,55273,NULL,NULL,NULL,'NGC 5728',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123322,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123322,31.95,0.53,24.6,55273,NULL,NULL,NULL,'NGC 5728',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123323,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123323,32.11,0.2,26.4,55273,74.4,NULL,NULL,'NGC 5728',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123324,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123324,32.22,0.43,27.8,55273,75,NULL,'3.6 micron, color corrected','NGC 5728',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123325,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123325,32.23,0.43,27.9,55273,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5728',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123326,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123326,32.36,0.45,29.7,55273,NULL,NULL,'K','NGC 5728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123327,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123327,32.39,0.47,30,55273,NULL,NULL,'H','NGC 5728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123328,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123328,32.44,0.46,30.7,55273,NULL,NULL,'J','NGC 5728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123329,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123329,32.97,0.4,39.2,55273,NULL,NULL,'mean','NGC 5728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123330,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123330,36.66,0.46,215,55274,70,NULL,NULL,'2MASX J14422423+2015153',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.87',0.15,NULL,NULL,NULL,NULL,NULL,1,220.6009583,20.25425,0,NULL,59500730237,929698909,14526545,17.87),(123331,'D-Sigma','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123331,34.57,0.4,82,55275,75,NULL,'Edat, raw','ESO 386- G 011',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000123,NULL,'14.33',0.8,'E?',NULL,NULL,NULL,NULL,1,220.601916667,-36.57242,0.225,NULL,47224123893,737876935,11529327,14.33),(123332,'D-Sigma','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123332,34.9,0.4,95.7,55275,75,NULL,'Edat, cor','ESO 386- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123333,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123333,35.2,0.4,110,55275,NULL,NULL,'mean','ESO 386- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123334,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123334,35.46,0.45,124,55275,NULL,NULL,'K','ESO 386- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123335,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123335,36.05,0.53,162,55276,70,NULL,NULL,'2MASX J14422455-1703566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.51',NULL,NULL,NULL,NULL,NULL,NULL,1,220.6024583,-17.06578,0.349,NULL,46682224369,729409755,11397027,16.51),(123336,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123336,37.33,0.77,293,55277,70,NULL,NULL,'2MASX J14422767-2127036',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,220.615417,-21.45108,0.321,NULL,46530667726,727041683,11360026,15.1),(123337,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123337,37.5,0.46,316,55278,70,NULL,NULL,'SDSS J144228.42+294220.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.6184583,29.70572,0,NULL,60019063554,937797868,14653091,18.1),(123338,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123338,36.47,0.46,197,55279,70,NULL,NULL,'2MASX J14422876+1718468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,220.619958333,17.31311,0.036,NULL,59551392389,930490506,14538914,18.16),(123339,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123339,35.73,0.19,140,55280,70,NULL,NULL,'2MASX J14422896+0841394',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'17.36',0.2,NULL,NULL,NULL,NULL,NULL,1,220.620625,8.69414,0.041,NULL,59365392312,927584254,14493503,17.36),(123340,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123340,35.2,0.46,110,55281,70,NULL,NULL,'2MASX J14422909+0840474',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.91',0.22,NULL,NULL,NULL,NULL,NULL,1,220.6212083,8.67969,0.041,NULL,59365391729,927584245,14493503,16.91),(123341,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123341,38.13,0.46,423,55282,70,NULL,NULL,'SDSS J144229.08+144717.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.6212083,14.78808,0.005,NULL,59558759070,930605610,14540712,17.3),(123342,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123342,38.17,0.46,431,55283,70,NULL,NULL,'2MASX J14422950+2940417',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.622875,29.67828,0,NULL,60019064288,937797879,14653091,17.8),(123343,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123343,38.66,0.46,539,55284,70,NULL,NULL,'SDSS J144229.58+242255.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.62325,24.382,0.094,NULL,59506856823,929794637,14528041,18.5),(123344,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123344,37.18,0.46,273,55285,70,NULL,NULL,'2MASX J14422959+5636035',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,220.6235,56.60092,0.029,NULL,57258734795,894667731,13979183,17),(123345,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123345,37.88,0.46,376,55286,70,NULL,NULL,'2MASX J14422978+0754044',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,220.624125,7.90117,0.041,NULL,59365978769,927593418,14493647,18.6),(123346,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123346,34.3,NULL,72.5,55287,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09484',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',0.000111,NULL,'16.8g',0.15,'Scd',NULL,NULL,NULL,NULL,1,220.633,42.47578,0,NULL,59958121096,936845642,14638213,16.8),(123347,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123347,34.32,NULL,73.1,55287,NULL,NULL,'Dipole + Quadrupole','UGC 09484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123348,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123348,34.33,NULL,73.5,55287,NULL,NULL,'Dipole','UGC 09484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123349,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123349,34.38,NULL,75.1,55287,NULL,NULL,NULL,'UGC 09484',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123350,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123350,37.18,0.46,272,55288,70,NULL,NULL,'2MASX J14423199+2659097',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.36',0.22,NULL,NULL,NULL,NULL,NULL,1,220.63325,26.98606,0.03,NULL,60026099000,937907796,14654809,17.36),(123351,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123351,37.62,0.46,334,55289,70,NULL,NULL,'2MASX J14423212+0427224',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000088,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.63375,4.45606,0.125,NULL,58258403103,910287548,14223242,16.7),(123352,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123352,35.25,0.8,112,55290,75,NULL,'CF, r','UGC 09479',NULL,'1997ApJS..109..333W',1997,1,1.54,NULL,'G',0.00008,NULL,'14.9g',0.41,'Sb',NULL,NULL,NULL,NULL,1,220.636,4.43044,0.125,NULL,58258400254,910287503,14223242,14.9),(123353,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123353,34.84,0.49,92.8,55290,75,NULL,'IR','UGC 09479',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123354,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123354,34.97,0.38,98.5,55290,75,NULL,'CF, r, raw','UGC 09479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123355,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123355,35.11,0.38,105,55290,75,NULL,'CF, r, inv','UGC 09479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123356,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123356,35.23,0.38,111,55290,75,NULL,'CF, r, cor','UGC 09479',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123357,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123357,37.76,0.46,356,55291,70,NULL,NULL,'2MASX J14423268+2018223',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.15,NULL,NULL,NULL,NULL,NULL,1,220.636167,20.30628,0,NULL,59500735386,929698990,14526546,18.27),(123358,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123358,38,0.46,399,55292,70,NULL,NULL,'2MASX J14423301+3417144',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,220.637583333,34.28742,0,NULL,60066933389,938545834,14664778,17.1),(123359,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123359,33.78,0.47,56.9,55293,NULL,NULL,'H','NGC 5735',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.000023,NULL,'13.10',1.9,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.6385,28.72644,0,NULL,60027264975,937926015,14655093,13.1),(123360,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123360,33.86,0.46,59.1,55293,NULL,NULL,'J','NGC 5735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123361,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123361,33.86,0.45,59.2,55293,NULL,NULL,'K','NGC 5735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123362,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123362,33.87,0.4,59.4,55293,NULL,NULL,'mean','NGC 5735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123363,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123363,38.08,0.46,413,55294,70,NULL,NULL,'2MASX J14423387+3626391',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.6410417,36.44414,0,NULL,60068074084,938563657,14665057,17.4),(123364,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123364,34.68,0.46,86.3,55295,70,NULL,NULL,'IC 4492',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000198,NULL,'15.2g',0.51,'E',NULL,NULL,NULL,NULL,1,220.641125,37.45233,0,NULL,60075371152,938677674,14666838,15.2),(123365,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123365,36.24,0.46,177,55296,70,NULL,NULL,'CGCG 164-014',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000143,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,220.647375,28.65533,0,NULL,60027293624,937926462,14655100,15.7),(123366,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123366,37.1,0.46,262,55297,70,NULL,NULL,'2MASX J14423540+0319024',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.6475417,3.31736,0.089,NULL,58256719794,910261246,14222831,17.5),(123367,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123367,38.34,0.46,465,55298,70,NULL,NULL,'2MASX J14423625+2446097',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.6512083,24.7695,0.077,NULL,59506901047,929795328,14528052,17.7),(123368,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123368,36.01,0.33,159,55299,70,NULL,NULL,'2MASX J14423794+2417437',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.6580417,24.29553,0.081,NULL,59507600552,929806258,14528222,16.1),(123369,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123369,38.14,0.15,425,55300,70,NULL,NULL,'2MASX J14423808+2221454',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.6587917,22.36264,0.073,NULL,59508277445,929816835,14528388,18),(123370,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123370,37.41,0.46,303,55301,70,NULL,NULL,'2MASX J14423828+3010344',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000199,NULL,'17.00',0.21,NULL,NULL,NULL,NULL,NULL,1,220.659333,30.17617,0,NULL,60019898191,937810909,14653295,17),(123371,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123371,35.31,0.47,116,55302,NULL,NULL,'H','ESO 386- G 012',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'15',0.7,'Sb             HII',NULL,NULL,NULL,NULL,1,220.661125,-35.0755,0.273,NULL,47221932831,737842700,11528792,15),(123372,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123372,35.37,0.45,119,55302,NULL,NULL,'K','ESO 386- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123373,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123373,35.38,0.4,119,55302,NULL,NULL,'mean','ESO 386- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123374,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123374,35.44,0.46,122,55302,NULL,NULL,'J','ESO 386- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123375,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123375,36.68,0.46,217,55303,70,NULL,NULL,'2MASX J14424152+1007430',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.20',0.2,NULL,NULL,NULL,NULL,NULL,1,220.672917,10.12878,0.033,NULL,59374525536,927726961,14495733,16.2),(123376,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123376,37.77,0.46,358,55304,70,NULL,NULL,'2MASX J14424211+1550419',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.675583,15.84497,0.009,NULL,59553899965,930529686,14539526,17.9),(123377,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123377,35.79,0.46,144,55305,70,NULL,NULL,'2MASX J14424260+0119114',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000094,NULL,'16.0g',0.41,'BLAGN          LINER',NULL,NULL,NULL,'Sy 1',1,220.677625,1.31975,0.117,NULL,58262118020,910345594,14224149,16),(123378,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123378,37.44,0.46,307,55306,70,NULL,NULL,'2MASX J14424302+1849584',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.92',0.11,NULL,NULL,NULL,NULL,NULL,1,220.679416667,18.83297,0.061,NULL,59529816330,930153380,14533646,18.92),(123379,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123379,37.77,0.46,359,55307,70,NULL,NULL,'2MASX J14424325+2237184',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,220.680458333,22.62181,0.073,NULL,59508390222,929818597,14528415,17.9),(123380,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123380,36.37,0.33,188,55308,70,NULL,NULL,'2MASX J14424414+1449579',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.41',0.14,NULL,NULL,NULL,NULL,NULL,1,220.684,14.83267,0.005,NULL,59558768956,930605764,14540715,18.41),(123381,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123381,32.07,NULL,25.9,55309,72,NULL,NULL,'NGC 5733',NULL,'2014Ap.....57..457K',2014,1,1.19,NULL,'G',0.000052,NULL,'14.5g',0.36,'Irr(f)         HII',NULL,NULL,NULL,NULL,1,220.691375,-0.35108,0.093,NULL,43494196215,679596815,10618700,14.5),(123382,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123382,35.73,0.19,140,55310,70,NULL,NULL,'CGCG 076-003',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'15.1g',0.53,NULL,'Group member',NULL,NULL,NULL,1,220.693333,8.72558,0.041,NULL,59365378056,927584032,14493500,15.1),(123383,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123383,36.03,0.46,161,55311,70,NULL,NULL,'MCG +10-21-027',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000107,NULL,'15.0g',0.55,'E0',NULL,NULL,NULL,NULL,1,220.6937917,61.71247,0.021,NULL,57757677432,902463709,14100995,15),(123384,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123384,32.57,0.2,32.7,55312,74.4,NULL,NULL,'ESO 512- G 016',NULL,'2013AJ....146...86T',2013,1,1.9,'The 2MASS position applies to a superposed star.','G',0.000027,NULL,'15.69',0.3,'S',NULL,NULL,NULL,NULL,1,220.695083,-24.21031,0.365,NULL,46537827802,727153559,11361774,15.69),(123385,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123385,32.85,0.58,37.1,55312,NULL,NULL,NULL,'ESO 512- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123386,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123386,33.01,0.54,39.9,55312,NULL,NULL,'Malmquist cor.','ESO 512- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123387,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123387,32.79,NULL,36.1,55313,72,NULL,NULL,'UGC 09482',NULL,'2014Ap.....57..457K',2014,1,1.34,NULL,'G',0.000031,NULL,'15.60',0.17,'Sd(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.695625,0.66175,0.129,NULL,58262641193,910353768,14224277,15.6),(123388,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123388,32.97,0.43,39.3,55313,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09482',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123389,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123389,33.29,NULL,45.6,55313,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09482',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123390,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123390,33.31,NULL,45.9,55313,NULL,NULL,'Dipole + Quadrupole','UGC 09482',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123391,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123391,33.32,NULL,46.1,55313,NULL,NULL,'Dipole','UGC 09482',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123392,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123392,36.88,0.23,237,55314,70,NULL,NULL,'2MASX J14424754+1022200',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.6979583,10.37225,0.009,NULL,59374413339,927725208,14495706,17.4),(123393,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123393,38.11,0.46,418,55315,70,NULL,NULL,'2MASX J14424777+2846257',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.6989583,28.77394,0,NULL,60027273126,937926142,14655095,17.6),(123394,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123394,34.34,0.55,73.8,55316,70,NULL,NULL,'ESO 580- G 011',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00005,NULL,'14.99',0.5,'(R)SA(l)0^+',NULL,NULL,NULL,NULL,1,220.700167,-19.89769,0.353,NULL,46528302287,727004723,11359448,14.99),(123395,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123395,35.33,0.59,116,55317,70,NULL,NULL,'2MASX J14424829-3634465',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.4I',0.5,'SB(r)0/a',NULL,NULL,NULL,NULL,1,220.701167,-36.57956,0.225,NULL,47224073054,737876141,11529314,13.4),(123396,'BL Lac Luminosity','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123396,39.45,NULL,667,55318,NULL,NULL,NULL,'SDSS J144248.28+120040.3',0.163058,'2005ApJ...635..173S',2005,1,NULL,'87GB source with large sky, narrow minor axis, or very bad confusion.','QSO',0.000187,NULL,'17.3g',NULL,'BrClG          BLLAC',NULL,NULL,NULL,'BL Lac',1,220.701167,12.01119,0.013,NULL,59371466935,927679170,14494987,17.3),(123397,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123397,37.55,0.71,324,55319,70,NULL,NULL,'2MASX J14424843-4224210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,220.7017917,-42.40589,0.345,NULL,47089759149,735777486,11496523,15.9),(123398,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123398,34.9,0.33,95.6,55320,70,NULL,NULL,'CGCG 048-003',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000156,NULL,'15.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,220.702083,6.65675,0.065,NULL,59362237687,927534963,14492733,15.4),(123399,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123399,38.35,0.19,467,55321,70,NULL,NULL,'2MASX J14424847+5501550',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,220.702083,55.03208,0,NULL,57246313126,894473642,13976150,16.8),(123400,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123400,38.35,0.19,467,55322,70,NULL,NULL,'2MASX J14424859+5511130',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.702667,55.18697,0,NULL,57246758329,894480598,13976259,17.3),(123401,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123401,34.57,0.65,82.1,55323,NULL,NULL,NULL,'ESO 327- G 012',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'13.56',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,220.7037083,-40.59997,0.089,NULL,47087209586,735737649,11495900,13.56),(123402,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123402,34.58,0.65,82.5,55323,NULL,NULL,'Malmquist cor.','ESO 327- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123403,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123403,34.61,0.2,83.6,55323,74.4,NULL,NULL,'ESO 327- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123404,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123404,36.37,0.33,188,55324,70,NULL,NULL,'2MASX J14424973+1451039',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.19',0.17,NULL,NULL,NULL,NULL,NULL,1,220.707167,14.85097,0.009,NULL,59558767590,930605743,14540714,18.19),(123405,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123405,38.35,0.19,467,55325,70,NULL,NULL,'2MASX J14425255+5507360',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.71925,55.12664,0,NULL,57246293291,894473332,13976145,17.6),(123406,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123406,37.18,0.33,273,55326,70,NULL,NULL,'2MASX J14425293+2252579',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,220.720667,22.88267,0.078,NULL,59508650154,929822658,14528479,16.4),(123407,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123407,38.01,0.17,400,55327,70,NULL,NULL,'2MASX J14425310+2009159',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.72125,20.15442,0.031,NULL,59500746636,929699166,14526549,17.9),(123408,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123408,38.35,0.19,467,55328,70,NULL,NULL,'2MASX J14425374+5516200',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000144,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.724208333,55.27211,0,NULL,57246617410,894478397,13976224,17.5),(123409,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123409,36.53,0.68,202,55329,70,NULL,NULL,'2MASX J14425415-1749154',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,220.725667,-17.82097,0.349,NULL,46679391449,729365491,11396335,14.2),(123410,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123410,38.41,0.46,481,55330,70,NULL,NULL,'2MASX J14425463+3615466',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.727583,36.26289,0,NULL,60068122916,938564420,14665069,17.6),(123411,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123411,38.01,0.17,400,55331,70,NULL,NULL,'2MASX J14425480+2011269',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.728333,20.19078,0.031,NULL,59500776398,929699631,14526556,17.8),(123412,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123412,35.64,0.46,134,55332,70,NULL,NULL,'2MASX J14425567+0109044',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000061,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.731875,1.15111,0.117,NULL,58262226502,910347289,14224176,16.5),(123413,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123413,34.9,0.33,95.6,55333,70,NULL,NULL,'CGCG 048-006',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.00008,NULL,'15.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,220.7332083,6.72183,0.069,NULL,59362189952,927534218,14492722,15.1),(123414,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123414,32.7,0.5,34.7,55334,70,NULL,NULL,'NGC 5726',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000067,NULL,'14.17',1,'S0- pec sp',NULL,NULL,NULL,NULL,1,220.7335417,-18.44489,0.329,NULL,46695223230,729612862,11400200,14.17),(123415,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123415,37.37,0.46,298,55335,70,NULL,NULL,'2MASX J14425640+1134260',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000159,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.735083333,11.57394,0.009,NULL,59371600553,927681258,14495019,16.7),(123416,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123416,36.59,0.46,208,55336,70,NULL,NULL,'CGCG 134-021',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000073,NULL,'15.3g',0.48,NULL,NULL,NULL,NULL,NULL,1,220.736417,25.0165,0.066,NULL,59493109328,929579833,14524684,15.3),(123417,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123417,36.99,0.46,250,55337,70,NULL,NULL,'2MASX J14425716+1738119',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.45',0.26,NULL,NULL,NULL,NULL,NULL,1,220.73825,17.63669,0.028,NULL,59551616945,930494014,14538968,17.45),(123418,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123418,37.8,0.46,363,55338,70,NULL,NULL,'2MASX J14425718+0917170',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,220.738375,9.28806,0.041,NULL,59370911514,927670492,14494851,16.7),(123419,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123419,38.07,0.46,412,55339,70,NULL,NULL,'2MASX J14425737+3121484',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.7390417,31.36339,0,NULL,60016933104,937764579,14652571,17.2),(123420,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123420,37.56,0.46,324,55340,70,NULL,NULL,'2MASX J14425748+0713220',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.739583,7.22286,0.065,NULL,59362989351,927546708,14492917,17.6),(123421,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123421,36.59,0.2,208,55341,74.4,NULL,NULL,'UGC 09487',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'15.33',0.4,'Sab','Isolated galaxy',NULL,NULL,NULL,1,220.74025,21.42061,0.031,NULL,59503701212,929745331,14527270,15.33),(123422,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123422,32.1,0.8,26.3,55342,75,NULL,'A82, H','IC 1048',NULL,'1997ApJS..109..333W',1997,1,2.2,'HOLM 670B is a star.','G',0.00002,NULL,'13.6B',0.7,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.741667,4.88947,0.077,NULL,58255149299,910236707,14222448,13.6),(123423,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123423,31.77,0.4,22.6,55342,NULL,NULL,'Virgo cluster at 15.6 Mpc','IC 1048',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123424,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123424,32.08,0.4,26.1,55342,75,NULL,NULL,'IC 1048',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123425,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123425,32.19,0.4,27.4,55342,NULL,NULL,'mean','IC 1048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123426,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123426,32.2,0.4,27.6,55342,75,NULL,'B','IC 1048',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123427,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123427,32.28,0.47,28.6,55342,75,NULL,'A82, H, raw','IC 1048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123428,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123428,32.33,0.47,29.2,55342,75,NULL,'A82, H, inv','IC 1048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123429,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123429,32.34,NULL,29.4,55342,72,NULL,NULL,'IC 1048',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123430,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123430,32.39,0.47,30.1,55342,75,NULL,'A82, H, cor','IC 1048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123431,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123431,32.43,0.47,30.6,55342,NULL,NULL,'Malmquist cor.','IC 1048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123432,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123432,32.48,0.47,31.4,55342,NULL,NULL,'H','IC 1048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123433,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123433,32.5,0.46,31.7,55342,NULL,NULL,'J','IC 1048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123434,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123434,32.55,0.45,32.4,55342,NULL,NULL,'K','IC 1048',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123435,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123435,32.63,0.49,33.5,55342,75,NULL,'IR','IC 1048',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123436,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123436,32.73,0.41,35.2,55342,NULL,NULL,NULL,'IC 1048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123437,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123437,32.77,0.2,35.8,55342,74.4,NULL,NULL,'IC 1048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123438,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123438,38.01,0.17,400,55343,70,NULL,NULL,'2MASX J14425963+2013059',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.72',0.19,'BrClG',NULL,NULL,NULL,NULL,1,220.7485417,20.21825,0.042,NULL,59500776694,929699635,14526556,17.72),(123439,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123439,37.66,0.46,340,55344,70,NULL,NULL,'2MASX J14430056+2558181',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.14,NULL,NULL,NULL,NULL,NULL,1,220.752375,25.97175,0.056,NULL,60025810090,937903282,14654738,18.68),(123440,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123440,37.84,0.46,370,55345,70,NULL,NULL,'2MASX J14430083+2429471',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.7535417,24.49639,0.087,NULL,59506824372,929794130,14528033,17.5),(123441,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123441,32.48,NULL,31.3,55346,72,NULL,NULL,'UGC 09485',NULL,'2014Ap.....57..457K',2014,1,1.4,NULL,'G',0.000023,NULL,'14.9B',0.4,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,220.7617917,4.76567,0.085,NULL,58255065777,910235402,14222428,14.9),(123442,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123442,38.35,0.19,467,55347,70,NULL,NULL,'2MASX J14430282+5507559',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000214,NULL,'17.4g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,220.762,55.13231,0,NULL,57246292666,894473322,13976145,17.4),(123443,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123443,37.4,0.46,302,55348,70,NULL,NULL,'2MASX J14430291+4441233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.762333,44.68972,0.017,NULL,59956457447,936819647,14637806,17.2),(123444,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123444,38.28,0.46,453,55349,70,NULL,NULL,'2MASX J14430353+2057589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.76475,20.96625,0,NULL,59504434729,929756792,14527449,17.8),(123445,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123445,37.18,0.46,273,55350,70,NULL,NULL,'2MASX J14430456+0501329',NULL,'2015arXiv151105856S',2015,1,0.32,'Star superposed 7\\\" southeast of the galaxy. HOLM 671B is a star.','G',0.000113,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.768917,5.02567,0.077,NULL,58255625756,910244152,14222564,16.6),(123446,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123446,38.09,0.46,415,55351,70,NULL,NULL,'2MASX J14430551+3644357',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000175,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.773125,36.74331,0,NULL,60075905339,938686020,14666969,18.3),(123447,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123447,37.62,0.46,334,55352,70,NULL,NULL,'SDSS J144305.92+095932.7',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.774667,9.99244,0.033,NULL,59374344447,927724131,14495689,17.4),(123448,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123448,36.01,0.33,159,55353,70,NULL,NULL,'2MASX J14430737+2412411',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.780625,24.21133,0.081,NULL,59507593628,929806150,14528221,17.2),(123449,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123449,36.32,0.46,184,55354,70,NULL,NULL,'2MASX J14430756+2342589',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.781541667,23.71653,0.057,NULL,59507365411,929802584,14528165,16.7),(123450,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123450,38.01,0.17,400,55355,70,NULL,NULL,'2MASX J14430787+2011199',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.41',0.13,NULL,NULL,NULL,NULL,NULL,1,220.782917,20.18892,0.042,NULL,59500774106,929699595,14526556,18.41),(123451,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123451,34.78,0.46,90.3,55356,70,NULL,NULL,'ESO 386- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000067,NULL,'15',0.7,'S0',NULL,NULL,NULL,NULL,1,220.7832083,-36.48914,0.229,NULL,47224063385,737875990,11529312,15),(123452,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123452,38.14,0.46,424,55357,70,NULL,NULL,'2MASX J14430834+2929431',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'18.05',0.17,'E',NULL,NULL,NULL,NULL,1,220.78475,29.49525,0,NULL,60019094218,937798347,14653099,18.05),(123453,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123453,37.18,0.33,273,55358,70,NULL,NULL,'2MASX J14430878+2252359',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.786583,22.87667,0.078,NULL,59508601421,929821897,14528467,17.5),(123454,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123454,37.68,0.46,344,55359,70,NULL,NULL,'2MASX J14430951+1326256',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.91',0.14,NULL,NULL,NULL,NULL,NULL,1,220.7897083,13.44036,0.005,NULL,59558021238,930594081,14540532,18.91),(123455,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123455,36.04,0.46,162,55360,70,NULL,NULL,'2MASX J14431112+4637283',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,220.796291667,46.62467,0.025,NULL,59987736264,937308379,14645443,16.7),(123456,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123456,34.87,0.69,94.4,55361,100,NULL,'mid-IR','NGC 5737',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'14.28',0.8,'SBb',NULL,NULL,NULL,NULL,1,220.79925,18.87994,0.061,NULL,59529778201,930152784,14533637,14.28),(123457,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123457,35.57,0.2,130,55361,74.4,NULL,NULL,'NGC 5737',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123458,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123458,35.66,0.47,136,55361,NULL,NULL,'H','NGC 5737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123459,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123459,35.77,0.4,143,55361,NULL,NULL,'mean','NGC 5737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123460,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123460,35.8,0.45,145,55361,NULL,NULL,'K','NGC 5737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123461,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123461,35.81,0.46,145,55361,NULL,NULL,'J','NGC 5737',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123462,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123462,36.58,0.46,207,55362,70,NULL,NULL,'2MASX J14431174+5925198',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000071,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.799167,59.42236,0,NULL,57768468666,902632322,14103630,16.9),(123463,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123463,37.71,0.46,348,55363,70,NULL,NULL,'2MASX J14431229+2540251',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.80125,25.67361,0.037,NULL,60014353377,937724271,14651941,17.3),(123464,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123464,37.27,0.46,285,55364,70,NULL,NULL,'2MASX J14431388+1357266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.41',0.12,NULL,NULL,NULL,NULL,NULL,1,220.807833333,13.95739,0,NULL,59558465969,930601030,14540641,18.41),(123465,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123465,37.32,0.46,291,55365,70,NULL,NULL,'2MASX J14431471+1156246',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.8112917,11.94017,0.013,NULL,59371457996,927679031,14494984,17.1),(123466,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123466,38.47,0.46,494,55366,70,NULL,NULL,'2MASX J14431595+3125274',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.816417,31.42411,0,NULL,60088024772,938875387,14669927,17.9),(123467,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123467,37.79,0.33,362,55367,70,NULL,NULL,'2MASX J14431715+5029443',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000171,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,220.821417,50.49583,0.049,NULL,59199644793,924994449,14453038,16.8),(123468,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123468,36.97,0.79,248,55368,70,NULL,NULL,'2MASX J14431809-1808243',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,220.8254583,-18.14008,0.321,NULL,46678531768,729352058,11396125,14.5),(123469,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123469,36.3,0.46,182,55369,70,NULL,NULL,'CGCG 134-022',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.0001,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,220.827958333,20.78625,0,NULL,59504149528,929752336,14527380,15.7),(123470,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123470,37.86,0.46,373,55370,70,NULL,NULL,'2MASX J14431913+0327049',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000095,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.829667,3.45125,0.077,NULL,58256081406,910251271,14222676,17),(123471,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123471,37.5,0.46,316,55371,70,NULL,NULL,'2MASX J14432069+1301266',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00021,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.836333333,13.02419,0.005,NULL,59557143979,930580374,14540318,16.9),(123472,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123472,37.79,0.46,362,55372,70,NULL,NULL,'2MASX J14432104+4651393',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,220.837541667,46.86089,0.017,NULL,59987628337,937306692,14645417,17.4),(123473,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123473,37.59,0.46,329,55373,70,NULL,NULL,'2MASX J14432198+1453526',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,220.841583,14.89797,0,NULL,59558786585,930606040,14540719,NULL),(123474,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123474,38.54,0.46,510,55374,70,NULL,NULL,'2MASX J14432225+5755235',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.842583333,57.92314,0,NULL,57723762883,901933795,14092715,18),(123475,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123475,35.57,0.66,130,55375,70,NULL,NULL,'2MASX J14432242-1732029',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,220.8434583,-17.53414,0.365,NULL,46678869351,729357333,11396208,14.2),(123476,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123476,37.86,0.46,374,55376,70,NULL,NULL,'SDSS J144323.21+080839.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.846708333,8.14439,0.049,NULL,59366017082,927594016,14493656,18.3),(123477,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123477,37.66,0.46,341,55377,70,NULL,NULL,'SDSS J144323.51+220806.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.848,22.13517,0.059,NULL,59506184725,929784136,14527877,18.1),(123478,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123478,37.81,0.33,366,55378,70,NULL,NULL,'SDSS J144323.75+290253.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.849,29.04811,0,NULL,60019026480,937797288,14653082,18.5),(123479,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123479,37.88,0.46,376,55379,70,NULL,NULL,'2MASX J14432454+2245293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.852208333,22.75819,0.054,NULL,59508328413,929817631,14528400,16.6),(123480,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123480,36.51,0.46,201,55380,70,NULL,NULL,'2MASX J14432455+0739269',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,220.85225,7.65736,0.041,NULL,59362320671,927536260,14492754,16.5),(123481,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123481,37.14,0.46,267,55381,70,NULL,NULL,'2MASX J14432460+0321209',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,220.852417,3.35581,0.077,NULL,58256165119,910252579,14222696,17.1),(123482,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123482,38.19,0.46,435,55382,70,NULL,NULL,'2MASX J14432463+2825110',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.852625,28.41975,0,NULL,60027132517,937923945,14655061,18),(123483,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123483,37.33,0.46,292,55383,70,NULL,NULL,'2MASX J14432473+5113373',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.852958333,51.22711,0.033,NULL,59203869558,925060461,14454069,17.6),(123484,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123484,36.37,0.46,188,55384,70,NULL,NULL,'MCG +09-24-032',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000196,NULL,'15.4g',0.54,'S0',NULL,NULL,NULL,NULL,1,220.853125,52.61453,0,NULL,59192899446,924889053,14451391,15.4),(123485,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123485,35.73,0.19,140,55385,70,NULL,NULL,'2MASX J14432505+0840479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.854417,8.68,0.029,NULL,59365284384,927582568,14493477,16.7),(123486,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123486,37.79,0.33,362,55386,70,NULL,NULL,'2MASX J14432532+5029353',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,220.8555,50.49306,0.061,NULL,59199645248,924994457,14453038,16.4),(123487,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123487,37.39,0.46,300,55387,70,NULL,NULL,'VII Zw 561',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,220.85675,57.43217,0,NULL,57723254203,901925846,14092591,16.9),(123488,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123488,34.91,0.46,96.1,55388,70,NULL,NULL,'CGCG 048-008',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000103,NULL,'14.7g',0.64,'E0',NULL,NULL,NULL,NULL,1,220.856917,4.37908,0.069,NULL,58258531076,910289548,14223274,14.7),(123489,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123489,37,0.46,252,55389,70,NULL,NULL,'2MASX J14432600+3508534',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,220.858333,35.14817,0,NULL,60068426631,938569166,14665143,16.5),(123490,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123490,37.5,1.06,316,55390,70,NULL,NULL,'ESO 580- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.75',1,'SB(r)bc',NULL,NULL,NULL,NULL,1,220.866667,-17.87397,0.349,NULL,46679339542,729364680,11396323,15.75),(123491,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123491,36.21,0.46,174,55391,70,NULL,NULL,'2MASX J14432822+0347009',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000101,NULL,'16.0g',0.34,'NLAGN',NULL,NULL,NULL,NULL,1,220.8675,3.78369,0.069,NULL,58256523835,910258184,14222784,16),(123492,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123492,38.01,0.17,400,55392,70,NULL,NULL,'SDSS J144330.18+200453.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.87575,20.08161,0.031,NULL,59500867651,929701057,14526579,18.5),(123493,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123493,36.85,0.33,235,55393,70,NULL,NULL,'2MASX J14433035+3135573',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000181,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,220.876625,31.59942,0,NULL,60088055889,938875873,14669935,15.9),(123494,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123494,37.46,0.46,311,55394,70,NULL,NULL,'2MASX J14433095+0543029',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.878875,5.71744,0.069,NULL,58254904904,910232889,14222388,17.8),(123495,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123495,36.88,0.23,237,55395,70,NULL,NULL,'2MASX J14433164+1020509',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,220.8817917,10.34767,0.049,NULL,59374322570,927723790,14495684,17.2),(123496,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123496,37.81,0.33,366,55396,70,NULL,NULL,'2MASX J14433238+2858320',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.21,'S0',NULL,NULL,NULL,NULL,1,220.884916667,28.97561,0,NULL,60019022872,937797232,14653081,17.6),(123497,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123497,36.22,0.46,175,55397,70,NULL,NULL,'SDSS J144333.30+201856.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.92',0.17,NULL,NULL,NULL,NULL,NULL,1,220.888791667,20.31569,0.042,NULL,59500759679,929699369,14526552,17.92),(123498,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123498,36.43,0.27,194,55398,70,NULL,NULL,'2MASX J14433343+1514502',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,220.8892083,15.24742,0.021,NULL,59555423262,930553488,14539898,17.97),(123499,'D-Sigma','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123499,32.75,0.4,35.5,55399,75,NULL,'Edat, raw','ESO 512- G 018',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000067,NULL,'12.95',1.5,'SAB0^0^: pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,220.891375,-24.46089,0.385,NULL,46536919113,727139361,11361552,12.95),(123500,'D-Sigma','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123500,32.86,0.4,37.3,55399,75,NULL,'Edat, cor','ESO 512- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123501,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123501,33.02,0.45,40.1,55399,NULL,NULL,'K','ESO 512- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123502,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123502,33.48,0.4,49.6,55399,NULL,NULL,'mean','ESO 512- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123503,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123503,35.23,0.48,111,55400,70,NULL,NULL,'MCG -01-38-001',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.88',0.2,NULL,NULL,NULL,NULL,NULL,1,220.90225,-5.17608,0.153,NULL,43495920752,679623761,10619121,14.88),(123504,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123504,37.75,0.46,355,55401,70,NULL,NULL,'2MASX J14433859+3559265',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,220.910917,35.99053,0,NULL,60068614308,938572098,14665189,17.7),(123505,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123505,38.3,0.46,458,55402,70,NULL,NULL,'SDSS J144338.94+194335.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,220.9122917,19.72661,0.077,NULL,59500799797,929699996,14526562,NULL),(123506,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123506,35.73,0.19,140,55403,70,NULL,NULL,'2MASX J14433896+0833506',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,220.912375,8.56411,0.057,NULL,59365326641,927583228,14493487,16.2),(123507,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123507,35.3,NULL,115,55404,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09490',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000016,NULL,'15.48',0.16,'Scd','in a triple',NULL,NULL,NULL,1,220.9142083,11.13931,0,NULL,59372143453,927689741,14495152,15.48),(123508,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123508,35.31,NULL,115,55404,NULL,NULL,'Dipole + Quadrupole','UGC 09490',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123509,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123509,35.32,NULL,116,55404,NULL,NULL,'Dipole','UGC 09490',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123510,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123510,35.35,NULL,117,55404,NULL,NULL,NULL,'UGC 09490',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123511,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123511,37.73,0.46,352,55405,70,NULL,NULL,'2MASX J14434022+1335203',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.54',0.13,NULL,NULL,NULL,NULL,NULL,1,220.9175,13.58897,0,NULL,59557481451,930585647,14540400,18.54),(123512,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123512,38.49,0.46,499,55406,70,NULL,NULL,'SDSS J144341.54+470313.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,220.923125,47.05369,0.021,NULL,59987661504,937307211,14645425,18.3),(123513,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123513,35.06,0.2,103,55407,74.4,NULL,NULL,'CGCG 134-023',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.000007,NULL,'14.8g',0.48,'Sa',NULL,NULL,NULL,NULL,1,220.9237917,23.01872,0.03,NULL,59507922388,929811287,14528301,14.8),(123514,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123514,36.93,0.46,243,55408,70,NULL,NULL,'2MASX J14434245+5644136',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000181,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,220.92725,56.73725,0.029,NULL,57258577334,894665270,13979144,16),(123515,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123515,37.28,0.46,286,55409,70,NULL,NULL,'2MASX J14434271+4416024',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,220.927875,44.26739,0.025,NULL,59955678257,936807472,14637616,16.5),(123516,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123516,32.89,NULL,37.9,55410,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1809',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000023,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,220.93,79.76778,0.085,NULL,57175296632,893364009,13958812,16.6),(123517,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123517,32.92,NULL,38.4,55410,NULL,NULL,'Dipole + Quadrupole','FGC 1809',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123518,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123518,32.95,NULL,38.9,55410,NULL,NULL,'Dipole','FGC 1809',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123519,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123519,33.02,NULL,40.3,55410,NULL,NULL,NULL,'FGC 1809',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123520,'SGRB','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123520,42.89,NULL,3780,55411,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 060805A',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,220.931166667,12.5865,0.009,NULL,59548673974,930448030,14538250,NULL),(123521,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123521,37.56,0.33,326,55412,70,NULL,NULL,'2MASX J14434452+4832593',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,220.9357083,48.54986,0.101,NULL,59935890146,936498283,14632785,16.5),(123522,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123522,37.56,0.33,326,55413,70,NULL,NULL,'2MASX J14434531+4829563',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.9385417,48.49881,0.101,NULL,59935884373,936498193,14632784,17.3),(123523,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123523,37.82,0.27,366,55414,70,NULL,NULL,'SDSS J144345.28+221728.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.938667,22.29128,0.051,NULL,59506419137,929787799,14527934,18.5),(123524,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123524,38.57,0.33,517,55415,70,NULL,NULL,'2MASX J14434627+2807519',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.942791667,28.13119,0.031,NULL,60027579315,937930926,14655170,17.7),(123525,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123525,36.77,0.46,226,55416,70,NULL,NULL,'2MASX J14434707+2726539',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.27',0.24,'Sbrst(PHOT)',NULL,NULL,NULL,NULL,1,220.946375,27.44839,0.043,NULL,60028075975,937938687,14655291,17.27),(123526,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123526,38.27,0.46,452,55417,70,NULL,NULL,'SDSS J144348.84+224350.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000149,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.9535417,22.73078,0.054,NULL,59506298503,929785914,14527904,18.5),(123527,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123527,33.47,0.8,49.5,55418,75,NULL,'CF, r','NGC 5751',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'13.8g',0.8,'Scd:','Field galaxy',NULL,NULL,NULL,1,220.954917,53.40067,0,NULL,59193338295,924895910,14451498,13.8),(123528,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123528,32.93,0.38,38.5,55418,75,NULL,'CF, r, raw','NGC 5751',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123529,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123529,32.97,0.38,39.2,55418,75,NULL,'CF, r, inv','NGC 5751',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123530,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123530,33.05,0.38,40.7,55418,75,NULL,'CF, r, cor','NGC 5751',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123531,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123531,33.58,0.47,52,55418,NULL,NULL,'H','NGC 5751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123532,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123532,33.6,0.4,52.6,55418,NULL,NULL,'mean','NGC 5751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123533,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123533,33.72,0.46,55.5,55418,NULL,NULL,'J','NGC 5751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123534,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123534,33.8,0.45,57.5,55418,NULL,NULL,'K','NGC 5751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123535,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123535,37.31,0.46,289,55419,70,NULL,NULL,'2MASX J14434992+2241182',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,220.958083333,22.68847,0.054,NULL,59506297864,929785904,14527904,17.7),(123536,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123536,35.09,0.53,104,55420,70,NULL,NULL,'AM 1440-365 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000087,NULL,'13.2I',0.6,NULL,NULL,NULL,NULL,NULL,1,220.960333333,-37.07008,0.253,NULL,47224713404,737886146,11529471,13.2),(123537,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123537,37.55,0.46,323,55421,70,NULL,NULL,'SDSS J144351.09+321257.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000159,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,220.962917,32.21603,0,NULL,60088482025,938882531,14670039,18.7),(123538,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123538,36.88,0.23,237,55422,70,NULL,NULL,'SDSS J144351.63+102018.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,220.965167,10.33856,0.049,NULL,59374210897,927722045,14495656,17.7),(123539,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123539,36.95,0.46,245,55423,70,NULL,NULL,'2MASX J14435229+2541399',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000184,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,220.967833,25.69439,0.064,NULL,60014374231,937724597,14651946,15.9),(123540,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123540,38.57,0.33,517,55424,70,NULL,NULL,'2MASX J14435292+2808069',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.9705,28.13542,0.031,NULL,60027622562,937931602,14655181,17.7),(123541,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123541,38.14,0.46,425,55425,70,NULL,NULL,'2MASX J14435418+1941202',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,220.975875,19.68894,0.077,NULL,59500803333,929700052,14526563,17.6),(123542,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123542,35.44,0.46,122,55426,70,NULL,NULL,'IC 4496',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000093,NULL,'14.6g',0.69,NULL,NULL,NULL,NULL,NULL,1,220.977416667,33.40656,0,NULL,60122177201,939409018,14678265,14.6),(123543,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123543,34.84,0.46,92.7,55427,70,NULL,NULL,'CGCG 220-051',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000157,NULL,'14.8g',0.33,'Sb','Isolated galaxy',NULL,NULL,NULL,1,220.977833,43.58061,0.043,NULL,59957664023,936838500,14638101,14.8),(123544,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123544,37.55,0.46,324,55428,70,NULL,NULL,'2MASX J14435656+3351056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,220.9857083,33.85169,0,NULL,60121885149,939404455,14678194,17.4),(123545,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123545,36.85,0.33,235,55429,70,NULL,NULL,'2MASX J14435660+3128136',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000185,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,220.9859583,31.47047,0,NULL,60088082526,938876289,14669942,15.8),(123546,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123546,39.17,0.46,681,55430,70,NULL,NULL,'SDSS J144356.65+073659.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,220.986083,7.6165,0.061,NULL,59362350412,927536725,14492761,18.6),(123547,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123547,37.5,0.46,316,55431,70,NULL,NULL,'2MASX J14435680+2024122',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'17.94',0.09,NULL,NULL,NULL,NULL,NULL,1,220.986708333,20.40356,0.042,NULL,59504279670,929754369,14527412,17.94),(123548,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123548,37.66,0.33,340,55432,70,NULL,NULL,'SDSS J144357.82+425026.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,220.991,42.84069,0.015,NULL,59958226991,936847296,14638239,18.5),(123549,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123549,38.49,0.27,499,55433,70,NULL,NULL,'2MASX J14435799+1755462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,220.9915417,17.92956,0.04,NULL,59551318311,930489348,14538896,17.8),(123550,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123550,37.12,0.46,265,55434,70,NULL,NULL,'2MASX J14435912+5557596',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000171,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,220.9965,55.96653,0.009,NULL,57245289734,894457652,13975900,16.4),(123551,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123551,37.76,0.46,356,55435,70,NULL,NULL,'2MASX J14435995+5439146',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,220.999833,54.65403,0,NULL,59191608302,924868879,14451076,17.5),(123552,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123552,37.66,0.33,340,55436,70,NULL,NULL,'2MASX J14440003+4250375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.000083,42.84369,0.015,NULL,59958219783,936847184,14638237,17.3),(123553,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123553,36,0.46,158,55437,70,NULL,NULL,'2MASX J14440012+2337522',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000204,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,221.000541667,23.63108,0.043,NULL,59507248446,929800756,14528136,15.5),(123554,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123554,38.32,0.46,460,55438,70,NULL,NULL,'SDSS J144401.68+164027.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.007041667,16.67422,0.005,NULL,59554318160,930536221,14539628,18.4),(123555,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123555,35.08,0.49,104,55439,75,NULL,'IR','ESO 386- G 016',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000023,NULL,'16.46',0.17,'Sb',NULL,NULL,NULL,NULL,1,221.0077917,-36.13594,0.237,NULL,47222482831,737851294,11528926,16.46),(123556,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123556,35.21,NULL,110,55439,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 386- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123557,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123557,35.23,NULL,111,55439,NULL,NULL,'Dipole','ESO 386- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123558,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123558,35.23,NULL,111,55439,NULL,NULL,'Dipole + Quadrupole','ESO 386- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123559,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123559,35.54,0.43,128,55439,75,NULL,'3.6 micron, color + selection bias corrected','ESO 386- G 016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123560,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123560,37.92,0.46,384,55440,70,NULL,NULL,'2MASX J14440342+2552068',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.0142917,25.86869,0.056,NULL,60014384073,937724751,14651949,17.8),(123561,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123561,38.38,0.46,474,55441,70,NULL,NULL,'2MASX J14440345+1929322',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.014375,19.49233,0.066,NULL,59529890424,930154537,14533664,17.8),(123562,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123562,38.49,0.27,499,55442,70,NULL,NULL,'SDSS J144403.49+175537.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.014583,17.92697,0.035,NULL,59551318395,930489349,14538896,18.5),(123563,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123563,37.89,0.46,379,55443,70,NULL,NULL,'2MASX J14440428+1913142',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.19',0.1,NULL,NULL,NULL,NULL,NULL,1,221.017917,19.22067,0.066,NULL,59529929315,930155145,14533674,19.19),(123564,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123564,37.84,0.46,370,55444,70,NULL,NULL,'2MASX J14440508+3400166',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.021167,34.00483,0,NULL,60121926787,939405106,14678204,17.4),(123565,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123565,37.79,0.46,362,55445,70,NULL,NULL,'2MASX J14440707+4701375',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00018,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,221.0295417,47.027,0.017,NULL,59987612578,937306446,14645413,16.3),(123566,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123566,38.18,0.46,433,55446,70,NULL,NULL,'2MASX J14440728+5530155',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000136,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.030625,55.50419,0.005,NULL,57247103546,894485992,13976343,17.5),(123567,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123567,37.37,0.46,298,55447,70,NULL,NULL,'SDSS J144407.59+094939.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000173,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.031667,9.82767,0.033,NULL,59373855742,927716495,14495570,18),(123568,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123568,35.73,0.19,140,55448,70,NULL,NULL,'2MASX J14440930+0838401',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'15.6g',0.39,NULL,NULL,NULL,NULL,NULL,1,221.038667,8.6445,0.077,NULL,59363397674,927553088,14493017,15.6),(123569,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123569,38.06,0.46,409,55449,70,NULL,NULL,'2MASX J14440956+3521216',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000193,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.04,35.35614,0,NULL,60068406705,938568854,14665138,17.3),(123570,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123570,36.6,0.46,209,55450,70,NULL,NULL,'2MASX J14441032+1507135',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.14',0.17,NULL,NULL,NULL,NULL,NULL,1,221.043083,15.12031,0,NULL,59555291784,930551434,14539866,18.14),(123571,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123571,38.01,0.17,400,55451,70,NULL,NULL,'SDSS J144410.49+201420.7',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.04375,20.23911,0.042,NULL,59500897614,929701525,14526586,16.8),(123572,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123572,36.97,0.46,248,55452,70,NULL,NULL,'SDSS J144410.78+282423.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000151,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.0449583,28.40642,0,NULL,60027601566,937931274,14655176,18.3),(123573,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123573,36.5,0.46,200,55453,70,NULL,NULL,'IC 1051',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000177,NULL,'15.4',0.7,NULL,NULL,NULL,NULL,NULL,1,221.0482917,19.02022,0.076,NULL,59530009713,930156401,14533693,15.4),(123574,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123574,37.59,0.46,330,55454,70,NULL,NULL,'2MASX J14441234+0346508',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.0515,3.78092,0.069,NULL,58258018583,910281540,14223149,17.5),(123575,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123575,37.23,0.71,279,55455,70,NULL,NULL,'2MASX J14441271-2914081',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,221.053,-29.23556,0.529,NULL,47019629353,734681708,11479401,14.8),(123576,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123576,38.13,0.46,423,55456,70,NULL,NULL,'2MASX J14441317+4604423',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.0549583,46.0785,0,NULL,59990863488,937357242,14646206,17),(123577,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123577,38.67,0.46,542,55457,70,NULL,NULL,'2MASX J14441322+2745478',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.37',0.14,NULL,NULL,NULL,NULL,NULL,1,221.055083,27.76344,0.04,NULL,60027495646,937929619,14655150,18.37),(123578,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123578,36.43,0.27,194,55458,70,NULL,NULL,'SDSS J144413.57+152308.5',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.6g',0.42,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.056583,15.38572,0.013,NULL,59555410531,930553289,14539895,15.6),(123579,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123579,38.49,0.27,499,55459,70,NULL,NULL,'2MASX J14441368+1759485',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.0569583,17.99692,0.091,NULL,59585200913,931018764,14547168,17.9),(123580,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123580,35.79,0.2,144,55460,74.4,NULL,NULL,'IC 1052',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00003,NULL,'15.33',0.3,'SBcd?',NULL,NULL,NULL,NULL,1,221.058791667,20.614,0.034,NULL,59504316174,929754940,14527420,15.33),(123581,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123581,36.88,0.23,237,55461,70,NULL,NULL,'2MASX J14441461+1024401',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000204,NULL,'15.7g',0.42,NULL,NULL,NULL,NULL,NULL,1,221.060958333,10.41122,0.041,NULL,59374246635,927722603,14495665,15.7),(123582,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123582,34.97,0.2,98.6,55462,74.4,NULL,NULL,'CGCG 134-026',NULL,'2013AJ....146...86T',2013,1,1.14,NULL,'G',0.000112,NULL,'15.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,221.0615,22.74772,0.054,NULL,59506428450,929787944,14527936,15.4),(123583,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123583,37.5,0.46,316,55463,70,NULL,NULL,'2MASX J14441561+0234288',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.065,2.57475,0.101,NULL,58263771167,910371424,14224553,17.8),(123584,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123584,36.47,0.46,197,55464,70,NULL,NULL,'2MASX J14441656+5706179',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.069,57.10492,0,NULL,57250156939,894533702,13977089,16.5),(123585,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123585,37.82,0.27,366,55465,70,NULL,NULL,'2MASX J14441733+2221301',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.0722083,22.3585,0.061,NULL,59506367057,929786985,14527921,17.7),(123586,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123586,37.86,0.46,373,55466,70,NULL,NULL,'2MASX J14441757+4609214',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.0732083,46.15619,0,NULL,59990778041,937355906,14646186,18.2),(123587,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123587,37.79,0.46,362,55467,70,NULL,NULL,'SDSS J144418.79+093710.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.078333,9.61964,0.029,NULL,59371051813,927672684,14494885,18),(123588,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123588,37.63,0.46,335,55468,70,NULL,NULL,'2MASX J14441936+0330488',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.08075,3.51367,0.061,NULL,58256099209,910251550,14222680,17.1),(123589,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123589,36.66,0.46,215,55469,70,NULL,NULL,'2MASX J14441956+1101381',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000214,NULL,'16.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.0814583,11.02711,0,NULL,59372202885,927690670,14495166,16.1),(123590,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123590,36.7,0.46,219,55470,70,NULL,NULL,'2MASX J14442003+2257554',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.083583,22.96553,0.05,NULL,59507871887,929810498,14528289,16.8),(123591,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123591,37.65,0.46,339,55471,70,NULL,NULL,'SDSS J144422.06+313945.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.091917,31.66253,0,NULL,60088027600,938875431,14669928,18.6),(123592,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123592,36.62,0.46,211,55472,70,NULL,NULL,'2MASX J14442273+0905461',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000158,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,221.09475,9.096,0.037,NULL,59363514437,927554913,14493045,16.6),(123593,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123593,37.82,0.27,366,55473,70,NULL,NULL,'2MASX J14442297+2223324',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000157,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.095833,22.39228,0.061,NULL,59506336796,929786512,14527914,17),(123594,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123594,37.57,0.33,327,55474,70,NULL,NULL,'2MASX J14442405+0443288',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.10025,4.72461,0.089,NULL,58255355222,910239925,14222498,18),(123595,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123595,31.97,0.8,24.8,55475,75,NULL,'A82, H','NGC 5740',NULL,'1997ApJS..109..333W',1997,1,2.55,'The APM position is northwest of the nucleus.','G',0.000018,NULL,'12.8g',0.94,'SAB(rs)b       NLAGN','Pair member (points to parent)',NULL,NULL,NULL,1,221.101875,1.67978,0.133,NULL,58263346268,910364785,14224449,12.8),(123596,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123596,32.07,0.8,25.9,55475,75,NULL,'CF, r','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123597,'Sosies','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123597,32.42,0.17,30.5,55475,NULL,NULL,NULL,'NGC 5740',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123598,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123598,32.02,NULL,25.4,55475,NULL,NULL,'B','NGC 5740',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123599,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123599,32.13,0.4,26.6,55475,75,NULL,'B','NGC 5740',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123600,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123600,32.15,0.47,27,55475,75,NULL,'A82, H, raw','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123601,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123601,32.26,0.4,28.4,55475,NULL,NULL,'mean','NGC 5740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123602,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123602,32.27,0.38,28.4,55475,NULL,NULL,NULL,'NGC 5740',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123603,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123603,32.27,0.47,28.5,55475,75,NULL,'A82, H, inv','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123604,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123604,32.31,0.47,29,55475,75,NULL,'A82, H, cor','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123605,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123605,32.31,NULL,29,55475,72,NULL,NULL,'NGC 5740',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123606,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123606,32.41,0.47,30.3,55475,NULL,NULL,'H','NGC 5740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123607,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123607,32.46,0.45,31,55475,NULL,NULL,'K','NGC 5740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123608,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123608,32.46,0.46,31.1,55475,NULL,NULL,'J','NGC 5740',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123609,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123609,32.49,0.38,31.5,55475,75,NULL,'CF, r, raw','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123610,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123610,32.53,0.38,32,55475,75,NULL,'CF, r, cor','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123611,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123611,32.62,0.38,33.4,55475,75,NULL,'CF, r, inv','NGC 5740',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123612,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123612,37.09,0.46,262,55476,70,NULL,NULL,'SDSS J144425.58+193701.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.106583,19.61706,0.068,NULL,59530361422,930161897,14533779,17.1),(123613,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123613,38.17,0.46,430,55477,70,NULL,NULL,'SDSS J144426.09+114554.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.1087083,11.76522,0.025,NULL,59367349403,927614834,14493981,18.4),(123614,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123614,36.65,0.46,214,55478,70,NULL,NULL,'2MASX J14442672+5604219',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000167,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,221.1114583,56.07283,0.013,NULL,57245257208,894457143,13975892,16.2),(123615,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123615,36.43,0.27,194,55479,70,NULL,NULL,'CGCG 105-014',NULL,'2015arXiv151105856S',2015,1,0.6,'This may possibly be IC 4494, but that is more likely CGCG 105-013.','G',0.00019,NULL,'15.5',0.6,NULL,'Group member',NULL,NULL,NULL,1,221.1125,15.48092,0.005,NULL,59555400138,930553127,14539892,15.5),(123616,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123616,32.44,0.8,30.7,55480,75,NULL,NULL,'ESO 222- G 015',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00002,NULL,'14.2',0.7,'Scd?;s.p.br.* on blg',NULL,NULL,NULL,NULL,1,221.113375,-49.39978,NULL,NULL,47053432893,735209888,11487654,14.2),(123617,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123617,37.35,0.46,295,55481,70,NULL,NULL,'2MASX J14442896-0258338',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.120583,-2.97628,0.205,NULL,43499603137,679681299,10620020,17),(123618,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123618,36.2,0.46,174,55482,70,NULL,NULL,'2MASX J14442906+5624319',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.1212917,56.40897,0.017,NULL,57245003273,894453176,13975830,16.3),(123619,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123619,37.64,0.46,337,55483,70,NULL,NULL,'2MASX J14442926+1324424',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.122,13.41189,0,NULL,59557477613,930585587,14540399,18),(123620,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123620,36.85,0.46,235,55484,70,NULL,NULL,'2MASX J14443008+3607166',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.125375,36.12131,0,NULL,60068633306,938572395,14665193,17.7),(123621,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123621,36.25,0.46,178,55485,70,NULL,NULL,'2MASX J14443128+1928115',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000073,NULL,'16.19',0.33,NULL,NULL,NULL,NULL,NULL,1,221.130583,19.46978,0.066,NULL,59530616007,930165875,14533841,16.19),(123622,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123622,37.89,0.46,378,55486,70,NULL,NULL,'2MASX J14443205+1225454',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.1335,12.42939,0.009,NULL,59548874090,930451157,14538299,18.2),(123623,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123623,36.6,0.46,209,55487,70,NULL,NULL,'2MASX J14443251+0335098',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000066,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.1354583,3.58606,0.069,NULL,58257997056,910281204,14223143,16.7),(123624,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123624,36.84,0.46,233,55488,70,NULL,NULL,'2MASX J14443332+2027035',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.92',0.24,NULL,NULL,NULL,NULL,NULL,1,221.138833,20.45094,0.059,NULL,59504115169,929751799,14527371,16.92),(123625,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123625,38.51,0.46,504,55489,70,NULL,NULL,'2MASX J14443514+2619465',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.146583,26.32964,0.058,NULL,60014852160,937732065,14652063,17.7),(123626,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123626,36.85,0.46,234,55490,70,NULL,NULL,'2MASX J14443524+2115565',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.15',0.18,NULL,NULL,NULL,NULL,NULL,1,221.146833,21.26589,0.043,NULL,59502244833,929722575,14526915,18.15),(123627,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123627,37.19,0.46,274,55491,70,NULL,NULL,'SDSS J144435.43+223535.1',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.147666667,22.59311,0.061,NULL,59506483646,929788806,14527950,16.8),(123628,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123628,37.52,0.46,320,55492,70,NULL,NULL,'2MASX J14443838+0420048',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,221.159833,4.33469,0.081,NULL,58258676153,910291814,14223309,17),(123629,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123629,37.63,0.46,335,55493,70,NULL,NULL,'2MASX J14443870+3022113',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000191,NULL,'18.45',0.13,NULL,NULL,NULL,NULL,NULL,1,221.161208333,30.36978,0,NULL,60018676196,937791815,14652997,18.45),(123630,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123630,37.68,0.46,343,55494,70,NULL,NULL,'2MASX J14443888+3725049',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.1619583,37.418,0,NULL,60075446888,938678857,14666857,17.2),(123631,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123631,36.77,0.46,226,55495,70,NULL,NULL,'2MASX J14444027+2419516',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000182,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,221.167917,24.33106,0.094,NULL,59493460790,929585324,14524770,16),(123632,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123632,38.57,0.46,519,55496,70,NULL,NULL,'SDSS J144441.51+192704.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.173,19.45117,0.068,NULL,59530668320,930166692,14533854,18.4),(123633,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123633,35.86,0.46,149,55497,70,NULL,NULL,'LCRS B144208.2-023644',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.183333,-2.82294,0.205,NULL,43499638371,679681849,10620028,16.8),(123634,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123634,37.06,0.46,258,55498,70,NULL,NULL,'SDSS J144447.32+013723.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000093,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.197167,1.62328,0.133,NULL,58266759266,910418113,14225283,17.8),(123635,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123635,37.57,0.33,327,55499,70,NULL,NULL,'2MASX J14444761+0446038',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.198417,4.76772,0.093,NULL,58255394576,910240540,14222508,17),(123636,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123636,37.57,0.46,326,55500,70,NULL,NULL,'2MASX J14444929+2930266',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.9g',0.24,'S0',NULL,NULL,NULL,NULL,1,221.205458333,29.50731,0,NULL,60019431674,937803619,14653181,16.9),(123637,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123637,34.2,0.54,69.3,55501,70,NULL,NULL,'ESO 222- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000087,NULL,'14.8b',0.6,'(R)SAB0^+',NULL,NULL,NULL,NULL,1,221.2064583,-48.35994,0.925,NULL,47055183440,735237241,11488081,14.8),(123638,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123638,37.5,0.46,316,55502,70,NULL,NULL,'2MASX J14445020+4433344',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.209041667,44.55972,0.021,NULL,59955555205,936805550,14637586,17.8),(123639,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123639,38.28,0.33,452,55503,70,NULL,NULL,'SDSS J144450.55+333520.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.210625,33.58889,0,NULL,60121970586,939405790,14678215,18),(123640,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123640,38.28,0.33,452,55504,70,NULL,NULL,'SDSS J144451.09+333639.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.212917,33.61103,0,NULL,60121969888,939405779,14678215,18.1),(123641,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123641,37.8,0.46,362,55505,70,NULL,NULL,'2MASX J14445110+2358466',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.213125,23.97981,0.101,NULL,59507441747,929803777,14528184,17.9),(123642,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123642,37.19,0.46,274,55506,70,NULL,NULL,'2MASX J14445130+5723339',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.213625,57.39278,0,NULL,57723317473,901926835,14092606,18.2),(123643,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123643,36.65,0.46,213,55507,70,NULL,NULL,'2MASX J14445221+2448336',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.217625,24.80944,0.109,NULL,59493253237,929582081,14524720,16.6),(123644,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123644,38.26,0.33,449,55508,70,NULL,NULL,'SDSS J144454.18+461332.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.225833,46.22564,0.005,NULL,59990785807,937356028,14646187,18.5),(123645,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123645,37.48,0.46,313,55509,70,NULL,NULL,'2MASX J14445466+0625292',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.22775,6.42478,0.101,NULL,59379018608,927797165,14496830,16.8),(123646,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123646,32.16,0.8,27.1,55510,75,NULL,'A82, H','NGC 5746',NULL,'1997ApJS..109..333W',1997,1,7.4,NULL,'G',0.000033,NULL,'11.29',1.3,'SAB(rs)b? sp','Pair member (points to parent)',NULL,NULL,NULL,1,221.233,1.955,0.117,NULL,58266897460,910420272,14225316,11.29),(123647,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123647,32.34,0.8,29.4,55510,75,NULL,'B','NGC 5746',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123648,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123648,31.96,0.35,24.7,55510,NULL,NULL,NULL,'NGC 5746',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123649,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123649,32.12,0.32,26.5,55510,NULL,NULL,'Malmquist cor.','NGC 5746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123650,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123650,32.31,0.3,29,55510,NULL,NULL,NULL,'NGC 5746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123651,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123651,32.31,NULL,29,55510,72,NULL,NULL,'NGC 5746',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123652,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123652,32.33,0.2,29.2,55510,74.4,NULL,NULL,'NGC 5746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123653,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123653,32.38,0.47,29.9,55510,75,NULL,'A82, H, raw','NGC 5746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123654,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123654,32.47,0.47,31.1,55510,75,NULL,'A82, H, cor','NGC 5746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123655,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123655,32.49,0.43,31.5,55510,75,NULL,'3.6 micron, color corrected','NGC 5746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123656,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123656,32.69,0.47,34.6,55510,75,NULL,'A82, H, inv','NGC 5746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123657,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123657,32.7,0.43,34.7,55510,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123658,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123658,36.76,0.46,225,55511,70,NULL,NULL,'2MASX J14445625-0128487',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.234333,-1.48028,0.153,NULL,43501491683,679710807,10620481,17.3),(123659,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123659,36.23,0.68,176,55512,70,NULL,NULL,'2MASX J14445626-1547103',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.40',NULL,NULL,NULL,NULL,NULL,NULL,1,221.2345,-15.78625,0.357,NULL,46679892408,729373318,11396458,16.4),(123660,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123660,37.98,0.46,395,55513,70,NULL,NULL,'2MASX J14445671+2721086',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.13,NULL,NULL,NULL,NULL,NULL,1,221.236208333,27.35242,0.044,NULL,60027343547,937927242,14655113,18.42),(123661,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123661,38.09,0.46,415,55514,70,NULL,NULL,'2MASX J14445724+1932533',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.2385417,19.54811,0.068,NULL,59530617368,930165896,14533842,17),(123662,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123662,37.63,0.46,336,55515,70,NULL,NULL,'2MASX J14445796+2740452',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.40',0.14,NULL,NULL,NULL,NULL,NULL,1,221.241375,27.67925,0.04,NULL,60027531137,937930174,14655158,18.4),(123663,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123663,34.49,0.49,79.2,55516,75,NULL,'IR','UGC 09502',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000088,NULL,'16.3g',0.17,'Scd',NULL,NULL,NULL,NULL,1,221.247167,40.87572,0.012,NULL,59951639918,936744373,14636630,16.3),(123664,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123664,36.68,0.46,217,55517,70,NULL,NULL,'2MASX J14445950+0928152',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000199,NULL,'15.6g',0.51,NULL,NULL,NULL,NULL,NULL,1,221.247917,9.47097,0.029,NULL,59371148992,927674203,14494909,15.6),(123665,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123665,35.01,0.46,100,55518,70,NULL,NULL,'IC 4498',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00016,NULL,'15.25',0.5,'S0?',NULL,NULL,NULL,NULL,1,221.253291667,26.30114,0.067,NULL,60014840163,937731877,14652060,15.25),(123666,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123666,37.97,0.46,393,55519,70,NULL,NULL,'2MASX J14450188+2215183',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.2579583,22.25525,0.052,NULL,59506261857,929785341,14527895,18),(123667,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123667,37.48,0.46,313,55520,70,NULL,NULL,'2MASX J14450324+1024281',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000192,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.263416667,10.40781,0.029,NULL,59374265687,927722901,14495670,17.2),(123668,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123668,36.99,0.46,250,55521,70,NULL,NULL,'2MASX J14450359+0635471',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000181,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.2647917,6.59661,0.093,NULL,59378935853,927795872,14496810,16.7),(123669,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123669,36.43,0.64,193,55522,70,NULL,NULL,'2MASX J14450376-3616047',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,221.265667,-36.26808,0.237,NULL,47221767108,737840111,11528751,14.5),(123670,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123670,35.14,0.2,107,55523,74.4,NULL,NULL,'SDSS J144503.96+163211.4',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000012,NULL,'16.94',0.2,NULL,NULL,NULL,NULL,NULL,1,221.266541667,16.53653,0.005,NULL,59553210259,930518910,14539357,16.94),(123671,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123671,37.14,0.46,267,55524,70,NULL,NULL,'2MASX J14450492+5648180',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.270667,56.80508,0.025,NULL,57244968314,894452629,13975822,17.1),(123672,'BL Lac Luminosity','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123672,41.11,NULL,1670,55525,70,NULL,'nucleus-to-host flux ratio, z > 0.51','WISE J144506.24-032612.5',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'17.2',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,221.27625,-3.43678,0.249,NULL,43498101012,679657828,10619653,17.2),(123673,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123673,37.5,0.46,317,55526,70,NULL,NULL,'2MASX J14450644+5559380',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000205,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.276875,55.994,0.005,NULL,57245262732,894457230,13975894,16.5),(123674,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123674,35.55,0.46,129,55527,70,NULL,NULL,'ARK 458',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000203,NULL,'15.3',0.25,NULL,NULL,NULL,NULL,NULL,1,221.283791667,19.43161,0.074,NULL,59530671554,930166743,14533855,15.3),(123675,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123675,37.34,0.46,294,55528,70,NULL,NULL,'2MASX J14450843-0203376',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.2850417,-2.06053,0.125,NULL,43502656619,679729009,10620765,17.7),(123676,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123676,35.2,0.46,109,55529,70,NULL,NULL,'CGCG 076-016',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000077,NULL,'14.9g',0.62,NULL,NULL,NULL,NULL,NULL,1,221.290667,9.27467,0.029,NULL,59371011325,927672051,14494875,14.9),(123677,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123677,37.05,0.23,257,55530,70,NULL,NULL,'2MASX J14451057+0351386',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.294125,3.86069,0.109,NULL,58258799200,910293737,14223339,16.6),(123678,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123678,37.05,0.23,257,55531,70,NULL,NULL,'2MASX J14451057+0350456',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.294167,3.84589,0.109,NULL,58258786198,910293534,14223336,17.2),(123679,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123679,39.36,0.46,746,55532,70,NULL,NULL,'2MASX J14451117+5605290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.296667,56.09153,0.005,NULL,57245742904,894464732,13976011,18.5),(123680,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123680,37.25,0.46,282,55533,70,NULL,NULL,'2MASX J14451471+2204293',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,221.311167,22.07481,0.052,NULL,59506239597,929784993,14527890,16.6),(123681,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123681,35.24,0.46,112,55534,70,NULL,NULL,'CGCG 048-014',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000091,NULL,'15.5g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,221.318125,3.404,0.085,NULL,58257875481,910279304,14223114,15.5),(123682,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123682,36.5,0.84,200,55535,70,NULL,NULL,'2MASX J14451652-3808255',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.7I',0.2,NULL,NULL,NULL,NULL,NULL,1,221.3189583,-38.14036,0.329,NULL,47216640944,737760014,11527500,14.7),(123683,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123683,37.84,0.46,370,55536,70,NULL,NULL,'2MASX J14451692+0345466',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.320375,3.76283,0.073,NULL,58257931374,910280177,14223127,17.4),(123684,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123684,37.72,0.46,350,55537,70,NULL,NULL,'SDSS J144518.42+271733.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.3267917,27.29267,0.058,NULL,60027317515,937926836,14655106,18.1),(123685,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123685,37.1,0.33,263,55538,70,NULL,NULL,'2MASX J14451856+3216328',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000188,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.327125,32.27575,0,NULL,60088485172,938882580,14670040,16.8),(123686,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123686,38.01,0.46,400,55539,70,NULL,NULL,'2MASX J14451940+4705118',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.3310417,47.08675,0.021,NULL,59987673430,937307397,14645428,17.5),(123687,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123687,37.05,0.23,257,55540,70,NULL,NULL,'2MASX J14451946+0349406',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.331208333,3.82792,0.109,NULL,58258790509,910293601,14223337,16.7),(123688,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123688,37.8,0.33,364,55541,70,NULL,NULL,'2MASX J14451994+3204019',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.333208333,32.06708,0,NULL,60088625007,938884765,14670074,17.2),(123689,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123689,35.15,0.46,107,55542,70,NULL,NULL,'2MASX J14452050+3637566',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'15.3g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,221.335291667,36.63256,0,NULL,60075199465,938674991,14666796,15.3),(123690,'GRB','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123690,43.9,0.23,3270,55543,NULL,NULL,NULL,'GRB 060814',0.84,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,221.338708333,20.58631,0.06,NULL,59504124395,929751943,14527374,NULL),(123691,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123691,32.27,0.8,28.4,55544,75,NULL,NULL,'UGC 09500',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000013,NULL,'15.12',2.8,'Sm:',NULL,NULL,NULL,NULL,1,221.339583,7.86278,0.057,NULL,59365703829,927589122,14493580,15.12),(123692,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123692,31.41,NULL,19.1,55544,72,NULL,NULL,'UGC 09500',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123693,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123693,37.02,0.46,254,55545,70,NULL,NULL,'2MASX J14452270+1400198',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.50',0.16,NULL,NULL,NULL,NULL,NULL,1,221.344625,14.0055,0.013,NULL,59558386107,930599782,14540621,18.5),(123694,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123694,37.36,0.46,296,55546,70,NULL,NULL,'2MASX J14452286+1208288',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,221.345375,12.14125,0.029,NULL,59367407944,927615749,14493996,16.3),(123695,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123695,37.47,0.46,312,55547,70,NULL,NULL,'LCRS B144248.4-023436',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.3504583,-2.78664,0.193,NULL,43499418782,679678418,10619975,17.7),(123696,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123696,37.8,0.33,364,55548,70,NULL,NULL,'2MASX J14452475+3159179',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.35325,31.98831,0,NULL,60088406526,938881351,14670021,17.4),(123697,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123697,38.02,0.46,402,55549,70,NULL,NULL,'2MASX J14452572+0951121',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.357166667,9.85333,0.025,NULL,59371219429,927675303,14494926,17.7),(123698,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123698,36.94,0.46,244,55550,70,NULL,NULL,'2MASX J14452607+4605428',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.358833,46.09517,0,NULL,59990805899,937356342,14646192,17),(123699,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123699,37.72,0.46,350,55551,70,NULL,NULL,'2MASX J14452733+0932181',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.364083,9.53842,0.029,NULL,59371096951,927673389,14494896,17.2),(123700,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123700,38.12,0.33,421,55552,70,NULL,NULL,'2MASX J14452757+1639178',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.74',0.13,NULL,NULL,NULL,NULL,NULL,1,221.36475,16.655,0,NULL,59553200021,930518750,14539355,18.74),(123701,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123701,38.14,0.46,425,55553,70,NULL,NULL,'2MASX J14452756+2922231',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.9g',0.32,'S0',NULL,NULL,NULL,NULL,1,221.364917,29.37322,0,NULL,60019268227,937801066,14653141,16.9),(123702,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123702,38.12,0.33,421,55554,70,NULL,NULL,'2MASX J14452806+1638439',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.63',0.15,NULL,NULL,NULL,NULL,NULL,1,221.367125,16.64547,0,NULL,59553200108,930518751,14539355,18.63),(123703,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123703,37.25,0.46,282,55555,70,NULL,NULL,'2MASX J14452843+5107159',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.368417,51.12108,0.061,NULL,59203652580,925057071,14454016,17.7),(123704,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123704,37.65,0.46,338,55556,70,NULL,NULL,'2MASX J14452855+2752181',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.01',0.18,NULL,NULL,NULL,NULL,NULL,1,221.3690417,27.87164,0.042,NULL,60027517985,937929968,14655155,18.01),(123705,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123705,37.05,0.23,257,55557,70,NULL,NULL,'2MASX J14452991+0355262',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000124,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,221.374667,3.92406,0.109,NULL,58258815276,910293988,14223343,16.3),(123706,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123706,38.27,0.46,451,55558,70,NULL,NULL,'2MASX J14453000+6124514',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.374667,61.41425,0.029,NULL,57778652542,902791445,14106116,17.8),(123707,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123707,37.47,0.33,312,55559,70,NULL,NULL,'2MASX J14453040+2244540',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.376625,22.7485,0.051,NULL,59506473331,929788645,14527947,16.5),(123708,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123708,35.94,0.46,154,55560,70,NULL,NULL,'2MASX J14453167+0756440',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.381833,7.94564,0.057,NULL,59365677300,927588707,14493573,16.3),(123709,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123709,36.95,0.46,245,55561,70,NULL,NULL,'2MASX J14453203+4346043',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.383458333,43.76792,0.029,NULL,59957606688,936837604,14638087,17.1),(123710,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123710,37.78,0.46,360,55562,70,NULL,NULL,'SDSS J144532.67+180821.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.386167,18.13936,0.063,NULL,59585252856,931019575,14547180,18.1),(123711,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123711,36.49,0.46,199,55563,70,NULL,NULL,'2MASX J14453370-0205165',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000113,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.390458333,-2.08792,0.169,NULL,43502657663,679729025,10620766,16.7),(123712,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123712,37.3,0.33,289,55564,70,NULL,NULL,'2MASX J14453380+0202232',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.390667,2.03967,0.077,NULL,58266916599,910420571,14225321,17.7),(123713,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123713,37.1,0.33,263,55565,70,NULL,NULL,'2MASX J14453433+3219419',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.392958333,32.3285,0,NULL,60088207493,938878242,14669972,17.4),(123714,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123714,37.63,0.33,335,55566,70,NULL,NULL,'2MASX J14453438+3734207',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.393375,37.57239,0,NULL,60075417514,938678398,14666849,16.9),(123715,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123715,37.63,0.33,335,55567,70,NULL,NULL,'2MASX J14453446+3734547',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.38',0.12,NULL,NULL,NULL,NULL,NULL,1,221.3937083,37.58186,0,NULL,60075417555,938678399,14666849,18.38),(123716,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123716,37.3,0.33,289,55568,70,NULL,NULL,'2MASX J14453587+0203472',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000102,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.399375,2.06317,0.077,NULL,58266915272,910420551,14225321,16.7),(123717,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123717,37.59,0.46,329,55569,70,NULL,NULL,'2MASX J14453680+3418389',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,221.403458333,34.31092,0,NULL,60124583260,939446613,14678853,16.6),(123718,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123718,32.79,0.47,36.2,55570,70,NULL,NULL,'NGC 5742',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000073,NULL,'13.84',0.5,'SB(r)0^0^?',NULL,NULL,NULL,NULL,1,221.403667,-11.80964,0.293,NULL,46463285016,725988828,11343575,13.84),(123719,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123719,37.54,0.46,323,55571,70,NULL,NULL,'2MASX J14453711+2718340',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.40',0.15,NULL,NULL,NULL,NULL,NULL,1,221.404625,27.30953,0.058,NULL,60027365414,937927584,14655118,18.4),(123720,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123720,38.63,0.46,533,55572,70,NULL,NULL,'SDSS J144537.14+274304.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.4047917,27.71786,0.057,NULL,60027557172,937930580,14655165,18.5),(123721,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123721,38.62,0.46,531,55573,70,NULL,NULL,'2MASX J14453794+5013189',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.40825,50.22194,0.045,NULL,59934591949,936477999,14632468,18),(123722,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123722,38.04,0.46,406,55574,70,NULL,NULL,'2MASX J14453814+5151499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.4092083,51.86375,0.037,NULL,59192289066,924879516,14451242,17.3),(123723,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123723,36.75,0.46,224,55575,70,NULL,NULL,'2MASX J14453940+1801180',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.90',0.2,NULL,NULL,NULL,NULL,NULL,1,221.414083,18.02178,0.063,NULL,59585226028,931019156,14547174,17.9),(123724,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123724,37.06,0.46,258,55576,70,NULL,NULL,'2MASX J14454014+5612380',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.4g',0.38,'BrClG          AGN',NULL,NULL,NULL,NULL,1,221.417458333,56.21067,0.013,NULL,57245955926,894468061,13976063,16.4),(123725,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123725,37.61,0.33,332,55577,70,NULL,NULL,'2MASX J14454185+1244110',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.4244583,12.7365,0.013,NULL,59549499617,930460931,14538452,18.2),(123726,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123726,37.54,0.46,322,55578,70,NULL,NULL,'2MASX J14454257+5544500',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.427416667,55.74722,0.005,NULL,57247147590,894486681,13976354,16.9),(123727,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123727,37.08,0.46,260,55579,70,NULL,NULL,'2MASX J14454285-0224405',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.4285417,-2.41119,0.177,NULL,43502992151,679734252,10620847,17.4),(123728,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123728,36.28,0.46,181,55580,70,NULL,NULL,'2MASX J14454284+3628028',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000154,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.4287083,36.46753,0,NULL,60067788805,938559200,14664987,16.5),(123729,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123729,33.52,NULL,50.6,55581,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 580- G 019',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',NULL,'?','17.28',0.1,'Sd',NULL,NULL,NULL,NULL,1,221.43,-22.45806,0.353,NULL,46538912209,727170503,11362039,17.28),(123730,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123730,33.55,NULL,51.3,55581,NULL,NULL,'Dipole + Quadrupole','ESO 580- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123731,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123731,33.58,NULL,52,55581,NULL,NULL,'Dipole','ESO 580- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123732,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123732,33.63,NULL,53.3,55581,NULL,NULL,NULL,'ESO 580- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123733,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123733,37.54,0.46,322,55582,70,NULL,NULL,'SDSS J144544.29+272028.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.434583,27.34128,0.058,NULL,60027366108,937927595,14655118,18.2),(123734,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123734,37.96,0.46,391,55583,70,NULL,NULL,'2MASX J14454491+2433580',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.71',0.13,NULL,NULL,NULL,NULL,NULL,1,221.4370417,24.56622,0.086,NULL,59494067851,929594810,14524918,18.71),(123735,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123735,36.26,0.33,179,55584,70,NULL,NULL,'2MASX J14454512+1405580',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.79',0.14,'AGN',NULL,NULL,NULL,NULL,1,221.4379583,14.09964,0.009,NULL,59558391003,930599859,14540622,18.79),(123736,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123736,35.71,0.2,139,55585,74.4,NULL,NULL,'UGC 09510',NULL,'2013AJ....146...86T',2013,1,1.28,NULL,'G',0.000033,NULL,'15.2g',0.36,'Sbc',NULL,NULL,NULL,NULL,1,221.43875,32.63011,0,NULL,60088242879,938878794,14669981,15.2),(123737,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123737,37.61,0.33,332,55586,70,NULL,NULL,'2MASX J14454691+1256170',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.445583333,12.93808,0.009,NULL,59549535175,930461487,14538460,17.7),(123738,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123738,32.68,0.8,34.3,55587,75,NULL,NULL,'UGCA 393',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',0.000019,NULL,NULL,NULL,'Im',NULL,NULL,NULL,NULL,1,221.4475,-20.79722,0.353,NULL,46530012896,727031451,11359866,NULL),(123739,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123739,38.24,0.46,444,55588,70,NULL,NULL,'SDSS J144547.55+241014.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.448166667,24.17081,0.082,NULL,59493576486,929587132,14524798,18.4),(123740,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123740,37.47,0.33,312,55589,70,NULL,NULL,'2MASX J14455021+2246140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.459333,22.77044,0.051,NULL,59506462480,929788476,14527944,17.4),(123741,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123741,36.26,0.33,179,55590,70,NULL,NULL,'2MASX J14455089+1405050',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.23',0.19,'AGN',NULL,NULL,NULL,NULL,1,221.462,14.08489,0.009,NULL,59558390086,930599845,14540622,17.23),(123742,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123742,32.61,0.8,33.3,55591,75,NULL,'MAT, I','ESO 022- G 003',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000021,NULL,'13.91',1.3,'SA(rs)c',NULL,NULL,NULL,NULL,1,221.462583333,-77.92489,0.429,NULL,44285645882,691963216,10811925,13.91),(123743,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123743,32.68,0.8,34.3,55591,75,NULL,NULL,'ESO 022- G 003',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123744,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123744,32.36,0.32,29.7,55591,85,NULL,'I, raw','ESO 022- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123745,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123745,32.36,0.32,29.7,55591,85,NULL,'I, inv','ESO 022- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123746,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123746,32.62,0.43,33.3,55591,75,NULL,'MAT, I, raw','ESO 022- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123747,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123747,32.66,0.43,34,55591,75,NULL,'MAT, I, inv','ESO 022- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123748,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123748,32.74,0.4,35.3,55591,NULL,NULL,NULL,'ESO 022- G 003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123749,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123749,32.8,0.43,36.3,55591,75,NULL,'MAT, I, cor','ESO 022- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123750,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123750,35.32,0.58,116,55592,70,NULL,NULL,'LCRS B144308.3-114057',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.07',0.3,NULL,NULL,NULL,NULL,NULL,1,221.463375,-11.89217,0.293,NULL,46463386163,725990408,11343600,16.07),(123751,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123751,36.99,0.46,250,55593,70,NULL,NULL,'2MASX J14455222+3048542',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.4675417,30.815,0,NULL,60091273392,938926146,14670721,16.9),(123752,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123752,37.8,0.46,364,55594,70,NULL,NULL,'SDSS J144552.70+201516.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.469625,20.25464,0.068,NULL,59530287930,930160748,14533761,17),(123753,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123753,38.56,0.46,516,55595,70,NULL,NULL,'SDSS J144554.38+095057.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,221.476583,9.84919,0.025,NULL,59371211776,927675184,14494924,18.3),(123754,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123754,36.28,0.2,180,55596,74.4,NULL,NULL,'CGCG 164-021',NULL,'2013AJ....146...86T',2013,1,0.64,'HOLM 675B does not exist (it is probably a plate defect).','G',0.00005,NULL,'15.4g',0.28,'SBc            Sbrst',NULL,NULL,NULL,NULL,1,221.482917,28.52561,0.019,NULL,60027745649,937933525,14655211,15.4),(123755,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123755,38.04,0.46,406,55597,70,NULL,NULL,'2MASX J14455658+0729219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.48575,7.48944,0.061,NULL,59362302887,927535982,14492749,17.1),(123756,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123756,37.46,0.46,310,55598,70,NULL,NULL,'2MASX J14455744+2425430',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.489375,24.42867,0.094,NULL,59493990860,929593607,14524900,17.8),(123757,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123757,37.92,0.46,384,55599,70,NULL,NULL,'2MASX J14455808+3012522',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.491916667,30.21467,0,NULL,60018817623,937794025,14653031,17),(123758,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123758,35.19,0.2,109,55600,74.4,NULL,NULL,'KUG 1443+110',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000047,NULL,'16.0g',0.32,'Spiral',NULL,NULL,NULL,NULL,1,221.49225,10.81986,0.025,NULL,59371956591,927686821,14495106,16),(123759,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123759,38.11,0.46,418,55601,70,NULL,NULL,'2MASX J14460093+1549016',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,221.503833,15.81714,0.025,NULL,59553717959,930526843,14539481,18.5),(123760,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123760,36.52,0.46,201,55602,70,NULL,NULL,'2MASX J14460173+0303582',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.507,3.06608,0.085,NULL,58257310724,910270480,14222976,17.1),(123761,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123761,35.97,0.48,156,55603,70,NULL,NULL,'2MASX J14460201-1318108',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.95',0.4,NULL,NULL,NULL,NULL,NULL,1,221.5082917,-13.30319,0.301,NULL,46684094914,729438983,11397484,15.95),(123762,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123762,37.17,0.46,272,55604,70,NULL,NULL,'SDSS J144603.98-013203.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000046,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,221.516583,-1.53431,0.117,NULL,43502685062,679729454,10620772,18.4),(123763,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123763,31.69,0.43,21.8,55605,75,NULL,'3.6 micron, color + selection bias corrected','ESO 580- G 022',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000017,NULL,'14.46',1.4,'SAB(s)m',NULL,NULL,NULL,NULL,1,221.5217917,-18.02211,0.337,NULL,46696075166,729626174,11400408,14.46),(123764,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123764,34.74,0.46,88.5,55606,70,NULL,NULL,'CGCG 076-020',NULL,'2015arXiv151105856S',2015,1,0.66,'GSC 0911-0106 (mag. 16) superposed 11 arcsec south of nucleus.','G',0.00011,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,221.5219583,8.91561,0.061,NULL,59363969182,927562018,14493156,15.6),(123765,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123765,38.33,0.46,463,55607,70,NULL,NULL,'2MASX J14460776+3557012',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.53225,35.95053,0,NULL,60067852169,938560190,14665002,17.6),(123766,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123766,37.61,0.33,332,55608,70,NULL,NULL,'2MASX J14460937+2950589',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.538917,29.84972,0,NULL,60019368141,937802627,14653166,17.3),(123767,'Ring Diameter','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123767,31.5,0.76,20,55609,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5750',NULL,'1981ApJS...45..541P',1981,1,2.16,'The APM position is 6 arcsec northwest of the nucleus.','G',0.000033,NULL,'12.6g',1.08,'SB(r)0/a;HII?  NLAGN','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,221.546333333,-0.22294,0.105,NULL,43492929179,679577018,10618390,12.6),(123768,'Ring Diameter','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123768,31.5,0.6,20,55609,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5750',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123769,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123769,32.51,0.8,31.8,55609,75,NULL,'B','NGC 5750',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123770,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123770,32.55,0.45,32.4,55609,NULL,NULL,'Malmquist cor.','NGC 5750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123771,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123771,32.55,NULL,32.4,55609,72,NULL,NULL,'NGC 5750',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123772,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123772,32.82,0.4,36.7,55609,NULL,NULL,NULL,'NGC 5750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123773,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123773,32.86,0.2,37.3,55609,74.4,NULL,NULL,'NGC 5750',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123774,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123774,35.42,0.33,121,55610,70,NULL,NULL,'2MASX J14461185+3234583',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000172,NULL,'15.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,221.549458333,32.58286,0,NULL,60088234923,938878670,14669979,15.6),(123775,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123775,37.16,0.46,270,55611,70,NULL,NULL,'2MASX J14461220-0148519',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.5507917,-1.81456,0.153,NULL,43502712108,679729876,10620779,17.2),(123776,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123776,37.06,0.33,258,55612,70,NULL,NULL,'2MASX J14461229+1608056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.2,NULL,NULL,NULL,NULL,NULL,1,221.551083,16.13486,0,NULL,59553861410,930529084,14539516,18.08),(123777,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123777,38.41,0.46,482,55613,70,NULL,NULL,'2MASX J14461236+1617526',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,221.551541667,16.29792,0.017,NULL,59553647613,930525743,14539464,NULL),(123778,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123778,37.99,0.46,396,55614,70,NULL,NULL,'2MASX J14461300+4314213',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.5542917,43.23925,0.029,NULL,59950341261,936724082,14636313,17.8),(123779,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123779,37.04,0.46,255,55615,70,NULL,NULL,'2MASX J14461319+1904078',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.88',0.2,NULL,NULL,NULL,NULL,NULL,1,221.555083,19.06881,0.091,NULL,59530739596,930167806,14533871,17.88),(123780,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123780,35.72,0.46,139,55616,70,NULL,NULL,'CGCG 164-022',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,221.557333,29.96914,0,NULL,60018841396,937794396,14653037,15.6),(123781,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123781,35.75,0.46,141,55617,70,NULL,NULL,'2MASX J14461380+1459056',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,221.5575,14.98481,0,NULL,59555958124,930561845,14540028,18.24),(123782,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123782,36.93,0.46,243,55618,70,NULL,NULL,'2MASX J14461395+2027488',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.14,NULL,NULL,NULL,NULL,NULL,1,221.558333,20.46367,0.075,NULL,59501973101,929718329,14526848,18.56),(123783,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123783,37.61,0.33,332,55619,70,NULL,NULL,'2MASX J14461413+2945099',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.4g',0.22,'E',NULL,NULL,NULL,NULL,1,221.558833333,29.75269,0,NULL,60019372337,937802692,14653167,17.4),(123784,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123784,37.88,0.46,377,55620,70,NULL,NULL,'2MASX J14461454+5150321',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.560583,51.84231,0.045,NULL,59192327997,924880124,14451251,17.9),(123785,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123785,38.33,0.46,462,55621,70,NULL,NULL,'2MASX J14461564+1122095',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.5652917,11.36922,0.025,NULL,59367661716,927619714,14494058,17.8),(123786,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123786,37.98,0.46,395,55622,70,NULL,NULL,'2MASX J14461773+3417413',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.573916667,34.29494,0,NULL,60124810814,939450168,14678908,17),(123787,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123787,37.58,0.46,328,55623,70,NULL,NULL,'2MASX J14461797+1934429',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.574958333,19.57869,0.081,NULL,59530559557,930164993,14533828,17.4),(123788,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123788,38.53,0.46,509,55624,70,NULL,NULL,'2MASX J14461823+2815569',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.5760417,28.26578,0.058,NULL,60027657805,937932153,14655189,18),(123789,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123789,35.23,0.46,111,55625,70,NULL,NULL,'MCG +06-32-098',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000166,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,221.58125,35.62769,0,NULL,60067810226,938559534,14664992,15.4),(123790,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123790,38.48,0.46,496,55626,70,NULL,NULL,'2MASX J14461983+2147019',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.5827083,21.78381,0.042,NULL,59502417578,929725274,14526957,17.6),(123791,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123791,38.01,0.46,399,55627,70,NULL,NULL,'2MASX J14462005+2116579',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,221.583583,21.28269,0.041,NULL,59502462117,929725970,14526968,17.1),(123792,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123792,31.51,NULL,20,55628,72,NULL,NULL,'SDSS J144620.20+044358.4',NULL,'2014Ap.....57..457K',2014,1,0.35,NULL,'G',0.000058,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.584208333,4.73297,0.105,NULL,58255272295,910238629,14222478,17.8),(123793,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123793,36.85,0.46,234,55629,70,NULL,NULL,'2MASX J14462035+4305453',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000179,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.584833,43.09603,0.025,NULL,59950362689,936724417,14636319,16.5),(123794,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123794,38.42,0.46,483,55630,70,NULL,NULL,'2MASX J14462162+3025283',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.590125,30.42456,0,NULL,60089404363,938896943,14670264,17.9),(123795,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123795,35.42,0.33,121,55631,70,NULL,NULL,'UGC 09518',NULL,'2015arXiv151105856S',2015,1,1.27,NULL,'G',0.0001,NULL,'14.0g',0.82,'E',NULL,NULL,NULL,NULL,1,221.590625,32.78022,0,NULL,60121578925,939399670,14678119,14),(123796,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123796,35.48,0.4,125,55631,NULL,NULL,'mean','UGC 09518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123797,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123797,35.9,0.45,151,55631,NULL,NULL,'K','UGC 09518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123798,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123798,37.06,0.33,258,55632,70,NULL,NULL,'2MASX J14462284+1606136',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,221.595083,16.10383,0,NULL,59553872422,930529256,14539519,18.44),(123799,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123799,37.97,0.46,392,55633,70,NULL,NULL,'2MASX J14462377+3214153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000046,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.598916667,32.23769,0,NULL,60088334553,938880227,14670003,17.4),(123800,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123800,37.95,0.46,390,55634,70,NULL,NULL,'2MASX J14462397+5543151',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000191,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.5997083,55.72086,0.005,NULL,57247871365,894497990,13976531,17.6),(123801,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123801,36.86,0.46,235,55635,70,NULL,NULL,'2MASX J14462397+6405191',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000334,NULL,'16.92',0.3,'AGN',NULL,NULL,NULL,NULL,1,221.599917,64.08875,0.021,NULL,57936690512,905260789,14144699,16.92),(123802,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123802,35.51,0.21,127,55636,70,NULL,NULL,'2MASX J14462449+1346076',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'18.12',0.21,NULL,NULL,NULL,NULL,NULL,1,221.601958333,13.76894,0.017,NULL,59549163507,930455679,14538369,18.12),(123803,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123803,37.6,0.46,331,55637,70,NULL,NULL,'2MASX J14462467+4139517',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,221.602917,41.66428,0.014,NULL,59952532591,936758321,14636848,16.4),(123804,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123804,36.84,0.23,234,55638,70,NULL,NULL,'2MASX J14462547+2218135',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'17.12',0.18,NULL,NULL,NULL,NULL,NULL,1,221.606167,22.30369,0.057,NULL,59506520072,929789376,14527959,17.12),(123805,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123805,37.61,0.46,332,55639,70,NULL,NULL,'2MASX J14462556+5446291',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.606625,54.77492,0,NULL,57246227336,894472302,13976129,17.8),(123806,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123806,36.63,0.46,212,55640,70,NULL,NULL,'2MASX J14462612+2351095',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000204,NULL,'15.6g',0.45,NULL,NULL,NULL,NULL,NULL,1,221.6087917,23.85278,0.075,NULL,59493377721,929584026,14524750,15.6),(123807,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123807,37.59,0.46,329,55641,70,NULL,NULL,'2MASX J14462615+0633584',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.609083,6.56642,0.101,NULL,59379760574,927808758,14497011,16.9),(123808,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123808,36.79,0.69,228,55642,70,NULL,NULL,'LCRS B144343.2-124115',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.58',0.3,NULL,NULL,NULL,NULL,NULL,1,221.6122083,-12.89681,0.281,NULL,46684696383,729448380,11397630,15.58),(123809,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123809,35.21,0.21,110,55643,70,NULL,NULL,'ARK 459',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00007,NULL,'14.7g',0.5,'S0','Group member',NULL,NULL,NULL,1,221.615375,11.50736,0.025,NULL,59367656671,927619635,14494056,14.7),(123810,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123810,35.52,0.25,127,55643,74.4,NULL,NULL,'ARK 459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123811,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123811,35.73,0.22,140,55643,70,NULL,NULL,'ARK 459',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123812,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123812,36.57,0.46,206,55644,70,NULL,NULL,'2MASX J14462885+2145205',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.6202083,21.75564,0.042,NULL,59502419449,929725303,14526957,17.5),(123813,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123813,37.36,0.46,297,55645,70,NULL,NULL,'2MASX J14463082+1855005',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.31',0.14,NULL,NULL,NULL,NULL,NULL,1,221.6284583,18.91683,0.078,NULL,59530680452,930166882,14533857,18.31),(123814,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123814,35.15,0.46,107,55646,70,NULL,NULL,'IC 1054',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000073,NULL,'14.4g',0.75,'S0',NULL,NULL,NULL,NULL,1,221.630166667,1.27475,0.109,NULL,58264852955,910388327,14224817,14.4),(123815,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123815,38.1,0.46,417,55647,70,NULL,NULL,'SDSS J144632.29+034643.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.634541667,3.77875,0.093,NULL,58257575540,910274617,14223040,17.9),(123816,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123816,37.84,0.46,370,55648,70,NULL,NULL,'2MASX J14463321+4236383',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.32',0.2,NULL,NULL,NULL,NULL,NULL,1,221.63825,42.61064,0.033,NULL,59951171913,936737061,14636516,17.32),(123817,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123817,36.91,0.46,241,55649,70,NULL,NULL,'2MASX J14463324+0411006',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.638458333,4.18364,0.049,NULL,58258244224,910285066,14223204,17),(123818,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123818,35.48,0.33,124,55650,70,NULL,NULL,'IC 4505',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000113,NULL,'14.4g',0.76,'S0-:',NULL,NULL,NULL,NULL,1,221.639041667,33.40861,0,NULL,60121488949,939398264,14678097,14.4),(123819,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123819,35.7,0.46,138,55651,70,NULL,NULL,'2MASX J14463441-0050578',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'16.0g',0.28,'S0',NULL,NULL,NULL,NULL,1,221.6434583,-0.84956,0.125,NULL,43501620075,679712813,10620512,16),(123820,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123820,38,0.46,399,55652,70,NULL,NULL,'2MASX J14463485+0440246',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000085,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.645167,4.67342,0.105,NULL,58255227241,910237925,14222467,17.7),(123821,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123821,37.77,0.21,358,55653,70,NULL,NULL,'2MASX J14463558+1433440',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,221.648333,14.56214,0.013,NULL,59555655838,930557122,14539955,18.47),(123822,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123822,36.64,0.46,213,55654,70,NULL,NULL,'2MASX J14463563+1919445',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.72',0.21,NULL,NULL,NULL,NULL,NULL,1,221.648417,19.329,0.079,NULL,59530791304,930168614,14533884,17.72),(123823,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123823,37.77,0.46,359,55655,70,NULL,NULL,'2MASX J14463570+0958097',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000209,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,221.648625,9.96939,0.025,NULL,59371196182,927674940,14494920,16.8),(123824,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123824,35.91,0.23,152,55656,70,NULL,NULL,'2MASX J14463605+1055257',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000176,NULL,'15.7g',0.38,NULL,NULL,NULL,NULL,NULL,1,221.650083333,10.92378,0.029,NULL,59367500970,927617202,14494018,15.7),(123825,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123825,35.21,0.21,110,55657,70,NULL,NULL,'2MASX J14463661+1151087',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000163,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.652625,11.85244,0.029,NULL,59368264895,927629138,14494205,16),(123826,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123826,38.49,0.46,499,55658,70,NULL,NULL,'SDSS J144636.81+293603.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.653417,29.60092,0.022,NULL,60019350889,937802357,14653161,18.6),(123827,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123827,35.72,0.46,139,55659,70,NULL,NULL,'IC 4504',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000174,NULL,'15.2g',0.44,NULL,NULL,NULL,NULL,NULL,1,221.654083333,31.69919,0,NULL,60087941693,938874088,14669907,15.2),(123828,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123828,38.25,0.33,447,55660,70,NULL,NULL,'2MASX J14463778+0728107',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.6574583,7.46969,0.077,NULL,59379346922,927802295,14496910,17.2),(123829,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123829,36.89,0.46,239,55661,70,NULL,NULL,'2MASX J14463818+3409001',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.659,34.14989,0,NULL,60124795315,939449926,14678905,17.2),(123830,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123830,36.84,0.23,234,55662,70,NULL,NULL,'2MASX J14463828+2203574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,221.659375,22.06606,0.046,NULL,59505786023,929777906,14527779,17.97),(123831,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123831,35.51,0.21,127,55663,70,NULL,NULL,'CGCG 076-031',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'14.13',0.35,'E','Group member',NULL,NULL,NULL,1,221.662917,13.67628,0.017,NULL,59549220558,930456571,14538383,14.13),(123832,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123832,36.02,0.58,160,55664,70,NULL,NULL,'2MASX J14463914-3817172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,221.6630417,-38.28819,0.285,NULL,47216702814,737760981,11527515,15),(123833,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123833,37.5,0.46,316,55665,70,NULL,NULL,'2MASXi J1446396+461937',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.66525,46.32708,0.005,NULL,59991106086,937361032,14646266,17.9),(123834,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123834,37.7,0.33,346,55666,70,NULL,NULL,'2MASX J14463984+5531490',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000187,NULL,'16.2g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,221.666167,55.53042,0,NULL,57248027118,894500423,13976569,16.2),(123835,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123835,35.48,0.33,124,55667,70,NULL,NULL,'IC 4506',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.0001,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,221.666416667,33.40122,0,NULL,60121541010,939399078,14678110,15.5),(123836,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123836,38.5,0.46,502,55668,70,NULL,NULL,'2MASX J14464012+0927147',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.6670417,9.45403,0.021,NULL,59371281627,927676275,14494941,17.8),(123837,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123837,36.84,0.23,234,55669,70,NULL,NULL,'2MASX J14464015+2206294',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.76',0.26,NULL,NULL,NULL,NULL,NULL,1,221.66725,22.10817,0.046,NULL,59505779993,929777812,14527778,16.76),(123838,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123838,35.06,0.2,103,55670,74.4,NULL,NULL,'UGC 09517',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000033,NULL,'14.8g',0.55,'Sb:',NULL,NULL,NULL,NULL,1,221.669625,12.60508,0.021,NULL,59549612821,930462700,14538479,14.8),(123839,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123839,36.17,0.46,171,55671,70,NULL,NULL,'CGCG 076-029',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000087,NULL,'15.5g',0.43,NULL,NULL,NULL,NULL,NULL,1,221.66975,10.16511,0.029,NULL,59370842807,927669418,14494834,15.5),(123840,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123840,35.91,0.23,152,55672,70,NULL,NULL,'2MASX J14464249+1058538',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000077,NULL,'15.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.676875,10.98178,0.029,NULL,59367544826,927617887,14494029,15.6),(123841,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123841,38.51,0.46,504,55673,70,NULL,NULL,'SDSS J144643.04+344209.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.679333,34.70275,0,NULL,60123743548,939433492,14678648,18.3),(123842,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123842,37.77,0.21,358,55674,70,NULL,NULL,'2MASX J14464350+1427520',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.681333333,14.46428,0.013,NULL,59555707704,930557932,14539967,17.9),(123843,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123843,36.19,0.46,173,55675,70,NULL,NULL,'MCG +07-30-064',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'16.73',0.17,NULL,NULL,NULL,NULL,NULL,1,221.6814583,42.30725,0.012,NULL,59950584833,936727888,14636373,16.73),(123844,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123844,37.7,0.33,346,55676,70,NULL,NULL,'2MASX J14464405+5531083',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.6837083,55.519,0,NULL,57248028194,894500440,13976569,17.1),(123845,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123845,38.14,0.46,425,55677,70,NULL,NULL,'2MASX J14464607+4759539',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.691916667,47.99856,0.045,NULL,59936297381,936504646,14632885,18.3),(123846,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123846,35.21,0.21,110,55678,70,NULL,NULL,'CGCG 076-032',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000083,NULL,'14.8g',0.62,'SB','Group member',NULL,NULL,NULL,1,221.693666667,11.57019,0.025,NULL,59368226953,927628546,14494196,14.8),(123847,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123847,35.51,0.25,126,55678,74.4,NULL,NULL,'CGCG 076-032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123848,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123848,35.73,0.22,140,55678,70,NULL,NULL,'CGCG 076-032',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123849,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123849,36.2,0.6,174,55679,70,NULL,NULL,'2MASX J14464892-1351109',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.64',0.4,NULL,NULL,NULL,NULL,NULL,1,221.703916667,-13.85297,0.321,NULL,46683916250,729436191,11397440,15.64),(123850,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123850,37.87,0.27,376,55680,70,NULL,NULL,'SDSS J144650.43+220418.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.710166667,22.07181,0.046,NULL,59505783497,929777867,14527779,18.5),(123851,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123851,35.67,0.46,136,55681,70,NULL,NULL,'2MASX J14465088+0151066',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000082,NULL,'15.3g',0.52,'E0',NULL,NULL,NULL,NULL,1,221.711917,1.85189,0.101,NULL,58267127401,910423865,14225372,15.3),(123852,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123852,37.77,0.21,358,55682,70,NULL,NULL,'2MASX J14465121+1438260',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.74',0.14,NULL,NULL,NULL,NULL,NULL,1,221.713333,14.64067,0.013,NULL,59555656747,930557136,14539955,18.74),(123853,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123853,37.08,0.46,260,55683,70,NULL,NULL,'2MASX J14465132-0206577',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.713917,-2.11603,0.157,NULL,43503292916,679738951,10620921,17),(123854,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123854,37.6,0.46,332,55684,70,NULL,NULL,'2MASX J14465208+1331410',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.7170417,13.52825,0.009,NULL,59549373016,930458953,14538421,17.6),(123855,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123855,36.84,0.23,234,55685,70,NULL,NULL,'2MASX J14465248+2153473',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.54',0.14,'AGN',NULL,NULL,NULL,NULL,1,221.7187917,21.8965,0.021,NULL,59501515891,929711185,14526737,18.54),(123856,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123856,35.73,0.22,140,55686,70,NULL,NULL,'GIN 361',NULL,'2001MNRAS.321..277C',2001,1,0.49,NULL,'G',0.000102,NULL,'15.8g',0.46,'SB',NULL,NULL,NULL,NULL,1,221.7230417,11.37975,0.025,NULL,59367698818,927620294,14494067,15.8),(123857,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123857,35.21,0.21,110,55687,70,NULL,NULL,'CGCG 076-033',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000093,NULL,'14.9g',0.53,'S0','Group member',NULL,NULL,NULL,1,221.723375,11.62622,0.021,NULL,59368228218,927628565,14494196,14.9),(123858,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123858,35.52,0.25,127,55687,74.4,NULL,NULL,'CGCG 076-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123859,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123859,35.73,0.22,140,55687,70,NULL,NULL,'CGCG 076-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123860,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123860,33.93,0.49,61.2,55688,NULL,NULL,NULL,'ESO 386- G 022',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.59',0.4,'Sb             HII',NULL,NULL,NULL,NULL,1,221.7244583,-35.50703,0.249,NULL,47229767534,737965117,11530704,15.59),(123861,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123861,33.97,0.2,62.2,55688,74.4,NULL,NULL,'ESO 386- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123862,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123862,34.07,0.46,65.1,55688,NULL,NULL,'Malmquist cor.','ESO 386- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123863,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123863,38.26,0.33,449,55689,70,NULL,NULL,'SDSS J144654.08+461808.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.725333333,46.30233,0.005,NULL,59991115610,937361181,14646268,18.5),(123864,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123864,38.25,0.33,447,55690,70,NULL,NULL,'SDSS J144654.92+072623.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.728833333,7.43983,0.077,NULL,59379348239,927802316,14496911,18.3),(123865,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123865,38.05,0.33,407,55691,70,NULL,NULL,'SDSS J144655.13+355250.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.72975,35.88078,0,NULL,60067834058,938559907,14664998,17.4),(123866,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123866,37.98,0.46,394,55692,70,NULL,NULL,'2MASX J14465572+4856490',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.732125,48.94703,0.017,NULL,59936523903,936508185,14632940,17.5),(123867,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123867,36.63,0.55,212,55693,70,NULL,NULL,'2MASX J14465783-1350261',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.97',0.4,NULL,NULL,NULL,NULL,NULL,1,221.740917,-13.84064,0.321,NULL,46685751299,729464864,11397888,16.97),(123868,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123868,37.96,0.46,390,55694,70,NULL,NULL,'SDSS J144658.00+182358.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.7417083,18.39972,0.057,NULL,59585169662,931018275,14547160,18.3),(123869,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123869,37.44,0.33,308,55695,70,NULL,NULL,'2MASX J14465915+4122178',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00022,NULL,'16.8g',0.27,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,221.7465,41.37172,0.009,NULL,59953314649,936770541,14637039,16.8),(123870,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123870,35.91,0.23,152,55696,70,NULL,NULL,'SDSS J144659.85+105921.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.2g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.749417,10.98933,0.025,NULL,59367549723,927617964,14494030,17.2),(123871,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123871,34.82,0.69,91.8,55697,100,NULL,'mid-IR','UGC 09521',NULL,'2013ApJ...771...88L',2013,1,1.19,NULL,'G',0.000067,NULL,'14.1g',0.74,'SBa:           LINER','Group member',NULL,NULL,NULL,1,221.750417,11.59203,0.021,NULL,59368049969,927625780,14494152,14.1),(123872,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123872,35.67,0.47,136,55697,NULL,NULL,'H','UGC 09521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123873,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123873,35.75,0.45,141,55697,NULL,NULL,'K','UGC 09521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123874,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123874,35.76,0.4,142,55697,NULL,NULL,'mean','UGC 09521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123875,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123875,35.81,0.46,145,55697,NULL,NULL,'J','UGC 09521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123876,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123876,37.01,0.46,252,55698,70,NULL,NULL,'2MASX J14470037+3025513',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,221.7515417,30.43092,0.009,NULL,60089407317,938896989,14670265,16.3),(123877,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123877,37.71,0.33,348,55699,70,NULL,NULL,'2MASX J14470042+1201396',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,221.75175,12.02769,0.025,NULL,59368129641,927627025,14494172,17),(123878,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123878,37.71,0.33,348,55700,70,NULL,NULL,'SDSS J144701.53+120631.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.756417,12.10867,0.021,NULL,59368134279,927627098,14494173,18.2),(123879,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123879,35.61,0.4,133,55701,NULL,NULL,'mean','NGC 5758',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.0001,NULL,'14.49',0.6,'S0-:','Group member',NULL,NULL,NULL,1,221.758666667,13.66839,0.017,NULL,59549211060,930456422,14538381,14.49),(123880,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123880,36.37,0.45,188,55701,NULL,NULL,'K','NGC 5758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123881,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123881,36.05,0.46,162,55702,70,NULL,NULL,'2MASX J14470211+1005293',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000179,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,221.75875,10.09144,0.029,NULL,59370833009,927669265,14494832,15.8),(123882,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123882,36.06,0.68,163,55703,70,NULL,NULL,'2MFGC 11967',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,221.7595417,-18.21678,0.345,NULL,46696014243,729625222,11400394,15.1),(123883,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123883,37.93,0.15,385,55704,70,NULL,NULL,'2MASX J14470283+3320103',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.761667,33.33611,0,NULL,60121544984,939399140,14678111,17.4),(123884,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123884,36.59,0.39,208,55705,NULL,NULL,NULL,'AGC 540233',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.00001,NULL,'15.5I',NULL,NULL,NULL,NULL,NULL,NULL,1,221.764583,-13.81139,0.321,NULL,46685759045,729464985,11397890,15.5),(123885,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123885,36.63,0.2,212,55705,74.4,NULL,NULL,'AGC 540233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123886,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123886,36.72,0.37,221,55705,NULL,NULL,'Malmquist cor.','AGC 540233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123887,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123887,37.09,0.33,262,55706,70,NULL,NULL,'2MASX J14470363+0535250',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000164,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.765375,5.59042,0.121,NULL,59333670187,927088596,14485759,16.7),(123888,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123888,37.91,0.46,382,55707,70,NULL,NULL,'2MASX J14470446+2036231',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.68',0.14,NULL,NULL,NULL,NULL,NULL,1,221.76875,20.60631,0.079,NULL,59532154466,930189913,14534217,18.68),(123889,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123889,36.87,0.33,237,55708,70,NULL,NULL,'2MASX J14470470+0934563',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00018,NULL,'18.60',0.16,NULL,NULL,NULL,NULL,NULL,1,221.7694583,9.58233,0.049,NULL,59371249291,927675770,14494933,18.6),(123890,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123890,37.56,0.46,325,55709,70,NULL,NULL,'2MASX J14470560+2548075',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.45',0.15,NULL,NULL,NULL,NULL,NULL,1,221.773208333,25.80219,0.076,NULL,60015033378,937734896,14652107,18.45),(123891,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123891,37.77,0.21,358,55710,70,NULL,NULL,'2MASX J14470559+1431006',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.7732917,14.51703,0.013,NULL,59555697268,930557769,14539965,18.5),(123892,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123892,36.98,0.15,249,55711,70,NULL,NULL,'2MASX J14470571+1133453',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,221.773708333,11.56267,0.021,NULL,59368050429,927625787,14494152,16.8),(123893,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123893,37.29,0.46,287,55712,70,NULL,NULL,'SDSS J144705.78+494542.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.774083,49.76172,0.045,NULL,59935316038,936489313,14632645,18.3),(123894,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123894,37.94,0.46,387,55713,70,NULL,NULL,'2MASX J14470617+1723216',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.89',0.12,NULL,NULL,NULL,NULL,NULL,1,221.775791667,17.38942,0.037,NULL,59587990451,931062350,14547849,18.89),(123895,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123895,37.12,0.46,265,55714,70,NULL,NULL,'SDSS J144706.23+631353.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.7759583,63.23164,0.017,NULL,57759096025,902485875,14101341,17.8),(123896,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123896,35.21,0.21,110,55715,70,NULL,NULL,'UGC 09523',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000097,NULL,'14.1g',0.84,'S0/a','Group member',NULL,NULL,NULL,1,221.776333333,11.59381,0.021,NULL,59368049729,927625777,14494152,14.1),(123897,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123897,35.51,0.25,126,55715,74.4,NULL,NULL,'UGC 09523',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123898,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123898,35.73,0.22,140,55715,70,NULL,NULL,'UGC 09523',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123899,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123899,37.93,0.15,385,55716,70,NULL,NULL,'2MASX J14470653+3310454',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,221.777083,33.17919,0,NULL,60121523100,939398798,14678106,17.8),(123900,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123900,35.52,0.25,127,55717,74.4,NULL,NULL,'CGCG 076-037',NULL,'2013AJ....146...86T',2013,1,0.86,'Two MAPS entries for the same object.','G',0.000063,NULL,'15.1g',0.57,'E/S0',NULL,NULL,NULL,NULL,1,221.7787083,10.99967,0.025,NULL,59367550974,927617983,14494030,15.1),(123901,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123901,35.73,0.22,140,55717,70,NULL,NULL,'CGCG 076-037',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123902,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123902,35.91,0.23,152,55717,70,NULL,NULL,'CGCG 076-037',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123903,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123903,38.18,0.46,433,55718,70,NULL,NULL,'LCRS B144432.3-022935',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.783458333,-2.70172,0.197,NULL,43500926088,679701970,10620343,18.7),(123904,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123904,37.09,0.33,262,55719,70,NULL,NULL,'2MASX J14470979+0526270',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,221.790708333,5.44072,0.133,NULL,59333625003,927087890,14485748,18.3),(123905,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123905,37.93,0.15,385,55720,70,NULL,NULL,'2MASX J14471003+3312374',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000191,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.792,33.21047,0,NULL,60121525616,939398837,14678106,16.7),(123906,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123906,37.77,0.21,358,55721,70,NULL,NULL,'2MASX J14471028+1431277',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.49',0.19,'BrClG',NULL,NULL,NULL,NULL,1,221.7930417,14.52433,0.013,NULL,59555680350,930557505,14539961,17.49),(123907,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123907,37.72,0.46,350,55722,70,NULL,NULL,'2MASX J14471162+3002244',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.7985417,30.03989,0.027,NULL,60089251540,938894555,14670227,17.2),(123908,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123908,37.87,0.27,376,55723,70,NULL,NULL,'2MASX J14471250+2214520',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,221.802083,22.24781,0.057,NULL,59505816240,929778378,14527787,17.7),(123909,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123909,37.87,0.27,376,55724,70,NULL,NULL,'2MASX J14471329+2213410',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.805375,22.22803,0.057,NULL,59505815732,929778370,14527787,17.1),(123910,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123910,38.65,0.46,536,55725,70,NULL,NULL,'SDSS J144714.53+282838.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.8105417,28.47739,0.033,NULL,60026955584,937921181,14655018,18),(123911,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123911,38.28,0.46,452,55726,70,NULL,NULL,'2MASX J14471549+6355268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.81475,63.92425,0.017,NULL,57755990960,902437358,14100583,17.7),(123912,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123912,37.44,0.33,308,55727,70,NULL,NULL,'2MASX J14471636+4125424',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,221.818083,41.42839,0.021,NULL,59953294764,936770230,14637034,17.1),(123913,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123913,37.93,0.15,385,55728,70,NULL,NULL,'SDSS J144717.06+331435.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,221.821083333,33.24308,0,NULL,60121525216,939398831,14678106,18.5),(123914,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123914,35.73,0.22,140,55729,70,NULL,NULL,'GIN 360',NULL,'2001MNRAS.321..277C',2001,1,0.62,NULL,'G',0.000171,NULL,'15.9g',0.35,'S',NULL,NULL,NULL,NULL,1,221.823417,11.13017,0.025,NULL,59367520664,927617510,14494023,15.9),(123915,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123915,36.3,0.25,182,55729,74.4,NULL,NULL,'GIN 360',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123916,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123916,37.14,0.46,268,55730,70,NULL,NULL,'2MASX J14471764+2657546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.84',0.19,NULL,NULL,NULL,NULL,NULL,1,221.8234583,26.96536,0.084,NULL,60015293324,937738958,14652171,17.84),(123917,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123917,37.82,0.46,366,55731,70,NULL,NULL,'SDSS J144717.63+030503.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000076,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.8235,3.08436,0.101,NULL,58257411648,910272057,14223000,18.5),(123918,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123918,36.98,0.46,249,55732,70,NULL,NULL,'2MASX J14471791+1656497',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.82475,16.94706,0.029,NULL,59585884059,931029438,14547334,17.6),(123919,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123919,37.3,0.46,289,55733,70,NULL,NULL,'2MASX J14471854+4605103',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.827125,46.08617,0,NULL,59990986329,937359161,14646236,17.6),(123920,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123920,38.05,0.33,407,55734,70,NULL,NULL,'2MASX J14471916+3545314',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000195,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,221.829833,35.75878,0,NULL,60123370438,939427663,14678557,17),(123921,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123921,38.32,0.46,461,55735,70,NULL,NULL,'SDSS J144719.22+284926.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,221.830125,28.82406,0.028,NULL,60027017227,937922144,14655033,18.5),(123922,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123922,35.11,0.53,105,55736,70,NULL,NULL,'LCRS B144441.3-061451',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.57',0.5,NULL,NULL,NULL,NULL,NULL,1,221.832458333,-6.45553,0.205,NULL,46498951457,726546116,11352283,15.57),(123923,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123923,37.93,0.15,385,55737,70,NULL,NULL,'2MASX J14472070+3305224',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.8362083,33.08947,0,NULL,60121650614,939400790,14678137,17.9),(123924,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123924,37.72,0.46,349,55738,70,NULL,NULL,'2MASX J14472064+4035354',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,221.83625,40.59311,0.012,NULL,59951577033,936743391,14636615,18.5),(123925,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123925,37.85,0.33,371,55739,70,NULL,NULL,'2MASX J14472307+0552094',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.8462917,5.86931,0.109,NULL,59333514968,927086171,14485721,17.6),(123926,'FP','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123926,36.87,0.33,237,55740,70,NULL,NULL,'2MASX J14472404+0941173',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'18.25',0.21,NULL,NULL,NULL,NULL,NULL,1,221.8502083,9.68808,0.033,NULL,59371371981,927677687,14494963,18.25),(123927,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123927,32.41,0.8,30.3,55741,75,NULL,'MAT, I','UGCA 394',NULL,'1997ApJS..109..333W',1997,1,3.7,NULL,'G',0.000018,NULL,'13.5',0.5,'SB(s)cd: sp    HII',NULL,NULL,NULL,NULL,1,221.85075,-17.44558,0.349,NULL,46698624733,729666011,11401031,13.5),(123928,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,NULL,123928,32.57,0.8,32.7,55741,75,NULL,NULL,'UGCA 394',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123929,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:41','1',NULL,'R',123929,30.71,0.4,13.9,55741,75,NULL,NULL,'UGCA 394',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123930,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123930,30.72,0.4,13.9,55741,73,NULL,'IR','UGCA 394',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123931,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123931,30.82,0.43,14.6,55741,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123932,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123932,31.11,0.43,16.7,55741,75,NULL,'3.6 micron, color corrected','UGCA 394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123933,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123933,31.32,0.4,18.4,55741,NULL,NULL,NULL,'UGCA 394',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123934,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123934,31.35,0.2,18.6,55741,74.4,NULL,NULL,'UGCA 394',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123935,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123935,31.54,0.49,20.3,55741,75,NULL,'IR','UGCA 394',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123936,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123936,31.62,0.49,21,55741,NULL,NULL,NULL,'UGCA 394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123937,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123937,31.67,0.48,21.6,55741,NULL,NULL,'Malmquist cor.','UGCA 394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123938,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123938,31.69,NULL,21.8,55741,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123939,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123939,31.7,NULL,21.9,55741,NULL,NULL,'Dipole + Quadrupole','UGCA 394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123940,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123940,31.7,NULL,21.9,55741,NULL,NULL,'Dipole','UGCA 394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123941,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123941,31.76,0.32,22.5,55741,85,NULL,'I, raw','UGCA 394',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123942,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123942,31.77,0.32,22.6,55741,85,NULL,'I, inv','UGCA 394',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123943,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123943,31.85,0.43,23.5,55741,75,NULL,'MAT, I, raw','UGCA 394',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123944,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123944,31.94,0.43,24.5,55741,75,NULL,'MAT, I, inv','UGCA 394',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123945,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123945,31.98,0.47,24.9,55741,NULL,NULL,'H','UGCA 394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123946,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123946,32.02,0.46,25.3,55741,NULL,NULL,'J','UGCA 394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123947,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123947,32.04,0.45,25.5,55741,NULL,NULL,'K','UGCA 394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123948,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123948,32.05,NULL,25.7,55741,NULL,NULL,NULL,'UGCA 394',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123949,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123949,32.2,0.43,27.5,55741,75,NULL,'MAT, I, cor','UGCA 394',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123950,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123950,32.45,0.4,31,55741,NULL,NULL,'mean','UGCA 394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123951,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123951,35.64,0.46,134,55742,70,NULL,NULL,'2MASX J14472519+0326274',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000108,NULL,'15.7g',0.4,'S0',NULL,NULL,NULL,NULL,1,221.854833,3.44111,0.093,NULL,58257506317,910273536,14223024,15.7),(123952,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123952,32.83,0.37,36.9,55743,NULL,NULL,'Malmquist cor.','IC 1055',NULL,'2009ApJS..182..474S',2009,1,2,'HOLM 677B,C are stars.','G',0.000017,NULL,'13.43',0.7,'(R\')SA(r)b:    HII',NULL,NULL,NULL,NULL,1,221.8570417,-13.71614,0.301,NULL,46685786885,729465420,11397897,13.43),(123953,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123953,32.9,0.46,38,55743,NULL,NULL,'J','IC 1055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123954,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123954,32.91,0.47,38.2,55743,NULL,NULL,'H','IC 1055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123955,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123955,32.94,0.2,38.7,55743,74.4,NULL,NULL,'IC 1055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123956,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123956,32.95,0.36,38.9,55743,NULL,NULL,NULL,'IC 1055',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123957,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123957,32.99,0.45,39.6,55743,NULL,NULL,'K','IC 1055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123958,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123958,33.1,0.43,41.7,55743,75,NULL,'3.6 micron, color corrected','IC 1055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123959,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123959,33.19,0.4,43.5,55743,NULL,NULL,'mean','IC 1055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123960,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123960,33.27,0.43,45,55743,75,NULL,'3.6 micron, color + selection bias corrected','IC 1055',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123961,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123961,37.86,0.46,373,55744,70,NULL,NULL,'2MASX J14472589+4831516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.857917,48.53089,0.045,NULL,59936454223,936507097,14632923,17.3),(123962,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123962,36.28,0.46,180,55745,70,NULL,NULL,'2MASX J14472616+2228355',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.19',0.17,NULL,NULL,NULL,NULL,NULL,1,221.859125,22.47661,0.071,NULL,59506591359,929790489,14527976,17.19),(123963,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123963,37.7,0.46,347,55746,70,NULL,NULL,'2MASX J14472800+2517425',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,221.866667,25.29511,0.072,NULL,60014618702,937728417,14652006,18.48),(123964,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123964,37.82,0.46,366,55747,70,NULL,NULL,'SDSS J144728.13+274547.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.8672917,27.76331,0.112,NULL,60013601449,937712522,14651758,18.2),(123965,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123965,36.99,0.46,250,55748,70,NULL,NULL,'2MASX J14472843+6009008',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000095,NULL,'16.7g',0.29,'NLAGN',NULL,NULL,NULL,NULL,1,221.8682917,60.15033,0.013,NULL,57771469783,902679215,14104362,16.7),(123966,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123966,37.75,0.46,355,55749,70,NULL,NULL,'2MASX J14472859+1644350',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.07',0.18,NULL,NULL,NULL,NULL,NULL,1,221.869,16.74303,0.009,NULL,59553301066,930520329,14539380,18.07),(123967,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123967,37.15,0.46,269,55750,70,NULL,NULL,'2MASX J14472861+4544253',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00018,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.869125,45.74028,0,NULL,59990934441,937358350,14646224,16.4),(123968,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123968,36.56,0.46,205,55751,70,NULL,NULL,'2MASX J14472895+3151584',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,221.870583,31.86617,0,NULL,60091085845,938923216,14670675,16.5),(123969,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123969,37.93,0.15,385,55752,70,NULL,NULL,'2MASX J14473121+3306064',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000179,NULL,'16.0g',0.46,'BrClG',NULL,NULL,NULL,NULL,1,221.8802083,33.10175,0,NULL,60121660923,939400951,14678139,16),(123970,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123970,37.42,0.46,305,55753,70,NULL,NULL,'2MASX J14473163+1521240',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.8817917,15.35658,0,NULL,59555015042,930547110,14539798,16.3),(123971,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123971,38.62,0.46,529,55754,70,NULL,NULL,'2MASX J14473234+0310514',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,221.884667,3.18103,0.101,NULL,58257426313,910272286,14223004,17.9),(123972,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123972,34.56,0.49,81.8,55755,75,NULL,'IR','ESO 580- G 028',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000043,NULL,'15.56',0.15,'Sc',NULL,NULL,NULL,NULL,1,221.888875,-19.32992,0.341,NULL,46649865820,728904153,11389127,15.56),(123973,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123973,34.34,0.51,73.8,55756,70,NULL,NULL,'MCG -03-38-010',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000087,NULL,'15',0.6,'poss. LINER',NULL,NULL,NULL,NULL,1,221.8895,-20.46739,0.353,NULL,46650660627,728916572,11389321,15),(123974,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123974,32.39,0.8,30.1,55757,75,NULL,'MAT, I','NGC 5756',NULL,'1997ApJS..109..333W',1997,1,2.1,'HOLM 676B does not exist (it is probably a plate defect).','G',0.000017,NULL,'13.09',0.9,'(R\')SB(s)bc pecHII',NULL,NULL,NULL,NULL,1,221.890541667,-14.85358,0.341,NULL,46687777923,729496530,11398383,13.09),(123975,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123975,32.56,0.8,32.6,55757,75,NULL,'B','NGC 5756',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123976,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123976,31.86,0.43,23.5,55757,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5756',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123977,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123977,31.91,0.32,24.1,55757,85,NULL,'I, raw','NGC 5756',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123978,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123978,31.95,0.32,24.5,55757,85,NULL,'I, inv','NGC 5756',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123979,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123979,31.96,0.43,24.6,55757,75,NULL,'3.6 micron, color corrected','NGC 5756',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123980,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123980,32.01,0.43,25.2,55757,75,NULL,'MAT, I, raw','NGC 5756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123981,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123981,32.06,0.2,25.8,55757,74.4,NULL,NULL,'NGC 5756',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123982,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123982,32.07,0.46,25.9,55757,NULL,NULL,'J','NGC 5756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123983,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123983,32.09,0.47,26.2,55757,NULL,NULL,'H','NGC 5756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123984,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123984,32.14,0.45,26.8,55757,NULL,NULL,'K','NGC 5756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123985,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123985,32.17,0.43,27.1,55757,75,NULL,'MAT, I, inv','NGC 5756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123986,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123986,32.24,0.5,28.1,55757,NULL,NULL,NULL,'NGC 5756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123987,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123987,32.29,0.49,28.7,55757,NULL,NULL,'Malmquist cor.','NGC 5756',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123988,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123988,32.31,0.43,28.9,55757,75,NULL,'MAT, I, cor','NGC 5756',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123989,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123989,32.42,0.4,30.4,55757,NULL,NULL,'mean','NGC 5756',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123990,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123990,32.75,0.8,35.5,55758,75,NULL,'MAT, I','ESO 580- G 029',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00002,NULL,'14.47',0.3,'S(r)b:         HII',NULL,NULL,NULL,NULL,1,221.89025,-19.76411,0.377,NULL,46649433317,728897395,11389021,14.47),(123991,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',123991,32.29,0.4,28.7,55758,75,NULL,NULL,'ESO 580- G 029',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123992,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123992,32.42,0.32,30.5,55758,85,NULL,'I, raw','ESO 580- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123993,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123993,32.45,0.43,30.9,55758,75,NULL,'MAT, I, raw','ESO 580- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123994,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123994,32.45,0.32,30.9,55758,85,NULL,'I, inv','ESO 580- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123995,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123995,32.46,0.47,31,55758,NULL,NULL,'H','ESO 580- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123996,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123996,32.47,0.46,31.2,55758,NULL,NULL,'J','ESO 580- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123997,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123997,32.52,0.45,31.9,55758,NULL,NULL,'K','ESO 580- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123998,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123998,32.6,0.43,33.1,55758,75,NULL,'MAT, I, inv','ESO 580- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(123999,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,123999,32.6,0.43,33.1,55758,75,NULL,'3.6 micron, color + selection bias corrected','ESO 580- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124000,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124000,32.68,0.49,34.4,55758,75,NULL,'IR','ESO 580- G 029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124001,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124001,32.7,0.43,34.7,55758,75,NULL,'MAT, I, cor','ESO 580- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124002,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124002,32.71,0.43,34.8,55758,75,NULL,'3.6 micron, color corrected','ESO 580- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124003,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124003,32.8,0.4,36.3,55758,NULL,NULL,'mean','ESO 580- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124004,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124004,32.8,0.2,36.3,55758,74.4,NULL,NULL,'ESO 580- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124005,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124005,32.91,0.45,38.3,55758,NULL,NULL,NULL,'ESO 580- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124006,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124006,32.99,0.44,39.6,55758,NULL,NULL,'Malmquist cor.','ESO 580- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124007,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124007,35.2,0.2,110,55759,74.4,NULL,NULL,'CGCG 076-045',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000137,NULL,'15.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.894083333,9.23103,0.021,NULL,59370510775,927664230,14494753,15.9),(124008,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124008,35.29,0.49,114,55760,75,NULL,'IR','CGCG 076-045',NULL,'2011yCatp016004901K',2011,1,0.97,NULL,'G',0.000137,NULL,'15.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,221.894083333,9.23103,0.021,NULL,59370510775,927664230,14494753,15.9),(124009,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124009,37.02,0.46,254,55761,70,NULL,NULL,'2MASX J14473553+1035149',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.47',0.18,NULL,NULL,NULL,NULL,NULL,1,221.8982083,10.58756,0.025,NULL,59368858105,927638407,14494350,16.47),(124010,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124010,37.43,0.46,306,55762,70,NULL,NULL,'2MASX J14473568+3756364',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,221.8985,37.94344,0,NULL,60073608125,938650126,14666408,16.7),(124011,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124011,35.23,0.46,111,55763,70,NULL,NULL,'2MASX J14473588+0347174',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000068,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,221.8995,3.78817,0.089,NULL,58257608623,910275134,14223048,16.4),(124012,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124012,34.41,0.69,76.3,55764,NULL,NULL,NULL,'ESO 580- G 031',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.82',0.7,'Sb',NULL,NULL,NULL,NULL,1,221.90325,-19.38739,0.341,NULL,46649862508,728904101,11389126,14.82),(124013,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124013,34.45,0.2,77.6,55764,74.4,NULL,NULL,'ESO 580- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124014,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124014,34.6,0.63,83.2,55764,NULL,NULL,'Malmquist cor.','ESO 580- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124015,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124015,37.93,0.15,385,55765,70,NULL,NULL,'2MASX J14473680+3317100',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.903333,33.28614,0,NULL,60121528630,939398884,14678107,17.5),(124016,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124016,37.74,0.46,353,55766,70,NULL,NULL,'2MASX J14473681+0344424',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.9035,3.74511,0.093,NULL,58257618028,910275281,14223051,17.2),(124017,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124017,37.54,0.46,322,55767,70,NULL,NULL,'2MASX J14473727-0145544',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000136,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.905291667,-1.76514,0.173,NULL,43502367029,679724484,10620695,16.9),(124018,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124018,37.72,0.46,350,55768,70,NULL,NULL,'2MASX J14473797+2812331',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.908125,28.20922,0.058,NULL,60026923626,937920681,14655010,17.5),(124019,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124019,37.46,0.46,310,55769,70,NULL,NULL,'2MASX J14473888+5615217',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,221.911917,56.25597,0.005,NULL,57245807299,894465739,13976027,17.1),(124020,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124020,38.16,0.46,429,55770,70,NULL,NULL,'2MASX J14473895+4738594',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.9122083,47.64981,0.041,NULL,59933992860,936468638,14632322,17.2),(124021,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124021,32.76,0.73,35.7,55771,NULL,NULL,'Malmquist cor.','AGC 540235',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000017,NULL,'16.71',NULL,NULL,NULL,NULL,NULL,NULL,1,221.9135417,-13.63664,0.301,NULL,46685783119,729465361,11397896,16.71),(124022,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124022,32.94,0.67,38.8,55771,NULL,NULL,NULL,'AGC 540235',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124023,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124023,32.98,0.2,39.5,55771,74.4,NULL,NULL,'AGC 540235',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124024,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124024,37.81,0.33,364,55772,70,NULL,NULL,'2MASX J14473938+1648430',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.59',0.15,NULL,NULL,NULL,NULL,NULL,1,221.914167,16.81183,0.009,NULL,59585872339,931029255,14547332,18.59),(124025,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124025,37.93,0.15,385,55773,70,NULL,NULL,'2MASX J14474057+3307401',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,221.9192083,33.12775,0,NULL,60121660008,939400937,14678139,16.8),(124026,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124026,37.93,0.15,385,55774,70,NULL,NULL,'SDSS J144740.69+325843.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000142,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,221.919541667,32.97883,0,NULL,60121653702,939400839,14678138,18.5),(124027,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124027,38.3,0.46,456,55775,70,NULL,NULL,'2MASX J14474083+4622454',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000176,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.92025,46.37942,0.025,NULL,59991125533,937361336,14646270,16.8),(124028,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124028,37.85,0.33,371,55776,70,NULL,NULL,'2MASX J14474123+0555314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,221.921917,5.92539,0.113,NULL,59333239501,927081867,14485654,17.3),(124029,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124029,34.62,0.43,83.9,55777,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09530',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000033,NULL,'14.87',0.5,'S?','Group member',NULL,NULL,NULL,1,221.9270417,9.65944,0.033,NULL,59371359818,927677497,14494960,14.87),(124030,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124030,33.84,0.8,58.7,55778,75,NULL,'MAT, I','IC 4484',NULL,'1997ApJS..109..333W',1997,1,3.53,'Stars superposed.','G',0.00003,NULL,'12.34',0.34,'Sc',NULL,NULL,NULL,NULL,1,221.932833,-73.30594,0.573,NULL,44913606292,701775098,10965235,12.34),(124031,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124031,33.22,0.47,44,55778,NULL,NULL,'H','IC 4484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124032,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124032,33.24,0.43,44.5,55778,75,NULL,'MAT, I, raw','IC 4484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124033,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124033,33.28,0.49,45.2,55778,75,NULL,'IR','IC 4484',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124034,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124034,33.33,0.32,46.4,55778,85,NULL,'I, raw','IC 4484',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124035,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124035,33.38,0.46,47.4,55778,NULL,NULL,'J','IC 4484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124036,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124036,33.38,0.32,47.5,55778,85,NULL,'I, inv','IC 4484',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124037,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124037,33.39,0.45,47.6,55778,NULL,NULL,'K','IC 4484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124038,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124038,33.41,0.43,48.1,55778,75,NULL,'MAT, I, cor','IC 4484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124039,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124039,33.45,0.43,49.1,55778,75,NULL,'MAT, I, inv','IC 4484',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124040,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124040,33.52,0.55,50.6,55778,NULL,NULL,NULL,'IC 4484',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124041,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124041,33.55,0.54,51.2,55778,NULL,NULL,'Malmquist cor.','IC 4484',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124042,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124042,33.56,0.2,51.5,55778,74.4,NULL,NULL,'IC 4484',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124043,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124043,33.59,NULL,52.2,55778,NULL,NULL,NULL,'IC 4484',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124044,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124044,33.73,0.4,55.8,55778,NULL,NULL,'mean','IC 4484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124045,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124045,33.8,NULL,57.5,55778,NULL,NULL,'Dipole','IC 4484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124046,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124046,33.8,NULL,57.5,55778,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124047,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124047,33.81,NULL,57.7,55778,NULL,NULL,'Dipole + Quadrupole','IC 4484',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124048,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124048,36.98,0.15,249,55779,70,NULL,NULL,'2MASX J14474484+1126119',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,221.9369583,11.43667,0.021,NULL,59367618478,927619038,14494047,16.1),(124049,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124049,36.56,0.46,205,55780,70,NULL,NULL,'SDSS J144745.51+132032.3',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.9g',0.42,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.939666667,13.34233,0.009,NULL,59549308157,930457939,14538405,15.9),(124050,'Tully est','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124050,32.98,0.8,39.5,55781,75,NULL,'B','NGC 5757',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000023,NULL,'13.50',1.6,'(R\')SB(r)b     HII','in a pair',NULL,NULL,'H II',1,221.94325,-19.07856,0.341,NULL,46649779328,728902802,11389106,13.5),(124051,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124051,36.66,0.49,215,55782,75,NULL,'IR','2MFGC 11989',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000068,NULL,'17.64',0.1,NULL,NULL,NULL,NULL,NULL,1,221.947375,16.83006,0.013,NULL,59586087412,931032615,14547384,17.64),(124052,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124052,37.47,0.46,312,55783,70,NULL,NULL,'2MASX J14474832+3249271',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.951333,32.82428,0.02,NULL,60121459578,939397805,14678090,17.4),(124053,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124053,38.06,0.46,409,55784,70,NULL,NULL,'2MASX J14474984+2833592',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.957875,28.56658,0.033,NULL,60027037278,937922457,14655038,17.9),(124054,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124054,37.98,0.46,395,55785,70,NULL,NULL,'2MASX J14475006+1321500',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.9585,13.36381,0.009,NULL,59549316033,930458063,14538407,17.6),(124055,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124055,37.22,0.46,278,55786,70,NULL,NULL,'2MASXi J1447511+255346',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,221.9630417,25.89619,0.07,NULL,60014584675,937727885,14651998,17.6),(124056,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124056,37.81,0.33,364,55787,70,NULL,NULL,'2MASX J14475143+1649230',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,221.964375,16.823,0.013,NULL,59586088002,931032625,14547384,17.5),(124057,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124057,36.98,0.15,249,55788,70,NULL,NULL,'2MASX J14475240+1122299',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,221.968375,11.37486,0.025,NULL,59367618744,927619042,14494047,16.7),(124058,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124058,37.69,0.46,346,55789,70,NULL,NULL,'2MASX J14475244+0715529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,221.968625,7.26461,0.077,NULL,59379499715,927804683,14496948,17.4),(124059,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124059,38.42,0.46,484,55790,70,NULL,NULL,'SDSS J144753.94+114436.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.9747917,11.74339,0,NULL,59368035330,927625552,14494149,18),(124060,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124060,37.5,0.46,317,55791,70,NULL,NULL,'2MASX J14475406+2006563',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.00',0.18,NULL,NULL,NULL,NULL,NULL,1,221.9752083,20.11572,0.108,NULL,59533405234,930209456,14534522,18),(124061,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124061,35.51,0.21,127,55792,70,NULL,NULL,'CGCG 076-053',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000103,NULL,'15.4',0.61,NULL,NULL,NULL,NULL,NULL,1,221.976375,13.66172,0.017,NULL,59549711157,930464236,14538503,15.4),(124062,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124062,36.97,0.46,247,55793,70,NULL,NULL,'SDSS J144755.22+222607.4',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000153,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,221.980083,22.43539,0.071,NULL,59505728076,929777001,14527765,16.9),(124063,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124063,32.56,0.2,32.5,55794,74.4,NULL,NULL,'MCG -02-38-015',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000003,NULL,'14.07',1.9,'SB(s)cd',NULL,NULL,NULL,NULL,1,221.9832917,-14.28253,0.321,NULL,46685242976,729456921,11397764,14.07),(124064,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124064,32.68,0.46,34.4,55794,NULL,NULL,NULL,'MCG -02-38-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124065,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124065,32.73,0.45,35.1,55794,NULL,NULL,'Malmquist cor.','MCG -02-38-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124066,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124066,32.75,0.43,35.5,55794,75,NULL,'3.6 micron, color corrected','MCG -02-38-015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124067,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124067,32.94,0.43,38.6,55794,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124068,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124068,36.33,0.46,185,55795,70,NULL,NULL,'UGC 09532 NED05',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000133,NULL,'16.12',0.2,'E2','Compact group member',NULL,NULL,NULL,1,221.986708333,19.04508,0.075,NULL,59530220201,930159690,14533745,16.12),(124069,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124069,37.04,0.46,255,55796,70,NULL,NULL,'2MASXi J1447578+120551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.9910417,12.09764,0.021,NULL,59367846490,927622601,14494103,18.1),(124070,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124070,38.55,0.46,513,55797,70,NULL,NULL,'SDSS J144759.10+254609.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.9962917,25.76939,0.064,NULL,60014548169,937727315,14651989,17.1),(124071,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124071,37.54,0.46,322,55798,70,NULL,NULL,'2MASX J14475915+1504284',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.996625,15.07458,0,NULL,59555087604,930548243,14539816,17.6),(124072,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124072,37.19,0.46,274,55799,70,NULL,NULL,'SDSS J144759.73+190202.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,221.998917,19.03392,0.075,NULL,59530220485,930159695,14533745,17.9),(124073,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124073,38.55,0.46,513,55800,70,NULL,NULL,'SDSS J144759.81-015318.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,221.99925,-1.88853,0.173,NULL,43502475869,679726185,10620721,18.2),(124074,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124074,37.98,0.33,394,55801,70,NULL,NULL,'2MASX J14480079+0354175',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.003375,3.90489,0.093,NULL,58257227511,910269179,14222955,17.3),(124075,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124075,36.05,0.46,162,55802,70,NULL,NULL,'2MASX J14480118+2106001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.24',0.23,NULL,NULL,NULL,NULL,NULL,1,222.004875,21.10006,0.063,NULL,59502044362,929719443,14526866,17.24),(124076,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124076,36.83,0.46,232,55803,70,NULL,NULL,'2MASX J14480162+0209285',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.0067917,2.15792,0.117,NULL,58266304177,910411002,14225171,17.9),(124077,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124077,38.26,0.46,448,55804,70,NULL,NULL,'2MASX J14480255+5415348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.010625,54.25961,0,NULL,59193723164,924901924,14451592,18.2),(124078,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124078,38.21,0.46,439,55805,70,NULL,NULL,'2MASX J14480357+0529075',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000177,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.014917,5.48558,0.121,NULL,59333476338,927085567,14485711,18.1),(124079,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124079,36.3,0.5,182,55806,70,NULL,NULL,'2MASX J14480447-2916319',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.018708333,-29.27547,0.377,NULL,47019416766,734678386,11479349,15),(124080,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124080,35.51,0.21,127,55807,70,NULL,NULL,'GIN 348',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000053,NULL,'14.70',0.24,'E/S0',NULL,NULL,NULL,NULL,1,222.0210417,13.48056,0.017,NULL,59549779771,930465308,14538520,14.7),(124081,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124081,37.7,0.46,347,55808,70,NULL,NULL,'2MASX J14480528+0317485',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.0219583,3.29669,0.073,NULL,58257694091,910276470,14223069,17.7),(124082,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124082,37.54,0.33,322,55809,70,NULL,NULL,'SDSS J144806.74+494642.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.028125,49.77853,0.017,NULL,59935391752,936490496,14632664,18.2),(124083,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124083,36.72,0.46,221,55810,70,NULL,NULL,'2MASX J14480692+2013351',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,222.028875,20.22639,0.108,NULL,59533381962,930209093,14534517,NULL),(124084,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124084,35.46,0.46,124,55811,70,NULL,NULL,'CGCG 164-028',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000147,NULL,'15.9g',0.35,'E','Group member',NULL,NULL,NULL,1,222.03075,31.73803,0,NULL,60091543216,938930362,14670786,15.9),(124085,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124085,34.53,0.46,80.4,55812,70,NULL,NULL,'CGCG 248-021',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000167,NULL,'14.9g',0.55,'S0^-',NULL,NULL,NULL,NULL,1,222.032041667,48.09378,0.045,NULL,59936187405,936502928,14632858,14.9),(124086,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124086,36.98,0.15,249,55813,70,NULL,NULL,'SDSS J144808.01+111728.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.033375,11.29125,0.025,NULL,59367594618,927618665,14494041,17.4),(124087,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124087,35.79,0.33,144,55814,70,NULL,NULL,'CGCG 164-027',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000143,NULL,'15.6g',0.36,'E','Group member',NULL,NULL,NULL,1,222.034916667,31.71033,0,NULL,60091542956,938930358,14670786,15.6),(124088,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124088,35.05,0.2,102,55815,74.4,NULL,NULL,'CGCG 076-054',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000057,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,222.039583,14.13378,0.017,NULL,59547894675,930435854,14538060,15.7),(124089,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124089,36.48,0.46,198,55816,70,NULL,NULL,'2MASX J14480957+0604129',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00017,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,222.0397917,6.07028,0.109,NULL,59333269789,927082340,14485661,15.9),(124090,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124090,37.93,0.15,385,55817,70,NULL,NULL,'SDSS J144810.31+325525.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.043,32.92364,0,NULL,60121467087,939397923,14678092,17.4),(124091,'IRAS','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124091,33.88,0.8,59.8,55818,75,NULL,'MAT, I','ESO 327- G 020',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000013,NULL,'15',1.6,'SBc            HII',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,222.047167,-37.82578,0.301,NULL,47217344335,737771005,11527671,15),(124092,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124092,32.51,0.43,31.7,55818,75,NULL,'MAT, I, raw','ESO 327- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124093,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124093,32.64,0.43,33.7,55818,75,NULL,'MAT, I, inv','ESO 327- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124094,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124094,32.76,0.43,35.7,55818,75,NULL,'MAT, I, cor','ESO 327- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124095,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124095,32.82,0.32,36.6,55818,85,NULL,'I, raw','ESO 327- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124096,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124096,32.85,0.32,37.2,55818,85,NULL,'I, inv','ESO 327- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124097,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124097,37.28,0.46,286,55819,70,NULL,NULL,'2MASX J14481182+1951081',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.049375,19.85217,0.085,NULL,59533287302,930207614,14534493,17.2),(124098,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124098,37.86,0.46,372,55820,70,NULL,NULL,'SDSS J144813.15+073110.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.0547917,7.51947,0.053,NULL,59382221916,927847217,14497612,18),(124099,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124099,36.98,0.15,249,55821,70,NULL,NULL,'2MASX J14481476+1123169',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.061583,11.38789,0.021,NULL,59367612184,927618940,14494045,17.7),(124100,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124100,35.99,0.46,157,55822,70,NULL,NULL,'2MASX J14481584+2617048',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000097,NULL,'15.97',0.28,NULL,NULL,NULL,NULL,NULL,1,222.066208333,26.28467,0.061,NULL,60015327880,937739498,14652179,15.97),(124101,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124101,35.09,0.72,104,55823,70,NULL,NULL,'2MASX J14481687-1346124',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.11',NULL,NULL,NULL,NULL,NULL,NULL,1,222.0702917,-13.77025,0.313,NULL,46685770127,729465158,11397893,16.11),(124102,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124102,37.43,0.46,306,55824,70,NULL,NULL,'2MASX J14481712+1345265',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.7g',0.41,NULL,NULL,NULL,NULL,NULL,1,222.071333,13.75725,0.017,NULL,59549728894,930464513,14538508,15.7),(124103,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124103,36.49,0.33,199,55825,70,NULL,NULL,'2MASX J14481906+1829351',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.24',0.22,NULL,NULL,NULL,NULL,NULL,1,222.079625,18.493,0.049,NULL,59585008693,931015760,14547121,17.24),(124104,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124104,37.3,0.46,288,55826,70,NULL,NULL,'2MASX J14481916+1017089',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.0799583,10.28589,0.025,NULL,59368904876,927639138,14494361,17.5),(124105,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124105,37.54,0.33,322,55827,70,NULL,NULL,'SDSS J144820.16+494348.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.0840417,49.73025,0.017,NULL,59935228207,936487940,14632624,18.1),(124106,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124106,35.15,0.49,107,55828,75,NULL,'IR','UGC 09533',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.35',0.2,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,222.086875,13.95775,0.017,NULL,59547874539,930435539,14538055,15.35),(124107,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124107,35.58,0.2,131,55829,74.4,NULL,NULL,'UGC 09533',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000033,NULL,'15.35',0.2,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,222.086875,13.95775,0.017,NULL,59547874539,930435539,14538055,15.35),(124108,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124108,36.49,0.33,199,55830,70,NULL,NULL,'SDSS J144821.14+182200.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.63',0.14,NULL,NULL,NULL,NULL,NULL,1,222.088125,18.36669,0.041,NULL,59584982833,931015356,14547114,18.63),(124109,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124109,38.09,0.33,414,55831,70,NULL,NULL,'2MASX J14482137+5727267',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,222.089,57.45753,0.013,NULL,57727393428,901990522,14093601,17.2),(124110,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124110,35.58,0.69,131,55832,70,NULL,NULL,'2MASX J14482257-4347345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.0939583,-43.79292,0.665,NULL,47094707377,735854802,11497731,15.3),(124111,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124111,37.5,0.33,316,55833,70,NULL,NULL,'2MASX J14482399+1053439',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.099917,10.89564,0.025,NULL,59369346829,927646044,14494469,17.7),(124112,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124112,36.04,0.46,161,55834,70,NULL,NULL,'2MASX J14482435+3318272',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.1015417,33.30769,0,NULL,60124986193,939452909,14678951,16.8),(124113,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124113,38.59,0.46,522,55835,70,NULL,NULL,'SDSS J144824.60+365018.6',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.1025,36.83853,0,NULL,60072957213,938639956,14666249,16.8),(124114,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124114,37.28,0.46,285,55836,70,NULL,NULL,'2MASX J14482505+0825569',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.73',0.16,NULL,NULL,NULL,NULL,NULL,1,222.104417,8.4325,0.053,NULL,59363629940,927556717,14493073,18.73),(124115,'FP','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124115,37.61,0.46,332,55837,70,NULL,NULL,'2MASX J14482623+0232161',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000097,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.10925,2.53781,0.101,NULL,58266002746,910406292,14225098,17.2),(124116,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124116,35.03,0.47,101,55838,NULL,NULL,'H','UGC 09537',NULL,'2007A&A...465...71T',2007,1,1.42,NULL,'G',0.00003,NULL,'14.3g',0.53,'Sb',NULL,NULL,NULL,NULL,1,222.1114583,34.99806,0,NULL,60124084973,939438827,14678731,14.3),(124117,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,'R',124117,35.1,0.49,105,55838,75,NULL,'IR','UGC 09537',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124118,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124118,35.1,0.45,105,55838,NULL,NULL,'Malmquist cor.','UGC 09537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124119,'Tully-Fisher','2016-12-15 15:15:28','2016-12-16 11:20:42','1',NULL,NULL,124119,35.13,0.45,106,55838,NULL,NULL,'K','UGC 09537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124120,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124120,35.13,0.2,106,55838,74.4,NULL,NULL,'UGC 09537',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124121,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124121,35.15,0.46,107,55838,NULL,NULL,'J','UGC 09537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124122,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124122,35.17,0.44,108,55838,NULL,NULL,NULL,'UGC 09537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124123,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124123,35.43,0.4,122,55838,NULL,NULL,'mean','UGC 09537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124124,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124124,35.79,0.46,144,55839,70,NULL,NULL,'2MASX J14482692+2254431',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.112167,22.91203,0.05,NULL,59494709789,929604840,14525075,16.5),(124125,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124125,37.98,0.33,394,55840,70,NULL,NULL,'SDSS J144827.32+040152.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000083,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.113875,4.03136,0.093,NULL,58257203869,910268810,14222950,17.8),(124126,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124126,36.98,0.15,249,55841,70,NULL,NULL,'SDSS J144828.06+112039.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.116917,11.34417,0.021,NULL,59369480435,927648131,14494502,18.1),(124127,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124127,38.34,0.46,465,55842,70,NULL,NULL,'2MASX J14482804+3106052',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.117,31.1015,0,NULL,60091364333,938927567,14670743,17.9),(124128,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124128,36.34,0.61,185,55843,70,NULL,NULL,'2MASX J14482828-3610473',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.117833333,-36.17989,0.257,NULL,47228952566,737952383,11530505,14.8),(124129,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124129,37.18,0.27,273,55844,70,NULL,NULL,'2MASX J14482920+1957591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.47',0.14,NULL,NULL,NULL,NULL,NULL,1,222.1217917,19.96656,0.085,NULL,59533280063,930207500,14534492,18.47),(124130,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124130,37.18,0.27,273,55845,70,NULL,NULL,'2MASX J14482985+1951271',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.96',0.21,NULL,NULL,NULL,NULL,NULL,1,222.1245,19.85769,0.085,NULL,59533291840,930207685,14534495,17.96),(124131,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124131,36.42,0.54,193,55846,70,NULL,NULL,'2MASX J14482985-3945163',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.1245417,-39.75456,0.105,NULL,47218908724,737795448,11528053,14.4),(124132,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124132,39.27,0.46,714,55847,70,NULL,NULL,'SDSS J144830.74+244829.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.128125,24.80814,0.076,NULL,59493732541,929589570,14524837,18),(124133,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124133,37.62,0.27,334,55848,70,NULL,NULL,'2MASX J14483097+5524398',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.12925,55.41103,0,NULL,57247854182,894497721,13976526,17.3),(124134,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124134,36.98,0.15,249,55849,70,NULL,NULL,'2MASX J14483270+1120253',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000191,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.136291667,11.3405,0.021,NULL,59369513082,927648641,14494510,16.8),(124135,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124135,36.98,0.15,249,55850,70,NULL,NULL,'2MASX J14483277+1121033',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.87',0.16,NULL,NULL,NULL,NULL,NULL,1,222.136583333,11.351,0.021,NULL,59369513211,927648643,14494510,18.87),(124136,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124136,37.55,0.46,324,55851,70,NULL,NULL,'2MASX J14483282+2227181',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.136666667,22.45492,0.071,NULL,59505746440,929777288,14527770,16.9),(124137,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124137,37.34,0.33,294,55852,70,NULL,NULL,'2MASX J14483328+1507324',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.25',0.17,NULL,NULL,NULL,NULL,NULL,1,222.1385417,15.12578,0,NULL,59555098411,930548412,14539818,18.25),(124138,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124138,34.92,0.46,96.5,55853,70,NULL,NULL,'CGCG 076-061',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000127,NULL,'15.6g',0.41,NULL,NULL,NULL,NULL,NULL,1,222.1422917,11.81603,0.041,NULL,59367921335,927623770,14494121,15.6),(124139,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124139,36.98,0.15,249,55854,70,NULL,NULL,'SDSS J144836.22+111939.8',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'17.1g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.150917,11.32775,0.009,NULL,59369513466,927648647,14494510,17.1),(124140,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124140,35.73,0.22,140,55855,70,NULL,NULL,'UGC 09534',NULL,'2001MNRAS.321..277C',2001,1,1,NULL,'G',0.000107,NULL,'14.00',0.7,'E?',NULL,NULL,NULL,NULL,1,222.152083,11.32567,0.009,NULL,59369513471,927648647,14494510,14),(124141,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124141,36.3,0.25,182,55855,74.4,NULL,NULL,'UGC 09534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124142,'SNIa','2016-12-15 15:15:29','2016-12-16 11:20:42','1','SN 2006cz',NULL,124142,35.19,0.19,105,55856,74.2,NULL,'SALT 2','MCG -01-38-002',0.0425,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000213,NULL,'15.30',1.4,'SA(s)cd:',NULL,NULL,NULL,NULL,1,222.1525,-4.73619,0.193,NULL,46446980736,725734074,11339594,15.3),(124143,'SNIa','2016-12-15 15:15:29','2016-12-16 11:20:42','1','SN 2006cz',NULL,124143,35.77,0.1,143,55856,74.4,NULL,NULL,'MCG -01-38-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124144,'SNIa','2016-12-15 15:15:29','2016-12-16 11:20:42','1','SN 2006cz',NULL,124144,36.01,0.25,153,55856,73.8,NULL,'SALT 2 (SNANA)','MCG -01-38-002',0.0425,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124145,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124145,37.5,0.33,316,55857,70,NULL,NULL,'2MASX J14483849+1055363',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'QSO',0.001237,NULL,'17.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,222.1602917,10.92675,0.013,NULL,59369565749,927649464,14494522,17.2),(124146,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124146,36.27,0.46,180,55858,70,NULL,NULL,'2MASX J14483856+2302311',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.59',0.23,NULL,NULL,NULL,NULL,NULL,1,222.16075,23.04194,0.093,NULL,59494756278,929605566,14525086,16.59),(124147,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124147,38.24,0.46,445,55859,70,NULL,NULL,'2MASX J14483906+1801461',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.162875,18.02944,0.041,NULL,59584938962,931014671,14547104,17.8),(124148,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124148,37.34,0.33,294,55860,70,NULL,NULL,'2MASX J14484033+1503484',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.92',0.2,NULL,NULL,NULL,NULL,NULL,1,222.167958333,15.06347,0,NULL,59555104650,930548510,14539820,17.92),(124149,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124149,36.85,0.46,235,55861,70,NULL,NULL,'2MASX J14484069+1010333',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.169583,10.17597,0.029,NULL,59368874764,927638668,14494354,17.1),(124150,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124150,37.32,0.46,290,55862,70,NULL,NULL,'2MASX J14484133+5829089',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.1724583,58.48586,0,NULL,57725272530,901957383,14093084,16.9),(124151,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124151,37.85,0.46,372,55863,70,NULL,NULL,'2MASX J14484151+2955236',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.1729583,29.92333,0,NULL,60089557387,938899334,14670302,17.2),(124152,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124152,29.05,0.69,6.45,55864,100,NULL,'mid-IR','NGC 5762',NULL,'2013ApJ...771...88L',2013,1,1.37,'RC3 has V = 837 +- 9 km/sec.','G',0.000003,NULL,'14.0g',0.85,'Sa             HII',NULL,NULL,NULL,NULL,1,222.177375,12.45722,0.025,NULL,59549116361,930454943,14538358,14),(124153,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124153,32.84,0.4,37,55864,NULL,NULL,'mean','NGC 5762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124154,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124154,33.34,0.47,46.6,55864,NULL,NULL,'H','NGC 5762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124155,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124155,33.4,0.46,47.8,55864,NULL,NULL,'J','NGC 5762',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124156,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124156,35.17,0.2,108,55865,74.4,NULL,NULL,'KUG 1446+089',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000127,NULL,'15.8g',0.42,'Spiral',NULL,NULL,NULL,NULL,1,222.17775,8.77469,0.045,NULL,59363207753,927550121,14492970,15.8),(124157,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124157,37.24,0.33,281,55866,70,NULL,NULL,'2MASX J14484305+1903431',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.97',0.21,NULL,NULL,NULL,NULL,NULL,1,222.1795,19.06211,0.041,NULL,59530279428,930160616,14533759,17.97),(124158,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124158,37.3,0.46,289,55867,70,NULL,NULL,'2MASXi J1448437+293833',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.182583,29.64272,0,NULL,60088800502,938887507,14670117,17.4),(124159,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124159,38.22,0.46,440,55868,70,NULL,NULL,'2MASX J14484405+0711583',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.183666667,7.19956,0.065,NULL,59382280370,927848130,14497627,17.4),(124160,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124160,37.98,0.46,395,55869,70,NULL,NULL,'2MASXi J1448448+241548',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.186708333,24.26344,0.078,NULL,59495294621,929613978,14525218,17.6),(124161,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124161,36.79,0.46,228,55870,70,NULL,NULL,'LCRS B144610.8-024439',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.194875,-2.95142,0.189,NULL,43501033682,679703651,10620369,17.3),(124162,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124162,38.12,0.33,422,55871,70,NULL,NULL,'2MASX J14484686+3027446',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.96',0.18,NULL,NULL,NULL,NULL,NULL,1,222.195375,30.46242,0,NULL,60089337039,938895891,14670248,17.96),(124163,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124163,31.19,NULL,17.3,55872,72,NULL,NULL,'MCG -01-38-003',NULL,'2014Ap.....57..457K',2014,1,1.4,'HOLM 678B is a star.','G',0.000017,NULL,'15.38',1,'SB(s)m:',NULL,NULL,NULL,NULL,1,222.2000417,-3.71639,0.201,NULL,43496838305,679638098,10619345,15.38),(124164,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124164,35.59,0.46,131,55873,70,NULL,NULL,'2MASX J14484950+6207152',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000184,NULL,'15.2g',0.59,'E0',NULL,NULL,NULL,NULL,1,222.2065,62.12081,0.041,NULL,57765916518,902592445,14103006,15.2),(124165,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124165,37.97,0.46,393,55874,70,NULL,NULL,'SDSS J144850.46+103234.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.21025,10.543,0.025,NULL,59369049328,927641395,14494396,18.1),(124166,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124166,36.8,0.38,229,55875,NULL,NULL,'Malmquist cor.','2MASX J14485104+1649554',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.000023,NULL,'15.9g',0.23,'Sb',NULL,NULL,NULL,NULL,1,222.212625,16.83206,0.013,NULL,59586062603,931032228,14547378,15.9),(124167,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124167,37.06,0.33,258,55875,NULL,NULL,NULL,'2MASX J14485104+1649554',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124168,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124168,37.1,0.2,263,55875,74.4,NULL,NULL,'2MASX J14485104+1649554',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124169,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124169,37.03,0.74,255,55876,70,NULL,NULL,'2MASX J14485106-2648545',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.2127083,-26.81519,0.673,NULL,47012991620,734577994,11477781,15.7),(124170,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124170,35.79,0.33,144,55877,70,NULL,NULL,'2MASX J14485193+3140576',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000073,NULL,'15.6g',0.4,'AGN',NULL,NULL,NULL,NULL,1,222.2162917,31.68272,0,NULL,60091576958,938930889,14670795,15.6),(124171,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124171,38.6,0.46,525,55878,70,NULL,NULL,'2MASXi J1448532+243156',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.2217083,24.53228,0.076,NULL,59495753524,929621148,14525330,17.9),(124172,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124172,37.84,0.46,370,55879,70,NULL,NULL,'2MASX J14485391+3058227',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.224666667,30.97286,0,NULL,60091394112,938928033,14670750,17.8),(124173,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124173,35.85,0.73,148,55880,70,NULL,NULL,'LCRS B144616.3-061538',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.42',0.26,NULL,NULL,NULL,NULL,NULL,1,222.2294583,-6.46781,0.217,NULL,46498780816,726543450,11352241,16.42),(124174,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124174,36.93,0.46,243,55881,70,NULL,NULL,'2MASX J14485524+1514504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.23',0.28,NULL,NULL,NULL,NULL,NULL,1,222.230083,15.24725,0.009,NULL,59555178461,930549663,14539838,17.23),(124175,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124175,35.64,0.51,134,55882,70,NULL,NULL,'2MASX J14485543-1125097',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.98',NULL,NULL,NULL,NULL,NULL,NULL,1,222.231,-11.41961,0.297,NULL,46463532643,725992697,11343635,15.98),(124176,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124176,36.79,0.46,228,55883,70,NULL,NULL,'2MASX J14485571+3248367',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.232208333,32.81031,0,NULL,60121431317,939397364,14678083,16.8),(124177,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124177,38.09,0.33,414,55884,70,NULL,NULL,'SDSS J144856.50+572710.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.2354583,57.45281,0.013,NULL,57727396052,901990563,14093602,18.7),(124178,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124178,35.87,0.46,150,55885,70,NULL,NULL,'SDSS J144856.99+160913.0',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'15.3g',0.58,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.2374583,16.15361,0.005,NULL,59552945853,930514778,14539293,15.3),(124179,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124179,35.38,0.58,119,55886,70,NULL,NULL,'2MASX J14485745-4131538',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.2395,-41.53156,0.353,NULL,47089414783,735772105,11496439,13.9),(124180,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124180,35.28,0.55,114,55887,NULL,NULL,'Malmquist cor.','ESO 448- G 003',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000123,NULL,'17.0R',0.3,'Sc:            HII',NULL,NULL,NULL,NULL,1,222.243833333,-29.47153,0.373,NULL,47200833396,737513021,11523640,17),(124181,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124181,35.59,0.47,131,55887,NULL,NULL,NULL,'ESO 448- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124182,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124182,35.63,0.2,134,55887,74.4,NULL,NULL,'ESO 448- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124183,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124183,37.93,0.46,386,55888,70,NULL,NULL,'2MASX J14485861+3036167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.244167,30.60464,0,NULL,60089356994,938896203,14670253,17.6),(124184,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124184,36.04,0.46,162,55889,70,NULL,NULL,'NGC 5763',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00017,NULL,'15.2g',0.56,NULL,NULL,NULL,NULL,NULL,1,222.244667,12.49014,0.025,NULL,59549119273,930454988,14538359,15.2),(124185,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124185,36.28,0.46,181,55890,70,NULL,NULL,'2MASX J14485936+0930168',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000186,NULL,'16.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.247375,9.50478,0.017,NULL,59370631834,927666122,14494783,16),(124186,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124186,36.21,0.46,175,55891,70,NULL,NULL,'SDSS J144859.42+172331.0',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.3g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.247625,17.39197,0.013,NULL,59588203056,931065672,14547901,16.3),(124187,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124187,37.23,0.33,279,55892,70,NULL,NULL,'2MASX J14490056+1622378',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.18,NULL,NULL,NULL,NULL,NULL,1,222.2524583,16.37706,0.005,NULL,59586186759,931034168,14547408,18.32),(124188,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124188,38.53,0.46,509,55893,70,NULL,NULL,'SDSS J144900.71+433412.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.252958333,43.57011,0.013,NULL,59950274616,936723040,14636297,18.2),(124189,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124189,35.33,0.75,116,55894,70,NULL,NULL,'ESO 580- G 037',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000023,NULL,'14.72',0.7,'SAB(rs)c',NULL,NULL,NULL,NULL,1,222.253875,-20.84744,0.337,NULL,46650719215,728917487,11389335,14.72),(124190,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124190,34.53,0.8,80.7,55894,75,NULL,'MAT, I','ESO 580- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124191,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124191,33.79,0.32,57.3,55894,85,NULL,'I, raw','ESO 580- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124192,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124192,33.83,0.32,58.3,55894,85,NULL,'I, inv','ESO 580- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124193,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124193,33.93,0.43,61,55894,75,NULL,'MAT, I, raw','ESO 580- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124194,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124194,34.11,0.43,66.2,55894,75,NULL,'MAT, I, inv','ESO 580- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124195,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124195,34.13,0.43,66.9,55894,75,NULL,'MAT, I, cor','ESO 580- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124196,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124196,34.4,0.2,75.9,55894,74.4,NULL,NULL,'ESO 580- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124197,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124197,34.49,0.44,79.1,55894,NULL,NULL,NULL,'ESO 580- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124198,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124198,34.7,0.4,87.3,55894,NULL,NULL,'Malmquist cor.','ESO 580- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124199,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124199,36.43,0.46,193,55895,70,NULL,NULL,'2MASX J14490100-0038516',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000097,NULL,'16.4g',0.22,'S0',NULL,NULL,NULL,NULL,1,222.2542083,-0.64772,0.133,NULL,43501414479,679709601,10620462,16.4),(124200,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124200,33.96,0.49,61.9,55896,75,NULL,'IR','UGC 09542',NULL,'2011yCatp016004901K',2011,1,1.72,NULL,'G',0.000095,NULL,'14.5g',0.49,'Sd',NULL,NULL,NULL,NULL,1,222.254958333,42.46392,0.017,NULL,59951052111,936735189,14636487,14.5),(124201,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124201,33.97,0.44,62.2,55896,NULL,NULL,NULL,'UGC 09542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124202,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124202,33.97,0.2,62.2,55896,74.4,NULL,NULL,'UGC 09542',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124203,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124203,34.09,0.42,65.7,55896,NULL,NULL,'Malmquist cor.','UGC 09542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124204,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124204,37.41,0.46,303,55897,70,NULL,NULL,'2MASX J14490224+2423027',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.89',0.1,NULL,NULL,NULL,NULL,NULL,1,222.259333,24.38397,0.078,NULL,59496019784,929625309,14525395,18.89),(124205,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124205,37.19,0.46,275,55898,70,NULL,NULL,'2MASX J14490303+1842219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.2627917,18.70606,0.053,NULL,59584838072,931013094,14547079,17),(124206,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124206,37.94,0.46,388,55899,70,NULL,NULL,'2MASXi J1449036+244555',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.9g',NULL,NULL,NULL,NULL,NULL,NULL,1,222.265,24.76542,0.069,NULL,59493743136,929589736,14524839,17.9),(124207,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124207,36.45,0.46,195,55900,70,NULL,NULL,'2MASX J14490373+6137023',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,222.2655,61.6175,0.021,NULL,57778792871,902793638,14106150,16.2),(124208,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124208,35.93,0.58,153,55901,70,NULL,NULL,'2MASX J14490405-4126518',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.267,-41.44772,0.353,NULL,47089406911,735771982,11496437,15.6),(124209,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124209,37.24,0.33,281,55902,70,NULL,NULL,'2MASX J14490463+1911129',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.24',0.17,NULL,NULL,NULL,NULL,NULL,1,222.269167,19.18703,0.037,NULL,59530262645,930160353,14533755,18.24),(124210,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124210,35.43,NULL,122,55903,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1813',NULL,'2010Ap&SS.325..163P',2010,1,0.86,NULL,'G',0.000027,NULL,'16.00',0.09,'Sc',NULL,NULL,NULL,NULL,1,222.270541667,17.18142,0.013,NULL,59586005391,931031334,14547364,16),(124211,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124211,35.45,NULL,123,55903,NULL,NULL,'Dipole + Quadrupole','FGC 1813',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124212,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124212,35.47,NULL,124,55903,NULL,NULL,'Dipole','FGC 1813',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124213,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124213,36.18,0.43,172,55903,NULL,NULL,NULL,'FGC 1813',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124214,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124214,36.18,0.43,172,55903,NULL,NULL,'Malmquist cor.','FGC 1813',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124215,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124215,36.22,0.2,175,55903,74.4,NULL,NULL,'FGC 1813',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124216,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124216,38.54,0.46,510,55904,70,NULL,NULL,'2MASX J14490494+1537348',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.73',0.16,NULL,NULL,NULL,NULL,NULL,1,222.270583333,15.62631,0.029,NULL,59552860832,930513450,14539272,18.73),(124217,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124217,38.96,0.46,618,55905,70,NULL,NULL,'2MASX J14490498+4036013',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.270667,40.60036,0.02,NULL,59952622484,936759726,14636870,18.1),(124218,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124218,37.41,0.46,304,55906,70,NULL,NULL,'2MASX J14490601+5609458',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.275167,56.16272,0.009,NULL,57245520683,894461260,13975957,17.6),(124219,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124219,37.43,0.46,307,55907,70,NULL,NULL,'2MASX J14490646+4903243',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000196,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.276791667,49.05667,0.017,NULL,59935760728,936496261,14632754,17.1),(124220,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124220,36.97,0.46,248,55908,70,NULL,NULL,'SDSS J144907.15+054929.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.2797917,5.82497,0.109,NULL,59333405927,927084467,14485694,17.9),(124221,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124221,36.07,0.46,164,55909,70,NULL,NULL,'SBS 1447+589',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000079,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,222.280166667,58.72786,0.009,NULL,57724766909,901949482,14092960,16),(124222,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124222,35.45,0.46,123,55910,70,NULL,NULL,'CGCG 076-065',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000047,NULL,'15.1g',0.56,'E/S0',NULL,NULL,NULL,NULL,1,222.281625,10.97992,0.013,NULL,59369576543,927649633,14494525,15.1),(124223,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124223,35.51,0.25,126,55910,74.4,NULL,NULL,'CGCG 076-065',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124224,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124224,35.73,0.22,140,55910,70,NULL,NULL,'CGCG 076-065',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124225,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124225,37.65,0.46,338,55911,70,NULL,NULL,'2MASX J14490793+2631247',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.47',0.14,NULL,NULL,NULL,NULL,NULL,1,222.283167,26.52356,0.058,NULL,60016199528,937753117,14652392,18.47),(124226,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124226,32.75,0.4,35.5,55912,75,NULL,'Edat, raw','NGC 5761',NULL,'1997ApJS..109..333W',1997,1,1.3,'NGC identification is not certain.','G',0.00006,NULL,'13.35',1,'S0^0^ pec:',NULL,NULL,NULL,NULL,1,222.285333,-20.37603,0.373,NULL,46652824163,728950377,11389849,13.35),(124227,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124227,32.86,0.4,37.3,55912,75,NULL,'Edat, cor','NGC 5761',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124228,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124228,33.49,0.45,49.8,55912,NULL,NULL,'K','NGC 5761',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124229,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124229,33.69,0.4,54.6,55912,NULL,NULL,'mean','NGC 5761',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124230,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124230,36.41,0.46,191,55913,70,NULL,NULL,'2MASX J14490979-0217296',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00015,NULL,'15.5g',0.55,'E0',NULL,NULL,NULL,NULL,1,222.290833,-2.29153,0.237,NULL,43500520049,679695625,10620244,15.5),(124231,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124231,38.27,0.46,450,55914,70,NULL,NULL,'SDSS J144910.26+625106.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.292791667,62.85192,0.041,NULL,57759028098,902484814,14101325,17.9),(124232,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124232,37.63,0.46,335,55915,70,NULL,NULL,'SDSS J144910.72+174727.4',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.294667,17.79097,0.045,NULL,59588136965,931064640,14547885,16.6),(124233,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124233,36.76,0.2,225,55916,74.4,NULL,NULL,'CGCG 076-066',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000177,NULL,'15.4g',0.57,NULL,NULL,NULL,NULL,NULL,1,222.29625,11.11522,0.005,NULL,59369526794,927648856,14494513,15.4),(124234,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124234,35.51,0.21,127,55917,70,NULL,NULL,'2MASX J14491203+1329238',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'17.43',0.24,NULL,NULL,NULL,NULL,NULL,1,222.3002083,13.48992,0.029,NULL,59549767424,930465116,14538517,17.43),(124235,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124235,35.07,0.49,103,55918,75,NULL,'IR','UGC 09541',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000033,NULL,'15.5g',0.2,'Sc',NULL,NULL,NULL,NULL,1,222.3005,29.74483,0,NULL,60088822848,938887857,14670122,15.5),(124236,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124236,35.39,NULL,120,55918,NULL,NULL,'Dipole + Quadrupole','UGC 09541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124237,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124237,35.39,NULL,120,55918,NULL,NULL,'Dipole','UGC 09541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124238,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124238,35.39,NULL,120,55918,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09541',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124239,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124239,35.42,NULL,121,55918,NULL,NULL,NULL,'UGC 09541',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124240,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124240,35.75,0.2,141,55918,74.4,NULL,NULL,'UGC 09541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124241,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124241,35.43,0.32,122,55919,NULL,NULL,'Malmquist cor.','IC 1058',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000021,NULL,'14.8',0.25,'S',NULL,NULL,NULL,NULL,1,222.301625,17.02094,0.013,NULL,59586007714,931031370,14547365,14.8),(124242,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124242,35.51,0.3,127,55919,NULL,NULL,NULL,'IC 1058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124243,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124243,35.56,0.49,130,55919,75,NULL,'IR','IC 1058',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124244,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124244,35.78,0.2,143,55919,74.4,NULL,NULL,'IC 1058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124245,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124245,35.96,0.47,155,55919,NULL,NULL,'H','IC 1058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124246,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124246,36.08,0.46,164,55919,NULL,NULL,'J','IC 1058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124247,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124247,36.08,0.4,165,55919,NULL,NULL,'mean','IC 1058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124248,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124248,36.1,0.45,166,55919,NULL,NULL,'K','IC 1058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124249,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124249,37.18,0.27,273,55920,70,NULL,NULL,'SDSS J144912.43+195043.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.301833,19.84547,0.074,NULL,59533726442,930214475,14534601,17.8),(124250,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124250,35.85,0.33,148,55921,70,NULL,NULL,'2MASX J14491307+0716068',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.304333,7.26867,0.065,NULL,59382256046,927847750,14497621,16.5),(124251,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124251,38.12,0.33,422,55922,70,NULL,NULL,'2MASX J14491413+3033248',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.85',0.12,NULL,NULL,NULL,NULL,NULL,1,222.308833333,30.55697,0,NULL,60089459557,938897805,14670278,18.85),(124252,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124252,38.12,0.46,422,55923,70,NULL,NULL,'2MASX J14491521+1146008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.313333,11.76694,0.021,NULL,59367943615,927624118,14494126,17.4),(124253,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124253,36.62,0.46,211,55924,70,NULL,NULL,'2MASX J14491563+0538595',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000155,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,222.3152083,5.64989,0.085,NULL,59333331522,927083305,14485676,16.7),(124254,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124254,36.43,0.7,193,55925,70,NULL,NULL,'2MASX J14491576-3617028',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,222.315667,-36.28417,0.257,NULL,47228917675,737951838,11530497,14.6),(124255,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124255,37.12,0.23,266,55926,70,NULL,NULL,'2MASX J14491671+3644133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.319625,36.737,0,NULL,60072978872,938640294,14666254,17.5),(124256,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124256,38.1,0.33,416,55927,70,NULL,NULL,'2MASX J14491670+0446515',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.319666667,4.78103,0.109,NULL,59336529734,927133277,14486457,17.4),(124257,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124257,36.02,0.33,160,55928,70,NULL,NULL,'2MASX J14491705+2745303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.75',0.17,NULL,NULL,NULL,NULL,NULL,1,222.321083333,27.7585,0.059,NULL,60014091846,937720185,14651877,17.75),(124258,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124258,37.71,0.46,348,55929,70,NULL,NULL,'2MASX J14491750+6140352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000128,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.323041667,61.67639,0.021,NULL,57765105747,902579777,14102809,17.9),(124259,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124259,37.95,0.46,389,55930,70,NULL,NULL,'2MASX J14492078+0341183',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.336416667,3.68831,0.081,NULL,58256867031,910263547,14222867,17.1),(124260,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124260,37.92,0.46,384,55931,70,NULL,NULL,'2MASX J14492174+1828479',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,222.340583333,18.47994,0.049,NULL,59585035087,931016173,14547127,18.1),(124261,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124261,37.23,0.33,279,55932,70,NULL,NULL,'SDSS J144922.36+162557.0',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,'PHOT','16.7g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.343167,16.4325,0.005,NULL,59586198806,931034356,14547411,16.7),(124262,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124262,36.79,0.26,228,55933,70,NULL,NULL,'GIN 371',NULL,'2001MNRAS.321..277C',2001,1,0.31,NULL,'G',0.000077,NULL,'15.26',0.22,'S',NULL,NULL,NULL,NULL,1,222.343375,16.43217,0.005,NULL,59586198806,931034356,14547411,15.26),(124263,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124263,37.11,0.33,264,55934,70,NULL,NULL,'2MASX J14492245+1725119',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,222.343667,17.41992,0.013,NULL,59588039419,931063115,14547861,18.53),(124264,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124264,37.55,0.46,323,55935,70,NULL,NULL,'2MASX J14492245+1610359',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,222.343708333,16.17678,0,NULL,59585519844,931023747,14547246,16.5),(124265,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124265,38.1,0.33,416,55936,70,NULL,NULL,'SDSS J144922.52+044918.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000105,NULL,'17.7g',0.18,'AGN',NULL,NULL,NULL,NULL,1,222.343875,4.82189,0.105,NULL,59336547523,927133555,14486461,17.7),(124266,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124266,37.36,0.33,296,55937,70,NULL,NULL,'2MASX J14492252+2559353',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.50',0.15,NULL,NULL,NULL,NULL,NULL,1,222.3439583,25.99308,0.036,NULL,60015705873,937745404,14652271,18.5),(124267,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124267,38.25,0.46,447,55938,70,NULL,NULL,'SDSS J144924.73+084035.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.353083333,8.6765,0.045,NULL,59363221825,927550341,14492974,18.3),(124268,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124268,36.02,0.33,160,55939,70,NULL,NULL,'2MASX J14492496+2746223',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.29',0.24,'AGN',NULL,NULL,NULL,NULL,1,222.354125,27.77292,0.059,NULL,60014088651,937720135,14651877,17.29),(124269,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124269,36.25,0.46,178,55940,70,NULL,NULL,'2MASX J14492661+0858158',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'16.09',0.21,NULL,NULL,NULL,NULL,NULL,1,222.360875,8.97111,0.041,NULL,59363251824,927550809,14492981,16.09),(124270,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124270,37.89,0.46,378,55941,70,NULL,NULL,'2MASX J14492707+2159518',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.3627917,21.99772,0.065,NULL,59501469884,929710466,14526726,17.8),(124271,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124271,36.65,0.46,213,55942,70,NULL,NULL,'2MASX J14492757+1130287',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.365083,11.50789,0.009,NULL,59370190138,927659220,14494675,16.6),(124272,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124272,37.59,0.46,329,55943,70,NULL,NULL,'2MASX J14492785+4452532',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.366083,44.88139,0,NULL,59988912633,937326759,14645730,17.5),(124273,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124273,36.67,0.46,216,55944,70,NULL,NULL,'2MASX J14492811+2836083',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.0002,NULL,'16.82',0.34,NULL,NULL,NULL,NULL,NULL,1,222.3670417,28.60239,0.009,NULL,60013179137,937705924,14651655,16.82),(124274,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124274,37.12,0.23,266,55945,70,NULL,NULL,'2MASX J14492919+3650524',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.37175,36.84792,0,NULL,60072945915,938639779,14666246,16.7),(124275,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124275,37.4,0.46,302,55946,NULL,NULL,'Malmquist cor.','MCG +03-38-030',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000023,NULL,'15.5',0.3,'Sab',NULL,NULL,NULL,NULL,1,222.374125,16.55994,0.009,NULL,59586237082,931034954,14547421,15.5),(124276,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124276,37.5,0.44,317,55946,NULL,NULL,NULL,'MCG +03-38-030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124277,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124277,37.55,0.2,324,55946,74.4,NULL,NULL,'MCG +03-38-030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124278,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124278,31.44,0.49,19.4,55947,75,NULL,'IR','ARP 261 NED01',NULL,'2011yCatp016004901K',2011,1,3,NULL,'G',0.000007,NULL,'13.35',2,'IB(s)m pec','in a triple',NULL,NULL,NULL,1,222.377417,-10.17331,0.317,NULL,46461755777,725964934,11343202,13.35),(124279,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124279,32.3,0.4,28.8,55947,75,NULL,'B','ARP 261 NED01',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124280,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124280,38.02,0.69,401,55948,70,NULL,NULL,'2MASX J14493213-2310215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.383917,-23.17272,0.417,NULL,46525203258,726956300,11358692,16.2),(124281,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124281,37.66,0.46,340,55949,70,NULL,NULL,'2MASX J14493276+3117430',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.3865,31.29528,0,NULL,60091638205,938931846,14670810,17.8),(124282,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124282,35.42,0.62,121,55950,NULL,NULL,'Malmquist cor.','CGCG 105-039',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000023,NULL,'15.7',0.21,'Sa',NULL,NULL,NULL,NULL,1,222.38875,17.2,0.013,NULL,59588058467,931063413,14547865,15.7),(124283,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124283,35.55,0.59,129,55950,NULL,NULL,NULL,'CGCG 105-039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124284,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124284,35.59,0.2,131,55950,74.4,NULL,NULL,'CGCG 105-039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124285,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124285,37.88,0.21,376,55951,70,NULL,NULL,'2MASX J14493368+3345070',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.390416667,33.75189,0,NULL,60125316423,939458069,14679032,17.8),(124286,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124286,38.85,0.46,589,55952,70,NULL,NULL,'2MASX J14493457+2329438',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.3939583,23.49569,0.055,NULL,59494825661,929606650,14525103,17.9),(124287,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124287,36.31,0.25,183,55953,74.4,NULL,NULL,'CGCG 076-068',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GTrpl',0.000097,NULL,NULL,NULL,'DB',NULL,NULL,NULL,NULL,1,222.394125,11.24808,0.009,NULL,59369504249,927648503,14494507,NULL),(124288,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124288,37.12,0.23,266,55954,70,NULL,NULL,'2MASX J14493479+3645124',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.3947917,36.75342,0,NULL,60072977352,938640271,14666254,17.2),(124289,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124289,37.12,0.23,266,55955,70,NULL,NULL,'2MASX J14493480+3642454',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,222.394833,36.71278,0,NULL,60072924142,938639439,14666241,16.5),(124290,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124290,35.73,0.22,140,55956,70,NULL,NULL,'SDSS J144934.93+111455.1',NULL,'2001MNRAS.321..277C',2001,1,0.47,NULL,'G',NULL,'PHOT','16.0g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.395583333,11.24867,0.009,NULL,59369504220,927648503,14494507,16),(124291,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124291,36.51,0.46,201,55957,70,NULL,NULL,'2MASX J14493615+2208508',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,222.400791667,22.1475,0.072,NULL,59505704634,929776634,14527759,15.8),(124292,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124292,37.72,0.46,350,55958,70,NULL,NULL,'LCRS B144701.7-023859',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.406875,-2.85625,0.233,NULL,43500348061,679692938,10620202,17.5),(124293,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124293,38.4,0.46,478,55959,70,NULL,NULL,'SDSS J144937.88-013249.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.407875,-1.547,0.161,NULL,43502278841,679723106,10620673,18.3),(124294,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124294,37.93,0.33,385,55960,70,NULL,NULL,'SDSS J144938.44+472730.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000142,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.4102083,47.45847,0.017,NULL,59989341566,937333461,14645835,18.6),(124295,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124295,37.69,0.46,345,55961,70,NULL,NULL,'2MASX J14493915+4632503',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000193,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,222.41325,46.54739,0.025,NULL,59991015185,937359612,14646243,16.3),(124296,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124296,38.37,0.46,471,55962,70,NULL,NULL,'SDSS J144939.47+070656.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.4144583,7.11567,0.065,NULL,59382259958,927847811,14497622,18.5),(124297,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124297,33.84,NULL,58.7,55963,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09546',NULL,'2010Ap&SS.325..163P',2010,1,1.46,NULL,'G',0.000013,NULL,'17.01',0.1,'Sd',NULL,NULL,NULL,NULL,1,222.415333,23.56103,0.055,NULL,59494821175,929606580,14525102,17.01),(124298,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124298,33.86,NULL,59.1,55963,NULL,NULL,NULL,'UGC 09546',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124299,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124299,33.86,NULL,59.1,55963,NULL,NULL,'Dipole + Quadrupole','UGC 09546',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124300,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124300,33.86,NULL,59.3,55963,NULL,NULL,'Dipole','UGC 09546',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124301,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124301,34.33,0.2,73.5,55963,74.4,NULL,NULL,'UGC 09546',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124302,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124302,37.62,0.27,334,55964,70,NULL,NULL,'2MASX J14494036+5516303',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,222.418125,55.27517,0.005,NULL,57247335379,894489615,13976400,16.7),(124303,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124303,38.08,0.46,414,55965,70,NULL,NULL,'2MASX J14494065+2034257',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.65',0.15,NULL,NULL,NULL,NULL,NULL,1,222.419417,20.57389,0.081,NULL,59532244716,930191323,14534239,18.65),(124304,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124304,35.76,0.46,142,55966,70,NULL,NULL,'CGCG 193-003',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000073,NULL,'15.2g',0.45,'S0',NULL,NULL,NULL,NULL,1,222.4197917,35.69031,0,NULL,60123424593,939428509,14678570,15.2),(124305,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124305,37.58,0.46,329,55967,70,NULL,NULL,'2MASX J14494135+1850147',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.79',0.13,NULL,NULL,NULL,NULL,NULL,1,222.422375,18.83728,0.049,NULL,59530072957,930157389,14533709,18.79),(124306,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124306,37.76,0.46,356,55968,70,NULL,NULL,'2MASX J14494135+1334193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.4224583,13.57206,0.029,NULL,59549880201,930466878,14538544,17.2),(124307,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124307,37.36,0.33,296,55969,70,NULL,NULL,'2MASX J14494148+3314410',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,222.4227083,33.24478,0,NULL,60125070850,939454232,14678972,16.9),(124308,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124308,38.1,0.46,417,55970,70,NULL,NULL,'2MASX J14494252+2828433',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.427333333,28.47858,0,NULL,60013389561,937709211,14651706,17.2),(124309,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124309,37.62,0.27,334,55971,70,NULL,NULL,'2MASX J14494259+5518283',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.4275,55.30778,0.025,NULL,57247793576,894496774,13976512,16.8),(124310,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124310,36.3,0.8,182,55972,70,NULL,NULL,'2MASX J14494262-4132261',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,222.4277083,-41.54072,0.345,NULL,47089224394,735769131,11496392,14.5),(124311,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124311,36.28,0.1,180,55973,70,NULL,NULL,'ABELL 1983b',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',0.000207,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,222.433333,16.89333,0.013,NULL,59586033097,931031767,14547371,NULL),(124312,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124312,38.02,0.46,402,55974,70,NULL,NULL,'LCRS B144709.8-022959',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.439833333,-2.70639,0.237,NULL,43500375959,679693374,10620208,17.9),(124313,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124313,37.72,0.46,351,55975,70,NULL,NULL,'2MASX J14494578+4907075',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.440667,49.11869,0.017,NULL,59935790973,936496733,14632761,18.3),(124314,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124314,37.5,0.46,317,55976,70,NULL,NULL,'2MASX J14494583+4941285',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.441,49.69117,0.005,NULL,59935282504,936488789,14632637,16.9),(124315,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124315,33.4,NULL,47.9,55977,NULL,NULL,'Dipole','UGC 09556',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000068,NULL,'15.3g',0.25,'Scd(f)','Isolated galaxy',NULL,NULL,NULL,1,222.4420417,60.39853,0.013,NULL,57771359482,902677491,14104335,15.3),(124316,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124316,33.41,NULL,48.1,55977,NULL,NULL,'Dipole + Quadrupole','UGC 09556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124317,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124317,33.42,NULL,48.4,55977,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09556',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124318,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124318,33.71,0.4,55.2,55977,NULL,NULL,NULL,'UGC 09556',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124319,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124319,33.78,0.49,57,55977,75,NULL,'IR','UGC 09556',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124320,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124320,33.83,0.2,58.3,55977,74.4,NULL,NULL,'UGC 09556',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124321,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124321,33.92,0.49,60.9,55977,NULL,NULL,'Malmquist cor.','UGC 09556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124322,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124322,34.05,0.46,64.6,55977,NULL,NULL,NULL,'UGC 09556',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124323,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124323,38.13,0.27,422,55978,70,NULL,NULL,'2MASX J14494760+3458029',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.4482917,34.96747,0,NULL,60124066699,939438542,14678727,17.5),(124324,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124324,35.85,0.33,148,55979,70,NULL,NULL,'2MASX J14494832+0723257',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.7g',0.45,NULL,NULL,NULL,NULL,NULL,1,222.451417,7.39039,0.065,NULL,59382380616,927849697,14497651,15.7),(124325,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124325,38.13,0.27,422,55980,70,NULL,NULL,'2MASX J14494857+3501329',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.4522917,35.02569,0,NULL,60124060166,939438440,14678725,17.6),(124326,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124326,37.88,0.21,376,55981,70,NULL,NULL,'2MASX J14494890+3351269',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.45375,33.85744,0,NULL,60125323059,939458172,14679033,17),(124327,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124327,37.11,0.33,264,55982,70,NULL,NULL,'2MASX J14494934+1742234',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'17.07',0.31,NULL,NULL,NULL,NULL,NULL,1,222.455583,17.70636,0.013,NULL,59588246163,931066346,14547911,17.07),(124328,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124328,37.53,0.46,320,55983,70,NULL,NULL,'2MASX J14494996+1602144',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,222.45825,16.03722,0.005,NULL,59585482646,931023166,14547236,18.6),(124329,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124329,37.85,0.46,372,55984,70,NULL,NULL,'2MASX J14495000+4853235',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000192,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.45825,48.88994,0.037,NULL,59935756427,936496194,14632753,17),(124330,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124330,32.75,0.4,35.5,55985,75,NULL,'Edat, raw','ESO 580- G 040',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00015,NULL,'14.49',0.8,'SAB0^0^:',NULL,NULL,NULL,NULL,1,222.458375,-20.27825,0.373,NULL,46652844659,728950697,11389854,14.49),(124331,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124331,32.86,0.4,37.3,55985,75,NULL,'Edat, cor','ESO 580- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124332,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124332,33.59,0.48,52.3,55985,70,NULL,NULL,'ESO 580- G 040',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124333,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124333,36.62,0.46,211,55986,70,NULL,NULL,'2MASX J14495021+1644134',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'17.96',0.4,'E/S0','Group member',NULL,NULL,NULL,1,222.459125,16.73706,0.013,NULL,59586216763,931034636,14547416,17.96),(124334,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124334,37.94,0.46,387,55987,70,NULL,NULL,'2MASXi J1449504+333013',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.460166667,33.50381,0,NULL,60125030345,939453599,14678962,18.3),(124335,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124335,38.04,0.46,406,55988,70,NULL,NULL,'SDSS J144950.58+241024.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.4607917,24.17342,0.098,NULL,59496030085,929625470,14525397,17.7),(124336,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124336,37.52,0.46,319,55989,70,NULL,NULL,'2MASX J14495068+6344153',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.4615,63.73775,0.017,NULL,57756515094,902445548,14100711,18),(124337,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124337,37.25,0.46,282,55990,70,NULL,NULL,'2MASX J14495165+2329026',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,222.46525,23.48403,0.055,NULL,59494815597,929606493,14525101,18.42),(124338,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124338,36.36,0.64,187,55991,70,NULL,NULL,'2MASX J14495279-3123548',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,222.470041667,-31.39856,0.433,NULL,47202692075,737542063,11524094,14.5),(124339,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124339,37.66,0.46,341,55992,70,NULL,NULL,'2MASX J14495419+4403342',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.475875,44.05953,0.013,NULL,59992200959,937378139,14646533,17.5),(124340,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124340,38.13,0.27,422,55993,70,NULL,NULL,'2MASX J14495469+3452450',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.477875,34.87897,0,NULL,60124062279,939438473,14678726,17.4),(124341,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124341,37.82,0.46,366,55994,70,NULL,NULL,'2MASX J14495601+0754117',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.4835417,7.90325,0.057,NULL,59381210999,927831421,14497365,17.8),(124342,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124342,37.06,0.46,258,55995,70,NULL,NULL,'SDSS J144956.19+034758.0',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00009,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.484167,3.79944,0.085,NULL,59333816191,927090877,14485794,16.8),(124343,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124343,37.71,0.46,349,55996,70,NULL,NULL,'SDSS J144956.60+041901.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.485875,4.31711,0.101,NULL,59334370339,927099536,14485930,17.9),(124344,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124344,36.86,0.46,236,55997,70,NULL,NULL,'2MASX J14495698+1054221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.487333,10.90614,0.005,NULL,59369454206,927647721,14494495,16.8),(124345,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124345,36.56,0.25,205,55998,74.4,NULL,NULL,'GIN 368',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00005,NULL,'14.80',0.55,'E/S0','Group member',NULL,NULL,NULL,1,222.4874583,16.80847,0.013,NULL,59586134622,931033353,14547396,14.8),(124346,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124346,36.79,0.26,228,55998,70,NULL,NULL,'GIN 368',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124347,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124347,36.28,0.1,180,55998,70,NULL,'ABELL 1983b, BGC','GIN 368',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124348,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124348,35.52,0.33,127,55999,70,NULL,NULL,'CGCG 020-021',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'15.2g',0.55,'E0',NULL,NULL,NULL,NULL,1,222.489083,0.55831,0.117,NULL,58252759293,910199363,14221865,15.2),(124349,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124349,37.77,0.33,358,56000,70,NULL,NULL,'2MASX J14495860+6232593',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.494333,62.54989,0.033,NULL,57765545852,902586653,14102916,17.6),(124350,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124350,37.45,0.46,309,56001,70,NULL,NULL,'2MASX J14495883+3133190',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.495167,31.55533,0,NULL,60091754853,938933669,14670838,17.4),(124351,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124351,36.56,0.25,205,56002,74.4,NULL,NULL,'GIN 367',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.00005,NULL,'17.42',0.22,'S0','Group member',NULL,NULL,NULL,1,222.4964583,16.80989,0.013,NULL,59586134698,931033354,14547396,17.42),(124352,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124352,36.79,0.26,228,56002,70,NULL,NULL,'GIN 367',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124353,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124353,36.49,0.09,198,56003,70,NULL,NULL,'SDSS J144959.10+164837.0',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.0g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.4962917,16.81028,0.013,NULL,59586134698,931033354,14547396,16),(124354,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124354,36.89,0.46,238,56004,70,NULL,NULL,'2MASX J14495920+5510272',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.496875,55.17436,0.005,NULL,57244529419,894445772,13975715,17.8),(124355,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124355,36.18,0.2,172,56005,74.4,NULL,NULL,'2MASX J14495928+1644166',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00005,NULL,'17.28',0.2,'Sc','Group member',NULL,NULL,NULL,1,222.49725,16.73772,0.013,NULL,59586350628,931036728,14547448,17.28),(124356,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124356,36.22,0.44,175,56005,NULL,NULL,'Malmquist cor.','2MASX J14495928+1644166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124357,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124357,36.27,0.43,179,56005,NULL,NULL,NULL,'2MASX J14495928+1644166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124358,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124358,37.89,0.46,378,56006,70,NULL,NULL,'SDSS J145000.08+341401.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,222.500333,34.23375,0,NULL,60125262492,939457226,14679019,18.6),(124359,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124359,36.68,0.33,216,56007,70,NULL,NULL,'2MASX J14500035+2944396',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000201,NULL,'16.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,222.5015417,29.74425,0,NULL,60088858247,938888410,14670131,16.6),(124360,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124360,35.78,0.41,143,56008,NULL,NULL,'Malmquist cor.','CGCG 105-041',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000023,NULL,'15.40',0.5,'SBb','Group member',NULL,NULL,NULL,1,222.506708333,17.04653,0.013,NULL,59586041284,931031895,14547373,15.4),(124361,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124361,36.03,0.36,161,56008,NULL,NULL,NULL,'CGCG 105-041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124362,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124362,36.19,0.2,173,56008,74.4,NULL,NULL,'CGCG 105-041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124363,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124363,35.52,0.33,127,56009,70,NULL,NULL,'2MASX J14500215+0034436',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000084,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,222.5090417,0.57878,0.117,NULL,58253500855,910210950,14222046,16),(124364,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124364,37.93,0.33,385,56010,70,NULL,NULL,'2MASX J14500229+4730321',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.5097917,47.50886,0.017,NULL,59989328565,937333258,14645832,17.5),(124365,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124365,37.99,0.46,396,56011,70,NULL,NULL,'2MASX J14500236+3250000',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.51,32.83336,0,NULL,60122735743,939417745,14678402,17.1),(124366,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124366,42.08,NULL,2610,56012,65,NULL,'L = 10e57 photons/s','GRB 970402',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,222.5125,-69.335,NULL,NULL,45041427247,703772300,10996442,NULL),(124367,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124367,43.17,NULL,4300,56012,65,NULL,'L = 2 x 10e58 photons/s','GRB 970402',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124368,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124368,33.77,NULL,56.7,56013,NULL,NULL,NULL,'FGC 1830',NULL,'2000BSAO...50....5K',2000,1,1,NULL,'G',0.00016,':','17.0',0.08,'Sd',NULL,NULL,NULL,NULL,1,222.514583,83.30403,0.185,NULL,56962730138,890042658,13906916,17),(124369,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124369,33.8,NULL,57.4,56013,NULL,NULL,'Dipole + Quadrupole','FGC 1830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124370,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124370,33.8,NULL,57.4,56013,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124371,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124371,33.8,NULL,57.6,56013,NULL,NULL,'Dipole','FGC 1830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124372,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124372,36.31,0.46,183,56014,70,NULL,NULL,'VII Zw 565 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,222.515083333,57.30456,0.017,NULL,57727453004,901991453,14093616,17),(124373,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124373,35.83,0.33,147,56015,70,NULL,NULL,'2MASX J14500451+5421593',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000183,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,222.518625,54.36647,0,NULL,59190532651,924852072,14450813,15.9),(124374,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124374,36.84,0.46,233,56016,70,NULL,NULL,'2MASX J14500466+1919163',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.519541667,19.32139,0.053,NULL,59533648979,930213265,14534582,17.3),(124375,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124375,37.36,0.33,296,56017,70,NULL,NULL,'2MASX J14500473+2603406',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.519833333,26.06136,0.082,NULL,60015687482,937745116,14652267,17.4),(124376,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124376,37.44,0.46,307,56018,70,NULL,NULL,'2MASX J14500479+3054370',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.5202083,30.91028,0,NULL,60090878937,938919983,14670624,17.8),(124377,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124377,37.88,0.21,376,56019,70,NULL,NULL,'2MASX J14500503+3350480',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,222.521125,33.84669,0,NULL,60125192537,939456133,14679002,17),(124378,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124378,36.81,0.46,230,56020,70,NULL,NULL,'2MASX J14500564+1757036',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.44',0.16,NULL,NULL,NULL,NULL,NULL,1,222.5235417,17.95089,0.017,NULL,59588254874,931066482,14547913,18.44),(124379,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124379,37.05,0.46,257,56021,70,NULL,NULL,'2MASX J14500618+0523386',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.5257083,5.39422,0.085,NULL,59336102362,927126599,14486353,17.4),(124380,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124380,37.46,0.46,310,56022,70,NULL,NULL,'2MASX J14500647+6323573',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.526875,63.39936,0.017,NULL,57756269121,902441705,14100651,17.1),(124381,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124381,37.47,0.46,312,56023,70,NULL,NULL,'2MASX J14500852+5236205',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.535417,52.60561,0,NULL,59192596268,924884316,14451317,16.9),(124382,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124382,37.87,0.46,376,56024,70,NULL,NULL,'2MASX J14500894+2521046',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.61',0.13,NULL,NULL,NULL,NULL,NULL,1,222.537416667,25.35131,0.065,NULL,60014468320,937726067,14651969,18.61),(124383,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124383,38.42,0.46,483,56025,70,NULL,NULL,'2MASX J14500941+1458346',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.5392917,14.97625,0.021,NULL,59547691367,930432677,14538010,17.9),(124384,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124384,37.05,0.46,257,56026,70,NULL,NULL,'2MASX J14500994+1959413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.10',0.19,NULL,NULL,NULL,NULL,NULL,1,222.541583333,19.995,0.053,NULL,59533915255,930217425,14534647,18.1),(124385,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124385,37.88,0.21,376,56027,70,NULL,NULL,'2MASX J14501034+3352520',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.543083,33.88106,0,NULL,60125200493,939456257,14679004,17.9),(124386,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124386,37.24,0.46,281,56028,70,NULL,NULL,'2MASX J14501321+4826485',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.5549583,48.44686,0.049,NULL,59933786359,936465411,14632272,17),(124387,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124387,36.24,0.46,177,56029,70,NULL,NULL,'2MASX J14501485+2132133',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,222.561833,21.53717,0.082,NULL,59532096498,930189007,14534203,18.43),(124388,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124388,37.96,0.46,390,56030,70,NULL,NULL,'2MASX J14501496+3734264',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.562375,37.57389,0,NULL,60073900509,938654695,14666479,18),(124389,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124389,37.93,0.46,385,56031,70,NULL,NULL,'SDSS J145017.75+364847.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.574,36.81319,0,NULL,60118056226,939344628,14677259,18.2),(124390,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124390,38.42,0.46,482,56032,70,NULL,NULL,'SDSS J145018.19+115158.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.575833,11.86617,0.025,NULL,59369949254,927655457,14494616,18.5),(124391,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124391,37.88,0.21,376,56033,70,NULL,NULL,'2MASX J14501823+3405380',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000193,NULL,'16.4g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,222.5760417,34.09394,0,NULL,60125285529,939457586,14679024,16.4),(124392,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124392,37.75,0.33,355,56034,70,NULL,NULL,'2MASX J14501881+5450553',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.578417,54.84872,0,NULL,57244619982,894447187,13975737,18),(124393,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124393,36.02,0.46,160,56035,70,NULL,NULL,'2MASX J14501890+1019482',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'18.22',0.21,'AGN',NULL,NULL,NULL,NULL,1,222.578833,10.32997,0.025,NULL,59369293415,927645209,14494456,18.22),(124394,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124394,38.08,0.46,412,56036,70,NULL,NULL,'2MASX J14502071+2901329',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.45',0.14,NULL,NULL,NULL,NULL,NULL,1,222.58625,29.02589,0,NULL,60092844712,938950698,14671104,18.45),(124395,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124395,37.75,0.33,355,56037,70,NULL,NULL,'2MASX J14502124+5449073',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.5882917,54.81872,0,NULL,57244630331,894447348,13975739,18.2),(124396,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124396,35.75,0.74,141,56038,NULL,NULL,'Malmquist cor.','ESO 448- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.49',0.5,'Sb',NULL,NULL,NULL,NULL,1,222.594083,-31.03289,0.441,NULL,47201719153,737526861,11523857,14.49),(124397,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124397,36.19,0.6,173,56038,NULL,NULL,NULL,'ESO 448- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124398,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124398,36.23,0.2,176,56038,74.4,NULL,NULL,'ESO 448- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124399,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124399,37.64,0.46,338,56039,70,NULL,NULL,'SDSS J145022.80+125430.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.5950417,12.90839,0.037,NULL,59550097212,930470268,14538597,16.8),(124400,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124400,35.58,NULL,131,56040,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09547',NULL,'2010Ap&SS.325..163P',2010,1,1.22,NULL,'G',0.000043,NULL,'15.5g',0.27,'Sb',NULL,NULL,NULL,NULL,1,222.597417,10.32772,0.025,NULL,59369293768,927645215,14494456,15.5),(124401,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124401,35.6,NULL,132,56040,NULL,NULL,'Dipole + Quadrupole','UGC 09547',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124402,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124402,35.61,NULL,132,56040,NULL,NULL,'Dipole','UGC 09547',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124403,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124403,36,0.49,159,56040,75,NULL,'IR','UGC 09547',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124404,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124404,36.56,0.2,205,56040,74.4,NULL,NULL,'UGC 09547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124405,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124405,38.39,0.46,477,56041,70,NULL,NULL,'2MASX J14502339+2239593',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000192,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.597583,22.66658,0.124,NULL,59494309762,929598590,14524977,17.4),(124406,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124406,37.63,0.46,336,56042,70,NULL,NULL,'SDSS J145024.20+010013.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.600875,1.00389,0.133,NULL,58253368393,910208881,14222013,18.3),(124407,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124407,37.68,0.46,343,56043,70,NULL,NULL,'2MASX J14502547+0437594',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000091,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.606291667,4.63319,0.109,NULL,59336371692,927130807,14486418,17),(124408,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124408,37.28,0.46,286,56044,70,NULL,NULL,'2MASX J14502575+1523217',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.15,NULL,NULL,NULL,NULL,NULL,1,222.607416667,15.38939,0.029,NULL,59554930852,930545794,14539778,18.67),(124409,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124409,35.69,0.35,138,56045,NULL,NULL,'Malmquist cor.','UGC 09550',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00002,NULL,'15.32',0.2,'Sc','Group member',NULL,NULL,NULL,1,222.611125,16.74522,0,NULL,59586360926,931036889,14547451,15.32),(124410,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124410,35.95,0.2,155,56045,74.4,NULL,NULL,'UGC 09550',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124411,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124411,35.96,0.31,156,56045,NULL,NULL,NULL,'UGC 09550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124412,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124412,36.98,0.15,249,56046,70,NULL,NULL,'2MASX J14502809+1106497',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000123,NULL,'15.4g',0.44,NULL,NULL,NULL,NULL,NULL,1,222.617,11.11375,0.009,NULL,59370276339,927660567,14494696,15.4),(124413,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124413,35.87,0.33,149,56047,70,NULL,NULL,'2MASX J14502856+0957477',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,222.619083,9.96319,0.029,NULL,59368447198,927631987,14494249,16.5),(124414,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124414,35.45,0.46,123,56048,70,NULL,NULL,'CGCG 134-040',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'15.7',0.33,NULL,NULL,NULL,NULL,NULL,1,222.6192917,26.03114,0.082,NULL,60015721044,937745641,14652275,15.7),(124415,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124415,38.24,0.33,445,56049,70,NULL,NULL,'2MASX J14502991+5158585',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.62475,51.98289,0.029,NULL,59930127395,936408240,14631378,17.7),(124416,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124416,37.83,0.46,368,56050,70,NULL,NULL,'2MASX J14503049+2410480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.626958333,24.18003,0.098,NULL,59496193261,929628019,14525437,16.9),(124417,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124417,36.58,0.33,207,56051,70,NULL,NULL,'2MASX J14503094+0929507',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.5g',0.34,'AGN',NULL,NULL,NULL,NULL,1,222.628875,9.49739,0.037,NULL,59368315318,927629926,14494217,16.5),(124418,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124418,38.15,0.46,427,56052,70,NULL,NULL,'LCRS B144756.0-024337',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00022,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.633208333,-2.93286,0.237,NULL,43500226174,679691033,10620172,17.7),(124419,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124419,37.74,0.46,353,56053,70,NULL,NULL,'2MASX J14503238+5759513',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.6347917,57.99769,0,NULL,57723371142,901927674,14092619,17),(124420,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124420,36.58,0.33,207,56054,70,NULL,NULL,'CGCG 076-071',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'15.6',0.31,NULL,NULL,NULL,NULL,NULL,1,222.638167,9.62839,0.037,NULL,59368490875,927632669,14494260,15.6),(124421,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124421,37.81,0.46,366,56055,70,NULL,NULL,'2MASX J14503359+3047224',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.640083333,30.7895,0,NULL,60088989203,938890456,14670163,18.1),(124422,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124422,38.29,0.46,455,56056,70,NULL,NULL,'2MASX J14503384+3453184',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.640917,34.88847,0,NULL,60123951729,939436745,14678699,17.5),(124423,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124423,34.25,0.2,70.8,56057,74.4,NULL,NULL,'CGCG 134-042',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000332,NULL,'15.44',0.4,NULL,NULL,NULL,NULL,NULL,1,222.642166667,24.82158,0.055,NULL,59495699008,929620297,14525317,15.44),(124424,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124424,33.06,0.8,40.9,56058,75,NULL,'MAT, I','ESO 580- G 041',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00001,NULL,'14.77',0.4,'Sbc? sp','in a pair',NULL,NULL,NULL,1,222.651917,-18.15117,0.293,NULL,46699059968,729672812,11401137,14.77),(124425,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124425,31.76,0.32,22.5,56058,85,NULL,'I, inv','ESO 580- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124426,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124426,31.77,0.32,22.6,56058,85,NULL,'I, raw','ESO 580- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124427,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124427,31.99,0.4,25,56058,75,NULL,NULL,'ESO 580- G 041',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124428,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124428,32.06,0.43,25.9,56058,75,NULL,'MAT, I, raw','ESO 580- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124429,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124429,32.09,0.43,26.1,56058,75,NULL,'MAT, I, inv','ESO 580- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124430,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124430,32.22,0.62,27.8,56058,NULL,NULL,NULL,'ESO 580- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124431,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124431,32.23,0.2,27.9,56058,74.4,NULL,NULL,'ESO 580- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124432,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124432,32.32,0.59,29.1,56058,NULL,NULL,'Malmquist cor.','ESO 580- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124433,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124433,32.32,0.43,29.1,56058,75,NULL,'3.6 micron, color + selection bias corrected','ESO 580- G 041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124434,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124434,32.33,0.43,29.2,56058,75,NULL,'3.6 micron, color corrected','ESO 580- G 041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124435,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124435,32.37,0.43,29.9,56058,75,NULL,'MAT, I, cor','ESO 580- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124436,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124436,32.55,0.49,32.3,56058,75,NULL,'IR','ESO 580- G 041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124437,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124437,33.13,0.4,42.2,56058,NULL,NULL,'mean','ESO 580- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124438,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124438,33.29,0.47,45.5,56058,NULL,NULL,'H','ESO 580- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124439,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124439,36.87,0.86,237,56059,70,NULL,NULL,'2MASX J14503678-4215356',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.6532917,-42.25983,0.353,NULL,47087724060,735745688,11496026,15.7),(124440,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124440,37.67,0.46,342,56060,70,NULL,NULL,'2MASX J14503831+3452134',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.659625,34.87053,0,NULL,60123951300,939436739,14678699,17),(124441,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124441,36.29,0.63,181,56061,70,NULL,NULL,'2MASX J14503834-2836195',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,222.6597917,-28.60547,0.593,NULL,47011885318,734560708,11477511,15.3),(124442,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124442,38.09,0.33,414,56062,70,NULL,NULL,'2MASX J14503993+3425415',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.66625,34.42808,0,NULL,60124427967,939444186,14678815,16.8),(124443,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124443,38.09,0.33,414,56063,70,NULL,NULL,'SDSS J145041.24+342541.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,222.671833,34.42828,0,NULL,60124427913,939444186,14678815,18.7),(124444,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124444,38.11,0.46,419,56064,70,NULL,NULL,'2MASX J14504123+0620107',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.671875,6.33642,0.097,NULL,59379048648,927797635,14496838,18),(124445,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124445,36.68,0.33,216,56065,70,NULL,NULL,'2MASX J14504148+2947050',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.2g',0.38,'E',NULL,NULL,NULL,NULL,1,222.6727917,29.78481,0,NULL,60088742721,938886605,14670103,16.2),(124446,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124446,37.83,0.46,368,56066,70,NULL,NULL,'2MASX J14504170+2129295',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.67375,21.49164,0.073,NULL,59532115917,930189311,14534207,17.6),(124447,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124447,37.6,0.46,331,56067,70,NULL,NULL,'2MASX J14504186+1814565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.32',0.18,NULL,NULL,NULL,NULL,NULL,1,222.6745,18.24922,0.029,NULL,59587943472,931061616,14547837,18.32),(124448,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124448,36.43,0.46,193,56068,70,NULL,NULL,'2MASX J14504193+0515094',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.674666667,5.25264,0.085,NULL,59336600241,927134378,14486474,17.6),(124449,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124449,38.49,0.46,499,56069,70,NULL,NULL,'2MASX J14504352+4938036',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000206,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.681417,49.63444,0.013,NULL,59935272941,936488639,14632634,16.7),(124450,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124450,38.24,0.33,445,56070,70,NULL,NULL,'2MASX J14504441+5200396',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.6849583,52.01114,0.029,NULL,59930124646,936408197,14631378,17.5),(124451,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124451,37.32,0.46,291,56071,70,NULL,NULL,'2MASX J14504458+1505378',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.86',0.2,NULL,NULL,NULL,NULL,NULL,1,222.6857083,15.09372,0.029,NULL,59547823092,930434735,14538042,17.86),(124452,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124452,36.9,0.46,240,56072,70,NULL,NULL,'2MASX J14504551+1958025',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.33',0.15,NULL,NULL,NULL,NULL,NULL,1,222.6897917,19.96744,0.041,NULL,59533943115,930217861,14534654,18.33),(124453,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124453,35.83,0.33,147,56073,70,NULL,NULL,'IC 1069',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000206,NULL,'14.5g',0.8,'S0',NULL,NULL,NULL,NULL,1,222.693833333,54.41117,0,NULL,59190482603,924851290,14450801,14.5),(124454,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124454,37.36,0.46,296,56074,70,NULL,NULL,'2MASX J14504673+3610014',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,222.694541667,36.167,0,NULL,60125378658,939459041,14679047,16.3),(124455,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124455,35.49,0.46,125,56075,70,NULL,NULL,'SDSS J145047.30+252530.0',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.24',0.32,NULL,NULL,NULL,NULL,NULL,1,222.697083,25.42503,0.052,NULL,60015515019,937742422,14652225,16.24),(124456,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124456,37.34,0.46,294,56076,70,NULL,NULL,'2MASX J14504849+2428012',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.07',0.18,NULL,NULL,NULL,NULL,NULL,1,222.702125,24.46708,0.065,NULL,59495874866,929623044,14525360,18.07),(124457,'Maser','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124457,35.51,0.19,126,56077,NULL,NULL,NULL,'NGC 5765B',NULL,'2016ApJ...817..128G',2016,1,0.7,'Component \'b)\' in UGC notes.','G',0.000063,NULL,'14.9',0.6,'Sa-b','Pair member (points to parent)',NULL,NULL,NULL,1,222.714625,5.11447,0.109,NULL,59336797655,927137463,14486522,14.9),(124458,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124458,37.84,0.33,369,56078,70,NULL,NULL,'2MASX J14505256+1131137',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.7189583,11.52039,0.025,NULL,59370212551,927659571,14494680,17.5),(124459,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124459,36.52,0.46,201,56079,70,NULL,NULL,'2MASX J14505258+0005402',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000105,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,222.719125,0.0945,0.117,NULL,58252711028,910198609,14221853,16.1),(124460,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124460,37.96,0.46,392,56080,70,NULL,NULL,'2MASX J14505385+0442592',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,222.7245417,4.7165,0.109,NULL,59336366429,927130725,14486417,17.2),(124461,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124461,38.18,0.46,433,56081,70,NULL,NULL,'SDSS J145055.03+315936.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.729333,31.99356,0,NULL,60091189395,938924834,14670700,18.4),(124462,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124462,36.62,0.46,211,56082,70,NULL,NULL,'2MASX J14505526+5610220',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.729958333,56.17269,0,NULL,57245532237,894461441,13975960,16.7),(124463,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124463,37.36,0.33,296,56083,70,NULL,NULL,'2MASX J14505543+3312422',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.7310417,33.21161,0,NULL,60122873989,939419906,14678436,17.4),(124464,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124464,36.58,0.33,207,56084,70,NULL,NULL,'2MASX J14505547-0029324',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000112,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,222.73125,-0.49239,0.121,NULL,43488637025,679509953,10617343,16),(124465,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124465,35.23,0.46,111,56085,70,NULL,NULL,'SDSS J145055.73+381852.4',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.73225,38.31456,0.049,NULL,60073295647,938645244,14666331,16.8),(124466,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124466,36.27,0.46,180,56086,70,NULL,NULL,'2MASX J14505632+0248012',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.734625,2.80033,0.157,NULL,58265221453,910394085,14224907,16.9),(124467,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124467,31.82,0.8,23.1,56087,75,NULL,'B','UGC 09560',NULL,'1988NBGC.C....0000T',1988,1,0.94,NULL,'G',0.000007,NULL,'14.7g',0.33,'pec; BCDG      HII','Pair member (points to parent)',NULL,NULL,NULL,1,222.735375,35.57156,0,NULL,60123391521,939427992,14678562,14.7),(124468,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124468,38.39,0.46,476,56088,70,NULL,NULL,'2MASX J14505944+5058104',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.7475,50.96964,0.013,NULL,59943078609,936610603,14634540,17.6),(124469,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124469,36.8,0.33,229,56089,70,NULL,NULL,'2MASX J14505983+3031193',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000211,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,222.74925,30.52203,0,NULL,60089005752,938890714,14670167,16.3),(124470,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124470,37.08,0.27,261,56090,70,NULL,NULL,'2MASX J14510119+4853176',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.755,48.88831,0.037,NULL,59935704204,936495378,14632740,17.6),(124471,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124471,35.31,0.2,115,56091,74.4,NULL,NULL,'CGCG 076-075',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000096,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.7592083,11.98878,0.021,NULL,59369872959,927654264,14494597,16.4),(124472,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124472,38.06,0.17,410,56092,70,NULL,NULL,'2MASX J14510234+3229273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,222.7597917,32.49094,0,NULL,60090009681,938906401,14670412,18),(124473,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124473,34.13,0.8,66.9,56093,75,NULL,'MAT, I','ESO 273- G 006',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.58',0.5,'S...',NULL,NULL,NULL,NULL,1,222.760916667,-43.91867,0.629,NULL,47108472970,736069890,11501092,13.58),(124474,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124474,33.73,0.32,55.8,56093,85,NULL,'I, raw','ESO 273- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124475,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124475,33.75,0.32,56.3,56093,85,NULL,'I, inv','ESO 273- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124476,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124476,33.81,0.48,57.8,56093,NULL,NULL,'Malmquist cor.','ESO 273- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124477,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124477,33.94,0.43,61.5,56093,75,NULL,'MAT, I, raw','ESO 273- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124478,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124478,33.98,0.44,62.6,56093,NULL,NULL,NULL,'ESO 273- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124479,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124479,34.02,0.2,63.7,56093,74.4,NULL,NULL,'ESO 273- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124480,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124480,34.07,0.43,65.2,56093,75,NULL,'MAT, I, inv','ESO 273- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124481,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124481,34.13,0.43,66.9,56093,75,NULL,'MAT, I, cor','ESO 273- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124482,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124482,36.68,0.33,216,56094,70,NULL,NULL,'2MASX J14510274+1847321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.11',0.19,NULL,NULL,NULL,NULL,NULL,1,222.7615,18.79239,0.049,NULL,59586642751,931041292,14547520,18.11),(124483,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124483,37.59,0.33,329,56095,70,NULL,NULL,'2MASX J14510314+0344061',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000093,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.763166667,3.73494,0.101,NULL,59333838850,927091232,14485800,16.4),(124484,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124484,36.8,0.46,229,56096,70,NULL,NULL,'2MASX J14510317+1017288',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,222.763333,10.29131,0.029,NULL,59369322670,927645666,14494463,16.3),(124485,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124485,36.1,0.27,166,56097,70,NULL,NULL,'2MASX J14510352+5531140',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.0002,NULL,'15.1g',0.64,'E0',NULL,NULL,NULL,NULL,1,222.7645,55.52064,0.025,NULL,57247680622,894495009,13976484,15.1),(124486,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124486,36.58,0.33,207,56098,70,NULL,NULL,'2MASX J14510387-0027434',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000102,NULL,'16.2g',0.29,'S0',NULL,NULL,NULL,NULL,1,222.766291667,-0.46222,0.125,NULL,43488630134,679509845,10617341,16.2),(124487,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124487,37.66,0.46,340,56099,70,NULL,NULL,'2MASX J14510410+2112541',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.766958333,21.21492,0.056,NULL,59532724693,930198823,14534356,17.8),(124488,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124488,37.08,0.27,261,56100,70,NULL,NULL,'2MASX J14510457+4915184',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000204,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,222.7692083,49.25514,0.021,NULL,59935585155,936493518,14632711,16),(124489,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124489,38.08,0.46,414,56101,70,NULL,NULL,'SDSS J145105.53+201202.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.773083,20.20064,0.049,NULL,59533876886,930216826,14534637,18.6),(124490,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124490,37.61,0.33,332,56102,70,NULL,NULL,'2MASX J14510676+5518180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.7780417,55.30503,0.005,NULL,57244196344,894440567,13975633,17.3),(124491,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124491,37.59,0.33,329,56103,70,NULL,NULL,'2MASX J14510674+0340291',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.77825,3.67469,0.101,NULL,59333876940,927091827,14485809,17.1),(124492,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124492,36.65,0.46,214,56104,70,NULL,NULL,'2MASX J14510739+2829052',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.780833,28.48475,0.006,NULL,60013364159,937708814,14651700,17.3),(124493,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124493,38.31,0.46,459,56105,70,NULL,NULL,'2MASX J14510744+3551023',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.781208333,35.85086,0,NULL,60125450972,939460171,14679065,17.8),(124494,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124494,37.24,0.46,281,56106,70,NULL,NULL,'2MASX J14510833+1813081',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,222.7847917,18.21886,0.029,NULL,59587947920,931061686,14547838,18.08),(124495,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124495,35.33,0.5,116,56107,70,NULL,NULL,'2MASX J14510866-3755217',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,222.786167,-37.92267,0.261,NULL,47216941960,737764718,11527573,13.2),(124496,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124496,37.06,0.46,258,56108,70,NULL,NULL,'2MASX J14510952+5823371',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.7895417,58.39364,0,NULL,57724672888,901948013,14092937,17.4),(124497,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124497,37.15,0.46,269,56109,70,NULL,NULL,'2MASX J14510983+1450482',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.92',0.18,NULL,NULL,NULL,NULL,NULL,1,222.791,14.84675,0.021,NULL,59547781075,930434079,14538032,17.92),(124498,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124498,35.8,0.33,145,56110,91,NULL,'H','UGC 09558',NULL,'1984ApJ...278..475B',1984,1,1,NULL,'G',0.00001,NULL,'15.11',0.6,'Scd:','Group member',NULL,NULL,NULL,1,222.7912917,17.18892,0.025,NULL,59585659421,931025928,14547280,15.11),(124499,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124499,36.15,0.2,170,56110,74.4,NULL,NULL,'UGC 09558',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124500,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124500,37.55,0.46,323,56111,70,NULL,NULL,'2MASX J14511010+1944411',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.7920417,19.74469,0.049,NULL,59533924750,930217574,14534649,16.7),(124501,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124501,38.06,0.17,410,56112,70,NULL,NULL,'2MASX J14511049+3220313',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.793625,32.34217,0,NULL,60089975989,938905874,14670404,17.9),(124502,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124502,36.53,0.46,202,56113,70,NULL,NULL,'2MASX J14511168+2525072',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.06',0.23,NULL,NULL,NULL,NULL,NULL,1,222.798625,25.41864,0.052,NULL,60012634556,937697414,14651522,17.06),(124503,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124503,33.23,0.8,44.3,56114,75,NULL,'MAT, I','UGCA 395',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'13.98',1.1,'SB(s)dm pec:',NULL,NULL,NULL,NULL,1,222.801625,-20.44075,0.357,NULL,46650428269,728912941,11389264,13.98),(124504,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124504,31.6,0.32,20.9,56114,85,NULL,'I, inv','UGCA 395',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124505,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124505,31.61,0.32,21,56114,85,NULL,'I, raw','UGCA 395',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124506,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124506,32.09,0.43,26.2,56114,75,NULL,'MAT, I, raw','UGCA 395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124507,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124507,32.1,0.43,26.3,56114,75,NULL,'MAT, I, inv','UGCA 395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124508,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124508,32.28,0.2,28.6,56114,74.4,NULL,NULL,'UGCA 395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124509,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124509,32.41,0.43,30.4,56114,75,NULL,'MAT, I, cor','UGCA 395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124510,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124510,32.48,0.6,31.3,56114,NULL,NULL,NULL,'UGCA 395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124511,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124511,32.58,0.58,32.8,56114,NULL,NULL,'Malmquist cor.','UGCA 395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124512,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124512,37.63,0.46,336,56115,70,NULL,NULL,'SDSS J145112.45+021250.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.801875,2.214,0.125,NULL,58252473335,910194895,14221795,18.3),(124513,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124513,38.31,0.46,458,56116,70,NULL,NULL,'2MASX J14511256+3528483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000178,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,222.802583333,35.48019,0,NULL,60124118828,939439356,14678739,18),(124514,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124514,35.87,0.33,149,56117,70,NULL,NULL,'2MASX J14511395+0939588',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,222.8082083,9.66636,0.037,NULL,59368522507,927633164,14494268,16.2),(124515,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124515,37.4,0.27,302,56118,70,NULL,NULL,'2MASX J14511409+4636551',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.808916667,46.61528,0.017,NULL,59989701837,937339091,14645923,17.8),(124516,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124516,36.68,0.33,216,56119,70,NULL,NULL,'IC 1061',NULL,'2015arXiv151105856S',2015,1,0.5,'Mislabeled as A1983 D in Colless, et al. (1993,MNRAS,262,475).','G',0.000147,NULL,'14.62',0.4,'E/S0',NULL,NULL,NULL,NULL,1,222.809333,18.75756,0.037,NULL,59586643432,931041303,14547520,14.62),(124517,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124517,36.68,0.23,217,56119,70,NULL,NULL,'IC 1061',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124518,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124518,37.11,0.25,264,56119,74.4,NULL,NULL,'IC 1061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124519,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124519,36.63,0.46,212,56120,70,NULL,NULL,'2MASX J14511425+2407442',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.21',0.14,NULL,NULL,NULL,NULL,NULL,1,222.809333,24.12914,0.088,NULL,59496158514,929627476,14525429,17.21),(124520,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124520,37.4,0.27,302,56121,70,NULL,NULL,'SDSS J145114.27+512231.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000012,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.809458333,51.37536,0.037,NULL,59929358568,936396227,14631191,18.3),(124521,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124521,31.88,0.8,23.8,56122,75,NULL,'B','UGC 09562',NULL,'1988NBGC.C....0000T',1988,1,0.98,NULL,'G',0.00006,NULL,'14.3g',0.77,'Pec            HII','Pair member (points to parent)',NULL,NULL,NULL,1,222.8100417,35.54228,0,NULL,60124117246,939439331,14678739,14.3),(124522,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124522,36.8,0.33,229,56123,70,NULL,NULL,'CGCG 164-036',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000203,NULL,'15.1g',0.58,'cD',NULL,NULL,NULL,NULL,1,222.8100417,30.69222,0,NULL,60089039520,938891242,14670175,15.1),(124523,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124523,38.06,0.17,410,56124,70,NULL,NULL,'2MASX J14511444+3222413',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'16.9g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,222.810125,32.37819,0,NULL,60089981142,938905955,14670405,16.9),(124524,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124524,38.06,0.17,410,56125,70,NULL,NULL,'SDSS J145114.50+322105.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.810417,32.35153,0,NULL,60090189855,938909216,14670456,18.3),(124525,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124525,36.21,0.16,175,56126,74.4,NULL,NULL,'CGCG 105-046',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000048,NULL,'15.3',0.4,'Sab','Group member',NULL,NULL,NULL,1,222.811083,16.69544,0,NULL,59586335764,931036496,14547445,15.3),(124526,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124526,36.79,0.26,228,56126,70,NULL,NULL,'CGCG 105-046',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124527,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124527,35.52,0.85,127,56126,NULL,NULL,'Malmquist cor.','CGCG 105-046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124528,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124528,35.94,0.7,154,56126,NULL,NULL,NULL,'CGCG 105-046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124529,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124529,36.21,0.16,175,56126,74.4,NULL,NULL,'CGCG 105-046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124530,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124530,36.99,NULL,250,56126,NULL,NULL,NULL,'CGCG 105-046',NULL,'1996PASJ...48..657S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124531,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124531,38.06,0.17,410,56127,70,NULL,NULL,'SDSS J145115.69+321947.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,222.815417,32.32983,0,NULL,60090190799,938909231,14670456,18.6),(124532,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124532,37.07,0.46,260,56128,70,NULL,NULL,'2MASX J14511576+2003071',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.22,'AGN',NULL,NULL,NULL,NULL,1,222.815875,20.05211,0.049,NULL,59533866598,930216665,14534635,17),(124533,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124533,37.62,0.46,334,56129,70,NULL,NULL,'2MASX J14511660+0619518',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.819208333,6.33119,0.101,NULL,59382486040,927851344,14497677,16.9),(124534,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124534,36.68,0.23,217,56130,70,NULL,NULL,'IC 1062',NULL,'2001MNRAS.321..277C',2001,1,NULL,'Mislabeled as A1983 E in Colless, et al. (1993,MNRAS,262,475).','G',0.00017,NULL,'13.96',NULL,'E/S0',NULL,NULL,NULL,NULL,1,222.823583,18.68697,0.037,NULL,59586648480,931041382,14547521,13.96),(124535,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124535,37.11,0.25,264,56130,74.4,NULL,NULL,'IC 1062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124536,'SNII optical','2016-12-15 15:15:29','2016-12-16 11:20:42','1','SN 2001dc',NULL,124536,31.9,0.19,24,56131,NULL,NULL,'SCM','NGC 5777',NULL,'2015ApJ...799..215P',2015,1,3.1,NULL,'G',0.000017,NULL,'14.1B',0.4,'Sbc            NLAGN',NULL,NULL,NULL,NULL,1,222.824375,58.97794,0.005,NULL,57725121027,901955016,14093047,14.1),(124537,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124537,33.14,0.43,42.5,56131,75,NULL,'3.6 micron, color corrected','NGC 5777',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124538,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124538,33.17,0.2,43.1,56131,74.4,NULL,NULL,'NGC 5777',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124539,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124539,33.19,0.43,43.4,56131,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5777',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124540,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124540,33.5,NULL,50.2,56131,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124541,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124541,33.5,NULL,50.2,56131,NULL,NULL,'Dipole','NGC 5777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124542,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124542,33.5,NULL,50.2,56131,NULL,NULL,'Dipole + Quadrupole','NGC 5777',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124543,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124543,33.59,NULL,52.3,56131,NULL,NULL,NULL,'NGC 5777',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124544,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124544,37.35,0.46,296,56132,70,NULL,NULL,'2MASX J14511786+1610122',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'18.41',0.2,'E','Group member',NULL,NULL,NULL,1,222.8245417,16.17008,0,NULL,59585581340,931024708,14547261,18.41),(124545,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124545,35.53,0.68,128,56133,NULL,NULL,NULL,'AGC 241306',NULL,'2009ApJS..182..474S',2009,1,0.29,NULL,'G',0.000017,NULL,'19.08',0.09,'Sc',NULL,NULL,NULL,NULL,1,222.828625,16.69503,0,NULL,59586343160,931036611,14547447,19.08),(124546,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124546,35.57,0.2,130,56133,74.4,NULL,NULL,'AGC 241306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124547,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124547,35.78,0.61,143,56133,NULL,NULL,'Malmquist cor.','AGC 241306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124548,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124548,38.19,0.46,435,56134,70,NULL,NULL,'2MASX J14511950+2708032',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.65',0.14,NULL,NULL,NULL,NULL,NULL,1,222.831125,27.13433,0.085,NULL,60013813404,937715834,14651809,18.65),(124549,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124549,37.49,0.46,315,56135,70,NULL,NULL,'2MASX J14512003+3039504',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000207,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.833625,30.66383,0,NULL,60089025891,938891029,14670172,16.6),(124550,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124550,37.49,0.46,315,56136,70,NULL,NULL,'2MASX J14512014+3605281',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.833875,36.09111,0,NULL,60125591817,939462372,14679099,17.6),(124551,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124551,36.1,0.27,166,56137,70,NULL,NULL,'2MASX J14512270+5524051',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00011,NULL,'15.1g',0.62,'E0',NULL,NULL,NULL,NULL,1,222.8447083,55.40136,0.005,NULL,57244253472,894441460,13975647,15.1),(124552,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124552,38.46,0.46,492,56138,70,NULL,NULL,'SDSS J145123.48+104812.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.847875,10.80344,0.013,NULL,59369718588,927651852,14494560,18.2),(124553,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124553,37.41,0.33,303,56139,70,NULL,NULL,'2MASX J14512384+0516490',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,222.8492917,5.28022,0.101,NULL,59336772269,927137066,14486516,17.1),(124554,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124554,38.14,0.46,424,56140,70,NULL,NULL,'2MASX J14512453+0807498',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.852333,8.13056,0.045,NULL,59381892639,927842072,14497532,17.8),(124555,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124555,37.23,0.46,279,56141,70,NULL,NULL,'2MASX J14512494+1539402',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,222.8539583,15.66117,0.025,NULL,59589539705,931086557,14548227,18.28),(124556,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124556,37.56,0.27,324,56142,70,NULL,NULL,'2MASX J14512598+3133243',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,222.858291667,31.55669,0,NULL,60091716289,938933067,14670829,16.3),(124557,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124557,38.02,0.46,401,56143,70,NULL,NULL,'2MASX J14512634+4816557',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.859917,48.28225,0.037,NULL,59934304947,936473514,14632398,17.3),(124558,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124558,37.08,0.27,261,56144,70,NULL,NULL,'2MASX J14512674+4911226',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,222.861375,49.18947,0.021,NULL,59935618543,936494039,14632719,16.7),(124559,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124559,36.94,0.46,244,56145,70,NULL,NULL,'2MASX J14512699+3931342',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.8627083,39.52622,0.022,NULL,60071165648,938611963,14665811,17.8),(124560,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124560,36.16,0.46,171,56146,70,NULL,NULL,'2MASX J14512748+2803478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.864708333,28.06342,0.037,NULL,60013290101,937707657,14651682,17.3),(124561,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124561,38.6,0.46,525,56147,70,NULL,NULL,'2MASX J14513121+5553530',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.88,55.89825,0,NULL,57245445577,894460087,13975938,18.1),(124562,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124562,38.23,0.46,443,56148,70,NULL,NULL,'2MASX J14513273+2454288',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.72',0.13,NULL,NULL,NULL,NULL,NULL,1,222.88625,24.90803,0.091,NULL,59495711854,929620497,14525320,18.72),(124563,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124563,36.29,0.46,181,56149,70,NULL,NULL,'2MASX J14513327+4526182',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000186,NULL,'16.0g',0.35,'AGN',NULL,NULL,NULL,NULL,1,222.888666667,45.43847,0.025,NULL,59988466989,937319796,14645621,16),(124564,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124564,37.1,0.46,263,56150,70,NULL,NULL,'2MASX J14513371+5013457',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.890458333,50.22928,0.021,NULL,59943325893,936614467,14634601,17.7),(124565,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124565,37.4,0.27,302,56151,70,NULL,NULL,'2MASX J14513439+5117007',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,222.8932917,51.28347,0.037,NULL,59929389644,936396713,14631198,17.5),(124566,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124566,37.77,0.33,358,56152,70,NULL,NULL,'2MASX J14513538+6243055',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,222.8977083,62.71803,0.033,NULL,57765538474,902586538,14102914,16.4),(124567,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124567,37.44,0.46,308,56153,70,NULL,NULL,'2MASX J14513554+0005520',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.898,0.09789,0.125,NULL,58253523089,910211298,14222051,17.7),(124568,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124568,37.41,0.33,303,56154,70,NULL,NULL,'2MASX J14513709+0520260',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,222.904416667,5.34053,0.101,NULL,59336707508,927136054,14486500,16.3),(124569,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124569,36.49,0.09,198,56155,70,NULL,NULL,'2MASX J14513715+1634558',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00007,NULL,'17.3g',0.17,'E','Group member',NULL,NULL,NULL,1,222.9047917,16.58222,0,NULL,59586298009,931035906,14547436,17.3),(124570,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124570,37.56,0.27,324,56156,70,NULL,NULL,'2MASX J14513804+3125386',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.908625,31.42731,0,NULL,60090836233,938919316,14670614,17.5),(124571,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124571,37.84,0.33,369,56157,70,NULL,NULL,'SDSS J145138.52+114052.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.9105417,11.68139,0.025,NULL,59370022572,927656602,14494634,17.7),(124572,'Sosies','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124572,35.2,0.25,110,56158,NULL,NULL,NULL,'NGC 5772',NULL,'2002A&A...393...57T',2002,1,1.91,NULL,'G',0.000023,NULL,'13.3g',0.94,'SA(r)b:','Isolated galaxy',NULL,NULL,NULL,1,222.912,40.59917,0.049,NULL,59949970028,936718281,14636223,13.3),(124573,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124573,33.36,0.69,46.9,56158,100,NULL,'mid-IR','NGC 5772',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124574,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124574,34.07,0.47,65.1,56158,NULL,NULL,'H','NGC 5772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124575,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124575,34.12,0.46,66.8,56158,NULL,NULL,'J','NGC 5772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124576,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124576,34.14,0.45,67.4,56158,NULL,NULL,'K','NGC 5772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124577,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124577,34.21,0.4,69.6,56158,NULL,NULL,'mean','NGC 5772',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124578,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124578,37.42,0.46,305,56159,70,NULL,NULL,'2MASX J14513892+5339486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.9124583,53.66369,0.013,NULL,59190737463,924855272,14450863,17.7),(124579,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124579,37.81,0.33,364,56160,70,NULL,NULL,'2MASX J14514007+0002470',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.916875,0.04639,0.125,NULL,58252987800,910202934,14221920,17.3),(124580,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124580,37.4,0.27,302,56161,70,NULL,NULL,'2MASX J14514157+5127476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000127,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,222.923417,51.46328,0.037,NULL,59929355297,936396176,14631190,17.8),(124581,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124581,37.41,0.27,304,56162,70,NULL,NULL,'2MASX J14514191+4522112',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000196,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.9245,45.36967,0.025,NULL,59988474695,937319917,14645623,16.7),(124582,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124582,37.41,0.27,304,56163,70,NULL,NULL,'2MASX J14514305+4522362',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.9294583,45.37669,0.025,NULL,59988474035,937319906,14645623,17.5),(124583,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124583,37.81,0.33,364,56164,70,NULL,NULL,'2MASX J14514384+0003460',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,222.932667,0.06283,0.125,NULL,58252986983,910202921,14221920,17.7),(124584,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124584,38.51,0.46,504,56165,70,NULL,NULL,'SDSS J145144.38+243917.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.2r',NULL,NULL,NULL,NULL,NULL,NULL,1,222.935,24.65492,0.042,NULL,59495830952,929622358,14525349,17.2),(124585,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124585,34.3,0.74,72.3,56166,NULL,NULL,NULL,'ESO 580- G 046',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.91',0.5,'Sb',NULL,NULL,NULL,NULL,1,222.9354583,-22.67792,0.445,NULL,46524464338,726944755,11358511,15.91),(124586,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124586,34.34,0.2,73.8,56166,74.4,NULL,NULL,'ESO 580- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124587,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124587,34.47,0.68,78.4,56166,NULL,NULL,'Malmquist cor.','ESO 580- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124588,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124588,37.65,0.33,340,56167,70,NULL,NULL,'2MASX J14514517+3245096',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000195,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,222.938291667,32.75275,0,NULL,60122745533,939417898,14678404,16.3),(124589,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124589,36.88,0.27,238,56168,70,NULL,NULL,'2MASX J14514576+3017396',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,222.940583,30.29439,0.006,NULL,60089090033,938892031,14670187,16.6),(124590,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124590,37.41,0.27,304,56169,70,NULL,NULL,'2MASX J14514675+4523422',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.944833,45.39525,0.025,NULL,59988465674,937319776,14645621,17.8),(124591,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124591,36.6,0.46,209,56170,70,NULL,NULL,'2MASX J14514721+1044358',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000172,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,222.9467083,10.74336,0.013,NULL,59368617639,927634650,14494291,16.3),(124592,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124592,37.51,0.46,317,56171,70,NULL,NULL,'2MASX J14514720+0508550',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,222.946791667,5.14861,0.109,NULL,59336811328,927137677,14486526,17.1),(124593,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124593,34.03,0.47,64,56172,NULL,NULL,'H','IC 1060',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'14.2b',0.8,'(R\')SB(r)a:',NULL,NULL,NULL,NULL,1,222.9472917,-7.23264,0.237,NULL,46502199058,726596860,11353075,14.2),(124594,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124594,34.12,0.45,66.7,56172,NULL,NULL,'K','IC 1060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124595,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124595,34.16,0.46,68,56172,NULL,NULL,'J','IC 1060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124596,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124596,34.17,0.4,68.1,56172,NULL,NULL,'mean','IC 1060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124597,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124597,36.77,0.46,226,56173,70,NULL,NULL,'2MASX J14514796+2609478',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.03',0.14,NULL,NULL,NULL,NULL,NULL,1,222.949833,26.16317,0.11,NULL,60016042093,937750657,14652354,18.03),(124598,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124598,38.03,0.46,404,56174,70,NULL,NULL,'2MASX J14514836+1348098',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,222.951583,13.80261,0.029,NULL,59550275075,930473048,14538641,17.4),(124599,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124599,37.06,0.46,258,56175,70,NULL,NULL,'2MASX J14514938+3133266',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.955875,31.55739,0,NULL,60090815381,938918990,14670609,17.2),(124600,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124600,37.57,0.46,326,56176,70,NULL,NULL,'2MASX J14515010+4502552',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,222.958875,45.04853,0.033,NULL,59992822283,937387848,14646685,17.6),(124601,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124601,37.78,0.46,360,56177,70,NULL,NULL,'2MASX J14515268+2458596',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,222.969375,24.98325,0.091,NULL,59492299580,929567180,14524487,18.53),(124602,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124602,36.88,0.27,238,56178,70,NULL,NULL,'2MASX J14515264+3024476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.35',0.25,NULL,NULL,NULL,NULL,NULL,1,222.969541667,30.41322,0.006,NULL,60089113326,938892395,14670193,17.35),(124603,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124603,36.28,0.56,180,56179,70,NULL,NULL,'2MASX J14515290-3606141',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,222.970583333,-36.10394,0.249,NULL,47242800452,738168757,11533886,14.2),(124604,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124604,38.07,0.46,411,56180,70,NULL,NULL,'2MASX J14515299+3141226',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000198,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,222.970833,31.68972,0,NULL,60091675715,938932433,14670819,16.8),(124605,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124605,38.16,0.46,428,56181,70,NULL,NULL,'2MASX J14515338+2830487',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.46',0.13,NULL,NULL,NULL,NULL,NULL,1,222.972417,28.51364,0.006,NULL,60081551572,938774243,14668347,18.46),(124606,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124606,37.63,0.46,335,56182,70,NULL,NULL,'2MASX J14515427+3116486',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,222.976291667,31.28014,0,NULL,60090950979,938921109,14670642,16.7),(124607,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124607,37.99,0.46,396,56183,70,NULL,NULL,'2MASX J14515516+1007258',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,222.98,10.12369,0.033,NULL,59369237447,927644335,14494442,17.5),(124608,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124608,38.21,0.46,438,56184,70,NULL,NULL,'SDSS J145156.10+101703.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,222.98375,10.28439,0.037,NULL,59369285468,927645085,14494454,18.3),(124609,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124609,38.53,0.46,509,56185,70,NULL,NULL,'SDSS J145156.66-013327.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,222.986083,-1.55761,0.165,NULL,43489325025,679520703,10617510,17.7),(124610,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124610,36.88,0.27,238,56186,70,NULL,NULL,'2MASX J14515798+3027106',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,222.9915,30.45292,0.006,NULL,60089111995,938892374,14670193,17),(124611,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124611,37.29,0.46,287,56187,70,NULL,NULL,'2MASX J14515804+0509250',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,222.9917917,5.15686,0.101,NULL,59336729513,927136398,14486506,15.8),(124612,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124612,36.49,0.09,198,56188,70,NULL,NULL,'SDSS J145158.13+163656.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.8g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,222.9922083,16.61572,0,NULL,59586270640,931035478,14547429,16.8),(124613,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124613,37.4,0.27,302,56189,70,NULL,NULL,'2MASX J14515980+4645041',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.6g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,222.999125,46.75103,0.017,NULL,59989879307,937341864,14645966,16.6),(124614,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124614,37.94,0.46,388,56190,70,NULL,NULL,'2MASX J14520006+4610581',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.00025,46.18278,0.017,NULL,59990311148,937348611,14646072,18),(124615,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124615,37.28,0.46,286,56191,70,NULL,NULL,'2MASX J14520010+4940036',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000175,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.0002917,49.66778,0.021,NULL,59935056931,936485264,14632582,16.9),(124616,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124616,37.39,0.46,301,56192,70,NULL,NULL,'2MASX J14520026+1758226',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.11',0.15,NULL,NULL,NULL,NULL,NULL,1,223.001125,17.97289,0.025,NULL,59588404146,931068814,14547950,18.11),(124617,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124617,37.56,0.27,324,56193,70,NULL,NULL,'SDSS J145200.37+313221.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.0015417,31.53936,0,NULL,60090870073,938919844,14670622,17.2),(124618,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124618,37.67,0.46,342,56194,70,NULL,NULL,'2MASX J14520087+1956203',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.11',0.19,NULL,NULL,NULL,NULL,NULL,1,223.0037083,19.939,0.041,NULL,59533773452,930215210,14534612,18.11),(124619,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124619,36.01,0.46,159,56195,70,NULL,NULL,'2MASX J14520211+2727577',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.29',0.27,NULL,NULL,NULL,NULL,NULL,1,223.00875,27.466,0.036,NULL,60013886937,937716983,14651827,17.29),(124620,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124620,37.84,0.46,369,56196,70,NULL,NULL,'2MASXi J1452023+534606',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.009625,53.76844,0.013,NULL,59190711576,924854868,14450857,18.1),(124621,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124621,37.5,0.46,317,56197,70,NULL,NULL,'2MASX J14520234+3100316',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.009875,31.00872,0.009,NULL,60090967385,938921365,14670646,17.4),(124622,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124622,37.29,0.46,287,56198,70,NULL,NULL,'2MASX J14520453+6214067',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.5g',0.29,'AGN',NULL,NULL,NULL,NULL,1,223.0192917,62.23514,0.033,NULL,57765809239,902590769,14102980,16.5),(124623,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124623,36.29,0.46,181,56199,70,NULL,NULL,'2MASX J14520592+2926457',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000173,NULL,'16.1g',0.31,'E',NULL,NULL,NULL,NULL,1,223.0247917,29.44592,0.031,NULL,60092995869,938953060,14671141,16.1),(124624,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124624,37.78,0.33,360,56200,70,NULL,NULL,'2MASX J14520747-0206169',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.031208333,-2.10486,0.201,NULL,43489634568,679525540,10617586,17.9),(124625,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124625,32.26,0.45,28.3,56201,NULL,NULL,'K','NGC 5768',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000007,NULL,'13.4g',1.06,'SA(rs)c:       HII','Isolated galaxy',NULL,NULL,NULL,1,223.033125,-2.52975,0.209,NULL,43488891396,679513928,10617405,13.4),(124626,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124626,32.3,0.4,28.8,56201,NULL,NULL,'mean','NGC 5768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124627,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124627,32.3,0.47,28.8,56201,NULL,NULL,'H','NGC 5768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124628,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124628,32.3,NULL,28.8,56201,72,NULL,NULL,'NGC 5768',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124629,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124629,32.34,0.46,29.4,56201,NULL,NULL,'J','NGC 5768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124630,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124630,36.96,0.33,247,56202,70,NULL,NULL,'2MASX J14520871-0023069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.036333,-0.38533,0.125,NULL,43488283521,679504430,10617256,17.9),(124631,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124631,37.03,0.46,255,56203,70,NULL,NULL,'2MASX J14520904+3857153',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000168,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,223.0377917,38.95433,0.017,NULL,60074340832,938661575,14666587,16.2),(124632,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124632,37.46,0.46,311,56204,70,NULL,NULL,'2MASX J14520938+1320547',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,223.0392083,13.34853,0.037,NULL,59550487701,930476370,14538693,17.4),(124633,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124633,37.62,0.46,335,56205,70,NULL,NULL,'2MASX J14520942+2130424',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.039375,21.51186,0.045,NULL,59532010537,930187664,14534182,16.9),(124634,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124634,38.09,0.46,416,56206,70,NULL,NULL,'2MASX J14520983+0657359',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.041,6.95986,0.081,NULL,59382798045,927856219,14497753,18),(124635,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124635,37.97,0.46,393,56207,70,NULL,NULL,'2MASX J14521012+5107596',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.042333,51.13336,0.029,NULL,59943041032,936610016,14634531,17.4),(124636,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124636,37.9,0.46,380,56208,70,NULL,NULL,'2MASX J14521029+0507040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.042875,5.11775,0.101,NULL,59336729943,927136405,14486506,17.8),(124637,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124637,32.82,0.4,36.6,56209,NULL,NULL,'mean','MCG -02-38-022',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00003,NULL,'13.97',0.6,'Sb pec?',NULL,NULL,NULL,NULL,1,223.043417,-10.74044,0.289,NULL,46462013711,725968964,11343265,13.97),(124638,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124638,32.96,0.47,39.1,56209,NULL,NULL,'H','MCG -02-38-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124639,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124639,32.96,0.45,39.1,56209,NULL,NULL,'K','MCG -02-38-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124640,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124640,32.98,0.46,39.5,56209,NULL,NULL,'J','MCG -02-38-022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124641,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124641,33.19,0.43,43.4,56209,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124642,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124642,36.9,0.46,240,56210,70,NULL,NULL,'2MASX J14521056+3556153',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.0439583,35.9375,0,NULL,60125435024,939459922,14679061,17.7),(124643,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124643,37.61,0.33,332,56211,70,NULL,NULL,'2MASX J14521073+5512531',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.044625,55.21461,0.013,NULL,57244691395,894448303,13975754,17.2),(124644,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124644,36.22,0.46,175,56212,70,NULL,NULL,'SDSS J145211.02+200435.9',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.5g',0.5,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.0459583,20.07667,0.049,NULL,59533101397,930204709,14534448,15.5),(124645,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124645,37.93,0.46,386,56213,70,NULL,NULL,'LCRS B144935.3-022951',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.04625,-2.70203,0.209,NULL,43488661070,679510329,10617348,17.2),(124646,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124646,43.97,1.53,2510,56214,100,NULL,NULL,'SMM J14522+4301',1.47688,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',NULL,NULL,'20.0R',NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,223.052166667,43.01833,0.009,NULL,59981566487,937211976,14643937,20),(124647,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124647,43.98,0.46,2520,56214,69.7,NULL,'Fiducial','SMM J14522+4301',1.47688,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124648,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124648,44.15,1.46,2730,56214,100,NULL,NULL,'SMM J14522+4301',1.47688,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124649,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124649,44.28,0.43,2900,56214,72,NULL,NULL,'SMM J14522+4301',1.47688,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124650,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124650,44.48,0.42,3180,56214,70,NULL,NULL,'SMM J14522+4301',1.47688,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124651,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124651,45.28,0.21,3350,56214,73,NULL,'H const./H=100','SMM J14522+4301',1.47688,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124652,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124652,44.62,0.29,3390,56214,69.7,NULL,'Calibrated','SMM J14522+4301',1.47688,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124653,'GRB','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124653,44.75,0.52,3600,56214,NULL,NULL,NULL,'SMM J14522+4301',1.47688,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124654,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124654,36.49,0.09,198,56215,70,NULL,NULL,'SDSS J145212.64+171458.8',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'15.6g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.0527083,17.24967,0.013,NULL,59587618309,931056536,14547758,15.6),(124655,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124655,38.5,0.46,501,56216,70,NULL,NULL,'2MASX J14521267+5533381',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000191,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.053167,55.56058,0.005,NULL,57244366834,894443231,13975675,17.5),(124656,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124656,36.49,0.09,198,56217,70,NULL,NULL,'2MASX J14521293+1726347',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'15.9g',0.39,'SB0/a','Group member',NULL,NULL,NULL,1,223.053875,17.44297,0.013,NULL,59587603462,931056304,14547754,15.9),(124657,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124657,38.14,0.46,425,56218,70,NULL,NULL,'2MASX J14521291+5325306',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.054,53.42517,0,NULL,59190770006,924855781,14450871,17),(124658,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124658,34.37,0.33,74.9,56219,70,NULL,NULL,'NGC 5771',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000073,NULL,'14.5g',0.72,'E?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,223.0597083,29.84542,0.028,NULL,60088715534,938886180,14670096,14.5),(124659,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124659,35.03,0.4,102,56219,NULL,NULL,'mean','NGC 5771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124660,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124660,35.21,0.45,110,56219,NULL,NULL,'K','NGC 5771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124661,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124661,35.81,0.54,145,56220,70,NULL,NULL,'2MASX J14521508-2904505',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.062917,-29.08064,0.245,NULL,47209202918,737643795,11525684,15.6),(124662,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124662,38.06,0.17,410,56221,70,NULL,NULL,'2MASX J14521546+3217066',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.064417,32.28528,0,NULL,60090209192,938909518,14670461,17.8),(124663,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124663,37.61,0.27,332,56222,70,NULL,NULL,'2MASX J14521549+5022246',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000185,NULL,'16.2g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,223.064417,50.37364,0.021,NULL,59943836921,936622451,14634725,16.2),(124664,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124664,36.56,0.55,205,56223,70,NULL,NULL,'2MASX J14521607-0017365',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000101,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,223.066916667,-0.29364,0.125,NULL,43488327252,679505113,10617267,15.6),(124665,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124665,36.96,0.33,247,56223,70,NULL,NULL,'2MASX J14521607-0017365',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124666,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124666,35.67,0.46,136,56224,70,NULL,NULL,'SDSS J145216.49+121711.5',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'15.1g',0.57,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.06875,12.28653,0.017,NULL,59366494539,927601477,14493773,15.1),(124667,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124667,37.86,0.46,373,56225,70,NULL,NULL,'2MASX J14521725+5110506',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.0g',0.3,'AGN',NULL,NULL,NULL,NULL,1,223.0719583,51.18064,0.029,NULL,59929343378,936395990,14631187,17),(124668,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124668,36.26,0.46,178,56226,70,NULL,NULL,'2MASX J14521732+2446337',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.38',0.26,NULL,NULL,NULL,NULL,NULL,1,223.072167,24.77603,0.091,NULL,59492369678,929568276,14524504,17.38),(124669,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124669,37.4,0.27,302,56227,70,NULL,NULL,'2MASX J14521786+4645598',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.074375,46.76664,0.017,NULL,59989882053,937341907,14645967,17),(124670,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124670,36.44,0.46,194,56228,70,NULL,NULL,'2MASX J14521927+1102379',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.79',0.16,NULL,NULL,NULL,NULL,NULL,1,223.0802917,11.04386,0.025,NULL,59369766902,927652607,14494571,18.79),(124671,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124671,36.49,0.09,198,56229,70,NULL,NULL,'2MASX J14521952+1704367',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'18.20',0.3,'E/S0','Group member',NULL,NULL,NULL,1,223.081333,17.07692,0.025,NULL,59585709154,931026705,14547292,18.2),(124672,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124672,38.05,0.46,408,56230,70,NULL,NULL,'2MASX J14521983+2313174',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.082583,23.22144,0.132,NULL,59494533355,929602083,14525032,17.5),(124673,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124673,37.8,0.46,362,56231,70,NULL,NULL,'SDSS J145220.22+491006.4',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,223.0842917,49.16842,0.025,NULL,59935564523,936493195,14632706,16.8),(124674,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124674,37.27,0.46,285,56232,70,NULL,NULL,'2MASX J14522226+1808454',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.48',0.15,NULL,NULL,NULL,NULL,NULL,1,223.0927083,18.14606,0.029,NULL,59587881422,931060647,14547822,18.48),(124675,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124675,36.49,0.09,198,56233,70,NULL,NULL,'CGCG 105-050',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000067,NULL,'15.00',0.8,'S0?','Group member',NULL,NULL,NULL,1,223.095167,17.12158,0.013,NULL,59585697713,931026526,14547289,15),(124676,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124676,36.56,0.25,205,56233,74.4,NULL,NULL,'CGCG 105-050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124677,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124677,36.79,0.26,228,56233,70,NULL,NULL,'CGCG 105-050',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124678,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124678,37.54,0.46,322,56234,70,NULL,NULL,'2MASX J14522357+0317243',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000111,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,223.098167,3.29006,0.105,NULL,59337913105,927154892,14486795,16.7),(124679,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124679,36.36,0.46,187,56235,70,NULL,NULL,'CGCG 134-045',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,223.1012917,20.33428,0.061,NULL,59533013329,930203333,14534427,15.5),(124680,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124680,35.8,0.5,144,56236,NULL,NULL,NULL,'2MASX J14522455+1659227',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000026,NULL,'16.96',0.4,'Sc','Group member',NULL,NULL,NULL,1,223.102375,16.98969,0.025,NULL,59585679662,931026244,14547285,16.96),(124681,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124681,35.89,0.48,150,56236,NULL,NULL,'Malmquist cor.','2MASX J14522455+1659227',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124682,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124682,36.02,0.2,160,56236,74.4,NULL,NULL,'2MASX J14522455+1659227',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124683,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124683,37.53,0.46,321,56237,70,NULL,NULL,'2MASX J14522462+2044314',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,223.102667,20.74211,0.077,NULL,59532589387,930196709,14534323,18.3),(124684,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124684,37.06,0.46,259,56238,70,NULL,NULL,'2MASX J14522501+2525219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.104333333,25.42267,0.094,NULL,60012647417,937697615,14651525,17.4),(124685,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124685,37.13,0.46,267,56239,70,NULL,NULL,'2MASX J14522514+0517203',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.104833,5.28903,0.101,NULL,59336748117,927136689,14486510,17.3),(124686,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124686,37.59,0.46,329,56240,70,NULL,NULL,'SDSS J145225.36+105632.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.1057083,10.94231,0.025,NULL,59369768226,927652628,14494572,17.9),(124687,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124687,37.8,0.46,364,56241,70,NULL,NULL,'2MASX J14522563+5734380',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.10675,57.57719,0,NULL,57728270846,902004231,14093816,17.8),(124688,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124688,38.25,0.46,447,56242,70,NULL,NULL,'2MASX J14522794+0806195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.116375,8.10531,0.053,NULL,59381465830,927835403,14497428,17.4),(124689,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124689,37.78,0.33,360,56243,70,NULL,NULL,'2MASX J14522860-0203215',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.1192917,-2.05597,0.201,NULL,43489682790,679526293,10617598,17.1),(124690,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124690,36.44,0.42,194,56244,NULL,NULL,'Malmquist cor.','2MASX J14522928+1620515',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'17.35',0.4,'SBbc','Group member',NULL,NULL,NULL,1,223.122041667,16.34764,0.013,NULL,59585403539,931021930,14547217,17.35),(124691,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124691,36.62,0.39,211,56244,NULL,NULL,NULL,'2MASX J14522928+1620515',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124692,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124692,36.66,0.2,215,56244,74.4,NULL,NULL,'2MASX J14522928+1620515',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124693,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124693,34.37,0.33,74.9,56245,70,NULL,NULL,'NGC 5773',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000067,NULL,'14.47',0.9,'Sab','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,223.12675,29.80739,0.028,NULL,60092975793,938952746,14671136,14.47),(124694,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124694,37.42,0.46,305,56246,70,NULL,NULL,'2MASX J14523065+3614351',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000209,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,223.127958333,36.24311,0.008,NULL,60125549510,939461711,14679089,16.3),(124695,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124695,36.1,0.27,166,56247,70,NULL,NULL,'2MASX J14523128+5524262',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000197,NULL,'15.1g',0.61,'E0',NULL,NULL,NULL,NULL,1,223.1305417,55.40714,0.013,NULL,57244331520,894442680,13975666,15.1),(124696,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124696,38.81,0.46,578,56248,70,NULL,NULL,'2MASX J14523367+1120225',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000181,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.1402917,11.33969,0.049,NULL,59370151788,927658621,14494665,17.8),(124697,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124697,37,0.46,251,56249,70,NULL,NULL,'2MASX J14523428+5837083',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.142958333,58.61889,0.005,NULL,57724884802,901951325,14092989,17.3),(124698,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124698,32.44,0.8,30.7,56250,75,NULL,NULL,'UGCA 396',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000013,NULL,'13.5',2.4,'SB(s)dm pec',NULL,NULL,NULL,NULL,1,223.1449583,-3.56156,0.197,NULL,46445787007,725715421,11339303,13.5),(124699,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124699,30.9,0.43,15.1,56250,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 396',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124700,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124700,32.18,NULL,27.3,56250,72,NULL,NULL,'UGCA 396',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124701,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124701,36.28,0.33,180,56251,70,NULL,NULL,'CGCG 048-041',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000118,NULL,'14.9g',0.52,'S0/a',NULL,NULL,NULL,NULL,1,223.14675,4.54589,0.117,NULL,59334039084,927094360,14485849,14.9),(124702,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124702,37.63,0.46,335,56252,70,NULL,NULL,'VII Zw 566',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,223.1504583,63.06547,0.013,NULL,57756120198,902439378,14100615,16.4),(124703,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124703,36.18,0.46,173,56253,70,NULL,NULL,'CGCG 076-082',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000168,NULL,'15.5g',0.46,NULL,NULL,NULL,NULL,NULL,1,223.151083,12.04764,0.021,NULL,59366679605,927604368,14493818,15.5),(124704,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124704,37.73,0.46,352,56254,70,NULL,NULL,'2MASX J14523669+1756446',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,223.153083,17.94569,0.013,NULL,59588362161,931068158,14547939,16.8),(124705,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124705,37.03,0.46,255,56255,70,NULL,NULL,'2MASX J14523716+2352100',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.154917,23.86939,0.108,NULL,59495673329,929619895,14525310,17.1),(124706,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124706,37.28,0.46,286,56256,70,NULL,NULL,'2MASX J14523873+2649279',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.41',0.15,NULL,NULL,NULL,NULL,NULL,1,223.161333,26.82436,0.146,NULL,60016024294,937750379,14652349,18.41),(124707,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124707,37.81,0.46,365,56257,70,NULL,NULL,'2MASX J14523931+3103362',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.163875,31.06003,0.048,NULL,60090965757,938921339,14670645,18),(124708,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124708,37.47,0.46,311,56258,70,NULL,NULL,'2MASX J14524000+2535299',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.166583333,25.59169,0.13,NULL,60012849187,937700768,14651574,17.9),(124709,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124709,37.14,0.46,268,56259,70,NULL,NULL,'2MASX J14524078+2906589',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.0002,NULL,'18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,223.16975,29.11644,0,NULL,60093086091,938954470,14671163,18.58),(124710,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124710,37.65,0.33,340,56260,70,NULL,NULL,'2MASX J14524123+3247332',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.171917,32.79256,0,NULL,60122838323,939419348,14678427,17.8),(124711,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124711,35.97,0.33,156,56261,70,NULL,NULL,'NGC 5769',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000123,NULL,'14.9',0.3,'E','Group member',NULL,NULL,NULL,1,223.1730417,7.93181,0.053,NULL,59381556959,927836827,14497450,14.9),(124712,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124712,38.39,0.33,477,56262,70,NULL,NULL,'SDSS J145241.80+212335.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.174167,21.39311,0.089,NULL,59540320021,930317500,14536210,17.9),(124713,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124713,35.22,0.27,111,56263,70,NULL,NULL,'CGCG 048-044',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000107,NULL,'15.0g',0.57,'E0','Group member',NULL,NULL,NULL,1,223.1795,3.22483,0.105,NULL,59337920318,927155004,14486796,15),(124714,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124714,36.49,0.09,198,56264,70,NULL,NULL,'CGCG 105-053',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00011,NULL,'15.02',0.5,'E;BrClG','Group member',NULL,NULL,NULL,1,223.18025,16.90375,0.025,NULL,59585800872,931028138,14547314,15.02),(124715,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124715,36.56,0.25,205,56264,74.4,NULL,NULL,'CGCG 105-053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124716,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124716,36.79,0.26,228,56264,70,NULL,NULL,'CGCG 105-053',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124717,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124717,36.49,0.09,198,56265,70,NULL,NULL,'SDSS J145243.42+164326.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.1809583,16.724,0.005,NULL,59585773235,931027706,14547307,17),(124718,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124718,37.52,0.35,306,56266,60,NULL,NULL,'ABELL 1983',0.0438,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,223.183333,16.74606,0.005,NULL,59585771251,931027675,14547307,NULL),(124719,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124719,36.5,0.17,200,56266,70,NULL,NULL,'ABELL 1983',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124720,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124720,31.8,NULL,22.9,56267,72,NULL,NULL,'AGC 249264',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000057,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.184167,4.60972,0.109,NULL,59335927444,927123866,14486310,NULL),(124721,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124721,36.55,0.43,204,56268,NULL,NULL,'Malmquist cor.','2MASX J14524547+1649237',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000023,NULL,'17.30',0.3,'Sc','Group member',NULL,NULL,NULL,1,223.1894583,16.82333,0.005,NULL,59585796717,931028073,14547313,17.3),(124722,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124722,36.78,0.39,227,56268,NULL,NULL,NULL,'2MASX J14524547+1649237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124723,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124723,36.82,0.2,231,56268,74.4,NULL,NULL,'2MASX J14524547+1649237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124724,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124724,37.44,0.46,308,56269,70,NULL,NULL,'2MASX J14524821+3141513',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00018,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.200875,31.6975,0,NULL,60090366647,938911978,14670499,16.7),(124725,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124725,38.06,0.17,410,56270,70,NULL,NULL,'2MASX J14524879+3221013',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.203333,32.35033,0.028,NULL,60090167962,938908874,14670451,17.4),(124726,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124726,38.21,0.46,439,56271,70,NULL,NULL,'2MASX J14524908+2808179',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.27',0.14,NULL,NULL,NULL,NULL,NULL,1,223.204375,28.13844,0,NULL,60081374243,938771472,14668304,18.27),(124727,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124727,39.73,NULL,885,56272,NULL,NULL,NULL,'ABELL 1995',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.23375,58.04889,0.005,NULL,57727790395,901996724,14093698,NULL),(124728,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124728,40.06,NULL,1030,56272,NULL,NULL,'3.1 (red) calibration','ABELL 1995',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124729,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124729,40.25,NULL,1120,56272,NULL,NULL,NULL,'ABELL 1995',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124730,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124730,40.38,0.25,1190,56272,NULL,NULL,'Hydrost. Eq.','ABELL 1995',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124731,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124731,40.38,NULL,1190,56272,NULL,NULL,'4.2 (black) calibration','ABELL 1995',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124732,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124732,40.4,0.35,1200,56272,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 1995',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124733,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124733,40.56,0.44,1290,56272,NULL,NULL,NULL,'ABELL 1995',NULL,'2000ApJ...541...37P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124734,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124734,40.57,0.32,1300,56272,NULL,NULL,'Isotherm.','ABELL 1995',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124735,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124735,40.64,NULL,1340,56272,NULL,NULL,'4.1 (blue) calibration','ABELL 1995',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124736,'SZ effect','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124736,41.33,0.42,1840,56272,NULL,NULL,NULL,'ABELL 1995',NULL,'2001PhDT.........5P',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124737,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124737,37.22,0.23,278,56273,70,NULL,NULL,'2MASX J14525046+1804320',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,223.210333333,18.07564,0.021,NULL,59587823512,931059742,14547808,18.29),(124738,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124738,37.25,0.46,281,56274,70,NULL,NULL,'2MASX J14525120-0044234',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000096,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,223.21325,-0.73994,0.141,NULL,43490283938,679535686,10617745,16.3),(124739,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124739,38.89,0.46,599,56275,70,NULL,NULL,'SDSS J145251.43+004414.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.214333333,0.73739,0.133,NULL,58254041801,910219403,14222178,18.6),(124740,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124740,37.47,0.46,312,56276,70,NULL,NULL,'2MASX J14525145+4413592',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.214417,44.23322,0.049,NULL,59993135501,937392742,14646761,16.8),(124741,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124741,35.97,0.33,156,56277,70,NULL,NULL,'2MASX J14525190+0754033',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,223.21625,7.90083,0.053,NULL,59381584053,927837250,14497457,16.5),(124742,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124742,37.21,0.46,277,56278,70,NULL,NULL,'2MASX J14525234-0128384',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,223.218125,-1.47739,0.153,NULL,43490610660,679540791,10617824,16.5),(124743,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124743,38.39,0.33,477,56279,70,NULL,NULL,'SDSS J145253.00+211945.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.220875,21.32922,0.089,NULL,59540322190,930317534,14536211,18.2),(124744,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124744,38.42,0.46,483,56280,70,NULL,NULL,'2MASX J14525325+3353473',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.222,33.8965,0,NULL,60122583897,939415373,14678365,17.3),(124745,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124745,37.5,0.46,316,56281,70,NULL,NULL,'2MASX J14525363+1602048',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.93',0.18,'Sa/0','Group member',NULL,NULL,NULL,1,223.223583,16.03469,0.017,NULL,59589678565,931088727,14548261,17.93),(124746,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124746,37.83,0.33,369,56282,70,NULL,NULL,'2MASX J14525441+3118053',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.226833333,31.30156,0,NULL,60090980384,938921568,14670649,17.7),(124747,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124747,37.61,0.27,332,56283,70,NULL,NULL,'2MASX J14525482+5010331',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.228417,50.17586,0,NULL,59943355921,936614936,14634608,17.7),(124748,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124748,31.73,NULL,22.2,56284,72,NULL,NULL,'MCG -01-38-005',NULL,'2014Ap.....57..457K',2014,1,1.1,NULL,'G',0.0001,NULL,'15.03',0.5,'IBm?',NULL,NULL,NULL,NULL,1,223.2287917,-3.82678,0.225,NULL,46445765686,725715088,11339298,15.03),(124749,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124749,37.52,0.35,306,56285,60,NULL,'ABELL 1983, BCG','GIN 363',0.0438,'1980ApJ...241..486H',1980,1,1.3,NULL,'G',0.000063,NULL,'14.55',0.9,'E;cD;BrClG','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,223.230417,16.70292,0.017,NULL,59585767644,931027619,14547306,14.55),(124750,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124750,36.55,0.25,204,56285,74.4,NULL,NULL,'GIN 363',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124751,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124751,36.79,0.26,228,56285,70,NULL,NULL,'GIN 363',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124752,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124752,36.5,0.17,200,56285,70,NULL,'ABELL 1983, BGC','GIN 363',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124753,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124753,36.49,0.09,198,56286,70,NULL,NULL,'SDSS J145255.31+164210.2',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',NULL,'PHOT','15.2g',0.62,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.2305,16.70286,0.017,NULL,59585767644,931027619,14547306,15.2),(124754,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124754,38,0.46,399,56287,70,NULL,NULL,'2MASX J14525616+6045525',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.234291667,60.76458,0,NULL,57778928744,902795761,14106183,18.1),(124755,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124755,38.33,0.46,464,56288,70,NULL,NULL,'2MASX J14525650+2207010',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000189,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.235375,22.11703,0.089,NULL,59526843091,930106923,14532920,17.6),(124756,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124756,36.79,0.26,228,56289,70,NULL,NULL,'CGCG 105-055',NULL,'2001MNRAS.321..277C',2001,1,0.8,NULL,'G',0.00008,NULL,'14.53',0.8,'SBa','Group member',NULL,NULL,NULL,1,223.2369583,16.72794,0.017,NULL,59585768239,931027628,14547306,14.53),(124757,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124757,36.49,0.09,198,56290,70,NULL,NULL,'SDSS J145257.75+164149.5',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'15.7g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.240667,16.69708,0.017,NULL,59585774638,931027728,14547308,15.7),(124758,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124758,36.56,0.25,205,56291,74.4,NULL,NULL,'CGCG 105-056',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000047,NULL,'15.2V',1.7,'E','Group member',NULL,NULL,NULL,1,223.240708333,16.69703,0.017,NULL,59585774638,931027728,14547308,15.2),(124759,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124759,36.79,0.26,228,56291,70,NULL,NULL,'CGCG 105-056',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124760,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124760,36.53,0.4,203,56291,NULL,NULL,'mean','CGCG 105-056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124761,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124761,37.51,0.45,318,56291,NULL,NULL,'K','CGCG 105-056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124762,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124762,38.22,0.46,440,56292,70,NULL,NULL,'2MASX J14525796+0141201',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.241583333,1.68911,0.121,NULL,58252333802,910192715,14221761,17.1),(124763,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124763,36.89,0.46,239,56293,70,NULL,NULL,'2MASX J14530014+2725297',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.12',0.16,NULL,NULL,NULL,NULL,NULL,1,223.250583,27.42494,0.074,NULL,60013921466,937717522,14651836,18.12),(124764,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124764,37.98,0.46,395,56294,70,NULL,NULL,'2MASX J14530040+3102253',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000191,NULL,'17.90',0.2,NULL,NULL,NULL,NULL,NULL,1,223.2515417,31.04036,0.048,NULL,60090786669,938918541,14670602,17.9),(124765,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124765,36.49,0.09,198,56295,70,NULL,NULL,'2MASX J14530086+1640577',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'18.02',0.2,'E','Group member',NULL,NULL,NULL,1,223.253667,16.68258,0.013,NULL,59585788123,931027939,14547311,18.02),(124766,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124766,36.46,0.5,196,56296,70,NULL,NULL,'MCG -03-38-022',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,223.254958333,-15.88278,0.437,NULL,46705924308,729780067,11402813,15.5),(124767,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124767,34.38,0.8,75.1,56297,75,NULL,'MAT, I','ESO 327- G 027',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14.25',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,223.256167,-39.92033,0.101,NULL,47215889166,737748268,11527316,14.25),(124768,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124768,33.76,0.32,56.5,56297,85,NULL,'I, raw','ESO 327- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124769,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124769,33.76,0.32,56.6,56297,85,NULL,'I, inv','ESO 327- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124770,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124770,34.03,0.43,64,56297,75,NULL,'MAT, I, raw','ESO 327- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124771,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124771,34.04,0.44,64.3,56297,NULL,NULL,'Malmquist cor.','ESO 327- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124772,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124772,34.06,0.44,64.8,56297,NULL,NULL,NULL,'ESO 327- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124773,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124773,34.1,0.43,66,56297,75,NULL,'MAT, I, inv','ESO 327- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124774,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124774,34.1,0.2,66.1,56297,74.4,NULL,NULL,'ESO 327- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124775,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124775,34.21,0.43,69.6,56297,75,NULL,'MAT, I, cor','ESO 327- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124776,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124776,34.26,0.49,71,56297,75,NULL,'IR','ESO 327- G 027',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124777,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124777,37.85,0.46,371,56298,70,NULL,NULL,'SDSS J145301.59+101433.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.256667,10.24269,0.033,NULL,59368722976,927636296,14494317,18.1),(124778,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124778,37.61,0.27,332,56299,70,NULL,NULL,'2MASX J14530158+5015242',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.256667,50.25686,0.021,NULL,59943829706,936622339,14634724,17),(124779,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124779,37.22,0.33,278,56300,70,NULL,NULL,'2MASX J14530188+2519417',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.11',0.15,NULL,NULL,NULL,NULL,NULL,1,223.2577917,25.32817,0.13,NULL,60012858610,937700915,14651576,18.11),(124780,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124780,37.98,0.46,395,56301,70,NULL,NULL,'2MASX J14530200+4659412',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.2582917,46.99497,0.009,NULL,59990044844,937344450,14646007,17.3),(124781,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124781,32.14,0.4,26.8,56302,NULL,NULL,'mean','IC 1066',NULL,'2007A&A...465...71T',2007,1,1.28,NULL,'G',0.00002,NULL,'13.9g',0.7,'Sab            HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,223.261917,3.29603,0.101,NULL,59338084659,927157572,14486837,13.9),(124782,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124782,32.65,0.47,33.9,56302,NULL,NULL,'H','IC 1066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124783,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124783,32.67,0.45,34.2,56302,NULL,NULL,'K','IC 1066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124784,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124784,32.7,0.46,34.6,56302,NULL,NULL,'J','IC 1066',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124785,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124785,37.83,0.33,369,56303,70,NULL,NULL,'SDSS J145304.58+311248.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.269125,31.21353,0.048,NULL,60090988304,938921692,14670651,18.2),(124786,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124786,36.89,0.59,238,56304,NULL,NULL,'Malmquist cor.','2MASX J14530511+1708247',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000023,NULL,'16.42',0.1,'Sc',NULL,NULL,NULL,NULL,1,223.27125,17.14025,0.013,NULL,59585826362,931028536,14547320,16.42),(124787,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124787,37.21,0.51,277,56304,NULL,NULL,NULL,'2MASX J14530511+1708247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124788,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124788,37.25,0.2,282,56304,74.4,NULL,NULL,'2MASX J14530511+1708247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124789,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124789,37.84,0.46,370,56305,70,NULL,NULL,'2MASX J14530522+2830147',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.27175,28.50422,0,NULL,60081513519,938773648,14668338,17.7),(124790,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124790,37.57,0.46,327,56306,70,NULL,NULL,'2MASX J14530535-0146094',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000175,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.272417,-1.76928,0.165,NULL,43488996893,679515576,10617430,17),(124791,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124791,37.19,0.61,274,56307,70,NULL,NULL,'2MASX J14530574-1931349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.273916667,-19.52644,0.361,NULL,46651476488,728929320,11389520,15.4),(124792,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124792,35.79,0.27,144,56308,70,NULL,NULL,'CGCG 193-007',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000107,NULL,'15.0g',0.54,'S0^-',NULL,NULL,NULL,NULL,1,223.2744583,36.92439,0.04,NULL,60118093482,939345210,14677268,15),(124793,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124793,37.95,0.46,389,56309,70,NULL,NULL,'SDSS J145307.26+575208.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.28025,57.86906,0.005,NULL,57727998999,901999984,14093749,18.5),(124794,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124794,33.66,0.8,53.9,56310,75,NULL,'MAT, I','ESO 580- G 049',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'15.13',0.3,'Sbc: sp',NULL,NULL,NULL,NULL,1,223.28275,-19.73697,0.369,NULL,46652275857,728941810,11389715,15.13),(124795,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124795,32.79,0.32,36.1,56310,85,NULL,'I, inv','ESO 580- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124796,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124796,32.79,0.32,36.2,56310,85,NULL,'I, raw','ESO 580- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124797,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124797,33.1,0.43,41.6,56310,75,NULL,'MAT, I, raw','ESO 580- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124798,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124798,33.15,0.43,42.7,56310,75,NULL,'MAT, I, inv','ESO 580- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124799,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124799,33.28,0.43,45.3,56310,75,NULL,'MAT, I, cor','ESO 580- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124800,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124800,33.38,0.41,47.3,56310,NULL,NULL,'Malmquist cor.','ESO 580- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124801,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124801,33.52,0.49,50.6,56310,75,NULL,'IR','ESO 580- G 049',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124802,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124802,33.59,0.43,52.3,56310,75,NULL,'3.6 micron, color + selection bias corrected','ESO 580- G 049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124803,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124803,33.6,0.43,52.5,56310,75,NULL,'3.6 micron, color corrected','ESO 580- G 049',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124804,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124804,33.63,0.2,53.2,56310,74.4,NULL,NULL,'ESO 580- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124805,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124805,33.78,0.34,57,56310,NULL,NULL,NULL,'ESO 580- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124806,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124806,37.97,0.11,392,56311,70,NULL,NULL,'2MASX J14530838+5408103',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.285,54.13622,0,NULL,59191063872,924860373,14450943,17.9),(124807,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124807,37.15,0.33,269,56312,70,NULL,NULL,'2MASX J14530851+0447069',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00009,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,223.285541667,4.78525,0.117,NULL,59335992046,927124875,14486326,16.4),(124808,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124808,36.49,0.09,198,56313,70,NULL,NULL,'CGCG 105-058',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00015,NULL,'15.7',0.4,'S0','Group member',NULL,NULL,NULL,1,223.286583,17.04414,0.013,NULL,59585838433,931028725,14547323,15.7),(124809,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124809,37.84,0.46,370,56314,70,NULL,NULL,'2MASX J14530932+2241086',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.2887083,22.68567,0.102,NULL,59526751528,930105492,14532898,17.7),(124810,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124810,36.57,0.25,206,56315,74.4,NULL,NULL,'CGCG 105-057',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00015,NULL,NULL,NULL,'S0?','Group member',NULL,NULL,NULL,1,223.288917,16.66586,0.013,NULL,59585788994,931027953,14547311,NULL),(124811,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124811,38.37,0.46,471,56316,70,NULL,NULL,'2MASX J14531059+3315160',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.294083,33.25453,0,NULL,60122893924,939420217,14678440,17.9),(124812,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124812,35.79,0.27,144,56317,70,NULL,NULL,'MCG +06-33-006',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000168,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,223.294917,36.91381,0.04,NULL,60118093713,939345214,14677268,15.8),(124813,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124813,37.03,0.1,254,56318,70,NULL,NULL,'2MASX J14531090+1805476',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.23',0.16,NULL,NULL,NULL,NULL,NULL,1,223.295333333,18.09653,0.021,NULL,59586710571,931042352,14547536,18.23),(124814,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124814,36.49,0.09,198,56319,70,NULL,NULL,'2MASX J14531137+1635277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'18.63',0.15,'E',NULL,NULL,NULL,NULL,1,223.2975417,16.59097,0.013,NULL,59585778748,931027792,14547309,18.63),(124815,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124815,37.45,0.46,310,56320,70,NULL,NULL,'2MASX J14531172+1312517',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.96',0.14,NULL,NULL,NULL,NULL,NULL,1,223.2987917,13.21433,0.037,NULL,59550337456,930474022,14538656,18.96),(124816,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124816,35.62,0.48,133,56321,NULL,NULL,NULL,'AGC 240869',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000023,NULL,'15.7V',0.5,'Sab            AGN','Group member',NULL,NULL,NULL,1,223.299083,16.92347,0.021,NULL,59585855472,931028991,14547327,15.7),(124817,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124817,35.63,0.48,134,56321,NULL,NULL,'Malmquist cor.','AGC 240869',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124818,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124818,35.66,0.2,136,56321,74.4,NULL,NULL,'AGC 240869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124819,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124819,37.11,0.46,265,56322,70,NULL,NULL,'2MASX J14531188+2941567',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.2995,29.69908,0.028,NULL,60093752171,938964877,14671326,17.6),(124820,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124820,35.79,0.27,144,56323,70,NULL,NULL,'2MASX J14531265+3652596',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,223.30275,36.88319,0.04,NULL,60118092503,939345195,14677268,16.2),(124821,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124821,37.22,0.23,278,56324,70,NULL,NULL,'2MASX J14531307+1807296',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.37',0.18,NULL,NULL,NULL,NULL,NULL,1,223.304583,18.12494,0.021,NULL,59586722457,931042538,14547539,18.37),(124822,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124822,36.75,0.46,224,56325,70,NULL,NULL,'2MASX J14531317+2935477',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.5g',0.37,'S0',NULL,NULL,NULL,NULL,1,223.3050417,29.59656,0.023,NULL,60093012478,938953319,14671145,16.5),(124823,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124823,36.49,0.09,198,56326,70,NULL,NULL,'SDSS J145313.70+170049.6',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'18.09',0.3,'S0','Group member',NULL,NULL,NULL,1,223.307083,17.01381,0.013,NULL,59585835093,931028673,14547323,18.09),(124824,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124824,37.44,0.46,307,56327,70,NULL,NULL,'2MASX J14531374+0039229',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.3072917,0.65647,0.133,NULL,58254076013,910219937,14222186,17),(124825,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124825,38.37,0.46,473,56328,70,NULL,NULL,'2MASX J14531422+2205476',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.48',0.13,NULL,NULL,NULL,NULL,NULL,1,223.309333,22.09656,0.057,NULL,59526712219,930104878,14532888,18.48),(124826,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124826,37.03,0.1,254,56329,70,NULL,NULL,'2MASX J14531469+1809076',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.15',0.18,NULL,NULL,NULL,NULL,NULL,1,223.31125,18.15228,0.025,NULL,59586723313,931042551,14547539,18.15),(124827,'SBF','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124827,31.39,0.29,19,56330,NULL,NULL,'I','NGC 5770',NULL,'2001ApJ...546..681T',2001,1,1.7,NULL,'G',0.000017,NULL,'13.15',1.3,'SB0','in a radial-velocity based grouping',NULL,NULL,NULL,1,223.312583333,3.95972,0.129,NULL,59334076305,927094942,14485858,13.15),(124828,'SBF','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124828,31.42,0.14,19.2,56330,74.4,NULL,NULL,'NGC 5770',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124829,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124829,31.86,0.45,23.5,56330,NULL,NULL,'K','NGC 5770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124830,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124830,31.96,0.4,24.7,56330,NULL,NULL,'mean','NGC 5770',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124831,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124831,37.28,0.46,286,56331,70,NULL,NULL,'2MASX J14531667+0446489',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000075,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.319625,4.78031,0.117,NULL,59335993854,927124903,14486326,17.1),(124832,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124832,38.07,0.46,412,56332,70,NULL,NULL,'2MASX J14531680+0805333',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.319916667,8.09256,0.057,NULL,59381470003,927835468,14497429,17.3),(124833,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124833,37.15,0.33,269,56333,70,NULL,NULL,'2MASX J14531701+0447359',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.32075,4.79339,0.117,NULL,59336025839,927125403,14486334,16.6),(124834,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124834,36.49,0.09,198,56334,70,NULL,NULL,'2MASX J14531708+1731248',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.19',0.16,'AGN',NULL,NULL,NULL,NULL,1,223.321333,17.52353,0.029,NULL,59587681034,931057516,14547773,18.19),(124835,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124835,36.88,0.46,238,56335,70,NULL,NULL,'2MASX J14531722+5749405',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.321583,57.82781,0,NULL,57728002670,902000041,14093750,17.1),(124836,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124836,36.49,0.09,198,56336,70,NULL,NULL,'CGCG 105-059',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000097,NULL,'15.7',0.5,'S0','Group member',NULL,NULL,NULL,1,223.328833,16.64214,0.013,NULL,59585789489,931027960,14547311,15.7),(124837,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124837,37.07,0.46,259,56337,70,NULL,NULL,'2MASX J14531963+2745467',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.23',0.16,NULL,NULL,NULL,NULL,NULL,1,223.332,27.76314,0.083,NULL,60081725944,938776967,14668390,18.23),(124838,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124838,36.56,0.33,205,56338,70,NULL,NULL,'2MASX J14532027+0917161',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000187,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,223.334625,9.28769,0.045,NULL,59375848722,927747636,14496056,16.1),(124839,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124839,37.97,0.11,392,56339,70,NULL,NULL,'2MASX J14532051+5408125',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000165,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,223.335625,54.13672,0,NULL,59191066368,924860412,14450943,16.5),(124840,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124840,36.65,0.46,214,56340,70,NULL,NULL,'2MASX J14532098+0358010',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'16.9g',0.23,'NLAGN',NULL,NULL,NULL,'Sy 2',1,223.337375,3.96694,0.129,NULL,59334080059,927095000,14485859,16.9),(124841,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124841,37.17,0.27,272,56341,70,NULL,NULL,'2MASX J14532119+5502195',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000188,NULL,'15.5g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,223.338416667,55.03889,0.009,NULL,57244898263,894451535,13975805,15.5),(124842,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124842,38.14,0.46,425,56342,70,NULL,NULL,'2MASX J14532363+1618108',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.98',0.13,NULL,NULL,NULL,NULL,NULL,1,223.348333,16.30311,0.013,NULL,59589659568,931088430,14548256,18.98),(124843,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124843,37.79,0.46,362,56343,70,NULL,NULL,'SDSS J145323.82-000451.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000091,NULL,'18.4g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,223.3492917,-0.08097,0.133,NULL,43488143505,679502242,10617222,18.4),(124844,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124844,37.97,0.11,392,56344,70,NULL,NULL,'2MASX J14532418+5419485',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000123,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.350875,54.33019,0,NULL,59190985071,924859141,14450924,17.3),(124845,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124845,36.71,0.46,219,56345,70,NULL,NULL,'2MASX J14532426+3851576',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,223.350916667,38.86594,0.043,NULL,60071381351,938615333,14665864,16.8),(124846,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124846,37.03,0.1,254,56346,70,NULL,NULL,'2MASX J14532426+1829285',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0001,NULL,'17.21',0.5,'E/S0','Group member',NULL,NULL,NULL,1,223.3509583,18.49142,0.025,NULL,59586848891,931044513,14547570,17.21),(124847,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124847,36.49,0.09,198,56347,70,NULL,NULL,'2MASX J14532456+1639435',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'16.8g',0.23,'E','Group member',NULL,NULL,NULL,1,223.352333,16.662,0.017,NULL,59585787471,931027929,14547311,16.8),(124848,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124848,36.57,0.46,206,56348,70,NULL,NULL,'LCRS B145049.0-023456',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.3537083,-2.78578,0.213,NULL,46440642254,725635035,11338047,17.8),(124849,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124849,34.8,0.49,91,56349,75,NULL,'IR','MCG -01-38-007',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.00001,NULL,'15',0.4,'Sc: sp',NULL,NULL,NULL,NULL,1,223.356167,-4.69786,0.165,NULL,46446918377,725733099,11339579,15),(124850,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124850,35.16,0.2,108,56349,74.4,NULL,NULL,'MCG -01-38-007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124851,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124851,35.31,0.41,115,56349,NULL,NULL,'Malmquist cor.','MCG -01-38-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124852,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124852,35.42,0.39,121,56349,NULL,NULL,NULL,'MCG -01-38-007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124853,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124853,37.69,0.46,345,56350,70,NULL,NULL,'2MASX J14532548+1030551',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.356291667,10.51547,0.029,NULL,59368799856,927637497,14494335,17.3),(124854,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124854,38.74,0.46,560,56351,70,NULL,NULL,'2MASX J14532552+5549385',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.3564583,55.82728,0,NULL,57714148745,901783574,14090368,17.7),(124855,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124855,37.3,0.46,289,56352,70,NULL,NULL,'2MASX J14532616+0533070',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.3589583,5.55181,0.097,NULL,59335059504,927110304,14486098,16.8),(124856,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124856,37.8,0.46,363,56353,70,NULL,NULL,'2MASX J14532721+0757421',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.363333,7.96175,0.053,NULL,59381644764,927838199,14497471,17.5),(124857,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124857,32.85,0.4,37.1,56354,75,NULL,'B','NGC 5783',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.00001,NULL,'13.5',1.8,'SAB(s)c','Field galaxy',NULL,NULL,NULL,1,223.3679583,52.07611,0.013,NULL,59929953639,936405525,14631336,13.5),(124858,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124858,32.91,0.4,38.2,56354,NULL,NULL,NULL,'NGC 5783',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124859,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124859,32.98,0.2,39.5,56354,74.4,NULL,NULL,'NGC 5783',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124860,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124860,33.02,0.43,40.2,56354,75,NULL,'3.6 micron, color corrected','NGC 5783',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124861,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124861,33.12,0.43,42,56354,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5783',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124862,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124862,35.85,0.46,148,56355,70,NULL,NULL,'2MASX J14532853+0050020',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000069,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.368916667,0.834,0.129,NULL,58254641533,910228773,14222324,16.6),(124863,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124863,37.17,0.27,272,56356,70,NULL,NULL,'2MASX J14532931+5507316',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,223.372,55.12556,0.017,NULL,57244902666,894451604,13975806,16.5),(124864,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124864,37.17,0.27,272,56357,70,NULL,NULL,'SDSS J145329.62+550146.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.373417,55.02967,0.009,NULL,57244853111,894450829,13975794,17.8),(124865,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124865,37.61,0.46,332,56358,70,NULL,NULL,'2MASX J14532968+4716086',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.373667,47.26917,0.037,NULL,59990015642,937343994,14645999,18.1),(124866,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124866,36.49,0.09,198,56359,70,NULL,NULL,'2MASX J14533014+1627575',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'18.28',0.2,'E','Group member',NULL,NULL,NULL,1,223.3757083,16.46603,0.017,NULL,59590117583,931095587,14548368,18.28),(124867,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124867,36.59,0.46,208,56360,70,NULL,NULL,'2MASX J14533106+2750004',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,223.379375,27.83342,0.036,NULL,60081762156,938777533,14668398,16.2),(124868,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124868,36.84,0.33,233,56361,70,NULL,NULL,'2MASX J14533115+1421125',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.78',0.21,NULL,NULL,NULL,NULL,NULL,1,223.379875,14.35356,0.041,NULL,59548340971,930442827,14538169,16.78),(124869,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,NULL,124869,37.03,0.62,254,56362,70,NULL,NULL,'2MASX J14533169-2334257',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.382,-23.57383,0.441,NULL,46524841048,726950641,11358603,15.6),(124870,'FP','2016-12-15 15:15:29','2016-12-16 11:20:42','1',NULL,'R',124870,36.51,0.46,200,56363,70,NULL,NULL,'2MASX J14533223+4126306',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000176,NULL,'15.8g',0.32,'S0',NULL,NULL,NULL,NULL,1,223.38425,41.44192,0,NULL,59949699306,936714051,14636157,15.8),(124871,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124871,38.36,0.46,471,56364,70,NULL,NULL,'LCRS B145056.8-024224',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.386333333,-2.90997,0.217,NULL,46440624838,725634763,11338043,18.4),(124872,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124872,35.22,0.27,111,56365,70,NULL,NULL,'IC 1068',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000077,NULL,'14.3g',0.74,'E0',NULL,NULL,NULL,NULL,1,223.387167,3.07731,0.125,NULL,59337965721,927155714,14486808,14.3),(124873,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124873,38.17,0.46,430,56366,70,NULL,NULL,'2MASX J14533313+2039503',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,223.3879583,20.66383,0.077,NULL,59532616423,930197131,14534330,18.52),(124874,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124874,35.75,0.46,141,56367,70,NULL,NULL,'2MASX J14533391+4841552',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.39125,48.69881,0.025,NULL,59933977573,936468399,14632318,16.3),(124875,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124875,37.8,0.46,363,56368,70,NULL,NULL,'2MASX J14533528+0338320',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.9g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,223.397167,3.64219,0.125,NULL,59338008689,927156385,14486818,17.9),(124876,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124876,38.02,0.46,401,56369,70,NULL,NULL,'2MASX J14533540+0517450',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,223.397583333,5.29581,0.101,NULL,59335838073,927122469,14486288,16.5),(124877,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124877,37.16,0.46,270,56370,70,NULL,NULL,'2MASX J14533785+1624225',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000097,NULL,'16.7g',0.28,'E','Group member',NULL,NULL,NULL,1,223.407625,16.40617,0.017,NULL,59590117163,931095580,14548368,16.7),(124878,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124878,37.62,0.46,334,56371,70,NULL,NULL,'2MASX J14533852+1959094',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.4105417,19.98594,0.029,NULL,59533065169,930204143,14534439,NULL),(124879,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124879,37.14,0.46,268,56372,70,NULL,NULL,'SDSS J145339.94-003552.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000058,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.4164583,-0.59794,0.141,NULL,43490421508,679537836,10617778,18),(124880,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124880,36.68,0.23,217,56373,70,NULL,NULL,'GIN 377',NULL,'2001MNRAS.321..277C',2001,1,0.8,'Mislabeled as A1983 F in Colless, et al. (1993,MNRAS,262,475).','G',0.000213,NULL,'14.67',0.4,'S0','Group member',NULL,NULL,NULL,1,223.4165,18.07017,0.021,NULL,59587181819,931049715,14547651,14.67),(124881,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124881,37.22,0.23,278,56373,70,NULL,NULL,'GIN 377',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124882,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124882,37.39,0.25,301,56373,74.4,NULL,NULL,'GIN 377',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124883,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124883,35.97,0.46,157,56374,70,NULL,NULL,'2MASX J14533997+0255140',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000076,NULL,'16.5g',0.3,'NLAGN',NULL,NULL,NULL,NULL,1,223.416667,2.92067,0.125,NULL,59326555451,926977428,14484022,16.5),(124884,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124884,37.51,0.46,318,56375,70,NULL,NULL,'2MASX J14534239+0412020',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.4264583,4.20069,0.117,NULL,59334087318,927095114,14485861,17.2),(124885,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124885,32.14,0.8,26.8,56376,75,NULL,'B','NGC 5774',NULL,'1988NBGC.C....0000T',1988,1,1.9,'The Kiso position is for a superposed star or knot.','G',0.000007,NULL,'13.7g',1.12,'SAB(rs)d','Pair member (points to parent)',NULL,NULL,NULL,1,223.426917,3.5825,0.125,NULL,59338054394,927157099,14486829,13.7),(124886,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124886,31.55,NULL,20.4,56376,72,NULL,NULL,'NGC 5774',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124887,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124887,32.13,0.4,26.6,56376,NULL,NULL,'mean','NGC 5774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124888,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124888,32.68,0.46,34.3,56376,NULL,NULL,'J','NGC 5774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124889,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124889,32.71,0.47,34.8,56376,NULL,NULL,'H','NGC 5774',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124890,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124890,36.92,0.27,242,56377,70,NULL,NULL,'2MASX J14534327+3125182',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.430291667,31.42181,0,NULL,60090369950,938912030,14670500,17.9),(124891,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124891,36.35,0.46,186,56378,NULL,NULL,'Malmquist cor.','2MASX J14534439+1642015',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000023,NULL,'18.06',0.1,'S0','Group member',NULL,NULL,NULL,1,223.4352083,16.70042,0.017,NULL,59585753361,931027396,14547303,18.06),(124892,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124892,36.45,0.44,195,56378,NULL,NULL,NULL,'2MASX J14534439+1642015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124893,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124893,36.49,0.2,199,56378,74.4,NULL,NULL,'2MASX J14534439+1642015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124894,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124894,36.92,0.27,242,56379,70,NULL,NULL,'2MASX J14534461+3123154',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000195,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,223.4360417,31.3875,0,NULL,60090369585,938912024,14670500,16),(124895,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124895,37.03,0.1,254,56380,70,NULL,NULL,'2MASX J14534495+1827594',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.16,NULL,NULL,NULL,NULL,NULL,1,223.437333,18.46656,0.025,NULL,59586854030,931044594,14547571,18.56),(124896,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124896,37.4,0.46,303,56381,70,NULL,NULL,'2MASX J14534497+3230304',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.437416667,32.50858,0,NULL,60090145145,938908517,14670445,17.5),(124897,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124897,36.91,0.46,240,56382,70,NULL,NULL,'2MASX J14534502+1834064',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.93',0.3,'Sa/0','Group member',NULL,NULL,NULL,1,223.437583333,18.56836,0.025,NULL,59586843269,931044426,14547569,17.93),(124898,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124898,38.23,0.46,442,56383,70,NULL,NULL,'SDSS J145345.97+351144.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.4415417,35.19583,0.057,NULL,60125837254,939466207,14679159,18.6),(124899,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124899,37.97,0.11,392,56384,70,NULL,NULL,'2MASX J14534771+5409046',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.448667,54.15117,0,NULL,59191011408,924859553,14450930,18.5),(124900,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124900,37.7,0.33,347,56385,70,NULL,NULL,'2MASX J14534793+0623271',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.449916667,6.391,0.085,NULL,59380586074,927821657,14497213,17.7),(124901,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124901,36.84,0.33,233,56386,70,NULL,NULL,'2MASX J14534856+1421075',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.00',0.12,NULL,NULL,NULL,NULL,NULL,1,223.452333333,14.35211,0.041,NULL,59548342312,930442848,14538169,19),(124902,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124902,37.03,0.1,254,56387,70,NULL,NULL,'2MASX J14534868+1828224',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.452917,18.47286,0.025,NULL,59586854131,931044595,14547571,17.3),(124903,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124903,36.47,0.46,197,56388,70,NULL,NULL,'2MASX J14534908+0005230',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000103,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.4544583,0.08967,0.137,NULL,58252865704,910201026,14221891,16.4),(124904,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124904,37.47,0.46,312,56389,70,NULL,NULL,'2MASX J14534964+5348032',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.45675,53.80108,0,NULL,59190638474,924853726,14450839,18.1),(124905,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124905,37.22,0.33,278,56390,70,NULL,NULL,'2MASX J14534984+2517084',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.11',0.16,NULL,NULL,NULL,NULL,NULL,1,223.457625,25.28578,0.157,NULL,60012731614,937698931,14651545,18.11),(124906,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124906,37.22,0.23,278,56391,70,NULL,NULL,'SDSS J145350.18+180444.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.459125,18.07903,0.025,NULL,59587179192,931049674,14547651,18.1),(124907,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124907,37.97,0.11,392,56392,70,NULL,NULL,'2MASX J14535020+5404406',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.459125,54.07808,0,NULL,59191055254,924860238,14450941,17.1),(124908,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124908,37.81,0.46,365,56393,70,NULL,NULL,'2MASX J14535032+0450000',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.459667,4.83331,0.093,NULL,59336019479,927125304,14486332,17.4),(124909,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124909,37.56,0.46,325,56394,70,NULL,NULL,'2MASX J14535080+5000522',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,223.461708333,50.01458,0.029,NULL,59943408551,936615758,14634621,16.9),(124910,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124910,37.57,0.46,326,56395,70,NULL,NULL,'2MASX J14535308+3422095',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.471083333,34.36931,0.017,NULL,60124337089,939442767,14678793,17.1),(124911,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124911,37.86,0.46,373,56396,70,NULL,NULL,'2MASX J14535347+2547233',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.31',0.16,NULL,NULL,NULL,NULL,NULL,1,223.472875,25.78983,0.181,NULL,60012906562,937701665,14651588,18.31),(124912,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124912,37.03,0.1,254,56397,70,NULL,NULL,'SDSS J145354.38+184743.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.476625,18.79533,0.025,NULL,59586799371,931043740,14547558,17.5),(124913,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124913,37.7,0.33,347,56398,70,NULL,NULL,'2MASX J14535437+0627124',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,223.476667,6.45344,0.085,NULL,59380544179,927821002,14497203,16.3),(124914,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124914,37.97,0.11,392,56399,70,NULL,NULL,'2MASX J14535469+5416426',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.477625,54.27847,0,NULL,59191007296,924859489,14450929,16.9),(124915,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124915,35.7,0.46,138,56400,70,NULL,NULL,'2MASX J14535568+2435253',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00007,NULL,'15.66',0.31,NULL,NULL,NULL,NULL,NULL,1,223.482125,24.59053,0.121,NULL,59492850857,929575794,14524621,15.66),(124916,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124916,37.03,0.1,254,56401,70,NULL,NULL,'2MASX J14535670+1847244',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.486167,18.79,0.025,NULL,59586800779,931043762,14547558,17),(124917,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124917,37.97,0.11,392,56402,70,NULL,NULL,'2MASX J14535691+5425466',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,223.4872917,54.42958,0,NULL,59190974190,924858971,14450921,18.5),(124918,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124918,36.92,0.27,242,56403,70,NULL,NULL,'2MASX J14535757+3128405',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.4897917,31.47781,0,NULL,60090374573,938912102,14670501,16.8),(124919,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124919,32.13,0.8,26.7,56404,75,NULL,'B','NGC 5775',NULL,'1988NBGC.C....0000T',1988,1,4.2,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'12.2B',1,'Sb(f)','Pair member (points to parent)',NULL,NULL,NULL,1,223.49,3.54444,0.125,NULL,59338036625,927156822,14486825,12.2),(124920,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124920,31,0.4,15.9,56404,75,NULL,NULL,'NGC 5775',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124921,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124921,31.2,0.43,17.4,56404,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5775',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124922,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124922,31.23,0.47,17.7,56404,NULL,NULL,'H','NGC 5775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124923,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124923,31.24,0.45,17.7,56404,NULL,NULL,'K','NGC 5775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124924,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124924,31.29,0.46,18.1,56404,NULL,NULL,'J','NGC 5775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124925,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124925,31.33,0.43,18.4,56404,75,NULL,'3.6 micron, color corrected','NGC 5775',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124926,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124926,31.47,0.2,19.7,56404,74.4,NULL,NULL,'NGC 5775',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124927,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124927,31.52,0.49,20.1,56404,75,NULL,'IR','NGC 5775',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124928,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124928,31.65,NULL,21.4,56404,72,NULL,NULL,'NGC 5775',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124929,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124929,32.15,0.4,27,56404,NULL,NULL,'mean','NGC 5775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124930,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124930,36.28,0.33,180,56405,70,NULL,NULL,'SDSS J145359.48+044742.5',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000076,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.497875,4.79517,0.093,NULL,59336015922,927125248,14486332,17.1),(124931,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124931,37.14,0.46,268,56406,70,NULL,NULL,'2MASX J14535998+1114024',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.73',0.15,NULL,NULL,NULL,NULL,NULL,1,223.499916667,11.23392,0.037,NULL,59369700558,927651571,14494555,18.73),(124932,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124932,36.34,0.63,185,56407,70,NULL,NULL,'2MASX J14540191-4236575',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,223.508083333,-42.61589,0.437,NULL,47095464758,735866636,11497916,14.8),(124933,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124933,37.97,0.11,392,56408,70,NULL,NULL,'2MASX J14540279+5415565',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000113,NULL,'16.3g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,223.511417,54.26564,0,NULL,59191007440,924859491,14450929,16.3),(124934,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124934,37.49,0.46,315,56409,70,NULL,NULL,'2MASX J14540275+1901497',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'18.41',0.17,NULL,NULL,NULL,NULL,NULL,1,223.5114583,19.0305,0.037,NULL,59531417302,930178395,14534037,18.41),(124935,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124935,37.8,0.46,363,56410,70,NULL,NULL,'SDSS J145403.03+255652.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.512667,25.94794,0.183,NULL,60012950672,937702354,14651599,18.3),(124936,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124936,35.05,0.46,103,56411,70,NULL,NULL,'SDSS J145403.73+305046.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.0g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.515583,30.84625,0.022,NULL,60088916410,938889318,14670145,16),(124937,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124937,37.29,0.46,286,56412,70,NULL,NULL,'2MASX J14540401+5953239',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.5167917,59.89014,0,NULL,57770176294,902659004,14104046,18.1),(124938,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124938,36.56,0.33,205,56413,70,NULL,NULL,'2MASX J14540477+0915014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.70',0.22,NULL,NULL,NULL,NULL,NULL,1,223.5199583,9.25033,0.045,NULL,59375721379,927745646,14496025,16.7),(124939,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124939,36.51,0.25,200,56414,74.4,NULL,NULL,'GIN 379',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000093,NULL,'14.90',0.6,'E','Group member',NULL,NULL,NULL,1,223.5212917,18.4335,0.025,NULL,59586839228,931044362,14547568,14.9),(124940,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124940,36.68,0.23,217,56414,70,NULL,NULL,'GIN 379',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124941,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124941,37.03,0.1,254,56414,70,NULL,NULL,'GIN 379',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124942,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124942,37.97,0.11,392,56415,70,NULL,NULL,'2MASX J14540515+5416389',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.521375,54.2775,0,NULL,59191007247,924859488,14450929,18),(124943,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124943,38.45,0.35,444,56416,60,NULL,NULL,'ABELL 1999',0.1032,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,223.52375,54.31425,0,NULL,59190982512,924859101,14450923,NULL),(124944,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124944,38.66,0.46,539,56417,70,NULL,NULL,'2MASX J14540609+4329029',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000195,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.52525,43.48397,0.013,NULL,59981537374,937211521,14643930,17.9),(124945,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124945,37.37,0.27,298,56418,70,NULL,NULL,'2MASX J14540724+2717226',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.87',0.17,NULL,NULL,NULL,NULL,NULL,1,223.530125,27.28967,0.109,NULL,60013734995,937714609,14651790,17.87),(124946,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124946,37.33,0.46,292,56419,70,NULL,NULL,'2MASX J14540748+0456076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.531125,4.93533,0.097,NULL,59336014375,927125224,14486331,16.8),(124947,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124947,35.56,0.46,129,56420,70,NULL,NULL,'2MASX J14540774+4925452',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000189,NULL,'15.4g',0.26,'Sa',NULL,NULL,NULL,NULL,1,223.5322083,49.42914,0.025,NULL,59944222704,936628479,14634819,15.4),(124948,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124948,37.6,0.46,332,56421,70,NULL,NULL,'2MASX J14540869+0920254',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.71',0.16,NULL,NULL,NULL,NULL,NULL,1,223.5360417,9.34044,0.045,NULL,59375724733,927745698,14496026,18.71),(124949,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124949,38.45,0.46,491,56422,70,NULL,NULL,'2MASX J14541017+1304277',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.542417,13.07428,0.049,NULL,59547331413,930427053,14537922,17.7),(124950,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124950,38.93,0.46,611,56423,70,NULL,NULL,'SDSS J145410.66+291600.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.40',0.16,NULL,NULL,NULL,NULL,NULL,1,223.544417,29.26692,0,NULL,60092933634,938952088,14671126,17.4),(124951,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124951,36.37,0.84,188,56424,70,NULL,NULL,'2MFGC 12073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.545291667,-13.49056,0.317,NULL,46686111538,729470492,11397976,15),(124952,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124952,36.49,0.09,198,56425,70,NULL,NULL,'2MASX J14541123+1626237',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00015,NULL,'17.90',0.2,'S0/E','Group member',NULL,NULL,NULL,1,223.546875,16.44003,0.013,NULL,59590120972,931095640,14548369,17.9),(124953,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124953,35.86,0.71,149,56426,70,NULL,NULL,'ESO 448- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.8R',0.2,'Sb:',NULL,NULL,NULL,NULL,1,223.5470417,-31.07072,0.437,NULL,47201702113,737526595,11523853,14.8),(124954,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124954,36.02,0.33,160,56427,70,NULL,NULL,'2MASX J14541142+0456476',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.5475417,4.94656,0.097,NULL,59336000995,927125015,14486328,16.5),(124955,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124955,36.07,0.46,164,56428,70,NULL,NULL,'2MASX J14541212+5430240',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000073,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,223.5507083,54.50675,0.009,NULL,59190087682,924845120,14450705,15.5),(124956,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124956,38.1,0.19,416,56429,70,NULL,NULL,'2MASX J14541233+2135476',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.07',0.24,'BrClG',NULL,NULL,NULL,NULL,1,223.551333,21.5965,0.093,NULL,59541193577,930331149,14536424,17.07),(124957,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124957,36.02,0.33,160,56430,70,NULL,NULL,'IC 1072',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000116,NULL,'14.8g',0.58,'E','Group member',NULL,NULL,NULL,1,223.55475,4.84156,0.093,NULL,59335792918,927121764,14486277,14.8),(124958,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124958,37.36,0.33,297,56431,70,NULL,NULL,'2MASX J14541331+1058205',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.56',0.24,NULL,NULL,NULL,NULL,NULL,1,223.555583,10.97247,0.037,NULL,59369639218,927650612,14494540,16.56),(124959,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124959,37.36,0.33,297,56432,70,NULL,NULL,'SDSS J145413.48+105725.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.5562083,10.95722,0.037,NULL,59369639888,927650623,14494540,17.7),(124960,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124960,38.12,0.33,421,56433,70,NULL,NULL,'2MASX J14541358+0543026',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,223.556708333,5.71747,0.097,NULL,59335068863,927110450,14486100,17.1),(124961,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124961,36.49,0.09,198,56434,70,NULL,NULL,'2MASX J14541415+1622197',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.44',0.15,'E','Group member',NULL,NULL,NULL,1,223.559125,16.37222,0.017,NULL,59590386638,931099791,14548434,18.44),(124962,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124962,36.85,0.33,234,56435,70,NULL,NULL,'2MASX J14541512+4925503',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000205,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,223.562875,49.43053,0.025,NULL,59944219323,936628426,14634819,15.5),(124963,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124963,37.92,0.46,383,56436,70,NULL,NULL,'2MASX J14541598+5509241',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,223.566667,55.15672,0.009,NULL,57244819637,894450306,13975786,16.9),(124964,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124964,36.32,0.46,184,56437,70,NULL,NULL,'2MASX J14541623-0140174',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.56775,-1.6715,0.153,NULL,43489142134,679517845,10617466,17.5),(124965,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124965,34.56,0.4,81.6,56438,NULL,NULL,'mean','NGC 5784',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000053,NULL,'13.38',1.8,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,223.5685417,42.55792,0.005,NULL,59980927841,937201997,14643781,13.38),(124966,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124966,34.59,0.45,82.9,56438,NULL,NULL,'K','NGC 5784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124967,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124967,37.97,0.11,392,56439,70,NULL,NULL,'2MASX J14541747+5418271',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.573083333,54.30742,0,NULL,59190971238,924858925,14450920,17.4),(124968,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124968,36.73,0.46,222,56440,70,NULL,NULL,'2MASX J14541761+2447597',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.573333,24.79989,0.127,NULL,59493007772,929578246,14524660,NULL),(124969,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124969,34.57,0.46,82.2,56441,70,NULL,NULL,'CGCG 048-065',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000106,NULL,'14.2g',0.78,'E',NULL,NULL,NULL,NULL,1,223.574333,4.28389,0.145,NULL,59334150081,927096095,14485876,14.2),(124970,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124970,36.5,0.25,200,56442,74.4,NULL,NULL,'MCG +03-38-048',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.0001,NULL,'14.67',0.4,'Sa','Group member',NULL,NULL,NULL,1,223.574625,18.55325,0.025,NULL,59586822131,931044095,14547563,14.67),(124971,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124971,36.68,0.23,217,56442,70,NULL,NULL,'MCG +03-38-048',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124972,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124972,35.73,0.46,140,56443,70,NULL,NULL,'CGCG 105-065',NULL,'2015arXiv151105856S',2015,1,0.83,'Bright star to the northeast.','G',NULL,NULL,'15.7',0.33,NULL,NULL,NULL,NULL,NULL,1,223.5765,17.72058,0.013,NULL,59587067100,931047923,14547623,15.7),(124973,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124973,37.37,0.33,298,56444,70,NULL,NULL,'2MASX J14541929+3527521',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.580375,35.46447,0.025,NULL,60125807663,939465744,14679152,17.9),(124974,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124974,38.1,0.19,416,56445,70,NULL,NULL,'SDSS J145419.48+213736.7',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.581167,21.62689,0.093,NULL,59541226306,930331661,14536432,17.1),(124975,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124975,38.25,0.46,446,56446,70,NULL,NULL,'2MASX J14541963+1058015',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,223.581833,10.96717,0.037,NULL,59369638689,927650604,14494540,18.2),(124976,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124976,38.1,0.19,416,56447,70,NULL,NULL,'2MASX J14541950+2137366',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.30',0.18,NULL,NULL,NULL,NULL,NULL,1,223.582833,21.63181,0.093,NULL,59541111170,930329862,14536404,18.3),(124977,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124977,37.77,0.46,359,56448,70,NULL,NULL,'2MASX J14542014+1431067',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.13,NULL,NULL,NULL,NULL,NULL,1,223.5839583,14.51858,0.057,NULL,59578413566,930912711,14545511,18.7),(124978,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124978,37.44,0.46,307,56449,70,NULL,NULL,'2MASX J14542059+2715396',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.13',0.18,NULL,NULL,NULL,NULL,NULL,1,223.585667,27.26106,0.109,NULL,60013680338,937713755,14651777,18.13),(124979,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124979,36.85,0.33,234,56450,70,NULL,NULL,'2MASX J14542221+4921014',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.592541667,49.35036,0.021,NULL,59941332597,936583321,14634114,16.7),(124980,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124980,36.92,0.46,242,56451,70,NULL,NULL,'SDSS J145422.81+071523.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.595083,7.25664,0.089,NULL,59382058266,927844660,14497572,17.5),(124981,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124981,36.49,0.09,198,56452,70,NULL,NULL,'IC 4516',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000067,NULL,'14.22',1.1,'cD;E','Group member',NULL,NULL,NULL,1,223.5977083,16.35528,0.017,NULL,59590431614,931100493,14548445,14.22),(124982,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124982,36.56,0.25,205,56452,74.4,NULL,NULL,'IC 4516',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124983,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124983,36.79,0.26,228,56452,70,NULL,NULL,'IC 4516',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124984,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124984,36.45,0.45,195,56452,NULL,NULL,'K','IC 4516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124985,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124985,36.53,0.4,203,56452,NULL,NULL,'mean','IC 4516',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(124986,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124986,38.1,0.19,416,56453,70,NULL,NULL,'2MASX J14542432+2142476',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.23',0.15,NULL,NULL,NULL,NULL,NULL,1,223.601375,21.71339,0.093,NULL,59540407451,930318866,14536232,18.23),(124987,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124987,37.46,0.46,311,56454,70,NULL,NULL,'2MASX J14542464+4936484',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.602625,49.61356,0.021,NULL,59944246651,936628853,14634825,17.2),(124988,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124988,37.36,0.46,296,56455,70,NULL,NULL,'2MASX J14542533+5737221',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.6055417,57.62278,0,NULL,57727963159,901999424,14093741,17.1),(124989,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124989,37.97,0.11,392,56456,70,NULL,NULL,'2MASX J14542559+5416241',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000124,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.606625,54.27339,0,NULL,59191002864,924859419,14450928,18.1),(124990,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124990,36.53,0.46,202,56457,70,NULL,NULL,'2MASX J14542571+2250536',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.40',0.26,NULL,NULL,NULL,NULL,NULL,1,223.607166667,22.84814,0.089,NULL,59527229157,930112955,14533014,17.4),(124991,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124991,37.35,0.46,295,56458,70,NULL,NULL,'2MASX J14542596-0111184',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000096,NULL,'17.0g',0.22,'NLAGN',NULL,NULL,NULL,'Sy 2',1,223.608208333,-1.18831,0.169,NULL,43490160569,679533758,10617714,17),(124992,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124992,37.03,0.1,254,56459,70,NULL,NULL,'2MASX J14542692+1821156',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.65',0.14,NULL,NULL,NULL,NULL,NULL,1,223.612167,18.35436,0.025,NULL,59587201329,931050020,14547656,18.65),(124993,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124993,37.37,0.33,298,56460,70,NULL,NULL,'2MASX J14542740+3526271',NULL,'2015arXiv151105856S',2015,1,0.4,'May be a resolved component of 87GB[BWE91] 1452+3539.','G',0.000197,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,223.613917,35.44094,0.025,NULL,60125821800,939465965,14679155,16.7),(124994,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124994,36.2,0.46,174,56461,70,NULL,NULL,'2MASX J14542741+0632105',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.614167,6.53636,0.093,NULL,59380499363,927820302,14497192,16.2),(124995,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124995,36.94,0.46,244,56462,70,NULL,NULL,'2MASX J14542745+1106375',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.614375,11.11042,0.033,NULL,59369607015,927650109,14494532,17.2),(124996,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124996,37.03,0.1,254,56463,70,NULL,NULL,'SDSS J145428.00+183656.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'17.8O',0.14,'QSO:',NULL,NULL,NULL,NULL,1,223.616708333,18.61569,0.025,NULL,59586811509,931043929,14547561,17.8),(124997,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124997,37.37,0.27,298,56464,70,NULL,NULL,'2MASX J14542824+2717116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.14',0.16,NULL,NULL,NULL,NULL,NULL,1,223.617541667,27.28664,0.109,NULL,60013679416,937713740,14651777,18.14),(124998,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',124998,36.1,0.46,166,56465,70,NULL,NULL,'2MASX J14542852+2156575',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.80',0.18,NULL,NULL,NULL,NULL,NULL,1,223.618875,21.94936,0.081,NULL,59540378852,930318419,14536225,17.8),(124999,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,124999,37.42,0.35,288,56466,60,NULL,NULL,'ABELL 1991',0.0589,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I:     [BM]',NULL,NULL,NULL,NULL,1,223.630833,18.64194,0.025,NULL,59586829711,931044214,14547565,NULL),(125000,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125000,37.42,0.35,288,56467,60,NULL,'ABELL 1991, BCG','NGC 5778',0.0589,'1980ApJ...241..486H',1980,1,1.2,'1990ApJ...360..436B has V = 17034 +- 50 km/sec.','G',0.000077,NULL,'14.80',0.9,'cD;BrClG','Group member',NULL,'NAT',NULL,1,223.631208333,18.64231,0.025,NULL,59586829711,931044214,14547565,14.8),(125001,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125001,36.52,0.25,201,56467,74.4,NULL,NULL,'NGC 5778',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125002,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125002,36.68,0.23,217,56467,70,NULL,NULL,'NGC 5778',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125003,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125003,37.03,0.1,254,56467,70,NULL,NULL,'NGC 5778',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125004,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125004,35.82,0.46,146,56468,70,NULL,NULL,'CGCG 193-008',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'15.1g',0.57,'S0/a',NULL,NULL,NULL,NULL,1,223.634458333,37.07561,0.006,NULL,60119052139,939360189,14677502,15.1),(125005,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125005,35.22,0.27,111,56469,70,NULL,NULL,'NGC 5776',NULL,'2015arXiv151105856S',2015,1,1.24,NULL,'G',0.000087,NULL,'14.1g',0.79,'E0',NULL,NULL,NULL,NULL,1,223.6364583,2.96644,0.129,NULL,59326527000,926976984,14484015,14.1),(125006,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125006,34.99,0.46,99.5,56470,70,NULL,NULL,'2MASX J14543279+4223079',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,223.6364583,42.38542,0.013,NULL,59980967574,937202618,14643790,16.3),(125007,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125007,35.19,0.2,109,56471,74.4,NULL,NULL,'CGCG 164-042',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000047,NULL,'15.6',0.6,'Sa             Sbrst',NULL,NULL,NULL,NULL,1,223.6372083,29.06436,0.02,NULL,60092922725,938951917,14671123,15.6),(125008,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125008,38.33,0.46,464,56472,70,NULL,NULL,'2MASX J14543320+2218289',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.91',0.13,NULL,NULL,NULL,NULL,NULL,1,223.638333333,22.30811,0.089,NULL,59527568280,930118254,14533097,18.91),(125009,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125009,37.97,0.11,392,56473,70,NULL,NULL,'2MASX J14543335+5407131',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,223.639,54.12028,0,NULL,59190893296,924857707,14450901,18.3),(125010,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125010,34.5,0.52,79.5,56474,70,NULL,NULL,'2MASX J14543338-3747544',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.4I',0.5,NULL,NULL,NULL,NULL,NULL,1,223.639041667,-37.79847,0.277,NULL,47234677510,738041836,11531903,13.4),(125011,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125011,37.92,0.46,384,56475,70,NULL,NULL,'2MASX J14543335+1118305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.639041667,11.30861,0.033,NULL,59366866345,927607286,14493863,17.7),(125012,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125012,35.05,0.46,102,56476,70,NULL,NULL,'2MASX J14543467+3412171',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.644667,34.20483,0.017,NULL,60122513982,939414280,14678348,16),(125013,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125013,34.57,0.4,82.2,56477,NULL,NULL,'mean','IC 4517',NULL,'2007A&A...465...71T',2007,1,1.08,NULL,'G',0.000173,NULL,'15.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,223.6462083,23.64328,0.102,NULL,59495425185,929616018,14525250,15.1),(125014,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125014,34.95,0.47,97.8,56477,NULL,NULL,'H','IC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125015,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125015,34.98,0.45,98.9,56477,NULL,NULL,'K','IC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125016,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125016,35.05,0.46,102,56477,NULL,NULL,'J','IC 4517',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125017,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125017,35.13,0.2,106,56477,74.4,NULL,NULL,'IC 4517',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125018,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125018,38.12,0.33,421,56478,70,NULL,NULL,'2MASX J14543526+0536478',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,223.646791667,5.61322,0.097,NULL,59335556888,927118076,14486219,16.4),(125019,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125019,37.89,0.27,378,56479,70,NULL,NULL,'2MASX J14543543+3137001',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.647875,31.61658,0,NULL,60090423964,938912874,14670513,17.8),(125020,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125020,38.47,0.23,495,56480,70,NULL,NULL,'2MASX J14543558+2239200',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.6482083,22.65561,0.097,NULL,59527512991,930117390,14533084,18.1),(125021,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125021,37.62,0.46,334,56481,70,NULL,NULL,'2MASX J14543598-0202593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000127,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.649875,-2.04975,0.205,NULL,46441021208,725640956,11338139,17.9),(125022,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125022,37.03,0.1,254,56482,70,NULL,NULL,'2MASX J14543620+1841190',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000103,NULL,'17.64',0.2,'S0/E','Group member',NULL,NULL,NULL,1,223.650917,18.68847,0.025,NULL,59586828136,931044189,14547565,17.64),(125023,'Tully est','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125023,32.99,0.8,39.6,56483,75,NULL,'B','I Zw 097',NULL,'1988NBGC.C....0000T',1988,1,0.8,'MCG position is -1 minute, +8 arcmin in error.','G',0.00024,NULL,'14.9',0.6,'SABab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,223.663625,42.02389,0.009,NULL,59979086846,937173231,14643331,14.9),(125024,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125024,37.35,0.46,295,56484,70,NULL,NULL,'2MASX J14543901+1214430',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.15',0.22,NULL,NULL,NULL,NULL,NULL,1,223.6625,12.24528,0.029,NULL,59366632263,927603629,14493806,18.15),(125025,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125025,37.03,0.1,254,56485,70,NULL,NULL,'2MASX J14543928+1846120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000097,NULL,'18.06',0.17,'E','Group member',NULL,NULL,NULL,1,223.6635417,18.77017,0.025,NULL,59586778387,931043412,14547553,18.06),(125026,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125026,37.28,0.46,286,56486,70,NULL,NULL,'2MASX J14543989+2929486',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'18.12',0.17,'E',NULL,NULL,NULL,NULL,1,223.666416667,29.49694,0.026,NULL,60093832772,938966137,14671345,18.12),(125027,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125027,36.52,0.55,202,56487,70,NULL,NULL,'2MASX J14544029-1041252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,223.667917,-10.69028,0.309,NULL,46461939899,725967810,11343247,15.7),(125028,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125028,38.1,0.19,416,56488,70,NULL,NULL,'2MASX J14544030+2144010',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.668083,21.73369,0.085,NULL,59541120401,930330006,14536406,17.2),(125029,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125029,35.76,0.2,142,56489,74.4,NULL,NULL,'CGCG 134-053',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000672,NULL,'16.00',0.1,NULL,NULL,NULL,NULL,NULL,1,223.669125,25.71081,0.181,NULL,60013118493,937704976,14651640,16),(125030,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125030,35.36,0.49,118,56490,75,NULL,'IR','CGCG 134-053',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000672,NULL,'16.00',0.1,NULL,NULL,NULL,NULL,NULL,1,223.669125,25.71081,0.181,NULL,60013118493,937704976,14651640,16),(125031,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125031,38.04,0.46,406,56491,70,NULL,NULL,'SDSS J145440.66+525752.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000165,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,223.669458333,52.96467,0.005,NULL,59928503118,936382861,14630982,18.6),(125032,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125032,33.11,0.8,41.8,56492,75,NULL,'MAT, I','MCG -03-38-025',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.70',0.9,'SAB(rs)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,223.669417,-17.40567,0.393,NULL,46698369502,729662023,11400969,13.7),(125033,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125033,33,0.32,39.8,56492,85,NULL,'I, raw','MCG -03-38-025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125034,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125034,33.03,0.32,40.4,56492,85,NULL,'I, inv','MCG -03-38-025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125035,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125035,33.09,0.2,41.5,56492,74.4,NULL,NULL,'MCG -03-38-025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125036,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125036,33.16,0.43,42.9,56492,75,NULL,'MAT, I, raw','MCG -03-38-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125037,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125037,33.2,0.44,43.7,56492,NULL,NULL,'Malmquist cor.','MCG -03-38-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125038,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125038,33.23,0.4,44.4,56492,NULL,NULL,'mean','MCG -03-38-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125039,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125039,33.32,0.43,46.2,56492,75,NULL,'MAT, I, inv','MCG -03-38-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125040,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125040,33.33,0.43,46.3,56492,75,NULL,'MAT, I, cor','MCG -03-38-025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125041,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125041,33.35,0.41,46.8,56492,NULL,NULL,NULL,'MCG -03-38-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125042,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125042,33.44,0.47,48.8,56492,NULL,NULL,'H','MCG -03-38-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125043,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125043,33.44,0.46,48.8,56492,NULL,NULL,'J','MCG -03-38-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125044,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125044,33.53,0.45,50.9,56492,NULL,NULL,'K','MCG -03-38-025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125045,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125045,37.03,0.1,254,56493,70,NULL,NULL,'2MASX J14544070+1844570',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.58',0.13,NULL,NULL,NULL,NULL,NULL,1,223.669625,18.74922,0.025,NULL,59586785916,931043529,14547555,18.58),(125046,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125046,38.47,0.23,495,56494,70,NULL,NULL,'2MASX J14544141+2245210',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,'PHOT',NULL,NULL,'BrClG',NULL,NULL,NULL,NULL,1,223.6725417,22.75581,0.097,NULL,59527511717,930117370,14533083,NULL),(125047,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125047,38.47,0.23,495,56495,70,NULL,NULL,'SDSS J145441.43+224258.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.672666667,22.71639,0.097,NULL,59527507049,930117297,14533082,18.5),(125048,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125048,36.49,0.09,198,56496,70,NULL,NULL,'2MASX J14544150+1613360',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00015,NULL,'17.37',0.7,'E','Group member',NULL,NULL,NULL,1,223.6730417,16.22672,0.033,NULL,59590430411,931100475,14548444,17.37),(125049,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125049,37.03,0.1,254,56497,70,NULL,NULL,'2MASX J14544220+1835590',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'18.41',0.17,NULL,NULL,NULL,NULL,NULL,1,223.675917,18.59983,0.025,NULL,59586810672,931043916,14547561,18.41),(125050,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125050,37.02,0.46,254,56498,70,NULL,NULL,'SDSS J145442.22+310130.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.7g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.675958333,31.02517,0.028,NULL,60090230031,938909844,14670466,17.7),(125051,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125051,37.37,0.27,298,56499,70,NULL,NULL,'2MASX J14544315+2719316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.22',0.2,NULL,NULL,NULL,NULL,NULL,1,223.679667,27.32564,0.109,NULL,60081578531,938774664,14668354,17.22),(125052,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125052,37.49,0.33,315,56500,70,NULL,NULL,'2MASX J14544368+1249530',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.681917,12.8315,0.045,NULL,59547551763,930430496,14537976,17),(125053,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125053,38,0.46,397,56501,70,NULL,NULL,'SDSS J145443.80+383256.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000161,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,223.682541667,38.54892,0.037,NULL,60071352361,938614880,14665857,18.7),(125054,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125054,37.03,0.1,254,56502,70,NULL,NULL,'SDSS J145444.19+182958.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.684125,18.49953,0.025,NULL,59587327987,931051999,14547687,17),(125055,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125055,37.03,0.1,254,56503,70,NULL,NULL,'2MASXi J1454442+183502',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.68425,18.58392,0.025,NULL,59586810604,931043915,14547561,17.8),(125056,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125056,38.51,0.46,503,56504,70,NULL,NULL,'2MASX J14544439+2412406',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.6850417,24.21142,0.13,NULL,59492753581,929574274,14524598,17.6),(125057,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125057,38.1,0.19,416,56505,70,NULL,NULL,'2MASX J14544449+2136410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.6854583,21.61142,0.093,NULL,59541238868,930331857,14536435,18),(125058,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125058,36.49,0.09,198,56506,70,NULL,NULL,'2MASX J14544664+1615230',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'16.7g',0.23,'S0','Group member',NULL,NULL,NULL,1,223.694333,16.25631,0.033,NULL,59590420942,931100327,14548442,16.7),(125059,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125059,37.96,0.33,390,56507,70,NULL,NULL,'2MASX J14544684+0526578',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,223.69525,5.44931,0.097,NULL,59335566487,927118226,14486222,16.4),(125060,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125060,36.66,0.46,215,56508,70,NULL,NULL,'2MASX J14544706+0242128',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000075,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.696166667,2.70356,0.125,NULL,59327201920,926987530,14484180,16.7),(125061,'BCG','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125061,38.45,0.35,444,56509,60,NULL,'ABELL 1999, BCG','2MASX J14544709+5422331',0.1032,'1980ApJ...241..486H',1980,1,0.36,NULL,'G',0.000217,NULL,'16.6g',0.35,NULL,'Brightest group member',NULL,NULL,NULL,1,223.696166667,54.37581,0.013,NULL,59190103021,924845359,14450708,16.6),(125062,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125062,36.75,0.46,224,56510,70,NULL,NULL,'2MASX J14544716+2513546',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.82',0.23,NULL,NULL,NULL,NULL,NULL,1,223.6965,25.23192,0.144,NULL,59492415491,929568992,14524515,16.82),(125063,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125063,37.87,0.46,374,56511,70,NULL,NULL,'2MASX J14544725-0041337',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000068,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.696958333,-0.69281,0.141,NULL,43490360064,679536876,10617763,17.6),(125064,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125064,37.69,0.46,345,56512,70,NULL,NULL,'2MASX J14544775+5737571',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000198,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.699,57.63269,0,NULL,57727921803,901998778,14093730,17.8),(125065,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125065,37.06,0.46,258,56513,70,NULL,NULL,'2MASX J14544778+3400580',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.699083,34.01597,0.045,NULL,60122723696,939417557,14678399,17.1),(125066,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125066,36.51,0.25,200,56514,74.4,NULL,NULL,'CGCG 105-068',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000117,NULL,'14.54',0.4,'SBbc','Group member',NULL,NULL,NULL,1,223.6995,18.56433,0.025,NULL,59587325661,931051963,14547686,14.54),(125067,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125067,36.68,0.23,217,56514,70,NULL,NULL,'CGCG 105-068',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125068,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125068,37.67,0.46,342,56515,70,NULL,NULL,'2MASX J14544820-0220447',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.700791667,-2.34561,0.225,NULL,46441272989,725644890,11338201,17.8),(125069,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125069,34.44,0.2,77.3,56516,74.4,NULL,NULL,'IC 1075',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000007,NULL,'14.62',0.7,'SBb','Pair member, S + S',NULL,NULL,NULL,1,223.7052083,18.10597,0.025,NULL,59587195624,931049931,14547655,14.62),(125070,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125070,37.95,0.46,390,56517,70,NULL,NULL,'2MASX J14545020+0059248',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.709125,0.99039,0.129,NULL,58254356906,910224326,14222255,17.8),(125071,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125071,38.05,0.46,407,56518,70,NULL,NULL,'2MASX J14545061+2315231',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.711,23.25656,0.093,NULL,59527158755,930111855,14532997,17.6),(125072,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125072,37.72,0.46,350,56519,70,NULL,NULL,'2MASX J14545067+3020028',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.711125,30.33406,0.043,NULL,60093612540,938962695,14671292,18.1),(125073,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125073,37.96,0.33,390,56520,70,NULL,NULL,'2MASX J14545073+0528318',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.711375,5.47553,0.097,NULL,59335559403,927118115,14486220,17.5),(125074,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125074,37.6,0.46,331,56521,70,NULL,NULL,'2MASX J14545109+3036108',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.712833333,30.60303,0.037,NULL,60093425874,938959779,14671246,17.7),(125075,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125075,37.79,0.46,361,56522,70,NULL,NULL,'2MASX J14545157+1824351',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00011,NULL,'18.71',0.13,NULL,NULL,NULL,NULL,NULL,1,223.714833333,18.40969,0.025,NULL,59587392568,931053008,14547703,18.71),(125076,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125076,37.13,0.46,267,56523,70,NULL,NULL,'2MASX J14545250+2231381',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.37',0.14,NULL,NULL,NULL,NULL,NULL,1,223.7187917,22.52728,0.101,NULL,59527607178,930118862,14533107,18.37),(125077,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125077,37.3,0.46,289,56524,70,NULL,NULL,'2MASX J14545289+2536527',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.04',0.2,NULL,NULL,NULL,NULL,NULL,1,223.720417,25.61464,0.153,NULL,60012999073,937703110,14651611,17.04),(125078,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125078,36.52,0.25,201,56525,74.4,NULL,NULL,'GIN 378',NULL,'2013AJ....146...86T',2013,1,0.28,NULL,'G',0.000067,NULL,'15.15',0.25,'Sa/0','Group member',NULL,NULL,NULL,1,223.725125,18.83681,0.033,NULL,59531408481,930178257,14534035,15.15),(125079,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125079,36.68,0.23,217,56525,70,NULL,NULL,'GIN 378',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125080,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125080,37.42,0.46,305,56526,70,NULL,NULL,'2MASX J14545401+3257389',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.725,32.96075,0.008,NULL,60123059389,939422802,14678481,17.9),(125081,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125081,37.03,0.1,254,56527,70,NULL,NULL,'2MASX J14545478+1841361',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.71',0.24,'SB0','Group member',NULL,NULL,NULL,1,223.728417,18.69328,0.025,NULL,59586785100,931043517,14547554,17.71),(125082,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125082,37.17,0.33,271,56528,70,NULL,NULL,'2MASX J14545561+4921082',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.731958333,49.35244,0.021,NULL,59941330959,936583296,14634114,17.1),(125083,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125083,38.47,0.23,495,56529,70,NULL,NULL,'2MASX J14545616+2240151',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.7342083,22.67086,0.097,NULL,59527634404,930119287,14533113,18.1),(125084,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125084,36.41,0.33,191,56530,70,NULL,NULL,'2MASX J14545693+0044068',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00009,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.737125,0.73511,0.133,NULL,58253968020,910218250,14222160,17.9),(125085,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125085,37.63,0.46,336,56531,70,NULL,NULL,'2MASX J14545786+5450092',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000201,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.7412083,54.83583,0.005,NULL,57244056866,894438388,13975599,16.4),(125086,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125086,37.51,0.46,318,56532,70,NULL,NULL,'2MASX J14545881+2547417',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.745041667,25.79489,0.156,NULL,60013122763,937705043,14651641,17.8),(125087,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125087,34.86,0.4,93.6,56533,NULL,NULL,'mean','IC 1076',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'14.2',0.5,'SBc            Sbrst','Possible field galaxy',NULL,NULL,'Starburst',1,223.748417,18.03733,0.025,NULL,59587185243,931049769,14547652,14.2),(125088,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125088,35.03,0.47,102,56533,NULL,NULL,'H','IC 1076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125089,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125089,37.89,0.27,378,56534,70,NULL,NULL,'2MASX J14550031+3140529',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.7514583,31.68139,0.017,NULL,60090420087,938912813,14670512,17.6),(125090,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125090,37.81,0.46,365,56535,70,NULL,NULL,'2MASX J14550160+4230287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.756583333,42.50803,0.013,NULL,59980925497,937201960,14643780,17.2),(125091,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125091,38.26,0.46,448,56536,70,NULL,NULL,'2MASX J14550242+1629413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.760083,16.49489,0.017,NULL,59590138436,931095913,14548373,17.5),(125092,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125092,37.49,0.33,315,56537,70,NULL,NULL,'2MASX J14550250+1251113',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.35',0.21,NULL,NULL,NULL,NULL,NULL,1,223.760333,12.85333,0.045,NULL,59547560988,930430640,14537978,18.35),(125093,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125093,37.97,0.11,392,56538,70,NULL,NULL,'2MASX J14550366+5419452',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'16.8g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,223.765083333,54.32931,0.005,NULL,59190100436,924845319,14450708,16.8),(125094,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125094,37.78,0.46,359,56539,70,NULL,NULL,'2MASX J14550626+1318113',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,223.776083333,13.30308,0.029,NULL,59546882609,930420040,14537813,NULL),(125095,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125095,37.07,0.46,260,56540,70,NULL,NULL,'2MASX J14550728+3450359',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000186,NULL,'15.9g',0.45,'E0',NULL,NULL,NULL,NULL,1,223.78025,34.84333,0.017,NULL,60125614893,939462732,14679105,15.9),(125096,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125096,37.89,0.27,378,56541,70,NULL,NULL,'SDSS J145507.48+314001.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.781167,31.66703,0.017,NULL,60090430515,938912976,14670515,18.5),(125097,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125097,38.06,0.46,409,56542,70,NULL,NULL,'2MASX J14550771+3857206',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,223.78225,38.95575,0.045,NULL,60071591091,938618610,14665915,16.7),(125098,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125098,37.97,0.11,392,56543,70,NULL,NULL,'2MASX J14550825+5418063',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000173,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.784125,54.30183,0.005,NULL,59190215667,924847119,14450736,18.1),(125099,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125099,34.39,0.8,75.5,56544,75,NULL,'CF, r','UGC 09598',NULL,'1997ApJS..109..333W',1997,1,1.74,NULL,'G',0.000162,NULL,'14.3g',0.55,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,223.78775,43.81858,0.037,NULL,59981288465,937207632,14643869,14.3),(125100,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125100,34.46,0.2,78,56544,74.4,NULL,NULL,'UGC 09598',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125101,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125101,34.47,0.41,78.5,56544,NULL,NULL,'Malmquist cor.','UGC 09598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125102,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125102,34.59,0.38,82.6,56544,75,NULL,'CF, r, raw','UGC 09598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125103,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125103,34.63,0.38,84.4,56544,NULL,NULL,NULL,'UGC 09598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125104,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125104,34.68,0.4,86.4,56544,NULL,NULL,'mean','UGC 09598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125105,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125105,34.74,0.38,88.8,56544,75,NULL,'CF, r, inv','UGC 09598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125106,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125106,34.83,0.47,92.5,56544,NULL,NULL,'H','UGC 09598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125107,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125107,34.85,0.38,93.3,56544,75,NULL,'CF, r, cor','UGC 09598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125108,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125108,34.93,0.46,96.9,56544,NULL,NULL,'J','UGC 09598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125109,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125109,35.03,0.45,101,56544,NULL,NULL,'K','UGC 09598',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125110,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125110,38.16,0.46,428,56545,70,NULL,NULL,'2MASX J14550921+5151153',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.7885417,51.85406,0.037,NULL,59930107691,936407932,14631373,17.8),(125111,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125111,37.03,0.1,254,56546,70,NULL,NULL,'2MASX J14551187+1853594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'18.25',0.16,NULL,NULL,NULL,NULL,NULL,1,223.799416667,18.89997,0.033,NULL,59531396239,930178066,14534032,18.25),(125112,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125112,37.04,0.33,256,56547,70,NULL,NULL,'2MASX J14551222+1908484',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.26',0.18,NULL,NULL,NULL,NULL,NULL,1,223.800875,19.14675,0.057,NULL,59531707523,930182930,14534108,18.26),(125113,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125113,33.39,0.8,47.6,56548,75,NULL,'MAT, I','ESO 580- G 052',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000019,NULL,'14.06',1.2,'SB(s)d pec?    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,223.803417,-19.66478,0.357,NULL,46651837922,728934967,11389608,14.06),(125114,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125114,33.52,0.62,50.5,56548,NULL,NULL,'Malmquist cor.','ESO 580- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125115,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125115,33.7,0.32,54.9,56548,85,NULL,'I, raw','ESO 580- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125116,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125116,33.74,0.32,55.9,56548,85,NULL,'I, inv','ESO 580- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125117,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125117,33.77,0.43,56.9,56548,75,NULL,'MAT, I, raw','ESO 580- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125118,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125118,33.78,0.2,57,56548,74.4,NULL,NULL,'ESO 580- G 052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125119,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125119,33.91,0.52,60.5,56548,NULL,NULL,NULL,'ESO 580- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125120,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125120,33.96,0.43,61.9,56548,75,NULL,'MAT, I, inv','ESO 580- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125121,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125121,33.96,0.43,62,56548,75,NULL,'MAT, I, cor','ESO 580- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125122,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125122,33.62,0.49,52.9,56549,75,NULL,'IR','UGC 09605',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.00001,NULL,'15.7g',0.21,'Sd',NULL,NULL,NULL,NULL,1,223.815917,48.36564,0.041,NULL,59934436349,936475567,14632430,15.7),(125123,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125123,34.1,NULL,66.2,56549,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125124,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125124,34.12,NULL,66.7,56549,NULL,NULL,'Dipole','UGC 09605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125125,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125125,34.12,NULL,66.7,56549,NULL,NULL,'Dipole + Quadrupole','UGC 09605',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125126,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125126,34.74,NULL,88.5,56549,NULL,NULL,NULL,'UGC 09605',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125127,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125127,37.65,0.46,339,56550,70,NULL,NULL,'SDSS J145516.86+173320.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.82025,17.55567,0.029,NULL,59586948404,931046068,14547594,17.9),(125128,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125128,35.15,0.4,107,56551,75,NULL,'Edat, raw','ESO 386- G 031',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00015,NULL,'15.5',0.7,'S0',NULL,NULL,NULL,NULL,1,223.830417,-35.72536,0.261,NULL,47243353979,738177405,11534021,15.5),(125129,'D-Sigma','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125129,35.49,0.4,125,56551,75,NULL,'Edat, cor','ESO 386- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125130,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125130,37.56,0.46,325,56552,70,NULL,NULL,'2MASX J14551968+0104104',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,223.832166667,1.06956,0.133,NULL,58250856439,910169631,14221400,17.2),(125131,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125131,36.3,0.46,182,56553,70,NULL,NULL,'2MASX J14551998+0929564',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.82',0.15,NULL,NULL,NULL,NULL,NULL,1,223.833417,9.49911,0.037,NULL,59376589823,927759215,14496237,18.82),(125132,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125132,37.97,0.11,392,56554,70,NULL,NULL,'2MASX J14552184+5427413',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000132,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,223.840666667,54.46153,0.013,NULL,59190108065,924845438,14450709,18.1),(125133,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125133,38.16,0.27,429,56555,70,NULL,NULL,'SDSS J145523.31+092705.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.847167,9.45161,0.037,NULL,59376588440,927759194,14496237,17.9),(125134,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125134,38.04,0.33,405,56556,70,NULL,NULL,'SDSS J145523.65+223012.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.848583,22.50344,0.101,NULL,59527654987,930119609,14533118,18),(125135,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125135,36.51,0.25,200,56557,74.4,NULL,NULL,'CGCG 105-076',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000077,NULL,'14.43',0.6,'Sa','Group member',NULL,NULL,NULL,1,223.8490417,18.83567,0.033,NULL,59531657424,930182147,14534096,14.43),(125136,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125136,36.68,0.23,217,56557,70,NULL,NULL,'CGCG 105-076',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125137,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125137,37.83,0.33,368,56558,70,NULL,NULL,'2MASX J14552471+3237316',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.852917,32.6255,0.013,NULL,60089776608,938902759,14670355,18),(125138,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125138,37.71,0.46,349,56559,70,NULL,NULL,'SDSS J145525.55+312020.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.8564583,31.33892,0.034,NULL,60090459251,938913425,14670522,17.5),(125139,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125139,37.95,0.46,388,56560,70,NULL,NULL,'2MASXi J1455258-003420',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.85775,-0.57233,0.149,NULL,43486929635,679483275,10616926,17.9),(125140,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125140,37.38,0.46,299,56561,70,NULL,NULL,'2MASX J14552661+3130047',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.15,NULL,NULL,NULL,NULL,NULL,1,223.860625,31.50122,0.034,NULL,60090454383,938913349,14670521,18.27),(125141,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125141,34.63,0.46,84.3,56562,70,NULL,NULL,'CGCG 221-014',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000147,NULL,'14.6g',0.53,'S0/a',NULL,NULL,NULL,NULL,1,223.8642083,41.25733,0.017,NULL,59949617428,936712772,14636137,14.6),(125142,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125142,37.6,0.46,331,56563,70,NULL,NULL,'2MASX J14552907+3329477',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.871125,33.4965,0.036,NULL,60123140577,939424071,14678501,18.2),(125143,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125143,38.59,0.46,523,56564,70,NULL,NULL,'2MASX J14552912+5453523',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.871125,54.89792,0.005,NULL,57244036884,894438076,13975594,18),(125144,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125144,37.45,0.46,310,56565,70,NULL,NULL,'2MASX J14552912+2942334',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000197,NULL,'18.14',0.17,'Pec',NULL,NULL,NULL,NULL,1,223.87125,29.70942,0.06,NULL,60093866894,938966670,14671354,18.14),(125145,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125145,36.49,0.09,198,56566,70,NULL,NULL,'2MASX J14552971+1627465',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.43',0.5,'S0','Group member',NULL,NULL,NULL,1,223.8739583,16.46286,0.025,NULL,59590250333,931097661,14548400,16.43),(125146,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125146,36.43,0.76,193,56567,70,NULL,NULL,'LCRS B145254.3-052427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.69',NULL,NULL,NULL,NULL,NULL,NULL,1,223.885083,-5.60958,0.241,NULL,46445624325,725712880,11339263,16.69),(125147,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125147,35.86,0.46,148,56568,70,NULL,NULL,'2MASX J14553300+0302143',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000089,NULL,'16.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,223.8874583,3.03717,0.133,NULL,59326464607,926976009,14484000,16.1),(125148,'FP','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,'R',125148,38.43,0.46,486,56569,70,NULL,NULL,'2MASX J14553388+2841234',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.8910417,28.68997,0.066,NULL,60082196964,938784327,14668505,17.9),(125149,'IRAS','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125149,33.92,0.8,60.7,56570,75,NULL,'MAT, I','ESO 327- G 031',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000023,NULL,'12.70',0.4,'SB(s)c? sp',NULL,NULL,NULL,NULL,1,223.8927083,-38.27833,0.265,NULL,47235526820,738055106,11532111,12.7),(125150,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125150,32.96,0.32,39.1,56570,85,NULL,'I, raw','ESO 327- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125151,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125151,32.98,0.32,39.5,56570,85,NULL,'I, inv','ESO 327- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125152,'Tully-Fisher','2016-12-15 15:15:29','2016-12-16 11:20:43','1',NULL,NULL,125152,33.01,0.43,39.9,56570,75,NULL,'MAT, I, raw','ESO 327- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125153,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125153,33.14,0.43,42.5,56570,75,NULL,'MAT, I, inv','ESO 327- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125154,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125154,33.19,0.8,43.4,56570,NULL,NULL,NULL,'ESO 327- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125155,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125155,33.23,0.2,44.3,56570,74.4,NULL,NULL,'ESO 327- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125156,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125156,33.27,0.77,45.1,56570,NULL,NULL,'Malmquist cor.','ESO 327- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125157,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125157,33.42,0.43,48.2,56570,75,NULL,'MAT, I, cor','ESO 327- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125158,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125158,37.18,0.33,273,56571,70,NULL,NULL,'2MASX J14553476+5000380',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,223.895,50.01069,0.009,NULL,59943261023,936613453,14634585,16.9),(125159,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125159,35.75,0.46,142,56572,70,NULL,NULL,'2MASX J14553517+6305271',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000093,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.896833,63.09072,0.013,NULL,57764474048,902569907,14102654,16.8),(125160,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125160,38.19,0.46,434,56573,70,NULL,NULL,'2MASX J14553541+2105274',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.8975417,21.09106,0.049,NULL,59540710863,930323607,14536306,17.9),(125161,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125161,38.11,0.46,418,56574,70,NULL,NULL,'SDSS J145535.85+525713.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.899375,52.95361,0.005,NULL,59928496335,936382755,14630980,18.1),(125162,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125162,36.78,0.33,227,56575,70,NULL,NULL,'2MASX J14553630+2527129',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.15',0.29,NULL,NULL,NULL,NULL,NULL,1,223.9012083,25.45353,0.153,NULL,60012961513,937702523,14651601,17.15),(125163,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125163,36.93,0.46,243,56576,70,NULL,NULL,'2MASX J14553633+0326333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,223.9015,3.44264,0.141,NULL,59338825961,927169155,14487018,17.4),(125164,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125164,35.74,0.65,140,56577,70,NULL,NULL,'ESO 581- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'16',1,'SAB(r)bc',NULL,NULL,NULL,NULL,1,223.90825,-21.59222,0.397,NULL,46655303603,728989118,11390454,16),(125165,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125165,38.35,0.46,467,56578,70,NULL,NULL,'SDSS J145539.41+020319.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.91425,2.0555,0.149,NULL,59326856834,926982138,14484095,18.4),(125166,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125166,36.38,0.46,188,56579,70,NULL,NULL,'2MASX J14553971+2335334',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.98',0.17,NULL,NULL,NULL,NULL,NULL,1,223.915375,23.59261,0.085,NULL,59529235688,930144307,14533504,17.98),(125167,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125167,38.04,0.33,405,56580,70,NULL,NULL,'2MASX J14553970+2224214',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.54',0.27,NULL,NULL,NULL,NULL,NULL,1,223.915541667,22.406,0.101,NULL,59527552907,930118014,14533093,17.54),(125168,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125168,37.04,0.33,256,56581,70,NULL,NULL,'2MASX J14554049+1916514',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.31',0.27,'E','Group member',NULL,NULL,NULL,1,223.9187917,19.281,0.081,NULL,59531798907,930184357,14534130,17.31),(125169,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125169,38.02,0.46,402,56582,70,NULL,NULL,'2MASX J14554058+4925471',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,223.9189583,49.42964,0.021,NULL,59944238770,936628730,14634823,17.8),(125170,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125170,36.99,0.46,250,56583,70,NULL,NULL,'2MASX J14554233+2819509',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.49',0.24,NULL,NULL,NULL,NULL,NULL,1,223.92625,28.33069,0.061,NULL,60082332013,938786437,14668538,17.49),(125171,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125171,36.58,0.46,207,56584,70,NULL,NULL,'2MASX J14554341+2108314',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.57',0.18,NULL,NULL,NULL,NULL,NULL,1,223.9310417,21.14197,0.049,NULL,59540601031,930321891,14536279,17.57),(125172,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125172,37.59,0.33,329,56585,70,NULL,NULL,'2MASX J14554489-0018218',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000098,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,223.937166667,-0.30617,0.161,NULL,43487015895,679484623,10616947,16.1),(125173,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125173,37.18,0.33,273,56586,70,NULL,NULL,'2MASX J14554521+5008091',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000189,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.938291667,50.13589,0.009,NULL,59943232772,936613012,14634578,16.5),(125174,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125174,37.62,0.27,335,56587,70,NULL,NULL,'2MASX J14554528+4731329',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.9385417,47.52572,0.041,NULL,59989138172,937330283,14645785,17.8),(125175,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125175,35.46,0.54,124,56588,70,NULL,NULL,'2MASX J14554568-3946020',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000113,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,223.9404583,-39.76725,0.185,NULL,47216234261,737753660,11527400,13.4),(125176,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125176,37.59,0.33,329,56589,70,NULL,NULL,'2MASX J14554576-0020058',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000102,NULL,'16.3g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,223.940708333,-0.33494,0.161,NULL,43487016594,679484634,10616947,16.3),(125177,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125177,36.36,0.33,187,56590,70,NULL,NULL,'2MASX J14554655+2151074',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.15',0.24,NULL,NULL,NULL,NULL,NULL,1,223.9439583,21.85211,0.081,NULL,59541103609,930329743,14536402,17.15),(125178,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125178,38.09,0.46,414,56591,70,NULL,NULL,'2MASX J14554707+3954583',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,223.946333,39.91608,0.041,NULL,60070907757,938607933,14665748,17.2),(125179,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125179,37.03,0.1,254,56592,70,NULL,NULL,'2MASX J14554754+1823044',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000097,NULL,'18.33',0.16,NULL,NULL,NULL,NULL,NULL,1,223.948083,18.38469,0.025,NULL,59587370108,931052657,14547697,18.33),(125180,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125180,36.41,0.33,191,56593,70,NULL,NULL,'2MASX J14554837+0052073',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000079,NULL,'16.7g',0.3,'AGN',NULL,NULL,NULL,NULL,1,223.951625,0.86881,0.133,NULL,58250872858,910169888,14221404,16.7),(125181,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125181,38.17,0.46,431,56594,70,NULL,NULL,'SDSS J145548.81+260140.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.953375,26.02794,0.156,NULL,60013042782,937703793,14651621,18.7),(125182,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125182,37.97,0.11,392,56595,70,NULL,NULL,'2MASX J14555059+5414209',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,223.9605417,54.23906,0.005,NULL,59190195731,924846808,14450731,18),(125183,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125183,38.99,0.46,627,56596,70,NULL,NULL,'SDSS J145551.30+130245.4',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.963791667,13.04597,0.029,NULL,59547473923,930429280,14537957,18.4),(125184,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125184,37.17,0.33,271,56597,70,NULL,NULL,'2MASX J14555216+4925302',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,223.967583,49.42511,0.021,NULL,59944238285,936628723,14634823,16.7),(125185,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125185,34.69,NULL,86.6,56598,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09606',NULL,'2010Ap&SS.325..163P',2010,1,1.62,NULL,'G',0.000008,NULL,'16.0',0.18,'Sbc',NULL,NULL,NULL,NULL,1,223.96825,24.71972,0.081,NULL,59493002351,929578161,14524658,16),(125186,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125186,34.69,NULL,86.9,56598,NULL,NULL,'Dipole + Quadrupole','UGC 09606',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125187,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125187,34.71,NULL,87.3,56598,NULL,NULL,'Dipole','UGC 09606',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125188,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125188,34.74,NULL,88.6,56598,NULL,NULL,NULL,'UGC 09606',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125189,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125189,34.79,0.49,90.8,56598,75,NULL,'IR','UGC 09606',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125190,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125190,35.34,0.2,117,56598,74.4,NULL,NULL,'UGC 09606',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125191,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125191,37.32,0.33,291,56599,70,NULL,NULL,'2MASX J14555287-0155338',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,223.9702917,-1.92617,0.161,NULL,46441124502,725642570,11338165,17),(125192,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125192,37.62,0.27,335,56600,70,NULL,NULL,'2MASX J14555467+4732134',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.97775,47.53706,0.041,NULL,59989145721,937330401,14645787,17.8),(125193,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125193,35.79,0.4,144,56601,NULL,NULL,'mean','NGC 5782',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000147,NULL,'14.59',0.8,'S0','Pair member (points to parent)',NULL,'radio jet','Flat-Spectrum Radio Source',1,223.980291667,11.86153,0.037,NULL,59367174184,927612096,14493939,14.59),(125194,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125194,36.59,0.45,208,56601,NULL,NULL,'K','NGC 5782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125195,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125195,38.11,0.46,418,56602,70,NULL,NULL,'2MASX J14555582+2944019',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000183,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,223.982667,29.73389,0.051,NULL,60093680763,938963761,14671308,17.6),(125196,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125196,36.5,0.25,200,56603,74.4,NULL,NULL,'CGCG 105-077',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000077,NULL,'14.45',0.33,'E','Group member',NULL,NULL,NULL,1,223.9862917,18.04733,0.041,NULL,59587279474,931051241,14547675,14.45),(125197,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125197,36.54,0.46,204,56603,70,NULL,NULL,'CGCG 105-077',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125198,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125198,36.68,0.23,217,56603,70,NULL,NULL,'CGCG 105-077',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125199,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125199,36.93,0.46,243,56604,70,NULL,NULL,'2MASX J14555687-0152018',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,223.9869583,-1.86731,0.161,NULL,46440950851,725639857,11338122,17.3),(125200,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125200,37.83,0.33,368,56605,70,NULL,NULL,'SDSS J145557.16+323459.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,223.988167,32.58319,0.013,NULL,60089823568,938903493,14670367,18.7),(125201,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125201,37.36,0.46,297,56606,70,NULL,NULL,'2MASX J14555745+0523323',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,223.989583,5.39225,0.085,NULL,59335610228,927118909,14486232,17.6),(125202,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125202,36.5,0.25,200,56607,74.4,NULL,NULL,'GIN 381',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000244,NULL,'15.25',0.4,'Sc','Group member',NULL,NULL,NULL,1,223.991583333,18.50233,0.025,NULL,59587345766,931052277,14547691,15.25),(125203,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125203,36.68,0.23,217,56607,70,NULL,NULL,'GIN 381',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125204,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125204,37.61,0.46,332,56608,70,NULL,NULL,'SDSS J145558.09+353208.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000128,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,223.9920417,35.53569,0,NULL,60125733873,939464591,14679134,18),(125205,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125205,36.78,0.33,227,56609,70,NULL,NULL,'2MASX J14555853+2536289',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.61',0.13,NULL,NULL,NULL,NULL,NULL,1,223.993833333,25.60808,0.143,NULL,60012983988,937702874,14651607,18.61),(125206,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125206,37.32,0.33,291,56610,70,NULL,NULL,'2MASX J14555874-0157458',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000113,NULL,'17.4g',0.23,'AGN',NULL,NULL,NULL,NULL,1,223.994708333,-1.96261,0.161,NULL,46441125223,725642581,11338165,17.4),(125207,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125207,37.62,0.33,335,56611,70,NULL,NULL,'SDSS J145558.88+260348.6',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,223.995333,26.0635,0.156,NULL,60013048667,937703885,14651623,16.4),(125208,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125208,35.46,0.46,124,56612,70,NULL,NULL,'2MASX J14555917+3539479',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000171,NULL,'16.0g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,223.996417,35.66342,0.009,NULL,60126191450,939471741,14679245,16),(125209,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125209,37.29,0.46,287,56613,70,NULL,NULL,'2MASX J14555965+0446523',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000094,NULL,'16.3g',0.36,'AGN',NULL,NULL,NULL,NULL,1,223.9985,4.78108,0.117,NULL,59335250423,927113287,14486145,16.3),(125210,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125210,37.42,0.46,304,56614,70,NULL,NULL,'2MASX J14555967+1153097',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,223.998708333,11.88622,0.037,NULL,59367174884,927612107,14493939,17.5),(125211,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125211,38.58,0.46,520,56615,70,NULL,NULL,'SDSS J145601.36+441820.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.0057083,44.30556,0.049,NULL,59992652465,937385194,14646643,18.3),(125212,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125212,37.38,0.46,300,56616,70,NULL,NULL,'2MASX J14560225+0516001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.009375,5.26681,0.085,NULL,59335334069,927114594,14486165,17.3),(125213,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125213,37.46,0.46,311,56617,70,NULL,NULL,'SDSS J145602.33+211059.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.0097083,21.18311,0.037,NULL,59540600374,930321880,14536279,18.4),(125214,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125214,37.42,0.46,305,56618,70,NULL,NULL,'2MASX J14560238+0008041',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.01,0.1345,0.153,NULL,58251128314,910173879,14221466,16.9),(125215,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125215,38.16,0.27,429,56619,70,NULL,NULL,'2MASX J14560243+0911427',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.010125,9.19533,0.045,NULL,59389850893,927966420,14499475,18.2),(125216,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125216,37.54,0.27,322,56620,70,NULL,NULL,'2MASX J14560260+3131539',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,224.0107083,31.53156,0.046,NULL,60090329935,938911405,14670490,16.6),(125217,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125217,37.54,0.27,322,56621,70,NULL,NULL,'2MASX J14560346+3130500',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.0145417,31.51392,0.046,NULL,60090331540,938911430,14670491,17.5),(125218,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125218,35.28,0.55,114,56622,NULL,NULL,'Malmquist cor.','ESO 448- G 008',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'13.29',0.4,'Sb             HII',NULL,NULL,NULL,NULL,1,224.0177083,-27.76797,0.625,NULL,47196036251,737438066,11522469,13.29),(125219,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125219,35.69,0.46,138,56622,NULL,NULL,NULL,'ESO 448- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125220,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125220,35.73,0.2,140,56622,74.4,NULL,NULL,'ESO 448- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125221,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125221,35.24,0.16,108,56623,74.2,NULL,'SALT 2','UGC 09612',0.036212,'2010ApJ...716..712A',2010,1,0.85,NULL,'G',0.000087,NULL,'14.7g',0.76,'SAB(s)c',NULL,NULL,NULL,NULL,1,224.0182083,45.40528,0.029,NULL,59995043343,937422552,14647227,14.7),(125222,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125222,35.79,0.09,144,56623,74.4,NULL,NULL,'UGC 09612',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125223,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125223,35.95,0.15,150,56623,70,NULL,'SALT 2','UGC 09612',0.036212,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125224,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125224,35.98,0.04,152,56623,72,NULL,'SALT2','UGC 09612',0.036212,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125225,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125225,36.07,0.18,158,56623,65,NULL,'SALT2','UGC 09612',0.036212,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125226,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125226,36.12,0.16,161,56623,65,NULL,'MLCS17','UGC 09612',0.036212,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125227,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125227,36.17,0.16,165,56623,65,NULL,'SALT','UGC 09612',0.036212,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125228,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2007O',NULL,125228,36.23,0.15,170,56623,65,NULL,'MLCS31','UGC 09612',0.036212,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125229,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125229,37.62,0.27,335,56624,70,NULL,NULL,'B3 1454+476',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000202,NULL,'16.1g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,224.020375,47.45344,0.037,NULL,59989145193,937330393,14645787,16.1),(125230,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125230,37.7,0.46,347,56625,70,NULL,NULL,'2MASX J14560580+2459189',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.16',0.17,NULL,NULL,NULL,NULL,NULL,1,224.024083,24.98875,0.093,NULL,59492101644,929564088,14524438,18.16),(125231,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125231,37.69,0.46,345,56626,70,NULL,NULL,'2MASX J14560686+0815107',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,224.0284583,8.25294,0.045,NULL,59389759675,927964994,14499453,17.2),(125232,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125232,37.51,0.46,318,56627,70,NULL,NULL,'2MASX J14560718+0850597',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.98',0.13,NULL,NULL,NULL,NULL,NULL,1,224.030083,8.85,0.053,NULL,59390269468,927972960,14499577,18.98),(125233,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125233,34.53,0.45,80.7,56628,NULL,NULL,'K','ESO 386- G 034',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'13.54',1,'SB(r)a: pec    Sy2?',NULL,NULL,NULL,NULL,1,224.035125,-37.64786,0.269,NULL,47234536805,738039637,11531869,13.54),(125234,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125234,34.54,0.47,81.1,56628,NULL,NULL,'H','ESO 386- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125235,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125235,34.62,0.46,84.1,56628,NULL,NULL,'J','ESO 386- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125236,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125236,35.08,0.4,104,56628,NULL,NULL,'mean','ESO 386- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125237,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125237,36.43,0.46,193,56629,70,NULL,NULL,'2MASX J14560842+0347171',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000102,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,224.035167,3.78822,0.145,NULL,59338683877,927166935,14486983,16.4),(125238,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125238,38.08,0.46,412,56630,70,NULL,NULL,'2MASX J14560937+3924437',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.03925,39.41208,0.045,NULL,60071685203,938620081,14665938,18),(125239,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125239,36.36,0.33,187,56631,70,NULL,NULL,'2MASX J14561021+2159328',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.72',0.3,NULL,NULL,NULL,NULL,NULL,1,224.042667,21.99233,0.065,NULL,59540843612,930325681,14536338,16.72),(125240,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125240,37.54,0.27,322,56632,70,NULL,NULL,'SDSS J145610.72+313035.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.044708333,31.50986,0.046,NULL,60090331822,938911434,14670491,18.4),(125241,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125241,37.5,0.46,316,56633,70,NULL,NULL,'2MASX J14561092+5008596',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.045417,50.15003,0.009,NULL,59944338468,936630288,14634848,17),(125242,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125242,38.48,0.46,497,56634,70,NULL,NULL,'2MASX J14561195+2153309',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.58',0.15,NULL,NULL,NULL,NULL,NULL,1,224.0497083,21.89186,0.069,NULL,59540892471,930326444,14536350,18.58),(125243,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125243,38.16,0.27,429,56635,70,NULL,NULL,'2MASX J14561250+0917328',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.80',0.16,NULL,NULL,NULL,NULL,NULL,1,224.052166667,9.29247,0.037,NULL,59376024988,927750390,14496099,18.8),(125244,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125244,35.29,0.33,114,56636,70,NULL,NULL,'2MASX J14561256+0924188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,224.0522083,9.40522,0.033,NULL,59376018292,927750285,14496098,16.2),(125245,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125245,37.16,0.33,270,56637,70,NULL,NULL,'2MASX J14561284+0303041',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000088,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.053583333,3.05119,0.173,NULL,59326936104,926983376,14484115,16.6),(125246,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125246,37.43,0.33,306,56638,70,NULL,NULL,'2MASX J14561312+3525310',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.054583,35.42539,0,NULL,60125730178,939464534,14679133,17.5),(125247,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125247,37.43,0.33,306,56639,70,NULL,NULL,'2MASX J14561369+3529370',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,224.057083,35.49369,0,NULL,60125681222,939463769,14679121,16.8),(125248,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125248,36.42,0.33,192,56640,70,NULL,NULL,'CGCG 134-057',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000157,NULL,'15.3',0.32,NULL,NULL,NULL,NULL,NULL,1,224.0675,20.52239,0.061,NULL,59541612571,930337696,14536526,15.3),(125249,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125249,37.25,0.46,282,56641,70,NULL,NULL,'2MASX J14561668+4654585',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,224.069625,46.91628,0.029,NULL,59989220681,937331573,14645805,16.7),(125250,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125250,35.21,0.46,110,56642,70,NULL,NULL,'MCG -06-33-005',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000097,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,224.0710417,-37.73283,0.269,NULL,47234519367,738039365,11531865,15),(125251,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125251,36.12,0.46,167,56643,70,NULL,NULL,'2MASX J14561732+2444511',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000067,NULL,'15.85',0.34,NULL,NULL,NULL,NULL,NULL,1,224.072417,24.74744,0.097,NULL,59492877518,929576211,14524628,15.85),(125252,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125252,37.16,0.33,270,56644,70,NULL,NULL,'2MASX J14561771+0259521',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.073791667,2.99775,0.173,NULL,59326935396,926983365,14484115,16.8),(125253,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125253,37.77,0.46,357,56645,70,NULL,NULL,'2MASX J14561771+0130461',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.073833333,1.51264,0.145,NULL,59324770184,926949534,14483586,17.8),(125254,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125254,37.21,0.46,277,56646,70,NULL,NULL,'2MASX J14561832+0847030',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.56',0.18,NULL,NULL,NULL,NULL,NULL,1,224.07625,8.78425,0.073,NULL,59390277071,927973079,14499579,18.56),(125255,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125255,37.22,0.46,279,56647,70,NULL,NULL,'2MASX J14561853+2102079',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.15',0.17,NULL,NULL,NULL,NULL,NULL,1,224.077333,21.03556,0.049,NULL,59540621030,930322203,14536284,18.15),(125256,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125256,37.52,0.33,319,56648,70,NULL,NULL,'2MASXi J1456188+222259',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'16.5I',0.16,NULL,NULL,NULL,NULL,NULL,1,224.078667,22.38333,0.101,NULL,59527547141,930117924,14533092,16.5),(125257,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125257,37.52,0.33,319,56649,70,NULL,NULL,'2MASX J14562084+2222469',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.56',0.17,NULL,NULL,NULL,NULL,NULL,1,224.086917,22.37975,0.101,NULL,59527038475,930109976,14532968,18.56),(125258,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125258,36.57,0.57,206,56650,70,NULL,NULL,'2MASX J14562221-1327302',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.39',0.4,NULL,NULL,NULL,NULL,NULL,1,224.092666667,-13.45858,0.337,NULL,46683358264,729427472,11397304,16.39),(125259,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125259,37.43,0.46,306,56651,70,NULL,NULL,'2MASX J14562273+3424169',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,224.0947083,34.40478,0.021,NULL,60126973203,939483956,14679436,17),(125260,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125260,38.16,0.46,428,56652,70,NULL,NULL,'2MASX J14562360+6201050',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.098,62.01814,0.017,NULL,57765374608,902583978,14102874,18.1),(125261,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125261,38.17,0.46,431,56653,70,NULL,NULL,'2MASX J14562434+5149587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.101375,51.83322,0.033,NULL,59929596959,936399952,14631249,18.1),(125262,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125262,32.04,0.47,25.6,56654,NULL,NULL,'H','ESO 386-IG 039',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000029,NULL,'13.16',1,'SB(s)c: pec',NULL,NULL,NULL,NULL,1,224.1055417,-37.60094,0.269,NULL,47234493015,738038953,11531858,13.16),(125263,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125263,32.1,0.46,26.2,56654,NULL,NULL,'J','ESO 386-IG 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125264,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125264,32.2,0.45,27.6,56654,NULL,NULL,'K','ESO 386-IG 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125265,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125265,32.72,0.4,35,56654,NULL,NULL,'mean','ESO 386-IG 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125266,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125266,37.76,0.46,356,56655,70,NULL,NULL,'2MASX J14562603+4749584',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.1085,47.83292,0.057,NULL,59933715706,936464307,14632254,17.3),(125267,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125267,38.27,0.46,451,56656,70,NULL,NULL,'2MASX J14562806+4843117',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.1170417,48.71994,0.021,NULL,59941443018,936585047,14634141,17.1),(125268,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125268,36.28,0.46,180,56657,70,NULL,NULL,'2MASX J14562917+3442149',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000168,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,224.1215417,34.70425,0.011,NULL,60129046999,939516359,14679943,16.1),(125269,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125269,37.62,0.33,335,56658,70,NULL,NULL,'2MASX J14562916+2604522',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,224.121625,26.08125,0.156,NULL,60013079310,937704364,14651630,18.43),(125270,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125270,37.47,0.46,312,56659,70,NULL,NULL,'2MASX J14563056+2533272',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.27',0.16,NULL,NULL,NULL,NULL,NULL,1,224.1274583,25.55753,0.155,NULL,60012281688,937691901,14651435,18.27),(125271,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125271,37.02,0.46,254,56660,70,NULL,NULL,'2MASX J14563225+4910527',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,224.134208333,49.18144,0.017,NULL,59941548786,936586699,14634167,16.2),(125272,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125272,38.11,0.46,418,56661,70,NULL,NULL,'SDSS J145632.34+413104.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,224.13475,41.51786,0,NULL,59979175653,937174619,14643353,18.7),(125273,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125273,38.29,0.46,455,56662,70,NULL,NULL,'2MASX J14563299+1438283',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.38',0.18,NULL,NULL,NULL,NULL,NULL,1,224.137375,14.64111,0.069,NULL,59578382089,930912220,14545503,18.38),(125274,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125274,34.26,0.2,71.1,56663,74.4,NULL,NULL,'ESO 513- G 009',NULL,'2013AJ....146...86T',2013,1,NULL,'Monnier-Ragaigne et al. (2003A&A...408..465M) also give v = 8563+/-14 km/sec.','GPair',0.000027,NULL,NULL,NULL,'Sc',NULL,NULL,NULL,NULL,1,224.140583,-24.50272,0.509,NULL,46524198299,726940598,11358446,NULL),(125275,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125275,34.35,0.57,74.1,56663,NULL,NULL,NULL,'ESO 513- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125276,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125276,34.46,0.54,77.9,56663,NULL,NULL,'Malmquist cor.','ESO 513- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125277,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125277,35.29,0.33,114,56664,70,NULL,NULL,'IC 1079',NULL,'2015arXiv151105856S',2015,1,1.7,NULL,'G',0.000097,NULL,'13.90',1,'E','Group member',NULL,NULL,NULL,1,224.150667,9.36975,0.033,NULL,59376071317,927751114,14496111,13.9),(125278,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125278,38.11,0.46,419,56665,70,NULL,NULL,'2MASX J14563653+0919551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.15225,9.33189,0.033,NULL,59376069205,927751081,14496110,17.7),(125279,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125279,37.16,0.46,270,56666,70,NULL,NULL,'2MASX J14563855+2501296',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.160666667,25.02481,0.113,NULL,59492095831,929563997,14524437,17),(125280,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125280,31.72,0.69,22.1,56667,100,NULL,'mid-IR','MCG -03-38-029',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',0.000017,NULL,'15.09',0.25,'HII',NULL,NULL,NULL,NULL,1,224.1609583,-16.48786,0.429,NULL,46706059836,729782184,11402846,15.09),(125281,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125281,38.15,0.46,428,56668,70,NULL,NULL,'SDSS J145638.70+165051.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.1612917,16.84764,0.029,NULL,59592167067,931127610,14548868,18.3),(125282,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125282,37.78,0.46,359,56669,70,NULL,NULL,'2MASX J14563882+3230306',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.161833,32.50844,0.013,NULL,60089811137,938903299,14670364,17.2),(125283,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125283,38.23,0.46,443,56670,70,NULL,NULL,'2MASX J14563933+0008376',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000097,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.163833,0.14364,0.141,NULL,58251088225,910173253,14221457,17.9),(125284,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125284,32.37,0.4,29.8,56671,NULL,NULL,'mean','NGC 5781',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00001,NULL,'13.82',0.8,'(R\')SBb pec sp',NULL,NULL,NULL,NULL,1,224.17175,-17.24394,0.433,NULL,46704153323,729752395,11402381,13.82),(125285,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125285,32.54,0.45,32.2,56671,NULL,NULL,'K','NGC 5781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125286,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125286,32.57,0.47,32.6,56671,NULL,NULL,'H','NGC 5781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125287,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125287,32.59,0.46,32.9,56671,NULL,NULL,'J','NGC 5781',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125288,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125288,37.79,0.46,362,56672,70,NULL,NULL,'SDSS J145641.56+011616.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.1732083,1.27131,0.137,NULL,59324792390,926949881,14483591,17.8),(125289,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125289,37.3,0.08,288,56673,72,NULL,'M(H) = -18.317 mag','2MASX J14564322+0919361',NULL,'2014ApJ...784..105W',2013,1,0.28,NULL,'G',NULL,NULL,'18.05',0.22,NULL,NULL,NULL,NULL,NULL,1,224.1800417,9.32678,0.033,NULL,59376069675,927751088,14496110,18.05),(125290,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125290,37.57,0.02,302,56673,70,NULL,NULL,'2MASX J14564322+0919361',0.07937,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125291,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag','R',125291,37.41,0.05,303,56673,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J14564322+0919361',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125292,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag','R',125292,37.44,0.04,308,56673,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J14564322+0919361',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125293,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125293,37.62,0.08,310,56673,72,NULL,NULL,'2MASX J14564322+0919361',0.07937,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125294,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125294,37.8,0.37,311,56673,72,NULL,NULL,'2MASX J14564322+0919361',0.0804,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125295,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125295,37.64,0.12,313,56673,72,NULL,'z lit','2MASX J14564322+0919361',0.07937,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125296,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125296,37.67,0.14,317,56673,70,NULL,'SALT 2','2MASX J14564322+0919361',0.07937,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125297,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125297,37.54,0.01,322,56673,72,NULL,'z lit','2MASX J14564322+0919361',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125298,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125298,37.71,0.13,323,56673,73.8,NULL,'SALT 2 (SNANA)','2MASX J14564322+0919361',0.0801,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125299,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005ag',NULL,125299,37.56,0.1,325,56673,74.4,NULL,NULL,'2MASX J14564322+0919361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125300,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125300,36.5,0.46,200,56674,70,NULL,NULL,'UGC 09613 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00013,NULL,'16.69',0.3,'S',NULL,NULL,NULL,NULL,1,224.180125,5.59292,0.061,NULL,59335603182,927118799,14486231,16.69),(125301,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125301,37.66,0.46,341,56675,70,NULL,NULL,'2MASX J14564495+1007409',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.03',0.15,NULL,NULL,NULL,NULL,NULL,1,224.1874583,10.12797,0.033,NULL,59376333469,927755210,14496175,19.03),(125302,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125302,35.5,0.2,126,56676,74.4,NULL,NULL,'UGC 09613',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00018,NULL,'15.07',0.5,NULL,NULL,NULL,NULL,NULL,1,224.191333333,5.58378,0.061,NULL,59335603111,927118798,14486231,15.07),(125303,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125303,38,0.46,397,56677,70,NULL,NULL,'2MASX J14564686+3358567',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.1952917,33.98236,0.016,NULL,60127026908,939484795,14679449,17.8),(125304,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125304,37.67,0.46,341,56678,70,NULL,NULL,'2MASX J14564687+5002236',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000152,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.195417,50.03997,0.009,NULL,59944348596,936630446,14634850,16.9),(125305,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125305,37.71,0.46,349,56679,70,NULL,NULL,'SDSS J145647.54+215438.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.198083,21.91075,0.065,NULL,59540882592,930326290,14536348,18.5),(125306,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125306,38.24,0.46,446,56680,70,NULL,NULL,'2MASX J14564768+5304056',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.198708333,53.06839,0.005,NULL,59928713259,936386144,14631033,17.5),(125307,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125307,37.71,0.46,348,56681,70,NULL,NULL,'SDSS J145648.43+250237.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.201833333,25.04367,0.113,NULL,59492126011,929564468,14524444,17.4),(125308,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125308,37.84,0.27,369,56682,70,NULL,NULL,'2MASX J14564896+1103339',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.2039583,11.05947,0.025,NULL,59374876446,927732444,14495819,17.8),(125309,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125309,37.83,0.46,369,56683,70,NULL,NULL,'SDSS J145649.21+290930.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.205083,29.15836,0.04,NULL,60093256054,938957125,14671205,18),(125310,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125310,36.49,0.33,199,56684,70,NULL,NULL,'2MASX J14565083+0849530',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.85',0.23,NULL,NULL,NULL,NULL,NULL,1,224.211875,8.83144,0.073,NULL,59389936594,927967759,14499496,16.85),(125311,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125311,34.59,0.46,82.9,56685,70,NULL,NULL,'UGC 09623',NULL,'2015arXiv151105856S',2015,1,1.14,NULL,'G',0.000103,NULL,'14.1g',0.73,'S0',NULL,NULL,NULL,NULL,1,224.2144583,38.75647,0.045,NULL,60117469403,939335459,14677116,14.1),(125312,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125312,37.84,0.27,369,56686,70,NULL,NULL,'2MASX J14565215+1103530',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.217417,11.06472,0.025,NULL,59374876507,927732445,14495819,17.3),(125313,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125313,38.04,0.46,406,56687,70,NULL,NULL,'SDSS J145652.56+062024.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.2190417,6.34014,0.089,NULL,59379985300,927812270,14497066,18),(125314,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125314,38.39,0.33,476,56688,70,NULL,NULL,'SDSS J145652.62+322658.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000188,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,224.2192917,32.44956,0.013,NULL,60089901585,938904712,14670386,18.5),(125315,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125315,32.59,0.48,32.9,56689,70,NULL,NULL,'ESO 386- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14',0.8,'S0:',NULL,NULL,NULL,NULL,1,224.2290417,-35.94486,0.245,NULL,47242899502,738170304,11533911,14),(125316,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125316,38.16,0.46,429,56690,70,NULL,NULL,'2MASX J14565606+3443267',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.233625,34.72422,0.011,NULL,60129035336,939516177,14679940,17.2),(125317,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125317,38.31,0.46,459,56691,70,NULL,NULL,'2MASX J14565700+3411127',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.2374583,34.18694,0.016,NULL,60127158157,939486846,14679481,17),(125318,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125318,35.1,0.2,105,56692,74.4,NULL,NULL,'CGCG 164-044',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00007,NULL,'15.6g',0.46,NULL,NULL,NULL,NULL,NULL,1,224.2399583,31.48956,0.035,NULL,60092213548,938940836,14670950,15.6),(125319,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125319,34.12,0.46,66.8,56693,70,NULL,NULL,'CGCG 020-035',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000117,NULL,'15.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,224.2457083,-2.11444,0.213,NULL,46441096749,725642136,11338158,15),(125320,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125320,34.5,0.64,79.6,56693,70,NULL,NULL,'CGCG 020-035',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125321,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125321,36.49,0.33,199,56694,70,NULL,NULL,'2MASX J14565906+0851210',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,224.246083333,8.85569,0.073,NULL,59389971970,927968312,14499504,17.2),(125322,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125322,37.19,0.46,274,56695,70,NULL,NULL,'2MASX J14565921+4509423',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.246875,45.16186,0.029,NULL,59994928508,937420757,14647199,17.4),(125323,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125323,38.39,0.33,476,56696,70,NULL,NULL,'SDSS J145659.56+322713.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.248166667,32.45372,0.013,NULL,60089949847,938905466,14670397,18.5),(125324,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125324,32.98,0.4,39.5,56697,75,NULL,'Edat, raw','ESO 386- G 041',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00015,NULL,'13.87',1,'S?',NULL,NULL,NULL,NULL,1,224.251583,-35.88483,0.245,NULL,47242929494,738170773,11533918,13.87),(125325,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125325,33.32,0.4,46.1,56697,75,NULL,'Edat, cor','ESO 386- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125326,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125326,36.42,0.33,192,56698,70,NULL,NULL,'2MASX J14570117+2032365',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,224.255,20.5435,0.069,NULL,59541574998,930337109,14536517,16.4),(125327,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125327,36.51,0.46,200,56699,70,NULL,NULL,'2MASX J14570224+3533027',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000117,NULL,'15.6g',0.4,'E0',NULL,NULL,NULL,NULL,1,224.259333,35.55064,0,NULL,60125679235,939463738,14679120,15.6),(125328,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125328,36.5,0.46,200,56700,70,NULL,NULL,'2MASX J14570243+2441086',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.90',0.25,NULL,NULL,NULL,NULL,NULL,1,224.260167,24.68569,0.117,NULL,59492176527,929565258,14524457,16.9),(125329,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125329,37.96,0.46,391,56701,70,NULL,NULL,'2MASX J14570291+0809030',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000159,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,224.2620417,8.15072,0.045,NULL,59390707854,927979810,14499684,16.8),(125330,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125330,37.27,0.46,284,56702,70,NULL,NULL,'SDSS J145704.32+294740.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.28',0.15,NULL,NULL,NULL,NULL,NULL,1,224.2680417,29.79469,0.051,NULL,60093637863,938963091,14671298,18.28),(125331,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125331,35.54,NULL,128,56703,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1832',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000009,NULL,'16.8',0.09,'Scd',NULL,NULL,NULL,NULL,1,224.273417,9.54606,0.037,NULL,59376090050,927751407,14496115,16.8),(125332,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125332,35.56,NULL,130,56703,NULL,NULL,'Dipole + Quadrupole','FGC 1832',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125333,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125333,35.58,NULL,130,56703,NULL,NULL,'Dipole','FGC 1832',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125334,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125334,36.33,0.2,185,56703,74.4,NULL,NULL,'FGC 1832',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125335,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125335,37.77,0.46,358,56704,70,NULL,NULL,'2MASX J14570652-0059499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000098,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,224.277167,-0.99725,0.193,NULL,43487174084,679487095,10616985,17),(125336,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125336,35.31,0.47,116,56705,NULL,NULL,'H','ESO 448- G 009',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'15',0.7,'Sb-c           HII',NULL,NULL,NULL,NULL,1,224.277833333,-31.80358,0.537,NULL,47200472630,737507384,11523552,15),(125337,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125337,35.37,0.45,118,56705,NULL,NULL,'K','ESO 448- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125338,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125338,35.44,0.46,122,56705,NULL,NULL,'J','ESO 448- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125339,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125339,35.53,0.5,128,56705,NULL,NULL,'Malmquist cor.','ESO 448- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125340,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125340,35.54,0.4,128,56705,NULL,NULL,'mean','ESO 448- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125341,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125341,35.85,0.43,148,56705,NULL,NULL,NULL,'ESO 448- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125342,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125342,35.89,0.2,151,56705,74.4,NULL,NULL,'ESO 448- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125343,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125343,38.02,0.46,401,56706,70,NULL,NULL,'2MASX J14570909+3315201',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000179,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.28775,33.25564,0.02,NULL,60122291925,939410811,14678293,17.6),(125344,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125344,32.13,0.46,26.7,56707,NULL,NULL,'J','ESO 176- G 006',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000021,NULL,'15.6',0.4,'S',NULL,NULL,NULL,NULL,1,224.2917917,-54.39214,NULL,NULL,46775120779,730861262,11419707,15.6),(125345,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125345,32.21,0.47,27.7,56707,NULL,NULL,'H','ESO 176- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125346,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125346,32.36,0.45,29.7,56707,NULL,NULL,'K','ESO 176- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125347,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125347,32.78,0.4,36,56707,NULL,NULL,'mean','ESO 176- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125348,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125348,34.56,0.49,81.8,56708,75,NULL,'IR','CGCG 105-080',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000009,NULL,'15.7',0.1,NULL,NULL,NULL,NULL,NULL,1,224.294667,17.18778,0.037,NULL,59592194268,931128035,14548875,15.7),(125349,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125349,34.34,0.2,73.8,56709,74.4,NULL,NULL,'CGCG 105-080',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000009,NULL,'15.7',0.1,NULL,NULL,NULL,NULL,NULL,1,224.294667,17.18778,0.037,NULL,59592194268,931128035,14548875,15.7),(125350,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125350,38.37,0.33,472,56710,70,NULL,NULL,'SDSS J145711.71+235326.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.2987917,23.89072,0.105,NULL,59526043150,930094424,14532725,18.5),(125351,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125351,36.44,0.46,194,56711,70,NULL,NULL,'2MASX J14571313+1851391',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'17.15',0.6,'S0/E','Group member',NULL,NULL,NULL,1,224.304875,18.86086,0.053,NULL,59530966450,930171350,14533927,17.15),(125352,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125352,37.15,0.23,270,56712,70,NULL,NULL,'2MASX J14571344+1248136',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000113,NULL,'16.91',0.29,NULL,NULL,NULL,NULL,NULL,1,224.306,12.80364,0.049,NULL,59546632101,930416126,14537751,16.91),(125353,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125353,38.67,0.46,541,56713,70,NULL,NULL,'SDSS J145713.61+203226.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.30675,20.54061,0.069,NULL,59541576545,930337133,14536517,18.7),(125354,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125354,34.75,NULL,89.1,56714,NULL,NULL,NULL,'FGC 1838',NULL,'2000BSAO...50....5K',2000,1,0.73,NULL,'G',0.00003,NULL,'17.2g',0.13,'Sdm',NULL,NULL,NULL,NULL,1,224.316375,38.63453,0.037,NULL,60117455944,939335249,14677113,17.2),(125355,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125355,34.8,NULL,91.1,56714,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125356,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125356,34.8,NULL,91.4,56714,NULL,NULL,'Dipole + Quadrupole','FGC 1838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125357,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125357,34.82,NULL,92.1,56714,NULL,NULL,'Dipole','FGC 1838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125358,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125358,37.84,0.27,369,56715,70,NULL,NULL,'2MASX J14571590+1100317',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.3162917,11.00892,0.025,NULL,59375046745,927735105,14495861,17.6),(125359,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125359,34.36,0.48,74.3,56716,70,NULL,NULL,'2MASX J14571724-3727568',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000103,NULL,'12.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,224.321833333,-37.46578,0.261,NULL,47235268651,738051072,11532048,12.9),(125360,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125360,37.78,0.17,360,56717,70,NULL,NULL,'SDSS J145717.61+084303.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000159,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.323417,8.71761,0.073,NULL,59389943457,927967866,14499497,18.6),(125361,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125361,37.78,0.17,360,56718,70,NULL,NULL,'SDSS J145718.86+084614.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.328625,8.77061,0.073,NULL,59389948575,927967946,14499499,18.1),(125362,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125362,37.97,0.46,392,56719,70,NULL,NULL,'2MASXi J1457188+183233',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.3287083,18.54286,0.049,NULL,59586587541,931040430,14547506,17.8),(125363,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125363,37.81,0.46,365,56720,70,NULL,NULL,'SDSS J145719.09+004747.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.2g',0.15,'E+A',NULL,NULL,NULL,NULL,1,224.3295417,0.79647,0.133,NULL,58250898613,910170290,14221410,18.2),(125364,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125364,37.49,0.23,315,56721,70,NULL,NULL,'SDSS J145719.83+202612.0',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'18.96',0.07,NULL,NULL,NULL,NULL,NULL,1,224.332667,20.43669,0.061,NULL,59541572082,930337063,14536516,18.96),(125365,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125365,37.38,0.46,299,56722,70,NULL,NULL,'SDSS J145721.05+224816.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.33775,22.80453,0.089,NULL,59527401462,930115647,14533056,18.4),(125366,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125366,34.3,0.4,72.5,56723,NULL,NULL,'mean','UGC 09622',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.07',0.8,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,224.338833,19.67294,0.053,NULL,59531201684,930175026,14533984,14.07),(125367,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125367,34.75,0.46,89.2,56723,NULL,NULL,'J','UGC 09622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125368,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125368,34.8,0.45,91.4,56723,NULL,NULL,'K','UGC 09622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125369,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125369,34.81,0.47,91.4,56723,NULL,NULL,'H','UGC 09622',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125370,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125370,38.67,0.46,541,56724,70,NULL,NULL,'2MASX J14572302+2653525',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.16',0.14,NULL,NULL,NULL,NULL,NULL,1,224.345917,26.898,0.141,NULL,60079953884,938749279,14667957,17.16),(125371,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125371,37.19,0.46,274,56725,70,NULL,NULL,'2MASXi J1457231+523408',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.3465,52.56906,0.013,NULL,59932097630,936439025,14631859,17.7),(125372,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125372,37.15,0.23,270,56726,70,NULL,NULL,'2MASX J14572380+1248217',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,224.349125,12.80619,0.049,NULL,59546628627,930416072,14537751,17.9),(125373,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125373,36.71,0.46,220,56727,70,NULL,NULL,'2MASX J14572473+3109502',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.3530417,31.16397,0.031,NULL,60092317602,938942462,14670975,17.4),(125374,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125374,38.37,0.33,472,56728,70,NULL,NULL,'SDSS J145724.97+235926.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.354041667,23.99069,0.105,NULL,59526049058,930094516,14532726,18.6),(125375,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125375,36.53,0.46,202,56729,70,NULL,NULL,'2MASX J14572532+1935481',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000087,NULL,'16.09',0.4,NULL,NULL,NULL,NULL,NULL,1,224.355417,19.59667,0.061,NULL,59531726826,930183231,14534112,16.09),(125376,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125376,38.34,0.46,466,56730,70,NULL,NULL,'2MASX J14572531+2029191',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.72',0.13,NULL,NULL,NULL,NULL,NULL,1,224.355417,20.48875,0.069,NULL,59541571353,930337052,14536516,18.72),(125377,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125377,37.78,0.17,360,56731,70,NULL,NULL,'SDSS J145725.38+084528.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.3557917,8.75794,0.073,NULL,59389948037,927967938,14499499,17.9),(125378,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125378,37.35,0.46,296,56732,70,NULL,NULL,'2MASX J14572629+1103348',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000181,NULL,'18.71',0.18,NULL,NULL,NULL,NULL,NULL,1,224.359375,11.05978,0.029,NULL,59375048526,927735133,14495861,18.71),(125379,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125379,37.84,0.46,370,56733,70,NULL,NULL,'2MASX J14572700+3252102',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.362417,32.86958,0.016,NULL,60122430105,939412970,14678327,17.5),(125380,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125380,34.93,0.47,96.8,56734,70,NULL,NULL,'ESO 581- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.0001,NULL,'16',0.9,'(R_1)SB0^+',NULL,NULL,NULL,NULL,1,224.3635,-21.66542,0.373,NULL,46654762314,728980661,11390322,16),(125381,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125381,36.27,0.46,180,56735,70,NULL,NULL,'2MASX J14572735+1625197',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00011,NULL,'16.35',0.48,NULL,NULL,NULL,NULL,NULL,1,224.363875,16.42217,0.025,NULL,59590184953,931096639,14548384,16.35),(125382,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125382,37.86,0.23,373,56736,70,NULL,NULL,'2MASX J14572753+3229391',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.364625,32.49428,0.013,NULL,60089943084,938905360,14670396,18),(125383,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125383,37.86,0.23,373,56737,70,NULL,NULL,'2MASX J14572760+3220431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,224.365083,32.34544,0.014,NULL,60089954167,938905533,14670398,18.3),(125384,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125384,36.81,0.46,230,56738,70,NULL,NULL,'2MASX J14572770+2438545',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.44',0.34,NULL,NULL,NULL,NULL,NULL,1,224.3655417,24.64861,0.129,NULL,59492194145,929565533,14524461,16.44),(125385,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125385,36.52,0.46,201,56739,70,NULL,NULL,'2MASX J14572796+2116291',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.33',0.31,NULL,NULL,NULL,NULL,NULL,1,224.366583,21.27467,0.033,NULL,59541032690,930328635,14536384,16.33),(125386,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125386,36.01,0.46,159,56740,70,NULL,NULL,'2MASX J14572815+0550375',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.63',0.37,NULL,NULL,NULL,NULL,NULL,1,224.367417,5.84392,0.085,NULL,59334930539,927108289,14486067,16.63),(125387,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125387,36.39,0.27,190,56741,70,NULL,NULL,'CGCG 134-059',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.0001,NULL,'15.6',0.6,NULL,NULL,NULL,NULL,NULL,1,224.3685,21.94431,0.065,NULL,59540997206,930328081,14536376,15.6),(125388,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125388,37.75,0.46,355,56742,70,NULL,NULL,'SDSS J145728.45+390821.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.368583333,39.13942,0.005,NULL,60117362965,939333796,14677090,18.3),(125389,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125389,35.89,0.46,151,56743,70,NULL,NULL,'CGCG 248-033',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.0002,NULL,'14.5g',0.76,'E0',NULL,NULL,NULL,NULL,1,224.370958333,45.8455,0.017,NULL,59991504662,937367260,14646363,14.5),(125390,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125390,37.74,0.46,353,56744,70,NULL,NULL,'2MASX J14572942+3314301',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.3724583,33.24169,0.02,NULL,60122309237,939411081,14678298,17.9),(125391,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125391,37.49,0.23,315,56745,70,NULL,NULL,'2MASX J14572965+2028241',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.11',0.18,NULL,NULL,NULL,NULL,NULL,1,224.373583,20.47344,0.069,NULL,59541573160,930337080,14536516,18.11),(125392,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125392,33.57,0.8,51.7,56746,75,NULL,'MAT, I','ESO 581- G 004',NULL,'1997ApJS..109..333W',1997,1,2.65,NULL,'G',0.00002,NULL,'15.16',0.36,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,224.374417,-18.45331,0.397,NULL,46696443257,729631925,11400498,15.16),(125393,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125393,32.9,NULL,37.9,56746,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 581- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125394,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125394,32.9,NULL,38,56746,NULL,NULL,'Dipole','ESO 581- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125395,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125395,32.9,NULL,38.1,56746,NULL,NULL,'Dipole + Quadrupole','ESO 581- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125396,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125396,33.05,NULL,40.7,56746,NULL,NULL,NULL,'ESO 581- G 004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125397,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125397,33.33,0.32,46.4,56746,85,NULL,'I, raw','ESO 581- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125398,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125398,33.34,0.32,46.5,56746,85,NULL,'I, inv','ESO 581- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125399,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125399,33.37,0.44,47.2,56746,NULL,NULL,'Malmquist cor.','ESO 581- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125400,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125400,33.45,0.43,48.9,56746,75,NULL,'MAT, I, raw','ESO 581- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125401,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125401,33.53,0.43,50.8,56746,75,NULL,'MAT, I, inv','ESO 581- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125402,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125402,33.56,0.2,51.5,56746,74.4,NULL,NULL,'ESO 581- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125403,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125403,33.6,0.43,52.4,56746,75,NULL,'MAT, I, cor','ESO 581- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125404,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125404,33.71,0.37,55.2,56746,NULL,NULL,NULL,'ESO 581- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125405,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125405,33.72,0.49,55.4,56746,75,NULL,'IR','ESO 581- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125406,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125406,37.78,0.17,360,56747,70,NULL,NULL,'2MASX J14572988+0846538',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.50',0.21,NULL,NULL,NULL,NULL,NULL,1,224.374625,8.78167,0.073,NULL,59389946692,927967917,14499498,18.5),(125407,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125407,37.12,0.46,265,56748,70,NULL,NULL,'2MASX J14572990+0542055',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.374667,5.70144,0.085,NULL,59334896286,927107754,14486058,16.9),(125408,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125408,37.97,0.46,393,56749,70,NULL,NULL,'2MASX J14573034+1310087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.3765,13.16914,0.089,NULL,59546930635,930420791,14537824,17.9),(125409,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125409,37.86,0.23,373,56750,70,NULL,NULL,'2MASX J14573037+3225471',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,224.3767083,32.42961,0.013,NULL,60089957591,938905587,14670399,18.2),(125410,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125410,35.22,0.46,110,56751,70,NULL,NULL,'CGCG 076-111',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000147,NULL,'15.0g',0.45,NULL,NULL,NULL,NULL,NULL,1,224.378875,8.39067,0.065,NULL,59389577383,927962146,14499408,15),(125411,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125411,37.55,0.46,324,56752,70,NULL,NULL,'2MASX J14573100+0459315',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,224.379125,4.99208,0.113,NULL,59337234718,927144292,14486629,16.6),(125412,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125412,38.18,0.46,433,56753,70,NULL,NULL,'SDSS J145731.76+012555.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.382333333,1.43211,0.153,NULL,59324802111,926950032,14483594,18.3),(125413,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125413,37.86,0.23,373,56754,70,NULL,NULL,'2MASX J14573180+3227341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.6g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,224.382375,32.45953,0.013,NULL,60089943452,938905366,14670396,17.6),(125414,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125414,37.78,0.17,360,56755,70,NULL,NULL,'SDSS J145732.53+084714.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.385583333,8.78747,0.073,NULL,59389946875,927967919,14499498,18.1),(125415,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125415,37.15,0.23,270,56756,70,NULL,NULL,'2MASX J14573310+1251317',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.75',0.13,NULL,NULL,NULL,NULL,NULL,1,224.388041667,12.85903,0.049,NULL,59546662035,930416594,14537759,18.75),(125416,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125416,36.12,NULL,168,56757,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1836',NULL,'2010Ap&SS.325..163P',2010,1,1.25,NULL,'G',0.000029,NULL,'16.7g',0.12,'Sc',NULL,NULL,NULL,NULL,1,224.3885,7.21244,0.065,NULL,59387783189,927934112,14498970,16.7),(125417,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125417,36.15,NULL,169,56757,NULL,NULL,'Dipole + Quadrupole','FGC 1836',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125418,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125418,36.15,NULL,170,56757,NULL,NULL,NULL,'FGC 1836',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125419,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125419,36.17,NULL,171,56757,NULL,NULL,'Dipole','FGC 1836',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125420,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125420,37.15,0.23,270,56758,70,NULL,NULL,'2MASX J14573646+1234258',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.402083,12.57392,0.037,NULL,59546789236,930418581,14537790,17.3),(125421,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125421,38.33,0.46,463,56759,70,NULL,NULL,'2MASX J14573643+6125276',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.402125,61.42444,0.025,NULL,57779372518,902802695,14106292,17.2),(125422,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125422,37.15,0.46,269,56760,70,NULL,NULL,'2MASX J14573674+2818205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.60',0.2,NULL,NULL,NULL,NULL,NULL,1,224.403167,28.30578,0.053,NULL,60082023241,938781613,14668462,17.6),(125423,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125423,38.32,0.46,462,56761,70,NULL,NULL,'2MASX J14573715+5215535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,224.404625,52.26494,0.033,NULL,59932267211,936441675,14631901,17.4),(125424,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125424,35.19,0.2,109,56762,74.4,NULL,NULL,'CGCG 076-112',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000153,NULL,'15.0',0.4,'Sa',NULL,NULL,NULL,NULL,1,224.407625,9.14617,0.065,NULL,59390002279,927968785,14499512,15),(125425,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125425,32.36,0.8,29.7,56763,75,NULL,'A82, H','NGC 5798',NULL,'1997ApJS..109..333W',1997,1,1.4,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'13.64',1,'Im:','Pair member, wide',NULL,NULL,'Emission-Line Galaxy',1,224.4082083,29.9685,0.05,NULL,60095791669,938996744,14671824,13.64),(125426,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125426,33.4,0.47,47.8,56763,75,NULL,'A82, H, inv','NGC 5798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125427,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125427,33.42,0.47,48.3,56763,75,NULL,'A82, H, raw','NGC 5798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125428,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125428,33.74,0.47,56,56763,75,NULL,'A82, H, cor','NGC 5798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125429,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125429,37.54,0.33,323,56764,70,NULL,NULL,'2MASX J14573867+2541275',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,224.411083,25.691,0.117,NULL,60012351697,937692995,14651453,18.3),(125430,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125430,36.66,0.46,215,56765,70,NULL,NULL,'2MASX J14573869+5511102',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,224.411167,55.18628,0,NULL,57713812151,901778314,14090286,16.7),(125431,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125431,37.49,0.23,315,56766,70,NULL,NULL,'2MASX J14573877+2029532',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.93',0.19,NULL,NULL,NULL,NULL,NULL,1,224.4114583,20.49817,0.069,NULL,59541786523,930340414,14536568,17.93),(125432,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125432,38.3,0.27,456,56767,70,NULL,NULL,'2MASX J14573943+5426002',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.414417,54.43344,0.009,NULL,59190237625,924847462,14450741,17.2),(125433,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125433,36.63,0.46,212,56768,70,NULL,NULL,'2MASX J14574054+0959458',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.66',0.25,NULL,NULL,NULL,NULL,NULL,1,224.418833333,9.99617,0.053,NULL,59376403305,927756301,14496192,16.66),(125434,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125434,37.95,0.17,389,56769,70,NULL,NULL,'2MASX J14574126+4713007',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,224.42175,47.217,0.057,NULL,59989260797,937332199,14645815,16.6),(125435,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125435,37.35,0.46,295,56770,70,NULL,NULL,'2MASX J14574369+1231518',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.432041667,12.53108,0.053,NULL,59546757368,930418083,14537782,16.7),(125436,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125436,37.49,0.23,315,56771,70,NULL,NULL,'SDSS J145743.78+203010.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.4324583,20.50303,0.069,NULL,59541786490,930340413,14536568,18.4),(125437,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125437,37.54,0.33,323,56772,70,NULL,NULL,'2MASX J14574450+2542037',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.34',0.16,NULL,NULL,NULL,NULL,NULL,1,224.4355,25.70114,0.117,NULL,60012335242,937692738,14651449,18.34),(125438,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125438,38.2,0.46,437,56773,70,NULL,NULL,'SDSS J145744.64+231203.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.4360417,23.20092,0.097,NULL,59529347683,930146057,14533532,18.3),(125439,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125439,34.58,0.49,82.4,56774,75,NULL,'IR','UGC 09625',NULL,'2011yCatp016004901K',2011,1,1.5,'UZC has V = 6459 km/sec.','G',0.000334,NULL,'14.44',0.5,'SBab:',NULL,NULL,NULL,NULL,1,224.4370417,6.62692,0.077,NULL,59379938809,927811543,14497055,14.44),(125440,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125440,34.59,0.47,83,56774,NULL,NULL,'H','UGC 09625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125441,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125441,34.68,0.46,86.2,56774,NULL,NULL,'J','UGC 09625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125442,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125442,34.69,0.45,86.7,56774,NULL,NULL,'K','UGC 09625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125443,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125443,34.78,0.4,90.4,56774,NULL,NULL,'mean','UGC 09625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125444,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125444,37.13,0.46,266,56775,70,NULL,NULL,'2MASX J14574501+2500437',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.63',0.22,NULL,NULL,NULL,NULL,NULL,1,224.437667,25.01225,0.113,NULL,59492255106,929566486,14524476,17.63),(125445,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125445,36.39,0.27,190,56776,70,NULL,NULL,'2MASX J14574559+2202312',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.49',0.21,NULL,NULL,NULL,NULL,NULL,1,224.4399583,22.04217,0.065,NULL,59526905968,930107905,14532936,17.49),(125446,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125446,29.9,0.43,9.5,56777,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5832',NULL,'2014MNRAS.444..527S',2014,1,3.7,NULL,'G',0.000004,NULL,'12.9',2.2,'SB(rs)b?','Isolated galaxy',NULL,NULL,NULL,1,224.4404583,71.68233,0.057,NULL,57918249419,904972647,14140197,12.9),(125447,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125447,30.3,0.4,11.5,56777,75,NULL,'B','NGC 5832',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125448,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125448,38.1,0.27,416,56778,70,NULL,NULL,'2MASX J14574649+2248022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.443625,22.80081,0.089,NULL,59528839633,930138119,14533408,18.1),(125449,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125449,36.03,0.46,161,56779,70,NULL,NULL,'2MASX J14574654+4004067',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000178,NULL,'15.5g',0.43,'E0',NULL,NULL,NULL,NULL,1,224.443917,40.06853,0.009,NULL,60071067902,938610435,14665788,15.5),(125450,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125450,35.44,0.45,122,56780,NULL,NULL,NULL,'ESO 273- G 013',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.29',0.7,'S...',NULL,NULL,NULL,NULL,1,224.445083,-44.14653,0.601,NULL,47108898974,736076546,11501196,14.29),(125451,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125451,35.48,0.2,125,56780,74.4,NULL,NULL,'ESO 273- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125452,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125452,35.59,0.42,131,56780,NULL,NULL,'Malmquist cor.','ESO 273- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125453,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125453,37.71,0.46,348,56781,70,NULL,NULL,'2MASX J14574754+5658302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.4480417,56.97508,0.009,NULL,57716302888,901817232,14090894,17.5),(125454,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125454,37.29,0.46,287,56782,70,NULL,NULL,'2MASX J14574780+2755218',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.70',0.2,NULL,NULL,NULL,NULL,NULL,1,224.449083,27.92264,0.073,NULL,60082762812,938793168,14668643,17.7),(125455,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125455,37.04,0.46,256,56783,70,NULL,NULL,'2MASX J14575082+2531098',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000127,NULL,'16.04',0.31,NULL,NULL,NULL,NULL,NULL,1,224.461667,25.5195,0.117,NULL,60012350700,937692979,14651452,16.04),(125456,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125456,38.3,0.46,457,56784,70,NULL,NULL,'2MASX J14575271+4846066',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.46975,48.76861,0.021,NULL,59941690294,936588910,14634201,18.3),(125457,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125457,36.39,0.27,190,56785,70,NULL,NULL,'2MASX J14575472+2141532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.89',0.16,NULL,NULL,NULL,NULL,NULL,1,224.4779583,21.69822,0.069,NULL,59540990370,930327974,14536374,17.89),(125458,'GRB','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125458,46.82,1.48,6440,56786,NULL,NULL,NULL,'GRB 080721',2.591,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,224.4827083,-11.72358,0.349,NULL,46460381908,725943467,11342866,NULL),(125459,'GRB','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125459,46.6,0.28,20900,56786,NULL,NULL,NULL,'GRB 080721',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125460,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125460,37.78,0.17,360,56787,70,NULL,NULL,'2MASX J14575622+0853341',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.48425,8.89281,0.073,NULL,59389993493,927968648,14499510,17.8),(125461,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125461,36.95,0.46,245,56788,70,NULL,NULL,'2MASX J14575645+4920396',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'15.8g',0.47,'E0',NULL,NULL,NULL,NULL,1,224.485125,49.34439,0.017,NULL,59941482195,936585659,14634150,15.8),(125462,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125462,38.39,0.46,476,56789,70,NULL,NULL,'2MASX J14575671+2349272',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.51',0.14,NULL,NULL,NULL,NULL,NULL,1,224.486375,23.82422,0.105,NULL,59526061790,930094715,14532729,18.51),(125463,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125463,37.78,0.17,360,56790,70,NULL,NULL,'SDSS J145757.60+085320.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.49,8.88914,0.073,NULL,59389993686,927968651,14499510,17.4),(125464,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125464,37.6,0.46,331,56791,70,NULL,NULL,'2MASX J14575772+2108332',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.08',0.17,NULL,NULL,NULL,NULL,NULL,1,224.490625,21.14253,0.061,NULL,59542209598,930347024,14536672,18.08),(125465,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125465,37.67,0.23,342,56792,70,NULL,NULL,'MCG +06-33-013',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00011,NULL,'15.6g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,224.4915,34.16308,0,NULL,60127126578,939486352,14679474,15.6),(125466,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125466,37.67,0.23,342,56793,70,NULL,NULL,'2MASX J14580098+3410116',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.504167,34.16994,0,NULL,60127130644,939486416,14679475,18.1),(125467,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125467,38.1,0.27,416,56794,70,NULL,NULL,'2MASX J14580139+2252102',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.97',0.16,NULL,NULL,NULL,NULL,NULL,1,224.505666667,22.86947,0.093,NULL,59529563322,930149426,14533584,17.97),(125468,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125468,38.89,0.46,601,56795,70,NULL,NULL,'LCRS B145526.4-024041',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000169,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.509833,-2.87767,0.237,NULL,46440863466,725638491,11338101,18.4),(125469,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125469,37.47,0.46,312,56796,70,NULL,NULL,'2MASX J14580237+0832532',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000161,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,224.509833,8.54811,0.073,NULL,59389904018,927967250,14499488,16.2),(125470,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125470,38.25,0.46,447,56797,70,NULL,NULL,'SDSS J145802.86+005637.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000084,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,224.511958333,0.94367,0.137,NULL,59324831383,926950490,14483601,18.4),(125471,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125471,33.16,0.8,42.9,56798,75,NULL,'MAT, I','ESO 581- G 006',NULL,'1997ApJS..109..333W',1997,1,1.74,NULL,'G',0.000033,NULL,'15.56',0.17,'SB(s)d pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,224.512875,-19.38975,0.341,NULL,46651338438,728927163,11389486,15.56),(125472,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125472,32.59,NULL,33,56798,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 581- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125473,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125473,32.6,NULL,33.2,56798,NULL,NULL,'Dipole + Quadrupole','ESO 581- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125474,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125474,32.62,NULL,33.4,56798,NULL,NULL,'Dipole','ESO 581- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125475,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125475,32.68,NULL,34.3,56798,NULL,NULL,NULL,'ESO 581- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125476,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125476,33.13,0.49,42.3,56798,NULL,NULL,'Malmquist cor.','ESO 581- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125477,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125477,33.35,0.44,46.7,56798,NULL,NULL,NULL,'ESO 581- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125478,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125478,33.38,0.32,47.4,56798,85,NULL,'I, inv','ESO 581- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125479,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125479,33.38,0.32,47.5,56798,85,NULL,'I, raw','ESO 581- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125480,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125480,33.39,0.2,47.6,56798,74.4,NULL,NULL,'ESO 581- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125481,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125481,33.56,0.43,51.5,56798,75,NULL,'MAT, I, raw','ESO 581- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125482,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125482,33.59,0.43,52.3,56798,75,NULL,'MAT, I, inv','ESO 581- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125483,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125483,33.72,0.43,55.4,56798,75,NULL,'MAT, I, cor','ESO 581- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125484,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125484,37.67,0.23,342,56799,70,NULL,NULL,'2MASX J14580364+3411306',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.515083333,34.19172,0.009,NULL,60127131579,939486430,14679475,17.4),(125485,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125485,38.1,0.46,417,56800,70,NULL,NULL,'SDSS J145803.78+120937.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000127,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.5157917,12.16044,0.045,NULL,59366419925,927600311,14493754,18.4),(125486,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125486,37.67,0.23,342,56801,70,NULL,NULL,'2MASX J14580460+3407206',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,224.519167,34.12233,0.009,NULL,60127017801,939484653,14679447,16.5),(125487,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125487,37.69,0.27,345,56802,70,NULL,NULL,'2MASX J14580469+0545527',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.519583,5.76453,0.081,NULL,59334946526,927108539,14486070,17.2),(125488,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125488,37.95,0.17,389,56803,70,NULL,NULL,'2MASX J14580475+4724238',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000246,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,224.519667,47.40664,0.057,NULL,59989084924,937329451,14645772,16.5),(125489,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125489,37.95,0.17,389,56804,70,NULL,NULL,'SDSS J145805.12+472517.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.521333,47.42153,0.057,NULL,59989084738,937329449,14645772,18.6),(125490,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125490,38.3,0.27,456,56805,70,NULL,NULL,'2MASX J14580624+5423321',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.5257083,54.39222,0.009,NULL,59190053616,924844587,14450696,17.7),(125491,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125491,36.19,0.46,173,56806,70,NULL,NULL,'2MASX J14580620+0130207',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000113,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,224.526,1.50572,0.153,NULL,59324911568,926951743,14483620,15.6),(125492,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125492,36.85,0.27,234,56807,70,NULL,NULL,'2MASX J14580675+0841192',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000126,NULL,'16.99',0.19,NULL,NULL,NULL,NULL,NULL,1,224.5282083,8.68856,0.073,NULL,59389964082,927968188,14499502,16.99),(125493,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125493,38.43,0.46,485,56808,70,NULL,NULL,'2MASX J14580762+1556379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.531875,15.94375,0.037,NULL,59590024209,931094128,14548345,17.8),(125494,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125494,31.58,NULL,20.7,56809,72,NULL,NULL,'SDSS J145808.78+064447.4',NULL,'2014Ap.....57..457K',2014,1,0.3,NULL,'G',0.00005,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.536583,6.74653,0.081,NULL,59379887876,927810748,14497042,18.1),(125495,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125495,37.87,0.46,375,56810,70,NULL,NULL,'SDSS J145809.08+215755.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.537875,21.96536,0.065,NULL,59540798085,930324970,14536327,18.4),(125496,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125496,32.63,0.4,33.6,56811,NULL,NULL,NULL,'UGC 09638',NULL,'2009AJ....138..323T',2009,1,0.84,NULL,'G',0.000023,NULL,'15.5g',0.63,'Im',NULL,NULL,NULL,NULL,1,224.5405,58.87181,0,NULL,57726336839,901974013,14093343,15.5),(125497,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125497,32.8,0.4,36.3,56811,75,NULL,'B','UGC 09638',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125498,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125498,38.12,0.46,421,56812,70,NULL,NULL,'SDSS J145809.80+201345.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.540875,20.22928,0.061,NULL,59538923620,930295681,14535870,18.4),(125499,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125499,37.9,0.46,380,56813,70,NULL,NULL,'2MASX J14581025+0247057',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000101,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.5427083,2.78481,0.173,NULL,59327075581,926985555,14484149,16.6),(125500,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125500,37.57,0.46,326,56814,70,NULL,NULL,'2MASX J14581067+0512157',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.544417,5.20422,0.109,NULL,59337223815,927144122,14486626,17.3),(125501,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125501,37.88,0.27,376,56815,70,NULL,NULL,'2MASXi J1458111+221955',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.546583,22.33211,0.077,NULL,59527113236,930111144,14532986,17.6),(125502,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125502,38.93,0.46,611,56816,70,NULL,NULL,'2MASX J14581191+1629569',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.5497917,16.49922,0.049,NULL,59592484268,931132566,14548946,17.8),(125503,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125503,37.17,0.46,272,56817,70,NULL,NULL,'2MASX J14581364+3242384',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.557,32.71064,0.017,NULL,60089722836,938901919,14670342,16.7),(125504,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125504,38.2,0.46,436,56818,70,NULL,NULL,'2MASX J14581558+2937409',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00027,NULL,'18.51',0.14,'E',NULL,NULL,NULL,NULL,1,224.564875,29.62806,0.039,NULL,60095095042,938985860,14671654,18.51),(125505,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125505,37.88,0.27,376,56819,70,NULL,NULL,'2MASX J14581606+2222160',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.20',0.17,'BrClG',NULL,NULL,NULL,NULL,1,224.567,22.37117,0.077,NULL,59527118793,930111231,14532987,18.2),(125506,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125506,37.14,0.46,267,56820,70,NULL,NULL,'2MASX J14581646+3149314',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,224.56875,31.82533,0.008,NULL,60091865739,938935402,14670865,17),(125507,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125507,37.88,0.27,376,56821,70,NULL,NULL,'2MASX J14581743+2223250',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.572833,22.39025,0.081,NULL,59527117468,930111210,14532987,18.3),(125508,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125508,36.99,0.46,250,56822,70,NULL,NULL,'2MASX J14581754+3310054',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.572958333,33.16814,0.014,NULL,60122434742,939413042,14678328,16.7),(125509,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125509,37.75,0.46,354,56823,70,NULL,NULL,'SDSS J145818.86+091159.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.578625,9.19978,0.065,NULL,59389801813,927965653,14499463,18.5),(125510,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125510,36.71,0.46,220,56824,70,NULL,NULL,'2MASX J14581906+0228397',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000093,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.579417,2.47772,0.149,NULL,59326992603,926984259,14484129,16.8),(125511,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125511,35.28,0.46,114,56825,70,NULL,NULL,'I Zw 099',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000182,NULL,'14.8g',0.69,'S0?',NULL,NULL,NULL,NULL,1,224.579833,53.2375,0.005,NULL,59928575725,936383995,14630999,14.8),(125512,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125512,38.43,0.46,485,56826,70,NULL,NULL,'2MASX J14581941+2315120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.04',0.14,NULL,NULL,NULL,NULL,NULL,1,224.5809583,23.25342,0.097,NULL,59529431215,930147362,14533552,18.04),(125513,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125513,34.54,0.47,81.1,56827,70,NULL,NULL,'ESO 386- G 043',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000017,NULL,'14.14',0.9,'SA(rs)bc:      HII',NULL,NULL,NULL,NULL,1,224.582416667,-37.55617,0.261,NULL,47236131736,738064558,11532258,14.14),(125514,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125514,35.08,0.8,104,56827,75,NULL,'MAT, I','ESO 386- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125515,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125515,34.93,0.43,96.9,56827,75,NULL,'MAT, I, raw','ESO 386- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125516,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125516,35.07,0.38,103,56827,NULL,NULL,'Malmquist cor.','ESO 386- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125517,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125517,35.12,0.32,106,56827,85,NULL,'I, raw','ESO 386- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125518,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125518,35.21,0.32,110,56827,85,NULL,'I, inv','ESO 386- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125519,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125519,35.25,0.43,112,56827,75,NULL,'MAT, I, cor','ESO 386- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125520,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125520,35.3,0.43,115,56827,75,NULL,'MAT, I, inv','ESO 386- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125521,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125521,35.32,0.34,116,56827,NULL,NULL,NULL,'ESO 386- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125522,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125522,35.36,0.2,118,56827,74.4,NULL,NULL,'ESO 386- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125523,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125523,37.95,0.17,389,56828,70,NULL,NULL,'2MASX J14582092+4733449',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.587,47.56242,0.057,NULL,59989057546,937329024,14645766,17.5),(125524,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125524,37.44,0.46,308,56829,70,NULL,NULL,'SDSS J145821.05+241213.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.58775,24.20386,0.121,NULL,59526504924,930101639,14532838,18.3),(125525,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125525,32.35,0.8,29.6,56830,75,NULL,'A82, H','NGC 5792',NULL,'1997ApJS..109..333W',1997,1,6.9,'Extended HIPASS source','G',0.000013,NULL,'12.08',1.7,'SB(rs)b        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,224.594625,-1.09108,0.157,NULL,46439776114,725621501,11337835,12.08),(125526,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125526,31.58,0.47,20.7,56830,75,NULL,'A82, H, raw','NGC 5792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125527,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125527,31.61,0.46,20.9,56830,NULL,NULL,'J','NGC 5792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125528,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125528,31.63,0.47,21.1,56830,NULL,NULL,'H','NGC 5792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125529,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125529,31.72,0.45,22.1,56830,NULL,NULL,'K','NGC 5792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125530,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125530,31.77,0.47,22.5,56830,75,NULL,'A82, H, inv','NGC 5792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125531,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125531,31.76,NULL,22.5,56830,72,NULL,NULL,'NGC 5792',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125532,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125532,31.93,0.47,24.4,56830,75,NULL,'A82, H, cor','NGC 5792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125533,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125533,32.05,0.43,25.8,56830,75,NULL,'3.6 micron, color corrected','NGC 5792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125534,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125534,32.09,0.43,26.2,56830,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125535,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125535,32.11,0.2,26.4,56830,74.4,NULL,NULL,'NGC 5792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125536,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125536,32.24,0.4,28.1,56830,NULL,NULL,'mean','NGC 5792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125537,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125537,32.43,0.4,30.6,56830,75,NULL,'B','NGC 5792',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125538,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125538,37.3,0.46,289,56831,70,NULL,NULL,'SDSS J145823.22+183344.7',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,224.5967917,18.56244,0.049,NULL,59586600401,931040631,14547509,16.8),(125539,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125539,38.06,0.46,409,56832,70,NULL,NULL,'2MASX J14582331+2727050',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.47',0.15,NULL,NULL,NULL,NULL,NULL,1,224.597041667,27.45144,0.081,NULL,60082824435,938794131,14668658,18.47),(125540,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125540,38.47,0.46,494,56833,70,NULL,NULL,'2MASXi J1458242+331203',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.601,33.20108,0.014,NULL,60122431805,939412996,14678328,17.7),(125541,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125541,37.95,0.17,389,56834,70,NULL,NULL,'SDSS J145825.42+471548.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.6059583,47.26356,0.057,NULL,59989082006,937329406,14645771,18.6),(125542,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125542,38.31,0.46,460,56835,70,NULL,NULL,'SDSS J145825.88+031509.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000118,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,224.607833,3.25253,0.149,NULL,59338178605,927159040,14486860,18.5),(125543,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125543,36.46,0.46,196,56836,70,NULL,NULL,'2MASX J14582603+0858290',NULL,'2015arXiv151105856S',2015,1,0.33,'Two MAPS entries for the same object.','G',NULL,NULL,'16.71',0.18,NULL,NULL,NULL,NULL,NULL,1,224.608625,8.97478,0.073,NULL,59389991683,927968620,14499509,16.71),(125544,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125544,36.74,0.46,222,56837,70,NULL,NULL,'2MASX J14582713+2515200',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.62',0.21,NULL,NULL,NULL,NULL,NULL,1,224.613083,25.25553,0.109,NULL,60012140882,937689701,14651401,17.62),(125545,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125545,35.51,0.33,126,56838,70,NULL,NULL,'CGCG 248-034',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000173,NULL,'14.9g',0.4,'E','Group member',NULL,NULL,NULL,1,224.615791667,48.49239,0.009,NULL,59941675587,936588681,14634198,14.9),(125546,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125546,37.95,0.17,389,56839,70,NULL,NULL,'2MASX J14582789+4721488',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.616083,47.36358,0.057,NULL,59989096521,937329633,14645775,17.1),(125547,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125547,38.1,0.27,416,56840,70,NULL,NULL,'2MASX J14582873+2252269',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.64',0.15,NULL,NULL,NULL,NULL,NULL,1,224.619875,22.87425,0.093,NULL,59529567313,930149489,14533585,18.64),(125548,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125548,36.34,0.46,185,56841,70,NULL,NULL,'2MASX J14582897+0324249',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000075,NULL,'16.4g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,224.620708333,3.40697,0.181,NULL,59338373657,927162088,14486907,16.4),(125549,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125549,36.88,0.55,237,56842,70,NULL,NULL,'2MASX J14582982-2320281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,224.624333,-23.34119,0.417,NULL,46644274181,728816784,11387762,15),(125550,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125550,35.3,0.4,115,56843,NULL,NULL,'mean','MCG -01-38-012',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.62',1.1,'SAB(s)c',NULL,NULL,NULL,NULL,1,224.625,-6.82064,0.261,NULL,46502327173,726598862,11353107,14.62),(125551,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125551,35.61,0.47,133,56843,NULL,NULL,'H','MCG -01-38-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125552,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125552,30.83,0.8,14.7,56844,75,NULL,NULL,'ESO 223- ?006',NULL,'1988NBGC.C....0000T',1988,1,3.8,'Two entries for this object in the ESO/Uppsala Catalogue.','G',0.00001,NULL,'12.9',2.8,'SB(s)m pec',NULL,NULL,NULL,NULL,1,224.6265417,-47.69894,NULL,NULL,47053861668,735216588,11487759,12.9),(125553,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125553,28.21,0.38,4.39,56844,NULL,NULL,NULL,'ESO 223- ?006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125554,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125554,29.98,0.4,9.9,56844,73,NULL,'opt','ESO 223- ?006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125555,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125555,29.98,NULL,9.91,56844,NULL,NULL,NULL,'ESO 223- ?006',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125556,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125556,38.19,0.33,434,56845,70,NULL,NULL,'SDSS J145831.42+030136.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000079,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.6309583,3.02692,0.149,NULL,59326883094,926982548,14484102,18.1),(125557,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125557,37.35,0.46,296,56846,70,NULL,NULL,'2MASX J14583166+2200529',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.13,NULL,NULL,NULL,NULL,NULL,1,224.6319583,22.01464,0.065,NULL,59540794974,930324921,14536326,18.68),(125558,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125558,37.95,0.17,389,56847,70,NULL,NULL,'2MASX J14583359+4729510',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00021,NULL,'15.6g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,224.64,47.49761,0.057,NULL,59989092639,937329572,14645774,15.6),(125559,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125559,38.27,0.46,450,56848,70,NULL,NULL,'2MASX J14583366+2740381',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.640125,27.67739,0.053,NULL,60083292242,938801441,14668772,18.2),(125560,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125560,37.08,0.46,261,56849,70,NULL,NULL,'2MASX J14583404+0530349',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.641875,5.50958,0.121,NULL,59336939217,927139675,14486557,17.1),(125561,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125561,37.13,0.46,267,56850,70,NULL,NULL,'2MASX J14583419+1852349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.70',0.23,NULL,NULL,NULL,NULL,NULL,1,224.642375,18.87639,0.061,NULL,59530845312,930169458,14533897,16.7),(125562,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125562,36.34,0.46,185,56851,70,NULL,NULL,'2MASX J14583419+4426370',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.6425417,44.4435,0.041,NULL,59994423778,937412871,14647076,16.9),(125563,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125563,38.19,0.33,434,56852,70,NULL,NULL,'2MASX J14583451+0258559',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.5g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,224.6437083,2.98222,0.173,NULL,59326886002,926982593,14484103,17.5),(125564,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125564,37.69,0.27,345,56853,70,NULL,NULL,'2MASX J14583451+0547269',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,224.64375,5.79078,0.081,NULL,59334937852,927108403,14486068,15.9),(125565,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125565,36.49,0.46,199,56854,70,NULL,NULL,'2MASX J14583482+2807031',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000334,NULL,'16.5',0.59,NULL,NULL,NULL,NULL,NULL,1,224.645167,28.11769,0.037,NULL,60082481442,938788772,14668574,16.5),(125566,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125566,36.25,0.46,177,56855,70,NULL,NULL,'2MASX J14583658+1245583',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.59',0.14,NULL,NULL,NULL,NULL,NULL,1,224.652583,12.76625,0.057,NULL,59546635726,930416183,14537752,18.59),(125567,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125567,37.23,0.46,279,56856,70,NULL,NULL,'2MASX J14583677+2035519',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.653083,20.59769,0.077,NULL,59541671002,930338609,14536540,16.8),(125568,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125568,38.12,0.46,420,56857,70,NULL,NULL,'LCRS B145601.1-022000',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.65325,-2.5325,0.217,NULL,46442638975,725666233,11338534,17.5),(125569,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125569,37.75,0.46,354,56858,70,NULL,NULL,'SDSS J145837.12+463840.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.654667,46.64461,0.021,NULL,59992085478,937376335,14646505,18.5),(125570,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125570,36.23,0.46,176,56859,70,NULL,NULL,'2MASX J14583727+3255384',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,224.655291667,32.92736,0.017,NULL,60122265000,939410390,14678287,16.5),(125571,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125571,32.19,NULL,27.4,56860,72,NULL,NULL,'KUG 1456+069',NULL,'2014Ap.....57..457K',2014,1,0.4,NULL,'G',0.000041,NULL,'15.4',0.3,'Spiral',NULL,NULL,NULL,NULL,1,224.6577083,6.77517,0.081,NULL,59387341630,927927212,14498862,15.4),(125572,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125572,37.07,0.46,259,56861,70,NULL,NULL,'2MASX J14583791+4736300',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.658167,47.60853,0.057,NULL,59933467280,936460426,14632194,17.2),(125573,'BCG','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125573,38.82,0.35,516,56862,60,NULL,'ABELL 2005, BCG','2MASX J14583892+2751041',0.1251,'1980ApJ...241..486H',1980,1,0.32,NULL,'G',NULL,NULL,'17.74',0.18,'BrClG','Brightest group member',NULL,NULL,NULL,1,224.6622083,27.85119,0.049,NULL,60083332509,938802070,14668782,17.74),(125574,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125574,32.09,0.37,26.2,56863,95,NULL,'Weighted Mean','NGC 5820',NULL,'1984ApJS...56...91D',1984,1,1.7,'Springob et al. (2005ApJS..160..149S) give v= 883 km/sec.','G',0.00003,NULL,'13.42',1.1,'S0','Possible field galaxy',NULL,NULL,NULL,1,224.665917,53.88608,0.025,NULL,59928308818,936379825,14630934,13.42),(125575,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125575,32.26,0.63,28.3,56863,95,NULL,'Michard 1979b, c','NGC 5820',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125576,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125576,32.59,0.46,33,56863,95,NULL,'Michard 1979a','NGC 5820',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125577,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125577,33.5,0.81,50.1,56863,55,NULL,'Visvanathan & Sandage 1979','NGC 5820',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125578,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125578,33.24,0.45,44.6,56863,NULL,NULL,'K','NGC 5820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125579,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125579,33.62,0.4,53,56863,NULL,NULL,'mean','NGC 5820',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125580,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125580,38.93,0.46,612,56864,70,NULL,NULL,'SDSS J145840.32+461330.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00018,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.668041667,46.22514,0.017,NULL,59992130343,937377036,14646516,18.6),(125581,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125581,36.84,0.46,233,56865,70,NULL,NULL,'2MASX J14584182+5324460',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.674333,53.41272,0.005,NULL,59929218662,936394041,14631156,17.5),(125582,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125582,36.61,0.46,210,56866,70,NULL,NULL,'2MASX J14584204+2643511',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.11',0.18,NULL,NULL,NULL,NULL,NULL,1,224.6750417,26.73072,0.109,NULL,60079901760,938748465,14667944,18.11),(125583,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125583,38.02,0.46,401,56867,70,NULL,NULL,'2MASX J14584251+3802273',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.6770417,38.04086,0.025,NULL,60120794882,939387420,14677928,17.4),(125584,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125584,37.98,0.27,395,56868,70,NULL,NULL,'2MASX J14584285+5340090',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.67825,53.66919,0.029,NULL,59929186022,936393531,14631148,17.4),(125585,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125585,38.15,0.46,427,56869,70,NULL,NULL,'2MASX J14584285+4038523',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000139,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.678667,40.64775,0,NULL,59949217204,936706518,14636039,17.5),(125586,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125586,36.92,0.46,242,56870,70,NULL,NULL,'2MASX J14584341+1340503',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.65',0.41,NULL,NULL,NULL,NULL,NULL,1,224.6809583,13.68061,0.029,NULL,59576596326,930884317,14545067,16.65),(125587,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125587,37.38,0.46,299,56871,70,NULL,NULL,'2MASX J14584391-0105486',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000113,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.683083333,-1.09675,0.157,NULL,46439761451,725621272,11337832,16.5),(125588,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125588,36.5,0.59,200,56872,70,NULL,NULL,'2MASX J14584396-2843233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,224.6832083,-28.72319,0.201,NULL,47195648168,737432002,11522375,15.5),(125589,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125589,38.12,0.46,420,56873,70,NULL,NULL,'SDSS J145844.72-021506.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.686375,-2.25181,0.217,NULL,46443339321,725677176,11338705,18.4),(125590,'BCG','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125590,38.82,0.35,516,56874,60,NULL,NULL,'ABELL 2005',0.1251,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,224.6875,27.81786,0.049,NULL,60083336203,938802128,14668783,NULL),(125591,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125591,31.75,NULL,22.4,56875,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09637',NULL,'2010Ap&SS.325..163P',2010,1,1.9,NULL,'G',0.000023,NULL,'16.0',0.27,'Sm',NULL,NULL,NULL,NULL,1,224.689083,41.76603,0,NULL,59979237215,937175581,14643368,16),(125592,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125592,31.76,NULL,22.5,56875,NULL,NULL,'Dipole + Quadrupole','UGC 09637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125593,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125593,31.77,NULL,22.6,56875,NULL,NULL,'Dipole','UGC 09637',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125594,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125594,32.75,0.4,35.5,56876,75,NULL,'Edat, raw','NGC 5791',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000037,NULL,'12.68',1.3,'E6:','in a pair',NULL,NULL,NULL,1,224.692583,-19.26686,0.341,NULL,46653342170,728958471,11389976,12.68),(125595,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125595,32.86,0.4,37.3,56876,75,NULL,'Edat, cor','NGC 5791',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125596,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125596,31.73,0.69,22.2,56876,95,NULL,'de Vaucouleurs','NGC 5791',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125597,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125597,32.34,0.47,29.4,56876,95,NULL,'Weighted Mean','NGC 5791',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125598,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125598,34.54,0.81,80.9,56876,55,NULL,'Visvanathan & Sandage 1979','NGC 5791',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125599,'Tertiary','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125599,32.08,0.35,26.1,56876,95,NULL,NULL,'NGC 5791',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125600,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125600,32.9,0.45,38,56876,NULL,NULL,'K','NGC 5791',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125601,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125601,33.35,0.4,46.7,56876,NULL,NULL,'mean','NGC 5791',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125602,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125602,36.97,0.46,247,56877,70,NULL,NULL,'2MASX J14584646+5344099',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,224.693666667,53.73619,0.025,NULL,59929178197,936393409,14631147,17.2),(125603,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125603,37.69,0.27,345,56878,70,NULL,NULL,'2MASX J14584765+0551469',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.698417,5.86297,0.077,NULL,59334768599,927105759,14486027,17.1),(125604,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125604,37.98,0.27,395,56879,70,NULL,NULL,'2MASX J14584953+5349119',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.70625,53.81975,0.025,NULL,59929172968,936393327,14631145,17.1),(125605,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125605,38.3,0.27,456,56880,70,NULL,NULL,'SDSS J145849.63+542807.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.706833,54.46883,0.009,NULL,59190055472,924844616,14450697,17.8),(125606,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125606,36.93,0.46,243,56881,70,NULL,NULL,'SDSS J145850.32+333756.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.709667,33.63236,0,NULL,60126564662,939477572,14679337,17.8),(125607,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125607,36.85,0.27,234,56882,70,NULL,NULL,'SDSS J145851.25+083101.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.713583,8.51714,0.049,NULL,59390422379,927975349,14499614,17.6),(125608,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125608,36.17,0.54,172,56883,70,NULL,NULL,'LCRS B145608.3-112826',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'16.47',NULL,NULL,NULL,NULL,NULL,NULL,1,224.714833333,-11.67283,0.333,NULL,46489858595,726404040,11350063,16.47),(125609,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125609,38.18,0.46,432,56884,70,NULL,NULL,'2MASX J14585306+1608452',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.75',0.13,NULL,NULL,NULL,NULL,NULL,1,224.7210417,16.146,0.045,NULL,59591783194,931121612,14548775,18.75),(125610,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125610,36.83,0.46,233,56885,70,NULL,NULL,'2MASX J14585351+2053584',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.10',0.17,NULL,NULL,NULL,NULL,NULL,1,224.722917,20.89975,0.041,NULL,59542228569,930347321,14536676,18.1),(125611,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125611,37.01,0.46,253,56886,70,NULL,NULL,'2MASX J14585406+2028054',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.45',0.16,NULL,NULL,NULL,NULL,NULL,1,224.72525,20.46831,0.069,NULL,59541672361,930338630,14536541,17.45),(125612,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125612,36.54,0.46,203,56887,70,NULL,NULL,'SDSS J145854.49+192630.8',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.0g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.727083,19.44189,0.061,NULL,59538327710,930286370,14535724,16),(125613,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125613,39.47,0.46,782,56888,70,NULL,NULL,'SDSS J145854.54+004243.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000085,NULL,'18.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.7272917,0.71219,0.145,NULL,59324423943,926944124,14483501,18.6),(125614,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125614,34.23,0.63,70,56889,70,NULL,NULL,'IC 1081',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.72',0.5,'SAB(s)0/a:',NULL,NULL,NULL,NULL,1,224.729416667,-19.23908,0.341,NULL,46653472999,728960515,11390008,14.72),(125615,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125615,34.47,0.46,78.2,56890,70,NULL,NULL,'CGCG 076-119',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000147,NULL,'15.5g',0.44,NULL,NULL,NULL,NULL,NULL,1,224.7325,11.65078,0.045,NULL,59374691680,927729557,14495774,15.5),(125616,'Sosies','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125616,32.1,0.63,26.3,56891,NULL,NULL,NULL,'NGC 5786',NULL,'2002A&A...393...57T',2002,1,2.3,NULL,'G',0.000017,NULL,'12',1.1,'(R\'_2)SAB(s)bc',NULL,NULL,NULL,NULL,1,224.734417,-42.01336,0.337,NULL,47093985332,735843520,11497555,12),(125617,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125617,32.35,0.47,29.5,56891,NULL,NULL,'H','NGC 5786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125618,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125618,32.37,0.45,29.8,56891,NULL,NULL,'K','NGC 5786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125619,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125619,32.38,0.46,30,56891,NULL,NULL,'J','NGC 5786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125620,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125620,32.85,0.4,37.2,56891,NULL,NULL,'mean','NGC 5786',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125621,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125621,37.45,0.33,310,56892,70,NULL,NULL,'2MASX J14585691+3508559',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.7370417,35.14878,0.029,NULL,60129513248,939523644,14680056,17.3),(125622,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125622,37.79,0.46,361,56893,70,NULL,NULL,'SDSS J145857.41+041303.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.73925,4.21753,0.117,NULL,59340767258,927199488,14487492,18.4),(125623,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125623,36.15,0.2,170,56894,74.4,NULL,NULL,'UGC 09634',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.12',0.5,'SB(s)b',NULL,NULL,NULL,NULL,1,224.741167,20.05275,0.065,NULL,59538948965,930296077,14535876,15.12),(125624,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125624,38.07,0.46,412,56895,70,NULL,NULL,'2MASX J14585816+4548290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.7425417,45.80819,0.021,NULL,59991469112,937366704,14646354,18.3),(125625,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125625,38.24,0.46,445,56896,70,NULL,NULL,'SDSS J145858.78+321424.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000162,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.744917,32.24022,0.009,NULL,60092026229,938937909,14670904,18.7),(125626,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125626,36.85,0.27,234,56897,70,NULL,NULL,'2MASX J14585975+0839424',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,224.749167,8.66189,0.049,NULL,59390404716,927975073,14499610,16.8),(125627,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125627,35.51,0.33,126,56898,70,NULL,NULL,'CGCG 248-038',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00022,NULL,'14.9g',0.51,NULL,'Group member',NULL,NULL,NULL,1,224.749666667,48.40983,0.053,NULL,59940976911,936577764,14634027,14.9),(125628,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125628,35.23,0.46,111,56899,70,NULL,NULL,'CGCG 221-019',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000143,NULL,'14.7g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,224.7525,43.40769,0.033,NULL,59981937263,937217769,14644027,14.7),(125629,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125629,37.34,0.46,294,56900,70,NULL,NULL,'SDSS J145900.76+322616.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.7532083,32.43797,0.005,NULL,60089735821,938902122,14670345,18),(125630,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125630,37.27,0.33,284,56901,70,NULL,NULL,'2MASX J14590130+2432595',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.38',0.16,NULL,NULL,NULL,NULL,NULL,1,224.755333,24.54981,0.097,NULL,59525690570,930088915,14532639,18.38),(125631,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125631,31.78,0.49,22.7,56902,75,NULL,'IR','ESO 327- G 039',NULL,'2011yCatp016004901K',2011,1,2.1,NULL,'G',0.000007,NULL,'16.1R',0.5,'Sb: sp',NULL,NULL,NULL,NULL,1,224.755625,-42.58172,0.441,NULL,47097809343,735903270,11498488,16.1),(125632,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125632,31.83,0.4,23.2,56902,75,NULL,NULL,'ESO 327- G 039',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125633,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125633,36.09,0.59,165,56903,70,NULL,NULL,'2MASX J14590220-2215136',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,224.75925,-22.25375,0.417,NULL,46643320485,728801882,11387529,14.1),(125634,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125634,34.27,0.46,71.4,56904,70,NULL,NULL,'UGC 09641',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000137,NULL,'14.4g',0.78,'S',NULL,NULL,NULL,NULL,1,224.762125,41.44683,0.005,NULL,59979440712,937178761,14643418,14.4),(125635,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125635,38.82,0.46,580,56905,70,NULL,NULL,'SDSS J145903.64+151148.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.7652083,15.19683,0.017,NULL,59579056901,930922764,14545668,18.5),(125636,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125636,35.91,0.46,152,56906,70,NULL,NULL,'2MASX J14590376+0729584',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.7657083,7.49947,0.065,NULL,59387861384,927935334,14498989,16.4),(125637,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125637,37.85,0.46,372,56907,70,NULL,NULL,'SDSS J145904.77+293208.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.769917,29.53558,0.029,NULL,60095155036,938986797,14671668,18.4),(125638,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125638,38.35,0.46,467,56908,70,NULL,NULL,'SDSS J145904.92+280512.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.770541667,28.08681,0.041,NULL,60082450380,938788287,14668566,17.9),(125639,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125639,38.43,0.46,485,56909,70,NULL,NULL,'2MASX J14590551+1555333',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.772833,15.92597,0.037,NULL,59591657210,931119643,14548744,18.2),(125640,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125640,37.58,0.46,328,56910,70,NULL,NULL,'2MASX J14590604+2651135',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.01',0.18,NULL,NULL,NULL,NULL,NULL,1,224.775083,26.85369,0.109,NULL,60079906480,938748538,14667945,18.01),(125641,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125641,37.56,0.46,325,56911,70,NULL,NULL,'SDSS J145907.37-022355.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.7807083,-2.39867,0.229,NULL,46442674410,725666787,11338543,18.3),(125642,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125642,37.17,0.46,272,56912,70,NULL,NULL,'2MASX J14590766+4841595',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.781875,48.69981,0.009,NULL,59941818401,936590912,14634233,17.3),(125643,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125643,37.45,0.33,310,56913,70,NULL,NULL,'2MASX J14590785+3518529',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,224.782875,35.31472,0.025,NULL,60129301275,939520332,14680005,16.9),(125644,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125644,38.51,0.46,503,56914,70,NULL,NULL,'SDSS J145908.14+623802.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,224.783916667,62.63392,0.021,NULL,57767915942,902623686,14103495,18.7),(125645,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125645,37.92,0.46,384,56915,70,NULL,NULL,'2MASX J14590820+0408518',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.784125,4.14758,0.117,NULL,59340982091,927202845,14487544,17.9),(125646,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125646,35.99,0.46,158,56916,70,NULL,NULL,'2MASX J14590984+0045348',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000078,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,224.791083333,0.75958,0.145,NULL,59324404276,926943816,14483497,16.2),(125647,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125647,38.52,0.46,506,56917,70,NULL,NULL,'SDSS J145910.18+122804.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.8g',0.2,'AGN',NULL,NULL,NULL,NULL,1,224.7924583,12.46781,0.053,NULL,59546594128,930415533,14537742,17.8),(125648,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125648,37.64,0.46,337,56918,70,NULL,NULL,'2MASX J14591139+2026068',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,224.797333333,20.43533,0.069,NULL,59541628439,930337944,14536530,17.1),(125649,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125649,36.52,0.27,201,56919,70,NULL,NULL,'2MASX J14591200+2342268',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.82',0.18,NULL,NULL,NULL,NULL,NULL,1,224.800083333,23.70742,0.093,NULL,59525900916,930092201,14532690,17.82),(125650,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125650,37.27,0.33,284,56920,70,NULL,NULL,'2MASX J14591223+2445515',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.93',0.18,NULL,NULL,NULL,NULL,NULL,1,224.800958333,24.76439,0.097,NULL,59525806662,930090729,14532667,17.93),(125651,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125651,37.63,0.46,336,56921,70,NULL,NULL,'2MASX J14591249+1726103',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,224.802083,17.43614,0.045,NULL,59588832905,931075514,14548054,NULL),(125652,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125652,37.6,0.46,331,56922,70,NULL,NULL,'SDSS J145913.86+090809.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.80775,9.13611,0.049,NULL,59389782252,927965347,14499458,18.4),(125653,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125653,37.29,0.46,287,56923,70,NULL,NULL,'2MASX J14591446+3830589',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.810125,38.51647,0.021,NULL,60117302602,939332853,14677075,17.2),(125654,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125654,37.34,0.46,294,56924,70,NULL,NULL,'2MASX J14591468+3128569',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.8112083,31.4825,0.025,NULL,60092802715,938950042,14671094,17.4),(125655,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125655,37.14,0.46,268,56925,70,NULL,NULL,'2MASX J14591474-0007450',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.811333,-0.12925,0.185,NULL,43486606047,679478219,10616847,17.4),(125656,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125656,37.6,0.2,331,56926,74.4,NULL,NULL,'2MASX J14591474+1717063',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000046,NULL,'17.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.811541667,17.28508,0.041,NULL,59588817847,931075278,14548051,17),(125657,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125657,37.31,0.46,290,56927,70,NULL,NULL,'2MASX J14591520+3736459',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000193,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,224.8135417,37.61294,0.021,NULL,60120978785,939390293,14677973,16.2),(125658,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125658,36.79,0.46,228,56928,70,NULL,NULL,'2MASX J14591558+1713403',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.815041667,17.22772,0.041,NULL,59588814628,931075228,14548050,16.9),(125659,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125659,36.52,0.27,201,56929,70,NULL,NULL,'CGCG 134-061 NED02',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00013,NULL,'15.96',0.32,NULL,NULL,NULL,NULL,NULL,1,224.82675,24.00028,0.097,NULL,59526395347,930099927,14532811,15.96),(125660,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125660,37.91,0.13,382,56930,70,NULL,NULL,'2MASX J14592170+4717562',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,224.8402917,47.29897,0.057,NULL,59991187921,937362311,14646286,17.8),(125661,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125661,36.24,0.46,177,56931,70,NULL,NULL,'2MASXi J1459222+174352',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.87',0.19,NULL,NULL,NULL,NULL,NULL,1,224.842666667,17.73133,0.065,NULL,59589485897,931085717,14548214,16.87),(125662,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125662,38.44,0.46,488,56932,70,NULL,NULL,'2MASX J14592244+0046448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000105,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.843667,0.77903,0.157,NULL,59325113439,926954897,14483670,17.7),(125663,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125663,33.75,0.8,56.3,56933,75,NULL,'MAT, I','ESO 581- G 010',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'15.22',0.9,'SAB(rs)d pec:',NULL,NULL,NULL,NULL,1,224.84375,-20.01931,0.389,NULL,46654244066,728972563,11390196,15.22),(125664,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125664,33.86,0.32,59.1,56933,85,NULL,'I, raw','ESO 581- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125665,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125665,33.87,0.32,59.5,56933,85,NULL,'I, inv','ESO 581- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125666,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125666,34.07,0.43,65.2,56933,75,NULL,'MAT, I, raw','ESO 581- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125667,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125667,34.17,0.43,68.2,56933,75,NULL,'MAT, I, inv','ESO 581- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125668,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125668,34.24,0.2,70.5,56933,74.4,NULL,NULL,'ESO 581- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125669,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125669,34.37,0.43,74.8,56933,75,NULL,'MAT, I, cor','ESO 581- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125670,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125670,34.59,0.43,82.8,56933,NULL,NULL,NULL,'ESO 581- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125671,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125671,34.83,0.38,92.4,56933,NULL,NULL,'Malmquist cor.','ESO 581- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125672,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125672,37.98,0.27,395,56934,70,NULL,NULL,'2MASX J14592355+5334105',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.848125,53.56958,0.029,NULL,59929259732,936394683,14631166,17.6),(125673,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125673,36.05,0.46,162,56935,70,NULL,NULL,'2MASX J14592382+0654245',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,224.8492083,6.90681,0.065,NULL,59387320555,927926883,14498857,15.5),(125674,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125674,32.75,0.4,35.5,56936,75,NULL,'Edat, raw','NGC 5796',NULL,'1997ApJS..109..333W',1997,1,2.5,'Confused HIPASS source','G',0.000023,NULL,'12.7',1.8,'E0-1','in a pair',NULL,NULL,NULL,1,224.8504583,-16.62386,0.477,NULL,46707729343,729808270,11403254,12.7),(125675,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125675,32.86,0.4,37.3,56936,75,NULL,'Edat, cor','NGC 5796',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125676,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125676,33.5,0.51,50.1,56936,95,NULL,'de Vaucouleurs','NGC 5796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125677,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125677,33.57,0.4,51.8,56936,95,NULL,'Weighted Mean','NGC 5796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125678,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125678,35.54,0.81,128,56936,55,NULL,'Visvanathan & Sandage 1979','NGC 5796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125679,'Tertiary','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125679,32.08,0.35,26.1,56936,95,NULL,NULL,'NGC 5796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125680,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125680,33.11,0.8,41.9,56936,75,NULL,'B','NGC 5796',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125681,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125681,33.27,0.4,45.1,56936,NULL,NULL,'mean','NGC 5796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125682,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125682,33.6,0.45,52.4,56936,NULL,NULL,'K','NGC 5796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125683,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125683,36.22,0.2,175,56937,74.4,NULL,NULL,'IC 4521',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000137,NULL,'15.3',0.3,'HII',NULL,NULL,NULL,NULL,1,224.864375,25.58408,0.117,NULL,60079248855,938738263,14667785,15.3),(125684,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125684,37.64,0.46,338,56938,70,NULL,NULL,'2MASX J14592754+1238200',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.55',0.18,NULL,NULL,NULL,NULL,NULL,1,224.864667,12.63889,0.057,NULL,59575933960,930873968,14544905,18.55),(125685,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125685,35.03,0.17,98.1,56939,74.2,NULL,'SALT 2','UGC 09640',0.033507,'2010ApJ...716..712A',2010,1,1.3,NULL,'G',0.000153,NULL,'14.02',1.1,'E',NULL,NULL,NULL,NULL,1,224.865167,16.64511,0.041,NULL,59592646279,931135098,14548985,14.02),(125686,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125686,35.6,0.09,132,56939,74.4,NULL,NULL,'UGC 09640',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125687,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125687,35.74,0.05,136,56939,72,NULL,'MLCS31','UGC 09640',0.033507,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125688,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125688,35.75,0.16,137,56939,70,NULL,'SALT 2','UGC 09640',0.033507,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125689,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125689,35.9,0.19,147,56939,65,NULL,'SALT2','UGC 09640',0.033507,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125690,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125690,35.99,0.17,152,56939,65,NULL,'MLCS17','UGC 09640',0.033507,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125691,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2008af',NULL,125691,36.1,0.17,160,56939,65,NULL,'MLCS31','UGC 09640',0.033507,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125692,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125692,34.99,0.46,99.6,56939,70,NULL,NULL,'UGC 09640',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125693,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125693,36.14,0.46,169,56940,70,NULL,NULL,'2MASX J14592788+6206353',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.1g',0.4,'S0',NULL,NULL,NULL,NULL,1,224.866125,62.10981,0.013,NULL,57767358417,902614975,14103358,16.1),(125694,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125694,38.72,0.33,555,56941,70,NULL,NULL,'2MASX J14592849+1155135',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.868708333,11.92042,0.061,NULL,59374810989,927731421,14495803,17.3),(125695,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125695,37.91,0.13,382,56942,70,NULL,NULL,'2MASX J14592859+4716593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,224.8692917,47.28322,0.057,NULL,59991189025,937362328,14646286,17.6),(125696,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125696,37.31,0.33,290,56943,70,NULL,NULL,'2MASX J14592887+1209040',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.8702917,12.15111,0.073,NULL,59374571583,927727680,14495745,17.8),(125697,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125697,37.89,0.46,378,56944,70,NULL,NULL,'SDSS J145929.97+460026.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,224.874917,46.0075,0.017,NULL,59991970560,937374540,14646477,18.3),(125698,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125698,37.82,0.46,367,56945,70,NULL,NULL,'2MASX J14593040+4637433',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,224.876583,46.62881,0.045,NULL,59992083586,937376306,14646504,17.2),(125699,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125699,38.42,0.46,483,56946,70,NULL,NULL,'2MASX J14593093+5435048',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.87925,54.58481,0,NULL,59928222706,936378479,14630913,18.1),(125700,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125700,37.39,0.46,300,56947,70,NULL,NULL,'2MASX J14593147+2215437',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.25',0.13,NULL,NULL,NULL,NULL,NULL,1,224.881208333,22.26214,0.085,NULL,59528762228,930136909,14533389,18.25),(125701,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125701,37.04,0.46,256,56948,70,NULL,NULL,'2MASX J14593175+5603098',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.8822083,56.05269,0.021,NULL,57717612319,901837692,14091213,16.9),(125702,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125702,37.02,0.46,254,56949,70,NULL,NULL,'2MASX J14593225+3416021',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,224.884541667,34.26736,0.009,NULL,60127211610,939487681,14679495,16.6),(125703,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125703,35.7,0.16,129,56950,72,NULL,NULL,'2MASX J14593310+1640070',0.03562,'2013ApJ...773...53F',2013,1,0.5,NULL,'G',NULL,NULL,'16.34',0.18,NULL,NULL,NULL,NULL,NULL,1,224.887833,16.66858,0.041,NULL,59592644261,931135066,14548985,16.34),(125704,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125704,35.85,0.05,143,56950,72,NULL,NULL,'2MASX J14593310+1640070',0.035,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125705,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125705,35.79,0.1,144,56950,74.4,NULL,NULL,'2MASX J14593310+1640070',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125706,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125706,35.82,0.02,146,56950,72,NULL,NULL,'2MASX J14593310+1640070',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125707,'SNIa','2016-12-15 15:15:30','2016-12-16 11:20:43','1','SN 2005be',NULL,125707,35.93,0.16,148,56950,70,NULL,'SALT 2','2MASX J14593310+1640070',0.035,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125708,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125708,37.82,0.46,366,56951,70,NULL,NULL,'2MASX J14593473+1559370',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.77',0.13,NULL,NULL,NULL,NULL,NULL,1,224.894625,15.99358,0.045,NULL,59591842751,931122542,14548789,18.77),(125709,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125709,37.5,0.46,316,56952,70,NULL,NULL,'2MASX J14593801+3513542',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,224.9085417,35.23183,0.029,NULL,60129519672,939523744,14680058,16.8),(125710,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125710,33.25,0.8,44.7,56953,75,NULL,'MAT, I','ESO 581- G 011',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'15.23',0.4,'Sc: sp',NULL,NULL,NULL,NULL,1,224.909167,-18.73158,0.341,NULL,46696249590,729628899,11400451,15.23),(125711,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125711,32.48,0.32,31.3,56953,85,NULL,'I, inv','ESO 581- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125712,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125712,32.49,0.32,31.5,56953,85,NULL,'I, raw','ESO 581- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125713,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125713,32.83,0.43,36.9,56953,75,NULL,'MAT, I, inv','ESO 581- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125714,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125714,32.84,0.43,36.9,56953,75,NULL,'MAT, I, raw','ESO 581- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125715,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125715,33.03,0.43,40.3,56953,75,NULL,'MAT, I, cor','ESO 581- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125716,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125716,33.25,0.49,44.7,56953,NULL,NULL,'Malmquist cor.','ESO 581- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125717,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125717,33.41,0.2,48.1,56953,74.4,NULL,NULL,'ESO 581- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125718,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125718,33.48,0.44,49.8,56953,NULL,NULL,NULL,'ESO 581- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125719,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125719,33.85,0.49,58.9,56953,75,NULL,'IR','ESO 581- G 011',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125720,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125720,36.53,0.2,202,56954,74.4,NULL,NULL,'CGCG 164-052',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00017,NULL,'15.7',0.4,'Sc',NULL,NULL,NULL,NULL,1,224.909417,28.95428,0.033,NULL,60081835589,938778681,14668416,15.7),(125721,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125721,37.57,0.46,327,56955,70,NULL,NULL,'2MASX J14593856+0543441',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,224.9105,5.72883,0.113,NULL,59337058061,927141532,14486586,17.3),(125722,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125722,34.52,0.52,80.3,56956,70,NULL,NULL,'2MASX J14593893-3754206',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,224.9122083,-37.90583,0.237,NULL,47236210632,738065791,11532277,13.5),(125723,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125723,37.79,0.46,361,56957,70,NULL,NULL,'SDSS J145939.83+332854.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.915958333,33.48192,0.009,NULL,60126601194,939478143,14679345,17.6),(125724,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125724,38.72,0.33,555,56958,70,NULL,NULL,'SDSS J145941.59+115609.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.923333,11.93586,0.061,NULL,59374808682,927731385,14495802,18.7),(125725,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125725,35.03,NULL,102,56959,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09646',NULL,'2010Ap&SS.325..163P',2010,1,1.1,NULL,'G',0.000012,NULL,'16.0',0.11,'Scd',NULL,NULL,NULL,NULL,1,224.924041667,27.32628,0.081,NULL,60083154418,938799287,14668738,16),(125726,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125726,35.05,NULL,102,56959,NULL,NULL,'Dipole + Quadrupole','UGC 09646',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125727,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125727,35.06,NULL,103,56959,NULL,NULL,'Dipole','UGC 09646',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125728,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125728,35.09,NULL,104,56959,NULL,NULL,NULL,'UGC 09646',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125729,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125729,35.73,0.2,140,56959,74.4,NULL,NULL,'UGC 09646',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125730,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125730,38.19,0.46,435,56960,70,NULL,NULL,'2MASX J14594222+1446100',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.925791667,14.76947,0.017,NULL,59579123970,930923812,14545684,18.2),(125731,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125731,37.91,0.13,382,56961,70,NULL,NULL,'2MASX J14594265+4721073',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,224.927875,47.35189,0.057,NULL,59991135941,937361499,14646273,16.9),(125732,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125732,38.09,0.46,416,56962,70,NULL,NULL,'2MASX J14594364+0325111',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,224.931917,3.41975,0.149,NULL,59340009455,927187647,14487306,17.9),(125733,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125733,36.79,0.46,228,56963,70,NULL,NULL,'2MASX J14594454+4756423',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000189,NULL,'16.1g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,224.935333333,47.94508,0.053,NULL,59940841872,936575654,14633994,16.1),(125734,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125734,37.75,0.46,355,56964,70,NULL,NULL,'2MASX J14594544+0118171',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,224.9394583,1.30472,0.157,NULL,59325083584,926954431,14483662,17.2),(125735,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125735,38.14,0.46,424,56965,70,NULL,NULL,'2MASX J14594679+4724172',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.9447917,47.40489,0.057,NULL,59991144756,937361636,14646275,17.8),(125736,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125736,37.89,0.46,379,56966,70,NULL,NULL,'2MASX J14594683+3602228',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.945,36.03972,0.021,NULL,60128993619,939515525,14679930,17.5),(125737,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125737,37.64,0.46,337,56967,70,NULL,NULL,'SDSS J145947.75+254546.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.949,25.76294,0.109,NULL,60079431196,938741112,14667829,18.3),(125738,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125738,36.1,0.46,166,56968,70,NULL,NULL,'2MASX J14594830+4751592',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,224.951125,47.86639,0.065,NULL,59940862454,936575975,14633999,16.2),(125739,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125739,37.66,0.46,340,56969,70,NULL,NULL,'2MASX J14594852+4307332',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,224.952125,43.126,0.033,NULL,59981892604,937217071,14644016,17.1),(125740,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125740,36.75,0.33,224,56970,70,NULL,NULL,'SDSS J145950.28+210100.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.9595417,21.01669,0.061,NULL,59542334423,930348975,14536702,17.9),(125741,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125741,38.38,0.46,475,56971,70,NULL,NULL,'2MASX J14595046+5442467',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.960375,54.71294,0,NULL,59190018939,924844045,14450688,18.3),(125742,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125742,36.52,0.27,201,56972,70,NULL,NULL,'2MASX J14595271+2347261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.93',0.18,NULL,NULL,NULL,NULL,NULL,1,224.969583,23.79058,0.093,NULL,59526361351,930099396,14532803,17.93),(125743,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125743,37.94,0.46,387,56973,70,NULL,NULL,'SDSS J145953.15+393508.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,224.9715,39.58581,0.005,NULL,60117166247,939330722,14677042,18.1),(125744,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125744,36.29,0.46,181,56974,70,NULL,NULL,'2MASX J14595430-0126437',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,224.9764583,-1.44547,0.173,NULL,46440123074,725626923,11337920,16.6),(125745,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125745,36.63,0.73,212,56974,70,NULL,NULL,'2MASX J14595430-0126437',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125746,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125746,37.85,0.46,372,56975,70,NULL,NULL,'2MASX J14595432+3904438',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,224.976583,39.07875,0.009,NULL,60118004205,939343815,14677247,17.9),(125747,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125747,38.26,0.46,450,56976,70,NULL,NULL,'SDSS J145955.35+080753.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.5g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.980625,8.13158,0.065,NULL,59391331824,927989559,14499836,18.5),(125748,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125748,37.8,0.46,363,56977,70,NULL,NULL,'2MASX J14595606+3929418',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,224.983666667,39.49511,0.005,NULL,60117169456,939330772,14677043,17.5),(125749,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125749,37.21,0.46,276,56978,70,NULL,NULL,'2MASX J14595618+2032131',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'16.83',0.17,NULL,NULL,NULL,NULL,NULL,1,224.984,20.53708,0.073,NULL,59542091223,930345175,14536643,16.83),(125750,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125750,37.56,0.46,326,56979,70,NULL,NULL,'2MASX J14595683+2625114',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'18.02',0.12,NULL,NULL,NULL,NULL,NULL,1,224.98675,26.41981,0.109,NULL,60080248045,938753875,14668029,18.02),(125751,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125751,35.84,0.46,147,56980,70,NULL,NULL,'2MASX J14595817+5619542',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'15.9g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,224.9922917,56.33181,0.005,NULL,57717764318,901840067,14091251,15.9),(125752,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125752,38.79,0.46,573,56981,70,NULL,NULL,'SDSS J145958.15+293219.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,224.992333,29.53869,0.045,NULL,60095188056,938987313,14671676,18.2),(125753,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125753,37.4,0.46,302,56982,70,NULL,NULL,'2MASX J14595863+3346184',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000218,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,224.994375,33.77192,0.013,NULL,60127382617,939490353,14679536,16),(125754,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125754,38.05,0.46,407,56983,70,NULL,NULL,'2MASX J14595913+1921251',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,224.996333,19.35706,0.061,NULL,59538407254,930287613,14535743,18.3),(125755,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125755,37.6,0.46,331,56984,70,NULL,NULL,'2MASX J14595950+3704158',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,224.9977917,37.07114,0.025,NULL,60120354615,939380540,14677820,17.8),(125756,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125756,31.66,0.8,21.5,56985,75,NULL,'A82, H','NGC 5806',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000017,NULL,'12.5g',1.15,'SAB(s)b        NLAGN','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,225.001667,1.89131,0.157,NULL,59328217251,927003394,14484428,12.5),(125757,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125757,31.71,0.8,22,56985,75,NULL,'CF, r','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125758,'Sosies','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125758,31.65,0.08,21.4,56985,NULL,NULL,NULL,'NGC 5806',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125759,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125759,32.27,0.8,28.5,56985,75,NULL,'B','NGC 5806',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125760,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125760,31.76,0.36,22.5,56985,NULL,NULL,NULL,'NGC 5806',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125761,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125761,31.93,0.47,24.3,56985,75,NULL,'A82, H, raw','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125762,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125762,32.01,0.5,25.2,56985,NULL,NULL,'Malmquist cor.','NGC 5806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125763,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125763,32.04,NULL,25.6,56985,72,NULL,NULL,'NGC 5806',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125764,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125764,32.05,0.47,25.7,56985,75,NULL,'A82, H, inv','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125765,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125765,32.07,0.4,26,56985,NULL,NULL,'mean','NGC 5806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125766,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125766,32.08,0.46,26.1,56985,NULL,NULL,'J','NGC 5806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125767,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125767,32.09,0.47,26.1,56985,NULL,NULL,'H','NGC 5806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125768,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125768,32.09,0.45,26.2,56985,NULL,NULL,'K','NGC 5806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125769,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125769,32.14,0.47,26.7,56985,NULL,NULL,NULL,'NGC 5806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125770,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125770,32.14,0.2,26.8,56985,74.4,NULL,NULL,'NGC 5806',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125771,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125771,32.16,0.47,27.1,56985,75,NULL,'A82, H, cor','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125772,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125772,32.17,0.38,27.2,56985,75,NULL,'CF, r, raw','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125773,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125773,32.17,0.43,27.2,56985,75,NULL,'3.6 micron, color corrected','NGC 5806',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125774,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125774,32.18,0.43,27.3,56985,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5806',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125775,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125775,32.28,0.38,28.6,56985,75,NULL,'CF, r, cor','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125776,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125776,32.32,0.38,29.1,56985,75,NULL,'CF, r, inv','NGC 5806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125777,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125777,37.13,0.71,266,56986,70,NULL,NULL,'2MASX J15000087-2749458',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.5R',0.27,NULL,NULL,NULL,NULL,NULL,1,225.00375,-27.82933,0.649,NULL,47198449884,737475779,11523059,15.5),(125778,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125778,37.16,0.46,270,56987,70,NULL,NULL,'2MASX J15000118+4022318',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.004917,40.37553,0,NULL,59978550925,937164858,14643200,17.4),(125779,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125779,37.41,0.46,304,56988,70,NULL,NULL,'2MASX J15000142+2429305',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.005916667,24.49183,0.097,NULL,59525762700,930090042,14532656,18.2),(125780,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125780,37.31,0.33,290,56989,70,NULL,NULL,'2MASX J15000148+1212227',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,225.006333,12.20633,0.073,NULL,59374583571,927727868,14495747,16.7),(125781,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125781,36.75,0.33,224,56990,70,NULL,NULL,'2MASX J15000164+2100491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.39',0.26,NULL,NULL,NULL,NULL,NULL,1,225.007,21.01367,0.061,NULL,59542335667,930348994,14536703,16.39),(125782,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125782,37.91,0.13,382,56991,70,NULL,NULL,'2MASX J15000201+4715294',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.008458333,47.25831,0.057,NULL,59991195564,937362430,14646287,17.8),(125783,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125783,38.16,0.46,428,56992,70,NULL,NULL,'2MASX J15000240+2048341',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.01025,20.80964,0.073,NULL,59542126773,930345730,14536652,18.5),(125784,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125784,37.23,0.46,279,56993,70,NULL,NULL,'2MASX J15000348+2126371',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,225.014417,21.44372,0.077,NULL,59541547221,930336675,14536510,16.8),(125785,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125785,37.25,0.33,282,56994,70,NULL,NULL,'2MASX J15000454+2527015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.46',0.23,NULL,NULL,NULL,NULL,NULL,1,225.018791667,25.45047,0.093,NULL,60079215692,938737745,14667777,17.46),(125786,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125786,37.91,0.13,382,56995,70,NULL,NULL,'2MASX J15000494+4730344',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.0204583,47.50969,0.077,NULL,59991133537,937361461,14646272,16.9),(125787,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125787,37.58,0.46,328,56996,70,NULL,NULL,'2MASX J15000817+3954328',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000186,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,225.0339583,39.90931,0,NULL,60117011994,939328312,14677004,16.5),(125788,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125788,37.25,0.33,282,56997,70,NULL,NULL,'2MASX J15000889+2524205',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.037,25.40578,0.097,NULL,60079225148,938737892,14667779,17.5),(125789,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125789,37.14,0.46,268,56998,70,NULL,NULL,'2MASX J15000919+2436075',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'18.06',0.16,NULL,NULL,NULL,NULL,NULL,1,225.0382917,24.60208,0.093,NULL,59525764584,930090071,14532657,18.06),(125790,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125790,36.35,0.46,186,56999,70,NULL,NULL,'2MASX J15001003+2800555',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0002,NULL,'16.5',0.48,NULL,NULL,NULL,NULL,NULL,1,225.041875,28.01544,0.041,NULL,60083224914,938800389,14668756,16.5),(125791,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125791,37.68,0.46,344,57000,70,NULL,NULL,'SDSS J150010.30+042512.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000069,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.0429583,4.42025,0.109,NULL,59340761424,927199397,14487490,18.5),(125792,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125792,37.44,0.46,307,57001,70,NULL,NULL,'2MASX J15001063+0944550',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.044333333,9.7485,0.053,NULL,59377974202,927780846,14496575,17),(125793,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125793,37.91,0.46,381,57002,70,NULL,NULL,'2MASX J15001212+2702335',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,225.050583333,27.04258,0.085,NULL,60079539735,938742808,14667856,18.22),(125794,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125794,37.08,0.46,261,57003,70,NULL,NULL,'2MASX J15001223+1937307',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.16',0.19,NULL,NULL,NULL,NULL,NULL,1,225.051,19.62528,0.065,NULL,59538227817,930284809,14535700,18.16),(125795,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125795,37.91,0.16,381,57004,70,NULL,NULL,'2MASX J15001227+3220424',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.051,32.34511,0.025,NULL,60091844204,938935065,14670860,17.9),(125796,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125796,37.2,0.46,275,57005,70,NULL,NULL,'2MASX J15001225+4554384',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.051083,45.9105,0.021,NULL,59991931185,937373924,14646467,17),(125797,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125797,38.51,0.46,504,57006,70,NULL,NULL,'SDSS J150013.04+331855.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.054375,33.31533,0.021,NULL,60126643405,939478803,14679356,18.7),(125798,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125798,37.87,0.46,374,57007,70,NULL,NULL,'2MASX J15001323+5146084',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.055333,51.769,0.021,NULL,59931621635,936431588,14631743,17.5),(125799,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125799,36.88,0.46,237,57008,70,NULL,NULL,'2MASX J15001330+5440423',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.0555417,54.67839,0,NULL,59928218883,936378420,14630912,17),(125800,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125800,37.35,0.46,296,57009,70,NULL,NULL,'2MASX J15001359+1732438',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.056583,17.54569,0.061,NULL,59589285462,931082585,14548165,17.7),(125801,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125801,37.97,0.46,393,57010,70,NULL,NULL,'2MASX J15001432+0027495',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000091,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.05975,0.46367,0.153,NULL,59324475490,926944929,14483514,17.2),(125802,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125802,37.91,0.13,382,57011,70,NULL,NULL,'2MASX J15001684+4713574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.070208333,47.23264,0.057,NULL,59991193748,937362402,14646287,18),(125803,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125803,37.53,0.46,320,57012,70,NULL,NULL,'2MASX J15001730+4505104',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.072375,45.08617,0.033,NULL,59995318640,937426853,14647294,17.3),(125804,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125804,37.85,0.46,372,57013,70,NULL,NULL,'2MASX J15001773+3117274',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,225.073833333,31.29089,0.017,NULL,60092604208,938946940,14671045,18.2),(125805,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125805,38.06,0.46,409,57014,70,NULL,NULL,'SDSS J150018.80+002809.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.078333,0.46925,0.153,NULL,59324477666,926944963,14483515,18),(125806,'CMD','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125806,17.1,NULL,0.0263,57015,NULL,NULL,NULL,'IC 4499',NULL,'2000ApJS..129..315V',2000,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,'Globular',NULL,NULL,NULL,NULL,1,225.0802083,-82.2135,0.385,0,44073795942,688653061,10760204,NULL),(125807,'Horizontal Branch','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125807,16.33,0.33,0.0185,57015,NULL,NULL,NULL,'IC 4499',NULL,'1995MNRAS.275.1057F',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125808,'RR Lyrae','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125808,16.2,0.23,0.0174,57015,NULL,NULL,'13, V','IC 4499',NULL,'1986AJ.....92..825C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125809,'RR Lyrae','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125809,16.36,NULL,0.0187,57015,NULL,NULL,'10, K','IC 4499',NULL,'1992MmSAI..63..433B',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125810,'RR Lyrae','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125810,16.47,0.04,0.0197,57015,NULL,18.5,'32, K, 0.06 mag systematic error','IC 4499',NULL,'2004A&A...415..987S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125811,'RR Lyrae','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,NULL,125811,17.09,0.04,0.0262,57015,NULL,NULL,NULL,'IC 4499',NULL,'2004ApJ...612.1092D',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125812,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125812,37.93,0.46,385,57016,70,NULL,NULL,'SDSS J150019.35+450912.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.080667,45.15347,0.021,NULL,59995318156,937426846,14647294,18.4),(125813,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125813,37.58,0.46,328,57017,70,NULL,NULL,'2MASX J15001966+0837290',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.0819583,8.62472,0.025,NULL,59390500190,927976565,14499633,17.4),(125814,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125814,37.53,0.46,320,57018,70,NULL,NULL,'2MASX J15001973+4756544',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.0819583,47.94836,0.053,NULL,59940820684,936575323,14633989,17.6),(125815,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125815,37.33,0.46,293,57019,70,NULL,NULL,'2MASX J15001983+5949064',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000079,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.0825,59.81836,0.017,NULL,57776745115,902761642,14105650,17),(125816,'FP','2016-12-15 15:15:30','2016-12-16 11:20:43','1',NULL,'R',125816,37.67,0.46,342,57020,70,NULL,NULL,'2MASX J15001992+5148294',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.082833,51.80825,0.021,NULL,59931612860,936431450,14631741,18.3),(125817,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125817,38.54,0.46,511,57021,70,NULL,NULL,'SDSS J150020.53+013516.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.085583333,1.58803,0.157,NULL,59328039670,927000619,14484384,18.4),(125818,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125818,37.95,0.46,389,57022,70,NULL,NULL,'SDSS J150020.76+371553.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.0865417,37.26481,0.029,NULL,60120313295,939379895,14677810,18.6),(125819,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125819,37.93,0.33,386,57023,70,NULL,NULL,'SDSS J150021.53+154838.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.08975,15.81083,0.017,NULL,59591683726,931120058,14548750,17.5),(125820,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125820,37.7,0.46,346,57024,70,NULL,NULL,'2MASX J15002177+1440358',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.61',0.12,NULL,NULL,NULL,NULL,NULL,1,225.0907083,14.67667,0.041,NULL,59579922634,930936291,14545879,18.61),(125821,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125821,37.08,0.46,261,57025,70,NULL,NULL,'2MASX J15002233+0642260',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,225.0929583,6.70722,0.061,NULL,59387400611,927928134,14498877,16.2),(125822,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125822,37.41,0.46,303,57026,70,NULL,NULL,'2MASX J15002282+2905541',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000207,NULL,'17.56',0.21,'E',NULL,NULL,NULL,NULL,1,225.095083,29.09844,0.037,NULL,60094428193,938975440,14671491,17.56),(125823,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125823,35.73,0.46,140,57027,70,NULL,NULL,'2MASX J15002314+0351402',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.096417,3.86117,0.129,NULL,59340916080,927201813,14487528,16.5),(125824,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125824,37.91,0.16,381,57028,70,NULL,NULL,'SDSS J150023.43+321825.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.097625,32.30719,0.025,NULL,60091837611,938934962,14670858,18.7),(125825,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125825,36.19,0.46,173,57029,70,NULL,NULL,'2MASX J15002362+2617091',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.61',0.17,NULL,NULL,NULL,NULL,NULL,1,225.0984583,26.28572,0.101,NULL,60080174299,938752723,14668011,17.61),(125826,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125826,35.03,0.8,101,57030,75,NULL,'MAT, I','ESO 386- G 044',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'14.83',0.9,'Sc',NULL,NULL,NULL,NULL,1,225.099167,-37.36211,0.245,NULL,47235380278,738052816,11532075,14.83),(125827,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125827,34.63,0.32,84.5,57030,85,NULL,'I, raw','ESO 386- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125828,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125828,34.68,0.32,86.1,57030,85,NULL,'I, inv','ESO 386- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125829,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125829,34.77,0.43,89.8,57030,75,NULL,'MAT, I, raw','ESO 386- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125830,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125830,34.97,0.43,98.6,57030,75,NULL,'MAT, I, inv','ESO 386- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125831,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125831,35.08,0.43,104,57030,75,NULL,'MAT, I, cor','ESO 386- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125832,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125832,35.09,0.44,104,57030,NULL,NULL,'Malmquist cor.','ESO 386- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125833,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125833,35.22,0.42,111,57030,NULL,NULL,NULL,'ESO 386- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125834,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125834,35.24,0.2,112,57030,74.4,NULL,NULL,'ESO 386- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125835,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125835,33.02,0.8,40.2,57031,75,NULL,NULL,'UGCA 397',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000019,NULL,'14.15',1.8,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,225.1012917,-13.55197,0.381,NULL,46692017742,729562777,11399418,14.15),(125836,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125836,37.91,0.13,382,57032,70,NULL,NULL,'2MASX J15002573+4724193',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.107375,47.40539,0.077,NULL,59991140120,937361564,14646274,18.1),(125837,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125837,36.52,0.46,202,57033,70,NULL,NULL,'2MASX J15002575+1925298',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.17',0.28,NULL,NULL,NULL,NULL,NULL,1,225.107458333,19.42486,0.069,NULL,59538396047,930287438,14535741,16.17),(125838,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125838,37.97,0.46,392,57034,70,NULL,NULL,'2MASX J15002602+2943521',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.108333,29.73122,0.037,NULL,60095147555,938986680,14671666,17.4),(125839,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125839,37.55,0.33,323,57035,70,NULL,NULL,'2MASX J15002700+1004490',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.55',0.17,NULL,NULL,NULL,NULL,NULL,1,225.112583,10.08017,0.049,NULL,59378677089,927791829,14496747,18.55),(125840,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125840,38.95,0.46,615,57036,70,NULL,NULL,'SDSS J150027.01+250832.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.112583,25.14239,0.101,NULL,59408137089,928252142,14503939,18.7),(125841,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125841,37.37,0.46,298,57037,70,NULL,NULL,'2MASX J15002721+4632283',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.113333,46.54117,0.037,NULL,59992004671,937375072,14646485,18.1),(125842,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125842,37.5,0.33,317,57038,70,NULL,NULL,'2MASX J15002827+4737223',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.117875,47.62294,0.073,NULL,59938704486,936542257,14633472,17.9),(125843,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125843,37.97,0.46,393,57039,70,NULL,NULL,'2MASX J15002907+5028168',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.121083,50.47122,0,NULL,59944145171,936627268,14634801,17.9),(125844,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125844,37.5,0.33,317,57040,70,NULL,NULL,'2MASX J15003005+4737446',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.125166667,47.62919,0.073,NULL,59938704090,936542251,14633472,16.8),(125845,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125845,37.91,0.16,381,57041,70,NULL,NULL,'2MASX J15003113+3213392',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.129875,32.22772,0.017,NULL,60092013162,938937705,14670901,17.7),(125846,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125846,37.82,0.46,366,57042,70,NULL,NULL,'2MASX J15003150+3628496',NULL,'2015arXiv151105856S',2015,1,0.37,'May be a resolved component of 87GB[BWE91] 1458+3640.','G',0.000202,NULL,'16.7g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,225.131167,36.4805,0.009,NULL,60127709753,939495464,14679616,16.7),(125847,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125847,37.55,0.33,323,57043,70,NULL,NULL,'2MASX J15003296+0954460',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000197,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.137167,9.91283,0.049,NULL,59377802300,927778160,14496533,16.5),(125848,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125848,35.81,0.46,145,57044,70,NULL,NULL,'2MASX J15003389+0903430',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.95',0.18,NULL,NULL,NULL,NULL,NULL,1,225.1412083,9.06206,0.057,NULL,59388465391,927944771,14499137,17.95),(125849,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125849,37.21,0.46,276,57045,70,NULL,NULL,'SDSS J150035.77+320610.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.149083,32.10306,0.005,NULL,60092018115,938937783,14670902,17.9),(125850,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125850,35.03,0.34,101,57046,NULL,NULL,'Malmquist cor.','ESO 581- G 014',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.30',0.4,'S              HII',NULL,NULL,NULL,NULL,1,225.151333,-21.89161,0.377,NULL,46655876423,728998069,11390594,15.3),(125851,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125851,35.27,0.31,113,57046,NULL,NULL,NULL,'ESO 581- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125852,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125852,35.31,0.2,115,57046,74.4,NULL,NULL,'ESO 581- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125853,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125853,33.06,0.49,40.9,57047,75,NULL,'IR','FGC 1842',NULL,'2011yCatp016004901K',2011,1,0.98,'2000A&AS..143..421M has z = 0.007965 +- 0.000057.','G',0.000208,NULL,'16.5g',0.17,'Sd',NULL,NULL,NULL,NULL,1,225.1535,38.00894,0.009,NULL,60120938128,939389658,14677963,16.5),(125854,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125854,33.53,NULL,50.7,57047,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125855,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125855,33.55,NULL,51.4,57047,NULL,NULL,'Dipole + Quadrupole','FGC 1842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125856,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125856,33.58,NULL,52,57047,NULL,NULL,'Dipole','FGC 1842',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125857,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125857,33.62,NULL,53.1,57047,NULL,NULL,NULL,'FGC 1842',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125858,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125858,38.8,0.46,574,57048,70,NULL,NULL,'SDSS J150037.52+521301.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.156375,52.21717,0.025,NULL,59932350725,936442980,14631921,18.6),(125859,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125859,37.93,0.33,386,57049,70,NULL,NULL,'SDSS J150037.75+154749.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.157333,15.797,0.017,NULL,59591135410,931111490,14548617,17.6),(125860,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125860,35.67,0.33,136,57050,70,NULL,NULL,'2MASX J15003823+0618070',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.61',0.36,NULL,NULL,NULL,NULL,NULL,1,225.159333,6.302,0.085,NULL,59385106821,927892294,14498317,16.61),(125861,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125861,35.4,0.8,120,57051,75,NULL,'MAT, I','ESO 581- G 015',NULL,'1997ApJS..109..333W',1997,1,1.6,'6dF DR1 has z = 0.026274.','G',0.000033,NULL,'15.54',0.5,'SB(r)c:',NULL,NULL,NULL,NULL,1,225.160875,-21.71797,0.409,NULL,46656419512,729006554,11390727,15.54),(125862,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125862,34.55,0.43,81.3,57051,75,NULL,'MAT, I, raw','ESO 581- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125863,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125863,34.58,0.32,82.6,57051,85,NULL,'I, raw','ESO 581- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125864,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125864,34.63,0.32,84.2,57051,85,NULL,'I, inv','ESO 581- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125865,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125865,34.75,0.43,88.9,57051,75,NULL,'MAT, I, inv','ESO 581- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125866,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125866,34.85,0.43,93.4,57051,75,NULL,'MAT, I, cor','ESO 581- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125867,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125867,34.98,0.31,99.1,57051,NULL,NULL,'Malmquist cor.','ESO 581- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125868,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125868,35.13,0.29,106,57051,NULL,NULL,NULL,'ESO 581- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125869,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125869,35.17,0.2,108,57051,74.4,NULL,NULL,'ESO 581- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125870,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125870,37.4,0.46,302,57052,70,NULL,NULL,'2MASX J15003983+3358272',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,225.165917,33.97414,0.025,NULL,60127404815,939490700,14679542,16.4),(125871,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125871,37.25,0.46,281,57053,70,NULL,NULL,'SDSS J150039.99+054531.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.166625,5.75869,0.113,NULL,59336854452,927138350,14486536,17.7),(125872,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125872,37.5,0.46,316,57054,70,NULL,NULL,'2MASX J15004034+2542092',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,225.1682917,25.70269,0.065,NULL,60079227945,938737936,14667780,18.18),(125873,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125873,37.48,0.46,313,57055,70,NULL,NULL,'2MASX J15004113+2205566',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.1714583,22.09911,0.085,NULL,59528199651,930128119,14533251,17.1),(125874,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125874,37.75,0.46,355,57056,70,NULL,NULL,'2MASX J15004312+0346362',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.1797083,3.77678,0.129,NULL,59340057111,927188392,14487318,17.5),(125875,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125875,37.83,0.46,368,57057,70,NULL,NULL,'2MASX J15004347+3325452',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.181125,33.42922,0.021,NULL,60126503017,939476609,14679322,17.6),(125876,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125876,36.57,0.46,206,57058,70,NULL,NULL,'2MASX J15004369+0029242',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000106,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.182125,0.49017,0.141,NULL,59324471497,926944867,14483513,16.7),(125877,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125877,38.13,0.46,422,57059,70,NULL,NULL,'SDSS J150044.91+292451.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.32',0.14,NULL,NULL,NULL,NULL,NULL,1,225.187166667,29.41419,0.045,NULL,60094956989,938983702,14671620,17.32),(125878,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125878,37.25,0.46,282,57060,70,NULL,NULL,'2MASXi J1500451+133623',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.85',0.14,NULL,NULL,NULL,NULL,NULL,1,225.188375,13.60639,0.053,NULL,59576714514,930886164,14545096,18.85),(125879,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125879,36.6,0.46,209,57061,70,NULL,NULL,'2MASX J15004586+2457262',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'15.9g',0.45,NULL,NULL,NULL,NULL,NULL,1,225.1912083,24.95725,0.097,NULL,59525602244,930087535,14532617,15.9),(125880,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125880,36.34,0.46,185,57062,70,NULL,NULL,'2MASX J15004691+0808385',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000494,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,225.1954583,8.14397,0.053,NULL,59391313849,927989278,14499832,16.2),(125881,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125881,32.72,0.4,35.1,57063,75,NULL,NULL,'UGC 09657',NULL,'2008Ap.....51..336K',2008,1,1.13,'HOLM 689B is a star.','G',0.000037,NULL,'15.2g',0.32,'SBdm?',NULL,NULL,NULL,NULL,1,225.202833,48.36081,0.021,NULL,59940896054,936576500,14634007,15.2),(125882,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125882,33.64,0.49,53.6,57063,75,NULL,'IR','UGC 09657',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125883,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125883,37.8,0.46,364,57064,70,NULL,NULL,'2MASX J15004880+4109388',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.2035,41.16075,0.029,NULL,59978645217,937166331,14643223,16.7),(125884,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125884,37.99,0.46,397,57065,70,NULL,NULL,'2MASX J15005100+0942425',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.2125,9.71181,0.053,NULL,59377943762,927780371,14496568,17.3),(125885,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125885,38.85,0.46,589,57066,70,NULL,NULL,'2MASX J15005188+1621282',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.216125,16.35789,0.021,NULL,59591716820,931120575,14548758,18.2),(125886,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125886,37.91,0.16,381,57067,70,NULL,NULL,'SDSS J150052.02+322110.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.2167917,32.35281,0.025,NULL,60091841353,938935021,14670859,18.1),(125887,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125887,35.84,0.33,147,57068,70,NULL,NULL,'2MASX J15005255+0145509',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000085,NULL,'15.9g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,225.219083333,1.76419,0.145,NULL,59328077046,927001203,14484393,15.9),(125888,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125888,37.72,0.46,350,57069,70,NULL,NULL,'2MASX J15005276+2052387',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.34',0.16,NULL,NULL,NULL,NULL,NULL,1,225.2199583,20.87742,0.073,NULL,59542310731,930348605,14536696,18.34),(125889,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125889,37.39,0.33,300,57070,70,NULL,NULL,'2MASX J15005339+3434361',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.2224583,34.57664,0.033,NULL,60126735381,939480240,14679378,17.8),(125890,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125890,37.91,0.16,381,57071,70,NULL,NULL,'2MASX J15005374+3210421',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.223917,32.17836,0.017,NULL,60092009280,938937645,14670900,17.6),(125891,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125891,36.12,0.46,168,57072,70,NULL,NULL,'2MASX J15005393+1955227',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.00',0.25,NULL,NULL,NULL,NULL,NULL,1,225.2247917,19.923,0.065,NULL,59539093532,930298336,14535911,16),(125892,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125892,32.15,0.29,26.9,57073,NULL,NULL,'I','NGC 5812',NULL,'2001ApJ...546..681T',2001,1,2.1,NULL,'G',0.000007,NULL,'12.19',1.9,'E0','in a pair',NULL,NULL,NULL,1,225.232083,-7.45736,0.301,NULL,46502941968,726608468,11353257,12.19),(125893,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125893,32.15,0.29,26.9,57073,NULL,NULL,NULL,'NGC 5812',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125894,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125894,32.21,0.14,27.7,57073,74.4,NULL,NULL,'NGC 5812',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125895,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125895,32.25,0.29,28.2,57073,NULL,NULL,'Malmquist cor.','NGC 5812',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125896,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125896,31.81,0.4,23,57073,75,NULL,'Edat, raw','NGC 5812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125897,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125897,32.14,0.4,26.8,57073,75,NULL,'Edat, cor','NGC 5812',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125898,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125898,33.4,0.65,47.9,57073,95,NULL,'Weighted Mean','NGC 5812',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125899,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125899,35.18,0.81,109,57073,55,NULL,'Visvanathan & Sandage 1979','NGC 5812',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125900,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125900,32.23,0.41,28,57073,NULL,NULL,NULL,'NGC 5812',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125901,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125901,32.37,0.41,29.8,57073,NULL,NULL,'Malmquist cor.','NGC 5812',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125902,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125902,32.5,0.8,31.7,57073,75,NULL,'B','NGC 5812',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125903,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125903,32.29,0.4,28.7,57073,NULL,NULL,'mean','NGC 5812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125904,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125904,32.35,0.45,29.5,57073,NULL,NULL,'K','NGC 5812',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125905,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125905,37.51,0.46,318,57074,70,NULL,NULL,'2MASX J15005599+4622527',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.2332917,46.38125,0.029,NULL,59992150577,937377352,14646521,17),(125906,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125906,37.54,0.46,322,57075,70,NULL,NULL,'2MASX J15005606-0215162',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.233625,-2.25453,0.229,NULL,46443434244,725678660,11338729,17.3),(125907,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125907,37.39,0.33,300,57076,70,NULL,NULL,'2MASX J15005695+3433521',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000208,NULL,'15.6g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,225.2372083,34.56444,0.033,NULL,60126735025,939480234,14679378,15.6),(125908,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125908,37.15,0.46,269,57077,70,NULL,NULL,'2MASX J15005732+2146087',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.238833,21.76928,0.093,NULL,59539482041,930304406,14536006,17.1),(125909,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125909,38.43,0.46,485,57078,70,NULL,NULL,'2MASX J15005824+4701477',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.24275,47.02992,0.057,NULL,59991356763,937364949,14646327,17.9),(125910,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125910,37.97,0.46,392,57079,70,NULL,NULL,'2MASX J15005906+4031449',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.2459583,40.52911,0,NULL,59970212603,937034571,14641165,17.5),(125911,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125911,36.91,0.46,241,57080,70,NULL,NULL,'2MASX J15005913+4040229',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.70',0.2,NULL,NULL,NULL,NULL,NULL,1,225.2464583,40.67303,0.017,NULL,59978577021,937165265,14643207,16.7),(125912,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125912,37.11,0.46,265,57081,70,NULL,NULL,'2MASX J15005980+2811455',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.09',0.17,NULL,NULL,NULL,NULL,NULL,1,225.249333,28.196,0.041,NULL,60082538374,938789662,14668588,18.09),(125913,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125913,37.83,0.27,369,57082,70,NULL,NULL,'2MASX J15005996+4153169',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.2499583,41.88806,0.033,NULL,59978900172,937170315,14643286,17.6),(125914,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125914,32.6,0.54,33.1,57083,NULL,NULL,'Malmquist cor.','MCG -02-38-027',NULL,'2009ApJS..182..474S',2009,1,2.5,NULL,'G',0.000013,NULL,'15.39',0.5,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,225.2502917,-15.12175,0.429,NULL,46694239503,729597492,11399960,15.39),(125915,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125915,32.74,0.2,35.3,57083,74.4,NULL,NULL,'MCG -02-38-027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125916,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125916,32.74,0.51,35.4,57083,NULL,NULL,NULL,'MCG -02-38-027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125917,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125917,32.96,0.43,39.1,57083,75,NULL,'3.6 micron, color corrected','MCG -02-38-027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125918,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125918,33.07,0.43,41.2,57083,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125919,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125919,37.33,0.46,293,57084,70,NULL,NULL,'2MASX J15010045+0441209',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.251875,4.68906,0.105,NULL,59337534196,927148971,14486702,17.4),(125920,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125920,37.58,0.46,328,57085,70,NULL,NULL,'2MASX J15010073+4434507',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'16.3g',0.43,NULL,NULL,NULL,NULL,NULL,1,225.253125,44.58061,0.045,NULL,59994382693,937412229,14647066,16.3),(125921,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125921,37.45,0.46,310,57086,70,NULL,NULL,'SDSS J150100.98+092153.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.254083,9.36472,0.069,NULL,59377250947,927769546,14496399,17.9),(125922,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125922,37.94,0.46,388,57087,70,NULL,NULL,'2MASX J15010124+2329147',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.255167,23.48742,0.141,NULL,59529096195,930142128,14533470,17.4),(125923,'BL Lac Luminosity','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125923,40.38,NULL,965,57088,NULL,NULL,NULL,'FBQS J150101.8+223806',0.235,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,':','16.79',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,225.257667,22.63511,0.085,NULL,59528817538,930137774,14533402,16.79),(125924,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125924,38.42,0.46,483,57089,70,NULL,NULL,'2MASX J15010231+0032149',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.259625,0.53728,0.141,NULL,59324346819,926942919,14483483,17.5),(125925,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125925,37.45,0.46,309,57090,70,NULL,NULL,'SDSS J150105.42+532908.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.272625,53.48569,0.013,NULL,59929246508,936394476,14631163,18.4),(125926,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125926,36.3,0.46,182,57091,70,NULL,NULL,'2MASX J15010565+0031499',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000075,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,225.2734583,0.53047,0.141,NULL,59324347142,926942924,14483483,16.4),(125927,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125927,35.67,0.33,136,57092,70,NULL,NULL,'2MASX J15010578+0607349',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.22',0.31,NULL,NULL,NULL,NULL,NULL,1,225.2740417,6.12628,0.089,NULL,59329531948,927023936,14484749,17.22),(125928,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125928,37.83,0.27,369,57093,70,NULL,NULL,'SDSS J150105.83+415354.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.274333,41.89839,0.033,NULL,59978899968,937170312,14643286,18.3),(125929,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125929,38.26,0.46,448,57094,70,NULL,NULL,'2MASX J15010708+1058225',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.279458333,10.97281,0.053,NULL,59375286486,927738851,14495919,17.8),(125930,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125930,35.34,0.52,117,57095,70,NULL,NULL,'2MASX J15010759-2210349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,225.281667,-22.17639,0.377,NULL,46642036419,728781819,11387215,16.45),(125931,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125931,27.93,0.04,3.85,57096,NULL,NULL,'I','ESO 223- G 009',NULL,'2009AJ....138..332J',2009,1,2.6,'Extended HIPASS source','G',0.000007,NULL,'14.8',2.4,'IAB(s)m;diff.sp.str','Group member',NULL,NULL,NULL,1,225.286125,-48.29047,NULL,NULL,47056080614,735251259,11488300,14.8),(125932,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125932,28.98,0.1,6.25,57096,NULL,NULL,NULL,'ESO 223- G 009',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125933,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125933,29,0.1,6.31,57096,74.4,NULL,NULL,'ESO 223- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125934,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125934,29.03,NULL,6.4,57096,NULL,NULL,NULL,'ESO 223- G 009',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125935,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125935,29.42,0.8,7.7,57096,75,NULL,NULL,'ESO 223- G 009',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125936,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125936,35.09,0.49,104,57097,70,NULL,NULL,'AM 1458-364 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,225.287333,-36.98547,0.241,NULL,47235236513,738050570,11532040,14.6),(125937,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125937,36.99,0.46,250,57098,70,NULL,NULL,'2MASX J15010892+1818167',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.9g',NULL,NULL,NULL,NULL,NULL,NULL,1,225.287375,18.30456,0.065,NULL,59588639957,931072499,14548007,17.9),(125938,'TRGB','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125938,30.17,0.1,10.8,57099,74.4,NULL,NULL,'UGC 09660',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000092,NULL,'14.2g',0.49,'Sm','Isolated galaxy',NULL,NULL,NULL,1,225.288667,44.69817,0.049,NULL,59994393550,937412399,14647068,14.2),(125939,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125939,29.35,NULL,7.41,57099,NULL,NULL,NULL,'UGC 09660',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125940,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125940,36.92,0.27,242,57100,70,NULL,NULL,'2MASX J15010949+2212576',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.08',0.23,NULL,NULL,NULL,NULL,NULL,1,225.2894583,22.21611,0.081,NULL,59528247382,930128865,14533263,17.08),(125941,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125941,37.75,0.46,355,57101,70,NULL,NULL,'2MASX J15011062+4759125',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.294417,47.98694,0.065,NULL,59940818788,936575293,14633988,18),(125942,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125942,32.5,0.12,31.6,57102,74.4,NULL,NULL,'NGC 5813',NULL,'2013AJ....146...86T',2013,1,4.2,NULL,'G',0.000017,NULL,'11.45',3,'E1-2           LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,225.296791667,1.70197,0.149,NULL,59328087997,927001374,14484396,11.45),(125943,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125943,32.53,0.18,32.1,57102,NULL,NULL,'Malmquist cor.','NGC 5813',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125944,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125944,32.54,0.18,32.2,57102,NULL,NULL,'I','NGC 5813',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125945,'SBF','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125945,32.54,0.18,32.2,57102,NULL,NULL,NULL,'NGC 5813',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125946,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125946,32.22,0.4,27.7,57102,75,NULL,'Edat, raw','NGC 5813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125947,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125947,32.37,0.4,29.7,57102,75,NULL,'Edat, cor','NGC 5813',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125948,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125948,30.83,0.55,14.7,57102,95,NULL,'de Vaucouleurs','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125949,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125949,31.71,0.3,22,57102,95,NULL,'Weighted Mean','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125950,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125950,31.96,NULL,24.7,57102,NULL,NULL,'LEDA [April 2006]','NGC 5813',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125951,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125951,32.54,0.46,32.2,57102,95,NULL,'Michard 1979a','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125952,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125952,32.91,0.63,38.2,57102,95,NULL,'Michard 1979b, c','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125953,'Faber-Jackson','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125953,33,0.81,39.8,57102,55,NULL,'Visvanathan & Sandage 1979','NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125954,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125954,32.32,0.41,29.1,57102,NULL,NULL,NULL,'NGC 5813',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125955,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125955,32.36,0.41,29.7,57102,NULL,NULL,'Malmquist cor.','NGC 5813',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125956,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125956,32.5,0.12,31.6,57102,74.4,NULL,NULL,'NGC 5813',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125957,'Tertiary','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125957,31.08,0.25,16.4,57102,95,NULL,NULL,'NGC 5813',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125958,'Tully est','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125958,32.27,0.8,28.5,57102,75,NULL,'B','NGC 5813',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125959,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125959,37.44,0.23,307,57103,70,NULL,NULL,'2MASX J15011134+3043260',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.297125,30.72381,0.025,NULL,60095328938,938989514,14671711,17.4),(125960,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125960,37.6,0.46,330,57104,70,NULL,NULL,'2MASX J15011169+4409205',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.2985417,44.15553,0.057,NULL,59993807125,937403236,14646925,18.2),(125961,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125961,37.76,0.46,356,57105,70,NULL,NULL,'2MASX J15011197+5448241',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000142,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.299667,54.80667,0,NULL,57579417656,899678400,14057475,17.3),(125962,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125962,37.91,0.16,381,57106,70,NULL,NULL,'2MASX J15011285+3216460',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.3035417,32.27931,0.017,NULL,60091826376,938934787,14670856,18.2),(125963,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125963,38.24,0.46,445,57107,70,NULL,NULL,'SDSS J150113.43+212858.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.306,21.48281,0.089,NULL,59541451117,930335173,14536487,18.6),(125964,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125964,32.91,0.4,38.2,57108,75,NULL,'B','UGC 09663',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'14.9',1.3,'Im:',NULL,NULL,NULL,NULL,1,225.307083,52.59556,0.021,NULL,59932194987,936440546,14631883,14.9),(125965,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125965,33.68,0.54,54.5,57109,70,NULL,NULL,'AM 1458-364 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000117,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,225.309667,-36.9385,0.241,NULL,47233387839,738021684,11531588,15.5),(125966,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125966,38.29,0.46,454,57110,70,NULL,NULL,'2MASX J15011461+0541099',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.3107083,5.68625,0.113,NULL,59336968664,927140135,14486564,17.7),(125967,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125967,37.72,0.46,349,57111,70,NULL,NULL,'2MASX J15011605+3034569',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.317083333,30.58267,0.029,NULL,60095296498,938989007,14671703,18),(125968,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125968,35.84,0.33,147,57112,70,NULL,NULL,'2MASX J15011770+0153039',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.0g',0.29,'E0',NULL,NULL,NULL,NULL,1,225.323667,1.88461,0.137,NULL,59328106123,927001658,14484400,16),(125969,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125969,35.86,0.46,149,57113,70,NULL,NULL,'CGCG 105-092',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.7',0.36,NULL,NULL,NULL,NULL,NULL,1,225.325417,16.77794,0.029,NULL,59592049458,931125772,14548840,15.7),(125970,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125970,33.77,0.49,56.7,57114,75,NULL,'IR','UGC 09656',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00004,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,225.3330417,9.15097,0.069,NULL,59388516402,927945568,14499149,15.2),(125971,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125971,33.49,0.2,49.9,57115,74.4,NULL,NULL,'UGC 09656',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00004,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,225.3330417,9.15097,0.069,NULL,59388516402,927945568,14499149,15.2),(125972,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125972,37.91,0.13,382,57116,70,NULL,NULL,'SDSS J150121.14+472235.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.338083,47.37656,0.077,NULL,59983848807,937247637,14644494,18.6),(125973,'IRAS','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125973,34.98,0.8,99.1,57117,75,NULL,'MAT, I','ESO 328- G 003',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.16',0.3,'Sb:',NULL,NULL,NULL,NULL,1,225.338416667,-39.74917,0.141,NULL,47232158793,738002481,11531288,13.16),(125974,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125974,35.16,0.49,108,57117,75,NULL,'IR','ESO 328- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125975,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125975,35.16,0.43,108,57117,75,NULL,'MAT, I, raw','ESO 328- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125976,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125976,35.2,0.32,109,57117,85,NULL,'I, raw','ESO 328- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125977,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125977,35.22,0.4,111,57117,NULL,NULL,'mean','ESO 328- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125978,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125978,35.24,0.45,112,57117,NULL,NULL,'Malmquist cor.','ESO 328- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125979,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125979,35.27,0.32,113,57117,85,NULL,'I, inv','ESO 328- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125980,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125980,35.26,0.47,113,57117,NULL,NULL,'H','ESO 328- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125981,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125981,35.35,0.43,117,57117,NULL,NULL,NULL,'ESO 328- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125982,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125982,35.37,0.45,119,57117,NULL,NULL,'K','ESO 328- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125983,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125983,35.39,0.2,120,57117,74.4,NULL,NULL,'ESO 328- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125984,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125984,35.43,0.43,122,57117,75,NULL,'MAT, I, cor','ESO 328- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125985,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,125985,35.45,0.43,123,57117,75,NULL,'MAT, I, inv','ESO 328- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(125986,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125986,38.04,0.46,405,57118,70,NULL,NULL,'2MASX J15012116+2507015',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.338333,25.11717,0.101,NULL,59408186236,928252909,14503951,17.9),(125987,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125987,37.91,0.13,382,57119,70,NULL,NULL,'2MASX J15012125+4725565',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.338583333,47.43244,0.077,NULL,59983852453,937247694,14644495,17.3),(125988,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125988,37.91,0.16,381,57120,70,NULL,NULL,'2MASX J15012276+3209379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.34475,32.16067,0.005,NULL,60091943672,938936619,14670884,17.6),(125989,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125989,37.5,0.46,316,57121,70,NULL,NULL,'2MASX J15012282+0915031',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.06',0.13,NULL,NULL,NULL,NULL,NULL,1,225.345167,9.25078,0.069,NULL,59377217050,927769016,14496390,19.06),(125990,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125990,37.4,0.46,303,57122,70,NULL,NULL,'2MASX J15012328+4200195',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.3469583,42.0055,0.033,NULL,59978937066,937170891,14643295,17.7),(125991,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125991,37.83,0.27,369,57123,70,NULL,NULL,'SDSS J150123.47+415001.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,225.347833,41.83369,0.037,NULL,59978907387,937170427,14643287,18.3),(125992,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125992,37.44,0.23,307,57124,70,NULL,NULL,'2MASX J15012445+3043489',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.52',0.14,NULL,NULL,NULL,NULL,NULL,1,225.351916667,30.73019,0.025,NULL,60095331225,938989550,14671711,18.52),(125993,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125993,37.15,0.46,269,57125,70,NULL,NULL,'2MASX J15012553+2232196',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.52',0.15,NULL,NULL,NULL,NULL,NULL,1,225.3564583,22.53875,0.085,NULL,59528820772,930137824,14533403,18.52),(125994,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125994,37.73,0.46,352,57126,70,NULL,NULL,'2MASX J15012563+2026196',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.12,NULL,NULL,NULL,NULL,NULL,1,225.357,20.43869,0.073,NULL,59541974564,930343352,14536614,18.42),(125995,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125995,38.56,0.46,516,57127,70,NULL,NULL,'2MASX J15012587+4513065',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.357917,45.21844,0.021,NULL,59995211396,937425178,14647268,17.6),(125996,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125996,37.74,0.27,353,57128,70,NULL,NULL,'2MASX J15012707+3120119',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.3627083,31.33661,0.021,NULL,60092400573,938943758,14670996,17.6),(125997,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125997,37.91,0.46,383,57129,70,NULL,NULL,'2MASX J15012724+5307576',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000184,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.363375,53.13272,0.021,NULL,59928927323,936389489,14631085,16.9),(125998,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125998,37.47,0.46,312,57130,70,NULL,NULL,'SDSS J150131.15+243655.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.3797917,24.6155,0.097,NULL,59525754533,930089914,14532654,18.3),(125999,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',125999,38.21,0.46,438,57131,70,NULL,NULL,'2MASX J15013132+2536316',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.3805,25.60875,0.077,NULL,59894875241,935857425,14622772,18.1),(126000,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126000,31.91,0.4,24.1,57132,75,NULL,NULL,'UGC 09665',NULL,'2008Ap.....51..336K',2008,1,1.83,'HOLM 691B is a star.','G',0.0001,NULL,'14.2g',0.42,'Sbc',NULL,NULL,NULL,NULL,1,225.38525,48.31975,0.037,NULL,59940928654,936577010,14634015,14.2),(126001,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126001,32.62,0.43,33.5,57132,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09665',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126002,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126002,32.82,0.43,36.7,57132,75,NULL,'3.6 micron, color corrected','UGC 09665',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126003,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126003,32.9,0.49,38,57132,75,NULL,'IR','UGC 09665',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126004,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126004,32.9,0.47,38.1,57132,NULL,NULL,'H','UGC 09665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126005,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126005,32.98,0.45,39.4,57132,NULL,NULL,'K','UGC 09665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126006,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126006,33.02,0.4,40.1,57132,NULL,NULL,'mean','UGC 09665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126007,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126007,33.05,0.46,40.7,57132,NULL,NULL,'J','UGC 09665',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126008,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126008,33.05,0.2,40.7,57132,74.4,NULL,NULL,'UGC 09665',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126009,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126009,36.3,0.46,182,57133,70,NULL,NULL,'2MASX J15013565+0156514',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000083,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.398583,1.94772,0.137,NULL,59328002914,927000045,14484375,16.9),(126010,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126010,36.78,0.46,227,57134,70,NULL,NULL,'2MASX J15013582+2352557',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.22',0.17,NULL,NULL,NULL,NULL,NULL,1,225.399291667,23.88222,0.105,NULL,59526262309,930097848,14532778,18.22),(126011,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126011,36.92,0.27,242,57135,70,NULL,NULL,'2MASX J15013613+2208446',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'16.45',0.23,NULL,NULL,NULL,NULL,NULL,1,225.400708333,22.14561,0.093,NULL,59528206270,930128222,14533253,16.45),(126012,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126012,37.74,0.27,353,57136,70,NULL,NULL,'2MASX J15013632+3119172',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.401291667,31.32156,0.021,NULL,60092517647,938945588,14671024,18.1),(126013,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126013,38.11,0.46,418,57137,70,NULL,NULL,'2MASX J15013633+2659537',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.401417,26.99828,0.081,NULL,60079583467,938743491,14667867,18),(126014,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126014,38.29,0.46,455,57138,70,NULL,NULL,'SDSS J150137.54+003726.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.4064583,0.62406,0.177,NULL,59324313347,926942396,14483474,17.9),(126015,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126015,37.11,0.46,265,57139,70,NULL,NULL,'2MASX J15013907+3216292',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.412875,32.27486,0.017,NULL,60084684326,938823192,14669112,17.9),(126016,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126016,38.08,0.46,412,57140,70,NULL,NULL,'2MASX J15013968+3326562',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.415291667,33.44886,0.021,NULL,60126515721,939476808,14679325,16.7),(126017,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126017,37.63,0.46,335,57141,70,NULL,NULL,'2MASXi J1501397-022422',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.41575,-2.40639,0.229,NULL,46442556560,725664946,11338514,17.9),(126018,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126018,37.31,0.46,290,57142,70,NULL,NULL,'2MASX J15014074+5542540',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.4199583,55.71503,0.017,NULL,57713979852,901780935,14090327,17.4),(126019,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126019,32.75,0.4,35.5,57143,75,NULL,'Edat, raw','ESO 581- G 016',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000143,NULL,'13.68',0.6,'E6:',NULL,NULL,NULL,NULL,1,225.424375,-19.29003,0.337,NULL,46646017986,728844031,11388187,13.68),(126020,'D-Sigma','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126020,32.86,0.4,37.3,57143,75,NULL,'Edat, cor','ESO 581- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126021,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126021,32.66,0.48,34,57143,70,NULL,NULL,'ESO 581- G 016',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126022,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126022,33.69,0.45,54.8,57143,NULL,NULL,'K','ESO 581- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126023,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126023,33.88,0.4,59.7,57143,NULL,NULL,'mean','ESO 581- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126024,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126024,37.95,0.33,390,57144,70,NULL,NULL,'2MASX J15014205+5231466',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.425125,52.52964,0.021,NULL,59931705921,936432905,14631764,17.4),(126025,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126025,37.91,0.16,381,57145,70,NULL,NULL,'2MASX J15014223+3213012',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.426083,32.217,0.017,NULL,60084554998,938821171,14669080,17.8),(126026,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126026,37.51,0.46,318,57146,70,NULL,NULL,'2MASX J15014264+2539317',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.42775,25.65883,0.065,NULL,59894887929,935857623,14622775,17.3),(126027,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126027,37.91,0.46,382,57147,70,NULL,NULL,'2MASX J15014266+3359162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000189,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.427875,33.98792,0.013,NULL,60127340231,939489691,14679526,17.3),(126028,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126028,35.88,0.46,150,57148,70,NULL,NULL,'2MASX J15014311+0057444',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.429583,0.96231,0.169,NULL,59324682355,926948161,14483565,16.9),(126029,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126029,37.25,0.46,282,57149,70,NULL,NULL,'2MASX J15014337+2007126',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.60',0.14,NULL,NULL,NULL,NULL,NULL,1,225.4307083,20.12028,0.077,NULL,59538619954,930290936,14535795,18.6),(126030,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126030,38.2,0.46,437,57150,70,NULL,NULL,'2MASX J15014342+1519323',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.431,15.32556,0.037,NULL,59577442968,930897546,14545274,18.1),(126031,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126031,35.2,0.46,110,57151,70,NULL,NULL,'CGCG 105-094',NULL,'2015arXiv151105856S',2015,1,0.45,'IRAS F14591+1603 is the large proper-motion star HD 132950 (V=9.2).','G',NULL,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,225.4329583,15.86469,0.021,NULL,59591318683,931114354,14548661,15.7),(126032,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126032,37.8,0.46,362,57152,70,NULL,NULL,'SDSS J150144.71+193948.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.4362917,19.6635,0.069,NULL,59539077085,930298079,14535907,18.3),(126033,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126033,34.97,0.75,98.8,57153,70,NULL,NULL,'LCRS B145907.9-034331',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.83',0.4,NULL,NULL,NULL,NULL,NULL,1,225.436791667,-3.92172,0.257,NULL,46455928648,725873885,11341779,15.83),(126034,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126034,37.91,0.13,382,57154,70,NULL,NULL,'2MASX J15014501+4708155',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.4374583,47.13767,0.077,NULL,59984020341,937250317,14644536,18.2),(126035,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126035,37.74,0.27,353,57155,70,NULL,NULL,'2MASX J15014522+3117232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.42',0.11,NULL,NULL,NULL,NULL,NULL,1,225.438417,31.28989,0.017,NULL,60092517060,938945579,14671024,18.42),(126036,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126036,36.27,0.46,180,57156,70,NULL,NULL,'2MASX J15014521+0000311',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000114,NULL,'15.4g',0.52,'E0',NULL,NULL,NULL,NULL,1,225.4385,0.00847,0.137,NULL,56371558438,880805600,13762587,15.4),(126037,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126037,36.7,0.46,218,57157,70,NULL,NULL,'2MASX J15014524+2855337',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'18.06',0.17,'E',NULL,NULL,NULL,NULL,1,225.438583,28.92608,0.033,NULL,60080568636,938758884,14668107,18.06),(126038,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126038,37.75,0.46,355,57158,70,NULL,NULL,'2MASX J15014536+4644385',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.4389583,46.74386,0.037,NULL,59991316132,937364314,14646317,18.1),(126039,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126039,37.62,0.46,334,57159,70,NULL,NULL,'SDSS J150149.52+574723.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000064,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.456375,57.78992,0.009,NULL,57730298729,902035917,14094311,17.7),(126040,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126040,37.95,0.33,390,57160,70,NULL,NULL,'2MASX J15015014+5229056',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000146,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.458875,52.48483,0.025,NULL,59932295202,936442112,14631908,17.4),(126041,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126041,36.65,0.46,213,57161,70,NULL,NULL,'2MASX J15015016+0659153',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.459125,6.98761,0.053,NULL,59388082317,927938786,14499043,16.4),(126042,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126042,36.19,0.46,173,57162,70,NULL,NULL,'2MASX J15015110+0931033',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.04',0.24,NULL,NULL,NULL,NULL,NULL,1,225.462875,9.51764,0.057,NULL,59377407153,927771986,14496437,18.04),(126043,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126043,35.83,0.46,147,57163,70,NULL,NULL,'2MASX J15015170+0943333',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.70',0.28,NULL,NULL,NULL,NULL,NULL,1,225.465375,9.72594,0.061,NULL,59377348627,927771072,14496423,17.7),(126044,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126044,37.68,0.46,344,57164,70,NULL,NULL,'SDSS J150151.99+263934.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.466667,26.6595,0.101,NULL,60079683822,938745059,14667891,18.2),(126045,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126045,36.66,0.46,215,57165,70,NULL,NULL,'2MASX J15015229+1742283',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000153,NULL,'16.66',0.38,NULL,NULL,NULL,NULL,NULL,1,225.467917,17.70783,0.049,NULL,59589095500,931079617,14548119,16.66),(126046,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126046,37.44,0.23,307,57166,70,NULL,NULL,'2MASX J15015295+3048132',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.73',0.14,NULL,NULL,NULL,NULL,NULL,1,225.4707083,30.80378,0.033,NULL,60095314298,938989285,14671707,18.73),(126047,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126047,37.75,0.46,354,57167,70,NULL,NULL,'2MASX J15015349+3036172',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.472875,30.60481,0.025,NULL,60095406319,938990723,14671730,17.8),(126048,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126048,34.86,0.47,93.8,57168,NULL,NULL,'H','NGC 5827',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00004,NULL,'13.91',0.9,'Sab pec:       LINER','Field galaxy',NULL,NULL,NULL,1,225.473875,25.96453,0.089,NULL,59894796422,935856194,14622753,13.91),(126049,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126049,34.9,0.45,95.4,57168,NULL,NULL,'K','NGC 5827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126050,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126050,34.9,0.46,95.6,57168,NULL,NULL,'J','NGC 5827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126051,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126051,34.98,0.4,99.1,57168,NULL,NULL,'mean','NGC 5827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126052,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126052,38.1,0.46,417,57169,70,NULL,NULL,'2MASX J15015403+1132133',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.475167,11.53717,0.077,NULL,59375423357,927740989,14495952,17.1),(126053,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126053,37.44,0.23,307,57170,70,NULL,NULL,'2MASX J15015426+3045262',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,225.476125,30.75744,0.033,NULL,60095315669,938989307,14671707,17.97),(126054,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126054,38.22,0.46,440,57171,70,NULL,NULL,'2MASX J15015455+0330370',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00009,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.477333333,3.51017,0.125,NULL,59339593708,927181151,14487205,17.4),(126055,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126055,37.07,0.46,259,57172,70,NULL,NULL,'2MASX J15015667+4159088',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000144,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.48625,41.98569,0.033,NULL,59978918786,937170606,14643290,17.3),(126056,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126056,37.91,0.13,382,57173,70,NULL,NULL,'SDSS J150156.78+471441.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.486583,47.24486,0.077,NULL,59983820902,937247201,14644487,18.4),(126057,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126057,37.42,0.46,304,57174,70,NULL,NULL,'2MASX J15015864+2911138',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.18',0.15,'E',NULL,NULL,NULL,NULL,1,225.49425,29.18714,0.037,NULL,60094653326,938978958,14671546,18.18),(126058,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126058,36.18,0.33,172,57175,70,NULL,NULL,'2MASX J15015919+4722078',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.496583,47.36883,0.077,NULL,59983843225,937247550,14644492,17),(126059,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126059,38.14,0.46,424,57176,70,NULL,NULL,'SDSS J150159.58+034520.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000079,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.49825,3.75558,0.121,NULL,59339573114,927180829,14487200,18.5),(126060,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126060,37.98,0.46,394,57177,70,NULL,NULL,'2MASX J15020091+2801228',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.37',0.14,NULL,NULL,NULL,NULL,NULL,1,225.503833,28.02294,0.041,NULL,60083210233,938800159,14668752,18.37),(126061,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126061,37.38,0.46,299,57178,70,NULL,NULL,'2MASX J15020092+2322477',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.504083,23.38003,0.141,NULL,59529221801,930144090,14533501,17.9),(126062,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126062,37.45,0.33,309,57179,70,NULL,NULL,'2MASX J15020110+2859498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.48',0.14,NULL,NULL,NULL,NULL,NULL,1,225.5045,28.99722,0.033,NULL,60094434255,938975535,14671492,18.48),(126063,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126063,36.89,0.46,239,57180,70,NULL,NULL,'2MASX J15020164+0924283',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.19',0.22,NULL,NULL,NULL,NULL,NULL,1,225.50675,9.40786,0.053,NULL,59377429182,927772330,14496442,18.19),(126064,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126064,37.64,0.33,338,57181,70,NULL,NULL,'2MASX J15020231+2253377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.50',0.18,NULL,NULL,NULL,NULL,NULL,1,225.50975,22.89381,0.109,NULL,59529626968,930150421,14533600,17.5),(126065,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126065,36.18,0.33,172,57182,70,NULL,NULL,'2MASX J15020255+4713488',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000183,NULL,'15.8g',0.25,'Sa',NULL,NULL,NULL,NULL,1,225.510625,47.23036,0.077,NULL,59984028683,937250448,14644538,15.8),(126066,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126066,37.17,0.17,272,57183,70,NULL,NULL,'CGCG 134-067',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00021,NULL,'15.2',0.6,NULL,NULL,NULL,NULL,NULL,1,225.51325,21.32694,0.085,NULL,59541423140,930334736,14536480,15.2),(126067,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126067,37.29,0.46,287,57184,70,NULL,NULL,'2MASX J15020415+0454080',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.517416667,4.90222,0.105,NULL,59337594658,927149916,14486717,16.6),(126068,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126068,37.17,0.17,272,57185,70,NULL,NULL,'2MASX J15020615+2116227',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.63',0.12,NULL,NULL,NULL,NULL,NULL,1,225.525667,21.27297,0.085,NULL,59541425912,930334779,14536480,18.63),(126069,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126069,37.38,0.46,299,57186,70,NULL,NULL,'2MASX J15020850+3726022',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000198,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.535625,37.43406,0.029,NULL,60120185436,939377897,14677779,17.1),(126070,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126070,36.18,0.46,172,57187,70,NULL,NULL,'2MASX J15020891+4409388',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,225.537041667,44.16097,0.041,NULL,59993800820,937403137,14646924,16.9),(126071,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126071,37.91,0.13,382,57188,70,NULL,NULL,'2MASX J15021001+4717119',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.541625,47.28658,0.077,NULL,59983813951,937247092,14644485,18),(126072,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126072,37.17,0.17,272,57189,70,NULL,NULL,'2MASX J15021016+2123437',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.31',0.15,NULL,NULL,NULL,NULL,NULL,1,225.542333,21.39547,0.089,NULL,59539532331,930305192,14536018,18.31),(126073,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126073,37.04,0.46,256,57190,70,NULL,NULL,'2MASX J15021049+2516188',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.70',0.18,NULL,NULL,NULL,NULL,NULL,1,225.543917,25.27181,0.097,NULL,59894677965,935854343,14622724,17.7),(126074,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126074,37.14,0.46,268,57191,70,NULL,NULL,'2MASX J15021107+5040373',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000175,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.546,50.67719,0.009,NULL,59942211485,936597054,14634328,16.5),(126075,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126075,36.92,0.27,242,57192,70,NULL,NULL,'SDSS J150212.68+220554.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.552875,22.09858,0.093,NULL,59528415505,930131492,14533304,18.2),(126076,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126076,35.9,0.46,151,57193,70,NULL,NULL,'2MASX J15021284+1628034',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.553583333,16.46772,0.025,NULL,59592019015,931125297,14548832,16.4),(126077,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126077,35.18,0.46,109,57194,70,NULL,NULL,'CGCG 164-054',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'15.7g',0.31,'Sa',NULL,NULL,NULL,NULL,1,225.55775,32.12947,0.037,NULL,60084574433,938821475,14669085,15.7),(126078,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126078,36.91,0.46,241,57195,70,NULL,NULL,'SDSS J150219.87+530406.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.582833,53.06833,0.029,NULL,59928892449,936388944,14631077,17.8),(126079,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126079,37.52,0.46,319,57196,70,NULL,NULL,'LCRS B145944.3-023259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00026,NULL,'17.13',0.14,NULL,NULL,NULL,NULL,NULL,1,225.5842917,-2.74558,0.237,NULL,46442211740,725659558,11338430,17.13),(126080,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126080,37.62,0.46,335,57197,70,NULL,NULL,'2MASX J15022040+2801578',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0',0.19,NULL,NULL,NULL,NULL,NULL,1,225.585083,28.03289,0.041,NULL,60083209132,938800142,14668752,18),(126081,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126081,36.55,0.46,205,57198,70,NULL,NULL,'2MASX J15022251+1156191',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.593916667,11.93872,0.073,NULL,59345294099,927270220,14488597,16.5),(126082,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126082,37.66,0.46,341,57199,70,NULL,NULL,'2MASX J15022258+1536262',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.39',0.15,NULL,NULL,NULL,NULL,NULL,1,225.594125,15.60722,0.029,NULL,59591197270,931112457,14548632,18.39),(126083,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126083,37.27,0.46,285,57200,70,NULL,NULL,'2MASX J15022317+4906453',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.596667,49.11261,0.013,NULL,59941146761,936580418,14634069,17.1),(126084,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126084,36.12,0.2,167,57201,74.4,NULL,NULL,'CGCG 076-137',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000155,NULL,'15.4g',0.42,NULL,NULL,NULL,NULL,NULL,1,225.5992917,11.20636,0.061,NULL,59375198855,927737482,14495898,15.4),(126085,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126085,36.75,0.46,223,57202,70,NULL,NULL,'2MASX J15022413+0820551',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.84',0.12,NULL,NULL,NULL,NULL,NULL,1,225.6004583,8.34864,0.045,NULL,59390899335,927982802,14499731,18.84),(126086,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126086,35.77,0.33,142,57203,70,NULL,NULL,'CGCG 105-096',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'15.7',0.35,NULL,NULL,NULL,NULL,NULL,1,225.6015417,16.19822,0.021,NULL,59591240597,931113134,14548642,15.7),(126087,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126087,37.26,0.46,283,57204,70,NULL,NULL,'2MASX J15022435+1152151',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.601583,11.87083,0.073,NULL,59345324146,927270689,14488604,17.9),(126088,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126088,37.8,0.46,363,57205,70,NULL,NULL,'2MASX J15022455-0122560',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.602417,-1.38211,0.165,NULL,46440078459,725626225,11337909,17),(126089,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126089,37.86,0.27,373,57206,70,NULL,NULL,'2MASX J15022456+3412416',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,225.6024583,34.21142,0.009,NULL,60126863074,939482235,14679409,16.7),(126090,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126090,37.64,0.33,338,57207,70,NULL,NULL,'SDSS J150224.80+225407.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.67',0.13,NULL,NULL,NULL,NULL,NULL,1,225.603375,22.90208,0.113,NULL,59529104988,930142265,14533472,18.67),(126091,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126091,37.91,0.46,382,57208,70,NULL,NULL,'2MASX J15022750+1944070',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.13',0.19,NULL,NULL,NULL,NULL,NULL,1,225.614583,19.73519,0.065,NULL,59538553720,930289901,14535779,18.13),(126092,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126092,37.39,0.46,301,57209,70,NULL,NULL,'2MASX J15022889+1835320',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.620333,18.59239,0.061,NULL,59581392200,930959253,14546238,17.9),(126093,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126093,38.24,0.46,445,57210,70,NULL,NULL,'SDSS J150230.80+294408.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,225.628333,29.73558,0.037,NULL,60094558983,938977484,14671523,NULL),(126094,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126094,37.87,0.11,375,57211,70,NULL,NULL,'2MASX J15023168+0732231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.6322083,7.53989,0.037,NULL,59387653858,927932091,14498938,17.8),(126095,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126095,37.17,0.17,272,57212,70,NULL,NULL,'2MASX J15023182+2146340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.27',0.18,NULL,NULL,NULL,NULL,NULL,1,225.632625,21.77611,0.093,NULL,59539712745,930308011,14536062,17.27),(126096,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126096,35.77,0.33,142,57213,70,NULL,NULL,'2MASX J15023247+1614352',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.64',0.25,NULL,NULL,NULL,NULL,NULL,1,225.635208333,16.24317,0.021,NULL,59591239436,931113116,14548642,17.64),(126097,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126097,36.7,0.33,218,57214,70,NULL,NULL,'2MASX J15023772+4532015',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,225.657,45.53364,0.045,NULL,59994771964,937418311,14647161,16.2),(126098,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126098,36.2,0.46,174,57215,70,NULL,NULL,'2MASX J15023773+2413562',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000099,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.657208333,24.23222,0.093,NULL,59526207025,930096984,14532765,16.8),(126099,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126099,36.7,0.33,218,57216,70,NULL,NULL,'2MASX J15023802+4527145',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.6585,45.45414,0.045,NULL,59994789620,937418587,14647165,17.9),(126100,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126100,37.17,0.17,272,57217,70,NULL,NULL,'2MASX J15023981+2114349',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.665833,21.24314,0.085,NULL,59539982046,930312219,14536128,17.8),(126101,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126101,36.44,0.46,194,57218,70,NULL,NULL,'2MASX J15024108-0106210',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.6712083,-1.10592,0.157,NULL,46439970484,725624538,11337883,16.9),(126102,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126102,38.96,0.46,620,57219,70,NULL,NULL,'2MASX J15024185+1452451',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.674417,14.87925,0.033,NULL,59577738659,930902166,14545346,18.4),(126103,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126103,37.74,0.19,354,57220,70,NULL,NULL,'2MASX J15024182+2713412',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'15.83',0.15,NULL,NULL,NULL,NULL,NULL,1,225.674417,27.22808,0.073,NULL,60083108051,938798563,14668727,15.83),(126104,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126104,33.25,0.68,44.6,57221,NULL,NULL,NULL,'NGC 5829',NULL,'2009ApJS..182..474S',2009,1,1.43,NULL,'G',0.000023,NULL,'14.1g',1.02,'SA(s)c         HII','Pair member (points to parent)',NULL,NULL,NULL,1,225.6750417,23.33361,0.141,NULL,59529195569,930143680,14533495,14.1),(126105,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126105,33.29,0.2,45.5,57221,74.4,NULL,NULL,'NGC 5829',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126106,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126106,33.64,0.56,53.4,57221,NULL,NULL,'Malmquist cor.','NGC 5829',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126107,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126107,35.2,0.46,109,57222,70,NULL,NULL,'CGCG 193-013',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000093,NULL,'15.0g',0.58,'E0',NULL,NULL,NULL,NULL,1,225.678916667,37.94936,0.013,NULL,60120567854,939383872,14677873,15),(126108,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126108,35.58,0.33,131,57223,70,NULL,NULL,'IC 1085',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000193,NULL,'15.0',1.2,NULL,NULL,NULL,NULL,NULL,1,225.6807083,17.25253,0.017,NULL,59589048840,931078888,14548107,15),(126109,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126109,38.12,0.23,421,57224,70,NULL,NULL,'2MASX J15024377+3559487',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.68225,35.99686,0,NULL,60127822479,939497226,14679644,18.1),(126110,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126110,37.91,0.13,382,57225,70,NULL,NULL,'2MASX J15024426+4722425',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.6845,47.37858,0.077,NULL,59984010581,937250165,14644533,17.4),(126111,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126111,37.17,0.17,272,57226,70,NULL,NULL,'2MASX J15024541+2122141',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.65',0.19,NULL,NULL,NULL,NULL,NULL,1,225.6892917,21.37067,0.089,NULL,59539990248,930312347,14536130,17.65),(126112,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126112,37.45,0.33,309,57227,70,NULL,NULL,'2MASX J15024611+2855493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.6922917,28.93028,0.033,NULL,60080672342,938760505,14668132,17.8),(126113,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126113,37.26,0.46,283,57228,70,NULL,NULL,'LCRS B150010.3-023801',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000124,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.692917,-2.829,0.237,NULL,46442160613,725658759,11338418,18.1),(126114,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126114,38.13,0.46,423,57229,70,NULL,NULL,'SDSS J150246.53-011921.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000178,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,225.693917,-1.32269,0.193,NULL,46439878844,725623106,11337861,18.6),(126115,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126115,38.12,0.23,421,57230,70,NULL,NULL,'2MASX J15024831+3554158',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.7014583,35.9045,0,NULL,60127835778,939497434,14679647,17.8),(126116,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126116,37.99,0.46,396,57231,70,NULL,NULL,'SDSS J150249.57+242537.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.706583333,24.42708,0.089,NULL,59408518060,928258094,14504032,18.6),(126117,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126117,36.43,0.46,193,57232,70,NULL,NULL,'2MASX J15024985+2321351',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.00',0.2,'S0','Compact group member',NULL,NULL,NULL,1,225.70775,23.35975,0.141,NULL,59529189146,930143580,14533493,17),(126118,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126118,37.74,0.19,354,57233,70,NULL,NULL,'2MASX J15025007+2659253',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.7087083,26.99028,0.081,NULL,60079495203,938742112,14667845,17.8),(126119,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126119,37.87,0.11,375,57234,70,NULL,NULL,'2MASX J15025066+0805357',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000167,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.711167,8.09342,0.045,NULL,59390921559,927983149,14499736,17),(126120,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126120,37.87,0.11,375,57235,70,NULL,NULL,'2MASX J15025133+0808357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.714125,8.14325,0.045,NULL,59390933700,927983339,14499739,17.2),(126121,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126121,37.39,0.46,301,57236,70,NULL,NULL,'SDSS J150252.30+300051.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.717958333,30.01417,0.029,NULL,60094220436,938972194,14671440,17.5),(126122,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126122,37.89,0.21,378,57237,70,NULL,NULL,'2MASX J15025342+0847357',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.7225,8.79311,0.053,NULL,59388556585,927946196,14499159,17.1),(126123,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126123,35.21,0.51,110,57238,70,NULL,NULL,'2MASX J15025374-4236395',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,225.724041667,-42.61094,0.377,NULL,47097233800,735894278,11498348,14.3),(126124,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126124,36.27,0.33,179,57239,70,NULL,NULL,'2MASX J15025512+5535389',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000162,NULL,'15.9g',0.41,'S0',NULL,NULL,NULL,NULL,1,225.729958333,55.59408,0.029,NULL,57714058842,901782169,14090346,15.9),(126125,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126125,33.44,NULL,48.8,57240,NULL,NULL,NULL,'FGC 1845',NULL,'2000BSAO...50....5K',2000,1,1.46,NULL,'G',0.00002,NULL,'16.3',0.11,'Sdm',NULL,NULL,NULL,NULL,1,225.73,-13.32833,0.401,NULL,46662083555,729095055,11392110,16.3),(126126,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126126,33.48,NULL,49.6,57240,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126127,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126127,33.48,NULL,49.8,57240,NULL,NULL,'Dipole + Quadrupole','FGC 1845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126128,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126128,33.49,NULL,49.8,57240,NULL,NULL,'Dipole','FGC 1845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126129,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126129,38.13,0.46,423,57241,70,NULL,NULL,'2MASX J15025523+5533409',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.7302083,55.56131,0.029,NULL,57714059831,901782184,14090346,17.3),(126130,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126130,35.42,0.46,121,57242,70,NULL,NULL,'2MASX J15025541-0211107',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00015,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,225.730875,-2.18633,0.213,NULL,46441769061,725652641,11338322,15.7),(126131,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126131,38.36,0.46,470,57243,70,NULL,NULL,'SDSS J150255.94+105638.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.733125,10.944,0.061,NULL,59375144492,927736632,14495884,18.5),(126132,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126132,37.86,0.27,373,57244,70,NULL,NULL,'2MASX J15025688+3408538',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00014,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,225.737125,34.14831,0.009,NULL,60126810679,939481416,14679397,16.1),(126133,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126133,36.03,0.46,160,57245,70,NULL,NULL,'2MASX J15025695+1108067',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000175,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,225.737166667,11.13533,0.061,NULL,59375324180,927739440,14495928,16.1),(126134,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126134,37.02,0.46,254,57246,70,NULL,NULL,'2MASX J15025730+2850373',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000397,NULL,'17.60',0.22,'E',NULL,NULL,NULL,NULL,1,225.738791667,28.84367,0.033,NULL,60080675781,938760559,14668133,17.6),(126135,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126135,37.99,0.46,397,57247,70,NULL,NULL,'2MASX J15025770+3401528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.740375,34.03136,0.013,NULL,60126852105,939482064,14679407,17.3),(126136,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126136,38.06,0.46,409,57248,70,NULL,NULL,'2MASX J15025805+5359409',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.7417917,53.99483,0.005,NULL,59928354083,936380532,14630945,17.6),(126137,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126137,38.41,0.46,480,57249,70,NULL,NULL,'2MASX J15025883+5012330',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,225.7452917,50.20903,0,NULL,59944800183,936637502,14634960,18.4),(126138,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126138,38.44,0.46,488,57250,70,NULL,NULL,'SDSS J150259.16+215537.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.746541667,21.92719,0.093,NULL,59539609086,930306391,14536037,17.8),(126139,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126139,37.91,0.46,381,57251,70,NULL,NULL,'2MASX J15025912+3311498',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.746541667,33.19725,0.017,NULL,60115065116,939297892,14676529,17.5),(126140,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126140,32.25,0.5,28.2,57252,70,NULL,NULL,'MCG -02-38-030',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000017,NULL,'14.54',0.4,'Sa? sp',NULL,NULL,NULL,NULL,1,225.750833,-13.28267,0.373,NULL,46662085028,729095078,11392110,14.54),(126141,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126141,31.45,0.47,19.5,57252,NULL,NULL,'H','MCG -02-38-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126142,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126142,31.63,0.45,21.1,57252,NULL,NULL,'K','MCG -02-38-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126143,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126143,31.67,0.46,21.5,57252,NULL,NULL,'J','MCG -02-38-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126144,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126144,32.69,0.4,34.5,57252,NULL,NULL,'mean','MCG -02-38-030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126145,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126145,38.12,0.23,421,57253,70,NULL,NULL,'2MASX J15030132+3553188',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,225.755458333,35.88858,0,NULL,60127831853,939497372,14679646,17.3),(126146,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126146,37.17,0.17,272,57254,70,NULL,NULL,'2MASX J15030146+2130431',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.58',0.23,NULL,NULL,NULL,NULL,NULL,1,225.7562083,21.51189,0.089,NULL,59539547961,930305436,14536022,16.58),(126147,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126147,38.17,0.33,431,57255,70,NULL,NULL,'SDSS J150302.12+093212.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.758833,9.53667,0.061,NULL,59377271819,927769872,14496404,18),(126148,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126148,37.87,0.11,375,57256,70,NULL,NULL,'2MASX J15030236+0732317',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.759875,7.54214,0.033,NULL,59387464344,927929130,14498892,16.8),(126149,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126149,38.17,0.33,431,57257,70,NULL,NULL,'SDSS J150304.00+093024.6',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000199,NULL,'16.5g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.7667083,9.50686,0.061,NULL,59377277774,927769965,14496405,16.5),(126150,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126150,37.82,0.46,367,57258,70,NULL,NULL,'2MASX J15030574+2856191',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.7739583,28.93872,0.033,NULL,60080682897,938760670,14668135,17.9),(126151,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126151,37.8,0.46,363,57259,70,NULL,NULL,'2MASX J15030600+2336061',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.775,23.60167,0.121,NULL,59528996339,930140567,14533446,17.2),(126152,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126152,37.56,0.46,326,57260,70,NULL,NULL,'2MASX J15030659+5908168',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000077,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,225.7775417,59.13797,0.021,NULL,57719107972,901861062,14091579,16.7),(126153,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126153,36.89,0.33,239,57261,70,NULL,NULL,'2MASX J15030670+0725416',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.777917,7.42822,0.037,NULL,59387459179,927929049,14498891,17.1),(126154,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126154,38.24,0.46,445,57262,70,NULL,NULL,'2MASX J15030740+0954206',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.32',0.14,NULL,NULL,NULL,NULL,NULL,1,225.781,9.90572,0.037,NULL,59377513379,927773646,14496463,19.32),(126155,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126155,36.94,0.46,245,57263,70,NULL,NULL,'2MASX J15030863+0859446',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.76',0.15,NULL,NULL,NULL,NULL,NULL,1,225.786083,8.99572,0.053,NULL,59388638734,927947480,14499179,18.76),(126156,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126156,37.74,0.19,354,57264,70,NULL,NULL,'2MASX J15030925+2713271',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,225.788583,27.22417,0.065,NULL,60082925856,938795716,14668683,18.51),(126157,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126157,35.73,0.54,140,57265,70,NULL,NULL,'2MASX J15030951-4120438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,225.789666667,-41.34553,0.321,NULL,47094248611,735847634,11497619,14.6),(126158,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126158,37.87,0.11,375,57266,70,NULL,NULL,'2MASX J15031033+0756386',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.793125,7.94406,0.045,NULL,59390851424,927982053,14499719,17.6),(126159,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126159,35.78,0.49,143,57267,75,NULL,'IR','CGCG 134-071',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',0.00002,NULL,'16.20',0.12,'Sc',NULL,NULL,NULL,NULL,1,225.794625,21.53942,0.089,NULL,59539551288,930305488,14536023,16.2),(126160,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126160,35.8,NULL,145,57267,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 134-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126161,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126161,35.83,NULL,146,57267,NULL,NULL,'Dipole + Quadrupole','CGCG 134-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126162,'Tully-Fisher','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126162,35.84,NULL,147,57267,NULL,NULL,'Dipole','CGCG 134-071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126163,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126163,37.87,0.11,375,57268,70,NULL,NULL,'2MASX J15031086+0807196',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,225.79525,8.12203,0.045,NULL,59388871222,927951112,14499236,16.9),(126164,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126164,37.09,0.46,262,57269,70,NULL,NULL,'2MASX J15031149+2652291',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.68',0.24,NULL,NULL,NULL,NULL,NULL,1,225.797917,26.87475,0.089,NULL,60079521864,938742529,14667852,17.68),(126165,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126165,38.17,0.46,430,57270,70,NULL,NULL,'2MASX J15031352+0042106',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.8062917,0.70294,0.165,NULL,56372344162,880817877,13762779,18.2),(126166,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126166,36.79,0.46,228,57271,70,NULL,NULL,'2MASX J15031377+4853559',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,225.807375,48.89886,0.017,NULL,59941232891,936581763,14634090,16.4),(126167,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,NULL,126167,36.7,0.64,218,57272,70,NULL,NULL,'2MASX J15031406-0422087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,225.808583,-4.36917,0.237,NULL,46455616285,725869004,11341703,15.7),(126168,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126168,37.89,0.21,378,57273,70,NULL,NULL,'SDSS J150314.06+090112.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.808625,9.02006,0.053,NULL,59388638094,927947470,14499179,18.5),(126169,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126169,37.95,0.46,389,57274,70,NULL,NULL,'2MASX J15031457+0405566',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.810667,4.09906,0.109,NULL,59339291734,927176433,14487131,17.7),(126170,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126170,37.96,0.46,391,57275,70,NULL,NULL,'2MASX J15031457+0718596',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.81075,7.31661,0.037,NULL,59387445397,927928834,14498888,17.6),(126171,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126171,37.87,0.11,375,57276,70,NULL,NULL,'SDSS J150314.59+080520.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.810833,8.08903,0.045,NULL,59390918752,927983105,14499736,18.2),(126172,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126172,37.47,0.33,312,57277,70,NULL,NULL,'2MASX J15031516+0503376',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,225.813125,5.06047,0.105,NULL,59329891531,927029555,14484836,17.5),(126173,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126173,37.33,0.46,292,57278,70,NULL,NULL,'2MASX J15031519+3608520',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000214,NULL,'15.5g',0.47,NULL,NULL,NULL,NULL,NULL,1,225.813125,36.14772,0,NULL,60127916851,939498700,14679667,15.5),(126174,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126174,37.87,0.11,375,57279,70,NULL,NULL,'2MASX J15031619+0800456',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.817417,8.01275,0.045,NULL,59390840812,927981887,14499716,17.6),(126175,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126175,37.92,0.46,384,57280,70,NULL,NULL,'2MASX J15031686+5305069',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.820167,53.08542,0.017,NULL,59928962957,936390046,14631094,17.6),(126176,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126176,35.58,0.33,131,57281,70,NULL,NULL,'2MASX J15031714+1709177',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.58',0.23,NULL,NULL,NULL,NULL,NULL,1,225.8215,17.15492,0.017,NULL,59591942453,931124100,14548814,16.58),(126177,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126177,35.97,0.46,157,57282,70,NULL,NULL,'2MASX J15031736+3108132',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.17',0.24,NULL,NULL,NULL,NULL,NULL,1,225.822417,31.13703,0.037,NULL,60092555769,938946183,14671034,17.17),(126178,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126178,37.27,0.46,284,57283,70,NULL,NULL,'2MASX J15031780+4350195',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.824167,43.83864,0.037,NULL,59980073051,937188641,14643572,17.3),(126179,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126179,37.87,0.11,375,57284,70,NULL,NULL,'2MASX J15031780+0737206',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.8242917,7.62256,0.033,NULL,59387473881,927929279,14498894,17.7),(126180,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126180,37.87,0.11,375,57285,70,NULL,NULL,'2MASX J15031794+0759526',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.824917,7.99797,0.045,NULL,59390839920,927981873,14499716,18.5),(126181,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126181,37.47,0.33,312,57286,70,NULL,NULL,'2MASX J15031875+0503518',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,225.828,5.06444,0.105,NULL,59329889644,927029525,14484836,16.9),(126182,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126182,38.39,0.46,476,57287,70,NULL,NULL,'SDSS J150319.22+104751.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000148,NULL,'18.9g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.830083333,10.79764,0.085,NULL,59375145016,927736640,14495885,18.9),(126183,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126183,37.86,0.27,373,57288,70,NULL,NULL,'SDSS J150319.24+341019.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.8302083,34.17222,0.009,NULL,60126885105,939482579,14679415,18.2),(126184,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126184,36.68,0.46,216,57289,70,NULL,NULL,'2MASX J15031996+5744089',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.833333,57.73589,0.005,NULL,57729756320,902027442,14094178,17.3),(126185,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126185,35.92,0.46,153,57290,70,NULL,NULL,'SDSS J150320.19+091121.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.74',0.18,NULL,NULL,NULL,NULL,NULL,1,225.834167,9.18931,0.053,NULL,59388652906,927947701,14499182,16.74),(126186,'FP','2016-12-15 15:15:30','2016-12-16 11:20:44','1',NULL,'R',126186,36.19,0.46,173,57291,70,NULL,NULL,'2MASX J15032035+0708236',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.83475,7.14008,0.065,NULL,59385688499,927901382,14498459,17),(126187,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126187,37.74,0.19,354,57292,70,NULL,NULL,'2MASX J15032094+2706561',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,225.83725,27.11558,0.073,NULL,60082919708,938795620,14668681,NULL),(126188,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126188,36.89,0.33,239,57293,70,NULL,NULL,'2MASX J15032136+0734436',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.839,7.57894,0.033,NULL,59387474377,927929287,14498895,17.3),(126189,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126189,34.83,0.2,92.5,57294,74.4,NULL,NULL,'UGC 09675',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'14.60',0.9,'SB?',NULL,NULL,NULL,NULL,1,225.8422083,10.65594,0.077,NULL,59378040309,927781879,14496591,14.6),(126190,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126190,37.74,0.19,354,57295,70,NULL,NULL,'2MASX J15032244+2709181',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.42',0.15,NULL,NULL,NULL,NULL,NULL,1,225.843417,27.15497,0.073,NULL,60082921306,938795645,14668681,18.42),(126191,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126191,38.12,0.23,421,57296,70,NULL,NULL,'2MASX J15032239+3556240',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.8435417,35.94,0,NULL,60127804939,939496952,14679639,17.1),(126192,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126192,36.92,0.46,243,57297,70,NULL,NULL,'SDSS J150323.10+225159.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.8462917,22.86664,0.113,NULL,59527991749,930124871,14533201,18.2),(126193,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126193,35.31,0.46,115,57298,70,NULL,NULL,'2MASX J15032330+0542049',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.36',0.41,NULL,NULL,NULL,NULL,NULL,1,225.847041667,5.70125,0.085,NULL,59330432258,927038004,14484968,16.36),(126194,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126194,37.75,0.27,356,57299,70,NULL,NULL,'2MASX J15032330+0706476',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000204,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.8472083,7.11317,0.065,NULL,59385686951,927901358,14498458,16.9),(126195,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126195,36.99,0.46,250,57300,70,NULL,NULL,'2MASX J15032412+2831061',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.37',0.16,NULL,NULL,NULL,NULL,NULL,1,225.850417,28.51844,0.017,NULL,60080720155,938761252,14668144,18.37),(126196,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126196,37.16,0.46,271,57301,70,NULL,NULL,'2MASX J15032408+4112441',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.850583,41.21236,0.029,NULL,59971013053,937047078,14641360,17.6),(126197,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126197,37.81,0.46,365,57302,70,NULL,NULL,'2MASX J15032414+3212153',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000189,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.850625,32.20439,0.041,NULL,60084538368,938820912,14669076,16.6),(126198,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126198,36.96,0.33,246,57303,70,NULL,NULL,'2MASX J15032415+3448543',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,225.85075,34.81508,0.005,NULL,60128535236,939508363,14679818,16.3),(126199,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126199,37.54,0.46,322,57304,70,NULL,NULL,'2MASX J15032424+1131136',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000191,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,225.851125,11.52053,0.077,NULL,59345654334,927275848,14488685,16.6),(126200,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126200,37.2,0.27,276,57305,70,NULL,NULL,'2MASX J15032475+2523201',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.28',0.19,NULL,NULL,NULL,NULL,NULL,1,225.853166667,25.38886,0.093,NULL,59894791240,935856113,14622751,16.28),(126201,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126201,36.89,0.46,239,57306,70,NULL,NULL,'2MASX J15032542+1835282',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.36',0.17,NULL,NULL,NULL,NULL,NULL,1,225.855875,18.59117,0.061,NULL,59581313996,930958031,14546219,18.36),(126202,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126202,37.96,0.46,391,57307,70,NULL,NULL,'SDSS J150325.95+095109.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.858166667,9.85264,0.037,NULL,59377502924,927773483,14496460,18.4),(126203,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126203,38.29,0.46,454,57308,70,NULL,NULL,'2MASX J15032606-0208403',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.858583,-2.14475,0.213,NULL,46441811158,725653299,11338332,17.6),(126204,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126204,37.2,0.27,276,57309,70,NULL,NULL,'2MASX J15032652+2523301',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'17.48',0.12,NULL,NULL,NULL,NULL,NULL,1,225.860375,25.39153,0.093,NULL,59894791288,935856113,14622751,17.48),(126205,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126205,38.16,0.46,428,57310,70,NULL,NULL,'2MASX J15032658+3134563',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.8607917,31.58228,0.025,NULL,60084904260,938826629,14669166,17.3),(126206,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126206,37.89,0.21,378,57311,70,NULL,NULL,'2MASX J15032665+0851166',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.8609583,8.85461,0.053,NULL,59389133196,927955206,14499300,17.6),(126207,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126207,37.2,0.27,276,57312,70,NULL,NULL,'2MASX J15032711+2521570',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.00',0.17,NULL,NULL,NULL,NULL,NULL,1,225.863,25.36569,0.093,NULL,59894790626,935856103,14622751,18),(126208,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126208,36.23,0.46,176,57313,70,NULL,NULL,'2MASX J15032728+3424543',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.863583333,34.41519,0.005,NULL,60126708595,939479821,14679372,16.9),(126209,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126209,37.87,0.46,375,57314,70,NULL,NULL,'2MASX J15032773+6131195',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,225.865458333,61.52217,0,NULL,57778094449,902782725,14105980,18),(126210,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126210,35.92,0.2,153,57315,74.4,NULL,NULL,'CGCG 076-140',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000096,NULL,'15.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,225.866875,10.60011,0.077,NULL,59378030981,927781734,14496589,15.4),(126211,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126211,38.19,0.46,435,57316,70,NULL,NULL,'2MASX J15032814+3944401',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.8672917,39.74453,0.025,NULL,60100276555,939066821,14672919,17.7),(126212,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126212,37.75,0.27,356,57317,70,NULL,NULL,'2MASX J15032867+0705556',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.8694583,7.09889,0.065,NULL,59385693937,927901467,14498460,16.3),(126213,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126213,37.88,0.33,377,57318,70,NULL,NULL,'2MASX J15032897+4754055',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,225.870583,47.90142,0.037,NULL,59938957443,936546210,14633534,18.3),(126214,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126214,32.42,0.8,30.5,57319,75,NULL,'MAT, I','ESO 008- G 007',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000021,NULL,'14.2',1,'SB(s)m',NULL,NULL,NULL,NULL,1,225.870875,-82.79631,0.445,NULL,44074561868,688665029,10760391,14.2),(126215,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126215,32.47,0.8,31.2,57319,75,NULL,NULL,'ESO 008- G 007',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126216,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126216,32.34,0.32,29.4,57319,85,NULL,'I, inv','ESO 008- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126217,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126217,32.35,0.32,29.5,57319,85,NULL,'I, raw','ESO 008- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126218,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126218,32.56,0.43,32.5,57319,75,NULL,'MAT, I, raw','ESO 008- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126219,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126219,32.58,0.43,32.7,57319,75,NULL,'MAT, I, inv','ESO 008- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126220,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126220,32.58,0.4,32.8,57319,73,NULL,'opt','ESO 008- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126221,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126221,32.66,0.65,34.1,57319,NULL,NULL,NULL,'ESO 008- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126222,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126222,32.66,0.66,34.1,57319,NULL,NULL,'Malmquist cor.','ESO 008- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126223,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126223,32.71,0.2,34.8,57319,74.4,NULL,NULL,'ESO 008- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126224,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126224,32.73,0.43,35.2,57319,75,NULL,'MAT, I, cor','ESO 008- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126225,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126225,35.08,0.46,104,57320,70,NULL,NULL,'IC 1086',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00019,NULL,'15.4',0.25,NULL,NULL,NULL,NULL,NULL,1,225.8715417,17.11442,0.017,NULL,59591944879,931124138,14548814,15.4),(126226,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126226,37.75,0.27,356,57321,70,NULL,NULL,'2MASX J15033069+0705596',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.877917,7.10008,0.065,NULL,59385693758,927901464,14498460,17.8),(126227,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126227,37.14,0.13,268,57322,70,NULL,NULL,'2MASX J15033076+2844160',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.06',0.18,NULL,NULL,NULL,NULL,NULL,1,225.878417,28.73792,0.021,NULL,60080695772,938760871,14668138,18.06),(126228,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126228,37.42,0.46,304,57323,70,NULL,NULL,'SDSS J150330.98+192932.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.879125,19.49231,0.061,NULL,59536964734,930265073,14535391,18.5),(126229,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126229,38.17,0.23,430,57324,70,NULL,NULL,'2MASX J15033294+1015006',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'BrClG',NULL,NULL,NULL,NULL,1,225.887291667,10.25011,0.069,NULL,59377036454,927766194,14496346,NULL),(126230,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126230,38.33,0.46,464,57325,70,NULL,NULL,'2MASX J15033313+1537432',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.56',0.15,NULL,NULL,NULL,NULL,NULL,1,225.8879583,15.62861,0.029,NULL,59591174424,931112100,14548626,18.56),(126231,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126231,37.87,0.11,375,57326,70,NULL,NULL,'2MASX J15033391+0817186',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.8912917,8.28856,0.045,NULL,59388906952,927951671,14499244,17.5),(126232,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126232,36.13,0.46,168,57327,70,NULL,NULL,'2MASX J15033399+2248432',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.34',0.22,NULL,NULL,NULL,NULL,NULL,1,225.8915,22.81194,0.109,NULL,59528499336,930132802,14533325,17.34),(126233,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126233,34.98,0.52,99.1,57328,70,NULL,NULL,'2MASX J15033414-2206080',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.28',0.6,NULL,NULL,NULL,NULL,NULL,1,225.89225,-22.10247,0.389,NULL,46642163127,728783798,11387246,16.28),(126234,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126234,37.87,0.11,375,57329,70,NULL,NULL,'2MASX J15033451+0807484',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.8937917,8.13017,0.029,NULL,59388938932,927952170,14499252,16.6),(126235,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126235,37.88,0.33,377,57330,70,NULL,NULL,'2MASX J15033473+4753575',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,225.8945,47.89947,0.037,NULL,59938959376,936546240,14633535,18.4),(126236,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126236,38.17,0.23,430,57331,70,NULL,NULL,'SDSS J150335.23+101258.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.896833,10.21614,0.077,NULL,59377036600,927766196,14496346,18.6),(126237,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126237,36.59,0.56,208,57332,NULL,NULL,'Malmquist cor.','CGCG 164-057 NED01',NULL,'2009ApJS..182..474S',2009,1,1.03,NULL,'G',0.00003,NULL,'16.7g',0.19,'SBb',NULL,NULL,NULL,NULL,1,225.902833,28.47594,0.017,NULL,60080603762,938759433,14668116,16.7),(126238,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126238,36.79,0.51,228,57332,NULL,NULL,NULL,'CGCG 164-057 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126239,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126239,36.83,0.2,232,57332,74.4,NULL,NULL,'CGCG 164-057 NED01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126240,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126240,38.24,0.46,444,57333,70,NULL,NULL,'2MASX J15033721+0210309',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000354,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.904958333,2.17528,0.137,NULL,59325983159,926968486,14483882,17.6),(126241,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126241,38.63,0.46,533,57334,70,NULL,NULL,'SDSS J150337.40+283318.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,225.905833,28.55508,0.021,NULL,60080718112,938761220,14668144,NULL),(126242,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126242,36.9,0.23,240,57335,70,NULL,NULL,'2MASX J15033770+2042581',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.35',0.2,'BrClG',NULL,NULL,NULL,NULL,1,225.907083,20.71622,0.081,NULL,59541845957,930341343,14536583,17.35),(126243,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126243,38.45,0.46,491,57336,70,NULL,NULL,'2MASX J15033892+5512510',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,225.91225,55.21411,0.013,NULL,57579550456,899680475,14057507,17.5),(126244,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126244,37.99,0.46,397,57337,70,NULL,NULL,'SDSS J150338.96+383856.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.912375,38.649,0.025,NULL,60117532837,939336450,14677132,18),(126245,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126245,34.21,NULL,69.4,57338,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09681',NULL,'2010Ap&SS.325..163P',2010,1,1.62,NULL,'G',0.000033,NULL,'16.0g',0.16,'Sd',NULL,NULL,NULL,NULL,1,225.9154583,42.12631,0.013,NULL,59982251013,937222672,14644104,16),(126246,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126246,34.22,NULL,69.8,57338,NULL,NULL,'Dipole + Quadrupole','UGC 09681',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126247,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126247,34.23,NULL,70.2,57338,NULL,NULL,'Dipole','UGC 09681',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126248,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126248,34.28,NULL,71.7,57338,NULL,NULL,NULL,'UGC 09681',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126249,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126249,34.59,0.55,82.7,57338,NULL,NULL,'Malmquist cor.','UGC 09681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126250,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126250,34.68,0.53,86.4,57338,NULL,NULL,NULL,'UGC 09681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126251,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126251,34.72,0.2,87.9,57338,74.4,NULL,NULL,'UGC 09681',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126252,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126252,36.81,0.35,230,57339,NULL,NULL,'Malmquist cor.','CGCG 164-057 NED03',NULL,'2009ApJS..182..474S',2009,1,0.73,NULL,'G',0.000027,NULL,'15.8g',0.32,'Sbc',NULL,NULL,NULL,NULL,1,225.9184583,28.47567,0.017,NULL,60081078665,938766854,14668232,15.8),(126253,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126253,36.94,0.33,245,57339,NULL,NULL,NULL,'CGCG 164-057 NED03',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126254,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126254,37.15,0.2,269,57339,74.4,NULL,NULL,'CGCG 164-057 NED03',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126255,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126255,36.11,0.49,167,57340,75,NULL,'IR','UGC 09677',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000008,NULL,'16.0',0.27,'Sb',NULL,NULL,NULL,NULL,1,225.918833333,22.70064,0.109,NULL,59528510193,930132971,14533327,16),(126256,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126256,36.4,0.2,191,57340,74.4,NULL,NULL,'UGC 09677',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126257,'BL Lac Luminosity','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126257,40.63,NULL,1330,57341,70,NULL,'nucleus-to-host flux ratio, z > 0.38','WISE J150340.67-154114.0',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'18.1',NULL,'candidate      BLLAC',NULL,NULL,NULL,'BL Lac',1,225.919167,-15.68719,0.473,NULL,46705071142,729766736,11402605,18.1),(126258,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126258,37.68,0.33,344,57342,70,NULL,NULL,'2MASX J15034141+5449599',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.922333,54.83336,0.017,NULL,57579641650,899681900,14057529,17.8),(126259,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126259,37.89,0.21,378,57343,70,NULL,NULL,'SDSS J150341.75+085207.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.9239583,8.86886,0.053,NULL,59389134847,927955231,14499300,18.5),(126260,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126260,37.68,0.33,344,57344,70,NULL,NULL,'2MASX J15034209+5448039',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00016,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.92525,54.80097,0.017,NULL,57579505673,899679776,14057496,17.2),(126261,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126261,35.76,0.4,142,57345,NULL,NULL,'mean','CGCG 135-002',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000033,NULL,NULL,NULL,'S?',NULL,NULL,NULL,NULL,1,225.926625,26.10772,0.089,NULL,59895569714,935868276,14622941,NULL),(126262,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126262,35.79,0.47,144,57345,NULL,NULL,'H','CGCG 135-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126263,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126263,35.95,0.46,155,57345,NULL,NULL,'J','CGCG 135-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126264,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126264,35.99,0.45,158,57345,NULL,NULL,'K','CGCG 135-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126265,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126265,37.91,0.46,382,57346,70,NULL,NULL,'2MASX J15034248+2043480',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.03',0.14,NULL,NULL,NULL,NULL,NULL,1,225.927125,20.73006,0.081,NULL,59541845010,930341328,14536583,18.03),(126266,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126266,37.87,0.11,375,57347,70,NULL,NULL,'2MASX J15034287+0749374',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.9285417,7.82697,0.033,NULL,59390828058,927981688,14499713,16.9),(126267,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126267,36.32,0.46,184,57348,70,NULL,NULL,'2MASX J15034370+3622250',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000166,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.93225,36.37375,0,NULL,60127890345,939498286,14679660,16.3),(126268,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126268,37.89,0.21,378,57349,70,NULL,NULL,'2MASX J15034372+0853314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.9322917,8.89189,0.053,NULL,59389147666,927955432,14499303,17.6),(126269,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:44','1','SN 2004bw','R',126269,34.74,0.06,88.7,57350,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 020-052',NULL,'2015Sci...347.1459K',2015,1,1.8,NULL,'G',0.000023,NULL,'15.00',1.2,'SAB(s)cd       HII',NULL,NULL,NULL,NULL,1,225.93875,-3.30258,0.269,NULL,46453907812,725842309,11341286,15),(126270,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:44','1','SN 2004bw','R',126270,34.79,0.06,90.8,57350,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 020-052',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126271,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:44','1','SN 2004bw',NULL,126271,34.9,0.17,93.6,57350,70,NULL,'SALT 2','CGCG 020-052',0.021198,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126272,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126272,35.45,0.49,123,57351,75,NULL,'IR','IC 4530',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00016,NULL,'15.5',0.15,'S              LINER',NULL,NULL,NULL,NULL,1,225.938791667,26.10086,0.089,NULL,59895568682,935868260,14622941,15.5),(126273,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126273,35.89,0.2,151,57351,74.4,NULL,NULL,'IC 4530',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126274,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126274,38.88,0.33,596,57352,70,NULL,NULL,'2MASX J15034534+4444525',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.9389583,44.74789,0.049,NULL,59994028410,937406693,14646979,17.9),(126275,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126275,36.42,0.46,192,57353,70,NULL,NULL,'2MASX J15034671+0749444',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.944667,7.82897,0.033,NULL,59390828181,927981690,14499713,16.7),(126276,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126276,36.39,0.46,190,57354,70,NULL,NULL,'2MASX J15034687+1013484',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,225.945167,10.23,0.069,NULL,59377033295,927766145,14496346,16.5),(126277,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126277,37.87,0.11,375,57355,70,NULL,NULL,'2MASX J15034738+0739394',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.947375,7.66103,0.033,NULL,59387427767,927928558,14498883,17.5),(126278,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126278,38.16,0.46,428,57356,70,NULL,NULL,'2MASX J15034742+2034039',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,225.947583333,20.56789,0.081,NULL,59541875488,930341804,14536590,17.5),(126279,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126279,38.17,0.23,430,57357,70,NULL,NULL,'2MASX J15034788+1020584',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.92',0.15,NULL,NULL,NULL,NULL,NULL,1,225.9495,10.34964,0.069,NULL,59377171604,927768306,14496379,18.92),(126280,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126280,37.45,0.46,309,57358,70,NULL,NULL,'2MASX J15034830+5404029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,225.951291667,54.06747,0.005,NULL,59659905927,932186030,14565406,17.2),(126281,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126281,37.77,0.46,358,57359,70,NULL,NULL,'2MASX J15034849+3044011',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,225.952083,30.73353,0.025,NULL,60095264265,938988504,14671695,18.42),(126282,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126282,38.88,0.33,596,57360,70,NULL,NULL,'2MASX J15034894+4437216',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,225.9537917,44.62278,0.029,NULL,59994017830,937406528,14646977,17.2),(126283,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126283,37.94,0.46,388,57361,70,NULL,NULL,'2MASX J15035006+0404256',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.958666667,4.07394,0.109,NULL,59339415225,927178362,14487161,17),(126284,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126284,36.15,0.46,170,57362,70,NULL,NULL,'2MASX J15035018+2012279',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.00',0.17,NULL,NULL,NULL,NULL,NULL,1,225.959083,20.20767,0.085,NULL,59538444614,930288197,14535753,18),(126285,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126285,37.56,0.46,326,57363,70,NULL,NULL,'2MASX J15035030+2134099',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.02',0.18,NULL,NULL,NULL,NULL,NULL,1,225.9595417,21.56947,0.097,NULL,59540194733,930315542,14536180,18.02),(126286,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126286,36.27,0.33,179,57364,70,NULL,NULL,'2MASX J15035031+5537379',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000165,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,225.9595417,55.62725,0.005,NULL,57714109931,901782967,14090358,16.3),(126287,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126287,37.38,0.46,300,57365,70,NULL,NULL,'2MASX J15035135+0810374',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.963875,8.17722,0.029,NULL,59388946997,927952296,14499254,17.4),(126288,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126288,37.42,0.46,305,57366,70,NULL,NULL,'2MASX J15035213+0358036',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.967333,3.96761,0.109,NULL,59339267583,927176055,14487125,17.8),(126289,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126289,37.43,0.46,306,57367,70,NULL,NULL,'2MASX J15035309+2252349',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'17.48',0.11,NULL,NULL,NULL,NULL,NULL,1,225.971333,22.87633,0.113,NULL,59528015093,930125235,14533206,17.48),(126290,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126290,37.14,0.13,268,57368,70,NULL,NULL,'2MASX J15035333+2831306',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.08',0.18,NULL,NULL,NULL,NULL,NULL,1,225.972333,28.52511,0.017,NULL,60081193927,938768655,14668260,18.08),(126291,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126291,38.43,0.46,485,57369,70,NULL,NULL,'2MASX J15035340+5417009',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,225.972583333,54.28361,0,NULL,59659868416,932185444,14565397,18.3),(126292,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126292,31.87,NULL,23.7,57370,72,NULL,NULL,'KKR 15',NULL,'2014Ap.....57..457K',2014,1,0.5,'This object contains two SDSS emission line objects.','G',0.00002,NULL,'16.3',0.35,'BCD;Irr',NULL,NULL,NULL,NULL,1,225.982917,0.42917,0.129,NULL,56372265614,880816650,13762760,16.3),(126293,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126293,37.62,0.46,334,57371,70,NULL,NULL,'2MASX J15035620+2442146',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,225.984083,24.70417,0.101,NULL,59409111547,928267367,14504177,16.9),(126294,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126294,37.32,0.46,291,57372,70,NULL,NULL,'2MASX J15035631+2323038',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.984708333,23.38431,0.121,NULL,59529009435,930140772,14533449,17.4),(126295,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126295,35.01,0.46,100,57373,70,NULL,NULL,'CGCG 248-050',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000153,NULL,'14.2g',0.82,'E0',NULL,NULL,NULL,NULL,1,225.9847917,48.55025,0.037,NULL,59939305431,936551647,14633619,14.2),(126296,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126296,37.77,0.46,358,57374,70,NULL,NULL,'2MASX J15035730-0220001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000186,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,225.988583,-2.33333,0.213,NULL,46442251536,725660180,11338440,17.4),(126297,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126297,35.69,0.46,137,57375,70,NULL,NULL,'2MASX J15035744+1438026',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.28',0.37,NULL,NULL,NULL,NULL,NULL,1,225.989375,14.63417,0.049,NULL,59577642853,930900669,14545322,16.28),(126298,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126298,37.9,0.33,380,57376,70,NULL,NULL,'2MASX J15035878+0919144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,225.994875,9.32067,0.053,NULL,59377269750,927769839,14496403,17.6),(126299,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126299,37.9,0.33,380,57377,70,NULL,NULL,'2MASX J15035911+0917254',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.03',0.14,NULL,NULL,NULL,NULL,NULL,1,225.996375,9.29033,0.053,NULL,59377255683,927769620,14496400,19.03),(126300,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126300,37.74,0.19,354,57378,70,NULL,NULL,'2MASX J15035913+2719016',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,225.9965,27.31717,0.073,NULL,60082941552,938795961,14668686,17.9),(126301,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126301,38.53,0.46,508,57379,70,NULL,NULL,'SDSS J150359.79+095738.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,225.999167,9.96061,0.077,NULL,59377497396,927773396,14496459,17.9),(126302,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126302,38.01,0.46,400,57380,70,NULL,NULL,'SDSS J150400.63+314457.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000187,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,226.002667,31.74928,0.033,NULL,60084883926,938826311,14669161,18.2),(126303,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126303,38.39,0.46,476,57381,70,NULL,NULL,'2MASX J15040075+2246098',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.00325,22.76942,0.109,NULL,59528494438,930132725,14533323,17.3),(126304,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126304,37.14,0.13,268,57382,70,NULL,NULL,'2MASX J15040084+2830446',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.30',0.16,NULL,NULL,NULL,NULL,NULL,1,226.0034583,28.51239,0.017,NULL,60081193271,938768644,14668260,18.3),(126305,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126305,38.1,0.21,417,57383,70,NULL,NULL,'2MASX J15040103+2240538',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.004333333,22.68161,0.109,NULL,59528487467,930132616,14533322,17.6),(126306,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126306,37.87,0.11,375,57384,70,NULL,NULL,'2MASX J15040165+0757054',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.007,7.95142,0.045,NULL,59388778881,927949670,14499213,17),(126307,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126307,32.99,0.43,39.7,57385,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-031',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00015,NULL,'15',0.2,'S?',NULL,NULL,NULL,NULL,1,226.0110417,-10.73869,0.449,NULL,46493336853,726458388,11350912,15),(126308,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126308,37.3,0.46,288,57386,70,NULL,NULL,'2MASX J15040469+4816536',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.01925,48.28164,0.033,NULL,59939558169,936555596,14633681,17.4),(126309,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126309,36.44,0.46,194,57387,70,NULL,NULL,'SDSS J150405.77+163506.3',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.6g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.024083,16.58511,0.033,NULL,59591041916,931110029,14548594,15.6),(126310,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126310,37.74,0.46,353,57388,70,NULL,NULL,'2MASX J15040586+2034228',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.0244583,20.57311,0.081,NULL,59541822832,930340981,14536577,NULL),(126311,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126311,38.26,0.46,449,57389,70,NULL,NULL,'2MASX J15040595+0111587',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.025,1.19961,0.137,NULL,56372013321,880812708,13762698,17.9),(126312,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126312,37.68,0.46,343,57390,70,NULL,NULL,'2MASX J15040657+5106323',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.02725,51.10911,0.013,NULL,59942259234,936597800,14634340,17.7),(126313,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126313,32.16,0.12,27,57391,74.4,NULL,NULL,'NGC 5831',NULL,'2013AJ....146...86T',2013,1,1.94,NULL,'G',0.000014,NULL,'12.4g',1.6,'E3             BLLAC','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.029167,1.21992,0.137,NULL,56372021089,880812829,13762700,12.4),(126314,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126314,32.17,0.17,27.2,57391,NULL,NULL,'I','NGC 5831',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126315,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126315,32.17,0.17,27.2,57391,NULL,NULL,NULL,'NGC 5831',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126316,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126316,32.2,0.17,27.5,57391,NULL,NULL,'Malmquist cor.','NGC 5831',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126317,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126317,32.22,0.4,27.7,57391,75,NULL,'Edat, raw','NGC 5831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126318,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126318,32.37,0.4,29.7,57391,75,NULL,'Edat, cor','NGC 5831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126319,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126319,31.64,0.49,21.3,57391,95,NULL,'de Vaucouleurs','NGC 5831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126320,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126320,31.7,0.39,21.9,57391,95,NULL,'Weighted Mean','NGC 5831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126321,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126321,33.23,0.81,44.3,57391,55,NULL,'Visvanathan & Sandage 1979','NGC 5831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126322,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126322,32.11,0.41,26.4,57391,NULL,NULL,NULL,'NGC 5831',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126323,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126323,32.16,0.12,27,57391,74.4,NULL,NULL,'NGC 5831',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126324,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126324,32.24,0.41,28.1,57391,NULL,NULL,'Malmquist cor.','NGC 5831',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126325,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126325,31.08,0.25,16.4,57391,95,NULL,NULL,'NGC 5831',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126326,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126326,32.27,0.8,28.5,57391,75,NULL,'B','NGC 5831',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126327,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126327,32.17,0.4,27.1,57391,NULL,NULL,'mean','NGC 5831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126328,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126328,32.53,0.45,32,57391,NULL,NULL,'K','NGC 5831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126329,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126329,36.9,0.23,240,57392,70,NULL,NULL,'2MASX J15040695+2042408',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.028916667,20.71128,0.069,NULL,59539756407,930308693,14536073,16.4),(126330,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126330,37.14,0.13,268,57393,70,NULL,NULL,'CGCG 165-005',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000103,NULL,'15.5',0.3,NULL,'Group member',NULL,NULL,NULL,1,226.0302083,28.5195,0.017,NULL,60081194738,938768667,14668260,15.5),(126331,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126331,35.65,0.58,135,57394,70,NULL,NULL,'CGCG 020-053',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,226.0305,-2.00372,0.209,NULL,46441940202,725655315,11338364,15.5),(126332,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126332,35.87,0.46,149,57394,70,NULL,NULL,'CGCG 020-053',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126333,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126333,37.82,0.46,366,57395,70,NULL,NULL,'2MASX J15040946+1556036',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.66',0.15,NULL,NULL,NULL,NULL,NULL,1,226.0395,15.93433,0.025,NULL,59591470305,931116723,14548698,18.66),(126334,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126334,36.04,0.46,162,57396,70,NULL,NULL,'2MASX J15041035-0135221',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,226.043125,-1.58944,0.193,NULL,46441694739,725651480,11338304,15.2),(126335,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126335,36.12,0.68,168,57396,70,NULL,NULL,'2MASX J15041035-0135221',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126336,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126336,37.14,0.13,268,57397,70,NULL,NULL,'2MASX J15041077+2830290',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.55',0.22,NULL,NULL,NULL,NULL,NULL,1,226.044833,28.50819,0.017,NULL,60081260935,938769702,14668276,17.55),(126337,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126337,37.87,0.11,375,57398,70,NULL,NULL,'2MASX J15041093+0758072',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.045583,7.96869,0.045,NULL,59388786892,927949795,14499215,16.8),(126338,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126338,37.33,0.46,293,57399,70,NULL,NULL,'2MASX J15041095+4032256',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.0457917,40.54044,0.045,NULL,59970245790,937035090,14641173,17.7),(126339,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126339,37.24,0.46,281,57400,70,NULL,NULL,'2MASX J15041218+2928560',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000127,NULL,NULL,NULL,'Sa',NULL,NULL,NULL,NULL,1,226.05075,29.48228,0.029,NULL,60094907766,938982933,14671608,NULL),(126340,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126340,36.18,0.72,172,57401,70,NULL,NULL,'2MASX J15041345-2011360',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,226.0560417,-20.19339,0.397,NULL,46646219421,728847178,11388237,15.6),(126341,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126341,31.59,0.43,20.8,57402,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-38-020',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000057,NULL,'14.28',0.9,'SAB(r)b?',NULL,NULL,NULL,NULL,1,226.0565,-7.22269,0.233,NULL,46495419359,726490927,11351420,14.28),(126342,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126342,37.74,0.46,354,57403,70,NULL,NULL,'2MASX J15041542+1555496',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.19',0.17,NULL,NULL,NULL,NULL,NULL,1,226.0642917,15.93044,0.025,NULL,59591469428,931116709,14548698,18.19),(126343,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126343,38.17,0.23,430,57404,70,NULL,NULL,'2MASX J15041545+1020222',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.0644583,10.33947,0.065,NULL,59377174257,927768347,14496380,17.7),(126344,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126344,37.14,0.13,268,57405,70,NULL,NULL,'2MASX J15041570+2828400',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.20',0.19,NULL,NULL,NULL,NULL,NULL,1,226.065375,28.47792,0.033,NULL,60081261132,938769705,14668276,18.2),(126345,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126345,35.84,0.49,147,57406,75,NULL,'IR','FGC 1853',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00008,NULL,'16.9g',0.13,'Scd',NULL,NULL,NULL,NULL,1,226.06575,48.16469,0.037,NULL,59938871776,936544871,14633513,16.9),(126346,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126346,35.88,NULL,150,57406,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126347,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126347,35.9,NULL,151,57406,NULL,NULL,'Dipole + Quadrupole','FGC 1853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126348,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126348,35.92,NULL,153,57406,NULL,NULL,NULL,'FGC 1853',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126349,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126349,35.93,NULL,153,57406,NULL,NULL,'Dipole','FGC 1853',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126350,'BCG','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126350,37.33,0.35,277,57407,60,NULL,'ABELL 2022, BCG','CGCG 165-006 NED01',0.0565,'1980ApJ...241..486H',1980,1,0.94,NULL,'G',0.000123,NULL,'16.58',0.42,NULL,'Brightest group member',NULL,NULL,NULL,1,226.066166667,28.49656,0.033,NULL,60081260751,938769699,14668276,16.58),(126351,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126351,36.82,0.14,231,57407,70,NULL,'ABELL 2022, BGC','CGCG 165-006 NED01',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126352,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126352,38.39,0.46,476,57408,70,NULL,NULL,'2MASX J15041586+4550396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.066333,45.84442,0.045,NULL,59991699602,937370306,14646411,17.7),(126353,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126353,38.05,0.46,407,57409,70,NULL,NULL,'SDSS J150416.81-003915.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.070083,-0.65439,0.153,NULL,45366440870,708850638,11075791,18.4),(126354,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126354,37.14,0.13,268,57410,70,NULL,NULL,'CGCG 165-006 NED03',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.42',0.2,NULL,NULL,NULL,NULL,NULL,1,226.0764583,28.50717,0.033,NULL,60081260575,938769696,14668276,17.42),(126355,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126355,37.24,0.21,280,57411,70,NULL,NULL,'2MASX J15041944+2558510',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.06',0.14,NULL,NULL,NULL,NULL,NULL,1,226.081125,25.98078,0.089,NULL,59895681577,935870024,14622969,18.06),(126356,'BCG','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126356,37.33,0.35,277,57412,60,NULL,NULL,'ABELL 2022',0.0565,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,226.08225,28.42267,0.033,NULL,60081274779,938769918,14668279,NULL),(126357,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126357,36.82,0.14,231,57412,70,NULL,NULL,'ABELL 2022',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126358,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126358,38.13,0.46,423,57413,70,NULL,NULL,'SDSS J150420.43+403305.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000123,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.085125,40.55167,0.045,NULL,59970250896,937035170,14641174,18.2),(126359,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126359,37.69,0.33,345,57414,70,NULL,NULL,'2MASX J15042093+2127137',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.10',0.15,NULL,NULL,NULL,NULL,NULL,1,226.087167,21.45375,0.089,NULL,59540229805,930316090,14536188,18.1),(126360,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126360,37.99,0.46,396,57415,70,NULL,NULL,'2MASX J15042159+1609337',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,226.0900417,16.15925,0.029,NULL,59591608995,931118890,14548732,18.24),(126361,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126361,38.09,0.46,415,57416,70,NULL,NULL,'SDSS J150421.89+225931.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.09125,22.99222,0.117,NULL,59528130135,930127033,14533234,18.1),(126362,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126362,37.79,0.46,362,57417,70,NULL,NULL,'2MASX J15042218+4741116',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000192,NULL,'16.3g',0.32,'E0',NULL,NULL,NULL,NULL,1,226.092583333,47.68669,0.045,NULL,59938810087,936543907,14633498,16.3),(126363,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126363,37.14,0.13,268,57418,70,NULL,NULL,'2MASX J15042298+2814390',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.90',0.23,NULL,NULL,NULL,NULL,NULL,1,226.095791667,28.24422,0.041,NULL,60081066843,938766669,14668229,17.9),(126364,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126364,37.08,0.46,261,57419,70,NULL,NULL,'2MASX J15042396+4323516',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.099875,43.39758,0.021,NULL,59980416645,937194010,14643656,17.5),(126365,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126365,38.12,0.46,421,57420,70,NULL,NULL,'2MASX J15042504+3526509',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.10425,35.44758,0.033,NULL,60128143391,939502240,14679722,16.9),(126366,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126366,37.55,0.33,323,57421,70,NULL,NULL,'2MASX J15042534+0802361',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.1055417,8.04314,0.029,NULL,59388772955,927949577,14499212,17.5),(126367,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126367,38.17,0.33,430,57422,70,NULL,NULL,'SDSS J150426.12+350451.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.108833,35.08089,0.005,NULL,60128004479,939500069,14679688,17.9),(126368,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126368,36.2,0.46,173,57423,70,NULL,NULL,'IC 4531',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000189,NULL,'15.4g',0.45,NULL,NULL,NULL,NULL,NULL,1,226.110167,23.41494,0.117,NULL,59527982532,930124727,14533198,15.4),(126369,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126369,37.91,0.46,382,57424,70,NULL,NULL,'2MASX J15042704+4857564',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.112541667,48.96572,0,NULL,59941274908,936582420,14634100,17.3),(126370,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126370,36.56,0.46,206,57425,70,NULL,NULL,'2MASX J15042708+3743032',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000166,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.112875,37.7175,0.009,NULL,60119427351,939366052,14677594,16.5),(126371,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126371,32.93,NULL,38.5,57426,NULL,NULL,'Dipole','MCG -02-38-032',NULL,'2010Ap&SS.325..163P',2010,1,2.27,NULL,'G',0.000007,NULL,'15',0.28,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,226.1132083,-14.43983,0.409,NULL,46693600428,729587506,11399804,15),(126372,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126372,32.93,NULL,38.5,57426,NULL,NULL,'Dipole + Quadrupole','MCG -02-38-032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126373,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126373,32.93,NULL,38.5,57426,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-38-032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126374,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126374,33.38,0.43,47.3,57426,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-38-032',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126375,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126375,37.4,0.46,302,57427,70,NULL,NULL,'2MASX J15042833+2544010',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.11',0.12,NULL,NULL,NULL,NULL,NULL,1,226.1179583,25.73356,0.085,NULL,59895652105,935869564,14622961,18.11),(126376,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126376,37.87,0.11,375,57428,70,NULL,NULL,'2MASX J15042885+0823551',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.1202917,8.39853,0.053,NULL,59388922223,927951909,14499248,17),(126377,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126377,37.69,0.33,345,57429,70,NULL,NULL,'SDSS J150429.12+212738.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.121375,21.46083,0.089,NULL,59540227413,930316053,14536188,18.1),(126378,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126378,36.17,0.33,172,57430,70,NULL,NULL,'CGCG 105-105',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000083,NULL,'15.5',0.6,NULL,NULL,NULL,NULL,NULL,1,226.1225417,17.69228,0.029,NULL,59581647516,930963242,14546300,15.5),(126379,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126379,36.68,0.46,216,57431,70,NULL,NULL,'2MASX J15042946+2426140',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.41',0.22,NULL,NULL,NULL,NULL,NULL,1,226.12275,24.43728,0.101,NULL,59409056364,928266505,14504164,16.41),(126380,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126380,37.87,0.11,375,57432,70,NULL,NULL,'2MASX J15043005+0801251',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.1252917,8.02361,0.029,NULL,59388774670,927949604,14499212,17.2),(126381,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126381,32.29,NULL,28.7,57433,72,NULL,NULL,'UGC 09682',NULL,'2014Ap.....57..457K',2014,1,1.8,NULL,'G',0.000023,NULL,'14.50',0.6,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,226.125625,-0.85133,0.149,NULL,45365979375,708843427,11075678,14.5),(126382,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126382,32.94,0.43,38.8,57433,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09682',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126383,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126383,36.38,0.2,189,57434,74.4,NULL,NULL,'IC 4533',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.68',0.7,'Sa',NULL,NULL,NULL,NULL,1,226.126417,27.79286,0.045,NULL,60081038185,938766221,14668222,14.68),(126384,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126384,36.58,0.46,207,57435,70,NULL,NULL,'2MASX J15043102+3749152',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.129417,37.82083,0.009,NULL,60119426059,939366032,14677594,17.3),(126385,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126385,36.78,0.46,227,57436,70,NULL,NULL,'2MASX J15043206+0544321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.1337083,5.74211,0.085,NULL,59330499274,927039051,14484985,17.5),(126386,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:44','1','SN 2006bk',NULL,126386,34.72,0.37,87.3,57437,74.2,NULL,'SALT 2','CGCG 193-015',0.0065,'2010ApJ...716..712A',2010,1,0.99,NULL,'G',0.000113,NULL,'14.3g',0.85,'E?',NULL,NULL,NULL,NULL,1,226.136291667,35.96503,0,NULL,60128459349,939507177,14679799,14.3),(126387,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126387,36.02,0.33,160,57437,70,NULL,NULL,'CGCG 193-015',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126388,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126388,32.18,NULL,27.3,57438,72,NULL,NULL,'SDSS J150434.22-023513.0',NULL,'2014Ap.....57..457K',2014,1,0.63,NULL,'G',0.00001,NULL,'16.4g',0.46,'Ir',NULL,NULL,NULL,NULL,1,226.142625,-2.58697,0.245,NULL,46442468412,725663568,11338493,16.4),(126389,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126389,36.72,0.46,221,57439,70,NULL,NULL,'2MASX J15043448+2403420',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.30',0.25,NULL,NULL,NULL,NULL,NULL,1,226.143583,24.06175,0.105,NULL,59408601517,928259398,14504053,16.3),(126390,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126390,34.36,0.48,74.6,57440,70,NULL,NULL,'ESO 067- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,'1984MNRAS.210...69F has V = 5900 +- 200 km/s.','G',0.00015,NULL,'13.7R',0.7,NULL,NULL,NULL,NULL,NULL,1,226.145417,-72.61661,0.453,NULL,45030425470,703600397,10993756,13.7),(126391,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126391,37.14,0.13,268,57441,70,NULL,NULL,'2MASX J15043557+2829380',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.08',0.21,NULL,NULL,NULL,NULL,NULL,1,226.1482083,28.49394,0.033,NULL,60081268420,938769819,14668278,18.08),(126392,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126392,38.17,0.33,430,57442,70,NULL,NULL,'2MASX J15043676+3510170',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.153,35.17142,0.005,NULL,60128197882,939503091,14679735,17.2),(126393,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126393,35.97,0.46,156,57443,70,NULL,NULL,'2MASX J15043704+1026278',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000147,NULL,'16.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.154375,10.44106,0.065,NULL,59376971210,927765175,14496330,16),(126394,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126394,36.62,0.46,211,57444,70,NULL,NULL,'2MASX J15043789+0900418',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.97',0.14,NULL,NULL,NULL,NULL,NULL,1,226.1579583,9.01183,0.053,NULL,59389173698,927955839,14499309,18.97),(126395,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126395,36.17,0.33,172,57445,70,NULL,NULL,'2MASX J15043853+1745397',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.1604583,17.76108,0.029,NULL,59581657642,930963400,14546303,16.4),(126396,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126396,34.53,0.69,80.4,57446,100,NULL,'mid-IR','NGC 5837',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000107,NULL,'14.5P',0.6,'SB(s)b',NULL,NULL,NULL,NULL,1,226.169083333,12.63344,0.081,NULL,59568481337,930757520,14543086,14.5),(126397,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126397,35.01,0.2,100,57446,74.4,NULL,NULL,'NGC 5837',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126398,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126398,35.31,0.47,115,57446,NULL,NULL,'H','NGC 5837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126399,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126399,35.42,0.45,122,57446,NULL,NULL,'K','NGC 5837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126400,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126400,35.49,0.4,125,57446,NULL,NULL,'mean','NGC 5837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126401,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126401,35.51,0.46,126,57446,NULL,NULL,'J','NGC 5837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126402,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126402,37.05,0.46,257,57447,70,NULL,NULL,'2MASX J15044158+2456510',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.173417,24.94761,0.113,NULL,59409037968,928266218,14504159,16.6),(126403,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126403,36.96,0.33,246,57448,70,NULL,NULL,'2MASX J15044319+3449220',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000185,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,226.179875,34.82275,0.005,NULL,60128498542,939507789,14679809,16.2),(126404,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126404,36.6,0.33,209,57449,70,NULL,NULL,'2MASX J15044418-0021071',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000094,NULL,'16.3g',0.33,'E0',NULL,NULL,NULL,NULL,1,226.184083,-0.35197,0.153,NULL,45366341616,708849087,11075766,16.3),(126405,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126405,37.8,0.46,363,57450,70,NULL,NULL,'2MASX J15044485+0751128',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.1870417,7.85353,0.045,NULL,59388727998,927948874,14499201,16.7),(126406,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126406,37.05,0.46,257,57451,70,NULL,NULL,'2MASX J15044511-0000461',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000068,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.1880417,-0.01286,0.157,NULL,45366144747,708846011,11075718,17.2),(126407,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126407,36.21,0.46,175,57452,70,NULL,NULL,'CGCG 048-102',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,226.189,6.33297,0.065,NULL,59386028876,927906701,14498542,15.6),(126408,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126408,36.95,0.41,245,57453,NULL,NULL,'Malmquist cor.','2MASX J15044627+2821140',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000027,NULL,'17.54',0.16,'Sb',NULL,NULL,NULL,NULL,1,226.192875,28.35397,0.041,NULL,60081304984,938770390,14668287,17.54),(126409,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126409,37.17,0.37,272,57453,NULL,NULL,NULL,'2MASX J15044627+2821140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126410,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126410,37.21,0.2,277,57453,74.4,NULL,NULL,'2MASX J15044627+2821140',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126411,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126411,37.55,0.33,323,57454,70,NULL,NULL,'2MASX J15044640+0800148',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.1932917,8.00403,0.029,NULL,59388752465,927949257,14499207,17.6),(126412,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126412,36.93,0.23,243,57455,70,NULL,NULL,'SDSS J150447.06+162025.1',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.196083333,16.34033,0.033,NULL,59591511630,931117369,14548708,16.7),(126413,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126413,35.32,0.2,116,57456,74.4,NULL,NULL,'UGC 09685',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000033,NULL,'14.8g',0.71,'Scd:',NULL,NULL,NULL,NULL,1,226.196791667,8.17119,0.029,NULL,59388965440,927952585,14499259,14.8),(126414,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126414,37.3,0.46,289,57457,70,NULL,NULL,'2MASX J15044853+3250130',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.202083,32.83694,0.009,NULL,60114942194,939295971,14676499,17.1),(126415,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126415,37.71,0.33,349,57458,70,NULL,NULL,'2MASX J15044853+2121517',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.97',0.17,NULL,NULL,NULL,NULL,NULL,1,226.202333333,21.36439,0.089,NULL,59540224474,930316007,14536187,17.97),(126416,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126416,37.64,0.46,337,57459,70,NULL,NULL,'2MASX J15044920+2837530',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'18.08',0.2,NULL,NULL,NULL,NULL,NULL,1,226.2052083,28.63133,0.037,NULL,60081239944,938769374,14668271,18.08),(126417,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126417,37.92,0.46,383,57460,70,NULL,NULL,'SDSS J150449.39+205325.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.2057917,20.89042,0.089,NULL,59539958224,930311847,14536122,18.5),(126418,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126418,37.56,0.33,325,57461,70,NULL,NULL,'2MASX J15044980+0457185',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,226.207541667,4.95522,0.077,NULL,59329772422,927027694,14484807,18.4),(126419,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126419,37.93,0.46,386,57462,70,NULL,NULL,'SDSS J150449.80+470825.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.207541667,47.14047,0.037,NULL,59983954886,937249295,14644520,17.9),(126420,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126420,38.45,0.33,490,57463,70,NULL,NULL,'2MASX J15045036+0652038',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.209708333,6.86789,0.065,NULL,59385869797,927904215,14498503,17.2),(126421,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126421,37.79,0.46,362,57464,70,NULL,NULL,'2MASX J15045076+2244527',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.38',0.15,NULL,NULL,NULL,NULL,NULL,1,226.211375,22.74814,0.113,NULL,59528662007,930135343,14533364,18.38),(126422,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126422,37.33,0.46,292,57465,70,NULL,NULL,'2MASX J15045188+0441555',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.216,4.69889,0.105,NULL,59331585285,927056020,14485250,17.6),(126423,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126423,38.26,0.46,448,57466,70,NULL,NULL,'SDSS J150451.91+273924.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.2162917,27.65672,0.049,NULL,60081032577,938766134,14668220,NULL),(126424,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126424,38.25,0.46,447,57467,70,NULL,NULL,'2MASX J15045280+2215307',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.220083,22.25867,0.085,NULL,59528571533,930133930,14533342,18.1),(126425,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126425,36.91,0.46,241,57468,70,NULL,NULL,'2MASX J15045346+5603341',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,226.223,56.05933,0.013,NULL,57717317000,901833078,14091141,16.3),(126426,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126426,36.51,0.27,201,57469,70,NULL,NULL,'IC 4532',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000117,NULL,'15.6',0.31,NULL,NULL,NULL,NULL,NULL,1,226.224208333,23.25661,0.121,NULL,59527963449,930124428,14533194,15.6),(126427,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126427,37.56,0.33,325,57470,70,NULL,NULL,'2MASX J15045388+0455525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.224417,4.93117,0.077,NULL,59329772614,927027697,14484807,17.3),(126428,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126428,37.65,0.46,339,57471,70,NULL,NULL,'2MASX J15045412+3141060',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.225417,31.68483,0.013,NULL,60084913401,938826771,14669168,17.5),(126429,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126429,37.77,0.46,358,57472,70,NULL,NULL,'2MASX J15045423+2759350',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.225958333,27.99308,0.049,NULL,60080980428,938765319,14668208,17.9),(126430,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126430,37.55,0.17,324,57473,70,NULL,NULL,'2MASX J15045441+0505515',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.226667,5.09756,0.081,NULL,59329977428,927030897,14484857,17.2),(126431,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126431,37.71,0.33,348,57474,70,NULL,NULL,'2MASX J15045440+0702028',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.22675,7.03425,0.061,NULL,59385753537,927902399,14498474,NULL),(126432,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126432,36.19,0.21,173,57475,70,NULL,NULL,'CGCG 048-104',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000063,NULL,'15.7',0.43,NULL,'Group member',NULL,NULL,NULL,1,226.22875,5.90917,0.089,NULL,59330368361,927037005,14484953,15.7),(126433,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126433,36.78,0.46,227,57476,70,NULL,NULL,'CGCG 165-012',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000137,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,226.2317917,31.12497,0.025,NULL,60084770155,938824533,14669133,15.4),(126434,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126434,37.88,0.33,377,57477,70,NULL,NULL,'2MASX J15045649+3051410',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.235417,30.86131,0.021,NULL,60092318583,938942477,14670976,17.2),(126435,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126435,37.65,0.46,338,57478,70,NULL,NULL,'2MASX J15045664+2958400',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.39',0.17,NULL,NULL,NULL,NULL,NULL,1,226.236125,29.97794,0.017,NULL,60094352703,938974260,14671472,18.39),(126436,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126436,36.4,0.46,191,57479,70,NULL,NULL,'2MASX J15045666+0607488',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.38,NULL,NULL,NULL,NULL,NULL,1,226.236167,6.13022,0.077,NULL,59330077737,927032464,14484882,16),(126437,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126437,37.07,0.46,259,57480,70,NULL,NULL,'2MASX J15045710+2435330',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,226.237917,24.5925,0.105,NULL,59409129398,928267646,14504181,16.3),(126438,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126438,36.25,0.57,178,57481,NULL,NULL,'Malmquist cor.','2MASX J15045771+2836450',NULL,'2009ApJS..182..474S',2009,1,0.29,NULL,'G',0.00004,NULL,'18.68',0.12,'Sc',NULL,NULL,NULL,NULL,1,226.240417,28.61256,0.037,NULL,60081228818,938769200,14668268,18.68),(126439,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126439,36.31,0.56,183,57481,NULL,NULL,NULL,'2MASX J15045771+2836450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126440,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126440,36.35,0.2,186,57481,74.4,NULL,NULL,'2MASX J15045771+2836450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126441,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126441,36.6,0.33,209,57482,70,NULL,NULL,'2MASX J15045838-0031111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.3g',0.13,'NLAGN',NULL,NULL,NULL,NULL,1,226.243416667,-0.51992,0.153,NULL,45366306325,708848536,11075758,17.3),(126442,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126442,36.51,0.27,201,57483,70,NULL,NULL,'2MASX J15045945+2313277',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00018,NULL,'17.84',0.18,NULL,NULL,NULL,NULL,NULL,1,226.2477083,23.22444,0.121,NULL,59528142111,930127220,14533237,17.84),(126443,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126443,36.76,0.68,225,57484,NULL,NULL,'Malmquist cor.','2MASX J15045952+2826490',NULL,'2009ApJS..182..474S',2009,1,0.45,NULL,'G',0.000037,NULL,'16.14',0.11,'SBab',NULL,NULL,NULL,NULL,1,226.248083,28.44689,0.033,NULL,60081302849,938770357,14668286,16.14),(126444,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126444,37.01,0.6,252,57484,NULL,NULL,NULL,'2MASX J15045952+2826490',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126445,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126445,37.05,0.2,257,57484,74.4,NULL,NULL,'2MASX J15045952+2826490',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126446,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126446,36.93,0.23,243,57485,70,NULL,NULL,'SDSS J150500.02+161751.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.250167,16.29753,0.033,NULL,59591522763,931117543,14548711,16.9),(126447,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126447,36.89,0.46,239,57486,70,NULL,NULL,'2MASX J15050063+0843468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.252667,8.72969,0.041,NULL,59389191810,927956122,14499314,17.8),(126448,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126448,37.24,0.21,280,57487,70,NULL,NULL,'MCG +04-36-006',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.33,'AGN',NULL,NULL,NULL,NULL,1,226.255083,26.01708,0.089,NULL,59895687091,935870110,14622970,16.4),(126449,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126449,36.67,0.45,216,57488,NULL,NULL,'Malmquist cor.','2MASX J15050119+2823030',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000027,NULL,'15.06',0.33,'Sc',NULL,NULL,NULL,NULL,1,226.255375,28.38414,0.033,NULL,60081303869,938770372,14668287,15.06),(126450,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126450,36.78,0.42,227,57488,NULL,NULL,NULL,'2MASX J15050119+2823030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126451,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126451,36.82,0.2,231,57488,74.4,NULL,NULL,'2MASX J15050119+2823030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126452,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126452,37.55,0.17,324,57489,70,NULL,NULL,'2MASX J15050144+0507545',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.256,5.13175,0.081,NULL,59329847564,927028868,14484826,16.9),(126453,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126453,37.55,0.17,324,57490,70,NULL,NULL,'SDSS J150501.64+050459.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.256833333,5.08331,0.081,NULL,59329977157,927030893,14484857,17.8),(126454,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126454,36.7,0.46,219,57491,70,NULL,NULL,'2MASX J15050185+3718082',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000149,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.257833,37.30228,0,NULL,60120062246,939375972,14677749,16.7),(126455,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126455,38.1,0.21,417,57492,70,NULL,NULL,'2MASX J15050212+2252357',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.259,22.87667,0.113,NULL,59528088661,930126385,14533224,17.9),(126456,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126456,36.93,0.23,243,57493,70,NULL,NULL,'2MASX J15050242+1621094',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.95',0.18,NULL,NULL,NULL,NULL,NULL,1,226.260083,16.35275,0.033,NULL,59591522205,931117534,14548711,17.95),(126457,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126457,37.24,0.21,280,57494,70,NULL,NULL,'2MASX J15050244+2602450',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.260167,26.04575,0.089,NULL,59895686148,935870096,14622970,17.8),(126458,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126458,37.24,0.21,280,57495,70,NULL,NULL,'SDSS J150502.68+255353.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.2612083,25.89828,0.089,NULL,59895697392,935870271,14622972,18),(126459,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126459,37.85,0.46,372,57496,70,NULL,NULL,'SDSS J150502.80+343456.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.2617083,34.58228,0.025,NULL,60126661970,939479093,14679360,18.3),(126460,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126460,37.49,0.46,315,57497,70,NULL,NULL,'SDSS J150502.97+200908.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.262375,20.15242,0.085,NULL,59536610976,930259546,14535305,18.4),(126461,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126461,37.55,0.17,324,57498,70,NULL,NULL,'2MASX J15050438+0504035',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.268333,5.06764,0.081,NULL,59329984718,927031011,14484859,16.2),(126462,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126462,37.24,0.21,280,57499,70,NULL,NULL,'SDSS J150504.64+260031.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.269375,26.00872,0.089,NULL,59895687136,935870111,14622970,17.4),(126463,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126463,38.45,0.33,490,57500,70,NULL,NULL,'2MASX J15050473+0650197',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.269667,6.83889,0.065,NULL,59385868683,927904198,14498503,17.5),(126464,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126464,36.95,0.72,246,57501,70,NULL,NULL,'2MASX J15050486-0106351',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000101,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,226.270375,-1.10972,0.161,NULL,45369416721,708897136,11076517,16),(126465,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126465,36.02,0.33,160,57502,70,NULL,NULL,'2MASX J15050539+3557501',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000165,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.2724583,35.96386,0,NULL,60128455593,939507118,14679798,16.4),(126466,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126466,36.51,0.27,201,57503,70,NULL,NULL,'2MASX J15050541+2325117',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.75',0.19,NULL,NULL,NULL,NULL,NULL,1,226.27275,23.42,0.117,NULL,59527975280,930124613,14533197,17.75),(126467,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126467,37.07,0.33,259,57504,70,NULL,NULL,'2MASX J15050745+3656232',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.71',0.19,NULL,NULL,NULL,NULL,NULL,1,226.280958333,36.93986,0.021,NULL,60119952463,939374257,14677722,16.71),(126468,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126468,37.05,0.27,257,57505,70,NULL,NULL,'2MASX J15050759+3012471',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.281541667,30.21308,0.025,NULL,60094414515,938975226,14671487,16.7),(126469,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126469,37.84,0.46,369,57506,70,NULL,NULL,'2MASX J15050767+2713380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.57',0.18,NULL,NULL,NULL,NULL,NULL,1,226.282041667,27.22731,0.073,NULL,60080797873,938762466,14668163,18.57),(126470,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126470,38.14,0.33,425,57507,70,NULL,NULL,'2MASX J15050863+2012157',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.286,20.20433,0.085,NULL,59536609356,930259521,14535305,17.5),(126471,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126471,37.63,0.46,335,57508,70,NULL,NULL,'SDSS J150508.70+115422.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.2862917,11.90628,0.149,NULL,59346226409,927284787,14488824,18.4),(126472,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126472,36.19,0.21,173,57509,70,NULL,NULL,'2MASX J15050874+0553235',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.2865,5.88986,0.089,NULL,59330094731,927032730,14484886,16.9),(126473,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126473,36.93,0.23,243,57510,70,NULL,NULL,'SDSS J150509.51+161524.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.289666667,16.25678,0.033,NULL,59591513734,931117402,14548709,17.4),(126474,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126474,37.47,0.5,311,57511,NULL,NULL,'Malmquist cor.','2MASX J15050966+2848480',NULL,'2009ApJS..182..474S',2009,1,0.45,NULL,'G',0.00003,NULL,'15.45',NULL,'Sab',NULL,NULL,NULL,NULL,1,226.2902083,28.81342,0.041,NULL,60081190420,938768600,14668259,15.45),(126475,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126475,37.6,0.47,331,57511,NULL,NULL,NULL,'2MASX J15050966+2848480',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126476,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126476,37.64,0.2,337,57511,74.4,NULL,NULL,'2MASX J15050966+2848480',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126477,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126477,37.37,0.46,298,57512,70,NULL,NULL,'2MASX J15050994+4533390',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.2914583,45.56072,0.025,NULL,59994595014,937415547,14647117,16.5),(126478,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126478,37.07,0.46,260,57513,70,NULL,NULL,'2MASX J15050993+0826037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.2915,8.43442,0.053,NULL,59388817279,927950269,14499222,17.4),(126479,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126479,37.55,0.17,324,57514,70,NULL,NULL,'2MASX J15051041+0459555',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,226.293417,4.99883,0.077,NULL,59329973735,927030839,14484856,16.7),(126480,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126480,36.9,0.23,240,57515,70,NULL,NULL,'2MASX J15051080+2037027',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.34',0.14,'AGN',NULL,NULL,NULL,NULL,1,226.294875,20.61731,0.113,NULL,59535269906,930238592,14534978,18.34),(126481,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126481,37.05,0.27,257,57516,70,NULL,NULL,'2MASXi J1505107+301357',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.4g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.294917,30.23247,0.025,NULL,60094412428,938975194,14671487,17.4),(126482,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126482,38.14,0.33,425,57517,70,NULL,NULL,'2MASX J15051097+2011027',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.29575,20.18403,0.085,NULL,59536610102,930259532,14535305,17.9),(126483,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126483,35.46,NULL,124,57518,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09704',NULL,'2010Ap&SS.325..163P',2010,1,1.38,NULL,'G',0.000102,NULL,'16.1g',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,226.305625,57.31847,0.017,NULL,57729024460,902016007,14094000,16.1),(126484,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126484,35.48,NULL,125,57518,NULL,NULL,'Dipole + Quadrupole','UGC 09704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126485,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126485,35.5,NULL,126,57518,NULL,NULL,'Dipole','UGC 09704',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126486,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126486,35.51,NULL,126,57518,NULL,NULL,NULL,'UGC 09704',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126487,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126487,38.39,0.46,476,57519,70,NULL,NULL,'2MASX J15051345+6026085',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.3062917,60.43578,0.029,NULL,57776821585,902762837,14105669,17.6),(126488,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126488,36.22,0.27,175,57520,70,NULL,NULL,'CGCG 076-145',NULL,'2015arXiv151105856S',2015,1,0.73,'1994AJ....107.1629T has V = 8677 +- 100 km/sec.','G',0.00018,NULL,'15.2g',0.52,'Sc',NULL,NULL,NULL,NULL,1,226.30675,8.79658,0.041,NULL,59389184347,927956005,14499312,15.2),(126489,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126489,37.71,0.33,348,57521,70,NULL,NULL,'SDSS J150513.72+071357.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.307208333,7.23261,0.061,NULL,59385792932,927903014,14498484,18.3),(126490,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126490,36.9,0.23,240,57522,70,NULL,NULL,'2MASX J15051450+2037066',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.77',0.18,'AGN',NULL,NULL,NULL,NULL,1,226.3105,20.61844,0.105,NULL,59535314973,930239296,14534989,17.77);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (126491,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126491,38.1,0.21,417,57523,70,NULL,NULL,'2MASX J15051485+2252576',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.3117917,22.88281,0.117,NULL,59528100504,930126570,14533227,17.7),(126492,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126492,36.17,0.46,172,57524,70,NULL,NULL,'2MASX J15051533+3233181',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.314083333,32.55514,0.065,NULL,60085321366,938833146,14669267,17),(126493,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126493,37.14,0.13,268,57525,70,NULL,NULL,'2MASX J15051570+2836561',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.95',0.23,NULL,NULL,NULL,NULL,NULL,1,226.3155,28.61564,0.037,NULL,60081226794,938769168,14668268,16.95),(126494,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126494,37.82,0.46,367,57526,70,NULL,NULL,'2MASX J15051660+4144293',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.319208333,41.74144,0.033,NULL,59970712215,937042378,14641287,16.9),(126495,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126495,37.64,0.46,338,57527,70,NULL,NULL,'2MASX J15051707+3218261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.32125,32.30722,0.005,NULL,60085354793,938833668,14669276,17.6),(126496,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126496,37.05,0.27,257,57528,70,NULL,NULL,'2MASX J15051731+3012581',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.322083,30.21606,0.025,NULL,60094408151,938975127,14671486,17.1),(126497,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126497,37.38,0.33,300,57529,70,NULL,NULL,'SDSS J150517.64+112413.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000212,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.3235,11.40378,0.093,NULL,59345587379,927274802,14488668,18),(126498,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126498,38.1,0.21,417,57530,70,NULL,NULL,'2MASX J15051831+2249341',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.32625,22.82617,0.113,NULL,59528606756,930134480,14533351,17.7),(126499,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126499,37.02,0.46,254,57531,70,NULL,NULL,'2MASX J15051924+0442526',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.330083333,4.71461,0.089,NULL,59331638066,927056844,14485263,17.3),(126500,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126500,35.69,0.49,137,57532,75,NULL,'IR','UGC 09694',NULL,'2011yCatp016004901K',2011,1,0.91,NULL,'G',0.000081,NULL,'15.4g',0.27,'Sb',NULL,NULL,NULL,NULL,1,226.334167,4.48056,0.093,NULL,59331113738,927048652,14485135,15.4),(126501,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126501,37.47,0.33,312,57533,70,NULL,NULL,'2MASX J15052040+2638201',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.92',0.2,NULL,NULL,NULL,NULL,NULL,1,226.3350417,26.63881,0.097,NULL,59895227546,935862930,14622858,17.92),(126502,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126502,38.1,0.21,417,57534,70,NULL,NULL,'2MASX J15052098+2251131',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.70',0.14,NULL,NULL,NULL,NULL,NULL,1,226.337583,22.85347,0.113,NULL,59528091782,930126434,14533225,18.7),(126503,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126503,37.55,0.17,324,57535,70,NULL,NULL,'2MASX J15052104+0505256',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.3377083,5.09036,0.081,NULL,59329852758,927028949,14484827,16.6),(126504,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126504,37.81,0.46,365,57536,70,NULL,NULL,'2MASX J15052212+1225166',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.342083,12.42136,0.081,NULL,59567959038,930749359,14542958,NULL),(126505,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126505,36.37,0.66,188,57537,70,NULL,NULL,'2MASX J15052225-0148107',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.0g',0.35,'S0',NULL,NULL,NULL,NULL,1,226.3427083,-1.80286,0.177,NULL,45367196447,708862444,11075975,16),(126506,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126506,38.34,0.46,466,57538,70,NULL,NULL,'2MASX J15052230+3646143',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'FoF','17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.3429583,36.77058,0.021,NULL,60119962828,939374419,14677725,17.4),(126507,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126507,37.38,0.33,300,57539,70,NULL,NULL,'2MASX J15052256+1125317',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.00',0.15,NULL,NULL,NULL,NULL,NULL,1,226.3440417,11.42547,0.093,NULL,59345597752,927274964,14488671,19),(126508,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126508,37.58,0.33,329,57540,70,NULL,NULL,'SDSS J150522.71+094527.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.344625,9.75778,0.061,NULL,59377628882,927775451,14496491,18.3),(126509,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126509,36.15,0.65,170,57541,70,NULL,NULL,'2MASX J15052272-4508311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,226.344666667,-45.14194,0.541,NULL,47108026230,736062909,11500982,15.3),(126510,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126510,37.71,0.33,349,57542,70,NULL,NULL,'SDSS J150523.21+213405.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.34675,21.56822,0.097,NULL,59540190504,930315476,14536179,18.3),(126511,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126511,37.88,0.33,377,57543,70,NULL,NULL,'2MASX J15052407+3056011',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.3502917,30.93364,0.025,NULL,60086553521,938852398,14669568,17.5),(126512,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126512,37.55,0.17,324,57544,70,NULL,NULL,'2MASX J15052426+0503336',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.351083333,5.05925,0.081,NULL,59329842291,927028785,14484824,16.7),(126513,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126513,37.07,0.33,259,57545,70,NULL,NULL,'2MASX J15052455+3644513',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,226.3522917,36.74753,0.021,NULL,60119918814,939373731,14677714,16.6),(126514,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126514,38.38,0.46,474,57546,70,NULL,NULL,'SDSS J150524.90-004138.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,226.3537917,-0.69392,0.157,NULL,45369071524,708891742,11076433,18.4),(126515,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126515,36.81,0.46,230,57547,70,NULL,NULL,'2MASX J15052604+0817577',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00019,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,226.358417,8.29939,0.053,NULL,59388853093,927950829,14499231,16.2),(126516,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126516,31.61,0.63,21,57548,95,NULL,'Michard 1979b, c','NGC 5838',NULL,'1984ApJS...56...91D',1984,1,4.2,NULL,'G',0.000017,NULL,'11.92',1.5,'SA0-           LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.359416667,2.09933,0.121,NULL,59325912120,926967376,14483865,11.92),(126517,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126517,31.61,0.46,21,57548,95,NULL,'Michard 1979a','NGC 5838',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126518,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126518,31.8,0.37,22.9,57548,95,NULL,'Weighted Mean','NGC 5838',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126519,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126519,34.44,0.81,77.3,57548,55,NULL,'Visvanathan & Sandage 1979','NGC 5838',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126520,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126520,32.69,0.25,34.5,57548,74.4,NULL,NULL,'NGC 5838',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126521,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126521,31.08,0.25,16.4,57548,95,NULL,NULL,'NGC 5838',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126522,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126522,32.27,0.8,28.5,57548,75,NULL,'B','NGC 5838',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126523,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126523,32.01,0.4,25.2,57548,NULL,NULL,'mean','NGC 5838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126524,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126524,32.16,NULL,27,57548,72,NULL,NULL,'NGC 5838',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126525,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126525,32.17,0.45,27.2,57548,NULL,NULL,'K','NGC 5838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126526,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126526,32.29,0.43,28.6,57549,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09703',NULL,'2014MNRAS.444..527S',2014,1,1.36,'HOLM 696B is a star.','G',0.000107,NULL,'14.6g',0.41,'Sbc',NULL,NULL,NULL,NULL,1,226.35975,46.56506,0.085,NULL,59984229127,937253580,14644587,14.6),(126527,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126527,32.94,0.4,38.7,57549,NULL,NULL,'mean','UGC 09703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126528,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126528,33.09,0.4,41.5,57549,75,NULL,NULL,'UGC 09703',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126529,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126529,33.66,0.47,54,57549,NULL,NULL,'H','UGC 09703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126530,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126530,33.67,0.49,54.3,57549,75,NULL,'IR','UGC 09703',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126531,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126531,37.58,0.33,329,57550,70,NULL,NULL,'2MASX J15052681+0947177',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.361917,9.78822,0.061,NULL,59377628057,927775438,14496491,17.3),(126532,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126532,32.89,0.2,37.8,57551,74.4,NULL,NULL,'UGC 09698',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.00002,NULL,'15.9g',0.32,'S?',NULL,NULL,NULL,NULL,1,226.3632083,23.68833,0.113,NULL,59411804679,928309448,14504835,15.9),(126533,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126533,37.47,0.33,312,57552,70,NULL,NULL,'2MASX J15052718+2638432',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.05',0.2,NULL,NULL,NULL,NULL,NULL,1,226.363333,26.64542,0.097,NULL,59895231514,935862992,14622859,18.05),(126534,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126534,31.77,0.3,22.6,57553,NULL,NULL,'I','NGC 5839',NULL,'2001ApJ...546..681T',2001,1,1.3,NULL,'G',0.000017,NULL,'13.7',1.2,'SAB(rs)0^0^:','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.364541667,1.63481,0.141,NULL,56373827049,880841047,13763141,13.7),(126535,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126535,31.78,0.12,22.7,57553,74.4,NULL,NULL,'NGC 5839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126536,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126536,31.41,1.29,19.1,57553,95,NULL,'Weighted Mean','NGC 5839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126537,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126537,31.41,1.29,19.1,57553,95,NULL,'de Vaucouleurs','NGC 5839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126538,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126538,31.78,0.12,22.7,57553,74.4,NULL,NULL,'NGC 5839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126539,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126539,31.08,0.25,16.4,57553,95,NULL,NULL,'NGC 5839',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126540,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126540,32.15,0.4,27,57553,NULL,NULL,'mean','NGC 5839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126541,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126541,32.86,0.45,37.3,57553,NULL,NULL,'K','NGC 5839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126542,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126542,36.98,0.2,249,57554,74.4,NULL,NULL,'UGC 09695',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000187,NULL,'15.02',0.5,'SBb',NULL,NULL,NULL,NULL,1,226.365833,14.42889,0.073,NULL,59577567735,930899495,14545304,15.02),(126543,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126543,34.98,0.47,98.9,57555,NULL,NULL,'H','UGC 09696',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000037,NULL,'14.1g',0.81,'Sa',NULL,NULL,NULL,NULL,1,226.3772917,8.52436,0.029,NULL,59389107792,927954809,14499293,14.1),(126544,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126544,35.16,0.45,107,57555,NULL,NULL,'K','UGC 09696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126545,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126545,35.17,0.46,108,57555,NULL,NULL,'J','UGC 09696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126546,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126546,35.31,0.4,115,57555,NULL,NULL,'mean','UGC 09696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126547,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126547,37.31,0.33,290,57556,70,NULL,NULL,'2MASX J15053125+0906337',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.380375,9.10936,0.053,NULL,59388329902,927942654,14499103,17.4),(126548,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126548,37.87,0.46,375,57557,70,NULL,NULL,'2MASX J15053212+0803145',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.38375,8.05406,0.029,NULL,59384479823,927882497,14498164,17.7),(126549,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126549,36.87,0.46,236,57558,70,NULL,NULL,'2MASX J15053279+3759112',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,226.386541667,37.9865,0.017,NULL,60119368681,939365135,14677580,16.2),(126550,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126550,37.31,0.33,290,57559,70,NULL,NULL,'2MASX J15053438+0902505',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.3934583,9.04744,0.053,NULL,59388315749,927942433,14499100,16.7),(126551,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126551,32.26,0.4,28.3,57560,75,NULL,'Edat, raw','NGC 5799',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000143,NULL,'13.32',1,'S0+: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,226.3967083,-72.43283,0.525,NULL,45033866720,703654167,10994596,13.32),(126552,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126552,32.6,0.4,33.1,57560,75,NULL,'Edat, cor','NGC 5799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126553,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126553,32.1,0.56,26.3,57560,70,NULL,NULL,'NGC 5799',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126554,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126554,32.82,0.45,36.6,57560,NULL,NULL,'K','NGC 5799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126555,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126555,32.97,0.4,39.2,57560,NULL,NULL,'mean','NGC 5799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126556,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126556,36.19,0.21,173,57561,70,NULL,NULL,'2MASX J15053585+0534276',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.399375,5.57442,0.077,NULL,59330292524,927035820,14484934,16.6),(126557,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126557,38.93,0.46,611,57562,70,NULL,NULL,'SDSS J150536.62+273449.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.402625,27.58042,0.053,NULL,60081014829,938765856,14668216,18.2),(126558,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126558,35.69,0.8,137,57563,75,NULL,'CF, r','UGC 09701',NULL,'1997ApJS..109..333W',1997,1,0.88,NULL,'G',0.000033,NULL,'15.2g',0.49,'Scd:',NULL,NULL,NULL,NULL,1,226.404167,31.16383,0.025,NULL,60084742644,938824103,14669126,15.2),(126559,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126559,35.09,0.38,104,57563,75,NULL,'CF, r, raw','UGC 09701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126560,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126560,35.2,0.38,109,57563,75,NULL,'CF, r, inv','UGC 09701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126561,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126561,35.41,0.38,121,57563,75,NULL,'CF, r, cor','UGC 09701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126562,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126562,36.22,0.27,175,57564,70,NULL,NULL,'2MASX J15053729+0838066',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.405417,8.63503,0.041,NULL,59389110061,927954844,14499294,17),(126563,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126563,38.2,0.46,436,57565,70,NULL,NULL,'2MASX J15053962+2207401',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.70',0.14,NULL,NULL,NULL,NULL,NULL,1,226.415083,22.12767,0.097,NULL,59527850175,930122658,14533166,18.7),(126564,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126564,37.35,0.46,296,57566,70,NULL,NULL,'2MASX J15053963+2231591',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.4152083,22.53325,0.109,NULL,59528623214,930134737,14533355,16.6),(126565,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126565,39.35,0.46,743,57567,70,NULL,NULL,'SDSS J150539.79+225909.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000131,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.415833,22.98586,0.117,NULL,59528105182,930126643,14533228,18.4),(126566,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126566,36.01,0.2,159,57568,74.4,NULL,NULL,'CGCG 135-008',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000554,NULL,'15.7',0.32,NULL,NULL,NULL,NULL,NULL,1,226.417167,25.44553,0.113,NULL,59895110612,935861103,14622829,15.7),(126567,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126567,38,0.46,399,57569,70,NULL,NULL,'2MASX J15054037+1037306',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.418125,10.62519,0.077,NULL,59346832061,927294250,14488972,17.7),(126568,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126568,37.36,0.46,297,57570,70,NULL,NULL,'2MASX J15054087+4005277',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000152,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.4202917,40.09094,0.029,NULL,60101046517,939078851,14673107,16.9),(126569,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126569,34.29,0.8,72,57571,75,NULL,'MAT, I','IC 4527',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15',0.7,'SA(s)c pec',NULL,NULL,NULL,NULL,1,226.420916667,-42.44953,0.377,NULL,47096067176,735876049,11498063,15),(126570,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126570,33.49,0.32,50,57571,85,NULL,'I, raw','IC 4527',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126571,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126571,33.55,0.32,51.3,57571,85,NULL,'I, inv','IC 4527',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126572,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126572,33.63,0.43,53.3,57571,75,NULL,'MAT, I, raw','IC 4527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126573,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126573,33.76,0.47,56.5,57571,NULL,NULL,'Malmquist cor.','IC 4527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126574,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126574,33.81,0.46,57.9,57571,NULL,NULL,NULL,'IC 4527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126575,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126575,33.85,0.2,58.9,57571,74.4,NULL,NULL,'IC 4527',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126576,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126576,33.89,0.43,59.9,57571,75,NULL,'MAT, I, inv','IC 4527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126577,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126577,33.96,0.43,62,57571,75,NULL,'MAT, I, cor','IC 4527',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126578,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126578,37.62,0.46,335,57572,70,NULL,NULL,'2MASX J15054296-0102273',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.429167,-1.04089,0.165,NULL,45369432256,708897379,11076521,17.3),(126579,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126579,37.83,0.46,368,57573,70,NULL,NULL,'2MASX J15054325+2611047',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.430375,26.18467,0.121,NULL,59895354005,935864906,14622889,17.6),(126580,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126580,38.07,0.46,411,57574,70,NULL,NULL,'2MASX J15054445+4715403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.435166667,47.26108,0.053,NULL,59984670168,937260471,14644694,18.1),(126581,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126581,37.14,0.13,268,57575,70,NULL,NULL,'2MASX J15054493+2817417',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.37',0.17,NULL,NULL,NULL,NULL,NULL,1,226.4372917,28.29506,0.041,NULL,60081132519,938767695,14668245,18.37),(126582,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126582,38.5,0.46,501,57576,70,NULL,NULL,'2MASX J15054537+0238047',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000103,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.439167,2.63467,0.117,NULL,59325451486,926960179,14483752,17.3),(126583,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126583,37.68,0.33,343,57577,70,NULL,NULL,'2MASX J15054647+3356475',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.44375,33.94644,0,NULL,60115640783,939306887,14676670,18.2),(126584,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126584,37.34,0.46,293,57578,70,NULL,NULL,'2MASX J15054676+6102047',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.445125,61.03481,0.005,NULL,57778296021,902785875,14106029,17.2),(126585,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126585,35.24,0.48,111,57579,70,NULL,NULL,'MCG -02-38-033',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.000133,NULL,'15.23',0.2,NULL,NULL,NULL,NULL,NULL,1,226.4495,-14.96483,0.449,NULL,46694062495,729594726,11399917,15.23),(126586,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126586,36.93,0.46,243,57580,70,NULL,NULL,'2MASX J15055077+0253047',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000137,NULL,'17.11',0.44,NULL,NULL,NULL,NULL,NULL,1,226.4615,2.88461,0.117,NULL,59325400001,926959375,14483740,17.11),(126587,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126587,37.14,0.13,268,57581,70,NULL,NULL,'2MASX J15055100+2809447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,226.4625,28.16256,0.053,NULL,60081154068,938768032,14668250,18.22),(126588,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126588,36.83,0.46,232,57582,70,NULL,NULL,'2MASX J15055306+2043202',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.47125,20.72239,0.105,NULL,59535308181,930239190,14534987,17.3),(126589,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126589,35.1,0.48,105,57583,70,NULL,NULL,'2MASX J15055334-1409089',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00014,NULL,'15.68',0.7,NULL,NULL,NULL,NULL,NULL,1,226.472417,-14.15244,0.441,NULL,46663254590,729113352,11392396,15.68),(126590,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126590,35.78,0.73,143,57584,70,NULL,NULL,'2MASX J15055379-0143502',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.8g',0.36,'S0/a',NULL,NULL,NULL,NULL,1,226.474167,-1.73072,0.177,NULL,45367412989,708865827,11076028,15.8),(126591,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126591,38.03,0.16,404,57585,70,NULL,NULL,'SDSS J150554.35+271944.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.4764583,27.32892,0.065,NULL,59897076180,935891815,14623309,17.8),(126592,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126592,36.7,0.51,219,57586,NULL,NULL,'Malmquist cor.','2MASX J15055536+2832247',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000023,NULL,'16.13',0.11,'Sb:',NULL,NULL,NULL,NULL,1,226.480625,28.54022,0.037,NULL,60081213404,938768959,14668264,16.13),(126593,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126593,36.85,0.48,234,57586,NULL,NULL,NULL,'2MASX J15055536+2832247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126594,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126594,36.89,0.2,239,57586,74.4,NULL,NULL,'2MASX J15055536+2832247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126595,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126595,38.2,0.46,437,57587,70,NULL,NULL,'2MASX J15055590+1621457',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.64',0.16,NULL,NULL,NULL,NULL,NULL,1,226.4830417,16.36286,0.037,NULL,59591499170,931117174,14548705,18.64),(126596,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126596,34.13,0.46,66.9,57588,70,NULL,NULL,'ARK 469',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'15.2',0.2,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,226.483917,12.72808,0.073,NULL,59567967172,930749487,14542960,15.2),(126597,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126597,37.75,0.27,355,57589,70,NULL,NULL,'2MASX J15055803+3131085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.4917083,31.51892,0.021,NULL,60084822357,938825349,14669146,17.3),(126598,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126598,38.12,0.33,421,57590,70,NULL,NULL,'2MASX J15055832+0814275',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.492958333,8.24106,0.053,NULL,59384423306,927881614,14498150,17.4),(126599,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126599,37.75,0.27,355,57591,70,NULL,NULL,'2MASX J15055865+3132065',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000196,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.494333,31.53528,0.021,NULL,60084822801,938825356,14669146,17.4),(126600,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126600,37.59,0.46,329,57592,70,NULL,NULL,'2MASX J15055971+1639027',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.12',0.2,NULL,NULL,NULL,NULL,NULL,1,226.498833,16.65072,0.037,NULL,59590993610,931109275,14548582,18.12),(126601,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126601,38.12,0.33,421,57593,70,NULL,NULL,'2MASX J15055994+0812555',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,226.4997083,8.21556,0.053,NULL,59384426123,927881658,14498150,18.4),(126602,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126602,38.11,0.46,418,57594,70,NULL,NULL,'2MASX J15060064+5402265',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.502667,54.04092,0,NULL,59660718292,932198723,14565605,17.5),(126603,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126603,31.91,0.21,24.1,57595,NULL,NULL,'I','NGC 5845',NULL,'2003ApJ...583..712J',2003,1,0.8,NULL,'G',0.000017,NULL,'13.50',0.5,'E:','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.503375,1.63381,0.141,NULL,56374040629,880844384,13763193,13.5),(126604,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126604,32.07,0.21,25.9,57595,NULL,NULL,'I','NGC 5845',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126605,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126605,32.36,0.12,29.7,57595,74.4,NULL,NULL,'NGC 5845',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126606,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126606,32.36,0.12,29.7,57595,74.4,NULL,NULL,'NGC 5845',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126607,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126607,32.27,0.8,28.5,57595,75,NULL,'B','NGC 5845',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126608,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126608,36.22,0.27,175,57596,70,NULL,NULL,'CGCG 076-148',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000163,NULL,'15.1g',0.57,NULL,NULL,NULL,NULL,NULL,1,226.507875,8.78981,0.045,NULL,59388379111,927943423,14499115,15.1),(126609,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126609,35.83,0.53,146,57597,70,NULL,NULL,'2MASX J15060197-1116298',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.11',NULL,NULL,NULL,NULL,NULL,NULL,1,226.508333,-11.27508,0.409,NULL,46484789769,726324840,11348825,16.11),(126610,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126610,37.68,0.46,343,57598,70,NULL,NULL,'2MASX J15060212+0920355',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.508625,9.34317,0.049,NULL,59376819258,927762800,14496293,17.6),(126611,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126611,37.88,0.46,377,57599,70,NULL,NULL,'2MASX J15060289+0525517',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.5122083,5.43089,0.077,NULL,59330280567,927035633,14484931,17.2),(126612,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126612,37.32,0.46,291,57600,70,NULL,NULL,'2MASX J15060323+1027175',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.513375,10.45492,0.077,NULL,59347025797,927297278,14489019,17.6),(126613,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126613,35.68,0.46,137,57601,70,NULL,NULL,'NGC 5862',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000182,NULL,'15.1g',0.61,'E0',NULL,NULL,NULL,NULL,1,226.5137917,55.57386,0,NULL,57580172358,899690193,14057659,15.1),(126614,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126614,37.48,0.46,313,57602,70,NULL,NULL,'SDSS J150603.50+152029.4',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.514583,15.3415,0.041,NULL,59577029234,930891081,14545173,17.1),(126615,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126615,36.94,0.46,244,57603,70,NULL,NULL,'2MASX J15060559+2032162',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.45',0.23,NULL,NULL,NULL,NULL,NULL,1,226.523333,20.53789,0.113,NULL,59535312913,930239264,14534988,16.45),(126616,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126616,36.58,0.33,207,57604,70,NULL,NULL,'2MASX J15060439+4620074',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000188,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.5284583,46.33522,0.045,NULL,59984312172,937254877,14644607,16.4),(126617,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126617,37.64,0.46,337,57605,70,NULL,NULL,'2MASX J15060686+0303057',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.528625,3.05147,0.113,NULL,59325384557,926959133,14483736,17.9),(126618,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126618,38.16,0.46,428,57606,70,NULL,NULL,'2MASX J15060780+5019452',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.532667,50.32911,0.017,NULL,59942664838,936604138,14634439,17.3),(126619,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126619,38.03,0.16,404,57607,70,NULL,NULL,'2MASX J15060788+2708397',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.5327083,27.14431,0.073,NULL,59897078750,935891855,14623310,17.5),(126620,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126620,35.92,0.33,152,57608,NULL,NULL,'Malmquist cor.','ESO 328- G 016',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'13.14',0.6,'Sb-c     poss. LINER',NULL,NULL,NULL,NULL,1,226.5340417,-39.91789,0.085,NULL,47186866764,737294793,11520231,13.14),(126621,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126621,36.21,0.29,175,57608,NULL,NULL,NULL,'ESO 328- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126622,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126622,36.25,0.2,178,57608,74.4,NULL,NULL,'ESO 328- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126623,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126623,37.69,0.46,344,57609,70,NULL,NULL,'2MASX J15060880-0054143',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000076,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.5367917,-0.90411,0.165,NULL,45369568637,708899509,11076554,17.4),(126624,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126624,34,0.69,63.1,57610,100,NULL,'mid-IR','UGC 09705',NULL,'2013ApJ...771...88L',2013,1,0.91,NULL,'G',0.00009,NULL,'14.6g',0.55,'S0/a',NULL,NULL,NULL,NULL,1,226.539041667,25.78278,0.117,NULL,59895008170,935859502,14622804,14.6),(126625,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126625,35.95,0.2,155,57610,74.4,NULL,NULL,'UGC 09705',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126626,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126626,35.76,0.46,142,57611,70,NULL,NULL,'CGCG 048-117',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.00012,NULL,'14.9g',0.58,'BrClG','Group member',NULL,NULL,NULL,1,226.539917,3.67506,0.105,NULL,59338989031,927171703,14487057,14.9),(126627,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126627,37.5,0.46,317,57612,70,NULL,NULL,'2MASX J15061085+5942114',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000068,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.5452083,59.70314,0.021,NULL,57775310840,902739231,14105300,17.6),(126628,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126628,36.36,0.46,187,57613,70,NULL,NULL,'2MASX J15061096+1947082',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.75',0.23,NULL,NULL,NULL,NULL,NULL,1,226.545583,19.78556,0.077,NULL,59536761364,930261896,14535342,16.75),(126629,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126629,37.64,0.46,337,57614,70,NULL,NULL,'2MASX J15061118+0106522',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.5465,1.11442,0.129,NULL,56375594769,880868668,13763572,16.8),(126630,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126630,37.4,0.33,302,57615,70,NULL,NULL,'2MASX J15061139+2055532',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.547458333,20.93142,0.105,NULL,59535418483,930240913,14535014,17.4),(126631,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126631,34.68,0.49,86.3,57616,75,NULL,'IR','FGC 1856',NULL,'2011yCatp016004901K',2011,1,0.99,'The 2MASX position is for the northern end of the galaxy.','G',0.000105,NULL,'16.1g',0.18,'Sc',NULL,NULL,NULL,NULL,1,226.547667,48.62972,0,NULL,59939434356,936553661,14633650,16.1),(126632,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126632,34.84,NULL,92.9,57616,NULL,NULL,NULL,'FGC 1856',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126633,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126633,34.87,NULL,94.2,57616,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126634,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126634,34.9,NULL,95.6,57616,NULL,NULL,'Dipole + Quadrupole','FGC 1856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126635,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126635,34.93,NULL,96.9,57616,NULL,NULL,'Dipole','FGC 1856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126636,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126636,36.5,0.27,199,57617,70,NULL,NULL,'CGCG 048-118',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000123,NULL,'14.9g',0.71,'BrClG',NULL,NULL,NULL,NULL,1,226.548667,3.14258,0.109,NULL,59339064430,927172881,14487076,14.9),(126637,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126637,36.19,0.21,173,57618,70,NULL,NULL,'2MASX J15061220+0523342',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.550917,5.39272,0.077,NULL,59330269116,927035454,14484928,16.4),(126638,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126638,38.6,0.33,524,57619,70,NULL,NULL,'SDSS J150612.32+524715.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.551375,52.78767,0.041,NULL,59931635098,936431798,14631746,18.3),(126639,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126639,37.68,0.33,343,57620,70,NULL,NULL,'2MASX J15061242+3355107',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.55175,33.91953,0,NULL,60115538411,939305287,14676645,16.4),(126640,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126640,36.12,0.49,168,57621,75,NULL,'IR','CGCG 135-012',NULL,'2011yCatp016004901K',2011,1,0.79,NULL,'G',0.000081,NULL,'15.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.5540417,25.60769,0.117,NULL,59895134337,935861474,14622835,15.9),(126641,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126641,37.4,0.33,302,57622,70,NULL,NULL,'2MASXi J1506143+205135',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.559667,20.85964,0.101,NULL,59535410681,930240791,14535012,17.7),(126642,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126642,36.5,0.27,199,57623,70,NULL,NULL,'2MASX J15061597+0308342',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00009,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.566625,3.14292,0.109,NULL,59339064477,927172882,14487076,17.1),(126643,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126643,38.53,0.46,507,57624,70,NULL,NULL,'2MASX J15061687+2046162',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.5702917,20.77128,0.101,NULL,59535490091,930242032,14535031,17.6),(126644,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126644,38.16,0.46,428,57625,70,NULL,NULL,'2MASX J15061788+3651063',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.5744583,36.85186,0.017,NULL,60119934769,939373980,14677718,17.6),(126645,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126645,36.4,0.46,191,57626,70,NULL,NULL,'2MASX J15061790+6107524',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.574625,61.13125,0.013,NULL,57778430292,902787973,14106062,16.5),(126646,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126646,37.68,0.55,343,57627,NULL,NULL,'Malmquist cor.','AGC 251802',NULL,'2009ApJS..182..474S',2009,1,0.26,NULL,'G',0.00003,NULL,'17.70',0.07,'Sc',NULL,NULL,NULL,NULL,1,226.575083,28.72828,0.041,NULL,60080346345,938755411,14668053,17.7),(126647,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126647,37.71,0.54,349,57627,NULL,NULL,NULL,'AGC 251802',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126648,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126648,37.76,0.2,356,57627,74.4,NULL,NULL,'AGC 251802',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126649,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126649,36.19,0.66,173,57628,70,NULL,NULL,'2MASX J15061928-0146403',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.1g',0.25,'S0',NULL,NULL,NULL,NULL,1,226.580417,-1.77789,0.177,NULL,45367369497,708865148,11076017,16.1),(126650,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126650,36.71,0.46,220,57629,70,NULL,NULL,'2MASX J15061937+2930305',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000137,NULL,'17.57',0.19,'Sa',NULL,NULL,NULL,NULL,1,226.580667,29.50842,0.037,NULL,60094844583,938981946,14671592,17.57),(126651,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126651,37.32,0.46,291,57630,70,NULL,NULL,'2MASX J15061938+0324392',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000095,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.580833,3.41086,0.109,NULL,59339124066,927173813,14487090,16.5),(126652,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126652,34.61,0.54,83.5,57631,NULL,NULL,NULL,'ESO 328- G 017',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.16',0.4,'S...',NULL,NULL,NULL,NULL,1,226.582,-41.03028,0.289,NULL,47065289242,735395144,11490549,14.16),(126653,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126653,34.65,0.2,85.1,57631,74.4,NULL,NULL,'ESO 328- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126654,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126654,34.8,0.49,91.3,57631,NULL,NULL,'Malmquist cor.','ESO 328- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126655,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126655,37.92,0.46,384,57632,70,NULL,NULL,'2MASX J15062021+4508524',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.584375,45.14786,0.053,NULL,59993749260,937402332,14646911,16.9),(126656,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126656,36.5,0.27,199,57633,70,NULL,NULL,'2MASX J15062111+0309442',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.587875,3.16219,0.109,NULL,59339142215,927174097,14487095,16.7),(126657,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126657,36.75,0.33,224,57634,70,NULL,NULL,'2MASX J15062136+3634313',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.588875,36.57533,0.013,NULL,60119194678,939362416,14677537,17.3),(126658,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126658,37.75,0.27,355,57635,70,NULL,NULL,'2MASX J15062188+3131447',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.5912083,31.52917,0.021,NULL,60084826228,938825409,14669147,17.6),(126659,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126659,38.25,0.46,447,57636,70,NULL,NULL,'2MASX J15062195+3115267',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000193,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.591333,31.25731,0.025,NULL,60086587064,938852922,14669576,16.8),(126660,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126660,36.94,0.46,244,57637,70,NULL,NULL,'2MASX J15062195+2034181',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.591583,20.57164,0.105,NULL,59535286029,930238844,14534981,16.4),(126661,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126661,37.51,0.46,318,57638,70,NULL,NULL,'2MASX J15062197+0830456',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.591667,8.51272,0.041,NULL,59389052625,927953947,14499280,17.9),(126662,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126662,35.33,0.48,117,57639,70,NULL,NULL,'CGCG 020-060',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000087,NULL,'15.1g',0.63,'E0',NULL,NULL,NULL,NULL,1,226.5927917,-1.75183,0.173,NULL,45367337401,708864646,11076010,15.1),(126663,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126663,35.8,0.33,145,57639,70,NULL,NULL,'CGCG 020-060',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126664,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126664,38.11,0.46,420,57640,70,NULL,NULL,'2MASX J15062285+0539272',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.5952083,5.65761,0.113,NULL,59330185103,927034142,14484908,17),(126665,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126665,37.42,0.46,305,57641,70,NULL,NULL,'2MASX J15062337+0809186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.597333,8.155,0.053,NULL,59384449967,927882030,14498156,17.1),(126666,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126666,37.67,0.46,341,57642,70,NULL,NULL,'2MASX J15062429+1148475',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.95',0.15,NULL,NULL,NULL,NULL,NULL,1,226.6012917,11.81303,0.149,NULL,59345918700,927279979,14488749,18.95),(126667,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126667,34.67,0.53,86,57643,70,NULL,NULL,'MCG -02-38-034',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000143,NULL,'14.80',0.2,NULL,NULL,NULL,NULL,NULL,1,226.6025417,-9.90711,0.405,NULL,46490858690,726419667,11350307,14.8),(126668,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126668,34.47,0.46,78.3,57644,70,NULL,NULL,'2MASX J15062613-1407010',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'15.25',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,226.6089583,-14.11697,0.441,NULL,46663425953,729116030,11392437,15.25),(126669,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126669,36.75,0.33,224,57645,70,NULL,NULL,'2MASX J15062625+3636214',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000186,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,226.6094583,36.60594,0.013,NULL,60119193527,939362398,14677537,15.6),(126670,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126670,37.85,0.46,372,57646,70,NULL,NULL,'2MASX J15062663+5226493',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.610917,52.44703,0.033,NULL,59930818147,936419033,14631547,17.8),(126671,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126671,35.61,0.46,133,57647,70,NULL,NULL,'2MASX J15062843+3825324',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000167,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,226.618417,38.42586,0.029,NULL,60103859095,939122798,14673793,15.8),(126672,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126672,36.58,0.33,207,57648,70,NULL,NULL,'MCG +08-27-065',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000186,NULL,'15.3g',0.58,'S0/a',NULL,NULL,NULL,NULL,1,226.6189583,46.34422,0.045,NULL,59984312679,937254885,14644607,15.3),(126673,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126673,32.27,0.8,28.5,57649,75,NULL,'B','NGC 5846A',NULL,'1988NBGC.C....0000T',1988,1,0.4,'Called \'NGC 5846b\' in MCG.','G',0.000047,NULL,'14.1',0.3,'cE2-3','is a companion galaxy',NULL,NULL,NULL,1,226.621667,1.59486,0.141,NULL,56373927838,880842622,13763165,14.1),(126674,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126674,32.1,0.2,26.3,57650,NULL,NULL,'TOM(V) = -7.3 mag','NGC 5846',NULL,'2009ApJ...690..512H',2009,1,4.1,'Called \'NGC 5846a\' in MCG.','G',0.000017,NULL,'11.05',3.8,'E0-1;LINER     HII','Parent (of companion) galaxy',NULL,NULL,NULL,1,226.622,1.60561,0.141,NULL,56373926986,880842609,13763165,11.05),(126675,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126675,32.32,0.23,29.1,57650,NULL,NULL,NULL,'NGC 5846',NULL,'1996AJ....112.2448F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126676,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126676,32.41,0.1,30.3,57650,NULL,NULL,NULL,'NGC 5846',NULL,'2002ApJ...567..294O',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126677,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126677,32.61,0.28,33.3,57650,NULL,NULL,'HST KP Calibrated, V','NGC 5846',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126678,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126678,31.98,0.2,24.9,57650,NULL,NULL,'I','NGC 5846',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126679,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126679,31.98,0.2,24.9,57650,NULL,NULL,NULL,'NGC 5846',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126680,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126680,31.99,0.12,25,57650,74.4,NULL,NULL,'NGC 5846',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126681,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126681,32.04,0.2,25.6,57650,NULL,NULL,'Malmquist cor.','NGC 5846',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126682,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126682,32.05,0.22,25.7,57650,NULL,NULL,'HST KP Calibrated, I','NGC 5846',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126683,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126683,32.22,0.4,27.7,57650,75,NULL,'Edat, raw','NGC 5846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126684,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126684,32.37,0.4,29.7,57650,75,NULL,'Edat, cor','NGC 5846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126685,'D-Sigma','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126685,32.46,0.17,31.1,57650,72,NULL,'HDCE 0897 Group; HG 50 Group, 7 galaxies','NGC 5846',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126686,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126686,30.71,0.35,13.9,57650,95,NULL,'de Vaucouleurs','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126687,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126687,31.26,0.25,17.9,57650,95,NULL,'Weighted Mean','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126688,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126688,31.49,NULL,19.9,57650,NULL,NULL,'LEDA [April 2006]','NGC 5846',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126689,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126689,32.02,0.46,25.4,57650,95,NULL,'Michard 1979a','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126690,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126690,32.32,0.63,29.1,57650,95,NULL,'Michard 1979b, c','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126691,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126691,33.9,0.81,60.3,57650,55,NULL,'Visvanathan & Sandage 1979','NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126692,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126692,31.72,0.41,22,57650,NULL,NULL,NULL,'NGC 5846',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126693,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126693,31.97,0.41,24.8,57650,NULL,NULL,'Malmquist cor.','NGC 5846',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126694,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126694,31.99,0.12,25,57650,74.4,NULL,NULL,'NGC 5846',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126695,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126695,31.08,0.25,16.4,57650,95,NULL,NULL,'NGC 5846',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126696,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126696,32.27,0.4,28.5,57650,75,NULL,'B','NGC 5846',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126697,'GCLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126697,30.75,0.1,14.1,57651,NULL,NULL,'TOM(V) = 7.29 mag','NGC 5866',NULL,'2007ApJ...668..209C',2007,1,4.7,'z=0.002242 (1988AJ.....95.1602S), this may be M102','G',0.000017,NULL,'10.74',1.9,'S0_3       HII/LINER','X-ray-faint group member',NULL,NULL,'Sy',1,226.622917,55.76322,0,NULL,57579937041,899686516,14057601,10.74),(126698,'PNLF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126698,30.73,0.12,14,57651,NULL,NULL,NULL,'NGC 5866',NULL,'2002ApJ...577...31C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126699,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126699,30.84,0.14,14.7,57651,74.4,NULL,NULL,'NGC 5866',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126700,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126700,30.93,0.12,15.3,57651,NULL,NULL,'I','NGC 5866',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126701,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126701,29.12,0.63,6.67,57651,95,NULL,'Michard 1979b, c','NGC 5866',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126702,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126702,29.71,0.37,8.75,57651,95,NULL,'Weighted Mean','NGC 5866',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126703,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126703,29.84,0.46,9.29,57651,95,NULL,'Michard 1979a','NGC 5866',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126704,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126704,30.21,NULL,11,57651,NULL,NULL,'LEDA [April 2006]','NGC 5866',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126705,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126705,31.18,0.81,17.2,57651,55,NULL,'Visvanathan & Sandage 1979','NGC 5866',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126706,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126706,30.92,0.8,15.3,57651,75,NULL,'B','NGC 5866',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126707,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126707,29.66,0.45,8.54,57651,NULL,NULL,'K','NGC 5866',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126708,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126708,30.2,0.4,10.9,57651,NULL,NULL,'mean','NGC 5866',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126709,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126709,38.03,0.16,404,57652,70,NULL,NULL,'SDSS J150629.79+265242.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.624167,26.87856,0.085,NULL,59898119020,935908109,14623564,17.9),(126710,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126710,36.61,0.33,210,57653,70,NULL,NULL,'2MASX J15063058+3857084',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,226.6274583,38.95239,0.025,NULL,60100688440,939073256,14673019,16.2),(126711,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126711,38.58,0.46,520,57654,70,NULL,NULL,'2MASX J15063089-0221003',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.628875,-2.35008,0.221,NULL,46441500452,725648444,11338256,18.4),(126712,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126712,36.89,0.46,238,57655,70,NULL,NULL,'2MASX J15063135+0756278',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.6305417,7.94111,0.057,NULL,59384528720,927883261,14498175,17.1),(126713,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126713,36.99,0.46,250,57656,70,NULL,NULL,'2MASX J15063204+4526231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.6337083,45.43981,0.045,NULL,59993545331,937399145,14646861,17),(126714,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126714,33.52,NULL,50.7,57657,NULL,NULL,NULL,'FGC 1854',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.00001,NULL,'16.26',0.1,'Sdm',NULL,NULL,NULL,NULL,1,226.638791667,-12.71706,0.381,NULL,46662410369,729100162,11392190,16.26),(126715,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126715,33.56,NULL,51.6,57657,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126716,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126716,33.57,NULL,51.9,57657,NULL,NULL,'Dipole + Quadrupole','FGC 1854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126717,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126717,33.58,NULL,51.9,57657,NULL,NULL,'Dipole','FGC 1854',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126718,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126718,35.8,0.33,145,57658,70,NULL,NULL,'2MASX J15063422-0151293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.29,'E0',NULL,NULL,NULL,NULL,1,226.6427083,-1.85825,0.177,NULL,45367362908,708865045,11076016,16.3),(126719,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126719,36,0.61,159,57658,70,NULL,NULL,'2MASX J15063422-0151293',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126720,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126720,37.36,0.46,297,57659,70,NULL,NULL,'SDSS J150635.77+140458.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.649083,14.083,0.061,NULL,59570108044,930782938,14543483,17.9),(126721,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126721,37.43,0.17,306,57660,70,NULL,NULL,'2MASX J15063614-0117533',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.6505417,-1.29822,0.165,NULL,45369627127,708900423,11076569,16.9),(126722,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126722,36.3,0.46,182,57661,70,NULL,NULL,'2MASX J15063617+0938578',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.0001,NULL,'15.2g',0.55,NULL,NULL,NULL,NULL,NULL,1,226.650583,9.6495,0.061,NULL,59376779357,927762177,14496284,15.2),(126723,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126723,37.23,0.46,279,57662,70,NULL,NULL,'SDSS J150636.28+162614.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.651167,16.4375,0.037,NULL,59590968842,931108888,14548576,18.2),(126724,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126724,33.8,0.48,57.5,57663,70,NULL,NULL,'ESO 328- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000083,NULL,'14',0.9,'S0',NULL,NULL,NULL,NULL,1,226.65425,-41.31986,0.289,NULL,47064642275,735385035,11490391,14),(126725,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126725,37.83,0.46,368,57664,70,NULL,NULL,'NGC 5846 CH02',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.6555,1.22917,0.129,NULL,56375537841,880867778,13763559,17.1),(126726,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126726,36.43,0.46,194,57665,70,NULL,NULL,'2MASX J15063885+4456031',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00019,NULL,'15.7g',0.44,'E0',NULL,NULL,NULL,NULL,1,226.661791667,44.93431,0.049,NULL,59993666799,937401043,14646891,15.7),(126727,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126727,37.02,0.46,253,57666,70,NULL,NULL,'2MASX J15063887+3559374',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.662083,35.99375,0.013,NULL,60128313644,939504900,14679764,17.2),(126728,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126728,37.43,0.17,306,57667,70,NULL,NULL,'SDSS J150639.65-011551.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.66525,-1.26444,0.193,NULL,45369627791,708900434,11076569,18.3),(126729,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126729,37,0.46,251,57668,70,NULL,NULL,'2MASXi J1506399+374415',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.666667,37.73761,0.017,NULL,60119473292,939366770,14677605,17.4),(126730,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126730,37.05,0.46,257,57669,70,NULL,NULL,'SDSS J150640.02+021726.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.6667917,2.29064,0.109,NULL,56374463749,880850996,13763296,17.2),(126731,'FP','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,'R',126731,36.61,0.33,210,57670,70,NULL,NULL,'2MASX J15064164+3854074',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.6735417,38.90192,0.025,NULL,60100677089,939073079,14673016,17.3),(126732,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:44','1',NULL,NULL,126732,34.29,0.2,72.1,57671,74.4,NULL,NULL,'CGCG 077-006',NULL,'2013AJ....146...86T',2013,1,0.8,'HOLM 695B is a star.','G',0.000137,NULL,'14.9',0.8,NULL,NULL,NULL,NULL,NULL,1,226.67525,12.67644,0.109,NULL,59568020894,930750326,14542973,14.9),(126733,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126733,36.4,0.46,190,57672,70,NULL,NULL,'2MASX J15064216+2559425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.675625,25.99519,0.117,NULL,59894995220,935859300,14622801,16.9),(126734,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126734,35.95,0.33,155,57673,70,NULL,NULL,'UGC 09719',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000203,NULL,'14.8g',0.59,'COMPACT',NULL,NULL,NULL,NULL,1,226.6765,40.58067,0.029,NULL,59970592219,937040503,14641257,14.8),(126735,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126735,37.43,0.17,306,57674,70,NULL,NULL,'2MASX J15064238-0117092',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,226.676583,-1.28583,0.193,NULL,45369645433,708900709,11076573,16.4),(126736,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126736,37.43,0.17,306,57675,70,NULL,NULL,'2MASX J15064331-0121082',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.6805,-1.35222,0.165,NULL,45369598947,708899983,11076562,17.5),(126737,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126737,36.19,0.21,173,57676,70,NULL,NULL,'CGCG 049-003',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000157,NULL,'15.5',0.47,NULL,NULL,NULL,NULL,NULL,1,226.6809583,5.32719,0.077,NULL,59332431610,927069243,14485456,15.5),(126738,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126738,37.57,0.33,327,57677,70,NULL,NULL,'2MASX J15064395+0959578',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.683,9.99944,0.061,NULL,59346387959,927287311,14488864,17.7),(126739,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126739,38.6,0.33,524,57678,70,NULL,NULL,'2MASX J15064445+5248094',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.685083333,52.80253,0.037,NULL,59930581098,936415329,14631489,17.8),(126740,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126740,37.4,0.46,302,57679,70,NULL,NULL,'SDSS J150644.54+135011.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.685583,13.83642,0.077,NULL,59571139967,930799061,14543735,18.3),(126741,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126741,37.12,0.46,265,57680,70,NULL,NULL,'2MASX J15064480+2012112',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.85',0.16,NULL,NULL,NULL,NULL,NULL,1,226.686791667,20.20308,0.097,NULL,59537345331,930271020,14535484,17.85),(126742,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126742,34.29,0.49,72.1,57681,75,NULL,'IR','UGC 09712',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00003,NULL,'15.02',0.3,'Scd:',NULL,NULL,NULL,NULL,1,226.688333,12.56139,0.113,NULL,59568016145,930750252,14542972,15.02),(126743,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126743,34.68,0.2,86.3,57681,74.4,NULL,NULL,'UGC 09712',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126744,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126744,36.98,0.46,249,57682,70,NULL,NULL,'2MASX J15064613-0149212',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.692125,-1.82264,0.173,NULL,45367330263,708864535,11076008,17.6),(126745,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126745,38.34,0.46,465,57683,70,NULL,NULL,'SDSS J150646.36+084955.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.6932083,8.83206,0.045,NULL,59388351157,927942986,14499109,18.7),(126746,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126746,36.76,0.46,225,57684,70,NULL,NULL,'2MASX J15064725+2207203',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.98',0.19,NULL,NULL,NULL,NULL,NULL,1,226.696791667,22.12239,0.097,NULL,59527874802,930123043,14533172,16.98),(126747,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126747,37.57,0.33,327,57685,70,NULL,NULL,'SDSS J150648.11+095637.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.7004583,9.94375,0.061,NULL,59346388558,927287321,14488864,18.4),(126748,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126748,36.27,0.82,179,57686,70,NULL,NULL,'LCRS B150404.8-114604',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,226.703083,-11.95994,0.385,NULL,46481773275,726277707,11348089,16.8),(126749,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126749,36.06,0.46,163,57687,70,NULL,NULL,'2MASX J15064880+0844398',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.7032917,8.74433,0.045,NULL,59388392494,927943632,14499119,16.8),(126750,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126750,35.56,0.58,129,57688,70,NULL,NULL,'NGC 5849',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00011,NULL,'15',0.8,'poss. LINER',NULL,NULL,NULL,NULL,1,226.711208333,-14.57183,0.449,NULL,46663276372,729113693,11392401,15),(126751,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126751,37.46,0.27,310,57689,70,NULL,NULL,'2MASX J15065196+1033068',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.716416667,10.552,0.089,NULL,59347038133,927297470,14489022,18),(126752,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126752,38.43,0.46,484,57690,70,NULL,NULL,'SDSS J150652.62+151710.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.24',0.1,NULL,NULL,NULL,NULL,NULL,1,226.7187083,15.28642,0.061,NULL,59577202685,930893791,14545215,19.24),(126753,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126753,34.97,0.4,98.6,57691,NULL,NULL,'mean','NGC 5851',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000137,NULL,'15.04',0.3,'S?             LINER','in a pair',NULL,NULL,'LINER',1,226.722583333,12.85886,0.105,NULL,59567888635,930748259,14542941,15.04),(126754,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126754,35.04,0.47,102,57691,NULL,NULL,'H','NGC 5851',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126755,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126755,37.54,0.46,321,57692,70,NULL,NULL,'2MASX J15065390+3911441',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.724417,39.19553,0.037,NULL,60100572512,939071445,14672991,17.8),(126756,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126756,37.37,0.27,298,57693,70,NULL,NULL,'2MASX J15065403+1134028',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.7252917,11.56744,0.089,NULL,59348682277,927323160,14489424,17.7),(126757,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126757,37.83,0.46,368,57694,70,NULL,NULL,'2MASX J15065419+1529185',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.72575,15.48847,0.041,NULL,59577174983,930893359,14545208,NULL),(126758,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126758,37.43,0.17,306,57695,70,NULL,NULL,'2MASX J15065418-0107351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.725833,-1.1265,0.193,NULL,45369732773,708902074,11076594,17.5),(126759,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126759,37.37,0.27,298,57696,70,NULL,NULL,'2MASX J15065525+1120408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.730125,11.34456,0.065,NULL,59349065357,927329146,14489517,17.4),(126760,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126760,37.52,0.46,319,57697,70,NULL,NULL,'2MASX J15065553+0835528',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000185,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,226.731583333,8.59789,0.041,NULL,59388336604,927942759,14499105,18.53),(126761,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126761,38.6,0.46,524,57698,70,NULL,NULL,'SDSS J150656.22+182919.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.73425,18.48878,0.053,NULL,59581916809,930967450,14546366,18.6),(126762,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126762,37.46,0.27,310,57699,70,NULL,NULL,'SDSS J150656.33+102606.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.734708333,10.43511,0.073,NULL,59346988208,927296690,14489010,18),(126763,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126763,37.46,0.27,310,57700,70,NULL,NULL,'2MASX J15065670+1027028',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,226.736333,10.45083,0.073,NULL,59346987554,927296680,14489010,16.3),(126764,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126764,37.42,0.46,304,57701,70,NULL,NULL,'2MASX J15065699+1819323',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.737583333,18.32569,0.037,NULL,59581844450,930966319,14546348,17.7),(126765,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126765,38.02,0.46,402,57702,70,NULL,NULL,'2MASX J15065745+0905478',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.7394583,9.09661,0.033,NULL,59388438076,927944344,14499130,17.6),(126766,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126766,37.43,0.17,306,57703,70,NULL,NULL,'2MASX J15065811-0105481',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000081,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.7422083,-1.09669,0.193,NULL,45369731590,708902056,11076594,17.8),(126767,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126767,38.06,0.46,409,57704,70,NULL,NULL,'2MASX J15065838+1259145',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.743375,12.98739,0.069,NULL,59567845100,930747579,14542930,17.9),(126768,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126768,37.85,0.33,372,57705,70,NULL,NULL,'SDSS J150658.44+071202.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.7435417,7.20064,0.045,NULL,59386196359,927909318,14498583,18.3),(126769,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126769,38.36,0.46,469,57706,70,NULL,NULL,'2MASX J15065852+4802503',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.744,48.04728,0.009,NULL,59939712943,936558014,14633718,17.9),(126770,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126770,36.98,0.46,249,57707,70,NULL,NULL,'SDSS J150659.59+323039.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.748333,32.51103,0.065,NULL,60085093268,938829582,14669212,17.9),(126771,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126771,37.72,0.46,349,57708,70,NULL,NULL,'2MASX J15065978+0627346',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.749208333,6.4595,0.057,NULL,59385560424,927899381,14498427,17.7),(126772,'Magnetic energy','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126772,21.28,NULL,0.18,57709,NULL,NULL,'1.7 microgauss, Vorster et al. 2013','2FGL J1507.0-6223',NULL,'2014arXiv1404.0889D',2014,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.752,-62.397,NULL,0,44880809418,701262647,10957228,NULL),(126773,'Magnetic energy','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126773,28.01,NULL,4,57709,NULL,NULL,'1 microgauss','2FGL J1507.0-6223',NULL,'2014arXiv1404.0889D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126774,'Magnetic energy','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126774,35,NULL,100,57709,NULL,NULL,'hadronic senario','2FGL J1507.0-6223',NULL,'2014arXiv1404.0889D',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126775,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126775,35.67,0.46,136,57710,70,NULL,NULL,'CGCG 135-017',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000177,NULL,'14.9g',0.63,NULL,NULL,NULL,NULL,NULL,1,226.752625,25.75417,0.117,NULL,59895038648,935859978,14622812,14.9),(126776,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126776,37.53,0.15,320,57711,70,NULL,NULL,'2MASX J15070116+0844026',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.754958333,8.73403,0.045,NULL,59388357433,927943084,14499110,17.4),(126777,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126777,37.83,0.46,369,57712,70,NULL,NULL,'SDSS J150701.46+034609.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,226.756125,3.76936,0.089,NULL,59330674627,927041791,14485027,18.3),(126778,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126778,36.01,0.46,159,57713,70,NULL,NULL,'2MASX J15070302+0353404',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.1g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,226.762583,3.8945,0.089,NULL,59331395582,927053055,14485203,16.1),(126779,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126779,36.11,0.8,167,57714,75,NULL,'CF, r','UGC 09718',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00001,NULL,'14.93',0.5,'Sb',NULL,NULL,NULL,NULL,1,226.76725,21.21067,0.117,NULL,59535917138,930248705,14535136,14.93),(126780,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126780,35.55,0.38,129,57714,75,NULL,'CF, r, raw','UGC 09718',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126781,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126781,35.74,0.38,140,57714,75,NULL,'CF, r, inv','UGC 09718',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126782,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126782,35.85,0.38,148,57714,75,NULL,'CF, r, cor','UGC 09718',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126783,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126783,36.31,0.2,183,57714,74.4,NULL,NULL,'UGC 09718',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126784,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126784,37.37,0.27,298,57715,70,NULL,NULL,'2MASX J15070450+1132196',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.83',0.22,NULL,NULL,NULL,NULL,NULL,1,226.768875,11.53869,0.089,NULL,59349141635,927330338,14489536,17.83),(126785,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126785,37.53,0.15,320,57716,70,NULL,NULL,'2MASX J15070460+0845066',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.7692917,8.75175,0.045,NULL,59388357144,927943080,14499110,17.1),(126786,'Ring Diameter','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126786,30.7,0.84,14,57717,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5850',NULL,'1981ApJS...45..541P',1981,1,4.3,NULL,'G',0.000013,NULL,'12.7g',3.7,'SB(r)b','in a pair',NULL,NULL,NULL,1,226.782041667,1.54425,0.145,NULL,56373870701,880841729,13763152,12.7),(126787,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126787,31.25,NULL,17.8,57717,NULL,NULL,'B','NGC 5850',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126788,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126788,32.27,0.4,28.5,57717,75,NULL,'B','NGC 5850',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126789,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126789,37.66,0.46,340,57718,70,NULL,NULL,'2MASX J15070837+0748396',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,226.784875,7.81106,0.057,NULL,59384377274,927880894,14498138,16.9),(126790,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126790,37.14,0.13,268,57719,70,NULL,NULL,'2MASX J15070904+2823181',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.74',0.14,NULL,NULL,NULL,NULL,NULL,1,226.78775,28.38828,0.045,NULL,60080435206,938756800,14668075,18.74),(126791,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126791,35.95,0.33,155,57720,70,NULL,NULL,'2MASX J15070971+4051132',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000189,NULL,'15.9g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,226.790625,40.85375,0.029,NULL,59970980894,937046576,14641352,15.9),(126792,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126792,38.6,0.33,524,57721,70,NULL,NULL,'SDSS J150710.20-021210.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000179,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.7925417,-2.203,0.213,NULL,45367551386,708867990,11076062,18.6),(126793,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126793,38.12,0.46,420,57722,70,NULL,NULL,'2MASX J15071141+1617155',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.7975417,16.28769,0.037,NULL,59582331786,930973934,14546467,NULL),(126794,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126794,35.79,0.46,144,57723,70,NULL,NULL,'2MASX J15071294+0401061',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,226.803875,4.01833,0.085,NULL,59331433084,927053641,14485213,16.5),(126795,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126795,38.03,0.46,403,57724,70,NULL,NULL,'2MASX J15071385+1706485',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.15,NULL,NULL,NULL,NULL,NULL,1,226.807625,17.11353,0.037,NULL,59582872555,930982383,14546599,18.68),(126796,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126796,38.14,0.46,425,57725,70,NULL,NULL,'2MASX J15071422+2259463',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.80925,22.99608,0.113,NULL,59409765732,928277589,14504337,17.6),(126797,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126797,37.43,0.17,306,57726,70,NULL,NULL,'2MASX J15071569-0116580',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.815583,-1.28275,0.193,NULL,45369618201,708900284,11076566,17.2),(126798,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126798,37.9,0.46,381,57727,70,NULL,NULL,'2MASX J15071604+5407481',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.816708333,54.13014,0.021,NULL,59660813897,932200217,14565628,17.8),(126799,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126799,38.63,0.46,532,57728,70,NULL,NULL,'SDSS J150717.14+101318.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.8214583,10.22186,0.069,NULL,59347145714,927299151,14489049,17.9),(126800,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126800,37.85,0.33,372,57729,70,NULL,NULL,'SDSS J150717.18+071105.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.821625,7.18481,0.045,NULL,59386193073,927909266,14498582,18.1),(126801,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126801,38.6,0.33,524,57730,70,NULL,NULL,'SDSS J150718.19-021749.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.825833,-2.29708,0.213,NULL,45366809165,708856393,11075881,18.1),(126802,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126802,37.59,0.46,330,57731,70,NULL,NULL,'2MASX J15071893+1638034',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.15',0.2,NULL,NULL,NULL,NULL,NULL,1,226.829,16.63439,0.037,NULL,59582800570,930981258,14546582,18.15),(126803,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126803,37.5,0.46,316,57732,70,NULL,NULL,'2MASX J15071918+0652466',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.8299583,6.87961,0.049,NULL,59386507133,927914173,14498658,17.1),(126804,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126804,36.77,0.46,225,57733,70,NULL,NULL,'2MASX J15071993+1058426',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.8329583,10.97858,0.073,NULL,59348992622,927328009,14489500,16.6),(126805,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126805,38.04,0.33,405,57734,70,NULL,NULL,'2MASX J15072006+0703406',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.8335,7.06144,0.045,NULL,59387076184,927923065,14498797,17.3),(126806,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126806,37.95,0.14,390,57735,70,NULL,NULL,'2MASX J15072007-0021590',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.8337917,-0.3665,0.169,NULL,45368185766,708877902,11076217,18.1),(126807,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126807,35.22,0.54,111,57736,70,NULL,NULL,'2MASX J15072054-3835425',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'13.6I',0.6,NULL,NULL,NULL,NULL,NULL,1,226.8355,-38.59511,0.233,NULL,47189380988,737334077,11520844,13.6),(126808,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126808,35.99,0.7,158,57737,70,NULL,NULL,'2MASX J15072131-3836295',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,226.838917,-38.60828,0.233,NULL,47189381104,737334079,11520844,14.5),(126809,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126809,36.24,0.27,177,57738,70,NULL,NULL,'2MASX J15072141+1608224',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.95',0.2,NULL,NULL,NULL,NULL,NULL,1,226.839167,16.13956,0.037,NULL,59590677153,931104330,14548505,16.95),(126810,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126810,36.43,0.46,193,57739,70,NULL,NULL,'CGCG 077-013',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000153,NULL,'15.0g',0.55,NULL,NULL,NULL,NULL,NULL,1,226.839667,9.92808,0.061,NULL,59346399337,927287489,14488867,15),(126811,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126811,37.74,0.46,352,57740,70,NULL,NULL,'2MASX J15072173+2659239',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.40',0.17,NULL,NULL,NULL,NULL,NULL,1,226.8405,26.99014,0.085,NULL,59898284631,935910697,14623604,18.4),(126812,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126812,36.24,0.27,177,57741,70,NULL,NULL,'SDSS J150722.10+161501.5',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.6g',0.46,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.842083,16.25044,0.037,NULL,59582324598,930973821,14546465,15.6),(126813,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126813,37.16,0.33,270,57742,70,NULL,NULL,'2MASX J15072266+2048052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.56',0.21,NULL,NULL,NULL,NULL,NULL,1,226.844417,20.80156,0.105,NULL,59535465453,930241647,14535025,17.56),(126814,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126814,36.76,0.46,225,57743,70,NULL,NULL,'2MASX J15072356+0354371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,226.848167,3.91017,0.085,NULL,59331438717,927053729,14485214,17.1),(126815,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126815,35.81,0.46,145,57744,70,NULL,NULL,'2MASX J15072408+3404340',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000157,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,226.850417,34.07611,0.017,NULL,60116024869,939312888,14676763,16.5),(126816,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126816,37.53,0.15,320,57745,70,NULL,NULL,'2MASX J15072530+0829446',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000097,NULL,'15.4g',0.55,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,226.8555,8.49569,0.053,NULL,59384078099,927876220,14498065,15.4),(126817,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126817,35.26,0.46,113,57746,70,NULL,NULL,'2MASX J15072560+1025096',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.66',0.27,NULL,NULL,NULL,NULL,NULL,1,226.856583,10.41917,0.073,NULL,59346980182,927296565,14489008,17.66),(126818,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126818,35.58,0.33,131,57747,70,NULL,NULL,'IC 1089',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000167,NULL,'14.7g',0.64,NULL,NULL,NULL,NULL,NULL,1,226.858291667,7.11675,0.045,NULL,59387057834,927922778,14498793,14.7),(126819,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126819,38.04,0.33,405,57748,70,NULL,NULL,'2MASX J15072631+0702506',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.6g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,226.8597917,7.04744,0.045,NULL,59387074004,927923031,14498797,16.6),(126820,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126820,34.2,0.47,69.3,57749,NULL,NULL,'H','NGC 5857',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000083,NULL,'13.86',0.6,'SB(s)b','Pair member, S + S',NULL,NULL,NULL,1,226.8637917,19.59764,0.057,NULL,59537503313,930273489,14535523,13.86),(126821,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126821,34.22,0.45,69.8,57749,NULL,NULL,'K','NGC 5857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126822,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126822,34.24,0.4,70.4,57749,NULL,NULL,'mean','NGC 5857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126823,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126823,34.27,0.46,71.4,57749,NULL,NULL,'J','NGC 5857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126824,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126824,37.53,0.15,320,57750,70,NULL,NULL,'2MASX J15072766+0833115',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.865375,8.55339,0.053,NULL,59384129755,927877027,14498078,17),(126825,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126825,33.68,0.8,54.4,57751,75,NULL,'MAT, I','NGC 5843',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.11',1.1,'SB(s)b:        HII',NULL,NULL,NULL,NULL,1,226.8662083,-36.32742,0.309,NULL,47240598309,738134348,11533349,13.11),(126826,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126826,33.31,0.43,46,57751,75,NULL,'MAT, I, raw','NGC 5843',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126827,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126827,33.41,0.32,48,57751,85,NULL,'I, raw','NGC 5843',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126828,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126828,33.48,0.32,49.7,57751,85,NULL,'I, inv','NGC 5843',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126829,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126829,33.49,0.47,50,57751,NULL,NULL,'H','NGC 5843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126830,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126830,33.5,0.45,50,57751,NULL,NULL,'K','NGC 5843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126831,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126831,33.51,0.46,50.3,57751,NULL,NULL,'J','NGC 5843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126832,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126832,33.61,0.43,52.8,57751,75,NULL,'MAT, I, inv','NGC 5843',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126833,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126833,33.73,0.43,55.6,57751,75,NULL,'MAT, I, cor','NGC 5843',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126834,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126834,33.75,0.39,56.2,57751,NULL,NULL,NULL,'NGC 5843',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126835,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126835,33.79,0.4,57.4,57751,NULL,NULL,'mean','NGC 5843',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126836,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126836,33.86,0.2,59.2,57751,74.4,NULL,NULL,'NGC 5843',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126837,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126837,33.95,0.35,61.6,57751,NULL,NULL,'Malmquist cor.','NGC 5843',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126838,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126838,37.72,0.46,350,57752,70,NULL,NULL,'2MASX J15072921+2742109',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.29',0.16,NULL,NULL,NULL,NULL,NULL,1,226.871708333,27.70314,0.057,NULL,59897215768,935893996,14623343,18.29),(126839,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126839,37.94,0.46,387,57753,70,NULL,NULL,'SDSS J150730.01+230817.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,226.875041667,23.13828,0.109,NULL,59409789344,928277958,14504343,18.8),(126840,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126840,38.41,0.46,482,57754,70,NULL,NULL,'SDSS J150730.06+185523.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.8752917,18.92331,0.057,NULL,59536354028,930255531,14535242,18.1),(126841,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126841,36.57,0.46,206,57755,70,NULL,NULL,'2MASX J15073079+3931003',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,226.87825,39.51675,0.029,NULL,60101028246,939078566,14673102,17.2),(126842,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126842,36.24,0.27,177,57756,70,NULL,NULL,'CGCG 106-004',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00015,NULL,'15.6',0.6,NULL,'Group member',NULL,NULL,NULL,1,226.881,16.19783,0.037,NULL,59582374232,930974597,14546478,15.6),(126843,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126843,37.88,0.46,376,57757,70,NULL,NULL,'2MASX J15073260+0102591',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'16.8g',0.3,'AGN',NULL,NULL,NULL,NULL,1,226.8860417,1.04972,0.129,NULL,56375469057,880866704,13763542,16.8),(126844,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126844,36.41,0.46,192,57758,70,NULL,NULL,'2MASX J15073259+0744568',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.8860417,7.74919,0.057,NULL,59384387950,927881061,14498141,16.1),(126845,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126845,35.58,0.33,131,57759,70,NULL,NULL,'2MASX J15073381+0707148',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,226.890875,7.12081,0.045,NULL,59387057269,927922769,14498793,16.4),(126846,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126846,37.78,0.33,360,57760,70,NULL,NULL,'2MASX J15073439+0239271',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,226.893375,2.65775,0.113,NULL,56373641387,880838146,13763096,17.3),(126847,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126847,33.34,0.47,46.5,57761,NULL,NULL,'H','NGC 5859',NULL,'2007A&A...465...71T',2007,1,2.9,NULL,'G',0.000017,NULL,'13.27',0.9,'SB(s)bc','Pair member, S + S',NULL,NULL,NULL,1,226.89475,19.58231,0.057,NULL,59537499603,930273431,14535522,13.27),(126848,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126848,33.38,0.46,47.5,57761,NULL,NULL,'J','NGC 5859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126849,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126849,33.41,0.45,48,57761,NULL,NULL,'K','NGC 5859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126850,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126850,34.24,0.4,70.4,57761,NULL,NULL,'mean','NGC 5859',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126851,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126851,37.26,0.21,283,57762,70,NULL,NULL,'2MASX J15073470+1019548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.894667,10.33194,0.073,NULL,59347142322,927299098,14489048,17.9),(126852,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126852,37.16,0.33,270,57763,70,NULL,NULL,'2MASX J15073485+2049162',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.8955,20.82103,0.105,NULL,59535459375,930241552,14535024,17.7),(126853,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126853,37.52,0.46,319,57764,70,NULL,NULL,'2MASX J15073583+1903372',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,226.899333,19.06033,0.057,NULL,59536331300,930255176,14535237,16.5),(126854,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126854,35.69,0.46,138,57765,70,NULL,NULL,'2MASX J15073763+0653228',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'17.23',0.37,NULL,NULL,NULL,NULL,NULL,1,226.906875,6.88983,0.049,NULL,59386548421,927914819,14498669,17.23),(126855,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126855,37.36,0.46,297,57766,70,NULL,NULL,'2MASX J15073786+0430348',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000084,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,226.9077917,4.50975,0.093,NULL,59331242530,927050664,14485166,16.9),(126856,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126856,37.53,0.15,320,57767,70,NULL,NULL,'2MASX J15073898+0816568',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,226.912333,8.28244,0.053,NULL,59384984829,927890387,14498287,16.6),(126857,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126857,35.71,0.52,139,57768,70,NULL,NULL,'CGCG 021-008',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.000096,NULL,'15.7g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,226.913833,-0.10947,0.161,NULL,45368133871,708877091,11076204,15.7),(126858,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126858,36.56,0.46,205,57769,70,NULL,NULL,'2MASX J15074014+3926084',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,226.917333,39.43575,0.037,NULL,60100984458,939077882,14673091,16.7),(126859,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126859,38.63,0.46,531,57770,70,NULL,NULL,'2MASX J15074027+2300531',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.917833,23.01475,0.113,NULL,59410075878,928282435,14504413,18.3),(126860,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126860,37.1,0.46,263,57771,70,NULL,NULL,'2MASX J15074027+2122301',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.918,21.37494,0.121,NULL,59535073800,930235528,14534930,18),(126861,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126861,37.72,0.46,350,57772,70,NULL,NULL,'2MASX J15074045+1813451',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.918583,18.22931,0.037,NULL,59583864489,930997882,14546841,17.6),(126862,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126862,37.24,0.46,280,57773,70,NULL,NULL,'2MASX J15074108+2640249',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.60',0.22,NULL,NULL,NULL,NULL,NULL,1,226.921083333,26.67361,0.101,NULL,59898279440,935910616,14623603,17.6),(126863,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126863,37.95,0.14,390,57774,70,NULL,NULL,'SDSS J150741.07-001715.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,226.921125,-0.28753,0.161,NULL,45368162571,708877540,11076211,18.5),(126864,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126864,39.11,0.46,663,57775,70,NULL,NULL,'SDSS J150743.84+090528.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.9g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.9327083,9.09133,0.033,NULL,59388262755,927941605,14499087,18.9),(126865,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126865,37.26,0.21,283,57776,70,NULL,NULL,'2MASX J15074500+1015418',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.9375,10.26167,0.073,NULL,59347156732,927299323,14489051,16.6),(126866,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126866,37.44,0.33,307,57777,70,NULL,NULL,'2MASX J15074610+0329588',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000096,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,226.942125,3.49961,0.081,NULL,59330742568,927042852,14485044,17.3),(126867,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126867,30.51,0.63,12.6,57778,95,NULL,'Michard 1979b, c','NGC 5854',NULL,'1984ApJS...56...91D',1984,1,2.95,NULL,'G',0.000017,NULL,'12.7g',0.74,'SB(s)0+','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.94875,2.56864,0.113,NULL,56373779101,880840298,13763129,12.7),(126868,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126868,30.89,0.44,15.1,57778,95,NULL,'Weighted Mean','NGC 5854',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126869,'Faber-Jackson','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126869,31.48,0.46,19.8,57778,95,NULL,'Michard 1979a','NGC 5854',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126870,'Tertiary','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126870,31.08,0.25,16.4,57778,95,NULL,NULL,'NGC 5854',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126871,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126871,32.27,0.8,28.5,57778,75,NULL,'B','NGC 5854',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126872,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126872,30.87,0.45,14.9,57778,NULL,NULL,'K','NGC 5854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126873,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126873,31.86,NULL,23.5,57778,72,NULL,NULL,'NGC 5854',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126874,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126874,32.16,0.4,27,57778,NULL,NULL,'mean','NGC 5854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126875,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126875,37.94,0.33,387,57779,70,NULL,NULL,'2MASX J15074806+2202391',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.44',0.2,NULL,NULL,NULL,NULL,NULL,1,226.950167,22.04428,0.121,NULL,59527698808,930120293,14533129,17.44),(126876,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126876,37.26,0.21,283,57780,70,NULL,NULL,'2MASX J15074805+1019018',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000209,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,226.95025,10.31728,0.073,NULL,59347143657,927299119,14489048,15.8),(126877,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126877,37.31,0.46,290,57781,70,NULL,NULL,'2MASX J15075014+2842260',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.958917,28.70736,0.041,NULL,60080508588,938757946,14668092,17.9),(126878,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126878,37.57,0.46,326,57782,70,NULL,NULL,'2MASX J15075019+1332577',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,226.959041667,13.5495,0.077,NULL,59571585251,930806019,14543844,17.5),(126879,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126879,37.26,0.21,283,57783,70,NULL,NULL,'2MASX J15075103+1012298',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,226.9625,10.20814,0.073,NULL,59347151292,927299238,14489050,17.2),(126880,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126880,35.34,0.59,117,57784,70,NULL,NULL,'2MASX J15075112-0922108',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.45',0.8,NULL,NULL,NULL,NULL,NULL,1,226.963167,-9.36981,0.405,NULL,46490768784,726418262,11350285,15.45),(126881,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126881,37.2,0.46,276,57785,70,NULL,NULL,'2MASX J15075116+1149488',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.963291667,11.83006,0.089,NULL,59348727658,927323869,14489435,16.9),(126882,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126882,37.75,0.46,355,57786,70,NULL,NULL,'SDSS J150751.50+370450.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,226.964625,37.08064,0.017,NULL,60119143549,939361617,14677525,17.6),(126883,'Sosies','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126883,33.41,0.28,48.1,57787,NULL,NULL,NULL,'NGC 5874',NULL,'2002A&A...393...57T',2002,1,1.27,NULL,'G',0.000007,NULL,'13.7g',1.17,'SAB(rs)c       HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,226.965958333,54.75278,0.013,NULL,57579806229,899684472,14057569,13.7),(126884,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126884,33.51,0.4,50.4,57787,NULL,NULL,'mean','NGC 5874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126885,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126885,33.53,0.2,50.8,57787,74.4,NULL,NULL,'NGC 5874',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126886,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126886,33.58,0.46,51.9,57787,NULL,NULL,NULL,'NGC 5874',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126887,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126887,33.58,0.46,52.1,57787,NULL,NULL,'Malmquist cor.','NGC 5874',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126888,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126888,33.99,0.46,62.7,57787,NULL,NULL,'J','NGC 5874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126889,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126889,34.01,0.47,63.4,57787,NULL,NULL,'H','NGC 5874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126890,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126890,34.02,0.45,63.6,57787,NULL,NULL,'K','NGC 5874',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126891,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126891,37.67,0.46,342,57788,70,NULL,NULL,'SDSS J150752.56+054418.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,226.9690417,5.73856,0.077,NULL,59332332851,927067700,14485432,18.5),(126892,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126892,37.44,0.33,307,57789,70,NULL,NULL,'2MASX J15075291+0337358',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,226.9704583,3.62658,0.069,NULL,59330682402,927041912,14485029,17.4),(126893,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126893,38.01,0.46,400,57790,70,NULL,NULL,'SDSS J150753.54+272939.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,226.973083,27.49442,0.065,NULL,59897232846,935894263,14623347,NULL),(126894,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126894,37.98,0.27,395,57791,70,NULL,NULL,'2MASX J15075382+4621043',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,226.974375,46.35133,0.057,NULL,59984166564,937252602,14644571,18),(126895,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126895,37.72,0.46,351,57792,70,NULL,NULL,'2MASX J15075397+3755044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,226.975083333,37.91786,0.017,NULL,60101863060,939091610,14673306,17.5),(126896,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126896,36.55,0.46,204,57793,70,NULL,NULL,'2MASX J15075440+0108168',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000026,NULL,'16.4g',0.34,'BLAGN',NULL,NULL,NULL,'Sy 1',1,226.976583,1.138,0.129,NULL,56374765420,880855709,13763370,16.4),(126897,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126897,36.73,0.46,222,57794,70,NULL,NULL,'2MASX J15075653+0905058',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,226.9857083,9.08511,0.033,NULL,59388256122,927941501,14499085,16),(126898,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126898,34.14,0.46,67.4,57795,70,NULL,NULL,'CGCG 274-019',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00008,NULL,'14.7g',0.53,'S0^-','Group member',NULL,NULL,NULL,1,226.985833,52.52247,0.033,NULL,59930621537,936415961,14631499,14.7),(126899,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126899,37.78,0.33,360,57796,70,NULL,NULL,'2MASX J15075693+0235358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,226.9872917,2.59328,0.113,NULL,56373785439,880840397,13763131,17.8),(126900,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126900,37.53,0.15,320,57797,70,NULL,NULL,'2MASX J15075707+0816393',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,226.987833333,8.27758,0.053,NULL,59384974611,927890228,14498284,17),(126901,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126901,36.63,0.46,212,57798,70,NULL,NULL,'2MASX J15075775+2852550',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.83',0.24,'E',NULL,NULL,NULL,NULL,1,226.990583,28.88186,0.041,NULL,60080290398,938754537,14668039,17.83),(126902,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126902,37.53,0.15,320,57799,70,NULL,NULL,'2MASX J15075802+0812183',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'16.0g',0.39,NULL,NULL,NULL,NULL,NULL,1,226.991875,8.20519,0.053,NULL,59384945059,927889766,14498277,16),(126903,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126903,37.26,0.21,283,57800,70,NULL,NULL,'2MASX J15075849+1020533',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,226.9937083,10.34822,0.073,NULL,59347273037,927301141,14489080,17.3),(126904,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126904,36.41,0.46,191,57801,70,NULL,NULL,'2MASX J15080021+1127133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.001,11.45375,0.089,NULL,59349182494,927330976,14489546,17.2),(126905,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126905,38.4,0.46,479,57802,70,NULL,NULL,'2MASX J15080035+1318178',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.0015,13.30494,0.097,NULL,59571490734,930804542,14543820,18.1),(126906,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126906,37.95,0.14,390,57803,70,NULL,NULL,'SDSS J150801.02-001712.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.004291667,-0.28689,0.161,NULL,45368128768,708877012,11076203,18.6),(126907,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126907,37.19,0.46,274,57804,70,NULL,NULL,'2MASX J15080153+0352338',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.0064583,3.87617,0.085,NULL,59331409416,927053272,14485207,17.1),(126908,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126908,37.58,0.46,328,57805,70,NULL,NULL,'2MASX J15080155+1911483',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.0064583,19.19686,0.069,NULL,59536326855,930255107,14535236,17.3),(126909,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126909,37.94,0.33,387,57806,70,NULL,NULL,'2MASX J15080257+2159113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.010667,21.9865,0.121,NULL,59539218966,930300296,14535942,17.8),(126910,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126910,37.53,0.15,320,57807,70,NULL,NULL,'SDSS J150802.99+081831.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.0125,8.30878,0.053,NULL,59384971576,927890180,14498284,18.3),(126911,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126911,38.7,0.33,549,57808,70,NULL,NULL,'SDSS J150803.29+291024.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.11',0.13,NULL,NULL,NULL,NULL,NULL,1,227.0137083,29.1735,0.041,NULL,60094108495,938970445,14671413,19.11),(126912,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126912,37.11,0.46,264,57809,70,NULL,NULL,'2MASX J15080372+2715440',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.98',0.33,NULL,NULL,NULL,NULL,NULL,1,227.0157083,27.26231,0.077,NULL,59897129271,935892644,14623322,16.98),(126913,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126913,38.9,0.46,604,57810,70,NULL,NULL,'2MASX J15080407+2855150',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.016833,28.92106,0.041,NULL,60080289223,938754519,14668039,18),(126914,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126914,37.53,0.15,320,57811,70,NULL,NULL,'2MASX J15080408+0813543',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.017083333,8.23158,0.053,NULL,59384943339,927889739,14498277,17.5),(126915,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126915,38.29,0.46,454,57812,70,NULL,NULL,'SDSS J150804.13+195159.4',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.01725,19.86653,0.065,NULL,59538059598,930282181,14535659,17.5),(126916,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126916,37.18,0.46,272,57813,70,NULL,NULL,'2MASX J15080546+0120539',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.022666667,1.34831,0.145,NULL,56374825053,880856641,13763385,17.6),(126917,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126917,38.07,0.46,411,57814,70,NULL,NULL,'2MASX J15080567+3020135',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.0235,30.33697,0.033,NULL,60086115020,938845547,14669461,17.5),(126918,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126918,37.95,0.14,390,57815,70,NULL,NULL,'2MASX J15080682-0009303',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.028583,-0.15853,0.161,NULL,45368139453,708877178,11076205,17.1),(126919,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126919,37.4,0.46,302,57816,70,NULL,NULL,'2MASX J15080697+2946040',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000133,NULL,'17.97',0.21,'E',NULL,NULL,NULL,NULL,1,227.029167,29.76786,0.037,NULL,60085639862,938838122,14669345,17.97),(126920,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126920,38.19,0.46,434,57817,70,NULL,NULL,'2MASX J15080786+0051469',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.032833,0.86283,0.133,NULL,56372831351,880825489,13762898,17.5),(126921,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126921,37.98,0.27,395,57818,70,NULL,NULL,'2MASX J15080803+4626443',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.033625,46.44581,0.057,NULL,59984173763,937252715,14644573,18.2),(126922,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126922,36.37,0.46,188,57819,70,NULL,NULL,'2MASX J15080825+2654580',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00042,NULL,'17.51',0.24,NULL,NULL,NULL,NULL,NULL,1,227.034416667,26.916,0.085,NULL,59898253197,935910206,14623596,17.51),(126923,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126923,36.49,0.46,199,57820,70,NULL,NULL,'2MASX J15080889+3601078',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000182,NULL,'15.9g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,227.037041667,36.01894,0.013,NULL,60127625434,939494147,14679596,15.9),(126924,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126924,38.44,0.46,487,57821,70,NULL,NULL,'SDSS J150810.36+025708.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00008,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,227.043208333,2.95247,0.093,NULL,59325293922,926957717,14483714,18.6),(126925,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126925,37.65,0.46,338,57822,70,NULL,NULL,'2MASX J15081103+1303188',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.0459583,13.05514,0.081,NULL,59571352352,930802380,14543787,17.1),(126926,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126926,38.03,0.16,404,57823,70,NULL,NULL,'2MASX J15081182+2714249',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.56',0.16,NULL,NULL,NULL,NULL,NULL,1,227.049375,27.24031,0.077,NULL,59897136208,935892753,14623324,18.56),(126927,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126927,37.51,0.46,318,57824,70,NULL,NULL,'2MASX J15081241+1759302',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.051833,17.99183,0.041,NULL,59584123600,931001931,14546905,16.8),(126928,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126928,37.71,0.46,348,57825,70,NULL,NULL,'SDSS J150812.67+274921.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.052833,27.82258,0.057,NULL,59897733901,935902092,14623470,18),(126929,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126929,38.03,0.16,404,57826,70,NULL,NULL,'SDSS J150813.22+270736.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.055125,27.12667,0.081,NULL,59897126666,935892604,14623321,18.2),(126930,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126930,38.3,0.46,456,57827,70,NULL,NULL,'2MASX J15081328+2538159',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.4g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,227.055291667,25.63789,0.129,NULL,59894940346,935858442,14622788,17.4),(126931,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126931,36.37,0.46,188,57828,70,NULL,NULL,'2MASX J15081350+0746483',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.0562083,7.78003,0.049,NULL,59384346932,927880420,14498131,16.9),(126932,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126932,34.52,0.4,80,57829,NULL,NULL,'mean','IC 1091',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000053,NULL,'14.5',0.7,'SB(s)b?','in a pair',NULL,NULL,NULL,1,227.0562917,-11.14092,0.413,NULL,46485371892,726333935,11348967,14.5),(126933,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126933,34.71,0.47,87.3,57829,NULL,NULL,'H','IC 1091',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126934,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126934,34.74,0.45,88.7,57829,NULL,NULL,'K','IC 1091',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126935,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126935,34.75,0.46,89.3,57829,NULL,NULL,'J','IC 1091',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126936,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126936,37.47,0.46,312,57830,70,NULL,NULL,'2MASX J15081422+1056203',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.0592083,10.93892,0.077,NULL,59348947763,927327308,14489489,17.3),(126937,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126937,38.7,0.33,549,57831,70,NULL,NULL,'2MASX J15081434+2915219',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.60',0.1,NULL,NULL,NULL,NULL,NULL,1,227.059667,29.25611,0.041,NULL,60094128609,938970759,14671418,19.6),(126938,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126938,36.95,0.46,245,57832,70,NULL,NULL,'2MASX J15081478+3417185',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.0614583,34.28853,0.021,NULL,60116166820,939315106,14676798,17.4),(126939,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126939,37.95,0.14,390,57833,70,NULL,NULL,'2MASX J15081496-0015443',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000092,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.06225,-0.26225,0.161,NULL,45368632925,708884889,11076326,17.4),(126940,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126940,38.24,0.46,444,57834,70,NULL,NULL,'2MASX J15081524+1106223',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.0635417,11.10617,0.065,NULL,59349254120,927332095,14489563,18.3),(126941,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126941,37.95,0.14,390,57835,70,NULL,NULL,'2MASX J15081529-0013153',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.0637083,-0.22094,0.161,NULL,45368631684,708884870,11076326,17),(126942,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126942,37.07,0.46,260,57836,70,NULL,NULL,'2MASX J15081624+2418019',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,227.0677083,24.30053,0.101,NULL,59412118301,928314348,14504911,16.4),(126943,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126943,35.46,0.46,124,57837,70,NULL,NULL,'2MASX J15081645+5640081',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000081,NULL,'16.0g',0.31,'E0',NULL,NULL,NULL,NULL,1,227.068333333,56.66886,0.013,NULL,57715668502,901807320,14090739,16),(126944,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126944,36.04,0.23,162,57838,70,NULL,NULL,'MCG +04-36-019',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.02',0.3,NULL,NULL,NULL,NULL,NULL,1,227.078667,20.48572,0.093,NULL,59535337898,930239654,14534994,17.02),(126945,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126945,39.03,0.46,639,57839,70,NULL,NULL,'SDSS J150818.90+213407.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.0787917,21.56878,0.105,NULL,59535230471,930237976,14534968,18.6),(126946,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126946,37.44,0.46,307,57840,70,NULL,NULL,'2MASX J15081987+0643503',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.0827917,6.73064,0.053,NULL,59386565420,927915084,14498673,17.4),(126947,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126947,37.35,0.46,295,57841,70,NULL,NULL,'2MASX J15081986+2742091',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.77',0.24,NULL,NULL,NULL,NULL,NULL,1,227.0829583,27.70264,0.057,NULL,59897701448,935901585,14623462,17.77),(126948,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126948,37.95,0.14,390,57842,70,NULL,NULL,'2MASX J15082076-0022233',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.086583333,-0.37308,0.161,NULL,45368624723,708884761,11076324,17.1),(126949,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126949,38.44,0.46,487,57843,70,NULL,NULL,'2MASX J15082205+0741143',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.092,7.68744,0.045,NULL,59384334741,927880230,14498128,17.6),(126950,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126950,34.39,0.8,75.5,57844,75,NULL,'MAT, I','ESO 448- G 013',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'12.37',0.5,'Sb             HII',NULL,NULL,NULL,NULL,1,227.09525,-28.8445,0.537,NULL,47196448813,737444512,11522570,12.37),(126951,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126951,34.17,0.45,68.3,57844,NULL,NULL,'K','ESO 448- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126952,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126952,34.22,0.47,69.8,57844,NULL,NULL,'H','ESO 448- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126953,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126953,34.3,0.46,72.5,57844,NULL,NULL,'J','ESO 448- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126954,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126954,34.34,0.4,73.9,57844,NULL,NULL,'mean','ESO 448- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126955,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126955,34.5,0.43,79.6,57844,75,NULL,'MAT, I, raw','ESO 448- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126956,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126956,34.53,0.32,80.5,57844,85,NULL,'I, raw','ESO 448- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126957,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126957,34.53,0.49,80.6,57844,75,NULL,'IR','ESO 448- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126958,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126958,34.55,0.42,81.4,57844,NULL,NULL,'Malmquist cor.','ESO 448- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126959,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126959,34.6,0.32,83.3,57844,85,NULL,'I, inv','ESO 448- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126960,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126960,34.74,0.43,88.8,57844,75,NULL,'MAT, I, cor','ESO 448- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126961,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126961,34.74,0.38,88.8,57844,NULL,NULL,NULL,'ESO 448- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126962,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126962,34.78,0.2,90.4,57844,74.4,NULL,NULL,'ESO 448- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126963,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126963,34.81,0.43,91.7,57844,75,NULL,'MAT, I, inv','ESO 448- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126964,'SNIa','2016-12-15 15:15:31','2016-12-16 11:20:45','1','PTF11v','N',126964,35.94,0.04,149,57845,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11v',0.0373,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126965,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126965,35.82,0.46,146,57846,70,NULL,NULL,'CGCG 249-007',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000173,NULL,'14.7g',0.6,'S0',NULL,NULL,NULL,NULL,1,227.097583,49.666,0.005,NULL,59937962707,936530667,14633291,14.7),(126966,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126966,36.49,0.46,198,57847,70,NULL,NULL,'2MASX J15082358+0723533',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.098375,7.39822,0.045,NULL,59386980567,927921571,14498774,17.2),(126967,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126967,38.42,0.46,483,57848,70,NULL,NULL,'SDSS J150823.78+332324.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000188,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.099125,33.39006,0.029,NULL,60115243628,939300681,14676573,18.2),(126968,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126968,34.33,0.46,73.4,57849,70,NULL,NULL,'CGCG 106-011',NULL,'2015arXiv151105856S',2015,1,0.7,'Sometimes incorrectly referred to as IC 1096.','G',0.000163,NULL,'15.1',0.7,'S?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,227.099875,19.20811,0.069,NULL,59537394089,930271782,14535496,15.1),(126969,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126969,37.21,0.46,277,57850,70,NULL,NULL,'SDSS J150824.07+044133.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.100333,4.69278,0.089,NULL,59331647491,927056992,14485265,17.8),(126970,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126970,37.35,0.46,295,57851,70,NULL,NULL,'2MASX J15082458+0532029',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.1025417,5.53414,0.093,NULL,59332308418,927067319,14485426,17.9),(126971,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126971,35.81,0.46,145,57852,70,NULL,NULL,'ARK 472',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000172,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,227.10325,37.66394,0.009,NULL,60101825933,939091030,14673297,15.2),(126972,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126972,36.86,0.46,236,57853,70,NULL,NULL,'2MASX J15082489+3612118',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000148,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,227.10375,36.20325,0.013,NULL,60127693514,939495211,14679612,16.4),(126973,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126973,37.98,0.27,395,57854,70,NULL,NULL,'2MASX J15082494+4622438',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.104083,46.37881,0.057,NULL,59984158021,937252469,14644569,17.4),(126974,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126974,37.76,0.46,357,57855,70,NULL,NULL,'SDSS J150825.42+163342.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.1059583,16.56181,0.041,NULL,59583057994,930985281,14546645,18.4),(126975,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126975,37.95,0.14,390,57856,70,NULL,NULL,'SDSS J150826.08-001904.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.108667,-0.31806,0.161,NULL,45368638808,708884981,11076327,18.5),(126976,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126976,37.32,0.21,291,57857,70,NULL,NULL,'2MASX J15082641+2647361',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'19.07',0.13,NULL,NULL,NULL,NULL,NULL,1,227.1100417,26.79336,0.085,NULL,59898248543,935910133,14623595,19.07),(126977,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126977,38.08,0.46,412,57858,70,NULL,NULL,'2MASX J15082697+2224337',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.1122083,22.40933,0.117,NULL,59409206627,928268853,14504200,18.1),(126978,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126978,37.52,0.46,318,57859,70,NULL,NULL,'2MASX J15082736+5415071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.1g',0.25,'FR II          AGN',NULL,NULL,NULL,NULL,1,227.113833,54.25211,0.021,NULL,59660469166,932194830,14565544,17.1),(126979,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126979,37.53,0.46,321,57860,70,NULL,NULL,'2MASX J15082826+2543421',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.1177083,25.72842,0.129,NULL,59898548008,935914812,14623668,17.2),(126980,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126980,35.11,0.46,105,57861,70,NULL,NULL,'CGCG 135-021',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00007,NULL,'15.3',0.3,'S0             Sy?',NULL,NULL,NULL,NULL,1,227.121,21.94772,0.121,NULL,59539199069,930299985,14535937,15.3),(126981,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126981,34.98,0.4,99,57861,NULL,NULL,'mean','CGCG 135-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126982,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126982,36.01,0.47,159,57861,NULL,NULL,'H','CGCG 135-021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(126983,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126983,38.03,0.46,404,57862,70,NULL,NULL,'2MASX J15083011+0952597',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.1255417,9.88314,0.065,NULL,59346459589,927288431,14488881,17.6),(126984,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,126984,35.88,0.2,150,57863,74.4,NULL,NULL,'CGCG 077-018',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.0001,NULL,'15.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.1277083,10.19625,0.073,NULL,59347250487,927300788,14489074,15.6),(126985,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126985,37.95,0.14,390,57864,70,NULL,NULL,'2MASX J15083069-0014493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.1277917,-0.24706,0.161,NULL,45368665910,708885404,11076334,17.9),(126986,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126986,37.95,0.14,390,57865,70,NULL,NULL,'SDSS J150831.98-001602.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000063,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.13325,-0.26744,0.161,NULL,45368665289,708885395,11076334,18.6),(126987,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126987,37.95,0.14,390,57866,70,NULL,NULL,'2MASX J15083209-0017093',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000073,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.133667,-0.286,0.161,NULL,45368633357,708884896,11076326,18),(126988,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126988,37.53,0.15,320,57867,70,NULL,NULL,'2MASX J15083284+0828567',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000222,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.136875,8.48236,0.053,NULL,59384087171,927876362,14498068,17.3),(126989,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126989,37.82,0.46,366,57868,70,NULL,NULL,'2MASX J15083345+0604223',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.13925,6.07292,0.053,NULL,59332101683,927064088,14485376,17.7),(126990,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126990,37.25,0.33,282,57869,70,NULL,NULL,'2MASX J15083362+0611187',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000113,NULL,'16.68',0.51,NULL,NULL,NULL,NULL,NULL,1,227.1400417,6.1885,0.053,NULL,59386366269,927911972,14498624,16.68),(126991,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126991,36.4,0.46,190,57870,70,NULL,NULL,'2MASX J15083381+2528591',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.39',0.16,NULL,NULL,NULL,NULL,NULL,1,227.1410417,25.48306,0.129,NULL,59894948670,935858572,14622790,18.39),(126992,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126992,37.27,0.46,285,57871,70,NULL,NULL,'2MASX J15083427+5731231',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.142917,57.52317,0.029,NULL,57729243025,902019422,14094053,17.8),(126993,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126993,37.96,0.46,391,57872,70,NULL,NULL,'2MASX J15083525+1012587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.146917,10.21633,0.073,NULL,59347293865,927301466,14489085,17.5),(126994,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126994,37.38,0.46,299,57873,70,NULL,NULL,'2MASX J15083540+5828351',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000101,NULL,'17.2g',0.21,'NLAGN',NULL,NULL,NULL,'Sy 2',1,227.147375,58.47639,0,NULL,57719370805,901865168,14091643,17.2),(126995,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126995,37.36,0.46,297,57874,70,NULL,NULL,'2MASX J15083739+2041068',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.32',0.21,NULL,NULL,NULL,NULL,NULL,1,227.1557917,20.68514,0.081,NULL,59535826351,930247286,14535113,17.32),(126996,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126996,37.25,0.33,282,57875,70,NULL,NULL,'2MASX J15083737+0611177',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.155833,6.18831,0.053,NULL,59386367485,927911991,14498624,17.9),(126997,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126997,36.04,0.23,162,57876,70,NULL,NULL,'SDSS J150838.16+201000.0',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.0g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.159,20.16669,0.053,NULL,59537976962,930280890,14535638,16),(126998,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126998,35.53,0.33,127,57877,70,NULL,NULL,'SDSS J150838.96+262438.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.18',0.18,NULL,NULL,NULL,NULL,NULL,1,227.162583333,26.41081,0.121,NULL,59898637806,935916215,14623690,18.18),(126999,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',126999,37.7,0.11,346,57878,70,NULL,NULL,'2MASX J15083945+0714107',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.16425,7.23639,0.045,NULL,59387141832,927924091,14498813,17.4),(127000,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127000,35.05,0.49,102,57879,75,NULL,'IR','ESO 448- G 014',NULL,'2011yCatp016004901K',2011,1,1.43,NULL,'G',0.00004,NULL,'16.1',0.18,'Sc',NULL,NULL,NULL,NULL,1,227.171791667,-29.12831,0.537,NULL,47208004828,737625075,11525391,16.1),(127001,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127001,35.34,NULL,117,57879,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 448- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127002,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127002,35.35,NULL,118,57879,NULL,NULL,'Dipole + Quadrupole','ESO 448- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127003,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127003,35.36,NULL,118,57879,NULL,NULL,'Dipole','ESO 448- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127004,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127004,33.82,0.47,58.1,57880,70,NULL,NULL,'ESO 387- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000073,NULL,'14.58',0.5,'Sa:',NULL,NULL,NULL,NULL,1,227.1717083,-37.66772,0.261,NULL,47188422013,737319093,11520610,14.58),(127005,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127005,36.37,0.64,188,57881,70,NULL,NULL,'2MASX J15084181-3259205',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,227.174208333,-32.98903,0.645,NULL,47237865844,738091653,11532682,15),(127006,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127006,38.03,0.16,404,57882,70,NULL,NULL,'SDSS J150841.85+270500.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.174375,27.08336,0.081,NULL,59898204885,935909451,14623585,18.5),(127007,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127007,36.66,0.46,215,57883,70,NULL,NULL,'2MASX J15084275+1914338',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.178167,19.24281,0.069,NULL,59537578588,930274665,14535541,15.7),(127008,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127008,36.66,0.46,215,57884,70,NULL,NULL,'2MASX J15084331+3516487',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000199,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.180375,35.28033,0.017,NULL,60114244564,939285071,14676329,16.3),(127009,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127009,38.5,0.33,500,57885,70,NULL,NULL,'2MASX J15084357+0034193',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.1815417,0.572,0.133,NULL,56373526661,880836354,13763068,17.3),(127010,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127010,38.03,0.16,404,57886,70,NULL,NULL,'2MASX J15084362+2711581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.57',0.17,NULL,NULL,NULL,NULL,NULL,1,227.1817083,27.19942,0.081,NULL,59897140446,935892819,14623325,18.57),(127011,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127011,37.71,0.46,348,57887,70,NULL,NULL,'SDSS J150844.55+053951.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.185625,5.66433,0.085,NULL,59332348574,927067946,14485436,18),(127012,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127012,38.1,0.46,417,57888,70,NULL,NULL,'SDSS J150844.79+010912.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.186625,1.15342,0.125,NULL,56374805226,880856331,13763380,18.4),(127013,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127013,37.74,0.12,354,57889,70,NULL,NULL,'2MASX J15084553+0906387',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.189833333,9.11067,0.049,NULL,59384020934,927875327,14498051,18),(127014,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127014,38.91,0.46,606,57890,70,NULL,NULL,'SDSS J150845.57+065632.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.189875,6.9425,0.049,NULL,59387101603,927923462,14498804,18.3),(127015,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127015,37.07,0.46,259,57891,70,NULL,NULL,'2MASX J15084578+0229333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00007,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.19075,2.49267,0.113,NULL,56373695708,880838995,13763109,17.4),(127016,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127016,37.69,0.46,345,57892,70,NULL,NULL,'2MASX J15084585+1157167',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.190917,11.95478,0.121,NULL,59348635666,927322432,14489413,17.2),(127017,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127017,37.74,0.12,354,57893,70,NULL,NULL,'SDSS J150846.43+084605.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.1934583,8.76828,0.037,NULL,59384253668,927878963,14498108,18.1),(127018,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127018,38.5,0.33,500,57894,70,NULL,NULL,'SDSS J150847.13+003331.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.196375,0.55881,0.133,NULL,56373527193,880836362,13763068,18.6),(127019,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127019,37.22,0.2,278,57895,74.4,NULL,NULL,'CGCG 165-022',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.00011,NULL,'15.5',0.31,NULL,NULL,NULL,NULL,NULL,1,227.2002083,30.1705,0.029,NULL,60086399559,938849993,14669531,15.5),(127020,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127020,37.17,0.46,271,57896,70,NULL,NULL,'2MASX J15084869+1114517',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000185,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.202875,11.24764,0.085,NULL,59349392563,927334258,14489597,16.3),(127021,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127021,35.78,0.6,143,57897,70,NULL,NULL,'2MASX J15084883-3654287',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,227.2035417,-36.90797,0.293,NULL,47233334935,738020858,11531575,14.6),(127022,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127022,37.59,0.46,330,57898,70,NULL,NULL,'2MASX J15084927+1638162',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.20525,16.63769,0.041,NULL,59583224539,930987883,14546685,16.8),(127023,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127023,38.02,0.46,401,57899,70,NULL,NULL,'2MASX J15084948+3026593',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.82',0.13,NULL,NULL,NULL,NULL,NULL,1,227.2062917,30.44975,0.033,NULL,60086193591,938846774,14669480,18.82),(127024,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127024,33.91,0.46,60.4,57900,70,NULL,NULL,'ESO 328- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'15',1.1,'S0',NULL,NULL,NULL,NULL,1,227.2170417,-38.47931,0.241,NULL,47189490415,737335787,11520871,15),(127025,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127025,37.44,0.46,307,57901,70,NULL,NULL,'2MASX J15085267+2647521',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.26',0.18,NULL,NULL,NULL,NULL,NULL,1,227.219375,26.79797,0.101,NULL,59898752565,935918008,14623718,18.26),(127026,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127026,37.23,0.27,280,57902,70,NULL,NULL,'2MASX J15085302+5901161',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.2207917,59.02122,0.013,NULL,57719896814,901873387,14091771,17.6),(127027,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127027,36.04,0.23,162,57903,70,NULL,NULL,'2MASX J15085325+2012034',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.222,20.20103,0.073,NULL,59538006681,930281354,14535646,16.1),(127028,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127028,38.03,0.16,404,57904,70,NULL,NULL,'SDSS J150854.15+270659.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.225667,27.11644,0.081,NULL,59897096149,935892127,14623314,NULL),(127029,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127029,37.32,0.46,291,57905,70,NULL,NULL,'2MASX J15085462+0437453',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.2275417,4.62931,0.089,NULL,59331972434,927062069,14485344,16.9),(127030,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127030,38.14,0.46,425,57906,70,NULL,NULL,'2MASX J15085658+1034035',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.235833,10.56781,0.081,NULL,59347097381,927298396,14489037,18.1),(127031,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127031,37.76,0.21,356,57907,70,NULL,NULL,'2MASX J15085728+0947005',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.2385417,9.78358,0.049,NULL,59346507110,927289173,14488893,17.1),(127032,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127032,37.7,0.11,346,57908,70,NULL,NULL,'2MASX J15085730+0753155',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.238625,7.88772,0.049,NULL,59384850924,927888295,14498254,16.8),(127033,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127033,37.32,0.21,291,57909,70,NULL,NULL,'2MASX J15085776+2639081',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.29',0.21,NULL,NULL,NULL,NULL,NULL,1,227.240708333,26.65228,0.117,NULL,59898755267,935918051,14623719,17.29),(127034,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127034,37.85,0.46,372,57910,70,NULL,NULL,'SDSS J150858.92+295708.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.2455417,29.95228,0.029,NULL,60086411575,938850180,14669534,18.1),(127035,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127035,34.95,0.51,97.6,57911,70,NULL,NULL,'LCRS B150616.0-114824',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000143,NULL,'15.95',0.4,NULL,NULL,NULL,NULL,NULL,1,227.249916667,-11.99692,0.397,NULL,46484969183,726327643,11348869,15.95),(127036,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127036,36.04,0.23,162,57912,70,NULL,NULL,'CGCG 135-022',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,227.25,20.44203,0.093,NULL,59535330631,930239541,14534992,15.6),(127037,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127037,36.76,0.46,225,57913,70,NULL,NULL,'2MASX J15090088+0258312',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,'FoF','17.05',0.36,NULL,NULL,NULL,NULL,NULL,1,227.253583,2.97522,0.117,NULL,56385090412,881017037,13765891,17.05),(127038,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127038,35.51,0.48,126,57914,70,NULL,NULL,'CGCG 021-018',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000083,NULL,'15.0g',0.57,'E0',NULL,NULL,NULL,NULL,1,227.254375,-0.16589,0.161,NULL,45367812731,708872073,11076126,15),(127039,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127039,35.59,0.46,131,57914,70,NULL,NULL,'CGCG 021-018',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127040,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127040,38.11,0.23,419,57915,70,NULL,NULL,'2MASX J15090127+3017034',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.255417,30.28439,0.033,NULL,60086389086,938849829,14669528,18.1),(127041,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127041,36.83,0.46,233,57916,70,NULL,NULL,'2MASX J15090143+2831031',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.00',0.2,NULL,NULL,NULL,NULL,NULL,1,227.256125,28.5175,0.041,NULL,59896778437,935887163,14623236,18),(127042,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127042,38.23,0.46,442,57917,70,NULL,NULL,'SDSS J150901.79+031729.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.2574583,3.29153,0.069,NULL,59330588374,927040443,14485006,17.9),(127043,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127043,37.59,0.46,330,57918,70,NULL,NULL,'2MASX J15090195+3825280',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.2580417,38.42428,0.037,NULL,60103964848,939124450,14673819,17.4),(127044,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127044,36.74,0.46,223,57919,70,NULL,NULL,'2MASX J15090349+2823022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.60',0.16,NULL,NULL,NULL,NULL,NULL,1,227.2645,28.38392,0.045,NULL,59897002032,935890656,14623291,18.6),(127045,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127045,36.44,0.64,194,57920,70,NULL,NULL,'2MASX J15090466-0717169',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,227.2694583,-7.288,0.249,NULL,46498014920,726531483,11352054,15.3),(127046,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127046,38.25,0.46,447,57921,70,NULL,NULL,'2MASX J15090474+2912442',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000203,NULL,'17.3g',0.22,'E',NULL,NULL,NULL,NULL,1,227.269833333,29.21233,0.041,NULL,60093918673,938967479,14671366,17.3),(127047,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127047,37.7,0.11,346,57922,70,NULL,NULL,'SDSS J150906.08+072027.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.275333,7.34106,0.045,NULL,59386997818,927921840,14498778,18.6),(127048,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127048,35.53,0.33,127,57923,70,NULL,NULL,'CGCG 165-023',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'14.8',0.3,'S0',NULL,NULL,NULL,NULL,1,227.2785417,26.50992,0.121,NULL,59898818693,935919042,14623735,14.8),(127049,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127049,19,0.1,0.063,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1985AJ.....90.2221O',1985,1,30.2,NULL,'G',0.000003,NULL,'11.9',19.1,'E','Isolated galaxy',NULL,NULL,NULL,1,227.285375,67.22261,0.037,1,57980457329,905944645,14155385,11.9),(127050,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127050,19.1,0.1,0.0661,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2013ApJ...763..110K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127051,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127051,19.16,0.11,0.0679,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127052,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127052,19.18,0.12,0.0685,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1999AJ....118..366M',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127053,'CMD','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127053,19.31,NULL,0.0728,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127054,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127054,19.04,0.17,0.064,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127055,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127055,19.15,0.07,0.0676,57924,NULL,NULL,'Red HB','UMI DWARF',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127056,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127056,19.17,0.07,0.0682,57924,NULL,NULL,'Probability > 0.5','UMI DWARF',NULL,'2011ApJ...731..119R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127057,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127057,19.19,NULL,0.069,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127058,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127058,19.28,0.25,0.0718,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127059,'Horizontal Branch','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127059,19.4,0.1,0.076,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2002AJ....123.3199C',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127060,'RR Lyrae','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127060,19,0.1,0.063,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1986AJ.....92..766C',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127061,'RR Lyrae','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127061,19.24,0.24,0.07,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'1988AJ.....96..528N',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127062,'RR Lyrae','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127062,19.29,NULL,0.0721,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127063,'RR Lyrae','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127063,19.94,0.13,0.0973,57924,NULL,NULL,'7','UMI DWARF',NULL,'2013ApJ...767...62G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127064,'TRGB','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127064,18.9,NULL,0.06,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127065,'TRGB','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127065,19.15,NULL,0.0676,57924,NULL,NULL,NULL,'UMI DWARF',NULL,'2003MNRAS.339..887F',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127066,'TRGB','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127066,19.16,0.14,0.07,57924,74.4,NULL,NULL,'UMI DWARF',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127067,'TRGB','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127067,19.41,0.12,0.076,57924,NULL,NULL,'I','UMI DWARF',NULL,'2002AJ....124.3222B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127068,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127068,20,0.8,0.1,57924,75,NULL,'B','UMI DWARF',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127069,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127069,36.56,0.46,205,57925,70,NULL,NULL,'2MASX J15090933+1830524',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.288875,18.51469,0.061,NULL,59583822373,930997224,14546831,17.5),(127070,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127070,37.74,0.12,354,57926,70,NULL,NULL,'2MASX J15090936+0838595',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.288917,8.64994,0.053,NULL,59384206214,927878222,14498097,17.7),(127071,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127071,35.48,0.67,125,57927,70,NULL,NULL,'2MASX J15090958-3956236',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,227.290041667,-39.94,0.109,NULL,47186422331,737287848,11520122,15),(127072,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127072,37.92,0.46,384,57928,70,NULL,NULL,'2MASX J15090999+4444484',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.291667,44.74686,0.053,NULL,59993296505,937395257,14646800,17.8),(127073,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127073,38.11,0.23,419,57929,70,NULL,NULL,'SDSS J150911.23+300141.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.296833,30.02833,0.029,NULL,60086405148,938850080,14669532,18.2),(127074,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127074,36.87,0.46,236,57930,70,NULL,NULL,'2MASX J15091133+0040385',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.2972917,0.67731,0.133,NULL,56373496679,880835885,13763060,17.1),(127075,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127075,37.09,0.33,262,57931,70,NULL,NULL,'2MASX J15091140+6116048',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000099,NULL,'16.1g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,227.297625,61.26789,0.005,NULL,57778577960,902790280,14106098,16.1),(127076,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127076,37.32,0.21,291,57932,70,NULL,NULL,'SDSS J150911.46+265230.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.29775,26.87522,0.101,NULL,59898729251,935917644,14623713,18.1),(127077,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127077,37.76,0.21,356,57933,70,NULL,NULL,'2MASX J15091270+0951085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.302833,9.85236,0.065,NULL,59346460963,927288452,14488882,17.4),(127078,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127078,33.57,0.8,51.8,57934,75,NULL,'CF, r','NGC 5875',NULL,'1997ApJS..109..333W',1997,1,1.53,NULL,'G',0.000067,NULL,'13.2g',1.01,'SAb:','in a pair',NULL,NULL,NULL,1,227.304833,52.52844,0.013,NULL,59661585726,932212276,14565816,13.2),(127079,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127079,33,0.38,39.8,57934,75,NULL,'CF, r, raw','NGC 5875',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127080,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127080,33.12,0.38,42.1,57934,75,NULL,'CF, r, inv','NGC 5875',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127081,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127081,33.15,0.38,42.7,57934,75,NULL,'CF, r, cor','NGC 5875',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127082,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127082,33.59,0.47,52.3,57934,NULL,NULL,'H','NGC 5875',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127083,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127083,33.61,0.45,52.8,57934,NULL,NULL,'K','NGC 5875',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127084,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127084,33.63,0.44,53.3,57934,NULL,NULL,'Malmquist cor.','NGC 5875',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127085,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127085,33.64,0.2,53.5,57934,74.4,NULL,NULL,'NGC 5875',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127086,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127086,33.65,0.46,53.7,57934,NULL,NULL,'J','NGC 5875',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127087,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127087,33.68,0.4,54.3,57934,NULL,NULL,'mean','NGC 5875',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127088,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127088,33.78,0.41,57.1,57934,NULL,NULL,NULL,'NGC 5875',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127089,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127089,38.01,0.46,401,57935,70,NULL,NULL,'2MASX J15091368+0848355',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.306917,8.81008,0.037,NULL,59384232411,927878631,14498103,17.1),(127090,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127090,36.87,0.46,237,57936,70,NULL,NULL,'SDSS J150914.45+343947.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.31025,34.66325,0.021,NULL,60114195164,939284299,14676317,17.7),(127091,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127091,37.7,0.11,346,57937,70,NULL,NULL,'SDSS J150915.85+073915.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000186,NULL,'18.4g',0.13,NULL,'Group member',NULL,NULL,NULL,1,227.316083333,7.65431,0.049,NULL,59386705863,927917279,14498707,18.4),(127092,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127092,32.12,0.8,26.6,57938,75,NULL,'MAT, I','NGC 5861',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000003,NULL,'12.30',1.7,'SAB(rs)c       HII','in a pair',NULL,NULL,'Sy 2',1,227.3170417,-11.32167,0.405,NULL,46485414653,726334603,11348978,12.3),(127093,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127093,32.14,0.8,26.8,57938,75,NULL,'A82, H','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127094,'Sosies','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127094,31.94,0.15,24.4,57938,NULL,NULL,NULL,'NGC 5861',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127095,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127095,31.85,0.46,23.4,57938,NULL,NULL,'J','NGC 5861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127096,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127096,31.87,0.43,23.7,57938,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5861',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127097,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127097,31.89,0.47,23.9,57938,NULL,NULL,'H','NGC 5861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127098,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127098,31.9,0.4,24,57938,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5861',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127099,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127099,31.93,0.43,24.3,57938,75,NULL,'3.6 micron, color corrected','NGC 5861',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127100,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127100,31.96,0.45,24.7,57938,NULL,NULL,'K','NGC 5861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127101,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127101,32,0.32,25.1,57938,85,NULL,'I, raw','NGC 5861',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127102,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127102,32.05,0.32,25.7,57938,85,NULL,'I, inv','NGC 5861',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127103,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127103,32.05,0.2,25.7,57938,74.4,NULL,NULL,'NGC 5861',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127104,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127104,32.15,0.43,26.9,57938,75,NULL,'MAT, I, raw','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127105,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127105,32.21,0.4,27.7,57938,NULL,NULL,'mean','NGC 5861',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127106,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127106,32.24,0.38,28.1,57938,NULL,NULL,NULL,'NGC 5861',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127107,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127107,32.3,0.4,28.9,57938,75,NULL,'B','NGC 5861',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127108,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127108,32.31,0.52,28.9,57938,NULL,NULL,'Malmquist cor.','NGC 5861',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127109,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127109,32.31,0.52,29,57938,NULL,NULL,NULL,'NGC 5861',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127110,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127110,32.36,0.43,29.6,57938,75,NULL,'MAT, I, cor','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127111,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127111,32.37,0.43,29.8,57938,75,NULL,'MAT, I, inv','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127112,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127112,32.53,0.47,32.1,57938,75,NULL,'A82, H, raw','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127113,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127113,32.66,0.47,34,57938,75,NULL,'A82, H, cor','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127114,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127114,32.67,0.47,34.3,57938,75,NULL,'A82, H, inv','NGC 5861',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127115,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127115,37.7,0.11,346,57939,70,NULL,NULL,'2MASX J15091606+0727575',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.7g',0.19,NULL,'Group member',NULL,NULL,NULL,1,227.317083333,7.46608,0.045,NULL,59386990672,927921729,14498777,17.7),(127116,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127116,38.11,0.23,419,57940,70,NULL,NULL,'SDSS J150916.60+301110.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.319208333,30.18611,0.029,NULL,60086398699,938849979,14669530,18.2),(127117,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127117,37.9,0.46,380,57941,70,NULL,NULL,'SDSS J150916.61+483247.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.31925,48.54639,0.017,NULL,59939371908,936552686,14633635,18.3),(127118,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127118,37.41,0.46,303,57942,70,NULL,NULL,'2MASX J15091668-0040365',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.319375,-0.67669,0.173,NULL,45368576056,708884000,11076312,17.1),(127119,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127119,36.74,0.46,222,57943,70,NULL,NULL,'2MASX J15091668+2452522',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.319625,24.88142,0.125,NULL,59411582769,928305980,14504780,17),(127120,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127120,37.7,0.11,346,57944,70,NULL,NULL,'2MASX J15091687+0738015',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000137,NULL,'15.3',0.27,NULL,'Group member',NULL,NULL,NULL,1,227.3202917,7.63392,0.049,NULL,59386707520,927917305,14498707,15.3),(127121,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127121,37.15,0.33,269,57945,70,NULL,NULL,'2MASX J15091851+0537075',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.3272917,5.61881,0.085,NULL,59332324982,927067577,14485430,16.9),(127122,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127122,37.7,0.11,346,57946,70,NULL,NULL,'2MASX J15091889+0737295',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,'Group member',NULL,NULL,NULL,1,227.328833,7.62492,0.049,NULL,59386707537,927917305,14498707,18),(127123,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127123,37.66,0.46,340,57947,70,NULL,NULL,'2MASX J15092013+0650235',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.333917,6.83986,0.049,NULL,59386461828,927913466,14498647,17.3),(127124,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127124,37.98,0.46,395,57948,70,NULL,NULL,'2MASX J15092022+1000185',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.334167,10.00522,0.077,NULL,59346347014,927286672,14488854,17.2),(127125,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127125,37.32,0.21,291,57949,70,NULL,NULL,'2MASX J15092045+2642491',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.30',0.25,NULL,NULL,NULL,NULL,NULL,1,227.335291667,26.71356,0.117,NULL,59898775619,935918369,14623724,17.3),(127126,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127126,36.87,0.46,236,57950,70,NULL,NULL,'2MASX J15092061+3419485',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.336,34.33006,0.021,NULL,60116087390,939313865,14676779,16.9),(127127,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127127,37.82,0.46,366,57951,70,NULL,NULL,'2MASX J15092162+1049215',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.3400417,10.82272,0.081,NULL,59348498781,927320293,14489379,17.3),(127128,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127128,35.38,0.2,119,57952,74.4,NULL,NULL,'CGCG 165-024',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.00005,NULL,'15.7',0.23,NULL,NULL,NULL,NULL,NULL,1,227.3407083,27.99758,0.053,NULL,59897710482,935901726,14623464,15.7),(127129,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127129,37.44,0.46,308,57953,70,NULL,NULL,'2MASX J15092190+3639004',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.341417,36.65014,0,NULL,60119120747,939361261,14677519,17),(127130,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127130,34.46,NULL,78,57954,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 328- G 026',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000036,NULL,'16.4',0.13,'Sd',NULL,NULL,NULL,NULL,1,227.342666667,-41.80939,0.321,NULL,47068163375,735440052,11491250,16.4),(127131,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127131,34.47,NULL,78.4,57954,NULL,NULL,'Dipole + Quadrupole','ESO 328- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127132,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127132,34.49,NULL,79,57954,NULL,NULL,'Dipole','ESO 328- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127133,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127133,34.6,0.46,83.1,57955,70,NULL,NULL,'2MASX J15092224+1056285',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000161,NULL,'15.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,227.342583333,10.94128,0.081,NULL,59348493153,927320205,14489378,15.7),(127134,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127134,38.23,0.33,442,57956,70,NULL,NULL,'2MASX J15092300+1221226',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.345875,12.35647,0.113,NULL,59569093556,930767086,14543235,17.5),(127135,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127135,37.15,0.33,269,57957,70,NULL,NULL,'2MASX J15092333+0543385',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.3472917,5.72742,0.077,NULL,59332314928,927067420,14485428,17.1),(127136,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127136,38.35,0.46,468,57958,70,NULL,NULL,'SDSS J150924.43+215109.3',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.351833,21.85258,0.109,NULL,59535012284,930234566,14534915,17.7),(127137,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127137,37.76,0.21,356,57959,70,NULL,NULL,'2MASX J15092454+0946155',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000197,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,227.352167,9.771,0.065,NULL,59346489896,927288904,14488889,16.4),(127138,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127138,37.25,0.46,282,57960,70,NULL,NULL,'SDSS J150924.53+561341.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.35225,56.22814,0.013,NULL,57715308557,901801696,14090651,18.3),(127139,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127139,37.7,0.11,346,57961,70,NULL,NULL,'SDSS J150924.62+073323.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000173,NULL,'16.0',NULL,NULL,'Group member',NULL,NULL,NULL,1,227.352625,7.55642,0.049,NULL,59386697420,927917147,14498705,16),(127140,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127140,37.32,0.21,291,57962,70,NULL,NULL,'2MASX J15092504+2637147',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.92',0.21,NULL,NULL,NULL,NULL,NULL,1,227.354291667,26.62067,0.117,NULL,59898814543,935918977,14623734,17.92),(127141,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127141,37.76,0.21,356,57963,70,NULL,NULL,'2MASX J15092591+0951527',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,227.358083,9.86469,0.065,NULL,59346345482,927286648,14488853,18.3),(127142,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127142,38.23,0.33,442,57964,70,NULL,NULL,'2MASX J15092628+1217596',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.3595,12.29994,0.113,NULL,59347576216,927305878,14489154,17.1),(127143,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127143,37.74,0.12,354,57965,70,NULL,NULL,'2MASX J15092661+0847457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.3609583,8.79614,0.037,NULL,59384231171,927878612,14498103,16.9),(127144,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127144,38.44,0.46,488,57966,70,NULL,NULL,'2MASX J15092755+3025299',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.76',0.15,NULL,NULL,NULL,NULL,NULL,1,227.364833,30.42489,0.033,NULL,60086319763,938848746,14669511,18.76),(127145,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127145,37.7,0.11,346,57967,70,NULL,NULL,'2MASX J15092779+0732167',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000177,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.365917,7.53786,0.049,NULL,59386751250,927917988,14498718,18),(127146,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127146,38.17,0.46,431,57968,70,NULL,NULL,'2MASX J15092808+2344093',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.3669583,23.73597,0.109,NULL,59412134855,928314607,14504915,17.6),(127147,'BCG','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127147,37.73,0.35,326,57969,60,NULL,'ABELL 2028, BCG','GIN 416',0.0772,'1980ApJ...241..486H',1980,1,0.79,NULL,'G',0.000117,NULL,'15.4g',0.52,'E/S0','Group member',NULL,NULL,NULL,1,227.367375,7.55683,0.049,NULL,59386751367,927917990,14498718,15.4),(127148,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127148,36.82,0.27,231,57969,70,NULL,NULL,'GIN 416',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127149,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127149,37.7,0.11,346,57969,70,NULL,NULL,'GIN 416',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127150,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127150,37.74,0.12,354,57970,70,NULL,NULL,'2MASX J15092844+0851157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.3685,8.85433,0.049,NULL,59384039845,927875622,14498056,17.6),(127151,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127151,37.02,0.33,253,57971,70,NULL,NULL,'CGCG 165-025',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00014,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,227.370375,27.42258,0.069,NULL,59897608318,935900129,14623439,15.6),(127152,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127152,31.4,0.8,19.1,57972,75,NULL,NULL,'ESO 223- G 012',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000017,NULL,'14.1',0.5,'SA(s)bc?sp;dust lane',NULL,NULL,NULL,NULL,1,227.3705417,-52.55547,NULL,NULL,46307703420,723557865,11305591,14.1),(127153,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127153,30.39,0.46,12,57972,NULL,NULL,'J','ESO 223- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127154,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127154,30.51,0.47,12.7,57972,NULL,NULL,'H','ESO 223- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127155,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127155,30.64,0.45,13.4,57972,NULL,NULL,'K','ESO 223- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127156,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127156,31.11,0.4,16.7,57972,NULL,NULL,'mean','ESO 223- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127157,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127157,37.76,0.21,356,57973,70,NULL,NULL,'SDSS J150929.14+095048.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.3714583,9.84689,0.065,NULL,59346371230,927287050,14488860,18.4),(127158,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127158,36.88,0.46,237,57974,70,NULL,NULL,'2MASX J15092923+4443384',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.371916667,44.72742,0.041,NULL,59993295786,937395246,14646800,16.9),(127159,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127159,37.54,0.46,322,57975,70,NULL,NULL,'2MASX J15092943+1641496',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.3727083,16.69717,0.053,NULL,59583198166,930987471,14546679,17.2),(127160,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127160,35.88,0.54,150,57976,70,NULL,NULL,'2MASX J15092957-3748117',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,227.373125,-37.80331,0.273,NULL,47188964423,737327569,11520743,14.1),(127161,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127161,38.29,0.46,455,57977,70,NULL,NULL,'2MASX J15092960+3227189',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.3735,32.45531,0.033,NULL,60085014904,938828357,14669193,18.1),(127162,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127162,36.86,0.46,236,57978,70,NULL,NULL,'2MASX J15093036+0536455',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.376417,5.61258,0.085,NULL,59332254515,927066476,14485413,16.7),(127163,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127163,37.7,0.11,346,57979,70,NULL,NULL,'2MASX J15093034+0744207',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.3764583,7.73917,0.049,NULL,59384665431,927885397,14498209,17.8),(127164,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127164,35.52,0.46,127,57980,70,NULL,NULL,'CGCG 249-008',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000167,NULL,'14.9g',0.67,'E0',NULL,NULL,NULL,NULL,1,227.3765,46.49269,0.057,NULL,59986034598,937281790,14645027,14.9),(127165,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127165,37.27,0.46,285,57981,70,NULL,NULL,'2MASX J15093088+1131267',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.378625,11.524,0.101,NULL,59349296494,927332757,14489574,17.2),(127166,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127166,37.57,0.46,326,57982,70,NULL,NULL,'2MASX J15093110+4714004',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.379583,47.23356,0.065,NULL,59984573066,937258954,14644671,17),(127167,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127167,37.74,0.12,354,57983,70,NULL,NULL,'SDSS J150931.16+085211.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.379833,8.86986,0.049,NULL,59384040835,927875638,14498056,18.7),(127168,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127168,33.56,0.4,51.6,57984,NULL,NULL,'mean','NGC 5876',NULL,'2007A&A...465...71T',2007,1,2.13,NULL,'G',0.000027,NULL,'13.3g',0.85,'SB(r)ab:','in a radial-velocity based grouping',NULL,NULL,NULL,1,227.3815,54.5065,0.005,NULL,59660539574,932195930,14565561,13.3),(127169,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127169,34.08,0.45,65.4,57984,NULL,NULL,'K','NGC 5876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127170,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127170,34.08,0.47,65.4,57984,NULL,NULL,'H','NGC 5876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127171,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127171,34.1,0.46,66,57984,NULL,NULL,'J','NGC 5876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127172,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127172,36.92,0.46,242,57985,70,NULL,NULL,'2MASX J15093274+5614338',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,227.386666667,56.24264,0.013,NULL,57581921422,899717522,14058086,16.3),(127173,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127173,38.19,0.46,434,57986,70,NULL,NULL,'SDSS J150932.87+222459.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.387,22.41644,0.117,NULL,59409191663,928268619,14504197,18.1),(127174,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127174,37.03,0.46,255,57987,70,NULL,NULL,'2MASX J15093290+4229234',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.387,42.48994,0.017,NULL,59972730330,937073911,14641779,16.5),(127175,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127175,38.14,0.46,426,57988,70,NULL,NULL,'2MASX J15093314+3321119',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000201,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.388,33.35347,0.029,NULL,60116326857,939317607,14676837,17.4),(127176,'BCG','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127176,37.73,0.35,326,57989,60,NULL,NULL,'ABELL 2028',0.0772,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,227.388458333,7.52708,0.049,NULL,59386752938,927918014,14498718,NULL),(127177,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127177,37.74,0.46,353,57990,70,NULL,NULL,'2MASX J15093360+3302189',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.389917,33.03858,0.025,NULL,60116212622,939315822,14676809,17.7),(127178,'Tully est','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127178,32.27,0.8,28.5,57991,75,NULL,'B','NGC 5864',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000013,NULL,'12.77',0.9,'SB(s)0^0^? sp','in a radial-velocity based grouping',NULL,NULL,NULL,1,227.389833333,3.05275,0.105,NULL,56385116445,881017444,13765897,12.77),(127179,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127179,31.26,0.45,17.8,57991,NULL,NULL,'K','NGC 5864',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127180,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127180,32.16,0.4,27,57991,NULL,NULL,'mean','NGC 5864',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127181,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127181,32.16,NULL,27,57991,72,NULL,NULL,'NGC 5864',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127182,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127182,37.7,0.11,346,57992,70,NULL,NULL,'2MASX J15093377+0730557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000123,NULL,'15.1',0.31,NULL,'Group member',NULL,NULL,NULL,1,227.390667,7.51531,0.049,NULL,59386752879,927918013,14498718,15.1),(127183,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127183,38.11,0.23,419,57993,70,NULL,NULL,'2MASX J15093387+3007170',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'19.25',0.11,NULL,NULL,NULL,NULL,NULL,1,227.391125,30.12131,0.029,NULL,60086493418,938851459,14669554,19.25),(127184,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127184,37.02,0.33,253,57994,70,NULL,NULL,'2MASX J15093475+2725177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.42',0.16,NULL,NULL,NULL,NULL,NULL,1,227.394875,27.42158,0.069,NULL,59897609193,935900143,14623439,18.42),(127185,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127185,37.65,0.46,339,57995,70,NULL,NULL,'2MASX J15093485+0615087',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000184,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.395375,6.25256,0.053,NULL,59383534976,927867734,14497933,17),(127186,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127186,37.78,0.46,359,57996,70,NULL,NULL,'2MASX J15093530+0120288',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.397208333,1.34139,0.117,NULL,56372760846,880824388,13762881,17.5),(127187,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127187,37.74,0.12,354,57997,70,NULL,NULL,'SDSS J150936.28+084748.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000171,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.401167,8.79678,0.037,NULL,59384219978,927878437,14498100,18.5),(127188,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127188,37.74,0.12,354,57998,70,NULL,NULL,'SDSS J150936.37+084527.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.401583,8.75756,0.037,NULL,59384153127,927877392,14498084,18.2),(127189,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127189,37.7,0.11,346,57999,70,NULL,NULL,'2MASX J15093640+0734007',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000117,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.40175,7.56686,0.049,NULL,59386753099,927918017,14498719,16.6),(127190,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127190,38.17,0.33,430,58000,70,NULL,NULL,'SDSS J150938.73+004049.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000075,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,227.411417,0.68039,0.133,NULL,56373438487,880834976,13763046,18.8),(127191,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127191,37.23,0.27,280,58001,70,NULL,NULL,'2MASX J15093865+5907118',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000066,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.4114583,59.11989,0.013,NULL,57719485740,901866964,14091671,17.2),(127192,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127192,34,0.46,63,58002,70,NULL,NULL,'CGCG 221-032',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000147,NULL,'14.8g',0.46,'S0/a',NULL,NULL,NULL,NULL,1,227.411708333,42.71339,0.017,NULL,59972689691,937073276,14641769,14.8),(127193,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127193,37.74,0.12,354,58003,70,NULL,NULL,'2MASX J15093889+0845007',NULL,'2015arXiv151105856S',2015,1,0.26,'TXS codes: lobes(C)','G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,227.412125,8.75022,0.037,NULL,59384153184,927877393,14498084,17.3),(127194,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127194,38.08,0.46,413,58004,70,NULL,NULL,'2MASX J15093928-0219192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.413583,-2.32192,0.257,NULL,45381138305,709080286,11079379,17.6),(127195,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127195,37.99,0.46,396,58005,70,NULL,NULL,'2MASX J15094037+0745507',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.418333,7.76403,0.049,NULL,59384720325,927886255,14498222,17.9),(127196,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127196,37.74,0.12,354,58006,70,NULL,NULL,'2MASX J15094247+0846497',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.427083,8.78044,0.037,NULL,59384153845,927877403,14498084,17.7),(127197,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127197,36.09,0.46,165,58007,70,NULL,NULL,'2MASX J15094384+0123238',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000101,NULL,'16.3g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,227.4325,1.38994,0.113,NULL,56372771074,880824548,13762883,16.3),(127198,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127198,37.34,0.46,294,58008,70,NULL,NULL,'2MASX J15094432+3034230',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.70',0.14,NULL,NULL,NULL,NULL,NULL,1,227.434833,30.573,0.033,NULL,60086346551,938849164,14669518,18.7),(127199,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127199,37.7,0.11,346,58009,70,NULL,NULL,'2MASX J15094534+0730247',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000163,NULL,'17.0g',0.24,NULL,'Group member',NULL,NULL,NULL,1,227.4389583,7.50681,0.049,NULL,59386750069,927917969,14498718,17),(127200,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127200,38.17,0.33,430,58010,70,NULL,NULL,'2MASX J15094624+0035338',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000089,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.44275,0.59281,0.133,NULL,56373467269,880835426,13763053,17),(127201,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127201,37.7,0.11,346,58011,70,NULL,NULL,'2MASX J15094642+0728587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.8g',0.19,NULL,'Group member',NULL,NULL,NULL,1,227.443333,7.48294,0.049,NULL,59386718256,927917472,14498710,17.8),(127202,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127202,31.06,0.8,16.3,58012,75,NULL,'A82, H','NGC 5879',NULL,'1997ApJS..109..333W',1997,1,3.74,NULL,'G',0.000017,NULL,'12.4g',1.01,'SA(rs)bc:?     LINER','X-ray-faint group member',NULL,NULL,NULL,1,227.444708333,57.00019,0.017,NULL,57714776716,901793386,14090521,12.4),(127203,'IRAS','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127203,31.17,0.8,17.2,58012,75,NULL,'CF, r','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127204,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127204,30.45,0.4,12.3,58012,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 5879',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127205,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127205,30.53,0.47,12.7,58012,75,NULL,'A82, H, raw','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127206,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127206,30.53,0.47,12.8,58012,75,NULL,'A82, H, inv','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127207,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127207,30.56,NULL,12.9,58012,NULL,NULL,'B','NGC 5879',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127208,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127208,30.79,0.47,14.4,58012,75,NULL,'A82, H, cor','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127209,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127209,31,0.35,15.8,58012,NULL,NULL,NULL,'NGC 5879',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127210,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127210,31.05,0.43,16.2,58012,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5879',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127211,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127211,31.11,0.43,16.6,58012,75,NULL,'3.6 micron, color corrected','NGC 5879',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127212,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127212,31.12,0.4,16.8,58012,75,NULL,'B','NGC 5879',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127213,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127213,31.2,0.2,17.4,58012,74.4,NULL,NULL,'NGC 5879',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127214,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127214,31.48,0.38,19.7,58012,75,NULL,'CF, r, raw','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127215,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127215,31.56,0.38,20.5,58012,75,NULL,'CF, r, inv','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127216,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127216,31.71,0.38,22,58012,75,NULL,'CF, r, cor','NGC 5879',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127217,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127217,37.74,0.12,354,58013,70,NULL,NULL,'2MASX J15094780+0850197',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.449291667,8.83889,0.049,NULL,59384217842,927878403,14498100,17.4),(127218,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127218,36.23,0.46,176,58014,70,NULL,NULL,'2MASX J15094919+2528257',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.454917,25.47378,0.129,NULL,59898388600,935912321,14623630,16.8),(127219,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127219,31.98,1.22,24.9,58015,NULL,NULL,'I','NGC 5869',NULL,'2001ApJ...546..681T',2001,1,2.3,'HOLM 699B,C are stars.','G',0.000013,NULL,'12.91',1.7,'S0^0^:','Pair member (points to parent)',NULL,NULL,NULL,1,227.456,0.47003,0.129,NULL,56372589822,880821715,13762839,12.91),(127220,'SBF','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127220,32.06,0.14,25.8,58015,74.4,NULL,NULL,'NGC 5869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127221,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127221,32.47,0.4,31.1,58015,NULL,NULL,'mean','NGC 5869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127222,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127222,32.63,0.45,33.5,58015,NULL,NULL,'K','NGC 5869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127223,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127223,37.66,0.46,341,58016,70,NULL,NULL,'2MASX J15095009+4552327',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.458666667,45.87583,0.045,NULL,59986123771,937283183,14645049,17.4),(127224,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127224,36.76,0.46,225,58017,70,NULL,NULL,'2MASX J15095067+3616379',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,227.4610417,36.27714,0.005,NULL,60127501622,939492212,14679565,16),(127225,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127225,34.24,0.2,70.5,58018,74.4,NULL,NULL,'UGC 09744',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00007,NULL,'14.8g',0.62,'SB(r)ab',NULL,NULL,NULL,NULL,1,227.464,1.77897,0.081,NULL,56385380147,881021564,13765961,14.8),(127226,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127226,37.74,0.12,354,58019,70,NULL,NULL,'2MASX J15095158+0850467',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.464875,8.84644,0.049,NULL,59351597056,927368704,14490136,17.3),(127227,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127227,37.81,0.17,365,58020,70,NULL,NULL,'2MASX J15095217+0424278',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.467458333,4.40772,0.089,NULL,59330906233,927045409,14485084,16.6),(127228,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127228,37.65,0.06,339,58021,70,NULL,NULL,'2MASX J15095251+0540468',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.468875,5.67972,0.077,NULL,59332249974,927066405,14485412,17.8),(127229,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127229,37.7,0.11,346,58022,70,NULL,NULL,'2MASX J15095254+0729027',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.8g',0.2,NULL,'Group member',NULL,NULL,NULL,1,227.469083333,7.48403,0.049,NULL,59386713302,927917395,14498709,17.8),(127230,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127230,37.81,0.17,365,58023,70,NULL,NULL,'SDSS J150953.83+042436.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.474291667,4.41011,0.089,NULL,59330907071,927045422,14485084,18.1),(127231,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127231,37.74,0.12,354,58024,70,NULL,NULL,'2MASX J15095435+0857490',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,227.476417,8.96356,0.049,NULL,59351530571,927367665,14490119,16.6),(127232,'Tully-Fisher','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,NULL,127232,35.62,0.2,133,58025,74.4,NULL,NULL,'CGCG 077-024',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000014,NULL,'15.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.4864583,9.38767,0.057,NULL,59353660143,927400939,14490639,15.9),(127233,'FP','2016-12-15 15:15:31','2016-12-16 11:20:45','1',NULL,'R',127233,36.08,0.46,164,58026,70,NULL,NULL,'2MASX J15095709+3241241',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000159,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.4877917,32.68997,0.025,NULL,60084979485,938827804,14669184,16.4),(127234,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127234,37.81,0.17,365,58027,70,NULL,NULL,'2MASX J15095718+0424558',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.488167,4.41567,0.089,NULL,59330906462,927045413,14485084,17.4),(127235,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127235,37.65,0.46,338,58028,70,NULL,NULL,'2MASX J15095851+0012038',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000065,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.49375,0.20092,0.129,NULL,56372749473,880824210,13762878,18),(127236,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127236,37.35,0.46,295,58029,70,NULL,NULL,'2MASX J15095896+3031381',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.81',0.14,NULL,NULL,NULL,NULL,NULL,1,227.4955417,30.52739,0.033,NULL,60086351378,938849240,14669519,18.81),(127237,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127237,38.13,0.33,423,58030,70,NULL,NULL,'2MASX J15100033+1815007',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.501375,18.25039,0.057,NULL,59583913076,930998641,14546853,17.5),(127238,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127238,38.3,0.23,456,58031,70,NULL,NULL,'2MASX J15100076+3330501',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.503333,33.51394,0.025,NULL,60116346862,939317919,14676842,18.5),(127239,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127239,37.84,0.46,369,58032,70,NULL,NULL,'SDSS J151001.40+200417.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.505875,20.07158,0.053,NULL,59537982920,930280983,14535640,18),(127240,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127240,37.87,0.27,374,58033,70,NULL,NULL,'2MASX J15100157+0256038',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000094,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.5065417,2.93439,0.105,NULL,56385304212,881020378,13765943,17),(127241,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127241,36.37,0.46,188,58034,70,NULL,NULL,'2MASX J15100167+1048200',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000173,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.507125,10.80544,0.081,NULL,59348509345,927320458,14489382,16.1),(127242,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127242,34.44,0.47,77.3,58035,70,NULL,NULL,'2MASX J15100233-1051019',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.33',0.7,NULL,NULL,NULL,NULL,NULL,1,227.509833,-10.85072,0.401,NULL,46484543909,726320998,11348765,15.33),(127243,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127243,37.05,0.46,257,58036,70,NULL,NULL,'2MASX J15100309+0312548',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000094,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.512917,3.21522,0.097,NULL,56381124459,880955069,13764922,17.5),(127244,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127244,38.3,0.23,456,58037,70,NULL,NULL,'2MASX J15100413+3328231',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.517208333,33.47317,0.025,NULL,60116377044,939318391,14676849,18.4),(127245,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127245,36.96,0.46,247,58038,70,NULL,NULL,'2MASX J15100496+0721020',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,'Group member',NULL,NULL,NULL,1,227.5207083,7.35069,0.053,NULL,59386825535,927919148,14498736,17.3),(127246,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127246,36.87,0.27,236,58039,70,NULL,NULL,'2MASX J15100555+0113198',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.523,1.22203,0.117,NULL,56372804579,880825071,13762891,16.4),(127247,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127247,38.13,0.33,423,58040,70,NULL,NULL,'2MASX J15100559+1812416',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.5235,18.21161,0.057,NULL,59583911786,930998621,14546853,16.7),(127248,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127248,36.87,0.27,236,58041,70,NULL,NULL,'2MASX J15100576+0114398',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000084,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,227.5239583,1.24428,0.113,NULL,56372795976,880824937,13762889,16.2),(127249,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127249,37.7,0.11,346,58042,70,NULL,NULL,'SDSS J151006.09+073802.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,'Group member',NULL,NULL,NULL,1,227.525375,7.63417,0.049,NULL,59386731651,927917682,14498713,18.1),(127250,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127250,37.15,0.46,269,58043,70,NULL,NULL,'2MASX J15100613-0006015',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000095,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,227.5255,-0.10042,0.129,NULL,45367931959,708873936,11076155,16.4),(127251,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127251,36.64,0.46,213,58044,70,NULL,NULL,'2MASX J15100628+1926226',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.17',0.28,NULL,NULL,NULL,NULL,NULL,1,227.526333333,19.4395,0.089,NULL,59537476738,930273074,14535516,17.17),(127252,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127252,37.74,0.12,354,58045,70,NULL,NULL,'2MASX J15100656+0850400',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000183,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,227.527375,8.84436,0.049,NULL,59351597583,927368712,14490136,16.1),(127253,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127253,37.21,0.46,277,58046,70,NULL,NULL,'2MASX J15100710+1006390',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,227.5295,10.11094,0.073,NULL,59347234841,927300544,14489071,16.5),(127254,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127254,34.81,0.46,91.5,58047,70,NULL,NULL,'CGCG 165-027',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.000177,NULL,'14.6g',0.64,'S0',NULL,NULL,NULL,NULL,1,227.536875,31.88783,0.025,NULL,60087284800,938863825,14669747,14.6),(127255,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127255,37.26,0.46,283,58048,70,NULL,NULL,'2MASX J15100913+0823280',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000192,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.537917,8.391,0.045,NULL,59384862649,927888478,14498257,16.6),(127256,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127256,36.94,0.46,245,58049,70,NULL,NULL,'2MASX J15100914+3737280',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.538041667,37.62447,0.009,NULL,60102134021,939095844,14673372,16.7),(127257,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127257,37.87,0.27,374,58050,70,NULL,NULL,'SDSS J151010.30+025538.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.542917,2.92731,0.105,NULL,56385300197,881020315,13765942,18.3),(127258,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127258,36.87,0.27,236,58051,70,NULL,NULL,'2MASX J15101041+0132528',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000068,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.543291667,1.54811,0.109,NULL,56387178090,881049657,13766400,17.7),(127259,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127259,36.52,0.09,202,58052,70,NULL,NULL,'2MASX J15101034+0742300',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16',0.3,'S0','Group member',NULL,NULL,NULL,1,227.543291667,7.70819,0.049,NULL,59384685890,927885717,14498214,16),(127260,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127260,37.64,0.46,337,58053,70,NULL,NULL,'2MASX J15101078+0520198',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.5450417,5.33886,0.093,NULL,59332369376,927068271,14485441,17.4),(127261,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127261,36.58,0.25,207,58054,74.4,NULL,NULL,'CGCG 049-018',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000147,NULL,'15.6g',0.57,'Sbc','Group member',NULL,NULL,NULL,1,227.5457083,7.62897,0.049,NULL,59386729776,927917652,14498713,15.6),(127262,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127262,36.82,0.27,231,58054,70,NULL,NULL,'CGCG 049-018',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127263,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127263,36.49,0.46,199,58055,70,NULL,NULL,'2MASX J15101137+0313318',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000103,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.5475,3.22547,0.097,NULL,56381123145,880955049,13764922,16.4),(127264,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127264,38.3,0.23,456,58056,70,NULL,NULL,'2MASX J15101140+3329542',NULL,'2015arXiv151105856S',2015,1,0.19,'1997A&AS..123..411M has z = 0.114459 +- 0.000394.','G',0.000155,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.547583,33.49839,0.025,NULL,60116376551,939318383,14676849,18.4),(127265,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127265,37.65,0.06,339,58057,70,NULL,NULL,'2MASX J15101181+0609400',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.5492917,6.16119,0.069,NULL,59383506427,927867287,14497926,17.5),(127266,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127266,37.54,0.46,322,58058,70,NULL,NULL,'2MASX J15101340+2514037',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000185,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.556,25.2345,0.125,NULL,59896238769,935878730,14623105,17.7),(127267,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127267,37.16,0.46,270,58059,70,NULL,NULL,'2MASX J15101393+0937010',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.558083,9.61692,0.065,NULL,59353811385,927403302,14490676,17.2),(127268,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127268,36.89,0.46,238,58060,70,NULL,NULL,'SDSS J151015.11+094713.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.563,9.78703,0.065,NULL,59346358949,927286858,14488857,17.8),(127269,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127269,38.01,0.46,399,58061,70,NULL,NULL,'2MASX J15101614+1818435',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.567167,18.31208,0.061,NULL,59583908892,930998576,14546852,17.5),(127270,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127270,36.14,0.11,169,58062,70,NULL,NULL,'2MASX J15101616+0431498',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00009,NULL,'16.0g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,227.567375,4.53036,0.093,NULL,59330903854,927045372,14485083,16),(127271,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127271,37.68,0.46,343,58063,70,NULL,NULL,'2MASX J15101631+0641290',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.568125,6.69144,0.049,NULL,59386466447,927913538,14498649,17.4),(127272,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127272,32.15,0.4,26.9,58064,75,NULL,NULL,'UGC 09746',NULL,'2008Ap.....51..336K',2008,1,1.85,NULL,'G',0.00002,NULL,'14.6g',0.45,'Sbc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.5689583,1.93428,0.081,NULL,56385557458,881024335,13766005,14.6),(127273,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127273,32.16,0.43,27.1,58064,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127274,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127274,32.29,0.43,28.7,58064,75,NULL,'3.6 micron, color corrected','UGC 09746',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127275,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127275,32.38,0.2,29.9,58064,74.4,NULL,NULL,'UGC 09746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127276,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127276,32.41,NULL,30.4,58064,72,NULL,NULL,'UGC 09746',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127277,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127277,32.51,0.49,31.8,58064,75,NULL,'IR','UGC 09746',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127278,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127278,37.65,0.06,339,58065,70,NULL,NULL,'2MASX J15101702+0443558',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.570791667,4.73214,0.093,NULL,59331993271,927062394,14485349,16.6),(127279,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127279,37.09,0.33,262,58066,70,NULL,NULL,'2MASX J15101749+6117010',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000082,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.572667,61.2835,0.005,NULL,57778470798,902788606,14106071,16.6),(127280,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127280,37.29,0.46,287,58067,70,NULL,NULL,'SDSS J151017.64+060630.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.5735,6.10853,0.069,NULL,59328739453,927011553,14484555,18),(127281,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127281,37.91,0.46,382,58068,70,NULL,NULL,'SDSS J151018.63+475104.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000153,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.577667,47.85119,0.033,NULL,59939203978,936550062,14633594,18.6),(127282,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127282,37.65,0.06,339,58069,70,NULL,NULL,'2MASX J15101955+0547118',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.581583,5.78653,0.073,NULL,59328936759,927014636,14484603,17.7),(127283,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127283,38.3,0.23,456,58070,70,NULL,NULL,'2MASX J15102011+3329092',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000103,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.583833,33.48597,0.025,NULL,60116384058,939318500,14676851,16.9),(127284,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127284,38.42,0.46,483,58071,70,NULL,NULL,'2MASX J15102018+2514237',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.584333333,25.23992,0.165,NULL,59896239031,935878734,14623105,17.9),(127285,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127285,37.71,0.46,349,58072,70,NULL,NULL,'SDSS J151020.49+021824.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000074,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.585417,2.30681,0.105,NULL,56386020580,881031571,13766118,18.5),(127286,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127286,34.9,0.53,95.3,58073,70,NULL,NULL,'2MASX J15102148-4451226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,227.589458333,-44.85633,0.617,NULL,47104011426,736000178,11500002,14.7),(127287,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127287,37.43,0.46,306,58074,70,NULL,NULL,'2MASX J15102166+2405017',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.5902083,24.08378,0.117,NULL,59412221336,928315958,14504936,17.5),(127288,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127288,38.08,0.46,413,58075,70,NULL,NULL,'2MASX J15102195+5929535',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.5914583,59.49806,0.013,NULL,57774878506,902732476,14105194,17.8),(127289,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127289,37.74,0.12,354,58076,70,NULL,NULL,'2MASX J15102359+0847239',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.5982083,8.79011,0.049,NULL,59351613306,927368957,14490139,16.9),(127290,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127290,37.35,0.46,296,58077,70,NULL,NULL,'2MASX J15102438+5424034',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.6014583,54.40094,0.013,NULL,59660523128,932195673,14565557,16.9),(127291,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127291,38.5,0.46,501,58078,70,NULL,NULL,'2MASX J15102503+0655549',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.60425,6.93197,0.057,NULL,59386901889,927920342,14498755,17.2),(127292,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127292,38.01,0.46,399,58079,70,NULL,NULL,'2MASX J15102512+0410498',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.6047917,4.18047,0.073,NULL,59330962864,927046294,14485098,16.8),(127293,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127293,37.65,0.06,339,58080,70,NULL,NULL,'2MASX J15102544+0550278',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.08',0.2,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.6060417,5.84111,0.073,NULL,59328934276,927014598,14484603,17.08),(127294,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127294,38.25,0.46,446,58081,70,NULL,NULL,'SDSS J151026.29+012457.8',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.609583,1.41608,0.113,NULL,56386712502,881042382,13766287,17.9),(127295,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127295,37.81,0.17,365,58082,70,NULL,NULL,'2MASX J15102686+0404498',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.611875,4.08044,0.073,NULL,59330959082,927046235,14485097,17.6),(127296,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127296,38.49,0.46,500,58083,70,NULL,NULL,'SDSS J151027.19+295050.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.613333,29.84739,0.029,NULL,60085587795,938837309,14669332,18.4),(127297,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127297,37.23,0.27,280,58084,70,NULL,NULL,'2MASX J15102828+5902194',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000092,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,227.617875,59.03889,0.013,NULL,57719556165,901868065,14091688,16.2),(127298,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127298,37.65,0.06,339,58085,70,NULL,NULL,'SDSS J151028.69+053817.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.6195417,5.63819,0.077,NULL,59328796579,927012446,14484569,18.3),(127299,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127299,37.39,0.46,301,58086,70,NULL,NULL,'2MASX J15102872+0704190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.619666667,7.07183,0.057,NULL,59386765766,927918215,14498722,17.4),(127300,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127300,34.81,0.48,91.6,58087,70,NULL,NULL,'ARK 473',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000145,NULL,'14.6g',0.53,'S0       poss. LINER',NULL,NULL,NULL,NULL,1,227.623041667,-2.16864,0.221,NULL,45381006953,709078233,11079347,14.6),(127301,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127301,36.78,0.46,227,58088,70,NULL,NULL,'2MASX J15103002+1746042',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.625125,17.76794,0.045,NULL,59584061283,931000957,14546889,16.1),(127302,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127302,37.94,0.33,387,58089,70,NULL,NULL,'2MASX J15103014+0358386',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000095,NULL,'17.7g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,227.625583,3.97744,0.085,NULL,59330932478,927045819,14485090,17.7),(127303,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127303,36.75,0.46,224,58090,70,NULL,NULL,'2MASX J15103016+1849504',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.6257083,18.83086,0.077,NULL,59534503553,930226618,14534790,16.7),(127304,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127304,37.88,0.46,376,58091,70,NULL,NULL,'2MASX J15103169+0636140',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.631875,6.60375,0.041,NULL,59383640271,927869379,14497959,17.4),(127305,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127305,36.18,0.46,172,58092,70,NULL,NULL,'2MASX J15103241+4607298',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000196,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,227.635125,46.12486,0.049,NULL,59986087144,937282611,14645040,15.8),(127306,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127306,37.94,0.33,387,58093,70,NULL,NULL,'SDSS J151033.76+040002.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000085,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,227.640708333,4.00069,0.073,NULL,59330932215,927045815,14485090,18.5),(127307,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127307,37.72,0.46,349,58094,70,NULL,NULL,'2MASX J15103543+2922148',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'16.55',0.14,NULL,NULL,NULL,NULL,NULL,1,227.647583333,29.37067,0.045,NULL,60085532948,938836452,14669319,16.55),(127308,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127308,36.05,0.46,162,58095,70,NULL,NULL,'2MASX J15103595+5423143',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000184,NULL,'15.2g',0.57,'E0',NULL,NULL,NULL,NULL,1,227.649833,54.38739,0.013,NULL,59660522849,932195669,14565557,15.2),(127309,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127309,38.33,0.33,464,58096,70,NULL,NULL,'2MASX J15103617+0200596',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000096,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.650708333,2.01653,0.085,NULL,56385599513,881024992,13766015,17.3),(127310,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127310,37.65,0.06,339,58097,70,NULL,NULL,'SDSS J151036.41+055003.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'17.0I',0.11,NULL,NULL,NULL,NULL,NULL,1,227.6517083,5.83436,0.073,NULL,59328926772,927014480,14484601,17),(127311,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127311,37.65,0.06,339,58098,70,NULL,NULL,'2MASX J15103647+0601316',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,227.6519583,6.02556,0.069,NULL,59328911396,927014240,14484597,16.9),(127312,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127312,37.63,0.21,335,58099,70,NULL,NULL,'2MASX J15103803+0322386',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000068,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.658583333,3.3775,0.093,NULL,56381092470,880954569,13764915,17.6),(127313,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127313,32.76,0.8,35.7,58100,75,NULL,'A82, H','UGC 09764',NULL,'1997ApJS..109..333W',1997,1,1.9,'Often misidentified as NGC 5881.','G',0.000037,NULL,'15.1',1.2,'SB(s)dm',NULL,NULL,NULL,NULL,1,227.659041667,64.89847,NULL,NULL,57957644322,905588192,14149815,15.1),(127314,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127314,32.77,0.4,35.8,58100,75,NULL,'B','UGC 09764',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127315,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127315,33.34,0.4,46.6,58100,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 09764',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127316,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127316,34.45,0.47,77.8,58100,75,NULL,'A82, H, raw','UGC 09764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127317,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127317,34.48,0.47,78.8,58100,75,NULL,'A82, H, inv','UGC 09764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127318,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127318,34.94,0.47,97.2,58100,75,NULL,'A82, H, cor','UGC 09764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127319,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127319,37.65,0.06,339,58101,70,NULL,NULL,'2MASX J15103848+0514196',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,227.660417,5.23878,0.093,NULL,59331910477,927061101,14485329,16.5),(127320,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127320,37.65,0.06,339,58102,70,NULL,NULL,'2MASX J15103888+0510576',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.662083,5.18258,0.093,NULL,59331909271,927061082,14485329,16.5),(127321,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127321,36.38,0.33,189,58103,70,NULL,NULL,'2MASX J15103895+0601506',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.662375,6.03067,0.069,NULL,59328919597,927014368,14484599,16.3),(127322,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127322,37.88,0.46,377,58104,70,NULL,NULL,'2MASX J15103918+2925288',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'16.71',0.16,NULL,NULL,NULL,NULL,NULL,1,227.663208333,29.42464,0.045,NULL,60085740596,938839696,14669370,16.71),(127323,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127323,37.87,0.27,374,58105,70,NULL,NULL,'2MASX J15103970+0254476',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000104,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.665375,2.91317,0.105,NULL,56385272179,881019877,13765935,16.9),(127324,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127324,37.65,0.06,339,58106,70,NULL,NULL,'2MASX J15103989+0539186',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'15.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,227.666375,5.65528,0.073,NULL,59328808182,927012627,14484572,15.8),(127325,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127325,37.65,0.06,339,58107,70,NULL,NULL,'2MASX J15104042+0557216',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.668333,5.95603,0.069,NULL,59328910984,927014234,14484597,17.3),(127326,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127326,33.6,0.45,52.4,58108,NULL,NULL,NULL,'UGC 09759',NULL,'2009ApJS..182..474S',2009,1,2,NULL,'G',0.000027,NULL,'15.10',0.4,'S0a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.6707917,55.34983,0.013,NULL,57583350983,899739859,14058435,15.1),(127327,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127327,33.65,0.44,53.6,58108,NULL,NULL,'Malmquist cor.','UGC 09759',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127328,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127328,33.65,0.4,53.7,58108,NULL,NULL,'mean','UGC 09759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127329,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127329,33.73,0.2,55.7,58108,74.4,NULL,NULL,'UGC 09759',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127330,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127330,33.83,0.47,58.2,58108,NULL,NULL,'H','UGC 09759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127331,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127331,33.91,0.45,60.6,58108,NULL,NULL,'K','UGC 09759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127332,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127332,34.03,0.46,64.1,58108,NULL,NULL,'J','UGC 09759',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127333,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127333,36.32,0.46,183,58109,70,NULL,NULL,'2MASX J15104100+0828500',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000179,NULL,'16.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.6709583,8.48061,0.041,NULL,59384139101,927877173,14498080,16),(127334,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127334,37.16,0.46,270,58110,70,NULL,NULL,'2MASX J15104125+0026396',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,227.671875,0.44419,0.125,NULL,56372608106,880822001,13762843,16.3),(127335,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127335,38.01,0.46,400,58111,70,NULL,NULL,'2MASX J15104353+2249322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000195,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.6812917,22.8255,0.117,NULL,59410099745,928282808,14504418,17.3),(127336,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127336,37.65,0.06,339,58112,70,NULL,NULL,'SDSS J151043.53+052851.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.681417,5.48089,0.081,NULL,59328771856,927012060,14484563,18.3),(127337,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127337,37.65,0.06,339,58113,70,NULL,NULL,'2MASX J15104377+0558146',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.68225,5.97061,0.069,NULL,59328910835,927014231,14484597,18),(127338,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127338,37.81,0.17,365,58114,70,NULL,NULL,'2MASX J15104411+0418386',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.683833,4.31058,0.077,NULL,59331047863,927047622,14485119,17.1),(127339,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127339,37.65,0.06,339,58115,70,NULL,NULL,'2MASX J15104431+0453216',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.684667,4.88939,0.097,NULL,59332089753,927063902,14485373,17.6),(127340,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127340,37.57,0.46,326,58116,70,NULL,NULL,'2MASX J15104454+2211152',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.685666667,22.18756,0.109,NULL,59422855023,928482109,14507532,18),(127341,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127341,36.38,0.33,189,58117,70,NULL,NULL,'2MASX J15104605+0603326',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000167,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.6917917,6.05914,0.069,NULL,59328906933,927014170,14484596,16.4),(127342,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127342,37.65,0.06,339,58118,70,NULL,NULL,'SDSS J151046.82+054740.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.1I',NULL,NULL,NULL,NULL,NULL,NULL,1,227.695,5.79464,0.073,NULL,59328945439,927014772,14484605,17.1),(127343,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127343,37.65,0.06,339,58119,70,NULL,NULL,'2MASX J15104752+0538566',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.698125,5.64908,0.073,NULL,59328808336,927012630,14484572,17.8),(127344,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127344,36.89,0.46,239,58120,70,NULL,NULL,'2MASX J15104789+3855423',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.699583,38.92853,0.057,NULL,60104349054,939130453,14673913,17.3),(127345,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127345,37.63,0.21,335,58121,70,NULL,NULL,'2MASX J15104792+0329026',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000096,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.6997917,3.48419,0.097,NULL,56381060840,880954075,13764907,16.7),(127346,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127346,38.33,0.33,464,58122,70,NULL,NULL,'SDSS J151048.03+020103.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.700125,2.01761,0.085,NULL,56385575997,881024624,13766009,18.3),(127347,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127347,32.94,0.49,38.8,58123,70,NULL,NULL,'NGC 5863',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00003,NULL,'13.70',1.2,'(R\')SAB(rs)a','in a pair',NULL,NULL,NULL,1,227.7015,-18.43103,0.433,NULL,46700132266,729689566,11401399,13.7),(127348,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127348,34.06,0.4,64.9,58123,NULL,NULL,'mean','NGC 5863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127349,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127349,34.18,0.47,68.6,58123,NULL,NULL,'H','NGC 5863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127350,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127350,34.18,0.45,68.7,58123,NULL,NULL,'K','NGC 5863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127351,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127351,34.26,0.46,71,58123,NULL,NULL,'J','NGC 5863',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127352,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127352,37.69,0.46,345,58124,70,NULL,NULL,'2MASX J15104865+6057030',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.7029583,60.95094,0.021,NULL,57778232781,902784887,14106013,17.6),(127353,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127353,37.65,0.06,339,58125,70,NULL,NULL,'2MASX J15105101+0548026',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'15.8I',0.21,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.712625,5.80086,0.073,NULL,59328945957,927014780,14484605,15.8),(127354,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127354,37.81,0.17,365,58126,70,NULL,NULL,'2MASX J15105133+0409026',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.713917,4.15069,0.073,NULL,59330973483,927046460,14485100,17.8),(127355,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127355,37.65,0.06,339,58127,70,NULL,NULL,'2MASX J15105208+0539266',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'15.8I',0.2,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.717167,5.65747,0.073,NULL,59328810045,927012656,14484572,15.8),(127356,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127356,36.18,0.26,172,58128,70,NULL,NULL,'GIN 405',NULL,'2001MNRAS.321..277C',2001,1,0.49,NULL,'G',NULL,NULL,'16.0g',0.42,'S',NULL,NULL,NULL,NULL,1,227.7175417,4.86769,0.097,NULL,59332099550,927064055,14485375,16),(127357,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127357,37.65,0.06,339,58128,70,NULL,NULL,'GIN 405',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127358,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127358,37.65,0.06,339,58129,70,NULL,NULL,'2MASX J15105275+0543296',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'15.9I',0.22,NULL,NULL,NULL,NULL,NULL,1,227.7199583,5.72483,0.073,NULL,59328807083,927012610,14484572,15.9),(127359,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127359,37.26,0.46,283,58130,70,NULL,NULL,'SDSS J151052.80+265636.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.720041667,26.94347,0.085,NULL,59897936651,935905260,14623519,NULL),(127360,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127360,37.25,0.35,262,58131,60,NULL,NULL,'ABELL 2029',0.0777,'1980ApJ...241..486H',1980,1,NULL,'Position for IC 1101 adopted for ABELL 2029.','GClstr',0.00056,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,227.729167,5.72,0.073,NULL,59328807745,927012621,14484572,NULL),(127361,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127361,37.66,0.16,340,58131,NULL,NULL,'ABELL 2029 cluster, avg. of 14 spiral galaxies                    ','ABELL 2029',NULL,'2003AJ....126..675D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127362,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127362,37.65,0.06,339,58132,70,NULL,NULL,'2MASX J15105509+0533316',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.729625,5.55881,0.081,NULL,59328817392,927012771,14484574,17.3),(127363,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127363,35.51,0.2,126,58133,74.4,NULL,NULL,'CGCG 077-030',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000178,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,227.7305,10.95242,0.081,NULL,59348578379,927321537,14489399,16.3),(127364,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127364,34.79,0.46,90.9,58134,70,NULL,NULL,'NGC 5872',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00011,NULL,'13.58',0.9,'SAB0^0^:',NULL,NULL,NULL,NULL,1,227.731917,-11.48014,0.409,NULL,46484556865,726321201,11348768,13.58),(127365,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127365,37.81,0.17,365,58135,70,NULL,NULL,'2MASX J15105567+0405346',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000111,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.731917,4.09283,0.073,NULL,59330983689,927046620,14485103,17.2),(127366,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127366,37.28,0.46,286,58136,70,NULL,NULL,'2MASX J15105577-0019252',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000098,NULL,'16.3g',0.37,'E0',NULL,NULL,NULL,NULL,1,227.732375,-0.32356,0.161,NULL,45367725795,708870715,11076104,16.3),(127367,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127367,37.25,0.35,262,58137,60,NULL,'ABELL 2029, BCG','IC 1101',0.0777,'1980ApJ...241..486H',1980,1,1.2,NULL,'G',0.000087,NULL,'14.73',0.6,'cD;S0-:','Group member, radial-velocity confirmed',NULL,'radio jet',NULL,1,227.73375,5.74478,0.073,NULL,59328897120,927014017,14484594,14.73),(127368,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127368,38.04,0.46,406,58138,70,NULL,NULL,'2MASX J15105652+0758499',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.7355,7.98064,0.045,NULL,59384781849,927887216,14498237,18),(127369,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127369,38.39,0.46,476,58139,70,NULL,NULL,'SDSS J151057.64+562150.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000101,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.7402083,56.36408,0.013,NULL,57581898312,899717161,14058080,18.2),(127370,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127370,37.65,0.06,339,58140,70,NULL,NULL,'2MASX J15105810+0514506',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.74225,5.24744,0.093,NULL,59331917611,927061212,14485331,17.9),(127371,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127371,38.19,0.46,435,58141,70,NULL,NULL,'2MASX J15105827+5425104',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.7427083,54.41964,0.013,NULL,59660347028,932192922,14565514,17.8),(127372,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127372,36.95,0.46,246,58142,70,NULL,NULL,'2MASX J15105828+4958487',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.743041667,49.98019,0.021,NULL,59938099335,936532802,14633325,17.2),(127373,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127373,37.59,0.46,329,58143,70,NULL,NULL,'2MASX J15105846+1323573',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.743666667,13.39919,0.101,NULL,59570847185,930794487,14543663,NULL),(127374,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127374,32.16,NULL,27,58144,72,NULL,NULL,'UGC 09751',NULL,'2014Ap.....57..457K',2014,1,1,NULL,'G',0.00005,NULL,'15.62',0.2,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.74375,1.4375,0.109,NULL,56386696813,881042137,13766283,15.62),(127375,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127375,37.65,0.06,339,58145,70,NULL,NULL,'2MASX J15105878+0541308',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'16.4I',0.16,NULL,NULL,NULL,NULL,NULL,1,227.744917,5.69189,0.073,NULL,59328810248,927012660,14484572,16.4),(127376,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127376,37.65,0.06,339,58146,70,NULL,NULL,'SDSS J151059.92+045644.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.749666667,4.94575,0.101,NULL,59332071927,927063623,14485369,17.9),(127377,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127377,37.65,0.06,339,58147,70,NULL,NULL,'SDSS J151100.91+045029.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.753833,4.84156,0.097,NULL,59332085038,927063828,14485372,18.4),(127378,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127378,37.63,0.21,335,58148,70,NULL,NULL,'2MASX J15110098+0325318',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000076,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.754,3.42558,0.097,NULL,56381079877,880954373,13764912,16.9),(127379,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127379,38.01,0.33,400,58149,70,NULL,NULL,'SDSS J151101.44+031921.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.7560417,3.32253,0.093,NULL,56380981175,880952830,13764887,17.7),(127380,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127380,35.28,0.61,114,58150,70,NULL,NULL,'ESO 448- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000033,NULL,'13.53',0.3,'S...',NULL,NULL,NULL,NULL,1,227.758167,-31.2595,0.333,NULL,47206730484,737605163,11525080,13.53),(127381,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127381,35.98,0.46,157,58150,NULL,NULL,'Malmquist cor.','ESO 448- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127382,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127382,36.3,0.4,182,58150,NULL,NULL,NULL,'ESO 448- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127383,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127383,36.34,0.2,185,58150,74.4,NULL,NULL,'ESO 448- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127384,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127384,37.65,0.06,339,58151,70,NULL,NULL,'2MASX J15110220+0518558',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.7592083,5.31544,0.093,NULL,59329089050,927017016,14484640,17.2),(127385,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127385,37.73,0.46,351,58152,70,NULL,NULL,'2MASX J15110227+2903489',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0001,NULL,'18.48',0.18,'E',NULL,NULL,NULL,NULL,1,227.759625,29.06378,0.045,NULL,59904157872,936002466,14625038,18.48),(127386,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127386,37.91,0.46,382,58153,70,NULL,NULL,'2MASX J15110277+2227589',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'18.09',0.14,NULL,NULL,NULL,NULL,NULL,1,227.761625,22.46647,0.113,NULL,59422965638,928483838,14507559,18.09),(127387,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127387,36.4,0.46,191,58154,70,NULL,NULL,'2MASX J15110303+2024329',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.04',0.31,NULL,NULL,NULL,NULL,NULL,1,227.762833,20.40925,0.077,NULL,59537720465,930276882,14535576,17.04),(127388,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127388,37.69,0.46,346,58155,70,NULL,NULL,'2MASX J15110344+3619185',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.764458333,36.32178,0.005,NULL,60113822979,939278484,14676226,17.9),(127389,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127389,36.83,0.46,232,58156,70,NULL,NULL,'MCG +06-33-025',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000117,NULL,'15.4g',0.58,'E0',NULL,NULL,NULL,NULL,1,227.765833,37.02586,0.017,NULL,60101476841,939085575,14673212,15.4),(127390,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127390,37.63,0.21,335,58157,70,NULL,NULL,'SDSS J151104.62+032743.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.7692917,3.46217,0.097,NULL,56381047602,880953868,13764904,18.8),(127391,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127391,37.25,0.46,282,58158,70,NULL,NULL,'2MASX J15110516+1414103',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.771417,14.23619,0.101,NULL,59570385619,930787275,14543551,NULL),(127392,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127392,38.69,0.46,548,58159,70,NULL,NULL,'SDSS J151105.14+253449.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.771417,25.58031,0.177,NULL,59896462832,935882231,14623159,18.1),(127393,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127393,37.65,0.06,339,58160,70,NULL,NULL,'2MASX J15110529+0450088',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.772083,4.83583,0.097,NULL,59332085118,927063829,14485372,17.6),(127394,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127394,38.03,0.12,403,58161,70,NULL,NULL,'2MASX J15110565+0000502',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.7734583,0.01394,0.137,NULL,56372497898,880820279,13762816,17.1),(127395,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127395,36.14,0.11,169,58162,70,NULL,NULL,'2MASX J15110563+0430068',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000081,NULL,'16.2g',0.41,'NLAGN',NULL,NULL,NULL,NULL,1,227.7734583,4.50197,0.081,NULL,59331020859,927047200,14485112,16.2),(127396,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127396,37.65,0.06,339,58163,70,NULL,NULL,'SDSS J151105.83+053842.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.774333,5.64506,0.077,NULL,59328820285,927012816,14484575,18.5),(127397,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127397,37.62,0.46,334,58164,70,NULL,NULL,'2MASX J15110628+2507059',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.7760417,25.11819,0.165,NULL,59410527848,928289497,14504523,17.3),(127398,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127398,37.17,0.46,272,58165,70,NULL,NULL,'2MASX J15110672-0212267',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.7780417,-2.20753,0.221,NULL,45380972788,709077699,11079339,17.7),(127399,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127399,38.03,0.12,403,58166,70,NULL,NULL,'SDSS J151106.77-000807.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.77825,-0.13536,0.129,NULL,45367698981,708870296,11076098,18.8),(127400,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127400,36.78,0.46,227,58167,70,NULL,NULL,'2MASX J15110723+1032399',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,'PRED','17.20',0.42,NULL,NULL,NULL,NULL,NULL,1,227.780125,10.54453,0.077,NULL,59346765083,927293204,14488956,17.2),(127401,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127401,37.65,0.06,339,58168,70,NULL,NULL,'2MASX J15110743+0519018',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000167,NULL,'15.3g',0.52,NULL,NULL,NULL,NULL,NULL,1,227.7807917,5.31728,0.093,NULL,59329089355,927017021,14484640,15.3),(127402,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127402,37.65,0.06,339,58169,70,NULL,NULL,'2MASX J15110742+0532598',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.781083,5.54992,0.081,NULL,59328763394,927011928,14484561,16.9),(127403,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127403,37.65,0.06,339,58170,70,NULL,NULL,'2MASX J15110776+0519379',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.782333333,5.32714,0.093,NULL,59329089527,927017023,14484640,17.2),(127404,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127404,37.65,0.06,339,58171,70,NULL,NULL,'2MASX J15110775+0553049',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,227.782417,5.88461,0.069,NULL,59328949006,927014828,14484606,17.4),(127405,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127405,37.92,0.46,385,58172,70,NULL,NULL,'SDSS J151107.89+223454.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000109,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.782917,22.58181,0.109,NULL,59422990776,928484230,14507566,18.5),(127406,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127406,37.04,0.46,256,58173,70,NULL,NULL,'2MASX J15110870-0150407',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.7862083,-1.84481,0.217,NULL,45381553065,709086766,11079480,16.6),(127407,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127407,37.27,0.46,285,58174,70,NULL,NULL,'SDSS J151108.79+082557.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.786667,8.43258,0.041,NULL,59351895808,927373372,14490208,18.2),(127408,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127408,38.03,0.12,403,58175,70,NULL,NULL,'2MASX J15110939-0005507',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.7892083,-0.09733,0.129,NULL,45367698437,708870288,11076098,17.4),(127409,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127409,37.65,0.06,339,58176,70,NULL,NULL,'2MASX J15110976+0612039',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.79075,6.20119,0.065,NULL,59383580838,927868450,14497944,17.5),(127410,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127410,36.97,0.46,248,58177,70,NULL,NULL,'2MASX J15111002+3631526',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.79175,36.53133,0.005,NULL,60108574030,939196469,14674944,17),(127411,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127411,37.81,0.16,365,58178,70,NULL,NULL,'2MASX J15111008+1801279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.79225,18.0245,0.045,NULL,59583893127,930998330,14546848,18),(127412,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127412,37.65,0.06,339,58179,70,NULL,NULL,'2MASX J15111016+0549239',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'15.6I',0.25,NULL,'Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.7922917,5.82322,0.069,NULL,59328899228,927014050,14484594,15.6),(127413,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127413,38.03,0.12,403,58180,70,NULL,NULL,'2MASX J15111079-0005177',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00008,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.794833,-0.08828,0.137,NULL,45379224615,709050384,11078912,17.4),(127414,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127414,38.03,0.12,403,58181,70,NULL,NULL,'2MASX J15111126-0008447',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.79675,-0.14564,0.129,NULL,45379231135,709050486,11078913,17.8),(127415,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127415,37.65,0.06,339,58182,70,NULL,NULL,'2MASX J15111125+0447539',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.796917,4.79833,0.097,NULL,59332084403,927063818,14485372,17.4),(127416,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127416,37.65,0.06,339,58183,70,NULL,NULL,'2MASX J15111238+0454279',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,227.8015,4.90789,0.101,NULL,59332080201,927063753,14485371,16.9),(127417,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127417,36.21,0.13,174,58184,70,NULL,NULL,'SDSS J151112.57+014433.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.802417,1.74272,0.101,NULL,56387391678,881052994,13766453,17.4),(127418,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127418,37.9,0.46,380,58185,70,NULL,NULL,'SDSS J151112.64+274540.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.802666667,27.76133,0.065,NULL,59897650807,935900793,14623449,17.9),(127419,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127419,37.85,0.46,372,58186,70,NULL,NULL,'2MASX J15111269+1816279',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.802917,18.27439,0.061,NULL,59580480440,930945006,14546015,17.4),(127420,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127420,37.65,0.06,339,58187,70,NULL,NULL,'2MASX J15111291+0618179',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.803833,6.30497,0.061,NULL,59383714170,927870533,14497977,17.5),(127421,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127421,37.81,0.16,365,58188,70,NULL,NULL,'2MASX J15111423+1805379',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.809458333,18.09403,0.057,NULL,59580418880,930944045,14546000,18.3),(127422,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127422,37.63,0.21,335,58189,70,NULL,NULL,'2MASX J15111467+0329559',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000097,NULL,'16.1g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,227.8112917,3.49878,0.097,NULL,56381755050,880964922,13765076,16.1),(127423,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127423,37.47,0.27,311,58190,70,NULL,NULL,'SDSS J151115.02+190823.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.812625,19.13983,0.089,NULL,59534698907,930229670,14534838,17.8),(127424,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127424,34.53,0.52,80.7,58191,70,NULL,NULL,'2MASX J15111535-1141427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,227.813833,-11.69544,0.401,NULL,46482990401,726296725,11348386,16),(127425,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127425,36.52,0.09,202,58192,70,NULL,NULL,'GIN 418',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000137,NULL,'15.4g',0.54,'E','Group member',NULL,NULL,NULL,1,227.816708333,7.4895,0.057,NULL,59386864236,927919753,14498746,15.4),(127426,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127426,36.59,0.25,208,58192,74.4,NULL,NULL,'GIN 418',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127427,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127427,36.82,0.27,231,58192,70,NULL,NULL,'GIN 418',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127428,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127428,38.03,0.12,403,58193,70,NULL,NULL,'2MASX J15111605-0006297',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.816791667,-0.10831,0.137,NULL,45379238856,709050607,11078915,18.1),(127429,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127429,37.65,0.06,339,58194,70,NULL,NULL,'2MASX J15111627+0623539',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.817958333,6.39822,0.061,NULL,59383688086,927870126,14497970,16.3),(127430,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127430,37.65,0.06,339,58195,70,NULL,NULL,'SDSS J151116.65+060718.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.819375,6.12167,0.065,NULL,59328842677,927013166,14484580,18.2),(127431,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127431,37.52,0.46,319,58196,70,NULL,NULL,'2MASX J15111703+3943306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.821083333,39.72511,0.049,NULL,60103839691,939122495,14673788,17.4),(127432,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127432,35.13,0.51,106,58197,70,NULL,NULL,'2MASX J15111714-0952317',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,227.821333,-9.87572,0.349,NULL,46485543348,726336614,11349009,16.25),(127433,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127433,36.93,0.46,244,58198,70,NULL,NULL,'2MASX J15111722+0658229',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,227.821833333,6.97303,0.053,NULL,59383297449,927864022,14497875,16.6),(127434,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127434,37.65,0.06,339,58199,70,NULL,NULL,'2MASX J15111721+0626229',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.8219583,6.43967,0.061,NULL,59383690221,927870159,14497971,18.2),(127435,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127435,37.65,0.06,339,58200,70,NULL,NULL,'2MASX J15111734+0513199',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,227.8222917,5.22214,0.093,NULL,59329092919,927017076,14484641,16.7),(127436,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127436,37.65,0.06,339,58201,70,NULL,NULL,'2MASX J15111761+0622129',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.8235417,6.37036,0.061,NULL,59383685634,927870088,14497970,18),(127437,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127437,36.24,0.46,177,58202,70,NULL,NULL,'2MASX J15111773+1345040',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.823916667,13.75119,0.117,NULL,59570891258,930795175,14543674,17.2),(127438,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127438,36.6,0.46,209,58203,70,NULL,NULL,'2MASX J15111832+3037207',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.826417,30.62228,0.037,NULL,60085888419,938842006,14669406,17.1),(127439,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127439,37.79,0.46,362,58204,70,NULL,NULL,'2MASX J15111863+4433112',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000204,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,227.827833,44.55308,0.029,NULL,59984990881,937265482,14644773,16.7),(127440,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127440,37.65,0.06,339,58205,70,NULL,NULL,'2MASX J15111901+0514179',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000127,NULL,'16.66',0.55,NULL,NULL,NULL,NULL,NULL,1,227.829167,5.23833,0.093,NULL,59329091919,927017061,14484641,16.66),(127441,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127441,38.69,0.46,546,58206,70,NULL,NULL,'SDSS J151119.65+305205.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000133,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.831917,30.86825,0.021,NULL,60086948308,938858567,14669665,18.7),(127442,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127442,37.81,0.16,365,58207,70,NULL,NULL,'2MASX J15111969+1802399',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,227.832083,18.04422,0.057,NULL,59580416665,930944010,14546000,16.2),(127443,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127443,37.65,0.06,339,58208,70,NULL,NULL,'2MASX J15112035+0603569',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,227.834875,6.06569,0.065,NULL,59328855155,927013361,14484583,16.1),(127444,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127444,37.11,0.46,265,58209,70,NULL,NULL,'2MASX J15112062+0251239',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.8359583,2.85675,0.069,NULL,56385983571,881030993,13766109,17.2),(127445,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127445,37.65,0.06,339,58210,70,NULL,NULL,'SDSS J151121.39+061845.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.1I',0.11,NULL,NULL,NULL,NULL,NULL,1,227.839167,6.3125,0.061,NULL,59383714010,927870531,14497977,17.1),(127446,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127446,37.65,0.06,339,58211,70,NULL,NULL,'SDSS J151121.51+054120.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'16.7I',0.15,NULL,NULL,NULL,NULL,NULL,1,227.839625,5.68897,0.077,NULL,59328789928,927012342,14484567,16.7),(127447,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127447,36.52,0.09,202,58212,70,NULL,NULL,'2MASX J15112156+0722508',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00019,NULL,'15.7g',0.5,'E','Group member',NULL,NULL,NULL,1,227.839708333,7.38072,0.049,NULL,59386852041,927919563,14498743,15.7),(127448,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127448,37.9,0.46,381,58213,70,NULL,NULL,'2MASX J15112218+2447550',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000194,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.842583333,24.79875,0.145,NULL,59410588011,928290437,14504538,17.2),(127449,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127449,37.39,0.46,301,58214,70,NULL,NULL,'2MASX J15112252+2030376',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.843791667,20.51042,0.101,NULL,59535750216,930246097,14535095,17.7),(127450,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127450,36.52,0.09,202,58215,70,NULL,NULL,'2MASX J15112351+0716258',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'16',0.3,'S0','Group member',NULL,NULL,NULL,1,227.847875,7.27381,0.049,NULL,59386779780,927918434,14498725,16),(127451,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127451,37.81,0.16,365,58216,70,NULL,NULL,'2MASX J15112423+1747420',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,227.851208333,17.79497,0.033,NULL,59583572018,930993312,14546770,17.3),(127452,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127452,36.94,0.46,244,58217,70,NULL,NULL,'2MASX J15112458+0010449',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000085,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.8522917,0.17908,0.125,NULL,56386138336,881033411,13766147,16.6),(127453,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127453,38.2,0.19,436,58218,70,NULL,NULL,'2MASX J15112521+1723260',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.8549583,17.3905,0.049,NULL,59583744231,930996003,14546812,18.2),(127454,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127454,35.55,0.46,129,58219,70,NULL,NULL,'CGCG 077-033',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00012,NULL,'15.7',0.58,NULL,NULL,NULL,NULL,NULL,1,227.855041667,9.22453,0.049,NULL,59351648486,927369507,14490148,15.7),(127455,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127455,36.21,0.13,174,58220,70,NULL,NULL,'CGCG 021-034',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000104,NULL,'16.1g',0.44,'E0','Group member',NULL,NULL,NULL,1,227.855875,1.68564,0.101,NULL,56387414562,881053352,13766458,16.1),(127456,'GRB','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127456,45.41,1.1,3260,58221,69.7,NULL,'Fiducial','GRB 060714',2.71,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,227.8602083,-6.56619,0.217,NULL,46494219343,726472177,11351127,NULL),(127457,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127457,37.27,0.46,284,58222,70,NULL,NULL,'2MASX J15112647+3706516',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.86025,37.11442,0.017,NULL,60101465975,939085405,14673209,17.5),(127458,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127458,35.95,0.46,155,58223,70,NULL,NULL,'2MASX J15112677+0409539',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000082,NULL,'16.5g',0.3,'NLAGN',NULL,NULL,NULL,'Sy 2',1,227.8615,4.16483,0.077,NULL,59330951897,927046123,14485095,16.5),(127459,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127459,36.21,0.13,174,58224,70,NULL,NULL,'SDSS J151127.08+014607.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'17.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.862875,1.76875,0.101,NULL,56387423348,881053489,13766460,17.6),(127460,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127460,37.87,0.46,376,58225,70,NULL,NULL,'2MASX J15112713+1638540',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.862917,16.64839,0.053,NULL,59582641746,930978777,14546543,17.5),(127461,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127461,36.91,0.33,241,58226,70,NULL,NULL,'2MASX J15112726+2000446',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.863708333,20.01247,0.053,NULL,59537821910,930278467,14535601,17.6),(127462,'SNIa','2016-12-15 15:15:32','2016-12-16 11:20:45','1','SN 1999dg','R',127462,34.81,0.09,91.6,58227,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 09758',NULL,'2015Sci...347.1459K',2015,1,1.2,NULL,'G',0.000143,NULL,'14.19',1.2,'S0',NULL,NULL,NULL,NULL,1,227.866875,13.48356,0.101,NULL,59570804020,930793812,14543653,14.19),(127463,'SNIa','2016-12-15 15:15:32','2016-12-16 11:20:45','1','SN 1999dg','R',127463,34.86,0.09,93.8,58227,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 09758',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127464,'SNIa','2016-12-15 15:15:32','2016-12-16 11:20:45','1','SN 1999dg',NULL,127464,35,0.18,97.9,58227,70,NULL,'SALT 2','UGC 09758',0.022059,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127465,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127465,38.03,0.12,403,58228,70,NULL,NULL,'SDSS J151128.32-000358.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.868,-0.06625,0.137,NULL,45375031153,708984861,11077888,18.8),(127466,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127466,36.52,0.09,202,58229,70,NULL,NULL,'2MASX J15112862+0715438',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.5g',0.16,'E','Group member',NULL,NULL,NULL,1,227.8692083,7.26225,0.049,NULL,59386788721,927918573,14498727,17.5),(127467,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127467,37.84,0.46,370,58230,70,NULL,NULL,'2MASX J15112861+1319120',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.869333,13.31989,0.125,NULL,59570787327,930793551,14543649,17.9),(127468,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127468,32.77,0.8,35.9,58231,75,NULL,NULL,'IC 4522',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.00001,NULL,'13.7b',0.9,'Sb',NULL,NULL,NULL,NULL,1,227.8705,-75.85997,0.393,NULL,44238809594,691231399,10800490,13.7),(127469,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127469,32.91,0.46,38.1,58231,NULL,NULL,'J','IC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127470,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127470,32.96,0.4,39.1,58231,NULL,NULL,'mean','IC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127471,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127471,32.98,0.45,39.4,58231,NULL,NULL,'K','IC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127472,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127472,33,0.47,39.8,58231,NULL,NULL,'H','IC 4522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127473,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127473,37.81,0.16,365,58232,70,NULL,NULL,'2MASX J15112898+1806347',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.870708333,18.10961,0.057,NULL,59580431122,930944236,14546003,17.1),(127474,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127474,36.53,0.2,202,58233,74.4,NULL,NULL,'2MASX J15112959+1219370',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00063,NULL,'16.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.8732083,12.327,0.109,NULL,59569177646,930768400,14543256,16),(127475,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127475,38.2,0.19,436,58234,70,NULL,NULL,'2MASX J15113002+1722360',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.87525,17.37678,0.049,NULL,59583715172,930995549,14546805,17.4),(127476,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127476,38.03,0.12,403,58235,70,NULL,NULL,'2MASX J15113028-0017417',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000072,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.8762917,-0.29492,0.129,NULL,45379275506,709051179,11078924,18.3),(127477,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127477,38.03,0.12,403,58236,70,NULL,NULL,'SDSS J151130.54-000614.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000082,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,227.87725,-0.10406,0.137,NULL,45379236911,709050576,11078915,18.7),(127478,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127478,37.65,0.06,339,58237,70,NULL,NULL,'2MASX J15113128+0615468',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,227.8802083,6.26297,0.061,NULL,59383590177,927868596,14497946,17.4),(127479,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127479,36.52,0.09,202,58238,70,NULL,NULL,'CGCG 049-033',NULL,'2015arXiv151105856S',2015,1,1.9,NULL,'G',0.00012,NULL,'13.44',1,'S0','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,227.88075,7.25197,0.049,NULL,59386788593,927918571,14498727,13.44),(127480,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127480,36.58,0.25,207,58238,74.4,NULL,NULL,'CGCG 049-033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127481,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127481,36.82,0.27,231,58238,70,NULL,NULL,'CGCG 049-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127482,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127482,37.65,0.06,339,58239,70,NULL,NULL,'2MASX J15113148+0622258',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,227.8810417,6.37383,0.061,NULL,59383688764,927870136,14497970,18.1),(127483,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127483,35.96,0.25,156,58240,74.4,NULL,NULL,'CGCG 049-030',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00008,NULL,'13.93',0.8,'S;BrClG','Group member',NULL,NULL,NULL,1,227.881416667,4.5175,0.081,NULL,59330819025,927044047,14485063,13.93),(127484,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127484,36.14,0.11,169,58240,70,NULL,NULL,'CGCG 049-030',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127485,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127485,36.18,0.26,172,58240,70,NULL,NULL,'CGCG 049-030',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127486,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127486,37.65,0.06,339,58241,70,NULL,NULL,'SDSS J151131.49+055115.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.88125,5.85417,0.073,NULL,59328895983,927013999,14484593,18.4),(127487,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127487,36.21,0.13,174,58242,70,NULL,NULL,'CGCG 021-037 NED01',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000102,NULL,'15.0g',0.66,'BrClG',NULL,NULL,NULL,NULL,1,227.882375,1.76389,0.101,NULL,56387435064,881053672,13766463,15),(127488,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127488,37.81,0.16,365,58243,70,NULL,NULL,'SDSS J151131.90+180618.3',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.3g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.882917,18.10511,0.057,NULL,59580431189,930944237,14546003,16.3),(127489,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127489,37.65,0.06,339,58244,70,NULL,NULL,'2MASX J15113252+0605229',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.885333333,6.08986,0.065,NULL,59328849201,927013268,14484582,17.8),(127490,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127490,36.21,0.13,174,58245,70,NULL,NULL,'2MASX J15113284+0146549',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000073,NULL,'15.8g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,227.886875,1.78206,0.101,NULL,56387433954,881053655,13766463,15.8),(127491,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127491,37.81,0.16,365,58246,70,NULL,NULL,'2MASX J15113290+1805067',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.88725,18.08525,0.057,NULL,59580417113,930944017,14546000,17.8),(127492,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127492,35.75,0.46,141,58247,70,NULL,NULL,'CGCG 077-036',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000087,NULL,'15.3',0.7,NULL,NULL,NULL,NULL,NULL,1,227.8895,9.47339,0.081,NULL,59353804505,927403195,14490674,15.3),(127493,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127493,37.94,0.46,387,58248,70,NULL,NULL,'SDSS J151133.68+242102.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.890333,24.35078,0.133,NULL,59411336867,928302138,14504720,18.2),(127494,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127494,37.87,0.46,376,58249,70,NULL,NULL,'2MASX J15113399+1847377',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.891667,18.79367,0.077,NULL,59580498801,930945293,14546020,17.9),(127495,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127495,37.81,0.16,365,58250,70,NULL,NULL,'SDSS J151134.08+180758.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.8920417,18.13297,0.057,NULL,59580422883,930944107,14546001,18.1),(127496,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127496,36.91,0.33,241,58251,70,NULL,NULL,'2MASX J15113421+2004177',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,227.892667,20.07158,0.053,NULL,59537878609,930279353,14535614,NULL),(127497,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127497,37.65,0.06,339,58252,70,NULL,NULL,'2MASX J15113437+0612038',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,227.893125,6.20111,0.061,NULL,59383591783,927868621,14497947,16.6),(127498,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127498,37.47,0.27,311,58253,70,NULL,NULL,'2MASX J15113489+1914297',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.895417,19.2415,0.093,NULL,59534648047,930228875,14534826,18.1),(127499,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127499,36.14,0.11,169,58254,70,NULL,NULL,'2MASX J15113491+0425349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.895583333,4.42639,0.081,NULL,59330839169,927044362,14485068,17.4),(127500,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127500,37.65,0.06,339,58255,70,NULL,NULL,'2MASX J15113530+0621018',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.897083,6.35056,0.061,NULL,59383567037,927868234,14497941,18),(127501,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127501,37.65,0.06,339,58256,70,NULL,NULL,'2MASX J15113537+0615098',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.89725,6.25269,0.061,NULL,59383589308,927868582,14497946,17.8),(127502,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127502,37.47,0.27,311,58257,70,NULL,NULL,'IC 1103',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.00016,NULL,'16.73',0.56,'BrClG',NULL,NULL,NULL,NULL,1,227.8994583,19.20778,0.089,NULL,59534648193,930228878,14534826,16.73),(127503,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127503,38.03,0.12,403,58258,70,NULL,NULL,'2MASX J15113607-0007167',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.9002083,-0.12131,0.137,NULL,45375035791,708984934,11077889,18.2),(127504,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127504,37.77,0.46,359,58259,70,NULL,NULL,'2MASX J15113613+0748388',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.9005417,7.81097,0.049,NULL,59384572402,927883943,14498186,17.5),(127505,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127505,35.95,0.25,155,58260,74.4,NULL,NULL,'CGCG 049-034',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000073,NULL,'15.6g',0.46,'E','Group member',NULL,NULL,NULL,1,227.904125,4.46725,0.081,NULL,59330841531,927044398,14485068,15.6),(127506,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127506,36.14,0.11,169,58260,70,NULL,NULL,'CGCG 049-034',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127507,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127507,36.18,0.26,172,58260,70,NULL,NULL,'CGCG 049-034',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127508,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127508,37.77,0.46,358,58261,70,NULL,NULL,'2MASX J15113731+5634467',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,227.9057083,56.57947,0.009,NULL,57714860223,901794690,14090542,17.4),(127509,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127509,36.07,0.8,164,58262,75,NULL,'CF, r','UGC 09757',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00003,NULL,'14.61',0.6,'Sbc',NULL,NULL,NULL,NULL,1,227.905625,5.39758,0.081,NULL,59329223887,927019123,14484673,14.61),(127510,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127510,35.72,0.38,139,58262,75,NULL,'CF, r, raw','UGC 09757',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127511,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127511,35.97,0.38,156,58262,75,NULL,'CF, r, inv','UGC 09757',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127512,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127512,35.99,0.38,158,58262,75,NULL,'CF, r, cor','UGC 09757',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127513,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127513,36.29,0.4,181,58262,NULL,NULL,'mean','UGC 09757',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127514,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127514,36.29,0.47,181,58262,NULL,NULL,'H','UGC 09757',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127515,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127515,36.41,0.46,191,58262,NULL,NULL,'J','UGC 09757',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127516,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127516,36.41,0.45,192,58262,NULL,NULL,'K','UGC 09757',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127517,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127517,37.84,0.27,369,58263,70,NULL,NULL,'SDSS J151137.59+200847.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.906625,20.14644,0.049,NULL,59537882323,930279411,14535615,18.5),(127518,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127518,38.15,0.46,426,58264,70,NULL,NULL,'2MASX J15113908+1809367',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.912875,18.16033,0.057,NULL,59580424140,930944127,14546001,17.9),(127519,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127519,38.03,0.12,403,58265,70,NULL,NULL,'2MASX J15114001-0008467',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.91675,-0.14631,0.137,NULL,45375033870,708984904,11077889,17.9),(127520,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127520,37.65,0.46,339,58266,70,NULL,NULL,'2MASX J15114054+0343419',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.918917,3.72819,0.101,NULL,56381778065,880965282,13765082,17.7),(127521,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127521,32.95,0.8,38.9,58267,75,NULL,'A82, H','NGC 5894',NULL,'1997ApJS..109..333W',1997,1,3.57,NULL,'G',0.000013,NULL,'13.1g',0.59,'SBdm?','Field galaxy',NULL,NULL,NULL,1,227.92075,59.80894,0.013,NULL,57774782955,902730983,14105171,13.1),(127522,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127522,32.57,0.4,32.6,58267,75,NULL,NULL,'NGC 5894',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127523,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127523,32.72,0.49,34.9,58267,75,NULL,'IR','NGC 5894',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127524,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127524,32.92,0.4,38.3,58267,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5894',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127525,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127525,32.95,0.36,38.9,58267,NULL,NULL,NULL,'NGC 5894',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127526,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127526,32.95,0.4,38.9,58267,75,NULL,'B','NGC 5894',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127527,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127527,32.98,0.2,39.5,58267,74.4,NULL,NULL,'NGC 5894',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127528,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127528,33.1,0.43,41.7,58267,75,NULL,'3.6 micron, color corrected','NGC 5894',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127529,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127529,33.2,0.47,43.7,58267,75,NULL,'A82, H, raw','NGC 5894',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127530,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127530,33.23,0.43,44.3,58267,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5894',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127531,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127531,33.36,0.47,46.9,58267,75,NULL,'A82, H, cor','NGC 5894',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127532,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127532,33.38,0.47,47.5,58267,75,NULL,'A82, H, inv','NGC 5894',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127533,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127533,32.8,0.8,36.3,58268,75,NULL,NULL,'UGC 09762',NULL,'1988NBGC.C....0000T',1988,1,1,'Multiple SDSS entries describe this source.','G',0.00002,NULL,'17.',0.9,'Sm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.922083,32.64306,0.045,NULL,60083720960,938808140,14668877,17),(127534,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127534,35.96,0.25,156,58269,74.4,NULL,NULL,'CGCG 049-037',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000073,NULL,'13.93',0.72,'cD','Group member',NULL,NULL,NULL,1,227.923,4.49128,0.085,NULL,59330851897,927044560,14485071,13.93),(127535,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127535,36.18,0.26,172,58269,70,NULL,NULL,'CGCG 049-037',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127536,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127536,37.84,0.46,369,58270,70,NULL,NULL,'2MASX J15114160+4030388',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.923333,40.51092,0.025,NULL,59973888471,937092007,14642062,18),(127537,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127537,37.65,0.06,339,58271,70,NULL,NULL,'2MASX J15114308+0617528',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,227.9295,6.29794,0.061,NULL,59383598500,927868726,14497948,17.1),(127538,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127538,37.65,0.06,339,58272,70,NULL,NULL,'2MASX J15114356+0610448',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,227.9315,6.17925,0.061,NULL,59383584434,927868506,14497945,15.8),(127539,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127539,37.9,0.46,380,58273,70,NULL,NULL,'2MASX J15114398+1145538',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.933416667,11.76492,0.117,NULL,59348128070,927314501,14489289,17.6),(127540,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127540,37.68,0.46,344,58274,70,NULL,NULL,'SDSS J151144.60+334948.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,227.935833,33.83022,0.013,NULL,60116759865,939324372,14676943,17.8),(127541,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127541,38.21,0.46,439,58275,70,NULL,NULL,'2MASX J15114526+0109309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000095,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,227.938625,1.15844,0.109,NULL,56386928838,881045763,13766340,17.5),(127542,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127542,38.2,0.19,436,58276,70,NULL,NULL,'SDSS J151145.86+173223.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.941125,17.53981,0.041,NULL,59583732233,930995816,14546809,18),(127543,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127543,37.75,0.46,355,58277,70,NULL,NULL,'SDSS J151146.15+065458.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.9422917,6.91631,0.049,NULL,59383288468,927863882,14497873,17.9),(127544,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127544,38.53,0.46,507,58278,70,NULL,NULL,'2MASX J15114614+0026499',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.942333,0.44725,0.113,NULL,56386373271,881037082,13766204,18),(127545,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127545,37.71,0.33,349,58279,70,NULL,NULL,'2MASX J15114722+0421509',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000095,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,227.946833,4.36411,0.081,NULL,59330832939,927044264,14485066,17.5),(127546,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127546,37.49,0.46,315,58280,70,NULL,NULL,'2MASX J15114852-0157017',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,227.952125,-1.95042,0.217,NULL,45381436064,709084938,11079452,17.9),(127547,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127547,32.82,NULL,36.6,58281,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 581- G 023',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000017,NULL,'16.88',0.11,'SB(s)d pec sp',NULL,NULL,NULL,NULL,1,227.9574583,-17.94392,0.377,NULL,46699723317,729683176,11401299,16.88),(127548,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127548,32.84,NULL,36.9,58281,NULL,NULL,'Dipole + Quadrupole','ESO 581- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127549,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127549,32.85,NULL,37.2,58281,NULL,NULL,'Dipole','ESO 581- G 023',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127550,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127550,33.22,0.65,44.1,58281,NULL,NULL,'Malmquist cor.','ESO 581- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127551,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127551,33.52,0.57,50.5,58281,NULL,NULL,NULL,'ESO 581- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127552,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127552,33.56,0.2,51.5,58281,74.4,NULL,NULL,'ESO 581- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127553,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127553,37.21,0.46,277,58282,70,NULL,NULL,'SDSS J151150.66+343724.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,227.961125,34.62347,0.033,NULL,60114473913,939288654,14676385,18),(127554,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127554,38.13,0.46,423,58283,70,NULL,NULL,'SDSS J151151.39+172918.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.964125,17.48858,0.041,NULL,59583738155,930995908,14546811,17.5),(127555,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127555,38.03,0.12,403,58284,70,NULL,NULL,'SDSS J151151.51-000634.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,227.964666667,-0.10944,0.137,NULL,45375034514,708984914,11077889,18.3),(127556,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127556,36.52,0.09,202,58285,70,NULL,NULL,'2MASX J15115182+0742450',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'16.0g',0.32,'S0','Group member',NULL,NULL,NULL,1,227.966,7.71242,0.053,NULL,59384566270,927883847,14498185,16),(127557,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127557,37.65,0.06,339,58286,70,NULL,NULL,'2MASX J15115230+0601469',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,227.967791667,6.02986,0.065,NULL,59328886382,927013849,14484591,17),(127558,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127558,38.2,0.19,436,58287,70,NULL,NULL,'2MASX J15115295+1732051',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.970583333,17.53483,0.041,NULL,59583741316,930995958,14546811,18.2),(127559,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127559,32.81,0.8,36.5,58288,75,NULL,'MAT, I','NGC 5833',NULL,'1997ApJS..109..333W',1997,1,3.1,'Confused and extended HIPASS source','G',0.000017,NULL,'12.82',2.3,'SAB(r)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,227.9735417,-72.85942,0.421,NULL,44997254941,703082108,10985657,12.82),(127560,'Sosies','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127560,32.62,0.15,33.4,58288,NULL,NULL,NULL,'NGC 5833',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127561,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127561,32.9,0.8,38,58288,75,NULL,NULL,'NGC 5833',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127562,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127562,32.4,0.43,30.2,58288,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5833',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127563,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127563,32.46,0.43,31.1,58288,75,NULL,'3.6 micron, color corrected','NGC 5833',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127564,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127564,32.61,0.47,33.3,58288,NULL,NULL,'H','NGC 5833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127565,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127565,32.62,0.45,33.4,58288,NULL,NULL,'K','NGC 5833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127566,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127566,32.62,0.46,33.5,58288,NULL,NULL,'J','NGC 5833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127567,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127567,32.78,0.43,35.9,58288,75,NULL,'MAT, I, raw','NGC 5833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127568,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127568,32.78,0.2,36,58288,74.4,NULL,NULL,'NGC 5833',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127569,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127569,32.88,0.32,37.7,58288,85,NULL,'I, raw','NGC 5833',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127570,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127570,32.96,0.32,39,58288,85,NULL,'I, inv','NGC 5833',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127571,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127571,32.99,0.43,39.6,58288,75,NULL,'MAT, I, cor','NGC 5833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127572,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127572,32.99,0.4,39.7,58288,NULL,NULL,'mean','NGC 5833',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127573,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127573,33.08,0.43,41.3,58288,75,NULL,'MAT, I, inv','NGC 5833',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127574,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127574,33.18,0.36,43.3,58288,NULL,NULL,'Malmquist cor.','NGC 5833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127575,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127575,33.35,0.33,46.7,58288,NULL,NULL,NULL,'NGC 5833',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127576,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127576,37.22,0.46,279,58289,70,NULL,NULL,'2MASX J15115467+2706380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.9777083,27.11061,0.089,NULL,59897430413,935897350,14623396,17.9),(127577,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127577,37.01,0.46,253,58290,70,NULL,NULL,'2MASX J15115468+3036281',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,227.978,30.60792,0.037,NULL,60085879787,938841871,14669404,17.8),(127578,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127578,37.84,0.27,369,58291,70,NULL,NULL,'SDSS J151155.17+200528.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.979917,20.09131,0.049,NULL,59537847213,930278862,14535607,18.2),(127579,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127579,37.46,0.46,311,58292,70,NULL,NULL,'2MASX J15115519+0538171',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.9g',0.44,NULL,NULL,NULL,NULL,NULL,1,227.98,5.63817,0.077,NULL,59329264161,927019752,14484683,15.9),(127580,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127580,37.51,0.46,318,58293,70,NULL,NULL,'SDSS J151157.11+233959.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,227.988,23.66658,0.137,NULL,59411303165,928301611,14504712,17.8),(127581,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127581,37.72,0.27,351,58294,70,NULL,NULL,'2MASX J15115759+0407431',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.989833333,4.12853,0.077,NULL,56381508527,880961070,13765016,17.6),(127582,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127582,37.72,0.27,351,58295,70,NULL,NULL,'2MASX J15115833+0410531',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.992958333,4.18125,0.077,NULL,56381637054,880963078,13765048,17.4),(127583,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127583,36.54,0.66,203,58296,70,NULL,NULL,'2MASX J15115838-0711276',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,227.99325,-7.19106,0.237,NULL,46494545158,726477268,11351207,14.5),(127584,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127584,37.71,0.33,349,58297,70,NULL,NULL,'2MASX J15115872+0415301',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000086,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,227.9947917,4.25833,0.081,NULL,59330825887,927044154,14485064,16.5),(127585,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127585,37.14,0.46,268,58298,70,NULL,NULL,'2MASX J15115954+0358361',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000066,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,227.998125,3.97656,0.053,NULL,56381493547,880960836,13765013,17.5),(127586,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127586,37.27,0.46,284,58299,70,NULL,NULL,'2MASX J15120015+2150580',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.92',0.17,NULL,NULL,NULL,NULL,NULL,1,228.00075,21.84956,0.153,NULL,59414638126,928353720,14505526,17.92),(127587,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127587,36.45,0.46,195,58300,70,NULL,NULL,'MCG +06-33-027',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000191,NULL,'15.1g',0.62,'E',NULL,NULL,NULL,NULL,1,228.00075,36.65197,0.033,NULL,60108625327,939197270,14674957,15.1),(127588,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127588,37.72,0.27,351,58301,70,NULL,NULL,'2MASX J15120034+0403131',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.0015,4.05358,0.077,NULL,56381517533,880961211,13765018,17.1),(127589,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127589,37.65,0.06,339,58302,70,NULL,NULL,'2MASX J15120047+0603381',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.001917,6.06064,0.065,NULL,59328884104,927013814,14484590,17.2),(127590,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127590,36.52,0.09,202,58303,70,NULL,NULL,'2MASX J15120111+0723221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'16.9g',0.21,'E','Group member',NULL,NULL,NULL,1,228.004583,7.38956,0.057,NULL,59386673671,927916776,14498699,16.9),(127591,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127591,34.69,0.2,86.7,58304,74.4,NULL,NULL,'UGC 09763',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00002,NULL,'15.16',0.4,'S?',NULL,NULL,NULL,NULL,1,228.009083,21.29836,0.121,NULL,59415345011,928364765,14505699,15.16),(127592,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127592,34.67,0.49,85.7,58305,75,NULL,'IR','UGC 09763',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00002,NULL,'15.16',0.4,'S?',NULL,NULL,NULL,NULL,1,228.009083,21.29836,0.121,NULL,59415345011,928364765,14505699,15.16),(127593,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127593,31.25,NULL,17.8,58306,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09760',NULL,'2010Ap&SS.325..163P',2010,1,3.25,'Star superposed.','G',0.000006,NULL,'14.67',0.22,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,228.010167,1.69875,0.101,NULL,56387292484,881051445,13766428,14.67),(127594,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127594,31.27,NULL,18,58306,NULL,NULL,'Dipole + Quadrupole','UGC 09760',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127595,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127595,31.28,NULL,18,58306,NULL,NULL,'Dipole','UGC 09760',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127596,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127596,31.37,NULL,18.8,58306,NULL,NULL,NULL,'UGC 09760',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127597,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127597,31.75,NULL,22.4,58306,72,NULL,NULL,'UGC 09760',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127598,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127598,32.11,0.2,26.4,58306,74.4,NULL,NULL,'UGC 09760',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127599,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127599,32.17,0.43,27.1,58306,75,NULL,'3.6 micron, color corrected','UGC 09760',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127600,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127600,32.21,0.43,27.7,58306,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09760',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127601,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127601,32.27,0.4,28.5,58306,75,NULL,'B','UGC 09760',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127602,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127602,32.34,0.4,29.4,58306,NULL,NULL,NULL,'UGC 09760',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127603,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127603,32.42,0.57,30.5,58306,NULL,NULL,'Malmquist cor.','UGC 09760',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127604,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127604,32.44,0.57,30.8,58306,NULL,NULL,NULL,'UGC 09760',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127605,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127605,36.34,0.49,185,58307,NULL,NULL,'Malmquist cor.','SDSS J151202.58+065553.9',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.00003,NULL,'16.01',NULL,'Sb','Group member',NULL,NULL,NULL,1,228.010791667,6.93164,0.049,NULL,59383341453,927864710,14497886,16.01),(127606,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127606,36.75,0.4,224,58307,NULL,NULL,NULL,'SDSS J151202.58+065553.9',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127607,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127607,36.8,0.2,229,58307,74.4,NULL,NULL,'SDSS J151202.58+065553.9',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127608,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127608,37.8,0.33,363,58308,70,NULL,NULL,'2MASX J15120335+1255322',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.014125,12.92569,0.097,NULL,59569367144,930771361,14543302,17.6),(127609,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127609,37.65,0.06,339,58309,70,NULL,NULL,'2MASX J15120409+0551321',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.016958333,5.85911,0.073,NULL,59328871211,927013612,14484587,16.8),(127610,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127610,35.95,0.46,155,58310,70,NULL,NULL,'CGCG 165-028',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,228.017166667,28.42058,0.037,NULL,59908401633,936068775,14626074,15.7),(127611,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127611,37.65,0.06,339,58311,70,NULL,NULL,'2MASX J15120449+0602491',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.01875,6.04694,0.065,NULL,59328883690,927013807,14484590,17.7),(127612,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127612,38.01,0.33,400,58312,70,NULL,NULL,'SDSS J151204.51+030713.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.018833,3.12053,0.093,NULL,56381282088,880957532,13764961,18.4),(127613,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127613,33.84,0.4,58.5,58313,NULL,NULL,'mean','IC 1110',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000047,NULL,'14.90',0.4,'Sa','Isolated galaxy',NULL,NULL,NULL,1,228.021125,67.36258,0.037,NULL,57980259388,905941552,14155336,14.9),(127614,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127614,34.16,0.45,67.9,58313,NULL,NULL,'K','IC 1110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127615,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127615,34.17,0.47,68.1,58313,NULL,NULL,'H','IC 1110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127616,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127616,34.27,0.46,71.4,58313,NULL,NULL,'J','IC 1110',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127617,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127617,37.69,0.27,345,58314,70,NULL,NULL,'2MASX J15120558+3050232',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000166,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,228.023208333,30.83986,0.021,NULL,60086973657,938858963,14669671,16),(127618,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127618,37.79,0.46,361,58315,70,NULL,NULL,'SDSS J151206.33+085522.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.026417,8.92289,0.049,NULL,59351663986,927369749,14490152,18.5),(127619,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127619,31.24,0.4,17.7,58316,75,NULL,'B','NGC 5866B',NULL,'1988NBGC.C....0000T',1988,1,1.46,NULL,'G',0.000013,NULL,'14.7g',0.82,'SAB(rs)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,228.030125,55.78508,0.013,NULL,57583004196,899734440,14058350,14.7),(127620,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127620,37.8,0.33,363,58317,70,NULL,NULL,'2MASX J15120745+1253482',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.0310417,12.89678,0.097,NULL,59569370074,930771407,14543303,NULL),(127621,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127621,36.81,0.62,230,58318,70,NULL,NULL,'2MASX J15120791-7022508',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.033125,-70.38081,0.209,NULL,45045236458,703831819,10997372,15.5),(127622,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127622,37.32,0.46,291,58319,70,NULL,NULL,'2MASX J15120882+1912251',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.0367083,19.20686,0.093,NULL,59534641221,930228769,14534824,16.7),(127623,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127623,36.21,0.13,174,58320,70,NULL,NULL,'2MASX J15120987+0155211',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000085,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.041208333,1.92258,0.081,NULL,56387340492,881052195,13766440,16.3),(127624,'GRB','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127624,42.68,NULL,3440,58321,71,NULL,NULL,'GRB 080906',NULL,'2011A&A...526A.153K',2011,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,228.045167,-80.51808,0.441,NULL,44278821668,691856588,10810259,NULL),(127625,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127625,38.01,0.46,400,58322,70,NULL,NULL,'2MASX J15121107+0526201',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.046125,5.43883,0.077,NULL,59329243247,927019425,14484678,NULL),(127626,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127626,36.13,0.47,168,58323,NULL,NULL,'Malmquist cor.','2MFGC 12301',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000027,NULL,'16.5g',0.15,'Sb','Group member',NULL,NULL,NULL,1,228.046875,7.56431,0.053,NULL,59386687624,927916994,14498703,16.5),(127627,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127627,36.39,0.42,189,58323,NULL,NULL,NULL,'2MFGC 12301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127628,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,NULL,127628,36.43,0.2,193,58323,74.4,NULL,NULL,'2MFGC 12301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127629,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127629,36.59,0.49,208,58323,75,NULL,'IR','2MFGC 12301',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127630,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127630,36.21,0.13,174,58324,70,NULL,NULL,'CGCG 021-043',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000077,NULL,'16.0g',0.37,'S0','Group member',NULL,NULL,NULL,1,228.047875,2.01019,0.081,NULL,56387343629,881052244,13766441,16),(127631,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127631,36.52,0.09,202,58325,70,NULL,NULL,'2MASX J15121153+0714141',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000097,NULL,'16.6g',0.24,'S0/S','Group member',NULL,NULL,NULL,1,228.048083,7.23725,0.049,NULL,59383449301,927866395,14497912,16.6),(127632,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127632,38.2,0.19,436,58326,70,NULL,NULL,'2MASX J15121225+1733091',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,228.050958333,17.55256,0.041,NULL,59583729649,930995775,14546808,16.7),(127633,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127633,38.63,0.46,532,58327,70,NULL,NULL,'2MASX J15121258+4554114',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.052541667,45.90317,0.033,NULL,59986816916,937294014,14645218,17.9),(127634,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127634,37.84,0.27,369,58328,70,NULL,NULL,'2MASX J15121328+2010401',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.0555,20.17792,0.049,NULL,59537662380,930275974,14535562,NULL),(127635,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127635,37.63,0.33,335,58329,70,NULL,NULL,'2MASX J15121439+2749102',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'18.02',0.17,NULL,NULL,NULL,NULL,NULL,1,228.06,27.81961,0.081,NULL,59897360829,935896262,14623379,18.02),(127636,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127636,37.23,0.46,279,58330,70,NULL,NULL,'2MASX J15121488+6046124',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.061916667,60.77017,0.013,NULL,57773908199,902717315,14104958,17.1),(127637,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127637,38.28,0.46,452,58331,70,NULL,NULL,'2MASX J15121511+4758495',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.063041667,47.98061,0.041,NULL,59940239372,936566240,14633847,18.4),(127638,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127638,38.06,0.46,409,58332,70,NULL,NULL,'SDSS J151215.44+100945.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.064333,10.1625,0.081,NULL,59354238143,927409970,14490780,18.2),(127639,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127639,37.21,0.46,277,58333,70,NULL,NULL,'2MASX J15121549+0502511',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.064375,5.0475,0.097,NULL,59329169545,927018274,14484660,17.2),(127640,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127640,37.63,0.33,335,58334,70,NULL,NULL,'2MASX J15121575+2750052',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.69',0.16,NULL,NULL,NULL,NULL,NULL,1,228.065667,27.83486,0.081,NULL,59897360668,935896260,14623379,18.69),(127641,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127641,37.72,0.46,350,58335,70,NULL,NULL,'SDSS J151216.54+390526.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.0689583,39.09061,0.057,NULL,60104288515,939129508,14673898,17.9),(127642,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127642,35.67,0.33,136,58336,70,NULL,NULL,'2MASX J15121720+4025507',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000179,NULL,'15.5g',0.58,'E0',NULL,NULL,NULL,NULL,1,228.071583,40.43072,0.041,NULL,59971741972,937058468,14641538,15.5),(127643,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127643,37.75,0.46,355,58337,70,NULL,NULL,'2MASX J15121756+2939262',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'17.76',0.19,'E',NULL,NULL,NULL,NULL,1,228.0732917,29.65719,0.033,NULL,59904237112,936003704,14625057,17.76),(127644,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127644,36.21,0.13,174,58338,70,NULL,NULL,'CGCG 021-045',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000103,NULL,'15.7g',0.49,'S0','Group member',NULL,NULL,NULL,1,228.074917,2.03253,0.081,NULL,56387345190,881052268,13766441,15.7),(127645,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127645,38.45,0.46,490,58339,70,NULL,NULL,'2MASX J15121820+2959199',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.075875,29.98903,0.029,NULL,60086420505,938850320,14669536,18),(127646,'FP','2016-12-15 15:15:32','2016-12-16 11:20:45','1',NULL,'R',127646,37.34,0.46,294,58340,70,NULL,NULL,'2MASX J15121865+2033362',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.51',0.14,NULL,NULL,NULL,NULL,NULL,1,228.07775,20.55997,0.101,NULL,59535576636,930243384,14535052,18.51),(127647,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127647,37.65,0.06,339,58341,70,NULL,NULL,'SDSS J151218.76+054856.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.0782083,5.81578,0.073,NULL,59329378183,927021534,14484711,17.8),(127648,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127648,36.42,0.46,192,58342,70,NULL,NULL,'2MASX J15121970+1042570',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.0822083,10.71594,0.081,NULL,59346523927,927289436,14488897,16.7),(127649,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127649,37.71,0.46,348,58343,70,NULL,NULL,'2MASX J15121990+0731202',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,'Group member',NULL,NULL,NULL,1,228.082875,7.52228,0.053,NULL,59386683079,927916923,14498701,17.7),(127650,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127650,36.43,0.46,193,58344,70,NULL,NULL,'2MASX J15122049+0904532',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.085333,9.08139,0.049,NULL,59351684740,927370074,14490157,16.5),(127651,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127651,36.21,0.13,174,58345,70,NULL,NULL,'2MASX J15122061+0147021',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00009,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.0859583,1.78403,0.101,NULL,56387272673,881051135,13766423,16.4),(127652,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127652,37.71,0.33,348,58346,70,NULL,NULL,'SDSS J151221.71+182834.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.0905,18.47617,0.073,NULL,59580517311,930945582,14546024,18.2),(127653,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127653,35.96,0.46,156,58347,70,NULL,NULL,'2MASX J15122206+0323481',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000133,NULL,'15.3g',0.5,'BrClG',NULL,NULL,NULL,NULL,1,228.091917,3.39681,0.101,NULL,56381820294,880965942,13765092,15.3),(127654,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127654,36.65,0.46,214,58348,70,NULL,NULL,'2MASX J15122240+0313021',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.093333,3.21719,0.097,NULL,56381340240,880958441,13764975,17.2),(127655,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127655,37.41,0.46,304,58349,70,NULL,NULL,'2MASX J15122259+2006462',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.094167,20.11286,0.101,NULL,59537663031,930275984,14535562,NULL),(127656,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127656,38.03,0.12,403,58350,70,NULL,NULL,'2MASX J15122434-0028403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.1015,-0.47806,0.129,NULL,45379372324,709052692,11078948,17.7),(127657,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127657,38.21,0.46,439,58351,70,NULL,NULL,'2MASXi J1512246+384600',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.1025417,38.76681,0.053,NULL,60103493281,939117082,14673704,17.8),(127658,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127658,36.2,0.19,174,58352,70,NULL,NULL,'2MASX J15122500+0431051',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000108,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,228.104167,4.51806,0.085,NULL,59330805379,927043834,14485059,16.4),(127659,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127659,38.35,0.46,467,58353,70,NULL,NULL,'SDSS J151225.32+301356.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.1055417,30.23233,0.033,NULL,60085958689,938843104,14669423,18.5),(127660,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127660,35.67,0.33,136,58354,70,NULL,NULL,'CGCG 221-035',NULL,'2015arXiv151105856S',2015,1,0.82,'UZC gives v = 9490 +/- 100 km/sec.','G',0.000187,NULL,'14.6g',0.63,'S?',NULL,NULL,NULL,NULL,1,228.106375,40.55247,0.025,NULL,59971771799,937058934,14641545,14.6),(127661,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127661,37.37,0.46,298,58355,70,NULL,NULL,'SDSS J151226.79+391937.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.111667,39.32703,0.049,NULL,60104270214,939129222,14673894,18.3),(127662,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127662,36.81,0.2,230,58356,74.4,NULL,NULL,'UGC 09765',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'16.64',0.6,'Sab            AGN',NULL,NULL,NULL,NULL,1,228.114625,20.65181,0.109,NULL,59535547514,930242929,14535045,16.64),(127663,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127663,36.52,0.09,202,58357,70,NULL,NULL,'2MASX J15122757+0730453',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00012,NULL,'17.0g',0.22,'S0','Group member',NULL,NULL,NULL,1,228.114917,7.51261,0.053,NULL,59386679686,927916870,14498701,17),(127664,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127664,31.15,0.48,17,58358,NULL,NULL,NULL,'ESO 328- G 030',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.000027,NULL,'13.10',0.8,'SAB:',NULL,NULL,NULL,NULL,1,228.116541667,-42.63236,0.465,NULL,47066346274,735411660,11490807,13.1),(127665,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127665,31.19,0.2,17.3,58358,74.4,NULL,NULL,'ESO 328- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127666,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127666,31.39,0.4,19,58358,73,NULL,'opt','ESO 328- G 030',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127667,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127667,31.48,0.41,19.8,58358,NULL,NULL,'Malmquist cor.','ESO 328- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127668,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127668,36.82,0.27,231,58359,70,NULL,NULL,'GIN 417',NULL,'2001MNRAS.321..277C',2001,1,0.61,NULL,'G',0.00023,NULL,'14.88',0.46,'S0/E','Group member',NULL,NULL,NULL,1,228.11725,7.97389,0.041,NULL,59351808405,927372006,14490187,14.88),(127669,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127669,34.06,0.8,65,58360,75,NULL,'MAT, I','ESO 328- G 031',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000033,NULL,'15.15',0.1,'Sc',NULL,NULL,NULL,NULL,1,228.1174583,-42.01781,0.353,NULL,47067578301,735430910,11491107,15.15),(127670,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127670,32.53,0.32,32.1,58360,85,NULL,'I, inv','ESO 328- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127671,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127671,32.58,0.32,32.8,58360,85,NULL,'I, raw','ESO 328- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127672,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127672,32.98,0.43,39.5,58360,75,NULL,'MAT, I, inv','ESO 328- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127673,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127673,33.1,0.43,41.7,58360,75,NULL,'MAT, I, raw','ESO 328- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127674,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127674,33.2,NULL,43.7,58360,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 328- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127675,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127675,33.21,NULL,43.8,58360,NULL,NULL,'Dipole','ESO 328- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127676,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127676,33.21,NULL,43.9,58360,NULL,NULL,'Dipole + Quadrupole','ESO 328- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127677,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127677,33.37,NULL,47.3,58360,NULL,NULL,NULL,'ESO 328- G 031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127678,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127678,33.57,0.43,51.9,58360,75,NULL,'MAT, I, cor','ESO 328- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127679,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127679,37.27,0.46,285,58361,70,NULL,NULL,'2MASX J15122821+2526182',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.117541667,25.43847,0.177,NULL,59896349210,935880456,14623132,17.2),(127680,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127680,37.56,0.46,325,58362,70,NULL,NULL,'2MASX J15122872-0217593',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.11975,-2.29967,0.233,NULL,45381715979,709089312,11079520,18.2),(127681,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127681,36.5,0.46,200,58363,70,NULL,NULL,'2MASX J15122919+0133212',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.121583,1.55589,0.101,NULL,56387254159,881050846,13766419,16.9),(127682,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127682,38.03,0.12,403,58364,70,NULL,NULL,'SDSS J151229.93-002127.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.1247083,-0.35756,0.137,NULL,45375262574,708988477,11077944,18.3),(127683,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127683,38.18,0.46,433,58365,70,NULL,NULL,'SDSS J151230.31+141935.2',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.1262917,14.32644,0.093,NULL,59571998036,930812469,14543944,17.2),(127684,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127684,36.61,0.33,210,58366,70,NULL,NULL,'2MASX J15123061+2039581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.2,'AGN',NULL,NULL,NULL,NULL,1,228.1277083,20.66608,0.109,NULL,59535547126,930242923,14535045,17.4),(127685,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127685,37.43,0.27,307,58367,70,NULL,NULL,'2MASX J15123065+0749273',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.12775,7.82422,0.049,NULL,59384536731,927883386,14498177,17.3),(127686,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127686,36.94,0.46,244,58368,70,NULL,NULL,'2MASX J15123105+1507545',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,228.129333333,15.13181,0.077,NULL,59572683392,930823178,14544112,16.2),(127687,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127687,37.48,0.46,313,58369,70,NULL,NULL,'2MASX J15123342+1709235',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.139333333,17.15656,0.057,NULL,59582452663,930975822,14546497,17.1),(127688,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127688,37.67,0.46,342,58370,70,NULL,NULL,'2MASX J15123349+3218501',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.1395,32.31392,0.017,NULL,60083901518,938810961,14668921,17.5),(127689,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127689,35.15,0.33,107,58371,70,NULL,NULL,'2MASX J15123368+0304252',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000085,NULL,'15.8g',0.27,'S0',NULL,NULL,NULL,NULL,1,228.1402917,3.07364,0.053,NULL,56381306088,880957907,13764967,15.8),(127690,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127690,37.24,0.46,281,58372,70,NULL,NULL,'2MASX J15123399+4848065',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.141833333,48.80194,0.017,NULL,59940749016,936574203,14633971,16.7),(127691,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127691,36.52,0.09,202,58373,70,NULL,NULL,'CGCG 049-042',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000113,NULL,'15.3g',0.36,'S0','Group member',NULL,NULL,NULL,1,228.1427083,7.76172,0.049,NULL,59384544735,927883511,14498179,15.3),(127692,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127692,36.52,0.09,202,58374,70,NULL,NULL,'GIN 413',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00007,NULL,'15.9g',0.37,'Ep','Group member',NULL,NULL,NULL,1,228.143041667,7.43153,0.053,NULL,59383246205,927863221,14497862,15.9),(127693,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127693,36.58,0.25,207,58374,74.4,NULL,NULL,'GIN 413',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127694,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127694,36.82,0.27,231,58374,70,NULL,NULL,'GIN 413',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127695,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127695,37.77,0.46,358,58375,70,NULL,NULL,'SDSS J151234.30+012512.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.142958333,1.42014,0.101,NULL,56386927564,881045743,13766339,17),(127696,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127696,36.52,0.09,202,58376,70,NULL,NULL,'2MASX J15123510+0729343',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'15.82',0.28,'S0','Group member',NULL,NULL,NULL,1,228.146166667,7.49278,0.053,NULL,59383222313,927862848,14497857,15.82),(127697,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127697,38.16,0.46,428,58377,70,NULL,NULL,'2MASX J15123518+2508022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.146541667,25.13389,0.165,NULL,59410671196,928291737,14504558,18),(127698,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127698,36.06,0.46,163,58378,70,NULL,NULL,'2MASX J15123519+5523218',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'15.9g',0.37,'S0',NULL,NULL,NULL,NULL,1,228.146833,55.38947,0.013,NULL,57583358368,899739974,14058437,15.9),(127699,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127699,37.62,0.46,334,58379,70,NULL,NULL,'2MASX J15123658+1938171',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.152375,19.63822,0.097,NULL,59534336993,930224015,14534750,17),(127700,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127700,37.31,0.46,289,58380,70,NULL,NULL,'2MASX J15123684+3051111',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.153417,30.853,0.021,NULL,60086960552,938858758,14669668,17.8),(127701,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127701,37.83,0.46,369,58381,70,NULL,NULL,'2MASX J15123713+3108161',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.154667,31.13797,0.009,NULL,60087071138,938860486,14669695,17.3),(127702,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127702,38.2,0.19,436,58382,70,NULL,NULL,'2MASX J15123746+1742215',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.156125,17.70589,0.033,NULL,59580775209,930949612,14546087,17.7),(127703,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127703,36.82,0.27,231,58383,70,NULL,NULL,'GIN 412',NULL,'2001MNRAS.321..277C',2001,1,0.32,NULL,'G',0.000077,NULL,'15.63',0.25,'S0','Group member',NULL,NULL,NULL,1,228.156583333,7.45181,0.053,NULL,59383243367,927863177,14497862,15.63),(127704,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127704,37.9,0.46,380,58383,70,NULL,NULL,'GIN 412',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127705,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127705,36.52,0.09,202,58384,70,NULL,NULL,'2MASX J15123773+0706513',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000147,NULL,'15.9g',0.38,'E','Group member',NULL,NULL,NULL,1,228.157083,7.11436,0.049,NULL,59383468890,927866701,14497917,15.9),(127706,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127706,37.85,0.46,371,58385,70,NULL,NULL,'SDSS J151237.73+063606.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.157208333,6.60175,0.057,NULL,59383985053,927874766,14498043,17.8),(127707,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127707,37.47,0.46,312,58386,70,NULL,NULL,'2MASX J15123879+4444050',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.161417,44.73475,0.033,NULL,59984922308,937264411,14644756,17.7),(127708,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127708,36.19,0.46,173,58387,70,NULL,NULL,'2MASX J15123880+0551452',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.161541667,5.86258,0.073,NULL,59329374638,927021478,14484710,16.6),(127709,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127709,37.29,0.46,287,58388,70,NULL,NULL,'2MASX J15123887+0532482',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.162,5.54669,0.073,NULL,59329454661,927022729,14484730,17),(127710,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127710,36.52,0.09,202,58389,70,NULL,NULL,'2MASX J15123940+0731103',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00014,NULL,'16.7g',0.3,'E/S0','Group member',NULL,NULL,NULL,1,228.1642083,7.51944,0.053,NULL,59383223009,927862859,14497857,16.7),(127711,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127711,36.82,0.46,232,58390,70,NULL,NULL,'2MASX J15123946+0840493',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.1645417,8.68031,0.049,NULL,59352486302,927382598,14490353,16.5),(127712,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127712,37.56,0.46,325,58391,70,NULL,NULL,'2MASX J15124085+3448161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.1702083,34.80458,0.029,NULL,60114489542,939288899,14676389,17),(127713,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127713,36.79,0.46,228,58392,70,NULL,NULL,'2MASX J15124088+0721393',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00013,NULL,'17.2g',0.2,'E/S0','Group member',NULL,NULL,NULL,1,228.170375,7.36103,0.057,NULL,59383247441,927863241,14497863,17.2),(127714,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127714,37.03,0.72,254,58393,70,NULL,NULL,'2MASX J15124151-0148293',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.5g',0.23,'Sa',NULL,NULL,NULL,NULL,1,228.173,-1.80808,0.185,NULL,45382200366,709096880,11079638,16.5),(127715,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127715,38.49,0.33,499,58394,70,NULL,NULL,'2MASX J15124163+0041522',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000085,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.173333,0.69778,0.113,NULL,56386252175,881035190,13766174,18.3),(127716,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127716,37.4,0.46,302,58395,70,NULL,NULL,'2MASX J15124167+3415491',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.173583,34.26356,0.021,NULL,60116642572,939322540,14676914,17.8),(127717,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127717,38.16,0.46,428,58396,70,NULL,NULL,'SDSS J151241.68-020547.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.173708333,-2.09642,0.161,NULL,45382281419,709098147,11079658,19),(127718,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127718,37.09,0.21,262,58397,70,NULL,NULL,'2MASX J15124194+1806561',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.17475,18.11558,0.057,NULL,59580937608,930952150,14546127,17.1),(127719,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127719,37.71,0.33,348,58398,70,NULL,NULL,'SDSS J151242.18+183011.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.175791667,18.50322,0.081,NULL,59580529496,930945773,14546027,17.6),(127720,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127720,36.99,0.33,250,58399,70,NULL,NULL,'2MASX J15124253+1539565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.1772917,15.66583,0.037,NULL,59564430567,930694227,14542097,17.5),(127721,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127721,37.43,0.27,307,58400,70,NULL,NULL,'SDSS J151242.70+075745.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.177917,7.96253,0.041,NULL,59351799716,927371870,14490185,18.3),(127722,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127722,36.52,0.09,202,58401,70,NULL,NULL,'GIN 411',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00005,NULL,'15.9g',0.52,'S0/E','Group member',NULL,NULL,NULL,1,228.180417,7.44722,0.053,NULL,59383279315,927863739,14497870,15.9),(127723,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127723,36.58,0.25,207,58401,74.4,NULL,NULL,'GIN 411',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127724,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127724,36.82,0.27,231,58401,70,NULL,NULL,'GIN 411',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127725,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127725,36.52,0.09,202,58402,70,NULL,NULL,'2MASX J15124350+0730173',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,'Group member',NULL,NULL,NULL,1,228.181375,7.50472,0.053,NULL,59383223050,927862860,14497857,17.2),(127726,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127726,37.03,0.46,255,58403,70,NULL,NULL,'2MASX J15124353+1851431',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,228.181583333,18.86211,0.085,NULL,59534595606,930228056,14534813,16.3),(127727,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127727,36.52,0.09,202,58404,70,NULL,NULL,'2MASX J15124384+0723343',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000113,NULL,'15.97',0.34,'E','Group member',NULL,NULL,NULL,1,228.182625,7.393,0.053,NULL,59383245016,927863203,14497862,15.97),(127728,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127728,36.52,0.09,202,58405,70,NULL,NULL,'2MASX J15124391+0733373',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00007,NULL,'15.9g',0.29,'S0','Group member',NULL,NULL,NULL,1,228.1829583,7.56039,0.053,NULL,59386636108,927916189,14498690,15.9),(127729,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127729,37.38,0.46,299,58406,70,NULL,NULL,'2MASX J15124461+1530486',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.1859583,15.51342,0.065,NULL,59571837958,930809968,14543905,17.2),(127730,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127730,37.31,0.46,290,58407,70,NULL,NULL,'2MASX J15124482+3243152',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.186541667,32.72075,0.005,NULL,60113308994,939270453,14676100,18),(127731,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127731,37.65,0.06,339,58408,70,NULL,NULL,'2MASX J15124478+0610443',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.186583,6.17917,0.069,NULL,59383547259,927867925,14497936,17.1),(127732,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127732,37.44,0.35,294,58409,60,NULL,NULL,'ABELL 2040',0.0456,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,228.188458333,7.42997,0.053,NULL,59383277304,927863707,14497870,NULL),(127733,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127733,36.45,0.13,195,58409,70,NULL,NULL,'ABELL 2040',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127734,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127734,37.55,0.46,323,58410,70,NULL,NULL,'2MASX J15124540+2341011',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00021,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.189125,23.68367,0.137,NULL,59411324073,928301938,14504717,17.2),(127735,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127735,35.47,0.46,124,58411,70,NULL,NULL,'NGC 5886',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.00006,NULL,'14.5g',0.63,'E0',NULL,NULL,NULL,NULL,1,228.189333333,41.23358,0.029,NULL,59974196754,937096824,14642137,14.5),(127736,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127736,31.84,NULL,23.3,58412,72,NULL,NULL,'AGC 258278',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000073,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.19125,6.16139,0.069,NULL,59383549896,927867967,14497936,NULL),(127737,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127737,37.53,0.46,320,58413,70,NULL,NULL,'2MASX J15124597+4605310',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.191625,46.092,0.025,NULL,59986857251,937294644,14645228,17.2),(127738,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127738,37.96,0.46,391,58414,70,NULL,NULL,'2MASX J15124623+1816341',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.1927083,18.27617,0.069,NULL,59580916846,930951825,14546122,17.7),(127739,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127739,38,0.46,397,58415,70,NULL,NULL,'2MASX J15124653+3358582',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.1937083,33.98289,0.005,NULL,60116604073,939321938,14676905,17.5),(127740,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127740,38,0.33,397,58416,70,NULL,NULL,'SDSS J151246.79+002846.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.195,0.47947,0.137,NULL,56377894147,880904596,13764134,18.2),(127741,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127741,37.2,0.46,276,58417,70,NULL,NULL,'SDSS J151247.23+310950.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.196833,31.16411,0.009,NULL,60087074062,938860532,14669695,18),(127742,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127742,37.44,0.35,294,58418,60,NULL,'ABELL 2040, BCG','UGC 09767',0.0456,'1980ApJ...241..486H',1980,1,1,NULL,'G',0.00005,NULL,'14.22',0.9,'BrClG','Group member',NULL,NULL,NULL,1,228.197917,7.43439,0.053,NULL,59383277196,927863706,14497870,14.22),(127743,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127743,36.59,0.25,208,58418,74.4,NULL,NULL,'UGC 09767',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127744,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127744,36.82,0.27,231,58418,70,NULL,NULL,'UGC 09767',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127745,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127745,36.45,0.13,195,58418,70,NULL,'ABELL 2040, BGC','UGC 09767',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127746,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127746,38.19,0.46,434,58419,70,NULL,NULL,'2MASX J15124870+1604586',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.203,16.08286,0.041,NULL,59565352947,930708639,14542322,17.3),(127747,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127747,37.69,0.46,345,58420,70,NULL,NULL,'2MASX J15124943+0618426',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000187,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.206,6.31175,0.061,NULL,59383818731,927872167,14498002,17.2),(127748,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127748,37.9,0.46,381,58421,70,NULL,NULL,'SDSS J151250.30+381141.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.209625,38.19492,0.037,NULL,60101611339,939087677,14673244,18.4),(127749,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127749,36.52,0.09,202,58422,70,NULL,NULL,'GIN 409',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00008,NULL,'14.88',0.36,'S0/E','Group member',NULL,NULL,NULL,1,228.211167,7.42439,0.053,NULL,59383277344,927863708,14497870,14.88),(127750,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127750,36.59,0.25,208,58422,74.4,NULL,NULL,'GIN 409',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127751,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127751,36.82,0.27,231,58422,70,NULL,NULL,'GIN 409',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127752,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127752,37.38,0.46,299,58423,70,NULL,NULL,'2MASX J15125110+1245297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.213,12.75836,0.101,NULL,59569576602,930774634,14543353,16.9),(127753,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127753,37.17,0.46,271,58424,70,NULL,NULL,'2MASX J15125163+1141516',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.2152083,11.69775,0.117,NULL,59348332147,927317689,14489338,17.5),(127754,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127754,38.3,0.21,457,58425,70,NULL,NULL,'2MASX J15125231+0248552',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000092,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.218125,2.81544,0.061,NULL,56385849854,881028903,13766076,17.4),(127755,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127755,35.96,0.25,156,58426,74.4,NULL,NULL,'CGCG 049-043',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.00009,NULL,'14.9g',0.55,'E/S0','Group member',NULL,NULL,NULL,1,228.2207083,4.514,0.089,NULL,56381409079,880959516,13764992,14.9),(127756,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127756,36.14,0.11,169,58426,70,NULL,NULL,'CGCG 049-043',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127757,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127757,36.18,0.26,172,58426,70,NULL,NULL,'CGCG 049-043',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127758,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127758,37.57,0.23,327,58427,70,NULL,NULL,'2MASX J15125306+1859470',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.221125,18.99644,0.089,NULL,59534598405,930228100,14534814,16.9),(127759,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127759,37.69,0.27,345,58428,70,NULL,NULL,'2MASX J15125308+3053423',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000184,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.22125,30.89517,0.021,NULL,60087027351,938859802,14669684,18.3),(127760,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127760,36.75,0.46,224,58429,70,NULL,NULL,'2MASX J15125429+3527523',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,228.226375,35.46453,0.041,NULL,60114679264,939291863,14676435,16.2),(127761,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127761,36.91,0.46,241,58430,70,NULL,NULL,'SDSS J151255.00+194242.4',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.0g',0.47,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.2292083,19.71181,0.089,NULL,59534329898,930223904,14534748,16),(127762,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127762,37.63,0.46,336,58431,70,NULL,NULL,'2MASX J15125544+1151086',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.231166667,11.8525,0.109,NULL,59348314348,927317411,14489334,17.3),(127763,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127763,35.86,0.46,149,58432,70,NULL,NULL,'2MASX J15125651+0730306',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'16.7g',0.21,'S0','Group member',NULL,NULL,NULL,1,228.2355,7.50861,0.053,NULL,59383223634,927862869,14497857,16.7),(127764,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127764,38.25,0.46,446,58433,70,NULL,NULL,'SDSS J151256.54+260601.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.235583,26.1005,0.169,NULL,59896550393,935883599,14623181,18.2),(127765,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127765,37.85,0.33,372,58434,70,NULL,NULL,'2MASX J15125671+1433067',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.3g',NULL,'BrClG',NULL,NULL,NULL,NULL,1,228.236333,14.55197,0.097,NULL,59572163467,930815054,14543985,17.3),(127766,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127766,37.63,0.46,336,58435,70,NULL,NULL,'2MASX J15125763+0443410',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.24025,4.72803,0.089,NULL,59328970491,927015163,14484611,17.2),(127767,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127767,38.67,0.46,541,58436,70,NULL,NULL,'SDSS J151257.71+095421.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.2405,9.90597,0.081,NULL,59354612849,927415825,14490872,18.6),(127768,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127768,37.63,0.46,335,58437,70,NULL,NULL,'2MASX J15125853+2200120',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.57',0.12,NULL,NULL,NULL,NULL,NULL,1,228.2437917,22.00333,0.157,NULL,59422875942,928482436,14507538,18.57),(127769,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127769,36.52,0.09,202,58438,70,NULL,NULL,'2MASX J15125853+0731276',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00012,NULL,'16.9g',0.28,'E','Group member',NULL,NULL,NULL,1,228.243833333,7.52444,0.053,NULL,59383223590,927862868,14497857,16.9),(127770,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127770,37.3,0.33,288,58439,70,NULL,NULL,'2MASX J15125904+1928310',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.245916667,19.47533,0.097,NULL,59534780800,930230950,14534858,17.8),(127771,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127771,38,0.33,397,58440,70,NULL,NULL,'2MASX J15125932+0025530',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000085,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.247333,0.43133,0.137,NULL,56377890317,880904536,13764133,17.3),(127772,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127772,35.15,0.33,107,58441,70,NULL,NULL,'CGCG 049-044',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000109,NULL,'14.3g',0.83,'E',NULL,NULL,NULL,NULL,1,228.2489583,3.15525,0.053,NULL,56381361155,880958768,13764980,14.3),(127773,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127773,38.29,0.46,454,58442,70,NULL,NULL,'2MASX J15125974+0328270',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000084,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.249041667,3.47431,0.101,NULL,56381241780,880956902,13764951,18.3),(127774,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127774,36.99,0.33,250,58443,70,NULL,NULL,'2MASX J15130033+0841196',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.2514583,8.68889,0.049,NULL,59352544826,927383512,14490367,17.9),(127775,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127775,38.3,0.21,457,58444,70,NULL,NULL,'SDSS J151300.40+024807.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000092,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.251667,2.80214,0.061,NULL,56385822634,881028478,13766069,18.4),(127776,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127776,36.21,0.13,174,58445,70,NULL,NULL,'CGCG 021-050',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000101,NULL,'15.3g',0.63,'BrClG',NULL,NULL,NULL,NULL,1,228.252417,2.02614,0.061,NULL,56388168701,881065135,13766642,15.3),(127777,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127777,37.5,0.46,316,58446,70,NULL,NULL,'2MASX J15130186+2829333',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.93',0.21,NULL,NULL,NULL,NULL,NULL,1,228.25775,28.49275,0.061,NULL,59908492224,936070191,14626096,17.93),(127778,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127778,38.59,0.46,522,58447,70,NULL,NULL,'2MASX J15130220+1648427',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.2592083,16.81194,0.061,NULL,59564915038,930701797,14542215,18.1),(127779,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127779,37.09,0.21,262,58448,70,NULL,NULL,'2MASX J15130231+1802380',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.259667,18.04406,0.057,NULL,59580907095,930951673,14546119,17.7),(127780,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127780,37.71,0.46,348,58449,70,NULL,NULL,'2MASX J15130299+1606017',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.262417,16.1005,0.041,NULL,59565353312,930708645,14542322,17.4),(127781,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127781,37.63,0.46,335,58450,70,NULL,NULL,'2MASX J15130364+3648146',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.2650417,36.80394,0.049,NULL,60108791375,939199865,14674997,17.6),(127782,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127782,38.24,0.46,446,58451,70,NULL,NULL,'2MASX J15130361+1418077',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.265125,14.30233,0.101,NULL,59572006823,930812606,14543946,17.1),(127783,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127783,37.61,0.46,333,58452,70,NULL,NULL,'2MASX J15130365+2213580',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.11',0.19,'BrClG',NULL,NULL,NULL,NULL,1,228.265167,22.23272,0.117,NULL,59422895933,928482748,14507542,18.11),(127784,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127784,38.26,0.23,449,58453,70,NULL,NULL,'SDSS J151304.98+181152.9',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.270791667,18.19806,0.057,NULL,59581091894,930954560,14546165,17.2),(127785,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127785,36.99,0.33,250,58454,70,NULL,NULL,'SDSS J151305.12+084022.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.271375,8.67297,0.049,NULL,59352545150,927383517,14490367,18.1),(127786,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127786,37.57,0.23,327,58455,70,NULL,NULL,'2MASX J15130591+1855500',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.2745,18.93047,0.089,NULL,59534548836,930227325,14534801,17.7),(127787,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127787,37.44,0.46,307,58456,70,NULL,NULL,'2MASX J15130593+2242130',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.2747917,22.70364,0.101,NULL,59423699168,928495299,14507739,16.8),(127788,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127788,36.21,0.13,174,58457,70,NULL,NULL,'2MASX J15130610+0206100',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000063,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.275417,2.10269,0.061,NULL,56388211274,881065801,13766653,16.8),(127789,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127789,37.85,0.33,372,58458,70,NULL,NULL,'2MASX J15130622+1437377',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.2760417,14.62706,0.097,NULL,59572164815,930815075,14543985,18.2),(127790,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127790,38.26,0.23,449,58459,70,NULL,NULL,'2MASX J15130707+1758180',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.2795417,17.97161,0.041,NULL,59580790930,930949858,14546091,17.8),(127791,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127791,31.21,0.8,17.4,58460,75,NULL,NULL,'UGC 09776',NULL,'1988NBGC.C....0000T',1988,1,0.8,'Multiple SDSS entries describe this object.','G',0.000017,NULL,'16',0.3,'Im','X-ray-faint group member',NULL,NULL,NULL,1,228.281541667,56.96864,0.013,NULL,57714679345,901791864,14090497,16),(127792,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127792,37.85,0.46,372,58461,70,NULL,NULL,'2MASX J15130737+1806180',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.280833,18.10503,0.057,NULL,59580898415,930951537,14546117,16.7),(127793,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127793,36.99,0.33,250,58462,70,NULL,NULL,'SDSS J151308.10+153631.5',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'15.7g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.283791667,15.60878,0.065,NULL,59564428441,930694194,14542096,15.7),(127794,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127794,38.26,0.23,449,58463,70,NULL,NULL,'2MASX J15130817+1758387',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.2839583,17.9775,0.041,NULL,59580777706,930949651,14546088,17.7),(127795,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127795,37.57,0.23,327,58464,70,NULL,NULL,'2MASX J15130817+1857060',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,228.2839583,18.95175,0.089,NULL,59534545222,930227269,14534801,16.5),(127796,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127796,37.69,0.27,345,58465,70,NULL,NULL,'SDSS J151308.74+304839.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.286417,30.81092,0.033,NULL,60085782993,938840359,14669380,18.1),(127797,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127797,37.46,0.46,310,58466,70,NULL,NULL,'2MASX J15131022+4230031',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.292417,42.50097,0.033,NULL,59973059193,937079049,14641860,17.4),(127798,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127798,37.66,0.46,341,58467,70,NULL,NULL,'2MASX J15131022+0636496',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.2925,6.61378,0.057,NULL,59384001093,927875017,14498047,17.7),(127799,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127799,35.96,0.25,156,58468,74.4,NULL,NULL,'CGCG 049-049',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000098,NULL,'15.2g',0.49,'E','Group member',NULL,NULL,NULL,1,228.293417,4.48206,0.089,NULL,56383511540,880992367,13765505,15.2),(127800,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127800,36.18,0.26,172,58468,70,NULL,NULL,'CGCG 049-049',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127801,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127801,35.91,0.55,152,58469,70,NULL,NULL,'2MASX J15131063-0401334',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,228.294333333,-4.02614,0.337,NULL,45372249106,708941392,11077209,16.24),(127802,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127802,37.46,0.46,310,58470,70,NULL,NULL,'2MASX J15131076+0246170',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000104,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.2949583,2.77136,0.061,NULL,56385636561,881025571,13766024,17.4),(127803,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127803,36.52,0.09,202,58471,70,NULL,NULL,'2MASX J15131137+0737186',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000123,NULL,'16.4g',0.27,'S0','Group member',NULL,NULL,NULL,1,228.297333333,7.62197,0.049,NULL,59383221547,927862836,14497856,16.4),(127804,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127804,37.69,0.33,345,58472,70,NULL,NULL,'SDSS J151313.00+462648.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.3042083,46.44675,0.057,NULL,59986912808,937295512,14645242,18.4),(127805,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127805,37.43,0.27,307,58473,70,NULL,NULL,'SDSS J151313.42+075609.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.3059583,7.93592,0.041,NULL,59351824123,927372251,14490191,18.2),(127806,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127806,37.84,0.46,369,58474,70,NULL,NULL,'2MASX J15131396+0558160',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.3082083,5.97122,0.069,NULL,59329359077,927021235,14484706,17.5),(127807,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127807,36.94,0.46,245,58475,70,NULL,NULL,'2MASX J15131435+4148166',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.309875,41.80456,0.037,NULL,59973399293,937084363,14641943,17.1),(127808,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127808,38.3,0.21,457,58476,70,NULL,NULL,'2MASX J15131510+0249010',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.8g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,228.312958333,2.81692,0.061,NULL,56385643830,881025684,13766026,16.8),(127809,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127809,37.3,0.33,288,58477,70,NULL,NULL,'2MASX J15131536+1923209',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,228.314167,19.38931,0.101,NULL,59534983415,930234115,14534908,16.6),(127810,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127810,37.73,0.46,352,58478,70,NULL,NULL,'SDSS J151315.78+230917.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.31575,23.15494,0.121,NULL,59423569258,928493269,14507707,18.7),(127811,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127811,38.11,0.46,419,58479,70,NULL,NULL,'SDSS J151316.26+305817.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.317791667,30.97158,0.013,NULL,60086855389,938857115,14669642,18.8),(127812,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127812,38.3,0.46,456,58480,70,NULL,NULL,'SDSS J151316.59+122237.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.319166667,12.37706,0.101,NULL,59569409751,930772027,14543312,18.1),(127813,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127813,37.86,0.46,374,58481,70,NULL,NULL,'2MASX J15131744+0546000',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.3227083,5.76658,0.073,NULL,59329392413,927021756,14484714,17.3),(127814,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127814,32.62,0.8,33.4,58482,75,NULL,NULL,'IC 4536',NULL,'1988NBGC.C....0000T',1988,1,2.2,'The 2MASX position applies to a knot north of the nucleus.','G',0.00001,NULL,'13.69',1.8,'SB(s)dm','in a pair',NULL,NULL,NULL,1,228.3217917,-18.13728,0.509,NULL,46700386578,729693540,11401461,13.69),(127815,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127815,31.7,0.43,21.9,58482,75,NULL,'3.6 micron, color + selection bias corrected','IC 4536',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127816,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127816,36.2,0.19,174,58483,70,NULL,NULL,'CGCG 049-056',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'15.7',0.45,NULL,NULL,NULL,NULL,NULL,1,228.324917,5.04522,0.093,NULL,59329194832,927018669,14484666,15.7),(127817,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127817,35.96,0.25,156,58484,74.4,NULL,NULL,'CGCG 049-054',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.00007,NULL,'15.2g',0.55,'E','Group member',NULL,NULL,NULL,1,228.327417,4.47747,0.089,NULL,56383509880,880992341,13765505,15.2),(127818,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127818,36.14,0.11,169,58484,70,NULL,NULL,'CGCG 049-054',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127819,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127819,36.18,0.26,172,58484,70,NULL,NULL,'CGCG 049-054',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127820,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127820,38.3,0.21,457,58485,70,NULL,NULL,'2MASX J15131910+0249240',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.329583,2.82339,0.061,NULL,56385646867,881025732,13766027,17.3),(127821,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127821,36.22,0.46,175,58486,70,NULL,NULL,'2MASX J15131914+0626462',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'17.31',0.41,NULL,'Group member',NULL,NULL,NULL,1,228.3297083,6.44614,0.049,NULL,59383830474,927872351,14498005,17.31),(127822,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127822,38.3,0.21,457,58487,70,NULL,NULL,'SDSS J151319.74+024805.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.3322917,2.80153,0.061,NULL,56385650517,881025789,13766027,18.3),(127823,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127823,37.57,0.23,327,58488,70,NULL,NULL,'2MASX J15132015+1856139',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.3339583,18.93725,0.105,NULL,59534812909,930231451,14534866,17),(127824,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127824,37.7,0.46,347,58489,70,NULL,NULL,'SDSS J151321.49+015933.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000068,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.339541667,1.99267,0.061,NULL,56388216665,881065885,13766654,18.7),(127825,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127825,37.69,0.46,345,58490,70,NULL,NULL,'2MASX J15132160+5254573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.34,52.91594,0.033,NULL,59663515743,932242433,14566288,17.8),(127826,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127826,37.67,0.46,342,58491,70,NULL,NULL,'2MASX J15132176-0225514',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.340625,-2.43089,0.233,NULL,45381758661,709089979,11079530,17.8),(127827,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127827,36.96,0.46,246,58492,70,NULL,NULL,'UGC 09770 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000201,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.341708333,25.2075,0.149,NULL,59896301630,935879712,14623120,16.3),(127828,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127828,36.32,0.46,184,58493,70,NULL,NULL,'2MASX J15132207+3057050',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,228.3420417,30.95156,0.037,NULL,60086856853,938857138,14669642,16.1),(127829,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127829,38.36,0.46,470,58494,70,NULL,NULL,'SDSS J151323.58+593228.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.3482917,59.54117,0.013,NULL,57774720223,902730003,14105156,18.6),(127830,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127830,38.49,0.33,499,58495,70,NULL,NULL,'2MASX J15132493+0049211',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.353875,0.82261,0.105,NULL,56386522403,881039412,13766240,17.4),(127831,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127831,37.71,0.46,348,58496,70,NULL,NULL,'2MASX J15132508+2337088',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.354583,23.61911,0.137,NULL,59411270490,928301101,14504704,17.3),(127832,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127832,37.98,0.1,394,58497,70,NULL,NULL,'2MASX J15132520+0435551',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.355041667,4.59869,0.089,NULL,56380102909,880939107,13764673,17.4),(127833,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127833,36.2,0.19,174,58498,70,NULL,NULL,'2MASX J15132532+0452161',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.3554583,4.87106,0.097,NULL,59328981882,927015341,14484614,16.4),(127834,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127834,38.13,0.46,423,58499,70,NULL,NULL,'SDSS J151325.78+110842.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.357458333,11.145,0.109,NULL,59347852778,927310199,14489221,18.6),(127835,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127835,38.11,0.46,418,58500,70,NULL,NULL,'2MASXi J1513258+355634',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.3577083,35.94289,0.053,NULL,60106591959,939165499,14674460,17.7),(127836,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127836,37.25,0.46,282,58501,70,NULL,NULL,'2MASX J15132637+2059534',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.3597917,20.99828,0.133,NULL,59414930243,928358285,14505598,NULL),(127837,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127837,36.32,0.46,183,58502,70,NULL,NULL,'2MASX J15132756+2027424',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.54',0.17,NULL,NULL,NULL,NULL,NULL,1,228.364875,20.46194,0.121,NULL,59535525153,930242580,14535040,17.54),(127838,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127838,38.1,0.27,418,58503,70,NULL,NULL,'2MASX J15132759+2249464',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.6g',0.2,'AGN',NULL,NULL,NULL,NULL,1,228.365167,22.82967,0.101,NULL,59423410886,928490795,14507668,17.6),(127839,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127839,38.11,0.33,419,58504,70,NULL,NULL,'2MASX J15132762+0015151',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.36525,0.25417,0.137,NULL,56377826158,880903533,13764117,17.7),(127840,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127840,36.38,0.49,189,58505,NULL,NULL,'Malmquist cor.','2MASX J15132872+0659283',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000027,NULL,'15.06',0.2,'Sc','Group member',NULL,NULL,NULL,1,228.3697083,6.99117,0.049,NULL,59383396220,927865565,14497899,15.06),(127841,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127841,36.79,0.41,228,58505,NULL,NULL,NULL,'2MASX J15132872+0659283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127842,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127842,36.83,0.2,232,58505,74.4,NULL,NULL,'2MASX J15132872+0659283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127843,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127843,36.86,0.33,235,58506,70,NULL,NULL,'2MASX J15132878+1729036',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.369958333,17.48444,0.077,NULL,59580663739,930947870,14546060,17.1),(127844,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127844,38.54,0.33,512,58507,70,NULL,NULL,'2MASX J15132892+2342544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.3705,23.71506,0.137,NULL,59411274702,928301167,14504705,17.2),(127845,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127845,36.52,0.09,202,58508,70,NULL,NULL,'2MASX J15132911+0720183',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'16.8g',0.25,'E/S0','Group member',NULL,NULL,NULL,1,228.371417,7.33836,0.049,NULL,59383261696,927863464,14497866,16.8),(127846,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127846,37.09,0.21,262,58509,70,NULL,NULL,'2MASX J15132912+1749236',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.3715417,17.82319,0.041,NULL,59580814653,930950228,14546097,17.3),(127847,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127847,38.54,0.33,512,58510,70,NULL,NULL,'2MASX J15133060+2348274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.377667,23.80756,0.137,NULL,59410796968,928293702,14504589,17.9),(127848,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127848,32.45,0.8,30.9,58511,75,NULL,'MAT, I','UGCA 402',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000013,NULL,'11.7B',0.7,'SBd pec sp     HII',NULL,NULL,NULL,NULL,1,228.378875,-20.67506,0.485,NULL,46617126723,728392605,11381134,11.7),(127849,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127849,32.6,0.8,33.1,58511,75,NULL,NULL,'UGCA 402',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127850,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127850,32.01,0.4,25.2,58511,NULL,NULL,NULL,'UGCA 402',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127851,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127851,32.03,0.43,25.4,58511,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 402',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127852,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127852,32.13,0.43,26.7,58511,75,NULL,'3.6 micron, color corrected','UGCA 402',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127853,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127853,32.18,0.32,27.3,58511,85,NULL,'I, raw','UGCA 402',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127854,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127854,32.21,0.32,27.7,58511,85,NULL,'I, inv','UGCA 402',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127855,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127855,32.23,0.2,27.9,58511,74.4,NULL,NULL,'UGCA 402',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127856,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127856,32.25,0.43,28.1,58511,75,NULL,'MAT, I, raw','UGCA 402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127857,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127857,32.3,0.49,28.9,58511,75,NULL,'IR','UGCA 402',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127858,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127858,32.43,0.43,30.6,58511,75,NULL,'MAT, I, inv','UGCA 402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127859,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127859,32.5,0.43,31.7,58511,75,NULL,'MAT, I, cor','UGCA 402',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127860,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127860,37.39,0.46,301,58512,70,NULL,NULL,'2MASX J15133091+0526241',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.3789583,5.44019,0.085,NULL,59329328791,927020762,14484699,16.7),(127861,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127861,37.62,0.46,334,58513,70,NULL,NULL,'2MASX J15133121+3739027',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.3799583,37.65069,0.041,NULL,60101634551,939088039,14673250,17.3),(127862,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127862,37.71,0.33,349,58514,70,NULL,NULL,'2MASX J15133198+3359230',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.383125,33.98978,0.045,NULL,60116624398,939322256,14676910,17.7),(127863,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127863,38.47,0.46,494,58515,70,NULL,NULL,'SDSS J151332.03+310459.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.3835,31.08311,0.033,NULL,60086833782,938856777,14669637,18.4),(127864,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127864,33.08,0.49,41.4,58516,70,NULL,NULL,'ESO 328- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'14.5',1,'SAb:',NULL,NULL,NULL,NULL,1,228.3839583,-39.21536,0.245,NULL,47189932962,737342702,11520979,14.5),(127865,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127865,37.23,0.46,279,58517,70,NULL,NULL,'MCG +10-22-007',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000201,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,228.386875,58.91808,0.017,NULL,57721601806,901900028,14092187,15.9),(127866,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127866,37.68,0.46,344,58518,70,NULL,NULL,'2MASX J15133331+2824368',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.0002,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.388708333,28.41008,0.065,NULL,59909246439,936081975,14626280,17.1),(127867,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127867,37.1,0.46,262,58519,70,NULL,NULL,'2MASX J15133447+0809313',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.393625,8.15853,0.041,NULL,59352003171,927375049,14490235,17.1),(127868,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127868,37.71,0.33,349,58520,70,NULL,NULL,'SDSS J151334.89+335840.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.395417,33.978,0.045,NULL,60116592739,939321761,14676902,18.6),(127869,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127869,37.98,0.1,394,58521,70,NULL,NULL,'2MASX J15133537+0437411',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.3974583,4.62808,0.097,NULL,56380104554,880939133,13764673,NULL),(127870,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127870,37.66,0.46,341,58522,70,NULL,NULL,'2MASX J15133543+2825458',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0002,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.3977083,28.42944,0.065,NULL,59909243630,936081931,14626280,16.8),(127871,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127871,38.03,0.46,404,58523,70,NULL,NULL,'2MASX J15133599+2002334',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.399916667,20.04261,0.101,NULL,59534237430,930222459,14534725,17),(127872,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127872,36.8,0.46,229,58524,70,NULL,NULL,'2MASX J15133687+1144563',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.4037083,11.74903,0.105,NULL,59348341597,927317837,14489341,17.4),(127873,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127873,37.38,0.46,299,58525,70,NULL,NULL,'2MASX J15133717+1909184',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.404958333,19.15517,0.109,NULL,59534852390,930232068,14534876,17.6),(127874,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127874,36.52,0.09,202,58526,70,NULL,NULL,'2MASX J15133832+0704373',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000113,NULL,'14.0',0.5,'E','Group member',NULL,NULL,NULL,1,228.409667,7.07706,0.049,NULL,59383390356,927865474,14497898,14),(127875,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127875,36.49,0.57,199,58527,NULL,NULL,'Malmquist cor.','AGC 251758',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.00003,NULL,'16.3',NULL,'Sc','Group member',NULL,NULL,NULL,1,228.410417,7.3275,0.049,NULL,59383265071,927863516,14497867,16.3),(127876,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127876,36.94,0.46,245,58527,NULL,NULL,NULL,'AGC 251758',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127877,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127877,36.98,0.2,249,58527,74.4,NULL,NULL,'AGC 251758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127878,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127878,36.59,0.46,208,58528,70,NULL,NULL,'2MASX J15133927+1932404',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.4135417,19.54453,0.097,NULL,59534953989,930233656,14534900,16.8),(127879,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127879,37.09,0.46,262,58529,70,NULL,NULL,'2MASX J15134010+0323221',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.417167,3.38939,0.057,NULL,56381388092,880959188,13764987,17.5),(127880,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127880,37.69,0.46,345,58530,70,NULL,NULL,'2MASX J15134013+2156514',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.61',0.15,NULL,NULL,NULL,NULL,NULL,1,228.417375,21.94761,0.157,NULL,59414546707,928352292,14505504,18.61),(127881,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127881,37.77,0.46,358,58531,70,NULL,NULL,'SDSS J151340.20+252805.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.4175417,25.46814,0.145,NULL,59896618985,935884671,14623197,18.4),(127882,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127882,37.36,0.33,296,58532,70,NULL,NULL,'2MASX J15134062+1130313',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,228.419417,11.50853,0.117,NULL,59347924417,927311319,14489239,16.4),(127883,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127883,37.14,0.46,268,58533,70,NULL,NULL,'2MASX J15134074+1037223',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000194,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.4197917,10.62275,0.097,NULL,59357008524,927453258,14491457,16.5),(127884,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127884,36.52,0.09,202,58534,70,NULL,NULL,'2MASX J15134175+0721183',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'13.98',0.17,NULL,NULL,NULL,NULL,NULL,1,228.423917,7.35508,0.049,NULL,59383266428,927863537,14497867,13.98),(127885,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127885,35.96,0.25,156,58535,74.4,NULL,NULL,'GIN 404',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00007,NULL,'15.9g',0.34,'S             BLAGN?',NULL,NULL,NULL,'Sy 1',1,228.4305,4.36214,0.049,NULL,56383528423,880992631,13765509,15.9),(127886,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127886,36.18,0.26,172,58535,70,NULL,NULL,'GIN 404',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127887,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127887,37.22,0.46,279,58536,70,NULL,NULL,'2MASX J15134511+0119241',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000075,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.438083,1.32342,0.097,NULL,56386638501,881041226,13766269,17.8),(127888,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127888,38.1,0.46,416,58537,70,NULL,NULL,'2MASX J15134519+3041390',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000151,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.438333,30.69422,0.033,NULL,60085822482,938840976,14669390,17.2),(127889,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127889,32,0.53,25.2,58538,70,NULL,NULL,'NGC 5878',NULL,'2014MNRAS.445.2677S',2014,1,3.5,'Confused HIPASS source','G',0.000007,NULL,'12.98',1.4,'SA(s)b','Group member',NULL,NULL,NULL,1,228.4404583,-14.26983,0.485,NULL,46670590414,729227975,11394187,12.98),(127890,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127890,32.25,0.8,28.1,58538,75,NULL,'MAT, I','NGC 5878',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127891,'Sosies','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127891,32.32,0.1,29.1,58538,NULL,NULL,NULL,'NGC 5878',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127892,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127892,32.5,0.8,31.6,58538,75,NULL,'B','NGC 5878',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127893,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127893,32.13,0.4,26.7,58538,NULL,NULL,NULL,'NGC 5878',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127894,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127894,32.23,0.43,28,58538,75,NULL,'MAT, I, raw','NGC 5878',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127895,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127895,32.3,0.46,28.9,58538,NULL,NULL,'J','NGC 5878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127896,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127896,32.34,0.47,29.3,58538,NULL,NULL,'H','NGC 5878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127897,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127897,32.35,0.32,29.5,58538,85,NULL,'I, raw','NGC 5878',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127898,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127898,32.35,0.4,29.5,58538,NULL,NULL,'mean','NGC 5878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127899,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127899,32.39,0.45,30,58538,NULL,NULL,'K','NGC 5878',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127900,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127900,32.41,0.32,30.4,58538,85,NULL,'I, inv','NGC 5878',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127901,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127901,32.44,0.43,30.8,58538,75,NULL,'MAT, I, cor','NGC 5878',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127902,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127902,32.48,0.2,31.3,58538,74.4,NULL,NULL,'NGC 5878',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127903,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127903,32.52,0.43,31.9,58538,75,NULL,'MAT, I, inv','NGC 5878',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127904,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127904,32.58,0.43,32.8,58538,75,NULL,'3.6 micron, color corrected','NGC 5878',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127905,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127905,32.61,0.36,33.2,58538,NULL,NULL,'Malmquist cor.','NGC 5878',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127906,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127906,32.7,0.34,34.7,58538,NULL,NULL,NULL,'NGC 5878',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127907,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127907,32.78,0.43,35.9,58538,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5878',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127908,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127908,36.21,0.13,174,58539,70,NULL,NULL,'CGCG 021-053',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000074,NULL,'16.1g',0.37,'E0','Group member',NULL,NULL,NULL,1,228.441167,2.12494,0.045,NULL,56388010126,881062658,13766604,16.1),(127909,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127909,37.3,0.46,288,58540,70,NULL,NULL,'CGCG 165-033',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000107,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,228.442,26.89786,0.101,NULL,59897818778,935903418,14623490,15.7),(127910,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127910,35.14,0.5,107,58541,70,NULL,NULL,'2MASX J15134622-4343365',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.4425,-43.72683,0.709,NULL,47072738337,735511536,11492367,14.7),(127911,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127911,37.67,0.46,342,58542,70,NULL,NULL,'2MASX J15134634+1813523',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.443167,18.23125,0.069,NULL,59581135166,930955236,14546175,16.9),(127912,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127912,37.98,0.1,394,58543,70,NULL,NULL,'SDSS J151346.69+043920.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.444541667,4.65567,0.097,NULL,56380157844,880939966,13764686,17.8),(127913,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127913,36.21,0.13,174,58544,70,NULL,NULL,'CGCG 021-052',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.0001,NULL,'15.6g',0.47,'E0','Group member',NULL,NULL,NULL,1,228.44625,2.09803,0.045,NULL,56388002682,881062541,13766602,15.6),(127914,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127914,37.59,0.46,329,58545,70,NULL,NULL,'2MASX J15134729+5745491',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000077,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.4474583,57.76358,0.013,NULL,57720936751,901889636,14092025,16.9),(127915,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127915,37.32,0.46,291,58546,70,NULL,NULL,'SDSS J151347.93+041204.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.44975,4.20133,0.045,NULL,56383612508,880993945,13765530,18.1),(127916,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127916,32.34,0.47,29.3,58547,NULL,NULL,'H','NGC 5892',NULL,'2007A&A...465...71T',2007,1,3.5,NULL,'G',0.000013,NULL,'12.30',2.8,'SA(s)d         HII',NULL,NULL,NULL,NULL,1,228.450875,-15.46389,0.441,NULL,46670427391,729225427,11394147,12.3),(127917,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127917,32.42,0.46,30.5,58547,NULL,NULL,'J','NGC 5892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127918,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127918,32.47,0.45,31.2,58547,NULL,NULL,'K','NGC 5892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127919,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127919,32.49,0.4,31.5,58547,NULL,NULL,'mean','NGC 5892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127920,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127920,32.64,0.4,33.7,58547,75,NULL,'B','NGC 5892',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127921,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127921,37.34,0.46,294,58548,70,NULL,NULL,'2MASX J15134826+4022289',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.4512083,40.37472,0.041,NULL,59971762206,937058784,14641543,17.7),(127922,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127922,35.91,0.36,152,58549,NULL,NULL,NULL,'AGC 251759',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.00003,NULL,'15.6',NULL,'Sc','Group member',NULL,NULL,NULL,1,228.453125,7.1545,0.049,NULL,59383372249,927865191,14497893,15.6),(127923,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127923,35.95,0.2,155,58549,74.4,NULL,NULL,'AGC 251759',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127924,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127924,36.02,0.34,160,58549,NULL,NULL,'Malmquist cor.','AGC 251759',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127925,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127925,38.1,0.27,418,58550,70,NULL,NULL,'SDSS J151349.12+224947.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.4547083,22.82978,0.121,NULL,59423523451,928492553,14507696,18.1),(127926,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127926,37.09,0.21,262,58551,70,NULL,NULL,'2MASX J15134931+1750439',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000107,NULL,'17.11',0.48,NULL,NULL,NULL,NULL,NULL,1,228.4555,17.84542,0.041,NULL,59580818834,930950294,14546098,17.11),(127927,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127927,38.1,0.27,418,58552,70,NULL,NULL,'2MASX J15134936+2251223',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00021,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,228.4557917,22.85606,0.121,NULL,59423526346,928492599,14507696,16),(127928,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127928,37.23,0.46,280,58553,70,NULL,NULL,'SDSS J151349.43+104510.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.456,10.75294,0.101,NULL,59357013928,927453342,14491458,18),(127929,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127929,38.11,0.33,419,58554,70,NULL,NULL,'2MASX J15134962+0021341',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000092,NULL,'16.7g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,228.4567083,0.35939,0.137,NULL,56378688292,880917004,13764328,16.7),(127930,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127930,36.18,0.26,172,58555,70,NULL,NULL,'GIN 403',NULL,'2001MNRAS.321..277C',2001,1,0.54,NULL,'G',0.000083,NULL,'15.9g',0.42,'S',NULL,NULL,NULL,NULL,1,228.457,4.72353,0.097,NULL,56380161486,880940023,13764687,15.9),(127931,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127931,36.64,0.25,213,58555,74.4,NULL,NULL,'GIN 403',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127932,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127932,37.78,0.46,360,58556,70,NULL,NULL,'SDSS J151350.68+252045.0',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.8g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.461208333,25.34586,0.149,NULL,59896575627,935883994,14623187,16.8),(127933,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127933,35.98,0.25,157,58557,74.4,NULL,NULL,'GIN 402',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000077,NULL,'15.8g',0.41,'E/S0',NULL,NULL,NULL,NULL,1,228.461583,4.62258,0.053,NULL,56380121855,880939403,13764678,15.8),(127934,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127934,36.18,0.26,172,58557,70,NULL,NULL,'GIN 402',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127935,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127935,36.2,0.19,174,58557,70,NULL,NULL,'GIN 402',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127936,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127936,37.89,0.46,379,58558,70,NULL,NULL,'2MASX J15135124+2756007',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0002,NULL,'17.51',0.15,NULL,NULL,NULL,NULL,NULL,1,228.463667,27.93361,0.073,NULL,59908731427,936073928,14626155,17.51),(127937,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127937,38.26,0.23,449,58559,70,NULL,NULL,'SDSS J151351.43+181142.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.464333333,18.19506,0.069,NULL,59581127111,930955111,14546173,18.1),(127938,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127938,37.6,0.46,331,58560,70,NULL,NULL,'2MASX J15135209+0443580',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.4669583,4.73292,0.097,NULL,56380161920,880940030,13764687,17),(127939,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127939,35.49,0.63,125,58561,70,NULL,NULL,'2MASX J15135321-3848251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.471791667,-38.80694,0.253,NULL,47189320261,737333129,11520830,14.9),(127940,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127940,36.77,0.78,226,58562,70,NULL,NULL,'2MASX J15135348-2135462',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,228.472917,-21.59617,0.465,NULL,46617550854,728399232,11381238,14.4),(127941,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127941,37.54,0.23,322,58563,70,NULL,NULL,'2MASX J15135400+2412317',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000191,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.474833,24.20894,0.125,NULL,59410952242,928296128,14504627,16.8),(127942,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127942,37.58,0.46,328,58564,70,NULL,NULL,'2MASX J15135467+1848212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.477917,18.80578,0.097,NULL,59534082507,930220039,14534688,17.2),(127943,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127943,37.7,0.27,347,58565,70,NULL,NULL,'2MASX J15135520+1937112',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.480125,19.61994,0.089,NULL,59534377953,930224655,14534760,16.9),(127944,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127944,37.7,0.27,347,58566,70,NULL,NULL,'SDSS J151355.52+193615.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.481417,19.60428,0.089,NULL,59534377916,930224654,14534760,18.4),(127945,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127945,37.98,0.1,394,58567,70,NULL,NULL,'2MASX J15135611+0437061',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.483666667,4.61822,0.053,NULL,56380125158,880939455,13764678,17.3),(127946,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127946,37.54,0.23,322,58568,70,NULL,NULL,'2MASX J15135692+2408547',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,228.487166667,24.14864,0.125,NULL,59411002013,928296906,14504639,16.6),(127947,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127947,36.14,0.46,169,58569,70,NULL,NULL,'2MASX J15135716+2336436',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.54',0.25,'AGN',NULL,NULL,NULL,NULL,1,228.488167,23.61222,0.137,NULL,59422015637,928468994,14507328,16.54),(127948,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127948,37.54,0.23,322,58570,70,NULL,NULL,'2MASX J15135721+2408237',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.488291667,24.13981,0.125,NULL,59411004874,928296951,14504639,17.4),(127949,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127949,34.76,NULL,89.5,58571,NULL,NULL,NULL,'FGC 1865',NULL,'2000BSAO...50....5K',2000,1,1.1,NULL,'G',0.0001,NULL,'16.9g',0.14,'Sdm',NULL,NULL,NULL,NULL,1,228.488167,37.33864,0.037,NULL,60108704188,939198502,14674976,16.9),(127950,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127950,34.81,NULL,91.6,58571,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1865',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127951,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127951,34.81,NULL,91.7,58571,NULL,NULL,'Dipole + Quadrupole','FGC 1865',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127952,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127952,34.83,NULL,92.4,58571,NULL,NULL,'Dipole','FGC 1865',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127953,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127953,36.2,0.19,174,58572,70,NULL,NULL,'2MASX J15135764+0445231',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.490083,4.75647,0.097,NULL,56380147108,880939798,13764684,16.6),(127954,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127954,37.98,0.1,394,58573,70,NULL,NULL,'2MASX J15135764+0447481',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.49025,4.79658,0.093,NULL,56380139673,880939682,13764682,16.7),(127955,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127955,36.43,0.46,194,58574,70,NULL,NULL,'2MASX J15135820+3950471',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.492667,39.84647,0.033,NULL,60102791681,939106120,14673533,17.1),(127956,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127956,37.94,0.46,386,58575,70,NULL,NULL,'SDSS J151359.66+485136.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.498625,48.86022,0.021,NULL,59940771943,936574561,14633977,18.5),(127957,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127957,36.8,0.57,229,58576,70,NULL,NULL,'2MASX J15140013-2131260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.500583,-21.524,0.465,NULL,46617585314,728399770,11381246,14.7),(127958,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127958,36.96,0.46,246,58577,70,NULL,NULL,'2MASX J15140022+2112486',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.46',0.15,NULL,NULL,NULL,NULL,NULL,1,228.501,21.21353,0.145,NULL,59415233535,928363023,14505672,18.46),(127959,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127959,38.18,0.46,433,58578,70,NULL,NULL,'2MASX J15140047+2603347',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.44',0.15,NULL,NULL,NULL,NULL,NULL,1,228.502125,26.05956,0.153,NULL,59896712800,935886137,14623220,18.44),(127960,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127960,38.57,0.33,519,58579,70,NULL,NULL,'SDSS J151400.55+233451.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.502333,23.58097,0.137,NULL,59423851462,928497679,14507776,18.2),(127961,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127961,33.87,NULL,59.5,58580,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09780',NULL,'2010Ap&SS.325..163P',2010,1,1.27,NULL,'G',0.000017,NULL,'14.9g',0.36,'Scd','Isolated galaxy',NULL,NULL,NULL,1,228.504375,44.59053,0.033,NULL,59984960352,937265005,14644765,14.9),(127962,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127962,33.88,NULL,59.7,58580,NULL,NULL,'Dipole + Quadrupole','UGC 09780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127963,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127963,33.88,NULL,59.8,58580,NULL,NULL,'Dipole','UGC 09780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127964,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127964,33.92,0.49,60.8,58580,75,NULL,'IR','UGC 09780',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127965,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127965,34,0.2,63.1,58580,74.4,NULL,NULL,'UGC 09780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127966,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127966,34.03,0.52,64,58580,NULL,NULL,NULL,'UGC 09780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127967,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127967,34.14,0.49,67.4,58580,NULL,NULL,'Malmquist cor.','UGC 09780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127968,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127968,38.57,0.33,519,58581,70,NULL,NULL,'SDSS J151401.20+232756.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.5050417,23.46558,0.117,NULL,59423340283,928489691,14507651,18.4),(127969,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127969,37.36,0.33,296,58582,70,NULL,NULL,'2MASX J15140130+1131411',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.505417,11.52808,0.117,NULL,59347922649,927311291,14489238,17.4),(127970,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127970,37.46,0.27,311,58583,70,NULL,NULL,'2MASX J15140150+1503300',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.50625,15.05825,0.077,NULL,59572729559,930823899,14544123,16.8),(127971,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127971,37.69,0.33,345,58584,70,NULL,NULL,'SDSS J151401.83+462601.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000136,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.507667,46.43378,0.041,NULL,59986725912,937292592,14645196,17.9),(127972,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127972,38.45,0.46,490,58585,70,NULL,NULL,'SDSS J151402.17+014401.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.509083,1.73386,0.081,NULL,56387637460,881056835,13766513,18.1),(127973,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127973,37.7,0.27,347,58586,70,NULL,NULL,'2MASX J15140391+1935035',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.516333,19.58439,0.089,NULL,59534888240,930232628,14534884,16.8),(127974,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127974,37.79,0.27,362,58587,70,NULL,NULL,'B2 1512+30',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',NULL,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,228.517375,30.14647,0.041,NULL,59904731890,936011435,14625178,15.9),(127975,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127975,37.47,0.46,312,58588,70,NULL,NULL,'2MASX J15140431+5630186',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000089,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.51775,56.50517,0.013,NULL,57581713250,899714269,14058035,16.6),(127976,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127976,36.26,0.53,179,58589,70,NULL,NULL,'2MASX J15140456-2208200',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,228.5189583,-22.13883,0.449,NULL,46621599216,728462487,11382226,13.7),(127977,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127977,37.79,0.27,362,58590,70,NULL,NULL,'2MASX J15140602+3010521',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.5252083,30.18131,0.041,NULL,59904734945,936011483,14625179,17.9),(127978,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127978,35.96,0.25,156,58591,74.4,NULL,NULL,'CGCG 049-067',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000077,NULL,'14.22',0.4,'E',NULL,NULL,NULL,NULL,1,228.52575,4.22217,0.045,NULL,56383709362,880995458,13765554,14.22),(127979,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127979,36.14,0.11,169,58591,70,NULL,NULL,'CGCG 049-067',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127980,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127980,36.18,0.26,172,58591,70,NULL,NULL,'CGCG 049-067',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127981,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127981,38.11,0.46,419,58592,70,NULL,NULL,'SDSS J151407.69+193622.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.532083,19.60614,0.089,NULL,59534378714,930224667,14534760,17.9),(127982,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127982,34.92,0.49,96.2,58593,75,NULL,'IR','CGCG 135-030',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000704,NULL,'16.20',0.1,NULL,NULL,NULL,NULL,NULL,1,228.5342917,25.69961,0.153,NULL,59896701567,935885961,14623218,16.2),(127983,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127983,35.54,0.2,128,58594,74.4,NULL,NULL,'CGCG 135-030',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000704,NULL,'16.20',0.1,NULL,NULL,NULL,NULL,NULL,1,228.5342917,25.69961,0.153,NULL,59896701567,935885961,14623218,16.2),(127984,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127984,37.46,0.27,311,58595,70,NULL,NULL,'2MASX J15140978+1514380',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,228.5409583,15.24378,0.073,NULL,59572598879,930821857,14544091,16.7),(127985,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127985,38.74,0.46,560,58596,70,NULL,NULL,'SDSS J151410.55+211356.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.544,21.2325,0.145,NULL,59415236544,928363071,14505672,18.6),(127986,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127986,36.24,0.43,177,58597,NULL,NULL,'Malmquist cor.','2MASX J15141134+0711511',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.000027,NULL,'17.1g',0.17,'Sc','Group member',NULL,NULL,NULL,1,228.547125,7.19756,0.049,NULL,59383368228,927865128,14497892,17.1),(127987,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127987,36.54,0.38,203,58597,NULL,NULL,NULL,'2MASX J15141134+0711511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127988,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127988,36.58,0.2,207,58597,74.4,NULL,NULL,'2MASX J15141134+0711511',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127989,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127989,36.21,0.46,175,58598,70,NULL,NULL,'2MASX J15141177+1901135',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.549041667,19.02039,0.109,NULL,59534860682,930232198,14534878,16.5),(127990,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127990,37.04,0.46,256,58599,70,NULL,NULL,'2MASX J15141201+4049183',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000138,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.5500417,40.82164,0.033,NULL,59971914363,937061161,14641580,17.1),(127991,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127991,34.71,0.2,87.5,58600,74.4,NULL,NULL,'CGCG 077-047',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000023,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,228.550458333,13.89431,0.085,NULL,59573284295,930832567,14544258,15.4),(127992,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127992,37.82,0.46,367,58601,70,NULL,NULL,'2MASX J15141269+0403431',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.553,4.06206,0.045,NULL,56383595218,880993675,13765526,17.3),(127993,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',127993,36.2,0.19,174,58602,70,NULL,NULL,'2MASX J15141296+0448431',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.5540417,4.81194,0.093,NULL,56380137978,880939655,13764682,16),(127994,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127994,27.41,0.09,3.03,58603,74.4,NULL,NULL,'ESO 274- G 001',NULL,'2013AJ....146...86T',2013,1,13.44,'The 2MASX position is centered on two knots southwest of the center.','G',0.000007,NULL,'11.7',1.34,'Sd',NULL,NULL,NULL,NULL,1,228.557667,-46.80794,NULL,NULL,47105558462,736024350,11500380,11.7),(127995,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127995,27.42,NULL,3.05,58603,NULL,NULL,NULL,'ESO 274- G 001',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127996,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127996,27.49,0.02,3.15,58603,NULL,NULL,'I','ESO 274- G 001',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127997,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127997,29.28,0.8,7.2,58603,75,NULL,'B','ESO 274- G 001',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127998,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127998,27.41,0.09,3.03,58603,74.4,NULL,NULL,'ESO 274- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(127999,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,127999,27.94,0.43,3.9,58603,75,NULL,'3.6 micron, color + selection bias corrected','ESO 274- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128000,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128000,28.13,0.43,4.2,58603,75,NULL,'3.6 micron, color corrected','ESO 274- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128001,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128001,28.54,NULL,5.11,58603,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 274- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128002,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128002,28.55,NULL,5.13,58603,NULL,NULL,'Dipole','ESO 274- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128003,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128003,28.56,NULL,5.14,58603,NULL,NULL,'Dipole + Quadrupole','ESO 274- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128004,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128004,28.64,NULL,5.34,58603,NULL,NULL,NULL,'ESO 274- G 001',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128005,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128005,34.94,0.55,97.1,58604,70,NULL,NULL,'LCRS B151137.6-033415',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000063,NULL,'17.59',0.7,'HII',NULL,NULL,NULL,NULL,1,228.558167,-3.75217,0.333,NULL,45373057847,708954028,11077406,17.59),(128006,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128006,36.58,0.64,207,58605,70,NULL,NULL,'2MASX J15141418-2312340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.5590417,-23.20936,0.497,NULL,46621022568,728453477,11382085,15.6),(128007,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128007,38.54,0.46,511,58606,70,NULL,NULL,'2MASX J15141468+0331491',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.561125,3.53047,0.057,NULL,56383195193,880987424,13765428,17.3),(128008,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128008,36.13,0.46,169,58607,70,NULL,NULL,'2MASX J15141471+2644321',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.02',0.21,NULL,NULL,NULL,NULL,NULL,1,228.5612917,26.74233,0.093,NULL,59896036534,935875570,14623055,17.02),(128009,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128009,35.12,0.46,106,58608,70,NULL,NULL,'CGCG 077-046',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00008,NULL,'15.3',NULL,NULL,NULL,NULL,NULL,NULL,1,228.562125,12.08761,0.141,NULL,59347399104,927303111,14489111,15.3),(128010,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128010,33.22,0.69,44,58609,100,NULL,'mid-IR','UGC 09777',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.00002,NULL,'14.40',0.9,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,228.563125,20.47867,0.125,NULL,59415738280,928370910,14505795,14.4),(128011,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128011,34.16,0.4,68.1,58609,NULL,NULL,'mean','UGC 09777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128012,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128012,34.17,0.2,68.2,58609,74.4,NULL,NULL,'UGC 09777',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128013,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128013,34.46,0.47,77.9,58609,NULL,NULL,'H','UGC 09777',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128014,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128014,37.97,0.46,393,58610,70,NULL,NULL,'SDSS J151415.35+365747.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.564,36.96306,0.041,NULL,60108743766,939199121,14674986,18.2),(128015,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128015,37.79,0.27,362,58611,70,NULL,NULL,'2MASX J15141535+3003421',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.78',0.14,NULL,NULL,NULL,NULL,NULL,1,228.564083333,30.06164,0.041,NULL,59904740694,936011573,14625180,18.78),(128016,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128016,37.09,0.21,262,58612,70,NULL,NULL,'2MASX J15141565+1741525',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.565166667,17.69786,0.089,NULL,59580848782,930950762,14546105,17.1),(128017,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128017,36.3,0.59,182,58613,NULL,NULL,'Malmquist cor.','AGC 251761',NULL,'2009ApJS..182..474S',2009,1,0.33,NULL,'G',0.000027,NULL,'16.78',NULL,'Sc',NULL,NULL,NULL,NULL,1,228.56775,7.33994,0.049,NULL,59349945918,927342904,14489732,16.78),(128018,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128018,36.6,0.52,209,58613,NULL,NULL,NULL,'AGC 251761',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128019,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128019,36.64,0.2,213,58613,74.4,NULL,NULL,'AGC 251761',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128020,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128020,37.62,0.46,334,58614,70,NULL,NULL,'2MASX J15141681+3516431',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.5702917,35.27875,0.041,NULL,60106892130,939170189,14674534,16.9),(128021,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128021,37.27,0.46,285,58615,70,NULL,NULL,'2MASX J15141720+0020151',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.5715417,0.33747,0.125,NULL,56378699062,880917172,13764330,17.3),(128022,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128022,37.32,0.46,291,58616,70,NULL,NULL,'2MASX J15141732+4012264',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.5722917,40.20742,0.037,NULL,60102755036,939105547,14673524,16.7),(128023,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128023,37.54,0.23,322,58617,70,NULL,NULL,'SDSS J151419.47+241925.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.581167,24.32381,0.129,NULL,59410840258,928294379,14504599,18.3),(128024,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128024,36.86,0.33,235,58618,70,NULL,NULL,'2MASX J15141959+1724505',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.5817083,17.41408,0.077,NULL,59563610678,930681416,14541897,17.3),(128025,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128025,35.65,0.33,135,58619,70,NULL,NULL,'CGCG 049-069',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00008,NULL,'15.7',0.48,NULL,NULL,NULL,NULL,NULL,1,228.584917,8.28872,0.045,NULL,59351882455,927373163,14490205,15.7),(128026,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128026,37.94,0.17,387,58620,70,NULL,NULL,'2MASX J15142050+0350470',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000082,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.585458333,3.84642,0.049,NULL,56383836230,880997441,13765585,18.2),(128027,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128027,37.98,0.1,394,58621,70,NULL,NULL,'2MASX J15142162+0437261',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.5902083,4.62375,0.053,NULL,56380113377,880939271,13764676,17),(128028,'HII LF','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128028,47.49,1.57,6000,58622,71,NULL,NULL,'MS 1512-cB58',2.7233,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.0005,NULL,'20.31',NULL,'Sb-Sc',NULL,NULL,NULL,NULL,1,228.5927917,36.607,0.033,NULL,60108679830,939198122,14674970,20.31),(128029,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128029,38,0.46,398,58623,70,NULL,NULL,'SDSS J151424.15+023232.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.600667,2.54233,0.057,NULL,56387860790,881060324,13766567,18.2),(128030,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128030,35.53,0.33,128,58624,NULL,NULL,NULL,'SDSS J151424.70+073652.6',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000033,NULL,'15.94',NULL,'Scd','Group member',NULL,NULL,NULL,1,228.602958333,7.61461,0.049,NULL,59349964480,927343195,14489737,15.94),(128031,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128031,35.57,0.2,130,58624,74.4,NULL,NULL,'SDSS J151424.70+073652.6',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128032,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128032,35.89,0.28,150,58624,NULL,NULL,'Malmquist cor.','SDSS J151424.70+073652.6',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128033,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128033,36.22,0.46,175,58625,70,NULL,NULL,'2MASX J15142471+0336161',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.603,3.60433,0.057,NULL,56383132410,880986443,13765413,16.3),(128034,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128034,36.13,0.52,168,58626,70,NULL,NULL,'2MASX J15142471-2129480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.6030417,-21.49672,0.465,NULL,46617555468,728399304,11381239,14.6),(128035,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128035,36.02,0.46,160,58627,70,NULL,NULL,'CGCG 049-071',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000103,NULL,'15.6',0.41,'S0/E','Group member',NULL,NULL,NULL,1,228.608625,7.89142,0.049,NULL,59352854425,927388350,14490442,15.6),(128036,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128036,37.75,0.46,355,58628,70,NULL,NULL,'2MASX J15142624+2710161',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.609208333,27.17114,0.089,NULL,59908556268,936071191,14626112,18),(128037,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128037,36.61,0.33,210,58629,70,NULL,NULL,'CGCG 135-034',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00017,NULL,'15.4',0.32,NULL,NULL,NULL,NULL,NULL,1,228.613708333,20.78933,0.145,NULL,59414692925,928354576,14505540,15.4),(128038,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128038,39.09,0.46,658,58630,70,NULL,NULL,'2MASX J15142799-0221011',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,228.616625,-2.35031,0.221,NULL,45381654180,709088346,11079505,18.4),(128039,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128039,36.88,0.2,238,58631,74.4,NULL,NULL,'CGCG 077-048',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.000159,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.6195417,9.95489,0.069,NULL,59354390098,927412345,14490817,15.9),(128040,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128040,37.18,0.46,273,58632,70,NULL,NULL,'2MASX J15142965+0642023',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,'Group member',NULL,NULL,NULL,1,228.623625,6.70056,0.033,NULL,59383910875,927873607,14498025,17.5),(128041,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128041,37.9,0.27,380,58633,70,NULL,NULL,'2MASX J15143032+0155261',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.00',0.33,NULL,NULL,NULL,NULL,NULL,1,228.626417,1.92408,0.089,NULL,56387523422,881055053,13766485,17),(128042,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128042,37.98,0.1,394,58634,70,NULL,NULL,'2MASX J15143145+0425291',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000087,NULL,'17.1g',0.27,'S0',NULL,NULL,NULL,NULL,1,228.631167,4.42481,0.049,NULL,56383725905,880995717,13765558,17.1),(128043,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128043,37.92,0.46,384,58635,70,NULL,NULL,'SDSS J151432.05+532600.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.633583333,53.4335,0.017,NULL,59663910108,932248595,14566384,18.6),(128044,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128044,38.26,0.46,449,58636,70,NULL,NULL,'2MASX J15143226+0804073',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.634458333,8.06867,0.041,NULL,59352958661,927389979,14490468,17.1),(128045,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128045,37.95,0.46,389,58637,70,NULL,NULL,'2MASX J15143269+2311374',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.636208333,23.19389,0.129,NULL,59423361134,928490017,14507656,18.1),(128046,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128046,37.65,0.46,339,58638,70,NULL,NULL,'2MASX J15143268+1526545',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.636291667,15.44853,0.065,NULL,59572351540,930817992,14544031,18.1),(128047,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128047,37.46,0.46,311,58639,70,NULL,NULL,'SDSS J151433.90+183200.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.6412917,18.53356,0.089,NULL,59580179781,930940309,14545942,18),(128048,'Sosies','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128048,31.61,0.24,21,58640,NULL,NULL,NULL,'WKK 4748',NULL,'2002A&A...393...57T',2002,1,3.53,'Extended HIPASS source','G',0.00001,NULL,'13.9',0.93,'SBb?sp;ext.dust lane',NULL,NULL,NULL,NULL,1,228.6437917,-52.98886,NULL,NULL,46308339728,723567808,11305747,13.9),(128049,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128049,30.61,0.46,13.2,58640,NULL,NULL,'J','WKK 4748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128050,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128050,31.12,0.4,16.8,58640,NULL,NULL,'mean','WKK 4748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128051,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128051,37.37,0.46,298,58641,70,NULL,NULL,'2MASX J15143496+3104592',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000091,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.645583333,31.08308,0.033,NULL,60083966560,938811977,14668937,17.2),(128052,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128052,35.65,0.33,135,58642,70,NULL,NULL,'CGCG 077-049',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.000103,NULL,'14.7g',0.42,'S0',NULL,NULL,NULL,NULL,1,228.649666667,8.33394,0.045,NULL,59351837685,927372463,14490194,14.7),(128053,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128053,37.06,0.46,259,58643,70,NULL,NULL,'2MASX J15143710+2709060',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.39',0.16,NULL,NULL,NULL,NULL,NULL,1,228.6545,27.15172,0.077,NULL,59910392713,936099886,14626560,18.39),(128054,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128054,37.86,0.46,373,58644,70,NULL,NULL,'2MASX J15143787+2532450',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.6577917,25.54592,0.145,NULL,59896591890,935884248,14623191,17.5),(128055,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128055,39.03,0.46,640,58645,70,NULL,NULL,'SDSS J151439.59+021128.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.6649583,2.19119,0.053,NULL,56387508249,881054816,13766481,18.5),(128056,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128056,34.8,0.69,91,58646,100,NULL,'mid-IR','CGCG 165-035',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000015,NULL,'15.41',0.3,'S?',NULL,NULL,NULL,NULL,1,228.6657917,26.59419,0.097,NULL,59896191373,935877990,14623093,15.41),(128057,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128057,36.2,0.2,174,58646,74.4,NULL,NULL,'CGCG 165-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128058,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128058,37.9,0.27,380,58647,70,NULL,NULL,'2MASX J15144139+0153451',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.672583333,1.89575,0.089,NULL,56387670715,881057354,13766521,17.9),(128059,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128059,37.33,0.46,292,58648,70,NULL,NULL,'2MASX J15144231+1235425',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.676375,12.59503,0.097,NULL,59568757659,930761838,14543153,17.6),(128060,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128060,37.48,0.46,313,58649,70,NULL,NULL,'2MASX J15144301+1842394',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.67925,18.71092,0.097,NULL,59580208917,930940764,14545949,NULL),(128061,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128061,37.94,0.46,387,58650,70,NULL,NULL,'2MASX J15144455+5138106',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.685625,51.63633,0.025,NULL,59661073384,932204271,14565691,17.1),(128062,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128062,35.65,0.46,135,58651,70,NULL,NULL,'2MASX J15144460+0606351',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.6857083,6.10978,0.049,NULL,59328529492,927008273,14484504,16.3),(128063,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128063,37.65,0.33,339,58652,70,NULL,NULL,'2MASX J15144508+0323201',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,228.6879583,3.389,0.057,NULL,56383002133,880984408,13765381,16.3),(128064,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128064,38.01,0.33,401,58653,70,NULL,NULL,'SDSS J151446.66+284628.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.80',0.16,NULL,NULL,NULL,NULL,NULL,1,228.694417,28.77453,0.045,NULL,59909160744,936080636,14626259,18.8),(128065,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128065,34.72,0.52,87.8,58654,70,NULL,NULL,'2MASX J15144710-0932171',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'16.02',NULL,NULL,NULL,NULL,NULL,NULL,1,228.696166667,-9.53825,0.373,NULL,46486208488,726347007,11349171,16.02),(128066,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128066,35.59,0.46,131,58655,70,NULL,NULL,'2MASX J15144812+4339572',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.700708333,43.66594,0.029,NULL,59974571741,937102683,14642229,16.3),(128067,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128067,38.47,0.46,494,58656,70,NULL,NULL,'2MASX J15144852+4602332',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.702375,46.04247,0.033,NULL,59986361245,937286894,14645107,17.8),(128068,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128068,36.67,0.54,215,58657,70,NULL,NULL,'2MASX J15144894-0829061',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.83',NULL,NULL,NULL,NULL,NULL,NULL,1,228.703916667,-8.48517,0.321,NULL,46478932734,726233323,11347395,16.83),(128069,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128069,37.3,0.46,288,58658,70,NULL,NULL,'2MASX J15144924+5754265',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.7052083,57.90728,0.021,NULL,57720752587,901886759,14091980,17.3),(128070,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128070,37.1,0.27,263,58659,70,NULL,NULL,'2MASX J15144933+1017035',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000208,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,228.705667,10.28422,0.097,NULL,59357114936,927454920,14491483,15.5),(128071,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128071,37.46,0.27,311,58660,70,NULL,NULL,'2MASX J15144947+1516043',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.706125,15.26781,0.053,NULL,59572312315,930817379,14544021,16.9),(128072,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128072,37.94,0.17,387,58661,70,NULL,NULL,'2MASX J15145063+0350054',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.7110417,3.83464,0.041,NULL,56383850914,880997670,13765588,18.2),(128073,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128073,35.57,0.46,130,58662,70,NULL,NULL,'2MASX J15145064+3715095',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'15.7g',0.33,'S0',NULL,NULL,NULL,NULL,1,228.711125,37.25258,0.009,NULL,60109482726,939210667,14675166,15.7),(128074,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128074,38.41,0.46,481,58663,70,NULL,NULL,'2MASX J15145073+3535433',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.711583,35.59525,0.041,NULL,60107452067,939178938,14674670,17.8),(128075,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128075,38.24,0.46,444,58664,70,NULL,NULL,'2MASX J15145098+1859154',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.7124583,18.98758,0.109,NULL,59534137357,930220896,14534701,17.7),(128076,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128076,37.1,0.27,263,58665,70,NULL,NULL,'2MASX J15145170+1015305',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000067,NULL,'15.6g',0.49,NULL,NULL,NULL,NULL,NULL,1,228.715333,10.25847,0.073,NULL,59357107968,927454812,14491481,15.6),(128077,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128077,37.98,0.1,394,58666,70,NULL,NULL,'2MASX J15145182+0417374',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'16.5g',0.35,'E/S0',NULL,NULL,NULL,NULL,1,228.715833,4.29369,0.049,NULL,56383669523,880994836,13765544,16.5),(128078,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128078,37.98,0.1,394,58667,70,NULL,NULL,'2MASX J15145182+0407214',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00008,NULL,'17.6g',0.17,'S0',NULL,NULL,NULL,NULL,1,228.715958333,4.12269,0.045,NULL,56383996947,880999952,13765624,17.6),(128079,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128079,37.98,0.1,394,58668,70,NULL,NULL,'2MASX J15145390+0404234',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,228.7245,4.07317,0.045,NULL,56384002329,881000036,13765625,17.8),(128080,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128080,37.49,0.46,314,58669,70,NULL,NULL,'2MASX J15145480+2040474',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.728333,20.67972,0.133,NULL,59415771864,928371435,14505803,17.8),(128081,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128081,37.65,0.46,339,58670,70,NULL,NULL,'2MASX J15145540+0532465',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,228.730875,5.54622,0.077,NULL,59328569859,927008904,14484514,16.8),(128082,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128082,35.97,NULL,156,58671,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09782',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000081,NULL,'16.4g',0.21,'Sc',NULL,NULL,NULL,NULL,1,228.737583333,1.18789,0.097,NULL,56378292723,880910823,13764231,16.4),(128083,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128083,35.99,NULL,157,58671,NULL,NULL,'Dipole + Quadrupole','UGC 09782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128084,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128084,36,NULL,159,58671,NULL,NULL,'Dipole','UGC 09782',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128085,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128085,36.02,0.49,160,58671,75,NULL,'IR','UGC 09782',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128086,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128086,38.01,0.33,401,58672,70,NULL,NULL,'2MASX J15145974+2851024',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.57',0.22,'E',NULL,NULL,NULL,NULL,1,228.7487917,28.85067,0.045,NULL,59909147066,936080422,14626256,17.57),(128087,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128087,37.98,0.1,394,58673,70,NULL,NULL,'SDSS J151501.06+043358.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.754417,4.56625,0.053,NULL,56383660818,880994700,13765542,18.2),(128088,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128088,34.17,0.51,68.1,58674,70,NULL,NULL,'NGC 5880',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00006,NULL,'14.9b',0.3,'E1 or S0-',NULL,NULL,NULL,NULL,1,228.75475,-14.57903,0.485,NULL,46670681041,729229391,11394209,14.9),(128089,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128089,21.17,NULL,0.171,58675,NULL,NULL,NULL,'FGC 1869',NULL,'2000BSAO...50....5K',2000,1,1.15,NULL,'G',0.00007,NULL,'16.7g',0.13,'Sdm',NULL,NULL,NULL,NULL,1,228.760833,5.92817,0.077,1,59328682426,927010662,14484541,16.7),(128090,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128090,34.14,NULL,67.4,58675,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1869',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128091,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128091,34.15,NULL,67.6,58675,NULL,NULL,'Dipole + Quadrupole','FGC 1869',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128092,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128092,34.17,NULL,68.4,58675,NULL,NULL,'Dipole','FGC 1869',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128093,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128093,37.98,0.1,394,58676,70,NULL,NULL,'2MASX J15150292+0423465',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.762125,4.39611,0.053,NULL,56383673930,880994905,13765545,18.2),(128094,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128094,38.88,0.46,596,58677,70,NULL,NULL,'SDSS J151502.99+153540.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.7625,15.59447,0.061,NULL,59564783337,930699739,14542183,18.2),(128095,'Tully est','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128095,33,0.8,39.8,58678,75,NULL,'B','NGC 5899',NULL,'1988NBGC.C....0000T',1988,1,3.2,'The position in 1988BoPos.M...0000V is 5.5 arcsec south of the nucleus.','G',0.000017,NULL,'12.50',1.2,'SAB(rs)c       Sy2','in a pair',NULL,NULL,'AGN',1,228.763416667,42.04983,0.077,NULL,59973324254,937083191,14641924,12.5),(128096,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128096,32.35,0.46,29.5,58678,NULL,NULL,'J','NGC 5899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128097,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128097,32.39,0.47,30.1,58678,NULL,NULL,'H','NGC 5899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128098,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128098,32.4,0.45,30.2,58678,NULL,NULL,'K','NGC 5899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128099,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128099,32.67,0.4,34.2,58678,75,NULL,NULL,'NGC 5899',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128100,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128100,32.96,0.4,39.2,58678,NULL,NULL,'mean','NGC 5899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128101,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128101,32.99,0.49,39.7,58678,75,NULL,'IR','NGC 5899',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128102,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128102,33.02,0.4,40.2,58678,NULL,NULL,NULL,'NGC 5899',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128103,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128103,33.22,0.43,44,58678,75,NULL,'3.6 micron, color corrected','NGC 5899',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128104,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128104,33.28,0.2,45.3,58678,74.4,NULL,NULL,'NGC 5899',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128105,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128105,33.29,0.43,45.5,58678,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5899',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128106,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128106,33.32,0.4,46.2,58678,NULL,NULL,'Malmquist cor.','NGC 5899',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128107,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128107,33.47,0.37,49.4,58678,NULL,NULL,NULL,'NGC 5899',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128108,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128108,37.98,0.1,394,58679,70,NULL,NULL,'2MASX J15150372+0430315',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'17.1g',0.24,'S0',NULL,NULL,NULL,NULL,1,228.7655417,4.50875,0.053,NULL,56383696106,880995251,13765550,17.1),(128109,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128109,32.22,0.46,27.7,58680,NULL,NULL,'J','NGC 5885',NULL,'2007A&A...465...71T',2007,1,3.5,'This is a part of the galaxy NGC 5885.','G',0.000004,NULL,'12.50',3.1,'SAB(r)c        HII',NULL,NULL,NULL,NULL,1,228.767333333,-10.086,0.441,NULL,46489273357,726394896,11349920,12.5),(128110,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128110,32.27,0.45,28.4,58680,NULL,NULL,'K','NGC 5885',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128111,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128111,32.34,0.4,29.3,58680,NULL,NULL,'mean','NGC 5885',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128112,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128112,32.35,0.47,29.5,58680,NULL,NULL,'H','NGC 5885',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128113,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128113,32.44,0.4,30.7,58680,75,NULL,'B','NGC 5885',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128114,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128114,32.9,0.4,37.9,58681,NULL,NULL,'mean','NGC 5900',NULL,'2007A&A...465...71T',2007,1,1.49,'HOLM 702B is a star.','G',0.000027,NULL,'14.8g',0.55,'Sb: sp         HII','in a pair',NULL,NULL,NULL,1,228.7715,42.20942,0.049,NULL,59973000098,937078126,14641845,14.8),(128115,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128115,33.24,0.45,44.5,58681,NULL,NULL,'K','NGC 5900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128116,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128116,33.27,0.4,45,58681,75,NULL,NULL,'NGC 5900',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128117,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128117,33.33,0.43,46.3,58681,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5900',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128118,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128118,33.4,0.47,47.8,58681,NULL,NULL,'H','NGC 5900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128119,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128119,33.6,0.46,52.4,58681,NULL,NULL,'J','NGC 5900',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128120,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128120,33.69,0.43,54.7,58681,75,NULL,'3.6 micron, color corrected','NGC 5900',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128121,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128121,33.8,0.4,57.5,58681,NULL,NULL,NULL,'NGC 5900',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128122,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128122,34.1,0.2,66.1,58681,74.4,NULL,NULL,'NGC 5900',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128123,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128123,34.21,0.47,69.6,58681,NULL,NULL,NULL,'NGC 5900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128124,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128124,34.25,0.46,70.7,58681,NULL,NULL,'Malmquist cor.','NGC 5900',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128125,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128125,36.98,0.55,248,58682,70,NULL,NULL,'2MASX J15150615-3704445',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.77575,-37.07903,0.365,NULL,47191080092,737360626,11521259,15),(128126,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128126,37.65,0.33,339,58683,70,NULL,NULL,'2MASX J15150633+0332195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.776375,3.53861,0.057,NULL,56383222290,880987848,13765435,17.4),(128127,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128127,37.31,0.27,290,58684,70,NULL,NULL,'2MASX J15150679+0519435',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.778166667,5.32883,0.077,NULL,59329020495,927015945,14484624,17.2),(128128,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128128,37.35,0.46,295,58685,70,NULL,NULL,'SDSS J151506.80+283602.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.778333,28.60069,0.053,NULL,59909182641,936080978,14626265,18.2),(128129,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128129,37.24,0.46,281,58686,70,NULL,NULL,'2MASX J15150758+3529115',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.7814583,35.48644,0.033,NULL,60106907612,939170431,14674537,16.9),(128130,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128130,38.68,0.46,544,58687,70,NULL,NULL,'2MASX J15150758+3107085',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.7817083,31.11897,0.033,NULL,60083992965,938812390,14668943,18),(128131,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128131,37.82,0.46,366,58688,70,NULL,NULL,'2MASX J15150784+3015115',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.782667,30.25308,0.037,NULL,59904872304,936013629,14625212,17.3),(128132,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128132,37.7,0.46,346,58689,70,NULL,NULL,'2MASX J15150803+3116486',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,228.783458333,31.28003,0.029,NULL,60084146940,938814795,14668981,16.5),(128133,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128133,34.76,0.53,89.4,58690,70,NULL,NULL,'2MASX J15150818-4321380',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.784125,-43.36053,0.477,NULL,47072857640,735513400,11492396,14.6),(128134,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128134,36.56,0.46,205,58691,70,NULL,NULL,'2MASX J15150900+0330095',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000121,NULL,'15.6g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,228.787667,3.50258,0.057,NULL,56383225060,880987891,13765435,15.6),(128135,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128135,36.12,0.46,168,58692,70,NULL,NULL,'2MASX J15150914-0158057',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.36,'E0',NULL,NULL,NULL,NULL,1,228.788167,-1.96822,0.221,NULL,45381995327,709093676,11079588,16.4),(128136,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128136,37.13,0.46,267,58693,70,NULL,NULL,'2MASX J15150948+3515575',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.789625,35.266,0.041,NULL,60106887542,939170117,14674533,17.2),(128137,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128137,37.31,0.27,290,58694,70,NULL,NULL,'2MASX J15150953+0520375',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,228.78975,5.34375,0.077,NULL,59329020115,927015939,14484624,16.5),(128138,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128138,37.98,0.1,394,58695,70,NULL,NULL,'2MASX J15150967+0420585',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.6g',0.2,'E/S0',NULL,NULL,NULL,NULL,1,228.790417,4.34958,0.053,NULL,56383792640,880996760,13765574,17.6),(128139,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128139,36.13,0.09,168,58696,70,NULL,NULL,'CGCG 049-075',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000083,NULL,'15.3',NULL,NULL,NULL,NULL,NULL,NULL,1,228.795,5.57758,0.069,NULL,59328623467,927009741,14484527,15.3),(128140,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128140,37.31,0.27,290,58697,70,NULL,NULL,'2MASX J15151094+0512385',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,228.795625,5.21064,0.085,NULL,56380238883,880941232,13764706,16.7),(128141,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128141,37.94,0.17,387,58698,70,NULL,NULL,'2MASX J15151114+0350545',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000016,NULL,'15.9g',0.38,'AGN',NULL,NULL,NULL,NULL,1,228.796291667,3.8485,0.061,NULL,56383931232,880998925,13765608,15.9),(128142,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128142,37.58,0.33,328,58699,70,NULL,NULL,'2MASX J15151144-0032517',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.79775,-0.54767,0.173,NULL,45375837517,708997461,11078085,16.8),(128143,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128143,38.61,0.46,527,58700,70,NULL,NULL,'SDSS J151511.84+255209.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.799375,25.86939,0.153,NULL,59896672382,935885505,14623211,18.1),(128144,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128144,35.81,0.2,145,58701,74.4,NULL,NULL,'CGCG 135-037',NULL,'2013AJ....146...86T',2013,1,0.86,'GSC 2027-0289 (mag. 14) superposed 6\\\" south of nucleus.','G',0.000173,NULL,'15.5g',0.38,'S?',NULL,NULL,NULL,NULL,1,228.804167,25.00392,0.149,NULL,59410336731,928286511,14504476,15.5),(128145,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128145,35.44,0.52,123,58702,70,NULL,NULL,'2MASX J15151299-1252467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.15',NULL,NULL,NULL,NULL,NULL,NULL,1,228.8042083,-12.87975,0.461,NULL,46663916745,729123699,11392557,16.15),(128146,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128146,37.94,0.17,387,58703,70,NULL,NULL,'2MASX J15151301+0354025',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,228.804375,3.90058,0.061,NULL,56383964991,880999452,13765616,18.1),(128147,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128147,38.15,0.35,390,58704,60,NULL,'ABELL 2048, BCG','MCG +01-39-011',0.0945,'1980ApJ...241..486H',1980,1,0.46,NULL,'G',0.000083,NULL,'16.3g',0.39,'S0;BrClG','Brightest group member',NULL,NULL,NULL,1,228.808791667,4.38622,0.053,NULL,56383672489,880994882,13765545,16.3),(128148,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128148,37.98,0.1,394,58704,70,NULL,NULL,'MCG +01-39-011',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128149,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128149,37.94,0.17,387,58705,70,NULL,NULL,'SDSS J151514.69+035017.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000069,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.81125,3.83825,0.061,NULL,56383934096,880998970,13765608,18.2),(128150,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128150,36.15,0.46,170,58706,70,NULL,NULL,'2MASX J15151474+2427335',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.811541667,24.45933,0.097,NULL,59411125876,928298841,14504669,17.2),(128151,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128151,37.9,0.27,380,58707,70,NULL,NULL,'2MASX J15151528+0202455',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.8137917,2.04603,0.073,NULL,56384709971,881011093,13765798,17.8),(128152,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128152,37.41,0.46,303,58708,70,NULL,NULL,'2MASX J15151533+0940305',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.813917,9.67519,0.069,NULL,59353976704,927405886,14490716,17.3),(128153,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128153,36.58,0.46,207,58709,70,NULL,NULL,'2MASX J15151569+2704315',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.02',0.27,NULL,NULL,NULL,NULL,NULL,1,228.815417,27.0755,0.077,NULL,59910397201,936099956,14626561,17.02),(128154,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128154,37.91,0.46,383,58710,70,NULL,NULL,'SDSS J151516.30+035910.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.817958333,3.98625,0.061,NULL,56383976024,880999625,13765619,18),(128155,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128155,37.94,0.17,387,58711,70,NULL,NULL,'SDSS J151516.39+035615.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000083,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,228.818291667,3.93772,0.061,NULL,56383978483,880999663,13765619,18.7),(128156,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128156,37.17,0.46,272,58712,70,NULL,NULL,'2MASX J15151640+1750135',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.8184583,17.83719,0.081,NULL,59580689832,930948278,14546066,16.8),(128157,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128157,37.76,0.27,356,58713,70,NULL,NULL,'SDSS J151517.08+484408.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000145,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,228.8212083,48.73569,0.025,NULL,59940566073,936571344,14633927,18.5),(128158,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128158,37.72,0.46,350,58714,70,NULL,NULL,'2MASX J15151712+1423435',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.821375,14.3955,0.093,NULL,59575522648,930867541,14544805,16.8),(128159,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128159,37.98,0.1,394,58715,70,NULL,NULL,'2MASX J15151749+0423495',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000107,NULL,'16.7g',0.3,'E/S0',NULL,NULL,NULL,NULL,1,228.822917,4.39697,0.053,NULL,56383672322,880994880,13765545,16.7),(128160,'BCG','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128160,38.15,0.35,390,58716,60,NULL,NULL,'ABELL 2048',0.0945,'1980ApJ...241..486H',1980,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,228.824417,4.38225,0.053,NULL,56383791255,880996738,13765574,NULL),(128161,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128161,37.71,0.46,349,58717,70,NULL,NULL,'2MASX J15151800+0813097',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.824875,8.21939,0.053,NULL,59353002856,927390669,14490479,17.6),(128162,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128162,37.98,0.1,394,58718,70,NULL,NULL,'2MASX J15151817+0418374',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000096,NULL,'17.1g',0.23,'S0',NULL,NULL,NULL,NULL,1,228.825667,4.31031,0.053,NULL,56383794043,880996781,13765574,17.1),(128163,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128163,35.39,0.62,120,58719,70,NULL,NULL,'LCRS B151233.5-121327',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00012,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,228.8257917,-12.40883,0.473,NULL,46663959978,729124374,11392568,16.3),(128164,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128164,38.04,0.33,405,58720,70,NULL,NULL,'2MASX J15151851+0342074',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.827208333,3.70194,0.041,NULL,56383070157,880985471,13765397,17.2),(128165,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128165,38.18,0.46,433,58721,70,NULL,NULL,'2MASX J15151859+5446286',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.8277083,54.77475,0.013,NULL,57581000226,899703128,14057861,17.7),(128166,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128166,37.08,0.46,260,58722,70,NULL,NULL,'2MASX J15151920+2435415',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.41',0.26,NULL,NULL,NULL,NULL,NULL,1,228.830166667,24.59481,0.109,NULL,59411097912,928298404,14504662,17.41),(128167,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128167,36.16,0.46,170,58723,70,NULL,NULL,'2MASX J15151923+0543134',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000037,NULL,'16.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,228.8302083,5.72044,0.069,NULL,59328582568,927009102,14484517,16.6),(128168,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128168,37.42,0.46,305,58724,70,NULL,NULL,'2MASX J15151934+3049006',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.830625,30.81692,0.037,NULL,60083929326,938811395,14668928,17),(128169,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128169,36.41,0.46,192,58725,70,NULL,NULL,'2MASX J15151985+3518276',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000161,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,228.832917,35.30764,0.041,NULL,60106915910,939170561,14674540,16.3),(128170,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128170,37.98,0.1,394,58726,70,NULL,NULL,'2MASX J15152098+0421504',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000103,NULL,'17.0g',0.26,'E/S0',NULL,NULL,NULL,NULL,1,228.837417,4.36389,0.053,NULL,56383824340,880997255,13765582,17),(128171,'SNIa','2016-12-15 15:15:32','2016-12-16 11:20:46','1','SN 1963O','R',128171,35.25,NULL,112,58727,NULL,NULL,'Photographic','NGC 5905',NULL,'1988SSRv...48....1R',1988,1,4,NULL,'G',0.000017,NULL,'12.49',2.6,'SB(r)b;HII     Sy1','Pair member, radial velocity confirmed',NULL,NULL,'H II',1,228.847167,55.51736,0.017,NULL,57582715295,899729926,14058280,12.49),(128172,'Ring Diameter','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128172,32.6,0.84,33,58727,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5905',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128173,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128173,32.67,0.69,34.2,58727,100,NULL,'mid-IR','NGC 5905',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128174,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128174,33.13,0.52,42.3,58727,NULL,NULL,'Malmquist cor.','NGC 5905',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128175,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128175,33.27,0.48,45,58727,NULL,NULL,NULL,'NGC 5905',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128176,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128176,33.34,0.2,46.6,58727,74.4,NULL,NULL,'NGC 5905',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128177,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128177,33.4,0.45,47.9,58727,NULL,NULL,'K','NGC 5905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128178,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128178,33.43,0.46,48.5,58727,NULL,NULL,'J','NGC 5905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128179,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128179,33.44,0.47,48.8,58727,NULL,NULL,'H','NGC 5905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128180,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128180,33.57,0.4,51.8,58727,NULL,NULL,'mean','NGC 5905',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128181,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128181,37.58,0.46,328,58728,70,NULL,NULL,'SDSS J151523.42+284057.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.847625,28.68256,0.053,NULL,59909181648,936080963,14626265,18.5),(128182,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128182,37.58,0.33,328,58729,70,NULL,NULL,'SDSS J151523.61-003243.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,228.848417,-0.54542,0.173,NULL,45375843017,708997547,11078086,18.2),(128183,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128183,37.98,0.1,394,58730,70,NULL,NULL,'SDSS J151523.97+043115.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.849917,4.52106,0.053,NULL,56383651642,880994556,13765539,NULL),(128184,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128184,38.95,0.46,616,58731,70,NULL,NULL,'2MASX J15152444-0020248',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.5g',0.24,'NLAGN',NULL,NULL,NULL,NULL,1,228.851916667,-0.34019,0.161,NULL,45375765204,708996331,11078067,17.5),(128185,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128185,37.98,0.1,394,58732,70,NULL,NULL,'2MASX J15152466+0423474',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.8527083,4.3965,0.053,NULL,56383824502,880997257,13765582,18),(128186,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128186,37.98,0.46,394,58733,70,NULL,NULL,'2MASX J15152548+0801387',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.856333,8.0275,0.049,NULL,59353010516,927390789,14490481,17.8),(128187,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128187,38.05,0.17,407,58734,70,NULL,NULL,'SDSS J151525.55+015903.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.8564583,1.98428,0.073,NULL,56384702113,881010970,13765796,17.8),(128188,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128188,37.23,0.46,280,58735,70,NULL,NULL,'2MASX J15152584+1551535',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.64',0.4,NULL,NULL,NULL,NULL,NULL,1,228.857625,15.86497,0.041,NULL,59564828716,930700448,14542194,16.64),(128189,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128189,37.25,0.46,281,58736,70,NULL,NULL,'2MASX J15152588-0158388',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.85775,-1.97736,0.221,NULL,45378537978,709039655,11078744,17.7),(128190,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128190,37.77,0.33,358,58737,70,NULL,NULL,'2MASX J15152587+3154306',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.857833,31.90844,0.049,NULL,60084436668,938819322,14669051,17.1),(128191,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128191,37.37,0.27,298,58738,70,NULL,NULL,'2MASX J15152598+1700235',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,228.85825,17.00656,0.109,NULL,59567201561,930737524,14542773,16.9),(128192,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128192,36.99,0.46,250,58739,70,NULL,NULL,'2MASX J15152734+1752552',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.863917,17.882,0.081,NULL,59580692061,930948313,14546067,17.8),(128193,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128193,37.94,0.17,387,58740,70,NULL,NULL,'2MASX J15152740+0356214',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000115,NULL,'15.8g',0.42,'AGN',NULL,NULL,NULL,NULL,1,228.864083,3.93928,0.061,NULL,56383940588,880999071,13765610,15.8),(128194,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128194,38.37,0.46,473,58741,70,NULL,NULL,'2MASX J15152841+3343295',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,228.868583333,33.72489,0.057,NULL,60113110229,939267347,14676052,18.4),(128195,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128195,37.1,0.27,263,58742,70,NULL,NULL,'2MASX J15152863+1014518',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,228.8692917,10.24789,0.073,NULL,59357132542,927455195,14491487,16.6),(128196,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128196,37.09,0.46,262,58743,70,NULL,NULL,'2MASX J15152871+3121336',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00019,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,228.869666667,31.35931,0.029,NULL,60084176649,938815260,14668988,16.1),(128197,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128197,38.04,0.33,405,58744,70,NULL,NULL,'2MASX J15153020+0350054',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000123,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.876,3.83478,0.061,NULL,56383936593,880999009,13765609,16.9),(128198,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128198,36.13,0.63,168,58745,70,NULL,NULL,'2MASX J15153096-2153002',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.879041667,-21.88333,0.441,NULL,46616958253,728389972,11381093,15.6),(128199,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128199,37.36,0.33,296,58746,70,NULL,NULL,'2MASX J15153099+2826415',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.15',0.21,NULL,NULL,NULL,NULL,NULL,1,228.879041667,28.44494,0.049,NULL,59909310142,936082970,14626296,18.15),(128200,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128200,37.27,0.46,284,58747,70,NULL,NULL,'2MASX J15153166+2049423',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.80',0.19,NULL,NULL,NULL,NULL,NULL,1,228.8819583,20.82842,0.145,NULL,59415886618,928373228,14505831,17.8),(128201,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128201,34.06,0.51,64.8,58748,70,NULL,NULL,'2MASX J15153172-4353259',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.882083,-43.89053,0.609,NULL,47070727660,735480119,11491876,14.7),(128202,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128202,37.19,0.46,274,58749,70,NULL,NULL,'SDSS J151532.07-000020.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000071,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.883667,-0.00578,0.165,NULL,45375570099,708993282,11078020,18),(128203,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128203,37.2,0.27,276,58750,70,NULL,NULL,'2MASX J15153432+0137064',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.892875,1.61856,0.081,NULL,56384555179,881008674,13765760,16.6),(128204,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128204,37.98,0.1,394,58751,70,NULL,NULL,'SDSS J151534.57+042140.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000075,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.8940417,4.36136,0.053,NULL,56383828421,880997319,13765583,18.7),(128205,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128205,37.98,0.46,394,58752,70,NULL,NULL,'2MASX J15153500+4629360',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.8957083,46.49347,0.069,NULL,59986216084,937284626,14645072,17.1),(128206,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128206,36.34,0.57,185,58753,70,NULL,NULL,'2MFGC 12340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.896125,-21.89975,0.441,NULL,46616968670,728390135,11381095,15.5),(128207,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128207,37.36,0.33,296,58754,70,NULL,NULL,'2MASX J15153667+2826505',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.29',0.18,NULL,NULL,NULL,NULL,NULL,1,228.902791667,28.44731,0.049,NULL,59909312222,936083003,14626296,18.29),(128208,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128208,36.73,0.46,222,58755,70,NULL,NULL,'2MASX J15153668+1249285',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.91',0.45,NULL,NULL,NULL,NULL,NULL,1,228.902833,12.82464,0.089,NULL,59568683198,930760674,14543135,16.91),(128209,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128209,37.63,0.46,336,58756,70,NULL,NULL,'2MASX J15153718-0031098',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000092,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.9050417,-0.51947,0.221,NULL,45375724890,708995701,11078057,17),(128210,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128210,35.8,0.46,144,58757,70,NULL,NULL,'2MASX J15153770+2605495',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000364,NULL,'16.77',0.17,NULL,NULL,NULL,NULL,NULL,1,228.907333,26.09711,0.141,NULL,59896634764,935884918,14623201,16.77),(128211,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128211,37.98,0.1,394,58758,70,NULL,NULL,'2MASX J15153823+0420234',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000114,NULL,'17.2g',0.23,'E/S0',NULL,NULL,NULL,NULL,1,228.9092083,4.33978,0.053,NULL,56383831544,880997367,13765583,17.2),(128212,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128212,37.66,0.46,340,58759,70,NULL,NULL,'2MASX J15153823+2948405',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.89',0.15,NULL,NULL,NULL,NULL,NULL,1,228.909333,29.81133,0.037,NULL,59904915211,936014300,14625223,18.89),(128213,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128213,36.54,0.46,203,58760,70,NULL,NULL,'2MASX J15153830+0010324',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.909583,0.17561,0.157,NULL,56378224886,880909763,13764215,17.1),(128214,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128214,36.84,0.46,234,58761,70,NULL,NULL,'2MASX J15153839+3129574',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.910083333,31.49922,0.029,NULL,60084180576,938815321,14668989,16.7),(128215,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128215,37.53,0.46,320,58762,70,NULL,NULL,'2MASX J15153852+0515274',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.9104583,5.25767,0.077,NULL,56380813314,880950208,13764847,17.8),(128216,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128216,37.77,0.33,358,58763,70,NULL,NULL,'2MASX J15153904+3156324',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.70',0.23,NULL,NULL,NULL,NULL,NULL,1,228.9125,31.94225,0.049,NULL,60084426541,938819164,14669049,17.7),(128217,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128217,36.61,0.46,210,58764,70,NULL,NULL,'2MASX J15154086+5314545',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,228.920333,53.24833,0,NULL,59663138748,932236542,14566195,17),(128218,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128218,37.98,0.1,394,58765,70,NULL,NULL,'SDSS J151542.05+040543.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.92525,4.09542,0.081,NULL,56383991036,880999859,13765622,18),(128219,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128219,32.59,NULL,33,58766,72,NULL,NULL,'UGC 09787',NULL,'2014Ap.....57..457K',2014,1,1.1,NULL,'G',0.000033,NULL,'14.70',0.8,'SABm:',NULL,NULL,NULL,NULL,1,228.928667,1.4555,0.081,NULL,56378786906,880918545,13764352,14.7),(128220,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128220,37.26,0.46,283,58767,70,NULL,NULL,'2MASX J15154328+3104474',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.930417,31.07997,0.033,NULL,60083990219,938812347,14668942,17.5),(128221,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128221,36.86,0.46,236,58768,70,NULL,NULL,'2MASX J15154336+1308293',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,228.930583,13.14147,0.101,NULL,59573604016,930837562,14544336,17),(128222,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128222,36.48,0.33,198,58769,70,NULL,NULL,'2MASX J15154355+0258034',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.53',0.41,NULL,NULL,NULL,NULL,NULL,1,228.931333333,2.9675,0.069,NULL,56384505999,881007906,13765748,16.53),(128223,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128223,37.37,0.27,298,58770,70,NULL,NULL,'2MASX J15154373+1702033',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.80',0.46,NULL,NULL,NULL,NULL,NULL,1,228.932083,17.03425,0.109,NULL,59567208822,930737637,14542775,16.8),(128224,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128224,35.61,0.6,132,58771,70,NULL,NULL,'2MASX J15154537-3828501',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.9389583,-38.48058,0.293,NULL,47189076144,737329314,11520770,15.4),(128225,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128225,35.27,0.46,113,58772,70,NULL,NULL,'CGCG 077-051',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000237,NULL,'15.5',0.61,NULL,NULL,NULL,NULL,NULL,1,228.9399583,12.15997,0.089,NULL,59347545643,927305400,14489146,15.5),(128226,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128226,37.37,0.27,298,58773,70,NULL,NULL,'2MASX J15154673+1659573',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.944708333,16.99928,0.109,NULL,59567207005,930737609,14542775,17.1),(128227,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128227,36.13,0.09,168,58774,70,NULL,NULL,'SDSS J151547.43+065809.4',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000043,NULL,'15.1',0.29,NULL,'Group member',NULL,NULL,NULL,1,228.947666667,6.96928,0.041,NULL,59350269600,927347962,14489811,15.1),(128228,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128228,36.19,0.4,173,58775,NULL,NULL,'mean','UGC 09793',NULL,'2007A&A...465...71T',2007,1,1.37,NULL,'G',0.000009,NULL,'15.74',0.18,'Sbc',NULL,NULL,NULL,NULL,1,228.950417,18.37858,0.101,NULL,59580260739,930941574,14545962,15.74),(128229,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128229,36.21,NULL,175,58775,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09793',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128230,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128230,36.23,NULL,176,58775,NULL,NULL,'Dipole + Quadrupole','UGC 09793',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128231,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128231,36.24,NULL,177,58775,NULL,NULL,NULL,'UGC 09793',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128232,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128232,36.25,0.49,178,58775,75,NULL,'IR','UGC 09793',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128233,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128233,36.26,NULL,178,58775,NULL,NULL,'Dipole','UGC 09793',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128234,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128234,36.36,0.47,187,58775,NULL,NULL,'H','UGC 09793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128235,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128235,36.43,0.45,193,58775,NULL,NULL,'K','UGC 09793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128236,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128236,36.83,0.2,232,58775,74.4,NULL,NULL,'UGC 09793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128237,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128237,37.97,0.46,393,58776,70,NULL,NULL,'2MASX J15155010+2801024',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.75',0.16,NULL,NULL,NULL,NULL,NULL,1,228.9587083,28.01733,0.069,NULL,59909132363,936080193,14626253,18.75),(128238,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128238,38.52,0.46,506,58777,70,NULL,NULL,'2MASX J15155028+2641204',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'BrClG',NULL,NULL,NULL,NULL,1,228.959458333,26.68903,0.093,NULL,59910109089,936095454,14626491,NULL),(128239,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128239,35.42,0.59,121,58778,70,NULL,NULL,'2MASX J15155036-3909008',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,228.96,-39.15025,0.257,NULL,47187348366,737302318,11520348,13.8),(128240,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128240,37.2,0.27,276,58779,70,NULL,NULL,'2MASX J15155059+0133421',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.80',0.34,NULL,NULL,NULL,NULL,NULL,1,228.960666667,1.56181,0.081,NULL,56376954038,880889906,13763904,16.8),(128241,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128241,37.76,0.46,356,58780,70,NULL,NULL,'2MASX J15155056+2448214',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000195,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.96075,24.80581,0.121,NULL,59410422087,928287845,14504497,17.1),(128242,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128242,37.61,0.46,333,58781,70,NULL,NULL,'SDSS J151550.66+062031.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000047,NULL,'17.5R',0.14,NULL,NULL,NULL,NULL,NULL,1,228.961083,6.34203,0.033,NULL,59382977101,927859017,14497797,17.5),(128243,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128243,37.39,0.33,301,58782,70,NULL,NULL,'2MASX J15155092+1531193',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.962333,15.52194,0.065,NULL,59572240725,930816261,14544004,16.8),(128244,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128244,36.97,0.46,248,58783,70,NULL,NULL,'2MASX J15155121+0208261',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.963375,2.1405,0.093,NULL,56384725780,881011340,13765802,16.7),(128245,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128245,36.13,0.09,168,58784,70,NULL,NULL,'2MASX J15155149+0701008',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000036,NULL,'15.30',0.6,'S0','Group member',NULL,NULL,NULL,1,228.964583,7.01694,0.041,NULL,59350264128,927347877,14489810,15.3),(128246,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128246,36.29,0.25,181,58784,74.4,NULL,NULL,'2MASX J15155149+0701008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128247,'FP','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128247,38,0.46,399,58785,70,NULL,NULL,'2MASX J15155189+4904296',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00016,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,228.966125,49.075,0.033,NULL,59940380685,936568448,14633882,17.1),(128248,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128248,34.81,0.5,91.5,58786,NULL,NULL,'Malmquist cor.','ESO 328- G 037',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'13.03',0.7,'Sb',NULL,NULL,NULL,NULL,1,228.9687917,-40.10442,0.117,NULL,47187619913,737306561,11520415,13.03),(128249,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128249,34.87,0.49,94.3,58786,NULL,NULL,NULL,'ESO 328- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128250,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128250,34.91,0.2,95.9,58786,74.4,NULL,NULL,'ESO 328- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128251,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128251,35.25,0.4,112,58786,NULL,NULL,'mean','ESO 328- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128252,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128252,35.4,0.47,120,58786,NULL,NULL,'H','ESO 328- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128253,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128253,31.13,0.1,16.8,58787,NULL,NULL,'I','NGC 5907',NULL,'2011ApJS..195...18R',2011,1,12.77,'NGC 5906 is the part of NGC 5907 west of the dust lane.','G',0.00001,NULL,'11.12',1.4,'SA(s)c: sp     HII:','X-ray-faint group member',NULL,NULL,NULL,1,228.974041667,56.32878,0.013,NULL,57582416133,899725252,14058207,11.12),(128254,'TRGB','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128254,31.17,0.09,17.1,58787,74.4,NULL,NULL,'NGC 5907',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128255,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128255,30.52,0.27,12.7,58787,NULL,NULL,NULL,'NGC 5907',NULL,'2000AJ....119.1701Z',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128256,'IRAS','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128256,30.86,0.8,14.9,58787,75,NULL,'A82, H','NGC 5907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128257,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128257,30.32,NULL,11.6,58787,75,NULL,'CO','NGC 5907',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128258,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128258,30.4,NULL,12,58787,75,NULL,'HI','NGC 5907',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128259,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,'R',128259,30.57,0.4,13,58787,75,NULL,NULL,'NGC 5907',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128260,'Tully-Fisher','2016-12-15 15:15:32','2016-12-16 11:20:46','1',NULL,NULL,128260,30.64,0.35,13.4,58787,NULL,NULL,NULL,'NGC 5907',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128261,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128261,30.86,0.4,14.9,58787,75,NULL,'B','NGC 5907',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128262,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128262,30.87,0.31,14.9,58787,NULL,NULL,NULL,'NGC 5907',NULL,'2000AJ....119.1701Z',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128263,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128263,30.91,0.4,15.2,58787,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 5907',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128264,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128264,31.08,0.43,16.5,58787,75,NULL,'3.6 micron, color corrected','NGC 5907',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128265,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128265,31.1,0.43,16.6,58787,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5907',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128266,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128266,31.15,NULL,17,58787,NULL,NULL,'Dipole','NGC 5907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128267,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128267,31.16,NULL,17.1,58787,NULL,NULL,'Dipole + Quadrupole','NGC 5907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128268,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128268,31.16,NULL,17.1,58787,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128269,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128269,31.17,0.47,17.1,58787,75,NULL,'A82, H, raw','NGC 5907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128270,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128270,31.17,0.09,17.1,58787,74.4,NULL,NULL,'NGC 5907',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128271,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128271,31.24,NULL,17.7,58787,NULL,NULL,NULL,'NGC 5907',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128272,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128272,31.37,0.47,18.8,58787,75,NULL,'A82, H, inv','NGC 5907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128273,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128273,31.48,0.47,19.8,58787,75,NULL,'A82, H, cor','NGC 5907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128274,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128274,37.77,0.46,359,58788,70,NULL,NULL,'2MASX J15155426+1815193',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,228.9760417,18.25531,0.081,NULL,59580284028,930941937,14545967,16.3),(128275,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128275,37.72,0.33,350,58789,70,NULL,NULL,'SDSS J151554.59+475355.1',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.9775,47.89867,0.041,NULL,59937353658,936521150,14633142,16.7),(128276,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128276,38.05,0.17,407,58790,70,NULL,NULL,'SDSS J151554.88+020029.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.978667,2.00825,0.073,NULL,56384812038,881012688,13765823,17.6),(128277,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128277,37.68,0.46,344,58791,70,NULL,NULL,'2MASX J15155545+1413234',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,228.981,14.22308,0.097,NULL,59575576779,930868387,14544818,NULL),(128278,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128278,37.87,0.46,375,58792,70,NULL,NULL,'2MASX J15155621+0535331',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.98425,5.59244,0.069,NULL,56379940253,880936566,13764633,17.1),(128279,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128279,37.2,0.27,276,58793,70,NULL,NULL,'2MASX J15155633+0129551',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,228.98475,1.49869,0.081,NULL,56378799980,880918749,13764355,16.7),(128280,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128280,37.72,0.33,350,58794,70,NULL,NULL,'2MASX J15155463+4753551',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,228.9874583,47.90153,0.041,NULL,59937353121,936521142,14633142,18.6),(128281,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128281,37.83,0.46,368,58795,70,NULL,NULL,'2MASX J15155718+0041441',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000096,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,228.988125,0.69564,0.125,NULL,56378526530,880914477,13764288,16.8),(128282,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128282,38.09,0.46,415,58796,70,NULL,NULL,'SDSS J151557.27+191856.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,228.988625,19.31569,0.105,NULL,59534079620,930219994,14534687,18.6),(128283,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128283,37.18,0.46,273,58797,70,NULL,NULL,'2MASX J15155803+1943133',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,228.9917083,19.72033,0.109,NULL,59412919966,928326874,14505107,16.9),(128284,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128284,38.05,0.17,407,58798,70,NULL,NULL,'2MASX J15155808+0200211',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,228.9920417,2.00597,0.073,NULL,56384800901,881012514,13765820,17.8),(128285,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128285,38.13,0.46,422,58799,70,NULL,NULL,'2MASX J15155861-0034452',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,228.994167,-0.57922,0.221,NULL,45375694968,708995233,11078050,18.4),(128286,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128286,35.57,0.66,130,58800,70,NULL,NULL,'2MASX J15155892-0801291',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,228.995583333,-8.02475,0.321,NULL,46480951987,726264874,11347888,15),(128287,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128287,37.65,0.46,340,58801,70,NULL,NULL,'2MASX J15155953+2156330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,228.998125,21.94264,0.145,NULL,59415036465,928359944,14505624,18),(128288,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128288,36.05,0.46,162,58802,70,NULL,NULL,'2MASX J15155957+0739538',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.1g',0.35,NULL,'Group member',NULL,NULL,NULL,1,228.998166667,7.66481,0.049,NULL,59350083180,927345049,14489766,16.1),(128289,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128289,37.78,0.46,360,58803,70,NULL,NULL,'2MASX J15155980+5153176',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.9995417,51.88828,0.033,NULL,59660910301,932201723,14565651,17),(128290,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128290,37.5,0.46,317,58804,70,NULL,NULL,'2MASX J15155988+3019424',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,228.999666667,30.32833,0.017,NULL,59904837217,936013081,14625204,17.4),(128291,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128291,37.69,0.46,345,58805,70,NULL,NULL,'2MASX J15160025+0344421',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.001,3.74508,0.061,NULL,56383058266,880985285,13765395,16.9),(128292,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128292,36.05,0.8,162,58806,75,NULL,'CF, r','UGC 09800',NULL,'1997ApJS..109..333W',1997,1,1.11,'1997AJ....114.2402C has z = 0.0452.','G',0.00016,NULL,'14.7g',0.56,'Sb',NULL,NULL,NULL,NULL,1,229.003875,54.48228,0.013,NULL,59662357867,932224341,14566005,14.7),(128293,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128293,36.26,0.38,178,58806,75,NULL,'CF, r, raw','UGC 09800',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128294,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128294,36.49,0.38,199,58806,75,NULL,'CF, r, cor','UGC 09800',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128295,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128295,36.52,0.38,201,58806,75,NULL,'CF, r, inv','UGC 09800',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128296,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128296,37.91,0.46,382,58807,70,NULL,NULL,'2MASX J15160105+5740003',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000082,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.004625,57.66667,0.025,NULL,57720876306,901888692,14092010,17.1),(128297,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128297,38.05,0.17,407,58808,70,NULL,NULL,'2MASX J15160135+0201001',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.92',NULL,'BrClG          AGN',NULL,NULL,NULL,'Sy',1,229.0057083,2.01672,0.073,NULL,56384812461,881012694,13765823,16.92),(128298,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128298,37.33,0.58,293,58809,70,NULL,NULL,'2MASX J15160189-0829541',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.80',NULL,NULL,NULL,NULL,NULL,NULL,1,229.00775,-8.4985,0.317,NULL,46480370422,726255787,11347746,16.8),(128299,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128299,37.4,0.33,301,58810,70,NULL,NULL,'2MASX J15160230+2912424',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.009667,29.21178,0.033,NULL,59904537284,936008395,14625131,NULL),(128300,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128300,35.84,0.46,147,58811,70,NULL,NULL,'2MASX J15160242+0447291',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,229.010041667,4.79147,0.057,NULL,56380682283,880948160,13764815,16),(128301,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128301,36.46,0.78,196,58812,70,NULL,NULL,'LCRS B151323.4-062635',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.58',NULL,NULL,NULL,NULL,NULL,NULL,1,229.012375,-6.62719,0.245,NULL,46477187267,726206051,11346969,15.58),(128302,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128302,37.51,0.46,317,58813,70,NULL,NULL,'2MASX J15160353+2556194',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.45',0.15,NULL,NULL,NULL,NULL,NULL,1,229.014708333,25.93889,0.153,NULL,59895782874,935871607,14622993,18.45),(128303,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128303,36.11,0.46,167,58814,70,NULL,NULL,'2MASX J15160443+0510081',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.018583,5.16883,0.081,NULL,56380792844,880949888,13764842,16.6),(128304,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128304,37.62,0.33,334,58815,70,NULL,NULL,'2MASX J15160505+4605111',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.0212083,46.08636,0.049,NULL,59986386677,937287291,14645113,17.5),(128305,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128305,36.74,0.46,222,58816,70,NULL,NULL,'2MASX J15160517+3217074',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.0215,32.28556,0.049,NULL,60084371073,938818298,14669035,17.5),(128306,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128306,37.96,0.33,390,58817,70,NULL,NULL,'2MASX J15160525+2732124',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.87',0.13,NULL,NULL,NULL,NULL,NULL,1,229.021875,27.53672,0.077,NULL,59910539115,936102173,14626596,18.87),(128307,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128307,37.51,0.33,318,58818,70,NULL,NULL,'SDSS J151606.51+154338.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.027125,15.72744,0.065,NULL,59564839709,930700620,14542197,18.2),(128308,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128308,37.35,0.46,295,58819,70,NULL,NULL,'2MASX J15160675+1723374',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.02825,17.39358,0.105,NULL,59563827131,930684798,14541949,16.7),(128309,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128309,37.39,0.33,301,58820,70,NULL,NULL,'2MASX J15160794+1527313',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.033167,15.45867,0.061,NULL,59572255137,930816486,14544007,17.2),(128310,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128310,38.05,0.17,407,58821,70,NULL,NULL,'SDSS J151608.32+020756.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.034666667,2.13233,0.093,NULL,56384755131,881011798,13765809,NULL),(128311,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128311,37.96,0.33,390,58822,70,NULL,NULL,'2MASX J15160901+2729194',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.17,NULL,NULL,NULL,NULL,NULL,1,229.0375,27.48864,0.077,NULL,59910616455,936103382,14626615,18.6),(128312,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128312,36.13,0.09,168,58823,70,NULL,NULL,'I Zw 104',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.3',0.32,NULL,NULL,NULL,NULL,NULL,1,229.0392917,6.01514,0.069,NULL,59328493426,927007709,14484495,17.3),(128313,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128313,38.2,0.46,436,58824,70,NULL,NULL,'2MASX J15160980+4131511',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.0407917,41.531,0.013,NULL,59971570163,937055783,14641496,17.7),(128314,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128314,35.27,0.52,113,58825,NULL,NULL,NULL,'ESO 328- G 039',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.7b',0.5,'S...',NULL,NULL,NULL,NULL,1,229.040875,-41.82411,0.437,NULL,47067457767,735429027,11491078,15.7),(128315,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128315,35.31,0.51,115,58825,NULL,NULL,'Malmquist cor.','ESO 328- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128316,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128316,35.31,0.2,115,58825,74.4,NULL,NULL,'ESO 328- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128317,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128317,35.76,0.25,142,58826,74.4,NULL,NULL,'GIN 422',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000047,NULL,'14.97',0.6,'S','Group member',NULL,NULL,NULL,1,229.0407917,6.96458,0.041,NULL,59350313398,927348646,14489822,14.97),(128318,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128318,35.99,0.21,158,58826,70,NULL,NULL,'GIN 422',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128319,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128319,38.3,0.46,456,58827,70,NULL,NULL,'SDSS J151609.87+311307.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.041166667,31.21867,0.017,NULL,60083946984,938811671,14668932,18.6),(128320,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128320,35.76,0.25,142,58828,74.4,NULL,NULL,'GIN 423',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.00004,NULL,'15.9g',0.38,'S','Group member',NULL,NULL,NULL,1,229.041375,6.95153,0.041,NULL,59350259229,927347800,14489809,15.9),(128321,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128321,35.99,0.21,158,58828,70,NULL,NULL,'GIN 423',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128322,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128322,36.98,0.33,249,58829,70,NULL,NULL,'SDSS J151609.94+451245.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.041417,45.21272,0.041,NULL,59985254483,937269601,14644837,17.4),(128323,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128323,37.48,0.23,314,58830,70,NULL,NULL,'2MASX J15160990+5701563',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000095,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,229.041417,57.0325,0.017,NULL,57588902324,899826598,14059790,16.5),(128324,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128324,38.28,0.46,453,58831,70,NULL,NULL,'2MASX J15161017+0027411',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.042375,0.46139,0.145,NULL,56378110887,880907982,13764187,16.7),(128325,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128325,37.52,0.46,319,58832,70,NULL,NULL,'2MASX J15161077+2948064',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00023,NULL,'18.40',0.19,'E',NULL,NULL,NULL,NULL,1,229.045,29.80178,0.029,NULL,59904945808,936014778,14625230,18.4),(128326,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128326,34.34,0.49,74,58833,75,NULL,'IR','UGC 09794',NULL,'2011yCatp016004901K',2011,1,3,NULL,'G',0.000023,NULL,'13.50',0.9,'SBdm:','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,229.045291667,10.50964,0.085,NULL,59357177647,927455900,14491498,13.5),(128327,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128327,34.51,0.2,79.8,58833,74.4,NULL,NULL,'UGC 09794',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128328,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128328,34.62,0.47,84.1,58833,NULL,NULL,NULL,'UGC 09794',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128329,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128329,34.65,0.46,85.2,58833,NULL,NULL,'Malmquist cor.','UGC 09794',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128330,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128330,38.1,0.46,417,58834,70,NULL,NULL,'SDSS J151611.98+062337.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00005,NULL,'18.0g',0.15,NULL,'Group member',NULL,NULL,NULL,1,229.0499583,6.39381,0.065,NULL,59382987543,927859180,14497799,18),(128331,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128331,36.98,0.33,249,58835,70,NULL,NULL,'2MASX J15161248+4513590',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000196,NULL,'15.8g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,229.052083,45.23306,0.041,NULL,59985323259,937270675,14644854,15.8),(128332,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128332,35.37,0.68,119,58836,70,NULL,NULL,'2MASX J15161274-4403377',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.053208333,-44.06042,0.669,NULL,47070757567,735480586,11491884,15.9),(128333,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128333,37.76,0.27,356,58837,70,NULL,NULL,'2MASX J15161443+4843437',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000191,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,229.0600417,48.72883,0.025,NULL,59940468775,936569824,14633903,16.5),(128334,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128334,38.37,0.46,473,58838,70,NULL,NULL,'2MASX J15161481+0145281',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.061625,1.75786,0.089,NULL,56376988176,880890440,13763913,17.7),(128335,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128335,34.88,0.46,94.6,58839,70,NULL,NULL,'CGCG 077-053',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000107,NULL,'15.1g',0.44,NULL,NULL,NULL,NULL,NULL,1,229.0622917,8.69442,0.045,NULL,59352660464,927385319,14490395,15.1),(128336,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128336,38.08,0.33,414,58840,70,NULL,NULL,'2MASX J15161509+2924494',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.13',0.19,NULL,NULL,NULL,NULL,NULL,1,229.062958333,29.41361,0.029,NULL,59904443227,936006925,14625108,17.13),(128337,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128337,36.13,0.09,168,58841,70,NULL,NULL,'CGCG 049-081',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00004,NULL,'15.3',0.33,'S0','Group member',NULL,NULL,NULL,1,229.0639583,6.79653,0.041,NULL,59349594848,927337419,14489647,15.3),(128338,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128338,37.49,0.46,315,58842,70,NULL,NULL,'2MASX J15161662+1202477',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.069208333,12.04658,0.093,NULL,59347346819,927302294,14489098,17.3),(128339,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128339,38.05,0.17,407,58843,70,NULL,NULL,'2MASX J15161676+0210367',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.0699583,2.17697,0.093,NULL,56384765069,881011954,13765811,17.3),(128340,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128340,38.05,0.17,407,58844,70,NULL,NULL,'2MASX J15161756+0204107',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.073167,2.06969,0.093,NULL,56384806739,881012605,13765821,18),(128341,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128341,37.86,0.46,373,58845,70,NULL,NULL,'2MASX J15161795+1413127',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.074958333,14.22019,0.097,NULL,59575575712,930868370,14544818,17.7),(128342,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128342,37.91,0.46,381,58846,70,NULL,NULL,'2MASX J15161816+1901231',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.0757917,19.02317,0.129,NULL,59534200689,930221885,14534716,16.9),(128343,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128343,36.48,0.33,198,58847,70,NULL,NULL,'2MASX J15161841+0304017',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000145,NULL,'15.5g',0.41,'E0',NULL,NULL,NULL,NULL,1,229.076583,3.06714,0.069,NULL,56382558964,880977483,13765273,15.5),(128344,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128344,34.58,0.49,82.4,58848,75,NULL,'IR','CGCG 135-039',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.00003,NULL,'15.1',0.15,'S',NULL,NULL,NULL,NULL,1,229.079,24.86728,0.125,NULL,59410474790,928288668,14504510,15.1),(128345,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128345,37.89,0.19,378,58849,70,NULL,NULL,'2MASX J15162077+1848531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.0865,18.81475,0.113,NULL,59533987004,930218546,14534664,17.1),(128346,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128346,37.51,0.33,318,58850,70,NULL,NULL,'2MASX J15162082+1544247',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.086917,15.74028,0.065,NULL,59564671178,930697987,14542156,17),(128347,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128347,38.08,0.33,414,58851,70,NULL,NULL,'2MASX J15162207+2924111',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000257,NULL,'16.59',0.17,'S0',NULL,NULL,NULL,NULL,1,229.092167,29.40308,0.029,NULL,59904442876,936006919,14625108,16.59),(128348,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128348,37.4,0.33,301,58852,70,NULL,NULL,'2MASX J15162219+2906591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.66',0.16,NULL,NULL,NULL,NULL,NULL,1,229.092625,29.11639,0.037,NULL,59904544760,936008511,14625132,18.66),(128349,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128349,37.63,0.46,335,58853,70,NULL,NULL,'2MASX J15162240+2711491',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.15',0.19,NULL,NULL,NULL,NULL,NULL,1,229.093333,27.19697,0.069,NULL,59910413186,936100206,14626565,18.15),(128350,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128350,36.86,0.46,236,58854,70,NULL,NULL,'2MASX J15162308-0018056',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000107,NULL,'16.3g',0.35,'E0',NULL,NULL,NULL,NULL,1,229.09625,-0.30144,0.209,NULL,45375589365,708993583,11078024,16.3),(128351,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128351,37.16,0.65,270,58854,70,NULL,NULL,'2MASX J15162308-0018056',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128352,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128352,37.37,0.46,298,58855,70,NULL,NULL,'2MASX J15162331+1445137',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'15.27',0.17,NULL,NULL,NULL,NULL,NULL,1,229.097125,14.75381,0.053,NULL,59575179633,930862181,14544721,15.27),(128353,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128353,35.34,0.63,117,58856,70,NULL,NULL,'2MASX J15162371-3710247',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.098791667,-37.1735,0.381,NULL,47191124012,737361312,11521270,14.9),(128354,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128354,37.22,0.46,278,58857,70,NULL,NULL,'2MASX J15162377-0151476',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.0989583,-1.86314,0.229,NULL,45378471192,709038612,11078728,17.3),(128355,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128355,38.3,0.27,458,58858,70,NULL,NULL,'2MASX J15162438+0122337',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.1017083,1.37597,0.113,NULL,56378835223,880919300,13764364,17.1),(128356,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128356,36.34,0.46,185,58859,70,NULL,NULL,'2MASX J15162544+1425267',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.42',0.43,NULL,NULL,NULL,NULL,NULL,1,229.106083333,14.42397,0.093,NULL,59575534643,930867728,14544808,16.42),(128357,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128357,36.13,0.09,168,58860,70,NULL,NULL,'2MASX J15162562+0712552',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000047,NULL,'14.9',0.26,'S0','Group member',NULL,NULL,NULL,1,229.106625,7.21539,0.049,NULL,59350289817,927348278,14489816,14.9),(128358,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128358,38.13,0.46,423,58861,70,NULL,NULL,'SDSS J151626.39+334300.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.1099583,33.71692,0.017,NULL,60113207025,939268859,14676075,18.2),(128359,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128359,36.4,0.71,191,58862,70,NULL,NULL,'2MASX J15162665-3811585',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.1109583,-38.19956,0.333,NULL,47190390355,737349849,11521091,15.4),(128360,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128360,36.72,0.46,221,58863,70,NULL,NULL,'2MASX J15162688+3525556',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.112125,35.432,0.013,NULL,60106819570,939169055,14674516,16.8),(128361,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128361,36.43,0.46,193,58864,70,NULL,NULL,'2MASX J15162700+0023037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.1125,0.38425,0.145,NULL,56378098293,880907785,13764184,16.8),(128362,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128362,37.43,0.46,306,58865,70,NULL,NULL,'2MASX J15162745+2734121',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.114375,27.57,0.077,NULL,59910544617,936102259,14626597,NULL),(128363,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128363,36.13,0.09,168,58866,70,NULL,NULL,'2MASX J15162830+0606532',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00011,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.117875,6.11489,0.065,NULL,59328434813,927006793,14484481,16.7),(128364,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128364,37.46,0.46,310,58867,70,NULL,NULL,'2MASX J15162832+5808461',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000065,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.1180417,58.14603,0.021,NULL,57721362788,901896293,14092129,17.7),(128365,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128365,38.1,0.46,416,58868,70,NULL,NULL,'SDSS J151629.72+073737.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000119,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.123833333,7.62719,0.049,NULL,59350061333,927344708,14489761,18.7),(128366,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128366,37.29,0.46,287,58869,70,NULL,NULL,'2MASX J15163047+1104332',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.127,11.07589,0.113,NULL,59356041090,927438142,14491220,18),(128367,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128367,36.13,0.09,168,58870,70,NULL,NULL,'2MASX J15163072+0657062',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000047,NULL,'16.4g',0.29,NULL,'Group member',NULL,NULL,NULL,1,229.127875,6.95189,0.041,NULL,59350280670,927348135,14489814,16.4),(128368,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128368,37.72,0.46,349,58871,70,NULL,NULL,'2MASX J15163086+1353287',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.1287083,13.89125,0.097,NULL,59573428971,930834827,14544294,17.8),(128369,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128369,37.02,0.46,253,58872,70,NULL,NULL,'2MASX J15163094+2712301',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.85',0.22,NULL,NULL,NULL,NULL,NULL,1,229.129,27.20847,0.069,NULL,59910628775,936103574,14626618,17.85),(128370,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128370,36.26,0.49,178,58873,75,NULL,'IR','UGC 09795',NULL,'2011yCatp016004901K',2011,1,1.49,NULL,'G',0.000137,NULL,'15.1g',0.4,'Sab','Group member',NULL,NULL,NULL,1,229.131875,7.74375,0.049,NULL,59352930169,927389533,14490461,15.1),(128371,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128371,37.15,0.27,269,58874,70,NULL,NULL,'2MASX J15163237+1025272',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.134833,10.42422,0.085,NULL,59357171253,927455800,14491496,16.1),(128372,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128372,35.09,0.46,104,58875,70,NULL,NULL,'CGCG 077-056',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000167,NULL,'15.3',0.53,NULL,NULL,NULL,NULL,NULL,1,229.1355,12.75419,0.089,NULL,59572896554,930826508,14544164,15.3),(128373,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128373,36.13,0.09,168,58876,70,NULL,NULL,'2MASX J15163294+0653382',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00005,NULL,'14.8',0.29,'S0','Group member',NULL,NULL,NULL,1,229.137333333,6.89397,0.041,NULL,59350278446,927348100,14489814,14.8),(128374,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128374,37.3,0.46,289,58877,70,NULL,NULL,'2MASX J15163322+3214376',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.138375,32.24394,0.017,NULL,60084358860,938818107,14669032,16.6),(128375,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128375,37.15,0.27,269,58878,70,NULL,NULL,'2MASX J15163325+1016592',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.1385417,10.28317,0.077,NULL,59357563764,927461933,14491592,17.4),(128376,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128376,37.06,0.33,258,58879,70,NULL,NULL,'2MASX J15163382+2431581',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000175,NULL,'18.28',0.16,NULL,NULL,NULL,NULL,NULL,1,229.141166667,24.53272,0.109,NULL,59410357712,928286839,14504481,18.28),(128377,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128377,37.44,0.46,308,58880,70,NULL,NULL,'2MASX J15163448+2639351',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.1437083,26.65983,0.093,NULL,59910119315,936095614,14626493,18.1),(128378,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128378,38.29,0.33,456,58881,70,NULL,NULL,'SDSS J151634.72+024750.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.144708333,2.79739,0.069,NULL,56384973124,881015205,13765862,18.2),(128379,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128379,37.53,0.46,320,58882,70,NULL,NULL,'2MASX J15163507+3119116',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.1460417,31.32003,0.021,NULL,60084030945,938812983,14668952,16.9),(128380,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128380,37.31,0.46,290,58883,70,NULL,NULL,'2MASX J15163587+0009597',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.1495,0.16661,0.145,NULL,56378057379,880907146,13764174,17.5),(128381,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128381,37.06,0.33,258,58884,70,NULL,NULL,'2MASX J15163602+2434241',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.149916667,24.57322,0.109,NULL,59410354607,928286790,14504481,18),(128382,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128382,34.89,0.49,94.9,58885,70,NULL,NULL,'2MASX J15163602-7135139',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.1502083,-71.58719,0.593,NULL,45031262035,703613469,10993960,14.7),(128383,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128383,37.89,0.19,378,58886,70,NULL,NULL,'2MASX J15163614+1847033',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.1505417,18.78433,0.113,NULL,59533989938,930218592,14534665,18),(128384,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128384,37.76,0.27,356,58887,70,NULL,NULL,'2MASX J15163668+4841140',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.152833,48.68725,0.033,NULL,59940470753,936569855,14633903,16.8),(128385,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128385,36.13,0.09,168,58888,70,NULL,NULL,'2MASX J15163717+0657552',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'17.40',0.2,'S0','Group member',NULL,NULL,NULL,1,229.155,6.96533,0.045,NULL,59350281049,927348141,14489814,17.4),(128386,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128386,38.19,0.46,434,58889,70,NULL,NULL,'SDSS J151637.58+544333.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.156583333,54.72589,0.013,NULL,57581078626,899704353,14057880,18.3),(128387,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128387,38.08,0.46,413,58890,70,NULL,NULL,'2MASX J15163807+1739307',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.158625,17.65867,0.117,NULL,59563751518,930683617,14541931,17.9),(128388,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128388,36.72,0.46,221,58891,70,NULL,NULL,'2MASX J15163831+1212257',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.1597917,12.20719,0.097,NULL,59347366792,927302606,14489103,17.5),(128389,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128389,35.41,0.46,121,58892,70,NULL,NULL,'CGCG 221-047',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00009,NULL,'14.9g',0.68,'E0',NULL,NULL,NULL,NULL,1,229.161333,41.03022,0.033,NULL,59972036049,937063063,14641610,14.9),(128390,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128390,36.76,0.63,225,58893,70,NULL,NULL,'2MASX J15163909-3548138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.1629583,-35.80389,0.477,NULL,47183808775,737247012,11519484,15.2),(128391,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128391,35.55,0.46,129,58894,70,NULL,NULL,'2MASX J15163929+3845201',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000161,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,229.163833,38.75572,0.097,NULL,60102856412,939107131,14673548,15.6),(128392,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128392,36.13,0.09,168,58895,70,NULL,NULL,'SDSS J151641.28+070006.1',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',NULL,NULL,'18.5g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.172,7.00169,0.045,NULL,59350275234,927348050,14489813,18.5),(128393,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128393,36.13,0.09,168,58896,70,NULL,NULL,'2MASX J15164167+0701452',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000063,NULL,'16.0g',0.26,'S0','Group member',NULL,NULL,NULL,1,229.1735,7.02931,0.045,NULL,59350305238,927348519,14489820,16),(128394,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:46','1','SN 2007ba',NULL,128394,35.59,0.4,122,58897,72,NULL,NULL,'UGC 09798',0.03908,'2013ApJ...773...53F',2013,1,1,NULL,'G',0.000093,NULL,'15.03',0.5,'S0/a','Group member',NULL,NULL,NULL,1,229.17425,7.39692,0.049,NULL,59350214478,927347101,14489798,15.03),(128395,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:46','1','SN 2007ba',NULL,128395,35.8,0.15,139,58897,65,NULL,'MLCS17','UGC 09798',0.038513,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128396,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:46','1','SN 2007ba',NULL,128396,35.91,0.16,146,58897,65,NULL,'MLCS31','UGC 09798',0.038513,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128397,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:46','1','SN 2007ba',NULL,128397,36.38,0.1,189,58897,74.4,NULL,NULL,'UGC 09798',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128398,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128398,37.36,0.27,297,58898,70,NULL,NULL,'2MASX J15164192+2159553',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,'AGN',NULL,NULL,NULL,NULL,1,229.174583,21.99881,0.137,NULL,59423111366,928486115,14507595,18),(128399,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128399,38.29,0.33,456,58899,70,NULL,NULL,'SDSS J151641.97+024735.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.174916667,2.79328,0.069,NULL,56385004629,881015697,13765870,18.7),(128400,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128400,37.19,0.97,274,58900,70,NULL,NULL,'2MASX J15164204-1907005',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.175167,-19.11686,0.513,NULL,46645082771,728829418,11387959,15.8),(128401,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128401,36.56,0.46,205,58901,70,NULL,NULL,'2MASX J15164220+2522011',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.17575,25.36689,0.125,NULL,59895927358,935873864,14623029,17.4),(128402,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128402,34,0.47,63.1,58902,70,NULL,NULL,'ESO 387- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000067,NULL,'14.23',0.7,'E5',NULL,NULL,NULL,NULL,1,229.175791667,-36.80242,0.389,NULL,47191021581,737359712,11521245,14.23),(128403,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128403,37.22,0.46,278,58903,70,NULL,NULL,'2MASX J15164277+4142401',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.178333,41.71111,0.037,NULL,59971499576,937054680,14641479,17.1),(128404,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128404,37.14,0.46,268,58904,70,NULL,NULL,'2MASX J15164304+1029169',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000207,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.179416667,10.48817,0.085,NULL,59357173963,927455843,14491497,16.1),(128405,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128405,33.58,0.4,51.9,58905,NULL,NULL,'mean','NGC 5908',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000017,NULL,'12.79',1.2,'Sb','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,229.180083,55.40925,0.013,NULL,57582744184,899730377,14058287,12.79),(128406,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128406,33.6,0.45,52.4,58905,NULL,NULL,'K','NGC 5908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128407,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128407,33.64,0.47,53.5,58905,NULL,NULL,'H','NGC 5908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128408,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128408,33.74,0.46,55.9,58905,NULL,NULL,'J','NGC 5908',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128409,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128409,38.79,0.46,573,58906,70,NULL,NULL,'SDSS J151643.19+275636.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.18,27.94336,0.069,NULL,59908623819,936072247,14626128,18.2),(128410,'BCG','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128410,36.41,0.35,185,58907,60,NULL,NULL,'ABELL 2052',0.0351,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.0003,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,229.183333,7.01861,0.045,NULL,59350275786,927348059,14489813,NULL),(128411,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128411,36.13,0.09,168,58908,70,NULL,NULL,'2MASX J15164408+0705350',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'16.83',0.3,'E/S0','Group member',NULL,NULL,NULL,1,229.1837917,7.09317,0.045,NULL,59350295415,927348365,14489818,16.83),(128412,'BCG','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128412,36.41,0.35,185,58909,60,NULL,'ABELL 2052, BCG','UGC 09799',0.0351,'1980ApJ...241..486H',1980,1,1.8,NULL,'G',0.000022,NULL,'13.96',0.9,'cD;E;Sy2       LEG','in a pair',NULL,'FR I','USS',1,229.185375,7.02164,0.045,NULL,59350275837,927348059,14489813,13.96),(128413,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128413,35.44,0.23,122,58909,74.4,NULL,NULL,'UGC 09799',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128414,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128414,35.99,0.21,158,58909,70,NULL,NULL,'UGC 09799',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128415,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128415,36.13,0.09,168,58909,70,NULL,NULL,'UGC 09799',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128416,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128416,34.84,0.45,93,58909,NULL,NULL,'K','UGC 09799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128417,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128417,35.83,0.4,147,58909,NULL,NULL,'mean','UGC 09799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128418,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128418,37.59,0.46,329,58910,70,NULL,NULL,'2MASX J15164466+1603268',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.186167,16.05744,0.053,NULL,59566618039,930728406,14542631,NULL),(128419,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128419,37.36,0.27,297,58911,70,NULL,NULL,'2MASX J15164479+2159323',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.91',0.21,'AGN',NULL,NULL,NULL,NULL,1,229.186625,21.99228,0.137,NULL,59423111265,928486113,14507595,17.91),(128420,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128420,37.89,0.19,378,58912,70,NULL,NULL,'2MASX J15164509+1847103',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.2g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,229.1877917,18.78633,0.109,NULL,59533990312,930218598,14534665,16.2),(128421,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128421,37.78,0.33,360,58913,70,NULL,NULL,'2MASX J15164531+1418108',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.188875,14.30319,0.093,NULL,59575452239,930866441,14544788,16.6),(128422,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128422,36.89,0.46,239,58914,70,NULL,NULL,'2MASX J15164550+1555008',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.16',0.38,NULL,NULL,NULL,NULL,NULL,1,229.18975,15.91683,0.065,NULL,59564638619,930697478,14542148,16.16),(128423,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128423,36.13,0.09,168,58915,70,NULL,NULL,'2MASX J15164560+0616070',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000057,NULL,'16.6g',0.2,NULL,'Group member',NULL,NULL,NULL,1,229.1900417,6.26861,0.065,NULL,59382960405,927858756,14497793,16.6),(128424,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128424,35.61,0.23,132,58916,74.4,NULL,NULL,'CGCG 049-089',NULL,'2013AJ....146...86T',2013,1,0.63,'UZC has V = 10336 +- 30 km/sec.','G',0.000014,NULL,'15.2g',0.58,'E/S0','Group member',NULL,NULL,NULL,1,229.190708333,7.00439,0.045,NULL,59350275881,927348060,14489813,15.2),(128425,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128425,35.99,0.21,158,58916,70,NULL,NULL,'CGCG 049-089',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128426,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128426,37.62,0.33,334,58917,70,NULL,NULL,'SDSS J151646.21+460346.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.1925417,46.06292,0.037,NULL,59986392372,937287380,14645115,18.2),(128427,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128427,36.13,0.09,168,58918,70,NULL,NULL,'2MASX J15164731+0656000',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00004,NULL,'16.3g',0.39,NULL,'Group member',NULL,NULL,NULL,1,229.1970417,6.93333,0.045,NULL,59350284008,927348187,14489815,16.3),(128428,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128428,38.3,0.27,458,58919,70,NULL,NULL,'SDSS J151647.88+012750.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.1995417,1.464,0.109,NULL,56378821000,880919078,13764360,18.5),(128429,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128429,36.14,0.11,169,58920,70,NULL,NULL,'CGCG 049-088 NED01',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000113,NULL,'16.21',0.53,NULL,NULL,NULL,NULL,NULL,1,229.20125,4.91128,0.061,NULL,56380524243,880945691,13764776,16.21),(128430,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128430,38.36,0.46,471,58921,70,NULL,NULL,'SDSS J151648.37+294552.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.201583,29.76472,0.029,NULL,59904900796,936014074,14625219,18.5),(128431,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128431,37.34,0.46,293,58922,70,NULL,NULL,'2MASX J15164871+1541138',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.202833,15.68728,0.065,NULL,59564687191,930698237,14542159,16.3),(128432,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128432,37.6,0.46,331,58923,70,NULL,NULL,'SDSS J151649.63+362850.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.206833,36.48078,0.021,NULL,60108965283,939202582,14675040,17.7),(128433,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128433,36.13,0.09,168,58924,70,NULL,NULL,'2MASX J15165011+0712400',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000047,NULL,'16.3g',0.19,'S0','Group member',NULL,NULL,NULL,1,229.208875,7.21125,0.049,NULL,59350433716,927350526,14489851,16.3),(128434,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128434,38.28,0.46,453,58925,70,NULL,NULL,'2MASX J15165057-0210054',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.2107083,-2.16817,0.277,NULL,45378632420,709041131,11078767,18.2),(128435,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128435,37.56,0.46,324,58926,70,NULL,NULL,'2MASX J15165063+2839035',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.2110417,28.65103,0.053,NULL,59909070845,936079231,14626237,18.3),(128436,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128436,38.3,0.46,458,58927,70,NULL,NULL,'2MASX J15165117-0205594',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000176,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.213333,-2.09978,0.277,NULL,45378589756,709040464,11078757,18.6),(128437,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128437,36.13,0.09,168,58928,70,NULL,NULL,'2MASX J15165140+0706330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00006,NULL,'17.29',0.2,'S0','Group member',NULL,NULL,NULL,1,229.21425,7.10903,0.045,NULL,59350421670,927350338,14489849,17.29),(128438,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128438,38.62,0.33,530,58929,70,NULL,NULL,'SDSS J151651.49+311206.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.214583,31.20181,0.017,NULL,59903528685,935992635,14624884,18.3),(128439,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128439,37.44,0.33,307,58930,70,NULL,NULL,'2MASX J15165182+3039500',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000195,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.215917,30.66394,0.005,NULL,59906763005,936043171,14625674,16.4),(128440,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128440,38.3,0.27,458,58931,70,NULL,NULL,'2MASX J15165196+0137063',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,229.216333333,1.6185,0.109,NULL,56376981748,880890339,13763911,16.6),(128441,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128441,35.41,0.46,121,58932,70,NULL,NULL,'2MASX J15165224+1646168',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.64',0.39,NULL,NULL,NULL,NULL,NULL,1,229.217667,16.77136,0.109,NULL,59567177835,930737153,14542768,16.64),(128442,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128442,37.6,0.46,332,58933,70,NULL,NULL,'2MASX J15165242+0427323',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.218333,4.45897,0.037,NULL,56383350509,880989851,13765466,17.9),(128443,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128443,37.36,0.27,297,58934,70,NULL,NULL,'2MASX J15165255+2155073',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.84',0.16,NULL,NULL,NULL,NULL,NULL,1,229.219083333,21.91867,0.145,NULL,59414964767,928358824,14505606,17.84),(128444,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128444,36.13,0.09,168,58935,70,NULL,NULL,'2MASX J15165306+0724500',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.55',0.3,NULL,'Group member',NULL,NULL,NULL,1,229.221,7.41403,0.049,NULL,59350216509,927347132,14489798,16.55),(128445,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128445,36.29,0.46,181,58936,70,NULL,NULL,'2MASX J15165336+0338063',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000093,NULL,'16.0g',0.39,'S0',NULL,NULL,NULL,NULL,1,229.2222917,3.63519,0.041,NULL,56382776935,880980889,13765326,16),(128446,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128446,37.74,0.46,354,58937,70,NULL,NULL,'2MASX J15165337+2929505',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.2225,29.49725,0.029,NULL,59904455084,936007110,14625111,17.8),(128447,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128447,36.01,0.46,159,58938,70,NULL,NULL,'2MASX J15165360+1454278',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.11',0.3,NULL,NULL,NULL,NULL,NULL,1,229.22325,14.90783,0.081,NULL,59575223754,930862871,14544732,16.11),(128448,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128448,35.76,0.23,142,58939,74.4,NULL,NULL,'CGCG 049-092',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000025,NULL,'15.1',0.5,'E/S0','Group member',NULL,NULL,NULL,1,229.224625,6.93947,0.045,NULL,59350283595,927348181,14489815,15.1),(128449,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128449,35.99,0.21,158,58939,70,NULL,NULL,'CGCG 049-092',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128450,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128450,36.13,0.09,168,58939,70,NULL,NULL,'CGCG 049-092',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128451,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128451,37.88,0.46,377,58940,70,NULL,NULL,'2MASX J15165422+6106198',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.225875,61.10553,0.009,NULL,57773589679,902712338,14104880,18),(128452,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128452,37.2,0.46,275,58941,70,NULL,NULL,'2MASX J15165493+2226062',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.80',0.2,NULL,NULL,NULL,NULL,NULL,1,229.2287917,22.43517,0.133,NULL,59423163863,928486935,14507608,17.8),(128453,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128453,38.62,0.33,530,58942,70,NULL,NULL,'2MASX J15165598+3106170',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.233375,31.10483,0.017,NULL,59903354711,935989917,14624842,18.2),(128454,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128454,36.99,0.21,250,58943,70,NULL,NULL,'2MASX J15165710+0512123',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'17.15',0.46,NULL,NULL,NULL,NULL,NULL,1,229.2379583,5.20347,0.081,NULL,56380739065,880949047,13764828,17.15),(128455,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128455,37.62,0.46,334,58944,70,NULL,NULL,'SDSS J151658.35-010538.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,229.243125,-1.09397,0.177,NULL,45377305812,709020403,11078443,18.6),(128456,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128456,37.15,0.27,269,58945,70,NULL,NULL,'SDSS J151700.06+102525.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.2502917,10.42364,0.085,NULL,59357691274,927463926,14491623,17.6),(128457,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128457,37.44,0.33,307,58946,70,NULL,NULL,'2MASX J15170011+3039490',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.250417,30.66361,0.005,NULL,59906763464,936043179,14625674,16.8),(128458,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128458,37.78,0.33,360,58947,70,NULL,NULL,'2MASX J15170203+1423489',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.258417,14.397,0.093,NULL,59575863893,930872873,14544888,16.9),(128459,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128459,37.55,0.46,324,58948,70,NULL,NULL,'SDSS J151702.27+304040.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.2594583,30.67778,0.005,NULL,59906765268,936043207,14625675,18.1),(128460,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128460,36.78,0.56,227,58949,70,NULL,NULL,'2MASX J15170305-2227520',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.5,NULL,NULL,NULL,NULL,NULL,1,229.2627083,-22.46442,0.409,NULL,46623458514,728491539,11382680,14.1),(128461,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128461,36.5,0.46,199,58950,70,NULL,NULL,'2MASX J15170341+2327505',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000163,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.2642917,23.46419,0.149,NULL,59424032977,928500515,14507820,16.3),(128462,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128462,36.99,0.21,250,58951,70,NULL,NULL,'IC 1109',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000083,NULL,'15.5',0.68,NULL,NULL,NULL,NULL,NULL,1,229.266583,5.25611,0.073,NULL,56380748853,880949200,13764831,15.5),(128463,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128463,36.68,0.46,216,58952,70,NULL,NULL,'2MASX J15170422+4020392',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.267583,40.34439,0.049,NULL,59972062213,937063472,14641616,16.9),(128464,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128464,38.57,0.46,517,58953,70,NULL,NULL,'SDSS J151704.37+085140.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.26825,8.86128,0.053,NULL,59352570417,927383912,14490373,18.5),(128465,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128465,37.59,0.46,329,58954,70,NULL,NULL,'2MASX J15170513+2801145',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.82',0.15,NULL,NULL,NULL,NULL,NULL,1,229.2715,28.02078,0.069,NULL,59910980222,936109065,14626704,18.82),(128466,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128466,38.7,0.46,550,58955,70,NULL,NULL,'SDSS J151705.50+015722.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.272958333,1.95619,0.093,NULL,56377112903,880892389,13763943,18.2),(128467,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128467,37.89,0.19,378,58956,70,NULL,NULL,'2MASX J15170576+1846555',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.274125,18.78208,0.109,NULL,59533987903,930218560,14534665,18.2),(128468,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128468,37.88,0.46,376,58957,70,NULL,NULL,'2MASX J15170759+0332143',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.2817083,3.53731,0.041,NULL,56382960784,880983762,13765371,17.9),(128469,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128469,38.67,0.46,542,58958,70,NULL,NULL,'LCRS B151431.9-021651',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,229.282083,-2.46331,0.281,NULL,45379143476,709049116,11078892,18.7),(128470,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128470,37.91,0.46,382,58959,70,NULL,NULL,'2MASX J15170811+2848595',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.28375,28.81656,0.041,NULL,59909047790,936078871,14626232,16.7),(128471,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128471,36.13,0.09,168,58960,70,NULL,NULL,'2MASX J15171041+0705350',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,'Group member',NULL,NULL,NULL,1,229.29325,7.09322,0.049,NULL,59350441490,927350648,14489853,17.7),(128472,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128472,37.38,0.33,299,58961,70,NULL,NULL,'2MASX J15171054+0712330',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'16.19',0.4,'E/S0','Group member',NULL,NULL,NULL,1,229.2939583,7.20911,0.049,NULL,59350428595,927350446,14489850,16.19),(128473,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128473,37.18,0.46,273,58962,70,NULL,NULL,'2MASX J15171066+2717015',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.36',0.18,NULL,NULL,NULL,NULL,NULL,1,229.294417,27.28375,0.077,NULL,59910640228,936103753,14626621,18.36),(128474,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128474,35.93,0.23,153,58963,74.4,NULL,NULL,'GIN 425',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000028,NULL,'14.45',NULL,'E/S0','Group member',NULL,NULL,NULL,1,229.2954583,6.94147,0.045,NULL,59350271673,927347994,14489812,14.45),(128475,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128475,35.99,0.21,158,58963,70,NULL,NULL,'GIN 425',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128476,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128476,36.34,0.46,185,58964,70,NULL,NULL,'CGCG 049-095',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000105,NULL,'15.3g',0.54,'S0^-',NULL,NULL,NULL,NULL,1,229.2965,3.35161,0.053,NULL,56382828723,880981698,13765339,15.3),(128477,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128477,38.42,0.46,483,58965,70,NULL,NULL,'LCRS B151435.2-022943',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.2970417,-2.67781,0.281,NULL,45379044928,709047577,11078868,18.1),(128478,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128478,37.47,0.33,312,58966,70,NULL,NULL,'2MASX J15171133+1439129',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.64',0.38,NULL,NULL,NULL,NULL,NULL,1,229.29725,14.65375,0.089,NULL,59575677748,930869964,14544843,16.64),(128479,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128479,35.78,0.61,143,58967,70,NULL,NULL,'LCRS B151435.9-025026',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00013,NULL,'16.73',0.4,NULL,NULL,NULL,NULL,NULL,1,229.3010417,-3.02339,0.297,NULL,45378309392,709036084,11078688,16.73),(128480,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128480,35.77,0.25,143,58968,74.4,NULL,NULL,'ARK 474',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000063,NULL,'14.56',0.3,'S0','in a pair',NULL,NULL,NULL,1,229.3024583,7.02858,0.045,NULL,59350394358,927349911,14489842,14.56),(128481,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128481,35.99,0.21,158,58968,70,NULL,NULL,'ARK 474',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128482,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128482,35.31,0.5,115,58969,70,NULL,NULL,'2MASX J15171263-3243367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.302583333,-32.72689,0.629,NULL,47236355844,738068060,11532313,14.9),(128483,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128483,36.07,0.63,164,58970,70,NULL,NULL,'2MASX J15171268-1112533',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.5b',0.4,NULL,NULL,NULL,NULL,NULL,1,229.303,-11.21489,0.489,NULL,46487546445,726367913,11349498,16.5),(128484,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128484,37.38,0.33,299,58971,70,NULL,NULL,'2MASX J15171290+0714240',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000077,NULL,'16.48',0.3,'E','Group member',NULL,NULL,NULL,1,229.303833,7.24,0.049,NULL,59350429128,927350455,14489850,16.48),(128485,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128485,36.19,0.65,173,58972,70,NULL,NULL,'2MASX J15171471-4452566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.311375,-44.88239,0.721,NULL,47071033456,735484897,11491951,15.8),(128486,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128486,38.01,0.46,400,58973,70,NULL,NULL,'2MASX J15171492+1733525',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.312041667,17.56461,0.117,NULL,59564310822,930692356,14542068,17),(128487,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128487,37.5,0.46,316,58974,70,NULL,NULL,'2MASX J15171529+2821125',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.42',0.17,NULL,NULL,NULL,NULL,NULL,1,229.313833,28.35347,0.045,NULL,59909000110,936078126,14626220,18.42),(128488,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128488,37.48,0.23,314,58975,70,NULL,NULL,'2MASX J15171560+5700173',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000106,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,229.314917,57.00475,0.025,NULL,57588872845,899826138,14059783,15.8),(128489,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128489,36.99,0.21,250,58976,70,NULL,NULL,'2MASX J15171566+0510433',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.315375,5.1785,0.073,NULL,56380742438,880949100,13764829,16.4),(128490,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128490,36.13,0.09,168,58977,70,NULL,NULL,'2MASX J15171586+0705570',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00004,NULL,'16.1g',0.36,'S0','Group member',NULL,NULL,NULL,1,229.3160417,7.09922,0.049,NULL,59350439913,927350623,14489853,16.1),(128491,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128491,37.73,0.46,352,58978,70,NULL,NULL,'2MASX J15171714+1938215',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.41',0.35,NULL,NULL,NULL,NULL,NULL,1,229.321375,19.63939,0.173,NULL,59413229281,928331707,14505182,17.41),(128492,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128492,35.6,0.46,132,58979,70,NULL,NULL,'2MASX J15171716+4642302',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.3214583,46.70847,0.077,NULL,59983590226,937243597,14644431,16.3),(128493,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128493,34.7,0.8,87.1,58980,75,NULL,'MAT, I','ESO 582- G 001',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'14.5',0.7,'SA(rs)b:       HII',NULL,NULL,NULL,NULL,1,229.32575,-22.29761,0.389,NULL,46621297830,728457778,11382152,14.5),(128494,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128494,33.98,0.43,62.4,58980,75,NULL,'MAT, I, raw','ESO 582- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128495,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128495,34.13,0.32,67,58980,85,NULL,'I, raw','ESO 582- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128496,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128496,34.19,0.32,68.9,58980,85,NULL,'I, inv','ESO 582- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128497,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128497,34.24,0.43,70.3,58980,75,NULL,'MAT, I, inv','ESO 582- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128498,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128498,34.29,0.43,72.1,58980,75,NULL,'MAT, I, cor','ESO 582- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128499,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128499,34.43,0.2,76.9,58980,74.4,NULL,NULL,'ESO 582- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128500,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128500,34.46,0.57,77.9,58980,NULL,NULL,'Malmquist cor.','ESO 582- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128501,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128501,34.48,0.56,78.7,58980,NULL,NULL,NULL,'ESO 582- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128502,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128502,34.63,0.47,84.5,58980,NULL,NULL,'H','ESO 582- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128503,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128503,34.74,0.45,88.6,58980,NULL,NULL,'K','ESO 582- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128504,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128504,34.76,0.46,89.4,58980,NULL,NULL,'J','ESO 582- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128505,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128505,34.82,0.4,92,58980,NULL,NULL,'mean','ESO 582- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128506,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128506,36.48,0.46,198,58981,70,NULL,NULL,'2MASX J15171976+2032145',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000127,NULL,'16.48',0.24,NULL,NULL,NULL,NULL,NULL,1,229.3322917,20.53728,0.165,NULL,59415848224,928372628,14505822,16.48),(128507,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128507,36.39,0.46,189,58982,70,NULL,NULL,'2MASX J15171975+0433103',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.332333333,4.55297,0.029,NULL,56383258896,880988420,13765444,16.5),(128508,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128508,37.89,0.46,378,58983,70,NULL,NULL,'2MASX J15172265+0254013',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.344333,2.90025,0.061,NULL,56384098712,881001542,13765649,17.5),(128509,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128509,38.57,0.46,518,58984,70,NULL,NULL,'SDSS J151722.79+302254.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.344958333,30.38181,0.017,NULL,59906954903,936046170,14625721,18.4),(128510,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128510,33.05,0.8,40.7,58985,75,NULL,NULL,'ESO 068- G 001',NULL,'1988NBGC.C....0000T',1988,1,1.1,'Confused HIPASS source','G',0.000019,NULL,'14.8',0.8,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.345417,-72.67217,0.517,NULL,45000132679,703127073,10986360,14.8),(128511,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128511,36.51,0.57,201,58986,70,NULL,NULL,'2MASX J15172294-1958589',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.3455,-19.98311,0.469,NULL,46616314455,728379913,11380936,15.2),(128512,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128512,35.81,0.25,145,58987,74.4,NULL,NULL,'CGCG 049-098',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.00005,NULL,'15.1g',0.51,'E/S0',NULL,NULL,NULL,NULL,1,229.345666667,4.21361,0.037,NULL,56383457559,880991524,13765492,15.1),(128513,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128513,36.02,0.21,160,58987,70,NULL,NULL,'CGCG 049-098',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128514,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128514,36.14,0.11,169,58987,70,NULL,NULL,'CGCG 049-098',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128515,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128515,36.13,0.09,168,58988,70,NULL,NULL,'2MASX J15172338+0716380',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000037,NULL,'16.81',0.2,NULL,'Group member',NULL,NULL,NULL,1,229.347375,7.27719,0.049,NULL,59350208564,927347008,14489797,16.81),(128516,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128516,36.97,0.46,248,58989,70,NULL,NULL,'2MASX J15172412+1053420',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.350667,10.89494,0.097,NULL,59356493369,927445208,14491331,17.2),(128517,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128517,37.07,0.33,259,58990,70,NULL,NULL,'2MASX J15172437+3855372',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.351667,38.92694,0.097,NULL,60103045655,939110088,14673595,17.3),(128518,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128518,37.55,0.46,323,58991,70,NULL,NULL,'SDSS J151725.30+070457.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.3554583,7.08269,0.049,NULL,59350389760,927349840,14489841,18.1),(128519,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128519,35.57,0.38,130,58992,NULL,NULL,NULL,'AGC 251805',NULL,'2009ApJS..182..474S',2009,1,0.92,NULL,'G',0.000027,NULL,'17.1g',0.11,'Sc',NULL,NULL,NULL,NULL,1,229.374667,8.17758,0.049,NULL,59353595302,927399926,14490623,17.1),(128520,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128520,35.61,0.2,132,58992,74.4,NULL,NULL,'AGC 251805',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128521,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128521,35.92,0.32,153,58992,NULL,NULL,'Malmquist cor.','AGC 251805',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128522,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128522,38.21,0.33,438,58993,70,NULL,NULL,'SDSS J151730.14+324140.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.375583,32.69464,0.009,NULL,60112926590,939264477,14676007,18.3),(128523,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128523,38.05,0.46,407,58994,70,NULL,NULL,'2MASX J15173030+0947080',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.3762917,9.78536,0.045,NULL,59357523969,927461312,14491583,17.6),(128524,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128524,37.49,0.27,314,58995,70,NULL,NULL,'2MASX J15173180+2209509',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.16',0.16,NULL,NULL,NULL,NULL,NULL,1,229.3825,22.16414,0.137,NULL,59423122983,928486296,14507598,18.16),(128525,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128525,38.21,0.33,438,58996,70,NULL,NULL,'2MASX J15173329+3242003',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.388666667,32.70014,0.009,NULL,60112926679,939264479,14676007,17.7),(128526,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128526,38.12,0.46,421,58997,70,NULL,NULL,'2MASX J15173333+2626079',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.388917,26.43558,0.113,NULL,59910241173,936097518,14626523,17.7),(128527,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128527,36.8,0.46,229,58998,70,NULL,NULL,'2MASX J15173328+2652219',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.13',0.21,NULL,NULL,NULL,NULL,NULL,1,229.388917,26.87269,0.065,NULL,59910048513,936094508,14626476,18.13),(128528,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128528,37.47,0.33,312,58999,70,NULL,NULL,'2MASX J15173339+1438446',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.3892917,14.64567,0.089,NULL,59575666708,930869792,14544840,16.7),(128529,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128529,37.15,0.46,269,59000,70,NULL,NULL,'2MASX J15173402+3635132',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000169,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.39175,36.58697,0.017,NULL,60109026058,939203532,14675055,16.6),(128530,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128530,37.49,0.27,314,59001,70,NULL,NULL,'2MASX J15173496+2217409',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.3957083,22.29472,0.133,NULL,59424146527,928502289,14507848,16.3),(128531,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128531,36.77,0.46,226,59002,70,NULL,NULL,'2MASX J15173571-0127315',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00014,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.39875,-1.45878,0.189,NULL,45377249152,709019518,11078429,17.7),(128532,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128532,36.21,0.46,175,59003,70,NULL,NULL,'MCG +01-39-014a',NULL,'2015arXiv151105856S',2015,1,0.63,'New entry added to MCG in volume IV of MCG Errata and Addenda.','G',NULL,NULL,'15.7',0.41,NULL,NULL,NULL,NULL,NULL,1,229.3987917,5.05439,0.081,NULL,56380475504,880944929,13764764,15.7),(128533,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128533,36.13,0.09,168,59004,70,NULL,NULL,'2MASX J15173648+0702250',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00005,NULL,'14.7',0.25,'S0','Group member',NULL,NULL,NULL,1,229.4020417,7.04031,0.049,NULL,59350392048,927349875,14489841,14.7),(128534,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128534,37.49,0.27,314,59005,70,NULL,NULL,'2MASX J15173698+2213419',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.88',0.2,NULL,NULL,NULL,NULL,NULL,1,229.404,22.22836,0.137,NULL,59423090372,928485787,14507590,17.88),(128535,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128535,37.89,0.19,378,59006,70,NULL,NULL,'SDSS J151736.98+184051.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.404083333,18.681,0.113,NULL,59580101117,930939079,14545923,NULL),(128536,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128536,37.89,0.19,378,59007,70,NULL,NULL,'2MASX J15173739+1843269',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.40575,18.72406,0.109,NULL,59580103968,930939124,14545923,17.7),(128537,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128537,37.66,0.46,340,59008,70,NULL,NULL,'2MASX J15173805+2228309',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.68',0.15,NULL,NULL,NULL,NULL,NULL,1,229.408583333,22.47531,0.133,NULL,59424335081,928505235,14507894,18.68),(128538,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128538,38.67,0.46,542,59009,70,NULL,NULL,'2MASX J15173820+0224263',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.409167,2.40742,0.077,NULL,56384887723,881013870,13765841,17.8),(128539,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128539,37.48,0.23,314,59010,70,NULL,NULL,'2MASX J15173923+5658065',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000089,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.413333,56.96833,0.025,NULL,57588861199,899825956,14059780,17.8),(128540,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128540,36.45,0.46,195,59011,70,NULL,NULL,'2MASX J15173941+0407093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000099,NULL,'16.9g',0.27,'NLAGN',NULL,NULL,NULL,'Sy 2',1,229.4142083,4.11936,0.037,NULL,56382424103,880975376,13765240,16.9),(128541,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128541,35.3,0.46,115,59012,70,NULL,NULL,'VIII Zw 465',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.4147917,9.96494,0.057,NULL,59357348849,927458575,14491540,16.4),(128542,'BL Lac Luminosity','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128542,37.03,NULL,243,59013,NULL,NULL,NULL,'AP Lib',0.049031,'2005ApJ...635..173S',2005,1,0.5,NULL,'G',0.00015,NULL,'15.08',0.4,'N galaxy       BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,229.424208333,-24.37208,0.645,NULL,46622664221,728479128,11382486,15.08),(128543,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128543,37.46,0.46,310,59014,70,NULL,NULL,'SDSS J151742.18+350646.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.42575,35.11286,0.021,NULL,60107933778,939186465,14674788,18.1),(128544,'FP','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,'R',128544,37.51,0.21,317,59015,70,NULL,NULL,'SDSS J151742.26+590116.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000158,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,229.426167,59.02111,0.025,NULL,57718309427,901848584,14091384,18.5),(128545,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128545,35.98,0.34,157,59016,NULL,NULL,'Malmquist cor.','2MFGC 12361',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000027,NULL,'14.88',NULL,'Sbc',NULL,NULL,NULL,NULL,1,229.4289583,8.01606,0.057,NULL,59353358322,927396223,14490565,14.88),(128546,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:46','1',NULL,NULL,128546,35.98,0.34,157,59016,NULL,NULL,NULL,'2MFGC 12361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128547,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128547,35.99,0.49,158,59016,75,NULL,'IR','2MFGC 12361',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128548,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128548,36.02,0.2,160,59016,74.4,NULL,NULL,'2MFGC 12361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128549,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128549,36.84,0.46,234,59017,70,NULL,NULL,'2MASX J15174398+4919428',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.433375,49.32869,0.033,NULL,59938224613,936534759,14633355,16.7),(128550,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128550,36.14,0.11,169,59018,70,NULL,NULL,'2MASX J15174421+0408598',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.434167,4.14983,0.037,NULL,56382424524,880975383,13765240,16.7),(128551,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128551,36.89,0.46,238,59019,70,NULL,NULL,'2MASX J15174569+1252032',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.440291667,12.86758,0.113,NULL,59573006874,930828232,14544191,17.5),(128552,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128552,34.65,0.8,85,59020,75,NULL,'MAT, I','ESO 387- G 020',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'16.42',0.5,'Sb-c           HII',NULL,NULL,NULL,NULL,1,229.440833,-33.08786,0.641,NULL,47236455137,738069611,11532337,16.42),(128553,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128553,34.43,0.43,77,59020,75,NULL,'MAT, I, raw','ESO 387- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128554,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128554,34.44,0.32,77.4,59020,85,NULL,'I, raw','ESO 387- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128555,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128555,34.48,0.32,78.8,59020,85,NULL,'I, inv','ESO 387- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128556,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128556,34.61,0.43,83.7,59020,75,NULL,'MAT, I, inv','ESO 387- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128557,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128557,34.63,0.43,84.5,59020,75,NULL,'MAT, I, cor','ESO 387- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128558,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128558,34.89,0.2,95.1,59020,74.4,NULL,NULL,'ESO 387- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128559,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128559,38.07,0.33,411,59021,70,NULL,NULL,'2MASX J15174601+0447078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.441625,4.7855,0.065,NULL,56380604636,880946947,13764796,17.4),(128560,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128560,36.34,0.46,186,59022,70,NULL,NULL,'2MASX J15174707+0510568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.446125,5.1825,0.073,NULL,56380430258,880944222,13764753,17),(128561,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128561,37.07,0.33,259,59023,70,NULL,NULL,'2MASXi J1517471+384653',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.4464583,38.78164,0.057,NULL,60102823616,939106619,14673540,17.8),(128562,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128562,36.12,0.46,168,59024,70,NULL,NULL,'2MASX J15174724+0124198',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.446667,1.40539,0.109,NULL,56378972023,880921437,13764397,16.5),(128563,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128563,36.99,0.21,250,59025,70,NULL,NULL,'2MASX J15174740+0515228',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.447583333,5.25625,0.073,NULL,56380438575,880944352,13764755,16.2),(128564,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128564,36.01,0.46,160,59026,70,NULL,NULL,'2MASX J15174849-0125343',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.3g',0.29,'S0',NULL,NULL,NULL,NULL,1,229.452083,-1.42614,0.189,NULL,45377197097,709018704,11078417,16.3),(128565,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128565,36.21,0.52,175,59026,70,NULL,NULL,'2MASX J15174849-0125343',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128566,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128566,38.33,0.46,464,59027,70,NULL,NULL,'2MASX J15174866+1918310',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.452667,19.30867,0.161,NULL,59412540850,928320950,14505014,17.8),(128567,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128567,37.85,0.46,371,59028,70,NULL,NULL,'2MASX J15174942+4144433',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.45575,41.74531,0.037,NULL,59971525395,937055084,14641485,17.2),(128568,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128568,33.94,0.48,61.4,59029,70,NULL,NULL,'ESO 274- G 008',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000077,NULL,'15.13',0.2,'S0',NULL,NULL,NULL,NULL,1,229.456083,-43.50158,0.541,NULL,47073641552,735525649,11492588,15.13),(128569,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128569,37.72,0.46,350,59030,70,NULL,NULL,'2MASX J15175000+0621128',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.0R',0.12,NULL,NULL,NULL,NULL,NULL,1,229.458416667,6.35356,0.057,NULL,59349426751,927334792,14489606,17),(128570,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128570,37.93,0.23,385,59031,70,NULL,NULL,'2MASX J15175010+2648029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'18.10',0.21,NULL,NULL,NULL,NULL,NULL,1,229.4587917,26.80089,0.065,NULL,59910041655,936094400,14626475,18.1),(128571,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128571,35.38,0.4,119,59032,NULL,NULL,NULL,'CGCG 049-108',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.000021,NULL,'15.6g',0.32,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.462083,8.22889,0.049,NULL,59353584542,927399758,14490621,15.6),(128572,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128572,35.43,0.2,122,59032,74.4,NULL,NULL,'CGCG 049-108',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128573,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128573,35.6,0.36,132,59032,NULL,NULL,'Malmquist cor.','CGCG 049-108',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128574,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128574,36.48,0.59,198,59033,70,NULL,NULL,'2MASX J15175148-1904076',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.4644583,-19.06872,0.493,NULL,46615522123,728367533,11380742,14.8),(128575,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128575,37.93,0.23,385,59034,70,NULL,NULL,'2MASX J15175182+2653359',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.465875,26.89317,0.065,NULL,59910061846,936094716,14626479,17.7),(128576,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128576,38.21,0.46,438,59035,70,NULL,NULL,'2MASX J15175233+2638329',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.468041667,26.64253,0.089,NULL,59910033128,936094267,14626472,NULL),(128577,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128577,37.37,0.33,298,59036,70,NULL,NULL,'2MASX J15175250+4841038',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.468875,48.68439,0.033,NULL,59936971642,936515181,14633049,16.6),(128578,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128578,37.29,0.33,287,59037,70,NULL,NULL,'2MASX J15175289+5047358',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,229.470583333,50.79347,0.033,NULL,59666272773,932285512,14566961,16.4),(128579,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128579,37.8,0.46,362,59038,70,NULL,NULL,'2MASX J15175371+3439223',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000154,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.4737917,34.65614,0.013,NULL,60107813598,939184587,14674759,16.9),(128580,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128580,36.18,0.46,172,59039,70,NULL,NULL,'CGCG 021-074',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000085,NULL,'15.6g',0.4,'E0',NULL,NULL,NULL,NULL,1,229.475083333,0.82867,0.133,NULL,56379607913,880931373,13764552,15.6),(128581,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128581,37.24,0.46,280,59040,70,NULL,NULL,'2MASX J15175426+1816159',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.4760417,18.27122,0.153,NULL,59563552821,930680512,14541883,16.8),(128582,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128582,37.29,0.33,287,59041,70,NULL,NULL,'2MASX J15175432+5048038',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.4762083,50.80114,0.033,NULL,59666243882,932285060,14566954,17.9),(128583,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128583,35.86,0.46,149,59042,70,NULL,NULL,'CGCG 106-030',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00011,NULL,'15.6',0.39,NULL,NULL,NULL,NULL,NULL,1,229.481417,20.15408,0.181,NULL,59413160939,928330639,14505166,15.6),(128584,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128584,38.07,0.33,411,59043,70,NULL,NULL,'2MASX J15175577+0449408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.482417,4.82794,0.065,NULL,56380599817,880946872,13764794,17.6),(128585,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128585,37.53,0.33,321,59044,70,NULL,NULL,'2MASX J15175793+2810288',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.4914583,28.17483,0.045,NULL,59911035992,936109937,14626717,17.3),(128586,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128586,36.13,0.09,168,59045,70,NULL,NULL,'CGCG 049-109',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00006,NULL,'15.3',0.5,NULL,'Group member',NULL,NULL,NULL,1,229.4920417,7.23922,0.049,NULL,59350416371,927350255,14489847,15.3),(128587,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128587,35.33,0.43,117,59046,NULL,NULL,NULL,'UGC 09807',NULL,'2009ApJS..182..474S',2009,1,1.18,NULL,'G',0.000033,NULL,'14.9g',0.42,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.494667,10.89569,0.097,NULL,59356360251,927443128,14491298,14.9),(128588,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128588,35.41,0.42,121,59046,NULL,NULL,'Malmquist cor.','UGC 09807',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128589,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128589,35.66,0.2,136,59046,74.4,NULL,NULL,'UGC 09807',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128590,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128590,37.93,0.23,385,59047,70,NULL,NULL,'2MASX J15175925+2652409',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.30',0.32,'BrClG',NULL,NULL,NULL,NULL,1,229.49675,26.87806,0.065,NULL,59910058545,936094664,14626479,17.3),(128591,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128591,37.86,0.21,374,59048,70,NULL,NULL,'2MASX J15180005+2705179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.500125,27.08833,0.077,NULL,59910509023,936101703,14626589,17.4),(128592,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128592,37.34,0.46,294,59049,70,NULL,NULL,'SDSS J151800.27+204327.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,229.501167,20.72444,0.165,NULL,59416292583,928379571,14505930,18.53),(128593,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128593,37.93,0.23,385,59050,70,NULL,NULL,'2MASX J15180119+2651249',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,'PHOT','16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.5050417,26.85703,0.065,NULL,59910052893,936094576,14626477,16.7),(128594,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128594,37.86,0.21,374,59051,70,NULL,NULL,'2MASX J15180245+2702189',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.98',0.18,NULL,NULL,NULL,NULL,NULL,1,229.510291667,27.03858,0.073,NULL,59910001474,936093773,14626465,17.98),(128595,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128595,37.99,0.46,396,59052,70,NULL,NULL,'2MASX J15180371+2332460',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.22',0.16,NULL,NULL,NULL,NULL,NULL,1,229.515333,23.54611,0.145,NULL,59423983406,928499740,14507808,18.22),(128596,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128596,37.37,0.33,298,59053,70,NULL,NULL,'2MASX J15180432+4836039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.51775,48.60111,0.045,NULL,59936987233,936515425,14633053,17.6),(128597,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128597,38.18,0.27,432,59054,70,NULL,NULL,'SDSS J151804.89+311905.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.520417,31.31817,0.021,NULL,59903486241,935991972,14624874,18.3),(128598,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128598,37.61,0.46,333,59055,70,NULL,NULL,'2MASX J15180566+3000494',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.523916667,30.01381,0.017,NULL,59907059372,936047802,14625746,18.1),(128599,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128599,35.92,0.47,153,59056,NULL,NULL,'H','UGC 09808',NULL,'2007A&A...465...71T',2007,1,1.3,'HOLM 705B is a star.','G',0.00003,NULL,'14.40',1,'SABb',NULL,NULL,NULL,NULL,1,229.5357917,13.82864,0.097,NULL,59573091236,930829550,14544211,14.4),(128600,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128600,36,0.4,159,59056,NULL,NULL,'mean','UGC 09808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128601,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128601,38.1,0.46,418,59057,70,NULL,NULL,'2MASX J15180872+1525072',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.536333,15.41878,0.077,NULL,59575116874,930861201,14544706,17.4),(128602,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128602,35.45,0.42,123,59058,NULL,NULL,NULL,'CGCG 049-111',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000027,NULL,'15.7g',0.29,'Sc',NULL,NULL,NULL,NULL,1,229.5375417,8.2475,0.049,NULL,59353449370,927397646,14490588,15.7),(128603,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128603,35.49,0.2,125,59058,74.4,NULL,NULL,'CGCG 049-111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128604,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128604,35.7,0.37,138,59058,NULL,NULL,'Malmquist cor.','CGCG 049-111',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128605,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128605,36.02,0.21,160,59059,70,NULL,NULL,'GIN 394',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',0.000067,NULL,'14.35',0.51,'S',NULL,NULL,NULL,NULL,1,229.53825,4.56303,0.065,NULL,56383250306,880988286,13765441,14.35),(128606,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128606,36.14,0.11,169,59059,70,NULL,NULL,'GIN 394',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128607,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128607,38.18,0.27,432,59060,70,NULL,NULL,'2MASX J15180944+3117364',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,229.539417,31.29342,0.021,NULL,59903487395,935991990,14624874,17.1),(128608,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128608,35.55,0.55,129,59061,70,NULL,NULL,'2MASX J15181047-7209033',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.543583,-72.15094,0.601,NULL,44999079522,703110617,10986103,15.1),(128609,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128609,37.86,0.21,374,59062,70,NULL,NULL,'2MASX J15181263+2702329',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.552666667,27.0425,0.073,NULL,59910465038,936101016,14626578,NULL),(128610,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128610,38.22,0.09,441,59063,70,NULL,NULL,'2MASX J15181261+0623285',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.5527083,6.39117,0.057,NULL,56409233619,881394275,13771785,17.9),(128611,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128611,36.99,0.21,250,59064,70,NULL,NULL,'2MASX J15181343+0510211',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.5560417,5.17247,0.073,NULL,56426422307,881662848,13775982,17.3),(128612,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128612,38.49,0.46,499,59065,70,NULL,NULL,'SDSS J151813.44+045342.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.556417,4.89517,0.065,NULL,56380376390,880943381,13764740,18.2),(128613,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128613,32.31,0.14,29,59066,74.4,NULL,NULL,'NGC 5898',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000014,NULL,'12.49',2,'E0','in a pair',NULL,NULL,NULL,1,229.5565,-24.09794,0.477,NULL,46622825303,728481645,11382525,12.49),(128614,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128614,32.32,0.26,29.1,59066,NULL,NULL,'I','NGC 5898',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128615,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128615,32.32,0.26,29.1,59066,NULL,NULL,NULL,'NGC 5898',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128616,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128616,32.44,0.26,30.7,59066,NULL,NULL,'Malmquist cor.','NGC 5898',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128617,'D-Sigma','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128617,32.08,0.4,26,59066,75,NULL,'Edat, raw','NGC 5898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128618,'D-Sigma','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128618,32.39,0.4,30.1,59066,75,NULL,'Edat, cor','NGC 5898',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128619,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128619,31.16,0.63,17.1,59066,95,NULL,'Michard 1979b, c','NGC 5898',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128620,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128620,31.74,0.37,22.3,59066,95,NULL,'Weighted Mean','NGC 5898',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128621,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128621,31.98,0.46,24.9,59066,95,NULL,'Michard 1979a','NGC 5898',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128622,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128622,34.54,0.81,80.9,59066,55,NULL,'Visvanathan & Sandage 1979','NGC 5898',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128623,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128623,32.23,0.41,27.9,59066,NULL,NULL,NULL,'NGC 5898',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128624,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128624,32.48,0.41,31.4,59066,NULL,NULL,'Malmquist cor.','NGC 5898',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128625,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128625,32.57,0.8,32.6,59066,75,NULL,'B','NGC 5898',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128626,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128626,32.65,0.4,33.8,59066,NULL,NULL,'mean','NGC 5898',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128627,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128627,32.77,0.45,35.8,59066,NULL,NULL,'K','NGC 5898',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128628,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128628,37.53,0.33,321,59067,70,NULL,NULL,'2MASX J15181435+2823339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.24',0.19,NULL,NULL,NULL,NULL,NULL,1,229.5597083,28.39289,0.033,NULL,59911012729,936109573,14626712,18.24),(128629,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128629,36.14,0.11,169,59068,70,NULL,NULL,'2MASX J15181565+0431021',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.56525,4.51714,0.065,NULL,56383258470,880988413,13765443,16.7),(128630,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128630,37.94,0.46,387,59069,70,NULL,NULL,'2MASX J15181567+5101381',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.565375,51.02731,0.033,NULL,59666227958,932284811,14566950,17.5),(128631,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128631,35.88,0.58,150,59070,70,NULL,NULL,'ESO 449- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.79,NULL,'G',0.00015,NULL,'15.8',0.2,'Sc',NULL,NULL,NULL,NULL,1,229.5755,-32.24944,0.545,NULL,47202932249,737545816,11524153,15.8),(128632,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128632,39.02,0.46,635,59071,70,NULL,NULL,'2MASX J15181827+2952503',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.5759583,29.8805,0.021,NULL,59907054215,936047722,14625745,18),(128633,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128633,37.19,0.46,274,59072,70,NULL,NULL,'2MASX J15181894+1104575',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.579041667,11.08281,0.097,NULL,59356498636,927445291,14491332,17.1),(128634,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128634,37.3,0.46,288,59073,70,NULL,NULL,'2MASX J15182005+5427569',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.583625,54.46586,0.017,NULL,59662327459,932223866,14565997,17.9),(128635,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128635,37.15,0.46,269,59074,70,NULL,NULL,'2MASX J15182132-0139127',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.8g',0.29,'poss. LINER',NULL,NULL,NULL,NULL,1,229.588875,-1.65356,0.245,NULL,45376871366,709013615,11078337,16.8),(128636,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128636,36.45,0.46,195,59075,70,NULL,NULL,'2MASX J15182235+1425002',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.593083,14.41681,0.089,NULL,59575844138,930872564,14544883,16.6),(128637,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128637,38.22,0.09,441,59076,70,NULL,NULL,'2MASX J15182295+0619455',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000093,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,229.595625,6.32931,0.057,NULL,56409238385,881394349,13771786,16.7),(128638,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128638,37.3,0.46,288,59077,70,NULL,NULL,'2MASX J15182345+2211459',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.597667,22.19597,0.133,NULL,59424174960,928502733,14507855,17.7),(128639,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128639,36.48,0.46,197,59078,70,NULL,NULL,'LCRS B151547.8-021803',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00012,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.598625,-2.48264,0.313,NULL,45376266310,709004161,11078190,16.6),(128640,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128640,38.35,0.46,467,59079,70,NULL,NULL,'2MASX J15182380+1849399',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.599125,18.82769,0.129,NULL,59412317732,928317464,14504960,NULL),(128641,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128641,33.94,0.8,61.5,59080,75,NULL,'MAT, I','ESO 328- G 041',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000026,NULL,'14.1b',0.5,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,229.599167,-38.50678,0.345,NULL,47191737675,737370901,11521420,14.1),(128642,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128642,33.63,0.43,53.3,59080,75,NULL,'MAT, I, raw','ESO 328- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128643,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128643,33.68,0.49,54.5,59080,75,NULL,'IR','ESO 328- G 041',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128644,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128644,33.75,0.32,56.3,59080,85,NULL,'I, raw','ESO 328- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128645,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128645,33.8,0.46,57.5,59080,NULL,NULL,'J','ESO 328- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128646,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128646,33.82,0.32,58,59080,85,NULL,'I, inv','ESO 328- G 041',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128647,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128647,33.84,0.47,58.6,59080,NULL,NULL,'H','ESO 328- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128648,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128648,33.9,0.43,60.2,59080,75,NULL,'MAT, I, inv','ESO 328- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128649,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128649,33.95,0.43,61.7,59080,75,NULL,'MAT, I, cor','ESO 328- G 041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128650,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128650,33.96,0.45,61.9,59080,NULL,NULL,'K','ESO 328- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128651,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128651,34,0.4,63.1,59080,NULL,NULL,'mean','ESO 328- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128652,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128652,34.1,0.34,66,59080,NULL,NULL,NULL,'ESO 328- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128653,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128653,34.14,0.2,67.3,59080,74.4,NULL,NULL,'ESO 328- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128654,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128654,34.16,0.33,67.9,59080,NULL,NULL,'Malmquist cor.','ESO 328- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128655,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128655,33.97,0.46,62.3,59081,70,NULL,NULL,'2MASX J15182391+2355279',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'15.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,229.599667,23.92456,0.149,NULL,59422589396,928477959,14507468,15.4),(128656,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128656,37.25,0.16,281,59082,70,NULL,NULL,'2MASX J15182414+4502061',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.60075,45.03497,0.033,NULL,59967795714,936996808,14640575,17),(128657,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128657,38.11,0.33,418,59083,70,NULL,NULL,'2MASX J15182441+0512021',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,'PHOT','17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.6017083,5.20053,0.065,NULL,56426426291,881662910,13775982,17.1),(128658,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128658,36.94,0.46,244,59084,70,NULL,NULL,'2MASX J15182446+2111469',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,229.602041667,21.19631,0.161,NULL,59415659449,928369678,14505776,18.43),(128659,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128659,38.44,0.33,488,59085,70,NULL,NULL,'SDSS J151824.61+041025.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.6025417,4.17369,0.037,NULL,56382414622,880975228,13765237,18.6),(128660,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128660,37.48,0.23,314,59086,70,NULL,NULL,'2MASX J15182471+5658329',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.602875,56.97592,0.025,NULL,57588941578,899827212,14059800,17.4),(128661,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128661,35.13,0.47,106,59087,NULL,NULL,'H','CGCG 077-069',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00004,NULL,'14.9',0.4,'S0a','Group member',NULL,NULL,NULL,1,229.6100417,12.93819,0.121,NULL,59572866826,930826044,14544156,14.9),(128662,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128662,35.35,0.4,117,59087,NULL,NULL,'mean','CGCG 077-069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128663,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128663,35.35,0.45,118,59087,NULL,NULL,'K','CGCG 077-069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128664,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128664,35.38,0.46,119,59087,NULL,NULL,'J','CGCG 077-069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128665,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128665,38.22,0.09,441,59088,70,NULL,NULL,'SDSS J151826.82+062502.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.6117917,6.41733,0.049,NULL,56409229992,881394218,13771784,18.2),(128666,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128666,38.06,0.27,410,59089,70,NULL,NULL,'2MASX J15182695+0439141',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.612375,4.65381,0.065,NULL,56380373660,880943338,13764739,16.8),(128667,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128667,36.71,0.17,219,59090,70,NULL,NULL,'2MASX J15182728+0426111',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000089,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.613583333,4.43642,0.029,NULL,56382206494,880971976,13765187,17.4),(128668,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128668,38.11,0.33,418,59091,70,NULL,NULL,'2MASX J15182749+0511421',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.614458333,5.19514,0.065,NULL,56426425501,881662898,13775982,NULL),(128669,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128669,35.52,0.46,127,59092,70,NULL,NULL,'CGCG 049-113',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000123,NULL,'14.63',0.39,'E/S0',NULL,NULL,NULL,NULL,1,229.6159583,4.67558,0.065,NULL,56380373446,880943335,13764739,14.63),(128670,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128670,36.02,0.21,160,59092,70,NULL,NULL,'CGCG 049-113',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128671,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128671,36.65,0.33,214,59093,70,NULL,NULL,'2MASX J15182783+3312075',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,229.615833,33.20206,0.021,NULL,60112881405,939263771,14675996,16),(128672,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128672,38.26,0.46,448,59094,70,NULL,NULL,'2MASX J15182796+0540451',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.6165,5.67931,0.065,NULL,56426088742,881657636,13775900,17.6),(128673,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128673,38.09,0.46,415,59095,70,NULL,NULL,'2MASX J15182893+2125519',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.6204583,21.43097,0.149,NULL,59415721629,928370650,14505791,18),(128674,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128674,37.66,0.46,341,59096,70,NULL,NULL,'2MASX J15182978+5509129',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000139,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.62425,55.15367,0.013,NULL,57581295751,899707746,14057933,17.2),(128675,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128675,37.55,0.46,323,59097,70,NULL,NULL,'2MASX J15183025+5232551',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.625916667,52.54867,0.025,NULL,59661130574,932205165,14565705,16.9),(128676,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128676,36.61,0.46,210,59098,70,NULL,NULL,'2MASX J15183060+2019218',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.87',0.32,NULL,NULL,NULL,NULL,NULL,1,229.627417,20.32289,0.177,NULL,59412647468,928322616,14505040,16.87),(128677,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128677,38.22,0.09,441,59099,70,NULL,NULL,'2MASX J15183060+0619595',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,229.6275417,6.33303,0.057,NULL,56409239332,881394364,13771786,16.7),(128678,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128678,38,0.27,397,59100,70,NULL,NULL,'SDSS J151831.34+021655.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.630625,2.28222,0.077,NULL,56377643089,880900673,13764073,18.1),(128679,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128679,38.22,0.09,441,59101,70,NULL,NULL,'2MASX J15183220+0623595',NULL,'2015arXiv151105856S',2015,1,0.4,'XBS J151832.3+062357 is identified as a GClstr in 2008A&A...477..735C.','G',0.000047,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.634208333,6.39975,0.049,NULL,56409240639,881394384,13771787,17.1),(128680,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128680,37.72,0.46,350,59102,70,NULL,NULL,'2MASX J15183240-0153037',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.634916667,-1.88436,0.249,NULL,45376887430,709013866,11078341,18),(128681,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128681,35.97,0.46,156,59103,70,NULL,NULL,'2MASX J15183241+0707205',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000047,NULL,'15.8g',0.4,NULL,'Group member',NULL,NULL,NULL,1,229.635125,7.12242,0.061,NULL,59350348159,927349189,14489831,15.8),(128682,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128682,36.67,0.46,216,59104,70,NULL,NULL,'2MASX J15183248+5824519',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000201,NULL,'15.6g',0.5,'E0',NULL,NULL,NULL,NULL,1,229.635375,58.41442,0.013,NULL,57721314592,901895540,14092117,15.6),(128683,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128683,38.44,0.33,488,59105,70,NULL,NULL,'SDSS J151833.13+041217.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000083,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.638083,4.20481,0.029,NULL,56382412865,880975201,13765237,18.5),(128684,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128684,35.88,0.46,150,59106,70,NULL,NULL,'2MASX J15183320+5228191',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.6382083,52.47186,0.025,NULL,59675003225,932421925,14569092,16.6),(128685,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128685,38.18,0.27,432,59107,70,NULL,NULL,'2MASX J15183334+3119485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.639,31.33011,0.021,NULL,59903492024,935992062,14624875,17.8),(128686,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128686,37.42,0.46,305,59108,70,NULL,NULL,'2MASX J15183441+4802121',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.6432083,48.03667,0.045,NULL,59937629257,936525457,14633210,17.2),(128687,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128687,38.22,0.09,441,59109,70,NULL,NULL,'2MASX J15183448+0617265',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'17.5g',0.19,NULL,'Group member',NULL,NULL,NULL,1,229.643625,6.29069,0.057,NULL,56409243784,881394434,13771788,17.5),(128688,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128688,37.98,0.13,394,59110,70,NULL,NULL,'2MASX J15183498+1946564',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,229.645625,19.78256,0.165,NULL,59413360121,928333751,14505214,18.5),(128689,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128689,35.23,0.58,111,59111,70,NULL,NULL,'LCRS B151558.8-033511',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.000103,NULL,'16.63',NULL,NULL,NULL,NULL,NULL,NULL,1,229.649167,-3.76817,0.329,NULL,45371743998,708933499,11077085,16.63),(128690,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128690,33.11,0.58,41.9,59112,70,NULL,NULL,'ESO 514- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00006,NULL,'14.6',0.6,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.6497917,-24.11994,0.629,NULL,46622830909,728481732,11382527,14.6),(128691,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128691,32.67,0.8,34.2,59112,75,NULL,'B','ESO 514- G 003',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128692,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128692,38.22,0.09,441,59113,70,NULL,NULL,'SDSS J151836.14+062551.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00018,NULL,'17.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.650708333,6.43119,0.049,NULL,56409409450,881397022,13771828,17.2),(128693,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128693,38.2,0.46,437,59114,70,NULL,NULL,'SDSS J151836.20+452055.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000173,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.650875,45.34886,0.037,NULL,59967602505,936993789,14640527,18.3),(128694,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128694,38.22,0.09,441,59115,70,NULL,NULL,'2MASX J15183627+0551231',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000113,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.651083,5.8565,0.065,NULL,56426230087,881659845,13775935,18.2),(128695,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128695,32.65,0.23,33.9,59116,NULL,NULL,'I','NGC 5903',NULL,'2001ApJ...546..681T',2001,1,2.7,NULL,'G',0.000017,NULL,'12.20',2.1,'E2','in a pair',NULL,NULL,NULL,1,229.6522083,-24.06858,0.477,NULL,46622832058,728481750,11382527,12.2),(128696,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128696,32.65,0.23,33.9,59116,NULL,NULL,NULL,'NGC 5903',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128697,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128697,32.69,0.23,34.5,59116,NULL,NULL,'Malmquist cor.','NGC 5903',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128698,'SBF','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128698,32.69,0.14,34.5,59116,74.4,NULL,NULL,'NGC 5903',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128699,'D-Sigma','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128699,32.08,0.4,26,59116,75,NULL,'Edat, raw','NGC 5903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128700,'D-Sigma','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128700,32.39,0.4,30.1,59116,75,NULL,'Edat, cor','NGC 5903',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128701,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128701,31.96,0.37,24.7,59116,95,NULL,'Weighted Mean','NGC 5903',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128702,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128702,32.28,0.63,28.6,59116,95,NULL,'Michard 1979b, c','NGC 5903',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128703,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128703,32.47,0.46,31.2,59116,95,NULL,'Michard 1979a','NGC 5903',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128704,'Faber-Jackson','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128704,33.62,0.81,53,59116,55,NULL,'Visvanathan & Sandage 1979','NGC 5903',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128705,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128705,32.23,0.41,28,59116,NULL,NULL,NULL,'NGC 5903',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128706,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128706,32.49,0.41,31.4,59116,NULL,NULL,'Malmquist cor.','NGC 5903',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128707,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128707,32.78,0.8,35.9,59116,75,NULL,'B','NGC 5903',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128708,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128708,32.61,0.45,33.2,59116,NULL,NULL,'K','NGC 5903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128709,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128709,32.68,0.4,34.4,59116,NULL,NULL,'mean','NGC 5903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128710,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128710,36.48,0.46,198,59117,70,NULL,NULL,'2MASX J15183660+4654292',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.6525,46.90808,0.057,NULL,59983754051,937246157,14644471,16.9),(128711,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128711,37.28,0.46,285,59118,70,NULL,NULL,'2MASX J15183690+1500512',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,229.653667,15.01433,0.077,NULL,59575330680,930864541,14544758,15.8),(128712,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128712,37.58,0.46,328,59119,70,NULL,NULL,'2MASX J15183703+3056245',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.654083333,30.94014,0.009,NULL,59903428332,935991067,14624860,16.9),(128713,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128713,37.92,0.46,384,59120,70,NULL,NULL,'2MASX J15183704+3040465',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.6545,30.67956,0.005,NULL,59906877658,936044963,14625702,17.1),(128714,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128714,36.93,0.46,243,59121,70,NULL,NULL,'2MASX J15183888+4045005',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000209,NULL,'16.1g',0.42,'Sy1',NULL,NULL,NULL,'Sy 1',1,229.662166667,40.75003,0.033,NULL,59972161511,937065023,14641640,16.1),(128715,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128715,37.51,0.21,317,59122,70,NULL,NULL,'VII Zw 594 NED03',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.6g',0.33,'E/SA0^-^',NULL,NULL,NULL,NULL,1,229.662375,59.08225,0.013,NULL,57718319459,901848741,14091386,16.6),(128716,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128716,36.34,0.46,186,59123,70,NULL,NULL,'2MASX J15183937+0347451',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000091,NULL,'15.9g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,229.664167,3.79578,0.033,NULL,56382853544,880982086,13765345,15.9),(128717,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128717,37.32,0.33,291,59124,70,NULL,NULL,'2MASX J15183972+2011574',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.665583,20.19936,0.181,NULL,59413114533,928329914,14505154,17.2),(128718,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128718,37.34,0.46,293,59125,70,NULL,NULL,'2MASX J15184091+5519579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.670375,55.33269,0.013,NULL,57580833817,899700528,14057820,17.4),(128719,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128719,36.71,0.17,219,59126,70,NULL,NULL,'2MASX J15184096+0425054',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00008,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,229.670583333,4.41817,0.065,NULL,56382205270,880971957,13765186,16.6),(128720,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128720,37.67,0.46,343,59127,70,NULL,NULL,'2MASX J15184208+0449084',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.675333333,4.819,0.065,NULL,56426290601,881660790,13775949,17.2),(128721,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128721,36.71,0.17,219,59128,70,NULL,NULL,'2MASX J15184250+0403494',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000071,NULL,'16.1g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,229.677,4.06372,0.029,NULL,56382347922,880974186,13765221,16.1),(128722,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128722,37.32,0.33,291,59129,70,NULL,NULL,'2MASX J15184256+2009354',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.677333333,20.15994,0.181,NULL,59413156286,928330566,14505165,16.6),(128723,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128723,38.22,0.09,441,59130,70,NULL,NULL,'SDSS J151842.67+055639.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'17.5R',0.11,NULL,NULL,NULL,NULL,NULL,1,229.677833,5.94425,0.073,NULL,56426195956,881659311,13775926,17.5),(128724,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128724,36.47,0.1,197,59131,70,NULL,NULL,'2MASX J15184300+2053284',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.93',0.19,NULL,NULL,NULL,NULL,NULL,1,229.67925,20.89128,0.161,NULL,59416483394,928382553,14505977,17.93),(128725,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128725,38.71,0.46,551,59132,70,NULL,NULL,'2MASX J15184412+0342274',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000122,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.6837083,3.70761,0.033,NULL,56382860217,880982190,13765346,17.2),(128726,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128726,36.65,0.33,214,59133,70,NULL,NULL,'2MASX J15184440+3314245',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000161,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.685166667,33.24008,0.021,NULL,60112875666,939263682,14675995,16.4),(128727,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128727,38.26,0.46,448,59134,70,NULL,NULL,'2MASX J15184489+1442575',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.1r',NULL,'BrClG',NULL,NULL,NULL,NULL,1,229.6870417,14.71606,0.081,NULL,59575787860,930871685,14544870,16.1),(128728,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128728,38.22,0.09,441,59135,70,NULL,NULL,'2MASX J15184500+0616264',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,'Group member',NULL,NULL,NULL,1,229.687625,6.27406,0.053,NULL,56409435819,881397434,13771834,16.9),(128729,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128729,38.22,0.09,441,59136,70,NULL,NULL,'2MASX J15184574+0613554',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000147,NULL,'16.6g',0.39,'BrClG','Group member',NULL,'NAT',NULL,1,229.690541667,6.23225,0.053,NULL,56409433203,881397393,13771834,16.6),(128730,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128730,38.22,0.09,441,59137,70,NULL,NULL,'2MASX J15184613+0600404',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00012,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.692167,6.01119,0.073,NULL,56426198928,881659358,13775927,18.2),(128731,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128731,36.97,0.27,248,59138,70,NULL,NULL,'2MASX J15184647+3316485',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.6937083,33.28025,0.021,NULL,60112868973,939263577,14675993,17.3),(128732,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128732,37.29,0.46,288,59139,70,NULL,NULL,'2MASX J15184652+1222035',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.69375,12.36775,0.117,NULL,59561274998,930644921,14541326,17.6),(128733,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128733,38.22,0.09,441,59140,70,NULL,NULL,'2MASX J15184742+0617014',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.697583333,6.28367,0.053,NULL,56409435938,881397436,13771834,18.3),(128734,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128734,38.22,0.09,441,59141,70,NULL,NULL,'2MASX J15184789+0607394',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.699625,6.12769,0.053,NULL,56409210898,881393920,13771780,17.1),(128735,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128735,37.51,0.21,317,59142,70,NULL,NULL,'VII Zw 594 NED04',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.1g',0.41,'E',NULL,NULL,NULL,NULL,1,229.704958333,59.06411,0.013,NULL,57718319188,901848737,14091386,16.1),(128736,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128736,37.22,0.46,278,59143,70,NULL,NULL,'2MASX J15185066+4854219',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.711167,48.90611,0.033,NULL,59936896065,936514001,14633031,17.7),(128737,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128737,37.98,0.13,394,59144,70,NULL,NULL,'2MASX J15185105+1944234',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.32',0.35,'BrClG',NULL,NULL,NULL,NULL,1,229.7127917,19.73981,0.165,NULL,59413274717,928332417,14505194,17.32),(128738,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128738,38.04,0.46,406,59145,70,NULL,NULL,'2MASX J15185134+2844288',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.60',0.16,'BrClG',NULL,NULL,NULL,NULL,1,229.7139583,28.74131,0.037,NULL,59908828453,936075444,14626178,18.6),(128739,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128739,37.86,0.21,374,59146,70,NULL,NULL,'2MASX J15185162+2709168',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.29',0.22,NULL,NULL,NULL,NULL,NULL,1,229.7149583,27.15467,0.077,NULL,59911320602,936114384,14626787,18.29),(128740,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128740,36.48,0.78,198,59147,70,NULL,NULL,'2MASX J15185164-2007572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.715125,-20.13264,0.485,NULL,46616306544,728379789,11380934,15.2),(128741,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128741,37.91,0.46,382,59148,70,NULL,NULL,'2MASX J15185222+0251154',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000105,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.7177083,2.85414,0.049,NULL,56384073180,881001143,13765642,17.2),(128742,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128742,37.14,0.46,268,59149,70,NULL,NULL,'2MASX J15185243+3105115',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.718375,31.08647,0.017,NULL,59903408534,935990758,14624855,16.9),(128743,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128743,35.81,0.25,145,59150,74.4,NULL,NULL,'CGCG 049-117',NULL,'2013AJ....146...86T',2013,1,0.76,'1994AJ....107.1629T has 13044 +- 100 km/sec.','G',0.00013,NULL,'14.16',0.64,'Sbc',NULL,NULL,NULL,NULL,1,229.719167,4.86569,0.069,NULL,56426298223,881660909,13775951,14.16),(128744,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128744,36.02,0.21,160,59150,70,NULL,NULL,'CGCG 049-117',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128745,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128745,38.22,0.09,441,59151,70,NULL,NULL,'2MASX J15185271+0621014',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000047,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.7197917,6.35039,0.049,NULL,56409443416,881397553,13771836,18.1),(128746,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128746,38.04,0.46,406,59152,70,NULL,NULL,'2MASX J15185304+1144104',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.721125,11.73636,0.097,NULL,59355851127,927435173,14491174,16.8),(128747,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128747,38.22,0.09,441,59153,70,NULL,NULL,'2MASX J15185357+0601004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000057,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.723166667,6.01686,0.073,NULL,56426193972,881659280,13775926,17.4),(128748,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128748,36.13,0.09,168,59154,70,NULL,NULL,'2MASX J15185364+0734334',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000158,NULL,'16.4g',0.29,NULL,'Group member',NULL,NULL,NULL,1,229.723583,7.57592,0.061,NULL,59349775199,927340237,14489691,16.4),(128749,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128749,38.22,0.09,441,59155,70,NULL,NULL,'2MASX J15185464+0603164',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000127,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.7277083,6.05456,0.073,NULL,56426121191,881658143,13775908,17.5),(128750,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128750,37.11,0.46,264,59156,70,NULL,NULL,'2MASX J15185503+3006295',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,229.729125,30.10819,0.041,NULL,59907091149,936048299,14625754,16.5),(128751,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128751,37.27,0.46,285,59157,70,NULL,NULL,'2MASX J15185509+3418135',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.7295417,34.30381,0.041,NULL,60105122331,939142536,14674102,17),(128752,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128752,38.88,0.46,598,59158,70,NULL,NULL,'2MASX J15185510+1905114',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.7297083,19.08656,0.145,NULL,59412346630,928317916,14504967,17.7),(128753,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128753,37.86,0.21,374,59159,70,NULL,NULL,'2MASX J15185558+2707398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.731625,27.12783,0.077,NULL,59911310258,936114222,14626784,17.9),(128754,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128754,35.95,0.57,155,59160,70,NULL,NULL,'2MASX J15185566-0827238',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.82',0.2,'poss. LINER',NULL,NULL,NULL,NULL,1,229.731833,-8.45678,0.325,NULL,46480300735,726254698,11347729,16.82),(128755,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128755,36.89,0.46,239,59161,70,NULL,NULL,'2MASX J15185576+2127493',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.56',0.22,NULL,NULL,NULL,NULL,NULL,1,229.73225,21.46378,0.149,NULL,59415687439,928370116,14505783,17.56),(128756,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128756,37.75,0.46,355,59162,70,NULL,NULL,'2MASX J15185577+1450475',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.732333,14.84672,0.081,NULL,59575303581,930864118,14544751,18),(128757,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128757,38.22,0.46,440,59163,70,NULL,NULL,'2MASX J15185603+5501437',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.7335417,55.02881,0.013,NULL,57581481958,899710655,14057978,18.4),(128758,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128758,37.64,0.15,337,59164,70,NULL,NULL,'SDSS J151856.15+484403.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.7339583,48.73419,0.033,NULL,59937110667,936517354,14633083,17.6),(128759,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128759,36.47,0.1,197,59165,70,NULL,NULL,'2MASX J15185622+2103313',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.734167,21.05875,0.161,NULL,59416335617,928380244,14505941,18),(128760,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128760,36.97,0.27,248,59166,70,NULL,NULL,'SDSS J151856.39+332152.2',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000172,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.7349583,33.36453,0.017,NULL,60112838676,939263104,14675986,16.4),(128761,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128761,37.66,0.46,340,59167,70,NULL,NULL,'2MASX J15185642+5412297',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.735083333,54.20825,0.017,NULL,59662818206,932231534,14566117,17.6),(128762,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128762,36.1,0.27,166,59168,70,NULL,NULL,'CGCG 049-121',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00011,NULL,'15.3',0.44,NULL,NULL,NULL,NULL,NULL,1,229.735833,5.19178,0.085,NULL,56426406832,881662606,13775978,15.3),(128763,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128763,37.98,0.13,394,59169,70,NULL,NULL,'SDSS J151856.97+194200.2',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.737416667,19.70008,0.165,NULL,59413278102,928332470,14505194,17.3),(128764,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128764,38.22,0.09,441,59170,70,NULL,NULL,'2MASX J15185768+0611514',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000057,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.740291667,6.19775,0.053,NULL,56409425705,881397276,13771832,17.5),(128765,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128765,38.22,0.09,441,59171,70,NULL,NULL,'2MASX J15185826+0557584',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000063,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,229.743041667,5.96628,0.073,NULL,56426123973,881658187,13775909,16),(128766,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128766,38,0.27,397,59172,70,NULL,NULL,'2MASX J15185843+0216044',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.7435,2.26783,0.109,NULL,56377642977,880900671,13764072,17.6),(128767,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128767,36.14,0.11,169,59173,70,NULL,NULL,'2MASX J15185861+0431454',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.7442083,4.52936,0.065,NULL,56427560813,881680637,13776259,16.8),(128768,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128768,38.22,0.09,441,59174,70,NULL,NULL,'2MASX J15185946+0604564',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00006,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.7477917,6.08239,0.053,NULL,56426122440,881658163,13775908,16.8),(128769,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128769,36.97,0.27,248,59175,70,NULL,NULL,'2MASX J15185950+3319009',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000185,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,229.747875,33.31678,0.021,NULL,60112868350,939263567,14675993,16),(128770,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128770,38,0.27,397,59176,70,NULL,NULL,'SDSS J151859.84+021428.6',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.749333,2.24131,0.109,NULL,56377641450,880900647,13764072,16.6),(128771,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128771,37.97,0.46,392,59177,70,NULL,NULL,'2MASX J15190003+0908514',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.7500417,9.14778,0.061,NULL,59350760708,927355636,14489931,18),(128772,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128772,38.24,0.14,444,59178,70,NULL,NULL,'SDSS J151900.01+041038.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.750083,4.17739,0.041,NULL,56382341703,880974089,13765220,18.3),(128773,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128773,37.25,0.16,281,59179,70,NULL,NULL,'2MASX J15190107+4503374',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.754417,45.06036,0.033,NULL,59967792311,936996754,14640574,17.1),(128774,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128774,36.71,0.17,219,59180,70,NULL,NULL,'2MASX J15190129+0402594',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000099,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.7552917,4.04997,0.029,NULL,56382353390,880974271,13765222,16.9),(128775,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128775,35.81,0.25,145,59181,74.4,NULL,NULL,'CGCG 049-120',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.00011,NULL,'13.7',0.2,'E/S0',NULL,NULL,NULL,NULL,1,229.756083,4.52078,0.065,NULL,56427557247,881680581,13776259,13.7),(128776,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128776,36.02,0.21,160,59181,70,NULL,NULL,'CGCG 049-120',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128777,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128777,36.14,0.11,169,59181,70,NULL,NULL,'CGCG 049-120',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128778,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128778,36.03,0.4,161,59181,NULL,NULL,'mean','CGCG 049-120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128779,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128779,36.06,0.45,163,59181,NULL,NULL,'K','CGCG 049-120',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128780,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128780,36.14,0.11,169,59182,70,NULL,NULL,'2MASX J15190155+0423294',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.7564583,4.39164,0.065,NULL,56427571506,881680804,13776262,17.5),(128781,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128781,35.16,0.46,108,59183,70,NULL,NULL,'2MASX J15190268+1346465',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.11',0.37,NULL,NULL,NULL,NULL,NULL,1,229.7610417,13.7795,0.101,NULL,59573126550,930830102,14544220,16.11),(128782,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128782,37.51,0.21,317,59184,70,NULL,NULL,'VII Zw 594 NED07',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000189,NULL,'16.6g',0.26,'SA:0/a:',NULL,NULL,NULL,NULL,1,229.762583,59.12633,0.013,NULL,57718298139,901848408,14091381,16.6),(128783,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128783,36.16,0.09,171,59185,70,NULL,NULL,'CGCG 049-125',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.000107,NULL,'15.5',0.57,NULL,NULL,NULL,NULL,NULL,1,229.764125,8.13872,0.053,NULL,59353163016,927393172,14490518,15.5),(128784,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128784,35.55,0.25,129,59186,74.4,NULL,NULL,'CGCG 049-123',NULL,'2013AJ....146...86T',2013,1,1.03,NULL,'G',0.00009,NULL,'14.6g',0.67,'E/S0',NULL,NULL,NULL,NULL,1,229.764625,4.33364,0.045,NULL,56427574937,881680858,13776263,14.6),(128785,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128785,36.02,0.21,160,59186,70,NULL,NULL,'CGCG 049-123',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128786,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128786,36.71,0.17,219,59186,70,NULL,NULL,'CGCG 049-123',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128787,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128787,37.51,0.46,317,59187,70,NULL,NULL,'2MASX J15190349+4811139',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000183,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.764583,48.18722,0.045,NULL,59937608213,936525128,14633205,17.1),(128788,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128788,37.83,0.46,368,59188,70,NULL,NULL,'2MASX J15190453+0634264',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.76875,6.574,0.057,NULL,56409347164,881396049,13771813,17.5),(128789,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128789,36.71,0.17,219,59189,70,NULL,NULL,'2MASX J15190503+0415334',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000071,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,229.771125,4.25939,0.041,NULL,56427564763,881680699,13776260,16.7),(128790,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128790,35,0.46,99.9,59190,70,NULL,NULL,'MCG -03-39-005',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000057,NULL,'14.3',0.3,NULL,NULL,NULL,NULL,NULL,1,229.7724583,-15.99619,0.437,NULL,46669123342,729205052,11393828,14.3),(128791,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128791,36.47,0.1,197,59191,70,NULL,NULL,'2MASX J15190560+2053576',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.29',0.17,NULL,NULL,NULL,NULL,NULL,1,229.773417,20.89944,0.181,NULL,59416356368,928380568,14505946,18.29),(128792,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128792,37.25,0.16,281,59192,70,NULL,NULL,'2MASX J15190588+4501554',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000165,NULL,'16.0g',0.46,'BrClG          AGN',NULL,NULL,NULL,NULL,1,229.774375,45.03219,0.033,NULL,59967792694,936996760,14640574,16),(128793,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128793,38.01,0.46,399,59193,70,NULL,NULL,'2MASX J15190588-0053087',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.774625,-0.88575,0.177,NULL,45377468763,709022949,11078483,17.5),(128794,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128794,34.12,NULL,66.6,59194,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09812',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000063,NULL,'15.80',0.12,'Sd','Pair member (points to parent)',NULL,NULL,NULL,1,229.7775,9.79861,0.057,NULL,59357339804,927458434,14491538,15.8),(128795,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128795,34.15,NULL,67.6,59194,NULL,NULL,'Dipole + Quadrupole','UGC 09812',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128796,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128796,34.17,NULL,68.2,59194,NULL,NULL,'Dipole','UGC 09812',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128797,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128797,38.24,0.14,444,59195,70,NULL,NULL,'SDSS J151906.71+042052.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.778,4.34792,0.045,NULL,56427577019,881680890,13776263,18.3),(128798,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128798,35.93,0.46,154,59196,70,NULL,NULL,'CGCG 021-075',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000085,NULL,'15.8g',0.43,'AGN',NULL,NULL,NULL,NULL,1,229.77825,1.04514,0.129,NULL,56379479294,880929363,13764521,15.8),(128799,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128799,37.14,0.46,268,59197,70,NULL,NULL,'SDSS J151907.47+161930.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.781125,16.32519,0.069,NULL,59566579915,930727811,14542622,NULL),(128800,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128800,37.08,0.46,260,59198,70,NULL,NULL,'2MASX J15190785-0010597',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000091,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.78275,-0.18342,0.185,NULL,45374424305,708975379,11077740,16.8),(128801,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128801,38.02,0.33,402,59199,70,NULL,NULL,'2MASX J15190843+0725544',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.785167,7.43192,0.061,NULL,59349869128,927341705,14489714,18),(128802,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128802,38.22,0.09,441,59200,70,NULL,NULL,'2MASX J15190854+0608344',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.785541667,6.14306,0.053,NULL,56409294208,881395222,13771800,16.8),(128803,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128803,38.22,0.09,441,59201,70,NULL,NULL,'2MASX J15190858+0553544',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0001,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.78575,5.89836,0.073,NULL,56426147766,881658558,13775914,18),(128804,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128804,37.32,0.46,291,59202,70,NULL,NULL,'2MASX J15190952+1151152',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.7897083,11.85422,0.097,NULL,59342175477,927221491,14487835,NULL),(128805,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128805,37.06,0.46,258,59203,70,NULL,NULL,'2MASX J15190965+0511412',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.790375,5.19469,0.085,NULL,56426437817,881663090,13775985,18),(128806,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128806,37.51,0.21,317,59204,70,NULL,NULL,'VII Zw 594 NED09',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'16.7g',0.25,'SB0^0^:',NULL,NULL,NULL,NULL,1,229.7910417,59.11939,0.013,NULL,57718327717,901848870,14091388,16.7),(128807,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128807,37.98,0.33,394,59205,70,NULL,NULL,'2MASX J15191053+1048422',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.793875,10.81175,0.085,NULL,59356381159,927443455,14491303,18),(128808,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128808,38.07,0.33,411,59206,70,NULL,NULL,'2MASX J15191097+0305322',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000091,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.79575,3.09225,0.065,NULL,56381968869,880968263,13765129,17.1),(128809,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128809,37.82,0.33,366,59207,70,NULL,NULL,'2MASX J15191093+4030297',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000187,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,229.79575,40.50811,0.025,NULL,59971411446,937053303,14641457,16.4),(128810,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128810,36.8,0.46,229,59208,70,NULL,NULL,'2MASX J15191112+2152406',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.796375,21.87789,0.137,NULL,59413639243,928338113,14505283,17.2),(128811,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128811,37.66,0.46,341,59209,70,NULL,NULL,'2MASX J15191119+5712019',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000069,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.7965417,57.20067,0.025,NULL,57589055420,899828990,14059827,17.9),(128812,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128812,37.98,0.13,394,59210,70,NULL,NULL,'2MASX J15191142+1938046',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.797458333,19.63461,0.173,NULL,59413272396,928332381,14505193,16.7),(128813,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128813,37.74,0.46,353,59211,70,NULL,NULL,'2MASX J15191138+4551044',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,229.7975,45.85117,0.045,NULL,59983273594,937238649,14644353,16.5),(128814,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128814,36.71,0.17,219,59212,70,NULL,NULL,'2MASX J15191208+0426092',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.80025,4.43586,0.065,NULL,56427607714,881681370,13776271,16.8),(128815,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128815,38.07,0.33,411,59213,70,NULL,NULL,'2MASX J15191257+0300372',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000072,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.802417,3.01033,0.049,NULL,56384089417,881001397,13765646,18),(128816,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128816,37.1,0.46,263,59214,70,NULL,NULL,'2MASX J15191296+4845019',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.803917,48.75053,0.033,NULL,59937111764,936517371,14633083,16.9),(128817,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128817,36.44,0.46,194,59215,70,NULL,NULL,'2MASX J15191313+0607502',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'15.6g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,229.804666667,6.13061,0.053,NULL,56409299160,881395299,13771801,15.6),(128818,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128818,38.22,0.09,441,59216,70,NULL,NULL,'SDSS J151913.38+055640.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'17.6R',0.13,NULL,NULL,NULL,NULL,NULL,1,229.805791667,5.94461,0.073,NULL,56426153752,881658652,13775916,17.6),(128819,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128819,36.98,0.46,249,59217,70,NULL,NULL,'2MASX J15191347+3021390',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,229.8062083,30.36075,0,NULL,59907001570,936046899,14625732,16.5),(128820,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128820,35.87,0.6,149,59218,70,NULL,NULL,'2MASX J15191372-1947318',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,229.807167,-19.79222,0.493,NULL,46616390728,728381105,11380954,15.85),(128821,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128821,35.84,0.35,147,59219,NULL,NULL,NULL,'CGCG 049-127',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'15.7',0.3,'Sbc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,229.8089583,8.00417,0.053,NULL,59353277713,927394964,14490546,15.7),(128822,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128822,35.92,0.34,153,59219,NULL,NULL,'Malmquist cor.','CGCG 049-127',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128823,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128823,36.17,0.2,171,59219,74.4,NULL,NULL,'CGCG 049-127',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128824,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128824,37.98,0.33,394,59220,70,NULL,NULL,'SDSS J151914.45+105401.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.81025,10.90044,0.081,NULL,59356369556,927443274,14491301,18.5),(128825,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128825,35.81,0.35,145,59221,NULL,NULL,NULL,'CGCG 049-126',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000013,NULL,'15.6',0.3,'Sc',NULL,NULL,NULL,NULL,1,229.811125,7.86547,0.057,NULL,59353326380,927395724,14490558,15.6),(128826,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128826,35.85,0.2,148,59221,74.4,NULL,NULL,'CGCG 049-126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128827,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128827,35.91,0.34,152,59221,NULL,NULL,'Malmquist cor.','CGCG 049-126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128828,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128828,37.37,0.46,298,59222,70,NULL,NULL,'2MASX J15191478+2712418',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.811625,27.21161,0.081,NULL,59911320076,936114376,14626787,18),(128829,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128829,38.09,0.46,415,59223,70,NULL,NULL,'2MASX J15191486+4142237',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000194,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.81175,41.70658,0.037,NULL,59975948441,937124194,14642565,16.7),(128830,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128830,36.9,0.46,240,59224,70,NULL,NULL,'2MASX J15191541+2001096',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,229.81425,20.0195,0.181,NULL,59413136918,928330264,14505160,16.2),(128831,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128831,38.9,0.46,603,59225,70,NULL,NULL,'2MASX J15191567+4146337',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.815541667,41.77606,0.037,NULL,59975949900,937124217,14642565,18.2),(128832,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128832,37.82,0.33,366,59226,70,NULL,NULL,'2MASX J15191602+4032287',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.816667,40.54136,0.025,NULL,59971410964,937053296,14641457,16.9),(128833,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128833,36.82,0.33,231,59227,70,NULL,NULL,'2MASX J15191603+0401493',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.816833,4.03022,0.029,NULL,56427664342,881682255,13776285,17.6),(128834,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128834,38.22,0.09,441,59228,70,NULL,NULL,'2MASX J15191633+0600063',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.818,6.00161,0.073,NULL,56426166146,881658846,13775919,17.3),(128835,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128835,38.47,0.46,495,59229,70,NULL,NULL,'2MASX J15191631-0109236',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000105,NULL,'17.6g',0.21,'AGN',NULL,NULL,NULL,NULL,1,229.818083,-1.15644,0.181,NULL,45377596977,709024952,11078514,17.6),(128836,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128836,37.13,0.46,266,59230,70,NULL,NULL,'2MASX J15191664-0020566',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000096,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.81925,-0.34894,0.185,NULL,45374407278,708975113,11077736,16.5),(128837,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128837,37.8,0.69,363,59230,70,NULL,NULL,'2MASX J15191664-0020566',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128838,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128838,37.57,0.33,326,59231,70,NULL,NULL,'2MASX J15191672+2623068',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.81975,26.38525,0.113,NULL,59910385173,936099768,14626558,16.5),(128839,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128839,37.04,0.33,256,59232,70,NULL,NULL,'2MASX J15191750+5650109',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.82275,56.83644,0.029,NULL,57593221043,899894078,14060844,17.2),(128840,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128840,36.47,0.1,197,59233,70,NULL,NULL,'2MASX J15191751+2050116',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.822917,20.83642,0.181,NULL,59416349580,928380462,14505944,17.4),(128841,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128841,30.88,0.8,15,59234,75,NULL,'MAT, I','ESO 328- G 043',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000019,NULL,'14.5',1.8,'(R\')SB(s)dm',NULL,NULL,NULL,NULL,1,229.8232083,-41.23372,0.565,NULL,47066984523,735421633,11490963,14.5),(128842,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128842,31.4,0.8,19.1,59234,75,NULL,NULL,'ESO 328- G 043',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128843,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128843,30.75,0.32,14.1,59234,85,NULL,'I, inv','ESO 328- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128844,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128844,30.76,0.32,14.2,59234,85,NULL,'I, raw','ESO 328- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128845,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128845,31.25,0.43,17.7,59234,75,NULL,'MAT, I, raw','ESO 328- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128846,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128846,31.27,0.43,18,59234,75,NULL,'MAT, I, inv','ESO 328- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128847,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128847,31.52,0.43,20.1,59234,75,NULL,'MAT, I, cor','ESO 328- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128848,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128848,38.63,0.46,532,59235,70,NULL,NULL,'2MASX J15191772+2842128',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.823833333,28.70367,0.037,NULL,59910922102,936108157,14626689,18.3),(128849,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128849,37.73,0.33,351,59236,70,NULL,NULL,'2MASX J15191792+0117213',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.824583,1.28922,0.125,NULL,56379518213,880929972,13764530,17.3),(128850,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128850,36.1,0.27,166,59237,70,NULL,NULL,'2MASX J15191809+0515093',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.825417,5.25269,0.085,NULL,56426445541,881663211,13775987,16.2),(128851,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128851,37.13,0.33,267,59238,70,NULL,NULL,'2MASX J15191818+3033220',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.825833,30.556,0,NULL,59906904751,936045386,14625709,17.6),(128852,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128852,36.64,0.46,213,59239,70,NULL,NULL,'2MASX J15191896+0425553',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.829083,4.43192,0.045,NULL,56427596503,881681195,13776268,16.4),(128853,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128853,37.98,0.33,394,59240,70,NULL,NULL,'SDSS J151919.50+455814.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.831333,45.97069,0.033,NULL,59983324305,937239442,14644366,18.2),(128854,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128854,37.13,0.33,267,59241,70,NULL,NULL,'2MASX J15191950+3042590',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,229.831416667,30.71653,0,NULL,59906858194,936044659,14625697,16.6),(128855,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128855,37.85,0.46,372,59242,70,NULL,NULL,'2MASX J15191985+0928492',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.832667,9.48042,0.061,NULL,59355387077,927427923,14491061,17.2),(128856,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128856,38.11,0.33,418,59243,70,NULL,NULL,'2MASX J15192056+0536243',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.835667,5.60675,0.065,NULL,56426962911,881671295,13776113,17.6),(128857,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128857,38.02,0.33,402,59244,70,NULL,NULL,'2MASX J15192069+0723402',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,'Group member',NULL,NULL,NULL,1,229.836291667,7.39447,0.061,NULL,59349915560,927342430,14489725,17.3),(128858,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128858,37.01,0.33,253,59245,70,NULL,NULL,'2MASX J15192305+0333543',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.0001,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,229.845958333,3.56511,0.033,NULL,56382037885,880969341,13765145,16.5),(128859,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128859,36,0.46,159,59246,70,NULL,NULL,'2MASX J15192338+0506173',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',NULL,NULL,'15.5g',0.44,NULL,NULL,NULL,NULL,NULL,1,229.8475417,5.10492,0.085,NULL,56426486561,881663852,13775997,15.5),(128860,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128860,37.92,0.46,383,59247,70,NULL,NULL,'2MASX J15192426+2642338',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.851208333,26.70942,0.065,NULL,59910166369,936096349,14626505,17.6),(128861,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PTF09dnp',NULL,128861,35.92,0.02,147,59248,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09dnp',0.037559,'2014MNRAS.438.1391P',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.8515417,49.49897,0.025,NULL,59666370579,932287040,14566985,NULL),(128862,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PTF09dnp',NULL,128862,36.22,0.07,169,59248,70,NULL,'SiFTO+SALT2, SN PTF09dnp','PTF09dnp',0.037559,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128863,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128863,35.82,0.25,146,59249,74.4,NULL,NULL,'GIN 388',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000047,NULL,'14.56',0.4,'E/S0',NULL,NULL,NULL,NULL,1,229.852833,4.57972,0.065,NULL,56427581686,881680963,13776265,14.56),(128864,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128864,36.02,0.21,160,59249,70,NULL,NULL,'GIN 388',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128865,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128865,36.14,0.11,169,59249,70,NULL,NULL,'GIN 388',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128866,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128866,38.24,0.14,444,59250,70,NULL,NULL,'2MASX J15192471+0419533',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000096,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.853,4.33147,0.045,NULL,56427783865,881684122,13776314,18.5),(128867,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128867,33.42,0.59,48.4,59251,NULL,NULL,'Malmquist cor.','UGC 09814',NULL,'2009ApJS..182..474S',2009,1,1.13,'Multiple SDSS entries describe this object.','G',0.000023,NULL,'14.9g',0.49,'Sdm:',NULL,NULL,NULL,NULL,1,229.854208333,11.05431,0.089,NULL,59356426348,927444161,14491315,14.9),(128868,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128868,33.46,0.2,49.2,59251,74.4,NULL,NULL,'UGC 09814',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128869,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128869,33.49,0.57,50,59251,NULL,NULL,NULL,'UGC 09814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128870,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128870,37.67,0.46,342,59252,70,NULL,NULL,'2MASX J15192513+0647472',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000016,NULL,'16.8g',0.3,NULL,'Group member',NULL,NULL,NULL,1,229.854667,6.79644,0.057,NULL,56409327505,881395742,13771808,16.8),(128871,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128871,38.08,0.46,414,59253,70,NULL,NULL,'2MASX J15192523+2323535',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.8552083,23.39828,0.161,NULL,59424500945,928507827,14507934,17.5),(128872,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128872,34.23,0.8,70.1,59254,75,NULL,'CF, r','NGC 5918',NULL,'1997ApJS..109..333W',1997,1,2.27,NULL,'G',0.000017,NULL,'13.8g',0.71,'Scd:','Field galaxy',NULL,NULL,NULL,1,229.85525,45.88025,0.045,NULL,59983323768,937239433,14644366,13.8),(128873,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128873,33.84,0.2,58.6,59254,74.4,NULL,NULL,'NGC 5918',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128874,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128874,33.92,0.38,60.7,59254,75,NULL,'CF, r, raw','NGC 5918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128875,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128875,33.97,0.47,62.2,59254,NULL,NULL,'H','NGC 5918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128876,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128876,34.04,0.45,64.2,59254,NULL,NULL,'K','NGC 5918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128877,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128877,34.06,0.46,64.8,59254,NULL,NULL,'J','NGC 5918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128878,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128878,34.08,0.38,65.4,59254,75,NULL,'CF, r, inv','NGC 5918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128879,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128879,34.09,0.49,65.8,59254,75,NULL,'IR','NGC 5918',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128880,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128880,34.22,0.38,69.9,59254,75,NULL,'CF, r, cor','NGC 5918',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128881,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128881,34.25,0.4,70.9,59254,NULL,NULL,'mean','NGC 5918',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128882,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128882,35.88,0.46,150,59255,70,NULL,NULL,'2MASX J15192538+4930043',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000191,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,229.855667,49.50131,0.025,NULL,59666370656,932287041,14566985,15.8),(128883,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128883,37.25,0.16,281,59256,70,NULL,NULL,'2MASX J15192545+4509073',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000194,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.855833,45.152,0.033,NULL,59967765267,936996332,14640567,16.8),(128884,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128884,36.1,0.27,166,59257,70,NULL,NULL,'2MASX J15192599+0500013',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.858333,5.00039,0.069,NULL,56426477396,881663709,13775995,16.6),(128885,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128885,37.43,0.46,306,59258,70,NULL,NULL,'2MASX J15192604+2729528',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.858667,27.49786,0.085,NULL,59911328272,936114504,14626789,17.4),(128886,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128886,38.24,0.14,444,59259,70,NULL,NULL,'SDSS J151926.45+040557.8',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000077,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.86025,4.09942,0.041,NULL,56427673824,881682403,13776287,18.1),(128887,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128887,37.57,0.33,326,59260,70,NULL,NULL,'2MASX J15192663+2624487',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.861,26.41353,0.113,NULL,59910352821,936099262,14626550,17.7),(128888,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128888,38.51,0.46,503,59261,70,NULL,NULL,'SDSS J151927.31+331713.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.863833,33.28703,0.045,NULL,60104537606,939133400,14673959,17.8),(128889,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128889,36.02,0.21,160,59262,70,NULL,NULL,'GIN 393',NULL,'2001MNRAS.321..277C',2001,1,0.77,NULL,'G',0.00008,NULL,'14.29',0.5,'E/S0',NULL,NULL,NULL,NULL,1,229.86525,4.09606,0.041,NULL,56427673685,881682401,13776287,14.29),(128890,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128890,36.09,0.25,165,59262,74.4,NULL,NULL,'GIN 393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128891,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128891,36.82,0.33,231,59262,70,NULL,NULL,'GIN 393',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128892,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128892,36.47,0.1,197,59263,70,NULL,NULL,'2MASX J15192913+2046485',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.32',0.15,NULL,NULL,NULL,NULL,NULL,1,229.87125,20.78011,0.181,NULL,59416346705,928380417,14505944,18.32),(128893,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128893,38.43,0.46,486,59264,70,NULL,NULL,'2MASX J15192917+0832362',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000179,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.871667,8.54347,0.045,NULL,59350792042,927356125,14489939,17.9),(128894,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128894,37.48,0.46,313,59265,70,NULL,NULL,'2MASX J15192939+0301143',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.872417,3.0205,0.065,NULL,56384043297,881000676,13765635,17.1),(128895,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128895,37.32,0.46,291,59266,70,NULL,NULL,'2MASX J15192950+0704482',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00007,NULL,'17.3g',0.27,NULL,'Group member',NULL,NULL,NULL,1,229.872833,7.07997,0.061,NULL,59349849265,927341394,14489709,17.3),(128896,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128896,37.64,0.15,337,59267,70,NULL,NULL,'2MASX J15193007+4851394',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.8754583,48.861,0.033,NULL,59936890038,936513906,14633029,17),(128897,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128897,38.06,0.27,410,59268,70,NULL,NULL,'SDSS J151930.31+044217.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.876333,4.70483,0.065,NULL,56429706953,881714171,13776783,18.5),(128898,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128898,38.26,0.46,448,59269,70,NULL,NULL,'2MASX J15193041+1024272',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.8765417,10.40761,0.093,NULL,59356946018,927452281,14491441,17.8),(128899,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128899,37.84,0.27,370,59270,70,NULL,NULL,'2MASX J15193074+0457083',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,229.878125,4.95239,0.069,NULL,56426252091,881660188,13775940,16.5),(128900,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128900,37.73,0.33,351,59271,70,NULL,NULL,'SDSS J151930.76+011908.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.878166667,1.31889,0.125,NULL,56379562985,880930671,13764541,18.3),(128901,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128901,38.61,0.46,528,59272,70,NULL,NULL,'SDSS J151930.89+131436.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,229.87875,13.24339,0.105,NULL,59573672337,930838630,14544353,NULL),(128902,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128902,36.47,0.1,197,59273,70,NULL,NULL,'2MASX J15193179+2053005',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00014,NULL,'17.06',0.26,'E2','Compact group member',NULL,NULL,NULL,1,229.882458333,20.88356,0.177,NULL,59416362892,928380670,14505947,17.06),(128903,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128903,37.68,0.46,344,59274,70,NULL,NULL,'2MASX J15193229+0923482',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,229.884583333,9.39675,0.065,NULL,59355416399,927428381,14491068,16.5),(128904,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128904,38.76,0.46,564,59275,70,NULL,NULL,'SDSS J151932.62+313830.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.885958333,31.64183,0.029,NULL,59904005441,936000085,14625001,18.6),(128905,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128905,34.81,0.69,91.5,59276,100,NULL,'mid-IR','CGCG 077-074',NULL,'2013ApJ...771...88L',2013,1,0.95,NULL,'G',0.000016,NULL,'14.7g',0.65,'Sa',NULL,NULL,NULL,NULL,1,229.886083,9.96003,0.069,NULL,59357332445,927458319,14491536,14.7),(128906,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128906,35.96,0.2,156,59276,74.4,NULL,NULL,'CGCG 077-074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128907,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128907,38.11,0.33,418,59277,70,NULL,NULL,'SDSS J151932.68+053051.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'17.4R',0.11,NULL,NULL,NULL,NULL,NULL,1,229.886208333,5.51439,0.085,NULL,56426981994,881671593,13776118,17.4),(128908,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128908,37.93,0.46,386,59278,70,NULL,NULL,'2MASX J15193324+2810432',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.888458333,28.17886,0.021,NULL,59911116793,936111199,14626737,18.2),(128909,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128909,37.79,0.17,361,59279,70,NULL,NULL,'2MASX J15193354+3247153',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.889833333,32.78753,0.021,NULL,60112830216,939262972,14675983,17.9),(128910,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128910,38.11,0.46,419,59280,70,NULL,NULL,'SDSS J151933.66+201219.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.8902917,20.20544,0.177,NULL,59412706565,928323540,14505055,18.1),(128911,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128911,35.82,0.25,146,59281,74.4,NULL,NULL,'GIN 392',NULL,'2013AJ....146...86T',2013,1,0.62,'Wegner et al (1999MNRAS.305..259W) have V = 11533 +- 72 km/s.','G',0.000108,NULL,'16.2g',0.37,'BrClG;E',NULL,NULL,NULL,NULL,1,229.890541667,4.33797,0.045,NULL,56427784470,881684132,13776314,16.2),(128912,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128912,36.02,0.21,160,59281,70,NULL,NULL,'GIN 392',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128913,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128913,38.24,0.14,444,59281,70,NULL,NULL,'GIN 392',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128914,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128914,37.16,0.46,271,59282,70,NULL,NULL,'2MASX J15193370+3216103',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.8905,32.26961,0.041,NULL,60083439609,938803743,14668808,17.2),(128915,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128915,38.24,0.14,444,59283,70,NULL,NULL,'2MASX J15193380+0406533',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.89075,4.11475,0.041,NULL,56427660767,881682199,13776284,17.7),(128916,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128916,37.84,0.27,370,59284,70,NULL,NULL,'2MASX J15193381+0457523',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.890917,4.96467,0.069,NULL,56426251820,881660184,13775940,17.4),(128917,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128917,37.14,0.46,268,59285,70,NULL,NULL,'LCRS B151658.9-022653',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.8955,-2.62869,0.313,NULL,45376327204,709005112,11078204,17.2),(128918,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128918,37.98,0.13,394,59286,70,NULL,NULL,'2MASX J15193589+1938325',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'17.9O',0.34,'BrClG',NULL,NULL,NULL,NULL,1,229.8995,19.64247,0.165,NULL,59413288797,928332637,14505197,17.9),(128919,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128919,37.21,0.46,276,59287,70,NULL,NULL,'2MASX J15193644+3111243',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.9019583,31.19014,0.037,NULL,59903882719,935998167,14624971,16.9),(128920,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128920,36.97,0.46,248,59288,70,NULL,NULL,'2MASX J15193657+0540333',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,229.9025,5.67581,0.065,NULL,56426965974,881671343,13776114,16.9),(128921,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128921,36.47,0.1,197,59289,70,NULL,NULL,'2MASX J15193678+2050005',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.68',0.22,NULL,NULL,NULL,NULL,NULL,1,229.903333,20.8335,0.181,NULL,59416348433,928380444,14505944,17.68),(128922,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128922,36.02,0.21,160,59290,70,NULL,NULL,'GIN 391',NULL,'2001MNRAS.321..277C',2001,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.38,'S',NULL,NULL,NULL,NULL,1,229.905541667,4.44878,0.045,NULL,56427589269,881681082,13776266,16.4),(128923,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128923,37.69,0.46,345,59291,70,NULL,NULL,'2MASX J15193904+2927333',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.91275,29.45914,0,NULL,59906444077,936038188,14625596,17.7),(128924,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128924,37.77,0.33,358,59292,70,NULL,NULL,'2MASX J15193974+1900565',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.915541667,19.01553,0.145,NULL,59441719094,928776860,14512138,17.9),(128925,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128925,35.6,0.46,132,59293,70,NULL,NULL,'2MASX J15194052+2019245',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.918875,20.32356,0.177,NULL,59412684470,928323194,14505049,16.6),(128926,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128926,36.51,0.46,201,59294,70,NULL,NULL,'2MASX J15194051+0719528',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,'Group member',NULL,NULL,NULL,1,229.9189583,7.33136,0.061,NULL,59349921398,927342521,14489726,17.3),(128927,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128927,37.16,0.46,270,59295,70,NULL,NULL,'2MASX J15194096+4806145',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00017,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,229.92075,48.10408,0.045,NULL,59937650517,936525789,14633215,17.5),(128928,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128928,37.81,0.46,365,59296,70,NULL,NULL,'2MASX J15194107+0647468',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.9210417,6.79617,0.057,NULL,56410047518,881406992,13771984,17.6),(128929,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128929,38.24,0.14,444,59297,70,NULL,NULL,'2MASX J15194161+0405368',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000071,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.9235,4.09361,0.041,NULL,56427673429,881682397,13776287,17.8),(128930,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128930,38.27,0.46,452,59298,70,NULL,NULL,'2MASX J15194261+1355064',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.927667,13.9185,0.097,NULL,59574993417,930859272,14544676,18.2),(128931,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128931,38.24,0.14,444,59299,70,NULL,NULL,'SDSS J151943.09+041519.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,229.9295417,4.25553,0.045,NULL,56427797870,881684341,13776317,18.7),(128932,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128932,37.98,0.13,394,59300,70,NULL,NULL,'SDSS J151943.24+193950.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.6g',NULL,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.930167,19.664,0.165,NULL,59413238820,928331856,14505185,17.6),(128933,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128933,37.88,0.33,377,59301,70,NULL,NULL,'2MASX J15194494+0730238',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,'Group member',NULL,NULL,NULL,1,229.937125,7.50664,0.057,NULL,59349904387,927342256,14489722,18),(128934,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128934,37.64,0.15,337,59302,70,NULL,NULL,'2MASX J15194519+4842205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.938333,48.70567,0.045,NULL,59937113513,936517398,14633084,17.8),(128935,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128935,37.01,0.33,253,59303,70,NULL,NULL,'2MASX J15194650+0333549',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000434,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,229.943666667,3.56511,0.069,NULL,56427184049,881674750,13776167,15.9),(128936,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128936,38.24,0.14,444,59304,70,NULL,NULL,'2MASX J15194716+0421099',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000099,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.946541667,4.35258,0.045,NULL,56427803961,881684436,13776319,18),(128937,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128937,37.81,0.46,364,59305,70,NULL,NULL,'2MASX J15194718+0135359',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.946667,1.59325,0.117,NULL,56377428442,880897319,13764020,17.5),(128938,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128938,37,0.46,251,59306,70,NULL,NULL,'2MASX J15194729+0745458',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,229.947167,7.76264,0.057,NULL,59353299026,927395297,14490551,16.5),(128939,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128939,37.98,0.13,394,59307,70,NULL,NULL,'SDSS J151948.45+194206.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.951917,19.70192,0.217,NULL,59413293375,928332708,14505198,18.3),(128940,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128940,36.69,0.11,218,59308,70,NULL,NULL,'2MASX J15194857+0738368',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'15.8g',0.36,NULL,'Group member',NULL,NULL,NULL,1,229.9522917,7.6435,0.057,NULL,59349680892,927338763,14489668,15.8),(128941,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128941,38.08,0.46,413,59309,70,NULL,NULL,'SDSS J151948.77+050148.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.953208333,5.03014,0.085,NULL,56426336035,881661500,13775960,18.5),(128942,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128942,35.69,0.49,137,59310,75,NULL,'IR','FGC 1888',NULL,'2011yCatp016004901K',2011,1,0.83,'Star superposed.','G',0.000191,NULL,'16.7',0.1,'Sc',NULL,NULL,NULL,NULL,1,229.953167,48.71731,0.045,NULL,59937113416,936517397,14633084,16.7),(128943,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128943,36.16,NULL,171,59310,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1888',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128944,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128944,36.18,NULL,172,59310,NULL,NULL,'Dipole + Quadrupole','FGC 1888',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128945,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128945,36.18,NULL,172,59310,NULL,NULL,NULL,'FGC 1888',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128946,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128946,36.21,NULL,175,59310,NULL,NULL,'Dipole','FGC 1888',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128947,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128947,37.35,0.46,295,59311,70,NULL,NULL,'SDSS J151949.13+300650.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000224,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,229.9547083,30.11392,0.017,NULL,59907233055,936050516,14625789,17.9),(128948,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128948,37.98,0.13,394,59312,70,NULL,NULL,'2MASX J15194990+1934475',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,229.958,19.57983,0.173,NULL,59413243682,928331932,14505186,18.2),(128949,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128949,37.29,0.46,287,59313,70,NULL,NULL,'2MASX J15195017+0334149',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000114,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,229.959125,3.57081,0.069,NULL,56427182574,881674727,13776167,16),(128950,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128950,37.56,0.33,325,59314,70,NULL,NULL,'2MASX J15195034+2202155',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.959875,22.03761,0.129,NULL,59421255903,928457123,14507142,17),(128951,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128951,38.35,0.46,467,59315,70,NULL,NULL,'2MASX J15195067+3008583',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,229.9612917,30.14961,0.017,NULL,59907242444,936050663,14625791,18),(128952,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128952,37.77,0.46,358,59316,70,NULL,NULL,'2MASX J15195130+0834438',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,229.96375,8.57889,0.073,NULL,59350785274,927356019,14489937,16.7),(128953,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128953,37.69,0.46,345,59317,70,NULL,NULL,'2MASX J15195170+3707106',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000131,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.965417,37.11958,0.025,NULL,60108935206,939202112,14675033,17.7),(128954,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128954,37.61,0.46,333,59318,70,NULL,NULL,'2MASX J15195192+3800126',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,229.966333333,38.00361,0.041,NULL,60112180756,939252824,14675825,17.1),(128955,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128955,37.04,0.33,256,59319,70,NULL,NULL,'2MASX J15195211+5646517',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00022,NULL,'15.7g',0.46,NULL,NULL,NULL,NULL,NULL,1,229.967458333,56.78103,0.025,NULL,57593206185,899893846,14060841,15.7),(128956,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128956,38.94,0.46,613,59320,70,NULL,NULL,'2MASX J15195249+3747076',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.9689583,37.78544,0.041,NULL,60112075029,939251172,14675799,18.2),(128957,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128957,37.25,0.16,281,59321,70,NULL,NULL,'2MASX J15195292+4501161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,229.970417,45.02114,0.033,NULL,59967691782,936995184,14640549,17),(128958,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128958,37.79,0.17,361,59322,70,NULL,NULL,'2MASX J15195297+3244443',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,229.970583333,32.74553,0.021,NULL,60112777239,939262144,14675971,17.8),(128959,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128959,37.83,0.23,369,59323,70,NULL,NULL,'SDSS J151953.30+512204.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,229.972167,51.36781,0.041,NULL,59675442391,932428787,14569199,18.5),(128960,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128960,38.21,0.46,438,59324,70,NULL,NULL,'SDSS J151953.67+310137.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000173,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,229.973667,31.02708,0.033,NULL,59903893121,935998330,14624973,18.6),(128961,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128961,38.28,0.46,453,59325,70,NULL,NULL,'2MASX J15195378+0234209',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,229.974041667,2.57253,0.081,NULL,56376911805,880889246,13763894,17.8),(128962,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128962,37.88,0.33,377,59326,70,NULL,NULL,'2MASX J15195395+0727348',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.9747917,7.45981,0.057,NULL,59349901831,927342216,14489722,16.8),(128963,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128963,37.84,0.27,370,59327,70,NULL,NULL,'2MASX J15195404+0456539',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,229.9752917,4.94836,0.085,NULL,56429858168,881716533,13776820,17.1),(128964,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128964,36.14,0.46,169,59328,70,NULL,NULL,'2MASX J15195563+4909385',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,229.981667,49.16067,0.017,NULL,59936868131,936513564,14633024,16.5),(128965,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128965,38.06,0.27,410,59329,70,NULL,NULL,'SDSS J151956.04+043258.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,229.9835417,4.54953,0.045,NULL,56427580694,881680948,13776264,18.3),(128966,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128966,37.56,0.33,325,59330,70,NULL,NULL,'2MASX J15195704+2220225',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000199,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.9877083,22.33969,0.137,NULL,59421445072,928460079,14507188,16.7),(128967,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128967,37.25,0.46,282,59331,70,NULL,NULL,'2MASX J15195744+2712162',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,229.989167,27.2045,0.093,NULL,59910839919,936106873,14626669,17.6),(128968,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128968,37.83,0.23,369,59332,70,NULL,NULL,'I Zw 108 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00019,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,229.991,51.31931,0.041,NULL,59675439604,932428743,14569199,16.6),(128969,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128969,37.83,0.23,369,59333,70,NULL,NULL,'I Zw 108 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000221,NULL,'15.9g',0.47,'BrClG',NULL,NULL,NULL,NULL,1,229.9914583,51.31311,0.041,NULL,59675439558,932428743,14569199,15.9),(128970,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PS1 SN 2008051','RN',128970,36.03,0.06,161,59334,NULL,NULL,'MLCS2k2, R(V) = 1.8, SNF20080522-011','PS1 SN 2008051 HOST',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128971,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PS1 SN 2008051','RN',128971,36.08,0.06,164,59334,NULL,NULL,'MLCS2k2, R(V) = 3.1, SNF20080522-011','PS1 SN 2008051 HOST',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128972,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','PS1 SN 2008051','N',128972,36.27,0.2,172,59334,73.8,NULL,'SALT 2 (SNANA)','PS1 SN 2008051 HOST',0.0403,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128973,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128973,37.82,0.46,366,59335,70,NULL,NULL,'2MASX J15195901+2833052',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.49',0.16,NULL,NULL,NULL,NULL,NULL,1,229.995667,28.55142,0.045,NULL,59910952333,936108630,14626697,18.49),(128974,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128974,37.68,0.46,343,59336,70,NULL,NULL,'2MASX J15195902+2349555',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,229.9957917,23.83203,0.149,NULL,59422480450,928476257,14507441,17.2),(128975,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128975,37.23,0.46,279,59337,70,NULL,NULL,'2MASX J15195906+3122133',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000182,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,229.9960417,31.37031,0.037,NULL,59904059515,936000929,14625014,16.5),(128976,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128976,36.47,0.1,197,59338,70,NULL,NULL,'2MASX J15195910+2042475',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.21',0.25,NULL,NULL,NULL,NULL,NULL,1,229.996375,20.71317,0.181,NULL,59416196557,928378071,14505907,17.21),(128977,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128977,37.98,0.13,394,59339,70,NULL,NULL,'2MASX J15195939+1938075',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,229.997625,19.63542,0.217,NULL,59413249476,928332023,14505187,17.5),(128978,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128978,38.24,0.14,444,59340,70,NULL,NULL,'SDSS J151959.48+041437.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,229.997875,4.24372,0.045,NULL,56427750686,881683604,13776306,18.5),(128979,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128979,31.86,0.2,23.6,59341,74.4,NULL,NULL,'ESO 514- G 007',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'14.3R',1.3,'S.../Irr',NULL,NULL,NULL,NULL,1,229.9987917,-23.92508,0.569,NULL,46622248079,728472626,11382384,14.3),(128980,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,128980,32.33,0.4,29.2,59341,NULL,NULL,NULL,'ESO 514- G 007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(128981,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128981,37.79,0.17,361,59342,70,NULL,NULL,'2MASX J15200020+3249233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000187,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.000833,32.82319,0.021,NULL,60112822838,939262856,14675982,17.1),(128982,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128982,36.8,0.46,229,59343,70,NULL,NULL,'2MASX J15200026+2803255',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.0010417,28.05719,0.045,NULL,59911093949,936110842,14626731,17.8),(128983,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128983,37.79,0.17,361,59344,70,NULL,NULL,'SDSS J152000.77+324612.6',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.2g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,230.0032083,32.77017,0.021,NULL,60112771034,939262047,14675969,16.2),(128984,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128984,37.82,0.46,366,59345,70,NULL,NULL,'SDSS J152000.82+111034.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.0034583,11.17636,0.073,NULL,59356327815,927442622,14491290,17.6),(128985,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128985,38.24,0.14,444,59346,70,NULL,NULL,'2MASX J15200086+0412069',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.003667,4.20186,0.045,NULL,56427632875,881681763,13776277,17.2),(128986,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128986,36.85,0.46,234,59347,70,NULL,NULL,'2MASX J15200130-0057246',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.005333,-0.95697,0.177,NULL,45374657670,708979026,11077797,17.6),(128987,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128987,38.19,0.21,434,59348,70,NULL,NULL,'2MASX J15200208+0502479',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.008625,5.04667,0.085,NULL,56429791401,881715490,13776804,16.9),(128988,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128988,37.49,0.46,315,59349,70,NULL,NULL,'2MASX J15200206+2852115',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.89',0.13,NULL,NULL,NULL,NULL,NULL,1,230.008625,28.87,0.025,NULL,59907509019,936054828,14625856,18.89),(128989,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128989,37.25,0.16,281,59350,70,NULL,NULL,'2MASX J15200217+4504061',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000159,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.008875,45.06847,0.033,NULL,59967699697,936995307,14640551,17.1),(128990,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128990,38.14,0.46,425,59351,70,NULL,NULL,'2MASX J15200275+2001355',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.011417,20.02667,0.181,NULL,59412791052,928324860,14505075,17.8),(128991,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128991,37.06,0.46,258,59352,70,NULL,NULL,'2MASX J15200343+1541024',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.014375,15.68408,0.077,NULL,59566177805,930721528,14542523,17.6),(128992,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128992,38.08,0.46,412,59353,70,NULL,NULL,'2MASX J15200371+5821498',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.015333,58.36381,0.025,NULL,57721469920,901897967,14092155,17.9),(128993,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128993,36.73,0.46,222,59354,70,NULL,NULL,'2MASX J15200377+0728459',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,'Group member',NULL,NULL,NULL,1,230.01575,7.47936,0.057,NULL,59349902221,927342222,14489722,17),(128994,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128994,37.46,0.33,310,59355,70,NULL,NULL,'2MASX J15200412+1535244',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.017208333,15.59025,0.073,NULL,59566165297,930721332,14542520,17.5),(128995,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128995,37.79,0.17,361,59356,70,NULL,NULL,'SDSS J152004.60+324156.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.0192083,32.69897,0.021,NULL,60112781031,939262203,14675971,18.2),(128996,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128996,37.24,0.46,281,59357,70,NULL,NULL,'2MASX J15200486+3645524',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.0202083,36.76456,0.029,NULL,60108855303,939200864,14675013,16.9),(128997,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128997,37.46,0.33,310,59358,70,NULL,NULL,'2MASX J15200543+1533224',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.0225417,15.55625,0.073,NULL,59565948993,930717953,14542468,16.7),(128998,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128998,37.49,0.33,314,59359,70,NULL,NULL,'2MASX J15200629+3106251',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.02625,31.107,0.037,NULL,59903899820,935998434,14624975,17.3),(128999,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',128999,36.17,0.46,172,59360,70,NULL,NULL,'2MASX J15200687+0328348',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.80',0.33,NULL,NULL,NULL,NULL,NULL,1,230.028583,3.47633,0.069,NULL,56427240151,881675627,13776181,16.8),(129000,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129000,37.77,0.33,358,59361,70,NULL,NULL,'2MASX J15200692+1857489',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'17.10',0.2,NULL,NULL,NULL,NULL,NULL,1,230.028875,18.96361,0.145,NULL,59441922962,928780046,14512188,17.1),(129001,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129001,37.37,0.46,298,59362,70,NULL,NULL,'2MASX J15200700+1436144',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.02925,14.60397,0.097,NULL,59574924663,930858197,14544659,NULL),(129002,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129002,37.79,0.17,361,59363,70,NULL,NULL,'SDSS J152007.19+324950.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.029958333,32.83072,0.021,NULL,60112769446,939262022,14675969,18.2),(129003,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129003,37.41,0.46,304,59364,70,NULL,NULL,'2MASX J15200856+6012597',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.035625,60.21672,0.029,NULL,57776275000,902754296,14105535,16.4),(129004,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129004,37.86,0.46,374,59365,70,NULL,NULL,'2MASX J15200931+3830464',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000145,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.038625,38.51286,0.033,NULL,60111037383,939234959,14675546,17.4),(129005,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129005,37.26,0.46,283,59366,70,NULL,NULL,'2MASX J15200931+3019151',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.0001,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.0387917,30.32097,0,NULL,59907023739,936047245,14625738,16.4),(129006,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129006,35.75,0.46,141,59367,70,NULL,NULL,'2MASX J15200937+2154169',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000103,NULL,'16.19',0.3,NULL,NULL,NULL,NULL,NULL,1,230.0389583,21.90478,0.129,NULL,59413674646,928338666,14505291,16.19),(129007,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129007,37.83,0.23,369,59368,70,NULL,NULL,'2MASX J15200945+5117148',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.039333,51.28764,0.033,NULL,59675437433,932428709,14569198,17.8),(129008,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129008,37.98,0.13,394,59369,70,NULL,NULL,'2MASX J15200947+1942460',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.039417,19.71278,0.217,NULL,59412721186,928323768,14505058,18.1),(129009,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129009,37.85,0.13,371,59370,70,NULL,NULL,'SDSS J152009.51+331905.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000158,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.039625,33.31811,0.045,NULL,60104528753,939133261,14673957,18.6),(129010,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129010,38.05,0.33,407,59371,70,NULL,NULL,'2MASX J15201004+1446174',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,230.041917,14.77156,0.097,NULL,59574124826,930845700,14544464,16.6),(129011,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129011,37.96,0.46,391,59372,70,NULL,NULL,'SDSS J152010.63+201924.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.044291667,20.32344,0.173,NULL,59412677973,928323093,14505048,18.6),(129012,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129012,35.96,0.21,155,59373,70,NULL,NULL,'CGCG 135-047',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000153,NULL,'14.7g',0.64,NULL,'Group member',NULL,NULL,NULL,1,230.045625,25.72203,0.129,NULL,59901102291,935954723,14624292,14.7),(129013,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129013,37.85,0.13,371,59374,70,NULL,NULL,'2MASX J15201115+3322171',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.046625,33.37133,0.049,NULL,60104557444,939133710,14673964,16.9),(129014,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129014,37.98,0.33,394,59375,70,NULL,NULL,'2MASX J15201152+4607361',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.048,46.12656,0.033,NULL,59983499067,937242172,14644408,17.8),(129015,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129015,35.96,0.21,155,59376,70,NULL,NULL,'2MASX J15201158+2548285',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.73',0.2,NULL,NULL,NULL,NULL,NULL,1,230.0482083,25.808,0.129,NULL,59909447602,936085118,14626329,17.73),(129016,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129016,37.85,0.13,371,59377,70,NULL,NULL,'SDSS J152012.56+332638.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.052375,33.44414,0.049,NULL,60104551075,939133610,14673962,18.3),(129017,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129017,38.05,0.33,407,59378,70,NULL,NULL,'2MASX J15201315+1446385',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.054875,14.77747,0.097,NULL,59574126094,930845720,14544464,17.8),(129018,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129018,37.85,0.13,371,59379,70,NULL,NULL,'2MASX J15201361+3328271',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,230.056708333,33.47431,0.049,NULL,60104552905,939133639,14673963,16.7),(129019,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129019,37.23,0.46,279,59380,70,NULL,NULL,'2MASX J15201365+3200322',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000191,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,230.0570417,32.00894,0.041,NULL,59903302559,935989102,14624829,16),(129020,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129020,37.25,0.46,282,59381,70,NULL,NULL,'2MASX J15201375+0259332',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.0572917,2.99247,0.065,NULL,56432279512,881754367,13777411,16.9),(129021,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129021,37.37,0.46,298,59382,70,NULL,NULL,'2MASX J15201389+2827055',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.0579583,28.45156,0.033,NULL,59910949861,936108591,14626696,17.8),(129022,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129022,38.46,0.46,491,59383,70,NULL,NULL,'SDSS J152014.74+015338.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.0614583,1.89417,0.109,NULL,56377447332,880897614,13764025,18.4),(129023,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129023,37.13,0.46,267,59384,70,NULL,NULL,'2MASX J15201479+4800119',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000173,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.061541667,48.00319,0.041,NULL,59937600486,936525007,14633203,16.7),(129024,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129024,36.34,0.46,185,59385,70,NULL,NULL,'2MASX J15201663+0512232',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.47',0.39,NULL,NULL,NULL,NULL,NULL,1,230.0692917,5.20642,0.085,NULL,56426352911,881661764,13775965,16.47),(129025,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129025,37.49,0.33,314,59386,70,NULL,NULL,'2MASX J15201665+3103022',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.069541667,31.05069,0.033,NULL,59903898383,935998412,14624975,17.6),(129026,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129026,36.21,0.46,175,59387,70,NULL,NULL,'2MASX J15201684+1143270',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.070125,11.72431,0.097,NULL,59342184672,927221635,14487838,16.9),(129027,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129027,37.62,0.46,333,59388,70,NULL,NULL,'2MASX J15201754+0344312',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.073167,3.74183,0.057,NULL,56427200240,881675003,13776171,17.4),(129028,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129028,35.96,0.21,155,59389,70,NULL,NULL,'2MASX J15201757+2543384',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.0732917,25.72736,0.129,NULL,59901114202,935954909,14624295,16.8),(129029,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129029,38.19,0.21,434,59390,70,NULL,NULL,'2MASX J15201797+0513352',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.6g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,230.074958333,5.22647,0.085,NULL,56426310142,881661095,13775954,16.6),(129030,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129030,33.53,0.47,50.9,59391,NULL,NULL,'H','ESO 449- G 005',NULL,'2007A&A...465...71T',2007,1,2.7,NULL,'G',0.000034,NULL,'15',1.2,'Sa:            HII',NULL,NULL,NULL,NULL,1,230.075041667,-31.43178,0.513,NULL,47132431759,736444246,11506941,15),(129031,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129031,33.66,0.45,53.9,59391,NULL,NULL,'K','ESO 449- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129032,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129032,33.71,0.46,55.1,59391,NULL,NULL,'J','ESO 449- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129033,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129033,34.31,0.4,72.6,59391,NULL,NULL,'mean','ESO 449- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129034,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129034,37.85,0.13,371,59392,70,NULL,NULL,'2MASX J15201865+3323052',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000199,NULL,'16.0g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,230.0777083,33.38481,0.049,NULL,60104549332,939133583,14673962,16),(129035,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129035,37.43,0.46,307,59393,70,NULL,NULL,'2MASX J15201904+3231362',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,230.079417,32.52672,0.037,NULL,60083418305,938803411,14668803,16.7),(129036,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129036,35.9,0.33,151,59394,NULL,NULL,NULL,'2MASX J15201967+0829180',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000027,NULL,'17.5g',0.16,'Sc',NULL,NULL,NULL,NULL,1,230.082166667,8.48836,0.073,NULL,59351249655,927363275,14490051,17.5),(129037,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129037,35.94,0.2,154,59394,74.4,NULL,NULL,'2MASX J15201967+0829180',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129038,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129038,36.02,0.32,160,59394,NULL,NULL,'Malmquist cor.','2MASX J15201967+0829180',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129039,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129039,37.21,0.46,276,59395,70,NULL,NULL,'2MASX J15202015+4706012',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.084083,47.10025,0.069,NULL,59983706304,937245411,14644459,17.6),(129040,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129040,37.35,0.46,295,59396,70,NULL,NULL,'2MASX J15202082+3607204',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.086667,36.12228,0.045,NULL,60107043478,939172554,14674571,17.3),(129041,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129041,37.16,0.46,270,59397,70,NULL,NULL,'2MASX J15202221+3220322',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.0925,32.34233,0.041,NULL,59903110989,935986109,14624782,17.7),(129042,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129042,36.69,0.11,218,59398,70,NULL,NULL,'2MASX J15202237+0733560',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.0932917,7.56558,0.057,NULL,59349692514,927338945,14489671,16.6),(129043,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129043,37.14,0.46,268,59399,70,NULL,NULL,'2MASX J15202236+0951480',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.093375,9.86347,0.073,NULL,59355436978,927428702,14491073,17.6),(129044,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129044,37.37,0.56,298,59400,70,NULL,NULL,'2MASX J15202243-1117184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.65',NULL,NULL,NULL,NULL,NULL,NULL,1,230.093667,-11.28875,0.525,NULL,46486938072,726358407,11349350,16.65),(129045,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129045,37.85,0.46,372,59401,70,NULL,NULL,'2MASX J15202285+2806384',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0',0.16,NULL,NULL,NULL,NULL,NULL,1,230.095125,28.11072,0.045,NULL,59911109194,936111081,14626735,18),(129046,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129046,37.85,0.13,371,59402,70,NULL,NULL,'2MASX J15202352+3317142',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.098083333,33.28725,0.045,NULL,60104598067,939134344,14673974,17.8),(129047,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129047,38.19,0.21,434,59403,70,NULL,NULL,'2MASX J15202400+0508252',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.1,5.14019,0.085,NULL,56429830950,881716108,13776814,17.3),(129048,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129048,37.85,0.13,371,59404,70,NULL,NULL,'2MASX J15202480+3330042',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.103417,33.50114,0.049,NULL,60104555696,939133682,14673963,17.3),(129049,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129049,37.82,0.46,367,59405,70,NULL,NULL,'2MASX J15202513+5745088',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000093,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.104833,57.75242,0.029,NULL,57589466936,899835420,14059928,17.3),(129050,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129050,37.25,0.16,281,59406,70,NULL,NULL,'2MASX J15202551+4501382',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000187,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.10625,45.02719,0.033,NULL,59967694285,936995223,14640550,17.4),(129051,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129051,37.91,0.46,383,59407,70,NULL,NULL,'SDSS J152025.61+042450.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.1067083,4.41392,0.045,NULL,56427728534,881683258,13776300,18.7),(129052,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129052,37.41,0.46,304,59408,70,NULL,NULL,'2MASXi J1520274+214547',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.114333,21.76317,0.185,NULL,59413845676,928341338,14505333,17.9),(129053,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129053,37.79,0.17,361,59409,70,NULL,NULL,'2MASX J15202806+3253442',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.1170417,32.89556,0.025,NULL,60104433288,939131770,14673933,17.9),(129054,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129054,38.19,0.21,434,59410,70,NULL,NULL,'2MASX J15202815+0510352',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.1172917,5.17631,0.085,NULL,56429777264,881715269,13776801,17.4),(129055,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129055,37.59,0.46,330,59411,70,NULL,NULL,'2MASX J15202818+5242460',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.117333,52.71294,0.025,NULL,59675515961,932429936,14569217,17.5),(129056,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129056,36.28,0.46,180,59412,70,NULL,NULL,'2MASX J15202870+0817070',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.2g',0.36,'E','Group member',NULL,NULL,NULL,1,230.119583,8.28517,0.045,NULL,59351165614,927361962,14490030,16.2),(129057,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129057,37.25,0.16,281,59413,70,NULL,NULL,'2MASX J15202901+4458153',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000186,NULL,'15.7g',0.43,'AGN',NULL,NULL,NULL,NULL,1,230.120791667,44.97097,0.033,NULL,59967696149,936995252,14640550,15.7),(129058,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129058,37.85,0.13,371,59414,70,NULL,NULL,'2MASX J15202904+3329362',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.120958333,33.49328,0.049,NULL,60104553931,939133655,14673963,17.2),(129059,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129059,37.64,0.15,337,59415,70,NULL,NULL,'SDSS J152029.18+483908.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,230.121583,48.65233,0.045,NULL,59937090043,936517031,14633078,18.3),(129060,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129060,36.47,0.1,197,59416,70,NULL,NULL,'2MASX J15203111+2037231',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.13',0.2,NULL,NULL,NULL,NULL,NULL,1,230.129625,20.62319,0.177,NULL,59416244544,928378821,14505919,17.13),(129061,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129061,34.26,0.2,71.1,59417,74.4,NULL,NULL,'CGCG 077-078',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000123,NULL,'15.2',0.6,NULL,NULL,NULL,NULL,NULL,1,230.135208333,11.99019,0.097,NULL,59342272660,927223010,14487859,15.2),(129062,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129062,37.59,0.46,330,59418,70,NULL,NULL,'2MASX J15203249+5102050',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.135291667,51.03481,0.033,NULL,59666663537,932291617,14567056,16.7),(129063,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129063,35.14,0.45,107,59419,NULL,NULL,'K','MCG -01-39-001',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000073,NULL,'14.49',0.9,'S0- pec:',NULL,NULL,NULL,NULL,1,230.139,-8.52994,0.313,NULL,46480027840,726250435,11347663,14.49),(129064,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129064,35.25,0.4,112,59419,NULL,NULL,'mean','MCG -01-39-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129065,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129065,37.85,0.13,371,59420,70,NULL,NULL,'SDSS J152033.60+332717.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.1400417,33.45483,0.049,NULL,60104549472,939133585,14673962,18.4),(129066,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129066,38.68,0.46,543,59421,70,NULL,NULL,'2MASX J15203419+2804200',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.81',0.15,NULL,NULL,NULL,NULL,NULL,1,230.1425,28.07236,0.061,NULL,59911101443,936110960,14626733,18.81),(129067,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129067,37.9,0.33,379,59422,70,NULL,NULL,'2MASX J15203487+2243542',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.85',0.17,NULL,NULL,NULL,NULL,NULL,1,230.14525,22.73181,0.149,NULL,59424179146,928502799,14507856,17.85),(129068,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129068,35.96,0.21,155,59423,70,NULL,NULL,'CGCG 135-048',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000113,NULL,'15.2g',0.47,NULL,'Group member',NULL,NULL,NULL,1,230.145417,25.73694,0.129,NULL,59901110863,935954857,14624294,15.2),(129069,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129069,37.98,0.13,394,59424,70,NULL,NULL,'SDSS J152035.71+193700.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.148833,19.61675,0.217,NULL,59412713081,928323641,14505056,18.6),(129070,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129070,38.31,0.33,458,59425,70,NULL,NULL,'2MASX J15203572+0314472',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.148875,3.24633,0.065,NULL,56434414151,881787721,13777933,17),(129071,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129071,38.12,0.27,421,59426,70,NULL,NULL,'2MASX J15203644+1914182',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.151833333,19.23847,0.173,NULL,59441857999,928779031,14512172,17.7),(129072,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129072,37.5,0.33,317,59427,70,NULL,NULL,'2MASX J15203650+2508070',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.1519583,25.13522,0.133,NULL,59417595538,928399930,14506248,17.6),(129073,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129073,37.98,0.13,394,59428,70,NULL,NULL,'2MASX J15203670+1941132',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.3E',NULL,NULL,NULL,NULL,NULL,NULL,1,230.152875,19.68694,0.217,NULL,59412725208,928323831,14505059,16.3),(129074,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129074,37.5,0.33,317,59429,70,NULL,NULL,'2MASX J15203708+2507070',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'18.18',0.16,NULL,NULL,NULL,NULL,NULL,1,230.154375,25.11853,0.129,NULL,59417595684,928399932,14506248,18.18),(129075,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129075,34.53,0.56,80.4,59430,70,NULL,NULL,'2MASX J15203752-1103024',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.06',NULL,NULL,NULL,NULL,NULL,NULL,1,230.15625,-11.05089,0.501,NULL,46486816887,726356513,11349320,16.06),(129076,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129076,36.47,0.1,197,59431,70,NULL,NULL,'2MASX J15203792+2050372',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.44',0.23,NULL,NULL,NULL,NULL,NULL,1,230.1579583,20.84367,0.177,NULL,59416102202,928376596,14505884,16.44),(129077,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129077,36.69,0.11,218,59432,70,NULL,NULL,'MENeaCS MKW03S_04_14_0 HOST',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.1585417,7.65969,0.057,NULL,59353108711,927392323,14490505,17),(129078,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129078,38.31,0.33,458,59433,70,NULL,NULL,'2MASX J15203916+0315541',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.163291667,3.265,0.065,NULL,56434397546,881787461,13777929,17.5),(129079,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129079,38.12,0.27,421,59434,70,NULL,NULL,'2MASX J15203940+1915172',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.164125,19.25469,0.173,NULL,59441871733,928779245,14512175,17.7),(129080,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129080,37.05,0.46,257,59435,70,NULL,NULL,'2MASX J15203974+2336352',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000167,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,230.1657917,23.60992,0.157,NULL,59422494160,928476471,14507444,16.3),(129081,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129081,36.58,0.46,207,59436,70,NULL,NULL,'CGCG 021-078',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000197,NULL,'15.4',0.52,NULL,NULL,NULL,NULL,NULL,1,230.169417,1.84675,0.105,NULL,56377445336,880897583,13764024,15.4),(129082,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129082,37.85,0.13,371,59437,70,NULL,NULL,'2MASX J15204105+3321548',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000197,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.1710417,33.36536,0.049,NULL,60104580678,939134073,14673969,16.6),(129083,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129083,37.63,0.46,335,59438,70,NULL,NULL,'2MASX J15204124+0552321',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00005,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.17175,5.87575,0.049,NULL,56426594054,881665532,13776023,16.8),(129084,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129084,35.96,0.21,155,59439,70,NULL,NULL,'CGCG 135-049',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000192,NULL,'15.3g',0.6,NULL,'Group member',NULL,NULL,NULL,1,230.173708333,25.68081,0.129,NULL,59901105535,935954773,14624293,15.3),(129085,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129085,36.79,0.46,228,59440,70,NULL,NULL,'SDSS J152043.12+124843.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.1797083,12.81206,0.113,NULL,59562095762,930657746,14541527,17.4),(129086,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129086,37.55,0.46,324,59441,70,NULL,NULL,'SDSS J152043.23+073049.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.180167,7.51389,0.057,NULL,59349728672,927339510,14489679,18),(129087,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129087,37.89,0.46,379,59442,70,NULL,NULL,'2MASX J15204409+3525409',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000193,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.18375,35.42792,0.053,NULL,60108487610,939195118,14674923,17.1),(129088,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129088,36.47,0.1,197,59443,70,NULL,NULL,'2MASX J15204413+2043292',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.57',0.19,NULL,NULL,NULL,NULL,NULL,1,230.183917,20.72472,0.181,NULL,59416220626,928378447,14505913,17.57),(129089,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129089,37.37,0.46,298,59444,70,NULL,NULL,'SDSS J152044.67+062322.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.186125,6.3895,0.061,NULL,56410139558,881408430,13772006,NULL),(129090,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129090,37.64,0.15,337,59445,70,NULL,NULL,'2MASX J15204499+4839230',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000199,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.187667,48.65636,0.037,NULL,59937091416,936517053,14633078,16.9),(129091,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129091,37.53,0.11,321,59446,70,NULL,NULL,'2MASX J15204570+3029418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.190417,30.49497,0,NULL,59907019589,936047181,14625737,17.7),(129092,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129092,32.44,0.8,30.7,59447,75,NULL,'MAT, I','ESO 582- G 004',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000013,NULL,'15.5',0.9,'Sc:',NULL,NULL,NULL,NULL,1,230.1915,-18.34889,0.461,NULL,46594726157,728042596,11375665,15.5),(129093,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129093,31.87,0.32,23.7,59447,85,NULL,'I, inv','ESO 582- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129094,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129094,31.89,0.32,23.9,59447,85,NULL,'I, raw','ESO 582- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129095,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129095,32.23,0.43,28,59447,75,NULL,'MAT, I, inv','ESO 582- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129096,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129096,32.24,0.43,28,59447,75,NULL,'MAT, I, raw','ESO 582- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129097,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129097,32.44,0.2,30.8,59447,74.4,NULL,NULL,'ESO 582- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129098,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129098,32.47,0.43,31.1,59447,75,NULL,'MAT, I, cor','ESO 582- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129099,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129099,32.6,0.49,33.1,59447,NULL,NULL,'Malmquist cor.','ESO 582- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129100,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129100,32.66,0.48,34,59447,NULL,NULL,NULL,'ESO 582- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129101,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129101,32.71,0.43,34.8,59447,75,NULL,'3.6 micron, color corrected','ESO 582- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129102,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129102,32.96,0.43,39.1,59447,75,NULL,'3.6 micron, color + selection bias corrected','ESO 582- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129103,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129103,37.09,0.46,262,59448,70,NULL,NULL,'2MASX J15204688+2757310',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0002,NULL,'18.1g',0.19,NULL,'Group member',NULL,NULL,NULL,1,230.195333,27.95861,0.061,NULL,59911053612,936110212,14626722,18.1),(129104,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129104,33.77,0.8,56.6,59449,75,NULL,'MAT, I','ESO 387- G 026',NULL,'1997ApJS..109..333W',1997,1,2.5,'ESO-LV gives v = 3069 +/- 50 km/sec.','G',0.000013,NULL,'13.30',1.3,'SAB(s)c:       HII','Group member, conflicting redshifts',NULL,NULL,NULL,1,230.1952917,-36.93369,0.417,NULL,47193755259,737402425,11521912,13.3),(129105,'Sosies','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129105,33.83,0.11,58.3,59449,NULL,NULL,NULL,'ESO 387- G 026',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129106,'Tully est','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129106,33.1,0.8,41.8,59449,75,NULL,'B','ESO 387- G 026',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129107,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129107,33.56,0.43,51.4,59449,75,NULL,'MAT, I, raw','ESO 387- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129108,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129108,33.64,0.32,53.4,59449,85,NULL,'I, raw','ESO 387- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129109,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129109,33.65,0.2,53.7,59449,74.4,NULL,NULL,'ESO 387- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129110,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129110,33.66,0.46,54,59449,NULL,NULL,'J','ESO 387- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129111,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129111,33.68,0.47,54.4,59449,NULL,NULL,'H','ESO 387- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129112,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129112,33.7,0.43,55,59449,75,NULL,'3.6 micron, color corrected','ESO 387- G 026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129113,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129113,33.72,0.32,55.4,59449,85,NULL,'I, inv','ESO 387- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129114,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129114,33.73,0.45,55.8,59449,NULL,NULL,'K','ESO 387- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129115,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129115,33.81,0.34,57.9,59449,NULL,NULL,NULL,'ESO 387- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129116,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129116,33.87,0.43,59.4,59449,75,NULL,'3.6 micron, color + selection bias corrected','ESO 387- G 026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129117,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129117,33.88,0.43,59.6,59449,75,NULL,'MAT, I, inv','ESO 387- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129118,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129118,33.88,0.4,59.6,59449,NULL,NULL,'mean','ESO 387- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129119,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129119,33.9,0.43,60.3,59449,75,NULL,'MAT, I, cor','ESO 387- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129120,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129120,33.98,0.32,62.5,59449,NULL,NULL,'Malmquist cor.','ESO 387- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129121,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129121,36.06,0.46,163,59450,70,NULL,NULL,'I Zw 109 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'15.8g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,230.199333,49.12756,0.037,NULL,59664505386,932257896,14566529,15.8),(129122,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129122,36.36,0.46,187,59451,70,NULL,NULL,'2MASX J15204841+3644149',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,230.2017917,36.73756,0.053,NULL,60108858559,939200914,14675014,16.2),(129123,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129123,38.19,0.21,434,59452,70,NULL,NULL,'2MASX J15204849+0503351',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.202083,5.05986,0.085,NULL,56429818027,881715906,13776811,17.6),(129124,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129124,36.49,0.46,199,59453,70,NULL,NULL,'2MASX J15204899+1554311',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.204083333,15.90869,0.073,NULL,59566143618,930720994,14542515,17.1),(129125,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129125,37.85,0.13,371,59454,70,NULL,NULL,'2MASX J15204911+3321499',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.2045417,33.36375,0.049,NULL,60104578971,939134046,14673969,18),(129126,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129126,38.12,0.46,421,59455,70,NULL,NULL,'2MASX J15204985+2850020',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000093,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.20775,28.834,0.025,NULL,59907560071,936055626,14625869,17.9),(129127,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129127,37.01,0.33,252,59456,70,NULL,NULL,'2MASX J15205090+4519153',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,230.2120417,45.32089,0.025,NULL,59969873723,937029276,14641082,16.4),(129128,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129128,35.96,0.33,156,59457,NULL,NULL,NULL,'SDSS J152051.59+083723.2',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000027,NULL,'16.7g',0.28,'Sc','Group member',NULL,NULL,NULL,1,230.2149583,8.62311,0.045,NULL,59351280554,927363758,14490058,16.7),(129129,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129129,36,0.2,158,59457,74.4,NULL,NULL,'SDSS J152051.59+083723.2',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129130,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129130,36.04,0.31,162,59457,NULL,NULL,'Malmquist cor.','SDSS J152051.59+083723.2',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129131,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129131,36.02,0.21,160,59458,70,NULL,NULL,'GIN 390',NULL,'2001MNRAS.321..277C',2001,1,0.41,NULL,'G',0.000077,NULL,'16.2g',0.35,'E/S0',NULL,NULL,NULL,NULL,1,230.215583,4.39131,0.045,NULL,56427713466,881683022,13776297,16.2),(129132,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129132,36.65,0.33,213,59458,70,NULL,NULL,'GIN 390',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129133,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129133,37.64,0.15,337,59459,70,NULL,NULL,'MCG +08-28-020',NULL,'2015arXiv151105856S',2015,1,0.87,'Fouque et al. (1992CORV..C...0000F) give z=0.1078.','G',0.000226,NULL,'15.1g',0.54,'BrClG',NULL,NULL,NULL,NULL,1,230.217667,48.66061,0.037,NULL,59937089341,936517020,14633078,15.1),(129134,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129134,38.2,0.46,437,59460,70,NULL,NULL,'SDSS J152052.39+402052.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.218333,40.34792,0.021,NULL,59971250587,937050790,14641418,18.5),(129135,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129135,37.9,0.33,379,59461,70,NULL,NULL,'2MASX J15205258+2243432',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.2192917,22.72883,0.161,NULL,59421492201,928460815,14507200,17),(129136,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129136,37.94,0.46,387,59462,70,NULL,NULL,'2MASX J15205268+2320102',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.219333,23.33606,0.161,NULL,59424622428,928509725,14507964,17.5),(129137,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129137,37.85,0.13,371,59463,70,NULL,NULL,'2MASX J15205262+3340219',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000146,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,230.2195,33.67269,0.057,NULL,60105362406,939146287,14674160,16.8),(129138,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129138,37.65,0.46,339,59464,70,NULL,NULL,'2MASX J15205280+1318350',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.220083,13.30978,0.113,NULL,59561842554,930653789,14541465,17),(129139,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129139,37.14,0.46,267,59465,70,NULL,NULL,'2MASX J15205302+4911083',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.22075,49.18561,0.037,NULL,59664514684,932258041,14566531,16.8),(129140,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129140,37.57,0.27,327,59466,70,NULL,NULL,'SDSS J152053.41+071721.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.7g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.222583333,7.28942,0.057,NULL,56409739238,881402175,13771908,17.7),(129141,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129141,37.64,0.15,337,59467,70,NULL,NULL,'SDSS J152053.82+484122.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.224291667,48.68958,0.037,NULL,59937093191,936517081,14633079,18.3),(129142,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129142,37.01,0.33,252,59468,70,NULL,NULL,'2MASX J15205384+4519173',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000171,NULL,'16.4g',0.37,'AGN',NULL,NULL,NULL,NULL,1,230.224375,45.32136,0.025,NULL,59969873216,937029269,14641082,16.4),(129143,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129143,36.05,0.46,162,59469,70,NULL,NULL,'2MASX J15205452+0826381',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000167,NULL,'16.3g',0.3,'S0','Group member',NULL,NULL,NULL,1,230.227125,8.44386,0.073,NULL,59351261958,927363468,14490054,16.3),(129144,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129144,38.13,0.46,423,59470,70,NULL,NULL,'2MASX J15205458+0918241',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.227375,9.30681,0.061,NULL,59355296760,927426511,14491039,17.6),(129145,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129145,37.42,0.46,305,59471,70,NULL,NULL,'2MASX J15205500+4926193',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.229167,49.43883,0.021,NULL,59667391043,932302985,14567234,17.1),(129146,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129146,37.95,0.46,390,59472,70,NULL,NULL,'2MASX J15205499+1957242',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.2292917,19.95664,0.169,NULL,59412801228,928325019,14505078,16.6),(129147,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129147,32.4,0.4,30.2,59473,NULL,NULL,'mean','NGC 5913',NULL,'2007A&A...465...71T',2007,1,1.76,NULL,'G',0.000037,NULL,'13.8g',0.76,'SB(r)a         HII','Isolated galaxy',NULL,NULL,NULL,1,230.231,-2.57794,0.337,NULL,45421361902,709708779,11089199,13.8),(129148,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129148,32.53,0.45,32,59473,NULL,NULL,'K','NGC 5913',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129149,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129149,32.53,NULL,32,59473,72,NULL,NULL,'NGC 5913',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129150,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129150,32.57,0.47,32.6,59473,NULL,NULL,'H','NGC 5913',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129151,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129151,32.61,0.46,33.2,59473,NULL,NULL,'J','NGC 5913',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129152,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129152,32.69,0.43,34.6,59473,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5913',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129153,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129153,32.8,0.43,36.3,59473,75,NULL,'3.6 micron, color corrected','NGC 5913',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129154,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129154,32.89,0.2,37.8,59473,74.4,NULL,NULL,'NGC 5913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129155,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129155,37.22,0.46,279,59474,70,NULL,NULL,'2MASX J15205717+4923123',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.238125,49.38681,0.017,NULL,59667392837,932303013,14567234,17),(129156,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129156,37.53,0.11,321,59475,70,NULL,NULL,'SDSS J152057.95+303723.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.2415,30.62333,0,NULL,59906528423,936039506,14625617,18.3),(129157,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129157,36.86,0.46,236,59476,70,NULL,NULL,'2MASX J15205876+2442400',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.2449583,24.71108,0.149,NULL,59417645555,928400711,14506261,17),(129158,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129158,37.19,0.23,274,59477,70,NULL,NULL,'SDSS J152058.82+565720.8',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000074,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,230.245083,56.95578,0.029,NULL,57588910773,899826730,14059792,16.2),(129159,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129159,37.03,0.46,254,59478,70,NULL,NULL,'2MASX J15205885+3021599',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.2452917,30.36675,0,NULL,59907016691,936047135,14625736,16.9),(129160,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129160,37.11,0.46,265,59479,70,NULL,NULL,'2MASX J15205892+3807279',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000154,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,230.245667,38.12456,0.033,NULL,60112164120,939252564,14675821,16.6),(129161,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129161,37.9,0.46,381,59480,70,NULL,NULL,'2MASX J15210012+2808400',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.0002,NULL,'17.7',0.18,NULL,NULL,NULL,NULL,NULL,1,230.2504583,28.14444,0.049,NULL,59911103008,936110984,14626734,17.7),(129162,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129162,37.91,0.46,381,59481,70,NULL,NULL,'2MASX J15210106+0126111',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.254417,1.43644,0.117,NULL,56375903333,880873489,13763648,16.9),(129163,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129163,38.03,0.46,403,59482,70,NULL,NULL,'SDSS J152101.10+474939.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.254583,47.82756,0.057,NULL,59936769568,936512024,14633000,18.1),(129164,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129164,37.77,0.46,358,59483,70,NULL,NULL,'2MASX J15210118+5915123',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000192,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.255083,59.25331,0.013,NULL,57772970498,902702664,14104729,17.6),(129165,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129165,38.32,0.46,462,59484,70,NULL,NULL,'2MASX J15210153+0356491',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000123,NULL,'17.2g',0.27,'NLAGN',NULL,NULL,NULL,'Sy 2',1,230.2564583,3.94708,0.065,NULL,56428010326,881687661,13776369,17.2),(129166,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129166,37.81,0.46,365,59485,70,NULL,NULL,'2MASX J15210162+2805040',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,'Group member',NULL,NULL,NULL,1,230.256708333,28.08447,0.061,NULL,59911051159,936110174,14626721,17.7),(129167,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129167,36.47,0.1,197,59486,70,NULL,NULL,'SDSS J152102.44+205423.7',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.260167,20.90658,0.177,NULL,59416105705,928376651,14505885,16.4),(129168,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129168,38.07,0.46,411,59487,70,NULL,NULL,'2MASX J15210386+0215171',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.266166667,2.25472,0.081,NULL,56432667737,881760433,13777506,16.8),(129169,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129169,37.67,0.46,342,59488,70,NULL,NULL,'SDSS J152104.32+441856.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.2680417,44.31575,0.049,NULL,59967364779,936990074,14640469,18),(129170,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129170,36.53,0.46,202,59489,70,NULL,NULL,'2MASX J15210476+3622269',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.2699583,36.37414,0.041,NULL,60107012929,939172077,14674563,16.9),(129171,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129171,38.26,0.27,449,59490,70,NULL,NULL,'SDSS J152105.01+460712.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000167,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.270917,46.12014,0.033,NULL,59966375396,936974615,14640228,18.4),(129172,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129172,37.85,0.46,371,59491,70,NULL,NULL,'2MASX J15210559+0431434',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.273417,4.52864,0.053,NULL,56427692024,881682687,13776291,17.4),(129173,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129173,38.14,0.46,425,59492,70,NULL,NULL,'2MASX J15210579+2744419',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,'Group member',NULL,NULL,NULL,1,230.274208333,27.74514,0.073,NULL,59911184505,936112257,14626754,17.5),(129174,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129174,35.67,0.46,136,59493,70,NULL,NULL,'2MASX J15210798+0503294',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,230.283167,5.05811,0.085,NULL,56429922541,881717539,13776836,16),(129175,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129175,37.53,0.11,321,59494,70,NULL,NULL,'2MASX J15210838+3034248',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000117,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,230.284916667,30.57361,0,NULL,59906583764,936040371,14625630,16.2),(129176,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129176,37.29,0.46,287,59495,70,NULL,NULL,'2MASX J15210883+2419380',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.73',0.13,NULL,NULL,NULL,NULL,NULL,1,230.2867083,24.32708,0.145,NULL,59417955736,928405558,14506336,18.73),(129177,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129177,37.53,0.11,321,59496,70,NULL,NULL,'2MASX J15210900+3031348',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.287375,30.52633,0,NULL,59906582133,936040345,14625630,18.1),(129178,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129178,37.08,0.17,261,59497,70.8,NULL,NULL,'[M96b] J152109.75+275508',NULL,'2008MNRAS.389.1577T',2008,1,NULL,'Not associated with ABELL 2065:[PGH88] 356. See Mueller (1996,IAUC,6405,1).','G',NULL,NULL,'20.7g',NULL,'S:',NULL,NULL,NULL,NULL,1,230.287625,27.92258,0.069,NULL,59911191384,936112365,14626755,20.7),(129179,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129179,38.32,0.17,408,59497,74.2,NULL,'SALT 2','[M96b] J152109.75+275508',0.13,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129180,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129180,38.93,0.15,479,59497,65,NULL,'MLCS2k2','[M96b] J152109.75+275508',0.13,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129181,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129181,38.68,0.28,482,59497,72,NULL,NULL,'[M96b] J152109.75+275508',0.13,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129182,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129182,38.85,0.21,522,59497,65,NULL,'MLCS17','[M96b] J152109.75+275508',0.13,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129183,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129183,38.88,0.04,529,59497,72,NULL,NULL,'[M96b] J152109.75+275508',0.13,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129184,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129184,38.89,0.05,529,59497,70,NULL,NULL,'[M96b] J152109.75+275508',0.13,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129185,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129185,38.89,0.29,530,59497,65,NULL,'MLCS31','[M96b] J152109.75+275508',0.13,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129186,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129186,38.9,0.18,533,59497,65,NULL,'MLCS2k2','[M96b] J152109.75+275508',0.13,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129187,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129187,38.95,0.17,546,59497,70,NULL,'SALT','[M96b] J152109.75+275508',0.13,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129188,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129188,38.99,0.11,555,59497,65,NULL,'MLCS2k2','[M96b] J152109.75+275508',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129189,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129189,39.01,0.13,561,59497,65,NULL,'MLCS','[M96b] J152109.75+275508',0.13,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129190,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129190,38.75,0.14,562,59497,60,NULL,NULL,'[M96b] J152109.75+275508',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129191,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129191,39.03,0.1,567,59497,65,NULL,'SALT2','[M96b] J152109.75+275508',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129192,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129192,39.04,0.17,570,59497,65,NULL,'SALT2','[M96b] J152109.75+275508',0.13,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129193,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129193,39.1,0.17,585,59497,65,NULL,'Template','[M96b] J152109.75+275508',0.13,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129194,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129194,39.14,0.02,596,59497,65,NULL,'SALT','[M96b] J152109.75+275508',0.13,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129195,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129195,39.15,0.15,599,59497,65,NULL,'SALT','[M96b] J152109.75+275508',0.13,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129196,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129196,38.89,0.08,600,59497,60,NULL,'M(B) = -19.48 mag','[M96b] J152109.75+275508',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129197,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129197,39.16,0.21,601,59497,70,NULL,'SALT 2','[M96b] J152109.75+275508',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129198,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129198,38.91,0.08,605,59497,60,NULL,'M(V) = -19.47 mag','[M96b] J152109.75+275508',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129199,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129199,39.2,0.22,612,59497,65,NULL,NULL,'[M96b] J152109.75+275508',0.13,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129200,'SNIa','2016-12-15 15:15:33','2016-12-16 11:20:47','1','SN 1996ab',NULL,129200,39.23,0.22,624,59497,73.8,NULL,'SALT 2 (SNANA)','[M96b] J152109.75+275508',0.1242,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129201,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129201,37.45,0.46,309,59498,70,NULL,NULL,'2MASX J15210936+0841544',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.289125,8.69856,0.045,NULL,59351456620,927366509,14490101,17.4),(129202,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129202,37.53,0.11,321,59499,70,NULL,NULL,'2MASX J15211006+3042433',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00019,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.291833,30.71203,0,NULL,59906534900,936039607,14625618,17.5),(129203,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129203,38.3,0.23,456,59500,70,NULL,NULL,'2MASX J15211124+3202433',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.2967083,32.04553,0.037,NULL,59903275322,935988676,14624823,18.1),(129204,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129204,37.53,0.11,321,59501,70,NULL,NULL,'2MASX J15211133+3035023',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000067,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,230.297083,30.584,0,NULL,59906583054,936040360,14625630,15.7),(129205,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129205,35.78,0.49,143,59502,75,NULL,'IR','CGCG 165-038',NULL,'2011yCatp016004901K',2011,1,1.16,NULL,'G',0.00005,NULL,'15.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.297333333,26.33142,0.113,NULL,59909795985,936090562,14626415,15.7),(129206,'IRAS','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129206,32.92,0.8,38.3,59503,75,NULL,'MAT, I','IC 4538',NULL,'1997ApJS..109..333W',1997,1,2.6,'6dF final data release has z = 0.012832 +- 0.000150.','G',0.000013,NULL,'12.82',2,'SAB(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,230.298375,-23.65842,0.545,NULL,46622071797,728469871,11382341,12.82),(129207,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129207,32.09,0.32,26.2,59503,85,NULL,'I, raw','IC 4538',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129208,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129208,32.12,0.32,26.6,59503,85,NULL,'I, inv','IC 4538',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129209,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129209,32.15,0.43,27,59503,75,NULL,'MAT, I, raw','IC 4538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129210,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129210,32.33,0.43,29.2,59503,75,NULL,'MAT, I, inv','IC 4538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129211,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129211,32.43,0.43,30.6,59503,75,NULL,'MAT, I, cor','IC 4538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129212,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129212,32.44,NULL,30.8,59503,NULL,NULL,'I','IC 4538',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129213,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129213,32.53,0.45,32,59503,NULL,NULL,'K','IC 4538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129214,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129214,32.53,0.47,32.1,59503,NULL,NULL,'H','IC 4538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129215,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129215,32.53,NULL,32.1,59503,NULL,NULL,'B','IC 4538',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129216,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129216,32.54,0.45,32.2,59503,NULL,NULL,'Malmquist cor.','IC 4538',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129217,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129217,32.55,0.46,32.4,59503,NULL,NULL,'J','IC 4538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129218,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129218,32.56,0.45,32.6,59503,NULL,NULL,NULL,'IC 4538',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129219,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129219,32.6,0.2,33.1,59503,74.4,NULL,NULL,'IC 4538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129220,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129220,32.93,0.4,38.5,59503,NULL,NULL,'mean','IC 4538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129221,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129221,38.21,0.46,439,59504,70,NULL,NULL,'2MASX J15211197+2827250',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.0002,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,230.299916667,28.45697,0.049,NULL,59907750472,936058601,14625915,16.8),(129222,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129222,37.53,0.11,321,59505,70,NULL,NULL,'2MASX J15211350+3032193',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.306417,30.53883,0,NULL,59906582432,936040350,14625630,18.1),(129223,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129223,36.86,0.46,235,59506,70,NULL,NULL,'2MASX J15211380+2419570',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.51',0.15,NULL,NULL,NULL,NULL,NULL,1,230.307625,24.3325,0.145,NULL,59417955222,928405550,14506336,18.51),(129224,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129224,37.67,0.46,342,59507,70,NULL,NULL,'2MASX J15211407+0135174',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.3085,1.58808,0.105,NULL,56432528859,881758263,13777472,17.6),(129225,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129225,34.92,0.51,96.5,59508,70,NULL,NULL,'2MFGC 12404',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000077,NULL,'15.55',NULL,NULL,NULL,NULL,NULL,NULL,1,230.308833333,-13.76061,0.505,NULL,46672702012,729260968,11394702,15.55),(129226,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129226,34.7,0.48,87.1,59509,70,NULL,NULL,'2MASX J15211525-2020262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'15.21',NULL,NULL,NULL,NULL,NULL,NULL,1,230.3135,-20.34081,0.549,NULL,46616057932,728375905,11380873,15.21),(129227,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129227,37.36,0.46,296,59510,70,NULL,NULL,'2MASX J15211594+0950294',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.316375,9.84167,0.073,NULL,59355475341,927429302,14491082,17.7),(129228,'BCG','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129228,37.59,0.35,306,59511,60,NULL,NULL,'ABELL 2061',0.0782,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,230.320833,30.64,0,NULL,59906577810,936040278,14625629,NULL),(129229,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129229,35.77,0.46,142,59512,70,NULL,NULL,'2MASX J15211747+5655372',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000085,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,230.322791667,56.92689,0.025,NULL,57593168795,899893262,14060832,16.1),(129230,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129230,37.53,0.11,321,59513,70,NULL,NULL,'2MASX J15211760+3035314',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000185,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.3232917,30.59211,0,NULL,59906588364,936040443,14625631,17.4),(129231,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129231,37.53,0.11,321,59514,70,NULL,NULL,'2MASX J15211835+3049584',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,230.3265417,30.83303,0.017,NULL,59903764966,935996327,14624942,16.3),(129232,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129232,35.68,0.46,137,59515,70,NULL,NULL,'2MASX J15211924+3417464',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.330041667,34.29625,0.037,NULL,60105173988,939143343,14674114,16.3),(129233,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129233,38.12,0.27,421,59516,70,NULL,NULL,'2MASX J15211933+1913372',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.3307083,19.22703,0.173,NULL,59441841248,928778769,14512168,17.2),(129234,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129234,36.98,0.33,248,59517,70,NULL,NULL,'2MASX J15212015+2357170',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.75',0.23,NULL,NULL,NULL,NULL,NULL,1,230.3340417,23.95481,0.165,NULL,59422389283,928474832,14507419,16.75),(129235,'BCG','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129235,37.59,0.35,306,59518,60,NULL,'ABELL 2061, BCG','CGCG 165-041',0.0782,'1980ApJ...241..486H',1980,1,0.79,NULL,'G',0.000077,NULL,'15.3g',0.53,'BrClG','Brightest group member',NULL,NULL,NULL,1,230.33575,30.67094,0,NULL,59906580346,936040317,14625629,15.3),(129236,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129236,37.53,0.11,321,59518,70,NULL,NULL,'CGCG 165-041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129237,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129237,38.26,0.27,449,59519,70,NULL,NULL,'2MASX J15212060+4606214',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.3360417,46.10592,0.033,NULL,59966388345,936974817,14640231,17.9),(129238,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129238,37.89,0.46,379,59520,70,NULL,NULL,'2MASX J15212080+0230254',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.336583333,2.50708,0.077,NULL,56433221214,881769081,13777641,17.2),(129239,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129239,34.19,0.94,68.8,59521,NULL,NULL,NULL,'ESO 582- G 005',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.98',0.3,'S',NULL,NULL,NULL,NULL,1,230.336625,-19.85642,0.521,NULL,46616131731,728377058,11380891,14.98),(129240,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129240,34.23,0.2,70.2,59521,74.4,NULL,NULL,'ESO 582- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129241,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129241,34.49,0.82,79,59521,NULL,NULL,'Malmquist cor.','ESO 582- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129242,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129242,37.51,0.46,317,59522,70,NULL,NULL,'2MASX J15212090+1706161',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.33725,17.10461,0.097,NULL,59566744081,930730376,14542662,16.7),(129243,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129243,37.57,0.27,327,59523,70,NULL,NULL,'2MASX J15212245+0715274',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,230.343708333,7.25761,0.057,NULL,56409956360,881405568,13771962,16.1),(129244,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129244,36.02,0.21,160,59524,70,NULL,NULL,'CGCG 049-138',NULL,'2001MNRAS.321..277C',2001,1,1.8,NULL,'G',0.00017,NULL,'14.13',0.8,'E/S0',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,230.343916667,4.34169,0.045,NULL,56427862761,881685355,13776333,14.13),(129245,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129245,36.09,0.25,165,59524,74.4,NULL,NULL,'CGCG 049-138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129246,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129246,36.65,0.33,213,59524,70,NULL,NULL,'CGCG 049-138',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129247,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129247,38.49,0.46,500,59525,70,NULL,NULL,'2MASX J15212284+4545104',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.345333,45.753,0.033,NULL,59966249823,936972653,14640197,17.8),(129248,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129248,36.98,0.33,248,59526,70,NULL,NULL,'2MASX J15212292+2355300',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.345375,23.925,0.165,NULL,59422521560,928476899,14507451,17.5),(129249,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129249,35.7,0.52,138,59527,NULL,NULL,NULL,'2MFGC 12406',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000043,NULL,'17.2g',0.15,'Sc',NULL,NULL,NULL,NULL,1,230.3465,8.25883,0.069,NULL,59351175916,927362123,14490033,17.2),(129250,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129250,35.72,0.49,139,59527,75,NULL,'IR','2MFGC 12406',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129251,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129251,35.74,0.2,141,59527,74.4,NULL,NULL,'2MFGC 12406',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129252,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129252,35.99,0.46,158,59527,NULL,NULL,'Malmquist cor.','2MFGC 12406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129253,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129253,37.28,0.46,286,59528,70,NULL,NULL,'2MASX J15212361+1406581',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.348417,14.11625,0.129,NULL,59574873402,930857396,14544646,17.2),(129254,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129254,38.01,0.46,399,59529,70,NULL,NULL,'2MASX J15212503+3058034',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.354291667,30.96764,0.033,NULL,59903760568,935996258,14624941,17.3),(129255,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129255,35.11,0.25,105,59530,NULL,NULL,NULL,'ESO 582- G 006',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.5',0.5,'Sb:',NULL,NULL,NULL,NULL,1,230.359625,-18.22533,0.461,NULL,46595405821,728053215,11375831,15.5),(129256,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129256,35.1,0.25,105,59530,NULL,NULL,'Malmquist cor.','ESO 582- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129257,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129257,35.15,0.2,107,59530,74.4,NULL,NULL,'ESO 582- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129258,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129258,37.53,0.11,321,59531,70,NULL,NULL,'2MASX J15212674+3042204',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.3614583,30.70578,0,NULL,59906577065,936040266,14625629,17.5),(129259,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129259,38.2,0.46,437,59532,70,NULL,NULL,'2MASX J15212746+0328464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.364333,3.47956,0.057,NULL,56434522913,881789420,13777959,17.6),(129260,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129260,34.81,0.2,91.6,59533,74.4,NULL,NULL,'ESO 582- G 007',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'16',0.5,'S...',NULL,NULL,NULL,NULL,1,230.365083,-18.87289,0.493,NULL,46624077279,728501207,11382831,16),(129261,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129261,34.98,0.21,99.2,59533,NULL,NULL,NULL,'ESO 582- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129262,'Tully-Fisher','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129262,35.05,0.2,102,59533,NULL,NULL,'Malmquist cor.','ESO 582- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129263,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129263,37.53,0.11,321,59534,70,NULL,NULL,'2MASX J15212790+3036294',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.3662083,30.60822,0,NULL,59906587273,936040426,14625631,17.7),(129264,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129264,36.56,0.46,205,59535,70,NULL,NULL,'I Zw 110 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.367625,41.92936,0.017,NULL,59976084069,937126313,14642598,17.3),(129265,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,NULL,129265,35.31,0.5,115,59536,70,NULL,NULL,'2MFGC 12407',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,230.370791667,-10.14578,0.441,NULL,46488294392,726379599,11349681,16.2),(129266,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129266,34.42,0.46,76.6,59537,70,NULL,NULL,'CGCG 106-033',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00015,NULL,'15.1',0.5,NULL,NULL,NULL,NULL,NULL,1,230.370833,15.13756,0.073,NULL,59574734553,930855227,14544612,15.1),(129267,'FP','2016-12-15 15:15:33','2016-12-16 11:20:47','1',NULL,'R',129267,38.16,0.23,429,59538,70,NULL,NULL,'2MASXi J1521294+220634',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.372791667,22.10936,0.173,NULL,59421347647,928458556,14507164,17.8),(129268,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129268,38.16,0.23,429,59539,70,NULL,NULL,'2MASX J15212949+2211011',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.372875,22.18378,0.173,NULL,59421318577,928458102,14507157,18.5),(129269,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129269,37.63,0.46,335,59540,70,NULL,NULL,'2MASX J15212973+3424174',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.373833333,34.40489,0.041,NULL,60104705232,939136019,14674000,17.5),(129270,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129270,37.56,0.46,325,59541,70,NULL,NULL,'2MASX J15212975+4424530',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000187,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.374083333,44.41478,0.049,NULL,59967405442,936990710,14640479,17.2),(129271,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129271,36.88,0.46,238,59542,70,NULL,NULL,'2MASX J15213000+0351214',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.375125,3.85594,0.065,NULL,56427991961,881687374,13776365,17.1),(129272,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129272,38.3,0.23,456,59543,70,NULL,NULL,'SDSS J152130.45+320630.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.376875,32.10858,0.037,NULL,59903265872,935988529,14624820,18.6),(129273,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129273,37.19,0.23,274,59544,70,NULL,NULL,'2MASX J15213043+5649044',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000113,NULL,'16.2g',0.39,'AGN',NULL,NULL,NULL,NULL,1,230.377,56.818,0.025,NULL,57593901424,899904709,14061011,16.2),(129274,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129274,34.23,0.5,70.1,59545,70,NULL,NULL,'2MASX J15213056-2031262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.11',NULL,NULL,NULL,NULL,NULL,NULL,1,230.377833,-20.52389,0.485,NULL,46618953381,728421146,11381580,15.11),(129275,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129275,37.19,0.23,274,59546,70,NULL,NULL,'2MASX J15213151+5651114',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,230.38125,56.85325,0.025,NULL,57593902357,899904724,14061011,16.3),(129276,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129276,36.69,0.11,218,59547,70,NULL,NULL,'MCG +01-39-020 NED01',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000063,NULL,'15.9g',0.36,'AGN',NULL,NULL,NULL,NULL,1,230.3815,7.7405,0.073,NULL,59350976514,927359008,14489984,15.9),(129277,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129277,37.57,0.27,327,59548,70,NULL,NULL,'2MASX J15213273+0708134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.386541667,7.13711,0.053,NULL,56409942376,881405349,13771958,16.9),(129278,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129278,34.27,0.42,71.4,59549,NULL,NULL,NULL,'UGC 09826',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00015,NULL,'15.05',0.7,'SBb(r)         Sy1','Isolated galaxy',NULL,NULL,'Sy 1.5',1,230.387416667,39.20075,0.045,NULL,60111624917,939244139,14675689,15.05),(129279,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129279,34.44,0.39,77.3,59549,NULL,NULL,'Malmquist cor.','UGC 09826',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129280,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129280,35.32,0.63,116,59550,70,NULL,NULL,'2MASX J15213303-1006546',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.26',NULL,NULL,NULL,NULL,NULL,NULL,1,230.38775,-10.11511,0.441,NULL,46488296924,726379639,11349681,16.26),(129281,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129281,32.64,0.8,33.7,59551,75,NULL,'B','NGC 5915',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.00001,NULL,'13.03',1.3,'SB(s)ab pec    HII','in an interacting triple',NULL,NULL,NULL,1,230.387833,-13.09175,0.545,NULL,46659433476,729053648,11391463,13.03),(129282,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129282,31.94,0.47,24.4,59551,NULL,NULL,'H','NGC 5915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129283,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129283,31.94,0.45,24.4,59551,NULL,NULL,'K','NGC 5915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129284,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129284,31.96,0.46,24.7,59551,NULL,NULL,'J','NGC 5915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129285,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129285,32.44,0.4,30.8,59551,NULL,NULL,'mean','NGC 5915',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129286,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129286,36.69,0.11,218,59552,70,NULL,NULL,'2MASX J15213321+0738314',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.388416667,7.64222,0.073,NULL,59349664037,927338500,14489664,17.6),(129287,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129287,31.63,0.34,21,59553,74.2,NULL,'SALT 2','MCG -01-39-003',0.006461,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',NULL,NULL,'14.64',0.7,'S0 pec',NULL,NULL,NULL,NULL,1,230.388708333,-7.44789,0.289,NULL,45391074355,709235536,11081805,14.64),(129288,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129288,32.01,0.17,25.1,59553,72,NULL,NULL,'MCG -01-39-003',0.006461,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129289,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129289,32.13,0.06,26.5,59553,72,NULL,NULL,'MCG -01-39-003',0.006461,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129290,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129290,32.2,0.1,27.4,59553,72,NULL,'NIR','MCG -01-39-003',0.006461,'2009ApJ...697..380W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129291,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129291,32.21,0.1,27.7,59553,74.4,NULL,NULL,'MCG -01-39-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129292,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129292,32.23,0.02,27.9,59553,72,NULL,'M(H) = -18.317 mag','MCG -01-39-003',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129293,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129293,32.29,0.12,28.5,59553,72,NULL,NULL,'MCG -01-39-003',0.006461,'2009ApJ...697..380W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129294,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129294,32.33,0.05,29.1,59553,72,NULL,NULL,'MCG -01-39-003',0.006461,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129295,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129295,32.43,0.13,30.4,59553,72,NULL,'MLCS2k2','MCG -01-39-003',0.006461,'2009ApJ...697..380W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129296,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129296,32.58,0.1,32.6,59553,72,NULL,'MLCS2k2, R(V) = 3.1','MCG -01-39-003',0.006461,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129297,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2005cf',NULL,129297,32.58,0.08,32.6,59553,72,NULL,'MLCS2k2, R(V) = 1.7','MCG -01-39-003',0.006461,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129298,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129298,37.26,0.46,284,59554,70,NULL,NULL,'2MASX J15213375+1018574',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.390541667,10.31592,0.077,NULL,59355147432,927424178,14491002,16.9),(129299,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129299,38.16,0.23,429,59555,70,NULL,NULL,'2MASX J15213389+2214191',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.391166667,22.23858,0.173,NULL,59421312004,928458000,14507156,17.7),(129300,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129300,34.13,NULL,67,59556,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1889',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.000092,NULL,'17.1g',0.12,'Sd',NULL,NULL,NULL,NULL,1,230.395041667,41.90525,0.017,NULL,59976083691,937126307,14642598,17.1),(129301,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129301,34.15,NULL,67.6,59556,NULL,NULL,'Dipole + Quadrupole','FGC 1889',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129302,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129302,34.17,NULL,68.3,59556,NULL,NULL,'Dipole','FGC 1889',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129303,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129303,34.21,NULL,69.6,59556,NULL,NULL,NULL,'FGC 1889',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129304,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129304,37.49,0.09,315,59557,70,NULL,NULL,'2MASX J15213494+2737319',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'15.36',0.2,NULL,NULL,NULL,NULL,NULL,1,230.3957083,27.62556,0.073,NULL,59910782132,936105970,14626655,15.36),(129305,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129305,38.17,0.33,431,59558,70,NULL,NULL,'2MASX J15213527+3138374',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000156,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.396958333,31.64353,0.029,NULL,59903959440,935999366,14624990,16.9),(129306,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129306,37.53,0.11,321,59559,70,NULL,NULL,'SDSS J152135.33+304057.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.39725,30.68269,0,NULL,59906561762,936040027,14625625,18.2),(129307,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129307,37.97,0.46,393,59560,70,NULL,NULL,'2MASX J15213552+3724125',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000156,NULL,'17.9g',NULL,NULL,NULL,NULL,NULL,NULL,1,230.398125,37.40336,0.029,NULL,60112522383,939258162,14675908,17.9),(129308,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129308,35.32,0.2,116,59561,74.4,NULL,NULL,'CGCG 106-034',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000535,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,230.4002083,14.38447,0.133,NULL,59574547781,930852309,14544567,15.7),(129309,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129309,36.69,0.11,218,59562,70,NULL,NULL,'MCG +01-39-020 NED04',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000113,NULL,'16.78',0.3,'AGN',NULL,NULL,NULL,NULL,1,230.401625,7.73908,0.073,NULL,59350976666,927359010,14489984,16.78),(129310,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129310,36.69,0.11,218,59563,70,NULL,NULL,'NGC 5919',NULL,'2015arXiv151105856S',2015,1,0.84,'UZC has V = 12984 +- 66 km/sec.','G',0.000083,NULL,'14.37',0.54,'SB0',NULL,NULL,NULL,NULL,1,230.403667,7.71931,0.073,NULL,59350977465,927359022,14489984,14.37),(129311,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129311,38.3,0.23,456,59564,70,NULL,NULL,'2MASX J15213769+3212303',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.407167,32.20836,0.041,NULL,59903086188,935985721,14624776,18.4),(129312,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129312,37.88,0.46,377,59565,70,NULL,NULL,'2MASX J15213777+2833479',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0002,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.40725,28.56336,0.049,NULL,59907753889,936058654,14625916,17.4),(129313,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129313,38.71,0.46,551,59566,70,NULL,NULL,'2MASX J15213802+0519515',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,'PHOT','17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.4085417,5.33086,0.085,NULL,56429941657,881717838,13776841,17.9),(129314,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129314,38.17,0.33,431,59567,70,NULL,NULL,'2MASX J15213911+3140383',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000189,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.413125,31.67744,0.029,NULL,59903926484,935998851,14624982,16.7),(129315,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129315,38.11,0.46,419,59568,70,NULL,NULL,'2MASX J15213913+1243460',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.413167,12.72961,0.113,NULL,59562203857,930659435,14541553,18.2),(129316,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129316,38.31,0.46,460,59569,70,NULL,NULL,'2MASX J15213951+0432335',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.414625,4.54269,0.053,NULL,56427351175,881677362,13776208,17.8),(129317,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129317,36.89,0.46,239,59570,70,NULL,NULL,'2MASX J15213965+0015595',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.415083,0.26644,0.177,NULL,56375880454,880873132,13763642,16.9),(129318,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129318,36.73,0.46,222,59571,70,NULL,NULL,'2MASX J15214000+2548460',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00011,NULL,'15.6g',0.42,NULL,NULL,NULL,NULL,NULL,1,230.4165417,25.81275,0.109,NULL,59901121369,935955021,14624297,15.6),(129319,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129319,38.26,0.27,449,59572,70,NULL,NULL,'2MASX J15214008+4609241',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.417,46.15661,0.033,NULL,59966379967,936974686,14640229,17.9),(129320,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129320,37.41,0.46,303,59573,70,NULL,NULL,'2MASX J15214015+0752359',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000083,NULL,'16.00',0.31,'E',NULL,NULL,NULL,NULL,1,230.417167,7.8765,0.065,NULL,59351029029,927359828,14489997,16),(129321,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129321,37.12,0.27,265,59574,70,NULL,NULL,'2MASX J15214066+3333323',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000185,NULL,'16.0g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,230.41925,33.559,0.049,NULL,60104467465,939132304,14673942,16),(129322,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129322,37.53,0.11,321,59575,70,NULL,NULL,'2MASX J15214069+3040363',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00014,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.419667,30.67681,0.013,NULL,59906562028,936040031,14625625,17),(129323,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129323,38.16,0.23,429,59576,70,NULL,NULL,'2MASX J15214115+2212494',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.421583,22.21386,0.173,NULL,59421326114,928458220,14507159,17.8),(129324,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129324,36.69,0.11,218,59577,70,NULL,NULL,'CGCG 049-144',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00007,NULL,'15.4B',0.41,NULL,'Group member',NULL,NULL,NULL,1,230.4230417,7.72353,0.073,NULL,59350977307,927359020,14489984,15.4),(129325,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129325,37.53,0.11,321,59578,70,NULL,NULL,'2MASX J15214188+3035087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.424375,30.58581,0.013,NULL,59906573996,936040218,14625628,17.6),(129326,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129326,37.19,0.23,274,59579,70,NULL,NULL,'2MASX J15214372+5646505',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.432375,56.78078,0.025,NULL,57593943789,899905371,14061021,17.4),(129327,'G Lens','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129327,41.92,NULL,2420,59580,NULL,NULL,'R(H) = ct','SBS 1520+530 ABS01',NULL,'2014ApJ...788..190W',2014,1,NULL,NULL,'AbLS',0.0009,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.436791667,52.9135,0.029,NULL,59673702489,932401601,14568775,NULL),(129328,'G Lens','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129328,41.93,NULL,2440,59580,NULL,NULL,'Standard','SBS 1520+530 ABS01',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129329,'G Lens','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129329,42.23,0.3,2790,59580,NULL,NULL,NULL,'SBS 1520+530 ABS01',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129330,'G Lens','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129330,43.58,0.68,5200,59580,NULL,NULL,NULL,'SBS 1520+530 ABS01',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129331,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129331,37.36,0.46,297,59581,70,NULL,NULL,'SDSS J152144.94+241814.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.43725,24.304,0.145,NULL,59417963889,928405685,14506338,18.2),(129332,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129332,38.22,0.46,440,59582,70,NULL,NULL,'2MASX J15214553+1917034',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.439625,19.28442,0.173,NULL,59442560271,928790004,14512343,17.5),(129333,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129333,37.27,0.46,284,59583,70,NULL,NULL,'2MASX J15214579+0211355',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.4407917,2.19325,0.097,NULL,56432736468,881761507,13777523,16.7),(129334,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129334,37.53,0.11,321,59584,70,NULL,NULL,'2MASX J15214645+3035517',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000067,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.443625,30.59758,0.013,NULL,59906566554,936040102,14625626,16.7),(129335,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129335,37.1,0.46,264,59585,70,NULL,NULL,'2MASX J15214666+0830199',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,230.444375,8.50544,0.045,NULL,59351468586,927366696,14490104,16.7),(129336,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129336,37.98,0.46,394,59586,70,NULL,NULL,'2MASX J15214699+0545425',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.445833,5.76183,0.049,NULL,56426712963,881667390,13776052,16.7),(129337,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129337,36.69,0.11,218,59587,70,NULL,NULL,'2MASX J15214777+0731219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000057,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.449125,7.52283,0.073,NULL,56409728899,881402014,13771906,16.8),(129338,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129338,37.15,0.33,269,59588,70,NULL,NULL,'2MASX J15214868+5805155',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,230.4529583,58.08761,0.033,NULL,57721227306,901894176,14092096,16),(129339,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129339,37.57,0.46,326,59589,70,NULL,NULL,'2MASX J15214905+1159209',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.454583,11.98931,0.097,NULL,59342964900,927233826,14488028,17.7),(129340,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129340,38.64,0.46,534,59590,70,NULL,NULL,'2MASX J15214932+0221015',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.455417,2.35033,0.077,NULL,56433198381,881768724,13777636,17.8),(129341,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129341,37.67,0.46,341,59591,70,NULL,NULL,'2MASX J15214938+2833370',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.0002,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.455833,28.56019,0.049,NULL,59907767054,936058860,14625919,17.8),(129342,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129342,36.69,0.11,218,59592,70,NULL,NULL,'2MASX J15215039+0744089',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000067,NULL,'17.18',0.5,NULL,NULL,NULL,NULL,NULL,1,230.459917,7.73583,0.065,NULL,59350975785,927358996,14489984,17.18),(129343,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129343,35.93,0.33,154,59593,70,NULL,NULL,'2MASX J15215057+0821519',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000067,NULL,'16.2g',0.33,'S0','Group member',NULL,NULL,NULL,1,230.460666667,8.36442,0.069,NULL,59351174517,927362101,14490032,16.2),(129344,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129344,36.45,0.46,195,59594,70,NULL,NULL,'SDSS J152150.57+280618.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0002,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.4607083,28.10506,0.049,NULL,59907587505,936056054,14625875,17.6),(129345,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129345,36.69,0.11,218,59595,70,NULL,NULL,'NGC 5920',NULL,'2015arXiv151105856S',2015,1,1.1,'TXS codes: variable(*)','G',0.00008,NULL,'14.68',0.9,'cD;S0:         NLRG','Group member',NULL,NULL,NULL,1,230.4660417,7.70881,0.065,NULL,59350978164,927359033,14489984,14.68),(129346,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129346,37.72,0.33,349,59596,70,NULL,NULL,'2MASX J15215215+2019334',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.467375,20.32583,0.205,NULL,59412582992,928321609,14505025,NULL),(129347,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129347,38.19,0.46,435,59597,70,NULL,NULL,'SDSS J152152.76+391558.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.469875,39.26619,0.045,NULL,60110752629,939230509,14675476,18.6),(129348,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129348,36.69,0.46,218,59598,70,NULL,NULL,'2MASX J15215302+2621280',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000191,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.471083333,26.35769,0.113,NULL,59909759479,936089991,14626406,16.5),(129349,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129349,37.7,0.46,347,59599,70,NULL,NULL,'SDSS J152153.46+410439.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.4727917,41.07753,0.017,NULL,59975570096,937118282,14642473,17.9),(129350,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129350,35.56,0.23,129,59600,74.4,NULL,NULL,'IC 1116',NULL,'2013AJ....146...86T',2013,1,1.09,NULL,'G',0.000063,NULL,'14.3g',0.75,'cD;E/S0','Group member',NULL,NULL,NULL,1,230.480291667,8.42378,0.081,NULL,59351335005,927364609,14490072,14.3),(129351,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129351,35.68,0.16,137,59600,70,NULL,NULL,'IC 1116',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129352,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129352,35.93,0.33,154,59600,70,NULL,NULL,'IC 1116',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129353,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129353,36.16,0.4,170,59600,NULL,NULL,'mean','IC 1116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129354,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129354,36.3,0.45,182,59600,NULL,NULL,'K','IC 1116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129355,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129355,37.12,0.27,265,59601,70,NULL,NULL,'2MASX J15215589+3330548',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000224,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.483083333,33.51508,0.041,NULL,60104470466,939132351,14673942,16.6),(129356,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129356,37.36,0.46,296,59602,70,NULL,NULL,'2MASX J15215590+5258316',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000142,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.483083333,52.97556,0.029,NULL,59673697991,932401531,14568773,17.5),(129357,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129357,36.69,0.11,218,59603,70,NULL,NULL,'2MASX J15215644+0740249',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00008,NULL,'17.29',0.28,NULL,NULL,NULL,NULL,NULL,1,230.485166667,7.67353,0.073,NULL,56411557237,881430581,13772352,17.29),(129358,'Ring Diameter','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129358,31.9,0.76,24,59604,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5921',NULL,'1981ApJS...45..541P',1981,1,4.9,NULL,'G',0.000003,NULL,'11.49',4,'SB(r)bc        LINER','Field galaxy',NULL,NULL,NULL,1,230.485666667,5.07053,0.061,NULL,56430164373,881721318,13776895,11.49),(129359,'Ring Diameter','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129359,32.1,0.6,26,59604,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5921',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129360,'SNII optical','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2001X',NULL,129360,31.59,0.11,20.6,59604,NULL,NULL,'SEAM','NGC 5921',0.004937,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129361,'SNII optical','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2001X',NULL,129361,31.85,0.22,23.4,59604,NULL,NULL,'V, photospheric magnitude method','NGC 5921',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129362,'SNII optical','2016-12-15 15:15:34','2016-12-16 11:20:47','1','SN 2001X',NULL,129362,31.96,0.2,24.7,59604,NULL,NULL,'I, photospheric magnitude method','NGC 5921',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129363,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129363,30.73,0.4,14,59604,NULL,NULL,NULL,'NGC 5921',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129364,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129364,32.01,0.4,25.2,59604,75,NULL,'B','NGC 5921',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129365,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129365,37.33,0.27,292,59605,70,NULL,NULL,'SDSS J152156.66+022039.2',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.4g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.486083,2.34422,0.077,NULL,56433198646,881768728,13777636,16.4),(129366,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129366,35.96,0.46,156,59606,70,NULL,NULL,'2MASX J15215683+0444095',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.46',0.36,NULL,NULL,NULL,NULL,NULL,1,230.48675,4.73589,0.053,NULL,56429257020,881707140,13776674,16.46),(129367,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129367,38.57,0.46,518,59607,70,NULL,NULL,'2MASX J15215681+0322535',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.486791667,3.38144,0.057,NULL,56434569954,881790155,13777971,17.9),(129368,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129368,37.43,0.33,306,59608,70,NULL,NULL,'2MASX J15215743+2859180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000117,NULL,'17.80',0.21,'Sy2',NULL,NULL,NULL,'Sy 2',1,230.48925,28.98839,0.033,NULL,59905903305,936029739,14625464,17.8),(129369,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129369,37.86,0.46,373,59609,70,NULL,NULL,'SDSS J152158.37+183332.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.4932083,18.55903,0.157,NULL,59433472327,928648005,14510125,18.2),(129370,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129370,38.15,0.46,427,59610,70,NULL,NULL,'2MASX J15215861+0337425',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00011,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.494333,3.62844,0.065,NULL,56434545713,881789776,13777965,16.9),(129371,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129371,37.71,0.33,348,59611,70,NULL,NULL,'2MASX J15215900+2724410',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,'Group member',NULL,NULL,NULL,1,230.495667,27.41153,0.089,NULL,59910894136,936107720,14626683,17.1),(129372,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129372,37.49,0.09,315,59612,70,NULL,NULL,'2MASX J15215953+2740390',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000217,NULL,'18.33',0.17,NULL,'Group member',NULL,NULL,NULL,1,230.498166667,27.67761,0.073,NULL,59910774539,936105852,14626653,18.33),(129373,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129373,37.72,0.33,349,59613,70,NULL,NULL,'2MASX J15215962+2022364',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.49825,20.37678,0.193,NULL,59415998373,928374974,14505858,16.5),(129374,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129374,38.3,0.23,456,59614,70,NULL,NULL,'2MASX J15215987+3217498',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000145,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.499417,32.29717,0.033,NULL,59911470464,936116726,14626823,17.5),(129375,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129375,36.26,0.46,179,59615,70,NULL,NULL,'2MASX J15220012+0533315',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.500583,5.55892,0.049,NULL,56429486750,881710730,13776730,15.9),(129376,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129376,37.49,0.09,315,59616,70,NULL,NULL,'2MASX J15220013+2734450',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,'Group member',NULL,NULL,NULL,1,230.500583,27.57936,0.081,NULL,59910762577,936105665,14626651,17.1),(129377,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129377,37.49,0.09,315,59617,70,NULL,NULL,'2MASX J15220043+2739250',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,'Group member',NULL,NULL,NULL,1,230.501625,27.65706,0.073,NULL,59910774238,936105847,14626653,17.4),(129378,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129378,36.69,0.11,218,59618,70,NULL,NULL,'2MASX J15220101+0735109',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000043,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.504291667,7.58636,0.073,NULL,56412617954,881447155,13772611,16.8),(129379,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129379,37.53,0.11,321,59619,70,NULL,NULL,'SDSS J152201.41+304058.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.505875,30.68292,0.013,NULL,59906571352,936040177,14625627,18.6),(129380,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129380,37.71,0.33,348,59620,70,NULL,NULL,'2MASX J15220155+2727540',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,'Group member',NULL,NULL,NULL,1,230.5065417,27.46517,0.081,NULL,59910888362,936107630,14626681,18),(129381,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129381,37.63,0.46,336,59621,70,NULL,NULL,'SDSS J152201.69+271114.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.507083,27.18736,0.093,NULL,59910693228,936104581,14626634,18.3),(129382,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129382,37.77,0.46,358,59622,70,NULL,NULL,'2MASX J15220176+3949127',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.507417,39.82025,0.013,NULL,60110696875,939229638,14675463,17.9),(129383,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129383,37.36,0.27,297,59623,70,NULL,NULL,'2MASX J15220187+4801255',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000171,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.5079583,48.02372,0.041,NULL,59936697524,936510898,14632982,16.5),(129384,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129384,36.94,0.46,245,59624,70,NULL,NULL,'2MASX J15220248+1233085',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.510417,12.55239,0.113,NULL,59562196973,930659327,14541551,17.6),(129385,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129385,37.49,0.09,315,59625,70,NULL,NULL,'2MASX J15220270+2748270',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,'Group member',NULL,NULL,NULL,1,230.511333333,27.80761,0.069,NULL,59907905655,936061025,14625953,17.3),(129386,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129386,37.33,0.27,292,59626,70,NULL,NULL,'2MASX J15220346+0224543',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.68',0.38,NULL,NULL,NULL,NULL,NULL,1,230.514458333,2.41517,0.077,NULL,56433276581,881769946,13777655,16.68),(129387,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129387,36.69,0.11,218,59627,70,NULL,NULL,'2MASX J15220466+0736386',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000067,NULL,'16.90',0.3,NULL,NULL,NULL,NULL,NULL,1,230.519541667,7.61086,0.073,NULL,56412616605,881447134,13772611,16.9),(129388,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129388,37.53,0.11,321,59628,70,NULL,NULL,'2MASX J15220596+3029517',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.524875,30.49764,0.013,NULL,59906708470,936042319,14625661,17),(129389,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129389,38,0.46,399,59629,70,NULL,NULL,'2MASX J15220687+0615326',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.5287917,6.25908,0.057,NULL,56409501334,881398458,13771850,17.2),(129390,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129390,37.49,0.09,315,59630,70,NULL,NULL,'2MASX J15220718+2811300',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.5297917,28.19161,0.049,NULL,59907632414,936056756,14625886,16.7),(129391,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129391,34.91,0.46,96.1,59631,70,NULL,NULL,'2MASX J15220752+1411215',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.84',0.52,NULL,NULL,NULL,NULL,NULL,1,230.53125,14.18931,0.129,NULL,59574385436,930849772,14544527,15.84),(129392,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129392,37.33,0.46,293,59632,70,NULL,NULL,'2MASX J15220763+5739084',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000098,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,230.531583,57.65239,0.045,NULL,57589617861,899837779,14059965,16.3),(129393,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129393,35.67,0.2,136,59633,74.4,NULL,NULL,'CGCG 077-088',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000009,NULL,'15.0',0.6,'S',NULL,NULL,NULL,NULL,1,230.532625,13.92822,0.125,NULL,59574321280,930848770,14544512,15),(129394,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129394,37.81,0.46,364,59634,70,NULL,NULL,'2MASX J15220927+2837321',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0002,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.5387083,28.62569,0.041,NULL,59907761847,936058778,14625918,17.3),(129395,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129395,38.53,0.46,507,59635,70,NULL,NULL,'2MASX J15220990+4253027',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.541208333,42.88394,0.081,NULL,59978294103,937160845,14643138,17.7),(129396,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129396,37.88,0.46,376,59636,70,NULL,NULL,'2MASX J15221008+2411001',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.43',0.15,NULL,NULL,NULL,NULL,NULL,1,230.542208333,24.18347,0.153,NULL,59418004691,928406323,14506348,18.43),(129397,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129397,37.29,0.46,287,59637,70,NULL,NULL,'2MASX J15221052+3331007',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.543917,33.51692,0.041,NULL,60104467045,939132297,14673942,17),(129398,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129398,37.15,0.33,269,59638,70,NULL,NULL,'2MASX J15221309+5807212',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.554583,58.12258,0.033,NULL,57721227050,901894172,14092096,16.9),(129399,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129399,37.12,0.27,265,59639,70,NULL,NULL,'2MASX J15221419+3326077',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.5592083,33.43539,0.037,NULL,60104500488,939132820,14673950,17.6),(129400,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129400,37.27,0.46,285,59640,70,NULL,NULL,'2MASX J15221424+0637406',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.55925,6.62803,0.053,NULL,56409586030,881399781,13771871,18),(129401,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129401,37.49,0.09,315,59641,70,NULL,NULL,'2MASX J15221530+2736171',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,'Group member',NULL,NULL,NULL,1,230.563833,27.60467,0.073,NULL,59910757073,936105579,14626649,17.4),(129402,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129402,37.91,0.46,382,59642,70,NULL,NULL,'SDSS J152215.32+190137.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.563875,19.02722,0.169,NULL,59442632146,928791127,14512361,18.5),(129403,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129403,37.55,0.46,324,59643,70,NULL,NULL,'2MASX J15221586+2342040',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.566208333,23.70119,0.149,NULL,59422338427,928474037,14507406,18),(129404,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129404,37.82,0.46,367,59644,70,NULL,NULL,'2MASX J15221634+0824366',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.5680417,8.41028,0.081,NULL,59351058539,927360289,14490004,16.7),(129405,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129405,36.69,0.11,218,59645,70,NULL,NULL,'2MASX J15221641+0802546',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'16.0g',0.37,'S0','Group member',NULL,NULL,NULL,1,230.568417,8.04844,0.057,NULL,59351213122,927362705,14490042,16),(129406,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129406,37.95,0.46,389,59646,70,NULL,NULL,'SDSS J152216.84+124453.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.570208333,12.74806,0.109,NULL,59562223958,930659749,14541558,18.5),(129407,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129407,37.34,0.33,294,59647,70,NULL,NULL,'2MASX J15221736+3706016',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.77',0.4,NULL,NULL,NULL,NULL,NULL,1,230.5724583,37.10056,0.029,NULL,60112445970,939256968,14675890,16.77),(129408,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129408,35.62,0.25,133,59648,74.4,NULL,NULL,'CGCG 077-089',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000047,NULL,'15.7',0.31,'S0','Group member',NULL,NULL,NULL,1,230.575125,8.57989,0.073,NULL,59351343490,927364742,14490074,15.7),(129409,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129409,37.36,0.46,296,59649,70,NULL,NULL,'2MASX J15221858+2658081',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.577333,26.96894,0.093,NULL,59909631985,936087999,14626374,17.2),(129410,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129410,37.67,0.33,341,59650,70,NULL,NULL,'2MASX J15221862+2314210',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.5775,23.23906,0.189,NULL,59420993418,928453022,14507078,16.9),(129411,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129411,37.49,0.09,315,59651,70,NULL,NULL,'2MASX J15221903+2805371',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.53',0.15,NULL,NULL,NULL,NULL,NULL,1,230.57925,28.09375,0.049,NULL,59908042613,936063165,14625986,18.53),(129412,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129412,38.04,0.46,406,59652,70,NULL,NULL,'2MASX J15221914+2204240',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.57975,22.07342,0.173,NULL,59421302468,928457851,14507153,17.3),(129413,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129413,37.13,0.46,267,59653,70,NULL,NULL,'SDSS J152219.55+361848.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.5815417,36.31336,0.037,NULL,60105703373,939151615,14674243,18.2),(129414,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129414,37.65,0.27,338,59654,70,NULL,NULL,'SDSS J152220.49+483029.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,230.585417,48.50828,0.025,NULL,59937002158,936515658,14633057,18.6),(129415,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129415,37.17,0.46,271,59655,70,NULL,NULL,'2MASX J15222065+2449151',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.5859583,24.82081,0.129,NULL,59418440809,928413137,14506455,17.9),(129416,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129416,37.24,0.46,281,59656,70,NULL,NULL,'SDSS J152221.74+032640.2',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.590583333,3.4445,0.061,NULL,56434524796,881789449,13777960,17.7),(129417,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129417,38.45,0.46,490,59657,70,NULL,NULL,'2MASX J15222180-0207431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,230.590917,-2.12881,0.329,NULL,45421874978,709716796,11089324,18.6),(129418,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129418,36.68,0.46,216,59658,70,NULL,NULL,'2MASX J15222192+0031433',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000098,NULL,'16.0g',0.47,'E0',NULL,NULL,NULL,NULL,1,230.591417,0.52881,0.161,NULL,56430326422,881723850,13776935,16),(129419,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129419,38.23,0.33,443,59659,70,NULL,NULL,'2MASX J15222240+2327560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.593417,23.46544,0.197,NULL,59424387737,928506058,14507907,17.7),(129420,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129420,37.64,0.46,337,59660,70,NULL,NULL,'2MASX J15222296+2229410',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.62',0.18,NULL,NULL,NULL,NULL,NULL,1,230.595708333,22.49464,0.173,NULL,59421729745,928464527,14507258,18.62),(129421,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129421,37.88,0.46,377,59661,70,NULL,NULL,'SDSS J152223.10+115614.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.59625,11.93733,0.097,NULL,59342955839,927233684,14488026,17.9),(129422,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129422,36.23,0.46,176,59662,70,NULL,NULL,'2MASX J15222368+0817026',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000112,NULL,'16.8g',0.25,'S0','Group member',NULL,NULL,NULL,1,230.5987083,8.28422,0.069,NULL,59351064422,927360381,14490005,16.8),(129423,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129423,37.91,0.35,356,59663,60,NULL,'ABELL 2065, BCG','MCG +05-36-020',0.0722,'1980ApJ...241..486H',1980,1,0.4,NULL,'G',0.000167,NULL,'16.30',0.4,'S0?;BrClG','Group member',NULL,NULL,NULL,1,230.600083,27.71436,0.073,NULL,59907957637,936061838,14625966,16.3),(129424,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129424,37.49,0.09,315,59663,70,NULL,NULL,'MCG +05-36-020',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129425,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129425,34.22,0.8,69.9,59664,75,NULL,'MAT, I','ESO 328- G 046',NULL,'1997ApJS..109..333W',1997,1,2.1,'Confused HIPASS source','G',0.000017,NULL,'14.3b',1.3,'SB(rs)cd?',NULL,NULL,NULL,NULL,1,230.602,-38.19942,0.441,NULL,47194113609,737408025,11522000,14.3),(129426,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129426,34.05,0.2,64.6,59664,74.4,NULL,NULL,'ESO 328- G 046',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129427,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129427,34.08,0.43,65.5,59664,NULL,NULL,NULL,'ESO 328- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129428,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129428,34.15,0.32,67.6,59664,85,NULL,'I, raw','ESO 328- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129429,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129429,34.17,0.47,68.2,59664,NULL,NULL,'H','ESO 328- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129430,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129430,34.17,0.46,68.4,59664,NULL,NULL,'J','ESO 328- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129431,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129431,34.22,0.4,69.7,59664,NULL,NULL,'Malmquist cor.','ESO 328- G 046',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129432,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129432,34.22,0.45,69.8,59664,NULL,NULL,'K','ESO 328- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129433,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129433,34.22,0.32,69.8,59664,85,NULL,'I, inv','ESO 328- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129434,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129434,34.29,0.4,72.2,59664,NULL,NULL,'mean','ESO 328- G 046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129435,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129435,34.6,0.43,83.3,59664,75,NULL,'MAT, I, raw','ESO 328- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129436,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129436,34.85,0.43,93.1,59664,75,NULL,'MAT, I, cor','ESO 328- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129437,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129437,34.95,0.43,97.6,59664,75,NULL,'MAT, I, inv','ESO 328- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129438,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129438,36.28,0.61,180,59665,70,NULL,NULL,'2MASX J15222476-4349122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,230.60325,-43.82003,0.689,NULL,47071126007,735486343,11491974,15.5),(129439,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129439,37.64,0.15,337,59666,70,NULL,NULL,'SDSS J152224.82+484211.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.6034583,48.70328,0.029,NULL,59664613018,932259578,14566555,17.9),(129440,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129440,37.49,0.09,315,59667,70,NULL,NULL,'SDSS J152224.93+274355.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'16.2',0.13,NULL,'Group member',NULL,NULL,NULL,1,230.603875,27.73194,0.073,NULL,59907957527,936061836,14625966,16.2),(129441,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129441,37.92,0.46,384,59668,70,NULL,NULL,'2MASX J15222494+0234033',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.27,'AGN',NULL,NULL,NULL,NULL,1,230.604,2.56761,0.085,NULL,56433309864,881770466,13777663,17),(129442,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129442,38.45,0.46,489,59669,70,NULL,NULL,'2MASX J15222503+2623122',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.6045417,26.38681,0.105,NULL,59901591501,935962367,14624411,17.6),(129443,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129443,36.76,0.33,225,59670,70,NULL,NULL,'2MASX J15222564+0910276',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.606917,9.17439,0.061,NULL,59350524944,927351952,14489874,17.7),(129444,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129444,37.9,0.46,379,59671,70,NULL,NULL,'2MASX J15222614+0222013',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.609083,2.36711,0.093,NULL,56433098435,881767163,13777611,17.3),(129445,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129445,37.43,0.33,306,59672,70,NULL,NULL,'2MASX J15222643+2859521',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.97',0.22,'E',NULL,NULL,NULL,NULL,1,230.610333,28.99772,0.033,NULL,59905778913,936027795,14625434,17.97),(129446,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129446,37.49,0.09,315,59673,70,NULL,NULL,'2MASX J15222696+2751151',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,'Group member',NULL,NULL,NULL,1,230.612167,27.85436,0.069,NULL,59907912099,936061126,14625955,18),(129447,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129447,37.19,0.46,274,59674,70,NULL,NULL,'2MASX J15222739+3618042',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.614167,36.30117,0.037,NULL,60105699660,939151557,14674243,17.3),(129448,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129448,36.69,0.11,218,59675,70,NULL,NULL,'2MASX J15222752+0743096',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00011,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,230.614667,7.71942,0.065,NULL,56411614142,881431470,13772366,16.1),(129449,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129449,37.65,0.27,338,59676,70,NULL,NULL,'SDSS J152227.55+482329.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.614833,48.39161,0.025,NULL,59937012229,936515816,14633059,17.9),(129450,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129450,37.58,0.46,329,59677,70,NULL,NULL,'2MASX J15222805+0036553',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.61675,0.61528,0.185,NULL,56430360042,881724375,13776943,18),(129451,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129451,37.64,0.15,337,59678,70,NULL,NULL,'2MASX J15222823+4848063',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000182,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.6177917,48.80181,0.037,NULL,59664735214,932261487,14566585,16.6),(129452,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129452,37.49,0.09,315,59679,70,NULL,NULL,'MCG +05-36-021',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.00025,NULL,'15.28',0.1,'E1','Group member',NULL,NULL,NULL,1,230.6185417,27.68692,0.073,NULL,59907924635,936061322,14625958,15.28),(129453,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129453,36.47,0.1,197,59680,70,NULL,NULL,'2MASX J15222975+2031440',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.6240417,20.52892,0.185,NULL,59413897759,928342152,14505346,17.8),(129454,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129454,37.49,0.09,315,59681,70,NULL,NULL,'2MASX J15222998+2745181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,'Group member',NULL,NULL,NULL,1,230.625,27.75511,0.069,NULL,59907960263,936061879,14625966,17.3),(129455,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129455,37.24,0.46,281,59682,70,NULL,NULL,'2MASX J15222997+4833023',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.625125,48.55053,0.029,NULL,59664573250,932258957,14566546,17.4),(129456,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129456,36.16,0.09,171,59683,70,NULL,NULL,'2MASX J15223022+0840396',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00005,NULL,'16.6g',0.29,'E','Group member',NULL,NULL,NULL,1,230.62575,8.67761,0.073,NULL,59351443104,927366298,14490098,16.6),(129457,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129457,37.34,0.33,294,59684,70,NULL,NULL,'2MASX J15223031+3703152',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.626166667,37.05406,0.029,NULL,60112475024,939257422,14675897,17.2),(129458,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129458,34.91,0.49,95.8,59685,75,NULL,'IR','UGC 09828',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000007,NULL,'15.67',0.15,'Sc','Isolated galaxy',NULL,NULL,NULL,1,230.629,19.26136,0.177,NULL,59442714525,928792414,14512381,15.67),(129459,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129459,35.11,NULL,105,59685,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129460,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129460,35.12,NULL,106,59685,NULL,NULL,'Dipole + Quadrupole','UGC 09828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129461,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129461,35.13,NULL,106,59685,NULL,NULL,'Dipole','UGC 09828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129462,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129462,35.17,NULL,108,59685,NULL,NULL,NULL,'UGC 09828',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129463,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129463,35.51,0.5,126,59685,NULL,NULL,'Malmquist cor.','UGC 09828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129464,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129464,35.53,0.2,128,59685,74.4,NULL,NULL,'UGC 09828',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129465,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,NULL,129465,35.53,0.49,128,59685,NULL,NULL,NULL,'UGC 09828',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129466,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129466,35.76,0.46,142,59686,70,NULL,NULL,'2MASX J15223174+3853432',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000152,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,230.63225,38.89528,0.041,NULL,60111715327,939245551,14675711,16.1),(129467,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129467,36.16,0.09,171,59687,70,NULL,NULL,'2MASX J15223177+0846426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.632333333,8.77864,0.065,NULL,59351435051,927366172,14490096,16.6),(129468,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129468,37.49,0.09,315,59688,70,NULL,NULL,'2MASX J15223194+2743091',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.78',0.14,NULL,NULL,NULL,NULL,NULL,1,230.633166667,27.71928,0.073,NULL,59907960363,936061880,14625966,18.78),(129469,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129469,38.15,0.33,426,59689,70,NULL,NULL,'2MASX J15223212+0050484',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.63375,0.84686,0.165,NULL,56431077470,881735585,13777118,17.6),(129470,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129470,37.97,0.33,392,59690,70,NULL,NULL,'SDSS J152232.10+054833.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.63375,5.80931,0.049,NULL,56429408384,881709506,13776711,18.5),(129471,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129471,37.7,0.33,347,59691,70,NULL,NULL,'SDSS J152233.70+292759.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.18,'AGN',NULL,NULL,NULL,NULL,1,230.640458333,29.46658,0.021,NULL,59905840179,936028752,14625449,17.9),(129472,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129472,37.49,0.09,315,59692,70,NULL,NULL,'2MASX J15223389+2738441',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,'Group member',NULL,NULL,NULL,1,230.641083,27.64561,0.073,NULL,59907925349,936061333,14625958,17.4),(129473,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129473,36.68,0.46,216,59693,70,NULL,NULL,'2MASX J15223405+4602508',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.6419583,46.0475,0.041,NULL,59966429563,936975461,14640241,16.4),(129474,'FP','2016-12-15 15:15:34','2016-12-16 11:20:47','1',NULL,'R',129474,38.07,0.46,412,59694,70,NULL,NULL,'SDSS J152234.17+443711.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,230.642375,44.61986,0.029,NULL,59969251460,937019554,14640930,18.7),(129475,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129475,36.69,0.11,218,59695,70,NULL,NULL,'2MASX J15223511+0743404',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000073,NULL,'16.70',NULL,NULL,NULL,NULL,NULL,NULL,1,230.646375,7.72775,0.065,NULL,56411614251,881431472,13772366,16.7),(129476,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129476,38.16,0.46,429,59696,70,NULL,NULL,'2MASX J15223549+2959245',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.6477917,29.99022,0.025,NULL,59906595863,936040560,14625633,16.9),(129477,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129477,36.16,0.09,171,59697,70,NULL,NULL,'2MASX J15223661+0834474',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00005,NULL,'16.3g',0.3,'S0','Group member',NULL,NULL,NULL,1,230.652416667,8.57989,0.073,NULL,59351355175,927364924,14490076,16.3),(129478,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129478,37.49,0.09,315,59698,70,NULL,NULL,'2MASX J15223691+2748081',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,'Group member',NULL,NULL,NULL,1,230.6537083,27.80219,0.069,NULL,59907958939,936061858,14625966,16.7),(129479,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129479,36.16,0.09,171,59699,70,NULL,NULL,'2MASX J15223709+0828194',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000043,NULL,'16.0',0.4,'S0','Group member',NULL,NULL,NULL,1,230.654667,8.47222,0.081,NULL,59351341014,927364703,14490073,16),(129480,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129480,37.26,0.33,284,59700,70,NULL,NULL,'2MASX J15223726+2958185',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.655125,29.97181,0.025,NULL,59906595533,936040555,14625633,16.9),(129481,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129481,37.67,0.33,341,59701,70,NULL,NULL,'2MASX J15223744+2311272',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.6562083,23.19103,0.189,NULL,59420996115,928453064,14507079,17.6),(129482,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129482,37.82,0.19,367,59702,70,NULL,NULL,'2MASX J15223828+2837111',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.57',0.17,NULL,NULL,NULL,NULL,NULL,1,230.659708333,28.61969,0.041,NULL,59907679159,936057486,14625898,18.57),(129483,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129483,38.32,0.46,462,59703,70,NULL,NULL,'2MASX J15223870+1644415',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.6612917,16.745,0.089,NULL,59565711522,930714242,14542410,17.2),(129484,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129484,37.49,0.09,315,59704,70,NULL,NULL,'2MASX J15223893+2738061',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,'Group member',NULL,NULL,NULL,1,230.6622917,27.63511,0.073,NULL,59907929628,936061400,14625959,17.4),(129485,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129485,36.16,0.09,171,59705,70,NULL,NULL,'2MASX J15223924+0832264',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000053,NULL,'17.0g',0.19,'S0','Group member',NULL,NULL,NULL,1,230.663417,8.54075,0.073,NULL,59351353305,927364895,14490076,17),(129486,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129486,37.49,0.09,315,59706,70,NULL,NULL,'2MASX J15223931+2739131',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,'Group member',NULL,NULL,NULL,1,230.66375,27.65369,0.073,NULL,59907926536,936061352,14625958,18.1),(129487,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129487,36.22,0.46,175,59707,70,NULL,NULL,'SDSS J152239.47+094242.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.6644583,9.71192,0.069,NULL,59355604670,927431322,14491114,17.1),(129488,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129488,38.53,0.46,507,59708,70,NULL,NULL,'2MASX J15223946+3240005',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.6644583,32.66678,0.033,NULL,59882108555,935657946,14619655,17.6),(129489,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:48','1','SN 2010dw',NULL,129489,36.01,0.2,154,59709,73.8,NULL,'SALT 2 (SNANA)','2MASX J15224062-0555214',0.0389,'2014ApJ...795...44R',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,230.66925,-5.92281,0.289,NULL,45428035897,709813060,11090829,16.8),(129490,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129490,38.15,0.33,426,59710,70,NULL,NULL,'2MASX J15224099+0054134',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000122,NULL,'16.8g',0.3,'AGN',NULL,NULL,NULL,NULL,1,230.670625,0.90356,0.165,NULL,56431082903,881735670,13777119,16.8),(129491,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129491,37.7,0.33,347,59711,70,NULL,NULL,'SDSS J152241.74+292935.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.6739583,29.49325,0.021,NULL,59905840810,936028762,14625449,18.2),(129492,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129492,36.05,0.34,162,59712,NULL,NULL,'Malmquist cor.','2MASX J15224215+0822074',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000027,NULL,'17.3g',0.15,'Sb:',NULL,NULL,NULL,NULL,1,230.6754583,8.36886,0.081,NULL,59351068117,927360439,14490006,17.3),(129493,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129493,36.04,0.34,162,59712,NULL,NULL,NULL,'2MASX J15224215+0822074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129494,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129494,36.08,0.2,164,59712,74.4,NULL,NULL,'2MASX J15224215+0822074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129495,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129495,37.37,0.46,298,59713,70,NULL,NULL,'2MASX J15224239+5609434',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.6769583,56.16208,0.021,NULL,57593402635,899896916,14060889,17.1),(129496,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129496,37.91,0.35,356,59714,60,NULL,NULL,'ABELL 2065',0.0722,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,230.6775417,27.72264,0.073,NULL,59907958732,936061855,14625966,NULL),(129497,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129497,37.26,0.33,284,59715,70,NULL,NULL,'2MASX J15224272+2956305',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.678083,29.94189,0.025,NULL,59906594912,936040545,14625633,17),(129498,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129498,37.95,0.46,389,59716,70,NULL,NULL,'2MASX J15224287+0702484',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.6787083,7.04678,0.053,NULL,56412673351,881448021,13772625,17.5),(129499,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129499,36.74,0.46,223,59717,70,NULL,NULL,'2MASX J15224310+3101405',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.6795417,31.02792,0.025,NULL,59903833863,935997404,14624959,17.3),(129500,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129500,38.27,0.33,452,59718,70,NULL,NULL,'2MASX J15224334+3147205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.680667,31.78914,0.033,NULL,59911505982,936117280,14626832,17.9),(129501,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129501,37.82,0.46,367,59719,70,NULL,NULL,'2MASX J15224371+4213366',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.682125,42.22681,0.053,NULL,59978113257,937158019,14643094,18.2),(129502,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129502,37.49,0.09,315,59720,70,NULL,NULL,'SDSS J152244.01+274000.5',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.683416667,27.66683,0.073,NULL,59907928472,936061382,14625959,16.9),(129503,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129503,38.51,0.46,504,59721,70,NULL,NULL,'SDSS J152244.07+401225.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.6837083,40.20722,0.025,NULL,59975402402,937115662,14642432,18.7),(129504,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129504,36.16,0.09,171,59722,70,NULL,NULL,'2MASX J15224423+0830134',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00009,NULL,'17.2g',0.2,NULL,'Group member',NULL,NULL,NULL,1,230.684291667,8.50372,0.073,NULL,59351357631,927364962,14490077,17.2),(129505,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129505,38.14,0.46,424,59723,70,NULL,NULL,'2MASX J15224544+0516044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.6892917,5.268,0.065,NULL,56430093345,881720208,13776878,17.5),(129506,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129506,38.4,0.46,479,59724,70,NULL,NULL,'2MASX J15224563+1942203',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,230.6900417,19.70567,0.177,NULL,59442409559,928787649,14512307,17.4),(129507,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129507,37.32,0.33,290,59725,70,NULL,NULL,'2MASX J15224626+3436406',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.692667,34.61142,0.037,NULL,60108240005,939191250,14674863,17.5),(129508,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129508,37.31,0.46,289,59726,70,NULL,NULL,'2MASX J15224631+0151584',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.61',0.34,NULL,NULL,NULL,NULL,NULL,1,230.693041667,1.86633,0.097,NULL,56433798253,881778097,13777782,16.61),(129509,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129509,38,0.46,399,59727,70,NULL,NULL,'2MASX J15224669+2915250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.39',0.16,NULL,NULL,NULL,NULL,NULL,1,230.694458333,29.25694,0.029,NULL,59905884022,936029437,14625459,17.39),(129510,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129510,38.14,0.46,425,59728,70,NULL,NULL,'2MASX J15224703+3203185',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.696083333,32.05508,0.033,NULL,59911546963,936117921,14626842,17.6),(129511,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129511,37.36,0.27,297,59729,70,NULL,NULL,'2MASX J15224705+4800343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.69625,48.00964,0.029,NULL,59936732485,936511445,14632991,16.5),(129512,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129512,37.89,0.46,378,59730,70,NULL,NULL,'2MASX J15224913+0544544',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.704625,5.74833,0.049,NULL,56429421005,881709703,13776714,16.9),(129513,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129513,38.27,0.33,452,59731,70,NULL,NULL,'2MASX J15224948+3147577',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.706333333,31.79947,0.033,NULL,59911518088,936117470,14626835,17.4),(129514,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129514,37.2,0.27,275,59732,70,NULL,NULL,'2MASX J15224951+0726174',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.706375,7.43833,0.057,NULL,56412851669,881450807,13772668,17.3),(129515,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129515,37.36,0.27,297,59733,70,NULL,NULL,'2MASX J15225164+4801132',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.715,48.02036,0.029,NULL,59936735090,936511485,14632991,17.8),(129516,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129516,37.2,0.27,275,59734,70,NULL,NULL,'2MASX J15225254+0720064',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.7190417,7.33497,0.057,NULL,56412855387,881450865,13772669,17.1),(129517,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129517,36.16,0.09,171,59735,70,NULL,NULL,'CGCG 077-093',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000057,NULL,'15.7g',0.39,'S0','Group member',NULL,NULL,NULL,1,230.7199583,8.74494,0.065,NULL,59351322301,927364410,14490068,15.7),(129518,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129518,36.4,0.25,191,59735,74.4,NULL,NULL,'CGCG 077-093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129519,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129519,38.23,0.33,443,59736,70,NULL,NULL,'SDSS J152252.85+232400.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.7202083,23.40019,0.197,NULL,59420981679,928452838,14507075,18.5),(129520,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129520,37.25,0.46,282,59737,70,NULL,NULL,'2MASX J15225292+0138404',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.62',0.31,NULL,NULL,NULL,NULL,NULL,1,230.7204583,1.64461,0.101,NULL,56433818506,881778414,13777787,16.62),(129521,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129521,37.23,0.46,279,59738,70,NULL,NULL,'2MASX J15225327+4032592',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00016,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.721833,40.54983,0.013,NULL,59975454612,937116478,14642444,16.7),(129522,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129522,37.2,0.27,275,59739,70,NULL,NULL,'2MASX J15225341+0721074',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000143,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,230.722583333,7.35197,0.057,NULL,56412854838,881450856,13772669,15.7),(129523,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129523,38.5,0.46,500,59740,70,NULL,NULL,'2MASX J15225469+2627400',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.727917,26.46114,0.101,NULL,59901721616,935964400,14624443,17.5),(129524,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129524,35.79,0.25,144,59741,74.4,NULL,NULL,'2MASX J15225515+0824004',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000047,NULL,'16.4g',0.19,'S0','Group member',NULL,NULL,NULL,1,230.729917,8.40025,0.081,NULL,59351097391,927360896,14490014,16.4),(129525,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129525,35.74,0.33,140,59742,70,NULL,NULL,'CGCG 021-081',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'15.8g',0.42,'E','in a triple',NULL,NULL,NULL,1,230.732375,-1.35644,0.313,NULL,45420495666,709695244,11088988,15.8),(129526,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129526,35.89,0.51,150,59742,70,NULL,NULL,'CGCG 021-081',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129527,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129527,34.53,0.69,80.6,59743,NULL,NULL,NULL,'CGCG 077-095',NULL,'2009ApJS..182..474S',2009,1,0.2,NULL,'G',0.000033,NULL,'15.6',0.2,'Sb','Group member',NULL,NULL,NULL,1,230.732625,8.52128,0.073,NULL,59351367137,927365111,14490079,15.6),(129528,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129528,34.71,0.64,87.3,59743,NULL,NULL,'Malmquist cor.','CGCG 077-095',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129529,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129529,36.76,0.33,225,59744,70,NULL,NULL,'SDSS J152255.92+091157.1',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.733,9.19919,0.069,NULL,59354833145,927419267,14490926,17.1),(129530,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129530,36.02,0.25,160,59745,74.4,NULL,NULL,'2MASX J15225650+0839004',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000057,NULL,'16.0g',0.21,'S0','Group member',NULL,NULL,NULL,1,230.735333333,8.65025,0.073,NULL,59351331144,927364549,14490071,16),(129531,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129531,36.16,0.09,171,59745,70,NULL,NULL,'2MASX J15225650+0839004',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129532,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129532,36.57,0.54,206,59746,70,NULL,NULL,'2MASX J15225701-1639494',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,230.737667,-16.66372,0.477,NULL,46667641306,729181895,11393467,15.5),(129533,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129533,37.32,0.33,290,59747,70,NULL,NULL,'2MASX J15225711+3442247',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.7377917,34.70697,0.033,NULL,60108230365,939191099,14674860,16.9),(129534,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129534,35.74,0.33,140,59748,70,NULL,NULL,'CGCG 021-083',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00017,NULL,'15.8g',0.49,'E','in a triple',NULL,NULL,NULL,1,230.7385,-1.38111,0.313,NULL,45420498485,709695288,11088988,15.8),(129535,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129535,35.27,0.5,113,59749,NULL,NULL,NULL,'CGCG 049-153',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000037,NULL,'15.5',0.4,'SD/I','Group member',NULL,NULL,NULL,1,230.740417,8.04028,0.069,NULL,56411702105,881432845,13772388,15.5),(129536,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129536,35.31,0.2,115,59749,74.4,NULL,NULL,'CGCG 049-153',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129537,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129537,35.67,0.42,136,59749,NULL,NULL,'Malmquist cor.','CGCG 049-153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129538,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129538,38.33,0.46,463,59750,70,NULL,NULL,'SDSS J152300.60+444313.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000183,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.7525417,44.72033,0.029,NULL,59969966176,937030721,14641105,18.4),(129539,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129539,37.65,0.27,338,59751,70,NULL,NULL,'SDSS J152300.72+482745.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.7530417,48.46261,0.025,NULL,59664580434,932259069,14566547,17.8),(129540,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129540,32.5,0.2,31.6,59752,74.4,NULL,NULL,'UGC 09830',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000018,NULL,'15.39',0.22,'Sc',NULL,NULL,NULL,NULL,1,230.75375,4.52944,0.069,NULL,56427300546,881676571,13776196,15.39),(129541,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129541,32.8,NULL,36.3,59752,NULL,NULL,'Dipole','UGC 09830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129542,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129542,32.81,NULL,36.4,59752,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129543,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129543,32.81,NULL,36.5,59752,NULL,NULL,'Dipole + Quadrupole','UGC 09830',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129544,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129544,32.81,0.56,36.5,59752,NULL,NULL,'Malmquist cor.','UGC 09830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129545,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129545,32.81,NULL,36.5,59752,72,NULL,NULL,'UGC 09830',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129546,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129546,32.83,0.55,36.7,59752,NULL,NULL,NULL,'UGC 09830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129547,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129547,32.97,NULL,39.3,59752,NULL,NULL,NULL,'UGC 09830',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129548,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129548,37.2,0.46,275,59753,70,NULL,NULL,'2MASX J15230109+0851004',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.1g',0.22,'S0','Group member',NULL,NULL,NULL,1,230.7545,8.85022,0.065,NULL,59350535730,927352120,14489876,17.1),(129549,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129549,35.3,0.4,115,59754,NULL,NULL,'mean','UGC 09829',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000003,NULL,'14.51',0.9,'Sb pec','in a triple',NULL,NULL,NULL,1,230.756625,-1.34719,0.313,NULL,45420497388,709695271,11088988,14.51),(129550,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129550,35.33,0.47,116,59754,NULL,NULL,'H','UGC 09829',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129551,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129551,36.4,0.35,184,59755,60,NULL,NULL,'ABELL 2063',0.0337,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.00026,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,230.75775,8.63942,0.073,NULL,59351329310,927364520,14490070,NULL),(129552,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129552,36.01,0.08,159,59755,70,NULL,NULL,'ABELL 2063',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129553,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129553,37.41,0.16,304,59756,70,NULL,NULL,'SDSS J152301.90+064723.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.7579583,6.78989,0.053,NULL,56413050170,881453908,13772717,18),(129554,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129554,37.53,0.15,320,59757,70,NULL,NULL,'2MASX J15230197+3049237',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.75825,30.82317,0.017,NULL,59903609414,935993897,14624904,17.8),(129555,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129555,37.37,0.33,297,59758,70,NULL,NULL,'2MASX J15230232+1133410',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.759583,11.56133,0.097,NULL,59342905124,927232892,14488013,17.6),(129556,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129556,38.28,0.33,452,59759,70,NULL,NULL,'2MASX J15230329+2821580',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.91',0.15,NULL,NULL,NULL,NULL,NULL,1,230.763583,28.36617,0.049,NULL,59908064252,936063503,14625992,18.91),(129557,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129557,37.37,0.33,297,59760,70,NULL,NULL,'2MASX J15230328+1133060',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,230.763625,11.55181,0.097,NULL,59342902019,927232844,14488013,16.4),(129558,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129558,36.16,0.09,171,59761,70,NULL,NULL,'SDSS J152304.56+083644.1',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000153,NULL,'15.8g',0.46,'S0','Group member',NULL,NULL,NULL,1,230.769041667,8.61225,0.073,NULL,59351329185,927364518,14490070,15.8),(129559,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129559,37.53,0.15,320,59762,70,NULL,NULL,'2MASX J15230453+3052277',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.769041667,30.87447,0.025,NULL,59903616172,935994002,14624906,17.9),(129560,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129560,37.33,0.27,292,59763,70,NULL,NULL,'2MASX J15230462+0211469',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.769417,2.19625,0.093,NULL,56432600138,881759377,13777490,17),(129561,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129561,38.01,0.46,400,59764,70,NULL,NULL,'SDSS J152304.98+052734.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.77075,5.45947,0.073,NULL,56429574626,881712103,13776751,18.5),(129562,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129562,37.97,0.33,392,59765,70,NULL,NULL,'2MASX J15230505+0558029',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.7712083,5.96747,0.069,NULL,56429391705,881709245,13776706,17.3),(129563,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129563,36.4,0.35,184,59766,60,NULL,'ABELL 2063, BCG','CGCG 077-097',0.0337,'1980ApJ...241..486H',1980,1,0.9,NULL,'G',0.00007,NULL,'13.61',0.9,'cD;S','Group member',NULL,NULL,NULL,1,230.772083,8.60922,0.073,NULL,59351329195,927364518,14490070,13.61),(129564,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129564,35.38,0.23,119,59766,74.4,NULL,NULL,'CGCG 077-097',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129565,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129565,35.68,0.16,137,59766,70,NULL,NULL,'CGCG 077-097',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129566,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129566,36.16,0.09,171,59766,70,NULL,NULL,'CGCG 077-097',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129567,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129567,35.59,0.45,131,59766,NULL,NULL,'K','CGCG 077-097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129568,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129568,35.85,0.4,148,59766,NULL,NULL,'mean','CGCG 077-097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129569,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129569,36.01,0.08,159,59766,70,NULL,'ABELL 2063, BGC','CGCG 077-097',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129570,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129570,37.45,0.46,308,59767,70,NULL,NULL,'2MASX J15230581+0225009',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.7742917,2.41694,0.097,NULL,56433055319,881766489,13777601,18.2),(129571,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129571,38.8,0.46,575,59768,70,NULL,NULL,'SDSS J152306.09+041321.8',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000112,NULL,'17.6g',0.22,'AGN',NULL,NULL,NULL,NULL,1,230.775375,4.22275,0.069,NULL,56427498857,881679669,13776244,17.6),(129572,'SNIa','2016-12-15 15:15:34','2016-12-16 11:20:48','1','SN 2001cw',NULL,129572,43.56,0.97,2640,59769,74.2,NULL,'SALT 2','SCP J152306.31+293931.9',0.953,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,230.776291667,29.65886,0.025,NULL,59905993088,936031142,14625486,NULL),(129573,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129573,36.69,0.46,218,59770,70,NULL,NULL,'2MASX J15230669+3740108',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,230.777875,37.66975,0.033,NULL,60112599267,939259363,14675927,16.4),(129574,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129574,37.82,0.19,367,59771,70,NULL,NULL,'SDSS J152306.79+283532.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.778333,28.59242,0.041,NULL,59907683113,936057548,14625899,18.2),(129575,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129575,36,0.25,158,59772,74.4,NULL,NULL,'2MASX J15230698+0840350',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000063,NULL,'16.2g',0.26,'S0','Group member',NULL,NULL,NULL,1,230.7790417,8.67647,0.065,NULL,59351331971,927364562,14490071,16.2),(129576,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129576,36.16,0.09,171,59772,70,NULL,NULL,'2MASX J15230698+0840350',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129577,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129577,36.47,0.1,197,59773,70,NULL,NULL,'SDSS J152307.27+203035.9',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.0g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.780333,20.50997,0.185,NULL,59413896924,928342139,14505345,17),(129578,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129578,35.68,0.16,137,59774,70,NULL,NULL,'CGCG 077-100',NULL,'2001MNRAS.321..277C',2001,1,0.5,NULL,'G',0.00006,NULL,'14.48',0.15,'Sb','Group member',NULL,NULL,NULL,1,230.780875,8.52839,0.073,NULL,59351361679,927365026,14490078,14.48),(129579,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129579,35.86,0.23,149,59774,74.4,NULL,NULL,'CGCG 077-100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129580,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129580,37.53,0.15,320,59775,70,NULL,NULL,'2MASX J15230748+3051417',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,230.781125,30.86169,0.017,NULL,59903616907,935994014,14624906,16.9),(129581,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129581,37.04,0.46,255,59776,70,NULL,NULL,'2MASX J15230778+1115090',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.2,'AGN',NULL,NULL,NULL,NULL,1,230.7825,11.25258,0.089,NULL,59342437842,927225591,14487899,16.8),(129582,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129582,38.3,0.35,426,59777,60,NULL,NULL,'ABELL 2067',0.0726,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000247,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,230.782917,30.845,0.017,NULL,59903620990,935994077,14624907,NULL),(129583,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129583,38.3,0.35,426,59778,60,NULL,'ABELL 2067, BCG','2MASX J15230842+3052387',0.0726,'1980ApJ...241..486H',1980,1,0.59,NULL,'G',0.000107,NULL,'16.0g',0.44,'cD;BrClG',NULL,NULL,NULL,NULL,1,230.785,30.8775,0.025,NULL,59903617009,935994015,14624906,16),(129584,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129584,37.53,0.15,320,59779,70,NULL,NULL,'SDSS J152308.68+305158.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00017,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.7862083,30.86619,0.017,NULL,59903616953,935994014,14624906,18.7),(129585,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129585,37.49,0.09,315,59780,70,NULL,NULL,'2MASX J15230962+2723270',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.60',0.18,NULL,NULL,NULL,NULL,NULL,1,230.790041667,27.39075,0.097,NULL,59907816175,936059627,14625931,18.6),(129586,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129586,36.47,0.1,197,59781,70,NULL,NULL,'2MASX J15230968+2114395',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.21',0.18,NULL,NULL,NULL,NULL,NULL,1,230.7905,21.24422,0.157,NULL,59414386895,928349795,14505465,17.21),(129587,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129587,35.32,0.23,116,59782,74.4,NULL,NULL,'CGCG 077-099',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.00005,NULL,'15.8g',0.4,'S0','Group member',NULL,NULL,NULL,1,230.79325,8.50533,0.073,NULL,59351356416,927364944,14490077,15.8),(129588,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129588,35.68,0.16,137,59782,70,NULL,NULL,'CGCG 077-099',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129589,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129589,36.16,0.09,171,59782,70,NULL,NULL,'CGCG 077-099',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129590,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129590,35.55,0.23,129,59783,74.4,NULL,NULL,'ARK 475',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000053,NULL,'14.48',0.2,'S0','Group member',NULL,NULL,NULL,1,230.795291667,8.63433,0.073,NULL,59351330815,927364543,14490070,14.48),(129591,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129591,35.68,0.16,137,59783,70,NULL,NULL,'ARK 475',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129592,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129592,36.16,0.09,171,59783,70,NULL,NULL,'ARK 475',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129593,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129593,37.53,0.15,320,59784,70,NULL,NULL,'2MASX J15231261+3055157',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,230.8027083,30.92117,0.025,NULL,59903615444,935993991,14624906,16.8),(129594,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129594,37.42,0.46,305,59785,70,NULL,NULL,'2MASX J15231331+2601292',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.805583,26.02492,0.109,NULL,59901841188,935966268,14624472,17),(129595,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129595,38.38,0.27,475,59786,70,NULL,NULL,'SDSS J152313.74+221354.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.8072917,22.23169,0.161,NULL,59421578302,928462160,14507221,18.6),(129596,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129596,38.28,0.33,452,59787,70,NULL,NULL,'SDSS J152313.93+282723.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.8080417,28.45647,0.049,NULL,59908178447,936065288,14626020,18.5),(129597,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129597,35.68,0.16,137,59788,70,NULL,NULL,'ARK 476',NULL,'2001MNRAS.321..277C',2001,1,0.55,NULL,'G',0.000053,NULL,'15.5g',0.5,'E','Group member',NULL,NULL,NULL,1,230.808333,8.64544,0.073,NULL,59351330408,927364537,14490070,15.5),(129598,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129598,35.8,0.23,145,59788,74.4,NULL,NULL,'ARK 476',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129599,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129599,36.16,0.09,171,59788,70,NULL,NULL,'ARK 476',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129600,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129600,37.74,0.46,353,59789,70,NULL,NULL,'2MASX J15231469+5302557',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.811125,53.04878,0.029,NULL,59673926984,932405109,14568829,17.9),(129601,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129601,36.16,0.09,171,59790,70,NULL,NULL,'SDSS J152314.84+084944.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.811875,8.829,0.065,NULL,59350650028,927353906,14489904,17.3),(129602,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129602,35.68,0.16,137,59791,70,NULL,NULL,'CGCG 077-103',NULL,'2001MNRAS.321..277C',2001,1,0.65,NULL,'G',0.000057,NULL,'15.3g',0.45,'S0','Group member',NULL,NULL,NULL,1,230.812625,8.57378,0.073,NULL,59351362895,927365045,14490078,15.3),(129603,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129603,35.7,0.23,138,59791,74.4,NULL,NULL,'CGCG 077-103',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129604,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129604,36.16,0.09,171,59791,70,NULL,NULL,'CGCG 077-103',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129605,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129605,36.81,0.25,230,59792,74.4,NULL,NULL,'2MASX J15231528+0839470',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000077,NULL,'16.4g',0.33,'E','Group member',NULL,NULL,NULL,1,230.813583,8.66317,0.065,NULL,59351328368,927364505,14490070,16.4),(129606,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129606,36.47,0.1,197,59793,70,NULL,NULL,'SDSS J152315.54+202629.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.81475,20.44153,0.185,NULL,59444045808,928813215,14512706,17.7),(129607,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129607,36.16,0.09,171,59794,70,NULL,NULL,'CGCG 077-106',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00006,NULL,'15.7',0.4,'S0','Group member',NULL,NULL,NULL,1,230.8165,8.74844,0.065,NULL,59350617122,927353392,14489896,15.7),(129608,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129608,36.45,0.25,195,59794,74.4,NULL,NULL,'CGCG 077-106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129609,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129609,37.81,0.46,365,59795,70,NULL,NULL,'2MASX J15231631+0033179',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000084,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.818083,0.55492,0.145,NULL,56430419640,881725306,13776957,17.1),(129610,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129610,36.66,0.7,215,59796,70,NULL,NULL,'2MASX J15231656-0933165',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,230.819125,-9.55458,0.445,NULL,46487766687,726371354,11349552,15.6),(129611,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129611,37.65,0.27,339,59797,70,NULL,NULL,'CGCG 165-046',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000147,NULL,'15.7',0.3,'BrClG',NULL,NULL,NULL,NULL,1,230.821625,32.07389,0.033,NULL,59911525914,936117592,14626837,15.7),(129612,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129612,37.65,0.27,339,59798,70,NULL,NULL,'2MASX J15231736+3203367',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.822417,32.06008,0.033,NULL,59911555482,936118054,14626844,17.3),(129613,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129613,32.44,0.2,30.8,59799,74.4,NULL,NULL,'ESO 514- G 013',NULL,'2013AJ....146...86T',2013,1,1.7,'Confused HIPASS source','G',0.000032,NULL,'15.89',1.2,'S...',NULL,NULL,NULL,NULL,1,230.827041667,-25.72061,0.597,NULL,47137682133,736526283,11508223,15.89),(129614,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129614,36.69,0.11,218,59800,70,NULL,NULL,'2MASX J15231981+0742320',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00006,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.832416667,7.70883,0.069,NULL,56411786824,881434169,13772408,16.6),(129615,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129615,31.38,0.43,18.9,59801,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-39-005',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00002,NULL,'13.49',0.9,'SB(r)ab pec:   HII',NULL,NULL,NULL,NULL,1,230.833875,-4.15161,0.345,NULL,45428984264,709827879,11091060,13.49),(129616,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129616,31.59,0.43,20.8,59801,75,NULL,'3.6 micron, color corrected','MCG -01-39-005',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129617,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129617,31.86,0.2,23.6,59801,74.4,NULL,NULL,'MCG -01-39-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129618,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129618,32.27,0.47,28.5,59801,NULL,NULL,'H','MCG -01-39-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129619,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129619,32.29,0.57,28.7,59801,NULL,NULL,NULL,'MCG -01-39-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129620,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129620,32.33,0.46,29.2,59801,NULL,NULL,'J','MCG -01-39-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129621,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129621,32.34,NULL,29.4,59801,72,NULL,NULL,'MCG -01-39-005',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129622,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129622,32.35,0.56,29.5,59801,NULL,NULL,'Malmquist cor.','MCG -01-39-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129623,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129623,32.36,0.45,29.7,59801,NULL,NULL,'K','MCG -01-39-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129624,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129624,32.43,0.4,30.6,59801,NULL,NULL,'mean','MCG -01-39-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129625,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129625,36.16,0.09,171,59802,70,NULL,NULL,'CGCG 077-107',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000083,NULL,'15.5g',0.39,'S0/a','Group member',NULL,NULL,NULL,1,230.833833,8.61803,0.073,NULL,59351327684,927364495,14490070,15.5),(129626,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129626,35.21,0.25,110,59803,74.4,NULL,NULL,'2MASX J15232040+0824150',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00004,NULL,'16.2g',0.18,'S0','Group member',NULL,NULL,NULL,1,230.8349583,8.40436,0.073,NULL,59351046268,927360097,14490001,16.2),(129627,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129627,37.49,0.09,315,59804,70,NULL,NULL,'2MASX J15232040+2732233',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,'Group member',NULL,NULL,NULL,1,230.835125,27.53983,0.097,NULL,59907997523,936062461,14625975,17.3),(129628,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129628,38.25,0.46,447,59805,70,NULL,NULL,'SDSS J152320.66-003542.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.836083,-0.59517,0.181,NULL,45420319493,709692492,11088945,18.3),(129629,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129629,38.38,0.27,475,59806,70,NULL,NULL,'2MASX J15232082+2220365',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000133,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.8367917,22.34344,0.161,NULL,59421697852,928464028,14507250,18.2),(129630,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129630,35.82,0.25,146,59807,74.4,NULL,NULL,'2MASX J15232088+0823390',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000047,NULL,'16.83',0.2,'SB0','Group member',NULL,NULL,NULL,1,230.8370417,8.39422,0.081,NULL,59351046305,927360098,14490001,16.83),(129631,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129631,37.01,0.46,252,59808,70,NULL,NULL,'2MASX J15232193+4430187',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000199,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,230.841417,44.50519,0.033,NULL,59969294115,937020220,14640940,15.9),(129632,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129632,38.38,0.27,475,59809,70,NULL,NULL,'SDSS J152322.13+222312.7',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.8422083,22.38689,0.173,NULL,59421700573,928464071,14507251,18),(129633,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129633,37.41,0.16,304,59810,70,NULL,NULL,'2MASX J15232312+0652280',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.846417,6.87444,0.061,NULL,56413034919,881453670,13772713,16.6),(129634,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129634,37.65,0.27,339,59811,70,NULL,NULL,'SDSS J152325.19+320517.1',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.855,32.08811,0.033,NULL,59911528261,936117629,14626837,17.6),(129635,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129635,37.53,0.15,320,59812,70,NULL,NULL,'2MASX J15232678+3103582',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000067,NULL,'15.9g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,230.861625,31.06628,0.025,NULL,59903812985,935997077,14624954,15.9),(129636,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129636,37.82,0.19,367,59813,70,NULL,NULL,'4C +28.39',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',NULL,NULL,'15.4',0.47,NULL,NULL,NULL,'radio jet',NULL,1,230.86225,28.62544,0.041,NULL,59907677751,936057464,14625897,15.4),(129637,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129637,34.97,0.5,98.6,59814,70,NULL,NULL,'CGCG 021-088',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000086,NULL,'15.2g',0.4,'S0',NULL,NULL,NULL,NULL,1,230.863583333,-1.16558,0.257,NULL,45420947259,709702300,11089098,15.2),(129638,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129638,37.97,0.33,393,59815,70,NULL,NULL,'2MASX J15232769+2843273',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.97',0.13,NULL,NULL,NULL,NULL,NULL,1,230.8652917,28.72422,0.037,NULL,59907691601,936057681,14625901,18.97),(129639,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129639,37.65,0.33,339,59816,70,NULL,NULL,'2MASX J15232778+2545523',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.865666667,25.76458,0.109,NULL,59902000145,935968752,14624511,17.9),(129640,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129640,36.47,0.46,196,59817,70,NULL,NULL,'2MASX J15232817+0444279',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,230.867333,4.741,0.077,NULL,56429159110,881705611,13776650,16.4),(129641,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129641,37.82,0.19,367,59818,70,NULL,NULL,'2MASX J15232830+2831083',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.867833333,28.519,0.049,NULL,59908187362,936065427,14626022,17.9),(129642,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129642,38.54,0.46,510,59819,70,NULL,NULL,'SDSS J152328.63+403136.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,230.869375,40.52672,0.013,NULL,59975430524,937116101,14642439,18.6),(129643,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129643,36.82,0.46,232,59820,70,NULL,NULL,'2MASXi J1523295+161916',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.872917,16.32131,0.085,NULL,59566350414,930724225,14542566,17.8),(129644,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129644,38.47,0.46,494,59821,70,NULL,NULL,'SDSS J152331.17+600701.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.879917,60.117,0.045,NULL,57772629397,902697334,14104645,18.7),(129645,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129645,38.59,0.46,523,59822,70,NULL,NULL,'2MASX J15233146+1910225',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,230.881125,19.17294,0.177,NULL,59442677239,928791831,14512372,17.6),(129646,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129646,37.77,0.46,358,59823,70,NULL,NULL,'2MASX J15233273+5130018',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.886291667,51.50042,0.037,NULL,59674834648,932419291,14569051,17.2),(129647,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129647,35.68,0.55,137,59824,70,NULL,NULL,'2MASX J15233396-0023456',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000075,NULL,'16.1g',0.27,'Sb',NULL,NULL,NULL,NULL,1,230.891583333,-0.39594,0.201,NULL,45420331185,709692674,11088948,16.1),(129648,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129648,37.49,0.09,315,59825,70,NULL,NULL,'2MASX J15233402+2745113',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000113,NULL,'17.86',0.4,NULL,'Group member',NULL,NULL,NULL,1,230.891833333,27.75303,0.081,NULL,59907940615,936061572,14625962,17.86),(129649,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129649,38,0.2,398,59826,74.4,NULL,NULL,'CGCG 165-047',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000203,NULL,'15.8g',0.31,'Sab',NULL,NULL,NULL,NULL,1,230.894583,31.6155,0.029,NULL,59911845557,936122586,14626915,15.8),(129650,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129650,35.48,0.25,125,59827,74.4,NULL,NULL,'CGCG 077-110',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000073,NULL,'14.6g',0.71,'E','Pair member (points to parent)',NULL,NULL,NULL,1,230.896875,9.34614,0.077,NULL,59354866101,927419782,14490934,14.6),(129651,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129651,35.59,0.46,132,59827,70,NULL,NULL,'CGCG 077-110',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129652,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129652,35.68,0.16,137,59827,70,NULL,NULL,'CGCG 077-110',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129653,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129653,36.96,0.46,246,59828,70,NULL,NULL,'2MASX J15233570+3512103',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.17',0.27,NULL,NULL,NULL,NULL,NULL,1,230.898625,35.20289,0.033,NULL,60108116883,939189326,14674833,17.17),(129654,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129654,37.04,0.46,256,59829,70,NULL,NULL,'2MASX J15233579+2815543',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.55',0.16,NULL,NULL,NULL,NULL,NULL,1,230.899125,28.265,0.057,NULL,59908250861,936066419,14626037,18.55),(129655,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129655,37.82,0.19,367,59830,70,NULL,NULL,'SDSS J152335.89+283949.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.899583,28.66372,0.049,NULL,59907690947,936057671,14625901,17.6),(129656,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129656,37.51,0.46,317,59831,70,NULL,NULL,'2MASX J15233596+3110213',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000067,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,230.899625,31.17253,0.025,NULL,59903805193,935996956,14624952,16.7),(129657,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129657,37.97,0.33,393,59832,70,NULL,NULL,'2MASX J15233613+2845183',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.900667,28.75517,0.037,NULL,59907649659,936057025,14625891,17.9),(129658,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129658,37.82,0.19,367,59833,70,NULL,NULL,'2MASX J15233673+2838353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.06',0.25,NULL,NULL,NULL,NULL,NULL,1,230.90325,28.64283,0.049,NULL,59907691355,936057677,14625901,17.06),(129659,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129659,36.16,0.09,171,59834,70,NULL,NULL,'CGCG 077-113',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000182,NULL,'15.7g',0.41,'SB0/a','Group member',NULL,NULL,NULL,1,230.9037917,8.98703,0.057,NULL,59350684035,927354438,14489913,15.7),(129660,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129660,36.31,0.46,182,59835,70,NULL,NULL,'2MASX J15233693+0008086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,230.903916667,0.13567,0.161,NULL,56396633639,881197400,13768709,17.2),(129661,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129661,36.19,0.33,173,59836,70,NULL,NULL,'2MASX J15233860+0604526',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,230.9109583,6.08133,0.057,NULL,56428339745,881692808,13776450,16.6),(129662,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129662,35.49,0.25,125,59837,74.4,NULL,NULL,'CGCG 077-112',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'14.27',0.8,'E/S0','Group member',NULL,NULL,NULL,1,230.913291667,8.75908,0.065,NULL,59350625436,927353522,14489898,14.27),(129663,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129663,35.68,0.16,137,59837,70,NULL,NULL,'CGCG 077-112',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129664,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129664,36.16,0.09,171,59837,70,NULL,NULL,'CGCG 077-112',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129665,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129665,36.47,0.1,197,59838,70,NULL,NULL,'2MASX J15233942+2058487',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.70',0.23,NULL,NULL,NULL,NULL,NULL,1,230.91425,20.98011,0.165,NULL,59414006209,928343847,14505372,16.7),(129666,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129666,37.33,0.46,292,59839,70,NULL,NULL,'2MASX J15234209+2118407',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,230.9252917,21.31133,0.145,NULL,59414266405,928347912,14505436,17.2),(129667,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129667,38.07,0.46,412,59840,70,NULL,NULL,'2MASX J15234272+2833372',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.927833,28.56028,0.049,NULL,59908190002,936065468,14626022,18.2),(129668,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129668,33.8,NULL,57.7,59841,NULL,NULL,'Dipole + Quadrupole','ESO 514- G 014',NULL,'2010Ap&SS.325..163P',2010,1,1.74,NULL,'G',NULL,NULL,'16.67',0.13,'Sc',NULL,NULL,NULL,NULL,1,230.929583,-25.465,0.577,NULL,47137527690,736523870,11508185,16.67),(129669,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129669,33.8,NULL,57.7,59841,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 514- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129670,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129670,33.81,NULL,57.8,59841,NULL,NULL,'Dipole','ESO 514- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129671,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129671,34.22,0.43,69.8,59841,75,NULL,'3.6 micron, color + selection bias corrected','ESO 514- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129672,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129672,34.32,0.43,73,59841,75,NULL,'3.6 micron, color corrected','ESO 514- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129673,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129673,34.36,0.2,74.5,59841,74.4,NULL,NULL,'ESO 514- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129674,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129674,34.64,0.41,84.8,59841,NULL,NULL,NULL,'ESO 514- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129675,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129675,34.67,0.4,85.9,59841,NULL,NULL,'Malmquist cor.','ESO 514- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129676,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129676,36.83,0.46,232,59842,70,NULL,NULL,'2MASX J15234372+0826144',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000133,NULL,'16.4g',0.24,'S0/S','Group member',NULL,NULL,NULL,1,230.93225,8.43725,0.073,NULL,59351306224,927364159,14490064,16.4),(129677,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129677,35.27,0.2,113,59843,74.4,NULL,NULL,'CGCG 077-116',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000011,NULL,'15.5g',0.45,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,230.93275,9.37703,0.077,NULL,59354898751,927420292,14490942,15.5),(129678,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129678,38.04,0.46,406,59844,70,NULL,NULL,'2MASX J15234590+2853542',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.40',0.17,'E',NULL,NULL,NULL,NULL,1,230.9414583,28.89836,0.033,NULL,59905750857,936027357,14625427,18.4),(129679,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129679,36.47,0.1,197,59845,70,NULL,NULL,'2MASX J15234609+2045048',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.11',0.17,NULL,NULL,NULL,NULL,NULL,1,230.942083,20.75131,0.173,NULL,59414122169,928345658,14505400,18.11),(129680,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129680,36.16,0.09,171,59846,70,NULL,NULL,'2MASX J15234655+0838534',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000043,NULL,'16.5g',0.35,'S0/S','Group member',NULL,NULL,NULL,1,230.943875,8.64811,0.065,NULL,59350637209,927353706,14489901,16.5),(129681,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129681,37.41,0.16,304,59847,70,NULL,NULL,'2MASX J15234668+0656074',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.944458333,6.93539,0.081,NULL,56413144818,881455387,13772740,17.7),(129682,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129682,36.19,0.33,173,59848,70,NULL,NULL,'CGCG 049-154',NULL,'2015arXiv151105856S',2015,1,2,NULL,'G',0.000127,NULL,'15.3',1.2,NULL,NULL,NULL,NULL,NULL,1,230.9452083,5.77519,0.065,NULL,56428575516,881696492,13776507,15.3),(129683,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129683,38.9,0.46,603,59849,70,NULL,NULL,'2MASX J15234696-0026067',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000085,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.9457917,-0.43531,0.201,NULL,45403440853,709428763,11084824,18),(129684,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129684,34.78,0.46,90.4,59850,70,NULL,NULL,'2MASX J15234709-0038227',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000059,NULL,'16.2g',0.35,'SF',NULL,NULL,NULL,NULL,1,230.9462917,-0.63972,0.181,NULL,45420313256,709692394,11088943,16.2),(129685,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129685,36.87,0.2,237,59851,74.4,NULL,NULL,'UGC 09832',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.35',0.6,'S?',NULL,NULL,NULL,NULL,1,230.947208333,13.87625,0.117,NULL,59562301626,930660962,14541577,15.35),(129686,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129686,36.69,0.46,218,59852,70,NULL,NULL,'2MASX J15234741+1712167',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.38',0.34,NULL,NULL,NULL,NULL,NULL,1,230.9475,17.20464,0.109,NULL,59437016441,928703381,14510990,17.38),(129687,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129687,37.53,0.15,320,59853,70,NULL,NULL,'2MASX J15234742+3111432',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00011,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,230.9475,31.19528,0.025,NULL,59903803869,935996935,14624952,16.7),(129688,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129688,36.16,0.09,171,59854,70,NULL,NULL,'2MASX J15234769+0859114',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00008,NULL,'15.0',0.4,'E/S0','Group member',NULL,NULL,NULL,1,230.948625,8.98644,0.057,NULL,59350685213,927354456,14489913,15),(129689,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129689,37.47,0.46,311,59855,70,NULL,NULL,'2MASX J15234764+3929424',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,230.948625,39.49517,0.037,NULL,60110820816,939231575,14675493,16.6),(129690,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129690,37.47,0.46,312,59856,70,NULL,NULL,'2MASX J15234813+0113546',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.9505417,1.23178,0.097,NULL,56431003127,881734423,13777100,17.4),(129691,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129691,37.68,0.46,343,59857,70,NULL,NULL,'2MASX J15234877+2937303',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,230.953125,29.62497,0.025,NULL,59905984184,936031002,14625484,18.5),(129692,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129692,38.29,0.46,455,59858,70,NULL,NULL,'SDSS J152349.42+050049.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.955916667,5.01367,0.065,NULL,56429218872,881706544,13776664,18.3),(129693,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129693,37.87,0.46,374,59859,70,NULL,NULL,'SDSS J152349.72-015221.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,230.957208333,-1.87278,0.305,NULL,45424070124,709751095,11089860,18.6),(129694,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129694,37.35,0.46,295,59860,70,NULL,NULL,'2MASX J15235033+2532503',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,230.959875,25.54722,0.113,NULL,59901901230,935967206,14624487,17.5),(129695,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129695,38.39,0.46,476,59861,70,NULL,NULL,'2MASX J15235086+0441416',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,230.961833,4.69494,0.077,NULL,56429179743,881705933,13776655,17.7),(129696,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129696,37.99,0.46,397,59862,70,NULL,NULL,'2MASX J15235090+1927488',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,230.9620417,19.46356,0.177,NULL,59442520436,928789381,14512334,18),(129697,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129697,37.55,0.46,324,59863,70,NULL,NULL,'SDSS J152351.00+063703.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.9625,6.61756,0.041,NULL,56413100003,881454687,13772729,18.5),(129698,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129698,33.07,0.4,41.2,59864,75,NULL,'B','UGC 09837',NULL,'1988NBGC.C....0000T',1988,1,1.14,NULL,'G',0.000017,NULL,'14.6g',0.95,'SAB(s)c',NULL,NULL,NULL,NULL,1,230.965291667,58.05294,0.017,NULL,57591473871,899866779,14060418,14.6),(129699,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129699,37.13,0.46,267,59865,70,NULL,NULL,'2MASX J15235307+1432397',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,230.97125,14.54444,0.113,NULL,59574395588,930849931,14544530,17),(129700,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129700,38.59,0.46,524,59866,70,NULL,NULL,'2MASX J15235364+4824116',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,230.973375,48.40331,0.029,NULL,59664839639,932263119,14566611,17.7),(129701,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129701,38.08,0.46,413,59867,70,NULL,NULL,'SDSS J152354.50+050512.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.977125,5.08686,0.065,NULL,56429222837,881706606,13776665,18),(129702,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129702,37.46,0.46,311,59868,70,NULL,NULL,'2MASX J15235474+2139048',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000171,NULL,'18.43',0.16,NULL,NULL,NULL,NULL,NULL,1,230.978167,21.65144,0.145,NULL,59413460703,928335323,14505239,18.43),(129703,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129703,37.58,0.46,328,59869,70,NULL,NULL,'2MASX J15235500+0103496',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000106,NULL,'17.4g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,230.979375,1.06367,0.097,NULL,56431181456,881737210,13777143,17.4),(129704,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129704,38.76,0.46,565,59870,70,NULL,NULL,'2MASX J15235646+3823413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,230.985333333,38.39475,0.025,NULL,60111374380,939240224,14675628,17.9),(129705,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129705,37.41,0.16,304,59871,70,NULL,NULL,'SDSS J152357.23+065659.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,230.9885,6.94983,0.081,NULL,56413359948,881458749,13772792,17.8),(129706,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129706,35.75,0.46,141,59872,70,NULL,NULL,'2MASX J15235753+1701337',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.56',0.33,NULL,NULL,NULL,NULL,NULL,1,230.989666667,17.02617,0.109,NULL,59434898440,928670288,14510473,16.56),(129707,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129707,37.53,0.15,320,59873,70,NULL,NULL,'CGCG 165-049',NULL,'2015arXiv151105856S',2015,1,0.97,NULL,'G',0.000077,NULL,'15.1g',0.53,'BrClG',NULL,NULL,NULL,NULL,1,230.9995417,31.21114,0.025,NULL,59911847970,936122624,14626916,15.1),(129708,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129708,36.47,0.1,197,59874,70,NULL,NULL,'2MASX J15240113+2044058',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.80',0.16,NULL,NULL,NULL,NULL,NULL,1,231.0047083,20.73489,0.185,NULL,59413987400,928343553,14505368,17.8),(129709,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129709,37.48,0.46,313,59875,70,NULL,NULL,'2MASX J15240155+0158512',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.006417,1.98081,0.121,NULL,56434314063,881786157,13777908,17.1),(129710,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129710,36.92,0.53,242,59876,NULL,NULL,'Malmquist cor.','2MASX J15240202+0818551',NULL,'2009ApJS..182..474S',2009,1,0.63,'1991A&AS...90..355C has V = 10945 +- 108 km/s.','G',0.00003,NULL,'17.0g',0.15,'Sc','Group member',NULL,NULL,NULL,1,231.008333,8.31531,0.073,NULL,56411687125,881432611,13772384,17),(129711,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129711,37.29,0.45,288,59876,NULL,NULL,NULL,'2MASX J15240202+0818551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129712,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129712,37.33,0.2,292,59876,74.4,NULL,NULL,'2MASX J15240202+0818551',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129713,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129713,37.08,0.46,261,59877,70,NULL,NULL,'2MASX J15240206+3927353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.008458333,39.45975,0.045,NULL,60110825673,939231651,14675494,17),(129714,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129714,37.91,0.46,381,59878,70,NULL,NULL,'2MASX J15240349+2950163',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.014417,29.83786,0.025,NULL,59905504879,936023513,14625367,18.3),(129715,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129715,36.99,0.46,250,59879,70,NULL,NULL,'2MASX J15240433+1927468',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.017917,19.46314,0.177,NULL,59442470428,928788600,14512321,17.1),(129716,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129716,35.55,0.46,129,59880,70,NULL,NULL,'2MASX J15240552+4045483',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.023125,40.76353,0.037,NULL,59975509413,937117334,14642458,16.3),(129717,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129717,38.03,0.27,404,59881,70,NULL,NULL,'2MASX J15240592+0545502',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.024625,5.76389,0.065,NULL,56428581705,881696589,13776509,17.8),(129718,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129718,37.9,0.46,379,59882,70,NULL,NULL,'2MASX J15240625+4528099',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.025833,45.46942,0.025,NULL,59969776272,937027754,14641058,17.2),(129719,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129719,37.53,0.15,320,59883,70,NULL,NULL,'2MASX J15240635+3105492',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,231.026333333,31.09689,0.025,NULL,59903593233,935993644,14624900,16.4),(129720,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129720,34.57,0.2,82,59884,74.4,NULL,NULL,'CGCG 077-118',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000123,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,231.033916667,13.59364,0.113,NULL,59562522645,930664416,14541631,15.4),(129721,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129721,36.47,0.1,197,59885,70,NULL,NULL,'2MASX J15240823+2042488',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.034416667,20.71344,0.185,NULL,59444249160,928816393,14512756,17.5),(129722,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129722,38.46,0.46,493,59886,70,NULL,NULL,'2MASX J15240865+2239448',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000176,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.035916667,22.66261,0.177,NULL,59421683023,928463797,14507246,18.1),(129723,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129723,37.73,0.33,352,59887,70,NULL,NULL,'SDSS J152408.93+112056.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.0372083,11.34911,0.089,NULL,59344302859,927254732,14488355,18.1),(129724,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129724,37.15,0.46,270,59888,70,NULL,NULL,'2MASX J15240938+3251212',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.039,32.85603,0.033,NULL,59882165238,935658831,14619669,17.2),(129725,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129725,38.12,0.46,420,59889,70,NULL,NULL,'2MASX J15241048+5728223',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.043417,57.47278,0.029,NULL,57589633778,899838027,14059969,17.9),(129726,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129726,34.43,0.55,77.1,59890,NULL,NULL,NULL,'ESO 328- G 048',NULL,'2009ApJS..182..474S',2009,1,1.2,'Confused HIPASS source','G',0.000033,NULL,'16.0b',0.3,'S...',NULL,NULL,NULL,NULL,1,231.0445,-38.46278,0.541,NULL,47191540144,737367814,11521372,16),(129727,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129727,34.45,0.49,77.8,59890,75,NULL,'IR','ESO 328- G 048',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129728,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129728,34.48,0.2,78.7,59890,74.4,NULL,NULL,'ESO 328- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129729,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129729,34.61,0.51,83.5,59890,NULL,NULL,'Malmquist cor.','ESO 328- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129730,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129730,37.11,0.46,264,59891,70,NULL,NULL,'2MASX J15241084+5642413',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000167,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.045083,56.71147,0.025,NULL,57593768224,899902628,14060978,16.4),(129731,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129731,32.89,NULL,37.8,59892,72,NULL,NULL,'AGC 258405',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000215,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.050833,7.4925,0.065,NULL,56413262363,881457224,13772769,NULL),(129732,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129732,33.29,0.76,45.4,59893,NULL,NULL,'Malmquist cor.','CGCG 077-117',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000041,NULL,'15.6',0.4,'Sab;HII        Sy2','Group member',NULL,NULL,'Sy 2',1,231.052417,8.54481,0.065,NULL,59350588121,927352939,14489889,15.6),(129733,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129733,33.33,0.74,46.4,59893,NULL,NULL,NULL,'CGCG 077-117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129734,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129734,38.03,0.27,404,59894,70,NULL,NULL,'2MASX J15241289+0544012',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.0537917,5.73378,0.065,NULL,56428417654,881694025,13776469,17.7),(129735,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129735,38.67,0.46,543,59895,70,NULL,NULL,'2MASX J15241332+2323529',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.055417,23.39808,0.185,NULL,59419196831,928424950,14506639,17.9),(129736,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129736,37.13,0.46,267,59896,70,NULL,NULL,'2MASX J15241346+1101142',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.0560417,11.02075,0.089,NULL,59344415357,927256489,14488382,16.5),(129737,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129737,37.7,0.46,347,59897,70,NULL,NULL,'2MASX J15241348+3324013',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000224,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,231.0560417,33.40017,0.037,NULL,59882937376,935670896,14619857,16.2),(129738,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129738,37.49,0.09,315,59898,70,NULL,NULL,'2MASX J15241366+2748363',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.73',0.16,NULL,NULL,NULL,NULL,NULL,1,231.056791667,27.81,0.081,NULL,59907967117,936061986,14625968,18.73),(129739,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129739,39.11,0.46,664,59899,70,NULL,NULL,'SDSS J152414.13+544806.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.058916667,54.80186,0.025,NULL,57580471398,899694865,14057732,18.4),(129740,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129740,36.47,0.1,197,59900,70,NULL,NULL,'2MASX J15241428+2046439',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.24',0.16,NULL,NULL,NULL,NULL,NULL,1,231.059375,20.77886,0.185,NULL,59444186074,928815407,14512740,18.24),(129741,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129741,37.11,0.46,264,59901,70,NULL,NULL,'2MASX J15241490+0742532',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.0622917,7.71478,0.069,NULL,56411632537,881431758,13772371,16),(129742,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129742,36.32,0.46,184,59902,70,NULL,NULL,'CGCG 049-156',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000089,NULL,'16.1g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,231.069208333,3.64489,0.097,NULL,56435203563,881800055,13778125,16.1),(129743,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129743,38.53,0.46,509,59903,70,NULL,NULL,'2MASX J15241673+4414550',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.0699583,44.24864,0.033,NULL,59969327301,937020739,14640949,17.9),(129744,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129744,37.81,0.46,365,59904,70,NULL,NULL,'2MASX J15241699+3359043',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.070708333,33.98439,0.045,NULL,60104792262,939137379,14674021,17.4),(129745,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129745,34.83,0.47,92.3,59905,NULL,NULL,'H','ESO 328- G 050',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'12.20',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,231.077208333,-39.08686,0.413,NULL,47192085580,737376337,11521505,12.2),(129746,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129746,34.86,0.45,93.9,59905,NULL,NULL,'K','ESO 328- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129747,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129747,34.92,0.46,96.3,59905,NULL,NULL,'J','ESO 328- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129748,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129748,35.06,0.4,103,59905,NULL,NULL,'mean','ESO 328- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129749,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129749,36.59,0.46,208,59906,70,NULL,NULL,'2MASX J15242095+3430173',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.087333333,34.50489,0.037,NULL,60108080585,939188759,14674824,17.3),(129750,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129750,37.49,0.09,315,59907,70,NULL,NULL,'2MASX J15242306+2741466',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.63',0.24,NULL,NULL,NULL,NULL,NULL,1,231.09625,27.69617,0.081,NULL,59907973875,936062091,14625970,17.63),(129751,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129751,37.64,0.27,338,59908,70,NULL,NULL,'2MASX J15242332+2909586',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.0972083,29.16639,0.033,NULL,59906062825,936032231,14625503,17.7),(129752,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129752,37.7,0.33,347,59909,70,NULL,NULL,'SDSS J152423.36+294304.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000115,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.097333,29.71783,0.013,NULL,59905969121,936030767,14625480,17.9),(129753,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129753,38.16,0.46,429,59910,70,NULL,NULL,'2MASX J15242458+4304241',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00018,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.10225,43.07344,0.097,NULL,59977962151,937155658,14643057,18),(129754,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129754,36.47,0.1,197,59911,70,NULL,NULL,'CGCG 135-055 NED01',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000153,NULL,'15.90',0.36,NULL,NULL,NULL,NULL,NULL,1,231.10325,20.76169,0.185,NULL,59444198406,928815600,14512743,15.9),(129755,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129755,37.13,0.46,267,59912,70,NULL,NULL,'2MASX J15242576+2912056',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'16.7g',0.28,'E',NULL,NULL,NULL,NULL,1,231.107125,29.20175,0.045,NULL,59906062962,936032233,14625503,16.7),(129756,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129756,38.05,0.46,408,59913,70,NULL,NULL,'2MASX J15242592+2223459',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.108125,22.39625,0.181,NULL,59420800110,928450001,14507031,17.7),(129757,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129757,37.36,0.46,296,59914,70,NULL,NULL,'SDSS J152426.18+063902.5',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.109083,6.65069,0.061,NULL,56412970022,881452656,13772697,17.6),(129758,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129758,35.42,0.46,121,59915,70,NULL,NULL,'2MASX J15242716+2855297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.54',0.31,'Sc',NULL,NULL,NULL,NULL,1,231.113083,28.92486,0.033,NULL,59906002747,936031292,14625488,16.54),(129759,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129759,36.48,0.46,198,59916,70,NULL,NULL,'2MASX J15242780+4558361',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.115791667,45.97672,0.045,NULL,59966799567,936981243,14640331,16.4),(129760,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129760,37.63,0.46,335,59917,70,NULL,NULL,'2MASX J15242831+5724123',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.117917,57.40347,0.025,NULL,57589641604,899838150,14059971,17.8),(129761,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129761,37.4,0.46,303,59918,70,NULL,NULL,'2MASX J15242898+2613587',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.120958333,26.23292,0.105,NULL,59901660409,935963443,14624428,17.9),(129762,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129762,37.8,0.46,363,59919,70,NULL,NULL,'2MASX J15242925+2130549',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.121916667,21.51522,0.145,NULL,59413562558,928336914,14505264,17.6),(129763,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129763,35.1,0.69,105,59920,100,NULL,'mid-IR','CGCG 077-119',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000027,NULL,'15.1g',0.4,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.123083333,8.37322,0.097,NULL,56412221439,881440959,13772514,15.1),(129764,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129764,35.52,0.38,127,59920,NULL,NULL,NULL,'CGCG 077-119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129765,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129765,35.67,0.35,136,59920,NULL,NULL,'Malmquist cor.','CGCG 077-119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129766,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129766,35.86,0.2,149,59920,74.4,NULL,NULL,'CGCG 077-119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129767,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129767,38.02,0.46,402,59921,70,NULL,NULL,'2MASX J15242960+2217359',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'17.97',0.24,NULL,NULL,NULL,NULL,NULL,1,231.123333,22.29333,0.181,NULL,59420904233,928451628,14507056,17.97),(129768,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129768,37.49,0.09,315,59922,70,NULL,NULL,'2MASX J15243006+2750127',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.125083,27.837,0.081,NULL,59907865174,936060393,14625943,17.6),(129769,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129769,37.85,0.46,371,59923,70,NULL,NULL,'2MASX J15243033+2601227',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.126333,26.02308,0.145,NULL,59901764461,935965069,14624454,17.1),(129770,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129770,36.47,0.1,197,59924,70,NULL,NULL,'2MASX J15243068+2045279',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.57',0.18,NULL,NULL,NULL,NULL,NULL,1,231.1277917,20.75783,0.185,NULL,59444198028,928815594,14512743,17.57),(129771,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129771,37.54,0.46,322,59925,70,NULL,NULL,'2MASX J15243113+0355291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.129667,3.92492,0.097,NULL,56435077362,881798083,13778095,17.8),(129772,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129772,36.49,0.46,198,59926,70,NULL,NULL,'2MASX J15243149+0147411',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.26',0.25,NULL,NULL,NULL,NULL,NULL,1,231.131333,1.79472,0.121,NULL,56434156714,881783698,13777870,17.26),(129773,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129773,36.58,0.46,207,59927,70,NULL,NULL,'2MASX J15243192+0410171',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.1329583,4.17133,0.093,NULL,56435098334,881798411,13778100,16.9),(129774,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129774,37.25,0.33,282,59928,70,NULL,NULL,'2MASX J15243303+0059001',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000085,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.137625,0.98342,0.125,NULL,56430596979,881728077,13777001,16.4),(129775,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129775,36.34,0.46,185,59929,70,NULL,NULL,'2MASX J15243339+2540497',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000182,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,231.139041667,25.68064,0.165,NULL,59901774995,935965234,14624456,15.6),(129776,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129776,36.32,0.46,183,59930,70,NULL,NULL,'2MASX J15243349+0201521',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.139583,2.03106,0.145,NULL,56434360155,881786877,13777919,16.9),(129777,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129777,37.52,0.46,320,59931,70,NULL,NULL,'2MASX J15243409+2004509',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.142166667,20.08078,0.193,NULL,59445330306,928833286,14513020,16.7),(129778,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129778,36.87,0.46,237,59932,70,NULL,NULL,'2MASX J15243481+0931488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.145083,9.53022,0.073,NULL,59354889211,927420143,14490939,17.3),(129779,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129779,38.54,0.46,512,59933,70,NULL,NULL,'SDSS J152435.69+054457.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.14875,5.74936,0.065,NULL,56428530014,881695781,13776496,18.6),(129780,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129780,37.61,0.46,332,59934,70,NULL,NULL,'2MASX J15243638+2846297',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.24',0.2,NULL,NULL,NULL,NULL,NULL,1,231.151625,28.77503,0.041,NULL,59907311179,936051737,14625808,18.24),(129781,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129781,37.06,0.46,258,59935,70,NULL,NULL,'2MASX J15243660+3209192',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000202,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,231.1525417,32.15536,0.033,NULL,59912307023,936129797,14627028,16),(129782,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129782,35.68,0.16,137,59936,70,NULL,NULL,'GIN 434',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'12.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,231.155083,8.99017,0.077,NULL,59350499548,927351555,14489868,12.1),(129783,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129783,37.73,0.33,352,59937,70,NULL,NULL,'2MASX J15243800+1117218',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.15825,11.28942,0.089,NULL,59344343199,927255362,14488365,16.7),(129784,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129784,37.43,0.27,306,59938,70,NULL,NULL,'2MASX J15243812+2514007',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.1587083,25.23358,0.133,NULL,59901408314,935959504,14624367,17.7),(129785,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129785,38.27,0.46,452,59939,70,NULL,NULL,'2MASX J15243887+0439161',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.1619583,4.65456,0.077,NULL,56436722292,881823785,13778496,18),(129786,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129786,36.83,0.46,232,59940,70,NULL,NULL,'2MASX J15243889+2838237',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.67',0.16,NULL,NULL,NULL,NULL,NULL,1,231.1620417,28.63997,0.049,NULL,59908173297,936065207,14626018,18.67),(129787,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129787,37.27,0.46,285,59941,70,NULL,NULL,'2MASX J15244013+0956429',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000196,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.1670417,9.94522,0.085,NULL,59343250473,927238288,14488098,16.6),(129788,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129788,37.25,0.33,282,59942,70,NULL,NULL,'2MASX J15244044+0100051',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.168375,1.00153,0.125,NULL,56430612992,881728328,13777005,17.3),(129789,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129789,36.71,0.46,220,59943,70,NULL,NULL,'SDSS J152442.21+183609.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.175917,18.60272,0.153,NULL,59434042394,928656912,14510264,17.5),(129790,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129790,37.44,0.27,307,59944,70,NULL,NULL,'SDSS J152442.58+323617.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.1774583,32.60475,0.033,NULL,59882152839,935658638,14619666,18),(129791,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129791,38.84,0.46,586,59945,70,NULL,NULL,'2MASX J15244278+1910589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.178375,19.18294,0.165,NULL,59442025668,928781651,14512213,18.1),(129792,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129792,38.03,0.27,404,59946,70,NULL,NULL,'SDSS J152442.96+054908.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.1790417,5.819,0.061,NULL,56428528875,881695763,13776496,18),(129793,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129793,37.7,0.33,347,59947,70,NULL,NULL,'SDSS J152443.16+294617.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.179875,29.77161,0.013,NULL,59906146543,936033539,14625524,18.5),(129794,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129794,38.86,0.46,592,59948,70,NULL,NULL,'SDSS J152443.61+192849.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.1817917,19.48028,0.177,NULL,59442466497,928788539,14512320,18.6),(129795,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129795,36.6,0.46,209,59949,70,NULL,NULL,'2MASX J15244431-0026293',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.184667,-0.44144,0.201,NULL,45403438240,709428722,11084823,17.4),(129796,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129796,37.5,0.46,317,59950,70,NULL,NULL,'SDSS J152444.53+252829.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000158,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.185583,25.47481,0.145,NULL,59901412400,935959568,14624368,18.6),(129797,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129797,37.41,0.16,304,59951,70,NULL,NULL,'2MASX J15244467+0653589',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',NULL,NULL,'15.5g',0.41,NULL,NULL,NULL,NULL,NULL,1,231.186125,6.89964,0.081,NULL,56413204146,881456314,13772754,15.5),(129798,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129798,34.6,0.47,83,59952,NULL,NULL,'H','NGC 5939',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00008,NULL,'14.0',0.5,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,231.1917917,68.73064,0.033,NULL,57969791789,905777996,14152781,14),(129799,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129799,34.6,0.45,83.2,59952,NULL,NULL,'K','NGC 5939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129800,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129800,34.64,0.46,84.8,59952,NULL,NULL,'J','NGC 5939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129801,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129801,34.84,0.4,92.9,59952,NULL,NULL,'mean','NGC 5939',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129802,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129802,36.42,0.46,192,59953,70,NULL,NULL,'2MASX J15244708+0710429',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.196166667,7.17858,0.065,NULL,56413210584,881456415,13772756,16.7),(129803,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129803,37.54,0.46,323,59954,70,NULL,NULL,'2MASX J15244727+3028292',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.196875,30.47486,0.017,NULL,59905468867,936022951,14625358,17.6),(129804,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129804,37.65,0.33,339,59955,70,NULL,NULL,'2MASX J15244856+2536203',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.202333333,25.60564,0.145,NULL,59901300313,935957817,14624340,17.6),(129805,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129805,36.19,0.46,173,59956,70,NULL,NULL,'2MASX J15244937+0306301',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000102,NULL,'15.6g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,231.2057083,3.10839,0.085,NULL,56434661015,881791578,13777993,15.6),(129806,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129806,37.44,0.27,307,59957,70,NULL,NULL,'2MASX J15244933+3236162',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000186,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.205833,32.60444,0.033,NULL,59882152249,935658628,14619666,16.2),(129807,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129807,37.44,0.27,307,59958,70,NULL,NULL,'2MASX J15245021+3228472',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.209167,32.47992,0.029,NULL,59911581702,936118464,14626851,17.6),(129808,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129808,37.92,0.46,384,59959,70,NULL,NULL,'2MASX J15245048+1536591',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.2104583,15.6165,0.109,NULL,59565635835,930713059,14542391,17.6),(129809,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129809,35.46,0.46,123,59960,70,NULL,NULL,'CGCG 077-120',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000143,NULL,'15.2g',0.5,'S0p','Group member',NULL,NULL,NULL,1,231.2130417,8.42514,0.093,NULL,56411382537,881427852,13772310,15.2),(129810,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129810,37.39,0.46,301,59961,70,NULL,NULL,'2MASX J15245129+3034243',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.213625,30.57358,0.021,NULL,59905423791,936022246,14625347,16.8),(129811,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129811,37.43,0.27,306,59962,70,NULL,NULL,'2MASX J15245206+2515053',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.216916667,25.25161,0.133,NULL,59901368073,935958876,14624357,16.7),(129812,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129812,36.04,0.63,161,59963,70,NULL,NULL,'2MASX J15245396-1119071',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.25',NULL,NULL,NULL,NULL,NULL,NULL,1,231.224875,-11.31875,0.585,NULL,46477005497,726203210,11346925,16.25),(129813,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129813,37.41,0.16,304,59964,70,NULL,NULL,'2MASX J15245609+0658199',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.2337083,6.97228,0.065,NULL,56413205321,881456333,13772755,17.6),(129814,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129814,37.43,0.27,306,59965,70,NULL,NULL,'2MASX J15245634+2508453',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.23475,25.14606,0.133,NULL,59901376472,935959007,14624359,17.4),(129815,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129815,37.34,0.33,294,59966,70,NULL,NULL,'2MASX J15245657+5422598',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.235666667,54.38317,0.021,NULL,59661930942,932217670,14565901,16.6),(129816,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129816,37.46,0.46,311,59967,70,NULL,NULL,'2MASX J15245696+3518542',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.2372917,35.315,0.021,NULL,60106093461,939157710,14674339,17.2),(129817,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129817,36.79,0.46,228,59968,70,NULL,NULL,'2MASX J15245755+2831593',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00005,NULL,'16.86',0.32,NULL,NULL,NULL,NULL,NULL,1,231.24,28.53314,0.049,NULL,59908202383,936065662,14626025,16.86),(129818,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129818,37.32,0.46,292,59969,70,NULL,NULL,'2MASX J15245774+2921313',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'17.0g',0.27,'E',NULL,NULL,NULL,NULL,1,231.240708333,29.35864,0.029,NULL,59906141366,936033458,14625522,17),(129819,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129819,37.86,0.46,372,59970,70,NULL,NULL,'2MASX J15245820+3407402',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.242417,34.12772,0.057,NULL,60104685348,939135708,14673995,18.4),(129820,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129820,36.11,0.46,167,59971,70,NULL,NULL,'2MASX J15245831+3944164',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000166,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,231.243167,39.73797,0.045,NULL,60097271279,939019863,14672185,16),(129821,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129821,37.52,0.46,320,59972,70,NULL,NULL,'2MASX J15245849+0822289',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.243625,8.37464,0.093,NULL,56412256664,881441510,13772523,17.3),(129822,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129822,35.08,0.46,104,59973,70,NULL,NULL,'IC 1118',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000167,NULL,'15.2',0.8,NULL,NULL,NULL,NULL,NULL,1,231.2480417,13.44508,0.113,NULL,59562359523,930661867,14541591,15.2),(129823,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129823,42.23,0.05,2790,59974,NULL,NULL,'z = 1.18 +/- 0.06','5B 970111',NULL,'2016ApJ...819...79G',2016,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,231.25,18.73,0.157,NULL,59442151846,928783622,14512244,NULL),(129824,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129824,37.35,0.46,295,59975,70,NULL,NULL,'2MASX J15250244+0338009',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.1g',0.15,'BLAGN',NULL,NULL,NULL,'Sy 1',1,231.26025,3.6335,0.097,NULL,56434696778,881792137,13778002,18.1),(129825,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129825,36.16,0.09,171,59976,70,NULL,NULL,'CGCG 077-121',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000143,NULL,'15.6g',0.31,'S0','Group member',NULL,NULL,NULL,1,231.2650417,8.71853,0.057,NULL,56411393924,881428030,13772312,15.6),(129826,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129826,37.16,0.46,270,59977,70,NULL,NULL,'2MASX J15250417+3348068',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.2675,33.80197,0.025,NULL,59882713567,935667399,14619803,17.6),(129827,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129827,35,0.46,100,59978,70,NULL,NULL,'CGCG 049-157',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000107,NULL,'15.6',0.6,NULL,'Group member',NULL,NULL,NULL,1,231.268333,4.82983,0.077,NULL,56436758815,881824356,13778505,15.6),(129828,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129828,32.45,0.2,30.9,59979,74.4,NULL,NULL,'UGC 09855',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000017,NULL,'14.84',0.5,'Im:',NULL,NULL,NULL,NULL,1,231.2702083,66.25536,0.073,NULL,57961303010,905645359,14150708,14.84),(129829,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129829,37.54,0.46,322,59980,70,NULL,NULL,'2MASX J15250725-0157516',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.2802083,-1.96444,0.305,NULL,45424199227,709753112,11089892,18.2),(129830,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129830,37.88,0.23,377,59981,70,NULL,NULL,'SDSS J152507.76+213749.9',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000196,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,231.282333333,21.63056,0.145,NULL,59413626682,928337916,14505279,16.5),(129831,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129831,38.65,0.46,536,59982,70,NULL,NULL,'SDSS J152508.45+025553.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000088,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,231.285208333,2.93156,0.085,NULL,56432799740,881762495,13777538,18.5),(129832,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129832,38.1,0.46,417,59983,70,NULL,NULL,'2MASX J15250867+0102379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.286083,1.04386,0.125,NULL,56430621735,881728464,13777007,17.6),(129833,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129833,38.63,0.46,531,59984,70,NULL,NULL,'2MASX J15250948+1951259',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.289625,19.85733,0.185,NULL,59445170469,928830788,14512981,18),(129834,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129834,37.94,0.46,387,59985,70,NULL,NULL,'SDSS J152510.59+034230.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.294125,3.70858,0.097,NULL,56438168202,881846378,13778849,18.1),(129835,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129835,37.22,0.23,278,59986,70,NULL,NULL,'2MASX J15251068+3258438',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.294625,32.97886,0.033,NULL,59883043479,935672554,14619883,17.9),(129836,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129836,37.72,0.46,350,59987,70,NULL,NULL,'SDSS J152511.19+064831.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.296667,6.80867,0.081,NULL,56410901668,881420338,13772192,18.4),(129837,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129837,35.44,0.33,122,59988,NULL,NULL,NULL,'UGC 09838',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00003,NULL,'14.96',0.4,'Sab','Group member, peripheral',NULL,NULL,NULL,1,231.300833,7.15481,0.065,NULL,56412511252,881445488,13772585,14.96),(129838,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129838,35.48,0.2,125,59988,74.4,NULL,NULL,'UGC 09838',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129839,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129839,35.58,0.31,131,59988,NULL,NULL,'Malmquist cor.','UGC 09838',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129840,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129840,35.67,0.49,136,59988,75,NULL,'IR','UGC 09838',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129841,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129841,35.85,0.4,148,59988,NULL,NULL,'mean','UGC 09838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129842,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129842,35.98,0.47,157,59988,NULL,NULL,'H','UGC 09838',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129843,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129843,35.44,0.6,122,59989,70,NULL,NULL,'UGC 09839',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000115,NULL,'16.1g',0.23,'S',NULL,NULL,NULL,NULL,1,231.3017917,-1.81117,0.305,NULL,45423622186,709744096,11089751,16.1),(129844,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129844,38.36,0.46,471,59990,70,NULL,NULL,'SDSS J152512.55+222400.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000135,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.3022917,22.40019,0.181,NULL,59420822074,928450344,14507036,18.2),(129845,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129845,36.9,0.46,239,59991,70,NULL,NULL,'2MASX J15251278+3033208',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000168,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,231.303333,30.55592,0.021,NULL,59905418528,936022164,14625346,16.2),(129846,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129846,37.64,0.27,338,59992,70,NULL,NULL,'SDSS J152512.82+285828.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.303417,28.97453,0.033,NULL,59905289082,936020141,14625314,NULL),(129847,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129847,38.13,0.27,422,59993,70,NULL,NULL,'2MASX J15251336+1305139',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,231.305708333,13.08714,0.085,NULL,59563184734,930674761,14541793,18.4),(129848,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129848,37.48,0.46,314,59994,70,NULL,NULL,'SBS 1523+511',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.30725,50.96231,0.045,NULL,59666596978,932290577,14567040,16.9),(129849,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129849,38.05,0.46,408,59995,70,NULL,NULL,'2MASX J15251472+1107104',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.3112917,11.11958,0.089,NULL,59345027298,927266051,14488532,17),(129850,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129850,37.04,0.46,256,59996,70,NULL,NULL,'2MASX J15251530+3823294',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.313625,38.39167,0.025,NULL,60111419457,939240929,14675639,17.3),(129851,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129851,37.88,0.23,377,59997,70,NULL,NULL,'2MASX J15251587+2136118',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.316083333,21.60314,0.165,NULL,59413624423,928337881,14505279,16.6),(129852,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129852,33.52,0.2,50.6,59998,74.4,NULL,NULL,'UGC 09849',NULL,'2013AJ....146...86T',2013,1,1.82,NULL,'G',0.000027,NULL,'15.1g',0.39,'Scd(f)',NULL,NULL,NULL,NULL,1,231.3185417,53.407,0.017,NULL,59674452433,932413319,14568958,15.1),(129853,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129853,33.57,0.47,51.9,59998,NULL,NULL,NULL,'UGC 09849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129854,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129854,33.61,0.46,52.8,59998,NULL,NULL,'Malmquist cor.','UGC 09849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129855,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129855,37.49,0.33,315,59999,70,NULL,NULL,'2MASX J15251646+4719487',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.318791667,47.33008,0.041,NULL,59982744115,937230376,14644224,16.7),(129856,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129856,38.13,0.27,422,60000,70,NULL,NULL,'SDSS J152516.76+125850.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.319916667,12.98072,0.085,NULL,59562710463,930667350,14541677,18.3),(129857,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129857,37.22,0.23,278,60001,70,NULL,NULL,'2MASX J15251751+3258088',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.323125,32.96911,0.033,NULL,59883044259,935672566,14619883,16.9),(129858,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129858,37.41,0.46,303,60002,70,NULL,NULL,'2MASX J15251757+3045478',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.32325,30.76322,0.005,NULL,59915111907,936173623,14627712,17),(129859,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129859,38.22,0.46,441,60003,70,NULL,NULL,'SDSS J152518.43+102433.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.3267917,10.40936,0.073,NULL,59343800084,927246876,14488232,18.5),(129860,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129860,38.12,0.46,421,60004,70,NULL,NULL,'2MASX J15251844+0454449',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.326916667,4.9125,0.077,NULL,56436753963,881824280,13778504,17.8),(129861,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129861,37.06,0.46,259,60005,70,NULL,NULL,'2MASX J15251854+0339359',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.327333,3.65986,0.097,NULL,56438222156,881847221,13778862,16.8),(129862,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129862,37.4,0.46,302,60006,70,NULL,NULL,'2MASX J15251879+5139432',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.328375,51.66186,0.033,NULL,59675972543,932437070,14569329,17.4),(129863,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129863,38.1,0.46,417,60007,70,NULL,NULL,'SDSS J152518.95+191330.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.329,19.22514,0.161,NULL,59442060164,928782190,14512221,18.4),(129864,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129864,37.94,0.46,387,60008,70,NULL,NULL,'2MASX J15251911+4542407',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'FoF','17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.3297917,45.71128,0.025,NULL,59966765150,936980705,14640323,17.3),(129865,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129865,37.88,0.23,377,60009,70,NULL,NULL,'2MASX J15252074+2138438',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.336583333,21.64544,0.165,NULL,59413613117,928337704,14505276,17.6),(129866,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129866,37.88,0.23,377,60010,70,NULL,NULL,'SDSS J152520.82+213603.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.33675,21.60103,0.165,NULL,59413623960,928337874,14505279,18.5),(129867,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129867,36.86,0.46,235,60011,70,NULL,NULL,'2MASX J15252092+2126568',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.3370417,21.44906,0.169,NULL,59413517871,928336216,14505253,16.7),(129868,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129868,36.83,0.46,232,60012,70,NULL,NULL,'2MASX J15252116+2252058',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.3380417,22.86839,0.153,NULL,59419210367,928425161,14506643,17.6),(129869,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129869,37.48,0.23,314,60013,70,NULL,NULL,'2MASX J15252195+3212418',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.3414583,32.21164,0.025,NULL,59912311972,936129874,14627029,18.5),(129870,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129870,38.13,0.27,422,60014,70,NULL,NULL,'2MASX J15252233+1255530',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.343,12.93144,0.129,NULL,59562721141,930667517,14541679,17.8),(129871,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129871,37.4,0.46,302,60015,70,NULL,NULL,'2MASX J15252233+3140368',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000197,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.3430417,31.67697,0.037,NULL,59912372298,936130817,14627044,16.6),(129872,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129872,37.46,0.46,310,60016,70,NULL,NULL,'2MASX J15252240+2925308',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.8g',0.26,'E',NULL,NULL,NULL,NULL,1,231.343125,29.42522,0.029,NULL,59906145162,936033518,14625523,16.8),(129873,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129873,35.98,0.23,157,60017,70,NULL,NULL,'2MASX J15252240+4827532',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.3435417,48.46486,0.033,NULL,59664969258,932265144,14566642,16.7),(129874,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129874,35.83,0.2,147,60018,74.4,NULL,NULL,'CGCG 077-124',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000019,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,231.343791667,9.73119,0.073,NULL,59343265397,927238521,14488101,15.3),(129875,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129875,37.48,0.23,314,60019,70,NULL,NULL,'2MASX J15252289+3208338',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.345333,32.14281,0.025,NULL,59912311485,936129866,14627029,17.2),(129876,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129876,35.98,0.23,157,60020,70,NULL,NULL,'MCG +08-28-029',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000186,NULL,'15.4g',0.55,'E0',NULL,NULL,NULL,NULL,1,231.345917,48.44011,0.033,NULL,59664967278,932265113,14566642,15.4),(129877,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129877,38.01,0.46,401,60021,70,NULL,NULL,'2MASX J15252316+3047288',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.346375,30.79122,0.005,NULL,59915111379,936173615,14627712,17.2),(129878,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129878,38.05,0.46,408,60022,70,NULL,NULL,'2MASX J15252357+3705034',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.348167,37.08422,0.025,NULL,60110463813,939225997,14675406,17.8),(129879,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129879,36.97,0.46,248,60023,70,NULL,NULL,'2MASX J15252504+2844049',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.354291667,28.73467,0.041,NULL,59907364745,936052574,14625821,17.7),(129880,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129880,38.2,0.46,437,60024,70,NULL,NULL,'SDSS J152525.86+274808.1',NULL,'2015arXiv151105856S',2015,1,0.02,NULL,'G',NULL,NULL,'23.3g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.35775,27.80228,0.081,NULL,59907893413,936060834,14625950,23.3),(129881,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129881,37.91,0.46,382,60025,70,NULL,NULL,'2MASX J15252618+0642414',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.359167,6.71142,0.081,NULL,56411033781,881422402,13772225,17.5),(129882,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129882,37.64,0.27,338,60026,70,NULL,NULL,'2MASX J15252759+2903019',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.3650417,29.05056,0.033,NULL,59905335168,936020862,14625325,17.6),(129883,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129883,37.05,0.46,258,60027,70,NULL,NULL,'2MASX J15252853+0152432',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.36875,1.87853,0.145,NULL,56434046969,881781983,13777843,16.8),(129884,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129884,36.25,0.33,178,60028,70,NULL,NULL,'SDSS J152528.75+045825.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.5g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.369833333,4.97386,0.081,NULL,56436867129,881826048,13778532,18.5),(129885,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129885,36.84,0.33,234,60029,70,NULL,NULL,'2MASX J15252900+3146378',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.370833,31.77717,0.037,NULL,59912453132,936132080,14627063,17),(129886,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129886,36.58,0.46,207,60030,70,NULL,NULL,'2MASX J15252945+1833579',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.01',0.27,NULL,NULL,NULL,NULL,NULL,1,231.372625,18.56619,0.157,NULL,59433836448,928653694,14510213,17.01),(129887,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129887,44,0.53,1760,60031,73,NULL,'H const./H=100','VLA J152530.3+444559',1.61,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',NULL,NULL,'18.2',NULL,'Irregular',NULL,NULL,NULL,NULL,1,231.3762917,44.76644,0.033,NULL,59970073352,937032396,14641131,18.2),(129888,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129888,44.36,0.47,2850,60031,69.7,NULL,'Fiducial','VLA J152530.3+444559',1.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129889,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129889,44.56,1.61,3130,60031,100,NULL,NULL,'VLA J152530.3+444559',1.61,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129890,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129890,44.66,0.37,3280,60031,69.7,NULL,'Calibrated','VLA J152530.3+444559',1.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129891,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129891,44.78,0.46,3460,60031,72,NULL,NULL,'VLA J152530.3+444559',1.61,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129892,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129892,44.8,1.55,3490,60031,73,NULL,'H const./H=100','VLA J152530.3+444559',1.61,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129893,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129893,44.99,0.45,3810,60031,70,NULL,NULL,'VLA J152530.3+444559',1.61,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129894,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129894,45.02,0.54,3870,60031,NULL,NULL,NULL,'VLA J152530.3+444559',1.61,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129895,'GRB','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129895,45.5,0.16,12600,60031,NULL,NULL,NULL,'VLA J152530.3+444559',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129896,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129896,38.2,0.46,436,60032,70,NULL,NULL,'2MASX J15253068+2038169',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.377958333,20.63797,0.185,NULL,59444245041,928816328,14512755,18),(129897,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129897,36.94,0.46,245,60033,70,NULL,NULL,'2MASX J15253090+2435139',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000167,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.378625,24.58733,0.125,NULL,59418277234,928410581,14506415,16.5),(129898,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129898,37.49,0.33,315,60034,70,NULL,NULL,'2MASX J15253127+4719304',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.380333333,47.32511,0.041,NULL,59982744049,937230375,14644224,17.4),(129899,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129899,37.07,0.46,259,60035,70,NULL,NULL,'2MASX J15253149+3406048',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.381333,34.10122,0.057,NULL,59882628170,935666065,14619782,16.8),(129900,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129900,37.87,0.46,374,60036,70,NULL,NULL,'2MASX J15253198+0248352',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00012,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.383375,2.80972,0.085,NULL,56433367833,881771372,13777677,16.9),(129901,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129901,38.16,0.46,429,60037,70,NULL,NULL,'2MASX J15253252+5907240',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.385625,59.12333,0.009,NULL,57717947320,901842926,14091295,17.1),(129902,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129902,35.62,0.46,133,60038,70,NULL,NULL,'CGCG 165-053 NED01',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00013,NULL,'15.0g',0.58,NULL,NULL,NULL,NULL,NULL,1,231.387375,26.54761,0.153,NULL,59902237427,935972459,14624569,15),(129903,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129903,37.38,0.46,299,60039,70,NULL,NULL,'2MASX J15253310+4757405',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,231.387917,47.96131,0.037,NULL,59664233506,932253648,14566463,18.2),(129904,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129904,36.05,0.46,163,60040,70,NULL,NULL,'2MASX J15253370+0555082',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000113,NULL,'16.57',0.43,NULL,NULL,NULL,NULL,NULL,1,231.390583,5.919,0.057,NULL,56429046046,881703844,13776622,16.57),(129905,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129905,33.63,0.49,53.3,60041,75,NULL,'IR','UGC 09841',NULL,'2011yCatp016004901K',2011,1,2.82,'UGC Dec (+18 22) is incorrect.','G',0.000015,NULL,'14.33',0.36,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,231.392,18.27722,0.145,NULL,59433961377,928655646,14510244,14.33),(129906,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129906,33.99,NULL,62.7,60041,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129907,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129907,33.99,NULL,62.7,60041,NULL,NULL,'Dipole','UGC 09841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129908,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129908,33.99,NULL,62.8,60041,NULL,NULL,'Dipole + Quadrupole','UGC 09841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129909,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129909,34.05,NULL,64.7,60041,NULL,NULL,NULL,'UGC 09841',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129910,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129910,34.06,0.2,64.9,60041,74.4,NULL,NULL,'UGC 09841',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129911,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129911,37.48,0.46,313,60042,70,NULL,NULL,'2MASX J15253466+4527495',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.394375,45.46375,0.025,NULL,59969444453,937022569,14640977,16.5),(129912,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129912,38.23,0.46,442,60043,70,NULL,NULL,'SDSS J152536.86+102301.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.403625,10.38372,0.073,NULL,59343928372,927248880,14488263,18.5),(129913,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129913,37.5,0.46,316,60044,70,NULL,NULL,'2MASX J15253747+0529533',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.4062083,5.49825,0.085,NULL,56428962125,881702533,13776602,16.8),(129914,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129914,38.63,0.46,533,60045,70,NULL,NULL,'2MASX J15253818+4529455',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.409333,45.49617,0.025,NULL,59969453954,937022718,14640979,17.9),(129915,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129915,36.84,0.33,234,60046,70,NULL,NULL,'CGCG 165-054',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000183,NULL,'15.0g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,231.413917,29.60356,0.013,NULL,59906116704,936033073,14625516,15),(129916,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129916,38.02,0.46,402,60047,70,NULL,NULL,'2MASX J15253983+3258138',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.415875,32.97047,0.033,NULL,59883039669,935672494,14619882,17.8),(129917,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129917,35.66,0.2,136,60048,74.4,NULL,NULL,'UGC 09843',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000107,NULL,'15.5',0.7,'SB(s)b: pec',NULL,NULL,NULL,NULL,1,231.415917,20.78794,0.181,NULL,59444215103,928815860,14512747,15.5),(129918,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129918,38.37,0.46,472,60049,70,NULL,NULL,'SDSS J152540.46+263901.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.418625,26.6505,0.137,NULL,59902248066,935972626,14624572,18.3),(129919,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129919,33.84,NULL,58.5,60050,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1903',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',NULL,NULL,'16.42',0.11,'Sdm',NULL,NULL,NULL,NULL,1,231.419583,66.21111,0.073,NULL,57961241054,905644391,14150693,16.42),(129920,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129920,33.86,NULL,59.1,60050,NULL,NULL,'Dipole + Quadrupole','FGC 1903',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129921,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129921,33.87,NULL,59.5,60050,NULL,NULL,'Dipole','FGC 1903',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129922,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129922,33.92,NULL,60.9,60050,NULL,NULL,NULL,'FGC 1903',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129923,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129923,37.22,0.23,278,60051,70,NULL,NULL,'2MASX J15254150+3254268',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000012,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,231.422917,32.90744,0.033,NULL,59883059586,935672806,14619887,16),(129924,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129924,37.65,0.46,339,60052,70,NULL,NULL,'2MASX J15254233+1318210',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.4264583,13.30575,0.097,NULL,59563225042,930675391,14541802,16.8),(129925,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129925,35.44,NULL,122,60053,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1895',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000033,NULL,'16.4',0.12,'Sc             HII',NULL,NULL,NULL,NULL,1,231.4309583,-17.24122,0.505,NULL,46598114005,728095531,11376492,16.4),(129926,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129926,35.46,NULL,123,60053,NULL,NULL,'Dipole + Quadrupole','FGC 1895',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129927,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129927,35.47,NULL,124,60053,NULL,NULL,'Dipole','FGC 1895',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129928,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129928,35.49,NULL,125,60053,NULL,NULL,NULL,'FGC 1895',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129929,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129929,36.84,0.33,234,60054,70,NULL,NULL,'2MASX J15254428+3143518',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.4345,31.731,0.037,NULL,59912260508,936129070,14627016,17.6),(129930,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129930,37.41,0.16,304,60055,70,NULL,NULL,'SDSS J152544.58+070107.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.43575,7.01867,0.065,NULL,56410582676,881415354,13772114,NULL),(129931,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129931,36.84,0.33,234,60056,70,NULL,NULL,'2MASX J15254529+2935079',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000113,NULL,'16.3g',0.29,'E',NULL,NULL,NULL,NULL,1,231.4385417,29.58567,0.013,NULL,59906115037,936033047,14625516,16.3),(129932,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129932,37.32,0.46,291,60057,70,NULL,NULL,'2MASX J15254550+0813089',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.4394583,8.21908,0.097,NULL,56412196363,881440568,13772508,16.8),(129933,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129933,37.74,0.46,353,60058,70,NULL,NULL,'2MASX J15254561+1906043',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.44,19.10128,0.161,NULL,59442039145,928781861,14512216,17.3),(129934,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129934,36.99,0.46,250,60059,70,NULL,NULL,'2MASX J15254619+0401343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000095,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.442458333,4.02631,0.093,NULL,56438331028,881848922,13778889,16.6),(129935,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129935,34.86,0.49,93.7,60060,75,NULL,'IR','UGC 09853',NULL,'2011yCatp016004901K',2011,1,2.24,NULL,'G',0.000043,NULL,'14.6g',0.42,'Sb','Isolated galaxy',NULL,NULL,NULL,1,231.444625,52.44472,0.033,NULL,59676423627,932444119,14569439,14.6),(129936,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129936,36.25,0.33,178,60061,70,NULL,NULL,'2MASX J15254671+0452103',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.444708333,4.86953,0.081,NULL,56436938164,881827158,13778549,16.9),(129937,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129937,37.48,0.23,314,60062,70,NULL,NULL,'2MASX J15254754+3204339',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'16.3g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,231.448,32.07614,0.025,NULL,59912461968,936132218,14627065,16.3),(129938,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129938,38.15,0.46,426,60063,70,NULL,NULL,'2MASX J15254828+2345123',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.451333,23.75342,0.185,NULL,59419863300,928435364,14506802,18),(129939,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129939,38.5,0.46,502,60064,70,NULL,NULL,'SDSS J152550.21+313205.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.45925,31.53472,0.029,NULL,59911796813,936121825,14626903,18.3),(129940,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129940,38,0.46,398,60065,70,NULL,NULL,'2MASX J15255024+4230285',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.4595,42.50808,0.085,NULL,59977596443,937149944,14642967,17.7),(129941,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129941,38.78,0.46,570,60066,70,NULL,NULL,'SDSS J152550.44+055554.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.460166667,5.93186,0.057,NULL,56428997055,881703078,13776610,NULL),(129942,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129942,37.41,0.16,304,60067,70,NULL,NULL,'2MASX J15255076+0652479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.4614583,6.87983,0.065,NULL,56411037998,881422468,13772226,17.5),(129943,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129943,37.01,0.46,253,60068,70,NULL,NULL,'SDSS J152550.76+082343.5',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000186,NULL,'15.8g',0.5,'S0','Group member',NULL,NULL,NULL,1,231.461541667,8.39542,0.093,NULL,56412170074,881440157,13772502,15.8),(129944,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129944,37.28,0.46,286,60069,70,NULL,NULL,'2MASX J15255148+5916291',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000195,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.464417,59.27464,0.037,NULL,57772536853,902695888,14104623,16.2),(129945,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129945,35.25,0.39,112,60070,NULL,NULL,NULL,'UGC 09844',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00001,NULL,'14.49',0.6,'SB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.469125,7.81961,0.081,NULL,56411967725,881436995,13772453,14.49),(129946,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129946,35.42,0.36,121,60070,NULL,NULL,'Malmquist cor.','UGC 09844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129947,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129947,35.8,0.4,144,60070,NULL,NULL,'mean','UGC 09844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129948,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129948,35.82,0.2,146,60070,74.4,NULL,NULL,'UGC 09844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129949,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129949,36.06,0.47,163,60070,NULL,NULL,'H','UGC 09844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129950,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129950,37.62,0.46,334,60071,70,NULL,NULL,'2MASX J15255381+4844220',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,231.474208333,48.73961,0.029,NULL,59664801825,932262528,14566602,18.2),(129951,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129951,37.13,0.23,266,60072,70,NULL,NULL,'2MASX J15255389+3618573',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.22',0.46,NULL,NULL,NULL,NULL,NULL,1,231.4747917,36.31592,0.021,NULL,60105823199,939153487,14674273,16.22),(129952,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129952,35.69,0.46,137,60073,70,NULL,NULL,'2MASX J15255426+1339370',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000067,NULL,'15.64',0.43,NULL,NULL,NULL,NULL,NULL,1,231.476167,13.66039,0.117,NULL,59562431462,930662991,14541609,15.64);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (129953,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129953,37.41,0.46,303,60074,70,NULL,NULL,'2MASX J15255504+2815216',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.19',0.16,NULL,NULL,NULL,NULL,NULL,1,231.47925,28.25603,0.057,NULL,59907414625,936053353,14625833,18.19),(129954,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129954,37.48,0.23,314,60075,70,NULL,NULL,'2MASX J15255580+3200339',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.4825,32.00953,0.025,NULL,59912466475,936132288,14627067,17.5),(129955,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129955,37.35,0.23,296,60076,70,NULL,NULL,'SDSS J152555.90+065135.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.4829583,6.86,0.065,NULL,56411037830,881422466,13772226,18.2),(129956,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129956,37.72,0.46,350,60077,70,NULL,NULL,'2MASX J15255739+1914223',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.48925,19.23961,0.161,NULL,59445504514,928836008,14513062,18.3),(129957,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129957,38.42,0.46,482,60078,70,NULL,NULL,'2MASX J15255943+5913541',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.4977083,59.23167,0.009,NULL,57772501650,902695338,14104614,17.4),(129958,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129958,37.98,0.46,395,60079,70,NULL,NULL,'SDSS J152559.46+430604.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.497833333,43.10111,0.097,NULL,59977917359,937154958,14643046,18),(129959,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129959,37.94,0.46,388,60080,70,NULL,NULL,'2MASX J15255961+0102037',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.498375,1.03428,0.117,NULL,56397372093,881208938,13768889,18),(129960,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129960,36.84,0.46,233,60081,70,NULL,NULL,'2MASX J15255984+0947245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.499333,9.79017,0.073,NULL,59343314041,927239281,14488113,16.9),(129961,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129961,36.92,0.46,242,60082,70,NULL,NULL,'2MASX J15260036+5600041',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.5017917,56.00108,0.013,NULL,57596084816,899938825,14061544,17.5),(129962,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129962,37.81,0.33,365,60083,70,NULL,NULL,'2MASX J15260064+3117139',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.5027083,31.28725,0.025,NULL,59911944647,936124135,14626939,17.1),(129963,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129963,37.81,0.46,364,60084,70,NULL,NULL,'SDSS J152600.67+103539.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.5027917,10.59436,0.085,NULL,59343902800,927248481,14488257,18.1),(129964,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129964,38.31,0.46,459,60085,70,NULL,NULL,'2MASXi J1526006+375716',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000158,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.502833333,37.95472,0.013,NULL,60111760482,939246257,14675722,17.3),(129965,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129965,37.15,0.33,269,60086,70,NULL,NULL,'2MASX J15260102+2916587',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000107,NULL,'16.8g',0.31,'E',NULL,NULL,NULL,NULL,1,231.504333333,29.283,0.045,NULL,59905346889,936021045,14625328,16.8),(129966,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129966,35.05,0.66,102,60087,70,NULL,NULL,'2MASX J15260190-0123273',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,231.5077917,-1.391,0.281,NULL,45420706983,709698546,11089039,15.7),(129967,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129967,35.22,0.46,111,60087,70,NULL,NULL,'2MASX J15260190-0123273',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129968,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129968,37.81,0.33,365,60088,70,NULL,NULL,'2MASX J15260189+3117039',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.5080417,31.28431,0.025,NULL,59911944608,936124134,14626939,17.6),(129969,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129969,37.13,0.23,266,60089,70,NULL,NULL,'2MASX J15260251+3620188',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.510625,36.33858,0.021,NULL,60110217481,939222148,14675346,16.5),(129970,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129970,33.87,0.46,59.3,60090,70,NULL,NULL,'NGC 5928',NULL,'2015arXiv151105856S',2015,1,1.6,NULL,'G',0.00006,NULL,'13.3g',1.02,'S0','Possible field galaxy',NULL,NULL,NULL,1,231.512,18.07364,0.141,NULL,59436811363,928700177,14510940,13.3),(129971,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129971,33.97,0.4,62.3,60090,NULL,NULL,'mean','NGC 5928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129972,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129972,34.14,0.45,67.4,60090,NULL,NULL,'K','NGC 5928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129973,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129973,37.11,0.46,265,60091,70,NULL,NULL,'2MASX J15260329+5030591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.51375,50.51639,0.037,NULL,59667338050,932302157,14567221,17.8),(129974,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129974,36.28,0.27,181,60092,70,NULL,NULL,'2MASX J15260490+0612445',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.520417,6.21242,0.065,NULL,56411096504,881423382,13772240,16.7),(129975,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129975,38.36,0.46,471,60093,70,NULL,NULL,'SDSS J152604.99+285756.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.520833,28.96575,0.033,NULL,59905299547,936020305,14625317,18.3),(129976,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129976,37.35,0.46,295,60094,70,NULL,NULL,'SDSS J152605.17+283122.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0002,NULL,'17.7g',0.13,NULL,'Group member',NULL,NULL,NULL,1,231.521583333,28.52294,0.049,NULL,59907452758,936053949,14625842,17.7),(129977,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129977,32.54,0.2,32.2,60095,74.4,NULL,NULL,'UGC 09845',NULL,'2013AJ....146...86T',2013,1,1.71,NULL,'G',0.000006,NULL,'15.3g',0.31,'Sbc',NULL,NULL,NULL,NULL,1,231.523208333,9.20414,0.073,NULL,59354644771,927416324,14490880,15.3),(129978,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129978,32.57,NULL,32.6,60095,72,NULL,NULL,'UGC 09845',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129979,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129979,32.65,0.4,33.8,60095,75,NULL,NULL,'UGC 09845',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129980,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129980,33,0.43,39.8,60095,75,NULL,'3.6 micron, color corrected','UGC 09845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129981,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129981,33.13,NULL,42.2,60095,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129982,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129982,33.14,NULL,42.5,60095,NULL,NULL,'Dipole + Quadrupole','UGC 09845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129983,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129983,33.15,NULL,42.6,60095,NULL,NULL,'Dipole','UGC 09845',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129984,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129984,33.22,NULL,44.1,60095,NULL,NULL,NULL,'UGC 09845',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129985,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129985,33.31,0.49,45.8,60095,75,NULL,'IR','UGC 09845',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129986,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129986,33.46,0.43,49.1,60095,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09845',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129987,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129987,36.48,0.46,198,60096,70,NULL,NULL,'2MASX J15260596+3039519',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000157,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,231.524833,30.66439,0.021,NULL,59913022739,936140980,14627202,16.3),(129988,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129988,32.93,0.8,38.5,60097,75,NULL,NULL,'NGC 5929',NULL,'1988NBGC.C....0000T',1988,1,1.14,NULL,'G',0.000027,NULL,'13.9g',0.89,'Sab: pec       Sy2','X-ray-faint group member',NULL,NULL,'Sy 2',1,231.525667,41.67067,0.057,NULL,59975924008,937123812,14642559,13.9),(129989,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129989,36.44,0.46,194,60098,70,NULL,NULL,'2MASX J15260623+2232263',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00018,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,231.525875,22.54056,0.177,NULL,59418800003,928418750,14506542,15.8),(129990,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',129990,37.34,0.33,294,60099,70,NULL,NULL,'2MASX J15260672+5421470',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.527833333,54.363,0.021,NULL,59673422608,932397228,14568706,17.6),(129991,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129991,33.11,0.8,41.9,60100,75,NULL,'B','NGC 5930',NULL,'1988NBGC.C....0000T',1988,1,1.93,NULL,'G',0.000014,NULL,'13.3g',0.84,'SAB(rs)b pec   HII','X-ray-faint group member',NULL,NULL,NULL,1,231.533083333,41.67606,0.057,NULL,59975924216,937123815,14642559,13.3),(129992,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129992,32.49,0.47,31.4,60100,NULL,NULL,'H','NGC 5930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129993,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129993,32.49,0.45,31.5,60100,NULL,NULL,'K','NGC 5930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129994,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129994,32.53,0.46,32.1,60100,NULL,NULL,'J','NGC 5930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129995,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129995,32.89,0.4,37.9,60100,NULL,NULL,'mean','NGC 5930',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129996,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129996,32.47,0.8,31.2,60101,75,NULL,'MAT, I','UGCA 408',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000024,NULL,'13',1.6,'SA(s)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.533458333,-22.28247,0.413,NULL,46619902684,728435979,11381812,13),(129997,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129997,32.63,0.8,33.6,60101,75,NULL,NULL,'UGCA 408',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129998,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129998,31.88,0.43,23.8,60101,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 408',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(129999,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,129999,31.9,0.32,24,60101,85,NULL,'I, raw','UGCA 408',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130000,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130000,31.94,0.43,24.4,60101,75,NULL,'3.6 micron, color corrected','UGCA 408',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130001,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130001,31.94,0.32,24.4,60101,85,NULL,'I, inv','UGCA 408',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130002,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130002,32,0.43,25.2,60101,75,NULL,'MAT, I, raw','UGCA 408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130003,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130003,32.03,0.2,25.5,60101,74.4,NULL,NULL,'UGCA 408',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130004,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130004,32.17,0.43,27.1,60101,75,NULL,'MAT, I, inv','UGCA 408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130005,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130005,32.27,0.46,28.4,60101,NULL,NULL,'J','UGCA 408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130006,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130006,32.27,0.43,28.5,60101,NULL,NULL,NULL,'UGCA 408',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130007,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130007,32.31,0.43,28.9,60101,75,NULL,'MAT, I, cor','UGCA 408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130008,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130008,32.33,0.42,29.2,60101,NULL,NULL,'Malmquist cor.','UGCA 408',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130009,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130009,32.38,0.45,29.9,60101,NULL,NULL,'K','UGCA 408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130010,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130010,32.39,0.47,30.1,60101,NULL,NULL,'H','UGCA 408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130011,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130011,32.57,0.4,32.6,60101,NULL,NULL,'mean','UGCA 408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130012,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130012,38.03,0.46,404,60102,70,NULL,NULL,'2MASX J15260951+5612370',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.539583,56.21042,0.021,NULL,57596050411,899938287,14061535,18),(130013,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130013,36.66,0.46,215,60103,70,NULL,NULL,'2MASX J15261015+5618510',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.5422917,56.31408,0.025,NULL,57595781186,899934081,14061470,16.6),(130014,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130014,37.8,0.27,363,60104,70,NULL,NULL,'SDSS J152610.29+035458.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000087,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.542917,3.91628,0.093,NULL,56438323511,881848804,13778887,18.4),(130015,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130015,36.81,0.46,230,60105,70,NULL,NULL,'2MASX J15261088-0027153',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.545291667,-0.45422,0.233,NULL,45404370688,709443292,11085051,16.7),(130016,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130016,35.75,0.35,141,60106,NULL,NULL,NULL,'CGCG 077-126',NULL,'2009ApJS..182..474S',2009,1,0.7,'This object is described by multiple SDSS entries.','G',0.000011,NULL,'15.7',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.546833,8.90742,0.081,NULL,56411330173,881427033,13772297,15.7),(130017,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130017,35.81,0.34,145,60106,NULL,NULL,'Malmquist cor.','CGCG 077-126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130018,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130018,35.9,0.2,151,60106,74.4,NULL,NULL,'CGCG 077-126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130019,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130019,33.77,0.49,56.9,60107,75,NULL,'IR','ESO 449- G 010',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000033,NULL,'13.66',0.3,'S...',NULL,NULL,NULL,NULL,1,231.5537917,-30.20136,0.545,NULL,47163261542,736925961,11514468,13.66),(130020,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130020,37.8,0.27,363,60108,70,NULL,NULL,'2MASX J15261303+0353058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000122,NULL,'17.1g',0.24,'NLAGN',NULL,NULL,NULL,'Sy 2',1,231.5542917,3.88486,0.093,NULL,56438323950,881848811,13778887,17.1),(130021,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130021,37.11,0.46,264,60109,70,NULL,NULL,'SBS 1525+580A',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000176,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.5574583,57.91183,0.017,NULL,57591687782,899870121,14060470,16.4),(130022,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130022,38.75,0.46,561,60110,70,NULL,NULL,'2MASX J15261414+3229180',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.559,32.48847,0.029,NULL,59912043507,936125679,14626963,18.3),(130023,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130023,37.94,0.33,387,60111,70,NULL,NULL,'2MASX J15261619+2207371',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.5675,22.12694,0.169,NULL,59420734058,928448969,14507015,17),(130024,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130024,37.95,0.46,389,60112,70,NULL,NULL,'SDSS J152617.47+104257.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.572791667,10.71586,0.101,NULL,59345076226,927266816,14488544,18.7),(130025,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130025,38.4,0.46,479,60113,70,NULL,NULL,'SDSS J152617.78+115113.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.574125,11.85389,0.105,NULL,59344920718,927264386,14488506,18),(130026,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130026,37.76,0.46,356,60114,70,NULL,NULL,'2MASX J15261816+0018558',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.5757917,0.31556,0.149,NULL,56397041221,881203769,13768808,17.6),(130027,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130027,35.94,0.46,154,60115,70,NULL,NULL,'2MASX J15261853+3724199',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.577208333,37.4055,0.029,NULL,60110009494,939218898,14675295,16),(130028,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130028,38.07,0.46,410,60116,70,NULL,NULL,'2MASX J15261928+0049048',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.5804583,0.81811,0.137,NULL,56397302104,881207845,13768872,17.5),(130029,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130029,37.13,0.23,266,60117,70,NULL,NULL,'2MASX J15261940+3618359',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.5807083,36.31008,0.021,NULL,60105824391,939153506,14674273,16.8),(130030,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130030,37.68,0.46,343,60118,70,NULL,NULL,'2MASX J15261978+3331170',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.5825,33.5215,0.029,NULL,59882766758,935668230,14619816,17.4),(130031,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130031,37.11,0.13,265,60119,70,NULL,NULL,'2MASX J15261985+2824158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.1g',0.25,NULL,'Group member',NULL,NULL,NULL,1,231.582833,28.4045,0.041,NULL,59907448755,936053886,14625841,17.1),(130032,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130032,37.44,0.27,307,60120,70,NULL,NULL,'2MASX J15262006+1017096',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.5837083,10.286,0.073,NULL,59344143100,927252235,14488316,17.2),(130033,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130033,37.85,0.46,371,60121,70,NULL,NULL,'2MASX J15262025+0555128',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.5842917,5.92025,0.057,NULL,56428161980,881690030,13776406,17.6),(130034,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130034,36.23,0.46,177,60122,70,NULL,NULL,'2MASX J15262028+5040492',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.5845,50.68047,0.037,NULL,59667175906,932299623,14567181,16.9),(130035,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130035,37.92,0.46,383,60123,70,NULL,NULL,'SDSS J152621.00+581753.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,231.587541667,58.29819,0.017,NULL,57588277886,899816841,14059638,18.2),(130036,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130036,37.94,0.33,387,60124,70,NULL,NULL,'2MASX J15262115+2210451',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.588125,22.17931,0.169,NULL,59420736560,928449008,14507015,17.5),(130037,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130037,37.35,0.23,296,60125,70,NULL,NULL,'2MASX J15262119+0642596',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00012,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,231.5882917,6.71647,0.053,NULL,56411250658,881425791,13772277,15.6),(130038,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130038,37.38,0.46,300,60126,70,NULL,NULL,'2MASX J15262130+3700319',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.5887917,37.00878,0.025,NULL,60110429508,939225461,14675397,17.4),(130039,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130039,37.35,0.23,296,60127,70,NULL,NULL,'2MASX J15262152+0648306',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.58975,6.80853,0.081,NULL,56411076384,881423068,13772235,17.7),(130040,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130040,35.58,0.2,131,60128,74.4,NULL,NULL,'CGCG 077-129',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000011,NULL,'15.3g',0.5,NULL,NULL,NULL,NULL,NULL,1,231.5924583,9.39644,0.085,NULL,59343170095,927237032,14488078,15.3),(130041,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130041,37.36,0.46,296,60129,70,NULL,NULL,'2MASX J15262243+4711125',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.5934583,47.18689,0.033,NULL,59965972904,936968326,14640130,17.1),(130042,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130042,35.58,0.46,131,60130,70,NULL,NULL,'2MASX J15262244+0859146',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000153,NULL,'15.3g',0.49,NULL,NULL,NULL,NULL,NULL,1,231.5935,8.98736,0.081,NULL,56419684564,881557571,13774337,15.3),(130043,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130043,37.11,0.13,265,60131,70,NULL,NULL,'2MASX J15262295+2832315',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000117,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.59575,28.54203,0.045,NULL,59907495564,936054618,14625853,16.5),(130044,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130044,36.26,0.46,178,60132,70,NULL,NULL,'2MASX J15262426+2040201',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'16.25',0.22,NULL,NULL,NULL,NULL,NULL,1,231.601083333,20.67214,0.185,NULL,59444593313,928821770,14512840,16.25),(130045,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130045,38.31,0.46,459,60133,70,NULL,NULL,'SDSS J152624.85+293347.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,231.6035417,29.56308,0.013,NULL,59906117709,936033089,14625517,18.1),(130046,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130046,37.24,0.46,281,60134,70,NULL,NULL,'2MASX J15262566+3147120',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'16.8g',0.32,'AGN',NULL,NULL,NULL,NULL,1,231.606875,31.78656,0.037,NULL,59912275145,936129299,14627020,16.8),(130047,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130047,37.25,0.46,282,60135,70,NULL,NULL,'2MASX J15262597+2326501',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000138,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.608208333,23.44731,0.193,NULL,59419320663,928426885,14506670,17.5),(130048,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130048,37.99,0.46,395,60136,70,NULL,NULL,'2MASX J15262633+3316480',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.6097917,33.28017,0.013,NULL,59883102739,935673480,14619898,17.7),(130049,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130049,37.15,0.33,269,60137,70,NULL,NULL,'2MASX J15262729+2922315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.61375,29.3755,0.029,NULL,59905244608,936019447,14625303,17.2),(130050,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130050,37.21,0.33,277,60138,70,NULL,NULL,'2MASX J15262807+1130561',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'16.4E',NULL,NULL,NULL,NULL,NULL,NULL,1,231.616917,11.51556,0.077,NULL,59344847563,927263243,14488488,16.4),(130051,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130051,37.8,0.46,363,60139,70,NULL,NULL,'2MASX J15262898+5326502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.620958333,53.44731,0.025,NULL,59674403828,932412559,14568946,17.5),(130052,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130052,36.16,0.09,171,60140,70,NULL,NULL,'CGCG 077-130',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.0001,NULL,'15.1g',0.64,NULL,NULL,NULL,NULL,NULL,1,231.62275,8.59061,0.077,NULL,56411481610,881429400,13772334,15.1),(130053,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130053,38.56,0.46,514,60141,70,NULL,NULL,'SDSS J152629.62+193306.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.9g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.623417,19.55186,0.169,NULL,59445637511,928838086,14513095,18.9),(130054,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130054,37.13,0.23,266,60142,70,NULL,NULL,'2MASX J15262966+3618249',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.6235,36.307,0.021,NULL,60105819206,939153425,14674272,17.1),(130055,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130055,32.52,NULL,31.9,60143,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09856',NULL,'2010Ap&SS.325..163P',2010,1,2.79,NULL,'G',0.000013,NULL,'14.9g',0.3,'Sc;WR          HII','X-ray-faint group member',NULL,NULL,NULL,1,231.62625,41.28953,0.037,NULL,59975855744,937122746,14642542,14.9),(130056,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130056,32.53,NULL,32.1,60143,NULL,NULL,'Dipole + Quadrupole','UGC 09856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130057,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130057,32.54,NULL,32.2,60143,NULL,NULL,'Dipole','UGC 09856',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130058,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130058,32.54,0.53,32.2,60143,NULL,NULL,NULL,'UGC 09856',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130059,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130059,32.66,0.2,34,60143,74.4,NULL,NULL,'UGC 09856',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130060,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130060,32.73,0.49,35.2,60143,NULL,NULL,'Malmquist cor.','UGC 09856',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130061,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130061,32.78,0.4,36,60143,NULL,NULL,NULL,'UGC 09856',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130062,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130062,32.99,0.43,39.5,60143,75,NULL,'3.6 micron, color corrected','UGC 09856',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130063,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130063,33.08,0.43,41.3,60143,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09856',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130064,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130064,37.93,0.46,386,60144,70,NULL,NULL,'SDSS J152631.12+300626.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.6297083,30.10739,0.013,NULL,59913116502,936142445,14627225,18.1),(130065,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130065,32.85,0.8,37.1,60145,75,NULL,NULL,'UGC 09857',NULL,'1988NBGC.C....0000T',1988,1,1.37,NULL,'G',0.000017,NULL,'15.6g',0.38,'IBm','X-ray-faint group member',NULL,NULL,NULL,1,231.6307083,41.72519,0.081,NULL,59975903734,937123495,14642554,15.6),(130066,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130066,36.87,0.46,237,60146,70,NULL,NULL,'2MASX J15263162+4457164',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000149,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.6317083,44.95453,0.041,NULL,59970053629,937032087,14641126,16.5),(130067,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130067,37.88,0.46,378,60147,70,NULL,NULL,'2MASX J15263256+1553013',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.63575,15.88375,0.105,NULL,59434378923,928662170,14510346,16.4),(130068,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130068,38.87,0.46,595,60148,70,NULL,NULL,'2MASX J15263332+2214541',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.638875,22.24828,0.169,NULL,59418644188,928416315,14506504,17.5),(130069,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130069,37.95,0.46,389,60149,70,NULL,NULL,'SDSS J152633.65+020204.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.6402083,2.03456,0.125,NULL,56431896504,881748382,13777318,18.4),(130070,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130070,36.4,0.46,191,60150,70,NULL,NULL,'2MASX J15263425+3931139',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.642583,39.52056,0.049,NULL,60098001749,939031277,14672363,16.8),(130071,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130071,37.41,0.46,304,60151,70,NULL,NULL,'2MASX J15263463+3513580',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.644417,35.23269,0.021,NULL,60106160465,939158757,14674355,16.4),(130072,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130072,36.96,0.46,246,60152,70,NULL,NULL,'2MASX J15263487+3123160',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.645333,31.38786,0.021,NULL,59911811322,936122051,14626907,17.5),(130073,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130073,36.06,0.46,163,60153,70,NULL,NULL,'2MASX J15263544+3248360',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.647625,32.80986,0.033,NULL,59882524893,935664451,14619757,16.4),(130074,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130074,37.44,0.27,307,60154,70,NULL,NULL,'2MASX J15263636+1004501',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.6514583,10.08067,0.073,NULL,59344099601,927251556,14488305,16.9),(130075,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130075,37.35,0.23,296,60155,70,NULL,NULL,'2MASX J15263877+0649141',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,231.6615,6.82042,0.081,NULL,56411246548,881425727,13772276,16.2),(130076,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130076,38.07,0.46,412,60156,70,NULL,NULL,'2MASX J15263936+0214287',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.6640417,2.24144,0.109,NULL,56431880705,881748136,13777314,16.9),(130077,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130077,37.15,0.46,269,60157,70,NULL,NULL,'SDSS J152639.38+043807.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.664083,4.63556,0.093,NULL,56436796705,881824948,13778514,18.3),(130078,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130078,37.26,0.46,283,60158,70,NULL,NULL,'2MASX J15263943+5848106',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.664125,58.80294,0.021,NULL,57718004289,901843817,14091309,17.2),(130079,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130079,37.51,0.46,318,60159,70,NULL,NULL,'2MASX J15263982+1748075',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.666083,17.80211,0.133,NULL,59437266902,928707295,14511051,17.4),(130080,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130080,37.11,0.46,264,60160,70,NULL,NULL,'2MASX J15263999+3841151',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.6665417,38.68769,0.041,NULL,60097332075,939020813,14672200,17.2),(130081,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130081,36.15,0.33,170,60161,70,NULL,NULL,'2MASX J15264039+0442527',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.668125,4.71472,0.097,NULL,56436846951,881825733,13778527,16.6),(130082,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130082,33,0.8,39.9,60162,75,NULL,'A82, H','UGC 09858',NULL,'1997ApJS..109..333W',1997,1,3.36,NULL,'G',0.000007,NULL,'13.5g',0.72,'SABbc','X-ray-faint group member',NULL,NULL,NULL,1,231.6727917,40.5645,0.033,NULL,59964065486,936938523,14639664,13.5),(130083,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130083,32.28,0.4,28.6,60162,75,NULL,NULL,'UGC 09858',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130084,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130084,32.31,0.4,29,60162,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 09858',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130085,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130085,32.6,0.38,33.1,60162,NULL,NULL,NULL,'UGC 09858',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130086,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130086,32.73,0.47,35.1,60162,75,NULL,'A82, H, raw','UGC 09858',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130087,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130087,32.83,0.47,36.8,60162,75,NULL,'A82, H, inv','UGC 09858',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130088,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130088,32.97,0.2,39.3,60162,74.4,NULL,NULL,'UGC 09858',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130089,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130089,32.98,0.47,39.4,60162,75,NULL,'A82, H, cor','UGC 09858',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130090,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130090,33.01,0.4,40,60162,NULL,NULL,'mean','UGC 09858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130091,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130091,33.04,0.4,40.6,60162,75,NULL,'B','UGC 09858',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130092,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130092,33.05,0.43,40.8,60162,75,NULL,'3.6 micron, color corrected','UGC 09858',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130093,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130093,33.11,0.49,42,60162,75,NULL,'IR','UGC 09858',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130094,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130094,33.21,0.46,43.8,60162,NULL,NULL,'J','UGC 09858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130095,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130095,33.23,0.43,44.2,60162,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09858',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130096,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130096,33.31,0.47,45.9,60162,NULL,NULL,'H','UGC 09858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130097,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130097,33.38,0.45,47.5,60162,NULL,NULL,'K','UGC 09858',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130098,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130098,37.69,0.33,345,60163,70,NULL,NULL,'2MASX J15264206+0438557',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.6752917,4.64869,0.093,NULL,56436796368,881824943,13778514,17.2),(130099,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130099,36.1,0.46,166,60164,70,NULL,NULL,'2MASX J15264211+2615117',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.89',0.15,NULL,NULL,NULL,NULL,NULL,1,231.6755,26.25342,0.141,NULL,59902972651,935983947,14624749,17.89),(130100,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130100,37.69,0.33,345,60165,70,NULL,NULL,'2MASX J15264346+0439417',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.6810417,4.66161,0.093,NULL,56436795487,881824929,13778514,16.8),(130101,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130101,37.92,0.46,385,60166,70,NULL,NULL,'2MASX J15264439+1854263',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.6849583,18.90733,0.181,NULL,59445400172,928834377,14513037,17.9),(130102,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130102,37.05,0.33,257,60167,70,NULL,NULL,'2MASX J15264524+1844323',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'17.22',0.43,NULL,NULL,NULL,NULL,NULL,1,231.6885,18.74225,0.177,NULL,59441953531,928780523,14512195,17.22),(130103,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130103,37.22,0.23,278,60168,70,NULL,NULL,'2MASX J15264523+3309233',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000204,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.688625,33.1565,0.021,NULL,59883092413,935673318,14619895,16.8),(130104,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130104,36.71,0.46,220,60169,70,NULL,NULL,'2MASX J15264605-0106082',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.6919583,-1.10222,0.249,NULL,45403846363,709435099,11084923,17.9),(130105,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130105,34.87,NULL,94.3,60170,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1899',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.000017,NULL,'16.8',0.09,'Sd',NULL,NULL,NULL,NULL,1,231.695,-13.96667,0.529,NULL,46660324180,729067565,11391680,16.8),(130106,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130106,34.88,NULL,94.5,60170,NULL,NULL,NULL,'FGC 1899',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130107,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130107,34.88,NULL,94.5,60170,NULL,NULL,'Dipole + Quadrupole','FGC 1899',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130108,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130108,34.89,NULL,95.1,60170,NULL,NULL,'Dipole','FGC 1899',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130109,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130109,35.32,0.46,116,60171,70,NULL,NULL,'CGCG 106-045',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000203,NULL,'15.4',0.49,NULL,NULL,NULL,NULL,NULL,1,231.6962083,16.55775,0.085,NULL,59435383225,928677862,14510591,15.4),(130110,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130110,36.84,0.46,234,60172,70,NULL,NULL,'2MASX J15264768+3731291',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.6985417,37.52481,0.037,NULL,60110114866,939220544,14675321,16.5),(130111,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130111,35.98,0.23,157,60173,70,NULL,NULL,'NGC 5932',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000183,NULL,'14.5g',0.82,'E0',NULL,NULL,NULL,NULL,1,231.700875,48.61497,0.033,NULL,59664987341,932265427,14566647,14.5),(130112,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130112,36.88,0.46,238,60174,70,NULL,NULL,'2MASX J15264903+0820501',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.7042917,8.34739,0.077,NULL,56411884894,881435701,13772432,17.6),(130113,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130113,37.21,0.33,277,60175,70,NULL,NULL,'2MASX J15264950+1126351',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.706166667,11.44322,0.077,NULL,59344975351,927265239,14488519,17.3),(130114,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130114,37.73,0.46,352,60176,70,NULL,NULL,'2MASX J15265110+0207147',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.713,2.12069,0.109,NULL,56431921989,881748781,13777324,NULL),(130115,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130115,36.45,0.46,195,60177,70,NULL,NULL,'2MASX J15265161+0338270',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.715167,3.64075,0.093,NULL,56438146898,881846045,13778844,16.6),(130116,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130116,37.05,0.33,257,60178,70,NULL,NULL,'2MASX J15265178+1844163',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.715667,18.73803,0.177,NULL,59441940371,928780318,14512192,17.3),(130117,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130117,37.39,0.46,300,60179,70,NULL,NULL,'2MASX J15265181+3539493',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.71575,35.66375,0.037,NULL,60106472242,939163628,14674431,17.2),(130118,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130118,37.86,0.46,373,60180,70,NULL,NULL,'2MASX J15265318+3020153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.7214583,30.3375,0.017,NULL,59913253312,936144583,14627259,17.8),(130119,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130119,35.01,0.47,101,60181,70,NULL,NULL,'2MASX J15265337-2005411',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.39',NULL,NULL,NULL,NULL,NULL,NULL,1,231.7225417,-20.09494,0.473,NULL,46627890155,728560783,11383762,15.39),(130120,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130120,37.31,0.23,289,60182,70,NULL,NULL,'2MASX J15265357+2549277',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.723125,25.82431,0.161,NULL,59902457800,935975903,14624623,17.3),(130121,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130121,37.35,0.46,295,60183,70,NULL,NULL,'2MASX J15265374+4224569',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.7239583,42.41586,0.089,NULL,59977608869,937150138,14642970,17.8),(130122,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130122,38.54,0.46,510,60184,70,NULL,NULL,'2MASX J15265460+0235240',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.7275,2.59008,0.113,NULL,56431574569,881743352,13777239,17.8),(130123,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130123,37.87,0.33,375,60185,70,NULL,NULL,'2MASX J15265571+0311270',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.732041667,3.19072,0.093,NULL,56435956014,881811812,13778309,17.3),(130124,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130124,38,0.46,397,60186,70,NULL,NULL,'2MASX J15265611+1907343',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.7339583,19.12631,0.161,NULL,59445565185,928836956,14513077,18.2),(130125,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130125,37.95,0.46,388,60187,70,NULL,NULL,'2MASX J15265642+3010303',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.73525,30.17503,0.013,NULL,59913120288,936142504,14627226,17.4),(130126,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130126,38.36,0.46,470,60188,70,NULL,NULL,'SDSS J152656.96+235450.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.737333,23.91394,0.173,NULL,59420640717,928447511,14506992,18.3),(130127,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130127,36.89,0.46,239,60189,70,NULL,NULL,'2MASX J15265874+0815435',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.11',0.34,NULL,NULL,NULL,NULL,NULL,1,231.744833,8.26203,0.117,NULL,56420080910,881563764,13774433,17.11),(130128,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130128,35.89,0.46,151,60190,70,NULL,NULL,'2MASX J15265899+0425150',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.74575,4.42078,0.093,NULL,56438436673,881850573,13778915,16.1),(130129,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130129,37.01,0.46,252,60191,70,NULL,NULL,'2MASX J15265901+0827015',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.7457917,8.45031,0.077,NULL,56419746048,881558532,13774352,16.5),(130130,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130130,37.23,0.46,280,60192,70,NULL,NULL,'2MASX J15265959+1524446',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.7482917,15.41231,0.097,NULL,59560168443,930627631,14541056,17.7),(130131,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130131,37.36,0.33,296,60193,70,NULL,NULL,'2MASX J15265984+0706585',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.74925,7.11633,0.073,NULL,56410763537,881418180,13772159,17),(130132,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130132,37.33,0.46,292,60194,70,NULL,NULL,'2MASX J15270034+3620022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.7514583,36.33386,0.021,NULL,60110209278,939222019,14675344,18),(130133,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130133,35.23,0.48,111,60195,70,NULL,NULL,'2MASX J15270061-1258519',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00005,NULL,'15.66',1,NULL,NULL,NULL,NULL,NULL,1,231.7525417,-12.98136,0.517,NULL,46661287522,729082617,11391915,15.66),(130134,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130134,35.98,0.23,157,60196,70,NULL,NULL,'NGC 5933',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.0002,NULL,'15.4g',0.47,'E0',NULL,NULL,NULL,NULL,1,231.7565417,48.61331,0.033,NULL,59664909485,932264210,14566628,15.4),(130135,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130135,37.36,0.33,296,60197,70,NULL,NULL,'2MASX J15270213+0710155',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.758917,7.17097,0.073,NULL,56410753584,881418024,13772156,17.2),(130136,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130136,35.38,0.33,119,60198,70,NULL,NULL,'UGC 09859',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000167,NULL,'14.86',0.7,'I?',NULL,NULL,NULL,NULL,1,231.7589583,26.70517,0.137,NULL,59902176046,935971500,14624554,14.86),(130137,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130137,37.03,0.46,255,60199,70,NULL,NULL,'2MASX J15270309+5611186',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.00',0.29,NULL,NULL,NULL,NULL,NULL,1,231.763166667,56.18842,0.021,NULL,57596028525,899937945,14061530,17),(130138,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130138,36.53,0.46,202,60200,70,NULL,NULL,'2MASX J15270376+3900232',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000172,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,231.76575,39.0065,0.037,NULL,60097480416,939023131,14672236,15.9),(130139,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130139,37.94,0.46,387,60201,70,NULL,NULL,'2MASX J15270432+2545583',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.767917,25.76622,0.157,NULL,59902416666,935975260,14624613,17.2),(130140,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130140,36.31,0.23,183,60202,70,NULL,NULL,'2MASX J15270627+0947465',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,231.7762083,9.79619,0.065,NULL,59343227563,927237930,14488092,15.9),(130141,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130141,37.8,0.27,363,60203,70,NULL,NULL,'2MASX J15270629+0405221',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,231.776417,4.08939,0.093,NULL,56438499122,881851548,13778930,16.7),(130142,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130142,38.55,0.46,514,60204,70,NULL,NULL,'SDSS J152707.78-014734.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000179,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,231.782417,-1.79297,0.305,NULL,45422540105,709727189,11089487,18.8),(130143,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130143,36.56,0.46,205,60205,70,NULL,NULL,'2MASX J15270797+0752445',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.4g',0.43,NULL,NULL,NULL,NULL,NULL,1,231.783333,7.87911,0.069,NULL,56411843636,881435056,13772422,16.4),(130144,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130144,37.61,0.46,333,60206,70,NULL,NULL,'2MASX J15270866+5710488',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.786083,57.18017,0.029,NULL,57591087508,899860742,14060324,17.5),(130145,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130145,38.26,0.46,449,60207,70,NULL,NULL,'2MASX J15270910+2004502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.787833,20.08072,0.197,NULL,59445745482,928839773,14513121,17.5),(130146,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130146,36.28,0.27,181,60208,70,NULL,NULL,'2MASX J15271113+0624145',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.7965,6.40414,0.053,NULL,56410454082,881413345,13772083,16.1),(130147,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130147,37.19,0.46,274,60209,70,NULL,NULL,'2MASX J15271200+2103324',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.39',0.13,NULL,NULL,NULL,NULL,NULL,1,231.8000417,21.05917,0.181,NULL,59444724534,928823820,14512872,18.39),(130148,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130148,37.11,0.13,265,60210,70,NULL,NULL,'2MASX J15271256+2843313',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'14.9R',0.24,NULL,NULL,NULL,NULL,NULL,1,231.802417,28.72533,0.041,NULL,59907275689,936051182,14625799,14.9),(130149,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130149,37.06,0.33,258,60211,70,NULL,NULL,'SDSS J152712.74+453616.3',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.803125,45.60453,0.025,NULL,59966650091,936978907,14640295,16.5),(130150,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130150,36.95,0.33,245,60212,70,NULL,NULL,'2MASX J15271343+2734503',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.805833,27.58061,0.081,NULL,59900847981,935950749,14624230,18.2),(130151,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130151,38.31,0.46,460,60213,70,NULL,NULL,'2MASX J15271349+3806439',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.806,38.11211,0.029,NULL,60111729871,939245779,14675715,17.3),(130152,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130152,36.95,0.33,245,60214,70,NULL,NULL,'SDSS J152714.62+273612.5',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.41,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.810916667,27.6035,0.061,NULL,59900849735,935950777,14624230,16),(130153,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130153,35.96,0.46,155,60215,70,NULL,NULL,'IC 4547',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000067,NULL,'15.1g',0.59,'E',NULL,NULL,NULL,NULL,1,231.8127917,28.78897,0.041,NULL,59907263231,936050987,14625796,15.1),(130154,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130154,37.57,0.46,327,60216,70,NULL,NULL,'2MASX J15271590+2200414',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,231.816083333,22.01167,0.169,NULL,59418617275,928415894,14506498,17.4),(130155,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130155,38.02,0.23,403,60217,70,NULL,NULL,'SDSS J152715.91+025200.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.816333,2.86683,0.113,NULL,56431657061,881744641,13777260,18.4),(130156,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130156,38.18,0.46,432,60218,70,NULL,NULL,'2MASX J15271639+1823194',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.818375,18.38867,0.173,NULL,59436760020,928699375,14510927,18.3),(130157,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130157,37.48,0.46,314,60219,70,NULL,NULL,'2MASX J15271650+0650525',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,231.818833333,6.84794,0.077,NULL,56411185822,881424778,13772262,16.8),(130158,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130158,35.38,0.33,119,60220,70,NULL,NULL,'2MASX J15271824+2640283',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000087,NULL,'16.34',0.22,NULL,NULL,NULL,NULL,NULL,1,231.8260417,26.6745,0.137,NULL,59902178031,935971531,14624555,16.34),(130159,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130159,35.31,0.2,115,60221,74.4,NULL,NULL,'UGC 09860',NULL,'2013AJ....146...86T',2013,1,1.22,NULL,'G',0.000033,NULL,'15.8g',0.29,'Scd:',NULL,NULL,NULL,NULL,1,231.8277917,30.98258,0.029,NULL,59915357606,936177462,14627772,15.8),(130160,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130160,35.39,0.49,119,60221,75,NULL,'IR','UGC 09860',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130161,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130161,37.46,0.46,311,60222,70,NULL,NULL,'2MASX J15272017+1618003',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.834167,16.30017,0.113,NULL,59435288554,928676383,14510568,17),(130162,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130162,37.74,0.46,353,60223,70,NULL,NULL,'2MASX J15272222+3214378',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.84275,32.24383,0.025,NULL,59912169460,936127647,14626994,18.1),(130163,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130163,36.87,0.46,237,60224,70,NULL,NULL,'2MASX J15272259+1242313',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,231.84425,12.70864,0.105,NULL,59562757689,930668088,14541688,17.5),(130164,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130164,38.1,0.46,417,60225,70,NULL,NULL,'2MASX J15272460+4227308',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.852667,42.45858,0.089,NULL,59977612412,937150193,14642971,18.5),(130165,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130165,38.02,0.46,402,60226,70,NULL,NULL,'SDSS J152724.67+060444.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.852833,6.07889,0.057,NULL,56428088878,881688888,13776388,18.5),(130166,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130166,37.87,0.33,375,60227,70,NULL,NULL,'SDSS J152724.88+031401.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.8537083,3.23386,0.093,NULL,56436170462,881815163,13778361,18),(130167,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130167,37.25,0.46,281,60228,70,NULL,NULL,'2MASX J15272600+0301188',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.858417,3.02189,0.109,NULL,56431633874,881744279,13777254,16.9),(130168,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130168,38.02,0.23,403,60229,70,NULL,NULL,'2MASX J15272607+0302358',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000095,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.85875,3.04319,0.109,NULL,56431633494,881744273,13777254,16.5),(130169,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130169,37.61,0.12,333,60230,70,NULL,NULL,'2MASX J15272704+5247219',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,231.8622083,52.78961,0.029,NULL,59674125098,932408204,14568878,17),(130170,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130170,38.02,0.23,403,60231,70,NULL,NULL,'SDSS J152726.93+025943.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000073,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,231.86225,2.99556,0.113,NULL,56431635040,881744297,13777254,18.5),(130171,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130171,36.28,0.27,181,60232,70,NULL,NULL,'2MASX J15272711+0606338',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.8629583,6.10925,0.057,NULL,56428085961,881688843,13776388,16.6),(130172,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130172,37.11,0.13,265,60233,70,NULL,NULL,'2MASX J15272785+2842016',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000087,NULL,'15.7g',0.41,NULL,NULL,NULL,NULL,NULL,1,231.866125,28.70056,0.041,NULL,59907265968,936051030,14625797,15.7),(130173,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130173,37.35,0.33,295,60234,70,NULL,NULL,'2MASX J15272868+4921059',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000192,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,231.86975,49.35189,0.053,NULL,59667826654,932309791,14567340,16.1),(130174,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130174,38.07,0.46,410,60235,70,NULL,NULL,'2MASX J15272885+1045329',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,231.87025,10.759,0.085,NULL,59344612912,927259576,14488430,17.7),(130175,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130175,36.56,0.46,205,60236,70,NULL,NULL,'2MASX J15272933+3046419',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000164,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.8722083,30.77833,0.041,NULL,59915341189,936177206,14627768,16.6),(130176,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130176,35.86,0.33,149,60237,70,NULL,NULL,'2MASX J15272935+2131245',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.17',0.25,NULL,NULL,NULL,NULL,NULL,1,231.872417,21.52353,0.165,NULL,59443823075,928809735,14512652,17.17),(130177,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130177,38.24,0.46,444,60238,70,NULL,NULL,'2MASX J15273107+1848135',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000186,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.879583,18.80386,0.181,NULL,59445352910,928833639,14513025,17.3),(130178,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130178,37.11,0.13,265,60239,70,NULL,NULL,'2MASX J15273131+2852456',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.0g',0.25,'E',NULL,NULL,NULL,NULL,1,231.880375,28.87944,0.041,NULL,59905194270,936018660,14625291,17),(130179,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130179,38.02,0.23,403,60240,70,NULL,NULL,'SDSS J152731.79+030258.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000075,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.8825,3.04972,0.109,NULL,56431634160,881744283,13777254,18.8),(130180,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130180,37.11,0.13,265,60241,70,NULL,NULL,'CGCG 165-060',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,231.883125,28.39528,0.041,NULL,59907461062,936054079,14625844,15.7),(130181,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130181,38.06,0.46,409,60242,70,NULL,NULL,'2MASX J15273314-0137445',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.888083,-1.62906,0.265,NULL,45404975132,709452736,11085199,17.9),(130182,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130182,38.1,0.46,416,60243,70,NULL,NULL,'2MASX J15273429-0211405',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.893,-2.19472,0.349,NULL,45422687490,709729492,11089523,18.2),(130183,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130183,36.31,0.23,183,60244,70,NULL,NULL,'2MASX J15273443+0933409',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,231.8935417,9.56142,0.069,NULL,56406198041,881346844,13771044,16.1),(130184,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130184,37.58,0.46,327,60245,70,NULL,NULL,'2MASX J15273527+3223370',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.896958333,32.39353,0.057,NULL,59912069773,936126090,14626970,17.4),(130185,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130185,36.55,0.46,204,60246,70,NULL,NULL,'2MASX J15273564+1834205',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,231.898625,18.57239,0.177,NULL,59435662235,928682222,14510659,17.4),(130186,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130186,36.83,0.46,232,60247,70,NULL,NULL,'VII Zw 604',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,231.898667,57.85725,0,NULL,57591639028,899869359,14060458,16.7),(130187,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130187,37.28,0.46,286,60248,70,NULL,NULL,'2MASX J15273705+1129299',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,231.9045,11.49167,0.077,NULL,59344822609,927262853,14488482,17.1),(130188,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130188,37.31,0.23,289,60249,70,NULL,NULL,'2MASX J15273777+2550057',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000177,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,231.907333,25.83492,0.157,NULL,59902464518,935976008,14624625,16),(130189,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130189,37.11,0.13,265,60250,70,NULL,NULL,'2MASX J15273947+2846527',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0001,NULL,'18.75',0.15,NULL,NULL,NULL,NULL,NULL,1,231.9145417,28.78117,0.041,NULL,59907272531,936051133,14625798,18.75),(130190,'Tully est','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130190,32.87,0.8,37.5,60251,75,NULL,NULL,'ESO 042- G 007',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000013,NULL,'13.8b',2.5,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,231.915667,-73.94444,0.501,NULL,44110962199,689233784,10769277,13.8),(130191,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130191,36.96,0.46,247,60252,70,NULL,NULL,'SDSS J152741.60+064812.7',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',NULL,NULL,'18.2g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.923333,6.80356,0.077,NULL,56411176652,881424635,13772259,18.2),(130192,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130192,35.86,0.33,149,60253,70,NULL,NULL,'2MASX J15274168+2132434',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,231.9235417,21.54533,0.165,NULL,59443817389,928809646,14512650,16.7),(130193,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130193,37.31,0.23,289,60254,70,NULL,NULL,'2MASX J15274325+2551527',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,231.930291667,25.86464,0.177,NULL,59902466433,935976038,14624625,17.8),(130194,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130194,37.89,0.23,379,60255,70,NULL,NULL,'SDSS J152743.64+033807.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000068,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.931875,3.63531,0.093,NULL,56436075397,881813678,13778338,18.5),(130195,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130195,37.34,0.35,276,60256,60,NULL,'ABELL 2079, BCG','UGC 09861 NED02',0.0657,'1980ApJ...241..486H',1980,1,0.15,NULL,'G',0.000067,NULL,'13.3R',0.15,'E','Pair member (points to parent)',NULL,NULL,NULL,1,231.938167,28.92889,0.041,NULL,59905184831,936018512,14625289,13.3),(130196,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130196,37.98,0.46,395,60257,70,NULL,NULL,'SDSS J152745.21+191202.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.938417,19.20069,0.173,NULL,59445583842,928837247,14513081,18.5),(130197,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130197,37.26,0.23,284,60258,70,NULL,NULL,'2MASX J15274583+0253508',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000062,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.9410417,2.8975,0.113,NULL,56431665141,881744767,13777261,17),(130198,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130198,38.27,0.46,450,60259,70,NULL,NULL,'2MASX J15274682+1857157',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,231.945083,18.95444,0.153,NULL,59445372185,928833940,14513030,18.2),(130199,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130199,37.29,0.46,288,60260,70,NULL,NULL,'2MASX J15274783+0647029',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.949167,6.78417,0.077,NULL,56411169902,881424529,13772258,16.4),(130200,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130200,36.92,0.33,242,60261,70,NULL,NULL,'2MASX J15274864+1759129',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.952625,17.98708,0.153,NULL,59436870550,928701102,14510954,17.5),(130201,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130201,36.31,0.23,183,60262,70,NULL,NULL,'2MASX J15274870+0945539',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,231.952875,9.76511,0.065,NULL,59343184453,927237257,14488082,16.9),(130202,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130202,37.9,0.17,380,60263,70,NULL,NULL,'SDSS J152748.86+045455.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.953625,4.91542,0.093,NULL,56437275930,881832436,13778631,18),(130203,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130203,37.89,0.23,379,60264,70,NULL,NULL,'2MASX J15274899+0331328',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000091,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.954083333,3.52581,0.093,NULL,56436109918,881814217,13778347,18.1),(130204,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130204,36.15,0.33,170,60265,70,NULL,NULL,'CGCG 049-167',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000083,NULL,'15.7',0.43,'AGN',NULL,NULL,NULL,NULL,1,231.954917,4.85678,0.093,NULL,56437271797,881832371,13778630,15.7),(130205,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130205,36.92,0.33,242,60266,70,NULL,NULL,'2MASX J15274930+1800177',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.955458333,18.005,0.153,NULL,59436869934,928701092,14510954,17.1),(130206,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130206,37.69,0.23,346,60267,70,NULL,NULL,'2MASX J15274946+0124448',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.956166667,1.41239,0.073,NULL,56400063691,881250995,13769546,NULL),(130207,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130207,37.44,0.46,308,60268,70,NULL,NULL,'2MASX J15274966+0338568',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000092,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.956833,3.64917,0.093,NULL,56436075980,881813687,13778338,16.8),(130208,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130208,37.44,0.27,307,60269,70,NULL,NULL,'2MASX J15275007+1009029',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,231.9585417,10.15078,0.073,NULL,59343540814,927242825,14488169,16.5),(130209,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130209,37.31,0.23,289,60270,70,NULL,NULL,'2MASX J15275051+2540317',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,231.960333333,25.67544,0.157,NULL,59902523296,935976926,14624639,16.9),(130210,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130210,37.53,0.21,320,60271,70,NULL,NULL,'2MASX J15275177+3030391',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,231.965833,30.511,0.045,NULL,59913236200,936144315,14627254,17.4),(130211,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130211,37.29,0.46,288,60272,70,NULL,NULL,'2MASX J15275215+5027209',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,231.96725,50.45569,0.037,NULL,59665386232,932271659,14566744,16.3),(130212,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130212,37.9,0.17,380,60273,70,NULL,NULL,'2MASX J15275240+0453408',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,231.968375,4.89469,0.093,NULL,56437276247,881832441,13778631,NULL),(130213,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130213,37.45,0.33,310,60274,70,NULL,NULL,'SDSS J152752.40+075236.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.968375,7.87694,0.069,NULL,56420002961,881562546,13774414,18.1),(130214,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130214,37.79,0.46,361,60275,70,NULL,NULL,'SDSS J152754.34+263302.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.7g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.9764583,26.55064,0.157,NULL,59902882355,935982536,14624727,17.7),(130215,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130215,37.46,0.46,311,60276,70,NULL,NULL,'2MASX J15275572+0203408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,231.982417,2.06133,0.077,NULL,56431849211,881747643,13777306,17.4),(130216,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130216,37.38,0.33,300,60277,70,NULL,NULL,'2MASX J15275619+4657368',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,231.984291667,46.96028,0.013,NULL,59685191045,932581110,14571579,16.9),(130217,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130217,37.9,0.17,380,60278,70,NULL,NULL,'SDSS J152756.84+050052.9',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.0g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.986833,5.01469,0.101,NULL,56437487249,881835738,13778683,16),(130218,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130218,37.89,0.23,379,60279,70,NULL,NULL,'2MASX J15275707+0322268',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000101,NULL,'15.9g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,231.987625,3.37414,0.093,NULL,56436132281,881814566,13778352,15.9),(130219,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130219,37.89,0.23,379,60280,70,NULL,NULL,'2MASX J15275720+0326518',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000107,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,231.98825,3.44761,0.093,NULL,56436099345,881814052,13778344,16.4),(130220,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130220,37.9,0.17,380,60281,70,NULL,NULL,'2MASX J15275735+0450398',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,231.9890417,4.84447,0.093,NULL,56437152644,881830510,13778601,18.4),(130221,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130221,37.9,0.17,380,60282,70,NULL,NULL,'2MASX J15275809+0508398',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,231.991916667,5.14453,0.101,NULL,56437497497,881835898,13778685,18),(130222,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130222,37.9,0.17,380,60283,70,NULL,NULL,'SDSS J152758.99+050349.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'17.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,231.995833,5.06386,0.101,NULL,56437486190,881835721,13778683,17.9),(130223,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130223,34.1,0.56,66,60284,NULL,NULL,NULL,'ESO 329- G 004',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'13.19',0.6,'Sb',NULL,NULL,NULL,NULL,1,232.0009583,-40.3535,0.381,NULL,47062049593,735344524,11489758,13.19),(130224,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130224,34.14,0.2,67.3,60284,74.4,NULL,NULL,'ESO 329- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130225,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130225,34.3,0.51,72.4,60284,NULL,NULL,'Malmquist cor.','ESO 329- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130226,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130226,37.45,0.33,310,60285,70,NULL,NULL,'2MASX J15280053+0752488',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00014,NULL,'15.6g',0.45,NULL,NULL,NULL,NULL,NULL,1,232.00225,7.88033,0.069,NULL,56419970304,881562036,13774406,15.6),(130227,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130227,30.3,0.8,11.5,60286,75,NULL,'A82, H','NGC 5949',NULL,'1997ApJS..109..333W',1997,1,2.27,'The 2MASS position is 5 arcsec northwest of the center of the optical bulge.','G',0.000003,NULL,'12.5g',0.94,'SA(r)bc?','Isolated galaxy',NULL,NULL,NULL,1,232.0027917,64.76319,0.065,NULL,57958441009,905600640,14150010,12.5),(130228,'IRAS','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130228,30.41,0.8,12.1,60286,75,NULL,'CF, r','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130229,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130229,30.09,0.43,10.4,60286,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5949',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130230,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130230,30.13,0.39,10.6,60286,73,NULL,'opt','NGC 5949',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130231,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130231,30.19,0.4,10.9,60286,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5949',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130232,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130232,30.24,0.4,11.2,60286,75,NULL,'B','NGC 5949',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130233,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130233,30.28,0.43,11.4,60286,75,NULL,'3.6 micron, color corrected','NGC 5949',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130234,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130234,30.46,0.47,12.4,60286,75,NULL,'A82, H, inv','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130235,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130235,30.48,0.2,12.5,60286,74.4,NULL,NULL,'NGC 5949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130236,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130236,30.56,0.47,12.9,60286,75,NULL,'A82, H, raw','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130237,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130237,30.77,0.36,14.3,60286,NULL,NULL,NULL,'NGC 5949',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130238,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130238,30.81,0.34,14.5,60286,NULL,NULL,NULL,'NGC 5949',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130239,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130239,30.83,0.47,14.7,60286,75,NULL,'A82, H, cor','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130240,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130240,30.89,0.33,15.1,60286,NULL,NULL,'Malmquist cor.','NGC 5949',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130241,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130241,31.27,0.38,18,60286,75,NULL,'CF, r, raw','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130242,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130242,31.28,0.38,18.1,60286,75,NULL,'CF, r, inv','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130243,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130243,31.46,0.38,19.6,60286,75,NULL,'CF, r, cor','NGC 5949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130244,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130244,37.11,0.13,265,60287,70,NULL,NULL,'SDSS J152801.26+285649.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.0052917,28.94719,0.037,NULL,59905210643,936018916,14625295,18.1),(130245,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130245,37.69,0.23,346,60288,70,NULL,NULL,'2MASX J15280126+0129338',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.52',0.4,NULL,NULL,NULL,NULL,NULL,1,232.005375,1.49264,0.073,NULL,56400053729,881250839,13769544,16.52),(130246,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130246,37.35,0.33,295,60289,70,NULL,NULL,'2MASX J15280166+4922172',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.006875,49.37136,0.053,NULL,59667845126,932310080,14567345,16.7),(130247,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130247,34.57,0.58,81.9,60290,NULL,NULL,NULL,'ESO 514- G 019',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.41',0.3,'S...',NULL,NULL,NULL,NULL,1,232.010417,-26.50189,0.465,NULL,47139696327,736557755,11508714,16.41),(130248,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130248,34.59,0.58,82.6,60290,NULL,NULL,'Malmquist cor.','ESO 514- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130249,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130249,34.61,0.2,83.6,60290,74.4,NULL,NULL,'ESO 514- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130250,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130250,37.11,0.13,265,60291,70,NULL,NULL,'2MASX J15280254+2856386',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000067,NULL,'16.3g',0.32,'E',NULL,NULL,NULL,NULL,1,232.0107083,28.94411,0.037,NULL,59905211687,936018932,14625295,16.3),(130251,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130251,38.15,0.46,427,60292,70,NULL,NULL,'2MASX J15280333+4248493',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000207,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.013916667,42.81364,0.085,NULL,59977114539,937142414,14642850,16.6),(130252,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130252,37.06,0.33,258,60293,70,NULL,NULL,'2MASX J15280448+4538283',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.018667,45.64128,0,NULL,59966704750,936979761,14640308,17.1),(130253,'BCG','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130253,37.34,0.35,276,60294,60,NULL,NULL,'ABELL 2079',0.0657,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000731,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,232.0197083,28.87772,0.041,NULL,59905203867,936018810,14625293,NULL),(130254,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130254,35.97,0.46,156,60295,70,NULL,NULL,'2MASX J15280499+0544278',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',NULL,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,232.020625,5.74117,0.065,NULL,56436480087,881820001,13778437,15.6),(130255,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130255,37.26,0.23,284,60296,70,NULL,NULL,'2MASX J15280514+0254038',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000088,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.0215417,2.90089,0.109,NULL,56432139723,881752183,13777377,16.8),(130256,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130256,37.38,0.33,300,60297,70,NULL,NULL,'2MASX J15280625+4656413',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.026083333,46.94486,0.013,NULL,59685181990,932580968,14571577,17.6),(130257,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130257,37.17,0.46,271,60298,70,NULL,NULL,'2MASX J15280663+2921386',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.027583,29.36086,0.045,NULL,59912636769,936134949,14627108,17.7),(130258,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130258,37.33,0.46,293,60299,70,NULL,NULL,'2MASX J15280798+5508408',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000172,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.033375,55.14456,0.037,NULL,57595056778,899922762,14061293,16.9),(130259,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130259,36.31,0.23,183,60300,70,NULL,NULL,'2MASX J15281016+0952198',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000185,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,232.042375,9.87228,0.097,NULL,59343178548,927237164,14488080,15.9),(130260,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130260,38.03,0.46,404,60301,70,NULL,NULL,'2MASX J15281042+0551108',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.043417,5.85303,0.065,NULL,56436485187,881820081,13778438,17.6),(130261,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130261,37.26,0.23,284,60302,70,NULL,NULL,'2MASX J15281109+0256578',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.046291667,2.94939,0.109,NULL,56432138287,881752160,13777377,17.8),(130262,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130262,37.73,0.46,352,60303,70,NULL,NULL,'2MASX J15281118+0350488',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.0464583,3.84697,0.097,NULL,56435751803,881808621,13778259,17.3),(130263,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130263,38.27,0.46,452,60304,70,NULL,NULL,'SDSS J152812.82-000929.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.0534583,-0.15822,0.225,NULL,45406754265,709480535,11085633,18),(130264,'FP','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,'R',130264,35.65,0.46,135,60305,70,NULL,NULL,'MRK 0855',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.5',0.3,'Compact',NULL,NULL,NULL,NULL,1,232.075166667,15.38503,0.097,NULL,59427041483,928547523,14508555,15.5),(130265,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130265,35.09,NULL,104,60306,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1906',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000017,NULL,'16.9g',0.11,'Sd',NULL,NULL,NULL,NULL,1,232.078625,49.121,0.045,NULL,59664338542,932255289,14566488,16.9),(130266,'Tully-Fisher','2016-12-15 15:15:34','2016-12-16 11:20:48','1',NULL,NULL,130266,35.11,NULL,105,60306,NULL,NULL,'Dipole + Quadrupole','FGC 1906',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130267,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130267,35.12,NULL,106,60306,NULL,NULL,'Dipole','FGC 1906',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130268,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130268,35.13,NULL,106,60306,NULL,NULL,NULL,'FGC 1906',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130269,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130269,37.11,0.13,265,60307,70,NULL,NULL,'2MASX J15281930+2858126',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.080375,28.97031,0.037,NULL,59905207142,936018861,14625294,17.4),(130270,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130270,37.26,0.23,284,60308,70,NULL,NULL,'2MASX J15282113+0300109',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.088125,3.00303,0.109,NULL,56432135723,881752120,13777376,16.8),(130271,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130271,38.13,0.27,423,60309,70,NULL,NULL,'2MASX J15282375+3030276',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.098916667,30.50781,0.045,NULL,59913194566,936143665,14627244,18),(130272,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130272,37.22,0.46,278,60310,70,NULL,NULL,'2MASX J15282402+5450149',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.100166667,54.83756,0.041,NULL,57585845626,899778837,14059044,17.4),(130273,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130273,37.61,0.12,333,60311,70,NULL,NULL,'2MASX J15282541+5249342',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000195,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.1060417,52.82617,0.029,NULL,59674098629,932407791,14568871,16.4),(130274,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130274,37.09,0.46,262,60312,70,NULL,NULL,'2MASX J15282586+3215366',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.10775,32.26025,0.061,NULL,59912211143,936128299,14627004,16.8),(130275,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130275,38.13,0.27,423,60313,70,NULL,NULL,'2MASX J15282592+3031147',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.1080417,30.52081,0.045,NULL,59913194156,936143658,14627244,17.1),(130276,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130276,37.11,0.13,265,60314,70,NULL,NULL,'2MASX J15282650+2841096',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000123,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.110583333,28.68589,0.041,NULL,59907254877,936050857,14625794,17.5),(130277,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130277,37.53,0.21,320,60315,70,NULL,NULL,'2MASX J15282737+3034174',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.113833,30.57164,0.045,NULL,59913200667,936143760,14627246,17.3),(130278,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130278,36.68,0.46,216,60316,70,NULL,NULL,'2MASX J15283001+1428150',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.125041667,14.47097,0.125,NULL,59560812685,930637698,14541214,17.1),(130279,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130279,37.53,0.21,320,60317,70,NULL,NULL,'2MASX J15283008+3021185',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000188,NULL,'16.0g',0.47,NULL,NULL,NULL,NULL,NULL,1,232.12525,30.35511,0.045,NULL,59913189161,936143580,14627243,16),(130280,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130280,37.17,0.46,272,60318,70,NULL,NULL,'2MASX J15283034+3056035',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00014,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.126417,30.93417,0.029,NULL,59915194863,936174919,14627733,17.1),(130281,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130281,38.1,0.46,417,60319,70,NULL,NULL,'2MASX J15283063+0558399',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.1277083,5.97783,0.057,NULL,56436464191,881819752,13778433,17.9),(130282,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130282,38.13,0.27,423,60320,70,NULL,NULL,'2MASX J15283125+3032355',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.130083333,30.54331,0.045,NULL,59913205689,936143838,14627247,18.2),(130283,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130283,37.89,0.46,379,60321,70,NULL,NULL,'2MASX J15283145+1705280',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.131208333,17.09119,0.117,NULL,59436590537,928696727,14510886,17),(130284,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130284,37.88,0.46,377,60322,70,NULL,NULL,'2MASX J15283155+5850379',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000199,NULL,'16.0g',0.43,'S0',NULL,NULL,NULL,NULL,1,232.1314583,58.84394,0.021,NULL,57717968857,901843263,14091300,16),(130285,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130285,37.47,0.23,312,60323,70,NULL,NULL,'2MASX J15283216+2818174',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.48',0.17,NULL,NULL,NULL,NULL,NULL,1,232.1340417,28.30492,0.041,NULL,59900142998,935939734,14624058,18.48),(130286,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130286,37.11,0.13,265,60324,70,NULL,NULL,'2MASX J15283150+2900165',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000153,NULL,'15.7g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.137,29.0025,0.037,NULL,59905204969,936018827,14625294,15.7),(130287,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130287,37.61,0.12,333,60325,70,NULL,NULL,'SDSS J152832.99+525139.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,232.1375,52.86103,0.029,NULL,59674158234,932408722,14568886,18.4),(130288,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130288,37.38,0.33,299,60326,70,NULL,NULL,'2MASX J15283335+0710269',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.139125,7.17408,0.101,NULL,56418224335,881534755,13773980,16.3),(130289,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130289,37.38,0.33,299,60327,70,NULL,NULL,'2MASX J15283369+0713269',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.140375,7.22428,0.101,NULL,56418193873,881534279,13773973,17.2),(130290,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130290,37.48,0.33,313,60328,70,NULL,NULL,'2MASX J15283529+3433446',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.146917,34.56242,0.049,NULL,59884460852,935694700,14620229,17),(130291,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130291,36.44,0.46,195,60329,70,NULL,NULL,'2MASX J15283524+0440349',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,232.147,4.67636,0.093,NULL,56437196976,881831202,13778612,16.3),(130292,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130292,37.54,0.46,323,60330,70,NULL,NULL,'2MASX J15283541+5059072',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.147583333,50.98531,0.041,NULL,59672905254,932389144,14568580,17.3),(130293,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130293,38.01,0.33,401,60331,70,NULL,NULL,'2MASX J15283565+0007079',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.148667,0.11894,0.225,NULL,56398195875,881221810,13769090,18.2),(130294,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130294,37.47,0.23,312,60332,70,NULL,NULL,'2MASX J15283799+2819594',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'18.03',0.18,NULL,NULL,NULL,NULL,NULL,1,232.158375,28.33328,0.041,NULL,59900143307,935939739,14624058,18.03),(130295,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130295,37.75,0.19,354,60333,70,NULL,NULL,'2MASX J15283867+0145019',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.161125,1.75042,0.077,NULL,56399223441,881237866,13769341,18.1),(130296,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130296,38.08,0.46,413,60334,70,NULL,NULL,'2MASX J15283903+0300529',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000082,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.1627083,3.01464,0.109,NULL,56431283432,881738803,13777168,18.4),(130297,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130297,37.87,0.15,376,60335,70,NULL,NULL,'2MASX J15284000-0008074',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.166583333,-0.13539,0.217,NULL,45405708017,709464187,11085377,17.4),(130298,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130298,36.63,0.46,212,60336,70,NULL,NULL,'2MASX J15284174+0510549',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.174041667,5.18206,0.109,NULL,56437366210,881833847,13778653,17.2),(130299,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130299,37.69,0.46,345,60337,70,NULL,NULL,'2MASX J15284232+0015409',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'FoF','17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.176333,0.26139,0.225,NULL,56400309632,881254838,13769606,17.4),(130300,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130300,38.81,0.46,578,60338,70,NULL,NULL,'SDSS J152843.08+062603.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.1795417,6.43425,0.073,NULL,56417632173,881525502,13773835,18.6),(130301,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130301,36.21,0.47,175,60339,NULL,NULL,'H','CGCG 049-171 NED01',NULL,'2007A&A...465...71T',2007,1,1.05,NULL,'G',0.000011,NULL,'15.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.1832917,7.38797,0.097,NULL,56418365934,881536967,13774015,15.1),(130302,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130302,36.29,0.4,181,60339,NULL,NULL,'mean','CGCG 049-171 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130303,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130303,38.04,0.23,405,60340,70,NULL,NULL,'2MASX J15284491+3044546',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.18725,30.74842,0.041,NULL,59915230589,936175477,14627741,17.9),(130304,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130304,37.35,0.46,295,60341,70,NULL,NULL,'VII Zw 605',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.188875,57.60239,0.005,NULL,57591978342,899874661,14060541,17.2),(130305,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130305,36.94,0.33,245,60342,70,NULL,NULL,'2MASX J15284605+4549245',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.1919583,45.8235,0,NULL,59966735935,936980248,14640316,17.6),(130306,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130306,36.16,0.2,171,60343,74.4,NULL,NULL,'CGCG 135-059',NULL,'2013AJ....146...86T',2013,1,0.99,NULL,'G',0.000178,NULL,'15.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,232.197,25.74781,0.157,NULL,59902370801,935974543,14624602,15.7),(130307,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130307,37.53,0.21,320,60344,70,NULL,NULL,'2MASX J15284787+3010017',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.199625,30.16703,0.045,NULL,59913506506,936148539,14627320,16.7),(130308,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130308,37.48,0.33,313,60345,70,NULL,NULL,'2MASX J15284823+3437577',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.0002,NULL,'16.1g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,232.201167,34.63278,0.049,NULL,59884678635,935698103,14620282,16.1),(130309,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130309,37.66,0.46,341,60346,70,NULL,NULL,'2MASX J15284866+2213063',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.52',0.14,NULL,NULL,NULL,NULL,NULL,1,232.202791667,22.21853,0.157,NULL,59451330091,928927032,14514484,18.52),(130310,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130310,34.95,0.47,97.7,60347,70,NULL,NULL,'2MASX J15284955-2112248',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,232.2064583,-21.20694,0.473,NULL,46625052302,728516442,11383069,14),(130311,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130311,37.61,0.12,333,60348,70,NULL,NULL,'2MASX J15284976+5251589',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.207083,52.86631,0.029,NULL,59674162860,932408794,14568887,17.2),(130312,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130312,37.9,0.17,380,60349,70,NULL,NULL,'2MASX J15285006+0513296',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.2085417,5.22489,0.109,NULL,56437320180,881833127,13778642,17),(130313,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130313,35.95,0.46,155,60350,70,NULL,NULL,'CGCG 021-101',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000108,NULL,'15.4g',0.54,'E0',NULL,NULL,NULL,NULL,1,232.209291667,0.77722,0.113,NULL,56400561125,881258767,13769668,15.4),(130314,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130314,37.53,0.21,320,60351,70,NULL,NULL,'2MASX J15285033+3012447',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.209708333,30.21233,0.045,NULL,59913503291,936148488,14627320,17.2),(130315,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130315,37.24,0.46,281,60352,70,NULL,NULL,'2MASX J15285103+0312556',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.21275,3.21531,0.105,NULL,56436268407,881816693,13778385,16.8),(130316,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130316,38.01,0.33,401,60353,70,NULL,NULL,'2MASX J15285299+0009326',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,232.2207083,0.15911,0.225,NULL,56398240415,881222506,13769101,17.3),(130317,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130317,38.04,0.23,405,60354,70,NULL,NULL,'2MASX J15285304+3050367',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.221,30.84353,0.029,NULL,59915239074,936175610,14627743,17.7),(130318,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130318,36.95,0.46,246,60355,70,NULL,NULL,'2MASX J15285322-0209211',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.2217083,-2.15589,0.305,NULL,45404995090,709453048,11085203,17.3),(130319,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130319,36.94,0.33,245,60356,70,NULL,NULL,'2MASX J15285351+4548216',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.2230417,45.80611,0,NULL,59966726885,936980107,14640314,17.2),(130320,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130320,37.01,0.46,253,60357,70,NULL,NULL,'2MASX J15285375+1458061',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.224,14.96828,0.101,NULL,59427125886,928548841,14508575,NULL),(130321,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130321,36.96,0.46,247,60358,70,NULL,NULL,'2MASX J15285377+5910119',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000196,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,232.224,59.16994,0.017,NULL,57772380858,902693450,14104585,16),(130322,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130322,37.87,0.15,376,60359,70,NULL,NULL,'2MASX J15285396-0018221',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.224666667,-0.30617,0.253,NULL,45406796657,709481197,11085643,18.1),(130323,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130323,37.69,0.23,346,60360,70,NULL,NULL,'SDSS J152853.94+013203.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.2247917,1.53431,0.093,NULL,56399073878,881235529,13769305,18),(130324,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130324,37.83,0.46,368,60361,70,NULL,NULL,'2MASX J15285403+1412071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.2252083,14.20206,0.121,NULL,59560943578,930639743,14541245,17.1),(130325,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130325,37.69,0.23,346,60362,70,NULL,NULL,'2MASX J15285452+0127516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.22725,1.46447,0.093,NULL,56400211551,881253305,13769582,16.9),(130326,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130326,31.4,0.8,19.1,60363,75,NULL,NULL,'ESO 274- G 016',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000013,NULL,'15.06',0.9,'IB(s)m',NULL,NULL,NULL,NULL,1,232.230167,-42.78217,0.617,NULL,47074080633,735532509,11492695,15.06),(130327,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130327,37.62,0.33,335,60364,70,NULL,NULL,'2MASX J15285562+0625466',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.231875,6.42956,0.073,NULL,56417627050,881525422,13773834,17.4),(130328,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130328,38.04,0.23,405,60365,70,NULL,NULL,'2MASX J15285615+3045527',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000124,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.233833,30.76475,0.041,NULL,59915228843,936175450,14627741,18.7),(130329,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130329,37.62,0.33,335,60366,70,NULL,NULL,'2MASX J15285615+0627066',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.234083,6.45175,0.073,NULL,56417628035,881525438,13773834,16.3),(130330,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130330,37.47,0.23,312,60367,70,NULL,NULL,'SDSS J152856.42+281722.4',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.5g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.235125,28.28956,0.065,NULL,59900150263,935939847,14624060,16.5),(130331,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130331,37.47,0.23,312,60368,70,NULL,NULL,'2MASX J15285639+2817223',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.97',0.18,NULL,NULL,NULL,NULL,NULL,1,232.241916667,28.28794,0.065,NULL,59900150101,935939845,14624060,17.97),(130332,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130332,37.75,0.19,354,60369,70,NULL,NULL,'SDSS J152858.53+013048.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.243875,1.51342,0.093,NULL,56400208099,881253251,13769582,18.1),(130333,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130333,37.53,0.63,321,60370,70,NULL,NULL,'2MASX J15285858-1335558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.10',NULL,NULL,NULL,NULL,NULL,NULL,1,232.2440417,-13.59878,0.577,NULL,46661092818,729079575,11391868,16.1),(130334,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130334,38.51,0.46,503,60371,70,NULL,NULL,'2MASX J15285900+3721292',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.2457917,37.35803,0.045,NULL,60110066767,939219793,14675309,18),(130335,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130335,37.34,0.46,294,60372,70,NULL,NULL,'2MASX J15285913+5313070',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.24625,53.21853,0.033,NULL,59674051239,932407050,14568860,16.7),(130336,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130336,37.75,0.19,354,60373,70,NULL,NULL,'2MASX J15285992+0140286',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.249583,1.67453,0.077,NULL,56399088823,881235762,13769308,16.5),(130337,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130337,37.75,0.19,354,60374,70,NULL,NULL,'2MASX J15290032+0156336',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.2512083,1.94283,0.081,NULL,56399144407,881236631,13769322,16.8),(130338,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130338,37.61,0.12,333,60375,70,NULL,NULL,'2MASX J15290047+5252450',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000157,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.2520417,52.87917,0.029,NULL,59674165029,932408828,14568887,16.8),(130339,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130339,37.69,0.46,344,60376,70,NULL,NULL,'SDSS J152900.64+171530.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.2527083,17.2585,0.129,NULL,59436688946,928698264,14510910,18.3),(130340,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130340,37.75,0.19,354,60377,70,NULL,NULL,'2MASX J15290112+0149156',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.254583,1.82111,0.077,NULL,56399181513,881237211,13769331,17.6),(130341,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130341,38.04,0.23,405,60378,70,NULL,NULL,'2MASX J15290137+3046204',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00021,NULL,'16.1g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,232.255625,30.77236,0.041,NULL,59915228993,936175453,14627741,16.1),(130342,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130342,37.72,0.46,349,60379,70,NULL,NULL,'SDSS J152901.69+032740.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.257041667,3.46122,0.105,NULL,56436403848,881818810,13778418,18.1),(130343,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130343,37.61,0.12,333,60380,70,NULL,NULL,'2MASX J15290195+5243130',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.258333,52.72022,0.029,NULL,59676049444,932438272,14569348,17.8),(130344,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130344,37.58,0.46,328,60381,70,NULL,NULL,'2MASX J15290289+2453295',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.261958333,24.8915,0.141,NULL,59416824433,928387881,14506060,17.5),(130345,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130345,37.45,0.46,309,60382,70,NULL,NULL,'2MASX J15290311+3039354',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.4g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.2627917,30.65981,0.041,NULL,59913149940,936142967,14627233,16.4),(130346,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130346,35.39,0.46,119,60383,70,NULL,NULL,'2MASX J15290323+1715521',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.91',0.26,NULL,NULL,NULL,NULL,NULL,1,232.263416667,17.26442,0.129,NULL,59436689102,928698267,14510910,16.91),(130347,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130347,35.85,0.2,148,60384,74.4,NULL,NULL,'CGCG 135-060',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000027,NULL,'14.8g',0.65,'SB?',NULL,NULL,NULL,NULL,1,232.265875,25.45822,0.157,NULL,59899416259,935928379,14623880,14.8),(130348,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130348,37.2,0.27,275,60385,70,NULL,NULL,'SDSS J152906.86+294039.8',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000197,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.278583,29.67772,0.057,NULL,59912664332,936135380,14627115,16.5),(130349,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130349,37.2,0.27,275,60386,70,NULL,NULL,'2MASX J15290757+2940115',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.22,'E',NULL,NULL,NULL,NULL,1,232.281667,29.66986,0.057,NULL,59912664361,936135380,14627115,17.1),(130350,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130350,37.87,0.15,376,60387,70,NULL,NULL,'2MASX J15290763-0021301',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000089,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,232.2817083,-0.35836,0.253,NULL,45406782361,709480974,11085640,18),(130351,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130351,37.61,0.12,333,60388,70,NULL,NULL,'SDSS J152908.13+524534.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,232.283916667,52.75947,0.029,NULL,59673969379,932405771,14568840,18.3),(130352,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130352,37.45,0.46,308,60389,70,NULL,NULL,'2MASX J15290839+0100036',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.2850417,1.00108,0.105,NULL,56400804504,881262570,13769727,17.1),(130353,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130353,37.68,0.46,343,60390,70,NULL,NULL,'SDSS J152909.58+284204.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.289917,28.70131,0.041,NULL,59899907115,935936048,14624000,18),(130354,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130354,36.99,0.46,251,60391,70,NULL,NULL,'2MASX J15290960+3601262',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.2899583,36.02389,0.041,NULL,60105675667,939151182,14674237,16.5),(130355,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130355,37.75,0.19,354,60392,70,NULL,NULL,'2MASX J15291012+0143516',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.292208333,1.73106,0.077,NULL,56399058005,881235281,13769301,17.6),(130356,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130356,37.87,0.15,376,60393,70,NULL,NULL,'2MASX J15291103-0012201',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.296,-0.20558,0.237,NULL,45405722268,709464410,11085381,16.8),(130357,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130357,37.61,0.12,333,60394,70,NULL,NULL,'SDSS J152911.19+523914.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.296625,52.65411,0.029,NULL,59676264756,932441636,14569400,18.2),(130358,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130358,36.64,0.46,213,60395,70,NULL,NULL,'2MASX J15291199+3831082',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.300125,38.519,0.049,NULL,60099181773,939049715,14672651,16.2),(130359,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130359,37.2,0.27,275,60396,70,NULL,NULL,'CGCG 165-063',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000173,NULL,'15.5g',0.48,'E',NULL,NULL,NULL,NULL,1,232.301333,29.63953,0.057,NULL,59912664160,936135377,14627115,15.5),(130360,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130360,37.87,0.15,376,60397,70,NULL,NULL,'2MASX J15291276-0015081',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000103,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,232.303083,-0.25222,0.237,NULL,45405723247,709464425,11085381,16.2),(130361,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130361,34.96,0.49,98.3,60398,75,NULL,'IR','FGC 1905',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000099,NULL,'16.6g',0.19,'Sc             HII',NULL,NULL,NULL,NULL,1,232.30925,-1.15908,0.293,NULL,45407380473,709490319,11085786,16.6),(130362,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130362,35.73,NULL,140,60398,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130363,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130363,35.76,NULL,142,60398,NULL,NULL,'Dipole + Quadrupole','FGC 1905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130364,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130364,35.78,NULL,143,60398,NULL,NULL,'Dipole','FGC 1905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130365,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130365,35.81,0.2,145,60399,74.4,NULL,NULL,'IC 4549',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000098,NULL,'15.3g',0.36,'Sbc',NULL,NULL,NULL,NULL,1,232.3107083,32.82556,0.053,NULL,59882361499,935661898,14619717,15.3),(130366,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130366,35.58,0.46,131,60400,70,NULL,NULL,'CGCG 049-175',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000093,NULL,'15.2',0.5,NULL,'Group member',NULL,NULL,NULL,1,232.313458333,5.06003,0.109,NULL,56437097533,881829648,13778588,15.2),(130367,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130367,38.88,0.46,597,60401,70,NULL,NULL,'SDSS J152915.55+120412.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.314833,12.07008,0.105,NULL,59341456367,927210255,14487660,18.2),(130368,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130368,36.71,0.21,220,60402,70,NULL,NULL,'2MASX J15291576+0734556',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.3157917,7.58219,0.097,NULL,56418270971,881535483,13773991,17.3),(130369,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130369,37.94,0.46,387,60403,70,NULL,NULL,'SDSS J152916.39+103953.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.318333333,10.66483,0.085,NULL,59343400819,927240637,14488134,17.8),(130370,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130370,37.16,0.46,270,60404,70,NULL,NULL,'2MASX J15291809+5606470',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.325333,56.11319,0.037,NULL,57595975734,899937120,14061517,NULL),(130371,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130371,37.61,0.12,333,60405,70,NULL,NULL,'2MASX J15291948+5259451',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.331291667,52.99592,0.033,NULL,59674184857,932409138,14568892,16.8),(130372,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130372,37.61,0.12,333,60406,70,NULL,NULL,'2MASX J15291958+5253521',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000214,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.3314583,52.89783,0.033,NULL,59674156224,932408691,14568885,16.7),(130373,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130373,34.65,0.53,85,60407,70,NULL,NULL,'2MASX J15291996-2111260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.81',NULL,NULL,NULL,NULL,NULL,NULL,1,232.333125,-21.19056,0.529,NULL,46638700881,728729701,11386401,15.81),(130374,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130374,37.7,0.33,347,60408,70,NULL,NULL,'2MASX J15291994+0155104',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.333208333,1.91969,0.081,NULL,56399135575,881236493,13769320,16.8),(130375,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130375,36.2,NULL,174,60409,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1908',NULL,'2010Ap&SS.325..163P',2010,1,0.83,NULL,'G',NULL,NULL,'17.51',0.1,'Scd',NULL,NULL,NULL,NULL,1,232.3335,62.4105,0.041,NULL,57746636044,902291188,14098299,17.51),(130376,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130376,36.23,NULL,176,60409,NULL,NULL,'Dipole + Quadrupole','FGC 1908',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130377,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130377,36.23,NULL,177,60409,NULL,NULL,NULL,'FGC 1908',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130378,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130378,36.25,0.49,178,60409,75,NULL,'IR','FGC 1908',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130379,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130379,36.26,NULL,178,60409,NULL,NULL,'Dipole','FGC 1908',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130380,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130380,37.7,0.33,347,60410,70,NULL,NULL,'2MASX J15292001+0154094',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.333417,1.90247,0.081,NULL,56399167602,881236993,13769328,17.5),(130381,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130381,37.53,0.46,320,60411,70,NULL,NULL,'2MASX J15292021+2526004',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000179,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.33425,25.43361,0.157,NULL,59899593861,935931154,14623924,16.5),(130382,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130382,37.61,0.12,333,60412,70,NULL,NULL,'SDSS J152920.27+525659.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.3345,52.94978,0.033,NULL,59674183967,932409124,14568892,17.7),(130383,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130383,35.99,0.31,158,60413,NULL,NULL,'Malmquist cor.','CGCG 077-135',NULL,'2009ApJS..182..474S',2009,1,0.89,NULL,'G',0.000009,NULL,'15.7g',0.29,'Sb','Isolated galaxy',NULL,NULL,NULL,1,232.341541667,9.091,0.113,NULL,56420285791,881566965,13774483,15.7),(130384,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130384,36.11,0.29,167,60413,NULL,NULL,NULL,'CGCG 077-135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130385,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,NULL,130385,36.13,0.2,168,60413,74.4,NULL,NULL,'CGCG 077-135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130386,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130386,37.17,0.46,272,60414,70,NULL,NULL,'2MASX J15292238+4756012',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.34325,47.93356,0.041,NULL,59718672164,933104252,14579753,16.6),(130387,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130387,38.08,0.33,413,60415,70,NULL,NULL,'2MASX J15292250+3621423',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000042,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.34375,36.36175,0.057,NULL,60109768112,939215126,14675236,16.7),(130388,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130388,38.18,0.46,432,60416,70,NULL,NULL,'2MASX J15292277-0122003',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.344916667,-1.36675,0.325,NULL,45407350724,709489855,11085778,17.8),(130389,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130389,38.17,0.46,430,60417,70,NULL,NULL,'2MASX J15292287+1914259',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.3452083,19.24064,0.169,NULL,59443439714,928803745,14512558,18),(130390,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130390,37.6,0.46,330,60418,70,NULL,NULL,'2MASX J15292314+0312584',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.346375,3.21631,0.105,NULL,56435604043,881806313,13778223,17.2),(130391,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130391,33.34,0.49,46.6,60419,75,NULL,'IR','FGC 228A',NULL,'2011yCatp016004901K',2011,1,1.48,'The 2MASX position is for the southwestern arm near the companion galaxy.','G',0.000017,NULL,'15.1R',0.25,'SBcd? sp',NULL,NULL,NULL,NULL,1,232.346667,-12.2465,0.513,NULL,46657857034,729029016,11391078,15.1),(130392,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130392,37.42,0.46,304,60420,70,NULL,NULL,'2MASX J15292343+4636142',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.347625,46.60397,0.017,NULL,59685872155,932591752,14571746,16.8),(130393,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130393,37.85,0.46,372,60421,70,NULL,NULL,'2MASX J15292381+0345224',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000134,NULL,'17.2g',0.21,'NLAGN',NULL,NULL,NULL,'Sy 2',1,232.3492083,3.75622,0.113,NULL,56436344246,881817878,13778404,17.2),(130394,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130394,37.87,0.46,376,60422,70,NULL,NULL,'2MASX J15292454+3103266',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.352167,31.05733,0.029,NULL,59915483929,936179436,14627803,18.2),(130395,'FP','2016-12-15 15:15:35','2016-12-16 11:20:48','1',NULL,'R',130395,37.27,0.46,284,60423,70,NULL,NULL,'2MASX J15292486+0810318',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.353667,8.17547,0.069,NULL,56421183955,881580999,13774703,17.6),(130396,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130396,38.31,0.46,459,60424,70,NULL,NULL,'2MASX J15292508+3016266',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.3545,30.27408,0.045,NULL,59913295152,936145236,14627269,17.8),(130397,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130397,37.54,0.46,322,60425,70,NULL,NULL,'2MASX J15292514+2216189',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.3547083,22.27214,0.157,NULL,59451267445,928926053,14514469,18.1),(130398,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130398,35.76,0.46,142,60426,70,NULL,NULL,'CGCG 049-177 NED01',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'15.8g',0.26,'S0',NULL,NULL,NULL,NULL,1,232.355417,2.74297,0.081,NULL,56431417155,881740893,13777201,15.8),(130399,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130399,37.58,0.46,328,60427,70,NULL,NULL,'2MASX J15292549+2051179',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.356375,20.855,0.185,NULL,59444369096,928818267,14512785,17.2),(130400,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130400,37,0.46,252,60428,70,NULL,NULL,'2MASX J15292681+3545086',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000153,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.3617917,35.75253,0.041,NULL,60105605380,939150084,14674220,16.5),(130401,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130401,36.02,0.23,160,60429,70,NULL,NULL,'2MASX J15292695+0328514',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000094,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,232.36225,3.48111,0.113,NULL,56436395644,881818681,13778416,16.1),(130402,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130402,36.71,0.21,220,60430,70,NULL,NULL,'2MASX J15292793+0711539',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.36625,7.19814,0.097,NULL,56418613904,881540842,13774075,17),(130403,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130403,36.71,0.21,220,60431,70,NULL,NULL,'NGC 5931',NULL,'2015arXiv151105856S',2015,1,1.26,'1994AJ....107.1629T has V = 11137 +- 100 km/sec.','G',0.00011,NULL,'14.3g',0.74,'S0',NULL,NULL,NULL,NULL,1,232.3734583,7.57325,0.097,NULL,56418297523,881535898,13773998,14.3),(130404,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130404,38.08,0.33,413,60432,70,NULL,NULL,'2MASX J15292979+3613133',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.374333,36.22028,0.049,NULL,60105525741,939148839,14674200,17.8),(130405,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130405,36.02,0.23,160,60433,70,NULL,NULL,'CGCG 049-178',NULL,'2015arXiv151105856S',2015,1,1.05,'1994AJ....107.1629T has V = 11669 +- 100 km/sec.','G',0.000121,NULL,'14.6g',0.72,'S0','Group member',NULL,NULL,NULL,1,232.3764583,3.46764,0.113,NULL,56436392444,881818631,13778416,14.6),(130406,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130406,37.69,0.46,346,60434,70,NULL,NULL,'SDSS J152931.41+600516.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.380875,60.08789,0.025,NULL,57739510893,902179857,14096560,18.7),(130407,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130407,36.02,0.23,160,60435,70,NULL,NULL,'2MASX J15293256+0323054',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00009,NULL,'16.2g',0.3,'S0',NULL,NULL,NULL,NULL,1,232.385583333,3.38494,0.105,NULL,56435576171,881805877,13778216,16.2),(130408,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130408,37.67,0.17,342,60436,70,NULL,NULL,'2MASX J15293296+0332314',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00011,NULL,'16.5g',0.36,'BLAGN',NULL,NULL,NULL,'Sy 1',1,232.387416667,3.54197,0.113,NULL,56436372685,881818323,13778411,16.5),(130409,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130409,38.78,0.46,569,60437,70,NULL,NULL,'SDSS J152935.56+063821.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.3982083,6.63939,0.069,NULL,56417820171,881528440,13773881,18.2),(130410,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130410,35.99,0.2,158,60438,74.4,NULL,NULL,'CGCG 077-136',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000465,NULL,'15.7',0.27,'Sm','Isolated galaxy',NULL,NULL,NULL,1,232.3994583,12.25567,0.105,NULL,59559743583,930620993,14540953,15.7),(130411,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130411,37.15,0.23,269,60439,70,NULL,NULL,'2MASX J15293747+1133399',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.40625,11.56103,0.101,NULL,59341859330,927216552,14487758,16.2),(130412,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130412,37.87,0.15,376,60440,70,NULL,NULL,'2MASX J15293762-0016503',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000087,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.406833,-0.28069,0.237,NULL,45405939769,709467808,11085434,17),(130413,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130413,37.55,0.46,324,60441,70,NULL,NULL,'2MASX J15293787+0733409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.407833,7.56125,0.097,NULL,56418298856,881535919,13773998,17.2),(130414,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130414,36.65,0.46,214,60442,70,NULL,NULL,'2MASX J15293929+0635269',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.41375,6.59086,0.069,NULL,56417827106,881528548,13773883,16.5),(130415,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130415,38.15,0.46,427,60443,70,NULL,NULL,'2MASX J15294029+3253064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.418083,32.88522,0.053,NULL,59882372113,935662064,14619719,17.7),(130416,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130416,38.72,0.46,556,60444,70,NULL,NULL,'SDSS J152941.45+532933.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,232.42275,53.49272,0.033,NULL,59669617278,932337769,14567777,18.3),(130417,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130417,37.79,0.46,361,60445,70,NULL,NULL,'2MASX J15294168+4449493',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.423833,44.83042,0,NULL,59968438544,937006852,14640732,17.4),(130418,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130418,37.08,0.46,260,60446,70,NULL,NULL,'2MASX J15294243+5832205',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.427,58.53903,0.033,NULL,57588745683,899824151,14059752,16.8),(130419,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130419,37.48,0.46,313,60447,70,NULL,NULL,'2MASX J15294340+4415283',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.4309583,44.25797,0.025,NULL,59969093373,937017083,14640891,16.5),(130420,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130420,38.03,0.27,403,60448,70,NULL,NULL,'2MASX J15294348+1805189',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.431166667,18.0885,0.133,NULL,59435773447,928683960,14510686,17.8),(130421,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130421,34.83,NULL,92.6,60449,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 514- G 020',NULL,'2010Ap&SS.325..163P',2010,1,1.69,NULL,'G',0.000053,NULL,'17.44',0.1,'Scd',NULL,NULL,NULL,NULL,1,232.4325,-26.19833,0.453,NULL,47139577162,736555893,11508685,17.44),(130422,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130422,34.83,NULL,92.6,60449,NULL,NULL,'Dipole + Quadrupole','ESO 514- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130423,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130423,34.84,NULL,92.7,60449,NULL,NULL,'Dipole','ESO 514- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130424,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130424,36.8,0.46,229,60450,70,NULL,NULL,'2MASX J15294424+3527465',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.43425,35.46294,0.049,NULL,60105570550,939149539,14674211,17.3),(130425,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130425,33.89,0.47,59.9,60451,NULL,NULL,'H','NGC 5945',NULL,'2007A&A...465...71T',2007,1,1.36,NULL,'G',0.00002,NULL,'13.6g',1.29,'SB(rs)ab       LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,232.437583333,42.91867,0.101,NULL,59977479431,937148116,14642939,13.6),(130426,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130426,33.9,0.46,60.2,60451,NULL,NULL,'J','NGC 5945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130427,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130427,33.9,0.45,60.3,60451,NULL,NULL,'K','NGC 5945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130428,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130428,34.48,0.4,78.8,60451,NULL,NULL,'mean','NGC 5945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130429,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130429,37.24,0.46,281,60452,70,NULL,NULL,'2MASX J15294580+0642389',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.440917,6.71078,0.081,NULL,56417669188,881526081,13773845,16.2),(130430,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130430,37.64,0.46,338,60453,70,NULL,NULL,'2MASX J15294628+1607015',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.442917,16.11706,0.101,NULL,59439388318,928740442,14511569,17.7),(130431,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130431,37.87,0.46,375,60454,70,NULL,NULL,'2MASX J15294639-0046147',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.4432083,-0.77081,0.253,NULL,45407408855,709490763,11085793,17.8),(130432,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130432,37.15,0.23,269,60455,70,NULL,NULL,'2MASX J15294687+1136569',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.4454583,11.61567,0.101,NULL,59341849861,927216404,14487756,16.8),(130433,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130433,37.08,0.46,261,60456,70,NULL,NULL,'2MASX J15294705+3143315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.4459583,31.72561,0.045,NULL,59914940985,936170952,14627671,17.6),(130434,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130434,37.44,0.33,308,60457,70,NULL,NULL,'2MASX J15294736+4848149',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000193,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.4475,48.80431,0.041,NULL,59664278617,932254353,14566474,17.3),(130435,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130435,38.75,0.46,562,60458,70,NULL,NULL,'2MASX J15294859-0113567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000087,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,232.4525417,-1.23242,0.293,NULL,45407368907,709490139,11085783,18.5),(130436,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130436,38.03,0.27,403,60459,70,NULL,NULL,'2MASX J15294868+1759086',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.452791667,17.98578,0.133,NULL,59436183250,928690363,14510786,17.9),(130437,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130437,36.71,0.21,220,60460,70,NULL,NULL,'2MASX J15294876+0731599',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.453125,7.53317,0.097,NULL,56418249296,881535145,13773986,NULL),(130438,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130438,36.02,0.23,160,60461,70,NULL,NULL,'CGCG 049-183',NULL,'2015arXiv151105856S',2015,1,1.05,NULL,'G',0.000123,NULL,'14.3g',0.83,'E0','Group member',NULL,NULL,NULL,1,232.457625,3.51089,0.113,NULL,56435493036,881804578,13778196,14.3),(130439,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130439,34.03,0.2,64,60462,74.4,NULL,NULL,'UGC 09873',NULL,'2013AJ....146...86T',2013,1,1.43,NULL,'G',0.000017,NULL,'15.2g',0.34,'Sc','Group member',NULL,NULL,NULL,1,232.4610417,42.62894,0.101,NULL,59977182216,937143472,14642866,15.2),(130440,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130440,34.06,0.52,64.9,60462,NULL,NULL,NULL,'UGC 09873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130441,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130441,34.24,0.49,70.4,60462,75,NULL,'IR','UGC 09873',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130442,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130442,34.28,0.47,71.7,60462,NULL,NULL,'Malmquist cor.','UGC 09873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130443,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130443,38.03,0.46,404,60463,70,NULL,NULL,'SDSS J152951.04+111359.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.4627083,11.23328,0.089,NULL,59341691987,927213937,14487717,18.5),(130444,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130444,37.58,0.46,328,60464,70,NULL,NULL,'2MASX J15295162+1035563',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.4652083,10.59883,0.089,NULL,59343384584,927240384,14488131,16.8),(130445,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130445,38.46,0.46,492,60465,70,NULL,NULL,'SDSS J152952.30+025328.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000088,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.467958333,2.89125,0.089,NULL,56431456178,881741502,13777210,18.6),(130446,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130446,37.59,0.46,329,60466,70,NULL,NULL,'2MASX J15295234+1839325',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000151,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.4682917,18.65911,0.101,NULL,59443348866,928802326,14512536,17.4),(130447,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130447,38.44,0.46,488,60467,70,NULL,NULL,'SDSS J152952.53+283323.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.468875,28.55639,0.041,NULL,59917755211,936214925,14628358,18.5),(130448,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130448,36.81,0.46,231,60468,70,NULL,NULL,'2MASX J15295389+4243283',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.474583,42.72447,0.101,NULL,59977173393,937143334,14642864,16.9),(130449,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130449,34.55,0.46,81.2,60469,NULL,NULL,'Malmquist cor.','ESO 514- G 021',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.99',0.3,'S...',NULL,NULL,NULL,NULL,1,232.477,-26.5965,0.441,NULL,47139199052,736549985,11508593,15.99),(130450,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130450,34.55,0.46,81.2,60469,NULL,NULL,NULL,'ESO 514- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130451,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130451,34.59,0.2,82.8,60469,74.4,NULL,NULL,'ESO 514- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130452,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130452,37.45,0.46,309,60470,70,NULL,NULL,'2MASX J15295451+2139585',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.47725,21.66636,0.169,NULL,59455531334,928992677,14515510,16.7),(130453,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130453,36.22,0.46,175,60471,70,NULL,NULL,'2MASX J15295502+0820273',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000165,NULL,'17.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,232.479375,8.34108,0.093,NULL,56421661424,881588459,13774819,17.1),(130454,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130454,34.84,0.8,93.1,60472,75,NULL,'MAT, I','ESO 582- G 013',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000027,NULL,'14.5',1,'SAB(rs)bc      HII',NULL,NULL,NULL,NULL,1,232.480667,-18.61958,0.405,NULL,46596208848,728065763,11376027,14.5),(130455,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130455,34.22,0.69,69.9,60472,100,NULL,'mid-IR','ESO 582- G 013',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130456,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130456,34.41,0.43,76.2,60472,75,NULL,'MAT, I, raw','ESO 582- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130457,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130457,34.44,0.32,77.2,60472,85,NULL,'I, raw','ESO 582- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130458,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130458,34.51,0.32,79.8,60472,85,NULL,'I, inv','ESO 582- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130459,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130459,34.72,0.43,87.7,60472,75,NULL,'MAT, I, inv','ESO 582- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130460,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130460,34.78,0.43,90.4,60472,75,NULL,'MAT, I, cor','ESO 582- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130461,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130461,35.03,0.47,101,60472,NULL,NULL,'H','ESO 582- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130462,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130462,35.04,0.4,102,60472,NULL,NULL,'mean','ESO 582- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130463,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130463,35.09,0.46,104,60472,NULL,NULL,'J','ESO 582- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130464,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130464,35.13,0.45,106,60472,NULL,NULL,'K','ESO 582- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130465,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130465,35.14,0.28,107,60472,NULL,NULL,'Malmquist cor.','ESO 582- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130466,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130466,35.29,0.2,114,60472,74.4,NULL,NULL,'ESO 582- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130467,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130467,35.34,0.26,117,60472,NULL,NULL,NULL,'ESO 582- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130468,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130468,37.49,0.46,315,60473,70,NULL,NULL,'2MASX J15295614+3028405',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.484041667,30.47778,0.041,NULL,59913286621,936145103,14627267,17.1),(130469,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130469,38.25,0.46,447,60474,70,NULL,NULL,'2MASX J15295625-0008107',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000087,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.484291667,-0.13625,0.229,NULL,45405854012,709466468,11085413,18.1),(130470,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130470,37.44,0.33,308,60475,70,NULL,NULL,'2MASX J15295639+4907569',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.485,49.13261,0.037,NULL,59667682096,932307532,14567305,16.7),(130471,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130471,37.15,0.23,269,60476,70,NULL,NULL,'SDSS J152956.42+113220.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.485125,11.53894,0.101,NULL,59341826231,927216034,14487750,17.5),(130472,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130472,37.41,0.46,303,60477,70,NULL,NULL,'2MASX J15295656+1630525',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.48575,16.51458,0.101,NULL,59439160219,928736878,14511513,17.5),(130473,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130473,37.85,0.46,371,60478,70,NULL,NULL,'2MASX J15295720+0029541',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000091,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.48825,0.49828,0.181,NULL,56398378861,881224669,13769135,17.1),(130474,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130474,37.54,0.46,322,60479,70,NULL,NULL,'2MASX J15295749+5417246',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.4895417,54.29019,0.029,NULL,59669397538,932334336,14567724,16.9),(130475,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130475,37.37,0.46,298,60480,70,NULL,NULL,'2MASX J15295759+2516137',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.49,25.27047,0.149,NULL,59899619822,935931559,14623930,16.8),(130476,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130476,37.58,0.46,328,60481,70,NULL,NULL,'2MASX J15295839+0816503',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.4932917,8.28075,0.097,NULL,56421654341,881588349,13774817,17.1),(130477,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130477,37.68,0.46,343,60482,70,NULL,NULL,'2MASX J15295892+0007211',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.495667,0.1225,0.201,NULL,56398294901,881223357,13769114,17.7),(130478,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130478,37.67,0.17,342,60483,70,NULL,NULL,'SDSS J153000.07+033005.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000069,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,232.5002917,3.5015,0.113,NULL,56435506987,881804796,13778199,18.7),(130479,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130479,38.35,0.46,468,60484,70,NULL,NULL,'SDSS J153000.61+002101.5',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000077,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,232.5025417,0.35042,0.201,NULL,56398385511,881224773,13769137,18.9),(130480,'Ring Diameter','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130480,33.5,0.84,50,60485,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5936',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.00002,NULL,'13.11',1.3,'SB(rs)b;LIRG   HII','Field galaxy',NULL,NULL,NULL,1,232.5034583,12.98933,0.093,NULL,59559941883,930624091,14541001,13.11),(130481,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130481,37.15,0.23,269,60486,70,NULL,NULL,'2MASX J15300137+1144063',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.505791667,11.73497,0.101,NULL,59342019518,927219054,14487797,16.7),(130482,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130482,35.94,0.46,154,60487,70,NULL,NULL,'2MASX J15300164+1228065',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.506833333,12.46842,0.101,NULL,59559735095,930620860,14540950,16.5),(130483,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130483,38.15,0.46,426,60488,70,NULL,NULL,'2MASX J15300176+3538115',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.5072917,35.63661,0.041,NULL,60105582890,939149732,14674214,17.6),(130484,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130484,37.4,0.33,303,60489,70,NULL,NULL,'2MASX J15300179-0046417',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.5074583,-0.77825,0.253,NULL,45407405182,709490705,11085792,17.4),(130485,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130485,38.26,0.46,448,60490,70,NULL,NULL,'2MASX J15300355+5810036',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.514708333,58.16783,0.021,NULL,57588645627,899822587,14059727,17.7),(130486,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130486,38.3,0.46,458,60491,70,NULL,NULL,'2MASX J15300403+1016223',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.516667,10.27294,0.085,NULL,56406814679,881356479,13771194,18.1),(130487,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130487,37.72,0.27,350,60492,70,NULL,NULL,'2MASX J15300481+2316234',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,232.5202917,23.27319,0.153,NULL,59419110031,928423594,14506618,18.3),(130488,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130488,37.11,0.46,264,60493,70,NULL,NULL,'2MASX J15300584+0333251',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.524333,3.55692,0.113,NULL,56435501390,881804709,13778198,17.1),(130489,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130489,36.89,0.46,239,60494,70,NULL,NULL,'2MASX J15300741+0651003',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.530875,6.85025,0.097,NULL,56417673914,881526154,13773846,17),(130490,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130490,37.46,0.46,311,60495,70,NULL,NULL,'2MASX J15300752-0033597',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.531333,-0.56656,0.253,NULL,45405827079,709466048,11085407,17.6),(130491,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130491,37.72,0.27,350,60496,70,NULL,NULL,'B2 1527+23',NULL,'2015arXiv151105856S',2015,1,0.44,'TXS codes: confusion(C);lobes(W)','G',0.000202,NULL,'16.3g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,232.5332083,23.27111,0.153,NULL,59419111300,928423614,14506618,16.3),(130492,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130492,31.13,0.8,16.9,60497,75,NULL,'MAT, I','ESO 329- G 007',NULL,'1997ApJS..109..333W',1997,1,1.8,'1996ApJS...107...97M gives V = 1439 +- 10 km/sec.','G',0.000013,NULL,'13.9b',0.5,'SA(rs)b:',NULL,NULL,NULL,NULL,1,232.5347083,-38.65181,0.517,NULL,47180785481,737199773,11518746,13.9),(130493,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130493,33.81,0.43,57.7,60497,75,NULL,'MAT, I, raw','ESO 329- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130494,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130494,33.81,0.32,57.9,60497,85,NULL,'I, raw','ESO 329- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130495,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130495,33.89,0.32,59.9,60497,85,NULL,'I, inv','ESO 329- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130496,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130496,34,0.43,63,60497,75,NULL,'3.6 micron, color + selection bias corrected','ESO 329- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130497,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130497,34,0.43,63.1,60497,75,NULL,'3.6 micron, color corrected','ESO 329- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130498,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130498,34.07,0.43,65.1,60497,75,NULL,'MAT, I, cor','ESO 329- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130499,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130499,34.07,0.2,65.2,60497,74.4,NULL,NULL,'ESO 329- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130500,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130500,34.12,0.43,66.7,60497,75,NULL,'MAT, I, inv','ESO 329- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130501,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130501,34.41,0.49,76.2,60497,75,NULL,'IR','ESO 329- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130502,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130502,37.4,0.33,303,60498,70,NULL,NULL,'2MASX J15300932-0052257',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.5387083,-0.87392,0.301,NULL,45407414061,709490844,11085794,17.4),(130503,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130503,36.49,NULL,198,60499,NULL,NULL,NULL,'FGC 1909',NULL,'2000BSAO...50....5K',2000,1,0.78,NULL,'G',0.000181,NULL,'17.0g',0.15,'Sd',NULL,NULL,NULL,NULL,1,232.540083333,49.02478,0.037,NULL,59664297902,932254654,14566478,17),(130504,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130504,37.8,0.46,364,60500,70,NULL,NULL,'2MASX J15301025+2112304',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.542791667,21.20847,0.169,NULL,59456234372,929003662,14515682,17.6),(130505,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130505,36.74,0.46,223,60501,70,NULL,NULL,'2MASX J15301065-0003067',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000091,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.544291667,-0.05186,0.229,NULL,45405858111,709466532,11085414,16.8),(130506,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm',NULL,130506,41.55,0.6,1410,60502,74.2,NULL,'SALT 2','H-ZSNS J153011.25+055527.0',0.45,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.546875,5.92417,0.113,NULL,56423080200,881610628,13775166,NULL),(130507,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm','R',130507,41.89,NULL,1650,60502,65,NULL,'SALT','H-ZSNS J153011.25+055527.0',0.45,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130508,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm',NULL,130508,42.28,0.42,1970,60502,70,NULL,'SALT','H-ZSNS J153011.25+055527.0',0.45,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130509,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm',NULL,130509,42.41,0.4,2090,60502,65,NULL,'SALT','H-ZSNS J153011.25+055527.0',0.45,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130510,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 1996cm',NULL,130510,42.58,0.19,2260,60502,65,NULL,NULL,'H-ZSNS J153011.25+055527.0',0.45,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130511,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130511,37.87,0.15,376,60503,70,NULL,NULL,'SDSS J153011.81-001801.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000091,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.5492083,-0.30042,0.237,NULL,45405912562,709467383,11085427,18.5),(130512,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130512,37.6,0.46,331,60504,70,NULL,NULL,'2MASX J15301191+2313103',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.549667,23.21958,0.153,NULL,59419119384,928423740,14506620,18.1),(130513,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130513,38.03,0.27,403,60505,70,NULL,NULL,'2MASX J15301223+1759089',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.551,17.98572,0.133,NULL,59436227740,928691058,14510797,17.1),(130514,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130514,37.07,0.33,259,60506,70,NULL,NULL,'2MASX J15301236+0113581',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000107,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.5515,1.23275,0.093,NULL,56399841191,881247518,13769492,16.3),(130515,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130515,37.67,0.17,342,60507,70,NULL,NULL,'SDSS J153013.04+034216.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.554333,3.70469,0.113,NULL,56436337849,881817778,13778402,18.4),(130516,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130516,37.23,0.46,279,60508,70,NULL,NULL,'2MASXi J1530131+323502',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.55475,32.58386,0.057,NULL,59882354651,935661791,14619715,17.7),(130517,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130517,37.07,0.33,259,60509,70,NULL,NULL,'2MASX J15301352+0116322',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.5562917,1.27578,0.093,NULL,56399854050,881247719,13769495,16.5),(130518,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130518,37.35,0.33,296,60510,70,NULL,NULL,'2MASX J15301455+0808093',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.5607083,8.13589,0.097,NULL,56421678045,881588719,13774823,17.8),(130519,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130519,37.72,0.27,350,60511,70,NULL,NULL,'2MASX J15301491+2318503',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.562083,23.31383,0.153,NULL,59419108940,928423577,14506618,16.8),(130520,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130520,36.13,0.46,169,60512,70,NULL,NULL,'CGCG 297-013',NULL,'2015arXiv151105856S',2015,1,0.6,'GSC 3872-1180 (mag. 13) superposed 20 arcsec south of nucleus.','G',0.0005,NULL,'15.7',0.5,'E','Isolated galaxy',NULL,NULL,NULL,1,232.563375,56.83222,0,NULL,57590440793,899850637,14060166,15.7),(130521,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130521,38.63,0.46,533,60513,70,NULL,NULL,'SDSS J153015.31+060735.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.563833,6.12658,0.101,NULL,56415584462,881493507,13773336,17.5),(130522,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130522,38.88,0.46,596,60514,70,NULL,NULL,'SDSS J153016.06+202953.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.5669583,20.49831,0.217,NULL,59444537041,928820891,14512826,18.6),(130523,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130523,36.17,0.46,172,60515,70,NULL,NULL,'CGCG 166-005',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00016,NULL,'14.92',0.6,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,232.567291667,27.09753,0.157,NULL,59900580207,935946565,14624165,14.92),(130524,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130524,37.9,0.46,380,60516,70,NULL,NULL,'2MASX J15301639+3206463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.568375,32.11286,0.065,NULL,59914870698,936169854,14627653,17.2),(130525,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130525,37.15,0.46,269,60517,70,NULL,NULL,'2MASX J15301835+2906045',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.576625,29.10133,0.069,NULL,59926157909,936346217,14630409,17.3),(130526,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130526,38.21,0.21,439,60518,70,NULL,NULL,'2MASX J15301858+0134562',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.5775417,1.58233,0.077,NULL,56399369894,881240154,13769377,17.2),(130527,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130527,36.11,0.56,167,60519,70,NULL,NULL,'2MASX J15301875-1312150',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,232.578083333,-13.20414,0.553,NULL,46658134770,729033355,11391146,14.4),(130528,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130528,37.35,0.33,296,60520,70,NULL,NULL,'2MASX J15301968+0813573',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.5820417,8.23269,0.097,NULL,56421698412,881589037,13774828,17.1),(130529,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130529,36.62,0.46,211,60521,70,NULL,NULL,'2MASX J15301983-0145569',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,232.582625,-1.76592,0.337,NULL,45405216072,709456501,11085257,16.8),(130530,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130530,37.44,0.46,307,60522,70,NULL,NULL,'2MASX J15302075+3546454',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00019,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.5865417,35.77919,0.061,NULL,60105573491,939149585,14674212,16.7),(130531,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130531,37.13,0.46,267,60523,70,NULL,NULL,'2MASX J15302106+1213510',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.587666667,12.23092,0.105,NULL,59341407368,927209490,14487648,16.8),(130532,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130532,36.71,0.21,220,60524,70,NULL,NULL,'2MASX J15302187+0742174',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.591125,7.70469,0.097,NULL,56421518724,881586230,13774784,16.8),(130533,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130533,37.89,0.46,379,60525,70,NULL,NULL,'2MASX J15302283+1036554',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.595083,10.61531,0.081,NULL,59343375187,927240237,14488128,17),(130534,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130534,37.95,0.46,389,60526,70,NULL,NULL,'2MASX J15302385-0020198',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000096,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.599333,-0.33897,0.237,NULL,45405899956,709467186,11085424,16.9),(130535,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130535,36.38,0.46,189,60527,70,NULL,NULL,'2MASX J15302471+0550142',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.602917,5.83742,0.113,NULL,56423028766,881609824,13775153,16.3),(130536,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130536,36.12,0.46,167,60528,70,NULL,NULL,'2MASX J15302501+1608280',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.604375,16.14111,0.089,NULL,59439446115,928741345,14511583,16.8),(130537,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130537,37.67,0.17,342,60529,70,NULL,NULL,'2MASX J15302522-0130258',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.8g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,232.6052083,-1.50728,0.325,NULL,45406675061,709479297,11085614,16.8),(130538,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130538,37.61,0.12,333,60530,70,NULL,NULL,'2MASX J15302640+5306444',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,232.6102083,53.11244,0.029,NULL,59674165876,932408841,14568888,16.7),(130539,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130539,37.87,0.15,376,60531,70,NULL,NULL,'2MASX J15302718-0014238',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.61325,-0.24006,0.229,NULL,45405879967,709466874,11085419,18.2),(130540,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130540,38.07,0.46,412,60532,70,NULL,NULL,'SDSS J153027.27+391300.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000125,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.613666667,39.21681,0.053,NULL,60097837213,939028706,14672323,18.4),(130541,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130541,35.06,0.62,103,60533,70,NULL,NULL,'2MASX J15302747-2011467',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.78',0.4,NULL,NULL,NULL,NULL,NULL,1,232.6142083,-20.19667,0.481,NULL,46627069610,728547962,11383561,15.78),(130542,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130542,38.21,0.21,439,60534,70,NULL,NULL,'SDSS J153027.97+013313.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.616583,1.55375,0.077,NULL,56399422396,881240974,13769390,18.6),(130543,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130543,37.67,0.17,342,60535,70,NULL,NULL,'2MASX J15303029-0124228',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.62625,-1.40636,0.293,NULL,45406669696,709479214,11085612,18.4),(130544,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130544,36.81,0.33,230,60536,70,NULL,NULL,'2MASX J15303033+4514531',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000173,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.6262917,45.24803,0.033,NULL,59968381285,937005957,14640718,16.1),(130545,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130545,37.67,0.17,342,60537,70,NULL,NULL,'2MASX J15303076-0132558',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.62825,-1.54892,0.325,NULL,45404754847,709449294,11085145,17.6),(130546,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130546,36.51,0.46,201,60538,70,NULL,NULL,'2MASX J15303081+3832276',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000165,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.62825,38.54092,0.049,NULL,60099388797,939052949,14672702,16.6),(130547,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130547,34.24,0.52,70.6,60539,70,NULL,NULL,'CGCG 021-104 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'16.42',0.19,NULL,NULL,NULL,NULL,NULL,1,232.628667,-2.27594,0.353,NULL,45405339794,709458434,11085288,16.42),(130548,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130548,37.37,0.46,298,60540,70,NULL,NULL,'2MASX J15303155+2413566',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6315,24.23244,0.145,NULL,59417168092,928393251,14506144,17.9),(130549,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130549,37.68,0.46,343,60541,70,NULL,NULL,'2MASX J15303179+3026163',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000196,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.63225,30.43775,0.041,NULL,59912818712,936137792,14627153,17),(130550,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130550,38.21,0.21,439,60542,70,NULL,NULL,'2MASX J15303299+0135192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.637375,1.58886,0.077,NULL,56399423186,881240987,13769390,17.1),(130551,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130551,37.51,0.33,318,60543,70,NULL,NULL,'2MASX J15303333-0048338',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00012,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,232.63875,-0.80933,0.313,NULL,45406096514,709470258,11085472,15.9),(130552,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130552,37.34,0.46,294,60544,70,NULL,NULL,'2MASX J15303388-0114228',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000095,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,232.64125,-1.23978,0.293,NULL,45406695553,709479618,11085619,16.2),(130553,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130553,36.26,0.46,178,60545,70,NULL,NULL,'VIII Zw 474',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000184,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,232.642833,8.49144,0.109,NULL,56420853211,881575831,13774622,16.3),(130554,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130554,38.39,0.46,476,60546,70,NULL,NULL,'2MASX J15303438+2313291',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6432083,23.22483,0.153,NULL,59418911694,928420495,14506570,17.6),(130555,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130555,37.67,0.17,342,60547,70,NULL,NULL,'SDSS J153034.48-012707.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000178,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,232.6437083,-1.45222,0.325,NULL,45406647226,709478862,11085607,18.8),(130556,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130556,35.13,0.2,106,60548,74.4,NULL,NULL,'ESO 449- G 012',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.08',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,232.646791667,-32.42878,0.437,NULL,47164426379,736944162,11514752,15.08),(130557,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130557,37.69,0.33,346,60549,70,NULL,NULL,'2MASX J15303538+0239062',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000093,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.647417,2.65183,0.081,NULL,56398948277,881233566,13769274,16.7),(130558,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130558,37.51,0.33,318,60550,70,NULL,NULL,'2MASX J15303547-0047558',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.6477083,-0.79894,0.313,NULL,45406096489,709470257,11085472,16.7),(130559,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130559,35.43,0.46,122,60551,70,NULL,NULL,'2MASX J15303690+2728556',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.65375,27.48214,0.093,NULL,59900523484,935945679,14624151,NULL),(130560,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130560,36.81,0.33,230,60552,70,NULL,NULL,'2MASX J15303698+4519288',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.653916667,45.32469,0.029,NULL,59968331213,937005175,14640705,17.4),(130561,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130561,35.85,0.53,148,60553,70,NULL,NULL,'2MASX J15303730-4100154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,232.6555,-41.00436,0.545,NULL,47061475289,735335551,11489617,15.5),(130562,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130562,37.67,0.17,342,60554,70,NULL,NULL,'2MASX J15303905+0329382',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000106,NULL,'15.7g',0.48,'BrClG;E        AGN',NULL,NULL,NULL,NULL,1,232.66275,3.49403,0.113,NULL,56435523276,881805051,13778203,15.7),(130563,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130563,38.21,0.21,439,60555,70,NULL,NULL,'2MASX J15303959+0133502',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.665083,1.564,0.077,NULL,56399391951,881240499,13769382,16.8),(130564,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130564,37.24,0.46,281,60556,70,NULL,NULL,'2MASX J15303993+0150132',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.6665,1.83717,0.085,NULL,56399398564,881240602,13769384,17.1),(130565,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130565,37.51,0.46,318,60557,70,NULL,NULL,'2MASX J15303997+4234089',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.6667083,42.56914,0.101,NULL,59977089305,937142020,14642844,17.4),(130566,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130566,37.62,0.46,334,60558,70,NULL,NULL,'2MASX J15304027+4023535',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.667833,40.39831,0.057,NULL,59964331270,936942676,14639729,17.3),(130567,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130567,37.26,0.46,283,60559,70,NULL,NULL,'2MASX J15304074+4748479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.669875,47.81325,0.045,NULL,59719498955,933117171,14579955,16.8),(130568,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130568,37.67,0.17,342,60560,70,NULL,NULL,'2MASX J15304078+0327582',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000075,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6699583,3.46628,0.113,NULL,56435521436,881805022,13778203,17.5),(130569,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130569,37.2,0.33,276,60561,70,NULL,NULL,'SDSS J153041.38+075003.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000176,NULL,'17.8g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.6724583,7.83419,0.097,NULL,56421575125,881587111,13774798,17.8),(130570,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130570,37.65,0.46,339,60562,70,NULL,NULL,'2MASX J15304290+2928122',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.678833333,29.47017,0.061,NULL,59912597753,936134339,14627099,17.4),(130571,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130571,38.21,0.33,439,60563,70,NULL,NULL,'2MASX J15304291+3042187',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.678833333,30.70536,0.073,NULL,59914729879,936167654,14627619,17.6),(130572,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130572,37.24,0.46,280,60564,70,NULL,NULL,'2MASX J15304300+5947442',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.679167,59.79556,0.041,NULL,57739662826,902182231,14096597,17.8),(130573,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130573,37.04,0.46,255,60565,70,NULL,NULL,'2MASX J15304310+2814492',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.679625,28.24714,0.065,NULL,59917843701,936216307,14628379,16.9),(130574,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130574,38.02,0.46,402,60566,70,NULL,NULL,'2MASX J15304333+0059298',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.680667,0.99167,0.185,NULL,56399949650,881249213,13769518,18.2),(130575,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130575,36.94,0.46,244,60567,70,NULL,NULL,'2MASX J15304348+4437379',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00016,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.6810417,44.62719,0.025,NULL,59968520283,937008129,14640752,16.5),(130576,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130576,36.66,0.46,215,60568,70,NULL,NULL,'2MASX J15304400+5321023',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6835,53.35083,0.033,NULL,59669632082,932338001,14567781,17.4),(130577,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130577,38.16,0.46,429,60569,70,NULL,NULL,'2MASX J15304406+0344018',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.683625,3.73364,0.117,NULL,56435476499,881804320,13778192,17.1),(130578,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130578,37.09,0.46,261,60570,70,NULL,NULL,'2MASX J15304491-0205553',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.687083,-2.09869,0.353,NULL,45405327744,709458246,11085285,17.2),(130579,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130579,37.55,0.11,323,60571,70,NULL,NULL,'2MASX J15304490+2750473',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.6872917,27.84658,0.089,NULL,59900757132,935949330,14624208,17.3),(130580,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130580,37.67,0.17,342,60572,70,NULL,NULL,'2MASX J15304549-0128163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000172,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.689583,-1.47125,0.293,NULL,45406649585,709478899,11085607,18.1),(130581,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130581,32.21,0.69,27.6,60573,100,NULL,'mid-IR','NGC 5937',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.00002,NULL,'13.35',1.1,'(R\')SAB(rs)b pec HII',NULL,NULL,NULL,NULL,1,232.6922083,-2.8295,0.385,NULL,45404426649,709444166,11085065,13.35),(130582,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130582,32.75,0.43,35.6,60573,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5937',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130583,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130583,32.89,0.45,37.8,60573,NULL,NULL,'K','NGC 5937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130584,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130584,32.92,0.47,38.4,60573,NULL,NULL,'H','NGC 5937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130585,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130585,32.93,0.43,38.5,60573,75,NULL,'3.6 micron, color corrected','NGC 5937',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130586,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130586,32.94,0.46,38.7,60573,NULL,NULL,'J','NGC 5937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130587,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130587,33.03,0.4,40.4,60573,NULL,NULL,'mean','NGC 5937',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130588,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130588,33.11,0.2,41.9,60573,74.4,NULL,NULL,'NGC 5937',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130589,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130589,38.21,0.33,439,60574,70,NULL,NULL,'2MASX J15304647+3042337',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000201,NULL,'17.4g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,232.6935417,30.70953,0.073,NULL,59914721842,936167528,14627617,17.4),(130590,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130590,37.58,0.46,328,60575,70,NULL,NULL,'2MASX J15304784+5745192',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.699208333,57.75533,0.025,NULL,57591292929,899863952,14060374,17.3),(130591,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130591,37.03,0.46,254,60576,70,NULL,NULL,'2MASX J15304783+3225137',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.699291667,32.42058,0.061,NULL,59914859828,936169684,14627651,17.3),(130592,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130592,36.46,0.46,196,60577,70,NULL,NULL,'2MASX J15304806+2832443',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.7002083,28.54572,0.041,NULL,59917750399,936214849,14628357,16.6),(130593,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130593,37.61,0.12,333,60578,70,NULL,NULL,'2MASX J15304904+5303433',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.704083333,53.06208,0.033,NULL,59673954746,932405542,14568836,17.5),(130594,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130594,38.21,0.21,439,60579,70,NULL,NULL,'2MASX J15304927+0130298',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.705375,1.50831,0.077,NULL,56399857584,881247774,13769496,17.4),(130595,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130595,37.64,0.46,337,60580,70,NULL,NULL,'SDSS J153049.84+115136.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.7077083,11.86006,0.105,NULL,59341971626,927218306,14487786,18.3),(130596,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130596,37.87,0.15,376,60581,70,NULL,NULL,'SDSS J153050.08-001939.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000072,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.7087083,-0.32767,0.229,NULL,45406385461,709474772,11085543,18.6),(130597,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130597,37.67,0.17,342,60582,70,NULL,NULL,'2MASX J15305102-0125113',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,232.712667,-1.41978,0.293,NULL,45406708752,709479824,11085622,18.5),(130598,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130598,37.24,0.27,281,60583,70,NULL,NULL,'2MASX J15305123+0650456',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.7135417,6.84614,0.097,NULL,56417649400,881525771,13773840,16.5),(130599,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130599,38.21,0.46,439,60584,70,NULL,NULL,'2MASX J15305130-0146173',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.71375,-1.77156,0.329,NULL,45404740388,709449068,11085141,17.9),(130600,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130600,37.33,0.46,292,60585,70,NULL,NULL,'2MASX J15305333-0052393',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.72225,-0.87772,0.313,NULL,45406099431,709470303,11085473,18.3),(130601,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130601,37.48,0.46,314,60586,70,NULL,NULL,'2MASX J15305349+4548490',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,232.723125,45.81375,0.025,NULL,59685263534,932582242,14571597,16.4),(130602,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130602,38.32,0.46,462,60587,70,NULL,NULL,'2MASX J15305622+1909342',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.734333,19.15942,0.145,NULL,59443534291,928805223,14512581,17.5),(130603,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130603,36.13,0.14,168,60588,70,NULL,NULL,'2MASX J15305642+0411428',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000119,NULL,'16.1g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,232.7350417,4.19517,0.125,NULL,56424505770,881632902,13775514,16.1),(130604,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130604,37.67,0.17,342,60589,70,NULL,NULL,'2MASX J15305795+0325338',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.7414583,3.42603,0.113,NULL,56435425301,881803520,13778180,18),(130605,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130605,37.25,0.46,282,60590,70,NULL,NULL,'SDSS J153058.94+064007.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.745625,6.66886,0.081,NULL,56415670647,881494853,13773357,17.9),(130606,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130606,37.2,0.33,276,60591,70,NULL,NULL,'2MASX J15305914+0752136',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.746417,7.87042,0.097,NULL,56421540340,881586567,13774790,17.6),(130607,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130607,37.67,0.17,342,60592,70,NULL,NULL,'SDSS J153100.23-013032.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.751,-1.50906,0.293,NULL,45406634992,709478671,11085604,18.5),(130608,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130608,38.1,0.46,416,60593,70,NULL,NULL,'2MASX J15310252+3252578',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.760625,32.88261,0.057,NULL,59885811091,935715798,14620559,17.9),(130609,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130609,37.88,0.33,376,60594,70,NULL,NULL,'2MASX J15310337+3741183',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.76425,37.68833,0.061,NULL,60098808044,939043875,14672560,17.7),(130610,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130610,38.11,0.46,419,60595,70,NULL,NULL,'2MASX J15310352+1844511',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.764875,18.74756,0.137,NULL,59443322708,928801917,14512529,18),(130611,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130611,37.24,0.27,281,60596,70,NULL,NULL,'SDSS J153104.94+064535.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.770583333,6.75992,0.097,NULL,56416344130,881505377,13773521,17.2),(130612,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130612,37.65,0.46,338,60597,70,NULL,NULL,'2MASX J15310543+3558163',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.772666667,35.97125,0.049,NULL,60105470718,939147979,14674187,16.7),(130613,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130613,37.76,0.23,356,60598,70,NULL,NULL,'SDSS J153105.61-000612.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000064,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.773417,-0.10353,0.217,NULL,45406369274,709474519,11085539,18.3),(130614,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130614,32.47,NULL,31.2,60599,72,NULL,NULL,'AGC 252522',NULL,'2014Ap.....57..457K',2014,1,1.3,NULL,'G',0.000007,NULL,'16.5',0.9,'Sm',NULL,NULL,NULL,NULL,1,232.775625,3.82983,0.117,NULL,56424733600,881636462,13775569,16.5),(130615,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130615,36.21,0.46,174,60600,70,NULL,NULL,'2MASX J15310617+0344157',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000102,NULL,'15.8g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,232.77575,3.73767,0.117,NULL,56424016093,881625251,13775394,15.8),(130616,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130616,37.01,0.46,252,60601,70,NULL,NULL,'2MASX J15310619+3314438',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'FoF','16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.775917,33.24542,0.065,NULL,59885957163,935718080,14620595,16.4),(130617,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130617,37.3,0.46,289,60602,70,NULL,NULL,'2MASX J15310688-0114462',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.7785417,-1.24631,0.301,NULL,45406726770,709480105,11085626,17.5),(130618,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130618,37.34,0.46,294,60603,70,NULL,NULL,'2MASX J15310738+2423473',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.7807917,24.39667,0.141,NULL,59417360838,928396263,14506191,17.5),(130619,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130619,37.14,0.46,269,60604,70,NULL,NULL,'2MASX J15310799+0019248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.783375,0.32353,0.201,NULL,56398555599,881227431,13769178,17.5),(130620,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130620,37.56,0.46,324,60605,70,NULL,NULL,'2MASX J15310910+0253037',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000084,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.787875,2.88433,0.081,NULL,56398721100,881230017,13769219,16.8),(130621,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130621,38.1,0.46,417,60606,70,NULL,NULL,'2MASX J15311054+5106338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.7939583,51.10947,0.041,NULL,59673223200,932394112,14568658,17.8),(130622,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130622,36.66,0.46,215,60607,70,NULL,NULL,'2MASX J15311111+5137477',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000191,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.796416667,51.63003,0.033,NULL,59673194257,932393660,14568650,16.5),(130623,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130623,37.76,0.46,357,60608,70,NULL,NULL,'2MASX J15311129+3314178',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.2r',NULL,NULL,NULL,NULL,NULL,NULL,1,232.7970417,33.23825,0.065,NULL,59885955326,935718051,14620594,16.2),(130624,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130624,37.74,0.46,353,60609,70,NULL,NULL,'SDSS J153114.23+221301.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.809333,22.217,0.157,NULL,59452066273,928938535,14514664,18.3),(130625,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130625,37.79,0.46,362,60610,70,NULL,NULL,'SDSS J153114.89+080834.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.812041667,8.14303,0.109,NULL,56421752755,881589886,13774841,18.3),(130626,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','PTF11atu','N',130626,37.75,0.1,329,60611,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11atu',0.0774,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130627,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130627,38.44,0.46,488,60612,70,NULL,NULL,'2MASX J15311533+3049494',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.814041667,30.83044,0.073,NULL,59914780091,936168438,14627631,17.5),(130628,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130628,37.51,0.46,318,60613,70,NULL,NULL,'2MASX J15311557+5016488',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.814666667,50.28014,0.041,NULL,59666057688,932282151,14566908,18.1),(130629,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130629,37.09,0.46,262,60614,70,NULL,NULL,'SDSS J153115.55+385247.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.814833,38.88,0.057,NULL,60099273672,939051151,14672674,18),(130630,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130630,37.69,0.33,346,60615,70,NULL,NULL,'2MASX J15311564+0226338',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.815083333,2.44278,0.081,NULL,56398891553,881232680,13769260,17.2),(130631,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130631,38.11,0.46,420,60616,70,NULL,NULL,'SDSS J153115.99+151325.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.816667,15.22372,0.097,NULL,59427902694,928560979,14508765,18.2),(130632,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130632,36.7,0.46,219,60617,70,NULL,NULL,'2MASX J15311623+1009036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,232.817458333,10.15078,0.085,NULL,56408789525,881387336,13771677,17.2),(130633,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130633,36.25,0.46,178,60618,70,NULL,NULL,'2MASX J15311659+1226247',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.819083,12.44019,0.121,NULL,59560026310,930625411,14541022,16.9),(130634,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130634,38.02,0.46,402,60619,70,NULL,NULL,'2MASX J15311661+2205551',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.8192917,22.0985,0.137,NULL,59452070331,928938598,14514665,16.5),(130635,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130635,37.63,0.33,336,60620,70,NULL,NULL,'SDSS J153117.00+235814.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.820875,23.97061,0.149,NULL,59417196845,928393700,14506151,17.1),(130636,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130636,37.55,0.11,323,60621,70,NULL,NULL,'2MASX J15311707+2755520',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,232.8212083,27.93108,0.089,NULL,59917798567,936215602,14628368,16.4),(130637,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130637,36.75,0.46,224,60622,70,NULL,NULL,'2MASX J15311716+4531063',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.821667,45.51839,0.029,NULL,59688616824,932634637,14572416,17.8),(130638,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130638,37.54,0.46,322,60623,70,NULL,NULL,'2MASX J15311732+3246284',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,232.822,32.77464,0.057,NULL,59885806295,935715723,14620558,16.6),(130639,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130639,36.97,0.46,248,60624,70,NULL,NULL,'2MASXi J1531175+152624',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.823125,15.44022,0.117,NULL,59438924016,928733187,14511456,17.6),(130640,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130640,37.63,0.33,336,60625,70,NULL,NULL,'2MASX J15311801+2404550',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.825125,24.08206,0.145,NULL,59417216262,928394004,14506156,16.9),(130641,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130641,46.03,1.57,3820,60626,100,NULL,NULL,'GRB 060526',3.21,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,232.8265,0.28469,0.201,NULL,56398574981,881227734,13769183,NULL),(130642,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130642,46.1,1.51,3930,60626,100,NULL,NULL,'GRB 060526',3.21,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130643,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130643,47.17,0.41,6450,60626,69.7,NULL,'Calibrated','GRB 060526',3.21,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130644,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130644,47.29,0.47,6820,60626,72,NULL,NULL,'GRB 060526',3.21,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130645,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130645,47.35,0.46,7010,60626,70,NULL,NULL,'GRB 060526',3.21,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130646,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130646,47.53,0.53,7620,60626,NULL,NULL,NULL,'GRB 060526',3.21,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130647,'GRB','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130647,47.56,0.43,7720,60626,69.7,NULL,'Fiducial','GRB 060526',3.21,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130648,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130648,37.88,0.33,376,60627,70,NULL,NULL,'2MASX J15311870+3736444',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,232.827875,37.61214,0.049,NULL,60098693496,939042085,14672532,17.9),(130649,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130649,35.14,0.46,107,60628,70,NULL,NULL,'2MASX J15311870+3604483',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000154,NULL,'15.9g',0.37,'SAB0',NULL,NULL,NULL,NULL,1,232.8280417,36.08006,0.049,NULL,60105479529,939148117,14674189,15.9),(130650,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130650,37.61,0.12,333,60629,70,NULL,NULL,'2MASX J15311889+5303208',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.8285417,53.05567,0.033,NULL,59669528496,932336382,14567755,17.6),(130651,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130651,36.67,0.46,215,60630,70,NULL,NULL,'2MASX J15312008+3427084',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.8337917,34.45244,0.073,NULL,59884504713,935695386,14620240,17.3),(130652,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130652,36.79,0.46,228,60631,70,NULL,NULL,'2MASX J15312047+1443147',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'15.2r',NULL,NULL,NULL,NULL,NULL,NULL,1,232.835417,14.72081,0.117,NULL,59427996836,928562450,14508788,15.2),(130653,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130653,37.24,0.27,281,60632,70,NULL,NULL,'SDSS J153120.65+065003.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.836083,6.83442,0.097,NULL,56416351957,881505499,13773523,17.9),(130654,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130654,32.22,0.8,27.8,60633,75,NULL,NULL,'ESO 008- G 008',NULL,'1988NBGC.C....0000T',1988,1,2.5,'-12h error in A-M RA.','G',0.000022,NULL,'14.0',0.6,'Im',NULL,NULL,NULL,NULL,1,232.842666667,-87.43783,0.437,NULL,44040074045,688126156,10751971,14),(130655,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130655,37.21,0.46,277,60634,70,NULL,NULL,'2MASX J15312226+1443147',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.84275,14.72092,0.117,NULL,59427996827,928562450,14508788,16.2),(130656,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130656,37.55,0.11,323,60635,70,NULL,NULL,'2MASX J15312280+2805340',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,232.844916667,28.09294,0.089,NULL,59917854877,936216482,14628382,16.1),(130657,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130657,38.46,0.46,493,60636,70,NULL,NULL,'2MASX J15312421+5703008',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.8507917,57.05022,0,NULL,57590644271,899853816,14060215,17.8),(130658,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130658,39.09,0.46,658,60637,70,NULL,NULL,'SDSS J153124.71+382311.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,232.853,38.38658,0.041,NULL,60099248960,939050765,14672668,18.7),(130659,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130659,37.58,0.46,329,60638,70,NULL,NULL,'2MASX J15312590+2819200',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.8577083,28.32219,0.065,NULL,59917979668,936218432,14628413,17.4),(130660,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130660,37.83,0.33,368,60639,70,NULL,NULL,'2MASX J15312626+0922017',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.859416667,9.36714,0.073,NULL,56406339837,881349059,13771079,16.7),(130661,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130661,37.62,0.46,334,60640,70,NULL,NULL,'2MASX J15312679+0142448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.861667,1.71247,0.085,NULL,56399451883,881241435,13769397,17.2),(130662,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130662,37.55,0.11,323,60641,70,NULL,NULL,'2MASX J15312688+2814360',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,232.861917,28.24336,0.065,NULL,59917847912,936216373,14628380,16.9),(130663,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130663,37.21,0.46,277,60642,70,NULL,NULL,'2MASX J15312889+5833568',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.870125,58.56572,0.033,NULL,57587972529,899812070,14059563,16.8),(130664,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130664,37.01,0.46,253,60643,70,NULL,NULL,'2MASX J15312974+5212467',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.873916667,52.21311,0.045,NULL,59672864428,932388506,14568570,17.3),(130665,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130665,33,0.8,39.8,60644,75,NULL,'CF, r','NGC 5950',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.00002,NULL,'14.2g',0.69,'Sb',NULL,NULL,NULL,NULL,1,232.878291667,40.43003,0.053,NULL,59964382611,936943478,14639741,14.2),(130666,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130666,32.44,0.43,30.7,60644,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5950',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130667,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130667,32.85,0.38,37.1,60644,75,NULL,'CF, r, raw','NGC 5950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130668,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130668,32.86,0.38,37.4,60644,75,NULL,'CF, r, inv','NGC 5950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130669,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130669,32.97,0.38,39.2,60644,75,NULL,'CF, r, cor','NGC 5950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130670,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130670,37.17,0.46,272,60645,70,NULL,NULL,'2MASX J15313114+3000455',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,232.879833,30.01264,0.069,NULL,59912920444,936139381,14627177,17.7),(130671,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130671,38.11,0.33,418,60646,70,NULL,NULL,'2MASX J15313215+2900560',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.884,29.01561,0.057,NULL,59926365823,936349465,14630460,17.7),(130672,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130672,36.96,0.46,247,60647,70,NULL,NULL,'2MASX J15313232+0511548',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,232.8847917,5.19869,0.101,NULL,56423210148,881612658,13775197,16.8),(130673,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130673,35.78,0.46,143,60648,70,NULL,NULL,'2MASX J15313247+4539275',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000178,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,232.885166667,45.65758,0.029,NULL,59685214529,932581477,14571585,15.6),(130674,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130674,36.22,0.46,176,60649,70,NULL,NULL,'2MASX J15313254+5934599',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,232.8857917,59.58333,0.029,NULL,57738998624,902171853,14096435,16.6),(130675,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130675,36.13,0.14,168,60650,70,NULL,NULL,'2MASX J15313265+0433168',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,232.885958333,4.55478,0.109,NULL,56424546632,881633541,13775524,16.2),(130676,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130676,37.83,0.33,368,60651,70,NULL,NULL,'2MASX J15313328+0922247',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.88875,9.37358,0.073,NULL,56406338330,881349036,13771078,17.4),(130677,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130677,36.41,0.46,192,60652,70,NULL,NULL,'2MASX J15313443+4751094',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,232.8935,47.85278,0.045,NULL,59719546462,933117913,14579967,16.1),(130678,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130678,36.13,0.14,168,60653,70,NULL,NULL,'2MASX J15313446+0434008',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.893583,4.56689,0.109,NULL,56424547003,881633546,13775524,16.3),(130679,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130679,37.52,0.46,320,60654,70,NULL,NULL,'2MASX J15313566+0025348',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,232.898625,0.42614,0.213,NULL,56398654694,881228979,13769202,17.6),(130680,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130680,36.88,0.46,238,60655,70,NULL,NULL,'SDSS J153136.46+332359.1',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.901917,33.39978,0.069,NULL,59885831448,935716116,14620564,16.7),(130681,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130681,37.28,0.46,285,60656,70,NULL,NULL,'2MASX J15313802+0726087',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.908375,7.43569,0.089,NULL,56418092192,881532690,13773948,16.6),(130682,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130682,38.11,0.33,418,60657,70,NULL,NULL,'2MASX J15313853+2853150',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.0002,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.910583,28.88753,0.057,NULL,59926350389,936349224,14630456,17.5),(130683,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130683,37.66,0.46,341,60658,70,NULL,NULL,'2MASX J15313874+0640457',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'16.0g',0.43,NULL,NULL,NULL,NULL,NULL,1,232.9115,6.67933,0.105,NULL,56416359973,881505624,13773525,16),(130684,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130684,35.58,0.33,131,60659,70,NULL,NULL,'NGC 5941',NULL,'2015arXiv151105856S',2015,1,0.68,'NGC identification is not certain.','G',0.0001,NULL,'14.91',0.55,'E2','Compact group member',NULL,NULL,NULL,1,232.917667,7.339,0.089,NULL,56418070627,881532353,13773943,14.91),(130685,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130685,37.76,0.23,356,60660,70,NULL,NULL,'2MASX J15314123-0017474',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.921791667,-0.2965,0.229,NULL,45406403507,709475054,11085547,18),(130686,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130686,37.67,0.17,342,60661,70,NULL,NULL,'2MASX J15314199+0318540',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,232.9249583,3.31503,0.089,NULL,56423933312,881623958,13775374,17.7),(130687,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130687,35.58,0.33,131,60662,70,NULL,NULL,'CGCG 050-010',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000097,NULL,'15.83',0.49,'E?','Group member',NULL,NULL,NULL,1,232.925917,7.28739,0.105,NULL,56418067868,881532310,13773942,15.83),(130688,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130688,37.12,0.46,266,60663,70,NULL,NULL,'2MASX J15314271+5736049',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,232.927833,57.60133,0.045,NULL,57591380927,899865326,14060395,16.7),(130689,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130689,36.67,0.46,216,60664,70,NULL,NULL,'2MASX J15314376+3417045',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000147,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,232.9324583,34.28475,0.057,NULL,59886144500,935721007,14620640,17.3),(130690,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130690,34.8,0.4,91.4,60665,NULL,NULL,'mean','UGC 09896',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.21',1.1,'Scd:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,232.93825,67.55636,0.057,NULL,57970015018,905781484,14152835,14.21),(130691,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130691,34.91,0.47,96,60665,NULL,NULL,'H','UGC 09896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130692,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130692,35.11,0.46,105,60665,NULL,NULL,'J','UGC 09896',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130693,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130693,35.32,0.44,116,60665,NULL,NULL,'Malmquist cor.','UGC 09896',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130694,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130694,35.38,0.43,119,60665,NULL,NULL,NULL,'UGC 09896',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130695,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130695,35.42,0.2,121,60665,74.4,NULL,NULL,'UGC 09896',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130696,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130696,37.55,0.11,323,60666,70,NULL,NULL,'2MASX J15314675+2807189',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,232.944833,28.12189,0.085,NULL,59917852932,936216452,14628382,NULL),(130697,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130697,37.53,0.27,321,60667,70,NULL,NULL,'2MASX J15314698+5908209',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,232.945667,59.13906,0.005,NULL,57617157311,900268082,14066688,16.6),(130698,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130698,36.13,0.14,168,60668,70,NULL,NULL,'2MASX J15314719+0424310',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,232.946583,4.40878,0.109,NULL,56424582805,881634106,13775532,16.1),(130699,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130699,37.45,0.46,309,60669,70,NULL,NULL,'2MASX J15315000+3107129',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000157,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,232.958333,31.12044,0.089,NULL,59914667630,936166681,14627604,17.1),(130700,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130700,38.66,0.46,539,60670,70,NULL,NULL,'2MASX J15315239+2412589',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000198,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,232.968416667,24.21633,0.141,NULL,59417200511,928393757,14506152,17.7),(130701,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130701,35.45,0.56,123,60671,70,NULL,NULL,'2MASX J15315346-3110159',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,232.972666667,-31.17111,0.453,NULL,47164066875,736938544,11514664,15.7),(130702,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130702,37.97,0.33,394,60672,70,NULL,NULL,'2MASX J15315488+3121380',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,232.978625,31.36056,0.037,NULL,59915555571,936180555,14627821,18.4),(130703,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130703,37.76,0.23,356,60673,70,NULL,NULL,'SDSS J153155.35-001707.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,232.980667,-0.28536,0.217,NULL,45405533449,709461460,11085335,18.5),(130704,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130704,37.09,0.46,262,60674,70,NULL,NULL,'2MASX J15315644+1229565',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.985375,12.49914,0.121,NULL,59559296854,930614013,14540843,16.8),(130705,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130705,38.22,0.46,440,60675,70,NULL,NULL,'SDSS J153156.74+090103.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,232.9864583,9.01778,0.093,NULL,56420740248,881574066,13774594,18.6),(130706,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130706,33.85,0.49,58.8,60676,75,NULL,'IR','ESO 514- G 022',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.000027,NULL,'15.5',0.2,'Sc',NULL,NULL,NULL,NULL,1,232.989375,-24.77264,0.405,NULL,46612207872,728315748,11379933,15.5),(130707,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130707,34,0.55,63.1,60676,NULL,NULL,NULL,'ESO 514- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130708,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130708,34.05,0.2,64.6,60676,74.4,NULL,NULL,'ESO 514- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130709,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130709,34.11,0.52,66.4,60676,NULL,NULL,'Malmquist cor.','ESO 514- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130710,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130710,34.12,0.43,66.8,60676,75,NULL,'3.6 micron, color + selection bias corrected','ESO 514- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130711,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130711,34.16,0.43,67.8,60676,75,NULL,'3.6 micron, color corrected','ESO 514- G 022',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130712,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130712,34.25,NULL,70.7,60676,NULL,NULL,NULL,'ESO 514- G 022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130713,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130713,34.58,NULL,82.2,60676,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 514- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130714,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130714,34.59,NULL,82.7,60676,NULL,NULL,'Dipole + Quadrupole','ESO 514- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130715,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130715,34.59,NULL,82.9,60676,NULL,NULL,'Dipole','ESO 514- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130716,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130716,36.08,0.46,164,60677,70,NULL,NULL,'2MASX J15315805+2514138',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00017,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,232.9919583,25.23717,0.145,NULL,59899449498,935928898,14623889,16.5),(130717,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130717,37.17,0.46,272,60678,70,NULL,NULL,'2MASX J15315947+3455530',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.997625,34.93144,0.049,NULL,59885209253,935706394,14620412,16.5),(130718,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130718,37.53,0.27,321,60679,70,NULL,NULL,'SDSS J153159.43+585438.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,232.997625,58.91058,0.009,NULL,57587833653,899809900,14059529,18.3),(130719,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130719,36.04,0.46,162,60680,70,NULL,NULL,'2MASX J15315971+3351270',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,232.999083,33.85736,0.045,NULL,59886222735,935722230,14620659,16.4),(130720,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130720,37.33,0.46,293,60681,70,NULL,NULL,'2MASX J15320008+1727555',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.0002917,17.46547,0.117,NULL,59436154489,928689913,14510779,16.9),(130721,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130721,37.55,0.11,323,60682,70,NULL,NULL,'2MASXi J1532007+280522',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.003,28.08956,0.085,NULL,59918684299,936229442,14628585,17.6),(130722,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 2003K',NULL,130722,33.56,0.19,50.4,60683,74.2,NULL,'SALT 2','IC 1129',0.0219,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000033,NULL,'13.81',0.9,'Scd:','in a radial-velocity based grouping',NULL,NULL,NULL,1,233.003416667,68.24633,0.057,NULL,57970509181,905789205,14152956,13.81),(130723,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 2003K',NULL,130723,34.14,0.1,67.3,60683,74.4,NULL,NULL,'IC 1129',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130724,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130724,35.63,0.46,134,60684,70,NULL,NULL,'CGCG 136-007',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000176,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,233.004833,25.57167,0.161,NULL,59899887451,935935741,14623995,15.5),(130725,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130725,37.28,0.46,286,60685,70,NULL,NULL,'2MASX J15320158+1138453',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.006625,11.64592,0.101,NULL,59341891998,927217062,14487766,16.9),(130726,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130726,37.78,0.33,360,60686,70,NULL,NULL,'2MASX J15320168+0149370',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.007041667,1.827,0.097,NULL,56399251394,881238303,13769348,17.5),(130727,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130727,35.58,0.46,131,60687,70,NULL,NULL,'2MASX J15320183+0451070',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.0077083,4.85194,0.101,NULL,56425130632,881642666,13775666,16.3),(130728,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130728,36.92,0.46,242,60688,70,NULL,NULL,'2MASX J15320208+0015140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000077,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.008833,0.25389,0.213,NULL,56397833661,881216150,13769002,17.2),(130729,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130729,36.54,0.46,203,60689,70,NULL,NULL,'2MASX J15320226+3016290',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8',0.37,'candidate      BLLAC',NULL,NULL,NULL,'BL Lac ?',1,233.009333,30.27472,0.08,NULL,59913005156,936140705,14627198,16.8),(130730,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130730,37.37,0.33,297,60690,70,NULL,NULL,'2MASX J15320294+3053270',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.01225,30.891,0.073,NULL,59914838102,936169345,14627646,17.2),(130731,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130731,37.3,0.33,289,60691,70,NULL,NULL,'SDSS J153204.30+485058.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.017958333,48.84961,0.045,NULL,59719033409,933109897,14579842,18.2),(130732,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130732,37.78,0.33,360,60692,70,NULL,NULL,'2MASX J15320621+0144560',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.0260417,1.74903,0.097,NULL,56399262106,881238470,13769351,17.5),(130733,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130733,37.97,0.33,394,60693,70,NULL,NULL,'2MASX J15320730+3131410',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.030458333,31.52817,0.053,NULL,59915516217,936179940,14627811,17.9),(130734,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130734,38.36,0.46,470,60694,70,NULL,NULL,'SDSS J153207.87+242534.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.8g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.032833,24.42636,0.141,NULL,59417544423,928399131,14506236,18.8),(130735,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130735,37.8,0.33,363,60695,70,NULL,NULL,'2MASX J15320866+1126123',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.0360417,11.43681,0.097,NULL,59341609454,927212647,14487697,17.8),(130736,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130736,37.76,0.23,356,60696,70,NULL,NULL,'2MASX J15320897-0017388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.037416667,-0.29403,0.277,NULL,45405647894,709463248,11085363,17.2),(130737,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130737,37.53,0.27,321,60697,70,NULL,NULL,'2MASX J15320963+5854187',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000222,NULL,'15.7g',0.51,'Elliptical     Sy2',NULL,NULL,NULL,NULL,1,233.040375,58.90508,0.009,NULL,57587832954,899809889,14059529,15.7),(130738,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130738,36.26,0.46,179,60698,70,NULL,NULL,'2MASX J15320995+3741386',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',NULL,NULL,'16.52',0.5,NULL,NULL,NULL,NULL,NULL,1,233.041583333,37.69397,0.061,NULL,60098889041,939045141,14672580,16.52),(130739,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130739,37.92,0.46,384,60699,70,NULL,NULL,'2MASX J15321048+5216063',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000195,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.043583,52.26847,0.045,NULL,59672666628,932385416,14568522,17.1),(130740,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130740,37.55,0.11,323,60700,70,NULL,NULL,'2MASX J15321063+2806127',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000067,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,233.044417,28.10342,0.085,NULL,59918687576,936229493,14628585,16.4),(130741,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130741,36.26,0.46,178,60701,70,NULL,NULL,'2MASX J15321198+4726308',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.05,47.44194,0.045,NULL,59718902487,933107851,14579810,16.3),(130742,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130742,37.27,0.46,284,60702,70,NULL,NULL,'2MASX J15321402+5136543',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.0585,51.61517,0.033,NULL,59673372563,932396446,14568694,17.7),(130743,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130743,37.64,0.46,337,60703,70,NULL,NULL,'2MASX J15321414+2555054',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.059,25.91833,0.161,NULL,59899689833,935932653,14623947,17.3),(130744,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130744,36.08,0.46,164,60704,70,NULL,NULL,'CGCG 078-005',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000127,NULL,'15.1g',0.56,NULL,NULL,NULL,NULL,NULL,1,233.0654583,9.46556,0.053,NULL,56408198348,881378099,13771532,15.1),(130745,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130745,37.18,0.46,273,60705,70,NULL,NULL,'2MASX J15321567+2032338',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.0654583,20.54292,0.189,NULL,59455599345,928993739,14515527,17.5),(130746,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130746,37.91,0.33,382,60706,70,NULL,NULL,'2MASX J15321576+2334238',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000186,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.06575,23.57328,0.153,NULL,59417047728,928391370,14506115,17.9),(130747,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130747,37.45,0.46,309,60707,70,NULL,NULL,'2MASX J15321636+0037566',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000085,NULL,'16.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,233.068166667,0.63231,0.201,NULL,56398642336,881228786,13769199,16.7),(130748,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130748,37.8,0.33,363,60708,70,NULL,NULL,'2MASX J15321675+1122183',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.0699583,11.37161,0.085,NULL,59341615881,927212748,14487699,16.8),(130749,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130749,37.8,0.46,363,60709,70,NULL,NULL,'SDSS J153217.07+114458.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.071167,11.7495,0.105,NULL,59341192080,927206126,14487595,18.1),(130750,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130750,37.32,0.46,291,60710,70,NULL,NULL,'2MASX J15321730+1912148',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,233.072083,19.20394,0.161,NULL,59443691577,928807680,14512620,17),(130751,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130751,34.32,0.75,73.1,60711,NULL,NULL,NULL,'ESO 582- G 018',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.73',0.5,'S...',NULL,NULL,NULL,NULL,1,233.074833333,-20.47353,0.589,NULL,46639126173,728736346,11386505,14.73),(130752,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130752,34.59,0.2,82.8,60711,74.4,NULL,NULL,'ESO 582- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130753,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130753,34.76,0.61,89.6,60711,NULL,NULL,'Malmquist cor.','ESO 582- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130754,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130754,34.11,0.69,66.2,60712,100,NULL,'mid-IR','CGCG 022-008',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00015,NULL,'14.7',0.9,'SA(s)m?',NULL,NULL,NULL,NULL,1,233.076833,-2.82236,0.377,NULL,45411978329,709562161,11086908,14.7),(130755,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130755,37.55,0.11,323,60713,70,NULL,NULL,'2MASX J15321851+2802444',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000097,NULL,'16.34',0.1,NULL,NULL,NULL,NULL,NULL,1,233.077041667,28.04564,0.085,NULL,59918702941,936229733,14628589,16.34),(130756,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130756,37.51,0.46,318,60714,70,NULL,NULL,'2MASX J15321917+2200095',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.07975,22.00256,0.137,NULL,59452038697,928938104,14514657,16.4),(130757,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130757,37.35,0.46,295,60715,70,NULL,NULL,'2MASX J15321948+2922574',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.71',0.21,NULL,NULL,NULL,NULL,NULL,1,233.081167,29.38264,0.061,NULL,59926287961,936348249,14630441,16.71),(130758,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130758,36.91,0.46,241,60716,70,NULL,NULL,'2MASX J15321963+0011356',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.0817083,0.19325,0.213,NULL,56397914577,881217415,13769022,16.6),(130759,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130759,37.44,0.33,308,60717,70,NULL,NULL,'2MASX J15321991-0030108',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.082875,-0.50294,0.277,NULL,45406316461,709473694,11085526,17.4),(130760,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130760,36.13,0.14,168,60718,70,NULL,NULL,'2MASX J15321997+0503056',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,233.083125,5.05144,0.101,NULL,56425101814,881642215,13775659,15.6),(130761,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130761,37.21,0.46,276,60719,70,NULL,NULL,'2MASX J15322150+0030216',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.089541667,0.50597,0.201,NULL,56398617523,881228398,13769193,17),(130762,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130762,36.04,0.46,161,60720,70,NULL,NULL,'2MASX J15322256+0100096',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000081,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.094,1.00278,0.169,NULL,56398147280,881221051,13769078,16.3),(130763,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130763,35.14,0.53,107,60721,70,NULL,NULL,'2MASX J15322312-0645528',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000027,NULL,'16.55',0.8,NULL,NULL,NULL,NULL,NULL,1,233.096333,-6.76478,0.397,NULL,45388626940,709197295,11081207,16.55),(130764,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130764,37.55,0.11,323,60722,70,NULL,NULL,'2MASX J15322320+2757184',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00008,NULL,'15.3R',0.37,NULL,NULL,NULL,NULL,NULL,1,233.096625,27.95522,0.085,NULL,59918709242,936229831,14628591,15.3),(130765,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130765,37.34,0.14,294,60723,70,NULL,NULL,'2MASX J15322384+3104169',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.0992083,31.07153,0.069,NULL,59914792284,936168629,14627634,17.9),(130766,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130766,35.2,0.49,110,60724,70,NULL,NULL,'2MASX J15322417-1223547',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.03',NULL,NULL,NULL,NULL,NULL,NULL,1,233.1007917,-12.39864,0.533,NULL,46657544322,729024130,11391002,16.03),(130767,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130767,37.89,0.46,378,60725,70,NULL,NULL,'2MASX J15322450+1058256',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.102167,10.97372,0.077,NULL,56405519368,881336240,13770878,17.7),(130768,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130768,36.81,0.46,230,60726,70,NULL,NULL,'2MASX J15322470+2205235',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.102917,22.08992,0.137,NULL,59452058508,928938414,14514662,16.9),(130769,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130769,37.28,0.46,285,60727,70,NULL,NULL,'2MASX J15322526+5805188',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.1054583,58.08872,0.025,NULL,57588498539,899820289,14059692,17.2),(130770,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130770,37.89,0.33,379,60728,70,NULL,NULL,'2MASX J15322531+2121205',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,233.105583,21.35581,0.161,NULL,59456339243,929005300,14515707,16.2),(130771,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130771,37.3,0.33,289,60729,70,NULL,NULL,'2MASX J15322581+4849594',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.0002,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,233.107458333,48.83325,0.045,NULL,59721933637,933155213,14580550,15.6),(130772,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130772,37.54,0.27,322,60730,70,NULL,NULL,'2MASX J15322580+1045386',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000177,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.107625,10.76072,0.069,NULL,56405374884,881333982,13770843,16.6),(130773,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130773,37.75,0.46,355,60731,70,NULL,NULL,'2MASX J15322668+1429078',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,233.111167,14.48553,0.117,NULL,59427378627,928552791,14508637,NULL),(130774,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130774,36.13,0.14,168,60732,70,NULL,NULL,'2MASX J15322820+0440516',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.04',0.3,NULL,NULL,NULL,NULL,NULL,1,233.117583333,4.68108,0.109,NULL,56424993820,881640528,13775633,17.04),(130775,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130775,38.42,0.46,483,60733,70,NULL,NULL,'2MASX J15322902+2218215',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.120833,22.306,0.145,NULL,59452126021,928939469,14514679,17.6),(130776,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130776,37.44,0.33,308,60734,70,NULL,NULL,'SDSS J153229.11-002755.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.121333,-0.46556,0.277,NULL,45405617430,709462772,11085355,18.2),(130777,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130777,37.54,0.27,322,60735,70,NULL,NULL,'2MASX J15322919+1046236',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.1215417,10.77322,0.069,NULL,56405374532,881333977,13770843,18.3),(130778,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130778,37.55,0.11,323,60736,70,NULL,NULL,'2MASX J15322916+2759104',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'16.35',0.1,NULL,NULL,NULL,NULL,NULL,1,233.121667,27.98633,0.085,NULL,59918712824,936229887,14628591,16.35),(130779,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130779,37.25,0.46,282,60737,70,NULL,NULL,'SDSS J153230.75-011436.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.128166667,-1.24358,0.317,NULL,45405989500,709468585,11085446,18.1),(130780,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130780,37.91,0.33,382,60738,70,NULL,NULL,'2MASX J15323104+2334405',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.1295,23.57814,0.153,NULL,59417042909,928391295,14506113,17.7),(130781,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130781,37.74,0.46,354,60739,70,NULL,NULL,'2MASX J15323187+2441564',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.132833,24.699,0.145,NULL,59417479157,928398111,14506220,17.7),(130782,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130782,36.13,0.14,168,60740,70,NULL,NULL,'UGC 09886',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00012,NULL,'15.1',1,'S0-:;BrClG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,233.133416667,4.681,0.109,NULL,56424994689,881640542,13775633,15.1),(130783,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130783,37.37,0.33,297,60741,70,NULL,NULL,'2MASX J15323220+3050120',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.134166667,30.83664,0.073,NULL,59914810367,936168911,14627639,17.2),(130784,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130784,38,0.19,398,60742,70,NULL,NULL,'2MASX J15323224+0148116',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.134208333,1.80328,0.149,NULL,56401106847,881267294,13769801,18.1),(130785,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130785,37.65,0.46,338,60743,70,NULL,NULL,'2MASX J15323239+5341254',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.1347083,53.69053,0.041,NULL,59670231150,932347361,14567927,17.6),(130786,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130786,37.22,0.46,278,60744,70,NULL,NULL,'2MASX J15323262+0635116',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.135958333,6.58647,0.105,NULL,56416500105,881507814,13773559,16.6),(130787,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130787,39.29,0.46,722,60745,70,NULL,NULL,'SDSS J153233.09+241226.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.137875,24.20733,0.141,NULL,59417117226,928392456,14506132,18.1),(130788,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130788,37.37,0.46,298,60746,70,NULL,NULL,'2MASX J15323396+3101220',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.141541667,31.02275,0.069,NULL,59914837838,936169341,14627645,18.5),(130789,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130789,35.82,0.46,146,60747,70,NULL,NULL,'2MASX J15323457+3854585',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000178,NULL,'15.6g',0.37,'S0',NULL,NULL,NULL,NULL,1,233.1440417,38.91622,0.053,NULL,60100036180,939063065,14672860,15.6),(130790,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130790,36.13,0.14,168,60748,70,NULL,NULL,'2MASX J15323489+0441316',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.145333,4.69214,0.109,NULL,56424994133,881640533,13775633,17.2),(130791,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130791,35.21,0.46,110,60749,70,NULL,NULL,'CGCG 078-006',NULL,'2015arXiv151105856S',2015,1,0.84,'Position in 1991AJ....102.1581B is incorrect.','G',0.0001,NULL,'14.9g',0.52,NULL,NULL,NULL,NULL,NULL,1,233.1455417,10.31906,0.061,NULL,56408949116,881389829,13771716,14.9),(130792,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130792,38,0.19,398,60750,70,NULL,NULL,'2MASX J15323537+0147176',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.147375,1.78825,0.149,NULL,56401124233,881267566,13769805,17.5),(130793,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130793,36.13,0.14,168,60751,70,NULL,NULL,'2MASX J15323576+0444326',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,233.149041667,4.74244,0.109,NULL,56425046780,881641355,13775646,15.9),(130794,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130794,37.55,0.11,323,60752,70,NULL,NULL,'2MASX J15323687+2802104',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00013,NULL,'16.51',0.2,'dE5?;cand. dwarf','Dwarf, within FOV of cluster',NULL,NULL,NULL,1,233.1537083,28.03614,0.085,NULL,59918698422,936229662,14628588,16.51),(130795,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130795,37.65,0.46,339,60753,70,NULL,NULL,'2MASX J15323706-0108297',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000103,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.154416667,-1.14147,0.317,NULL,45406193961,709471780,11085496,17),(130796,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130796,37.54,0.27,322,60754,70,NULL,NULL,'2MASX J15323720+1044466',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.1550417,10.74619,0.069,NULL,56405373689,881333963,13770843,17.5),(130797,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130797,38.32,0.46,462,60755,70,NULL,NULL,'SDSS J153237.44+062825.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.1560417,6.47386,0.105,NULL,56416420714,881506573,13773540,18),(130798,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130798,37.97,0.46,392,60756,70,NULL,NULL,'2MASX J15323772+2028295',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.157125,20.47506,0.189,NULL,59457444751,929022574,14515977,17.8),(130799,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130799,37.13,0.46,267,60757,70,NULL,NULL,'SDSS J153238.00+310715.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.158333,31.12083,0.089,NULL,59914670098,936166720,14627605,17.2),(130800,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130800,38,0.19,398,60758,70,NULL,NULL,'2MASX J15323953+0148139',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.1647917,1.80394,0.149,NULL,56401131549,881267680,13769807,17.2),(130801,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130801,37.58,0.46,329,60759,70,NULL,NULL,'2MASX J15324097+3859394',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000178,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,233.170833,38.99431,0.053,NULL,60100031060,939062985,14672859,16.4),(130802,'BCG','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130802,37.7,0.35,323,60760,60,NULL,NULL,'ABELL 2089',0.0743,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000337,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,233.172167,28.01547,0.085,NULL,59918699664,936229682,14628588,NULL),(130803,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130803,36.63,0.46,212,60761,70,NULL,NULL,'2MASX J15324418+3506140',NULL,'2015arXiv151105856S',2015,1,0.36,'The FIRST source is 7.6 arcsec to the southeast.','G',0.000161,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.184083,35.10375,0.061,NULL,59885077193,935704331,14620380,16.9),(130804,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130804,37.55,0.11,323,60762,70,NULL,NULL,'B2 1530+28',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'15.5',0.2,'AGN',NULL,NULL,NULL,NULL,1,233.186417,28.06314,0.085,NULL,59918690783,936229543,14628586,15.5),(130805,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130805,37.29,0.46,288,60763,70,NULL,NULL,'2MASX J15324590+3634225',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.191167,36.57292,0.045,NULL,60098148278,939033566,14672399,17),(130806,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130806,37.45,0.46,309,60764,70,NULL,NULL,'2MASX J15324612+5602108',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000145,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.1922083,56.03636,0.009,NULL,57592665507,899885398,14060709,16.9),(130807,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130807,36.79,0.46,228,60765,70,NULL,NULL,'2MASX J15324637+0418299',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.1932083,4.30836,0.109,NULL,56424716523,881636195,13775565,16),(130808,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130808,36.72,0.46,220,60766,70,NULL,NULL,'2MASX J15324666+3625164',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000175,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.194333,36.42119,0.045,NULL,60098092208,939032690,14672385,16.6),(130809,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130809,36.07,0.46,164,60767,70,NULL,NULL,'CGCG 136-009',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000157,NULL,'15.4',0.53,NULL,NULL,NULL,NULL,NULL,1,233.194667,23.18481,0.129,NULL,59451675460,928932429,14514569,15.4),(130810,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130810,38,0.19,398,60768,70,NULL,NULL,'2MASX J15324820+0207379',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.200875,2.12731,0.113,NULL,56401241031,881269391,13769834,17.3),(130811,'BCG','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130811,37.7,0.35,323,60769,60,NULL,'ABELL 2089, BCG','2MASX J15324982+2802224',0.0743,'1980ApJ...241..486H',1980,1,1.1,NULL,'G',0.000067,NULL,'14.5R',0.4,'cD','Brightest group member',NULL,NULL,NULL,1,233.207625,28.0395,0.085,NULL,59918700255,936229691,14628588,14.5),(130812,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130812,37.55,0.11,323,60769,70,NULL,NULL,'2MASX J15324982+2802224',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130813,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130813,37.89,0.33,379,60770,70,NULL,NULL,'2MASX J15325009+2127280',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.208583333,21.45767,0.173,NULL,59456194236,929003034,14515672,18.2),(130814,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130814,37.61,0.46,333,60771,70,NULL,NULL,'2MASX J15325025+2151410',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.209458333,21.86144,0.141,NULL,59451512184,928929877,14514529,17.2),(130815,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130815,35.56,0.58,129,60772,70,NULL,NULL,'2MASX J15325210-0650082',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.0001,NULL,'16.71',0.5,NULL,NULL,NULL,NULL,NULL,1,233.2169583,-6.83569,0.397,NULL,45388438727,709194355,11081161,16.71),(130816,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130816,36.66,0.46,215,60773,70,NULL,NULL,'SDSS J153252.71+302532.5',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000177,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,233.219625,30.42572,0.061,NULL,59912986695,936140417,14627194,16.2),(130817,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130817,37.14,0.46,268,60774,70,NULL,NULL,'2MASX J15325397+1307034',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.224916667,13.11767,0.113,NULL,59425491170,928523299,14508176,17.4),(130818,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130818,36.42,0.46,192,60775,70,NULL,NULL,'2MASX J15325447+3324120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000135,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.227,33.40331,0.069,NULL,59885820633,935715947,14620561,17),(130819,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130819,37.44,0.46,307,60776,70,NULL,NULL,'SDSS J153254.75-012537.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000153,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.228167,-1.42719,0.317,NULL,45414098985,709595296,11087426,18.6),(130820,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130820,36.61,0.46,210,60777,70,NULL,NULL,'2MASX J15325566+4204186',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000186,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,233.2317917,42.07175,0.069,NULL,59963330782,936927043,14639485,16.1),(130821,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130821,37.41,0.46,304,60778,70,NULL,NULL,'2MASX J15325701+0150319',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.237625,1.84225,0.149,NULL,56401119684,881267495,13769804,16.9),(130822,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130822,30.87,0.8,15,60779,75,NULL,'B','UGC 09893',NULL,'1988NBGC.C....0000T',1988,1,1.39,NULL,'G',0.00002,NULL,'14.9g',0.48,'Pec','Isolated galaxy',NULL,NULL,NULL,1,233.238667,46.45264,0.025,NULL,59685742691,932589729,14571714,14.9),(130823,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130823,37.35,0.27,296,60780,70,NULL,NULL,'SDSS J153257.95+453345.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.2415,45.56275,0.017,NULL,59688644812,932635075,14572423,18),(130824,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130824,36.19,0.27,173,60781,70,NULL,NULL,'CGCG 022-010',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.00006,NULL,'14.8g',0.64,'E0','Group member',NULL,NULL,NULL,1,233.2417917,0.44072,0.201,NULL,56397769517,881215148,13768986,14.8),(130825,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130825,35.96,0.46,155,60782,70,NULL,NULL,'CGCG 022-011',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000084,NULL,'15.9g',0.26,'S0',NULL,NULL,NULL,NULL,1,233.2419583,0.71069,0.189,NULL,56398580019,881227812,13769184,15.9),(130826,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130826,36.5,0.46,199,60783,70,NULL,NULL,'2MASX J15325908+0742550',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.24625,7.71536,0.073,NULL,56421267833,881582309,13774723,16.5),(130827,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130827,37.55,0.11,323,60784,70,NULL,NULL,'2MASX J15325912+2753405',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000073,NULL,'15.4R',0.7,NULL,NULL,NULL,NULL,NULL,1,233.2465,27.89472,0.089,NULL,59918679721,936229370,14628583,15.4),(130828,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN CLN12Did','N',130828,43.28,0.09,2450,60785,71.6,NULL,'MLCS2k2','SN CLN12Did',0.851,'2014ApJ...786....9P',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130829,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN CLN12Did','N',130829,43.33,0.15,2500,60785,71.6,NULL,'SALT 2','SN CLN12Did',0.851,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130830,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN CLN12Did','N',130830,43.43,0.09,2620,60785,71.6,NULL,'MLCS2k2 + G Lens = 0.15 mag','SN CLN12Did',0.851,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130831,'SNIa','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN CLN12Did','N',130831,43.57,0.15,2800,60785,71.6,NULL,'SALT 2 + G Lens = 0.24 mag','SN CLN12Did',0.851,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130832,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130832,36.5,0.33,200,60786,70,NULL,NULL,'2MASX J15325995+0058089',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000097,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,233.249875,0.96917,0.181,NULL,56402481407,881288771,13770137,15.9),(130833,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130833,35.36,0.2,118,60787,74.4,NULL,NULL,'CGCG 136-010',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000088,NULL,'15.7g',0.42,'Sa',NULL,NULL,NULL,NULL,1,233.252,25.56867,0.157,NULL,59899850818,935935169,14623987,15.7),(130834,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130834,36.2,0.46,173,60788,70,NULL,NULL,'SDSS J153300.86+171625.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.253625,17.27381,0.101,NULL,59437964085,928718188,14511221,17.2),(130835,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130835,37.97,0.46,393,60789,70,NULL,NULL,'2MASX J15330162+0017019',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,'PHOT','17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.256667,0.28383,0.213,NULL,56397899053,881217172,13769018,17.3),(130836,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130836,36.19,0.27,173,60790,70,NULL,NULL,'2MASX J15330228+0025119',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.259625,0.41994,0.201,NULL,56397767957,881215124,13768986,16.2),(130837,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130837,37.83,0.46,368,60791,70,NULL,NULL,'2MASX J15330365+3336069',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.2652917,33.60186,0.053,NULL,59886083600,935720056,14620625,17.1),(130838,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130838,38,0.19,398,60792,70,NULL,NULL,'SDSS J153303.75+015714.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.265625,1.95411,0.149,NULL,56401308929,881270452,13769850,18.3),(130839,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130839,37.51,0.46,318,60793,70,NULL,NULL,'2MASX J15330525+3129219',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.2719583,31.48936,0.065,NULL,59914192713,936159261,14627488,18.2),(130840,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130840,32.2,0.69,27.6,60794,100,NULL,'mid-IR','IC 1125',NULL,'2013ApJ...771...88L',2013,1,1.4,'Noted possibly interacting in MCG/UGC, coalescent pair in VV.  Star superposed.','G',0.00002,NULL,'14.2g',0.69,'S-Irr          HII','Pair member (points to parent)',NULL,NULL,NULL,1,233.273375,-1.62825,0.317,NULL,45415142492,709611601,11087681,14.2),(130841,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130841,32.26,0.43,28.3,60794,75,NULL,'3.6 micron, color + selection bias corrected','IC 1125',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130842,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130842,32.39,0.43,30,60794,75,NULL,'3.6 micron, color corrected','IC 1125',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130843,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130843,32.5,0.2,31.6,60794,74.4,NULL,NULL,'IC 1125',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130844,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130844,32.65,0.49,33.9,60794,75,NULL,'IR','IC 1125',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130845,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130845,32.72,0.6,35,60794,NULL,NULL,'Malmquist cor.','IC 1125',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130846,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130846,32.74,0.59,35.3,60794,NULL,NULL,NULL,'IC 1125',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130847,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130847,37.9,0.46,380,60795,70,NULL,NULL,'SDSS J153305.62+005430.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000073,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.273417,0.90858,0.181,NULL,56402456181,881288377,13770130,18.5),(130848,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130848,37.83,0.46,368,60796,70,NULL,NULL,'2MASX J15330706+0327393',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.27925,3.46078,0.085,NULL,56393646940,881150733,13767980,17.3),(130849,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130849,37.22,0.46,278,60797,70,NULL,NULL,'2MASX J15330723+0707120',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.2800417,7.11986,0.105,NULL,56416232987,881503640,13773494,16.7),(130850,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130850,36.13,0.14,168,60798,70,NULL,NULL,'2MASX J15330725+0445203',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.93',0.39,NULL,NULL,NULL,NULL,NULL,1,233.2802083,4.75564,0.109,NULL,56425846698,881653854,13775841,16.93),(130851,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130851,38.63,0.46,532,60799,70,NULL,NULL,'SDSS J153307.49+195744.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.28125,19.96228,0.229,NULL,59456905028,929014141,14515845,18.6),(130852,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130852,37.97,0.46,392,60800,70,NULL,NULL,'2MASX J15330797+0649510',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.283167,6.83069,0.097,NULL,56416330282,881505160,13773518,17.4),(130853,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130853,37.55,0.11,323,60801,70,NULL,NULL,'SDSS J153308.81+275823.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,233.2867083,27.97314,0.085,NULL,59918671287,936229238,14628581,NULL),(130854,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130854,37.35,0.27,296,60802,70,NULL,NULL,'2MASX J15330906+4533516',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.287667,45.56433,0.017,NULL,59688645171,932635080,14572423,16.5),(130855,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130855,35.73,0.57,140,60803,70,NULL,NULL,'2MASX J15330950-0151579',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000103,NULL,'15.6g',0.3,'E0',NULL,NULL,NULL,NULL,1,233.2897083,-1.86603,0.337,NULL,45412300347,709567192,11086987,15.6),(130856,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130856,35.97,0.46,156,60803,70,NULL,NULL,'2MASX J15330950-0151579',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130857,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130857,37.26,0.33,283,60804,70,NULL,NULL,'2MASX J15331002+2729204',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.19,'AGN',NULL,NULL,NULL,NULL,1,233.2917917,27.48897,0.105,NULL,59918247114,936222611,14628478,16.8),(130858,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130858,36.19,0.27,173,60805,70,NULL,NULL,'2MASX J15331041+0029263',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000097,NULL,'16.2g',0.41,'E0',NULL,NULL,NULL,NULL,1,233.2934583,0.49075,0.201,NULL,56397763951,881215061,13768985,16.2),(130859,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130859,37.75,0.33,354,60806,70,NULL,NULL,'2MASX J15331066+2207451',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.294417,22.12928,0.145,NULL,59451543491,928930367,14514536,17.9),(130860,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130860,38.7,0.46,548,60807,70,NULL,NULL,'2MASX J15331163+5223411',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.2982917,52.39481,0.045,NULL,59670818719,932356542,14568070,18.5),(130861,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130861,38,0.19,398,60808,70,NULL,NULL,'2MASX J15331201+0148403',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.300083333,1.81117,0.149,NULL,56401093925,881267092,13769798,17.5),(130862,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130862,37.31,0.46,290,60809,70,NULL,NULL,'2MASX J15331219+2852004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.30075,28.86681,0.061,NULL,59926196231,936346816,14630419,17.4),(130863,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130863,34.41,0.46,76.3,60810,70,NULL,NULL,'CGCG 222-025',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000147,NULL,'14.6g',0.64,'E0',NULL,NULL,NULL,NULL,1,233.304833,41.07661,0.061,NULL,59965898581,936967165,14640111,14.6),(130864,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130864,37.34,0.14,294,60811,70,NULL,NULL,'SDSS J153315.10+310357.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000192,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.312958333,31.06589,0.069,NULL,59914828743,936169199,14627643,17.4),(130865,'BCG','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130865,38.03,0.35,378,60812,60,NULL,'ABELL 2092, BCG','2MASX J15331536+3108430',0.0669,'1980ApJ...241..486H',1980,1,NULL,NULL,'GPair',0.00015,NULL,NULL,NULL,NULL,'Brightest group member',NULL,NULL,NULL,1,233.3132083,31.14483,0.069,NULL,59914696275,936167129,14627611,NULL),(130866,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130866,38.55,0.46,514,60813,70,NULL,NULL,'SDSS J153315.47+305440.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.3145,30.91111,0.069,NULL,59914822086,936169095,14627642,18),(130867,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130867,38.05,0.46,408,60814,70,NULL,NULL,'2MASX J15331591+0927186',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.3162917,9.45525,0.073,NULL,56407849376,881372646,13771447,17.1),(130868,'BCG','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130868,38.03,0.35,378,60815,60,NULL,NULL,'ABELL 2092',0.0669,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,233.320833,31.14861,0.069,NULL,59914696479,936167132,14627611,NULL),(130869,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130869,38.3,0.46,456,60816,70,NULL,NULL,'2MASX J15331774+0046013',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000093,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.323875,0.76708,0.189,NULL,56402706751,881292292,13770192,17.7),(130870,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130870,37.35,0.27,296,60817,70,NULL,NULL,'SDSS J153319.27+453116.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000179,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.330333333,45.52125,0.017,NULL,59688647698,932635120,14572423,18.1),(130871,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130871,37.38,0.46,299,60818,70,NULL,NULL,'2MASX J15331991+2040232',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.332917,20.67317,0.189,NULL,59457565771,929024465,14516007,18),(130872,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130872,37.55,0.11,323,60819,70,NULL,NULL,'2MASX J15332081+2804017',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000113,NULL,'15.97',0.23,NULL,NULL,NULL,NULL,NULL,1,233.3367083,28.06708,0.085,NULL,59918770546,936230789,14628606,15.97),(130873,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130873,37.86,0.46,373,60820,70,NULL,NULL,'SDSS J153321.19+265546.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.3382917,26.92969,0.137,NULL,59919041080,936235016,14628672,18.4),(130874,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130874,36.13,0.14,168,60821,70,NULL,NULL,'CGCG 050-024',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00008,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,233.340417,4.47275,0.109,NULL,56424264640,881629135,13775455,15.6),(130875,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130875,36.5,0.33,200,60822,70,NULL,NULL,'2MASX J15332181+0046433',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000093,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,233.340791667,0.77864,0.189,NULL,56402708123,881292314,13770192,16.1),(130876,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130876,38.58,0.46,520,60823,70,NULL,NULL,'2MASX J15332206+3113440',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.341875,31.22878,0.069,NULL,59914689565,936167024,14627609,18.1),(130877,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130877,37.18,0.46,273,60824,70,NULL,NULL,'2MASX J15332396+5313012',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.349833333,53.21708,0.045,NULL,59669591283,932337363,14567771,17.1),(130878,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130878,37.56,0.46,326,60825,70,NULL,NULL,'2MASX J15332526+4823102',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.355333333,48.38628,0.041,NULL,59719181293,933112207,14579878,17.1),(130879,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130879,35.15,0.52,107,60826,70,NULL,NULL,'2MASX J15332594-0505469',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00005,NULL,'15.1',NULL,NULL,NULL,NULL,NULL,NULL,1,233.358166667,-5.09639,0.377,NULL,45420117187,709689331,11088895,15.1),(130880,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130880,37.72,0.46,350,60827,70,NULL,NULL,'2MASX J15332610+0959097',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.3589583,9.98606,0.077,NULL,56409119172,881392487,13771757,17.6),(130881,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130881,36.59,0.69,208,60828,70,NULL,NULL,'2MASX J15332709-3224091',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,233.3629583,-32.40261,0.481,NULL,47162558371,736914974,11514296,14.2),(130882,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130882,30.85,0.4,14.8,60829,75,NULL,'B','NGC 5963',NULL,'1988NBGC.C....0000T',1988,1,3.3,NULL,'G',0.000033,NULL,'13.1g',2.6,'S pec','Pair member (points to parent)',NULL,NULL,NULL,1,233.366083,56.55969,0,NULL,57592429404,899881709,14060651,13.1),(130883,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130883,32.26,0.6,28.3,60829,NULL,NULL,NULL,'NGC 5963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130884,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130884,32.3,0.2,28.8,60829,74.4,NULL,NULL,'NGC 5963',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130885,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130885,32.39,0.57,30.1,60829,NULL,NULL,'Malmquist cor.','NGC 5963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130886,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130886,32.65,0.4,33.9,60829,NULL,NULL,NULL,'NGC 5963',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130887,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130887,36.27,0.46,180,60830,70,NULL,NULL,'2MASX J15332894+1014307',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000174,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.370833,10.24194,0.061,NULL,56409160902,881393139,13771767,16.3),(130888,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130888,37.81,0.46,365,60831,70,NULL,NULL,'2MASX J15333070+5905045',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.3777917,59.08453,0.009,NULL,57633970460,900530788,14070793,17.1),(130889,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130889,37.53,0.46,321,60832,70,NULL,NULL,'2MASX J15333155+3014104',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000109,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.381375,30.23642,0.069,NULL,59912785894,936137279,14627144,18.1),(130890,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130890,37.85,0.46,371,60833,70,NULL,NULL,'2MASX J15333209+2227492',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.383667,22.46378,0.149,NULL,59451955053,928936797,14514637,16.8),(130891,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130891,37.34,0.14,294,60834,70,NULL,NULL,'2MASX J15333376+3111394',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00013,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,233.390541667,31.19422,0.069,NULL,59914696890,936167138,14627611,16.7),(130892,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130892,37.75,0.33,354,60835,70,NULL,NULL,'2MASX J15333404+2213303',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.3920417,22.22508,0.145,NULL,59451458890,928929045,14514516,16.4),(130893,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130893,36.64,0.46,213,60836,70,NULL,NULL,'2MASX J15333432+3341584',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000067,NULL,'16.25',0.4,NULL,NULL,NULL,NULL,NULL,1,233.393083,33.69961,0.061,NULL,59885412202,935709565,14620461,16.25),(130894,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130894,37.47,0.46,312,60837,70,NULL,NULL,'2MASX J15333528+1827523',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.397125,18.46458,0.133,NULL,59435620498,928681570,14510649,16.5),(130895,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130895,36.56,0.46,205,60838,70,NULL,NULL,'2MASX J15333556+0710507',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.398125,7.18083,0.105,NULL,56416633994,881509906,13773592,16.8),(130896,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130896,38.04,0.46,406,60839,70,NULL,NULL,'SDSS J153336.94-004051.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,233.403916667,-0.68089,0.277,NULL,45413951593,709592993,11087390,18.9),(130897,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130897,37.26,0.33,283,60840,70,NULL,NULL,'2MASX J15333718+2731206',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.4050417,27.52233,0.105,NULL,59918250497,936222664,14628479,17.9),(130898,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130898,38.49,0.46,498,60841,70,NULL,NULL,'2MASX J15333977+3836012',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.415667,38.60036,0.049,NULL,60100141399,939064709,14672886,18),(130899,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130899,35.65,0.46,135,60842,70,NULL,NULL,'CGCG 136-012',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000167,NULL,'15.1g',0.68,NULL,NULL,NULL,NULL,NULL,1,233.416583333,24.40469,0.141,NULL,59417389502,928396710,14506198,15.1),(130900,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130900,37.86,0.46,373,60843,70,NULL,NULL,'2MASX J15334194+0947547',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.4247083,9.79842,0.061,NULL,56408223682,881378495,13771538,17.9),(130901,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130901,37.72,0.46,350,60844,70,NULL,NULL,'2MASX J15334256+0753137',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.427375,7.88714,0.081,NULL,56419214958,881550233,13774222,17.7),(130902,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130902,37.34,0.14,294,60845,70,NULL,NULL,'2MASX J15334274+3036185',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000193,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,233.4279583,30.60525,0.065,NULL,59912806554,936137602,14627150,16.2),(130903,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130903,37.86,0.46,373,60846,70,NULL,NULL,'2MASX J15334296-0105401',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000101,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.428916667,-1.09464,0.313,NULL,45414263340,709597864,11087466,16.9),(130904,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130904,38.53,0.46,508,60847,70,NULL,NULL,'2MASX J15334293+0026371',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.428916667,0.44386,0.201,NULL,56402070109,881282345,13770036,18.1),(130905,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130905,32.3,0.8,28.9,60848,75,NULL,'A82, H','NGC 5951',NULL,'1997ApJS..109..333W',1997,1,3.5,'HOLM 713B is a star.','G',0.000003,NULL,'13.36',0.8,'SBc: sp','in a triple',NULL,NULL,NULL,1,233.429416667,15.00728,0.097,NULL,59427743487,928558491,14508726,13.36),(130906,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130906,31.55,0.4,20.4,60848,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5951',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130907,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130907,31.66,0.4,21.5,60848,75,NULL,NULL,'NGC 5951',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130908,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130908,31.94,0.47,24.5,60848,75,NULL,'A82, H, inv','NGC 5951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130909,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130909,31.97,0.47,24.7,60848,75,NULL,'A82, H, raw','NGC 5951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130910,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130910,31.99,0.2,25,60848,74.4,NULL,NULL,'NGC 5951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130911,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130911,32.07,0.36,25.9,60848,NULL,NULL,NULL,'NGC 5951',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130912,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130912,32.07,0.43,25.9,60848,75,NULL,'3.6 micron, color corrected','NGC 5951',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130913,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130913,32.17,0.4,27.1,60848,NULL,NULL,'mean','NGC 5951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130914,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130914,32.16,0.43,27.1,60848,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5951',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130915,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130915,32.17,0.49,27.2,60848,75,NULL,'IR','NGC 5951',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130916,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130916,32.25,0.47,28.2,60848,75,NULL,'A82, H, cor','NGC 5951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130917,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130917,32.35,0.4,29.5,60848,75,NULL,'B','NGC 5951',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130918,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130918,32.45,0.46,30.9,60848,NULL,NULL,'J','NGC 5951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130919,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130919,32.57,0.47,32.6,60848,NULL,NULL,'H','NGC 5951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130920,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130920,32.62,0.45,33.5,60848,NULL,NULL,'K','NGC 5951',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130921,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130921,38.24,0.46,444,60849,70,NULL,NULL,'2MASX J15334340+0900467',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.430875,9.013,0.089,NULL,56419077534,881548086,13774188,17.5),(130922,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130922,37.89,0.46,379,60850,70,NULL,NULL,'2MASX J15334379+0529111',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.4324583,5.48631,0.113,NULL,56425659911,881650936,13775795,17.7),(130923,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130923,37.63,0.46,336,60851,70,NULL,NULL,'2MASX J15334388+5633384',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.432875,56.56078,0,NULL,57592420452,899881569,14060649,16.9),(130924,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130924,37.58,0.46,328,60852,70,NULL,NULL,'SDSS J153344.27+292034.2',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.4345,29.34283,0.061,NULL,59927112236,936361128,14630642,17.1),(130925,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130925,35.27,0.46,113,60853,70,NULL,NULL,'2MASX J15334448+3913422',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00015,NULL,'15.7g',0.37,'S0             HII',NULL,NULL,NULL,NULL,1,233.4352083,39.22833,0.053,NULL,60099870152,939060471,14672819,15.7),(130926,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130926,37.24,0.46,281,60854,70,NULL,NULL,'2MASX J15334512+1821182',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.4379583,18.35517,0.121,NULL,59435644994,928681953,14510655,18.2),(130927,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130927,37.3,0.46,289,60855,70,NULL,NULL,'SDSS J153345.28+384728.1',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.4387083,38.79114,0.053,NULL,60100169280,939065145,14672892,17.3),(130928,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130928,34.46,0.46,77.8,60856,70,NULL,NULL,'CGCG 136-013',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000083,NULL,'15.2',0.48,'E?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,233.439417,21.01061,0.169,NULL,59456097055,929001516,14515648,15.2),(130929,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130929,37.63,0.33,336,60857,70,NULL,NULL,'2MASX J15334592+3140325',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00011,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,233.44125,31.67567,0.065,NULL,59914334312,936161473,14627523,15.6),(130930,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130930,36.92,0.46,242,60858,70,NULL,NULL,'2MASX J15334596+3618472',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.4415417,36.31308,0.049,NULL,59878993004,935609265,14618894,17.1),(130931,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130931,34.7,0.52,87.3,60859,70,NULL,NULL,'MCG -01-40-003',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,233.442833,-8.77722,0.473,NULL,45398065229,709344769,11083512,15.5),(130932,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130932,36.65,0.33,213,60860,70,NULL,NULL,'2MASX J15334776+0656155',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.449167,6.93769,0.085,NULL,56416602516,881509414,13773584,16.5),(130933,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130933,37.63,0.33,336,60861,70,NULL,NULL,'2MASX J15334788+3141335',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00014,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.449417,31.69261,0.065,NULL,59914332406,936161443,14627522,16.8),(130934,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130934,37.28,0.46,286,60862,70,NULL,NULL,'2MASX J15334934+4034440',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000141,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.455667,40.57897,0.041,NULL,59965401227,936959394,14639990,17.1),(130935,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130935,36.54,0.46,204,60863,70,NULL,NULL,'SDSS J153350.29+092851.4',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.4595417,9.48097,0.073,NULL,56407824099,881372251,13771441,17.1),(130936,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130936,37.34,0.14,294,60864,70,NULL,NULL,'2MASX J15335075+3113024',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.4615,31.21739,0.069,NULL,59914220979,936159702,14627495,18.1),(130937,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130937,36.79,0.46,228,60865,70,NULL,NULL,'2MASXi J1533517+232924',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000181,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,233.465541667,23.49008,0.149,NULL,59450356459,928911819,14514247,15.9),(130938,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130938,37.55,0.46,323,60866,70,NULL,NULL,'2MASX J15335191+3107594',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.466167,31.13319,0.069,NULL,59914207833,936159497,14627492,17.5),(130939,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130939,37.53,0.46,321,60867,70,NULL,NULL,'2MASX J15335258+5809588',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.4692083,58.16625,0.009,NULL,57588553327,899821145,14059705,18),(130940,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130940,37.34,0.14,294,60868,70,NULL,NULL,'2MASX J15335432+3106264',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.4764583,31.10747,0.069,NULL,59914207252,936159488,14627492,18),(130941,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130941,36.43,0.46,193,60869,70,NULL,NULL,'2MASX J15335474+3249334',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.478167,32.82603,0.065,NULL,59883858836,935685294,14620082,17.2),(130942,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130942,37.34,0.14,294,60870,70,NULL,NULL,'2MASX J15335503+3108504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.479333,31.14736,0.069,NULL,59914208014,936159500,14627492,16.8),(130943,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130943,37.55,0.11,323,60871,70,NULL,NULL,'SDSS J153355.28+275402.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,233.4805,27.90069,0.085,NULL,59918551154,936227361,14628552,NULL),(130944,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130944,37.13,0.46,266,60872,70,NULL,NULL,'2MASX J15335542+5250292',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.480916667,52.84144,0.049,NULL,59671365308,932365082,14568204,16.7),(130945,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130945,38.45,0.27,490,60873,70,NULL,NULL,'2MASX J15335548+0715295',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,233.4809583,7.25806,0.113,NULL,56416770287,881512035,13773625,17.2),(130946,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130946,37.15,0.46,269,60874,70,NULL,NULL,'2MASX J15335578-0135551',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.482417,-1.59867,0.337,NULL,45415352082,709614876,11087732,17.8),(130947,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130947,36.88,0.46,238,60875,70,NULL,NULL,'2MASX J15335704+0649255',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'17.32',0.31,NULL,NULL,NULL,NULL,NULL,1,233.4877083,6.82372,0.085,NULL,56416929410,881514522,13773664,17.32),(130948,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130948,38.45,0.27,490,60876,70,NULL,NULL,'2MASX J15335742+0718025',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.489083,7.30067,0.113,NULL,56416778598,881512165,13773627,17.5),(130949,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130949,37.34,0.14,294,60877,70,NULL,NULL,'2MASX J15335750+3023134',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.489666667,30.38697,0.061,NULL,59912786323,936137286,14627145,16.4),(130950,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130950,38.45,0.27,490,60878,70,NULL,NULL,'2MASX J15335971+0718325',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.498875,7.30889,0.113,NULL,56416779543,881512180,13773627,17.4),(130951,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130951,38.42,0.46,482,60879,70,NULL,NULL,'2MASX J15340006+2246201',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.5002083,22.77225,0.153,NULL,59453809456,928965772,14515090,18.3),(130952,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130952,36.65,0.33,213,60880,70,NULL,NULL,'2MASX J15340025+0654015',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000127,NULL,'15.6g',0.45,NULL,NULL,NULL,NULL,NULL,1,233.501,6.90033,0.085,NULL,56417455881,881522748,13773792,15.6),(130953,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130953,34.23,0.59,70.2,60881,70,NULL,NULL,'2MASX J15340046-1555172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.61',NULL,NULL,NULL,NULL,NULL,NULL,1,233.501833,-15.92167,0.365,NULL,46605692831,728213950,11378342,15.61),(130954,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130954,38.26,0.46,449,60882,70,NULL,NULL,'2MASX J15340050-0107171',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.5022917,-1.12136,0.313,NULL,45414256009,709597750,11087464,18.4),(130955,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130955,37.72,0.33,351,60883,70,NULL,NULL,'2MASX J15340132+0724185',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.505583,7.40525,0.113,NULL,56416772902,881512076,13773626,17.1),(130956,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130956,36.72,0.46,220,60884,70,NULL,NULL,'SDSS J153401.88+385338.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.507875,38.89403,0.053,NULL,60099942873,939061607,14672837,17.7),(130957,'SNII optical','2016-12-15 15:15:35','2016-12-16 11:20:49','1','SN 2001cm',NULL,130957,33.18,0.1,42.3,60885,NULL,NULL,'SEAM','NGC 5965',0.011381,'2009ApJ...694.1067P',2009,1,6.16,NULL,'G',0.000017,NULL,'11.5B',0.84,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,233.51025,56.68561,0,NULL,57592392514,899881133,14060642,11.5),(130958,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130958,33.21,NULL,43.8,60885,NULL,NULL,'Dipole','NGC 5965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130959,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130959,33.22,NULL,44,60885,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 5965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130960,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130960,33.22,NULL,44,60885,NULL,NULL,'Dipole + Quadrupole','NGC 5965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130961,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130961,33.27,NULL,45.2,60885,NULL,NULL,NULL,'NGC 5965',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130962,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130962,33.35,0.46,46.8,60885,NULL,NULL,'J','NGC 5965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130963,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130963,33.41,0.47,48,60885,NULL,NULL,'H','NGC 5965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130964,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130964,33.43,0.49,48.4,60885,75,NULL,'IR','NGC 5965',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130965,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130965,33.47,0.4,49.4,60885,NULL,NULL,'mean','NGC 5965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130966,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130966,33.48,0.37,49.7,60885,NULL,NULL,'Malmquist cor.','NGC 5965',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130967,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130967,33.51,0.45,50.3,60885,NULL,NULL,'K','NGC 5965',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130968,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130968,33.58,0.2,52,60885,74.4,NULL,NULL,'NGC 5965',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130969,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130969,33.6,0.35,52.4,60885,NULL,NULL,NULL,'NGC 5965',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130970,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130970,34.3,0.2,72.4,60886,74.4,NULL,NULL,'CGCG 136-016',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000127,NULL,'14.6',0.4,NULL,NULL,NULL,NULL,NULL,1,233.517083333,22.93425,0.157,NULL,59453844221,928966315,14515098,14.6),(130971,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130971,37.17,0.46,272,60887,70,NULL,NULL,'2MASX J15340597+5601589',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000192,NULL,'16.0g',0.44,NULL,NULL,NULL,NULL,NULL,1,233.524958333,56.03308,0.009,NULL,57592714372,899886162,14060721,16),(130972,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130972,37.52,0.46,319,60888,70,NULL,NULL,'2MASX J15340674-0108006',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000089,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.5280417,-1.13347,0.313,NULL,45414253251,709597707,11087464,17.1),(130973,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130973,34.64,0.46,84.8,60889,70,NULL,NULL,'CGCG 107-005',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000169,NULL,'15.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,233.5289583,18.64922,0.137,NULL,59442759774,928793121,14512392,15.7),(130974,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130974,35.67,NULL,136,60890,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1913',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',0.000014,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,233.52925,11.65975,0.105,NULL,56405107063,881329797,13770778,16.6),(130975,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130975,35.69,NULL,137,60890,NULL,NULL,'Dipole + Quadrupole','FGC 1913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130976,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130976,35.71,NULL,139,60890,NULL,NULL,'Dipole','FGC 1913',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130977,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130977,35.71,NULL,139,60890,NULL,NULL,NULL,'FGC 1913',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130978,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130978,36.49,0.2,199,60890,74.4,NULL,NULL,'FGC 1913',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(130979,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130979,37.26,0.46,284,60891,70,NULL,NULL,'2MASX J15340721+5703339',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.5302083,57.05939,0.021,NULL,57590907871,899857935,14060280,16.7),(130980,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130980,37.82,0.46,366,60892,70,NULL,NULL,'2MASX J15340832+2226131',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.534625,22.43706,0.149,NULL,59451448419,928928881,14514513,17.5),(130981,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130981,37.72,0.33,351,60893,70,NULL,NULL,'SDSS J153409.47+072124.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.5394583,7.35689,0.113,NULL,56416781366,881512208,13773628,17.9),(130982,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130982,37.34,0.14,294,60894,70,NULL,NULL,'2MASX J15340950+3113529',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.539583,31.23131,0.069,NULL,59914222527,936159726,14627495,17.3),(130983,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130983,37.35,0.23,296,60895,70,NULL,NULL,'2MASX J15341075+2708105',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.12',0.33,NULL,NULL,NULL,NULL,NULL,1,233.544833,27.13633,0.129,NULL,59919081264,936235644,14628681,17.12),(130984,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130984,38.25,0.46,446,60896,70,NULL,NULL,'2MASX J15341147+0627475',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,'BrClG',NULL,NULL,NULL,NULL,1,233.5479583,6.46331,0.125,NULL,56416829864,881512966,13773640,17.6),(130985,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130985,37.74,0.46,354,60897,70,NULL,NULL,'SDSS J153412.05-012948.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.55025,-1.49686,0.317,NULL,45414201928,709596905,11087451,18.2),(130986,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130986,37.55,0.11,323,60898,70,NULL,NULL,'SDSS J153412.41+280327.6',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000178,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.5517083,28.05767,0.093,NULL,59918762921,936230670,14628604,16.5),(130987,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,130987,34.86,0.49,93.8,60899,70,NULL,NULL,'2MASX J15341393-2111527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'15.47',NULL,NULL,NULL,NULL,NULL,NULL,1,233.558083,-21.19803,0.529,NULL,46638952594,728733634,11386463,15.47),(130988,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130988,37.35,0.23,296,60900,70,NULL,NULL,'2MASX J15341454+2657475',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,233.5607083,26.96328,0.133,NULL,59919100841,936235950,14628686,16.4),(130989,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130989,38.19,0.46,435,60901,70,NULL,NULL,'2MASX J15341470+0810565',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.5612917,8.18219,0.117,NULL,56419263270,881550988,13774234,18),(130990,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130990,37.45,0.19,309,60902,70,NULL,NULL,'2MASXi J1534149+551658',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.562375,55.28286,0.053,NULL,57586448966,899788265,14059191,17.8),(130991,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130991,35.9,0.33,152,60903,70,NULL,NULL,'2MASX J15341542+2409125',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000168,NULL,'16.87',0.4,NULL,NULL,NULL,NULL,NULL,1,233.564375,24.1535,0.141,NULL,59417103522,928392242,14506128,16.87),(130992,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130992,38.13,0.46,422,60904,70,NULL,NULL,'2MASX J15341761-0137436',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.5734583,-1.62894,0.341,NULL,45415291736,709613933,11087717,18),(130993,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130993,37.4,0.33,302,60905,70,NULL,NULL,'2MASX J15341801+0017365',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000096,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.575041667,0.29347,0.241,NULL,56401883228,881279425,13769991,16.7),(130994,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130994,37.99,0.46,396,60906,70,NULL,NULL,'2MASX J15341920+5225522',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.5802917,52.43106,0.045,NULL,59670831296,932356739,14568074,17.5),(130995,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130995,35.16,0.46,108,60907,70,NULL,NULL,'2MASX J15341928+5447139',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000166,NULL,'15.7g',0.45,'E/S0',NULL,NULL,NULL,NULL,1,233.580375,54.78731,0.053,NULL,57586518561,899789352,14059208,15.7),(130996,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130996,38.42,0.46,483,60908,70,NULL,NULL,'2MASX J15341940+5220542',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000186,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.5807917,52.34856,0.045,NULL,59671028353,932359818,14568122,17.5),(130997,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130997,36.98,0.46,249,60909,70,NULL,NULL,'2MASX J15342119+2523434',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00021,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,233.58825,25.39542,0.157,NULL,59899068027,935922937,14623795,16),(130998,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130998,36.67,0.46,215,60910,70,NULL,NULL,'2MASX J15342315+0155305',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,233.5965,1.92519,0.169,NULL,56404648120,881322626,13770666,NULL),(130999,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',130999,37.35,0.23,296,60911,70,NULL,NULL,'2MASX J15342336+2700414',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.597417,27.01142,0.129,NULL,59919105806,936236028,14628687,17.2),(131000,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131000,37.17,0.91,271,60912,70,NULL,NULL,'2MASX J15342434-1329382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,233.6014583,-13.494,0.637,NULL,46590675834,727979309,11374676,15.6),(131001,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131001,37.18,0.46,273,60913,70,NULL,NULL,'2MASX J15342594+1155301',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.60825,11.92492,0.105,NULL,56405026714,881328542,13770758,17.2),(131002,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131002,38.1,0.46,416,60914,70,NULL,NULL,'2MASX J15342682+5823529',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.611917,58.39814,0.009,NULL,57588393596,899818649,14059666,18.3),(131003,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131003,33.5,0.49,50.2,60915,75,NULL,'IR','UGC 09901',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000003,NULL,'15.06',0.2,'Sbc',NULL,NULL,NULL,NULL,1,233.61225,12.271,0.101,NULL,59559127663,930611369,14540802,15.06),(131004,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131004,33.53,0.2,50.8,60915,74.4,NULL,NULL,'UGC 09901',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131005,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131005,33.7,0.47,55,60915,NULL,NULL,NULL,'UGC 09901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131006,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131006,33.85,0.44,58.8,60915,NULL,NULL,'Malmquist cor.','UGC 09901',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131007,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131007,35.95,0.19,155,60916,70,NULL,NULL,'2MASX J15342763+2509174',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.7g',0.35,'AGN',NULL,NULL,NULL,NULL,1,233.6150417,25.15483,0.145,NULL,59899078343,935923099,14623798,16.7),(131008,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131008,37.35,0.46,295,60917,70,NULL,NULL,'2MASX J15342813+4457245',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000196,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,233.617375,44.95689,0.017,NULL,59686615230,932603362,14571927,16.5),(131009,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131009,37.35,0.23,296,60918,70,NULL,NULL,'2MASX J15342912+2659164',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.71',0.33,NULL,NULL,NULL,NULL,NULL,1,233.6212917,26.98778,0.129,NULL,59919103528,936235992,14628687,16.71),(131010,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131010,36.28,0.82,180,60919,70,NULL,NULL,'2MASX J15342946-0448213',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.12',0.3,NULL,NULL,NULL,NULL,NULL,1,233.622583,-4.80597,0.401,NULL,45419854253,709685222,11088831,17.12),(131011,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131011,35.47,NULL,124,60920,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1917',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000098,NULL,'17.3g',0.11,'Sd',NULL,NULL,NULL,NULL,1,233.625833,33.99092,0.053,NULL,59885450095,935710157,14620471,17.3),(131012,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131012,35.49,NULL,125,60920,NULL,NULL,'Dipole + Quadrupole','FGC 1917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131013,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131013,35.51,NULL,126,60920,NULL,NULL,'Dipole','FGC 1917',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131014,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131014,35.52,NULL,127,60920,NULL,NULL,NULL,'FGC 1917',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131015,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131015,37.01,0.46,253,60921,70,NULL,NULL,'2MASX J15343043+3031159',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.626958333,30.52114,0.061,NULL,59912751291,936136738,14627136,16.9),(131016,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131016,35.95,0.19,155,60922,70,NULL,NULL,'2MASX J15343095+2510264',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'16.3g',0.34,'AGN',NULL,NULL,NULL,NULL,1,233.629,25.17406,0.153,NULL,59899080574,935923133,14623798,16.3),(131017,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131017,37.34,0.14,294,60923,70,NULL,NULL,'2MASX J15343112+3137039',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.6297083,31.61775,0.065,NULL,59914349206,936161706,14627526,17.4),(131018,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131018,32.59,0.8,33,60924,75,NULL,'B','NGC 5953',NULL,'1988NBGC.C....0000T',1988,1,1.35,NULL,'G',0.00002,NULL,'13.0g',1.16,'SAa: pec;LINER;Sy2','Pair member, near/close',NULL,NULL,'Sy 2',1,233.634916667,15.19378,0.093,NULL,59427576022,928555875,14508685,13),(131019,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131019,31.8,0.45,22.9,60924,NULL,NULL,'K','NGC 5953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131020,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131020,31.84,0.47,23.4,60924,NULL,NULL,'H','NGC 5953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131021,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131021,31.94,0.46,24.5,60924,NULL,NULL,'J','NGC 5953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131022,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131022,32.49,0.4,31.5,60924,NULL,NULL,'mean','NGC 5953',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131023,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131023,36.72,0.46,220,60925,70,NULL,NULL,'2MASX J15343282+1118491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.636875,11.31358,0.089,NULL,56405876150,881341814,13770965,17),(131024,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131024,37.66,0.27,341,60926,70,NULL,NULL,'2MASX J15343350+2326513',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.6395417,23.44753,0.149,NULL,59450560201,928915003,14514296,18.2),(131025,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131025,36.05,0.46,162,60927,70,NULL,NULL,'CGCG 078-012',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000185,NULL,'15.6g',0.5,NULL,NULL,NULL,NULL,NULL,1,233.64025,8.35083,0.125,NULL,56419249470,881550772,13774230,15.6),(131026,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131026,36.74,0.46,223,60928,70,NULL,NULL,'2MASX J15343412+0408116',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000099,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,233.642125,4.13661,0.109,NULL,56394091936,881157686,13768088,16),(131027,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131027,37.97,0.33,393,60929,70,NULL,NULL,'2MASX J15343425+1138211',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.642667,11.63911,0.105,NULL,56405258302,881332160,13770815,17),(131028,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131028,32.53,0.4,32.1,60930,75,NULL,'B','NGC 5954',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00001,NULL,'13.7',0.6,'SAB(rs)cd: pec Sy2','Pair member, near/close',NULL,NULL,NULL,1,233.645916667,15.20008,0.093,NULL,59427575974,928555874,14508685,13.7),(131029,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131029,37.74,0.33,353,60931,70,NULL,NULL,'2MASX J15343806+3142064',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000147,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.658416667,31.70181,0.065,NULL,59914344031,936161625,14627525,16.6),(131030,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131030,37.97,0.33,393,60932,70,NULL,NULL,'2MASX J15343806+1137491',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.6585417,11.63025,0.105,NULL,56405202052,881331282,13770801,16.9),(131031,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131031,37.78,0.46,360,60933,70,NULL,NULL,'2MASX J15343856+3414184',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.660625,34.23861,0.057,NULL,59885255101,935707110,14620423,17.7),(131032,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131032,37.34,0.14,294,60934,70,NULL,NULL,'2MASX J15343934+3135454',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.0001,NULL,'15.6g',0.5,'E0',NULL,NULL,NULL,NULL,1,233.663875,31.59594,0.065,NULL,59914352226,936161753,14627527,15.6),(131033,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131033,37.56,0.46,325,60935,70,NULL,NULL,'2MASX J15343990+2341353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.6664583,23.69308,0.153,NULL,59450583909,928915373,14514302,17.2),(131034,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131034,37.88,0.46,377,60936,70,NULL,NULL,'VII Zw 612 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000195,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,233.669667,57.62817,0.025,NULL,57591234579,899863040,14060360,17),(131035,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131035,34.73,0.48,88.5,60937,70,NULL,NULL,'2MASX J15344078-1504192',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.56',NULL,NULL,NULL,NULL,NULL,NULL,1,233.6699583,-15.07222,0.433,NULL,46591658228,727994659,11374916,15.56),(131036,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131036,37.45,0.19,309,60938,70,NULL,NULL,'2MASX J15344256+5508279',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.6775,55.14106,0.053,NULL,57586403504,899787554,14059180,17.8),(131037,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131037,34.43,0.49,76.9,60939,75,NULL,'IR','UGC 09905',NULL,'2011yCatp016004901K',2011,1,0.87,'SDSS DR6 has z = 0.019653 +- 0.000235.','G',0.000117,NULL,'16.4g',0.18,'Scd',NULL,NULL,NULL,NULL,1,233.67875,8.33411,0.125,NULL,56419282334,881551286,13774238,16.4),(131038,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131038,34.91,NULL,96,60939,NULL,NULL,'Dipole','UGC 09905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131039,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131039,34.91,NULL,96.2,60939,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131040,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131040,34.92,NULL,96.3,60939,NULL,NULL,'Dipole + Quadrupole','UGC 09905',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131041,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131041,35.21,0.2,110,60939,74.4,NULL,NULL,'UGC 09905',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131042,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131042,35.58,0.44,131,60939,NULL,NULL,NULL,'UGC 09905',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131043,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131043,35.83,0.39,146,60939,NULL,NULL,'Malmquist cor.','UGC 09905',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131044,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131044,36.74,0.46,223,60940,70,NULL,NULL,'2MASX J15344362+1122472',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,233.681917,11.37986,0.081,NULL,56405881184,881341893,13770967,16.8),(131045,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131045,37.4,0.33,302,60941,70,NULL,NULL,'SDSS J153444.10+001834.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000103,NULL,'18.5g',0.12,'NLAGN',NULL,NULL,NULL,NULL,1,233.68375,0.30964,0.229,NULL,56390356096,881099314,13767176,18.5),(131046,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131046,37.45,0.19,309,60942,70,NULL,NULL,'2MASX J15344442+5509249',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000238,NULL,'15.8g',0.51,NULL,NULL,NULL,NULL,NULL,1,233.685,55.15697,0.053,NULL,57586373878,899787091,14059173,15.8),(131047,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131047,36.81,0.33,230,60943,70,NULL,NULL,'2MASX J15344549+2119182',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'17.17',0.36,NULL,NULL,NULL,NULL,NULL,1,233.6895417,21.32181,0.157,NULL,59455995273,928999926,14515623,17.17),(131048,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131048,37.66,0.27,341,60944,70,NULL,NULL,'2MASX J15344724+2329122',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.2,'ALG',NULL,NULL,NULL,NULL,1,233.696833,23.48664,0.149,NULL,59450562570,928915040,14514297,17.9),(131049,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131049,38.1,0.33,418,60945,70,NULL,NULL,'SDSS J153448.16+195009.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.700667,19.83603,0.193,NULL,59457079224,929016862,14515888,18.5),(131050,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131050,38.04,0.33,406,60946,70,NULL,NULL,'2MASX J15344863+0054486',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.7027083,0.9135,0.213,NULL,56402844716,881294448,13770225,17.3),(131051,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131051,38.47,0.46,495,60947,70,NULL,NULL,'SDSS J153449.64+545219.9',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.00017,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.706875,54.87219,0.053,NULL,57586539961,899789686,14059213,18.7),(131052,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131052,35.59,0.46,131,60948,70,NULL,NULL,'NGC 5969',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000083,NULL,'14.8g',0.63,'E/S0',NULL,NULL,NULL,NULL,1,233.712583333,56.45108,0.013,NULL,57592975384,899890240,14060785,14.8),(131053,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131053,36.81,0.33,230,60949,70,NULL,NULL,'2MASX J15345157+2116162',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.714875,21.27122,0.157,NULL,59455989148,928999830,14515622,17.7),(131054,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131054,38.41,0.46,482,60950,70,NULL,NULL,'SDSS J153452.15+005300.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.7172917,0.88356,0.213,NULL,56402844596,881294446,13770225,18.4),(131055,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131055,37.66,0.27,341,60951,70,NULL,NULL,'2MASX J15345267+2328477',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0001,NULL,'17.5g',0.22,'E',NULL,NULL,NULL,NULL,1,233.7195,23.48003,0.149,NULL,59450438802,928913106,14514267,17.5),(131056,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131056,34.42,0.49,76.7,60952,70,NULL,NULL,'2MASX J15345311-1814534',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,233.7212917,-18.24817,0.413,NULL,46595591377,728056115,11375876,14.9),(131057,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131057,35.22,0.49,111,60953,75,NULL,'IR','UGC 09907',NULL,'2011yCatp016004901K',2011,1,1.13,NULL,'G',0.000102,NULL,'15.6g',0.26,'Sb',NULL,NULL,NULL,NULL,1,233.721833,9.58292,0.061,NULL,56408128133,881377002,13771515,15.6),(131058,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131058,35.36,NULL,118,60953,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131059,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131059,35.39,NULL,119,60953,NULL,NULL,'Dipole + Quadrupole','UGC 09907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131060,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131060,35.43,NULL,122,60953,NULL,NULL,'Dipole','UGC 09907',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131061,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131061,37.36,0.46,296,60954,70,NULL,NULL,'2MASX J15345325+3957035',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.721958333,39.95108,0.053,NULL,60096259531,939004055,14671938,18.2),(131062,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131062,38.04,0.33,406,60955,70,NULL,NULL,'2MASX J15345463+0052346',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.727625,0.87636,0.213,NULL,56402814834,881293981,13770218,17.6),(131063,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131063,35.9,0.33,152,60956,70,NULL,NULL,'CGCG 136-018',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00006,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,233.734625,24.13658,0.141,NULL,59450985620,928921650,14514400,15.6),(131064,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131064,35.9,0.46,152,60957,70,NULL,NULL,'NGC 5952',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000183,NULL,'15.5',0.17,'S0',NULL,NULL,NULL,NULL,1,233.735166667,4.95883,0.117,NULL,56425421193,881647206,13775737,15.5),(131065,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131065,37.74,0.33,353,60958,70,NULL,NULL,'2MASX J15345749+3138124',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.739583,31.63678,0.065,NULL,59914353510,936161773,14627527,18.3),(131066,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131066,37.94,0.19,387,60959,70,NULL,NULL,'2MASX J15345889+3040574',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.745583333,30.68286,0.065,NULL,59914063440,936157241,14627456,17.8),(131067,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131067,37.45,0.19,309,60960,70,NULL,NULL,'2MASX J15345970+5507120',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000187,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,233.748667,55.11997,0.053,NULL,57586410995,899787671,14059182,16.2),(131068,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131068,37.92,0.46,384,60961,70,NULL,NULL,'2MASX J15345984+0035167',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000082,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.749333,0.58794,0.201,NULL,56401971113,881280798,13770012,17.4),(131069,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131069,38.1,0.33,418,60962,70,NULL,NULL,'2MASX J15350001+1949267',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000191,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.75,19.82406,0.193,NULL,59457046812,929016356,14515880,17),(131070,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131070,36.9,0.46,240,60963,70,NULL,NULL,'2MASX J15350111+2320357',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.754833,23.34328,0.149,NULL,59453896594,928967134,14515111,17.8),(131071,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131071,37.94,0.19,387,60964,70,NULL,NULL,'2MASX J15350122+3047214',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.755,30.7895,0.065,NULL,59914072757,936157386,14627459,17.9),(131072,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131072,37.53,0.46,321,60965,70,NULL,NULL,'2MASX J15350179+3826343',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.757541667,38.44286,0.045,NULL,60099561526,939055648,14672744,18),(131073,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131073,36.2,0.86,174,60966,70,NULL,NULL,'2MASX J15350290-1208392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,233.762125,-12.14419,0.517,NULL,45382372655,709099572,11079680,15.1),(131074,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131074,37.53,0.46,321,60967,70,NULL,NULL,'2MASX J15350395+0712493',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.766583,7.21381,0.113,NULL,56417521234,881523769,13773808,16.8),(131075,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131075,36.66,NULL,215,60968,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1923',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.00009,NULL,'17.0g',0.15,'Sc             Sbrst',NULL,NULL,NULL,NULL,1,233.76775,43.14039,0.093,NULL,59963061372,936922833,14639419,17),(131076,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131076,36.67,NULL,215,60968,NULL,NULL,NULL,'FGC 1923',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131077,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131077,36.69,NULL,218,60968,NULL,NULL,'Dipole + Quadrupole','FGC 1923',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131078,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131078,36.74,NULL,223,60968,NULL,NULL,'Dipole','FGC 1923',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131079,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131079,37.08,0.49,260,60968,75,NULL,'IR','FGC 1923',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131080,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131080,37.59,0.46,329,60969,70,NULL,NULL,'2MASX J15350639+1237086',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.776667,12.61908,0.105,NULL,59425117078,928517454,14508085,17.4),(131081,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131081,37.94,0.19,387,60970,70,NULL,NULL,'2MASX J15350650+3044424',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.777041667,30.74517,0.065,NULL,59914075112,936157423,14627459,17.9),(131082,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131082,37.1,0.46,263,60971,70,NULL,NULL,'2MASX J15350773+2132527',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.782167,21.54808,0.169,NULL,59455876535,928998070,14515594,17.5),(131083,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131083,35.25,0.2,112,60972,74.4,NULL,NULL,'UGC 09916',NULL,'2013AJ....146...86T',2013,1,1.03,NULL,'G',0.000033,NULL,'16.1g',0.24,'S?',NULL,NULL,NULL,NULL,1,233.7840417,24.10069,0.141,NULL,59450998198,928921846,14514403,16.1),(131084,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131084,35.54,0.49,128,60973,75,NULL,'IR','UGC 09916',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000033,NULL,'16.1g',0.24,'S?',NULL,NULL,NULL,NULL,1,233.7840417,24.10069,0.141,NULL,59450998198,928921846,14514403,16.1),(131085,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131085,36.11,0.46,167,60974,70,NULL,NULL,'2MASX J15350974-0039501',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000107,NULL,'16.2g',0.41,'NLAGN',NULL,NULL,NULL,'Sy 2',1,233.7904583,-0.66389,0.293,NULL,45414019594,709594056,11087407,16.2),(131086,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131086,31.47,0.4,19.7,60975,75,NULL,'B','UGC 09912',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'14.0',1.7,'SBdm',NULL,NULL,NULL,NULL,1,233.79375,16.54944,0.093,NULL,59441645720,928775714,14512120,14),(131087,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131087,37.48,0.33,313,60976,70,NULL,NULL,'2MASX J15351112+5224247',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.7965417,52.40675,0.049,NULL,59671013567,932359586,14568118,17),(131088,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131088,36.71,0.46,220,60977,70,NULL,NULL,'2MASX J15351125+3402426',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000154,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.796833,34.04508,0.057,NULL,59885272637,935707384,14620427,17),(131089,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131089,36.25,0.46,178,60978,70,NULL,NULL,'2MASX J15351323+0429573',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,233.805291667,4.49919,0.117,NULL,56424149338,881627333,13775427,16.6),(131090,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131090,37.46,0.46,310,60979,70,NULL,NULL,'2MASX J15351341-0220041',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000196,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,233.8059583,-2.33436,0.429,NULL,45415541769,709617840,11087778,17.7),(131091,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131091,37.48,0.33,313,60980,70,NULL,NULL,'2MASX J15351372+5220117',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000203,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.807125,52.33644,0.041,NULL,59671049787,932360152,14568127,16.6),(131092,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131092,37.66,0.46,340,60981,70,NULL,NULL,'2MASX J15351557+3408567',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000142,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,233.814833,34.14922,0.057,NULL,59885288044,935707625,14620431,16.8),(131093,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131093,32.28,0.8,28.5,60982,75,NULL,'B','NGC 5961',NULL,'1988NBGC.C....0000T',1988,1,0.8,'HOLM 715C is a star. Multiple SDSS entries describe this object.','G',0.000067,NULL,'14.5',0.3,'Sb','Possible field galaxy',NULL,NULL,NULL,1,233.818,30.86417,0.069,NULL,59914119497,936158117,14627470,14.5),(131094,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131094,32.89,0.2,37.8,60982,74.4,NULL,NULL,'NGC 5961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131095,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131095,35.14,0.49,107,60983,75,NULL,'IR','UGC 09920',NULL,'2011yCatp016004901K',2011,1,2.18,NULL,'G',0.00001,NULL,'15.0g',0.26,'Sbc',NULL,NULL,NULL,NULL,1,233.823875,30.80328,0.065,NULL,59914067940,936157311,14627457,15),(131096,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131096,35.33,NULL,117,60983,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131097,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131097,35.35,NULL,117,60983,NULL,NULL,'Dipole + Quadrupole','UGC 09920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131098,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131098,35.35,NULL,118,60983,NULL,NULL,'Dipole','UGC 09920',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131099,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131099,35.38,NULL,119,60983,NULL,NULL,NULL,'UGC 09920',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131100,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131100,35.56,0.2,129,60983,74.4,NULL,NULL,'UGC 09920',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131101,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131101,33.03,0.2,40.4,60984,74.4,NULL,NULL,'UGC 09917',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000027,NULL,'14.96',0.5,'SB?',NULL,NULL,NULL,NULL,1,233.8295417,20.84239,0.173,NULL,59458321804,929036278,14516191,14.96),(131102,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131102,37.94,0.19,387,60985,70,NULL,NULL,'2MASX J15351958+3041027',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.831667,30.68403,0.065,NULL,59925334652,936333353,14630208,17.2),(131103,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131103,38.43,0.46,484,60986,70,NULL,NULL,'SDSS J153520.09-005930.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.83375,-0.99167,0.309,NULL,45414722723,709605042,11087578,18.5),(131104,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131104,36.07,0.23,163,60987,70,NULL,NULL,'2MASX J15352060+2722594',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.83575,27.38325,0.121,NULL,59919203588,936237556,14628711,16.2),(131105,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131105,37.61,0.46,332,60988,70,NULL,NULL,'2MASX J15352121+4150264',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.838416667,41.84056,0.061,NULL,59963477492,936929335,14639520,17),(131106,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131106,37.94,0.19,387,60989,70,NULL,NULL,'2MASX J15352167+3041487',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000194,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,233.84025,30.69681,0.065,NULL,59925346229,936333534,14630211,16.8),(131107,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131107,35.95,0.19,155,60990,70,NULL,NULL,'IC 4556',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.00021,NULL,'14.3g',0.85,NULL,'Group member',NULL,NULL,NULL,1,233.8435417,25.29714,0.149,NULL,59899096448,935923382,14623802,14.3),(131108,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131108,37.85,0.46,371,60991,70,NULL,NULL,'2MASX J15352259+3300057',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.84425,33.00167,0.065,NULL,59884157598,935689962,14620155,18.2),(131109,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131109,38.13,0.33,423,60992,70,NULL,NULL,'2MASX J15352340+0942210',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.8475417,9.70594,0.049,NULL,56408142934,881377233,13771519,17.7),(131110,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131110,37.94,0.19,387,60993,70,NULL,NULL,'2MASX J15352663+3041317',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000198,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,233.861167,30.69208,0.065,NULL,59925346100,936333532,14630211,17),(131111,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131111,38.13,0.33,423,60994,70,NULL,NULL,'2MASX J15352732+0950010',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,233.86375,9.83347,0.049,NULL,56408098705,881376542,13771508,17.4),(131112,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131112,35.95,0.46,155,60995,70,NULL,NULL,'2MASX J15352738+5423023',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000184,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,233.8642917,54.38394,0.045,NULL,59669971022,932343297,14567864,15.5),(131113,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131113,36.84,0.61,233,60996,70,NULL,NULL,'2MASX J15352824-3307053',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,233.86775,-33.11822,0.553,NULL,47155469641,736804213,11512565,14.2),(131114,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131114,36.38,0.46,189,60997,70,NULL,NULL,'2MASX J15353061-0107101',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000086,NULL,'16.4g',0.28,'S0^-',NULL,NULL,NULL,NULL,1,233.877583,-1.11939,0.337,NULL,45414842744,709606917,11087608,16.4),(131115,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131115,38.45,0.33,491,60998,70,NULL,NULL,'2MASX J15353103+4618083',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.87925,46.30222,0.025,NULL,59688443969,932631937,14572374,17.8),(131116,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131116,37.63,0.46,336,60999,70,NULL,NULL,'SDSS J153531.03+112008.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.879333333,11.33578,0.081,NULL,56405596223,881337440,13770897,18),(131117,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131117,38.58,0.46,520,61000,70,NULL,NULL,'2MASX J15353125+1831076',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.880041667,18.51875,0.109,NULL,59435400136,928678127,14510595,18.2),(131118,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131118,37.35,0.46,295,61001,70,NULL,NULL,'2MASX J15353233+3412137',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.884625,34.20383,0.057,NULL,59885286393,935707599,14620431,18.1),(131119,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131119,37.5,0.46,316,61002,70,NULL,NULL,'SDSS J153532.36+015230.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.884875,1.87525,0.157,NULL,56404848597,881325759,13770714,17.9),(131120,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131120,38.02,0.33,401,61003,70,NULL,NULL,'2MASX J15353359+2013566',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,233.889917,20.23231,0.189,NULL,59457483654,929023182,14515987,18),(131121,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131121,37.21,0.46,276,61004,70,NULL,NULL,'SDSS J153533.64+402135.6',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.3g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.8902083,40.35992,0.041,NULL,59962330869,936911419,14639240,16.3),(131122,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131122,37.27,0.46,284,61005,70,NULL,NULL,'2MASX J15353361+3045127',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000181,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,233.8902917,30.75347,0.065,NULL,59925344114,936333501,14630210,16.1),(131123,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131123,37.45,0.19,309,61006,70,NULL,NULL,'2MASX J15353438+5514134',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.893375,55.23711,0.005,NULL,57586858558,899794664,14059291,16.8),(131124,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131124,36.5,0.33,199,61007,70,NULL,NULL,'SDSS J153535.32+134840.3',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.5g',0.46,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.897208333,13.81122,0.125,NULL,59428703604,928573493,14508960,15.5),(131125,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131125,36.82,0.46,231,61008,70,NULL,NULL,'2MASX J15353585-0050017',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000095,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,233.899417,-0.83381,0.293,NULL,45414691489,709604554,11087571,17.3),(131126,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131126,35.53,0.2,128,61009,74.4,NULL,NULL,'CGCG 136-022',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000077,NULL,'15.7',0.4,'Sc',NULL,NULL,NULL,NULL,1,233.904416667,21.50394,0.169,NULL,59455871662,928997994,14515593,15.7),(131127,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131127,36.03,0.67,161,61010,70,NULL,NULL,'2MASX J15353708-1617416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.80',NULL,NULL,NULL,NULL,NULL,NULL,1,233.9045,-16.29508,0.341,NULL,46607055333,728235239,11378675,15.8),(131128,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131128,37.3,0.21,288,61011,70,NULL,NULL,'2MASX J15353749+4652333',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,233.906125,46.87589,0.037,NULL,59685518314,932586223,14571659,17.3),(131129,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131129,38.22,0.46,441,61012,70,NULL,NULL,'2MASX J15353772+2107186',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.907,21.12203,0.169,NULL,59458047392,929031990,14516124,17.6),(131130,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131130,36.22,0.46,176,61013,70,NULL,NULL,'2MASX J15353902+0852180',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,233.9125417,8.87178,0.101,NULL,56418839141,881544361,13774130,16.2),(131131,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131131,33.39,0.49,47.7,61014,75,NULL,'IR','UGC 09919',NULL,'2011yCatp016004901K',2011,1,1.58,NULL,'G',0.000006,NULL,'15.30',0.21,'Sc',NULL,NULL,NULL,NULL,1,233.915291667,12.60639,0.105,NULL,59425138603,928517790,14508090,15.3),(131132,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131132,33.48,0.2,49.7,61014,74.4,NULL,NULL,'UGC 09919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131133,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131133,33.6,NULL,52.5,61014,NULL,NULL,NULL,'UGC 09919',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131134,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131134,33.6,NULL,52.6,61014,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131135,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131135,33.62,NULL,53,61014,NULL,NULL,'Dipole + Quadrupole','UGC 09919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131136,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131136,33.65,NULL,53.7,61014,NULL,NULL,'Dipole','UGC 09919',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131137,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131137,33.66,0.44,53.9,61014,NULL,NULL,NULL,'UGC 09919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131138,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131138,33.81,0.41,57.8,61014,NULL,NULL,'Malmquist cor.','UGC 09919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131139,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131139,38.29,0.46,454,61015,70,NULL,NULL,'SDSS J153539.97-021152.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.916583333,-2.19783,0.389,NULL,45415690813,709620168,11087815,18.8),(131140,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131140,38.1,0.46,417,61016,70,NULL,NULL,'2MASX J15354004+0907510',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.917083,9.13075,0.093,NULL,56418737958,881542780,13774105,16.9),(131141,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131141,37.41,0.46,304,61017,70,NULL,NULL,'2MASX J15354100+5237397',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.92075,52.62758,0.049,NULL,59671414570,932365852,14568216,17.3),(131142,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131142,35.93,0.46,154,61018,70,NULL,NULL,'2MASX J15354109+3328347',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000112,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,233.9214583,33.47625,0.065,NULL,59883487068,935679485,14619991,15.9),(131143,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131143,37.1,0.46,263,61019,70,NULL,NULL,'2MASX J15354170+2541209',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.923833,25.68914,0.165,NULL,59915821224,936184706,14627886,17.9),(131144,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131144,36.07,0.23,163,61020,70,NULL,NULL,'CGCG 166-017',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000127,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,233.927166667,27.11842,0.121,NULL,59919301595,936239087,14628735,15.6),(131145,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131145,38.02,0.33,401,61021,70,NULL,NULL,'2MASX J15354376+2018236',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.932208333,20.30661,0.189,NULL,59457474935,929023045,14515985,17.8),(131146,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131146,38.87,0.46,593,61022,70,NULL,NULL,'SDSS J153543.96+100905.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.9332083,10.15156,0.061,NULL,56407612514,881368945,13771389,18.1),(131147,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131147,37.45,0.19,309,61023,70,NULL,NULL,'2MASX J15354397+5513074',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.933416667,55.21878,0.005,NULL,57586859463,899794679,14059291,17.6),(131148,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131148,34.56,0.58,81.8,61024,70,NULL,NULL,'2MASX J15354403-1646566',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000043,NULL,'15.65',NULL,NULL,NULL,NULL,NULL,NULL,1,233.9335,-16.78258,0.365,NULL,46606854723,728232105,11378626,15.65),(131149,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131149,38.15,0.46,426,61025,70,NULL,NULL,'2MASX J15354449+5401364',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.935417,54.02686,0.033,NULL,59669965235,932343206,14567862,17.5),(131150,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131150,37.69,0.46,345,61026,70,NULL,NULL,'2MASX J15354474+3945431',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,233.936333,39.76206,0.057,NULL,60096302401,939004725,14671948,16.7),(131151,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131151,37.78,0.46,360,61027,70,NULL,NULL,'2MASX J15354594+2107016',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,233.9414583,21.11703,0.169,NULL,59458015526,929031492,14516117,18.1),(131152,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131152,36.44,0.09,194,61028,70,NULL,NULL,'2MASX J15354597+2149466',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,233.9415,21.82964,0.177,NULL,59451386489,928927913,14514498,16.1),(131153,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131153,35.72,0.46,139,61029,70,NULL,NULL,'CGCG 050-036',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.0001,NULL,'15.3g',0.47,'E',NULL,NULL,NULL,NULL,1,233.9432083,7.94186,0.093,NULL,56414783905,881480998,13773140,15.3),(131154,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131154,36.35,0.33,186,61030,70,NULL,NULL,'2MASX J15354704+0322590',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,'FoF','16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,233.9459583,3.38292,0.117,NULL,56393979407,881155928,13768061,16.8),(131155,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131155,35.95,0.19,155,61031,70,NULL,NULL,'2MASX J15354774+2514499',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.948917,25.24706,0.149,NULL,59898879124,935919986,14623749,16.1),(131156,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131156,36.35,0.33,186,61032,70,NULL,NULL,'2MASX J15354818+0322400',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.0001,NULL,'15.9g',0.43,'S0',NULL,NULL,NULL,NULL,1,233.95075,3.37792,0.117,NULL,56393981470,881155960,13768061,15.9),(131157,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131157,36.84,0.46,233,61033,70,NULL,NULL,'2MASX J15354896+5600385',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,233.954083333,56.01069,0.005,NULL,57592628429,899884819,14060700,17.4),(131158,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131158,38.41,0.46,481,61034,70,NULL,NULL,'SDSS J153549.41+014627.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.955875,1.77436,0.173,NULL,56404862710,881325979,13770718,18.4),(131159,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131159,38.14,0.46,424,61035,70,NULL,NULL,'SDSS J153549.65+120327.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.956875,12.05769,0.093,NULL,56589612295,884212692,13815823,18),(131160,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131160,36.44,0.09,194,61036,70,NULL,NULL,'2MASX J15354967+2122376',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,233.957,21.37717,0.169,NULL,59457946712,929030417,14516100,16.6),(131161,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131161,36.07,0.46,164,61037,70,NULL,NULL,'2MASX J15355092+3756252',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,233.9620417,37.94047,0.045,NULL,60098591274,939040488,14672507,16.6),(131162,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131162,37.5,0.46,316,61038,70,NULL,NULL,'SDSS J153551.81+070230.0',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.965917,7.04167,0.121,NULL,56417371070,881521422,13773772,17.3),(131163,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131163,38.51,0.46,503,61039,70,NULL,NULL,'2MASX J15355187+0022490',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,233.966083,0.38025,0.201,NULL,56390522896,881101920,13767217,18.1),(131164,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131164,36.45,0.46,195,61040,70,NULL,NULL,'2MASX J15355196+3413376',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,233.9664583,34.22706,0.057,NULL,59885237174,935706830,14620419,17),(131165,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131165,33.9,0.45,60.3,61041,NULL,NULL,'K','NGC 5966',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000047,NULL,'13.5g',1.1,'E','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,233.96725,39.76894,0.057,NULL,60096299512,939004679,14671948,13.5),(131166,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131166,34.09,0.4,65.8,61041,NULL,NULL,'mean','NGC 5966',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131167,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131167,37.68,0.46,343,61042,70,NULL,NULL,'2MASX J15355240+1125182',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,233.968416667,11.42161,0.073,NULL,56589943803,884217871,13815904,17.6),(131168,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131168,37.95,0.46,389,61043,70,NULL,NULL,'SDSS J153553.01+312745.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000127,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,233.970916667,31.46256,0.077,NULL,59914157250,936158707,14627479,18.6),(131169,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131169,35.95,0.19,155,61044,70,NULL,NULL,'IC 4559',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000133,NULL,'15.1g',0.59,'AGN','Group member',NULL,NULL,NULL,1,233.973,25.34114,0.149,NULL,59898873844,935919903,14623748,15.1),(131170,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131170,36.64,0.46,213,61045,70,NULL,NULL,'2MASX J15355414+2246004',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.02',0.38,NULL,NULL,NULL,NULL,NULL,1,233.975583,22.76675,0.165,NULL,59454104301,928970379,14515162,17.02),(131171,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131171,37.5,0.46,317,61046,70,NULL,NULL,'SDSS J153554.23-010933.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000077,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,233.975958333,-1.15931,0.337,NULL,45414550305,709602348,11087536,18.9),(131172,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131172,38.32,0.46,462,61047,70,NULL,NULL,'2MASX J15355508+1611332',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,233.979416667,16.19269,0.085,NULL,59441581423,928774709,14512104,18.2),(131173,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131173,36.26,0.46,178,61048,70,NULL,NULL,'2MASX J15355641+2056464',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.59',0.38,NULL,NULL,NULL,NULL,NULL,1,233.984917,20.94608,0.173,NULL,59458290885,929035795,14516184,16.59),(131174,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131174,36.05,0.49,162,61049,75,NULL,'IR','UGC 09921 NOTES02',NULL,'2011yCatp016004901K',2011,1,0.84,NULL,'G',0.000207,NULL,'17.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,233.990083,26.37019,0.133,NULL,59916239884,936191248,14627988,17),(131175,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131175,36.89,0.46,238,61050,70,NULL,NULL,'SDSS J153557.63+091309.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,233.990125,9.21939,0.093,NULL,56407261177,881363455,13771303,17.6),(131176,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131176,37.29,0.46,287,61051,70,NULL,NULL,'VII Zw 613',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000203,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,233.991,58.79781,0.013,NULL,57634129446,900533272,14070832,16.1),(131177,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131177,35.91,0.46,152,61052,70,NULL,NULL,'2MASX J15355831+3615062',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'15.8g',0.41,'S0',NULL,NULL,NULL,NULL,1,233.992791667,36.25169,0.053,NULL,59879036217,935609940,14618905,15.8),(131178,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131178,37.62,0.46,334,61053,70,NULL,NULL,'SDSS J153559.82+454433.3',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000168,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,233.999291667,45.74258,0.017,NULL,59688989403,932640459,14572507,18.4),(131179,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131179,36.13,0.46,168,61054,70,NULL,NULL,'2MASX J15360049+4140512',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.002166667,41.68083,0.077,NULL,59965518059,936961219,14640019,16.6),(131180,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131180,37.33,0.46,293,61055,70,NULL,NULL,'2MASX J15360119+0239258',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.0050417,2.65725,0.169,NULL,56404446610,881319478,13770616,17.1),(131181,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131181,36.14,0.66,169,61056,70,NULL,NULL,'2MASX J15360214-0529123',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,234.008917,-5.48672,0.425,NULL,45416762368,709636912,11088076,15.6),(131182,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131182,36.44,0.09,194,61057,70,NULL,NULL,'2MASX J15360275+2134555',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.011417,21.58211,0.173,NULL,59457934153,929030221,14516097,NULL),(131183,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131183,34.48,0.33,78.6,61058,70,NULL,NULL,'I Zw 118 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000063,NULL,'15.3g',0.2,'E0','Pair member, contact system',NULL,NULL,NULL,1,234.011625,43.50347,0.089,NULL,59962821776,936919090,14639360,15.3),(131184,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131184,36.64,0.46,213,61059,70,NULL,NULL,'2MASX J15360407+0218588',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.017,2.31622,0.177,NULL,56404296028,881317125,13770580,17.2),(131185,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131185,36.5,0.33,199,61060,70,NULL,NULL,'2MASX J15360450+1357033',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.018708333,13.95094,0.117,NULL,59428754352,928574286,14508973,16.7),(131186,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131186,35.76,0.46,142,61061,70,NULL,NULL,'2MASX J15360629+3011216',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000178,NULL,'15.9g',0.43,'S0/a',NULL,NULL,NULL,NULL,1,234.026333333,30.18933,0.065,NULL,59927184900,936362264,14630660,15.9),(131187,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131187,35.79,0.46,144,61062,70,NULL,NULL,'2MASX J15360707+3957381',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000184,NULL,'15.7g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,234.0295417,39.96069,0.053,NULL,60096296963,939004640,14671947,15.7),(131188,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131188,37.54,0.46,322,61063,70,NULL,NULL,'SDSS J153607.59+062640.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.031667,6.44464,0.113,NULL,56414137610,881470900,13772982,18.2),(131189,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131189,38.41,0.33,481,61064,70,NULL,NULL,'2MASX J15360794+1352203',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.033041667,13.8725,0.117,NULL,59428710556,928573602,14508962,18),(131190,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131190,36.21,0.46,174,61065,70,NULL,NULL,'2MASX J15360826+0633562',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.23',0.37,NULL,NULL,NULL,NULL,NULL,1,234.034375,6.56558,0.113,NULL,56414072972,881469890,13772967,17.23),(131191,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131191,36.67,0.46,215,61066,70,NULL,NULL,'2MASX J15360882+2045525',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.67',0.45,NULL,NULL,NULL,NULL,NULL,1,234.0367083,20.7645,0.173,NULL,59458428512,929037945,14516217,16.67),(131192,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131192,38.41,0.33,481,61067,70,NULL,NULL,'2MASX J15360918+1352413',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.0382917,13.87822,0.117,NULL,59428710655,928573603,14508962,17.7),(131193,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131193,37.36,0.46,296,61068,70,NULL,NULL,'2MASX J15360918+3051286',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000133,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.038417,30.858,0.073,NULL,59925370248,936333910,14630217,17.2),(131194,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131194,37.3,0.21,288,61069,70,NULL,NULL,'CGPG 1534.5+4709',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000206,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,234.0457917,47.01192,0.037,NULL,59685479168,932585612,14571650,16.1),(131195,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131195,38.24,0.46,445,61070,70,NULL,NULL,'2MASX J15361163+4731253',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.048333,47.52378,0.037,NULL,59722217949,933159655,14580619,17.4),(131196,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131196,36.78,0.46,227,61071,70,NULL,NULL,'2MASX J15361219+1826494',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.050958333,18.44706,0.109,NULL,59437484888,928710701,14511104,17.6),(131197,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131197,38.48,0.46,496,61072,70,NULL,NULL,'2MASX J15361446+0353468',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00009,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.0602083,3.89614,0.129,NULL,56394122460,881158163,13768096,17.9),(131198,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131198,38.52,0.46,506,61073,70,NULL,NULL,'2MASX J15361483+2531407',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.061833,25.52806,0.173,NULL,59915781932,936184092,14627876,17.4),(131199,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131199,36.07,0.23,163,61074,70,NULL,NULL,'CGCG 166-018',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00016,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,234.0632083,27.30453,0.121,NULL,59919243337,936238177,14628721,15.4),(131200,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131200,37.47,0.46,311,61075,70,NULL,NULL,'SDSS J153615.18+195921.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.0632917,19.98942,0.189,NULL,59457155764,929018058,14515907,18.7),(131201,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131201,36.61,0.46,210,61076,70,NULL,NULL,'2MASX J15361586-0117313',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.066125,-1.29208,0.337,NULL,45414608189,709603252,11087550,17.4),(131202,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131202,37.99,0.46,397,61077,70,NULL,NULL,'2MASX J15361592+3002296',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.066208333,30.04164,0.065,NULL,59927266747,936363542,14630680,17),(131203,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131203,37.47,0.33,311,61078,70,NULL,NULL,'2MASX J15361603+3434156',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.066708333,34.57083,0.049,NULL,59892879574,935826243,14622285,16.8),(131204,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131204,36.88,0.46,237,61079,70,NULL,NULL,'2MASX J15361711+5755272',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.0g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,234.071333,57.92408,0.013,NULL,57588319735,899817495,14059648,16),(131205,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131205,36.98,0.46,249,61080,70,NULL,NULL,'SDSS J153619.27+502940.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.080333333,50.49447,0.041,NULL,59665070353,932266724,14566667,17.5),(131206,'Tully est','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131206,32.27,0.8,28.5,61081,75,NULL,'B','MRK 0689',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000007,NULL,'15.1g',0.43,'dwarf','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.081,30.68231,0.069,NULL,59925391341,936334239,14630222,15.1),(131207,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131207,36.6,0.49,209,61082,75,NULL,'IR','CGCG 078-026',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000697,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,234.095625,12.12756,0.065,NULL,56589584589,884212259,13815816,15.7),(131208,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131208,37.9,0.33,380,61083,70,NULL,NULL,'2MASX J15362328+5252239',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.09675,52.87342,0.057,NULL,59671403143,932365674,14568213,17.6),(131209,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131209,38.46,0.46,492,61084,70,NULL,NULL,'2MASX J15362338+1358414',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.097375,13.97822,0.125,NULL,59428739021,928574047,14508969,17.5),(131210,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131210,37.47,0.33,311,61085,70,NULL,NULL,'2MASX J15362369+3435006',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000222,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,234.098625,34.58347,0.053,NULL,59892880150,935826252,14622285,16.1),(131211,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131211,37.74,0.27,353,61086,70,NULL,NULL,'2MASX J15362493+2552216',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.1039583,25.87275,0.157,NULL,59915801522,936184398,14627881,17.2),(131212,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131212,38.86,0.46,591,61087,70,NULL,NULL,'SDSS J153626.00+271120.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.108375,27.18894,0.121,NULL,59919251062,936238297,14628723,18.3),(131213,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131213,36.5,0.46,199,61088,70,NULL,NULL,'2MASX J15362626+4131296',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000186,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,234.109375,41.52475,0.077,NULL,59965527119,936961361,14640021,15.8),(131214,'Sosies','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131214,32.2,0.57,27.5,61089,NULL,NULL,NULL,'NGC 5938',NULL,'2002A&A...393...57T',2002,1,2.8,NULL,'G',0.000019,NULL,'12.4',2.5,'SB(s)bc',NULL,NULL,NULL,NULL,1,234.1094583,-66.85975,NULL,NULL,45059291353,704051427,11000803,12.4),(131215,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131215,32.07,0.46,26,61089,NULL,NULL,'J','NGC 5938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131216,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131216,32.07,0.47,26,61089,NULL,NULL,'H','NGC 5938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131217,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131217,32.16,0.45,27,61089,NULL,NULL,'K','NGC 5938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131218,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131218,33.05,0.4,40.8,61089,NULL,NULL,'mean','NGC 5938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131219,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131219,34.81,0.4,91.4,61090,NULL,NULL,'mean','IC 4564',NULL,'2007A&A...465...71T',2007,1,1.28,'UZC has V = 6104 +- 46 km/sec.','G',0.000047,NULL,'14.1g',0.53,'S?             Sbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,234.11275,43.51878,0.089,NULL,59678656492,932479007,14569984,14.1),(131220,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131220,35.28,0.46,114,61090,NULL,NULL,'J','IC 4564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131221,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131221,35.3,0.47,115,61090,NULL,NULL,'H','IC 4564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131222,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131222,35.34,0.45,117,61090,NULL,NULL,'K','IC 4564',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131223,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131223,38.11,0.46,419,61091,70,NULL,NULL,'SDSS J153627.76+143822.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.115666667,14.63947,0.113,NULL,59428232154,928566127,14508845,17.9),(131224,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131224,37.88,0.33,377,61092,70,NULL,NULL,'SDSS J153628.09+311209.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.117083,31.20275,0.077,NULL,59914173563,936158961,14627483,18.7),(131225,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131225,36.44,0.09,194,61093,70,NULL,NULL,'2MASX J15362900+2122301',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.50',0.32,NULL,NULL,NULL,NULL,NULL,1,234.120791667,21.37519,0.169,NULL,59457979328,929030927,14516108,16.5),(131226,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131226,37.23,0.46,279,61094,70,NULL,NULL,'2MASXi J1536301+295232',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.125333,29.87572,0.065,NULL,59927240880,936363138,14630674,17.5),(131227,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131227,31.52,0.69,20.1,61095,100,NULL,'mid-IR','NGC 5962',NULL,'2013ApJ...771...88L',2013,1,2.47,'HOLM 716B is a star.','G',0.000007,NULL,'12.2g',1.49,'SA(r)c         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.132,16.60778,0.097,NULL,59441448350,928772630,14512072,12.2),(131228,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131228,32.4,0.4,30.2,61095,NULL,NULL,NULL,'NGC 5962',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131229,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131229,32.48,0.4,31.3,61095,NULL,NULL,'mean','NGC 5962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131230,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131230,32.51,0.4,31.8,61095,75,NULL,'B','NGC 5962',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131231,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131231,32.56,0.45,32.5,61095,NULL,NULL,'K','NGC 5962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131232,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131232,32.56,0.47,32.6,61095,NULL,NULL,'H','NGC 5962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131233,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131233,32.59,0.46,32.9,61095,NULL,NULL,'J','NGC 5962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131234,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131234,32.61,0.43,33.3,61095,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131235,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131235,32.67,0.43,34.2,61095,75,NULL,'3.6 micron, color corrected','NGC 5962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131236,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131236,32.85,0.2,37.2,61095,74.4,NULL,NULL,'NGC 5962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131237,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131237,32.97,0.51,39.3,61095,NULL,NULL,'Malmquist cor.','NGC 5962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131238,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131238,33.11,0.48,41.8,61095,NULL,NULL,NULL,'NGC 5962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131239,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131239,33.18,0.2,43.3,61096,74.4,NULL,NULL,'UGC 09925',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000023,NULL,'14.70',0.8,'Scd:',NULL,NULL,NULL,NULL,1,234.133333,16.43972,0.093,NULL,59441636584,928775571,14512118,14.7),(131240,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131240,33.39,0.5,47.7,61096,NULL,NULL,NULL,'UGC 09925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131241,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131241,33.74,0.43,55.9,61096,NULL,NULL,'Malmquist cor.','UGC 09925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131242,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131242,38.45,0.33,491,61097,70,NULL,NULL,'SDSS J153632.47+462309.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.135333333,46.38589,0.025,NULL,59688552588,932633634,14572400,18.3),(131243,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131243,37.85,0.46,371,61098,70,NULL,NULL,'2MASX J15363315+2503083',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000201,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.138167,25.05236,0.145,NULL,59898871224,935919862,14623747,17.4),(131244,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131244,36.66,0.46,215,61099,70,NULL,NULL,'2MASX J15363522+1944492',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000187,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,234.146833,19.74708,0.173,NULL,59457185533,929018523,14515914,15.9),(131245,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131245,37.64,0.46,337,61100,70,NULL,NULL,'2MASX J15363535+1317152',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.147125,13.28744,0.109,NULL,59425835959,928528686,14508260,17.4),(131246,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131246,35.98,0.46,157,61101,70,NULL,NULL,'2MASX J15363727+5503273',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.155541667,55.05772,0.021,NULL,57586826173,899794158,14059283,16.4),(131247,'IRAS','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131247,34.63,0.8,84.2,61102,75,NULL,'MAT, I','ESO 582- G 021',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15',0.7,'(R\')SA:(r)b    HII',NULL,NULL,NULL,NULL,1,234.158583333,-18.78633,0.449,NULL,46637555340,728711802,11386121,15),(131248,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131248,34.43,0.43,76.8,61102,75,NULL,'MAT, I, raw','ESO 582- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131249,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131249,34.51,0.47,79.7,61102,NULL,NULL,'H','ESO 582- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131250,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131250,34.53,0.32,80.5,61102,85,NULL,'I, raw','ESO 582- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131251,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131251,34.6,0.32,83,61102,85,NULL,'I, inv','ESO 582- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131252,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131252,34.6,0.45,83,61102,NULL,NULL,'K','ESO 582- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131253,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131253,34.63,0.2,84.3,61102,74.4,NULL,NULL,'ESO 582- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131254,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131254,34.68,0.46,86.4,61102,NULL,NULL,'J','ESO 582- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131255,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131255,34.71,0.43,87.5,61102,75,NULL,'MAT, I, inv','ESO 582- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131256,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131256,34.79,0.43,90.6,61102,75,NULL,'MAT, I, cor','ESO 582- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131257,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131257,34.83,0.22,92.3,61102,NULL,NULL,NULL,'ESO 582- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131258,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131258,34.84,0.4,92.8,61102,NULL,NULL,'mean','ESO 582- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131259,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131259,35.01,0.2,100,61102,NULL,NULL,'Malmquist cor.','ESO 582- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131260,'Black Hole','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131260,36.43,0.66,193,61103,NULL,NULL,NULL,'MRK 0486',NULL,'2014ApJ...793..108W',2014,1,0.5,NULL,'G',0.000093,NULL,'15.0V',NULL,'SBb?           Sy1',NULL,NULL,NULL,'Sy 1.0',1,234.159833,54.55922,0.045,NULL,57586196913,899784326,14059130,15),(131261,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131261,37.74,0.27,353,61104,70,NULL,NULL,'2MASX J15363897+2554244',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,234.1622917,25.90681,0.157,NULL,59916510928,936195483,14628054,16.2),(131262,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131262,36.81,0.46,231,61105,70,NULL,NULL,'2MASX J15363899-0221267',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.1625,-2.35758,0.389,NULL,45415494093,709617095,11087767,17.5),(131263,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131263,36.07,0.23,163,61106,70,NULL,NULL,'2MASX J15363923+2709174',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.163625,27.15483,0.121,NULL,59919128714,936236386,14628693,16.2),(131264,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131264,38.82,0.46,582,61107,70,NULL,NULL,'SDSS J153639.74+202407.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.165583,20.40208,0.185,NULL,59458381507,929037211,14516206,18.5),(131265,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131265,36.44,0.09,194,61108,70,NULL,NULL,'2MASX J15364132+2159222',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.172208333,21.98961,0.169,NULL,59453272366,928957380,14514959,16.2),(131266,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131266,37.69,0.33,346,61109,70,NULL,NULL,'2MASX J15364186+1204322',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,234.174417,12.07561,0.065,NULL,56589772773,884215199,13815862,16.8),(131267,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131267,35.7,0.2,138,61110,74.4,NULL,NULL,'CGCG 078-028 NED01',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000093,NULL,'15.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,234.176291667,9.02528,0.093,NULL,56418683502,881541929,13774092,15.4),(131268,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131268,37.69,0.33,346,61111,70,NULL,NULL,'SDSS J153642.85+121053.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.178583,12.18142,0.061,NULL,56589698003,884214031,13815844,18.3),(131269,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131269,37.47,0.46,312,61112,70,NULL,NULL,'SDSS J153643.40+103918.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.180875,10.65503,0.081,NULL,56591125326,884236333,13816192,18.2),(131270,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131270,37.68,0.46,343,61113,70,NULL,NULL,'SDSS J153643.43+094546.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.1809583,9.76281,0.085,NULL,56407170981,881362046,13771281,NULL),(131271,'Tully-Fisher','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131271,33.05,0.4,40.7,61114,75,NULL,'B','UGC 09936',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000013,NULL,'15.6g',0.52,'Sm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.1874583,44.23683,0.017,NULL,59686245163,932597580,14571837,15.6),(131272,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131272,35.71,0.6,139,61115,70,NULL,NULL,'2MASX J15364521-0049317',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00009,NULL,'16.3g',0.33,'S0',NULL,NULL,NULL,NULL,1,234.188375,-0.82556,0.321,NULL,45400645030,709385078,11084141,16.3),(131273,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131273,36.16,0.46,171,61115,70,NULL,NULL,'2MASX J15364521-0049317',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131274,'BL Lac Luminosity','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,NULL,131274,41.1,NULL,1270,61116,NULL,NULL,NULL,'RBS 1517',0.312,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'18.70',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,234.1947917,1.63336,0.173,NULL,56404178904,881315295,13770551,18.7),(131275,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131275,35.95,0.19,155,61117,70,NULL,NULL,'IC 4561',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000157,NULL,'14.9g',0.55,NULL,NULL,NULL,NULL,NULL,1,234.196125,25.41681,0.149,NULL,59915674814,936182418,14627850,14.9),(131276,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131276,37.8,0.46,362,61118,70,NULL,NULL,'2MASX J15364749+2001082',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.197875,20.01914,0.173,NULL,59456690840,929010794,14515793,17.7),(131277,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131277,38.22,0.46,441,61119,70,NULL,NULL,'2MASX J15364860+2057212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.202583,20.95589,0.169,NULL,59458094867,929032732,14516136,17.5),(131278,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131278,37.74,0.27,353,61120,70,NULL,NULL,'2MASX J15364868+2552464',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000188,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.202917,25.87956,0.157,NULL,59915802874,936184419,14627881,17.3),(131279,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131279,37.99,0.33,397,61121,70,NULL,NULL,'2MASX J15364976+1959371',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.207417,19.99364,0.173,NULL,59456692023,929010812,14515793,NULL),(131280,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131280,37.88,0.33,377,61122,70,NULL,NULL,'SDSS J153649.86+311635.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.2077917,31.27653,0.077,NULL,59914162669,936158791,14627481,18.5),(131281,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131281,37.69,0.46,346,61123,70,NULL,NULL,'2MASX J15365022-0050437',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.2092083,-0.84542,0.321,NULL,45400644555,709385071,11084141,17.7),(131282,'FP','2016-12-15 15:15:35','2016-12-16 11:20:49','1',NULL,'R',131282,37.5,0.46,316,61124,70,NULL,NULL,'2MASX J15365057+4058405',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.210583,40.97783,0.061,NULL,59965709031,936964203,14640065,17.5),(131283,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131283,35.83,0.46,146,61125,70,NULL,NULL,'2MASX J15365091+2634494',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000188,NULL,'15.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.212125,26.58025,0.121,NULL,59916326599,936192603,14628009,15.7),(131284,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131284,37.33,0.46,292,61126,70,NULL,NULL,'2MASX J15365178+3717245',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.215833,37.29025,0.041,NULL,59879586290,935618535,14619039,17.5),(131285,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131285,38.63,0.46,532,61127,70,NULL,NULL,'2MASX J15365188+4106374',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00019,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.2162083,41.11039,0.061,NULL,59965608060,936962625,14640041,17.4),(131286,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131286,36.4,0.46,190,61128,70,NULL,NULL,'2MASX J15365206-0222227',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.2169583,-2.37317,0.389,NULL,45415523776,709617559,11087774,16.7),(131287,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131287,36.64,0.33,213,61129,70,NULL,NULL,'CGCG 050-043',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000103,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,234.221583,4.75797,0.125,NULL,56392729507,881136398,13767756,15.5),(131288,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131288,34.79,NULL,90.7,61130,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1926',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.000199,NULL,'16.5g',0.18,'Scd(f)',NULL,NULL,NULL,NULL,1,234.22275,51.28864,0.037,NULL,59670481414,932351272,14567988,16.5),(131289,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131289,34.81,NULL,91.4,61130,NULL,NULL,'Dipole + Quadrupole','FGC 1926',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131290,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131290,34.81,NULL,91.8,61130,NULL,NULL,'Dipole','FGC 1926',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131291,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131291,34.85,NULL,93.4,61130,NULL,NULL,NULL,'FGC 1926',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131292,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131292,36.22,0.46,176,61131,70,NULL,NULL,'2MASX J15365442+1142213',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.226875,11.70603,0.093,NULL,56590513970,884226780,13816043,16.5),(131293,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131293,37.54,0.46,322,61132,70,NULL,NULL,'SDSS J153655.38+325844.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.2307917,32.97914,0.069,NULL,59884113110,935689267,14620144,18),(131294,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131294,38.69,0.46,547,61133,70,NULL,NULL,'SDSS J153655.60-011039.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000077,NULL,'19.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.231667,-1.17758,0.325,NULL,45414584284,709602879,11087544,19.1),(131295,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131295,37.68,0.27,344,61134,70,NULL,NULL,'2MASX J15365640+1802123',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,234.235083333,18.03692,0.089,NULL,59437630552,928712977,14511140,16.7),(131296,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131296,38.29,0.33,455,61135,70,NULL,NULL,'2MASX J15365911+2036593',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.2462083,20.61664,0.177,NULL,59458420103,929037814,14516215,18.1),(131297,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131297,38.13,0.46,422,61136,70,NULL,NULL,'2MASX J15365990+3953395',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.2495417,39.89436,0.053,NULL,60096397592,939006212,14671972,17.6),(131298,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131298,35.84,0.46,147,61137,70,NULL,NULL,'2MASX J15370020+1211482',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'17.17',0.31,'BrClG',NULL,NULL,NULL,NULL,1,234.2507917,12.19661,0.061,NULL,56589710395,884214224,13815847,17.17),(131299,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131299,37.18,0.46,273,61138,70,NULL,NULL,'2MASX J15370021+1122173',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.250917,11.3715,0.073,NULL,56589978463,884218413,13815912,16.5),(131300,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131300,38.24,0.46,446,61139,70,NULL,NULL,'2MASX J15370051+3108417',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.252083,31.14503,0.077,NULL,59925495380,936335865,14630247,18.2),(131301,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131301,38.37,0.46,473,61140,70,NULL,NULL,'2MASX J15370115+2603156',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000198,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.254875,26.05428,0.145,NULL,59916508502,936195445,14628053,17.8),(131302,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131302,38.29,0.33,455,61141,70,NULL,NULL,'2MASX J15370175+2037473',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,234.257167,20.62992,0.177,NULL,59458419112,929037798,14516215,17),(131303,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131303,36.03,0.46,161,61142,70,NULL,NULL,'2MASX J15370240+2404517',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.260125,24.08114,0.137,NULL,59451050487,928922663,14514416,17.2),(131304,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131304,33.46,0.49,49.3,61143,75,NULL,'IR','2MFGC 12578',NULL,'2011yCatp016004901K',2011,1,0.79,NULL,'G',0.000103,NULL,'15.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.2615,20.12883,0.185,NULL,59456693873,929010841,14515794,15.6),(131305,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131305,38.02,0.46,401,61144,70,NULL,NULL,'2MASX J15370355+1446542',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.264875,14.78186,0.129,NULL,59428200914,928565639,14508838,18.3),(131306,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131306,36.64,0.33,213,61145,70,NULL,NULL,'2MASX J15370377+0443074',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.26575,4.71878,0.125,NULL,56392918687,881139354,13767802,NULL),(131307,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131307,36.56,0.2,205,61146,74.4,NULL,NULL,'CGCG 136-031',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000104,NULL,'15.1g',0.47,'SBb',NULL,NULL,NULL,NULL,1,234.266,25.56533,0.173,NULL,59915888550,936185758,14627902,15.1),(131308,'Tully est','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131308,30.88,0.8,15,61147,75,NULL,'B','UGCA 410',NULL,'1988NBGC.C....0000T',1988,1,0.45,'The SDSS position applies to a knot or superposed companion 2.2 arcsec north.','G',0.000023,NULL,'15.2g',0.36,'BCDG           HII','Group member',NULL,NULL,NULL,1,234.267458333,55.26342,0.021,NULL,57586953962,899796155,14059314,15.2),(131309,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131309,34.94,0.46,97.2,61148,70,NULL,NULL,'CGCG 1535.0+2930 NED02',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000147,NULL,'15.13',0.3,NULL,NULL,NULL,NULL,NULL,1,234.272583,29.33772,0.065,NULL,59926501722,936351589,14630493,15.13),(131310,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131310,36.86,0.46,235,61149,70,NULL,NULL,'2MASX J15370536+5655426',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000062,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.272666667,56.92853,0.013,NULL,57590056405,899844631,14060072,17.6),(131311,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131311,37.68,0.27,344,61150,70,NULL,NULL,'2MASX J15370601+1759143',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.275125,17.98747,0.089,NULL,59437645618,928713212,14511143,18.1),(131312,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131312,38.77,0.46,567,61151,70,NULL,NULL,'SDSS J153706.15+040419.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000084,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.275667,4.07214,0.101,NULL,56396454845,881194606,13768665,18.8),(131313,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131313,37.94,0.46,388,61152,70,NULL,NULL,'2MASX J15370822+4545363',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.284333333,45.76022,0.013,NULL,59688974599,932640228,14572503,17.7),(131314,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131314,37.3,0.21,288,61153,70,NULL,NULL,'2MASX J15370839+4702546',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.285167,47.04836,0.037,NULL,59688356048,932630563,14572352,17.9),(131315,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131315,38.38,0.46,475,61154,70,NULL,NULL,'2MASX J15370887+2050333',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.287125,20.84247,0.173,NULL,59458220204,929034690,14516167,18.1),(131316,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131316,37.98,0.46,395,61155,70,NULL,NULL,'2MASX J15370985+4507493',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.3R',0.2,NULL,NULL,NULL,NULL,NULL,1,234.29125,45.13036,0.013,NULL,59686817825,932606528,14571977,16.3),(131317,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131317,37.37,0.46,297,61156,70,NULL,NULL,'2MASX J15370999+3446217',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,234.291833,34.77269,0.053,NULL,59892847189,935825737,14622277,17),(131318,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131318,36.92,0.46,243,61157,70,NULL,NULL,'2MASX J15371196+4104184',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000156,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.299667,41.07169,0.061,NULL,59965581594,936962212,14640034,16.6),(131319,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131319,37.69,0.46,345,61158,70,NULL,NULL,'2MASX J15371202-0101442',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.3000417,-1.02897,0.321,NULL,45400680431,709385631,11084150,18.3),(131320,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131320,34.52,0.57,80.2,61159,70,NULL,NULL,'2MASX J15371268-0519572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'16.3R',NULL,'HII',NULL,NULL,NULL,NULL,1,234.302917,-5.33256,0.461,NULL,45416370233,709630784,11087981,16.3),(131321,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131321,33.94,0.43,61.4,61160,75,NULL,'3.6 micron, color + selection bias corrected','IC 4567',NULL,'2014MNRAS.444..527S',2014,1,1.16,NULL,'G',0.00002,NULL,'13.6g',0.8,'Scd?           Sbrst','in a radial-velocity based grouping',NULL,NULL,NULL,1,234.305291667,43.29831,0.093,NULL,59678681609,932479400,14569990,13.6),(131322,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131322,34.05,0.43,64.6,61160,75,NULL,'3.6 micron, color corrected','IC 4567',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131323,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131323,34.25,0.2,70.8,61160,74.4,NULL,NULL,'IC 4567',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131324,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131324,34.38,0.47,75.3,61160,NULL,NULL,'H','IC 4567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131325,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131325,34.39,0.45,75.4,61160,NULL,NULL,'K','IC 4567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131326,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131326,34.45,0.46,77.7,61160,NULL,NULL,'J','IC 4567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131327,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,NULL,131327,34.66,0.4,85.6,61160,NULL,NULL,'mean','IC 4567',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131328,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131328,38.31,0.46,459,61161,70,NULL,NULL,'SDSS J153714.70+293236.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.3112917,29.54353,0.065,NULL,59927574665,936368354,14630755,18),(131329,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131329,37.99,0.33,397,61162,70,NULL,NULL,'2MASX J15371483+2000003',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.311875,20.00025,0.173,NULL,59456745899,929011654,14515807,17.4),(131330,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131330,37.2,0.27,275,61163,70,NULL,NULL,'2MASX J15371549+4158544',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.314666667,41.98181,0.121,NULL,59963523303,936930051,14639532,17.6),(131331,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131331,36.9,0.46,240,61164,70,NULL,NULL,'2MASX J15371633+1831063',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.31825,18.51839,0.085,NULL,59430179005,928596546,14509321,16.9),(131332,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131332,37.68,0.27,344,61165,70,NULL,NULL,'2MASX J15371638+1800313',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000199,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,234.318375,18.00886,0.089,NULL,59437643613,928713181,14511143,16.5),(131333,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131333,37.97,0.46,393,61166,70,NULL,NULL,'2MASX J15371643+5711306',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.3185,57.19197,0.021,NULL,57590871434,899857366,14060271,17.5),(131334,'FP','2016-12-15 15:15:36','2016-12-16 11:20:49','1',NULL,'R',131334,38.36,0.46,471,61167,70,NULL,NULL,'SDSS J153717.72+304054.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.323833333,30.68175,0.069,NULL,59925563986,936336937,14630264,17.7),(131335,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131335,37.2,0.27,275,61168,70,NULL,NULL,'SDSS J153718.42+415301.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.3267917,41.88364,0.121,NULL,59963497522,936929648,14639525,18.3),(131336,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131336,38.12,0.46,422,61169,70,NULL,NULL,'2MASX J15372013+2540097',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.333875,25.66947,0.165,NULL,59915841691,936185026,14627891,17.7),(131337,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131337,38.14,0.46,425,61170,70,NULL,NULL,'2MASX J15372248+0628496',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.343791667,6.48044,0.149,NULL,56414282992,881473171,13773018,18.2),(131338,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131338,36.76,0.46,225,61171,70,NULL,NULL,'2MASX J15372273+0307474',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000122,NULL,'15.8g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,234.3447083,3.12978,0.141,NULL,56395054788,881172731,13768323,15.8),(131339,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131339,35.85,0.25,148,61172,74.4,NULL,NULL,'CGCG 136-033',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000087,NULL,'14.37',0.7,'S',NULL,NULL,NULL,NULL,1,234.3587083,21.74381,0.169,NULL,59452690986,928948296,14514817,14.37),(131340,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131340,36.04,0.27,161,61172,70,NULL,NULL,'CGCG 136-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131341,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131341,35.98,0.2,157,61173,74.4,NULL,NULL,'CGCG 078-030',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000489,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,234.3592917,10.62786,0.081,NULL,56591170961,884237046,13816203,15.6),(131342,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131342,37.75,0.46,354,61174,70,NULL,NULL,'2MASX J15372865+1923125',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00019,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.3694583,19.38689,0.149,NULL,59457328865,929020763,14515949,17.3),(131343,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131343,37.81,0.46,365,61175,70,NULL,NULL,'2MASX J15372871+2357035',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.369666667,23.95089,0.137,NULL,59450937371,928920896,14514389,17.6),(131344,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131344,37.07,0.46,260,61176,70,NULL,NULL,'MCG +06-34-023',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00019,NULL,'15.6g',0.52,'E0',NULL,NULL,NULL,NULL,1,234.371125,36.24378,0.057,NULL,59878999664,935609369,14618896,15.6),(131345,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131345,38.03,0.46,404,61177,70,NULL,NULL,'2MASX J15373162+2619006',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.3817083,26.31683,0.125,NULL,59916657327,936197770,14628090,16.8),(131346,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131346,37.9,0.33,380,61178,70,NULL,NULL,'2MASX J15373254+5247385',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.385375,52.79403,0.057,NULL,59672285243,932379456,14568429,17.7),(131347,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131347,37.2,0.27,275,61179,70,NULL,NULL,'2MASX J15373259+4149084',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.385958333,41.81903,0.077,NULL,59963491830,936929559,14639524,17.6),(131348,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131348,37.56,0.46,325,61180,70,NULL,NULL,'2MASX J15373349+1342524',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,234.389666667,13.71458,0.125,NULL,59425391615,928521743,14508152,16.5),(131349,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131349,36.19,0.33,173,61181,70,NULL,NULL,'2MASX J15373355+3513512',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,234.389833333,35.23108,0.053,NULL,59892910362,935826724,14622292,16.5),(131350,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131350,36.66,0.33,215,61182,70,NULL,NULL,'2MASX J15373383+4533195',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000181,NULL,'16.1g',0.29,'E0',NULL,NULL,NULL,NULL,1,234.3912083,45.55556,0.009,NULL,59688279490,932629367,14572333,16.1),(131351,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131351,37.47,0.46,312,61183,70,NULL,NULL,'2MASX J15373413+5326365',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.392,53.44339,0.049,NULL,59672205443,932378210,14568409,17.4),(131352,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131352,37.13,0.46,267,61184,70,NULL,NULL,'2MASX J15373515+3753514',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.396375,37.89772,0.045,NULL,60098401513,939037523,14672461,17.6),(131353,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131353,35.74,0.46,140,61185,70,NULL,NULL,'2MASX J15373628+0416578',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.43',0.42,NULL,NULL,NULL,NULL,NULL,1,234.4012083,4.28275,0.117,NULL,56396253106,881191454,13768616,16.43),(131354,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131354,31.96,0.4,24.7,61186,75,NULL,'B','NGC 5964',NULL,'1988NBGC.C....0000T',1988,1,4.2,'2MASS position is for a southern hot-spot.','G',0.000004,NULL,'12.6',3.2,'SB(rs)d        AGN?','Isolated galaxy',NULL,NULL,NULL,1,234.400917,5.97403,0.145,NULL,56421848616,881591384,13774865,12.6),(131355,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131355,32.18,0.68,27.3,61186,NULL,NULL,NULL,'NGC 5964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131356,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131356,32.18,NULL,27.3,61186,72,NULL,NULL,'NGC 5964',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131357,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131357,32.21,0.67,27.7,61186,NULL,NULL,'Malmquist cor.','NGC 5964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131358,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131358,32.22,0.2,27.8,61186,74.4,NULL,NULL,'NGC 5964',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131359,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131359,36.8,0.23,229,61187,70,NULL,NULL,'2MASX J15373644+1423264',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.401917,14.39075,0.097,NULL,59428647581,928572618,14508947,16.7),(131360,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131360,35.19,0.4,109,61188,NULL,NULL,'mean','MCG -01-40-004',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000037,NULL,'15.25',0.5,'Sb',NULL,NULL,NULL,NULL,1,234.4052083,-8.72119,0.461,NULL,45388905617,709201650,11081275,15.25),(131361,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131361,35.32,0.47,116,61188,NULL,NULL,'H','MCG -01-40-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131362,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131362,38.13,0.46,422,61189,70,NULL,NULL,'2MASX J15373782+1703424',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.407625,17.06189,0.073,NULL,59438160354,928721255,14511269,18),(131363,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131363,35.26,0.46,113,61190,70,NULL,NULL,'CGCG 078-032',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000153,NULL,'15.5',0.38,NULL,NULL,NULL,NULL,NULL,1,234.4077083,9.31486,0.097,NULL,56590610062,884228282,13816066,15.5),(131364,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131364,37.74,0.33,352,61191,70,NULL,NULL,'SDSS J153738.50-015544.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.4104583,-1.92911,0.369,NULL,45415024394,709609756,11087652,18.7),(131365,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131365,37.53,0.46,321,61192,70,NULL,NULL,'2MASX J15373849+5147195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.4104583,51.78883,0.049,NULL,59671258128,932363408,14568178,17.2),(131366,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131366,37.93,0.46,385,61193,70,NULL,NULL,'2MASX J15373903+2037146',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.41275,20.62083,0.141,NULL,59458226059,929034782,14516168,17.2),(131367,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131367,37.47,0.46,312,61194,70,NULL,NULL,'2MASX J15373978+2915107',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.415708333,29.25303,0.065,NULL,59926480062,936351250,14630488,17.5),(131368,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131368,36.34,0.46,185,61195,70,NULL,NULL,'2MASX J15373986+3930424',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,234.415958333,39.51167,0.053,NULL,60096450374,939007037,14671984,16.3),(131369,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131369,36.48,0.46,197,61196,70,NULL,NULL,'2MASX J15374062+3131572',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.419333,31.5325,0.077,NULL,59914388436,936162319,14627536,16.7),(131370,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131370,36.19,0.33,173,61197,70,NULL,NULL,'2MASX J15374106+3512452',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,234.4212083,35.21269,0.053,NULL,59892911086,935826735,14622292,16),(131371,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131371,38.05,0.46,408,61198,70,NULL,NULL,'SDSS J153741.25+574139.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.421917,57.69439,0.025,NULL,57635529028,900555141,14071174,17.9),(131372,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131372,36.8,0.23,229,61199,70,NULL,NULL,'2MASX J15374126+1421154',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00008,NULL,'16.55',0.39,NULL,NULL,NULL,NULL,NULL,1,234.421958333,14.35422,0.097,NULL,59428647008,928572609,14508947,16.55),(131373,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131373,36.85,0.46,235,61200,70,NULL,NULL,'2MASX J15374429+0002024',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000085,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.434375,0.03403,0.249,NULL,56390732522,881105195,13767268,16.8),(131374,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131374,37.3,0.21,288,61201,70,NULL,NULL,'2MASX J15374579+4659409',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.0002,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.440875,46.99467,0.037,NULL,59687311078,932614235,14572097,16.4),(131375,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131375,37.37,0.46,298,61202,70,NULL,NULL,'2MASX J15374606+2754157',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.4419583,27.90444,0.093,NULL,59918866107,936232282,14628629,16.3),(131376,'Tully est','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131376,32.33,0.8,29.2,61203,75,NULL,'B','NGC 5981',NULL,'1988NBGC.C....0000T',1988,1,2.8,'1983Afz....19..613K has V_sun = 2611 +- 27 km sec^-1.','G',0.000153,NULL,'13.93',0.5,'Sc? sp','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,234.4727083,59.39175,0.013,NULL,57618147295,900283551,14066930,13.93),(131377,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131377,33.43,0.2,48.5,61203,74.4,NULL,NULL,'NGC 5981',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131378,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131378,33.48,0.4,49.8,61203,75,NULL,NULL,'NGC 5981',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131379,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131379,33.53,0.43,50.9,61203,75,NULL,'3.6 micron, color corrected','NGC 5981',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131380,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131380,33.63,0.43,53.2,61203,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5981',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131381,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131381,33.73,0.49,55.6,61203,75,NULL,'IR','NGC 5981',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131382,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131382,34.16,0.46,67.9,61204,70,NULL,NULL,'UGC 09939',NULL,'2015arXiv151105856S',2015,1,1.02,NULL,'G',0.000107,NULL,'14.7g',0.76,'S0:',NULL,NULL,NULL,NULL,1,234.4704583,-1.73528,0.373,NULL,45414915768,709608058,11087625,14.7),(131383,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131383,37.05,0.46,257,61205,70,NULL,NULL,'2MASX J15375371-0041224',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.473708333,-0.68958,0.341,NULL,45401037713,709391214,11084237,17.5),(131384,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131384,36.67,0.46,215,61206,70,NULL,NULL,'2MASX J15375388+1314234',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.474583,13.23994,0.109,NULL,59425319754,928520621,14508134,17.1),(131385,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131385,36.96,0.46,247,61207,70,NULL,NULL,'SDSS J153754.21+463204.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.475875,46.53469,0.025,NULL,59688508139,932632939,14572389,18),(131386,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131386,37.47,0.46,312,61208,70,NULL,NULL,'2MASX J15375778+1103557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.490625,11.06533,0.105,NULL,56593381381,884271584,13816743,17.2),(131387,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131387,36.69,0.46,218,61209,70,NULL,NULL,'2MASX J15375869+2306467',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,234.494417,23.11292,0.153,NULL,59453559930,928961873,14515029,17),(131388,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131388,37.25,0.46,282,61210,70,NULL,NULL,'SDSS J153758.76+484812.6',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.494875,48.8035,0.045,NULL,59721719746,933151871,14580497,17.6),(131389,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131389,37.74,0.33,352,61211,70,NULL,NULL,'2MASX J15375888-0156317',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.49525,-1.942,0.369,NULL,45413270000,709582343,11087224,17.5),(131390,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131390,36.89,0.73,239,61212,70,NULL,NULL,'2MASX J15375907-2800389',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,234.496083333,-28.01078,0.425,NULL,47172509826,737070466,11516726,15.9),(131391,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131391,36.2,0.46,174,61213,70,NULL,NULL,'2MASX J15380169+0737207',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.41',0.4,NULL,NULL,NULL,NULL,NULL,1,234.507041667,7.62228,0.093,NULL,56417086984,881516984,13773702,17.41),(131392,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131392,38.1,0.46,416,61214,70,NULL,NULL,'SDSS J153802.05+513152.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.508541667,51.53128,0.045,NULL,59670476238,932351191,14567987,18.1),(131393,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131393,36.52,0.46,201,61215,70,NULL,NULL,'2MASX J15380259+2939437',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.5g',0.27,'E',NULL,NULL,NULL,NULL,1,234.5107083,29.66214,0.065,NULL,59928142436,936377225,14630894,16.5),(131394,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131394,36.66,0.33,215,61216,70,NULL,NULL,'2MASX J15380268+4533480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.51125,45.56319,0.009,NULL,59688273079,932629266,14572332,16.8),(131395,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131395,37.13,0.46,267,61217,70,NULL,NULL,'2MASX J15380308+4701340',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.5129583,47.02628,0.037,NULL,59687359560,932614993,14572109,17.1),(131396,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131396,37.02,0.46,253,61218,70,NULL,NULL,'2MASX J15380329+1624057',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,234.513666667,16.4015,0.097,NULL,59441084212,928766940,14511983,16.2),(131397,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131397,35.83,0.33,146,61219,70,NULL,NULL,'CGCG 136-035',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000117,NULL,'15.6g',0.46,NULL,'Group member',NULL,NULL,NULL,1,234.51775,26.26122,0.133,NULL,59916644966,936197577,14628087,15.6),(131398,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131398,35.83,0.33,146,61220,70,NULL,NULL,'CGCG 136-036',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000093,NULL,'15.4g',0.51,NULL,'Group member',NULL,NULL,NULL,1,234.518583,26.28153,0.133,NULL,59916639270,936197488,14628085,15.4),(131399,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131399,37.6,0.46,331,61221,70,NULL,NULL,'SDSS J153805.81+030508.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.524208333,3.08567,0.141,NULL,56395057763,881172777,13768324,18.2),(131400,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131400,37.87,0.46,374,61222,70,NULL,NULL,'2MASX J15380641+3233430',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.526625,32.562,0.077,NULL,59883353147,935677392,14619959,17.5),(131401,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131401,37.59,0.46,329,61223,70,NULL,NULL,'2MASX J15380654+3316070',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000188,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.527,33.26864,0.069,NULL,59884060211,935688440,14620131,17.4),(131402,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131402,37.66,0.33,340,61224,70,NULL,NULL,'2MASX J15380652+2835384',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.527125,28.59394,0.089,NULL,59918267143,936222924,14628483,17.9),(131403,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131403,37.55,0.46,323,61225,70,NULL,NULL,'2MASX J15380706+0634477',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.529375,6.57989,0.161,NULL,56414384659,881474760,13773043,17.4),(131404,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131404,36.71,0.46,220,61226,70,NULL,NULL,'2MASX J15380715+3114300',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,234.5297083,31.24183,0.077,NULL,59925517061,936336204,14630253,16.1),(131405,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131405,37.65,0.46,340,61227,70,NULL,NULL,'2MASX J15380849+2048097',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,234.535541667,20.80261,0.169,NULL,59458202777,929034418,14516162,16.7),(131406,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131406,38.37,0.46,473,61228,70,NULL,NULL,'SDSS J153809.80+120656.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.540875,12.11569,0.061,NULL,56590403796,884225059,13816016,NULL),(131407,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131407,37.5,0.46,316,61229,70,NULL,NULL,'SDSS J153810.15+222020.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.542333,22.33897,0.161,NULL,59453330192,928958284,14514973,18.4),(131408,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131408,36.45,0.46,195,61230,70,NULL,NULL,'2MASX J15381085+0337585',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.545291667,3.633,0.161,NULL,56395678894,881182482,13768476,17.1),(131409,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131409,37.63,0.33,336,61231,70,NULL,NULL,'2MASX J15381157+0301405',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.548125,3.02786,0.141,NULL,56403198592,881299978,13770312,17.5),(131410,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131410,38.55,0.46,514,61232,70,NULL,NULL,'SDSS J153812.67+055833.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.5527917,5.97597,0.145,NULL,56421887889,881591998,13774874,18.4),(131411,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131411,36.8,0.23,229,61233,70,NULL,NULL,'2MASX J15381415+1416317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.5590417,14.27547,0.117,NULL,59428674900,928573045,14508953,17.4),(131412,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131412,38.19,0.15,434,61234,70,NULL,NULL,'2MASX J15381497+3048460',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000204,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.5625,30.81278,0.073,NULL,59925418951,936334671,14630229,16.5),(131413,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131413,35.38,0.56,119,61235,70,NULL,NULL,'2MASX J15381532-0654071',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.57',0.5,NULL,NULL,NULL,NULL,NULL,1,234.563917,-6.90214,0.457,NULL,45387170064,709174532,11080852,16.57),(131414,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131414,37.86,0.46,373,61236,70,NULL,NULL,'SDSS J153815.88+173844.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.566208333,17.64558,0.097,NULL,59438074337,928719911,14511248,18.2),(131415,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131415,37.66,0.33,340,61237,70,NULL,NULL,'2MASX J15381593+2839414',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.5664583,28.66153,0.077,NULL,59918268635,936222947,14628483,17.6),(131416,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131416,37.63,0.33,336,61238,70,NULL,NULL,'2MASX J15381658+0300475',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.569,3.01322,0.141,NULL,56403378633,881302791,13770356,16.9),(131417,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131417,36.44,0.09,194,61239,70,NULL,NULL,'2MASX J15381905+2151587',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00025,NULL,'16.56',0.2,NULL,NULL,NULL,NULL,NULL,1,234.5794583,21.86636,0.169,NULL,59452710256,928948597,14514821,16.56),(131418,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131418,36.11,0.46,167,61240,70,NULL,NULL,'2MASX J15382011+4708520',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000167,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,234.584,47.14792,0.037,NULL,59720130657,933127041,14580110,16.3),(131419,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131419,37.84,0.46,369,61241,70,NULL,NULL,'SDSS J153820.27+082630.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.5845,8.44194,0.073,NULL,56595910009,884311093,13817360,18.4),(131420,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131420,38.19,0.15,434,61242,70,NULL,NULL,'2MASX J15382056+3046030',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.5857917,30.76758,0.069,NULL,59925450055,936335157,14630236,17.9),(131421,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131421,37.16,0.46,270,61243,70,NULL,NULL,'2MASX J15382108+1746497',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,234.5879583,17.78058,0.089,NULL,59430209146,928597017,14509328,16.7),(131422,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131422,37.51,0.46,318,61244,70,NULL,NULL,'2MASX J15382197+3519210',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.591541667,35.32261,0.053,NULL,59893406640,935834478,14622413,17.6),(131423,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131423,32.41,0.4,30.3,61245,75,NULL,'B','UGC 09941',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000017,NULL,'14.3',1.5,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.592083,12.96083,0.125,NULL,56523058697,883172792,13799574,14.3),(131424,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131424,35.67,0.59,136,61246,70,NULL,NULL,'CGCG 022-019',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000073,NULL,'15.9g',0.25,'Sa',NULL,NULL,NULL,NULL,1,234.5930417,-0.46211,0.305,NULL,45400901596,709389087,11084204,15.9),(131425,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131425,35.94,0.68,154,61247,70,NULL,NULL,'2MASX J15382438-0853511',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.17',0.3,NULL,NULL,NULL,NULL,NULL,1,234.601875,-8.89764,0.513,NULL,45610129918,712658279,11135285,16.17),(131426,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131426,36.93,0.46,243,61248,70,NULL,NULL,'2MASX J15382452+3053250',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,234.602083,30.89025,0.073,NULL,59925420133,936334689,14630229,16.2),(131427,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131427,38.3,0.46,458,61249,70,NULL,NULL,'2MASXi J1538254+375901',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.6057917,37.98375,0.045,NULL,60098347648,939036682,14672448,17.8),(131428,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131428,37.36,0.46,296,61250,70,NULL,NULL,'SDSS J153825.54+064026.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.606416667,6.67406,0.161,NULL,56414347791,881474184,13773034,18.5),(131429,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131429,37.97,0.46,392,61251,70,NULL,NULL,'2MASX J15382629+3033100',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.609583,30.55281,0.041,NULL,59927323532,936364430,14630694,17.6),(131430,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131430,37.68,0.46,344,61252,70,NULL,NULL,'2MASX J15382730+1943425',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.613625,19.7285,0.173,NULL,59456872626,929013634,14515838,16.9),(131431,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131431,36.96,0.33,246,61253,70,NULL,NULL,'2MASX J15382758+0623333',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.11',0.42,NULL,NULL,NULL,NULL,NULL,1,234.614875,6.39256,0.149,NULL,56413554733,881461792,13772840,17.11),(131432,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131432,38.07,0.46,412,61254,70,NULL,NULL,'2MASX J15382763+1918555',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000218,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.6150417,19.31525,0.125,NULL,59448557613,928883712,14513808,16.7),(131433,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131433,37.99,0.46,396,61255,70,NULL,NULL,'2MASX J15382789+0040301',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000098,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.616167,0.67492,0.253,NULL,56391120104,881111251,13767363,17.3),(131434,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131434,37.63,0.46,336,61256,70,NULL,NULL,'SDSS J153828.57+022209.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.6190417,2.36922,0.149,NULL,56403748025,881308562,13770446,17.9),(131435,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131435,38.08,0.46,414,61257,70,NULL,NULL,'SDSS J153829.29+472907.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.622083,47.48547,0.033,NULL,59720108825,933126700,14580104,18.4),(131436,'Ring Diameter','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131436,31.5,0.76,20,61258,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5970',NULL,'1981ApJS...45..541P',1981,1,2.9,NULL,'G',0.000017,NULL,'12.24',1.9,'SB(r)c;  HII   LINER','in a radial-velocity based grouping',NULL,NULL,NULL,1,234.624875,12.18661,0.069,NULL,56590152839,884221138,13815955,12.24),(131437,'Ring Diameter','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131437,31.9,0.6,24,61258,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5970',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131438,'Sosies','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131438,32.35,0.23,29.5,61258,NULL,NULL,NULL,'NGC 5970',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131439,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131439,31.51,0.69,20,61258,100,NULL,'mid-IR','NGC 5970',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131440,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131440,32.08,0.4,26.1,61258,NULL,NULL,NULL,'NGC 5970',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131441,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131441,32.24,0.43,28.1,61258,75,NULL,'3.6 micron, color corrected','NGC 5970',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131442,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131442,32.25,0.2,28.2,61258,74.4,NULL,NULL,'NGC 5970',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131443,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131443,32.28,0.43,28.6,61258,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5970',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131444,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131444,32.35,0.45,29.5,61258,NULL,NULL,'Malmquist cor.','NGC 5970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131445,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131445,32.36,0.4,29.6,61258,NULL,NULL,'mean','NGC 5970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131446,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131446,32.36,0.45,29.7,61258,NULL,NULL,NULL,'NGC 5970',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131447,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131447,32.5,0.4,31.6,61258,75,NULL,'B','NGC 5970',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131448,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131448,32.63,0.46,33.6,61258,NULL,NULL,'J','NGC 5970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131449,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131449,32.64,0.47,33.7,61258,NULL,NULL,'H','NGC 5970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131450,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131450,32.66,0.45,34,61258,NULL,NULL,'K','NGC 5970',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131451,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131451,37.42,0.46,305,61259,70,NULL,NULL,'2MASX J15382996+4618245',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.624625,46.30667,0.025,NULL,59688495739,932632745,14572386,17.5),(131452,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131452,37.88,0.46,377,61260,70,NULL,NULL,'2MASX J15383023+2648504',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000202,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.625916667,26.81417,0.129,NULL,59919448097,936241376,14628771,16.8),(131453,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131453,36.8,0.23,229,61261,70,NULL,NULL,'2MASX J15383025+1420397',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.6259583,14.34444,0.117,NULL,59426664044,928541625,14508462,17.1),(131454,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131454,37.3,0.21,288,61262,70,NULL,NULL,'2MASX J15383032+4703035',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.62625,47.05097,0.037,NULL,59687343716,932614745,14572105,16.7),(131455,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131455,37.91,0.46,382,61263,70,NULL,NULL,'SDSS J153830.32+262824.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000173,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.626333,26.4735,0.161,NULL,59916458967,936194671,14628041,18.7),(131456,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131456,37.93,0.46,385,61264,70,NULL,NULL,'2MASX J15383030+4339095',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.6265,43.65275,0.045,NULL,59690431513,932662992,14572859,17.9),(131457,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131457,36.6,0.27,209,61265,70,NULL,NULL,'2MASX J15383234+0642343',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000455,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,234.63475,6.70958,0.161,NULL,56414356833,881474325,13773036,16.3),(131458,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131458,36.95,0.27,245,61266,70,NULL,NULL,'2MASX J15383242+3812418',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.634916667,38.2115,0.057,NULL,60096523383,939008177,14672002,17.2),(131459,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131459,38.34,0.46,466,61267,70,NULL,NULL,'SDSS J153832.63+234902.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00021,NULL,'18.2g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.635958333,23.81744,0.149,NULL,59450684968,928916952,14514327,18.2),(131460,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131460,38.3,0.46,457,61268,70,NULL,NULL,'2MASX J15383334+3114367',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.639,31.24361,0.077,NULL,59926012595,936343946,14630374,17.3),(131461,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131461,36.14,0.46,169,61269,70,NULL,NULL,'2MASX J15383353+1320423',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00006,NULL,'15.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,234.639583,13.34522,0.105,NULL,59425374224,928521472,14508148,15.4),(131462,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131462,36.6,0.27,209,61270,70,NULL,NULL,'2MASX J15383368+0639123',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000295,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.640375,6.65347,0.161,NULL,56414351439,881474241,13773035,17),(131463,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131463,37.49,0.33,315,61271,70,NULL,NULL,'SDSS J153834.31-002623.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.642958333,-0.43981,0.297,NULL,45400872653,709388635,11084197,18.2),(131464,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131464,38.19,0.15,434,61272,70,NULL,NULL,'2MASX J15383592+3051338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.6497917,30.85953,0.065,NULL,59925428537,936334820,14630231,17.9),(131465,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131465,36.85,0.46,234,61273,70,NULL,NULL,'2MASX J15383718+4906215',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.65475,49.10592,0.049,NULL,59721316668,933145572,14580399,17.8),(131466,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131466,36.8,0.46,229,61274,70,NULL,NULL,'2MASX J15383750+1434363',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.6562083,14.57661,0.113,NULL,59426739719,928542808,14508481,16.8),(131467,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131467,36.93,0.46,243,61275,70,NULL,NULL,'2MASX J15383815+4209426',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.659041667,42.16178,0.089,NULL,59963579829,936930934,14639545,16.9),(131468,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131468,32.91,0.15,38.2,61276,NULL,NULL,'BV A01','NGC 5982',NULL,'2007ApJ...668..130C',2007,1,2.26,NULL,'G',0.000031,NULL,'12.1g',1.39,'E3             LINER','in a triple',NULL,NULL,NULL,1,234.665958333,59.35583,0.013,NULL,57618197415,900284334,14066942,12.1),(131469,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131469,33.03,0.14,40.4,61276,74.4,NULL,NULL,'NGC 5982',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131470,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131470,33.09,0.1,41.5,61276,NULL,NULL,'J03','NGC 5982',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131471,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131471,33.09,0.1,41.5,61276,NULL,NULL,'M06','NGC 5982',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131472,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131472,33.2,0.66,43.7,61276,NULL,NULL,NULL,'NGC 5982',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131473,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131473,33.25,0.1,44.7,61276,NULL,NULL,'T01','NGC 5982',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131474,'SBF','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131474,33.57,0.66,51.7,61276,NULL,NULL,'Malmquist cor.','NGC 5982',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131475,'D-Sigma','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131475,32.66,0.4,34,61276,75,NULL,'Edat, raw','NGC 5982',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131476,'D-Sigma','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131476,32.99,0.4,39.7,61276,75,NULL,'Edat, cor','NGC 5982',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131477,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131477,31.72,0.27,22.1,61276,95,NULL,'Weighted Mean','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131478,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131478,31.79,0.63,22.8,61276,95,NULL,'Michard 1979b, c','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131479,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131479,31.99,0.46,25,61276,95,NULL,'Michard 1979a','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131480,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131480,32.09,0.4,26.2,61276,95,NULL,'de Vaucouleurs','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131481,'Faber-Jackson','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131481,32.16,0.81,27,61276,55,NULL,'Visvanathan & Sandage 1979','NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131482,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131482,32.87,0.41,37.4,61276,NULL,NULL,NULL,'NGC 5982',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131483,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131483,33.06,0.41,41,61276,NULL,NULL,'Malmquist cor.','NGC 5982',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131484,'Tertiary','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131484,32.2,0.29,27.5,61276,95,NULL,NULL,'NGC 5982',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131485,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131485,32.91,0.45,38.1,61276,NULL,NULL,'K','NGC 5982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131486,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131486,33.17,0.4,43.1,61276,NULL,NULL,'mean','NGC 5982',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131487,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131487,36.44,0.09,194,61277,70,NULL,NULL,'2MASX J15384018+2159546',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00006,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.667458333,21.99839,0.169,NULL,59452946340,928952286,14514879,16.2),(131488,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131488,36.93,0.46,243,61278,70,NULL,NULL,'2MASX J15384313+0845408',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,234.679583,8.76139,0.081,NULL,56595955756,884311808,13817372,16.6),(131489,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131489,35.69,0.2,137,61279,74.4,NULL,NULL,'CGCG 166-023',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'14.1',0.4,'Sc',NULL,NULL,NULL,NULL,1,234.6810417,29.41408,0.057,NULL,59927630408,936369225,14630769,14.1),(131490,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131490,37.4,0.46,302,61280,70,NULL,NULL,'2MASX J15384374+3102218',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.68225,31.03939,0.077,NULL,59925495888,936335873,14630248,17.3),(131491,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131491,37.83,0.46,367,61281,70,NULL,NULL,'2MASX J15384468+5808127',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.686,58.13703,0.005,NULL,57634423673,900537869,14070904,17.2),(131492,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131492,38.33,0.46,464,61282,70,NULL,NULL,'2MASX J15384714+0311331',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000085,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.696375,3.19253,0.181,NULL,56395148854,881174200,13768346,17.6),(131493,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131493,38.19,0.15,434,61283,70,NULL,NULL,'2MASX J15384881+3052209',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.7032917,30.87258,0.065,NULL,59925430093,936334845,14630231,17.3),(131494,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131494,35.41,0.46,121,61284,70,NULL,NULL,'2MASX J15384896+4934065',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'15.9g',0.4,'S0',NULL,NULL,NULL,NULL,1,234.703833333,49.56833,0.053,NULL,59721494951,933148358,14580443,15.9),(131495,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131495,37.43,0.27,307,61285,70,NULL,NULL,'2MASX J15385006+3607599',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.7087917,36.13342,0.057,NULL,59893163002,935830671,14622354,17.1),(131496,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131496,38,0.46,397,61286,70,NULL,NULL,'2MASX J15385152+2536522',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.7147917,25.6145,0.157,NULL,59915735321,936183364,14627865,17.8),(131497,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131497,38.07,0.46,410,61287,70,NULL,NULL,'2MASX J15385172-0208247',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.7155,-2.14025,0.365,NULL,45413249584,709582024,11087219,17.9),(131498,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131498,36.18,0.46,172,61288,70,NULL,NULL,'2MASX J15385234+0737168',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000169,NULL,'16.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.71825,7.62139,0.093,NULL,56417059051,881516547,13773696,16.1),(131499,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131499,36.69,0.46,218,61289,70,NULL,NULL,'2MASX J15385312+5302444',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.721,53.04567,0.049,NULL,59672325127,932380080,14568438,17.3),(131500,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131500,36.6,0.27,209,61290,70,NULL,NULL,'2MASX J15385479+0639519',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0002,NULL,'15.8g',0.49,'E0',NULL,NULL,NULL,NULL,1,234.728333,6.66444,0.161,NULL,56414343365,881474115,13773033,15.8),(131501,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131501,36.85,0.46,234,61291,70,NULL,NULL,'2MASX J15385641+4213577',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000183,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,234.734875,42.23283,0.077,NULL,59963455154,936928986,14639515,16),(131502,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131502,37.17,0.46,271,61292,70,NULL,NULL,'2MASX J15385686+4017549',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.73675,40.29872,0.061,NULL,59962656051,936916500,14639320,17.5),(131503,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131503,34.38,0.8,75.2,61293,75,NULL,'MAT, I','ESO 515- G 003',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.5',1,'SB(rs)c',NULL,NULL,NULL,NULL,1,234.7375417,-22.66347,0.549,NULL,46631828809,728622325,11384723,14.5),(131504,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131504,34.28,0.43,71.8,61293,75,NULL,'MAT, I, raw','ESO 515- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131505,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131505,34.44,0.47,77.4,61293,NULL,NULL,'H','ESO 515- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131506,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131506,34.47,0.46,78.5,61293,NULL,NULL,'J','ESO 515- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131507,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131507,34.52,0.45,80,61293,NULL,NULL,'K','ESO 515- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131508,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131508,34.53,0.4,80.5,61293,NULL,NULL,'mean','ESO 515- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131509,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131509,34.57,0.43,81.9,61293,75,NULL,'MAT, I, cor','ESO 515- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131510,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131510,34.59,0.43,82.6,61293,75,NULL,'MAT, I, inv','ESO 515- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131511,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131511,34.59,0.32,82.9,61293,85,NULL,'I, raw','ESO 515- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131512,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131512,34.62,0.2,84,61293,74.4,NULL,NULL,'ESO 515- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131513,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131513,34.67,0.32,86,61293,85,NULL,'I, inv','ESO 515- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131514,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131514,34.74,0.34,88.5,61293,NULL,NULL,NULL,'ESO 515- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131515,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131515,34.79,0.33,91,61293,NULL,NULL,'Malmquist cor.','ESO 515- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131516,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131516,36.44,0.09,194,61294,70,NULL,NULL,'2MASX J15385812+2148178',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.47',0.2,NULL,NULL,NULL,NULL,NULL,1,234.742125,21.80486,0.181,NULL,59452917690,928951838,14514872,17.47),(131517,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131517,37.12,0.46,266,61295,70,NULL,NULL,'2MASX J15385818+0256119',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.742458333,2.93656,0.173,NULL,56403358025,881302469,13770351,17.3),(131518,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131518,36.82,0.2,231,61296,74.4,NULL,NULL,'CGCG 136-039',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00007,NULL,'15.5',0.3,'S0',NULL,NULL,NULL,NULL,1,234.743,23.78078,0.149,NULL,59450676834,928916825,14514325,15.5),(131519,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131519,37.49,0.33,315,61297,70,NULL,NULL,'2MASX J15385905-0025298',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000091,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.746083333,-0.42489,0.297,NULL,45400870367,709388599,11084196,16.8),(131520,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131520,36.09,0.46,165,61298,70,NULL,NULL,'CGCG 050-057',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000187,NULL,'15.5g',0.51,NULL,NULL,NULL,NULL,NULL,1,234.747333,8.09033,0.081,NULL,56596330467,884317663,13817463,15.5),(131521,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131521,36.96,0.33,246,61299,70,NULL,NULL,'2MASX J15385990+0625049',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000156,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.7494583,6.41794,0.161,NULL,56413640376,881463130,13772861,16.7),(131522,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131522,37.86,0.33,374,61300,70,NULL,NULL,'2MASX J15390169+3530459',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000237,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,234.756917,35.51281,0.053,NULL,59893376697,935834010,14622406,17.1),(131523,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131523,36.34,0.46,185,61301,70,NULL,NULL,'2MASX J15390216+3304479',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000168,NULL,'16.0g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,234.758917,33.08014,0.069,NULL,59883249098,935675767,14619933,16),(131524,'Tully est','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131524,32.34,0.8,29.4,61302,75,NULL,'B','NGC 5974',NULL,'1988NBGC.C....0000T',1988,1,0.87,NULL,'G',0.000097,NULL,'14.1g',0.53,'Sd/Irr','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.760083,31.75992,0.093,NULL,59925173588,936330837,14630169,14.1),(131525,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131525,37.86,0.33,374,61303,70,NULL,NULL,'SDSS J153902.56+353142.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.7607083,35.52856,0.053,NULL,59893376870,935834013,14622406,18.4),(131526,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131526,37.54,0.46,322,61304,70,NULL,NULL,'2MASX J15390364+0712329',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.7652083,7.20903,0.109,NULL,56413867494,881466679,13772916,17),(131527,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131527,37.17,0.33,271,61305,70,NULL,NULL,'2MASX J15390366+3205219',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.765333,32.08961,0.085,NULL,59913577513,936149648,14627338,17.1),(131528,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131528,37.48,0.46,313,61306,70,NULL,NULL,'2MASX J15390418+0231299',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.7675,2.52489,0.133,NULL,56403938529,881311539,13770492,17.3),(131529,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131529,37.44,0.46,308,61307,70,NULL,NULL,'SDSS J153904.53+332740.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.768875,33.46117,0.069,NULL,59891057863,935797779,14621840,18.5),(131530,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131530,37.17,0.33,271,61308,70,NULL,NULL,'2MASX J15390462+3212199',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.7692917,32.20544,0.085,NULL,59913585135,936149767,14627340,17.6),(131531,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131531,38.02,0.33,402,61309,70,NULL,NULL,'2MASX J15390472+1256404',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'PHOT','16.6g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,234.7697917,12.94453,0.125,NULL,56523247086,883175735,13799620,16.6),(131532,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131532,38.02,0.33,402,61310,70,NULL,NULL,'2MASX J15390526+1255044',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.771875,12.91786,0.125,NULL,56523246764,883175730,13799620,18.2),(131533,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131533,36.94,0.33,244,61311,70,NULL,NULL,'2MASX J15390562+2845411',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00009,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,234.773417,28.76133,0.077,NULL,59927431039,936366109,14630720,15.5),(131534,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131534,36.94,0.33,244,61312,70,NULL,NULL,'2MASX J15390685+2851031',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00019,NULL,'17.1g',0.23,'E',NULL,NULL,NULL,NULL,1,234.778667,28.85094,0.065,NULL,59927434500,936366164,14630721,17.1),(131535,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131535,37.18,0.46,273,61313,70,NULL,NULL,'2MASX J15390692+5159429',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.778916667,51.99522,0.049,NULL,59671267466,932363554,14568180,16.7),(131536,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131536,37.43,0.27,307,61314,70,NULL,NULL,'2MASX J15390762+3602238',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000168,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.781667,36.04003,0.065,NULL,59893209947,935831405,14622365,17.4),(131537,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131537,37.19,0.46,274,61315,70,NULL,NULL,'2MASX J15390927+3731098',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000138,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.78875,37.51933,0.049,NULL,59879670887,935619857,14619060,17.3),(131538,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131538,37.43,0.27,307,61316,70,NULL,NULL,'SDSS J153909.38+360525.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000175,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.789083333,36.0905,0.065,NULL,59893194255,935831160,14622361,18.1),(131539,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131539,38.62,0.46,530,61317,70,NULL,NULL,'SDSS J153909.52+315656.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000138,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,234.789666667,31.94894,0.089,NULL,59913683900,936151310,14627364,18.8),(131540,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131540,35.51,0.64,126,61318,70,NULL,NULL,'2MASX J15391002-1411478',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.10',NULL,NULL,NULL,NULL,NULL,NULL,1,234.791833,-14.19653,0.517,NULL,46592932670,728014572,11375227,16.1),(131541,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131541,38.11,0.46,419,61319,70,NULL,NULL,'2MASX J15391124+3207202',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.796917,32.12217,0.085,NULL,59913577941,936149655,14627338,17.7),(131542,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131542,36.69,0.46,218,61320,70,NULL,NULL,'2MASX J15391225+4321410',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,234.801,43.36144,0.061,NULL,59678808376,932481380,14570021,16.9),(131543,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131543,37.97,0.46,392,61321,70,NULL,NULL,'2MASX J15391273+0303479',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.8029583,3.06333,0.177,NULL,56395112929,881173639,13768338,17.9),(131544,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131544,38.19,0.46,435,61322,70,NULL,NULL,'SDSS J153912.87+254710.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.8g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.803666667,25.78633,0.157,NULL,59915714492,936183038,14627859,18.8),(131545,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131545,37.28,0.46,286,61323,70,NULL,NULL,'2MASX J15391333+0301589',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000087,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.805666667,3.03317,0.177,NULL,56403303848,881301622,13770337,17.6),(131546,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131546,34.28,NULL,71.8,61324,NULL,NULL,NULL,'UGC 09949',NULL,'2000BSAO...50....5K',2000,1,1.15,NULL,'G',0.000012,NULL,'16.0',0.11,'Sc','Group member',NULL,NULL,NULL,1,234.805833,14.17706,0.117,NULL,59426700483,928542195,14508471,16),(131547,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131547,34.3,NULL,72.4,61324,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131548,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131548,34.33,NULL,73.6,61324,NULL,NULL,'Dipole + Quadrupole','UGC 09949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131549,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131549,34.35,NULL,74.2,61324,NULL,NULL,'Dipole','UGC 09949',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131550,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131550,34.53,0.49,80.5,61324,75,NULL,'IR','UGC 09949',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131551,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131551,34.61,0.2,83.6,61324,74.4,NULL,NULL,'UGC 09949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131552,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131552,37.24,0.46,281,61325,70,NULL,NULL,'2MASX J15391347+3343262',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.8062083,33.72394,0.065,NULL,59891107967,935798561,14621852,17.4),(131553,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131553,37.85,0.46,371,61326,70,NULL,NULL,'2MASX J15391358+0042039',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000082,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.8065417,0.70111,0.245,NULL,56391773162,881121455,13767522,17.4),(131554,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131554,35.41,0.46,121,61327,70,NULL,NULL,'2MASX J15391412+0111419',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000063,NULL,'16.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.80875,1.19489,0.249,NULL,56391622284,881119098,13767485,16.2),(131555,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131555,39.28,0.46,718,61328,70,NULL,NULL,'SDSS J153914.21-014418.8',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000157,NULL,'19.2g',0.09,NULL,NULL,NULL,NULL,NULL,1,234.8092083,-1.73858,0.365,NULL,45401792069,709403001,11084421,19.2),(131556,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131556,37.47,0.46,312,61329,70,NULL,NULL,'2MASX J15391458+4522250',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.810916667,45.37378,0.017,NULL,59688308411,932629818,14572340,17.1),(131557,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131557,34.78,0.55,90.2,61330,70,NULL,NULL,'2MASX J15391472-1138232',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.89',NULL,NULL,NULL,NULL,NULL,NULL,1,234.8112917,-11.63992,0.589,NULL,45600854084,712513345,11133021,15.89),(131558,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131558,35.74,0.49,140,61331,75,NULL,'IR','UGC 09957',NULL,'2011yCatp016004901K',2011,1,1.41,NULL,'G',0.000173,NULL,'16.3g',0.17,'Sd',NULL,NULL,NULL,NULL,1,234.813125,40.14525,0.061,NULL,59962676213,936916815,14639325,16.3),(131559,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131559,36,NULL,158,61331,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09957',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131560,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131560,36.02,NULL,160,61331,NULL,NULL,'Dipole + Quadrupole','UGC 09957',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131561,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131561,36.02,NULL,160,61331,NULL,NULL,NULL,'UGC 09957',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131562,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131562,36.04,NULL,161,61331,NULL,NULL,'Dipole','UGC 09957',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131563,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131563,34.92,NULL,96.4,61332,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1931',NULL,'2010Ap&SS.325..163P',2010,1,0.72,NULL,'G',0.00009,NULL,'17.0g',0.14,'Sd',NULL,NULL,NULL,NULL,1,234.814875,46.83617,0.029,NULL,59687554936,932618045,14572156,17),(131564,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131564,34.93,NULL,97,61332,NULL,NULL,'Dipole + Quadrupole','FGC 1931',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131565,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131565,34.96,NULL,98.4,61332,NULL,NULL,'Dipole','FGC 1931',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131566,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131566,35.19,NULL,109,61332,NULL,NULL,NULL,'FGC 1931',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131567,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131567,35.81,0.2,145,61333,74.4,NULL,NULL,'UGC 09954',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000033,NULL,'14.9g',0.41,'Sab',NULL,NULL,NULL,NULL,1,234.819541667,24.45508,0.125,NULL,59395657535,928057148,14500892,14.9),(131568,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131568,35.87,0.4,149,61333,NULL,NULL,'mean','UGC 09954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131569,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131569,35.91,0.47,152,61333,NULL,NULL,'H','UGC 09954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131570,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131570,35.95,0.45,155,61333,NULL,NULL,'K','UGC 09954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131571,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131571,36.1,0.46,166,61333,NULL,NULL,'J','UGC 09954',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131572,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131572,36.44,0.09,194,61334,70,NULL,NULL,'2MASX J15391714+2144319',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000063,NULL,'17.13',0.2,NULL,NULL,NULL,NULL,NULL,1,234.8214583,21.74206,0.181,NULL,59452799587,928949993,14514843,17.13),(131573,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131573,36.78,0.46,227,61335,70,NULL,NULL,'2MASX J15391877+0444399',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,234.828125,4.74436,0.129,NULL,56393128728,881142636,13767853,16.5),(131574,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131574,37.36,0.46,297,61336,70,NULL,NULL,'2MASX J15391944+1922529',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.830917,19.38131,0.137,NULL,59448617199,928884643,14513822,17),(131575,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131575,35.27,0.46,113,61337,70,NULL,NULL,'2MASX J15391964+0452069',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,234.831875,4.86878,0.117,NULL,56393233626,881144275,13767879,16),(131576,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131576,36.44,0.09,194,61338,70,NULL,NULL,'2MASX J15391980+2152329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00025,NULL,'17.71',0.2,NULL,NULL,NULL,NULL,NULL,1,234.832416667,21.87575,0.189,NULL,59452793223,928949894,14514842,17.71),(131577,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131577,33.87,0.54,59.6,61339,NULL,NULL,NULL,'ESO 450- G 004',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.70',0.2,'S...',NULL,NULL,NULL,NULL,1,234.8325,-29.99681,0.533,NULL,47177471590,737147993,11517937,16.7),(131578,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131578,33.92,0.2,60.8,61339,74.4,NULL,NULL,'ESO 450- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131579,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131579,34.14,0.48,67.2,61339,NULL,NULL,'Malmquist cor.','ESO 450- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131580,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131580,34.37,0.49,74.8,61339,75,NULL,'IR','ESO 450- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131581,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131581,35.85,0.25,148,61340,74.4,NULL,NULL,'CGCG 136-041',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00007,NULL,'14.24',0.7,'E/S0','Group member',NULL,NULL,NULL,1,234.8452917,21.73925,0.181,NULL,59452799985,928949999,14514843,14.24),(131582,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131582,36.04,0.27,161,61340,70,NULL,NULL,'CGCG 136-041',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131583,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131583,36.44,0.09,194,61340,70,NULL,NULL,'CGCG 136-041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131584,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131584,36.44,0.09,194,61341,70,NULL,NULL,'2MASX J15392453+2140139',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000063,NULL,'16.81',0.3,NULL,NULL,NULL,NULL,NULL,1,234.852375,21.67036,0.173,NULL,59454682991,928979421,14515303,16.81),(131585,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131585,38,0.46,399,61342,70,NULL,NULL,'2MASX J15392486+1207035',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.85375,12.11761,0.101,NULL,56590304695,884223510,13815992,17),(131586,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131586,37.97,0.14,393,61343,70,NULL,NULL,'2MASX J15392535+1738025',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.8557083,17.63406,0.097,NULL,59430573595,928602712,14509417,17.9),(131587,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131587,37.04,0.46,256,61344,70,NULL,NULL,'2MASX J15392567+1618425',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.8569583,16.31178,0.105,NULL,59439948560,928749196,14511706,NULL),(131588,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131588,38.97,0.46,621,61345,70,NULL,NULL,'SDSS J153926.15+115444.4',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.8589583,11.91233,0.109,NULL,56590297114,884223392,13815990,NULL),(131589,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131589,36.26,0.46,178,61346,70,NULL,NULL,'2MASX J15392629+0019457',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'17.6g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,234.8597083,0.32928,0.253,NULL,56391679541,881119992,13767499,17.6),(131590,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131590,38.5,0.46,502,61347,70,NULL,NULL,'SDSS J153926.34+044607.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,234.8597917,4.76881,0.129,NULL,56393110531,881142352,13767849,NULL),(131591,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131591,37.55,0.33,324,61348,70,NULL,NULL,'2MASX J15392642+2319419',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.860083,23.32842,0.153,NULL,59450623623,928915994,14514312,17.2),(131592,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131592,36.74,0.46,223,61349,70,NULL,NULL,'2MASX J15392690+1706255',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.8619583,17.10697,0.077,NULL,59438034388,928719287,14511238,16.9),(131593,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131593,37.86,0.46,373,61350,70,NULL,NULL,'2MASX J15392693+1919239',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.8622917,19.32333,0.137,NULL,59448615527,928884617,14513822,17.3),(131594,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131594,37.73,0.33,352,61351,70,NULL,NULL,'2MASX J15392715+1056130',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.863167,10.93694,0.089,NULL,56593603524,884275055,13816797,17.7),(131595,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131595,36.95,0.27,245,61352,70,NULL,NULL,'2MASX J15392719+3808218',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000163,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,234.863416667,38.13944,0.057,NULL,59878157406,935596209,14618690,16.8),(131596,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131596,37.55,0.33,324,61353,70,NULL,NULL,'2MASX J15392747+2320378',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.864416667,23.34378,0.153,NULL,59450625173,928916018,14514312,17.5),(131597,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131597,38.19,0.15,434,61354,70,NULL,NULL,'SDSS J153927.96+304424.7',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.8665,30.74022,0.073,NULL,59925864949,936341639,14630338,17),(131598,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131598,36.55,0.46,204,61355,70,NULL,NULL,'SDSS J153927.98+103705.9',NULL,'2015arXiv151105856S',2015,1,0.07,NULL,'G',NULL,NULL,'20.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.866625,10.61833,0.085,NULL,56590927852,884233247,13816144,20.6),(131599,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131599,36.42,0.46,192,61356,70,NULL,NULL,'2MASX J15392880+1817419',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,234.870125,18.29511,0.073,NULL,59430329254,928598894,14509357,16.3),(131600,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131600,38.19,0.15,434,61357,70,NULL,NULL,'2MASX J15392882+3044002',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.8702917,30.73333,0.073,NULL,59925864930,936341639,14630338,18.5),(131601,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131601,38.41,0.46,482,61358,70,NULL,NULL,'2MASX J15392887+0502267',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.870375,5.04086,0.117,NULL,56393448385,881147631,13767931,17.9),(131602,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131602,37.91,0.46,383,61359,70,NULL,NULL,'2MASX J15393008+5635147',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.87525,56.58733,0.041,NULL,57592010119,899875158,14060549,18),(131603,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131603,37.69,0.46,344,61360,70,NULL,NULL,'2MASX J15393049+0051107',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,234.877125,0.85286,0.249,NULL,56392346224,881130409,13767662,17.1),(131604,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131604,37.97,0.14,393,61361,70,NULL,NULL,'2MASXi J1539306+174652',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.877958333,17.78119,0.073,NULL,59431117864,928611216,14509550,18.1),(131605,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131605,37.73,0.46,352,61362,70,NULL,NULL,'SDSS J153931.71-013118.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000134,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.882125,-1.52172,0.385,NULL,45402308649,709411072,11084548,18.8),(131606,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131606,37.94,0.46,387,61363,70,NULL,NULL,'SDSS J153931.72+303745.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.8822083,30.62919,0.073,NULL,59925399463,936334366,14630224,18.3),(131607,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131607,36.95,0.27,245,61364,70,NULL,NULL,'2MASX J15393202+3809488',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000205,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,234.883375,38.16392,0.057,NULL,59878157797,935596215,14618690,15.6),(131608,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131608,36.6,0.46,209,61365,70,NULL,NULL,'2MASX J15393209+4804229',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.883833333,48.07311,0.045,NULL,59722499878,933164060,14580688,17.5),(131609,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131609,37.68,0.46,343,61366,70,NULL,NULL,'SDSS J153932.23+104841.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.884333,10.81147,0.077,NULL,56593563042,884274422,13816787,18.2),(131610,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131610,35.24,0.5,112,61367,70,NULL,NULL,'2MASX J15393276-1134262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'15.79',NULL,NULL,NULL,NULL,NULL,NULL,1,234.886625,-11.574,0.589,NULL,45604336099,712567751,11133871,15.79),(131611,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131611,36.76,0.46,225,61368,70,NULL,NULL,'2MASX J15393305+3205382',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000187,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,234.887833,32.09397,0.085,NULL,59913583581,936149743,14627339,15.8),(131612,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131612,36.6,0.46,209,61369,70,NULL,NULL,'2MASX J15393349+0331577',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000095,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.889416667,3.53286,0.141,NULL,56395332623,881177072,13768391,17.1),(131613,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131613,36.44,0.09,194,61370,70,NULL,NULL,'2MASX J15393532+2144259',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'16.84',0.3,NULL,NULL,NULL,NULL,NULL,1,234.897375,21.74053,0.181,NULL,59452792037,928949875,14514841,16.84),(131614,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131614,36.67,0.33,216,61371,70,NULL,NULL,'2MASX J15393556+5530162',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000108,NULL,'16.2g',0.4,'AGN',NULL,NULL,NULL,NULL,1,234.898333,55.50442,0.037,NULL,57584978096,899765282,14058832,16.2),(131615,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131615,36.28,0.33,181,61372,70,NULL,NULL,'2MASX J15393652+4601500',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000205,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,234.901917,46.03067,0.021,NULL,59688168491,932627632,14572306,15.9),(131616,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131616,36.64,0.46,213,61373,70,NULL,NULL,'2MASX J15393700+1109255',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,234.90425,11.157,0.101,NULL,56593723456,884276929,13816827,15.7),(131617,'Ring Diameter','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131617,32.1,0.84,26,61374,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 5985',NULL,'1981ApJS...45..541P',1981,1,5.5,NULL,'G',0.000013,NULL,'11.87',3,'SAB(r)b;LINER  Sy1','in a triple',NULL,NULL,'Sy',1,234.9045417,59.33194,NULL,NULL,57618166191,900283846,14066935,11.87),(131618,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131618,32.1,0.69,26.4,61374,100,NULL,'mid-IR','NGC 5985',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131619,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131619,32.94,0.4,38.8,61374,NULL,NULL,'mean','NGC 5985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131620,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131620,32.97,0.4,39.2,61374,75,NULL,'B','NGC 5985',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131621,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131621,33.03,0.46,40.4,61374,NULL,NULL,'J','NGC 5985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131622,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131622,33.07,0.41,41.2,61374,NULL,NULL,'Malmquist cor.','NGC 5985',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131623,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131623,33.09,0.41,41.5,61374,NULL,NULL,NULL,'NGC 5985',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131624,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131624,33.12,0.45,42,61374,NULL,NULL,'K','NGC 5985',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131625,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131625,33.51,0.2,50.4,61374,74.4,NULL,NULL,'NGC 5985',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131626,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131626,33.61,0.36,52.7,61374,NULL,NULL,NULL,'NGC 5985',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131627,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131627,33.78,0.43,56.9,61374,75,NULL,'3.6 micron, color corrected','NGC 5985',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131628,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131628,33.93,0.43,61.1,61374,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5985',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131629,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131629,36.85,0.46,235,61375,70,NULL,NULL,'2MASX J15393757+2355119',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.906583333,23.92006,0.145,NULL,59450663924,928916623,14514322,16.8),(131630,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131630,39.03,0.63,640,61376,NULL,NULL,'Hydrost. Eq.','ABELL 2111',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,234.93375,34.41556,0.061,NULL,59894110308,935845473,14622585,NULL),(131631,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131631,39.29,0.97,720,61376,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2111',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131632,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131632,39.29,1,720,61376,NULL,NULL,'Isotherm.','ABELL 2111',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131633,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131633,39.75,NULL,893,61376,NULL,NULL,'4.2 (black) calibration','ABELL 2111',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131634,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131634,39.78,NULL,903,61376,NULL,NULL,'3.1 (red) calibration','ABELL 2111',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131635,'SZ effect','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131635,39.82,NULL,921,61376,NULL,NULL,'4.1 (blue) calibration','ABELL 2111',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131636,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131636,36.34,0.6,185,61377,70,NULL,NULL,'2MASX J15393825-2356332',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,234.909417,-23.94264,0.541,NULL,46628475627,728569931,11383905,14.6),(131637,'BCG','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131637,36.47,0.35,189,61378,60,NULL,NULL,'ABELL 2107',0.0421,'1980ApJ...241..486H',1980,1,NULL,'The adopted position is for UGC 09958, the brightest cluster member.','GClstr',0.000287,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,234.91,21.78889,0.181,NULL,59452796960,928949952,14514843,NULL),(131638,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131638,36.67,0.33,216,61379,70,NULL,NULL,'2MASX J15393847+5519382',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,234.91025,55.32742,0.025,NULL,57587658541,899807164,14059486,16.6),(131639,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131639,35.46,0.49,124,61380,75,NULL,'IR','UGC 09956',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.60',0.2,'SBb',NULL,NULL,NULL,NULL,1,234.912375,10.21994,0.105,NULL,56591534875,884242732,13816292,15.6),(131640,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131640,35.93,0.2,153,61380,74.4,NULL,NULL,'UGC 09956',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131641,'BCG','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131641,36.47,0.35,189,61381,60,NULL,'ABELL 2107, BCG','UGC 09958',0.0421,'1980ApJ...241..486H',1980,1,1.3,'May be associated with the extended X-ray source EXSS 1537.4+2156.','G',0.000083,NULL,'14.33',1.1,'E;S0-:         BrClG','Group member',NULL,NULL,NULL,1,234.912667,21.78272,0.181,NULL,59452789867,928949841,14514841,14.33),(131642,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131642,35.85,0.25,148,61381,74.4,NULL,NULL,'UGC 09958',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131643,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131643,36.04,0.27,161,61381,70,NULL,NULL,'UGC 09958',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131644,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131644,36.44,0.09,194,61381,70,NULL,NULL,'UGC 09958',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131645,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131645,36.15,0.45,170,61381,NULL,NULL,'K','UGC 09958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131646,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131646,36.24,0.4,177,61381,NULL,NULL,'mean','UGC 09958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131647,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131647,38.3,0.46,458,61382,70,NULL,NULL,'2MASX J15393978+3042276',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,234.915917,30.70775,0.073,NULL,59925865972,936341655,14630338,18.5),(131648,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131648,36.9,0.2,240,61383,74.4,NULL,NULL,'CGCG 136-045',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.00006,NULL,'15.4g',0.37,'Sc',NULL,NULL,NULL,NULL,1,234.918375,25.73983,0.157,NULL,59869627810,935462934,14616608,15.4),(131649,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131649,37.04,0.46,256,61384,70,NULL,NULL,'2MASX J15394092+1532419',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.920583333,15.54511,0.093,NULL,59440487891,928757623,14511837,18),(131650,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131650,37.66,0.46,340,61385,70,NULL,NULL,'2MASX J15394088+2338079',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.920667,23.63553,0.149,NULL,59450834750,928919292,14514363,18),(131651,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131651,37.07,0.46,260,61386,70,NULL,NULL,'2MASX J15394162+3548556',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000178,NULL,'15.8g',0.51,'E0',NULL,NULL,NULL,NULL,1,234.9232917,35.81539,0.053,NULL,59893296010,935832750,14622386,15.8),(131652,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131652,36.44,0.09,194,61387,70,NULL,NULL,'2MASX J15394162+2151149',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00007,NULL,'16.17',0.32,NULL,NULL,NULL,NULL,NULL,1,234.9235,21.85411,0.189,NULL,59452804940,928950077,14514844,16.17),(131653,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131653,37.78,0.33,360,61388,70,NULL,NULL,'2MASX J15394218+0325087',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000086,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,234.925667,3.419,0.161,NULL,56395402235,881178159,13768408,17.3),(131654,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131654,36.99,0.46,250,61389,70,NULL,NULL,'2MASX J15394357+0309477',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,234.931625,3.16328,0.177,NULL,56395375718,881177745,13768402,16.5),(131655,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131655,38.86,0.46,593,61390,70,NULL,NULL,'SBS 1538+580',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.932375,57.85586,0.025,NULL,57637620780,900587824,14071684,18.3),(131656,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131656,35.12,NULL,106,61391,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1932',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.000101,NULL,'17.5g',0.09,'Sdm',NULL,NULL,NULL,NULL,1,234.9415,41.87339,0.069,NULL,59963402965,936928171,14639502,17.5),(131657,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131657,35.15,NULL,107,61391,NULL,NULL,'Dipole + Quadrupole','FGC 1932',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131658,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131658,35.17,NULL,108,61391,NULL,NULL,'Dipole','FGC 1932',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131659,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131659,35.33,NULL,116,61391,NULL,NULL,NULL,'FGC 1932',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131660,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131660,37.66,0.46,341,61392,70,NULL,NULL,'2MASX J15394598+3238277',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.9417083,32.641,0.105,NULL,59883185405,935674771,14619918,17.4),(131661,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131661,38.13,0.46,423,61393,70,NULL,NULL,'2MASX J15394635-0156266',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,234.943167,-1.94061,0.337,NULL,45401877663,709404338,11084442,18.4),(131662,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131662,37.97,0.14,393,61394,70,NULL,NULL,'2MASX J15394645+1750079',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,234.943625,17.8355,0.073,NULL,59431080419,928610631,14509541,16.3),(131663,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131663,34.97,0.49,98.7,61395,70,NULL,NULL,'2MASX J15394745-1323422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,234.94775,-13.39508,0.553,NULL,45466549409,710414834,11100231,14.8),(131664,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131664,37.78,0.33,360,61396,70,NULL,NULL,'2MASX J15394758+0325137',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000118,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,234.948166667,3.42042,0.161,NULL,56395412720,881178323,13768411,16.4),(131665,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131665,37.38,0.46,299,61397,70,NULL,NULL,'2MASX J15394777+3114217',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,234.949083,31.23939,0.089,NULL,59926110945,936345483,14630398,17.2),(131666,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131666,38.48,0.46,498,61398,70,NULL,NULL,'2MASX J15394804+1412059',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.9502083,14.20172,0.117,NULL,59426720265,928542504,14508476,17.9),(131667,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131667,37.55,0.21,324,61399,70,NULL,NULL,'2MASX J15394812+0311067',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000081,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,234.950625,3.18522,0.169,NULL,56395380252,881177816,13768403,17.5),(131668,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131668,36.44,0.09,194,61400,70,NULL,NULL,'2MASX J15394873+2147270',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000073,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.953083,21.79086,0.181,NULL,59452808059,928950125,14514845,16.4),(131669,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131669,37.85,0.46,371,61401,70,NULL,NULL,'2MASX J15394962+4710268',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,234.956875,47.17406,0.045,NULL,59720304296,933129754,14580152,17.3),(131670,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131670,37.73,0.33,352,61402,70,NULL,NULL,'2MASX J15394985+1057405',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,234.957625,10.96122,0.089,NULL,56593609777,884275152,13816799,17.9),(131671,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131671,37.37,0.33,298,61403,70,NULL,NULL,'2MASX J15395045+4436218',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,234.960125,44.60614,0.029,NULL,59690832853,932669263,14572957,18),(131672,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131672,37.43,0.46,307,61404,70,NULL,NULL,'2MASX J15395059+3348197',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000186,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,234.96075,33.80544,0.065,NULL,59891074891,935798045,14621844,16.3),(131673,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131673,36.44,0.09,194,61405,70,NULL,NULL,'2MASX J15395067+2158070',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'17.59',0.2,NULL,NULL,NULL,NULL,NULL,1,234.961125,21.96869,0.189,NULL,59452783046,928949735,14514839,17.59),(131674,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131674,38.19,0.15,434,61406,70,NULL,NULL,'2MASX J15395079+3043037',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000222,NULL,'16.0g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,234.961583,30.71778,0.073,NULL,59925869030,936341703,14630339,16),(131675,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131675,36.04,0.27,161,61407,70,NULL,NULL,'GIN 442',NULL,'2001MNRAS.321..277C',2001,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.36,'S',NULL,NULL,NULL,NULL,1,234.963667,21.70419,0.181,NULL,59452788905,928949826,14514841,16.4),(131676,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131676,37.97,0.14,393,61408,70,NULL,NULL,'2MASX J15395261+1757329',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,234.9692917,17.95906,0.069,NULL,59431132333,928611442,14509553,16.8),(131677,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131677,37.97,0.14,393,61409,70,NULL,NULL,'2MASX J15395282+1751309',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,234.970375,17.85858,0.069,NULL,59431080119,928610626,14509541,17.8),(131678,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131678,37.64,0.46,338,61410,70,NULL,NULL,'SDSS J153953.43+244603.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,234.972625,24.76769,0.141,NULL,59395694550,928057727,14500901,18.2),(131679,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131679,36.44,0.09,194,61411,70,NULL,NULL,'CGCG 136-048',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00009,NULL,'14.9V',0.5,NULL,'Group member',NULL,NULL,NULL,1,234.983375,21.86681,0.189,NULL,59452815290,928950238,14514847,14.9),(131680,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131680,35.86,0.25,149,61412,74.4,NULL,NULL,'CGCG 136-047 NED02',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000077,NULL,'14.47',0.47,'E/S0',NULL,NULL,NULL,NULL,1,234.9865,21.82422,0.181,NULL,59452817301,928950270,14514847,14.47),(131681,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131681,36.04,0.27,161,61412,70,NULL,NULL,'CGCG 136-047 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131682,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131682,36.44,0.09,194,61412,70,NULL,NULL,'CGCG 136-047 NED02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131683,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131683,33.31,0.46,46,61413,NULL,NULL,'J','NGC 5987',NULL,'2007A&A...465...71T',2007,1,4.2,NULL,'G',0.00002,NULL,'12.72',1.3,'Sb','in a radial-velocity based grouping',NULL,NULL,NULL,1,234.9890417,58.07953,0.025,NULL,57637823777,900590996,14071734,12.72),(131684,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131684,33.32,0.4,46.1,61413,NULL,NULL,'mean','NGC 5987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131685,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131685,33.34,0.47,46.6,61413,NULL,NULL,'H','NGC 5987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131686,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131686,33.42,0.45,48.3,61413,NULL,NULL,'K','NGC 5987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131687,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131687,33.42,0.34,48.3,61413,NULL,NULL,'Malmquist cor.','NGC 5987',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131688,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131688,33.47,0.33,49.5,61413,NULL,NULL,NULL,'NGC 5987',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131689,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131689,33.48,0.2,49.7,61413,74.4,NULL,NULL,'NGC 5987',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131690,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131690,38.19,0.15,434,61414,70,NULL,NULL,'2MASX J15395770+3041087',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,234.990625,30.68569,0.073,NULL,59925872518,936341758,14630339,18),(131691,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131691,33.49,0.47,50,61415,NULL,NULL,'H','NGC 5975',NULL,'2007A&A...465...71T',2007,1,1,'HOLM 718B does not exist (it is probably a plate defect).','G',0.000007,NULL,'15.10',0.3,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,234.9915417,21.47081,0.173,NULL,59454697614,928979650,14515307,15.1),(131692,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131692,33.53,0.45,50.8,61415,NULL,NULL,'K','NGC 5975',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131693,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131693,33.58,0.46,52.1,61415,NULL,NULL,'J','NGC 5975',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131694,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131694,33.67,0.43,54.1,61415,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5975',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131695,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131695,33.84,0.43,58.6,61415,75,NULL,'3.6 micron, color corrected','NGC 5975',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131696,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131696,33.92,0.4,60.7,61415,NULL,NULL,'mean','NGC 5975',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131697,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131697,34.07,0.2,65.2,61415,74.4,NULL,NULL,'NGC 5975',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131698,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131698,37.97,0.14,393,61416,70,NULL,NULL,'2MASX J15395899+1758339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,234.9957917,17.97594,0.069,NULL,59431130506,928611414,14509553,17.8),(131699,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131699,37.5,0.27,317,61417,70,NULL,NULL,'2MASX J15395954+3543207',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000176,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,234.998083,35.72233,0.049,NULL,59893342934,935833483,14622398,18.3),(131700,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131700,37.89,0.46,379,61418,70,NULL,NULL,'2MASX J15395981+3801471',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000139,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,234.999167,38.02975,0.041,NULL,59878203997,935596937,14618702,17.9),(131701,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131701,37.29,0.27,287,61419,70,NULL,NULL,'2MASX J15400006+4835409',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.000375,48.59481,0.037,NULL,59721908023,933154812,14580543,17.7),(131702,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131702,38.32,0.46,461,61420,70,NULL,NULL,'2MASX J15400341+1224432',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.014208333,12.41192,0.093,NULL,56522949401,883171084,13799548,17.7),(131703,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131703,32.89,0.2,37.8,61421,74.4,NULL,NULL,'UGC 09962',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000013,NULL,'15.70',0.1,'Im:','Group member',NULL,NULL,NULL,1,235.0142917,13.97603,0.109,NULL,59426531153,928539549,14508430,15.7),(131704,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131704,37.5,0.27,317,61422,70,NULL,NULL,'2MASX J15400398+3543507',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,235.0167083,35.73075,0.049,NULL,59893345607,935833525,14622398,16.5),(131705,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131705,36.44,0.27,194,61423,70,NULL,NULL,'2MASX J15400439+0607263',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,235.018333,6.12386,0.109,NULL,56413389603,881459212,13772800,16.2),(131706,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131706,36.28,0.33,181,61424,70,NULL,NULL,'2MASX J15400447+4606209',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000187,NULL,'15.5g',0.47,'E0',NULL,NULL,NULL,NULL,1,235.01875,46.10594,0.021,NULL,59687714240,932620535,14572195,15.5),(131707,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131707,36.09,0.4,165,61425,NULL,NULL,'mean','UGC 09960',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'14.80',0.5,'Sa','Isolated galaxy',NULL,NULL,NULL,1,235.023875,1.93364,0.217,NULL,56389706415,881089162,13767018,14.8),(131708,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131708,36.37,0.47,188,61425,NULL,NULL,'H','UGC 09960',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131709,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131709,38.01,0.33,399,61426,70,NULL,NULL,'SDSS J154006.13+232544.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.025583,23.42917,0.157,NULL,59450653428,928916459,14514319,18.5),(131710,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131710,37.55,0.21,324,61427,70,NULL,NULL,'2MASX J15400662+0309503',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.027667,3.16386,0.169,NULL,56394655576,881166493,13768226,17.7),(131711,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131711,37.5,0.27,317,61428,70,NULL,NULL,'2MASX J15400677+3544447',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.028125,35.74583,0.049,NULL,59893346276,935833535,14622398,17.3),(131712,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131712,37.63,0.46,335,61429,70,NULL,NULL,'2MASX J15400722+0055153',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000084,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.0302083,0.921,0.249,NULL,56392380093,881130938,13767670,17.5),(131713,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131713,37.72,0.46,350,61430,70,NULL,NULL,'2MASXi J1540072+515428',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.030333,51.90764,0.049,NULL,59670698479,932354663,14568041,17.4),(131714,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131714,38.29,0.46,454,61431,70,NULL,NULL,'SDSS J154007.60+452906.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000158,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.0317083,45.48517,0.017,NULL,59688141130,932627205,14572300,18.4),(131715,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131715,37.08,0.46,260,61432,70,NULL,NULL,'SDSS J154008.23+091422.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.034333333,9.23958,0.077,NULL,56604305436,884442272,13819410,17.8),(131716,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131716,36.4,0.46,191,61433,70,NULL,NULL,'MCG +03-40-021',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000067,NULL,'15.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.037167,16.05361,0.101,NULL,59440579438,928759053,14511860,15.3),(131717,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131717,38.37,0.27,472,61434,70,NULL,NULL,'SDSS J154009.61+072026.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.040083333,7.34078,0.097,NULL,56594519113,884289361,13817021,18.8),(131718,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131718,37.02,0.46,254,61435,70,NULL,NULL,'2MASX J15401006+2032120',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.0419583,20.53658,0.137,NULL,59455010050,928984532,14515383,17.4),(131719,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131719,37.76,0.46,356,61436,70,NULL,NULL,'2MASX J15401121+2501167',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.0465417,25.02131,0.153,NULL,59869603991,935462562,14616602,17.8),(131720,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131720,37.32,0.46,291,61437,70,NULL,NULL,'2MASXi J1540118+361127',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.049125,36.19083,0.073,NULL,59879410945,935615796,14618996,17.8),(131721,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131721,36.46,0.33,196,61438,70,NULL,NULL,'2MASX J15401274+0722434',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000192,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,235.053125,7.37869,0.097,NULL,56594524691,884289448,13817022,16.2),(131722,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131722,36.88,0.46,238,61439,70,NULL,NULL,'2MASX J15401420+3431588',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000143,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,235.059083,34.53294,0.061,NULL,59893961408,935843147,14622549,15.9),(131723,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131723,37.15,0.46,269,61440,70,NULL,NULL,'2MASX J15401435+1841030',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.059916667,18.68414,0.065,NULL,59448942115,928889720,14513901,17.6),(131724,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131724,37.29,0.27,287,61441,70,NULL,NULL,'2MASX J15401437+4835299',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000172,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.059958333,48.59153,0.049,NULL,59721905660,933154775,14580543,16.4),(131725,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131725,37.11,0.46,264,61442,70,NULL,NULL,'2MASX J15401593+0812224',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',NULL,NULL,'16.77',0.32,NULL,NULL,NULL,NULL,NULL,1,235.066375,8.20628,0.073,NULL,56596218904,884315920,13817436,16.77),(131726,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131726,37.55,0.21,324,61443,70,NULL,NULL,'2MASX J15401623+0301573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.0677083,3.03264,0.177,NULL,56402980551,881296571,13770258,17.7),(131727,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131727,38.19,0.15,434,61444,70,NULL,NULL,'2MASX J15401650+3042169',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.068833333,30.70472,0.073,NULL,59925862766,936341605,14630337,17.9),(131728,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131728,37.55,0.21,324,61445,70,NULL,NULL,'2MASX J15401676+0311243',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.0697917,3.19019,0.169,NULL,56394657149,881166517,13768226,17.3),(131729,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131729,37.38,0.33,299,61446,70,NULL,NULL,'2MASX J15401703+0243343',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.0710417,2.72631,0.173,NULL,56403102502,881298476,13770288,16.7),(131730,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131730,36.44,0.09,194,61447,70,NULL,NULL,'2MASX J15401716+2124291',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000067,NULL,'16.71',0.2,NULL,NULL,NULL,NULL,NULL,1,235.0715,21.40797,0.181,NULL,59455203199,928987549,14515430,16.71),(131731,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131731,35.85,0.25,148,61448,74.4,NULL,NULL,'GIN 440',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.00006,NULL,'15.18',0.44,'S',NULL,NULL,NULL,NULL,1,235.071875,21.91503,0.189,NULL,59452780334,928949692,14514838,15.18),(131732,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131732,36.04,0.27,161,61448,70,NULL,NULL,'GIN 440',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131733,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131733,37.97,0.14,393,61449,70,NULL,NULL,'2MASX J15401797+1753042',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000179,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.074958333,17.88453,0.069,NULL,59431183521,928612242,14509566,16.8),(131734,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131734,37.77,0.46,358,61450,70,NULL,NULL,'2MASXi J1540183+491847',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.07625,49.31289,0.053,NULL,59721372540,933146445,14580413,17.8),(131735,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131735,37.55,0.21,324,61451,70,NULL,NULL,'2MASX J15401830+0303423',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.0762917,3.06172,0.177,NULL,56394652956,881166452,13768225,17),(131736,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131736,37.38,0.46,299,61452,70,NULL,NULL,'2MASX J15401831+0423173',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.076333,4.38803,0.157,NULL,56395875899,881185560,13768524,17.4),(131737,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131737,36.56,0.46,205,61453,70,NULL,NULL,'SDSS J154018.95+161822.4',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.0789583,16.30625,0.105,NULL,59440098075,928751532,14511742,17.1),(131738,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131738,37.97,0.14,393,61454,70,NULL,NULL,'SDSS J154019.03+175123.3',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.1g',0.36,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.079291667,17.85647,0.069,NULL,59431151780,928611746,14509558,16.1),(131739,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131739,37.6,0.46,331,61455,70,NULL,NULL,'2MASX J15401903+3134529',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000117,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.0795,31.58142,0.085,NULL,59925269015,936332328,14630192,17.4),(131740,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131740,36.08,0.77,165,61456,70,NULL,NULL,'2MASX J15402019-0658573',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,235.084125,-6.98253,0.449,NULL,45609841411,712653772,11135215,14.3),(131741,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131741,34.83,0.8,92.6,61457,75,NULL,'MAT, I','ESO 583- G 002',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.5',1,'SB(rs)bc;Sy1   HII',NULL,NULL,NULL,NULL,1,235.085417,-18.44261,0.445,NULL,46600880476,728138757,11377168,15.5),(131742,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131742,34.3,0.43,72.4,61457,75,NULL,'MAT, I, raw','ESO 583- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131743,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131743,34.31,0.32,72.7,61457,85,NULL,'I, raw','ESO 583- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131744,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131744,34.35,0.32,74.3,61457,85,NULL,'I, inv','ESO 583- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131745,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131745,34.51,0.43,79.9,61457,75,NULL,'MAT, I, inv','ESO 583- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131746,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131746,34.69,0.43,86.8,61457,75,NULL,'MAT, I, cor','ESO 583- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131747,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131747,34.88,0.25,94.7,61457,NULL,NULL,NULL,'ESO 583- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131748,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131748,34.92,0.2,96.4,61457,74.4,NULL,NULL,'ESO 583- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131749,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131749,35.03,0.4,101,61457,NULL,NULL,'mean','ESO 583- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131750,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131750,35.04,0.23,102,61457,NULL,NULL,'Malmquist cor.','ESO 583- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131751,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131751,35.21,0.47,110,61457,NULL,NULL,'H','ESO 583- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131752,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131752,37.35,0.46,296,61458,70,NULL,NULL,'2MASX J15402052+1411092',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.085583333,14.18592,0.089,NULL,59426716956,928542452,14508475,17.1),(131753,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131753,38.01,0.33,399,61459,70,NULL,NULL,'2MASX J15402073+2324191',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.086375,23.40522,0.157,NULL,59450651342,928916427,14514319,17.5),(131754,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131754,37.07,0.46,260,61460,70,NULL,NULL,'2MASX J15402088+1323292',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.0870417,13.39139,0.105,NULL,56526080719,883220011,13800312,17),(131755,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131755,37.57,0.46,327,61461,70,NULL,NULL,'2MASX J15402088+2314351',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.087125,23.24322,0.153,NULL,59453530633,928961416,14515022,17),(131756,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131756,36.5,0.7,200,61462,70,NULL,NULL,'2MASX J15402114-1508178',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,235.0880417,-15.13858,0.385,NULL,46593284358,728020068,11375313,15.85),(131757,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131757,37.97,0.14,393,61463,70,NULL,NULL,'2MASX J15402217+1754332',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.092375,17.90931,0.069,NULL,59431188051,928612313,14509567,17),(131758,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131758,36.05,0.65,162,61464,70,NULL,NULL,'2MASX J15402307-0511341',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.55',NULL,NULL,NULL,NULL,NULL,NULL,1,235.096375,-5.193,0.449,NULL,45407940201,709499065,11085922,16.55),(131759,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131759,36.19,0.46,173,61465,70,NULL,NULL,'2MASX J15402482-0154121',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.103333,-1.90347,0.353,NULL,45401966985,709405734,11084464,16.8),(131760,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131760,37.82,0.46,367,61466,70,NULL,NULL,'2MASX J15402487+0601170',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000188,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.103625,6.02147,0.109,NULL,56614731257,884605175,13821955,17.2),(131761,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131761,33.9,0.53,60.3,61467,NULL,NULL,NULL,'ESO 450- G 006',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'16.10',0.5,'Sb:',NULL,NULL,NULL,NULL,1,235.108333,-29.1065,0.457,NULL,47173829543,737091086,11517048,16.1),(131762,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131762,33.94,0.2,61.4,61467,74.4,NULL,NULL,'ESO 450- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131763,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131763,34.1,0.49,66.1,61467,NULL,NULL,'Malmquist cor.','ESO 450- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131764,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131764,36.44,0.09,194,61468,70,NULL,NULL,'2MASX J15402733+2133510',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000063,NULL,'17.70',0.1,NULL,NULL,NULL,NULL,NULL,1,235.114,21.56422,0.173,NULL,59454663807,928979121,14515298,17.7),(131765,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131765,37.05,0.46,257,61469,70,NULL,NULL,'2MASX J15402750+4745017',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.11475,47.75053,0.037,NULL,59720257768,933129027,14580141,16.7),(131766,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131766,36.43,0.46,193,61470,70,NULL,NULL,'2MASX J15402752+1527582',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.114833,15.46622,0.073,NULL,59440436060,928756813,14511825,16.9),(131767,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131767,37.71,0.46,349,61471,70,NULL,NULL,'2MASX J15402809+2651418',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000189,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.117125,26.8615,0.121,NULL,59919517501,936242460,14628788,16.9),(131768,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131768,37.03,0.46,255,61472,70,NULL,NULL,'2MASX J15402841+5627220',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000101,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.118333,56.45619,0.017,NULL,57592027514,899875429,14060553,16.5),(131769,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131769,38.37,0.27,472,61473,70,NULL,NULL,'2MASX J15402887+0713544',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.1202083,7.23172,0.097,NULL,56594353906,884286779,13816980,16.9),(131770,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131770,36.88,0.46,238,61474,70,NULL,NULL,'2MASX J15402943+3328220',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.1225417,33.47286,0.073,NULL,59891370092,935802657,14621916,17.4),(131771,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131771,35.54,0.46,128,61475,70,NULL,NULL,'2MASX J15402996+2821568',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000077,NULL,'15.9g',0.34,NULL,NULL,NULL,NULL,NULL,1,235.125,28.36572,0.093,NULL,59917181730,936205964,14628218,15.9),(131772,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131772,37.97,0.14,393,61476,70,NULL,NULL,'2MASX J15403057+1750241',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.127375,17.84008,0.069,NULL,59431146930,928611670,14509557,17.7),(131773,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131773,38.05,0.27,407,61477,70,NULL,NULL,'2MASX J15403083+0331340',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.128291667,3.52622,0.165,NULL,56395509901,881179842,13768435,16.9),(131774,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131774,36.46,0.33,196,61478,70,NULL,NULL,'CGCG 050-066',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000212,NULL,'16.1g',0.32,'AGN',NULL,NULL,NULL,NULL,1,235.132416667,7.45797,0.085,NULL,56594419877,884287810,13816997,16.1),(131775,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131775,37.97,0.14,393,61479,70,NULL,NULL,'2MASX J15403212+1751426',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.133917,17.86192,0.069,NULL,59431147385,928611677,14509557,18.2),(131776,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131776,37.38,0.33,299,61480,70,NULL,NULL,'2MASX J15403214+0246240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.1340417,2.77328,0.177,NULL,56403110939,881298608,13770290,17.4),(131777,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131777,38.19,0.15,434,61481,70,NULL,NULL,'2MASX J15403231+3044380',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'18.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,235.1347917,30.74386,0.073,NULL,59925733611,936339587,14630306,18.2),(131778,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131778,38.17,0.46,431,61482,70,NULL,NULL,'2MASX J15403498+5758590',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.146,57.98325,0.029,NULL,57637861722,900591589,14071743,17.5),(131779,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131779,37.79,0.46,361,61483,70,NULL,NULL,'2MASX J15403629+2303357',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.151125,23.05989,0.157,NULL,59453510319,928961098,14515017,17.3),(131780,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131780,35.39,0.2,120,61484,74.4,NULL,NULL,'CGCG 136-052',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00005,NULL,'15.34',0.3,'S?',NULL,NULL,NULL,NULL,1,235.155291667,20.56233,0.137,NULL,59455001810,928984403,14515381,15.34),(131781,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131781,37.37,0.46,298,61485,70,NULL,NULL,'2MASX J15403856-0000231',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.160666667,-0.0065,0.265,NULL,45399441684,709366276,11083848,18.3),(131782,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131782,36.44,0.09,194,61486,70,NULL,NULL,'2MASX J15403858+2156577',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00006,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.16075,21.94942,0.189,NULL,59453054565,928953977,14514905,17.3),(131783,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131783,36.44,0.09,194,61487,70,NULL,NULL,'2MASX J15403857+2118377',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.160833,21.31067,0.181,NULL,59455199876,928987498,14515429,17.5),(131784,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131784,36.65,0.46,213,61488,70,NULL,NULL,'CGCG 166-033',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00013,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,235.16975,32.00175,0.089,NULL,59925122815,936330043,14630156,15.6),(131785,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131785,38.12,0.46,420,61489,70,NULL,NULL,'SDSS J154041.03+284136.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.171,28.69361,0.069,NULL,59924576007,936321500,14630023,18.3),(131786,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131786,37.3,0.46,288,61490,70,NULL,NULL,'2MASX J15404205-0045501',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000071,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.175375,-0.76386,0.349,NULL,45403104768,709423512,11084742,17.8),(131787,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131787,34.48,0.33,78.6,61491,70,NULL,NULL,'CGCG 222-040',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000158,NULL,'15.2g',0.47,'S0',NULL,NULL,NULL,NULL,1,235.176667,43.75125,0.041,NULL,59691143873,932674123,14573033,15.2),(131788,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131788,38.82,0.33,579,61492,70,NULL,NULL,'SDSS J154043.40+535014.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.180833,53.83736,0.021,NULL,59668532191,932320815,14567512,18.1),(131789,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131789,37.37,0.33,298,61493,70,NULL,NULL,'2MASX J15404356+4435126',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000194,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,235.181667,44.58683,0.029,NULL,59690828140,932669189,14572956,16.3),(131790,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131790,36.95,0.46,246,61494,70,NULL,NULL,'SDSS J154044.23+242021.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.5g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.184333,24.33925,0.141,NULL,59396499096,928070298,14501098,17.5),(131791,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131791,38.2,0.46,437,61495,70,NULL,NULL,'2MASX J15404524+3023470',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.188375,30.39647,0.053,NULL,59927818489,936372163,14630815,17.5),(131792,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131792,37.65,0.46,338,61496,70,NULL,NULL,'2MASX J15404528-0129161',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.188625,-1.48778,0.353,NULL,45402361685,709411901,11084560,18.1),(131793,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131793,35.86,0.25,149,61497,74.4,NULL,NULL,'GIN 441',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000063,NULL,'15.46',0.33,'E',NULL,NULL,NULL,NULL,1,235.19425,21.77253,0.181,NULL,59452766255,928949472,14514835,15.46),(131794,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131794,36.04,0.27,161,61497,70,NULL,NULL,'GIN 441',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131795,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131795,36.44,0.09,194,61497,70,NULL,NULL,'GIN 441',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131796,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131796,37.86,0.46,373,61498,70,NULL,NULL,'2MASXi J1540473+230622',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.197375,23.10611,0.157,NULL,59453481046,928960641,14515010,17.9),(131797,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131797,38.1,0.46,418,61499,70,NULL,NULL,'2MASX J15404754-0111001',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.198083,-1.18336,0.373,NULL,45403234175,709425533,11084773,18.2),(131798,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131798,37.43,0.23,306,61500,70,NULL,NULL,'2MASX J15404757+5556590',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000086,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.1982917,55.94967,0.009,NULL,57585645849,899775716,14058995,16.6),(131799,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131799,36.44,0.09,194,61501,70,NULL,NULL,'2MASX J15404887+2124567',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.87',0.3,NULL,NULL,NULL,NULL,NULL,1,235.203875,21.41589,0.173,NULL,59455235524,928988055,14515438,16.87),(131800,'BL Lac Luminosity','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131800,42.79,NULL,2250,61502,NULL,NULL,NULL,'[HB89] 1538+149',0.605,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'18.5g',NULL,'Opt.var.;FSRQ  BLLAC',NULL,NULL,NULL,'HP QSO',1,235.2062083,14.79608,0.109,NULL,59426817184,928544018,14508500,18.5),(131801,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131801,37.25,0.46,282,61503,70,NULL,NULL,'2MASX J15404953+0709197',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.206333333,7.15553,0.097,NULL,56594774141,884293345,13817083,17.6),(131802,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131802,38.05,0.27,407,61504,70,NULL,NULL,'2MASX J15404968+0335090',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000089,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.207041667,3.58581,0.161,NULL,56395476563,881179321,13768426,17.3),(131803,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131803,37.43,0.23,306,61505,70,NULL,NULL,'2MASX J15404970+5550080',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000097,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,235.207125,55.83553,0.009,NULL,57585695245,899776488,14059007,16.3),(131804,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131804,36.44,0.27,194,61506,70,NULL,NULL,'2MASX J15405020+0555250',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000184,NULL,'15.9g',0.34,'E0',NULL,NULL,NULL,NULL,1,235.2092083,5.92342,0.109,NULL,56614768080,884605751,13821964,15.9),(131805,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131805,36.29,0.46,181,61507,70,NULL,NULL,'2MASX J15405067+5501110',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000158,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,235.211,55.01961,0.041,NULL,57587584367,899806005,14059468,16.3),(131806,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131806,37.34,0.46,294,61508,70,NULL,NULL,'2MASX J15405089+5645590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.2120417,56.76653,0.005,NULL,57589952107,899843001,14060046,18),(131807,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131807,38.37,0.27,472,61509,70,NULL,NULL,'2MASX J15405140+0713277',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.214083,7.22436,0.097,NULL,56594763191,884293174,13817080,18.1),(131808,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131808,37.07,0.73,260,61510,70,NULL,NULL,'2MASX J15405222-0700385',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,235.2175417,-7.01075,0.517,NULL,45609849345,712653896,11135217,14.5),(131809,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131809,37.43,0.23,306,61511,70,NULL,NULL,'2MASX J15405292+5555360',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000098,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.2207083,55.92669,0.009,NULL,57585644415,899775693,14058995,16.8),(131810,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131810,38.6,0.46,524,61512,70,NULL,NULL,'2MASX J15405392+0837007',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.22475,8.61667,0.077,NULL,56596656067,884322751,13817542,17.9),(131811,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131811,35.47,0.46,124,61513,70,NULL,NULL,'CGCG 050-068',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000113,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,235.22575,5.14253,0.105,NULL,56393043978,881141312,13767833,15.5),(131812,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131812,37.93,0.46,385,61514,70,NULL,NULL,'2MASX J15405425+5301139',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000131,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.2260417,53.02039,0.049,NULL,59671671393,932369865,14568279,17.8),(131813,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131813,38.05,0.46,407,61515,70,NULL,NULL,'2MASX J15405545+0453040',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.231,4.88439,0.109,NULL,56392959756,881139996,13767812,18.5),(131814,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131814,36.74,0.46,223,61516,70,NULL,NULL,'2MASX J15405554+4448435',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000171,NULL,'16.1g',0.43,NULL,NULL,NULL,NULL,NULL,1,235.231333333,44.812,0.025,NULL,59690944595,932671009,14572984,16.1),(131815,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131815,36.44,0.27,194,61517,70,NULL,NULL,'2MASX J15405576+0556000',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.81',0.5,NULL,NULL,NULL,NULL,NULL,1,235.232333,5.93319,0.109,NULL,56614765323,884605708,13821964,16.81),(131816,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131816,36.92,0.46,242,61518,70,NULL,NULL,'2MASX J15405804+1200130',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.241625,12.00356,0.101,NULL,56593012401,884265818,13816653,17.2),(131817,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131817,37.66,0.46,340,61519,70,NULL,NULL,'2MASX J15405977+2613364',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.249,26.22694,0.165,NULL,59916044780,936188199,14627940,16.7),(131818,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131818,36.37,0.46,188,61520,70,NULL,NULL,'CGCG 194-016',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000117,NULL,'15.3g',0.56,'E0',NULL,NULL,NULL,NULL,1,235.2499583,32.66675,0.105,NULL,59890529173,935789518,14621711,15.3),(131819,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131819,36.45,0.46,195,61521,70,NULL,NULL,'2MASX J15410095+0417520',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000123,NULL,'15.5g',0.45,NULL,NULL,NULL,NULL,NULL,1,235.254125,4.29772,0.157,NULL,56394839492,881169367,13768271,15.5),(131820,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131820,37.19,0.33,274,61522,70,NULL,NULL,'2MASX J15410112+4734255',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000202,NULL,'16.0g',0.41,'E0',NULL,NULL,NULL,NULL,1,235.2547917,47.57378,0.033,NULL,59720352258,933130504,14580164,16),(131821,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131821,36.9,0.46,239,61523,70,NULL,NULL,'2MASX J15410256+0723347',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.260583,7.39308,0.085,NULL,56594439615,884288118,13817001,16.7),(131822,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131822,38.05,0.46,407,61524,70,NULL,NULL,'2MASX J15410290+2106327',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.2622917,21.10917,0.137,NULL,59455306160,928989158,14515455,18),(131823,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131823,37.73,0.46,352,61525,70,NULL,NULL,'2MASX J15410295+5251438',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.2625,52.86217,0.041,NULL,59671784373,932371630,14568306,17.3),(131824,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131824,38.38,0.46,473,61526,70,NULL,NULL,'2MASX J15410336+0434491',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.264125,4.58031,0.157,NULL,56392943853,881139747,13767808,17.5),(131825,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131825,37.52,0.46,319,61527,70,NULL,NULL,'2MASX J15410416+3406276',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.267291667,34.10775,0.057,NULL,59891134348,935798974,14621858,17.1),(131826,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131826,37,0.46,251,61528,70,NULL,NULL,'2MASXi J1541042+460649',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.267458333,46.11367,0.021,NULL,59687738949,932620921,14572201,17.2),(131827,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131827,36.97,0.46,248,61529,70,NULL,NULL,'2MASX J15410438-0116135',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.268375,-1.2705,0.377,NULL,45403238248,709425597,11084774,16.8),(131828,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131828,37.76,0.33,357,61530,70,NULL,NULL,'2MASX J15410449+3011206',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.268708333,30.18906,0.069,NULL,59927788469,936371694,14630807,17.4),(131829,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131829,34.94,0.51,97.1,61531,70,NULL,NULL,'2MASX J15410476-0509255',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,235.269917,-5.15711,0.481,NULL,45588533793,712320840,11130013,14.5),(131830,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131830,36.44,0.09,194,61532,70,NULL,NULL,'2MASX J15410775+2207337',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00025,NULL,'17.03',0.3,NULL,NULL,NULL,NULL,NULL,1,235.2824583,22.12611,0.181,NULL,59453201780,928956277,14514941,17.03),(131831,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131831,37.81,0.33,365,61533,70,NULL,NULL,'2MASX J15410866+2224067',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.286083,22.40189,0.165,NULL,59453165120,928955705,14514932,16.9),(131832,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131832,35.04,0.54,102,61534,70,NULL,NULL,'2MASX J15410898-0505075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.42',NULL,NULL,NULL,NULL,NULL,NULL,1,235.287333,-5.08558,0.481,NULL,45588528540,712320758,11130011,16.42),(131833,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131833,37.81,0.33,365,61535,70,NULL,NULL,'2MASX J15410938+2220168',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.289041667,22.33814,0.165,NULL,59453177281,928955895,14514935,18.4),(131834,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131834,35.28,0.58,114,61536,70,NULL,NULL,'UGC 09968',NULL,'2014MNRAS.445.2677S',2014,1,1.04,NULL,'G',0.000123,NULL,'14.9g',0.75,'SAB(rs)b',NULL,NULL,NULL,NULL,1,235.291083333,-1.70619,0.353,NULL,45402042419,709406912,11084483,14.9),(131835,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131835,36.54,0.2,203,61536,74.4,NULL,NULL,'UGC 09968',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131836,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131836,37.54,0.46,322,61537,70,NULL,NULL,'2MASX J15410994+0637180',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,235.2912917,6.62164,0.065,NULL,56593979653,884280932,13816889,16.5),(131837,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131837,33.7,0.8,55.1,61538,75,NULL,'CF, r','IC 1133',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00003,NULL,'14.80',0.4,'Scd:',NULL,NULL,NULL,NULL,1,235.2999583,15.57342,0.073,NULL,59439745761,928746027,14511656,14.8),(131838,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131838,32.93,0.38,38.6,61538,75,NULL,'CF, r, inv','IC 1133',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131839,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131839,32.95,0.38,39,61538,75,NULL,'CF, r, raw','IC 1133',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131840,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131840,33.29,0.38,45.5,61538,75,NULL,'CF, r, cor','IC 1133',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131841,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131841,33.56,0.2,51.5,61538,74.4,NULL,NULL,'IC 1133',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131842,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131842,36.61,0.46,210,61539,70,NULL,NULL,'2MASX J15411369+0019441',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000099,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.3070417,0.32883,0.269,NULL,56388949560,881077336,13766833,16.6),(131843,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131843,38.05,0.27,407,61540,70,NULL,NULL,'2MASX J15411560+0336321',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000084,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,235.314875,3.60894,0.161,NULL,56395469167,881179205,13768425,18.4),(131844,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131844,38.01,0.46,399,61541,70,NULL,NULL,'2MASX J15411653+0822060',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.318917,8.36836,0.081,NULL,56597808080,884340751,13817824,17.3),(131845,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131845,37.76,0.33,357,61542,70,NULL,NULL,'2MASX J15411668+3010396',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000179,NULL,'16.3g',0.43,NULL,NULL,NULL,NULL,NULL,1,235.3194583,30.17775,0.069,NULL,59927897262,936373394,14630834,16.3),(131846,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131846,38.23,0.33,442,61543,70,NULL,NULL,'2MASX J15411805+0104591',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.325375,1.08294,0.245,NULL,56392174067,881127719,13767620,18.4),(131847,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131847,37.5,0.33,316,61544,70,NULL,NULL,'SDSS J154118.14+284957.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.325625,28.83261,0.069,NULL,59924787597,936324806,14630075,18),(131848,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131848,37.2,0.46,276,61545,70,NULL,NULL,'2MASX J15411866+0650011',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,235.327625,6.83369,0.057,NULL,56593840124,884278751,13816855,16.4),(131849,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131849,37.1,0.46,264,61546,70,NULL,NULL,'2MASX J15411875+2753012',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.328,27.88364,0.085,NULL,59917013718,936203339,14628177,17.6),(131850,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131850,38.23,0.33,442,61547,70,NULL,NULL,'2MASX J15411891+0106131',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.328875,1.10367,0.245,NULL,56392057124,881125892,13767592,17.5),(131851,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131851,38.38,0.46,475,61548,70,NULL,NULL,'SDSS J154119.55+035309.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.3315,3.88603,0.153,NULL,56394964059,881171313,13768301,18.2),(131852,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131852,38.82,0.33,579,61549,70,NULL,NULL,'2MASX J15411952+5347280',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.331583,53.79094,0.033,NULL,59668541324,932320958,14567514,18),(131853,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131853,38.12,0.46,421,61550,70,NULL,NULL,'SDSS J154120.58+001842.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000089,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,235.3357917,0.31181,0.269,NULL,56388956741,881077449,13766835,18.6),(131854,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131854,37.5,0.33,316,61551,70,NULL,NULL,'2MASX J15412074+2850532',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.336291667,28.84822,0.069,NULL,59924787299,936324801,14630075,17.3),(131855,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131855,38.53,0.33,509,61552,70,NULL,NULL,'2MASX J15412093+0450301',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.337125,4.84164,0.161,NULL,56615016201,884609628,13822025,18.4),(131856,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131856,37.58,0.33,329,61553,70,NULL,NULL,'2MASX J15412167+0722531',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.34025,7.38144,0.085,NULL,56594589466,884290460,13817038,17.4),(131857,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131857,33.61,1.01,52.8,61554,NULL,NULL,NULL,'IC 4570',NULL,'2009ApJS..182..474S',2009,1,0.81,NULL,'G',0.000033,NULL,'14.8g',0.77,'SABcd:','Group member',NULL,NULL,NULL,1,235.344125,28.22975,0.093,NULL,59917151002,936205484,14628210,14.8),(131858,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131858,34.04,0.83,64.1,61554,NULL,NULL,'Malmquist cor.','IC 4570',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131859,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131859,37.51,0.27,318,61555,70,NULL,NULL,'2MASX J15412271+0030521',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.3445417,0.51456,0.277,NULL,56388943327,881077239,13766831,17.1),(131860,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131860,37.69,0.46,346,61556,70,NULL,NULL,'2MASX J15412379+0541401',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.34925,5.69456,0.117,NULL,56614804104,884606314,13821973,17.8),(131861,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131861,37.13,0.46,266,61557,70,NULL,NULL,'2MASX J15412501+3735389',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.354417,37.59408,0.049,NULL,59881760834,935652513,14619570,17.3),(131862,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131862,38.53,0.33,509,61558,70,NULL,NULL,'2MASX J15412648+0443551',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000023,NULL,'16.9g',0.28,'S0;BrClG',NULL,NULL,NULL,NULL,1,235.360458333,4.732,0.161,NULL,56614988503,884609195,13822018,16.9),(131863,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131863,36.66,0.46,215,61559,70,NULL,NULL,'2MASX J15412663+0309281',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.360875,3.15783,0.165,NULL,56394733602,881167712,13768245,17.5),(131864,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131864,37.58,0.33,329,61560,70,NULL,NULL,'SDSS J154126.79+072129.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.361667,7.35808,0.085,NULL,56594593751,884290527,13817039,17.8),(131865,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131865,36.39,0.46,190,61561,70,NULL,NULL,'2MASX J15412704+2249398',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.362625,22.82761,0.161,NULL,59452641543,928947524,14514805,16.7),(131866,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131866,37.84,0.46,370,61562,70,NULL,NULL,'2MASX J15412733+3349437',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.3639583,33.82886,0.057,NULL,59891274196,935801159,14621893,17.1),(131867,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131867,36.59,0.46,208,61563,70,NULL,NULL,'SDSS J154127.85+462906.4',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000154,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,235.366083,46.48514,0.021,NULL,59688049393,932625771,14572277,18.4),(131868,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131868,38.99,0.46,628,61564,70,NULL,NULL,'SDSS J154127.93+030728.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000082,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.366375,3.12447,0.169,NULL,56394560579,881165009,13768203,18.8),(131869,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131869,37.79,0.46,362,61565,70,NULL,NULL,'SDSS J154128.76+091230.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.369833333,9.20861,0.069,NULL,56604681788,884448152,13819502,17.9),(131870,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131870,37.11,0.46,264,61566,70,NULL,NULL,'2MASX J15412930+4439258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00013,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.371916667,44.65722,0.029,NULL,59690973660,932671463,14572991,17.6),(131871,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131871,37.31,0.46,290,61567,70,NULL,NULL,'2MASX J15412927+1630206',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.372,16.50564,0.089,NULL,59431947733,928624183,14509752,16.6),(131872,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131872,38.88,0.46,597,61568,70,NULL,NULL,'2MASX J15412973+5801051',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.37375,58.01808,0.029,NULL,57637814001,900590843,14071731,18.2),(131873,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131873,33.34,0.47,46.5,61569,NULL,NULL,'H','NGC 5980',NULL,'2007A&A...465...71T',2007,1,1.9,'HOLM 720B is a star.','G',0.000017,NULL,'12.3B',0.7,'S','Possible field galaxy',NULL,NULL,NULL,1,235.376667,15.78767,0.061,NULL,59439670403,928744850,14511638,12.3),(131874,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131874,33.35,0.46,46.7,61569,NULL,NULL,'J','NGC 5980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131875,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131875,33.37,0.45,47.3,61569,NULL,NULL,'K','NGC 5980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131876,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131876,33.5,0.43,50.2,61569,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5980',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131877,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131877,33.69,0.4,54.7,61569,NULL,NULL,'mean','NGC 5980',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131878,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131878,38.86,0.46,591,61570,70,NULL,NULL,'2MASX J15413056+0527011',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.377375,5.45033,0.113,NULL,56615695351,884620239,13822191,18.4),(131879,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131879,37.35,0.46,295,61571,70,NULL,NULL,'2MASX J15413246+4253148',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.385125,42.8875,0.065,NULL,59679680749,932495011,14570234,17),(131880,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131880,37.33,0.46,293,61572,70,NULL,NULL,'2MASX J15413262+2744113',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.3860417,27.73644,0.089,NULL,59917474330,936210536,14628289,17.3),(131881,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131881,38,0.46,399,61573,70,NULL,NULL,'2MASX J15413368+2826473',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000204,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.390458333,28.44647,0.081,NULL,59917168150,936205752,14628214,16.7),(131882,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131882,36.55,0.46,204,61574,70,NULL,NULL,'2MASX J15413383+2146585',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00025,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.390917,21.78294,0.189,NULL,59452303151,928942236,14514722,17.2),(131883,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131883,39.23,0.46,701,61575,70,NULL,NULL,'2MASX J15413424+0517391',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.392625,5.29414,0.113,NULL,56615149295,884611707,13822057,17.8),(131884,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131884,36.65,0.46,214,61576,70,NULL,NULL,'2MASX J15413466+3407488',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000178,NULL,'15.8g',0.36,'Sa',NULL,NULL,NULL,NULL,1,235.394375,34.13019,0.057,NULL,59891267771,935801058,14621891,15.8),(131885,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131885,37.29,0.46,287,61577,70,NULL,NULL,'2MASX J15413663+1349571',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.4024583,13.83253,0.097,NULL,56524908124,883201689,13800026,17.1),(131886,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131886,35.84,0.2,147,61578,74.4,NULL,NULL,'CGCG 136-055',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000073,NULL,'15.8g',0.24,'Sb',NULL,NULL,NULL,NULL,1,235.4072917,25.1115,0.153,NULL,59870467649,935476057,14616813,15.8),(131887,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131887,38.66,0.46,540,61579,70,NULL,NULL,'2MASX J15413826-0006029',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.409458333,-0.10094,0.265,NULL,45399601626,709368775,11083887,18.3),(131888,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131888,37.43,0.23,306,61580,70,NULL,NULL,'2MASX J15413925+5556251',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000087,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.413667,55.94042,0.009,NULL,57585523071,899773797,14058965,17.5),(131889,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131889,37.51,0.27,318,61581,70,NULL,NULL,'2MASX J15413945+0033261',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000072,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.414375,0.55719,0.277,NULL,56388932434,881077069,13766829,17.8),(131890,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131890,36.2,0.46,173,61582,70,NULL,NULL,'2MASX J15413977+4547447',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000192,NULL,'15.6g',0.44,'E0',NULL,NULL,NULL,NULL,1,235.4154583,45.79567,0.017,NULL,59687785701,932621651,14572213,15.6),(131891,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131891,37.51,0.27,318,61583,70,NULL,NULL,'2MASX J15414018+0029261',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000104,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.4175417,0.49047,0.277,NULL,56388918371,881076849,13766825,17.2),(131892,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131892,37.69,0.23,345,61584,70,NULL,NULL,'SDSS J154140.67+251708.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00018,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.419458333,25.28581,0.153,NULL,59870457135,935475892,14616810,18.1),(131893,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131893,37.41,0.33,304,61585,70,NULL,NULL,'2MASX J15414165+0230431',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000073,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.423583,2.51192,0.233,NULL,56389505452,881086022,13766969,18.3),(131894,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131894,37.47,0.46,312,61586,70,NULL,NULL,'2MASX J15414165+0301031',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000109,NULL,'16.3g',0.34,'AGN',NULL,NULL,NULL,NULL,1,235.423667,3.01742,0.169,NULL,56402931039,881295797,13770246,16.3),(131895,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131895,37.41,0.46,304,61587,70,NULL,NULL,'2MASX J15414294+4228445',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.4287917,42.47906,0.065,NULL,59679014698,932484604,14570071,17.1),(131896,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131896,37.19,0.33,274,61588,70,NULL,NULL,'2MASX J15414319+4736385',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.430083,47.61061,0.033,NULL,59720578882,933134045,14580219,16.9),(131897,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131897,36.85,0.2,234,61589,74.4,NULL,NULL,'CGCG 136-056',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000093,NULL,'15.6g',0.43,'Irr',NULL,NULL,NULL,NULL,1,235.4307083,23.20369,0.161,NULL,59397113265,928079894,14501248,15.6),(131898,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131898,37.59,0.46,329,61590,70,NULL,NULL,'2MASX J15414378+0829170',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.17,'AGN',NULL,NULL,NULL,NULL,1,235.4325,8.48817,0.073,NULL,56596966112,884327595,13817618,17.4),(131899,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131899,35.74,NULL,141,61591,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +08-29-002',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000082,NULL,'16.4g',0.17,'Scd',NULL,NULL,NULL,NULL,1,235.4355,45.58081,0.013,NULL,59687631030,932619234,14572175,16.4),(131900,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131900,35.76,NULL,142,61591,NULL,NULL,'Dipole + Quadrupole','MCG +08-29-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131901,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131901,35.78,NULL,143,61591,NULL,NULL,NULL,'MCG +08-29-002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131902,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131902,35.79,NULL,144,61591,NULL,NULL,'Dipole','MCG +08-29-002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131903,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131903,36.88,0.46,237,61592,70,NULL,NULL,'2MASX J15414479-0012039',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.436541667,-0.201,0.301,NULL,45399577802,709368403,11083881,17),(131904,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131904,37.73,0.46,352,61593,70,NULL,NULL,'2MASX J15414549+2213016',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.439625,22.21708,0.173,NULL,59453149953,928955468,14514929,17.5),(131905,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131905,37.37,0.46,297,61594,70,NULL,NULL,'2MASX J15414583+2957578',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.440875,29.96617,0.077,NULL,59927865842,936372903,14630826,17.4),(131906,'TRGB','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131906,30.26,0.1,11.3,61595,74.4,NULL,NULL,'UGC 09992',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000017,NULL,'15.2',1,'Im','Isolated galaxy',NULL,NULL,NULL,1,235.449375,67.25425,0.081,NULL,57956633457,905572397,14149568,15.2),(131907,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131907,29.32,NULL,7.31,61595,NULL,NULL,NULL,'UGC 09992',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131908,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131908,30.24,0.4,11.2,61595,75,NULL,'B','UGC 09992',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131909,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131909,36.29,0.46,181,61596,70,NULL,NULL,'2MASX J15414818+5511341',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000164,NULL,'16.2g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,235.450875,55.19292,0.029,NULL,57587469577,899804212,14059440,16.2),(131910,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131910,37.94,0.33,387,61597,70,NULL,NULL,'2MASX J15414834+0126416',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.451291667,1.44492,0.237,NULL,56392003740,881125058,13767579,17.8),(131911,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131911,37.69,0.23,345,61598,70,NULL,NULL,'2MASX J15415135+2519596',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'PRED','16.71',0.37,NULL,NULL,NULL,NULL,NULL,1,235.464125,25.33317,0.153,NULL,59870453811,935475840,14616810,16.71),(131912,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131912,37.48,0.46,313,61599,70,NULL,NULL,'2MASX J15415167+1551371',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.46525,15.8605,0.061,NULL,59439649666,928744526,14511633,17.3),(131913,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131913,37.53,0.46,321,61600,70,NULL,NULL,'2MASX J15415201+4728166',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.466667,47.47142,0.037,NULL,59720447145,933131986,14580187,17.4),(131914,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131914,37.64,0.46,337,61601,70,NULL,NULL,'2MASX J15415227+2005436',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.467875,20.0955,0.157,NULL,59447239336,928863114,14513486,17.1),(131915,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131915,36.2,0.46,174,61602,70,NULL,NULL,'2MASX J15415258+4831191',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.469167,48.52194,0.045,NULL,59719836712,933122448,14580038,16.7),(131916,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131916,37.69,0.23,345,61603,70,NULL,NULL,'2MASX J15415290+2520087',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000215,NULL,'16.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.470375,25.33569,0.153,NULL,59870453772,935475840,14616810,16.1),(131917,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131917,36.44,0.09,194,61604,70,NULL,NULL,'2MASX J15415299+2157036',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,235.471,21.95106,0.153,NULL,59453039699,928953745,14514902,16.6),(131918,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131918,35.49,0.47,126,61605,NULL,NULL,'H','IC 4572',NULL,'2007A&A...465...71T',2007,1,1.12,NULL,'G',0.00014,NULL,'14.4g',0.71,NULL,NULL,NULL,NULL,NULL,1,235.475791667,28.134,0.081,NULL,59917029098,936203579,14628180,14.4),(131919,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131919,35.69,0.46,137,61605,NULL,NULL,'J','IC 4572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131920,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131920,35.76,0.45,142,61605,NULL,NULL,'K','IC 4572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131921,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131921,35.81,0.4,145,61605,NULL,NULL,'mean','IC 4572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131922,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131922,37.41,0.33,304,61606,70,NULL,NULL,'2MASX J15415479+0227076',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000097,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.4782917,2.45203,0.233,NULL,56389481350,881085646,13766963,16.7),(131923,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131923,37.94,0.33,387,61607,70,NULL,NULL,'2MASX J15415514+0125176',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,235.479875,1.4215,0.237,NULL,56392002621,881125040,13767578,16.3),(131924,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131924,38.59,0.46,521,61608,70,NULL,NULL,'2MASX J15415556+0439196',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.481583333,4.65533,0.161,NULL,56618398558,884662477,13822851,17.5),(131925,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131925,37.01,0.46,253,61609,70,NULL,NULL,'2MASX J15415605+3134399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.4835417,31.57769,0.077,NULL,59925260530,936332195,14630190,17.2),(131926,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131926,32.16,NULL,27,61610,72,NULL,NULL,'SDSS J154157.11+043444.9',NULL,'2014Ap.....57..457K',2014,1,0.28,NULL,'G',0.000088,NULL,'17.8g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.488,4.57917,0.157,NULL,56618390249,884662347,13822849,17.8),(131927,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131927,36.03,0.46,161,61611,70,NULL,NULL,'2MASX J15415827+0746360',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000073,NULL,'15.4g',0.47,NULL,NULL,NULL,NULL,NULL,1,235.492833,7.77664,0.069,NULL,56597688699,884338885,13817795,15.4),(131928,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131928,37.15,0.46,269,61612,70,NULL,NULL,'2MASX J15415872+4716316',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.494708333,47.27533,0.045,NULL,59720455064,933132110,14580189,17.1),(131929,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131929,37.29,0.46,287,61613,70,NULL,NULL,'SDSS J154158.74+062407.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.49475,6.40214,0.077,NULL,56623360694,884740010,13824062,18.3),(131930,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131930,35.41,0.2,121,61614,74.4,NULL,NULL,'IC 4574',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00005,NULL,'15.9g',0.36,'S0',NULL,NULL,NULL,NULL,1,235.496833,28.24033,0.093,NULL,59917141167,936205330,14628208,15.9),(131931,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131931,32.34,0.8,29.4,61615,75,NULL,'A82, H','UGC 09977',NULL,'1997ApJS..109..333W',1997,1,4.26,NULL,'G',0.00001,NULL,'13.90',0.4,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,235.498083,0.71281,0.293,NULL,56389020215,881078440,13766850,13.9),(131932,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131932,31.47,0.4,19.7,61615,75,NULL,NULL,'UGC 09977',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131933,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131933,32.01,NULL,25.3,61615,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09977',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131934,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131934,32.02,NULL,25.3,61615,NULL,NULL,'Dipole','UGC 09977',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131935,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131935,32.02,NULL,25.3,61615,NULL,NULL,'Dipole + Quadrupole','UGC 09977',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131936,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131936,32.06,NULL,25.9,61615,NULL,NULL,NULL,'UGC 09977',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131937,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131937,32.1,0.49,26.3,61615,75,NULL,'IR','UGC 09977',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131938,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131938,32.13,0.4,26.7,61615,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 09977',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131939,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131939,32.15,0.2,26.9,61615,74.4,NULL,NULL,'UGC 09977',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131940,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131940,32.21,0.43,27.7,61615,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09977',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131941,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131941,32.22,0.43,27.8,61615,75,NULL,'3.6 micron, color corrected','UGC 09977',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131942,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131942,32.31,0.51,28.9,61615,NULL,NULL,NULL,'UGC 09977',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131943,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131943,32.3,NULL,28.9,61615,72,NULL,NULL,'UGC 09977',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131944,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131944,32.31,0.5,29,61615,NULL,NULL,'Malmquist cor.','UGC 09977',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131945,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131945,32.4,0.4,30.2,61615,75,NULL,'B','UGC 09977',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131946,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131946,32.48,0.36,31.3,61615,NULL,NULL,NULL,'UGC 09977',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131947,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131947,32.55,0.47,32.3,61615,75,NULL,'A82, H, raw','UGC 09977',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131948,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131948,32.55,0.47,32.3,61615,75,NULL,'A82, H, inv','UGC 09977',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131949,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131949,32.68,0.47,34.3,61615,75,NULL,'A82, H, cor','UGC 09977',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131950,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131950,38.08,0.46,412,61616,70,NULL,NULL,'2MASX J15420148+3552119',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000199,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.5062083,35.86997,0.053,NULL,59893141656,935830338,14622349,16.9),(131951,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131951,37.92,0.46,384,61617,70,NULL,NULL,'2MASX J15420396+3621145',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.516625,36.35397,0.061,NULL,59879222679,935612854,14618950,17.3),(131952,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131952,36.27,0.46,179,61618,70,NULL,NULL,'2MASX J15420402+2817477',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.5167083,28.29678,0.093,NULL,59917117315,936204958,14628202,16.9),(131953,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131953,36.82,0.46,231,61619,70,NULL,NULL,'2MASX J15420598+4755222',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.525167,47.92297,0.041,NULL,59720370087,933130782,14580168,17.1),(131954,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131954,37.29,0.27,287,61620,70,NULL,NULL,'2MASX J15420626+4835142',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,235.526167,48.58731,0.049,NULL,59719836044,933122438,14580038,16.1),(131955,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131955,37.27,0.46,284,61621,70,NULL,NULL,'2MASX J15420676+3714565',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.528125,37.24897,0.021,NULL,59881937813,935655278,14619613,17),(131956,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131956,37.94,0.46,388,61622,70,NULL,NULL,'2MASX J15420754+1312436',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.5315,13.21219,0.089,NULL,56526634847,883228669,13800447,17.6),(131957,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131957,39,0.46,632,61623,70,NULL,NULL,'2MASX J15420884+0640397',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.536875,6.67769,0.057,NULL,56623240329,884738130,13824033,18),(131958,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131958,36.37,0.46,188,61624,70,NULL,NULL,'2MASX J15420887+0413356',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.537083,4.22642,0.157,NULL,56616524517,884633195,13822393,16.8),(131959,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131959,36.79,0.46,228,61625,70,NULL,NULL,'2MASX J15420922+1200206',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.538375,12.00569,0.097,NULL,56592157037,884252453,13816444,17.3),(131960,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131960,37.36,0.33,296,61626,70,NULL,NULL,'2MASX J15420960+3348570',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.540083333,33.81592,0.041,NULL,59891299947,935801561,14621899,17.1),(131961,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131961,36.29,0.46,181,61627,70,NULL,NULL,'2MASX J15420984+3046150',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,235.541125,30.77081,0.093,NULL,59925851995,936341437,14630334,NULL),(131962,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131962,36.44,0.09,194,61628,70,NULL,NULL,'2MASX J15420998+2157565',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000143,NULL,'15.9',0.35,NULL,NULL,NULL,NULL,NULL,1,235.541625,21.96567,0.153,NULL,59452327343,928942614,14514728,15.9),(131963,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131963,38.74,0.46,559,61629,70,NULL,NULL,'2MASX J15421020+3926117',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.5425417,39.4365,0.033,NULL,60096245650,939003838,14671934,18.8),(131964,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131964,37.69,0.23,345,61630,70,NULL,NULL,'SDSS J154210.31+252624.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.543,25.44014,0.153,NULL,59870536956,935477139,14616830,18.5),(131965,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131965,36.76,0.46,225,61631,70,NULL,NULL,'2MASX J15421198+2613277',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.549875,26.22444,0.157,NULL,59870260706,935472823,14616762,17.6),(131966,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131966,37.36,0.33,296,61632,70,NULL,NULL,'2MASX J15421241+3349220',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.551625,33.82275,0.041,NULL,59891300010,935801562,14621899,18.1),(131967,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131967,36.83,0.46,232,61633,70,NULL,NULL,'SDSS J154212.77+560446.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000063,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.55325,56.07947,0.005,NULL,57584825119,899762892,14058795,17.8),(131968,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131968,36.13,0.46,168,61634,70,NULL,NULL,'CGCG 250-004',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000192,NULL,'15.2g',0.59,'E0',NULL,NULL,NULL,NULL,1,235.5747917,48.21567,0.053,NULL,59720064319,933126004,14580093,15.2),(131969,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131969,37.64,0.33,337,61635,70,NULL,NULL,'2MASX J15421917+1103088',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'PHOT','16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.579833,11.05236,0.105,NULL,56592217315,884253395,13816459,16.9),(131970,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131970,31.75,NULL,22.4,61636,72,NULL,NULL,'UGC 09979',NULL,'2014Ap.....57..457K',2014,1,1.4,NULL,'G',0.00001,NULL,'14.6B',0.7,'Irr(sa)        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,235.5817917,0.47378,0.277,NULL,56389252621,881082072,13766907,14.6),(131971,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131971,32.45,0.4,31,61636,75,NULL,'B','UGC 09979',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131972,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131972,35.94,0.2,154,61637,74.4,NULL,NULL,'IC 4575',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.00007,NULL,'15.3g',0.47,'Sb','Group member',NULL,NULL,NULL,1,235.581875,23.80764,0.153,NULL,59395909377,928061084,14500954,15.3),(131973,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131973,36.63,0.46,212,61638,70,NULL,NULL,'2MASX J15421978+3247370',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.5822917,32.7935,0.089,NULL,59888403229,935756300,14621192,16.8),(131974,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131974,38.5,0.46,502,61639,70,NULL,NULL,'SDSS J154220.75+525942.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000141,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.5865,52.99522,0.009,NULL,59671689916,932370154,14568283,18.7),(131975,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131975,37.64,0.33,337,61640,70,NULL,NULL,'2MASX J15422209+1103418',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'PHOT','16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.592,11.06144,0.105,NULL,56592213052,884253328,13816458,16.6),(131976,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131976,37.33,0.46,292,61641,70,NULL,NULL,'2MASX J15422207+4200185',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.592,42.00497,0.069,NULL,59680000927,932500014,14570312,17.4),(131977,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131977,36,0.46,159,61642,70,NULL,NULL,'2MASX J15422357-0116301',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,235.598333,-1.27497,0.317,NULL,45402794473,709418663,11084666,16.1),(131978,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131978,36.28,0.6,181,61642,70,NULL,NULL,'2MASX J15422357-0116301',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131979,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131979,36.9,0.46,240,61643,70,NULL,NULL,'2MASX J15422381+3238479',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.5992917,32.64678,0.081,NULL,59888413401,935756459,14621194,17.9),(131980,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131980,37.05,0.46,257,61644,70,NULL,NULL,'2MASX J15422414+1837465',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.6007083,18.62953,0.065,NULL,59448451815,928882059,14513782,16.4),(131981,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131981,34.6,NULL,83.2,61645,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09988',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000202,NULL,'16.4g',0.19,'Scd',NULL,NULL,NULL,NULL,1,235.600833,41.62347,0.077,NULL,59677122045,932455031,14569609,16.4),(131982,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131982,34.62,NULL,83.8,61645,NULL,NULL,'Dipole + Quadrupole','UGC 09988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131983,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131983,34.63,NULL,84.3,61645,NULL,NULL,'Dipole','UGC 09988',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131984,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131984,34.67,NULL,86.1,61645,NULL,NULL,NULL,'UGC 09988',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131985,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131985,34.73,0.49,88.3,61645,75,NULL,'IR','UGC 09988',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(131986,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131986,37.49,0.46,314,61646,70,NULL,NULL,'2MASX J15422451+2339205',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.602083,23.65561,0.153,NULL,59395817913,928059654,14500932,17.3),(131987,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131987,38.53,0.46,508,61647,70,NULL,NULL,'2MASX J15422529+3229169',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.6055,32.48819,0.077,NULL,59888428047,935756688,14621198,18.1),(131988,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131988,37.86,0.46,373,61648,70,NULL,NULL,'2MASX J15422540+1357236',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,235.6059583,13.95667,0.089,NULL,56524891933,883201436,13800022,16.4),(131989,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131989,37.8,0.46,363,61649,70,NULL,NULL,'2MASX J15422548+4117069',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000155,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.606083333,41.28519,0.065,NULL,59677325227,932458206,14569659,16.9),(131990,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131990,38.67,0.46,542,61650,70,NULL,NULL,'2MASX J15422607+2115155',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.608625,21.25425,0.149,NULL,59454459396,928975928,14515248,17.6),(131991,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131991,38.12,0.46,420,61651,70,NULL,NULL,'2MASX J15422665-0139101',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.6112083,-1.65289,0.349,NULL,45401749865,709402341,11084411,18.5),(131992,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131992,36.44,0.09,194,61652,70,NULL,NULL,'2MASX J15422665+2146205',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.87',0.37,NULL,NULL,NULL,NULL,NULL,1,235.61125,21.77247,0.157,NULL,59452355662,928943057,14514735,16.87),(131993,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131993,37.24,0.33,281,61653,70,NULL,NULL,'2MASX J15422832+5259501',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00021,NULL,'16.0g',0.48,'AGN',NULL,NULL,NULL,NULL,1,235.618167,52.99744,0.009,NULL,59671690061,932370157,14568283,16),(131994,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131994,37.96,0.46,391,61654,70,NULL,NULL,'SDSS J154228.43+281136.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.6185,28.19358,0.093,NULL,59917618652,936212791,14628324,18.7),(131995,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131995,37.46,0.46,310,61655,70,NULL,NULL,'2MASX J15422850+3915529',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.618833,39.26467,0.037,NULL,60096141250,939002207,14671909,17.4),(131996,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131996,38.26,0.46,449,61656,70,NULL,NULL,'2MASX J15422895+5313561',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.620625,53.23228,0.009,NULL,59668830205,932325471,14567585,18),(131997,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,131997,35.93,0.2,153,61657,74.4,NULL,NULL,'CGCG 078-050',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000535,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,235.6212917,12.29683,0.105,NULL,56524245235,883191331,13799864,15.7),(131998,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131998,37.54,0.46,322,61658,70,NULL,NULL,'SDSS J154232.29+054557.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.634583333,5.76603,0.113,NULL,56615589522,884618586,13822165,18.3),(131999,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',131999,37.16,0.46,270,61659,70,NULL,NULL,'2MASX J15423306+3829349',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000181,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,235.637917,38.49292,0.033,NULL,59878324983,935598827,14618731,16.2),(132000,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132000,36.13,0.46,169,61660,70,NULL,NULL,'2MASX J15423423+4611236',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000183,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.642458333,46.19006,0.021,NULL,59687930610,932623915,14572248,16.5),(132001,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132001,37.24,0.33,281,61661,70,NULL,NULL,'2MASX J15423438+5300199',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,235.643375,53.00556,0.009,NULL,59671676143,932369939,14568280,17.3),(132002,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132002,35.57,0.46,130,61662,70,NULL,NULL,'2MASX J15423494+1000369',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.18',0.38,NULL,NULL,NULL,NULL,NULL,1,235.6455417,10.01039,0.093,NULL,56604897899,884451529,13819555,16.18),(132003,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132003,34.74,0.27,88.6,61663,70,NULL,NULL,'IC 4576',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.000063,NULL,'14.4g',0.72,'S?','Pair member, S + S',NULL,NULL,NULL,1,235.647917,23.67006,0.153,NULL,59395899634,928060931,14500952,14.4),(132004,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132004,33.45,0.47,48.9,61664,70,NULL,NULL,'ESO 329- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'13.5R',0.3,'SBab? sp',NULL,NULL,NULL,NULL,1,235.6537917,-38.70089,0.657,NULL,47144837669,736638088,11509970,13.5),(132005,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132005,37.53,0.27,321,61665,70,NULL,NULL,'2MASX J15423950+0646439',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.66475,6.77897,0.057,NULL,56623970807,884749543,13824211,17.3),(132006,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132006,38.61,0.46,527,61666,70,NULL,NULL,'2MASX J15424052+2523037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.668666667,25.3845,0.153,NULL,59870496001,935476500,14616820,17.7),(132007,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132007,38.32,0.12,461,61667,70,NULL,NULL,'SDSS J154241.97+054210.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,235.674916667,5.70294,0.113,NULL,56615736309,884620879,13822201,19),(132008,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132008,37.68,0.46,343,61668,70,NULL,NULL,'2MASX J15424213+3031251',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.675625,30.52353,0.089,NULL,59925628279,936337941,14630280,17.3),(132009,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132009,37.95,0.46,389,61669,70,NULL,NULL,'2MASX J15424255+1456551',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.6772917,14.94867,0.073,NULL,59426167323,928533864,14508341,18),(132010,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132010,36.89,0.46,238,61670,70,NULL,NULL,'SDSS J154244.99+570234.2',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000082,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.6875,57.04283,0,NULL,57635186856,900549794,14071090,16.5),(132011,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132011,34.74,0.27,88.6,61671,70,NULL,NULL,'IC 4577',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000063,NULL,'14.9g',0.64,'S?','Pair member, S + S',NULL,NULL,NULL,1,235.689833333,23.79264,0.157,NULL,59395914046,928061156,14500955,14.9),(132012,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132012,36.33,0.21,184,61672,70,NULL,NULL,'NGC 5983',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.000107,NULL,'14.6g',0.82,'E',NULL,NULL,NULL,NULL,1,235.690125,8.24111,0.097,NULL,56597881115,884341892,13817842,14.6),(132013,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132013,34.77,0.46,89.8,61673,70,NULL,NULL,'CGCG 136-062',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00017,NULL,'15.1',0.4,NULL,NULL,NULL,NULL,NULL,1,235.691167,24.98608,0.153,NULL,59869950864,935467982,14616687,15.1),(132014,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132014,38.32,0.12,461,61674,70,NULL,NULL,'2MASX J15424636+0545470',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.693167,5.76314,0.113,NULL,56615608835,884618888,13822170,17.2),(132015,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132015,37.42,0.33,305,61675,70,NULL,NULL,'SDSS J154247.34+331209.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.6972917,33.20269,0.061,NULL,59890591860,935790497,14621726,18),(132016,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132016,38.17,0.46,430,61676,70,NULL,NULL,'2MASX J15424961+3214081',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.70675,32.23569,0.081,NULL,59920917697,936264339,14629130,17.5),(132017,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132017,37.71,0.46,348,61677,70,NULL,NULL,'2MASX J15425022+4025282',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.70925,40.42444,0.041,NULL,59961901000,936904703,14639135,17),(132018,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132018,38.02,0.33,401,61678,70,NULL,NULL,'2MASX J15425076+0001570',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.711625,0.03258,0.293,NULL,56388358618,881068103,13766689,17.9),(132019,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132019,34.74,0.27,88.6,61679,70,NULL,NULL,'IC 4579',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000067,NULL,'15.2g',0.52,NULL,'Group member',NULL,NULL,NULL,1,235.714625,23.77317,0.153,NULL,59395905719,928061026,14500953,15.2),(132020,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132020,38.02,0.33,401,61680,70,NULL,NULL,'SDSS J154251.79+000135.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.7157917,0.02661,0.293,NULL,56388358540,881068102,13766689,18),(132021,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132021,37.53,0.27,321,61681,70,NULL,NULL,'2MASX J15425306+0642129',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000197,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.721125,6.70364,0.057,NULL,56624014820,884750231,13824222,17),(132022,'IRAS','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132022,31.5,0.8,19.9,61682,75,NULL,'A82, H','NGC 5984',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000017,NULL,'13.08',0.8,'SB(rs)d:','Possible field galaxy',NULL,NULL,NULL,1,235.721541667,14.23147,0.073,NULL,56525545806,883211653,13800182,13.08),(132023,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132023,30.73,0.4,14,61682,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 5984',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132024,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132024,31.03,0.47,16.1,61682,75,NULL,'A82, H, inv','NGC 5984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132025,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132025,31.11,0.47,16.7,61682,75,NULL,'A82, H, raw','NGC 5984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132026,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132026,31.27,0.4,18,61682,NULL,NULL,'mean','NGC 5984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132027,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132027,31.37,0.43,18.8,61682,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5984',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132028,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132028,31.39,0.43,19,61682,75,NULL,'3.6 micron, color corrected','NGC 5984',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132029,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132029,31.45,0.2,19.5,61682,74.4,NULL,NULL,'NGC 5984',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132030,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132030,31.5,0.36,20,61682,NULL,NULL,NULL,'NGC 5984',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132031,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132031,31.53,0.47,20.2,61682,75,NULL,'A82, H, cor','NGC 5984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132032,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132032,31.54,0.4,20.3,61682,75,NULL,NULL,'NGC 5984',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132033,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132033,31.58,0.4,20.7,61682,75,NULL,'B','NGC 5984',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132034,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132034,31.7,0.46,21.9,61682,NULL,NULL,'J','NGC 5984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132035,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132035,31.75,0.51,22.4,61682,NULL,NULL,NULL,'NGC 5984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132036,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132036,31.77,0.5,22.6,61682,NULL,NULL,'Malmquist cor.','NGC 5984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132037,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132037,31.8,0.47,22.9,61682,NULL,NULL,'H','NGC 5984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132038,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132038,31.83,0.49,23.2,61682,75,NULL,'IR','NGC 5984',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132039,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132039,31.92,0.45,24.2,61682,NULL,NULL,'K','NGC 5984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132040,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132040,37.02,0.46,254,61683,70,NULL,NULL,'2MASX J15425397+4652305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.724916667,46.87531,0.005,NULL,59687115097,932611173,14572049,17.4),(132041,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132041,36.36,0.81,187,61684,70,NULL,NULL,'2MASX J15425541-0425027',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.90',NULL,NULL,NULL,NULL,NULL,NULL,1,235.730833,-4.41744,0.461,NULL,45590483695,712351307,11130489,16.9),(132042,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132042,36.33,0.21,184,61685,70,NULL,NULL,'2MASX J15425550+0813409',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,235.731375,8.228,0.097,NULL,56597791317,884340489,13817820,16.6),(132043,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132043,34.91,0.2,95.9,61686,74.4,NULL,NULL,'CGCG 166-040',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000027,NULL,'16.1g',0.29,'Sc',NULL,NULL,NULL,NULL,1,235.7317083,28.92461,0.073,NULL,59924637614,936322462,14630038,16.1),(132044,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132044,35.42,0.48,121,61687,NULL,NULL,'Malmquist cor.','ESO 583- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.04',0.3,'SB(rs)bc',NULL,NULL,NULL,NULL,1,235.7372083,-18.39739,0.477,NULL,46601113349,728142396,11377224,14.04),(132045,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132045,35.5,0.46,126,61687,NULL,NULL,NULL,'ESO 583- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132046,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132046,35.54,0.2,128,61687,74.4,NULL,NULL,'ESO 583- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132047,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132047,38.32,0.12,461,61688,70,NULL,NULL,'SDSS J154257.02+054805.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.737625,5.80164,0.105,NULL,56615612660,884618947,13822171,18.6),(132048,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132048,35.41,0.54,121,61689,70,NULL,NULL,'2MASX J15425760-0227277',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.91',NULL,NULL,NULL,NULL,NULL,NULL,1,235.740125,-2.45761,0.381,NULL,45401363341,709396302,11084317,16.91),(132049,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132049,37.96,0.33,391,61690,70,NULL,NULL,'2MASX J15425796+0032250',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000123,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,235.741416667,0.54019,0.293,NULL,56389266778,881082293,13766910,16.2),(132050,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132050,36.59,0.46,208,61691,70,NULL,NULL,'2MASX J15425946+3356081',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000124,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.7477917,33.93564,0.065,NULL,59890823815,935794122,14621783,17.5),(132051,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132051,35.45,NULL,123,61692,NULL,NULL,NULL,'FGC 1939',NULL,'2000BSAO...50....5K',2000,1,0.78,'6dF DR2 has z = 0.023778.','G',0.0001,NULL,'16.8',0.09,'Sd',NULL,NULL,NULL,NULL,1,235.7495417,-13.95669,0.505,NULL,45468155341,710439927,11100623,16.8),(132052,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132052,35.53,NULL,128,61692,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1939',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132053,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132053,35.55,NULL,129,61692,NULL,NULL,'Dipole + Quadrupole','FGC 1939',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132054,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132054,35.57,NULL,130,61692,NULL,NULL,'Dipole','FGC 1939',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132055,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132055,38.21,0.46,439,61693,70,NULL,NULL,'2MASX J15430080-0211207',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.753375,-2.18908,0.385,NULL,45401650623,709400790,11084387,17.5),(132056,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132056,37.96,0.33,391,61694,70,NULL,NULL,'SDSS J154301.27+003327.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.755333,0.55767,0.293,NULL,56389264337,881082255,13766910,18.5),(132057,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132057,37.42,0.33,305,61695,70,NULL,NULL,'2MASX J15430172+3321081',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.757041667,33.35239,0.057,NULL,59891395104,935803048,14621922,17.5),(132058,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132058,37.01,0.46,252,61696,70,NULL,NULL,'2MASX J15430181+3515401',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.757625,35.26103,0.057,NULL,59893790423,935840475,14622507,17),(132059,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132059,38.32,0.12,461,61697,70,NULL,NULL,'2MASX J15430184+0532510',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.757667,5.54744,0.133,NULL,56615523969,884617562,13822149,17.1),(132060,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132060,36.86,0.27,235,61698,70,NULL,NULL,'2MASX J15430217+3912293',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.7592083,39.20811,0.037,NULL,60096144589,939002259,14671910,17.3),(132061,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132061,39.08,0.46,655,61699,70,NULL,NULL,'SDSS J154304.29+400054.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.767917,40.01511,0.017,NULL,59961987867,936906060,14639157,18.1),(132062,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132062,37.63,0.46,336,61700,70,NULL,NULL,'2MASX J15430526+5213440',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000097,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,235.771916667,52.22903,0.049,NULL,59670584603,932352884,14568013,16.6),(132063,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132063,36.28,0.46,180,61701,70,NULL,NULL,'2MASX J15430561+4407001',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000188,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,235.77325,44.11675,0.041,NULL,59691031949,932672374,14573005,15.9),(132064,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132064,36.6,0.46,209,61702,70,NULL,NULL,'2MASX J15430567+3059151',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.773625,30.98756,0.101,NULL,59925706309,936339161,14630299,17.5),(132065,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132065,36.86,0.27,235,61703,70,NULL,NULL,'2MASX J15430699+3909053',NULL,'2015arXiv151105856S',2015,1,0.52,'Hernandez-Toledo et al. (2010AJ....139.2525H) give z = 0.176.','G',0.000334,NULL,'16.80',0.45,'E/S0;BrClG',NULL,NULL,NULL,NULL,1,235.779167,39.15131,0.037,NULL,59877990332,935593598,14618649,16.8),(132066,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132066,38.41,0.27,481,61704,70,NULL,NULL,'2MASX J15430800+4212001',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.78325,42.20006,0.073,NULL,59680122998,932501921,14570342,18),(132067,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132067,38,0.46,399,61705,70,NULL,NULL,'2MASX J15430897+4034583',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.7872917,40.58281,0.041,NULL,59961849824,936903903,14639123,18.1),(132068,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132068,38.41,0.27,481,61706,70,NULL,NULL,'SDSS J154309.00+420959.6',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,'PRED','17.4g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.7875,42.16656,0.073,NULL,59680125072,932501954,14570343,17.4),(132069,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132069,38.32,0.12,461,61707,70,NULL,NULL,'SDSS J154309.66+052828.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.79025,5.47464,0.129,NULL,56615566901,884618232,13822159,18.5),(132070,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132070,36.62,0.46,211,61708,70,NULL,NULL,'2MASX J15431034+2215062',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,235.793208333,22.25175,0.165,NULL,59452235305,928941176,14514705,16.6),(132071,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132071,34.12,0.53,66.8,61709,70,NULL,NULL,'MCG -02-40-003',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.0001,NULL,'15.39',0.7,'HII',NULL,NULL,NULL,NULL,1,235.794,-12.57428,0.629,NULL,45468821155,710450330,11100786,15.39),(132072,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132072,36.86,0.27,235,61710,70,NULL,NULL,'2MASX J15431130+3914193',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.7970417,39.23878,0.037,NULL,60096137416,939002147,14671908,16.5),(132073,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132073,37.63,0.46,335,61711,70,NULL,NULL,'2MASX J15431139+0422200',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.7975417,4.37236,0.161,NULL,56616462793,884632231,13822378,17.4),(132074,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132074,38.32,0.12,461,61712,70,NULL,NULL,'SDSS J154311.44+055505.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.797667,5.91817,0.105,NULL,56615575776,884618371,13822162,18.1),(132075,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132075,36.29,0.46,181,61713,70,NULL,NULL,'2MASX J15431172+2151312',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.77',0.4,NULL,NULL,NULL,NULL,NULL,1,235.7989583,21.85858,0.153,NULL,59452417799,928944028,14514750,16.77),(132076,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132076,37.9,0.46,380,61714,70,NULL,NULL,'2MASX J15431183+4515241',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.7992917,45.25664,0.029,NULL,59689460542,932647820,14572622,18.3),(132077,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132077,37.99,0.46,396,61715,70,NULL,NULL,'2MASX J15431192+4731091',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.7997917,47.51925,0.037,NULL,59720547943,933133561,14580211,17.2),(132078,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132078,38.69,0.46,547,61716,70,NULL,NULL,'SDSS J154312.21+051400.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.800917,5.23353,0.129,NULL,56615052570,884610196,13822034,18.2),(132079,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132079,37.38,0.09,299,61717,70,NULL,NULL,'2MASX J15431230+3624373',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'FoF','16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.801417,36.41036,0.053,NULL,59881092476,935642069,14619407,16.5),(132080,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132080,37.42,0.46,304,61718,70,NULL,NULL,'2MASX J15431367+2427228',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,235.807083,24.45642,0.153,NULL,59396261067,928066579,14501040,16.8),(132081,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132081,36.92,0.46,242,61719,70,NULL,NULL,'2MASX J15431550+3211252',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000199,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,235.814625,32.19036,0.081,NULL,59921104561,936267258,14629175,16),(132082,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132082,34.37,0.4,74.8,61720,NULL,NULL,'mean','UGC 09989',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00019,NULL,'15.40',0.2,'S?',NULL,NULL,NULL,NULL,1,235.816791667,9.72397,0.093,NULL,56605698346,884464036,13819750,15.4),(132083,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132083,34.7,0.47,87.2,61720,NULL,NULL,'H','UGC 09989',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132084,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132084,37.08,0.46,261,61721,70,NULL,NULL,'2MASX J15431597+1729188',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.6g',0.34,'AGN',NULL,NULL,NULL,NULL,1,235.816708333,17.48867,0.073,NULL,59433096942,928642139,14510033,16.6),(132085,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132085,37.53,0.27,321,61722,70,NULL,NULL,'2MASX J15431792+0651251',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,235.8247083,6.85694,0.049,NULL,56623993584,884749899,13824217,16.7),(132086,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132086,38.32,0.12,461,61723,70,NULL,NULL,'2MASX J15431840+0553010',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.8265417,5.8835,0.105,NULL,56615330562,884614540,13822102,18),(132087,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132087,37.73,0.46,351,61724,70,NULL,NULL,'2MASX J15431980+2320552',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,235.832625,23.34892,0.169,NULL,59399231729,928112995,14501765,18.4),(132088,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132088,37.89,0.46,378,61725,70,NULL,NULL,'2MASX J15431993+4056133',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,235.833166667,40.93708,0.053,NULL,59677152894,932455513,14569617,17.1),(132089,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132089,38.32,0.12,461,61726,70,NULL,NULL,'SDSS J154320.28+055211.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.834541667,5.86992,0.105,NULL,56615333738,884614589,13822102,18.5),(132090,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132090,37.89,0.33,378,61727,70,NULL,NULL,'2MASX J15432081-0011359',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00009,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.8367083,-0.19319,0.293,NULL,45399232911,709363014,11083797,16.9),(132091,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132091,37.41,0.46,303,61728,70,NULL,NULL,'2MASX J15432177+4313481',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.8405417,43.23017,0.061,NULL,59679412797,932490824,14570169,18.1),(132092,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132092,37.68,0.46,343,61729,70,NULL,NULL,'2MASX J15432188+0604420',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.841333,6.0785,0.101,NULL,56615318647,884614353,13822099,17.7),(132093,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132093,37.67,0.46,341,61730,70,NULL,NULL,'2MASX J15432203+2249042',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,235.841708333,22.81797,0.165,NULL,59397218636,928081541,14501274,18),(132094,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132094,37.89,0.33,378,61731,70,NULL,NULL,'SDSS J154322.09-001136.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.8420417,-0.19339,0.293,NULL,45399232591,709363009,11083797,18.4),(132095,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132095,37.22,0.46,278,61732,70,NULL,NULL,'2MASX J15432278+2806057',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.844916667,28.1015,0.077,NULL,59917721714,936214401,14628350,17.9),(132096,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132096,38.41,0.46,481,61733,70,NULL,NULL,'SDSS J154323.04+142703.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.846,14.45086,0.069,NULL,56525488466,883210757,13800168,18.4),(132097,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132097,38.02,0.33,402,61734,70,NULL,NULL,'2MASX J15432302+0647331',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.846083,6.79261,0.057,NULL,56624001672,884750026,13824219,16.9),(132098,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132098,36.69,0.46,217,61735,70,NULL,NULL,'2MASX J15432320+1530488',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.846667,15.51342,0.033,NULL,59439609210,928743893,14511623,16.3),(132099,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132099,38.02,0.33,402,61736,70,NULL,NULL,'2MASX J15432336+0649181',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.84725,6.82186,0.057,NULL,56623995404,884749928,13824217,17.6),(132100,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132100,37.92,0.46,384,61737,70,NULL,NULL,'2MASX J15432332+1053001',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.847333,10.88344,0.105,NULL,56603486693,884429479,13819210,17.3),(132101,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132101,35.16,0.46,108,61738,70,NULL,NULL,'2MASX J15432371+3859230',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.848625,38.98972,0.037,NULL,59878012455,935593944,14618655,16.3),(132102,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132102,35.6,0.7,132,61739,70,NULL,NULL,'2MASX J15432396-0240559',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,235.849875,-2.68214,0.445,NULL,45584967317,712265114,11129142,14.8),(132103,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132103,32.74,0.2,35.3,61740,74.4,NULL,NULL,'UGC 09991',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'14.66',0.5,'Scd:',NULL,NULL,NULL,NULL,1,235.849875,14.43581,0.069,NULL,56525488844,883210763,13800168,14.66),(132104,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132104,32.97,0.43,39.3,61740,75,NULL,'3.6 micron, color corrected','UGC 09991',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132105,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132105,33.21,0.43,43.8,61740,75,NULL,'3.6 micron, color + selection bias corrected','UGC 09991',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132106,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132106,35.75,0.2,141,61741,74.4,NULL,NULL,'CGCG 078-055',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000183,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,235.852,11.52103,0.113,NULL,56592533698,884258339,13816536,15.5),(132107,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132107,37.91,0.46,383,61742,70,NULL,NULL,'2MASX J15432500+2551116',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.854167,25.85331,0.161,NULL,59870207689,935471995,14616749,16.9),(132108,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132108,36.72,0.46,221,61743,70,NULL,NULL,'2MASX J15432525+1742188',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,235.855166667,17.70528,0.073,NULL,59432834283,928638035,14509969,16),(132109,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132109,37.21,0.46,277,61744,70,NULL,NULL,'2MASX J15432559+3649180',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000213,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,235.8564583,36.82164,0.037,NULL,59881238978,935644359,14619443,16.5),(132110,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132110,36.92,0.46,243,61745,70,NULL,NULL,'2MASX J15432746+2414016',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.864375,24.23375,0.149,NULL,59396203095,928065673,14501026,17.9),(132111,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132111,37.71,0.46,349,61746,70,NULL,NULL,'2MASX J15432885+1419358',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.870333,14.32661,0.069,NULL,56525530428,883211412,13800178,16.9),(132112,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132112,34.97,0.2,98.6,61747,74.4,NULL,NULL,'UGC 09990',NULL,'2013AJ....146...86T',2013,1,1.3,'Haynes, et al. (1999AJ....117.2039H) give v = 6436 km/sec.','G',0.000334,NULL,'15.04',0.3,'Scd:','in a triple',NULL,NULL,NULL,1,235.8745417,4.79444,0.161,NULL,56618472043,884663625,13822869,15.04),(132113,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132113,35.03,0.49,101,61747,NULL,NULL,NULL,'UGC 09990',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132114,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132114,35.28,0.44,114,61747,NULL,NULL,'Malmquist cor.','UGC 09990',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132115,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132115,38.57,0.46,518,61748,70,NULL,NULL,'SDSS J154330.69+305214.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,235.877875,30.87072,0.093,NULL,59925825950,936341030,14630328,18.7),(132116,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132116,38.32,0.12,461,61749,70,NULL,NULL,'2MASX J15433153+0543060',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,235.8814583,5.71844,0.137,NULL,56615436556,884616196,13822128,16.8),(132117,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132117,38.13,0.46,422,61750,70,NULL,NULL,'2MASX J15433302+5607187',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000083,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,235.8877917,56.12181,0.005,NULL,57584837286,899763082,14058798,17.2),(132118,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132118,37.38,0.09,299,61751,70,NULL,NULL,'2MASX J15433308+3545351',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.8879583,35.75986,0.029,NULL,59893651907,935838311,14622473,17.5),(132119,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132119,37.56,0.46,324,61752,70,NULL,NULL,'SDSS J154333.32+252452.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.888875,25.4145,0.149,NULL,59869853553,935466461,14616663,18.4),(132120,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132120,37.05,0.46,258,61753,70,NULL,NULL,'SDSS J154333.97+091427.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.891583333,9.24094,0.109,NULL,56605543163,884461611,13819712,17.7),(132121,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132121,36.33,0.21,184,61754,70,NULL,NULL,'2MASX J15433480+0822066',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,235.8949583,8.36864,0.073,NULL,56597749131,884339830,13817809,16.2),(132122,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132122,38.32,0.12,461,61755,70,NULL,NULL,'2MASX J15433589+0533160',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.8994583,5.55447,0.133,NULL,56615424584,884616009,13822125,18),(132123,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132123,35.84,0.46,147,61756,70,NULL,NULL,'CGCG 222-043',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000184,NULL,'15.3g',0.5,'E0','Group member',NULL,NULL,NULL,1,235.9015417,43.91328,0.041,NULL,59690538292,932664660,14572885,15.3),(132124,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132124,38.77,0.46,567,61757,70,NULL,NULL,'2MASX J15433646+1611129',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.901917,16.18681,0.049,NULL,59432094864,928626482,14509788,18.2),(132125,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132125,38.04,0.46,405,61758,70,NULL,NULL,'2MASX J15433676+2151295',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.903041667,21.85814,0.153,NULL,59452410945,928943921,14514748,17.2),(132126,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132126,38.32,0.12,461,61759,70,NULL,NULL,'2MASX J15433723+0546200',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.90525,5.77217,0.137,NULL,56615439022,884616234,13822128,17.9),(132127,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132127,35.85,0.46,148,61760,70,NULL,NULL,'2MASX J15433766+3929301',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000096,NULL,'16.4g',0.3,'HII',NULL,NULL,NULL,NULL,1,235.907083,39.49172,0.029,NULL,60096036513,939000570,14671883,16.4),(132128,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132128,38.63,0.46,532,61761,70,NULL,NULL,'2MASX J15433938+2655276',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.914,26.92422,0.117,NULL,59871911368,935498615,14617165,18.2),(132129,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132129,36.9,0.46,239,61762,70,NULL,NULL,'2MASX J15434246+1105167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.926917,11.08786,0.117,NULL,56603592451,884431132,13819236,17.3),(132130,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132130,38.24,0.21,444,61763,70,NULL,NULL,'2MASX J15434313-0211204',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,235.92975,-2.18903,0.385,NULL,45585396109,712271814,11129247,18.2),(132131,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132131,36.15,0.27,170,61764,70,NULL,NULL,'2MASX J15434321+0415139',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,235.9300417,4.25381,0.161,NULL,56616572895,884633951,13822405,15.8),(132132,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132132,38.41,0.27,481,61765,70,NULL,NULL,'2MASX J15434325+4230128',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,235.930167,42.5035,0.069,NULL,59679768684,932496385,14570256,17.7),(132133,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132133,37.26,0.33,283,61766,70,NULL,NULL,'2MASX J15434358+4826327',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.931375,48.4425,0.045,NULL,59719858966,933122796,14580043,16.9),(132134,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132134,36.11,0.46,167,61767,70,NULL,NULL,'2MASX J15434579-0145124',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000067,NULL,'16.0g',0.39,'E',NULL,NULL,NULL,NULL,1,235.9407917,-1.75333,0.357,NULL,45585326378,712270724,11129230,16),(132135,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132135,36.45,0.46,195,61768,70,NULL,NULL,'2MASX J15434637+5217407',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000065,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.943167,52.29478,0.049,NULL,59670537400,932352146,14568002,17.1),(132136,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132136,35.38,0.49,119,61769,75,NULL,'IR','UGC 09994',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000015,NULL,'16.1g',0.19,'Sbc',NULL,NULL,NULL,NULL,1,235.947,33.30589,0.057,NULL,59891384398,935802881,14621920,16.1),(132137,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132137,35.42,NULL,121,61769,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132138,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132138,35.43,NULL,122,61769,NULL,NULL,'Dipole + Quadrupole','UGC 09994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132139,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132139,35.45,NULL,123,61769,NULL,NULL,'Dipole','UGC 09994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132140,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132140,35.47,NULL,124,61769,NULL,NULL,NULL,'UGC 09994',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132141,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132141,35.87,0.2,149,61769,74.4,NULL,NULL,'UGC 09994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132142,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132142,36.15,0.27,170,61770,70,NULL,NULL,'SDSS J154348.88+044330.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.9537083,4.72517,0.177,NULL,56618509597,884664212,13822878,17),(132143,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132143,38.32,0.12,461,61771,70,NULL,NULL,'2MASX J15435074+0538319',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.961541667,5.64211,0.137,NULL,56615413882,884615841,13822122,17.9),(132144,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132144,38.17,0.46,431,61772,70,NULL,NULL,'SDSS J154351.72+095423.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,235.965541667,9.9065,0.097,NULL,56605710686,884464229,13819753,17.7),(132145,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132145,37.38,0.09,299,61773,70,NULL,NULL,'2MASX J15435179+3633371',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,235.965917,36.56044,0.041,NULL,59881272518,935644883,14619451,18.1),(132146,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132146,37.91,0.46,382,61774,70,NULL,NULL,'2MASX J15435253+0026489',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,235.968917,0.44694,0.277,NULL,56388310960,881067358,13766677,17.9),(132147,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132147,38.46,0.46,492,61775,70,NULL,NULL,'2MASX J15435314+3937241',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,235.971417,39.62333,0.029,NULL,60096052539,939000820,14671887,17.2),(132148,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132148,37.13,0.46,267,61776,70,NULL,NULL,'2MASX J15435382+1520190',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.974333,15.33864,0.033,NULL,59439585971,928743530,14511617,17.3),(132149,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132149,37.55,0.19,324,61777,70,NULL,NULL,'MCG +06-34-029',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000212,NULL,'15.8g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,235.978875,34.48206,0.061,NULL,59894338540,935849039,14622641,15.8),(132150,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132150,36.19,0.46,173,61778,70,NULL,NULL,'2MASX J15435526+0145539',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,235.980291667,1.76503,0.245,NULL,56608742099,884511595,13820493,16.6),(132151,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132151,38.07,0.33,411,61779,70,NULL,NULL,'SDSS J154355.52+052425.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,235.981375,5.40717,0.133,NULL,56618191008,884659234,13822800,18.4),(132152,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132152,35.18,0.46,109,61780,70,NULL,NULL,'CGCG 050-086',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000153,NULL,'15.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,235.9815,7.85467,0.037,NULL,56597651885,884338310,13817786,15.2),(132153,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132153,32.04,0.4,25.6,61781,75,NULL,'B','UGC 10054',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000013,NULL,'13.7',1.1,'SBdm',NULL,NULL,NULL,NULL,1,235.982,81.80961,0.177,NULL,57131156857,892674325,13948036,13.7),(132154,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132154,32.86,0.49,37.3,61781,75,NULL,'IR','UGC 10054',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132155,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132155,38.26,0.46,449,61782,70,NULL,NULL,'2MASX J15435581+3743351',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000209,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.982625,37.72636,0.041,NULL,59881829312,935653583,14619587,17.3),(132156,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132156,36.86,0.46,236,61783,70,NULL,NULL,'2MASX J15435596+2215205',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,235.983083333,22.25567,0.165,NULL,59452236209,928941190,14514706,17.6),(132157,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132157,37.02,0.46,253,61784,70,NULL,NULL,'2MASX J15435641+3217042',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000195,NULL,'15.9g',0.42,'E/S0',NULL,NULL,NULL,NULL,1,235.985083333,32.28433,0.081,NULL,59921038975,936266233,14629159,15.9),(132158,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132158,38.32,0.12,461,61785,70,NULL,NULL,'2MASX J15435664+0555099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,235.985917,5.91944,0.129,NULL,56615346388,884614787,13822106,17.7),(132159,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132159,36.39,0.46,190,61786,70,NULL,NULL,'2MASX J15435856+4458179',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000213,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,235.994125,44.97169,0.037,NULL,59693027754,932703558,14573493,16.4),(132160,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132160,35.09,0.46,104,61787,70,NULL,NULL,'CGCG 107-031',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000153,NULL,'15.1g',0.61,NULL,NULL,NULL,NULL,NULL,1,235.995417,19.21153,0.109,NULL,59449937921,928905280,14514145,15.1),(132161,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132161,35.66,0.46,136,61788,70,NULL,NULL,'CGCG 050-088',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000198,NULL,'15.9g',0.38,NULL,NULL,NULL,NULL,NULL,1,236.0022917,8.28839,0.073,NULL,56597494847,884335856,13817747,15.9),(132162,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132162,38.24,0.21,444,61789,70,NULL,NULL,'SDSS J154401.04-015731.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,236.004333333,-1.95883,0.369,NULL,45585508921,712273576,11129274,18.9),(132163,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132163,38.32,0.12,461,61790,70,NULL,NULL,'2MASX J15440120+0536259',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.0050417,5.60728,0.137,NULL,56615433566,884616149,13822127,17.3),(132164,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132164,38.02,0.46,402,61791,70,NULL,NULL,'2MASX J15440188+2612329',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.007917,26.20908,0.181,NULL,59873004388,935515693,14617432,17.1),(132165,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132165,38.32,0.12,461,61792,70,NULL,NULL,'2MASX J15440220+0528169',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.0092917,5.47156,0.133,NULL,56615377398,884615271,13822113,18.6),(132166,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132166,38.24,0.21,444,61793,70,NULL,NULL,'SDSS J154402.73-020426.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000133,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.011375,-2.07397,0.369,NULL,45585502303,712273473,11129273,18.6),(132167,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132167,37.38,0.09,299,61794,70,NULL,NULL,'2MASX J15440307+3635500',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.012625,36.59731,0.041,NULL,59881273864,935644904,14619451,16.5),(132168,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132168,37.57,0.46,327,61795,70,NULL,NULL,'2MASX J15440344+1812106',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.0142917,18.20294,0.065,NULL,59430704655,928604760,14509449,17.7),(132169,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132169,35.29,0.48,114,61796,70,NULL,NULL,'2MASX J15440361-2047165',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.0150417,-20.78794,0.609,NULL,46635228990,728675452,11385553,14.9),(132170,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132170,37.57,0.46,327,61797,70,NULL,NULL,'2MASX J15440400+0406299',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.01675,4.10833,0.161,NULL,56616776020,884637125,13822455,NULL),(132171,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132171,37.38,0.09,299,61798,70,NULL,NULL,'2MASX J15440445+3620510',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.3g',0.26,NULL,'Group member',NULL,NULL,NULL,1,236.018333,36.3475,0.061,NULL,59880546226,935633534,14619273,17.3),(132172,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132172,37.63,0.46,335,61799,70,NULL,NULL,'2MASX J15440477+2734229',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.02,27.57308,0.085,NULL,59917298125,936207783,14628246,17.3),(132173,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132173,33.51,0.2,50.4,61800,74.4,NULL,NULL,'ESO 329- G 016',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00015,NULL,'15.5',0.7,'SB(rs)bc:',NULL,NULL,NULL,NULL,1,236.0220417,-41.24794,0.845,NULL,46339142905,724049107,11313267,15.5),(132174,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132174,33.81,0.47,57.9,61800,NULL,NULL,'H','ESO 329- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132175,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132175,33.85,0.46,59,61800,NULL,NULL,'J','ESO 329- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132176,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132176,33.92,0.45,60.7,61800,NULL,NULL,'K','ESO 329- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132177,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132177,34.04,0.4,64.4,61800,NULL,NULL,'mean','ESO 329- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132178,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132178,37.22,0.46,278,61801,70,NULL,NULL,'2MASX J15440537+2854239',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.38,'Sc',NULL,NULL,NULL,NULL,1,236.022375,28.90653,0.073,NULL,59924931651,936327057,14630110,16.4),(132179,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132179,37.38,0.46,299,61802,70,NULL,NULL,'2MASX J15440628+0948504',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.02625,9.81383,0.097,NULL,56605751525,884464867,13819763,18.1),(132180,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132180,34.81,NULL,91.4,61803,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10004',NULL,'2010Ap&SS.325..163P',2010,1,1.34,NULL,'G',0.000053,NULL,'16.6g',0.13,'Sd',NULL,NULL,NULL,NULL,1,236.029583,47.29464,0.037,NULL,59719726657,933120729,14580011,16.6),(132181,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132181,34.82,NULL,92.2,61803,NULL,NULL,'Dipole + Quadrupole','UGC 10004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132182,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132182,34.84,NULL,92.8,61803,NULL,NULL,'Dipole','UGC 10004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132183,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132183,34.87,NULL,94,61803,NULL,NULL,NULL,'UGC 10004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132184,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132184,37.48,0.46,313,61804,70,NULL,NULL,'2MASX J15440732+4324369',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.030667,43.41019,0.057,NULL,59690484533,932663820,14572872,17.2),(132185,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132185,38.24,0.21,444,61805,70,NULL,NULL,'2MASX J15440740-0154283',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.8g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,236.030958333,-1.90783,0.369,NULL,45585507203,712273550,11129274,16.8),(132186,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132186,35.21,0.46,110,61806,70,NULL,NULL,'2MASX J15440769+2244136',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000163,NULL,'15.6g',0.4,NULL,NULL,NULL,NULL,NULL,1,236.0319583,22.73722,0.165,NULL,59397209815,928081403,14501271,15.6),(132187,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132187,36.98,0.46,249,61807,70,NULL,NULL,'2MASX J15440874+4226039',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000186,NULL,'15.9g',0.41,'E/S0',NULL,NULL,NULL,NULL,1,236.0365,42.43444,0.073,NULL,59680634129,932509908,14570467,15.9),(132188,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132188,37.75,0.46,355,61808,70,NULL,NULL,'2MASX J15441018+2417488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00014,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.042417,24.29689,0.153,NULL,59396253555,928066461,14501038,17.5),(132189,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132189,37.37,0.46,298,61809,70,NULL,NULL,'2MASX J15441037+2038196',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.043208333,20.63881,0.105,NULL,59447895960,928873374,14513646,17.9),(132190,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132190,38.24,0.21,444,61810,70,NULL,NULL,'SDSS J154411.19-015015.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.046667,-1.83761,0.357,NULL,45585321549,712270649,11129228,18.5),(132191,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132191,37.27,0.33,284,61811,70,NULL,NULL,'2MASX J15441136+1416025',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.0475,14.26731,0.069,NULL,56525428473,883209819,13800153,17.2),(132192,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132192,37.66,0.46,341,61812,70,NULL,NULL,'2MASX J15441166+4013420',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.048625,40.22853,0.049,NULL,59961786512,936902914,14639108,18),(132193,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132193,37.38,0.09,299,61813,70,NULL,NULL,'2MASX J15441341+3606400',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000093,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.056083,36.11119,0.053,NULL,59880563363,935633802,14619278,17),(132194,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132194,37.6,0.46,332,61814,70,NULL,NULL,'SDSS J154414.52+080945.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.0605417,8.16261,0.065,NULL,56597517084,884336204,13817753,17.4),(132195,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132195,36.54,0.46,204,61815,70,NULL,NULL,'2MASX J15441517+3947450',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.063041667,39.79592,0.041,NULL,59961779753,936902808,14639106,16.9),(132196,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132196,37.99,0.33,397,61816,70,NULL,NULL,'2MASX J15441566+4240038',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000204,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.06525,42.66772,0.069,NULL,59679777187,932496518,14570258,16.9),(132197,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132197,38.07,0.33,411,61817,70,NULL,NULL,'2MASX J15441594+0528401',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.066333,5.47769,0.133,NULL,56618197506,884659336,13822802,17.6),(132198,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132198,37.38,0.09,299,61818,70,NULL,NULL,'2MASX J15441622+3553500',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000097,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.0675,35.89717,0.041,NULL,59891842104,935810032,14622031,16.9),(132199,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132199,37.64,0.46,337,61819,70,NULL,NULL,'2MASX J15441702-0029218',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000093,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.070875,-0.48942,0.257,NULL,45399336176,709364627,11083822,16.6),(132200,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132200,35.51,0.46,127,61820,70,NULL,NULL,'2MASX J15441720+0206421',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,236.071708333,2.11186,0.253,NULL,56608890470,884513913,13820529,16),(132201,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132201,37,0.46,251,61821,70,NULL,NULL,'2MASX J15441754+1549585',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.073083333,15.83292,0.077,NULL,59431393085,928615516,14509617,17.8),(132202,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132202,37.55,0.19,324,61822,70,NULL,NULL,'2MASX J15441775+3449307',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000163,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.073875,34.82514,0.041,NULL,59894229491,935847335,14622614,16.8),(132203,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132203,37.55,0.19,324,61823,70,NULL,NULL,'MCG +06-35-001',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000117,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,236.0745,34.69628,0.069,NULL,59894225664,935847276,14622613,15.6),(132204,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132204,37.35,0.46,294,61824,70,NULL,NULL,'SDSS J154418.54+105259.9',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.0772917,10.88333,0.105,NULL,56603693292,884432707,13819261,17.1),(132205,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132205,37.55,0.19,324,61825,70,NULL,NULL,'2MASXi J1544192+344139',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,'FoF','17.3g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.08025,34.69433,0.069,NULL,59894226319,935847286,14622613,17.3),(132206,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132206,36.74,0.46,223,61826,70,NULL,NULL,'SDSS J154419.88+400948.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.082875,40.1635,0.049,NULL,59961788828,936902950,14639108,17.8),(132207,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132207,37.9,0.46,381,61827,70,NULL,NULL,'2MASX J15442189+1258435',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.091167,12.97883,0.073,NULL,56523843349,883185052,13799766,NULL),(132208,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132208,38.16,0.33,428,61828,70,NULL,NULL,'2MASX J15442247+2947138',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.0935,29.78711,0.077,NULL,59924542385,936320974,14630015,18),(132209,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132209,37.96,0.46,391,61829,70,NULL,NULL,'2MASX J15442288+1155195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.095333,11.92211,0.129,NULL,56591731228,884245800,13816340,17.1),(132210,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132210,35.33,0.46,117,61830,70,NULL,NULL,'UGC 09999',NULL,'2015arXiv151105856S',2015,1,1.15,NULL,'G',0.000173,NULL,'14.1g',0.83,'S0',NULL,NULL,NULL,NULL,1,236.095625,25.32753,0.149,NULL,59869864655,935466635,14616666,14.1),(132211,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132211,37.87,0.46,374,61831,70,NULL,NULL,'2MASX J15442383+1351485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.0992917,13.86356,0.077,NULL,56525288172,883207627,13800119,17.7),(132212,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132212,37.55,0.19,324,61832,70,NULL,NULL,'2MASX J15442393+3442407',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'FoF','16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.099667,34.71131,0.069,NULL,59894226795,935847293,14622613,16.7),(132213,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132213,37.26,0.33,283,61833,70,NULL,NULL,'2MASX J15442392+4829345',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.09975,48.49303,0.097,NULL,59724299739,933192183,14581127,16.7),(132214,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132214,37.77,0.33,357,61834,70,NULL,NULL,'2MASX J15442413+1703455',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.1007083,17.06261,0.049,NULL,59433212709,928643948,14510061,17.8),(132215,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132215,37.82,0.33,366,61835,70,NULL,NULL,'2MASX J15442459+2203444',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000195,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,236.102375,22.0625,0.161,NULL,59452263989,928941624,14514712,16.5),(132216,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132216,38.07,0.46,411,61836,70,NULL,NULL,'2MASX J15442516+4152040',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.10475,41.86786,0.069,NULL,59680053938,932500842,14570325,17.2),(132217,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132217,37.74,0.46,354,61837,70,NULL,NULL,'SDSS J154425.91+114355.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.108,11.73203,0.133,NULL,56591816849,884247138,13816361,18.5),(132218,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132218,37.82,0.33,366,61838,70,NULL,NULL,'2MASX J15442618+2204394',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.109125,22.07769,0.161,NULL,59396737328,928074020,14501156,18.3),(132219,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132219,37.43,0.46,307,61839,70,NULL,NULL,'2MASXi J1544267+470659',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.111667,47.11653,0.045,NULL,59719704390,933120381,14580005,17.5),(132220,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132220,35.94,0.46,154,61840,70,NULL,NULL,'CGCG 250-006',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000183,NULL,'14.6g',0.65,'E0',NULL,NULL,NULL,NULL,1,236.1122083,47.00672,0.053,NULL,59719710550,933120477,14580007,14.6),(132221,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132221,37.77,0.33,357,61841,70,NULL,NULL,'SDSS J154427.24+170236.7',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.9g',0.43,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.1135417,17.04356,0.049,NULL,59433213009,928643953,14510061,15.9),(132222,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132222,36.33,0.21,184,61842,70,NULL,NULL,'2MASX J15442848+0824296',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,'PHOT','16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.118791667,8.40814,0.069,NULL,56595580006,884305937,13817280,16.5),(132223,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132223,37.93,0.46,386,61843,70,NULL,NULL,'2MASX J15442857+1319474',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.1192083,13.32972,0.081,NULL,56525733926,883214592,13800228,17.3),(132224,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132224,37.55,0.19,324,61844,70,NULL,NULL,'2MASX J15442896+3446307',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.120791667,34.77525,0.041,NULL,59894253619,935847712,14622620,17.5),(132225,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132225,37.27,0.33,284,61845,70,NULL,NULL,'2MASX J15442918+1418534',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.32',0.28,NULL,NULL,NULL,NULL,NULL,1,236.121583,14.31478,0.069,NULL,56525398830,883209356,13800146,17.32),(132226,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132226,35.85,0.49,148,61846,75,NULL,'IR','UGC 09996',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00001,NULL,'15.38',0.19,'Sb',NULL,NULL,NULL,NULL,1,236.121583,11.54953,0.109,NULL,56592505028,884257891,13816529,15.38),(132227,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132227,36.04,NULL,161,61846,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 09996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132228,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132228,36.05,NULL,162,61846,NULL,NULL,'Dipole + Quadrupole','UGC 09996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132229,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132229,36.06,NULL,163,61846,NULL,NULL,NULL,'UGC 09996',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132230,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132230,36.07,NULL,164,61846,NULL,NULL,'Dipole','UGC 09996',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132231,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132231,36.68,0.2,217,61846,74.4,NULL,NULL,'UGC 09996',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132232,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132232,38.2,0.46,436,61847,70,NULL,NULL,'2MASX J15442946+5346175',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.1227083,53.77142,0.017,NULL,59669107202,932329800,14567653,16.9),(132233,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132233,36.89,0.46,238,61848,70,NULL,NULL,'2MASX J15442970+2101224',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.123875,21.02286,0.121,NULL,59447028676,928859823,14513434,16.1),(132234,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132234,37.57,0.33,326,61849,70,NULL,NULL,'SDSS J154429.97+242026.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.124917,24.34064,0.153,NULL,59396224644,928066010,14501031,18.6),(132235,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132235,36.15,0.27,170,61850,70,NULL,NULL,'2MASX J15443125+0413531',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.130083333,4.23133,0.169,NULL,56616583482,884634116,13822408,16.3),(132236,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132236,34.7,0.47,87,61851,70,NULL,NULL,'2MASX J15443216-1525087',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000047,NULL,'15.08',NULL,NULL,NULL,NULL,NULL,NULL,1,236.1339583,-15.41917,0.381,NULL,46599821174,728122205,11376909,15.08),(132237,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132237,36.83,0.46,232,61852,70,NULL,NULL,'2MASX J15443238+3205317',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.134916667,32.09228,0.089,NULL,59921044655,936266322,14629161,17.4),(132238,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132238,34.85,0.2,93.3,61853,74.4,NULL,NULL,'ESO 515- G 005',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'13.90',0.6,'S...',NULL,NULL,NULL,NULL,1,236.136291667,-25.37478,0.821,NULL,47115294665,736176479,11502757,13.9),(132239,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132239,34.89,0.46,94.9,61853,NULL,NULL,'Malmquist cor.','ESO 515- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132240,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132240,35.13,0.41,106,61853,NULL,NULL,NULL,'ESO 515- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132241,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132241,38.03,0.46,404,61854,70,NULL,NULL,'2MASX J15443283+4143570',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.136917,41.73242,0.069,NULL,59680095337,932501489,14570335,17.4),(132242,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132242,37.99,0.33,397,61855,70,NULL,NULL,'2MASX J15443369+4238080',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.1402917,42.63564,0.069,NULL,59679823556,932497243,14570269,17.6),(132243,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132243,36.56,0.2,205,61856,74.4,NULL,NULL,'NGC 5988',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'14.50',1,'Scd:',NULL,NULL,NULL,NULL,1,236.141083,10.29314,0.105,NULL,56606271189,884472987,13819890,14.5),(132244,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132244,37.38,0.09,299,61857,70,NULL,NULL,'2MASX J15443385+3628390',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00007,NULL,'16.8g',0.3,NULL,'Group member',NULL,NULL,NULL,1,236.1412083,36.47739,0.053,NULL,59880538869,935633419,14619272,16.8),(132245,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132245,37.61,0.46,333,61858,70,NULL,NULL,'SDSS J154434.35+261742.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.143125,26.29506,0.197,NULL,59873138419,935517787,14617465,18.1),(132246,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132246,37.38,0.09,299,61859,70,NULL,NULL,'2MASX J15443516+3626263',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'17.3g',0.18,NULL,'Group member',NULL,NULL,NULL,1,236.146333,36.44075,0.053,NULL,59880540540,935633445,14619272,17.3),(132247,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132247,37.42,0.46,305,61860,70,NULL,NULL,'2MASX J15443580+0957176',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.149125,9.95497,0.097,NULL,56606101417,884470334,13819848,17.5),(132248,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132248,37.23,0.46,279,61861,70,NULL,NULL,'2MASX J15443860+4221001',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.160917,42.34992,0.073,NULL,59680682146,932510658,14570479,17.5),(132249,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132249,38.16,0.33,428,61862,70,NULL,NULL,'2MASX J15443897+2940368',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.1622917,29.67678,0.077,NULL,59924486607,936320103,14630001,17.6),(132250,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132250,37.44,0.46,308,61863,70,NULL,NULL,'SDSS J154438.97+382615.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.162416667,38.43775,0.045,NULL,59878911378,935607990,14618874,17.7),(132251,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132251,38.45,0.46,489,61864,70,NULL,NULL,'SDSS J154439.58-014021.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.164916667,-1.6725,0.357,NULL,45587429029,712303578,11129743,19),(132252,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132252,35.74,0.57,141,61865,70,NULL,NULL,'2MASX J15443973-3003281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.165625,-30.05781,0.477,NULL,47173913047,737092391,11517068,14),(132253,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132253,37.73,0.46,351,61866,70,NULL,NULL,'2MASX J15444014+0759276',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000176,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.167375,7.99094,0.065,NULL,56595352340,884302380,13817224,17.9),(132254,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132254,37.85,0.46,372,61867,70,NULL,NULL,'2MASX J15444035+3047166',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00021,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,236.168167,30.78794,0.081,NULL,59921201260,936268769,14629199,16.7),(132255,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132255,38.71,0.46,553,61868,70,NULL,NULL,'2MASX J15444048+3327232',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.168583,33.45658,0.049,NULL,59888968306,935765129,14621330,18.4),(132256,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132256,36.44,0.46,194,61869,70,NULL,NULL,'2MASX J15444108+0931046',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',NULL,NULL,'16.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.171083333,9.518,0.105,NULL,56602689668,884417026,13819016,16.1),(132257,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132257,37.33,0.23,293,61870,70,NULL,NULL,'2MASX J15444118+5246544',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000102,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.1715,52.78178,0.037,NULL,59668744602,932324134,14567564,16.3),(132258,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132258,37.33,0.23,293,61871,70,NULL,NULL,'SBS 1543+528',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00011,NULL,'15.1g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,236.1765417,52.68733,0.037,NULL,59668753553,932324274,14567566,15.1),(132259,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132259,35.18,0.49,109,61872,75,NULL,'IR','UGC 10006',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000088,NULL,'15.8g',0.26,'Sbc',NULL,NULL,NULL,NULL,1,236.17925,32.40375,0.073,NULL,59888492051,935757688,14621213,15.8),(132260,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132260,35.58,0.2,131,61872,74.4,NULL,NULL,'UGC 10006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132261,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132261,35.66,0.36,136,61872,NULL,NULL,'Malmquist cor.','UGC 10006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132262,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,NULL,132262,35.72,0.35,139,61872,NULL,NULL,NULL,'UGC 10006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132263,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132263,37.33,0.23,293,61873,70,NULL,NULL,'SDSS J154444.39+524839.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.185,52.81089,0.013,NULL,59668717309,932323707,14567557,18.2),(132264,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132264,37.38,0.09,299,61874,70,NULL,NULL,'2MASX J15444471+3607474',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000083,NULL,'16.7g',0.27,NULL,'Group member',NULL,NULL,NULL,1,236.1864583,36.12986,0.053,NULL,59880534481,935633351,14619271,16.7),(132265,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132265,37.33,0.23,293,61875,70,NULL,NULL,'2MASX J15444501+5251094',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000107,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,236.187625,52.85269,0.013,NULL,59668714214,932323659,14567557,16),(132266,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132266,37.38,0.09,299,61876,70,NULL,NULL,'2MASX J15444538+3604324',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'15.8',0.2,NULL,'Group member',NULL,NULL,NULL,1,236.1889583,36.07558,0.053,NULL,59880531911,935633311,14619270,15.8),(132267,'FP','2016-12-15 15:15:36','2016-12-16 11:20:50','1',NULL,'R',132267,38.27,0.46,450,61877,70,NULL,NULL,'2MASX J15444546+0452343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.189375,4.87608,0.145,NULL,56618734779,884667730,13822933,17),(132268,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132268,36.13,0.2,168,61878,74.4,NULL,NULL,'CGCG 078-059',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000137,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,236.1904583,8.99725,0.093,NULL,56595280476,884301257,13817207,15.5),(132269,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132269,37.1,0.46,263,61879,70,NULL,NULL,'2MASX J15444658+4102274',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.1940417,41.04103,0.053,NULL,59677575050,932462110,14569720,16.3),(132270,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132270,37.85,0.46,372,61880,70,NULL,NULL,'2MASX J15444721+0815586',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.19675,8.26619,0.069,NULL,56595511956,884304874,13817263,18.1),(132271,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132271,36.43,0.33,193,61881,70,NULL,NULL,'2MASX J15444807+3532253',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000167,NULL,'16.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,236.200375,35.54022,0.037,NULL,59891887344,935810739,14622042,16.4),(132272,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132272,35.45,0.48,123,61882,70,NULL,NULL,'2MASX J15444821-1922215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.19',NULL,NULL,NULL,NULL,NULL,NULL,1,236.200791667,-19.37258,0.517,NULL,46636441217,728694394,11385849,15.19),(132273,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132273,38.02,0.46,401,61883,70,NULL,NULL,'2MASX J15444858+5654486',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.202375,56.91367,0.017,NULL,57642480821,900663762,14072871,17.8),(132274,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132274,37.81,0.46,365,61884,70,NULL,NULL,'2MASX J15444864+1823168',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.20275,18.38817,0.069,NULL,59430666307,928604161,14509440,17.7),(132275,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132275,33.46,NULL,49.2,61885,NULL,NULL,'Dipole','UGC 10000',NULL,'2010Ap&SS.325..163P',2010,1,1.97,NULL,'G',0.000005,NULL,'15.90',0.2,'Scd',NULL,NULL,NULL,NULL,1,236.206083,3.95633,0.217,NULL,56616169073,884627641,13822306,15.9),(132276,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132276,33.47,NULL,49.4,61885,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10000',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132277,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132277,33.47,NULL,49.5,61885,NULL,NULL,'Dipole + Quadrupole','UGC 10000',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132278,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132278,33.56,NULL,51.6,61885,NULL,NULL,NULL,'UGC 10000',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132279,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132279,34.55,0.2,81.3,61885,74.4,NULL,NULL,'UGC 10000',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132280,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132280,34.77,0.74,89.9,61885,NULL,NULL,NULL,'UGC 10000',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132281,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132281,34.93,0.69,96.7,61885,NULL,NULL,'Malmquist cor.','UGC 10000',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132282,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132282,38.18,0.46,432,61886,70,NULL,NULL,'2MASX J15444988+0604383',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000196,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.208,6.07742,0.117,NULL,56615269489,884613585,13822087,18.2),(132283,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132283,37.57,0.33,326,61887,70,NULL,NULL,'2MASX J15445108+2424378',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000185,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.2129583,24.41039,0.153,NULL,59396211135,928065798,14501028,16.3),(132284,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132284,35.19,0.46,109,61888,70,NULL,NULL,'CGCG 222-050',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.00015,NULL,'14.5g',0.65,'E0',NULL,NULL,NULL,NULL,1,236.2135,43.51406,0.049,NULL,59690501720,932664089,14572876,14.5),(132285,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132285,37.9,0.33,380,61889,70,NULL,NULL,'2MASX J15445149+3646484',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.2145417,36.78017,0.037,NULL,59881151250,935642988,14619421,17.1),(132286,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132286,37.38,0.09,299,61890,70,NULL,NULL,'2MASX J15445181+3609594',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000127,NULL,'17.3g',0.18,NULL,'Group member',NULL,NULL,NULL,1,236.215875,36.16664,0.053,NULL,59880534758,935633355,14619271,17.3),(132287,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132287,36.88,0.46,237,61891,70,NULL,NULL,'2MASX J15445194+4216140',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000152,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.216625,42.27056,0.073,NULL,59680683912,932510686,14570479,16.3),(132288,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132288,34.4,0.57,75.8,61892,NULL,NULL,'Malmquist cor.','UGC 10022',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000044,NULL,'15.9r',0.4,'Sc(f)',NULL,NULL,NULL,NULL,1,236.221625,57.36153,0.033,NULL,57635916845,900561200,14071268,15.9),(132289,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132289,34.53,0.54,80.5,61892,NULL,NULL,NULL,'UGC 10022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132290,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132290,34.57,0.2,82,61892,74.4,NULL,NULL,'UGC 10022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132291,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132291,35.97,0.46,157,61893,70,NULL,NULL,'2MASX J15445321+0024153',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000071,NULL,'16.2g',0.37,'S0',NULL,NULL,NULL,NULL,1,236.221791667,0.40431,0.277,NULL,56606543527,884477242,13819956,16.2),(132292,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132292,36.43,0.33,193,61894,70,NULL,NULL,'2MASX J15445372+3531434',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000186,NULL,'16.0g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,236.2239583,35.52881,0.037,NULL,59891886400,935810725,14622042,16),(132293,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132293,37.38,0.09,299,61895,70,NULL,NULL,'SDSS J154455.61+360534.0',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000162,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,236.2317083,36.09281,0.053,NULL,59880536026,935633375,14619271,18.6),(132294,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132294,37.38,0.09,299,61896,70,NULL,NULL,'2MASX J15445586+3608184',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.16,NULL,'Group member',NULL,NULL,NULL,1,236.23275,36.1385,0.053,NULL,59880537890,935633404,14619271,17.6),(132295,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132295,37.44,0.46,308,61897,70,NULL,NULL,'2MASX J15445698+0630266',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000182,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.2375417,6.50731,0.057,NULL,56623481800,884741903,13824092,16.9),(132296,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132296,37.61,0.46,333,61898,70,NULL,NULL,'2MASX J15445788+2715083',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.2412083,27.25244,0.085,NULL,59872014474,935500226,14617191,17.5),(132297,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132297,37.38,0.09,299,61899,70,NULL,NULL,'2MASX J15445791+3604074',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00011,NULL,'16.7g',0.31,NULL,'Group member',NULL,NULL,NULL,1,236.241416667,36.06883,0.053,NULL,59880523927,935633186,14619268,16.7),(132298,'BCG','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132298,37.47,0.35,292,61900,60,NULL,'ABELL 2124, BCG','UGC 10012',0.0671,'1980ApJ...241..486H',1980,1,0.92,NULL,'G',0.0001,NULL,'14.9g',0.67,'cD;E           BrClG','Group member',NULL,NULL,NULL,1,236.2459583,36.10947,0.053,NULL,59880535406,935633365,14619271,14.9),(132299,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132299,37.38,0.09,299,61900,70,NULL,NULL,'UGC 10012',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132300,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132300,38.15,0.46,427,61901,70,NULL,NULL,'2MASX J15445937-0120047',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.247333,-1.33458,0.349,NULL,45584197649,712253088,11128954,18.2),(132301,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132301,35.13,0.49,106,61902,75,NULL,'IR','ESO 515- G 006',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'14.40',0.2,'S...',NULL,NULL,NULL,NULL,1,236.2480417,-25.26003,0.813,NULL,47115356485,736177445,11502772,14.4),(132302,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132302,35.55,0.6,129,61902,NULL,NULL,'Malmquist cor.','ESO 515- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132303,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132303,35.62,0.58,133,61902,NULL,NULL,NULL,'ESO 515- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132304,'Tully-Fisher','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132304,35.66,0.2,136,61902,74.4,NULL,NULL,'ESO 515- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132305,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132305,37.38,0.09,299,61903,70,NULL,NULL,'2MASX J15445972+3559174',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.3g',0.14,NULL,'Group member',NULL,NULL,NULL,1,236.248917,35.98814,0.041,NULL,59891823876,935809748,14622027,18.3),(132306,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132306,36.58,0.46,207,61904,70,NULL,NULL,'SDSS J154459.98+535016.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.2499583,53.83803,0.017,NULL,59669139022,932330297,14567660,17.5),(132307,'BCG','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132307,37.47,0.35,292,61905,60,NULL,NULL,'ABELL 2124',0.0671,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000387,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,236.25,36.06611,0.053,NULL,59880523969,935633187,14619268,NULL),(132308,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,NULL,132308,35.48,0.61,125,61906,70,NULL,NULL,'2MASX J15450006-1530175',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.250333,-15.50494,0.449,NULL,46599813418,728122084,11376907,15.3),(132309,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132309,36.3,0.46,182,61907,70,NULL,NULL,'2MASX J15450153+3558174',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00006,NULL,'17.0g',0.22,NULL,'Group member',NULL,NULL,NULL,1,236.256333,35.97158,0.041,NULL,59891824048,935809750,14622027,17),(132310,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132310,37.55,0.46,324,61908,70,NULL,NULL,'SDSS J154502.32+041328.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.6g',0.09,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.2597083,4.22453,0.169,NULL,56616229472,884628585,13822321,18.6),(132311,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132311,36.47,0.46,197,61909,70,NULL,NULL,'2MASX J15450264+3920394',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.260833,39.34425,0.045,NULL,59877933480,935592710,14618636,17.2),(132312,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132312,37.38,0.09,299,61910,70,NULL,NULL,'2MASX J15450338+3610564',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.0g',0.24,NULL,'Group member',NULL,NULL,NULL,1,236.264041667,36.18225,0.053,NULL,59880528552,935633258,14619269,17),(132313,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132313,37.38,0.09,299,61911,70,NULL,NULL,'2MASX J15450346+3610034',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'15.21',0.3,NULL,'Group member',NULL,NULL,NULL,1,236.264583,36.16753,0.053,NULL,59880528481,935633257,14619269,15.21),(132314,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132314,36.9,0.33,240,61912,70,NULL,NULL,'2MASX J15450413+1658510',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.267083333,16.98083,0.049,NULL,59433161619,928643150,14510049,17.7),(132315,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132315,38.34,0.46,465,61913,70,NULL,NULL,'SDSS J154505.15+054901.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.2715,5.81703,0.129,NULL,56615286813,884613856,13822091,18.4),(132316,'FP','2016-12-15 15:15:36','2016-12-16 11:20:51','1',NULL,'R',132316,37.38,0.09,299,61914,70,NULL,NULL,'SDSS J154505.68+360655.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'18.1g',0.14,NULL,'Group member',NULL,NULL,NULL,1,236.273666667,36.11547,0.053,NULL,59880536581,935633384,14619271,18.1),(132317,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132317,36.37,0.46,188,61915,70,NULL,NULL,'2MASX J15450639+5315285',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000169,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,236.2767083,53.25797,0.009,NULL,59668778179,932324659,14567572,16),(132318,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132318,37.38,0.09,299,61916,70,NULL,NULL,'2MASX J15450724+3605273',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000113,NULL,'17.3g',0.21,NULL,'Group member',NULL,NULL,NULL,1,236.2802917,36.09078,0.053,NULL,59880524434,935633194,14619268,17.3),(132319,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132319,36.13,0.66,168,61917,70,NULL,NULL,'2MASX J15450789-1631515',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.09',0.2,NULL,NULL,NULL,NULL,NULL,1,236.282833,-16.53125,0.365,NULL,46600580905,728134076,11377094,16.09),(132320,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132320,37.69,0.33,345,61918,70,NULL,NULL,'2MASX J15450929+4817094',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.2887917,48.28594,0.089,NULL,59724375364,933193365,14581146,17.7),(132321,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132321,34.91,0.46,96,61919,70,NULL,NULL,'CGCG 166-049',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000167,NULL,'14.9g',0.65,'AGN',NULL,NULL,NULL,NULL,1,236.290083333,26.50611,0.149,NULL,59873127613,935517618,14617462,14.9),(132322,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132322,37.69,0.33,345,61920,70,NULL,NULL,'2MASX J15451060+4818284',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.294125,48.30794,0.097,NULL,59724375664,933193369,14581146,17.7),(132323,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132323,33.01,NULL,39.9,61921,NULL,NULL,'Dipole','ESO 099- G 008',NULL,'2010Ap&SS.325..163P',2010,1,2.8,'Star superposed.','G',0.000027,NULL,'15.5',0.21,'Scd;high incl',NULL,NULL,NULL,NULL,1,236.297167,-66.29214,NULL,NULL,45056775886,704012123,11000189,15.5),(132324,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132324,33.01,NULL,39.9,61921,NULL,NULL,'Dipole + Quadrupole','ESO 099- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132325,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132325,33.01,NULL,40,61921,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 099- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132326,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132326,37.48,0.46,314,61922,70,NULL,NULL,'2MASX J15451188+5212304',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00008,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,236.2995,52.20847,0.029,NULL,59718034143,933094283,14579598,16.5),(132327,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132327,36.42,0.58,192,61923,70,NULL,NULL,'2MASX J15451412-1736485',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.308791667,-17.61342,0.429,NULL,46602209884,728159529,11377492,14.9),(132328,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132328,36.61,0.46,210,61924,70,NULL,NULL,'2MASX J15451433+3541519',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,236.309583,35.69783,0.045,NULL,59892030048,935812969,14622077,16.3),(132329,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132329,37.38,0.09,299,61925,70,NULL,NULL,'SDSS J154514.78+362423.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000158,NULL,'18.6g',0.12,NULL,'Group member',NULL,NULL,NULL,1,236.311667,36.40664,0.049,NULL,59880731494,935636429,14619319,18.6),(132330,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132330,37.53,0.46,321,61926,70,NULL,NULL,'2MASX J15451484+0053542',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000062,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.311875,0.89844,0.293,NULL,56607243697,884488182,13820127,18.1),(132331,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132331,37.95,0.46,389,61927,70,NULL,NULL,'2MASX J15451507+4849234',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000182,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.312833,48.82331,0.089,NULL,59726396454,933224944,14581639,17.5),(132332,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132332,38.15,0.33,428,61928,70,NULL,NULL,'2MASX J15451517+0609584',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.3132917,6.16617,0.117,NULL,56623421766,884740965,13824077,17.7),(132333,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132333,37.38,0.09,299,61929,70,NULL,NULL,'SDSS J154515.64+360101.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'18.2g',0.11,NULL,'Group member',NULL,NULL,NULL,1,236.3152083,36.01717,0.053,NULL,59891814145,935809596,14622024,18.2),(132334,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132334,38.15,0.33,428,61930,70,NULL,NULL,'2MASX J15451577+0603294',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.315833,6.05808,0.117,NULL,56615297552,884614024,13822094,18),(132335,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132335,38.25,0.46,446,61931,70,NULL,NULL,'2MASX J15451648+0955354',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.318791667,9.92653,0.133,NULL,56606076455,884469944,13819842,17.2),(132336,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132336,37.95,0.46,390,61932,70,NULL,NULL,'SDSS J154520.02+075103.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.333417,7.85094,0.065,NULL,56595342326,884302223,13817222,18.3),(132337,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132337,35.68,0.8,137,61933,75,NULL,'CF, r','UGC 10011',NULL,'1997ApJS..109..333W',1997,1,1.07,NULL,'G',0.000033,NULL,'15.4g',0.39,'Sbc',NULL,NULL,NULL,NULL,1,236.34,25.44369,0.157,NULL,59873328666,935520760,14617511,15.4),(132338,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132338,35.53,0.38,128,61933,75,NULL,'CF, r, raw','UGC 10011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132339,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132339,35.69,0.38,138,61933,75,NULL,'CF, r, inv','UGC 10011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132340,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132340,35.75,0.38,141,61933,75,NULL,'CF, r, cor','UGC 10011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132341,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132341,36,0.2,158,61933,74.4,NULL,NULL,'UGC 10011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132342,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132342,37.12,0.46,265,61934,70,NULL,NULL,'2MASX J15452221+0654164',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.3424583,6.90456,0.057,NULL,56626578110,884790282,13824848,16.7),(132343,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132343,38.27,0.46,450,61935,70,NULL,NULL,'2MASX J15452289+0734194',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.345417,7.57208,0.049,NULL,56626568870,884790138,13824845,17.1),(132344,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132344,36.38,0.46,189,61936,70,NULL,NULL,'2MASX J15452304+1322020',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'16.97',0.43,NULL,NULL,NULL,NULL,NULL,1,236.345875,13.36714,0.081,NULL,56523793044,883184266,13799754,16.97),(132345,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132345,35.12,0.2,106,61937,74.4,NULL,NULL,'CGCG 136-068',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000067,NULL,'15.3g',0.46,'SBb',NULL,NULL,NULL,NULL,1,236.347,24.50678,0.157,NULL,59398972447,928108944,14501702,15.3),(132346,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132346,36.33,0.21,184,61938,70,NULL,NULL,'2MASX J15452337+0836094',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000113,NULL,'16.44',0.39,NULL,NULL,NULL,NULL,NULL,1,236.3472917,8.60272,0.057,NULL,56595620789,884306574,13817290,16.44),(132347,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132347,37.88,0.46,377,61939,70,NULL,NULL,'2MASX J15452377+0017392',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000094,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.349167,0.29436,0.277,NULL,56606378578,884474665,13819916,17.2),(132348,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132348,37.58,0.46,327,61940,70,NULL,NULL,'2MASX J15452411+4725010',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.349958333,47.41767,0.037,NULL,59719655603,933119618,14579994,16.7),(132349,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132349,38.02,0.46,401,61941,70,NULL,NULL,'2MASX J15452515+2236589',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.354917,22.61631,0.169,NULL,59397624619,928087884,14501373,18.3),(132350,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132350,38.18,0.46,433,61942,70,NULL,NULL,'2MASX J15452677+3200060',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.3615,32.00175,0.081,NULL,59921790551,936277977,14629343,17.8),(132351,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132351,38.22,0.46,441,61943,70,NULL,NULL,'2MASX J15452684+1434590',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.3619583,14.58308,0.089,NULL,56536999563,883390618,13802978,17.5),(132352,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132352,37.33,0.46,293,61944,70,NULL,NULL,'2MASX J15452716+0012542',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.363167,0.21511,0.277,NULL,56606387983,884474812,13819918,18.2),(132353,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132353,36.34,0.78,185,61945,70,NULL,NULL,'2MASX J15452741-2224556',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.3642083,-22.41547,0.729,NULL,46584991340,727890489,11373288,16.1),(132354,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132354,36.69,0.46,217,61946,70,NULL,NULL,'2MASX J15452762+0806478',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000182,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,236.364917,8.11342,0.065,NULL,56595568666,884305760,13817277,16),(132355,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132355,37.02,0.46,253,61947,70,NULL,NULL,'2MASX J15452865+3505550',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.369333,35.09844,0.057,NULL,59892173728,935815214,14622112,17.3),(132356,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132356,36.9,0.33,240,61948,70,NULL,NULL,'2MASX J15453091+1657170',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,236.378917,16.95472,0.061,NULL,59432689558,928635774,14509933,16.2),(132357,'L(H{beta})-{sigma}','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132357,46.03,NULL,1608,61949,74.3,NULL,NULL,'WISP 138_0173',2.158,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.379291667,9.55833,0.105,NULL,56602829795,884419215,13819050,NULL),(132358,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132358,38.23,0.46,443,61950,70,NULL,NULL,'SDSS J154531.17-000909.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.379875,-0.15256,0.261,NULL,45516591902,711196748,11112449,18.7),(132359,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132359,37.99,0.46,396,61951,70,NULL,NULL,'2MASX J15453136+2543213',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.3807083,25.72256,0.161,NULL,59873305437,935520397,14617506,18.1),(132360,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132360,38.35,0.46,467,61952,70,NULL,NULL,'2MASX J15453141+2800493',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.3809583,28.01375,0.073,NULL,59916855747,936200871,14628138,17.5),(132361,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132361,37.38,0.09,299,61953,70,NULL,NULL,'2MASX J15453171+3613041',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.0g',0.25,NULL,'Group member',NULL,NULL,NULL,1,236.382125,36.21761,0.053,NULL,59880747320,935636676,14619323,17),(132362,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132362,38.02,0.46,402,61954,70,NULL,NULL,'2MASX J15453218+1401120',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.384,14.01997,0.097,NULL,56536382144,883380971,13802827,17.7),(132363,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132363,38.38,0.46,474,61955,70,NULL,NULL,'2MASX J15453238+3946571',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00019,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.384833,39.78269,0.041,NULL,59794001694,934281276,14598144,18),(132364,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132364,36.08,0.2,164,61956,74.4,NULL,NULL,'UGC 10019',NULL,'2013AJ....146...86T',2013,1,1.12,NULL,'G',0.000033,NULL,'15.2g',0.36,'Sb','Group member',NULL,NULL,NULL,1,236.389708333,30.14742,0.077,NULL,59922476254,936288691,14629510,15.2),(132365,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132365,36.9,0.46,239,61957,70,NULL,NULL,'2MASX J15453492+4426099',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000233,NULL,'15.8g',0.45,'E0',NULL,NULL,NULL,NULL,1,236.395583333,44.43606,0.029,NULL,59693202377,932706287,14573535,15.8),(132366,'L(H{beta})-{sigma}','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132366,46.15,NULL,1595,61958,74.3,NULL,NULL,'WISP 138_0160',2.264,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.4012083,9.57408,0.105,NULL,56602832288,884419254,13819050,NULL),(132367,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132367,37.54,0.46,322,61959,70,NULL,NULL,'2MASX J15453688+0257168',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.403875,2.95467,0.257,NULL,56609028200,884516065,13820563,18),(132368,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132368,37.36,0.46,297,61960,70,NULL,NULL,'2MASX J15453743+2400403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.4060417,24.01119,0.153,NULL,59399030979,928109859,14501716,17.8),(132369,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132369,35.98,0.6,157,61961,70,NULL,NULL,'2MASX J15453750-1654207',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.06',0.3,NULL,NULL,NULL,NULL,NULL,1,236.40625,-16.90594,0.389,NULL,46602515344,728164302,11377567,16.06),(132370,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132370,38.05,0.33,408,61962,70,NULL,NULL,'2MASX J15453794+1830594',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.408083333,18.51639,0.077,NULL,59446406446,928850100,14513282,17),(132371,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132371,37.14,0.46,267,61963,70,NULL,NULL,'SDSS J154538.83+245257.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.411791667,24.88256,0.153,NULL,59869773444,935465210,14616643,17.9),(132372,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132372,34.62,0.2,84,61964,74.4,NULL,NULL,'UGC 10015',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000017,NULL,'16.2g',0.33,'Sdm:',NULL,NULL,NULL,NULL,1,236.413458333,21.01953,0.121,NULL,59447175856,928862122,14513470,16.2),(132373,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132373,36.12,0.51,168,61965,70,NULL,NULL,'2MASX J15453931-1701517',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000093,NULL,'15.64',NULL,NULL,NULL,NULL,NULL,NULL,1,236.413833,-17.031,0.433,NULL,46602485248,728163832,11377559,15.64),(132374,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132374,32.86,0.4,37.3,61966,75,NULL,NULL,'IC 4582',NULL,'2008Ap.....51..336K',2008,1,1.3,'Multiple SDSS entries describe this object.','G',0.00003,NULL,'13.7B',0.3,'S?',NULL,NULL,NULL,NULL,1,236.414375,28.08867,0.073,NULL,59916882763,936201293,14628145,13.7),(132375,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132375,33.06,0.4,41,61966,NULL,NULL,'mean','IC 4582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132376,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132376,33.38,0.47,47.5,61966,NULL,NULL,'H','IC 4582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132377,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132377,33.42,0.45,48.2,61966,NULL,NULL,'K','IC 4582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132378,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132378,33.49,0.46,49.9,61966,NULL,NULL,'J','IC 4582',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132379,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132379,33.69,0.49,54.7,61966,75,NULL,'IR','IC 4582',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132380,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132380,38.3,0.46,457,61967,70,NULL,NULL,'SDSS J154539.51+222308.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000166,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.414625,22.38558,0.177,NULL,59396751451,928074241,14501160,18.7),(132381,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132381,36.43,0.46,193,61968,70,NULL,NULL,'2MASX J15453978+2037534',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.41575,20.63158,0.145,NULL,59447913655,928873650,14513650,17),(132382,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132382,36.54,0.46,203,61969,70,NULL,NULL,'2MASX J15453996+1503590',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'16.4r',0.2,NULL,NULL,NULL,NULL,NULL,1,236.416625,15.06642,0.093,NULL,56536298265,883379660,13802807,16.4),(132383,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132383,38.05,0.33,408,61970,70,NULL,NULL,'2MASX J15454041+1829204',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.4184583,18.48892,0.077,NULL,59446406095,928850095,14513282,17.8),(132384,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132384,36.55,0.46,205,61971,70,NULL,NULL,'2MASX J15454072+3329080',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.419541667,33.48561,0.065,NULL,59889001072,935765641,14621338,17.5),(132385,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132385,36.65,0.46,214,61972,70,NULL,NULL,'2MASX J15454092+1453040',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.4204583,14.88458,0.097,NULL,56536280181,883379377,13802802,16.7),(132386,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132386,45,0.51,4020,61973,69.7,NULL,'Calibrated','HG 060418',1.49,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',NULL,NULL,'20.2R',NULL,'Swift',NULL,NULL,NULL,NULL,1,236.428333,-3.64058,0.477,NULL,45599343435,712489741,11132652,20.2),(132387,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132387,45.09,0.47,4190,61973,69.7,NULL,'Fiducial','HG 060418',1.49,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132388,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132388,45.33,0.54,4680,61973,72,NULL,NULL,'HG 060418',1.49,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132389,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132389,45.43,1.6,4900,61973,100,NULL,NULL,'HG 060418',1.49,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132390,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132390,45.45,0.56,4940,61973,70,NULL,NULL,'HG 060418',1.49,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132391,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132391,45.45,0.63,4940,61973,NULL,NULL,NULL,'HG 060418',1.49,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132392,'GRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132392,45.6,1.54,5290,61973,69.7,NULL,'Calibrated','HG 060418',1.49,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132393,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132393,36.32,NULL,184,61974,NULL,NULL,'B, Hubble-type-TF','CGCG 136-071',NULL,'2005Ap&SS.298..577R',2005,1,0.55,NULL,'G',0.000063,NULL,'15.3g',0.46,'Irr            HII',NULL,NULL,NULL,NULL,1,236.42975,22.87847,0.161,NULL,59397426122,928084783,14501324,15.3),(132394,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132394,37.41,0.46,304,61975,70,NULL,NULL,'2MASX J15454385+3611491',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000103,NULL,'16.4g',0.32,NULL,'Group member',NULL,NULL,NULL,1,236.43275,36.19692,0.053,NULL,59880750487,935636726,14619323,16.4),(132395,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132395,37.38,0.09,299,61976,70,NULL,NULL,'2MASX J15454384+3607491',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.432833,36.13017,0.053,NULL,59880736533,935636508,14619320,16.7),(132396,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132396,31.58,0.4,20.7,61977,75,NULL,'B','UGC 10014',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000013,NULL,'14.5',1.2,'Im',NULL,NULL,NULL,NULL,1,236.4332083,12.51058,0.137,NULL,56523740977,883183452,13799741,14.5),(132397,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132397,32.95,0.4,38.9,61977,NULL,NULL,NULL,'UGC 10014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132398,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132398,32.62,0.4,33.4,61978,75,NULL,'B','UGC 10020',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'14.8g',2.1,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,236.4354583,20.56042,0.145,NULL,59447959168,928874362,14513661,14.8),(132399,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132399,35.44,0.52,122,61979,70,NULL,NULL,'CGCG 022-035',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00015,NULL,'15.6g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,236.4372083,-2.10469,0.417,NULL,45587442148,712303783,11129746,15.6),(132400,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132400,31.3,0.8,18.2,61980,75,NULL,NULL,'UGC 10031',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000017,NULL,'17.',1.4,'Sm:','Group member',NULL,NULL,NULL,1,236.439167,61.55583,0.033,NULL,57744118983,902251859,14097685,17),(132401,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132401,36.81,0.46,231,61981,70,NULL,NULL,'SDSS J154545.75+143657.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.440667,14.61606,0.089,NULL,56537046211,883391347,13802989,17.9),(132402,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132402,35.68,0.49,137,61982,75,NULL,'IR','CGCG 078-062',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000193,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,236.440875,9.07975,0.109,NULL,56595190918,884299858,13817185,15.4),(132403,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132403,34.16,0.49,68,61983,75,NULL,'IR','CGCG 050-093',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000014,NULL,'15.1g',0.29,'S              LLIRG','Group member',NULL,NULL,NULL,1,236.4412917,2.40983,0.257,NULL,56609216246,884519003,13820609,15.1),(132404,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132404,37.53,0.46,321,61984,70,NULL,NULL,'SDSS J154546.39+000358.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.4432917,0.06636,0.261,NULL,56472170439,882377663,13787150,18.6),(132405,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132405,37.65,0.46,339,61985,70,NULL,NULL,'SDSS J154546.46+294037.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000125,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.443583,29.67717,0.077,NULL,59924474966,936319921,14629998,18.5),(132406,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132406,36.99,0.46,250,61986,70,NULL,NULL,'SDSS J154547.03+052113.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.446,5.35375,0.109,NULL,56618292127,884660814,13822825,17.7),(132407,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132407,38.74,0.46,560,61987,70,NULL,NULL,'2MASX J15454706+2510243',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.44625,25.17361,0.153,NULL,59873213235,935518956,14617483,17.3),(132408,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132408,36.76,0.46,225,61988,70,NULL,NULL,'2MASX J15454716+3343500',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.446541667,33.73056,0.061,NULL,59888912024,935764250,14621316,16.6),(132409,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132409,37.51,0.46,318,61989,70,NULL,NULL,'2MASX J15454734+3912142',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,236.447333,39.204,0.045,NULL,59878110602,935595478,14618679,17),(132410,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132410,37.38,0.09,299,61990,70,NULL,NULL,'2MASX J15454873+3557157',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000097,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.4529583,35.95442,0.049,NULL,59891926989,935811359,14622052,17.7),(132411,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132411,38.04,0.46,405,61991,70,NULL,NULL,'2MASX J15454892+4252130',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.453833333,42.87036,0.061,NULL,59679942604,932499103,14570298,17.8),(132412,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132412,38.06,0.46,409,61992,70,NULL,NULL,'2MASX J15454938+2759573',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.45575,27.99936,0.073,NULL,59916865432,936201022,14628140,17.8),(132413,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132413,38.5,0.46,500,61993,70,NULL,NULL,'2MASX J15454968+1611470',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.45725,16.19656,0.061,NULL,59432134997,928627109,14509798,17.6),(132414,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132414,38.54,0.27,512,61994,70,NULL,NULL,'SDSS J154551.37+323221.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.464083,32.53936,0.073,NULL,59889297639,935770275,14621410,18.4),(132415,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132415,37.52,0.46,320,61995,70,NULL,NULL,'2MASX J15455141+2744073',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.46425,27.73533,0.061,NULL,59916826867,936200419,14628131,17.2),(132416,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132416,37.24,0.46,281,61996,70,NULL,NULL,'2MASX J15455205+4622130',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.466833,46.37033,0.037,NULL,59687199970,932612499,14572070,17),(132417,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132417,38,0.46,398,61997,70,NULL,NULL,'2MASX J15455427+0619339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.476125,6.32606,0.125,NULL,56626811379,884793927,13824905,18),(132418,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132418,38.54,0.27,512,61998,70,NULL,NULL,'SDSS J154554.71+323259.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.4779583,32.54994,0.073,NULL,59889341501,935770960,14621421,18.4),(132419,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132419,37.48,0.46,314,61999,70,NULL,NULL,'2MASX J15455481+1741320',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.478375,17.69233,0.069,NULL,59432959429,928639991,14509999,17.1),(132420,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132420,38.87,0.46,594,62000,70,NULL,NULL,'SDSS J154554.90+442740.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.4787917,44.46136,0.029,NULL,59693182209,932705972,14573530,18.4),(132421,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132421,37.24,0.46,280,62001,70,NULL,NULL,'2MASX J15455638+4302520',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.4847917,43.04783,0.049,NULL,59679761982,932496280,14570254,16.9),(132422,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132422,36.35,0.46,186,62002,70,NULL,NULL,'2MASX J15455643+4543290',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'16.48',0.51,NULL,NULL,NULL,NULL,NULL,1,236.4850417,45.72469,0.033,NULL,59690088077,932657626,14572775,16.48),(132423,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132423,37.39,0.46,300,62003,70,NULL,NULL,'2MASX J15455688+0558428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.4870417,5.97858,0.117,NULL,56618137471,884658397,13822787,18),(132424,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132424,33.96,0.56,62.1,62004,70,NULL,NULL,'ESO 042- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00007,NULL,'15.1b',0.8,'SB0',NULL,NULL,NULL,NULL,1,236.4939583,-77.10633,0.349,NULL,44233917498,691154960,10799296,15.1),(132425,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132425,35.97,0.46,156,62005,70,NULL,NULL,'2MASX J15455874+1917435',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000162,NULL,'16.94',0.3,NULL,NULL,NULL,NULL,NULL,1,236.494875,19.29539,0.117,NULL,59449853022,928903953,14514124,16.94),(132426,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132426,37.6,0.46,331,62006,70,NULL,NULL,'2MASX J15455963+5206481',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00008,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.4985417,52.11331,0.021,NULL,59717999749,933093746,14579589,16.9),(132427,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132427,36.94,0.46,244,62007,70,NULL,NULL,'2MASX J15455979+2419593',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.499333,24.33314,0.153,NULL,59399194141,928112408,14501756,17.1),(132428,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132428,37.52,0.46,320,62008,70,NULL,NULL,'2MASXi J1546008+363402',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.5035,36.56742,0.045,NULL,59880687150,935635736,14619308,17.7),(132429,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132429,37.41,0.46,303,62009,70,NULL,NULL,'2MASX J15460101+2832340',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.5042083,28.54289,0.077,NULL,59916779550,936199680,14628120,16.4),(132430,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132430,37.87,0.46,375,62010,70,NULL,NULL,'2MASX J15460301+1221588',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.5125417,12.36631,0.157,NULL,56523530842,883180169,13799690,17.3),(132431,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132431,37.66,0.46,341,62011,70,NULL,NULL,'2MASX J15460321+3217058',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.513416667,32.28492,0.077,NULL,59921468791,936272949,14629264,17.6),(132432,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132432,37.38,0.09,299,62012,70,NULL,NULL,'2MASX J15460361+3556563',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.5152083,35.94894,0.049,NULL,59891940417,935811569,14622055,17.5),(132433,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132433,37.9,0.33,380,62013,70,NULL,NULL,'2MASX J15460597+3658343',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.525,36.97608,0.037,NULL,59881423056,935647235,14619488,17.5),(132434,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132434,37.95,0.46,388,62014,70,NULL,NULL,'2MASX J15460671+1827057',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.528083333,18.45153,0.077,NULL,59446453603,928850837,14513294,17.3),(132435,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132435,37.62,0.46,334,62015,70,NULL,NULL,'2MASX J15460703+3027158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.529208333,30.45456,0.077,NULL,59922998112,936296845,14629638,17.9),(132436,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132436,37.35,0.23,295,62016,70,NULL,NULL,'2MASX J15460758+0830247',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.531625,8.50681,0.057,NULL,56595688198,884307628,13817306,16.7),(132437,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132437,35.95,0.67,155,62017,70,NULL,NULL,'2MASX J15460848-1817513',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.67',NULL,NULL,NULL,NULL,NULL,NULL,1,236.535417,-18.29767,0.497,NULL,46599300767,728114074,11376782,15.67),(132438,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132438,32.31,NULL,29,62018,72,NULL,NULL,'UGC 10023',NULL,'2014Ap.....57..457K',2014,1,1.05,NULL,'G',0.000017,NULL,'15.5g',0.52,'Im',NULL,NULL,NULL,NULL,1,236.5405,6.89847,0.057,NULL,56627094010,884798343,13824974,15.5),(132439,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132439,32.36,0.2,29.7,62019,74.4,NULL,NULL,'UGC 10023',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000017,NULL,'15.5g',0.52,'Im',NULL,NULL,NULL,NULL,1,236.5405,6.89847,0.057,NULL,56627094010,884798343,13824974,15.5),(132440,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132440,36.92,0.33,242,62020,70,NULL,NULL,'2MASX J15461019+0846017',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.542417,8.76719,0.037,NULL,56595780132,884309064,13817329,17.2),(132441,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132441,37.35,0.23,295,62021,70,NULL,NULL,'2MASX J15461034+0826457',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000175,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,236.543125,8.44594,0.057,NULL,56595682648,884307541,13817305,16.6),(132442,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132442,35.59,0.46,131,62022,70,NULL,NULL,'CGCG 136-072',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00018,NULL,'15.3g',0.44,NULL,NULL,NULL,NULL,NULL,1,236.544583,21.06636,0.137,NULL,59447142352,928861599,14513462,15.3),(132443,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132443,37.32,0.46,291,62023,70,NULL,NULL,'2MASX J15461207+1131007',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.550167,11.51678,0.113,NULL,56603381570,884427837,13819184,17),(132444,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132444,38.56,0.46,516,62024,70,NULL,NULL,'SDSS J154612.09+124844.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.550417,12.81247,0.117,NULL,56523567401,883180740,13799699,18.3),(132445,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132445,37.05,0.46,257,62025,70,NULL,NULL,'2MASX J15461569+3239458',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.5654583,32.66267,0.073,NULL,59889338621,935770915,14621420,17.1),(132446,'Sosies','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132446,33.42,0.13,48.3,62026,NULL,NULL,NULL,'NGC 5990',NULL,'2002A&A...393...57T',2002,1,1.5,NULL,'G',0.000017,NULL,'13.30',0.9,'(R\')Sa pec?;Sy2LIRG','Group member',NULL,NULL,'Sy 2',1,236.568166667,2.41542,0.293,NULL,56609095162,884517111,13820579,13.3),(132447,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132447,33.02,0.45,40.2,62026,NULL,NULL,'K','NGC 5990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132448,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132448,33.16,0.47,42.8,62026,NULL,NULL,'H','NGC 5990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132449,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132449,33.25,0.46,44.6,62026,NULL,NULL,'J','NGC 5990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132450,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132450,33.47,0.4,49.3,62026,NULL,NULL,'mean','NGC 5990',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132451,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132451,37.45,0.46,310,62027,70,NULL,NULL,'SDSS J154617.65+010224.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000065,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.5735417,1.04008,0.277,NULL,56607372527,884490195,13820159,18.2),(132452,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132452,34.34,0.8,73.9,62028,75,NULL,'CF, r','UGC 10026',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.15',0.4,'Scd:',NULL,NULL,NULL,NULL,1,236.573667,10.75853,0.113,NULL,56603866045,884435406,13819303,15.15),(132453,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132453,34.12,0.2,66.7,62028,74.4,NULL,NULL,'UGC 10026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132454,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132454,34.26,0.38,71.2,62028,75,NULL,'CF, r, raw','UGC 10026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132455,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132455,34.29,0.38,72.2,62028,75,NULL,'CF, r, inv','UGC 10026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132456,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132456,34.4,0.38,75.7,62028,75,NULL,'CF, r, cor','UGC 10026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132457,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132457,37.35,0.23,295,62029,70,NULL,NULL,'2MASX J15461770+0816237',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.573916667,8.27322,0.069,NULL,56595444555,884303821,13817247,17.3),(132458,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132458,38.1,0.23,418,62030,70,NULL,NULL,'SDSS J154617.74+292449.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000132,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.573916667,29.41378,0.081,NULL,59924941620,936327212,14630112,18.5),(132459,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132459,37.87,0.33,375,62031,70,NULL,NULL,'2MASX J15461802+1423328',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.575166667,14.39244,0.049,NULL,56536532855,883383325,13802864,17.2),(132460,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132460,37.03,0.46,255,62032,70,NULL,NULL,'SDSS J154618.67+370849.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.5777917,37.14694,0.033,NULL,59881435742,935647433,14619491,18.2),(132461,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132461,37.01,0.46,253,62033,70,NULL,NULL,'2MASX J15461983+0146538',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.5825417,1.78158,0.281,NULL,56609830566,884528602,13820759,17.5),(132462,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132462,37,0.46,251,62034,70,NULL,NULL,'2MASX J15462223-0212331',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.592625,-2.20914,0.417,NULL,45587709603,712307962,11129811,17.2),(132463,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132463,36.87,0.46,237,62035,70,NULL,NULL,'2MASX J15462241+0808537',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000186,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.5935417,8.14825,0.069,NULL,56625622707,884775354,13824614,16.6),(132464,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132464,38.23,0.46,442,62036,70,NULL,NULL,'2MASX J15462287+0554068',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.59525,5.90194,0.117,NULL,56617101696,884642214,13822534,18),(132465,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132465,38.42,0.19,483,62037,70,NULL,NULL,'SDSS J154622.86+032515.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000089,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.5952917,3.42094,0.249,NULL,56620893802,884701465,13823460,18.6),(132466,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132466,37.82,0.46,366,62038,70,NULL,NULL,'2MASX J15462288+1845327',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.9g',0.29,'E',NULL,NULL,NULL,NULL,1,236.595417,18.75897,0.093,NULL,59446608442,928853256,14513332,16.9),(132467,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132467,38.54,0.27,512,62039,70,NULL,NULL,'2MASX J15462296+3235454',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,236.595625,32.59578,0.073,NULL,59889346257,935771035,14621422,16.7),(132468,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132468,35.59,0.46,131,62040,70,NULL,NULL,'2MASX J15462324+0221338',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000079,NULL,'16.3g',0.34,'S0',NULL,NULL,NULL,NULL,1,236.596833333,2.35956,0.293,NULL,56609551476,884524241,13820691,16.3),(132469,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132469,34.12,0.8,66.8,62041,75,NULL,'HMCL, I','ESO 136- G 002',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000024,NULL,'15.0',0.4,'S;flaring disk?',NULL,NULL,NULL,NULL,1,236.598,-62.18997,NULL,NULL,44863832580,700997384,10953084,15),(132470,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132470,33.16,0.4,42.9,62041,75,NULL,'HMCL, I, raw','ESO 136- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132471,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132471,33.25,0.4,44.7,62041,75,NULL,'HMCL, I, inv','ESO 136- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132472,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132472,33.42,0.4,48.3,62041,75,NULL,'HMCL, I, cor','ESO 136- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132473,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132473,34.04,0.49,64.2,62041,75,NULL,'IR','ESO 136- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132474,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132474,36.35,0.46,186,62042,70,NULL,NULL,'2MASX J15462363+4402157',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000178,NULL,'15.9g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,236.5985,44.03772,0.013,NULL,59692490654,932695166,14573361,15.9),(132475,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132475,32.06,0.2,25.8,62043,74.4,NULL,NULL,'UGC 10025',NULL,'2013AJ....146...86T',2013,1,1.15,NULL,'G',0.000007,NULL,'17.',0.12,'Sdm',NULL,NULL,NULL,NULL,1,236.6009583,2.84422,0.265,NULL,56609198278,884518723,13820605,17),(132476,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132476,32.59,NULL,32.9,62043,72,NULL,NULL,'UGC 10025',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132477,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132477,32.84,NULL,36.9,62043,NULL,NULL,NULL,'UGC 10025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132478,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132478,32.86,NULL,37.3,62043,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132479,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132479,32.88,NULL,37.7,62043,NULL,NULL,'Dipole + Quadrupole','UGC 10025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132480,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132480,32.88,NULL,37.8,62043,NULL,NULL,'Dipole','UGC 10025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132481,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132481,38.42,0.19,483,62044,70,NULL,NULL,'2MASX J15462459+0325008',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'FoF','17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.602333,3.41686,0.249,NULL,56620893737,884701464,13823460,17.5),(132482,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132482,35.73,0.33,140,62045,70,NULL,NULL,'CGCG 166-054 NED01',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.17,'S0^-',NULL,NULL,NULL,NULL,1,236.602417,30.267,0.077,NULL,59922492808,936288950,14629514,17.5),(132483,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132483,37.75,0.46,354,62046,70,NULL,NULL,'2MASX J15462513+0414398',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,236.6047917,4.24447,0.185,NULL,56620514385,884695537,13823367,18.3),(132484,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132484,33.7,NULL,55.1,62047,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10027',NULL,'2010Ap&SS.325..163P',2010,1,1.22,NULL,'G',0.000238,NULL,'16.0',0.11,'Scd',NULL,NULL,NULL,NULL,1,236.6065,4.42764,0.185,NULL,56616080865,884626263,13822285,16),(132485,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132485,33.73,NULL,55.6,62047,NULL,NULL,'Dipole + Quadrupole','UGC 10027',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132486,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132486,33.73,NULL,55.8,62047,NULL,NULL,'Dipole','UGC 10027',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132487,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132487,38.1,0.23,418,62048,70,NULL,NULL,'2MASX J15462595+2929340',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.608208333,29.493,0.081,NULL,59924415171,936318987,14629984,18.1),(132488,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132488,37.87,0.33,375,62049,70,NULL,NULL,'2MASX J15462663+1425047',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.6110417,14.41806,0.049,NULL,56536531712,883383308,13802864,NULL),(132489,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132489,37.22,0.46,278,62050,70,NULL,NULL,'2MASX J15462700+0815299',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.612666667,8.25811,0.069,NULL,56595393825,884303028,13817234,17.6),(132490,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132490,38.38,0.46,475,62051,70,NULL,NULL,'SDSS J154628.54+314505.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.6189583,31.75153,0.073,NULL,59921893799,936279590,14629368,18.1),(132491,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132491,37.58,0.33,328,62052,70,NULL,NULL,'2MASX J15462944+3547295',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000127,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.622625,35.79142,0.045,NULL,59891952056,935811750,14622058,17.1),(132492,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132492,35.54,0.2,128,62053,74.4,NULL,NULL,'CGCG 078-066',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000397,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,236.6235,12.35178,0.137,NULL,56523549714,883180464,13799694,15.7),(132493,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132493,35.79,0.4,144,62054,NULL,NULL,'mean','CGCG 166-055',NULL,'2007A&A...465...71T',2007,1,0.99,NULL,'G',0.000063,NULL,'14.9g',0.45,'SBb',NULL,NULL,NULL,NULL,1,236.624958333,32.11728,0.081,NULL,59921526020,936273844,14629278,14.9),(132494,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132494,36.2,0.45,173,62054,NULL,NULL,'K','CGCG 166-055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132495,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132495,36.2,0.47,173,62054,NULL,NULL,'H','CGCG 166-055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132496,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132496,36.21,0.2,175,62054,74.4,NULL,NULL,'CGCG 166-055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132497,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132497,35.73,0.33,140,62055,70,NULL,NULL,'2MASX J15463020+3018465',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000161,NULL,'16.1g',0.4,'S0',NULL,NULL,NULL,NULL,1,236.626,30.31281,0.077,NULL,59922497074,936289016,14629515,16.1),(132498,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132498,33.15,0.8,42.7,62056,75,NULL,'B','MRK 0490',NULL,'1988NBGC.C....0000T',1988,1,0.39,NULL,'G',0.000009,NULL,'15.2g',0.35,'NELG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,236.627958333,45.99828,0.029,NULL,59690098137,932657783,14572777,15.2),(132499,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132499,37.67,0.46,341,62057,70,NULL,NULL,'2MASX J15463192+1016079',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.633208333,10.26883,0.113,NULL,56605964698,884468198,13819815,18.2),(132500,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132500,37.35,0.23,295,62058,70,NULL,NULL,'2MASX J15463212+0831369',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000201,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.6337917,8.52689,0.037,NULL,56595709478,884307960,13817311,16.7),(132501,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132501,37.82,0.33,367,62059,70,NULL,NULL,'2MASX J15463366+1737487',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000121,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.640375,17.63036,0.085,NULL,59432909503,928639210,14509987,17.8),(132502,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132502,38.06,0.46,410,62060,70,NULL,NULL,'2MASX J15463386+3439175',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.6412083,34.65497,0.061,NULL,59892267138,935816674,14622135,17.3),(132503,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132503,37.37,0.46,298,62061,70,NULL,NULL,'2MASX J15463396+2012147',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.641416667,20.20397,0.141,NULL,59447618274,928869035,14513578,17.8),(132504,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132504,37.6,0.33,331,62062,70,NULL,NULL,'2MASX J15463410+2924008',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'17.1g',0.22,'E',NULL,NULL,NULL,NULL,1,236.642125,29.40019,0.081,NULL,59924090858,936313919,14629904,17.1),(132505,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132505,37.82,0.33,367,62063,70,NULL,NULL,'2MASX J15463457+1738497',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.6442083,17.64731,0.085,NULL,59432909713,928639214,14509987,17.3),(132506,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132506,34.91,NULL,95.9,62064,NULL,NULL,'Dipole + Quadrupole','FGCE 1224',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.000053,NULL,'16.8',0.1,'Scd',NULL,NULL,NULL,NULL,1,236.650417,-21.13194,0.693,NULL,46634468033,728663563,11385368,16.8),(132507,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132507,34.91,NULL,95.9,62064,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132508,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132508,34.92,NULL,96.5,62064,NULL,NULL,'Dipole','FGCE 1224',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132509,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132509,34.98,NULL,99.2,62064,NULL,NULL,NULL,'FGCE 1224',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132510,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132510,37.14,0.33,268,62065,70,NULL,NULL,'2MASX J15463669+4631587',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000202,NULL,'15.7g',0.5,'E0',NULL,NULL,NULL,NULL,1,236.652833,46.53303,0.037,NULL,59689159160,932643111,14572548,15.7),(132511,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132511,37.29,0.46,287,62066,70,NULL,NULL,'2MASX J15463693+0628399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.65375,6.47775,0.133,NULL,56627013345,884797083,13824954,17.3),(132512,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132512,36.68,0.53,217,62067,70,NULL,NULL,'2MASX J15463693-0434251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.97',NULL,NULL,NULL,NULL,NULL,NULL,1,236.6540417,-4.57364,0.529,NULL,45591040564,712360008,11130625,16.97),(132513,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132513,38.14,0.33,425,62068,70,NULL,NULL,'SDSS J154637.03+034131.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.654333,3.69217,0.217,NULL,56620766984,884699484,13823429,18.2),(132514,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132514,37.37,0.46,298,62069,70,NULL,NULL,'2MASX J15463763+3509255',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,236.656667,35.15722,0.057,NULL,59892329274,935817644,14622150,16.9),(132515,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132515,37.51,0.46,318,62070,70,NULL,NULL,'2MASX J15463765-0013141',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.656917,-0.22067,0.261,NULL,45516846518,711200726,11112511,17.2),(132516,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132516,37.58,0.33,328,62071,70,NULL,NULL,'2MASX J15463807+3547015',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00011,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.658833,35.78375,0.045,NULL,59891951636,935811744,14622058,17.7),(132517,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132517,38.42,0.19,483,62072,70,NULL,NULL,'2MASX J15463897+0325546',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.6622917,3.43167,0.249,NULL,56620302372,884692224,13823316,17.5),(132518,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132518,38.49,0.33,500,62073,70,NULL,NULL,'2MASX J15463908+5455296',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.663,54.92492,0,NULL,57584119578,899751868,14058622,17.8),(132519,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132519,37.93,0.46,386,62074,70,NULL,NULL,'2MASX J15463932+0815309',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.663875,8.25867,0.057,NULL,56625600986,884775015,13824609,17.1),(132520,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132520,38.42,0.19,483,62075,70,NULL,NULL,'SDSS J154641.31+031529.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000076,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.672125,3.25831,0.261,NULL,56620392772,884693637,13823338,18.9),(132521,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132521,38.37,0.33,473,62076,70,NULL,NULL,'SDSS J154641.82+052407.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.67425,5.40217,0.109,NULL,56617142019,884642844,13822544,17.9),(132522,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132522,37.25,0.46,282,62077,70,NULL,NULL,'2MASX J15464193+1248247',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.674666667,12.807,0.125,NULL,56537313231,883395519,13803054,18.1),(132523,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132523,36.92,0.33,242,62078,70,NULL,NULL,'2MASX J15464264+0846339',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,236.677583,8.77611,0.049,NULL,56595742782,884308480,13817320,16.2),(132524,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132524,38.14,0.33,425,62079,70,NULL,NULL,'2MASX J15464431+0341556',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.684625,3.69889,0.249,NULL,56620795934,884699936,13823436,17.2),(132525,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132525,38.12,0.46,422,62080,70,NULL,NULL,'2MASX J15464466+5559096',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.6860417,55.98606,0.049,NULL,57641169090,900643267,14072551,17.3),(132526,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132526,36.97,0.46,247,62081,70,NULL,NULL,'2MASX J15464498+0953159',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.687416667,9.88786,0.133,NULL,56602958971,884421233,13819081,16.8),(132527,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132527,38.51,0.46,504,62082,70,NULL,NULL,'SDSS J154645.16+443323.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000156,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,236.688167,44.55639,0.041,NULL,59693320103,932708126,14573564,18.6),(132528,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132528,37.7,0.16,347,62083,70,NULL,NULL,'2MASX J15464576+2758098',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000195,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.690875,27.96944,0.073,NULL,59871692666,935495197,14617112,17),(132529,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132529,37.44,0.46,308,62084,70,NULL,NULL,'2MASX J15464588+2601468',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.2g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,236.6910417,26.02975,0.157,NULL,59873675903,935526185,14617596,17.2),(132530,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132530,37.23,0.46,279,62085,70,NULL,NULL,'2MASX J15464982+4702147',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000196,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,236.707583,47.03747,0.065,NULL,59719610479,933118913,14579983,16.1),(132531,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132531,35.97,0.66,156,62086,70,NULL,NULL,'2MASX J15465092-0237251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.71225,-2.62361,0.441,NULL,45585118547,712267477,11129179,15.2),(132532,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132532,37.14,0.33,268,62087,70,NULL,NULL,'2MASX J15465113+4630357',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.713167,46.51003,0.037,NULL,59689157889,932643092,14572548,17),(132533,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132533,36.57,0.46,206,62088,70,NULL,NULL,'2MASX J15465227+1836171',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00017,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,236.717667,18.60481,0.085,NULL,59446643169,928853799,14513340,16.6),(132534,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132534,37.74,0.46,353,62089,70,NULL,NULL,'2MASX J15465227-0043111',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.7177083,-0.71967,0.293,NULL,45583841042,712247516,11128867,17.8),(132535,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132535,36.41,0.58,192,62090,70,NULL,NULL,'2MASX J15465302-0333291',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.70',NULL,NULL,NULL,NULL,NULL,NULL,1,236.721083333,-3.55808,0.501,NULL,45599188270,712487316,11132614,16.7),(132536,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132536,38.49,0.33,500,62091,70,NULL,NULL,'2MASX J15465348+5457065',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000601,NULL,'17.7g',0.17,'AGN2',NULL,NULL,NULL,'Sy 2',1,236.7230417,54.95186,0,NULL,57584085814,899751340,14058614,17.7),(132537,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132537,37.7,0.16,347,62092,70,NULL,NULL,'2MASX J15465406+2756598',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.72525,27.94986,0.073,NULL,59871692055,935495188,14617112,17.7),(132538,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132538,38.06,0.33,409,62093,70,NULL,NULL,'2MASX J15465434+0232136',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.726375,2.53722,0.309,NULL,56609577927,884524655,13820697,18.3),(132539,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132539,38.61,0.33,527,62094,70,NULL,NULL,'SDSS J154654.65+115442.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.72775,11.91183,0.109,NULL,56603226784,884425418,13819147,17.9),(132540,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132540,38.37,0.33,473,62095,70,NULL,NULL,'2MASX J15465521+0517586',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.730167,5.29964,0.109,NULL,56617482085,884648157,13822627,17.7),(132541,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132541,37.98,0.46,395,62096,70,NULL,NULL,'2MASX J15465810+3035108',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.742167,30.58639,0.073,NULL,59923214144,936300221,14629690,17.5),(132542,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132542,38.06,0.33,409,62097,70,NULL,NULL,'2MASX J15465841+0235386',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000103,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.743333,2.59406,0.309,NULL,56609098701,884517167,13820580,17.6),(132543,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132543,32.66,0.8,34.1,62098,75,NULL,'MAT, I','NGC 5967A',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'12.61',1.3,'SB(rs+)bc:','in a pair',NULL,NULL,NULL,1,236.744667,-75.78744,0.281,NULL,44114580972,689290327,10770161,12.61),(132544,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132544,32.21,0.32,27.7,62098,85,NULL,'I, raw','NGC 5967A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132545,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132545,32.21,0.32,27.7,62098,85,NULL,'I, inv','NGC 5967A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132546,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132546,32.7,0.43,34.7,62098,75,NULL,'MAT, I, raw','NGC 5967A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132547,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132547,32.77,0.43,35.8,62098,75,NULL,'MAT, I, inv','NGC 5967A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132548,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132548,32.91,0.43,38.1,62098,75,NULL,'MAT, I, cor','NGC 5967A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132549,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132549,37.7,0.16,347,62099,70,NULL,NULL,'2MASX J15465889+2748448',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.745333,27.81258,0.073,NULL,59871708334,935495442,14617116,17.2),(132550,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132550,32.54,0.69,32.2,62100,100,NULL,'mid-IR','NGC 5996',NULL,'2013ApJ...771...88L',2013,1,1.58,'Incorrectly called NGC 5994 in 1976ApJS...31..187D.','G',0.000007,NULL,'13.4g',0.69,'SBc;WR?;HII    Sbrst','Possible field galaxy',NULL,NULL,'Starburst',1,236.745333,17.88419,0.057,NULL,59429473893,928585529,14509148,13.4),(132551,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132551,32.99,0.47,39.6,62100,NULL,NULL,'H','NGC 5996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132552,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132552,33.09,0.46,41.5,62100,NULL,NULL,'J','NGC 5996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132553,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132553,33.12,0.45,42.1,62100,NULL,NULL,'K','NGC 5996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132554,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132554,33.26,0.4,44.8,62100,NULL,NULL,'mean','NGC 5996',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132555,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132555,38.75,0.46,561,62101,70,NULL,NULL,'2MASX J15465922+1748292',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.74675,17.80825,0.057,NULL,59429486071,928585719,14509151,18.2),(132556,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132556,34.9,0.17,92.7,62102,74.2,NULL,'SALT 2','UGC 10030',0.029864,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000023,NULL,'15.03',1,'SB(s)b pec:    HII',NULL,NULL,NULL,NULL,1,236.75175,-0.98514,0.301,NULL,45584588693,712259198,11129049,15.03),(132557,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132557,35.36,0.2,115,62102,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 10030',0.029864,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132558,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132558,35.46,0.04,120,62102,72,NULL,'SALT','UGC 10030',0.029864,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132559,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132559,35.53,0.16,124,62102,70,NULL,'SALT 2','UGC 10030',0.029864,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132560,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132560,35.47,0.09,124,62102,74.4,NULL,NULL,'UGC 10030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132561,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132561,35.66,0.17,132,62102,65,NULL,'SALT','UGC 10030',0.029864,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132562,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132562,35.75,0.17,137,62102,65,NULL,'MLCS17','UGC 10030',0.029864,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132563,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132563,35.76,0.19,138,62102,65,NULL,'SALT2','UGC 10030',0.029864,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132564,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2002ck',NULL,132564,35.77,0.17,138,62102,65,NULL,'MLCS31','UGC 10030',0.029864,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132565,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132565,35.04,0.47,102,62102,NULL,NULL,'H','UGC 10030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132566,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132566,35.24,0.45,112,62102,NULL,NULL,'K','UGC 10030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132567,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132567,35.25,0.46,112,62102,NULL,NULL,'J','UGC 10030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132568,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132568,35.46,0.4,124,62102,NULL,NULL,'mean','UGC 10030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132569,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132569,38.1,0.23,418,62103,70,NULL,NULL,'2MASX J15470112+2930208',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000157,NULL,'16.4g',0.4,'BrClG;E',NULL,NULL,NULL,NULL,1,236.75475,29.50567,0.085,NULL,59922779327,936293426,14629584,16.4),(132570,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132570,39.69,0.46,867,62104,70,NULL,NULL,'2MASX J15470110+0515252',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000199,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.7547917,5.25692,0.109,NULL,56617478318,884648098,13822626,18.3),(132571,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132571,38.11,0.46,418,62105,70,NULL,NULL,'2MASX J15470162+2010071',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.756667,20.16867,0.141,NULL,59447644178,928869440,14513585,18.1),(132572,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132572,38.53,0.46,508,62106,70,NULL,NULL,'SDSS J154701.68+140240.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,236.757,14.04461,0.069,NULL,56538385468,883412272,13803316,NULL),(132573,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132573,38.14,0.46,425,62107,70,NULL,NULL,'2MASX J15470191+1441063',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.758083333,14.68506,0.057,NULL,56537104863,883392263,13803004,17.7),(132574,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132574,37.84,0.33,369,62108,70,NULL,NULL,'SDSS J154702.83+060027.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.761833333,6.00753,0.101,NULL,56617121648,884642525,13822539,18.7),(132575,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132575,37.84,0.33,369,62109,70,NULL,NULL,'2MASX J15470291+0603316',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.762083,6.05892,0.125,NULL,56617122397,884642537,13822539,16.8),(132576,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132576,38.36,0.46,470,62110,70,NULL,NULL,'2MASX J15470329+2943228',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.7637083,29.72303,0.093,NULL,59922574808,936290231,14629534,17.9),(132577,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132577,37.7,0.16,347,62111,70,NULL,NULL,'2MASX J15470365+2759198',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.765375,27.98889,0.073,NULL,59871694320,935495223,14617112,16.7),(132578,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132578,38.21,0.33,438,62112,70,NULL,NULL,'2MASX J15470396+1212223',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.7664583,12.20633,0.157,NULL,56598987371,884359177,13818112,16.7),(132579,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132579,38.21,0.33,438,62113,70,NULL,NULL,'2MASX J15470423+1213203',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.767667,12.22244,0.157,NULL,56528733136,883261455,13800960,17.9),(132580,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132580,38.27,0.46,450,62114,70,NULL,NULL,'2MASX J15470499+0609276',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.770667,6.15767,0.133,NULL,56624709258,884761082,13824391,17.8),(132581,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132581,37.22,0.46,279,62115,70,NULL,NULL,'2MASX J15470533+1429433',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.7722917,14.4955,0.049,NULL,56536899583,883389055,13802953,17.2),(132582,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132582,38.61,0.33,527,62116,70,NULL,NULL,'2MASX J15470656+1151436',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.777333333,11.86203,0.109,NULL,56603217893,884425279,13819144,18.3),(132583,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132583,38.1,0.23,418,62117,70,NULL,NULL,'2MASX J15470719+2930101',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.7800417,29.50281,0.085,NULL,59922777492,936293398,14629584,18.1),(132584,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132584,37.31,0.46,289,62118,70,NULL,NULL,'SDSS J154707.73+040435.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.1g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.7822083,4.07656,0.185,NULL,56620704917,884698514,13823414,18.1),(132585,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132585,38.1,0.46,416,62119,70,NULL,NULL,'2MASX J15470812+3210229',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.784,32.173,0.077,NULL,59921521474,936273773,14629277,17.9),(132586,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132586,37.06,0.46,258,62120,70,NULL,NULL,'2MASX J15470874+2027183',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000164,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,236.786333,20.45514,0.145,NULL,59447538065,928867782,14513559,16.4),(132587,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132587,37.6,0.33,331,62121,70,NULL,NULL,'2MASX J15470883+2915302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.786875,29.25839,0.077,NULL,59922059332,936282177,14629409,17.3),(132588,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132588,37.52,0.46,319,62122,70,NULL,NULL,'MCG +06-35-006',NULL,'2015arXiv151105856S',2015,1,0.67,'One of two 6cm sources associated with [WB92] 1545+3541','G',0.000097,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,236.788417,35.64617,0.045,NULL,59892463278,935819738,14622183,15.7),(132589,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132589,37.2,0.46,276,62123,70,NULL,NULL,'2MASX J15470984+2611222',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.790917,26.18956,0.161,NULL,59873599738,935524995,14617578,17.2),(132590,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132590,38.48,0.46,496,62124,70,NULL,NULL,'2MASX J15470988+1024206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.791125,10.40578,0.117,NULL,56605850319,884466411,13819787,18.3),(132591,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132591,37.44,0.46,307,62125,70,NULL,NULL,'2MASX J15471068+0517562',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000168,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,236.794625,5.29911,0.109,NULL,56617476836,884648075,13822626,17.1),(132592,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132592,38.08,0.46,414,62126,70,NULL,NULL,'2MASX J15471092+1745194',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.795625,17.75544,0.085,NULL,59429481405,928585646,14509150,17.8),(132593,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132593,32.07,NULL,25.9,62127,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 450- G 014',NULL,'2010Ap&SS.325..163P',2010,1,1.48,NULL,'G',0.000017,NULL,'16.31',0.2,'Sd',NULL,NULL,NULL,NULL,1,236.800417,-28.77389,0.597,NULL,47173380464,737084069,11516938,16.31),(132594,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132594,32.1,NULL,26.3,62127,NULL,NULL,'Dipole + Quadrupole','ESO 450- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132595,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132595,32.12,NULL,26.6,62127,NULL,NULL,'Dipole','ESO 450- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132596,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132596,37.17,0.46,271,62128,70,NULL,NULL,'2MASX J15471329+1217034',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.805291667,12.28442,0.137,NULL,56528734377,883261474,13800960,17.1),(132597,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132597,37.41,0.46,303,62129,70,NULL,NULL,'SDSS J154713.61+180211.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.80675,18.03644,0.041,NULL,59429607353,928587614,14509181,18),(132598,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132598,37.63,0.46,335,62130,70,NULL,NULL,'2MASX J15471422+4306545',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.809375,43.11517,0.049,NULL,59677928729,932467636,14569806,17.2),(132599,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132599,36.93,0.46,244,62131,70,NULL,NULL,'2MASX J15471428+4852352',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.809417,48.87639,0.089,NULL,59726494936,933226483,14581663,17.5),(132600,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132600,37.85,0.46,371,62132,70,NULL,NULL,'SDSS J154715.02+372929.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000142,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,236.812625,37.49147,0.037,NULL,59881519746,935648746,14619511,18.6),(132601,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132601,38.42,0.19,483,62133,70,NULL,NULL,'2MASX J15471612+0310222',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,236.817,3.17297,0.261,NULL,56620440354,884694380,13823349,18.5),(132602,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132602,35.29,0.6,114,62134,70,NULL,NULL,'2MASX J15471612-7314560',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,236.817333,-73.24889,0.369,NULL,44997764213,703090065,10985782,16.6),(132603,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132603,35.51,0.46,126,62135,70,NULL,NULL,'CGCG 050-103',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000097,NULL,'15.4g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,236.824917,2.95683,0.261,NULL,56608977759,884515277,13820551,15.4),(132604,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132604,38.38,0.46,475,62136,70,NULL,NULL,'SDSS J154718.61+493125.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000183,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.827583,49.52381,0.049,NULL,59726681277,933229394,14581709,18.4),(132605,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132605,37.74,0.27,353,62137,70,NULL,NULL,'2MASX J15471886+1201405',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,236.828625,12.02781,0.113,NULL,56599045677,884360088,13818126,16.9),(132606,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132606,37.33,0.46,292,62138,70,NULL,NULL,'2MASX J15471916+1727095',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.829917,17.45264,0.073,NULL,59429763313,928590051,14509219,16.9),(132607,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132607,36.5,0.2,200,62139,74.4,NULL,NULL,'CGCG 136-077',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000076,NULL,'15.5g',0.44,'S',NULL,NULL,NULL,NULL,1,236.8315,21.53111,0.129,NULL,59401878360,928154349,14502411,15.5),(132608,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132608,37.05,0.46,257,62140,70,NULL,NULL,'2MASX J15471960+1647235',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',NULL,NULL,'16.96',0.35,NULL,NULL,NULL,NULL,NULL,1,236.831875,16.78986,0.061,NULL,59432549118,928633579,14509899,16.96),(132609,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132609,37.48,0.46,314,62141,70,NULL,NULL,'2MASX J15471966+1718165',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000175,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.832083,17.30456,0.057,NULL,59432623391,928634740,14509917,17.5),(132610,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132610,38.42,0.19,483,62142,70,NULL,NULL,'SDSS J154720.92+031038.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000083,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.8372083,3.17747,0.261,NULL,56620262970,884691608,13823306,18.8),(132611,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132611,36.87,0.46,237,62143,70,NULL,NULL,'2MASX J15472104+2955132',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.83775,29.92019,0.085,NULL,59922537406,936289646,14629525,16.9),(132612,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132612,37.7,0.16,347,62144,70,NULL,NULL,'2MASX J15472215+2755462',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000193,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.8424583,27.92958,0.073,NULL,59871828109,935497314,14617145,17),(132613,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132613,37.06,0.46,258,62145,70,NULL,NULL,'2MASX J15472232+0823275',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.843,8.39089,0.041,NULL,56625267750,884769808,13824528,16.8),(132614,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132614,38.69,0.46,546,62146,70,NULL,NULL,'2MASX J15472310+1257235',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.846417,12.95664,0.121,NULL,56537290814,883395168,13803049,17.6),(132615,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132615,37.69,0.46,345,62147,70,NULL,NULL,'2MASX J15472375+3300579',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000228,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.849,33.01614,0.069,NULL,59889206717,935768854,14621388,17.4),(132616,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132616,37.97,0.46,394,62148,70,NULL,NULL,'2MASX J15472391+2050493',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.8497917,20.847,0.141,NULL,59447064620,928860384,14513443,17.2),(132617,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132617,36.02,0.46,160,62149,70,NULL,NULL,'CGCG 078-072',NULL,'2015arXiv151105856S',2015,1,0.7,'Star 20\\\" to the northwest.','G',0.00007,NULL,'15.6',0.23,'Sa','Isolated galaxy',NULL,NULL,NULL,1,236.859583,10.28272,0.113,NULL,56602634224,884416159,13819002,15.6),(132618,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132618,38.1,0.33,416,62150,70,NULL,NULL,'2MASX J15472629+2745022',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.8597917,27.75069,0.061,NULL,59871681862,935495029,14617109,17.3),(132619,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132619,38.09,0.46,414,62151,70,NULL,NULL,'2MASX J15472642+0604582',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,236.860125,6.08283,0.101,NULL,56617222379,884644099,13822564,17.8),(132620,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132620,37.52,0.46,319,62152,70,NULL,NULL,'2MASX J15472684+3250419',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.861875,32.84506,0.069,NULL,59889192093,935768626,14621384,17.2),(132621,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132621,38.25,0.33,446,62153,70,NULL,NULL,'2MASX J15472742+0839537',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000156,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,236.864458333,8.66494,0.049,NULL,56594986144,884296658,13817135,18.7),(132622,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132622,36.2,0.46,174,62154,70,NULL,NULL,'NGC 5997',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000113,NULL,'15.3g',0.57,'E0',NULL,NULL,NULL,NULL,1,236.8652917,8.32119,0.049,NULL,56626129475,884783273,13824738,15.3),(132623,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132623,36.86,0.2,236,62155,74.4,NULL,NULL,'CGCG 166-057',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000171,NULL,'15.6g',0.41,NULL,NULL,NULL,NULL,NULL,1,236.871833333,32.01517,0.077,NULL,59921605543,936275086,14629298,15.6),(132624,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132624,37.03,0.46,255,62156,70,NULL,NULL,'2MASX J15472958+1456568',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,236.8732917,14.94917,0.089,NULL,56536964075,883390063,13802969,16.5),(132625,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132625,37.83,0.46,368,62157,70,NULL,NULL,'SDSS J154729.69+231844.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.87375,23.31242,0.157,NULL,59398868277,928107316,14501676,18.2),(132626,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132626,37.7,0.16,347,62158,70,NULL,NULL,'2MASX J15473143+2801512',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000234,NULL,'16.2g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,236.8810417,28.03072,0.073,NULL,59871824020,935497250,14617144,16.2),(132627,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132627,37.17,0.46,272,62159,70,NULL,NULL,'SDSS J154732.40+063055.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.8850417,6.51539,0.113,NULL,56624839002,884763109,13824423,18.1),(132628,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132628,37.95,0.33,389,62160,70,NULL,NULL,'2MASX J15473347+1840233',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.889333333,18.67308,0.093,NULL,59446597030,928853078,14513329,17.7),(132629,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132629,36.87,0.46,236,62161,70,NULL,NULL,'2MASX J15473357+2948342',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000158,NULL,'16.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,236.8899583,29.8095,0.093,NULL,59922544201,936289753,14629527,16.6),(132630,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132630,34.94,0.65,97.4,62162,70,NULL,NULL,'2MASX J15473422-3050416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,236.892625,-30.84494,0.565,NULL,47168299880,737004685,11515698,14.6),(132631,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132631,35.45,0.48,123,62163,70,NULL,NULL,'IC 1136',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000067,NULL,'15.4',0.6,NULL,NULL,NULL,NULL,NULL,1,236.8932917,-1.54528,0.397,NULL,45587209862,712300154,11129689,15.4),(132632,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132632,38.5,0.46,502,62164,70,NULL,NULL,'SDSS J154734.41+543951.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.893416667,54.66428,0.009,NULL,57584577111,899759017,14058734,18.1),(132633,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132633,38.1,0.46,417,62165,70,NULL,NULL,'SDSS J154734.64+041951.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,236.894375,4.331,0.221,NULL,56622608671,884728260,13823879,18.7),(132634,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132634,37.7,0.16,347,62166,70,NULL,NULL,'2MASX J15473504+2748262',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000179,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,236.8962083,27.80731,0.073,NULL,59871797388,935496834,14617138,16.1),(132635,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132635,37.26,0.46,283,62167,70,NULL,NULL,'2MASX J15473533+5548382',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.897583333,55.81086,0.041,NULL,57640696915,900635889,14072435,17.3),(132636,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132636,35.73,0.2,140,62168,74.4,NULL,NULL,'UGC 10035',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000033,NULL,'14.6g',0.58,'S?             HII',NULL,NULL,NULL,NULL,1,236.901375,26.06378,0.161,NULL,59873639957,935525624,14617587,14.6),(132637,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132637,37.79,0.46,361,62169,70,NULL,NULL,'2MASX J15473677+1311479',NULL,'2015arXiv151105856S',2015,1,0.19,'TXS codes: lobes(W)','G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.90325,13.19669,0.121,NULL,56538144027,883408500,13803257,18),(132638,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132638,37.48,0.46,313,62170,70,NULL,NULL,'2MASX J15473785+1949357',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000135,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.907667,19.82678,0.129,NULL,59449784310,928902879,14514107,17.7),(132639,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132639,38.25,0.33,446,62171,70,NULL,NULL,'SDSS J154740.51+084205.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,236.9187917,8.70147,0.049,NULL,56594952868,884296138,13817127,18.3),(132640,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132640,36.48,0.46,198,62172,70,NULL,NULL,'2MASX J15474122+3538233',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000156,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,236.921583,35.63986,0.049,NULL,59892484301,935820067,14622188,16.6),(132641,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132641,37.34,0.46,293,62173,70,NULL,NULL,'2MASX J15474138+5237021',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,236.9224583,52.61719,0.021,NULL,59714819341,933044052,14578813,16.8),(132642,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132642,37.45,0.46,309,62174,70,NULL,NULL,'SDSS J154741.59+414950.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000132,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.923333,41.83078,0.065,NULL,59680439191,932506862,14570419,17.8),(132643,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132643,36.55,0.23,205,62175,70,NULL,NULL,'2MASX J15474214+1212189',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.9254583,12.20517,0.093,NULL,56599023666,884359744,13818121,17),(132644,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132644,36.87,0.46,236,62176,70,NULL,NULL,'2MASX J15474248+1133316',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.9269583,11.55889,0.105,NULL,56599067751,884360433,13818131,16.8),(132645,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132645,36.59,0.46,208,62177,70,NULL,NULL,'2MASX J15474248+4536511',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,236.927,45.61436,0.033,NULL,59690167122,932658861,14572794,16.9),(132646,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132646,38.55,0.46,512,62178,70,NULL,NULL,'2MASX J15474245+1317169',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,236.9270417,13.28797,0.121,NULL,56538151991,883408624,13803259,18.1),(132647,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132647,37.15,0.46,269,62179,70,NULL,NULL,'2MASX J15474450+0901046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000199,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.9352917,9.01794,0.065,NULL,56595038010,884297468,13817147,16.6),(132648,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132648,37.92,0.46,384,62180,70,NULL,NULL,'2MASX J15474499+5441111',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,236.9372917,54.68656,0.013,NULL,57584522772,899758168,14058721,17.3),(132649,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132649,38.07,0.33,412,62181,70,NULL,NULL,'2MASX J15474627+0258592',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.2g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,236.942833,2.98317,0.317,NULL,56608954163,884514908,13820545,16.2),(132650,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132650,36.55,0.23,205,62182,70,NULL,NULL,'2MASX J15474686+1150146',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000093,NULL,'17.26',0.45,'AGN',NULL,NULL,NULL,NULL,1,236.945167,11.83747,0.109,NULL,56599222765,884362855,13818169,17.26),(132651,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132651,37.38,0.46,300,62183,70,NULL,NULL,'2MASX J15474752+1854468',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.947875,18.91311,0.093,NULL,59446562892,928852545,14513321,17.4),(132652,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132652,37.74,0.27,353,62184,70,NULL,NULL,'2MASX J15474780+1210109',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.949291667,12.16975,0.093,NULL,56599027295,884359801,13818121,17.6),(132653,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132653,37.32,0.46,291,62185,70,NULL,NULL,'2MASX J15474870+3331353',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00014,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.9529583,33.52642,0.073,NULL,59889056857,935766513,14621351,17.5),(132654,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132654,36.71,0.46,220,62186,70,NULL,NULL,'2MASX J15474890+3701359',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,236.9537083,37.02672,0.037,NULL,59880335465,935630241,14619222,16.4),(132655,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132655,38.28,0.46,453,62187,70,NULL,NULL,'SDSS J154750.28+533752.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.9595,53.63117,0.013,NULL,59668349209,932317956,14567468,18.3),(132656,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132656,38.15,0.46,427,62188,70,NULL,NULL,'2MASX J15475061+0603362',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.9610417,6.06011,0.109,NULL,56617231860,884644247,13822566,18.1),(132657,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132657,36.55,0.23,205,62189,70,NULL,NULL,'2MASX J15475066+1220510',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,236.96125,12.3475,0.093,NULL,56528796742,883262449,13800975,16.2),(132658,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132658,37.62,0.46,335,62190,70,NULL,NULL,'2MASX J15475094+0812196',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,236.9622083,8.20547,0.049,NULL,56626168664,884783885,13824748,17.2),(132659,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132659,37.74,0.27,353,62191,70,NULL,NULL,'2MASX J15475217+1211270',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.9675417,12.19092,0.093,NULL,56599027131,884359798,13818121,17.4),(132660,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132660,37.19,0.46,274,62192,70,NULL,NULL,'2MASX J15475318+2357426',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000191,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,236.9715,23.96181,0.149,NULL,59399080190,928110627,14501728,17.9),(132661,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132661,36.56,0.2,205,62193,74.4,NULL,NULL,'CGCG 136-080',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000172,NULL,'15.5g',0.3,'S',NULL,NULL,NULL,NULL,1,236.9752917,25.72956,0.161,NULL,59873546827,935524169,14617565,15.5),(132662,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132662,37.58,0.46,328,62194,70,NULL,NULL,'2MASX J15475455+5319302',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,236.9772917,53.32506,0.033,NULL,59668301180,932317205,14567456,17.5),(132663,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132663,37.93,0.33,385,62195,70,NULL,NULL,'2MASX J15475484+0542322',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,236.978333,5.70903,0.105,NULL,56617814281,884653348,13822708,17.8),(132664,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132664,38.1,0.33,416,62196,70,NULL,NULL,'2MASX J15475552+2754556',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,236.981375,27.91544,0.081,NULL,59871852723,935497698,14617151,17.7),(132665,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132665,36.56,0.46,205,62197,70,NULL,NULL,'2MASX J15475582+1621580',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.34',0.24,NULL,NULL,NULL,NULL,NULL,1,236.982541667,16.36614,0.093,NULL,59431485826,928616966,14509640,17.34),(132666,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132666,37.24,0.46,281,62198,70,NULL,NULL,'2MASX J15475615+0235102',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,236.983875,2.58614,0.325,NULL,56609721100,884526892,13820732,18),(132667,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132667,36.98,0.46,249,62199,70,NULL,NULL,'2MASX J15475666+1752158',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'17.44',0.25,NULL,NULL,NULL,NULL,NULL,1,236.9862917,17.87114,0.057,NULL,59429439951,928584999,14509140,17.44),(132668,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132668,37.95,0.33,389,62200,70,NULL,NULL,'2MASX J15475752+1843208',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000154,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,236.989916667,18.72233,0.093,NULL,59446593382,928853021,14513328,16.9),(132669,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132669,36.49,0.33,199,62201,70,NULL,NULL,'CGCG 250-012 NED02',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,'FoF','16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,236.999208333,45.00631,0.053,NULL,59692624414,932697256,14573394,16.6),(132670,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132670,36.49,0.33,199,62202,70,NULL,NULL,'CGCG 250-012 NED01',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000197,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,237.0077917,45.00183,0.053,NULL,59692624628,932697259,14573394,15.4),(132671,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132671,38.07,0.33,412,62203,70,NULL,NULL,'2MASX J15480197+0255426',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000098,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.0082083,2.92844,0.317,NULL,56608957627,884514962,13820546,18),(132672,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132672,37.45,0.46,308,62204,70,NULL,NULL,'2MASX J15480312+2214247',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.013083,22.24011,0.189,NULL,59404072243,928188628,14502947,17.2),(132673,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132673,37.14,0.46,267,62205,70,NULL,NULL,'2MASX J15480458+0840280',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.0192083,8.67439,0.049,NULL,56625314306,884770536,13824539,16.8),(132674,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132674,37.7,0.16,347,62206,70,NULL,NULL,'2MASX J15480594+2757446',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.024708333,27.96236,0.081,NULL,59871841986,935497531,14617148,16.7),(132675,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132675,38.66,0.46,540,62207,70,NULL,NULL,'2MASX J15480635+5301292',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.026583,53.02486,0,NULL,59714710909,933042357,14578786,17.4),(132676,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132676,37.87,0.46,376,62208,70,NULL,NULL,'2MASX J15480811-0026261',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.033791667,-0.44061,0.289,NULL,45517581165,711212205,11112690,17.9),(132677,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132677,36.97,0.46,248,62209,70,NULL,NULL,'2MASX J15481037+0751490',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.043125,7.86375,0.053,NULL,56626046474,884781976,13824718,17.8),(132678,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132678,37.5,0.46,317,62210,70,NULL,NULL,'2MASX J15481103+2655425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.046083,26.92839,0.109,NULL,59872407291,935506363,14617286,16.7),(132679,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132679,36.22,0.46,176,62211,70,NULL,NULL,'2MASX J15481174+0904250',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000172,NULL,'16.1g',0.27,'E0',NULL,NULL,NULL,NULL,1,237.048917,9.0735,0.057,NULL,56594821785,884294090,13817095,16.1),(132680,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132680,37.99,0.46,396,62212,70,NULL,NULL,'2MASX J15481253+5321302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.0520417,53.35856,0.033,NULL,59668306168,932317283,14567457,17.7),(132681,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132681,37.93,0.33,385,62213,70,NULL,NULL,'2MASX J15481271+0543346',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.053125,5.72622,0.101,NULL,56617753386,884652396,13822693,18.3),(132682,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132682,37.87,0.46,374,62214,70,NULL,NULL,'2MASX J15481365+2954536',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.056833333,29.915,0.085,NULL,59922727031,936292609,14629572,16.5),(132683,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132683,32.55,0.8,32.4,62215,75,NULL,'MAT, I','IC 4555',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000022,NULL,'13.53',0.5,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,237.0617083,-78.17886,0.425,NULL,44282755340,691918052,10811219,13.53),(132684,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132684,31.91,0.32,24.1,62215,85,NULL,'I, raw','IC 4555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132685,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132685,31.92,0.32,24.2,62215,85,NULL,'I, inv','IC 4555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132686,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132686,31.97,0.4,24.8,62215,73,NULL,'opt','IC 4555',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132687,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132687,32.03,0.2,25.5,62215,74.4,NULL,NULL,'IC 4555',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132688,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132688,32.04,0.43,25.6,62215,75,NULL,'3.6 micron, color + selection bias corrected','IC 4555',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132689,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132689,32.06,0.58,25.8,62215,NULL,NULL,'Malmquist cor.','IC 4555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132690,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132690,32.07,0.43,25.9,62215,75,NULL,'3.6 micron, color corrected','IC 4555',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132691,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132691,32.1,0.43,26.3,62215,75,NULL,'MAT, I, raw','IC 4555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132692,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132692,32.11,0.57,26.4,62215,NULL,NULL,NULL,'IC 4555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132693,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132693,32.17,0.43,27.1,62215,75,NULL,'MAT, I, inv','IC 4555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132694,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132694,32.43,0.49,30.7,62215,75,NULL,'IR','IC 4555',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132695,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132695,32.44,0.43,30.8,62215,75,NULL,'MAT, I, cor','IC 4555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132696,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132696,32.91,0.4,38.3,62215,NULL,NULL,'mean','IC 4555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132697,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132697,32.95,0.47,38.9,62215,NULL,NULL,'H','IC 4555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132698,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132698,33.05,0.46,40.7,62215,NULL,NULL,'J','IC 4555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132699,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132699,33.21,0.45,43.8,62215,NULL,NULL,'K','IC 4555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132700,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132700,37.32,0.46,291,62216,70,NULL,NULL,'SDSS J154814.90+055456.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.062083,5.91564,0.101,NULL,56617259943,884644686,13822573,18.3),(132701,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132701,32.74,0.8,35.2,62217,75,NULL,'MAT, I','NGC 5967',NULL,'1997ApJS..109..333W',1997,1,2.9,'Confused HIPASS source','G',0.000019,NULL,'12.6b',1.7,'SAB(rs)c','in a pair',NULL,NULL,NULL,1,237.066375,-75.67294,0.293,NULL,44114494114,689288970,10770140,12.6),(132702,'Sosies','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132702,32.72,0.16,35,62217,NULL,NULL,NULL,'NGC 5967',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132703,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132703,32.81,0.8,36.6,62217,75,NULL,'B','NGC 5967',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132704,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132704,32.46,0.47,31,62217,NULL,NULL,'H','NGC 5967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132705,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132705,32.47,0.4,31.2,62217,NULL,NULL,NULL,'NGC 5967',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132706,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132706,32.59,0.45,33,62217,NULL,NULL,'K','NGC 5967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132707,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132707,32.59,0.43,33,62217,75,NULL,'3.6 micron, color + selection bias corrected','NGC 5967',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132708,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132708,32.63,0.46,33.6,62217,NULL,NULL,'J','NGC 5967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132709,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132709,32.64,0.32,33.7,62217,85,NULL,'I, raw','NGC 5967',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132710,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132710,32.68,0.43,34.4,62217,75,NULL,'3.6 micron, color corrected','NGC 5967',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132711,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132711,32.69,0.43,34.5,62217,75,NULL,'MAT, I, raw','NGC 5967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132712,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132712,32.7,0.32,34.6,62217,85,NULL,'I, inv','NGC 5967',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132713,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132713,32.89,0.2,37.8,62217,74.4,NULL,NULL,'NGC 5967',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132714,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132714,32.9,0.43,38,62217,75,NULL,'MAT, I, cor','NGC 5967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132715,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132715,32.92,0.43,38.4,62217,75,NULL,'MAT, I, inv','NGC 5967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132716,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132716,32.93,0.4,38.6,62217,NULL,NULL,'mean','NGC 5967',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132717,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132717,33.11,0.48,41.9,62217,NULL,NULL,'Malmquist cor.','NGC 5967',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132718,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132718,33.22,0.46,44,62217,NULL,NULL,NULL,'NGC 5967',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132719,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132719,36.38,0.33,188,62218,70,NULL,NULL,'2MASX J15481608+4255527',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000194,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,237.066708333,42.93133,0.037,NULL,59678108732,932470448,14569850,16.2),(132720,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132720,37.27,0.46,284,62219,70,NULL,NULL,'2MASX J15481831+5735490',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000102,NULL,'16.1g',0.33,'S',NULL,NULL,NULL,NULL,1,237.076166667,57.59706,0,NULL,57635269219,900551081,14071110,16.1),(132721,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132721,37.99,0.46,395,62220,70,NULL,NULL,'2MASX J15481925+3018106',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.080333333,30.30303,0.065,NULL,59922640870,936291263,14629550,17.6),(132722,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132722,37.64,0.33,337,62221,70,NULL,NULL,'SDSS J154819.72+032330.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000077,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.0822083,3.39186,0.249,NULL,56622090836,884720169,13823752,18.4),(132723,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132723,37.41,0.15,304,62222,70,NULL,NULL,'SDSS J154820.35+254128.6',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.0847917,25.69131,0.161,NULL,59873502951,935523483,14617554,17.1),(132724,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132724,38.27,0.46,452,62223,70,NULL,NULL,'2MASX J15482066+3451056',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.086083,34.8515,0.081,NULL,59892158134,935814970,14622108,17.6),(132725,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132725,37.46,0.46,310,62224,70,NULL,NULL,'2MASX J15482196+3311026',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.091333,33.18408,0.073,NULL,59889157318,935768083,14621376,16.7),(132726,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132726,37.31,0.46,289,62225,70,NULL,NULL,'2MASX J15482224+2539196',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.09275,25.65547,0.161,NULL,59873237667,935519338,14617489,16.7),(132727,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132727,38.41,0.46,480,62226,70,NULL,NULL,'2MASX J15482328+4322267',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.096833333,43.37417,0.033,NULL,59691783466,932684116,14573189,17.7),(132728,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132728,37.64,0.33,337,62227,70,NULL,NULL,'2MASX J15482367+0326426',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000085,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.0984583,3.44503,0.249,NULL,56622269863,884722966,13823796,18.2),(132729,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132729,36.13,0.46,168,62228,70,NULL,NULL,'2MASX J15482631+0909519',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'15.8g',0.36,'E0',NULL,NULL,NULL,NULL,1,237.109583,9.16456,0.057,NULL,56602172717,884408948,13818889,15.8),(132730,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132730,37.79,0.46,361,62229,70,NULL,NULL,'2MASX J15482690+2548316',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.112083,25.80878,0.161,NULL,59873498200,935523409,14617553,17.4),(132731,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132731,36.38,0.33,188,62230,70,NULL,NULL,'2MASX J15482839+4242048',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000206,NULL,'15.9g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,237.1184583,42.70147,0.049,NULL,59677976614,932468384,14569818,15.9),(132732,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132732,37.58,0.46,328,62231,70,NULL,NULL,'2MASX J15482915-0112254',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.121625,-1.20706,0.361,NULL,45584239757,712253746,11128964,17.7),(132733,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132733,37.43,0.46,306,62232,70,NULL,NULL,'2MASX J15483209+3722557',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000189,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,237.133625,37.38206,0.041,NULL,59880265831,935629153,14619205,16.8),(132734,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132734,35.79,0.49,144,62233,75,NULL,'IR','UGC 10039',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.40',0.2,'S?',NULL,NULL,NULL,NULL,1,237.145,11.64742,0.109,NULL,56599947456,884374179,13818346,15.4),(132735,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132735,37.47,0.46,312,62234,70,NULL,NULL,'2MASX J15483657+3822567',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.1525,38.38239,0.025,NULL,59760854652,933763353,14590052,17.1),(132736,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132736,38.36,0.33,470,62235,70,NULL,NULL,'SDSS J154836.79+523826.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,237.153333,52.64064,0.021,NULL,59714774070,933043344,14578802,18.6),(132737,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132737,37.44,0.46,307,62236,70,NULL,NULL,'2MASX J15483711+0806329',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.1547083,8.10919,0.049,NULL,56626223710,884784745,13824761,16.9),(132738,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132738,37.29,0.46,287,62237,70,NULL,NULL,'2MASX J15483772+2356056',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000182,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.157333,23.93503,0.149,NULL,59398292029,928098312,14501536,16.2),(132739,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132739,37.41,0.21,304,62238,70,NULL,NULL,'2MASX J15483785+0841599',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000183,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.157875,8.69989,0.057,NULL,56625441606,884772525,13824570,17.2),(132740,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132740,36.31,0.33,183,62239,70,NULL,NULL,'CGCG 136-085',NULL,'2015arXiv151105856S',2015,1,0.86,'Companion galaxy superposed 13 arcsec south of nucleus.','G',0.00024,NULL,'15.1g',0.56,NULL,NULL,NULL,NULL,NULL,1,237.159583,25.40417,0.161,NULL,59871260433,935488444,14617006,15.1),(132741,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132741,38,0.33,397,62240,70,NULL,NULL,'2MASX J15483911+3432462',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000193,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,237.1629583,34.54611,0.077,NULL,59887796698,935746823,14621044,16.6),(132742,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132742,37.41,0.15,304,62241,70,NULL,NULL,'2MASX J15483982+2525325',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000159,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,237.165958333,25.42581,0.161,NULL,59871260133,935488439,14617006,17.5),(132743,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132743,32.72,0.4,35,62242,75,NULL,NULL,'UGC 10043',NULL,'2008Ap.....51..336K',2008,1,2.69,NULL,'G',0.000004,NULL,'14.80',0.35,'Sbc',NULL,NULL,NULL,NULL,1,237.1717083,21.86939,0.181,NULL,59404126946,928189483,14502960,14.8),(132744,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132744,33,0.43,39.9,62242,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132745,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132745,33.04,0.4,40.5,62242,NULL,NULL,'mean','UGC 10043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132746,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132746,33.39,0.43,47.7,62242,75,NULL,'3.6 micron, color corrected','UGC 10043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132747,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132747,33.4,0.45,47.8,62242,NULL,NULL,'K','UGC 10043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132748,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132748,33.43,0.47,48.4,62242,NULL,NULL,'H','UGC 10043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132749,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132749,33.49,NULL,50,62242,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132750,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132750,33.5,NULL,50,62242,NULL,NULL,'Dipole','UGC 10043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132751,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132751,33.5,NULL,50.1,62242,NULL,NULL,'Dipole + Quadrupole','UGC 10043',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132752,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132752,33.56,NULL,51.5,62242,NULL,NULL,NULL,'UGC 10043',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132753,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132753,33.63,0.46,53.2,62242,NULL,NULL,'J','UGC 10043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132754,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132754,33.7,0.49,55.1,62242,75,NULL,'IR','UGC 10043',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132755,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132755,33.78,0.2,57,62242,74.4,NULL,NULL,'UGC 10043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132756,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132756,38.18,0.46,433,62243,70,NULL,NULL,'SDSS J154843.53+055522.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.181375,5.92306,0.109,NULL,56617743235,884652238,13822691,18.4),(132757,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132757,37.97,0.23,393,62244,70,NULL,NULL,'2MASX J15484366-0014484',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.181875,-0.24686,0.269,NULL,45517207085,711206360,11112599,18),(132758,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132758,35.58,0.2,131,62245,74.4,NULL,NULL,'UGC 10040',NULL,'2013AJ....146...86T',2013,1,1.11,NULL,'G',0.000033,NULL,'15.2g',0.34,'S?',NULL,NULL,NULL,NULL,1,237.182917,17.86272,0.041,NULL,59430108994,928595453,14509303,15.2),(132759,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132759,36.55,0.23,205,62246,70,NULL,NULL,'2MASX J15484398+1139529',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,237.1832083,11.66481,0.109,NULL,56599949107,884374204,13818346,16.2),(132760,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132760,35.98,0.46,157,62247,70,NULL,NULL,'CGCG 275-007',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000106,NULL,'15.2g',0.53,'SABb',NULL,NULL,NULL,NULL,1,237.183833,52.34294,0.021,NULL,59714671069,933041735,14578777,15.2),(132761,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132761,38.31,0.46,458,62248,70,NULL,NULL,'SDSS J154845.62+024122.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000092,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.190125,2.68953,0.325,NULL,56607654334,884494598,13820228,18),(132762,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132762,38.1,0.46,416,62249,70,NULL,NULL,'2MASX J15484641+3341052',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.1934583,33.68472,0.073,NULL,59889654437,935775850,14621497,17.8),(132763,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132763,37.97,0.23,393,62250,70,NULL,NULL,'2MASX J15484645+0001155',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000083,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.193583,0.02106,0.273,NULL,56472528652,882383260,13787238,18.2),(132764,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132764,36.31,0.33,183,62251,70,NULL,NULL,'SDSS J154846.56+252840.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.4g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.194,25.47792,0.161,NULL,59871206539,935487602,14616993,17.4),(132765,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132765,37.46,0.46,310,62252,70,NULL,NULL,'2MASX J15484712+1559552',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.196417,15.99867,0.085,NULL,56532574196,883321471,13801897,17.2),(132766,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132766,37.12,0.46,266,62253,70,NULL,NULL,'SDSS J154847.61+111253.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,237.198417,11.21494,0.113,NULL,56599507653,884367307,13818239,NULL),(132767,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132767,37.97,0.23,393,62254,70,NULL,NULL,'2MASX J15484825-0004024',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.201083,-0.06731,0.273,NULL,45517215623,711206494,11112601,17.8),(132768,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132768,37.97,0.23,393,62255,70,NULL,NULL,'2MASX J15484852-0000014',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000102,NULL,'17.0g',NULL,'BrClG',NULL,NULL,NULL,NULL,1,237.2022083,-0.00044,0.273,NULL,45517215846,711206497,11112601,17),(132769,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132769,37.84,0.33,370,62256,70,NULL,NULL,'2MASX J15484876+0743019',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.203041667,7.71717,0.093,NULL,56625885714,884779464,13824679,17.1),(132770,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132770,37.57,0.46,326,62257,70,NULL,NULL,'2MASX J15484884+0441510',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.2035417,4.69761,0.185,NULL,56619417082,884678391,13823099,17.3),(132771,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132771,38.14,0.46,424,62258,70,NULL,NULL,'2MASX J15484936+0258310',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000105,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.205583,2.97525,0.297,NULL,56607648345,884494505,13820226,17.6),(132772,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132772,37.4,0.46,302,62259,70,NULL,NULL,'2MASX J15484963+3029352',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00017,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.20675,30.49317,0.073,NULL,59923043351,936297552,14629649,16.9),(132773,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132773,37.75,0.46,355,62260,70,NULL,NULL,'2MASX J15485229+1923298',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.217875,19.39161,0.137,NULL,59446368642,928849510,14513273,17.6),(132774,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132774,36.34,0.46,186,62261,70,NULL,NULL,'2MASX J15485321+4557357',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00022,NULL,'15.4g',0.43,'E0',NULL,NULL,NULL,NULL,1,237.2215,45.95992,0.053,NULL,59689324560,932645696,14572589,15.4),(132775,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132775,38.59,0.46,522,62262,70,NULL,NULL,'2MASX J15485368+3421392',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.223583,34.36092,0.073,NULL,59887625042,935744141,14621002,17.8),(132776,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132776,37.48,0.46,313,62263,70,NULL,NULL,'2MASX J15485405+3926400',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,237.225125,39.44444,0.057,NULL,59760638289,933759973,14589999,16.6),(132777,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132777,36.35,0.46,187,62264,70,NULL,NULL,'SDSS J154855.66+000540.0',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.231958333,0.09447,0.273,NULL,56472531553,882383305,13787239,17.3),(132778,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132778,37.38,0.46,299,62265,70,NULL,NULL,'2MASX J15485667+4720497',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.236083,47.34719,0.069,NULL,59723975230,933187112,14581048,16.5),(132779,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132779,33.75,0.49,56.1,62266,75,NULL,'IR','UGC 10042',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000017,NULL,'14.88',0.2,'Scd:',NULL,NULL,NULL,NULL,1,237.2379583,7.22231,0.073,NULL,56626404299,884787567,13824805,14.88),(132780,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132780,33.92,0.2,60.8,62266,74.4,NULL,NULL,'UGC 10042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132781,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132781,33.98,0.4,62.6,62266,NULL,NULL,'mean','UGC 10042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132782,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132782,34.02,0.47,63.5,62266,NULL,NULL,'H','UGC 10042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132783,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132783,34.13,0.24,66.9,62266,NULL,NULL,'Malmquist cor.','UGC 10042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132784,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132784,34.16,0.45,68,62266,NULL,NULL,'K','UGC 10042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132785,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132785,34.17,0.46,68.1,62266,NULL,NULL,'J','UGC 10042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132786,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132786,34.24,0.23,70.4,62266,NULL,NULL,NULL,'UGC 10042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132787,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132787,33.83,NULL,58.4,62267,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10044',NULL,'2010Ap&SS.325..163P',2010,1,1.29,NULL,'G',0.000009,NULL,'16.0',0.11,'Scd',NULL,NULL,NULL,NULL,1,237.24325,18.10319,0.025,NULL,59430068980,928594827,14509294,16),(132788,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132788,33.85,NULL,58.8,62267,NULL,NULL,'Dipole + Quadrupole','UGC 10044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132789,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132789,33.86,NULL,59.2,62267,NULL,NULL,'Dipole','UGC 10044',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132790,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132790,33.91,NULL,60.6,62267,NULL,NULL,NULL,'UGC 10044',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132791,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132791,38.53,0.33,508,62268,70,NULL,NULL,'2MASX J15485944+1231314',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.247583333,12.52553,0.101,NULL,56528934317,883264598,13801009,17.7),(132792,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132792,37.41,0.21,304,62269,70,NULL,NULL,'2MASX J15485949+0902112',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.2477917,9.03647,0.069,NULL,56594801795,884293778,13817090,16.3),(132793,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132793,37.41,0.21,304,62270,70,NULL,NULL,'2MASX J15485949+0854362',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000227,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,237.2479583,8.90992,0.069,NULL,56625264137,884769752,13824527,15.9),(132794,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132794,37.97,0.46,393,62271,70,NULL,NULL,'2MASX J15485979+1303494',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,237.249083,13.06375,0.105,NULL,56538045487,883406960,13803233,NULL),(132795,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132795,36.77,0.46,226,62272,70,NULL,NULL,'2MASX J15490022+5048297',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000179,NULL,'16.1g',0.31,'E0',NULL,NULL,NULL,NULL,1,237.251,50.80825,0.037,NULL,59717490148,933085783,14579465,16.1),(132796,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132796,37.02,0.46,254,62273,70,NULL,NULL,'2MASX J15490082+2740328',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.253583,27.67569,0.081,NULL,59871787958,935496686,14617135,17.1),(132797,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132797,37.35,0.46,295,62274,70,NULL,NULL,'2MASX J15490124+0824452',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.255333,8.41247,0.049,NULL,56625371779,884771434,13824553,17.4),(132798,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132798,32.3,0.2,28.8,62275,74.4,NULL,NULL,'UGC 10041',NULL,'2013AJ....146...86T',2013,1,3,NULL,'G',0.000007,NULL,'13.5',1.7,'SABdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,237.255833,5.18861,0.181,NULL,56617414201,884647096,13822610,13.5),(132799,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132799,32.41,0.43,30.3,62275,75,NULL,'3.6 micron, color corrected','UGC 10041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132800,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132800,32.5,0.43,31.6,62275,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132801,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132801,32.63,0.4,33.6,62275,75,NULL,'B','UGC 10041',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132802,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132802,32.77,0.37,35.8,62275,NULL,NULL,NULL,'UGC 10041',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132803,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132803,34.04,0.2,64.3,62276,74.4,NULL,NULL,'CGCG 166-060',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000083,NULL,'15.2',0.4,NULL,NULL,NULL,NULL,NULL,1,237.257125,27.60997,0.081,NULL,59871780122,935496564,14617133,15.2),(132804,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132804,38,0.33,397,62277,70,NULL,NULL,'2MASX J15490387+3433082',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.2662083,34.55228,0.077,NULL,59887799110,935746861,14621044,17.4),(132805,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132805,37.41,0.15,304,62278,70,NULL,NULL,'2MASX J15490610+2540268',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.275375,25.67397,0.165,NULL,59873492997,935523328,14617552,18.1),(132806,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132806,38.18,0.46,433,62279,70,NULL,NULL,'2MASX J15490617+0846162',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.275625,8.77111,0.057,NULL,56625242371,884769412,13824522,17.9),(132807,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132807,38.36,0.33,470,62280,70,NULL,NULL,'2MASX J15490767+5241027',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.281667,52.68428,0.021,NULL,59714653555,933041461,14578772,17.4),(132808,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132808,35.93,0.46,154,62281,70,NULL,NULL,'CGCG 250-013',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000167,NULL,'14.8g',0.59,'E0',NULL,NULL,NULL,NULL,1,237.282333333,44.6995,0.041,NULL,59692755529,932699305,14573426,14.8),(132809,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132809,38.53,0.33,508,62282,70,NULL,NULL,'SDSS J154908.42+123010.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.285125,12.50283,0.101,NULL,56528942736,883264730,13801011,18.2),(132810,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132810,37.52,0.46,319,62283,70,NULL,NULL,'2MASX J15491114+3511342',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.2962083,35.19269,0.073,NULL,59892427335,935819177,14622174,17.6),(132811,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132811,33.6,0.49,52.4,62284,75,NULL,'IR','ESO 450- G 017',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'17.15',0.2,'S0:',NULL,NULL,NULL,NULL,1,237.3042917,-28.92272,0.597,NULL,47166039961,736969374,11515146,17.15),(132812,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132812,37.87,0.46,374,62285,70,NULL,NULL,'2MASX J15491318+0443340',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.3050417,4.72622,0.185,NULL,56619286918,884676358,13823068,17.7),(132813,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132813,37.41,0.15,304,62286,70,NULL,NULL,'2MASX J15491502+2531153',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.312667,25.52092,0.161,NULL,59871212672,935487698,14616995,18),(132814,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132814,36.97,0.46,247,62287,70,NULL,NULL,'2MASX J15491525+2811123',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000146,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.3135,28.18681,0.077,NULL,59873715553,935526805,14617606,17.2),(132815,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132815,37.82,0.23,367,62288,70,NULL,NULL,'2MASX J15491609+2843163',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.3170417,28.72128,0.097,NULL,59866386481,935412288,14615817,17.9),(132816,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132816,37.52,0.46,319,62289,70,NULL,NULL,'2MASX J15491640+2807133',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000166,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.3184583,28.12033,0.077,NULL,59873708199,935526690,14617604,17.5),(132817,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132817,38,0.46,398,62290,70,NULL,NULL,'2MASX J15491716+3913420',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.321625,39.22831,0.037,NULL,59761327318,933770739,14590167,17.6),(132818,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132818,37.41,0.15,304,62291,70,NULL,NULL,'2MASX J15491731+2534543',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.3222917,25.58175,0.165,NULL,59871331905,935489561,14617024,17.6),(132819,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132819,37.41,0.15,304,62292,70,NULL,NULL,'2MASX J15491833+2539163',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000198,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.326583,25.65439,0.165,NULL,59871331010,935489547,14617024,16.7),(132820,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132820,37.65,0.46,339,62293,70,NULL,NULL,'2MASX J15491873+0043200',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.327958333,0.72225,0.253,NULL,56472953239,882389894,13787342,18.3),(132821,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132821,37.65,0.46,338,62294,70,NULL,NULL,'2MASX J15491890+2513513',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.3287917,25.23094,0.161,NULL,59871241642,935488150,14617002,17.5),(132822,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132822,33.59,0.8,52.2,62295,75,NULL,'MAT, I','ESO 450- G 018',NULL,'1997ApJS..109..333W',1997,1,5,NULL,'G',0.00002,NULL,'15.62',0.9,'I0:            HII',NULL,NULL,NULL,NULL,1,237.3329583,-28.90367,0.597,NULL,47166043924,736969436,11515147,15.62),(132823,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132823,31.1,0.32,16.6,62295,85,NULL,'I, inv','ESO 450- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132824,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132824,31.11,0.32,16.7,62295,85,NULL,'I, raw','ESO 450- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132825,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132825,31.45,0.43,19.5,62295,75,NULL,'MAT, I, raw','ESO 450- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132826,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132826,31.45,0.43,19.5,62295,75,NULL,'MAT, I, inv','ESO 450- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132827,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132827,31.76,0.43,22.5,62295,75,NULL,'MAT, I, cor','ESO 450- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132828,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132828,33.17,0.47,43.1,62295,NULL,NULL,'H','ESO 450- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132829,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132829,33.32,0.46,46.1,62295,NULL,NULL,'J','ESO 450- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132830,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132830,33.33,0.45,46.3,62295,NULL,NULL,'K','ESO 450- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132831,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132831,33.63,0.4,53.3,62295,NULL,NULL,'mean','ESO 450- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132832,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132832,37.21,0.46,277,62296,70,NULL,NULL,'2MASX J15492139+1056118',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.33925,10.93661,0.141,NULL,56601126908,884392607,13818634,16.9),(132833,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132833,37.14,0.46,268,62297,70,NULL,NULL,'2MASX J15492165+1437205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.340375,14.62233,0.097,NULL,56538898859,883420294,13803442,17.8),(132834,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132834,36.5,NULL,200,62298,NULL,NULL,NULL,'FGC 1959',NULL,'2000BSAO...50....5K',2000,1,0.91,NULL,'G',0.000088,NULL,'17.6g',0.09,'Scd',NULL,NULL,NULL,NULL,1,237.343167,33.64258,0.073,NULL,59889623439,935775366,14621490,17.6),(132835,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132835,37.35,0.46,295,62299,70,NULL,NULL,'2MASX J15492240+1151028',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.3434583,11.85081,0.081,NULL,56599859545,884372805,13818325,16.7),(132836,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132836,38.55,0.46,514,62300,70,NULL,NULL,'2MASX J15492242+2625543',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.3435417,26.43164,0.141,NULL,59872877278,935513707,14617401,18.4),(132837,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132837,37.52,0.46,319,62301,70,NULL,NULL,'2MASX J15492248+2737063',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.343875,27.61844,0.081,NULL,59871734181,935495846,14617122,17.5),(132838,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132838,37.13,0.46,266,62302,70,NULL,NULL,'2MASX J15492260+3617040',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,237.3442083,36.28433,0.057,NULL,59880151935,935627373,14619177,16.9),(132839,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132839,37.41,0.21,304,62303,70,NULL,NULL,'2MASX J15492286+0854088',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.345167,8.90228,0.069,NULL,56625241838,884769403,13824521,17.5),(132840,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132840,37.25,0.33,282,62304,70,NULL,NULL,'2MASX J15492295+0438300',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.345708333,4.64178,0.205,NULL,56619293349,884676458,13823069,17.3),(132841,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132841,37.98,0.46,395,62305,70,NULL,NULL,'SDSS J154923.25+385741.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.346875,38.96161,0.061,NULL,59761484661,933773197,14590206,18.1),(132842,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132842,37.84,0.33,370,62306,70,NULL,NULL,'2MASX J15492541+0746128',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000155,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.3557917,7.77011,0.093,NULL,56625945844,884780403,13824693,17),(132843,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132843,36.69,0.33,218,62307,70,NULL,NULL,'2MASX J15492536+2059531',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000186,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,237.3557917,20.99814,0.121,NULL,59402820841,928169075,14502641,16.4),(132844,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132844,33.59,0.46,52.3,62308,70,NULL,NULL,'NGC 6003',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00004,NULL,'14.30',0.9,'S0?','in a radial-velocity based grouping',NULL,NULL,NULL,1,237.356833,19.03208,0.041,NULL,59446871724,928857370,14513396,14.3),(132845,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132845,36,0.2,158,62309,74.4,NULL,NULL,'CGCG 136-088',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000083,NULL,'14.8g',0.51,'Sa',NULL,NULL,NULL,NULL,1,237.3674583,21.03411,0.121,NULL,59402829146,928169205,14502643,14.8),(132846,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132846,38.5,0.46,500,62310,70,NULL,NULL,'2MASX J15493076+2617343',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,237.378291667,26.29278,0.153,NULL,59872903083,935514110,14617407,17.8),(132847,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132847,33.4,0.2,47.9,62311,74.4,NULL,NULL,'CGCG 136-089',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'15.00',0.8,'S(B)b',NULL,NULL,NULL,NULL,1,237.385625,20.64514,0.117,NULL,59402259043,928160297,14502504,15),(132848,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132848,37.87,0.17,375,62312,70,NULL,NULL,'2MASX J15493317+1902181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.388291667,19.03844,0.041,NULL,59446874071,928857407,14513396,17.7),(132849,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132849,37.41,0.21,304,62313,70,NULL,NULL,'2MASX J15493367+0901008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.390125,9.01692,0.069,NULL,56636743478,884949116,13827329,17.1),(132850,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132850,36.85,0.46,235,62314,70,NULL,NULL,'2MASX J15493433+1359577',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'17.15',NULL,NULL,NULL,NULL,NULL,NULL,1,237.392958333,13.99931,0.097,NULL,56538596437,883415569,13803368,17.15),(132851,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132851,37.87,0.17,375,62315,70,NULL,NULL,'2MASX J15493621+1905321',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.400791667,19.09208,0.057,NULL,59446804713,928856323,14513380,17.9),(132852,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132852,36.42,0.46,192,62316,70,NULL,NULL,'2MASX J15493623+3342084',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.401083,33.70225,0.073,NULL,59889625771,935775402,14621490,16.6),(132853,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132853,33.15,0.69,42.7,62317,100,NULL,'mid-IR','ESO 329- G 022',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000021,NULL,'16.1R',0.7,'SB(s)cd:',NULL,NULL,NULL,NULL,1,237.405083,-40.32672,0.549,NULL,46373192230,724581128,11321580,16.1),(132854,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132854,33.46,0.2,49.2,62317,74.4,NULL,NULL,'ESO 329- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132855,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132855,33.7,0.33,55,62317,NULL,NULL,NULL,'ESO 329- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132856,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132856,33.95,0.3,61.6,62317,NULL,NULL,'Malmquist cor.','ESO 329- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132857,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132857,34.03,0.4,64,62317,NULL,NULL,'mean','ESO 329- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132858,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132858,34.2,0.47,69.3,62317,NULL,NULL,'H','ESO 329- G 022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132859,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132859,35.85,0.33,148,62318,70,NULL,NULL,'CGCG 222-052',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00019,NULL,'14.3g',0.77,'E','Group member',NULL,NULL,NULL,1,237.409375,42.03422,0.049,NULL,59678287109,932473236,14569894,14.3),(132860,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132860,38.47,0.33,493,62319,70,NULL,NULL,'SDSS J154939.21+325330.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.413375,32.89189,0.069,NULL,59889839976,935778749,14621542,18.1),(132861,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132861,37.82,0.23,367,62320,70,NULL,NULL,'2MASX J15494199+2831363',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,'PHOT','15.7g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,237.425,28.52675,0.089,NULL,59866407694,935412620,14615822,15.7),(132862,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132862,38.21,0.27,438,62321,70,NULL,NULL,'2MASX J15494214+2910223',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.4255,29.17294,0.093,NULL,59922031212,936281737,14629402,18.6),(132863,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132863,36.72,0.64,221,62322,70,NULL,NULL,'2MASX J15494297-0519237',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,237.429125,-5.32328,0.525,NULL,45597132388,712455193,11132112,14.6),(132864,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132864,38.28,0.46,452,62323,70,NULL,NULL,'2MASX J15494523+2636023',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.438375,26.60067,0.117,NULL,59872149527,935502336,14617224,18.5),(132865,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132865,37.88,0.33,377,62324,70,NULL,NULL,'2MASX J15494738+4018304',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.447375,40.30853,0.053,NULL,59794891722,934295183,14598362,16.9),(132866,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132866,37.87,0.17,375,62325,70,NULL,NULL,'2MASX J15494752+1906276',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.448083,19.10778,0.057,NULL,59446297069,928848391,14513256,16.5),(132867,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132867,36.99,0.27,250,62326,70,NULL,NULL,'2MASX J15494784+5121029',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.449417,51.35078,0.017,NULL,59717616466,933087757,14579496,16.6),(132868,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132868,35.85,0.33,148,62327,70,NULL,NULL,'CGCG 222-053',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000107,NULL,'15.4g',0.5,'E0','Group member',NULL,NULL,NULL,1,237.450833,41.98636,0.049,NULL,59678293041,932473328,14569895,15.4),(132869,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132869,36.12,0.46,167,62328,70,NULL,NULL,'2MASX J15494836+3800104',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00018,NULL,'16.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.451417,38.00292,0.061,NULL,59760713500,933761148,14590017,16.2),(132870,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132870,37.25,0.33,282,62329,70,NULL,NULL,'2MASX J15494920+0443590',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.454875,4.73297,0.197,NULL,56619295719,884676495,13823070,16.7),(132871,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132871,36.71,0.46,220,62330,70,NULL,NULL,'2MASX J15494933+0814497',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.455583,8.24722,0.085,NULL,56625807031,884778234,13824659,17.9),(132872,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132872,36.99,0.27,250,62331,70,NULL,NULL,'2MASX J15494942+5123549',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000106,NULL,'15.9g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,237.455833,51.39875,0.021,NULL,59718320572,933098758,14579668,15.9),(132873,'Sosies','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132873,32.73,0.62,35.2,62332,NULL,NULL,NULL,'NGC 6000',NULL,'2002A&A...393...57T',2002,1,1.9,NULL,'G',0.000003,NULL,'13.01',1.6,'SB(s)bc:;HII   Sbrst','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,237.4564583,-29.38683,0.669,NULL,47166167845,736971372,11515177,13.01),(132874,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132874,32.39,0.8,30.1,62332,75,NULL,NULL,'NGC 6000',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132875,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132875,31.8,0.45,22.9,62332,NULL,NULL,'K','NGC 6000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132876,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132876,31.87,0.47,23.7,62332,NULL,NULL,'H','NGC 6000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132877,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132877,31.93,0.46,24.3,62332,NULL,NULL,'J','NGC 6000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132878,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132878,32.24,0.4,28.1,62332,NULL,NULL,'mean','NGC 6000',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132879,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132879,36.99,0.27,250,62333,70,NULL,NULL,'2MASX J15495019+5119599',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000104,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,237.459333,51.3335,0.017,NULL,59717648781,933088262,14579504,16.2),(132880,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132880,37.41,0.15,304,62334,70,NULL,NULL,'2MASX J15495087+2536028',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.461875,25.60078,0.165,NULL,59871341631,935489712,14617026,17.5),(132881,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132881,34.25,0.46,70.9,62335,70,NULL,NULL,'MCG -01-40-007',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000093,NULL,'16',0.25,NULL,NULL,NULL,NULL,NULL,1,237.4650417,-7.48006,0.505,NULL,45620456199,712819628,11137806,16),(132882,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132882,37.86,0.46,374,62336,70,NULL,NULL,'2MASX J15495255+0507140',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.468875,5.12064,0.181,NULL,56619854811,884685231,13823206,17.8),(132883,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132883,37.04,0.46,255,62337,70,NULL,NULL,'2MASX J15495297+0837301',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.47075,8.62511,0.057,NULL,56636841604,884950650,13827353,17.1),(132884,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132884,34.92,0.8,96.2,62338,75,NULL,'MAT, I','ESO 583- G 007',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'15',1,'SB(rs)c',NULL,NULL,NULL,NULL,1,237.476833333,-21.04936,0.705,NULL,46579838267,727809972,11372030,15),(132885,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132885,34.91,0.47,95.8,62338,NULL,NULL,'H','ESO 583- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132886,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132886,34.93,0.46,96.9,62338,NULL,NULL,'J','ESO 583- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132887,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132887,34.95,0.43,97.7,62338,75,NULL,'MAT, I, raw','ESO 583- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132888,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132888,34.97,0.45,98.5,62338,NULL,NULL,'K','ESO 583- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132889,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132889,35.03,0.32,101,62338,85,NULL,'I, raw','ESO 583- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132890,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132890,35.06,0.4,103,62338,NULL,NULL,'mean','ESO 583- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132891,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132891,35.11,0.32,105,62338,85,NULL,'I, inv','ESO 583- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132892,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132892,35.21,0.4,110,62338,NULL,NULL,'Malmquist cor.','ESO 583- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132893,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132893,35.25,0.43,112,62338,75,NULL,'MAT, I, cor','ESO 583- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132894,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132894,35.29,0.43,115,62338,75,NULL,'MAT, I, inv','ESO 583- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132895,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132895,35.51,0.35,127,62338,NULL,NULL,NULL,'ESO 583- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132896,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132896,35.56,0.2,129,62338,74.4,NULL,NULL,'ESO 583- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132897,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132897,37.06,0.46,259,62339,70,NULL,NULL,'2MASX J15495560+5523455',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.3g',0.37,'AGN',NULL,NULL,NULL,NULL,1,237.4815417,55.39606,0.005,NULL,57641774545,900652727,14072698,16.3),(132898,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132898,37.82,0.23,367,62340,70,NULL,NULL,'SDSS J154956.22+283049.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.484291667,28.51369,0.089,NULL,59866377674,935412151,14615814,18.6),(132899,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132899,36.36,0.46,187,62341,70,NULL,NULL,'2MASX J15495738+2223476',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000153,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.4892083,22.39658,0.189,NULL,59404548348,928196067,14503063,16.7),(132900,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132900,32.2,NULL,27.5,62342,72,NULL,NULL,'AGC 258343',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000097,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,237.4925,5.51472,0.157,NULL,56617001094,884640642,13822510,NULL),(132901,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132901,37.65,0.46,339,62343,70,NULL,NULL,'2MASX J15495926+2733498',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.4970417,27.56383,0.081,NULL,59871727579,935495743,14617120,17.7),(132902,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132902,34.42,0.59,76.6,62344,70,NULL,NULL,'2MASX J15495933-3954432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,237.497333,-39.91203,0.453,NULL,46373135387,724580240,11321566,15.5),(132903,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132903,36.43,0.46,193,62345,70,NULL,NULL,'2MASX J15495952+0426114',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.4979583,4.43653,0.205,NULL,56622857800,884732153,13823939,16.4),(132904,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132904,35.5,0.46,126,62346,70,NULL,NULL,'2MASX J15495976+2111226',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000098,NULL,'16.0g',0.29,'AGN+SF',NULL,NULL,NULL,NULL,1,237.499083,21.18964,0.121,NULL,59402734289,928167723,14502620,16),(132905,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132905,37.13,0.33,267,62347,70,NULL,NULL,'2MASX J15495989+2705598',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000186,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,237.4995417,27.10006,0.105,NULL,59872232433,935503631,14617244,15.9),(132906,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132906,36.39,0.58,189,62348,70,NULL,NULL,'2MASX J15500012-0535597',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,237.5005,-5.59983,0.513,NULL,45589042394,712328787,11130137,15.8),(132907,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132907,35.92,0.46,153,62349,70,NULL,NULL,'2MASX J15500130+1054221',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.505541667,10.90625,0.093,NULL,56601336926,884395889,13818685,16.7),(132908,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132908,35.24,0.8,112,62350,75,NULL,'MAT, I','CGCG 022-042',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000017,NULL,'15.24',0.24,'Sc             HII','Isolated galaxy',NULL,NULL,NULL,1,237.509333,-2.82331,0.505,NULL,45586404207,712287565,11129493,15.24),(132909,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132909,34.63,0.49,84.3,62350,75,NULL,'IR','CGCG 022-042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132910,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132910,34.69,0.43,86.8,62350,75,NULL,'MAT, I, raw','CGCG 022-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132911,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132911,34.86,0.32,93.8,62350,85,NULL,'I, raw','CGCG 022-042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132912,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132912,34.87,0.2,94.2,62350,74.4,NULL,NULL,'CGCG 022-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132913,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132913,34.91,0.32,96.1,62350,85,NULL,'I, inv','CGCG 022-042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132914,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132914,34.93,0.43,96.8,62350,75,NULL,'MAT, I, inv','CGCG 022-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132915,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132915,34.98,NULL,99.2,62350,NULL,NULL,'Dipole','CGCG 022-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132916,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132916,34.99,NULL,99.5,62350,NULL,NULL,'Dipole + Quadrupole','CGCG 022-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132917,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132917,34.99,NULL,99.6,62350,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 022-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132918,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132918,35,0.48,100,62350,NULL,NULL,NULL,'CGCG 022-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132919,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132919,35.03,0.47,102,62350,NULL,NULL,'Malmquist cor.','CGCG 022-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132920,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132920,35.1,0.43,104,62350,75,NULL,'MAT, I, cor','CGCG 022-042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132921,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132921,37.01,0.46,252,62351,70,NULL,NULL,'2MASX J15500313+5258470',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000094,NULL,'16.6g',0.28,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,237.513,52.97958,0.025,NULL,59715265463,933051022,14578922,16.6),(132922,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132922,36.69,0.33,218,62352,70,NULL,NULL,'2MASX J15500482+2057216',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.520125,20.95614,0.121,NULL,59402878185,928169971,14502655,16.9),(132923,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132923,34.39,0.43,75.6,62353,75,NULL,'3.6 micron, color + selection bias corrected','ESO 515- G 010',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00003,NULL,'10.6K',0.6,'Sb:            HII',NULL,NULL,NULL,NULL,1,237.5207083,-23.63886,0.681,NULL,46583488356,727867005,11372921,10.6),(132924,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132924,37.95,0.46,389,62354,70,NULL,NULL,'2MASX J15500554+4413235',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.522958333,44.22306,0.033,NULL,59691574532,932680852,14573138,17.5),(132925,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132925,37.79,0.11,362,62355,70,NULL,NULL,'2MASX J15500558+2754209',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000189,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.5234583,27.90589,0.081,NULL,59873801115,935528142,14617627,16.3),(132926,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132926,37.87,0.17,375,62356,70,NULL,NULL,'2MASX J15500656+1857506',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.1g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,237.527375,18.964,0.041,NULL,59446812505,928856445,14513381,16.1),(132927,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132927,37.82,0.23,367,62357,70,NULL,NULL,'SDSS J155007.96+283719.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.5332083,28.622,0.089,NULL,59866401194,935412518,14615820,18.5),(132928,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132928,38.47,0.33,493,62358,70,NULL,NULL,'2MASX J15500895+3253554',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.537167,32.89861,0.069,NULL,59889833762,935778652,14621541,17.8),(132929,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132929,37.41,0.46,304,62359,70,NULL,NULL,'2MASX J15501028-0100007',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000121,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.543,-1.00028,0.365,NULL,45520447229,711256987,11113390,16.3),(132930,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132930,37.67,0.46,342,62360,70,NULL,NULL,'2MASX J15501058+1238270',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.544208333,12.64092,0.101,NULL,56529721122,883276892,13801201,17),(132931,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132931,37.9,0.46,380,62361,70,NULL,NULL,'2MASX J15501092+2738078',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000182,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.545375,27.6355,0.081,NULL,59873758023,935527469,14617616,17.8),(132932,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132932,36.81,0.46,230,62362,70,NULL,NULL,'2MASX J15501325+3628114',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.555333,36.46989,0.045,NULL,59880066283,935626035,14619156,17.8),(132933,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132933,37.87,0.17,375,62363,70,NULL,NULL,'2MASX J15501416+1857367',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.558916667,18.96011,0.041,NULL,59446810193,928856409,14513381,17.7),(132934,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132934,37.51,0.46,318,62364,70,NULL,NULL,'2MASX J15501428+4701196',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.559417,47.02219,0.069,NULL,59712447181,933006987,14578234,16.9),(132935,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132935,37.39,0.46,301,62365,70,NULL,NULL,'SDSS J155015.64+082355.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.5652083,8.39875,0.089,NULL,56637654991,884963359,13827552,18.4),(132936,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132936,38.21,0.27,438,62366,70,NULL,NULL,'SDSS J155015.82+291215.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000175,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.565917,29.20425,0.093,NULL,59922045671,936281963,14629405,18.5),(132937,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132937,37.13,0.33,267,62367,70,NULL,NULL,'2MASX J15501716+2716042',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.42',0.47,NULL,NULL,NULL,NULL,NULL,1,237.5715417,27.26783,0.073,NULL,59872237334,935503708,14617245,17.42),(132938,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132938,37.41,0.15,304,62368,70,NULL,NULL,'2MASX J15501803+2538252',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.575083,25.64028,0.165,NULL,59871367173,935490112,14617033,16.9),(132939,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132939,37.65,0.33,339,62369,70,NULL,NULL,'2MASX J15501852+1943237',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.57725,19.72319,0.101,NULL,59400262553,928129102,14502017,17.4),(132940,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132940,37.87,0.17,375,62370,70,NULL,NULL,'2MASX J15501875+1854267',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.578166667,18.9075,0.041,NULL,59446841013,928856890,14513388,17.6),(132941,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132941,37.15,0.46,269,62371,70,NULL,NULL,'2MASX J15501960+3822445',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.581583,38.37908,0.025,NULL,59760942474,933764726,14590073,16.7),(132942,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132942,37.16,0.46,271,62372,70,NULL,NULL,'2MASX J15501959+4407467',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.5817917,44.12969,0.025,NULL,59691572294,932680817,14573137,17.8),(132943,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132943,37.56,0.46,326,62373,70,NULL,NULL,'2MASX J15502081+3602335',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000189,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.5867917,36.04267,0.049,NULL,59880143720,935627245,14619175,16.7),(132944,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132944,37.88,0.33,377,62374,70,NULL,NULL,'2MASX J15502114+4021475',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000186,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,237.58825,40.36319,0.045,NULL,59795028589,934297321,14598395,16.3),(132945,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132945,37.95,0.46,389,62375,70,NULL,NULL,'SDSS J155021.55+281247.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.589833,28.21319,0.077,NULL,59873936094,935530251,14617660,18.1),(132946,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132946,37.22,0.27,278,62376,70,NULL,NULL,'2MASX J15502179+2818473',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,237.59075,28.313,0.085,NULL,59873732468,935527069,14617610,16.9),(132947,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132947,32.97,0.64,39.3,62377,NULL,NULL,'Malmquist cor.','NGC 6004',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000023,NULL,'13.11',1.7,'SAB(rs)bc','in a radial-velocity based grouping',NULL,NULL,NULL,1,237.594666667,18.93928,0.041,NULL,59446839944,928856874,14513388,13.11),(132948,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132948,33.05,0.61,40.8,62377,NULL,NULL,NULL,'NGC 6004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132949,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132949,33.09,0.2,41.5,62377,74.4,NULL,NULL,'NGC 6004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132950,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132950,35.61,0.46,133,62378,70,NULL,NULL,'2MASX J15502410+3023464',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000177,NULL,'15.8g',0.35,NULL,NULL,NULL,NULL,NULL,1,237.600417,30.39617,0.077,NULL,59923380483,936302820,14629731,15.8),(132951,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132951,32.68,0.8,34.4,62379,75,NULL,NULL,'UGC 10058',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000013,NULL,'17.',0.8,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,237.6007917,25.92247,0.165,NULL,59870917314,935483083,14616923,17),(132952,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132952,34.21,0.4,69.5,62379,NULL,NULL,NULL,'UGC 10058',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132953,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132953,37.72,0.46,351,62380,70,NULL,NULL,'2MASX J15502427+0022349',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000106,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.601083333,0.37633,0.309,NULL,56475812049,882434563,13788040,17.3),(132954,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132954,37.22,0.27,278,62381,70,NULL,NULL,'2MASX J15502444+2819513',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000183,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.602,28.33094,0.085,NULL,59873731836,935527059,14617610,16.3),(132955,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132955,38.21,0.27,438,62382,70,NULL,NULL,'SDSS J155024.70+285931.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.602917,28.99214,0.097,NULL,59866499634,935414056,14615844,18.5),(132956,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132956,38,0.46,399,62383,70,NULL,NULL,'SDSS J155025.40+071810.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.605833,7.30289,0.069,NULL,56624458623,884757165,13824330,17.6),(132957,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132957,37.07,0.33,259,62384,70,NULL,NULL,'2MASX J15502601+3029524',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.608375,30.49803,0.077,NULL,59923377552,936302774,14629730,17),(132958,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132958,37.87,0.17,375,62385,70,NULL,NULL,'2MASX J15502734+1857207',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000186,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.6139583,18.95572,0.041,NULL,59446850954,928857046,14513391,16.9),(132959,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132959,37.07,0.33,259,62386,70,NULL,NULL,'2MASX J15502756+3028474',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000194,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,237.6147917,30.47975,0.077,NULL,59923377118,936302767,14629730,16.4),(132960,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132960,37.6,0.46,331,62387,70,NULL,NULL,'2MASX J15503362+0348069',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.640125,3.80183,0.277,NULL,56622973544,884733961,13823968,18),(132961,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132961,37.64,0.46,338,62388,70,NULL,NULL,'2MASX J15503559+2858173',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00017,NULL,'16.4g',0.33,'E',NULL,NULL,NULL,NULL,1,237.6482083,28.9715,0.097,NULL,59866512191,935414252,14615847,16.4),(132962,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132962,37.79,0.11,362,62389,70,NULL,NULL,'2MASX J15503570+2753243',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.648833,27.89006,0.081,NULL,59873806984,935528234,14617628,17.3),(132963,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132963,37.96,0.46,391,62390,70,NULL,NULL,'2MASX J15503663+3548464',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,237.6524583,35.813,0.049,NULL,59891759761,935808746,14622011,16.6),(132964,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132964,37.65,0.33,339,62391,70,NULL,NULL,'2MASX J15503765+1945587',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.656958333,19.76639,0.101,NULL,59400319103,928129985,14502031,17.1),(132965,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132965,37.42,0.46,305,62392,70,NULL,NULL,'2MASX J15504088+1132572',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.670333,11.54936,0.097,NULL,56599657315,884369645,13818275,17.5),(132966,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132966,37.1,0.46,263,62393,70,NULL,NULL,'2MASX J15504104+4238196',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,237.6710417,42.63875,0.057,NULL,59678621086,932478454,14569975,16.5),(132967,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132967,36.24,0.46,177,62394,70,NULL,NULL,'2MASX J15504156+1211194',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.66',0.44,NULL,NULL,NULL,NULL,NULL,1,237.673083,12.18883,0.077,NULL,56599614426,884368975,13818265,16.66),(132968,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132968,34.56,0.46,81.7,62395,70,NULL,NULL,'MCG -01-40-008',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000033,NULL,'14.9',0.3,NULL,NULL,NULL,NULL,NULL,1,237.6822917,-7.56056,0.505,NULL,45631146748,712986667,11140416,14.9),(132969,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132969,35.31,0.4,115,62395,NULL,NULL,'mean','MCG -01-40-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132970,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132970,35.42,0.45,121,62395,NULL,NULL,'K','MCG -01-40-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(132971,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132971,37.41,0.15,304,62396,70,NULL,NULL,'2MASX J15504444+2544142',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,237.68525,25.73739,0.165,NULL,59870901152,935482830,14616919,16.1),(132972,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132972,38.06,0.46,408,62397,70,NULL,NULL,'2MASX J15504602+0620011',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.69175,6.33375,0.117,NULL,56624400161,884756252,13824316,17.7),(132973,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132973,37.51,0.46,318,62398,70,NULL,NULL,'2MASX J15504748+2027201',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000185,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.697875,20.45572,0.069,NULL,59402201728,928159402,14502490,17.8),(132974,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132974,37.71,0.27,348,62399,70,NULL,NULL,'2MASX J15504752+5328039',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000095,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.698166667,53.46792,0.017,NULL,59714566537,933040102,14578751,17),(132975,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132975,38.04,0.46,405,62400,70,NULL,NULL,'SDSS J155047.75+275646.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.699,27.94619,0.065,NULL,59873779514,935527804,14617621,18.3),(132976,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132976,36.72,0.68,221,62401,70,NULL,NULL,'2MASX J15504903-1511382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,237.704333,-15.194,0.561,NULL,45479369034,710615141,11103361,15.6),(132977,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132977,35.67,0.27,136,62402,70,NULL,NULL,'CGCG 078-082',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',NULL,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,237.706833,13.28864,0.101,NULL,56529499649,883273432,13801147,15.6),(132978,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132978,35.28,0.62,114,62403,70,NULL,NULL,'MCG -01-40-009',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'16',0.4,NULL,NULL,NULL,NULL,NULL,1,237.706875,-7.66628,0.505,NULL,45632980340,713015317,11140864,16),(132979,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132979,37.73,0.27,352,62404,70,NULL,NULL,'2MASX J15505038+2832503',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.7099583,28.54728,0.089,NULL,59866581686,935415338,14615864,17.6),(132980,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132980,35.15,0.2,107,62405,74.4,NULL,NULL,'UGC 10059',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000033,NULL,'15.5g',0.57,'Scd:',NULL,NULL,NULL,NULL,1,237.7110417,22.23869,0.165,NULL,59404744461,928199132,14503111,15.5),(132981,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132981,37.22,0.27,278,62406,70,NULL,NULL,'2MASX J15505087+2815523',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.0002,NULL,'15.5g',0.49,'E0',NULL,NULL,NULL,NULL,1,237.711917,28.26453,0.085,NULL,59873915179,935529924,14617655,15.5),(132982,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132982,38.32,0.46,461,62407,70,NULL,NULL,'2MASX J15505115+3200219',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.713167,32.00614,0.073,NULL,59923507972,936304812,14629762,18.2),(132983,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132983,37.73,0.27,352,62408,70,NULL,NULL,'SDSS J155052.71+281433.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,237.719625,28.24264,0.081,NULL,59873913696,935529901,14617654,18.7),(132984,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132984,37.29,0.46,287,62409,70,NULL,NULL,'2MASX J15505414+0806299',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,237.72575,8.10817,0.085,NULL,56637220962,884956577,13827446,16.4),(132985,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132985,37.01,0.46,253,62410,70,NULL,NULL,'2MASX J15505493+1729264',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.728875,17.49075,0.061,NULL,59429947576,928592930,14509264,17.5),(132986,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132986,37.36,0.46,296,62411,70,NULL,NULL,'2MASX J15505703+3256149',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00017,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,237.7375417,32.93758,0.073,NULL,59889884835,935779450,14621553,16.6),(132987,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132987,37.87,0.27,376,62412,70,NULL,NULL,'2MASX J15505768+1230485',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.74025,12.51336,0.109,NULL,56529162077,883268157,13801064,18.3),(132988,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132988,37.57,0.46,326,62413,70,NULL,NULL,'2MASX J15510101+1916422',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.754167,19.27833,0.073,NULL,59446288904,928848264,14513254,17.6),(132989,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132989,34.8,0.46,91.2,62414,70,NULL,NULL,'CGCG 136-095',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000073,NULL,'15.1g',0.64,NULL,NULL,NULL,NULL,NULL,1,237.7557083,23.01578,0.173,NULL,59407351771,928239871,14503747,15.1),(132990,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132990,34.56,0.2,81.7,62415,74.4,NULL,NULL,'CGCG 078-083 NED01',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000344,NULL,'16.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,237.756625,10.03056,0.085,NULL,56601016654,884390885,13818607,16.2),(132991,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132991,34.64,0.2,84.7,62416,74.4,NULL,NULL,'KUG 1548+241',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000073,NULL,'15.4g',0.43,'Spiral',NULL,NULL,NULL,NULL,1,237.757583,23.96011,0.157,NULL,59398523721,928101933,14501592,15.4),(132992,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132992,36.87,0.46,237,62417,70,NULL,NULL,'2MASX J15510304+0848189',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000153,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.7627083,8.80525,0.121,NULL,56636935726,884952120,13827376,16.9),(132993,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132993,35.63,0.46,133,62418,70,NULL,NULL,'2MASX J15510394+4241236',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000188,NULL,'15.6g',0.47,'E0',NULL,NULL,NULL,NULL,1,237.766333,42.68981,0.049,NULL,59678617571,932478399,14569974,15.6),(132994,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132994,37.36,0.27,296,62419,70,NULL,NULL,'2MASX J15510438+3432050',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.76825,34.53481,0.065,NULL,59887779853,935746560,14621040,16.5),(132995,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,132995,35.24,0.65,112,62420,70,NULL,NULL,'2MASX J15510443-0726340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'16.84',NULL,NULL,NULL,NULL,NULL,NULL,1,237.768458333,-7.44292,0.493,NULL,45631207540,712987617,11140431,16.84),(132996,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132996,37.39,0.46,300,62421,70,NULL,NULL,'2MASX J15510564+2118512',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000187,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,237.773417,21.31414,0.129,NULL,59402483216,928163800,14502559,16.6),(132997,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132997,36.38,0.46,189,62422,70,NULL,NULL,'SDSS J155105.78+201415.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000173,NULL,'17.4g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.774125,20.23756,0.081,NULL,59403354603,928177415,14502772,17.4),(132998,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132998,36.43,0.49,193,62423,75,NULL,'IR','2MFGC 12731',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000175,NULL,'16.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,237.775083,50.37528,0.033,NULL,59725091109,933204548,14581321,16.7),(132999,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',132999,37.27,0.27,284,62424,70,NULL,NULL,'2MASX J15510641+5250449',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000107,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.7764583,52.84583,0.013,NULL,59715345395,933052271,14578941,16.6),(133000,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133000,37.45,0.46,309,62425,70,NULL,NULL,'2MASX J15510677+0707349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.7782917,7.12633,0.069,NULL,56638413847,884975216,13827737,17.2),(133001,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133001,37.71,0.27,348,62426,70,NULL,NULL,'2MASX J15510688+5324430',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.778625,53.41186,0.017,NULL,59714564534,933040070,14578751,17.3),(133002,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133002,37.79,0.11,362,62427,70,NULL,NULL,'2MASX J15510684+2751234',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.7787083,27.8565,0.065,NULL,59873781000,935527828,14617622,17.1),(133003,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133003,37.93,0.46,386,62428,70,NULL,NULL,'2MASX J15510715+0839439',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.779916667,8.66225,0.121,NULL,56637699167,884964049,13827563,18.3),(133004,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133004,36.52,NULL,202,62429,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1962',NULL,'2010Ap&SS.325..163P',2010,1,0.77,NULL,'G',NULL,NULL,'16.8',0.09,'Sc',NULL,NULL,NULL,NULL,1,237.78,50.375,0.033,NULL,59725091122,933204548,14581321,16.8),(133005,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133005,36.53,NULL,202,62429,NULL,NULL,NULL,'FGC 1962',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133006,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133006,36.55,NULL,204,62429,NULL,NULL,'Dipole + Quadrupole','FGC 1962',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133007,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133007,36.59,NULL,208,62429,NULL,NULL,'Dipole','FGC 1962',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133008,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133008,37.27,0.27,284,62430,70,NULL,NULL,'2MASX J15510960+5247449',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000083,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.790041667,52.79583,0.013,NULL,59715334385,933052099,14578939,17.3),(133009,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133009,36.4,0.46,191,62431,70,NULL,NULL,'2MASX J15510971+4510106',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.7904583,45.16961,0.049,NULL,59689727908,932651998,14572687,16.4),(133010,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133010,36.69,0.46,218,62432,70,NULL,NULL,'SDSS J155109.79+501245.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,237.790833,50.21269,0.037,NULL,59725106587,933204790,14581324,17.3),(133011,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133011,37.4,0.46,302,62433,70,NULL,NULL,'2MASX J15511038+0829409',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.793208333,8.49472,0.093,NULL,56637676763,884963699,13827557,16.9),(133012,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133012,36.5,0.46,200,62434,70,NULL,NULL,'2MASX J15511146+0953169',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000176,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,237.7977083,9.88808,0.085,NULL,56600107714,884376683,13818385,16.2),(133013,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133013,37.71,0.27,348,62435,70,NULL,NULL,'SDSS J155111.56+532957.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,237.7982083,53.49925,0.017,NULL,59714554566,933039915,14578748,18.3),(133014,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133014,38.06,0.46,409,62436,70,NULL,NULL,'2MASX J15511157+0019109',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.9g',0.26,'AGN',NULL,NULL,NULL,NULL,1,237.7982917,0.31961,0.301,NULL,56475801379,882434396,13788037,16.9),(133015,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133015,35.09,0.8,104,62437,75,NULL,'CF, r','UGC 10062',NULL,'1997ApJS..109..333W',1997,1,1.28,NULL,'G',0.000033,NULL,'14.9g',0.62,'Scd:',NULL,NULL,NULL,NULL,1,237.799375,21.94264,0.161,NULL,59404749305,928199207,14503112,14.9),(133016,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133016,34.46,0.38,77.9,62437,75,NULL,'CF, r, raw','UGC 10062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133017,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133017,34.54,0.38,81,62437,75,NULL,'CF, r, inv','UGC 10062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133018,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133018,34.61,0.38,83.4,62437,75,NULL,'CF, r, cor','UGC 10062',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133019,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133019,34.68,0.2,86.3,62437,74.4,NULL,NULL,'UGC 10062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133020,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133020,33.99,0.49,62.8,62438,70,NULL,NULL,'ESO 042- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00012,NULL,'14.3b',0.8,'S0-a',NULL,NULL,NULL,NULL,1,237.80125,-74.70256,0.365,NULL,44123135527,689423992,10772249,14.3),(133021,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133021,37.66,0.46,340,62439,70,NULL,NULL,'2MASX J15511438+3722392',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.809916667,37.37744,0.037,NULL,59762251218,933785175,14590393,17.8),(133022,'Tully est','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133022,32.61,0.8,33.2,62440,75,NULL,NULL,'UGC 10061',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'14.0',1.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,237.812875,16.32956,0.065,NULL,56535000092,883359376,13802490,14),(133023,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133023,37.42,0.46,305,62441,70,NULL,NULL,'2MASX J15511597+2217580',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000183,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.816625,22.29936,0.165,NULL,59404620588,928197196,14503081,17.9),(133024,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133024,37.82,0.46,366,62442,70,NULL,NULL,'2MASX J15511598+0231039',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000084,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,237.816667,2.51767,0.333,NULL,56608250534,884503914,13820373,18.5),(133025,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133025,37.88,0.46,377,62443,70,NULL,NULL,'2MASX J15511939+2847231',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.83075,28.78981,0.133,NULL,59866607634,935415744,14615871,17.7),(133026,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133026,35.97,0.46,157,62444,70,NULL,NULL,'2MASX J15511952+0642162',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.831291667,6.70464,0.085,NULL,56637919779,884967496,13827617,16.3),(133027,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133027,36.84,0.46,233,62445,70,NULL,NULL,'2MASX J15512177+0538569',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.840666667,5.64925,0.141,NULL,56619158846,884674356,13823036,16.9),(133028,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133028,37.51,0.46,318,62446,70,NULL,NULL,'2MASX J15512203+4703275',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,237.84175,47.05761,0.053,NULL,59712417143,933006517,14578226,16.7),(133029,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133029,39.22,0.46,700,62447,70,NULL,NULL,'SDSS J155122.85+181832.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.84525,18.30908,0.037,NULL,59446021731,928844089,14513188,18.2),(133030,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133030,37.19,0.46,274,62448,70,NULL,NULL,'2MASX J15512360+4003202',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000175,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,237.848167,40.05556,0.033,NULL,59794819487,934294054,14598344,15.8),(133031,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133031,37.99,0.46,397,62449,70,NULL,NULL,'2MASX J15512395+3647142',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.8497917,36.78739,0.041,NULL,59880050003,935625781,14619152,17.8),(133032,'HII region diameter','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133032,31.96,NULL,24.7,62450,NULL,NULL,NULL,'NGC 6015',NULL,'1988ApL&C..27...41S',1988,1,5.4,NULL,'G',0.000003,NULL,'11.69',2.1,'SA(s)cd        HII','Isolated galaxy',NULL,NULL,NULL,1,237.855125,62.31003,0.029,NULL,57734465978,902101030,14095328,11.69),(133033,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133033,31.17,0.8,17.1,62450,75,NULL,'A82, H','NGC 6015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133034,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133034,30.09,0.69,10.4,62450,100,NULL,'mid-IR','NGC 6015',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133035,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133035,30.91,0.35,15.2,62450,NULL,NULL,NULL,'NGC 6015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133036,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133036,30.92,0.4,15.3,62450,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 6015',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133037,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133037,30.94,0.34,15.4,62450,NULL,NULL,'Malmquist cor.','NGC 6015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133038,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133038,31,0.47,15.9,62450,75,NULL,'A82, H, raw','NGC 6015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133039,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133039,31.06,0.47,16.3,62450,75,NULL,'A82, H, inv','NGC 6015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133040,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133040,31.22,0.4,17.5,62450,75,NULL,'B','NGC 6015',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133041,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133041,31.27,0.47,17.9,62450,75,NULL,'A82, H, cor','NGC 6015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133042,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133042,31.37,0.43,18.8,62450,75,NULL,'3.6 micron, color corrected','NGC 6015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133043,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133043,31.39,0.43,18.9,62450,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133044,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133044,31.39,0.2,19,62450,74.4,NULL,NULL,'NGC 6015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133045,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133045,31.53,0.26,20.2,62450,NULL,NULL,NULL,'NGC 6015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133046,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133046,37.62,0.46,335,62451,70,NULL,NULL,'2MASX J15512703+3316209',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.862666667,33.27253,0.073,NULL,59890433157,935788018,14621687,17.1),(133047,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133047,37.49,0.33,315,62452,70,NULL,NULL,'2MASX J15512715+0907462',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.863125,9.12936,0.081,NULL,56636892019,884951437,13827366,17.2),(133048,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133048,37.18,0.46,273,62453,70,NULL,NULL,'2MASX J15512748+2237111',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,237.864625,22.61981,0.153,NULL,59404603029,928196922,14503076,16.3),(133049,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133049,38.21,0.46,439,62454,70,NULL,NULL,'SDSS J155128.16+024627.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000088,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,237.867333,2.77419,0.325,NULL,56608332223,884505190,13820393,18.6),(133050,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133050,37.69,0.46,346,62455,70,NULL,NULL,'2MASX J15512822+2436492',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.867583333,24.61378,0.145,NULL,59397717668,928089338,14501395,16.8),(133051,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133051,37.69,0.46,345,62456,70,NULL,NULL,'SDSS J155128.26+090352.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.8677917,9.06458,0.105,NULL,56636926993,884951984,13827374,18.2),(133052,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133052,37.49,0.33,315,62457,70,NULL,NULL,'2MASX J15512971+0857482',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,237.87375,8.96325,0.113,NULL,56636922132,884951908,13827373,17.4),(133053,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133053,35.61,0.2,132,62458,74.4,NULL,NULL,'KUG 1549+245',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.00005,NULL,'15.7g',0.35,'S?',NULL,NULL,NULL,NULL,1,237.873875,24.435,0.161,NULL,59398590983,928102984,14501609,15.7),(133054,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133054,38.02,0.46,401,62459,70,NULL,NULL,'2MASX J15513191+1939101',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.882875,19.65269,0.101,NULL,59400504174,928132877,14502076,17.7),(133055,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133055,35.98,0.46,157,62460,70,NULL,NULL,'2MASX J15513315+3817573',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000178,NULL,'15.8g',0.37,'S0',NULL,NULL,NULL,NULL,1,237.888167,38.29942,0.025,NULL,59764271731,933816745,14590886,15.8),(133056,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133056,37.27,0.27,284,62461,70,NULL,NULL,'2MASX J15513338+5247510',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,237.888917,52.7975,0.013,NULL,59715328529,933052008,14578937,16.6),(133057,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133057,37.87,0.27,376,62462,70,NULL,NULL,'2MASX J15513355+1228362',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,237.889791667,12.47669,0.109,NULL,56529253201,883269581,13801087,16.9),(133058,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133058,37.73,0.27,352,62463,70,NULL,NULL,'2MASX J15513524+2817322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,237.896958333,28.29228,0.081,NULL,59873842319,935528786,14617637,17.2),(133059,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133059,37.43,0.46,306,62464,70,NULL,NULL,'2MASXi J1551355+334630',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,237.8982917,33.77511,0.069,NULL,59890330772,935786418,14621662,17.7),(133060,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133060,35.67,0.27,136,62465,70,NULL,NULL,'CGCG 078-089',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000103,NULL,'15.6',0.61,NULL,NULL,NULL,NULL,NULL,1,237.8994583,13.18808,0.101,NULL,56529411311,883272051,13801125,15.6),(133061,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133061,38.55,0.46,513,62466,70,NULL,NULL,'SDSS J155136.21+183344.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.900917,18.56244,0.033,NULL,59446121940,928845655,14513213,18.7),(133062,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133062,36.9,0.46,240,62467,70,NULL,NULL,'2MASX J15513633+0911132',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000181,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,237.901333,9.187,0.081,NULL,56632660782,884885324,13826333,16.8),(133063,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133063,36.44,0.2,194,62468,74.4,NULL,NULL,'UGC 10066',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.90',0.1,'S?',NULL,NULL,NULL,NULL,1,237.9037083,23.79017,0.157,NULL,59398285137,928098205,14501534,15.9),(133064,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133064,35.87,0.49,149,62469,75,NULL,'IR','UGC 10066',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.90',0.1,'S?',NULL,NULL,NULL,NULL,1,237.9037083,23.79017,0.157,NULL,59398285137,928098205,14501534,15.9),(133065,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133065,37.4,0.33,302,62470,70,NULL,NULL,'2MASX J15513765+2849282',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000155,NULL,'16.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,237.906875,28.82456,0.117,NULL,59866561918,935415029,14615859,16.7),(133066,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133066,37.79,0.11,362,62471,70,NULL,NULL,'2MASX J15514189+2753472',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000175,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,237.924583,27.89642,0.065,NULL,59874643716,935541308,14617832,16.7),(133067,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133067,37.7,0.46,347,62472,70,NULL,NULL,'SDSS J155142.90+204656.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000126,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,237.92875,20.78228,0.085,NULL,59402623625,928165994,14502593,18.5),(133068,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133068,35.98,0.46,157,62473,70,NULL,NULL,'2MASX J15514378+0946082',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.932375,9.76894,0.085,NULL,56632684142,884885689,13826338,16.3),(133069,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133069,34.29,0.2,72.1,62474,74.4,NULL,NULL,'KUG 1549+128',NULL,'2013AJ....146...86T',2013,1,0.9,'Tarenghi, et al. (1994,AJ,107,1629) give v = 13107 +/- 99 km/sec.','G',0.000009,NULL,'15.1',0.4,'Spiral',NULL,NULL,NULL,NULL,1,237.936375,12.74236,0.121,NULL,56529121030,883267516,13801054,15.1),(133070,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133070,38.14,0.46,425,62475,70,NULL,NULL,'2MASX J15514515+2121107',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.938125,21.35292,0.129,NULL,59402464283,928163504,14502554,17.9),(133071,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133071,37,0.46,251,62476,70,NULL,NULL,'2MASX J15514590+3745462',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,237.941125,37.76292,0.041,NULL,59764343669,933817869,14590904,17.5),(133072,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133072,36.47,0.46,197,62477,70,NULL,NULL,'2MASX J15514592+1808047',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.9412083,18.13469,0.045,NULL,59429336255,928583378,14509115,16.5),(133073,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133073,36.1,0.46,166,62478,70,NULL,NULL,'2MASX J15514686-0006190',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000093,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,237.945125,-0.10517,0.353,NULL,45518989856,711234216,11113034,15.9),(133074,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133074,37.4,0.33,302,62479,70,NULL,NULL,'2MASX J15514709+2851382',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,237.9462083,28.86064,0.117,NULL,59866561380,935415021,14615859,17.4),(133075,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133075,37.87,0.27,376,62480,70,NULL,NULL,'2MASX J15514748+1228311',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,237.947875,12.47519,0.109,NULL,56529254573,883269602,13801087,17.2),(133076,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133076,38.23,0.33,442,62481,70,NULL,NULL,'2MASX J15514918+1225371',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,237.955,12.42689,0.109,NULL,56529243922,883269436,13801084,17.8),(133077,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133077,37.79,0.11,362,62482,70,NULL,NULL,'SDSS J155154.21+280117.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,237.975917,28.02158,0.057,NULL,59873857087,935529016,14617640,18.1),(133078,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133078,37.52,0.27,319,62483,70,NULL,NULL,'2MASX J15515728+2226037',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000202,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,237.988667,22.43444,0.153,NULL,59404640834,928197513,14503086,16.8),(133079,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133079,36.73,0.46,222,62484,70,NULL,NULL,'2MASX J15515793+5353561',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000085,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,237.99125,53.89892,0.013,NULL,59697535768,932773996,14574593,16.4),(133080,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133080,37.06,0.46,258,62485,70,NULL,NULL,'2MASX J15515798+0313212',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,237.991625,3.22244,0.305,NULL,56621175172,884705862,13823529,17.5),(133081,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133081,37.47,0.46,312,62486,70,NULL,NULL,'2MASX J15515881+0011122',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,237.995,0.18678,0.369,NULL,56473919629,882404994,13787578,17.4),(133082,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133082,38.23,0.33,442,62487,70,NULL,NULL,'2MASX J15520044+1224399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.001667,12.41117,0.109,NULL,56529014924,883265858,13801029,17.4),(133083,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133083,37.22,0.46,278,62488,70,NULL,NULL,'2MASX J15520151+2312377',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000173,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.0062083,23.21056,0.149,NULL,59406338325,928224036,14503500,16.3),(133084,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133084,37,0.46,251,62489,70,NULL,NULL,'2MASX J15520176+3240137',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,238.007333,32.67061,0.065,NULL,59889913308,935779895,14621560,16.6),(133085,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133085,37.79,0.11,362,62490,70,NULL,NULL,'2MASX J15520258+2744245',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.010791667,27.74014,0.073,NULL,59874649066,935541391,14617834,17.1),(133086,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133086,37.79,0.11,362,62491,70,NULL,NULL,'2MASX J15520354+2757365',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000182,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.01475,27.96017,0.065,NULL,59874561542,935540024,14617812,17.8),(133087,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133087,37.79,0.11,362,62492,70,NULL,NULL,'2MASX J15520363+2751595',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000207,NULL,'16.0g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,238.01525,27.86658,0.065,NULL,59874673728,935541777,14617840,16),(133088,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133088,35.67,0.27,136,62493,70,NULL,NULL,'UGC 10068',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000157,NULL,'14.50',0.8,'S0',NULL,NULL,NULL,NULL,1,238.0152917,12.89869,0.117,NULL,56529061419,883266584,13801040,14.5),(133089,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133089,37.3,0.46,288,62494,70,NULL,NULL,'2MASX J15520682+2733315',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.028333,27.55872,0.097,NULL,59874639811,935541247,14617831,16.7),(133090,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133090,37.86,0.46,373,62495,70,NULL,NULL,'2MASX J15520840+3322187',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.034875,33.37192,0.069,NULL,59890450506,935788289,14621692,18.3),(133091,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133091,37.88,0.33,376,62496,70,NULL,NULL,'2MASX J15520913+2005477',NULL,'2015arXiv151105856S',2015,1,0.48,'Probable core of 3C 326. See 1990MNRAS.246P..21R','G',0.001,NULL,'16.8g',0.26,'LIG',NULL,NULL,NULL,NULL,1,238.038,20.09658,0.093,NULL,59403401484,928178148,14502783,16.8),(133092,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133092,37.96,0.46,390,62497,70,NULL,NULL,'2MASX J15520977+2718386',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.040875,27.31061,0.085,NULL,59874154857,935533669,14617713,17.4),(133093,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133093,38.37,0.46,472,62498,70,NULL,NULL,'2MASX J15521070+5646089',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.0445417,56.76911,0,NULL,57642706657,900667291,14072926,17.4),(133094,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133094,36.7,0.46,219,62499,70,NULL,NULL,'MCG +06-35-012',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000214,NULL,'15.3g',0.63,'E0',NULL,NULL,NULL,NULL,1,238.044833,34.08428,0.069,NULL,59887977063,935749641,14621088,15.3),(133095,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133095,37.57,0.33,326,62500,70,NULL,NULL,'2MASX J15521082+5513319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.045167,55.22558,0.009,NULL,57641611215,900650175,14072658,17.5),(133096,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133096,37.18,0.23,273,62501,70,NULL,NULL,'2MASX J15521126+0432112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.047,4.53653,0.237,NULL,56622342287,884724098,13823814,17.1),(133097,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133097,37.65,0.46,339,62502,70,NULL,NULL,'2MASX J15521224+4817192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.051167,48.2885,0.041,NULL,59724046602,933188228,14581066,17.4),(133098,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133098,37.99,0.46,397,62503,70,NULL,NULL,'2MASX J15521275+0640237',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.0529583,6.67336,0.097,NULL,56637985148,884968517,13827633,17.4),(133099,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133099,37.61,0.33,333,62504,70,NULL,NULL,'2MASX J15521437+1021307',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.9g',0.27,'AGN',NULL,NULL,NULL,NULL,1,238.059916667,10.35858,0.089,NULL,56600555111,884383673,13818494,16.9),(133100,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133100,37.27,0.46,284,62505,70,NULL,NULL,'2MASX J15521435+2618416',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.059958333,26.31169,0.125,NULL,59870814957,935481483,14616898,16.9),(133101,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133101,38.59,0.46,522,62506,70,NULL,NULL,'SDSS J155214.40+545420.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00007,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.06,54.90578,0.017,NULL,57638934915,900608358,14072005,18.6),(133102,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133102,37.29,0.46,287,62507,70,NULL,NULL,'SDSS J155214.73+513538.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.061417,51.59394,0.017,NULL,59717885435,933091959,14579561,18.2),(133103,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133103,37,0.46,251,62508,70,NULL,NULL,'2MASX J15521590+3333327',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,238.066208333,33.55903,0.069,NULL,59890440380,935788130,14621689,16.5),(133104,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133104,37.29,0.46,286,62509,70,NULL,NULL,'2MASX J15521635+1210590',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.0680417,12.18308,0.101,NULL,56599518629,884367478,13818241,17.8),(133105,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133105,37.98,0.46,395,62510,70,NULL,NULL,'2MASX J15521722+3454498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000134,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.071583,34.91394,0.061,NULL,59888274111,935754282,14621160,18.2),(133106,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133106,37.48,0.46,314,62511,70,NULL,NULL,'2MASX J15521843+3011368',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000191,NULL,'15.9g',0.39,NULL,NULL,NULL,NULL,NULL,1,238.077,30.19356,0.089,NULL,59922203881,936284435,14629444,15.9),(133107,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133107,37.9,0.46,380,62512,70,NULL,NULL,'2MASX J15521854+1015355',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.077208333,10.25969,0.089,NULL,56600452205,884382065,13818469,17.1),(133108,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133108,36.84,0.46,233,62513,70,NULL,NULL,'2MASX J15521853+2914006',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000117,NULL,'17.0g',0.26,'S0',NULL,NULL,NULL,NULL,1,238.0772917,29.23333,0.109,NULL,59867263034,935425984,14616031,17),(133109,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133109,37.18,0.23,273,62514,70,NULL,NULL,'2MASX J15521869+0430402',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.077833,4.51108,0.237,NULL,56622325260,884723832,13823809,16.3),(133110,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133110,37.26,0.46,283,62515,70,NULL,NULL,'2MASX J15522133+2345015',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.089,23.75033,0.145,NULL,59398237247,928097456,14501522,17.6),(133111,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133111,37.57,0.33,326,62516,70,NULL,NULL,'2MASX J15522146+5515310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000076,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.089625,55.2585,0.009,NULL,57641611347,900650177,14072659,17.5),(133112,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133112,36.89,0.46,239,62517,70,NULL,NULL,'2MASX J15522211+1619270',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.0922917,16.32425,0.057,NULL,56534908963,883357952,13802468,17.2),(133113,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133113,37.52,0.27,319,62518,70,NULL,NULL,'2MASX J15522239+2233115',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000207,NULL,'15.7g',0.54,NULL,NULL,NULL,NULL,NULL,1,238.093167,22.55333,0.153,NULL,59407451143,928241424,14503772,15.7),(133114,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133114,38.1,0.33,416,62519,70,NULL,NULL,'2MASX J15522312+2820336',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,238.0962917,28.34264,0.081,NULL,59873826199,935528534,14617633,18.6),(133115,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133115,37.18,0.23,273,62520,70,NULL,NULL,'SDSS J155223.88+042928.2',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.0995417,4.49117,0.237,NULL,56622323108,884723798,13823809,17),(133116,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133116,37.48,0.46,314,62521,70,NULL,NULL,'2MASX J15522418+2422085',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.10075,24.36886,0.161,NULL,59397842351,928091286,14501426,17.6),(133117,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133117,37.52,0.27,319,62522,70,NULL,NULL,'SDSS J155225.63+223417.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.106833,22.57158,0.153,NULL,59407451275,928241426,14503772,18.2),(133118,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133118,36.76,0.46,225,62523,70,NULL,NULL,'2MASX J15522848+2534096',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000188,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.11875,25.56933,0.129,NULL,59871486792,935491981,14617062,16.2),(133119,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133119,36.32,0.46,184,62524,70,NULL,NULL,'2MASX J15522856+1331130',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,238.118833,13.52028,0.101,NULL,56529829903,883278592,13801228,16.3),(133120,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133120,37.79,0.11,362,62525,70,NULL,NULL,'2MASX J15522867+2741166',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.1195417,27.68775,0.073,NULL,59874700743,935542199,14617846,17.3),(133121,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133121,37.98,0.46,395,62526,70,NULL,NULL,'SDSS J155229.50-002821.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.122958333,-0.47256,0.353,NULL,45519062082,711235345,11113052,18.4),(133122,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133122,37.79,0.11,362,62527,70,NULL,NULL,'2MASX J15522955+2705086',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.12325,27.08589,0.073,NULL,59874199189,935534362,14617724,17),(133123,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133123,37.35,0.46,296,62528,70,NULL,NULL,'2MASX J15522998+0704285',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.125041667,7.07458,0.069,NULL,56638804640,884981322,13827833,17.2),(133124,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133124,37.83,0.33,369,62529,70,NULL,NULL,'2MASX J15523040+1253160',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.126583,12.88792,0.117,NULL,56530190289,883284223,13801315,17.1),(133125,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133125,37.4,0.46,302,62530,70,NULL,NULL,'2MASX J15523086+5528159',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000074,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.1287083,55.47103,0.005,NULL,57642093924,900657717,14072776,17.6),(133126,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133126,37.48,0.46,313,62531,70,NULL,NULL,'2MASX J15523234+0817085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.134833,8.28569,0.069,NULL,56637076636,884954322,13827411,17.6),(133127,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133127,37.59,0.46,329,62532,70,NULL,NULL,'SDSS J155233.12+253620.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.138,25.60567,0.129,NULL,59870973972,935483968,14616937,18.1),(133128,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133128,38.07,0.46,410,62533,70,NULL,NULL,'2MASX J15523564+2550406',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000187,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.148583,25.84469,0.133,NULL,59870959465,935483741,14616933,17.7),(133129,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133129,37.18,0.23,273,62534,70,NULL,NULL,'2MASX J15523748+0431065',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.156083,4.51847,0.181,NULL,56622332660,884723947,13823811,17.2),(133130,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133130,37.61,0.33,333,62535,70,NULL,NULL,'SDSS J155239.29+102629.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.16375,10.44144,0.077,NULL,56600515211,884383050,13818485,18.2),(133131,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133131,37.69,0.46,345,62536,70,NULL,NULL,'2MASX J15523972+3544068',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.1655,35.73522,0.053,NULL,59891527418,935805115,14621954,18.5),(133132,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133132,37.88,0.33,376,62537,70,NULL,NULL,'SDSS J155240.43+200825.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,238.1685,20.14039,0.081,NULL,59403351777,928177371,14502771,NULL),(133133,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133133,37.37,0.46,299,62538,70,NULL,NULL,'SDSS J155240.78+051612.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.1699583,5.27022,0.157,NULL,56611976525,884562133,13821283,18.2),(133134,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133134,37.57,0.46,327,62539,70,NULL,NULL,'2MASX J15524125+4618101',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.172208333,46.30269,0.045,NULL,59682676110,932541814,14570965,17.3),(133135,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133135,36.39,0.46,190,62540,70,NULL,NULL,'2MASX J15524206+1028015',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.1754583,10.46719,0.077,NULL,56600514712,884383042,13818485,16.5),(133136,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133136,37.7,0.46,346,62541,70,NULL,NULL,'2MASX J15524319+2900536',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000152,NULL,'17.1g',0.22,'S0',NULL,NULL,NULL,NULL,1,238.179958333,29.01483,0.101,NULL,59867224281,935425379,14616021,17.1),(133137,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133137,37.97,0.46,392,62542,70,NULL,NULL,'2MASX J15524370+1355241',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.18225,13.92339,0.105,NULL,56527989848,883249841,13800778,17.1),(133138,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133138,37.36,0.27,296,62543,70,NULL,NULL,'2MASX J15524421+3438248',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,238.1842083,34.64042,0.065,NULL,59888359609,935755618,14621181,16.6),(133139,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133139,37.83,0.33,369,62544,70,NULL,NULL,'2MASX J15524449+1258201',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.185417,12.97233,0.125,NULL,56530704757,883292261,13801441,16.8),(133140,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133140,37.47,0.46,311,62545,70,NULL,NULL,'2MASX J15524494+1855248',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.187166667,18.92353,0.049,NULL,59399926638,928123853,14501935,16.7),(133141,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133141,37.27,0.33,285,62546,70,NULL,NULL,'SDSS J155245.30-003329.9',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.18875,-0.55833,0.385,NULL,45519071314,711235489,11113054,17.2),(133142,'SGRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133142,40.71,NULL,1390,62547,70,NULL,'Amati relation, minimum D','GRB 060923B',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,238.194583,-30.90381,0.641,NULL,47168808102,737012626,11515822,NULL),(133143,'SGRB','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133143,42.46,NULL,3100,62547,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 060923B',NULL,'2012A&A...545A..77R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133144,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133144,37.27,0.33,285,62548,70,NULL,NULL,'2MASX J15524712-0030061',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000109,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.1962917,-0.50175,0.385,NULL,45519071144,711235486,11113054,17.5),(133145,'CMD','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'N',133145,16.9,0.3,0.02,62549,NULL,NULL,NULL,'Draco II/Laevens 4',NULL,'2015ApJ...813...44L',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133146,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133146,35.27,0.2,113,62550,74.4,NULL,NULL,'UGC 10074',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.98',0.6,'Scd:',NULL,NULL,NULL,NULL,1,238.199417,24.39022,0.137,NULL,59397887764,928091996,14501437,14.98),(133147,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133147,38.26,0.46,450,62551,70,NULL,NULL,'2MASX J15524793+1647261',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.1997083,16.79061,0.073,NULL,56531545076,883305391,13801646,17.9),(133148,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133148,37.36,0.27,296,62552,70,NULL,NULL,'2MASX J15524916+3436568',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.55',0.48,'BrClG',NULL,NULL,NULL,NULL,1,238.204667,34.61586,0.065,NULL,59888349223,935755456,14621179,16.55),(133149,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133149,35.78,0.57,143,62553,70,NULL,NULL,'2MASX J15524972-1444256',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.18',0.4,NULL,NULL,NULL,NULL,NULL,1,238.2072917,-14.74072,0.589,NULL,45479875999,710623062,11103485,16.18),(133150,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133150,37.35,0.33,295,62554,70,NULL,NULL,'2MASX J15525004+2811235',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.208333,28.18986,0.081,NULL,59874549473,935539835,14617809,17.3),(133151,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133151,37.67,0.46,342,62555,70,NULL,NULL,'2MASX J15525024+1204311',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.20925,12.07525,0.073,NULL,56601617825,884400278,13818754,17.7),(133152,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133152,38.05,0.46,408,62556,70,NULL,NULL,'SDSS J155252.04+174128.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.216875,17.69136,0.065,NULL,56531063070,883297860,13801529,18.3),(133153,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133153,33.91,0.2,60.5,62557,74.4,NULL,NULL,'NGC 6013',NULL,'2013AJ....146...86T',2013,1,1.41,NULL,'G',0.000417,NULL,'14.0g',0.73,'SBb','Field galaxy',NULL,NULL,NULL,1,238.220167,40.64672,0.045,NULL,59797525857,934336341,14599005,14),(133154,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133154,34.27,0.4,71.5,62557,NULL,NULL,'mean','NGC 6013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133155,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133155,34.49,0.47,79.2,62557,NULL,NULL,'H','NGC 6013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133156,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133156,34.58,0.45,82.6,62557,NULL,NULL,'K','NGC 6013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133157,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,NULL,133157,34.59,0.46,82.8,62557,NULL,NULL,'J','NGC 6013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133158,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133158,36.88,0.46,238,62558,70,NULL,NULL,'2MASX J15525291+2556585',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.2204583,25.94942,0.133,NULL,59870956272,935483691,14616932,16.6),(133159,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133159,36.26,0.46,179,62559,70,NULL,NULL,'2MASX J15525544+0043044',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000084,NULL,'16.4g',0.28,'E0',NULL,NULL,NULL,NULL,1,238.2309583,0.71803,0.325,NULL,56473813758,882403339,13787552,16.4),(133160,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133160,35.4,0.22,116,62560,74.2,NULL,'SALT 2','MCG +11-19-025',0.036,'2010ApJ...716..712A',2010,1,0.65,NULL,'G',0.000066,NULL,'17',0.13,NULL,NULL,NULL,NULL,NULL,1,238.232208333,65.93558,0.045,NULL,57954959340,905546239,14149159,17),(133161,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133161,35.95,0.2,149,62560,72,NULL,NULL,'MCG +11-19-025',0.036,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133162,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133162,35.95,0.17,155,62560,70.8,NULL,NULL,'MCG +11-19-025',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133163,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133163,36.03,0.08,161,62560,74.4,NULL,NULL,'MCG +11-19-025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133164,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133164,36.11,0.27,161,62560,70,NULL,'SALT','MCG +11-19-025',0.036,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133165,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133165,36.11,0.07,161,62560,70,NULL,NULL,'MCG +11-19-025',0.036,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133166,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133166,36.13,0.15,162,62560,70,NULL,'SALT 2','MCG +11-19-025',0.036,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133167,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133167,36.16,0.08,165,62560,65,NULL,'SALT2','MCG +11-19-025',0.036,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133168,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133168,36.17,0.15,165,62560,73.8,NULL,'SALT 2 (SNANA)','MCG +11-19-025',0.0369,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133169,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133169,36.21,0.03,168,62560,72,NULL,NULL,'MCG +11-19-025',0.036,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133170,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133170,36.28,0.27,174,62560,65,NULL,'SALT','MCG +11-19-025',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133171,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133171,36.21,0.17,175,62560,72,NULL,NULL,'MCG +11-19-025',NULL,'2006AJ....131.1639K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133172,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133172,36.38,0.1,176,62560,65,NULL,'MLCS2k2','MCG +11-19-025',0.036,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133173,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133173,36.3,0.03,176,62560,70,NULL,'SALT 2','MCG +11-19-025',0.036,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133174,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133174,36.32,0.15,177,62560,65,NULL,'MLCS17','MCG +11-19-025',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133175,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133175,36.33,0.16,178,62560,65,NULL,'MLCS31','MCG +11-19-025',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133176,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133176,36.33,0.18,178,62560,65,NULL,'SALT2','MCG +11-19-025',0.036,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133177,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133177,36.36,0.06,180,62560,65,NULL,'MLCS2k2','MCG +11-19-025',0.036,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133178,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133178,36.36,0.11,181,62560,65,NULL,'MLCS2k2','MCG +11-19-025',0.036,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133179,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133179,36.39,0.18,183,62560,65,NULL,NULL,'MCG +11-19-025',0.036,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133180,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133180,36.44,0.03,188,62560,65,NULL,'SALT','MCG +11-19-025',0.036,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133181,'SNIa','2016-12-15 15:15:37','2016-12-16 11:20:51','1','SN 2000cf',NULL,133181,36.42,0.14,192,62560,60,NULL,NULL,'MCG +11-19-025',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133182,'FP','2016-12-15 15:15:37','2016-12-16 11:20:51','1',NULL,'R',133182,37.44,0.33,307,62561,70,NULL,NULL,'2MASX J15525583+4747360',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.232625,47.79322,0.049,NULL,59712850429,933013287,14578332,17.4),(133183,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133183,38.39,0.46,477,62562,70,NULL,NULL,'2MASX J15525664+0028354',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.2360417,0.47653,0.369,NULL,56473852942,882403952,13787561,18.3),(133184,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133184,38.1,0.33,416,62563,70,NULL,NULL,'2MASX J15525713+2811584',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000183,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.237917,28.19956,0.081,NULL,59874547488,935539804,14617809,17.3),(133185,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133185,37.79,0.11,362,62564,70,NULL,NULL,'2MASX J15525730+2739474',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00011,NULL,'15.9g',0.52,NULL,NULL,NULL,NULL,NULL,1,238.238667,27.66331,0.073,NULL,59874694500,935542101,14617845,15.9),(133186,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133186,37.35,0.33,295,62565,70,NULL,NULL,'2MASX J15525868+2759025',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.244541667,27.98406,0.057,NULL,59874591542,935540492,14617820,17.3),(133187,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133187,37.26,0.33,283,62566,70,NULL,NULL,'SDSS J155259.39+243055.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.2475,24.51539,0.141,NULL,59397880311,928091879,14501435,18.1),(133188,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133188,35.25,0.48,112,62567,70,NULL,NULL,'ESO 515- G 013',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000033,NULL,'12.48',0.7,'SA(rs)b',NULL,NULL,NULL,NULL,1,238.251875,-27.29208,0.809,NULL,47123705388,736307896,11504810,12.48),(133189,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133189,35.35,0.8,118,62567,75,NULL,'MAT, I','ESO 515- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133190,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133190,35.27,0.43,113,62567,75,NULL,'MAT, I, raw','ESO 515- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133191,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133191,35.63,0.43,134,62567,75,NULL,'MAT, I, cor','ESO 515- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133192,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133192,35.67,0.43,136,62567,75,NULL,'MAT, I, inv','ESO 515- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133193,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133193,35.74,0.32,140,62567,85,NULL,'I, raw','ESO 515- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133194,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133194,35.84,0.32,147,62567,85,NULL,'I, inv','ESO 515- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133195,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133195,35.88,0.4,150,62567,NULL,NULL,'Malmquist cor.','ESO 515- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133196,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133196,35.91,0.39,152,62567,NULL,NULL,NULL,'ESO 515- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133197,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133197,35.95,0.2,155,62567,74.4,NULL,NULL,'ESO 515- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133198,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133198,38.12,0.46,421,62568,70,NULL,NULL,'2MASX J15530147+3926194',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.256125,39.43875,0.033,NULL,59760986912,933765420,14590084,17.8),(133199,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133199,36.69,0.46,218,62569,70,NULL,NULL,'2MASX J15530150+2302286',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,238.256167,23.04119,0.149,NULL,59406385410,928224772,14503512,16.3),(133200,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133200,37.54,0.33,322,62570,70,NULL,NULL,'2MASX J15530255+3402388',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'16.3g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,238.2607083,34.04408,0.069,NULL,59887984096,935749751,14621089,16.3),(133201,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133201,38.06,0.46,409,62571,70,NULL,NULL,'2MASX J15530376+0224504',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000089,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.2657917,2.41403,0.289,NULL,56474292706,882410823,13787669,17.7),(133202,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133202,38.53,0.46,508,62572,70,NULL,NULL,'2MASX J15530387+1213161',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.26625,12.22108,0.073,NULL,56527162980,883236921,13800576,17.7),(133203,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133203,34.17,0.51,68.2,62573,NULL,NULL,NULL,'ESO 515- G 014',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.58',0.3,'S...',NULL,NULL,NULL,NULL,1,238.2697917,-24.63594,0.637,NULL,46583136501,727861507,11372836,14.58),(133204,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133204,34.21,0.2,69.5,62573,74.4,NULL,NULL,'ESO 515- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133205,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133205,34.38,0.47,75.2,62573,NULL,NULL,'Malmquist cor.','ESO 515- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133206,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133206,37.46,0.46,311,62574,70,NULL,NULL,'SDSS J155305.69+494312.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000126,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.273708333,49.72019,0.037,NULL,59725618526,933212789,14581449,18.5),(133207,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133207,34.58,0.46,82.3,62575,70,NULL,NULL,'NGC 6008B',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000153,NULL,'14.9g',0.48,'E','in a pair',NULL,NULL,NULL,1,238.2845417,21.07464,0.085,NULL,59402571386,928165177,14502580,14.9),(133208,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133208,38.04,0.46,405,62576,70,NULL,NULL,'2MASX J15530871+1914005',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.286375,19.23344,0.049,NULL,59400628732,928134823,14502106,16.7),(133209,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133209,37.79,0.11,362,62577,70,NULL,NULL,'SDSS J155309.37+273955.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,238.289083333,27.66542,0.073,NULL,59874693771,935542090,14617845,18.7),(133210,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133210,37.84,0.23,370,62578,70,NULL,NULL,'2MASX J15531040+2734475',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.293333,27.57992,0.109,NULL,59874518406,935539350,14617802,17.6),(133211,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133211,37.17,0.46,272,62579,70,NULL,NULL,'SDSS J155311.12-001007.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000069,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,238.296333333,-0.16878,0.365,NULL,45519131435,711236428,11113069,18.7),(133212,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133212,38.47,0.46,494,62580,70,NULL,NULL,'SDSS J155311.76+062646.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.299041667,6.44639,0.101,NULL,56629611509,884837679,13825588,18.2),(133213,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133213,37.79,0.11,362,62581,70,NULL,NULL,'2MASX J15531213+2726255',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.300583333,27.44028,0.097,NULL,59874047228,935531987,14617687,18),(133214,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133214,37.18,0.46,273,62582,70,NULL,NULL,'2MASX J15531354+3124453',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000179,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.3065417,31.41258,0.077,NULL,59920159453,936252491,14628945,16.3),(133215,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133215,36.53,0.46,202,62583,70,NULL,NULL,'2MASX J15531390+3654356',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000173,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.308,36.90994,0.041,NULL,59762367738,933786995,14590421,16.5),(133216,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133216,38.18,0.33,433,62584,70,NULL,NULL,'2MASX J15531438+0926427',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.7g',0.18,'BrClG',NULL,NULL,NULL,NULL,1,238.309875,9.44514,0.109,NULL,56632969043,884890141,13826408,17.7),(133217,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133217,37.9,0.23,380,62585,70,NULL,NULL,'2MASX J15531341+3650206',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.311125,36.83722,0.041,NULL,59762375865,933787122,14590423,18.1),(133218,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133218,37.3,0.46,288,62586,70,NULL,NULL,'2MASX J15531531+0947577',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000195,NULL,'15.9g',0.48,'E0',NULL,NULL,NULL,NULL,1,238.3137917,9.79956,0.089,NULL,56633350229,884896097,13826501,15.9),(133219,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133219,37.41,0.46,303,62587,70,NULL,NULL,'2MASX J15531531+2522255',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,238.313875,25.37386,0.157,NULL,59870613825,935478341,14616849,16.9),(133220,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133220,37.44,0.33,307,62588,70,NULL,NULL,'2MASX J15531558+4748320',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.3147917,47.80903,0.049,NULL,59712819806,933012809,14578325,16.9),(133221,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133221,39,0.46,631,62589,70,NULL,NULL,'SDSS J155317.95+270136.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.324833333,27.02678,0.109,NULL,59874184885,935534138,14617720,18.4),(133222,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133222,38.18,0.33,433,62590,70,NULL,NULL,'2MASX J15531904+0925187',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.329333333,9.42206,0.109,NULL,56632982557,884890352,13826411,17.8),(133223,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133223,37.04,0.46,256,62591,70,NULL,NULL,'2MASX J15531921+2156098',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.33,21.936,0.121,NULL,59407754295,928246160,14503846,17.7),(133224,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133224,38.02,0.33,401,62592,70,NULL,NULL,'2MASX J15531925+1256561',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.33025,12.94906,0.125,NULL,56530221064,883284704,13801323,16.7),(133225,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133225,35.97,0.46,156,62593,70,NULL,NULL,'CGCG 275-013',NULL,'2015arXiv151105856S',2015,1,0.58,'GSC 3870-0287 (mag. 14) superposed 16 arcsec northwest of nucleus.','G',0.000102,NULL,'15.3g',0.52,'S0^-',NULL,NULL,NULL,NULL,1,238.333833,54.70814,0.021,NULL,57639084973,900610702,14072042,15.3),(133226,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133226,35.11,0.2,105,62594,74.4,NULL,NULL,'NGC 6007',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000017,NULL,'13.82',1.2,'SABbc:         HII',NULL,NULL,NULL,NULL,1,238.346583,11.95919,0.073,NULL,56598231304,884347364,13817927,13.82),(133227,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133227,35.81,0.47,145,62594,NULL,NULL,'H','NGC 6007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133228,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133228,35.96,0.4,155,62594,NULL,NULL,'mean','NGC 6007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133229,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133229,35.96,0.46,156,62594,NULL,NULL,'J','NGC 6007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133230,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133230,36,0.45,159,62594,NULL,NULL,'K','NGC 6007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133231,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133231,36.88,0.2,238,62595,74.4,NULL,NULL,'NGC 6009',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000123,NULL,'15.4',0.3,NULL,NULL,NULL,NULL,NULL,1,238.350333,12.05867,0.073,NULL,56598263552,884347868,13817935,15.4),(133232,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133232,38.33,0.33,463,62596,70,NULL,NULL,'2MASX J15532449+3242024',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.352167,32.70067,0.077,NULL,59886950011,935733593,14620837,18.1),(133233,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133233,36.35,0.46,186,62597,70,NULL,NULL,'SDSS J155324.69+040457.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,238.352875,4.08256,0.245,NULL,56613255414,884582115,13821595,NULL),(133234,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133234,36.46,0.46,196,62598,70,NULL,NULL,'B2 1551+36B',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.1g',0.37,'S0^-',NULL,NULL,NULL,'USS',1,238.354417,36.71619,0.041,NULL,59761658955,933775921,14590248,16.1),(133235,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133235,37.9,0.23,380,62599,70,NULL,NULL,'2MASX J15532508+3651326',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.3544583,36.85894,0.041,NULL,59762375495,933787117,14590423,17.6),(133236,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133236,37.59,0.46,330,62600,70,NULL,NULL,'2MASX J15532534+1115307',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.3557083,11.2585,0.089,NULL,56601420496,884397195,13818706,17.8),(133237,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133237,37.79,0.11,362,62601,70,NULL,NULL,'2MASX J15532569+2749085',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.357083,27.81914,0.109,NULL,59874717970,935542468,14617851,17.7),(133238,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133238,37.73,0.46,352,62602,70,NULL,NULL,'2MASX J15532771+4142236',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.3655,41.7065,0.041,NULL,59796611146,934322049,14598782,17.4),(133239,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133239,35.53,0.25,128,62603,74.4,NULL,NULL,'CGCG 223-010',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000143,NULL,'14.7g',0.62,'E','Field galaxy',NULL,NULL,NULL,1,238.370417,41.5805,0.041,NULL,59796619028,934322172,14598783,14.7),(133240,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133240,35.74,0.35,140,62603,70,NULL,NULL,'CGCG 223-010',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133241,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133241,35.78,0.19,143,62603,70,NULL,NULL,'CGCG 223-010',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133242,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133242,36.84,0.46,233,62604,70,NULL,NULL,'2MASX J15532897-0039343',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.37075,-0.6595,0.385,NULL,45519532342,711242692,11113167,17.2),(133243,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133243,36.92,0.46,243,62605,70,NULL,NULL,'2MASX J15532943+4651075',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,238.372583,46.85197,0.033,NULL,59713141108,933017829,14578403,16),(133244,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133244,37.39,0.17,300,62606,70,NULL,NULL,'2MASX J15532959+3531494',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'16.9g',0.31,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,238.3732083,35.53056,0.057,NULL,59887366189,935740096,14620939,16.9),(133245,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133245,37.9,0.23,380,62607,70,NULL,NULL,'2MASX J15532966+3647196',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.373667,36.78867,0.041,NULL,59762363848,933786935,14590420,17.1),(133246,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133246,38.04,0.27,406,62608,70,NULL,NULL,'2MASX J15532985+1154357',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.3742917,11.90986,0.061,NULL,56598443896,884350685,13817979,17.6),(133247,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133247,35.7,0.46,138,62609,70,NULL,NULL,'GIN 534',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000073,NULL,'15.5g',0.54,'E/S0',NULL,NULL,NULL,NULL,1,238.378667,18.358,0.053,NULL,59399743147,928120986,14501890,15.5),(133248,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133248,36.44,0.18,194,62609,70,NULL,NULL,'GIN 534',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133249,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133249,36.52,0.25,201,62609,74.4,NULL,NULL,'GIN 534',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133250,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133250,38.46,0.46,492,62610,70,NULL,NULL,'2MASX J15533110+3750166',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.3797083,37.83783,0.041,NULL,59764237013,933816203,14590878,18),(133251,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133251,37.5,0.46,316,62611,70,NULL,NULL,'2MASX J15533153+2912347',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.381208333,29.20978,0.109,NULL,59867379766,935427808,14616059,17.9),(133252,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133252,37.31,0.46,290,62612,70,NULL,NULL,'2MASX J15533217+1718107',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'17.0g',0.24,'AGN',NULL,NULL,NULL,NULL,1,238.384083,17.30303,0.065,NULL,56531745201,883308518,13801695,17),(133253,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133253,37.9,0.23,380,62613,70,NULL,NULL,'2MASX J15533307+3648146',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000183,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.387708333,36.80392,0.041,NULL,59762364076,933786938,14590420,18),(133254,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133254,36.92,0.46,242,62614,70,NULL,NULL,'2MASX J15533316+3429074',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.388333333,34.48542,0.065,NULL,59888337041,935755266,14621176,16.8),(133255,'BL Lac Luminosity','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133255,40.08,NULL,1040,62615,NULL,NULL,'Min. z = 0.28','6dF J1553336-311830',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'VisS',NULL,NULL,'15.5R',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,238.3900417,-31.30836,0.633,NULL,47165747321,736964801,11515075,15.5),(133256,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133256,38.33,0.33,463,62616,70,NULL,NULL,'2MASX J15533408+3242523',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.3920417,32.71464,0.077,NULL,59886979748,935734058,14620844,17.8),(133257,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133257,38.45,0.46,489,62617,70,NULL,NULL,'2MASX J15533451+1232407',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.393917,12.54461,0.077,NULL,56530074591,883282415,13801287,18.1),(133258,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133258,38.2,0.46,436,62618,70,NULL,NULL,'SDSS J155334.61+220740.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.3942083,22.12789,0.121,NULL,59407783318,928246614,14503853,18.3),(133259,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133259,37.79,0.11,362,62619,70,NULL,NULL,'2MASX J15533475+2715077',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.394708333,27.252,0.089,NULL,59874067898,935532310,14617692,17.1),(133260,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133260,37.39,0.33,301,62620,70,NULL,NULL,'2MASX J15533499+3941596',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.395625,39.69978,0.033,NULL,59794283869,934285685,14598213,17.3),(133261,'IRAS','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133261,33.84,0.8,58.6,62621,75,NULL,'HMCL, I','ESO 136- G 006',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000053,NULL,'14.8',0.3,'Sc;LSB disk    Sy2',NULL,NULL,NULL,NULL,1,238.397,-61.68289,NULL,NULL,44864188517,701002945,10953171,14.8),(133262,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133262,33.21,0.4,43.8,62621,75,NULL,'HMCL, I, raw','ESO 136- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133263,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133263,33.41,0.4,48,62621,75,NULL,'HMCL, I, inv','ESO 136- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133264,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133264,33.47,0.4,49.5,62621,75,NULL,'HMCL, I, cor','ESO 136- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133265,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133265,33.61,0.46,52.7,62621,NULL,NULL,'J','ESO 136- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133266,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133266,33.62,0.47,52.9,62621,NULL,NULL,'H','ESO 136- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133267,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133267,33.7,0.49,55.1,62621,75,NULL,'IR','ESO 136- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133268,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133268,33.71,0.45,55.3,62621,NULL,NULL,'K','ESO 136- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133269,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133269,33.73,0.4,55.8,62621,NULL,NULL,'mean','ESO 136- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133270,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133270,37.01,0.46,252,62622,70,NULL,NULL,'2MASX J15533640+2426447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.4017917,24.44583,0.141,NULL,59397873864,928091779,14501434,17.5),(133271,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133271,38.1,0.46,416,62623,70,NULL,NULL,'2MASX J15533768+0038039',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.407041667,0.63433,0.365,NULL,56473995194,882406174,13787596,17.4),(133272,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133272,37.84,0.23,370,62624,70,NULL,NULL,'2MASX J15533782+2737248',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.407667,27.62361,0.109,NULL,59874526989,935539484,14617804,17.3),(133273,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133273,36.31,0.46,183,62625,70,NULL,NULL,'2MASX J15533999+1928209',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'15.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,238.416625,19.47239,0.057,NULL,59400551698,928133620,14502087,15.8),(133274,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133274,38,0.33,398,62626,70,NULL,NULL,'2MASX J15534002+1747387',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,238.416875,17.794,0.061,NULL,56531056991,883297765,13801527,18.4),(133275,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133275,36.74,0.46,223,62627,70,NULL,NULL,'2MASX J15534099+3539512',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.420667,35.66419,0.053,NULL,59887330302,935739535,14620930,16.6),(133276,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133276,37.7,0.33,347,62628,70,NULL,NULL,'2MASX J15534122+2026559',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.4217083,20.44897,0.085,NULL,59403846038,928185094,14502892,18.3),(133277,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133277,37.29,0.46,288,62629,70,NULL,NULL,'2MASX J15534153+4029067',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00014,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.423083,40.48508,0.053,NULL,59797941317,934342833,14599106,17.1),(133278,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133278,35.4,NULL,120,62630,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1966',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',0.000063,NULL,'16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,238.424167,45.40694,0.053,NULL,59682293414,932535834,14570872,16.6),(133279,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133279,35.42,NULL,121,62630,NULL,NULL,'Dipole + Quadrupole','FGC 1966',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133280,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133280,35.43,NULL,122,62630,NULL,NULL,'Dipole','FGC 1966',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133281,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133281,35.45,NULL,123,62630,NULL,NULL,NULL,'FGC 1966',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133282,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133282,37.26,0.46,284,62631,70,NULL,NULL,'2MASX J15534227+1738597',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.426333,17.64997,0.061,NULL,56530984459,883296632,13801509,16.7),(133283,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133283,38,0.33,398,62632,70,NULL,NULL,'2MASX J15534275+1748587',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.428333,17.81625,0.061,NULL,56531056885,883297763,13801527,17.5),(133284,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133284,37.39,0.17,300,62633,70,NULL,NULL,'2MASX J15534480+3528552',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,238.436708333,35.48203,0.057,NULL,59887370066,935740157,14620939,16.6),(133285,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133285,34.93,0.57,96.9,62634,70,NULL,NULL,'2MASX J15534487-0242203',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,238.436917,-2.70564,0.517,NULL,45517688558,711213883,11112716,15.5),(133286,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133286,35.55,0.25,129,62635,74.4,NULL,NULL,'GIN 449',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.00009,NULL,'16.0g',0.33,'S','Field galaxy',NULL,NULL,NULL,1,238.439417,41.39036,0.029,NULL,59796464787,934319762,14598746,16),(133287,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133287,35.74,0.35,140,62635,70,NULL,NULL,'GIN 449',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133288,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133288,37.7,0.33,347,62636,70,NULL,NULL,'2MASX J15534557+2025284',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,238.439833333,20.42453,0.085,NULL,59403845648,928185088,14502892,NULL),(133289,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133289,37.39,0.17,300,62637,70,NULL,NULL,'2MASX J15534768+3521573',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.448625,35.36603,0.057,NULL,59887535400,935742740,14620980,18.3),(133290,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133290,38.02,0.33,401,62638,70,NULL,NULL,'2MASX J15534781+1253377',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.449333,12.89389,0.125,NULL,56530126825,883283231,13801300,17.7),(133291,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133291,36.19,0.46,173,62639,70,NULL,NULL,'GIN 533',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00008,NULL,'15.5g',0.52,'SB0',NULL,NULL,NULL,NULL,1,238.45825,18.34133,0.053,NULL,59399749618,928121087,14501891,15.5),(133292,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133292,36.25,0.25,178,62639,74.4,NULL,NULL,'GIN 533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133293,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133293,36.44,0.18,194,62639,70,NULL,NULL,'GIN 533',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133294,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133294,38.05,0.46,407,62640,70,NULL,NULL,'2MASX J15535116+1309517',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.46325,13.16442,0.133,NULL,56530822566,883294102,13801470,17.1),(133295,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133295,37.61,0.21,332,62641,70,NULL,NULL,'2MASX J15535119+2852247',NULL,'2015arXiv151105856S',2015,1,0.25,'2001AJ....122.2893W has z = +- 0.095466 +- 0.000183.','G',0.000156,NULL,'17.2g',0.25,'E',NULL,NULL,NULL,NULL,1,238.463291667,28.87356,0.117,NULL,59867361017,935427515,14616054,17.2),(133296,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133296,36.92,0.98,242,62642,70,NULL,NULL,'2MASX J15535222-0538260',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,238.467583,-5.64064,0.525,NULL,45595180484,712424695,11131635,15.1),(133297,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133297,35.54,0.25,128,62643,74.4,NULL,NULL,'GIN 452',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000147,NULL,'16.1g',0.35,'S','Field galaxy',NULL,NULL,NULL,1,238.470083,41.49767,0.029,NULL,59796607843,934321997,14598781,16.1),(133298,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133298,35.74,0.35,140,62643,70,NULL,NULL,'GIN 452',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133299,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133299,35.78,0.19,143,62643,70,NULL,NULL,'GIN 452',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133300,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133300,37.81,0.46,364,62644,70,NULL,NULL,'2MASX J15535303+2932357',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.6g',0.14,'AGN',NULL,NULL,NULL,NULL,1,238.4709583,29.54319,0.097,NULL,59867081635,935423150,14615986,17.6),(133301,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133301,37.51,0.46,318,62645,70,NULL,NULL,'SDSS J155353.17+393040.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.471583,39.51128,0.041,NULL,59794316536,934286195,14598221,18),(133302,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133302,37.54,0.33,322,62646,70,NULL,NULL,'SDSS J155353.19+335744.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.471667,33.96244,0.065,NULL,59890055513,935782117,14621595,18.3),(133303,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133303,37.69,0.46,345,62647,70,NULL,NULL,'2MASX J15535663+2736417',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.486083,27.61142,0.109,NULL,59874541145,935539705,14617807,16.9),(133304,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133304,37.77,0.46,357,62648,70,NULL,NULL,'2MASX J15535672+3558157',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,238.486333,35.971,0.065,NULL,59775132967,933986452,14593538,17.6),(133305,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133305,37.22,0.46,278,62649,70,NULL,NULL,'2MASX J15535678+2119024',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.486583,21.31733,0.133,NULL,59402367481,928161991,14502531,16.9),(133306,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133306,38.85,0.46,588,62650,70,NULL,NULL,'2MASX J15535812+3317313',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.492125,33.29206,0.073,NULL,59890084001,935782562,14621602,17.7),(133307,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133307,36.04,0.46,161,62651,70,NULL,NULL,'2MASX J15535882+1953154',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.4952083,19.88761,0.053,NULL,59403207865,928175122,14502736,16.7),(133308,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133308,38.15,0.46,426,62652,70,NULL,NULL,'2MASX J15540085+2810174',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.503667,28.17161,0.109,NULL,59874340439,935536569,14617758,17.4),(133309,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133309,37.26,0.33,283,62653,70,NULL,NULL,'2MASX J15540100+2422514',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.504167,24.38092,0.141,NULL,59397680379,928088755,14501386,17),(133310,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133310,37.79,0.11,362,62654,70,NULL,NULL,'2MASX J15540105+2728084',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000181,NULL,'16.4g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,238.504291667,27.46889,0.097,NULL,59874485050,935538828,14617794,16.4),(133311,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133311,36.18,0.46,172,62655,70,NULL,NULL,'2MASX J15540203+0356420',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'17.09',0.37,NULL,NULL,NULL,NULL,NULL,1,238.508625,3.94506,0.297,NULL,56613212907,884581451,13821585,17.09),(133312,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133312,36.3,0.46,182,62656,70,NULL,NULL,'MCG +06-35-013',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000192,NULL,'15.4g',0.47,'S0',NULL,NULL,NULL,NULL,1,238.50875,37.17147,0.025,NULL,59762495601,933788993,14590453,15.4),(133313,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133313,36.37,0.46,188,62657,70,NULL,NULL,'2MASX J15540265+4229556',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000178,NULL,'15.8g',0.37,'S0^-','Field galaxy',NULL,NULL,NULL,1,238.510916667,42.49894,0.061,NULL,59677800372,932465630,14569775,15.8),(133314,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133314,38.04,0.27,406,62658,70,NULL,NULL,'2MASX J15540266+1147461',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.5112083,11.79628,0.061,NULL,56598289800,884348278,13817941,17.8),(133315,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133315,38.04,0.27,406,62659,70,NULL,NULL,'SDSS J155402.80+114619.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.511667,11.77217,0.061,NULL,56598289454,884348272,13817941,18.2),(133316,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133316,35.37,0.46,119,62660,70,NULL,NULL,'2MASX J15540325+1712384',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00018,NULL,'17.27',0.32,NULL,NULL,NULL,NULL,NULL,1,238.513583,17.21081,0.053,NULL,56531482153,883304408,13801631,17.27),(133317,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133317,37.7,0.46,346,62661,70,NULL,NULL,'2MASX J15540376+2954543',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000188,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,238.5155417,29.91511,0.093,NULL,59866936514,935420883,14615951,16.3),(133318,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133318,38.33,0.46,463,62662,70,NULL,NULL,'2MASX J15540433+5528329',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.5182083,55.47592,NULL,NULL,57642303753,900660996,14072828,17.5),(133319,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133319,37.79,0.11,362,62663,70,NULL,NULL,'2MASX J15540466+2722404',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.519583,27.37797,0.097,NULL,59874022727,935531605,14617681,17.8),(133320,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133320,36.49,0.33,198,62664,70,NULL,NULL,'2MASX J15540516+0835161',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.521417,8.58797,0.065,NULL,56639464078,884991626,13827994,17.8),(133321,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133321,36.33,0.69,185,62665,70,NULL,NULL,'2MASX J15540529-0424270',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,238.522125,-4.40742,0.597,NULL,45593636416,712400569,11131258,16.1),(133322,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133322,37.03,0.46,254,62666,70,NULL,NULL,'2MASX J15540557+1013041',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.523166667,10.21778,0.125,NULL,56633214080,884893970,13826468,17.1),(133323,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133323,37.01,0.33,253,62667,70,NULL,NULL,'2MASX J15540585+2649044',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.524417,26.81794,0.117,NULL,59877578429,935587162,14618549,16.5),(133324,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133324,36.25,0.25,178,62668,74.4,NULL,NULL,'CGCG 107-053',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.000167,NULL,'15.2g',0.55,'SAb:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,238.524917,18.64767,0.053,NULL,59399974185,928124596,14501946,15.2),(133325,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133325,36.44,0.18,194,62669,70,NULL,NULL,'GIN 531',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000077,NULL,'14.43',NULL,'S',NULL,NULL,NULL,NULL,1,238.525291667,18.6475,0.053,NULL,59399974185,928124596,14501946,14.43),(133326,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133326,36.04,0.46,161,62670,70,NULL,NULL,'2MASX J15540712+4743151',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000142,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.5297083,47.72078,0.049,NULL,59712944357,933014755,14578355,16.8),(133327,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133327,37.16,0.46,270,62671,70,NULL,NULL,'2MASX J15540777+0633371',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.532375,6.56033,0.129,NULL,56629564676,884836948,13825577,16.9),(133328,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133328,38.02,0.46,402,62672,70,NULL,NULL,'2MASX J15540793+3802167',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.533,38.03803,0.041,NULL,59764485924,933820092,14590938,17.8),(133329,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133329,37.15,0.46,269,62673,70,NULL,NULL,'2MASX J15540837+3925437',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,238.5347083,39.42892,0.025,NULL,59794271943,934285499,14598210,16.7),(133330,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133330,36.49,0.33,198,62674,70,NULL,NULL,'2MASX J15540853+0835281',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00018,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,238.535625,8.59122,0.065,NULL,56639463840,884991622,13827994,15.8),(133331,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133331,38.65,0.46,537,62675,70,NULL,NULL,'2MASX J15540886+1916064',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.537,19.26847,0.049,NULL,59400781412,928137209,14502143,17.5),(133332,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133332,36.98,0.46,249,62676,70,NULL,NULL,'2MASX J15540977+2321234',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000133,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.54075,23.35653,0.153,NULL,59406845666,928231963,14503624,17),(133333,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133333,37.84,0.23,370,62677,70,NULL,NULL,'2MASX J15540976+2730094',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000204,NULL,'16.5g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,238.540833,27.50261,0.097,NULL,59874486923,935538858,14617794,16.5),(133334,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133334,37.94,0.33,387,62678,70,NULL,NULL,'2MASX J15540999+1229234',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.541667,12.48997,0.077,NULL,56527387575,883240430,13800631,17.5),(133335,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133335,38.47,0.19,494,62679,70,NULL,NULL,'SDSS J155410.35+331000.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.543166667,33.16672,0.073,NULL,59890075476,935782429,14621600,18.5),(133336,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133336,37.79,0.11,362,62680,70,NULL,NULL,'SDSS J155410.83+272524.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000172,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.545167,27.42356,0.097,NULL,59874023766,935531621,14617681,18.3),(133337,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133337,37.3,0.46,288,62681,70,NULL,NULL,'2MASX J15541128+2051284',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.547125,20.85775,0.073,NULL,59403131662,928173932,14502717,17.8),(133338,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133338,35.32,0.46,116,62682,70,NULL,NULL,'CGCG 166-067',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000083,NULL,'15.3g',0.41,'E0',NULL,NULL,NULL,NULL,1,238.5479583,30.15586,0.089,NULL,59866875066,935419922,14615936,15.3),(133339,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133339,37.78,0.46,359,62683,70,NULL,NULL,'2MASX J15541164+0224090',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.548583,2.40253,0.245,NULL,56474402554,882412539,13787695,17.7),(133340,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133340,35.22,0.49,111,62684,75,NULL,'IR','2MFGC 12763',NULL,'2011yCatp016004901K',2011,1,0.48,NULL,'G',0.000033,NULL,'16.3g',0.45,'S',NULL,NULL,NULL,NULL,1,238.548625,21.56806,0.141,NULL,59407606048,928243844,14503810,16.3),(133341,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133341,34.41,0.2,76.2,62685,74.4,NULL,NULL,'CGCG 078-098',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000279,NULL,'15.7',0.5,NULL,NULL,NULL,NULL,NULL,1,238.5512917,11.86461,0.073,NULL,56598410762,884350168,13817971,15.7),(133342,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133342,38.4,0.46,479,62686,70,NULL,NULL,'SDSS J155413.84+265105.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.557667,26.85156,0.117,NULL,59877585104,935587267,14618551,18.2),(133343,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133343,31.52,0.45,20.1,62687,NULL,NULL,'K','NGC 6012',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000013,NULL,'12.69',1.5,'(R)SB(r)ab:   LINER:','Supercluster foreground object',NULL,NULL,NULL,1,238.558083,14.60125,0.101,NULL,56535162096,883361907,13802529,12.69),(133344,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133344,31.52,0.47,20.2,62687,NULL,NULL,'H','NGC 6012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133345,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133345,31.59,0.46,20.8,62687,NULL,NULL,'J','NGC 6012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133346,'Tully-Fisher','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133346,32.1,0.4,26.3,62687,NULL,NULL,'mean','NGC 6012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133347,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133347,38.47,0.19,494,62688,70,NULL,NULL,'2MASX J15541406+3308161',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.5587083,33.13792,0.081,NULL,59886602582,935728165,14620752,17.5),(133348,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133348,35.54,0.25,128,62689,74.4,NULL,NULL,'GIN 448',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.000078,NULL,'16.0g',0.34,'S','Field galaxy',NULL,NULL,NULL,1,238.559125,41.41517,0.029,NULL,59796475451,934319928,14598748,16),(133349,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,NULL,133349,35.74,0.35,140,62689,70,NULL,NULL,'GIN 448',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133350,'FP','2016-12-15 15:15:37','2016-12-16 11:20:52','1',NULL,'R',133350,37.39,0.33,301,62690,70,NULL,NULL,'2MASX J15541460+3945522',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,238.5607917,39.7645,0.033,NULL,59797701778,934339090,14599048,16.1),(133351,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133351,37.26,0.46,283,62691,70,NULL,NULL,'2MASX J15541483+3840571',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,238.561916667,38.68256,0.013,NULL,59764056321,933813380,14590834,16.9),(133352,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133352,35.4,NULL,120,62692,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1965',NULL,'2010Ap&SS.325..163P',2010,1,0.64,NULL,'G',0.000016,NULL,'16.9',0.09,'Scd',NULL,NULL,NULL,NULL,1,238.5637917,10.96944,0.101,NULL,56598513585,884351774,13817996,16.9),(133353,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133353,35.42,NULL,121,62692,NULL,NULL,'Dipole + Quadrupole','FGC 1965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133354,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133354,35.44,NULL,123,62692,NULL,NULL,'Dipole','FGC 1965',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133355,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133355,36.04,0.2,161,62692,74.4,NULL,NULL,'FGC 1965',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133356,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133356,37.01,0.33,253,62693,70,NULL,NULL,'2MASX J15541661+2650454',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.56925,26.84606,0.117,NULL,59877577738,935587152,14618549,16.7),(133357,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133357,38.2,0.33,437,62694,70,NULL,NULL,'2MASX J15541720+3746492',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.5717917,37.78031,0.061,NULL,59764456795,933819637,14590931,17),(133358,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133358,37.43,0.46,306,62695,70,NULL,NULL,'2MASX J15541740+3435451',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.572333,34.59594,0.065,NULL,59887937013,935749015,14621078,16.8),(133359,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133359,37.94,0.33,387,62696,70,NULL,NULL,'SDSS J155417.59+122505.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.573333,12.41822,0.077,NULL,56527405717,883240714,13800636,18.3),(133360,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133360,38.47,0.19,494,62697,70,NULL,NULL,'2MASX J15541820+3308191',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000147,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.575875,33.13867,0.081,NULL,59886603039,935728172,14620752,17.1),(133361,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133361,38,0.46,399,62698,70,NULL,NULL,'2MASX J15541854+3123151',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.577375,31.38744,0.077,NULL,59920666572,936260415,14629068,17.4),(133362,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133362,31.62,0.2,21.1,62699,74.4,NULL,NULL,'NGC 6010',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000017,NULL,'13.60',0.5,'S0/a: sp',NULL,NULL,NULL,NULL,1,238.5797917,0.54306,0.365,NULL,56474198692,882409354,13787646,13.6),(133363,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133363,31.63,0.36,21.2,62699,NULL,NULL,NULL,'NGC 6010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133364,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133364,31.67,NULL,21.6,62699,72,NULL,NULL,'NGC 6010',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133365,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133365,31.71,0.35,22,62699,NULL,NULL,'Malmquist cor.','NGC 6010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133366,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133366,32.18,0.49,27.3,62699,75,NULL,'IR','NGC 6010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133367,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133367,32.34,0.4,29.3,62699,75,NULL,NULL,'NGC 6010',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133368,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133368,37.84,0.23,370,62700,70,NULL,NULL,'2MASX J15542006+2727474',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,238.583625,27.46317,0.097,NULL,59874486146,935538846,14617794,NULL),(133369,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133369,37.24,0.46,281,62701,70,NULL,NULL,'2MASX J15542016+0357599',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.5840417,3.96667,0.257,NULL,56613527006,884586359,13821661,17.2),(133370,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133370,37.11,0.46,264,62702,70,NULL,NULL,'2MASX J15542042+1021345',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.585167,10.35953,0.125,NULL,56635181378,884924709,13826948,17),(133371,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133371,33.79,0.8,57.2,62703,75,NULL,'HMCL, I','ESO 136- G 008',NULL,'1997ApJS..109..333W',1997,1,1.2,'Confused HIPASS source','G',0.000023,NULL,'14.5',0.3,'S?;cl.to v.br.*',NULL,NULL,NULL,NULL,1,238.596417,-61.34,NULL,NULL,44377951689,693405495,10834460,14.5),(133372,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133372,32.87,0.47,37.4,62703,NULL,NULL,'H','ESO 136- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133373,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133373,32.88,0.46,37.7,62703,NULL,NULL,'J','ESO 136- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133374,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133374,32.9,0.45,38,62703,NULL,NULL,'K','ESO 136- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133375,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133375,32.99,0.4,39.7,62703,75,NULL,'HMCL, I, raw','ESO 136- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133376,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133376,33.17,0.4,43.1,62703,75,NULL,'HMCL, I, inv','ESO 136- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133377,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133377,33.28,0.4,45.3,62703,75,NULL,'HMCL, I, cor','ESO 136- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133378,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133378,33.7,0.4,55,62703,NULL,NULL,'mean','ESO 136- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133379,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133379,37.47,0.11,313,62704,70,NULL,NULL,'SDSS J155423.21+282503.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.59675,28.41756,0.101,NULL,59866800752,935418761,14615918,17.7),(133380,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133380,36.09,0.46,165,62705,70,NULL,NULL,'UGC 10084',NULL,'2015arXiv151105856S',2015,1,1.4,NULL,'G',0.0001,NULL,'14.35',0.8,'S0+?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,238.601,18.652,0.057,NULL,59399978741,928124667,14501947,14.35),(133381,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133381,36.25,0.25,178,62705,74.4,NULL,NULL,'UGC 10084',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133382,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133382,36.44,0.18,194,62705,70,NULL,NULL,'UGC 10084',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133383,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133383,36.97,0.46,248,62706,70,NULL,NULL,'2MASX J15542618+1153025',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,238.609167,11.88417,0.073,NULL,56598398394,884349974,13817968,18),(133384,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133384,38.12,0.46,420,62707,70,NULL,NULL,'2MASX J15542661+1355357',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.610875,13.92664,0.141,NULL,56528507691,883257932,13800905,17.9),(133385,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133385,38.21,0.46,438,62708,70,NULL,NULL,'2MASX J15542672+3915572',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.61125,39.26594,0.037,NULL,59760977260,933765269,14590082,17.9),(133386,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133386,35.58,0.8,131,62709,75,NULL,'W91CL, r','UGC 10085',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'14.86',0.7,'SAcd:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,238.611875,18.5255,0.053,NULL,59399765963,928121343,14501895,14.86),(133387,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133387,35.59,0.8,131,62709,75,NULL,'HMCL, I','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133388,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133388,34.94,0.4,97.5,62709,75,NULL,'HMCL, I, raw','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133389,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133389,35.09,0.38,104,62709,75,NULL,'W91CL, r, raw','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133390,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133390,35.12,0.4,106,62709,75,NULL,'HMCL, I, inv','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133391,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133391,35.24,0.38,112,62709,75,NULL,'W91CL, r, inv','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133392,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133392,35.33,0.4,117,62709,75,NULL,'HMCL, I, cor','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133393,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133393,35.49,0.38,125,62709,75,NULL,'W91CL, r, cor','UGC 10085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133394,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133394,36.3,0.33,182,62710,70,NULL,NULL,'2MASX J15542717+4154132',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.15',NULL,NULL,'Field galaxy',NULL,NULL,NULL,1,238.61325,41.90367,0.073,NULL,59797037731,934328714,14598886,16.15),(133395,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133395,35.03,0.59,101,62711,70,NULL,NULL,'2MASX J15542731-0751126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.16',NULL,NULL,NULL,NULL,NULL,NULL,1,238.6139583,-7.8535,0.549,NULL,45633601273,713025019,11141015,17.16),(133396,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133396,36.4,0.46,191,62712,70,NULL,NULL,'2MASX J15542783+2459174',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000181,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.6159583,24.98819,0.153,NULL,59870561659,935477525,14616836,16.3),(133397,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133397,36.44,0.46,194,62713,70,NULL,NULL,'2MASX J15542830+2525094',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.618,25.41939,0.161,NULL,59874874517,935544914,14617889,17.5),(133398,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133398,38.08,0.46,413,62714,70,NULL,NULL,'2MASX J15542920-0041324',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000077,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.62175,-0.69228,0.385,NULL,45519582619,711243478,11113179,17.7),(133399,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133399,38.41,0.46,480,62715,70,NULL,NULL,'2MASX J15542989+0719175',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.62475,7.3215,0.105,NULL,56638304355,884973505,13827711,17.2),(133400,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133400,37.33,0.46,292,62716,70,NULL,NULL,'2MASX J15543205+2310059',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.633625,23.16825,0.137,NULL,59406357152,928224330,14503505,17),(133401,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133401,37.47,0.11,313,62717,70,NULL,NULL,'2MASX J15543232+2827380',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.634541667,28.46058,0.101,NULL,59866803338,935418802,14615918,16.7),(133402,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133402,36.3,0.33,182,62718,70,NULL,NULL,'2MASX J15543235+4207512',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.634667,42.13092,0.041,NULL,59797022688,934328479,14598882,16.6),(133403,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133403,37.45,0.46,309,62719,70,NULL,NULL,'2MASX J15543299+0954345',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.637291667,9.90961,0.117,NULL,56633196735,884893698,13826464,17.6);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (133404,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133404,37.36,0.23,297,62720,70,NULL,NULL,'2MASX J15543435+1054545',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,238.64325,10.91542,0.101,NULL,56598490379,884351412,13817990,16.3),(133405,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133405,38.43,0.46,486,62721,70,NULL,NULL,'2MASX J15543453+3317062',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.64375,33.28522,0.073,NULL,59890078630,935782478,14621601,17.9),(133406,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133406,36.91,0.46,241,62722,70,NULL,NULL,'2MASX J15543448+5336465',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.9g',0.36,'E0',NULL,NULL,NULL,NULL,1,238.643917,53.61292,0.013,NULL,59697779819,932777809,14574653,15.9),(133407,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133407,39.43,0.46,770,62723,70,NULL,NULL,'SDSS J155434.86+353357.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000132,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.64525,35.56589,0.057,NULL,59766758432,933855600,14591493,18.7),(133408,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133408,38.22,0.33,441,62724,70,NULL,NULL,'2MASX J15543532+2437541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.647125,24.63181,0.145,NULL,59870555867,935477435,14616834,17.2),(133409,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133409,38.7,0.46,551,62725,70,NULL,NULL,'SDSS J155435.94+093823.6',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000174,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.64975,9.63989,0.089,NULL,56632907542,884889180,13826393,17.7),(133410,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133410,35.79,0.27,144,62726,70,NULL,NULL,'MCG +07-33-008',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00017,NULL,'15.2g',0.62,'E0',NULL,NULL,NULL,NULL,1,238.655083,39.76158,0.033,NULL,59797716783,934339324,14599051,15.2),(133411,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133411,36.46,0.33,196,62727,70,NULL,NULL,'2MASX J15543893+1916369',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.662333,19.27703,0.045,NULL,59400743968,928136624,14502134,17),(133412,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133412,38.22,0.33,441,62728,70,NULL,NULL,'SDSS J155439.47+243448.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.6645,24.58014,0.145,NULL,59397643340,928088177,14501377,18.5),(133413,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133413,37.48,0.46,314,62729,70,NULL,NULL,'2MASX J15543982+4449221',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.6660417,44.82269,0.045,NULL,59683409789,932553277,14571144,17.2),(133414,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133414,37.36,0.23,297,62730,70,NULL,NULL,'2MASX J15544052+1101556',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,238.668833333,11.03222,0.101,NULL,56598485819,884351340,13817989,16.5),(133415,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133415,37.47,0.11,313,62731,70,NULL,NULL,'2MASX J15544100+2811301',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.1g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,238.670833,28.19164,0.109,NULL,59874330256,935536410,14617756,16.1),(133416,'Tully est','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133416,32.77,0.8,35.9,62732,75,NULL,'B','UGC 10086',NULL,'1988NBGC.C....0000T',1988,1,0.6,NULL,'G',0.000103,NULL,'15.3',0.2,'S0/a?          HII','Supercluster foreground object',NULL,NULL,NULL,1,238.671875,16.61719,0.061,NULL,56534250663,883347666,13802307,15.3),(133417,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133417,37.61,0.21,332,62733,70,NULL,NULL,'2MASX J15544175+2903161',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.674083,29.05458,0.117,NULL,59867179347,935424677,14616010,17.9),(133418,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133418,37.39,0.17,300,62734,70,NULL,NULL,'2MASX J15544310+3521171',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.6g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,238.6797083,35.35475,0.057,NULL,59766835999,933856812,14591512,16.6),(133419,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133419,35.84,0.49,147,62735,75,NULL,'IR','FGC 1967',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000009,NULL,'16.4',0.11,'Scd',NULL,NULL,NULL,NULL,1,238.68125,4.51697,0.213,NULL,56613303717,884582870,13821607,16.4),(133420,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133420,35.91,NULL,152,62735,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133421,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133421,35.93,NULL,154,62735,NULL,NULL,'Dipole + Quadrupole','FGC 1967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133422,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133422,35.95,NULL,155,62735,NULL,NULL,NULL,'FGC 1967',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133423,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133423,35.95,NULL,155,62735,NULL,NULL,'Dipole','FGC 1967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133424,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133424,37.36,0.23,297,62736,70,NULL,NULL,'2MASX J15544391+1100091',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.683,11.00253,0.101,NULL,56598494655,884351478,13817991,17.4),(133425,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133425,38.47,0.19,494,62737,70,NULL,NULL,'2MASX J15544390+3256471',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000142,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.6830417,32.94639,0.085,NULL,59887071274,935735488,14620867,18.1),(133426,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133426,37.56,0.46,324,62738,70,NULL,NULL,'2MASX J15544411+5508417',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.6837083,55.14481,NULL,NULL,57641931562,900655180,14072737,17.8),(133427,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133427,36.7,0.46,219,62739,70,NULL,NULL,'I Zw 128 NOTES03',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'15.5',0.35,NULL,NULL,NULL,NULL,NULL,1,238.687,45.33828,0.053,NULL,59684051530,932563305,14571301,15.5),(133428,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133428,38.2,0.33,437,62740,70,NULL,NULL,'2MASX J15544605+3746132',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.6917083,37.77039,0.061,NULL,59763728668,933808260,14590754,17.9),(133429,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133429,36.19,0.46,173,62741,70,NULL,NULL,'2MASX J15544667+3237041',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000176,NULL,'15.8g',0.43,'S0',NULL,NULL,NULL,NULL,1,238.694583,32.61772,0.077,NULL,59886961538,935733774,14620840,15.8),(133430,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133430,34.78,0.4,90.4,62742,NULL,NULL,'mean','ESO 389- G 003',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000037,NULL,'13.6R',0.7,'S...',NULL,NULL,NULL,NULL,1,238.696875,-37.58236,1.053,NULL,46257551589,722774243,11293347,13.6),(133431,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133431,34.92,0.47,96.5,62742,NULL,NULL,'H','ESO 389- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133432,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133432,34.99,0.45,99.4,62742,NULL,NULL,'K','ESO 389- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133433,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133433,34.99,0.46,99.7,62742,NULL,NULL,'J','ESO 389- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133434,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133434,38.47,0.19,494,62743,70,NULL,NULL,'2MASX J15544888+3303311',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.7037083,33.05881,0.081,NULL,59886606629,935728228,14620753,17.7),(133435,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133435,37.97,0.46,393,62744,70,NULL,NULL,'SDSS J155450.65+260423.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000151,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,238.711083,26.07308,0.165,NULL,59875462157,935554096,14618032,18.8),(133436,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133436,37.88,0.46,377,62745,70,NULL,NULL,'2MASX J15545063+5546447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.711125,55.779,0,NULL,57641437206,900647456,14072616,17.7),(133437,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133437,37.87,0.46,375,62746,70,NULL,NULL,'2MASX J15545098+2749431',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000187,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,238.7125,27.82878,0.109,NULL,59874388541,935537320,14617770,16.4),(133438,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133438,37.97,0.46,392,62747,70,NULL,NULL,'2MASX J15545195+5601507',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000093,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,238.716333333,56.03078,0,NULL,57641321328,900645645,14072588,16.9),(133439,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133439,34.35,0.8,74.2,62748,75,NULL,'HMCL, I','UGC 10089',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000027,NULL,'15.52',0.2,'Scd:',NULL,NULL,NULL,NULL,1,238.717083,21.11669,0.081,NULL,59402935183,928170862,14502669,15.52),(133440,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133440,34.07,0.2,65.2,62748,74.4,NULL,NULL,'UGC 10089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133441,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133441,34.3,0.4,72.4,62748,75,NULL,'HMCL, I, raw','UGC 10089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133442,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133442,34.39,0.4,75.5,62748,75,NULL,'HMCL, I, inv','UGC 10089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133443,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133443,34.4,0.4,75.9,62748,75,NULL,'HMCL, I, cor','UGC 10089',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133444,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133444,37.08,0.46,260,62749,70,NULL,NULL,'2MASX J15545298+3610088',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'16.7g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,238.720833,36.16925,0.065,NULL,59775159206,933986862,14593544,16.7),(133445,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133445,37.53,0.46,321,62750,70,NULL,NULL,'SDSS J155455.97+234129.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.7332083,23.69167,0.153,NULL,59407013942,928234592,14503665,18.4),(133446,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133446,37.61,0.46,333,62751,70,NULL,NULL,'2MASX J15545663+4831541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.735875,48.53158,0.041,NULL,59711437531,932991211,14577987,17.4),(133447,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133447,38.47,0.19,494,62752,70,NULL,NULL,'SDSS J155456.62+330022.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.735917,33.00622,0.081,NULL,59887070494,935735476,14620866,18.1),(133448,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133448,37.47,0.46,312,62753,70,NULL,NULL,'2MASX J15545791+4753003',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.7414583,47.88342,0.049,NULL,59712886876,933013857,14578341,18.1),(133449,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133449,37.51,0.46,317,62754,70,NULL,NULL,'2MASX J15545908+2701581',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.74625,27.03278,0.109,NULL,59877534653,935586478,14618538,17.5),(133450,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133450,37.36,0.23,297,62755,70,NULL,NULL,'2MASX J15550034+1052561',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,238.7515,10.88236,0.101,NULL,56631799933,884871873,13826123,16.5),(133451,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133451,36.78,0.2,227,62756,74.4,NULL,NULL,'CGCG 079-005',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.0005,NULL,'15.6',0.2,NULL,'Group member',NULL,NULL,NULL,1,238.752917,11.07411,0.097,NULL,56598695337,884354614,13818040,15.6),(133452,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133452,35.53,0.25,128,62757,74.4,NULL,NULL,'CGCG 223-012',NULL,'2013AJ....146...86T',2013,1,1.12,NULL,'G',0.000087,NULL,'14.2g',0.81,'cD;S?','Field galaxy',NULL,NULL,NULL,1,238.758,41.57833,0.029,NULL,59796915380,934326802,14598856,14.2),(133453,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133453,35.74,0.35,140,62757,70,NULL,NULL,'CGCG 223-012',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133454,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133454,35.78,0.19,143,62757,70,NULL,NULL,'CGCG 223-012',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133455,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133455,37.39,0.17,300,62758,70,NULL,NULL,'2MASX J15550211+3514062',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,238.758875,35.23508,0.053,NULL,59766838452,933856850,14591513,17.8),(133456,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133456,35.88,NULL,150,62759,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 079-004 NED01',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.000131,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,238.760958333,10.937,0.101,NULL,56631803085,884871923,13826123,16.5),(133457,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133457,35.89,NULL,151,62759,NULL,NULL,'Dipole + Quadrupole','CGCG 079-004 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133458,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133458,35.92,NULL,153,62759,NULL,NULL,'Dipole','CGCG 079-004 NED01',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133459,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133459,36.5,0.49,199,62759,75,NULL,'IR','CGCG 079-004 NED01',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133460,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133460,36.56,0.46,205,62760,70,NULL,NULL,'2MASX J15550504+5058062',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.7710417,50.96836,0.017,NULL,59717435498,933084929,14579452,16.8),(133461,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133461,37.74,0.46,353,62761,70,NULL,NULL,'SDSS J155506.15+285430.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.775625,28.90842,0.117,NULL,59866696650,935417135,14615892,18.1),(133462,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133462,35.75,0.46,141,62762,70,NULL,NULL,'2MASX J15550693+3446562',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00018,NULL,'15.4g',0.49,'E',NULL,NULL,NULL,NULL,1,238.778875,34.78228,0.065,NULL,59887925907,935748842,14621075,15.4),(133463,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133463,35.79,0.27,144,62763,70,NULL,NULL,'MCG +07-33-010',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5',0.4,NULL,NULL,NULL,NULL,NULL,1,238.78325,39.75008,0.033,NULL,59797720683,934339385,14599052,16.5),(133464,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133464,37.28,0.33,286,62764,70,NULL,NULL,'MCG +06-35-014',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,238.787625,36.22214,0.057,NULL,59775339280,933989676,14593588,16.3),(133465,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133465,35.53,0.25,128,62765,74.4,NULL,NULL,'GIN 451',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000141,NULL,'16.1g',0.37,'S','Field galaxy',NULL,NULL,NULL,1,238.78925,41.4485,0.029,NULL,59796448236,934319503,14598742,16.1),(133466,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133466,35.74,0.35,140,62765,70,NULL,NULL,'GIN 451',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133467,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133467,37.47,0.11,313,62766,70,NULL,NULL,'2MASX J15550959+2834456',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000174,NULL,'15.7g',0.52,'E0',NULL,NULL,NULL,NULL,1,238.790083333,28.57944,0.113,NULL,59866763292,935418176,14615909,15.7),(133468,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133468,37.36,0.46,297,62767,70,NULL,NULL,'2MASX J15551156+3934239',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000162,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,238.798167,39.57342,0.041,NULL,59797673070,934338641,14599041,16.2),(133469,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133469,38.33,0.33,463,62768,70,NULL,NULL,'2MASX J15551194+2803136',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000177,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.799916667,28.05369,0.109,NULL,59874465267,935538519,14617789,17.4),(133470,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133470,37.39,0.17,300,62769,70,NULL,NULL,'2MASX J15551369+3510052',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.807208333,35.16817,0.053,NULL,59766855115,933857111,14591517,17.9),(133471,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133471,35.53,0.25,128,62770,74.4,NULL,NULL,'GIN 444',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000073,NULL,'15.9g',0.32,'S','Field galaxy',NULL,NULL,NULL,1,238.807625,41.58178,0.029,NULL,59796929279,934327019,14598859,15.9),(133472,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133472,35.74,0.35,140,62770,70,NULL,NULL,'GIN 444',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133473,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133473,35.78,0.19,143,62770,70,NULL,NULL,'GIN 444',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133474,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133474,35.53,0.25,128,62771,74.4,NULL,NULL,'GIN 450',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000142,NULL,'16.5g',0.27,'S',NULL,NULL,NULL,NULL,1,238.808875,41.46722,0.029,NULL,59796918886,934326857,14598857,16.5),(133475,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133475,35.74,0.35,140,62771,70,NULL,NULL,'GIN 450',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133476,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133476,35.78,0.19,143,62771,70,NULL,NULL,'GIN 450',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133477,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133477,37.67,0.46,342,62772,70,NULL,NULL,'2MASX J15551589+1719535',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.816166667,17.33169,0.069,NULL,56564828020,883825437,13809772,18.3),(133478,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133478,37.48,0.46,314,62773,70,NULL,NULL,'SDSS J155516.19+132445.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.8175,13.41261,0.081,NULL,56530515656,883289307,13801395,18.6),(133479,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133479,38.33,0.33,463,62774,70,NULL,NULL,'SDSS J155516.64+281028.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.819333333,28.17464,0.109,NULL,59874450658,935538291,14617785,17.7),(133480,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133480,37.89,0.33,378,62775,70,NULL,NULL,'2MASX J15551666+1926097',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.8195,19.43597,0.033,NULL,59400081097,928126267,14501972,17.3),(133481,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133481,37.31,0.46,290,62776,70,NULL,NULL,'2MASX J15551697+5348272',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000091,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,238.8205417,53.8075,0.013,NULL,59697681774,932776277,14574629,16.6),(133482,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133482,38.31,0.46,460,62777,70,NULL,NULL,'2MASX J15551844+3249552',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,238.8267917,32.83194,0.085,NULL,59887111574,935736118,14620876,17.4),(133483,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133483,37.84,0.46,369,62778,70,NULL,NULL,'2MASX J15551876+3834069',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.828,38.56856,0.013,NULL,59764027678,933812932,14590827,17.4),(133484,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133484,36.23,0.46,176,62779,70,NULL,NULL,'2MASX J15551914+5303512',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000086,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,238.8297083,53.06439,0.013,NULL,59698450919,932788295,14574817,16.1),(133485,'Tully est','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133485,32.46,0.8,31.1,62780,75,NULL,NULL,'UGC 10095',NULL,'1988NBGC.C....0000T',1988,1,1.2,'Multiple SDSS entries describe this source.','G',0.000023,NULL,'16.5',0.6,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,238.8314583,45.42775,0.053,NULL,59684093785,932563965,14571311,16.5),(133486,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133486,32.47,0.4,31.2,62780,NULL,NULL,NULL,'UGC 10095',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133487,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133487,37.41,0.46,303,62781,70,NULL,NULL,'2MASX J15551983+3314530',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.832833,33.24817,0.073,NULL,59886664528,935729133,14620767,17.1),(133488,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133488,37.61,0.21,332,62782,70,NULL,NULL,'2MASX J15552056+2903446',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000191,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.8357083,29.06267,0.105,NULL,59867190088,935424845,14616013,17.8),(133489,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133489,38.51,0.33,503,62783,70,NULL,NULL,'2MASX J15552074+0000522',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.836416667,0.01447,0.405,NULL,56473196913,882393701,13787401,18.3),(133490,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133490,37.61,0.21,332,62784,70,NULL,NULL,'2MASX J15552095+2900507',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.4g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,238.837167,29.01419,0.117,NULL,59867173601,935424587,14616009,17.4),(133491,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133491,37.5,0.33,317,62785,70,NULL,NULL,'2MASX J15552200+4531013',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.841708333,45.51692,0.053,NULL,59684033593,932563024,14571297,16.9),(133492,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133492,38.31,0.46,459,62786,70,NULL,NULL,'2MASX J15552217+0513028',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.842333,5.21736,0.165,NULL,56614533122,884602080,13821907,17.8),(133493,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133493,37.65,0.27,340,62787,70,NULL,NULL,'2MASX J15552234+2714097',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,238.843125,27.23608,0.089,NULL,59877626401,935587912,14618561,16.9),(133494,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133494,37.09,0.33,262,62788,70,NULL,NULL,'2MASX J15552239+5313442',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,238.843417,53.22889,0,NULL,59698502411,932789100,14574829,16.2),(133495,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133495,37.28,0.33,286,62789,70,NULL,NULL,'2MASX J15552461+3612562',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.8524583,36.21575,0.057,NULL,59775346615,933989790,14593590,16.9),(133496,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133496,37.86,0.46,373,62790,70,NULL,NULL,'2MASX J15552464+3426031',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.8527917,34.43431,0.057,NULL,59888081844,935751278,14621113,17.3),(133497,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133497,37.65,0.27,340,62791,70,NULL,NULL,'SDSS J155524.85+271436.9',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.8535417,27.24358,0.089,NULL,59877629268,935587957,14618561,17.7),(133498,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133498,38.51,0.33,503,62792,70,NULL,NULL,'2MASX J15552514+0000212',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000089,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.854625,0.00586,0.405,NULL,56473195242,882393675,13787401,18.6),(133499,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133499,36.16,0.46,170,62793,70,NULL,NULL,'2MASX J15552554+0346548',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.8564583,3.78186,0.257,NULL,56612709417,884573584,13821462,17.7),(133500,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133500,38.29,0.46,455,62794,70,NULL,NULL,'2MASX J15552593+3632342',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.8579583,36.54292,0.049,NULL,59761569700,933774526,14590226,17.6),(133501,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133501,34.25,0.4,70.9,62795,NULL,NULL,'mean','NGC 6068',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000037,NULL,'13.60',0.7,'SBbc?','Pair member (points to parent)',NULL,NULL,NULL,1,238.858291667,78.99678,0.137,NULL,57137304931,892770389,13949537,13.6),(133502,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133502,35.04,0.46,102,62795,NULL,NULL,'J','NGC 6068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133503,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133503,35.07,0.47,103,62795,NULL,NULL,'H','NGC 6068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133504,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133504,35.12,0.45,105,62795,NULL,NULL,'K','NGC 6068',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133505,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133505,35.53,0.25,128,62796,74.4,NULL,NULL,'GIN 447',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.00012,NULL,'15.9g',0.38,'E/S0','Field galaxy',NULL,NULL,NULL,1,238.8627083,41.55828,0.029,NULL,59796927110,934326986,14598859,15.9),(133506,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133506,35.74,0.35,140,62796,70,NULL,NULL,'GIN 447',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133507,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133507,37.16,0.33,271,62797,70,NULL,NULL,'2MASX J15552725+4047332',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.863708333,40.7925,0.045,NULL,59798083284,934345051,14599141,17.8),(133508,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133508,38.4,0.46,478,62798,70,NULL,NULL,'2MASX J15552942+2019567',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,238.872583,20.33233,0.085,NULL,59403776675,928184010,14502875,18.1),(133509,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133509,35.16,0.72,108,62799,70,NULL,NULL,'2MASX J15553033-0513527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,238.876333,-5.23122,0.581,NULL,45596161700,712440026,11131875,15.6),(133510,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133510,37.52,0.46,320,62800,70,NULL,NULL,'2MASX J15553053+4022243',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00014,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.877041667,40.37336,0.037,NULL,59798162468,934346288,14599160,17.3),(133511,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133511,38.13,0.46,424,62801,70,NULL,NULL,'2MASX J15553054+4019353',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000137,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,238.877167,40.3265,0.037,NULL,59798163128,934346298,14599160,17.7),(133512,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133512,36.05,0.46,163,62802,70,NULL,NULL,'2MASX J15553116+1917567',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,238.87975,19.29897,0.045,NULL,59400160648,928127510,14501992,16.1),(133513,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133513,37.49,0.14,315,62803,70,NULL,NULL,'SDSS J155531.75+253946.5',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000164,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,238.882333333,25.66292,0.177,NULL,59875612013,935556437,14618069,18.8),(133514,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133514,37.65,0.27,340,62804,70,NULL,NULL,'2MASX J15553223+2709217',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.88425,27.15603,0.117,NULL,59877647308,935588239,14618566,17.2),(133515,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133515,37.09,0.33,262,62805,70,NULL,NULL,'MCG +09-26-029',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000114,NULL,'15.6g',0.44,'E0',NULL,NULL,NULL,NULL,1,238.892208333,53.03333,0.013,NULL,59698503696,932789120,14574830,15.6),(133516,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133516,37.8,0.46,363,62806,70,NULL,NULL,'2MASX J15553499+3955223',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000146,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,238.8959583,39.92292,0.021,NULL,59797927941,934342624,14599103,17),(133517,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133517,37.89,0.33,378,62807,70,NULL,NULL,'2MASX J15553582+1930107',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.899208333,19.50289,0.033,NULL,59400083861,928126310,14501973,17.7),(133518,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133518,36.46,0.33,196,62808,70,NULL,NULL,'2MASX J15553610+1911157',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.52',0.36,NULL,NULL,NULL,NULL,NULL,1,238.900333333,19.18764,0.049,NULL,59400676274,928135566,14502118,17.52),(133519,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133519,37.39,0.17,300,62809,70,NULL,NULL,'2MASX J15553633+3511031',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000134,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,238.901417,35.18414,0.053,NULL,59766859226,933857175,14591518,16.6),(133520,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133520,37.81,0.46,365,62810,70,NULL,NULL,'2MASX J15553710+4938146',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,238.9044583,49.63733,0.037,NULL,59725783910,933215373,14581490,17),(133521,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133521,37.5,0.33,317,62811,70,NULL,NULL,'2MASX J15553781+4535134',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000185,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.9075,45.58717,0.033,NULL,59684042606,932563165,14571299,16.5),(133522,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133522,37.49,0.14,315,62812,70,NULL,NULL,'2MASX J15553830+2532406',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.909667,25.54472,0.153,NULL,59875609548,935556399,14618068,17.2),(133523,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133523,37.37,0.46,298,62813,70,NULL,NULL,'2MASX J15553934+3520071',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.72',0.43,NULL,NULL,NULL,NULL,NULL,1,238.914,35.33542,0.057,NULL,59766821495,933856585,14591509,16.72),(133524,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133524,37.5,0.27,316,62814,70,NULL,NULL,'2MASX J15553977+0309158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.915667,3.15436,0.265,NULL,56481789663,882527963,13789499,17.5),(133525,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133525,37.61,0.21,332,62815,70,NULL,NULL,'2MASX J15553981+2848006',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,238.915875,28.80036,0.129,NULL,59866820128,935419064,14615922,17.4),(133526,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133526,35.74,0.35,140,62816,70,NULL,NULL,'GIN 445',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',0.000107,NULL,'15.7g',0.32,'S','Field galaxy',NULL,NULL,NULL,1,238.917375,41.50483,0.017,NULL,59796936951,934327139,14598861,15.7),(133527,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133527,36.14,0.46,169,62817,70,NULL,NULL,'2MASX J15554054+2521006',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,238.918833333,25.35031,0.161,NULL,59874941568,935545962,14617905,16.5),(133528,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133528,36.85,0.46,235,62818,70,NULL,NULL,'2MASX J15554115+0358536',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.9215,3.98144,0.257,NULL,56613556314,884586817,13821669,17.5),(133529,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133529,37.06,0.46,258,62819,70,NULL,NULL,'2MASX J15554205+1048223',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.9252083,10.80606,0.141,NULL,56631999784,884874996,13826171,17),(133530,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133530,38.07,0.46,412,62820,70,NULL,NULL,'2MASX J15554238+1902147',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,238.9264583,19.03733,0.049,NULL,59400667064,928135422,14502115,17.1),(133531,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133531,37.84,NULL,370,62821,70,NULL,'nucleus-to-host flux ratio, z > 0.09','[HB89] 1553+113',NULL,'2006AJ....132....1S',2006,1,NULL,'Literature z~0.36 considered erroneous. See 2010ApJ...720..976D.','QSO',NULL,NULL,'14.1V',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,238.929333,11.19011,0.097,NULL,56631913796,884873653,13826150,14.1),(133532,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133532,40,NULL,1000,62821,NULL,NULL,NULL,'[HB89] 1553+113',NULL,'2007A&A...473L..17T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133533,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133533,40.21,NULL,1100,62821,70,NULL,'z > 0.30','[HB89] 1553+113',NULL,'2014A&A...570A.126L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133534,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133534,40.8,NULL,1440,62821,NULL,NULL,'very high energy spectrum absorption, z < 0.42','[HB89] 1553+113',NULL,'2007ApJ...655L..13M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133535,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133535,41.03,0.27,1610,62821,70,NULL,'z = 0.485 +/- 0.09 = mean of z0.53-0.62 max. + z0.395 min.','[HB89] 1553+113',NULL,'2015ApJ...799....7A',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133536,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133536,41.07,0.24,1640,62821,NULL,NULL,'intervening absorbers, z = 0.497 +/- 0.083','[HB89] 1553+113',NULL,'2010ApJ...720..976D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133537,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133537,41.11,0.34,1670,62821,70,NULL,'z = 0.51 +/- 0.11','[HB89] 1553+113',NULL,'2015arXiv150203012A',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133538,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133538,41.55,NULL,2040,62821,NULL,NULL,'very high energy, z < 0.68. mean of z < 0.67, 0.80, 0.58','[HB89] 1553+113',NULL,'2009arXiv0907.0157P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133539,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133539,41.57,NULL,2060,62821,NULL,NULL,'very high energy spectrum absorption, z < 0.69','[HB89] 1553+113',NULL,'2007ApJ...655L..13M',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133540,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133540,41.57,NULL,2060,62821,NULL,NULL,'very high energy absorption z < 0.69','[HB89] 1553+113',NULL,'2008A&A...477..481A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133541,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133541,41.67,NULL,2160,62821,NULL,NULL,'very high energy absorption z < 0.74','[HB89] 1553+113',NULL,'2006A&A...448L..19A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133542,'BL Lac Luminosity','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133542,41.67,NULL,2160,62821,NULL,NULL,'very high energy spectrum z > 0.74','[HB89] 1553+113',NULL,'2007ApJ...654L.119A',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133543,'GeV TeV ratio','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133543,40.36,NULL,1180,62821,72,NULL,NULL,'[HB89] 1553+113',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133544,'GeV TeV ratio','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133544,41.05,0.13,1620,62821,70,NULL,'z = 0.49 +/- 0.04','[HB89] 1553+113',NULL,'2015arXiv150202920S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133545,'GeV TeV ratio','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133545,41.62,0.12,2110,62821,72,NULL,NULL,'[HB89] 1553+113',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133546,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133546,34.25,0.8,70.9,62822,75,NULL,'HMCL, I','UGC 10092',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00002,NULL,'14.90',0.3,'SA(s)d:','Supercluster foreground object',NULL,NULL,NULL,1,238.929416667,18.28269,0.077,NULL,56509970206,882968284,13796379,14.9),(133547,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133547,33.25,0.4,44.8,62822,75,NULL,'HMCL, I, raw','UGC 10092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133548,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133548,33.26,0.4,44.9,62822,75,NULL,'HMCL, I, inv','UGC 10092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133549,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133549,33.65,0.4,53.6,62822,75,NULL,'HMCL, I, cor','UGC 10092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133550,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133550,38.2,0.46,437,62823,70,NULL,NULL,'2MASX J15554311+3318491',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.9297083,33.31372,0.073,NULL,59886645091,935728829,14620762,18.2),(133551,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133551,34.91,0.4,95.8,62824,NULL,NULL,'mean','UGC 10097',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000073,NULL,'13.92',1.1,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,238.9302083,47.86728,0.049,NULL,59712890077,933013907,14578342,13.92),(133552,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133552,35.12,0.45,106,62824,NULL,NULL,'K','UGC 10097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133553,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133553,38.75,0.46,562,62825,70,NULL,NULL,'2MASX J15554346+0947273',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.931166667,9.79083,0.117,NULL,56634811574,884918930,13826858,17.8),(133554,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133554,37.87,0.46,375,62826,70,NULL,NULL,'2MASX J15554514+2550446',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.938,25.84575,0.177,NULL,59875761991,935558781,14618105,17.4),(133555,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133555,35.39,0.49,119,62827,75,NULL,'IR','UGC 10094',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000019,NULL,'15.7g',0.18,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,238.938875,24.49389,0.185,NULL,59392407597,928006368,14500099,15.7),(133556,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133556,35.8,0.31,144,62827,NULL,NULL,'Malmquist cor.','UGC 10094',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133557,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133557,35.92,0.29,153,62827,NULL,NULL,NULL,'UGC 10094',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133558,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133558,36.04,0.2,161,62827,74.4,NULL,NULL,'UGC 10094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133559,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133559,36.06,NULL,163,62827,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10094',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133560,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133560,36.08,NULL,164,62827,NULL,NULL,'Dipole + Quadrupole','UGC 10094',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133561,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133561,36.09,NULL,165,62827,NULL,NULL,NULL,'UGC 10094',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133562,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133562,36.1,NULL,166,62827,NULL,NULL,'Dipole','UGC 10094',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133563,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133563,37.5,0.27,316,62828,70,NULL,NULL,'2MASX J15554690+0309046',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.9454583,3.15142,0.265,NULL,56481791420,882527990,13789499,18),(133564,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133564,38.04,0.46,406,62829,70,NULL,NULL,'SDSS J155547.56+505254.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000047,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,238.9482083,50.88192,0.017,NULL,59717451407,933085178,14579455,18.4),(133565,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133565,36.83,0.46,233,62830,70,NULL,NULL,'SDSS J155548.39+112433.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,238.951625,11.40939,0.097,NULL,56598536070,884352126,13818001,17.8),(133566,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133566,36.8,0.33,229,62831,70,NULL,NULL,'2MASX J15554944+2429117',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.001185,NULL,'17.6g',0.16,'AGN',NULL,NULL,NULL,NULL,1,238.9560417,24.48653,0.185,NULL,59392407676,928006369,14500099,17.6),(133567,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133567,38.24,0.46,445,62832,70,NULL,NULL,'SDSS J155550.62+345937.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,238.9609583,34.99378,0.065,NULL,59767666203,933869784,14591715,18.2),(133568,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133568,35.79,0.27,144,62833,70,NULL,NULL,'CGCG 223-014',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000157,NULL,'15.4',0.4,NULL,NULL,NULL,NULL,NULL,1,238.965291667,39.76708,0.033,NULL,59797698753,934339043,14599047,15.4),(133569,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133569,37.51,0.46,317,62834,70,NULL,NULL,'2MASX J15555356+3129341',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000197,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,238.9732083,31.49278,0.049,NULL,59920820887,936262826,14629106,16.4),(133570,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133570,34.68,0.8,86.3,62835,75,NULL,'CF, r','NGC 6016',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000027,NULL,'14.7g',0.5,'Scd:',NULL,NULL,NULL,NULL,1,238.978625,26.9665,0.121,NULL,59877639097,935588110,14618564,14.7),(133571,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133571,34.4,0.38,75.9,62835,75,NULL,'CF, r, raw','NGC 6016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133572,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133572,34.5,0.38,79.6,62835,75,NULL,'CF, r, inv','NGC 6016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133573,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133573,34.67,0.38,85.8,62835,75,NULL,'CF, r, cor','NGC 6016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133574,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133574,34.68,0.2,86.3,62835,74.4,NULL,NULL,'NGC 6016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133575,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133575,36.71,0.46,220,62836,70,NULL,NULL,'2MASX J15555571+4842326',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,238.982,48.70903,0.061,NULL,59711467919,932991686,14577995,16.9),(133576,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133576,37.84,0.27,370,62837,70,NULL,NULL,'2MASX J15555748+3723163',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000124,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,238.989583,37.38797,0.045,NULL,59761864410,933779131,14590298,17.6),(133577,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133577,37.62,0.46,335,62838,70,NULL,NULL,'2MASX J15555808+2413307',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000161,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,238.9919583,24.22511,0.165,NULL,59406071166,928219861,14503435,17.5),(133578,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133578,37.91,0.46,381,62839,70,NULL,NULL,'2MASX J15555872+2143181',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,238.9947917,21.72178,0.117,NULL,59405713720,928214276,14503348,18),(133579,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133579,37.5,0.27,316,62840,70,NULL,NULL,'2MASX J15555886+0303436',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,238.995375,3.06211,0.265,NULL,56481659668,882525932,13789467,16.9),(133580,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133580,35.83,0.46,147,62841,70,NULL,NULL,'2MASX J15555924+0619444',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000105,NULL,'16.0g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,238.996875,6.32931,0.129,NULL,56629860808,884841575,13825649,16),(133581,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133581,37.89,0.46,378,62842,70,NULL,NULL,'2MASX J15555976+2655057',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000103,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,238.999125,26.91839,0.121,NULL,59877720950,935589389,14618584,17.2),(133582,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133582,37.83,0.46,367,62843,70,NULL,NULL,'2MASX J15560129+2346111',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.005375,23.76989,0.153,NULL,59406903020,928232859,14503638,17.3),(133583,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133583,37.61,0.46,333,62844,70,NULL,NULL,'2MASX J15560166+3339432',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.007041667,33.66192,0.069,NULL,59889981942,935780967,14621577,17.4),(133584,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133584,38.03,0.05,403,62845,70,NULL,NULL,'2MASX J15560202+2706377',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.0085,27.11053,0.117,NULL,59877651160,935588299,14618567,17.8),(133585,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133585,37.06,0.46,258,62846,70,NULL,NULL,'2MASX J15560209+3951473',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000157,NULL,'16.6g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,239.008708333,39.86306,0.033,NULL,59797912312,934342379,14599099,16.6),(133586,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133586,37.67,0.46,342,62847,70,NULL,NULL,'SDSS J155602.82+272559.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.0117917,27.43317,0.105,NULL,59877167557,935580743,14618449,18.4),(133587,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133587,37.84,0.27,370,62848,70,NULL,NULL,'2MASX J15560334+3720503',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.2g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,239.014041667,37.34728,0.025,NULL,59761988408,933781068,14590329,17.2),(133588,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133588,36.3,0.46,182,62849,70,NULL,NULL,'CGCG 137-003',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000077,NULL,'15.0g',0.57,'E?','Pair member (points to parent)',NULL,'radio jet',NULL,1,239.0162083,24.44806,0.185,NULL,59392400975,928006265,14500097,15),(133589,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133589,37.1,0.46,262,62850,70,NULL,NULL,'2MASX J15560492+0641134',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.0204583,6.68706,0.121,NULL,56630246058,884847594,13825743,16.1),(133590,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133590,37.49,0.14,315,62851,70,NULL,NULL,'SDSS J155604.92+255816.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00018,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.020541667,25.97139,0.165,NULL,59875765992,935558843,14618106,18.4),(133591,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133591,37.7,0.46,346,62852,70,NULL,NULL,'2MASX J15560524+5202496',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.021875,52.04731,0.013,NULL,59717717919,933089342,14579520,17),(133592,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133592,36.3,0.46,182,62853,70,NULL,NULL,'2MASX J15560561-0021001',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.023375,-0.35,0.393,NULL,45530238279,711409973,11115780,16.8),(133593,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133593,36.52,0.46,202,62854,70,NULL,NULL,'2MASX J15560610+1023064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.025417,10.38519,0.129,NULL,56635450423,884928912,13827014,16.9),(133594,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133594,38.18,0.46,432,62855,70,NULL,NULL,'2MASX J15560617+4832366',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.0255417,48.54347,0.041,NULL,59711449128,932991392,14577990,17.7),(133595,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133595,37.16,0.33,271,62856,70,NULL,NULL,'2MASX J15560624+4045504',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000135,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.026167,40.76408,0.073,NULL,59798104639,934345384,14599146,17.4),(133596,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133596,38.03,0.05,403,62857,70,NULL,NULL,'2MASX J15560723+2735336',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.030125,27.59269,0.105,NULL,59877218965,935581546,14618461,18.1),(133597,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133597,34.44,0.49,77.3,62858,70,NULL,NULL,'2MASX J15560742-0832442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'16.05',NULL,NULL,NULL,NULL,NULL,NULL,1,239.030917,-8.54572,0.593,NULL,45630499625,712976556,11140258,16.05),(133598,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133598,37.67,0.46,342,62859,70,NULL,NULL,'2MASX J15560742+3348312',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.030917,33.80861,0.069,NULL,59889997641,935781213,14621581,17.6),(133599,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133599,36.83,0.46,232,62860,70,NULL,NULL,'2MASX J15560750+5115106',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.031583,51.25286,0.009,NULL,59716863720,933075995,14579312,16.5),(133600,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133600,35,0.21,100,62861,70,NULL,NULL,'CGCG 250-023',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000107,NULL,'14.6g',0.59,'E0','Group member',NULL,NULL,NULL,1,239.032125,48.09325,0.069,NULL,59713500721,933023448,14578491,14.6),(133601,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133601,36.89,0.15,238,62862,70,NULL,NULL,'2MASX J15560782+1958200',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.0327083,19.97211,0.077,NULL,59403657599,928182149,14502846,16.7),(133602,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133602,38.57,0.46,518,62863,70,NULL,NULL,'SDSS J155608.24+034658.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.034375,3.78278,0.261,NULL,56612684808,884573200,13821456,18.4),(133603,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133603,37.58,0.21,328,62864,70,NULL,NULL,'2MASX J15560876+2643308',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.036541667,26.72525,0.121,NULL,59877450187,935585159,14618518,18),(133604,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133604,38.53,0.46,508,62865,70,NULL,NULL,'2MASX J15560992+2700098',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.041208333,27.00258,0.121,NULL,59877854102,935591470,14618616,17.8),(133605,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133605,37.66,0.46,341,62866,70,NULL,NULL,'SDSS J155610.64+380859.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.044375,38.14975,0.025,NULL,59763682855,933807544,14590742,18.1),(133606,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133606,37.84,0.27,370,62867,70,NULL,NULL,'SDSS J155610.77+371907.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,239.044917,37.31864,0.025,NULL,59761989132,933781080,14590329,18.7),(133607,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133607,37.22,0.46,277,62868,70,NULL,NULL,'2MASX J15561078+3305212',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000181,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.045,33.08928,0.081,NULL,59886618372,935728412,14620756,16.7),(133608,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133608,37.34,0.46,294,62869,70,NULL,NULL,'2MASX J15561118+2426058',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.0465,24.43497,0.185,NULL,59392453087,928007079,14500110,17),(133609,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133609,36.6,0.46,209,62870,70,NULL,NULL,'2MASX J15561134+1250086',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.047167,12.83558,0.081,NULL,56527463749,883241621,13800650,16.6),(133610,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133610,36.8,0.33,229,62871,70,NULL,NULL,'2MASX J15561146+2433348',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.047875,24.55958,0.185,NULL,59392403426,928006303,14500098,17.8),(133611,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133611,37.58,0.21,328,62872,70,NULL,NULL,'2MASX J15561152+2646118',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000165,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,239.047917,26.77006,0.121,NULL,59877726666,935589479,14618585,16.3),(133612,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133612,38.24,0.46,445,62873,70,NULL,NULL,'SDSS J155611.56+451229.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.0482083,45.20811,0.037,NULL,59684097110,932564017,14571312,18),(133613,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133613,37.22,0.46,278,62874,70,NULL,NULL,'2MASX J15561215+5612122',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.050583333,56.20342,0.037,NULL,57639449277,900616394,14072131,17.2),(133614,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133614,36.91,0.46,241,62875,70,NULL,NULL,'2MASX J15561309+4743362',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000176,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.054583,47.72689,0.041,NULL,59713331840,933020810,14578450,16.9),(133615,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133615,34.51,0.49,79.6,62876,75,NULL,'IR','ESO 450- G 023',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00006,NULL,'15.8b',0.2,'Sa-b',NULL,NULL,NULL,NULL,1,239.061125,-31.52031,0.661,NULL,47165932646,736967697,11515120,15.8),(133616,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133616,37.77,0.46,357,62877,70,NULL,NULL,'SDSS J155615.51+290421.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.064666667,29.07256,0.105,NULL,59866688244,935417003,14615890,18),(133617,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133617,37.66,0.46,341,62878,70,NULL,NULL,'SDSS J155616.82+080657.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.070125,8.11608,0.105,NULL,56636374995,884943359,13827239,18.1),(133618,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133618,37.43,0.33,307,62879,70,NULL,NULL,'2MASX J15561691+2406268',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.0704583,24.10761,0.149,NULL,59406240145,928222502,14503476,16.8),(133619,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133619,37.56,0.46,326,62880,70,NULL,NULL,'SDSS J155617.81+165330.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.07425,16.89189,0.049,NULL,56568095356,883876489,13810570,17.9),(133620,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133620,35.59,0.2,131,62881,74.4,NULL,NULL,'CGCG 079-010',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000315,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,239.075333,9.76419,0.065,NULL,56634728250,884917628,13826837,15.7),(133621,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133621,38.03,0.05,403,62882,70,NULL,NULL,'2MASX J15561872+2742278',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.077875,27.70769,0.105,NULL,59877211530,935581430,14618459,17.7),(133622,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133622,37.33,0.46,293,62883,70,NULL,NULL,'2MASX J15561892+2458218',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.078875,24.97264,0.153,NULL,59874770854,935543294,14617863,18),(133623,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133623,38.33,0.46,462,62884,70,NULL,NULL,'SDSS J155618.93+225128.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.8g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.078917,22.85794,0.141,NULL,59407202419,928237537,14503711,18.8),(133624,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133624,37.49,0.14,315,62885,70,NULL,NULL,'2MASX J15561925+2553188',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.080083333,25.8885,0.165,NULL,59875773646,935558963,14618108,17.9),(133625,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133625,36.2,0.46,174,62886,70,NULL,NULL,'2MASX J15561929+0948551',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00001,NULL,'15.7g',0.43,'AGN',NULL,NULL,NULL,NULL,1,239.080417,9.81544,0.065,NULL,56634735087,884917735,13826839,15.7),(133626,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133626,38.67,0.46,542,62887,70,NULL,NULL,'2MASX J15561944+1912461',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.081125,19.21297,0.045,NULL,59400191581,928127993,14501999,17.5),(133627,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133627,37.73,0.46,352,62888,70,NULL,NULL,'2MASX J15561985+1343506',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.082875,13.73075,0.077,NULL,56528242158,883253783,13800840,17.1),(133628,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133628,38.64,0.33,534,62889,70,NULL,NULL,'SDSS J155621.47+485658.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.0895,48.94967,0.073,NULL,59711572621,932993322,14578020,18),(133629,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133629,38.3,0.46,457,62890,70,NULL,NULL,'2MASX J15562151+3259071',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000136,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.089833,32.98525,0.081,NULL,59887272891,935738638,14620916,18.2),(133630,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133630,38.13,0.46,422,62891,70,NULL,NULL,'SDSS J155623.55+280842.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000153,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.098125,28.14522,0.101,NULL,59874267061,935535422,14617740,18.6),(133631,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133631,33.64,0.21,52.6,62892,74.2,NULL,'SALT 2','CGCG 108-012',0.015818,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.00007,NULL,'14.28',1,'SA0+','Supercluster foreground object',NULL,NULL,NULL,1,239.0982917,16.52331,0.053,NULL,56566180058,883846563,13810102,14.28),(133632,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133632,34.24,0.04,69.4,62892,72,NULL,'MLCS17','CGCG 108-012',0.015818,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133633,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133633,34.22,0.09,69.8,62892,74.4,NULL,NULL,'CGCG 108-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133634,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133634,34.45,0.2,76.4,62892,70,NULL,'SALT 2','CGCG 108-012',0.015818,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133635,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133635,34.5,0.23,78,62892,65,NULL,'MLCS17','CGCG 108-012',0.015818,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133636,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133636,34.57,0.22,80.9,62892,65,NULL,'MLCS31','CGCG 108-012',0.015818,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133637,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2007ap',NULL,133637,34.68,0.25,85.1,62892,65,NULL,'SALT2','CGCG 108-012',0.015818,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133638,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133638,33.94,0.25,61.3,62892,70,NULL,NULL,'CGCG 108-012',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133639,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133639,34.22,0.09,69.8,62892,74.4,NULL,NULL,'CGCG 108-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133640,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133640,36.43,0.33,193,62893,70,NULL,NULL,'2MASX J15562435+0855541',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.101375,8.93169,0.077,NULL,56636197060,884940579,13827196,16.5),(133641,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133641,37.49,0.14,315,62894,70,NULL,NULL,'2MASX J15562458+2552328',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000213,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.1024583,25.87572,0.165,NULL,59875773121,935558955,14618108,16.3),(133642,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133642,36.62,0.46,211,62895,70,NULL,NULL,'2MASX J15562480+1227102',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.1034583,12.45294,0.121,NULL,56527515572,883242430,13800662,16.5),(133643,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133643,36.65,0.46,214,62896,70,NULL,NULL,'2MASX J15562495+4619282',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000183,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,239.10375,46.32439,0.033,NULL,59682541853,932539716,14570933,16),(133644,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133644,36.43,0.33,193,62897,70,NULL,NULL,'2MASX J15562489+0856361',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000175,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,239.1037917,8.9435,0.077,NULL,56636196963,884940577,13827196,15.9),(133645,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133645,37.42,0.46,305,62898,70,NULL,NULL,'2MASX J15562525+2617588',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000194,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,239.105333333,26.29967,0.129,NULL,59875539380,935555302,14618051,16.3),(133646,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133646,36.3,0.46,182,62899,70,NULL,NULL,'2MASX J15562649+4611092',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.110583333,46.186,0.033,NULL,59682551756,932539871,14570935,16.9),(133647,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133647,37.62,0.46,335,62900,70,NULL,NULL,'2MASXi J1556265+193805',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.110625,19.63506,0.053,NULL,59400238574,928128727,14502011,17.5),(133648,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133648,36.18,0.46,172,62901,70,NULL,NULL,'CGCG 223-015',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000093,NULL,'15.1g',0.57,'E','Field galaxy',NULL,NULL,NULL,1,239.1135417,42.10117,0.041,NULL,59796259496,934316554,14598696,15.1),(133649,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133649,35,0.21,100,62902,70,NULL,NULL,'2MASX J15562738+4757302',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000163,NULL,'15.7g',0.34,'E',NULL,NULL,NULL,NULL,1,239.11425,47.95842,0.085,NULL,59713367764,933021371,14578458,15.7),(133650,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133650,35.73,0.46,140,62903,70,NULL,NULL,'2MASX J15562753+0003333',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.11475,0.05925,0.409,NULL,56478402985,882475046,13788672,17.1),(133651,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133651,38.54,0.46,511,62904,70,NULL,NULL,'2MASX J15562822+1709542',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.117625,17.16522,0.053,NULL,56564745336,883824145,13809752,17.5),(133652,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133652,36.88,0.46,237,62905,70,NULL,NULL,'2MASX J15562841+2905088',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000137,NULL,'16.9g',0.29,'E',NULL,NULL,NULL,NULL,1,239.1185417,29.08586,0.105,NULL,59866689142,935417017,14615890,16.9),(133653,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133653,33.9,0.49,60.3,62906,75,NULL,'IR','ESO 389- G 004',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000033,NULL,'13.86',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,239.118916667,-36.89964,1.041,NULL,46257528004,722773875,11293341,13.86),(133654,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133654,34.26,0.2,71.1,62906,74.4,NULL,NULL,'ESO 389- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133655,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133655,34.42,0.5,76.5,62906,NULL,NULL,'Malmquist cor.','ESO 389- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133656,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133656,34.44,0.49,77.4,62906,NULL,NULL,NULL,'ESO 389- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133657,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133657,37.55,0.46,324,62907,70,NULL,NULL,'2MASX J15562894+0254572',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.1205,2.91589,0.289,NULL,56485882522,882591914,13790498,17.9),(133658,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133658,37.47,0.11,313,62908,70,NULL,NULL,'2MASX J15562908+2838508',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.121167,28.64747,0.129,NULL,59866853198,935419581,14615930,18.3),(133659,'GRB','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133659,48.6,0.93,8900,62909,69.7,NULL,'Calibrated','GRB 060510B',4.9,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,239.122958333,78.57017,0.145,NULL,57169991281,893281113,13957517,NULL),(133660,'GRB','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133660,48.66,0.94,9140,62909,69.7,NULL,'Fiducial','GRB 060510B',4.9,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133661,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133661,36.89,0.15,238,62910,70,NULL,NULL,'2MASX J15562931+2000242',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,239.122125,20.00675,0.085,NULL,59403665267,928182269,14502847,NULL),(133662,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133662,38.03,0.05,403,62911,70,NULL,NULL,'2MASX J15562941+2734368',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'16.9g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,239.122625,27.57683,0.105,NULL,59877215442,935581491,14618460,16.9),(133663,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133663,38.05,0.33,408,62912,70,NULL,NULL,'2MASX J15562992+5527563',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.1247917,55.46558,NULL,NULL,57641889675,900654526,14072726,17.8),(133664,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133664,36.46,0.46,196,62913,70,NULL,NULL,'2MASX J15563147+2351582',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.131167,23.86622,0.153,NULL,59406217802,928222153,14503471,17.1),(133665,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133665,38.24,0.46,445,62914,70,NULL,NULL,'SDSS J155631.63+280246.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.131833,28.04628,0.101,NULL,59874259417,935535303,14617739,18),(133666,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133666,35.07,0.16,100,62915,74.2,NULL,'SALT 2','CGCG 108-013',0.032156,'2010ApJ...716..712A',2010,1,0.9,NULL,'G',0.000233,NULL,'14.73',0.7,'SA0/a','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.140333,20.05236,0.085,NULL,59403655923,928182123,14502845,14.73),(133667,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133667,35.64,0.09,134,62915,74.4,NULL,NULL,'CGCG 108-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133668,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133668,35.74,0.15,136,62915,73.8,NULL,'SALT 2 (SNANA)','CGCG 108-013',0.0315,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133669,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133669,35.78,0.16,139,62915,65,NULL,'MLCS31','CGCG 108-013',0.032156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133670,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133670,35.83,NULL,142,62915,65,NULL,'intrinsic extinction A(V) = 0.428 mag','CGCG 108-013',0.032156,'2010ApJ...708.1748F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133671,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133671,35.94,0.18,150,62915,65,NULL,'SALT2','CGCG 108-013',0.032156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133672,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133672,35.98,0.16,152,62915,65,NULL,'SALT','CGCG 108-013',0.032156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133673,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133673,35.99,0.14,153,62915,65,NULL,'MLCS17','CGCG 108-013',0.032156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133674,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133674,36.52,NULL,195,62915,65,NULL,'intrinsic extinction A(V) = 0.0 mag','CGCG 108-013',0.032156,'2010ApJ...708.1748F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133675,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 2006bt',NULL,133675,36.58,0.02,200,62915,70,NULL,'SALT 2','CGCG 108-013',0.032156,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133676,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133676,34.91,0.46,96,62915,70,NULL,NULL,'CGCG 108-013',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133677,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133677,33.29,0.46,45.6,62916,70,NULL,NULL,'CGCG 137-004',NULL,'2015arXiv151105856S',2015,1,1.01,NULL,'G',0.00016,NULL,'14.0g',0.8,NULL,NULL,NULL,NULL,NULL,1,239.140416667,21.28908,0.109,NULL,59401079594,928141868,14502216,14),(133678,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133678,37.47,0.11,313,62917,70,NULL,NULL,'2MASX J15563410+2840018',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.142,28.66706,0.129,NULL,59866850726,935419542,14615930,17.8),(133679,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133679,36.83,0.46,232,62918,70,NULL,NULL,'2MASX J15563486+0832331',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.145167,8.54247,0.085,NULL,56636530071,884945782,13827277,17.1),(133680,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133680,38.13,0.46,422,62919,70,NULL,NULL,'2MASX J15563491+1113011',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.145417,11.21706,0.153,NULL,56632435489,884881804,13826278,16.7),(133681,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133681,37.68,0.46,344,62920,70,NULL,NULL,'2MASX J15563607+0004533',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.15025,0.08144,0.409,NULL,56478414797,882475231,13788675,17.7),(133682,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133682,36.77,0.46,225,62921,70,NULL,NULL,'2MASX J15563646+3254447',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.152,32.91253,0.085,NULL,59887274089,935738657,14620916,17.8),(133683,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133683,37.58,0.21,328,62922,70,NULL,NULL,'2MASX J15563664+2701598',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.152625,27.03331,0.117,NULL,59877861999,935591593,14618618,17),(133684,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133684,36.87,0.77,237,62923,70,NULL,NULL,'2MASX J15563674-1405325',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.153083,-14.09239,0.661,NULL,45477155589,710580556,11102821,15.6),(133685,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133685,32.54,NULL,32.2,62924,72,NULL,NULL,'SDSS J155636.84+061138.6',NULL,'2014Ap.....57..457K',2014,1,0.66,NULL,'G',0.000014,NULL,'16.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,239.1535,6.19406,0.173,NULL,56629702516,884839101,13825610,16.9),(133686,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133686,36.89,0.15,238,62925,70,NULL,NULL,'2MASX J15563710+1938092',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.154583,19.63592,0.053,NULL,59400238120,928128720,14502011,17.1),(133687,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133687,37.58,0.21,328,62926,70,NULL,NULL,'2MASX J15563710+2708178',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.154667,27.13817,0.117,NULL,59877867549,935591680,14618620,17.5),(133688,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133688,32.35,NULL,29.5,62927,72,NULL,NULL,'AGC 258349',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000122,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,239.155,5.97306,0.137,NULL,56612156451,884564944,13821327,NULL),(133689,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133689,36.81,0.46,230,62928,70,NULL,NULL,'2MASX J15563806+1842012',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.1585,18.70036,0.053,NULL,56510742137,882980345,13796567,16.6),(133690,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133690,37.87,0.21,375,62929,70,NULL,NULL,'2MASX J15563812+2820086',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.15875,28.33586,0.109,NULL,59866649170,935416393,14615881,18.2),(133691,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133691,36.96,0.46,246,62930,70,NULL,NULL,'2MASX J15563921+0918023',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.163375,9.30069,0.081,NULL,56634355469,884911804,13826746,17.1),(133692,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133692,36.89,0.15,238,62931,70,NULL,NULL,'SDSS J155639.27+201024.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.163667,20.17336,0.085,NULL,59403510356,928179849,14502810,18.2),(133693,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133693,38.04,0.33,406,62932,70,NULL,NULL,'2MASX J15563949+4532271',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000188,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.1645417,45.54081,0.033,NULL,59684814491,932575226,14571487,16.8),(133694,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133694,38.03,0.05,403,62933,70,NULL,NULL,'2MASX J15563986+2733108',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.1660417,27.55311,0.105,NULL,59877214484,935581476,14618460,18.3),(133695,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133695,37.22,0.46,278,62934,70,NULL,NULL,'2MASXi J1556399+402939',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00014,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.166375,40.49428,0.025,NULL,59798017317,934344020,14599125,17.7),(133696,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133696,37.49,0.14,315,62935,70,NULL,NULL,'2MASX J15564049+2538176',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000192,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.1687917,25.63836,0.177,NULL,59875698033,935557781,14618090,16.8),(133697,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133697,38.43,0.46,485,62936,70,NULL,NULL,'SDSS J155640.79+050445.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.17,5.07942,0.169,NULL,56614702993,884604734,13821948,18.5),(133698,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133698,37.92,0.46,383,62937,70,NULL,NULL,'SDSS J155640.88+255235.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000185,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.170375,25.87642,0.165,NULL,59875750074,935558594,14618103,18.4),(133699,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133699,37.11,0.46,264,62938,70,NULL,NULL,'2MASX J15564116+3121427',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.171583,31.36194,0.045,NULL,59920737885,936261529,14629086,17.1),(133700,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133700,36.89,0.15,238,62939,70,NULL,NULL,'2MASX J15564131+2010172',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000073,NULL,'15.9g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.17225,20.17158,0.085,NULL,59403510443,928179850,14502810,15.9),(133701,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133701,38.05,0.33,408,62940,70,NULL,NULL,'SDSS J155641.72+552729.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000067,NULL,'18.2g',0.16,'NLAGN',NULL,NULL,NULL,NULL,1,239.173875,55.45808,NULL,NULL,57641888645,900654510,14072726,18.2),(133702,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133702,36.86,0.27,236,62941,70,NULL,NULL,'2MASX J15564213+0859503',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.175625,8.99728,0.077,NULL,56636172084,884940188,13827190,16.6),(133703,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133703,38.64,0.33,534,62942,70,NULL,NULL,'SDSS J155642.27+485259.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000125,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.176167,48.88308,0.073,NULL,59711576127,932993376,14578021,18.4),(133704,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133704,37.49,0.14,315,62943,70,NULL,NULL,'2MASX J15564238+2550106',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.176667,25.83628,0.165,NULL,59875748814,935558575,14618102,16.9),(133705,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133705,37.58,0.33,328,62944,70,NULL,NULL,'2MASX J15564261+2703216',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.1774583,27.05597,0.117,NULL,59877862298,935591598,14618618,18),(133706,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133706,38.03,0.05,403,62945,70,NULL,NULL,'2MASX J15564294+2741086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.178916667,27.68592,0.105,NULL,59877205702,935581339,14618458,18),(133707,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133707,38.03,0.05,403,62946,70,NULL,NULL,'2MASX J15564296+2733246',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.1789583,27.55681,0.105,NULL,59877214467,935581476,14618460,17),(133708,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133708,36.86,0.27,236,62947,70,NULL,NULL,'2MASX J15564321+0857553',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000172,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,239.18,8.96547,0.077,NULL,56636170880,884940170,13827190,15.9),(133709,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133709,35,0.21,100,62948,70,NULL,NULL,'IC 1152',NULL,'2015arXiv151105856S',2015,1,1.07,NULL,'G',0.000073,NULL,'13.9g',0.98,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,239.1805,48.095,0.069,NULL,59713518555,933023727,14578495,13.9),(133710,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133710,37.49,0.14,315,62949,70,NULL,NULL,'2MASX J15564396+2540266',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.18325,25.67397,0.177,NULL,59875700410,935557818,14618090,17.7),(133711,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133711,37.58,0.21,328,62950,70,NULL,NULL,'2MASX J15564412+2657566',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000077,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.1837083,26.96564,0.121,NULL,59877858492,935591538,14618617,17),(133712,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133712,37.49,0.14,315,62951,70,NULL,NULL,'2MASX J15564430+2551456',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.000183,NULL,'18.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,239.184625,25.86261,0.165,NULL,59875750839,935558606,14618103,18),(133713,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133713,37.95,0.46,389,62952,70,NULL,NULL,'SDSS J155644.45+554538.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000077,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.1852083,55.76064,0.013,NULL,57641408225,900647003,14072609,18.3),(133714,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133714,38.04,0.33,406,62953,70,NULL,NULL,'2MASX J15564453+4533183',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.185417,45.55517,0.033,NULL,59684814187,932575221,14571487,17.6),(133715,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133715,37.49,0.14,315,62954,70,NULL,NULL,'2MASX J15564482+2553076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.186667,25.88558,0.165,NULL,59875750495,935558601,14618103,16.9),(133716,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133716,36.86,0.46,236,62955,70,NULL,NULL,'2MASX J15564510+3709530',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.188083,37.16483,0.029,NULL,59761979620,933780931,14590327,17.6),(133717,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133717,36.89,0.15,238,62956,70,NULL,NULL,'2MASX J15564528+2009001',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.1885417,20.15014,0.085,NULL,59403510250,928179847,14502810,16.3),(133718,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133718,37.47,0.11,313,62957,70,NULL,NULL,'SDSS J155646.21+284011.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.1925417,28.66997,0.097,NULL,59866642447,935416288,14615879,17.9),(133719,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133719,38.03,0.05,403,62958,70,NULL,NULL,'2MASX J15564695+2731136',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.1957083,27.52056,0.105,NULL,59877184842,935581013,14618453,17.6),(133720,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133720,36.05,0.33,162,62959,70,NULL,NULL,'2MASX J15564753+2533486',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.198166667,25.56367,0.149,NULL,59875704113,935557876,14618091,16.9),(133721,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133721,36.3,0.46,182,62960,70,NULL,NULL,'2MASX J15564766+4217514',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000196,NULL,'15.9g',0.37,'S0^-','Field galaxy',NULL,NULL,NULL,1,239.19875,42.29769,0.053,NULL,59796349602,934317962,14598718,15.9),(133722,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133722,37.53,0.46,321,62961,70,NULL,NULL,'2MASX J15564768+2946286',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'16.3g',0.43,'Sa',NULL,NULL,NULL,NULL,1,239.198917,29.77447,0.093,NULL,59869179161,935455924,14616498,16.3),(133723,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133723,37.49,0.14,315,62962,70,NULL,NULL,'2MASX J15564816+2550446',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000181,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.200667,25.84575,0.165,NULL,59875748583,935558571,14618102,17.9),(133724,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133724,36.89,0.15,238,62963,70,NULL,NULL,'2MASX J15564838+2014432',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.201583,20.24547,0.073,NULL,59403532347,928180192,14502815,17.2),(133725,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133725,38.21,0.46,439,62964,70,NULL,NULL,'2MASX J15564911+4442274',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.20475,44.70767,0.041,NULL,59683517148,932554955,14571171,17.5),(133726,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133726,38.12,0.46,420,62965,70,NULL,NULL,'2MASX J15564947+3438017',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000194,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.2059583,34.63378,0.057,NULL,59767177317,933862145,14591596,17.3),(133727,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133727,35.78,0.19,143,62966,70,NULL,NULL,'2MASX J15565009+4144161',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000176,NULL,'15.7g',0.44,'E','Field galaxy',NULL,NULL,NULL,1,239.208875,41.73781,0.045,NULL,59797118350,934329974,14598905,15.7),(133728,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133728,37.57,0.27,327,62967,70,NULL,NULL,'SDSS J155650.64+345337.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.211,34.89369,0.057,NULL,59767679499,933869992,14591718,18.5),(133729,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133729,33.11,0.69,41.9,62968,100,NULL,'mid-IR','ESO 330-G 006',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000017,NULL,'10.6K',0.6,'Sb-c',NULL,NULL,NULL,NULL,1,239.213167,-38.76875,0.977,NULL,46256510391,722757974,11293093,10.6),(133730,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133730,38.46,0.46,492,62969,70,NULL,NULL,'2MASX J15565124+3133417',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.213375,31.56169,0.069,NULL,59919994527,936249914,14628904,18.1),(133731,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133731,36.05,0.33,162,62970,70,NULL,NULL,'2MASX J15565277+2534067',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000083,NULL,'15.5g',0.49,NULL,NULL,NULL,NULL,NULL,1,239.2197917,25.56858,0.149,NULL,59875693859,935557716,14618089,15.5),(133732,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133732,37.78,0.46,359,62971,70,NULL,NULL,'2MASX J15565318+0025408',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'17.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.221583,0.42806,0.413,NULL,56487029218,882609831,13790778,17.6),(133733,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133733,38.03,0.05,403,62972,70,NULL,NULL,'SDSS J155653.78+272609.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.224083,27.43608,0.105,NULL,59877192984,935581140,14618455,18.3),(133734,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133734,35.87,0.46,150,62973,70,NULL,NULL,'CGCG 079-013',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000163,NULL,'15.3',0.6,NULL,NULL,NULL,NULL,NULL,1,239.22475,14.1275,0.089,NULL,56528322430,883255037,13800859,15.3),(133735,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133735,37.57,0.27,327,62974,70,NULL,NULL,'2MASX J15565491+3447167',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000211,NULL,'15.6g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,239.228667,34.78797,0.045,NULL,59767175625,933862119,14591595,15.6),(133736,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133736,36.47,0.55,197,62975,70,NULL,NULL,'2MASX J15565520-1413422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.230083,-14.22839,0.745,NULL,45477192182,710581127,11102830,15.3),(133737,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133737,38.03,0.05,403,62976,70,NULL,NULL,'2MASX J15565537+2733447',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.23075,27.56256,0.105,NULL,59877184173,935581002,14618453,17.1),(133738,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133738,37.47,0.11,313,62977,70,NULL,NULL,'2MASX J15565612+2842197',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.233917,28.7055,0.097,NULL,59866629883,935416091,14615876,17.6),(133739,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133739,37.58,0.33,328,62978,70,NULL,NULL,'2MASX J15565698+2702587',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000067,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.237416667,27.04967,0.117,NULL,59877882732,935591917,14618623,16.8),(133740,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133740,36.36,0.46,187,62979,70,NULL,NULL,'2MASX J15565864+3154347',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000173,NULL,'15.6g',0.51,'E',NULL,NULL,NULL,NULL,1,239.244417,31.90969,0.061,NULL,59919957222,936249331,14628895,15.6),(133741,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133741,37.66,0.46,341,62980,70,NULL,NULL,'2MASX J15565865+3947431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.244417,39.79528,0.017,NULL,59795732996,934308328,14598567,17.3),(133742,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133742,38.33,0.46,463,62981,70,NULL,NULL,'2MASX J15565977+0532458',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.249083,5.54606,0.157,NULL,56614452559,884600821,13821887,18),(133743,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133743,39.11,0.46,664,62982,70,NULL,NULL,'SDSS J155700.35+335614.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000179,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.2515,33.93725,0.073,NULL,59889942628,935780353,14621568,18.4),(133744,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133744,36.98,0.46,249,62983,70,NULL,NULL,'2MASX J15570199+4921593',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.258125,49.3665,0.049,NULL,59725657517,933213398,14581459,16.9),(133745,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133745,35.15,0.69,107,62984,70,NULL,NULL,'MCG -01-41-002',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00011,NULL,'17',0.4,NULL,NULL,NULL,NULL,NULL,1,239.25825,-6.15517,0.525,NULL,45627271774,712926121,11139470,17),(133746,'SBF','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133746,31.28,0.21,18,62985,NULL,NULL,'I','IC 1153',NULL,'2001ApJ...546..681T',2001,1,1.14,'RC3 gives v = 744 km/sec.','G',0.000067,NULL,'13.6g',0.98,'S0','Group member',NULL,NULL,NULL,1,239.2625417,48.16839,0.069,NULL,59713512642,933023635,14578494,13.6),(133747,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133747,35,0.21,100,62985,70,NULL,NULL,'IC 1153',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133748,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133748,36.86,0.27,236,62986,70,NULL,NULL,'2MASX J15570400+0854033',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000196,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.266583,8.901,0.109,NULL,56636123707,884939432,13827178,16.4),(133749,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133749,38.03,0.05,403,62987,70,NULL,NULL,'SDSS J155704.02+272516.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000076,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.2667917,27.42119,0.105,NULL,59877183322,935580989,14618452,18.4),(133750,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133750,36.44,0.18,194,62988,70,NULL,NULL,'GIN 535',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',0.0001,NULL,'15.7g',0.52,'S',NULL,NULL,NULL,NULL,1,239.2682917,17.62556,0.089,NULL,56565229203,883831706,13809870,15.7),(133751,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133751,37.47,0.11,313,62989,70,NULL,NULL,'SDSS J155704.49+284223.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.26875,28.70658,0.097,NULL,59866632179,935416127,14615876,18.2),(133752,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133752,37.13,0.33,267,62990,70,NULL,NULL,'2MASX J15570529+0941513',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.272166667,9.69753,0.065,NULL,56634303180,884910987,13826734,16.6),(133753,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133753,37.11,0.46,265,62991,70,NULL,NULL,'SDSS J155706.55+025440.8',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000077,NULL,'19.1g',0.08,NULL,NULL,NULL,NULL,NULL,1,239.277333333,2.91133,0.289,NULL,56486337469,882599022,13790609,19.1),(133754,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133754,37.47,0.11,313,62992,70,NULL,NULL,'2MASX J15570699+2837347',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.2790417,28.62631,0.097,NULL,59866644068,935416313,14615879,17.4),(133755,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133755,37.87,0.21,375,62993,70,NULL,NULL,'2MASX J15570713+2818197',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.279625,28.30558,0.109,NULL,59874220292,935534692,14617729,18.3),(133756,'D-Sigma','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133756,33.91,0.4,60.6,62994,75,NULL,'Edat, raw','NGC 6020',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000053,NULL,'13.75',1,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,239.283916667,22.40458,0.113,NULL,59407269847,928238591,14503727,13.75),(133757,'D-Sigma','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133757,34.25,0.4,70.7,62994,75,NULL,'Edat, cor','NGC 6020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133758,'Faber-Jackson','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133758,32.65,0.7,33.9,62994,95,NULL,'Weighted Mean','NGC 6020',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133759,'Faber-Jackson','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133759,32.65,0.7,33.9,62994,95,NULL,'de Vaucouleurs','NGC 6020',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133760,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133760,34.02,0.46,63.7,62994,70,NULL,NULL,'NGC 6020',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133761,'Tertiary','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133761,33.37,0.5,47.2,62994,95,NULL,NULL,'NGC 6020',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133762,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133762,33.98,0.4,62.4,62994,NULL,NULL,'mean','NGC 6020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133763,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133763,34.36,0.45,74.3,62994,NULL,NULL,'K','NGC 6020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133764,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133764,36.92,0.46,243,62995,70,NULL,NULL,'2MASX J15570832-0017252',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000071,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.28475,-0.29033,0.409,NULL,45526042650,711344416,11114756,17.6),(133765,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133765,37.87,0.21,375,62996,70,NULL,NULL,'2MASX J15570849+2822217',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.285458333,28.37278,0.109,NULL,59866622722,935415980,14615874,17.9),(133766,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133766,38.03,0.05,403,62997,70,NULL,NULL,'2MASX J15570890+2723147',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000062,NULL,'17.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.286958333,27.38753,0.105,NULL,59877180073,935580938,14618452,17.7),(133767,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133767,37.53,0.46,320,62998,70,NULL,NULL,'2MASX J15570956+2931597',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.289875,29.53322,0.089,NULL,59869061419,935454084,14616470,17.7),(133768,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133768,37.67,0.23,341,62999,70,NULL,NULL,'SDSS J155710.08+120259.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.292,12.04997,0.105,NULL,56598178304,884346536,13817914,18.2),(133769,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133769,37.71,0.33,349,63000,70,NULL,NULL,'2MASX J15571042+2145583',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.2935,21.76617,0.113,NULL,59405675851,928213685,14503338,17.3),(133770,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133770,38.41,0.46,481,63001,70,NULL,NULL,'SDSS J155710.52+093607.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.293833333,9.60219,0.065,NULL,56634297081,884910891,13826732,18.7),(133771,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133771,37.87,0.21,375,63002,70,NULL,NULL,'2MASX J15571133+2818146',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000194,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.297125,28.30403,0.109,NULL,59874220504,935534695,14617729,17.1),(133772,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133772,37.3,0.46,289,63003,70,NULL,NULL,'2MASX J15571274+3151071',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.303,31.85194,0.061,NULL,59919945060,936249141,14628892,16.7),(133773,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133773,38.03,0.05,403,63004,70,NULL,NULL,'SDSS J155713.24+272858.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.3052083,27.48281,0.105,NULL,59877296277,935582754,14618480,18.6),(133774,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133774,37.45,0.46,308,63005,70,NULL,NULL,'2MASX J15571328+2134503',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000193,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.3055,21.5805,0.117,NULL,59405753925,928214905,14503357,16.3),(133775,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133775,37.87,0.21,375,63006,70,NULL,NULL,'2MASX J15571383+2817127',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.307583,28.28686,0.109,NULL,59874221034,935534703,14617729,16.8),(133776,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133776,38.07,0.46,410,63007,70,NULL,NULL,'SDSS J155714.42+030138.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000074,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.310083,3.02733,0.277,NULL,56481941095,882530329,13789536,18.7),(133777,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133777,37.1,0.46,262,63008,70,NULL,NULL,'2MASX J15571487+0317151',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000096,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.312125,3.28767,0.281,NULL,56482528010,882539500,13789679,17.3),(133778,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133778,37.43,0.33,307,63009,70,NULL,NULL,'2MASX J15571539+2415007',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.314,24.25017,0.165,NULL,59392632972,928009890,14500154,16.6),(133779,'SBF','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133779,32.37,0.31,29.8,63010,NULL,NULL,'I','NGC 6017',NULL,'2001ApJ...546..681T',2001,1,0.8,NULL,'G',0.000017,NULL,'14.10',0.7,'S?','in a pair',NULL,NULL,NULL,1,239.314333,5.99839,0.173,NULL,56612107695,884564182,13821315,14.1),(133780,'SBF','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133780,32.41,0.14,30.3,63010,74.4,NULL,NULL,'NGC 6017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133781,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133781,38.03,0.05,403,63011,70,NULL,NULL,'2MASX J15571633+2740407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.318166667,27.67803,0.105,NULL,59877350379,935583599,14618493,17.9),(133782,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133782,37.74,0.46,352,63012,70,NULL,NULL,'2MASX J15571717+5235014',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000064,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.32175,52.58375,0.005,NULL,59698031209,932781737,14574714,18),(133783,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133783,38.1,0.46,417,63013,70,NULL,NULL,'2MASX J15571787+2012103',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00019,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.324417,20.20297,0.073,NULL,59403516738,928179949,14502811,17.3),(133784,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133784,37.22,0.46,278,63014,70,NULL,NULL,'2MASX J15571832+3510241',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.326417,35.17342,0.041,NULL,59767731166,933870799,14591731,18.2),(133785,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133785,37.43,0.33,306,63015,70,NULL,NULL,'2MASX J15571865+3400551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00017,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.327625,34.01522,0.073,NULL,59766999013,933859359,14591552,17.9),(133786,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133786,37.67,0.23,341,63016,70,NULL,NULL,'2MASX J15571868+1215270',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.8g',0.48,NULL,NULL,NULL,NULL,NULL,1,239.32775,12.25742,0.121,NULL,56526852091,883232063,13800500,15.8),(133787,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133787,38.03,0.05,403,63017,70,NULL,NULL,'2MASX J15571918+2742027',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.330125,27.70092,0.105,NULL,59877349533,935583586,14618493,17.5),(133788,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133788,36.57,0.46,206,63018,70,NULL,NULL,'2MASX J15572003+0626401',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000178,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,239.333583,6.44461,0.145,NULL,56630739159,884855299,13825864,15.7),(133789,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133789,35,0.21,100,63019,70,NULL,NULL,'2MASX J15572018+4812264',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'15.7g',0.37,'E0',NULL,NULL,NULL,NULL,1,239.334125,48.20725,0.069,NULL,59713482536,933023164,14578486,15.7),(133790,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133790,37.64,0.46,338,63020,70,NULL,NULL,'SDSS J155720.52+241443.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,239.335541667,24.24544,0.165,NULL,59392634884,928009920,14500155,18.5),(133791,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133791,37.57,0.27,327,63021,70,NULL,NULL,'2MASX J15572087+3451041',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.336833,34.85122,0.045,NULL,59767672487,933869882,14591716,17.9),(133792,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133792,33.75,0.69,56.2,63022,100,NULL,'mid-IR','UGC 10109',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000187,NULL,'14.67',0.7,'SAB(r)b',NULL,NULL,NULL,NULL,1,239.337375,47.16647,0.053,NULL,59713676484,933026195,14578534,14.67),(133793,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133793,34.25,0.2,70.8,63022,74.4,NULL,NULL,'UGC 10109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133794,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133794,34.69,0.4,86.7,63022,NULL,NULL,'mean','UGC 10109',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133795,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133795,34.86,0.47,93.7,63022,NULL,NULL,'H','UGC 10109',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133796,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133796,36.21,0.33,175,63023,70,NULL,NULL,'CGCG 275-016',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00009,NULL,'14.9g',0.66,'BrClG          PEG',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,239.339167,54.67111,NULL,NULL,57605208836,900081388,14063771,14.9),(133797,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133797,36.23,0.46,176,63024,70,NULL,NULL,'2MASX J15572244+4157502',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.343667,41.96397,0.061,NULL,59797007931,934328248,14598878,17.5),(133798,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133798,37.96,0.46,391,63025,70,NULL,NULL,'SDSS J155722.70+251131.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000125,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.344625,25.19194,0.169,NULL,59874842977,935544421,14617881,18.4),(133799,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133799,34.67,0.52,85.7,63026,70,NULL,NULL,'2MFGC 12799',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.347791667,-15.64394,0.701,NULL,45489539153,710774049,11105844,14.9),(133800,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133800,37.09,0.46,262,63027,70,NULL,NULL,'2MASX J15572394+1512243',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,239.349667,15.20686,0.085,NULL,56569652451,883900819,13810950,15.9),(133801,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133801,38.9,0.46,601,63028,70,NULL,NULL,'SDSS J155724.58+185815.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,239.352417,18.97092,0.057,NULL,56510477380,882976209,13796503,NULL),(133802,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133802,36.33,0.46,184,63029,70,NULL,NULL,'2MASX J15572462+0841071',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000164,NULL,'16.1g',0.34,NULL,NULL,NULL,NULL,NULL,1,239.352583,8.68531,0.097,NULL,56636697214,884948393,13827318,16.1),(133803,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133803,37.58,0.46,328,63030,70,NULL,NULL,'2MASX J15572469+2728177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.352875,27.47158,0.105,NULL,59877297202,935582768,14618480,17.9),(133804,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133804,37.71,0.33,349,63031,70,NULL,NULL,'2MASX J15572487+2149448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.353583,21.82925,0.113,NULL,59405677121,928213705,14503339,17.1),(133805,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133805,37.44,0.46,308,63032,70,NULL,NULL,'SDSS J155725.18+481924.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.3549583,48.32356,0.053,NULL,59713406878,933021982,14578468,18.1),(133806,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133806,35.23,0.73,111,63033,70,NULL,NULL,'2MASX J15572524-2159475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.35525,-21.99656,0.733,NULL,46589027939,727953561,11374274,15.1),(133807,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133807,37.49,0.46,314,63034,70,NULL,NULL,'2MASX J15572566+2000158',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.356875,20.00447,0.085,NULL,59403434934,928178670,14502791,16.5),(133808,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133808,37.8,0.46,363,63035,70,NULL,NULL,'2MASX J15572906+1328293',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.3712083,13.47478,0.085,NULL,56526953842,883233653,13800525,17.7),(133809,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133809,38.17,0.46,431,63036,70,NULL,NULL,'SDSS J155729.34+262447.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000172,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.3722917,26.41325,0.125,NULL,59875075829,935548059,14617938,18.3),(133810,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133810,38.23,0.33,442,63037,70,NULL,NULL,'2MASX J15572949+3724282',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.373,37.40786,0.025,NULL,59761781168,933777830,14590278,17.5),(133811,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133811,34.51,0.4,79.9,63038,NULL,NULL,'mean','NGC 6018',NULL,'2007A&A...465...71T',2007,1,1.4,'This may also be IC 1150.','G',0.000083,NULL,'14.34',0.7,'(R)SAB(s)0+:','Supercluster foreground object',NULL,NULL,NULL,1,239.3740417,15.87261,0.049,NULL,56565529973,883836405,13809943,14.34),(133812,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133812,34.64,0.45,84.5,63038,NULL,NULL,'K','NGC 6018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133813,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133813,38.03,0.05,403,63039,70,NULL,NULL,'2MASX J15573010+2718557',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.3755,27.31547,0.105,NULL,59877772834,935590200,14618596,17.7),(133814,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133814,33.73,0.25,55.7,63040,74.4,NULL,NULL,'NGC 6021',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00007,NULL,'14.15',0.8,'E+','Supercluster foreground object',NULL,NULL,NULL,1,239.377875,15.95606,0.053,NULL,56566383820,883849747,13810152,14.15),(133815,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133815,33.94,0.25,61.3,63040,70,NULL,NULL,'NGC 6021',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133816,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133816,34.54,0.33,80.7,63040,70,NULL,NULL,'NGC 6021',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133817,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133817,34.3,0.4,72.5,63040,NULL,NULL,'mean','NGC 6021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133818,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133818,34.66,0.45,85.6,63040,NULL,NULL,'K','NGC 6021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133819,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133819,37.93,0.46,385,63041,70,NULL,NULL,'2MASX J15573108+2706087',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000106,NULL,'17.7g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,239.3794583,27.10244,0.117,NULL,59877879430,935591866,14618622,17.7),(133820,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133820,36.83,0.46,233,63042,70,NULL,NULL,'2MASX J15573116+1836588',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.379875,18.61636,0.053,NULL,56510868872,882982326,13796598,16.6),(133821,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133821,36.63,0.46,212,63043,70,NULL,NULL,'2MASX J15573163+0744591',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000194,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,239.381917,7.74961,0.125,NULL,56628661675,884822838,13825356,15.8),(133822,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133822,36.18,0.46,172,63044,70,NULL,NULL,'2MASX J15573257+0358462',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.88',0.22,NULL,NULL,NULL,NULL,NULL,1,239.3857083,3.97939,0.257,NULL,56482179525,882534055,13789594,16.88),(133823,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133823,38.23,0.33,442,63045,70,NULL,NULL,'SDSS J155732.67+372105.6',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.386125,37.35156,0.029,NULL,59761817448,933778397,14590287,17.3),(133824,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133824,36.71,0.46,220,63046,70,NULL,NULL,'2MASX J15573283+1737443',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.386875,17.62906,0.061,NULL,56565049799,883828903,13809826,16.5),(133825,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133825,37.42,0.46,305,63047,70,NULL,NULL,'2MASX J15573290+2356048',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.387125,23.93483,0.149,NULL,59392469045,928007328,14500114,17.4),(133826,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133826,36.84,0.46,233,63048,70,NULL,NULL,'SDSS J155733.32+085222.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.388833,8.87297,0.109,NULL,56636631414,884947365,13827302,18.1),(133827,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133827,38.66,0.46,539,63049,70,NULL,NULL,'2MASX J15573366+3510341',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.390458333,35.17619,0.041,NULL,59767728530,933870758,14591730,18),(133828,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133828,37.77,0.46,358,63050,70,NULL,NULL,'2MASX J15573403+3031301',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.391667,30.525,0.065,NULL,59865770173,935402658,14615666,16.9),(133829,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133829,37.16,0.46,270,63051,70,NULL,NULL,'2MASX J15573445+0513432',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.393666667,5.22886,0.177,NULL,56614458455,884600913,13821889,17.7),(133830,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133830,35.4,0.52,120,63052,NULL,NULL,NULL,'KUG 1555+181',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000015,NULL,'15.4g',0.34,'Sb:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.3967083,18.02817,0.077,NULL,56565026303,883828535,13809820,15.4),(133831,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133831,35.49,0.2,125,63052,74.4,NULL,NULL,'KUG 1555+181',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133832,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133832,35.5,0.5,126,63052,NULL,NULL,'Malmquist cor.','KUG 1555+181',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133833,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133833,37.69,0.46,346,63053,70,NULL,NULL,'SDSS J155735.44+100546.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.3977083,10.09633,0.085,NULL,56635088421,884923256,13826925,18.1),(133834,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133834,37.06,0.46,258,63054,70,NULL,NULL,'2MASX J15573658+2851537',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.4024583,28.86494,0.093,NULL,59868673962,935448030,14616375,17.8),(133835,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133835,38.03,0.05,403,63055,70,NULL,NULL,'2MASX J15573746+2720377',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.405916667,27.34383,0.105,NULL,59877772784,935590199,14618596,17.9),(133836,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133836,35.75,0.7,141,63056,70,NULL,NULL,'2MASX J15573750-0253301',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.406375,-2.89169,0.577,NULL,45531723035,711433172,11116143,15.6),(133837,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133837,36.62,0.77,211,63057,70,NULL,NULL,'2MASX J15573754-1320426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.4064583,-13.34519,0.693,NULL,45475188556,710549821,11102340,15.6),(133838,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133838,35.01,0.46,100,63058,70,NULL,NULL,'2MASX J15573901+2517507',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000152,NULL,'16.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.4124583,25.29742,0.169,NULL,59874812606,935543946,14617874,16),(133839,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133839,36.21,0.33,175,63059,70,NULL,NULL,'2MASX J15573968+5439132',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000088,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.415083,54.65361,NULL,NULL,57605207749,900081371,14063771,16.2),(133840,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133840,38.03,0.05,403,63060,70,NULL,NULL,'2MASX J15573968+2748227',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.415291667,27.80619,0.093,NULL,59877343431,935583491,14618492,17.9),(133841,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133841,37.43,0.33,306,63061,70,NULL,NULL,'2MASX J15573974+3403252',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000197,NULL,'16.6g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,239.4155,34.057,0.073,NULL,59768055449,933875866,14591810,16.6),(133842,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133842,38.03,0.05,403,63062,70,NULL,NULL,'2MASX J15573994+2722497',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.4g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,239.41625,27.38031,0.105,NULL,59877265140,935582267,14618472,17.4),(133843,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133843,38.26,0.46,449,63063,70,NULL,NULL,'2MASX J15573997+1401553',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.416416667,14.03203,0.089,NULL,56558398687,883724979,13808202,17.9),(133844,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133844,37.47,0.11,313,63064,70,NULL,NULL,'2MASX J15574008+2852487',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.3g',0.36,'Sa',NULL,NULL,NULL,NULL,1,239.417,28.88028,0.093,NULL,59868673865,935448029,14616375,16.3),(133845,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133845,37.13,0.33,267,63065,70,NULL,NULL,'2MASX J15574036+0947117',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.418041667,9.78647,0.073,NULL,56634382429,884912225,13826753,17.1),(133846,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133846,34.54,0.33,80.7,63066,70,NULL,NULL,'2MASX J15574052+1552283',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'15.5g',0.43,NULL,NULL,NULL,NULL,NULL,1,239.418875,15.87458,0.049,NULL,56565524570,883836321,13809942,15.5),(133847,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133847,37.67,0.23,341,63067,70,NULL,NULL,'2MASX J15574133+1217403',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.422417,12.29461,0.121,NULL,56526677489,883229335,13800458,17.5),(133848,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133848,38.03,0.05,403,63068,70,NULL,NULL,'2MASX J15574152+2724327',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.4229583,27.40906,0.105,NULL,59877265316,935582270,14618472,17.7),(133849,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133849,38.03,0.05,403,63069,70,NULL,NULL,'2MASX J15574203+2719467',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.425083333,27.32953,0.105,NULL,59877772035,935590188,14618596,18.3),(133850,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133850,33.94,0.25,61.3,63070,70,NULL,NULL,'SDSS J155742.59+161304.9',NULL,'2001MNRAS.321..277C',2001,1,0.83,NULL,'G',NULL,NULL,'15.0g',0.64,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.4275,16.21806,0.085,NULL,56566473761,883851152,13810174,15),(133851,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133851,35.74,0.25,141,63071,74.4,NULL,NULL,'CGCG 108-019',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00008,NULL,'15.14',0.8,'SA0^0^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.4287917,16.2175,0.085,NULL,56566442000,883850656,13810166,15.14),(133852,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133852,38.03,0.05,403,63072,70,NULL,NULL,'2MASX J15574360+2716370',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000067,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.4317083,27.27692,0.105,NULL,59877784309,935590379,14618599,18.2),(133853,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133853,37.47,0.11,313,63073,70,NULL,NULL,'2MASX J15574363+2839347',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.4317083,28.65958,0.097,NULL,59868492543,935445195,14616331,17.8),(133854,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133854,36.89,0.15,238,63074,70,NULL,NULL,'SDSS J155744.07+201201.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.433625,20.20028,0.073,NULL,59401454973,928147733,14502308,18),(133855,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133855,37.8,0.46,364,63075,70,NULL,NULL,'2MASX J15574603+3147582',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.4417917,31.79953,0.061,NULL,59920080351,936251255,14628925,17.5),(133856,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133856,37.63,0.46,336,63076,70,NULL,NULL,'SDSS J155746.40+064541.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.443333,6.76142,0.149,NULL,56630892939,884857702,13825901,17.6),(133857,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133857,35.98,0.35,157,63077,NULL,NULL,'Malmquist cor.','KUG 1555+165',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000029,NULL,'16.2g',0.23,'Sbc:',NULL,NULL,NULL,NULL,1,239.44375,16.37344,0.069,NULL,56566269451,883847960,13810124,16.2),(133858,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133858,36,0.35,158,63077,NULL,NULL,NULL,'KUG 1555+165',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133859,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133859,36.04,0.2,161,63077,74.4,NULL,NULL,'KUG 1555+165',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133860,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133860,38.03,0.05,403,63078,70,NULL,NULL,'2MASX J15574757+2744290',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.4482917,27.74142,0.105,NULL,59877345719,935583526,14618492,17.1),(133861,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133861,35.19,0.81,109,63079,NULL,NULL,'Malmquist cor.','NGC 6022',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.00002,NULL,'15.33',0.5,'(R\')SB(s)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.449041667,16.28231,0.085,NULL,56566439081,883850610,13810165,15.33),(133862,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133862,35.22,0.8,111,63079,NULL,NULL,NULL,'NGC 6022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133863,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133863,35.27,0.2,113,63079,74.4,NULL,NULL,'NGC 6022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133864,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133864,37.47,0.11,313,63080,70,NULL,NULL,'2MASX J15574822+2844160',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.450833,28.73797,0.097,NULL,59868489615,935445150,14616330,17.4),(133865,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133865,38.01,0.46,400,63081,70,NULL,NULL,'2MASX J15574848+0745197',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.451917,7.75553,0.125,NULL,56628850322,884825786,13825402,17.3),(133866,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133866,37.27,0.33,284,63082,70,NULL,NULL,'2MASX J15574893+0219292',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000092,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.453875,2.32481,0.313,NULL,56488430313,882631723,13791120,18),(133867,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1969I',NULL,133867,35.22,0.29,111,63083,NULL,NULL,'Avg. of 8 SN host galaxies','[TB93] 1555.6+1937',NULL,'1985ApJ...297...23D',1985,1,NULL,NULL,'G',NULL,NULL,'18.0',NULL,NULL,NULL,NULL,NULL,NULL,1,239.455875,19.47406,0.065,NULL,59400035814,928125559,14501961,18),(133868,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133868,33.94,0.25,61.3,63084,70,NULL,NULL,'NGC 6023',NULL,'2001MNRAS.321..277C',2001,1,1.4,NULL,'G',0.000083,NULL,'14.22',1,'E','Supercluster (RV-confirmed) member',NULL,NULL,'Flat-Spectrum Radio Source',1,239.45675,16.31019,0.085,NULL,56566438368,883850599,13810165,14.22),(133869,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133869,35.75,0.25,141,63084,74.4,NULL,NULL,'NGC 6023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133870,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133870,35.85,0.46,148,63084,70,NULL,NULL,'NGC 6023',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133871,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133871,36.03,0.4,161,63084,NULL,NULL,'mean','NGC 6023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133872,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133872,36.2,0.45,173,63084,NULL,NULL,'K','NGC 6023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133873,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133873,38.03,0.05,403,63085,70,NULL,NULL,'2MASX J15574958+2726120',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000073,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.456667,27.43653,0.105,NULL,59877275076,935582423,14618475,17.6),(133874,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133874,38.03,0.05,403,63086,70,NULL,NULL,'SDSS J155749.68+271812.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000065,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.457,27.3035,0.105,NULL,59877783013,935590359,14618599,18.4),(133875,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133875,35.39,0.64,119,63087,70,NULL,NULL,'2MASX J15574995-1949419',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.458167,-19.82825,0.621,NULL,46581208305,727831379,11372365,15.2),(133876,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133876,38.03,0.05,403,63088,70,NULL,NULL,'SDSS J155750.24+271428.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.459375,27.24122,0.105,NULL,59877783814,935590372,14618599,18.7),(133877,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133877,35.19,0.49,109,63089,75,NULL,'IR','ESO 583- G 008',NULL,'2011yCatp016004901K',2011,1,1.97,NULL,'G',0.000037,NULL,'15.8',0.21,'Sbc',NULL,NULL,NULL,NULL,1,239.460083333,-22.49422,0.725,NULL,46589381238,727959081,11374360,15.8),(133878,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133878,35.32,NULL,116,63089,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 583- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133879,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133879,35.34,NULL,117,63089,NULL,NULL,'Dipole + Quadrupole','ESO 583- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133880,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133880,35.34,NULL,117,63089,NULL,NULL,'Dipole','ESO 583- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133881,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133881,35.65,0.43,135,63089,75,NULL,'3.6 micron, color + selection bias corrected','ESO 583- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133882,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133882,36.15,0.36,170,63090,NULL,NULL,'Malmquist cor.','CGCG 108-023',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000027,NULL,'15.43',0.9,'SA(s)c','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.464,16.36231,0.069,NULL,56566263736,883847870,13810122,15.43),(133883,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133883,36.34,0.33,186,63090,NULL,NULL,NULL,'CGCG 108-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133884,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133884,36.38,0.2,189,63090,74.4,NULL,NULL,'CGCG 108-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133885,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133885,38.03,0.05,403,63091,70,NULL,NULL,'SDSS J155751.66+271605.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000065,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.465291667,27.26828,0.105,NULL,59877785489,935590398,14618599,17.8),(133886,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133886,37.67,0.23,341,63092,70,NULL,NULL,'2MASX J15575198+1222003',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.46675,12.36681,0.081,NULL,56526684247,883229441,13800460,16.9),(133887,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133887,36.55,0.46,205,63093,70,NULL,NULL,'SDSS J155752.04+423504.8',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.466875,42.58467,0.053,NULL,59807660575,934494696,14601479,17.1),(133888,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133888,37.98,0.33,394,63094,70,NULL,NULL,'2MASX J15575273+0232132',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.469625,2.53714,0.293,NULL,56486458751,882600917,13790639,17.7),(133889,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133889,37.98,0.33,394,63095,70,NULL,NULL,'2MASX J15575313+0234252',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000078,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.471333,2.57364,0.289,NULL,56486448214,882600753,13790636,17.5),(133890,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133890,37.87,0.46,375,63096,70,NULL,NULL,'2MASX J15575392+2539101',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.47475,25.65267,0.125,NULL,59875660149,935557189,14618081,17.8),(133891,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133891,36.64,0.14,212,63097,70,NULL,NULL,'2MASX J15575424+1811281',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.475917,18.19119,0.077,NULL,56565012575,883828321,13809817,16.6),(133892,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133892,35.25,0.46,112,63098,70,NULL,NULL,'CGCG 079-014',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000093,NULL,'15.2g',0.55,NULL,NULL,NULL,NULL,NULL,1,239.477375,9.40994,0.105,NULL,56634205211,884909456,13826710,15.2),(133893,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133893,37.87,0.46,374,63099,70,NULL,NULL,'2MASX J15575471+5311033',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.001217,NULL,'17.9g',0.16,'BLAGN',NULL,NULL,NULL,'Sy 1',1,239.478041667,53.18419,0.013,NULL,59698561052,932790016,14574844,17.9),(133894,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133894,38.03,0.05,403,63100,70,NULL,NULL,'SDSS J155754.92+271151.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.478833333,27.19756,0.105,NULL,59877776996,935590265,14618597,18.2),(133895,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133895,37.27,0.33,284,63101,70,NULL,NULL,'2MASX J15575514+0220362',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000103,NULL,'16.5g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,239.479625,2.3435,0.313,NULL,56488441478,882631898,13791123,16.5),(133896,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133896,37.82,0.46,367,63102,70,NULL,NULL,'2MASX J15575611+0610527',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.4837083,6.18142,0.141,NULL,56630712444,884854881,13825857,17.6),(133897,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133897,37.47,0.11,313,63103,70,NULL,NULL,'UGC 10110',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000127,NULL,'15.2g',0.61,'S0?;BrClG',NULL,NULL,NULL,NULL,1,239.4849583,28.79561,0.093,NULL,59868666556,935447914,14616373,15.2),(133898,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133898,38.03,0.05,403,63104,70,NULL,NULL,'2MASX J15575649+2723521',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000065,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.485333333,27.39786,0.105,NULL,59877276433,935582444,14618475,18),(133899,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133899,35.96,0.65,155,63105,70,NULL,NULL,'2MASX J15575679-0550458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,239.486708333,-5.84611,0.533,NULL,45592648839,712385138,11131017,15.7),(133900,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133900,38.03,0.05,403,63106,70,NULL,NULL,'2MASX J15575853+2710431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000069,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.4939583,27.17872,0.105,NULL,59877804301,935590692,14618604,18.1),(133901,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133901,35.09,0.46,104,63107,70,NULL,NULL,'2MASX J15575983+3508082',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000169,NULL,'15.2g',0.51,'S0/a',NULL,NULL,NULL,NULL,1,239.49925,35.13569,0.041,NULL,59767755927,933871186,14591737,15.2),(133902,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133902,38.03,0.05,403,63108,70,NULL,NULL,'2MASX J15580025+2718021',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.501125,27.30061,0.105,NULL,59877783061,935590360,14618599,17.5),(133903,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133903,37.53,0.46,321,63109,70,NULL,NULL,'2MASX J15580094+3446332',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.503917,34.77589,0.045,NULL,59767081083,933860641,14591572,18.3),(133904,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133904,38.5,0.33,502,63110,70,NULL,NULL,'2MASX J15580121+4223530',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.5050417,42.39817,0.053,NULL,59807729289,934495770,14601496,18.4),(133905,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133905,38.03,0.05,403,63111,70,NULL,NULL,'2MASX J15580130+2715021',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.5052917,27.25072,0.105,NULL,59877782476,935590351,14618599,17.8),(133906,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133906,37.81,0.46,365,63112,70,NULL,NULL,'2MASX J15580239+2807481',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.509875,28.13,0.101,NULL,59877111531,935579867,14618435,17.3),(133907,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133907,36.7,0.46,218,63113,70,NULL,NULL,'2MASX J15580351+5259384',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000105,NULL,'16.0g',0.31,'E0',NULL,NULL,NULL,NULL,1,239.5145417,52.99392,0.013,NULL,59698355256,932786800,14574793,16),(133908,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133908,38.5,0.33,502,63114,70,NULL,NULL,'2MASX J15580365+4222301',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.514958333,42.37486,0.053,NULL,59807729590,934495774,14601496,18),(133909,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133909,38.27,0.46,450,63115,70,NULL,NULL,'2MASX J15580370+2726521',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.515417,27.44781,0.105,NULL,59877273974,935582405,14618475,17.8),(133910,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133910,37.66,0.46,340,63116,70,NULL,NULL,'SDSS J155804.97-003505.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000132,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.52075,-0.585,0.409,NULL,45526098906,711345295,11114770,18.6),(133911,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133911,38.03,0.05,403,63117,70,NULL,NULL,'2MASX J15580506+2705311',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.520917,27.09203,0.117,NULL,59877797298,935590582,14618602,17.8),(133912,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133912,37.41,0.46,303,63118,70,NULL,NULL,'2MASX J15580603+0226436',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.525167,2.44536,0.313,NULL,56488435856,882631810,13791122,17.8),(133913,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133913,37.47,0.11,313,63119,70,NULL,NULL,'2MASX J15580647+2858001',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000186,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.5269583,28.96678,0.077,NULL,59868704073,935448501,14616382,17.7),(133914,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133914,38.03,0.05,403,63120,70,NULL,NULL,'2MASX J15580685+2718591',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000143,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.5284583,27.31628,0.105,NULL,59877778765,935590293,14618598,18.6),(133915,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133915,36.3,0.33,182,63121,70,NULL,NULL,'GIN 470',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'16.9g',0.27,'E',NULL,NULL,NULL,NULL,1,239.528667,22.66481,0.101,NULL,59407115633,928236181,14503690,16.9),(133916,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133916,38.03,0.05,403,63122,70,NULL,NULL,'2MASX J15580745+2714431',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.5310417,27.2455,0.105,NULL,59877779664,935590307,14618598,18.2),(133917,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133917,34.08,0.47,65.6,63123,NULL,NULL,'H','IC 1149',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00002,NULL,'14.1P',1,'Sbc',NULL,NULL,NULL,NULL,1,239.53325,12.07028,0.145,NULL,56597948793,884342949,13817858,14.1),(133918,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133918,34.2,0.45,69.2,63123,NULL,NULL,'K','IC 1149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133919,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133919,34.22,0.46,69.9,63123,NULL,NULL,'J','IC 1149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133920,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133920,34.25,0.4,70.8,63123,NULL,NULL,'mean','IC 1149',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133921,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133921,36.89,0.15,238,63124,70,NULL,NULL,'2MASX J15580834+2003011',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.5347917,20.05044,0.065,NULL,59401354417,928146162,14502283,16.7),(133922,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133922,38.03,0.05,403,63125,70,NULL,NULL,'SDSS J155808.92+271022.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.5372083,27.17303,0.105,NULL,59877804699,935590698,14618604,18.3),(133923,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133923,37.29,0.46,286,63126,70,NULL,NULL,'2MASX J15581007+2356381',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.541875,23.94394,0.157,NULL,59392483528,928007555,14500118,17.3),(133924,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133924,38.03,0.05,403,63127,70,NULL,NULL,'2MASX J15581023+2719031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000079,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.542667,27.31753,0.105,NULL,59877781348,935590333,14618598,17.6),(133925,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133925,37.77,0.46,358,63128,70,NULL,NULL,'SDSS J155811.38+263643.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,239.547416667,26.61208,0.153,NULL,59877017380,935578396,14618412,18.8),(133926,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133926,37.82,0.09,366,63129,70,NULL,NULL,'2MASX J15581192+2631201',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000156,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,239.549625,26.52222,0.165,NULL,59877024795,935578512,14618414,16.8),(133927,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133927,38.13,0.33,422,63130,70,NULL,NULL,'2MASX J15581231+2229211',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.5512917,22.48925,0.109,NULL,59407221316,928237833,14503716,16.9),(133928,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133928,38.08,0.25,413,63131,74.4,NULL,NULL,'GIN 471',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000247,NULL,'15.62',NULL,'E/S0',NULL,NULL,NULL,NULL,1,239.5520417,22.48872,0.109,NULL,59407221317,928237833,14503716,15.62),(133929,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133929,37.82,0.46,366,63132,70,NULL,NULL,'2MASX J15581259+2221271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.552625,22.35753,0.113,NULL,59405349624,928208587,14503259,16.9),(133930,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133930,37.34,0.13,294,63133,70,NULL,NULL,'2MASX J15581276+5352513',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000109,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.553333,53.881,NULL,NULL,57604967465,900077616,14063712,16.1),(133931,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133931,37.97,0.33,394,63134,70,NULL,NULL,'2MASX J15581305+5337383',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.55425,53.62761,NULL,NULL,59698389053,932787328,14574802,18),(133932,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133932,35.34,NULL,117,63135,NULL,NULL,'Dipole','UGC 10111',NULL,'2010Ap&SS.325..163P',2010,1,2.07,'UGC declination of +13d27m should be +13d18m.','G',0.000009,NULL,'16.0',0.19,'Sc',NULL,NULL,NULL,NULL,1,239.554875,13.16883,0.105,NULL,56556641375,883697521,13807773,16),(133933,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133933,35.35,NULL,118,63135,NULL,NULL,'Dipole + Quadrupole','UGC 10111',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133934,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133934,35.36,NULL,118,63135,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10111',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133935,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133935,35.54,NULL,128,63135,NULL,NULL,NULL,'UGC 10111',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133936,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133936,36.7,0.2,219,63135,74.4,NULL,NULL,'UGC 10111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133937,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133937,38.03,0.05,403,63136,70,NULL,NULL,'2MASX J15581330+2714531',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000064,NULL,'16.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,239.555375,27.24814,0.105,NULL,59877811385,935590802,14618606,16.3),(133938,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133938,37.47,0.11,313,63137,70,NULL,NULL,'SDSS J155813.73+284632.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,239.557208333,28.77572,0.093,NULL,59868664748,935447886,14616373,18.2),(133939,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133939,38.03,0.05,403,63138,70,NULL,NULL,'B2 1556+27',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.5g',0.22,'Radio galaxy',NULL,NULL,'NAT',NULL,1,239.559625,27.27211,0.105,NULL,59877779910,935590311,14618598,17.5),(133940,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133940,36.87,0.46,236,63139,70,NULL,NULL,'2MASX J15581526+0336247',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.563625,3.60692,0.257,NULL,56482383509,882537242,13789644,16.9),(133941,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133941,38.03,0.05,403,63140,70,NULL,NULL,'SDSS J155815.42+271627.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000061,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.5642917,27.27431,0.105,NULL,59877779961,935590311,14618598,18.9),(133942,'SZ effect','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133942,37.6,NULL,331,63141,NULL,NULL,NULL,'ABELL 2142',NULL,'2001ApJ...555L..11M',2001,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,239.585833,27.22694,0.117,NULL,59877811609,935590806,14618606,NULL),(133943,'SZ effect','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133943,37.63,NULL,335,63141,NULL,NULL,NULL,'ABELL 2142',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133944,'BCG','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133944,38.56,0.35,472,63141,60,NULL,NULL,'ABELL 2142',0.0911,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133945,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133945,38.03,0.05,403,63142,70,NULL,NULL,'2MASX J15581671+2720540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.569625,27.34831,0.105,NULL,59877265941,935582280,14618473,18.1),(133946,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133946,37.11,0.33,264,63143,70,NULL,NULL,'2MASX J15581687+3529256',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.5702917,35.49039,0.065,NULL,59767598690,933868729,14591698,17.1),(133947,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133947,35.95,0.25,155,63144,74.4,NULL,NULL,'CGCG 137-007',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000073,NULL,'15.4g',0.53,'E/S0',NULL,NULL,NULL,NULL,1,239.5727083,22.67478,0.101,NULL,59407118843,928236231,14503691,15.4),(133948,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133948,36.3,0.33,182,63144,70,NULL,NULL,'CGCG 137-007',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133949,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133949,38.03,0.05,403,63145,70,NULL,NULL,'SDSS J155818.43+270325.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000066,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.5767917,27.05711,0.117,NULL,59877798664,935590604,14618603,18.6),(133950,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133950,38.03,0.05,403,63146,70,NULL,NULL,'2MASX J15581875+2714210',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000105,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.5780417,27.23911,0.105,NULL,59877812119,935590814,14618606,17.8),(133951,'BCG','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133951,38.56,0.35,472,63147,60,NULL,'ABELL 2142, BCG','2MASX J15582002+2714000',0.0911,'1980ApJ...241..486H',1980,1,0.67,'VCV (mis?)identifies this as the X-ray source 2E 1556+2725.','G',0.000167,NULL,'16.2g',0.35,'BrClG          Sy1',NULL,NULL,NULL,NULL,1,239.583333,27.23342,0.117,NULL,59877811628,935590806,14618606,16.2),(133952,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133952,38.03,0.05,403,63147,70,NULL,NULL,'2MASX J15582002+2714000',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133953,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133953,36.24,0.25,177,63148,74.4,NULL,NULL,'CGCG 108-025',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000083,NULL,'14.10',0.65,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.5860417,18.08086,0.061,NULL,56565151560,883830493,13809851,14.1),(133954,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133954,36.44,0.18,194,63148,70,NULL,NULL,'CGCG 108-025',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133955,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133955,36.64,0.14,212,63148,70,NULL,NULL,'CGCG 108-025',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133956,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133956,38.03,0.05,403,63149,70,NULL,NULL,'2MASX J15582073+2656460',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000065,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.586416667,26.94614,0.117,NULL,59877789280,935590457,14618600,17),(133957,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133957,38.03,0.05,403,63150,70,NULL,NULL,'2MASX J15582091+2720010',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.587,27.33375,0.105,NULL,59877778328,935590286,14618598,16.6),(133958,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133958,37.82,0.46,366,63151,70,NULL,NULL,'2MASX J15582092+2213002',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.5872083,22.21661,0.133,NULL,59405366872,928208857,14503263,17.4),(133959,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133959,38.03,0.05,403,63152,70,NULL,NULL,'2MASX J15582102+2705260',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.587625,27.09069,0.117,NULL,59877798130,935590595,14618603,17.3),(133960,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133960,37.27,0.46,285,63153,70,NULL,NULL,'2MASX J15582125+2659230',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000172,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.588666667,26.98983,0.117,NULL,59877787024,935590422,14618600,17.7),(133961,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133961,36.12,0.35,167,63154,NULL,NULL,'Malmquist cor.','2MASX J15582240+1606100',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000027,NULL,'16.9g',0.13,'Sc',NULL,NULL,NULL,NULL,1,239.593375,16.10258,0.085,NULL,56566407835,883850122,13810158,16.9),(133962,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133962,36.2,0.34,174,63154,NULL,NULL,NULL,'2MASX J15582240+1606100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133963,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133963,36.24,0.2,177,63154,74.4,NULL,NULL,'2MASX J15582240+1606100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133964,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133964,36.87,0.46,237,63155,70,NULL,NULL,'2MASX J15582245+2254152',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000177,NULL,'17.3g',NULL,NULL,NULL,NULL,NULL,NULL,1,239.5934583,22.90428,0.129,NULL,59407098078,928235907,14503686,17.3),(133965,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133965,36.89,0.15,238,63156,70,NULL,NULL,'2MASX J15582309+2004272',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'16.73',0.3,NULL,NULL,NULL,NULL,NULL,1,239.596125,20.07419,0.061,NULL,59401348417,928146069,14502282,16.73),(133966,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133966,38.03,0.05,403,63157,70,NULL,NULL,'2MASX J15582318+2712260',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00018,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.5965,27.20717,0.117,NULL,59877817953,935590905,14618607,18.2),(133967,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133967,38.03,0.05,403,63158,70,NULL,NULL,'SDSS J155824.50+271125.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.602083,27.19044,0.117,NULL,59877818350,935590911,14618607,18),(133968,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133968,37.42,0.33,305,63159,70,NULL,NULL,'2MASX J15582494+2951090',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00013,NULL,'16.7g',0.3,'Sb;BrClG',NULL,NULL,NULL,NULL,1,239.604041667,29.85267,0.085,NULL,59869261548,935457211,14616518,16.7),(133969,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133969,37.34,0.13,294,63160,70,NULL,NULL,'2MASX J15582512+5357013',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.6047917,53.95056,NULL,NULL,57604974091,900077720,14063714,17.2),(133970,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133970,36.44,0.46,194,63161,70,NULL,NULL,'2MASX J15582551+3509076',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.606291667,35.15206,0.041,NULL,59767765550,933871336,14591739,16.6),(133971,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133971,36.23,0.49,176,63162,75,NULL,'IR','CGCG 108-027',NULL,'2011yCatp016004901K',2011,1,1.04,NULL,'G',0.00013,NULL,'15.3g',0.28,'S..','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.61,18.03964,0.061,NULL,56565145963,883830405,13809850,15.3),(133972,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133972,37.82,0.09,366,63163,70,NULL,NULL,'SDSS J155826.60+262021.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.610875,26.33928,0.165,NULL,59875114101,935548657,14617947,18.3),(133973,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133973,38.03,0.05,403,63164,70,NULL,NULL,'2MASX J15582661+2719120',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.611,27.31992,0.117,NULL,59877777595,935590274,14618598,18.1),(133974,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133974,36.45,0.33,195,63165,70,NULL,NULL,'2MASX J15582666+2448440',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.611083,24.81211,0.153,NULL,59863409363,935365771,14615090,16.8),(133975,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133975,37.82,0.09,366,63166,70,NULL,NULL,'2MASX J15582667+2638431',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.611167,26.64517,0.153,NULL,59877007965,935578249,14618410,16.6),(133976,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133976,37.56,0.46,325,63167,70,NULL,NULL,'2MASX J15582723+2904130',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.1g',0.25,'E',NULL,NULL,NULL,NULL,1,239.6135,29.0705,0.077,NULL,59868657998,935447781,14616371,17.1),(133977,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133977,37.34,0.13,294,63168,70,NULL,NULL,'2MASX J15582816+5350000',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.617417,53.83333,NULL,NULL,59698127895,932783248,14574738,17.2),(133978,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133978,36.52,0.46,201,63169,70,NULL,NULL,'2MASX J15582851+5213270',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000159,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,239.6185417,52.22411,0.017,NULL,59701251834,932832059,14575500,16.4),(133979,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133979,37.97,0.33,394,63170,70,NULL,NULL,'SDSS J155828.48+533917.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.618708333,53.65497,NULL,NULL,59698176752,932784011,14574750,18.2),(133980,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133980,37.16,0.46,270,63171,70,NULL,NULL,'2MASX J15582858+1951453',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,239.619083,19.86264,0.065,NULL,59401317490,928145585,14502274,18.3),(133981,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133981,37.57,0.46,327,63172,70,NULL,NULL,'SDSS J155829.05+281356.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.6210417,28.23225,0.109,NULL,59876062714,935563479,14618179,18.2),(133982,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133982,35.59,0.33,131,63173,70,NULL,NULL,'2MASX J15582911+1421365',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000422,NULL,'15.5g',0.53,NULL,NULL,NULL,NULL,NULL,1,239.621167,14.36017,0.101,NULL,56558437588,883725587,13808212,15.5),(133983,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133983,38.03,0.05,403,63174,70,NULL,NULL,'2MASX J15582938+2727341',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000069,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.62225,27.45958,0.105,NULL,59877292474,935582694,14618479,17.6),(133984,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133984,38.03,0.05,403,63175,70,NULL,NULL,'2MASX J15582955+2706550',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.623333,27.11533,0.117,NULL,59877809068,935590766,14618605,17.8),(133985,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133985,38.13,0.33,422,63176,70,NULL,NULL,'2MASX J15582989+2225293',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000191,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.624583,22.42483,0.109,NULL,59405338751,928208417,14503256,17.8),(133986,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133986,35.85,0.46,148,63177,70,NULL,NULL,'2MASX J15583083+1925453',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'15.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.6285417,19.42922,0.065,NULL,56510437621,882975587,13796493,15.8),(133987,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133987,38.03,0.05,403,63178,70,NULL,NULL,'2MASX J15583149+2721441',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000064,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.631333,27.36214,0.113,NULL,59877281991,935582531,14618477,17.3),(133988,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133988,36.45,0.46,195,63179,70,NULL,NULL,'2MASX J15583151+1355005',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.631416667,13.91672,0.089,NULL,56559448881,883741388,13808459,17.2),(133989,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133989,38.03,0.05,403,63180,70,NULL,NULL,'SDSS J155831.65+272310.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.631917,27.38614,0.113,NULL,59877282589,935582540,14618477,17.9),(133990,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',133990,36.25,0.46,178,63181,70,NULL,NULL,'2MASX J15583199+2813331',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,239.633375,28.22592,0.109,NULL,59876062532,935563477,14618179,16),(133991,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133991,32.96,0.11,38.9,63182,65,NULL,'MLCS','IC 1151',0.007235,'1996ApJ...473..588R',1996,1,2.5,NULL,'G',0.000004,NULL,'13.49',0.8,'SB(rs)c','Supercluster foreground object',NULL,NULL,NULL,1,239.63475,17.44147,0.061,NULL,56568355047,883880547,13810633,13.49),(133992,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133992,32.95,0.09,38.9,63182,74.4,NULL,NULL,'IC 1151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133993,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133993,32.96,0.1,39.1,63182,65,NULL,'Snapshot','IC 1151',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133994,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133994,33.1,0.47,41,63182,67,NULL,NULL,'IC 1151',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133995,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133995,33.11,0.17,41.9,63182,65,NULL,'LCS','IC 1151',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133996,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:52','1','SN 1991M',NULL,133996,33.52,0.18,49.8,63182,65,NULL,'MLCS2k2','IC 1151',0.007235,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133997,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133997,31.92,0.36,24.2,63182,NULL,NULL,NULL,'IC 1151',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133998,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133998,32.06,0.43,25.8,63182,75,NULL,'3.6 micron, color + selection bias corrected','IC 1151',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(133999,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,133999,32.1,0.43,26.3,63182,75,NULL,'3.6 micron, color corrected','IC 1151',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134000,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134000,32.12,0.4,26.5,63182,75,NULL,'HOSTS SN 1991M','IC 1151',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134001,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134001,32.13,0.4,26.7,63182,75,NULL,'HOSTS SN 1991M','IC 1151',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134002,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134002,32.18,0.42,27.3,63182,NULL,18.48,'3.6 micron','IC 1151',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134003,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134003,32.78,0.4,35.9,63182,NULL,NULL,'mean','IC 1151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134004,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134004,32.85,0.47,37.1,63182,NULL,NULL,'H','IC 1151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134005,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134005,32.88,0.46,37.7,63182,NULL,NULL,'J','IC 1151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134006,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134006,32.95,0.09,38.9,63182,74.4,NULL,NULL,'IC 1151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134007,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134007,33,0.45,39.9,63182,NULL,NULL,'K','IC 1151',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134008,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134008,36.25,0.25,178,63183,74.4,NULL,NULL,'GIN 529',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.00008,NULL,'15.7g',0.39,'E/S0',NULL,NULL,NULL,NULL,1,239.634875,17.87147,0.061,NULL,56565122818,883830044,13809844,15.7),(134009,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134009,36.44,0.18,194,63183,70,NULL,NULL,'GIN 529',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134010,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134010,36.64,0.14,212,63183,70,NULL,NULL,'GIN 529',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134011,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134011,39.7,0.46,870,63184,70,NULL,NULL,'SDSS J155832.71+101438.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.9g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.636333333,10.24411,0.101,NULL,56635051354,884922677,13826916,18.9),(134012,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134012,37.81,0.33,364,63185,70,NULL,NULL,'SDSS J155833.99+194223.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,239.641625,19.7065,0.069,NULL,59403403464,928178179,14502784,NULL),(134013,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134013,38.03,0.05,403,63186,70,NULL,NULL,'SDSS J155834.29+270718.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000063,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.642875,27.12183,0.117,NULL,59877808475,935590757,14618605,18.6),(134014,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134014,37.42,0.33,305,63187,70,NULL,NULL,'2MASX J15583424+2946501',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.642958333,29.78053,0.085,NULL,59869262634,935457228,14616519,17.4),(134015,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134015,35.73,0.27,140,63188,70,NULL,NULL,'CGCG 167-008',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000133,NULL,'14.8g',0.62,'E0',NULL,NULL,NULL,NULL,1,239.645,27.61825,0.105,NULL,59877250347,935582036,14618469,14.8),(134016,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134016,36.74,0.46,223,63189,70,NULL,NULL,'2MASX J15583501+2317353',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.645875,23.29325,0.149,NULL,59406565531,928227586,14503556,17.7),(134017,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134017,38.24,0.46,444,63190,70,NULL,NULL,'SDSS J155835.30+500538.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.647125,50.094,0.009,NULL,59724809317,933200145,14581252,18.4),(134018,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134018,36.56,0.46,205,63191,70,NULL,NULL,'2MASX J15583625+3220516',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.651083,32.34764,0.061,NULL,59886533291,935727082,14620735,16.8),(134019,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134019,37.11,0.33,264,63192,70,NULL,NULL,'2MASX J15583652+3517586',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.652333333,35.29956,0.021,NULL,59767634121,933869283,14591707,17.6),(134020,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134020,36.64,0.14,212,63193,70,NULL,NULL,'2MASX J15583701+1802323',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000195,NULL,'15.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.654375,18.04236,0.061,NULL,56564928927,883827014,13809797,15.9),(134021,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134021,37.81,0.33,364,63194,70,NULL,NULL,'SDSS J155838.93+194245.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.66225,19.71275,0.069,NULL,59401306313,928145411,14502272,18.3),(134022,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134022,38.01,0.46,399,63195,70,NULL,NULL,'SDSS J155839.06+362009.2',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.66275,36.33592,0.029,NULL,59776150946,934002358,14593786,18),(134023,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134023,36.19,0.46,173,63196,70,NULL,NULL,'2MASX J15583932+0515578',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.663917,5.26617,0.189,NULL,56611187883,884549810,13821090,16.9),(134024,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134024,35.73,0.27,140,63197,70,NULL,NULL,'2MASX J15584005+2734581',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00019,NULL,'15.9g',0.25,'S0/a',NULL,NULL,NULL,NULL,1,239.6669583,27.58289,0.125,NULL,59877257249,935582144,14618471,15.9),(134025,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134025,36.5,0.46,200,63198,70,NULL,NULL,'2MASX J15584012+3524196',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000188,NULL,'16.1g',0.24,'Sa',NULL,NULL,NULL,NULL,1,239.667333,35.40539,0.021,NULL,59767349966,933864843,14591638,16.1),(134026,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134026,36.92,0.46,243,63199,70,NULL,NULL,'2MASX J15584103+5425024',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000091,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,239.670916667,54.41725,NULL,NULL,57605586993,900087296,14063864,16.3),(134027,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134027,37.61,0.46,333,63200,70,NULL,NULL,'SDSS J155841.83+273737.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000085,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.674291667,27.62711,0.125,NULL,59877257863,935582154,14618471,18.5),(134028,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134028,38.03,0.05,403,63201,70,NULL,NULL,'2MASX J15584357+2720070',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00006,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.681625,27.33528,0.113,NULL,59877237149,935581830,14618466,17.7),(134029,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134029,37.89,0.46,378,63202,70,NULL,NULL,'2MASX J15584431+2005003',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.684708333,20.08356,0.061,NULL,59401355323,928146176,14502284,17.5),(134030,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134030,37.71,0.46,348,63203,70,NULL,NULL,'SDSS J155845.12+170929.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000129,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.688,17.15814,0.061,NULL,56568566898,883883857,13810685,18.3),(134031,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134031,38.03,0.05,403,63204,70,NULL,NULL,'2MASX J15584536+2711520',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000075,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.688833,27.19781,0.117,NULL,59877807251,935590738,14618605,16.8),(134032,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134032,37.82,0.09,366,63205,70,NULL,NULL,'2MASX J15584546+2638510',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,'PHOT','16.3g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,239.68925,26.64767,0.153,NULL,59877090251,935579535,14618430,16.3),(134033,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134033,37.38,0.33,299,63206,70,NULL,NULL,'2MASX J15584717+0349298',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.6965,3.82489,0.245,NULL,56482213337,882534583,13789602,17.1),(134034,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134034,35.72,0.46,139,63207,70,NULL,NULL,'2MASX J15584737+1911423',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000103,NULL,'16.53',0.42,'S',NULL,NULL,NULL,NULL,1,239.6972917,19.19497,0.065,NULL,56510545812,882977278,13796519,16.53),(134035,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134035,35.59,0.33,131,63208,70,NULL,NULL,'CGCG 079-016',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000153,NULL,'15.4',0.45,NULL,NULL,NULL,NULL,NULL,1,239.698708333,14.20375,0.101,NULL,56558468662,883726072,13808219,15.4),(134036,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134036,37.85,0.46,372,63209,70,NULL,NULL,'2MASX J15584776+5331212',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000103,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.69875,53.52264,NULL,NULL,59698149062,932783579,14574743,16.9),(134037,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134037,36.64,0.14,212,63210,70,NULL,NULL,'2MASX J15584781+1759153',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000199,NULL,'16.5g',0.32,'E',NULL,NULL,NULL,NULL,1,239.699333,17.98756,0.061,NULL,56564951926,883827373,13809802,16.5),(134038,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134038,37.82,0.09,366,63211,70,NULL,NULL,'SDSS J155848.28+262626.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.7012083,26.44081,0.165,NULL,59876986459,935577913,14618404,18.2),(134039,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134039,37.38,0.33,299,63212,70,NULL,NULL,'2MASX J15584897+0357278',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000202,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.704125,3.95764,0.249,NULL,56482264286,882535379,13789615,17.9),(134040,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134040,36.55,0.46,204,63213,70,NULL,NULL,'2MASX J15584897+1234205',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.704125,12.57236,0.069,NULL,56556214319,883690848,13807669,17.3),(134041,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134041,38.55,0.46,513,63214,70,NULL,NULL,'2MASX J15584917+3230072',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.7047083,32.50208,0.061,NULL,59886379513,935724679,14620698,17.4),(134042,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134042,38.84,0.46,585,63215,70,NULL,NULL,'2MASX J15585141+3734533',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.71425,37.58147,0.025,NULL,59763074310,933798036,14590594,18),(134043,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134043,37.83,0.27,368,63216,70,NULL,NULL,'SDSS J155852.13+200745.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.3g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.7172083,20.12936,0.061,NULL,59401552174,928149252,14502332,18.3),(134044,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134044,37.82,0.09,366,63217,70,NULL,NULL,'2MASX J15585266+2626183',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000198,NULL,'15.8g',0.48,NULL,NULL,NULL,NULL,NULL,1,239.719417,26.43861,0.165,NULL,59876986409,935577912,14618404,15.8),(134045,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134045,35.45,0.49,123,63218,75,NULL,'IR','CGCG 108-031',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.00001,NULL,'15.6',0.15,'S..','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.7254583,14.9815,0.097,NULL,56559003968,883734437,13808350,15.6),(134046,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134046,35.95,0.32,155,63218,NULL,NULL,'Malmquist cor.','CGCG 108-031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134047,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134047,36.04,0.31,161,63218,NULL,NULL,NULL,'CGCG 108-031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134048,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134048,36.08,0.2,164,63218,74.4,NULL,NULL,'CGCG 108-031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134049,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134049,37.83,0.27,368,63219,70,NULL,NULL,'2MASX J15585474+2005111',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000198,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.728,20.08636,0.061,NULL,59401327177,928145737,14502277,16.7),(134050,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134050,36.24,0.46,177,63220,70,NULL,NULL,'2MASX J15585557+2046372',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.731625,20.77697,0.097,NULL,59401829918,928153592,14502399,17.3),(134051,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134051,36.45,0.33,195,63221,70,NULL,NULL,'2MASX J15585564+2505213',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000183,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.731958333,25.08928,0.169,NULL,59863382245,935365347,14615083,16.7),(134052,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134052,38.03,0.05,403,63222,70,NULL,NULL,'2MASX J15585573+2716403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000062,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.732167,27.27786,0.117,NULL,59877759546,935589992,14618593,17.7),(134053,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134053,38.03,0.05,403,63223,70,NULL,NULL,'2MASX J15585639+2733433',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000088,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.735083333,27.562,0.125,NULL,59877287480,935582616,14618478,18.1),(134054,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134054,35.96,0.33,156,63224,70,NULL,NULL,'CGCG 250-031',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000147,NULL,'15.3g',0.42,'E0',NULL,NULL,NULL,NULL,1,239.736708333,44.76439,0.041,NULL,59684351345,932567989,14571374,15.3),(134055,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134055,37.19,0.46,274,63225,70,NULL,NULL,'2MASX J15585696+0619550',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.73725,6.33186,0.145,NULL,56628042426,884813162,13825205,17.8),(134056,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134056,37.82,0.09,366,63226,70,NULL,NULL,'SDSS J155900.47+263017.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,239.752,26.50475,0.153,NULL,59877062072,935579094,14618423,18.7),(134057,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134057,36.47,0.46,197,63227,70,NULL,NULL,'CGCG 250-032',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000087,NULL,'15.1g',0.51,'E0',NULL,NULL,NULL,NULL,1,239.754291667,46.02336,0.041,NULL,59684649383,932572646,14571447,15.1),(134058,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134058,36.55,0.46,205,63228,70,NULL,NULL,'2MASX J15590200+0223038',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.1g',0.19,'NLAGN',NULL,NULL,NULL,NULL,1,239.758375,2.38431,0.297,NULL,56488574085,882633970,13791155,17.1),(134059,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134059,36.87,0.46,236,63229,70,NULL,NULL,'2MASX J15590264+1109240',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,239.760958333,11.15656,0.113,NULL,56632147017,884877297,13826207,16.2),(134060,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134060,36.86,0.46,236,63230,70,NULL,NULL,'2MASX J15590324+2751173',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.7634583,27.85497,0.097,NULL,59876280577,935566884,14618232,17),(134061,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134061,37.83,0.27,368,63231,70,NULL,NULL,'2MASX J15590340+2003102',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,239.764208333,20.05281,0.061,NULL,59401330622,928145790,14502277,18.1),(134062,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134062,37.53,0.46,321,63232,70,NULL,NULL,'SDSS J155903.74+450113.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.765625,45.0205,0.037,NULL,59684338366,932567786,14571371,18.5),(134063,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134063,38.03,0.05,403,63233,70,NULL,NULL,'SDSS J155904.42+271606.8',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000072,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.768417,27.26856,0.117,NULL,59877767937,935590124,14618595,17.2),(134064,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134064,36.64,0.14,212,63234,70,NULL,NULL,'2MASX J15590469+1759513',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.769625,17.99764,0.061,NULL,56564948522,883827320,13809801,17.2),(134065,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134065,37.75,0.46,354,63235,70,NULL,NULL,'2MASX J15590777+2931433',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.782541667,29.52883,0.089,NULL,59869488201,935460753,14616574,18.3),(134066,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134066,36.69,0.46,218,63236,70,NULL,NULL,'2MASX J15590901+2437373',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.7875,24.62689,0.173,NULL,59863330999,935364546,14615071,17.5),(134067,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134067,38.03,0.05,403,63237,70,NULL,NULL,'2MASX J15590944+2655093',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.3g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,239.789417,26.91942,0.117,NULL,59876923050,935576922,14618389,17.3),(134068,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134068,36.83,0.27,232,63238,70,NULL,NULL,'2MASX J15590949+0247590',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000104,NULL,'15.5g',0.58,'S0^-',NULL,NULL,NULL,NULL,1,239.7897083,2.79958,0.285,NULL,56488387067,882631047,13791110,15.5),(134069,'Ring Diameter','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134069,33.3,0.84,46,63239,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 10120',NULL,'1981ApJS...45..541P',1981,1,0.81,NULL,'G',0.000117,NULL,'14.5g',0.67,'SB(r)b         Sy1','Isolated galaxy',NULL,NULL,'Sy 1',1,239.790125,35.02986,0.057,NULL,59767547842,933867935,14591686,14.5),(134070,'Black Hole','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134070,33.96,1.51,62,63239,NULL,NULL,NULL,'UGC 10120',NULL,'2014ApJ...793..108W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134071,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134071,35.21,0.65,110,63240,70,NULL,NULL,'2MFGC 12821',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'17.34',0.3,NULL,NULL,NULL,NULL,NULL,1,239.791417,-7.67194,0.533,NULL,45628405675,712943838,11139747,17.34),(134072,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134072,36.83,0.27,232,63241,70,NULL,NULL,'2MASX J15591010+0248570',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.792166667,2.81583,0.285,NULL,56486302542,882598477,13790601,16.9),(134073,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134073,36.37,0.46,188,63242,70,NULL,NULL,'2MASX J15591081+0710310',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.795125,7.17522,0.153,NULL,56631474600,884866790,13826043,16.6),(134074,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134074,37.34,0.46,294,63243,70,NULL,NULL,'SDSS J155912.03+205822.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.800167,20.97303,0.101,NULL,59401749708,928152339,14502380,18),(134075,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134075,38.03,0.05,403,63244,70,NULL,NULL,'2MASX J15591244+2705593',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.8017917,27.09969,0.117,NULL,59876905232,935576644,14618385,17.1),(134076,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134076,35.19,0.73,109,63245,70,NULL,NULL,'2MASX J15591328-3040067',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.000083,NULL,'15.85',0.3,'Sa',NULL,NULL,NULL,NULL,1,239.80525,-30.66856,0.713,NULL,47119842875,736247544,11503867,15.85),(134077,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134077,36.83,0.27,232,63246,70,NULL,NULL,'SDSS J155914.11+024715.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000084,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,239.808833333,2.78761,0.285,NULL,56488389905,882631092,13791110,18.5),(134078,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134078,38.03,0.05,403,63247,70,NULL,NULL,'2MASX J15591464+2717243',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000065,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,239.811167,27.29,0.117,NULL,59877754195,935589909,14618592,17.1),(134079,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134079,38.67,0.46,541,63248,70,NULL,NULL,'2MASX J15591486+3944131',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.811916667,39.73692,0.017,NULL,59796064363,934313505,14598648,18),(134080,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134080,36.82,0.46,231,63249,70,NULL,NULL,'2MASX J15591539+0513200',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'16.1g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,239.814041667,5.22211,0.165,NULL,56611223355,884550364,13821099,16.1),(134081,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134081,35.59,0.46,131,63250,70,NULL,NULL,'CGCG 108-034',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000233,NULL,'15.2',0.6,'E:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.815833,15.1765,0.081,NULL,56558944495,883733507,13808336,15.2),(134082,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134082,37.33,0.46,292,63251,70,NULL,NULL,'2MASX J15591650+4007581',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.818625,40.13286,0.025,NULL,59795399291,934303113,14598486,17.7),(134083,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134083,36.97,0.46,247,63252,70,NULL,NULL,'2MASX J15591766+4645368',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.823667,46.76017,0.029,NULL,59713577730,933024652,14578510,17.2),(134084,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134084,37.58,0.46,329,63253,70,NULL,NULL,'2MASX J15591773+3619591',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.823791667,36.33297,0.029,NULL,59775962231,933999409,14593740,17.7),(134085,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134085,38.03,0.05,403,63254,70,NULL,NULL,'2MASX J15591875+2720029',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000074,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.8280417,27.33414,0.113,NULL,59877230929,935581733,14618464,17.2),(134086,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134086,37.92,0.46,384,63255,70,NULL,NULL,'2MASX J15591981+0334550',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,239.8327083,3.58189,0.257,NULL,56481928112,882530126,13789533,17.7),(134087,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134087,37.84,0.33,370,63256,70,NULL,NULL,'2MASX J15592051+3000504',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.8355,30.01389,0.081,NULL,59869246869,935456982,14616515,17.2),(134088,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134088,37.19,0.46,274,63257,70,NULL,NULL,'2MASX J15592099+2907009',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.8g',0.29,'E',NULL,NULL,NULL,NULL,1,239.837375,29.117,0.077,NULL,59868541434,935445959,14616343,16.8),(134089,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134089,35.95,0.2,155,63258,74.4,NULL,NULL,'SDSS J155921.15+150821.4',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',0.000028,NULL,'16.89',0.27,'Sd',NULL,NULL,NULL,NULL,1,239.838125,15.13928,0.081,NULL,56558683710,883729432,13808272,16.89),(134090,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134090,35.98,0.34,157,63258,NULL,NULL,NULL,'SDSS J155921.15+150821.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134091,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134091,36.05,0.33,162,63258,NULL,NULL,'Malmquist cor.','SDSS J155921.15+150821.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134092,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134092,38.03,0.05,403,63259,70,NULL,NULL,'2MASX J15592139+2711479',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00007,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.83925,27.19653,0.117,NULL,59876915262,935576800,14618387,17.6),(134093,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134093,38.75,0.46,563,63260,70,NULL,NULL,'2MASX J15592286+1526557',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.84525,15.44886,0.069,NULL,56570599494,883915617,13811181,17.5),(134094,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134094,38.03,0.05,403,63261,70,NULL,NULL,'2MASX J15592287+2720479',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000064,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.8452917,27.34667,0.113,NULL,59877232008,935581750,14618464,18.5),(134095,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134095,35.31,0.46,115,63262,70,NULL,NULL,'2MASX J15592314+2901019',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000113,NULL,'15.9g',0.3,'S0',NULL,NULL,NULL,NULL,1,239.846375,29.01708,0.077,NULL,59868564921,935446326,14616348,15.9),(134096,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134096,35.73,0.56,140,63263,NULL,NULL,'Malmquist cor.','ESO 515- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.48',0.3,'S              HII',NULL,NULL,NULL,NULL,1,239.849375,-25.343,0.433,NULL,47112448651,736132010,11502062,14.48),(134097,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134097,35.74,0.55,141,63263,NULL,NULL,NULL,'ESO 515- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134098,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134098,35.78,0.2,143,63263,74.4,NULL,NULL,'ESO 515- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134099,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134099,38.03,0.05,403,63264,70,NULL,NULL,'2MASX J15592393+2715169',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.849667,27.25478,0.117,NULL,59877755262,935589925,14618592,17.5),(134100,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134100,35.38,0.46,119,63265,70,NULL,NULL,'2MASX J15592462+0332200',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000097,NULL,'15.9g',0.33,'S0^-',NULL,NULL,NULL,NULL,1,239.8525,3.53903,0.257,NULL,56481914358,882529911,13789529,15.9),(134101,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134101,37.15,0.46,269,63266,70,NULL,NULL,'SDSS J155924.72+171657.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000168,NULL,'18.0g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.8530417,17.28253,0.049,NULL,56568497482,883882773,13810668,18),(134102,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134102,36.51,0.46,200,63267,70,NULL,NULL,'2MASX J15592559+4215488',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000196,NULL,'15.5g',0.49,'E','Field galaxy',NULL,NULL,NULL,1,239.8565,42.26347,0.029,NULL,59807722491,934495663,14601494,15.5),(134103,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134103,37.11,0.33,264,63268,70,NULL,NULL,'2MASX J15592734+3753251',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,239.864,37.89025,0.009,NULL,59763304806,933801637,14590650,16.9),(134104,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134104,37.82,0.09,366,63269,70,NULL,NULL,'2MASX J15592802+2639320',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.866791667,26.65894,0.153,NULL,59877084357,935579443,14618428,17.4),(134105,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134105,37.57,0.33,326,63270,70,NULL,NULL,'2MASX J15592872+1951496',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.869625,19.86383,0.065,NULL,56512272727,883004261,13796941,16.8),(134106,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134106,36.9,0.33,240,63271,70,NULL,NULL,'2MASX J15592919+3314324',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.871625,33.24242,0.073,NULL,59765255089,933832110,14591126,17.2),(134107,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134107,36.64,0.27,212,63272,70,NULL,NULL,'2MASX J15592961+2744080',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000193,NULL,'16.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,239.8735417,27.73547,0.097,NULL,59876161256,935565019,14618203,16.4),(134108,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134108,38.56,0.46,516,63273,70,NULL,NULL,'2MASX J15593070+2646160',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.878,26.77117,0.137,NULL,59877070561,935579227,14618425,17.8),(134109,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134109,37.73,0.33,351,63274,70,NULL,NULL,'2MASX J15593160+2101106',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000197,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,239.881583,21.01961,0.113,NULL,59401739924,928152186,14502377,16.6),(134110,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134110,38,0.46,398,63275,70,NULL,NULL,'SDSS J155933.51+201923.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.889625,20.32331,0.077,NULL,59401423161,928147236,14502300,18.4),(134111,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134111,37.49,0.46,315,63276,70,NULL,NULL,'2MASX J15593453+3915272',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.893833333,39.25736,0.013,NULL,59795650697,934307042,14598547,17.8),(134112,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134112,36.64,0.14,212,63277,70,NULL,NULL,'2MASX J15593490+1759516',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000205,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,239.8955417,17.99764,0.061,NULL,56567851209,883872675,13810510,16),(134113,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134113,38.2,0.46,436,63278,70,NULL,NULL,'2MASX J15593502+0639076',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.896083333,6.65211,0.113,NULL,56627959484,884811866,13825185,17.8),(134114,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134114,37.82,0.09,366,63279,70,NULL,NULL,'2MASX J15593525+2634290',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,239.896958333,26.57486,0.153,NULL,59877053093,935578954,14618421,18.2),(134115,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134115,36.29,0.33,181,63280,70,NULL,NULL,'2MASX J15593525+2459190',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,239.8970417,24.98872,0.149,NULL,59864190530,935377977,14615280,16.5),(134116,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134116,37.11,0.33,264,63281,70,NULL,NULL,'2MASX J15593630+3747044',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,239.901333,37.78464,0.009,NULL,59763087892,933798248,14590597,16.1),(134117,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134117,32.48,0.8,31.3,63282,75,NULL,'MAT, I','ESO 009- G 001',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.20',0.6,'SAB(s)b:',NULL,NULL,NULL,NULL,1,239.902833,-82.91581,0.381,NULL,44046130647,688220791,10753449,13.2),(134118,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134118,32.51,0.32,31.7,63282,85,NULL,'I, inv','ESO 009- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134119,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134119,32.51,0.32,31.8,63282,85,NULL,'I, raw','ESO 009- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134120,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134120,32.54,0.4,32.2,63282,NULL,NULL,NULL,'ESO 009- G 001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134121,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134121,32.54,0.39,32.2,63282,73,NULL,'opt','ESO 009- G 001',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134122,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134122,32.91,0.43,38.2,63282,75,NULL,'MAT, I, raw','ESO 009- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134123,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134123,32.95,0.43,39,63282,75,NULL,'MAT, I, inv','ESO 009- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134124,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,NULL,134124,33.08,0.43,41.3,63282,75,NULL,'MAT, I, cor','ESO 009- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134125,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134125,37.06,0.46,258,63283,70,NULL,NULL,'2MASX J15593959+3110004',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000179,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.915083,31.16689,0.049,NULL,59865398211,935396847,14615575,16.7),(134126,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134126,37.82,0.09,366,63284,70,NULL,NULL,'2MASX J15594010+2632560',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000196,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,239.917125,26.54894,0.153,NULL,59876876770,935576199,14618378,17.4),(134127,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134127,37.84,0.46,370,63285,70,NULL,NULL,'2MASX J15594057+5450512',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000072,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,239.919417,54.84744,0.005,NULL,57605106513,900079789,14063746,17.3),(134128,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134128,37.89,0.46,379,63286,70,NULL,NULL,'SDSS J155941.01+070658.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.920875,7.11625,0.153,NULL,56631248949,884863264,13825988,18.2),(134129,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134129,37.82,0.09,366,63287,70,NULL,NULL,'2MASX J15594166+2629580',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.0g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,239.923708333,26.4995,0.153,NULL,59876879407,935576240,14618378,16),(134130,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134130,37.84,0.33,370,63288,70,NULL,NULL,'2MASX J15594176+3001314',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,239.924041667,30.0255,0.081,NULL,59868789703,935449839,14616403,17.6),(134131,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134131,36.29,0.33,181,63289,70,NULL,NULL,'SDSS J155942.00+250239.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.9250417,25.04425,0.149,NULL,59864200641,935378135,14615283,17.9),(134132,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134132,37.73,0.33,351,63290,70,NULL,NULL,'2MASX J15594203+2101587',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,239.925083333,21.03308,0.129,NULL,59400872401,928138631,14502166,17.8),(134133,'FP','2016-12-15 15:15:38','2016-12-16 11:20:52','1',NULL,'R',134133,37.57,0.33,326,63291,70,NULL,NULL,'SDSS J155942.69+195102.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.7g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,239.927875,19.85058,0.065,NULL,56512267615,883004181,13796940,17.7),(134134,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134134,38.54,0.46,510,63292,70,NULL,NULL,'2MASX J15594321+3521474',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.9302083,35.36314,0.021,NULL,59767509143,933867330,14591677,17.4),(134135,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134135,36.64,0.27,212,63293,70,NULL,NULL,'2MASX J15594391+2742299',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000217,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,239.9330417,27.70825,0.097,NULL,59876157890,935564967,14618202,16.4),(134136,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134136,38.05,0.46,408,63294,70,NULL,NULL,'SDSS J155944.69+271919.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000099,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,239.93625,27.322,0.113,NULL,59876573216,935571456,14618304,18.5),(134137,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134137,34.58,0.69,82.3,63295,100,NULL,'mid-IR','UGC 10121',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000027,NULL,'14.50',0.6,'SAB(rs)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.940833,18.80108,0.061,NULL,56513718784,883026856,13797294,14.5),(134138,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134138,35.54,0.2,128,63295,74.4,NULL,NULL,'UGC 10121',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134139,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134139,35.64,0.4,134,63295,NULL,NULL,'mean','UGC 10121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134140,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134140,35.79,0.47,144,63295,NULL,NULL,'H','UGC 10121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134141,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134141,35.89,0.3,151,63295,NULL,NULL,'Malmquist cor.','UGC 10121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134142,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134142,36.22,0.26,175,63295,NULL,NULL,NULL,'UGC 10121',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134143,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134143,35.59,0.27,131,63296,70,NULL,NULL,'CGCG 051-016',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000126,NULL,'14.4g',0.8,'S0',NULL,NULL,NULL,NULL,1,239.9457083,2.71275,0.285,NULL,56488410930,882631420,13791115,14.4),(134144,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134144,37.82,0.09,366,63297,70,NULL,NULL,'2MASX J15594755+2633339',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,239.9482083,26.55953,0.153,NULL,59876877152,935576205,14618378,17.1),(134145,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134145,36.64,0.14,212,63298,70,NULL,NULL,'2MASX J15594829+1805147',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,239.951083,18.08756,0.061,NULL,56567805296,883871957,13810499,17.1),(134146,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134146,38.03,0.05,403,63299,70,NULL,NULL,'2MASX J15594933+2722463',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000072,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,239.955583,27.37942,0.113,NULL,59876118260,935564347,14618192,17.6),(134147,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134147,35.59,0.27,131,63300,70,NULL,NULL,'CGCG 051-017',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000114,NULL,'15.3g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,239.957041667,2.66722,0.285,NULL,56488397675,882631213,13791112,15.3),(134148,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134148,36.43,0.46,193,63301,70,NULL,NULL,'IC 4587',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000143,NULL,'15.5g',0.51,'E',NULL,NULL,NULL,NULL,1,239.9650417,25.94064,0.125,NULL,59875033795,935547403,14617928,15.5),(134149,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134149,38.19,0.27,435,63302,70,NULL,NULL,'2MASX J15595389+2021326',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'17.1g',0.3,NULL,NULL,NULL,NULL,NULL,1,239.974625,20.359,0.077,NULL,59401434645,928147416,14502303,17.1),(134150,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134150,35.96,0.33,156,63303,70,NULL,NULL,'B3 1558+448',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000189,NULL,'15.4g',0.5,'E0',NULL,NULL,NULL,NULL,1,239.9749583,44.709,0.041,NULL,59684310111,932567345,14571364,15.4),(134151,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134151,32.21,NULL,27.7,63304,72,NULL,NULL,'SDSS J155955.46+065302.7',NULL,'2014Ap.....57..457K',2014,1,0.32,NULL,'G',0.000067,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,239.981083,6.88408,0.153,NULL,56631102931,884860983,13825952,18),(134152,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134152,37.04,0.46,256,63305,70,NULL,NULL,'2MASX J15595691+2624283',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,239.987,26.40786,0.165,NULL,59876876136,935576189,14618377,16.7),(134153,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134153,37.88,0.46,376,63306,70,NULL,NULL,'2MASX J15595766+2618503',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000177,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,239.990375,26.31408,0.165,NULL,59875028465,935547319,14617926,16.9),(134154,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134154,35.84,0.4,147,63307,NULL,NULL,'mean','CGCG 108-037',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000023,NULL,'15.55',0.3,'SAb pec sp','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,239.994417,15.59136,0.057,NULL,56570638195,883916221,13811190,15.55),(134155,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134155,35.95,0.31,155,63307,NULL,NULL,'Malmquist cor.','CGCG 108-037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134156,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134156,36.06,0.47,163,63307,NULL,NULL,'H','CGCG 108-037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134157,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134157,36.08,0.45,164,63307,NULL,NULL,'K','CGCG 108-037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134158,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134158,36.19,0.49,173,63307,75,NULL,'IR','CGCG 108-037',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134159,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134159,36.32,0.2,184,63307,74.4,NULL,NULL,'CGCG 108-037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134160,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134160,36.32,0.26,184,63307,NULL,NULL,NULL,'CGCG 108-037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134161,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134161,36.64,0.27,212,63308,70,NULL,NULL,'2MASX J15595938+2740563',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000153,NULL,'16.2g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,239.997375,27.68219,0.097,NULL,59876166748,935565105,14618204,16.2),(134162,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134162,37.59,0.46,330,63309,70,NULL,NULL,'2MASX J16000055+5301572',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000083,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.0024583,53.0325,NULL,NULL,59698198269,932784347,14574755,17.8),(134163,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134163,38.08,0.46,412,63310,70,NULL,NULL,'2MASX J16000087+3434048',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,240.0035,34.56803,0.053,NULL,59768190186,933877971,14591843,16.6),(134164,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134164,38.13,0.17,423,63311,70,NULL,NULL,'SDSS J160003.05+332829.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.0127083,33.47486,0.057,NULL,59765335250,933833363,14591146,18.1),(134165,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134165,38.8,0.46,576,63312,70,NULL,NULL,'2MASX J16000342+5347582',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.014333,53.79964,NULL,NULL,57604983004,900077859,14063716,18.1),(134166,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134166,38.03,0.05,403,63313,70,NULL,NULL,'2MASX J16000368+2712323',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.015417,27.20903,0.117,NULL,59876457325,935569645,14618275,17.2),(134167,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134167,37.98,0.46,394,63314,70,NULL,NULL,'2MASX J16000430+4559091',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.018083,45.986,0.041,NULL,59681116146,932517439,14570584,17.2),(134168,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134168,36.42,0.46,192,63315,70,NULL,NULL,'2MASX J16000506+0336067',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.021,3.60189,0.245,NULL,56483823779,882559746,13789996,17.2),(134169,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134169,37.77,0.46,358,63316,70,NULL,NULL,'SDSS J160005.38+340522.8',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.022417,34.08969,0.061,NULL,59768254356,933878974,14591858,18.2),(134170,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134170,37.3,0.46,289,63317,70,NULL,NULL,'2MASX J16000562+4236181',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.023208333,42.60514,0.013,NULL,59807809806,934497028,14601516,17.6),(134171,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134171,37.68,0.46,343,63318,70,NULL,NULL,'2MASX J16000672+0327577',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.027917,3.46586,0.257,NULL,56483861914,882560342,13790005,18.1),(134172,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134172,35.59,0.43,131,63319,NULL,NULL,NULL,'2MASX J16000693+1501109',NULL,'2009ApJS..182..474S',2009,1,1.07,NULL,'G',0.000014,NULL,'16.0g',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.028833,15.01981,0.081,NULL,56558732077,883730188,13808284,16),(134173,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134173,35.64,0.2,134,63319,74.4,NULL,NULL,'2MASX J16000693+1501109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134174,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134174,35.76,0.4,142,63319,NULL,NULL,'Malmquist cor.','2MASX J16000693+1501109',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134175,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134175,38.19,0.27,435,63320,70,NULL,NULL,'SDSS J160006.91+201936.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.028833,20.32678,0.077,NULL,59401433726,928147401,14502303,18.7),(134176,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134176,36.24,0.46,177,63321,70,NULL,NULL,'2MASX J16000799+1819006',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000103,NULL,'15.8g',0.36,'S',NULL,NULL,NULL,NULL,1,240.0332083,18.31683,0.061,NULL,56513542655,883024103,13797251,15.8),(134177,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134177,36.56,0.46,205,63322,70,NULL,NULL,'2MASX J16000841+0420507',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.035125,4.34753,0.221,NULL,56484423182,882569112,13790142,17.3),(134178,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134178,36.76,0.33,225,63323,70,NULL,NULL,'2MASX J16000916+0555327',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.0382083,5.92567,0.177,NULL,56611445074,884553829,13821153,16.7),(134179,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134179,37.82,0.09,366,63324,70,NULL,NULL,'SDSS J160009.23+264919.9',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.0385,26.82219,0.137,NULL,59877066468,935579163,14618424,17.9),(134180,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134180,36.83,0.46,232,63325,70,NULL,NULL,'SDSS J160009.63+182302.3',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000176,NULL,'16.0g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.040125,18.38397,0.057,NULL,56513587435,883024803,13797262,16),(134181,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134181,37.82,0.09,366,63326,70,NULL,NULL,'SDSS J160010.04+263319.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.041833,26.55553,0.153,NULL,59876887189,935576362,14618380,18.4),(134182,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134182,37.82,0.09,366,63327,70,NULL,NULL,'2MASX J16001121+2629283',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.046583,26.49114,0.153,NULL,59876899619,935576556,14618383,18.2),(134183,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134183,37.82,0.09,366,63328,70,NULL,NULL,'SDSS J160012.03+260634.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,240.050125,26.10953,0.141,NULL,59875039086,935547485,14617929,18.3),(134184,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134184,38.28,0.33,454,63329,70,NULL,NULL,'2MASX J16001217+0952478',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.050625,9.88003,0.101,NULL,56634509146,884914205,13826784,16.8),(134185,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134185,36.04,0.46,162,63330,70,NULL,NULL,'2MASX J16001313+2924563',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000168,NULL,'16.1g',0.34,'S0',NULL,NULL,NULL,NULL,1,240.05475,29.41564,0.081,NULL,59869391293,935459238,14616550,16.1),(134186,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134186,36.76,0.46,225,63331,70,NULL,NULL,'2MASXi J1600131+462638',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.055167,46.44411,0.025,NULL,59681051431,932516428,14570569,17),(134187,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134187,34.94,0.54,97.2,63332,70,NULL,NULL,'2MASX J16001409-0655056',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00006,NULL,'15.6',NULL,NULL,NULL,NULL,NULL,NULL,1,240.05875,-6.91819,0.537,NULL,45626308665,712911072,11139235,15.6),(134188,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134188,36.44,0.18,194,63333,70,NULL,NULL,'VV 156 NED02',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.0001,NULL,'14.87',NULL,'E/S0',NULL,NULL,NULL,NULL,1,240.0622083,18.37572,0.057,NULL,56513533678,883023963,13797249,14.87),(134189,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134189,37.55,0.25,324,63333,74.4,NULL,NULL,'VV 156 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134190,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134190,36,0.46,158,63334,70,NULL,NULL,'2MASX J16001493+4306341',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000175,NULL,'15.6g',0.48,'E','Field galaxy',NULL,NULL,NULL,1,240.0622083,43.10958,0.025,NULL,59803524405,934430068,14600469,15.6),(134191,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134191,36.96,0.76,246,63335,70,NULL,NULL,'2MASX J16001534-0108090',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,240.063917,-1.13589,0.437,NULL,45526327606,711348868,11114826,14.8),(134192,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134192,38.28,0.33,454,63336,70,NULL,NULL,'SDSS J160015.94+095403.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.0664583,9.90106,0.101,NULL,56633985362,884906021,13826656,18),(134193,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134193,36.76,0.33,225,63337,70,NULL,NULL,'2MASX J16001607+0557337',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000185,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,240.066875,5.95933,0.177,NULL,56611453079,884553954,13821155,16.1),(134194,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134194,38.24,0.46,444,63338,70,NULL,NULL,'2MASX J16001631+2204186',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.068,22.07181,0.133,NULL,59405406914,928209483,14503273,17.6),(134195,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134195,38.19,0.27,435,63339,70,NULL,NULL,'2MASX J16001665+2019577',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000181,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.069541667,20.33281,0.077,NULL,59401381960,928146593,14502290,16.8),(134196,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134196,35.73,0.27,140,63340,70,NULL,NULL,'2MASX J16001706+2735563',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000158,NULL,'16.2g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,240.0712083,27.59908,0.125,NULL,59876173566,935565211,14618206,16.2),(134197,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134197,37.32,0.46,291,63341,70,NULL,NULL,'2MASX J16001712+1019118',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.071333,10.32008,0.137,NULL,56578559642,884039994,13813124,17.5),(134198,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134198,37.82,0.09,366,63342,70,NULL,NULL,'2MASX J16001717+2632403',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.071417,26.54453,0.153,NULL,59876898254,935576535,14618383,17.7),(134199,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134199,37.94,0.46,387,63343,70,NULL,NULL,'2MASX J16001857+4159081',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000172,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.07725,41.98544,0.033,NULL,59808605764,934509465,14601710,17.8),(134200,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134200,37.86,0.46,373,63344,70,NULL,NULL,'2MASX J16001880+3418028',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.078291667,34.30072,0.061,NULL,59768224887,933878513,14591851,18),(134201,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134201,38.13,0.17,423,63345,70,NULL,NULL,'2MASXi J1600195+331953',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.081625,33.33147,0.065,NULL,59765653559,933838336,14591224,18.1),(134202,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134202,37.34,0.13,294,63346,70,NULL,NULL,'2MASX J16002272+5350563',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0001,NULL,'15.8g',0.41,'E0',NULL,NULL,NULL,NULL,1,240.0945417,53.84906,NULL,NULL,57604995324,900078051,14063719,15.8),(134203,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134203,38.13,0.17,423,63347,70,NULL,NULL,'2MASX J16002272+3313186',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',NULL,NULL,'16.7',0.39,'BrClG',NULL,NULL,NULL,NULL,1,240.0947917,33.22167,0.073,NULL,59765525313,933836333,14591192,16.7),(134204,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134204,35.59,0.27,131,63348,70,NULL,NULL,'2MASX J16002360+0244167',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.4g',0.23,'Sa',NULL,NULL,NULL,NULL,1,240.098375,2.73786,0.281,NULL,56485196843,882581200,13790331,16.4),(134205,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134205,34.08,0.8,65.6,63349,75,NULL,'HMCL, I','UGC 10127',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'14.09',0.7,'Sb','Supercluster foreground object',NULL,NULL,NULL,1,240.0997917,20.84908,0.113,NULL,59400947978,928139812,14502184,14.09),(134206,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134206,33.63,0.4,53.2,63349,75,NULL,'HMCL, I, raw','UGC 10127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134207,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134207,33.83,0.4,58.3,63349,75,NULL,'HMCL, I, inv','UGC 10127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134208,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134208,33.88,0.4,59.6,63349,75,NULL,'HMCL, I, cor','UGC 10127',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134209,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134209,34.02,0.47,63.7,63349,NULL,NULL,'H','UGC 10127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134210,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134210,34.03,0.46,63.9,63349,NULL,NULL,'J','UGC 10127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134211,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134211,34.04,0.45,64.3,63349,NULL,NULL,'K','UGC 10127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134212,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134212,34.33,0.4,73.3,63349,NULL,NULL,'mean','UGC 10127',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134213,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134213,36.15,0.46,170,63350,70,NULL,NULL,'2MASX J16002501+0313357',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.104333333,3.22647,0.269,NULL,56483668201,882557315,13789958,17.4),(134214,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134214,38.13,0.17,423,63351,70,NULL,NULL,'SDSS J160025.13+331758.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.10475,33.29972,0.065,NULL,59765653952,933838343,14591224,18.5),(134215,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134215,37.06,0.46,258,63352,70,NULL,NULL,'2MASX J16002550+3716077',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.106291667,37.26886,0.017,NULL,59776210845,934003294,14593801,16.9),(134216,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134216,36.9,0.33,240,63353,70,NULL,NULL,'2MASX J16002557+3318576',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000187,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,240.1065,33.31606,0.065,NULL,59765654384,933838349,14591224,15.6),(134217,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134217,36.19,0.46,173,63354,70,NULL,NULL,'2MASX J16002581+2719529',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.107583,27.33136,0.113,NULL,59876579945,935571561,14618305,17.5),(134218,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134218,38.13,0.17,423,63355,70,NULL,NULL,'SDSS J160026.03+331336.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.108458333,33.22675,0.073,NULL,59765524677,933836323,14591192,18.5),(134219,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134219,35.01,0.6,101,63356,70,NULL,NULL,'2MASX J16002742-0807336',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.97',0.4,NULL,NULL,NULL,NULL,NULL,1,240.1142083,-8.12619,0.517,NULL,45628677583,712948087,11139813,16.97),(134220,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134220,38.33,0.46,463,63357,70,NULL,NULL,'SDSS J160027.94+153602.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.1164583,15.60069,0.057,NULL,56570446367,883913224,13811144,18.2),(134221,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134221,36.29,0.46,181,63358,70,NULL,NULL,'2MASX J16002901+0802098',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000156,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,240.120917,8.03619,0.149,NULL,56629234175,884831783,13825496,16),(134222,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134222,36.17,0.62,171,63359,70,NULL,NULL,'2MASX J16003120-0559336',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.3I',1.1,'Sd?',NULL,NULL,NULL,NULL,1,240.129833,-5.99267,0.541,NULL,45592938234,712389659,11131088,14.3),(134223,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134223,36.6,0.33,209,63360,70,NULL,NULL,'2MASX J16003170+4524411',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.132083,45.4115,0.061,NULL,59684240280,932566254,14571347,16.8),(134224,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134224,38.13,0.17,423,63361,70,NULL,NULL,'2MASX J16003245+3307116',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.135083,33.11983,0.073,NULL,59765531317,933836426,14591194,18),(134225,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134225,37.45,0.46,308,63362,70,NULL,NULL,'2MASX J16003244+3400326',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.135417,34.00906,0.065,NULL,59768133549,933877086,14591829,17.4),(134226,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134226,38.28,0.46,452,63363,70,NULL,NULL,'2MASX J16003304+0423306',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.137666667,4.39203,0.201,NULL,56484351369,882567990,13790124,17.8),(134227,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134227,38.03,0.05,403,63364,70,NULL,NULL,'2MASX J16003335+2658359',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.138917,26.97664,0.117,NULL,59876474478,935569913,14618279,18.4),(134228,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134228,38.95,0.46,616,63365,70,NULL,NULL,'SDSS J160033.45+170949.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000213,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.139416667,17.16372,0.049,NULL,56567634486,883869288,13810457,18.3),(134229,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134229,38.25,0.46,447,63366,70,NULL,NULL,'2MASX J16003348+2838269',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.139625,28.64097,0.101,NULL,59868176664,935440260,14616254,18.1),(134230,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134230,36.78,0.46,227,63367,70,NULL,NULL,'2MASX J16003520+2010560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,240.14675,20.18225,0.077,NULL,56512407498,883006367,13796974,16.6),(134231,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134231,38.02,0.46,402,63368,70,NULL,NULL,'2MASX J16003529+2657489',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.1470417,26.96356,0.117,NULL,59876473993,935569906,14618279,18.4),(134232,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134232,37.34,0.13,294,63369,70,NULL,NULL,'2MASX J16003543+5415297',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000105,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.147833333,54.25811,0.017,NULL,57605412403,900084568,14063821,17.2),(134233,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134233,35.3,0.16,115,63370,74.4,NULL,NULL,'IC 1155',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000007,NULL,'14.88',0.7,'SAB(rs)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.149,15.68564,0.049,NULL,56570461820,883913465,13811147,14.88),(134234,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134234,35.95,0.18,155,63370,70,NULL,NULL,'IC 1155',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134235,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134235,35.79,0.8,144,63370,75,NULL,'HMCL, I','IC 1155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134236,'Sosies','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134236,35.27,0.15,113,63370,NULL,NULL,'Avg. of 7 galaxies','IC 1155',NULL,'1985ApJ...297...23D',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134237,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134237,34.86,0.97,93.9,63370,NULL,NULL,'Malmquist cor.','IC 1155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134238,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134238,34.97,0.92,98.8,63370,NULL,NULL,NULL,'IC 1155',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134239,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134239,34.98,0.4,99.2,63370,75,NULL,'HMCL, I, raw','IC 1155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134240,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134240,35.15,0.4,107,63370,75,NULL,'HMCL, I, inv','IC 1155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134241,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134241,35.3,0.16,115,63370,74.4,NULL,NULL,'IC 1155',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134242,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134242,35.38,0.4,119,63370,75,NULL,'HMCL, I, cor','IC 1155',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134243,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134243,38.02,0.46,401,63371,70,NULL,NULL,'2MASX J16003715+3300526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.154833,33.01464,0.081,NULL,59765513794,933836153,14591189,17.6),(134244,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134244,35.1,0.46,105,63372,70,NULL,NULL,'IC 1156',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.00003,NULL,'14.7g',0.75,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.155667,19.72322,0.069,NULL,56512330529,883005164,13796955,14.7),(134245,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134245,36.82,0.46,231,63373,70,NULL,NULL,'2MASX J16003749+2402479',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000182,NULL,'15.8g',0.46,NULL,NULL,NULL,NULL,NULL,1,240.1562083,24.04681,0.197,NULL,59393411071,928022047,14500344,15.8),(134246,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134246,36.2,0.2,174,63374,74.4,NULL,NULL,'MCG +03-41-024',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000027,NULL,'16.0g',0.24,'S',NULL,NULL,NULL,NULL,1,240.157125,16.67053,0.061,NULL,56565701497,883839085,13809985,16),(134247,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134247,37.27,0.64,285,63375,70,NULL,NULL,'2MASX J16003813-0106425',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00011,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,240.1587917,-1.11192,0.437,NULL,45526525731,711351964,11114874,16.6),(134248,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134248,38.03,0.05,403,63376,70,NULL,NULL,'SDSS J160039.50+265922.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.164625,26.98958,0.117,NULL,59876474627,935569916,14618279,18.1),(134249,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134249,36.1,0.46,166,63377,70,NULL,NULL,'SDSS J160040.46+125541.3',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.168625,12.92817,0.121,NULL,56556066836,883688544,13807633,17.1),(134250,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134250,39,0.46,632,63378,70,NULL,NULL,'2MASX J16004045+2859319',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.1687917,28.99228,0.097,NULL,59868060316,935438442,14616225,18),(134251,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134251,36.64,0.14,212,63379,70,NULL,NULL,'2MASX J16004095+1801210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.17075,18.0225,0.057,NULL,56566792845,883856138,13810252,17.3),(134252,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134252,38.59,0.33,522,63380,70,NULL,NULL,'SDSS J160041.70+265632.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.1737917,26.94225,0.117,NULL,59876473597,935569899,14618279,18.7),(134253,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134253,38.9,0.46,603,63381,70,NULL,NULL,'SDSS J160042.30+200731.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.17625,20.12553,0.077,NULL,56512401350,883006271,13796972,18.7),(134254,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134254,35.21,0.71,110,63382,NULL,NULL,'Malmquist cor.','KUG 1558+168',NULL,'2009ApJS..182..474S',2009,1,0.67,NULL,'G',0.000013,NULL,'15.6g',0.41,'SAa pec','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.179833,16.71628,0.061,NULL,56567543668,883867869,13810435,15.6),(134255,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134255,35.22,0.71,111,63382,NULL,NULL,NULL,'KUG 1558+168',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134256,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134256,35.26,0.2,113,63382,74.4,NULL,NULL,'KUG 1558+168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134257,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134257,38.59,0.33,522,63383,70,NULL,NULL,'2MASX J16004419+2656309',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.184167,26.94189,0.117,NULL,59876473438,935569897,14618279,18.4),(134258,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134258,38.92,0.46,608,63384,70,NULL,NULL,'SDSS J160044.45+531255.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00007,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.1852083,53.21556,NULL,NULL,59698205932,932784467,14574757,18.6),(134259,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134259,36.14,0.05,169,63385,70,NULL,NULL,'2MASX J16004661+1614230',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.194375,16.23972,0.029,NULL,56570369103,883912017,13811125,16.5),(134260,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134260,35.96,0.46,156,63386,70,NULL,NULL,'2MASX J16004669+2354529',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000169,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,240.194583,23.91475,0.169,NULL,59393202864,928018794,14500293,16.1),(134261,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134261,37.82,0.09,366,63387,70,NULL,NULL,'2MASX J16004799+2612339',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.2000417,26.20933,0.141,NULL,59875009984,935547031,14617922,17.8),(134262,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134262,37.34,0.13,294,63388,70,NULL,NULL,'2MASX J16004889+5353450',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000105,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.2035,53.89592,NULL,NULL,57605057113,900079017,14063734,16.5),(134263,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134263,38.68,0.46,546,63389,70,NULL,NULL,'2MASX J16005022+2912099',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000211,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.2092083,29.20281,0.109,NULL,59869367981,935458874,14616544,17.7),(134264,'SNIa','2016-12-15 15:15:38','2016-12-16 11:20:53','1','SN 1958A',NULL,134264,35.22,0.29,111,63390,NULL,NULL,'Avg. of 8 SN host galaxies','MCG +03-41-027',NULL,'1985ApJ...297...23D',1985,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.209708333,19.71164,0.069,NULL,56512319821,883004997,13796953,16.5),(134265,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134265,37.65,0.46,339,63391,70,NULL,NULL,'2MASX J16005046+2916489',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.2102083,29.28031,0.081,NULL,59868849155,935450768,14616418,17.6),(134266,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134266,36.47,0.46,196,63392,70,NULL,NULL,'2MASX J16005062+1324550',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.210875,13.41528,0.137,NULL,56556353489,883693023,13807703,16.8),(134267,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134267,36.95,0.46,246,63393,70,NULL,NULL,'2MASX J16005090+3918038',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.211917,39.30119,0.013,NULL,59795234492,934300538,14598445,17.6),(134268,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134268,37.87,0.46,375,63394,70,NULL,NULL,'2MASX J16005089+0433266',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.212125,4.55744,0.197,NULL,56480863126,882513486,13789273,17),(134269,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134269,37.82,0.09,366,63395,70,NULL,NULL,'2MASX J16005125+2611129',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.2135,26.18692,0.141,NULL,59875010161,935547033,14617922,16.8),(134270,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134270,37.4,0.46,302,63396,70,NULL,NULL,'SDSS J160051.37+065811.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.2140417,6.96972,0.181,NULL,56627690201,884807659,13825119,18.4),(134271,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134271,35.97,0.31,157,63397,NULL,NULL,'Malmquist cor.','CGCG 108-049',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000042,NULL,'15.2g',0.48,'S0^0^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.217958333,17.54578,0.069,NULL,56567276719,883863698,13810370,15.2),(134272,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134272,36.3,0.27,182,63397,NULL,NULL,NULL,'CGCG 108-049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134273,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134273,36.83,0.2,232,63397,74.4,NULL,NULL,'CGCG 108-049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134274,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134274,37.82,0.09,366,63398,70,NULL,NULL,'2MASX J16005276+2606336',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000164,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,240.219875,26.10933,0.141,NULL,59863732543,935370820,14615169,18.6),(134275,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134275,38.03,0.05,403,63399,70,NULL,NULL,'SDSS J160052.83+270834.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000149,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.220167,27.14283,0.117,NULL,59876506415,935570412,14618287,18.6),(134276,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134276,36.34,0.46,185,63400,70,NULL,NULL,'2MASX J16005412+0557306',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,240.225375,5.95861,0.177,NULL,56610591774,884540496,13820945,16.2),(134277,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134277,37.15,0.46,269,63401,70,NULL,NULL,'2MASX J16005434+1643485',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.226417,16.73003,0.041,NULL,56567532758,883867699,13810432,17.4),(134278,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134278,34.4,0.2,75.9,63402,74.4,NULL,NULL,'KUG 1558+128',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000027,NULL,'14.8',0.4,'Sa',NULL,NULL,NULL,NULL,1,240.230458333,12.68039,0.117,NULL,56547793532,883559273,13805613,14.8),(134279,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134279,37.21,0.27,277,63403,70,NULL,NULL,'SDSS J160055.69+100620.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.232041667,10.10564,0.137,NULL,56578666460,884041663,13813150,18),(134280,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134280,36.63,0.46,211,63404,70,NULL,NULL,'2MASX J16005583+1617595',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.2327083,16.29992,0.037,NULL,56570370976,883912046,13811125,16.7),(134281,'IRAS','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134281,34.46,0.8,78.1,63405,75,NULL,'MAT, I','ESO 389- G 006',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'16',0.5,'SA(r)c:',NULL,NULL,NULL,NULL,1,240.2337917,-35.69864,0.841,NULL,46268964192,722952565,11296133,16),(134282,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134282,33.84,0.69,58.7,63405,100,NULL,'mid-IR','ESO 389- G 006',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134283,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134283,34.04,0.2,64.3,63405,74.4,NULL,NULL,'ESO 389- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134284,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134284,34.27,0.32,71.4,63405,85,NULL,'I, raw','ESO 389- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134285,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134285,34.32,0.32,73.2,63405,85,NULL,'I, inv','ESO 389- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134286,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134286,34.4,0.43,75.8,63405,75,NULL,'MAT, I, raw','ESO 389- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134287,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134287,34.59,0.47,82.8,63405,NULL,NULL,'H','ESO 389- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134288,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134288,34.65,0.43,84.9,63405,75,NULL,'MAT, I, inv','ESO 389- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134289,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134289,34.65,0.43,85.1,63405,75,NULL,'MAT, I, cor','ESO 389- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134290,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134290,34.67,0.4,86.1,63405,NULL,NULL,'mean','ESO 389- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134291,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134291,34.74,0.45,88.8,63405,NULL,NULL,'K','ESO 389- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134292,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134292,34.78,0.46,90.4,63405,NULL,NULL,'J','ESO 389- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134293,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134293,34.9,0.83,95.5,63406,NULL,NULL,'Malmquist cor.','IC 1157',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000347,NULL,'15.7',0.3,'Sc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.234417,15.52644,0.057,NULL,56570095073,883907735,13811058,15.7),(134294,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134294,35.05,0.78,103,63406,NULL,NULL,NULL,'IC 1157',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134295,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134295,35.09,0.2,104,63406,74.4,NULL,NULL,'IC 1157',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134296,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134296,37.91,0.12,382,63407,70,NULL,NULL,'2MASX J16005652+2546506',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.235417,25.78069,0.129,NULL,59863977819,935374653,14615228,17.2),(134297,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134297,36.6,0.33,209,63408,70,NULL,NULL,'CGCG 250-036',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.00017,NULL,'15.2g',0.58,'E0',NULL,NULL,NULL,NULL,1,240.236791667,45.41767,0.061,NULL,59684238463,932566225,14571347,15.2),(134298,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134298,35.39,0.46,120,63409,70,NULL,NULL,'CGCG 108-052',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000127,NULL,'15.4g',0.44,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.2372083,18.61469,0.061,NULL,56513758589,883027477,13797304,15.4),(134299,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134299,37.91,0.12,382,63410,70,NULL,NULL,'2MASX J16005761+2555596',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.24,25.93325,0.125,NULL,59863780660,935371572,14615180,18.3),(134300,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134300,36.2,0.46,173,63411,70,NULL,NULL,'2MASX J16005858+1922093',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.9g',0.36,NULL,NULL,NULL,NULL,NULL,1,240.244125,19.36933,0.061,NULL,56513953225,883030519,13797351,15.9),(134301,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134301,36.6,0.46,209,63412,70,NULL,NULL,'2MASX J16005896+2126463',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.2455,21.44614,0.149,NULL,59405231035,928206734,14503230,16.7),(134302,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134302,38.21,0.46,439,63413,70,NULL,NULL,'2MASX J16005901+5301431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000105,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.2457083,53.02875,NULL,NULL,59701011257,932828300,14575442,17.4),(134303,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134303,37.71,0.46,349,63414,70,NULL,NULL,'2MASX J16005930+3837408',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00009,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,240.246917,38.62808,0.017,NULL,59762705309,933792270,14590504,16.3),(134304,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134304,37.03,0.46,254,63415,70,NULL,NULL,'2MASX J16010105+0029177',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000096,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.2544583,0.48817,0.377,NULL,56478792857,882481138,13788767,16.5),(134305,'FP','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,'R',134305,35.92,0.46,153,63416,70,NULL,NULL,'KUG 1558+190',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.25775,18.87997,0.057,NULL,56513624609,883025384,13797271,17),(134306,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134306,35.5,0.39,126,63417,NULL,NULL,NULL,'UGC 10136',NULL,'2009ApJS..182..474S',2009,1,0.98,NULL,'G',0.000154,NULL,'15.3g',0.35,'S?',NULL,NULL,NULL,NULL,1,240.258083333,36.59106,0.025,NULL,59776250373,934003912,14593811,15.3),(134307,'Tully-Fisher','2016-12-15 15:15:38','2016-12-16 11:20:53','1',NULL,NULL,134307,35.57,0.2,130,63417,74.4,NULL,NULL,'UGC 10136',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134308,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134308,35.58,0.37,131,63417,NULL,NULL,'Malmquist cor.','UGC 10136',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134309,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134309,38.39,0.21,477,63418,70,NULL,NULL,'2MASX J16010427+5356541',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000113,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.267875,53.94847,NULL,NULL,57605095240,900079613,14063743,18.1),(134310,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134310,37.82,0.09,366,63419,70,NULL,NULL,'SDSS J160105.18+262027.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.271625,26.341,0.133,NULL,59876838661,935575604,14618368,18.6),(134311,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134311,37.91,0.12,382,63420,70,NULL,NULL,'2MASX J16010547+2552457',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.27275,25.87919,0.125,NULL,59863769233,935371394,14615178,17.3),(134312,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134312,36.89,0.46,238,63421,70,NULL,NULL,'2MASX J16010562+3609109',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.27325,36.15294,0.041,NULL,59775505110,933992267,14593629,17.3),(134313,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134313,37.91,0.12,382,63422,70,NULL,NULL,'2MASX J16010591+2550567',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.274708333,25.84911,0.125,NULL,59863945300,935374145,14615221,18.1),(134314,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134314,37.6,0.46,331,63423,70,NULL,NULL,'2MASX J16010635+2028303',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.2765417,20.47514,0.093,NULL,59400913724,928139276,14502176,17.4),(134315,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134315,36.37,0.46,188,63424,70,NULL,NULL,'2MASX J16010650+1411595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.2772917,14.19986,0.097,NULL,56560186115,883752908,13808639,16.9),(134316,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134316,37.26,0.46,283,63425,70,NULL,NULL,'2MASX J16010682+2516377',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000186,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.278667,25.27722,0.153,NULL,59864021395,935375334,14615239,17.1),(134317,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134317,36.57,0.46,206,63426,70,NULL,NULL,'CGCG 079-020',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000137,NULL,'15.7',0.49,NULL,NULL,NULL,NULL,NULL,1,240.278916667,11.94544,0.113,NULL,56577879561,884029368,13812958,15.7),(134318,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134318,34.23,0.46,70.2,63427,70,NULL,NULL,'CGCG 108-053',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000233,NULL,'14.74',0.8,'SAB0-','Supercluster foreground object',NULL,NULL,NULL,1,240.279375,19.44858,0.061,NULL,56513948940,883030452,13797350,14.74),(134319,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134319,36.9,0.46,240,63428,70,NULL,NULL,'2MASX J16010795+1036112',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,240.283041667,10.60311,0.141,NULL,56578576256,884040254,13813128,16.4),(134320,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134320,36.62,0.46,211,63429,70,NULL,NULL,'2MASX J16010919+2812257',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.288417,28.20706,0.101,NULL,59876206192,935565721,14618214,17.5),(134321,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134321,38.5,0.46,502,63430,70,NULL,NULL,'2MASX J16010963+2148053',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.2902917,21.80142,0.145,NULL,59405102762,928204730,14503198,18.3),(134322,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134322,36.95,0.46,245,63431,70,NULL,NULL,'2MASX J16011003+3509557',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.2919583,35.16553,0.041,NULL,59767294952,933863983,14591624,17.1),(134323,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134323,38.13,0.46,422,63432,70,NULL,NULL,'SDSS J160110.92+253425.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.2955417,25.57375,0.133,NULL,59863932379,935373943,14615217,18.8),(134324,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134324,37.14,0.46,268,63433,70,NULL,NULL,'2MASX J16011121+1009372',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,240.296791667,10.16042,0.137,NULL,56578632749,884041136,13813142,16.7),(134325,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134325,37.77,0.46,357,63434,70,NULL,NULL,'2MASX J16011146+3256417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.2977917,32.94492,0.081,NULL,59765623330,933837864,14591216,17.4),(134326,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134326,38.07,0.46,412,63435,70,NULL,NULL,'SDSS J160111.55+041813.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.298125,4.30383,0.201,NULL,56484490391,882570162,13790158,18.2),(134327,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134327,37.26,0.46,283,63436,70,NULL,NULL,'2MASX J16011155+3152077',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,240.298125,31.86878,0.073,NULL,59735293348,933363958,14583811,16.6),(134328,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134328,35.86,0.49,149,63437,75,NULL,'IR','2MFGC 12848',NULL,'2011yCatp016004901K',2011,1,0.76,NULL,'G',0.000018,NULL,'16.5g',0.18,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.3015,15.75603,0.049,NULL,56569959324,883905614,13811025,16.5),(134329,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134329,35.92,0.33,153,63437,NULL,NULL,'Malmquist cor.','2MFGC 12848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134330,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134330,36.01,0.32,159,63437,NULL,NULL,NULL,'2MFGC 12848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134331,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134331,36.18,0.2,172,63437,74.4,NULL,NULL,'2MFGC 12848',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134332,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134332,36.93,0.46,243,63438,70,NULL,NULL,'2MASX J16011289+2230173',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.303666667,22.50489,0.141,NULL,59394211164,928034549,14500539,17.2),(134333,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134333,35.49,0.2,125,63439,74.4,NULL,NULL,'2MASX J16011331+2428537',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000091,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,240.305417,24.48167,0.197,NULL,59863655342,935369614,14615150,16.1),(134334,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134334,36.53,0.46,202,63440,70,NULL,NULL,'2MASX J16011374+3438087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.307125,34.63564,0.049,NULL,59767874046,933873031,14591766,17.6),(134335,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134335,37.21,0.27,277,63441,70,NULL,NULL,'2MASX J16011385+1008552',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.3077083,10.14858,0.137,NULL,56578631480,884041116,13813142,16.3),(134336,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134336,36.23,0.49,176,63442,75,NULL,'IR','2MFGC 12849',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000037,NULL,'14.8',0.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.308916667,15.68883,0.049,NULL,56570013008,883906453,13811038,14.8),(134337,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134337,35.62,0.49,133,63443,75,NULL,'IR','UGC 10131',NULL,'2011yCatp016004901K',2011,1,1.25,NULL,'G',0.00002,NULL,'16.0',0.11,'Sc','Group non-member, background',NULL,NULL,NULL,1,240.3095,14.07878,0.101,NULL,56560166689,883752604,13808634,16),(134338,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134338,35.9,NULL,152,63443,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10131',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134339,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134339,35.9,NULL,152,63443,NULL,NULL,'Dipole + Quadrupole','UGC 10131',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134340,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134340,35.91,NULL,152,63443,NULL,NULL,'Dipole','UGC 10131',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134341,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134341,36.05,NULL,162,63443,NULL,NULL,NULL,'UGC 10131',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134342,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134342,36.19,0.38,173,63443,NULL,NULL,'Malmquist cor.','UGC 10131',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134343,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134343,36.43,0.34,193,63443,NULL,NULL,NULL,'UGC 10131',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134344,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134344,36.48,0.2,198,63443,74.4,NULL,NULL,'UGC 10131',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134345,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134345,37.91,0.33,382,63444,70,NULL,NULL,'SDSS J160114.48+245354.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.310375,24.89858,0.149,NULL,59864141463,935377210,14615268,18.4),(134346,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134346,38.13,0.17,423,63445,70,NULL,NULL,'2MASX J16011463+3300307',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.3110417,33.00844,0.081,NULL,59765636742,933838074,14591219,17.3),(134347,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134347,38.78,0.46,570,63446,70,NULL,NULL,'2MASX J16011514+1006582',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.3132917,10.11631,0.137,NULL,56578907632,884045431,13813209,17.9),(134348,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134348,37.81,0.46,364,63447,70,NULL,NULL,'2MASX J16011588+0512027',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.31625,5.20072,0.141,NULL,56481429900,882522342,13789411,17.5),(134349,'Sosies','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134349,35.27,0.15,113,63448,NULL,NULL,'Avg. of 7 galaxies','IC 1162',NULL,'1985ApJ...297...23D',1985,1,0.7,NULL,'G',0.00003,NULL,'15.4g',0.53,'SAB(s)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.3180417,17.67783,0.061,NULL,56567306532,883864164,13810377,15.4),(134350,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134350,38.14,0.46,424,63449,70,NULL,NULL,'SDSS J160116.50+054638.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.318791667,5.77725,0.169,NULL,56610729014,884542640,13820978,18.4),(134351,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134351,35.75,0.25,141,63450,74.4,NULL,NULL,'IC 1161',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00008,NULL,'14.82',0.8,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.320083,15.64542,0.049,NULL,56570006101,883906345,13811036,14.82),(134352,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134352,35.95,0.18,155,63450,70,NULL,NULL,'IC 1161',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134353,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134353,36.14,0.05,169,63450,70,NULL,NULL,'IC 1161',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134354,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134354,37.22,0.46,278,63451,70,NULL,NULL,'2MASX J16011726+2059493',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.321833333,20.99703,0.129,NULL,59401042795,928141293,14502207,16.7),(134355,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134355,36.14,0.05,169,63452,70,NULL,NULL,'2MASX J16011808+1644535',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.32525,16.74822,0.029,NULL,56568842651,883888166,13810752,16.6),(134356,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134356,37.99,0.46,396,63453,70,NULL,NULL,'2MASX J16011833+2921467',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.326417,29.36314,0.081,NULL,59868845991,935450718,14616417,18.1),(134357,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134357,35.65,0.45,135,63454,NULL,NULL,NULL,'AGC 251511',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000021,NULL,'14.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,240.327417,15.59239,0.049,NULL,56570003872,883906310,13811036,14.9),(134358,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134358,35.66,0.2,136,63454,74.4,NULL,NULL,'AGC 251511',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134359,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134359,35.86,0.41,149,63454,NULL,NULL,'Malmquist cor.','AGC 251511',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134360,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134360,37.34,0.13,294,63455,70,NULL,NULL,'2MASX J16011900+5400314',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.3289583,54.00858,0.021,NULL,57605086688,900079479,14063741,18),(134361,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134361,36.14,0.05,169,63456,70,NULL,NULL,'2MASX J16011934+1655515',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000163,NULL,'15.8g',0.27,'S',NULL,NULL,NULL,NULL,1,240.330667,16.93083,0.049,NULL,56567069984,883860468,13810319,15.8),(134362,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134362,38.36,0.46,470,63457,70,NULL,NULL,'2MASX J16011967+3618139',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.332166667,36.30375,0.033,NULL,59776580901,934009076,14593891,17.7),(134363,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134363,37.82,0.09,366,63458,70,NULL,NULL,'2MASX J16012016+2604397',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.334125,26.07756,0.141,NULL,59863783396,935371615,14615181,17.4),(134364,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134364,35.73,0.25,140,63459,74.4,NULL,NULL,'CGCG 108-059',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.00007,NULL,'14.9g',0.68,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.338416667,16.67661,0.029,NULL,56572251037,883941422,13811584,14.9),(134365,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134365,35.95,0.18,155,63459,70,NULL,NULL,'CGCG 108-059',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134366,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134366,36.14,0.05,169,63459,70,NULL,NULL,'CGCG 108-059',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134367,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134367,36.52,0.33,201,63460,70,NULL,NULL,'2MASX J16012207+2028382',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,240.342,20.47722,0.109,NULL,56512023668,883000369,13796880,16.2),(134368,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134368,36.54,0.46,203,63461,70,NULL,NULL,'2MASX J16012247+2056102',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.343583333,20.93611,0.129,NULL,59401041772,928141277,14502207,16.8),(134369,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134369,38.39,0.21,477,63462,70,NULL,NULL,'MCG +09-26-045',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000109,NULL,'16.1g',0.44,NULL,NULL,NULL,NULL,NULL,1,240.345708333,53.86642,NULL,NULL,57605053862,900078966,14063733,16.1),(134370,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134370,37.82,0.09,366,63463,70,NULL,NULL,'2MASX J16012364+2606577',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.348583,26.11617,0.141,NULL,59863739197,935370924,14615170,16.8),(134371,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134371,37.93,0.46,385,63464,70,NULL,NULL,'2MASX J16012472+2035405',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.353,20.59475,0.109,NULL,59400921062,928139391,14502177,17.9),(134372,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134372,38.39,0.21,477,63465,70,NULL,NULL,'2MASX J16012490+5402374',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000087,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.3537917,54.04364,0.021,NULL,57604939878,900077185,14063706,18.2),(134373,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134373,38.17,0.46,431,63466,70,NULL,NULL,'2MASX J16012501+4017537',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.354083,40.29831,0.013,NULL,59795462523,934304101,14598501,17.6),(134374,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134374,36.14,0.05,169,63467,70,NULL,NULL,'2MASX J16012700+1632056',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.362417,16.53497,0.029,NULL,56572308929,883942327,13811598,16.6),(134375,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134375,37.82,0.09,366,63468,70,NULL,NULL,'2MASX J16012784+2603251',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.3662083,26.05703,0.141,NULL,59863785441,935371647,14615181,17.2),(134376,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134376,37.38,0.46,299,63469,70,NULL,NULL,'2MASX J16012794+3324497',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000189,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.366375,33.41367,0.065,NULL,59765488805,933835762,14591183,16.7),(134377,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134377,37.34,0.13,294,63470,70,NULL,NULL,'SBS 1600+540A',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000136,NULL,'15.3g',0.56,'E              BrClG',NULL,NULL,NULL,NULL,1,240.367,53.94739,0.021,NULL,57605081004,900079390,14063740,15.3),(134378,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134378,34.1,0.44,66.1,63471,95,NULL,'Weighted Mean','NGC 6028',NULL,'1984ApJS...56...91D',1984,1,1.3,NULL,'G',0.00003,NULL,'14.35',1.2,'(R)SA0+:','Supercluster foreground object',NULL,NULL,NULL,1,240.370666667,19.35989,0.061,NULL,56513964415,883030693,13797354,14.35),(134379,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134379,34.55,0.46,81.3,63471,95,NULL,'Michard 1979a','NGC 6028',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134380,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134380,34.84,0.63,92.9,63471,95,NULL,'Michard 1979b, c','NGC 6028',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134381,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134381,36.22,0.2,175,63472,74.4,NULL,NULL,'CGCG 108-061',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000023,NULL,'15.4g',0.42,'Sc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.3752917,16.75564,0.029,NULL,56568854274,883888348,13810755,15.4),(134382,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134382,35.74,0.25,141,63473,74.4,NULL,NULL,'IC 1163',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00016,NULL,'14.90',0.7,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.3772917,15.50392,0.049,NULL,56570134009,883908343,13811067,14.9),(134383,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134383,35.95,0.18,155,63473,70,NULL,NULL,'IC 1163',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134384,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134384,36.14,0.05,169,63473,70,NULL,NULL,'IC 1163',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134385,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134385,37.82,0.46,367,63474,70,NULL,NULL,'2MASX J16013056+2820321',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.3775,28.34217,0.101,NULL,59868052466,935438319,14616223,17.3),(134386,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134386,36.87,0.27,236,63475,70,NULL,NULL,'2MASX J16013076+1015395',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.378333,10.26117,0.125,NULL,56578621911,884040967,13813140,17.2),(134387,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134387,37.34,0.13,294,63476,70,NULL,NULL,'2MASX J16013134+5354373',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000073,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.38075,53.91047,0.021,NULL,57605082432,900079413,14063740,17.4),(134388,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134388,37.21,0.27,277,63477,70,NULL,NULL,'SDSS J160131.65+101015.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.381875,10.17106,0.137,NULL,56578901287,884045332,13813208,17.8),(134389,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134389,36.55,0.46,204,63478,70,NULL,NULL,'2MASX J16013172+0408261',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.3822083,4.14056,0.221,NULL,56484657284,882572770,13790199,16.9),(134390,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134390,36.14,0.05,169,63479,70,NULL,NULL,'2MASX J16013196+1549506',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000057,NULL,'15.8g',0.29,'E',NULL,NULL,NULL,NULL,1,240.383166667,15.83072,0.021,NULL,56569969365,883905771,13811027,15.8),(134391,'Tully est','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134391,32.41,0.8,30.3,63480,75,NULL,'B','IC 1158',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00002,NULL,'12.8B',1.7,'SAB(r)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.392,1.70783,0.321,NULL,56477651453,882463303,13788489,12.8),(134392,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134392,31.46,0.69,19.6,63480,100,NULL,'mid-IR','IC 1158',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134393,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134393,31.95,0.4,24.5,63480,NULL,NULL,NULL,'IC 1158',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134394,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134394,32.25,0.43,28.1,63480,75,NULL,'3.6 micron, color + selection bias corrected','IC 1158',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134395,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134395,32.25,0.2,28.2,63480,74.4,NULL,NULL,'IC 1158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134396,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134396,32.26,0.43,28.3,63480,75,NULL,'3.6 micron, color corrected','IC 1158',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134397,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134397,32.36,0.49,29.7,63480,NULL,NULL,'Malmquist cor.','IC 1158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134398,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134398,32.42,0.48,30.5,63480,NULL,NULL,NULL,'IC 1158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134399,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134399,32.42,NULL,30.5,63480,72,NULL,NULL,'IC 1158',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134400,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134400,32.74,0.4,35.3,63480,NULL,NULL,'mean','IC 1158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134401,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134401,33.19,0.47,43.5,63480,NULL,NULL,'H','IC 1158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134402,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134402,33.23,0.46,44.3,63480,NULL,NULL,'J','IC 1158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134403,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134403,33.23,0.45,44.3,63480,NULL,NULL,'K','IC 1158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134404,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134404,38.39,0.21,477,63481,70,NULL,NULL,'2MASX J16013485+5349101',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.3952917,53.81939,0.005,NULL,57604875561,900076180,14063690,18),(134405,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134405,36.13,0.2,168,63482,74.4,NULL,NULL,'SDSS J160135.07+152804.4',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000018,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,240.396125,15.46789,0.061,NULL,56570132089,883908313,13811067,18.4),(134406,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134406,37.77,0.33,359,63483,70,NULL,NULL,'2MASX J16013586+0334411',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.3995,3.57797,0.257,NULL,56483308449,882551694,13789870,18.4),(134407,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134407,37.09,0.46,261,63484,70,NULL,NULL,'2MASX J16013598+3107548',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.399875,31.13206,0.037,NULL,59865486348,935398224,14615597,17.2),(134408,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134408,37.62,0.46,334,63485,70,NULL,NULL,'2MASX J16013722-0019037',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000107,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.4050417,-0.31761,0.413,NULL,45526582995,711352859,11114888,17.7),(134409,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134409,37.65,0.33,338,63486,70,NULL,NULL,'2MASX J16013773+3333268',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.4072917,33.55747,0.057,NULL,59765440204,933835003,14591171,17.4),(134410,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134410,36.87,0.27,236,63487,70,NULL,NULL,'2MASX J16013787+1021115',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,240.4077083,10.35325,0.125,NULL,56578705658,884042275,13813160,16.2),(134411,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134411,36.14,0.05,169,63488,70,NULL,NULL,'2MASX J16013923+1600516',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00005,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,240.413333,16.0145,0.029,NULL,56572315732,883942433,13811600,15.9),(134412,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134412,36.26,0.2,179,63489,74.4,NULL,NULL,'SDSS J160139.37+161837.9',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000014,NULL,'16.0g',0.21,'S',NULL,NULL,NULL,NULL,1,240.414083,16.31053,0.037,NULL,56572479095,883944985,13811640,16),(134413,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134413,38.01,0.33,400,63490,70,NULL,NULL,'2MASX J16013939+2629061',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000132,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.41425,26.48517,0.125,NULL,59876325670,935567588,14618243,18),(134414,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134414,38.39,0.21,477,63491,70,NULL,NULL,'2MASX J16013983+5347031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.416083,53.78419,0.005,NULL,57604881870,900076279,14063691,18.1),(134415,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134415,34.72,0.69,87.7,63492,100,NULL,'mid-IR','UGC 10138',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'14.4g',0.6,'Sa','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.417625,21.35294,0.149,NULL,59405196248,928206191,14503221,14.4),(134416,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134416,35.66,0.45,135,63492,NULL,NULL,'K','UGC 10138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134417,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134417,35.68,0.47,136,63492,NULL,NULL,'H','UGC 10138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134418,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134418,35.75,0.46,141,63492,NULL,NULL,'J','UGC 10138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134419,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134419,35.76,0.4,142,63492,NULL,NULL,'mean','UGC 10138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134420,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134420,36.44,0.2,194,63492,74.4,NULL,NULL,'UGC 10138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134421,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134421,36.14,0.05,169,63493,70,NULL,NULL,'2MASX J16014021+1642466',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000171,NULL,'16.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.41775,16.71297,0.029,NULL,56568848310,883888254,13810753,16.1),(134422,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134422,40.74,NULL,1400,63494,NULL,NULL,'Standard','87GB[BWE91] 1600+4325 ABS01',NULL,'2014ApJ...788..190W',2014,1,NULL,NULL,'AbLS',0.0003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,240.41875,43.27889,0.009,NULL,59804425253,934444144,14600689,NULL),(134423,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134423,40.78,NULL,1440,63494,NULL,NULL,'R(H) = ct','87GB[BWE91] 1600+4325 ABS01',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134424,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134424,40.93,0.37,1540,63494,NULL,NULL,NULL,'87GB[BWE91] 1600+4325 ABS01',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134425,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134425,41.42,0.54,1920,63494,NULL,NULL,NULL,'87GB[BWE91] 1600+4325 ABS01',NULL,'2000ApJ...544..117B',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134426,'G Lens','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134426,42.75,0.81,3550,63494,NULL,NULL,NULL,'87GB[BWE91] 1600+4325 ABS01',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134427,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134427,37.91,0.33,382,63495,70,NULL,NULL,'2MASX J16014052+2457471',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.418917,24.963,0.185,NULL,59864023306,935375364,14615240,17.4),(134428,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134428,38.23,0.46,443,63496,70,NULL,NULL,'2MASX J16014075+5137061',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.420083,51.61847,0.009,NULL,59699422724,932803480,14575054,17.2),(134429,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134429,36.7,0.46,219,63497,70,NULL,NULL,'2MASX J16014141+0547401',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000203,NULL,'16.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.4225,5.79467,0.185,NULL,56610783100,884543485,13820991,16.2),(134430,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134430,37.82,0.09,366,63498,70,NULL,NULL,'SDSS J160141.78+260532.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.424083,26.09233,0.141,NULL,59863736516,935370883,14615170,18.8),(134431,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134431,36.87,0.27,236,63499,70,NULL,NULL,'2MASX J16014187+1023425',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,240.424583,10.39508,0.125,NULL,56578717283,884042457,13813163,16.3),(134432,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134432,37.67,0.46,341,63500,70,NULL,NULL,'2MASX J16014194+2216476',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.4247917,22.28006,0.137,NULL,59394096818,928032762,14500511,17.9),(134433,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134433,37.65,0.33,338,63501,70,NULL,NULL,'2MASX J16014245+3331418',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.426875,33.52842,0.057,NULL,59765435092,933834923,14591170,17.6),(134434,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134434,36.42,0.46,192,63502,70,NULL,NULL,'2MASX J16014303+3534398',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.4294583,35.57786,0.045,NULL,59775440712,933991261,14593613,16.9),(134435,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134435,38.01,0.33,400,63503,70,NULL,NULL,'2MASX J16014341+2630302',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.430833,26.50839,0.125,NULL,59876318456,935567475,14618241,17.5),(134436,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134436,36.52,0.33,201,63504,70,NULL,NULL,'CGCG 137-016',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00017,NULL,'15.3g',0.54,NULL,'Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.432208333,20.42275,0.085,NULL,56512881067,883013766,13797090,15.3),(134437,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134437,37.24,0.46,281,63505,70,NULL,NULL,'2MASX J16014396+0550481',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.4332083,5.84683,0.185,NULL,56610781402,884543459,13820991,17.4),(134438,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134438,38.35,0.46,467,63506,70,NULL,NULL,'2MASX J16014472+3431418',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.436208333,34.52817,0.053,NULL,59768736371,933886505,14591976,17.8),(134439,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134439,37.27,0.46,284,63507,70,NULL,NULL,'2MASX J16014495+4052208',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.3g',0.31,NULL,'Field galaxy',NULL,NULL,NULL,1,240.437333,40.87256,0.037,NULL,59809214460,934518975,14601858,16.3),(134440,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134440,37.34,0.13,294,63508,70,NULL,NULL,'2MASX J16014512+5350321',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.438167,53.84219,0.005,NULL,57604877659,900076213,14063690,17.1),(134441,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134441,36.64,0.14,212,63509,70,NULL,NULL,'SDSS J160145.49+180109.7',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.4395417,18.01939,0.085,NULL,56566927020,883858234,13810284,17),(134442,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134442,37.84,0.33,370,63510,70,NULL,NULL,'2MASX J16014632+3956098',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.443041667,39.93614,0.033,NULL,59795971633,934312056,14598625,17),(134443,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134443,37.15,0.46,270,63511,70,NULL,NULL,'2MASX J16014639+2834192',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000218,NULL,'15.8g',0.4,NULL,NULL,NULL,NULL,NULL,1,240.44325,28.57214,0.101,NULL,59868007576,935437618,14616212,15.8),(134444,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134444,37.82,0.09,366,63512,70,NULL,NULL,'2MASX J16014743+2608322',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.447583333,26.14214,0.141,NULL,59864259959,935379061,14615297,17.6),(134445,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134445,36,0.46,159,63513,70,NULL,NULL,'CGCG 250-037',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000183,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,240.4524583,47.38803,0.029,NULL,59714045487,933031960,14578624,15.1),(134446,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134446,36.14,0.05,169,63514,70,NULL,NULL,'2MASX J16014923+1609496',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00006,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,240.455083,16.16372,0.029,NULL,56572370026,883943281,13811613,16.3),(134447,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134447,36.63,0.46,212,63515,70,NULL,NULL,'2MASX J16014924+4303593',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.455167,43.06636,0.009,NULL,59804416452,934444007,14600687,17.1),(134448,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134448,36.96,0.33,246,63516,70,NULL,NULL,'2MASX J16014937+1846016',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.455625,18.76706,0.065,NULL,56511566697,882993229,13796769,17.4),(134449,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134449,37.34,0.13,294,63517,70,NULL,NULL,'2MASX J16014964+5353068',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000087,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.456958333,53.88511,0.005,NULL,57604853770,900075840,14063685,18),(134450,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134450,34.18,0.28,68.7,63518,NULL,NULL,'Malmquist cor.','UGC 10137',NULL,'2009ApJS..182..474S',2009,1,1.27,NULL,'G',0.00003,NULL,'15.0g',0.66,'Sc',NULL,NULL,NULL,NULL,1,240.457167,8.14828,0.169,NULL,56583676128,884119939,13814374,15),(134451,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134451,34.22,0.2,69.8,63518,74.4,NULL,NULL,'UGC 10137',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134452,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134452,34.39,0.26,75.7,63518,NULL,NULL,NULL,'UGC 10137',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134453,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134453,36.62,0.83,211,63519,70,NULL,NULL,'2MASX J16015034-0438517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,240.45975,-4.64769,0.553,NULL,45521582071,711274719,11113667,15.7),(134454,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134454,37.97,0.46,392,63520,70,NULL,NULL,'2MASX J16015080+3654218',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.461583,36.90619,0.033,NULL,59776383689,934005995,14593843,17.9),(134455,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134455,37.34,0.13,294,63521,70,NULL,NULL,'2MASX J16015123+5407438',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000114,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.463417,54.12881,0.021,NULL,57604955121,900077423,14063709,16.7),(134456,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134456,33.81,0.46,57.8,63522,70,NULL,NULL,'NGC 6030',NULL,'2015arXiv151105856S',2015,1,1.22,NULL,'G',0.000063,NULL,'13.6g',0.86,'S0^0^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.46425,17.9575,0.057,NULL,56566919508,883858117,13810283,13.6),(134457,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134457,36.14,0.05,169,63523,70,NULL,NULL,'2MASXi J1601517+161618',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.465625,16.27183,0.037,NULL,56572357849,883943091,13811610,17.3),(134458,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134458,37.57,0.46,326,63524,70,NULL,NULL,'2MASX J16015243+2756521',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.468625,27.94781,0.093,NULL,59876217031,935565891,14618217,17.7),(134459,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134459,37.91,0.12,382,63525,70,NULL,NULL,'2MASX J16015254+2545041',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000196,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.4690417,25.75114,0.125,NULL,59863943292,935374113,14615220,17),(134460,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134460,38.15,0.46,427,63526,70,NULL,NULL,'2MASX J16015264+0707285',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.46925,7.12472,0.145,NULL,56627778744,884809042,13825141,17.3),(134461,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134461,36.96,0.33,246,63527,70,NULL,NULL,'2MASX J16015274+1842046',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.46975,18.70125,0.065,NULL,56511622298,882994098,13796782,17.3),(134462,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134462,37.91,0.12,382,63528,70,NULL,NULL,'SDSS J160153.24+253334.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.471875,25.55961,0.129,NULL,59863921961,935373780,14615215,18.3),(134463,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134463,37.19,0.46,274,63529,70,NULL,NULL,'SDSS J160153.74+513326.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.4739583,51.55742,0.009,NULL,59699415251,932803363,14575052,18.1),(134464,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134464,37.77,0.33,359,63530,70,NULL,NULL,'2MASX J16015450+0334421',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.477083,3.57842,0.261,NULL,56483311763,882551746,13789871,18),(134465,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134465,35.74,0.25,141,63531,74.4,NULL,NULL,'GIN 466',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.000007,NULL,'15.5g',0.47,'S',NULL,NULL,NULL,NULL,1,240.478417,16.45458,0.029,NULL,56572486132,883945095,13811642,15.5),(134466,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134466,35.95,0.18,155,63531,70,NULL,NULL,'GIN 466',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134467,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134467,36.14,0.05,169,63531,70,NULL,NULL,'GIN 466',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134468,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134468,37.15,0.46,269,63532,70,NULL,NULL,'2MASX J16015557+2439581',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.481583333,24.66622,0.189,NULL,59863687168,935370112,14615158,17.9),(134469,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134469,36.04,0.42,161,63533,NULL,NULL,'Malmquist cor.','KUG 1559+135',NULL,'2009ApJS..182..474S',2009,1,0.6,'The position in 1985AnTok..202.237T is 22 arcsec south of the nucleus.','G',0.000157,NULL,'15.5',0.1,'Spiral',NULL,NULL,NULL,NULL,1,240.484167,13.40644,0.141,NULL,56556476339,883694942,13807733,15.5),(134470,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134470,36.39,0.35,189,63533,NULL,NULL,NULL,'KUG 1559+135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134471,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134471,36.49,0.2,199,63533,74.4,NULL,NULL,'KUG 1559+135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134472,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134472,36.9,0.46,240,63534,70,NULL,NULL,'2MASX J16015750+3707498',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,240.48975,37.13064,0.041,NULL,59776325395,934005084,14593829,16.6),(134473,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134473,38.26,0.46,448,63535,70,NULL,NULL,'2MASX J16015820+1452441',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.492583,14.87906,0.069,NULL,56559191371,883737365,13808396,18),(134474,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134474,36.11,0.33,166,63536,70,NULL,NULL,'NGC 6029',NULL,'2015arXiv151105856S',2015,1,0.68,'Star superposed 5\\\" to the north of the nucleus.','G',0.000012,NULL,'15.7g',0.47,'Compact',NULL,NULL,NULL,NULL,1,240.4952917,12.57403,0.109,NULL,56548597068,883571829,13805809,15.7),(134475,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134475,38.21,0.46,439,63537,70,NULL,NULL,'SDSS J160159.50+500458.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.498,50.08283,0.041,NULL,59705924515,932905070,14576641,18.1),(134476,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134476,37.02,0.46,254,63538,70,NULL,NULL,'2MASX J16020024+4920461',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000116,NULL,'15.9g',0.38,'S0',NULL,NULL,NULL,NULL,1,240.5007917,49.34625,0.037,NULL,59711354775,932989918,14577967,15.9),(134477,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134477,35.97,0.46,156,63539,70,NULL,NULL,'2MASX J16020022+4752549',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000161,NULL,'16.0g',0.31,'AGN+SF',NULL,NULL,NULL,NULL,1,240.5009583,47.88189,0.053,NULL,59713990691,933031104,14578611,16),(134478,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134478,38.33,0.46,464,63540,70,NULL,NULL,'2MASX J16020130+0022064',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000089,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.5052917,0.36842,0.381,NULL,56479753409,882496147,13789002,18.6),(134479,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134479,36.06,0.46,163,63541,70,NULL,NULL,'CGCG 250-040',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000173,NULL,'15.0g',0.46,'E0',NULL,NULL,NULL,NULL,1,240.506333,48.66375,0.037,NULL,59711883914,932998186,14578096,15),(134480,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134480,36.14,0.05,169,63542,70,NULL,NULL,'2MASX J16020214+1610081',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.5087917,16.16889,0.037,NULL,56572378846,883943419,13811615,16.2),(134481,'Tully est','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134481,32.94,0.8,38.7,63543,75,NULL,'B','UGCA 411',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000043,NULL,'15.1',0.5,'Pec','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.509125,18.81656,0.065,NULL,56511576128,882993377,13796771,15.1),(134482,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134482,37.53,0.46,320,63544,70,NULL,NULL,'2MASX J16020251+3247447',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.510375,32.79564,0.077,NULL,59764728123,933823876,14590998,16.8),(134483,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134483,37.68,0.46,344,63545,70,NULL,NULL,'2MASX J16020299+1519471',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,240.512417,15.32969,0.061,NULL,56569893371,883904583,13811009,NULL),(134484,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134484,37.17,0.46,272,63546,70,NULL,NULL,'2MASX J16020326+1048524',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.513625,10.81447,0.145,NULL,56580752130,884074252,13813660,16.5),(134485,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134485,38.24,0.46,445,63547,70,NULL,NULL,'SDSS J160203.64+331301.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.5152083,33.21703,0.073,NULL,59765638539,933838102,14591220,18.4),(134486,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134486,37.06,0.46,259,63548,70,NULL,NULL,'2MASX J16020402+5154451',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000179,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,240.516958333,51.91253,NULL,NULL,59701267952,932832311,14575504,16.8),(134487,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134487,36.14,0.05,169,63549,70,NULL,NULL,'CGCG 108-068',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000053,NULL,'14.6g',0.63,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.5177917,17.07586,0.049,NULL,56567237430,883863084,13810360,14.6),(134488,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134488,38.27,0.46,451,63550,70,NULL,NULL,'2MASX J16020516+1501452',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.5215,15.02922,0.065,NULL,56559153826,883736778,13808387,18.3),(134489,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134489,35.95,0.18,155,63551,70,NULL,NULL,'IC 1165 NED01',NULL,'2001MNRAS.321..277C',2001,1,0.7,'RC3 has z = 0.04969 +- 0.00032.','G',0.000197,NULL,'14.8g',0.63,'SA0- pec','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.533458333,15.69656,0.053,NULL,56571883879,883935685,13811495,14.8),(134490,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134490,35.74,0.25,141,63552,74.4,NULL,NULL,'IC 1165',NULL,'2013AJ....146...86T',2013,1,NULL,'VV misprints dec as +15d54\'.','GPair',NULL,NULL,NULL,NULL,NULL,'Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.534166667,15.69389,0.053,NULL,56571887291,883935738,13811495,NULL),(134491,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 2001bp',NULL,134491,38.43,0.3,444,63553,70,NULL,'SALT 2','SDSS J160208.91+364313.8',0.094859,'2013MNRAS.433.2240G',2013,1,0.23,NULL,'G',0.00006,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.537333,36.72056,0.025,NULL,59777125532,934017586,14594024,17.7),(134492,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134492,37.12,0.46,266,63554,70,NULL,NULL,'2MASX J16020943+5323179',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.1g',0.15,'NLAGN',NULL,NULL,NULL,'Sy 2',1,240.5389583,53.38836,NULL,NULL,59698100820,932782825,14574731,18.1),(134493,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134493,36.14,0.05,169,63555,70,NULL,NULL,'2MASX J16021028+1556392',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.542833,15.94425,0.029,NULL,56572582863,883946607,13811665,17.2),(134494,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134494,37.91,0.12,382,63556,70,NULL,NULL,'SDSS J160211.33+253629.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.54725,25.60811,0.129,NULL,59863886260,935373222,14615206,18.3),(134495,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134495,36.66,0.46,215,63557,70,NULL,NULL,'2MASX J16021152+3033468',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,240.548167,30.56297,0.073,NULL,59865931904,935405186,14615706,16.4),(134496,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134496,37.57,0.46,327,63558,70,NULL,NULL,'2MASX J16021220+2043155',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.5507917,20.72089,0.105,NULL,56512056464,883000882,13796888,17.2),(134497,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134497,35.74,0.25,141,63559,74.4,NULL,NULL,'UGC 10143 NOTES02',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00007,NULL,'15.22',0.5,'E3','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.553375,15.90758,0.029,NULL,56571866715,883935417,13811490,15.22),(134498,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134498,35.95,0.18,155,63559,70,NULL,NULL,'UGC 10143 NOTES02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134499,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134499,36.14,0.05,169,63559,70,NULL,NULL,'UGC 10143 NOTES02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134500,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134500,38.53,0.46,508,63560,70,NULL,NULL,'SDSS J160212.92+080803.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.553875,8.13436,0.169,NULL,56583673735,884119902,13814373,18.5),(134501,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134501,35.67,0.46,136,63561,70,NULL,NULL,'2MASX J16021329+3605512',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000171,NULL,'15.9g',0.39,'S0',NULL,NULL,NULL,NULL,1,240.555291667,36.09747,0.041,NULL,59776589154,934009205,14593893,15.9),(134502,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134502,36.39,0.46,189,63562,70,NULL,NULL,'2MASX J16021377+5219059',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000161,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,240.55725,52.31825,NULL,NULL,59701568891,932837013,14575578,15.9),(134503,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134503,36.59,0.46,208,63563,70,NULL,NULL,'2MASX J16021426+3020188',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.5595,30.3385,0.093,NULL,59866075077,935407423,14615740,17.1),(134504,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134504,37.2,0.33,275,63564,70,NULL,NULL,'2MASX J16021499+2053075',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.562416667,20.88553,0.117,NULL,59400817436,928137772,14502152,18.1),(134505,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134505,36.11,0.33,166,63565,70,NULL,NULL,'2MASX J16021500+1237142',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.562583333,12.62072,0.097,NULL,56548648591,883572634,13805822,16.2),(134506,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134506,37.34,0.13,294,63566,70,NULL,NULL,'SDSS J160215.16+541449.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.5632083,54.24697,0.017,NULL,57608387408,900131053,14064547,17.6),(134507,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134507,37.18,0.46,273,63567,70,NULL,NULL,'2MASX J16021630+0033424',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.567917,0.56172,0.369,NULL,56479966023,882499469,13789054,17.4),(134508,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134508,37.42,0.46,305,63568,70,NULL,NULL,'2MASX J16021645+4300459',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.5685,43.01275,0.009,NULL,59804413789,934443965,14600686,17.5),(134509,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134509,36.5,0.35,192,63569,60,NULL,'ABELL 2147, BCG','UGC 10143',0.0377,'1980ApJ...241..486H',1980,1,1.23,NULL,'G',0.000077,NULL,'14.4g',0.73,'cD;E+;BrClG','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.570958333,15.97467,0.029,NULL,56572583066,883946610,13811665,14.4),(134510,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134510,35.74,0.25,141,63569,74.4,NULL,NULL,'UGC 10143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134511,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134511,35.95,0.18,155,63569,70,NULL,NULL,'UGC 10143',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134512,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134512,36.14,0.05,169,63569,70,NULL,NULL,'UGC 10143',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134513,'Magnitude','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134513,36.11,NULL,167,63569,NULL,NULL,'ABELL 2147 cluster','UGC 10143',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134514,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134514,35.93,0.4,153,63569,NULL,NULL,'mean','UGC 10143',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134515,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134515,35.95,0.08,155,63569,70,NULL,'ABELL 2147, BGC','UGC 10143',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134516,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134516,36.21,0.45,174,63569,NULL,NULL,'K','UGC 10143',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134517,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134517,37.2,0.33,275,63570,70,NULL,NULL,'2MASX J16021699+2056165',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000156,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.570875,20.93783,0.117,NULL,59400830575,928137977,14502155,17.1),(134518,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134518,36.14,0.05,169,63571,70,NULL,NULL,'2MASX J16021755+1600102',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00006,NULL,'16.5g',0.24,'E',NULL,NULL,NULL,NULL,1,240.5732917,16.00294,0.029,NULL,56572588878,883946701,13811667,16.5),(134519,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134519,35.76,0.25,142,63572,74.4,NULL,NULL,'ARK 495',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000093,NULL,'15.3B',0.6,'S?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.575083,16.36622,0.029,NULL,56572499666,883945307,13811645,15.3),(134520,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134520,35.95,0.18,155,63572,70,NULL,NULL,'ARK 495',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134521,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134521,36.14,0.05,169,63572,70,NULL,NULL,'ARK 495',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134522,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134522,37.96,0.46,391,63573,70,NULL,NULL,'2MASX J16021862+2307045',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.5777083,23.11786,0.165,NULL,59394699388,928042177,14500659,18),(134523,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134523,36.5,0.35,192,63574,60,NULL,NULL,'ABELL 2147',0.0377,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.577917,16.02,0.029,NULL,56572588137,883946689,13811667,NULL),(134524,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134524,35.95,0.08,155,63574,70,NULL,NULL,'ABELL 2147',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134525,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134525,37.15,0.46,269,63575,70,NULL,NULL,'2MASX J16021944+3238408',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.5809583,32.64481,0.077,NULL,59764765365,933824458,14591007,17.3),(134526,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134526,36.14,0.05,169,63576,70,NULL,NULL,'2MASX J16021949+1618062',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000177,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.581291667,16.30164,0.037,NULL,56572334601,883942728,13811605,17.2),(134527,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134527,35.76,0.25,142,63577,74.4,NULL,NULL,'UGC 10144',NULL,'2013AJ....146...86T',2013,1,1.16,NULL,'G',0.000093,NULL,'14.2g',0.9,'E;BrClG','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.5827083,16.34603,0.037,NULL,56572456432,883944631,13811634,14.2),(134528,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134528,35.95,0.18,155,63577,70,NULL,NULL,'UGC 10144',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134529,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134529,36.14,0.05,169,63577,70,NULL,NULL,'UGC 10144',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134530,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134530,35.78,0.45,144,63577,NULL,NULL,'K','UGC 10144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134531,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134531,36.12,0.4,168,63577,NULL,NULL,'mean','UGC 10144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134532,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134532,37.59,0.46,329,63578,70,NULL,NULL,'2MASX J16021997+4513199',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.583333,45.22233,0.065,NULL,59681431358,932522364,14570661,18),(134533,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134533,38.32,0.46,461,63579,70,NULL,NULL,'2MASX J16022018+2038455',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.584125,20.646,0.105,NULL,56512065514,883001023,13796890,17.9),(134534,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134534,37.65,0.46,340,63580,70,NULL,NULL,'2MASX J16022052+3433398',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.585458333,34.561,0.053,NULL,59768652533,933885195,14591956,18),(134535,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134535,37.15,0.46,269,63581,70,NULL,NULL,'2MASX J16022074+1925345',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.586416667,19.42636,0.061,NULL,56513092439,883017069,13797141,17.4),(134536,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134536,37.86,0.46,374,63582,70,NULL,NULL,'SDSS J160221.26+121546.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.588625,12.26303,0.113,NULL,56548059377,883563427,13805678,18.4),(134537,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134537,36.5,0.46,199,63583,70,NULL,NULL,'2MASX J16022160+1359512',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,240.589917,13.99747,0.117,NULL,56559918907,883748732,13808573,16.2),(134538,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134538,37.91,0.12,382,63584,70,NULL,NULL,'2MASX J16022251+2532576',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000188,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.5939583,25.54928,0.137,NULL,59863920098,935373751,14615214,18.1),(134539,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134539,36.14,0.05,169,63585,70,NULL,NULL,'SDSS J160223.00+155622.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000186,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.595875,15.93964,0.049,NULL,56572580691,883946573,13811665,17.6),(134540,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134540,36.14,0.05,169,63586,70,NULL,NULL,'2MASX J16022333+1559469',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000057,NULL,'16.7g',NULL,NULL,NULL,NULL,NULL,NULL,1,240.5972083,15.99644,0.029,NULL,56572581455,883946585,13811665,16.7),(134541,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134541,35.77,0.46,142,63587,70,NULL,NULL,'CGCG 195-007',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000117,NULL,'14.8g',0.58,'E0',NULL,NULL,NULL,NULL,1,240.5982917,36.10989,0.041,NULL,59776655468,934010241,14593910,14.8),(134542,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134542,36.64,0.14,212,63588,70,NULL,NULL,'2MASX J16022454+1815585',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00015,NULL,'15.5g',0.48,'S0/E3','Group member',NULL,NULL,NULL,1,240.602333,18.26633,0.081,NULL,56511550660,882992979,13796765,15.5),(134543,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134543,38.96,0.46,619,63589,70,NULL,NULL,'SDSS J160224.74+063735.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.603125,6.62647,0.165,NULL,56627368244,884802628,13825041,18.5),(134544,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134544,38.21,0.46,439,63590,70,NULL,NULL,'2MASX J16022497+3331358',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.604083,33.52661,0.085,NULL,59765025787,933828527,14591070,18.1),(134545,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134545,36.14,0.05,169,63591,70,NULL,NULL,'2MASX J16022500+1556449',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00006,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.604125,15.94589,0.049,NULL,56572579963,883946561,13811665,17.3),(134546,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134546,36.14,0.05,169,63592,70,NULL,NULL,'SDSS J160225.69+162113.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.6070417,16.35383,0.029,NULL,56572455578,883944618,13811634,17.5),(134547,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134547,38.58,0.46,521,63593,70,NULL,NULL,'SDSS J160225.88+360317.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,240.607833,36.05497,0.041,NULL,59776659345,934010302,14593910,18.7),(134548,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134548,37.36,0.46,296,63594,70,NULL,NULL,'2MASX J16022885+3002178',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000179,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.6202917,30.03828,0.093,NULL,59868735487,935448991,14616390,17),(134549,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134549,37.84,0.46,369,63595,70,NULL,NULL,'2MASX J16022908+4835481',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.621125,48.59686,0.037,NULL,59711892046,932998313,14578098,18.1),(134550,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134550,38.37,0.46,473,63596,70,NULL,NULL,'2MASX J16022955+1043228',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.623041667,10.72306,0.145,NULL,56580715291,884073676,13813651,18.4),(134551,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134551,37.11,0.66,264,63597,70,NULL,NULL,'2MASX J16022986-0413353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,240.624375,-4.22656,0.549,NULL,45524659109,711322798,11114418,15.8),(134552,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134552,37.46,0.42,310,63598,70,NULL,NULL,'GIN 482',NULL,'2001MNRAS.321..277C',2001,1,0.29,NULL,'G',0.000091,NULL,'16.9g',0.23,'S',NULL,NULL,NULL,NULL,1,240.626166667,25.60161,0.137,NULL,59863883947,935373186,14615206,16.9),(134553,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134553,34.09,0.46,65.7,63599,70,NULL,NULL,'CGCG 137-019',NULL,'2015arXiv151105856S',2015,1,0.96,NULL,'G',0.00008,NULL,'14.2g',0.83,'E','Supercluster foreground object',NULL,NULL,NULL,1,240.627,21.12072,0.129,NULL,59400841985,928138156,14502158,14.2),(134554,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134554,38.13,0.46,423,63600,70,NULL,NULL,'2MASX J16023047+2010355',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000147,NULL,'16.6g',0.32,'S',NULL,NULL,NULL,NULL,1,240.627041667,20.17647,0.085,NULL,56512994276,883015535,13797117,16.6),(134555,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134555,36.74,0.46,222,63601,70,NULL,NULL,'2MASX J16023169+3534168',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.6320417,35.57122,0.045,NULL,59776447609,934006993,14593859,16.6),(134556,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134556,36.14,0.05,169,63602,70,NULL,NULL,'CGCG 108-077',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000093,NULL,'15.7',0.4,'S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.636375,14.55494,0.077,NULL,56559331728,883739558,13808430,15.7),(134557,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134557,34.45,0.59,77.6,63603,NULL,NULL,'Malmquist cor.','ESO 516- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00002,NULL,'16',0.7,'Sb',NULL,NULL,NULL,NULL,1,240.643041667,-25.80669,0.477,NULL,47113717533,736151836,11502372,16),(134558,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134558,34.58,0.56,82.5,63603,NULL,NULL,NULL,'ESO 516- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134559,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134559,34.62,0.2,84,63603,74.4,NULL,NULL,'ESO 516- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134560,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134560,33.76,0.8,56.5,63604,75,NULL,'HMCL, I','ESO 136- G 012',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'16.1',1,'SB(s)c:;tidal feat.',NULL,NULL,NULL,NULL,1,240.647875,-61.77453,NULL,NULL,44379364979,693427577,10834805,16.1),(134561,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134561,32.29,0.4,28.7,63604,75,NULL,'HMCL, I, raw','ESO 136- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134562,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134562,32.39,0.4,30,63604,75,NULL,'HMCL, I, inv','ESO 136- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134563,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134563,32.63,0.4,33.6,63604,75,NULL,'HMCL, I, cor','ESO 136- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134564,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134564,36.14,0.05,169,63605,70,NULL,NULL,'2MASX J16023573+1420079',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.649,14.33558,0.105,NULL,56559731721,883745808,13808528,16.6),(134565,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134565,36.14,0.05,169,63606,70,NULL,NULL,'2MASX J16023619+1628509',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000157,NULL,'16.1g',0.42,'E',NULL,NULL,NULL,NULL,1,240.651,16.48078,0.029,NULL,56572502472,883945351,13811646,16.1),(134566,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134566,37.26,0.33,283,63607,70,NULL,NULL,'SDSS J160236.88-000906.9',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000118,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.653667,-0.15192,0.397,NULL,45525298383,711332787,11114574,16.8),(134567,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134567,36.85,0.46,234,63608,70,NULL,NULL,'2MASX J16023811+0830138',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.658833,8.50381,0.157,NULL,56584239726,884128745,13814511,17.7),(134568,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134568,37.26,0.33,283,63609,70,NULL,NULL,'2MASX J16023973-0005113',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.6654583,-0.08653,0.397,NULL,45525292317,711332692,11114573,17.5),(134569,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134569,35.75,0.25,141,63610,74.4,NULL,NULL,'GIN 464',NULL,'2013AJ....146...86T',2013,1,0.14,NULL,'G',0.000073,NULL,'16.8g',0.12,'S0',NULL,NULL,NULL,NULL,1,240.668167,15.756,0.053,NULL,56571924647,883936322,13811505,16.8),(134570,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134570,35.95,0.18,155,63610,70,NULL,NULL,'GIN 464',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134571,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134571,33.11,0.2,40.5,63611,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6038',0.03133,'2011A&A...526A..81B',2011,1,1.16,NULL,'G',0.000077,NULL,'13.9g',0.99,'Sc',NULL,NULL,NULL,NULL,1,240.6689583,37.3595,0.017,NULL,59774464592,933976009,14593375,13.9),(134572,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134572,34.99,0.22,96.5,63611,74.2,NULL,'SALT 2','NGC 6038',0.03133,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134573,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134573,35.58,0.2,127,63611,72,NULL,NULL,'NGC 6038',0.03133,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134574,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134574,35.55,0.08,129,63611,74.4,NULL,NULL,'NGC 6038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134575,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc','R',134575,35.56,0.12,129,63611,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 6038',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134576,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134576,35.64,0.16,130,63611,70,NULL,'SALT 2','NGC 6038',0.03133,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134577,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc','R',134577,35.58,0.12,131,63611,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 6038',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134578,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134578,35.68,0.07,132,63611,65,NULL,'SALT2','NGC 6038',0.03133,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134579,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134579,35.69,0.16,133,63611,73.8,NULL,'SALT 2 (SNANA)','NGC 6038',0.0318,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134580,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134580,35.72,0.04,135,63611,72,NULL,NULL,'NGC 6038',0.03133,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134581,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134581,35.65,0.17,135,63611,72,NULL,NULL,'NGC 6038',NULL,'2006AJ....131.1639K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134582,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134582,35.66,0.17,136,63611,70.8,NULL,NULL,'NGC 6038',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134583,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134583,35.73,0.27,136,63611,70,NULL,'SALT','NGC 6038',0.03133,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134584,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134584,35.86,0.09,140,63611,65,NULL,'MLCS2k2','NGC 6038',0.03133,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134585,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134585,35.79,0.07,140,63611,70,NULL,NULL,'NGC 6038',0.03133,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134586,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134586,35.81,0.15,141,63611,65,NULL,'MLCS31','NGC 6038',0.03133,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134587,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134587,35.82,0.09,142,63611,65,NULL,'MLCS2k2','NGC 6038',0.03133,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134588,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134588,35.83,0.15,142,63611,65,NULL,'MLCS17','NGC 6038',0.03133,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134589,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134589,35.85,0.19,143,63611,65,NULL,NULL,'NGC 6038',0.03133,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134590,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134590,35.86,0.19,144,63611,65,NULL,'SALT2','NGC 6038',0.03133,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134591,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134591,35.87,0.27,144,63611,65,NULL,'SALT','NGC 6038',0.03133,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134592,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134592,35.88,0.05,145,63611,65,NULL,'MLCS2k2','NGC 6038',0.03133,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134593,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134593,35.98,0.01,152,63611,65,NULL,'SALT','NGC 6038',0.03133,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134594,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134594,36.09,0.14,165,63611,60,NULL,NULL,'NGC 6038',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134595,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1999cc',NULL,134595,36.3,0.02,177,63611,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6038',0.03133,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134596,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134596,35.91,0.46,152,63612,70,NULL,NULL,'2MASX J16024099+2712269',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'17.06',0.39,NULL,NULL,NULL,NULL,NULL,1,240.67075,27.20742,0.101,NULL,59876402242,935568785,14618262,17.06),(134597,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134597,37.25,0.46,282,63613,70,NULL,NULL,'2MASX J16024116+3318033',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.671375,33.30094,0.097,NULL,59764983564,933827868,14591060,17.2),(134598,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134598,38.33,0.46,464,63614,70,NULL,NULL,'2MASX J16024111+3959179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.6715,39.98819,0.013,NULL,59795440105,934303751,14598496,17.3),(134599,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134599,37.94,0.46,388,63615,70,NULL,NULL,'SDSS J160241.74+382413.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.6739583,38.40378,0.017,NULL,59762696453,933792132,14590502,17.8),(134600,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134600,37.39,0.46,301,63616,70,NULL,NULL,'2MASX J16024268+3755089',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.678,37.91922,0.021,NULL,59775051746,933985183,14593518,16.9),(134601,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134601,36.14,0.05,169,63617,70,NULL,NULL,'2MASX J16024513+1614539',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000067,NULL,'15.7g',0.43,'E',NULL,NULL,NULL,NULL,1,240.6879583,16.24819,0.037,NULL,56572610085,883947032,13811672,15.7),(134602,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134602,37.84,0.33,370,63618,70,NULL,NULL,'SDSS J160246.38+395054.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000135,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.69325,39.84856,0.025,NULL,59795115205,934298675,14598416,17.9),(134603,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134603,35.95,0.46,155,63619,70,NULL,NULL,'CGCG 108-080',NULL,'2015arXiv151105856S',2015,1,0.7,'2011ApJ...735..125S gives z=0.0386968.','G',0.000627,NULL,'15.34',0.5,'E','Supercluster foreground object',NULL,NULL,NULL,1,240.69775,19.78725,0.073,NULL,56512661655,883010338,13797036,15.34),(134604,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134604,37.34,0.25,294,63620,74.4,NULL,NULL,'GIN 486',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000177,NULL,'17.4g',0.21,'E/S0',NULL,NULL,NULL,NULL,1,240.698917,25.50919,0.137,NULL,59864328035,935380125,14615314,17.4),(134605,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134605,37.46,0.42,310,63620,70,NULL,NULL,'GIN 486',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134606,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134606,37.91,0.12,382,63620,70,NULL,NULL,'GIN 486',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134607,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134607,36.14,0.05,169,63621,70,NULL,NULL,'2MASX J16024803+1643228',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000133,NULL,'16.0g',0.36,'E',NULL,NULL,NULL,NULL,1,240.700167,16.723,0.029,NULL,56568942047,883889719,13810776,16),(134608,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134608,36.14,0.05,169,63622,70,NULL,NULL,'CGCG 108-078',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000073,NULL,'15.2g',0.45,'(R)SAB0+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.702625,16.11936,0.041,NULL,56572619159,883947174,13811674,15.2),(134609,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134609,36.14,0.05,169,63623,70,NULL,NULL,'2MASX J16024920+1710028',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.5g',0.38,'S0','Group member',NULL,NULL,NULL,1,240.705083,17.16742,0.049,NULL,56568999116,883890611,13810790,15.5),(134610,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134610,35.91,0.49,152,63624,75,NULL,'IR','2MFGC 12872',NULL,'2011yCatp016004901K',2011,1,0.69,NULL,'G',0.000027,NULL,'16.6g',0.18,'S/I','Group member',NULL,NULL,NULL,1,240.706917,18.44561,0.077,NULL,56511797946,882996842,13796825,16.6),(134611,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134611,37.02,0.46,253,63625,70,NULL,NULL,'2MASX J16025188+3350405',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,240.716125,33.84467,0.061,NULL,59768503204,933882862,14591919,16.2),(134612,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134612,35.79,0.46,144,63626,70,NULL,NULL,'2MASX J16025193+1531485',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000093,NULL,'15.8g',0.34,'E',NULL,NULL,NULL,NULL,1,240.7164583,15.53008,0.057,NULL,56571747650,883933557,13811461,15.8),(134613,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134613,36.34,0.46,185,63627,70,NULL,NULL,'2MASX J16025250+3418275',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000177,NULL,'16.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.7187083,34.30753,0.037,NULL,59768679723,933885620,14591962,16.2),(134614,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134614,36.69,0.27,218,63628,70,NULL,NULL,'2MASX J16025271+1856315',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.719625,18.94214,0.057,NULL,56511240557,882988133,13796689,16.9),(134615,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134615,37.56,0.46,325,63629,70,NULL,NULL,'2MASX J16025270+3728109',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00012,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,240.719708333,37.46961,0.013,NULL,59774430648,933975478,14593366,16.2),(134616,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134616,36.13,0.46,169,63630,70,NULL,NULL,'2MASX J16025280+2356079',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000161,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.7199583,23.93558,0.197,NULL,59393078728,928016855,14500263,16.5),(134617,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134617,36.48,0.33,197,63631,70,NULL,NULL,'ARK 496',NULL,'2015arXiv151105856S',2015,1,0.75,'1992ApJS...79..157F has V = 8586 +- 100 km/s.','G',0.00022,NULL,'15.3g',0.53,'S0',NULL,NULL,NULL,NULL,1,240.725083333,33.13464,0.085,NULL,59765078547,933829352,14591083,15.3),(134618,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134618,35.29,0.49,114,63632,70,NULL,NULL,'2MASX J16025491-3328177',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.000103,NULL,'15.05',0.56,'E',NULL,NULL,NULL,NULL,1,240.728833333,-33.47164,0.901,NULL,46263880906,722873139,11294892,15.05),(134619,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134619,37.76,0.46,357,63633,70,NULL,NULL,'2MASX J16025756+1835344',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.739833333,18.59281,0.065,NULL,56511923507,882998804,13796856,17.6),(134620,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134620,36.74,0.46,223,63634,70,NULL,NULL,'SDSS J160257.84+400416.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.7410417,40.07111,0.013,NULL,59809283147,934520049,14601875,17.9),(134621,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134621,37.46,0.33,310,63635,70,NULL,NULL,'2MASX J16025842+2220034',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.7435,22.33425,0.161,NULL,59394459161,928038424,14500600,17.3),(134622,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134622,36.48,0.33,197,63636,70,NULL,NULL,'2MASX J16025866+3309185',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000183,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,240.744417,33.15519,0.085,NULL,59765077283,933829332,14591083,15.7),(134623,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134623,36.14,0.05,169,63637,70,NULL,NULL,'CGCG 108-081',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.00006,NULL,'14.9g',0.5,'(R\')SB(s)0/a','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.744917,15.84283,0.049,NULL,56571921491,883936273,13811504,14.9),(134624,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134624,38.3,0.33,457,63638,70,NULL,NULL,'2MASX J16025884+3330245',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.745041667,33.50678,0.085,NULL,59765015634,933828369,14591068,18.5),(134625,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134625,33.95,0.49,61.5,63639,75,NULL,'IR','UGC 10212',NULL,'2011yCatp016004901K',2011,1,1.66,NULL,'G',0.000053,NULL,'16.0',0.19,'Sbc',NULL,NULL,NULL,NULL,1,240.752625,77.60639,0.189,NULL,57168574337,893258974,13957171,16),(134626,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134626,34.1,0.2,66.1,63639,74.4,NULL,NULL,'UGC 10212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134627,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134627,34.11,NULL,66.5,63639,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134628,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134628,34.13,NULL,66.9,63639,NULL,NULL,'Dipole + Quadrupole','UGC 10212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134629,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134629,34.13,NULL,66.9,63639,NULL,NULL,'Dipole','UGC 10212',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134630,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134630,34.17,0.53,68.2,63639,NULL,NULL,NULL,'UGC 10212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134631,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134631,34.24,0.51,70.4,63639,NULL,NULL,'Malmquist cor.','UGC 10212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134632,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134632,34.7,NULL,87.2,63639,NULL,NULL,NULL,'UGC 10212',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134633,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134633,33.81,0.8,57.9,63640,75,NULL,'HMCL, I','NGC 6032',NULL,'1997ApJS..109..333W',1997,1,1.63,NULL,'G',0.000027,NULL,'14.3g',0.77,'SB(rs)b:','Supercluster foreground object',NULL,NULL,NULL,1,240.754667,20.95594,0.117,NULL,56512012744,883000199,13796878,14.3),(134634,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134634,32.73,0.4,35.2,63640,75,NULL,'HMCL, I, raw','NGC 6032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134635,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134635,32.83,0.4,36.8,63640,75,NULL,'HMCL, I, inv','NGC 6032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134636,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134636,33.09,0.4,41.5,63640,75,NULL,'HMCL, I, cor','NGC 6032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134637,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134637,33.25,0.49,44.7,63640,75,NULL,'IR','NGC 6032',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134638,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134638,33.97,0.4,62.3,63640,NULL,NULL,'mean','NGC 6032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134639,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134639,34.09,0.47,65.7,63640,NULL,NULL,'H','NGC 6032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134640,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134640,34.17,0.46,68.3,63640,NULL,NULL,'J','NGC 6032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134641,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134641,34.21,0.45,69.5,63640,NULL,NULL,'K','NGC 6032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134642,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134642,38.35,0.46,468,63641,70,NULL,NULL,'2MASX J16030161+5314232',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.756708333,53.23989,0.009,NULL,59700959532,932827492,14575429,17.2),(134643,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134643,38.65,0.46,537,63642,70,NULL,NULL,'2MASX J16030269+2703432',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.761167,27.062,0.121,NULL,59876441286,935569395,14618271,17.9),(134644,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134644,36.98,0.46,248,63643,70,NULL,NULL,'2MASX J16030310+0517322',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000192,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.7629583,5.29217,0.173,NULL,56480666113,882510408,13789225,17.1),(134645,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134645,37.32,0.25,291,63644,74.4,NULL,NULL,'GIN 479',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000097,NULL,'16.7g',0.31,'E/S0',NULL,NULL,NULL,NULL,1,240.764083333,25.45303,0.157,NULL,59864320549,935380008,14615312,16.7),(134646,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134646,37.46,0.42,310,63644,70,NULL,NULL,'GIN 479',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134647,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134647,37.91,0.12,382,63644,70,NULL,NULL,'GIN 479',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134648,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134648,37.46,0.46,311,63645,70,NULL,NULL,'2MASX J16030346+0301382',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000064,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.764333,3.02719,0.257,NULL,56482732133,882542689,13789729,18.1),(134649,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134649,37.77,0.46,358,63646,70,NULL,NULL,'2MASX J16030395+4039109',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.766375,40.65308,0,NULL,59809420749,934522199,14601909,17.8),(134650,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134650,36.69,0.27,218,63647,70,NULL,NULL,'2MASX J16030414+1910565',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000093,NULL,'17.11',0.35,'S',NULL,NULL,NULL,NULL,1,240.767208333,19.18239,0.057,NULL,56513162829,883018169,13797158,17.11),(134651,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134651,36.14,0.05,169,63648,70,NULL,NULL,'2MASX J16030532+1616015',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000097,NULL,'16.4g',0.23,'S',NULL,NULL,NULL,NULL,1,240.7722917,16.26694,0.041,NULL,56572742742,883949105,13811704,16.4),(134652,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1968K',NULL,134652,35.22,0.29,111,63649,NULL,NULL,'Avg. of 8 SN host galaxies','SDSS J160305.72+171020.3',NULL,'1985ApJ...297...23D',1985,1,0.49,NULL,'G',0.000013,NULL,'17.1g',0.16,'Sd/I','Group member',NULL,NULL,NULL,1,240.773875,17.17233,0.049,NULL,56569034331,883891161,13810799,17.1),(134653,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134653,38.3,0.33,457,63650,70,NULL,NULL,'2MASX J16030691+3337336',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,240.778625,33.62614,0.073,NULL,59765004783,933828199,14591065,17.1),(134654,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134654,38.24,0.33,445,63651,70,NULL,NULL,'2MASX J16030774+1251125',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.7822083,12.85358,0.093,NULL,56548452003,883569562,13805774,16.8),(134655,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134655,37.59,0.33,330,63652,70,NULL,NULL,'2MASX J16030833+0258252',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.7847917,2.97361,0.257,NULL,56484768106,882574501,13790226,17.3),(134656,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134656,38.24,0.33,445,63653,70,NULL,NULL,'2MASX J16030836+1247105',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.784833333,12.78628,0.093,NULL,56548458374,883569662,13805775,18.4),(134657,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134657,38.62,0.46,530,63654,70,NULL,NULL,'2MASX J16030916+3812119',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.788041667,38.20328,0.009,NULL,59774199240,933971863,14593310,17.5),(134658,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134658,37.91,0.12,382,63655,70,NULL,NULL,'2MASX J16030947+2519102',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,240.7895417,25.31969,0.157,NULL,59864646423,935385100,14615392,18.2),(134659,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134659,37.83,0.46,368,63656,70,NULL,NULL,'2MASX J16031058+3555508',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.794291667,35.93069,0.061,NULL,59776674133,934010533,14593914,17.4),(134660,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134660,36.14,0.05,169,63657,70,NULL,NULL,'2MASX J16031074+1548265',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00006,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.794708333,15.80739,0.049,NULL,56571934276,883936473,13811507,16.9),(134661,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134661,37.27,0.46,284,63658,70,NULL,NULL,'2MASX J16031112+2804292',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.796375,28.07472,0.085,NULL,59875867264,935560426,14618131,17.2),(134662,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134662,37.08,0.46,261,63659,70,NULL,NULL,'SDSS J160311.43+201329.3',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.0g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.797667,20.22481,0.085,NULL,56512844898,883013201,13797081,17),(134663,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134663,37.46,0.33,310,63660,70,NULL,NULL,'2MASX J16031276+2217115',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.80325,22.28664,0.161,NULL,59394472003,928038625,14500603,17.4),(134664,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134664,37.46,0.46,311,63661,70,NULL,NULL,'2MASX J16031281+4712587',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,240.803333,47.21628,0.029,NULL,59710955055,932983672,14577869,16.5),(134665,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134665,36.14,0.05,169,63662,70,NULL,NULL,'2MASX J16031352+1453395',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000103,NULL,'16.0g',0.31,'E',NULL,NULL,NULL,NULL,1,240.806333333,14.89436,0.109,NULL,56557545506,883711648,13807994,16),(134666,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134666,38.41,0.46,481,63663,70,NULL,NULL,'SDSS J160313.95+245248.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.808167,24.88003,0.185,NULL,59863577644,935368400,14615131,17.9),(134667,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134667,37.98,0.46,394,63664,70,NULL,NULL,'SDSS J160314.17+120954.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.809083,12.16525,0.113,NULL,56577507934,884023561,13812868,18.3),(134668,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134668,35.75,0.25,141,63665,74.4,NULL,NULL,'CGCG 108-082',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.00007,NULL,'14.9g',0.59,'E+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.811417,16.40283,0.029,NULL,56572535849,883945872,13811654,14.9),(134669,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134669,35.95,0.18,155,63665,70,NULL,NULL,'CGCG 108-082',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134670,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134670,36.14,0.05,169,63665,70,NULL,NULL,'CGCG 108-082',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134671,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134671,37.22,0.46,278,63666,70,NULL,NULL,'2MASX J16031483+0816375',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.811875,8.277,0.157,NULL,56583604147,884118814,13814356,17),(134672,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134672,34.29,0.8,72.1,63667,75,NULL,'MAT, I','ESO 584- G 004',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'15',1.2,'Sb             HII',NULL,NULL,NULL,NULL,1,240.812333,-22.32278,0.529,NULL,46575613214,727743956,11370999,15),(134673,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134673,34.05,0.32,64.6,63667,85,NULL,'I, raw','ESO 584- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134674,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134674,34.06,0.43,64.9,63667,75,NULL,'MAT, I, raw','ESO 584- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134675,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134675,34.1,0.32,66.2,63667,85,NULL,'I, inv','ESO 584- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134676,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134676,34.29,0.43,72.2,63667,75,NULL,'MAT, I, inv','ESO 584- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134677,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134677,34.32,0.43,73.2,63667,75,NULL,'MAT, I, cor','ESO 584- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134678,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134678,34.46,0.2,78,63667,74.4,NULL,NULL,'ESO 584- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134679,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134679,34.47,0.48,78.4,63667,NULL,NULL,NULL,'ESO 584- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134680,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134680,34.64,0.45,84.6,63667,NULL,NULL,'Malmquist cor.','ESO 584- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134681,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134681,36.98,0.46,249,63668,70,NULL,NULL,'2MASX J16031521+1844215',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.813333,18.73925,0.065,NULL,56511938571,882999040,13796860,16.9),(134682,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134682,37.91,0.12,382,63669,70,NULL,NULL,'2MASX J16031581+2520342',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,240.815833,25.34294,0.157,NULL,59865170239,935393284,14615520,18),(134683,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134683,36.69,0.27,218,63670,70,NULL,NULL,'2MASX J16031593+1905035',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000153,NULL,'15.4',0.31,'S',NULL,NULL,NULL,NULL,1,240.816417,19.08419,0.057,NULL,56511298452,882989038,13796703,15.4),(134684,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134684,39.01,0.33,633,63671,70,NULL,NULL,'SDSS J160316.07+335201.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,240.8169583,33.86717,0.061,NULL,59768480472,933882507,14591914,18.7),(134685,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134685,37.43,0.33,306,63672,70,NULL,NULL,'2MASX J16031669+2655562',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.819541667,26.93247,0.121,NULL,59876416603,935569009,14618265,18),(134686,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134686,35.89,0.46,151,63673,70,NULL,NULL,'2MASX J16031694+0300442',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'16.3g',0.31,'S0',NULL,NULL,NULL,NULL,1,240.8205,3.01219,0.257,NULL,56484765867,882574466,13790226,16.3),(134687,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134687,37.59,0.33,330,63674,70,NULL,NULL,'SDSS J160317.04+025156.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000072,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,240.8210417,2.86564,0.257,NULL,56484809847,882575153,13790236,18.3),(134688,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134688,36.69,0.46,218,63675,70,NULL,NULL,'2MASX J16031792+0731325',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000189,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,240.8247083,7.52575,0.153,NULL,56581733499,884089585,13813899,16),(134689,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134689,37.06,0.46,258,63676,70,NULL,NULL,'2MASXi J1603185+373511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.827208333,37.58664,0.013,NULL,59774910332,933982973,14593483,17.4),(134690,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134690,37.05,0.46,257,63677,70,NULL,NULL,'2MASX J16031890+2820052',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.8287083,28.33492,0.077,NULL,59867537664,935430276,14616098,17.6),(134691,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134691,37.34,0.25,294,63678,74.4,NULL,NULL,'GIN 478',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000113,NULL,'16.1g',0.37,'cD;BrClG',NULL,NULL,NULL,NULL,1,240.832667,25.45372,0.157,NULL,59864332326,935380192,14615315,16.1),(134692,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134692,37.46,0.42,310,63678,70,NULL,NULL,'GIN 478',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134693,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134693,37.91,0.12,382,63678,70,NULL,NULL,'GIN 478',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134694,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134694,37.33,0.25,292,63679,74.4,NULL,NULL,'GIN 485',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000159,NULL,'16.7g',0.32,'E/S0',NULL,NULL,NULL,NULL,1,240.836583333,25.30925,0.157,NULL,59864648003,935385125,14615392,16.7),(134695,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134695,37.46,0.42,310,63679,70,NULL,NULL,'GIN 485',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134696,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134696,37.91,0.12,382,63679,70,NULL,NULL,'GIN 485',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134697,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134697,35.61,0.2,132,63680,74.4,NULL,NULL,'SDSS J160321.00+174325.8',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000025,NULL,'18.1g',0.09,NULL,NULL,NULL,NULL,NULL,1,240.837541667,17.72386,0.041,NULL,56566659229,883854050,13810219,18.1),(134698,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134698,37.65,0.46,339,63681,70,NULL,NULL,'2MASX J16032208+4114029',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000184,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.842083,41.23406,0.005,NULL,59809949991,934530468,14602038,17.2),(134699,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134699,37.33,0.25,292,63682,74.4,NULL,NULL,'GIN 484',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000186,NULL,'17.0g',0.27,'S',NULL,NULL,NULL,NULL,1,240.842375,25.37267,0.157,NULL,59865173848,935393341,14615520,17),(134700,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134700,37.46,0.42,310,63682,70,NULL,NULL,'GIN 484',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134701,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134701,36.14,0.05,169,63683,70,NULL,NULL,'2MASX J16032323+1431286',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000407,NULL,'15.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.846875,14.52456,0.093,NULL,56557841465,883716272,13808066,15.9),(134702,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134702,38.07,0.46,411,63684,70,NULL,NULL,'2MASX J16032325+2438222',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.847,24.63947,0.185,NULL,59863490073,935367032,14615109,18.2),(134703,'Tully est','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134703,32.73,0.8,35.1,63685,75,NULL,'B','NGC 6035',NULL,'1988NBGC.C....0000T',1988,1,1.02,'Freudling, et al. (1992, ApJS, 79, 157) give v=4757 km/sec.','G',0.000097,NULL,'14.1g',0.97,'SAB(rs)c','Supercluster foreground object',NULL,NULL,NULL,1,240.85075,20.89125,0.117,NULL,56512018445,883000288,13796879,14.1),(134704,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134704,36.02,0.2,160,63686,74.4,NULL,NULL,'SDSS J160325.85+153848.2',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000013,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,240.85775,15.64675,0.053,NULL,56571831310,883934864,13811482,16.9),(134705,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134705,34.01,0.8,63.5,63687,75,NULL,'HMCL, I','MRK 0296',NULL,'1997ApJS..109..333W',1997,1,0.75,NULL,'G',0.000027,NULL,'16.0g',0.23,'Im pec?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.860625,19.16269,0.057,NULL,56511282732,882988792,13796699,16),(134706,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134706,33.1,0.4,41.8,63687,75,NULL,'HMCL, I, inv','MRK 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134707,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134707,33.15,0.4,42.6,63687,75,NULL,'HMCL, I, raw','MRK 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134708,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134708,33.57,0.4,51.9,63687,75,NULL,'HMCL, I, cor','MRK 0296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134709,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134709,33.92,0.49,60.7,63687,75,NULL,'IR','MRK 0296',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134710,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134710,36.14,0.05,169,63688,70,NULL,NULL,'2MASX J16032752+1531066',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.86475,15.51861,0.057,NULL,56571233274,883925519,13811336,17.4),(134711,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134711,35.77,0.33,142,63689,70,NULL,NULL,'CGCG 108-086',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',NULL,NULL,'15.24',0.38,'S0/a:','Supercluster apparent member',NULL,NULL,NULL,1,240.866708333,20.29219,0.085,NULL,56512861889,883013467,13797085,15.24),(134712,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134712,35.78,NULL,143,63690,NULL,NULL,NULL,'FGC 1988',NULL,'2000BSAO...50....5K',2000,1,0.77,NULL,'G',NULL,NULL,'17.3',0.06,'Scd',NULL,NULL,NULL,NULL,1,240.873583,77.52603,0.189,NULL,57168565994,893258843,13957169,17.3),(134713,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134713,35.9,0.67,152,63691,70,NULL,NULL,'2MASX J16032995-0616155',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,240.874833333,-6.27092,0.537,NULL,45571174342,712049599,11125774,14.3),(134714,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134714,36.7,0.46,219,63692,70,NULL,NULL,'2MASX J16033015+0537015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000173,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.8755417,5.61697,0.177,NULL,56480713015,882511140,13789236,17),(134715,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134715,36.63,0.78,212,63693,70,NULL,NULL,'2MASX J16033138-3016561',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.48',0.42,'Sa',NULL,NULL,NULL,NULL,1,240.8807917,-30.28222,0.681,NULL,47119110512,736236101,11503689,15.48),(134716,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134716,36.15,0.2,170,63694,74.4,NULL,NULL,'KUG 1601+140',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000052,NULL,'15.3',0.2,'Spiral',NULL,NULL,NULL,NULL,1,240.882,13.94411,0.101,NULL,56557606838,883712606,13808009,15.3),(134717,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134717,36.14,0.05,169,63695,70,NULL,NULL,'NGC 6034',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000097,NULL,'14.5g',0.73,'E+','Supercluster (RV-confirmed) member',NULL,'head-tail','Flat-Spectrum Radio Source',1,240.883667,17.19869,0.049,NULL,56569025080,883891016,13810797,14.5),(134718,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134718,36.31,0.46,183,63696,70,NULL,NULL,'2MASX J16033238+5025089',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000088,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,240.88475,50.41903,0.061,NULL,59706144071,932908501,14576695,16.7),(134719,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134719,37.68,0.46,343,63697,70,NULL,NULL,'2MASX J16033244+1729386',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000113,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.885291667,17.49406,0.045,NULL,56566614389,883853349,13810208,17.8),(134720,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134720,36.14,0.05,169,63698,70,NULL,NULL,'2MASX J16033287+1512556',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.886875,15.2155,0.061,NULL,56571229450,883925460,13811335,17.3),(134721,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134721,37.4,0.46,302,63699,70,NULL,NULL,'2MASX J16033489+2428175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.8952917,24.47164,0.189,NULL,59863523146,935367549,14615117,17.4),(134722,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134722,37.97,0.46,394,63700,70,NULL,NULL,'2MASX J16033482+5506014',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00008,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.895375,55.10044,0,NULL,57607186809,900112293,14064254,16.8),(134723,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134723,38.25,0.46,447,63701,70,NULL,NULL,'2MASX J16033665+1945044',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,240.9027083,19.75119,0.097,NULL,56512526251,883008222,13797003,NULL),(134724,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134724,38.1,0.33,417,63702,70,NULL,NULL,'SDSS J160337.68+292222.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,240.907041667,29.37303,0.081,NULL,59867919014,935436234,14616191,18.8),(134725,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134725,35.95,0.18,155,63703,70,NULL,NULL,'GIN 463',NULL,'2001MNRAS.321..277C',2001,1,0.48,NULL,'G',0.00013,NULL,'16.6g',0.34,'E/S0;FSRQ      Sy',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,240.908583333,15.90067,0.049,NULL,56571815826,883934622,13811478,16.6),(134726,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134726,38.14,0.46,425,63704,70,NULL,NULL,'2MASX J16033889+1854054',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.912166667,18.90167,0.057,NULL,56511729435,882995772,13796808,17.6),(134727,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134727,36.14,0.05,169,63705,70,NULL,NULL,'2MASX J16033924+1711057',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.0g',0.21,'E','Group member',NULL,NULL,NULL,1,240.913625,17.18486,0.049,NULL,56569011710,883890807,13810793,17),(134728,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134728,37.44,0.46,308,63706,70,NULL,NULL,'2MASX J16034119+0425575',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.92175,4.43269,0.225,NULL,56483967899,882561998,13790031,17.8),(134729,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134729,37.43,0.33,306,63707,70,NULL,NULL,'2MASX J16034162+2652405',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'16.9g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,240.92325,26.87797,0.125,NULL,59862575912,935352748,14614886,16.9),(134730,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134730,37.98,0.46,395,63708,70,NULL,NULL,'SDSS J160341.63+292449.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.9235,29.41389,0.081,NULL,59867921601,935436275,14616191,18.1),(134731,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134731,35.12,0.25,106,63709,74.4,NULL,NULL,'GIN 490',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000053,NULL,'15.7g',0.52,'S',NULL,NULL,NULL,NULL,1,240.924417,24.09511,0.165,NULL,59395040288,928047504,14500742,15.7),(134732,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134732,35.31,0.29,115,63709,70,NULL,NULL,'GIN 490',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134733,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134733,38.3,0.46,456,63710,70,NULL,NULL,'2MASX J16034238+5318581',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.926667,53.31622,0.009,NULL,59700987794,932827934,14575436,17.6),(134734,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134734,44.6,0.75,3310,63711,NULL,NULL,NULL,'GRB 060502A',1.51,'2008AIPC.1065..367L',2008,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,240.9269583,66.60072,0.069,NULL,57824069479,903501085,14117204,NULL),(134735,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134735,44.65,0.67,3390,63711,72,NULL,NULL,'GRB 060502A',1.51,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134736,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134736,44.71,0.66,3490,63711,70,NULL,NULL,'GRB 060502A',1.51,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134737,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134737,44.9,0.62,3800,63711,69.7,NULL,'Calibrated','GRB 060502A',1.51,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134738,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134738,45.37,0.65,4720,63711,69.7,NULL,'Fiducial','GRB 060502A',1.51,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134739,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134739,46.06,1.36,6490,63711,69.7,NULL,'Fiducial','GRB 060502A',1.51,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134740,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134740,38.43,0.33,486,63712,70,NULL,NULL,'2MASX J16034279+1557167',NULL,'2015arXiv151105856S',2015,1,0.27,'1998AJ....115....6B: z = 0.039811 +- 0.000083; 2004AJ....128.1558S, 0.10759.','G',0.000183,NULL,'17.1g',0.27,'BrClG;E',NULL,NULL,NULL,NULL,1,240.928375,15.95461,0.049,NULL,56572680957,883948139,13811689,17.1),(134741,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134741,38.1,0.33,417,63713,70,NULL,NULL,'2MASX J16034289+2922545',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.6g',0.34,'BrClG;E',NULL,NULL,NULL,NULL,1,240.928916667,29.38197,0.081,NULL,59867922073,935436282,14616191,16.6),(134742,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134742,37.66,0.46,340,63714,70,NULL,NULL,'2MASX J16034312+1448317',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.9297917,14.80886,0.109,NULL,56557515991,883711187,13807987,17.7),(134743,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134743,38.51,0.46,503,63715,70,NULL,NULL,'SDSS J160343.75+113455.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.932333,11.58214,0.145,NULL,56580582897,884071607,13813618,18.4),(134744,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134744,35.74,0.25,141,63716,74.4,NULL,NULL,'CGCG 108-087',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000083,NULL,'14.26',0.4,'S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.932417,16.32728,0.029,NULL,56572560260,883946254,13811660,14.26),(134745,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134745,35.95,0.18,155,63716,70,NULL,NULL,'CGCG 108-087',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134746,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134746,35.95,0.18,155,63717,70,NULL,NULL,'CGCG 108-087 NED02',NULL,'2001MNRAS.321..277C',2001,1,0.38,NULL,'G',0.00007,NULL,'16.1g',0.37,'S','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,240.9410417,16.33833,0.029,NULL,56572559831,883946247,13811660,16.1),(134747,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134747,36.14,0.05,169,63717,70,NULL,NULL,'CGCG 108-087 NED02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134748,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134748,35.89,0.46,151,63718,70,NULL,NULL,'2MASX J16034618+1357047',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,240.942583,13.95136,0.101,NULL,56557618464,883712788,13808012,15.7),(134749,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134749,37.5,0.46,316,63719,70,NULL,NULL,'2MASX J16034641+3312352',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.9434583,33.20986,0.097,NULL,59765154281,933830535,14591102,17.2),(134750,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134750,36.14,0.05,169,63720,70,NULL,NULL,'2MASX J16034754+1745047',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000053,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,240.948125,17.75142,0.041,NULL,56566655255,883853988,13810218,16.8),(134751,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134751,36.95,0.46,246,63721,70,NULL,NULL,'2MASX J16034771+2629106',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,240.948583,26.48639,0.129,NULL,59862657242,935354019,14614906,17),(134752,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134752,35.96,0.53,156,63722,70,NULL,NULL,'2MASX J16034839-0149487',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,240.951583,-1.83014,0.569,NULL,45527881107,711373142,11115205,14.9),(134753,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134753,36.56,0.33,205,63723,70,NULL,NULL,'2MASX J16034875+2628166',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000185,NULL,'16.2g',0.34,'E0',NULL,NULL,NULL,NULL,1,240.9532917,26.47117,0.133,NULL,59862659192,935354049,14614907,16.2),(134754,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134754,38.13,0.46,423,63724,70,NULL,NULL,'2MASX J16034884+2106064',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.953458333,21.10192,0.129,NULL,56520358535,883130602,13798915,17.6),(134755,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134755,37.92,0.13,384,63725,70,NULL,NULL,'SDSS J160348.94+244222.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.953916667,24.70631,0.185,NULL,59863496472,935367132,14615111,18),(134756,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134756,34.32,0.8,73.1,63726,75,NULL,'HMCL, I','ESO 136- G 016',NULL,'1997ApJS..109..333W',1997,1,3.47,'Star superposed.','G',0.00002,NULL,'15.2',0.26,'SB(s)c:sp;flar.disk?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,240.955583,-60.97781,NULL,NULL,44378405709,693412589,10834571,15.2),(134757,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134757,33.19,0.49,43.5,63726,75,NULL,'IR','ESO 136- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134758,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134758,33.51,0.4,50.2,63726,75,NULL,'HMCL, I, raw','ESO 136- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134759,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134759,33.74,0.4,55.9,63726,75,NULL,'HMCL, I, cor','ESO 136- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134760,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134760,33.75,0.4,56.1,63726,75,NULL,'HMCL, I, inv','ESO 136- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134761,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134761,34.11,NULL,66.3,63726,NULL,NULL,'Dipole','ESO 136- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134762,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134762,34.12,NULL,66.8,63726,NULL,NULL,'Dipole + Quadrupole','ESO 136- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134763,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134763,34.13,NULL,67,63726,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 136- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134764,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134764,34.2,NULL,69.3,63726,NULL,NULL,NULL,'ESO 136- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134765,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134765,37.89,0.46,379,63727,70,NULL,NULL,'2MASX J16034953+2947526',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.956333333,29.79817,0.073,NULL,59867666294,935432285,14616129,17.9),(134766,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134766,36.56,0.33,205,63728,70,NULL,NULL,'CGCG 167-019',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00011,NULL,'15.3g',0.59,'E0',NULL,NULL,NULL,NULL,1,240.95725,26.54208,0.129,NULL,59862678100,935354345,14614911,15.3),(134767,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134767,36.14,0.05,169,63729,70,NULL,NULL,'2MASX J16035014+1556447',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000157,NULL,'15.5g',0.39,'E',NULL,NULL,NULL,NULL,1,240.95875,15.94569,0.049,NULL,56572681539,883948149,13811689,15.5),(134768,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134768,37.59,0.46,329,63730,70,NULL,NULL,'2MASX J16035148+1643521',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.964417,16.73117,0.033,NULL,56568921335,883889395,13810771,17.7),(134769,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134769,35.4,0.54,120,63731,NULL,NULL,'Malmquist cor.','UGC 10166',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000417,NULL,'12.51',0.6,'SBb','Group member, peripheral',NULL,NULL,NULL,1,240.967333,39.98444,0.013,NULL,59809589367,934524833,14601950,12.51),(134770,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134770,35.53,0.51,127,63731,NULL,NULL,NULL,'UGC 10166',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134771,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134771,35.57,0.2,130,63731,74.4,NULL,NULL,'UGC 10166',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134772,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134772,37.25,0.46,282,63732,70,NULL,NULL,'2MASX J16035219+2817416',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000183,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.9675417,28.29497,0.077,NULL,59867591254,935431113,14616111,16.5),(134773,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134773,37.46,0.42,310,63733,70,NULL,NULL,'GIN 480',NULL,'2001MNRAS.321..277C',2001,1,0.53,NULL,'G',0.000077,NULL,'16.3g',0.42,'S',NULL,NULL,NULL,NULL,1,240.9682917,25.44694,0.137,NULL,59865180356,935393443,14615522,16.3),(134774,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134774,36.14,0.05,169,63734,70,NULL,NULL,'IC 1167',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'14.7',0.5,'E',NULL,NULL,NULL,NULL,1,240.97025,14.94644,0.109,NULL,56557507373,883711052,13807985,14.7),(134775,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134775,37.64,0.46,337,63735,70,NULL,NULL,'PKS 1601-00',NULL,'2015arXiv151105856S',2015,1,0.3,'Identified as 4C -00.63 in PKSCAT90 (version 1.01).','G',0.000094,NULL,'17.1g',0.23,'N galaxy',NULL,NULL,NULL,NULL,1,240.970916667,-0.497,0.453,NULL,45525368665,711333885,11114591,17.1),(134776,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134776,38.43,0.33,486,63736,70,NULL,NULL,'SDSS J160354.71+155029.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,240.978,15.84158,0.049,NULL,56571849391,883935146,13811486,18.1),(134777,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134777,37.54,0.46,323,63737,70,NULL,NULL,'2MASX J16035515+3051413',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,240.9797917,30.86136,0.045,NULL,59735708929,933370452,14583913,17.6),(134778,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134778,35.98,0.46,157,63738,70,NULL,NULL,'UGC 10158',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000163,NULL,'14.61',0.7,'S0',NULL,NULL,NULL,NULL,1,240.980667,11.72867,0.141,NULL,56580614944,884072108,13813626,14.61),(134779,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134779,37.55,0.27,323,63739,70,NULL,NULL,'2MASX J16035560+2757226',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,240.981583333,27.95628,0.085,NULL,59875904063,935561000,14618140,17.6),(134780,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134780,37.4,0.46,302,63740,70,NULL,NULL,'2MASX J16035635+2835246',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,240.98475,28.59033,0.077,NULL,59868270184,935441721,14616276,18),(134781,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134781,36.14,0.05,169,63741,70,NULL,NULL,'2MASX J16035650+1620511',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000067,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.9854583,16.34753,0.029,NULL,56572553884,883946154,13811658,16.9),(134782,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134782,36.14,0.05,169,63742,70,NULL,NULL,'2MASX J16035656+1625251',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.9855,16.42367,0.029,NULL,56572566119,883946345,13811661,17),(134783,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134783,36.14,0.05,169,63743,70,NULL,NULL,'2MASX J16035667+1718182',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000057,NULL,'16.1g',0.35,'Ep','Group member',NULL,NULL,NULL,1,240.986083,17.30511,0.049,NULL,56569555907,883899311,13810926,16.1),(134784,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134784,38.02,0.33,401,63744,70,NULL,NULL,'2MASX J16035758+1608522',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000123,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,240.9900417,16.14781,0.041,NULL,56572662318,883947848,13811685,17.4),(134785,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134785,36.99,0.46,250,63745,70,NULL,NULL,'2MASX J16035765+4557543',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000176,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,240.990125,45.96511,0.029,NULL,59681720086,932526876,14570732,16.8),(134786,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134786,38.01,0.27,401,63746,70,NULL,NULL,'SDSS J160357.65-003717.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,240.9902083,-0.62167,0.465,NULL,45525319401,711333115,11114579,18.1),(134787,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134787,37.08,0.46,260,63747,70,NULL,NULL,'2MASX J16035823+3125423',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,240.99275,31.42836,0.045,NULL,59735442984,933366296,14583848,17.3),(134788,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134788,39.01,0.33,633,63748,70,NULL,NULL,'2MASX J16035919+3400523',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,240.9967083,34.01444,0.065,NULL,59768513306,933883020,14591922,17.7),(134789,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134789,37.86,0.46,374,63749,70,NULL,NULL,'2MASX J16035943+3814082',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,240.99775,38.23583,0.009,NULL,59774283333,933973177,14593330,17),(134790,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134790,37.69,0.33,345,63750,70,NULL,NULL,'2MASX J16040027+2119465',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.001083333,21.3295,0.141,NULL,59393446588,928022602,14500353,17.6),(134791,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134791,36.14,0.05,169,63751,70,NULL,NULL,'CGCG 108-093',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000093,NULL,'15.3g',0.46,'E/S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.0115,17.28239,0.049,NULL,56569558575,883899352,13810927,15.3),(134792,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134792,37.27,0.25,284,63752,74.4,NULL,NULL,'GIN 483',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',0.000135,NULL,'16.7g',0.4,'S',NULL,NULL,NULL,NULL,1,241.0125,25.49706,0.137,NULL,59865226389,935394162,14615533,16.7),(134793,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134793,37.46,0.42,310,63752,70,NULL,NULL,'GIN 483',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134794,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134794,38.01,0.27,401,63753,70,NULL,NULL,'2MASX J16040354-0040454',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000099,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.014833,-0.67922,0.465,NULL,45525306484,711332913,11114576,18.5),(134795,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134795,38.27,0.46,450,63754,70,NULL,NULL,'2MASX J16040421+2705496',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.017583,27.09706,0.101,NULL,59862549650,935352338,14614880,17.6),(134796,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134796,32.06,NULL,25.8,63755,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10194',NULL,'2010Ap&SS.325..163P',2010,1,1.9,NULL,'G',0.000017,NULL,'16.0',0.17,'Sd',NULL,NULL,NULL,NULL,1,241.018333,63.71306,0,NULL,57949441617,905460025,14147812,16),(134797,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134797,32.07,NULL,25.9,63755,NULL,NULL,'Dipole + Quadrupole','UGC 10194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134798,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134798,32.08,NULL,26,63755,NULL,NULL,'Dipole','UGC 10194',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134799,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134799,32.42,0.43,30.4,63755,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10194',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134800,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134800,37.46,0.42,310,63756,70,NULL,NULL,'KUG 1601+256',NULL,'2001MNRAS.321..277C',2001,1,0.44,NULL,'G',0.00007,NULL,'15.9g',0.32,'Compact',NULL,NULL,NULL,NULL,1,241.018917,25.56269,0.137,NULL,59865210397,935393912,14615529,15.9),(134801,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134801,38.01,0.27,401,63757,70,NULL,NULL,'2MASX J16040453-0039314',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00011,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.0189583,-0.65875,0.465,NULL,45525318156,711333096,11114579,17.6),(134802,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134802,36.01,0.16,159,63758,70,NULL,NULL,'2MASX J16040526+2411386',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000067,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.0220417,24.19414,0.173,NULL,59395019647,928047181,14500737,16.4),(134803,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134803,36.26,0.46,179,63759,70,NULL,NULL,'2MASX J16040737+4034162',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000097,NULL,'16.0g',0.36,'E0','Field galaxy',NULL,NULL,NULL,1,241.0307083,40.57111,0,NULL,59809382658,934521604,14601900,16),(134804,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134804,38.88,0.46,597,63760,70,NULL,NULL,'2MASX J16040763+5205112',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.031917,52.08639,NULL,NULL,59700851625,932825806,14575403,17.6),(134805,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134805,37.55,0.27,323,63761,70,NULL,NULL,'2MASX J16040788+2758593',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.03275,27.98306,0.085,NULL,59875903345,935560989,14618140,16.9),(134806,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134806,37.1,0.46,263,63762,70,NULL,NULL,'2MASX J16040835+5458125',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000099,NULL,'16.8g',0.25,'Sbrst',NULL,NULL,NULL,NULL,1,241.034583333,54.97033,0,NULL,57607046022,900110094,14064220,16.8),(134807,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134807,38.46,0.33,492,63763,70,NULL,NULL,'2MASX J16040833+1507162',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.034875,15.12122,0.097,NULL,56557469287,883710457,13807975,17.8),(134808,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134808,37.92,0.13,384,63764,70,NULL,NULL,'2MASX J16040887+2438463',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.036916667,24.64625,0.181,NULL,59863490968,935367046,14615110,17.2),(134809,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134809,35.89,NULL,151,63765,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10171',NULL,'2010Ap&SS.325..163P',2010,1,1.7,NULL,'G',0.000169,NULL,'15.8g',0.16,'Scd','Field galaxy',NULL,NULL,NULL,1,241.0382083,42.88925,0,NULL,59803951408,934436740,14600574,15.8),(134810,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134810,35.9,NULL,152,63765,NULL,NULL,'Dipole + Quadrupole','UGC 10171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134811,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134811,35.92,NULL,153,63765,NULL,NULL,NULL,'UGC 10171',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134812,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134812,35.93,NULL,153,63765,NULL,NULL,'Dipole','UGC 10171',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134813,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134813,36.31,0.46,183,63766,70,NULL,NULL,'2MASX J16040945+5353122',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00009,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.0394583,53.88669,0.005,NULL,57608291785,900129559,14064524,17.1),(134814,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134814,36.14,0.05,169,63767,70,NULL,NULL,'2MASX J16041022+1758505',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00006,NULL,'16.39',0.31,'SB0','Group member',NULL,NULL,NULL,1,241.04275,17.98075,0.061,NULL,56566733012,883855203,13810237,16.39),(134815,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134815,37.55,0.27,323,63768,70,NULL,NULL,'2MASX J16041029+2758564',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.0430417,27.98217,0.085,NULL,59875903052,935560985,14618140,17.1),(134816,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134816,35.74,0.25,141,63769,74.4,NULL,NULL,'GIN 527',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000057,NULL,'15.7g',0.5,'S',NULL,NULL,NULL,NULL,1,241.043583,16.08753,0.041,NULL,56572703909,883948498,13811695,15.7),(134817,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134817,35.79,0.18,144,63769,70,NULL,NULL,'GIN 527',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134818,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134818,38.07,0.46,411,63770,70,NULL,NULL,'2MASX J16041174+3749563',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.049125,37.83222,0,NULL,59775068234,933985441,14593522,16.9),(134819,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134819,36.96,0.33,247,63771,70,NULL,NULL,'2MASX J16041208+1109088',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.18',0.23,NULL,NULL,NULL,NULL,NULL,1,241.050417,11.15233,0.153,NULL,56581078468,884079351,13813739,17.18),(134820,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134820,36.66,0.46,215,63772,70,NULL,NULL,'2MASX J16041251+1210373',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.0520417,12.17697,0.137,NULL,56547878121,883560595,13805634,17),(134821,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134821,36.93,0.27,243,63773,70,NULL,NULL,'2MASX J16041371+0003131',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000122,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.057083,0.05353,0.377,NULL,56476904250,882451628,13788306,16.6),(134822,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134822,36.87,0.46,236,63774,70,NULL,NULL,'2MASX J16041519+3131523',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.063125,31.53122,0.041,NULL,59735448906,933366389,14583849,16.9),(134823,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134823,36.18,0.39,172,63775,NULL,NULL,'Malmquist cor.','2MASX J16041594+1627373',NULL,'2009ApJS..182..474S',2009,1,0.65,NULL,'G',0.000033,NULL,'16.2g',0.21,'Sc',NULL,NULL,NULL,NULL,1,241.0665,16.46019,0.029,NULL,56572547911,883946061,13811657,16.2),(134824,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134824,36.43,0.35,193,63775,NULL,NULL,NULL,'2MASX J16041594+1627373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134825,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134825,36.47,0.2,197,63775,74.4,NULL,NULL,'2MASX J16041594+1627373',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134826,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134826,37.67,0.33,342,63776,70,NULL,NULL,'2MASX J16041615+2849024',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.067458333,28.81725,0.073,NULL,59868359636,935443119,14616298,17.7),(134827,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134827,37.11,0.21,264,63777,70,NULL,NULL,'2MASX J16041649+0537271',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.06875,5.62411,0.177,NULL,56489001233,882640644,13791260,17.6),(134828,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134828,36.98,0.13,249,63778,70,NULL,NULL,'2MASX J16041653+3344023',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,241.068917,33.73408,0.073,NULL,59768527637,933883244,14591925,16.3),(134829,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134829,37.58,0.33,327,63779,70,NULL,NULL,'2MASX J16041688+2724364',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,241.070333,27.40997,0.105,NULL,59875929567,935561399,14618146,16.6),(134830,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134830,37.67,0.33,342,63780,70,NULL,NULL,'2MASX J16041752+2851094',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.0732083,28.85256,0.073,NULL,59868366817,935443231,14616300,17.5),(134831,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134831,37.44,0.33,308,63781,70,NULL,NULL,'2MASX J16041821+1806115',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.075916667,18.10306,0.057,NULL,56566712079,883854876,13810232,17.5),(134832,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134832,37.48,0.46,313,63782,70,NULL,NULL,'2MASX J16041884+2317365',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.0785417,23.29358,0.141,NULL,59395538084,928055282,14500863,17),(134833,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134833,36.14,0.05,169,63783,70,NULL,NULL,'2MASX J16041958+1710493',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'15.5g',0.46,'S0','Group member',NULL,NULL,NULL,1,241.0815,17.18039,0.049,NULL,56569589447,883899835,13810934,15.5),(134834,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134834,38.32,0.46,461,63784,70,NULL,NULL,'2MASX J16041980+2900584',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.082667,29.01622,0.069,NULL,59868343743,935442870,14616294,17.5),(134835,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134835,37.06,0.46,258,63785,70,NULL,NULL,'SDSS J160419.95+351124.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.083125,35.19025,0.029,NULL,59765989862,933843591,14591306,17.9),(134836,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134836,36.05,0.46,162,63786,70,NULL,NULL,'2MASX J16041996+1247433',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.10',0.34,NULL,NULL,NULL,NULL,NULL,1,241.08325,12.79533,0.093,NULL,56551413424,883615834,13806497,17.1),(134837,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134837,36.14,0.05,169,63787,70,NULL,NULL,'2MASX J16042031+1639483',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00014,NULL,'16.2g',0.3,'E',NULL,NULL,NULL,NULL,1,241.084541667,16.6635,0.033,NULL,56572054014,883938343,13811536,16.2),(134838,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134838,38.34,0.46,466,63788,70,NULL,NULL,'2MASX J16042178+0951428',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.090875,9.86203,0.141,NULL,56586246654,884160103,13815001,17.8),(134839,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134839,38.26,0.46,449,63789,70,NULL,NULL,'2MASX J16042180+2301315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.090875,23.02547,0.165,NULL,59395466649,928054166,14500846,17.6),(134840,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134840,36.9,0.46,240,63790,70,NULL,NULL,'2MASX J16042257+2647054',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.093875,26.78492,0.125,NULL,59862592266,935353004,14614890,16.9),(134841,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134841,37.22,0.46,278,63791,70,NULL,NULL,'2MASX J16042280+1927525',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.094916667,19.46456,0.081,NULL,56511228236,882987941,13796686,17.8),(134842,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134842,35.5,0.8,126,63792,75,NULL,'W91CL, r','CGCG 108-095',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000023,NULL,'15.70',0.2,'SA(s)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.0955417,16.69833,0.033,NULL,56569236621,883894322,13810848,15.7),(134843,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134843,35.4,0.38,120,63792,75,NULL,'W91CL, r, raw','CGCG 108-095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134844,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134844,35.51,0.38,126,63792,75,NULL,'W91CL, r, inv','CGCG 108-095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134845,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134845,35.72,0.38,140,63792,75,NULL,'W91CL, r, cor','CGCG 108-095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134846,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134846,37.11,0.21,264,63793,70,NULL,NULL,'CGCG 051-029',NULL,'2015arXiv151105856S',2015,1,0.89,NULL,'G',0.0002,NULL,'15.4g',0.49,'BrClG',NULL,NULL,NULL,NULL,1,241.096625,5.62044,0.177,NULL,56489004347,882640692,13791260,15.4),(134847,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134847,37.83,0.46,367,63794,70,NULL,NULL,'2MASX J16042371+0424059',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.098875,4.40161,0.225,NULL,56482866473,882544788,13789762,18),(134848,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134848,36.98,0.13,249,63795,70,NULL,NULL,'2MASX J16042376+3344255',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000173,NULL,'17.3g',NULL,NULL,NULL,NULL,NULL,NULL,1,241.0990417,33.74039,0.073,NULL,59768528164,933883252,14591925,17.3),(134849,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134849,37.01,0.46,252,63796,70,NULL,NULL,'2MASX J16042415+3550055',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.1007083,35.83481,0.061,NULL,59773701960,933964093,14593188,17.6),(134850,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134850,36.96,0.33,247,63797,70,NULL,NULL,'2MASX J16042499+1111458',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,241.104125,11.19611,0.153,NULL,56581070482,884079226,13813737,16.6),(134851,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134851,37.35,0.46,295,63798,70,NULL,NULL,'2MASX J16042500+0834388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.10425,8.57736,0.145,NULL,56583950856,884124232,13814441,17.2),(134852,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134852,37.4,0.46,301,63799,70,NULL,NULL,'2MASX J16042521+1243041',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.105125,12.71778,0.093,NULL,56551435219,883616175,13806502,17.2),(134853,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134853,39.5,0.46,796,63800,70,NULL,NULL,'2MASX J16042591+1725431',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000087,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.108125,17.42864,0.045,NULL,56568668629,883885447,13810710,18.7),(134854,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134854,37.41,0.46,303,63801,70,NULL,NULL,'2MASX J16042594+3809061',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.108125,38.15183,0,NULL,59774272577,933973009,14593328,16.6),(134855,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134855,38.02,0.46,402,63802,70,NULL,NULL,'SDSS J160426.25+405950.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000171,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.109416667,40.99744,0.013,NULL,59809844632,934528822,14602012,17.9),(134856,'Ring Diameter','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134856,32.8,0.84,37,63803,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6040B',NULL,'1981ApJS...45..541P',1981,1,0.16,'Component \'a)\' in UGC notes.','G',0.00012,NULL,'16.5g',0.15,'SA0+ pec','Supercluster (RV-confirmed) member',NULL,NULL,'Flat-Spectrum Radio Source',1,241.110458333,17.74197,0.041,NULL,56566631114,883853611,13810212,16.5),(134857,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134857,35.29,0.52,114,63804,70,NULL,NULL,'NGC 6033',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000083,NULL,'14.50',1,'SA(s)bc?',NULL,NULL,NULL,NULL,1,241.116583,-2.12097,0.577,NULL,45528068612,711376072,11115251,14.5),(134858,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134858,35.31,0.46,115,63805,70,NULL,NULL,'UGC 10164',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.000163,NULL,'14.70',0.9,'S0-:','Supercluster foreground object',NULL,NULL,NULL,1,241.117417,14.78242,0.109,NULL,56558052371,883719568,13808118,14.7),(134859,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134859,37.11,0.21,264,63806,70,NULL,NULL,'2MASX J16042823+0538249',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.1177083,5.64025,0.173,NULL,56488976004,882640250,13791253,16.8),(134860,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134860,37.11,0.21,264,63807,70,NULL,NULL,'2MASX J16042823+0539479',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.1177083,5.66328,0.173,NULL,56488973172,882640205,13791253,17.4),(134861,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134861,37.4,0.46,302,63808,70,NULL,NULL,'2MASX J16042845+0813588',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000215,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.1185417,8.23292,0.145,NULL,56584715310,884136176,13814627,16.5),(134862,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134862,38.02,0.33,401,63809,70,NULL,NULL,'2MASXi J1604284+160039',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.118708333,16.01094,0.041,NULL,56572655916,883947748,13811683,18),(134863,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134863,36.14,0.05,169,63810,70,NULL,NULL,'2MASX J16042883+1738551',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000067,NULL,'16.5g',0.28,'S0','Group member',NULL,NULL,NULL,1,241.120125,17.64872,0.041,NULL,56568681774,883885652,13810713,16.5),(134864,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134864,38.05,0.46,408,63811,70,NULL,NULL,'2MASX J16042889+2139562',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.120417,21.66564,0.157,NULL,59393678247,928026222,14500409,18.5),(134865,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134865,37.22,0.46,277,63812,70,NULL,NULL,'SDSS J160429.25+313550.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.121916667,31.59739,0.049,NULL,59735417628,933365900,14583842,18.3),(134866,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134866,36.94,0.46,245,63813,70,NULL,NULL,'2MASX J16042929+2324502',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.122,23.414,0.141,NULL,59395515696,928054932,14500858,17.8),(134867,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134867,37.73,0.46,351,63814,70,NULL,NULL,'2MASX J16042939+3331296',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000187,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.122625,33.52483,0.085,NULL,59764930320,933827036,14591047,17.2),(134868,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134868,35.77,0.46,143,63815,70,NULL,NULL,'CGCG 079-034',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000183,NULL,'15.4',0.7,NULL,NULL,NULL,NULL,NULL,1,241.1275417,11.21467,0.153,NULL,56581083974,884079437,13813741,15.4),(134869,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134869,36.04,0.8,161,63816,75,NULL,'W91CL, r','KUG 1602+176',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000014,NULL,'16.02',0.4,'SAB(s)c','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.128,17.46861,0.045,NULL,56568671623,883885494,13810710,16.02),(134870,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134870,35.65,0.5,135,63816,NULL,NULL,NULL,'KUG 1602+176',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134871,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134871,35.71,0.2,139,63816,74.4,NULL,NULL,'KUG 1602+176',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134872,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134872,35.75,0.38,141,63816,75,NULL,'W91CL, r, raw','KUG 1602+176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134873,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134873,35.78,0.47,143,63816,NULL,NULL,'Malmquist cor.','KUG 1602+176',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134874,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134874,35.86,0.38,148,63816,75,NULL,'W91CL, r, inv','KUG 1602+176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134875,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134875,36.01,0.38,159,63816,75,NULL,'W91CL, r, cor','KUG 1602+176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134876,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134876,37.92,0.13,384,63817,70,NULL,NULL,'SDSS J160430.94+243829.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.128917,24.64142,0.181,NULL,59864571869,935383935,14615373,18.4),(134877,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134877,36.81,0.46,230,63818,70,NULL,NULL,'2MASX J16043113+2130023',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.129583,21.50058,0.149,NULL,59393462154,928022846,14500356,17.1),(134878,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134878,35.53,0.46,127,63819,70,NULL,NULL,'CGCG 195-010',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00007,NULL,'15.2g',0.44,'E0',NULL,NULL,NULL,NULL,1,241.1299583,37.15953,0.045,NULL,59774736737,933980261,14593441,15.2),(134879,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134879,37.51,0.46,318,63820,70,NULL,NULL,'2MASX J16043170+3340176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.1322083,33.67169,0.073,NULL,59768356358,933880568,14591883,17.7),(134880,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134880,38.08,0.46,412,63821,70,NULL,NULL,'2MASX J16043200+1430342',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.133333,14.50933,0.101,NULL,56558060835,883719700,13808120,17.7),(134881,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134881,37.11,0.21,264,63822,70,NULL,NULL,'2MASX J16043232+0536539',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.134583333,5.61494,0.177,NULL,56488973823,882640215,13791253,17.4),(134882,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134882,36.42,0.46,192,63823,70,NULL,NULL,'2MASX J16043247+3827242',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00008,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.13525,38.45689,0,NULL,59774292864,933973326,14593333,16.1),(134883,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134883,37.92,0.13,384,63824,70,NULL,NULL,'SDSS J160433.85+243726.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.1410417,24.624,0.181,NULL,59864571461,935383929,14615373,18.5),(134884,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134884,36.18,0.46,172,63825,70,NULL,NULL,'CGCG 079-038',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000247,NULL,'15.4',0.6,NULL,'Group member',NULL,NULL,NULL,1,241.142125,12.24603,0.137,NULL,56551278681,883613729,13806464,15.4),(134885,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134885,36.13,0.2,168,63826,74.4,NULL,NULL,'CGCG 079-037',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000123,NULL,'15.2',0.2,NULL,'Group member',NULL,NULL,NULL,1,241.143333,12.18139,0.137,NULL,56547868778,883560449,13805632,15.2),(134886,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134886,37.95,0.46,390,63827,70,NULL,NULL,'2MASX J16043457+0950268',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.1439583,9.84067,0.141,NULL,56586241483,884160023,13815000,16.9),(134887,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134887,36.07,0.46,163,63828,70,NULL,NULL,'2MASX J16043469+1402482',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.10',0.29,NULL,NULL,NULL,NULL,NULL,1,241.144541667,14.04667,0.077,NULL,56557798216,883715597,13808056,17.1),(134888,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134888,38.46,0.33,492,63829,70,NULL,NULL,'SDSS J160435.00+150757.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.145875,15.13267,0.097,NULL,56557441494,883710023,13807969,18.1),(134889,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134889,35.7,0.6,138,63830,70,NULL,NULL,'2MASX J16043511-0205473',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.79',0.3,NULL,NULL,NULL,NULL,NULL,1,241.1462917,-2.09664,0.569,NULL,45528060282,711375941,11115249,16.79),(134890,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134890,36.01,0.16,159,63831,70,NULL,NULL,'2MASX J16043518+2322363',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000147,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.146541667,23.37681,0.141,NULL,59395517782,928054965,14500858,16.5),(134891,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134891,35.57,0.25,130,63832,74.4,NULL,NULL,'NGC 6041',NULL,'2013AJ....146...86T',2013,1,NULL,'Part of the GTrpl CGCG 1602.3+1751.','GPair',0.00009,NULL,NULL,NULL,'E','Group member',NULL,NULL,NULL,1,241.147,17.71925,0.041,NULL,56568677723,883885589,13810712,NULL),(134892,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134892,35.37,0.45,119,63832,NULL,NULL,'K','NGC 6041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134893,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134893,35.89,0.4,151,63832,NULL,NULL,'mean','NGC 6041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134894,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134894,36.98,0.13,249,63833,70,NULL,NULL,'MCG +06-35-028',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00019,NULL,'15.3g',0.52,'BrClG',NULL,NULL,NULL,NULL,1,241.14725,33.32642,0.097,NULL,59764941520,933827211,14591050,15.3),(134895,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134895,36.46,0.2,196,63834,74.4,NULL,NULL,'CGCG 137-028',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.000097,NULL,'15.1g',0.41,'Sa',NULL,NULL,NULL,NULL,1,241.148333,25.18992,0.125,NULL,59864690987,935385796,14615403,15.1),(134896,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134896,35.53,0.33,127,63835,70,NULL,NULL,'CGCG 108-100',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000117,NULL,'14.7g',0.63,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.148417,16.903,0.057,NULL,56569425730,883897277,13810894,14.7),(134897,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134897,36.43,0.35,186,63836,60,NULL,'ABELL 2151, BCG','NGC 6041A',0.036,'1980ApJ...241..486H',1980,1,1.13,'Component \'a)\' in UGC notes.','G',0.000077,NULL,'14.5g',0.82,'cD;SA0^-^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.149167,17.72156,0.041,NULL,56568677752,883885589,13810712,14.5),(134898,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134898,35.97,0.44,156,63836,95,NULL,'Weighted Mean','NGC 6041A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134899,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134899,36.24,0.46,177,63836,95,NULL,'Michard 1979a','NGC 6041A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134900,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134900,37.55,0.63,324,63836,95,NULL,'Michard 1979b, c','NGC 6041A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134901,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134901,35.77,0.25,143,63836,70,NULL,NULL,'NGC 6041A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134902,'Magnitude','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134902,35.98,NULL,157,63836,NULL,NULL,'Hurcules Cluster, ABELL 2151','NGC 6041A',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134903,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134903,35.88,0.16,150,63836,70,NULL,'ABELL 2151 Cluster','NGC 6041A',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134904,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134904,36.06,0.08,163,63836,70,NULL,'ABELL 2151, BGC','NGC 6041A',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134905,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134905,36.98,0.13,249,63837,70,NULL,NULL,'SDSS J160435.89+331850.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.149583,33.31394,0.097,NULL,59764944213,933827253,14591050,18.6),(134906,'GRB','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134906,42.81,NULL,3650,63838,70,NULL,'Pseudo z = 2.53','GRB 030519',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,241.15,-33.46667,0.901,NULL,46263743313,722870989,11294859,NULL),(134907,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134907,37.46,0.46,311,63839,70,NULL,NULL,'2MASX J16043640+3550496',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.1517083,35.84731,0.061,NULL,59773713046,933964266,14593191,17.2),(134908,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134908,34.49,0.2,79.1,63840,74.4,NULL,NULL,'MRK 0868',NULL,'2013AJ....146...86T',2013,1,0.5,'Multiple SDSS entries describe this object.','G',0.000335,NULL,'15.7',0.3,'Rejected QSO cand.',NULL,NULL,NULL,NULL,1,241.1545417,9.95333,0.141,NULL,56585977302,884155895,13814935,15.7),(134909,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134909,36.98,0.13,249,63841,70,NULL,NULL,'2MASX J16043843+3331586',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000196,NULL,'16.0g',0.36,'E0',NULL,NULL,NULL,NULL,1,241.160166667,33.53311,0.085,NULL,59764926260,933826972,14591046,16),(134910,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134910,36.14,0.05,169,63842,70,NULL,NULL,'2MASX J16043855+1635572',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.1607083,16.59917,0.033,NULL,56572105856,883939154,13811549,17),(134911,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134911,37.56,0.46,325,63843,70,NULL,NULL,'2MASX J16043904+1713302',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.16275,17.22503,0.053,NULL,56569620982,883900327,13810942,17.4),(134912,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134912,35.57,0.25,130,63844,74.4,NULL,NULL,'NGC 6039',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000053,NULL,'14.9g',0.7,'SA0-','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.164875,17.70086,0.041,NULL,56568689964,883885780,13810715,14.9),(134913,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134913,35.77,0.25,143,63844,70,NULL,NULL,'NGC 6039',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134914,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134914,36.14,0.05,169,63844,70,NULL,NULL,'NGC 6039',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134915,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134915,36.23,0.46,176,63845,70,NULL,NULL,'2MASX J16044005+1300462',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,241.16675,13.01292,0.089,NULL,56551548962,883617952,13806530,16.2),(134916,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134916,37.92,0.13,384,63846,70,NULL,NULL,'2MASX J16044022+2418532',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0001,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.167667,24.31489,0.173,NULL,59395015388,928047115,14500736,17.4),(134917,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134917,38.16,0.46,429,63847,70,NULL,NULL,'SDSS J160440.24+262859.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000175,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.1677083,26.48331,0.129,NULL,59862503929,935351623,14614869,18.6),(134918,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134918,35.59,0.25,131,63848,74.4,NULL,NULL,'CGCG 108-102',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000089,NULL,'15.3g',0.47,'S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.1712917,16.42989,0.029,NULL,56572074500,883938664,13811541,15.3),(134919,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134919,35.79,0.18,144,63848,70,NULL,NULL,'CGCG 108-102',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134920,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134920,35.63,0.25,134,63849,74.4,NULL,NULL,'GIN 525',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000087,NULL,'15.05',NULL,'E',NULL,NULL,NULL,NULL,1,241.172583333,16.64975,0.033,NULL,56572063365,883938490,13811538,15.05),(134921,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134921,35.79,0.18,144,63850,70,NULL,NULL,'SDSS J160441.49+163858.4',NULL,'2001MNRAS.321..277C',2001,1,0.54,NULL,'G',0.000186,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,241.172875,16.64956,0.033,NULL,56572063372,883938490,13811538,16.1),(134922,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134922,36.14,0.05,169,63850,70,NULL,NULL,'SDSS J160441.49+163858.4',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134923,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134923,37.92,0.13,384,63851,70,NULL,NULL,'2MASX J16044163+2437542',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000179,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.173583,24.63181,0.181,NULL,59864569236,935383894,14615373,17.6),(134924,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134924,36.14,0.05,169,63852,70,NULL,NULL,'SDSS J160442.09+163040.2',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00009,NULL,'16.0g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.175375,16.51119,0.029,NULL,56572114877,883939294,13811551,16),(134925,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134925,36.95,0.46,246,63853,70,NULL,NULL,'2MASX J16044248+2052103',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.177166667,20.86947,0.133,NULL,56520596124,883134314,13798973,16.8),(134926,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134926,36.14,0.05,169,63854,70,NULL,NULL,'2MASX J16044282+1738191',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000047,NULL,'16.4g',0.37,'SB0/a','Group member',NULL,NULL,NULL,1,241.1785,17.63867,0.041,NULL,56568688566,883885758,13810714,16.4),(134927,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134927,35.77,0.33,142,63855,70,NULL,NULL,'2MASX J16044349+2019253',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.0001,NULL,'16.55',0.4,NULL,NULL,NULL,NULL,NULL,1,241.181333333,20.32378,0.073,NULL,56520791117,883137361,13799021,16.55),(134928,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134928,35.64,0.25,134,63856,74.4,NULL,NULL,'KUG 1602+166B',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000073,NULL,'14.86',0.3,'E?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.182083,16.52247,0.029,NULL,56572114376,883939287,13811551,14.86),(134929,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134929,35.79,0.18,144,63856,70,NULL,NULL,'KUG 1602+166B',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134930,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134930,37.58,0.33,327,63857,70,NULL,NULL,'SDSS J160444.46+272446.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.1852917,27.41294,0.105,NULL,59875923531,935561305,14618145,18.1),(134931,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134931,37.92,0.13,384,63858,70,NULL,NULL,'2MASX J16044530+2437242',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000237,NULL,'16.5g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,241.188875,24.62347,0.181,NULL,59864576847,935384013,14615375,16.5),(134932,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134932,35.79,0.8,144,63859,75,NULL,'W91CL, r','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.000009,NULL,'15.50',0.5,'SA(s)c           AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.1892083,17.44839,0.045,NULL,56568662602,883885353,13810708,15.5),(134933,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134933,35.79,0.8,144,63859,75,NULL,'HMCL, I','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134934,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134934,35.15,0.74,107,63859,NULL,NULL,'Malmquist cor.','KUG 1602+175',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134935,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134935,35.2,0.73,109,63859,NULL,NULL,NULL,'KUG 1602+175',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134936,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134936,35.24,0.38,112,63859,75,NULL,'W91CL, r, raw','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134937,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134937,35.31,0.2,115,63859,74.4,NULL,NULL,'KUG 1602+175',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134938,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134938,35.33,0.38,117,63859,75,NULL,'W91CL, r, inv','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134939,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134939,35.44,0.4,122,63859,75,NULL,'HMCL, I, raw','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134940,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134940,35.59,0.4,131,63859,75,NULL,'HMCL, I, inv','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134941,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134941,35.6,0.38,132,63859,75,NULL,'W91CL, r, cor','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134942,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134942,35.78,0.4,143,63859,75,NULL,'HMCL, I, cor','KUG 1602+175',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134943,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134943,37.79,0.33,362,63860,70,NULL,NULL,'SDSS J160445.65+530834.1',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000096,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,241.190291667,53.14281,0.009,NULL,59701150407,932830475,14575476,16.4),(134944,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134944,37.75,0.46,354,63861,70,NULL,NULL,'SDSS J160446.77+152956.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000134,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.194875,15.49894,0.061,NULL,56571399612,883928118,13811376,18.6),(134945,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134945,35.12,0.25,106,63862,74.4,NULL,NULL,'GIN 491',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000077,NULL,'14.49',0.44,'E',NULL,NULL,NULL,NULL,1,241.195125,24.27883,0.173,NULL,59395017612,928047150,14500736,14.49),(134946,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134946,35.31,0.29,115,63862,70,NULL,NULL,'GIN 491',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134947,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134947,37.43,0.46,306,63863,70,NULL,NULL,'2MASX J16044712+4136054',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.196333,41.60147,0.029,NULL,59810588773,934540449,14602194,17.1),(134948,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134948,33.76,0.49,56.4,63864,75,NULL,'IR','UGC 10172',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000017,NULL,'15.40',0.2,'Sbc',NULL,NULL,NULL,NULL,1,241.197625,14.28717,0.093,NULL,56557685739,883713839,13808028,15.4),(134949,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134949,34.04,0.2,64.3,63864,74.4,NULL,NULL,'UGC 10172',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134950,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134950,37.92,0.13,384,63865,70,NULL,NULL,'SDSS J160447.63+243626.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.1985,24.60731,0.181,NULL,59864576215,935384003,14615375,18),(134951,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134951,35.58,0.46,131,63866,70,NULL,NULL,'CGCG 079-040',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000009,NULL,'15.2',0.2,NULL,NULL,NULL,NULL,NULL,1,241.200417,14.12886,0.077,NULL,56557667645,883713556,13808024,15.2),(134952,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134952,37.91,0.46,381,63867,70,NULL,NULL,'2MASX J16044862+2816082',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.202667,28.26919,0.085,NULL,59867552181,935430502,14616101,18),(134953,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134953,36.14,0.05,169,63868,70,NULL,NULL,'2MASX J16044876+1616081',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.203208333,16.26886,0.029,NULL,56572159363,883939990,13811562,17.2),(134954,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134954,35.53,0.33,127,63869,70,NULL,NULL,'CGCG 108-106',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000233,NULL,'14.15',0.8,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.20825,16.58361,0.033,NULL,56572107350,883939177,13811549,14.15),(134955,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134955,35.58,0.25,131,63869,74.4,NULL,NULL,'CGCG 108-106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134956,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134956,35.79,0.18,144,63869,70,NULL,NULL,'CGCG 108-106',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134957,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134957,38.62,0.46,530,63870,70,NULL,NULL,'SDSS J160450.00+242731.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.208333,24.45875,0.177,NULL,59864516528,935383070,14615360,18.2),(134958,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134958,36.69,0.46,218,63871,70,NULL,NULL,'2MASX J16045006+3430496',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.208625,34.51378,0.013,NULL,59766475371,933851177,14591424,16.5),(134959,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134959,37.69,0.33,345,63872,70,NULL,NULL,'2MASX J16045040+2122443',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000195,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.210166667,21.37908,0.149,NULL,56506756921,882918076,13795594,16.7),(134960,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134960,35.12,0.25,106,63873,74.4,NULL,NULL,'GIN 489',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.00006,NULL,'16.0g',0.33,'E',NULL,NULL,NULL,NULL,1,241.210666667,23.97489,0.165,NULL,59395057283,928047770,14500746,16),(134961,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134961,35.31,0.29,115,63873,70,NULL,NULL,'GIN 489',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134962,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134962,36.01,0.16,159,63873,70,NULL,NULL,'GIN 489',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134963,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134963,36.98,0.13,249,63874,70,NULL,NULL,'2MASX J16045113+3320406',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00019,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,241.213125,33.34464,0.097,NULL,59764950138,933827345,14591052,16.8),(134964,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134964,37.59,0.46,330,63875,70,NULL,NULL,'2MASX J16045126+3854514',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00011,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.213625,38.91417,0.017,NULL,59769880730,933904386,14592256,16.7),(134965,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134965,36.14,0.05,169,63876,70,NULL,NULL,'2MASX J16045137+1741058',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00006,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.214167,17.68492,0.041,NULL,56568814516,883887726,13810745,17.4),(134966,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134966,36.82,0.46,231,63877,70,NULL,NULL,'2MASX J16045153+2039483',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.214875,20.66353,0.133,NULL,56520437714,883131839,13798934,18.1),(134967,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134967,35.75,0.25,141,63878,74.4,NULL,NULL,'CGCG 108-105',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000053,NULL,'15.0g',0.66,'SB(s)a','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.215583,15.72314,0.061,NULL,56571486235,883929472,13811398,15),(134968,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134968,35.79,0.18,144,63878,70,NULL,NULL,'CGCG 108-105',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134969,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134969,37.82,0.33,366,63879,70,NULL,NULL,'2MASX J16045271+1911343',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.219583,19.19289,0.057,NULL,56511330905,882989545,13796711,17.3),(134970,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134970,36.14,0.05,169,63880,70,NULL,NULL,'2MASX J16045292+1612198',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000181,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.220417,16.20558,0.029,NULL,56572160056,883940000,13811562,16.4),(134971,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134971,37.27,0.46,284,63881,70,NULL,NULL,'2MASX J16045338-0002509',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000109,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.2225,-0.04747,0.377,NULL,45525042841,711328794,11114512,17.2),(134972,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134972,37.69,0.46,345,63882,70,NULL,NULL,'2MASX J16045352+3355458',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'16.9g',0.28,'Cand.grav.lens',NULL,NULL,NULL,NULL,1,241.222917,33.9295,0.061,NULL,59768539668,933883432,14591928,16.9),(134973,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134973,35.49,0.65,125,63883,70,NULL,NULL,'2MASX J16045497-0224439',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,241.229125,-2.41225,0.505,NULL,45527281217,711363769,11115058,14.1),(134974,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134974,37.44,0.33,308,63884,70,NULL,NULL,'2MASX J16045542+1805423',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000063,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.2309583,18.09506,0.057,NULL,56566507770,883851683,13810182,17.9),(134975,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134975,37.92,0.13,384,63885,70,NULL,NULL,'2MASX J16045608+2430383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000158,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.233625,24.51056,0.177,NULL,59864521324,935383145,14615361,17.4),(134976,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','PS1 SN PS11uw','N',134976,41.05,0.13,1250,63886,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11uw HOST',0.3001,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134977,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134977,36.01,0.16,159,63887,70,NULL,NULL,'2MASX J16045634+2345283',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000063,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.234625,23.75778,0.149,NULL,59395268845,928051075,14500798,17),(134978,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134978,37.23,0.33,279,63888,70,NULL,NULL,'2MASX J16045656+4121264',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.235583,41.35722,0.005,NULL,59810610402,934540787,14602199,16.5),(134979,'D-Sigma','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134979,35.09,0.4,104,63889,75,NULL,'Edat, raw','NGC 6051',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000057,NULL,'14.23',0.9,'cD;E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.236125,23.93269,0.165,NULL,59395234653,928050541,14500789,14.23),(134980,'D-Sigma','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134980,35.43,0.4,122,63889,75,NULL,'Edat, cor','NGC 6051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134981,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134981,34.83,0.44,92.5,63889,95,NULL,'Weighted Mean','NGC 6051',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134982,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134982,35.28,0.46,114,63889,95,NULL,'Michard 1979a','NGC 6051',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134983,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134983,35.78,0.63,143,63889,95,NULL,'Michard 1979b, c','NGC 6051',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134984,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134984,35.12,0.25,106,63889,74.4,NULL,NULL,'NGC 6051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134985,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134985,35.31,0.29,115,63889,70,NULL,NULL,'NGC 6051',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134986,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134986,35.59,0.45,131,63889,NULL,NULL,'K','NGC 6051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134987,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134987,35.75,0.4,141,63889,NULL,NULL,'mean','NGC 6051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134988,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134988,36.14,0.05,169,63890,70,NULL,NULL,'SDSS J160457.02+163407.8',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.2g',0.28,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.237583333,16.56883,0.033,NULL,56572101684,883939088,13811548,16.2),(134989,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134989,37.92,0.13,384,63891,70,NULL,NULL,'SDSS J160457.12+241705.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.2380417,24.28494,0.173,NULL,59391608253,927993878,14499904,18.3),(134990,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134990,35.75,0.2,141,63892,74.4,NULL,NULL,'KUG 1602+142',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000016,NULL,'15.4',0.3,'Spiral',NULL,NULL,NULL,NULL,1,241.241333333,14.13758,0.077,NULL,56557680644,883713760,13808027,15.4),(134991,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134991,37.92,0.13,384,63893,70,NULL,NULL,'2MASX J16045828+2435103',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000182,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.242833,24.58608,0.181,NULL,59864520292,935383129,14615361,18.2),(134992,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134992,35.82,0.49,146,63894,75,NULL,'IR','2MFGC 12909',NULL,'2011yCatp016004901K',2011,1,0.59,NULL,'G',0.000027,NULL,'17.0g',0.14,'S','Group member',NULL,NULL,NULL,1,241.2435417,18.18683,0.053,NULL,56510946086,882983532,13796617,17),(134993,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134993,38.06,0.46,409,63895,70,NULL,NULL,'2MASX J16045867+3610364',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,241.244417,36.17681,0.053,NULL,59776514588,934008040,14593875,17),(134994,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',134994,36.32,0.49,184,63896,75,NULL,'IR','2MFGC 12910',NULL,'2011yCatp016004901K',2011,1,0.67,NULL,'G',0.000039,NULL,'16.2g',0.19,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.2445,16.80983,0.057,NULL,56569297176,883895268,13810863,16.2),(134995,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134995,36.35,0.45,186,63896,NULL,NULL,'Malmquist cor.','2MFGC 12910',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134996,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134996,36.7,0.38,219,63896,NULL,NULL,NULL,'2MFGC 12910',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134997,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134997,36.87,0.2,237,63896,74.4,NULL,NULL,'2MFGC 12910',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(134998,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134998,35.7,0.51,138,63897,70,NULL,NULL,'2MASX J16045942-0144519',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.3I',0.6,NULL,NULL,NULL,NULL,NULL,1,241.247583333,-1.74781,0.497,NULL,45527540041,711367813,11115122,13.3),(134999,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,134999,35.56,0.25,129,63898,74.4,NULL,NULL,'NGC 6044',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000067,NULL,'14.9g',0.58,'SA0^0^','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.248667,17.87036,0.061,NULL,56568596554,883884321,13810692,14.9),(135000,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135000,35.77,0.25,143,63898,70,NULL,NULL,'NGC 6044',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135001,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135001,36.14,0.05,169,63898,70,NULL,NULL,'NGC 6044',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135002,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135002,36.99,0.46,250,63899,70,NULL,NULL,'2MASX J16050053+0729524',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000167,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.25225,7.49783,0.149,NULL,56581949188,884092956,13813952,16.4),(135003,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135003,37.23,0.33,279,63900,70,NULL,NULL,'2MASX J16050061+4123304',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000202,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.252375,41.39169,0.009,NULL,59810610662,934540791,14602199,16.6),(135004,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135004,37.47,0.46,312,63901,70,NULL,NULL,'2MASX J16050056+0825374',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.3g',0.24,'AGN',NULL,NULL,NULL,NULL,1,241.252417,8.42714,0.149,NULL,56584386281,884131035,13814547,17.3),(135005,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135005,36.11,0.46,167,63902,70,NULL,NULL,'2MASX J16050074+2644473',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.253125,26.74647,0.125,NULL,59862585030,935352891,14614888,16.5),(135006,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135006,35.56,0.25,129,63903,74.4,NULL,NULL,'NGC 6043',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00003,NULL,NULL,NULL,'S0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.255,17.77389,0.061,NULL,56568810341,883887661,13810744,NULL),(135007,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135007,35.77,0.25,143,63904,70,NULL,NULL,'NGC 6043A',NULL,'2001MNRAS.321..277C',2001,1,0.66,NULL,'G',0.00008,NULL,'15.2g',0.51,'SAB0^-^        AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.2557083,17.77569,0.061,NULL,56568810353,883887661,13810744,15.2),(135008,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135008,37.31,0.46,290,63905,70,NULL,NULL,'2MASX J16050141+2820343',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000175,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.255916667,28.343,0.073,NULL,59867621694,935431588,14616118,17),(135009,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135009,36.37,0.69,188,63906,70,NULL,NULL,'2MASX J16050172-0845141',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,241.257167,-8.75403,0.613,NULL,45572673954,712073030,11126141,14),(135010,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135010,34.09,0.2,65.8,63907,74.4,NULL,NULL,'UGC 10176',NULL,'2013AJ....146...86T',2013,1,1.76,NULL,'G',0.000016,NULL,'15.28',0.17,'Sbc',NULL,NULL,NULL,NULL,1,241.258167,13.70122,0.077,NULL,56550195663,883596807,13806200,15.28),(135011,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135011,34.1,0.49,66,63907,75,NULL,'IR','UGC 10176',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135012,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135012,34.1,NULL,66,63907,NULL,NULL,NULL,'UGC 10176',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135013,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135013,34.19,NULL,68.8,63907,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135014,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135014,34.21,NULL,69.6,63907,NULL,NULL,'Dipole + Quadrupole','UGC 10176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135015,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135015,34.23,NULL,70.1,63907,NULL,NULL,'Dipole','UGC 10176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135016,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135016,36.73,0.46,222,63908,70,NULL,NULL,'2MASX J16050260-0025359',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000109,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,241.260875,-0.42664,0.433,NULL,45525985639,711343525,11114742,16.3),(135017,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135017,37.24,0.46,281,63909,70,NULL,NULL,'SDSS J160504.01+170644.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.26675,17.11233,0.053,NULL,56569610170,883900158,13810939,18.1),(135018,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:53','1','SN 1962C',NULL,135018,35.22,0.29,111,63910,NULL,NULL,'Avg. of 8 SN host galaxies','MCG +03-41-085',NULL,'1985ApJ...297...23D',1985,1,0.59,NULL,'G',0.00008,NULL,'17.4g',0.13,'S',NULL,NULL,NULL,NULL,1,241.267625,17.58044,0.041,NULL,56568786877,883887294,13810738,17.4),(135019,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135019,36.28,0.46,180,63911,70,NULL,NULL,'IC 4588',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00009,NULL,'15.8g',0.45,NULL,NULL,NULL,NULL,NULL,1,241.2677083,23.91714,0.165,NULL,59395242877,928050669,14500791,15.8),(135020,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135020,39.48,0.46,787,63912,70,NULL,NULL,'SDSS J160504.31+504700.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.268,50.78342,NULL,NULL,59706784583,932918509,14576851,18.7),(135021,'Horizontal Branch','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'N',135021,18.49,NULL,0.05,63913,NULL,NULL,NULL,'Hercules Moving Group',NULL,'2010MNRAS.405.1796H',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135022,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135022,37.82,0.33,366,63914,70,NULL,NULL,'2MASX J16050488+1911375',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.27025,19.19369,0.045,NULL,56511329394,882989521,13796711,18),(135023,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135023,37.9,0.46,380,63915,70,NULL,NULL,'2MASX J16050491+1923065',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.270625,19.38528,0.081,NULL,56518789255,883106082,13798532,17.1),(135024,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135024,36.75,0.46,224,63916,70,NULL,NULL,'2MASX J16050543+1156598',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.71',0.45,NULL,NULL,NULL,NULL,NULL,1,241.272583,11.95006,0.121,NULL,56579354785,884052418,13813319,16.71),(135025,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135025,35.13,0.25,106,63917,74.4,NULL,NULL,'GIN 494',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000053,NULL,'16.5g',0.33,'E',NULL,NULL,NULL,NULL,1,241.27675,23.86497,0.149,NULL,59395241609,928050650,14500791,16.5),(135026,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135026,35.31,0.29,115,63917,70,NULL,NULL,'GIN 494',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135027,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135027,36.01,0.16,159,63917,70,NULL,NULL,'GIN 494',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135028,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135028,36.71,0.46,220,63918,70,NULL,NULL,'2MASX J16050670+4250278',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.277917,42.841,0,NULL,59803942949,934436608,14600572,17),(135029,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135029,37.72,0.46,350,63919,70,NULL,NULL,'2MASX J16050685+0753205',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00016,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,241.278583,7.88906,0.173,NULL,56585141375,884142833,13814731,17.6),(135030,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135030,36.24,0.46,177,63920,70,NULL,NULL,'2MASX J16050685+0959325',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.278667,9.99219,0.149,NULL,56586090949,884157671,13814963,17.1),(135031,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135031,37.38,0.33,299,63921,70,NULL,NULL,'SDSS J160507.62+272145.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.28175,27.36275,0.105,NULL,59862230003,935347343,14614802,18),(135032,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135032,35.59,0.47,131,63922,NULL,NULL,'H','NGC 6045',NULL,'2007A&A...465...71T',2007,1,1.17,NULL,'G',0.000033,NULL,'14.9g',0.28,'SB(s)c','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.282875,17.75767,0.061,NULL,56568821477,883887835,13810747,14.9),(135033,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135033,35.69,0.45,137,63922,NULL,NULL,'K','NGC 6045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135034,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135034,35.76,0.31,142,63922,NULL,NULL,'Malmquist cor.','NGC 6045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135035,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135035,35.79,0.46,144,63922,NULL,NULL,'J','NGC 6045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135036,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135036,35.85,0.4,148,63922,NULL,NULL,'mean','NGC 6045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135037,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135037,35.87,0.29,149,63922,NULL,NULL,NULL,'NGC 6045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135038,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135038,35.91,0.2,152,63922,74.4,NULL,NULL,'NGC 6045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135039,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135039,37.79,0.33,362,63923,70,NULL,NULL,'2MASX J16050810+5304379',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.2839583,53.07714,0.009,NULL,59701087122,932829486,14575460,17.2),(135040,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135040,34.71,0.44,87.5,63924,95,NULL,'Weighted Mean','NGC 6047',NULL,'1984ApJS...56...91D',1984,1,1.1,NULL,'G',0.00006,NULL,'14.55',0.8,'E+','Supercluster (RV-confirmed) member',NULL,'radio jet',NULL,1,241.2874583,17.72989,0.061,NULL,56568820136,883887814,13810747,14.55),(135041,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135041,35.17,0.46,108,63924,95,NULL,'Michard 1979a','NGC 6047',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135042,'Faber-Jackson','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135042,35.6,0.63,132,63924,95,NULL,'Michard 1979b, c','NGC 6047',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135043,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135043,35.56,0.25,129,63924,74.4,NULL,NULL,'NGC 6047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135044,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135044,35.77,0.25,143,63924,70,NULL,NULL,'NGC 6047',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135045,'Magnitude','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135045,35.98,NULL,157,63924,NULL,NULL,'Hurcules Cluster, ABELL 2151','NGC 6047',NULL,'1995A&A...302...21G',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135046,'Sosies','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135046,35.25,0.3,112,63924,NULL,NULL,'Hurcules Cluster, ABELL 2151, vs. Messier 031 m-M = 24.07 mag','NGC 6047',NULL,'1986ApJ...308..487D',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135047,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135047,35.72,0.4,140,63924,NULL,NULL,'mean','NGC 6047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135048,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135048,35.88,0.16,150,63924,70,NULL,'ABELL 2151 Cluster','NGC 6047',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135049,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135049,36.17,0.45,172,63924,NULL,NULL,'K','NGC 6047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135050,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135050,37.16,0.27,270,63925,70,NULL,NULL,'2MASX J16050901+3711195',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00012,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.287625,37.18883,0.029,NULL,59774757817,933980590,14593446,16.7),(135051,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135051,36.25,0.27,178,63926,70,NULL,NULL,'2MASX J16051015+2724027',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000187,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.2925,27.40086,0.105,NULL,59862274062,935348032,14614813,16.5),(135052,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135052,37.95,0.46,390,63927,70,NULL,NULL,'2MASX J16051051+1344069',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.29375,13.73522,0.089,NULL,56550197059,883596829,13806200,17.9),(135053,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135053,36.84,0.46,234,63928,70,NULL,NULL,'2MASX J16051184+2114236',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000014,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,241.2992917,21.23983,0.137,NULL,56506944623,882921009,13795640,16.1),(135054,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135054,35.09,0.58,104,63929,70,NULL,NULL,'2MASX J16051251-0212528',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,241.3022083,-2.21472,0.577,NULL,45528047418,711375740,11115245,14.2),(135055,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135055,35.75,0.8,141,63930,75,NULL,'W91CL, r','IC 1173',NULL,'1997ApJS..109..333W',1997,1,0.95,NULL,'G',0.000023,NULL,'15.2g',0.5,'SAB(rs)c','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.302333,17.42286,0.049,NULL,56568742206,883886596,13810728,15.2),(135056,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135056,35.75,0.8,141,63930,75,NULL,'HMCL, I','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135057,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135057,35.42,0.56,122,63930,NULL,NULL,NULL,'IC 1173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135058,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135058,35.46,0.2,124,63930,74.4,NULL,NULL,'IC 1173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135059,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135059,35.5,0.54,126,63930,NULL,NULL,'Malmquist cor.','IC 1173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135060,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135060,35.64,0.4,134,63930,75,NULL,'HMCL, I, raw','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135061,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135061,35.83,0.38,147,63930,75,NULL,'W91CL, r, raw','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135062,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135062,35.86,0.4,149,63930,75,NULL,'HMCL, I, inv','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135063,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135063,35.94,0.4,154,63930,75,NULL,'HMCL, I, cor','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135064,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135064,36.02,0.38,160,63930,75,NULL,'W91CL, r, inv','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135065,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135065,36.09,0.38,165,63930,75,NULL,'W91CL, r, cor','IC 1173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135066,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135066,34.27,0.4,71.4,63931,NULL,NULL,'mean','NGC 6052',NULL,'2007A&A...465...71T',2007,1,NULL,'One of two 6cm sources associated with [WB92] 1603+2037','GPair',0.000003,NULL,NULL,NULL,'Sc+Sc          LIRG','Supercluster foreground object',NULL,NULL,NULL,1,241.304125,20.54236,0.101,NULL,56521323990,883145687,13799151,NULL),(135067,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135067,35.7,0.46,138,63931,NULL,NULL,'J','NGC 6052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135068,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135068,35.72,0.47,140,63931,NULL,NULL,'H','NGC 6052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135069,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135069,35.73,0.45,140,63931,NULL,NULL,'K','NGC 6052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135070,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135070,36.14,0.05,169,63932,70,NULL,NULL,'2MASX J16051341+1639178',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.306,16.65511,0.033,NULL,56572098797,883939043,13811547,17.4),(135071,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135071,38.15,0.46,427,63933,70,NULL,NULL,'SDSS J160514.31+263053.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000165,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.309667,26.515,0.129,NULL,59862510599,935351728,14614870,18),(135072,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135072,38.18,0.46,433,63934,70,NULL,NULL,'SDSS J160514.65+175442.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.311083,17.91169,0.057,NULL,56568605832,883884466,13810694,17.9),(135073,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135073,36.43,0.35,186,63935,60,NULL,NULL,'ABELL 2151',0.036,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.3124583,17.74853,0.061,NULL,56568818754,883887793,13810746,NULL),(135074,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135074,36.06,0.08,163,63935,70,NULL,NULL,'ABELL 2151',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135075,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135075,35.63,0.25,134,63936,74.4,NULL,NULL,'GIN 516',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.000177,NULL,'15.5g',0.48,'E',NULL,NULL,NULL,NULL,1,241.312958333,15.92608,0.061,NULL,56571009505,883922023,13811281,15.5),(135076,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135076,35.79,0.18,144,63936,70,NULL,NULL,'GIN 516',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135077,'FP','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135077,36.14,0.05,169,63936,70,NULL,NULL,'GIN 516',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135078,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,'R',135078,35.9,0.49,151,63937,75,NULL,'IR','2MFGC 12915',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.000014,NULL,'14.76',0.3,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.314125,17.53969,0.061,NULL,56568789372,883887333,13810739,14.76),(135079,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135079,35.96,0.33,156,63937,NULL,NULL,'Malmquist cor.','2MFGC 12915',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135080,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:53','1',NULL,NULL,135080,35.96,0.34,156,63937,NULL,NULL,NULL,'2MFGC 12915',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135081,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135081,36.11,0.2,167,63937,74.4,NULL,NULL,'2MFGC 12915',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135082,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135082,36.93,0.27,243,63938,70,NULL,NULL,'2MASX J16051568+0008167',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000116,NULL,'16.6g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,241.31525,0.13808,0.377,NULL,56476445973,882444468,13788194,16.6),(135083,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135083,36.14,0.05,169,63939,70,NULL,NULL,'2MASX J16051599+1821586',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.63',0.25,'Ep','Group member',NULL,NULL,NULL,1,241.316833,18.36625,0.041,NULL,56510930482,882983288,13796613,16.63),(135084,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135084,36.81,0.46,230,63940,70,NULL,NULL,'2MASX J16051631+4431288',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000201,NULL,'16.0g',0.3,'E0',NULL,NULL,NULL,NULL,1,241.318166667,44.52475,0.017,NULL,59802666587,934416665,14600260,16),(135085,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135085,36.66,0.46,215,63941,70,NULL,NULL,'2MASX J16051655+2008146',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.318875,20.13758,0.093,NULL,56520865675,883138526,13799039,16.3),(135086,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135086,35.11,0.25,105,63942,74.4,NULL,NULL,'CGCG 137-034',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000063,NULL,'15.4g',0.47,'S',NULL,NULL,NULL,NULL,1,241.323417,23.75567,0.149,NULL,59395170020,928049531,14500773,15.4),(135087,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135087,35.31,0.29,115,63942,70,NULL,NULL,'CGCG 137-034',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135088,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135088,36.01,0.16,159,63942,70,NULL,NULL,'CGCG 137-034',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135089,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135089,36.93,0.27,243,63943,70,NULL,NULL,'2MASX J16051910+0007512',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000093,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.3295417,0.131,0.377,NULL,56476489446,882445147,13788205,17.2),(135090,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135090,35.42,0.73,121,63944,70,NULL,NULL,'2MASX J16051968-0223247',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000127,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,241.3320417,-2.39025,0.505,NULL,45527201229,711362519,11115039,13.9),(135091,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135091,36.53,0.33,203,63945,70,NULL,NULL,'SDSS J160520.10+441332.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.33375,44.22561,0.021,NULL,59806281774,934473152,14601143,17.9),(135092,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135092,37.45,0.46,309,63946,70,NULL,NULL,'2MASX J16052012+1033075',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.3339583,10.55214,0.149,NULL,56578291354,884035802,13813059,17),(135093,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135093,37.92,0.13,384,63947,70,NULL,NULL,'2MASX J16052026+2419258',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.334625,24.32383,0.177,NULL,59391617003,927994015,14499906,17.7),(135094,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135094,37.99,0.46,397,63948,70,NULL,NULL,'2MASX J16052035+1822466',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000206,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.3349583,18.37953,0.041,NULL,56510928653,882983260,13796613,17.1),(135095,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135095,36.21,0.43,175,63949,NULL,NULL,'Malmquist cor.','2MFGC 12917',NULL,'2009ApJS..182..474S',2009,1,0.54,NULL,'G',0.000023,NULL,'15.34',NULL,'Sc',NULL,NULL,NULL,NULL,1,241.335667,14.73933,0.109,NULL,56558029121,883719205,13808112,15.34),(135096,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135096,36.45,0.49,195,63949,75,NULL,'IR','2MFGC 12917',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135097,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135097,36.47,0.39,197,63949,NULL,NULL,NULL,'2MFGC 12917',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135098,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135098,36.51,0.2,200,63949,74.4,NULL,NULL,'2MFGC 12917',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135099,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135099,36.76,0.46,225,63950,70,NULL,NULL,'2MASX J16052247+2321316',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.343625,23.35894,0.153,NULL,59395341126,928052205,14500815,17),(135100,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135100,35.55,0.8,129,63951,75,NULL,'W91CL, r','UGC 10186',NULL,'1997ApJS..109..333W',1997,1,NULL,'Delta V > 1000 km/sec; probably an optical pair.','GPair',0.000073,NULL,NULL,NULL,'DBL SYS','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.344916667,17.75506,0.061,NULL,56568824102,883887876,13810748,NULL),(135101,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135101,35.42,0.38,121,63951,75,NULL,'W91CL, r, raw','UGC 10186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135102,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135102,35.57,0.38,130,63951,75,NULL,'W91CL, r, inv','UGC 10186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135103,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135103,35.74,0.38,140,63951,75,NULL,'W91CL, r, cor','UGC 10186',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135104,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135104,38,0.46,397,63952,70,NULL,NULL,'2MASX J16052297+2841039',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.345666667,28.68447,0.081,NULL,59867515016,935429922,14616092,18),(135105,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135105,35.87,0.46,149,63953,70,NULL,NULL,'2MASX J16052340+2230276',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000174,NULL,'15.6g',0.43,NULL,NULL,NULL,NULL,NULL,1,241.3474583,22.50775,0.173,NULL,59393793662,928028025,14500437,15.6),(135106,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135106,35.55,0.8,129,63954,75,NULL,'HMCL, I','NGC 6050',NULL,'1997ApJS..109..333W',1997,1,0.93,'Component \'b)\' in UGC notes.','G',0.000104,NULL,'15.2g',0.58,'SA(s)c           AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.347375,17.75717,0.065,NULL,56568824099,883887876,13810748,15.2),(135107,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135107,35.85,0.4,148,63954,75,NULL,'HMCL, I, raw','NGC 6050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135108,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135108,36.04,0.4,161,63954,75,NULL,'HMCL, I, inv','NGC 6050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135109,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135109,36.13,0.4,168,63954,75,NULL,'HMCL, I, cor','NGC 6050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135110,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135110,36.06,0.46,163,63955,70,NULL,NULL,'CGCG 108-115',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.000233,NULL,'14.30',1.3,'E+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.349375,14.64767,0.109,NULL,56557927753,883717621,13808087,14.3),(135111,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135111,36.51,0.46,201,63956,70,NULL,NULL,'2MASX J16052516+0409350',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000187,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.354875,4.15961,0.241,NULL,56490663951,882666624,13791666,16.4),(135112,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135112,37.44,0.46,308,63957,70,NULL,NULL,'2MASX J16052545+2755419',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000198,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.356083333,27.92831,0.085,NULL,59875810562,935559540,14618117,16.8),(135113,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135113,35.64,0.25,134,63958,74.4,NULL,NULL,'UGC 10187 NED01',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000053,NULL,'15.3g',0.5,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.360125,16.44275,0.029,NULL,56572233001,883941140,13811580,15.3),(135114,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135114,35.79,0.18,144,63958,70,NULL,NULL,'UGC 10187 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135115,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135115,36.14,0.05,169,63958,70,NULL,NULL,'UGC 10187 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135116,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135116,35.88,0.8,150,63959,75,NULL,'HMCL, I','UGC 10190',NULL,'1997ApJS..109..333W',1997,1,0.85,NULL,'G',0.000007,NULL,'16.6g',0.18,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.359583,17.69683,0.065,NULL,56568837586,883888087,13810751,16.6),(135117,'IRAS','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135117,35.88,0.8,150,63959,75,NULL,'W91CL, r','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135118,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135118,35.55,0.4,129,63959,75,NULL,'HMCL, I, raw','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135119,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135119,35.65,0.4,135,63959,75,NULL,'HMCL, I, inv','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135120,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135120,35.71,0.38,138,63959,75,NULL,'W91CL, r, raw','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135121,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135121,35.76,0.38,142,63959,75,NULL,'W91CL, r, inv','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135122,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135122,35.87,0.4,149,63959,75,NULL,'HMCL, I, cor','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135123,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135123,35.92,0.34,153,63959,NULL,NULL,NULL,'UGC 10190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135124,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135124,35.97,0.38,157,63959,75,NULL,'W91CL, r, cor','UGC 10190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135125,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135125,36,0.33,159,63959,NULL,NULL,'Malmquist cor.','UGC 10190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135126,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135126,36.01,0.2,159,63959,74.4,NULL,NULL,'UGC 10190',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135127,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135127,35.66,0.5,136,63960,70,NULL,NULL,'2MASX J16052668-0156187',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.0001,NULL,'15.91',0.7,NULL,NULL,NULL,NULL,NULL,1,241.361083,-1.93864,0.497,NULL,45527509347,711367333,11115114,15.91),(135128,'SNIa','2016-12-15 15:15:39','2016-12-16 11:20:54','1','SN 2000cp',NULL,135128,35.98,0.17,152,63961,70,NULL,'SALT 2','2MFGC 12921',0.034204,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'GPair',0.00015,NULL,NULL,NULL,'S','Group member',NULL,NULL,NULL,1,241.363625,17.83097,0.061,NULL,56568598834,883884356,13810693,NULL),(135129,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135129,37.16,0.27,270,63962,70,NULL,NULL,'2MASX J16052743+3716365',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000173,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,241.364458333,37.27683,0.029,NULL,59774751197,933980487,14593445,15.8),(135130,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135130,37.16,0.27,270,63963,70,NULL,NULL,'2MASX J16052793+3717225',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'FoF','17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.3662917,37.28964,0.029,NULL,59774779983,933980937,14593452,17.3),(135131,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135131,36.97,0.35,237,63964,60,NULL,'ABELL 2152, BCG','UGC 10187 NED02',0.0444,'1980ApJ...241..486H',1980,1,1.3,NULL,'G',0.000043,NULL,'13.86',1.3,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.371583,16.43586,0.029,NULL,56572234988,883941171,13811580,13.86),(135132,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135132,35.63,0.25,134,63964,74.4,NULL,NULL,'UGC 10187 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135133,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135133,35.79,0.18,144,63964,70,NULL,NULL,'UGC 10187 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135134,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135134,37.38,0.33,299,63965,70,NULL,NULL,'2MASX J16052990+2724499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000152,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,241.3747083,27.41389,0.105,NULL,59862261357,935347833,14614809,17.1),(135135,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135135,35.53,0.67,127,63966,NULL,NULL,NULL,'KUG 1603+179A',NULL,'2009ApJS..182..474S',2009,1,0.67,'Often incorrectly identified as NGC 6054.','G',0.000023,NULL,'15.9g',0.41,'(R\')SAB(s)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.377625,17.76867,0.065,NULL,56568824654,883887885,13810748,15.9),(135136,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135136,35.53,0.67,128,63966,NULL,NULL,'Malmquist cor.','KUG 1603+179A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135137,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135137,36.32,0.46,184,63967,70,NULL,NULL,'2MASX J16053064-0015597',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.37775,-0.26647,0.417,NULL,45525066901,711329170,11114518,17.2),(135138,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135138,37.81,0.46,366,63968,70,NULL,NULL,'SDSS J160530.68+100827.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.377875,10.14111,0.149,NULL,56586103492,884157867,13814966,18.2),(135139,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135139,37.79,0.46,362,63969,70,NULL,NULL,'2MASX J16053093+0953175',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.378875,9.88833,0.141,NULL,56586048267,884157004,13814953,16.9),(135140,'BCG','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135140,36.97,0.35,237,63970,60,NULL,NULL,'ABELL 2152',0.0444,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.384166667,16.44194,0.029,NULL,56572235691,883941182,13811580,NULL),(135141,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135141,37.66,0.46,340,63971,70,NULL,NULL,'2MASX J16053230+2439559',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.3847083,24.66558,0.181,NULL,59864540990,935383452,14615366,17.5),(135142,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135142,35.58,0.25,131,63972,74.4,NULL,NULL,'NGC 6055',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000083,NULL,'14.7g',0.6,'(R)SAB0+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.385666667,18.15958,0.053,NULL,56566487260,883851363,13810177,14.7),(135143,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135143,35.77,0.25,143,63972,70,NULL,NULL,'NGC 6055',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135144,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135144,35.85,0.4,148,63973,NULL,NULL,'mean','IC 1178',NULL,'2007A&A...465...71T',2007,1,1.13,NULL,'G',0.000033,NULL,'14.9g',0.6,'S0- pec?','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.388,17.60144,0.061,NULL,56568779663,883887182,13810737,14.9),(135145,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135145,36.1,0.45,166,63973,NULL,NULL,'K','IC 1178',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135146,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135146,37.96,0.46,391,63974,70,NULL,NULL,'2MASX J16053313+3326457',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.388083,33.44606,0.037,NULL,59764916123,933826814,14591043,17.6),(135147,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135147,37.71,0.46,349,63975,70,NULL,NULL,'2MASX J16053412+2949059',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.3922917,29.81822,0.073,NULL,59736893576,933388962,14584202,17.7),(135148,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135148,36.59,0.46,208,63976,70,NULL,NULL,'2MASX J16053432+0542100',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000168,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.393125,5.70289,0.173,NULL,56489761521,882652523,13791445,16.3),(135149,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135149,37.73,0.46,352,63977,70,NULL,NULL,'2MASX J16053494+5256441',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000115,NULL,'17.1g',0.28,'NLAGN',NULL,NULL,NULL,NULL,1,241.395667,52.94561,0.009,NULL,59699990691,932812354,14575193,17.1),(135150,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135150,36.53,0.33,203,63978,70,NULL,NULL,'CGCG 223-039',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000196,NULL,'14.8g',0.65,'E              AGN:',NULL,NULL,NULL,NULL,1,241.398166667,44.20614,0.021,NULL,59806280157,934473127,14601142,14.8),(135151,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135151,37.71,0.46,348,63979,70,NULL,NULL,'2MASX J16053577+5331001',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.399041667,53.51675,0.025,NULL,59699943490,932811617,14575181,17.4),(135152,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135152,35.58,0.25,131,63980,74.4,NULL,NULL,'CGCG 108-127',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000023,NULL,'15.4g',0.45,'SB(r)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.40225,18.273,0.053,NULL,56510912419,882983006,13796609,15.4),(135153,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135153,35.77,0.25,143,63980,70,NULL,NULL,'CGCG 108-127',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135154,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135154,35.87,0.33,149,63981,NULL,NULL,'Malmquist cor.','IC 1182',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',0.000027,NULL,'15.0g',0.6,'SA0+ pec       HII','Supercluster (RV-confirmed) member',NULL,NULL,'Sy 2',1,241.403333,17.80214,0.065,NULL,56568619954,883884686,13810698,15),(135155,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135155,36.24,0.28,177,63981,NULL,NULL,NULL,'IC 1182',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135156,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135156,36.28,0.2,180,63981,74.4,NULL,NULL,'IC 1182',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135157,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135157,35.32,0.52,116,63982,NULL,NULL,NULL,'LSBC F584-01',NULL,'2009ApJS..182..474S',2009,1,0.86,NULL,'G',0.000184,NULL,'15.4g',0.61,'S?',NULL,NULL,NULL,NULL,1,241.403333,22.18639,0.161,NULL,59393875959,928029311,14500457,15.4),(135158,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135158,35.42,0.5,122,63982,NULL,NULL,'Malmquist cor.','LSBC F584-01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135159,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135159,35.55,0.2,129,63982,74.4,NULL,NULL,'LSBC F584-01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135160,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135160,36.95,0.46,245,63983,70,NULL,NULL,'2MASX J16053696+4904001',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000112,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,241.404167,49.06658,0.045,NULL,59704756799,932886824,14576356,15.9),(135161,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135161,38.1,0.23,416,63984,70,NULL,NULL,'2MASX J16053806+2256258',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.4084583,22.94042,0.165,NULL,59394925241,928045706,14500714,17.3),(135162,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135162,36.41,0.2,191,63985,74.4,NULL,NULL,'CGCG 079-045',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000147,NULL,'15.0',0.4,'Sbc',NULL,NULL,NULL,NULL,1,241.408666667,10.03542,0.149,NULL,56586063274,884157238,13814956,15),(135163,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135163,36.14,0.05,169,63986,70,NULL,NULL,'NGC 6054',NULL,'2015arXiv151105856S',2015,1,0.86,'Misidentified as IC 1184 in CGCG and in several papers referring to it.','G',0.000103,NULL,'15.1g',0.47,'SAB0-','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.4089583,17.76789,0.065,NULL,56568798987,883887484,13810741,15.1),(135164,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135164,35.57,0.2,130,63986,74.4,NULL,NULL,'NGC 6054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135165,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135165,38.1,0.23,416,63987,70,NULL,NULL,'2MASX J16053921+2257538',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00021,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,241.413333,22.96506,0.165,NULL,59394928383,928045755,14500714,16.2),(135166,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135166,35.57,0.25,130,63988,74.4,NULL,NULL,'NGC 6053',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000053,NULL,'15.3g',0.56,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.4152083,18.16436,0.053,NULL,56566482108,883851282,13810176,15.3),(135167,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135167,35.77,0.25,143,63988,70,NULL,NULL,'NGC 6053',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135168,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135168,37.89,0.46,378,63989,70,NULL,NULL,'2MASX J16054008+3814020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.416875,38.23394,0.009,NULL,59774233208,933972393,14593318,17.5),(135169,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135169,36.14,0.05,169,63990,70,NULL,NULL,'2MASX J16054022+1535308',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,241.417667,15.592,0.061,NULL,56571696890,883932763,13811449,16.3),(135170,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135170,32.71,NULL,34.9,63991,72,NULL,NULL,'HIPASS J1605-04',NULL,'2014Ap.....57..457K',2014,1,1.3,NULL,'G',0.000003,NULL,'18.2',1,'Ir',NULL,NULL,NULL,NULL,1,241.418333,-4.57225,0.561,NULL,45553585371,711774771,11121480,18.2),(135171,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135171,36.14,0.05,169,63992,70,NULL,NULL,'2MASX J16054083+1806268',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000057,NULL,'16.0g',0.39,'E2','Group member',NULL,NULL,NULL,1,241.420167,18.10753,0.053,NULL,56566483811,883851309,13810176,16),(135172,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135172,35.19,0.81,109,63993,NULL,NULL,'Malmquist cor.','AGC 261206',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000027,NULL,'14.8',NULL,'SBa',NULL,NULL,NULL,NULL,1,241.420625,14.79906,0.109,NULL,56557241294,883706895,13807920,14.8),(135173,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135173,35.23,0.79,111,63993,NULL,NULL,NULL,'AGC 261206',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135174,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135174,35.27,0.2,113,63993,74.4,NULL,NULL,'AGC 261206',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135175,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135175,38.1,0.46,416,63994,70,NULL,NULL,'2MASX J16054114+2837190',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.4212917,28.62194,0.081,NULL,59867507979,935429812,14616090,17.3),(135176,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135176,35.4,0.46,120,63995,70,NULL,NULL,'2MASX J16054145+1326378',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.4227083,13.44381,0.077,NULL,56551183064,883612235,13806441,16.6),(135177,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135177,35.73,0.46,140,63996,70,NULL,NULL,'2MASX J16054218+5239590',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.425583,52.66653,0.009,NULL,59701595757,932837433,14575584,17.1),(135178,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135178,36.14,0.05,169,63997,70,NULL,NULL,'2MASX J16054228+1626258',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.426291667,16.44047,0.029,NULL,56572203344,883940677,13811573,17.1),(135179,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135179,38.06,0.46,409,63998,70,NULL,NULL,'2MASX J16054235+2211258',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'18.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.426417,22.19047,0.161,NULL,59393873588,928029274,14500457,18),(135180,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135180,34.22,NULL,69.8,63999,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1986',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000011,NULL,'16.5g',0.18,'Sc',NULL,NULL,NULL,NULL,1,241.427833,22.45658,0.173,NULL,59393912621,928029884,14500466,16.5),(135181,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135181,34.23,NULL,70.2,63999,NULL,NULL,'Dipole + Quadrupole','FGC 1986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135182,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135182,34.25,NULL,70.7,63999,NULL,NULL,'Dipole','FGC 1986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135183,'Tully-Fisher','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,NULL,135183,34.29,NULL,72.1,63999,NULL,NULL,NULL,'FGC 1986',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135184,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135184,36.14,0.05,169,64000,70,NULL,NULL,'2MASX J16054299+1548528',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.429167,15.81458,0.061,NULL,56571505676,883929776,13811402,16.8),(135185,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135185,36.59,0.46,208,64001,70,NULL,NULL,'2MASX J16054346+1659348',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000097,NULL,'16.1g',0.33,'E',NULL,NULL,NULL,NULL,1,241.431,16.99308,0.053,NULL,56569314840,883895544,13810867,16.1),(135186,'FP','2016-12-15 15:15:39','2016-12-16 11:20:54','1',NULL,'R',135186,36.14,0.05,169,64002,70,NULL,NULL,'SDSS J160544.02+161534.5',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',NULL,NULL,'15.6g',0.42,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.4334583,16.25958,0.073,NULL,56572136772,883939637,13811556,15.6),(135187,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135187,35.96,0.4,156,64003,NULL,NULL,'Malmquist cor.','IC 1186',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000033,NULL,'15.2g',0.5,'SB(r)b         AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.43425,17.36217,0.049,NULL,56569491255,883898300,13810910,15.2),(135188,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135188,36.44,0.32,194,64003,NULL,NULL,NULL,'IC 1186',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135189,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135189,36.48,0.2,198,64003,74.4,NULL,NULL,'IC 1186',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135190,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135190,36.25,0.27,178,64004,70,NULL,NULL,'2MASX J16054449+2726188',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.4352917,27.43869,0.105,NULL,59862266538,935347914,14614811,16.3),(135191,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135191,36.29,0.49,181,64005,75,NULL,'IR','UGC 10193 NED01',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000014,NULL,'15.7',0.2,'Sbc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.435833,16.20336,0.069,NULL,56571037102,883922454,13811288,15.7),(135192,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135192,35.57,0.25,130,64006,74.4,NULL,NULL,'IC 1185',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000093,NULL,'14.89',0.5,'SA(rs)ab:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.436208333,17.71703,0.065,NULL,56568803660,883887557,13810743,14.89),(135193,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135193,35.77,0.25,143,64006,70,NULL,NULL,'IC 1185',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135194,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135194,35.44,0.47,122,64006,NULL,NULL,'H','IC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135195,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135195,35.62,0.46,133,64006,NULL,NULL,'J','IC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135196,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135196,35.67,0.45,136,64006,NULL,NULL,'K','IC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135197,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135197,35.89,0.4,151,64006,NULL,NULL,'mean','IC 1185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135198,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10kd','N',135198,41.4,0.2,1430,64007,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kd HOST',0.3311,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135199,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135199,37.5,0.46,316,64008,70,NULL,NULL,'SDSS J160544.90+282945.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.437125,28.49592,0.081,NULL,59867632981,935431765,14616121,17.9),(135200,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135200,37.07,0.33,259,64009,70,NULL,NULL,'2MASX J16054585+1140155',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,241.441083,11.67092,0.141,NULL,56579419081,884053423,13813334,15.7),(135201,'Tully est','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135201,32.53,0.8,32.1,64010,75,NULL,'B','UGC 10200',NULL,'1988NBGC.C....0000T',1988,1,0.71,NULL,'G',0.000006,NULL,'13.6g',0.67,'Sab            HII','Pair member (points to parent)',NULL,NULL,NULL,1,241.44125,41.34475,0,NULL,59810764387,934543193,14602237,13.6),(135202,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135202,35.59,0.25,131,64011,74.4,NULL,NULL,'CGCG 108-135',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.00007,NULL,'15.7g',0.46,'SB(rs)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.442917,18.01681,0.057,NULL,56568591135,883884236,13810691,15.7),(135203,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135203,35.77,0.25,143,64011,70,NULL,NULL,'CGCG 108-135',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135204,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135204,37.49,0.46,315,64012,70,NULL,NULL,'SDSS J160546.85+375855.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PRED','17.1g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.4452083,37.98211,0,NULL,59774215909,933972123,14593314,17.1),(135205,'Tully est','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135205,32.6,0.8,33.2,64013,75,NULL,'B','CGCG 223-037',NULL,'1988NBGC.C....0000T',1988,1,0.7,'Kirshner, et al. (1978,AJ,83,1549) give v_hel_=14110 km/sec.','G',0.000053,NULL,'15.2g',0.4,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,241.4459583,41.31825,0,NULL,59810719851,934542497,14602226,15.2),(135206,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135206,35.62,0.25,133,64014,74.4,NULL,NULL,'CGCG 108-131',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000057,NULL,'14.7g',0.76,'E+','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.446333,15.79097,0.061,NULL,56571504329,883929755,13811402,14.7),(135207,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135207,35.79,0.18,144,64014,70,NULL,NULL,'CGCG 108-131',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135208,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135208,36.14,0.05,169,64014,70,NULL,NULL,'CGCG 108-131',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135209,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135209,37.23,0.46,279,64015,70,NULL,NULL,'2MASX J16054757+1020125',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.448125,10.33683,0.153,NULL,56585927991,884155124,13814923,17.3),(135210,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135210,38.1,0.23,416,64016,70,NULL,NULL,'SDSS J160548.78+230708.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,241.4532917,23.11894,0.153,NULL,59394951268,928046113,14500720,18.6),(135211,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135211,37.19,0.46,274,64017,70,NULL,NULL,'2MASX J16054932+1803439',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000113,NULL,'17.0g',0.23,'E3','Group member',NULL,NULL,NULL,1,241.455625,18.06233,0.057,NULL,56568593427,883884272,13810691,17),(135212,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135212,35.12,0.25,106,64018,74.4,NULL,NULL,'GIN 492',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00007,NULL,'16.5g',0.35,'E/S0',NULL,NULL,NULL,NULL,1,241.456583333,24.17592,0.173,NULL,59391669510,927994836,14499919,16.5),(135213,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135213,35.31,0.29,115,64018,70,NULL,NULL,'GIN 492',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135214,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135214,36.01,0.16,159,64018,70,NULL,NULL,'GIN 492',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135215,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135215,38.42,0.46,483,64019,70,NULL,NULL,'SDSS J160551.54+181422.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.4647917,18.23958,0.053,NULL,56510907487,882982929,13796608,18.5),(135216,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135216,33.92,0.8,60.9,64020,75,NULL,'CF, r','NGC 6060',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00002,NULL,'13.80',1.1,'SAB(rs)c','Supercluster foreground object',NULL,NULL,NULL,1,241.466583333,21.48497,0.193,NULL,56506924321,882920692,13795635,13.8),(135217,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135217,33.95,0.8,61.7,64020,75,NULL,'HMCL, I','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135218,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135218,33.55,0.4,51.3,64020,75,NULL,'HMCL, I, raw','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135219,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135219,33.61,0.38,52.8,64020,75,NULL,'CF, r, raw','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135220,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135220,33.77,0.4,56.8,64020,75,NULL,'HMCL, I, inv','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135221,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135221,33.8,0.38,57.6,64020,75,NULL,'CF, r, inv','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135222,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135222,33.84,0.4,58.6,64020,75,NULL,'HMCL, I, cor','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135223,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135223,33.86,0.38,59.2,64020,75,NULL,'CF, r, cor','NGC 6060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135224,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135224,33.95,0.2,61.7,64020,74.4,NULL,NULL,'NGC 6060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135225,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135225,33.99,0.47,62.9,64020,NULL,NULL,'H','NGC 6060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135226,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135226,34,0.45,63,64020,NULL,NULL,'K','NGC 6060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135227,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135227,34.01,0.46,63.3,64020,NULL,NULL,'J','NGC 6060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135228,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135228,34.15,0.4,67.6,64020,NULL,NULL,'mean','NGC 6060',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135229,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135229,38.01,0.46,400,64021,70,NULL,NULL,'2MASX J16055204+2919159',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000198,NULL,'16.9g',0.27,'E',NULL,NULL,NULL,NULL,1,241.466875,29.32117,0.081,NULL,59736979945,933390311,14584223,16.9),(135230,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135230,35.81,0.8,145,64022,75,NULL,'HMCL, I','IC 1190',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'15.61',0.4,'(R\')SAB(s)b','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.468375,18.22053,0.053,NULL,56510908076,882982938,13796608,15.61),(135231,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135231,35.81,0.8,145,64022,75,NULL,'W91CL, r','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135232,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135232,35.91,0.38,152,64022,75,NULL,'W91CL, r, raw','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135233,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135233,35.93,0.4,154,64022,75,NULL,'HMCL, I, raw','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135234,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135234,35.95,0.3,155,64022,NULL,NULL,'Malmquist cor.','IC 1190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135235,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135235,36.13,0.38,168,64022,75,NULL,'W91CL, r, inv','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135236,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135236,36.15,0.38,170,64022,75,NULL,'W91CL, r, cor','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135237,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135237,36.19,0.4,173,64022,75,NULL,'HMCL, I, inv','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135238,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135238,36.21,0.4,175,64022,75,NULL,'HMCL, I, cor','IC 1190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135239,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135239,36.22,0.26,176,64022,NULL,NULL,NULL,'IC 1190',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135240,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135240,36.26,0.2,179,64022,74.4,NULL,NULL,'IC 1190',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135241,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135241,36.14,0.05,169,64023,70,NULL,NULL,'SDSS J160553.52+154231.7',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000113,NULL,'15.6g',0.37,'S',NULL,NULL,NULL,NULL,1,241.473,15.70881,0.061,NULL,56571710303,883932973,13811452,15.6),(135242,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135242,37.36,0.46,297,64024,70,NULL,NULL,'2MASX J16055363+3641371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.473708333,36.69356,0.005,NULL,59776954082,934014907,14593982,17.3),(135243,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135243,36.47,0.46,197,64025,70,NULL,NULL,'2MASX J16055381-0033016',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000089,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.47425,-0.55044,0.433,NULL,45525851751,711341433,11114709,17.1),(135244,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135244,35.71,0.52,139,64026,70,NULL,NULL,'2MASX J16055385-0834146',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,241.474375,-8.57078,0.613,NULL,45574483488,712101304,11126582,15.5),(135245,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10acx','N',135245,41.29,0.11,1340,64027,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10acx HOST',0.3501,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135246,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135246,38.21,0.46,439,64028,70,NULL,NULL,'2MASX J16055483+4046161',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000164,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.478458333,40.77128,0.017,NULL,59810644333,934541317,14602208,17.6),(135247,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135247,37.69,0.46,345,64029,70,NULL,NULL,'SDSS J160555.29+281722.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.480375,28.28947,0.073,NULL,59867439695,935428745,14616074,17.7),(135248,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135248,36.25,0.27,178,64030,70,NULL,NULL,'2MASX J16055534+2716279',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'16.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.480667,27.27456,0.105,NULL,59862283293,935348176,14614815,16.9),(135249,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135249,38.42,0.46,484,64031,70,NULL,NULL,'SDSS J160555.49+065848.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.48125,6.98019,0.189,NULL,56581566481,884086976,13813859,18.3),(135250,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135250,36.65,0.33,214,64032,70,NULL,NULL,'2MASX J16055606+4814033',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000094,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,241.4837083,48.23433,0,NULL,59704089475,932876398,14576193,16),(135251,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135251,38.07,0.46,410,64033,70,NULL,NULL,'2MASX J16055657+1440091',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.485875,14.66925,0.061,NULL,56557213519,883706461,13807913,17.8),(135252,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135252,37.51,0.46,318,64034,70,NULL,NULL,'2MASX J16055690+4218127',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000182,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.487125,42.30364,0.013,NULL,59808191153,934502986,14601609,16.9),(135253,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135253,37.92,0.46,384,64035,70,NULL,NULL,'SDSS J160557.04+480816.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.487667,48.13797,0,NULL,59705132347,932892692,14576448,18.1),(135254,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135254,37.57,0.46,327,64036,70,NULL,NULL,'2MASX J16055729+3507397',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.488625,35.12764,0.025,NULL,59766144174,933846002,14591343,17.2),(135255,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135255,36.14,0.05,169,64037,70,NULL,NULL,'2MASX J16055744+1543331',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000117,NULL,'15.9g',0.38,'S',NULL,NULL,NULL,NULL,1,241.489333333,15.72597,0.061,NULL,56571679798,883932496,13811445,15.9),(135256,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135256,36.42,0.55,192,64038,NULL,NULL,'Malmquist cor.','AGC 260959',NULL,'2009ApJS..182..474S',2009,1,0.73,NULL,'G',0.000016,NULL,'17.7g',0.1,'Scd',NULL,NULL,NULL,NULL,1,241.492125,16.46447,0.085,NULL,56572030243,883937972,13811530,17.7),(135257,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135257,36.88,0.45,238,64038,NULL,NULL,NULL,'AGC 260959',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135258,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135258,37.1,0.2,263,64038,74.4,NULL,NULL,'AGC 260959',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135259,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135259,38.1,0.23,416,64039,70,NULL,NULL,'SDSS J160558.28+225444.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.492875,22.91247,0.165,NULL,59394973838,928046466,14500726,18.8),(135260,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135260,37.74,0.46,354,64040,70,NULL,NULL,'2MASX J16055884+0620129',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.495167,6.33703,0.169,NULL,56459611004,882181421,13784084,17.5),(135261,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135261,36.83,0.46,232,64041,70,NULL,NULL,'2MASXi J1605590+534816',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00009,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.496083333,53.80467,0,NULL,57606191047,900096735,14064011,16.7),(135262,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135262,36.14,0.05,169,64042,70,NULL,NULL,'2MASX J16060013+1804512',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.4g',0.35,'E/S0','Group member',NULL,NULL,NULL,1,241.5005,18.08103,0.081,NULL,56568580346,883884067,13810688,16.4),(135263,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135263,36.02,0.4,160,64043,NULL,NULL,'Malmquist cor.','CGCG 108-139',NULL,'2009ApJS..182..474S',2009,1,1.08,NULL,'G',0.00003,NULL,'15.2g',0.46,'SAB(rs)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.500708333,18.19594,0.053,NULL,56518247415,883097615,13798400,15.2),(135264,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135264,36.52,0.32,201,64043,NULL,NULL,NULL,'CGCG 108-139',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135265,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135265,36.56,0.2,205,64043,74.4,NULL,NULL,'CGCG 108-139',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135266,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135266,36.65,0.33,214,64044,70,NULL,NULL,'2MASX J16060038+4810354',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000182,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,241.501667,48.17647,0,NULL,59705145133,932892892,14576451,16.1),(135267,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135267,32.89,NULL,37.8,64045,72,NULL,NULL,'CGCG 079-046',NULL,'2014Ap.....57..457K',2014,1,0.84,NULL,'G',0.000044,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.509125,8.50675,0.145,NULL,56584514925,884133045,13814578,15.8),(135268,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135268,35.98,0.8,157,64046,75,NULL,'HMCL, I','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000019,NULL,'16.0',0.4,'SB(s)a','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.509,18.67003,0.045,NULL,56518400811,883100012,13798437,16),(135269,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135269,35.98,0.8,157,64046,75,NULL,'W91CL, r','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135270,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135270,35.7,0.4,138,64046,75,NULL,'HMCL, I, raw','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135271,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135271,35.82,0.3,146,64046,NULL,NULL,'Malmquist cor.','CGCG 108-140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135272,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135272,35.89,0.29,151,64046,NULL,NULL,NULL,'CGCG 108-140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135273,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135273,35.96,0.4,156,64046,75,NULL,'HMCL, I, inv','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135274,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135274,36.01,0.4,159,64046,75,NULL,'HMCL, I, cor','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135275,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135275,36.19,0.2,173,64046,74.4,NULL,NULL,'CGCG 108-140',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135276,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135276,36.31,0.38,183,64046,75,NULL,'W91CL, r, raw','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135277,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135277,36.52,0.38,202,64046,75,NULL,'W91CL, r, inv','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135278,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135278,36.54,0.38,204,64046,75,NULL,'W91CL, r, cor','CGCG 108-140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135279,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135279,36.82,0.46,231,64047,70,NULL,NULL,'2MASX J16060258+1237322',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'15.8g',0.43,NULL,NULL,NULL,NULL,NULL,1,241.5107083,12.62575,0.129,NULL,56551376109,883615251,13806488,15.8),(135280,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135280,36.14,0.05,169,64048,70,NULL,NULL,'2MASX J16060304+1742062',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'16.81',0.2,'E','Group member',NULL,NULL,NULL,1,241.512583,17.70167,0.065,NULL,56568727432,883886366,13810724,16.81),(135281,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135281,35.59,0.25,131,64049,74.4,NULL,NULL,'GIN 523',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000133,NULL,'16.1g',0.35,'S',NULL,NULL,NULL,NULL,1,241.514667,16.17575,0.069,NULL,56571173880,883924591,13811321,16.1),(135282,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135282,35.79,0.18,144,64049,70,NULL,NULL,'GIN 523',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135283,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135283,36.88,0.46,238,64050,70,NULL,NULL,'2MASX J16060361+3039004',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000184,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,241.515083333,30.65022,0.049,NULL,59735615963,933368999,14583890,16.5),(135284,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135284,37.07,0.33,259,64051,70,NULL,NULL,'SDSS J160603.70+114212.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,241.515417,11.70358,0.141,NULL,56579410101,884053282,13813332,NULL),(135285,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135285,37.66,0.46,341,64052,70,NULL,NULL,'2MASX J16060399+4807014',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.0002,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,241.516625,48.11717,0.009,NULL,59705146229,932892909,14576451,17.2),(135286,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135286,36.4,0.46,191,64053,70,NULL,NULL,'2MASX J16060518+4519207',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000148,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.5217083,45.32253,0.021,NULL,59802779693,934418432,14600288,17.2),(135287,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135287,38.53,0.46,509,64054,70,NULL,NULL,'SDSS J160605.39+140011.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.5224583,14.00325,0.077,NULL,56550048671,883594510,13806164,18.6),(135288,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135288,36.98,0.13,249,64055,70,NULL,NULL,'2MASX J16060553+3325004',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000198,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,241.522958333,33.41678,0.037,NULL,59781942957,934092858,14595200,15.9),(135289,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135289,35.58,0.25,131,64056,74.4,NULL,NULL,'CGCG 108-141',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000077,NULL,'15.37',0.5,'SB0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.5255,18.60689,0.045,NULL,56518475598,883101181,13798455,15.37),(135290,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135290,35.77,0.25,143,64056,70,NULL,NULL,'CGCG 108-141',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135291,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135291,36.14,0.05,169,64056,70,NULL,NULL,'CGCG 108-141',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135292,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135292,36.76,0.46,225,64057,70,NULL,NULL,'2MASX J16060691+4933224',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000106,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,241.5287917,49.55636,NULL,NULL,59704701086,932885954,14576343,15.9),(135293,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1964C',NULL,135293,35.22,0.29,111,64058,NULL,NULL,'Avg. of 8 SN host galaxies','IC 1188A',NULL,'1985ApJ...297...23D',1985,1,0.68,NULL,'G',0.00015,NULL,'15.4g',0.51,'SAB(s)a','Group member',NULL,NULL,NULL,1,241.530417,17.46081,0.061,NULL,56568720388,883886256,13810722,15.4),(135294,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135294,37.02,0.46,253,64059,70,NULL,NULL,'2MASX J16060778+1515272',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.532333333,15.25764,0.061,NULL,56570868016,883919812,13811247,17.4),(135295,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135295,36.99,0.27,250,64060,70,NULL,NULL,'2MASX J16060826+0000493',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.5342917,0.01372,0.401,NULL,56476336274,882442754,13788168,17),(135296,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135296,37.3,0.46,288,64061,70,NULL,NULL,'2MASX J16060848+0435342',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000166,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.535291667,4.59267,0.205,NULL,56492657354,882697771,13792152,17.7),(135297,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135297,38.34,0.46,466,64062,70,NULL,NULL,'2MASX J16060917+1839042',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.538333,18.65125,0.045,NULL,56518468938,883101077,13798454,17.4),(135298,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135298,37.92,0.13,384,64063,70,NULL,NULL,'2MASX J16061004+2432560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.541917,24.54883,0.181,NULL,59861681685,935338776,14614668,17.9),(135299,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135299,36.99,0.27,250,64064,70,NULL,NULL,'2MASX J16061082+0005052',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.545167,0.08481,0.401,NULL,56476519453,882445616,13788212,18),(135300,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1967G',NULL,135300,35.22,0.29,111,64065,NULL,NULL,'Avg. of 8 SN host galaxies','2MFGC 12933',NULL,'1985ApJ...297...23D',1985,1,0.75,NULL,'G',0.000078,NULL,'16.4g',0.15,'S','Group member',NULL,NULL,NULL,1,241.5482083,18.32911,0.041,NULL,56518258854,883097794,13798403,16.4),(135301,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135301,36.42,0.49,192,64065,75,NULL,'IR','2MFGC 12933',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135302,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135302,36.09,0.46,165,64066,70,NULL,NULL,'MCG +07-33-041',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.0001,NULL,'15.2g',0.55,'S0','Field galaxy',NULL,NULL,NULL,1,241.5487083,40.41228,0.013,NULL,59809504915,934523514,14601929,15.2),(135303,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135303,35.61,0.58,132,64067,NULL,NULL,NULL,'AGC 260212',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000033,NULL,'15.8g',0.27,'SB(r)b','Group member',NULL,NULL,NULL,1,241.550458333,17.30208,0.049,NULL,56569174134,883893345,13810833,15.8),(135304,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135304,35.65,0.2,135,64067,74.4,NULL,NULL,'AGC 260212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135305,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135305,35.65,0.57,135,64067,NULL,NULL,'Malmquist cor.','AGC 260212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135306,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135306,38.01,0.46,399,64068,70,NULL,NULL,'2MASX J16061297+1750352',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.554167,17.84322,0.073,NULL,56568612378,883884568,13810696,18.3),(135307,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135307,35.96,0.36,156,64069,NULL,NULL,'Malmquist cor.','CGCG 108-146',NULL,'2009ApJS..182..474S',2009,1,0.69,NULL,'G',0.00003,NULL,'15.5g',0.48,'SAB(rs)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.559417,18.41444,0.041,NULL,56518311359,883098614,13798415,15.5),(135308,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135308,36.12,0.33,168,64069,NULL,NULL,NULL,'CGCG 108-146',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135309,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135309,36.17,0.2,171,64069,74.4,NULL,NULL,'CGCG 108-146',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135310,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135310,38.55,0.46,513,64070,70,NULL,NULL,'2MASX J16061453+2406330',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.560583,24.10925,0.169,NULL,59391627272,927994176,14499909,18.7),(135311,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135311,37.38,0.46,300,64071,70,NULL,NULL,'2MASX J16061514+3448584',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.5632083,34.81625,0.021,NULL,59766621760,933853465,14591460,17.1),(135312,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135312,37.06,0.46,258,64072,70,NULL,NULL,'2MASX J16061524+1524532',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000187,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.563458333,15.41478,0.061,NULL,56570853794,883919590,13811243,17.4),(135313,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135313,35.58,0.25,131,64073,74.4,NULL,NULL,'NGC 6061',NULL,'2013AJ....146...86T',2013,1,0.98,'UZC has V = 11844 +- 50 km/sec.','G',0.00009,NULL,'14.4g',0.81,'SA0-','Supercluster (RV-confirmed) member',NULL,'head-tail','Flat-Spectrum Radio Source',1,241.566791667,18.24994,0.081,NULL,56516151357,883064864,13797888,14.4),(135314,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135314,35.77,0.25,143,64073,70,NULL,NULL,'NGC 6061',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135315,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135315,36.14,0.05,169,64073,70,NULL,NULL,'NGC 6061',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135316,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135316,36.04,0.4,161,64073,NULL,NULL,'mean','NGC 6061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135317,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135317,36.58,0.45,207,64073,NULL,NULL,'K','NGC 6061',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135318,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135318,33.89,0.46,59.9,64074,NULL,NULL,'J','ESO 451- G 008',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000023,NULL,'14.04',0.3,'(R\')SB(s)b:',NULL,NULL,NULL,NULL,1,241.5675417,-29.28167,0.785,NULL,46244748687,722574198,11290221,14.04),(135319,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135319,33.9,0.47,60.4,64074,NULL,NULL,'H','ESO 451- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135320,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135320,34.08,0.45,65.4,64074,NULL,NULL,'K','ESO 451- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135321,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135321,34.1,0.4,66,64074,NULL,NULL,'mean','ESO 451- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135322,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135322,34.11,0.49,66.4,64074,75,NULL,'IR','ESO 451- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135323,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135323,34.58,0.43,82.3,64074,75,NULL,'3.6 micron, color + selection bias corrected','ESO 451- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135324,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135324,35.63,0.25,134,64075,74.4,NULL,NULL,'GIN 524',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000063,NULL,'15.8g',0.39,'E/S0',NULL,NULL,NULL,NULL,1,241.56875,16.03919,0.069,NULL,56571147796,883924184,13811315,15.8),(135325,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135325,35.79,0.18,144,64075,70,NULL,NULL,'GIN 524',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135326,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135326,36.14,0.05,169,64075,70,NULL,NULL,'GIN 524',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135327,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135327,38.23,0.33,442,64076,70,NULL,NULL,'2MASX J16061767+2858237',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00026,NULL,'17.1g',0.27,'E',NULL,NULL,NULL,NULL,1,241.573583,28.97319,0.073,NULL,59736471438,933382366,14584099,17.1),(135328,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135328,36.23,0.46,176,64077,70,NULL,NULL,'2MASX J16061784+4956484',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000175,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,241.5742917,49.94689,NULL,NULL,59705985767,932906027,14576656,16.2),(135329,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135329,37.99,0.46,396,64078,70,NULL,NULL,'2MASX J16061815+3359484',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.575583,33.99686,0.013,NULL,59766458813,933850918,14591420,17.1),(135330,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135330,36.99,0.27,250,64079,70,NULL,NULL,'2MASX J16061880-0002095',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000096,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.5782083,-0.03592,0.409,NULL,45524995952,711328061,11114500,18.1),(135331,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135331,37.78,0.33,360,64080,70,NULL,NULL,'2MASX J16061900+2915378',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.579167,29.26047,0.077,NULL,59736977082,933390266,14584222,17.6),(135332,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135332,35.74,0.25,141,64081,74.4,NULL,NULL,'CGCG 108-142',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000063,NULL,'14.20',0.7,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.581375,16.43142,0.085,NULL,56572026260,883937910,13811529,14.2),(135333,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135333,35.79,0.18,144,64081,70,NULL,NULL,'CGCG 108-142',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135334,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135334,36.36,0.46,187,64082,70,NULL,NULL,'2MASX J16061981+2250522',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000176,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.582583,22.84775,0.165,NULL,59394981595,928046587,14500727,17.2),(135335,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135335,36.14,0.05,169,64083,70,NULL,NULL,'2MASX J16062008+1843542',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,241.583875,18.73167,0.045,NULL,56518447316,883100739,13798449,16.1),(135336,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135336,37.01,0.46,253,64084,70,NULL,NULL,'2MASX J16062102+5056124',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.5877083,50.93681,NULL,NULL,59706566028,932915094,14576798,17.5),(135337,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135337,33.62,0.48,52.9,64085,70,NULL,NULL,'ESO 068-IG 016 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000117,NULL,'13.2R',0.9,'(R\'_1)SB(r)0/a',NULL,NULL,NULL,NULL,1,241.5884583,-67.72336,0.413,NULL,44985516194,702898690,10982792,13.2),(135338,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135338,36.87,0.46,236,64086,70,NULL,NULL,'2MASX J16062214+2821018',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.592417,28.35047,0.073,NULL,59867420123,935428439,14616069,16.7),(135339,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135339,35.31,0.29,115,64087,70,NULL,NULL,'GIN 493',NULL,'2001MNRAS.321..277C',2001,1,0.4,NULL,'G',0.00008,NULL,'16.8g',0.29,'E/S0',NULL,NULL,NULL,NULL,1,241.5962917,24.22353,0.169,NULL,59391653574,927994587,14499915,16.8),(135340,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135340,36.65,0.46,213,64087,70,NULL,NULL,'GIN 493',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135341,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135341,36.98,0.13,249,64088,70,NULL,NULL,'2MASX J16062399+3324534',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.2g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,241.600041667,33.41469,0.037,NULL,59784826437,934137913,14595904,16.2),(135342,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135342,37.47,0.46,312,64089,70,NULL,NULL,'SDSS J160624.62+271223.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.602583,27.2065,0.105,NULL,59862238681,935347479,14614804,18.2),(135343,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135343,35.61,0.25,132,64090,74.4,NULL,NULL,'UGC 10201 NED01',NULL,'2013AJ....146...86T',2013,1,1.3,'Component \'a)\' in UGC notes.','G',0.000067,NULL,'14.3',1.3,'E+0','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.606083333,15.68581,0.061,NULL,56571633937,883931780,13811434,14.3),(135344,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135344,35.79,0.18,144,64090,70,NULL,NULL,'UGC 10201 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135345,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135345,36.27,0.4,180,64090,NULL,NULL,'mean','UGC 10201 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135346,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135346,36.44,0.45,194,64090,NULL,NULL,'K','UGC 10201 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135347,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135347,35.63,0.25,134,64091,74.4,NULL,NULL,'UGC 10201 NED02',NULL,'2013AJ....146...86T',2013,1,0.59,'Component \'b)\' in UGC notes.','G',0.000077,NULL,'15.2g',0.53,'E','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.6075,15.69381,0.061,NULL,56571634007,883931781,13811434,15.2),(135348,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135348,35.79,0.18,144,64091,70,NULL,NULL,'UGC 10201 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135349,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135349,38.41,0.46,481,64092,70,NULL,NULL,'SDSS J160625.83+495928.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.607667,49.99131,NULL,NULL,59705998147,932906221,14576659,18.3),(135350,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135350,36.14,0.05,169,64093,70,NULL,NULL,'2MASX J16062600+1633361',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.608375,16.55992,0.085,NULL,56572047396,883938240,13811535,17.5),(135351,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135351,35.76,0.23,142,64094,70,NULL,NULL,'2MASX J16062684+1420571',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.611875,14.34925,0.061,NULL,56550675991,883604312,13806317,16.2),(135352,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS11zu','N',135352,41.31,0.16,1340,64095,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zu HOST',0.3601,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135353,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135353,37.78,0.33,360,64096,70,NULL,NULL,'2MASX J16062848+2917238',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.618667,29.28994,0.081,NULL,59736944054,933389750,14584214,17.7),(135354,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135354,36.01,0.16,159,64097,70,NULL,NULL,'2MASX J16062886+2354148',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00005,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,241.62025,23.90417,0.165,NULL,59391713537,927995524,14499930,16.9),(135355,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135355,38.05,0.33,408,64098,70,NULL,NULL,'2MASX J16063203+3150243',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.633541667,31.84014,0.057,NULL,59781860399,934091568,14595180,18.2),(135356,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135356,35.59,0.25,131,64099,74.4,NULL,NULL,'IC 1193',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.0001,NULL,'15.4g',0.53,'SAB(s)0+       AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.634166667,17.71386,0.065,NULL,56561352106,883771126,13808923,15.4),(135357,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135357,35.77,0.25,143,64099,70,NULL,NULL,'IC 1193',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135358,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135358,36.14,0.05,169,64099,70,NULL,NULL,'IC 1193',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135359,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135359,38.05,0.33,408,64100,70,NULL,NULL,'2MASX J16063273+3151013',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.636417,31.85042,0.057,NULL,59781858661,934091541,14595180,18.1),(135360,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135360,36.09,0.36,166,64101,NULL,NULL,'Malmquist cor.','IC 1192',NULL,'2009ApJS..182..474S',2009,1,0.89,NULL,'G',0.000043,NULL,'15.7g',0.31,'Sb             AGN','in a triple',NULL,NULL,NULL,1,241.638041667,17.77564,0.065,NULL,56561339329,883770927,13808920,15.7),(135361,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135361,36.52,0.3,202,64101,NULL,NULL,NULL,'IC 1192',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135362,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135362,36.56,0.2,205,64101,74.4,NULL,NULL,'IC 1192',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135363,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135363,37.33,0.46,293,64102,70,NULL,NULL,'2MASX J16063440+1717501',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00015,NULL,'16.1g',0.34,'S0','Group member',NULL,NULL,NULL,1,241.643333,17.29725,0.049,NULL,56569177162,883893393,13810834,16.1),(135364,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135364,36.94,0.46,245,64103,70,NULL,NULL,'2MASX J16063496+4903289',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00007,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.645625,49.058,NULL,NULL,59704642171,932885033,14576328,17.2),(135365,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135365,35.63,0.79,134,64104,70,NULL,NULL,'2MASX J16063542-0111475',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000107,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,241.647583333,-1.19653,0.473,NULL,45525518975,711336233,11114628,16.1),(135366,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135366,37.93,0.46,385,64105,70,NULL,NULL,'2MASX J16063593+2125162',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.6497917,21.42125,0.193,NULL,56507669601,882932337,13795817,17.6),(135367,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135367,36.14,0.05,169,64106,70,NULL,NULL,'SDSS J160636.32+174747.2',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.26,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.651333,17.79647,0.073,NULL,56561468661,883772947,13808952,16.8),(135368,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135368,36.1,0.46,166,64107,70,NULL,NULL,'2MASX J16063636+1656531',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000182,NULL,'16.1g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.651375,16.94822,0.053,NULL,56569119991,883892499,13810820,16.1),(135369,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135369,37.23,0.46,279,64108,70,NULL,NULL,'2MASX J16063645+2306112',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00014,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.651875,23.10311,0.153,NULL,59394859076,928044673,14500698,18.2),(135370,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135370,38.23,0.46,442,64109,70,NULL,NULL,'2MASX J16063826+1438531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.6595417,14.64814,0.061,NULL,56557200959,883706264,13807910,18.1),(135371,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135371,37.47,0.46,311,64110,70,NULL,NULL,'2MASX J16063894+1658401',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.662375,16.97781,0.053,NULL,56569334237,883895847,13810872,17.4),(135372,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135372,35.59,0.25,131,64111,74.4,NULL,NULL,'IC 1194',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000077,NULL,'15.0g',0.47,'SA(s)0+ pec    AGN','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.6639583,17.76119,0.065,NULL,56561350466,883771101,13808923,15),(135373,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135373,35.77,0.25,143,64111,70,NULL,NULL,'IC 1194',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135374,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135374,36.14,0.05,169,64111,70,NULL,NULL,'IC 1194',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135375,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135375,35.87,0.43,150,64112,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10205',NULL,'2014MNRAS.444..527S',2014,1,1.56,NULL,'G',0.000047,NULL,'13.9g',0.83,'Sa','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,241.667417,30.09908,0.053,NULL,59739199953,933424999,14584765,13.9),(135376,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1963Q',NULL,135376,35.22,0.29,111,64113,NULL,NULL,'Avg. of 8 SN host galaxies','IC 1195',NULL,'1985ApJ...297...23D',1985,1,0.63,NULL,'G',0.000033,NULL,'15.2g',0.43,'SB(r)bc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.670333,17.19181,0.049,NULL,56569205609,883893837,13810841,15.2),(135377,'Sosies','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135377,35.27,0.15,113,64113,NULL,NULL,'Avg. of 7 galaxies','IC 1195',NULL,'1985ApJ...297...23D',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135378,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135378,37.81,0.46,365,64114,70,NULL,NULL,'2MASX J16064101+2316162',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.6707917,23.27111,0.153,NULL,59394872736,928044886,14500701,17.8),(135379,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135379,31.55,NULL,20.4,64115,72,NULL,NULL,'CGCG 051-043',NULL,'2014Ap.....57..457K',2014,1,0.63,NULL,'G',0.00008,NULL,'15.2g',0.45,NULL,NULL,NULL,NULL,NULL,1,241.670833,6.58094,0.169,NULL,56460566183,882196346,13784317,15.2),(135380,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135380,37.14,0.46,268,64116,70,NULL,NULL,'2MASX J16064106+4505022',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.671,45.08408,0.021,NULL,59803361509,934427523,14600430,17),(135381,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135381,38.01,0.46,400,64117,70,NULL,NULL,'2MASX J16064174-0019135',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000123,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.673917,-0.32042,0.409,NULL,45525199607,711331243,11114550,17.7),(135382,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135382,36.14,0.05,169,64118,70,NULL,NULL,'2MASX J16064241+1540361',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000184,NULL,'16.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.6767917,15.67675,0.061,NULL,56571638461,883931850,13811435,16.7),(135383,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135383,35.98,0.33,157,64119,NULL,NULL,'Malmquist cor.','AGC 261203',NULL,'2009ApJS..182..474S',2009,1,0.69,NULL,'G',0.00003,NULL,'14.58',NULL,'Sa',NULL,NULL,NULL,NULL,1,241.677625,15.59283,0.061,NULL,56570759580,883918118,13811220,14.58),(135384,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135384,35.99,0.33,158,64119,NULL,NULL,NULL,'AGC 261203',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135385,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135385,36.03,0.2,161,64119,74.4,NULL,NULL,'AGC 261203',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135386,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135386,37.84,0.46,371,64120,70,NULL,NULL,'2MASX J16064261+2425008',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000217,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.677583,24.41683,0.173,NULL,59861862414,935341600,14614712,17),(135387,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135387,37.52,0.46,320,64121,70,NULL,NULL,'SDSS J160642.94+095746.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.678916667,9.963,0.149,NULL,56589296729,884207761,13815746,18.4),(135388,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135388,38.23,0.33,442,64122,70,NULL,NULL,'2MASX J16064357+2855068',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.681625,28.91847,0.073,NULL,59736512007,933383000,14584109,18.4),(135389,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135389,34.97,0.5,98.8,64123,70,NULL,NULL,'ESO 584- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00005,NULL,'14.1B',1.1,'SB(s)0^0^: pec',NULL,NULL,NULL,NULL,1,241.682541667,-18.21328,0.817,NULL,45438000689,709968760,11093261,14.1),(135390,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135390,35.13,0.4,106,64123,NULL,NULL,'mean','ESO 584- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135391,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135391,35.84,0.45,148,64123,NULL,NULL,'K','ESO 584- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135392,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135392,37.85,0.46,371,64124,70,NULL,NULL,'SDSS J160643.89+001545.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000096,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,241.682917,0.26253,0.381,NULL,56476544122,882446001,13788218,18.8),(135393,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135393,36.08,0.4,165,64125,NULL,NULL,'Malmquist cor.','SDSS J160644.61+181443.9',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.00003,NULL,'17.66',0.12,'Sc',NULL,NULL,NULL,NULL,1,241.685875,18.24553,0.057,NULL,56516209520,883065773,13797902,17.66),(135394,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135394,36.11,0.39,167,64125,NULL,NULL,NULL,'SDSS J160644.61+181443.9',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135395,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135395,36.15,0.2,170,64125,74.4,NULL,NULL,'SDSS J160644.61+181443.9',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135396,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135396,34.26,0.2,71.1,64126,74.4,NULL,NULL,'CGCG 079-047',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000093,NULL,'15.2',0.2,NULL,NULL,NULL,NULL,NULL,1,241.687667,11.88806,0.145,NULL,56580007764,884062621,13813478,15.2),(135397,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135397,38.61,0.33,527,64127,70,NULL,NULL,'SDSS J160645.15+270034.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.688167,27.00964,0.105,NULL,59863140982,935361577,14615024,18.5),(135398,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135398,38.61,0.33,527,64128,70,NULL,NULL,'2MASX J16064546+2656437',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000128,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.689375,26.94539,0.097,NULL,59863149582,935361712,14615026,18.2),(135399,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135399,37.64,0.46,337,64129,70,NULL,NULL,'SDSS J160645.84+271039.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.691,27.17767,0.109,NULL,59862352647,935349260,14614832,18.5),(135400,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135400,37.56,0.46,325,64130,70,NULL,NULL,'SDSS J160646.15+240959.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.692333,24.16658,0.169,NULL,59391835546,927997430,14499959,18.7),(135401,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135401,35.76,0.23,142,64131,70,NULL,NULL,'2MASX J16064638+1410221',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,241.693375,14.17286,0.069,NULL,56550711818,883604872,13806326,16.2),(135402,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135402,36.14,0.05,169,64132,70,NULL,NULL,'SDSS J160647.61+174723.7',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.23,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.698417,17.78994,0.073,NULL,56561474014,883773031,13808953,16.7),(135403,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135403,35.38,0.73,119,64133,NULL,NULL,NULL,'2MFGC 12939',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000027,NULL,'16.4g',0.2,'S/I','Group member',NULL,NULL,NULL,1,241.700875,17.64767,0.065,NULL,56561368546,883771383,13808927,16.4),(135404,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135404,35.42,0.2,121,64133,74.4,NULL,NULL,'2MFGC 12939',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135405,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135405,35.45,0.7,123,64133,NULL,NULL,'Malmquist cor.','2MFGC 12939',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135406,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135406,35.68,0.49,137,64133,75,NULL,'IR','2MFGC 12939',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135407,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10jz','N',135407,42.52,0.21,2060,64134,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jz HOST',0.5501,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135408,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135408,38.05,0.46,407,64135,70,NULL,NULL,'2MASX J16065039+3822333',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.709875,38.37592,0.017,NULL,59770114109,933908032,14592313,17.8),(135409,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135409,37.67,0.46,342,64136,70,NULL,NULL,'2MASX J16065159+4021193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.71475,40.35553,0.013,NULL,59809038274,934516223,14601815,17.6),(135410,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135410,37,0.46,251,64137,70,NULL,NULL,'2MASX J16065259+1108483',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.719125,11.14683,0.153,NULL,56579696276,884057754,13813402,17.8),(135411,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135411,36.14,0.05,169,64138,70,NULL,NULL,'2MASX J16065292+1813222',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'15.8g',0.38,'S07','Group member',NULL,NULL,NULL,1,241.7204583,18.22289,0.057,NULL,56516208286,883065754,13797902,15.8),(135412,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135412,34.06,0.46,65,64139,70,NULL,NULL,'UGC 10203',NULL,'2015arXiv151105856S',2015,1,0.94,NULL,'G',0.000165,NULL,'14.9g',0.34,'S0',NULL,NULL,NULL,NULL,1,241.723333,3.7935,0.257,NULL,56490892691,882670198,13791721,14.9),(135413,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135413,36.98,0.13,249,64140,70,NULL,NULL,'2MASX J16065377+3310374',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000192,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,241.724167,33.17694,0.033,NULL,59784851373,934138302,14595910,16),(135414,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135414,36.91,0.46,240,64141,70,NULL,NULL,'2MASX J16065388+2546267',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.7244583,25.77403,0.153,NULL,59864862391,935388474,14615444,17.4),(135415,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135415,35.95,0.46,155,64142,70,NULL,NULL,'2MASX J16065389+0327246',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.0g',0.41,NULL,NULL,NULL,NULL,NULL,1,241.724625,3.45675,0.253,NULL,56503716551,882870571,13794852,16),(135416,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135416,38.09,0.46,414,64143,70,NULL,NULL,'2MASX J16065450+1407171',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,241.727083,14.12139,0.069,NULL,56550738050,883605282,13806332,NULL),(135417,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135417,37.06,0.46,258,64144,70,NULL,NULL,'2MASX J16065451+1356391',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.72725,13.94431,0.073,NULL,56550541481,883602210,13806284,17),(135418,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135418,37.55,0.46,323,64145,70,NULL,NULL,'2MASX J16065471+4118373',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.727833,41.31036,0,NULL,59810730537,934542664,14602229,18),(135419,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135419,37.71,0.46,348,64146,70,NULL,NULL,'2MASX J16065619+2327362',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.734125,23.46,0.153,NULL,59392004023,928000062,14500000,18.2),(135420,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135420,35.8,0.49,144,64147,75,NULL,'IR','MCG +10-23-020',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'16',0.09,'Sd',NULL,NULL,NULL,NULL,1,241.7369583,62.53742,0.017,NULL,57613080265,900204379,14065693,16),(135421,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135421,36.19,NULL,173,64147,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +10-23-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135422,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135422,36.22,NULL,175,64147,NULL,NULL,'Dipole + Quadrupole','MCG +10-23-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135423,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135423,36.22,NULL,176,64147,NULL,NULL,NULL,'MCG +10-23-020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135424,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135424,36.24,NULL,177,64147,NULL,NULL,'Dipole','MCG +10-23-020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135425,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135425,35.61,0.48,132,64148,NULL,NULL,NULL,'2MASX J16065705+1751251',NULL,'2009ApJS..182..474S',2009,1,0.67,NULL,'G',0.000027,NULL,'16.7g',0.19,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.7375,17.85692,0.073,NULL,56561472648,883773010,13808953,16.7),(135426,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135426,35.65,0.2,135,64148,74.4,NULL,NULL,'2MASX J16065705+1751251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135427,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135427,35.88,0.42,150,64148,NULL,NULL,'Malmquist cor.','2MASX J16065705+1751251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135428,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135428,39.05,0.46,646,64149,70,NULL,NULL,'SDSS J160658.06+300012.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.7419583,30.00336,0.073,NULL,59739058171,933422783,14584730,18.3),(135429,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135429,35.62,0.25,133,64150,74.4,NULL,NULL,'GIN 526',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000107,NULL,'15.7g',0.45,'S',NULL,NULL,NULL,NULL,1,241.7427083,16.16225,0.073,NULL,56571160245,883924378,13811318,15.7),(135430,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135430,35.79,0.18,144,64150,70,NULL,NULL,'GIN 526',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135431,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135431,36.14,0.05,169,64150,70,NULL,NULL,'GIN 526',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135432,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135432,35.8,0.33,144,64151,NULL,NULL,NULL,'2MASX J16070160+1801205',NULL,'2009ApJS..182..474S',2009,1,0.81,NULL,'G',0.00002,NULL,'15.7g',0.36,'SB(rs)a','Group member',NULL,NULL,NULL,1,241.756667,18.0225,0.081,NULL,56561282574,883770040,13808906,15.7),(135433,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135433,35.83,0.33,147,64151,NULL,NULL,'Malmquist cor.','2MASX J16070160+1801205',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135434,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135434,36,0.2,158,64151,74.4,NULL,NULL,'2MASX J16070160+1801205',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135435,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135435,37.46,0.46,311,64152,70,NULL,NULL,'SDSS J160701.66+175106.6',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.9g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.756958333,17.85186,0.073,NULL,56561490261,883773285,13808957,16.9),(135436,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135436,37.72,0.33,350,64153,70,NULL,NULL,'2MASX J16070169+2650528',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000133,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.757167,26.848,0.097,NULL,59863175558,935362118,14615033,18.2),(135437,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135437,37.37,0.46,298,64154,70,NULL,NULL,'2MASX J16070242+2207276',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000181,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.7599583,22.12431,0.161,NULL,56507340093,882927188,13795737,18),(135438,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135438,38,0.46,398,64155,70,NULL,NULL,'SDSS J160703.07+153621.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.762833,15.60589,0.061,NULL,56570770224,883918284,13811223,18.3),(135439,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135439,36.22,0.2,175,64156,74.4,NULL,NULL,'KUG 1604+157',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00003,NULL,'15.12',0.5,'Sc','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,241.76325,15.59317,0.061,NULL,56570770165,883918283,13811223,15.12),(135440,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135440,37.27,0.46,285,64157,70,NULL,NULL,'2MASX J16070321+3645184',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00012,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,241.7632917,36.75522,0.025,NULL,59776742388,934011599,14593931,16.7),(135441,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135441,37.59,0.46,330,64158,70,NULL,NULL,'2MASX J16070327+3017004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.763666667,30.2835,0.061,NULL,59739150532,933424227,14584753,17.5),(135442,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135442,35.47,0.58,124,64159,70,NULL,NULL,'2MASX J16070369-0149288',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000033,NULL,'15.9',0.4,NULL,NULL,NULL,NULL,NULL,1,241.765333,-1.82472,0.529,NULL,45560146789,711877293,11123082,15.9),(135443,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135443,37.12,0.46,266,64160,70,NULL,NULL,'2MASX J16070406+1218101',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.767,12.30297,0.141,NULL,56549303604,883582868,13805982,16.3),(135444,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135444,36.98,0.13,249,64161,70,NULL,NULL,'2MASX J16070476+3309464',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.769833333,33.16294,0.033,NULL,59784851880,934138310,14595911,17.3),(135445,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135445,36.97,0.46,248,64162,70,NULL,NULL,'2MASX J16070543+2606478',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.772666667,26.11328,0.133,NULL,59864899257,935389050,14615453,17.8),(135446,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135446,38.02,0.46,402,64163,70,NULL,NULL,'2MASX J16070570+3821324',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.773666667,38.35903,0.017,NULL,59770085840,933907591,14592306,17),(135447,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135447,36.14,0.05,169,64164,70,NULL,NULL,'SDSS J160705.92+175057.3',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.7g',0.38,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.774708333,17.84925,0.073,NULL,56561491908,883773311,13808957,15.7),(135448,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135448,36.38,0.46,189,64165,70,NULL,NULL,'2MASX J16070687+2758438',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.778625,27.97878,0.085,NULL,59875789810,935559215,14618112,17.2),(135449,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135449,33.85,0.8,58.8,64166,75,NULL,'HMCL, I','UGC 10211',NULL,'1997ApJS..109..333W',1997,1,1.29,NULL,'G',0.000033,NULL,'14.3g',0.44,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,241.77925,22.06056,0.161,NULL,56507352449,882927382,13795740,14.3),(135450,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135450,33.78,0.4,57.1,64166,75,NULL,'HMCL, I, raw','UGC 10211',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135451,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135451,33.84,0.47,58.7,64166,NULL,NULL,'H','UGC 10211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135452,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135452,33.88,0.45,59.7,64166,NULL,NULL,'K','UGC 10211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135453,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135453,33.94,0.4,61.4,64166,75,NULL,'HMCL, I, inv','UGC 10211',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135454,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135454,33.95,0.4,61.8,64166,75,NULL,'HMCL, I, cor','UGC 10211',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135455,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135455,33.96,0.2,61.9,64166,74.4,NULL,NULL,'UGC 10211',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135456,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135456,33.96,0.46,62,64166,NULL,NULL,'J','UGC 10211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135457,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135457,34.01,0.4,63.5,64166,NULL,NULL,'mean','UGC 10211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135458,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135458,38.48,0.46,497,64167,70,NULL,NULL,'2MASX J16070770+3644234',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.782167,36.73986,0.025,NULL,59776742123,934011595,14593931,17.3),(135459,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135459,35.59,0.25,131,64168,74.4,NULL,NULL,'MCG +03-41-132',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00008,NULL,'14.20',0.5,'E/S0',NULL,NULL,NULL,NULL,1,241.791166667,18.64128,0.057,NULL,56518354158,883099283,13798426,14.2),(135460,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135460,35.77,0.25,143,64168,70,NULL,NULL,'MCG +03-41-132',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135461,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135461,36.14,0.05,169,64168,70,NULL,NULL,'MCG +03-41-132',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135462,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135462,36.14,0.05,169,64169,70,NULL,NULL,'2MASX J16071062+1839356',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.79425,18.65981,0.057,NULL,56518354901,883099295,13798426,16.5),(135463,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135463,37.14,0.33,268,64170,70,NULL,NULL,'2MASX J16071113+3403538',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.7964583,34.06508,0.013,NULL,59766444611,933850697,14591417,17),(135464,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135464,36.14,0.05,169,64171,70,NULL,NULL,'2MASX J16071182+1836366',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.799333,18.61011,0.057,NULL,56518347771,883099183,13798424,16),(135465,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135465,35.87,0.46,149,64172,70,NULL,NULL,'2MASX J16071198+2738558',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000192,NULL,'15.6g',0.41,'Sa',NULL,NULL,NULL,NULL,1,241.799916667,27.64894,0.101,NULL,59862208176,935347002,14614796,15.6),(135466,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135466,37.47,0.46,312,64173,70,NULL,NULL,'2MASX J16071283+1032074',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.8034583,10.53531,0.169,NULL,56588979071,884202797,13815668,17.5),(135467,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135467,32.45,0.24,30.6,64174,74.2,NULL,'SALT 2','NGC 6063',0.0095,'2010ApJ...716..712A',2010,1,1.72,NULL,'G',0.000017,NULL,'13.7g',0.84,'Scd:',NULL,NULL,NULL,NULL,1,241.804125,7.979,0.125,NULL,56584941038,884139703,13814682,13.7),(135468,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135468,32.71,0.25,34.5,64174,72,NULL,NULL,'NGC 6063',0.0095,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135469,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135469,33.03,0.08,40.4,64174,74.4,NULL,NULL,'NGC 6063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135470,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135470,33.09,0.03,41.1,64174,72,NULL,NULL,'NGC 6063',0.0095,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135471,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135471,33.1,0.17,41.7,64174,70.8,NULL,NULL,'NGC 6063',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135472,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135472,33.17,0.23,42.6,64174,70,NULL,'SALT','NGC 6063',0.0095,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135473,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135473,33.33,0.08,45.6,64174,65,NULL,'MLCS2k2','NGC 6063',0.0095,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135474,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135474,33.53,0.03,50.4,64174,70,NULL,'SALT 2','NGC 6063',0.0095,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135475,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1999ac',NULL,135475,33.53,0.3,50.8,64174,60,NULL,NULL,'NGC 6063',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135476,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135476,33.08,0.8,41.3,64174,75,NULL,'CF, r','NGC 6063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135477,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135477,32.29,0.69,28.7,64174,100,NULL,'mid-IR','NGC 6063',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135478,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135478,32.87,0.4,37.5,64174,NULL,NULL,NULL,'NGC 6063',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135479,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135479,33.03,0.08,40.4,64174,74.4,NULL,NULL,'NGC 6063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135480,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135480,33.15,0.4,42.7,64174,75,NULL,'HOSTS SN 1999ac','NGC 6063',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135481,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135481,33.16,0.4,42.9,64174,75,NULL,'HOSTS SN 1999ac','NGC 6063',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135482,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135482,33.27,0.42,45.1,64174,NULL,18.48,'3.6 micron','NGC 6063',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135483,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135483,33.29,0.43,45.5,64174,75,NULL,'3.6 micron, color corrected','NGC 6063',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135484,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135484,33.34,0.43,46.5,64174,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6063',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135485,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135485,33.35,0.4,46.9,64174,NULL,NULL,'mean','NGC 6063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135486,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135486,33.35,0.66,46.9,64174,NULL,NULL,NULL,'NGC 6063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135487,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135487,33.51,0.61,50.3,64174,NULL,NULL,'Malmquist cor.','NGC 6063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135488,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135488,33.51,0.38,50.3,64174,75,NULL,'CF, r, raw','NGC 6063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135489,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135489,33.54,0.47,51.1,64174,NULL,NULL,'H','NGC 6063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135490,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135490,33.6,0.46,52.6,64174,NULL,NULL,'J','NGC 6063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135491,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135491,33.61,0.38,52.8,64174,75,NULL,'CF, r, inv','NGC 6063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135492,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135492,33.72,0.45,55.4,64174,NULL,NULL,'K','NGC 6063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135493,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135493,33.83,0.38,58.5,64174,75,NULL,'CF, r, cor','NGC 6063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135494,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135494,35.98,0.46,157,64175,70,NULL,NULL,'2MASX J16071357-0004436',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000116,NULL,'15.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,241.8065,-0.07878,0.401,NULL,45524991638,711327994,11114499,15.7),(135495,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135495,36.75,0.46,223,64176,70,NULL,NULL,'2MASX J16071398+1951296',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,241.808333,19.85828,0.073,NULL,56521742103,883152220,13799253,16.6),(135496,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135496,36.2,0.46,173,64177,70,NULL,NULL,'2MASX J16071688+2616278',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'16.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.820208333,26.27442,0.133,NULL,59862871086,935357360,14614958,16.4),(135497,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135497,36.14,0.05,169,64178,70,NULL,NULL,'2MASX J16071693+1741451',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00015,NULL,'16.2g',0.19,'S0','Group member',NULL,NULL,NULL,1,241.820416667,17.696,0.065,NULL,56561332504,883770820,13808919,16.2),(135498,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135498,37.61,0.33,333,64179,70,NULL,NULL,'2MASX J16071795+3654374',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.824875,36.91036,0.021,NULL,59776756729,934011823,14593934,17.6),(135499,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135499,37.72,0.33,350,64180,70,NULL,NULL,'2MASX J16071839+2649173',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000141,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.82675,26.82139,0.097,NULL,59863052011,935360187,14615002,17.6),(135500,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135500,35.64,0.46,134,64181,70,NULL,NULL,'2MASX J16071867+0710514',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'16.4g',0.32,'AGN+SF',NULL,NULL,NULL,NULL,1,241.827875,7.18092,0.165,NULL,56460073065,882188641,13784197,16.4),(135501,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135501,35.61,0.25,132,64182,74.4,NULL,NULL,'GIN 515',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.00008,NULL,'15.9g',0.49,'S',NULL,NULL,NULL,NULL,1,241.831375,15.84994,0.061,NULL,56571608307,883931379,13811427,15.9),(135502,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135502,35.79,0.18,144,64182,70,NULL,NULL,'GIN 515',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135503,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135503,37.61,0.33,333,64183,70,NULL,NULL,'2MASX J16072072+3701274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.8362083,37.02403,0.013,NULL,59774608234,933978253,14593410,17.6),(135504,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135504,35.04,0.2,102,64184,74.4,NULL,NULL,'CGCG 079-049',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.0002,NULL,'15.6',0.1,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,241.841375,10.36614,0.149,NULL,56588966250,884202597,13815665,15.6),(135505,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135505,38.22,0.46,440,64185,70,NULL,NULL,'2MASX J16072265+2353006',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.8447083,23.88344,0.165,NULL,59391805468,927996960,14499952,17.8),(135506,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135506,35.76,0.23,142,64186,70,NULL,NULL,'NGC 6065',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00014,NULL,'15.0',0.6,'S0','Group member',NULL,NULL,NULL,1,241.845666667,13.88792,0.073,NULL,56550407438,883600116,13806251,15),(135507,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135507,36.14,0.05,169,64187,70,NULL,NULL,'2MASX J16072510+1814396',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.6g',0.31,'E0','Group member',NULL,NULL,NULL,1,241.8547083,18.24425,0.057,NULL,56516166710,883065104,13797892,16.6),(135508,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135508,37.25,0.46,282,64188,70,NULL,NULL,'2MASX J16072563+3051339',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.857,30.85936,0.061,NULL,59738762377,933418162,14584658,17.7),(135509,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135509,35.3,0.2,115,64189,74.4,NULL,NULL,'UGC 10215',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000011,NULL,'15.59',0.4,'Sbc?','Supercluster foreground object',NULL,NULL,NULL,1,241.8572083,19.54964,0.053,NULL,56518911895,883107998,13798562,15.59),(135510,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135510,38.36,0.46,471,64190,70,NULL,NULL,'2MASX J16072609+4401366',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.85875,44.02689,0,NULL,59806346134,934474158,14601158,17.7),(135511,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135511,36.56,0.21,205,64191,70,NULL,NULL,'2MASX J16072651+2829483',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.860458333,28.49672,0.081,NULL,59736545542,933383524,14584117,17.3),(135512,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135512,37.14,0.33,268,64192,70,NULL,NULL,'2MASX J16072650+3404309',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.8605,34.07517,0.013,NULL,59766319417,933848740,14591386,17),(135513,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135513,36.55,0.46,204,64193,70,NULL,NULL,'2MASX J16072764+4438426',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000191,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,241.865333,44.64517,0.021,NULL,59802740251,934417816,14600278,15.7),(135514,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135514,36.97,0.33,248,64194,70,NULL,NULL,'2MASX J16072860+2731503',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000133,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,241.8692083,27.53081,0.113,NULL,59862374947,935349608,14614837,15.5),(135515,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135515,38.35,0.46,469,64195,70,NULL,NULL,'2MASX J16072877+2348166',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.8700417,23.8045,0.165,NULL,59391702455,927995350,14499927,17),(135516,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135516,37.34,0.46,293,64196,70,NULL,NULL,'SDSS J160729.46+375439.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.87275,37.91094,0,NULL,59770805701,933918839,14592481,18.3),(135517,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135517,37.74,0.21,353,64197,70,NULL,NULL,'SDSS J160730.64+231418.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,241.8777083,23.23842,0.153,NULL,59392027353,928000427,14500006,18.4),(135518,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135518,36.56,0.21,205,64198,70,NULL,NULL,'2MASX J16073106+2821164',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,241.879417,28.35458,0.073,NULL,59736390615,933381103,14584079,17.2),(135519,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135519,37.74,0.21,353,64199,70,NULL,NULL,'2MASX J16073134+2313184',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,241.880583,23.22181,0.153,NULL,59392025856,928000404,14500006,16.6),(135520,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135520,36.85,0.46,235,64200,70,NULL,NULL,'2MASX J16073142+1731387',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000043,NULL,'17.9g',0.13,'Sy',NULL,NULL,NULL,NULL,1,241.880875,17.52736,0.065,NULL,56562218313,883784661,13809135,17.9),(135521,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135521,37.76,0.46,357,64201,70,NULL,NULL,'2MASX J16073251+1433257',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,241.885583333,14.55706,0.061,NULL,56549913562,883592399,13806131,17.8),(135522,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135522,37.35,0.46,295,64202,70,NULL,NULL,'2MASX J16073358+1747237',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.889833333,17.78992,0.073,NULL,56561437182,883772455,13808944,17.9),(135523,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135523,37.74,0.21,353,64203,70,NULL,NULL,'2MASX J16073368+2305064',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.890167,23.08503,0.141,NULL,59394850924,928044545,14500696,17.8),(135524,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135524,37.74,0.21,353,64204,70,NULL,NULL,'2MASX J16073402+2312344',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.891833333,23.20969,0.153,NULL,59392032483,928000507,14500007,17.8),(135525,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135525,37.71,0.46,349,64205,70,NULL,NULL,'2MASX J16073423+2656194',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.892583,26.93878,0.105,NULL,59863059175,935360299,14615004,17.6),(135526,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135526,37,0.46,251,64206,70,NULL,NULL,'SDSS J160734.28+040046.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.6g',0.18,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.892875,4.01281,0.229,NULL,56490880617,882670009,13791718,17.6),(135527,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135527,37.55,0.46,323,64207,70,NULL,NULL,'2MASX J16073442+0521450',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.8934583,5.36236,0.189,NULL,56492420957,882694077,13792094,17.5),(135528,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135528,35.76,0.23,142,64208,70,NULL,NULL,'NGC 6066',NULL,'2015arXiv151105856S',2015,1,0.99,NULL,'G',0.000153,NULL,'15.2',0.75,NULL,'Group member',NULL,NULL,NULL,1,241.8972917,13.94372,0.093,NULL,56550394566,883599915,13806248,15.2),(135529,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135529,37.74,0.21,353,64209,70,NULL,NULL,'2MASX J16073534+2308494',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.897333,23.14722,0.153,NULL,59392019535,928000305,14500004,17.8),(135530,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135530,36.98,0.13,249,64210,70,NULL,NULL,'2MASX J16073537+3301179',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000202,NULL,'16.1g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,241.897333,33.02169,0.037,NULL,59785067713,934141683,14595963,16.1),(135531,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135531,39.06,0.46,647,64211,70,NULL,NULL,'2MASXi J1607369+333400',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000239,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.903833333,33.56658,0.025,NULL,59783826067,934122282,14595660,17.9),(135532,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135532,35.58,0.25,131,64212,74.4,NULL,NULL,'GIN 510',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000073,NULL,'14.47',0.4,'S03','Group member',NULL,NULL,NULL,1,241.9105,18.48011,0.057,NULL,56516373054,883068328,13797942,14.47),(135533,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135533,35.77,0.25,143,64212,70,NULL,NULL,'GIN 510',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135534,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135534,37.56,0.46,326,64213,70,NULL,NULL,'2MASX J16073851+3629567',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000151,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.910417,36.49897,0.029,NULL,59773527542,933961367,14593146,17),(135535,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135535,37.07,0.46,260,64214,70,NULL,NULL,'2MASX J16073867+3507379',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.911083,35.12725,0.025,NULL,59765766667,933840104,14591251,16.6),(135536,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135536,38.54,0.46,509,64215,70,NULL,NULL,'2MASX J16073878+5134526',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.911833,51.58131,0.037,NULL,59698853451,932794585,14574915,17.8),(135537,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135537,38.03,0.46,404,64216,70,NULL,NULL,'2MASX J16073892-0026076',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.9122917,-0.43558,0.445,NULL,45558774944,711855858,11122747,18),(135538,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135538,36.98,0.13,249,64217,70,NULL,NULL,'2MASX J16073943+3303499',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.914333333,33.06383,0.037,NULL,59785063426,934141616,14595962,17.3),(135539,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135539,38.05,0.46,407,64218,70,NULL,NULL,'2MASX J16073964+2721573',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'17.0g',0.31,NULL,NULL,NULL,NULL,NULL,1,241.9150417,27.36594,0.113,NULL,59862307410,935348553,14614821,17),(135540,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135540,35.9,0.33,151,64219,70,NULL,NULL,'2MASX J16073971+3857387',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000087,NULL,'16.1g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,241.915333,38.96078,0.009,NULL,59800526315,934383223,14599737,16.1),(135541,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135541,37.79,0.46,362,64220,70,NULL,NULL,'2MASX J16073976+1511017',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.915583,15.18381,0.053,NULL,56570684143,883916939,13811202,17),(135542,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135542,36.97,0.33,248,64221,70,NULL,NULL,'2MASX J16074033+2731463',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,241.917875,27.52956,0.113,NULL,59862383589,935349743,14614839,18),(135543,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135543,36.98,0.13,249,64222,70,NULL,NULL,'2MASX J16074162+3304512',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000195,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,241.923375,33.08081,0.037,NULL,59785063508,934141617,14595962,15.7),(135544,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135544,35.9,0.33,151,64223,70,NULL,NULL,'NGC 6069',NULL,'2015arXiv151105856S',2015,1,0.88,NULL,'G',0.00009,NULL,'14.6g',0.75,'E0',NULL,NULL,NULL,NULL,1,241.9235,38.93075,0.009,NULL,59800397566,934381211,14599706,14.6),(135545,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135545,37.79,0.46,361,64224,70,NULL,NULL,'2MASX J16074315+3402362',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,241.929875,34.0435,0.013,NULL,59766321343,933848770,14591387,17.1),(135546,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135546,36.14,0.46,169,64225,70,NULL,NULL,'2MASX J16074315+2529333',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,241.929917,25.49256,0.149,NULL,59864962451,935390038,14615469,16.2),(135547,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135547,36.89,0.46,239,64226,70,NULL,NULL,'2MASX J16074379+2344005',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000176,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,241.932375,23.73367,0.165,NULL,59392178658,928002791,14500043,17.2),(135548,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135548,37.78,0.46,360,64227,70,NULL,NULL,'2MASX J16074391+4148227',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.9332083,41.80631,0.025,NULL,59810410653,934537666,14602151,17.3),(135549,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135549,37.13,0.23,266,64228,70,NULL,NULL,'2MASX J16074419+4915006',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000064,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.934167,49.25,NULL,NULL,59704639392,932884990,14576327,17.9),(135550,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135550,37.41,0.46,303,64229,70,NULL,NULL,'2MASX J16074567+3121053',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,241.940375,31.35142,0.065,NULL,59736019172,933375299,14583989,17.5),(135551,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135551,36.77,0.33,226,64230,70,NULL,NULL,'2MASX J16074582+4836246',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000101,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,241.941,48.60692,NULL,NULL,59705288666,932895135,14576486,16),(135552,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135552,37.26,0.46,283,64231,70,NULL,NULL,'2MASX J16074652+5341506',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000108,NULL,'16.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,241.943666667,53.69742,0,NULL,57606394233,900099909,14064061,16.1),(135553,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135553,36.14,0.55,169,64232,70,NULL,NULL,'2MASX J16074757-0242175',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'16.71',NULL,NULL,NULL,NULL,NULL,NULL,1,241.948166667,-2.70481,0.485,NULL,45560539550,711883430,11123178,16.71),(135554,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135554,37.07,0.46,260,64233,70,NULL,NULL,'2MASX J16074840+1310363',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.9517083,13.17681,0.081,NULL,56550909049,883607953,13806374,16.9),(135555,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135555,35.78,0.46,143,64234,70,NULL,NULL,'SDSS J160748.81+123952.6',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'15.9g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.953417,12.66461,0.121,NULL,56549682511,883588789,13806074,15.9),(135556,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135556,36.3,0.46,182,64235,70,NULL,NULL,'2MASX J16074901+1354103',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,241.954125,13.90275,0.093,NULL,56550432136,883600502,13806257,16.7),(135557,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135557,37.59,0.46,329,64236,70,NULL,NULL,'2MASX J16074923+2615123',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.95525,26.25347,0.133,NULL,59862842853,935356919,14614951,17.5),(135558,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135558,36.46,0.46,196,64237,70,NULL,NULL,'2MASX J16075252+1104338',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.96875,11.07617,0.173,NULL,56587896650,884185885,13815404,16.4),(135559,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135559,36.52,0.46,201,64238,70,NULL,NULL,'2MASX J16075254+4232395',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000097,NULL,'16.0g',0.38,'E0','Field galaxy',NULL,NULL,NULL,1,241.969,42.54431,0.013,NULL,59805013451,934453335,14600833,16),(135560,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135560,37.75,0.46,355,64239,70,NULL,NULL,'SDSS J160753.41+525852.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,241.972583333,52.98136,0,NULL,59700449103,932819517,14575304,18.3),(135561,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135561,36.2,0.46,174,64240,70,NULL,NULL,'2MASX J16075367+3106503',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000166,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,241.9734583,31.11397,0.065,NULL,59735952985,933374265,14583972,16.4),(135562,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135562,37.66,0.46,341,64241,70,NULL,NULL,'SDSS J160753.80+214539.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.5g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.974208333,21.76092,0.177,NULL,56507522809,882930043,13795781,18.5),(135563,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135563,37.87,0.46,375,64242,70,NULL,NULL,'2MASX J16075397+5219461',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,241.974666667,52.32933,0.025,NULL,59700305378,932817271,14575269,17.9),(135564,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135564,37.87,0.46,374,64243,70,NULL,NULL,'2MASX J16075510+1847065',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.979625,18.78517,0.057,NULL,56518324050,883098813,13798418,17.7),(135565,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135565,36.95,0.46,246,64244,70,NULL,NULL,'2MASX J16075598+1418503',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,241.98325,14.31403,0.093,NULL,56550614470,883603351,13806302,17),(135566,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135566,35.98,0.46,157,64245,70,NULL,NULL,'2MASX J16075617+4403005',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000174,NULL,'15.9g',0.44,'Sbrst',NULL,NULL,NULL,NULL,1,241.983833,44.05028,0,NULL,59806380840,934474700,14601167,15.9),(135567,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135567,37.99,0.46,397,64246,70,NULL,NULL,'2MASX J16075632+5311032',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000105,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.984583,53.18433,0,NULL,59700066187,932813534,14575211,17.6),(135568,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135568,38.27,0.46,451,64247,70,NULL,NULL,'SDSS J160757.72+193025.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,241.9905,19.50719,0.053,NULL,56519041294,883110020,13798594,18.4),(135569,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135569,37.72,0.27,350,64248,70,NULL,NULL,'2MASX J16075790+4301245',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,241.9912083,43.02361,0.025,NULL,59805777332,934465270,14601019,17.6),(135570,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135570,37.95,0.46,390,64249,70,NULL,NULL,'2MASX J16075802+1534004',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.991667,15.56692,0.057,NULL,56570773771,883918340,13811224,17.6),(135571,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135571,33.37,0.69,47.2,64250,100,NULL,'mid-IR','IC 1196',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000033,NULL,'14.56',0.6,'Sa',NULL,NULL,NULL,NULL,1,241.9932083,10.77964,0.185,NULL,56587833284,884184895,13815388,14.56),(135572,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135572,34.18,0.25,68.5,64250,NULL,NULL,'Malmquist cor.','IC 1196',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135573,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135573,34.2,0.25,69.1,64250,NULL,NULL,NULL,'IC 1196',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135574,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135574,34.4,0.4,75.7,64250,NULL,NULL,'mean','IC 1196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135575,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135575,34.42,0.2,76.6,64250,74.4,NULL,NULL,'IC 1196',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135576,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135576,34.66,0.47,85.4,64250,NULL,NULL,'H','IC 1196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135577,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135577,37.8,0.46,363,64251,70,NULL,NULL,'2MASX J16075875+1358594',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,241.99475,13.98328,0.093,NULL,56550438590,883600602,13806259,16.8),(135578,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135578,37.93,0.46,385,64252,70,NULL,NULL,'2MASX J16075912+1129178',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,241.996375,11.48831,0.169,NULL,56579922091,884061282,13813457,17.9),(135579,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135579,36.57,0.46,206,64253,70,NULL,NULL,'2MASX J16075967+1134518',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,241.99875,11.581,0.169,NULL,56579248188,884050752,13813293,16.4),(135580,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135580,37.6,0.27,331,64254,70,NULL,NULL,'2MASX J16080004+3408464',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.000167,34.14628,0.009,NULL,59766330478,933848913,14591389,17.2),(135581,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135581,38.09,0.27,416,64255,70,NULL,NULL,'2MASX J16080044+3742413',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.001833,37.71136,0,NULL,59770324834,933911325,14592364,17.5),(135582,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135582,36.56,0.21,205,64256,70,NULL,NULL,'2MASX J16080048+2837463',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000163,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.0020417,28.62964,0.085,NULL,59736579102,933384048,14584125,16.5),(135583,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135583,37.87,0.46,376,64257,70,NULL,NULL,'2MASX J16080283+3130384',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000188,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.011833333,31.51067,0.057,NULL,59735829010,933372328,14583942,16.5),(135584,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135584,36.43,0.46,193,64258,70,NULL,NULL,'2MASX J16080349+1831037',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.014583,18.51769,0.057,NULL,56516350829,883067981,13797937,16.7),(135585,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135585,33.73,0.2,55.7,64259,74.4,NULL,NULL,'UGC 10220',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.000224,NULL,'15.7g',0.48,'SBc',NULL,NULL,NULL,NULL,1,242.016625,20.19878,0.077,NULL,56522331097,883161423,13799397,15.7),(135586,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135586,37.65,0.46,340,64260,70,NULL,NULL,'2MASX J16080445+3854263',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.01875,38.9075,0.009,NULL,59800405580,934381337,14599708,17.2),(135587,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135587,37.72,0.27,350,64261,70,NULL,NULL,'2MASX J16080453+4309486',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0001,NULL,'16.1g',0.38,'E0','Field galaxy',NULL,NULL,NULL,1,242.018875,43.16347,0.009,NULL,59805646877,934463232,14600988,16.1),(135588,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135588,36.92,0.46,242,64262,70,NULL,NULL,'SDSS J160805.80+163944.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.4g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.024208333,16.66225,0.081,NULL,56563363376,883802552,13809414,17.4),(135589,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135589,37.96,0.46,391,64263,70,NULL,NULL,'SDSS J160806.54+363032.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.02725,36.50894,0.029,NULL,59773505548,933961024,14593141,18.4),(135590,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135590,37.13,0.23,266,64264,70,NULL,NULL,'2MASX J16080697+4913093',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000074,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.029208333,49.21919,NULL,NULL,59704633107,932884892,14576326,17.7),(135591,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135591,37.72,0.27,350,64265,70,NULL,NULL,'2MASX J16080754+4310476',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.0314583,43.18,0.009,NULL,59805647012,934463234,14600988,17.9),(135592,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135592,37.13,0.23,266,64266,70,NULL,NULL,'2MASX J16080820+4912033',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000113,NULL,'15.8g',0.47,'AGN',NULL,NULL,NULL,NULL,1,242.0340417,49.20097,NULL,NULL,59704634985,932884921,14576326,15.8),(135593,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135593,37.6,0.27,331,64267,70,NULL,NULL,'2MASXi J1608085+340639',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.035417,34.11089,0.013,NULL,59766286630,933848228,14591378,17),(135594,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135594,38.3,0.46,456,64268,70,NULL,NULL,'2MASX J16080894+0855538',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.0372917,8.93153,0.109,NULL,56582697719,884104651,13814135,18),(135595,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135595,36.8,0.46,229,64269,70,NULL,NULL,'2MASX J16080948+1156058',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.0395,11.93506,0.141,NULL,56579151616,884049244,13813269,16.4),(135596,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135596,36.19,0.2,173,64270,74.4,NULL,NULL,'CGCG 108-157',NULL,'2013AJ....146...86T',2013,1,0.82,NULL,'G',0.000021,NULL,'15.4g',0.39,'S..','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,242.045083,16.77278,0.093,NULL,56563386955,883802921,13809420,15.4),(135597,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135597,36.77,0.33,226,64271,70,NULL,NULL,'2MASX J16081088+4836013',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,242.0455,48.60039,NULL,NULL,59705289603,932895150,14576486,16.9),(135598,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135598,37.13,0.23,266,64272,70,NULL,NULL,'2MASX J16081147+4910293',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0001,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,242.0479583,49.17472,NULL,NULL,59704631641,932884869,14576326,15.9),(135599,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135599,37.45,0.46,308,64273,70,NULL,NULL,'2MASX J16081256+1407004',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,242.052333,14.11672,0.093,NULL,56550322563,883598790,13806231,16.1),(135600,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135600,36.2,0.46,174,64274,70,NULL,NULL,'2MASX J16081287+2734163',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000155,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.0535,27.57114,0.101,NULL,59862188144,935346689,14614792,16.5),(135601,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135601,36.15,0.46,170,64275,70,NULL,NULL,'2MASX J16081401+3338567',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,242.0584583,33.64919,0.017,NULL,59784022289,934125348,14595708,16.5),(135602,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135602,37.6,0.27,331,64276,70,NULL,NULL,'2MASX J16081439+3406457',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.06,34.11281,0.017,NULL,59766287805,933848246,14591378,17.6),(135603,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135603,36.37,0.46,188,64277,70,NULL,NULL,'KUGX 1606+343',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000098,NULL,'17.0g',0.19,'Compact',NULL,NULL,NULL,NULL,1,242.065541667,34.23478,0.009,NULL,59766283118,933848173,14591377,17),(135604,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135604,37.31,0.46,290,64278,70,NULL,NULL,'2MASX J16081603+1626274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.0669583,16.44081,0.085,NULL,56563059514,883797804,13809340,17.7),(135605,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135605,37.79,0.33,362,64279,70,NULL,NULL,'2MASX J16081617+2343557',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.067291667,23.73225,0.165,NULL,59392351134,928005486,14500085,17.6),(135606,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135606,36.37,0.46,188,64280,70,NULL,NULL,'2MASX J16081619+0357385',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000177,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,242.067375,3.96083,0.229,NULL,56490333119,882661454,13791585,16.2),(135607,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135607,38.09,0.27,416,64281,70,NULL,NULL,'2MASX J16081636+3737434',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000117,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.068,37.62867,0,NULL,59770343474,933911616,14592369,17.1),(135608,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135608,36.06,0.46,163,64282,70,NULL,NULL,'CGCG 195-016',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000087,NULL,'15.0g',0.56,'E0',NULL,NULL,NULL,NULL,1,242.0684583,36.09336,0.029,NULL,59773453781,933960215,14593128,15),(135609,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135609,31.6,0.43,20.9,64283,75,NULL,'3.6 micron, color + selection bias corrected','IC 1197',NULL,'2014MNRAS.444..527S',2014,1,3.02,NULL,'G',0.000006,NULL,'14.1g',0.51,'Sd',NULL,NULL,NULL,NULL,1,242.0719583,7.5385,0.149,NULL,56462936879,882233388,13784896,14.1),(135610,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135610,31.7,0.4,21.9,64283,75,NULL,NULL,'IC 1197',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135611,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135611,31.72,0.43,22.1,64283,75,NULL,'3.6 micron, color corrected','IC 1197',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135612,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135612,31.8,NULL,22.9,64283,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 1197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135613,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135613,31.83,NULL,23.2,64283,NULL,NULL,'Dipole','IC 1197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135614,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135614,31.83,NULL,23.2,64283,NULL,NULL,'Dipole + Quadrupole','IC 1197',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135615,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135615,31.83,0.2,23.2,64283,74.4,NULL,NULL,'IC 1197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135616,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135616,31.89,0.4,23.9,64283,NULL,NULL,NULL,'IC 1197',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135617,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135617,31.9,0.49,24,64283,75,NULL,'IR','IC 1197',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135618,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135618,31.95,NULL,24.6,64283,NULL,NULL,NULL,'IC 1197',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135619,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135619,31.98,0.4,24.9,64283,NULL,NULL,'mean','IC 1197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135620,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135620,32.02,NULL,25.3,64283,72,NULL,NULL,'IC 1197',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135621,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135621,32.08,0.52,26.1,64283,NULL,NULL,NULL,'IC 1197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135622,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135622,32.16,0.5,27.1,64283,NULL,NULL,'Malmquist cor.','IC 1197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135623,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135623,32.53,0.47,32.1,64283,NULL,NULL,'H','IC 1197',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135624,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135624,36.14,0.46,169,64284,70,NULL,NULL,'2MASX J16081759+1724364',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'15.9g',0.39,'E',NULL,NULL,NULL,NULL,1,242.073125,17.41006,0.117,NULL,56562058798,883782168,13809096,15.9),(135625,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135625,38.3,0.46,458,64285,70,NULL,NULL,'SDSS J160817.94+190358.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.0747917,19.06611,0.061,NULL,56519168138,883112002,13798625,18.2),(135626,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135626,38.09,0.27,416,64286,70,NULL,NULL,'2MASX J16081822+3743354',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00011,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,242.075833,37.72647,0,NULL,59770317876,933911216,14592362,16.6),(135627,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10jt','N',135627,41.01,0.14,1190,64287,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jt HOST',0.3361,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135628,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135628,37.81,0.46,364,64288,70,NULL,NULL,'2MASX J16081839+1453567',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.07675,14.89917,0.057,NULL,56549744243,883589753,13806089,17.4),(135629,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135629,36.56,0.21,205,64289,70,NULL,NULL,'SDSS J160821.14+282843.2',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',NULL,NULL,'15.4g',0.48,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.088083,28.47869,0.093,NULL,59736569266,933383894,14584123,15.4),(135630,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135630,37.81,0.46,366,64290,70,NULL,NULL,'2MASX J16082344+1140324',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.097625,11.67572,0.161,NULL,56579245489,884050710,13813292,17.6),(135631,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135631,37.38,0.46,300,64291,70,NULL,NULL,'2MASX J16082464+2653046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000143,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.102583,26.88469,0.097,NULL,59863015859,935359622,14614994,17.1),(135632,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135632,36.87,0.46,237,64292,70,NULL,NULL,'2MASX J16082554+4513016',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.1065417,45.21708,0.021,NULL,59803340321,934427192,14600424,17.4),(135633,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135633,33.93,0.49,61.2,64293,75,NULL,'IR','ESO 451- G 009',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00002,NULL,'15.13',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,242.110125,-32.55494,0.869,NULL,46300674551,723448039,11303875,15.13),(135634,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135634,36.97,0.46,248,64294,70,NULL,NULL,'2MASX J16082655+3624293',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00011,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.110667,36.40806,0.029,NULL,59773514597,933961165,14593143,17),(135635,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135635,38.25,0.46,447,64295,70,NULL,NULL,'2MASX J16082685+3817563',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.1120417,38.29903,0.017,NULL,59770750714,933917979,14592468,17.6),(135636,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135636,36.65,0.46,213,64296,70,NULL,NULL,'SDSS J160828.04+165123.7',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000153,NULL,'15.8g',0.38,'E',NULL,NULL,NULL,NULL,1,242.116833333,16.85661,0.093,NULL,56563377034,883802766,13809418,15.8),(135637,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135637,37.85,0.46,372,64297,70,NULL,NULL,'2MASX J16082857+2859146',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.6g',0.18,'E',NULL,NULL,NULL,NULL,1,242.118875,28.98739,0.081,NULL,59737290357,933395161,14584299,17.6),(135638,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135638,37.81,0.33,365,64298,70,NULL,NULL,'2MASX J16082937+2626096',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.1222917,26.43594,0.129,NULL,59862941419,935358459,14614975,17.4),(135639,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135639,37.81,0.33,365,64299,70,NULL,NULL,'SDSS J160830.20+263113.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.125833,26.52031,0.129,NULL,59862931117,935358298,14614973,18.6),(135640,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135640,36.56,0.21,205,64300,70,NULL,NULL,'2MASX J16083026+2826046',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.1259583,28.43464,0.093,NULL,59736557829,933383716,14584120,17.1),(135641,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135641,38.22,0.46,440,64301,70,NULL,NULL,'2MASX J16083138+2640086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.130875,26.66914,0.129,NULL,59862767321,935355739,14614933,17.7),(135642,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135642,34.94,0.46,97.1,64302,70,NULL,NULL,'CGCG 079-057',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00017,NULL,'14.9',0.6,'E','Isolated galaxy',NULL,NULL,NULL,1,242.1365,9.60672,0.149,NULL,56587087420,884173240,13815206,14.9),(135643,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135643,38.44,0.46,487,64303,70,NULL,NULL,'SDSS J160832.83+471324.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.1367917,47.22339,NULL,NULL,59702630166,932853596,14575837,18.3),(135644,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135644,38.21,0.46,438,64304,70,NULL,NULL,'2MASX J16083366+3424459',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.140458333,34.41292,0.017,NULL,59766545774,933852277,14591441,17.9),(135645,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135645,34.86,0.8,93.7,64305,75,NULL,'MAT, I','ESO 516- G 008',NULL,'1997ApJS..109..333W',1997,1,2.07,NULL,'G',0.000033,NULL,'14.18',0.25,'Sbc',NULL,NULL,NULL,NULL,1,242.141667,-25.0195,0.465,NULL,47111273945,736113655,11501775,14.18),(135646,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135646,34.3,NULL,72.6,64305,NULL,NULL,NULL,'ESO 516- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135647,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135647,34.34,0.32,73.9,64305,85,NULL,'I, raw','ESO 516- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135648,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135648,34.36,0.32,74.6,64305,85,NULL,'I, inv','ESO 516- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135649,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135649,34.61,0.43,83.5,64305,75,NULL,'MAT, I, raw','ESO 516- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135650,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135650,34.63,NULL,84.2,64305,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 516- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135651,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135651,34.63,NULL,84.4,64305,NULL,NULL,'Dipole','ESO 516- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135652,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135652,34.64,NULL,84.8,64305,NULL,NULL,'Dipole + Quadrupole','ESO 516- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135653,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135653,34.74,0.43,88.9,64305,75,NULL,'MAT, I, inv','ESO 516- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135654,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135654,34.82,0.48,92.1,64305,NULL,NULL,'Malmquist cor.','ESO 516- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135655,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135655,34.91,0.46,95.8,64305,NULL,NULL,NULL,'ESO 516- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135656,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135656,34.95,0.43,97.8,64305,75,NULL,'3.6 micron, color + selection bias corrected','ESO 516- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135657,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135657,34.96,0.43,98.2,64305,75,NULL,'MAT, I, cor','ESO 516- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135658,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135658,35.03,0.43,101,64305,75,NULL,'3.6 micron, color corrected','ESO 516- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135659,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135659,35.03,0.2,101,64305,74.4,NULL,NULL,'ESO 516- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135660,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135660,35.1,0.49,105,64305,75,NULL,'IR','ESO 516- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135661,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135661,36.18,0.46,172,64306,70,NULL,NULL,'2MASX J16083539+2457096',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.147666667,24.95256,0.169,NULL,59861914625,935342416,14614725,17),(135662,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135662,38.41,0.46,481,64307,70,NULL,NULL,'SDSS J160835.48+341353.4',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.147917,34.2315,0.017,NULL,59766277838,933848091,14591376,17.7),(135663,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135663,38.06,0.46,410,64308,70,NULL,NULL,'2MASX J16083574+3855169',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.149083,38.92139,0.009,NULL,59800413585,934381462,14599710,17.5),(135664,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135664,35.89,0.4,151,64309,NULL,NULL,'mean','IC 1198',NULL,'2007A&A...465...71T',2007,1,0.6,'1992A&AS...96..389d has V = 9683 +- 90 km/sec.','G',0.00013,NULL,'15.20',0.3,'SB0            Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,242.1515417,12.33094,0.129,NULL,56548836932,883575577,13805868,15.2),(135665,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135665,36.15,0.45,170,64309,NULL,NULL,'K','IC 1198',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135666,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135666,36.16,0.47,171,64309,NULL,NULL,'H','IC 1198',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135667,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135667,37.74,0.46,353,64310,70,NULL,NULL,'2MASX J16083713+2655506',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.1547083,26.93089,0.105,NULL,59862751307,935355489,14614929,17.3),(135668,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135668,35.58,0.42,131,64311,NULL,NULL,NULL,'AGC 260963',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000021,NULL,'17.8g',0.1,'Scd',NULL,NULL,NULL,NULL,1,242.155417,15.87692,0.049,NULL,56562457943,883788405,13809193,17.8),(135669,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135669,35.65,0.2,135,64311,74.4,NULL,NULL,'AGC 260963',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135670,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135670,35.84,0.38,147,64311,NULL,NULL,'Malmquist cor.','AGC 260963',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135671,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135671,36.11,0.53,166,64312,70,NULL,NULL,'2MASX J16083767-0801407',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000087,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,242.157,-8.02806,0.625,NULL,45573720581,712089384,11126396,13.7),(135672,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135672,34.48,0.2,78.7,64313,74.4,NULL,NULL,'CGCG 079-058',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00016,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,242.164875,12.01069,0.133,NULL,56579300151,884051564,13813305,15.5),(135673,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135673,34.4,0.49,76,64314,75,NULL,'IR','CGCG 079-058',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.00016,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,242.164875,12.01069,0.133,NULL,56579300151,884051564,13813305,15.5),(135674,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135674,37.35,0.46,294,64315,70,NULL,NULL,'2MASX J16083988+2341544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.166375,23.69861,0.181,NULL,59392379257,928005925,14500092,17.5),(135675,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135675,37.4,0.46,301,64316,70,NULL,NULL,'SDSS J160841.68+442329.7',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.173708333,44.39161,0.013,NULL,59803056102,934422751,14600355,18.6),(135676,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135676,38.09,0.46,416,64317,70,NULL,NULL,'2MASX J16084229+2702256',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.17625,27.04036,0.105,NULL,59863011149,935359549,14614992,17.6),(135677,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135677,38.24,0.27,444,64318,70,NULL,NULL,'2MASX J16084389+3716099',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.182875,37.26953,0,NULL,59770194761,933909293,14592332,17.5),(135678,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135678,36.53,0.46,202,64319,70,NULL,NULL,'2MASX J16084428+3053220',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000191,NULL,'16.2g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,242.184625,30.88947,0.065,NULL,59738936149,933420877,14584701,16.2),(135679,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135679,35.78,0.8,143,64320,75,NULL,'HMCL, I','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,1,1.11,NULL,'G',0.00001,NULL,'15.3g',0.33,'(R\')SB(s)ab','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,242.18875,16.75922,0.093,NULL,56563580036,883805938,13809467,15.3),(135680,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135680,35.79,0.8,144,64320,75,NULL,'W91CL, r','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135681,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135681,35.64,0.4,134,64320,75,NULL,'HMCL, I, raw','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135682,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135682,35.72,0.2,139,64320,74.4,NULL,NULL,'CGCG 108-158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135683,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135683,35.77,0.38,143,64320,75,NULL,'W91CL, r, raw','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135684,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135684,35.81,0.29,145,64320,NULL,NULL,NULL,'CGCG 108-158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135685,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135685,35.8,0.29,145,64320,NULL,NULL,'Malmquist cor.','CGCG 108-158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135686,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135686,35.87,0.4,149,64320,75,NULL,'HMCL, I, inv','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135687,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135687,35.93,0.4,153,64320,75,NULL,'HMCL, I, cor','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135688,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135688,35.98,0.38,157,64320,75,NULL,'W91CL, r, inv','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135689,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135689,36.03,0.38,161,64320,75,NULL,'W91CL, r, cor','CGCG 108-158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135690,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135690,37.1,0.46,264,64321,70,NULL,NULL,'SDSS J160846.48+501018.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,242.1937083,50.17167,0.041,NULL,59706345566,932911649,14576744,17.6),(135691,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135691,36.02,0.46,160,64322,70,NULL,NULL,'2MASX J16084751+1558377',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000173,NULL,'16.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.198083,15.97725,0.053,NULL,56563167330,883799489,13809367,16.1),(135692,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135692,38.11,0.46,418,64323,70,NULL,NULL,'2MASX J16084772+3456593',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.199,34.94994,0,NULL,59765793487,933840523,14591258,17.6),(135693,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135693,37.5,0.46,317,64324,70,NULL,NULL,'2MASX J16084891+2715246',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.203916667,27.25686,0.109,NULL,59729060192,933266565,14582290,18.4),(135694,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135694,35.51,0.8,126,64325,75,NULL,'CF, r','UGC 10224',NULL,'1997ApJS..109..333W',1997,1,1.02,NULL,'G',0.000033,NULL,'15.1g',0.47,'Sbc',NULL,NULL,NULL,NULL,1,242.209375,22.04264,0.161,NULL,56507428178,882928565,13795758,15.1),(135695,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135695,35.53,0.38,128,64325,75,NULL,'CF, r, raw','UGC 10224',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135696,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135696,35.57,0.2,130,64325,74.4,NULL,NULL,'UGC 10224',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135697,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135697,35.7,0.38,138,64325,75,NULL,'CF, r, inv','UGC 10224',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135698,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135698,35.81,0.38,145,64325,75,NULL,'CF, r, cor','UGC 10224',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135699,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135699,37.67,0.46,342,64326,70,NULL,NULL,'SDSS J160850.65+090629.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,242.211083,9.10822,0.113,NULL,56587033180,884172393,13815193,NULL),(135700,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135700,36.77,0.46,226,64327,70,NULL,NULL,'2MASX J16085091-0029290',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.21225,-0.49136,0.445,NULL,45558691142,711854549,11122727,17.5),(135701,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135701,37.78,0.46,359,64328,70,NULL,NULL,'2MASX J16085204+0746560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,242.216916667,7.78228,0.153,NULL,56461926331,882217598,13784649,18.3),(135702,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS10jk','N',135702,42.11,0.16,1850,64329,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jk HOST',0.4301,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135703,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135703,37.74,0.46,353,64330,70,NULL,NULL,'2MASX J16085552+3038484',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,242.231375,30.64669,0.061,NULL,59738768221,933418253,14584660,17),(135704,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135704,35.52,0.61,127,64331,70,NULL,NULL,'2MASX J16085638-1147185',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,242.235,-11.78847,1.113,NULL,45576600487,712134382,11127099,14),(135705,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135705,37.79,0.33,362,64332,70,NULL,NULL,'2MASX J16085750+2351414',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000203,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.2395,23.86161,0.181,NULL,59392283021,928004422,14500069,16.7),(135706,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135706,35.43,0.46,122,64333,70,NULL,NULL,'2MASX J16085749+2221424',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00016,NULL,'16.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.239666667,22.36175,0.185,NULL,56509363626,882958806,13796231,16.2),(135707,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135707,37.95,0.46,390,64334,70,NULL,NULL,'SDSS J160857.91+080504.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.241333333,8.08453,0.161,NULL,56582984217,884109128,13814205,18),(135708,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135708,38.24,0.27,444,64335,70,NULL,NULL,'SDSS J160858.23+371437.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.242667,37.24375,0,NULL,59770169592,933908899,14592326,18.1),(135709,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135709,35.27,NULL,113,64336,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10227',NULL,'2010Ap&SS.325..163P',2010,1,2.02,NULL,'G',0.000016,NULL,'15.0g',0.31,'SBcd?','Isolated galaxy',NULL,NULL,NULL,1,242.242917,36.61089,0.029,NULL,59773327750,933958246,14593097,15),(135710,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135710,35.27,NULL,113,64336,NULL,NULL,'Dipole + Quadrupole','UGC 10227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135711,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135711,35.28,NULL,114,64336,NULL,NULL,'Dipole','UGC 10227',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135712,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135712,35.31,NULL,116,64336,NULL,NULL,NULL,'UGC 10227',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135713,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135713,35.43,0.49,122,64336,75,NULL,'IR','UGC 10227',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135714,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135714,35.64,0.4,134,64336,NULL,NULL,'mean','UGC 10227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135715,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135715,35.74,0.47,141,64336,NULL,NULL,'H','UGC 10227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135716,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135716,35.78,0.45,143,64336,NULL,NULL,'K','UGC 10227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135717,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135717,35.93,0.46,153,64336,NULL,NULL,'J','UGC 10227',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135718,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135718,38.05,0.46,407,64337,70,NULL,NULL,'SDSS J160858.46+245103.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.243583,24.85103,0.169,NULL,59862132543,935345820,14614778,18.6),(135719,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135719,38.24,0.27,444,64338,70,NULL,NULL,'2MASX J16085939+3714539',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,242.247417,37.24847,0,NULL,59770169498,933908898,14592326,17.3),(135720,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135720,35.43,0.8,122,64339,75,NULL,'CF, r','UGC 10226',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00001,NULL,'15.0g',0.47,'Sb','Isolated galaxy',NULL,NULL,NULL,1,242.252625,35.79364,0.017,NULL,59773999514,933968742,14593261,15),(135721,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135721,35.55,0.33,129,64339,NULL,NULL,NULL,'UGC 10226',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135722,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135722,35.6,0.32,132,64339,NULL,NULL,'Malmquist cor.','UGC 10226',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135723,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135723,35.61,0.2,132,64339,74.4,NULL,NULL,'UGC 10226',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135724,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135724,35.73,0.38,140,64339,75,NULL,'CF, r, raw','UGC 10226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135725,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135725,35.89,0.38,151,64339,75,NULL,'CF, r, inv','UGC 10226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135726,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135726,35.92,0.38,153,64339,75,NULL,'CF, r, cor','UGC 10226',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135727,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135727,37.32,0.33,291,64340,70,NULL,NULL,'2MASX J16090211+5344363',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000082,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.258666667,53.74347,0,NULL,57606226591,900097290,14064020,16.3),(135728,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135728,38.38,0.46,474,64341,70,NULL,NULL,'SDSS J160902.29+222317.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000152,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,242.2595417,22.38811,0.185,NULL,56509366112,882958845,13796231,19),(135729,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135729,37.21,0.27,277,64342,70,NULL,NULL,'SDSS J160902.44+091933.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.260167,9.32606,0.117,NULL,56587136679,884174010,13815218,18.1),(135730,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135730,37.43,0.33,306,64343,70,NULL,NULL,'2MASX J16090502+3242135',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.270917,32.70369,0,NULL,59785395506,934146804,14596043,16.9),(135731,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135731,35.33,0.46,117,64344,70,NULL,NULL,'2MASX J16090555+2753340',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00019,NULL,'15.5g',0.46,'Sy2',NULL,NULL,NULL,'Sy 2',1,242.273,27.89272,0.085,NULL,59729034339,933266161,14582283,15.5),(135732,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135732,36.19,0.46,173,64345,70,NULL,NULL,'CGCG 250-047',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000097,NULL,'15.2g',0.61,'S0',NULL,NULL,NULL,NULL,1,242.2764583,46.67119,NULL,NULL,59701952121,932843001,14575671,15.2),(135733,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135733,35.88,0.2,150,64346,74.4,NULL,NULL,'CGCG 137-045',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000103,NULL,'15.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.277041667,24.87042,0.169,NULL,59862134577,935345852,14614778,15.6),(135734,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135734,37.48,0.46,313,64347,70,NULL,NULL,'2MASX J16090662+2249247',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.2775,22.82367,0.145,NULL,59391873090,927998017,14499969,17.7),(135735,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135735,36.72,0.46,220,64348,70,NULL,NULL,'2MASX J16090787+2631010',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.2827917,26.51683,0.105,NULL,59862924770,935358199,14614971,16.6),(135736,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135736,36.47,0.46,197,64349,70,NULL,NULL,'CGCG 079-062',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000197,NULL,'15.2',0.5,NULL,NULL,NULL,NULL,NULL,1,242.285625,12.085,0.145,NULL,56579082192,884048159,13813252,15.2),(135737,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135737,37.36,0.15,297,64350,70,NULL,NULL,'2MASX J16090862+5302123',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.2860417,53.03681,0,NULL,59700567454,932821366,14575333,17),(135738,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135738,37.43,0.33,306,64351,70,NULL,NULL,'2MASX J16090914+3239565',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.288125,32.66556,0.045,NULL,59785392290,934146754,14596043,17.2),(135739,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135739,37.21,0.27,277,64352,70,NULL,NULL,'2MASX J16091264+0922260',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.302583333,9.374,0.117,NULL,56587138299,884174035,13815219,16.7),(135740,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135740,37.33,0.46,293,64353,70,NULL,NULL,'2MASX J16091279+1453477',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.3032917,14.89664,0.089,NULL,56552040739,883625636,13806650,16.4),(135741,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135741,37.36,0.15,297,64354,70,NULL,NULL,'2MASX J16091372+5303353',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000065,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.307375,53.06003,0,NULL,59700567919,932821373,14575333,17.7),(135742,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135742,40.77,NULL,1420,64355,NULL,NULL,'WMAP-7 cosmology','WN B1608+6540:[KTF2003] G1',NULL,'2015JCAP...11..033J',2014,1,NULL,NULL,'G',NULL,NULL,'18.23',NULL,NULL,NULL,NULL,NULL,NULL,1,242.307875,65.54108,0.041,NULL,57828320628,903567509,14118242,18.23),(135743,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135743,40.86,NULL,1490,64355,NULL,NULL,NULL,'WN B1608+6540:[KTF2003] G1',NULL,'2015JCAP...11..033J',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135744,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135744,40.92,0.7,1530,64355,NULL,NULL,NULL,'WN B1608+6540:[KTF2003] G1',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135745,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135745,43.59,0.08,5230,64355,NULL,NULL,NULL,'WN B1608+6540:[KTF2003] G1',NULL,'2010ApJ...711..201S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135746,'G Lens','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135746,44,0.46,6300,64355,NULL,NULL,NULL,'WN B1608+6540:[KTF2003] G1',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135747,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135747,36.46,0.46,196,64356,70,NULL,NULL,'2MASX J16091509+4612477',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.312875,46.21319,NULL,NULL,59701726125,932839470,14575616,16.2),(135748,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135748,37.43,0.46,307,64357,70,NULL,NULL,'2MASX J16091623+5032083',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000164,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.31775,50.53547,0.033,NULL,59706760810,932918137,14576845,16.9),(135749,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135749,34.81,0.46,91.8,64358,70,NULL,NULL,'I Zw 134',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000063,NULL,'14.9g',0.5,'S0','Field galaxy',NULL,NULL,NULL,1,242.318625,41.74572,0.021,NULL,59806968909,934483889,14601310,14.9),(135750,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135750,36.55,0.46,204,64359,70,NULL,NULL,'2MASX J16091771+0402378',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000168,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.323667,4.04392,0.229,NULL,56504325259,882880082,13795001,16.3),(135751,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135751,36.01,0.46,160,64360,70,NULL,NULL,'2MASX J16091787+1415502',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.0g',0.36,NULL,NULL,NULL,NULL,NULL,1,242.3245417,14.26403,0.101,NULL,56552254061,883628969,13806702,16),(135752,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135752,36.39,0.46,190,64361,70,NULL,NULL,'2MASX J16091995+2355177',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.333291667,23.92144,0.181,NULL,59392312330,928004880,14500076,16.5),(135753,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135753,37.5,0.46,317,64362,70,NULL,NULL,'SDSS J160921.26+321522.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000139,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.338625,32.25611,0.049,NULL,59785259348,934144677,14596010,18.5),(135754,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135754,37.24,0.46,281,64363,70,NULL,NULL,'SDSS J160923.20+352240.4',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',NULL,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,242.346667,35.37792,0.005,NULL,59773283736,933957558,14593086,15.8),(135755,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135755,37.49,0.46,315,64364,70,NULL,NULL,'2MASX J16092333+3109523',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000148,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.3472083,31.16439,0.065,NULL,59738735887,933417748,14584652,17),(135756,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135756,38.27,0.46,451,64365,70,NULL,NULL,'SDSS J160923.37+472619.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.347417,47.43881,NULL,NULL,59702742620,932855353,14575864,17.9),(135757,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135757,36.62,0.27,211,64366,70,NULL,NULL,'2MASX J16092439+2541025',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.3517917,25.68419,0.145,NULL,59861388737,935334199,14614596,18),(135758,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135758,38.78,0.46,570,64367,70,NULL,NULL,'2MASX J16092538+3703148',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.3557083,37.05419,0,NULL,59772032487,933938007,14592781,18.2),(135759,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135759,36.14,0.05,169,64368,70,NULL,NULL,'2MASX J16092565+1812577',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'AGN',NULL,NULL,NULL,NULL,1,242.3569583,18.21603,0.133,NULL,56516556097,883071189,13797987,NULL),(135760,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135760,37.2,0.46,275,64369,70,NULL,NULL,'SDSS J160926.01+045213.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'17.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.358417,4.8705,0.189,NULL,56492276095,882691813,13792059,17.8),(135761,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135761,37.83,0.46,368,64370,70,NULL,NULL,'SDSS J160926.09+082731.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.35875,8.45867,0.129,NULL,56583102945,884110983,13814234,18.2),(135762,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135762,35.85,0.59,148,64371,70,NULL,NULL,'2MASX J16092617-0726305',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.3590417,-7.44186,0.601,NULL,45545667540,711651055,11119547,15.5),(135763,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135763,37.61,0.46,333,64372,70,NULL,NULL,'2MASX J16092630+4340138',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.3595,43.67069,0.017,NULL,59805964511,934468195,14601065,17.2),(135764,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135764,37.21,0.27,277,64373,70,NULL,NULL,'2MASX J16092705+0924039',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,242.362625,9.40125,0.117,NULL,56587013712,884172089,13815188,16.1),(135765,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135765,38.22,0.46,440,64374,70,NULL,NULL,'2MASX J16092871+3641578',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.369625,36.69925,0.029,NULL,59771516324,933929942,14592655,17.8),(135766,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135766,33.64,0.49,53.5,64375,75,NULL,'IR','ESO 451- G 011',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000028,NULL,'14.14',0.2,'Sc             HII',NULL,NULL,NULL,NULL,1,242.373667,-29.00133,0.841,NULL,46245207731,722581370,11290333,14.14),(135767,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PTF10qny','N',135767,35.79,0.05,139,64376,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qny',0.0333,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135768,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135768,37.89,0.46,378,64377,70,NULL,NULL,'2MASX J16093098+1520052',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.37925,15.33475,0.061,NULL,56544502517,883507851,13804810,16.9),(135769,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135769,37.09,0.46,262,64378,70,NULL,NULL,'2MASX J16093234+1327452',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.384625,13.46244,0.097,NULL,56553377855,883646528,13806977,18.2),(135770,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135770,38.09,0.46,415,64379,70,NULL,NULL,'2MASX J16093292+0837129',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.387333333,8.62022,0.129,NULL,56583205749,884112589,13814259,17.2),(135771,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135771,37.45,0.46,308,64380,70,NULL,NULL,'2MASX J16093372+2400476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.390583,24.01322,0.181,NULL,59392315513,928004929,14500077,17.8),(135772,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135772,34.89,0.64,95.2,64381,70,NULL,NULL,'2MASX J16093451-0234036',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.393875,-2.56764,0.525,NULL,45559953732,711874277,11123035,15.4),(135773,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135773,36.85,0.65,235,64382,70,NULL,NULL,'FAIRALL 1412',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.6b',0.42,NULL,NULL,NULL,NULL,NULL,1,242.40125,-77.49919,0.329,NULL,44279300735,691864073,10810376,16.6),(135774,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135774,36.56,0.46,205,64383,70,NULL,NULL,'2MASX J16093662+2219523',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.4025,22.33119,0.173,NULL,56509568186,882962002,13796281,17.9),(135775,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135775,30.15,0.39,10.7,64384,73,NULL,'opt','MCG -01-41-006',NULL,'2011A&A...532A.104N',2011,1,0.6,NULL,'G',0.00002,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,242.4035,-4.62017,0.533,NULL,45553347410,711771053,11121422,15.5),(135776,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135776,30.15,NULL,10.7,64384,72,NULL,NULL,'MCG -01-41-006',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135777,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135777,37.36,0.15,297,64385,70,NULL,NULL,'2MASX J16093700+5302282',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000118,NULL,'15.3g',0.59,'BrClG',NULL,NULL,NULL,NULL,1,242.403916667,53.04125,0,NULL,59700593618,932821775,14575340,15.3),(135778,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135778,37.32,0.33,291,64386,70,NULL,NULL,'2MASX J16093718+5344232',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000099,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.404958333,53.73969,0,NULL,57606507380,900101677,14064088,16.7),(135779,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135779,37.72,0.46,350,64387,70,NULL,NULL,'SDSS J160937.58+524941.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000083,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.406625,52.82828,0,NULL,59700663608,932822868,14575357,18.5),(135780,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135780,37.97,0.46,393,64388,70,NULL,NULL,'2MASX J16093798+3656427',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.408333,36.94531,0.013,NULL,59772038825,933938106,14592782,18.2),(135781,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135781,36.6,0.46,209,64389,70,NULL,NULL,'2MASX J16094001+3707077',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.416875,37.11881,0,NULL,59772022931,933937858,14592779,16.5),(135782,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135782,36.94,0.46,245,64390,70,NULL,NULL,'2MASX J16094022+2151373',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000207,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.417458333,21.86047,0.177,NULL,56508950311,882952348,13796130,16.3),(135783,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135783,37.85,0.33,372,64391,70,NULL,NULL,'2MASX J16094135+1938103',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.422208333,19.63628,0.069,NULL,56518527046,883101985,13798468,17.6),(135784,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135784,37.54,0.46,323,64392,70,NULL,NULL,'2MASX J16094136+4744117',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000083,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.42225,47.7365,NULL,NULL,59702435793,932850559,14575789,16.8),(135785,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135785,37.85,0.33,372,64393,70,NULL,NULL,'2MASX J16094205+1939073',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.42525,19.652,0.069,NULL,56521951176,883155487,13799304,17.5),(135786,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135786,36.26,0.46,179,64394,70,NULL,NULL,'KUGX 1607+325',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000165,NULL,'15.8g',0.38,'Compact',NULL,NULL,NULL,NULL,1,242.4255417,32.46528,0.049,NULL,59785378447,934146538,14596039,15.8),(135787,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135787,34.97,0.2,98.6,64395,74.4,NULL,NULL,'2MASX J16094265+3040533',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000009,NULL,'16.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.427583,30.68164,0.073,NULL,59738861946,933419717,14584683,16.3),(135788,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135788,37.91,0.46,381,64396,70,NULL,NULL,'2MASX J16094275+1849423',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.4282917,18.82831,0.029,NULL,56517036951,883078702,13798104,17.1),(135789,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135789,37.27,0.33,284,64397,70,NULL,NULL,'2MASX J16094338+2200573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.9g',0.22,'BrClG',NULL,NULL,NULL,NULL,1,242.430875,22.01592,0.177,NULL,56509673131,882963642,13796306,17.9),(135790,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135790,38.2,0.46,437,64398,70,NULL,NULL,'2MASX J16094423+3225573',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.434333,32.43256,0.049,NULL,59785366031,934146344,14596036,18),(135791,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135791,37.19,0.46,274,64399,70,NULL,NULL,'2MASX J16094516+4226237',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00009,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.438083,42.43997,0.029,NULL,59805109725,934454839,14600856,16.5),(135792,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135792,34.16,0.49,67.8,64400,75,NULL,'IR','ESO 451- G 014',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'13.43',0.2,'Sa             HII',NULL,NULL,NULL,NULL,1,242.439833333,-29.00708,0.841,NULL,46244892825,722576450,11290257,13.43),(135793,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135793,34.32,0.46,73.2,64400,NULL,NULL,'Malmquist cor.','ESO 451- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135794,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135794,34.37,0.45,74.7,64400,NULL,NULL,NULL,'ESO 451- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135795,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135795,34.41,0.2,76.2,64400,74.4,NULL,NULL,'ESO 451- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135796,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135796,36.64,0.8,213,64401,70,NULL,NULL,'2MASX J16094617-1135485',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.442417,-11.59689,1.041,NULL,45580806769,712200105,11128126,15.8),(135797,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135797,38.23,0.33,442,64402,70,NULL,NULL,'SDSS J160946.16+510425.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.442417,51.07381,0.041,NULL,59709425077,932959766,14577496,18.2),(135798,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135798,36.43,0.49,194,64403,75,NULL,'IR','CGCG 079-065',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000046,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,242.442417,13.44864,0.097,NULL,56553400725,883646886,13806982,15.5),(135799,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135799,38.4,0.46,478,64404,70,NULL,NULL,'2MASX J16094661+0508175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.444125,5.13811,0.189,NULL,56491643668,882681932,13791905,17.7),(135800,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135800,37.88,0.33,376,64405,70,NULL,NULL,'SDSS J160947.11-000503.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.446333,-0.08433,0.397,NULL,45504195425,711003053,11109422,18.2),(135801,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135801,37.36,0.15,297,64406,70,NULL,NULL,'2MASX J16094743+5302102',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000104,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.4475,53.03611,0,NULL,59700585174,932821643,14575338,17.1),(135802,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135802,35.42,0.46,121,64407,70,NULL,NULL,'CGCG 167-032',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000168,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,242.449833,30.14311,0.089,NULL,59739406550,933428227,14584816,15.4),(135803,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135803,36.68,0.46,216,64408,70,NULL,NULL,'2MASX J16094876+3137343',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000162,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,242.453125,31.62611,0.057,NULL,59785099769,934142183,14595971,16.4),(135804,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135804,35.91,0.8,152,64409,70,NULL,NULL,'2MASX J16094888-0411334',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,242.45375,-4.19256,0.525,NULL,45564059280,711938426,11124037,14.2),(135805,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135805,36.62,0.27,211,64410,70,NULL,NULL,'2MASX J16094901+2529186',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000182,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,242.454375,25.48853,0.149,NULL,59861603519,935337554,14614649,16),(135806,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135806,38.23,0.33,442,64411,70,NULL,NULL,'2MASX J16094930+5104582',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000114,NULL,'17.8g',0.18,'NLAGN',NULL,NULL,NULL,'Sy 2',1,242.455667,51.08283,0.041,NULL,59709424937,932959764,14577496,17.8),(135807,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135807,37.27,0.33,284,64412,70,NULL,NULL,'2MASX J16094957+2200263',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000205,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.4565,22.00719,0.177,NULL,56509671785,882963621,13796306,17.1),(135808,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135808,34.76,0.46,89.7,64413,70,NULL,NULL,'2MASX J16094972+1740432',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00007,NULL,'15.6g',0.43,'E',NULL,NULL,NULL,NULL,1,242.45725,17.67867,0.113,NULL,56561943677,883780369,13809068,15.6),(135809,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135809,38.48,0.27,497,64414,70,NULL,NULL,'2MASX J16094996+3722581',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000181,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.458167,37.38292,0.009,NULL,59770244552,933910071,14592344,17.8),(135810,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135810,37.54,0.33,322,64415,70,NULL,NULL,'2MASX J16095020+2626316',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000183,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,242.459125,26.44225,0.105,NULL,59862709717,935354839,14614919,16.3),(135811,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135811,33.22,0.49,44.1,64416,75,NULL,'IR','UGC 10232',NULL,'2011yCatp016004901K',2011,1,1.79,'Multiple SDSS entries describe this object.','G',0.000007,NULL,'15.81',0.17,'Sd',NULL,NULL,NULL,NULL,1,242.461208333,20.17775,0.093,NULL,56522039936,883156874,13799326,15.81),(135812,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135812,33.36,NULL,46.9,64416,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10232',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135813,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135813,33.37,NULL,47.1,64416,NULL,NULL,'Dipole + Quadrupole','UGC 10232',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135814,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135814,33.37,NULL,47.3,64416,NULL,NULL,'Dipole','UGC 10232',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135815,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135815,33.4,0.2,47.9,64416,74.4,NULL,NULL,'UGC 10232',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135816,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135816,33.49,0.48,49.8,64416,NULL,NULL,NULL,'UGC 10232',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135817,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135817,33.87,0.4,59.5,64416,NULL,NULL,'Malmquist cor.','UGC 10232',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135818,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135818,38.11,0.46,418,64417,70,NULL,NULL,'SDSS J160950.79+235547.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.461667,23.92989,0.181,NULL,59392301124,928004705,14500073,18.7),(135819,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135819,35.01,NULL,101,64418,NULL,NULL,NULL,'UGC 10233',NULL,'2000BSAO...50....5K',2000,1,2.06,NULL,'G',0.000027,NULL,'15.7g',0.21,'Scd',NULL,NULL,NULL,NULL,1,242.4640417,22.61525,0.165,NULL,56509368311,882958879,13796232,15.7),(135820,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135820,35.13,NULL,106,64418,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135821,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135821,35.14,NULL,106,64418,NULL,NULL,'Dipole + Quadrupole','UGC 10233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135822,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135822,35.14,NULL,107,64418,NULL,NULL,'Dipole','UGC 10233',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135823,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135823,35.52,0.41,127,64418,NULL,NULL,NULL,'UGC 10233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135824,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135824,35.61,0.39,132,64418,NULL,NULL,'Malmquist cor.','UGC 10233',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135825,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135825,35.62,0.2,133,64418,74.4,NULL,NULL,'UGC 10233',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135826,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135826,36.62,0.27,211,64419,70,NULL,NULL,'2MASX J16095184+2541116',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0001,NULL,'15.2g',0.6,'E0',NULL,NULL,NULL,NULL,1,242.465875,25.68658,0.145,NULL,59861400887,935334388,14614599,15.2),(135827,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135827,37.36,0.15,297,64420,70,NULL,NULL,'2MASX J16095253+5304472',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.468666667,53.07994,0,NULL,59700594549,932821789,14575340,16.9),(135828,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135828,36.8,0.2,229,64421,74.4,NULL,NULL,'KUG 1607+136B',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000821,NULL,'15.6',0.1,'Spiral',NULL,NULL,NULL,NULL,1,242.4722917,13.52914,0.097,NULL,56553436072,883647438,13806991,15.6),(135829,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135829,36.02,0.49,160,64422,75,NULL,'IR','KUG 1607+136B',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000821,NULL,'15.6',0.1,'Spiral',NULL,NULL,NULL,NULL,1,242.4722917,13.52914,0.097,NULL,56553436072,883647438,13806991,15.6),(135830,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135830,35.35,0.16,114,64423,74.2,NULL,'SALT 2','UGC 10244',0.032529,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000107,NULL,'15.4g',0.24,'S?             LINER','Field galaxy',NULL,NULL,'LINER',1,242.480916667,43.12919,0.009,NULL,59805151899,934455498,14600867,15.4),(135831,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135831,35.76,0.04,137,64423,72,NULL,'MLCS31','UGC 10244',0.032529,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135832,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135832,35.78,0.16,139,64423,65,NULL,'MLCS31','UGC 10244',0.032529,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135833,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135833,35.84,0.15,143,64423,70,NULL,'SALT 2','UGC 10244',0.032529,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135834,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135834,35.92,0.09,153,64423,74.4,NULL,NULL,'UGC 10244',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135835,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135835,36.19,0.14,168,64423,65,NULL,'MLCS17','UGC 10244',0.032529,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135836,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135836,36.21,0.16,169,64423,65,NULL,'SALT','UGC 10244',0.032529,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135837,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2006cc',NULL,135837,36.23,0.18,170,64423,65,NULL,'SALT2','UGC 10244',0.032529,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135838,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135838,37.53,0.46,320,64424,70,NULL,NULL,'2MASX J16095646+3157144',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.485166667,31.95389,0.049,NULL,59785331077,934145798,14596028,16.9),(135839,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135839,37.4,0.46,302,64425,70,NULL,NULL,'2MASX J16095644+4004292',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.4852917,40.07486,0.009,NULL,59800836276,934388066,14599813,17.6),(135840,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135840,37.49,0.46,315,64426,70,NULL,NULL,'SDSS J160957.50+043726.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.489625,4.62403,0.229,NULL,56492047242,882688238,13792003,18),(135841,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135841,34.11,NULL,66.3,64427,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 1997',NULL,'2010Ap&SS.325..163P',2010,1,0.72,NULL,'G',NULL,NULL,'16.7',0.1,'Sdm',NULL,NULL,NULL,NULL,1,242.49,22.73611,0.161,NULL,56505948828,882905450,13795397,16.7),(135842,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135842,34.13,NULL,67,64427,NULL,NULL,'Dipole + Quadrupole','FGC 1997',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135843,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135843,34.15,NULL,67.7,64427,NULL,NULL,'Dipole','FGC 1997',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135844,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135844,34.2,NULL,69.1,64427,NULL,NULL,NULL,'FGC 1997',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135845,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135845,37.54,0.33,322,64428,70,NULL,NULL,'2MASX J16095815+2636473',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,'FoF','16.3r',NULL,NULL,NULL,NULL,NULL,NULL,1,242.49225,26.61322,0.097,NULL,59729396194,933271815,14582372,16.3),(135846,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135846,32.41,0.8,30.3,64429,75,NULL,'A82, H','NGC 6070',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000019,NULL,'12.45',1.9,'SA(s)cd','Parent (of companion) galaxy',NULL,NULL,NULL,1,242.494541667,0.70931,0.361,NULL,56447798431,881996850,13781200,12.45),(135847,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135847,32.45,0.8,30.9,64429,75,NULL,'CF, r','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135848,'Sosies','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135848,32.14,0.11,26.8,64429,NULL,NULL,NULL,'NGC 6070',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135849,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135849,31.56,0.69,20.5,64429,100,NULL,'mid-IR','NGC 6070',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135850,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135850,32.13,0.38,26.7,64429,75,NULL,'CF, r, raw','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135851,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135851,32.22,0.38,27.8,64429,NULL,NULL,NULL,'NGC 6070',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135852,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135852,32.25,0.38,28.2,64429,75,NULL,'CF, r, cor','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135853,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135853,32.27,0.38,28.5,64429,75,NULL,'CF, r, inv','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135854,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135854,32.33,0.4,29.3,64429,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6070',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135855,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135855,32.47,0.4,31.2,64429,75,NULL,'B','NGC 6070',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135856,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135856,32.48,NULL,31.3,64429,72,NULL,NULL,'NGC 6070',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135857,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135857,32.49,0.43,31.5,64429,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6070',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135858,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135858,32.56,0.46,32.6,64429,NULL,NULL,'J','NGC 6070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135859,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135859,32.62,0.47,33.3,64429,NULL,NULL,'H','NGC 6070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135860,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135860,32.65,0.4,33.9,64429,NULL,NULL,'mean','NGC 6070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135861,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135861,32.65,0.47,33.9,64429,75,NULL,'A82, H, raw','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135862,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135862,32.67,0.45,34.2,64429,NULL,NULL,'K','NGC 6070',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135863,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135863,32.83,0.47,36.9,64429,75,NULL,'A82, H, cor','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135864,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135864,32.84,0.47,37,64429,75,NULL,'A82, H, inv','NGC 6070',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135865,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135865,38.06,0.33,410,64430,70,NULL,NULL,'2MASX J16095900+1636082',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.495833,16.60236,0.089,NULL,56562945518,883796023,13809312,16.9),(135866,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135866,36.95,0.33,245,64431,70,NULL,NULL,'2MASX J16095926+1133342',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.496958333,11.55956,0.161,NULL,56587656757,884182136,13815345,16.4),(135867,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135867,38.12,0.33,421,64432,70,NULL,NULL,'2MASX J16100068+5231251',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000087,NULL,'18.1g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,242.5025417,52.52356,0,NULL,59700241563,932816274,14575254,18.1),(135868,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135868,38.48,0.46,497,64433,70,NULL,NULL,'SDSS J161001.11+111218.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.504667,11.205,0.185,NULL,56588355374,884193052,13815516,18.5),(135869,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135869,38.48,0.27,497,64434,70,NULL,NULL,'2MASX J16100121+3718482',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,242.5052083,37.31344,0,NULL,59772125621,933939462,14592804,17.3),(135870,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135870,38.14,0.46,424,64435,70,NULL,NULL,'2MASX J16100160+0443485',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.50675,4.73003,0.229,NULL,56491561008,882680640,13791885,17.6),(135871,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135871,37.92,0.46,384,64436,70,NULL,NULL,'2MASX J16100325+0826082',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.513666667,8.43556,0.145,NULL,56583121339,884111270,13814238,18.1),(135872,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135872,35.32,0.66,116,64437,70,NULL,NULL,'2MASX J16100375-3205042',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.50',0.47,'E',NULL,NULL,NULL,NULL,1,242.515667,-32.0845,0.885,NULL,46300393786,723443652,11303807,15.5),(135873,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135873,37.29,0.46,287,64438,70,NULL,NULL,'2MASX J16100400+1701362',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.5167917,17.02686,0.109,NULL,56564322014,883817531,13809648,17.7),(135874,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135874,37.32,0.46,291,64439,70,NULL,NULL,'2MASX J16100444+0555575',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.518458333,5.93261,0.177,NULL,56491287886,882676373,13791818,17.4),(135875,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135875,36.68,0.46,217,64440,70,NULL,NULL,'2MASX J16100452+4913251',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.518708333,49.22358,0.017,NULL,59704505842,932882903,14576295,16.8),(135876,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135876,38.06,0.33,410,64441,70,NULL,NULL,'2MASX J16100491+1635162',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.5205,16.58781,0.089,NULL,56563076746,883798074,13809344,18.3),(135877,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135877,35.44,NULL,122,64442,NULL,NULL,NULL,'UGC 10236',NULL,'2000BSAO...50....5K',2000,1,1.49,NULL,'G',0.000033,NULL,'15.4g',0.27,'Sbc',NULL,NULL,NULL,NULL,1,242.521125,22.65022,0.165,NULL,56505942822,882905356,13795396,15.4),(135878,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135878,35.46,NULL,124,64442,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10236',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135879,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135879,35.47,NULL,124,64442,NULL,NULL,'Dipole + Quadrupole','UGC 10236',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135880,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135880,35.48,NULL,125,64442,NULL,NULL,'Dipole','UGC 10236',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135881,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135881,35.57,0.49,130,64442,75,NULL,'IR','UGC 10236',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135882,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135882,35.97,0.34,156,64442,NULL,NULL,'Malmquist cor.','UGC 10236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135883,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135883,36.12,0.2,167,64442,74.4,NULL,NULL,'UGC 10236',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135884,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135884,36.34,0.29,185,64442,NULL,NULL,NULL,'UGC 10236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135885,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135885,37.8,0.46,362,64443,70,NULL,NULL,'SDSS J161006.47+301922.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.5269583,30.32278,0.073,NULL,59739379705,933427807,14584809,18.4),(135886,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135886,37.05,0.46,258,64444,70,NULL,NULL,'2MASX J16100687+2453053',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.5285,24.88475,0.185,NULL,59862147868,935346060,14614782,17.2),(135887,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135887,37.41,0.46,303,64445,70,NULL,NULL,'2MASX J16100732+1039082',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,242.530583,10.65219,0.189,NULL,56588190222,884190472,13815476,17.4),(135888,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135888,37.75,0.46,354,64446,70,NULL,NULL,'2MASX J16100836+5340316',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.53475,53.67542,0,NULL,57606522010,900101906,14064092,17.2),(135889,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135889,38.27,0.46,451,64447,70,NULL,NULL,'2MASX J16101012+1616312',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.54225,16.27536,0.077,NULL,56563108805,883798575,13809352,17.3),(135890,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135890,38.12,0.46,421,64448,70,NULL,NULL,'2MASX J16101048+3831232',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.54375,38.52331,0.021,NULL,59770475971,933913687,14592401,17.9),(135891,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135891,37.88,0.33,376,64449,70,NULL,NULL,'2MASX J16101065-0010372',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000104,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.5444583,-0.17694,0.397,NULL,45504143380,711002240,11109410,17.4),(135892,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135892,33.96,0.8,61.8,64450,75,NULL,'HMCL, I','NGC 6073',NULL,'1997ApJS..109..333W',1997,1,1.29,'HOLM 731B is a star.','G',0.00002,NULL,'14.1g',0.63,'Sc:','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,242.5452083,16.69961,0.089,NULL,56564256154,883816502,13809632,14.1),(135893,'IRAS','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135893,34,0.8,63.2,64450,75,NULL,'CF, r','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135894,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135894,33.74,0.4,55.9,64450,75,NULL,'HMCL, I, raw','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135895,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135895,33.85,0.38,59,64450,75,NULL,'CF, r, raw','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135896,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135896,33.88,0.4,59.8,64450,75,NULL,'HMCL, I, inv','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135897,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135897,33.94,0.4,61.3,64450,75,NULL,'HMCL, I, cor','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135898,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135898,33.96,0.38,62.1,64450,75,NULL,'CF, r, inv','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135899,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135899,33.99,0.38,62.8,64450,75,NULL,'CF, r, cor','NGC 6073',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135900,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135900,34.07,0.2,65.2,64450,74.4,NULL,NULL,'NGC 6073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135901,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135901,34.18,0.47,68.6,64450,NULL,NULL,'H','NGC 6073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135902,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135902,34.28,0.46,71.8,64450,NULL,NULL,'J','NGC 6073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135903,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135903,34.29,0.4,72.1,64450,NULL,NULL,'mean','NGC 6073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135904,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135904,34.29,0.45,72.1,64450,NULL,NULL,'K','NGC 6073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135905,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135905,37.1,0.46,264,64451,70,NULL,NULL,'2MASX J16101093+2600382',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.5454583,26.01064,0.129,NULL,59864790495,935387351,14615427,17.8),(135906,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135906,37.77,0.46,358,64452,70,NULL,NULL,'SDSS J161011.09+363219.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.546291667,36.53883,0.041,NULL,59771700406,933932818,14592700,18),(135907,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135907,38.21,0.46,438,64453,70,NULL,NULL,'2MASX J16101123+1957431',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.546958333,19.96203,0.089,NULL,56522161551,883158774,13799355,17.7),(135908,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135908,36.45,0.62,195,64454,70,NULL,NULL,'2MASX J16101134-0226472',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.5472917,-2.44658,0.513,NULL,45561877401,711904334,11123505,15.7),(135909,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1992bi',NULL,135909,42.54,0.24,2210,64455,70,NULL,'SALT','[PPG92] 160828.27+395457.2',0.458,'2008ApJ...686..749K',2008,1,NULL,NULL,'G',0.001,NULL,'21.3',NULL,'Sm/Irr',NULL,NULL,NULL,NULL,1,242.5532917,39.78681,0.009,NULL,59801020603,934390946,14599858,21.3),(135910,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135910,38.12,0.33,421,64456,70,NULL,NULL,'SDSS J161013.38+522933.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,242.555791667,52.49261,0,NULL,59700244169,932816315,14575254,18.2),(135911,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135911,38.04,0.46,406,64457,70,NULL,NULL,'2MASX J16101433-0033382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000101,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.5595417,-0.56072,0.413,NULL,45504959636,711014994,11109609,17.8),(135912,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135912,37.33,0.46,292,64458,70,NULL,NULL,'2MASX J16101449+4812217',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000074,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.5605,48.206,NULL,NULL,59705694472,932901476,14576585,17.6),(135913,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135913,38.48,0.27,497,64459,70,NULL,NULL,'SDSS J161014.57+372247.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.56075,37.37986,0.009,NULL,59772128078,933939501,14592804,18.4),(135914,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135914,37.04,0.46,256,64460,70,NULL,NULL,'2MASX J16101740+0445161',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.5725417,4.75439,0.229,NULL,56491562492,882680663,13791885,17.4),(135915,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135915,37.36,0.11,296,64461,70,NULL,NULL,'SDSS J161018.58+364343.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,242.5774583,36.72875,0.029,NULL,59771495483,933929616,14592650,18.6),(135916,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135916,37.85,0.46,371,64462,70,NULL,NULL,'2MASX J16101917+3901042',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.579875,39.01783,0,NULL,59801239168,934394362,14599911,17.5),(135917,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135917,38,0.46,398,64463,70,NULL,NULL,'2MASX J16101926+4754477',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000099,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.580417,47.91319,NULL,NULL,59705198716,932893729,14576464,16.9),(135918,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135918,36.18,0.46,172,64464,70,NULL,NULL,'SDSS J161019.84+212008.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.3g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.5827083,21.33569,0.161,NULL,56508867570,882951055,13796110,17.3),(135919,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135919,35.45,0.46,123,64465,70,NULL,NULL,'2MASX J16101998+2253561',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000155,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.58325,22.89889,0.161,NULL,56506173500,882908960,13795452,16.3),(135920,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135920,37.3,0.46,289,64466,70,NULL,NULL,'2MASX J16102046+1136464',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.585291667,11.61283,0.161,NULL,56587606279,884181348,13815333,16.4),(135921,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135921,37.94,0.46,388,64467,70,NULL,NULL,'2MASX J16102156+0356381',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000205,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.589708333,3.944,0.233,NULL,56504279832,882879372,13794990,17.4),(135922,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135922,37.36,0.33,297,64468,70,NULL,NULL,'2MASX J16102262+1011154',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.5942917,10.18769,0.173,NULL,56586765200,884168206,13815128,17.9),(135923,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135923,37.31,0.46,290,64469,70,NULL,NULL,'2MASX J16102287+2648112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.5954583,26.80325,0.097,NULL,59729432109,933272376,14582380,17.6),(135924,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135924,36.96,0.46,247,64470,70,NULL,NULL,'KUGX 1608+349',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000175,NULL,'16.2g',0.34,'Spiral',NULL,NULL,NULL,NULL,1,242.596833333,34.85711,0,NULL,59765736813,933839637,14591244,16.2),(135925,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135925,37.74,0.46,353,64471,70,NULL,NULL,'2MASX J16102331+1648354',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.5972917,16.80992,0.093,NULL,56564265181,883816643,13809635,18.1),(135926,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135926,37.56,0.33,325,64472,70,NULL,NULL,'2MASX J16102430+4858588',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.601417,48.98292,0.017,NULL,59704999848,932890622,14576415,17.4),(135927,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135927,36.92,0.46,242,64473,70,NULL,NULL,'2MASX J16102530+1521144',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000175,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.605333333,15.35403,0.053,NULL,56544666597,883510415,13804850,16.6),(135928,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','PS1 SN PS11zw','N',135928,42.27,0.42,1990,64474,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zw HOST',0.4231,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135929,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135929,35.68,0.2,137,64475,74.4,NULL,NULL,'UGC 10238',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000033,NULL,'14.40',0.7,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,242.610625,12.30569,0.137,NULL,56552858426,883638412,13806850,14.4),(135930,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135930,35.91,0.4,152,64475,NULL,NULL,'mean','UGC 10238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135931,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135931,36.1,0.47,166,64475,NULL,NULL,'H','UGC 10238',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135932,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135932,37.83,0.46,367,64476,70,NULL,NULL,'2MASX J16102682+5333108',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.6117917,53.55294,0,NULL,57606477161,900101205,14064081,17),(135933,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135933,37.94,0.46,387,64477,70,NULL,NULL,'2MASX J16102765+1834581',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,242.6152917,18.58286,0.121,NULL,56516970104,883077657,13798088,NULL),(135934,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135934,38.46,0.46,492,64478,70,NULL,NULL,'SDSS J161027.98+212111.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'19.0g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.616583,21.35319,0.169,NULL,56508834601,882950540,13796102,19),(135935,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135935,37.89,0.46,378,64479,70,NULL,NULL,'SDSS J161030.09+212358.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.3g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.625375,21.3995,0.169,NULL,56508836881,882950576,13796102,18.3),(135936,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135936,36.24,0.25,177,64480,70,NULL,NULL,'GIN 477',NULL,'2001MNRAS.321..277C',2001,1,0.41,NULL,'G',0.000237,NULL,'17.0g',0.32,'S',NULL,NULL,NULL,NULL,1,242.627167,24.05461,0.177,NULL,59391460770,927991574,14499868,17),(135937,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135937,36.26,0.2,179,64481,74.4,NULL,NULL,'UGC 10246',NULL,'2013AJ....146...86T',2013,1,0.89,NULL,'G',0.000027,NULL,'15.6g',0.42,'Sab',NULL,NULL,NULL,NULL,1,242.629291667,27.49969,0.097,NULL,59729151617,933267994,14582312,15.6),(135938,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135938,37.56,0.33,325,64482,70,NULL,NULL,'2MASX J16103172+4858118',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.632458333,48.96986,0.017,NULL,59704997233,932890581,14576415,17.4),(135939,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135939,36.93,0.46,243,64483,70,NULL,NULL,'2MASX J16103204+4300028',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00014,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.633583333,43.00092,0.025,NULL,59805176790,934455887,14600873,16.6),(135940,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135940,37.47,0.46,311,64484,70,NULL,NULL,'2MASX J16103269+1728054',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.63625,17.46811,0.121,NULL,56563984324,883812255,13809566,17.3),(135941,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135941,37.01,0.91,252,64485,70,NULL,NULL,'2MASX J16103294-1119247',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.637291667,-11.32353,0.989,NULL,45581481485,712210648,11128291,15.6),(135942,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135942,36.57,0.46,206,64486,70,NULL,NULL,'2MASX J16103298+0844234',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.637625,8.73972,0.141,NULL,56582421897,884100342,13814067,17),(135943,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135943,37.58,0.46,328,64487,70,NULL,NULL,'SDSS J161033.18+293555.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000124,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.638291667,29.59881,0.085,NULL,59736818152,933387783,14584184,18.5),(135944,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135944,37.36,0.33,297,64488,70,NULL,NULL,'SDSS J161033.22+101015.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.638458333,10.17089,0.161,NULL,56586897037,884170266,13815160,18),(135945,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135945,36.11,0.2,167,64489,74.4,NULL,NULL,'CGCG 079-071',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000622,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,242.639791667,13.69464,0.101,NULL,56555503584,883679743,13807495,15.6),(135946,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135946,35.78,0.49,143,64490,75,NULL,'IR','CGCG 079-071',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000622,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,242.639791667,13.69464,0.101,NULL,56555503584,883679743,13807495,15.6),(135947,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135947,35.15,0.47,107,64491,70,NULL,NULL,'2MASX J16103449-1151317',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000057,NULL,'16.37',NULL,NULL,NULL,NULL,NULL,NULL,1,242.6437917,-11.85892,1.041,NULL,45580576204,712196503,11128070,16.37),(135948,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135948,36.12,0.46,168,64492,70,NULL,NULL,'CGCG 051-059',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000167,NULL,'15.4g',0.5,'AGN',NULL,NULL,NULL,NULL,1,242.6452917,4.75467,0.221,NULL,56491568924,882680764,13791886,15.4),(135949,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135949,38.03,0.46,403,64493,70,NULL,NULL,'2MASX J16103505+1446115',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.64625,14.77006,0.089,NULL,56552675815,883635559,13806805,18.4),(135950,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135950,37.36,0.15,297,64494,70,NULL,NULL,'2MASX J16103526+5248028',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000093,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.646958333,52.80072,0,NULL,59700501190,932820331,14575317,16.7),(135951,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135951,35.58,0.49,131,64495,75,NULL,'IR','UGC 10248',NULL,'2011yCatp016004901K',2011,1,0.94,NULL,'G',0.000017,NULL,'16.8g',0.14,'Sb',NULL,NULL,NULL,NULL,1,242.6540417,29.51322,0.097,NULL,59736833173,933388018,14584187,16.8),(135952,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135952,36.06,0.2,163,64495,74.4,NULL,NULL,'UGC 10248',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135953,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135953,37.51,0.33,317,64496,70,NULL,NULL,'2MASX J16103779+5324208',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00012,NULL,'15.8g',0.5,'AGN',NULL,NULL,NULL,NULL,1,242.657375,53.40586,0,NULL,59699693717,932807714,14575120,15.8),(135954,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135954,37.54,0.46,323,64497,70,NULL,NULL,'2MASX J16103809+1245495',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.65875,12.76386,0.133,NULL,56553044595,883641321,13806895,17.1),(135955,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 1965F',NULL,135955,35.22,0.29,111,64498,NULL,NULL,'Avg. of 8 SN host galaxies','KUG 1608+191',NULL,'1985ApJ...297...23D',1985,1,0.62,NULL,'G',0.00013,NULL,'15.7g',0.35,'Sc',NULL,NULL,NULL,NULL,1,242.661417,19.0575,0.105,NULL,56516854701,883075854,13798060,15.7),(135956,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135956,36.38,0.46,189,64499,70,NULL,NULL,'2MASX J16103907+0017445',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000108,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.662875,0.29569,0.377,NULL,56447913104,881998642,13781228,17),(135957,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135957,37.48,0.46,313,64500,70,NULL,NULL,'2MASX J16103931+3429268',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.663833,34.49078,0.017,NULL,59783742591,934120977,14595640,17),(135958,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135958,37.77,0.27,358,64501,70,NULL,NULL,'2MASX J16104020+4739599',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.6675,47.66653,NULL,NULL,59702521858,932851904,14575811,17.2),(135959,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135959,36.35,0.46,187,64502,70,NULL,NULL,'2MASX J16104077+3015188',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000187,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,242.6697917,30.25514,0.073,NULL,59738549787,933414840,14584606,16),(135960,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135960,37.17,0.46,272,64503,70,NULL,NULL,'2MASX J16104089+2341042',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000137,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.6705417,23.68458,0.181,NULL,59391523081,927992548,14499883,17.5),(135961,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135961,37.48,0.46,313,64504,70,NULL,NULL,'SDSS J161041.37+523703.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000945,NULL,'18.0g',0.15,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,242.6724583,52.61756,0.005,NULL,59700541759,932820964,14575327,18),(135962,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135962,37.77,0.27,358,64505,70,NULL,NULL,'2MASX J16104348+4732219',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000096,NULL,'16.5g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,242.681417,47.53953,NULL,NULL,59702560644,932852510,14575820,16.5),(135963,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135963,38.36,0.23,470,64506,70,NULL,NULL,'2MASX J16104393+1649495',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.683125,16.83028,0.093,NULL,56564310268,883817347,13809646,17.7),(135964,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135964,37.64,0.46,337,64507,70,NULL,NULL,'2MASX J16104507+0005235',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.68775,0.08981,0.357,NULL,56447350334,881989848,13781091,17.4),(135965,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135965,35.79,0.46,144,64508,70,NULL,NULL,'2MASX J16104517+1459595',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.688291667,14.99986,0.073,NULL,56551943852,883624122,13806626,16.7),(135966,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135966,38.49,0.46,499,64509,70,NULL,NULL,'SDSS J161045.44-000700.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000097,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.689333333,-0.11675,0.357,NULL,45504600835,711009388,11109521,18.5),(135967,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135967,37.87,0.46,376,64510,70,NULL,NULL,'2MASX J16104552+2611496',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.6897083,26.19717,0.121,NULL,59729263723,933269745,14582339,18),(135968,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135968,37.91,0.46,382,64511,70,NULL,NULL,'2MASX J16104633+1721075',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.692875,17.35225,0.113,NULL,56564221397,883815959,13809624,17.9),(135969,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135969,37.36,0.11,296,64512,70,NULL,NULL,'2MASX J16104666+3707112',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.694458333,37.11978,0,NULL,59772237303,933941207,14592831,16.5),(135970,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135970,37.42,0.46,305,64513,70,NULL,NULL,'2MASX J16104718+5214507',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.696667,52.24744,0.017,NULL,59700256476,932816507,14575257,17.1),(135971,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135971,36.95,0.33,245,64514,70,NULL,NULL,'2MASX J16104770+1131194',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,242.698875,11.52211,0.209,NULL,56587587885,884181060,13815329,16.3),(135972,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135972,37.36,0.15,297,64515,70,NULL,NULL,'2MASX J16104791+5226427',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000079,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.6994583,52.44536,0,NULL,59700223527,932815992,14575249,16.9),(135973,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135973,38.87,0.46,595,64516,70,NULL,NULL,'2MASX J16104845+0723134',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000166,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.701875,7.38719,0.193,NULL,56463600610,882243759,13785058,18.6),(135974,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135974,38.01,0.46,400,64517,70,NULL,NULL,'2MASX J16104857+3309058',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.7g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,242.7024583,33.15164,0.021,NULL,59784627728,934134808,14595856,16.7),(135975,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135975,37.88,0.46,377,64518,70,NULL,NULL,'2MASX J16104947+0018465',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000107,NULL,'17.3g',0.22,'AGN',NULL,NULL,NULL,NULL,1,242.7062083,0.31286,0.377,NULL,56447882876,881998169,13781221,17.3),(135976,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135976,37.95,0.33,390,64519,70,NULL,NULL,'SDSS J161050.47+134339.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.710333333,13.72758,0.101,NULL,56555702305,883682848,13807544,18.4),(135977,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135977,35.75,0.2,141,64520,74.4,NULL,NULL,'KUG 1608+171',NULL,'2013AJ....146...86T',2013,1,0.83,NULL,'G',0.00001,NULL,'14.7g',0.43,'Sb','Supercluster (RV-confirmed) member',NULL,NULL,NULL,1,242.713125,17.05742,0.109,NULL,56564345189,883817893,13809654,14.7),(135978,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135978,35.9,0.31,151,64520,NULL,NULL,'Malmquist cor.','KUG 1608+171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135979,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135979,35.95,0.3,155,64520,NULL,NULL,NULL,'KUG 1608+171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(135980,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135980,35.4,0.55,120,64521,70,NULL,NULL,'2MASX J16105184-2458266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.715958333,-24.974,0.725,NULL,47111339074,736114673,11501791,14.8),(135981,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135981,37.09,0.46,262,64522,70,NULL,NULL,'2MASX J16105217+0357146',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00016,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,242.717375,3.95392,0.233,NULL,56504685679,882885713,13795089,17.6),(135982,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135982,35.37,0.46,118,64523,70,NULL,NULL,'CGCG 223-049',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000199,NULL,'14.3g',0.74,'S?','Field galaxy',NULL,NULL,NULL,1,242.717583,41.88583,0,NULL,59807516442,934492444,14601444,14.3),(135983,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135983,37.14,0.46,267,64524,70,NULL,NULL,'SDSS J161053.89-000215.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00009,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.7245417,-0.03758,0.357,NULL,45504606109,711009470,11109522,18.4),(135984,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135984,37.74,0.46,354,64525,70,NULL,NULL,'LCSB S2219P',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.727125,20.14317,0.093,NULL,56519982351,883124724,13798823,16.8),(135985,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135985,37.95,0.33,390,64526,70,NULL,NULL,'SDSS J161054.75+133826.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,242.728167,13.64072,0.101,NULL,56555569195,883680768,13807512,NULL),(135986,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135986,37.77,0.27,358,64527,70,NULL,NULL,'2MASX J16105611+4728319',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000086,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.7337083,47.47556,NULL,NULL,59702553705,932852401,14575818,17),(135987,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135987,37.05,0.46,256,64528,70,NULL,NULL,'2MASX J16105690+2436415',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,242.737166667,24.61153,0.177,NULL,59861307388,935332927,14614576,16.6),(135988,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135988,38.33,0.46,464,64529,70,NULL,NULL,'2MASX J16105726+3518168',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.7387083,35.30458,0,NULL,59773058796,933954043,14593031,17.3),(135989,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135989,37.98,0.46,394,64530,70,NULL,NULL,'2MASX J16105890+1736391',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.7455417,17.61086,0.121,NULL,56564093609,883813962,13809593,17.2),(135990,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135990,37.36,0.11,296,64531,70,NULL,NULL,'SDSS J161058.92+365539.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.7455417,36.92775,0.013,NULL,59772221610,933940962,14592827,18.1),(135991,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135991,38.52,0.46,507,64532,70,NULL,NULL,'2MASX J16105977+1756501',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.7489583,17.94739,0.133,NULL,56561805414,883778209,13809034,17.8),(135992,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135992,37.36,0.11,296,64533,70,NULL,NULL,'2MASX J16110003+3650518',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000123,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,242.7502917,36.84769,0.013,NULL,59772080080,933938751,14592792,16.7),(135993,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135993,37.14,0.33,268,64534,70,NULL,NULL,'2MASX J16110019+0652243',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.7507917,6.87331,0.181,NULL,56463534245,882242722,13785042,16.5),(135994,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135994,37.53,0.46,320,64535,70,NULL,NULL,'2MASX J16110023+3834418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.751,38.57822,0.021,NULL,59770510682,933914229,14592409,17.6),(135995,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135995,33.07,0.49,41.2,64536,75,NULL,'IR','ESO 451- G 015',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000027,NULL,'14.85',0.2,'Sb',NULL,NULL,NULL,NULL,1,242.751167,-32.34575,0.881,NULL,46300819241,723450300,11303910,14.85),(135996,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135996,37.36,0.15,297,64537,70,NULL,NULL,'2MASX J16110032+5227216',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.751583,52.45611,0,NULL,59700223899,932815998,14575249,17.6),(135997,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135997,38.36,0.46,469,64538,70,NULL,NULL,'SDSS J161101.87+380615.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000129,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.7577917,38.10442,0.009,NULL,59770582711,933915354,14592427,18.5),(135998,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,135998,35.27,0.42,113,64539,70,NULL,NULL,'GIN 554',NULL,'2001MNRAS.321..277C',2001,1,0.49,NULL,'G',0.000133,NULL,'15.8g',0.47,'E/S0',NULL,NULL,NULL,NULL,1,242.758333,29.52467,0.085,NULL,59736619998,933384687,14584135,15.8),(135999,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',135999,36.84,0.16,233,64539,70,NULL,NULL,'GIN 554',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136000,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136000,36.23,0.46,176,64540,70,NULL,NULL,'2MASX J16110248+2509564',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,242.7602083,25.16581,0.169,NULL,59861553868,935336779,14614637,16.6),(136001,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:54','1','SN 2008cl',NULL,136001,37.45,0.19,290,64541,70,NULL,'SALT 2','UGC 10261',0.063434,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',NULL,NULL,'15.20',0.8,'S0-:;BrClG','Group member',NULL,NULL,NULL,1,242.766958333,52.45033,0,NULL,59700223053,932815985,14575249,15.2),(136002,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136002,37.79,0.27,362,64542,70,NULL,NULL,'2MASX J16110578+3621218',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.7742917,36.35611,0.041,NULL,59771652209,933932065,14592688,17.6),(136003,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136003,37.38,0.46,300,64543,70,NULL,NULL,'SDSS J161105.89-003927.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000061,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.7745417,-0.65775,0.413,NULL,45505017100,711015892,11109623,18.3),(136004,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136004,37.9,0.16,381,64544,70,NULL,NULL,'2MASX J16110702+3056021',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.779375,30.93381,0.069,NULL,59737745176,933402268,14584410,18.4),(136005,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136005,33.38,0.2,47.4,64545,74.4,NULL,NULL,'UGC 10257',NULL,'2013AJ....146...86T',2013,1,1.9,'Position in Kiso list (1984AnTok..192.595T) is incorrect.','G',0.000017,NULL,'14.81',0.4,'Sbc',NULL,NULL,NULL,NULL,1,242.781333,38.25131,0,NULL,59770617383,933915896,14592435,14.81),(136006,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136006,33.71,0.49,55.2,64545,75,NULL,'IR','UGC 10257',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136007,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136007,33.97,0.4,62.2,64545,NULL,NULL,'mean','UGC 10257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136008,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136008,34.19,0.47,69,64545,NULL,NULL,'H','UGC 10257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136009,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136009,37.36,0.11,296,64546,70,NULL,NULL,'SDSS J161108.23+365923.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.7842917,36.98972,0,NULL,59772215274,933940863,14592825,18.6),(136010,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136010,37.85,0.46,371,64547,70,NULL,NULL,'2MASX J16110960+2437495',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.789875,24.63047,0.177,NULL,59861305537,935332899,14614576,18),(136011,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136011,35.53,0.45,128,64548,NULL,NULL,'K','NGC 6095',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000103,NULL,'13.62',1.6,'S0-:',NULL,NULL,NULL,NULL,1,242.7957083,61.26797,0,NULL,57616503702,900257870,14066529,13.62),(136012,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136012,35.57,0.4,130,64548,NULL,NULL,'mean','NGC 6095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136013,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136013,38.22,0.46,440,64549,70,NULL,NULL,'SDSS J161112.38+384124.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.801583333,38.69003,0.009,NULL,59800711256,934386113,14599783,18.8),(136014,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136014,37.36,0.11,296,64550,70,NULL,NULL,'KUGX 1609+371A',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000133,NULL,'15.5g',0.58,'Compact;BrClG',NULL,NULL,NULL,NULL,1,242.807667,36.97339,0,NULL,59772214558,933940852,14592825,15.5),(136015,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136015,37.82,0.46,366,64551,70,NULL,NULL,'SDSS J161114.00+331207.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.808375,33.20206,0.021,NULL,59784181771,934127840,14595747,18.3),(136016,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136016,35.37,0.46,118,64552,70,NULL,NULL,'NGC 6077',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000073,NULL,'14.4g',0.78,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,242.808833333,26.92342,0.097,NULL,59729330219,933270784,14582356,14.4),(136017,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136017,37.81,0.19,365,64553,70,NULL,NULL,'2MASX J16111417+1659032',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.8092083,16.98428,0.109,NULL,56564269882,883816716,13809636,17.2),(136018,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136018,38.36,0.23,470,64554,70,NULL,NULL,'2MASX J16111550+1701042',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.8147083,17.01786,0.109,NULL,56564335280,883817738,13809652,16.9),(136019,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136019,37.36,0.11,296,64555,70,NULL,NULL,'KUG 1609+372',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',NULL,NULL,'16.8g',0.1,'Compact',NULL,NULL,NULL,NULL,1,242.8155,37.14269,0,NULL,59772179486,933940304,14592817,16.8),(136020,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136020,35.76,0.2,142,64556,74.4,NULL,NULL,'UGC 10249',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.93',0.5,'SBab',NULL,NULL,NULL,NULL,1,242.820916667,13.86614,0.097,NULL,56555722040,883683156,13807549,14.93),(136021,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136021,37.46,0.46,311,64557,70,NULL,NULL,'2MASX J16111754+1156064',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.823083333,11.93506,0.201,NULL,56573841492,883966273,13811973,17.5),(136022,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136022,37.44,0.46,308,64558,70,NULL,NULL,'2MASX J16111863+0012502',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000102,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.827667,0.21411,0.377,NULL,56447382415,881990350,13781099,17.1),(136023,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136023,37.36,0.11,296,64559,70,NULL,NULL,'2MASX J16111869+3657469',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000195,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.827875,36.96314,0,NULL,59772084530,933938820,14592794,17.6),(136024,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,'R',136024,38.36,0.23,470,64560,70,NULL,NULL,'SDSS J161118.77+165601.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.82825,16.93375,0.109,NULL,56563764315,883808817,13809512,18.4),(136025,'FP','2016-12-15 15:15:40','2016-12-16 11:20:54','1',NULL,NULL,136025,36.24,0.25,177,64561,70,NULL,NULL,'GIN 475',NULL,'2001MNRAS.321..277C',2001,1,0.38,NULL,'G',0.000199,NULL,'16.7g',0.31,'S',NULL,NULL,NULL,NULL,1,242.828417,24.182,0.169,NULL,59861255021,935332109,14614564,16.7),(136026,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136026,38.02,0.46,402,64561,70,NULL,NULL,'GIN 475',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136027,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136027,37.02,0.46,253,64562,70,NULL,NULL,'2MASX J16111904-0005396',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000095,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.829333333,-0.09439,0.425,NULL,45504636941,711009952,11109530,16.8),(136028,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136028,37.97,0.15,393,64563,70,NULL,NULL,'2MASX J16111906+2103573',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000179,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.829417,21.06606,0.141,NULL,56519773585,883121462,13798772,17.5),(136029,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136029,37.51,0.33,317,64564,70,NULL,NULL,'2MASX J16111953+5329536',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000064,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.831625,53.49817,0,NULL,57605805864,900090716,14063917,17.9),(136030,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136030,37.36,0.11,296,64565,70,NULL,NULL,'2MASX J16112010+3702479',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.8339583,37.04669,0,NULL,59772228038,933941063,14592829,17.6),(136031,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136031,35.63,0.46,134,64566,70,NULL,NULL,'CGCG 137-054',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000113,NULL,'15.2g',0.53,NULL,NULL,NULL,NULL,NULL,1,242.837458333,22.37522,0.173,NULL,56509660898,882963451,13796303,15.2),(136032,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136032,38.36,0.23,470,64567,70,NULL,NULL,'2MASX J16112116+1656568',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000152,NULL,'16.6g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,242.838083,16.94922,0.109,NULL,56563764684,883808823,13809512,16.6),(136033,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136033,36,0.25,158,64568,74.4,NULL,NULL,'NGC 6075',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.00005,NULL,'14.5g',0.74,'E/S0',NULL,NULL,NULL,NULL,1,242.844125,23.965,0.137,NULL,59391596547,927993696,14499901,14.5),(136034,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136034,36.24,0.25,177,64568,70,NULL,NULL,'NGC 6075',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136035,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136035,38.72,0.46,554,64569,70,NULL,NULL,'2MASX J16112256+2215483',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000182,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.84425,22.26333,0.173,NULL,56509637396,882963084,13796298,18.5),(136036,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136036,38.11,0.46,419,64570,70,NULL,NULL,'2MASX J16112316+3201181',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.8465,32.02181,0.057,NULL,59785191201,934143612,14595993,16.9),(136037,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136037,37.9,0.16,381,64571,70,NULL,NULL,'2MASX J16112326+3100041',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.846916667,31.00103,0.069,NULL,59737889032,933404516,14584445,18.2),(136038,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136038,34.85,0.46,93.5,64572,70,NULL,NULL,'CGCG 275-028',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000073,NULL,'15.3g',0.41,'E0','Group member',NULL,NULL,NULL,1,242.8482917,52.45478,0,NULL,59700230355,932816099,14575251,15.3),(136039,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136039,37.97,0.15,393,64573,70,NULL,NULL,'2MASX J16112421+2103113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.851,21.05319,0.141,NULL,56519705736,883120402,13798756,18),(136040,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136040,37.79,0.27,362,64574,70,NULL,NULL,'SDSS J161124.48+360329.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.852,36.05831,0.021,NULL,59771845258,933935082,14592735,18.3),(136041,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136041,37.36,0.11,296,64575,70,NULL,NULL,'2MASX J16112470+3703569',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.852917,37.06583,0,NULL,59772185872,933940404,14592818,17.1),(136042,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136042,37.81,0.19,365,64576,70,NULL,NULL,'2MASX J16112515+1653249',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.8547083,16.89014,0.109,NULL,56563770462,883808913,13809514,17.9),(136043,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136043,37.52,0.46,320,64577,70,NULL,NULL,'2MASX J16112515+1400239',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.854833,14.00656,0.097,NULL,56555642955,883681921,13807530,16.9),(136044,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136044,37.93,0.33,385,64578,70,NULL,NULL,'2MASX J16112534+1810493',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.855583,18.18039,0.129,NULL,56516468263,883069816,13797965,17.9),(136045,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136045,37.75,0.46,355,64579,70,NULL,NULL,'SDSS J161125.56+220129.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'19.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.8565417,22.02475,0.177,NULL,56509776338,882965255,13796332,19),(136046,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136046,37.95,0.19,389,64580,70,NULL,NULL,'SDSS J161126.13+293416.8',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000152,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.858875,29.57136,0.073,NULL,59736616573,933384633,14584134,18.7),(136047,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136047,36.62,0.46,211,64581,70,NULL,NULL,'2MASX J16112689+2757445',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,242.861875,27.96228,0.101,NULL,59740592419,933446756,14585105,16.7),(136048,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136048,36.84,0.16,233,64582,70,NULL,NULL,'2MASX J16112726+2947385',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000162,NULL,'16.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,242.8635,29.79411,0.073,NULL,59738473366,933413646,14584588,16.6),(136049,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136049,37.36,0.11,296,64583,70,NULL,NULL,'KUGX 1609+370A',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000117,NULL,'16.7g',0.31,'Compact',NULL,NULL,NULL,NULL,1,242.868417,36.91911,0.013,NULL,59772087041,933938860,14592794,16.7),(136050,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136050,35.09,0.25,104,64584,74.4,NULL,NULL,'GIN 553',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.00015,NULL,'16.0g',0.38,'Sc',NULL,NULL,NULL,NULL,1,242.873125,29.45014,0.081,NULL,59736651191,933385174,14584143,16),(136051,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136051,35.27,0.42,113,64584,70,NULL,NULL,'GIN 553',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136052,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136052,37.21,0.33,277,64585,70,NULL,NULL,'2MASX J16112960+2613345',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000193,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,242.873417,26.22633,0.121,NULL,59730350782,933286730,14582605,16.1),(136053,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136053,37.98,0.27,394,64586,70,NULL,NULL,'2MASX J16112964+2044163',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.8734583,20.73775,0.101,NULL,56519639958,883119374,13798740,17.7),(136054,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136054,37.36,0.11,296,64587,70,NULL,NULL,'2MASX J16112987+3700008',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,242.8745,37.00025,0,NULL,59772092459,933938944,14592796,17.6),(136055,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136055,37.14,0.33,268,64588,70,NULL,NULL,'2MASX J16113069+0643555',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.877833,6.73197,0.197,NULL,56461363034,882208797,13784512,17.5),(136056,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136056,35.77,0.4,143,64589,NULL,NULL,'mean','UGC 10256',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'15.4B',0.2,'Sb',NULL,NULL,NULL,NULL,1,242.87825,23.81161,0.137,NULL,59391568155,927993252,14499894,15.4),(136057,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136057,35.81,0.47,145,64589,NULL,NULL,'H','UGC 10256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136058,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136058,35.89,0.45,151,64589,NULL,NULL,'K','UGC 10256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136059,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136059,36.75,0.46,224,64590,70,NULL,NULL,'2MASX J16113152+0518362',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,242.881208333,5.31025,0.209,NULL,56491875125,882685548,13791961,16.2),(136060,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136060,37.93,0.33,385,64591,70,NULL,NULL,'2MASX J16113165+1803503',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.881917,18.06403,0.089,NULL,56561775244,883777738,13809027,17.4),(136061,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136061,38.69,0.46,546,64592,70,NULL,NULL,'SDSS J161133.05+475129.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000106,NULL,'18.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,242.887708333,47.85808,0.013,NULL,59705538561,932899040,14576547,18.4),(136062,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136062,37.49,0.46,315,64593,70,NULL,NULL,'2MASX J16113339+2634496',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.889167,26.58036,0.069,NULL,59729484339,933273192,14582393,16.8),(136063,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136063,37.21,0.33,277,64594,70,NULL,NULL,'2MASX J16113484+2621146',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,242.895125,26.35411,0.069,NULL,59729278174,933269971,14582343,16.6),(136064,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136064,35.29,0.46,114,64595,70,NULL,NULL,'2MASX J16113508+1637580',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000093,NULL,'15.4g',0.45,NULL,NULL,NULL,NULL,NULL,1,242.896125,16.63278,0.093,NULL,56563745607,883808525,13809508,15.4),(136065,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136065,37.95,0.19,389,64596,70,NULL,NULL,'SDSS J161135.63+293318.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.8984583,29.55514,0.073,NULL,59736613571,933384587,14584134,18.3),(136066,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136066,35.27,0.42,113,64597,70,NULL,NULL,'GIN 556',NULL,'2001MNRAS.321..277C',2001,1,0.31,NULL,'G',0.000127,NULL,'17.0g',0.26,'E',NULL,NULL,NULL,NULL,1,242.900875,29.49233,0.081,NULL,59736647003,933385109,14584142,17),(136067,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136067,37.95,0.19,389,64597,70,NULL,NULL,'GIN 556',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136068,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136068,36.21,0.46,175,64598,70,NULL,NULL,'2MASX J16113617+5013529',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00011,NULL,'15.6g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,242.900833,50.2315,0.041,NULL,59709738581,932964665,14577572,15.6),(136069,'SNIa','2016-12-15 15:15:40','2016-12-16 11:20:55','1','PS1 SN PS11zv','N',136069,41.29,0.18,1340,64599,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11zv HOST',0.3501,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136070,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136070,37.95,0.19,389,64600,70,NULL,NULL,'2MASX J16113752+2934556',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,242.906125,29.58217,0.073,NULL,59736612943,933384577,14584134,17.5),(136071,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136071,37.95,0.19,389,64601,70,NULL,NULL,'2MASX J16113751+2936136',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00014,NULL,'16.2g',0.41,'E;BrClG',NULL,NULL,NULL,NULL,1,242.90625,29.60383,0.073,NULL,59738461181,933413455,14584585,16.2),(136072,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136072,37.36,0.11,296,64602,70,NULL,NULL,'2MASX J16113807+3657047',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.908583333,36.95122,0,NULL,59772096253,933939003,14592796,16.7),(136073,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136073,37.14,0.46,267,64603,70,NULL,NULL,'2MASX J16113817+0534264',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.909125,5.57408,0.193,NULL,56491976832,882687138,13791986,17.1),(136074,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136074,38.22,0.33,441,64604,70,NULL,NULL,'2MASX J16113827+0851574',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.9095,8.86608,0.141,NULL,56582253035,884097703,13814026,18),(136075,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136075,37.36,0.11,296,64605,70,NULL,NULL,'2MASX J16113841+3655447',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'17.08',0.37,NULL,NULL,NULL,NULL,NULL,1,242.9100417,36.92908,0.013,NULL,59772094159,933938971,14592796,17.08),(136076,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136076,36.72,0.46,221,64606,70,NULL,NULL,'2MASX J16113871+2746276',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,242.911417,27.77439,0.097,NULL,59729117324,933267458,14582304,17.2),(136077,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136077,37.7,0.46,347,64607,70,NULL,NULL,'2MASX J16113911+0933244',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.913125,9.55683,0.133,NULL,56586496099,884164001,13815062,17.9),(136078,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136078,37.04,0.46,256,64608,70,NULL,NULL,'2MASX J16113926+3812417',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000117,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,242.9135417,38.21158,0,NULL,59770662006,933916593,14592446,15.9),(136079,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136079,37.9,0.16,381,64609,70,NULL,NULL,'B2 1609+31',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.0g',0.3,'S',NULL,NULL,'radio jet',NULL,1,242.917667,31.05033,0.069,NULL,59737895585,933404618,14584447,17),(136080,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136080,37.81,0.19,365,64610,70,NULL,NULL,'2MASX J16114040+1653410',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.91825,16.89472,0.109,NULL,56563799409,883809365,13809521,17.4),(136081,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136081,37.9,0.16,381,64611,70,NULL,NULL,'2MASX J16114072+3118145',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.919708333,31.30386,0.069,NULL,59737853691,933403963,14584436,17.8),(136082,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136082,37.11,0.46,264,64612,70,NULL,NULL,'2MASX J16114079+0019334',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.919917,0.32597,0.397,NULL,56447416845,881990888,13781107,16.7),(136083,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136083,36.66,0.46,214,64613,70,NULL,NULL,'2MASX J16114093+4156547',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000127,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.920417,41.94842,0,NULL,59807561211,934493143,14601455,16.2),(136084,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136084,37.68,0.33,343,64614,70,NULL,NULL,'2MASX J16114161+1747090',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.9235,17.78594,0.097,NULL,56563901033,883810953,13809546,17.5),(136085,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136085,37.81,0.19,365,64615,70,NULL,NULL,'2MASX J16114284+1655110',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.928375,16.91975,0.109,NULL,56563806919,883809483,13809523,17),(136086,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136086,36.52,0.46,201,64616,70,NULL,NULL,'2MASX J16114380+1414231',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,242.932583,14.23967,0.089,NULL,56555615746,883681496,13807523,16.1),(136087,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136087,37.9,0.16,381,64617,70,NULL,NULL,'2MASX J16114383+3123585',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,242.932667,31.39969,0.061,NULL,59783217740,934112777,14595512,17),(136088,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136088,37.97,0.15,393,64618,70,NULL,NULL,'2MASX J16114388+2059364',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,242.932875,20.99339,0.117,NULL,56519740382,883120943,13798764,16.8),(136089,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136089,37.36,0.15,297,64619,70,NULL,NULL,'2MASX J16114692+5216190',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000088,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.9455417,52.272,0.017,NULL,59708413223,932943956,14577249,17.9),(136090,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136090,37.83,0.46,368,64620,70,NULL,NULL,'2MASX J16114751+4344485',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000103,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,242.9480417,43.74686,0,NULL,59805830817,934466106,14601032,16.7),(136091,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136091,37.79,0.27,362,64621,70,NULL,NULL,'2MASX J16114857+3608077',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.952333333,36.13558,0.021,NULL,59771825909,933934779,14592730,17.9),(136092,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136092,37.68,0.33,343,64622,70,NULL,NULL,'2MASX J16114893+1748117',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000134,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,242.9537083,17.80342,0.097,NULL,56563902796,883810981,13809546,18.3),(136093,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136093,37.97,0.15,393,64623,70,NULL,NULL,'2MASX J16115059+2101134',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.9607917,21.02036,0.141,NULL,56519750824,883121106,13798767,17.5),(136094,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136094,36.74,0.33,223,64624,70,NULL,NULL,'2MASX J16115103+3002045',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,242.962667,30.03456,0.061,NULL,59738522287,933414410,14584600,17.2),(136095,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136095,37.97,0.15,393,64625,70,NULL,NULL,'2MASX J16115237+2058044',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.9682917,20.96781,0.117,NULL,56519752275,883121129,13798767,17.6),(136096,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136096,37.22,0.46,278,64626,70,NULL,NULL,'2MASXi J1611525+140000',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.968833333,14.00033,0.097,NULL,56555669051,883682328,13807536,18.1),(136097,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136097,34.62,0.52,83.8,64627,70,NULL,NULL,'2MASX J16115452-1628297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,242.977083,-16.47497,0.953,NULL,45493035749,710828683,11106698,15),(136098,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136098,37.42,0.46,305,64628,70,NULL,NULL,'2MASX J16115496+2705586',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,242.978916667,27.09969,0.097,NULL,59729821946,933278467,14582476,17.5),(136099,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136099,35.27,0.42,113,64629,70,NULL,NULL,'UGC 10262 NOTES01',NULL,'2001MNRAS.321..277C',2001,1,0.46,NULL,'G',0.00006,NULL,'15.9g',0.38,'SBab',NULL,NULL,NULL,NULL,1,242.98025,29.82969,0.065,NULL,59738452949,933413327,14584583,15.9),(136100,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136100,36.84,0.16,233,64629,70,NULL,NULL,'UGC 10262 NOTES01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136101,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136101,36.89,0.25,239,64629,74.4,NULL,NULL,'UGC 10262 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136102,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136102,38.22,0.33,441,64630,70,NULL,NULL,'2MASX J16115535+0852049',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.98075,8.86806,0.149,NULL,56582248166,884097627,13814025,18.5),(136103,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136103,37.95,0.19,389,64631,70,NULL,NULL,'2MASX J16115583+2929256',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.982625,29.49039,0.073,NULL,59736594277,933384285,14584129,17.8),(136104,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136104,38.65,0.33,538,64632,70,NULL,NULL,'2MASX J16115607+4151567',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.9835417,41.86597,0.009,NULL,59807542570,934492852,14601450,18.1),(136105,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136105,35.08,0.25,104,64633,74.4,NULL,NULL,'GIN 551',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000167,NULL,'15.7g',0.42,'Sb',NULL,NULL,NULL,NULL,1,242.985833,29.45456,0.081,NULL,59736647680,933385120,14584142,15.7),(136106,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136106,35.27,0.42,113,64633,70,NULL,NULL,'GIN 551',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136107,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136107,38.65,0.33,538,64634,70,NULL,NULL,'2MASX J16115661+4155567',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000173,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,242.986,41.93236,0,NULL,59807561867,934493154,14601455,18.2),(136108,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136108,36.37,0.46,188,64635,70,NULL,NULL,'2MASX J16115668+3944237',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,242.9862917,39.74006,0.009,NULL,59800970034,934390156,14599846,17.2),(136109,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136109,37.97,0.15,393,64636,70,NULL,NULL,'2MASX J16115680+2057004',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000208,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,242.986625,20.95025,0.117,NULL,56519744344,883121005,13798765,16.3),(136110,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136110,37.9,0.16,381,64637,70,NULL,NULL,'2MASX J16115695+3118416',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,242.987166667,31.31164,0.069,NULL,59737788055,933402938,14584420,17.7),(136111,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136111,37.9,0.16,381,64638,70,NULL,NULL,'2MASX J16115726+3106036',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.8g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,242.9887083,31.101,0.069,NULL,59737894528,933404602,14584446,16.8),(136112,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136112,37.81,0.19,365,64639,70,NULL,NULL,'2MASX J16115730+1701177',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,242.988917,17.02164,0.109,NULL,56563686838,883807606,13809493,17.7),(136113,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136113,37.9,0.16,381,64640,70,NULL,NULL,'2MASX J16115773+3100316',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,242.990667,31.00883,0.069,NULL,59737846651,933403853,14584435,17.8),(136114,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136114,37.81,0.19,365,64641,70,NULL,NULL,'2MASX J16115793+1658587',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000172,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,242.991375,16.98289,0.109,NULL,56563805828,883809466,13809522,16.7),(136115,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136115,37.97,0.15,393,64642,70,NULL,NULL,'SDSS J161157.94+205634.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000161,NULL,'18.6g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,242.9914583,20.94303,0.117,NULL,56519744426,883121006,13798765,18.6),(136116,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136116,36.89,0.25,239,64643,74.4,NULL,NULL,'UGC 10262',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000087,NULL,'13.48',0.9,'S0;BrClG',NULL,NULL,NULL,NULL,1,242.99225,29.83856,0.065,NULL,59738452331,933413317,14584583,13.48),(136117,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136117,35.27,0.42,113,64644,70,NULL,NULL,'SDSS J161158.62+295021.8',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'25.1g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,242.99425,29.83942,0.065,NULL,59738452322,933413317,14584583,25.1),(136118,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136118,37.97,0.15,393,64645,70,NULL,NULL,'2MASX J16115909+2100124',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000179,NULL,'17.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,242.996166667,21.00344,0.141,NULL,56519753353,883121146,13798767,17.8),(136119,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136119,38.19,0.33,435,64646,70,NULL,NULL,'SDSS J161159.90-000806.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000095,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,242.999583,-0.13508,0.425,NULL,45504767275,711011988,11109562,18.7),(136120,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136120,35.95,0.46,155,64647,70,NULL,NULL,'2MASX J16120028+2033154',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000184,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,243.0010417,20.55422,0.101,NULL,56520321430,883130022,13798906,15.9),(136121,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136121,37.48,0.46,313,64648,70,NULL,NULL,'2MASX J16120090+3018456',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.0039583,30.31264,0.049,NULL,59738090051,933407657,14584494,17.4),(136122,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136122,36.84,0.16,233,64649,70,NULL,NULL,'2MASX J16120166+2933196',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000185,NULL,'16.5g',0.32,'E',NULL,NULL,NULL,NULL,1,243.006958333,29.55528,0.073,NULL,59736594695,933384292,14584129,16.5),(136123,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136123,37.47,0.46,312,64650,70,NULL,NULL,'2MASX J16120190+3833237',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.0079583,38.55653,0.021,NULL,59800584423,934384131,14599752,17.8),(136124,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136124,37.9,0.33,380,64651,70,NULL,NULL,'2MASX J16120195+2515176',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,243.0082083,25.25492,0.157,NULL,59727488824,933242012,14581906,NULL),(136125,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136125,38.07,0.46,412,64652,70,NULL,NULL,'2MASX J16120220+2953236',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000199,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.009,29.88981,0.065,NULL,59738453399,933413334,14584583,16.9),(136126,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136126,38.15,0.33,427,64653,70,NULL,NULL,'2MASX J16120461+4014037',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.019333,40.23422,0,NULL,59801388306,934396692,14599948,16.8),(136127,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136127,37.95,0.46,389,64654,70,NULL,NULL,'2MASX J16120491+0033268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000074,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.020417,0.55739,0.341,NULL,56447328490,881989507,13781086,17.9),(136128,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136128,37.9,0.33,380,64655,70,NULL,NULL,'2MASX J16120500+2517296',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000203,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.020875,25.29164,0.157,NULL,59727490473,933242038,14581906,17.3),(136129,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136129,36.84,0.16,233,64656,70,NULL,NULL,'2MASX J16120536+2932496',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'16.9g',0.26,'E',NULL,NULL,NULL,NULL,1,243.022375,29.54703,0.073,NULL,59736594885,933384295,14584129,16.9),(136130,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136130,38.15,0.33,427,64657,70,NULL,NULL,'2MASX J16120572+4008247',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.023708333,40.14033,0,NULL,59801362407,934396287,14599941,17.7),(136131,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136131,36,0.25,158,64658,74.4,NULL,NULL,'GIN 473',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000057,NULL,'15.11',NULL,'S',NULL,NULL,NULL,NULL,1,243.0247917,23.84133,0.137,NULL,59391572071,927993313,14499895,15.11),(136132,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136132,36.24,0.25,177,64658,70,NULL,NULL,'GIN 473',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136133,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136133,36,0.25,158,64659,74.4,NULL,NULL,'GIN 474',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000057,NULL,'15.9g',0.41,'E/S0',NULL,NULL,NULL,NULL,1,243.032083,23.71814,0.137,NULL,59391495772,927992121,14499876,15.9),(136134,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136134,36.24,0.25,177,64659,70,NULL,NULL,'GIN 474',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136135,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136135,37.02,0.46,253,64660,70,NULL,NULL,'2MASX J16120926+0003328',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000116,NULL,'16.4g',0.34,'AGN',NULL,NULL,NULL,NULL,1,243.0387083,0.05922,0.433,NULL,56447254482,881988351,13781067,16.4),(136136,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136136,36.98,0.27,249,64661,70,NULL,NULL,'2MASX J16120946+3206565',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.039375,32.11578,0.057,NULL,59783133776,934111465,14595491,17.8),(136137,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136137,38.12,0.46,421,64662,70,NULL,NULL,'2MASX J16120971+0650559',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.040417,6.84883,0.209,NULL,56460963297,882202551,13784414,17.6),(136138,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136138,37.63,0.46,336,64663,70,NULL,NULL,'2MASX J16121056+4754236',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,243.044,47.90642,0.009,NULL,59705583972,932899749,14576558,16.3),(136139,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136139,35.27,0.42,113,64664,70,NULL,NULL,'CGCG 167-042',NULL,'2001MNRAS.321..277C',2001,1,0.7,NULL,'G',0.000047,NULL,'14.50',0.7,'Sb',NULL,NULL,NULL,NULL,1,243.046917,29.57411,0.073,NULL,59738433429,933413022,14584578,14.5),(136140,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136140,36.91,0.25,241,64664,74.4,NULL,NULL,'CGCG 167-042',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136141,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136141,36.71,0.46,220,64665,70,NULL,NULL,'2MASX J16121219+1249457',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.050875,12.82947,0.133,NULL,56552920585,883639384,13806865,16.5),(136142,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136142,38.05,0.46,407,64666,70,NULL,NULL,'SDSS J161212.21+430953.3',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.050917,43.16483,0,NULL,59805304628,934457884,14600904,17.8),(136143,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136143,36.98,0.27,249,64667,70,NULL,NULL,'2MASX J16121249+3209263',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.052125,32.15728,0.057,NULL,59783120526,934111258,14595488,16.9),(136144,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136144,36.48,0.46,197,64668,70,NULL,NULL,'2MASX J16121274+1058469',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.053083,10.97964,0.173,NULL,56574320930,883973764,13812090,16.4),(136145,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136145,37.55,0.46,323,64669,70,NULL,NULL,'2MASX J16121281+4213096',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00013,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.053208333,42.21925,NULL,NULL,59806650052,934478907,14601232,17.3),(136146,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136146,37.54,0.33,322,64670,70,NULL,NULL,'2MASX J16121352+4015481',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000107,NULL,'16.0g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,243.056375,40.26331,0,NULL,59801388181,934396690,14599948,16),(136147,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136147,37.97,0.15,393,64671,70,NULL,NULL,'2MASX J16121363+2105309',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.05675,21.09192,0.141,NULL,56519696142,883120252,13798753,17.3),(136148,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136148,37.23,0.33,279,64672,70,NULL,NULL,'2MASX J16121365+2412536',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.0570417,24.21494,0.153,NULL,59861152468,935330507,14614539,17.1),(136149,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136149,37.59,0.46,329,64673,70,NULL,NULL,'2MASX J16121385+1713116',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.057875,17.21981,0.113,NULL,56563671035,883807359,13809489,17.4),(136150,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136150,36.83,0.56,232,64674,70,NULL,NULL,'2MASX J16121465-0059356',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000104,NULL,'15.8g',0.49,NULL,NULL,NULL,NULL,NULL,1,243.060958333,-0.99317,0.445,NULL,45504380284,711005941,11109467,15.8),(136151,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136151,36.76,0.46,225,64675,70,NULL,NULL,'2MASX J16121470+4831379',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000113,NULL,'15.7g',0.41,'E0',NULL,NULL,NULL,NULL,1,243.0612917,48.52719,0,NULL,59705770188,932902659,14576604,15.7),(136152,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136152,37.56,0.46,326,64676,70,NULL,NULL,'2MASX J16121522+0554278',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.063375,5.90781,0.181,NULL,56491108638,882673572,13791774,17.2),(136153,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136153,38.23,0.46,442,64677,70,NULL,NULL,'2MASX J16121537+5234034',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000098,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.063875,52.56767,0,NULL,59699772651,932808947,14575139,17.5),(136154,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136154,37.33,0.46,293,64678,70,NULL,NULL,'2MASX J16121555+1722276',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000178,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.064917,17.37428,0.121,NULL,56564122632,883814416,13809600,16.9),(136155,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136155,35.27,0.42,113,64679,70,NULL,NULL,'GIN 549',NULL,'2001MNRAS.321..277C',2001,1,0.36,NULL,'G',0.00006,NULL,'16.4g',0.34,'S              Sy2',NULL,NULL,NULL,'Sy 2',1,243.069666667,29.57306,0.073,NULL,59738437467,933413085,14584579,16.4),(136156,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136156,36.91,0.25,241,64679,74.4,NULL,NULL,'GIN 549',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136157,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136157,37.62,0.46,334,64680,70,NULL,NULL,'2MASX J16121716+3911112',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.071417,39.18636,0,NULL,59800678869,934385607,14599775,17.3),(136158,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136158,37.36,0.11,296,64681,70,NULL,NULL,'2MASXi J1612173+370743',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000165,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.0722917,37.12886,0.017,NULL,59772062976,933938484,14592788,17.4),(136159,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136159,37.73,0.46,352,64682,70,NULL,NULL,'2MASX J16121746+2133080',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.072833,21.55233,0.137,NULL,56508465141,882944767,13796011,17.7),(136160,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136160,36.18,0.46,172,64683,70,NULL,NULL,'2MASX J16121762+2825466',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.0002,NULL,'15.4g',0.56,'E/(S0)',NULL,NULL,NULL,NULL,1,243.0734583,28.42958,0.089,NULL,59741546885,933461670,14585338,15.4),(136161,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136161,35.94,0.23,154,64684,70,NULL,NULL,'MRK 0697',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000117,NULL,'15.5g',0.45,'E',NULL,NULL,NULL,NULL,1,243.075625,29.07933,0.085,NULL,59741286034,933457594,14585274,15.5),(136162,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136162,36.84,0.16,233,64685,70,NULL,NULL,'2MASX J16121839+2932507',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000147,NULL,'16.8g',0.31,'E',NULL,NULL,NULL,NULL,1,243.0765,29.54733,0.073,NULL,59738425355,933412896,14584576,16.8),(136163,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136163,38.19,0.33,435,64686,70,NULL,NULL,'SDSS J161220.14-000925.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000095,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.083917,-0.15719,0.425,NULL,45504578278,711009035,11109516,18.7),(136164,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136164,31.86,NULL,23.5,64687,72,NULL,NULL,'AGC 268216',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'RadioS',0.000077,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,243.085417,6.53833,0.197,NULL,56461608118,882212626,13784572,NULL),(136165,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136165,37.01,0.46,253,64688,70,NULL,NULL,'2MASX J16122077+0325078',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.0865417,3.41883,0.233,NULL,56504975484,882890241,13795160,17),(136166,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136166,35.94,0.23,154,64689,70,NULL,NULL,'2MASX J16122114+2938507',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.0g',0.21,'E',NULL,NULL,NULL,NULL,1,243.088125,29.64744,0.073,NULL,59738438927,933413108,14584579,17),(136167,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136167,37.87,0.27,374,64690,70,NULL,NULL,'2MASX J16122177+1048312',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.090583333,10.80872,0.177,NULL,56575955726,883999308,13812489,17.6),(136168,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136168,36.84,0.16,233,64691,70,NULL,NULL,'2MASX J16122183+2952487',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,243.091125,29.88025,0.065,NULL,59737947023,933405422,14584459,16.4),(136169,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136169,36.24,0.25,177,64692,70,NULL,NULL,'GIN 476',NULL,'2001MNRAS.321..277C',2001,1,0.29,NULL,'G',0.000107,NULL,'17.1g',0.27,'E',NULL,NULL,NULL,NULL,1,243.092583333,24.20722,0.153,NULL,59861145393,935330396,14614537,17.1),(136170,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136170,37.23,0.33,279,64692,70,NULL,NULL,'GIN 476',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136171,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136171,38.35,0.46,468,64693,70,NULL,NULL,'2MASX J16122250+1833560',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.09375,18.56561,0.113,NULL,56517685835,883088841,13798263,17.6),(136172,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136172,36.03,0.46,160,64694,70,NULL,NULL,'2MASX J16122266+5258275',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.0g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,243.09425,52.97442,0,NULL,59699882375,932810662,14575166,16),(136173,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136173,36.98,0.27,249,64695,70,NULL,NULL,'2MASX J16122384+3204154',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00019,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,243.0992917,32.07103,0.057,NULL,59783132702,934111448,14595491,15.8),(136174,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136174,38.04,0.46,406,64696,70,NULL,NULL,'2MASX J16122570+4033202',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.107166667,40.55561,0,NULL,59799554395,934368037,14599500,17),(136175,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136175,38.22,0.46,441,64697,70,NULL,NULL,'SDSS J161226.17+501923.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000081,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.1090417,50.32331,0.021,NULL,59709808768,932965762,14577590,18.3),(136176,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136176,33.79,NULL,57.3,64698,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10274',NULL,'2010Ap&SS.325..163P',2010,1,1.61,NULL,'G',0.000041,NULL,'15.8g',0.21,'Scd',NULL,NULL,NULL,NULL,1,243.111291667,38.24292,0.009,NULL,59770625341,933916020,14592437,15.8),(136177,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136177,33.8,NULL,57.7,64698,NULL,NULL,'Dipole + Quadrupole','UGC 10274',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136178,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136178,33.81,NULL,57.7,64698,NULL,NULL,'Dipole','UGC 10274',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136179,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136179,33.88,NULL,59.6,64698,NULL,NULL,NULL,'UGC 10274',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136180,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136180,34.18,0.2,68.6,64698,74.4,NULL,NULL,'UGC 10274',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136181,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136181,37.5,0.46,316,64699,70,NULL,NULL,'SDSS J161226.87+414015.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.1120417,41.67097,0.009,NULL,59807577247,934493394,14601459,18.2),(136182,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136182,36.36,0.46,187,64700,70,NULL,NULL,'2MASX J16122736+1251381',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.3g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.114167,12.86053,0.133,NULL,56552921265,883639394,13806865,16.3),(136183,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136183,35.98,0.46,157,64701,70,NULL,NULL,'2MASX J16122767+0605402',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000184,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,243.115375,6.09467,0.189,NULL,56460711175,882198612,13784353,16.2),(136184,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136184,37.54,0.33,322,64702,70,NULL,NULL,'2MASX J16122960+4008313',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.1234583,40.14186,0,NULL,59801583862,934399747,14599996,17.4),(136185,'BCG','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136185,36.17,0.35,166,64703,60,NULL,NULL,'ABELL 2162',0.0318,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,243.124958333,29.53978,0.073,NULL,59738425842,933412903,14584576,NULL),(136186,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136186,37.69,0.46,345,64704,70,NULL,NULL,'2MASX J16123046+1919050',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.127167,19.31806,0.129,NULL,56517409538,883084524,13798195,17.3),(136187,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136187,37.28,0.46,286,64705,70,NULL,NULL,'2MASX J16123049+2801137',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.127167,28.02053,0.097,NULL,59741462813,933460356,14585318,17.8),(136188,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136188,38.23,0.46,442,64706,70,NULL,NULL,'2MASX J16123164+0809032',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.132,8.15106,0.181,NULL,56462532556,882227071,13784797,18),(136189,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136189,37.45,0.46,309,64707,70,NULL,NULL,'SDSS J161232.38+220317.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.134916667,22.05492,0.117,NULL,56509256754,882957136,13796205,17.6),(136190,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136190,37.87,0.27,374,64708,70,NULL,NULL,'2MASX J16123257+1100152',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.1357083,11.00422,0.173,NULL,56574315123,883973673,13812088,17.2),(136191,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136191,37.97,0.15,393,64709,70,NULL,NULL,'SDSS J161233.83+205833.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'18.0g',0.19,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.1409583,20.97603,0.141,NULL,56520219182,883128424,13798881,18),(136192,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136192,37.5,0.46,316,64710,70,NULL,NULL,'2MASX J16123500+3806413',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.145625,38.11164,0.009,NULL,59770621712,933915964,14592436,17.5),(136193,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136193,35.64,0.47,134,64711,NULL,NULL,'H','NGC 6085',NULL,'2007A&A...465...71T',2007,1,1.49,NULL,'G',0.000077,NULL,'13.9g',1.04,'Sa','Group member',NULL,NULL,NULL,1,243.14675,29.36508,0.081,NULL,59741059338,933454052,14585219,13.9),(136194,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136194,35.71,0.45,139,64711,NULL,NULL,'K','NGC 6085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136195,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136195,35.75,0.46,141,64711,NULL,NULL,'J','NGC 6085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136196,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136196,35.79,0.4,144,64711,NULL,NULL,'mean','NGC 6085',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136197,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136197,37.31,0.46,289,64712,70,NULL,NULL,'2MASX J16123544+1138372',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.147666667,11.64356,0.201,NULL,56574809164,883981393,13812209,16.8),(136198,'BCG','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136198,36.17,0.35,166,64713,60,NULL,'ABELL 2162, BCG','NGC 6086',0.0318,'1980ApJ...241..486H',1980,1,1.7,NULL,'G',0.000083,NULL,'13.79',1.2,'cD;E','Group member',NULL,NULL,NULL,1,243.1480417,29.48478,0.073,NULL,59736591700,933384245,14584128,13.79),(136199,'D-Sigma','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136199,35.49,0.4,126,64713,75,NULL,'Edat, raw','NGC 6086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136200,'D-Sigma','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136200,35.83,0.4,147,64713,75,NULL,'Edat, cor','NGC 6086',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136201,'Faber-Jackson','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136201,35.13,0.55,106,64713,95,NULL,'Weighted Mean','NGC 6086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136202,'Faber-Jackson','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136202,35.13,0.55,106,64713,95,NULL,'de Vaucouleurs','NGC 6086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136203,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136203,35.08,0.25,104,64713,74.4,NULL,NULL,'NGC 6086',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136204,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136204,35.27,0.42,113,64713,70,NULL,NULL,'NGC 6086',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136205,'Tertiary','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136205,34.9,0.5,95.5,64713,95,NULL,NULL,'NGC 6086',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136206,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136206,35.75,0.4,141,64713,NULL,NULL,'mean','NGC 6086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136207,'Tully-Fisher','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,NULL,136207,35.94,0.45,154,64713,NULL,NULL,'K','NGC 6086',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136208,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136208,37.36,0.11,296,64714,70,NULL,NULL,'2MASX J16123622+3654083',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.151083,36.90239,0.009,NULL,59772048150,933938252,14592785,17),(136209,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136209,37.98,0.27,394,64715,70,NULL,NULL,'2MASX J16123674+2046317',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.1529583,20.77542,0.117,NULL,56520257490,883129023,13798890,18.1),(136210,'FP','2016-12-15 15:15:40','2016-12-16 11:20:55','1',NULL,'R',136210,37.35,0.46,295,64716,70,NULL,NULL,'2MASX J16123707+2008267',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.154375,20.14067,0.129,NULL,56519925247,883123831,13798809,16.9),(136211,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136211,34.95,0.46,97.8,64717,70,NULL,NULL,'2MASX J16123720+3925083',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00008,NULL,'15.5g',0.48,'S0/a',NULL,NULL,NULL,NULL,1,243.1550417,39.41903,0.005,NULL,59800617536,934384649,14599760,15.5),(136212,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136212,37.11,0.46,265,64718,70,NULL,NULL,'2MASX J16123868+1340181',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.161125,13.67175,0.097,NULL,56555080337,883673130,13807392,17.4),(136213,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136213,35.08,0.25,104,64719,74.4,NULL,NULL,'CGCG 167-046',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.00013,NULL,'15.1g',0.46,'S0/a',NULL,NULL,NULL,NULL,1,243.161875,29.64361,0.073,NULL,59737908251,933404816,14584450,15.1),(136214,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136214,35.27,0.42,113,64719,70,NULL,NULL,'CGCG 167-046',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136215,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136215,35.94,0.23,154,64719,70,NULL,NULL,'CGCG 167-046',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136216,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136216,39.15,0.46,676,64720,70,NULL,NULL,'SDSS J161239.27+370835.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.163667,37.14317,0.017,NULL,59772930938,933952045,14593000,18.6),(136217,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136217,36.38,0.46,189,64721,70,NULL,NULL,'2MASX J16124183+0438531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.17425,4.64794,0.213,NULL,56502850895,882857045,13794641,16.8),(136218,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136218,37.87,0.27,374,64722,70,NULL,NULL,'2MASX J16124238+1053436',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,243.176625,10.89542,0.173,NULL,56575954172,883999283,13812488,NULL),(136219,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136219,36.74,0.33,223,64723,70,NULL,NULL,'SDSS J161242.69+295404.7',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,243.177917,29.90133,0.061,NULL,59737942763,933405355,14584458,15.6),(136220,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136220,35.59,0.46,131,64724,70,NULL,NULL,'2MASX J16124302+0844396',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.1792083,8.74431,0.149,NULL,56461672433,882213631,13784587,16.2),(136221,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136221,37.93,0.46,385,64725,70,NULL,NULL,'2MASX J16124354+2911505',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.181583333,29.19753,0.085,NULL,59741109008,933454828,14585231,17.7),(136222,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136222,37.37,0.46,298,64726,70,NULL,NULL,'2MASX J16124501+4937495',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.187583333,49.63033,0.009,NULL,59703037280,932859957,14575936,17.1),(136223,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136223,37.13,0.13,267,64727,70,NULL,NULL,'2MASX J16124609+4905536',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000098,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,243.192125,49.09828,0.017,NULL,59705095489,932892117,14576439,16.2),(136224,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136224,38.07,0.46,410,64728,70,NULL,NULL,'2MASX J16124682+2656125',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.19525,26.93675,0.069,NULL,59729785556,933277899,14582467,17.6),(136225,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136225,34.86,0.46,93.9,64729,70,NULL,NULL,'UGC 10275',NULL,'2015arXiv151105856S',2015,1,1.12,'NGC 6092 is a double star.','G',0.000103,NULL,'14.3g',0.83,'E',NULL,NULL,NULL,NULL,1,243.1955417,27.98733,0.113,NULL,59740951919,933452373,14585193,14.3),(136226,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136226,37.36,0.11,296,64730,70,NULL,NULL,'2MASX J16124761+3653496',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000107,NULL,'16.98',0.4,NULL,NULL,NULL,NULL,NULL,1,243.198333,36.89711,0.009,NULL,59772907163,933951674,14592994,16.98),(136227,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136227,37.91,0.33,381,64731,70,NULL,NULL,'2MASX J16124798+1625411',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.199833,16.42822,0.145,NULL,56545044894,883516326,13804942,16.9),(136228,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136228,37.32,0.46,291,64732,70,NULL,NULL,'2MASX J16124796+1339121',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'PHOT','16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.199875,13.65342,0.097,NULL,56555092391,883673318,13807395,16.8),(136229,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136229,36.76,0.46,225,64733,70,NULL,NULL,'2MASX J16124884+2551525',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000198,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.2035417,25.86464,0.137,NULL,59727628774,933244199,14581940,16.4),(136230,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136230,37.98,0.27,394,64734,70,NULL,NULL,'2MASX J16124893+2038117',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.20375,20.63658,0.137,NULL,56520287265,883129488,13798898,18.1),(136231,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136231,34.82,NULL,92,64735,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10276',NULL,'2010Ap&SS.325..163P',2010,1,1.4,NULL,'G',0.000009,NULL,'15.5g',0.27,'Sbc',NULL,NULL,NULL,NULL,1,243.2044583,31.99314,0.057,NULL,59783307422,934114178,14595534,15.5),(136232,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136232,34.82,NULL,92.2,64735,NULL,NULL,'Dipole + Quadrupole','UGC 10276',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136233,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136233,34.84,NULL,93,64735,NULL,NULL,'Dipole','UGC 10276',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136234,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136234,34.87,NULL,94.1,64735,NULL,NULL,NULL,'UGC 10276',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136235,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136235,35.03,0.49,102,64735,75,NULL,'IR','UGC 10276',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136236,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136236,37.91,0.33,381,64736,70,NULL,NULL,'2MASX J16124923+1626321',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.205167,16.44219,0.145,NULL,56544990918,883515483,13804929,18.6),(136237,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136237,37.75,0.46,354,64737,70,NULL,NULL,'2MASX J16124961+1244431',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.206667,12.74547,0.153,NULL,56541460211,883460315,13804067,18.2),(136238,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136238,35.96,0.33,156,64738,70,NULL,NULL,'CGCG 079-077',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00015,NULL,'15.3',0.57,NULL,NULL,NULL,NULL,NULL,1,243.208083333,11.15981,0.169,NULL,56574192901,883971764,13812058,15.3),(136239,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136239,36.35,0.33,186,64739,70,NULL,NULL,'2MASXi J1612505+375832',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.2105417,37.9755,0.009,NULL,59772602701,933946917,14592920,17.3),(136240,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136240,36.76,0.46,225,64740,70,NULL,NULL,'2MASX J16125083+1653092',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000171,NULL,'15.8g',0.32,'E',NULL,NULL,NULL,NULL,1,243.211875,16.88597,0.137,NULL,56563627996,883806687,13809479,15.8),(136241,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136241,35.62,0.46,133,64741,70,NULL,NULL,'CGCG 051-065 NED01',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000167,NULL,'16.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.2130417,6.0625,0.145,NULL,56460734207,882198971,13784358,16),(136242,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136242,38.87,0.46,594,64742,70,NULL,NULL,'2MASX J16125281+2223087',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000191,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.220041667,22.38583,0.125,NULL,56509324386,882958193,13796221,18),(136243,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136243,35.09,0.19,101,64743,74.2,NULL,'SALT 2','ESO 584- G 007',0.031662,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000137,NULL,'15',1.6,'Sc             HII',NULL,NULL,NULL,NULL,1,243.222333,-21.62333,0.629,NULL,45434578186,709915284,11092426,15),(136244,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136244,35.37,0.08,111,64743,72,NULL,NULL,'ESO 584- G 007',0.03201,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136245,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136245,35.4,0.04,120,64743,72,NULL,'M(H) = -18.317 mag','ESO 584- G 007',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136246,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136246,35.65,0.17,131,64743,70,NULL,'SALT 2','ESO 584- G 007',0.031662,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136247,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136247,35.65,0.04,131,64743,72,NULL,'SALT2','ESO 584- G 007',0.031662,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136248,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136248,35.63,0.09,134,64743,74.4,NULL,NULL,'ESO 584- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136249,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136249,35.71,0.24,134,64743,73.8,NULL,'SALT 2 (SNANA)','ESO 584- G 007',0.0324,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136250,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136250,35.9,0.22,146,64743,73.8,NULL,'SALT 2 (SNANA)','ESO 584- G 007',0.0324,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136251,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136251,35.91,0.2,148,64743,65,NULL,'SALT2','ESO 584- G 007',0.031662,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136252,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136252,35.96,0.2,151,64743,65,NULL,'MLCS31','ESO 584- G 007',0.031662,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136253,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136253,35.99,0.18,153,64743,65,NULL,'MLCS17','ESO 584- G 007',0.031662,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136254,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2007ai',NULL,136254,36.01,0.17,154,64743,65,NULL,'SALT','ESO 584- G 007',0.031662,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136255,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136255,35.94,0.23,154,64744,70,NULL,NULL,'2MASX J16125369+2919105',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000143,NULL,'16.9g',0.22,'E',NULL,NULL,NULL,NULL,1,243.223667,29.31978,0.081,NULL,59741056116,933454001,14585218,16.9),(136256,'SNII optical','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2009kf',NULL,136256,40.63,0.5,1340,64745,NULL,NULL,NULL,'SDSS J161254.19+553814.4',NULL,'2010ApJ...717L..52B',2010,1,0.09,NULL,'G',NULL,NULL,'20.3g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.225791667,55.63733,0,NULL,57608959210,900139987,14064687,20.3),(136257,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136257,35.96,0.33,156,64746,70,NULL,NULL,'2MASX J16125501+1104576',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.4,NULL,NULL,NULL,NULL,NULL,1,243.22925,11.08264,0.169,NULL,56574196958,883971827,13812059,16.3),(136258,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136258,37.7,0.46,347,64747,70,NULL,NULL,'2MASX J16125615+1219552',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.234125,12.332,0.145,NULL,56541409455,883459522,13804055,17.7),(136259,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136259,34.67,0.73,85.8,64748,70,NULL,NULL,'UGC 10264',NULL,'2014MNRAS.445.2677S',2014,1,1.27,NULL,'G',0.000089,NULL,'14.6g',0.69,'SAB(s)cd:      HII','Group member',NULL,NULL,NULL,1,243.236791667,-0.09625,0.433,NULL,45504538015,711008406,11109506,14.6),(136260,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136260,35.71,0.4,139,64748,NULL,NULL,'mean','UGC 10264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136261,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136261,35.72,0.47,140,64748,NULL,NULL,'H','UGC 10264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136262,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136262,35.87,0.45,149,64748,NULL,NULL,'K','UGC 10264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136263,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136263,35.94,0.46,155,64748,NULL,NULL,'J','UGC 10264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136264,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136264,36.32,0.25,184,64749,70,NULL,NULL,'GIN 545',NULL,'2001MNRAS.321..277C',2001,1,0.57,NULL,'G',0.00009,NULL,'14.30',0.44,'E/S0',NULL,NULL,NULL,NULL,1,243.237333,30.77072,0.053,NULL,59738389244,933412331,14584567,14.3),(136265,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136265,36.93,0.19,243,64749,70,NULL,NULL,'GIN 545',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136266,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136266,34.5,0.2,79.4,64750,74.4,NULL,NULL,'UGC 10282',NULL,'2013AJ....146...86T',2013,1,0.99,'Listed in CGCG special map in vol III, p 87 (SM1-003).','G',0.000013,NULL,'15.0g',0.63,'SA(s)c',NULL,NULL,NULL,NULL,1,243.2399583,32.51244,0.037,NULL,59784719357,934136239,14595878,15),(136267,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136267,34.5,0.61,79.5,64750,NULL,NULL,'Malmquist cor.','UGC 10282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136268,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136268,34.52,0.61,80.1,64750,NULL,NULL,NULL,'UGC 10282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136269,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136269,37.66,0.46,340,64751,70,NULL,NULL,'2MASX J16125818+1416172',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.242375,14.27153,0.081,NULL,56555775030,883683984,13807562,17.6),(136270,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136270,36.93,0.46,243,64752,70,NULL,NULL,'2MASX J16125874+0649296',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,243.244708333,6.82478,0.209,NULL,56461001409,882203147,13784424,16.7),(136271,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136271,36.84,0.16,233,64753,70,NULL,NULL,'SDSS J161259.02+294253.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.245916667,29.71475,0.065,NULL,59737911329,933404864,14584451,17.7),(136272,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136272,34.83,0.2,92.5,64754,74.4,NULL,NULL,'SDSS J161259.92+305022.0',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000011,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.249666667,30.83944,0.053,NULL,59738377101,933412142,14584564,16.8),(136273,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136273,36.37,0.46,188,64755,70,NULL,NULL,'2MASX J16130101+4421358',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'15.8g',0.38,'SABa',NULL,NULL,NULL,NULL,1,243.254083,44.36,NULL,NULL,59848823075,935137860,14611529,15.8),(136274,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136274,37.6,0.46,332,64756,70,NULL,NULL,'2MASX J16130113+5057494',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000076,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.2547917,50.96386,0.013,NULL,59710076571,932969946,14577655,17.2),(136275,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136275,36.93,0.19,243,64757,70,NULL,NULL,'SDSS J161303.11+305459.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.263,30.91661,0.053,NULL,59738322421,933411287,14584551,17.8),(136276,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136276,36.93,0.19,243,64758,70,NULL,NULL,'2MASX J16130327+3103560',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.2637917,31.06544,0.057,NULL,59737821727,933403464,14584429,16.7),(136277,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136277,36.32,0.25,184,64759,70,NULL,NULL,'GIN 542',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000067,NULL,'14.10',NULL,'E/S0',NULL,NULL,NULL,NULL,1,243.267375,30.90011,0.053,NULL,59738324030,933411312,14584551,14.1),(136278,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136278,37.06,0.33,258,64760,70,NULL,NULL,'2MASX J16130436+2957119',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.8g',0.23,'AGN',NULL,NULL,NULL,NULL,1,243.268083,29.95344,0.061,NULL,59738116118,933408064,14584501,16.8),(136279,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136279,37.06,0.33,258,64761,70,NULL,NULL,'2MASX J16130482+2957339',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PHOT','17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.270333,29.9595,0.061,NULL,59738144912,933408514,14584508,17.3),(136280,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136280,36.15,0.25,170,64762,74.4,NULL,NULL,'CGCG 167-050 NED01',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000093,NULL,'14.8g',0.58,'E/S0',NULL,NULL,NULL,NULL,1,243.270625,30.90169,0.053,NULL,59738324011,933411312,14584551,14.8),(136281,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136281,36.32,0.25,184,64762,70,NULL,NULL,'CGCG 167-050 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136282,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136282,37.01,0.46,252,64763,70,NULL,NULL,'2MASX J16130560+3606307',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00009,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.27325,36.10856,0.021,NULL,59771939632,933936556,14592758,17),(136283,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136283,36.84,0.46,233,64764,70,NULL,NULL,'2MASX J16130589+4950175',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000097,NULL,'16.0g',0.35,'S0',NULL,NULL,NULL,NULL,1,243.274417,49.83814,0.009,NULL,59709591878,932962373,14577537,16),(136284,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136284,38.13,0.46,423,64765,70,NULL,NULL,'2MASX J16130655+2203577',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000176,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.2772083,22.06611,0.121,NULL,56508125964,882939468,13795929,18.1),(136285,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136285,37.9,0.46,380,64766,70,NULL,NULL,'SDSS J161307.16+424642.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.279875,42.77858,NULL,NULL,59805481341,934460645,14600947,18.2),(136286,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136286,37.53,0.27,320,64767,70,NULL,NULL,'SDSS J161307.24+311632.7',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.7g',0.31,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.2802083,31.27578,0.053,NULL,59737772580,933402696,14584417,16.7),(136287,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136287,36.15,0.25,170,64768,74.4,NULL,NULL,'UGC 10283',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000103,NULL,'14.9g',0.56,'E/S0','Group member',NULL,NULL,NULL,1,243.287,30.82703,0.053,NULL,59738387492,933412304,14584567,14.9),(136288,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136288,36.32,0.25,184,64768,70,NULL,NULL,'UGC 10283',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136289,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136289,36.58,0.46,207,64769,70,NULL,NULL,'2MASX J16130926+1516153',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00007,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.2885417,15.27097,0.089,NULL,56544944089,883514751,13804917,16.6),(136290,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136290,36.68,0.33,217,64770,70,NULL,NULL,'2MASX J16130951+2851403',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,243.289666667,28.86114,0.085,NULL,59741199724,933456245,14585253,16.9),(136291,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136291,37.57,0.46,327,64771,70,NULL,NULL,'2MASX J16131056+2310097',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.294125,23.16947,0.169,NULL,56506566479,882915101,13795548,17.2),(136292,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136292,38.85,0.46,588,64772,70,NULL,NULL,'SDSS J161310.62+122548.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.294291667,12.43011,0.145,NULL,56541399464,883459366,13804052,17.9),(136293,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136293,36.2,0.46,173,64773,70,NULL,NULL,'2MASX J16131101+2053447',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000189,NULL,'16.1g',0.29,'AGN',NULL,NULL,NULL,NULL,1,243.295916667,20.89567,0.141,NULL,56519389147,883115455,13798678,16.1),(136294,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136294,37.52,0.46,318,64774,70,NULL,NULL,'2MASX J16131120+2106167',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.296667,21.10461,0.145,NULL,56519362650,883115041,13798672,17.8),(136295,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136295,36.14,0.46,169,64775,70,NULL,NULL,'2MASX J16131174+1820508',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000117,NULL,'15.0',NULL,'E',NULL,NULL,NULL,NULL,1,243.298875,18.3475,0.105,NULL,56514619908,883040936,13797514,15),(136296,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136296,37.88,0.33,377,64776,70,NULL,NULL,'2MASX J16131201+3128309',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.3000417,31.47525,0.053,NULL,59783112000,934111125,14595486,17.5),(136297,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136297,36.68,0.33,217,64777,70,NULL,NULL,'2MASX J16131234+2845523',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.301417,28.76442,0.089,NULL,59741228165,933456690,14585260,16.7),(136298,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136298,38.36,0.46,471,64778,70,NULL,NULL,'2MASX J16131359+3224299',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000199,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.306583,32.40828,0.037,NULL,59782828466,934106694,14595417,17.3),(136299,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136299,36.15,0.25,170,64779,74.4,NULL,NULL,'UGC 10285',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000073,NULL,'14.35',0.7,'E/S0','Group member',NULL,NULL,NULL,1,243.31175,30.90253,0.053,NULL,59738324349,933411317,14584551,14.35),(136300,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136300,36.32,0.25,184,64779,70,NULL,NULL,'UGC 10285',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136301,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136301,36.93,0.19,243,64780,70,NULL,NULL,'2MASX J16131508+3058369',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.31275,30.97689,0.057,NULL,59738320859,933411263,14584550,17.3),(136302,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136302,35.28,0.49,114,64781,75,NULL,'IR','UGC 10289',NULL,'2011yCatp016004901K',2011,1,0.93,'Springob et al. (2005ApJS..160..149S) give v= 5918 km/sec.','G',0.000081,NULL,'16.3g',0.25,'Sb(f)',NULL,NULL,NULL,NULL,1,243.314,48.23497,0.005,NULL,59705591862,932899872,14576560,16.3),(136303,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136303,37.35,0.46,295,64782,70,NULL,NULL,'2MASX J16131668+1801048',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.319417,18.01808,0.089,NULL,56560678938,883760608,13808759,16.8),(136304,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136304,35.15,0.53,107,64783,70,NULL,NULL,'2MASX J16131698-7728487',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,243.3204583,-77.48022,0.473,NULL,44262731607,691605181,10806330,16),(136305,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136305,37.3,0.46,289,64784,70,NULL,NULL,'SDSS J161317.46+495746.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000086,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.32275,49.96292,0.017,NULL,59709614917,932962733,14577542,17.7),(136306,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136306,37.37,0.46,298,64785,70,NULL,NULL,'2MASX J16131784+2833003',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.32425,28.55,0.097,NULL,59741365213,933458831,14585294,17.3),(136307,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136307,36.54,0.56,204,64786,70,NULL,NULL,'2MASX J16131902-0112563',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.0001,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,243.329291667,-1.21569,0.465,NULL,45507930305,711061411,11110334,16.3),(136308,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136308,38.39,0.46,477,64787,70,NULL,NULL,'SDSS J161320.06+462951.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000158,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.333625,46.49758,0.013,NULL,59831925657,934873838,14607403,18.6),(136309,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136309,37.13,0.13,267,64788,70,NULL,NULL,'2MASX J16132091+4908176',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000067,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.337083,49.13814,0,NULL,59705082040,932891906,14576436,17.6),(136310,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136310,37.55,0.46,324,64789,70,NULL,NULL,'2MASX J16132089+4137276',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.337167,41.62456,NULL,NULL,59806759311,934480614,14601259,17.6),(136311,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136311,37.53,0.27,320,64790,70,NULL,NULL,'2MASX J16132096+3116265',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000145,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.337458333,31.27408,0.053,NULL,59783062745,934110355,14595474,16.8),(136312,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136312,37.53,0.27,320,64791,70,NULL,NULL,'2MASX J16132213+3117405',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.3422917,31.29453,0.053,NULL,59783062592,934110353,14595474,17.4),(136313,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136313,36.74,0.54,223,64792,70,NULL,NULL,'2MASX J16132255-0112322',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.68',NULL,NULL,NULL,NULL,NULL,NULL,1,243.343875,-1.20917,0.445,NULL,45507876084,711060563,11110321,16.68),(136314,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136314,38.51,0.46,503,64793,70,NULL,NULL,'2MASX J16132264+5037576',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000086,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.344125,50.63272,0.021,NULL,59710082129,932970033,14577656,17.7),(136315,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136315,37.36,0.11,296,64794,70,NULL,NULL,'2MASX J16132295+3729499',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.345583,37.49719,0.009,NULL,59772865415,933951022,14592984,17.9),(136316,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136316,36.43,0.46,193,64795,70,NULL,NULL,'2MASX J16132364+4827566',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.348333,48.46583,0,NULL,59705774233,932902722,14576605,16.4),(136317,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136317,37.06,0.33,259,64796,70,NULL,NULL,'SDSS J161324.10+273510.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.350417,27.58617,0.101,NULL,59729622874,933275357,14582427,18.1),(136318,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136318,38.09,0.46,415,64797,70,NULL,NULL,'2MASX J16132410+5319306',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000094,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.35075,53.32528,0.005,NULL,57605656277,900088379,14063880,17.4),(136319,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136319,37.54,0.46,323,64798,70,NULL,NULL,'2MASX J16132454+3825260',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000182,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.352208333,38.42397,0.009,NULL,59770412169,933912690,14592385,17.4),(136320,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136320,36.32,0.25,184,64799,70,NULL,NULL,'KUG 1611+307',NULL,'2001MNRAS.321..277C',2001,1,0.48,NULL,'G',0.000161,NULL,'16.0g',0.39,'S',NULL,NULL,NULL,NULL,1,243.353291667,30.59972,0.053,NULL,59738408774,933412637,14584572,16),(136321,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136321,35.16,0.51,108,64800,NULL,NULL,NULL,'UGC 10286',NULL,'2009ApJS..182..474S',2009,1,1.23,'Listed in CGCG special map in vol III, p 87 (SM1-004).','G',0.000033,NULL,'15.8g',0.25,'Scd:',NULL,NULL,NULL,NULL,1,243.35625,32.28581,0.045,NULL,59782853054,934107078,14595423,15.8),(136322,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136322,35.17,0.2,108,64800,74.4,NULL,NULL,'UGC 10286',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136323,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136323,35.47,0.44,124,64800,NULL,NULL,'Malmquist cor.','UGC 10286',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136324,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136324,34.72,0.46,88,64801,70,NULL,NULL,'CGCG 137-063',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000097,NULL,'15.0g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.356583,21.90942,0.117,NULL,56508115479,882939304,13795926,15),(136325,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136325,37.84,0.46,370,64802,70,NULL,NULL,'SDSS J161326.79+174216.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.361625,17.70456,0.113,NULL,56560548626,883758572,13808727,18.3),(136326,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136326,37.22,0.46,278,64803,70,NULL,NULL,'2MASX J16132688+3119196',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.361917,31.32225,0.053,NULL,59783069262,934110457,14595475,17.1),(136327,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136327,36.2,0.46,173,64804,70,NULL,NULL,'2MASX J16132722+4425429',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.363625,44.42858,0,NULL,59848837119,935138079,14611532,16.8),(136328,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136328,36.93,0.19,243,64805,70,NULL,NULL,'2MASX J16132809+3105146',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.3669583,31.08733,0.057,NULL,59738299672,933410932,14584545,17.2),(136329,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136329,36.84,0.46,234,64806,70,NULL,NULL,'2MASX J16132833+2304088',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000189,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.368125,23.06919,0.169,NULL,56506283622,882910681,13795479,16.2),(136330,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136330,37.06,0.33,259,64807,70,NULL,NULL,'2MASX J16132937+2726153',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.372417,27.43758,0.101,NULL,59729762634,933277541,14582461,16.8),(136331,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136331,37.64,0.46,337,64808,70,NULL,NULL,'2MASX J16133007+2908363',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.0002,NULL,'16.2g',0.31,'BrClG;Sa',NULL,NULL,NULL,NULL,1,243.3752917,29.14339,0.085,NULL,59743171830,933487059,14585735,16.2),(136332,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136332,37.88,0.33,377,64809,70,NULL,NULL,'2MASX J16133162+3130116',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000167,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.38175,31.50319,0.053,NULL,59783077991,934110593,14595478,17.5),(136333,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136333,35.58,0.61,130,64810,70,NULL,NULL,'2MASX J16133441-1503253',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.393375,-15.05706,0.917,NULL,45462333872,710348966,11099202,15.1),(136334,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136334,37.56,0.46,325,64811,70,NULL,NULL,'2MASX J16133466+3238276',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000189,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,243.394541667,32.64092,0.029,NULL,59784773962,934137093,14595892,16.3),(136335,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136335,37.13,0.13,267,64812,70,NULL,NULL,'SDSS J161334.99+490723.8',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.0001,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,243.395833,49.12328,0,NULL,59703133138,932861455,14575960,18.6),(136336,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136336,37.13,0.46,267,64813,70,NULL,NULL,'2MASX J16133499-0015256',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000071,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.395875,-0.25703,0.433,NULL,45507468108,711054189,11110221,18),(136337,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136337,36.74,0.46,223,64814,70,NULL,NULL,'2MASX J16133526+5041055',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000087,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.397083,50.68472,0.021,NULL,59710093683,932970213,14577659,16.5),(136338,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136338,37.92,0.46,385,64815,70,NULL,NULL,'2MASX J16133566+2142298',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.39875,21.70822,0.133,NULL,56508772888,882949576,13796087,18),(136339,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136339,36.93,0.19,243,64816,70,NULL,NULL,'2MASX J16133744+3053276',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.4060417,30.89092,0.053,NULL,59738344231,933411628,14584556,17.2),(136340,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136340,37.13,0.13,267,64817,70,NULL,NULL,'2MASX J16133790+4904095',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.40775,49.06942,0,NULL,59703133820,932861465,14575960,16.7),(136341,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136341,36.7,0.33,219,64818,70,NULL,NULL,'SDSS J161338.09+134924.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.40875,13.82347,0.089,NULL,56555119583,883673743,13807402,17.7),(136342,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136342,38.21,0.46,439,64819,70,NULL,NULL,'2MASX J16133827+2930403',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.409375,29.51128,0.073,NULL,59739741349,933433458,14584897,18),(136343,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136343,36.7,0.33,219,64820,70,NULL,NULL,'2MASX J16133832+1348244',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,243.4097917,13.80672,0.089,NULL,56555118777,883673730,13807402,16.2),(136344,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136344,37.01,0.62,252,64821,70,NULL,NULL,'2MASX J16133895-2052182',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.41225,-20.87175,0.765,NULL,45447585038,710118516,11095601,15.8),(136345,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136345,36.37,0.2,188,64822,74.4,NULL,NULL,'KUG 1611+344',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.000043,NULL,'15.5g',0.29,'Spiral',NULL,NULL,NULL,NULL,1,243.413167,34.28603,0.005,NULL,59792030458,934250475,14597663,15.5),(136346,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136346,37.48,0.33,313,64823,70,NULL,NULL,'2MASX J16133916+2650073',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000164,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.413291667,26.83528,0.069,NULL,59730102928,933282858,14582544,17),(136347,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136347,37.75,0.46,355,64824,70,NULL,NULL,'2MASX J16133979+0850459',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.415875,8.84625,0.177,NULL,56470258465,882347788,13786684,16.8),(136348,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136348,37.49,0.46,315,64825,70,NULL,NULL,'SDSS J161341.35+245045.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.422333,24.84603,0.181,NULL,59727065033,933235391,14581802,18.5),(136349,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136349,36.3,NULL,182,64826,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2005',NULL,'2010Ap&SS.325..163P',2010,1,0.73,NULL,'G',NULL,NULL,'16.9',0.09,'Sd',NULL,NULL,NULL,NULL,1,243.422833333,52.87386,0.037,NULL,59699842965,932810046,14575156,16.9),(136350,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136350,36.31,NULL,183,64826,NULL,NULL,NULL,'FGC 2005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136351,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136351,36.34,NULL,185,64826,NULL,NULL,'Dipole + Quadrupole','FGC 2005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136352,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136352,36.37,NULL,188,64826,NULL,NULL,'Dipole','FGC 2005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136353,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136353,37.19,0.46,274,64827,70,NULL,NULL,'2MASX J16134201+4853575',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000078,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,243.425167,48.89925,0,NULL,59705058192,932891534,14576430,16.5),(136354,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136354,36.74,0.46,223,64828,70,NULL,NULL,'2MASX J16134220+0038534',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0001,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.425791667,0.64831,0.353,NULL,56450786521,882043539,13781930,16.8),(136355,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136355,37.31,0.46,290,64829,70,NULL,NULL,'2MASX J16134283+2629283',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,243.4285,26.49119,0.069,NULL,59730468333,933288567,14582633,16.8),(136356,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136356,35.89,0.46,151,64830,70,NULL,NULL,'2MASX J16134297+2544253',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,243.429,25.74042,0.125,NULL,59727609617,933243900,14581935,16.4),(136357,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136357,36.13,0.46,168,64831,70,NULL,NULL,'SDSS J161344.00+130508.1',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',NULL,NULL,'15.2g',0.55,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.433333,13.08561,0.145,NULL,56541945803,883467903,13804185,15.2),(136358,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136358,37.35,0.46,295,64832,70,NULL,NULL,'2MASX J16134556+1651083',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.439833333,16.85219,0.137,NULL,56560740661,883761572,13808774,17.1),(136359,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136359,38.19,0.46,434,64833,70,NULL,NULL,'2MASX J16134620+2324289',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000148,NULL,'19.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.4425417,23.40811,0.153,NULL,56505805217,882903206,13795362,19),(136360,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136360,35.67,0.59,136,64834,70,NULL,NULL,'2MASX J16134736-2100542',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,'(R\')SAB(s)0^+',NULL,NULL,NULL,NULL,1,243.4472917,-21.01514,0.789,NULL,45447540894,710117826,11095591,14.2),(136361,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136361,26.35,0.14,1.86,64835,NULL,NULL,NULL,'ELAIS06S(R) J161347.7+542218',NULL,'2001A&A...379..407K',2001,1,1.1,NULL,'G',0.000001,NULL,'17.0',0.65,'Ir',NULL,NULL,NULL,NULL,1,243.4497917,54.37117,0,1,57610401230,900162519,14065039,17),(136362,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136362,26.4,0.07,1.91,64835,NULL,NULL,'I','ELAIS06S(R) J161347.7+542218',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136363,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136363,26.43,0.05,1.93,64835,NULL,NULL,'I','ELAIS06S(R) J161347.7+542218',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136364,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136364,26.42,0.07,1.93,64835,NULL,NULL,'I','ELAIS06S(R) J161347.7+542218',NULL,'2012MNRAS.425..709M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136365,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136365,26.65,0.15,2.14,64835,NULL,NULL,NULL,'ELAIS06S(R) J161347.7+542218',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136366,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10jw','N',136366,41.48,0.14,1450,64836,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jw HOST',0.36,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136367,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136367,37.36,0.46,297,64837,70,NULL,NULL,'SDSS J161348.56+262418.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,243.452375,26.40528,0.069,NULL,59730462605,933288478,14582632,18.4),(136368,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136368,36.35,0.33,186,64838,70,NULL,NULL,'CGCG 196-008',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000103,NULL,'14.8g',0.61,'E0',NULL,NULL,NULL,NULL,1,243.455,38.15194,0.009,NULL,59772561400,933946271,14592910,14.8),(136369,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136369,37.96,0.46,391,64839,70,NULL,NULL,'2MASX J16134950+2059149',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.4562083,20.98767,0.145,NULL,56519403846,883115685,13798682,18.3),(136370,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136370,37.16,0.46,271,64840,70,NULL,NULL,'2MASX J16135003+2714113',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.458583333,27.2365,0.097,NULL,59729735364,933277115,14582454,16.4),(136371,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136371,38.14,0.46,425,64841,70,NULL,NULL,'SDSS J161351.07+191325.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.4627917,19.22383,0.113,NULL,56518219920,883097186,13798393,18.5),(136372,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136372,37.87,0.27,374,64842,70,NULL,NULL,'2MASX J16135165+2814444',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.465125,28.24556,0.109,NULL,59740875654,933451182,14585174,17.8),(136373,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136373,37.48,0.33,313,64843,70,NULL,NULL,'2MASX J16135188+2649334',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.4662917,26.82589,0.069,NULL,59730116486,933283070,14582547,17.7),(136374,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136374,36.92,0.46,242,64844,70,NULL,NULL,'2MASX J16135563+0621042',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.4817083,6.35131,0.173,NULL,56460809305,882200145,13784377,16.9),(136375,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136375,38.02,0.46,401,64845,70,NULL,NULL,'2MASX J16135692+2235539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.487333,22.59825,0.189,NULL,56509096338,882954630,13796166,17.5),(136376,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136376,37.13,0.13,267,64846,70,NULL,NULL,'2MASX J16135804+4911228',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000103,NULL,'15.9g',0.42,'E              BrClG',NULL,NULL,NULL,NULL,1,243.492,49.18961,0,NULL,59703266360,932863536,14575992,15.9),(136377,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136377,37.21,0.46,277,64847,70,NULL,NULL,'2MASX J16140016+0811502',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.500667,8.19733,0.185,NULL,56470455395,882350865,13786732,16.8),(136378,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136378,37.3,0.33,289,64848,70,NULL,NULL,'2MASX J16140082+5049488',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00013,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,243.503167,50.83017,0.017,NULL,59710101365,932970333,14577661,16.4),(136379,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136379,35.52,0.67,127,64849,70,NULL,NULL,'2MASX J16140113-6512213',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.5R',0.41,'E?',NULL,NULL,NULL,NULL,1,243.5045,-65.20594,0.893,NULL,44981077009,702829328,10981708,15.5),(136380,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136380,37.33,0.46,292,64850,70,NULL,NULL,'2MASX J16140276+2423304',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.511583333,24.39172,0.169,NULL,59726952407,933233631,14581775,17.9),(136381,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136381,36.68,0.46,217,64851,70,NULL,NULL,'2MASX J16140288-0032347',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000093,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.5120417,-0.54317,0.389,NULL,45507666720,711057292,11110270,16.9),(136382,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136382,35.21,0.47,110,64852,NULL,NULL,'H','UGC 10287',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000013,NULL,'14.13',1,'SBb','Group non-member, foreground',NULL,NULL,NULL,1,243.5137083,14.28211,0.089,NULL,56555924416,883686319,13807598,14.13),(136383,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136383,35.3,0.45,115,64852,NULL,NULL,'K','UGC 10287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136384,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136384,35.36,0.46,118,64852,NULL,NULL,'J','UGC 10287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136385,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136385,35.35,0.9,118,64852,NULL,NULL,'Malmquist cor.','UGC 10287',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136386,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136386,35.65,0.4,135,64852,NULL,NULL,'mean','UGC 10287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136387,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136387,36,0.67,158,64852,NULL,NULL,NULL,'UGC 10287',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136388,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136388,36.04,0.2,161,64852,74.4,NULL,NULL,'UGC 10287',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136389,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136389,37.83,0.46,368,64853,70,NULL,NULL,'2MASX J16140445+2401254',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000209,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.518583,24.02375,0.153,NULL,56639896953,884998389,13828099,16.8),(136390,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136390,37.13,0.13,267,64854,70,NULL,NULL,'2MASX J16140681+4911238',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.528625,49.18989,0,NULL,59703278823,932863731,14575995,16.9),(136391,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136391,36.79,0.46,228,64855,70,NULL,NULL,'2MASX J16140714+2218359',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.52975,22.30981,0.125,NULL,56508051743,882938308,13795911,18.2),(136392,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136392,37.98,0.46,394,64856,70,NULL,NULL,'2MASX J16140717+5016108',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.5300417,50.26969,0.017,NULL,59709697309,932964020,14577562,17.1),(136393,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136393,38.08,0.46,413,64857,70,NULL,NULL,'2MASXi J1614084+460431',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.535333,46.07539,0.009,NULL,59831816491,934872132,14607377,17.8),(136394,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136394,38.32,0.46,462,64858,70,NULL,NULL,'2MASXi J1614094+495800',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.539666667,49.96692,0.017,NULL,59707527031,932930109,14577032,18),(136395,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136395,37.37,0.46,297,64859,70,NULL,NULL,'2MASX J16140977+4859218',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.540667,48.98933,0,NULL,59703138263,932861535,14575961,16.9),(136396,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136396,35.28,0.46,114,64860,70,NULL,NULL,'CGCG 167-055',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00011,NULL,'15.2g',0.53,'E',NULL,NULL,NULL,NULL,1,243.545125,29.85169,0.061,NULL,59739766946,933433858,14584904,15.2),(136397,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136397,35.95,0.33,155,64861,70,NULL,NULL,'CGCG 051-070',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00013,NULL,'15.5',0.4,'E','Pair member (points to parent)',NULL,NULL,NULL,1,243.5482917,6.15103,0.173,NULL,56460639533,882197492,13784335,15.5),(136398,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136398,37.78,0.33,361,64862,70,NULL,NULL,'2MASX J16141178+1949575',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000204,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.549167,19.83256,0.105,NULL,56515941689,883061588,13797837,16.3),(136399,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136399,37.23,0.46,279,64863,70,NULL,NULL,'2MASX J16141183+0009220',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.549375,0.15619,0.361,NULL,56448569341,882008895,13781388,17.6),(136400,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136400,37.13,0.13,267,64864,70,NULL,NULL,'2MASX J16141190+4907128',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000103,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,243.5497083,49.12028,0,NULL,59703141423,932861584,14575962,15.9),(136401,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136401,36.88,0.46,238,64865,70,NULL,NULL,'2MASX J16141204+1609274',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000177,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,243.5502083,16.15764,0.129,NULL,56547199992,883549999,13805468,16.3),(136402,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136402,38.48,0.46,496,64866,70,NULL,NULL,'2MASX J16141219+2807543',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.5507917,28.13183,0.109,NULL,59740897737,933451527,14585180,18.1),(136403,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136403,34.92,0.46,96.5,64867,70,NULL,NULL,'2MASX J16141241-2940198',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00012,NULL,'14.59',0.63,'E',NULL,NULL,NULL,NULL,1,243.551667,-29.67217,0.853,NULL,46251137008,722674015,11291781,14.59),(136404,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136404,35.53,0.46,127,64868,70,NULL,NULL,'2MASX J16141242+3129255',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000158,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.551917,31.49042,0.053,NULL,59783377397,934115271,14595551,16.2),(136405,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136405,37.92,0.46,384,64869,70,NULL,NULL,'2MASX J16141268+2122456',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.552666667,21.37914,0.165,NULL,56507937801,882936528,13795883,17.9),(136406,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136406,38.41,0.46,481,64870,70,NULL,NULL,'SDSS J161413.51+262252.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.556333333,26.38117,0.093,NULL,59730970395,933296412,14582756,18.6),(136407,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136407,37.32,0.46,291,64871,70,NULL,NULL,'2MASXi J1614136+205619',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.2g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.556625,20.93897,0.145,NULL,56519537569,883117774,13798715,18.2),(136408,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136408,37.24,0.46,280,64872,70,NULL,NULL,'2MASX J16141386-0015347',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000079,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.55775,-0.25964,0.397,NULL,45506394912,711037420,11109959,17.2),(136409,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136409,37.78,0.33,361,64873,70,NULL,NULL,'2MASX J16141447+1948396',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.560333333,19.81114,0.105,NULL,56515948729,883061698,13797839,18.6),(136410,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136410,35.09,0.25,104,64874,74.4,NULL,NULL,'GIN 555',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000107,NULL,'16.4g',0.36,'E/S0',NULL,NULL,NULL,NULL,1,243.562041667,29.29239,0.089,NULL,59743185712,933487276,14585738,16.4),(136411,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136411,35.27,0.42,113,64874,70,NULL,NULL,'GIN 555',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136412,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136412,36.32,0.46,184,64874,70,NULL,NULL,'GIN 555',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136413,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136413,33.54,0.4,51,64875,NULL,NULL,'mean','IC 1205',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000004,NULL,'14.6',0.4,'Sa',NULL,NULL,NULL,NULL,1,243.566333,9.53719,0.153,NULL,56456537311,882133395,13783334,14.6),(136414,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136414,33.61,0.47,52.8,64875,NULL,NULL,'H','IC 1205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136415,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136415,34.63,0.69,84.2,64876,100,NULL,'mid-IR','NGC 6084',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000033,NULL,'14.9',0.5,'Sa',NULL,NULL,NULL,NULL,1,243.569666667,17.75744,0.113,NULL,56561137755,883767777,13808871,14.9),(136416,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136416,35.69,0.4,137,64876,NULL,NULL,'mean','NGC 6084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136417,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136417,36.21,0.47,175,64876,NULL,NULL,'H','NGC 6084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136418,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136418,36.22,0.45,175,64876,NULL,NULL,'K','NGC 6084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136419,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136419,36.25,0.46,178,64876,NULL,NULL,'J','NGC 6084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136420,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136420,35.95,0.33,155,64877,70,NULL,NULL,'CGCG 051-072',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000166,NULL,'15.6g',0.42,'E              AGN','Pair member (points to parent)',NULL,NULL,NULL,1,243.5715,6.15944,0.173,NULL,56460636990,882197452,13784335,15.6),(136421,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136421,36.86,0.46,236,64878,70,NULL,NULL,'2MASX J16141844+1411592',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.576916667,14.19989,0.089,NULL,56555016897,883672139,13807377,17.1),(136422,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136422,38.25,0.46,447,64879,70,NULL,NULL,'2MASX J16141986+2110476',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.582833,21.17992,0.165,NULL,56507909349,882936083,13795876,17.3),(136423,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136423,35.54,0.46,128,64880,70,NULL,NULL,'2MASX J16141998-0001536',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000071,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.583208333,-0.03156,0.385,NULL,45506397542,711037461,11109960,16.4),(136424,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136424,35.89,0.74,151,64880,70,NULL,NULL,'2MASX J16141998-0001536',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136425,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136425,37.36,0.46,297,64881,70,NULL,NULL,'2MASX J16142058+3426255',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.585875,34.44036,0.009,NULL,59792113369,934251771,14597683,17.5),(136426,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136426,37,0.46,252,64882,70,NULL,NULL,'2MASX J16142115+0026471',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000096,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.588125,0.44639,0.353,NULL,56450715572,882042430,13781912,16.8),(136427,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136427,37.21,0.46,277,64883,70,NULL,NULL,'2MASX J16142212+2545184',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.5922083,25.75511,0.125,NULL,59727558439,933243100,14581923,18.2),(136428,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136428,38.11,0.46,420,64884,70,NULL,NULL,'2MASX J16142308+1520272',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.596125,15.34083,0.089,NULL,56546614399,883540849,13805325,17.4),(136429,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136429,32.44,0.8,30.8,64885,75,NULL,'A82, H','UGC 10288',NULL,'1997ApJS..109..333W',1997,1,5.71,NULL,'G',0.000005,NULL,'14.24',0.58,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.603333,-0.20753,0.397,NULL,45506601073,711040641,11110010,14.24),(136430,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136430,32.02,0.4,25.4,64885,75,NULL,NULL,'UGC 10288',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136431,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136431,32.11,NULL,26.4,64885,NULL,NULL,NULL,'UGC 10288',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136432,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136432,32.23,0.4,27.9,64885,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 10288',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136433,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136433,32.23,NULL,27.9,64885,NULL,NULL,'Dipole','UGC 10288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136434,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136434,32.23,NULL,28,64885,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136435,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136435,32.24,NULL,28,64885,NULL,NULL,'Dipole + Quadrupole','UGC 10288',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136436,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136436,32.45,0.4,30.9,64885,NULL,NULL,'mean','UGC 10288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136437,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136437,32.49,0.4,31.5,64885,75,NULL,'B','UGC 10288',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136438,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136438,32.51,0.47,31.8,64885,75,NULL,'A82, H, raw','UGC 10288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136439,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136439,32.53,0.46,32.1,64885,NULL,NULL,'J','UGC 10288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136440,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136440,32.54,0.47,32.2,64885,NULL,NULL,'H','UGC 10288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136441,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136441,32.59,0.36,33,64885,NULL,NULL,NULL,'UGC 10288',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136442,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136442,32.61,0.47,33.2,64885,75,NULL,'A82, H, inv','UGC 10288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136443,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136443,32.65,0.45,33.9,64885,NULL,NULL,'K','UGC 10288',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136444,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136444,32.66,0.47,34,64885,75,NULL,'A82, H, cor','UGC 10288',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136445,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136445,32.66,0.49,34,64885,75,NULL,'IR','UGC 10288',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136446,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136446,32.68,0.2,34.4,64885,74.4,NULL,NULL,'UGC 10288',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136447,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136447,32.71,0.43,34.8,64885,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10288',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136448,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136448,32.75,0.43,35.5,64885,75,NULL,'3.6 micron, color corrected','UGC 10288',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136449,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136449,37.88,0.46,376,64886,70,NULL,NULL,'2MASX J16142566+5207287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000091,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.607125,52.12467,0.057,NULL,59709002224,932953159,14577393,17.3),(136450,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136450,35.93,0.1,153,64887,70,NULL,NULL,'NGC 6097',NULL,'2015arXiv151105856S',2015,1,1.12,NULL,'G',0.000087,NULL,'14.3g',0.59,NULL,NULL,NULL,NULL,NULL,1,243.6090417,35.10917,0.009,NULL,59778527788,934039496,14594367,14.3),(136451,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136451,37.12,0.46,266,64888,70,NULL,NULL,'2MASX J16142639+5106330',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000087,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.6100417,51.10931,0.013,NULL,59710019241,932969050,14577641,17),(136452,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136452,37.87,0.27,374,64889,70,NULL,NULL,'2MASX J16142716+2817164',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.613167,28.28792,0.109,NULL,59740903140,933451611,14585181,17.8),(136453,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136453,35.95,0.39,155,64890,NULL,NULL,'Malmquist cor.','CGCG 167-056',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000113,NULL,'15.06',0.6,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.61575,29.97386,0.037,NULL,59738011859,933406435,14584475,15.06),(136454,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136454,36.31,0.33,183,64890,NULL,NULL,NULL,'CGCG 167-056',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136455,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136455,36.33,0.2,185,64890,74.4,NULL,NULL,'CGCG 167-056',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136456,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS11aea','N',136456,41.14,0.11,1300,64891,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11aea HOST',0.3001,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136457,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136457,37.87,0.27,374,64892,70,NULL,NULL,'B2 1612+28',NULL,'2015arXiv151105856S',2015,1,0.33,'TXS codes: lobes(C)','G',0.0002,NULL,'15.1',0.25,'BrClG          WLAGN',NULL,NULL,NULL,NULL,1,243.618333,28.29194,0.109,NULL,59740902928,933451608,14585181,15.1),(136458,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136458,38.77,0.46,567,64893,70,NULL,NULL,'SDSS J161428.66+483533.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000086,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.6194583,48.59253,0,NULL,59705459252,932897800,14576528,18.3),(136459,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10ji','N',136459,40.12,0.14,856,64894,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ji HOST',0.2311,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136460,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136460,38.1,0.46,417,64895,70,NULL,NULL,'2MASX J16142908+1750522',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.621333,17.84792,0.113,NULL,56561134486,883767726,13808870,18.4),(136461,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136461,33.31,0.4,46,64896,NULL,NULL,'mean','IC 1210',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000103,NULL,'14.00',0.5,'Sab','Field galaxy',NULL,NULL,NULL,1,243.625625,62.53669,0,NULL,57646722387,900730037,14073906,14),(136462,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136462,33.54,0.47,50.9,64896,NULL,NULL,'H','IC 1210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136463,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136463,33.61,0.45,52.7,64896,NULL,NULL,'K','IC 1210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136464,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136464,33.62,0.46,53.1,64896,NULL,NULL,'J','IC 1210',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136465,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136465,37.3,0.33,289,64897,70,NULL,NULL,'2MASX J16143088+5048460',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,243.6284583,50.81281,0.017,NULL,59710056018,932969625,14577650,16.8),(136466,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136466,38.31,0.46,460,64898,70,NULL,NULL,'2MASX J16143194+4825471',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000081,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.633,48.42986,0,NULL,59705470422,932897975,14576530,18.1),(136467,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136467,37.36,0.46,297,64899,70,NULL,NULL,'2MASX J16143198+4931131',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,243.633166667,49.52039,0,NULL,59703081752,932860652,14575947,16.6),(136468,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136468,32.44,0.4,30.8,64900,75,NULL,'B','UGC 10290',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000013,NULL,'13.8',1.7,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.637291667,0.82156,0.337,NULL,56450986673,882046666,13781979,13.8),(136469,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136469,37.04,0.46,256,64901,70,NULL,NULL,'2MASX J16143308+3749548',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.638,37.83186,0.017,NULL,59772724581,933948821,14592950,16.9),(136470,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136470,37.39,0.46,301,64902,70,NULL,NULL,'SDSS J161434.06+265629.3',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000165,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.6419583,26.9415,0.085,NULL,59730150556,933283602,14582556,18.6),(136471,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136471,36.54,0.46,203,64903,70,NULL,NULL,'2MASX J16143476+2534374',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.644875,25.57694,0.125,NULL,59727735652,933245869,14581966,16.7),(136472,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136472,35.47,0.33,124,64904,70,NULL,NULL,'KUGX 1612+343',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.00009,NULL,'14.9g',0.57,'Compact',NULL,NULL,NULL,NULL,1,243.647083,34.22253,0.013,NULL,59792857304,934263395,14597865,14.9),(136473,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136473,37.11,0.46,264,64905,70,NULL,NULL,'2MASX J16143549+1642062',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000152,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.648083,16.70172,0.141,NULL,56543696949,883495264,13804613,16.6),(136474,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136474,37.78,0.46,360,64906,70,NULL,NULL,'2MASX J16143566+3952049',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.648417,39.86792,0,NULL,59802221056,934409704,14600151,17.6),(136475,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136475,36.89,0.46,239,64907,70,NULL,NULL,'2MASX J16143719+0541175',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.655,5.68814,0.225,NULL,56502560721,882852511,13794570,17.2),(136476,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136476,34.88,0.46,94.6,64908,70,NULL,NULL,'2MASX J16143829+5225221',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000064,NULL,'16.0g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,243.659458333,52.42294,0.065,NULL,59708111446,932939241,14577175,16),(136477,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136477,38.85,0.46,589,64909,70,NULL,NULL,'2MASX J16143850+2852173',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.660375,28.87153,0.105,NULL,59743260611,933488447,14585756,17.8),(136478,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136478,36.34,0.46,185,64910,70,NULL,NULL,'2MASX J16143906+0702424',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.662667,7.04511,0.205,NULL,56468567584,882321368,13786271,17.1),(136479,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136479,37.02,0.46,253,64911,70,NULL,NULL,'2MASX J16144079+1137524',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.670041667,11.63128,0.201,NULL,56574503438,883976616,13812134,17.3),(136480,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136480,38.16,0.46,428,64912,70,NULL,NULL,'2MASX J16144231+1646372',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.676417,16.77694,0.141,NULL,56543915510,883498679,13804666,17),(136481,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136481,34.96,0.49,98.1,64913,75,NULL,'IR','FGC 2006',NULL,'2011yCatp016004901K',2011,1,1.35,NULL,'G',0.000009,NULL,'16.6g',0.14,'Sd',NULL,NULL,NULL,NULL,1,243.686417,27.86139,0.117,NULL,59740806471,933450101,14585157,16.6),(136482,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136482,34.99,NULL,99.3,64913,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136483,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136483,35,NULL,100,64913,NULL,NULL,'Dipole + Quadrupole','FGC 2006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136484,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136484,35.02,NULL,101,64913,NULL,NULL,'Dipole','FGC 2006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136485,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136485,36.68,0.46,217,64914,70,NULL,NULL,'2MASX J16144647+2253378',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,243.6937083,22.894,0.169,NULL,56640191345,885002989,13828171,16.6),(136486,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136486,37.34,0.46,294,64915,70,NULL,NULL,'2MASX J16144690+2010298',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000153,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.6954583,20.17494,0.109,NULL,56516094096,883063970,13797874,17.2),(136487,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136487,36,0.46,159,64916,70,NULL,NULL,'2MASX J16144772+1953018',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000186,NULL,'16.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.6989583,19.88386,0.105,NULL,56515917331,883061208,13797831,16.6),(136488,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136488,36.73,0.46,222,64917,70,NULL,NULL,'2MASX J16144805+2918014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'16.8g',0.27,'Sa',NULL,NULL,NULL,NULL,1,243.700417,29.30036,0.089,NULL,59743356912,933489951,14585780,16.8),(136489,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136489,35.51,0.2,126,64918,74.4,NULL,NULL,'UGC 10296',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000133,NULL,'15.35',0.6,'Scd:',NULL,NULL,NULL,NULL,1,243.706375,39.51439,0.005,NULL,59802348708,934411698,14600182,15.35),(136490,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136490,35.75,0.08,142,64918,NULL,NULL,NULL,'UGC 10296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136491,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136491,36.09,0.59,165,64919,70,NULL,NULL,'2MASX J16145014-0054561',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000086,NULL,'15.8g',0.36,NULL,NULL,NULL,NULL,NULL,1,243.708875,-0.91567,0.457,NULL,45508117887,711064341,11110380,15.8),(136492,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136492,36.32,0.46,184,64920,70,NULL,NULL,'2MASX J16145017+3655420',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.708917,36.92844,0.017,NULL,59772442802,933944418,14592881,17),(136493,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136493,37.99,0.46,396,64921,70,NULL,NULL,'2MASX J16145267+4112260',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.719458333,41.20731,0,NULL,59799311044,934364235,14599441,17.6),(136494,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136494,36.45,0.33,195,64922,70,NULL,NULL,'2MASX J16145283+4953452',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.720167,49.89581,0.009,NULL,59707710479,932932976,14577077,17.5),(136495,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136495,37.71,0.75,349,64923,70,NULL,NULL,'2MASX J16145298-6623478',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.7205,-66.39669,0.737,NULL,44995948154,703061689,10985338,15.8),(136496,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136496,37.64,0.46,337,64924,70,NULL,NULL,'2MASX J16145525+0624024',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.730125,6.40061,0.185,NULL,56467957645,882311838,13786122,17.1),(136497,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136497,35.4,0.46,120,64925,70,NULL,NULL,'KUGX 1613+331A',NULL,'2015arXiv151105856S',2015,1,0.65,'Listed in CGCG special map in vol III, p 87 (SM1-006).','G',0.00017,NULL,'15.4g',0.57,'Compact',NULL,NULL,NULL,NULL,1,243.734125,33.06267,0.025,NULL,59784038225,934125597,14595712,15.4),(136498,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136498,37.74,0.46,353,64926,70,NULL,NULL,'2MASX J16145701+3045143',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000188,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.7374583,30.75406,0.053,NULL,59737572006,933399562,14584368,16.9),(136499,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136499,37.39,0.46,300,64927,70,NULL,NULL,'2MASX J16145761+0020015',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000094,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.74,0.33367,0.353,NULL,56448770751,882012042,13781438,17.9),(136500,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136500,37.66,0.46,341,64928,70,NULL,NULL,'2MASX J16145805+1703380',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,243.7419583,17.06061,0.117,NULL,56543835027,883497422,13804647,17),(136501,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136501,37.01,0.46,253,64929,70,NULL,NULL,'2MASXi J1614594+371111',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,243.747625,37.18656,0.009,NULL,59772803511,933950054,14592969,17.5),(136502,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136502,36.43,0.23,193,64930,70,NULL,NULL,'2MASX J16145941+5020282',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000093,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,243.747666667,50.34108,0.021,NULL,59709707485,932964179,14577565,15.95),(136503,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136503,37.58,0.46,328,64931,70,NULL,NULL,'SDSS J161500.31+213953.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,243.7512917,21.66494,0.161,NULL,56507833884,882934904,13795857,18.5),(136504,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136504,38.12,0.33,420,64932,70,NULL,NULL,'2MASX J16150054+4932472',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000092,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.752375,49.54653,0,NULL,59703067027,932860422,14575944,17.4),(136505,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136505,36.39,0.46,189,64933,70,NULL,NULL,'2MASX J16150160+3901110',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,243.756875,39.01983,0,NULL,59801852588,934403946,14600061,16.4),(136506,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136506,32.93,0.4,38.5,64934,75,NULL,'Edat, raw','ESO 137- G 006',NULL,'1997ApJS..109..333W',1997,1,1.5,'abs(b) < 10 degrees.','G',0.000117,NULL,'13.5B',1.1,'E1;cD','Group member, radial-velocity confirmed',NULL,'WAT',NULL,1,243.766,-60.90717,NULL,NULL,44377688002,693401375,10834396,13.5),(136507,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136507,33.25,0.4,44.7,64934,75,NULL,'Edat, cor','ESO 137- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136508,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136508,37.74,0.46,353,64935,70,NULL,NULL,'2MASX J16150418+0854264',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.767583,8.90736,0.165,NULL,56470151997,882346124,13786658,17.4),(136509,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136509,34.73,0.49,88.5,64936,75,NULL,'IR','FGC 2008',NULL,'2011yCatp016004901K',2011,1,0.83,NULL,'G',0.000058,NULL,'16.6g',0.19,'Sdm',NULL,NULL,NULL,NULL,1,243.768417,31.46308,0.053,NULL,59782634093,934103657,14595369,16.6),(136510,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136510,35.03,NULL,101,64936,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136511,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136511,35.06,NULL,103,64936,NULL,NULL,'Dipole + Quadrupole','FGC 2008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136512,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136512,35.08,NULL,104,64936,NULL,NULL,'Dipole','FGC 2008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136513,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136513,35.46,NULL,124,64936,NULL,NULL,NULL,'FGC 2008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136514,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136514,36.6,0.46,209,64937,70,NULL,NULL,'2MASX J16150461+4335441',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000093,NULL,'15.4g',0.55,'E0',NULL,NULL,NULL,NULL,1,243.769375,43.59553,0.009,NULL,59850341711,935161589,14611899,15.4),(136515,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136515,37.07,0.64,259,64938,70,NULL,NULL,'2MASX J16150566-1505270',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,243.7735417,-15.09081,0.857,NULL,45463659309,710369676,11099526,15),(136516,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136516,37.88,0.46,378,64939,70,NULL,NULL,'2MASX J16150614+0905124',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.775667,9.08669,0.157,NULL,56456458196,882132159,13783314,17.7),(136517,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136517,38.45,0.46,491,64940,70,NULL,NULL,'2MASX J16150631+3809260',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.7764583,38.15708,0.009,NULL,59769121057,933892516,14592070,18.6),(136518,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136518,37.06,0.46,258,64941,70,NULL,NULL,'2MASX J16150777+3430164',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.782417,34.50447,0.009,NULL,59792077516,934251211,14597675,16.8),(136519,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136519,37.79,0.46,361,64942,70,NULL,NULL,'2MASX J16150856+1637280',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.785541667,16.62453,0.141,NULL,56543779663,883496557,13804633,17.2),(136520,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136520,36.77,0.46,226,64943,70,NULL,NULL,'2MASX J16150870+5228511',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.7862917,52.48089,0.065,NULL,59708227308,932941051,14577203,16.8),(136521,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136521,38.12,0.33,420,64944,70,NULL,NULL,'2MASX J16150924+4927481',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000073,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,243.7882917,49.46333,0.005,NULL,59703250795,932863293,14575988,18.2),(136522,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136522,37.59,0.46,330,64945,70,NULL,NULL,'2MASX J16151199+1431160',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000194,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,243.799875,14.52108,0.097,NULL,56554233519,883659898,13807185,16.7),(136523,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136523,36.45,0.33,195,64946,70,NULL,NULL,'2MASX J16151252+5006444',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.802125,50.11225,0.017,NULL,59707650520,932932039,14577063,17.1),(136524,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136524,34.87,0.69,94.3,64947,100,NULL,'mid-IR','IC 1206',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000033,NULL,'14.6g',0.69,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,243.8044583,11.29739,0.197,NULL,56576806798,884012606,13812696,14.6),(136525,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136525,35.83,0.47,146,64947,NULL,NULL,'H','IC 1206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136526,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136526,35.9,0.4,152,64947,NULL,NULL,'mean','IC 1206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136527,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136527,36.01,0.45,159,64947,NULL,NULL,'K','IC 1206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136528,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136528,36.04,0.46,161,64947,NULL,NULL,'J','IC 1206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136529,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136529,37.7,0.46,346,64948,70,NULL,NULL,'2MASX J16151534+2644118',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000177,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,243.814041667,26.73681,0.093,NULL,59730118188,933283096,14582548,17.4),(136530,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136530,37.13,0.13,267,64949,70,NULL,NULL,'2MASX J16151564+4935365',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000105,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,243.815375,49.59358,0,NULL,59707720347,932933130,14577080,16.3),(136531,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136531,36.76,0.46,225,64950,70,NULL,NULL,'2MASX J16151688+0009455',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000081,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,243.8204583,0.16264,0.377,NULL,56448634810,882009918,13781404,17.5),(136532,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136532,36.82,0.46,231,64951,70,NULL,NULL,'2MASX J16151959+3042534',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.8315,30.71483,0.057,NULL,59737585712,933399776,14584371,17),(136533,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136533,37.77,0.46,359,64952,70,NULL,NULL,'2MASX J16152183+1623390',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.8409583,16.39419,0.133,NULL,56547253930,883550842,13805481,16.9),(136534,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136534,37.59,0.46,329,64953,70,NULL,NULL,'2MASX J16152301+2047434',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000157,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.845833,20.79533,0.113,NULL,56515122420,883048787,13797637,18.5),(136535,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136535,37.4,0.46,302,64954,70,NULL,NULL,'2MASX J16152302+3823038',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.845917,38.3845,0,NULL,59798721483,934355023,14599297,17.2),(136536,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136536,37.24,0.46,281,64955,70,NULL,NULL,'2MASX J16152333+4801335',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000071,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.847083,48.02606,0,NULL,59705423241,932897238,14576519,17.5),(136537,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136537,35.48,0.46,124,64956,70,NULL,NULL,'CGCG 167-059 NED02',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000165,NULL,'15.4g',0.32,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,243.8475,26.618,0.093,NULL,59731018421,933297162,14582768,15.4),(136538,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136538,35.47,0.33,124,64957,70,NULL,NULL,'KUGX 1613+343',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000053,NULL,'15.7g',0.41,'Compact',NULL,NULL,NULL,NULL,1,243.858375,34.22453,0.009,NULL,59792899996,934264062,14597875,15.7),(136539,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136539,37.6,0.46,332,64958,70,NULL,NULL,'2MASX J16152638+1031436',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.8600417,10.52883,0.177,NULL,56575237269,883988082,13812313,16.5),(136540,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136540,38.11,0.46,419,64959,70,NULL,NULL,'SDSS J161528.71+431718.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,243.869666667,43.28844,0.021,NULL,59850223686,935159745,14611871,18),(136541,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136541,32.62,0.4,33.5,64960,75,NULL,NULL,'UGC 10297',NULL,'2008Ap.....51..336K',2008,1,2.24,NULL,'G',0.000013,NULL,'14.96',0.29,'Sc',NULL,NULL,NULL,NULL,1,243.870083,18.90486,0.109,NULL,56514438705,883038104,13797470,14.96),(136542,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136542,32.76,0.4,35.6,64960,NULL,NULL,NULL,'UGC 10297',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136543,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136543,32.87,0.43,37.5,64960,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10297',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136544,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136544,32.89,0.2,37.8,64960,74.4,NULL,NULL,'UGC 10297',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136545,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136545,32.89,0.43,37.9,64960,75,NULL,'3.6 micron, color corrected','UGC 10297',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136546,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136546,32.9,NULL,38,64960,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136547,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136547,32.91,NULL,38.2,64960,NULL,NULL,'Dipole + Quadrupole','UGC 10297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136548,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136548,32.91,NULL,38.2,64960,NULL,NULL,'Dipole','UGC 10297',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136549,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136549,32.98,NULL,39.5,64960,NULL,NULL,NULL,'UGC 10297',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136550,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136550,33.04,0.5,40.5,64960,NULL,NULL,NULL,'UGC 10297',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136551,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136551,33.06,0.49,40.9,64960,75,NULL,'IR','UGC 10297',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136552,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136552,33.09,0.49,41.5,64960,NULL,NULL,'Malmquist cor.','UGC 10297',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136553,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136553,38.59,0.46,521,64961,70,NULL,NULL,'2MASX J16152913+0814386',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.871375,8.24411,0.189,NULL,56470345299,882349145,13786705,18.6),(136554,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136554,36.66,0.46,215,64962,70,NULL,NULL,'2MASX J16153082+3030136',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,243.87825,30.50378,0.037,NULL,59737562276,933399410,14584365,16.3),(136555,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136555,36.26,0.73,179,64963,70,NULL,NULL,'2MASX J16153116-1444420',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.879875,-14.74506,1.325,NULL,45463837052,710372453,11099569,15.2),(136556,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136556,36.2,0.56,174,64964,70,NULL,NULL,'2MASX J16153172-7318038',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,243.8822917,-73.30111,0.329,NULL,44117526304,689336348,10770880,15.4),(136557,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136557,37.41,0.46,304,64965,70,NULL,NULL,'2MASX J16153195+0031233',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000086,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,243.88325,0.52328,0.337,NULL,56448684680,882010698,13781417,16.7),(136558,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136558,36.12,0.61,167,64966,70,NULL,NULL,'2MASX J16153251-8257177',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,'E int',NULL,NULL,NULL,NULL,1,243.8847917,-82.95492,0.381,NULL,44046382709,688224729,10753511,16.4),(136559,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136559,38.34,0.46,466,64967,70,NULL,NULL,'2MASX J16153258+2434117',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.8857083,24.56986,0.141,NULL,56170276623,877660572,13713446,17.8),(136560,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136560,36.96,NULL,247,64968,NULL,NULL,'3.1 (red) calibration, NH = 12.1 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,243.892208333,-6.12397,0.741,NULL,45538661729,711541589,11117837,NULL),(136561,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136561,37.85,NULL,372,64968,NULL,NULL,'4.2 (black) calibration, NH = 12.1 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136562,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136562,38.12,0.38,420,64968,NULL,NULL,'Isotherm.','ABELL 2163',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136563,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136563,38.43,NULL,485,64968,NULL,NULL,'4.1 (blue) calibration, NH = 12.1 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136564,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136564,38.58,0.19,520,64968,NULL,NULL,'Hydrost. Eq.','ABELL 2163',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136565,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136565,39.03,NULL,641,64968,NULL,NULL,'3.1 (red) calibration, NH = 18.7 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136566,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136566,39.23,1.24,702,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'1997ApJ...480..449H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136567,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136567,39.32,0.74,730,64968,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2163',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136568,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136568,39.39,NULL,755,64968,NULL,NULL,'4.2 (black) calibration, NH = 18.7 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136569,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136569,39.44,1.1,772,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'1998ApJ...507L...5L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136570,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136570,39.49,0.04,790,64968,70,NULL,NULL,'ABELL 2163',NULL,'1997ApJ...481...35H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136571,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136571,39.53,NULL,806,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136572,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136572,39.59,NULL,828,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136573,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136573,39.73,NULL,884,64968,NULL,NULL,'4.1 (blue) calibration, NH = 18.7 _ 10e20 cm_2','ABELL 2163',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136574,'SZ effect','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136574,39.8,1.11,913,64968,NULL,NULL,NULL,'ABELL 2163',NULL,'1997ApJ...480..449H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136575,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136575,37.13,0.13,267,64969,70,NULL,NULL,'2MASX J16153415+4936436',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.892375,49.61208,0,NULL,59707721546,932933149,14577080,17.1),(136576,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136576,37.76,0.46,357,64970,70,NULL,NULL,'2MASX J16153422+2806337',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000113,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.892667,28.10944,0.109,NULL,59742843948,933481936,14585655,16.9),(136577,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136577,37.59,0.46,330,64971,70,NULL,NULL,'2MASX J16153421+5129066',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.8g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,243.89275,51.48514,0.041,NULL,59708730187,932948909,14577326,17.8),(136578,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136578,35.26,0.4,113,64972,NULL,NULL,'mean','IC 1215',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.0001,NULL,'14.10',0.7,'SBc            HII',NULL,NULL,NULL,NULL,1,243.896375,68.39767,0.129,NULL,57832459025,903632172,14119252,14.1),(136579,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136579,35.35,0.47,118,64972,NULL,NULL,'H','IC 1215',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136580,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136580,35.84,0.4,147,64973,NULL,NULL,'mean','NGC 6099',NULL,'2007A&A...465...71T',2007,1,0.18,NULL,'G',0.000033,NULL,'15.9g',0.17,'E+','Pair member (points to parent)',NULL,NULL,NULL,1,243.898166667,19.45339,0.105,NULL,56517963281,883093176,13798330,15.9),(136581,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136581,37.14,0.45,268,64973,NULL,NULL,'K','NGC 6099',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136582,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136582,35.31,0.2,115,64974,74.4,NULL,NULL,'UGC 10301',NULL,'2013AJ....146...86T',2013,1,0.59,NULL,'G',0.000007,NULL,'16.0g',0.23,'SBb:',NULL,NULL,NULL,NULL,1,243.907375,31.32131,0.077,NULL,59782644331,934103817,14595372,16),(136583,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136583,36.57,0.46,206,64975,70,NULL,NULL,'2MASX J16153898+3047217',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000175,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,243.9124583,30.78947,0.057,NULL,59737576455,933399632,14584369,16.2),(136584,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136584,36.99,0.27,250,64976,70,NULL,NULL,'2MASX J16153969+2241253',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.915417,22.69042,0.173,NULL,56643612696,885056448,13829007,17.2),(136585,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136585,36.99,0.27,250,64977,70,NULL,NULL,'2MASX J16154147+2241230',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.92275,22.68967,0.173,NULL,56643610770,885056418,13829006,17.6),(136586,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136586,37.33,0.46,292,64978,70,NULL,NULL,'2MASX J16154195+4523012',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,243.9247917,45.38375,0.009,NULL,59849130562,935142665,14611604,16.9),(136587,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136587,36.4,0.46,191,64979,70,NULL,NULL,'2MASX J16154340+1531279',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.9309583,15.52442,0.113,NULL,56546183489,883534117,13805220,17),(136588,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136588,38.69,0.46,546,64980,70,NULL,NULL,'SDSS J161543.60+223606.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.9317083,22.60178,0.173,NULL,56643575863,885055872,13828998,18.9),(136589,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136589,36.99,0.27,250,64981,70,NULL,NULL,'2MASX J16154464+2243330',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00021,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,243.9360417,22.72589,0.173,NULL,56643605910,885056342,13829005,16.1),(136590,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136590,37.43,0.46,306,64982,70,NULL,NULL,'2MASX J16154519+3149187',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000178,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.938125,31.82183,0.061,NULL,59783436644,934116197,14595565,16.6),(136591,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136591,32.93,0.4,38.5,64983,75,NULL,'Edat, raw','ESO 137- G 008',NULL,'1997ApJS..109..333W',1997,1,1.6,'abs(b) < 10 degrees.','G',0.000127,NULL,'13.1B',1.4,'S0-:;cD','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.942,-60.91872,NULL,NULL,44377691463,693401429,10834397,13.1),(136592,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136592,33.25,0.4,44.7,64983,75,NULL,'Edat, cor','ESO 137- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136593,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136593,34.27,0.07,71.3,64983,NULL,NULL,'Norma Cluster, ABELL 3627, n = 121 early-type galaxies','ESO 137- G 008',NULL,'2014MNRAS.439.3666M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136594,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136594,33.46,0.45,49.2,64983,NULL,NULL,'K','ESO 137- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136595,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136595,33.52,0.4,50.6,64983,NULL,NULL,'mean','ESO 137- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136596,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136596,37.81,0.46,365,64984,70,NULL,NULL,'2MASX J16154806+3826208',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000167,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,243.950125,38.43908,0,NULL,59798774924,934355858,14599310,17),(136597,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136597,37.19,0.46,274,64985,70,NULL,NULL,'2MASX J16154852+1219467',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,243.9522917,12.32964,0.161,NULL,56541599003,883462484,13804101,16.8),(136598,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136598,38.14,0.46,424,64986,70,NULL,NULL,'2MASX J16154868+1049463',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.9529583,10.82953,0.185,NULL,56576353868,884005529,13812586,17.8),(136599,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136599,32.93,0.4,38.5,64987,75,NULL,'Edat, raw','ESO 137- G 010',NULL,'1997ApJS..109..333W',1997,1,2.5,'abs(b) < 10 degrees.','G',0.000107,NULL,'12.46',1.5,'(R\')SAB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,243.959,-60.80306,NULL,NULL,44377665512,693401023,10834390,12.46),(136600,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136600,33.25,0.4,44.7,64987,75,NULL,'Edat, cor','ESO 137- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136601,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136601,33.2,0.45,43.7,64987,NULL,NULL,'K','ESO 137- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136602,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136602,33.27,0.4,45,64987,NULL,NULL,'mean','ESO 137- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136603,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136603,38.07,0.33,411,64988,70,NULL,NULL,'2MASX J16155059+2125480',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,243.9607083,21.43014,0.161,NULL,56640966626,885015103,13828360,17.9),(136604,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136604,38.07,0.33,411,64989,70,NULL,NULL,'2MASX J16155145+2121450',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,243.9645417,21.36247,0.165,NULL,56640969560,885015149,13828361,18.2),(136605,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS11xc','N',136605,41.32,0.28,1380,64990,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11xc HOST',0.3281,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136606,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136606,37.81,0.46,364,64991,70,NULL,NULL,'SDSS J161552.11+360911.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,243.967167,36.15328,0.013,NULL,59771405788,933928215,14592628,18.2),(136607,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136607,34.93,0.46,96.6,64992,70,NULL,NULL,'ARK 498',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000143,NULL,'15.0g',0.67,'Compact',NULL,NULL,NULL,NULL,1,243.9695,36.99747,0.013,NULL,59772346798,933942918,14592858,15),(136608,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136608,38.08,0.46,413,64993,70,NULL,NULL,'2MASX J16155303+4202493',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000177,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,243.9710417,42.04714,0.021,NULL,59806585789,934477902,14601217,17.6),(136609,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136609,37.69,0.46,346,64994,70,NULL,NULL,'2MASX J16155411+2752183',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,243.9754583,27.87189,0.097,NULL,59742662663,933479104,14585611,17.2),(136610,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136610,36.57,0.46,206,64995,70,NULL,NULL,'2MASX J16155429+1827300',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,243.976291667,18.45847,0.117,NULL,56514926768,883045730,13797589,17.5),(136611,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136611,35.35,0.2,117,64996,74.4,NULL,NULL,'UGC 10305',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.000014,NULL,'15.8g',0.32,'S?',NULL,NULL,NULL,NULL,1,243.978875,31.69078,0.061,NULL,59782555084,934102423,14595350,15.8),(136612,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136612,35.74,NULL,141,64997,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2010',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000011,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,243.9810417,16.78419,0.141,NULL,56543797659,883496838,13804638,16.5),(136613,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136613,35.75,0.49,141,64997,75,NULL,'IR','FGC 2010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136614,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136614,35.76,NULL,142,64997,NULL,NULL,'Dipole + Quadrupole','FGC 2010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136615,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136615,35.78,NULL,143,64997,NULL,NULL,'Dipole','FGC 2010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136616,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136616,35.78,NULL,144,64997,NULL,NULL,NULL,'FGC 2010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136617,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136617,36.35,0.2,186,64997,74.4,NULL,NULL,'FGC 2010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136618,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136618,37.22,0.46,278,64998,70,NULL,NULL,'2MASX J16155567+2348490',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000187,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,243.982083,23.81372,0.153,NULL,56640047017,885000734,13828136,17.2),(136619,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136619,37.23,0.33,280,64999,70,NULL,NULL,'2MASX J16155711+1224118',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,243.9880417,12.40328,0.161,NULL,56541595401,883462428,13804100,16.2),(136620,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136620,36.74,0.46,223,65000,70,NULL,NULL,'2MASX J16155934+1346208',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.1g',0.37,NULL,NULL,NULL,NULL,NULL,1,243.997333,13.77253,0.125,NULL,56540582855,883446607,13803853,16.1),(136621,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136621,37.79,0.46,361,65001,70,NULL,NULL,'2MASX J16155955+1328478',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,243.9980417,13.48003,0.137,NULL,56542427846,883475435,13804303,17.4),(136622,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136622,36.48,0.46,198,65002,70,NULL,NULL,'2MASX J16160054+3709200',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.00225,37.15558,0.009,NULL,59772361779,933943152,14592861,16.9),(136623,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136623,37.13,0.13,267,65003,70,NULL,NULL,'2MASX J16160155+4921267',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000079,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.006375,49.35753,0.005,NULL,59703187035,932862297,14575973,17.2),(136624,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136624,36.57,NULL,206,65004,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2011',NULL,'2010Ap&SS.325..163P',2010,1,0.75,NULL,'G',0.000019,NULL,'17.1',0.09,'Sc',NULL,NULL,NULL,NULL,1,244.014083333,11.48092,0.201,NULL,56576614967,884009608,13812650,17.1),(136625,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136625,36.58,NULL,207,65004,NULL,NULL,'Dipole + Quadrupole','FGC 2011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136626,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136626,36.6,NULL,209,65004,NULL,NULL,'Dipole','FGC 2011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136627,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136627,36.68,NULL,217,65004,NULL,NULL,NULL,'FGC 2011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136628,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136628,36.98,0.2,249,65004,74.4,NULL,NULL,'FGC 2011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136629,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136629,34.67,0.52,85.8,65005,70,NULL,NULL,'IC 4596',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000123,NULL,'15.5',0.5,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,244.0150417,-22.62539,0.645,NULL,45905910358,717279849,11207497,15.5),(136630,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136630,35.83,0.43,147,65005,75,NULL,'3.6 micron, color + selection bias corrected','IC 4596',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136631,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136631,37.67,0.46,343,65006,70,NULL,NULL,'2MASX J16160446+4829247',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.018791667,48.49031,0,NULL,59703465908,932866654,14576041,17),(136632,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136632,36.98,0.46,249,65007,70,NULL,NULL,'2MASX J16160506+2430193',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000161,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,244.0212083,24.50544,0.149,NULL,56170294573,877660852,13713450,16.3),(136633,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136633,35,0.46,100,65008,70,NULL,NULL,'2MASX J16160538+3740130',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00009,NULL,'15.4g',0.45,'S0',NULL,NULL,NULL,NULL,1,244.0225,37.67036,0.005,NULL,59769214893,933893982,14592093,15.4),(136634,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136634,36.13,0.46,168,65009,70,NULL,NULL,'I Zw 138',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00011,NULL,'15.5g',0.56,'E0',NULL,NULL,NULL,NULL,1,244.024833,50.91544,0.041,NULL,59709266913,932957295,14577457,15.5),(136635,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136635,37.13,0.13,267,65010,70,NULL,NULL,'2MASX J16160719+4917347',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000106,NULL,'15.6g',0.39,NULL,NULL,NULL,NULL,NULL,1,244.030125,49.29292,0,NULL,59703217750,932862777,14575980,15.6),(136636,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136636,37.81,0.46,365,65011,70,NULL,NULL,'2MASX J16160810+0850491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.033875,8.84711,0.161,NULL,56470624138,882353502,13786773,17.4),(136637,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136637,37.99,0.46,397,65012,70,NULL,NULL,'2MASX J16161009+4751387',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.0419583,47.86086,0,NULL,59703307678,932864182,14576002,18.1),(136638,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136638,37.66,0.46,340,65013,70,NULL,NULL,'SDSS J161611.80+325742.4',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',NULL,'PHOT','16.2g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,244.0492083,32.96178,0.025,NULL,59793272070,934269876,14597966,16.2),(136639,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136639,37.75,0.46,355,65014,70,NULL,NULL,'2MASX J16161193+0922401',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.049667,9.37775,0.145,NULL,56457320244,882145628,13783525,NULL),(136640,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136640,37.78,0.46,360,65015,70,NULL,NULL,'2MASX J16161378+1031251',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.057375,10.52347,0.177,NULL,56575150607,883986728,13812292,17.4),(136641,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136641,37.68,0.27,343,65016,70,NULL,NULL,'2MASX J16161554+3455451',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.064666667,34.92931,0.009,NULL,59779198213,934049972,14594530,17),(136642,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136642,37.68,0.27,343,65017,70,NULL,NULL,'2MASX J16161587+3453371',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.06625,34.89369,0.009,NULL,59779198915,934049983,14594530,17.7),(136643,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136643,31,0.4,15.8,65018,75,NULL,'B','UGC 10310',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000004,NULL,'13.58',2.2,'SB(s)m',NULL,NULL,NULL,NULL,1,244.0764583,47.04642,0,NULL,59832495077,934882735,14607542,13.58),(136644,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136644,36.01,0.46,159,65019,70,NULL,NULL,'2MASX J16162041+1157191',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.0849583,11.95533,0.185,NULL,56576453789,884007090,13812610,16.3),(136645,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136645,38.5,0.46,502,65020,70,NULL,NULL,'2MASX J16162076+4839498',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.086625,48.66375,0,NULL,59703587779,932868559,14576071,17.9),(136646,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136646,37.26,0.46,283,65021,70,NULL,NULL,'2MASX J16162187+2248022',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.091125,22.80058,0.185,NULL,56643592422,885056131,13829002,17.7),(136647,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136647,37.44,0.46,307,65022,70,NULL,NULL,'2MASX J16162297+1321121',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.095833,13.35344,0.137,NULL,56542624286,883478504,13804351,17.1),(136648,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136648,37.2,0.46,275,65023,70,NULL,NULL,'2MASX J16162454+1538111',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000153,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.102125,15.63631,0.113,NULL,56546226255,883534785,13805231,16.8),(136649,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136649,37.62,0.46,334,65024,70,NULL,NULL,'2MASX J16162592+0009547',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000091,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.107875,0.16511,0.349,NULL,56448848713,882013261,13781457,17.9),(136650,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136650,37.06,0.46,258,65025,70,NULL,NULL,'2MASX J16162645+2824434',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.110333,28.41217,0.081,NULL,59743486919,933491983,14585812,17.6),(136651,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136651,37.25,0.46,281,65026,70,NULL,NULL,'2MASX J16162748+5212177',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000111,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,244.114541667,52.20483,0.057,NULL,59708927643,932951994,14577374,16.3),(136652,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136652,36.89,0.46,239,65027,70,NULL,NULL,'2MASX J16162832+2834494',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000184,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.118167,28.58047,0.069,NULL,59743612021,933493937,14585842,16.6),(136653,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136653,35.85,0.46,148,65028,70,NULL,NULL,'2MASX J16162994+2115052',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000178,NULL,'16.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,244.124875,21.25142,0.157,NULL,56640934590,885014602,13828353,16),(136654,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136654,34.78,0.17,87.9,65029,74.2,NULL,'SALT 2','NGC 6104',0.028116,'2010ApJ...716..712A',2010,1,0.95,NULL,'G',0.0001,NULL,'14.2g',0.78,'S(R)pec/Pec    Sy1.5',NULL,NULL,NULL,'Sy 1.5',1,244.127875,35.70806,0.005,NULL,59778888207,934045128,14594455,14.2),(136655,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136655,35.35,0.09,117,65029,74.4,NULL,NULL,'NGC 6104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136656,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136656,35.46,0.15,120,65029,70,NULL,'SALT 2','NGC 6104',0.028116,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136657,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136657,35.49,0.16,122,65029,73.8,NULL,'SALT 2 (SNANA)','NGC 6104',0.0277,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136658,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de','R',136658,35.45,0.05,123,65029,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 6104',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136659,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de','R',136659,35.51,0.04,126,65029,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 6104',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136660,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136660,35.63,0.19,130,65029,65,NULL,'MLCS31','NGC 6104',0.028116,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136661,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136661,35.66,0.2,132,65029,65,NULL,'SALT2','NGC 6104',0.028116,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136662,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136662,35.68,0.17,133,65029,65,NULL,'SALT','NGC 6104',0.028116,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136663,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136663,35.71,0.16,135,65029,65,NULL,'MLCS17','NGC 6104',0.028116,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136664,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','SN 2002de',NULL,136664,36.26,0.02,174,65029,70,NULL,'SALT 2','NGC 6104',0.028116,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136665,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136665,36.92,0.33,242,65030,70,NULL,NULL,'2MASX J16163080+1449062',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.128291667,14.81839,0.089,NULL,56554843142,883669424,13807334,17.7),(136666,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136666,36.49,0.46,199,65031,70,NULL,NULL,'2MASX J16163144+4122478',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00008,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,244.1309583,41.38003,0.005,NULL,59799499754,934367183,14599487,16.4),(136667,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136667,34.51,0.47,79.9,65032,70,NULL,NULL,'ESO 100- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'12.4R',0.9,'(R\'_1)SB(r)ab',NULL,NULL,NULL,NULL,1,244.136167,-65.65242,0.833,NULL,44995555304,703055551,10985242,12.4),(136668,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136668,37.42,0.46,305,65033,70,NULL,NULL,'2MASX J16163329+1726072',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.138875,17.43536,0.141,NULL,56543540761,883492824,13804575,17.2),(136669,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136669,36.92,0.33,242,65034,70,NULL,NULL,'2MASX J16163384+1447412',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.141,14.79467,0.089,NULL,56554845161,883669455,13807335,16.9),(136670,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136670,37.46,0.46,310,65035,70,NULL,NULL,'2MASX J16163422+3246251',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000937,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.142625,32.77367,0.049,NULL,59790372970,934224577,14597259,18.1),(136671,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136671,37.21,0.46,277,65036,70,NULL,NULL,'2MASX J16163531+2119022',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.1472917,21.31739,0.157,NULL,56640990754,885015480,13828366,18.1),(136672,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136672,37.74,0.33,353,65037,70,NULL,NULL,'2MASX J16163551+5209367',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,244.147875,52.16042,0.057,NULL,59708926630,932951978,14577374,16.6),(136673,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136673,37.23,0.33,280,65038,70,NULL,NULL,'SDSS J161637.09+123654.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.0g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.154583,12.615,0.173,NULL,56542847343,883481989,13804406,18),(136674,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136674,35.12,NULL,106,65039,NULL,NULL,'Dipole','FGC 2013',NULL,'2010Ap&SS.325..163P',2010,1,1.18,NULL,'G',0.000009,NULL,'16.6',0.11,'Sc',NULL,NULL,NULL,NULL,1,244.17,14.65,0.137,NULL,56554942374,883670974,13807358,16.6),(136675,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136675,35.13,NULL,106,65039,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136676,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136676,35.13,NULL,106,65039,NULL,NULL,'Dipole + Quadrupole','FGC 2013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136677,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136677,35.27,NULL,113,65039,NULL,NULL,NULL,'FGC 2013',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136678,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136678,35.41,0.2,121,65039,74.4,NULL,NULL,'FGC 2013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136679,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136679,37.22,0.46,278,65040,70,NULL,NULL,'2MASX J16164175+1407222',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.173917,14.12292,0.149,NULL,56554533289,883664582,13807259,17.4),(136680,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136680,38.02,0.21,401,65041,70,NULL,NULL,'2MASX J16164219+2700035',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.175708333,27.00106,0.101,NULL,59730183110,933284111,14582564,17.5),(136681,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136681,38.12,0.27,420,65042,70,NULL,NULL,'2MASX J16164222+1302442',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.176,13.04561,0.169,NULL,56543319721,883489370,13804521,16.4),(136682,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136682,37.18,0.46,273,65043,70,NULL,NULL,'2MASX J16164259+3400468',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000153,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.1775,34.01311,0.013,NULL,59792708082,934261063,14597829,17),(136683,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136683,38.12,0.27,420,65044,70,NULL,NULL,'2MASX J16164331+1256112',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.180458333,12.93644,0.169,NULL,56543339825,883489684,13804526,18),(136684,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136684,35.48,0.8,125,65045,75,NULL,'CF, r','UGC 10306',NULL,'1997ApJS..109..333W',1997,1,1.47,NULL,'G',0.00002,NULL,'14.8g',0.57,'(R\')SAB(s)b:','Group member',NULL,NULL,NULL,1,244.1815,0.24647,0.349,NULL,56448162247,882002535,13781289,14.8),(136685,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136685,35.17,0.38,108,65045,75,NULL,'CF, r, raw','UGC 10306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136686,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136686,35.41,0.38,121,65045,75,NULL,'CF, r, inv','UGC 10306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136687,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136687,35.41,0.38,121,65045,75,NULL,'CF, r, cor','UGC 10306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136688,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136688,35.42,0.28,121,65045,NULL,NULL,'Malmquist cor.','UGC 10306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136689,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136689,35.46,0.28,124,65045,NULL,NULL,NULL,'UGC 10306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136690,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136690,35.51,0.2,126,65045,74.4,NULL,NULL,'UGC 10306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136691,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136691,35.66,0.47,136,65045,NULL,NULL,'H','UGC 10306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136692,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136692,35.72,0.4,139,65045,NULL,NULL,'mean','UGC 10306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136693,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136693,35.84,0.46,147,65045,NULL,NULL,'J','UGC 10306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136694,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136694,35.88,0.45,150,65045,NULL,NULL,'K','UGC 10306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136695,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136695,36.58,0.46,207,65046,70,NULL,NULL,'2MASX J16164540+2851475',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000179,NULL,'16.1g',0.45,'SB0',NULL,NULL,NULL,NULL,1,244.18925,28.86333,0.065,NULL,59743424979,933491015,14585797,16.1),(136696,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136696,38.61,0.46,527,65047,70,NULL,NULL,'2MASX J16164992+2254589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.208125,22.9165,0.197,NULL,56643774906,885058982,13829046,18),(136697,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136697,37.77,0.33,358,65048,70,NULL,NULL,'2MASX J16165007+1354115',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.20875,13.90319,0.149,NULL,56540757803,883449340,13803895,17.5),(136698,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136698,34.61,0.4,83.5,65049,NULL,NULL,'mean','IC 1211',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000063,NULL,'13.72',1,'E','Isolated galaxy',NULL,NULL,NULL,1,244.216583333,53.00603,0.021,NULL,59694442803,932725668,14573838,13.72),(136699,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136699,34.78,0.45,90.5,65049,NULL,NULL,'K','IC 1211',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136700,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136700,37.18,0.33,273,65050,70,NULL,NULL,'2MASX J16165216+3440139',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.217417,34.67058,0.005,NULL,59792492650,934257697,14597776,16.7),(136701,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136701,36.08,0.46,164,65051,70,NULL,NULL,'2MASX J16165257+1433236',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.219167,14.55664,0.137,NULL,56554889793,883670153,13807346,16.3),(136702,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136702,38.02,0.21,401,65052,70,NULL,NULL,'2MASX J16165352+2656357',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000167,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,244.223,26.94333,0.101,NULL,59728299588,933254681,14582104,18.3),(136703,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136703,35.93,0.1,153,65053,70,NULL,NULL,'2MASX J16165400+3457159',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.224916667,34.95453,0.009,NULL,59779247689,934050745,14594542,16.9),(136704,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136704,37.4,0.46,302,65054,70,NULL,NULL,'SDSS J161654.82+403909.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,244.228458333,40.65258,0,NULL,59800260568,934379071,14599672,18.4),(136705,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136705,37.21,0.46,277,65055,70,NULL,NULL,'2MASX J16165564+1457546',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.231875,14.96514,0.125,NULL,56554822231,883669097,13807329,16.6),(136706,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136706,37.51,0.16,318,65056,70,NULL,NULL,'2MASX J16165626+2433007',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.234333,24.55025,0.141,NULL,56170989495,877671710,13713620,17.7),(136707,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136707,35.96,0.46,155,65057,70,NULL,NULL,'2MASX J16165621+1956289',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.234417,19.94131,0.137,NULL,56646468228,885101066,13829704,16.6),(136708,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136708,37.68,0.27,343,65058,70,NULL,NULL,'2MASX J16165653+3452279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.235666667,34.87456,0.009,NULL,59779191600,934049868,14594529,17.9),(136709,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136709,38.02,0.21,401,65059,70,NULL,NULL,'2MASX J16165659+2657037',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000199,NULL,'17.3g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,244.235917,26.95106,0.101,NULL,59728299804,933254684,14582104,17.3),(136710,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136710,37.77,0.46,358,65060,70,NULL,NULL,'2MASX J16165704+0639049',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.237625,6.65153,0.209,NULL,56465961609,882280650,13785635,17.4),(136711,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136711,38.02,0.21,401,65061,70,NULL,NULL,'2MASX J16165763+2657067',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.24025,26.95192,0.101,NULL,59728299831,933254684,14582104,18.3),(136712,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136712,37.54,0.46,322,65062,70,NULL,NULL,'2MASX J16165796-0018347',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000092,NULL,'16.7g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,244.241375,-0.30983,0.369,NULL,45506185545,711034149,11109908,16.7),(136713,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136713,38.02,0.21,401,65063,70,NULL,NULL,'2MASX J16165845+2658037',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.243375,26.96789,0.101,NULL,59728301947,933254717,14582104,18.2),(136714,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136714,37.22,0.46,278,65064,70,NULL,NULL,'2MASX J16165853+1908049',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.244,19.13464,0.109,NULL,56514541502,883039710,13797495,17.9),(136715,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136715,37.77,0.46,357,65065,70,NULL,NULL,'2MASX J16165923+4014414',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00011,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.246917,40.24492,0,NULL,59799954790,934374293,14599598,16.9),(136716,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136716,38.12,0.27,420,65066,70,NULL,NULL,'2MASX J16170006+1308306',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.2502083,13.14194,0.161,NULL,56543316667,883489322,13804520,18.1),(136717,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136717,37.77,0.33,358,65067,70,NULL,NULL,'2MASX J16170168+1356236',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.256958333,13.93981,0.149,NULL,56540753787,883449277,13803894,16.7),(136718,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136718,38.92,0.46,608,65068,70,NULL,NULL,'2MASX J16170232+2202169',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.259583,22.03808,0.177,NULL,56641966147,885030721,13828605,18.4),(136719,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136719,37.38,0.46,300,65069,70,NULL,NULL,'2MASX J16170292+2603058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.262,26.05153,0.081,NULL,59730810404,933293912,14582717,17.3),(136720,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136720,37.9,0.46,381,65070,70,NULL,NULL,'2MASX J16170358+1036059',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.2650417,10.60161,0.181,NULL,56576189759,884002964,13812546,17),(136721,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136721,37.52,0.46,319,65071,70,NULL,NULL,'2MASX J16170521+2428488',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.2717917,24.48022,0.141,NULL,56171103433,877673491,13713648,17.3),(136722,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136722,37.57,0.46,327,65072,70,NULL,NULL,'2MASX J16170809+2757308',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000172,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.283916667,27.95858,0.097,NULL,59742848669,933482010,14585656,17.1),(136723,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136723,37.51,0.46,318,65073,70,NULL,NULL,'2MASX J16170836-0027197',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.284916667,-0.4555,0.369,NULL,45506970971,711046421,11110100,16.9),(136724,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136724,38.1,0.46,416,65074,70,NULL,NULL,'2MASX J16170870+2729358',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.286333,27.49328,0.097,NULL,59742118496,933470601,14585478,18.2),(136725,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136725,35.44,NULL,123,65075,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2014',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.00001,NULL,'16.4',0.11,'Scd',NULL,NULL,NULL,NULL,1,244.286833,19.99469,0.137,NULL,56646649323,885103895,13829748,16.4),(136726,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136726,35.46,NULL,124,65075,NULL,NULL,'Dipole + Quadrupole','FGC 2014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136727,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136727,35.47,NULL,124,65075,NULL,NULL,'Dipole','FGC 2014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136728,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136728,35.49,NULL,125,65075,NULL,NULL,NULL,'FGC 2014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136729,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136729,35.67,0.49,136,65075,75,NULL,'IR','FGC 2014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136730,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136730,35.55,0.25,129,65076,74.4,NULL,NULL,'NGC 6105',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000063,NULL,'15.29',0.5,'S0','Group member',NULL,NULL,NULL,1,244.2887917,34.87889,0.009,NULL,59778715711,934042432,14594413,15.29),(136731,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136731,35.77,0.32,143,65076,70,NULL,NULL,'NGC 6105',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136732,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136732,37.91,0.33,383,65077,70,NULL,NULL,'SDSS J161710.16+231338.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,244.292375,23.22742,0.161,NULL,56643688924,885057639,13829025,18.8),(136733,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136733,32.48,0.8,31.3,65078,75,NULL,'HMCL, I','ESO 137- G 014',NULL,'1997ApJS..109..333W',1997,1,1,'abs(b) < 10 degrees.','G',0.000053,NULL,'14.81',0.3,'S?;dusty patches','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,244.2950417,-58.31253,NULL,NULL,44380306845,693442294,10835035,14.81),(136734,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136734,31.91,0.4,24.1,65078,75,NULL,'HMCL, I, raw','ESO 137- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136735,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136735,31.98,0.4,24.9,65078,75,NULL,'HMCL, I, inv','ESO 137- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136736,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136736,32.27,0.4,28.5,65078,75,NULL,'HMCL, I, cor','ESO 137- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136737,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136737,37.51,0.16,318,65079,70,NULL,NULL,'2MASX J16171085+2429078',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.295125,24.48553,0.141,NULL,56171116650,877673697,13713651,16.6),(136738,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136738,35.93,0.1,153,65080,70,NULL,NULL,'2MASX J16171106+3530363',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000133,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,244.296291667,35.51014,0,NULL,59779075627,934048056,14594500,16.2),(136739,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136739,36.7,0.46,219,65081,70,NULL,NULL,'2MASX J16171159+3803366',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.2985,38.06025,0.005,NULL,59769274553,933894914,14592108,17.3),(136740,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136740,35.93,0.1,153,65082,70,NULL,NULL,'2MASX J16171197+3452583',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000133,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.3,34.88289,0.009,NULL,59778699491,934042179,14594409,NULL),(136741,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136741,37.91,0.33,383,65083,70,NULL,NULL,'2MASX J16171216+2320309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000129,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.300583333,23.34211,0.185,NULL,56640223428,885003491,13828179,17.7),(136742,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136742,38.07,0.46,411,65084,70,NULL,NULL,'2MASXi J1617128+224138',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000168,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.303375,22.69397,0.185,NULL,56643661928,885057217,13829019,18.4),(136743,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136743,37.73,0.33,352,65085,70,NULL,NULL,'SDSS J161712.83+301939.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.3035,30.32767,0.029,NULL,59739587185,933431049,14584860,18.5),(136744,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136744,37.18,0.33,273,65086,70,NULL,NULL,'KUGX 1615+349A',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000133,NULL,'15.8g',0.44,'Compact',NULL,NULL,NULL,NULL,1,244.3092083,34.79906,0.005,NULL,59778673073,934041766,14594402,15.8),(136745,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136745,36.62,0.46,211,65087,70,NULL,NULL,'2MASX J16171505+2941268',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000113,NULL,'16.9g',0.29,'S0',NULL,NULL,NULL,NULL,1,244.312875,29.69081,0.057,NULL,59740476012,933444937,14585077,16.9),(136746,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136746,29.93,0.69,9.67,65088,100,NULL,'mid-IR','MCG -02-41-001',NULL,'2013ApJ...771...88L',2013,1,2.4,'Extended HIPASS source','G',0.000003,NULL,'15',1.7,'SAB(r)b?',NULL,NULL,NULL,NULL,1,244.31575,-11.73192,0.981,NULL,45567664451,711994757,11124918,15),(136747,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136747,30.76,0.4,14.2,65088,NULL,NULL,'mean','MCG -02-41-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136748,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136748,31.48,0.45,19.8,65088,NULL,NULL,'K','MCG -02-41-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136749,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136749,31.51,0.47,20,65088,NULL,NULL,'H','MCG -02-41-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136750,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136750,31.56,0.46,20.5,65088,NULL,NULL,'J','MCG -02-41-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136751,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS11aij','N',136751,42.21,0.15,1830,65089,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11aij HOST',0.51,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136752,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136752,37.51,0.46,318,65090,70,NULL,NULL,'2MASX J16171728+1649401',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.321875,16.82775,0.141,NULL,56544116473,883501819,13804715,16.7),(136753,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136753,36.94,0.46,245,65091,70,NULL,NULL,'KUGX 1615+332',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000169,NULL,'16.0g',0.44,'Compact',NULL,NULL,NULL,NULL,1,244.3287917,33.08317,0.045,NULL,59793460847,934272825,14598012,16),(136754,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136754,37.02,0.46,253,65092,70,NULL,NULL,'KUGX 1615+360',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000127,NULL,'16.1g',0.28,'Spiral',NULL,NULL,NULL,NULL,1,244.3289583,35.95111,0.013,NULL,59779040015,934047500,14594492,16.1),(136755,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136755,35.07,0.4,103,65093,75,NULL,'Edat, raw','NGC 6107',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000053,NULL,'14.89',0.7,'cD;E:','Group member',NULL,NULL,NULL,1,244.333875,34.90194,0.013,NULL,59778699913,934042186,14594409,14.89),(136756,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136756,35.41,0.4,121,65093,75,NULL,'Edat, cor','NGC 6107',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136757,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136757,35.56,0.25,129,65093,74.4,NULL,NULL,'NGC 6107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136758,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136758,35.77,0.32,143,65093,70,NULL,NULL,'NGC 6107',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136759,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136759,32.92,0.49,38.4,65094,75,NULL,'IR','UGC 10331',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00004,NULL,'14.79',0.3,'S pec          Sbrst',NULL,NULL,NULL,NULL,1,244.3380417,59.32011,0,NULL,57623243278,900363176,14068174,14.79),(136760,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136760,37.97,0.46,392,65095,70,NULL,NULL,'SDSS J161723.32+212559.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.3472083,21.43317,0.153,NULL,56654774590,885230852,13831732,18.2),(136761,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136761,35.93,0.1,153,65096,70,NULL,NULL,'2MASX J16172391+3458164',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000133,NULL,'16.1g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,244.3497917,34.97133,0.013,NULL,59779212492,934050195,14594534,16.1),(136762,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136762,36.43,0.23,193,65097,70,NULL,NULL,'2MASX J16172531+5038396',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.35525,50.64444,0.045,NULL,59707334091,932927095,14576985,16.8),(136763,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136763,37.66,0.46,341,65098,70,NULL,NULL,'2MASX J16172545+2606539',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000176,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.356083333,26.11514,0.081,NULL,59730665801,933291653,14582682,17.3),(136764,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136764,36.43,0.23,193,65099,70,NULL,NULL,'2MASX J16172879+5037216',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.369833333,50.62258,0.053,NULL,59707334337,932927099,14576985,16.3),(136765,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136765,36.76,0.23,225,65100,70,NULL,NULL,'2MASX J16172932+5018396',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.8g',0.42,NULL,NULL,NULL,NULL,NULL,1,244.372083,50.31119,0.041,NULL,59707806074,932934469,14577101,15.8),(136766,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136766,37.68,0.33,343,65101,70,NULL,NULL,'2MASX J16172932+0707229',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.3722083,7.12306,0.221,NULL,56468360736,882318136,13786220,17.5),(136767,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136767,35.93,0.1,153,65102,70,NULL,NULL,'KUGX 1615+349B',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000067,NULL,'15.7g',0.37,'Compact',NULL,NULL,NULL,NULL,1,244.3735,34.82286,0.013,NULL,59778718419,934042475,14594413,15.7),(136768,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136768,37.74,0.33,353,65103,70,NULL,NULL,'2MASX J16173099+5217226',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.378917,52.28953,0.037,NULL,59708161251,932940019,14577187,17.4),(136769,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136769,37.23,0.46,279,65104,70,NULL,NULL,'2MASX J16173125+2908230',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.380125,29.13958,0.053,NULL,59742960264,933483754,14585683,17.1),(136770,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136770,35.93,0.1,153,65105,70,NULL,NULL,'2MASX J16173164+3456244',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.381917,34.94019,0.013,NULL,59778701895,934042217,14594409,17.3),(136771,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136771,35.93,0.1,153,65106,70,NULL,NULL,'2MASX J16173188+3456454',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000073,NULL,'16.77',0.33,NULL,NULL,NULL,NULL,NULL,1,244.382875,34.94594,0.013,NULL,59778701442,934042210,14594409,16.77),(136772,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136772,38.26,0.33,450,65107,70,NULL,NULL,'2MASX J16173202+2343598',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.3835,23.73325,0.161,NULL,56640569893,885008904,13828264,17.6),(136773,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136773,34.87,0.46,94.1,65108,70,NULL,NULL,'2MASX J16173377+4141186',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.0001,NULL,'15.8g',0.3,'S0/a',NULL,NULL,NULL,NULL,1,244.390541667,41.68856,0.005,NULL,59799280908,934363764,14599433,15.8),(136774,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136774,37.68,0.33,343,65109,70,NULL,NULL,'2MASX J16173436+0706099',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000165,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,244.393333,7.10283,0.209,NULL,56468359493,882318117,13786220,16.7),(136775,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136775,38.19,0.46,434,65110,70,NULL,NULL,'2MASX J16173488+0853009',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.3954583,8.88353,0.161,NULL,56470599781,882353121,13786767,17),(136776,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136776,35.39,0.46,120,65111,70,NULL,NULL,'CGCG 079-089',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000036,NULL,'15.2',0.6,NULL,NULL,NULL,NULL,NULL,1,244.39675,13.49203,0.137,NULL,56542556171,883477440,13804335,15.2),(136777,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136777,35.93,0.1,153,65112,70,NULL,NULL,'KUGX 1615+352B',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000067,NULL,'15.5g',0.27,'S0',NULL,NULL,NULL,NULL,1,244.3982917,35.13411,0.005,NULL,59779272516,934051133,14594548,15.5),(136778,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136778,37.13,0.13,267,65113,70,NULL,NULL,'2MASX J16173680+4956447',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.403208333,49.94578,0.033,NULL,59707985136,932937267,14577144,17.7),(136779,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136779,37.31,0.46,290,65114,70,NULL,NULL,'2MASX J16173860+5147037',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.411083,51.78436,0.029,NULL,59708654525,932947726,14577308,16.9),(136780,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136780,37.73,0.33,352,65115,70,NULL,NULL,'2MASX J16173867+3019364',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.41125,30.32669,0.029,NULL,59739679007,933432484,14584882,18.2),(136781,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136781,35.93,0.1,153,65116,70,NULL,NULL,'KUGX 1615+351B',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000133,NULL,'15.8g',0.25,'Compact',NULL,NULL,NULL,NULL,1,244.4115,35.06,0.005,NULL,59779203416,934050053,14594532,15.8),(136782,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136782,32.24,0.49,28.1,65117,70,NULL,NULL,'IC 4597',NULL,'2014MNRAS.445.2677S',2014,1,1.5,'This may also be NGC 6082.','G',0.000024,NULL,'16.4',1.2,'S        poss. LINER',NULL,NULL,NULL,NULL,1,244.415541667,-34.36594,1.057,NULL,46302408469,723475132,11304298,16.4),(136783,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136783,35.07,0.4,103,65118,75,NULL,'Edat, raw','NGC 6109',NULL,'1997ApJS..109..333W',1997,1,1.06,NULL,'G',0.00005,NULL,'14.2g',1,'E/S0;BrClG;LERGLINER','Group member',NULL,'FR I',NULL,1,244.418833333,35.00428,0.013,NULL,59778696922,934042139,14594408,14.2),(136784,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136784,35.41,0.4,121,65118,75,NULL,'Edat, cor','NGC 6109',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136785,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136785,35.55,0.25,129,65118,74.4,NULL,NULL,'NGC 6109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136786,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136786,35.77,0.32,143,65118,70,NULL,NULL,'NGC 6109',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136787,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136787,35.93,0.1,153,65118,70,NULL,NULL,'NGC 6109',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136788,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136788,37.79,0.46,361,65119,70,NULL,NULL,'SDSS J161740.62+242259.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.41925,24.38311,0.185,NULL,56171063332,877672864,13713638,18.2),(136789,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136789,37.69,0.46,344,65120,70,NULL,NULL,'2MASX J16174100+1234221',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000185,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,244.4207917,12.57292,0.169,NULL,56542737761,883480277,13804379,17.1),(136790,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136790,35.93,0.1,153,65121,70,NULL,NULL,'2MASX J16174311+3502284',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000168,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4295417,35.04111,0.005,NULL,59779203697,934050057,14594532,16.6),(136791,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136791,37.6,0.33,330,65122,70,NULL,NULL,'SDSS J161743.51+192655.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000166,NULL,'18.7g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.431333333,19.44869,0.133,NULL,56644664539,885072883,13829263,18.7),(136792,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136792,37.6,0.33,330,65123,70,NULL,NULL,'2MASX J16174365+1927579',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.431833,19.46597,0.133,NULL,56644665242,885072894,13829263,17.1),(136793,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136793,35.93,0.1,153,65124,70,NULL,NULL,'2MASX J16174481+3510485',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000133,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.43675,35.18006,0.005,NULL,59779090602,934048290,14594504,16.5),(136794,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136794,35.93,0.1,153,65125,70,NULL,NULL,'2MASX J16174565+3449445',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000133,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,244.440417,34.829,0.013,NULL,59778712697,934042385,14594412,16),(136795,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136795,37.86,0.46,373,65126,70,NULL,NULL,'2MASX J16174705+2838080',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000143,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.446,28.6355,0.065,NULL,59743566377,933493224,14585831,17.6),(136796,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136796,37.6,0.33,331,65127,70,NULL,NULL,'2MASX J16174739+1512098',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4475,15.20286,0.129,NULL,56545651782,883525809,13805090,17.1),(136797,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10jv','N',136797,41.29,0.12,1330,65128,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10jv HOST',0.36,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136798,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136798,36.13,0.46,169,65129,70,NULL,NULL,'2MASX J16174776+4115300',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.448917,41.25828,0,NULL,59799430380,934366099,14599470,16.7),(136799,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136799,37.04,0.46,256,65130,70,NULL,NULL,'2MASX J16174786+1427038',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000184,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.4495,14.45094,0.137,NULL,56554043244,883656925,13807139,17.1),(136800,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136800,36.43,0.23,193,65131,70,NULL,NULL,'2MASX J16174905+5019497',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'15.8g',0.46,NULL,NULL,NULL,NULL,NULL,1,244.454375,50.33042,0.041,NULL,59707790015,932934218,14577097,15.8),(136801,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136801,37.77,0.46,358,65132,70,NULL,NULL,'2MASX J16174920+4805337',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000139,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.455291667,48.09272,0,NULL,59703527067,932867610,14576056,17.7),(136802,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136802,35.56,0.2,129,65133,74.4,NULL,NULL,'CGCG 109-001',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.00006,NULL,'15.5g',0.49,'SBc',NULL,NULL,NULL,NULL,1,244.456,20.69131,0.113,NULL,56647123903,885111310,13829864,15.5),(136803,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136803,35.46,0.46,123,65134,70,NULL,NULL,'2MASX J16174983+1552218',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000087,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,244.4574583,15.87281,0.113,NULL,56545867505,883529179,13805143,15.4),(136804,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136804,37.35,0.46,295,65135,70,NULL,NULL,'2MASX J16175003+3834350',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.458666667,38.57647,0,NULL,59798804495,934356320,14599317,17),(136805,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136805,37.13,0.13,267,65136,70,NULL,NULL,'2MASX J16175045+4944477',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.4602083,49.74667,0.029,NULL,59707856874,932935263,14577113,NULL),(136806,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136806,37.73,0.46,351,65137,70,NULL,NULL,'2MASX J16175067+1652328',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.461083,16.87589,0.149,NULL,56544145506,883502273,13804723,17.6),(136807,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136807,37.34,0.46,293,65138,70,NULL,NULL,'2MASX J16175134+2955376',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.4640417,29.92711,0.061,NULL,59740466363,933444786,14585074,17.4),(136808,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136808,38.1,0.46,416,65139,70,NULL,NULL,'2MASX J16175212+2408100',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000187,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4672083,24.13628,0.173,NULL,56170517431,877664334,13713505,17.2),(136809,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136809,35.93,0.1,153,65140,70,NULL,NULL,'2MASX J16175279+3514496',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000133,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4699583,35.24708,0,NULL,59779100962,934048452,14594507,16.4),(136810,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136810,38.26,0.33,450,65141,70,NULL,NULL,'2MASX J16175356+2339449',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000186,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.4732917,23.66244,0.161,NULL,56640579695,885009057,13828266,18.1),(136811,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136811,38.27,0.46,451,65142,70,NULL,NULL,'2MASX J16175444+2226259',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.477,22.44069,0.153,NULL,56641728695,885027010,13828547,17.4),(136812,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136812,37.16,0.46,271,65143,70,NULL,NULL,'2MASX J16175453+2421398',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.47725,24.36125,0.185,NULL,56171062951,877672858,13713638,16.8),(136813,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136813,36.64,0.46,213,65144,70,NULL,NULL,'2MASX J16175702-0022530',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00008,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.487667,-0.38144,0.369,NULL,45506253335,711035208,11109925,17.2),(136814,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136814,38.02,0.46,402,65145,70,NULL,NULL,'2MASX J16175704+3808280',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.4877083,38.14108,0.005,NULL,59769284947,933895077,14592110,17.3),(136815,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136815,37.6,0.33,331,65146,70,NULL,NULL,'2MASX J16175872+1510168',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,244.494583,15.17125,0.129,NULL,56545700012,883526562,13805102,16.7),(136816,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136816,38.02,0.33,401,65147,70,NULL,NULL,'2MASX J16175994+3001077',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.49975,30.01872,0.061,NULL,59740341667,933442838,14585044,17.2),(136817,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136817,36.75,0.27,223,65148,70,NULL,NULL,'2MASX J16180044+4123320',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.00013,NULL,'15.6g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,244.50175,41.39219,0.005,NULL,59799391178,934365487,14599460,15.6),(136818,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136818,35.56,0.25,129,65149,74.4,NULL,NULL,'NGC 6112',NULL,'2013AJ....146...86T',2013,1,0.88,NULL,'G',0.000063,NULL,'14.5g',0.82,'E/S0','Group member',NULL,NULL,NULL,1,244.502333,35.11028,0.005,NULL,59779088693,934048260,14594504,14.5),(136819,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136819,35.77,0.32,143,65149,70,NULL,NULL,'NGC 6112',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136820,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136820,35.93,0.1,153,65149,70,NULL,NULL,'NGC 6112',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136821,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136821,38.24,0.46,445,65150,70,NULL,NULL,'2MASX J16180175+1647058',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000132,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.507417,16.78503,0.149,NULL,56544185288,883502895,13804732,17.8),(136822,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136822,38.72,0.46,555,65151,70,NULL,NULL,'SDSS J161802.85-002604.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000095,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.511917,-0.43456,0.369,NULL,45506254640,711035228,11109925,18.5),(136823,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136823,37.93,0.46,385,65152,70,NULL,NULL,'SDSS J161804.83+082722.2',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.520167,8.45619,0.201,NULL,56471233426,882363022,13786922,NULL),(136824,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136824,35.52,0.2,127,65153,74.4,NULL,NULL,'UGC 10320',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000033,NULL,'15.2g',0.35,'Sab',NULL,NULL,NULL,NULL,1,244.5307083,21.06644,0.157,NULL,56646331547,885098930,13829670,15.2),(136825,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136825,35.78,0.4,143,65153,NULL,NULL,'mean','UGC 10320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136826,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136826,35.95,0.47,155,65153,NULL,NULL,'H','UGC 10320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136827,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136827,36.05,0.45,162,65153,NULL,NULL,'K','UGC 10320',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136828,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136828,33.95,0.49,61.7,65154,75,NULL,'IR','UGC 10322',NULL,'2011yCatp016004901K',2011,1,1.41,'Multiple SDSS entries describe this object.','G',0.000013,NULL,'14.4g',0.38,'S',NULL,NULL,NULL,NULL,1,244.53275,22.22572,0.153,NULL,56641931077,885030173,13828596,14.4),(136829,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136829,33.99,0.47,62.7,65154,NULL,NULL,'H','UGC 10322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136830,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136830,34.07,0.45,65.1,65154,NULL,NULL,'K','UGC 10322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136831,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136831,34.08,0.4,65.6,65154,NULL,NULL,'mean','UGC 10322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136832,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136832,34.15,0.46,67.7,65154,NULL,NULL,'J','UGC 10322',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136833,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136833,38.06,0.33,409,65155,70,NULL,NULL,'SDSS J161808.40+123139.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.535,12.52772,0.185,NULL,56539902591,883435977,13803687,18.1),(136834,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136834,37.54,0.46,323,65156,70,NULL,NULL,'2MASX J16180900+4215334',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000188,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.537375,42.25939,0.005,NULL,59856951748,935264871,14613513,16.9),(136835,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136835,36.84,0.46,233,65157,70,NULL,NULL,'2MASX J16181082+2233109',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.5452083,22.553,0.153,NULL,56641718546,885026852,13828544,17),(136836,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136836,36.75,0.27,223,65158,70,NULL,NULL,'2MASX J16181233+4128290',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000087,NULL,'16.25',0.47,NULL,NULL,NULL,NULL,NULL,1,244.5514583,41.47486,0,NULL,59854914056,935233032,14613016,16.25),(136837,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136837,38.77,0.46,568,65159,70,NULL,NULL,'SDSS J161812.67+100944.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.5527917,10.16244,0.169,NULL,56459112053,882173625,13783962,18.3),(136838,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136838,37.5,0.62,316,65160,70,NULL,NULL,'2MASX J16181280-1616082',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,244.5532917,-16.26889,0.857,NULL,45459474428,710304287,11098504,14.8),(136839,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136839,33.32,0.8,46.2,65161,75,NULL,'MAT, I','IC 4598',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'13.07',0.6,'Sb:            HII',NULL,NULL,NULL,NULL,1,244.5554583,-31.44289,1.073,NULL,46301161390,723455646,11303994,13.07),(136840,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136840,32.97,0.32,39.3,65161,85,NULL,'I, raw','IC 4598',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136841,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136841,32.99,0.32,39.6,65161,85,NULL,'I, inv','IC 4598',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136842,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136842,33.12,0.2,42.1,65161,74.4,NULL,NULL,'IC 4598',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136843,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136843,33.15,0.43,42.7,65161,75,NULL,'MAT, I, raw','IC 4598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136844,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136844,33.27,0.43,45.1,65161,75,NULL,'MAT, I, inv','IC 4598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136845,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136845,33.69,0.43,54.7,65161,75,NULL,'MAT, I, cor','IC 4598',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136846,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136846,36.15,0.46,170,65162,70,NULL,NULL,'CGCG 079-093',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000163,NULL,'15.4g',0.53,NULL,NULL,NULL,NULL,NULL,1,244.5560417,12.71603,0.185,NULL,56542702979,883479734,13804370,15.4),(136847,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136847,37.94,0.46,388,65163,70,NULL,NULL,'2MASX J16181527+5224281',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.563583,52.40786,0.037,NULL,59694460953,932725952,14573843,17.8),(136848,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10ju','N',136848,41.16,0.15,1290,65164,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ju HOST',0.323,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136849,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136849,37.81,0.46,364,65165,70,NULL,NULL,'2MASX J16181616+3617310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.001162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.5672083,36.29197,0.025,NULL,59780903528,934076617,14594947,17.8),(136850,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136850,38.01,0.46,401,65166,70,NULL,NULL,'2MASX J16181616+1649123',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.567291667,16.81994,0.149,NULL,56544176436,883502756,13804730,17.6),(136851,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136851,37.9,0.46,381,65167,70,NULL,NULL,'2MASX J16181654+1237293',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,244.569,12.62478,0.185,NULL,56539931401,883436428,13803694,17.2),(136852,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136852,35.54,0.65,128,65168,70,NULL,NULL,'2MASX J16181677-2201195',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,244.5699583,-22.02214,0.669,NULL,45905468172,717272940,11207389,15.7),(136853,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136853,35.93,0.46,153,65169,70,NULL,NULL,'2MASX J16181763+3818410',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000087,NULL,'15.5g',0.44,'E0',NULL,NULL,NULL,NULL,1,244.5735417,38.31133,0.005,NULL,59798794270,934356160,14599315,15.5),(136854,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136854,36.02,0.46,160,65170,70,NULL,NULL,'KUGX 1616+342',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000133,NULL,'15.8g',0.42,'Compact',NULL,NULL,NULL,NULL,1,244.5777917,34.11114,0.025,NULL,59792605279,934259457,14597804,15.8),(136855,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136855,38.16,0.46,428,65171,70,NULL,NULL,'2MASX J16182068+3820411',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.5862083,38.34478,0.005,NULL,59798841410,934356897,14599326,17.4),(136856,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136856,37.6,0.46,332,65172,70,NULL,NULL,'SDSS J161821.39+002649.9',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.589125,0.44722,0.361,NULL,56448105031,882001641,13781275,17.1),(136857,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136857,35.93,0.1,153,65173,70,NULL,NULL,'2MASX J16182160+3459507',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.589833,34.99758,0.013,NULL,59778742162,934042846,14594419,16.5),(136858,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136858,37.51,0.16,318,65174,70,NULL,NULL,'2MASX J16182337+2405230',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.597333,24.08983,0.173,NULL,56640505341,885007895,13828248,17.7),(136859,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136859,35.55,0.25,129,65175,74.4,NULL,NULL,'NGC 6114',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000063,NULL,'14.8g',0.65,'S0a','Group member',NULL,NULL,NULL,1,244.5984583,35.17431,0.005,NULL,59778623249,934040988,14594390,14.8),(136860,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136860,35.77,0.32,143,65175,70,NULL,NULL,'NGC 6114',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136861,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136861,35.93,0.1,153,65176,70,NULL,NULL,'2MASX J16182423+3519357',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000067,NULL,'15.5g',0.39,'S0',NULL,NULL,NULL,NULL,1,244.6009583,35.3265,0,NULL,59779110596,934048603,14594509,15.5),(136862,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136862,38.06,0.33,409,65177,70,NULL,NULL,'2MASX J16182468+1228113',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000184,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.602917,12.46983,0.185,NULL,56539915178,883436174,13803690,17.5),(136863,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136863,36.99,0.46,250,65178,70,NULL,NULL,'KUG 1616+338A',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000187,NULL,'16.8g',0.24,'Compact',NULL,NULL,NULL,NULL,1,244.612,33.71461,0,NULL,59793016289,934265879,14597904,16.8),(136864,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136864,38.02,0.33,401,65179,70,NULL,NULL,'2MASX J16182930+3005517',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,244.622125,30.09786,0.029,NULL,59739642991,933431921,14584873,18.2),(136865,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136865,35.93,0.1,153,65180,70,NULL,NULL,'2MASX J16182971+3518367',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000113,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.623583,35.31006,0,NULL,59779064321,934047880,14594498,16.7),(136866,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136866,33.9,0.49,60.4,65181,75,NULL,'IR','UGC 10327',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.00001,NULL,'15.7g',0.25,'Sc',NULL,NULL,NULL,NULL,1,244.624958333,22.16314,0.153,NULL,56641866112,885029158,13828580,15.7),(136867,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136867,33.93,0.2,61.1,65181,74.4,NULL,NULL,'UGC 10327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (136868,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136868,34.25,NULL,70.8,65181,NULL,NULL,NULL,'UGC 10327',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136869,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136869,34.26,NULL,71.3,65181,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10327',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136870,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136870,34.29,NULL,72.3,65181,NULL,NULL,'Dipole + Quadrupole','UGC 10327',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136871,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136871,34.31,NULL,72.8,65181,NULL,NULL,'Dipole','UGC 10327',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136872,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136872,38.26,0.27,449,65182,70,NULL,NULL,'2MASX J16183037+1956479',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,244.626583,19.94661,0.137,NULL,56647697193,885120268,13830004,17),(136873,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136873,38.27,0.46,452,65183,70,NULL,NULL,'2MASX J16183131+3434097',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.630667,34.5695,0,NULL,59792524165,934258190,14597784,17.5),(136874,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136874,38.26,0.27,449,65184,70,NULL,NULL,'2MASX J16183307+1957389',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.6377917,19.96089,0.137,NULL,56647696980,885120265,13830004,17.5),(136875,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136875,38.31,0.46,458,65185,70,NULL,NULL,'2MASX J16183309+5126351',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000086,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.638041667,51.443,0.021,NULL,59708590798,932946731,14577292,17.7),(136876,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136876,34.14,0.66,67.1,65186,70,NULL,NULL,'2MASX J16183451-1517392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,244.6437917,-15.29425,1.149,NULL,45459001931,710296905,11098389,14.5),(136877,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136877,38.53,0.46,509,65187,70,NULL,NULL,'2MASX J16183474+4840031',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.644833,48.66756,0,NULL,59703675775,932869933,14576092,17.6),(136878,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136878,37.23,0.33,279,65188,70,NULL,NULL,'UGC 10332 NED01',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.5g',0.36,'E;BrClG',NULL,NULL,NULL,NULL,1,244.6465,29.81731,0.061,NULL,59740367098,933443235,14585050,16.5),(136879,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136879,38.32,0.46,461,65189,70,NULL,NULL,'2MASX J16183536+1109376',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.647208333,11.16036,0.209,NULL,56573383072,883959110,13811861,17.8),(136880,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136880,37.76,0.46,357,65190,70,NULL,NULL,'2MASX J16183643+5147161',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.6515417,51.78789,0.029,NULL,59708652158,932947689,14577307,17.7),(136881,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136881,37.23,0.33,279,65191,70,NULL,NULL,'UGC 10332 NED02',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000165,NULL,'16.9g',0.3,'Sc',NULL,NULL,NULL,NULL,1,244.6567917,29.81358,0.061,NULL,59740368914,933443264,14585051,16.9),(136882,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136882,37.58,0.33,328,65192,70,NULL,NULL,'2MASX J16183824+2356333',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000183,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,244.659291667,23.94258,0.173,NULL,56640645621,885010087,13828282,16.4),(136883,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136883,38.13,0.27,423,65193,70,NULL,NULL,'2MASX J16184093+1948088',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.670583333,19.80247,0.137,NULL,56647729746,885120777,13830012,17.1),(136884,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136884,36.71,0.55,220,65194,70,NULL,NULL,'2MASX J16184123-1542122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,244.671833,-15.70333,1.061,NULL,45459831527,710309867,11098591,15.4),(136885,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136885,35.92,0.46,153,65195,70,NULL,NULL,'2MASX J16184119+3037417',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,244.671833,30.62836,0.037,NULL,59739512008,933429875,14584841,16.4),(136886,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136886,36.75,0.27,223,65196,70,NULL,NULL,'2MASX J16184161+4129581',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000097,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,244.6735,41.49953,0,NULL,59855059408,935235303,14613051,16.1),(136887,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136887,38.26,0.27,449,65197,70,NULL,NULL,'2MASX J16184200+1957128',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.6750417,19.95353,0.137,NULL,56647699420,885120303,13830004,17.5),(136888,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136888,38.13,0.27,423,65198,70,NULL,NULL,'SDSS J161842.39+194927.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.5g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.676625,19.82428,0.137,NULL,56647700741,885120324,13830005,18.5),(136889,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136889,36.73,0.46,222,65199,70,NULL,NULL,'2MASX J16184303+1433104',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,244.67925,14.55292,0.133,NULL,56540370211,883443284,13803801,16.2),(136890,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136890,37.51,0.16,318,65200,70,NULL,NULL,'2MASX J16184413+2419554',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.683833,24.33211,0.185,NULL,56170635998,877666187,13713534,17.1),(136891,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136891,37.14,0.46,268,65201,70,NULL,NULL,'2MASX J16184478+4147531',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.686791667,41.79817,0,NULL,59854858991,935232171,14613002,17.3),(136892,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136892,35.54,0.46,128,65202,70,NULL,NULL,'CGCG 223-056',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000107,NULL,'15.0g',0.54,'S0','Isolated galaxy',NULL,NULL,NULL,1,244.6907917,39.33444,0.017,NULL,59798583342,934352864,14599263,15),(136893,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136893,37.58,0.33,328,65203,70,NULL,NULL,'2MASX J16184663+2354544',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.694541667,23.91525,0.173,NULL,56640652147,885010189,13828284,17),(136894,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136894,37.94,0.19,387,65204,70,NULL,NULL,'SDSS J161847.15+105842.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.6965,10.97844,0.193,NULL,56573395205,883959300,13811864,18.3),(136895,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136895,31.88,0.8,23.7,65205,75,NULL,'A82, H','NGC 6106',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000019,NULL,'12.84',1.4,'SA(s)c','Line-of-sight pair member',NULL,NULL,NULL,1,244.696541667,7.41089,0.213,NULL,56468231994,882316124,13786189,12.84),(136896,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136896,31.94,0.8,24.5,65205,75,NULL,'CF, r','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136897,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136897,30.97,0.69,15.6,65205,100,NULL,'mid-IR','NGC 6106',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136898,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136898,31.11,0.4,16.7,65205,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6106',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136899,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136899,31.6,0.47,20.9,65205,75,NULL,'A82, H, raw','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136900,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136900,31.61,0.47,21,65205,75,NULL,'A82, H, inv','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136901,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136901,31.8,0.43,22.9,65205,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6106',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136902,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136902,31.85,0.43,23.4,65205,75,NULL,'3.6 micron, color corrected','NGC 6106',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136903,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136903,31.93,0.2,24.3,65205,74.4,NULL,NULL,'NGC 6106',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136904,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136904,31.94,0.4,24.4,65205,NULL,NULL,'mean','NGC 6106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136905,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136905,31.94,0.4,24.5,65205,75,NULL,'B','NGC 6106',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136906,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136906,31.95,0.47,24.5,65205,75,NULL,'A82, H, cor','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136907,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136907,31.95,NULL,24.6,65205,72,NULL,NULL,'NGC 6106',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136908,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136908,31.96,0.36,24.7,65205,NULL,NULL,NULL,'NGC 6106',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136909,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136909,32.01,0.38,25.3,65205,75,NULL,'CF, r, raw','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136910,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136910,32.07,0.38,26,65205,75,NULL,'CF, r, inv','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136911,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136911,32.13,0.45,26.7,65205,NULL,NULL,'Malmquist cor.','NGC 6106',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136912,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136912,32.14,0.46,26.7,65205,NULL,NULL,'J','NGC 6106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136913,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136913,32.15,0.47,26.9,65205,NULL,NULL,'H','NGC 6106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136914,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136914,32.16,0.44,27,65205,NULL,NULL,NULL,'NGC 6106',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136915,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136915,32.19,0.38,27.4,65205,75,NULL,'CF, r, cor','NGC 6106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136916,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136916,32.2,0.45,27.6,65205,NULL,NULL,'K','NGC 6106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136917,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136917,38.13,0.27,423,65206,70,NULL,NULL,'2MASX J16184768+1950057',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.6987917,19.83475,0.137,NULL,56647731708,885120807,13830012,18),(136918,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136918,36.52,0.46,201,65207,70,NULL,NULL,'2MASX J16184795+2218147',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.7000417,22.304,0.153,NULL,56641391425,885021741,13828464,16.7),(136919,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136919,37.67,0.46,342,65208,70,NULL,NULL,'2MASX J16185049+4753540',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.7102083,47.89825,0.005,NULL,59834331475,934911429,14607991,17.2),(136920,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:55','1','PS1 SN PS10kc','N',136920,41.14,0.15,1260,65209,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10kc HOST',0.347,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136921,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136921,37.3,0.46,288,65210,70,NULL,NULL,'2MASX J16185475+4510384',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.728083,45.17719,0,NULL,59852164008,935190062,14612344,17.2),(136922,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136922,37.94,0.19,387,65211,70,NULL,NULL,'2MASX J16185520+1050226',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.730083,10.83969,0.185,NULL,56455819783,882122184,13783159,16.9),(136923,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136923,37.94,0.19,387,65212,70,NULL,NULL,'2MASX J16185547+1055246',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.7312917,10.92356,0.193,NULL,56455809964,882122030,13783156,17),(136924,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136924,36.95,0.33,245,65213,70,NULL,NULL,'2MASX J16185620+4629024',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.734041667,46.48406,0,NULL,59835560699,934930635,14608291,16.8),(136925,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136925,38.38,0.46,474,65214,70,NULL,NULL,'2MASX J16185790+5206116',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.740917,52.10317,0.033,NULL,59694787646,932731056,14573922,17.7),(136926,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136926,37.69,0.46,345,65215,70,NULL,NULL,'2MASX J16185866+1203420',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.7442917,12.0615,0.181,NULL,56573167550,883955742,13811808,17.2),(136927,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136927,37.2,0.46,275,65216,70,NULL,NULL,'2MASX J16190060+1506430',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000163,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.7525417,15.112,0.129,NULL,56545545432,883524147,13805064,16.9),(136928,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136928,37.94,0.19,387,65217,70,NULL,NULL,'2MASX J16190063+1056356',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.752667,10.94339,0.193,NULL,56455742480,882120976,13783140,17.4),(136929,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136929,38.35,0.21,469,65218,70,NULL,NULL,'SDSS J161901.72+081910.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.7g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,244.7572083,8.3195,0.201,NULL,56469291133,882332673,13786448,18.7),(136930,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136930,35.75,NULL,142,65219,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2020',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',0.000008,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,244.75775,15.76394,0.137,NULL,56546432605,883538009,13805281,16.5),(136931,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136931,35.77,NULL,143,65219,NULL,NULL,'Dipole + Quadrupole','FGC 2020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136932,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136932,35.79,NULL,144,65219,NULL,NULL,NULL,'FGC 2020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136933,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136933,35.79,NULL,144,65219,NULL,NULL,'Dipole','FGC 2020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136934,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136934,35.93,0.49,154,65219,75,NULL,'IR','FGC 2020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136935,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136935,37.29,0.46,287,65220,70,NULL,NULL,'2MASX J16190201+1244460',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.758333,12.74614,0.177,NULL,56540020003,883437812,13803715,17),(136936,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136936,38.43,0.46,485,65221,70,NULL,NULL,'SDSS J161902.14+233214.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000154,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,244.758917,23.53742,0.141,NULL,56643404649,885053197,13828956,19),(136937,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136937,37.23,0.33,280,65222,70,NULL,NULL,'2MASX J16190219+2605588',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.75925,26.09961,0.081,NULL,59728685264,933260707,14582198,16.9),(136938,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136938,37.23,0.33,280,65223,70,NULL,NULL,'2MASX J16190323+2606418',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000181,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,244.7635417,26.11169,0.081,NULL,59728685160,933260705,14582198,16.4),(136939,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136939,38.35,0.21,469,65224,70,NULL,NULL,'2MASX J16190521+0819045',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.771583333,8.31808,0.201,NULL,56469750635,882339853,13786560,17.1),(136940,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136940,38.4,0.33,479,65225,70,NULL,NULL,'2MASX J16190690+2645258',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.778667,26.75731,0.073,NULL,59728943276,933264738,14582261,16.5),(136941,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136941,37.47,0.46,312,65226,70,NULL,NULL,'2MASX J16190703+4354155',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.7792917,43.90422,0,NULL,59851810721,935184542,14612258,17.7),(136942,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136942,38.13,0.46,422,65227,70,NULL,NULL,'2MASX J16190936+2944348',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000178,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.789,29.74303,0.061,NULL,59740087092,933438860,14584982,17.9),(136943,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136943,35.54,0.46,128,65228,70,NULL,NULL,'CGCG 080-003',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000157,NULL,'15.2g',0.5,NULL,NULL,NULL,NULL,NULL,1,244.793917,14.07422,0.137,NULL,56541288049,883457625,13804025,15.2),(136944,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136944,33.45,0.4,49.1,65229,75,NULL,'Edat, raw','NGC 6125',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000022,NULL,'13.0',1.4,'E','in a pair',NULL,NULL,NULL,1,244.798125,57.98422,0,NULL,57622003534,900343805,14067871,13),(136945,'D-Sigma','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136945,33.79,0.4,57.2,65229,75,NULL,'Edat, cor','NGC 6125',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136946,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136946,34.12,0.4,66.6,65229,NULL,NULL,'mean','NGC 6125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136947,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136947,34.36,0.45,74.4,65229,NULL,NULL,'K','NGC 6125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136948,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136948,35.35,NULL,117,65230,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2022',NULL,'2010Ap&SS.325..163P',2010,1,1.24,NULL,'G',0.000088,NULL,'16.6g',0.13,'Sd',NULL,NULL,NULL,NULL,1,244.798875,39.74464,0.009,NULL,59801900323,934404692,14600073,16.6),(136949,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136949,35.36,NULL,118,65230,NULL,NULL,'Dipole + Quadrupole','FGC 2022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136950,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136950,35.38,NULL,119,65230,NULL,NULL,'Dipole','FGC 2022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136951,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136951,35.4,NULL,120,65230,NULL,NULL,NULL,'FGC 2022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136952,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136952,37.74,0.46,353,65231,70,NULL,NULL,'2MASX J16191238+2838128',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000151,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,244.8017083,28.63686,0.065,NULL,59743035182,933484924,14585701,17.3),(136953,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136953,37.84,0.46,370,65232,70,NULL,NULL,'2MASX J16191342+2417268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.805875,24.29092,0.185,NULL,56170598754,877665605,13713525,17.9),(136954,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136954,37.03,0.46,255,65233,70,NULL,NULL,'2MASX J16191399+4646285',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'PRED','16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,244.8082083,46.77469,0.005,NULL,59835732404,934933318,14608333,16.6),(136955,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136955,37.17,0.46,272,65234,70,NULL,NULL,'2MASX J16191496+2508409',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.812416667,25.14472,0.153,NULL,56170791267,877668613,13713572,16.7),(136956,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136956,36.78,0.46,227,65235,70,NULL,NULL,'2MASX J16191595+3729120',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000093,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,244.816625,37.48672,0,NULL,59769705413,933901647,14592213,16.5),(136957,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136957,37.84,0.46,370,65236,70,NULL,NULL,'2MASX J16191625+1039586',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.81775,10.66614,0.185,NULL,56455701693,882120338,13783130,16.8),(136958,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136958,36.68,0.46,217,65237,70,NULL,NULL,'2MASX J16191690+1541413',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,244.820416667,15.69481,0.137,NULL,56545581456,883524710,13805073,16.5),(136959,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136959,37.21,0.46,277,65238,70,NULL,NULL,'2MASX J16191710+3409318',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.821375,34.15894,0.009,NULL,59792639865,934259997,14597812,17.1),(136960,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136960,36.98,0.46,248,65239,70,NULL,NULL,'2MASX J16191775+1201593',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.8239583,12.03303,0.181,NULL,56573690577,883963915,13811936,18.2),(136961,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136961,32.38,NULL,29.9,65240,72,NULL,NULL,'CGCG 024-001',NULL,'2014Ap.....57..457K',2014,1,NULL,NULL,'G',0.000023,NULL,'15.4',NULL,NULL,NULL,NULL,NULL,NULL,1,244.824833333,1.70364,0.285,NULL,56455055095,882110235,13782972,15.4),(136962,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136962,37.32,0.23,291,65241,70,NULL,NULL,'2MASX J16191797+2432269',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,244.824958333,24.54092,0.173,NULL,56170500016,877664062,13713500,17.4),(136963,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136963,38.35,0.21,469,65242,70,NULL,NULL,'SDSS J161918.77+081540.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.8282083,8.26131,0.201,NULL,56469632786,882338012,13786531,18.4),(136964,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136964,37.51,0.16,318,65243,70,NULL,NULL,'2MASX J16191883+2413108',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000187,NULL,'15.5g',0.48,'BrClG',NULL,NULL,NULL,NULL,1,244.8284583,24.21969,0.185,NULL,56170424868,877662888,13713482,15.5),(136965,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136965,37.51,0.16,318,65244,70,NULL,NULL,'SDSS J161918.86+235935.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000163,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,244.828625,23.99331,0.173,NULL,56640470051,885007344,13828239,18.6),(136966,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136966,37.41,0.46,304,65245,70,NULL,NULL,'2MASX J16192002+3656410',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.833458333,36.94467,0.033,NULL,59769470288,933897973,14592155,17.3),(136967,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136967,38.4,0.33,479,65246,70,NULL,NULL,'SDSS J161921.00+265415.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000178,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,244.837541667,26.90422,0.085,NULL,59728886464,933263851,14582247,18.7),(136968,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136968,37.85,0.21,371,65247,70,NULL,NULL,'SDSS J161921.34+244806.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000143,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,244.838917,24.80189,0.157,NULL,56170907120,877670423,13713600,18.6),(136969,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136969,38,0.1,398,65248,70,NULL,NULL,'2MASX J16192151+3013407',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.839625,30.22792,0.029,NULL,59739628105,933431689,14584870,17.2),(136970,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136970,36.44,0.46,194,65249,70,NULL,NULL,'2MASX J16192170+4105240',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000113,NULL,'15.6g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,244.84025,41.08989,0,NULL,59855742951,935245983,14613218,15.6),(136971,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136971,37.94,0.19,387,65250,70,NULL,NULL,'2MASX J16192175+1051576',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,244.840625,10.86603,0.193,NULL,56455850367,882122661,13783166,NULL),(136972,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136972,34.22,0.46,69.7,65251,70,NULL,NULL,'CGCG 137-079',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000097,NULL,'15.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,244.842625,22.14686,0.153,NULL,56641351740,885021120,13828455,15.2),(136973,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136973,37.25,0.46,282,65252,70,NULL,NULL,'2MASX J16192609+4911036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.8585,49.18433,0.017,NULL,59702901297,932857832,14575903,17.8),(136974,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136974,37.51,0.16,318,65253,70,NULL,NULL,'SDSS J161926.06+241503.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,244.858625,24.25086,0.185,NULL,56170424602,877662884,13713482,18),(136975,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136975,38,0.1,398,65254,70,NULL,NULL,'2MASX J16192808+3006155',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.867083,30.10428,0.029,NULL,59739617598,933431524,14584867,18.2),(136976,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136976,35.28,0.49,114,65255,75,NULL,'IR','UGC 10340',NULL,'2011yCatp016004901K',2011,1,1.18,'RC3 has V = 5047 +- 11 km/s.','G',0.000172,NULL,'15.5g',0.24,'S?',NULL,NULL,NULL,NULL,1,244.867583333,36.29433,0.025,NULL,59780938316,934077161,14594955,15.5),(136977,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136977,35.55,0.2,129,65256,74.4,NULL,NULL,'UGC 10340',NULL,'2013AJ....146...86T',2013,1,1.18,'RC3 has V = 5047 +- 11 km/s.','G',0.000172,NULL,'15.5g',0.24,'S?',NULL,NULL,NULL,NULL,1,244.867583333,36.29433,0.025,NULL,59780938316,934077161,14594955,15.5),(136978,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136978,35.36,0.8,118,65257,75,NULL,'CF, r','UGC 10337',NULL,'1997ApJS..109..333W',1997,1,1.56,NULL,'G',0.00005,NULL,'14.6g',0.42,'Sb','Line-of-sight pair member',NULL,NULL,NULL,1,244.869167,7.27875,0.201,NULL,56466380150,882287189,13785737,14.6),(136979,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136979,35.37,0.38,118,65257,75,NULL,'CF, r, raw','UGC 10337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136980,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136980,35.57,0.4,130,65257,NULL,NULL,'mean','UGC 10337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136981,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136981,35.57,0.2,130,65257,74.4,NULL,NULL,'UGC 10337',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136982,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136982,35.59,0.38,131,65257,75,NULL,'CF, r, inv','UGC 10337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136983,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136983,35.6,0.38,132,65257,75,NULL,'CF, r, cor','UGC 10337',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136984,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136984,35.62,0.47,133,65257,NULL,NULL,'H','UGC 10337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136985,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136985,35.7,0.46,138,65257,NULL,NULL,'J','UGC 10337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136986,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136986,35.71,0.45,139,65257,NULL,NULL,'K','UGC 10337',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136987,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136987,35.48,0.46,125,65258,70,NULL,NULL,'2MASX J16192964+1827521',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.22',0.38,NULL,NULL,NULL,NULL,NULL,1,244.873417,18.46442,0.129,NULL,56644173830,885065216,13829144,16.22),(136988,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136988,38.35,0.21,469,65259,70,NULL,NULL,'2MASX J16193006+0819055',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.875166667,8.31822,0.201,NULL,56469756238,882339941,13786561,17.3),(136989,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136989,38.38,0.46,474,65260,70,NULL,NULL,'2MASX J16193143+2144271',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,244.880875,21.74086,0.125,NULL,56655463808,885241622,13831900,17.5),(136990,'FP','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,'R',136990,36.95,0.33,245,65261,70,NULL,NULL,'2MASX J16193245+4637375',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,'FoF','16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,244.885291667,46.62717,0.005,NULL,59835739425,934933428,14608334,16.4),(136991,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136991,34.27,0.4,71.6,65262,NULL,NULL,'mean','NGC 6130',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00016,NULL,'14.26',0.7,'SBbc:','in a pair',NULL,NULL,NULL,1,244.889333333,57.61497,0,NULL,57630676903,900479326,14069989,14.26),(136992,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136992,34.48,0.47,78.9,65262,NULL,NULL,'H','NGC 6130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136993,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:55','1',NULL,NULL,136993,34.56,0.46,81.5,65262,NULL,NULL,'J','NGC 6130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136994,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,136994,34.6,0.45,83.1,65262,NULL,NULL,'K','NGC 6130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(136995,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136995,37.28,0.46,286,65263,70,NULL,NULL,'2MASX J16193444+4023192',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.8934583,40.38867,0,NULL,59799785419,934371647,14599556,18),(136996,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136996,38,0.23,398,65264,70,NULL,NULL,'2MASX J16193524+1014402',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.896958333,10.24442,0.193,NULL,56459296624,882176509,13784007,17.4),(136997,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136997,37.74,0.46,353,65265,70,NULL,NULL,'2MASX J16193577+1952181',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000159,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.89925,19.87156,0.169,NULL,56647690117,885120158,13830002,17.4),(136998,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136998,38,0.1,398,65266,70,NULL,NULL,'2MASX J16193640+3011346',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,244.901417,30.19308,0.029,NULL,59732206505,933315726,14583058,18.3),(136999,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',136999,37.86,0.33,374,65267,70,NULL,NULL,'2MASX J16193660+4657014',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.90225,46.95044,0,NULL,59835239229,934925612,14608212,17.2),(137000,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137000,35.94,0.46,154,65268,70,NULL,NULL,'CGCG 109-004',NULL,'2015arXiv151105856S',2015,1,0.77,NULL,'G',0.000177,NULL,'15.0g',0.58,NULL,NULL,NULL,NULL,NULL,1,244.903667,15.27831,0.137,NULL,56545531655,883523932,13805061,15),(137001,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137001,37.86,0.33,374,65269,70,NULL,NULL,'2MASX J16193729+4655564',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000136,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.90525,46.93242,0,NULL,59835239342,934925614,14608212,17.7),(137002,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137002,36.76,0.23,225,65270,70,NULL,NULL,'2MASX J16193735+5034469',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,244.905541667,50.57967,0.021,NULL,59707484058,932929438,14577022,17.6),(137003,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137003,35.43,0.46,122,65271,70,NULL,NULL,'CGCG 196-038',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000087,NULL,'15.2g',0.59,NULL,NULL,NULL,NULL,NULL,1,244.9082917,34.32294,0.009,NULL,59792489313,934257645,14597775,15.2),(137004,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137004,36.73,0.46,221,65272,70,NULL,NULL,'2MASX J16193867+4052352',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000107,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,244.911375,40.87631,0,NULL,59855219785,935237809,14613090,15.2),(137005,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137005,37.84,0.46,369,65273,70,NULL,NULL,'2MASX J16193997+1617165',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000184,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.9164583,16.28806,0.185,NULL,56666637709,885416214,13834628,17.1),(137006,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137006,38,0.1,398,65274,70,NULL,NULL,'2MASX J16194003+3004096',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.916833,30.06922,0.029,NULL,59739604061,933431313,14584864,17.3),(137007,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137007,36.76,0.23,225,65275,70,NULL,NULL,'2MASX J16194030+5033150',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00011,NULL,'15.59',0.62,NULL,NULL,NULL,NULL,NULL,1,244.917833,50.554,0.021,NULL,59707485775,932929465,14577022,15.59),(137008,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137008,37.32,0.23,291,65276,70,NULL,NULL,'2MASX J16194092+2434203',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,244.920375,24.57233,0.165,NULL,56170485133,877663830,13713497,16.8),(137009,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137009,37.32,0.23,291,65277,70,NULL,NULL,'2MASX J16194121+2438103',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.921791667,24.63619,0.165,NULL,56170503942,877664124,13713501,17.2),(137010,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137010,35.93,0.1,153,65278,70,NULL,NULL,'2MASX J16194129+3509066',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'16.0g',0.27,'E0',NULL,NULL,NULL,NULL,1,244.922125,35.15169,0.005,NULL,59778634673,934041166,14594393,16),(137011,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137011,37.69,0.46,345,65279,70,NULL,NULL,'2MASX J16194218-0027216',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000106,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.925583,-0.45583,0.365,NULL,45514716861,711167450,11111991,17.9),(137012,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137012,38.35,0.21,469,65280,70,NULL,NULL,'2MASX J16194304+0819252',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,244.929167,8.32378,0.201,NULL,56469807962,882340749,13786574,18),(137013,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137013,37.94,0.19,387,65281,70,NULL,NULL,'2MASX J16194586+1102172',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.941125,11.03808,0.209,NULL,56455763904,882121311,13783145,17.5),(137014,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137014,37.84,0.46,369,65282,70,NULL,NULL,'2MASX J16194624+3857202',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,244.942667,38.95553,0,NULL,59799194289,934362410,14599412,17.2),(137015,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137015,36.54,0.46,203,65283,70,NULL,NULL,'2MASX J16194816+1313148',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000169,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,244.950708333,13.22064,0.157,NULL,56543103745,883485996,13804468,16.7),(137016,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137016,37.65,0.46,339,65284,70,NULL,NULL,'2MASX J16194842+2618133',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.951917,26.30383,0.093,NULL,59728545705,933258526,14582164,17.3),(137017,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137017,38,0.1,398,65285,70,NULL,NULL,'2MASX J16194957+3000505',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.956667,30.01411,0.061,NULL,59739603344,933431302,14584864,18),(137018,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137018,38,0.23,398,65286,70,NULL,NULL,'2MASX J16194981+1005012',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,244.957583,10.08367,0.165,NULL,56459523515,882180054,13784063,17.3),(137019,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137019,38.04,0.46,406,65287,70,NULL,NULL,'2MASX J16195052+4114492',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000168,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,244.960625,41.247,0,NULL,59854907235,935232925,14613014,17.2),(137020,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137020,37.32,0.23,291,65288,70,NULL,NULL,'2MASX J16195140+2434473',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000208,NULL,'15.9g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,244.9642083,24.57978,0.165,NULL,56170486466,877663851,13713497,15.9),(137021,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137021,37.85,0.21,371,65289,70,NULL,NULL,'2MASX J16195661+2444403',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,244.9857083,24.7445,0.157,NULL,56173927019,877717609,13714337,17),(137022,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137022,37.76,0.46,356,65290,70,NULL,NULL,'2MASX J16195660+1600268',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,244.985917,16.00758,0.177,NULL,56666695704,885417120,13834642,17.8),(137023,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137023,38.3,0.46,458,65291,70,NULL,NULL,'SDSS J162001.34+092220.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.005625,9.37225,0.137,NULL,56458182187,882159096,13783735,18.6),(137024,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137024,37.37,0.46,298,65292,70,NULL,NULL,'2MASX J16200178+4650504',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000139,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.007167,46.84742,0,NULL,59835725489,934933210,14608331,17.2),(137025,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137025,37.28,0.46,286,65293,70,NULL,NULL,'2MASX J16200237+4547494',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000168,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,245.009833,45.79731,0.009,NULL,59835428783,934928574,14608258,16.6),(137026,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137026,37.85,0.21,371,65294,70,NULL,NULL,'SDSS J162003.45+244328.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.014375,24.72444,0.165,NULL,56173926069,877717594,13714337,18.5),(137027,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137027,38.22,0.46,440,65295,70,NULL,NULL,'2MASX J16200382+3445479',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.0157917,34.76331,0.013,NULL,59778560364,934040005,14594375,17.7),(137028,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137028,37.01,0.46,252,65296,70,NULL,NULL,'2MASX J16200555+1451488',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000166,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.023083,14.86375,0.129,NULL,56540321468,883442522,13803789,16.7),(137029,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137029,35.81,NULL,145,65297,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2025',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000095,NULL,'17.0g',0.12,'Sd',NULL,NULL,NULL,NULL,1,245.0279583,40.95167,0,NULL,59855790496,935246726,14613230,17),(137030,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137030,35.84,NULL,147,65297,NULL,NULL,'Dipole + Quadrupole','FGC 2025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137031,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137031,35.84,NULL,147,65297,NULL,NULL,NULL,'FGC 2025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137032,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137032,35.86,NULL,149,65297,NULL,NULL,'Dipole','FGC 2025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137033,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137033,36.72,0.46,221,65298,70,NULL,NULL,'2MASXi J1620070+302610',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000149,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.029625,30.43606,0.033,NULL,59732365745,933318214,14583097,17),(137034,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137034,38.68,0.46,543,65299,70,NULL,NULL,'2MASX J16200735+1556438',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.030667,15.94553,0.177,NULL,56666692023,885417062,13834641,17.9),(137035,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137035,38,0.23,398,65300,70,NULL,NULL,'2MASX J16200892+1007155',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.6g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,245.037167,10.12086,0.165,NULL,56459492768,882179574,13784055,16.6),(137036,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137036,37.85,0.21,371,65301,70,NULL,NULL,'2MASX J16201020+2446376',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.0425417,24.77728,0.157,NULL,56173933016,877717703,13714339,17.8),(137037,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137037,38.42,0.46,483,65302,70,NULL,NULL,'2MASX J16201049+2302487',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.043833333,23.04678,0.137,NULL,56643114250,885048660,13828885,18),(137038,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137038,38,0.1,398,65303,70,NULL,NULL,'2MASX J16201090+3003020',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.0455417,30.05056,0.009,NULL,59732198621,933315603,14583056,17.4),(137039,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137039,37.85,0.21,371,65304,70,NULL,NULL,'SDSS J162012.06+245022.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.05025,24.83953,0.157,NULL,56174057583,877719649,13714369,18.5),(137040,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137040,38.24,0.46,444,65305,70,NULL,NULL,'SDSS J162012.26+113312.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.6g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.051083,11.55347,0.217,NULL,56572968684,883952635,13811759,18.6),(137041,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137041,38,0.1,398,65306,70,NULL,NULL,'2MASX J16201315+2956230',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.054875,29.93986,0.021,NULL,59732527603,933320743,14583136,18.3),(137042,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137042,38,0.1,398,65307,70,NULL,NULL,'2MASX J16201337+3002070',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.055666667,30.03522,0.009,NULL,59733051586,933328931,14583264,18.1),(137043,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137043,37.32,0.46,291,65308,70,NULL,NULL,'2MASX J16201429+4512573',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.05975,45.21594,0.009,NULL,59851976781,935187137,14612299,18),(137044,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137044,38.45,0.46,491,65309,70,NULL,NULL,'2MASX J16201644+3539490',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.0685,35.66353,0.005,NULL,59780982278,934077848,14594966,18.6),(137045,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137045,36.32,0.46,184,65310,70,NULL,NULL,'2MASX J16201675+1804176',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.1g',0.32,NULL,NULL,NULL,NULL,NULL,1,245.069708333,18.07172,0.141,NULL,56665204422,885393819,13834278,16.1),(137046,'GRB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137046,46.3,0.4,4380,65311,73,NULL,'H const./H=100','GRB 000301C',2.0335,'2006astro.ph..9262M',2006,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'ASM/Ulysses',NULL,NULL,NULL,NULL,1,245.077083,29.44306,0.033,NULL,59740228712,933441073,14585016,NULL),(137047,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137047,35.35,0.46,117,65312,70,NULL,NULL,'CGCG 109-007',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000254,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,245.077625,18.46461,0.141,NULL,56698773516,885918336,13842474,15.5),(137048,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137048,36.96,0.46,247,65313,70,NULL,NULL,'2MASX J16201980+4304377',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.0827083,43.07714,0,NULL,59850021574,935156587,14611821,17.2),(137049,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137049,37.51,0.16,318,65314,70,NULL,NULL,'2MASX J16202001+2406486',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.083417,24.11358,0.125,NULL,56640405671,885006338,13828224,16.7),(137050,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137050,37.77,0.33,359,65315,70,NULL,NULL,'2MASX J16202247+2439366',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.093791667,24.66008,0.125,NULL,56173941917,877717842,13714341,17.8),(137051,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137051,38,0.1,398,65316,70,NULL,NULL,'2MASX J16202284+3000340',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.095375,30.00956,0.021,NULL,59733063008,933329109,14583267,17),(137052,'BCG','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137052,38.44,0.35,444,65317,60,NULL,NULL,'ABELL 2175',0.0978,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,245.095417,29.91503,0.021,NULL,59732538492,933320913,14583139,NULL),(137053,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137053,37.24,0.46,280,65318,70,NULL,NULL,'2MASX J16202335+1936446',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.09',0.24,NULL,NULL,NULL,NULL,NULL,1,245.097417,19.61253,0.165,NULL,56647876799,885123074,13830048,17.09),(137054,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137054,38,0.1,398,65319,70,NULL,NULL,'2MASX J16202480+2954077',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000123,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.103291667,29.90206,0.021,NULL,59732539340,933320927,14583139,17.2),(137055,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137055,37.77,0.33,359,65320,70,NULL,NULL,'2MASX J16202504+2434097',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.10425,24.56931,0.125,NULL,56174015546,877718992,13714359,17.8),(137056,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137056,37.96,0.46,391,65321,70,NULL,NULL,'2MASX J16202511+2945117',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000137,NULL,'17.1g',0.22,'E',NULL,NULL,NULL,NULL,1,245.1047083,29.75314,0.025,NULL,59732583139,933321611,14583150,17.1),(137057,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137057,38.52,0.46,505,65322,70,NULL,NULL,'SDSS J162025.21+094246.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.5g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.105083333,9.71283,0.145,NULL,56458557163,882164955,13783827,18.5),(137058,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137058,36.6,0.46,209,65323,70,NULL,NULL,'2MASX J16202738+2529497',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.11425,25.49717,0.121,NULL,56173562358,877711911,13714248,17.1),(137059,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137059,37.94,0.46,388,65324,70,NULL,NULL,'2MASX J16202824+1753404',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.11775,17.89447,0.137,NULL,56665216518,885394008,13834281,17.1),(137060,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137060,37.1,0.33,263,65325,70,NULL,NULL,'2MASX J16202839+1422194',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.78',0.37,NULL,NULL,NULL,NULL,NULL,1,245.11825,14.37211,0.117,NULL,56540413173,883443955,13803811,16.78),(137061,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137061,38.03,0.46,404,65326,70,NULL,NULL,'2MASX J16202934+2049166',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.122,20.82136,0.173,NULL,56646952204,885108628,13829822,17.8),(137062,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137062,38.78,0.27,570,65327,70,NULL,NULL,'SDSS J162029.81+210711.2',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000158,NULL,'18.9g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.12425,21.11981,0.145,NULL,56654984407,885234131,13831783,18.9),(137063,'BCG','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137063,38.44,0.35,444,65328,60,NULL,'ABELL 2175, BCG','2MASX J16203111+2953276',0.0978,'1980ApJ...241..486H',1980,1,0.61,NULL,'G',0.000117,NULL,'16.2g',0.37,'cD;BrClG','Brightest group member',NULL,NULL,NULL,1,245.129667,29.89103,0.021,NULL,59732534678,933320854,14583138,16.2),(137064,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137064,38,0.1,398,65328,70,NULL,NULL,'2MASX J16203111+2953276',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137065,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137065,38,0.1,398,65329,70,NULL,NULL,'2MASX J16203126+2951277',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.130125,29.85764,0.021,NULL,59732537840,933320903,14583139,17.9),(137066,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137066,37.1,0.33,263,65330,70,NULL,NULL,'2MASX J16203197+1410594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.133333,14.18314,0.137,NULL,56540872031,883451125,13803923,17.3),(137067,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137067,38,0.23,398,65331,70,NULL,NULL,'2MASX J16203374+1009586',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.140708333,10.16633,0.193,NULL,56459477200,882179331,13784052,17.7),(137068,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137068,38.29,0.46,455,65332,70,NULL,NULL,'2MASX J16203381+2519174',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000186,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.140833333,25.32144,0.149,NULL,56173783734,877715370,13714302,17.4),(137069,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137069,37.96,0.46,391,65333,70,NULL,NULL,'2MASX J16203480+2126557',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000158,NULL,'17.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,245.1449583,21.44883,0.137,NULL,56654988080,885234188,13831784,17.8),(137070,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137070,37.67,0.46,342,65334,70,NULL,NULL,'2MASX J16203641-0030201',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000089,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,245.151625,-0.50547,0.365,NULL,45500980203,710952815,11108637,18.1),(137071,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137071,36.18,0.46,172,65335,70,NULL,NULL,'2MASX J16203815+2740474',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.158917,27.67997,0.101,NULL,59742560649,933477510,14585586,16.5),(137072,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137072,37.11,0.46,264,65336,70,NULL,NULL,'2MASX J16204133+1833367',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,245.172083,18.56036,0.141,NULL,56698770530,885918289,13842473,16.2),(137073,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137073,38,0.1,398,65337,70,NULL,NULL,'2MASX J16204138+2947284',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.172333,29.79122,0.025,NULL,59732586580,933321665,14583151,17.2),(137074,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137074,38.14,0.27,424,65338,70,NULL,NULL,'2MASX J16204153+3417064',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.1730417,34.28511,0,NULL,59792963897,934265060,14597891,17.9),(137075,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137075,38.23,0.46,443,65339,70,NULL,NULL,'2MASX J16204162+2521424',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.1735,25.36172,0.149,NULL,56173781495,877715335,13714302,18.3),(137076,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137076,37.56,0.46,325,65340,70,NULL,NULL,'2MASX J16204361+1107196',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.1817083,11.12211,0.229,NULL,56456319039,882129984,13783281,17.5),(137077,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137077,33.1,0.8,41.7,65341,75,NULL,'MAT, I','IC 4595',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000025,NULL,'11.51',0.5,'Sc: sp',NULL,NULL,NULL,NULL,1,245.185166667,-70.14261,0.189,NULL,45019700696,703432823,10991137,11.51),(137078,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137078,32.73,0.43,35.1,65341,75,NULL,'3.6 micron, color + selection bias corrected','IC 4595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137079,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137079,32.76,0.47,35.7,65341,NULL,NULL,'H','IC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137080,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137080,32.8,0.46,36.4,65341,NULL,NULL,'J','IC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137081,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137081,32.82,0.45,36.6,65341,NULL,NULL,'K','IC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137082,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137082,32.97,0.43,39.3,65341,75,NULL,'3.6 micron, color corrected','IC 4595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137083,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137083,33.05,0.49,40.7,65341,75,NULL,'IR','IC 4595',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137084,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137084,33.09,0.4,41.6,65341,NULL,NULL,'mean','IC 4595',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137085,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137085,33.21,0.2,43.9,65341,74.4,NULL,NULL,'IC 4595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137086,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137086,33.22,0.43,44,65341,75,NULL,'MAT, I, raw','IC 4595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137087,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137087,33.23,0.32,44.3,65341,85,NULL,'I, raw','IC 4595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137088,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137088,33.3,0.32,45.7,65341,85,NULL,'I, inv','IC 4595',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137089,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137089,33.45,0.43,49,65341,75,NULL,'MAT, I, cor','IC 4595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137090,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137090,33.5,0.43,50,65341,75,NULL,'MAT, I, inv','IC 4595',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137091,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137091,38,0.1,398,65342,70,NULL,NULL,'2MASX J16204545+2949474',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.2g',0.25,'E',NULL,NULL,NULL,NULL,1,245.18925,29.82997,0.021,NULL,59732579929,933321561,14583149,17.2),(137092,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137092,38.05,0.46,407,65343,70,NULL,NULL,'2MASX J16204636+2954285',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.193083,29.90783,0.021,NULL,59732533727,933320839,14583138,17.9),(137093,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137093,36.83,0.33,232,65344,70,NULL,NULL,'2MASX J16204638+2401425',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000171,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,245.193167,24.02856,0.125,NULL,56642246054,885035094,13828673,17.5),(137094,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137094,37.43,0.46,306,65345,70,NULL,NULL,'2MASX J16204677+0013459',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000099,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.19475,0.22942,0.341,NULL,56440857368,881888396,13779506,16.8),(137095,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137095,35.21,0.46,110,65346,70,NULL,NULL,'2MASX J16204693+3418454',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000087,NULL,'15.8g',0.39,'S0',NULL,NULL,NULL,NULL,1,245.1957083,34.31272,0,NULL,59792964312,934265067,14597891,15.8),(137096,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137096,36.83,0.33,232,65347,70,NULL,NULL,'2MASX J16204703+2400505',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,245.1960417,24.01419,0.125,NULL,56642246510,885035101,13828673,16.5),(137097,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137097,37.75,0.46,355,65348,70,NULL,NULL,'2MASX J16204861+3816266',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000123,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.202625,38.27406,0.005,NULL,59798373165,934349580,14599212,17.1),(137098,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137098,38.55,0.27,512,65349,70,NULL,NULL,'SDSS J162049.45+155117.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.4g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.206083,15.85475,0.177,NULL,56666973538,885421461,13834710,18.4),(137099,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137099,36.88,0.46,238,65350,70,NULL,NULL,'2MASX J16204947+3848026',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.206333333,38.80083,0,NULL,59799174106,934362095,14599407,17.1),(137100,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137100,36.85,0.46,235,65351,70,NULL,NULL,'SDSS J162050.21+143924.5',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.9g',0.4,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.2092083,14.65683,0.125,NULL,56658868194,885294815,13832731,15.9),(137101,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137101,38.78,0.27,570,65352,70,NULL,NULL,'SDSS J162050.24+210654.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000187,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.209375,21.11514,0.145,NULL,56654971048,885233922,13831780,18.4),(137102,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137102,34.19,NULL,68.9,65353,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2028',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.00011,'?','16.9',0.08,'Sd',NULL,NULL,NULL,NULL,1,245.21,63.12111,0,NULL,57529882683,898904416,14045381,16.9),(137103,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137103,34.2,NULL,69.2,65353,NULL,NULL,'Dipole + Quadrupole','FGC 2028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137104,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137104,34.21,NULL,69.4,65353,NULL,NULL,NULL,'FGC 2028',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137105,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137105,34.21,NULL,69.4,65353,NULL,NULL,'Dipole','FGC 2028',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137106,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137106,38.61,0.46,528,65354,70,NULL,NULL,'SDSS J162052.28+201416.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.6g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.217833,20.23803,0.169,NULL,56648182965,885127858,13830122,18.6),(137107,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137107,38,0.1,398,65355,70,NULL,NULL,'2MASX J16205244+2950445',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000137,NULL,'17.2g',0.25,'E',NULL,NULL,NULL,NULL,1,245.218625,29.84569,0.021,NULL,59732582105,933321595,14583149,17.2),(137108,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137108,38,0.1,398,65356,70,NULL,NULL,'2MASX J16205397+2956495',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.2249583,29.94711,0.021,NULL,59733053728,933328964,14583265,17.6),(137109,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137109,38.8,0.46,575,65357,70,NULL,NULL,'SDSS J162054.54+250631.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00018,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,245.2272917,25.10875,0.089,NULL,56174085388,877720084,13714376,18.6),(137110,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137110,38.55,0.27,512,65358,70,NULL,NULL,'2MASX J16205520+1551277',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.229875,15.85778,0.177,NULL,56666977987,885421531,13834711,16.9),(137111,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137111,37.74,0.46,353,65359,70,NULL,NULL,'2MASX J16205516+2605254',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.2g',0.22,'AGN',NULL,NULL,NULL,NULL,1,245.229958333,26.0905,0.093,NULL,59728580757,933259074,14582173,17.2),(137112,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137112,37.44,0.46,307,65360,70,NULL,NULL,'SDSS J162055.72+113930.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.232167,11.65844,0.217,NULL,56572920675,883951885,13811748,18.5),(137113,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137113,38,0.1,398,65361,70,NULL,NULL,'2MASX J16205574+2949034',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000107,NULL,'16.9g',0.27,'E',NULL,NULL,NULL,NULL,1,245.23225,29.8175,0.021,NULL,59732581469,933321585,14583149,16.9),(137114,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137114,35.7,0.33,138,65362,70,NULL,NULL,'2MASX J16205672+2119563',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.2364583,21.33231,0.137,NULL,56655080800,885235637,13831806,16.7),(137115,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137115,31.34,0.4,18.6,65363,75,NULL,'B','NGC 6140',NULL,'1988NBGC.C....0000T',1988,1,6.3,NULL,'G',0.000013,NULL,'11.81',4.6,'SB(s)cd pec','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,245.242333,65.39056,0.045,NULL,57829639663,903588119,14118564,11.81),(137116,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137116,28.04,0.05,4.06,65364,NULL,NULL,'I','ESO 137- G 018',NULL,'2009AJ....138..332J',2009,1,3.2,'abs(b) < 10 degrees.','G',0.00001,NULL,'12.24',1.1,'SA(s)c:',NULL,NULL,NULL,NULL,1,245.2432917,-60.49103,NULL,NULL,44495318562,695239352,10863114,12.24),(137117,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137117,28.84,0.1,5.86,65364,74.4,NULL,NULL,'ESO 137- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137118,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137118,28.95,0.1,6.17,65364,NULL,NULL,NULL,'ESO 137- G 018',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137119,'TRGB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137119,29.01,NULL,6.34,65364,NULL,NULL,NULL,'ESO 137- G 018',NULL,'2007AJ....133..504K',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137120,'Tully est','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137120,29.29,0.8,7.2,65364,75,NULL,NULL,'ESO 137- G 018',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137121,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137121,35.61,0.33,132,65365,70,NULL,NULL,'I Zw 143',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,245.250875,34.76411,0.013,NULL,59780429981,934069218,14594831,15.6),(137122,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137122,38.1,0.46,417,65366,70,NULL,NULL,'SDSS J162100.44+512309.7',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.251875,51.38603,0.017,NULL,59694669935,932729217,14573894,17.8),(137123,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137123,38.55,0.27,512,65367,70,NULL,NULL,'2MASX J16210047+1550077',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.252083,15.83561,0.177,NULL,56666966991,885421359,13834708,17.8),(137124,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137124,37.96,0.33,390,65368,70,NULL,NULL,'2MASX J16210104+2440294',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.3g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,245.254333333,24.67483,0.125,NULL,56173991622,877718619,13714353,17.3),(137125,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137125,38,0.1,398,65369,70,NULL,NULL,'2MASX J16210128+2954105',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.255333,29.90286,0.021,NULL,59733073971,933329280,14583270,17.8),(137126,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137126,38,0.1,398,65370,70,NULL,NULL,'2MASX J16210272+2944214',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.261333333,29.73944,0.025,NULL,59732575699,933321495,14583148,17.5),(137127,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137127,35.92,0.49,152,65371,70,NULL,NULL,'2MASX J16210398-1650212',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,245.266667,-16.83917,0.929,NULL,45943880687,717873135,11216767,14.1),(137128,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137128,38.05,0.46,408,65372,70,NULL,NULL,'2MASXi J1621041+301623',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000162,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.26725,30.27328,0.029,NULL,59732216272,933315879,14583060,17.9),(137129,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137129,35.7,0.33,138,65373,70,NULL,NULL,'CGCG 137-081',NULL,'2015arXiv151105856S',2015,1,0.7,'GSC 1517-0497 (mag. 15) superposed 10 arcsec southeast of nucleus.','G',0.00017,NULL,'15.2g',0.59,'AGN',NULL,NULL,NULL,NULL,1,245.267583,21.34053,0.137,NULL,56655080552,885235633,13831806,15.2),(137130,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137130,38.29,0.46,455,65374,70,NULL,NULL,'SDSS J162104.38+250109.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,245.2682917,25.01942,0.089,NULL,56174092897,877720201,13714378,18.9),(137131,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137131,38,0.1,398,65375,70,NULL,NULL,'2MASX J16210592+2954263',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.2745417,29.90736,0.021,NULL,59733074881,933329295,14583270,17.9),(137132,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137132,37.62,0.46,334,65376,70,NULL,NULL,'SDSS J162107.32+172844.0',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,245.2805,17.47892,0.189,NULL,56665885867,885404466,13834444,NULL),(137133,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137133,37.43,0.46,306,65377,70,NULL,NULL,'2MASX J16210845+2913333',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000131,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.285208333,29.22594,0.029,NULL,59732447437,933319491,14583117,18.1),(137134,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137134,35.54,0.21,128,65378,70,NULL,NULL,'2MASX J16210880+3802006',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000127,NULL,'15.7g',0.43,'S0/a',NULL,NULL,NULL,NULL,1,245.2865,38.03336,0,NULL,59768930617,933889540,14592024,15.7),(137135,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137135,35.61,0.33,132,65379,70,NULL,NULL,'KUGX 1619+348B',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.000087,NULL,'14.9g',0.62,'Compact',NULL,NULL,NULL,NULL,1,245.29,34.75911,0.013,NULL,59780416822,934069012,14594828,14.9),(137136,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137136,37.64,0.46,337,65380,70,NULL,NULL,'2MASX J16211057+0018470',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.294083,0.31317,0.325,NULL,56440735388,881886490,13779476,17.3),(137137,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137137,38.78,0.27,570,65381,70,NULL,NULL,'2MASX J16211253+2113293',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.30225,21.22481,0.137,NULL,56655051657,885235182,13831799,17.8),(137138,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137138,37.96,0.33,390,65382,70,NULL,NULL,'2MASX J16211406+2437283',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.308583,24.62444,0.125,NULL,56174042163,877719408,13714365,18.2),(137139,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137139,36.88,0.33,238,65383,70,NULL,NULL,'2MASX J16211480+1203526',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.3117917,12.06458,0.213,NULL,56539257221,883425894,13803529,17.4),(137140,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137140,38.3,0.46,458,65384,70,NULL,NULL,'2MASX J16211627+0849426',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.3177083,8.82842,0.177,NULL,56469938134,882342783,13786605,17.4),(137141,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137141,37.34,0.46,294,65385,70,NULL,NULL,'2MASX J16211684+4906573',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000196,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.320416667,49.116,0.005,NULL,59702795331,932856177,14575877,17),(137142,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137142,36.6,0.46,209,65386,70,NULL,NULL,'2MASX J16211739+0627246',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.3225417,6.45692,0.201,NULL,56467371569,882302680,13785979,17),(137143,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137143,35.45,0.33,123,65387,70,NULL,NULL,'2MASX J16211956+2440003',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000156,NULL,'15.9g',0.35,NULL,NULL,NULL,NULL,NULL,1,245.331416667,24.66664,0.109,NULL,56173996335,877718692,13714354,15.9),(137144,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137144,38.14,0.27,424,65388,70,NULL,NULL,'2MASX J16211959+3412001',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.33175,34.20017,0,NULL,59791118485,934236226,14597441,18.2),(137145,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137145,36.76,0.46,224,65389,70,NULL,NULL,'2MASX J16212011+1345277',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.33375,13.75778,0.149,NULL,56659074585,885298040,13832781,17.1),(137146,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137146,38,0.1,398,65390,70,NULL,NULL,'2MASX J16212183+2937573',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000143,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.341167,29.63256,0.025,NULL,59732615385,933322115,14583158,17.5),(137147,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137147,38.62,0.46,530,65391,70,NULL,NULL,'2MASX J16212188+1047516',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.3412917,10.79778,0.209,NULL,56456036129,882125564,13783211,17.7),(137148,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137148,37.94,0.46,387,65392,70,NULL,NULL,'2MASX J16212215+3856033',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.342375,38.93428,0,NULL,59799116562,934361196,14599393,17.2),(137149,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137149,38.14,0.27,424,65393,70,NULL,NULL,'2MASX J16212314+3410241',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.346375,34.17353,0,NULL,59791138853,934236544,14597446,17.4),(137150,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137150,37.86,0.46,374,65394,70,NULL,NULL,'2MASX J16212430+0609056',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00019,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.351375,6.15167,0.229,NULL,56464308010,882254812,13785231,17.7),(137151,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137151,36.88,0.33,238,65395,70,NULL,NULL,'2MASX J16212539+1204277',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'17.00',0.38,NULL,NULL,NULL,NULL,NULL,1,245.355667,12.07431,0.213,NULL,56539255783,883425871,13803529,17),(137152,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137152,35.43,0.46,122,65396,70,NULL,NULL,'CGCG 080-009',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00016,NULL,'14.8g',0.55,NULL,NULL,NULL,NULL,NULL,1,245.3572083,14.53153,0.125,NULL,56658846667,885294479,13832726,14.8),(137153,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137153,37.99,0.46,396,65397,70,NULL,NULL,'2MASX J16212618-0023193',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000102,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.3590417,-0.38869,0.349,NULL,45501842401,710966287,11108848,17.1),(137154,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137154,35.88,0.59,150,65398,70,NULL,NULL,'2MASX J16212722-6531465',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.5R',0.28,NULL,NULL,NULL,NULL,NULL,1,245.363375,-65.52967,0.669,NULL,44995633905,703056779,10985262,15.5),(137155,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137155,37.65,0.46,339,65399,70,NULL,NULL,'2MASX J16212815+0938036',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.43',0.34,NULL,NULL,NULL,NULL,NULL,1,245.3672083,9.63447,0.145,NULL,56458267417,882160428,13783756,17.43),(137156,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137156,37.79,0.33,361,65400,70,NULL,NULL,'2MASX J16212822+0036111',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000077,NULL,'16.8g',0.36,NULL,NULL,NULL,NULL,NULL,1,245.3675,0.60325,0.289,NULL,56441564409,881899443,13779678,16.8),(137157,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137157,29.5,0.49,7.95,65401,75,NULL,'IR','UGC 10351',NULL,'2011yCatp016004901K',2011,1,1.07,'The 2MASX position refers to a knot in the southwestern end.','G',0.000003,NULL,'14.8g',0.57,'Sdm:',NULL,NULL,NULL,NULL,1,245.36775,28.64019,0.065,NULL,59741886520,933466976,14585421,14.8),(137158,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137158,38,0.1,398,65402,70,NULL,NULL,'2MASX J16212935+2941593',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.372333,29.69986,0.025,NULL,59732569639,933321400,14583146,18.4),(137159,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137159,35.45,0.33,123,65403,70,NULL,NULL,'2MASX J16213162+2459523',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.381833,24.99789,0.089,NULL,56174291812,877723309,13714426,16.5),(137160,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137160,37.26,0.46,283,65404,70,NULL,NULL,'2MASX J16213251+0000376',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0001,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,245.385541667,0.01033,0.341,NULL,56440717550,881886211,13779472,16.5),(137161,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137161,36.53,0.65,202,65405,70,NULL,NULL,'2MFGC 13131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,245.3865,-16.75447,0.929,NULL,45943800724,717871886,11216748,15.7),(137162,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137162,37.79,0.33,361,65406,70,NULL,NULL,'2MASX J16213295+0036281',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.387333333,0.60789,0.289,NULL,56441566760,881899480,13779679,17),(137163,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137163,38.33,0.46,464,65407,70,NULL,NULL,'2MASX J16213351+4541268',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.38975,45.69064,0.005,NULL,59833384445,934896631,14607759,17.4),(137164,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137164,38.43,0.27,485,65408,70,NULL,NULL,'SDSS J162135.03+253703.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.3959583,25.61758,0.085,NULL,56172601218,877696894,13714013,18.2),(137165,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137165,37.64,0.46,337,65409,70,NULL,NULL,'2MASX J16213729+2117429',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.405541667,21.29536,0.157,NULL,56654872791,885232387,13831756,17.8),(137166,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137166,36.74,0.46,223,65410,70,NULL,NULL,'2MASX J16213788+4355008',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.4077917,43.91694,0,NULL,59851918461,935186225,14612284,17.2),(137167,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137167,37.16,0.46,270,65411,70,NULL,NULL,'2MASX J16214097+2151399',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,245.420833,21.86128,0.113,NULL,56655349624,885239837,13831872,16.7),(137168,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137168,36.69,0.46,217,65412,70,NULL,NULL,'2MASX J16214104+1325457',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,245.4209583,13.42922,0.153,NULL,56657242869,885269419,13832334,17),(137169,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137169,35.54,0.21,128,65413,70,NULL,NULL,'NGC 6129',NULL,'2015arXiv151105856S',2015,1,0.98,'HOLM 741C is a star.','G',0.000083,NULL,'14.2g',0.89,'E0',NULL,NULL,NULL,NULL,1,245.430291667,37.99603,0.005,NULL,59768851750,933888308,14592004,14.2),(137170,'SGRB','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'N',137170,29.52,2.72,8,65414,NULL,NULL,NULL,'GRB 031214',NULL,'2006ApJ...640..849N',2006,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137171,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137171,38.43,0.27,485,65415,70,NULL,NULL,'2MASX J16214520+2535488',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.438458333,25.597,0.085,NULL,56172554720,877696167,13714002,18),(137172,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137172,37.78,0.46,360,65416,70,NULL,NULL,'SDSS J162145.61+112537.5',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,245.440083,11.42708,0.237,NULL,56455507530,882117305,13783082,NULL),(137173,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137173,36.69,0.21,217,65417,70,NULL,NULL,'CGCG 138-001',NULL,'2015arXiv151105856S',2015,1,1.08,NULL,'G',0.000189,NULL,'15.2g',0.5,NULL,NULL,NULL,NULL,NULL,1,245.4419583,25.82069,0.081,NULL,56172561516,877696273,13714004,15.2),(137174,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137174,37.41,0.27,303,65418,70,NULL,NULL,'2MASX J16214814+3930576',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.0001,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,245.4505,39.51594,0,NULL,59853485305,935210707,14612667,16),(137175,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137175,31.93,0.8,24.4,65419,75,NULL,'MAT, I','NGC 6118',NULL,'1997ApJS..109..333W',1997,1,4.7,NULL,'G',0.000005,NULL,'11.0B',2,'SA(s)cd        HII','Isolated galaxy',NULL,NULL,NULL,1,245.452583,-2.28344,0.453,NULL,45516147682,711189807,11112340,11),(137176,'IRAS','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137176,31.94,0.8,24.4,65419,75,NULL,'A82, H','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137177,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137177,31.08,0.69,16.4,65419,100,NULL,'mid-IR','NGC 6118',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137178,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137178,31.38,0.4,18.9,65419,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6118',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137179,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137179,31.42,0.32,19.2,65419,85,NULL,'I, raw','NGC 6118',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137180,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137180,31.46,0.32,19.6,65419,85,NULL,'I, inv','NGC 6118',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137181,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137181,31.5,0.43,19.9,65419,75,NULL,'MAT, I, raw','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137182,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137182,31.58,0.43,20.7,65419,75,NULL,'3.6 micron, color corrected','NGC 6118',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137183,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137183,31.59,0.43,20.8,65419,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6118',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137184,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137184,31.59,0.2,20.8,65419,74.4,NULL,NULL,'NGC 6118',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137185,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137185,31.61,0.36,21,65419,NULL,NULL,NULL,'NGC 6118',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137186,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137186,31.7,0.43,21.9,65419,75,NULL,'MAT, I, inv','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137187,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137187,31.75,NULL,22.4,65419,NULL,NULL,'B','NGC 6118',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137188,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137188,31.76,0.47,22.5,65419,75,NULL,'A82, H, raw','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137189,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137189,31.8,0.43,22.9,65419,75,NULL,'MAT, I, cor','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137190,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137190,31.82,0.29,23.1,65419,NULL,NULL,NULL,'NGC 6118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137191,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137191,31.85,NULL,23.4,65419,72,NULL,NULL,'NGC 6118',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137192,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137192,31.87,0.47,23.6,65419,75,NULL,'A82, H, inv','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137193,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137193,31.88,0.28,23.8,65419,NULL,NULL,'Malmquist cor.','NGC 6118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137194,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137194,31.97,0.4,24.8,65419,NULL,NULL,'mean','NGC 6118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137195,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137195,31.98,0.46,24.9,65419,NULL,NULL,'J','NGC 6118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137196,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137196,32.02,0.47,25.3,65419,75,NULL,'A82, H, cor','NGC 6118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137197,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137197,32.02,0.4,25.4,65419,75,NULL,'B','NGC 6118',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137198,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137198,32.04,0.47,25.6,65419,NULL,NULL,'H','NGC 6118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137199,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137199,32.07,0.45,25.9,65419,NULL,NULL,'K','NGC 6118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137200,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137200,37.51,0.46,317,65420,70,NULL,NULL,'2MASX J16214897+0709147',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.4540417,7.15403,0.221,NULL,56467857624,882310275,13786098,16.9),(137201,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137201,38.05,0.46,408,65421,70,NULL,NULL,'2MASX J16214937+1857407',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.45575,18.96128,0.157,NULL,56699256414,885925881,13842591,17.7),(137202,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137202,33.07,NULL,41.2,65422,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10369',NULL,'2010Ap&SS.325..163P',2010,1,1.24,'Matthews (2000A&AS..143..421M) detects another feature at v=8433 km/sec.','G',0.000023,NULL,'16.5',0.17,'Sdm',NULL,NULL,NULL,NULL,1,245.462667,67.29308,0.117,NULL,57826887825,903545122,14117892,16.5),(137203,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137203,33.09,NULL,41.5,65422,NULL,NULL,'Dipole + Quadrupole','UGC 10369',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137204,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137204,33.11,NULL,41.8,65422,NULL,NULL,'Dipole','UGC 10369',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137205,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137205,33.18,NULL,43.2,65422,NULL,NULL,NULL,'UGC 10369',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137206,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137206,38.33,0.27,463,65423,70,NULL,NULL,'SDSS J162151.86+212023.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.466125,21.33981,0.157,NULL,56654847065,885231985,13831749,18.6),(137207,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137207,37.5,0.59,317,65424,70,NULL,NULL,'2MASX J16215327-0050233',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.54',0.4,NULL,NULL,NULL,NULL,NULL,1,245.472125,-0.84003,0.397,NULL,45501307966,710957936,11108717,16.54),(137208,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137208,36.23,0.2,176,65425,74.4,NULL,NULL,'CGCG 138-002',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000073,NULL,'15.4g',0.55,'E',NULL,NULL,NULL,NULL,1,245.477667,25.62553,0.085,NULL,56172556408,877696193,13714003,15.4),(137209,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137209,37.9,0.46,380,65426,70,NULL,NULL,'2MASX J16215575+1313449',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000188,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.482333,13.22914,0.181,NULL,56657427084,885272298,13832379,17.8),(137210,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137210,37.55,0.46,324,65427,70,NULL,NULL,'2MASX J16215590+2418398',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.4829583,24.31097,0.141,NULL,56171929615,877686400,13713850,17.6),(137211,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137211,37.78,0.46,360,65428,70,NULL,NULL,'2MASX J16215661+5022448',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.48575,50.37914,0.013,NULL,59696031950,932750499,14574226,18),(137212,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137212,38,0.1,398,65429,70,NULL,NULL,'SDSS J162157.37+294725.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.4890417,29.79044,0.021,NULL,59732591100,933321735,14583152,18.3),(137213,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137213,37.25,0.46,281,65430,70,NULL,NULL,'2MASX J16215826+2330547',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.4927083,23.51525,0.149,NULL,56642829733,885044214,13828815,17.3),(137214,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137214,37.87,0.46,375,65431,70,NULL,NULL,'2MASX J16215836+1419409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.493125,14.32792,0.137,NULL,56659691678,885307682,13832932,17.6),(137215,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137215,37.46,0.46,311,65432,70,NULL,NULL,'2MASX J16215984+0014375',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000101,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.499375,0.24389,0.325,NULL,56441628156,881900439,13779694,17.5),(137216,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137216,36.91,0.46,241,65433,70,NULL,NULL,'2MASX J16220027+3859417',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000117,NULL,'16.2g',0.33,NULL,NULL,NULL,NULL,NULL,1,245.501125,38.995,0,NULL,59798587113,934352923,14599264,16.2),(137217,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137217,37.72,0.46,349,65434,70,NULL,NULL,'2MASX J16220260+0900587',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.510916667,9.01628,0.169,NULL,56469082984,882329421,13786397,17),(137218,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137218,37.58,0.46,328,65435,70,NULL,NULL,'SDSS J162206.75+003259.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000073,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,245.528125,0.54978,0.325,NULL,56441690489,881901413,13779709,18.6),(137219,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137219,37.68,0.46,344,65436,70,NULL,NULL,'2MASX J16220790+3139037',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.532833,31.65106,0.029,NULL,59788301291,934192207,14596753,17.8),(137220,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137220,37.98,0.27,394,65437,70,NULL,NULL,'2MASX J16220870+2720544',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'16.4g',0.36,'E0',NULL,NULL,NULL,NULL,1,245.5362917,27.34844,0.081,NULL,59741790779,933465480,14585398,16.4),(137221,'SNIa','2016-12-15 15:15:41','2016-12-16 11:20:56','1','SN 2007bj',NULL,137221,34.46,0.19,76.7,65438,70,NULL,'SALT 2','NGC 6172',0.016708,'2013MNRAS.433.2240G',2013,1,1,NULL,'G',0.000027,NULL,'13.83',1,'E+:',NULL,NULL,NULL,NULL,1,245.542917,-1.51486,0.457,NULL,45515555365,711180552,11112196,13.83),(137222,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137222,38.26,0.46,448,65439,70,NULL,NULL,'2MASX J16221154+2359084',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.547917,23.98581,0.125,NULL,56642461989,885038468,13828726,17.9),(137223,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137223,37.57,0.46,327,65440,70,NULL,NULL,'2MASX J16221173+3216097',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.5487917,32.26947,0.005,NULL,59790283763,934223183,14597237,17.3),(137224,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137224,37.15,0.46,269,65441,70,NULL,NULL,'2MASX J16221302+2419154',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.554375,24.32097,0.141,NULL,56171939422,877686553,13713852,17.3),(137225,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137225,38.15,0.46,426,65442,70,NULL,NULL,'2MASX J16221323+3611588',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.555291667,36.19975,0,NULL,59777548760,934024199,14594128,17.8),(137226,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137226,37.34,0.46,293,65443,70,NULL,NULL,'2MASX J16221503+2115528',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.562625,21.26489,0.157,NULL,56654881301,885232520,13831758,17.6),(137227,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137227,37.32,0.46,291,65444,70,NULL,NULL,'2MASX J16221601+2700594',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.566708333,27.01667,0.085,NULL,59728169692,933252651,14582072,17.2),(137228,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137228,36.5,0.46,200,65445,70,NULL,NULL,'2MASX J16221650+4017128',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.568583,40.28694,0,NULL,59856339323,935255301,14613364,17.3),(137229,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137229,38.71,0.46,552,65446,70,NULL,NULL,'2MASX J16221745+2526154',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000171,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.572875,25.43775,0.089,NULL,56174196409,877721818,13714403,17.7),(137230,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137230,37.14,0.67,268,65447,70,NULL,NULL,'2MASX J16221766-0121551',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,245.573625,-1.36536,0.417,NULL,45515066936,711172920,11112076,15.6),(137231,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137231,37.98,0.27,394,65448,70,NULL,NULL,'2MASX J16221801+2720214',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.575041667,27.33933,0.081,NULL,59741792643,933465510,14585398,17.5),(137232,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137232,37.98,0.27,394,65449,70,NULL,NULL,'2MASX J16221973+2722194',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,245.58225,27.37211,0.081,NULL,59741824461,933466007,14585406,17),(137233,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137233,36.69,0.46,218,65450,70,NULL,NULL,'2MASX J16222006+4658233',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',NULL,NULL,'16.02',0.42,NULL,NULL,NULL,NULL,NULL,1,245.583417,46.97325,0,NULL,59835857902,934935279,14608363,16.02),(137234,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137234,35.85,NULL,148,65451,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10355',NULL,'2010Ap&SS.325..163P',2010,1,0.52,NULL,'G',0.000033,NULL,'16.3g',0.17,'Sc',NULL,NULL,NULL,NULL,1,245.5895,13.85383,0.145,NULL,56660101021,885314078,13833032,16.3),(137235,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137235,35.86,NULL,148,65451,NULL,NULL,'Dipole + Quadrupole','UGC 10355',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137236,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137236,35.86,0.49,149,65451,75,NULL,'IR','UGC 10355',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137237,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137237,35.86,NULL,149,65451,NULL,NULL,'Dipole','UGC 10355',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137238,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137238,35.91,NULL,152,65451,NULL,NULL,NULL,'UGC 10355',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137239,'Tully-Fisher','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,NULL,137239,36.22,0.2,175,65451,74.4,NULL,NULL,'UGC 10355',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137240,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137240,36.81,0.33,230,65452,70,NULL,NULL,'2MASX J16222166+1441037',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.590333,14.68453,0.137,NULL,56659741607,885308462,13832944,17.7),(137241,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137241,38.64,0.46,534,65453,70,NULL,NULL,'2MASX J16222172+3456403',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.5905417,34.9445,0.013,NULL,59780478570,934069977,14594843,18),(137242,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137242,38.43,0.27,485,65454,70,NULL,NULL,'2MASX J16222349+2536554',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.598,25.61539,0.085,NULL,56173005175,877703205,13714112,18),(137243,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137243,37.62,0.27,335,65455,70,NULL,NULL,'2MASX J16222504+1948281',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.604208333,19.80789,0.193,NULL,56647994782,885124918,13830076,18.2),(137244,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137244,37.99,0.46,397,65456,70,NULL,NULL,'2MASX J16222522+4447083',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000123,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.6049583,44.78564,0.037,NULL,59851008455,935172007,14612062,16.8),(137245,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137245,38.23,0.46,444,65457,70,NULL,NULL,'2MASX J16222614+1117427',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.6089583,11.29531,0.237,NULL,56456185004,882127890,13783248,17.3),(137246,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137246,37.82,0.46,367,65458,70,NULL,NULL,'2MASX J16222633+3257303',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.609917,32.95847,0.025,NULL,59793710579,934276727,14598073,17.6),(137247,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137247,37.47,0.46,312,65459,70,NULL,NULL,'2MASX J16222648+3513203',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.610417,35.22244,0.005,NULL,59780460136,934069689,14594838,17.3),(137248,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137248,37.92,0.46,383,65460,70,NULL,NULL,'2MASX J16222695+0002538',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000075,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.612167,0.04833,0.325,NULL,56441071890,881891748,13779558,17.8),(137249,'FP','2016-12-15 15:15:41','2016-12-16 11:20:56','1',NULL,'R',137249,36.27,0.33,179,65461,70,NULL,NULL,'2MASX J16222802+1726177',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000087,NULL,'16.29',0.45,NULL,NULL,NULL,NULL,NULL,1,245.61675,17.43836,0.189,NULL,56668531410,885445803,13835090,16.29),(137250,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137250,36.27,0.33,179,65462,70,NULL,NULL,'SDSS J162228.06+172420.9',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.1g',0.37,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.6169583,17.40581,0.189,NULL,56668533530,885445836,13835091,16.1),(137251,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137251,36.55,0.46,204,65463,70,NULL,NULL,'2MASX J16222834+4010039',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00016,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.618083,40.16783,0,NULL,59856345876,935255404,14613365,16.5),(137252,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137252,35.62,0.46,133,65464,70,NULL,NULL,'CGCG 080-015',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000087,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,245.619625,10.50483,0.185,NULL,56458797755,882168714,13783886,15.7),(137253,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137253,35.09,0.46,104,65465,70,NULL,NULL,'KUGX 1620+357',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000127,NULL,'15.1g',0.51,'Compact',NULL,NULL,NULL,NULL,1,245.622375,35.65583,0,NULL,59781381014,934084078,14595063,15.1),(137254,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137254,38.07,0.46,411,65466,70,NULL,NULL,'SDSS J162229.88+214618.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.6245,21.77183,0.133,NULL,56656064519,885251008,13832047,18.7),(137255,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137255,36.82,0.52,231,65467,70,NULL,NULL,'2MASX J16223020-0039131',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00012,NULL,'16.03',NULL,NULL,NULL,NULL,NULL,NULL,1,245.625833,-0.65364,0.365,NULL,45501872340,710966755,11108855,16.03),(137256,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137256,37.41,0.27,303,65468,70,NULL,NULL,'2MASX J16223109+3937299',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000181,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.629417,39.62506,0,NULL,59853463113,935210361,14612661,17.1),(137257,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137257,37.94,0.46,388,65469,70,NULL,NULL,'2MASX J16223255+4950438',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.635666667,49.84539,0.017,NULL,59695591243,932743613,14574118,17.5),(137258,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137258,37.43,0.46,306,65470,70,NULL,NULL,'2MASX J16223476+1517027',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.644875,15.28417,0.089,NULL,56670376524,885474633,13835541,17.9),(137259,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137259,36.69,0.21,217,65471,70,NULL,NULL,'2MASX J16223511+2549014',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000175,NULL,'16.0g',0.47,NULL,NULL,NULL,NULL,NULL,1,245.646541667,25.81708,0.081,NULL,56173066463,877704163,13714127,16),(137260,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137260,37.56,0.46,325,65472,70,NULL,NULL,'2MASX J16223583+2520314',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.649291667,25.34208,0.089,NULL,56173355311,877708676,13714198,17.2),(137261,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137261,36.52,0.46,201,65473,70,NULL,NULL,'2MASX J16223659+5008379',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.652833,50.14386,0.013,NULL,59696289941,932754530,14574289,16.6),(137262,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137262,37.07,0.33,260,65474,70,NULL,NULL,'2MASX J16223772+2603354',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000184,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,245.657167,26.05986,0.093,NULL,56173224891,877706638,13714166,16.2),(137263,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137263,36.74,0.46,223,65475,70,NULL,NULL,'2MASXi J1622384+443157',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.660166667,44.53253,0.021,NULL,59851421702,935178464,14612163,17.9),(137264,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137264,35.87,0.46,149,65476,70,NULL,NULL,'CGCG 224-007',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.0001,NULL,'14.5g',0.68,'E0',NULL,NULL,NULL,NULL,1,245.661917,43.46467,0,NULL,59849888781,935154512,14611789,14.5),(137265,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137265,37.17,0.46,271,65477,70,NULL,NULL,'2MASX J16223905+4709383',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000179,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,245.662625,47.16078,0.005,NULL,59835017596,934922149,14608158,16.6),(137266,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137266,37.83,0.46,368,65478,70,NULL,NULL,'2MASXi J1622404+461618',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.668333,46.27175,0,NULL,59835492525,934929570,14608274,17.8),(137267,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137267,37.41,0.27,303,65479,70,NULL,NULL,'SDSS J162240.74+393936.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.6697917,39.66014,0,NULL,59853471022,935210484,14612663,18.4),(137268,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137268,38.27,0.46,450,65480,70,NULL,NULL,'2MASX J16224119+3414353',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.671625,34.24311,0,NULL,59791160702,934236885,14597451,17.2),(137269,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137269,36.88,0.17,237,65481,70,NULL,NULL,'2MASX J16224432+2357151',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000201,NULL,'16.2g',0.44,NULL,NULL,NULL,NULL,NULL,1,245.684583,23.95417,0.153,NULL,56642427003,885037921,13828717,16.2),(137270,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137270,37.07,0.33,260,65482,70,NULL,NULL,'2MASX J16224550+2605529',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.689583,26.098,0.093,NULL,56173203606,877706306,13714161,17.8),(137271,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137271,36.79,0.46,228,65483,70,NULL,NULL,'2MASX J16224660+2024581',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.694375,20.41617,0.181,NULL,56647367926,885115123,13829923,17.5),(137272,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137272,36.88,0.17,237,65484,70,NULL,NULL,'2MASX J16224665+2347031',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.694375,23.78436,0.137,NULL,56642927430,885045741,13828839,17.2),(137273,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137273,36.36,0.33,187,65485,70,NULL,NULL,'2MASX J16224707+5126249',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00011,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.6962083,51.44031,0.017,NULL,59696705938,932761030,14574391,16.8),(137274,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137274,37.37,0.46,297,65486,70,NULL,NULL,'2MASX J16224818+2043491',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.700917,20.73025,0.177,NULL,56645484570,885085696,13829464,16.6),(137275,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137275,36.87,0.46,236,65487,70,NULL,NULL,'2MASX J16224830+0016388',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.7012083,0.27753,0.325,NULL,56441116733,881892448,13779569,17.6),(137276,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137276,36.88,0.17,237,65488,70,NULL,NULL,'2MASX J16224869+2352589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.703041667,23.88322,0.153,NULL,56642410887,885037670,13828713,17.8),(137277,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137277,37.09,0.46,262,65489,70,NULL,NULL,'2MASX J16224869+4946049',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000175,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,245.703167,49.76806,0.017,NULL,59695592706,932743636,14574119,16.7),(137278,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137278,36.76,0.23,225,65490,70,NULL,NULL,'2MASX J16225052+5028049',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.710417,50.468,0.013,NULL,59696050476,932750788,14574231,16.5),(137279,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137279,37.97,0.46,392,65491,70,NULL,NULL,'2MASX J16225117+1738167',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'16.5g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,245.713291667,17.63806,0.177,NULL,56665733048,885402078,13834407,16.5),(137280,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137280,36.36,0.33,187,65492,70,NULL,NULL,'2MASX J16225124+5104539',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,245.713667,51.08161,0.013,NULL,59696710487,932761101,14574392,16.9),(137281,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137281,34.56,0.46,81.6,65493,70,NULL,NULL,'CGCG 080-016',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000107,NULL,'15.6',0.8,NULL,NULL,NULL,NULL,NULL,1,245.716875,11.371,0.237,NULL,56740613956,886572093,13852688,15.6),(137282,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137282,35.4,0.46,120,65494,70,NULL,NULL,'2MASX J16225229+2118191',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'16.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.717791667,21.30533,0.157,NULL,56655931491,885248929,13832014,16.1),(137283,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137283,38.68,0.33,544,65495,70,NULL,NULL,'SDSS J162252.99+305722.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.7207917,30.95617,0.041,NULL,59788685965,934198218,14596847,18.5),(137284,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137284,38.68,0.33,544,65496,70,NULL,NULL,'2MASXi J1622530+305308',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.721166667,30.88575,0.041,NULL,59788636306,934197442,14596835,17.8),(137285,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137285,38.13,0.46,422,65497,70,NULL,NULL,'SDSS J162253.53+400727.1',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000188,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.723083,40.12419,0,NULL,59856374771,935255855,14613372,17.3),(137286,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137286,35.7,0.4,138,65498,NULL,NULL,'mean','UGC 10362',NULL,'2007A&A...465...71T',2007,1,1.17,NULL,'G',0.00002,NULL,'14.5g',0.61,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,245.73125,39.79164,0,NULL,59853455609,935210243,14612660,14.5),(137287,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137287,35.76,0.07,142,65498,NULL,NULL,NULL,'UGC 10362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137288,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137288,35.83,0.2,147,65498,74.4,NULL,NULL,'UGC 10362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137289,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137289,35.96,0.47,156,65498,NULL,NULL,'H','UGC 10362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137290,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137290,37.62,0.27,335,65499,70,NULL,NULL,'2MASX J16225582+1951331',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,245.732417,19.85911,0.193,NULL,56647769032,885121391,13830021,16.8),(137291,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137291,35.54,0.21,128,65500,70,NULL,NULL,'2MASX J16225650+3758581',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000067,NULL,'15.9g',0.28,'S0/a',NULL,NULL,NULL,NULL,1,245.735375,37.98286,0.005,NULL,59798203480,934346929,14599170,15.9),(137292,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137292,36.88,0.17,237,65501,70,NULL,NULL,'2MASX J16225730+2353359',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00018,NULL,'15.8g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,245.7387083,23.89333,0.153,NULL,56642924193,885045690,13828838,15.8),(137293,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137293,36.81,0.33,230,65502,70,NULL,NULL,'2MASX J16225767+1440357',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000179,NULL,'15.8g',0.44,NULL,NULL,NULL,NULL,NULL,1,245.740417,14.67667,0.137,NULL,56659776283,885309004,13832953,15.8),(137294,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137294,35.51,0.46,127,65503,70,NULL,NULL,'2MASX J16225835+2007401',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000163,NULL,'16.3g',0.42,NULL,NULL,NULL,NULL,NULL,1,245.743041667,20.12792,0.209,NULL,56647867691,885122932,13830045,16.3),(137295,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137295,37.32,0.46,291,65504,70,NULL,NULL,'2MASX J16225885+4015074',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.745333,40.25219,0,NULL,59856350805,935255481,14613366,17.1),(137296,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137296,19.06,0.34,0.065,65505,NULL,NULL,'1,K, Cepheid 1','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137297,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137297,19.13,0.19,0.067,65505,NULL,NULL,'1, I, Cepheid 1','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137298,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137298,19.32,0.53,0.073,65505,NULL,NULL,'1, I, Cepheid 2','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137299,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137299,19.46,0.19,0.078,65505,NULL,NULL,'1,K, Cepheid 3','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137300,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137300,19.46,0.16,0.078,65505,NULL,NULL,'1, I, Cepheid 3','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137301,'Type II Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'RN',137301,17.39,NULL,0.03,65505,NULL,NULL,'3, I','NORMA DWARF B',NULL,'2016arXiv160103381C',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137302,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137302,38.33,0.27,463,65506,70,NULL,NULL,'2MASX J16225965+2133202',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000172,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.748583,21.55558,0.133,NULL,56656091109,885251423,13832053,17.4),(137303,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137303,37.97,0.46,393,65507,70,NULL,NULL,'2MASX J16225983+2246192',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000148,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.7494583,22.77186,0.161,NULL,56653796049,885215563,13831493,18.4),(137304,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137304,36.54,0.46,203,65508,70,NULL,NULL,'2MASX J16230000+2156122',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.0002,NULL,'16.1g',0.35,NULL,NULL,NULL,NULL,NULL,1,245.75,21.93667,0.133,NULL,56656586424,885259162,13832174,16.1),(137305,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137305,37.08,0.33,261,65509,70,NULL,NULL,'2MASX J16230069+2301382',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.7530417,23.02731,0.133,NULL,56653923170,885217549,13831524,18.1),(137306,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137306,37.08,0.33,261,65510,70,NULL,NULL,'2MASX J16230105+2301122',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'17.00',0.37,NULL,NULL,NULL,NULL,NULL,1,245.754333333,23.02,0.133,NULL,56653923292,885217551,13831524,17),(137307,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137307,36.88,0.17,237,65511,70,NULL,NULL,'2MASX J16230168+2356512',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.757125,23.94767,0.153,NULL,56642408474,885037632,13828713,17.2),(137308,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137308,38.33,0.27,463,65512,70,NULL,NULL,'SDSS J162301.99+213553.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.758333,21.59822,0.133,NULL,56656127021,885251984,13832062,18.6),(137309,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137309,37.95,0.33,389,65513,70,NULL,NULL,'SDSS J162302.40+102833.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.760041667,10.47594,0.185,NULL,56457693036,882151453,13783616,17.9),(137310,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137310,36.86,0.21,236,65514,70,NULL,NULL,'2MASX J16230269+1420477',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000199,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,245.76125,14.3465,0.137,NULL,56659579383,885305927,13832905,15.9),(137311,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137311,35.2,0.45,110,65515,NULL,NULL,'K','NGC 6137',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000047,NULL,'13.40',1.2,'E','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,245.762917,37.92236,0.005,NULL,59768838261,933888097,14592001,13.4),(137312,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137312,35.66,0.4,136,65515,NULL,NULL,'mean','NGC 6137',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137313,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137313,36.88,0.17,237,65516,70,NULL,NULL,'2MASX J16230343+2403569',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.7642917,24.06586,0.153,NULL,56642376827,885037137,13828705,17.4),(137314,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137314,36.23,0.46,176,65517,70,NULL,NULL,'2MASX J16230431+3945245',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000137,NULL,'15.7g',0.37,'S0',NULL,NULL,NULL,NULL,1,245.767833,39.75686,0,NULL,59853390099,935209220,14612644,15.7),(137315,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137315,38.3,0.46,457,65518,70,NULL,NULL,'2MASX J16230446+0922061',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.7685,9.36839,0.161,NULL,56457636145,882150564,13783602,17.1),(137316,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137316,35.55,0.75,129,65519,70,NULL,NULL,'2MASX J16230457-3021476',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,245.769041667,-30.36317,0.977,NULL,46249438841,722647481,11291366,16.1),(137317,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137317,37.62,0.27,335,65520,70,NULL,NULL,'2MASX J16230552+1956152',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.7730417,19.93747,0.209,NULL,56647978274,885124660,13830072,17.3),(137318,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137318,37.32,0.46,291,65521,70,NULL,NULL,'2MASX J16230762+2154412',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.781875,21.91147,0.133,NULL,56656555103,885258673,13832166,17.3),(137319,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137319,38.06,0.46,409,65522,70,NULL,NULL,'2MASX J16230771+0709081',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,245.782083,7.15236,0.277,NULL,56467562768,882305668,13786026,17.2),(137320,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137320,37.95,0.33,389,65523,70,NULL,NULL,'2MASX J16230827+1028581',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.7842917,10.48281,0.185,NULL,56457695088,882151485,13783616,17.9),(137321,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137321,36.69,0.21,217,65524,70,NULL,NULL,'2MASX J16230834+2549279',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000194,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,245.78475,25.82428,0.081,NULL,56173031727,877703620,13714119,16.4),(137322,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137322,37.55,0.46,324,65525,70,NULL,NULL,'2MASX J16230848+2546399',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.785208333,25.77772,0.081,NULL,56173027684,877703557,13714118,17.3),(137323,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137323,38.4,0.46,479,65526,70,NULL,NULL,'2MASX J16230860+1045561',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.785833,10.76553,0.185,NULL,56740844488,886575695,13852745,17.9),(137324,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137324,37.72,0.46,351,65527,70,NULL,NULL,'SDSS J162309.50+080501.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.789625,8.08381,0.297,NULL,56465806982,882278234,13785597,18.7),(137325,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137325,34.98,0.46,99.2,65528,70,NULL,NULL,'UGC 10360',NULL,'2015arXiv151105856S',2015,1,1.1,NULL,'G',0.00015,NULL,'14.44',1.1,'S0',NULL,NULL,NULL,NULL,1,245.797125,16.93261,0.181,NULL,56669067942,885454186,13835221,14.44),(137326,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137326,36.33,0.46,184,65529,70,NULL,NULL,'2MASX J16231377+2628457',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000173,NULL,'15.9g',0.41,NULL,NULL,NULL,NULL,NULL,1,245.8074583,26.47928,0.085,NULL,56172450470,877694538,13713977,15.9),(137327,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137327,38.07,0.46,411,65530,70,NULL,NULL,'2MASX J16232012+3854415',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00013,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,245.8339583,38.91142,0,NULL,59853630950,935212983,14612702,16.5),(137328,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137328,37.43,0.46,306,65531,70,NULL,NULL,'2MASX J16232031+3529194',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,245.834541667,35.48869,0.005,NULL,59781310045,934082969,14595046,17.6),(137329,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137329,38.43,0.46,486,65532,70,NULL,NULL,'2MASX J16232037+1434524',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.834833,14.58114,0.137,NULL,56659572812,885305825,13832903,18),(137330,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137330,36.53,0.23,203,65533,70,NULL,NULL,'2MASX J16232189+0855511',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.841125,8.93092,0.169,NULL,56469028551,882328571,13786383,16.5),(137331,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137331,37.34,0.46,293,65534,70,NULL,NULL,'2MASX J16232227+2451067',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.1g',0.21,'AGN',NULL,NULL,NULL,NULL,1,245.8427917,24.85178,0.125,NULL,56171497087,877679641,13713744,17.1),(137332,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137332,35.62,0.09,133,65535,NULL,NULL,NULL,'KUG 1621+417',NULL,'2009ApJS..182..474S',2009,1,0.87,NULL,'G',0.000047,NULL,'14.9g',0.45,'Sb',NULL,NULL,NULL,NULL,1,245.8452083,41.65122,0,NULL,59855442167,935241283,14613145,14.9),(137333,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137333,36.53,0.23,203,65536,70,NULL,NULL,'2MASX J16232364+0856071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'16.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.8484583,8.93547,0.169,NULL,56469025121,882328517,13786383,16.9),(137334,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137334,37.03,0.33,255,65537,70,NULL,NULL,'2MASX J16232486+2113546',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,NULL,'16.67',0.31,NULL,NULL,NULL,NULL,NULL,1,245.8537083,21.23181,0.157,NULL,56653050722,885203917,13831311,16.67),(137335,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137335,36.53,0.23,203,65538,70,NULL,NULL,'2MASX J16232702+0901488',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.862625,9.03031,0.153,NULL,56468988063,882327938,13786374,16.7),(137336,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137336,37.5,0.46,317,65539,70,NULL,NULL,'2MASX J16232739+1121028',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,245.86425,11.35072,0.237,NULL,56741467899,886585435,13852897,17.9),(137337,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137337,35.54,0.21,128,65540,70,NULL,NULL,'2MASX J16232792+3749515',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000073,NULL,'15.9g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,245.8662083,37.83106,0,NULL,59768834502,933888039,14592000,15.9),(137338,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137338,35.45,0.25,123,65541,74.4,NULL,NULL,'KUG 1621+393',NULL,'2013AJ....146...86T',2013,1,0.62,'Position in Kiso list (1984AnTok..192.595T) is incorrect.','G',0.000137,NULL,'15.5g',0.62,'S',NULL,NULL,NULL,NULL,1,245.866917,39.19142,0,NULL,59853617287,935212770,14612699,15.5),(137339,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137339,35.66,0.16,135,65541,70,NULL,NULL,'KUG 1621+393',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137340,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137340,36.88,0.17,237,65542,70,NULL,NULL,'2MASX J16232869+2353477',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000176,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.8697083,23.89653,0.153,NULL,56642960687,885046260,13828847,17.1),(137341,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137341,36.59,0.33,208,65543,70,NULL,NULL,'2MASX J16233009+2407247',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,245.875375,24.12344,0.113,NULL,56642375271,885037113,13828704,16.6),(137342,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137342,37.22,0.2,278,65544,74.4,NULL,NULL,'CGCG 168-003',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000025,NULL,'15.8g',0.25,'Irr',NULL,NULL,NULL,NULL,1,245.882166667,30.68725,0.041,NULL,59788106893,934189170,14596705,15.8),(137343,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137343,35.54,0.46,128,65545,70,NULL,NULL,'CGCG 052-011',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000195,NULL,'15.0g',0.53,NULL,NULL,NULL,NULL,NULL,1,245.883833333,7.85119,0.281,NULL,56465459706,882272807,13785512,15),(137344,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137344,38.1,0.46,416,65546,70,NULL,NULL,'SDSS J162332.39+341218.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00017,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,245.885,34.20517,0.029,NULL,59791263025,934238484,14597476,18.8),(137345,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137345,35.76,0.06,142,65547,70,NULL,NULL,'2MASX J16233242+3913005',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000133,NULL,'16.0g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,245.885,39.21672,0,NULL,59853604637,935212572,14612696,16),(137346,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137346,36.85,0.46,234,65548,70,NULL,NULL,'2MASX J16233331+1521004',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.888875,15.35028,0.133,NULL,56671245549,885488211,13835753,17.4),(137347,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137347,37.03,0.33,255,65549,70,NULL,NULL,'SDSS J162333.76+211850.2',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.890667,21.31394,0.145,NULL,56653026470,885203538,13831305,17.3),(137348,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137348,37.53,0.46,320,65550,70,NULL,NULL,'2MASX J16233385+2145176',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.8910417,21.755,0.133,NULL,56656082712,885251292,13832051,17.6),(137349,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137349,37.69,0.46,345,65551,70,NULL,NULL,'2MASX J16233396+2854556',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,245.8915,28.9155,0.089,NULL,59734461510,933350961,14583608,17.2),(137350,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137350,36.53,0.23,203,65552,70,NULL,NULL,'2MASX J16233425+0851068',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.1g',0.21,'AGN',NULL,NULL,NULL,NULL,1,245.892875,8.85181,0.169,NULL,56469000430,882328131,13786377,17.1),(137351,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137351,38.21,0.46,439,65553,70,NULL,NULL,'SDSS J162334.83-002733.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000068,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.895125,-0.45922,0.329,NULL,45501565608,710961962,11108780,18.7),(137352,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137352,37.65,0.46,339,65554,70,NULL,NULL,'2MASX J16233612+4011246',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,245.9005417,40.19028,0,NULL,59856330618,935255165,14613361,16.7),(137353,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137353,37.88,0.33,376,65555,70,NULL,NULL,'SDSS J162336.21+232506.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00019,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.900875,23.41833,0.149,NULL,56642839281,885044363,13828818,18.2),(137354,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137354,36.86,0.21,236,65556,70,NULL,NULL,'2MASX J16233842+1441544',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.91025,14.69853,0.133,NULL,56659640379,885306880,13832920,17.9),(137355,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137355,35.51,0.46,127,65557,70,NULL,NULL,'KUGX 1621+351',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000127,NULL,'14.9g',0.62,'Compact',NULL,NULL,NULL,NULL,1,245.910917,35.01128,0.037,NULL,59779987763,934062308,14594723,14.9),(137356,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137356,34.29,0.2,72.1,65558,74.4,NULL,NULL,'NGC 6132',NULL,'2013AJ....146...86T',2013,1,1.62,NULL,'G',0.000033,NULL,'14.3g',0.45,'Sab',NULL,NULL,NULL,NULL,1,245.911833,11.78625,0.237,NULL,56740800674,886575010,13852734,14.3),(137357,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137357,34.46,0.4,77.9,65558,NULL,NULL,'mean','NGC 6132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137358,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137358,34.64,0.47,84.7,65558,NULL,NULL,'H','NGC 6132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137359,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137359,36.15,0.46,170,65559,70,NULL,NULL,'CGCG 138-004',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000167,NULL,'15.3g',0.56,NULL,NULL,NULL,NULL,NULL,1,245.917,24.47419,0.121,NULL,56172055309,877688364,13713880,15.3),(137360,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137360,38.22,0.23,441,65560,70,NULL,NULL,'SDSS J162340.22+233932.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.917625,23.659,0.137,NULL,56642852908,885044576,13828821,18.4),(137361,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137361,37.09,0.46,262,65561,70,NULL,NULL,'2MASX J16234027+4144407',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.917958333,41.74467,0,NULL,59857332332,935270817,14613606,17.9),(137362,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137362,37.88,0.33,376,65562,70,NULL,NULL,'SDSS J162340.43+230903.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.9185,23.15103,0.165,NULL,56653966946,885218233,13831534,18.4),(137363,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137363,35.83,0.46,147,65563,70,NULL,NULL,'CGCG 080-019',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000163,NULL,'15.2',0.55,NULL,'Group member',NULL,NULL,NULL,1,245.923625,9.74492,0.185,NULL,56457497962,882148405,13783568,15.2),(137364,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137364,36.59,0.33,208,65564,70,NULL,NULL,'2MASX J16234171+2410186',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0002,NULL,'15.5g',0.38,NULL,NULL,NULL,NULL,NULL,1,245.924,24.17181,0.113,NULL,56171758063,877683719,13713808,15.5),(137365,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137365,36.92,0.46,242,65565,70,NULL,NULL,'2MASX J16234201+1804426',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,245.9250417,18.0785,0.189,NULL,56665595985,885399937,13834374,16.6),(137366,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137366,37.82,0.27,367,65566,70,NULL,NULL,'2MASX J16234227+0021380',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00009,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,245.9262083,0.36044,0.325,NULL,56441150299,881892973,13779577,16.5),(137367,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137367,37.97,0.46,393,65567,70,NULL,NULL,'2MASX J16234295+3925037',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.929083333,39.41769,0,NULL,59853419915,935209686,14612651,17.6),(137368,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137368,38.27,0.46,451,65568,70,NULL,NULL,'2MASX J16234372+4619187',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.932083,46.32175,0,NULL,59833581684,934899713,14607808,18),(137369,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137369,37.95,0.46,390,65569,70,NULL,NULL,'SDSS J162343.86+205247.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.8g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,245.9327917,20.87992,0.169,NULL,56645647369,885088240,13829503,18.8),(137370,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137370,37.34,0.46,294,65570,70,NULL,NULL,'2MASX J16234600+2357166',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,245.941625,23.95447,0.153,NULL,56642904694,885045385,13828834,17.5),(137371,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137371,37.82,0.27,367,65571,70,NULL,NULL,'SDSS J162350.85+002912.3',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000072,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.961875,0.48675,0.309,NULL,56441018153,881890908,13779545,17.6),(137372,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137372,35.76,0.06,142,65572,70,NULL,NULL,'2MASX J16235131+4007508',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000073,NULL,'15.2g',0.49,'E0',NULL,NULL,NULL,NULL,1,245.963667,40.13089,0,NULL,59856338682,935255291,14613363,15.2),(137373,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137373,37.42,0.46,304,65573,70,NULL,NULL,'SDSS J162351.33+242831.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,245.963875,24.47553,0.121,NULL,56172065935,877688530,13713883,17.9),(137374,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137374,38.22,0.23,441,65574,70,NULL,NULL,'2MASX J16235162+2338049',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,245.9650417,23.63481,0.137,NULL,56642862944,885044733,13828823,17.3),(137375,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137375,37.82,0.27,367,65575,70,NULL,NULL,'2MASX J16235213+0027130',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000116,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.967125,0.45372,0.309,NULL,56441028084,881891063,13779547,17.1),(137376,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137376,38.38,0.33,473,65576,70,NULL,NULL,'SDSS J162352.67+210935.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,245.9695,21.15994,0.157,NULL,56653018604,885203415,13831303,18.6),(137377,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137377,35.05,NULL,102,65577,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2034',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',NULL,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,245.973833,69.08217,0.149,NULL,57846946160,903858533,14122789,16.6),(137378,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137378,35.06,NULL,103,65577,NULL,NULL,'Dipole + Quadrupole','FGC 2034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137379,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137379,35.08,NULL,104,65577,NULL,NULL,'Dipole','FGC 2034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137380,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137380,35.09,NULL,104,65577,NULL,NULL,NULL,'FGC 2034',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137381,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137381,36.79,0.46,228,65578,70,NULL,NULL,'2MASX J16235426+2213419',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00019,NULL,'16.0g',0.4,NULL,NULL,NULL,NULL,NULL,1,245.9760417,22.22844,0.133,NULL,56656602916,885259420,13832178,16),(137382,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137382,38.37,0.46,472,65579,70,NULL,NULL,'2MASX J16235443+1535232',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000192,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.9769583,15.58969,0.133,NULL,56671327890,885489498,13835773,17.8),(137383,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137383,38.28,0.33,452,65580,70,NULL,NULL,'SDSS J162355.66+390837.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000179,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,245.981958333,39.14381,0,NULL,59853612277,935212691,14612698,18.2),(137384,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137384,36.86,0.21,236,65581,70,NULL,NULL,'2MASX J16235573+1407262',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,245.9822917,14.12392,0.161,NULL,56660250692,885316417,13833069,16.6),(137385,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137385,37.75,0.46,354,65582,70,NULL,NULL,'2MASX J16235579+3609178',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,245.9824583,36.15486,0.013,NULL,59777904735,934029761,14594215,17.4),(137386,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137386,39.18,0.46,685,65583,70,NULL,NULL,'2MASX J16235648+2632074',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,245.9854583,26.5355,0.085,NULL,56172464188,877694752,13713980,18.6),(137387,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137387,38.19,0.46,435,65584,70,NULL,NULL,'SDSS J162357.65+215028.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,245.99025,21.84128,0.133,NULL,56655967642,885249494,13832023,18.3),(137388,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137388,38.2,0.27,436,65585,70,NULL,NULL,'2MASX J16235820+2039199',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,245.992417,20.65558,0.185,NULL,56645482067,885085657,13829463,17.8),(137389,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137389,36.69,0.21,217,65586,70,NULL,NULL,'2MASX J16235851+2542374',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000194,NULL,'16.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.993833333,25.71031,0.081,NULL,56172962249,877702535,13714102,16.2),(137390,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137390,38.28,0.33,452,65587,70,NULL,NULL,'2MASX J16235875+3916188',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,245.994833,39.27194,0,NULL,59853734640,935214603,14612728,17.1),(137391,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137391,37.81,0.46,365,65588,70,NULL,NULL,'2MASX J16235888+1520022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,245.9955,15.33386,0.133,NULL,56671265998,885488531,13835758,18.5),(137392,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137392,36.86,0.21,236,65589,70,NULL,NULL,'2MASX J16235913+1437182',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,245.996333,14.62167,0.137,NULL,56659459394,885304053,13832875,16.8),(137393,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137393,37.22,0.27,278,65590,70,NULL,NULL,'2MASX J16235986+4548067',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,245.999625,45.80194,0,NULL,59833531450,934898928,14607795,17.3),(137394,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137394,38.2,0.27,436,65591,70,NULL,NULL,'2MASX J16240112+2040179',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.004625,20.67178,0.185,NULL,56645481921,885085655,13829463,17.6),(137395,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137395,37.98,0.27,394,65592,70,NULL,NULL,'SDSS J162401.46+273138.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.006125,27.52731,0.097,NULL,59733396091,933334313,14583348,18.4),(137396,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137396,36.86,0.21,236,65593,70,NULL,NULL,'2MASX J16240238+1427082',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000183,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,246.0097917,14.45244,0.137,NULL,56659427056,885303547,13832867,16),(137397,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137397,38.38,0.33,473,65594,70,NULL,NULL,'2MASX J16240460+2109009',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000168,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.0192083,21.15031,0.157,NULL,56653008538,885203258,13831300,17.9),(137398,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137398,37.54,0.46,322,65595,70,NULL,NULL,'2MASX J16240610+1226552',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.0255417,12.44872,0.209,NULL,56874916631,888670572,13885477,17.1),(137399,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137399,37.69,0.46,345,65596,70,NULL,NULL,'SDSS J162406.17+231301.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.02575,23.21703,0.145,NULL,56653917052,885217453,13831522,18.3),(137400,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137400,38.2,0.46,436,65597,70,NULL,NULL,'2MASX J16240624+0747393',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000207,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,246.026125,7.79411,0.297,NULL,56465555354,882274302,13785535,17.9),(137401,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137401,36.53,0.46,202,65598,70,NULL,NULL,'2MASX J16240730+5045343',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,246.030417,50.75969,0.017,NULL,59696142448,932752225,14574253,16.2),(137402,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137402,38.59,0.46,524,65599,70,NULL,NULL,'SDSS J162409.80+214548.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,246.040875,21.76344,0.133,NULL,56656000127,885250001,13832031,18.4),(137403,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137403,38.55,0.46,512,65600,70,NULL,NULL,'2MASX J16241132+0918363',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.047125,9.31011,0.161,NULL,56741633123,886588017,13852937,18),(137404,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137404,36.69,0.2,218,65601,74.4,NULL,NULL,'UGC 10372',NULL,'2013AJ....146...86T',2013,1,0.99,NULL,'G',0.000007,NULL,'15.2g',0.59,'SAB(rs)b:',NULL,NULL,NULL,NULL,1,246.05075,30.16225,0.053,NULL,59732859215,933325925,14583217,15.2),(137405,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137405,38.13,0.33,422,65602,70,NULL,NULL,'2MASX J16241232+2053489',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.0515,20.89689,0.169,NULL,56645587372,885087302,13829489,17.3),(137406,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137406,37.22,0.27,278,65603,70,NULL,NULL,'2MASX J16241306+4544523',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.0002,NULL,'16.1g',0.27,'S0',NULL,NULL,NULL,NULL,1,246.054417,45.74783,0,NULL,59833402578,934896915,14607764,16.1),(137407,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137407,19.26,0.4,0.071,65604,NULL,NULL,'1, K, Unidentified Dwarf Galaxy, center 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,'Class III2',NULL,NULL,NULL,NULL,1,246.0590417,-51.15181,NULL,0,46325221951,723831592,11309868,NULL),(137408,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137408,19.77,0.27,0.09,65604,NULL,NULL,'4, K, Mean of 4 Cepheids, Unidentified Dwarf Gxy, 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137409,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137409,19.82,0.4,0.092,65604,NULL,NULL,'1, K, Unidentified Dwarf Galaxy, center 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137410,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137410,19.84,0.4,0.093,65604,NULL,NULL,'1, K, Unidentified Dwarf Galaxy, center 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137411,'Cepheids','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137411,20,0.4,0.1,65604,NULL,NULL,'1, K, Unidentified Dwarf Galaxy, center 30 arcmin from ESO 226-SC 006','ESO 226-SC 006',NULL,'2015ApJ...802L...4C',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137412,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137412,37.47,0.46,311,65605,70,NULL,NULL,'2MASX J16241468+1059493',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',NULL,NULL,'17.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,246.06125,10.99689,0.197,NULL,56741049011,886578890,13852795,17.7),(137413,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137413,38.08,0.46,414,65606,70,NULL,NULL,'2MASX J16241494+2558214',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000144,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.0622083,25.97258,0.093,NULL,56172838870,877700607,13714071,17.7),(137414,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137414,35.54,0.23,128,65607,74.4,NULL,NULL,'CGCG 224-015',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000073,NULL,'14.9g',0.65,'E/S0',NULL,NULL,NULL,NULL,1,246.0734583,39.21103,0,NULL,59853748020,935214812,14612731,14.9),(137415,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137415,35.66,0.16,135,65607,70,NULL,NULL,'CGCG 224-015',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137416,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137416,35.76,0.06,142,65607,70,NULL,NULL,'CGCG 224-015',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137417,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137417,38.29,0.46,454,65608,70,NULL,NULL,'2MASX J16241900+2256209',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.07925,22.93925,0.141,NULL,56653858397,885216537,13831508,18.2),(137418,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137418,37.98,0.27,394,65609,70,NULL,NULL,'2MASX J16241933+2729225',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.0805,27.48956,0.097,NULL,59733409077,933334516,14583351,18.1),(137419,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137419,37.31,0.46,289,65610,70,NULL,NULL,'2MASX J16241992+1527478',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000176,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,246.083125,15.46339,0.133,NULL,56671298662,885489041,13835766,16.2),(137420,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137420,37.18,0.46,273,65611,70,NULL,NULL,'2MASXi J1624201+465043',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.083833,46.84519,0.005,NULL,59835147812,934924184,14608190,17.5),(137421,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137421,38.13,0.33,422,65612,70,NULL,NULL,'2MASX J16242017+2057049',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.0840417,20.95128,0.169,NULL,56645537873,885086529,13829477,18.1),(137422,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137422,34.32,NULL,73.1,65613,NULL,NULL,NULL,'FGC 2032',NULL,'2000BSAO...50....5K',2000,1,0.78,NULL,'G',NULL,NULL,'17.3g',0.12,'Scd',NULL,NULL,NULL,NULL,1,246.0842917,40.865,0.005,NULL,59855475358,935241802,14613153,17.3),(137423,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137423,37.76,0.46,357,65614,70,NULL,NULL,'2MASX J16242036+4606383',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000192,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,246.084833,46.11067,0.005,NULL,59833639617,934900619,14607822,16.4),(137424,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137424,37.01,0.46,252,65615,70,NULL,NULL,'2MASX J16242199+0001486',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.091625,0.03022,0.333,NULL,56441963125,881905673,13779776,17.6),(137425,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137425,38.22,0.23,441,65616,70,NULL,NULL,'2MASX J16242202+2335082',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000179,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.091708333,23.58553,0.137,NULL,56642166319,885033848,13828653,17.1),(137426,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137426,37.8,0.46,363,65617,70,NULL,NULL,'2MASX J16242357+2507486',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000176,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,246.098125,25.13011,0.105,NULL,56171531025,877680172,13713752,16.9),(137427,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137427,36.63,0.46,212,65618,70,NULL,NULL,'2MASX J16242445+4831423',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000222,NULL,'15.5g',0.52,'AGN',NULL,NULL,NULL,NULL,1,246.102125,48.52844,0,NULL,59833994249,934906160,14607908,15.5),(137428,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137428,38.22,0.46,441,65619,70,NULL,NULL,'SDSS J162424.70+290936.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.102917,29.16025,0.073,NULL,59734441204,933350643,14583603,17.4),(137429,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137429,37.22,0.27,278,65620,70,NULL,NULL,'2MASX J16242471+4546543',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,246.103166667,45.78189,0,NULL,59833404964,934896952,14607764,17),(137430,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137430,37.58,0.46,329,65621,70,NULL,NULL,'2MASX J16242481+0020378',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.103333,0.34392,0.321,NULL,56442009007,881906390,13779787,18.3),(137431,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137431,36.9,0.46,240,65622,70,NULL,NULL,'2MASX J16242820-0019243',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.1175,-0.32339,0.321,NULL,45503512051,710992375,11109255,17.3),(137432,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137432,37.73,0.46,352,65623,70,NULL,NULL,'2MASX J16242838+2642076',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.11825,26.70208,0.077,NULL,56172263925,877691623,13713931,17.5),(137433,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137433,37.98,0.27,394,65624,70,NULL,NULL,'2MASX J16242902+2735096',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.120917,27.58592,0.097,NULL,59733435938,933334936,14583358,18),(137434,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137434,36.91,0.46,241,65625,70,NULL,NULL,'2MASX J16242971+3255094',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,246.123916667,32.91928,0.025,NULL,59791626094,934244157,14597564,17.5),(137435,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137435,38.08,0.46,412,65626,70,NULL,NULL,'2MASX J16243074+2059513',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000207,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.128291667,20.99758,0.157,NULL,56645539414,885086553,13829477,17),(137436,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137436,37.75,0.46,355,65627,70,NULL,NULL,'2MASX J16243163+2331463',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.131833,23.52961,0.141,NULL,56642122424,885033162,13828643,18.1),(137437,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137437,38.22,0.23,441,65628,70,NULL,NULL,'2MASX J16243192+2332093',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000186,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,246.133083,23.53603,0.141,NULL,56642122407,885033162,13828643,16.7),(137438,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137438,36.66,0.46,214,65629,70,NULL,NULL,'2MASX J16243517+2352423',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000161,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,246.146583,23.87853,0.153,NULL,56642186427,885034162,13828658,17.1),(137439,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137439,37.5,0.46,316,65630,70,NULL,NULL,'SDSS J162436.14+305455.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,246.150625,30.91536,0.041,NULL,59788180754,934190324,14596723,18.6),(137440,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137440,37.64,0.46,337,65631,70,NULL,NULL,'SDSS J162436.84+000912.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000072,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,246.1535417,0.1535,0.333,NULL,56441975401,881905865,13779779,18),(137441,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137441,38.2,0.27,436,65632,70,NULL,NULL,'2MASX J16243776+2038133',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.1575,20.63706,0.185,NULL,56646130425,885095787,13829621,17.5),(137442,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137442,38.29,0.46,456,65633,70,NULL,NULL,'2MASX J16243940+1859393',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.164125,18.99419,0.189,NULL,56702542185,885977221,13843394,17),(137443,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137443,36.79,0.46,228,65634,70,NULL,NULL,'CGCG 168-007',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000213,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,246.175667,30.76439,0.041,NULL,59788193135,934190517,14596726,15.6),(137444,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137444,34.72,0.68,88,65635,NULL,NULL,'Malmquist cor.','UGC 10373',NULL,'2009ApJS..182..474S',2009,1,1.31,'CGCG declination is 7 arcmin too large (B. Skiff).','G',0.00007,NULL,'15.6g',0.23,'Scd:',NULL,NULL,NULL,NULL,1,246.176375,7.18256,0.237,NULL,56464003968,882250062,13785157,15.6),(137445,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137445,34.87,0.63,94.1,65635,NULL,NULL,NULL,'UGC 10373',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137446,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137446,34.88,0.2,94.6,65635,74.4,NULL,NULL,'UGC 10373',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137447,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137447,38.58,0.46,520,65636,70,NULL,NULL,'SDSS J162443.35+460832.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000119,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.180667,46.14233,0.005,NULL,59833643459,934900679,14607823,18.5),(137448,'SGRB','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137448,38.73,NULL,557,65637,71,NULL,NULL,'CXO J162444.3-273227',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'G',0.0004,NULL,'18.6I',NULL,'Early-type',NULL,NULL,NULL,NULL,1,246.184917,-27.54097,1.065,NULL,46247705667,722620401,11290943,18.6),(137449,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137449,37.92,0.46,383,65638,70,NULL,NULL,'2MASX J16244452+1446037',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.185417,14.76775,0.153,NULL,56659503198,885304737,13832886,17.1),(137450,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137450,37.75,0.46,355,65639,70,NULL,NULL,'SDSS J162445.97+391051.1',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,246.1915417,39.18086,0.005,NULL,59853742599,935214728,14612730,16.8),(137451,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137451,38.07,0.33,411,65640,70,NULL,NULL,'2MASX J16244856+0952214',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.202333333,9.87272,0.185,NULL,56742503633,886601619,13853150,17.3),(137452,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137452,35.78,0.33,143,65641,70,NULL,NULL,'CGCG 080-024',NULL,'2015arXiv151105856S',2015,1,1.2,NULL,'G',0.000117,NULL,'15.3',0.9,'E','Pair member (points to parent)',NULL,NULL,NULL,1,246.204833,9.57589,0.165,NULL,56741851033,886591422,13852990,15.3),(137453,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137453,37.59,0.46,329,65642,70,NULL,NULL,'2MASX J16244931+2934030',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.205625,29.56744,0.049,NULL,59735093675,933360838,14583763,17.1),(137454,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137454,35.84,0.2,147,65643,74.4,NULL,NULL,'UGC 10375',NULL,'2013AJ....146...86T',2013,1,1.23,NULL,'G',0.000013,NULL,'15.43',0.15,'Sbc','Pair member (points to parent)',NULL,NULL,NULL,1,246.2085417,9.60708,0.185,NULL,56741794072,886590532,13852977,15.43),(137455,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137455,35.89,NULL,150,65643,NULL,NULL,'Dipole + Quadrupole','UGC 10375',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137456,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137456,35.89,NULL,151,65643,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10375',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137457,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137457,35.9,NULL,151,65643,NULL,NULL,'Dipole','UGC 10375',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137458,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137458,36.05,NULL,162,65643,NULL,NULL,NULL,'UGC 10375',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137459,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137459,35.66,0.46,135,65644,70,NULL,NULL,'CGCG 138-010',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000166,NULL,'15.4g',0.49,NULL,NULL,NULL,NULL,NULL,1,246.21,21.61386,0.125,NULL,56653182725,885205980,13831343,15.4),(137460,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137460,37.77,0.46,357,65645,70,NULL,NULL,'2MASX J16245061+0720294',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.2109583,7.3415,0.237,NULL,56464042405,882250662,13785166,17.7),(137461,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137461,35.76,0.2,142,65646,74.4,NULL,NULL,'CGCG 080-026',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000094,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,246.2114583,13.68508,0.161,NULL,56660469375,885319833,13833122,16.5),(137462,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137462,36.36,0.46,187,65647,70,NULL,NULL,'SDSS J162450.92+174413.7',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.2g',0.32,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.2122083,17.73714,0.177,NULL,56667423557,885428493,13834820,16.2),(137463,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137463,36.34,0.46,185,65648,70,NULL,NULL,'2MASX J16245379+3122306',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000158,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,246.224291667,31.37519,0.021,NULL,59788508964,934195452,14596803,16.5),(137464,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137464,35.67,0.1,136,65649,NULL,NULL,NULL,'NGC 6138',NULL,'2009ApJS..182..474S',2009,1,1.2,'Identification as N6138 is uncertain; N6138 may be CGCG 224-009.','G',0.000077,NULL,'15.4g',0.25,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.225708333,41.05078,0.005,NULL,59855490106,935242032,14613156,15.4),(137465,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137465,36.38,0.46,189,65650,70,NULL,NULL,'2MASX J16245589+4729184',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,246.23275,47.48853,0.009,NULL,59834627487,934916054,14608063,16.4),(137466,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137466,38.29,0.46,454,65651,70,NULL,NULL,'2MASX J16245830+3011425',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.242875,30.19508,0.053,NULL,59732881598,933326274,14583223,17.5),(137467,'SNIa','2016-12-15 15:15:42','2016-12-16 11:20:56','1','PTF10gmg','N',137467,37.38,0.03,282,65652,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10gmg',0.0628,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137468,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137468,35.78,0.33,143,65653,70,NULL,NULL,'2MASX J16250045+0944285',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.7g',0.37,NULL,NULL,NULL,NULL,NULL,1,246.251833,9.74122,0.185,NULL,56741760110,886590001,13852968,15.7),(137469,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137469,36.06,0.46,163,65654,70,NULL,NULL,'2MASX J16250140+2415471',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000891,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.256,24.26317,0.121,NULL,56171350444,877677350,13713708,16.6),(137470,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137470,35.73,0.06,140,65655,NULL,NULL,NULL,'NGC 6145',NULL,'2009ApJS..182..474S',2009,1,0.98,NULL,'G',0.00011,NULL,'14.5g',0.5,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.259833,40.94664,0.005,NULL,59855976839,935249638,14613275,14.5),(137471,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137471,38.07,0.33,411,65656,70,NULL,NULL,'2MASX J16250294+0954375',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.2622917,9.91047,0.185,NULL,56742469242,886601081,13853141,17.7),(137472,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137472,37.35,0.33,295,65657,70,NULL,NULL,'2MASX J16250543+2347555',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,246.2727083,23.79875,0.133,NULL,56642203425,885034428,13828662,17.1),(137473,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137473,37.52,0.59,320,65658,70,NULL,NULL,'2MASX J16250671-6454099',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.277833333,-64.90281,0.797,NULL,44993742648,703027228,10984800,16),(137474,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137474,36.65,0.46,214,65659,70,NULL,NULL,'2MASX J16250741+3236169',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.281083,32.60467,0.029,NULL,59786960713,934171261,14596425,17.3),(137475,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137475,36.34,0.46,185,65660,70,NULL,NULL,'2MASX J16250750+5015327',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000102,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.281375,50.25922,0,NULL,59696474934,932757420,14574334,16.9),(137476,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137476,34.3,0.4,72.4,65661,75,NULL,'Edat, raw','NGC 6146',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000053,NULL,'13.51',1,'E/S0           PEG','in a radial-velocity based grouping',NULL,'radio jet',NULL,1,246.293166667,40.89286,0.005,NULL,59855975274,935249613,14613275,13.51),(137477,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137477,34.63,0.4,84.2,65661,75,NULL,'Edat, cor','NGC 6146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137478,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137478,34.7,0.22,87.1,65661,74.4,NULL,NULL,'NGC 6146',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137479,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137479,35.29,0.22,114,65661,70,NULL,NULL,'NGC 6146',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137480,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137480,35.37,0.45,119,65661,NULL,NULL,'K','NGC 6146',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137481,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137481,35.49,0.4,125,65661,NULL,NULL,'mean','NGC 6146',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137482,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137482,36.57,0.46,206,65662,70,NULL,NULL,'SDSS J162511.07+375829.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000186,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.296167,37.97475,0,NULL,59819227685,934675432,14604303,16.9),(137483,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137483,36.67,0.46,216,65663,70,NULL,NULL,'2MASX J16251271+3648568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.302875,36.81597,0.013,NULL,59777814114,934028345,14594192,17.1),(137484,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137484,37.39,0.33,300,65664,70,NULL,NULL,'2MASX J16251519+4145568',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.313458333,41.76581,0.009,NULL,59857392502,935271757,14613621,17.2),(137485,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137485,38.38,0.46,474,65665,70,NULL,NULL,'SDSS J162516.47+182654.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.318625,18.44844,0.173,NULL,56702292614,885973322,13843333,18.5),(137486,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137486,36.76,0.46,225,65666,70,NULL,NULL,'2MASX J16251703+0814505',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00012,NULL,'16.75',0.43,NULL,NULL,NULL,NULL,NULL,1,246.321167,8.24747,0.221,NULL,56747240911,886675639,13854306,16.75),(137487,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137487,37.35,0.33,295,65667,70,NULL,NULL,'2MASX J16251710+2359551',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000185,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.321417,23.99872,0.125,NULL,56642220309,885034692,13828667,16.6),(137488,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137488,36.46,0.33,196,65668,70,NULL,NULL,'2MASX J16251751+1332319',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000187,NULL,'15.9g',0.43,NULL,NULL,NULL,NULL,NULL,1,246.323083333,13.54222,0.165,NULL,56657023759,885265996,13832281,15.9),(137489,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137489,38.71,0.46,552,65669,70,NULL,NULL,'SDSS J162517.70+085244.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.323791667,8.87892,0.205,NULL,56747053789,886672715,13854261,18.4),(137490,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137490,38.37,0.33,472,65670,70,NULL,NULL,'2MASX J16252001+3507220',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.3335417,35.12281,0.013,NULL,59779672428,934057381,14594646,17.7),(137491,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137491,38.37,0.33,472,65671,70,NULL,NULL,'2MASX J16252001+3509370',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.333625,35.16028,0.013,NULL,59779703978,934057874,14594654,17.5),(137492,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137492,37.39,0.33,300,65672,70,NULL,NULL,'2MASX J16252175+4156365',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,246.340417,41.94353,0.009,NULL,59857416934,935272139,14613627,17.2),(137493,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137493,37.13,0.46,267,65673,70,NULL,NULL,'2MASX J16252254+1311289',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.3439583,13.19147,0.189,NULL,56657121459,885267522,13832305,17.1),(137494,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137494,36.43,0.46,194,65674,70,NULL,NULL,'2MASX J16252268+3910393',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000077,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.3445,39.17758,0.005,NULL,59853724658,935214447,14612725,16.6),(137495,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137495,37.1,0.46,263,65675,70,NULL,NULL,'2MASX J16252365+3151420',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,246.3485,31.86169,0.037,NULL,59788862694,934200979,14596890,16.5),(137496,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137496,37.13,0.46,267,65676,70,NULL,NULL,'2MASX J16252389+2044447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.34975,20.74567,0.169,NULL,56646083027,885095047,13829610,17.6),(137497,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137497,37.61,0.46,333,65677,70,NULL,NULL,'2MASX J16252549+1750459',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.356416667,17.84608,0.169,NULL,56667647654,885431994,13834874,17.6),(137498,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137498,35.79,0.46,144,65678,70,NULL,NULL,'2MASX J16252668+2303467',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,246.361333333,23.06297,0.145,NULL,56654548747,885227324,13831676,16.3),(137499,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137499,35.86,0.58,148,65679,70,NULL,NULL,'FAIRALL 1420',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'17.1b',0.2,NULL,NULL,NULL,NULL,NULL,1,246.367917,-76.87781,0.397,NULL,44140983161,689702861,10776607,17.1),(137500,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137500,35.93,0.46,154,65680,70,NULL,NULL,'2MASX J16252835+3751523',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000087,NULL,'15.6g',0.45,'E0',NULL,NULL,NULL,NULL,1,246.3680417,37.86469,0.009,NULL,59819192697,934674885,14604295,15.6),(137501,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137501,37.62,0.46,335,65681,70,NULL,NULL,'2MASX J16252928+1734349',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.3719583,17.57636,0.177,NULL,56667537112,885430267,13834847,17.2),(137502,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137502,37.28,0.46,286,65682,70,NULL,NULL,'SDSS J162530.09+070657.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.375375,7.11597,0.237,NULL,56745365041,886646328,13853848,17.8),(137503,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137503,37.03,0.46,255,65683,70,NULL,NULL,'2MASX J16253335+0719302',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.389041667,7.32517,0.241,NULL,56745290556,886645164,13853830,17.4),(137504,'L(H{beta})-{sigma}','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137504,46.05,NULL,1605,65684,74.3,NULL,NULL,'PKS 1623+26:[ESS2006] BX0215',2.1814,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'24.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.390833333,26.89742,0.085,NULL,56183799323,877871864,13716747,24.4),(137505,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137505,35.76,0.06,142,65685,70,NULL,NULL,'2MASX J16253400+3840344',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000093,NULL,'15.5g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,246.391541667,38.67617,0.013,NULL,59852808949,935200139,14612502,15.5),(137506,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137506,35.76,0.06,142,65686,70,NULL,NULL,'2MASX J16253423+3855594',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000143,NULL,'15.3g',0.53,'S0',NULL,NULL,NULL,NULL,1,246.392833,38.93331,0.009,NULL,59853685399,935213834,14612716,15.3),(137507,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137507,38.35,0.46,468,65687,70,NULL,NULL,'2MASX J16253481+3450280',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.395125,34.84117,0.021,NULL,59780322292,934067535,14594805,18.3),(137508,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137508,35.84,0.46,147,65688,70,NULL,NULL,'2MASX J16253488+2032397',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000187,NULL,'15.7g',0.49,NULL,NULL,NULL,NULL,NULL,1,246.3952083,20.54436,0.185,NULL,56646027539,885094180,13829596,15.7),(137509,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137509,37.1,0.65,263,65689,70,NULL,NULL,'2MASX J16253621-0310394',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,246.400875,-3.17769,0.645,NULL,45510175809,711096497,11110882,14.4),(137510,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137510,37.18,0.46,274,65690,70,NULL,NULL,'2MASX J16253741+1452199',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.405916667,14.87219,0.153,NULL,56659318352,885301849,13832841,17.3),(137511,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137511,35.83,0.46,147,65691,70,NULL,NULL,'KUGX 1623+360',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00009,NULL,'15.1g',0.44,'Spiral',NULL,NULL,NULL,NULL,1,246.4062917,35.97764,0.013,NULL,59777782590,934027852,14594185,15.1),(137512,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137512,34.97,0.46,98.5,65692,70,NULL,NULL,'ARK 502',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00011,NULL,'14.5g',0.65,'E',NULL,NULL,NULL,NULL,1,246.4087083,16.45503,0.173,NULL,56670824302,885481629,13835650,14.5),(137513,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137513,36.46,0.33,196,65693,70,NULL,NULL,'2MASX J16253856+1332510',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.410666667,13.54739,0.165,NULL,56657020841,885265950,13832280,16.6),(137514,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137514,35.76,0.06,142,65694,70,NULL,NULL,'2MASX J16253934+3932464',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000073,NULL,'16.0g',0.31,'E0',NULL,NULL,NULL,NULL,1,246.414125,39.54611,0.005,NULL,59853060295,935204067,14612563,16),(137515,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137515,38.49,0.46,499,65695,70,NULL,NULL,'SDSS J162541.57+113432.8',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,246.42325,11.57581,0.229,NULL,56741349462,886583585,13852868,NULL),(137516,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137516,35.6,0.25,132,65696,74.4,NULL,NULL,'CGCG 224-020',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000097,NULL,'14.7g',0.6,'S0',NULL,NULL,NULL,NULL,1,246.424333,39.60008,0.005,NULL,59853049079,935203891,14612560,14.7),(137517,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137517,35.76,0.06,142,65696,70,NULL,NULL,'CGCG 224-020',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137518,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137518,36.69,0.21,217,65697,70,NULL,NULL,'2MASX J16254249+2543571',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000117,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,246.427083,25.73261,0.081,NULL,56184021595,877875337,13716802,15.7),(137519,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137519,36.62,0.46,211,65698,70,NULL,NULL,'2MASX J16254360+4918515',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000194,NULL,'15.6g',0.46,'S0^-',NULL,NULL,NULL,NULL,1,246.43175,49.31422,0,NULL,59828645554,934822586,14606602,15.6),(137520,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137520,36.44,0.46,194,65699,70,NULL,NULL,'2MASX J16254564+1733072',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',NULL,NULL,'17.07',0.42,NULL,NULL,NULL,NULL,NULL,1,246.440291667,17.55208,0.177,NULL,56667497035,885429641,13834838,17.07),(137521,'HII LF','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137521,45.45,3.07,2750,65700,71,NULL,NULL,'PKS 1623+26:[ESS2003] BX0432',2.1817,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',NULL,NULL,'24.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.453083,26.77972,0.085,NULL,56184010576,877875165,13716799,24.5),(137522,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137522,35.07,0.49,103,65701,75,NULL,'IR','UGC 10380',NULL,'2011yCatp016004901K',2011,1,1.62,NULL,'G',0.000033,NULL,'15.1g',0.32,'Sb',NULL,NULL,NULL,NULL,1,246.4579583,16.57606,0.185,NULL,56672913877,885514279,13836160,15.1),(137523,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137523,35.38,0.2,119,65701,74.4,NULL,NULL,'UGC 10380',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137524,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137524,35.55,0.47,129,65701,NULL,NULL,'H','UGC 10380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137525,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137525,35.6,0.4,132,65701,NULL,NULL,'mean','UGC 10380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137526,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137526,35.7,0.45,138,65701,NULL,NULL,'K','UGC 10380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137527,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137527,35.77,0.46,142,65701,NULL,NULL,'J','UGC 10380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137528,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137528,35.76,0.06,142,65702,70,NULL,NULL,'NGC 6150',NULL,'2015arXiv151105856S',2015,1,1.28,NULL,'G',0.000093,NULL,'14.0g',0.67,'E?','Group member, radial-velocity confirmed',NULL,'NAT',NULL,1,246.4584583,40.48856,0.013,NULL,59856816242,935262753,14613480,14),(137529,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137529,37.72,0.46,349,65703,70,NULL,NULL,'2MASX J16255076+1659483',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.4614583,16.99661,0.197,NULL,56667896316,885435879,13834935,17.1),(137530,'L(H{beta})-{sigma}','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137530,46.05,NULL,1604,65704,74.3,NULL,NULL,'PKS 1623+26:[SSP2004] BX0453',2.1816,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'23.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.461833,26.82539,0.085,NULL,56183976824,877874637,13716791,23.3),(137531,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137531,37.63,0.46,335,65705,70,NULL,NULL,'2MASX J16255106+1426023',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.4627083,14.43406,0.153,NULL,56660007072,885312610,13833009,17.3),(137532,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137532,35.54,0.21,128,65706,70,NULL,NULL,'KUGX 1624+374',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00008,NULL,'15.3g',0.43,'Compact',NULL,NULL,NULL,NULL,1,246.465375,37.36208,0.009,NULL,59748113961,933564280,14586941,15.3),(137533,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137533,35.05,0.51,102,65707,70,NULL,NULL,'2MASX J16255356-6526472',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.4730417,-65.44658,0.757,NULL,44994161465,703033772,10984902,15.2),(137534,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137534,37.02,0.46,254,65708,70,NULL,NULL,'2MASX J16255370+3036027',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000145,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.47375,30.60067,0.041,NULL,59788032959,934188014,14596687,16.9),(137535,'HII LF','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'N',137535,44.82,1.58,1850,65709,71,NULL,NULL,'[HB89] 1623+269:MD107',2.5373,'2005MNRAS.356.1117S',2005,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137536,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137536,37.1,0.46,262,65710,70,NULL,NULL,'2MASX J16255439+5006465',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000184,NULL,'16.5g',0.34,'AGN',NULL,NULL,NULL,NULL,1,246.47675,50.11294,0.017,NULL,59696399746,932756246,14574316,16.5),(137537,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137537,38.49,0.46,498,65711,70,NULL,NULL,'SDSS J162555.89+255650.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,246.482917,25.94744,0.089,NULL,56184240556,877878758,13716855,18.6),(137538,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137538,37.94,0.46,388,65712,70,NULL,NULL,'2MASX J16260061+3348107',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,246.502417,33.80294,0.037,NULL,59790944074,934233501,14597398,17.3),(137539,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137539,38.1,0.46,417,65713,70,NULL,NULL,'2MASX J16260070+2042529',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.502958333,20.71456,0.169,NULL,56645993466,885093647,13829588,18.1),(137540,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137540,36.18,0.46,172,65714,70,NULL,NULL,'2MASX J16260081+0923503',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00009,NULL,'16.20',0.52,NULL,NULL,NULL,NULL,NULL,1,246.5035,9.39728,0.153,NULL,56755446956,886803858,13856310,16.2),(137541,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137541,38.04,0.46,405,65715,70,NULL,NULL,'2MASX J16260104+2105429',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.504291667,21.09511,0.153,NULL,56645193609,885081150,13829392,17.6),(137542,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137542,37,0.46,251,65716,70,NULL,NULL,'2MASX J16260492+1720423',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00011,NULL,'11.2K',NULL,NULL,NULL,NULL,NULL,NULL,1,246.520541667,17.34503,0.177,NULL,56667955682,885436807,13834950,11.2),(137543,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137543,36.34,0.5,185,65717,70,NULL,NULL,'2MASX J16260655-0040457',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.24',0.4,NULL,NULL,NULL,NULL,NULL,1,246.527167,-0.67939,0.321,NULL,45503621310,710994082,11109282,16.24),(137544,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137544,37.52,0.46,319,65718,70,NULL,NULL,'2MASX J16260663+0715223',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,246.527667,7.25614,0.241,NULL,56745502926,886648483,13853882,NULL),(137545,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137545,37.89,0.21,378,65719,70,NULL,NULL,'2MASX J16260790+1337133',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.5329583,13.62036,0.165,NULL,56660545041,885321016,13833140,17.2),(137546,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137546,31.85,0.43,23.4,65720,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6155',NULL,'2014MNRAS.444..527S',2014,1,1.68,NULL,'G',0.00009,NULL,'13.2g',0.99,'SBcd','Field galaxy',NULL,NULL,NULL,1,246.53475,48.36681,0,NULL,59842358873,935036857,14609950,13.2),(137547,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137547,32.03,0.43,25.4,65720,75,NULL,'3.6 micron, color corrected','NGC 6155',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137548,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137548,32.22,0.2,27.8,65720,74.4,NULL,NULL,'NGC 6155',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137549,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137549,35.42,0.46,122,65721,70,NULL,NULL,'KUGX 1624+328',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.0001,NULL,'15.3g',0.44,'Compact',NULL,NULL,NULL,NULL,1,246.538333,32.75231,0.041,NULL,59787073706,934173026,14596453,15.3),(137550,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137550,36.66,0.46,215,65722,70,NULL,NULL,'2MASX J16260958+4620189',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,246.5397917,46.3385,0,NULL,59833263164,934894736,14607730,16.7),(137551,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137551,37.89,0.21,378,65723,70,NULL,NULL,'2MASX J16260994+1331335',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00018,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.541333,13.52606,0.165,NULL,56656940234,885264691,13832260,16.8),(137552,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137552,35.67,0.69,136,65724,70,NULL,NULL,'2MASX J16261019-0208117',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.3,NULL,NULL,NULL,NULL,NULL,1,246.5425417,-2.13661,0.545,NULL,45502813626,710981462,11109085,14.1),(137553,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137553,35.76,0.06,142,65725,70,NULL,NULL,'2MASX J16261097+3914137',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.1g',0.28,'S0',NULL,NULL,NULL,NULL,1,246.545875,39.237,0,NULL,59853065286,935204145,14612564,16.1),(137554,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137554,37.89,0.21,378,65726,70,NULL,NULL,'2MASX J16261105+1324255',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,246.5460417,13.407,0.165,NULL,56656941479,885264710,13832261,18.3),(137555,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137555,38.24,0.46,444,65727,70,NULL,NULL,'SDSS J162611.15+341120.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.5465,34.18897,0.029,NULL,59779461898,934054092,14594595,17.7),(137556,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137556,36.66,0.55,215,65728,70,NULL,NULL,'2MASX J16261289-0039337',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,246.553666667,-0.65931,0.321,NULL,45503616292,710994004,11109281,13.8),(137557,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137557,36.66,0.46,215,65729,70,NULL,NULL,'2MASX J16261379+4610540',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000157,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.557375,46.18153,0.005,NULL,59833615176,934900237,14607816,17.1),(137558,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137558,35.46,0.25,124,65730,74.4,NULL,NULL,'KUG 1624+400',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000092,NULL,'14.8g',0.51,'S',NULL,NULL,NULL,NULL,1,246.55925,39.96717,0,NULL,59856677400,935260584,14613446,14.8),(137559,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137559,35.66,0.16,135,65730,70,NULL,NULL,'KUG 1624+400',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137560,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137560,37.32,0.46,291,65731,70,NULL,NULL,'2MASX J16262088+2807087',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,246.587,28.11922,0.125,NULL,59734118385,933345599,14583524,16.6),(137561,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137561,37.89,0.21,378,65732,70,NULL,NULL,'2MASX J16262153+1336165',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.589625,13.60456,0.165,NULL,56660376090,885318376,13833099,17.6),(137562,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137562,37.55,0.46,323,65733,70,NULL,NULL,'2MASX J16262389+3919247',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000147,NULL,'16.7g',0.28,'S0',NULL,NULL,NULL,NULL,1,246.5995,39.32344,0,NULL,59853075191,935204299,14612567,16.7),(137563,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137563,35.76,0.06,142,65734,70,NULL,NULL,'2MASX J16262604+3917217',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000077,NULL,'16.1g',0.39,'E',NULL,NULL,NULL,NULL,1,246.608667,39.28936,0,NULL,59853076982,935204327,14612567,16.1),(137564,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137564,37.27,0.46,285,65735,70,NULL,NULL,'2MASX J16262674+3714007',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00011,NULL,'16.0g',0.47,'E0',NULL,NULL,NULL,NULL,1,246.611416667,37.23347,0.005,NULL,59747943775,933561621,14586900,16),(137565,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137565,37.85,0.46,372,65736,70,NULL,NULL,'2MASX J16262761+2728409',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.615125,27.47806,0.085,NULL,56179712610,877808009,13715750,17.6),(137566,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137566,37.64,0.46,338,65737,70,NULL,NULL,'2MASX J16262913+1432306',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000145,NULL,'18.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,246.6212917,14.54194,0.153,NULL,56659957008,885311828,13832997,18.7),(137567,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137567,35.76,0.06,142,65738,70,NULL,NULL,'2MASX J16262938+3904557',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000073,NULL,'15.4g',0.43,'E',NULL,NULL,NULL,NULL,1,246.6222917,39.08219,0.005,NULL,59853147383,935205427,14612584,15.4),(137568,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137568,37.89,0.21,378,65739,70,NULL,NULL,'2MASX J16263236+1341486',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000161,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.635,13.697,0.177,NULL,56660373165,885318330,13833098,17.6),(137569,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137569,36.17,0.46,171,65740,70,NULL,NULL,'2MASX J16263270+2252282',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,246.636167,22.87442,0.141,NULL,56654293269,885223332,13831614,16.8),(137570,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137570,37.17,0.46,272,65741,70,NULL,NULL,'2MASX J16263313+0946006',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,246.638083,9.76692,0.201,NULL,56741659854,886588435,13852944,17.1),(137571,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137571,36.66,0.33,215,65742,70,NULL,NULL,'2MASX J16263333+2552569',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000185,NULL,'16.1g',0.35,'AGN',NULL,NULL,NULL,NULL,1,246.639,25.88239,0.089,NULL,56184035869,877875560,13716805,16.1),(137572,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137572,33.35,0.8,46.8,65743,75,NULL,'HMCL, I','ESO 100- G 023',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'16.1',1.1,'SAB(s)c',NULL,NULL,NULL,NULL,1,246.648625,-63.19617,NULL,NULL,44463580838,694743450,10855366,16.1),(137573,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137573,31.71,0.4,22,65743,75,NULL,'HMCL, I, raw','ESO 100- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137574,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137574,31.86,0.4,23.5,65743,75,NULL,'HMCL, I, inv','ESO 100- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137575,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137575,32.08,0.4,26.1,65743,75,NULL,'HMCL, I, cor','ESO 100- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137576,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137576,33.23,0.46,44.3,65743,NULL,NULL,'J','ESO 100- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137577,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137577,33.24,0.47,44.4,65743,NULL,NULL,'H','ESO 100- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137578,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137578,33.26,0.45,45,65743,NULL,NULL,'K','ESO 100- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137579,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137579,33.47,0.4,49.5,65743,NULL,NULL,'mean','ESO 100- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137580,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137580,35.76,0.06,142,65744,70,NULL,NULL,'2MASX J16263702+3910516',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'16.1g',0.39,'S0',NULL,NULL,NULL,NULL,1,246.6542917,39.18111,0,NULL,59853179428,935205928,14612592,16.1),(137581,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137581,35.64,0.08,135,65745,NULL,NULL,NULL,'UGC 10389',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000046,NULL,'15.8g',0.3,'SBb            HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.6545,39.12753,0.005,NULL,59853178693,935205917,14612592,15.8),(137582,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137582,36.14,0.46,169,65746,70,NULL,NULL,'KUG 1624+336A',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000172,NULL,'15.6g',0.48,'Compact',NULL,NULL,NULL,NULL,1,246.656166667,33.52108,0.045,NULL,59791030649,934234853,14597419,15.6),(137583,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137583,38.4,0.46,478,65747,70,NULL,NULL,'SDSS J162639.12+180730.9',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,246.6630417,18.12525,0.161,NULL,56700287766,885941996,13842843,NULL),(137584,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137584,35.11,0.25,105,65748,74.4,NULL,NULL,'CGCG 224-025',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000137,NULL,'14.3g',0.84,'SB?',NULL,NULL,NULL,NULL,1,246.6660417,40.47808,0.013,NULL,59856745751,935261652,14613463,14.3),(137585,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137585,35.29,0.22,114,65748,70,NULL,NULL,'CGCG 224-025',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137586,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137586,37.84,0.46,370,65749,70,NULL,NULL,'2MASX J16263999+4931101',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.666875,49.51942,0.005,NULL,59828754074,934824282,14606629,17.8),(137587,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137587,37.54,0.46,322,65750,70,NULL,NULL,'2MASX J16264075+2746389',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,246.6699583,27.77753,0.109,NULL,59734113435,933345522,14583523,17),(137588,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137588,32.05,0.49,25.8,65751,75,NULL,'IR','ESO 137- G 027',NULL,'2011yCatp016004901K',2011,1,2.6,NULL,'G',0.000025,NULL,'13.96',0.5,'SB(s)dm:;ext.LSB dsk',NULL,NULL,NULL,NULL,1,246.673333,-59.95658,NULL,NULL,44502683180,695354424,10864912,13.96),(137589,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137589,37.73,0.33,351,65752,70,NULL,NULL,'2MASX J16264481+4852310',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000178,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,246.686625,48.87517,0.005,NULL,59842394349,935037411,14609959,16.3),(137590,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137590,37.81,0.46,364,65753,70,NULL,NULL,'2MASX J16264512+1428417',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.6879583,14.47842,0.153,NULL,56659996425,885312444,13833006,17.3),(137591,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137591,35.76,0.06,142,65754,70,NULL,NULL,'III Zw 078',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000133,NULL,'15.4g',0.53,'S0','Group member',NULL,NULL,NULL,1,246.688083,40.68422,0.005,NULL,59856037486,935250585,14613290,15.4),(137592,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137592,37.26,0.46,283,65755,70,NULL,NULL,'2MASX J16264546+2021072',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000195,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,246.689417,20.35214,0.225,NULL,56701625434,885962897,13843170,16.2),(137593,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137593,38,0.46,398,65756,70,NULL,NULL,'2MASX J16264549+0754276',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.6895417,7.90778,0.241,NULL,56748297746,886692152,13854564,17.7),(137594,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137594,36.61,0.46,209,65757,70,NULL,NULL,'2MASX J16264558+2240412',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000178,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,246.68975,22.678,0.137,NULL,56654072945,885219889,13831560,16.4),(137595,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137595,34.46,0.47,77.8,65758,NULL,NULL,'H','UGC 10384',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000017,NULL,'15.00',0.3,'S?',NULL,NULL,NULL,NULL,1,246.6945,11.58028,0.253,NULL,56741232481,886581757,13852839,15),(137596,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137596,34.48,0.4,78.7,65758,NULL,NULL,'mean','UGC 10384',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137597,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137597,34.49,0.49,79.1,65758,75,NULL,'IR','UGC 10384',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137598,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137598,34.56,0.45,81.5,65758,NULL,NULL,'K','UGC 10384',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137599,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137599,34.56,0.2,81.7,65758,74.4,NULL,NULL,'UGC 10384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137600,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137600,34.71,0.46,87.7,65758,NULL,NULL,'J','UGC 10384',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137601,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137601,37.47,0.46,312,65759,70,NULL,NULL,'2MASX J16264676+1324028',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,246.6949583,13.40081,0.165,NULL,56656977539,885265274,13832269,17.9),(137602,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137602,35.98,0.46,157,65760,70,NULL,NULL,'2MASX J16264811+2318342',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000164,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,246.7005,23.30939,0.141,NULL,56654424158,885225377,13831646,16.6),(137603,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137603,37.47,0.27,312,65761,70,NULL,NULL,'2MASX J16264946+4836042',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000195,NULL,'16.5g',0.33,'AGN',NULL,NULL,NULL,NULL,1,246.706,48.60122,0,NULL,59842444354,935038193,14609971,16.5),(137604,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137604,37.27,0.46,284,65762,70,NULL,NULL,'SDSS J162650.05+164405.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.2g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.708583333,16.73475,0.189,NULL,56669556690,885461823,13835340,18.2),(137605,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137605,38.06,0.46,410,65763,70,NULL,NULL,'2MASX J16265127+2716219',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,246.713583,27.27264,0.077,NULL,56179765928,877808842,13715763,18.5),(137606,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137606,36.41,0.59,191,65764,70,NULL,NULL,'2MASX J16265145-6438317',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.7142917,-64.64211,0.817,NULL,44981984938,702843514,10981929,15.1),(137607,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137607,36.66,0.33,215,65765,70,NULL,NULL,'2MASX J16265342+2557529',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00021,NULL,'16.1g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,246.7225417,25.96467,0.085,NULL,56184243514,877878804,13716856,16.1),(137608,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137608,38.26,0.46,448,65766,70,NULL,NULL,'SDSS J162653.45+093202.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.5g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.72275,9.534,0.241,NULL,56755396316,886803067,13856297,18.5),(137609,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137609,37.73,0.33,351,65767,70,NULL,NULL,'2MASX J16265426+4850003',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000162,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,246.7260417,48.83333,0.005,NULL,59842387842,935037310,14609957,18.7),(137610,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137610,38.22,0.46,440,65768,70,NULL,NULL,'2MASX J16265588+2607169',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,246.732917,26.12133,0.085,NULL,56184099405,877876553,13716821,18),(137611,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137611,37.11,0.73,264,65769,70,NULL,NULL,'6dF J1626560-031513',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.733416667,-3.2535,0.649,NULL,45509508569,711086071,11110719,16.2),(137612,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137612,38.21,0.46,438,65770,70,NULL,NULL,'2MASX J16265652+1746208',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,246.7357083,17.77253,0.169,NULL,56668094404,885438975,13834983,16.9),(137613,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137613,36.87,0.19,236,65771,70,NULL,NULL,'2MASX J16265692+1348099',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000191,NULL,'15.7g',0.48,NULL,NULL,NULL,NULL,NULL,1,246.737083,13.80272,0.177,NULL,56660351677,885317994,13833093,15.7),(137614,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137614,37.87,0.46,376,65772,70,NULL,NULL,'2MASX J16265717+1931332',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.738291667,19.52594,0.245,NULL,56701827248,885966050,13843219,17.8),(137615,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137615,35.12,0.47,106,65773,70,NULL,NULL,'2MASX J16265853-6635276',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.17',0.74,NULL,NULL,NULL,NULL,NULL,1,246.7435417,-66.59083,0.613,NULL,44992697847,703010903,10984545,15.17),(137616,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137616,35.2,0.25,110,65774,74.4,NULL,NULL,'2MASX J16265971+3919129',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000053,NULL,'15.6g',0.21,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.749,39.32011,0,NULL,59853230304,935206723,14612605,15.6),(137617,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137617,35.76,0.06,142,65775,70,NULL,NULL,'2MASX J16270075+4048379',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00015,NULL,'15.7g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,246.753291667,40.81053,0.005,NULL,59856088550,935251383,14613302,15.7),(137618,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137618,37.47,0.27,312,65776,70,NULL,NULL,'2MASX J16270090+4829074',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,246.753667,48.48536,0,NULL,59842317973,935036218,14609940,17.2),(137619,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137619,34.26,0.33,71.1,65777,NULL,NULL,'Malmquist cor.','UGC 10388',NULL,'2009ApJS..182..474S',2009,1,1.55,NULL,'G',0.000033,NULL,'14.3g',0.49,'Sa',NULL,NULL,NULL,NULL,1,246.762375,16.38222,0.185,NULL,56673167098,885518235,13836222,14.3),(137620,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137620,34.37,0.4,75,65777,NULL,NULL,'mean','UGC 10388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137621,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137621,34.47,0.3,78.4,65777,NULL,NULL,NULL,'UGC 10388',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137622,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137622,34.51,0.2,79.8,65777,74.4,NULL,NULL,'UGC 10388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137623,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137623,34.66,0.47,85.5,65777,NULL,NULL,'H','UGC 10388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137624,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137624,34.72,0.46,87.8,65777,NULL,NULL,'J','UGC 10388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137625,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137625,34.8,0.45,91.1,65777,NULL,NULL,'K','UGC 10388',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137626,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137626,38.13,0.46,424,65778,70,NULL,NULL,'2MASX J16270333+1916472',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.764041667,19.27986,0.189,NULL,56701832459,885966132,13843220,17.8),(137627,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137627,35.16,0.23,108,65779,74.4,NULL,NULL,'CGCG 224-027',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000022,NULL,'14.7g',0.64,'E',NULL,NULL,NULL,NULL,1,246.765083333,39.52736,0.005,NULL,59853093306,935204582,14612571,14.7),(137628,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137628,35.66,0.16,135,65779,70,NULL,NULL,'CGCG 224-027',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137629,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137629,35.76,0.06,142,65779,70,NULL,NULL,'CGCG 224-027',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137630,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137630,38.47,0.46,494,65780,70,NULL,NULL,'2MASX J16270449+0953324',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.768708333,9.89228,0.241,NULL,56742002625,886593791,13853027,17.8),(137631,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137631,36.87,0.19,236,65781,70,NULL,NULL,'2MASX J16270467+1351469',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.769625,13.86303,0.169,NULL,56660346714,885317917,13833092,16.9),(137632,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137632,38.11,0.46,419,65782,70,NULL,NULL,'SDSS J162706.07+161657.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.3g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.775333,16.28275,0.173,NULL,56673120950,885517514,13836211,18.3),(137633,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137633,36.87,0.19,236,65783,70,NULL,NULL,'2MASX J16270713+1356299',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000178,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,246.7797917,13.9415,0.169,NULL,56660430080,885319220,13833112,16.1),(137634,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137634,38.13,0.46,423,65784,70,NULL,NULL,'SDSS J162707.92+210711.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,246.783041667,21.11992,0.189,NULL,56645224270,885081629,13829400,18.5),(137635,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137635,37.47,0.27,312,65785,70,NULL,NULL,'SDSS J162709.15+483600.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.788167,48.60025,0,NULL,59842398307,935037473,14609960,18.6),(137636,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137636,35.61,0.25,132,65786,74.4,NULL,NULL,'2MASX J16271098+3918186',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000067,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,246.7957083,39.30508,0,NULL,59853230741,935206730,14612605,16.1),(137637,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137637,35.84,0.46,147,65786,70,NULL,NULL,'2MASX J16271098+3918186',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137638,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137638,35.54,0.46,128,65787,70,NULL,NULL,'2MASX J16271202+4841105',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000198,NULL,'14.9g',0.69,'E0',NULL,NULL,NULL,NULL,1,246.800083333,48.68617,0,NULL,59842408276,935037629,14609962,14.9),(137639,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137639,37.13,0.46,267,65788,70,NULL,NULL,'2MASX J16271258+3046411',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,246.802375,30.77819,0.013,NULL,59789069853,934204216,14596940,16.9),(137640,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137640,37.64,0.46,338,65789,70,NULL,NULL,'2MASX J16271354+2407037',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.806375,24.11783,0.125,NULL,56649322124,885145658,13830400,17.7),(137641,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137641,36.87,0.19,236,65790,70,NULL,NULL,'2MASX J16271375+1418392',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.807333,14.31086,0.165,NULL,56658362920,885286920,13832608,16.9),(137642,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137642,34.8,0.2,91.2,65791,74.4,NULL,NULL,'UGC 10387',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000033,NULL,'15.6g',0.49,'SBcd:',NULL,NULL,NULL,NULL,1,246.807375,12.97956,0.205,NULL,56875466919,888679170,13885612,15.6),(137643,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137643,36.87,0.19,236,65792,70,NULL,NULL,'CGCG 080-035',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000183,NULL,'14.9g',0.75,NULL,NULL,NULL,NULL,NULL,1,246.809916667,14.33953,0.165,NULL,56658494222,885288972,13832640,14.9),(137644,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137644,37.7,0.46,346,65793,70,NULL,NULL,'2MASX J16271441+1434562',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00017,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.8102083,14.58236,0.161,NULL,56658090090,885282657,13832541,17),(137645,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137645,35.65,0.46,135,65794,70,NULL,NULL,'2MASX J16271477+1343532',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000183,NULL,'15.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,246.811625,13.73164,0.177,NULL,56660389509,885318586,13833102,15.9),(137646,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137646,35.76,0.06,142,65795,70,NULL,NULL,'2MASX J16271784+3908357',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000087,NULL,'16.0g',0.35,'S',NULL,NULL,NULL,NULL,1,246.8242917,39.14311,0.005,NULL,59853237564,935206836,14612606,16),(137647,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137647,37.11,0.46,264,65796,70,NULL,NULL,'2MASX J16271813+2059572',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000158,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,246.825667,20.99919,0.189,NULL,56645369464,885083897,13829435,17),(137648,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137648,38.17,0.46,431,65797,70,NULL,NULL,'2MASX J16271846+0812462',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.826958333,8.21292,0.233,NULL,56747176481,886674632,13854291,17.9),(137649,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137649,35.42,0.2,121,65798,74.4,NULL,NULL,'CGCG 109-020',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.00008,NULL,'15.7g',0.29,'Sc','Isolated galaxy',NULL,NULL,NULL,1,246.8319583,15.99789,0.181,NULL,56673292004,885520187,13836252,15.7),(137650,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137650,35.28,0.49,114,65799,75,NULL,'IR','UGC 10386',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.000067,NULL,'15.33',0.18,'Sc',NULL,NULL,NULL,NULL,1,246.833,1.92086,0.237,NULL,56440622624,881884728,13779448,15.33),(137651,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137651,35.53,NULL,127,65799,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10386',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137652,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137652,35.55,NULL,129,65799,NULL,NULL,'Dipole + Quadrupole','UGC 10386',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137653,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137653,35.58,NULL,131,65799,NULL,NULL,'Dipole','UGC 10386',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137654,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137654,36.04,0.2,161,65800,74.4,NULL,NULL,'CGCG 138-013',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000157,NULL,'15.3g',0.52,NULL,NULL,NULL,NULL,NULL,1,246.833208333,22.07206,0.129,NULL,56652982341,885202849,13831294,15.3),(137655,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137655,36.64,0.46,212,65801,70,NULL,NULL,'2MASX J16272040+4551140',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000149,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.834917,45.85394,0,NULL,59833761489,934902523,14607851,16.8),(137656,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137656,37.74,0.46,353,65802,70,NULL,NULL,'SDSS J162720.74+214322.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.836416667,21.72289,0.097,NULL,56653434825,885209919,13831404,18.2),(137657,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137657,37.58,0.46,328,65803,70,NULL,NULL,'2MASX J16272140+1512413',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,246.8392083,15.21139,0.149,NULL,56671917720,885498714,13835917,17),(137658,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137658,37.65,0.46,340,65804,70,NULL,NULL,'2MASX J16272170+1336323',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,246.840375,13.60911,0.177,NULL,56660331559,885317680,13833088,17.1),(137659,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137659,35.46,0.25,124,65805,74.4,NULL,NULL,'KUG 1625+392A',NULL,'2013AJ....146...86T',2013,1,0.83,NULL,'G',0.00007,NULL,'14.4g',0.67,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.842083,39.10964,0.005,NULL,59853235031,935206797,14612606,14.4),(137660,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137660,35.66,0.16,135,65805,70,NULL,NULL,'KUG 1625+392A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137661,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137661,35.78,0.05,144,65805,NULL,NULL,NULL,'KUG 1625+392A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137662,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137662,36.93,0.68,244,65806,70,NULL,NULL,'2MASX J16272295-6424497',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,246.845708333,-64.41386,0.841,NULL,44981897466,702842147,10981908,15.7),(137663,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137663,35.81,0.27,145,65807,70,NULL,NULL,'NGC 6159',NULL,'2015arXiv151105856S',2015,1,1.08,NULL,'G',0.000153,NULL,'14.3g',0.81,'S0-:           Sy2',NULL,NULL,NULL,'Sy 2',1,246.855125,42.67972,0.009,NULL,59861063973,935329124,14614517,14.3),(137664,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137664,34.44,NULL,77.2,65808,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2036',NULL,'2010Ap&SS.325..163P',2010,1,0.89,NULL,'G',0.00017,NULL,'16.6g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,246.883917,48.71531,0,NULL,59842413607,935037712,14609964,16.6),(137665,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137665,34.46,NULL,78,65808,NULL,NULL,'Dipole + Quadrupole','FGC 2036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137666,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137666,34.47,NULL,78.3,65808,NULL,NULL,'Dipole','FGC 2036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137667,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137667,34.53,NULL,80.6,65808,NULL,NULL,NULL,'FGC 2036',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137668,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137668,34.88,0.25,94.6,65809,74.4,NULL,NULL,'2MASX J16273232+3934148',NULL,'2013AJ....146...86T',2013,1,0.32,NULL,'G',0.000063,NULL,'15.83',0.32,'S0',NULL,NULL,NULL,NULL,1,246.884541667,39.57067,0.005,NULL,59856539441,935258428,14613412,15.83),(137669,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137669,35.76,0.06,142,65809,70,NULL,NULL,'2MASX J16273232+3934148',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137670,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137670,38.29,0.46,456,65810,70,NULL,NULL,'2MASX J16273291+2055254',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,246.887083,20.92358,0.197,NULL,56645341204,885083456,13829429,18.3),(137671,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137671,36.87,0.19,236,65811,70,NULL,NULL,'2MASX J16273302+1356033',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,246.8875417,13.93422,0.169,NULL,56658266581,885285415,13832584,17.1),(137672,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137672,38.67,0.46,541,65812,70,NULL,NULL,'SDSS J162734.13+135111.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,246.89225,13.85331,0.169,NULL,56658278681,885285604,13832587,18.3),(137673,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137673,37.28,0.46,286,65813,70,NULL,NULL,'2MASX J16273447+4821230',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000126,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,246.8937917,48.35628,0,NULL,59843191821,935049872,14610154,17.6),(137674,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137674,37.56,0.46,325,65814,70,NULL,NULL,'2MASX J16273460+3325139',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000145,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,246.8942917,33.42047,0.045,NULL,59791009918,934234529,14597414,17.1),(137675,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137675,37.01,0.46,252,65815,70,NULL,NULL,'2MASX J16273481+1313153',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,246.895125,13.22097,0.197,NULL,56875321862,888676904,13885576,18.1),(137676,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137676,35.57,0.09,130,65816,NULL,NULL,NULL,'2MASX J16273674+3916098',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000081,NULL,'16.0g',0.36,'SBc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.902875,39.26964,0,NULL,59853227074,935206673,14612604,16),(137677,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137677,35.81,0.27,145,65817,70,NULL,NULL,'CGCG 224-033',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000163,NULL,'15.0g',0.56,'BrClG',NULL,NULL,NULL,NULL,1,246.907083,42.63822,0,NULL,59861062055,935329094,14614517,15),(137678,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137678,35.88,0.4,150,65818,75,NULL,'Edat, raw','NGC 6158',NULL,'1997ApJS..109..333W',1997,1,0.3,NULL,'G',0.000022,NULL,'14.68',0.25,'E/S0','Group member',NULL,NULL,NULL,1,246.920375,39.383,0,NULL,59853225142,935206642,14612603,14.68),(137679,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137679,35.9,0.4,152,65818,75,NULL,'Edat, cor','NGC 6158',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137680,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137680,35.02,0.22,101,65818,74.4,NULL,NULL,'NGC 6158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137681,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137681,35.66,0.16,135,65818,70,NULL,NULL,'NGC 6158',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137682,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137682,35.56,0.4,130,65818,NULL,NULL,'mean','NGC 6158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137683,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137683,35.83,0.45,147,65818,NULL,NULL,'K','NGC 6158',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137684,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137684,34.3,0.4,72.4,65819,75,NULL,'Edat, raw','NGC 6160',NULL,'1997ApJS..109..333W',1997,1,1.58,NULL,'G',0.00007,NULL,'14.0g',0.83,'cD;E','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,246.921375,40.927,0.005,NULL,59856077816,935251215,14613300,14),(137685,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137685,34.63,0.4,84.2,65819,75,NULL,'Edat, cor','NGC 6160',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137686,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137686,35.23,0.22,111,65819,74.4,NULL,NULL,'NGC 6160',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137687,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137687,35.29,0.22,114,65819,70,NULL,NULL,'NGC 6160',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137688,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137688,35.76,0.06,142,65819,70,NULL,NULL,'NGC 6160',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137689,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137689,35.04,0.45,102,65819,NULL,NULL,'K','NGC 6160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137690,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137690,35.65,0.4,135,65819,NULL,NULL,'mean','NGC 6160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137691,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137691,35.76,0.06,142,65820,70,NULL,NULL,'2MASX J16274399+3932348',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000067,NULL,'15.87',0.2,'S0',NULL,NULL,NULL,NULL,1,246.933416667,39.543,0,NULL,59856535653,935258369,14613412,15.87),(137692,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137692,37.2,0.46,276,65821,70,NULL,NULL,'2MASX J16274458+3031339',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,246.9357917,30.52617,0.049,NULL,59786142353,934158474,14596226,17.1),(137693,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'N',137693,20,NULL,0.1,65822,NULL,NULL,NULL,'Her X',NULL,'2009AJ....137..450W',2009,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137694,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137694,35.57,0.46,130,65823,70,NULL,NULL,'2MASX J16274621+2003145',NULL,'2015arXiv151105856S',2015,1,0.35,'RC3 has V = 3720 +- 60 km/s.','G',0.000158,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,246.94275,20.05403,0.233,NULL,56701727147,885964486,13843195,17.1),(137695,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137695,37.29,0.46,287,65824,70,NULL,NULL,'SDSS J162749.83+364921.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,246.957625,36.82261,0.013,NULL,59748861387,933575959,14587124,17.7),(137696,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137696,34.53,0.2,80.5,65825,74.4,NULL,NULL,'UGC 10394',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.0001,NULL,'14.70',0.5,'SA(s)d:',NULL,NULL,NULL,NULL,1,246.959583,-1.76364,0.445,NULL,45502427770,710975433,11108991,14.7),(137697,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137697,34.6,0.48,83.3,65825,NULL,NULL,NULL,'UGC 10394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137698,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137698,34.68,0.46,86.2,65825,NULL,NULL,'Malmquist cor.','UGC 10394',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137699,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137699,35.76,0.06,142,65826,70,NULL,NULL,'2MASX J16275030+4056149',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00007,NULL,'15.6g',0.34,'S0',NULL,NULL,NULL,NULL,1,246.959625,40.93747,0,NULL,59855896583,935248384,14613256,15.6),(137700,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137700,35.76,0.06,142,65827,70,NULL,NULL,'2MASX J16275494+4036219',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000047,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,246.97875,40.60606,0,NULL,59856055178,935250862,14613294,16.3),(137701,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137701,34.75,0.6,89.2,65828,70,NULL,NULL,'2MASX J16275487-6454388',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.84',0.36,NULL,NULL,NULL,NULL,NULL,1,246.979375,-64.91047,0.741,NULL,44993474375,703023037,10984734,16.84),(137702,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137702,35.88,0.4,150,65829,75,NULL,'Edat, raw','CGCG 224-034 NED02',NULL,'1997ApJS..109..333W',1997,1,0.91,NULL,'G',0.000067,NULL,'14.7g',0.63,'E',NULL,NULL,NULL,NULL,1,246.980167,39.25883,0,NULL,59853226353,935206661,14612604,14.7),(137703,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137703,35.9,0.4,152,65829,75,NULL,'Edat, cor','CGCG 224-034 NED02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137704,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137704,35.66,0.16,135,65829,70,NULL,NULL,'CGCG 224-034 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137705,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137705,35.76,0.06,142,65829,70,NULL,NULL,'CGCG 224-034 NED02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137706,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137706,36.91,0.46,241,65830,70,NULL,NULL,'2MASX J16275527+4356540',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,246.980291667,43.94828,0,NULL,59859954865,935311794,14614246,16.3),(137707,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137707,35.88,0.4,150,65831,75,NULL,'Edat, raw','MCG +07-34-044',NULL,'1997ApJS..109..333W',1997,1,0.48,NULL,'G',0.000067,NULL,'15.5g',0.47,'S?',NULL,NULL,NULL,NULL,1,246.983375,39.28139,0,NULL,59853218537,935206539,14612602,15.5),(137708,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137708,35.9,0.4,152,65831,75,NULL,'Edat, cor','MCG +07-34-044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137709,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137709,35.76,0.06,142,65831,70,NULL,NULL,'MCG +07-34-044',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137710,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137710,35.07,0.25,103,65832,74.4,NULL,NULL,'2MASX J16275604+3934059',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.00006,NULL,'15.5g',0.42,'E',NULL,NULL,NULL,NULL,1,246.983333,39.56825,0,NULL,59856601370,935259396,14613428,15.5),(137711,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137711,35.76,0.06,142,65832,70,NULL,NULL,'2MASX J16275604+3934059',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137712,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137712,35.48,0.23,125,65833,74.4,NULL,NULL,'CGCG 224-034',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.00007,NULL,NULL,NULL,'E/S0',NULL,NULL,NULL,NULL,1,246.985,39.25583,0,NULL,59853226331,935206661,14612604,NULL),(137713,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137713,35.85,0.25,148,65834,74.4,NULL,NULL,'CGCG 224-034 NED01',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000067,NULL,'15.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,246.989666667,39.25286,0,NULL,59853226789,935206668,14612604,15.6),(137714,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137714,35.4,0.25,120,65835,74.4,NULL,NULL,'CGCG 224-034 NED01',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000067,NULL,'15.6g',0.3,'S0',NULL,NULL,NULL,NULL,1,246.989666667,39.25286,0,NULL,59853226789,935206668,14612604,15.6),(137715,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137715,37.72,0.46,349,65836,70,NULL,NULL,'2MASX J16275786+2657588',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,246.9912917,26.9665,0.073,NULL,56184343911,877880373,13716880,17.3),(137716,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137716,35.43,0.25,122,65837,74.4,NULL,NULL,'GIN 581',NULL,'2013AJ....146...86T',2013,1,0.54,NULL,'G',0.000063,NULL,'15.4g',0.46,'S0/a',NULL,NULL,NULL,NULL,1,246.9945,39.60394,0,NULL,59856602942,935259420,14613428,15.4),(137717,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137717,35.66,0.16,135,65837,70,NULL,NULL,'GIN 581',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137718,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137718,35.76,0.06,142,65837,70,NULL,NULL,'GIN 581',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137719,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137719,35.73,0.1,140,65838,NULL,NULL,NULL,'2MASX J16275925+4029499',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000093,NULL,'15.3g',0.25,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,246.99675,40.49728,0,NULL,59856008935,935250139,14613283,15.3),(137720,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137720,36.89,0.46,239,65839,70,NULL,NULL,'2MASX J16280147+1932450',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.00625,19.54592,0.225,NULL,56701859171,885966549,13843227,17.8),(137721,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137721,37.75,0.33,355,65840,70,NULL,NULL,'2MASX J16280239+1149167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.0099583,11.82136,0.241,NULL,56744010614,886625165,13853518,17.8),(137722,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137722,37.36,0.46,297,65841,70,NULL,NULL,'2MASX J16280256+2256330',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.010625,22.94253,0.141,NULL,56649628516,885150445,13830475,17.1),(137723,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137723,37.54,0.46,322,65842,70,NULL,NULL,'2MASX J16280310+4355459',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,'FoF','17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.012875,43.92936,0,NULL,59859959303,935311864,14614247,17.3),(137724,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137724,38.32,0.46,461,65843,70,NULL,NULL,'2MASX J16280323+2115260',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000179,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.0135,21.25714,0.173,NULL,56652508989,885195452,13831178,17.9),(137725,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137725,37.52,0.46,320,65844,70,NULL,NULL,'2MASX J16280505+3417520',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.020917,34.29781,0.017,NULL,59779578667,934055916,14594623,17.6),(137726,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137726,34.36,0.2,74.5,65845,74.4,NULL,NULL,'CGCG 138-015',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00006,NULL,'15.5g',0.34,'Sa',NULL,NULL,NULL,NULL,1,247.021667,21.65583,0.129,NULL,56652590161,885196721,13831198,15.5),(137727,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137727,37.75,0.33,355,65846,70,NULL,NULL,'2MASX J16280715+1146487',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.029875,11.78006,0.241,NULL,56744011232,886625175,13853518,17.5),(137728,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137728,35.76,0.06,142,65847,70,NULL,NULL,'SDSS J162807.73+393123.2',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00019,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.0322083,39.52314,0,NULL,59856424563,935256633,14613384,16.4),(137729,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137729,36.52,0.25,201,65848,74.4,NULL,NULL,'2MASX J16280771+3931229',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000087,NULL,'16.80',0.14,'S0',NULL,NULL,NULL,NULL,1,247.0324583,39.52325,0,NULL,59856424563,935256633,14613384,16.8),(137730,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137730,36.92,0.46,242,65849,70,NULL,NULL,'2MASX J16280801+4216599',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00009,NULL,'15.6g',0.51,'E0',NULL,NULL,NULL,NULL,1,247.033417,42.28322,0,NULL,59860668149,935322939,14614420,15.6),(137731,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137731,34.08,0.4,65.4,65850,NULL,NULL,'mean','ESO 452- G 003',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.4R',0.3,'S...',NULL,NULL,NULL,NULL,1,247.036333,-29.09675,1.057,NULL,46250261199,722660331,11291567,14.4),(137732,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137732,34.12,0.47,66.8,65850,NULL,NULL,'H','ESO 452- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137733,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137733,34.16,0.46,68,65850,NULL,NULL,'J','ESO 452- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137734,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137734,34.25,0.45,70.9,65850,NULL,NULL,'K','ESO 452- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137735,'BCG','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137735,35.5,0.35,122,65851,60,NULL,NULL,'ABELL 2197',0.0303,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,247.043583,40.90719,0,NULL,59854129412,935220772,14612824,NULL),(137736,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137736,37.08,0.46,261,65852,70,NULL,NULL,'2MASX J16281067+1706484',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,247.0445417,17.11336,0.205,NULL,56669691898,885463935,13835373,16.3),(137737,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137737,37.67,0.46,341,65853,70,NULL,NULL,'2MASX J16281074+3933389',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.0001,NULL,'16.83',0.22,NULL,NULL,NULL,NULL,NULL,1,247.044625,39.56075,0,NULL,59856423615,935256618,14613384,16.83),(137738,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137738,38.41,0.46,481,65854,70,NULL,NULL,'2MASX J16281104+1235434',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.046,12.59528,0.209,NULL,56875098147,888673408,13885522,17.4),(137739,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137739,37.05,0.46,257,65855,70,NULL,NULL,'2MASX J16281218+1856291',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.0507083,18.94133,0.185,NULL,56700037733,885938089,13842782,17.7),(137740,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137740,35.56,0.04,130,65856,NULL,NULL,NULL,'CGCG 224-036',NULL,'2009ApJS..182..474S',2009,1,0.76,NULL,'G',0.000083,NULL,'15.0g',0.69,'SB','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.058375,40.31386,0,NULL,59856459785,935257184,14613393,15),(137741,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137741,35.63,0.25,134,65857,74.4,NULL,NULL,'2MASX J16281419+3932439',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000067,NULL,'16.8g',0.21,'E',NULL,NULL,NULL,NULL,1,247.059333,39.54558,0,NULL,59856423985,935256624,14613384,16.8),(137742,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137742,37.32,0.46,291,65858,70,NULL,NULL,'2MASX J16281642+0739017',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.0685417,7.6505,0.241,NULL,56748680714,886698136,13854658,17.6),(137743,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137743,35.76,0.06,142,65859,70,NULL,NULL,'2MASX J16281766+4058009',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000083,NULL,'15.7g',0.43,'S0/a','Brightest group member',NULL,NULL,NULL,1,247.0735417,40.96703,0,NULL,59854260947,935222827,14612856,15.7),(137744,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137744,34.42,0.47,76.4,65860,NULL,NULL,'H','UGC 10447',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000203,NULL,'15.20',0.5,'Sb',NULL,NULL,NULL,NULL,1,247.079417,80.35464,0.209,NULL,57141469914,892835467,13950554,15.2),(137745,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137745,34.52,0.45,80.1,65860,NULL,NULL,'K','UGC 10447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137746,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137746,34.68,0.46,86.4,65860,NULL,NULL,'J','UGC 10447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137747,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137747,34.8,0.4,91.3,65860,NULL,NULL,'mean','UGC 10447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137748,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137748,35.14,0.25,107,65861,74.4,NULL,NULL,'2MASX J16281973+3957329',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000067,NULL,'16.0g',0.31,'E/S0',NULL,NULL,NULL,NULL,1,247.082333333,39.95914,0.005,NULL,59856621700,935259714,14613433,16),(137749,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137749,35.76,0.06,142,65861,70,NULL,NULL,'2MASX J16281973+3957329',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137750,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137750,37.76,0.33,356,65862,70,NULL,NULL,'2MASX J16282024+2545562',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000187,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.08425,25.76556,0.085,NULL,56185937666,877905276,13717269,16.6),(137751,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137751,37.98,0.33,395,65863,70,NULL,NULL,'2MASX J16282092+2207251',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.087125,22.12358,0.125,NULL,56652883767,885201308,13831270,18.1),(137752,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137752,37.94,0.46,387,65864,70,NULL,NULL,'2MASX J16282141+4313461',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.089125,43.22958,0,NULL,59860452720,935319573,14614368,17.5),(137753,'BCG','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137753,35.5,0.35,122,65865,60,NULL,'ABELL 2197, BCG','GIN 575',0.0303,'1980ApJ...241..486H',1980,1,0.63,NULL,'G',0.000133,NULL,'15.7g',0.37,'S',NULL,NULL,NULL,NULL,1,247.089833,40.90681,0,NULL,59854259391,935222802,14612856,15.7),(137754,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137754,35.11,0.25,105,65865,74.4,NULL,NULL,'GIN 575',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137755,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137755,35.29,0.22,114,65865,70,NULL,NULL,'GIN 575',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137756,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137756,37.32,0.46,291,65866,70,NULL,NULL,'2MASX J16282190+1707194',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.091333,17.12208,0.205,NULL,56669672331,885463630,13835369,17.9),(137757,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137757,37.98,0.33,395,65867,70,NULL,NULL,'2MASX J16282251+2208221',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.093875,22.13958,0.125,NULL,56652883872,885201310,13831270,17.3),(137758,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137758,37.58,0.46,329,65868,70,NULL,NULL,'2MASX J16282306+4655341',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.0960417,46.92628,0.017,NULL,59840714664,935011166,14609549,16.9),(137759,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137759,37.76,0.33,356,65869,70,NULL,NULL,'SDSS J162823.12+254445.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,247.096375,25.74597,0.085,NULL,56185935410,877905240,13717269,18.6),(137760,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137760,35.88,0.4,150,65870,75,NULL,'Edat, raw','NGC 6166C',NULL,'1997ApJS..109..333W',1997,1,0.67,NULL,'G',0.000033,NULL,'15.1g',0.62,'E',NULL,NULL,NULL,NULL,1,247.097125,39.57031,0,NULL,59856436355,935256818,14613387,15.1),(137761,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137761,35.9,0.4,152,65870,75,NULL,'Edat, cor','NGC 6166C',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137762,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137762,35.5,0.22,126,65870,74.4,NULL,NULL,'NGC 6166C',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137763,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137763,35.66,0.16,135,65870,70,NULL,NULL,'NGC 6166C',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137764,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137764,35.76,0.06,142,65870,70,NULL,NULL,'NGC 6166C',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137765,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137765,36.38,0.25,189,65871,74.4,NULL,NULL,'MCG +07-34-049',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.000067,NULL,'15.74',0.15,'E/S0',NULL,NULL,NULL,NULL,1,247.0982917,39.60539,0,NULL,59856430485,935256726,14613386,15.74),(137766,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137766,35.23,0.25,111,65872,74.4,NULL,NULL,'2MASX J16282464+3944278',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000067,NULL,'15.8g',0.25,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.1027917,39.74106,0,NULL,59856634680,935259916,14613436,15.8),(137767,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137767,35.76,0.06,142,65873,70,NULL,NULL,'2MASX J16282511+4051298',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00008,NULL,'15.4g',0.33,'S0',NULL,NULL,NULL,NULL,1,247.1047083,40.85822,0,NULL,59854141402,935220959,14612827,15.4),(137768,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137768,36.64,0.33,213,65874,70,NULL,NULL,'2MASX J16282525+1140561',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.105125,11.68239,0.241,NULL,56743996425,886624944,13853514,17.2),(137769,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137769,38.22,0.46,441,65875,70,NULL,NULL,'2MASX J16282657+4922151',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,247.110583333,49.37094,0,NULL,59829583981,934837249,14606832,18.2),(137770,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137770,37.38,0.46,299,65876,70,NULL,NULL,'2MASX J16282696+2242317',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.112458333,22.70889,0.141,NULL,56651417765,885178402,13830912,17.7),(137771,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137771,35.1,0.25,105,65877,74.4,NULL,NULL,'CGCG 224-037 NED02',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000083,NULL,'15.2g',0.5,'S0',NULL,NULL,NULL,NULL,1,247.114833,41.161,0,NULL,59854081801,935220028,14612812,15.2),(137772,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137772,35.29,0.22,114,65877,70,NULL,NULL,'CGCG 224-037 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137773,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137773,36.57,0.46,206,65878,70,NULL,NULL,'2MASX J16282976+1310004',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,247.123916667,13.16689,0.177,NULL,56878277053,888723078,13886298,16.2),(137774,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137774,36.19,0.25,173,65879,74.4,NULL,NULL,'NGC 6166A NED01',NULL,'2013AJ....146...86T',2013,1,0.48,NULL,'G',0.000067,NULL,'15.30',0.19,'S0',NULL,NULL,NULL,NULL,1,247.1294583,39.52111,0,NULL,59856435677,935256807,14613387,15.3),(137775,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137775,36.19,0.25,173,65880,74.4,NULL,NULL,'2MASX J16283115+3943409',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000067,NULL,'16.2g',0.23,'S0',NULL,NULL,NULL,NULL,1,247.129917,39.72797,0,NULL,59856633950,935259905,14613436,16.2),(137776,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137776,38.27,0.46,451,65881,70,NULL,NULL,'2MASX J16283228+0800531',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.134625,8.01486,0.269,NULL,56748825031,886700391,13854693,18.2),(137777,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137777,35.88,0.4,150,65882,75,NULL,'Edat, raw','MCG +07-34-054',NULL,'1997ApJS..109..333W',1997,1,0.31,NULL,'G',0.000053,NULL,'16.6g',0.19,'E',NULL,NULL,NULL,NULL,1,247.141458333,39.54889,0,NULL,59856433811,935256778,14613387,16.6),(137778,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137778,35.9,0.4,152,65882,75,NULL,'Edat, cor','MCG +07-34-054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137779,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137779,35.6,0.25,132,65882,74.4,NULL,NULL,'MCG +07-34-054',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137780,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137780,35.76,0.06,142,65883,70,NULL,NULL,'2MASX J16283508+3929349',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.146166667,39.49303,0,NULL,59856427818,935256684,14613385,17),(137781,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137781,35.88,0.4,150,65884,75,NULL,'Edat, raw','PGC 058257',NULL,'1997ApJS..109..333W',1997,1,0.28,NULL,'G',0.000143,NULL,'17.56',0.21,'E',NULL,NULL,NULL,NULL,1,247.149375,39.55358,0,NULL,59856433863,935256779,14613387,17.56),(137782,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137782,35.9,0.4,152,65884,75,NULL,'Edat, cor','PGC 058257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137783,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137783,35.84,0.25,147,65884,74.4,NULL,NULL,'PGC 058257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137784,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137784,35.88,0.4,150,65885,75,NULL,'Edat, raw','MCG +07-34-055',NULL,'1997ApJS..109..333W',1997,1,0.33,NULL,'G',0.00011,NULL,'15.9g',0.31,'E',NULL,NULL,NULL,NULL,1,247.15025,39.53375,0,NULL,59856426249,935256660,14613385,15.9),(137785,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137785,35.9,0.4,152,65885,75,NULL,'Edat, cor','MCG +07-34-055',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137786,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137786,36.17,0.23,171,65885,74.4,NULL,NULL,'MCG +07-34-055',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137787,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137787,37.12,0.46,266,65886,70,NULL,NULL,'2MASX J16283615+4041079',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,247.150708333,40.6855,0,NULL,59854151529,935221117,14612829,16.5),(137788,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137788,36.52,0.33,201,65887,70,NULL,NULL,'2MASX J16283693+1637124',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.1540417,16.62011,0.225,NULL,56669572347,885462067,13835344,17.2),(137789,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137789,36.72,0.46,221,65888,70,NULL,NULL,'2MASX J16283713+1625144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.154833,16.42072,0.205,NULL,56673186181,885518534,13836227,17.4),(137790,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137790,35.09,0.25,104,65889,74.4,NULL,NULL,'ARK 505',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000043,NULL,'15.4g',0.51,'E/S0',NULL,NULL,NULL,NULL,1,247.158,41.16394,0,NULL,59854070381,935219849,14612810,15.4),(137791,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137791,35.29,0.22,114,65889,70,NULL,NULL,'ARK 505',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137792,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137792,35.76,0.06,142,65889,70,NULL,NULL,'ARK 505',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137793,'BCG','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137793,35.42,0.35,118,65890,60,NULL,NULL,'ABELL 2199',0.0312,'1980ApJ...241..486H',1980,1,NULL,'Position for NGC 6166 adopted for ABELL 2199.','GClstr',0.00023,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,247.158333,39.54861,0,NULL,59856433771,935256777,14613387,NULL),(137794,'BCG','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137794,35.42,0.35,118,65891,60,NULL,'ABELL 2199, BCG','NGC 6166',0.0312,'1980ApJ...241..486H',1980,1,1.9,NULL,'G',0.00003,NULL,'12.78',1.4,'cD;E;NLRG      LEG','Possible field galaxy',NULL,'FR I','USS',1,247.160333333,39.55156,0,NULL,59856433789,935256777,14613387,12.78),(137795,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137795,35.5,0.12,126,65891,72,NULL,'ABELL 2199, 13 galaxies','NGC 6166',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137796,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137796,35.57,0.08,130,65891,70,NULL,'ABELL 2199','NGC 6166',NULL,'1997MNRAS.287..899L',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137797,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137797,35.88,0.4,150,65891,75,NULL,'Edat, raw','NGC 6166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137798,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137798,35.9,0.4,152,65891,75,NULL,'Edat, cor','NGC 6166',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137799,'Faber-Jackson','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137799,33.96,0.34,61.9,65891,95,NULL,'Weighted Mean','NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137800,'Faber-Jackson','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137800,34.12,0.55,66.7,65891,95,NULL,'de Vaucouleurs','NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137801,'Faber-Jackson','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137801,34.2,0.46,69.2,65891,95,NULL,'Michard 1979a','NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137802,'Faber-Jackson','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137802,34.71,0.63,87.5,65891,95,NULL,'Michard 1979b, c','NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137803,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137803,35.47,0.07,124,65891,75,NULL,'ABELL 2199, 36 galaxies','NGC 6166',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137804,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137804,35.47,0.07,124,65891,75,NULL,'ABELL 2199 Cluster, 36 galaxies','NGC 6166',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137805,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137805,35.48,0.23,125,65891,74.4,NULL,NULL,'NGC 6166',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137806,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137806,35.65,0.07,135,65891,75,NULL,'ABELL 2199 Cluster, 35 galaxies','NGC 6166',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137807,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137807,35.66,0.16,135,65891,70,NULL,NULL,'NGC 6166',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137808,'Tertiary','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137808,34.77,0.5,89.9,65891,95,NULL,NULL,'NGC 6166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137809,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137809,35.12,0.45,106,65891,NULL,NULL,'K','NGC 6166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137810,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137810,35.55,0.4,129,65891,NULL,NULL,'mean','NGC 6166',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137811,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137811,35.76,0.06,142,65892,70,NULL,NULL,'NGC 6166 NED03',NULL,'2015arXiv151105856S',2015,1,1.23,'Designation as \\\"Component B\\\" from 1961AJ.....66..558M.','G',0.00008,NULL,'14.5',0.84,'E0','Triplet member at center of cluster',NULL,NULL,NULL,1,247.163083,39.55283,0,NULL,59856433786,935256777,14613387,14.5),(137812,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137812,35.76,0.06,142,65893,70,NULL,NULL,'CGCG 224-042',NULL,'2015arXiv151105856S',2015,1,0.84,NULL,'G',0.000077,NULL,'15.2g',0.39,'E','Group member',NULL,NULL,NULL,1,247.164916667,41.11106,0,NULL,59854266392,935222912,14612858,15.2),(137813,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137813,36.83,0.46,233,65894,70,NULL,NULL,'2MASX J16284057+3105347',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,247.16925,31.09292,0.005,NULL,59789141291,934205332,14596958,16.3),(137814,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137814,37.8,0.46,363,65895,70,NULL,NULL,'2MASX J16284090+2329398',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.1705,23.4945,0.129,NULL,56650298975,885160921,13830639,17.3),(137815,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137815,37.06,0.46,258,65896,70,NULL,NULL,'2MASX J16284165+1509597',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.173625,15.16664,0.141,NULL,56671970570,885499540,13835930,17.2),(137816,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137816,35.1,0.25,105,65897,74.4,NULL,NULL,'CGCG 224-043',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000067,NULL,'15.1g',0.51,'E','Group member',NULL,NULL,NULL,1,247.173583,41.137,0,NULL,59854069978,935219843,14612810,15.1),(137817,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137817,35.29,0.22,114,65897,70,NULL,NULL,'CGCG 224-043',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137818,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137818,35.76,0.06,142,65897,70,NULL,NULL,'CGCG 224-043',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137819,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137819,37.55,0.33,324,65898,70,NULL,NULL,'2MASX J16284192+2446279',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000185,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.174625,24.77439,0.097,NULL,56184923383,877889427,13717022,16.8),(137820,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137820,36.43,0.33,193,65899,70,NULL,NULL,'2MASX J16284203+1537467',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000172,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,247.175167,15.62969,0.173,NULL,56672052085,885500813,13835950,16.2),(137821,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137821,36.62,0.46,211,65900,70,NULL,NULL,'2MASX J16284271+1452047',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.177833,14.86808,0.153,NULL,56658138223,885283409,13832553,17),(137822,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137822,36.3,0.19,182,65901,70,NULL,NULL,'CGCG 138-018 NED01',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000179,NULL,'16.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.180167,25.49747,0.085,NULL,56185468718,877897948,13717155,16.4),(137823,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137823,37.6,0.46,332,65902,70,NULL,NULL,'SDSS J162844.44+312844.2',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.185166667,31.47894,0.005,NULL,59789565324,934211958,14597061,17.1),(137824,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137824,35.33,0.25,116,65903,74.4,NULL,NULL,'MCG +07-34-065',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.00007,NULL,'16.6g',0.21,'S0',NULL,NULL,NULL,NULL,1,247.185375,39.48458,0,NULL,59856428406,935256693,14613385,16.6),(137825,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137825,35.88,0.4,150,65904,75,NULL,'Edat, raw','I Zw 153 NOTES01',NULL,'1997ApJS..109..333W',1997,1,0.35,NULL,'G',0.000067,NULL,'15.9g',0.3,'E',NULL,NULL,NULL,NULL,1,247.18525,39.5155,0,NULL,59856428875,935256701,14613385,15.9),(137826,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137826,35.9,0.4,152,65904,75,NULL,'Edat, cor','I Zw 153 NOTES01',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137827,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137827,35.76,0.06,142,65904,70,NULL,NULL,'I Zw 153 NOTES01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137828,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137828,36.41,0.25,191,65904,74.4,NULL,NULL,'I Zw 153 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137829,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137829,36.05,0.25,162,65905,74.4,NULL,NULL,'MCG +07-34-068',NULL,'2013AJ....146...86T',2013,1,0.15,NULL,'G',NULL,NULL,'16.5',0.15,NULL,NULL,NULL,NULL,NULL,1,247.1855,39.63892,0,NULL,59856438822,935256856,14613388,16.5),(137830,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137830,35.76,0.06,142,65906,70,NULL,NULL,'MCG +07-34-067',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000067,NULL,'15.6g',0.41,'S0',NULL,NULL,NULL,NULL,1,247.1877917,39.43708,0,NULL,59853005579,935203212,14612550,15.6),(137831,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137831,36.03,0.25,161,65906,74.4,NULL,NULL,'MCG +07-34-067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137832,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137832,35.88,0.4,150,65907,75,NULL,'Edat, raw','I Zw 153 NOTES02',NULL,'1997ApJS..109..333W',1997,1,0.3,NULL,'G',0.000057,NULL,'16.3g',0.27,'E',NULL,NULL,NULL,NULL,1,247.1902083,39.52767,0,NULL,59856426808,935256668,14613385,16.3),(137833,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137833,35.9,0.4,152,65907,75,NULL,'Edat, cor','I Zw 153 NOTES02',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137834,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137834,35.76,0.06,142,65907,70,NULL,NULL,'I Zw 153 NOTES02',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137835,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137835,35.79,0.23,144,65907,74.4,NULL,NULL,'I Zw 153 NOTES02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137836,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137836,35.76,0.06,142,65908,70,NULL,NULL,'MCG +07-34-071',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000057,NULL,'16.4g',0.27,'E',NULL,NULL,NULL,NULL,1,247.191333333,39.60978,0,NULL,59856439118,935256861,14613388,16.4),(137837,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137837,36.3,0.19,182,65909,70,NULL,NULL,'CGCG 138-018 NED02',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000113,NULL,'15.2g',0.63,NULL,NULL,NULL,NULL,NULL,1,247.1922083,25.49469,0.085,NULL,56185468810,877897950,13717155,15.2),(137838,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137838,35.49,0.46,126,65910,70,NULL,NULL,'2MASX J16284853+0850267',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,247.202166667,8.84094,0.217,NULL,56747600749,886681261,13854394,16.2),(137839,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137839,35.76,0.06,142,65911,70,NULL,NULL,'MCG +07-34-074',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000028,NULL,'16.3g',0.22,'E',NULL,NULL,NULL,NULL,1,247.2057917,39.61578,0,NULL,59856439281,935256863,14613388,16.3),(137840,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137840,35.94,0.23,154,65911,74.4,NULL,NULL,'MCG +07-34-074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137841,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137841,38.24,0.46,444,65912,70,NULL,NULL,'2MASX J16284984+4657259',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.207667,46.95722,0.017,NULL,59840699938,935010936,14609545,17.4),(137842,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137842,35.47,0.25,124,65913,74.4,NULL,NULL,'KUG 1627+399',NULL,'2013AJ....146...86T',2013,1,0.67,NULL,'G',0.00007,NULL,'14.9g',0.56,'S?',NULL,NULL,NULL,NULL,1,247.209125,39.83508,0.005,NULL,59856631612,935259868,14613435,14.9),(137843,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137843,35.66,0.16,135,65913,70,NULL,NULL,'KUG 1627+399',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137844,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137844,37.28,0.46,286,65914,70,NULL,NULL,'2MASX J16285027+2923129',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.209583,29.38683,0.029,NULL,59731871426,933310491,14582976,17.2),(137845,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137845,37.1,0.46,263,65915,70,NULL,NULL,'2MASX J16285048+2712279',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.2105,27.20769,0.105,NULL,56179989207,877812331,13715817,17.2),(137846,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137846,37.91,0.46,381,65916,70,NULL,NULL,'2MASX J16285057+4650329',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.210625,46.84239,0.017,NULL,59840710420,935011100,14609548,18),(137847,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137847,38.26,0.46,448,65917,70,NULL,NULL,'2MASX J16285199+3747489',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.216583333,37.79686,0,NULL,59820086807,934688856,14604513,17.8),(137848,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137848,36.3,0.19,182,65918,70,NULL,NULL,'2MASX J16285225+2535519',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,247.21775,25.59781,0.085,NULL,56185916137,877904939,13717264,16.3),(137849,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137849,37.02,0.46,254,65919,70,NULL,NULL,'2MASX J16285246+2343259',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.218625,23.72375,0.125,NULL,56650268935,885160452,13830632,17.9),(137850,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137850,35.09,0.25,104,65920,74.4,NULL,NULL,'III Zw 079',NULL,'2013AJ....146...86T',2013,1,0.66,NULL,'G',0.000053,NULL,'15.4g',0.56,'S',NULL,NULL,NULL,NULL,1,247.225625,40.86661,0,NULL,59854135685,935220870,14612826,15.4),(137851,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137851,35.29,0.22,114,65920,70,NULL,NULL,'III Zw 079',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137852,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137852,35.76,0.06,142,65920,70,NULL,NULL,'III Zw 079',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137853,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137853,37.55,0.33,324,65921,70,NULL,NULL,'SDSS J162854.70+244050.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000169,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.2279583,24.68078,0.097,NULL,56184920333,877889380,13717021,18.3),(137854,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137854,34.51,0.49,79.9,65922,75,NULL,'IR','UGC 10425',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000043,NULL,'15.27',0.3,'Sb',NULL,NULL,NULL,NULL,1,247.234417,64.20694,0.009,NULL,57815472886,903366763,14115105,15.27),(137855,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137855,36.14,0.67,169,65923,70,NULL,NULL,'2MASX J16285641-1813167',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.235,-18.22125,0.969,NULL,45959215647,718112744,11220511,16.5),(137856,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137856,35.88,0.4,150,65924,75,NULL,'Edat, raw','2MASX J16285724+3942299',NULL,'1997ApJS..109..333W',1997,1,0.37,NULL,'G',0.000073,NULL,'15.9g',0.34,'E',NULL,NULL,NULL,NULL,1,247.2385417,39.70828,0,NULL,59856412273,935256441,14613381,15.9),(137857,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137857,35.9,0.4,152,65924,75,NULL,'Edat, cor','2MASX J16285724+3942299',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137858,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137858,35.73,0.23,140,65924,74.4,NULL,NULL,'2MASX J16285724+3942299',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137859,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137859,35.76,0.06,142,65924,70,NULL,NULL,'2MASX J16285724+3942299',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137860,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137860,37.52,0.33,319,65925,70,NULL,NULL,'2MASX J16285802+1439047',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.241875,14.65119,0.153,NULL,56658718132,885292470,13832694,17.7),(137861,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137861,35.81,0.27,145,65926,70,NULL,NULL,'III Zw 081',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000087,NULL,'16.2g',0.28,'AGN',NULL,NULL,NULL,NULL,1,247.243333,42.82811,0,NULL,59861024291,935328504,14614507,16.2),(137862,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137862,35.77,NULL,143,65927,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2039',NULL,'2010Ap&SS.325..163P',2010,1,1.05,NULL,'G',0.00004,NULL,'16.4g',0.17,'Sb(f)',NULL,NULL,NULL,NULL,1,247.2454583,42.41967,0,NULL,59860960406,935327506,14614492,16.4),(137863,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137863,35.79,NULL,144,65927,NULL,NULL,'Dipole + Quadrupole','FGC 2039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137864,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137864,35.81,NULL,145,65927,NULL,NULL,NULL,'FGC 2039',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137865,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137865,35.81,NULL,145,65927,NULL,NULL,'Dipole','FGC 2039',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137866,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137866,36.06,0.49,163,65927,75,NULL,'IR','FGC 2039',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137867,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137867,36.52,0.33,201,65928,70,NULL,NULL,'2MASX J16285955+1635017',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.2482083,16.58369,0.225,NULL,56669896967,885467140,13835424,17.2),(137868,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137868,35.88,0.4,150,65929,75,NULL,'Edat, raw','2MASX J16285980+3941015',NULL,'1997ApJS..109..333W',1997,1,0.5,NULL,'G',0.000053,NULL,'15.9g',0.29,'E',NULL,NULL,NULL,NULL,1,247.249041667,39.68386,0,NULL,59856410222,935256409,14613381,15.9),(137869,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137869,35.9,0.4,152,65929,75,NULL,'Edat, cor','2MASX J16285980+3941015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137870,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137870,35.75,0.25,141,65929,74.4,NULL,NULL,'2MASX J16285980+3941015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137871,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137871,35.76,0.06,142,65929,70,NULL,NULL,'2MASX J16285980+3941015',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137872,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137872,36.23,0.46,176,65930,70,NULL,NULL,'2MASX J16290206+2942188',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.1g',0.4,'S0',NULL,NULL,NULL,NULL,1,247.258541667,29.70511,0.037,NULL,59731439679,933303744,14582871,16.1),(137873,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137873,39.32,0.46,731,65931,70,NULL,NULL,'SDSS J162902.24+101254.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.5g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.259375,10.21508,0.265,NULL,56755800913,886809389,13856396,18.5),(137874,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137874,37.94,0.46,387,65932,70,NULL,NULL,'2MASX J16290267+1150317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.2610417,11.84206,0.221,NULL,56742962997,886608796,13853262,17.6),(137875,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137875,38.21,0.46,439,65933,70,NULL,NULL,'2MASX J16290266+4351190',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000096,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.2612917,43.85542,0,NULL,59860051556,935313305,14614270,17),(137876,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137876,38.59,0.46,522,65934,70,NULL,NULL,'2MASX J16290338+2357593',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.264125,23.96658,0.129,NULL,56649499051,885148422,13830444,18.1),(137877,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137877,36.3,0.19,182,65935,70,NULL,NULL,'UGC 10410',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000167,NULL,'15.0g',0.56,'E:',NULL,NULL,NULL,NULL,1,247.264708333,25.71339,0.085,NULL,56186774007,877918343,13717474,15),(137878,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137878,38.15,0.46,426,65936,70,NULL,NULL,'2MASX J16290557+2632341',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.27325,26.54286,0.089,NULL,56184427534,877881680,13716901,17.3),(137879,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137879,37.78,0.46,359,65937,70,NULL,NULL,'2MASX J16290627+1350527',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000178,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.276083333,13.84806,0.165,NULL,56877349290,888708582,13886071,17.1),(137880,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137880,34.79,0.25,90.8,65938,74.4,NULL,NULL,'MCG +07-34-079',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000053,NULL,'15.9g',0.43,'Elliptical',NULL,NULL,NULL,NULL,1,247.279958333,39.49572,0,NULL,59856441617,935256900,14613389,15.9),(137881,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137881,35.76,0.06,142,65938,70,NULL,NULL,'MCG +07-34-079',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137882,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137882,35.67,0.07,136,65939,NULL,NULL,NULL,'2MASX J16290785+4039536',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000107,NULL,'15.7g',0.36,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.282625,40.66503,0,NULL,59854154998,935221171,14612830,15.7),(137883,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137883,36.64,0.33,213,65940,70,NULL,NULL,'2MASX J16290893+1144477',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',NULL,NULL,'16.82',0.56,'AGN',NULL,NULL,NULL,NULL,1,247.28725,11.74661,0.221,NULL,56742935474,886608366,13853255,16.82),(137884,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137884,37.91,0.46,382,65941,70,NULL,NULL,'2MASX J16290897+4325450',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.287667,43.42933,0,NULL,59859801999,935309406,14614209,16.7),(137885,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137885,36.43,0.33,193,65942,70,NULL,NULL,'2MASX J16290912+1547283',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000153,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.2877917,15.79119,0.193,NULL,56672453358,885507083,13836048,17.2),(137886,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137886,37.95,0.46,389,65943,70,NULL,NULL,'2MASX J16290921+2552141',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.288375,25.87058,0.085,NULL,56186813623,877918962,13717483,17.1),(137887,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137887,35.11,0.25,105,65944,74.4,NULL,NULL,'GIN 578',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00008,NULL,'15.2g',0.66,'E/S0',NULL,NULL,NULL,NULL,1,247.2889583,40.98761,0,NULL,59854289250,935223269,14612863,15.2),(137888,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137888,35.29,0.22,114,65944,70,NULL,NULL,'GIN 578',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137889,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137889,35.76,0.06,142,65944,70,NULL,NULL,'GIN 578',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137890,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137890,38.58,0.46,520,65945,70,NULL,NULL,'2MASX J16291071+1248023',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.294667,12.80067,0.189,NULL,56878720774,888730012,13886406,17.2),(137891,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137891,35.72,0.08,140,65946,NULL,NULL,NULL,'MCG +07-34-081',NULL,'2009ApJS..182..474S',2009,1,1.05,NULL,'G',0.00017,NULL,'15.3g',0.37,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.296167,40.85742,0,NULL,59854233704,935222401,14612850,15.3),(137892,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137892,36.42,0.71,193,65947,70,NULL,NULL,'2MASX J16291180-1806279',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.299125,-18.10778,1.013,NULL,45959186180,718112284,11220504,15),(137893,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137893,38.08,0.46,413,65948,70,NULL,NULL,'2MASX J16291267+2616582',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.302875,26.28289,0.085,NULL,56186442434,877913163,13717393,17.9),(137894,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137894,37.85,0.46,371,65949,70,NULL,NULL,'2MASX J16291292+2852131',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.3040417,28.87031,0.037,NULL,59734507657,933351682,14583620,17.1),(137895,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137895,36.78,0.59,227,65950,70,NULL,NULL,'FAIRALL 1423',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.2R',0.42,NULL,NULL,NULL,NULL,NULL,1,247.3055417,-67.42886,0.505,NULL,45022926532,703483227,10991925,14.2),(137896,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137896,37.82,0.46,367,65951,70,NULL,NULL,'2MASX J16291368+0952577',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.3069583,9.88269,0.241,NULL,56755930706,886811417,13856428,17),(137897,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137897,37.94,0.46,388,65952,70,NULL,NULL,'2MASX J16291380+4207070',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.307417,42.11861,0,NULL,59860709977,935323593,14614431,17.2),(137898,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137898,35.8,0.49,145,65953,75,NULL,'IR','UGC 10406',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000043,NULL,'15.10',0.4,'Sbc',NULL,NULL,NULL,NULL,1,247.319166667,3.11553,0.257,NULL,56720643206,886260050,13847813,15.1),(137899,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137899,35.8,0.38,145,65953,NULL,NULL,'Malmquist cor.','UGC 10406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137900,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137900,35.93,0.4,154,65953,NULL,NULL,'mean','UGC 10406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137901,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137901,35.97,0.47,156,65953,NULL,NULL,'H','UGC 10406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137902,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137902,35.99,0.45,158,65953,NULL,NULL,'K','UGC 10406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137903,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137903,36.2,0.46,174,65953,NULL,NULL,'J','UGC 10406',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137904,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137904,36.21,0.2,175,65953,74.4,NULL,NULL,'UGC 10406',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137905,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137905,36.25,0.31,178,65953,NULL,NULL,NULL,'UGC 10406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137906,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137906,36.13,0.46,168,65954,70,NULL,NULL,'2MASX J16291775+2528282',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.323875,25.47458,0.085,NULL,56185133214,877892706,13717073,17.2),(137907,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137907,37.76,0.46,356,65955,70,NULL,NULL,'2MASX J16291827+2758002',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.326375,27.96672,0.121,NULL,56180329110,877817642,13715900,18.3),(137908,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137908,37.6,0.33,331,65956,70,NULL,NULL,'2MASX J16291846+1944593',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.327,19.74997,0.209,NULL,56701275289,885957426,13843084,17.4),(137909,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137909,38.44,0.46,488,65957,70,NULL,NULL,'2MASX J16291947+3500344',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,247.33125,35.00947,0.013,NULL,59749815263,933590863,14587357,18.4),(137910,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137910,36.52,0.46,201,65958,70,NULL,NULL,'2MASX J16291968+4351480',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000104,NULL,'15.3g',0.54,'E0',NULL,NULL,NULL,NULL,1,247.331875,43.86339,0,NULL,59860052482,935313320,14614270,15.3),(137911,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137911,37.6,0.33,331,65959,70,NULL,NULL,'2MASX J16292017+1948213',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.3340417,19.80594,0.209,NULL,56701243666,885956932,13843077,17.3),(137912,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137912,37.52,0.33,319,65960,70,NULL,NULL,'2MASX J16292019+1442593',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00019,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.334125,14.71658,0.153,NULL,56658666066,885291657,13832682,17.1),(137913,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137913,37.85,0.46,372,65961,70,NULL,NULL,'2MASX J16292047+2632122',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000179,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.335333,26.53667,0.089,NULL,56184431913,877881748,13716902,18.3),(137914,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137914,35.08,0.25,104,65962,74.4,NULL,NULL,'III Zw 082',NULL,'2013AJ....146...86T',2013,1,0.74,NULL,'G',0.00008,NULL,'15.0g',0.62,'E/S0','Group member',NULL,NULL,NULL,1,247.349125,40.87494,0,NULL,59854237491,935222460,14612850,15),(137915,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137915,35.29,0.22,114,65962,70,NULL,NULL,'III Zw 082',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137916,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137916,35.76,0.06,142,65962,70,NULL,NULL,'III Zw 082',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137917,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137917,36.43,0.57,193,65963,70,NULL,NULL,'2MASX J16292425-6719321',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.351,-67.32564,0.505,NULL,45022924722,703483198,10991924,15.3),(137918,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137918,37.21,0.46,277,65964,70,NULL,NULL,'2MASX J16292467+2452082',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.352875,24.86894,0.109,NULL,56185730280,877902035,13717219,17.1),(137919,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137919,37.55,0.57,323,65965,70,NULL,NULL,'2MASX J16292570-6435418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.357,-64.59497,0.777,NULL,44982035772,702844308,10981942,16),(137920,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137920,33.16,0.8,42.9,65966,75,NULL,'CF, r','UGC 10413',NULL,'1997ApJS..109..333W',1997,1,2.04,NULL,'G',0.000003,NULL,'14.6g',0.61,'Scd:',NULL,NULL,NULL,NULL,1,247.3630417,21.33658,0.137,NULL,56650428483,885162945,13830671,14.6),(137921,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137921,32.99,0.38,39.7,65966,75,NULL,'CF, r, raw','UGC 10413',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137922,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137922,33.02,0.38,40.3,65966,75,NULL,'CF, r, inv','UGC 10413',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137923,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137923,33.3,0.38,45.7,65966,75,NULL,'CF, r, cor','UGC 10413',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137924,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137924,33.3,0.2,45.7,65966,74.4,NULL,NULL,'UGC 10413',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137925,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137925,33.34,0.5,46.5,65966,NULL,NULL,'Malmquist cor.','UGC 10413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137926,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137926,33.38,0.43,47.5,65966,75,NULL,'3.6 micron, color corrected','UGC 10413',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137927,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137927,33.43,0.48,48.5,65966,NULL,NULL,NULL,'UGC 10413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137928,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137928,33.48,0.43,49.6,65966,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10413',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137929,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137929,36.72,0.46,221,65967,70,NULL,NULL,'2MASX J16292793+2635552',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,247.3662917,26.59867,0.089,NULL,56184423839,877881622,13716900,16.6),(137930,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137930,37.6,0.46,331,65968,70,NULL,NULL,'SDSS J162928.76+320434.6',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00017,NULL,'17.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,247.369875,32.07628,0.029,NULL,59787317340,934176833,14596513,17.8),(137931,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137931,35.76,0.06,142,65969,70,NULL,NULL,'2MASX J16292913+3848438',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000117,NULL,'16.1g',0.36,'SB',NULL,NULL,NULL,NULL,1,247.3714583,38.81217,0,NULL,59819948909,934686701,14604479,16.1),(137932,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137932,38.22,0.46,441,65970,70,NULL,NULL,'SDSS J162929.65+400328.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.3735417,40.05778,0.005,NULL,59854454485,935225851,14612903,17.9),(137933,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137933,36.29,0.46,181,65971,70,NULL,NULL,'2MASX J16293053+1305003',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000183,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,247.377375,13.08342,0.177,NULL,56878908667,888732947,13886452,16.1),(137934,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137934,38.98,0.46,626,65972,70,NULL,NULL,'2MASX J16293067+1940434',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00018,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.37775,19.67875,0.209,NULL,56701278029,885957469,13843085,18.2),(137935,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137935,36.95,0.46,246,65973,70,NULL,NULL,'2MASX J16293121+1314383',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000167,NULL,'16.8g',NULL,NULL,NULL,NULL,NULL,NULL,1,247.380166667,13.24417,0.177,NULL,56878337133,888724017,13886312,16.8),(137936,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137936,37.07,0.46,260,65974,70,NULL,NULL,'2MASX J16293145+2021004',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000137,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.3809583,20.35022,0.197,NULL,56701550745,885961730,13843152,17.6),(137937,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137937,37.16,0.62,270,65975,70,NULL,NULL,'2MASX J16293189-6423367',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.382875,-64.3935,0.841,NULL,44982047344,702844489,10981945,14.5),(137938,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137938,35.76,0.06,142,65976,70,NULL,NULL,'2MASX J16293306+3954108',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00005,NULL,'16.1g',0.25,'E',NULL,NULL,NULL,NULL,1,247.387833,39.90294,0.005,NULL,59854504799,935226637,14612916,16.1),(137939,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137939,33.53,0.47,50.8,65977,NULL,NULL,'H','NGC 6182',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.44',0.6,'Sa',NULL,NULL,NULL,NULL,1,247.391667,55.51778,0,NULL,57603415518,900053367,14063333,14.44),(137940,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137940,33.69,0.46,54.8,65977,NULL,NULL,'J','NGC 6182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137941,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137941,33.7,0.45,54.9,65977,NULL,NULL,'K','NGC 6182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137942,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137942,34.24,0.4,70.4,65977,NULL,NULL,'mean','NGC 6182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137943,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137943,36.75,0.46,224,65978,70,NULL,NULL,'2MASX J16293615+1327163',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,247.4005417,13.45456,0.181,NULL,56878329900,888723904,13886311,16.5),(137944,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137944,36.71,0.46,220,65979,70,NULL,NULL,'2MASX J16293758+2318105',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.406583333,23.30278,0.117,NULL,56649675379,885151177,13830487,16.9),(137945,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137945,36.48,0.46,198,65980,70,NULL,NULL,'2MASX J16293963+2408563',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.4149583,24.14889,0.141,NULL,56176484377,877757568,13714962,17.3),(137946,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137946,37.3,0.46,288,65981,70,NULL,NULL,'2MASX J16293960+1239522',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.415167,12.6645,0.197,NULL,56878643038,888728797,13886387,18),(137947,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137947,37.81,0.46,365,65982,70,NULL,NULL,'2MASX J16294037+2406213',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000142,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.418041667,24.10586,0.129,NULL,56649457160,885147768,13830433,17.9),(137948,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137948,35.62,0.13,133,65983,NULL,NULL,NULL,'UGC 10417',NULL,'2009ApJS..182..474S',2009,1,0.94,NULL,'G',0.0001,NULL,'16.0g',0.24,'Sb(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.419917,40.68694,0,NULL,59854120272,935220629,14612822,16),(137949,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137949,36.73,0.46,222,65984,70,NULL,NULL,'2MASX J16294134+2935323',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.422167,29.59247,0.037,NULL,59731915482,933311179,14582987,17.3),(137950,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137950,37.99,0.46,396,65985,70,NULL,NULL,'SDSS J162942.00+245404.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.425,24.90131,0.109,NULL,56185718425,877901850,13717216,17.8),(137951,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137951,37.47,0.33,312,65986,70,NULL,NULL,'2MASX J16294215+2655094',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.42575,26.91917,0.093,NULL,56184292750,877879574,13716868,17.3),(137952,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137952,35.88,0.46,150,65987,70,NULL,NULL,'2MASX J16294368+1516372',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000159,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,247.432167,15.27694,0.177,NULL,56672243851,885503810,13835997,16.5),(137953,'FP','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137953,34.73,0.49,88.3,65988,70,NULL,NULL,'FAIRALL 1425',NULL,'2014MNRAS.445.2677S',2014,1,1.17,NULL,'G',0.00015,NULL,'14.5R',1,NULL,NULL,NULL,NULL,NULL,1,247.4322917,-68.00339,0.417,NULL,45027808323,703559505,10993117,14.5),(137954,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137954,33.99,0.2,62.8,65989,74.4,NULL,NULL,'CGCG 080-042',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00001,NULL,'15.6',0.15,'Sbc',NULL,NULL,NULL,NULL,1,247.4337917,11.84711,0.221,NULL,56743124351,886611317,13853301,15.6),(137955,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137955,34.11,NULL,66.2,65989,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 080-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137956,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137956,34.12,NULL,66.6,65989,NULL,NULL,'Dipole + Quadrupole','CGCG 080-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137957,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137957,34.13,NULL,67.1,65989,NULL,NULL,'Dipole','CGCG 080-042',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137958,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,NULL,137958,34.18,NULL,68.6,65989,NULL,NULL,NULL,'CGCG 080-042',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137959,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:56','1',NULL,'R',137959,34.24,0.49,70.5,65989,75,NULL,'IR','CGCG 080-042',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137960,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137960,37.47,0.33,312,65990,70,NULL,NULL,'2MASX J16294440+2651234',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,247.435166667,26.8565,0.093,NULL,56184298844,877879669,13716869,16.6),(137961,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137961,34.3,0.4,72.4,65991,75,NULL,'Edat, raw','NGC 6173',NULL,'1997ApJS..109..333W',1997,1,1.9,'HOLM 753B is a double star.','G',0.00005,NULL,'13.1B',1.4,'cD;E           AGN','in a radial-velocity based grouping',NULL,NULL,NULL,1,247.437083,40.81161,0,NULL,59854111787,935220496,14612820,13.1),(137962,'D-Sigma','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137962,34.63,0.4,84.2,65991,75,NULL,'Edat, cor','NGC 6173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137963,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137963,34.88,0.22,94.6,65991,74.4,NULL,NULL,'NGC 6173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137964,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137964,35.29,0.22,114,65991,70,NULL,NULL,'NGC 6173',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137965,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137965,35.76,0.06,142,65991,70,NULL,NULL,'NGC 6173',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137966,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137966,34.89,0.45,94.9,65991,NULL,NULL,'K','NGC 6173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137967,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137967,35.47,0.4,124,65991,NULL,NULL,'mean','NGC 6173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137968,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137968,35.56,0.3,129,65991,NULL,NULL,'ABELL 2197, 3 galaxies','NGC 6173',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137969,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137969,37.69,0.46,345,65992,70,NULL,NULL,'SDSS J162945.10+302218.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,247.4379583,30.37181,0.021,NULL,59786243688,934160057,14596250,18.3),(137970,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137970,35.76,0.06,142,65993,70,NULL,NULL,'2MASX J16294513+3948381',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000067,NULL,'15.6g',0.41,'Elliptical',NULL,NULL,NULL,NULL,1,247.438,39.81056,0.005,NULL,59854325009,935223828,14612872,15.6),(137971,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137971,37.35,0.46,296,65994,70,NULL,NULL,'2MASX J16294578+2245476',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.440833,22.76317,0.165,NULL,56651655130,885182111,13830970,17.7),(137972,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137972,36.99,0.16,250,65995,70,NULL,NULL,'2MASX J16294712+2434194',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000174,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,247.44625,24.57206,0.121,NULL,56176590204,877759221,13714987,16.3),(137973,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137973,38.59,0.46,523,65996,70,NULL,NULL,'SDSS J162947.11+221642.5',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,247.4462917,22.2785,0.141,NULL,56651090249,885173285,13830832,18.2),(137974,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137974,37.71,0.46,348,65997,70,NULL,NULL,'SDSS J162947.27+385350.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000136,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.447,38.89725,0,NULL,59819905089,934686017,14604469,18.1),(137975,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137975,37.67,0.46,341,65998,70,NULL,NULL,'2MASX J16295013+1224333',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.459041667,12.40925,0.209,NULL,56878662285,888729098,13886392,17.4),(137976,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137976,36.43,0.46,193,65999,70,NULL,NULL,'2MASX J16295039+2046076',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000139,NULL,'17.5g',NULL,NULL,NULL,NULL,NULL,NULL,1,247.4597917,20.76886,0.209,NULL,56703031872,885984873,13843513,17.5),(137977,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137977,35.69,0.08,138,66000,NULL,NULL,NULL,'UGC 10420',NULL,'2009ApJS..182..474S',2009,1,1.24,NULL,'G',0.00006,NULL,'14.8g',0.75,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.462667,39.7665,0,NULL,59854338429,935224037,14612875,14.8),(137978,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137978,37.44,0.46,307,66001,70,NULL,NULL,'2MASX J16295154+2209396',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.4647083,22.16108,0.125,NULL,56651267085,885176048,13830875,17.3),(137979,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137979,37.86,0.46,373,66002,70,NULL,NULL,'2MASX J16295276+2939434',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.469917,29.66206,0.037,NULL,59731905212,933311018,14582984,18.1),(137980,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137980,35.45,0.46,123,66003,70,NULL,NULL,'CGCG 109-025',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000186,NULL,'15.0g',0.6,NULL,NULL,NULL,NULL,NULL,1,247.472417,20.23256,0.193,NULL,56703194666,885987416,13843553,15),(137981,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137981,35.71,0.08,139,66004,NULL,NULL,NULL,'UGC 10423',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000063,NULL,'16.0',0.5,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.476625,41.60453,0,NULL,59858747139,935292924,14613951,16),(137982,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137982,35.66,0.16,135,66005,70,NULL,NULL,'GIN 596',NULL,'2001MNRAS.321..277C',2001,1,0.37,NULL,'G',0.000093,NULL,'14.52',0.33,'E/S0',NULL,NULL,NULL,NULL,1,247.4857917,39.94372,0.005,NULL,59854517702,935226839,14612919,14.52),(137983,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137983,36.65,0.25,214,66005,74.4,NULL,NULL,'GIN 596',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137984,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137984,36.74,0.46,223,66005,70,NULL,NULL,'GIN 596',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137985,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137985,38.42,0.46,484,66006,70,NULL,NULL,'SDSS J162957.17+460459.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000143,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,247.48825,46.08314,0.009,NULL,59841000155,935015627,14609619,18.5),(137986,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137986,35.78,0.46,143,66007,70,NULL,NULL,'2MASX J16300278+4349297',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000093,NULL,'15.3g',0.5,'S0',NULL,NULL,NULL,NULL,1,247.511375,43.82492,0,NULL,59860029931,935312967,14614265,15.3),(137987,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137987,35.95,0.46,155,66008,70,NULL,NULL,'CGCG 138-024',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00012,NULL,'15.0g',0.57,NULL,NULL,NULL,NULL,NULL,1,247.511417,23.35442,0.117,NULL,56649704241,885151628,13830494,15),(137988,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137988,37.77,0.46,359,66009,70,NULL,NULL,'2MASX J16300582+2005131',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.524333,20.08714,0.193,NULL,56703220568,885987821,13843559,17.6),(137989,'Tully est','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137989,33.02,0.8,40.1,66010,75,NULL,NULL,'UGC 10419',NULL,'1988NBGC.C....0000T',1988,1,0.41,NULL,'G',0.000011,NULL,'17.2g',0.14,'Im:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.525417,27.69931,0.117,NULL,56180221173,877815955,13715874,17.2),(137990,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137990,37.16,0.33,270,66011,70,NULL,NULL,'KUGX 1628+363',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.0001,NULL,'15.5g',0.48,'Compact',NULL,NULL,NULL,NULL,1,247.528583,36.22019,0,NULL,59751707491,933620429,14587819,15.5),(137991,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137991,35.92,0.46,152,66012,70,NULL,NULL,'2MASX J16300809+1454127',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000093,NULL,'15.3g',0.54,NULL,NULL,NULL,NULL,NULL,1,247.5337083,14.90347,0.141,NULL,56657833561,885278649,13832478,15.3),(137992,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137992,38.6,0.46,525,66013,70,NULL,NULL,'SDSS J163008.89+270943.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.537041667,27.16211,0.105,NULL,56180064412,877813506,13715836,18.4),(137993,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137993,36.98,0.46,249,66014,70,NULL,NULL,'SDSS J163010.26+092305.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'17.9g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.542791667,9.38494,0.221,NULL,56755585684,886806026,13856344,17.9),(137994,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137994,35.63,0.49,134,66015,75,NULL,'IR','CGCG 138-026',NULL,'2011yCatp016004901K',2011,1,1.06,NULL,'G',0.000057,NULL,'15.1g',0.31,'S',NULL,NULL,NULL,NULL,1,247.5555,23.06972,0.165,NULL,56651568950,885180764,13830949,15.1),(137995,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137995,35.83,0.4,147,66015,NULL,NULL,'mean','CGCG 138-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137996,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137996,35.97,0.47,156,66015,NULL,NULL,'H','CGCG 138-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137997,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137997,36.04,0.2,161,66015,74.4,NULL,NULL,'CGCG 138-026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137998,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,137998,36.06,0.45,163,66015,NULL,NULL,'K','CGCG 138-026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(137999,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',137999,36.99,0.16,250,66016,70,NULL,NULL,'2MASX J16301543+2442443',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.5642917,24.71225,0.097,NULL,56177323856,877770685,13715166,17.7),(138000,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138000,37.16,0.33,270,66017,70,NULL,NULL,'2MASX J16301555+3616260',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.5647917,36.27392,0,NULL,59751702199,933620346,14587817,17.8),(138001,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138001,36.67,0.46,216,66018,70,NULL,NULL,'2MASX J16301589+2507393',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00017,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.566166667,25.12756,0.081,NULL,56185244391,877894443,13717100,17.2),(138002,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138002,35.76,0.06,142,66019,70,NULL,NULL,'2MASX J16301736+3953220',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000057,NULL,'15.4g',0.41,'S0',NULL,NULL,NULL,NULL,1,247.572375,39.88942,0.005,NULL,59854511347,935226739,14612917,15.4),(138003,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138003,35.09,0.25,104,66020,74.4,NULL,NULL,'KUG 1628+407',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.000053,NULL,'15.3g',0.57,'S','Group member',NULL,NULL,NULL,1,247.5740417,40.59861,0,NULL,59854596663,935228072,14612938,15.3),(138004,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138004,35.29,0.22,114,66020,70,NULL,NULL,'KUG 1628+407',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138005,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138005,37.66,0.46,341,66021,70,NULL,NULL,'2MASX J16301852+1930171',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,247.577167,19.50472,0.237,NULL,56704375333,886005864,13843841,18.3),(138006,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138006,36.27,0.46,179,66022,70,NULL,NULL,'2MASX J16301888+4254538',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00006,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,247.5787917,42.91486,0,NULL,59860173415,935315209,14614300,15.8),(138007,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138007,37.02,0.46,253,66023,70,NULL,NULL,'2MASX J16301913+0011064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.57975,0.185,0.293,NULL,56707049491,886047648,13844494,17.5),(138008,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138008,36.68,0.33,217,66024,70,NULL,NULL,'2MASX J16301981+2452344',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0002,NULL,'16.1g',0.31,'S0^-',NULL,NULL,NULL,NULL,1,247.582583,24.87625,0.109,NULL,56177007436,877765741,13715089,16.1),(138009,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138009,35.66,0.16,135,66025,70,NULL,NULL,'GIN 595',NULL,'2001MNRAS.321..277C',2001,1,0.59,NULL,'G',0.000063,NULL,'15.5g',0.46,'S0',NULL,NULL,NULL,NULL,1,247.583875,39.80431,0,NULL,59854335800,935223996,14612874,15.5),(138010,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138010,35.76,0.06,142,66025,70,NULL,NULL,'GIN 595',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138011,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138011,36.98,0.46,249,66026,70,NULL,NULL,'2MASX J16302025+2544024',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,247.584333333,25.73417,0.081,NULL,56186292057,877910813,13717356,16.5),(138012,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138012,38.2,0.46,437,66027,70,NULL,NULL,'SDSS J163020.35+093247.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.584833,9.5465,0.237,NULL,56756694368,886823349,13856614,18.3),(138013,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138013,35.41,1.14,121,66028,NULL,NULL,'Malmquist cor.','UGC 10416',NULL,'2009ApJS..182..474S',2009,1,1,'Springob et al. (2005ApJS..160..149S) give v= 6214 km/sec.','G',0.00018,NULL,'14.60',0.8,'SAB(s)bc',NULL,NULL,NULL,NULL,1,247.584833,8.62881,0.253,NULL,56747926727,886686355,13854474,14.6),(138014,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138014,36.15,0.81,170,66028,NULL,NULL,NULL,'UGC 10416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138015,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138015,36.47,0.46,197,66029,70,NULL,NULL,'2MASX J16302054+2147591',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000181,NULL,'15.7g',0.38,NULL,NULL,NULL,NULL,NULL,1,247.585667,21.79981,0.145,NULL,56650450158,885163283,13830676,15.7),(138016,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138016,36.9,0.46,240,66030,70,NULL,NULL,'2MASX J16302064+3902361',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'16.9g',0.27,'S',NULL,NULL,NULL,NULL,1,247.586167,39.04322,0,NULL,59819726504,934683226,14604425,16.9),(138017,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138017,36.54,0.46,203,66031,70,NULL,NULL,'SDSS J163022.07+114935.9',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'16.7g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.592,11.82667,0.221,NULL,56743055589,886610243,13853285,16.7),(138018,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138018,37.86,0.46,373,66032,70,NULL,NULL,'2MASX J16302229+3101447',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.593125,31.02908,0.045,NULL,59786411142,934162674,14596291,17.7),(138019,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138019,35.76,0.06,142,66033,70,NULL,NULL,'CGCG 224-052',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000073,NULL,'15.1g',0.52,'E','Group member',NULL,NULL,NULL,1,247.5997083,40.66569,0,NULL,59854588081,935227938,14612936,15.1),(138020,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138020,37.94,0.33,387,66034,70,NULL,NULL,'2MASX J16302564+1639278',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000181,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.6069583,16.65792,0.237,NULL,56669981676,885468463,13835444,18.2),(138021,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138021,36.99,0.16,250,66035,70,NULL,NULL,'2MASX J16302666+2436404',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000168,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.6110417,24.61119,0.097,NULL,56177294210,877770222,13715159,17.1),(138022,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138022,35.09,0.25,104,66036,74.4,NULL,NULL,'UGC 10430',NULL,'2013AJ....146...86T',2013,1,0.97,NULL,'G',0.000026,NULL,'14.6g',0.82,'SB(rs)bc',NULL,NULL,NULL,NULL,1,247.611833,41.48397,0.005,NULL,59858571280,935290176,14613909,14.6),(138023,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138023,35.29,0.22,114,66036,70,NULL,NULL,'UGC 10430',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138024,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138024,36.3,0.46,182,66037,70,NULL,NULL,'2MASX J16302675+2603364',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000187,NULL,'15.7g',0.47,'S0^-',NULL,NULL,NULL,NULL,1,247.611667,26.06003,0.089,NULL,56186678999,877916859,13717450,15.7),(138025,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138025,35.8,0.07,145,66038,NULL,NULL,NULL,'CGCG 224-055',NULL,'2009ApJS..182..474S',2009,1,1.14,NULL,'G',0.000067,NULL,'14.6g',0.41,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.62,39.62606,0,NULL,59854353341,935224270,14612879,14.6),(138026,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138026,36.99,0.16,250,66039,70,NULL,NULL,'2MASX J16302886+2433164',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.620125,24.55453,0.097,NULL,56177396465,877771819,13715184,18),(138027,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138027,37.51,0.46,318,66040,70,NULL,NULL,'2MASX J16302939+3040278',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.62275,30.67428,0.049,NULL,59786300938,934160952,14596264,17),(138028,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138028,38.41,0.23,481,66041,70,NULL,NULL,'2MASX J16303188+2116532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000184,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.6327917,21.2815,0.157,NULL,56695477149,885866830,13841669,17.6),(138029,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138029,37.05,0.46,257,66042,70,NULL,NULL,'2MASX J16303210+1353128',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.633625,13.887,0.165,NULL,56877203993,888706312,13886036,17.1),(138030,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138030,35.09,0.25,104,66043,74.4,NULL,NULL,'NGC 6180',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000043,NULL,'14.5g',0.67,'S0','Group member',NULL,NULL,NULL,1,247.641333,40.53944,0,NULL,59854594939,935228045,14612938,14.5),(138031,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138031,35.29,0.22,114,66043,70,NULL,NULL,'NGC 6180',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138032,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138032,35.76,0.06,142,66043,70,NULL,NULL,'NGC 6180',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138033,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138033,37.49,0.46,315,66044,70,NULL,NULL,'2MASX J16303428+0947509',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.642791667,9.79736,0.241,NULL,56757206448,886831350,13856739,17),(138034,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138034,37.17,0.27,271,66045,70,NULL,NULL,'2MASX J16303455+2848034',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000153,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.644,28.80097,0.057,NULL,59731630544,933306727,14582917,16.8),(138035,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138035,36.99,0.16,250,66046,70,NULL,NULL,'2MASX J16303509+2435324',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.6462083,24.59231,0.097,NULL,56177403267,877771926,13715186,17.7),(138036,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138036,38.05,0.46,408,66047,70,NULL,NULL,'2MASX J16303775+2246363',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000215,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,247.657541667,22.77681,0.165,NULL,56651531636,885180181,13830940,18.4),(138037,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138037,38.23,0.33,443,66048,70,NULL,NULL,'2MASX J16303787+2944576',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,247.657667,29.74936,0.037,NULL,59732024553,933312883,14583013,16.9),(138038,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138038,37.14,0.2,268,66049,74.4,NULL,NULL,'CGCG 168-017',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000105,NULL,'15.7g',0.43,'SBbc',NULL,NULL,NULL,NULL,1,247.658167,27.46228,0.109,NULL,56179924651,877811322,13715801,15.7),(138039,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138039,36.99,0.16,250,66050,70,NULL,NULL,'2MASX J16303890+2430594',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,247.6620417,24.51644,0.121,NULL,56177400658,877771885,13715185,17.9),(138040,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138040,35.34,0.2,117,66051,74.4,NULL,NULL,'NGC 6177',NULL,'2013AJ....146...86T',2013,1,1.44,NULL,'G',0.00003,NULL,'14.4g',0.89,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,247.662,35.05644,0.013,NULL,59749930015,933592656,14587385,14.4),(138041,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138041,35.73,0.4,140,66051,NULL,NULL,'mean','NGC 6177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138042,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138042,35.74,0.47,141,66051,NULL,NULL,'H','NGC 6177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138043,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138043,35.87,0.46,149,66051,NULL,NULL,'J','NGC 6177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138044,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138044,35.88,0.45,150,66051,NULL,NULL,'K','NGC 6177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138045,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138045,36.3,0.19,182,66052,70,NULL,NULL,'2MASX J16303911+2536336',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,247.6627917,25.60944,0.077,NULL,56186258784,877910293,13717348,15.5),(138046,'SNIa','2016-12-15 15:15:42','2016-12-16 11:20:57','1','SN 1998cs',NULL,138046,36.08,0.19,159,66053,65,NULL,NULL,'UGC 10432',0.03256,'2004ApJ...607..665R',2004,1,1.7,NULL,'G',0.000143,NULL,'15.5g',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.663375,41.21067,0,NULL,59854184587,935221634,14612838,15.5),(138047,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138047,35.64,0.11,135,66053,NULL,NULL,NULL,'UGC 10432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138048,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138048,37.17,0.27,271,66054,70,NULL,NULL,'2MASX J16303969+2845246',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.665333,28.75683,0.057,NULL,59731638685,933306854,14582919,18),(138049,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138049,36.99,0.16,250,66055,70,NULL,NULL,'2MASX J16303981+2434546',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.6660417,24.582,0.097,NULL,56177409557,877772024,13715187,17.1),(138050,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138050,37,0.46,251,66056,70,NULL,NULL,'2MASX J16303992+3938071',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000073,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.66625,39.63542,0,NULL,59854351407,935224240,14612878,17.1),(138051,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138051,35.09,0.25,104,66057,74.4,NULL,NULL,'KUG 1629+406A',NULL,'2013AJ....146...86T',2013,1,0.62,NULL,'G',0.000053,NULL,'15.5g',0.56,'S',NULL,NULL,NULL,NULL,1,247.6745,40.52942,0,NULL,59854770186,935230784,14612981,15.5),(138052,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138052,35.29,0.22,114,66057,70,NULL,NULL,'KUG 1629+406A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138053,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138053,35.29,0.22,114,66057,70,NULL,NULL,'KUG 1629+406A',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138054,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138054,37.94,0.33,387,66058,70,NULL,NULL,'2MASX J16304317+1639104',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,247.67975,16.653,0.265,NULL,56669800647,885465635,13835400,16.7),(138055,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138055,36.31,0.46,182,66059,70,NULL,NULL,'2MASX J16304436+2354043',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000151,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.685,23.90114,0.145,NULL,56649934278,885155223,13830550,16.7),(138056,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138056,36.65,0.46,214,66060,70,NULL,NULL,'2MASX J16304463+1503354',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.685875,15.05992,0.193,NULL,56657812797,885278324,13832473,16.9),(138057,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138057,38.62,0.46,529,66061,70,NULL,NULL,'2MASX J16304489+1519294',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.6870417,15.32486,0.193,NULL,56671509329,885492333,13835817,17.9),(138058,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138058,35.45,0.25,123,66062,74.4,NULL,NULL,'MCG +07-34-099',NULL,'2013AJ....146...86T',2013,1,0.72,NULL,'G',0.00008,NULL,'15.5g',0.47,'E/S0',NULL,NULL,NULL,NULL,1,247.6887083,39.19525,0,NULL,59822577470,934727772,14605121,15.5),(138059,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138059,35.66,0.16,135,66062,70,NULL,NULL,'MCG +07-34-099',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138060,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138060,35.76,0.06,142,66062,70,NULL,NULL,'MCG +07-34-099',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138061,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138061,38.23,0.33,443,66063,70,NULL,NULL,'2MASX J16304571+2943006',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000207,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.6904583,29.71675,0.037,NULL,59732021895,933312842,14583013,17.5),(138062,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138062,36.98,0.46,248,66064,70,NULL,NULL,'2MASX J16304818+2604116',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.700667,26.06981,0.089,NULL,56186679880,877916873,13717451,16.9),(138063,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138063,37.33,0.46,293,66065,70,NULL,NULL,'2MASX J16304884+4223319',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.703667,42.39231,0,NULL,59860195317,935315551,14614305,17.4),(138064,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138064,35.61,0.2,132,66066,74.4,NULL,NULL,'UGC 10426',NULL,'2013AJ....146...86T',2013,1,1.03,NULL,'G',0.000033,NULL,'15.1g',0.35,'S?',NULL,NULL,NULL,NULL,1,247.708917,16.25075,0.249,NULL,56671619338,885494052,13835844,15.1),(138065,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138065,37.25,0.46,282,66067,70,NULL,NULL,'2MASX J16305035+4840266',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00017,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.7097917,48.67408,0,NULL,59842877543,935044961,14610077,16.5),(138066,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138066,38.41,0.23,481,66068,70,NULL,NULL,'2MASX J16305228+2122083',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,247.717791667,21.36889,0.157,NULL,56695703902,885870373,13841724,18.5),(138067,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138067,36.99,0.16,250,66069,70,NULL,NULL,'CGCG 138-030',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000083,NULL,'15.5g',0.51,'BrClG',NULL,NULL,NULL,NULL,1,247.724333,24.56211,0.097,NULL,56177399419,877771865,13715185,15.5),(138068,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138068,36.55,0.46,204,66070,70,NULL,NULL,'2MASX J16305545+2552006',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,247.7312083,25.86689,0.081,NULL,56186322685,877911291,13717363,17),(138069,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138069,36.68,0.33,217,66071,70,NULL,NULL,'2MASX J16305579+2446476',NULL,'2015arXiv151105856S',2015,1,0.39,'1999ApJS..122..415A has z = 0.026 +- 0.004.','G',0.000173,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.732625,24.77989,0.109,NULL,56177308000,877770437,13715163,16.5),(138070,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138070,37.66,0.46,340,66072,70,NULL,NULL,'2MASX J16305646+3001506',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.7352083,30.03075,0.041,NULL,59731478567,933304352,14582880,17.6),(138071,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138071,35.55,0.5,129,66073,70,NULL,NULL,'2MASX J16305650-6825553',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,247.735417,-68.43203,0.417,NULL,45027617838,703556528,10993070,14),(138072,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138072,36.77,0.46,226,66074,70,NULL,NULL,'2MASX J16305671+2107073',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00013,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,247.736375,21.11883,0.177,NULL,56702945543,885983524,13843492,17.6),(138073,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138073,37.96,0.46,390,66075,70,NULL,NULL,'2MASX J16305685+3739353',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.7369583,37.65992,0,NULL,59819651130,934682048,14604407,17.6),(138074,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138074,35.1,0.25,105,66076,74.4,NULL,NULL,'CGCG 224-063',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000073,NULL,'15.1g',0.53,'S0','Group member',NULL,NULL,NULL,1,247.744833,40.93056,0,NULL,59854197266,935221832,14612841,15.1),(138075,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138075,35.29,0.22,114,66076,70,NULL,NULL,'CGCG 224-063',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138076,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138076,35.76,0.06,142,66076,70,NULL,NULL,'CGCG 224-063',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138077,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138077,36.47,0.46,197,66077,70,NULL,NULL,'2MASX J16305991-0006538',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000088,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,247.7495,-0.11489,0.293,NULL,45164329566,705692649,11026447,16.7),(138078,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138078,36.81,0.75,230,66077,70,NULL,NULL,'2MASX J16305991-0006538',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138079,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138079,35.76,0.06,142,66078,70,NULL,NULL,'2MASX J16310015+4014514',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000087,NULL,'15.9g',0.36,'S0',NULL,NULL,NULL,NULL,1,247.750583,40.24767,0,NULL,59854454939,935225858,14612904,15.9),(138080,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138080,20.4,0.2,0.12,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2008AJ....135.1361D',2008,1,NULL,NULL,'G',NULL,NULL,'14.7V',NULL,'dSph',NULL,NULL,NULL,NULL,1,247.758333,12.79167,0.189,1,56878762689,888730667,13886416,14.7),(138081,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138081,20.58,0.1,0.13,66079,NULL,NULL,'Girardi','HERCULES SATELLITE',NULL,'2009ApJ...704..898S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138082,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138082,20.6,0.19,0.132,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2007ApJ...668L..43C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138083,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138083,20.6,0.05,0.132,66079,NULL,NULL,'Dotter','HERCULES SATELLITE',NULL,'2009ApJ...704..898S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138084,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138084,20.62,0.1,0.133,66079,NULL,NULL,'Empirical','HERCULES SATELLITE',NULL,'2009ApJ...704..898S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138085,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138085,20.9,NULL,0.135,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2013ApJ...771...29G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138086,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138086,20.7,NULL,0.138,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138087,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138087,20.7,0.2,0.14,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2008AJ....135.1361D',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138088,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138088,20.7,0.2,0.14,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2007ApJ...654..897B',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138089,'CMD','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138089,20.92,0.06,0.153,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2012ApJ...753L..21B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138090,'Horizontal Branch','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138090,20.84,0.11,0.147,66079,NULL,NULL,NULL,'HERCULES SATELLITE',NULL,'2009A&A...506.1147A',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138091,'RR Lyrae','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138091,20.6,0.1,0.132,66079,NULL,NULL,'7, V','HERCULES SATELLITE',NULL,'2012ApJ...756..121M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138092,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138092,36.74,0.33,223,66080,70,NULL,NULL,'2MASX J16310202+4225059',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000053,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.758333,42.41833,0,NULL,59860250100,935316407,14614318,16.8),(138093,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138093,35.66,0.16,135,66081,70,NULL,NULL,'CGCG 224-064 NED01',NULL,'2001MNRAS.321..277C',2001,1,0.89,NULL,'G',0.000103,NULL,'14.3g',0.84,'E',NULL,NULL,NULL,NULL,1,247.761333333,39.7925,0,NULL,59854530164,935227033,14612922,14.3),(138094,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138094,35.76,0.06,142,66081,70,NULL,NULL,'CGCG 224-064 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138095,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138095,35.44,0.25,122,66082,74.4,NULL,NULL,'CGCG 224-064',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000047,NULL,NULL,NULL,'E/S0','Group member',NULL,NULL,NULL,1,247.76375,39.79306,0,NULL,59854530122,935227033,14612922,NULL),(138096,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138096,35.45,0.25,123,66083,74.4,NULL,NULL,'CGCG 224-065',NULL,'2013AJ....146...86T',2013,1,0.96,NULL,'G',0.00007,NULL,'14.8g',0.65,'E','Group member',NULL,NULL,NULL,1,247.764208333,39.83847,0,NULL,59854531837,935227059,14612922,14.8),(138097,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138097,35.66,0.16,135,66083,70,NULL,NULL,'CGCG 224-065',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138098,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138098,37.63,0.33,335,66084,70,NULL,NULL,'SDSS J163104.62+245719.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.76925,24.95553,0.109,NULL,56177022145,877765971,13715093,18),(138099,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138099,37.41,0.33,303,66085,70,NULL,NULL,'2MASX J16310613+2715246',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.775417,27.25692,0.105,NULL,56181701551,877839086,13716235,17.6),(138100,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138100,38,0.33,399,66086,70,NULL,NULL,'2MASX J16310648+1221054',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.7769583,12.35147,0.197,NULL,56876547014,888696047,13885875,17.8),(138101,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138101,37.17,0.27,271,66087,70,NULL,NULL,'SDSS J163106.65+284749.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.77775,28.79697,0.057,NULL,59731840773,933310012,14582968,17.6),(138102,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138102,37.28,0.45,285,66088,NULL,NULL,'Malmquist cor.','FGC 2041',NULL,'2009ApJS..182..474S',2009,1,0.51,NULL,'G',0.000196,NULL,'17.7g',0.13,'Sc','Group non-member, background',NULL,NULL,NULL,1,247.7784583,39.43044,0,NULL,59821535456,934711491,14604867,17.7),(138103,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138103,37.43,0.42,306,66088,NULL,NULL,NULL,'FGC 2041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138104,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138104,37.47,0.2,312,66088,74.4,NULL,NULL,'FGC 2041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138105,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138105,35.76,0.06,142,66089,70,NULL,NULL,'III Zw 085',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.7784583,40.93306,0,NULL,59854709708,935229839,14612966,16.6),(138106,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138106,35.43,0.25,122,66090,74.4,NULL,NULL,'GIN 587',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.000097,NULL,'16.1g',0.48,'S',NULL,NULL,NULL,NULL,1,247.7792917,39.20531,0,NULL,59822626750,934728542,14605133,16.1),(138107,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138107,35.66,0.16,135,66090,70,NULL,NULL,'GIN 587',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138108,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138108,38,0.33,399,66091,70,NULL,NULL,'2MASX J16310961+1222025',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.79,12.36747,0.197,NULL,56876532752,888695824,13885872,17.7),(138109,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138109,35.92,0.46,152,66092,70,NULL,NULL,'2MASX J16310965+3725204',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,247.790417,37.42239,0,NULL,59819460166,934679065,14604360,16.7),(138110,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138110,38.12,0.46,421,66093,70,NULL,NULL,'SDSS J163109.73+123647.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.790583,12.61325,0.189,NULL,56876478759,888694980,13885859,18.6),(138111,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138111,36.3,0.19,182,66094,70,NULL,NULL,'2MASX J16311030+2536146',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.7929583,25.60408,0.077,NULL,56186146026,877908531,13717320,17),(138112,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138112,36.52,0.46,202,66095,70,NULL,NULL,'2MASX J16311207+1546025',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,247.800333,15.76736,0.201,NULL,56672288639,885504509,13836007,16.7),(138113,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138113,37.96,0.46,391,66096,70,NULL,NULL,'SDSS J163113.74+490856.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,247.8072917,49.149,0,NULL,59829030176,934828596,14606696,18.3),(138114,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138114,35.76,0.06,142,66097,70,NULL,NULL,'2MASX J16311634+3952334',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'15.8g',0.43,'S',NULL,NULL,NULL,NULL,1,247.8180417,39.87597,0,NULL,59854533273,935227082,14612923,15.8),(138115,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138115,37.1,0.33,263,66098,70,NULL,NULL,'2MASX J16311707+2351167',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.821083333,23.85461,0.145,NULL,56650052066,885157063,13830579,17.3),(138116,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138116,37.79,0.46,361,66099,70,NULL,NULL,'2MASX J16311749+4033113',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.823125,40.55314,0,NULL,59854814462,935231475,14612991,17.7),(138117,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138117,35.53,0.72,128,66100,70,NULL,NULL,'2MASX J16311764-7717448',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,247.8235,-77.29586,0.429,NULL,44133475506,689585554,10774774,16.8),(138118,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138118,35.66,0.16,135,66101,70,NULL,NULL,'CGCG 224-067',NULL,'2001MNRAS.321..277C',2001,1,0.6,NULL,'G',0.000077,NULL,'15.1g',0.56,'E',NULL,NULL,NULL,NULL,1,247.83,39.15081,0,NULL,59822635661,934728682,14605135,15.1),(138119,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138119,35.7,0.23,138,66101,74.4,NULL,NULL,'CGCG 224-067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138120,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138120,35.76,0.06,142,66101,70,NULL,NULL,'CGCG 224-067',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138121,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138121,35.76,0.06,142,66102,70,NULL,NULL,'2MASX J16311927+3944383',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000117,NULL,'15.5g',0.45,'E',NULL,NULL,NULL,NULL,1,247.8302917,39.74414,0,NULL,59854309272,935223582,14612868,15.5),(138122,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138122,37.5,0.46,316,66103,70,NULL,NULL,'2MASX J16311975+3353537',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000135,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.832375,33.89831,0.029,NULL,59756312476,933692382,14588943,17.1),(138123,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138123,38.15,0.33,426,66104,70,NULL,NULL,'SDSS J163120.41+252509.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000137,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.835083,25.41942,0.077,NULL,56185113747,877892402,13717068,18.5),(138124,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138124,38.17,0.46,431,66105,70,NULL,NULL,'2MASX J16312063+2501372',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.8360417,25.02706,0.081,NULL,56177139739,877767808,13715122,18.2),(138125,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138125,36.16,0.46,170,66106,70,NULL,NULL,'2MASX J16312103+2652552',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.83775,26.88189,0.125,NULL,56182970475,877858913,13716545,16.5),(138126,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138126,32.14,0.4,26.8,66107,75,NULL,NULL,'NGC 6168',NULL,'2008Ap.....51..336K',2008,1,0.9,'Position is for SDSS J163121.30+201105.8.','G',0.000013,NULL,'14.7g',0.45,'Sdm:',NULL,NULL,NULL,NULL,1,247.83875,20.18494,0.221,NULL,56703143979,885986624,13843541,14.7),(138127,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138127,32.38,0.43,29.9,66107,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6168',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138128,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138128,32.49,0.43,31.5,66107,75,NULL,'3.6 micron, color corrected','NGC 6168',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138129,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138129,32.6,0.2,33.1,66107,74.4,NULL,NULL,'NGC 6168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138130,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138130,32.98,0.49,39.5,66107,75,NULL,'IR','NGC 6168',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138131,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138131,35.75,0.25,141,66108,74.4,NULL,NULL,'MCG +07-34-108',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.0001,NULL,'15.5g',0.26,'S0',NULL,NULL,NULL,NULL,1,247.844083,39.16783,0,NULL,59822635929,934728686,14605135,15.5),(138132,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138132,38.15,0.33,426,66109,70,NULL,NULL,'2MASX J16312281+2523502',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000185,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.845,25.39719,0.077,NULL,56185111757,877892371,13717068,17.5),(138133,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138133,37.82,0.46,367,66110,70,NULL,NULL,'2MASX J16312448+2638122',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000148,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.852208333,26.63672,0.097,NULL,56186405599,877912587,13717384,17.6),(138134,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138134,37.63,0.33,335,66111,70,NULL,NULL,'2MASX J16312468+2503102',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000187,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,247.852875,25.05272,0.081,NULL,56177184897,877768514,13715133,16.2),(138135,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138135,35.4,0.46,120,66112,70,NULL,NULL,'MCG +08-30-020',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.00017,NULL,'15.0g',0.67,'E0',NULL,NULL,NULL,NULL,1,247.856416667,46.32414,0,NULL,59841166504,935018226,14609659,15),(138136,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138136,37.39,0.46,301,66113,70,NULL,NULL,'2MASX J16312732-0001536',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,247.863833,-0.03144,0.309,NULL,45164479445,705694991,11026484,17.6),(138137,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138137,37.41,0.33,303,66114,70,NULL,NULL,'2MASX J16312827+2712102',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'18.27',0.37,NULL,NULL,NULL,NULL,NULL,1,247.867917,27.20289,0.129,NULL,56181715458,877839304,13716239,18.27),(138138,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138138,38.88,0.46,597,66115,70,NULL,NULL,'SDSS J163128.60+413202.6',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000132,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.869167,41.53408,0,NULL,59858851883,935294560,14613977,18),(138139,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138139,45.75,1.59,3620,66116,100,NULL,NULL,'GRB 050401',2.8992,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',0.0004,NULL,'16.8',NULL,'Swift',NULL,NULL,NULL,NULL,1,247.870167,2.18736,0.241,NULL,56709418389,886084662,13845072,16.8),(138140,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138140,45.9,1.53,3880,66116,100,NULL,NULL,'GRB 050401',2.8992,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138141,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138141,45.94,0.55,3950,66116,69.7,NULL,'Calibrated','GRB 050401',2.8992,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138142,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138142,46.15,0.53,4360,66116,69.7,NULL,'Fiducial','GRB 050401',2.8992,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138143,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138143,46.52,0.59,5160,66116,72,NULL,NULL,'GRB 050401',2.8992,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138144,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138144,46.67,0.59,5530,66116,70,NULL,NULL,'GRB 050401',2.8992,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138145,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138145,47.37,0.7,7640,66116,NULL,NULL,NULL,'GRB 050401',2.8992,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138146,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138146,46.5,0.42,20000,66116,NULL,NULL,NULL,'GRB 050401',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138147,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138147,35.76,0.06,142,66117,70,NULL,NULL,'CGCG 224-069',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00008,NULL,'15.1g',0.42,'E','Group member',NULL,NULL,NULL,1,247.882083,39.89767,0,NULL,59854527429,935226991,14612921,15.1),(138148,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138148,38.41,0.23,481,66118,70,NULL,NULL,'2MASX J16313235+2131366',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000183,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,247.884625,21.52692,0.137,NULL,56695631642,885869244,13841706,16.6),(138149,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138149,36.94,0.14,244,66119,70,NULL,NULL,'2MASX J16313244+1339495',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,247.885291667,13.66383,0.185,NULL,56877570031,888712031,13886125,17.1),(138150,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138150,38.41,0.23,481,66120,70,NULL,NULL,'SDSS J163133.45+212959.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.889375,21.49992,0.137,NULL,56695658787,885869668,13841713,18.3),(138151,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138151,35.81,0.06,146,66121,NULL,NULL,NULL,'NGC 6184',NULL,'2009ApJS..182..474S',2009,1,0.92,'Pos in 1984AnTok..192.595T is wrong.  1997AJ....113...22G has V = 9279 km/s.','G',0.000113,NULL,'14.5g',0.55,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,247.893875,40.56561,0,NULL,59854812105,935231439,14612991,14.5),(138152,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138152,34.43,0.57,76.9,66122,NULL,NULL,'Malmquist cor.','ESO 069- G 005',NULL,'2009ApJS..182..474S',2009,1,1.37,NULL,'G',0.000033,NULL,'14.65',0.16,'Sc',NULL,NULL,NULL,NULL,1,247.89725,-67.86794,0.449,NULL,45027492600,703554571,10993040,14.65),(138153,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138153,34.43,0.49,77.1,66122,75,NULL,'IR','ESO 069- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138154,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138154,34.57,NULL,82,66122,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 069- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138155,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138155,34.58,NULL,82.6,66122,NULL,NULL,'Dipole + Quadrupole','ESO 069- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138156,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138156,34.59,NULL,82.7,66122,NULL,NULL,'Dipole','ESO 069- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138157,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138157,34.6,0.53,83.2,66122,NULL,NULL,NULL,'ESO 069- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138158,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138158,34.64,0.2,84.7,66122,74.4,NULL,NULL,'ESO 069- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138159,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138159,34.15,0.2,67.6,66123,74.4,NULL,NULL,'CGCG 080-043 NED01',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000081,NULL,'15.9g',0.22,'WR?            HII',NULL,NULL,NULL,NULL,1,247.899125,13.63714,0.185,NULL,56877576285,888712129,13886127,15.9),(138160,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138160,37.1,0.33,263,66124,70,NULL,NULL,'2MASX J16313729+2356076',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.905375,23.93553,0.145,NULL,56650096009,885157750,13830589,17.1),(138161,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138161,38.04,0.46,405,66125,70,NULL,NULL,'2MASX J16313853+3530297',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.91075,35.50828,0,NULL,59749240425,933581881,14587216,17.1),(138162,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138162,37.12,0.46,265,66126,70,NULL,NULL,'2MASX J16313980-0009418',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00007,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.91575,-0.16169,0.309,NULL,45164490938,705695170,11026487,17.6),(138163,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138163,36.74,0.33,223,66127,70,NULL,NULL,'2MASX J16314057+4226555',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00012,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,247.9190417,42.44875,0,NULL,59858327675,935286369,14613849,16.4),(138164,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138164,34.53,0.39,80.5,66128,NULL,NULL,'Malmquist cor.','NGC 6189',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000017,NULL,'13.36',0.9,'Scd:','Field galaxy',NULL,NULL,NULL,1,247.920417,59.62611,0,NULL,57653373277,900833957,14075530,13.36),(138165,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138165,34.56,0.2,81.7,66128,74.4,NULL,NULL,'NGC 6189',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138166,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138166,34.63,0.37,84.5,66128,NULL,NULL,NULL,'NGC 6189',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138167,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138167,36.37,0.25,188,66129,74.4,NULL,NULL,'GIN 606',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.00008,NULL,'14.50',0.41,'S',NULL,NULL,NULL,NULL,1,247.927,50.16775,0,NULL,59829160562,934830633,14606728,14.5),(138168,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138168,36.58,0.21,207,66129,70,NULL,NULL,'GIN 606',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138169,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138169,34.76,0.2,89.5,66130,74.4,NULL,NULL,'CGCG 109-029',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.0001,NULL,'15.7',0.4,'Sd',NULL,NULL,NULL,NULL,1,247.9272083,18.65064,0.253,NULL,56704100615,886001572,13843774,15.7),(138170,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138170,38.09,0.46,415,66131,70,NULL,NULL,'2MASX J16314259+2942132',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.9274583,29.70378,0.045,NULL,59732048492,933313257,14583019,17.7),(138171,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138171,36.94,0.14,244,66132,70,NULL,NULL,'2MASX J16314268+1338078',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.927833,13.63556,0.185,NULL,56877579831,888712184,13886127,17),(138172,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138172,36.58,0.21,207,66133,70,NULL,NULL,'2MASX J16314270+5014128',NULL,'2001MNRAS.321..277C',2001,1,0.56,NULL,'G',NULL,NULL,'15.7g',0.55,NULL,NULL,NULL,NULL,NULL,1,247.927791667,50.23669,0,NULL,59829172710,934830823,14606731,15.7),(138173,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138173,37.14,0.23,268,66134,70,NULL,NULL,'2MASX J16314282+2533102',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000175,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,247.928417,25.55283,0.077,NULL,56185065570,877891649,13717057,17.2),(138174,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138174,36.94,0.14,244,66135,70,NULL,NULL,'2MASX J16314489+1322338',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,247.9369583,13.37594,0.185,NULL,56878015255,888718988,13886234,17.1),(138175,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138175,36.94,0.14,244,66136,70,NULL,NULL,'2MASX J16314487+1340548',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.937083,13.68189,0.185,NULL,56877578608,888712165,13886127,17.4),(138176,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138176,38.49,0.46,500,66137,70,NULL,NULL,'2MASX J16314528+2621011',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,247.938625,26.35033,0.097,NULL,56186517654,877914338,13717411,17.8),(138177,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138177,37.93,0.19,386,66138,70,NULL,NULL,'2MASX J16314628+1303198',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,247.943,13.05542,0.185,NULL,56878090836,888720169,13886252,18),(138178,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138178,37.14,0.23,268,66139,70,NULL,NULL,'2MASX J16314664+2535441',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00019,NULL,'16.3g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,247.944417,25.59558,0.077,NULL,56186163631,877908806,13717325,16.3),(138179,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138179,37.93,0.19,386,66140,70,NULL,NULL,'SDSS J163147.26+130305.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.8g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.946917,13.0515,0.185,NULL,56878090828,888720169,13886252,17.8),(138180,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138180,36.98,0.46,249,66141,70,NULL,NULL,'2MASX J16314887+4547315',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,247.9535,45.79203,0,NULL,59840333985,935005218,14609456,17.1),(138181,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138181,38.31,0.46,460,66142,70,NULL,NULL,'SDSS J163149.98+124406.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000132,NULL,'18.7g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.95825,12.73522,0.185,NULL,56876609144,888697017,13885890,18.7),(138182,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138182,37.14,0.23,268,66143,70,NULL,NULL,'2MASX J16315057+2526511',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,247.960666667,25.4475,0.077,NULL,56185072117,877891751,13717058,17),(138183,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138183,37.14,0.23,268,66144,70,NULL,NULL,'2MASX J16315234+2526271',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,'FoF','17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,247.968083,25.44081,0.077,NULL,56185073114,877891767,13717058,17.3),(138184,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138184,37.15,0.46,269,66145,70,NULL,NULL,'2MASX J16315260+3027586',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,247.9692917,30.46625,0.037,NULL,59786483333,934163802,14596309,17.6),(138185,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138185,37.26,0.46,283,66146,70,NULL,NULL,'2MASX J16315429+2140486',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.976125,21.68014,0.145,NULL,56695641004,885869390,13841709,17.3),(138186,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138186,38.47,0.46,494,66147,70,NULL,NULL,'SDSS J163155.68+233236.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,247.982041667,23.5435,0.129,NULL,56652069153,885188580,13831071,18.5),(138187,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138187,36.73,0.17,221,66148,70,NULL,NULL,'2MASX J16315669+1128588',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,247.9862917,11.48306,0.221,NULL,56743524062,886617563,13853399,17),(138188,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138188,37.35,0.46,295,66149,70,NULL,NULL,'2MASXi J1631581+144026',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.8g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,247.991916667,14.67397,0.193,NULL,56877102317,888704723,13886011,16.8),(138189,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138189,37,0.46,251,66150,70,NULL,NULL,'2MASX J16315966+2428552',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,247.998708333,24.48206,0.113,NULL,56176872897,877763639,13715056,16.8),(138190,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138190,34.11,0.2,66.4,66151,74.4,NULL,NULL,'ESO 452- G 006',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000023,NULL,'13.61',0.3,'S              HII',NULL,NULL,NULL,NULL,1,248.001917,-29.55467,0.961,NULL,46247346559,722614789,11290856,13.61),(138191,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138191,34.22,0.49,69.7,66151,75,NULL,'IR','ESO 452- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138192,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138192,34.49,0.48,79,66151,NULL,NULL,'Malmquist cor.','ESO 452- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138193,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138193,34.53,0.4,80.5,66151,NULL,NULL,'mean','ESO 452- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138194,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138194,34.56,0.47,81.5,66151,NULL,NULL,NULL,'ESO 452- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138195,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138195,34.72,0.47,87.7,66151,NULL,NULL,'H','ESO 452- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138196,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138196,38.1,0.46,416,66152,70,NULL,NULL,'SDSS J163202.25+430600.5',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000088,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.009417,43.10014,0.009,NULL,59859581630,935305962,14614155,17.6),(138197,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138197,36.94,0.14,244,66153,70,NULL,NULL,'2MASXi J1632023+133552',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'17.9g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.0097917,13.59808,0.185,NULL,56877547269,888711676,13886119,17.9),(138198,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138198,38.57,0.46,517,66154,70,NULL,NULL,'SDSS J163202.41+365613.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.010083,36.93708,0,NULL,59751299913,933614061,14587719,18.1),(138199,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138199,37.93,0.19,386,66155,70,NULL,NULL,'2MASX J16320346+1243328',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.0142917,12.72592,0.185,NULL,56876651508,888697679,13885901,17.6),(138200,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138200,37.8,0.46,363,66156,70,NULL,NULL,'2MASX J16320380+2226429',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,248.01575,22.44533,0.149,NULL,56650716749,885167449,13830741,18.3),(138201,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138201,37.2,0.46,275,66157,70,NULL,NULL,'2MASX J16320426+2929172',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.0177917,29.48797,0.045,NULL,59731964994,933311953,14582999,17.5),(138202,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138202,36.42,0.46,192,66158,70,NULL,NULL,'2MASX J16320442+4745531',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,248.01825,47.76478,0,NULL,59844206851,935065732,14610402,16.6),(138203,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138203,37.92,0.46,383,66159,70,NULL,NULL,'2MASX J16320467+2150479',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,248.0195,21.84656,0.149,NULL,56696311713,885879870,13841872,16.9),(138204,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138204,36.94,0.14,244,66160,70,NULL,NULL,'CGCG 080-045',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000173,NULL,'15.2g',NULL,NULL,NULL,NULL,NULL,NULL,1,248.021875,13.64725,0.185,NULL,56877536577,888711509,13886117,15.2),(138205,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138205,36.58,0.21,207,66161,70,NULL,NULL,'GIN 603',NULL,'2001MNRAS.321..277C',2001,1,0.57,NULL,'G',NULL,NULL,'15.5g',0.46,'S',NULL,NULL,NULL,NULL,1,248.023583,50.37956,0,NULL,59831283010,934863797,14607246,15.5),(138206,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138206,37.38,0.46,300,66162,70,NULL,NULL,'2MASX J16320771+4910416',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000183,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,248.032083,49.17814,0,NULL,59828951475,934827366,14606677,16.3),(138207,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138207,37.53,0.46,320,66163,70,NULL,NULL,'I Zw 155',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.0362083,37.98111,0,NULL,59822990916,934734233,14605222,16.8),(138208,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138208,33.57,0.8,51.7,66164,75,NULL,'MAT, I','ESO 452- G 007',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000017,NULL,'11.46',1,'(R\'_1)SAB(s)a',NULL,NULL,NULL,NULL,1,248.049667,-28.09192,1.081,NULL,45776406228,715256347,11175880,11.46),(138209,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138209,33.21,0.2,43.9,66164,74.4,NULL,NULL,'ESO 452- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138210,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138210,33.87,0.43,59.5,66164,75,NULL,'MAT, I, raw','ESO 452- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138211,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138211,34.07,0.32,65.1,66164,85,NULL,'I, raw','ESO 452- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138212,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138212,34.16,0.32,68,66164,85,NULL,'I, inv','ESO 452- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138213,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138213,34.22,0.43,69.9,66164,75,NULL,'MAT, I, cor','ESO 452- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138214,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138214,34.25,0.43,70.7,66164,75,NULL,'MAT, I, inv','ESO 452- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138215,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138215,36.7,0.46,219,66165,70,NULL,NULL,'2MASX J16321209-0018141',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000089,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.0505,-0.30406,0.309,NULL,45164474644,705694916,11026483,16.8),(138216,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138216,37.93,0.19,386,66166,70,NULL,NULL,'2MASX J16321325+1243407',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000205,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,248.055291667,12.72792,0.181,NULL,56876638010,888697468,13885897,16.7),(138217,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138217,36.94,0.14,244,66167,70,NULL,NULL,'2MASX J16321384+1351527',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.0575,13.86469,0.189,NULL,56877581959,888712218,13886128,17),(138218,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138218,36.89,0.46,239,66168,70,NULL,NULL,'2MASX J16321639+2715451',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.068333333,27.26242,0.129,NULL,56181672090,877838626,13716228,17.5),(138219,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138219,36.38,0.25,189,66169,74.4,NULL,NULL,'MCG +08-30-023',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00007,NULL,'14.33',0.4,'S',NULL,NULL,NULL,NULL,1,248.069208333,50.18936,0,NULL,59831242637,934863166,14607236,14.33),(138220,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138220,36.58,0.21,207,66169,70,NULL,NULL,'MCG +08-30-023',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138221,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138221,36.94,0.14,244,66170,70,NULL,NULL,'2MASX J16321736+1335427',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000191,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,248.0725,13.59533,0.185,NULL,56877533042,888711453,13886116,16.5),(138222,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138222,37.04,0.46,256,66171,70,NULL,NULL,'2MASX J16321761+3150227',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000154,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,248.073375,31.83967,0.029,NULL,59789293704,934207714,14596995,16.9),(138223,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138223,35.76,0.06,142,66172,70,NULL,NULL,'2MASX J16321980+4034304',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000077,NULL,'15.2g',0.34,'S0',NULL,NULL,NULL,NULL,1,248.082458333,40.57506,0,NULL,59854752630,935230509,14612976,15.2),(138224,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138224,36.94,0.14,244,66173,70,NULL,NULL,'2MASX J16322003+1340577',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.083625,13.68264,0.185,NULL,56877608665,888712635,13886134,17),(138225,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138225,32.75,0.8,35.5,66174,75,NULL,'A82, H','NGC 6181',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000013,NULL,'12.49',1.1,'SA(rs)c        HII','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,248.087333333,19.82656,0.229,NULL,56706716139,886042439,13844413,12.49),(138226,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138226,32.75,0.8,35.5,66174,75,NULL,'CF, r','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138227,'Sosies','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138227,32.72,0.08,35,66174,NULL,NULL,NULL,'NGC 6181',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138228,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138228,31.7,0.4,21.9,66174,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6181',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138229,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138229,31.94,0.69,24.5,66174,100,NULL,'mid-IR','NGC 6181',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138230,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138230,32.06,0.47,25.8,66174,75,NULL,'A82, H, raw','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138231,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138231,32.2,0.47,27.6,66174,75,NULL,'A82, H, inv','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138232,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138232,32.46,0.43,31.1,66174,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6181',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138233,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138233,32.5,0.47,31.6,66174,75,NULL,'A82, H, cor','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138234,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138234,32.53,0.43,32.1,66174,75,NULL,'3.6 micron, color corrected','NGC 6181',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138235,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138235,32.57,0.46,32.6,66174,NULL,NULL,'J','NGC 6181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138236,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138236,32.59,0.47,33,66174,NULL,NULL,'H','NGC 6181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138237,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138237,32.62,0.45,33.4,66174,NULL,NULL,'K','NGC 6181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138238,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138238,32.62,0.4,33.4,66174,NULL,NULL,'mean','NGC 6181',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138239,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138239,32.63,0.36,33.6,66174,NULL,NULL,NULL,'NGC 6181',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138240,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138240,32.64,0.38,33.7,66174,75,NULL,'CF, r, raw','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138241,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138241,32.76,0.2,35.7,66174,74.4,NULL,NULL,'NGC 6181',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138242,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138242,32.8,0.68,36.2,66174,NULL,NULL,'Malmquist cor.','NGC 6181',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138243,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138243,32.81,0.38,36.4,66174,75,NULL,'CF, r, inv','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138244,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138244,32.82,0.4,36.7,66174,75,NULL,'B','NGC 6181',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138245,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138245,32.88,0.38,37.7,66174,75,NULL,'CF, r, cor','NGC 6181',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138246,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138246,33.1,0.59,41.7,66174,NULL,NULL,NULL,'NGC 6181',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138247,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138247,37.33,0.46,292,66175,70,NULL,NULL,'2MASX J16322371+2630541',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000182,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.098791667,26.51511,0.097,NULL,56183092807,877860825,13716575,17.7),(138248,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138248,37.16,0.46,271,66176,70,NULL,NULL,'2MASX J16322473+2411132',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.103,24.18717,0.121,NULL,56176708676,877761073,13715016,16.9),(138249,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138249,37.88,0.46,377,66177,70,NULL,NULL,'SDSS J163224.99+321047.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.104167,32.17989,0.041,NULL,59754453973,933663343,14588489,18.3),(138250,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138250,38.35,0.46,467,66178,70,NULL,NULL,'2MASX J16322504+2648482',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,248.104333333,26.81342,0.125,NULL,56183181775,877862215,13716597,18.2),(138251,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138251,37.69,0.46,345,66179,70,NULL,NULL,'SDSS J163226.15+250706.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000125,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.1089583,25.11844,0.109,NULL,56177157238,877768081,13715126,18),(138252,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138252,38.01,0.46,399,66180,70,NULL,NULL,'2MASX J16322666+2719212',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.111125,27.32247,0.129,NULL,56181670251,877838597,13716228,17.6),(138253,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138253,36.64,0.46,213,66181,70,NULL,NULL,'2MASX J16323009-0005131',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,248.125375,-0.087,0.313,NULL,45164408958,705693889,11026467,16.8),(138254,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138254,38.8,NULL,575,66182,NULL,NULL,NULL,'ABELL 2205',NULL,'2012ApJ...748..113H',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,248.1315417,12.87833,0.181,NULL,56876190086,888690470,13885788,NULL),(138255,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138255,34.95,0.4,97.6,66183,NULL,NULL,'mean','NGC 6251',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000073,NULL,'8.0 R',1.5,'E;LERG         Sy2','Pair member, radial velocity confirmed',NULL,'FR I','unobscured Seyfert 2',1,248.133208333,82.53789,0.297,NULL,56954771155,889918299,13904973,8),(138256,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138256,34.97,0.45,98.8,66183,NULL,NULL,'K','NGC 6251',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138257,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138257,37.93,0.19,386,66184,70,NULL,NULL,'2MASX J16323287+1252438',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000175,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,248.136917,12.87886,0.181,NULL,56876160625,888690009,13885781,17.5),(138258,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138258,36.94,0.2,244,66185,74.4,NULL,NULL,'CGCG 138-036',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000133,NULL,'15.5g',0.32,'Sa',NULL,NULL,NULL,NULL,1,248.140833333,26.38069,0.097,NULL,56183499574,877867180,13716674,15.5),(138259,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138259,34.91,NULL,96.1,66186,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10452',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',NULL,NULL,'16.5',0.12,'Sbc',NULL,NULL,NULL,NULL,1,248.142125,67.74669,0.173,NULL,57838223069,903722235,14120659,16.5),(138260,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138260,34.93,NULL,96.8,66186,NULL,NULL,'Dipole + Quadrupole','UGC 10452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138261,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138261,34.94,NULL,97.2,66186,NULL,NULL,'Dipole','UGC 10452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138262,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138262,34.97,NULL,98.8,66186,NULL,NULL,NULL,'UGC 10452',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138263,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138263,37.28,0.46,286,66187,70,NULL,NULL,'2MASX J16323549+0941309',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.1479583,9.692,0.245,NULL,56756608852,886822013,13856593,17.5),(138264,'IRAS','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138264,33.93,0.8,61,66188,75,NULL,'MAT, I','ESO 452- G 008',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.62',0.3,'Sd? sp',NULL,NULL,NULL,NULL,1,248.1514583,-29.38494,0.965,NULL,46246522623,722601915,11290654,13.62),(138265,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138265,33.19,0.32,43.5,66188,85,NULL,'I, raw','ESO 452- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138266,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138266,33.2,0.32,43.7,66188,85,NULL,'I, inv','ESO 452- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138267,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138267,33.21,0.2,43.9,66188,74.4,NULL,NULL,'ESO 452- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138268,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138268,33.25,0.43,44.7,66188,75,NULL,'MAT, I, raw','ESO 452- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138269,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138269,33.35,0.43,46.7,66188,75,NULL,'MAT, I, inv','ESO 452- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138270,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138270,33.76,0.49,56.4,66188,75,NULL,'IR','ESO 452- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138271,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138271,33.81,0.43,57.8,66188,75,NULL,'MAT, I, cor','ESO 452- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138272,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138272,38.28,0.46,452,66189,70,NULL,NULL,'2MASX J16323642+2122170',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.151833333,21.37131,0.169,NULL,56696429170,885881705,13841901,17.8),(138273,'GRB','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138273,41.29,NULL,1810,66190,70,NULL,'Pseudo z = 0.57','GRB 010629A',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,248.16,-18.72,0.957,NULL,45967656895,718244638,11222572,NULL),(138274,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138274,31.74,NULL,22.3,66191,65.2,NULL,'CO','NGC 6217',NULL,'1997A&A...326..915T',1997,1,3,NULL,'G',0.000013,NULL,'11.79',2.5,'(R)SB(rs)bc;HIISy2','Group member',NULL,NULL,'H II',1,248.163333,78.19817,0.137,NULL,57138579630,892790306,13949848,11.79),(138275,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138275,31.89,0.4,23.9,66191,75,NULL,'B','NGC 6217',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138276,'Tully-Fisher','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138276,32.73,NULL,35.2,66191,54,NULL,'HI','NGC 6217',NULL,'1997A&A...326..915T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138277,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138277,37.22,0.46,278,66192,70,NULL,NULL,'2MASX J16324065+1453285',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.169541667,14.89128,0.193,NULL,56876871829,888701122,13885955,17.5),(138278,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,'R',138278,38.13,0.46,423,66193,70,NULL,NULL,'2MASX J16324179+3107101',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.174208333,31.1195,0.033,NULL,59786043786,934156934,14596202,17.7),(138279,'FP','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138279,35.1,0.54,105,66194,70,NULL,NULL,'2MASX J16324321-0228467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,248.1800417,-2.47978,0.573,NULL,46039987332,719374802,11240231,16.12),(138280,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138280,38.31,0.48,460,66195,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2204',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',0.000307,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,248.19375,5.57056,0.333,NULL,56717837275,886216207,13847128,NULL),(138281,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138281,38.7,NULL,550,66195,NULL,NULL,NULL,'ABELL 2204',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138282,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138282,38.93,0.23,610,66195,NULL,NULL,'Hydrost. Eq.','ABELL 2204',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138283,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138283,40.17,0.43,1080,66195,NULL,NULL,'Isotherm.','ABELL 2204',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138284,'SZ effect','2016-12-15 15:15:42','2016-12-16 11:20:57','1',NULL,NULL,138284,40.43,NULL,1220,66195,NULL,NULL,'3.1 (red) calibration','ABELL 2204',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138285,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138285,41.01,NULL,1590,66195,NULL,NULL,'4.2 (black) calibration','ABELL 2204',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138286,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138286,41.23,NULL,1760,66195,NULL,NULL,'4.1 (blue) calibration','ABELL 2204',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138287,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138287,38.45,0.46,489,66196,70,NULL,NULL,'2MASX J16324578+4122483',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.190625,41.38,0,NULL,59858870678,935294854,14613982,17.5),(138288,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138288,36.73,0.17,221,66197,70,NULL,NULL,'2MASX J16324743+1153466',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,248.19775,11.89639,0.213,NULL,56742753174,886605518,13853211,17.5),(138289,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138289,36.73,0.17,221,66198,70,NULL,NULL,'2MASX J16325063+1152036',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'16.77',0.37,NULL,NULL,NULL,NULL,NULL,1,248.211125,11.86772,0.189,NULL,56742751482,886605491,13853210,16.77),(138290,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138290,37.31,0.46,289,66199,70,NULL,NULL,'2MASX J16325087+1236475',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.2119583,12.61319,0.185,NULL,56876819966,888700311,13885942,17.4),(138291,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138291,37.94,0.46,387,66200,70,NULL,NULL,'2MASX J16325114+1223595',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.213291667,12.39975,0.185,NULL,56876807575,888700118,13885939,17.5),(138292,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138292,37.02,0.33,253,66201,70,NULL,NULL,'2MASX J16325305+4310331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000069,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.221125,43.17594,0.009,NULL,59859596987,935306202,14614159,17.6),(138293,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138293,36.73,0.17,221,66202,70,NULL,NULL,'2MASX J16325526+1142386',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'17.16',0.36,NULL,NULL,NULL,NULL,NULL,1,248.230291667,11.71069,0.201,NULL,56742900689,886607823,13853247,17.16),(138294,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138294,37.02,0.33,253,66203,70,NULL,NULL,'2MASX J16325588+4315401',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,248.23275,43.26103,0.009,NULL,59859563344,935305677,14614151,16.9),(138295,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138295,35.84,0.46,147,66204,70,NULL,NULL,'2MASX J16325590+2356448',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00011,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,248.233,23.94589,0.121,NULL,56649879888,885154373,13830537,15.4),(138296,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138296,36.58,0.21,207,66205,70,NULL,NULL,'VV 667 NED05',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.00007,NULL,'13.43',NULL,'E/S0',NULL,NULL,NULL,NULL,1,248.23825,50.4015,0,NULL,59831272546,934863633,14607244,13.43),(138297,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138297,36.72,0.46,220,66206,70,NULL,NULL,'2MASX J16325783+4231281',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.0001,NULL,'16.1g',0.32,'E0',NULL,NULL,NULL,NULL,1,248.2412083,42.52467,0,NULL,59858246581,935285102,14613829,16.1),(138298,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138298,37.97,0.46,393,66207,70,NULL,NULL,'2MASX J16325810+3541288',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.242125,35.69125,0.021,NULL,59751188054,933612313,14587692,17.7),(138299,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138299,36.18,0.2,172,66208,74.4,NULL,NULL,'CGCG 080-046',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000137,NULL,'15.2',0.3,'BrClG',NULL,NULL,NULL,NULL,1,248.2432083,11.72158,0.201,NULL,56742903107,886607861,13853247,15.2),(138300,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138300,36.38,0.25,189,66209,74.4,NULL,NULL,'VV 667 NED01',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',0.000223,NULL,NULL,NULL,'S?','Group member',NULL,NULL,NULL,1,248.244583,50.39861,0,NULL,59831272677,934863635,14607244,NULL),(138301,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138301,35.46,0.46,124,66210,70,NULL,NULL,'2MASX J16325894+2311510',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000103,NULL,'15.0g',0.51,NULL,NULL,NULL,NULL,NULL,1,248.245583333,23.19739,0.145,NULL,56652245465,885191335,13831114,15),(138302,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138302,36.88,0.27,237,66211,70,NULL,NULL,'2MASX J16330064+2613408',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000182,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,248.2527917,26.22808,0.093,NULL,56183404814,877865700,13716651,16.6),(138303,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138303,36.37,0.25,188,66212,74.4,NULL,NULL,'VV 667 NED06',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'14.79',NULL,'E/S0',NULL,NULL,NULL,NULL,1,248.2537083,50.39506,0,NULL,59831272664,934863635,14607244,14.79),(138304,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138304,36.58,0.21,207,66212,70,NULL,NULL,'VV 667 NED06',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138305,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138305,35.61,0.46,133,66213,70,NULL,NULL,'IC 4609',NULL,'2015arXiv151105856S',2015,1,0.87,NULL,'G',0.000187,NULL,'14.6g',0.8,'E/S0',NULL,NULL,NULL,NULL,1,248.25675,22.79739,0.153,NULL,56651899230,885185925,13831030,14.6),(138306,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138306,37.91,0.46,382,66214,70,NULL,NULL,'2MASX J16330271+3101419',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000187,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.26125,31.02819,0.037,NULL,59786066116,934157283,14596207,17.4),(138307,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138307,37.29,0.12,287,66215,70,NULL,NULL,'2MASX J16330324+2647428',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.2635,26.79508,0.125,NULL,56183218429,877862787,13716606,17.9),(138308,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138308,36.79,0.55,228,66216,70,NULL,NULL,'2MASX J16330405-0056366',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000111,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,248.266958333,-0.94367,0.393,NULL,46037332508,719333320,11239583,16.3),(138309,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138309,38.22,0.23,440,66217,70,NULL,NULL,'2MASX J16330563+2701518',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00018,NULL,'16.6g',0.38,'BrClG',NULL,NULL,NULL,NULL,1,248.2735,27.03106,0.129,NULL,56181362408,877833787,13716152,16.6),(138310,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138310,38.22,0.23,440,66218,70,NULL,NULL,'2MASX J16330578+2701398',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,248.274125,27.02778,0.129,NULL,56181362218,877833784,13716152,18.5),(138311,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138311,36.37,0.25,188,66219,74.4,NULL,NULL,'GIN 607',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000077,NULL,'16.1g',0.35,'S',NULL,NULL,NULL,NULL,1,248.275041667,50.53597,0,NULL,59827839280,934809988,14606406,16.1),(138312,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138312,36.58,0.21,207,66219,70,NULL,NULL,'GIN 607',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138313,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138313,37.93,0.19,386,66220,70,NULL,NULL,'2MASX J16330618+1257253',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.27575,12.95694,0.193,NULL,56876324777,888692574,13885821,18),(138314,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138314,37.71,0.46,348,66221,70,NULL,NULL,'2MASX J16330744+2448598',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.280958333,24.81658,0.093,NULL,56176739131,877761548,13715024,17.6),(138315,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138315,36.88,0.27,237,66222,70,NULL,NULL,'2MASX J16330948+2610318',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.289666667,26.17539,0.077,NULL,56183399519,877865617,13716650,17.6),(138316,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138316,36.58,0.21,207,66223,70,NULL,NULL,'GIN 608',NULL,'2001MNRAS.321..277C',2001,1,0.55,NULL,'G',0.000077,NULL,'15.8g',0.48,NULL,NULL,NULL,NULL,NULL,1,248.292375,50.30617,0,NULL,59831271536,934863617,14607244,15.8),(138317,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138317,38.22,0.23,440,66224,70,NULL,NULL,'2MASX J16331072+2701108',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.294833,27.01975,0.129,NULL,56181231067,877831735,13716120,17.8),(138318,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138318,37.29,0.12,287,66225,70,NULL,NULL,'2MASX J16331192+2700008',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.299875,27.00019,0.129,NULL,56181231299,877831739,13716120,17.3),(138319,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138319,37.38,0.46,300,66226,70,NULL,NULL,'2MASX J16331349+4615411',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,248.30625,46.26153,0,NULL,59841138351,935017786,14609652,17),(138320,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138320,36.36,0.25,187,66227,74.4,NULL,NULL,'VV 667 NED02',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00011,NULL,'13.88',0.8,'BrClG;E/S0','Group member',NULL,NULL,NULL,1,248.30775,50.39847,0,NULL,59831265917,934863529,14607242,13.88),(138321,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138321,36.58,0.21,207,66227,70,NULL,NULL,'VV 667 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138322,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138322,37.29,0.12,287,66228,70,NULL,NULL,'2MASX J16331428+2642368',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,248.309375,26.71033,0.097,NULL,56183130326,877861411,13716584,16.4),(138323,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138323,37.8,0.46,363,66229,70,NULL,NULL,'SDSS J163314.79+370205.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,248.311667,37.03486,0.025,NULL,59751322588,933614415,14587725,18.4),(138324,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138324,38.06,0.33,410,66230,70,NULL,NULL,'2MASX J16331494+2458248',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.312167,24.97353,0.109,NULL,56177538802,877774043,13715219,17.1),(138325,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138325,37.29,0.12,287,66231,70,NULL,NULL,'2MASX J16331757+2642218',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000201,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,248.3232083,26.706,0.097,NULL,56183131006,877861421,13716584,16.3),(138326,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138326,36.94,0.14,244,66232,70,NULL,NULL,'2MASX J16331761+1350283',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.3232917,13.84108,0.189,NULL,56877628572,888712946,13886139,17.1),(138327,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138327,37.31,0.46,290,66233,70,NULL,NULL,'2MASX J16331905+1357083',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.329291667,13.95239,0.209,NULL,56877497880,888710904,13886107,17.3),(138328,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138328,38.06,0.33,410,66234,70,NULL,NULL,'2MASX J16331995+2458048',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000143,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,248.333125,24.96794,0.109,NULL,56177540950,877774077,13715219,18.8),(138329,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138329,38.22,0.23,440,66235,70,NULL,NULL,'2MASX J16331997+2705099',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,248.333208333,27.08608,0.129,NULL,56181364937,877833827,13716153,18.7),(138330,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138330,36.05,0.46,163,66236,70,NULL,NULL,'2MASX J16332149+2248504',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000187,NULL,'16.1g',0.38,'S0',NULL,NULL,NULL,NULL,1,248.339541667,22.81422,0.153,NULL,56651903025,885185984,13831031,16.1),(138331,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138331,36.73,0.17,221,66237,70,NULL,NULL,'2MASX J16332209+1139102',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.48',0.33,NULL,NULL,NULL,NULL,NULL,1,248.342125,11.65278,0.201,NULL,56742870265,886607347,13853239,17.48),(138332,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138332,37.95,0.46,390,66238,70,NULL,NULL,'SDSS J163322.93+294743.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,248.3455417,29.79544,0.041,NULL,59731328721,933302011,14582843,18.7),(138333,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138333,36.88,0.27,237,66239,70,NULL,NULL,'2MASX J16332377+2558449',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.34925,25.97928,0.081,NULL,56183466877,877866669,13716666,17.5),(138334,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138334,37.44,0.46,308,66240,70,NULL,NULL,'2MASX J16332604+2703149',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00021,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,248.358458333,27.05433,0.129,NULL,56181241516,877831898,13716123,16.6),(138335,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138335,38.27,0.46,452,66241,70,NULL,NULL,'2MASX J16332817+3727109',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.367417,37.45297,0.017,NULL,59822840918,934731889,14605185,17.5),(138336,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138336,37.86,0.46,373,66242,70,NULL,NULL,'2MASX J16333022+2136354',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000051,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,248.375916667,21.60969,0.165,NULL,56696460660,885882197,13841909,16.8),(138337,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138337,37.7,0.46,347,66243,70,NULL,NULL,'2MASX J16333035+2738559',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.3767083,27.64886,0.129,NULL,56181733717,877839589,13716243,17.3),(138338,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138338,37.19,0.46,274,66244,70,NULL,NULL,'2MASX J16333345+3326392',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000143,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.389416667,33.44439,0.041,NULL,59754293535,933660836,14588450,17.3),(138339,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138339,36.73,0.17,221,66245,70,NULL,NULL,'2MASX J16333742+1152561',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,248.4059583,11.88225,0.189,NULL,56742672854,886604263,13853191,NULL),(138340,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138340,36.82,0.46,231,66246,70,NULL,NULL,'2MASX J16333858+2043485',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.4107083,20.73003,0.209,NULL,56703474981,885991796,13843621,16.4),(138341,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138341,36.94,0.14,244,66247,70,NULL,NULL,'2MASX J16333859+1358197',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,248.4107917,13.97233,0.209,NULL,56877483867,888710685,13886104,16.5),(138342,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138342,35.45,0.25,123,66248,74.4,NULL,NULL,'IC 4610',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.0001,NULL,'16.0g',0.23,'Sa(f)          AGN',NULL,NULL,NULL,NULL,1,248.413167,39.25764,0,NULL,59821643982,934713187,14604893,16),(138343,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138343,36.58,0.21,207,66249,70,NULL,NULL,'VV 667 NED04',NULL,'2001MNRAS.321..277C',2001,1,0.7,NULL,'G',NULL,'?','14.65',0.6,'S',NULL,NULL,NULL,NULL,1,248.4209583,50.37517,0,NULL,59831264317,934863504,14607242,14.65),(138344,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138344,35.76,0.06,142,66250,70,NULL,NULL,'2MASX J16334253+3935519',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.0001,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,248.427125,39.59781,0,NULL,59821721526,934714398,14604912,15.4),(138345,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138345,35.76,0.06,142,66251,70,NULL,NULL,'2MASX J16334254+4009109',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000156,NULL,'15.8g',0.33,'S0',NULL,NULL,NULL,NULL,1,248.427333333,40.15311,0,NULL,59821326848,934708232,14604816,15.8),(138346,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138346,37.82,0.46,367,66252,70,NULL,NULL,'2MASX J16334421+3235083',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00013,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.434333,32.58556,0.041,NULL,59754497178,933664018,14588500,18),(138347,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138347,37.53,0.46,321,66253,70,NULL,NULL,'2MASX J16334463+1131113',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,248.435917,11.51983,0.201,NULL,56754406506,886787601,13856056,17.9),(138348,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138348,37.29,0.12,287,66254,70,NULL,NULL,'2MASX J16334654+2650219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.4437917,26.83936,0.125,NULL,56183151812,877861747,13716589,17.6),(138349,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138349,38.23,0.46,442,66255,70,NULL,NULL,'2MASX J16334738+3739448',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.447417,37.66247,0.021,NULL,59822857372,934732146,14605189,17.6),(138350,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138350,35.81,0.33,145,66256,70,NULL,NULL,'2MASX J16334747+2536239',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000178,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,248.447875,25.60661,0.073,NULL,56175656452,877744632,13714759,15.6),(138351,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138351,31.23,0.4,17.6,66257,NULL,NULL,NULL,'UGC 10445',NULL,'2009AJ....138..323T',2009,1,1.35,NULL,'G',0.00001,NULL,'14.4g',0.97,'SBc            Sbrst','Isolated galaxy',NULL,NULL,NULL,1,248.448417,28.98478,0.049,NULL,56179469754,877804214,13715690,14.4),(138352,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138352,32.46,0.47,31.1,66257,NULL,NULL,NULL,'UGC 10445',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138353,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138353,32.5,0.2,31.6,66257,74.4,NULL,NULL,'UGC 10445',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138354,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138354,32.86,0.39,37.4,66257,NULL,NULL,'Malmquist cor.','UGC 10445',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138355,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138355,36.89,0.46,239,66258,70,NULL,NULL,'2MASX J16334869+1234238',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.452917,12.57336,0.181,NULL,56876736642,888699010,13885922,17.1),(138356,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138356,35.66,0.16,135,66259,70,NULL,NULL,'IC 4612',NULL,'2001MNRAS.321..277C',2001,1,0.75,'This is often incorrectly called IC 4610.','G',0.000053,NULL,'14.4g',0.74,'E/S0           AGN',NULL,NULL,NULL,NULL,1,248.45675,39.26319,0.013,NULL,59821652287,934713316,14604895,14.4),(138357,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138357,36.45,0.46,195,66260,70,NULL,NULL,'2MASX J16335192+2122325',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,248.46625,21.37578,0.169,NULL,56695921025,885873766,13841777,16.4),(138358,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138358,35.53,0.46,128,66261,70,NULL,NULL,'2MASX J16335213+2052595',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'15.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,248.467333,20.88308,0.201,NULL,56703569794,885993278,13843644,15.6),(138359,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138359,37.72,0.46,350,66262,70,NULL,NULL,'2MASX J16335343+1737279',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.472666667,17.62444,0.241,NULL,56662930429,885358287,13833723,17.6),(138360,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138360,41.52,0.66,1180,66263,72,NULL,NULL,'GRB 991208',0.7063,'2008JCAP...07..004M',2008,1,NULL,NULL,'G',0.0017,NULL,'19.5',NULL,'Ulysses/KO/NE',NULL,NULL,NULL,NULL,1,248.4730417,46.45583,0.009,NULL,59840485251,935007582,14609493,19.5),(138361,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138361,41.65,0.65,1250,66263,69.7,NULL,'Calibrated','GRB 991208',0.7063,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138362,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138362,41.69,0.67,1280,66263,70,NULL,NULL,'GRB 991208',0.7063,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138363,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138363,41.87,0.66,1390,66263,69.7,NULL,'Fiducial','GRB 991208',0.7063,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138364,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138364,43.35,0.86,2000,66263,73,NULL,'H const./H=100','GRB 991208',0.7063,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138365,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138365,43.43,0.29,2840,66263,72,NULL,NULL,'GRB 991208',0.7063,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138366,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138366,38.08,0.46,414,66264,70,NULL,NULL,'2MASX J16335406+2550118',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.4752083,25.83661,0.081,NULL,56175659889,877744685,13714760,17.6),(138367,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138367,36.66,0.46,215,66265,70,NULL,NULL,'2MASX J16335576+4725381',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.482208333,47.42725,0,NULL,59844272671,935066760,14610418,17),(138368,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138368,35.81,0.33,145,66266,70,NULL,NULL,'2MASX J16335631+2536548',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'15.7g',0.39,'S0',NULL,NULL,NULL,NULL,1,248.484708333,25.61517,0.073,NULL,56175656181,877744627,13714759,15.7),(138369,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138369,38.09,0.46,416,66267,70,NULL,NULL,'SDSS J163356.50+440816.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000078,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.4854583,44.13794,0,NULL,59846340838,935099075,14610923,18.3),(138370,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138370,37.6,0.46,331,66268,70,NULL,NULL,'2MASX J16335651+3200302',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.4855,32.00831,0.037,NULL,59755500871,933679701,14588745,18.2),(138371,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138371,35.15,0.63,107,66269,70,NULL,NULL,'2MASX J16335693-1021419',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,248.48725,-10.36169,0.829,NULL,46069602408,719837537,11247461,13.8),(138372,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138372,38.19,0.46,435,66270,70,NULL,NULL,'2MASX J16335831+2241495',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000192,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.492791667,22.69708,0.153,NULL,56651734938,885183358,13830989,16.9),(138373,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138373,37.29,0.12,287,66271,70,NULL,NULL,'2MASX J16335911+2653528',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000178,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.4962917,26.89797,0.133,NULL,56183107677,877861057,13716579,16.8),(138374,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138374,36.05,0.46,162,66272,70,NULL,NULL,'2MASX J16340035+2007565',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,248.5015417,20.13231,0.261,NULL,56706976996,886046515,13844476,17.1),(138375,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138375,35.59,0.46,131,66273,70,NULL,NULL,'KUGX 1632+363',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00008,NULL,'16.0g',0.41,'Compact',NULL,NULL,NULL,NULL,1,248.502333,36.29267,0.009,NULL,59751924805,933623825,14587872,16),(138376,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138376,35.17,0.49,108,66274,75,NULL,'IR','UGC 10450',NULL,'2011yCatp016004901K',2011,1,0.86,NULL,'G',0.000117,NULL,'16.5g',0.2,'Scd:','Group member, peripheral',NULL,NULL,NULL,1,248.503416667,36.19069,0.017,NULL,59751933017,933623953,14587874,16.5),(138377,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138377,35.76,0.1,142,66274,NULL,NULL,NULL,'UGC 10450',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138378,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138378,36.18,0.2,172,66274,74.4,NULL,NULL,'UGC 10450',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138379,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138379,37.78,0.46,360,66275,70,NULL,NULL,'2MASX J16340134+3508534',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.505625,35.14808,0.049,NULL,59749388415,933584193,14587253,17.8),(138380,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138380,38.44,0.46,487,66276,70,NULL,NULL,'2MASX J16340204+1420290',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.508625,14.34147,0.205,NULL,56889324078,888895688,13888995,17.9),(138381,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138381,37.68,0.46,344,66277,70,NULL,NULL,'SDSS J163404.33+172259.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.22,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.518083,17.38328,0.269,NULL,56662744778,885355387,13833677,17.7),(138382,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138382,35.92,0.46,153,66278,70,NULL,NULL,'2MASX J16340730+2336499',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.5305417,23.614,0.165,NULL,56652095778,885188996,13831078,17),(138383,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138383,35.34,0.46,117,66279,70,NULL,NULL,'2MASX J16340790+3428324',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000087,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,248.533125,34.47581,0.029,NULL,59757138074,933705282,14589145,16.5),(138384,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138384,36.38,0.46,189,66280,70,NULL,NULL,'2MASX J16340893+2609369',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.5372917,26.16028,0.077,NULL,56183355323,877864926,13716639,17.4),(138385,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138385,37.66,0.46,341,66281,70,NULL,NULL,'2MASX J16341412+2102479',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000155,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.55875,21.04669,0.185,NULL,56703351459,885989866,13843591,17),(138386,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138386,37.92,0.46,384,66282,70,NULL,NULL,'2MASX J16341446+3116015',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.56025,31.26719,0.033,NULL,59752687208,933635737,14588058,17.9),(138387,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138387,37.54,0.46,322,66283,70,NULL,NULL,'SDSS J163414.72+371931.1',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.561375,37.32533,0.009,NULL,59820796648,934699947,14604686,17.5),(138388,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138388,35.38,0.8,119,66284,75,NULL,'CF, r','UGC 10456',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000047,NULL,'14.70',1,'Sb',NULL,NULL,NULL,NULL,1,248.5622917,52.94108,0.045,NULL,57597008513,899953258,14061769,14.7),(138389,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138389,35.1,0.38,105,66284,75,NULL,'CF, r, raw','UGC 10456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138390,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138390,35.28,0.38,114,66284,75,NULL,'CF, r, inv','UGC 10456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138391,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138391,35.35,0.38,118,66284,75,NULL,'CF, r, cor','UGC 10456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138392,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138392,35.6,0.4,132,66284,NULL,NULL,'mean','UGC 10456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138393,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138393,35.8,0.47,144,66284,NULL,NULL,'H','UGC 10456',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138394,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138394,38.12,0.46,420,66285,70,NULL,NULL,'2MASX J16341530+1255174',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.563875,12.92167,0.193,NULL,56876262314,888691598,13885806,18.1),(138395,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138395,36.99,0.46,251,66286,70,NULL,NULL,'2MASX J16341548+2708179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.564417,27.13822,0.161,NULL,56181255880,877832123,13716126,17.6),(138396,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138396,36.96,0.46,246,66287,70,NULL,NULL,'2MASX J16341557+4448433',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.564833,44.81214,0,NULL,59845535251,935086488,14610726,16.8),(138397,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138397,36.1,0.49,166,66288,70,NULL,NULL,'2MASX J16341729-0004121',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000109,NULL,'15.5g',0.48,NULL,NULL,NULL,NULL,NULL,1,248.5719583,-0.07006,0.365,NULL,45165020941,705703452,11026616,15.5),(138398,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138398,36.1,0.46,166,66288,70,NULL,NULL,'2MASX J16341729-0004121',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138399,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138399,35.39,0.46,120,66289,70,NULL,NULL,'2MASX J16342016+1710004',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000172,NULL,'15.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,248.5840417,17.16686,0.265,NULL,56664137563,885377149,13834017,15.6),(138400,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138400,37.73,0.46,351,66290,70,NULL,NULL,'2MASX J16342064+2813449',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.5859583,28.22914,0.085,NULL,56182031266,877844238,13716316,17.1),(138401,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138401,37.66,0.46,341,66291,70,NULL,NULL,'2MASX J16342124+2434239',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.5885417,24.57314,0.109,NULL,56177969942,877780780,13715324,17.3),(138402,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138402,37.56,0.63,325,66292,70,NULL,NULL,'2MASX J16342180-6521302',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,248.590666667,-65.35833,0.729,NULL,44990097380,702970271,10983910,15.9),(138403,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138403,36.56,0.46,205,66293,70,NULL,NULL,'2MASX J16342265+4803428',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000185,NULL,'15.7g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,248.5945417,48.062,0.013,NULL,59843527393,935055115,14610236,15.7),(138404,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138404,36.73,0.17,221,66294,70,NULL,NULL,'2MASX J16342534+1136489',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.605583,11.61358,0.201,NULL,56754225280,886784770,13856012,16.7),(138405,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138405,35.64,0.16,129,66295,74.2,NULL,'SALT 2','UGC 10483',0.040695,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',NULL,NULL,'16.0',0.5,'S',NULL,NULL,NULL,NULL,1,248.620167,76.02972,0.137,NULL,57096704394,892136006,13939625,16),(138406,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138406,35.89,0.05,145,66295,70,NULL,'SALT 2','UGC 10483',0.040695,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138407,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138407,36.2,0.04,167,66295,72,NULL,'SALT','UGC 10483',0.040695,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138408,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138408,36.2,0.09,174,66295,74.4,NULL,NULL,'UGC 10483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138409,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138409,36.36,0.18,179,66295,65,NULL,'SALT','UGC 10483',0.040695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138410,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138410,36.39,0.15,182,66295,65,NULL,'MLCS17','UGC 10483',0.040695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138411,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138411,36.42,0.16,185,66295,70,NULL,'SALT 2','UGC 10483',0.040695,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138412,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138412,36.45,0.16,188,66295,73.8,NULL,'SALT 2 (SNANA)','UGC 10483',0.0403,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138413,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138413,36.47,0.15,189,66295,65,NULL,'MLCS31','UGC 10483',0.040695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138414,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2001az',NULL,138414,36.49,0.18,191,66295,65,NULL,'SALT2','UGC 10483',0.040695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138415,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138415,38.17,0.46,431,66296,70,NULL,NULL,'2MASX J16342922+4707303',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.621708333,47.12519,0,NULL,59844084290,935063817,14610372,17.2),(138416,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138416,37.3,0.46,288,66297,70,NULL,NULL,'2MASX J16343043+3104555',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.626667,31.08203,0.033,NULL,59752706401,933636037,14588063,18.3),(138417,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138417,37.38,0.46,299,66298,70,NULL,NULL,'2MASX J16343085+3741434',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000043,NULL,'16.6g',0.29,'Sy2',NULL,NULL,NULL,'Sy 2',1,248.628667,37.69544,0.021,NULL,59823063870,934735372,14605240,16.6),(138418,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138418,37.37,0.46,298,66299,70,NULL,NULL,'2MASX J16343243+4505003',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000075,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.635,45.08339,0,NULL,59838127408,934970740,14608917,17),(138419,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138419,36.12,NULL,167,66300,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2047',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000099,NULL,'17.1g',0.13,'Sb(f)',NULL,NULL,NULL,NULL,1,248.639458333,43.92203,0.005,NULL,59846326889,935098857,14610919,17.1),(138420,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138420,36.14,NULL,169,66300,NULL,NULL,'Dipole + Quadrupole','FGC 2047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138421,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138421,36.15,NULL,170,66300,NULL,NULL,NULL,'FGC 2047',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138422,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138422,36.17,NULL,172,66300,NULL,NULL,'Dipole','FGC 2047',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138423,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138423,37.81,0.46,365,66301,70,NULL,NULL,'2MASX J16343439+2009173',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.643167,20.15481,0.261,NULL,56706982032,886046594,13844478,18.1),(138424,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138424,34.62,0.49,83.8,66302,75,NULL,'IR','UGC 10460',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.00005,NULL,'16.0',0.17,'Sc',NULL,NULL,NULL,NULL,1,248.643583,57.31939,0,NULL,57706166751,901658855,14088419,16),(138425,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138425,38.23,0.46,443,66303,70,NULL,NULL,'SDSS J163434.81+123459.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.645041667,12.58311,0.189,NULL,56875884854,888685700,13885714,18.2),(138426,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138426,33.79,0.8,57.2,66304,75,NULL,'HMCL, I','ESO 137- G 032',NULL,'1997ApJS..109..333W',1997,1,1.96,'Star superposed.','G',0.000334,NULL,'15.24',0.17,'Sc;sm.comp.near,warp',NULL,NULL,NULL,NULL,1,248.645417,-62.04622,NULL,NULL,44495078519,695235601,10863056,15.24),(138427,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138427,32.83,0.4,36.8,66304,75,NULL,'HMCL, I, raw','ESO 137- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138428,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138428,32.86,0.4,37.4,66304,75,NULL,'HMCL, I, inv','ESO 137- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138429,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138429,33.12,0.4,42,66304,75,NULL,'HMCL, I, cor','ESO 137- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138430,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138430,33.18,NULL,43.3,66304,NULL,NULL,'Dipole + Quadrupole','ESO 137- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138431,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138431,33.19,NULL,43.4,66304,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 137- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138432,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138432,33.19,NULL,43.5,66304,NULL,NULL,'Dipole','ESO 137- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138433,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138433,37.25,0.46,282,66305,70,NULL,NULL,'2MASX J16343949+3604094',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,248.664666667,36.06944,0.017,NULL,59751083384,933610677,14587666,17.4),(138434,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138434,37.95,0.46,390,66306,70,NULL,NULL,'2MASX J16344021+2247133',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000173,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.6675417,22.78689,0.169,NULL,56648802795,885137543,13830274,16.8),(138435,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138435,35.57,0.21,130,66307,70,NULL,NULL,'2MASX J16344105+4430319',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.671166667,44.50894,0.005,NULL,59845550077,935086719,14610729,16.3),(138436,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138436,38.53,0.46,509,66308,70,NULL,NULL,'SDSS J163441.25+174437.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000129,NULL,'18.6g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.671917,17.74369,0.269,NULL,56662622728,885353480,13833648,18.6),(138437,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138437,38.1,0.46,417,66309,70,NULL,NULL,'2MASX J16344539+2158273',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'16.9g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,248.689167,21.97428,0.173,NULL,56696116276,885876816,13841825,16.9),(138438,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138438,35.89,0.33,151,66310,70,NULL,NULL,'2MASX J16344610+2339503',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000174,NULL,'15.9g',0.51,'S0/a',NULL,NULL,NULL,NULL,1,248.692167,23.66383,0.165,NULL,56648660423,885135319,13830239,15.9),(138439,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138439,36.85,0.46,234,66311,70,NULL,NULL,'2MASX J16344711+2823107',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.696417,28.38639,0.069,NULL,56182015861,877843997,13716312,17.5),(138440,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138440,36.35,0.46,186,66312,70,NULL,NULL,'2MASX J16344820+2457177',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.700875,24.95481,0.101,NULL,56178468094,877788563,13715446,16.6),(138441,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138441,36.28,0.27,180,66313,70,NULL,NULL,'2MASX J16344888+2616147',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00017,NULL,'16.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,248.7037917,26.27083,0.101,NULL,56183563414,877868178,13716690,16.6),(138442,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138442,37.54,0.46,323,66314,70,NULL,NULL,'SDSS J163449.15+305438.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.704833,30.91058,0.037,NULL,59752918203,933639346,14588114,18.2),(138443,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138443,37.29,0.12,287,66315,70,NULL,NULL,'2MASX J16344941+2639077',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000164,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.7060417,26.65208,0.133,NULL,56183656433,877869631,13716712,18),(138444,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138444,36.28,0.27,180,66316,70,NULL,NULL,'2MASX J16344977+2616567',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.707333,26.28233,0.101,NULL,56183563355,877868177,13716690,16.9),(138445,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138445,37.29,0.12,287,66317,70,NULL,NULL,'2MASX J16345307+2640217',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000174,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,248.721,26.67264,0.133,NULL,56183654056,877869594,13716712,16.4),(138446,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138446,36.52,0.46,201,66318,70,NULL,NULL,'2MASX J16345390+3243507',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.7247083,32.73069,0.045,NULL,59755000597,933671884,14588623,16.8),(138447,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138447,36.28,0.27,180,66319,70,NULL,NULL,'CGCG 138-041',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.00017,NULL,'15.2g',0.46,'E0',NULL,NULL,NULL,NULL,1,248.7267083,26.27478,0.101,NULL,56183556134,877868064,13716688,15.2),(138448,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138448,34.11,0.49,66.4,66320,75,NULL,'IR','UGC 10453',NULL,'2011yCatp016004901K',2011,1,1.75,NULL,'G',0.000005,NULL,'15.8g',0.22,'Sd',NULL,NULL,NULL,NULL,1,248.7307083,20.57881,0.245,NULL,56706460259,886038441,13844350,15.8),(138449,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138449,34.16,NULL,67.8,66320,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138450,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138450,34.17,NULL,68.2,66320,NULL,NULL,'Dipole + Quadrupole','UGC 10453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138451,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138451,34.17,NULL,68.3,66320,NULL,NULL,'Dipole','UGC 10453',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138452,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138452,34.22,NULL,69.9,66320,NULL,NULL,NULL,'UGC 10453',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138453,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138453,34.44,0.2,77.3,66320,74.4,NULL,NULL,'UGC 10453',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138454,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138454,36.58,0.27,207,66321,70,NULL,NULL,'2MASX J16345675+2557318',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,248.736375,25.95881,0.077,NULL,56175798531,877746852,13714794,16.3),(138455,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138455,37.29,0.12,287,66322,70,NULL,NULL,'2MASX J16345865+2625548',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.744333,26.432,0.125,NULL,56183611743,877868933,13716702,17.4),(138456,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138456,36.75,0.6,224,66323,70,NULL,NULL,'2MASX J16350063-6530265',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,'SAB(r)0^+',NULL,NULL,NULL,NULL,1,248.7525,-65.50761,0.729,NULL,44989614097,702962720,10983792,15.4),(138457,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138457,37.29,0.12,287,66324,70,NULL,NULL,'2MASX J16350267+2632338',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.7610417,26.54267,0.125,NULL,56183572706,877868323,13716692,16.6),(138458,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138458,35.89,0.33,151,66325,70,NULL,NULL,'2MASX J16350305+2336422',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,248.7627917,23.61183,0.165,NULL,56648622889,885134732,13830230,16.4),(138459,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138459,38.03,0.46,404,66326,70,NULL,NULL,'2MASX J16350358+2458589',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,248.764833,24.98303,0.089,NULL,56178474307,877788661,13715447,17.8),(138460,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138460,37.82,0.46,366,66327,70,NULL,NULL,'2MASX J16350355+3655184',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.764958333,36.92192,0.025,NULL,59750467838,933601059,14587516,17.5),(138461,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138461,37.31,0.27,290,66328,70,NULL,NULL,'2MASX J16350394+2727268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,248.766333,27.45731,0.169,NULL,56181632308,877838004,13716218,17.8),(138462,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138462,37.56,0.46,325,66329,70,NULL,NULL,'2MASX J16350545+2856388',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.772625,28.94422,0.049,NULL,56179424082,877803501,13715679,17),(138463,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138463,37.65,0.46,339,66330,70,NULL,NULL,'2MASX J16350636+4416010',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000082,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.776625,44.26692,0,NULL,59846373082,935099579,14610930,17.4),(138464,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138464,35.38,NULL,119,66331,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10459',NULL,'2010Ap&SS.325..163P',2010,1,1.83,NULL,'G',0.000034,NULL,'15.6g',0.22,'Sd(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,248.7827917,40.99136,0,NULL,59858008983,935281390,14613771,15.6),(138465,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138465,35.39,NULL,120,66331,NULL,NULL,'Dipole + Quadrupole','UGC 10459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138466,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138466,35.4,NULL,120,66331,NULL,NULL,'Dipole','UGC 10459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138467,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138467,35.71,NULL,139,66331,NULL,NULL,NULL,'UGC 10459',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138468,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138468,35.81,0.2,145,66331,74.4,NULL,NULL,'UGC 10459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138469,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138469,37.54,0.46,321,66332,70,NULL,NULL,'2MASX J16350890+2935538',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.7872083,29.59833,0.049,NULL,56178567916,877790123,13715470,17.6),(138470,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138470,35.62,0.4,133,66333,NULL,NULL,'mean','IC 1222',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.16',1.3,'SAB(s)c','Parent (of companion) galaxy',NULL,NULL,NULL,1,248.788333,46.21392,0.009,NULL,59840619166,935009674,14609526,14.16),(138471,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138471,35.73,0.47,140,66333,NULL,NULL,'H','IC 1222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138472,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138472,37.31,0.27,290,66334,70,NULL,NULL,'2MASX J16350942+2725208',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.76',0.32,NULL,NULL,NULL,NULL,NULL,1,248.7892917,27.42239,0.169,NULL,56181651511,877838304,13716223,17.76),(138473,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138473,37.05,0.46,257,66335,70,NULL,NULL,'2MASX J16351072-0007038',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000091,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.794583,-0.11767,0.353,NULL,45164854600,705700853,11026575,17.2),(138474,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138474,36.13,0.57,168,66336,70,NULL,NULL,'2MASX J16351097-7310098',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,248.7957083,-73.16947,0.261,NULL,44116252781,689316449,10770569,15),(138475,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138475,36.28,0.66,180,66337,70,NULL,NULL,'2MASX J16351168-6343304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,248.7987083,-63.72517,0.877,NULL,44461117837,694704966,10854765,15.2),(138476,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138476,37.29,0.12,287,66338,70,NULL,NULL,'2MASX J16351252+2637488',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000185,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.802083,26.63039,0.133,NULL,56182902321,877857848,13716528,17.2),(138477,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138477,37.8,0.46,362,66339,70,NULL,NULL,'2MASX J16351255+4542139',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000159,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,248.802333,45.70397,0,NULL,59838634895,934978670,14609041,17.9),(138478,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138478,32.47,0.8,31.1,66340,75,NULL,'HMCL, I','ESO 137- G 034',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000022,NULL,'12.21',1.1,'SAB(s)0/a?     Sy2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,248.808791667,-58.08003,NULL,NULL,44548181449,696065335,10876020,12.21),(138479,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138479,32.46,0.4,31,66340,75,NULL,'HMCL, I, raw','ESO 137- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138480,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138480,32.67,0.4,34.1,66340,75,NULL,'HMCL, I, inv','ESO 137- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138481,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138481,32.75,0.4,35.6,66340,75,NULL,'HMCL, I, cor','ESO 137- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138482,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138482,36.82,0.46,231,66341,70,NULL,NULL,'2MASX J16351473+3104070',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.8115,31.06856,0.029,NULL,59752670354,933635474,14588054,16.8),(138483,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138483,38.21,0.46,439,66342,70,NULL,NULL,'2MASX J16351545+2144197',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.814333,21.73892,0.165,NULL,56695793398,885871771,13841746,17.4),(138484,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138484,37.31,0.27,290,66343,70,NULL,NULL,'2MASX J16351768+2726578',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,248.823833333,27.44956,0.169,NULL,56181652188,877838315,13716223,16.3),(138485,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138485,37.29,0.12,287,66344,70,NULL,NULL,'2MASX J16351841+2637018',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000195,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.82675,26.61722,0.133,NULL,56182868873,877857326,13716520,16.6),(138486,'Tully est','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138486,33.07,0.8,41,66345,75,NULL,'B','UGCA 412',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.000013,NULL,'16.0',0.2,'BlueCG         Sbrst','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,248.8375,52.21453,0.017,NULL,59693455867,932710247,14573597,16),(138487,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138487,37.43,0.46,306,66346,70,NULL,NULL,'SDSS J163522.35+113759.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.1g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.843167,11.63328,0.165,NULL,56750001704,886718776,13854980,18.1),(138488,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138488,35.88,0.46,150,66347,70,NULL,NULL,'2MASX J16352321+1451222',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,248.846667,14.85608,0.205,NULL,56888578681,888884041,13888813,16.6),(138489,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138489,36.65,0.46,213,66348,70,NULL,NULL,'2MASX J16352425+4144554',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,248.8510417,41.74883,0,NULL,59858040623,935281884,14613779,16.3),(138490,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138490,37.39,0.46,300,66349,70,NULL,NULL,'2MASX J16352585+2254528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.857583,22.91481,0.165,NULL,56648822803,885137856,13830279,17.4),(138491,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138491,37.53,0.46,321,66350,70,NULL,NULL,'2MASX J16352631+1456442',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,248.8597917,14.94556,0.205,NULL,56888535040,888883360,13888802,17.8),(138492,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138492,36.58,0.27,207,66351,70,NULL,NULL,'2MASX J16352672+2555452',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00019,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,248.861291667,25.92911,0.077,NULL,56175791464,877746741,13714792,16),(138493,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138493,36.45,0.46,195,66352,70,NULL,NULL,'2MASX J16352751+3636004',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00007,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,248.864667,36.60011,0.005,NULL,59750318029,933598719,14587479,16.5),(138494,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138494,36.9,0.46,240,66353,70,NULL,NULL,'2MASX J16353201+2615242',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'15.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,248.883416667,26.25683,0.101,NULL,56176282082,877754407,13714912,15.9),(138495,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138495,36.35,0.46,186,66354,70,NULL,NULL,'2MASX J16353332+2552102',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000107,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,248.8889583,25.86961,0.089,NULL,56175706754,877745418,13714772,16.3),(138496,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138496,37.11,0.46,264,66355,70,NULL,NULL,'2MASX J16353618+3749142',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00009,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,248.900708333,37.82064,0.009,NULL,59820925783,934701965,14604718,16.8),(138497,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138497,37.29,0.12,287,66356,70,NULL,NULL,'2MASX J16353682+2630172',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000171,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,248.903583,26.50489,0.125,NULL,56182898058,877857782,13716527,16.3),(138498,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138498,37.76,0.46,357,66357,70,NULL,NULL,'2MASX J16353712+1202133',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.9047083,12.03711,0.185,NULL,56881066949,888766671,13886979,17.4),(138499,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138499,35.25,0.33,112,66358,70,NULL,NULL,'2MASX J16353863+0018425',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000076,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.910917,0.31181,0.333,NULL,55972497165,874570268,13665160,16.5),(138500,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138500,35.25,0.33,112,66359,70,NULL,NULL,'CGCG 024-018',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000111,NULL,'14.4g',0.78,NULL,NULL,NULL,NULL,NULL,1,248.920083,0.33139,0.333,NULL,55972499451,874570303,13665160,14.4),(138501,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138501,37.31,0.46,289,66360,70,NULL,NULL,'2MASX J16354156+4036252',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,248.923333,40.60717,0.005,NULL,59853805906,935215717,14612745,17.4),(138502,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138502,37.29,0.12,287,66361,70,NULL,NULL,'2MASX J16354233+2649472',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'16.0r',NULL,NULL,NULL,NULL,NULL,NULL,1,248.926417,26.82981,0.161,NULL,56182809440,877856397,13716506,16),(138503,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138503,37.99,0.46,397,66362,70,NULL,NULL,'2MASX J16354366+2708423',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.3g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,248.931875,27.14514,0.173,NULL,56180791543,877824867,13716013,17.3),(138504,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138504,38.16,0.33,428,66363,70,NULL,NULL,'2MASX J16354434+3117037',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,248.934625,31.28447,0.041,NULL,59752756537,933636820,14588075,17.9),(138505,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138505,35.87,0.46,149,66364,70,NULL,NULL,'2MASX J16354443+2613433',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000133,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,248.93525,26.22861,0.101,NULL,56176293398,877754584,13714915,16.7),(138506,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138506,34.93,NULL,96.7,66365,NULL,NULL,'Dipole','UGC 10478',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',0.000023,NULL,'16.0',0.24,'Sc',NULL,NULL,NULL,NULL,1,248.935375,68.42828,0.173,NULL,57847105102,903861017,14122828,16),(138507,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138507,34.93,NULL,96.9,66365,NULL,NULL,'Dipole + Quadrupole','UGC 10478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138508,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138508,34.93,NULL,97,66365,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10478',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138509,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138509,35.18,0.49,108,66365,75,NULL,'IR','UGC 10478',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138510,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138510,35.41,0.37,121,66365,NULL,NULL,'Malmquist cor.','UGC 10478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138511,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138511,35.56,0.34,129,66365,NULL,NULL,NULL,'UGC 10478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138512,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138512,35.6,0.2,132,66365,74.4,NULL,NULL,'UGC 10478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138513,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138513,36.15,0.62,170,66366,70,NULL,NULL,'2MASX J16354720-7747230',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,248.9462917,-77.78969,0.517,NULL,44263016034,691609625,10806400,16.9),(138514,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138514,38.47,0.46,494,66367,70,NULL,NULL,'SDSS J163547.41+140920.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,248.9475417,14.15561,0.257,NULL,56888783654,888887244,13888863,18.4),(138515,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138515,38.39,0.46,476,66368,70,NULL,NULL,'2MASX J16354820+2442123',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,248.95075,24.70328,0.101,NULL,56177840604,877778759,13715293,17.9),(138516,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138516,36.73,0.46,222,66369,70,NULL,NULL,'2MASX J16355021+4717374',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,248.959333,47.29386,0,NULL,59843931503,935061429,14610334,16.4),(138517,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138517,39.1,0.42,660,66370,NULL,NULL,'Hydrost. Eq.','ABELL 2218',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,248.968333,66.21444,0.077,NULL,57821767898,903465123,14116642,NULL),(138518,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138518,39.35,0.71,740,66370,NULL,NULL,NULL,'ABELL 2218',NULL,'1994ApJ...420...33B',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138519,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138519,39.54,NULL,809,66370,NULL,NULL,NULL,'ABELL 2218',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138520,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138520,39.75,1.44,890,66370,NULL,NULL,NULL,'ABELL 2218',NULL,'1998PASJ...50..169T',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138521,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138521,40.06,NULL,1030,66370,NULL,NULL,NULL,'ABELL 2218',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138522,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138522,40.13,NULL,1060,66370,75,NULL,NULL,'ABELL 2218',NULL,'1982ApJ...257..473B',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138523,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138523,40.15,0.41,1070,66370,NULL,NULL,'Isotherm.','ABELL 2218',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138524,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138524,40.36,0.41,1180,66370,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2218',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138525,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138525,40.91,NULL,1520,66370,NULL,NULL,'3.1 (red) calibration','ABELL 2218',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138526,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138526,41.02,NULL,1600,66370,NULL,NULL,'4.2 (black) calibration','ABELL 2218',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138527,'SZ effect','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138527,41.22,NULL,1750,66370,NULL,NULL,'4.1 (blue) calibration','ABELL 2218',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138528,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138528,39.12,0.14,667,66370,NULL,NULL,'ABELL 2218 cluster, avg. of 8 spiral galaxies','ABELL 2218',NULL,'2003AJ....126..675D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138529,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138529,36.87,0.46,236,66371,70,NULL,NULL,'2MASX J16355553+3815482',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,248.981333333,38.26342,0.005,NULL,59823165641,934736963,14605265,17.3),(138530,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138530,38.06,0.46,410,66372,70,NULL,NULL,'2MASX J16355613+3819382',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,248.983875,38.32722,0.005,NULL,59822477945,934726217,14605097,17.4),(138531,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138531,37.68,0.46,344,66373,70,NULL,NULL,'2MASX J16355947+4343069',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000084,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,248.997917,43.7185,0,NULL,59845731015,935089547,14610774,16.9),(138532,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138532,36.64,0.56,213,66374,70,NULL,NULL,'2MASX J16355975-6613014',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,248.999083,-66.21714,0.573,NULL,44991322033,702989406,10984209,15.3),(138533,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138533,38.16,0.33,428,66375,70,NULL,NULL,'SDSS J163559.99+312721.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,249,31.45594,0.053,NULL,59752774979,933637109,14588079,18.3),(138534,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138534,37.72,0.46,350,66376,70,NULL,NULL,'2MASX J16360183+3311458',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000142,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.007667,33.19611,0.041,NULL,59754926613,933670728,14588605,17.7),(138535,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138535,38.01,0.46,400,66377,70,NULL,NULL,'SDSS J163602.20+120511.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.009167,12.08653,0.177,NULL,56881118458,888767475,13886991,18.3),(138536,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138536,36.88,0.33,237,66378,70,NULL,NULL,'SDSS J163603.54+263145.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'17.9g',0.12,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.0147917,26.52928,0.125,NULL,56182860391,877857193,13716518,17.9),(138537,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138537,36.06,0.65,163,66379,70,NULL,NULL,'2MASX J16360409-6403032',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.017166667,-64.05094,0.797,NULL,44474461369,694913458,10858022,15.8),(138538,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138538,38.1,0.46,418,66380,70,NULL,NULL,'2MASX J16360549+3239308',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000197,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.0227917,32.65861,0.045,NULL,59754814026,933668969,14588577,16.8),(138539,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138539,36.88,0.33,237,66381,70,NULL,NULL,'2MASX J16360777+2630594',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000187,NULL,'15.7g',0.59,'E0',NULL,NULL,NULL,NULL,1,249.032333333,26.51658,0.125,NULL,56182861017,877857203,13716518,15.7),(138540,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138540,37.34,0.46,294,66382,70,NULL,NULL,'2MASX J16360875+2245345',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.0365,22.75953,0.165,NULL,56694693583,885854587,13841477,17.7),(138541,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138541,35.57,0.21,130,66383,70,NULL,NULL,'2MASX J16361142+4406540',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000079,NULL,'15.9g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,249.04775,44.11497,0.013,NULL,59846407254,935100113,14610939,15.9),(138542,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138542,37.98,0.46,394,66384,70,NULL,NULL,'2MASX J16361224+2649264',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,249.051125,26.82403,0.161,NULL,56182944181,877858502,13716539,18.6),(138543,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138543,36.58,0.27,207,66385,70,NULL,NULL,'CGCG 138-043',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00012,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,249.053083,25.93125,0.097,NULL,56176368399,877755756,13714933,15.4),(138544,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138544,37,0.46,252,66386,70,NULL,NULL,'2MASX J16361302+2923324',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.05425,29.39244,0.049,NULL,56224759713,878511870,13726747,18),(138545,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138545,37.64,0.33,337,66387,70,NULL,NULL,'2MASX J16361347+1220352',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.056,12.34303,0.189,NULL,56889672278,888901129,13889080,18.2),(138546,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138546,37.56,0.33,325,66388,70,NULL,NULL,'2MASX J16361561+2802394',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.064917,28.04431,0.129,NULL,56180887796,877826371,13716037,17.1),(138547,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138547,37.81,0.33,364,66389,70,NULL,NULL,'2MASX J16361627+4027097',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.06775,40.45269,0.005,NULL,59821281563,934707524,14604805,17.2),(138548,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138548,37.77,0.46,358,66390,70,NULL,NULL,'2MASX J16361674+3140093',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.0697917,31.66936,0.045,NULL,59755583341,933680989,14588765,17.9),(138549,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138549,37.56,0.33,325,66391,70,NULL,NULL,'2MASX J16361885+2757314',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.0785417,27.95875,0.145,NULL,56181115841,877829935,13716092,17.1),(138550,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138550,38.27,0.46,451,66392,70,NULL,NULL,'2MASX J16362122+2435243',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.088333,24.59,0.109,NULL,56175024182,877734752,13714605,17.9),(138551,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138551,35.57,0.21,130,66393,70,NULL,NULL,'2MASX J16362472+4416480',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000076,NULL,'15.8g',0.33,'E0',NULL,NULL,NULL,NULL,1,249.103166667,44.28011,0,NULL,59846264233,935097878,14610904,15.8),(138552,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138552,37.99,0.46,396,66394,70,NULL,NULL,'2MASX J16362493+3922437',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.1037917,39.379,0.013,NULL,59821952575,934718008,14604968,17.4),(138553,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138553,38.11,0.33,418,66395,70,NULL,NULL,'2MASX J16362625+2919493',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.109416667,29.33025,0.057,NULL,56224766572,878511977,13726749,17.7),(138554,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138554,37.35,0.46,295,66396,70,NULL,NULL,'2MASX J16362652+1055105',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.110625,10.91967,0.237,NULL,56750498827,886726544,13855102,16.3),(138555,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138555,36.24,0.75,177,66397,70,NULL,NULL,'2MASX J16362810-6748136',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,'SB(r)0/a:',NULL,NULL,NULL,NULL,1,249.116708333,-67.80389,0.445,NULL,45023171725,703487058,10991985,15.2),(138556,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138556,37.64,0.33,337,66398,70,NULL,NULL,'2MASX J16362835+1220012',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.118125,12.33361,0.189,NULL,56881201560,888768774,13887012,17.1),(138557,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138557,38.11,0.33,418,66399,70,NULL,NULL,'2MASX J16363123+2925283',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.130166667,29.42456,0.065,NULL,56224755682,878511807,13726746,18.2),(138558,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138558,35.67,0.2,136,66400,74.4,NULL,NULL,'NGC 6195',NULL,'2013AJ....146...86T',2013,1,1.48,NULL,'G',0.000034,NULL,'14.0g',0.83,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,249.1357083,39.02789,0.005,NULL,59821943538,934717867,14604966,14),(138559,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138559,35.71,0.43,139,66400,75,NULL,'3.6 micron, color corrected','NGC 6195',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138560,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138560,35.96,0.43,155,66400,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6195',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138561,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138561,38.15,0.46,427,66401,70,NULL,NULL,'2MASX J16363380+1430152',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.141,14.50422,0.217,NULL,56889089307,888892020,13888937,17.5),(138562,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138562,36.97,0.46,248,66402,70,NULL,NULL,'2MASX J16363383+2341167',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.141083,23.68808,0.153,NULL,56649313165,885145518,13830398,16.8),(138563,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138563,37.55,0.46,323,66403,70,NULL,NULL,'2MASX J16363392+2134337',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.141333,21.57606,0.209,NULL,56697799922,885903123,13842236,17.1),(138564,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138564,36.55,0.46,204,66404,70,NULL,NULL,'2MASX J16363434+2321517',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.143041667,23.36447,0.161,NULL,56648884559,885138821,13830294,17.1),(138565,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138565,37.6,0.46,331,66405,70,NULL,NULL,'2MASX J16363515+3554014',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000189,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.1464583,35.90031,0.025,NULL,59750740007,933605312,14587583,16.9),(138566,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138566,33.96,0.43,62,66406,NULL,NULL,NULL,'ESO 101- G 001',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.75',0.6,'Sb',NULL,NULL,NULL,NULL,1,249.146958333,-66.00675,0.569,NULL,44991450010,702991406,10984240,14.75),(138567,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138567,34,0.2,63.1,66406,74.4,NULL,NULL,'ESO 101- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138568,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138568,34.12,0.4,66.8,66406,NULL,NULL,'Malmquist cor.','ESO 101- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138569,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138569,38.95,0.46,616,66407,70,NULL,NULL,'2MASX J16363697+3222274',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,249.154,32.37439,0.041,NULL,59756173260,933690207,14588909,18.1),(138570,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138570,34.82,0.33,92.2,66408,70,NULL,NULL,'NGC 6194',NULL,'2015arXiv151105856S',2015,1,1,NULL,'G',0.000087,NULL,'14.1g',0.8,'Compact',NULL,NULL,NULL,NULL,1,249.1547917,36.20044,0.017,NULL,59750762200,933605659,14587588,14.1),(138571,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138571,36.9,0.27,240,66409,70,NULL,NULL,'2MASX J16363729+2512483',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.69',0.36,NULL,NULL,NULL,NULL,NULL,1,249.155541667,25.21353,0.077,NULL,56178181224,877784081,13715376,16.69),(138572,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138572,36.5,0.53,200,66410,70,NULL,NULL,'2MASX J16363969-6548557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.1655,-65.81556,0.569,NULL,44991445703,702991339,10984239,15.4),(138573,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138573,37.61,0.33,333,66411,70,NULL,NULL,'2MASX J16364090+3434314',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.17025,34.57528,0.029,NULL,59756932127,933702064,14589094,17.8),(138574,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138574,37.07,0.33,259,66412,70,NULL,NULL,'2MASX J16364092+4418271',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.170583333,44.30744,0,NULL,59845997632,935093713,14610839,16.9),(138575,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138575,37.45,0.33,309,66413,70,NULL,NULL,'2MASX J16364146+4146347',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.172875,41.77639,0,NULL,59846611084,935103298,14610989,18.4),(138576,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138576,38.18,0.33,433,66414,70,NULL,NULL,'2MASX J16364243+2846313',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000201,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.1767083,28.77533,0.069,NULL,56225120811,878517512,13726836,17.4),(138577,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138577,36.44,0.71,194,66415,70,NULL,NULL,'2MASX J16364352-1940160',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.181417,-19.67114,1.085,NULL,45966691570,718229555,11222336,15.7),(138578,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138578,38.18,0.33,433,66416,70,NULL,NULL,'2MASX J16364372+2847523',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.182083,28.79786,0.069,NULL,56225056469,878516507,13726820,17.7),(138579,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138579,38.42,0.46,482,66417,70,NULL,NULL,'SDSS J163644.18+193322.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.184083,19.55628,0.289,NULL,56693362659,885833791,13841152,18.2),(138580,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138580,37.57,0.46,327,66418,70,NULL,NULL,'2MASX J16364463+2928553',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.186208333,29.48214,0.065,NULL,56224878880,878513732,13726777,17.3),(138581,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138581,35.77,0.46,142,66419,70,NULL,NULL,'2MASX J16364525+1309529',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,249.1885,13.16472,0.205,NULL,56890281826,888910653,13889228,16.2),(138582,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138582,37.45,0.33,309,66420,70,NULL,NULL,'2MASX J16364668+4153151',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000096,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.194708333,41.88769,0,NULL,59847339858,935114685,14611166,16.7),(138583,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138583,37.62,0.46,334,66421,70,NULL,NULL,'2MASX J16364845+1705039',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.2020417,17.08439,0.273,NULL,56664830594,885387978,13834187,17.1),(138584,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138584,36.35,0.46,186,66422,70,NULL,NULL,'2MASX J16365089+3115091',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',NULL,NULL,'16.73',0.42,NULL,NULL,NULL,NULL,NULL,1,249.2120417,31.25256,0.041,NULL,59752906392,933639162,14588111,16.73),(138585,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138585,37.03,0.46,255,66423,70,NULL,NULL,'2MASX J16365439+2900533',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000215,NULL,'15.7g',0.47,NULL,NULL,NULL,NULL,NULL,1,249.226667,29.01483,0.049,NULL,56225093068,878517079,13726829,15.7),(138586,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138586,37.04,0.46,256,66424,70,NULL,NULL,'2MASX J16365489+4400571',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000095,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.2287917,44.01586,0.013,NULL,59846190951,935096733,14610886,16.7),(138587,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138587,37.73,0.46,352,66425,70,NULL,NULL,'2MASX J16365687+2338346',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.237125,23.64281,0.161,NULL,56649144408,885142881,13830357,17.4),(138588,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138588,37.99,0.46,396,66426,70,NULL,NULL,'2MASX J16365835+3734593',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.243125,37.58333,0.021,NULL,59821018553,934703414,14604740,17.4),(138589,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138589,38.09,0.46,414,66427,70,NULL,NULL,'2MASX J16365893+2618143',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.245417,26.30386,0.125,NULL,56175559228,877743112,13714736,17.3),(138590,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138590,37.61,0.33,333,66428,70,NULL,NULL,'2MASX J16370138+3431472',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000117,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.255833,34.52978,0.029,NULL,59759759532,933746242,14589785,16.8),(138591,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138591,35.57,0.21,130,66429,70,NULL,NULL,'2MASX J16370198+4420081',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000087,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,249.2582083,44.33561,0,NULL,59845999910,935093748,14610839,15.5),(138592,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138592,37.61,0.46,333,66430,70,NULL,NULL,'2MASX J16370228+1242219',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000196,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.259583,12.70622,0.193,NULL,56889512691,888898635,13889041,17.6),(138593,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138593,37.81,0.33,364,66431,70,NULL,NULL,'2MASX J16370247+4030093',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000127,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,249.2602083,40.50278,0.005,NULL,59821299336,934707802,14604809,16.6),(138594,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138594,37.62,0.46,334,66432,70,NULL,NULL,'2MASX J16370322+0023558',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.263583,0.39872,0.333,NULL,55972561236,874571269,13665176,18),(138595,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138595,35.19,0.46,109,66433,70,NULL,NULL,'CGCG 138-046',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000157,NULL,'15.1g',0.62,'E0',NULL,NULL,NULL,NULL,1,249.2637083,21.05533,0.217,NULL,56705190265,886018597,13844040,15.1),(138596,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138596,37.11,0.46,264,66434,70,NULL,NULL,'2MASX J16370518-0022244',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000092,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.2717083,-0.37336,0.409,NULL,45166723857,705730060,11027032,17.2),(138597,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138597,37.02,0.46,253,66435,70,NULL,NULL,'2MASX J16370524+2216186',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,249.2717083,22.27178,0.201,NULL,56698371009,885912047,13842375,16.3),(138598,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138598,37.07,0.33,259,66436,70,NULL,NULL,'2MASX J16370588+4416111',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000087,NULL,'15.8g',0.47,'E0',NULL,NULL,NULL,NULL,1,249.274625,44.26975,0,NULL,59845985503,935093523,14610836,15.8),(138599,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138599,36.33,0.46,184,66437,70,NULL,NULL,'2MASX J16370732+1411302',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000189,NULL,'15.5g',0.43,NULL,NULL,NULL,NULL,NULL,1,249.2805,14.19181,0.245,NULL,56891355550,888927430,13889491,15.5),(138600,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138600,38.54,0.46,511,66438,70,NULL,NULL,'SDSS J163709.86+275249.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.7g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.291125,27.88047,0.145,NULL,56181026602,877828540,13716070,18.7),(138601,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138601,36.84,0.46,233,66439,70,NULL,NULL,'2MASX J16371100+2617092',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.2957083,26.28597,0.125,NULL,56175526540,877742602,13714728,16.6),(138602,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138602,37.75,0.46,355,66440,70,NULL,NULL,'2MASX J16371342+3705164',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.305917,37.08781,0.017,NULL,59820817514,934700273,14604691,17.1),(138603,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138603,36.87,0.55,236,66441,70,NULL,NULL,'2MASX J16371406-6422036',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.3084583,-64.36778,0.797,NULL,44474332775,694911449,10857991,15.8),(138604,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138604,38.7,0.46,550,66442,70,NULL,NULL,'2MASX J16371463+2733092',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.311083,27.55253,0.165,NULL,56180686283,877823223,13715987,18.2),(138605,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138605,37.15,0.46,269,66443,70,NULL,NULL,'SDSS J163715.56+104935.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.314875,10.82639,0.237,NULL,56750473328,886726145,13855096,18.3),(138606,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138606,37.61,0.46,333,66444,70,NULL,NULL,'2MASX J16371732+4740528',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.322167,47.68139,0,NULL,59841516543,935023695,14609745,17.3),(138607,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138607,38.19,0.46,434,66445,70,NULL,NULL,'SDSS J163718.84+272331.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.6g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.3285,27.39217,0.153,NULL,56180716429,877823694,13715995,18.6),(138608,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138608,34.26,0.49,71,66446,75,NULL,'IR','UGC 10489',NULL,'2011yCatp016004901K',2011,1,1.57,'The 2MASS position is 8 arcsec northeast of the center of the bulge.','G',NULL,NULL,'16.5',0.11,'Sd',NULL,NULL,NULL,NULL,1,249.333583,62.74072,0.021,NULL,57530588777,898915449,14045553,16.5),(138609,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138609,34.66,NULL,85.6,66446,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138610,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138610,34.67,NULL,86.1,66446,NULL,NULL,'Dipole + Quadrupole','UGC 10489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138611,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138611,34.68,NULL,86.4,66446,NULL,NULL,'Dipole','UGC 10489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138612,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138612,34.73,NULL,88.4,66446,NULL,NULL,NULL,'UGC 10489',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138613,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138613,35.62,0.46,133,66447,70,NULL,NULL,'2MASXi J1637205+411120',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000077,NULL,'15.4g',0.5,'S0^-',NULL,NULL,NULL,NULL,1,249.335458333,41.18897,0,NULL,59846478964,935101233,14610956,15.4),(138614,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138614,36.9,0.27,240,66448,70,NULL,NULL,'2MASX J16372555+2518283',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000189,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.356625,25.30797,0.085,NULL,56178231479,877784866,13715388,16.6),(138615,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2002aw',NULL,138615,35.15,0.16,104,66449,70,NULL,'SALT 2','2MFGC 13321',0.026145,'2013MNRAS.433.2240G',2013,1,0.95,NULL,'G',0.000107,NULL,'15.8g',0.21,'Sb(f)          Sbrst',NULL,NULL,NULL,NULL,1,249.3719583,40.87997,0,NULL,59816033432,934625522,14603523,15.8),(138616,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2002aw','R',138616,35.09,0.09,104,66449,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MFGC 13321',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138617,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','SN 2002aw','R',138617,35.16,0.07,108,66449,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MFGC 13321',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138618,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138618,35.06,0.2,103,66450,74.4,NULL,NULL,'CGCG 109-035',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000067,NULL,'15.5',0.3,'Irr',NULL,NULL,NULL,NULL,1,249.372875,17.93239,0.237,NULL,56664532738,885383324,13834114,15.5),(138619,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138619,35.57,0.21,130,66451,70,NULL,NULL,'UGC 10480',NULL,'2015arXiv151105856S',2015,1,1.24,NULL,'G',0.000116,NULL,'14.1g',0.73,'E?',NULL,NULL,NULL,NULL,1,249.375667,44.14447,0,NULL,59846105176,935095393,14610865,14.1),(138620,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138620,34.05,0.25,64.6,66452,74.4,NULL,NULL,'UGC 10486',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000053,NULL,'13.90',0.8,'S0-:','Field galaxy',NULL,NULL,NULL,1,249.393083,50.3455,0,NULL,59828210434,934815788,14606496,13.9),(138621,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138621,36.58,0.21,207,66452,70,NULL,NULL,'UGC 10486',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138622,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138622,34.92,0.4,96.4,66452,NULL,NULL,'mean','UGC 10486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138623,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138623,35.25,0.45,112,66452,NULL,NULL,'K','UGC 10486',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138624,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138624,37.07,0.33,259,66453,70,NULL,NULL,'2MASX J16373432+1238218',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.393125,12.63928,0.185,NULL,56881188733,888768573,13887008,17),(138625,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138625,36.25,0.46,177,66454,70,NULL,NULL,'2MASX J16373481+2550168',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.395083,25.83814,0.097,NULL,56176097602,877751525,13714867,17),(138626,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138626,38.05,0.46,408,66455,70,NULL,NULL,'2MASX J16373601+2348387',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.400125,23.81075,0.153,NULL,56648468968,885132327,13830192,17.2),(138627,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138627,38.61,0.46,528,66456,70,NULL,NULL,'2MASX J16373637+2742268',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.401625,27.70736,0.141,NULL,56226546273,878539785,13727184,17.3),(138628,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138628,36.25,0.46,178,66457,70,NULL,NULL,'2MASX J16373744+4427029',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000094,NULL,'15.7g',0.43,'S0',NULL,NULL,NULL,NULL,1,249.405833,44.45086,0,NULL,59846012292,935093942,14610842,15.7),(138629,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138629,37.41,0.46,304,66458,70,NULL,NULL,'2MASX J16373781+3707013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.4077917,37.11714,0.017,NULL,59821078520,934704351,14604755,16.9),(138630,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138630,37.94,0.33,387,66459,70,NULL,NULL,'2MASX J16373944+1601078',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000188,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.414375,16.01872,0.257,NULL,56884982183,888827846,13887935,17.2),(138631,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138631,38.02,0.61,401,66460,70,NULL,NULL,'2MASX J16374049-6643401',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.4187917,-66.72786,0.585,NULL,44990725826,702980091,10984063,15.9),(138632,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138632,37.57,0.46,326,66461,70,NULL,NULL,'2MASX J16374115+2922259',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.421583,29.37381,0.065,NULL,56225598373,878524974,13726952,17.2),(138633,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138633,37.13,0.33,266,66462,70,NULL,NULL,'2MASX J16374143+3041471',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.4227917,30.69639,0.057,NULL,59753034668,933641166,14588143,16.7),(138634,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138634,38.01,0.17,399,66463,70,NULL,NULL,'SDSS J163741.69+274837.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.15,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.42375,27.81033,0.141,NULL,56226296451,878535882,13727123,18.2),(138635,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138635,38.02,0.33,401,66464,70,NULL,NULL,'2MASX J16374255+4418509',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000094,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.4272917,44.31425,0,NULL,59846152494,935096132,14610877,17.1),(138636,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138636,38.05,0.46,407,66465,70,NULL,NULL,'SDSS J163745.13+340539.7',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.6g',0.27,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,249.438083,34.09439,0.037,NULL,59760057049,933750891,14589857,16.6),(138637,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138637,37.73,0.46,352,66466,70,NULL,NULL,'2MASX J16374765+4747428',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.4487917,47.79531,0,NULL,59841541961,935024093,14609751,17.9),(138638,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138638,37.38,0.27,300,66467,70,NULL,NULL,'2MASX J16375022+1136570',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.459167,11.61594,0.205,NULL,56750877137,886732455,13855194,17),(138639,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138639,34.67,0.53,85.7,66468,70,NULL,NULL,'UGC 10474',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.1',0.7,'S',NULL,NULL,NULL,NULL,1,249.459833,-1.36625,0.477,NULL,45168002297,705750035,11027344,15.1),(138640,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138640,37.2,0.46,275,66469,70,NULL,NULL,'2MASX J16375062+2733219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.4609583,27.55603,0.177,NULL,56225830639,878528603,13727009,17.3),(138641,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138641,37.13,0.33,266,66470,70,NULL,NULL,'2MASX J16375189+3039551',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.4662083,30.66544,0.053,NULL,59752977516,933640273,14588129,17.1),(138642,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138642,37.38,0.27,300,66471,70,NULL,NULL,'2MASX J16375246+1139210',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',NULL,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,249.468625,11.65581,0.205,NULL,56750897289,886732770,13855199,16.2),(138643,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138643,34.85,NULL,93.3,66472,NULL,NULL,'Dipole','ESO 101- G 003',NULL,'2010Ap&SS.325..163P',2010,1,2.58,'Star superposed.','G',0.000233,NULL,'14.61',0.22,'Sb',NULL,NULL,NULL,NULL,1,249.4702083,-64.81297,0.725,NULL,44989305965,702957905,10983717,14.61),(138644,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138644,34.86,NULL,93.7,66472,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 101- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138645,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138645,34.89,NULL,94.9,66472,NULL,NULL,'Dipole + Quadrupole','ESO 101- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138646,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138646,37.13,0.46,267,66473,70,NULL,NULL,'2MASX J16375291+2155022',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.470583333,21.91719,0.201,NULL,56698525243,885914456,13842413,17.7),(138647,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138647,36.19,0.46,173,66474,70,NULL,NULL,'2MASX J16375293+2615409',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000179,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,249.470625,26.26142,0.125,NULL,56175501371,877742208,13714722,15.7),(138648,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138648,35.8,0.46,144,66475,70,NULL,NULL,'2MASX J16375334+4304181',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.472083,43.07153,0,NULL,59847674241,935119910,14611248,17),(138649,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138649,35.55,0.34,129,66476,NULL,NULL,NULL,'UGC 10475',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000625,NULL,'15.82',0.1,'Sbc',NULL,NULL,NULL,NULL,1,249.473375,7.56256,0.369,NULL,56772275235,887066800,13860418,15.82),(138650,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138650,35.57,0.34,130,66476,NULL,NULL,'Malmquist cor.','UGC 10475',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138651,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138651,35.63,0.2,134,66476,74.4,NULL,NULL,'UGC 10475',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138652,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138652,35.7,0.12,138,66477,NULL,NULL,NULL,'UGC 10485',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000107,NULL,'16.0',0.1,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,249.473333,39.24972,0.009,NULL,59822037068,934719329,14604989,16),(138653,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138653,34.82,0.33,92.2,66478,70,NULL,NULL,'NGC 6196',NULL,'2015arXiv151105856S',2015,1,1.31,NULL,'G',0.000093,NULL,'13.8g',0.75,'SAB0-: pec','Group member',NULL,NULL,NULL,1,249.474666667,36.07306,0.021,NULL,59750862986,933607234,14587613,13.8),(138654,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138654,35.75,0.4,141,66478,NULL,NULL,'mean','NGC 6196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138655,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138655,36.42,0.45,192,66478,NULL,NULL,'K','NGC 6196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138656,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138656,36.17,0.78,171,66479,70,NULL,NULL,'2MASX J16375395-6704531',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.474666667,-67.0815,0.593,NULL,45023338728,703489667,10992026,15.9),(138657,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138657,37.66,0.33,341,66480,70,NULL,NULL,'SDSS J163754.22+414639.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.475958333,41.77758,0,NULL,59847410352,935115786,14611184,18.2),(138658,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138658,36.9,0.27,240,66481,70,NULL,NULL,'2MASX J16375645+2518429',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.48525,25.312,0.105,NULL,56178025862,877781654,13715338,17.8),(138659,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138659,37.64,0.46,338,66482,70,NULL,NULL,'2MASX J16375742+3912582',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.23,'AGN',NULL,NULL,NULL,NULL,1,249.489083,39.21633,0.009,NULL,59822024711,934719136,14604986,17.2),(138660,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138660,37.53,0.46,320,66483,70,NULL,NULL,'SDSS J163758.03+342340.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.491833,34.39472,0.009,NULL,59759727340,933745739,14589777,18.5),(138661,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138661,35.58,0.46,131,66484,70,NULL,NULL,'CGCG 168-026',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000113,NULL,'15.1g',0.55,'E0',NULL,NULL,NULL,NULL,1,249.492667,32.87242,0.049,NULL,59755223764,933675371,14588677,15.1),(138662,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138662,37.07,0.33,259,66485,70,NULL,NULL,'2MASX J16380090+1236068',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000159,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.503833,12.60175,0.185,NULL,56881911211,888779862,13887185,16.9),(138663,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138663,35.36,0.46,118,66486,70,NULL,NULL,'CGCG 138-047',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000163,NULL,'15.3g',0.55,'S0/a',NULL,NULL,NULL,NULL,1,249.514125,25.30272,0.105,NULL,56178031794,877781746,13715339,15.3),(138664,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138664,37.31,0.46,289,66487,70,NULL,NULL,'2MASX J16380339+2307242',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000197,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.514208333,23.12328,0.177,NULL,56695357368,885864958,13841639,16.9),(138665,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138665,38.02,0.33,401,66488,70,NULL,NULL,'2MASX J16380451+4417272',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000078,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.518833,44.29075,0,NULL,59846154777,935096168,14610877,17.3),(138666,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138666,37.43,0.46,306,66489,70,NULL,NULL,'2MASX J16380486+3805219',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00011,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.52025,38.08944,0.013,NULL,59820589578,934696712,14604636,16.5),(138667,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'N',138667,37.14,NULL,268,66490,65,NULL,'L = 10e57 photons/s','GRB 790113',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138668,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'N',138668,40.24,NULL,1120,66490,65,NULL,'L = 2 x 10e58 photons/s','GRB 790113',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138669,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'RN',138669,43.66,NULL,5400,66490,NULL,NULL,NULL,'GRB 790113',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138670,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138670,37.97,0.33,393,66491,70,NULL,NULL,'2MASX J16380573+2856137',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000141,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.5239583,28.93708,0.049,NULL,56225112457,878517382,13726834,18.4),(138671,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138671,37.93,0.46,385,66492,70,NULL,NULL,'2MASX J16380828-0011449',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.0001,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.534375,-0.19583,0.393,NULL,45166794663,705731166,11027049,17),(138672,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138672,37.38,0.27,300,66493,70,NULL,NULL,'2MASX J16380829+1131321',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.534416667,11.52561,0.205,NULL,56751000740,886734386,13855224,16.7),(138673,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138673,31.92,0.8,24.2,66494,75,NULL,'MAT, I','MCG -01-42-003',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'15.5',0.5,'Sc',NULL,NULL,NULL,NULL,1,249.535833,-4.82333,0.773,NULL,46049693273,719526457,11242600,15.5),(138674,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138674,31.63,0.2,21.2,66494,74.4,NULL,NULL,'MCG -01-42-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138675,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138675,31.8,0.35,22.9,66494,NULL,NULL,NULL,'MCG -01-42-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138676,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138676,31.89,0.32,23.9,66494,85,NULL,'I, inv','MCG -01-42-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138677,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138677,31.92,0.32,24.2,66494,85,NULL,'I, raw','MCG -01-42-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138678,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138678,32.1,0.3,26.3,66494,NULL,NULL,'Malmquist cor.','MCG -01-42-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138679,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138679,32.12,NULL,26.5,66494,72,NULL,NULL,'MCG -01-42-003',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138680,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138680,32.21,0.43,27.6,66494,75,NULL,'MAT, I, inv','MCG -01-42-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138681,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138681,32.26,0.43,28.3,66494,75,NULL,'MAT, I, raw','MCG -01-42-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138682,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138682,32.34,0.43,29.4,66494,75,NULL,'MAT, I, cor','MCG -01-42-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138683,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138683,35.78,0.07,144,66495,NULL,NULL,NULL,'UGC 10488',NULL,'2009ApJS..182..474S',2009,1,1.17,NULL,'G',0.000172,NULL,'14.5g',0.49,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,249.5377083,39.91783,0,NULL,59823425578,934741024,14605328,14.5),(138684,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138684,38.71,0.46,552,66496,70,NULL,NULL,'2MASX J16380957+2102121',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.5397917,21.03667,0.245,NULL,56705345962,886021030,13844078,18),(138685,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138685,37.6,0.46,331,66497,70,NULL,NULL,'2MASX J16381036+4714052',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.541583333,47.23461,0,NULL,59841891841,935029560,14609836,17.4),(138686,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138686,38.81,0.46,577,66498,70,NULL,NULL,'2MASX J16381004+4136229',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000097,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.5417917,41.60625,0,NULL,59846523029,935101922,14610967,17.8),(138687,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138687,38.29,0.46,455,66499,70,NULL,NULL,'2MASX J16381251+1556270',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.552125,15.94075,0.257,NULL,56884906532,888826664,13887916,18.2),(138688,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138688,37.13,0.46,266,66500,70,NULL,NULL,'2MASX J16381273+2758227',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.78',0.35,NULL,NULL,NULL,NULL,NULL,1,249.553167,27.97308,0.125,NULL,56226305451,878536022,13727125,17.78),(138689,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138689,37.78,0.46,360,66501,70,NULL,NULL,'2MASX J16381283+4028289',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.553333,40.47456,0.005,NULL,59823379100,934740298,14605317,17.5),(138690,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138690,36.65,0.46,214,66502,70,NULL,NULL,'MCG +07-34-126',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000107,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,249.553666667,40.17347,0,NULL,59823469548,934741711,14605339,16),(138691,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138691,36.73,0.46,222,66503,70,NULL,NULL,'2MASX J16381365+2632007',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.556791667,26.53364,0.157,NULL,56175511031,877742359,13714724,16.9),(138692,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138692,37.66,0.33,341,66504,70,NULL,NULL,'2MASX J16381456+4147519',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000084,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.560583,41.79778,0,NULL,59847410823,935115794,14611184,16.6),(138693,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138693,38.01,0.17,399,66505,70,NULL,NULL,'2MASX J16381500+2754117',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.5625417,27.90317,0.125,NULL,56226311513,878536117,13727126,17.5),(138694,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138694,37.95,0.46,389,66506,70,NULL,NULL,'SDSS J163815.35+393725.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000136,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,249.564,39.62375,0.005,NULL,59821860104,934716564,14604946,18.1),(138695,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138695,37.97,0.33,393,66507,70,NULL,NULL,'2MASX J16381556+2859327',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.56475,28.9925,0.049,NULL,56224996403,878515568,13726805,17.6),(138696,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138696,37.94,0.33,387,66508,70,NULL,NULL,'2MASX J16381730+1559020',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.5722083,15.98397,0.257,NULL,56884877134,888826205,13887909,17.1),(138697,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138697,36.68,0.46,217,66509,70,NULL,NULL,'2MASX J16381818+1316150',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.575833,13.27094,0.209,NULL,56889957682,888905588,13889149,17.2),(138698,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138698,38.65,0.46,537,66510,70,NULL,NULL,'SDSS J163818.73+294808.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.578083333,29.80242,0.081,NULL,56207941758,878249089,13722642,17.7),(138699,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138699,37.91,0.46,382,66511,70,NULL,NULL,'2MASX J16381938+2244551',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.580625,22.74856,0.193,NULL,56695209372,885862646,13841603,17.8),(138700,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138700,36.82,0.46,231,66512,70,NULL,NULL,'2MASX J16382594+3105018',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,249.6079583,31.08389,0.061,NULL,59752524811,933633200,14588018,16.7),(138701,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138701,36.34,0.33,185,66513,70,NULL,NULL,'2MASX J16382636+3242028',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.609875,32.70086,0.045,NULL,59755448411,933678881,14588732,16.5),(138702,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138702,36.84,0.46,233,66514,70,NULL,NULL,'2MASX J16382850+3209158',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.618583333,32.15433,0.045,NULL,59756104987,933689140,14588892,17.1),(138703,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138703,36.59,0.46,208,66515,70,NULL,NULL,'2MASX J16383021+2135080',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,249.6257917,21.58547,0.201,NULL,56697199644,885893744,13842089,17.1),(138704,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138704,38.01,0.17,399,66516,70,NULL,NULL,'2MASX J16383023+2746277',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.6259583,27.77428,0.141,NULL,56226610928,878540795,13727199,18.4),(138705,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138705,37.72,0.46,350,66517,70,NULL,NULL,'2MASX J16383199+2804437',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.633291667,28.07872,0.125,NULL,56226430555,878537977,13727155,17),(138706,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138706,38.01,0.17,399,66518,70,NULL,NULL,'2MASX J16383203+2744437',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.6335,27.74539,0.141,NULL,56226604854,878540700,13727198,17.4),(138707,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138707,37.18,0.46,273,66519,70,NULL,NULL,'2MASX J16383216+4614352',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,'FoF','16.1g',0.38,NULL,NULL,NULL,NULL,NULL,1,249.6339583,46.243,0,NULL,59839091658,934985807,14609153,16.1),(138708,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138708,38.01,0.17,399,66520,70,NULL,NULL,'2MASX J16383550+2747337',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.648083,27.79258,0.141,NULL,56226610354,878540786,13727199,17),(138709,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138709,37.71,0.46,348,66521,70,NULL,NULL,'2MASX J16383565+3244528',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.648708333,32.74789,0.049,NULL,59755421608,933678462,14588725,17.7),(138710,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138710,38.01,0.17,399,66522,70,NULL,NULL,'2MASX J16383614+2748354',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.650417,27.80967,0.141,NULL,56226609815,878540778,13727199,17.8),(138711,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138711,36.34,0.33,185,66523,70,NULL,NULL,'CGCG 168-027',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000097,NULL,'15.5g',0.51,'E0',NULL,NULL,NULL,NULL,1,249.667791667,32.54558,0.045,NULL,59755372559,933677696,14588714,15.5),(138712,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138712,38.01,0.17,399,66524,70,NULL,NULL,'2MASX J16384110+2754595',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00018,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.6712917,27.91644,0.125,NULL,56226594690,878540542,13727195,17.1),(138713,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138713,37.47,0.46,312,66525,70,NULL,NULL,'2MASX J16384333+2504445',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.680625,25.07897,0.105,NULL,56174835301,877731801,13714559,16.5),(138714,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138714,36.51,0.46,200,66526,70,NULL,NULL,'2MASX J16384623+2840465',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000171,NULL,'15.8g',0.41,NULL,NULL,NULL,NULL,NULL,1,249.6925,28.67944,0.097,NULL,56228540880,878570951,13727671,15.8),(138715,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138715,36.32,0.46,184,66527,70,NULL,NULL,'2MASX J16384734+1218461',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000181,NULL,'15.9g',0.35,'AGN',NULL,NULL,NULL,NULL,1,249.697375,12.31297,0.185,NULL,56882061539,888782211,13887222,15.9),(138716,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138716,37.68,0.46,343,66528,70,NULL,NULL,'2MASX J16384992+2801385',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,249.70825,28.02736,0.125,NULL,56226414745,878537730,13727152,17.4),(138717,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138717,37.96,0.46,391,66529,70,NULL,NULL,'2MASX J16385055+2737585',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.71075,27.63289,0.141,NULL,56225860663,878529072,13727016,17.2),(138718,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138718,38.04,0.33,406,66530,70,NULL,NULL,'2MASX J16385065+2716475',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,249.711125,27.28014,0.153,NULL,56225717416,878526834,13726981,18.6),(138719,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138719,38,0.46,398,66531,70,NULL,NULL,'2MASX J16385078+3100159',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,249.711625,31.00442,0.061,NULL,59752574353,933633974,14588030,18),(138720,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138720,37.17,0.67,272,66532,70,NULL,NULL,'2MASX J16385090-6507389',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.7122917,-65.12756,0.725,NULL,44990048936,702969514,10983898,16.2),(138721,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138721,36.23,0.53,176,66533,70,NULL,NULL,'2MASX J16385109-6334469',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.7127083,-63.57969,0.809,NULL,44474933483,694920835,10858138,15.3),(138722,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138722,38.13,0.46,422,66534,70,NULL,NULL,'2MASX J16385197+3004379',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000193,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.7165417,30.07706,0.069,NULL,56208819354,878262802,13722856,17.5),(138723,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138723,37.36,0.46,296,66535,70,NULL,NULL,'2MASX J16385208+3835090',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.7170417,38.58581,0.017,NULL,59820478651,934694978,14604609,17.3),(138724,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138724,37.49,0.46,314,66536,70,NULL,NULL,'2MASX J16385655+3427179',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.7354583,34.45489,0.009,NULL,59760228213,933753565,14589899,17.7),(138725,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138725,37.12,0.46,265,66537,70,NULL,NULL,'2MASX J16385759+3223489',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00014,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.74,32.397,0.041,NULL,59755387893,933677935,14588717,16.6),(138726,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138726,38.54,0.46,509,66538,70,NULL,NULL,'2MASX J16390000+1122076',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,249.750125,11.36867,0.189,NULL,56750696693,886729635,13855150,17.7),(138727,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138727,38.04,0.33,406,66539,70,NULL,NULL,'2MASX J16390078+2724205',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.1g',0.33,NULL,NULL,NULL,NULL,NULL,1,249.753333,27.40558,0.177,NULL,56225935363,878530240,13727035,17.1),(138728,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138728,37.21,0.46,276,66540,70,NULL,NULL,'2MASX J16390183+2909275',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.757625,29.15764,0.081,NULL,56225486603,878523228,13726925,17),(138729,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138729,38.15,0.46,426,66541,70,NULL,NULL,'2MASX J16390192+2249278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000191,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.7580417,22.82447,0.189,NULL,56695103089,885860985,13841577,16.9),(138730,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138730,38.1,0.23,416,66542,70,NULL,NULL,'2MASX J16390245+2613395',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000182,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.760167,26.22772,0.141,NULL,56231343541,878614742,13728355,17),(138731,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138731,37.14,0.23,269,66543,70,NULL,NULL,'2MASX J16390516+2942235',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000147,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,249.771417,29.70656,0.081,NULL,56225510466,878523601,13726931,16.6),(138732,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138732,34.72,0.8,87.8,66544,75,NULL,'MAT, I','ESO 101- G 005',NULL,'1997ApJS..109..333W',1997,1,1.5,'Marginal HIPASS detection.','G',0.000032,NULL,'15.16',0.3,'SB(s)c: sp',NULL,NULL,NULL,NULL,1,249.775167,-66.90914,0.585,NULL,45023252163,703488315,10992004,15.16),(138733,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138733,34.58,0.43,82.4,66544,75,NULL,'MAT, I, raw','ESO 101- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138734,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138734,34.62,0.53,84.1,66544,NULL,NULL,'Malmquist cor.','ESO 101- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138735,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138735,34.64,0.32,84.8,66544,85,NULL,'I, raw','ESO 101- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138736,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138736,34.69,0.32,86.6,66544,85,NULL,'I, inv','ESO 101- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138737,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138737,34.78,0.49,90.2,66544,75,NULL,'IR','ESO 101- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138738,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138738,34.79,0.43,90.8,66544,75,NULL,'MAT, I, inv','ESO 101- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138739,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138739,34.81,0.43,91.6,66544,75,NULL,'MAT, I, cor','ESO 101- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138740,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138740,35.04,0.44,102,66544,NULL,NULL,NULL,'ESO 101- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138741,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138741,35.08,0.2,104,66544,74.4,NULL,NULL,'ESO 101- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138742,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138742,37.9,0.46,381,66545,70,NULL,NULL,'SDSS J163906.32+222738.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,249.776333333,22.46075,0.189,NULL,56697921969,885905030,13842266,18.5),(138743,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138743,37.42,0.46,305,66546,70,NULL,NULL,'2MASX J16390859+3415447',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000167,NULL,'16.4g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,249.785875,34.26236,0.005,NULL,59760204973,933753202,14589893,16.4),(138744,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138744,37.14,0.23,269,66547,70,NULL,NULL,'2MASX J16390906+2937018',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.78775,29.61728,0.049,NULL,56225551235,878524238,13726941,17.3),(138745,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138745,37.85,0.46,372,66548,70,NULL,NULL,'2MASX J16390917+4723017',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000138,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.788333,47.38394,NULL,NULL,59841986996,935031046,14609860,17),(138746,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138746,37.24,0.46,280,66549,70,NULL,NULL,'2MASX J16390960+1139276',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.790041667,11.65764,0.205,NULL,56750757013,886730578,13855165,16.8),(138747,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138747,38.52,0.46,505,66550,70,NULL,NULL,'SDSS J163909.71+244604.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000154,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,249.7905,24.76797,0.113,NULL,56175236300,877738067,13714657,18.6),(138748,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138748,37.14,0.23,269,66551,70,NULL,NULL,'2MASX J16391452+2954477',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000194,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.8104583,29.91317,0.081,NULL,56208801406,878262521,13722851,17.2),(138749,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138749,38.27,0.46,452,66552,70,NULL,NULL,'2MASX J16391688+3905577',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,249.820375,39.0995,0.009,NULL,59823659333,934744677,14605385,17.2),(138750,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138750,37.14,0.23,269,66553,70,NULL,NULL,'2MASX J16391845+2953168',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.827125,29.88808,0.081,NULL,56208800491,878262507,13722851,17.8),(138751,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138751,37.33,0.46,292,66554,70,NULL,NULL,'SDSS J163918.85+334937.6',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000144,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,249.8285417,33.82711,0.017,NULL,59760177931,933752780,14589887,18.4),(138752,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138752,34.79,0.46,90.7,66555,70,NULL,NULL,'CGCG 224-084',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000053,NULL,'15.3g',0.3,'S0^-',NULL,NULL,NULL,NULL,1,249.829875,42.18414,0,NULL,59847247251,935113238,14611144,15.3),(138753,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138753,37.13,0.27,266,66556,70,NULL,NULL,'2MASX J16391952+2044394',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,249.831291667,20.74422,0.265,NULL,56705090141,886017033,13844016,16.7),(138754,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138754,38.09,0.46,414,66557,70,NULL,NULL,'2MASX J16392018+1054036',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,249.834083,10.90111,0.205,NULL,56753072122,886766751,13855730,16.7),(138755,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138755,35.86,NULL,149,66558,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10498',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.000015,NULL,'17.2g',0.13,'Sc',NULL,NULL,NULL,NULL,1,249.839708333,29.36978,0.065,NULL,56225450629,878522666,13726916,17.2),(138756,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138756,35.87,NULL,149,66558,NULL,NULL,'Dipole + Quadrupole','UGC 10498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138757,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138757,35.87,NULL,149,66558,NULL,NULL,'Dipole','UGC 10498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138758,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138758,35.98,NULL,157,66558,NULL,NULL,NULL,'UGC 10498',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138759,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138759,37.08,0.2,261,66558,74.4,NULL,NULL,'UGC 10498',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138760,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138760,36.73,0.52,221,66559,70,NULL,NULL,'2MASX J16392187-6515453',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.83',0.3,NULL,NULL,NULL,NULL,NULL,1,249.84,-65.26269,0.621,NULL,44989956772,702968074,10983876,16.83),(138761,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138761,36.84,0.58,233,66560,70,NULL,NULL,'2MASX J16392192-6405533',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'12.74',0.34,NULL,NULL,NULL,NULL,NULL,1,249.841333,-64.09819,0.797,NULL,44474390673,694912354,10858005,12.74),(138762,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138762,34.72,0.47,87.8,66561,70,NULL,NULL,'UGC 10492',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000117,NULL,'14.70',0.9,'SA(s)a:','Isolated galaxy',NULL,NULL,NULL,1,249.847875,-2.40653,0.477,NULL,45165536961,705711515,11026742,14.7),(138763,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138763,38.1,0.23,416,66562,70,NULL,NULL,'2MASX J16392403+2614359',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,249.850125,26.24339,0.141,NULL,56231338434,878614663,13728354,NULL),(138764,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138764,38,0.46,398,66563,70,NULL,NULL,'2MASX J16392492+2336095',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.853833,23.60281,0.157,NULL,56694661016,885854078,13841469,17.7),(138765,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138765,36.45,0.46,195,66564,70,NULL,NULL,'2MASX J16392550+2636359',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',NULL,NULL,'16.88',0.34,NULL,NULL,NULL,NULL,NULL,1,249.856291667,26.60986,0.157,NULL,56231141843,878611591,13728306,16.88),(138766,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138766,37.72,0.46,350,66565,70,NULL,NULL,'2MASX J16392611+1113396',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.8587083,11.22772,0.189,NULL,56752728560,886761383,13855646,17.4),(138767,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138767,34.58,0.2,82.4,66566,74.4,NULL,NULL,'CGCG 080-051',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00011,NULL,'15.1',0.25,'Sb',NULL,NULL,NULL,NULL,1,249.859917,11.2105,0.189,NULL,56752726579,886761352,13855646,15.1),(138768,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138768,38.54,0.46,510,66567,70,NULL,NULL,'SDSS J163929.14+302726.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000158,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,249.871417,30.45747,0.053,NULL,56208760438,878261881,13722841,18.4),(138769,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138769,38.11,0.46,418,66568,70,NULL,NULL,'SDSS J163929.22+285111.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,249.87175,28.85319,0.089,NULL,56228510160,878570471,13727663,18.6),(138770,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138770,37.13,0.27,266,66569,70,NULL,NULL,'2MASX J16392937+2039125',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,249.872375,20.65353,0.265,NULL,56705073092,886016767,13844011,16.6),(138771,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138771,36.69,0.46,218,66570,70,NULL,NULL,'2MASX J16393025-0017546',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.876166667,-0.29867,0.413,NULL,45167314794,705739293,11027176,17.2),(138772,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138772,36.78,0.46,227,66571,70,NULL,NULL,'2MASX J16393099+1331563',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000161,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,249.879083,13.53228,0.233,NULL,56890791773,888918621,13889353,17),(138773,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138773,36.78,0.66,227,66572,70,NULL,NULL,'2MASX J16393117-6342184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.879875,-63.70506,0.797,NULL,44474910773,694920480,10858132,14.5),(138774,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138774,36.64,0.58,213,66573,70,NULL,NULL,'2MASX J16393126-6546264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.88025,-65.77394,0.577,NULL,44992166384,703002599,10984415,15.7),(138775,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138775,35.64,0.46,134,66574,70,NULL,NULL,'2MASX J16393494+3556047',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000057,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,249.895667,35.93458,0.025,NULL,59758412828,933725200,14589456,16.2),(138776,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138776,37.44,0.46,308,66575,70,NULL,NULL,'2MASX J16393968+2848015',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,249.915333,28.80044,0.089,NULL,56228494669,878570229,13727659,17.3),(138777,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138777,37.27,0.46,284,66576,70,NULL,NULL,'2MASX J16393977+2945356',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.915625,29.75981,0.049,NULL,56225246456,878519475,13726866,17.9),(138778,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138778,37.3,0.57,288,66577,70,NULL,NULL,'2MASX J16394428-6334325',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.934458333,-63.57578,0.809,NULL,44475034269,694922410,10858162,16),(138779,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138779,37.63,0.46,336,66578,70,NULL,NULL,'2MASX J16394520+3009182',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000155,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,249.938458333,30.15506,0.057,NULL,56208875770,878263683,13722870,17),(138780,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138780,37.63,0.46,335,66579,70,NULL,NULL,'2MASX J16394547+2348174',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,249.939333333,23.80481,0.157,NULL,56694429498,885850460,13841413,16.5),(138781,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138781,38.1,0.23,416,66580,70,NULL,NULL,'2MASX J16394583+2611396',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,249.9410417,26.19419,0.141,NULL,56231375471,878615241,13728363,17.7),(138782,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138782,37.91,0.46,382,66581,70,NULL,NULL,'2MASX J16394718+3634161',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,249.946541667,36.57103,0.017,NULL,59750204837,933596950,14587452,17.3),(138783,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138783,36.38,0.46,189,66582,70,NULL,NULL,'2MASX J16394974+3654331',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000083,NULL,'15.6g',0.43,'E0',NULL,NULL,NULL,NULL,1,249.9574583,36.90928,0.037,NULL,59820427671,934694182,14604596,15.6),(138784,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138784,36.95,0.55,245,66583,70,NULL,NULL,'2MASX J16395239-6448565',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.968375,-64.81572,0.729,NULL,44989285382,702957584,10983712,15.5),(138785,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138785,37.13,0.27,266,66584,70,NULL,NULL,'2MASX J16395390+2029554',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,249.97475,20.49878,0.245,NULL,56705031986,886016124,13844001,17.6),(138786,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138786,38.1,0.23,416,66585,70,NULL,NULL,'2MASX J16395445+2610106',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.976917,26.16964,0.141,NULL,56231376625,878615259,13728363,17.5),(138787,'Tully est','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138787,32.48,0.8,31.3,66586,75,NULL,'B','ARK 507',NULL,'1988NBGC.C....0000T',1988,1,0.76,'1994AJ....107.1629T has V = 2100 +- 100 km/s.','G',0.000185,NULL,'15.2g',0.33,'Spiral','Group non-member, background',NULL,NULL,NULL,1,249.978375,37.18008,0.017,NULL,59820414054,934693969,14604593,15.2),(138788,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138788,37.13,0.46,267,66587,70,NULL,NULL,'2MASX J16395810+1146129',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,249.992083,11.77031,0.217,NULL,56750526790,886726981,13855109,NULL),(138789,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138789,37.21,0.46,276,66588,70,NULL,NULL,'2MASX J16395829+3843582',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000103,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.992791667,38.73264,0.041,NULL,59827029524,934797336,14606208,16.6),(138790,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138790,37.19,0.46,274,66589,70,NULL,NULL,'2MASX J16395857+2959003',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,249.994167,29.98336,0.053,NULL,56208298994,878254671,13722729,17.2),(138791,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','PTF10qjl',NULL,138791,37.21,0.03,262,66590,70,NULL,'SiFTO+SALT2, SN PTF10qjl','PTF10qjl',0.0579,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,249.997208333,12.10708,0.213,NULL,56881570971,888774546,13887102,NULL),(138792,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:57','1','PTF10qjl',NULL,138792,37.33,0.02,276,66590,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qjl',0.0579,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138793,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138793,37.77,0.46,358,66591,70,NULL,NULL,'2MASX J16395937+3114343',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,249.9972917,31.24286,0.053,NULL,59752344255,933630378,14587974,17.8),(138794,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138794,37.77,0.46,358,66592,70,NULL,NULL,'2MASX J16395939+2711566',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,249.9974583,27.19889,0.169,NULL,56233282504,878645039,13728828,16.8),(138795,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138795,35.97,0.66,156,66593,70,NULL,NULL,'2MASX J16395943-1614076',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,249.997666667,-16.23544,0.941,NULL,46128381688,720755963,11261811,15.9),(138796,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138796,37.47,0.46,312,66594,70,NULL,NULL,'SDSS J164000.02+371454.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00018,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.000083,37.24858,0.025,NULL,59820420313,934694067,14604594,18.3),(138797,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138797,36.72,0.46,221,66595,70,NULL,NULL,'2MASX J16400010+2929286',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000181,NULL,'15.9g',0.42,NULL,NULL,NULL,NULL,NULL,1,250.000541667,29.49125,0.081,NULL,56225381886,878521591,13726899,15.9),(138798,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138798,37.26,0.46,283,66596,70,NULL,NULL,'2MASX J16400248+3008463',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.29,'AGN',NULL,NULL,NULL,NULL,1,250.010417,30.14622,0.057,NULL,56208876728,878263698,13722870,17.2),(138799,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138799,38.38,0.33,475,66597,70,NULL,NULL,'2MASX J16400286+3641102',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,250.012083,36.68608,0.017,NULL,59750200353,933596880,14587451,18.1),(138800,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138800,38.08,0.27,413,66598,70,NULL,NULL,'2MASX J16400629+3927232',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000143,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,250.026291667,39.45661,0.005,NULL,59823824580,934747259,14605425,16.8),(138801,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138801,35.77,0.46,143,66599,70,NULL,NULL,'2MASX J16401129+4616549',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'15.9g',0.37,'S0',NULL,NULL,NULL,NULL,1,250.04725,46.28194,0,NULL,59839134210,934986472,14609163,15.9),(138802,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138802,35.71,0.48,139,66600,70,NULL,NULL,'2MASX J16401184-6216143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.049167,-62.27064,0.929,NULL,44461877494,694716835,10854950,15.7),(138803,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138803,39.36,0.46,745,66601,70,NULL,NULL,'2MASX J16401207+2742291',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.0502917,27.70811,0.141,NULL,56226664937,878541639,13727213,18.5),(138804,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138804,36.82,0.58,231,66602,70,NULL,NULL,'2MASX J16401372-6512215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.0570417,-65.20594,0.661,NULL,44989876541,702966820,10983856,14.2),(138805,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138805,38.17,0.46,431,66603,70,NULL,NULL,'2MASX J16401421+2731472',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.059167,27.52972,0.153,NULL,56225768156,878527627,13726994,18.2),(138806,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138806,37.23,0.46,280,66604,70,NULL,NULL,'2MASX J16401458+1134139',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,250.060667,11.57064,0.217,NULL,56752623571,886759743,13855620,16.6),(138807,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138807,38.42,0.46,483,66605,70,NULL,NULL,'2MASX J16401712+2643532',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.0712917,26.73144,0.161,NULL,56231116459,878611194,13728299,17.7),(138808,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138808,36.7,0.53,219,66606,70,NULL,NULL,'2MASX J16401807-8432591',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,250.07475,-84.54975,0.341,NULL,44085908588,688842321,10763161,16.6),(138809,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138809,38.08,0.27,413,66607,70,NULL,NULL,'2MASX J16402036+3929102',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,250.084875,39.48625,0.005,NULL,59823831321,934747364,14605427,18),(138810,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138810,38.08,0.27,413,66608,70,NULL,NULL,'2MASX J16402038+3934432',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,250.084917,39.57856,0,NULL,59823786417,934746662,14605416,16.8),(138811,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138811,36.86,0.54,235,66609,70,NULL,NULL,'2MASX J16402107-6426115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.08775,-64.43647,0.737,NULL,44466086834,694782606,10855978,15.5),(138812,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138812,37.77,0.46,358,66610,70,NULL,NULL,'2MASX J16402135+4045192',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000082,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.088917,40.75525,0,NULL,59816133805,934627090,14603548,17.2),(138813,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138813,35.3,0.27,115,66611,NULL,NULL,NULL,'UGC 10504',NULL,'2009ApJS..182..474S',2009,1,1.07,NULL,'G',0.000015,NULL,'14.5g',0.52,'Sab','Field galaxy',NULL,NULL,NULL,1,250.0945417,33.67975,0.045,NULL,59760018744,933750292,14589848,14.5),(138814,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138814,35.5,0.25,126,66611,NULL,NULL,'Malmquist cor.','UGC 10504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138815,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138815,35.64,0.2,134,66611,74.4,NULL,NULL,'UGC 10504',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138816,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138816,35.76,0.4,142,66611,NULL,NULL,'mean','UGC 10504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138817,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138817,35.89,0.47,151,66611,NULL,NULL,'H','UGC 10504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138818,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138818,36.02,0.46,160,66611,NULL,NULL,'J','UGC 10504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138819,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138819,37.36,0.46,296,66612,70,NULL,NULL,'2MASX J16402360+2857362',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,250.0982083,28.96,0.081,NULL,56228642671,878572541,13727695,17.6),(138820,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138820,35.92,0.55,153,66613,70,NULL,NULL,'2MASX J16402378-6416455',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.0992917,-64.27925,0.737,NULL,44466070434,694782350,10855974,14.2),(138821,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138821,34.93,0.46,97,66614,70,NULL,NULL,'MRK 0887',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00019,NULL,'14.3g',0.67,'Compact',NULL,NULL,NULL,NULL,1,250.11675,39.32014,0.005,NULL,59823880615,934748134,14605439,14.3),(138822,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138822,38.38,0.33,475,66615,70,NULL,NULL,'2MASX J16402854+3650501',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000155,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,250.119,36.84725,0.037,NULL,59820260589,934691571,14604555,17),(138823,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138823,36.15,0.46,170,66616,70,NULL,NULL,'2MASX J16403495+4632409',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000157,NULL,'15.8g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,250.145417,46.54464,0,NULL,59837489755,934960777,14608762,15.8),(138824,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138824,36.28,0.46,180,66617,70,NULL,NULL,'CGCG 197-004',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000191,NULL,'15.5g',0.42,'S0',NULL,NULL,NULL,NULL,1,250.1599583,33.93114,0.041,NULL,59760046013,933750718,14589854,15.5),(138825,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138825,37.54,0.46,322,66618,70,NULL,NULL,'2MASX J16404166+1939440',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.1734583,19.66236,0.265,NULL,56691976358,885812130,13840814,17.4),(138826,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138826,37.85,0.46,371,66619,70,NULL,NULL,'2MASX J16404252+1126105',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,250.177083,11.43642,0.201,NULL,56752862496,886763476,13855679,16.5),(138827,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138827,36.52,0.46,201,66620,70,NULL,NULL,'2MASX J16404328+2713202',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,'17.66',NULL,NULL,NULL,NULL,NULL,NULL,1,250.180125,27.22236,0.169,NULL,56233244176,878644440,13728819,17.66),(138828,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138828,36.12,0.46,167,66621,70,NULL,NULL,'2MASX J16404559+4316560',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000097,NULL,'16.5g',0.28,'BLAGN',NULL,NULL,NULL,'Sy 1',1,250.190083,43.28244,0,NULL,59848313651,935129900,14611404,16.5),(138829,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138829,36,0.55,159,66622,70,NULL,NULL,'2MASX J16404809-7243286',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.200167,-72.72453,0.237,NULL,44116291180,689317049,10770578,15),(138830,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138830,37.34,0.46,294,66623,70,NULL,NULL,'2MASX J16405223+2540584',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000156,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,250.2177083,25.68294,0.145,NULL,56232268518,878629195,13728581,16.6),(138831,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138831,38.07,0.46,411,66624,70,NULL,NULL,'SDSS J164054.04+342035.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,250.225167,34.34308,0.041,NULL,59760264630,933754134,14589908,18.2),(138832,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138832,36.46,0.21,196,66625,70,NULL,NULL,'2MASX J16405922+2650044',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.24675,26.83453,0.169,NULL,56231079533,878610617,13728290,17),(138833,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138833,36.8,0.46,229,66626,70,NULL,NULL,'SDSS J164101.14+250035.9',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,250.25475,25.01,0.141,NULL,56229729281,878589520,13727961,16.8),(138834,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138834,36.57,0.46,206,66627,70,NULL,NULL,'2MASX J16410217+3049387',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000171,NULL,'16.1g',0.33,'E0',NULL,NULL,NULL,NULL,1,250.258875,30.82736,0.057,NULL,56208612779,878259574,13722805,16.1),(138835,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138835,37.12,0.46,265,66628,70,NULL,NULL,'2MASX J16410358+3215527',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.264917,32.26472,0.045,NULL,59753951272,933655488,14588367,17.7),(138836,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138836,36.46,0.46,196,66629,70,NULL,NULL,'2MASX J16410775+4234061',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000097,NULL,'16.07',0.4,NULL,NULL,NULL,NULL,NULL,1,250.2822917,42.56842,0,NULL,59847899310,935123426,14611303,16.07),(138837,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138837,36.12,0.82,167,66630,70,NULL,NULL,'2MASX J16410820-1636132',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.28425,-16.60369,1.073,NULL,46125421704,720709714,11261089,15.9),(138838,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138838,35.12,0.46,106,66631,70,NULL,NULL,'MCG +07-34-132',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.0001,NULL,'14.6g',0.45,'S0',NULL,NULL,NULL,NULL,1,250.290875,39.75686,0,NULL,59824364442,934755694,14605557,14.6),(138839,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138839,37.18,0.33,272,66632,70,NULL,NULL,'2MASX J16411051+2903023',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.92',0.39,NULL,NULL,NULL,NULL,NULL,1,250.293917,29.05081,0.081,NULL,56228613284,878572082,13727688,16.92),(138840,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138840,37.63,0.46,336,66633,70,NULL,NULL,'2MASX J16411556+2958253',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000146,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.314833,29.97356,0.053,NULL,56208377939,878255905,13722748,17.6),(138841,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138841,37.3,0.46,288,66634,70,NULL,NULL,'2MASX J16411595+2332074',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000156,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.3164583,23.53539,0.153,NULL,56677700684,885589073,13837329,17),(138842,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138842,37.48,0.46,313,66635,70,NULL,NULL,'2MASX J16411672+3724398',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000123,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.319666667,37.41111,0.025,NULL,59820315200,934692425,14604569,17.4),(138843,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138843,36.65,0.27,214,66636,70,NULL,NULL,'CGCG 080-054',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.00022,NULL,'15.0g',0.62,'BrClG',NULL,NULL,NULL,NULL,1,250.319833333,13.39178,0.237,NULL,56882140894,888783451,13887241,15),(138844,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138844,38.36,0.46,470,66637,70,NULL,NULL,'SDSS J164118.21+340852.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,250.325916667,34.14794,0.033,NULL,59760251168,933753924,14589905,18.3),(138845,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138845,37.18,0.33,272,66638,70,NULL,NULL,'2MASX J16411835+2903305',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,250.3265417,29.05856,0.081,NULL,56228610821,878572044,13727688,17.2),(138846,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138846,35.66,0.46,136,66639,70,NULL,NULL,'CGCG 138-057',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000073,NULL,'15.3g',0.4,'E0',NULL,NULL,NULL,NULL,1,250.32875,22.27875,0.221,NULL,56696814740,885887730,13841995,15.3),(138847,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138847,37.41,0.46,304,66640,70,NULL,NULL,'2MASX J16412059+3159264',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.3357083,31.99072,0.041,NULL,59753809105,933653267,14588332,17.4),(138848,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138848,36.65,0.27,214,66641,70,NULL,NULL,'2MASX J16412066+1325573',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000209,NULL,'15.5g',0.54,NULL,NULL,NULL,NULL,NULL,1,250.3360417,13.43253,0.237,NULL,56882139899,888783435,13887241,15.5),(138849,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138849,35.85,NULL,148,66642,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2065',NULL,'2010Ap&SS.325..163P',2010,1,0.66,NULL,'G',NULL,NULL,'17.1',0.08,'Sd',NULL,NULL,NULL,NULL,1,250.336333333,77.19625,0.145,NULL,57066982465,891671601,13932368,17.1),(138850,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138850,35.87,NULL,149,66642,NULL,NULL,NULL,'FGC 2065',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138851,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138851,35.88,NULL,150,66642,NULL,NULL,'Dipole + Quadrupole','FGC 2065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138852,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138852,35.9,NULL,151,66642,NULL,NULL,'Dipole','FGC 2065',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138853,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138853,38.11,0.12,418,66643,70,NULL,NULL,'2MASX J16412258+2719425',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.3442083,27.3285,0.169,NULL,56234017634,878656525,13729008,17.5),(138854,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138854,36.65,0.27,214,66644,70,NULL,NULL,'SDSS J164122.73+132722.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.3447083,13.45622,0.237,NULL,56880292211,888754565,13886790,17.1),(138855,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138855,37.08,0.81,261,66645,70,NULL,NULL,'2MFGC 13361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.356167,-63.60178,0.809,NULL,44475005743,694921964,10858155,16),(138856,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138856,35.54,0.46,128,66646,70,NULL,NULL,'2MASX J16413032+2214555',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000167,NULL,'16.0g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,250.3765,22.24889,0.221,NULL,56696800011,885887500,13841992,16),(138857,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138857,38.25,0.46,447,66647,70,NULL,NULL,'SDSS J164131.49+285906.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000167,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,250.38125,28.98511,0.081,NULL,56228803646,878575056,13727735,18.4),(138858,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138858,37.44,0.46,308,66648,70,NULL,NULL,'2MASX J16413253+2345515',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.3854583,23.76425,0.161,NULL,56677879937,885591874,13837373,17.6),(138859,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138859,37.55,0.33,324,66649,70,NULL,NULL,'2MASX J16413257+3715588',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000097,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,250.385541667,37.26639,0.025,NULL,59824556406,934758693,14605604,16.8),(138860,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138860,36.51,0.71,200,66650,70,NULL,NULL,'2MASX J16413529-6311256',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.397083,-63.19044,0.849,NULL,44475371850,694927685,10858245,15.8),(138861,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138861,38.01,0.46,400,66651,70,NULL,NULL,'2MASX J16413559+3033525',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00018,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.3984583,30.56447,0.077,NULL,56208536575,878258383,13722787,17),(138862,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138862,34.48,NULL,78.8,66652,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 080-057',NULL,'2010Ap&SS.325..163P',2010,1,0.97,NULL,'G',0.000009,NULL,'15.6',0.12,'Sbc',NULL,NULL,NULL,NULL,1,250.398708333,9.43211,0.321,NULL,56759199874,886862498,13857226,15.6),(138863,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138863,34.5,NULL,79.3,66652,NULL,NULL,'Dipole + Quadrupole','CGCG 080-057',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138864,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138864,34.51,NULL,79.9,66652,NULL,NULL,'Dipole','CGCG 080-057',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138865,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138865,34.56,NULL,81.6,66652,NULL,NULL,NULL,'CGCG 080-057',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138866,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138866,38.38,0.46,474,66653,70,NULL,NULL,'2MASX J16413581+3049275',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,250.399417,30.82425,0.057,NULL,56208606060,878259469,13722804,17.6),(138867,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138867,37.54,0.46,322,66654,70,NULL,NULL,'SDSS J164136.81+435319.0',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,'FoF','16.9g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,250.403417,43.88861,0,NULL,59848032939,935125514,14611336,16.9),(138868,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138868,36.04,0.27,162,66655,70,NULL,NULL,'CGCG 224-090',NULL,'2015arXiv151105856S',2015,1,1.23,NULL,'G',0.00009,NULL,'14.5g',0.47,'S0',NULL,NULL,NULL,NULL,1,250.4057083,40.1635,0,NULL,59824254989,934753984,14605531,14.5),(138869,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138869,37.48,0.46,313,66656,70,NULL,NULL,'2MASX J16414109+2542535',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.421083333,25.71481,0.145,NULL,56232497189,878632768,13728637,17.3),(138870,'CMD','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138870,14.7,NULL,0.0087,66657,NULL,NULL,NULL,'MESSIER 013',NULL,'2008A&A...477..139L',2008,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,250.4234583,36.46131,0.009,0,59758405895,933725092,14589454,NULL),(138871,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138871,38.11,0.12,418,66658,70,NULL,NULL,'2MASX J16414263+2730265',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000138,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,250.427833,27.50739,0.153,NULL,56233937551,878655274,13728988,18.4),(138872,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138872,38.79,0.46,574,66659,70,NULL,NULL,'SDSS J164142.68+232859.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.427875,23.48319,0.153,NULL,56678602562,885603165,13837549,18.7),(138873,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138873,35.73,0.4,140,66660,NULL,NULL,'mean','CGCG 224-092',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000223,NULL,NULL,NULL,'14.247',NULL,NULL,NULL,NULL,1,250.449167,39.98722,0,NULL,59824388852,934756075,14605563,NULL),(138874,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138874,35.81,0.45,145,66660,NULL,NULL,'K','CGCG 224-092',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138875,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138875,37.55,0.33,324,66661,70,NULL,NULL,'2MASX J16414938+3718335',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.5g',0.37,'AGN',NULL,NULL,NULL,NULL,1,250.455667,37.30928,0.025,NULL,59824569150,934758892,14605607,16.5),(138876,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138876,34.66,0.49,85.7,66662,75,NULL,'IR','ESO 517- G 013',NULL,'2011yCatp016004901K',2011,1,1.08,NULL,'G',0.000027,NULL,'16.9',0.11,'Scd',NULL,NULL,NULL,NULL,1,250.4752917,-24.94564,0.981,NULL,45823768294,715996379,11187443,16.9),(138877,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138877,35.76,0.43,142,66662,75,NULL,'3.6 micron, color + selection bias corrected','ESO 517- G 013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138878,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138878,38.8,0.46,576,66663,70,NULL,NULL,'2MASX J16415445+2558423',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.476833333,25.97828,0.157,NULL,56232441869,878631904,13728623,18.4),(138879,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138879,36.75,0.46,224,66664,70,NULL,NULL,'2MASX J16420164+2731454',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.5067917,27.52928,0.153,NULL,56233930505,878655164,13728986,16.9),(138880,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138880,38.15,0.46,427,66665,70,NULL,NULL,'2MASX J16420190+1949596',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.507917,19.83322,0.289,NULL,56692046718,885813229,13840831,17.4),(138881,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138881,36.62,0.46,211,66666,70,NULL,NULL,'2MASX J16420205+3731046',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000113,NULL,'16.0g',0.34,'S0',NULL,NULL,NULL,NULL,1,250.508583333,37.51786,0.029,NULL,59824593653,934759275,14605613,16),(138882,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138882,31.9,0.8,24,66667,75,NULL,'MAT, I','MCG -01-42-004',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000004,NULL,'15',1.4,'SAB(rs)bc:',NULL,NULL,NULL,NULL,1,250.51325,-5.03269,0.749,NULL,46047836192,719497440,11242147,15),(138883,'Sosies','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138883,31.77,0.23,22.6,66667,NULL,NULL,NULL,'MCG -01-42-004',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138884,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138884,31.5,0.4,20,66667,NULL,NULL,NULL,'MCG -01-42-004',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138885,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138885,31.58,0.43,20.7,66667,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-42-004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138886,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138886,31.67,0.2,21.6,66667,74.4,NULL,NULL,'MCG -01-42-004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138887,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138887,31.69,0.43,21.8,66667,75,NULL,'3.6 micron, color corrected','MCG -01-42-004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138888,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138888,31.92,0.32,24.2,66667,NULL,NULL,NULL,'MCG -01-42-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138889,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138889,31.98,0.47,24.9,66667,NULL,NULL,'H','MCG -01-42-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138890,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138890,31.98,0.4,24.9,66667,NULL,NULL,'mean','MCG -01-42-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138891,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138891,32.02,NULL,25.3,66667,72,NULL,NULL,'MCG -01-42-004',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138892,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138892,32.03,0.46,25.5,66667,NULL,NULL,'J','MCG -01-42-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138893,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138893,32.09,0.45,26.2,66667,NULL,NULL,'K','MCG -01-42-004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138894,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138894,32.09,0.32,26.2,66667,85,NULL,'I, raw','MCG -01-42-004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138895,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138895,32.12,0.32,26.5,66667,85,NULL,'I, inv','MCG -01-42-004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138896,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138896,32.13,0.29,26.6,66667,NULL,NULL,'Malmquist cor.','MCG -01-42-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138897,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138897,32.17,0.43,27.2,66667,75,NULL,'MAT, I, raw','MCG -01-42-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138898,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138898,32.26,0.43,28.3,66667,75,NULL,'MAT, I, cor','MCG -01-42-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138899,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138899,32.31,0.43,29,66667,75,NULL,'MAT, I, inv','MCG -01-42-004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138900,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138900,36.33,0.46,185,66668,70,NULL,NULL,'2MASX J16420354+3232385',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000099,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.514875,32.54422,0.045,NULL,59754038361,933656849,14588388,16.7),(138901,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138901,38.49,0.46,498,66669,70,NULL,NULL,'2MASX J16420614+2743124',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.5255417,27.72025,0.141,NULL,56233651123,878650798,13728918,18.1),(138902,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138902,37.27,0.46,285,66670,70,NULL,NULL,'2MASX J16420641+1928576',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,250.526833333,19.48267,0.329,NULL,56693941701,885842839,13841294,17.3),(138903,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138903,37.11,0.46,264,66671,70,NULL,NULL,'2MASX J16420922+3809525',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00009,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,250.538458333,38.16475,0.029,NULL,59825143035,934767859,14605747,16.1),(138904,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138904,36.27,0.55,179,66672,70,NULL,NULL,'2MASX J16421059-1958560',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.544083,-19.98217,0.821,NULL,45955334739,718052105,11219564,15.4),(138905,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138905,36.15,0.46,170,66673,70,NULL,NULL,'2MASX J16421264+3842285',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000113,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,250.552917,38.70794,0.041,NULL,59827272466,934801132,14606267,16.5),(138906,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138906,38.05,0.46,407,66674,70,NULL,NULL,'2MASXi J1642133+300130',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,250.555583,30.02511,0.053,NULL,56208160386,878252506,13722695,18),(138907,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138907,36.04,0.27,162,66675,70,NULL,NULL,'2MASX J16421465+3950265',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000087,NULL,'16.1g',0.23,'S0',NULL,NULL,NULL,NULL,1,250.560916667,39.84078,0,NULL,59824176735,934752761,14605511,16.1),(138908,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138908,35.92,0.2,153,66676,74.4,NULL,NULL,'CGCG 109-039',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',NULL,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,250.565917,19.15161,0.337,NULL,56690716567,885792446,13840506,15.7),(138909,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138909,38.11,0.12,418,66677,70,NULL,NULL,'2MASX J16421698+2723274',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,250.570916667,27.39092,0.169,NULL,56234075430,878657428,13729022,17.1),(138910,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138910,34.42,NULL,76.7,66678,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2059',NULL,'2010Ap&SS.325..163P',2010,1,0.74,NULL,'G',NULL,NULL,'16.8',0.09,'Sdm',NULL,NULL,NULL,NULL,1,250.575833,48.46056,0,NULL,59829827031,934841047,14606891,16.8),(138911,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138911,34.45,NULL,77.6,66678,NULL,NULL,'Dipole + Quadrupole','FGC 2059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138912,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138912,34.47,NULL,78.3,66678,NULL,NULL,'Dipole','FGC 2059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138913,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138913,34.7,NULL,87.3,66678,NULL,NULL,NULL,'FGC 2059',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138914,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138914,36.36,0.46,187,66679,70,NULL,NULL,'2MASX J16421858+1305156',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.577417,13.08758,0.213,NULL,56882266943,888785420,13887272,17.3),(138915,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138915,35.06,0.74,103,66680,70,NULL,NULL,'2MASX J16422094-1532001',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.58725,-15.53336,1.065,NULL,46126633958,720728655,11261385,15.4),(138916,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138916,35.89,0.49,151,66681,75,NULL,'IR','FGC 2058',NULL,'2011yCatp016004901K',2011,1,0.98,NULL,'G',0.000025,NULL,'17.1g',0.13,'Scd',NULL,NULL,NULL,NULL,1,250.6,20.01322,0.289,NULL,56691895247,885810863,13840794,17.1),(138917,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138917,36.02,NULL,160,66681,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138918,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138918,36.03,NULL,161,66681,NULL,NULL,'Dipole + Quadrupole','FGC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138919,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138919,36.04,NULL,161,66681,NULL,NULL,'Dipole','FGC 2058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138920,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138920,35.79,0.55,144,66682,70,NULL,NULL,'2MASX J16422432-0021486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.65',NULL,NULL,NULL,NULL,NULL,NULL,1,250.60125,-0.36367,0.365,NULL,45178111499,705907992,11029812,15.65),(138921,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138921,37.9,0.46,381,66683,70,NULL,NULL,'2MASX J16422543+2857193',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,250.6060417,28.95528,0.089,NULL,56228763225,878574425,13727725,17.5),(138922,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,NULL,138922,33.91,0.51,60.4,66684,70,NULL,NULL,'FAIRALL 0165',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,'Elliptical',NULL,NULL,NULL,NULL,1,250.606291667,-68.90142,0.369,NULL,45026897895,703545279,10992894,15.3),(138923,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138923,38.11,0.12,418,66685,70,NULL,NULL,'SDSS J164230.39+272600.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000146,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.626667,27.43358,0.153,NULL,56234068664,878657322,13729020,18.7),(138924,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138924,38.02,0.46,402,66686,70,NULL,NULL,'2MASX J16423355+3410297',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.639875,34.17486,0.033,NULL,59759553974,933743030,14589734,17.3),(138925,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138925,38.11,0.12,418,66687,70,NULL,NULL,'2MASX J16423407+2730354',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,250.6419583,27.50972,0.153,NULL,56234060498,878657195,13729018,18.6),(138926,'FP','2016-12-15 15:15:43','2016-12-16 11:20:57','1',NULL,'R',138926,37.53,0.46,321,66688,70,NULL,NULL,'2MASX J16423624+2907584',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000178,NULL,'18.9g',0.09,NULL,NULL,NULL,NULL,NULL,1,250.650917,29.133,0.081,NULL,56228238951,878566233,13727597,18.9),(138927,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138927,36.14,0.56,169,66689,70,NULL,NULL,'2MASX J16423809-6539427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.6587083,-65.66197,0.549,NULL,44991987201,702999800,10984371,15.5),(138928,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138928,38.11,0.12,418,66690,70,NULL,NULL,'2MASX J16423866+2726374',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000201,NULL,'16.5g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,250.6610417,27.44372,0.153,NULL,56234066479,878657288,13729020,16.5),(138929,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138929,38.33,0.46,463,66691,70,NULL,NULL,'2MASX J16423947+3943216',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.664417,39.72256,0,NULL,59824148511,934752320,14605505,17.1),(138930,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138930,37.83,0.46,369,66692,70,NULL,NULL,'2MASX J16424226+3534217',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.67625,35.57283,0.025,NULL,59759209310,933737645,14589650,17.3),(138931,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138931,37.04,0.46,256,66693,70,NULL,NULL,'2MASX J16424521+3557037',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'17.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.68825,35.95111,0.053,NULL,59758504775,933726637,14589478,17.6),(138932,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138932,36.42,0.52,193,66694,70,NULL,NULL,'2MASX J16424551-6450297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.689583,-64.84158,0.673,NULL,44466362301,694786910,10856045,14.8),(138933,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138933,38.11,0.12,418,66695,70,NULL,NULL,'SDSS J164245.85+272759.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.8g',0.13,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,250.691125,27.46667,0.153,NULL,56234066065,878657282,13729020,18.8),(138934,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138934,37.86,0.69,373,66696,70,NULL,NULL,'2MASX J16424816-6637200',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.700708333,-66.62217,0.545,NULL,44991528032,702992625,10984259,15.8),(138935,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138935,38.11,0.12,418,66697,70,NULL,NULL,'2MASX J16424896+2726514',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.703875,27.4475,0.185,NULL,56234037851,878656841,13729013,18.5),(138936,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138936,37.38,0.46,300,66698,70,NULL,NULL,'2MASX J16425081+4625112',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.71175,46.41983,0.009,NULL,59837342295,934958473,14608726,17.1),(138937,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138937,37.82,0.46,367,66699,70,NULL,NULL,'2MASX J16425236+2937039',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,250.7182917,29.61792,0.077,NULL,56227061951,878547842,13727310,18.2),(138938,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138938,38.43,0.46,486,66700,70,NULL,NULL,'2MASX J16425377+2752379',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000173,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.7239583,27.87728,0.125,NULL,56233810468,878653288,13728957,18.4),(138939,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138939,37.2,0.46,276,66701,70,NULL,NULL,'2MASX J16425482+3543327',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.728375,35.72572,0.041,NULL,59758486929,933726358,14589474,17.4),(138940,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138940,37.94,0.46,387,66702,70,NULL,NULL,'2MASX J16425518+2715139',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,250.73,27.25389,0.193,NULL,56233463159,878647861,13728872,18.5),(138941,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138941,38.11,0.12,418,66703,70,NULL,NULL,'2MASX J16425540+2724359',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,250.73075,27.41003,0.185,NULL,56233862305,878654098,13728970,18),(138942,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138942,36.04,0.27,162,66704,70,NULL,NULL,'2MASX J16425732+4007487',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,250.738833,40.13025,0,NULL,59823970591,934749540,14605461,16.7),(138943,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138943,37.56,0.46,326,66705,70,NULL,NULL,'2MASX J16425821+4122267',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000088,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,250.742625,41.37411,0,NULL,59816821329,934637833,14603716,16.7),(138944,'Brightest Stars','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138944,31.65,NULL,21.4,66706,NULL,NULL,'BS','NGC 6207',NULL,'2006MNRAS.369.1303H',2006,1,3,NULL,'G',0.000005,NULL,'12.16',1.3,'SA(s)c         HII','Isolated galaxy',NULL,NULL,NULL,1,250.765625,36.83242,0.049,NULL,59812925487,934576960,14602765,12.16),(138945,'Brightest Stars','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138945,32,NULL,25.1,66706,NULL,NULL,'BS','NGC 6207',NULL,'2006MNRAS.369.1303H',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138946,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A',NULL,138946,31.46,0.1,19.6,66706,NULL,NULL,'SCM','NGC 6207',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138947,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A','R',138947,31.52,0.35,20.2,66706,NULL,NULL,'SCM, V','NGC 6207',NULL,'2008BASI...36...79G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138948,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A',NULL,138948,31.54,0.22,20.3,66706,NULL,NULL,'V, photospheric magnitude method','NGC 6207',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138949,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A','R',138949,31.56,0.12,20.5,66706,NULL,NULL,'SCM, Nugent et al. 06','NGC 6207',NULL,'2008BASI...36...79G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138950,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A','R',138950,31.56,0.28,20.5,66706,NULL,NULL,'SCM, I','NGC 6207',NULL,'2008BASI...36...79G',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138951,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A',NULL,138951,31.61,NULL,21,66706,NULL,NULL,'SCM','NGC 6207',NULL,'2006MNRAS.369.1303H',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138952,'SNII optical','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2004A',NULL,138952,31.66,0.17,21.5,66706,NULL,NULL,'I, photospheric magnitude method','NGC 6207',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138953,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138953,30.62,0.4,13.3,66706,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 6207',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138954,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138954,30.73,0.43,14,66706,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138955,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138955,30.87,0.43,14.9,66706,75,NULL,'3.6 micron, color corrected','NGC 6207',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138956,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138956,31.07,0.36,16.4,66706,NULL,NULL,NULL,'NGC 6207',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138957,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138957,31.08,0.2,16.4,66706,74.4,NULL,NULL,'NGC 6207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138958,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138958,31.21,0.4,17.4,66706,75,NULL,'B','NGC 6207',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138959,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138959,31.42,0.82,19.2,66706,NULL,NULL,NULL,'NGC 6207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138960,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138960,31.47,0.8,19.6,66706,NULL,NULL,'Malmquist cor.','NGC 6207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138961,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138961,38.11,0.12,418,66707,70,NULL,NULL,'SDSS J164306.17+272847.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000133,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,250.77575,27.47989,0.185,NULL,56233871078,878654235,13728972,19),(138962,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138962,37.58,0.46,328,66708,70,NULL,NULL,'2MASX J16430747+2302298',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,250.781167,23.04153,0.165,NULL,56681450436,885647663,13838244,17.7),(138963,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138963,37.32,0.46,291,66709,70,NULL,NULL,'2MASX J16430814+3546321',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,250.783791667,35.77544,0.041,NULL,59758492136,933726439,14589475,16.8),(138964,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138964,37.83,0.46,368,66710,70,NULL,NULL,'2MASX J16430834+3024331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.7847917,30.40911,0.077,NULL,56211715036,878308047,13723563,17.6),(138965,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138965,36.87,0.46,237,66711,70,NULL,NULL,'2MASX J16430901+2406140',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000182,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,250.787583333,24.10372,0.161,NULL,56677765855,885590091,13837345,16.4),(138966,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138966,34.07,0.46,65.1,66712,70,NULL,NULL,'CGCG 251-041',NULL,'2015arXiv151105856S',2015,1,0.95,NULL,'G',0.000083,NULL,'14.8g',0.41,'NLAGN',NULL,NULL,NULL,'Sy 2',1,250.7895,45.84575,0.005,NULL,59840003375,935000052,14609375,14.8),(138967,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138967,36.49,0.56,198,66713,70,NULL,NULL,'2MASX J16431143-6310125',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.7975417,-63.17014,0.865,NULL,44475612519,694931445,10858303,15.8),(138968,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138968,37.74,0.46,354,66714,70,NULL,NULL,'2MASXi J1643122+351258',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,250.800917,35.21622,0.053,NULL,59758977219,933734019,14589594,17.7),(138969,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2010dt',NULL,138969,36.96,0.21,234,66715,73.8,NULL,'SALT 2 (SNANA)','CGCG 168-029',0.0529,'2014ApJ...795...44R',2014,1,0.83,NULL,'G',0.000174,NULL,'15.9g',0.25,'Sb',NULL,NULL,NULL,NULL,1,250.8052083,32.67792,0.073,NULL,59754029788,933656715,14588386,15.9),(138970,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2010dt','R',138970,36.94,0.21,244,66715,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 168-029',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138971,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2010dt','R',138971,36.98,0.22,249,66715,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 168-029',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138972,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138972,36.1,0.46,166,66716,70,NULL,NULL,'2MASX J16431341+2520219',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000148,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,250.8060417,25.33956,0.137,NULL,56229193938,878581155,13727830,16.8),(138973,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138973,37.82,0.46,366,66717,70,NULL,NULL,'SDSS J164317.58+303718.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00013,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.8232917,30.62178,0.077,NULL,56211852332,878310192,13723596,18.5),(138974,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138974,37.69,0.46,346,66718,70,NULL,NULL,'2MASX J16431784+1326397',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.8245,13.44431,0.265,NULL,56880334978,888755234,13886800,17.9),(138975,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138975,36.85,0.33,235,66719,70,NULL,NULL,'2MASX J16431882+2646529',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.8285,26.78136,0.201,NULL,56231699440,878620303,13728442,17.8),(138976,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138976,36.85,0.33,235,66720,70,NULL,NULL,'2MASX J16432000+2637409',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000198,NULL,'16.2g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,250.83325,26.62794,0.205,NULL,56231676968,878619952,13728436,16.2),(138977,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138977,31.23,1.1,17.7,66721,NULL,NULL,NULL,'NGC 6232',NULL,'2009ApJS..182..474S',2009,1,1.6,'MCG misprints name as \'NGC 6237\'; corrected in MCG errata.','G',NULL,NULL,'13.40',1.6,'(R\')SB(s)a','Group member',NULL,NULL,NULL,1,250.834333333,70.63253,0.197,NULL,57842962193,903796284,14121816,13.4),(138978,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138978,31.28,1.08,18,66721,NULL,NULL,'Malmquist cor.','NGC 6232',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138979,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138979,34.8,0.46,91.2,66722,70,NULL,NULL,'NGC 6212',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00008,NULL,'14.7g',0.62,'Sb             Sy1',NULL,NULL,NULL,'Sy 1',1,250.846417,39.80644,0,NULL,59824063799,934750996,14605484,14.7),(138980,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138980,34.17,0.47,68.4,66723,NULL,NULL,'H','NGC 6202',NULL,'2007A&A...465...71T',2007,1,0.8,'Identification as NGC 6202 is very uncertain.','G',0.000043,NULL,'13.8',0.4,'PECULR',NULL,NULL,NULL,NULL,1,250.8467917,61.98394,0.009,NULL,57543775272,899121488,14048773,13.8),(138981,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138981,34.24,0.45,70.4,66723,NULL,NULL,'K','NGC 6202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138982,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138982,34.33,0.46,73.3,66723,NULL,NULL,'J','NGC 6202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138983,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138983,34.49,0.4,78.9,66723,NULL,NULL,'mean','NGC 6202',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(138984,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138984,38.11,0.12,418,66724,70,NULL,NULL,'2MASX J16432464+2728588',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,250.8527917,27.48294,0.185,NULL,56233875905,878654311,13728973,NULL),(138985,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138985,38.45,0.46,490,66725,70,NULL,NULL,'SDSS J164325.15+323031.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.854833,32.50864,0.045,NULL,59754068752,933657324,14588395,18.3),(138986,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138986,38.11,0.12,418,66726,70,NULL,NULL,'2MASX J16432726+2734598',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000175,NULL,'17.9g',0.18,'BrClG',NULL,NULL,NULL,NULL,1,250.863666667,27.58325,0.185,NULL,56233880666,878654385,13728974,17.9),(138987,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138987,37.68,0.33,343,66727,70,NULL,NULL,'SDSS J164330.03+241951.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.875125,24.33106,0.157,NULL,56195378211,878052784,13719574,18.3),(138988,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138988,36.75,0.33,224,66728,70,NULL,NULL,'2MASX J16433224+2542068',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00011,NULL,'16.70',0.56,NULL,NULL,NULL,NULL,NULL,1,250.884375,25.70183,0.149,NULL,56232694349,878635849,13728685,16.7),(138989,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138989,38.11,0.12,418,66729,70,NULL,NULL,'SDSS J164332.25+273332.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000151,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,250.884375,27.55897,0.185,NULL,56233881706,878654401,13728975,18.9),(138990,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138990,34.39,0.51,75.5,66730,70,NULL,NULL,'FAIRALL 0167',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00009,NULL,'14.9b',1,'SA0-',NULL,NULL,NULL,NULL,1,250.8875417,-68.9785,0.369,NULL,45026849999,703544531,10992883,14.9),(138991,'BL Lac Luminosity','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138991,38.42,NULL,483,66731,NULL,NULL,'Min. z = 0.12','1FGL J1643.5-0646',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,250.889,-6.78,0.757,NULL,46092722887,720198795,11253106,NULL),(138992,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138992,36.46,0.21,196,66732,70,NULL,NULL,'2MASX J16433596+2638508',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.8997917,26.64758,0.201,NULL,56231497141,878617142,13728392,17.5),(138993,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138993,35.25,0.49,112,66733,75,NULL,'IR','CGCG 110-004',NULL,'2011yCatp016004901K',2011,1,0.84,NULL,'G',0.000083,NULL,'16.0g',0.24,'Scd',NULL,NULL,NULL,NULL,1,250.900708333,20.23169,0.297,NULL,56684359721,885693120,13838955,16),(138994,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138994,35.89,0.62,151,66734,70,NULL,NULL,'2MASX J16433871-6417046',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.91125,-64.28458,0.745,NULL,44466777352,694793396,10856146,15.2),(138995,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,138995,37.22,0.65,279,66735,70,NULL,NULL,'2MASX J16433990-0039091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,250.91625,-0.6525,0.377,NULL,45178029891,705906717,11029792,16.24),(138996,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138996,37.92,0.27,384,66736,70,NULL,NULL,'2MASX J16434047+3227316',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,250.9185417,32.45875,0.045,NULL,59753185795,933643528,14588180,17.1),(138997,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138997,37.68,0.33,343,66737,70,NULL,NULL,'2MASX J16434122+2418289',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,250.9217083,24.30811,0.157,NULL,56196239491,878066242,13719785,17.6),(138998,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138998,38.59,0.46,523,66738,70,NULL,NULL,'2MASX J16434263+3703145',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,250.927583,37.05392,0.065,NULL,59824636719,934759948,14605624,18.1),(138999,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',138999,38.07,0.46,411,66739,70,NULL,NULL,'2MASX J16434420+2914358',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,250.934291667,29.24319,0.081,NULL,56227075585,878548056,13727313,18.1),(139000,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139000,38.14,0.46,424,66740,70,NULL,NULL,'2MASX J16434453+1927497',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',NULL,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,250.9355,19.46381,0.345,NULL,56682410525,885662664,13838479,16.6),(139001,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139001,38.11,0.12,418,66741,70,NULL,NULL,'2MASX J16434471+2729259',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,250.936375,27.49053,0.185,NULL,56233828479,878653569,13728962,17.7),(139002,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139002,37.92,0.27,384,66742,70,NULL,NULL,'2MASX J16434616+3225287',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000196,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,250.942375,32.42453,0.045,NULL,59753186131,933643533,14588180,17.3),(139003,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139003,37.78,0.46,359,66743,70,NULL,NULL,'2MASX J16434718+2720098',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,250.9467083,27.33608,0.185,NULL,56233382158,878646596,13728853,17.7),(139004,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139004,36.89,0.63,238,66744,70,NULL,NULL,'2MASX J16435522-6528495',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,250.980167,-65.48042,0.565,NULL,44992015986,703000249,10984378,15.8),(139005,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139005,37.92,0.27,384,66745,70,NULL,NULL,'2MASX J16435579+3222337',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000156,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,250.982625,32.376,0.045,NULL,59753267940,933644811,14588200,17.1),(139006,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139006,36.75,0.33,224,66746,70,NULL,NULL,'2MASX J16435623+2541426',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000192,NULL,'16.0g',0.35,'E0',NULL,NULL,NULL,NULL,1,250.984458333,25.69517,0.149,NULL,56232691525,878635805,13728684,16),(139007,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139007,33.98,0.47,62.5,66747,70,NULL,NULL,'2MASX J16440203-6156345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'13.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,251.008708333,-61.94292,0.945,NULL,44473293380,694895209,10857737,13.2),(139008,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139008,38.8,0.46,575,66748,70,NULL,NULL,'2MASX J16440478+4038547',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.0001,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.02,40.64867,0,NULL,59816537494,934633398,14603646,17.7),(139009,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139009,34.4,0.8,75.7,66749,75,NULL,'CF, r','UGC 10536',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00004,NULL,'14.6',0.9,'Sb',NULL,NULL,NULL,NULL,1,251.0252083,62.08733,0.009,NULL,57543996286,899124941,14048827,14.6),(139010,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139010,34.82,0.38,92,66749,75,NULL,'CF, r, raw','UGC 10536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139011,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139011,34.96,0.38,98,66749,75,NULL,'CF, r, inv','UGC 10536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139012,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139012,35.05,0.38,102,66749,75,NULL,'CF, r, cor','UGC 10536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139013,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139013,36.89,0.46,238,66750,70,NULL,NULL,'2MASX J16440680+4236135',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000084,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.028416667,42.60369,0,NULL,59844918185,935076846,14610575,16.7),(139014,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139014,37.15,0.46,269,66751,70,NULL,NULL,'2MASX J16440951+3708468',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.039833,37.14631,0.065,NULL,59824519586,934758118,14605595,17.2),(139015,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139015,36.71,0.46,219,66752,70,NULL,NULL,'2MASX J16441142+2758106',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.0475,27.96964,0.165,NULL,56236540399,878695943,13729624,17.7),(139016,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139016,36.46,0.21,196,66753,70,NULL,NULL,'2MASX J16441234+2644046',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.051583333,26.73478,0.201,NULL,56232010673,878625166,13728518,17),(139017,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139017,37.04,0.46,255,66754,70,NULL,NULL,'2MASX J16441390+2528286',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000221,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,251.057875,25.47456,0.141,NULL,56229332483,878583320,13727864,16.6),(139018,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139018,34.38,NULL,75.2,66755,NULL,NULL,'Dipole','ESO 179- G 012',NULL,'2010Ap&SS.325..163P',2010,1,2.46,'Star superposed.','G',0.000025,NULL,'15.7',0.22,'Sd',NULL,NULL,NULL,NULL,1,251.0892083,-55.49367,NULL,NULL,44539847735,695935120,10873986,15.7),(139019,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139019,34.4,NULL,75.8,66755,NULL,NULL,'Dipole + Quadrupole','ESO 179- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139020,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139020,34.4,NULL,75.8,66755,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 179- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139021,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139021,37.26,0.46,283,66756,70,NULL,NULL,'2MASX J16442163+3726188',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000097,NULL,'16.1g',0.4,'E0',NULL,NULL,NULL,NULL,1,251.090083,37.43869,0.061,NULL,59824529627,934758275,14605598,16.1),(139022,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139022,34.83,NULL,92.5,66757,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10534',NULL,'2010Ap&SS.325..163P',2010,1,1,NULL,'G',NULL,NULL,'17.',0.08,'Sd',NULL,NULL,NULL,NULL,1,251.097625,58.84253,0,NULL,57651917161,900811205,14075175,17),(139023,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139023,34.84,NULL,93.1,66757,NULL,NULL,'Dipole + Quadrupole','UGC 10534',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139024,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139024,34.87,NULL,94,66757,NULL,NULL,'Dipole','UGC 10534',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139025,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139025,34.9,NULL,95.7,66757,NULL,NULL,NULL,'UGC 10534',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139026,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139026,36.57,0.46,206,66758,70,NULL,NULL,'2MASX J16442354+2444136',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000182,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.097958333,24.73708,0.153,NULL,56196182369,878065349,13719771,16.3),(139027,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139027,36.46,0.21,196,66759,70,NULL,NULL,'2MASX J16442500+2636355',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00017,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.10425,26.60989,0.201,NULL,56232035172,878625549,13728524,16.6),(139028,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139028,38.09,0.46,416,66760,70,NULL,NULL,'2MASX J16442704+1327119',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,251.112625,13.45336,0.213,NULL,56880718513,888761226,13886894,17.3),(139029,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139029,38.13,0.46,423,66761,70,NULL,NULL,'SDSS J164427.92+435130.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.116375,43.85853,0.005,NULL,59844771375,935074552,14610539,18.1),(139030,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139030,38.11,0.12,418,66762,70,NULL,NULL,'2MASX J16442869+2720158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.119583,27.33767,0.185,NULL,56233395517,878646804,13728856,18.2),(139031,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139031,36.79,0.78,228,66763,70,NULL,NULL,'2MASX J16443025-6338313',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,251.125916667,-63.64208,0.745,NULL,44474638067,694916219,10858065,16),(139032,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139032,34.6,0.46,83.1,66764,70,NULL,NULL,'MRK 0888',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000106,NULL,'15.1g',0.53,'E/S0','Isolated galaxy',NULL,NULL,NULL,1,251.128166667,19.94075,0.333,NULL,56684412951,885693952,13838968,15.1),(139033,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139033,36.46,0.21,196,66765,70,NULL,NULL,'CGCG 138-066',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000183,NULL,'15.4',0.51,NULL,NULL,NULL,NULL,NULL,1,251.133875,26.68275,0.201,NULL,56232047983,878625749,13728527,15.4),(139034,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139034,38.22,0.46,440,66766,70,NULL,NULL,'SDSS J164432.18+272149.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.134083,27.36389,0.185,NULL,56233408677,878647010,13728859,18.3),(139035,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139035,37.85,0.46,372,66767,70,NULL,NULL,'SDSS J164434.43+280258.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.1434583,28.04964,0.161,NULL,56236686579,878698227,13729659,18.2),(139036,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139036,31.61,0.4,21,66768,NULL,NULL,NULL,'NGC 6236',NULL,'2009AJ....138..323T',2009,1,2.9,NULL,'G',0.00002,NULL,'12.63',1.7,'SAB(s)cd','Group member',NULL,NULL,NULL,1,251.144375,70.78022,0.197,NULL,57840231598,903753618,14121150,12.63),(139037,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139037,31.83,0.4,23.3,66768,75,NULL,'B','NGC 6236',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139038,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139038,31.87,0.2,23.7,66768,74.4,NULL,NULL,'NGC 6236',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139039,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139039,31.91,0.43,24,66768,75,NULL,'3.6 micron, color corrected','NGC 6236',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139040,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139040,31.95,0.43,24.6,66768,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6236',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139041,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139041,32.12,0.55,26.5,66768,NULL,NULL,NULL,'NGC 6236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139042,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139042,32.3,0.51,28.9,66768,NULL,NULL,'Malmquist cor.','NGC 6236',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139043,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139043,38.33,0.46,464,66769,70,NULL,NULL,'2MASX J16443654+3618376',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000143,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,251.152125,36.31042,0.065,NULL,59744937625,933514650,14586166,16.9),(139044,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139044,35.64,0.59,134,66770,70,NULL,NULL,'2MASX J16444001-1540553',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,251.16675,-15.68206,1.113,NULL,46126673182,720729268,11261394,14.6),(139045,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139045,38.26,0.46,448,66771,70,NULL,NULL,'2MASX J16444051+2745419',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.16875,27.7615,0.173,NULL,56236521830,878695653,13729619,17.7),(139046,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139046,37.45,0.46,309,66772,70,NULL,NULL,'2MASXi J1644418+411853',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00007,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,251.1745,41.31486,0,NULL,59816686931,934635733,14603683,17.6),(139047,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139047,37.53,0.46,321,66773,70,NULL,NULL,'2MASX J16444298+2704059',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.1792083,27.06836,0.193,NULL,56233300448,878645319,13728833,17.3),(139048,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139048,35.84,0.61,147,66774,70,NULL,NULL,'2MASX J16444520-2056572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,251.188417,-20.94917,0.965,NULL,45924608951,717572014,11212062,15.7),(139049,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139049,37.63,0.27,336,66775,70,NULL,NULL,'2MASX J16444570+3413121',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.190417,34.22017,0.061,NULL,59757603917,933712561,14589258,17.1),(139050,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139050,36.02,0.56,160,66776,70,NULL,NULL,'2MASX J16444633-6506322',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,251.1932083,-65.109,0.673,NULL,44989705403,702964146,10983814,15.6),(139051,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139051,38.07,0.46,410,66777,70,NULL,NULL,'2MASX J16445119+3040151',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000205,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.213167,30.67092,0.077,NULL,56211889742,878310777,13723605,17.2),(139052,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139052,37.34,0.46,294,66778,70,NULL,NULL,'2MASX J16445206+3245481',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00016,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.2170417,32.76325,0.069,NULL,59753203320,933643801,14588184,17.1),(139053,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139053,37.63,0.27,336,66779,70,NULL,NULL,'2MASX J16445287+3412511',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000203,NULL,'16.3g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,251.2202917,34.21422,0.061,NULL,59757603329,933712552,14589258,16.3),(139054,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139054,37.33,0.46,293,66780,70,NULL,NULL,'2MASX J16445350+3427121',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000139,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.2229583,34.45333,0.073,NULL,59757569502,933712023,14589250,17.5),(139055,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139055,37.08,0.46,261,66781,70,NULL,NULL,'2MASX J16445461+3131592',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000178,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,251.227583,31.53314,0.073,NULL,56210964750,878296324,13723380,16.9),(139056,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139056,37.63,0.27,336,66782,70,NULL,NULL,'2MASX J16445497+3411112',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,251.228916667,34.18644,0.061,NULL,59757602180,933712534,14589258,18),(139057,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139057,37.44,0.46,307,66783,70,NULL,NULL,'2MASX J16450114+2754233',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000054,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,251.254833,27.90653,0.165,NULL,56236569625,878696400,13729631,17.7),(139058,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139058,38.73,0.46,556,66784,70,NULL,NULL,'2MASX J16450188+4008167',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000101,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.25775,40.13778,0.005,NULL,59823945474,934749148,14605455,17.5),(139059,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139059,37.79,0.46,361,66785,70,NULL,NULL,'2MASX J16450236+3631587',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.25975,36.533,0.069,NULL,59812985994,934577906,14602779,18.1),(139060,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139060,37,0.46,252,66786,70,NULL,NULL,'2MASX J16450397+3838407',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00009,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,251.2664583,38.64475,0.025,NULL,59827413404,934803334,14606302,16.2),(139061,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139061,37.52,0.46,319,66787,70,NULL,NULL,'2MASX J16450581+3454402',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000184,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.274167,34.91122,0.049,NULL,59745041797,933516278,14586191,17.4),(139062,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139062,37.06,0.33,259,66788,70,NULL,NULL,'2MASX J16450708+4208249',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000113,NULL,'16.3g',0.34,'NLAGN',NULL,NULL,NULL,'Sy 2',1,251.279583,42.14022,0,NULL,59818693271,934667082,14604173,16.3),(139063,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139063,34.44,0.49,77.2,66789,75,NULL,'IR','UGC 10542',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',NULL,NULL,'15.60',0.2,'Sc',NULL,NULL,NULL,NULL,1,251.2814583,61.84025,0.033,NULL,57535409479,898990773,14046730,15.6),(139064,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139064,34.66,0.47,85.6,66789,NULL,NULL,'H','UGC 10542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139065,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139065,34.67,0.4,86,66789,NULL,NULL,'mean','UGC 10542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139066,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139066,34.72,0.45,88,66789,NULL,NULL,'K','UGC 10542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139067,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139067,34.78,0.2,90.4,66789,74.4,NULL,NULL,'UGC 10542',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139068,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139068,34.83,0.48,92.5,66789,NULL,NULL,'Malmquist cor.','UGC 10542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139069,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139069,34.9,0.47,95.6,66789,NULL,NULL,NULL,'UGC 10542',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139070,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139070,34.96,0.46,98.1,66789,NULL,NULL,'J','UGC 10542',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139071,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139071,34.52,0.51,80.1,66790,70,NULL,NULL,'ESO 101- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000147,NULL,'14.45',0.9,'SA(r)0/a:',NULL,NULL,NULL,NULL,1,251.283,-66.61681,0.545,NULL,45021929554,703467649,10991682,14.45),(139072,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139072,37.53,0.46,321,66791,70,NULL,NULL,'2MASX J16451012+3649398',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000107,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.29225,36.82789,0.073,NULL,59813074014,934579281,14602801,16.7),(139073,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139073,36.5,0.46,200,66792,70,NULL,NULL,'2MASX J16451067+4253289',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00008,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,251.2945417,42.89156,0.021,NULL,59845104626,935079759,14610621,16.3),(139074,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139074,35.09,0.49,104,66793,75,NULL,'IR','CGCG 168-032',NULL,'2011yCatp016004901K',2011,1,0.86,NULL,'G',0.000094,NULL,'15.7g',0.28,'Sc',NULL,NULL,NULL,NULL,1,251.296667,31.30364,0.065,NULL,56210767542,878293242,13723331,15.7),(139075,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139075,35.41,0.2,121,66794,74.4,NULL,NULL,'CGCG 168-032',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000094,NULL,'15.7g',0.28,'Sc',NULL,NULL,NULL,NULL,1,251.296667,31.30364,0.065,NULL,56210767542,878293242,13723331,15.7),(139076,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139076,37.16,0.46,271,66795,70,NULL,NULL,'2MASX J16451300+2654573',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.3042917,26.91589,0.229,NULL,56230152551,878596133,13728064,17.5),(139077,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139077,38.65,0.46,536,66796,70,NULL,NULL,'2MASX J16451441+1311005',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.31,13.18356,0.213,NULL,56882872899,888794889,13887420,17.8),(139078,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139078,35.97,0.46,156,66797,70,NULL,NULL,'SDSS J164515.55+431711.3',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00008,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.3147917,43.2865,0.013,NULL,59845360283,935083754,14610683,16.3),(139079,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139079,35.97,0.46,156,66798,70,NULL,NULL,'2MASX J16451764+2412234',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,251.3235,24.20639,0.169,NULL,56195701876,878057841,13719653,16.1),(139080,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139080,39.05,0.46,644,66799,70,NULL,NULL,'2MASX J16451852+3837358',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,'FoF','17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.327167,38.62658,0.025,NULL,59826672372,934791755,14606121,17.6),(139081,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139081,46.8,1.59,5730,66800,NULL,NULL,NULL,'GRB 090715B',3,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,251.339875,44.83889,0,NULL,59836785655,934949775,14608590,NULL),(139082,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139082,37.06,0.33,259,66801,70,NULL,NULL,'2MASX J16452713+4204450',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000089,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,251.362917,42.07936,0,NULL,59818685292,934666957,14604171,16.6),(139083,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139083,38.17,0.23,430,66802,70,NULL,NULL,'B2 1643+27',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000189,NULL,'16.4g',0.37,'BrClG',NULL,NULL,'radio jet',NULL,1,251.365333,27.33497,0.193,NULL,56236922539,878701914,13729717,16.4),(139084,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139084,37.55,0.27,323,66803,70,NULL,NULL,'2MASX J16452982+3105322',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,251.3744583,31.09231,0.065,NULL,56211091477,878298304,13723411,16.9),(139085,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139085,34.06,0.47,64.9,66804,70,NULL,NULL,'2MASX J16453066-6254412',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'15.03',0.48,NULL,NULL,NULL,NULL,NULL,1,251.377625,-62.91089,0.777,NULL,44475498470,694929663,10858275,15.03),(139086,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139086,36.89,0.46,239,66805,70,NULL,NULL,'2MASX J16453592+3134172',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00018,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,251.39975,31.57136,0.073,NULL,56211000605,878296884,13723388,16.2),(139087,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139087,37.98,0.46,394,66806,70,NULL,NULL,'SDSS J164536.44+302731.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.401875,30.45875,0.077,NULL,56209703139,878276611,13723072,18.3),(139088,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139088,35.63,0.46,134,66807,70,NULL,NULL,'CGCG 168-033',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000171,NULL,'15.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,251.40525,26.98103,0.229,NULL,56234619421,878665928,13729155,15.5),(139089,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139089,38.22,0.46,440,66808,70,NULL,NULL,'2MASX J16453871+3952248',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000101,NULL,'17.3g',0.21,'NLAGN',NULL,NULL,NULL,'Sy 2',1,251.41125,39.87353,0,NULL,59826794590,934793665,14606151,17.3),(139090,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139090,37.86,0.46,374,66809,70,NULL,NULL,'2MASX J16454250+2833342',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.427,28.55942,0.149,NULL,56235642814,878681918,13729404,18),(139091,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139091,36.53,0.46,202,66810,70,NULL,NULL,'2MASX J16454280+1302246',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.42825,13.04011,0.193,NULL,56879239027,888738109,13886532,17.7),(139092,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139092,35.24,0.56,112,66811,70,NULL,NULL,'2MASX J16455059-8434065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,251.460917,-84.5685,0.401,NULL,44086038793,688844356,10763193,16.7),(139093,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139093,35.76,0.46,142,66812,70,NULL,NULL,'I Zw 164',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000105,NULL,'15.3g',0.49,'E/S0',NULL,NULL,NULL,NULL,1,251.4662083,44.63719,0,NULL,59836745550,934949149,14608580,15.3),(139094,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139094,37.22,0.46,278,66813,70,NULL,NULL,'SDSS J164553.54+212005.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.473125,21.33489,0.249,NULL,56687000416,885734381,13839599,17.9),(139095,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139095,38.17,0.23,430,66814,70,NULL,NULL,'2MASX J16455479+2718063',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,251.478333,27.30192,0.193,NULL,56236943139,878702236,13729722,17.5),(139096,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139096,34.78,0.49,90.5,66815,75,NULL,'IR','ESO 023- G 002',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.03',0.3,'S...',NULL,NULL,NULL,NULL,1,251.4809583,-81.45822,0.393,NULL,44054982379,688359099,10755610,15.03),(139097,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139097,35.07,0.54,103,66815,NULL,NULL,NULL,'ESO 023- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139098,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139098,35.11,0.2,105,66815,74.4,NULL,NULL,'ESO 023- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139099,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139099,35.23,0.5,111,66815,NULL,NULL,'Malmquist cor.','ESO 023- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139100,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139100,37.29,0.46,287,66816,70,NULL,NULL,'2MASX J16455556+3759023',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000141,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,251.481625,37.98392,0.061,NULL,59824920551,934764383,14605693,17.1),(139101,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139101,35.9,0.46,151,66817,70,NULL,NULL,'2MASX J16455569+2715193',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000177,NULL,'16.1g',0.36,NULL,NULL,NULL,NULL,NULL,1,251.481917,27.25539,0.193,NULL,56236735422,878698990,13729671,16.1),(139102,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139102,35.11,NULL,105,66818,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2067',NULL,'2010Ap&SS.325..163P',2010,1,1.46,NULL,'G',0.000033,NULL,'16.2g',0.17,'Sd(f)',NULL,NULL,NULL,NULL,1,251.4889583,39.98583,0,NULL,59826771477,934793304,14606145,16.2),(139103,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139103,35.12,NULL,106,66818,NULL,NULL,'Dipole + Quadrupole','FGC 2067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139104,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139104,35.14,NULL,107,66818,NULL,NULL,'Dipole','FGC 2067',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139105,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139105,35.16,NULL,108,66818,NULL,NULL,NULL,'FGC 2067',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139106,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139106,37.89,0.46,379,66819,70,NULL,NULL,'SDSS J164557.59+301912.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000138,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.49,30.32019,0.113,NULL,56209763705,878277557,13723086,18.6),(139107,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139107,37.97,0.46,392,66820,70,NULL,NULL,'SDSS J164559.77+251938.5',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.499083,25.32739,0.165,NULL,56195864113,878060376,13719693,18.1),(139108,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139108,38.29,0.33,455,66821,70,NULL,NULL,'SDSS J164600.56+634127.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.502417,63.691,0.053,NULL,57543382445,899115350,14048677,18.3),(139109,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139109,38.07,0.46,411,66822,70,NULL,NULL,'2MASX J16460094+3812524',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.503917,38.21447,0.057,NULL,59824780616,934762197,14605659,17.8),(139110,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139110,35.36,0.4,118,66823,NULL,NULL,'mean','UGC 10535',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',NULL,NULL,'15.40',0.2,'Sab',NULL,NULL,NULL,NULL,1,251.506375,6.46253,0.301,NULL,56769330378,887020787,13859699,15.4),(139111,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139111,35.46,0.49,123,66823,75,NULL,'IR','UGC 10535',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139112,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139112,35.54,0.47,128,66823,NULL,NULL,'H','UGC 10535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139113,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139113,35.57,0.45,130,66823,NULL,NULL,'K','UGC 10535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139114,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139114,35.64,0.46,134,66823,NULL,NULL,'J','UGC 10535',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139115,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139115,37.55,0.27,323,66824,70,NULL,NULL,'2MASX J16460201+3108530',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000152,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.508417,31.14803,0.065,NULL,56211119885,878298748,13723417,17),(139116,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139116,36.62,0.46,211,66825,70,NULL,NULL,'2MASX J16460398+2855513',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000166,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.516625,28.93092,0.129,NULL,56227343778,878552246,13727378,16.6),(139117,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139117,44.16,0.57,3580,66826,NULL,NULL,NULL,'GRB 091003',0.8969,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,251.519625,36.62514,0.069,NULL,59812964844,934577575,14602774,NULL),(139118,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139118,43.82,0.09,5810,66826,NULL,NULL,NULL,'GRB 091003',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139119,'GRB','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139119,45.97,0.28,15600,66826,NULL,NULL,NULL,'GRB 091003',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139120,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139120,37.82,0.33,367,66827,70,NULL,NULL,'2MASX J16460731+3439080',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.5305,34.65225,0.069,NULL,59746877155,933544955,14586639,18.1),(139121,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139121,38.17,0.23,430,66828,70,NULL,NULL,'2MASX J16461091+2724593',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,251.545333333,27.41636,0.193,NULL,56236937587,878702149,13729721,17.6),(139122,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139122,37.77,0.46,358,66829,70,NULL,NULL,'SDSS J164611.95+314251.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000178,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.549833,31.71428,0.073,NULL,56210956988,878296202,13723378,18.3),(139123,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139123,37.73,0.46,351,66830,70,NULL,NULL,'2MASX J16461246+2832533',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.551917,28.54817,0.149,NULL,56235643244,878681925,13729405,17.4),(139124,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139124,36.05,0.46,162,66831,70,NULL,NULL,'2MASX J16461302+2215021',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.5544583,22.25064,0.217,NULL,56679169867,885612029,13837687,17.2),(139125,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139125,37.82,0.33,367,66832,70,NULL,NULL,'2MASX J16461517+3438200',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000152,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,251.56325,34.63886,0.069,NULL,59746875218,933544925,14586639,17),(139126,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139126,37.47,0.46,312,66833,70,NULL,NULL,'2MASX J16461873+2657253',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.578291667,26.95689,0.209,NULL,56234637073,878666204,13729159,16.9),(139127,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139127,36.5,0.46,200,66834,70,NULL,NULL,'2MASX J16462020+2415093',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00016,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,251.58425,24.25269,0.169,NULL,56195596943,878056202,13719628,16.7),(139128,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139128,31.63,0.4,21.2,66835,75,NULL,'B','NGC 6248',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.00002,NULL,'13.70',1.2,'SBd','Group member',NULL,NULL,NULL,1,251.591625,70.35881,0.193,NULL,57842898925,903795295,14121801,13.7),(139129,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139129,31.81,0.43,23,66835,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6248',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139130,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139130,31.84,0.43,23.4,66835,75,NULL,'3.6 micron, color corrected','NGC 6248',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139131,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139131,31.88,0.2,23.8,66835,74.4,NULL,NULL,'NGC 6248',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139132,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139132,32.16,0.51,27,66835,NULL,NULL,NULL,'NGC 6248',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139133,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139133,32.34,0.47,29.4,66835,NULL,NULL,'Malmquist cor.','NGC 6248',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139134,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139134,35.55,0.33,129,66836,70,NULL,NULL,'2MASX J16462241+3943505',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000057,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,251.5932083,39.73081,0.041,NULL,59826808812,934793887,14606154,15.7),(139135,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139135,38.96,0.46,619,66837,70,NULL,NULL,'2MASX J16462280+2936163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000174,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,251.5950417,29.60472,0.121,NULL,56226812836,878543950,13727249,18.2),(139136,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139136,37.13,0.46,266,66838,70,NULL,NULL,'SDSS J164625.30+252517.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000173,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.605417,25.42147,0.165,NULL,56198705724,878104776,13720387,18),(139137,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139137,37.64,0.23,337,66839,70,NULL,NULL,'2MASX J16462578+2007029',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,251.607333333,20.11744,0.321,NULL,56685946097,885717907,13839342,18.2),(139138,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139138,37.58,0.46,328,66840,70,NULL,NULL,'2MASX J16462670+2747443',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.611333333,27.79578,0.173,NULL,56237200481,878706257,13729785,18.4),(139139,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139139,36.08,0.46,165,66841,70,NULL,NULL,'2MASX J16462724+2759113',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000176,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,251.6135417,27.98653,0.181,NULL,56237119776,878704996,13729765,16.7),(139140,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139140,38.2,0.46,436,66842,70,NULL,NULL,'2MASX J16462838+3831156',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.16,'AGN',NULL,NULL,NULL,NULL,1,251.618417,38.52111,0.065,NULL,59826758623,934793103,14606142,17.7),(139141,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139141,36.2,0.33,174,66843,70,NULL,NULL,'CGCG 168-036',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000147,NULL,'15.1g',0.65,NULL,NULL,NULL,NULL,NULL,1,251.637083,27.31825,0.193,NULL,56236802530,878700039,13729688,15.1),(139142,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139142,38.29,0.33,455,66844,70,NULL,NULL,'2MASX J16463312+6339297',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000108,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,251.6382083,63.65814,0.053,NULL,57543390984,899115484,14048679,16.4),(139143,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139143,36.15,0.46,170,66845,70,NULL,NULL,'2MASX J16463413+2441083',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,251.642166667,24.68556,0.165,NULL,56195626703,878056667,13719635,16.4),(139144,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139144,37.81,0.46,365,66846,70,NULL,NULL,'2MASX J16463432+3556016',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,251.643,35.93375,0.057,NULL,59745610499,933525164,14586330,18.4),(139145,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139145,37.91,0.46,382,66847,70,NULL,NULL,'2MASX J16463484+3050167',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.645125,30.83806,0.101,NULL,56211236263,878300566,13723446,17.6),(139146,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139146,34.69,0.54,86.6,66848,NULL,NULL,'Malmquist cor.','ESO 453- G 003',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'13.61',0.5,'Sb:',NULL,NULL,NULL,NULL,1,251.647625,-31.58933,NULL,NULL,45795396785,715553074,11180516,13.61),(139147,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139147,34.75,0.52,89.1,66848,NULL,NULL,NULL,'ESO 453- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139148,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139148,34.79,0.2,90.8,66848,74.4,NULL,NULL,'ESO 453- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139149,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139149,34.98,0.4,99.3,66848,NULL,NULL,'mean','ESO 453- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139150,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139150,35.1,0.47,105,66848,NULL,NULL,'H','ESO 453- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139151,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139151,34.27,NULL,71.6,66849,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10561',NULL,'2010Ap&SS.325..163P',2010,1,3.09,NULL,'G',0.000027,NULL,'15.05',0.31,'Sb',NULL,NULL,NULL,NULL,1,251.65,62.82269,0.029,NULL,57545196328,899143692,14049120,15.05),(139152,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139152,34.28,NULL,71.7,66849,NULL,NULL,'Dipole + Quadrupole','UGC 10561',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139153,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139153,34.28,NULL,71.7,66849,NULL,NULL,'Dipole','UGC 10561',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139154,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139154,34.36,0.47,74.6,66849,NULL,NULL,'H','UGC 10561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139155,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139155,34.42,0.45,76.4,66849,NULL,NULL,'K','UGC 10561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139156,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139156,34.43,0.49,76.8,66849,75,NULL,'IR','UGC 10561',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139157,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139157,34.51,0.4,79.9,66849,NULL,NULL,'mean','UGC 10561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139158,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139158,34.52,0.46,80.1,66849,NULL,NULL,'J','UGC 10561',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139159,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139159,35.87,NULL,149,66850,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2071',NULL,'2010Ap&SS.325..163P',2010,1,0.8,NULL,'G',0.0001,NULL,'16.5',0.1,'Sc',NULL,NULL,NULL,NULL,1,251.65175,69.34542,0.189,NULL,57841736564,903777133,14121517,16.5),(139160,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139160,35.89,NULL,151,66850,NULL,NULL,'Dipole + Quadrupole','FGC 2071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139161,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139161,35.9,NULL,151,66850,NULL,NULL,NULL,'FGC 2071',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139162,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139162,35.92,NULL,153,66850,NULL,NULL,'Dipole','FGC 2071',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139163,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139163,38.3,0.33,458,66851,70,NULL,NULL,'SDSS J164638.25+384819.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000087,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,251.659417,38.80553,0.061,NULL,59826601901,934790654,14606103,17.3),(139164,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139164,35.77,0.46,143,66852,70,NULL,NULL,'2MASX J16464059+4045297',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000073,NULL,'16.0g',0.4,'E0',NULL,NULL,NULL,NULL,1,251.66925,40.75833,0,NULL,59818340814,934661575,14604087,16),(139165,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139165,38.17,0.23,430,66853,70,NULL,NULL,'2MASX J16464187+2716303',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000159,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,251.674417,27.27511,0.193,NULL,56234822032,878669094,13729204,17.3),(139166,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139166,37.44,0.46,307,66854,70,NULL,NULL,'2MASX J16464205+3327057',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.675375,33.45167,0.057,NULL,59745907360,933529802,14586403,17),(139167,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139167,36.2,0.33,174,66855,70,NULL,NULL,'2MASX J16464277+2715423',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,251.678417,27.26169,0.193,NULL,56234822620,878669103,13729204,17.1),(139168,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139168,37.55,0.27,323,66856,70,NULL,NULL,'2MASX J16464323+3114418',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000151,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,251.6800417,31.24506,0.089,NULL,56210637859,878291216,13723300,16.8),(139169,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139169,36.84,0.46,233,66857,70,NULL,NULL,'2MASX J16464761+2609263',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,251.6985,26.15722,0.233,NULL,56230591684,878602995,13728171,17.1),(139170,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139170,35.91,0.46,152,66858,70,NULL,NULL,'CGCG 138-072',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000182,NULL,'15.3g',0.57,'E','Isolated galaxy',NULL,NULL,NULL,1,251.704833,22.90508,0.213,NULL,56681029158,885641080,13838141,15.3),(139171,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139171,38.16,0.46,428,66859,70,NULL,NULL,'2MASX J16465059+3954317',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.7107083,39.90881,0.041,NULL,59825742065,934777219,14605894,17.5),(139172,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139172,37.95,0.46,388,66860,70,NULL,NULL,'2MASX J16465227+3732067',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.718041667,37.53511,0.049,NULL,59813500026,934585937,14602905,17.8),(139173,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139173,35.49,0.8,126,66861,75,NULL,'CF, r','UGC 10545',NULL,'1997ApJS..109..333W',1997,1,1.43,NULL,'G',0.000033,NULL,'14.8g',0.45,'Sbc',NULL,NULL,NULL,NULL,1,251.7207083,34.41003,0.061,NULL,59746320902,933536264,14586504,14.8),(139174,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139174,34.93,0.38,96.8,66861,75,NULL,'CF, r, raw','UGC 10545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139175,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139175,35.07,0.38,103,66861,75,NULL,'CF, r, inv','UGC 10545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139176,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139176,35.21,0.2,110,66861,74.4,NULL,NULL,'UGC 10545',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139177,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139177,35.29,0.38,114,66861,75,NULL,'CF, r, cor','UGC 10545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139178,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139178,34.23,NULL,70.2,66862,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2068',NULL,'2010Ap&SS.325..163P',2010,1,0.04,NULL,'G',0.000013,NULL,'21.5g',0.03,'Sd',NULL,NULL,NULL,NULL,1,251.7277083,31.8855,0.073,NULL,56210136548,878283383,13723177,21.5),(139179,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139179,34.24,NULL,70.4,66862,NULL,NULL,'Dipole + Quadrupole','FGC 2068',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139180,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139180,34.24,NULL,70.5,66862,NULL,NULL,'Dipole','FGC 2068',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139181,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139181,34.27,NULL,71.3,66862,NULL,NULL,NULL,'FGC 2068',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139182,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139182,34.7,0.2,87.1,66862,74.4,NULL,NULL,'FGC 2068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139183,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139183,37.37,0.46,298,66863,70,NULL,NULL,'2MASX J16465469+4005217',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'17.1g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,251.7279583,40.08944,0.041,NULL,59825732649,934777072,14605891,17.1),(139184,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139184,36.08,0.46,165,66864,70,NULL,NULL,'CGCG 138-073',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000087,NULL,'15.5g',0.45,'E0',NULL,NULL,NULL,NULL,1,251.7287083,22.52136,0.217,NULL,56678967658,885608869,13837638,15.5),(139185,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139185,37.68,0.46,344,66865,70,NULL,NULL,'2MASX J16465653+3716197',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.735583,37.27217,0.069,NULL,59813490177,934585784,14602902,17.3),(139186,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139186,34.62,0.69,83.8,66866,100,NULL,'mid-IR','UGC 10547',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'14.53',0.7,'SB(s)b',NULL,NULL,NULL,NULL,1,251.7364583,34.15556,0.057,NULL,59746544355,933539755,14586558,14.53),(139187,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139187,36.23,0.2,176,66866,74.4,NULL,NULL,'UGC 10547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139188,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139188,35.91,0.58,152,66867,70,NULL,NULL,'ESO 043- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.7R',0.5,'S...',NULL,NULL,NULL,NULL,1,251.7419583,-72.74539,0.297,NULL,44150064834,689844763,10778824,14.7),(139189,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139189,38.3,0.33,458,66868,70,NULL,NULL,'2MASX J16465844+3855423',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000074,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.743583,38.92853,0.061,NULL,59826627582,934791055,14606110,17.5),(139190,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139190,37.64,0.23,337,66869,70,NULL,NULL,'2MASX J16465871+2004231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,251.744667,20.07314,0.313,NULL,56686014124,885718970,13839358,17.2),(139191,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139191,34.27,0.8,71.4,66870,75,NULL,'CF, r','IC 1231',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'13.59',1,'Scd:           AGN?','Isolated galaxy',NULL,NULL,NULL,1,251.745916667,58.42317,0,NULL,57708216143,901690877,14088919,13.59),(139192,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139192,33.88,0.38,59.7,66870,75,NULL,'CF, r, raw','IC 1231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139193,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139193,34.02,0.38,63.8,66870,75,NULL,'CF, r, inv','IC 1231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139194,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139194,34.17,0.38,68.1,66870,75,NULL,'CF, r, cor','IC 1231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139195,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139195,34.22,0.47,70,66870,NULL,NULL,'H','IC 1231',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139196,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139196,34.27,0.4,71.3,66870,NULL,NULL,'mean','IC 1231',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139197,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139197,34.3,0.46,72.4,66870,NULL,NULL,'J','IC 1231',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139198,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139198,34.33,0.2,73.5,66870,74.4,NULL,NULL,'IC 1231',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139199,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139199,34.35,0.45,74.1,66870,NULL,NULL,'K','IC 1231',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139200,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139200,34.37,0.37,74.9,66870,NULL,NULL,'Malmquist cor.','IC 1231',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139201,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139201,34.39,0.37,75.3,66870,NULL,NULL,NULL,'IC 1231',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139202,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139202,35.53,0.46,127,66871,70,NULL,NULL,'2MASX J16470020+3407078',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.2g',0.41,NULL,NULL,NULL,NULL,NULL,1,251.750833,34.11897,0.057,NULL,59746543665,933539744,14586558,16.2),(139203,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139203,34.89,0.49,94.9,66872,75,NULL,'IR','UGC 10550',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00007,NULL,'16.0',0.2,'Sb(f)','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,251.760541667,40.14392,0.041,NULL,59825719300,934776864,14605888,16),(139204,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139204,35.04,0.2,102,66872,74.4,NULL,NULL,'UGC 10550',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139205,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139205,35.58,0.12,131,66872,NULL,NULL,NULL,'UGC 10550',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139206,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139206,37.28,0.46,286,66873,70,NULL,NULL,'2MASX J16470301+6345570',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.7625417,63.76592,0.053,NULL,57543457205,899116518,14048695,17.4),(139207,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139207,37.64,0.23,337,66874,70,NULL,NULL,'2MASX J16470325+2006241',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,251.763625,20.10661,0.313,NULL,56685957387,885718084,13839345,17.3),(139208,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139208,36.26,0.46,179,66875,70,NULL,NULL,'2MASX J16470342+3412058',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000172,NULL,'15.7g',0.43,'E0',NULL,NULL,NULL,NULL,1,251.764083333,34.20172,0.057,NULL,59746545251,933539769,14586558,15.7),(139209,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139209,34.04,0.49,64.2,66876,75,NULL,'IR','ESO 453- G 004',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000033,NULL,'15.9',0.21,'Sd',NULL,NULL,NULL,NULL,1,251.767208333,-29.09064,1.241,NULL,45832340852,716130325,11189536,15.9),(139210,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139210,34.99,NULL,99.4,66876,NULL,NULL,'Dipole','ESO 453- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139211,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139211,34.99,NULL,99.5,66876,NULL,NULL,'Dipole + Quadrupole','ESO 453- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139212,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139212,34.99,NULL,99.5,66876,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 453- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139213,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139213,38.33,0.27,464,66877,70,NULL,NULL,'SDSS J164704.75+342922.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000175,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.769875,34.48969,0.061,NULL,59747042275,933547535,14586680,18.3),(139214,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139214,37.64,0.23,337,66878,70,NULL,NULL,'2MASX J16470588+2003271',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000162,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,251.774583,20.05753,0.313,NULL,56686018048,885719032,13839359,16.8),(139215,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139215,38.07,0.33,411,66879,70,NULL,NULL,'2MASX J16470693+2813196',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.779,28.22211,0.173,NULL,56237113286,878704895,13729763,18),(139216,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139216,38.36,0.46,471,66880,70,NULL,NULL,'SDSS J164708.15+291103.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.784,29.18431,0.121,NULL,56226880755,878545011,13727265,18.5),(139217,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139217,37.11,0.46,264,66881,70,NULL,NULL,'2MASX J16470906+2036311',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.787833,20.60853,0.337,NULL,56685069928,885704217,13839128,17.7),(139218,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139218,36.87,0.46,236,66882,70,NULL,NULL,'2MASX J16471067+2652577',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000172,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,251.794417,26.88275,0.229,NULL,56230307115,878598548,13728102,16.6),(139219,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139219,37.83,0.46,369,66883,70,NULL,NULL,'2MASX J16471075+3407308',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.794917,34.12542,0.057,NULL,59746490029,933538906,14586545,17.6),(139220,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139220,38.07,0.33,411,66884,70,NULL,NULL,'2MASX J16471089+2805137',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,251.795375,28.08725,0.181,NULL,56237134987,878705234,13729769,17.2),(139221,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139221,38.33,0.27,464,66885,70,NULL,NULL,'2MASX J16471269+3433388',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,251.80275,34.56083,0.061,NULL,59747056164,933547752,14586683,16.4),(139222,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139222,37.03,0.33,255,66886,70,NULL,NULL,'2MASX J16471365+3356118',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.807,33.93669,0.049,NULL,59746370967,933537046,14586516,17.7),(139223,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2007is',NULL,139223,35.39,0.21,116,66887,73.8,NULL,'SALT 2 (SNANA)','UGC 10553',0.0301,'2014ApJ...795...44R',2014,1,1.21,NULL,'G',0.000107,NULL,'14.5g',0.52,'SBab:          NLAGN',NULL,NULL,NULL,NULL,1,251.811583,40.24508,0.041,NULL,59817603391,934650052,14603907,14.5),(139224,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2007is','R',139224,35.54,0.1,128,66887,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10553',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139225,'SNIa','2016-12-15 15:15:43','2016-12-16 11:20:58','1','SN 2007is','R',139225,35.57,0.13,130,66887,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10553',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139226,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139226,38.27,0.33,451,66888,70,NULL,NULL,'2MASX J16471567+2931007',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000193,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,251.81525,29.51686,0.121,NULL,56226993790,878546777,13727293,17.4),(139227,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139227,37.03,0.33,255,66889,70,NULL,NULL,'2MASX J16471566+3355568',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000117,NULL,'15.99',0.46,NULL,NULL,NULL,NULL,NULL,1,251.815375,33.93242,0.049,NULL,59746371062,933537047,14586516,15.99),(139228,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139228,38.27,0.33,451,66890,70,NULL,NULL,'SDSS J164716.17+293242.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.817417,29.54519,0.121,NULL,56226992613,878546759,13727293,18.3),(139229,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139229,38.33,0.27,464,66891,70,NULL,NULL,'SDSS J164716.66+343352.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000177,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.8194583,34.56458,0.061,NULL,59747056300,933547754,14586683,18.3),(139230,'Tully est','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139230,30.2,0.8,10.9,66892,75,NULL,NULL,'ESO 179-IG 013',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000013,NULL,'15.0',1.7,'SB(s)dm',NULL,NULL,NULL,NULL,1,251.8335417,-57.44017,NULL,NULL,44550962672,696108791,10876699,15),(139231,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139231,36.51,0.46,200,66893,70,NULL,NULL,'2MASX J16472078+2416358',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,251.8365,24.27675,0.173,NULL,56199009953,878109530,13720461,16.8),(139232,'IRAS','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139232,34.65,0.8,85.3,66894,75,NULL,'MAT, I','ESO 586- G 002',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'14.28',0.5,'S',NULL,NULL,NULL,NULL,1,251.851833,-20.14172,1.013,NULL,45927576086,717618376,11212787,14.28),(139233,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139233,33.52,0.2,50.6,66894,74.4,NULL,NULL,'ESO 586- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139234,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139234,33.78,0.89,57,66894,NULL,NULL,NULL,'ESO 586- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139235,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139235,33.87,0.32,59.5,66894,85,NULL,'I, raw','ESO 586- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139236,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139236,33.88,0.32,59.7,66894,85,NULL,'I, inv','ESO 586- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139237,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139237,34.01,0.43,63.5,66894,75,NULL,'MAT, I, raw','ESO 586- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139238,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139238,34.1,0.43,66,66894,75,NULL,'MAT, I, inv','ESO 586- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139239,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139239,34.13,0.75,67.1,66894,NULL,NULL,'Malmquist cor.','ESO 586- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139240,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139240,34.41,0.43,76.1,66894,75,NULL,'MAT, I, cor','ESO 586- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139241,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139241,37.34,0.46,294,66895,70,NULL,NULL,'2MASX J16472796+4322374',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,251.866541667,43.37717,0.025,NULL,59844506248,935070410,14610475,16.4),(139242,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139242,37.49,0.33,315,66896,70,NULL,NULL,'2MASX J16472821+3112073',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.8677083,31.20222,0.089,NULL,56210529502,878289523,13723273,17.7),(139243,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139243,37.63,0.46,335,66897,70,NULL,NULL,'2MASX J16473013+3117303',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.875583,31.29172,0.089,NULL,56210533743,878289589,13723274,17.2),(139244,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139244,35.83,0.46,147,66898,70,NULL,NULL,'2MASX J16473361+2507078',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000103,NULL,'16.1g',0.37,'HII',NULL,NULL,NULL,NULL,1,251.890167,25.11883,0.137,NULL,56198790020,878106094,13720407,16.1),(139245,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139245,37.11,0.33,265,66899,70,NULL,NULL,'2MASX J16473443+3256523',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000185,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,251.8935417,32.94792,0.065,NULL,59745806754,933528230,14586378,17.1),(139246,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139246,34.49,0.48,78.9,66900,70,NULL,NULL,'CGCG 025-005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00008,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,251.9017917,-1.41942,0.417,NULL,45175829666,705872338,11029255,15.6),(139247,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139247,35.3,0.49,115,66901,75,NULL,'IR','CGCG 053-008',NULL,'2011yCatp016004901K',2011,1,0.99,NULL,'G',0.000008,NULL,'15.7',0.18,NULL,NULL,NULL,NULL,NULL,1,251.9019583,8.75294,0.341,NULL,56771065264,887047894,13860123,15.7),(139248,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139248,38.03,0.33,403,66902,70,NULL,NULL,'2MASX J16473904+2943284',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.912667,29.7245,0.121,NULL,56226844542,878544445,13727256,17.5),(139249,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139249,37.64,0.46,338,66903,70,NULL,NULL,'2MASX J16473916+2552324',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000138,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.913167,25.87572,0.177,NULL,56197792378,878090505,13720164,17.9),(139250,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139250,37.66,0.46,341,66904,70,NULL,NULL,'2MASX J16473918+3923195',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000074,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,251.913208333,39.38864,0.045,NULL,59825836523,934778695,14605917,17.7),(139251,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139251,38.62,0.46,530,66905,70,NULL,NULL,'SDSS J164740.11+353544.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.0g',0.14,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,251.917167,35.59572,0.057,NULL,59745407845,933521997,14586281,18),(139252,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139252,33.17,0.47,43,66906,NULL,NULL,'H','ESO 137- G 042',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000013,NULL,'13.65',0.8,'SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,251.919625,-60.149,NULL,NULL,44498919558,695295618,10863994,13.65),(139253,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139253,33.21,0.46,43.9,66906,NULL,NULL,'J','ESO 137- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139254,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139254,33.22,0.45,44.1,66906,NULL,NULL,'K','ESO 137- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139255,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139255,33.3,0.4,45.7,66906,NULL,NULL,'mean','ESO 137- G 042',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139256,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139256,38.33,0.33,462,66907,70,NULL,NULL,'2MASX J16474406+2956314',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000087,NULL,'16.0g',0.49,'BrClG;cD',NULL,NULL,NULL,NULL,1,251.9335417,29.94192,0.113,NULL,56209089448,878267022,13722922,16),(139257,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139257,38.03,0.33,403,66908,70,NULL,NULL,'SDSS J164746.76+294459.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000155,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.944875,29.74989,0.121,NULL,56209064544,878266633,13722916,18.6),(139258,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139258,36.73,0.46,222,66909,70,NULL,NULL,'2MASX J16474754+4505423',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000116,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,251.947917,45.09519,0,NULL,59836405181,934943830,14608497,15.4),(139259,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139259,37.76,0.33,357,66910,70,NULL,NULL,'2MASX J16474846+3903166',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,251.952083,39.05461,0.053,NULL,59826112019,934783000,14605984,17.3),(139260,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139260,37.11,0.33,265,66911,70,NULL,NULL,'2MASX J16475278+3254164',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.9699583,32.90467,0.065,NULL,59745815357,933528364,14586380,17.5),(139261,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139261,37.49,0.33,315,66912,70,NULL,NULL,'2MASX J16475331+3117054',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000143,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,251.9722917,31.28506,0.089,NULL,56210554692,878289917,13723279,17.7),(139262,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139262,37.99,0.46,396,66913,70,NULL,NULL,'2MASX J16475343+2245330',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,251.972833333,22.759,0.213,NULL,56680800262,885637504,13838086,18),(139263,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139263,37.35,0.46,295,66914,70,NULL,NULL,'2MASX J16475357+2908485',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,251.973333,29.14692,0.125,NULL,56235259697,878675932,13729311,17.3),(139264,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139264,38.09,0.46,415,66915,70,NULL,NULL,'2MASX J16475363+3208484',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000207,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,251.973625,32.14675,0.081,NULL,56218467194,878413549,13725211,16.4),(139265,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139265,36.98,0.46,249,66916,70,NULL,NULL,'2MASX J16475488+4433454',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000104,NULL,'17.0g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,251.9787917,44.5625,0,NULL,59836901228,934951581,14608618,17),(139266,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139266,38.33,0.33,462,66917,70,NULL,NULL,'SDSS J164755.07+295200.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,251.9795417,29.86683,0.113,NULL,56209139697,878267807,13722934,18.4),(139267,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139267,37.63,0.46,335,66918,70,NULL,NULL,'SDSS J164756.35+332916.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,251.984833,33.48778,0.057,NULL,59746634334,933541161,14586580,18.1),(139268,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139268,35.55,0.33,129,66919,70,NULL,NULL,'2MASX J16475755+3958186',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.3g',0.26,'NLAGN',NULL,NULL,NULL,NULL,1,251.98975,39.97186,0.041,NULL,59825763235,934777550,14605899,16.3),(139269,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139269,35.85,0.46,148,66920,70,NULL,NULL,'2MASX J16475838+2908295',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000185,NULL,'15.6g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,251.993167,29.14153,0.125,NULL,56235258981,878675921,13729311,15.6),(139270,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139270,36.61,0.33,209,66921,70,NULL,NULL,'2MASX J16475913+3155104',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000169,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,251.996333,31.91967,0.081,NULL,56218421746,878412839,13725200,16.6),(139271,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139271,37.9,0.23,380,66922,70,NULL,NULL,'2MASX J16480145+2739325',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.0062083,27.65914,0.173,NULL,56236310838,878692356,13729568,17.7),(139272,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139272,37.76,0.33,357,66923,70,NULL,NULL,'2MASX J16480151+3908226',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000086,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.0062917,39.13958,0.053,NULL,59826245282,934785082,14606016,17.5),(139273,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139273,37.87,0.46,374,66924,70,NULL,NULL,'2MASX J16480172+2340331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000162,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.0072917,23.67594,0.181,NULL,56680096389,885626506,13837914,17.5),(139274,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139274,37.9,0.23,380,66925,70,NULL,NULL,'2MASX J16480235+2737495',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.0097083,27.63047,0.173,NULL,56234410445,878662663,13729104,17.6),(139275,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139275,36.1,0.2,166,66926,74.4,NULL,NULL,'NGC 6228',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000006,NULL,'14.90',0.6,'S?',NULL,NULL,NULL,NULL,1,252.011083333,26.21356,0.209,NULL,56230777794,878605903,13728217,14.9),(139276,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139276,32.49,0.47,31.5,66927,NULL,NULL,'H','NGC 6244',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',NULL,NULL,'14.43',0.3,'SBa:',NULL,NULL,NULL,NULL,1,252.016291667,62.20044,0.029,NULL,57544149685,899127338,14048864,14.43),(139277,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139277,32.68,0.45,34.3,66927,NULL,NULL,'K','NGC 6244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139278,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139278,32.74,0.46,35.3,66927,NULL,NULL,'J','NGC 6244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139279,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139279,33.47,0.4,49.5,66927,NULL,NULL,'mean','NGC 6244',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139280,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139280,35.91,0.46,152,66928,70,NULL,NULL,'CGCG 169-003',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000063,NULL,'15.7g',0.34,'S0/a',NULL,NULL,NULL,NULL,1,252.02125,30.08517,0.113,NULL,56209126618,878267603,13722931,15.7),(139281,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139281,37.8,0.33,363,66929,70,NULL,NULL,'2MASX J16481117+4038588',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.046416667,40.64964,0,NULL,59818215587,934659618,14604056,17.1),(139282,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139282,36.14,0.27,169,66930,70,NULL,NULL,'2MASX J16481206+2409077',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00013,NULL,'15.9g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,252.0502083,24.15214,0.173,NULL,56196917046,878076828,13719950,15.9),(139283,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139283,37.72,0.46,350,66931,70,NULL,NULL,'2MASX J16481207+4425123',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000072,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.050375,44.42028,0,NULL,59836891526,934951430,14608616,16.9),(139284,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139284,37.9,0.23,380,66932,70,NULL,NULL,'2MASX J16481360+2737457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.0565417,27.62933,0.173,NULL,56234411862,878662685,13729104,17.2),(139285,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139285,36.14,0.27,169,66933,70,NULL,NULL,'2MASX J16481637+2408427',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00009,NULL,'15.5g',0.48,'E0',NULL,NULL,NULL,NULL,1,252.068333333,24.14514,0.173,NULL,56196884867,878076326,13719942,15.5),(139286,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139286,35.55,0.33,129,66934,70,NULL,NULL,'CGCG 197-013',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000123,NULL,'14.8g',0.7,'E0','Group member',NULL,NULL,NULL,1,252.073083333,35.90014,0.061,NULL,59745490526,933523289,14586301,14.8),(139287,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139287,37.82,0.23,367,66935,70,NULL,NULL,'2MASX J16481882+2721527',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000184,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.078583,27.36472,0.209,NULL,56234900722,878670323,13729223,17.8),(139288,'FP','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,NULL,139288,37.23,0.93,280,66936,70,NULL,NULL,'2MASX J16481938-6209305',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.0807917,-62.15847,0.809,NULL,44469453119,694835204,10856800,14.4),(139289,'Tully-Fisher','2016-12-15 15:15:43','2016-12-16 11:20:58','1',NULL,'R',139289,32.53,NULL,32,66937,72,NULL,NULL,'UGC 10554',NULL,'2014Ap.....57..457K',2014,1,1.5,NULL,'G',0.000027,NULL,'14.90',0.5,'Scd: sp',NULL,NULL,NULL,NULL,1,252.088917,-1.61919,0.409,NULL,45175498768,705867168,11029174,14.9),(139290,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139290,35.76,0.2,142,66938,74.4,NULL,NULL,'CGCG 139-004',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000009,NULL,'15.4g',0.42,'SABbc(r)',NULL,NULL,NULL,NULL,1,252.0907083,23.61469,0.181,NULL,56680083538,885626305,13837911,15.4),(139291,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139291,38.04,0.46,406,66939,70,NULL,NULL,'SDSS J164822.29+325255.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.092875,32.88197,0.081,NULL,59745795933,933528061,14586375,18.5),(139292,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139292,34.65,0.49,84.9,66940,70,NULL,NULL,'2MASX J16482393-0616193',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'12.9I',0.6,NULL,NULL,NULL,NULL,NULL,1,252.0997917,-6.27214,0.801,NULL,46092212478,720190819,11252981,12.9),(139293,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139293,37.9,0.23,380,66941,70,NULL,NULL,'2MASX J16482406+2737018',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00017,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,252.1002917,27.61722,0.173,NULL,56234416205,878662753,13729105,17.2),(139294,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139294,37.82,0.23,367,66942,70,NULL,NULL,'2MASX J16482498+2721128',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000194,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,252.104,27.35356,0.209,NULL,56234899586,878670306,13729223,16.9),(139295,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139295,34.72,0.46,87.9,66943,70,NULL,NULL,'CGCG 224-103',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000083,NULL,'15.1g',0.47,'E0',NULL,NULL,NULL,NULL,1,252.110458333,41.95311,0,NULL,59818772001,934668312,14604192,15.1),(139296,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139296,36.14,0.27,169,66944,70,NULL,NULL,'2MASX J16482725+2421128',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.11375,24.3535,0.181,NULL,56196893745,878076464,13719944,16.6),(139297,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139297,37.2,0.46,275,66945,70,NULL,NULL,'2MASX J16482905+3608450',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.120917,36.14594,0.057,NULL,59745338647,933520916,14586264,16.9),(139298,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139298,37.8,0.33,363,66946,70,NULL,NULL,'SDSS J164829.32+404226.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000111,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,252.1222083,40.70742,0,NULL,59818226356,934659786,14604059,18.5),(139299,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139299,37.29,0.46,287,66947,70,NULL,NULL,'2MASX J16483009+2712398',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000193,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.1255,27.21111,0.197,NULL,56234983285,878671613,13729243,16.9),(139300,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139300,36.25,0.51,178,66948,70,NULL,NULL,'2MASX J16483268-7222323',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.136333333,-72.37569,0.477,NULL,44150114944,689845546,10778836,14.7),(139301,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139301,36.61,0.33,209,66949,70,NULL,NULL,'2MASX J16483278+3152553',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000188,NULL,'16.2g',0.25,'S0/a',NULL,NULL,NULL,NULL,1,252.136583333,31.88217,0.089,NULL,56219286401,878426350,13725411,16.2),(139302,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139302,37.49,0.46,314,66950,70,NULL,NULL,'2MASX J16483384+2842028',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.141083,28.70067,0.157,NULL,56236150155,878689846,13729528,17.3),(139303,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139303,38.52,0.46,507,66951,70,NULL,NULL,'2MASX J16483417+4056590',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.142417,40.94972,0,NULL,59818208737,934659511,14604054,17.8),(139304,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139304,38.39,0.46,476,66952,70,NULL,NULL,'SDSS J164834.55+250307.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00013,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,252.144,25.05206,0.173,NULL,56199472133,878116752,13720574,18.7),(139305,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139305,35.08,0.6,104,66953,70,NULL,NULL,'2MASX J16483531-0105143',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.02',0.4,NULL,NULL,NULL,NULL,NULL,1,252.147125,-1.08747,0.389,NULL,45176759855,705886872,11029482,16.02),(139306,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139306,36.93,0.46,243,66954,70,NULL,NULL,'2MASX J16483551+3154080',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.147833333,31.90231,0.081,NULL,56219286816,878426356,13725411,17.1),(139307,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139307,37.75,0.33,356,66955,70,NULL,NULL,'2MASX J16483728+2918278',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000182,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,252.155291667,29.30767,0.125,NULL,56235373413,878677709,13729339,16.5),(139308,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139308,36.82,0.27,231,66956,70,NULL,NULL,'2MASX J16483765+2652318',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.156917,26.87544,0.185,NULL,56229956701,878593073,13728016,17.7),(139309,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139309,33.75,0.4,56.3,66957,NULL,NULL,NULL,'ESO 069- G 010',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'13.29',0.3,'SA(s)b:',NULL,NULL,NULL,NULL,1,252.1702917,-69.49372,0.305,NULL,45018678750,703416855,10990888,13.29),(139310,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139310,33.79,0.2,57.3,66957,74.4,NULL,NULL,'ESO 069- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139311,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139311,33.94,0.37,61.4,66957,NULL,NULL,'Malmquist cor.','ESO 069- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139312,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139312,36.66,0.46,215,66958,70,NULL,NULL,'2MASX J16484093+6328447',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.17075,63.47919,0.045,NULL,57545578183,899149659,14049213,17.1),(139313,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139313,38.23,0.46,442,66959,70,NULL,NULL,'2MASX J16484267+4125400',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000099,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,252.177833,41.42775,0.009,NULL,59819129784,934673902,14604279,17.3),(139314,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139314,36.82,0.27,231,66960,70,NULL,NULL,'2MASX J16484350+2657129',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,252.18125,26.95347,0.185,NULL,56234216198,878659628,13729056,16.6),(139315,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139315,38.43,0.46,484,66961,70,NULL,NULL,'SDSS J164844.45+310803.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,252.18525,31.13425,0.089,NULL,56216784246,878387253,13724800,18.6),(139316,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139316,35.81,0.25,145,66962,74.4,NULL,NULL,'CGCG 367-018',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00008,NULL,'14.16',NULL,'E','Group member',NULL,NULL,NULL,1,252.1869583,81.61083,0.269,NULL,56956384812,889943512,13905367,14.16),(139317,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139317,36.01,0.28,159,66962,70,NULL,NULL,'CGCG 367-018',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139318,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139318,36.06,0.72,163,66963,70,NULL,NULL,'2MASX J16484519-6803384',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.188291667,-68.06067,0.425,NULL,45024564927,703508826,10992325,14.9),(139319,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139319,36.82,0.27,231,66964,70,NULL,NULL,'2MASX J16484663+2700380',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000185,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.194333,27.01053,0.185,NULL,56234940600,878670946,13729233,17),(139320,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139320,37.3,0.33,288,66965,70,NULL,NULL,'2MASX J16485270+4440133',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.219708333,44.67039,0,NULL,59836912783,934951762,14608621,16.8),(139321,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139321,37.4,0.46,302,66966,70,NULL,NULL,'2MASX J16485437+1949521',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,252.2265417,19.83119,0.313,NULL,56685739879,885714685,13839291,17.8),(139322,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139322,37.82,0.23,367,66967,70,NULL,NULL,'2MASX J16485597+2717540',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000152,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.233125,27.29825,0.209,NULL,56235105815,878673528,13729273,17.8),(139323,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139323,37.82,0.23,367,66968,70,NULL,NULL,'2MASX J16485703+2711420',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.2377917,27.19508,0.197,NULL,56234987398,878671678,13729244,17.6),(139324,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139324,37.72,0.46,351,66969,70,NULL,NULL,'2MASX J16490059+3430090',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.252417,34.50264,0.061,NULL,59747738501,933558414,14586850,17.2),(139325,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139325,35.28,0.59,114,66970,70,NULL,NULL,'2MASX J16490082-1612433',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.2535,-16.21208,1.325,NULL,46156944108,721202251,11268785,15.7),(139326,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139326,36.18,0.52,173,66971,70,NULL,NULL,'2MASX J16490214-1945242',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000113,NULL,'14.8R',NULL,'E',NULL,NULL,NULL,NULL,1,252.2589583,-19.75675,0.977,NULL,45926886446,717607600,11212618,14.8),(139327,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139327,37.01,0.21,252,66972,70,NULL,NULL,'2MASX J16490501+2617300',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.271,26.29158,0.209,NULL,56230032886,878594263,13728035,17.3),(139328,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139328,37.01,0.21,252,66973,70,NULL,NULL,'2MASX J16491077+2636270',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00018,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.2949583,26.60742,0.253,NULL,56230100151,878595314,13728051,17.1),(139329,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139329,38.22,0.46,441,66974,70,NULL,NULL,'SDSS J164912.46+291838.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,252.3019583,29.31075,0.125,NULL,56235349236,878677331,13729333,18.6),(139330,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139330,36.84,0.6,234,66975,70,NULL,NULL,'2MASX J16491562-6423124',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.315,-64.38681,0.705,NULL,44466576647,694790260,10856097,15.1),(139331,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139331,38.24,0.46,445,66976,70,NULL,NULL,'2MASX J16491632+2336101',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000142,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,252.3180417,23.60283,0.185,NULL,56680741161,885636580,13838071,18.3),(139332,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139332,36.98,0.46,248,66977,70,NULL,NULL,'2MASX J16491760+3001516',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000179,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,252.323333,30.03114,0.125,NULL,56208936814,878264637,13722884,16.3),(139333,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139333,37.51,0.46,318,66978,70,NULL,NULL,'2MASX J16491963+3035566',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000203,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.3317083,30.59906,0.109,NULL,56216857457,878388397,13724818,17),(139334,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139334,37.01,0.21,252,66979,70,NULL,NULL,'2MASX J16492220+2647104',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000115,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.342583333,26.78628,0.185,NULL,56230004301,878593817,13728028,16.9),(139335,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139335,36.67,0.55,216,66980,70,NULL,NULL,'2MASX J16492348-6426515',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.347667,-64.44767,0.705,NULL,44467030620,694797353,10856208,15.7),(139336,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139336,37.6,0.33,331,66981,70,NULL,NULL,'2MASX J16492490+3308166',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,252.354,33.13786,0.073,NULL,59745885249,933529457,14586397,16.9),(139337,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139337,37.01,0.21,252,66982,70,NULL,NULL,'SDSS J164925.13+263652.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,252.3547083,26.61444,0.253,NULL,56230089802,878595153,13728049,18.4),(139338,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139338,35.55,0.33,129,66983,70,NULL,NULL,'CGCG 197-016',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000093,NULL,'15.1g',0.55,'E0',NULL,NULL,NULL,NULL,1,252.357917,36.05586,0.057,NULL,59745271630,933519869,14586247,15.1),(139339,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139339,37.3,0.33,288,66984,70,NULL,NULL,'2MASX J16492698+4441525',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000091,NULL,'16.5g',0.31,'NLAGN',NULL,NULL,NULL,NULL,1,252.362333333,44.69792,0,NULL,59836861029,934950953,14608608,16.5),(139340,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139340,35.53,0.72,128,66985,70,NULL,NULL,'2MASX J16492750-1657122',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.364583,-16.95342,1.181,NULL,46158261862,721222841,11269106,16.3),(139341,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139341,37.01,0.21,252,66986,70,NULL,NULL,'2MASX J16492901+2636205',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00018,NULL,'16.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.370958333,26.60583,0.253,NULL,56230090568,878595165,13728049,16.6),(139342,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139342,37.98,0.46,394,66987,70,NULL,NULL,'2MASXi J1649312+382025',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000077,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,252.3802083,38.34044,0.049,NULL,59826038090,934781845,14605966,18),(139343,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139343,37.6,0.33,331,66988,70,NULL,NULL,'2MASX J16493231+3315116',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.384833,33.25333,0.073,NULL,59745834610,933528665,14586385,17.4),(139344,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139344,38.34,0.46,465,66989,70,NULL,NULL,'2MASX J16493422+3803299',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.0001,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,252.3925417,38.05836,0.053,NULL,59812092038,934563938,14602561,17.6),(139345,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139345,37.36,0.46,296,66990,70,NULL,NULL,'2MASX J16493443+2723005',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,252.3935417,27.38336,0.209,NULL,56235073034,878673016,13729265,17.1),(139346,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139346,37.61,0.46,333,66991,70,NULL,NULL,'2MASX J16493537+2825175',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000185,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.3975417,28.42153,0.189,NULL,56235697957,878682780,13729418,17.2),(139347,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139347,37.75,0.33,356,66992,70,NULL,NULL,'SDSS J164935.88+292015.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,252.3995,29.33758,0.125,NULL,56235346949,878677296,13729332,18.3),(139348,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139348,37.73,0.46,352,66993,70,NULL,NULL,'2MASX J16493765+2939385',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.407041667,29.66064,0.137,NULL,56235133625,878673962,13729280,17.6),(139349,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139349,37.17,0.33,272,66994,70,NULL,NULL,'2MASX J16493789+2424085',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000175,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.4079583,24.40233,0.181,NULL,56197062027,878079094,13719985,17.4),(139350,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139350,38.21,0.46,438,66995,70,NULL,NULL,'2MASX J16493974+3210426',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.415541667,32.17853,0.081,NULL,56219340545,878427196,13725424,17.4),(139351,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139351,38.15,0.27,426,66996,70,NULL,NULL,'2MASX J16493999+2729485',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.4165417,27.49678,0.201,NULL,56235091124,878673298,13729270,17.6),(139352,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139352,36.7,0.46,219,66997,70,NULL,NULL,'2MASX J16494120+2450105',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,252.4217083,24.83636,0.173,NULL,56199299069,878114047,13720531,16.6),(139353,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139353,37.17,0.33,272,66998,70,NULL,NULL,'2MASX J16494163+2421525',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000165,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.423583,24.3645,0.181,NULL,56197070206,878079221,13719987,17),(139354,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139354,38.15,0.27,426,66999,70,NULL,NULL,'2MASX J16494298+2722105',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,252.4292083,27.36956,0.209,NULL,56235071846,878672997,13729265,18.5),(139355,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139355,36.9,0.33,240,67000,70,NULL,NULL,'2MASX J16494326+3852219',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000117,NULL,'15.7g',0.38,'E0',NULL,NULL,NULL,NULL,1,252.430375,38.87269,0.045,NULL,59826177138,934784017,14606000,15.7),(139356,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139356,37.93,0.46,386,67001,70,NULL,NULL,'2MASX J16494401+4004299',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000082,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.433333,40.07508,0.029,NULL,59817700171,934651565,14603930,17.8),(139357,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139357,37.45,0.33,310,67002,70,NULL,NULL,'SDSS J164950.79+351211.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,252.461708333,35.20325,0.053,NULL,59747420715,933553448,14586772,18.6),(139358,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139358,37.59,0.46,330,67003,70,NULL,NULL,'SDSS J164951.04+213740.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,252.4627083,21.62778,0.257,NULL,56689896010,885779625,13840306,18.5),(139359,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139359,34.62,0.18,81.5,67004,74.2,NULL,'SALT 2','CGCG 224-104',0.02956,'2010ApJ...716..712A',2010,1,0.55,NULL,'G',0.000053,NULL,'15.9g',0.31,'S0',NULL,NULL,NULL,NULL,1,252.463208333,40.43342,0.021,NULL,59817764435,934652569,14603946,15.9),(139360,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139360,35.29,0.09,114,67004,74.4,NULL,NULL,'CGCG 224-104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139361,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139361,35.41,0.04,117,67004,72,NULL,NULL,'CGCG 224-104',0.02956,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139362,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139362,35.41,0.17,117,67004,70,NULL,'SALT 2','CGCG 224-104',0.02956,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139363,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139363,35.47,0.12,124,67004,70.8,NULL,NULL,'CGCG 224-104',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139364,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139364,35.58,0.08,127,67004,70,NULL,'SALT','CGCG 224-104',0.02956,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139365,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139365,35.76,0.14,134,67004,65,NULL,'MLCS2k2','CGCG 224-104',0.02956,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139366,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139366,35.7,0.19,134,67004,65,NULL,NULL,'CGCG 224-104',0.02956,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139367,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139367,35.72,0.2,139,67004,60,NULL,'M(V) = -19.47 mag','CGCG 224-104',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139368,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139368,35.73,0.19,140,67004,60,NULL,'M(B) = -19.48 mag','CGCG 224-104',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139369,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139369,35.73,0.14,140,67004,60,NULL,'M(I) = -19.19 mag','CGCG 224-104',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139370,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139370,35.86,0.13,149,67004,65,NULL,'Snapshot','CGCG 224-104',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139371,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139371,35.9,0.14,151,67004,60,NULL,NULL,'CGCG 224-104',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139372,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1994Q',NULL,139372,36.12,0.14,162,67004,65,NULL,'MLCS','CGCG 224-104',0.02956,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139373,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139373,34.21,0.8,69.4,67005,75,NULL,'MAT, I','ESO 069- G 011',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'12.78',0.5,'SAB(rs)c',NULL,NULL,NULL,NULL,1,252.4755,-71.20222,0.541,NULL,44972240055,702691250,10979550,12.78),(139374,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139374,33.86,0.32,59.1,67005,85,NULL,'I, raw','ESO 069- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139375,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139375,33.9,0.32,60.3,67005,85,NULL,'I, inv','ESO 069- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139376,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139376,33.92,0.43,60.7,67005,75,NULL,'MAT, I, raw','ESO 069- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139377,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139377,34.12,0.43,66.7,67005,75,NULL,'MAT, I, inv','ESO 069- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139378,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139378,34.14,0.43,67.3,67005,75,NULL,'MAT, I, cor','ESO 069- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139379,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139379,34.16,0.37,67.9,67005,NULL,NULL,'Malmquist cor.','ESO 069- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139380,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139380,34.24,0.36,70.4,67005,NULL,NULL,NULL,'ESO 069- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139381,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139381,34.28,0.2,71.8,67005,74.4,NULL,NULL,'ESO 069- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139382,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139382,34.37,0.4,74.8,67005,NULL,NULL,'mean','ESO 069- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139383,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139383,34.54,0.47,80.9,67005,NULL,NULL,'H','ESO 069- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139384,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139384,34.67,0.46,85.9,67005,NULL,NULL,'J','ESO 069- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139385,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139385,37.45,0.33,310,67006,70,NULL,NULL,'2MASX J16495634+3512430',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000187,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,252.485,35.21211,0.053,NULL,59747419503,933553429,14586772,16.4),(139386,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139386,37.5,0.46,316,67007,70,NULL,NULL,'2MASX J16495731+2830259',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.4887083,28.50719,0.177,NULL,56235676458,878682444,13729413,17.5),(139387,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139387,37.72,0.46,351,67008,70,NULL,NULL,'2MASX J16495932+3015210',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000156,NULL,'17.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.497333,30.25589,0.125,NULL,56216408360,878381380,13724709,17.5),(139388,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139388,35.51,NULL,126,67009,NULL,NULL,'Dipole','UGC 10569',NULL,'2010Ap&SS.325..163P',2010,1,1.93,NULL,'G',0.00001,NULL,'15.27',0.24,'Sc',NULL,NULL,NULL,NULL,1,252.5,9.43583,0.389,NULL,56729184368,886393505,13849898,15.27),(139389,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139389,35.51,NULL,126,67009,NULL,NULL,'Dipole + Quadrupole','UGC 10569',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139390,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139390,35.51,NULL,127,67009,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10569',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139391,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139391,35.61,NULL,133,67009,NULL,NULL,NULL,'UGC 10569',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139392,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139392,35.98,0.15,157,67010,70,NULL,NULL,'2MASX J16500190+2341424',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000178,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,252.508,23.69514,0.185,NULL,56680685993,885635718,13838058,15.8),(139393,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139393,37.4,0.46,302,67011,70,NULL,NULL,'2MASX J16500253+2625419',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,252.510583,26.42819,0.229,NULL,56197487480,878085741,13720089,17.5),(139394,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139394,38.15,0.27,426,67012,70,NULL,NULL,'SDSS J165003.03+274021.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000126,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.512667,27.67272,0.201,NULL,56234522590,878664415,13729131,18.4),(139395,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139395,31.39,0.8,18.9,67013,75,NULL,'B','NGC 6239',NULL,'1988NBGC.C....0000T',1988,1,1.99,NULL,'G',0.000009,NULL,'12.9g',0.98,'SB(s)b pec?    HII',NULL,NULL,NULL,NULL,1,252.52075,42.73969,0.013,NULL,59815954727,934624292,14603504,12.9),(139396,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139396,31.76,0.46,22.4,67013,NULL,NULL,NULL,'NGC 6239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139397,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139397,31.84,0.2,23.3,67013,74.4,NULL,NULL,'NGC 6239',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139398,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139398,31.91,0.43,24.1,67013,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6239',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139399,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139399,31.94,0.43,24.4,67013,75,NULL,'3.6 micron, color corrected','NGC 6239',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139400,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139400,32.04,0.41,25.6,67013,NULL,NULL,'Malmquist cor.','NGC 6239',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139401,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139401,36.89,0.46,239,67014,70,NULL,NULL,'2MASX J16500647+3526400',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000175,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,252.526875,35.44456,0.057,NULL,59747571443,933555803,14586809,16.3),(139402,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139402,37.25,0.46,282,67015,70,NULL,NULL,'2MASX J16500810+2713109',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000204,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,252.5337083,27.21961,0.209,NULL,56234281620,878660650,13729072,16.8),(139403,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139403,35.98,0.15,157,67016,70,NULL,NULL,'2MASX J16501092+2312444',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000193,NULL,'16.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,252.5454583,23.21242,0.261,NULL,56680329440,885630147,13837971,16.4),(139404,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139404,37.74,0.46,353,67017,70,NULL,NULL,'2MASX J16501152+2917359',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000191,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,252.5482083,29.29339,0.125,NULL,56221612454,878462694,13725979,16.6),(139405,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139405,37.66,0.46,340,67018,70,NULL,NULL,'2MASX J16501178+3639051',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.549167,36.65131,0.061,NULL,59813248293,934582004,14602843,17.6),(139406,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139406,37.78,0.46,359,67019,70,NULL,NULL,'2MASX J16501401+4244454',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.558125,42.74581,0.013,NULL,59815841610,934622525,14603476,17.3),(139407,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139407,35.98,0.15,157,67020,70,NULL,NULL,'NGC 6233',NULL,'2015arXiv151105856S',2015,1,1.32,NULL,'G',0.000177,NULL,'14.2g',0.8,'S0',NULL,NULL,NULL,NULL,1,252.565417,23.57983,0.185,NULL,56680719553,885636243,13838066,14.2),(139408,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139408,37.99,0.46,397,67021,70,NULL,NULL,'2MASX J16501834+2651029',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.576417,26.85094,0.185,NULL,56229907595,878592306,13728004,17.4),(139409,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139409,38.54,0.46,512,67022,70,NULL,NULL,'2MASX J16501973+3039120',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.582083,30.65325,0.125,NULL,56217154059,878393032,13724891,17.5),(139410,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139410,35.98,0.15,157,67023,70,NULL,NULL,'2MASX J16501980+2334254',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.582416667,23.57386,0.185,NULL,56680601816,885634403,13838037,16.6),(139411,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139411,37.9,0.46,380,67024,70,NULL,NULL,'2MASX J16502404+3320570',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,252.600333,33.34908,0.077,NULL,59746159493,933533742,14586464,17.9),(139412,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139412,36.4,0.56,191,67025,70,NULL,NULL,'2MASX J16502677-6347264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.611583333,-63.79064,0.729,NULL,44475617206,694931518,10858304,15.5),(139413,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139413,37.28,0.46,285,67026,70,NULL,NULL,'2MASX J16502881+2653578',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000186,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.619958333,26.89939,0.185,NULL,56234116977,878658077,13729032,17.3),(139414,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139414,35.11,NULL,105,67027,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2074',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.000049,NULL,'16.5g',0.16,'Sd(f)          NLAGN',NULL,NULL,NULL,NULL,1,252.6214583,40.78736,0,NULL,59817868459,934654194,14603971,16.5),(139415,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139415,35.13,NULL,106,67027,NULL,NULL,'Dipole + Quadrupole','FGC 2074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139416,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139416,35.14,NULL,107,67027,NULL,NULL,'Dipole','FGC 2074',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139417,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139417,35.17,NULL,108,67027,NULL,NULL,NULL,'FGC 2074',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139418,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139418,37.11,0.33,265,67028,70,NULL,NULL,'2MASX J16502958+2718068',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.623125,27.30194,0.209,NULL,56234177234,878659019,13729047,17.6),(139419,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139419,33.83,0.5,58.4,67029,70,NULL,NULL,'2MASX J16503068-6149194',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.627833,-61.82211,0.761,NULL,44470103001,694845359,10856958,12.2),(139420,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139420,36.88,0.61,237,67030,70,NULL,NULL,'2MASX J16503194-6838226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.6330417,-68.63972,0.437,NULL,45023983073,703499735,10992183,15.7),(139421,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139421,37.16,0.46,270,67031,70,NULL,NULL,'2MASX J16503231+3207350',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,252.634625,32.12647,0.089,NULL,56219374786,878427731,13725433,18),(139422,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139422,36.97,0.04,248,67032,72,NULL,'M(H) = -18.317 mag','PTF10nlg',NULL,'2014ApJ...784..105W',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,252.64375,60.27639,0,NULL,57658164868,900908826,14076700,NULL),(139423,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139423,36.99,0.02,250,67032,NULL,NULL,'H','PTF10nlg',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139424,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139424,37.11,0.03,264,67032,NULL,NULL,'J','PTF10nlg',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139425,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139425,37.3,0.03,274,67032,70,NULL,'SiFTO+SALT2, SN PTF10nlg','PTF10nlg',0.056,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139426,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10nlg',NULL,139426,37.45,0.03,293,67032,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10nlg',0.056,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139427,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139427,38.73,0.46,557,67033,70,NULL,NULL,'2MASX J16503932+3341420',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000191,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.663833,33.69489,0.069,NULL,59746199079,933534360,14586474,17.8),(139428,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139428,35.98,0.15,157,67034,70,NULL,NULL,'2MASX J16503940+2327451',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000165,NULL,'15.5g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,252.6642083,23.46258,0.185,NULL,56680637178,885634955,13838046,15.5),(139429,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139429,36.11,0.37,167,67035,NULL,NULL,'Malmquist cor.','2MASX J16503970+7839062',NULL,'2009ApJS..182..474S',2009,1,0.92,NULL,'G',0.000027,NULL,'13.69',NULL,'Sa',NULL,NULL,NULL,NULL,1,252.665167,78.65172,0.145,NULL,57140208382,892815755,13950246,13.69),(139430,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139430,36.32,0.34,184,67035,NULL,NULL,NULL,'2MASX J16503970+7839062',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139431,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139431,36.36,0.2,187,67035,74.4,NULL,NULL,'2MASX J16503970+7839062',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139432,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139432,37.96,0.46,392,67036,70,NULL,NULL,'2MASX J16504119+2811179',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000146,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.671541667,28.18825,0.189,NULL,56234358422,878661850,13729091,17.9),(139433,'G Lens','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139433,41.59,NULL,2080,67037,NULL,NULL,'Standard','SDSS J1650+4251',NULL,'2014ApJ...788..190W',2014,1,NULL,'This QSO is lensed by a foreground z=0.577 galaxy.','QSO',0.000457,NULL,'17.5g',NULL,'BAL',NULL,NULL,NULL,'QSO',1,252.6810417,42.86369,0,NULL,59815149303,934611707,14603307,17.5),(139434,'G Lens','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139434,41.61,NULL,2100,67037,NULL,NULL,'R(H) = ct','SDSS J1650+4251',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139435,'G Lens','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139435,41.91,0.38,2410,67037,NULL,NULL,NULL,'SDSS J1650+4251',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139436,'G Lens','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139436,43.74,0.72,5600,67037,NULL,NULL,NULL,'SDSS J1650+4251',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139437,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139437,35.17,0.49,108,67038,70,NULL,NULL,'2MASX J16504398-6242504',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.6835,-62.71428,0.729,NULL,44476118610,694939353,10858427,14.4),(139438,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139438,38.05,0.46,408,67039,70,NULL,NULL,'2MASX J16504542+2746519',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,252.689375,27.78111,0.201,NULL,56234497051,878664016,13729125,18.3),(139439,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139439,38.89,0.46,600,67040,70,NULL,NULL,'SDSS J165047.16+301111.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000168,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,252.6965,30.18664,0.125,NULL,56216491840,878382685,13724729,18.6),(139440,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139440,38.48,0.46,496,67041,70,NULL,NULL,'2MASX J16504731+3137587',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.697167,31.63308,0.109,NULL,56219821020,878434703,13725542,18.1),(139441,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139441,37.55,0.21,324,67042,70,NULL,NULL,'SDSS J165048.83+325027.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,252.7035,32.84106,0.081,NULL,56204806544,878200102,13721876,18.5),(139442,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139442,37.14,0.46,268,67043,70,NULL,NULL,'2MASX J16504910+2114531',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.704667,21.24822,0.257,NULL,56687852328,885747692,13839807,17),(139443,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139443,37.5,0.46,317,67044,70,NULL,NULL,'2MASX J16504985+4002175',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.70775,40.03825,0.029,NULL,59817664318,934651004,14603921,17.6),(139444,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139444,37.55,0.21,324,67045,70,NULL,NULL,'2MASX J16505076+3248547',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,252.711541667,32.81517,0.081,NULL,56205673524,878213648,13722088,17),(139445,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139445,37.11,0.33,265,67046,70,NULL,NULL,'2MASX J16505100+2719419',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000184,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,252.712416667,27.32831,0.209,NULL,56234199578,878659368,13729052,16.9),(139446,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139446,35.13,NULL,106,67047,NULL,NULL,NULL,'FGC 2075',NULL,'2000BSAO...50....5K',2000,1,1.2,NULL,'G',0.000056,NULL,'16.7g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,252.713,39.36794,0.041,NULL,59826442896,934788170,14606065,16.7),(139447,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139447,35.51,0.46,126,67048,70,NULL,NULL,'CGCG 225-003',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000077,NULL,'15.3g',0.5,'E0',NULL,NULL,NULL,NULL,1,252.713167,39.59828,0.037,NULL,59826434140,934788033,14606063,15.3),(139448,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139448,35.39,NULL,120,67049,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +08-31-009',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',NULL,NULL,'16.8g',0.11,'Sd',NULL,NULL,NULL,NULL,1,252.72375,47.21783,0.005,NULL,59616648014,931510125,14554845,16.8),(139449,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139449,35.41,NULL,121,67049,NULL,NULL,'Dipole + Quadrupole','MCG +08-31-009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139450,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139450,35.43,NULL,122,67049,NULL,NULL,'Dipole','MCG +08-31-009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139451,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139451,35.43,NULL,122,67049,NULL,NULL,NULL,'MCG +08-31-009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139452,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139452,36.6,0.33,209,67050,70,NULL,NULL,'2MASX J16505413+2031220',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.7255,20.52294,0.305,NULL,56683880000,885685625,13838837,16.5),(139453,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139453,33.88,0.48,59.7,67051,70,NULL,NULL,'ESO 137-IG 044 NED01',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000087,NULL,'15.32',0.5,'SB(s)0+:','Pair member (points to parent)',NULL,NULL,NULL,1,252.727583,-61.81264,0.761,NULL,44470107678,694845432,10856959,15.32),(139454,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139454,37.6,0.46,332,67052,70,NULL,NULL,'2MASX J16505526+2759579',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.730167,27.99942,0.201,NULL,56234378564,878662165,13729096,17.5),(139455,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139455,35.53,0.46,128,67053,70,NULL,NULL,'2MASX J16505636+2844289',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000166,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,252.734833,28.74133,0.181,NULL,56221988093,878468563,13726071,16.3),(139456,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139456,37.55,0.21,324,67054,70,NULL,NULL,'2MASX J16505750+3249377',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000215,NULL,'16.4g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,252.739625,32.82719,0.081,NULL,56205687669,878213869,13722091,16.4),(139457,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139457,35.81,0.25,145,67055,74.4,NULL,NULL,'UGC 10638 NED05',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000073,NULL,'14.16',NULL,'E/S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,252.744667,81.57481,0.269,NULL,56956372663,889943322,13905364,14.16),(139458,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139458,36.01,0.28,159,67055,70,NULL,NULL,'UGC 10638 NED05',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139459,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139459,37.55,0.21,324,67056,70,NULL,NULL,'2MASX J16505989+3247467',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.7497083,32.7965,0.097,NULL,56205679252,878213738,13722089,17.9),(139460,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139460,37.21,0.46,277,67057,70,NULL,NULL,'2MASX J16510002+2232073',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.7500417,22.53539,0.261,NULL,56689559108,885774361,13840224,17.5),(139461,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139461,37.88,0.46,377,67058,70,NULL,NULL,'2MASXi J1651014+412337',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.7559583,41.39394,0,NULL,59818600649,934665635,14604150,17.8),(139462,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139462,32.66,0.48,34.1,67059,70,NULL,NULL,'ESO 137- G 045',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000107,NULL,'13.25',1.2,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,252.761417,-60.80869,1.133,NULL,44499799575,695309368,10864208,13.25),(139463,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139463,36.6,0.33,209,67060,70,NULL,NULL,'2MASX J16510394+2018014',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000196,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,252.7665,20.30044,0.297,NULL,56683761094,885683767,13838808,16.1),(139464,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139464,35.87,0.49,149,67061,75,NULL,'IR','2MFGC 13495',NULL,'2011yCatp016004901K',2011,1,0.62,NULL,'G',0.000086,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,252.769041667,22.54442,0.261,NULL,56688445747,885756964,13839952,16.7),(139465,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139465,31.55,0.8,20.5,67062,75,NULL,'B','NGC 6215',NULL,'1988NBGC.C....0000T',1988,1,2.1,'Confused HIPASS source','G',0.000013,NULL,'12.0B',1.8,'SA(s)c pec','in a pair',NULL,NULL,NULL,1,252.778375,-58.99347,NULL,NULL,44554038627,696156853,10877450,12),(139466,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139466,38.03,0.46,405,67063,70,NULL,NULL,'SDSS J165106.88+294848.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,252.778667,29.81339,0.181,NULL,56214181298,878346582,13724165,18.3),(139467,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139467,35.81,0.25,145,67064,74.4,NULL,NULL,'UGC 10638 NED02',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'14.90',NULL,'E/S0',NULL,NULL,NULL,NULL,1,252.782833,81.58225,0.269,NULL,56956372862,889943325,13905364,14.9),(139468,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139468,36.01,0.28,159,67064,70,NULL,NULL,'UGC 10638 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139469,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139469,37.31,0.46,290,67065,70,NULL,NULL,'2MASX J16510868+3240357',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000196,NULL,'16.2g',0.42,NULL,NULL,NULL,NULL,NULL,1,252.7862083,32.67667,0.097,NULL,56205650988,878213296,13722082,16.2),(139470,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139470,35.94,0.32,154,67066,NULL,NULL,'Malmquist cor.','UGC 10582',NULL,'2009ApJS..182..474S',2009,1,1.05,NULL,'G',0.000033,NULL,'15.7g',0.27,'Sbc',NULL,NULL,NULL,NULL,1,252.795083,23.94714,0.201,NULL,56679857625,885622775,13837855,15.7),(139471,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139471,35.96,0.2,156,67066,74.4,NULL,NULL,'UGC 10582',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139472,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139472,36.07,0.3,164,67066,NULL,NULL,NULL,'UGC 10582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139473,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139473,37.69,0.33,346,67067,70,NULL,NULL,'2MASX J16511165+3217167',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000154,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.7985,32.288,0.097,NULL,56219245395,878425709,13725401,17.1),(139474,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139474,37.5,0.46,316,67068,70,NULL,NULL,'2MASX J16511223+2555309',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,252.800875,25.92542,0.209,NULL,56198282230,878098159,13720283,17.1),(139475,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139475,37.3,0.46,288,67069,70,NULL,NULL,'2MASX J16511465+4358238',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000095,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,252.81125,43.97331,0,NULL,59613700051,931464063,14554125,16.9),(139476,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139476,36.1,0.46,166,67070,70,NULL,NULL,'2MASX J16511671+2806519',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000095,NULL,'15.9g',NULL,'SF',NULL,NULL,NULL,NULL,1,252.8195,28.11458,0.201,NULL,56223099074,878485923,13726342,15.9),(139477,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139477,36.74,0.46,222,67071,70,NULL,NULL,'2MASX J16511784+3205187',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,252.824375,32.08844,0.089,NULL,56219170752,878424543,13725383,16.5),(139478,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139478,36.55,0.64,204,67072,70,NULL,NULL,'2MASX J16511789-0016258',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,252.824583,-0.27386,0.385,NULL,45172863370,705825990,11028531,15.6),(139479,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139479,35.65,0.56,135,67073,70,NULL,NULL,'2MASX J16512015-1444385',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,252.833917,-14.74406,1.449,NULL,46163885124,721310705,11270479,14.4),(139480,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139480,37.69,0.33,346,67074,70,NULL,NULL,'2MASX J16512066+3222146',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,252.8362083,32.37078,0.097,NULL,56219001255,878421894,13725342,17.1),(139481,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139481,36.64,0.46,213,67075,70,NULL,NULL,'2MASX J16512071+4052267',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000074,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,252.83625,40.874,0,NULL,59817455467,934647741,14603870,16.5),(139482,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139482,37.92,0.46,385,67076,70,NULL,NULL,'2MASX J16512182+3111537',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.841167,31.19811,0.101,NULL,56219786361,878434161,13725533,17.9),(139483,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139483,37.55,0.21,324,67077,70,NULL,NULL,'2MASX J16512421+3247437',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000183,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,252.851,32.79558,0.097,NULL,56205704049,878214125,13722095,16.8),(139484,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139484,37.24,0.46,281,67078,70,NULL,NULL,'2MASX J16512622+2219294',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.859125,22.32478,0.253,NULL,56689255301,885769614,13840150,17.8),(139485,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139485,36.9,0.33,240,67079,70,NULL,NULL,'2MASX J16513224+3848067',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000097,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,252.884375,38.80178,0.045,NULL,59826052115,934782064,14605969,15.8),(139486,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139486,34.91,0.45,95.9,67080,NULL,NULL,'K','UGCA 414',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000043,NULL,'13',1.7,'SB(rs)bc       HII',NULL,NULL,NULL,NULL,1,252.884667,-3.09667,0.605,NULL,45169551929,705774248,11027722,13),(139487,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139487,34.94,0.46,97.2,67080,NULL,NULL,'J','UGCA 414',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139488,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139488,34.94,0.47,97.4,67080,NULL,NULL,'H','UGCA 414',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139489,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139489,35.01,0.4,101,67080,NULL,NULL,'mean','UGCA 414',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139490,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139490,38.54,0.46,510,67081,70,NULL,NULL,'2MASX J16513420+4050377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00009,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,252.89275,40.84375,0,NULL,59817421176,934647205,14603862,17.4),(139491,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139491,37.33,0.46,293,67082,70,NULL,NULL,'2MASX J16513485+2534490',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00017,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.895125,25.58039,0.189,NULL,56198126541,878095727,13720245,17.6),(139492,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139492,36.51,0.46,200,67083,70,NULL,NULL,'2MASX J16513525+1818540',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,252.896875,18.315,0.309,NULL,56865867145,888529174,13883268,17.3),(139493,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139493,37.77,0.46,358,67084,70,NULL,NULL,'2MASX J16514196+2638300',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.9249583,26.64158,0.209,NULL,56197438357,878084974,13720077,18),(139494,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139494,37.28,0.46,286,67085,70,NULL,NULL,'2MASX J16514251+3914086',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000107,NULL,'16.87',0.32,NULL,NULL,NULL,NULL,NULL,1,252.927166667,39.23581,0.041,NULL,59826327472,934786366,14606036,16.87),(139495,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139495,35.98,0.15,157,67086,70,NULL,NULL,'2MASX J16514444+2342400',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00019,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,252.935166667,23.71108,0.197,NULL,56679951635,885624244,13837878,16.4),(139496,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139496,35.82,0.25,146,67087,74.4,NULL,NULL,'UGC 10638 NED06',NULL,'2013AJ....146...86T',2013,1,0.13,NULL,'G',0.000073,NULL,'14.29',NULL,'E/S0',NULL,NULL,NULL,NULL,1,252.9374583,81.592,0.269,NULL,56956499060,889945297,13905395,14.29),(139497,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139497,36.01,0.28,159,67087,70,NULL,NULL,'UGC 10638 NED06',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139498,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139498,38.03,0.46,403,67088,70,NULL,NULL,'2MASX J16514731+2619500',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,252.947208333,26.33061,0.229,NULL,56197575884,878087123,13720111,18.1),(139499,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139499,33.82,0.49,58,67089,70,NULL,NULL,'2MASX J16514761-6133582',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.37',0.46,NULL,NULL,NULL,NULL,NULL,1,252.948917,-61.56692,0.789,NULL,44469675124,694838673,10856854,15.37),(139500,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139500,34.14,NULL,67.3,67090,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2089',NULL,'2010Ap&SS.325..163P',2010,1,0.63,NULL,'G',0.000027,NULL,'16.09',0.09,'Scd',NULL,NULL,NULL,NULL,1,252.951667,78.75361,0.145,NULL,57140227033,892816047,13950250,16.09),(139501,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139501,34.17,NULL,68.1,67090,NULL,NULL,'Dipole + Quadrupole','FGC 2089',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139502,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139502,34.19,NULL,69,67090,NULL,NULL,'Dipole','FGC 2089',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139503,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139503,34.4,0.69,75.9,67090,NULL,NULL,NULL,'FGC 2089',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139504,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139504,34.44,0.2,77.3,67090,74.4,NULL,NULL,'FGC 2089',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139505,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139505,34.68,0.6,86.1,67090,NULL,NULL,'Malmquist cor.','FGC 2089',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139506,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139506,38.33,0.46,464,67091,70,NULL,NULL,'2MASX J16514858+3541348',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,252.9525,35.69311,0.069,NULL,59743955412,933499303,14585926,17.5),(139507,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139507,36.19,0.46,173,67092,70,NULL,NULL,'2MASX J16514927+2006100',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000162,NULL,'16.2g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,252.9552083,20.10278,0.297,NULL,56683471663,885679244,13838738,16.2),(139508,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139508,35.37,0.46,119,67093,70,NULL,NULL,'2MASX J16514954+3711109',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00008,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,252.956375,37.18633,0.069,NULL,59814883183,934607549,14603242,16.3),(139509,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139509,35.74,0.46,141,67094,70,NULL,NULL,'2MASX J16515086+1749385',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'17.23',0.32,NULL,NULL,NULL,NULL,NULL,1,252.9619583,17.82731,0.273,NULL,56894118471,888970601,13890165,17.23),(139510,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139510,35.47,0.56,124,67095,70,NULL,NULL,'2MASX J16515408-8001482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,252.975167,-80.03008,0.485,NULL,44272404152,691756314,10808692,16.1),(139511,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139511,35.81,0.25,145,67096,74.4,NULL,NULL,'GIN 616',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000057,NULL,'14.94',NULL,'S',NULL,NULL,NULL,NULL,1,252.994667,81.51172,0.269,NULL,56955584538,889931008,13905172,14.94),(139512,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139512,36.01,0.28,159,67096,70,NULL,NULL,'GIN 616',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139513,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139513,37.92,0.46,383,67097,70,NULL,NULL,'2MASX J16520091+2726417',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,253.003875,27.44481,0.209,NULL,56222742015,878480343,13726255,18.5),(139514,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139514,37.91,0.33,382,67098,70,NULL,NULL,'2MASX J16520187+2853467',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.007833,28.89631,0.141,NULL,56221967447,878468241,13726066,17.4),(139515,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139515,37.91,0.33,382,67099,70,NULL,NULL,'2MASX J16520240+2853207',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,253.01,28.88897,0.141,NULL,56221968214,878468253,13726066,18.5),(139516,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139516,36.93,0.46,243,67100,70,NULL,NULL,'2MASX J16520295+4045089',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00008,NULL,'16.2g',0.32,'E0',NULL,NULL,NULL,NULL,1,253.0122083,40.75239,0,NULL,59817413110,934647079,14603860,16.2),(139517,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139517,37.07,0.46,259,67101,70,NULL,NULL,'2MASX J16520686+3244350',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000196,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,253.028583,32.74303,0.097,NULL,56205156272,878205566,13721961,16.2),(139518,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139518,36.88,0.46,238,67102,70,NULL,NULL,'2MASX J16520701+2334516',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.029375,23.581,0.229,NULL,56688215988,885753374,13839896,17.1),(139519,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139519,35.11,0.52,105,67103,70,NULL,NULL,'2MASX J16520774-1703135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,'HII?',NULL,NULL,NULL,NULL,1,253.03225,-17.05375,1.105,NULL,46155520380,721180005,11268437,14.2),(139520,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139520,37.63,0.46,336,67104,70,NULL,NULL,'2MASX J16521118+3050410',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.0464583,30.84478,0.113,NULL,56217090389,878392037,13724875,17.6),(139521,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139521,35.58,0.63,131,67105,70,NULL,NULL,'2MASX J16521197-0203452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.05,-2.06253,0.473,NULL,45220439466,706569366,11040146,15.6),(139522,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139522,36.91,0.46,241,67106,70,NULL,NULL,'2MASX J16521228+2115166',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000173,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,253.051167,21.25458,0.249,NULL,56687974700,885749604,13839837,16.3),(139523,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139523,35.82,0.25,146,67107,74.4,NULL,NULL,'UGC 10638 NED09',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'14.48',NULL,'E/S0',NULL,NULL,NULL,NULL,1,253.0539583,81.62019,0.269,NULL,56956496949,889945264,13905394,14.48),(139524,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139524,36.01,0.28,159,67107,70,NULL,NULL,'UGC 10638 NED09',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139525,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139525,38.73,0.46,558,67108,70,NULL,NULL,'SDSS J165213.62+294045.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,253.05675,29.67928,0.181,NULL,56221688223,878463878,13725998,18.2),(139526,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139526,37.94,0.46,388,67109,70,NULL,NULL,'2MASX J16521363+2614177',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000162,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.0569583,26.23817,0.229,NULL,56197527692,878086370,13720099,18.1),(139527,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139527,36.11,0.66,166,67110,70,NULL,NULL,'2MASX J16521414-6048123',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.0590417,-60.80336,1.133,NULL,44500918198,695326846,10864481,15.9),(139528,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139528,35.98,0.15,157,67111,70,NULL,NULL,'2MASX J16521489+2349096',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000168,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,253.062041667,23.81942,0.213,NULL,56679944877,885624138,13837877,16.1),(139529,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139529,37.92,0.23,383,67112,70,NULL,NULL,'2MASX J16521603+2744477',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.066833,27.74644,0.213,NULL,56223456754,878491511,13726429,17.7),(139530,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139530,36.67,0.46,216,67113,70,NULL,NULL,'2MASX J16521630+6219274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.067791667,62.32431,0.037,NULL,57535916759,898998699,14046854,17.3),(139531,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139531,35.98,0.15,157,67114,70,NULL,NULL,'CGCG 139-011',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000186,NULL,'16.0g',0.41,'E0','Group member',NULL,NULL,NULL,1,253.072,23.30039,0.249,NULL,56688200667,885753135,13839892,16),(139532,'D-Sigma','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139532,32.53,0.4,32,67115,75,NULL,'Edat, raw','ESO 069- G 014',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00015,NULL,'12.67',1,'SB0^0^: pec',NULL,NULL,NULL,NULL,1,253.076375,-69.12514,0.449,NULL,45018552167,703414877,10990857,12.67),(139533,'D-Sigma','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139533,32.86,0.4,37.4,67115,75,NULL,'Edat, cor','ESO 069- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139534,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139534,33.26,0.47,44.8,67115,70,NULL,NULL,'ESO 069- G 014',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139535,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139535,33.44,0.45,48.6,67115,NULL,NULL,'K','ESO 069- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139536,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139536,34.01,0.4,63.3,67115,NULL,NULL,'mean','ESO 069- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139537,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139537,35.98,0.15,157,67116,70,NULL,NULL,'2MASX J16522146+2323365',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.089458333,23.39344,0.229,NULL,56688204816,885753200,13839893,16.9),(139538,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139538,35.87,0.46,149,67117,70,NULL,NULL,'CGCG 169-009 NED01',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000133,NULL,'15.1g',0.52,'S0',NULL,NULL,NULL,NULL,1,253.0944583,30.71103,0.105,NULL,56217193901,878393654,13724900,15.1),(139539,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139539,36.84,0.33,233,67118,70,NULL,NULL,'2MASXi J1652242+235302',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000179,NULL,'16.3g',0.27,'S0^-',NULL,NULL,NULL,NULL,1,253.101083333,23.88394,0.213,NULL,56679776892,885621513,13837836,16.3),(139540,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139540,36.95,0.63,246,67119,70,NULL,NULL,'WKK 7630',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'17.1',0.25,'w.comp.',NULL,NULL,NULL,NULL,1,253.110625,-59.98125,0.905,NULL,44499220631,695300322,10864067,17.1),(139541,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139541,38.11,0.46,418,67120,70,NULL,NULL,'2MASX J16522656+3814120',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000081,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,253.1109583,38.23656,0.069,NULL,59812284936,934566952,14602608,17.9),(139542,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139542,37.56,0.6,325,67121,70,NULL,NULL,'2MASX J16522685-6008363',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.11175,-60.1435,0.913,NULL,44501383301,695334114,10864595,16.3),(139543,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139543,35.62,0.46,133,67122,70,NULL,NULL,'CGCG 225-005',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00008,NULL,'15.7g',0.37,'S0/a',NULL,NULL,NULL,NULL,1,253.12125,40.31194,0.021,NULL,59818065705,934657276,14604019,15.7),(139544,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139544,37.49,0.46,315,67123,70,NULL,NULL,'2MASX J16522921+2433177',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000129,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,253.121708333,24.55489,0.233,NULL,56197288760,878082636,13720041,18),(139545,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139545,37.92,0.23,383,67124,70,NULL,NULL,'2MASX J16523411+2743247',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000147,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,253.142208333,27.72342,0.213,NULL,56223450385,878491412,13726428,17.2),(139546,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139546,37.17,0.59,271,67125,70,NULL,NULL,'2MASX J16523428-7941120',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,253.142667,-79.68669,0.473,NULL,44274039100,691781860,10809091,16.5),(139547,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139547,37.51,0.46,317,67126,70,NULL,NULL,'2MASX J16523544+2827177',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000197,NULL,'16.2g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,253.147583333,28.45478,0.213,NULL,56223837666,878497463,13726522,16.2),(139548,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139548,38.32,0.46,461,67127,70,NULL,NULL,'2MASX J16523654+3202394',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,253.15225,32.04439,0.089,NULL,56219506971,878429796,13725465,18),(139549,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139549,36.29,0.46,181,67128,70,NULL,NULL,'2MASX J16523792+3851171',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000071,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,253.1580417,38.85489,0.065,NULL,59825587805,934774809,14605856,17.4),(139550,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139550,36.37,0.82,188,67129,70,NULL,NULL,'WKK 7642',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.1',0.27,'s.p.* near blg',NULL,NULL,NULL,NULL,1,253.1595417,-59.95744,0.905,NULL,44499084417,695298194,10864034,17.1),(139551,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139551,36.26,0.46,178,67130,70,NULL,NULL,'2MASX J16523888+2419367',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000164,NULL,'16.3g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,253.1619583,24.32689,0.233,NULL,56196586692,878071667,13719869,16.3),(139552,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139552,37.85,0.46,372,67131,70,NULL,NULL,'2MASX J16523894+4042501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000101,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.162333,40.71383,0,NULL,59817492851,934648325,14603880,17.3),(139553,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139553,38.07,0.46,410,67132,70,NULL,NULL,'2MASX J16524177+2612507',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,253.174125,26.21417,0.257,NULL,56200399532,878131242,13720800,18.2),(139554,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139554,36.32,0.61,184,67133,70,NULL,NULL,'2MASX J16524201-0836043',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.175083333,-8.60125,0.949,NULL,46076403624,719943806,11249121,15.8),(139555,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139555,38.08,0.46,412,67134,70,NULL,NULL,'SDSS J165242.18+183922.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,253.17575,18.65631,0.313,NULL,56865920376,888530005,13883281,18.5),(139556,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139556,37.92,0.23,383,67135,70,NULL,NULL,'2MASX J16524293+2745167',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.179083333,27.75461,0.213,NULL,56223452672,878491448,13726428,18.1),(139557,'Sosies','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139557,29.12,0.32,6.67,67136,NULL,NULL,NULL,'NGC 6221',NULL,'2002A&A...393...57T',2002,1,3.5,'Confused HIPASS source','G',0.000017,NULL,'11.2B',2.5,'SB(s)bc pec;Sy1Sy2','in a pair',NULL,NULL,'unobscured Seyfert 2',1,253.192,-59.21861,NULL,NULL,44554115794,696158059,10877469,11.2),(139558,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139558,31.44,0.8,19.4,67136,75,NULL,'B','NGC 6221',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139559,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139559,30,0.43,10,67136,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6221',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139560,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139560,30.12,0.47,10.6,67136,NULL,NULL,'H','NGC 6221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139561,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139561,30.13,0.46,10.6,67136,NULL,NULL,'J','NGC 6221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139562,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139562,30.15,0.45,10.7,67136,NULL,NULL,'K','NGC 6221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139563,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139563,30.16,NULL,10.8,67136,NULL,NULL,'LEDA [April 2006]','NGC 6221',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139564,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139564,30.24,0.43,11.2,67136,75,NULL,'3.6 micron, color corrected','NGC 6221',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139565,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139565,30.31,0.36,11.5,67136,NULL,NULL,NULL,'NGC 6221',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139566,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139566,30.3,0.4,11.5,67136,73,NULL,'opt','NGC 6221',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139567,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139567,30.46,0.2,12.4,67136,74.4,NULL,NULL,'NGC 6221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139568,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139568,31.14,0.4,16.9,67136,NULL,NULL,'mean','NGC 6221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139569,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139569,35.98,0.15,157,67137,70,NULL,NULL,'ARK 510',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000184,NULL,'14.9g',0.63,'E0','Group member',NULL,NULL,NULL,1,253.195625,23.24306,0.249,NULL,56688987159,885765424,13840084,14.9),(139570,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139570,35.81,0.25,145,67138,74.4,NULL,NULL,'UGC 10638 NED07',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.000073,NULL,'13.91',NULL,'E/S0;BrClG','Brightest group member',NULL,NULL,NULL,1,253.198917,81.63294,0.269,NULL,56956496832,889945263,13905394,13.91),(139571,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139571,36.01,0.28,159,67138,70,NULL,NULL,'UGC 10638 NED07',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139572,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139572,35.3,0.56,115,67139,70,NULL,NULL,'ESO 023- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.5b',0.4,'S...',NULL,NULL,NULL,NULL,1,253.2005417,-79.83981,0.461,NULL,44272243890,691753810,10808653,15.5),(139573,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','PTF10fxl','N',139573,35.61,0.02,129,67140,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10fxl',0.0296,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139574,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139574,38.1,0.33,416,67141,70,NULL,NULL,'SDSS J165249.93+320029.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,253.208083333,32.00806,0.089,NULL,56219512866,878429888,13725467,18.3),(139575,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139575,36.31,0.33,183,67142,70,NULL,NULL,'2MASX J16525214+3951080',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000076,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.2172083,39.85219,0.057,NULL,59817248993,934644515,14603820,16.9),(139576,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139576,37.68,0.46,343,67143,70,NULL,NULL,'2MASX J16525423+2159530',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000211,NULL,'16.4g',0.38,NULL,NULL,NULL,NULL,NULL,1,253.225958333,21.99792,0.253,NULL,56687440641,885741260,13839707,16.4),(139577,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139577,36.84,0.33,233,67144,70,NULL,NULL,'2MASX J16525467+2350070',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.227667,23.83528,0.213,NULL,56679767707,885621370,13837833,17.1),(139578,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139578,37.78,0.46,360,67145,70,NULL,NULL,'2MASX J16525486+2757457',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.22875,27.96261,0.209,NULL,56223236531,878488070,13726376,18),(139579,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139579,37.62,0.23,334,67146,70,NULL,NULL,'2MASX J16525715+3301595',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.238291667,33.03331,0.097,NULL,56205547407,878211678,13722057,17.2),(139580,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139580,37.62,0.23,334,67147,70,NULL,NULL,'2MASX J16525897+3257204',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000161,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.245583333,32.95567,0.097,NULL,56205068333,878204192,13721940,16.8),(139581,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139581,42.08,0.82,1320,67148,74.2,NULL,'SALT 2','H-ZSNS J165300.27+350346.4',0.97,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,253.251125,35.06289,0.069,NULL,59744462553,933507227,14586050,NULL),(139582,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139582,44.06,0.27,1670,67148,65,NULL,'H96','H-ZSNS J165300.27+350346.4',0.97,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139583,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139583,44.15,0.45,1740,67148,65,NULL,'RPK','H-ZSNS J165300.27+350346.4',0.97,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139584,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck','R',139584,43.04,NULL,2060,67148,65,NULL,'SALT','H-ZSNS J165300.27+350346.4',0.97,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139585,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139585,43.08,0.74,2100,67148,70,NULL,'SALT','H-ZSNS J165300.27+350346.4',0.97,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139586,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139586,43.13,0.74,2150,67148,65,NULL,'SALT','H-ZSNS J165300.27+350346.4',0.97,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139587,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139587,44.13,0.38,3400,67148,65,NULL,NULL,'H-ZSNS J165300.27+350346.4',0.97,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139588,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139588,44.3,0.19,3680,67148,65,NULL,'Template','H-ZSNS J165300.27+350346.4',0.97,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139589,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 1997ck',NULL,139589,44.39,0.3,3830,67148,65,NULL,'MLCS','H-ZSNS J165300.27+350346.4',0.97,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139590,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139590,37.88,0.46,376,67149,70,NULL,NULL,'2MASX J16530181+4221456',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.25775,42.36253,0,NULL,59635065112,931797892,14559342,17.8),(139591,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139591,37.47,0.46,313,67150,70,NULL,NULL,'2MASX J16530287+3156274',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.262,31.94086,0.101,NULL,56219489808,878429528,13725461,17.1),(139592,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139592,35.9,0.27,151,67151,70,NULL,NULL,'2MASX J16530366+2512531',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,253.265375,25.21478,0.213,NULL,56201078603,878141853,13720966,16.2),(139593,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139593,37.25,0.46,282,67152,70,NULL,NULL,'2MASX J16530431+1959152',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.267833,19.98772,0.329,NULL,56865217119,888519017,13883109,17.3),(139594,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139594,38.3,0.46,457,67153,70,NULL,NULL,'2MASX J16530560+3018134',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,253.2732917,30.30386,0.101,NULL,56215017300,878359645,13724369,17.2),(139595,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139595,37.4,0.46,302,67154,70,NULL,NULL,'2MASX J16530665+4459487',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.2777917,44.99686,0,NULL,59614470388,931476099,14554314,17),(139596,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139596,37.92,0.23,383,67155,70,NULL,NULL,'2MASX J16530730+2743121',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.280375,27.71997,0.213,NULL,56223543202,878492862,13726450,18),(139597,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139597,37.82,0.46,367,67156,70,NULL,NULL,'2MASX J16530805+2747171',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000136,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.283541667,27.78806,0.209,NULL,56223587615,878493556,13726461,17.8),(139598,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139598,38.1,0.46,417,67157,70,NULL,NULL,'SDSS J165308.77+185408.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,253.286583,18.90239,0.349,NULL,56866202224,888534409,13883350,18.4),(139599,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139599,36.08,0.46,164,67158,70,NULL,NULL,'2MASX J16531222+4257087',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.300958333,42.95244,0,NULL,59634701363,931792208,14559253,17.2),(139600,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139600,37.19,0.19,274,67159,70,NULL,NULL,'2MASX J16531275+2327282',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000176,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.3032917,23.45789,0.229,NULL,56688316608,885754947,13839921,17.4),(139601,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139601,38.1,0.33,416,67160,70,NULL,NULL,'2MASX J16531771+3200174',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.323833333,32.005,0.045,NULL,56219635926,878431811,13725497,17.4),(139602,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139602,36.57,0.46,206,67161,70,NULL,NULL,'2MASX J16531979+1752494',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.3325417,17.88033,0.289,NULL,56894045630,888969462,13890147,17),(139603,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139603,37.04,0.23,256,67162,70,NULL,NULL,'2MASX J16532033+2940331',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000168,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.334917,29.67592,0.181,NULL,56222089548,878470149,13726096,16.5),(139604,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139604,37.86,0.46,373,67163,70,NULL,NULL,'2MASX J16532096+3024384',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.2g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.337375,30.41072,0.101,NULL,56214755605,878355556,13724305,17.2),(139605,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139605,36.54,0.46,203,67164,70,NULL,NULL,'2MASX J16532310+4326427',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000079,NULL,'16.2g',0.34,NULL,NULL,NULL,NULL,NULL,1,253.346,43.44522,0,NULL,59634829055,931794203,14559284,16.2),(139606,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139606,38.3,0.46,456,67165,70,NULL,NULL,'2MASX J16532412+2801181',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000204,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.3505,28.02172,0.225,NULL,56223362111,878490032,13726406,17.1),(139607,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139607,36.25,0.46,178,67166,70,NULL,NULL,'2MASX J16532414+2605411',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.350583,26.09483,0.257,NULL,56199918197,878123721,13720683,17.1),(139608,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139608,35.43,0.69,122,67167,70,NULL,NULL,'2MASX J16532514-1620582',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.3547917,-16.34947,1.309,NULL,46169963214,721405675,11271963,16.3),(139609,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139609,37.44,0.46,307,67168,70,NULL,NULL,'2MASX J16532553+3029174',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,253.356208333,30.48797,0.105,NULL,56214761540,878355649,13724307,17.4),(139610,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139610,37.58,0.46,328,67169,70,NULL,NULL,'2MASX J16532575+6320151',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000111,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.357583,63.33756,0.033,NULL,57542036128,899094314,14048348,18),(139611,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139611,38.43,0.46,485,67170,70,NULL,NULL,'2MASX J16532627+2329420',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.359667,23.49517,0.213,NULL,56688267890,885754185,13839909,17.7),(139612,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139612,37.25,0.46,282,67171,70,NULL,NULL,'2MASX J16532782+3255374',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000189,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,253.3660417,32.92697,0.097,NULL,56205072099,878204251,13721941,16.2),(139613,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139613,37.62,0.23,334,67172,70,NULL,NULL,'2MASX J16532807+3303024',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,253.367125,33.05083,0.097,NULL,56205054069,878203969,13721937,18.2),(139614,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139614,36.81,0.46,230,67173,70,NULL,NULL,'2MASX J16532867+3341504',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000177,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.3694583,33.69719,0.049,NULL,56205302167,878207846,13721997,17),(139615,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139615,33.87,NULL,59.5,67174,NULL,NULL,'Dipole + Quadrupole','UGC 10632',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000027,NULL,'15.47',0.22,'Sd',NULL,NULL,NULL,NULL,1,253.369583,79.06917,0.149,NULL,57141032092,892828626,13950447,15.47),(139616,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139616,33.88,NULL,59.6,67174,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10632',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139617,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139617,33.88,NULL,59.7,67174,NULL,NULL,'Dipole','UGC 10632',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139618,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139618,34.46,0.2,78,67174,74.4,NULL,NULL,'UGC 10632',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139619,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139619,34.56,0.53,81.6,67174,NULL,NULL,NULL,'UGC 10632',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139620,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139620,34.81,0.47,91.7,67174,NULL,NULL,'Malmquist cor.','UGC 10632',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139621,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139621,37.04,0.23,256,67175,70,NULL,NULL,'2MASX J16532884+2937310',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000207,NULL,'16.1g',0.4,'BrClG',NULL,NULL,NULL,NULL,1,253.370167,29.62525,0.181,NULL,56222103899,878470373,13726099,16.1),(139622,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139622,37.04,0.23,256,67176,70,NULL,NULL,'2MASX J16532957+2939212',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000194,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,253.3732917,29.65594,0.181,NULL,56222091777,878470184,13726096,16.1),(139623,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139623,37.04,0.23,256,67177,70,NULL,NULL,'2MASX J16533455+2945142',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000183,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,253.394125,29.75378,0.129,NULL,56214555616,878352431,13724256,16.6),(139624,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139624,37.19,0.19,274,67178,70,NULL,NULL,'2MASX J16533524+2325398',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000176,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.396958333,23.42767,0.229,NULL,56688309538,885754836,13839919,18),(139625,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139625,36.54,0.81,203,67179,70,NULL,NULL,'2MASX J16533523-7948181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,253.39725,-79.80511,0.461,NULL,44272202038,691753156,10808643,16.9),(139626,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139626,37.62,0.23,334,67180,70,NULL,NULL,'2MASX J16533546+3303054',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000169,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,253.397875,33.05147,0.097,NULL,56205054266,878203972,13721937,17.5),(139627,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139627,37.63,0.46,336,67181,70,NULL,NULL,'2MASX J16533705+2654102',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.404333,26.90272,0.221,NULL,56192369341,878005770,13718840,17.6),(139628,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139628,38.23,0.19,443,67182,70,NULL,NULL,'2MASX J16533714+3132234',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.404875,31.53981,0.053,NULL,56220419119,878444048,13725688,18),(139629,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139629,37.76,0.46,356,67183,70,NULL,NULL,'2MASX J16533847+3110155',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.410125,31.17108,0.065,NULL,56220090268,878438910,13725607,18.1),(139630,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139630,36.81,0.46,230,67184,70,NULL,NULL,'2MASX J16534097+1943278',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000206,NULL,'15.9g',0.39,'E0',NULL,NULL,NULL,NULL,1,253.4207917,19.7245,0.333,NULL,56865089908,888517029,13883078,15.9),(139631,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139631,36.19,0.46,173,67185,70,NULL,NULL,'2MASX J16534249+2058158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.427166667,20.97117,0.285,NULL,56683103047,885673485,13838648,17.3),(139632,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139632,37.29,0.46,287,67186,70,NULL,NULL,'2MASX J16534260+6225120',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000088,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,253.427416667,62.42003,0.041,NULL,57535893331,898998333,14046848,16.5),(139633,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139633,36.92,0.33,242,67187,70,NULL,NULL,'2MASX J16534554+3312226',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000185,NULL,'15.6g',0.41,'E0',NULL,NULL,NULL,NULL,1,253.4397917,33.20619,0.093,NULL,56205510570,878211102,13722048,15.6),(139634,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139634,35.9,0.27,151,67188,70,NULL,NULL,'2MASX J16534584+2428023',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,253.440917,24.46731,0.217,NULL,56200678438,878135600,13720868,16.8),(139635,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139635,36.75,0.33,224,67189,70,NULL,NULL,'2MASX J16534592+2350248',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000165,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.441375,23.84008,0.213,NULL,56688169278,885752644,13839885,16.9),(139636,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139636,37.96,0.46,391,67190,70,NULL,NULL,'2MASX J16534625+2726232',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000173,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.442917,27.43983,0.209,NULL,56222678514,878479351,13726239,16.9),(139637,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139637,36.75,0.33,224,67191,70,NULL,NULL,'2MASX J16535051+2344078',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,253.460666667,23.73542,0.213,NULL,56688163152,885752549,13839883,16.5),(139638,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139638,36.02,0.23,160,67192,70,NULL,NULL,'2MASX J16535111+2658222',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000205,NULL,'15.8g',0.38,NULL,NULL,NULL,NULL,NULL,1,253.462917,26.97286,0.221,NULL,56192383359,878005989,13718843,15.8),(139639,'GeV TeV ratio','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139639,35.38,NULL,119,67193,72,NULL,NULL,'MRK 0501',NULL,'2010MNRAS.405L..76P',2010,1,NULL,'Additional radio sources may contribute to the WMAP flux.','QSO',0.000073,NULL,'14.15',NULL,'E?             BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,253.467583,39.76017,0.057,NULL,59817293958,934645218,14603831,14.15),(139640,'GeV TeV ratio','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139640,37.53,0.46,320,67193,72,NULL,NULL,'MRK 0501',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139641,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139641,35.17,0.46,108,67194,70,NULL,NULL,'2MASX J16535612+3515186',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000169,NULL,'15.5g',0.42,'E/S0',NULL,NULL,NULL,NULL,1,253.4837083,35.25531,0.069,NULL,59744486366,933507599,14586056,15.5),(139642,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139642,36.31,0.33,183,67195,70,NULL,NULL,'2MASX J16535637+3948459',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000067,NULL,'15.9g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,253.484708333,39.81261,0.057,NULL,59817286157,934645096,14603829,15.9),(139643,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139643,36.19,0.5,173,67196,70,NULL,NULL,'2MASX J16535767-6706464',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.49025,-67.11289,0.437,NULL,45022398512,703474976,10991796,14),(139644,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139644,37.18,0.46,273,67197,70,NULL,NULL,'2MASX J16535813+2615262',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.4922917,26.25717,0.197,NULL,56200420276,878131566,13720805,17.6),(139645,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139645,37.71,0.46,348,67198,70,NULL,NULL,'2MASX J16540145+3850149',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.506,38.83744,0.065,NULL,59811941122,934561580,14602524,17.9),(139646,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139646,37.58,0.46,329,67199,70,NULL,NULL,'2MASX J16540196+3928348',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000088,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,253.50825,39.47642,0.061,NULL,59825477378,934773084,14605829,16.7),(139647,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139647,37.9,0.46,379,67200,70,NULL,NULL,'SDSS J165404.66+243607.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,253.5194583,24.60208,0.209,NULL,56200721666,878136276,13720879,18.5),(139648,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139648,38.23,0.19,443,67201,70,NULL,NULL,'2MASX J16540741+3123145',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00018,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,253.530833,31.38761,0.109,NULL,56220136227,878439628,13725619,17.2),(139649,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139649,37.45,0.46,309,67202,70,NULL,NULL,'SDSS J165408.10+341843.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,253.533791667,34.31208,0.057,NULL,59744240246,933503753,14585996,18.3),(139650,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139650,36.92,0.33,242,67203,70,NULL,NULL,'2MASX J16540905+3314035',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00019,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,253.5377917,33.23425,0.093,NULL,56207409306,878240770,13722512,16.3),(139651,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139651,35.32,0.2,116,67204,74.4,NULL,NULL,'UGC 10598',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000027,NULL,'15.5g',0.41,'S?',NULL,NULL,NULL,NULL,1,253.542667,27.17308,0.193,NULL,56192393980,878006155,13718846,15.5),(139652,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139652,37.18,0.14,273,67205,70,NULL,NULL,'2MASXi J1654117+392017',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000072,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.548875,39.33822,0.061,NULL,59825498806,934773418,14605834,17.5),(139653,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139653,38.23,0.19,443,67206,70,NULL,NULL,'2MASX J16541329+3127298',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.555375,31.45839,0.053,NULL,56220014707,878437729,13725589,17.6),(139654,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139654,35.54,0.44,128,67207,NULL,NULL,'Malmquist cor.','UGC 10596',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.0',0.8,'SB?',NULL,NULL,NULL,NULL,1,253.567958333,10.44931,0.253,NULL,56731128135,886423877,13850373,16),(139655,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139655,35.64,0.43,134,67207,NULL,NULL,NULL,'UGC 10596',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139656,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139656,35.76,0.2,142,67207,74.4,NULL,NULL,'UGC 10596',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139657,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139657,34,0.62,63.1,67208,70,NULL,NULL,'2MASX J16541664-6047304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.56925,-60.79189,1.109,NULL,44501000470,695328132,10864502,15.1),(139658,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139658,35.32,0.7,116,67209,70,NULL,NULL,'2MASX J16541750-0559292',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.572917,-5.9915,0.821,NULL,45190311725,706098620,11032790,15),(139659,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139659,37.53,0.46,320,67210,70,NULL,NULL,'2MASX J16541911+4239418',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.579417,42.66161,0.005,NULL,59635555871,931805560,14559461,17.5),(139660,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139660,35.84,0.2,147,67211,74.4,NULL,NULL,'UGC 10600',NULL,'2013AJ....146...86T',2013,1,1.07,NULL,'G',0.00007,NULL,'15.4g',0.26,'Scd(f)         AGN',NULL,NULL,NULL,NULL,1,253.5865,36.01364,0.061,NULL,59811504549,934554758,14602418,15.4),(139661,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139661,34.98,0.49,99.2,67212,75,NULL,'IR','UGC 10600',NULL,'2011yCatp016004901K',2011,1,1.07,NULL,'G',0.00007,NULL,'15.4g',0.26,'Scd(f)         AGN',NULL,NULL,NULL,NULL,1,253.5865,36.01364,0.061,NULL,59811504549,934554758,14602418,15.4),(139662,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139662,31.61,0.4,21,67213,75,NULL,'B','UGC 10608',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.00002,NULL,'15.2',0.9,'SBdm',NULL,NULL,NULL,NULL,1,253.589583,53.11306,0.073,NULL,57480915495,898139304,14033426,15.2),(139663,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139663,38.33,0.46,464,67214,70,NULL,NULL,'2MASX J16542430+2757550',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000188,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.601375,27.96536,0.225,NULL,56223369013,878490140,13726408,17.4),(139664,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139664,35.31,0.58,116,67215,70,NULL,NULL,'2MASX J16542435-0541441',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.601583,-5.69564,0.829,NULL,45223392612,706615509,11040867,15),(139665,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139665,37.8,0.46,362,67216,70,NULL,NULL,'2MASX J16542583+3719030',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00009,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.607833,37.31761,0.085,NULL,59814533275,934602082,14603157,17.3),(139666,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139666,36.05,0.46,163,67217,70,NULL,NULL,'2MASX J16542878+3922190',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000086,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,253.62,39.37197,0.061,NULL,59825518710,934773729,14605839,15.9),(139667,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139667,37.17,0.46,272,67218,70,NULL,NULL,'2MASX J16543043+2456450',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,253.626833,24.94578,0.209,NULL,56201425642,878147275,13721051,16.9),(139668,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139668,35.83,0.46,147,67219,70,NULL,NULL,'2MASX J16543073+1946158',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.00001,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,253.6280417,19.77097,0.297,NULL,56864998793,888515606,13883056,15.6),(139669,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139669,36.95,0.46,245,67220,70,NULL,NULL,'SDSS J165430.86+231539.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,253.628583,23.26111,0.257,NULL,56674879926,885544998,13836640,18.2),(139670,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139670,36.96,0.33,247,67221,70,NULL,NULL,'2MASX J16543187+3737531',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000092,NULL,'16.5g',0.35,NULL,NULL,NULL,NULL,NULL,1,253.6327917,37.63142,0.069,NULL,59814518939,934601858,14603154,16.5),(139671,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139671,38.23,0.19,443,67222,70,NULL,NULL,'SDSS J165432.30+313354.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.634625,31.56525,0.053,NULL,56220051326,878438301,13725598,18.1),(139672,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139672,37.18,0.14,273,67223,70,NULL,NULL,'2MASX J16543480+3906460',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000074,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,253.645083,39.11281,0.061,NULL,59811841886,934560029,14602500,16.8),(139673,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139673,37.1,0.46,263,67224,70,NULL,NULL,'2MASX J16543514+6339436',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000063,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,253.64675,63.66203,0.053,NULL,57540100325,899064067,14047876,17.5),(139674,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139674,35.83,0.46,146,67225,70,NULL,NULL,'CGCG 139-018',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00019,NULL,'15.1g',0.57,'E0',NULL,NULL,NULL,NULL,1,253.65075,24.06364,0.209,NULL,56189001457,877953147,13718017,15.1),(139675,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139675,37.22,0.46,278,67226,70,NULL,NULL,'2MASX J16543945+3914380',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.664375,39.24403,0.061,NULL,59825494080,934773345,14605833,17.7),(139676,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139676,37.79,0.46,362,67227,70,NULL,NULL,'2MASX J16543946+3259568',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000164,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,253.6645,32.99911,0.069,NULL,56206979419,878234053,13722407,17.1),(139677,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139677,36.92,0.46,242,67228,70,NULL,NULL,'2MASX J16543955+3525039',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.6647917,35.41781,0.073,NULL,59744608534,933509508,14586086,17.5),(139678,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139678,37.22,0.46,278,67229,70,NULL,NULL,'2MASX J16544371+2955433',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.682083,29.92858,0.145,NULL,56214594630,878353041,13724266,17.6),(139679,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139679,35.9,0.27,151,67230,70,NULL,NULL,'2MASX J16544393+2449063',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000186,NULL,'15.7g',0.57,NULL,NULL,NULL,NULL,NULL,1,253.6830417,24.81856,0.209,NULL,56201409042,878147016,13721047,15.7),(139680,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139680,37.49,0.33,314,67231,70,NULL,NULL,'2MASX J16544663+1748599',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.694333,17.81683,0.289,NULL,56893745363,888964771,13890074,17),(139681,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139681,36.01,0.46,159,67232,70,NULL,NULL,'2MASX J16544710+4108521',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000093,NULL,'16.65',0.24,NULL,NULL,NULL,NULL,NULL,1,253.696417,41.14767,0.017,NULL,59636426671,931819166,14559674,16.65),(139682,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139682,31.33,0.8,18.5,67233,75,NULL,'A82, H','NGC 6255',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.000007,NULL,'13.4',1.5,'SBcd:','Isolated galaxy',NULL,NULL,NULL,1,253.6997917,36.50111,0.053,NULL,59811568103,934555751,14602433,13.4),(139683,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139683,31.19,0.4,17.3,67233,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6255',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139684,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139684,31.24,0.2,17.7,67233,74.4,NULL,NULL,'NGC 6255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139685,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139685,31.32,0.4,18.3,67233,75,NULL,'B','NGC 6255',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139686,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139686,31.34,0.43,18.6,67233,75,NULL,'3.6 micron, color corrected','NGC 6255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139687,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139687,31.49,0.43,19.9,67233,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139688,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139688,31.59,0.72,20.8,67233,NULL,NULL,NULL,'NGC 6255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139689,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139689,31.6,0.38,20.9,67233,NULL,NULL,NULL,'NGC 6255',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139690,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139690,31.77,0.66,22.6,67233,NULL,NULL,'Malmquist cor.','NGC 6255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139691,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139691,32.12,0.47,26.5,67233,75,NULL,'A82, H, inv','NGC 6255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139692,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139692,32.19,0.47,27.4,67233,75,NULL,'A82, H, raw','NGC 6255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139693,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139693,32.53,0.47,32,67233,75,NULL,'A82, H, cor','NGC 6255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139694,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139694,37.7,0.46,347,67234,70,NULL,NULL,'2MASX J16544845+2618413',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000192,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,253.701833333,26.31147,0.197,NULL,56200314898,878129920,13720780,16.8),(139695,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139695,37.76,0.33,357,67235,70,NULL,NULL,'2MASX J16544927+3208275',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.7052083,32.141,0.085,NULL,56219616218,878431503,13725492,17.3),(139696,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139696,37.79,0.46,362,67236,70,NULL,NULL,'2MASX J16544969+2726283',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000182,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.706917,27.44122,0.257,NULL,56192280435,878004381,13718818,17.1),(139697,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139697,37.03,0.46,255,67237,70,NULL,NULL,'2MASX J16544993+1950388',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,253.7080417,19.84403,0.305,NULL,56864889054,888513891,13883029,17.2),(139698,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139698,36.15,0.33,170,67238,70,NULL,NULL,'2MASX J16545006+3443385',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000164,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,253.708666667,34.72722,0.069,NULL,59744276435,933504319,14586004,16),(139699,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139699,37.49,0.33,314,67239,70,NULL,NULL,'2MASX J16545489+1747499',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.7287083,17.79736,0.289,NULL,56893746372,888964787,13890074,17.3),(139700,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139700,36.15,0.33,170,67240,70,NULL,NULL,'2MASX J16545533+3443105',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000185,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,253.730583,34.71953,0.069,NULL,59744275084,933504298,14586004,15.7),(139701,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139701,36.36,0.46,187,67241,70,NULL,NULL,'2MASX J16545544+3845192',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000077,NULL,'17.1g',NULL,NULL,NULL,NULL,NULL,NULL,1,253.730833,38.75542,0.065,NULL,59812036033,934563063,14602547,17.1),(139702,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139702,37.5,0.59,316,67242,70,NULL,NULL,'2MASX J16545599-6236314',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.7335,-62.60872,0.705,NULL,44472523317,694883176,10857549,15.9),(139703,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139703,37.69,0.46,345,67243,70,NULL,NULL,'VII Zw 666',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000084,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.73925,63.46903,0.041,NULL,57542119539,899095617,14048369,17.6),(139704,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139704,33.89,0.48,60.1,67244,70,NULL,NULL,'NGC 6209',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.000033,NULL,'11.41',1.6,'(R\')SAB(rs)b',NULL,NULL,NULL,NULL,1,253.74025,-72.58664,0.257,NULL,44149990970,689843608,10778806,11.41),(139705,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139705,34.49,0.8,79,67244,75,NULL,'MAT, I','NGC 6209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139706,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139706,34.29,0.43,72.3,67244,75,NULL,'MAT, I, raw','NGC 6209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139707,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139707,34.32,0.45,73.2,67244,NULL,NULL,'K','NGC 6209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139708,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139708,34.33,0.47,73.5,67244,NULL,NULL,'H','NGC 6209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139709,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139709,34.35,0.46,74.3,67244,NULL,NULL,'J','NGC 6209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139710,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139710,34.39,0.34,75.3,67244,NULL,NULL,'Malmquist cor.','NGC 6209',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139711,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139711,34.44,0.43,77.1,67244,75,NULL,'MAT, I, cor','NGC 6209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139712,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139712,34.46,0.33,78.1,67244,NULL,NULL,NULL,'NGC 6209',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139713,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139713,34.47,0.32,78.3,67244,85,NULL,'I, raw','NGC 6209',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139714,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139714,34.49,0.4,79.1,67244,NULL,NULL,'mean','NGC 6209',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139715,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139715,34.5,0.2,79.4,67244,74.4,NULL,NULL,'NGC 6209',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139716,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139716,34.56,0.32,81.8,67244,85,NULL,'I, inv','NGC 6209',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139717,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139717,34.67,0.43,85.7,67244,75,NULL,'MAT, I, inv','NGC 6209',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139718,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139718,35.7,NULL,138,67245,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10603',NULL,'2010Ap&SS.325..163P',2010,1,1.37,NULL,'G',0.000023,NULL,'15.8g',0.22,'Sc',NULL,NULL,NULL,NULL,1,253.742583,22.14844,0.241,NULL,56676287159,885566986,13836984,15.8),(139719,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139719,35.7,NULL,138,67245,NULL,NULL,'Dipole + Quadrupole','UGC 10603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139720,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139720,35.71,NULL,138,67245,NULL,NULL,'Dipole','UGC 10603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139721,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139721,35.79,NULL,144,67245,NULL,NULL,NULL,'UGC 10603',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139722,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139722,35.9,0.2,151,67245,74.4,NULL,NULL,'UGC 10603',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139723,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139723,37.71,0.46,349,67246,70,NULL,NULL,'2MASX J16545867+1939153',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,253.7445,19.65433,0.297,NULL,56865048746,888516386,13883068,17.5),(139724,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139724,36.02,0.23,160,67247,70,NULL,NULL,'2MASX J16550437+2710292',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,253.768,27.17469,0.193,NULL,56193089978,878017030,13719016,16.3),(139725,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139725,37.9,0.46,380,67248,70,NULL,NULL,'2MASX J16550493+3139325',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000176,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,253.7705,31.65908,0.049,NULL,56220002874,878437544,13725586,16.8),(139726,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139726,36.54,0.46,203,67249,70,NULL,NULL,'2MASX J16550662+2235074',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000168,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.777583,22.58558,0.229,NULL,56676595397,885571803,13837059,17.1),(139727,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139727,37.19,0.19,274,67250,70,NULL,NULL,'2MASX J16551094+2325475',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,253.795625,23.42992,0.197,NULL,56675458437,885554038,13836781,17),(139728,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139728,36.77,0.46,226,67251,70,NULL,NULL,'2MASX J16551107+2711243',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.7960417,27.19017,0.221,NULL,56193090299,878017035,13719016,17.8),(139729,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139729,38.28,0.46,453,67252,70,NULL,NULL,'2MASX J16551217+2749563',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.80075,27.83225,0.277,NULL,56222992166,878484252,13726316,17.8),(139730,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139730,35.97,0.46,156,67253,70,NULL,NULL,'2MASX J16551394+2512193',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000183,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,253.808083,25.2055,0.213,NULL,56201222972,878144108,13721001,15.8),(139731,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139731,36.63,0.46,212,67254,70,NULL,NULL,'2MASX J16551621+3030435',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000187,NULL,'16.2g',0.33,'E0',NULL,NULL,NULL,NULL,1,253.817417,30.51217,0.125,NULL,56214857995,878357156,13724330,16.2),(139732,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139732,37.13,0.46,267,67255,70,NULL,NULL,'2MASX J16551869+3300306',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,253.828083333,33.00864,0.069,NULL,56207074100,878235532,13722430,16.7),(139733,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139733,36.77,0.73,226,67256,70,NULL,NULL,'2MASX J16551929-6356425',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.830417,-63.94519,0.693,NULL,44465237122,694769330,10855770,16),(139734,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139734,37.76,0.33,357,67257,70,NULL,NULL,'2MASX J16552135+3216176',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.8387917,32.27175,0.085,NULL,56217590526,878399851,13724997,17.8),(139735,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139735,33.6,NULL,52.4,67258,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10616',NULL,'2010Ap&SS.325..163P',2010,1,1.08,'UGC dec. of +58d47\' in error.','G',0.00013,NULL,'17.',0.09,'Sd',NULL,NULL,NULL,NULL,1,253.8420417,58.66014,0,NULL,57702482738,901601292,14087520,17),(139736,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139736,33.62,NULL,52.9,67258,NULL,NULL,'Dipole + Quadrupole','UGC 10616',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139737,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139737,33.63,NULL,53.3,67258,NULL,NULL,'Dipole','UGC 10616',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139738,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139738,33.7,NULL,55,67258,NULL,NULL,NULL,'UGC 10616',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139739,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139739,34.2,0.57,69.1,67259,70,NULL,NULL,'2MASX J16552449-0715255',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00013,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,253.852125,-7.25711,0.869,NULL,46077855278,719966488,11249476,15.2),(139740,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139740,38.19,0.33,434,67260,70,NULL,NULL,'2MASX J16552478+2806123',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,253.853417,28.10333,0.297,NULL,56223044449,878485069,13726329,16.9),(139741,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139741,38.23,0.19,443,67261,70,NULL,NULL,'2MASX J16552554+3124347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000199,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,253.8565,31.40969,0.053,NULL,56219943922,878436623,13725572,16.8),(139742,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139742,38.19,0.33,434,67262,70,NULL,NULL,'2MASX J16552659+2800083',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000163,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.8607083,28.00239,0.297,NULL,56223069088,878485454,13726335,17.5),(139743,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139743,37.84,0.33,370,67263,70,NULL,NULL,'2MASX J16553398+3206387',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000143,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.891458333,32.11086,0.085,NULL,56217677741,878401214,13725018,18.2),(139744,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139744,37.53,0.46,321,67264,70,NULL,NULL,'2MASX J16553601+4446530',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,253.900167,44.7815,0,NULL,59614057451,931469647,14554213,17.2),(139745,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139745,36.02,0.23,160,67265,70,NULL,NULL,'2MASX J16553854+2638307',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,253.9105,26.64197,0.221,NULL,56200096387,878126506,13720726,16.2),(139746,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139746,37.19,0.19,274,67266,70,NULL,NULL,'2MASX J16553911+2317356',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,253.913083,23.29322,0.257,NULL,56675420721,885553448,13836772,17.1),(139747,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139747,37.54,0.46,323,67267,70,NULL,NULL,'2MASX J16554012+3203508',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000136,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,253.9172917,32.06425,0.045,NULL,56217683446,878401303,13725020,17.9),(139748,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139748,37.49,0.46,315,67268,70,NULL,NULL,'2MASXi J1655416+380038',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000076,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.923708333,38.01067,0.089,NULL,59812558773,934571230,14602675,18),(139749,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139749,37.96,0.46,391,67269,70,NULL,NULL,'2MASX J16554262+3304268',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,253.9275417,33.07408,0.069,NULL,56207031656,878234869,13722419,17.4),(139750,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139750,37.59,0.46,330,67270,70,NULL,NULL,'SDSS J165543.54+320232.8',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.7g',0.3,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,253.9314583,32.04247,0.045,NULL,56217695599,878401493,13725023,16.7),(139751,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139751,37.89,0.46,378,67271,70,NULL,NULL,'2MASX J16554546+2608528',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000212,NULL,'16.4g',0.39,NULL,NULL,NULL,NULL,NULL,1,253.9392917,26.14814,0.209,NULL,56200265831,878129153,13720768,16.4),(139752,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139752,37.74,0.46,353,67272,70,NULL,NULL,'2MASX J16554543+2334586',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00018,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,253.9395,23.58281,0.197,NULL,56675468862,885554200,13836784,17.4),(139753,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139753,37.84,0.46,369,67273,70,NULL,NULL,'SDSS J165545.60+323316.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000142,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,253.94,32.55458,0.081,NULL,56206356089,878224313,13722254,18),(139754,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139754,38.77,0.46,568,67274,70,NULL,NULL,'SDSS J165545.77+175803.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0001,NULL,'18.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,253.94075,17.96778,0.369,NULL,56863263112,888488486,13882632,18.4),(139755,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139755,38.23,0.19,443,67275,70,NULL,NULL,'2MASX J16554585+3122048',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,253.9412083,31.36794,0.089,NULL,56217877894,878404342,13725067,17),(139756,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139756,36.96,0.33,247,67276,70,NULL,NULL,'2MASX J16554896+3759232',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.91',0.4,NULL,NULL,NULL,NULL,NULL,1,253.95425,37.98989,0.089,NULL,59812558435,934571225,14602675,16.91),(139757,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139757,37.84,0.33,370,67277,70,NULL,NULL,'2MASX J16555027+3210378',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000147,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,253.959333,32.17714,0.085,NULL,56217800993,878403140,13725049,17.3),(139758,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139758,35.91,0.46,152,67278,70,NULL,NULL,'2MASX J16555032+2726298',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000188,NULL,'15.6g',0.48,NULL,NULL,NULL,NULL,NULL,1,253.9595417,27.44158,0.257,NULL,56193034932,878016170,13719002,15.6),(139759,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139759,34.37,0.2,74.8,67279,74.4,NULL,NULL,'UGC 10619',NULL,'2013AJ....146...86T',2013,1,1.36,NULL,'G',NULL,NULL,'16.5',0.22,'Sd',NULL,NULL,NULL,NULL,1,253.972583333,54.39753,0.009,NULL,57678395800,901224934,14081639,16.5),(139760,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139760,34.38,0.51,75.3,67279,NULL,NULL,NULL,'UGC 10619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139761,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139761,34.52,0.48,80.3,67279,NULL,NULL,'Malmquist cor.','UGC 10619',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139762,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139762,36.92,0.46,242,67280,70,NULL,NULL,'2MASX J16555462+2250496',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,253.977583,22.84708,0.281,NULL,56674763446,885543178,13836612,17),(139763,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139763,37.45,0.84,309,67281,70,NULL,NULL,'2MASX J16555479-6430124',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,'E',NULL,NULL,NULL,NULL,1,253.97825,-64.50344,0.685,NULL,44467978858,694812169,10856440,15.6),(139764,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139764,37.93,0.46,385,67282,70,NULL,NULL,'2MASX J16555567+3849052',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,253.982041667,38.81825,0.069,NULL,59811977867,934562154,14602533,17.7),(139765,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139765,36.94,0.46,245,67283,70,NULL,NULL,'2MASX J16555727+3840152',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000108,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,253.988667,38.67094,0.069,NULL,59812019292,934562801,14602543,16.2),(139766,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139766,35.59,0.52,131,67284,70,NULL,NULL,'2MASX J16560292-6308385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.0122083,-63.14394,0.725,NULL,44473238401,694894350,10857724,15.3),(139767,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139767,36,0.69,159,67285,70,NULL,NULL,'2MASX J16560506-6254415',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.021,-62.9115,0.725,NULL,44472667279,694885426,10857584,15.5),(139768,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139768,37.19,0.19,274,67286,70,NULL,NULL,'2MASX J16560527+2311439',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,254.0217917,23.19569,0.257,NULL,56674829612,885544212,13836628,16.8),(139769,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139769,37.18,0.14,273,67287,70,NULL,NULL,'2MASX J16560862+3925583',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,254.0357083,39.43283,0.069,NULL,59628326317,931692598,14557696,16.6),(139770,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139770,37.7,0.33,347,67288,70,NULL,NULL,'2MASX J16560944+2548152',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000191,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.0394583,25.80422,0.221,NULL,56203641588,878181899,13721592,16.6),(139771,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139771,37.18,0.14,273,67289,70,NULL,NULL,'2MASX J16560978+3916593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000091,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.040833,39.28308,0.069,NULL,59628330478,931692663,14557697,17.3),(139772,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139772,35.44,0.6,122,67290,70,NULL,NULL,'2MASX J16560989-0037126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'16.68',NULL,NULL,NULL,NULL,NULL,NULL,1,254.0410417,-0.62014,0.485,NULL,45202955133,706296173,11035877,16.68),(139773,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139773,38.27,0.46,451,67291,70,NULL,NULL,'SDSS J165609.93+182044.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,254.041417,18.34561,0.357,NULL,56863346584,888489790,13882652,18.4),(139774,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139774,35.98,0.2,157,67292,74.4,NULL,NULL,'UGC 10615',NULL,'2013AJ....146...86T',2013,1,1.12,NULL,'G',0.000033,NULL,'15.3g',0.38,'SBcd:',NULL,NULL,NULL,NULL,1,254.044125,34.8365,0.045,NULL,59744579479,933509054,14586078,15.3),(139775,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139775,37.58,0.46,328,67293,70,NULL,NULL,'2MASX J16561283+4317541',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.053417,43.29847,0,NULL,59635204716,931800073,14559376,17),(139776,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139776,37.03,0.46,255,67294,70,NULL,NULL,'2MASX J16561305+3335258',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,254.054375,33.59058,0.033,NULL,56207637151,878244330,13722567,16.6),(139777,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139777,37.83,0.27,369,67295,70,NULL,NULL,'2MASX J16561306+1829079',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000159,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,254.054583,18.48547,0.357,NULL,56863301361,888489083,13882641,17.1),(139778,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139778,37.19,0.19,274,67296,70,NULL,NULL,'2MASX J16561484+2305339',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,254.061833,23.09281,0.257,NULL,56674865115,885544767,13836636,17.1),(139779,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139779,35.35,0.8,118,67297,75,NULL,'CF, r','IC 1237',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000133,NULL,'14.30',1,'SB(s)c:',NULL,NULL,NULL,NULL,1,254.066875,55.02647,0,NULL,57668859941,901075936,14079311,14.3),(139780,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139780,35.55,0.4,129,67297,NULL,NULL,'mean','IC 1237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139781,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139781,35.62,0.47,133,67297,NULL,NULL,'H','IC 1237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139782,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139782,35.65,0.45,135,67297,NULL,NULL,'K','IC 1237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139783,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139783,35.66,0.46,135,67297,NULL,NULL,'J','IC 1237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139784,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139784,35.79,0.38,144,67297,75,NULL,'CF, r, raw','IC 1237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139785,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139785,35.97,0.38,156,67297,75,NULL,'CF, r, cor','IC 1237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139786,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139786,36.06,0.38,163,67297,75,NULL,'CF, r, inv','IC 1237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139787,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139787,37.12,0.27,266,67298,70,NULL,NULL,'2MASX J16561947+1836329',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000181,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,254.081125,18.60928,0.341,NULL,56864147975,888502312,13882848,16.4),(139788,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139788,37.7,0.33,347,67299,70,NULL,NULL,'2MASX J16562025+2546422',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000132,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.08425,25.77847,0.221,NULL,56203642700,878181917,13721592,18.4),(139789,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139789,36.12,0.46,168,67300,70,NULL,NULL,'2MASX J16562035+3210278',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000184,NULL,'15.6g',0.47,'AGN+SF',NULL,NULL,NULL,NULL,1,254.0847083,32.17428,0.093,NULL,56217777915,878402779,13725043,15.6),(139790,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139790,37.18,0.14,273,67301,70,NULL,NULL,'MCG +07-35-008',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000116,NULL,'15.3g',0.55,'BrClG',NULL,NULL,NULL,NULL,1,254.087875,39.27517,0.069,NULL,59628328481,931692632,14557697,15.3),(139791,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139791,35.33,0.52,117,67302,70,NULL,NULL,'2MASX J16562225-6235575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.092583333,-62.59931,0.705,NULL,44472502126,694882845,10857544,15.2),(139792,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139792,37.89,0.46,379,67303,70,NULL,NULL,'2MASX J16562251+1931489',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.093791667,19.53019,0.297,NULL,56872941012,888639703,13884995,17.6),(139793,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139793,36.38,0.46,189,67304,70,NULL,NULL,'2MASX J16562575+4058444',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000076,NULL,'16.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.1075,40.97892,0.069,NULL,59636353115,931818017,14559656,16.6),(139794,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139794,37.18,0.14,273,67305,70,NULL,NULL,'2MASX J16562623+3916293',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000083,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,254.1092917,39.27481,0.069,NULL,59628382617,931693478,14557710,18.2),(139795,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139795,38.09,0.46,416,67306,70,NULL,NULL,'SDSS J165628.07+313240.3',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.29,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,254.1169583,31.54456,0.089,NULL,56218089044,878407641,13725119,16.9),(139796,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139796,37.83,0.27,369,67307,70,NULL,NULL,'2MASX J16562888+1830418',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000189,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.120333,18.51172,0.357,NULL,56863306055,888489157,13882643,17.1),(139797,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139797,37.69,0.46,345,67308,70,NULL,NULL,'2MASX J16562970+3303458',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000204,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,254.123791667,33.06267,0.069,NULL,56206936785,878233387,13722396,16),(139798,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139798,38.38,0.46,475,67309,70,NULL,NULL,'2MASX J16563044+4418573',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.126958333,44.31586,0,NULL,59643620089,931931563,14561430,17),(139799,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:58','1','SN 2007hu',NULL,139799,35.97,0.26,151,67310,73.8,NULL,'SALT 2 (SNANA)','NGC 6261',0.0356,'2014ApJ...795...44R',2014,1,1.21,NULL,'G',0.000103,NULL,'14.5g',0.57,'S0/a',NULL,NULL,NULL,NULL,1,254.127167,27.9775,0.297,NULL,56222844293,878481942,13726280,14.5),(139800,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139800,36.63,0.46,212,67311,70,NULL,NULL,'2MASX J16563061+4153503',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000073,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,254.1277083,41.89742,0,NULL,59638467898,931851060,14560172,16.8),(139801,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139801,37.12,0.27,266,67312,70,NULL,NULL,'SDSS J165631.62+183538.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.1317917,18.59403,0.341,NULL,56863295131,888488986,13882640,17.7),(139802,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139802,36.88,0.46,237,67313,70,NULL,NULL,'2MASX J16563453+3413518',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000128,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.143833333,34.23114,0.049,NULL,56204146877,878189794,13721715,17.6),(139803,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139803,37.18,0.14,273,67314,70,NULL,NULL,'2MASX J16563495+3921097',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000091,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.1455417,39.35275,0.069,NULL,59628333765,931692715,14557698,17.3),(139804,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139804,37.18,0.14,273,67315,70,NULL,NULL,'2MASX J16563668+3919377',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,254.152917,39.32708,0.069,NULL,59628333250,931692707,14557698,16.3),(139805,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139805,35.77,NULL,143,67316,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2092',NULL,'2010Ap&SS.325..163P',2010,1,0.76,NULL,'G',NULL,NULL,'17.15',0.08,'Scd',NULL,NULL,NULL,NULL,1,254.159167,59.82472,0.029,NULL,57657280698,900895010,14076484,17.15),(139806,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139806,35.8,NULL,145,67316,NULL,NULL,'Dipole + Quadrupole','FGC 2092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139807,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139807,35.81,NULL,145,67316,NULL,NULL,NULL,'FGC 2092',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139808,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139808,35.82,NULL,146,67316,NULL,NULL,'Dipole','FGC 2092',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139809,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139809,32.44,NULL,30.7,67317,72,NULL,NULL,'HIPASS J1656+08',NULL,'2014Ap.....57..457K',2014,1,1.1,NULL,'G',0.000007,NULL,'17.0',0.85,'Sm?',NULL,NULL,NULL,NULL,1,254.1605,7.99872,0.417,NULL,56733993651,886468650,13851072,17),(139810,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139810,37.45,0.46,309,67318,70,NULL,NULL,'2MASX J16563965+3248088',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,254.165375,32.80239,0.069,NULL,56206522141,878226908,13722295,17.1),(139811,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139811,37.83,0.27,369,67319,70,NULL,NULL,'2MASX J16564153+1830492',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,'PRED','17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.173166667,18.51367,0.357,NULL,56863303297,888489114,13882642,17.5),(139812,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139812,35.64,0.46,134,67320,70,NULL,NULL,'CGCG 139-023',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00011,NULL,'15.1g',0.51,NULL,NULL,NULL,NULL,NULL,1,254.174375,26.83847,0.197,NULL,56192551865,878008622,13718884,15.1),(139813,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139813,36.72,0.6,221,67321,70,NULL,NULL,'2MASX J16564214-6057233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.175625,-60.95653,1.029,NULL,44500784796,695324762,10864449,15.6),(139814,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139814,35.36,0.25,118,67322,74.4,NULL,NULL,'NGC 6263',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000087,NULL,'14.66',0.9,'E',NULL,NULL,NULL,NULL,1,254.18,27.82208,0.277,NULL,56192906168,878014158,13718971,14.66),(139815,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139815,35.55,0.16,129,67322,70,NULL,NULL,'NGC 6263',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139816,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139816,35.86,0.4,148,67322,NULL,NULL,'mean','NGC 6263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139817,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139817,36.39,0.45,190,67322,NULL,NULL,'K','NGC 6263',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139818,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139818,37.18,0.14,273,67323,70,NULL,NULL,'2MASX J16564504+3920358',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000079,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.187667,39.34328,0.069,NULL,59628333375,931692708,14557698,17.1),(139819,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139819,35.39,0.72,120,67324,70,NULL,NULL,'2MASX J16564648-0157432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.193625,-1.962,0.505,NULL,45222882252,706607535,11040742,15),(139820,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139820,37.95,0.46,389,67325,70,NULL,NULL,'2MASX J16564676+3502538',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000188,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,254.194917,35.04806,0.057,NULL,59743839340,933497489,14585898,16.8),(139821,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139821,37.74,0.33,353,67326,70,NULL,NULL,'2MASX J16564813+3242408',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000133,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,254.2004583,32.71147,0.081,NULL,56206554407,878227412,13722303,17.1),(139822,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139822,37.9,0.46,381,67327,70,NULL,NULL,'2MASX J16564822+3612178',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.2010417,36.20511,0.065,NULL,59811818802,934559668,14602494,17.5),(139823,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139823,37.65,0.33,338,67328,70,NULL,NULL,'2MASX J16565049+6227160',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000074,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.210417,62.45453,0.029,NULL,57534631588,898978618,14046540,17.2),(139824,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139824,36.29,0.33,181,67329,70,NULL,NULL,'2MASX J16565288+2726379',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000171,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,254.220333,27.444,0.225,NULL,56192947597,878014806,13718981,16.6),(139825,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139825,37.18,0.14,273,67330,70,NULL,NULL,'2MASXi J1656545+391720',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.227125,39.28908,0.069,NULL,59628378656,931693416,14557709,17.4),(139826,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139826,37.05,0.46,257,67331,70,NULL,NULL,'2MASX J16565530+3152558',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000134,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.23025,31.88208,0.085,NULL,56218114996,878408046,13725125,18),(139827,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139827,38.22,0.27,441,67332,70,NULL,NULL,'2MASX J16565634+3233008',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.234917,32.55025,0.081,NULL,56206407564,878225118,13722267,18.1),(139828,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139828,37.74,0.33,353,67333,70,NULL,NULL,'2MASX J16565820+3244428',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,254.2425,32.74531,0.081,NULL,56206554680,878227416,13722303,18),(139829,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139829,33.57,0.48,51.8,67334,70,NULL,NULL,'ESO 101- G 018',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00015,NULL,'13.27',1,'SB(rs)0/a',NULL,NULL,NULL,NULL,1,254.248625,-65.95292,0.497,NULL,44988151552,702939868,10983435,13.27),(139830,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139830,37.8,0.46,364,67335,70,NULL,NULL,'2MASX J16565988+6244001',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,254.249625,62.73331,0.037,NULL,57542290585,899098290,14048410,18.2),(139831,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139831,35.4,0.75,120,67336,70,NULL,NULL,'2MASX J16570093-0650580',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,254.2539583,-6.84947,0.877,NULL,45193314949,706145546,11033524,14.6),(139832,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139832,38.27,0.21,450,67337,70,NULL,NULL,'SDSS J165701.20+625026.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000075,NULL,'18.7g',0.12,'NLAGN',NULL,NULL,NULL,'Sy 2',1,254.2550417,62.84056,0.037,NULL,57542268329,899097942,14048405,18.7),(139833,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139833,37.33,0.2,292,67338,74.4,NULL,NULL,'UGC 10620',NULL,'2013AJ....146...86T',2013,1,0.84,NULL,'G',0.000164,NULL,'16.2g',0.32,'S?',NULL,NULL,NULL,NULL,1,254.255541667,31.25333,0.101,NULL,56213416178,878334627,13723978,16.2),(139834,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139834,38,0.46,397,67339,70,NULL,NULL,'2MASX J16570271+2224077',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000133,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.261333333,22.40208,0.249,NULL,56676248552,885566383,13836974,18.2),(139835,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139835,34.59,NULL,82.9,67340,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2098',NULL,'2010Ap&SS.325..163P',2010,1,0.8,NULL,'G',NULL,NULL,'17.0',0.08,'Sd',NULL,NULL,NULL,NULL,1,254.27,77.14111,0.145,NULL,57066739221,891667800,13932309,17),(139836,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139836,34.62,NULL,84,67340,NULL,NULL,'Dipole + Quadrupole','FGC 2098',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139837,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139837,34.63,NULL,84.4,67340,NULL,NULL,'Dipole','FGC 2098',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139838,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139838,34.67,NULL,86,67340,NULL,NULL,NULL,'FGC 2098',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139839,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139839,36.27,0.5,180,67341,70,NULL,NULL,'2MASX J16570509-7137479',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.271375,-71.62992,0.533,NULL,44095633685,688994276,10765535,13.9),(139840,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139840,36.25,0.56,178,67342,70,NULL,NULL,'2MASX J16570559-5951145',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.2734583,-59.85411,0.873,NULL,44501073412,695329272,10864519,15.9),(139841,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139841,36.13,0.54,168,67343,70,NULL,NULL,'2MASX J16570573-7552586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,254.273875,-75.88292,0.189,NULL,44142799480,689731241,10777050,16.3),(139842,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139842,37.3,0.46,288,67344,70,NULL,NULL,'2MASX J16570843+2401099',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,254.285083,24.01964,0.221,NULL,56189059997,877954062,13718032,17.6),(139843,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139843,37.18,0.14,273,67345,70,NULL,NULL,'2MASX J16570855+3910588',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000098,NULL,'16.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.285541667,39.18303,0.069,NULL,59628375774,931693371,14557708,16.7),(139844,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139844,36.51,0.86,200,67346,70,NULL,NULL,'2MASX J16570887-0142268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.286916667,-1.70744,0.509,NULL,45222424629,706600384,11040631,15.7),(139845,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139845,36.63,0.6,212,67347,70,NULL,NULL,'2MASX J16571044-5928405',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.293333,-59.47794,0.801,NULL,44554471384,696163615,10877556,15.7),(139846,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139846,36.29,0.33,181,67348,70,NULL,NULL,'2MASX J16571205+2730409',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000164,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,254.300167,27.5115,0.225,NULL,56192951098,878014860,13718982,16.3),(139847,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139847,38.71,0.46,552,67349,70,NULL,NULL,'SDSS J165713.36+255656.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000161,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.305708333,25.94903,0.225,NULL,56203634901,878181795,13721590,18.4),(139848,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139848,34.95,0.52,97.7,67350,70,NULL,NULL,'2MASX J16571426-0613510',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.309458333,-6.23086,0.925,NULL,45192953414,706139897,11033435,14),(139849,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139849,36.02,0.23,160,67351,70,NULL,NULL,'2MASX J16571499+2650107',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000171,NULL,'16.0g',0.33,NULL,NULL,NULL,NULL,NULL,1,254.312375,26.83633,0.197,NULL,56192437986,878006843,13718856,16),(139850,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139850,36.84,0.46,233,67352,70,NULL,NULL,'2MASX J16571515+3648346',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.313041667,36.80975,0.061,NULL,59811298450,934551538,14602367,16.8),(139851,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139851,34.55,0.49,81.2,67353,75,NULL,'IR','UGC 10627',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00004,NULL,'15.41',0.3,'Scd:           AGN?','Isolated galaxy',NULL,NULL,NULL,1,254.314333,46.87461,0.037,NULL,59615005559,931484461,14554444,15.41),(139852,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139852,35.11,0.4,105,67353,NULL,NULL,'mean','UGC 10627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139853,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139853,35.13,0.47,106,67353,NULL,NULL,'H','UGC 10627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139854,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139854,35.2,0.45,110,67353,NULL,NULL,'K','UGC 10627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139855,'Maser','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139855,35.79,0.27,144,67354,NULL,NULL,NULL,'NGC 6264',NULL,'2013ApJ...767..155K',2013,1,0.81,'HOLM 763B is a star.','G',0.000093,NULL,'15.2g',0.58,'Sb             Sy2','Group member',NULL,NULL,'Sy 2',1,254.3172083,27.84961,0.261,NULL,56192884579,878013821,13718965,15.2),(139856,'Maser','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139856,35.89,0.43,151,67354,NULL,NULL,NULL,'NGC 6264',NULL,'2011PhDT.......205K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139857,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139857,37.12,0.27,266,67355,70,NULL,NULL,'2MASX J16571884+1839047',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00019,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,254.328625,18.65133,0.341,NULL,56871426309,888616036,13884625,18.1),(139858,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139858,38.22,0.27,441,67356,70,NULL,NULL,'2MASX J16571921+3227274',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.3302083,32.45761,0.093,NULL,56217723713,878401933,13725030,17.6),(139859,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139859,36.42,0.81,192,67357,70,NULL,NULL,'2MASX J16572087-6017565',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.337083,-60.29908,0.897,NULL,44501183561,695330993,10864546,15.9),(139860,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139860,38.99,0.46,629,67358,70,NULL,NULL,'2MASX J16572245+2609227',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.343625,26.15633,0.209,NULL,56202972903,878171451,13721428,18),(139861,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139861,31.99,NULL,25,67359,NULL,NULL,NULL,'UGC 10625',NULL,'2000BSAO...50....5K',2000,1,1.7,NULL,'G',0.000023,NULL,'16.5',0.22,'Sdm',NULL,NULL,NULL,NULL,1,254.347417,38.67119,0.069,NULL,59628448359,931694505,14557726,16.5),(139862,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139862,32.06,NULL,25.8,67359,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139863,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139863,32.08,NULL,26.1,67359,NULL,NULL,'Dipole + Quadrupole','UGC 10625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139864,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139864,32.09,NULL,26.2,67359,NULL,NULL,'Dipole','UGC 10625',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139865,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139865,33.23,0.2,44.3,67359,74.4,NULL,NULL,'UGC 10625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139866,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139866,35.97,0.57,156,67360,70,NULL,NULL,'2MASX J16572382-0147498',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.3492083,-1.79719,0.509,NULL,45222353013,706599265,11040613,14.9),(139867,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139867,36.06,0.33,163,67361,70,NULL,NULL,'2MASX J16572463+2743337',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.352625,27.72597,0.233,NULL,56192815903,878012748,13718949,16.5),(139868,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139868,35.85,0.46,148,67362,70,NULL,NULL,'2MASX J16572567+2441007',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000103,NULL,'16.1g',0.39,NULL,NULL,NULL,NULL,NULL,1,254.356917,24.68347,0.201,NULL,56189854701,877966479,13718226,16.1),(139869,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139869,36.27,0.46,179,67363,70,NULL,NULL,'2MASX J16572738+4042347',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000067,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.364125,40.70956,0.073,NULL,59636698696,931823417,14559740,16.8),(139870,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139870,37.2,0.46,275,67364,70,NULL,NULL,'2MASX J16572875+6355040',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000114,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,254.3697917,63.91789,0.025,NULL,57540254145,899066471,14047913,16.8),(139871,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139871,35.35,0.25,117,67365,74.4,NULL,NULL,'NGC 6265',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00007,NULL,'15.22',0.5,'S0','Group member',NULL,NULL,NULL,1,254.37125,27.84422,0.261,NULL,56192891687,878013932,13718967,15.22),(139872,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139872,35.55,0.16,129,67365,70,NULL,NULL,'NGC 6265',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139873,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139873,38.27,0.21,450,67366,70,NULL,NULL,'SDSS J165730.17+625225.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000077,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,254.37575,62.87372,0.037,NULL,57542274910,899098045,14048406,18),(139874,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,NULL,139874,37.4,0.72,302,67367,70,NULL,NULL,'2MASX J16573228-6249464',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.38475,-62.82956,0.725,NULL,44472654029,694885219,10857581,16),(139875,'FP','2016-12-15 15:15:44','2016-12-16 11:20:58','1',NULL,'R',139875,37.8,0.46,363,67368,70,NULL,NULL,'2MASX J16573279+3214347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.386583333,32.24303,0.093,NULL,56218249709,878410151,13725158,17.3),(139876,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139876,37.23,0.23,279,67369,70,NULL,NULL,'2MASX J16573310+3239297',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.3877917,32.65842,0.081,NULL,56206384665,878224760,13722261,17),(139877,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139877,37.97,0.46,393,67370,70,NULL,NULL,'SDSS J165734.38+274442.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'19.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,254.3932917,27.74517,0.233,NULL,56192818294,878012785,13718949,19),(139878,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139878,38.27,0.21,450,67371,70,NULL,NULL,'2MASX J16573491+6252210',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000084,NULL,'17.2g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,254.395375,62.8725,0.037,NULL,57542275051,899098047,14048406,17.2),(139879,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139879,37.99,0.46,396,67372,70,NULL,NULL,'2MASX J16573491+3450147',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.3954583,34.83739,0.045,NULL,59743825371,933497271,14585894,17.5),(139880,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139880,38,0.46,398,67373,70,NULL,NULL,'2MASX J16573511+1734049',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.39625,17.56819,0.301,NULL,56900995057,889078047,13891844,17.7),(139881,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139881,36.89,0.46,239,67374,70,NULL,NULL,'2MASX J16573600+3222597',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000137,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.399916667,32.38325,0.093,NULL,56217709385,878401709,13725026,17.2),(139882,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139882,36.97,0.46,247,67375,70,NULL,NULL,'2MASX J16573638+3158257',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,254.4017083,31.97381,0.085,NULL,56218345387,878411646,13725181,17),(139883,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139883,37.74,0.46,354,67376,70,NULL,NULL,'SDSS J165738.00+260536.8',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.408333,26.09361,0.209,NULL,56203562332,878180661,13721572,17.5),(139884,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139884,38.02,0.46,402,67377,70,NULL,NULL,'2MASX J16573803+2540027',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.408583333,25.66756,0.253,NULL,56202802613,878168790,13721387,17.5),(139885,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139885,38.22,0.27,441,67378,70,NULL,NULL,'2MASX J16574040+3232048',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.4184583,32.53475,0.081,NULL,56206415473,878225241,13722269,17.2),(139886,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139886,37.79,0.17,361,67379,70,NULL,NULL,'2MASX J16574053+3124338',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,'FoF','16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,254.418875,31.40939,0.089,NULL,56213588208,878337315,13724020,16.6),(139887,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139887,35.26,0.33,113,67380,70,NULL,NULL,'CGCG 225-017',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.000093,NULL,'14.8g',0.61,'E','in a triple',NULL,NULL,NULL,1,254.419667,40.72236,0.073,NULL,59636695575,931823368,14559740,14.8),(139888,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139888,37.26,0.46,283,67381,70,NULL,NULL,'2MASX J16574192+3138218',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000161,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.4245417,31.63933,0.089,NULL,56217960327,878405630,13725087,17.1),(139889,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139889,35.36,0.25,118,67382,74.4,NULL,NULL,'GIN 632',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00007,NULL,'16.2g',0.35,'E',NULL,NULL,NULL,NULL,1,254.428583,27.65925,0.233,NULL,56192857603,878013400,13718959,16.2),(139890,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139890,35.55,0.16,129,67382,70,NULL,NULL,'GIN 632',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139891,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139891,36.06,0.33,163,67382,70,NULL,NULL,'GIN 632',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139892,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139892,37.79,0.17,361,67383,70,NULL,NULL,'2MASX J16574654+3124348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.444,31.40969,0.089,NULL,56213595350,878337427,13724022,18),(139893,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139893,38.27,0.21,450,67384,70,NULL,NULL,'SDSS J165748.20+624733.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000081,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,254.450917,62.79275,0.037,NULL,57542311592,899098618,14048415,18.5),(139894,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139894,35.94,0.33,154,67385,70,NULL,NULL,'CGCG 225-018',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000069,NULL,'15.6g',0.44,'S0^-',NULL,NULL,NULL,NULL,1,254.45675,39.21689,0.069,NULL,59628537685,931695901,14557748,15.6),(139895,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139895,37.79,0.17,361,67386,70,NULL,NULL,'2MASX J16575178+3128058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000191,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,254.465708333,31.46814,0.089,NULL,56213536080,878336501,13724007,17.5),(139896,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139896,35.36,0.25,118,67387,74.4,NULL,NULL,'MRK 1113',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000047,NULL,'14.04',0.7,'E/S0',NULL,NULL,NULL,NULL,1,254.470667,28.12811,0.261,NULL,56194767809,878043247,13719425,14.04),(139897,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139897,35.55,0.16,129,67387,70,NULL,NULL,'MRK 1113',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139898,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139898,35.37,0.25,119,67388,74.4,NULL,NULL,'GIN 631',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000093,NULL,'15.26',0.4,'S',NULL,NULL,NULL,NULL,1,254.480375,27.69908,0.233,NULL,56192852235,878013316,13718958,15.26),(139899,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139899,35.55,0.16,129,67388,70,NULL,NULL,'GIN 631',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139900,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139900,35.94,0.33,154,67389,70,NULL,NULL,'CGCG 225-019',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00012,NULL,'15.4g',0.43,'S0',NULL,NULL,NULL,NULL,1,254.487333,39.25533,0.069,NULL,59628536110,931695876,14557748,15.4),(139901,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139901,35.37,0.25,119,67390,74.4,NULL,NULL,'NGC 6269',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000043,NULL,'13.32',1.6,'cD;E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,254.4920417,27.85433,0.261,NULL,56192811169,878012674,13718948,13.32),(139902,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139902,35.55,0.16,129,67390,70,NULL,NULL,'NGC 6269',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139903,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139903,35.09,0.45,104,67390,NULL,NULL,'K','NGC 6269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139904,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139904,35.87,0.4,149,67390,NULL,NULL,'mean','NGC 6269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139905,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139905,34.48,0.8,78.7,67391,75,NULL,'MAT, I','ESO 101- G 020',NULL,'1997ApJS..109..333W',1997,1,1.9,'6dF DR2 has z = 0.016743.','G',0.000033,NULL,'13.44',0.9,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,254.4942083,-62.72597,0.705,NULL,44472657470,694885272,10857582,13.44),(139906,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139906,33.12,0.43,42.1,67391,75,NULL,'MAT, I, raw','ESO 101- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139907,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139907,33.12,0.32,42.1,67391,85,NULL,'I, raw','ESO 101- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139908,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139908,33.17,0.32,43.1,67391,85,NULL,'I, inv','ESO 101- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139909,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139909,33.35,0.43,46.8,67391,75,NULL,'MAT, I, inv','ESO 101- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139910,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139910,33.44,0.43,48.7,67391,75,NULL,'MAT, I, cor','ESO 101- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139911,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139911,36.91,0.46,241,67392,70,NULL,NULL,'2MASX J16580025+6137033',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000063,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.5009583,61.61756,0.029,NULL,57536854465,899013351,14047083,17.3),(139912,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139912,37.79,0.17,361,67393,70,NULL,NULL,'2MASX J16580030+3128158',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.6g',0.27,'BrClG',NULL,NULL,NULL,NULL,1,254.501125,31.47106,0.089,NULL,56213525947,878336342,13724005,16.6),(139913,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139913,37.65,0.33,338,67394,70,NULL,NULL,'2MASX J16580049+6222403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000088,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.501833,62.37778,0.029,NULL,57534820834,898981575,14046587,17.6),(139914,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139914,37.79,0.17,361,67395,70,NULL,NULL,'2MASX J16580110+3136578',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000197,NULL,'16.1g',0.4,NULL,NULL,NULL,NULL,NULL,1,254.504667,31.61617,0.089,NULL,56217948566,878405446,13725085,16.1),(139915,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139915,36.21,0.46,175,67396,70,NULL,NULL,'2MASX J16580262+2209371',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000166,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,254.51075,22.16022,0.229,NULL,56676353161,885568018,13837000,16.4),(139916,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139916,37.76,0.46,357,67397,70,NULL,NULL,'SDSS J165804.15+342316.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,254.517333333,34.38783,0.049,NULL,56204717493,878198710,13721854,18.2),(139917,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139917,37.19,0.46,274,67398,70,NULL,NULL,'2MASX J16580504+3219047',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.520833,32.31789,0.093,NULL,56218235834,878409934,13725155,17.7),(139918,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139918,37.2,0.46,276,67399,70,NULL,NULL,'2MASX J16580635+6446244',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000098,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,254.5265417,64.77336,0.045,NULL,57538176166,899034002,14047406,16.5),(139919,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139919,34.28,NULL,71.8,67400,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10641',NULL,'2010Ap&SS.325..163P',2010,1,1.44,NULL,'G',0.000063,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,254.5269583,58.88564,0.017,NULL,57702922767,901608168,14087627,16.5),(139920,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139920,34.29,NULL,72.2,67400,NULL,NULL,'Dipole + Quadrupole','UGC 10641',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139921,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139921,34.3,NULL,72.6,67400,NULL,NULL,'Dipole','UGC 10641',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139922,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139922,34.35,NULL,74.2,67400,NULL,NULL,NULL,'UGC 10641',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139923,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139923,34.58,0.67,82.3,67400,NULL,NULL,NULL,'UGC 10641',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139924,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139924,34.62,0.2,84,67400,74.4,NULL,NULL,'UGC 10641',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139925,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139925,34.7,0.63,87.3,67400,NULL,NULL,'Malmquist cor.','UGC 10641',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139926,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139926,38.73,0.46,557,67401,70,NULL,NULL,'2MASX J16580677+4035244',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000094,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.528416667,40.59008,0.073,NULL,59636672269,931823004,14559734,17.6),(139927,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139927,37.79,0.17,361,67402,70,NULL,NULL,'2MASX J16580785+3135429',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.53275,31.59536,0.089,NULL,56213508347,878336067,13724001,17.2),(139928,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139928,36.39,0.46,190,67403,70,NULL,NULL,'2MASX J16580813+3758124',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000094,NULL,'16.1g',0.29,'S0',NULL,NULL,NULL,NULL,1,254.533916667,37.97008,0.077,NULL,59628807473,931700116,14557814,16.1),(139929,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139929,36.69,0.46,217,67404,70,NULL,NULL,'2MASX J16580847+2253432',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.535167,22.89539,0.273,NULL,56677579782,885587184,13837299,16.9),(139930,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139930,38.05,0.46,408,67405,70,NULL,NULL,'2MASX J16580852+3252419',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.535583,32.87819,0.077,NULL,56206577070,878227766,13722308,17.6),(139931,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139931,35.26,0.33,113,67406,70,NULL,NULL,'2MASX J16580851+4053445',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00009,NULL,'15.7g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,254.535625,40.89569,0.069,NULL,59636505562,931820399,14559693,15.7),(139932,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139932,33.39,0.4,47.7,67407,NULL,NULL,'mean','NGC 6267',NULL,'2007A&A...465...71T',2007,1,1.3,'HOLM 764B is a star.','G',0.000007,NULL,'13.92',1,'SB(r)bc','in a pair',NULL,NULL,NULL,1,254.536083,22.98511,0.273,NULL,56677456563,885585258,13837269,13.92),(139933,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139933,33.74,0.46,55.9,67407,NULL,NULL,'J','NGC 6267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139934,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139934,33.75,0.47,56.1,67407,NULL,NULL,'H','NGC 6267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139935,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139935,33.75,0.45,56.1,67407,NULL,NULL,'K','NGC 6267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139936,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139936,36.64,0.58,213,67408,70,NULL,NULL,'2MASX J16581133-6111214',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.547375,-61.18931,1.029,NULL,44471735134,694870861,10857357,16),(139937,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139937,38.49,0.33,500,67409,70,NULL,NULL,'2MASX J16581462+3151329',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.5612083,31.85925,0.085,NULL,56218219347,878409677,13725151,18.1),(139938,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139938,37.5,0.46,316,67410,70,NULL,NULL,'2MASX J16581535+3324489',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,254.563833,33.41353,0.061,NULL,56207277990,878238718,13722479,17.3),(139939,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139939,36.14,0.46,169,67411,70,NULL,NULL,'2MASX J16581783+2512340',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.0g',0.35,NULL,NULL,NULL,NULL,NULL,1,254.574417,25.20953,0.225,NULL,56200833386,878138021,13720906,16),(139940,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139940,36.24,0.93,177,67412,70,NULL,NULL,'2MASX J16582281-0032033',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,254.5950417,-0.53431,0.501,NULL,45205532687,706336448,11036507,14.6),(139941,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139941,37.79,0.17,361,67413,70,NULL,NULL,'2MASX J16582436+3138480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000159,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,254.601583,31.64664,0.089,NULL,56213510993,878336109,13724001,17.9),(139942,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139942,35.98,0.33,157,67414,70,NULL,NULL,'CGCG 197-021',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000186,NULL,'15.3g',0.46,'E0',NULL,NULL,NULL,NULL,1,254.609375,33.03758,0.069,NULL,56206622304,878228473,13722319,15.3),(139943,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139943,38.38,0.46,474,67415,70,NULL,NULL,'2MASX J16582757+3206190',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,254.615,32.10536,0.093,NULL,56218289077,878410766,13725168,17.9),(139944,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139944,37.35,0.46,296,67416,70,NULL,NULL,'2MASX J16582954+2713391',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.623167,27.22753,0.225,NULL,56194386268,878037285,13719332,18),(139945,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139945,37.42,0.46,305,67417,70,NULL,NULL,'2MASX J16582978+3539440',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,254.62425,35.66233,0.049,NULL,59811021571,934547212,14602300,17.2),(139946,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139946,36.01,0.46,160,67418,70,NULL,NULL,'CGCG 139-026',NULL,'2015arXiv151105856S',2015,1,0.74,NULL,'G',0.0001,NULL,'15.2g',0.54,'S0',NULL,NULL,NULL,NULL,1,254.6252083,25.39025,0.225,NULL,56200816328,878137755,13720902,15.2),(139947,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139947,34.7,0.47,86.9,67419,NULL,NULL,'H','ESO 453- G 013',NULL,'2007A&A...465...71T',2007,1,1.3,'abs(b) < 10 degrees.','G',0.000033,NULL,'9.86K',0.7,'(R\')SB(s)bc:',NULL,NULL,NULL,NULL,1,254.626166667,-28.48572,NULL,NULL,45818877037,715919953,11186249,9.86),(139948,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139948,34.71,0.46,87.3,67419,NULL,NULL,'J','ESO 453- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139949,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139949,34.76,0.4,89.6,67419,NULL,NULL,'mean','ESO 453- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139950,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139950,34.77,0.45,89.8,67419,NULL,NULL,'K','ESO 453- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139951,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139951,38.49,0.33,500,67420,70,NULL,NULL,'2MASX J16583095+3157100',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000199,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,254.628875,31.95272,0.093,NULL,56218185167,878409143,13725142,17),(139952,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139952,34.73,0.4,88.3,67421,NULL,NULL,'mean','UGC 10648',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000037,NULL,'15.10',0.7,'SB(s)b',NULL,NULL,NULL,NULL,1,254.637583333,59.75472,0.045,NULL,57658324826,900911325,14076739,15.1),(139953,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139953,34.99,0.47,99.5,67421,NULL,NULL,'H','UGC 10648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139954,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139954,36.92,0.33,242,67422,70,NULL,NULL,'2MASX J16583382+2515201',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.6409583,25.25553,0.225,NULL,56200853849,878138341,13720911,17.6),(139955,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139955,37.81,0.46,365,67423,70,NULL,NULL,'SDSS J165834.16+213208.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000147,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,254.642333,21.53569,0.281,NULL,56859943553,888436618,13881822,18.7),(139956,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139956,34.25,NULL,70.8,67424,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 069- G 016',NULL,'2010Ap&SS.325..163P',2010,1,1.68,NULL,'G',0.000033,NULL,'16.5b',0.22,'Sc',NULL,NULL,NULL,NULL,1,254.6452917,-71.46,0.497,NULL,44095370230,688990159,10765471,16.5),(139957,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139957,34.26,NULL,71.1,67424,NULL,NULL,'Dipole + Quadrupole','ESO 069- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139958,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139958,34.27,NULL,71.4,67424,NULL,NULL,'Dipole','ESO 069- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139959,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139959,34.32,NULL,73,67424,NULL,NULL,NULL,'ESO 069- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139960,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139960,34.37,0.47,74.8,67424,NULL,NULL,'Malmquist cor.','ESO 069- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139961,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139961,34.54,0.43,81.1,67424,NULL,NULL,NULL,'ESO 069- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139962,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139962,34.58,0.2,82.4,67424,74.4,NULL,NULL,'ESO 069- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139963,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139963,35.98,0.33,157,67425,70,NULL,NULL,'2MASX J16583592+3305049',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.649583,33.08467,0.069,NULL,56206613044,878228328,13722317,16.8),(139964,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139964,37.96,0.46,390,67426,70,NULL,NULL,'2MASX J16583720+1930379',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000169,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.654875,19.51069,0.377,NULL,56874085362,888657583,13885274,17.9),(139965,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139965,36.73,0.46,222,67427,70,NULL,NULL,'UGC 10637',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000171,NULL,'16.2g',0.31,'S',NULL,NULL,NULL,NULL,1,254.66325,31.97406,0.093,NULL,56218185228,878409144,13725142,16.2),(139966,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139966,37.31,0.46,290,67428,70,NULL,NULL,'2MASX J16583958+4021014',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.665,40.35042,0.073,NULL,59636639972,931822499,14559726,17.2),(139967,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139967,35.04,0.56,102,67429,70,NULL,NULL,'2MASX J16584191-8159529',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,254.674833,-81.99808,0.337,NULL,44056841971,688388155,10756064,16.5),(139968,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139968,35.32,0.53,116,67430,70,NULL,NULL,'2MASX J16584401-0139597',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,254.683333,-1.66653,0.517,NULL,45221189945,706581092,11040329,13.9),(139969,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139969,35.35,0.25,117,67431,74.4,NULL,NULL,'NGC 6270',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00008,NULL,'14.32',0.4,'E/S0',NULL,NULL,NULL,NULL,1,254.6835417,27.85911,0.261,NULL,56194868157,878044814,13719450,14.32),(139970,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139970,35.55,0.16,129,67431,70,NULL,NULL,'NGC 6270',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139971,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139971,35.26,0.46,112,67432,70,NULL,NULL,'2MASX J16584448+3946585',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000081,NULL,'15.7g',0.48,'E',NULL,NULL,NULL,NULL,1,254.685375,39.78294,0.077,NULL,59640040812,931875637,14560556,15.7),(139972,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139972,36.71,0.45,220,67433,NULL,NULL,'Malmquist cor.','2MASX J16584688+7825211',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.000023,NULL,'15.5V',NULL,'Sc             AGN',NULL,NULL,NULL,NULL,1,254.6952083,78.42267,0.161,NULL,57140105412,892814147,13950221,15.5),(139973,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139973,36.92,0.41,242,67433,NULL,NULL,NULL,'2MASX J16584688+7825211',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139974,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139974,36.96,0.2,247,67433,74.4,NULL,NULL,'2MASX J16584688+7825211',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139975,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139975,38.27,0.21,450,67434,70,NULL,NULL,'2MASX J16584721+6256245',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.5g',0.23,'E              AGN',NULL,NULL,NULL,NULL,1,254.6965,62.94017,0.017,NULL,57542570454,899102663,14048479,17.5),(139976,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139976,37.23,0.23,279,67435,70,NULL,NULL,'2MASX J16584966+3231032',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,254.706958333,32.51758,0.081,NULL,56205917369,878217458,13722147,17.2),(139977,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139977,35,0.46,99.9,67436,70,NULL,NULL,'CGCG 225-021',NULL,'2015arXiv151105856S',2015,1,0.86,NULL,'G',0.000097,NULL,'14.5g',0.81,'E0',NULL,NULL,NULL,NULL,1,254.7112917,40.12119,0.065,NULL,59635731181,931808299,14559504,14.5),(139978,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139978,35.37,0.25,119,67437,74.4,NULL,NULL,'NGC 6271',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000067,NULL,'14.98',0.7,'E/S0',NULL,NULL,NULL,NULL,1,254.711541667,27.96464,0.261,NULL,56195007504,878046992,13719484,14.98),(139979,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139979,35.55,0.16,129,67437,70,NULL,NULL,'NGC 6271',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139980,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139980,36.92,0.33,242,67438,70,NULL,NULL,'2MASX J16585247+2516002',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000154,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.7185,25.26664,0.225,NULL,56200800551,878137508,13720898,17.4),(139981,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139981,38.39,0.46,477,67439,70,NULL,NULL,'2MASX J16585366+2509212',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000166,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,254.7235,25.15603,0.201,NULL,56189544935,877961639,13718150,17.7),(139982,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139982,36.9,0.46,240,67440,70,NULL,NULL,'2MASX J16585404+6306486',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00007,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,254.725167,63.11336,0.021,NULL,57542640315,899103754,14048496,17.7),(139983,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139983,35.21,0.53,110,67441,70,NULL,NULL,'2MASX J16585495-0150057',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000113,NULL,'16.16',0.4,NULL,NULL,NULL,NULL,NULL,1,254.728875,-1.83511,0.517,NULL,45221378409,706584037,11040375,16.16),(139984,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139984,38.3,0.46,457,67442,70,NULL,NULL,'SDSS J165859.84+325347.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,254.749375,32.89658,0.077,NULL,56206809247,878231394,13722365,18.5),(139985,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139985,37,0.46,251,67443,70,NULL,NULL,'2MASX J16590045+6353266',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000096,NULL,'16.5g',0.32,'Sab',NULL,NULL,NULL,NULL,1,254.751875,63.89089,0.025,NULL,57540366838,899068231,14047941,16.5),(139986,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139986,37.23,0.23,279,67444,70,NULL,NULL,'2MASXi J1659009+323009',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,254.754083,32.5025,0.081,NULL,56205907227,878217300,13722145,17.8),(139987,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139987,37.23,0.23,279,67445,70,NULL,NULL,'4C +32.52A',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.0002,NULL,'16.1g',0.33,'E',NULL,NULL,NULL,NULL,1,254.754167,32.49425,0.081,NULL,56205909233,878217331,13722145,16.1),(139988,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139988,38.23,0.46,442,67446,70,NULL,NULL,'2MASX J16590153+3347273',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.7565,33.79083,0.057,NULL,56207314147,878239283,13722488,17.8),(139989,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139989,30.84,0.8,14.7,67447,75,NULL,NULL,'ESO 138- G 010',NULL,'1988NBGC.C....0000T',1988,1,5.6,'Extended HIPASS source','G',0.000007,NULL,'11.59',4.1,'SA(s)cd',NULL,NULL,NULL,NULL,1,254.7622917,-60.21603,0.873,NULL,44497755992,695277437,10863709,11.59),(139990,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139990,37.36,0.46,297,67448,70,NULL,NULL,'SDSS J165903.23+433002.9',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.2g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,254.7634583,43.50081,0.077,NULL,59643515452,931929928,14561405,17.2),(139991,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139991,37.03,0.46,254,67449,70,NULL,NULL,'2MASX J16590525+3420112',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000174,NULL,'16.1g',0.42,'E0',NULL,NULL,NULL,NULL,1,254.771875,34.33647,0.057,NULL,56204574574,878196477,13721819,16.1),(139992,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139992,35.53,0.53,128,67450,70,NULL,NULL,'2MASX J16590588-0154501',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.774583,-1.91389,0.517,NULL,45221375990,706583999,11040374,15.2),(139993,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139993,34.73,0.56,88.2,67451,70,NULL,NULL,'2MASX J16590728-0544311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.780333,-5.74197,0.825,NULL,45224661106,706635329,11041177,14.4),(139994,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139994,35.83,0.4,146,67452,NULL,NULL,'mean','UGC 10639',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000107,NULL,'15.15',0.5,'SBb; HII       Sy2',NULL,NULL,NULL,'H II',1,254.7857083,28.99194,0.237,NULL,56221469869,878460466,13725944,15.15),(139995,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139995,35.97,0.47,156,67452,NULL,NULL,'H','UGC 10639',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(139996,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,139996,36.74,0.67,223,67453,70,NULL,NULL,'2MASX J16590978-6204041',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.790875,-62.06786,0.697,NULL,44471285313,694863833,10857247,15.9),(139997,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139997,36.86,0.46,236,67454,70,NULL,NULL,'2MASX J16591479+2200451',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,254.811667,22.01256,0.241,NULL,56675958610,885561853,13836903,16.7),(139998,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139998,36.72,0.33,221,67455,70,NULL,NULL,'2MASX J16591551+2451332',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.8147083,24.85922,0.237,NULL,56189669765,877963590,13718181,16.7),(139999,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',139999,36.56,0.46,205,67456,70,NULL,NULL,'2MASX J16591797+2323071',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000169,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.824958333,23.38519,0.229,NULL,56677313996,885583031,13837234,16.8),(140000,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140000,37.54,0.46,323,67457,70,NULL,NULL,'2MASX J16591798+2107031',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000206,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,254.825083,21.11761,0.261,NULL,56860009071,888437641,13881838,17),(140001,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140001,37.52,0.46,319,67458,70,NULL,NULL,'SDSS J165918.18+184816.1',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000146,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,254.8257917,18.8045,0.317,NULL,56871536917,888617764,13884652,17.9),(140002,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140002,38.04,0.17,406,67459,70,NULL,NULL,'2MASX J16592044+3246179',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.835125,32.77158,0.077,NULL,56206653889,878228967,13722327,18),(140003,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140003,38.38,0.46,473,67460,70,NULL,NULL,'2MASX J16592050+3219589',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,254.835375,32.33286,0.129,NULL,56217414110,878397095,13724954,18.4),(140004,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140004,35.34,0.65,117,67461,70,NULL,NULL,'2MASX J16592167-0533311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,254.8402917,-5.55861,0.833,NULL,45224943252,706639738,11041245,15.7),(140005,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140005,36.72,0.33,221,67462,70,NULL,NULL,'2MASX J16592245+2456463',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00018,NULL,'16.6g',0.36,NULL,NULL,NULL,NULL,NULL,1,254.8434583,24.94622,0.261,NULL,56189744714,877964761,13718199,16.6),(140006,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140006,38.04,0.17,406,67463,70,NULL,NULL,'2MASX J16592592+3233050',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,254.858083,32.55131,0.081,NULL,56205967081,878218235,13722159,18.2),(140007,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140007,38.01,0.46,399,67464,70,NULL,NULL,'2MASX J16592744+2503183',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000161,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.8642917,25.05503,0.261,NULL,56189564763,877961949,13718155,17.2),(140008,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140008,38.04,0.17,406,67465,70,NULL,NULL,'SDSS J165929.17+323827.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,254.8715417,32.64089,0.081,NULL,56205940725,878217823,13722153,18.2),(140009,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140009,36.81,0.46,230,67466,70,NULL,NULL,'2MASX J16593427+2340391',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,254.892875,23.67742,0.213,NULL,56677135913,885580248,13837191,18),(140010,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140010,35.33,0.8,117,67467,75,NULL,'CF, r','UGC 10655',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000147,NULL,'15.24',0.4,'Sbc',NULL,NULL,NULL,NULL,1,254.900375,56.06936,0.013,NULL,57699900091,901560938,14086889,15.24),(140011,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140011,34.91,0.38,95.8,67467,75,NULL,'CF, r, raw','UGC 10655',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140012,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140012,35.01,0.38,101,67467,75,NULL,'CF, r, inv','UGC 10655',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140013,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140013,35.19,0.38,109,67467,75,NULL,'CF, r, cor','UGC 10655',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140014,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140014,37.72,0.46,351,67468,70,NULL,NULL,'2MASX J16593633+3203260',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000197,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,254.901375,32.05728,0.113,NULL,56217460338,878397817,13724965,16.3),(140015,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140015,37.07,0.46,259,67469,70,NULL,NULL,'SDSS J165940.59+311642.0',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000145,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,254.919125,31.27836,0.097,NULL,56213961050,878343141,13724111,18.7),(140016,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140016,36.06,0.51,163,67470,70,NULL,NULL,'2MASX J16594376-0134025',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.12',NULL,NULL,NULL,NULL,NULL,NULL,1,254.9322917,-1.56747,0.497,NULL,45203809977,706309530,11036086,16.12),(140017,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140017,38.04,0.17,406,67471,70,NULL,NULL,'4C +32.52C',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.00067,NULL,'16.5',0.43,'BrClG',NULL,NULL,NULL,NULL,1,254.933083333,32.61528,0.077,NULL,56205952732,878218011,13722156,16.5),(140018,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140018,36.21,0.46,175,67472,70,NULL,NULL,'2MASX J16594673+2307347',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,254.944667,23.12642,0.201,NULL,56677427138,885584799,13837262,17),(140019,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140019,35.37,0.25,119,67473,74.4,NULL,NULL,'GIN 622',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000073,NULL,'14.38',NULL,'S',NULL,NULL,NULL,NULL,1,254.9457083,27.76697,0.261,NULL,56195253248,878050832,13719544,14.38),(140020,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140020,36.08,0.41,164,67473,70,NULL,NULL,'GIN 622',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140021,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140021,36.91,0.46,242,67474,70,NULL,NULL,'2MASX J16595476+4155078',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,254.978375,41.91886,0.069,NULL,59638709509,931854836,14560231,17.1),(140022,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140022,37.18,0.46,272,67475,70,NULL,NULL,'2MASX J16595895+1932137',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000163,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,254.9955417,19.53719,0.349,NULL,56874507416,888664178,13885377,17.2),(140023,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140023,38.05,0.46,408,67476,70,NULL,NULL,'2MASX J16595966+3244100',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,254.998625,32.73594,0.069,NULL,56205969264,878218269,13722160,17.2),(140024,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140024,37.37,0.46,298,67477,70,NULL,NULL,'2MASX J17000039+3236550',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.0017917,32.61522,0.077,NULL,56205922309,878217536,13722149,17.5),(140025,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140025,36.08,0.41,164,67478,70,NULL,NULL,'GIN 625',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.30',NULL,'S',NULL,NULL,NULL,NULL,1,255.013666667,28.42789,0.245,NULL,56191604193,877993815,13718653,15.3),(140026,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140026,37.15,0.46,270,67479,70,NULL,NULL,'2MASX J17000487+3954358',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,255.0202917,39.90994,0.061,NULL,59640770822,931887044,14560735,17.2),(140027,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140027,38.54,0.46,510,67480,70,NULL,NULL,'SDSS J170005.87+173824.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000191,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.0245,17.64014,0.313,NULL,56901888062,889092000,13892062,18.7),(140028,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140028,36.95,0.46,245,67481,70,NULL,NULL,'2MASX J17000740+3749088',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,255.0307083,37.81903,0.077,NULL,59628690368,931698287,14557785,16.5),(140029,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140029,36.79,0.46,228,67482,70,NULL,NULL,'2MASX J17001047+1819322',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000162,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,255.043625,18.32572,0.325,NULL,56869348391,888583568,13884118,16.6),(140030,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140030,38.04,0.17,406,67483,70,NULL,NULL,'4C +32.52E',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000169,NULL,'16.8g',0.29,'E              AGN',NULL,NULL,'NAT',NULL,1,255.04675,32.58744,0.077,NULL,56205996022,878218687,13722166,16.8),(140031,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140031,36.08,0.41,164,67484,70,NULL,NULL,'GIN 623',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000157,NULL,'14.32',NULL,'E',NULL,NULL,NULL,NULL,1,255.047667,28.2795,0.253,NULL,56191464384,877991631,13718619,14.32),(140032,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140032,37.31,0.46,290,67485,70,NULL,NULL,'2MASX J17001330+3250230',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000184,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,255.055375,32.83969,0.069,NULL,56205855362,878216490,13722132,16.4),(140033,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140033,38.04,0.17,406,67486,70,NULL,NULL,'2MASX J17001392+3232010',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000168,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,255.058083,32.53367,0.077,NULL,56205997502,878218710,13722167,16.8),(140034,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140034,38.04,0.17,406,67487,70,NULL,NULL,'2MASX J17001432+3239430',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,255.059667,32.662,0.069,NULL,56206027014,878219172,13722174,18.8),(140035,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140035,36.47,0.57,197,67488,70,NULL,NULL,'2MASX J17001694-6313006',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.070791667,-63.21692,0.689,NULL,44472379689,694880932,10857514,14.3),(140036,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140036,35.5,0.64,126,67489,70,NULL,NULL,'2MASX J17001772-6618306',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.0739583,-66.3085,0.457,NULL,44967244429,702613194,10978331,15.3),(140037,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140037,37.07,0.46,259,67490,70,NULL,NULL,'SDSS J170021.52+262257.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,255.089708333,26.3825,0.185,NULL,56201923366,878155052,13721172,18.3),(140038,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140038,35.63,0.48,134,67491,70,NULL,NULL,'2MASX J17002302-0219322',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'16.44',0.7,'poss. LINER',NULL,NULL,NULL,NULL,1,255.096,-2.32567,0.569,NULL,45221859883,706591560,11040493,16.44),(140039,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140039,37.2,0.33,276,67492,70,NULL,NULL,'2MASX J17002430+3320438',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,255.10125,33.34561,0.077,NULL,56206287294,878223238,13722238,17.1),(140040,'Tully est','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140040,30.33,0.8,11.6,67493,75,NULL,NULL,'UGC 10669',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000013,NULL,'17.',1.3,'Im?',NULL,NULL,NULL,NULL,1,255.105417,70.29,0.141,NULL,57789094767,902954605,14108665,17),(140041,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140041,30.13,NULL,10.6,67493,NULL,NULL,NULL,'UGC 10669',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140042,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140042,36.71,0.46,220,67494,70,NULL,NULL,'2MASX J17002726+2034321',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00019,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,255.113708333,20.57561,0.313,NULL,56873403762,888646933,13885108,16.3),(140043,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140043,36.65,0.27,213,67495,70,NULL,NULL,'2MASX J17003272+2523590',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000171,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,255.136208333,25.39969,0.221,NULL,56188265367,877941646,13717838,16.5),(140044,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140044,36.79,0.46,228,67496,70,NULL,NULL,'2MASX J17003301+3923524',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000102,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,255.1375,39.39797,0.065,NULL,59640830572,931887977,14560749,15.9),(140045,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140045,37.3,0.46,289,67497,70,NULL,NULL,'2MASX J17003362+3842394',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000091,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.1400417,38.71089,0.057,NULL,59629222284,931706598,14557915,16.7),(140046,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140046,36.65,0.27,213,67498,70,NULL,NULL,'2MASX J17003487+2522360',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,255.1452917,25.37658,0.221,NULL,56188232584,877941134,13717830,17.4),(140047,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140047,36.21,0.46,174,67499,70,NULL,NULL,'2MASX J17003550+3213548',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000188,NULL,'15.9g',0.33,'S0',NULL,NULL,NULL,NULL,1,255.1477917,32.23181,0.129,NULL,56217348711,878396073,13724938,15.9),(140048,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140048,38.63,0.46,531,67500,70,NULL,NULL,'2MASX J17003742+3407438',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.156,34.12889,0.057,NULL,56204217545,878190899,13721732,18),(140049,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140049,36.06,0.46,163,67501,70,NULL,NULL,'2MASX J17003815+2426200',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000176,NULL,'15.7g',0.43,NULL,NULL,NULL,NULL,NULL,1,255.159083,24.43886,0.205,NULL,56190466316,877976036,13718375,15.7),(140050,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140050,37.14,0.46,267,67502,70,NULL,NULL,'2MASX J17003912+2603150',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.163083,26.05417,0.165,NULL,56202268423,878160444,13721256,17.3),(140051,'GRB','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140051,41.59,NULL,2080,67503,70,NULL,'Pseudo z = 0.7','GRB 010613',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE/Ulysses',NULL,NULL,NULL,NULL,1,255.166667,14.26667,0.321,NULL,56854743205,888355362,13880552,NULL),(140052,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140052,36.65,0.27,213,67504,70,NULL,NULL,'2MASX J17004143+2533280',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000198,NULL,'15.9g',0.4,NULL,NULL,NULL,NULL,NULL,1,255.1727083,25.55775,0.193,NULL,56188245990,877941343,13717833,15.9),(140053,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140053,36.21,0.46,175,67505,70,NULL,NULL,'SDSS J170042.16+393139.5',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000081,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,255.175667,39.52767,0.065,NULL,59640815973,931887749,14560746,16),(140054,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140054,35.96,0.25,156,67506,74.4,NULL,NULL,'UGC 10658 NOTES01',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00008,NULL,'14.44',0.7,'E:',NULL,NULL,NULL,NULL,1,255.181833,28.02583,0.253,NULL,56195028522,878047320,13719489,14.44),(140055,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140055,36.08,0.41,164,67506,70,NULL,NULL,'UGC 10658 NOTES01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140056,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140056,38.16,0.46,428,67507,70,NULL,NULL,'2MASX J17004573+3205399',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,255.190708333,32.09439,0.113,NULL,56213129164,878330143,13723908,17.6),(140057,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140057,35.95,0.25,155,67508,74.4,NULL,NULL,'MCG +05-40-023',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00008,NULL,'14.81',0.4,'S',NULL,NULL,NULL,NULL,1,255.1955417,27.84917,0.253,NULL,56195064087,878047876,13719498,14.81),(140058,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140058,36.08,0.41,164,67508,70,NULL,NULL,'MCG +05-40-023',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140059,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140059,38.17,0.13,430,67509,70,NULL,NULL,'2MASX J17004788+3359388',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,255.1995417,33.99397,0.061,NULL,56204202943,878190670,13721729,17.3),(140060,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140060,37.36,0.46,296,67510,70,NULL,NULL,'SDSS J170048.05+311712.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.2002083,31.28678,0.097,NULL,56213812614,878340822,13724075,18),(140061,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140061,36.79,0.66,228,67511,70,NULL,NULL,'2MASX J17004953-6018205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.20625,-60.30561,0.825,NULL,44498203443,695284428,10863819,15.9),(140062,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140062,37.13,0.46,266,67512,70,NULL,NULL,'2MASX J17004970+2029004',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000153,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,255.207041667,20.48344,0.313,NULL,56873946222,888655409,13885240,17.4),(140063,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140063,32.7,0.45,34.7,67513,NULL,NULL,'K','NGC 6278',NULL,'2007A&A...465...71T',2007,1,1.93,'HOLM 765C is a double star.','G',0.000017,NULL,'13.1g',0.88,'S0','in a pair',NULL,NULL,NULL,1,255.209708333,23.01103,0.201,NULL,56676917852,885576841,13837138,13.1),(140064,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140064,33.2,0.4,43.6,67513,NULL,NULL,'mean','NGC 6278',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140065,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140065,38.09,0.46,415,67514,70,NULL,NULL,'SDSS J170050.69+343409.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000148,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.211208333,34.56942,0.057,NULL,56338810625,880293916,13754592,18.7),(140066,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140066,37.29,0.46,287,67515,70,NULL,NULL,'2MASX J17005280+3853420',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,255.220125,38.89514,0.057,NULL,59628918392,931701849,14557841,17.5),(140067,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140067,35.36,0.25,118,67516,74.4,NULL,NULL,'MCG +05-40-024',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000047,NULL,'14.28',0.4,'SB0',NULL,NULL,NULL,NULL,1,255.223166667,27.72458,0.237,NULL,56195245717,878050714,13719542,14.28),(140068,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140068,36.08,0.41,164,67516,70,NULL,NULL,'MCG +05-40-024',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140069,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140069,37.23,0.46,280,67517,70,NULL,NULL,'2MASX J17005378+3306157',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.224,33.10428,0.057,NULL,56206703065,878229735,13722339,17.4),(140070,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140070,38.17,0.13,430,67518,70,NULL,NULL,'2MASX J17005627+3358187',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.234667,33.97194,0.061,NULL,56338163244,880283800,13754434,18.2),(140071,'HII LF','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'N',140071,46.64,1.58,4400,67519,71,NULL,NULL,'HS 1700+6416:BX717',2.4353,'2005MNRAS.356.1117S',2005,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140072,'HII LF','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140072,46.72,1.8,4730,67520,71,NULL,NULL,'HS 1700+6416:[SSE2005] MD0103',2.315,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',NULL,NULL,'24.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.250875,64.19878,0.025,NULL,57540066756,899063543,14047867,24.2),(140073,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140073,36.3,0.46,182,67521,70,NULL,NULL,'2MASX J17010097+2450478',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.254,24.84658,0.261,NULL,56191000096,877984376,13718505,17.2),(140074,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140074,37.65,0.46,339,67522,70,NULL,NULL,'2MASX J17010184+2118054',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000165,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.257667,21.30167,0.293,NULL,56859410602,888428290,13881692,18.3),(140075,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140075,35.36,0.48,118,67523,70,NULL,NULL,'2MASX J17010646-6656591',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.277041667,-66.94975,0.437,NULL,44967655728,702619620,10978431,14.8),(140076,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140076,37.53,0.46,321,67524,70,NULL,NULL,'2MASX J17010687+1901594',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.2787917,19.03317,0.337,NULL,56871059026,888610297,13884535,17.9),(140077,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140077,37.71,0.46,348,67525,70,NULL,NULL,'2MASX J17010776+1843014',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000154,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.282333333,18.71703,0.333,NULL,56869123432,888580053,13884063,18.5),(140078,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140078,36.15,0.66,170,67526,70,NULL,NULL,'2MASX J17010790-0247456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.283,-2.79594,0.541,NULL,45221078877,706579357,11040302,15.3),(140079,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140079,38.01,0.46,399,67527,70,NULL,NULL,'2MASX J17010960+2638329',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.290125,26.64258,0.181,NULL,56202026044,878156656,13721197,18.1),(140080,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140080,37.74,0.46,352,67528,70,NULL,NULL,'2MASX J17011019+3909591',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000085,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.292333,39.16653,0.037,NULL,59640261432,931879084,14560610,17.1),(140081,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140081,36.27,0.46,179,67529,70,NULL,NULL,'IC 4638',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000191,NULL,'15.5g',0.43,'E0',NULL,NULL,NULL,NULL,1,255.307083,33.51319,0.077,NULL,56339481204,880304393,13754756,15.5),(140082,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140082,36.69,0.75,218,67530,70,NULL,NULL,'2MASX J17011593-6212065',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.54',0.32,NULL,NULL,NULL,NULL,NULL,1,255.3165,-62.20208,0.617,NULL,44470901222,694857831,10857153,16.54),(140083,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140083,38.11,0.46,420,67531,70,NULL,NULL,'SDSS J170116.47+231252.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.318666667,23.2145,0.229,NULL,56674223489,885534742,13836480,18.8),(140084,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140084,37.07,0.46,259,67532,70,NULL,NULL,'ZwCl 1700.5+3322 04',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000191,NULL,'16.3g',0.37,'Fuzzy red spherical',NULL,NULL,NULL,NULL,1,255.3387917,32.78561,0.069,NULL,56205871305,878216739,13722136,16.3),(140085,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140085,38.37,0.46,471,67533,70,NULL,NULL,'SDSS J170122.35+245150.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.343167,24.86414,0.261,NULL,56191003363,877984427,13718506,18.6),(140086,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140086,36.76,0.46,225,67534,70,NULL,NULL,'2MASX J17012249+2018249',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'16.94',0.33,NULL,NULL,NULL,NULL,NULL,1,255.343708333,20.30681,0.317,NULL,56873914870,888654919,13885233,16.94),(140087,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140087,37.66,0.46,341,67535,70,NULL,NULL,'SDSS J170123.36+350706.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.0002,NULL,'18.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,255.347333,35.11844,0.069,NULL,56338110786,880282981,13754421,18.3),(140088,'Black Hole','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140088,40.66,0.28,1360,67536,NULL,NULL,NULL,'[HB89] 1700+518',NULL,'2014ApJ...793..108W',2014,1,NULL,NULL,'QSO',NULL,NULL,'15.1V',NULL,'BAL;Sy1        Sbrst',NULL,NULL,NULL,'Sy 1.0',1,255.353333,51.82222,0.017,NULL,57493997526,898343711,14036620,15.1),(140089,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140089,38.17,0.13,430,67537,70,NULL,NULL,'2MASX J17012658+3400478',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,255.36075,34.01322,0.061,NULL,56338212937,880284577,13754446,NULL),(140090,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140090,37.74,0.46,354,67538,70,NULL,NULL,'SDSS J170127.29+631751.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00006,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.36375,63.29756,0.021,NULL,57541769393,899090146,14048283,18.2),(140091,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140091,36.47,0.46,197,67539,70,NULL,NULL,'2MASX J17012841+3136192',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000176,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,255.3682917,31.60547,0.129,NULL,56214024779,878344137,13724127,16.4),(140092,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140092,35.78,0.46,143,67540,70,NULL,NULL,'ZwCl 1700.5+3322 07',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000142,NULL,'16.0g',0.38,'Spherical compact',NULL,NULL,NULL,NULL,1,255.3857083,33.05222,0.057,NULL,56339072211,880298003,13754656,16),(140093,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140093,37.2,0.33,276,67541,70,NULL,NULL,'WISEPC J170132.94+331901.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000053,NULL,'18.3g',0.1,'AGN',NULL,NULL,NULL,NULL,1,255.387167,33.31697,0.077,NULL,56339583318,880305989,13754781,18.3),(140094,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140094,38.46,0.27,493,67542,70,NULL,NULL,'SDSS J170135.77+351122.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,255.399041667,35.18972,0.069,NULL,56337926565,880280102,13754376,18.4),(140095,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140095,38.15,0.46,426,67543,70,NULL,NULL,'2MASX J17013814+2138335',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000167,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.408875,21.64267,0.281,NULL,56859361502,888427523,13881680,17.4),(140096,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140096,38.46,0.27,493,67544,70,NULL,NULL,'2MASX J17013909+3508503',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.412917,35.14753,0.069,NULL,56338119319,880283114,13754423,18.3),(140097,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140097,35.05,0.48,102,67545,70,NULL,NULL,'2MFGC 13615',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.4155,-62.75297,0.705,NULL,44470249506,694847648,10856994,14.6),(140098,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140098,35.82,0.25,146,67546,74.4,NULL,NULL,'GIN 615',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000107,NULL,'14.80',NULL,'E/S0',NULL,NULL,NULL,NULL,1,255.4252083,81.91292,0.337,NULL,56957745335,889964770,13905699,14.8),(140099,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140099,36.01,0.28,159,67546,70,NULL,NULL,'GIN 615',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140100,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140100,35.07,0.49,103,67547,75,NULL,'IR','UGC 10664',NULL,'2011yCatp016004901K',2011,1,1.44,'Star superposed.','G',0.000177,':','15.37',0.18,'Sc',NULL,NULL,NULL,NULL,1,255.4255417,41.22936,0.033,NULL,59637782995,931840359,14560005,15.37),(140101,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140101,35.1,NULL,105,67547,NULL,NULL,NULL,'UGC 10664',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140102,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140102,35.25,NULL,112,67547,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10664',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140103,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140103,35.27,NULL,113,67547,NULL,NULL,'Dipole + Quadrupole','UGC 10664',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140104,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140104,35.3,NULL,115,67547,NULL,NULL,'Dipole','UGC 10664',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140105,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140105,37.79,0.33,362,67548,70,NULL,NULL,'ZwCl 1700.5+3322 11',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00018,NULL,'16.5g',0.35,'Red sph. compact',NULL,NULL,NULL,NULL,1,255.436625,32.97217,0.065,NULL,56339128921,880298889,13754670,16.5),(140106,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140106,38.17,0.13,430,67549,70,NULL,NULL,'2MASX J17014602+3400164',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.4417083,34.00456,0.061,NULL,56338157617,880283712,13754433,17.8),(140107,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140107,36.44,0.16,182,67550,74.2,NULL,'SALT 2','UGC 10704',0.064387,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000199,NULL,'15.6',0.7,'S              LINER',NULL,NULL,NULL,NULL,1,255.455125,79.03769,0.177,NULL,57129115033,892642422,13947537,15.6),(140108,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140108,36.77,0.05,212,67550,70,NULL,'SALT 2','UGC 10704',0.064387,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140109,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140109,37.05,0.03,241,67550,72,NULL,'SALT','UGC 10704',0.064387,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140110,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140110,36.97,0.09,248,67550,74.4,NULL,NULL,'UGC 10704',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140111,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140111,37.16,0.16,254,67550,70,NULL,'SALT 2','UGC 10704',0.064387,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140112,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae','R',140112,37.03,0.08,255,67550,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10704',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140113,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae','R',140113,37.08,0.08,261,67550,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10704',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140114,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140114,37.23,0.16,263,67550,65,NULL,'SALT','UGC 10704',0.064387,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140115,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140115,37.24,0.18,263,67550,65,NULL,'SALT2','UGC 10704',0.064387,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140116,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140116,37.27,0.15,267,67550,65,NULL,'MLCS17','UGC 10704',0.064387,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140117,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','SN 2007ae',NULL,140117,37.34,0.14,275,67550,65,NULL,'MLCS31','UGC 10704',0.064387,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140118,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140118,34.62,0.49,83.8,67551,70,NULL,NULL,'CGCG 025-018',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000083,NULL,'15.6',0.26,'Sb','Isolated galaxy',NULL,NULL,NULL,1,255.463458333,-1.89908,0.561,NULL,45204073572,706313649,11036150,15.6),(140119,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140119,38.02,0.46,402,67552,70,NULL,NULL,'2MASX J17015268+6113100',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000075,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.469625,61.21944,0.025,NULL,57533988059,898968563,14046383,17.4),(140120,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140120,37.79,0.33,362,67553,70,NULL,NULL,'ZwCl 1700.5+3322 17',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000163,NULL,'17.0g',0.21,'Red fuzzy ell.comp.',NULL,NULL,NULL,NULL,1,255.47575,33.05881,0.057,NULL,56339083588,880298181,13754659,17),(140121,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140121,35.37,0.25,119,67554,74.4,NULL,NULL,'CGCG 169-033',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000047,NULL,'13.83',0.2,'E/S0',NULL,NULL,NULL,NULL,1,255.479,28.41772,0.281,NULL,56191936122,877999001,13718734,13.83),(140122,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140122,36.08,0.41,164,67554,70,NULL,NULL,'CGCG 169-033',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140123,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140123,37.77,0.46,358,67555,70,NULL,NULL,'SDSS J170155.31+592334.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000055,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.4805,59.39292,0.029,NULL,57704930918,901639545,14088117,18.6),(140124,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140124,35.37,0.25,119,67556,74.4,NULL,NULL,'CGCG 169-032',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000077,NULL,'14.39',0.2,'E/S0',NULL,NULL,NULL,NULL,1,255.483666667,28.38803,0.281,NULL,56191934941,877998983,13718734,14.39),(140125,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140125,36.08,0.41,164,67556,70,NULL,NULL,'CGCG 169-032',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140126,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140126,37.42,0.46,305,67557,70,NULL,NULL,'2MASX J17015692+6138210',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000064,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.4869583,61.63933,0.013,NULL,57537230561,899019227,14047175,17.3),(140127,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140127,38.46,0.27,493,67558,70,NULL,NULL,'SDSS J170157.89+351027.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,255.4912083,35.17439,0.073,NULL,56338039994,880281874,13754404,18.5),(140128,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140128,34.8,0.46,91.3,67559,70,NULL,NULL,'2MASX J17015796-6318419',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.4915417,-63.31167,0.689,NULL,44464967512,694765117,10855704,13.3),(140129,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140129,36.96,0.46,247,67560,70,NULL,NULL,'2MASX J17015952+2433401',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000166,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,255.498125,24.56111,0.197,NULL,56190400812,877975012,13718359,16.9),(140130,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140130,35.12,0.49,106,67561,70,NULL,NULL,'2MASX J17020094-7833333',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000097,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,255.503583,-78.55919,0.421,NULL,44259362954,691552546,10805508,15.6),(140131,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140131,34.98,0.51,99.1,67562,70,NULL,NULL,'2MASX J17020261-0251011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.0001,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.510875,-2.85036,0.617,NULL,45220923009,706576922,11040264,14.9),(140132,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140132,37.8,0.1,363,67563,70,NULL,NULL,'ZwCl 1700.5+3322 18',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.4g',0.21,'Fuzzy red ell.comp.',NULL,NULL,NULL,NULL,1,255.514125,33.50525,0.077,NULL,56339701434,880307834,13754809,17.4),(140133,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140133,38.03,0.46,404,67564,70,NULL,NULL,'SDSS J170206.17+381938.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000078,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.52575,38.32747,0.089,NULL,59629004851,931703200,14557862,18.4),(140134,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140134,36.71,0.43,220,67565,NULL,NULL,'Malmquist cor.','2MASX J17020727+7817300',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.00003,NULL,'15.55',NULL,'Sbc',NULL,NULL,NULL,NULL,1,255.530333,78.29164,0.161,NULL,57135858359,892747786,13949184,15.55),(140135,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140135,36.91,0.39,241,67565,NULL,NULL,NULL,'2MASX J17020727+7817300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140136,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140136,36.95,0.2,245,67565,74.4,NULL,NULL,'2MASX J17020727+7817300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140137,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140137,37.13,0.46,267,67566,70,NULL,NULL,'VII Zw 674',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000097,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,255.534416667,60.96356,0.017,NULL,57533879182,898966862,14046357,16.3),(140138,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140138,38.32,0.46,462,67567,70,NULL,NULL,'2MASX J17020878+3311283',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000183,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.5367083,33.19133,0.057,NULL,56339804937,880309452,13754835,17.7),(140139,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140139,37.86,0.33,372,67568,70,NULL,NULL,'2MASX J17021092+3521493',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000133,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.5454583,35.36364,0.089,NULL,56120032717,876875511,13701179,18.1),(140140,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140140,36.08,0.41,164,67569,70,NULL,NULL,'GIN 624',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',NULL,NULL,'15.28',NULL,'SB',NULL,NULL,NULL,NULL,1,255.557,28.12886,0.261,NULL,56194602308,878040661,13719385,15.28),(140141,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140141,37.8,0.1,363,67570,70,NULL,NULL,'ZwCl 1700.5+3322 22a',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.2g',0.13,'Red sph.comp.20\\\"SW b',NULL,NULL,NULL,NULL,1,255.561333,33.561,0.057,NULL,56339716682,880308073,13754813,18.2),(140142,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140142,37.15,0.33,269,67571,70,NULL,NULL,'2MASX J17021551+1912449',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000183,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,255.564666667,19.21247,0.353,NULL,56870842269,888606910,13884482,16.2),(140143,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140143,37.8,0.1,363,67572,70,NULL,NULL,'ZwCl 1700.5+3322 22b',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'17.1g',0.25,'V.red sph.comp.',NULL,NULL,NULL,NULL,1,255.5675417,33.56383,0.057,NULL,56339724699,880308198,13754815,17.1),(140144,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140144,35.98,0.56,157,67573,70,NULL,NULL,'2MASX J17021655-0437111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.568917,-4.61983,0.905,NULL,45228714494,706698663,11042166,15.8),(140145,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140145,36.97,0.46,248,67574,70,NULL,NULL,'ZwCl 1700.5+3322 24',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.0g',0.31,'Red spherical comp.',NULL,NULL,NULL,NULL,1,255.569875,34.502,0.053,NULL,56338350509,880286726,13754480,17),(140146,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140146,37.8,0.1,363,67575,70,NULL,NULL,'ZwCl 1700.5+3322 23',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.1g',0.23,'Fuzzy red sph.comp.',NULL,NULL,NULL,NULL,1,255.571417,33.491,0.077,NULL,56339669883,880307341,13754802,17.1),(140147,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140147,38.19,0.46,434,67576,70,NULL,NULL,'2MASX J17021729+3133193',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000162,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,255.572,31.55533,0.129,NULL,56213711541,878339242,13724050,17.8),(140148,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140148,37.43,0.46,307,67577,70,NULL,NULL,'2MASX J17022007+2927031',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,255.583583,29.45086,0.257,NULL,56220500538,878445320,13725708,17),(140149,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140149,37.15,0.33,269,67578,70,NULL,NULL,'2MASX J17022017+1914529',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000174,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,255.583917,19.24803,0.353,NULL,56870842630,888606916,13884483,17.3),(140150,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140150,37.8,0.1,363,67579,70,NULL,NULL,'SDSS J170223.56+332249.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000162,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,255.5982083,33.38031,0.077,NULL,56339557095,880305579,13754774,18.4),(140151,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140151,37.8,0.1,363,67580,70,NULL,NULL,'ZwCl 1700.5+3322 a',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000155,NULL,'17.4g',0.21,'Red ellipt. fuzzy',NULL,NULL,NULL,NULL,1,255.598791667,33.49703,0.077,NULL,56339672387,880307381,13754802,17.4),(140152,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140152,37.8,0.1,363,67581,70,NULL,NULL,'ZwCl 1700.5+3322 b',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000186,NULL,'16.5g',0.35,'Red ellipt. fuzzy',NULL,NULL,NULL,NULL,1,255.6024583,33.50311,0.077,NULL,56339672434,880307381,13754802,16.5),(140153,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140153,37.8,0.1,363,67582,70,NULL,NULL,'ZwCl 1700.5+3322 29',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000212,NULL,'16.6g',0.32,'Red,fuzzy ell.comp.',NULL,NULL,NULL,NULL,1,255.604833,33.37989,0.077,NULL,56339556915,880305576,13754774,16.6),(140154,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140154,38.17,0.13,430,67583,70,NULL,NULL,'2MASX J17022571+3359543',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000107,NULL,'17.5g',0.19,'S0',NULL,NULL,NULL,NULL,1,255.607125,33.99828,0.065,NULL,56341612144,880337689,13755276,17.5),(140155,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140155,37.61,0.46,333,67584,70,NULL,NULL,'2MASX J17022700+3827052',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,255.612583,38.45131,0.097,NULL,59629070222,931704222,14557878,17.4),(140156,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140156,38.13,0.33,422,67585,70,NULL,NULL,'2MASX J17022710+3519473',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000177,NULL,'17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,255.6130417,35.33,0.089,NULL,56119895435,876873366,13701146,17.1),(140157,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140157,37.36,0.46,297,67586,70,NULL,NULL,'2MASX J17022789+2105549',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,255.616333,21.09847,0.289,NULL,56861193115,888456142,13882127,16.7),(140158,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140158,37.39,0.46,301,67587,70,NULL,NULL,'2MASX J17022911+2357379',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000172,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,255.621333,23.96044,0.185,NULL,56187522939,877930045,13717656,17.1),(140159,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140159,37.86,0.33,372,67588,70,NULL,NULL,'2MASX J17022946+3516303',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000178,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.6227083,35.27517,0.089,NULL,56119900619,876873447,13701147,17.2),(140160,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140160,38.17,0.13,430,67589,70,NULL,NULL,'ZwCl 1700.5+3322 26',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.7g',0.36,'Red fuzzy sph.comp.',NULL,NULL,NULL,NULL,1,255.632875,33.89597,0.061,NULL,56341593547,880337399,13755271,16.7),(140161,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140161,37.8,0.1,363,67590,70,NULL,NULL,'ZwCl 1700.5+3322 31',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.5g',0.18,'Red sph. compact',NULL,NULL,NULL,NULL,1,255.634375,33.42997,0.077,NULL,56339560773,880305637,13754775,17.5),(140162,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140162,38.17,0.13,430,67591,70,NULL,NULL,'2MASX J17023247+3401163',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,255.635417,34.02119,0.065,NULL,56341605805,880337590,13755274,18),(140163,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140163,34.67,0.51,85.9,67592,70,NULL,NULL,'ESO 070- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'16.1b',0.2,'S...',NULL,NULL,NULL,NULL,1,255.6367917,-69.29356,0.329,NULL,44974025522,702719148,10979986,16.1),(140164,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140164,37.8,0.1,363,67593,70,NULL,NULL,'ZwCl 1700.5+3322 d',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000213,NULL,'15.5g',0.57,'BrClG',NULL,NULL,NULL,NULL,1,255.638083,33.51672,0.057,NULL,56339671763,880307371,13754802,15.5),(140165,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140165,37.8,0.1,363,67594,70,NULL,NULL,'ZwCl 1700.5+3322 e',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.4g',0.2,'Red spher. compact',NULL,NULL,NULL,NULL,1,255.64175,33.48656,0.077,NULL,56339670980,880307359,13754802,17.4),(140166,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140166,37.8,0.1,363,67595,70,NULL,NULL,'ZwCl 1700.5+3322 32',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000164,NULL,'17.4g',0.24,'Red sph. compact',NULL,NULL,NULL,NULL,1,255.6457917,33.44628,0.077,NULL,56339561378,880305646,13754775,17.4),(140167,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140167,37.8,0.1,363,67596,70,NULL,NULL,'SDSS J170236.48+332305.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.6520417,33.38486,0.077,NULL,56339559612,880305618,13754775,18.3),(140168,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140168,37.8,0.1,363,67597,70,NULL,NULL,'ZwCl 1700.5+3322 g',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00039,NULL,'16.7g',0.21,'Red ell.fuzzy comp.',NULL,NULL,NULL,NULL,1,255.663833,33.51408,0.057,NULL,56339676690,880307448,13754803,16.7),(140169,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140169,37.14,0.66,268,67598,70,NULL,NULL,'2MASX J17024014-6452410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.667167,-64.87806,0.561,NULL,44481222714,695019104,10859673,15.8),(140170,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140170,37.91,0.46,381,67599,70,NULL,NULL,'SDSS J170240.30+374129.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000089,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.667958333,37.69164,0.093,NULL,59630330064,931723907,14558186,18),(140171,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140171,38.17,0.13,430,67600,70,NULL,NULL,'2MASX J17024278+3405533',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000169,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.678208333,34.09817,0.065,NULL,56341775380,880340240,13755316,18.5),(140172,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140172,37.72,0.46,351,67601,70,NULL,NULL,'2MASX J17024393+3028343',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.683,30.47628,0.177,NULL,56212477120,878319955,13723749,17.5),(140173,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140173,37.8,0.1,363,67602,70,NULL,NULL,'ZwCl 1700.5+3322 35',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000171,NULL,'17.3g',0.23,'Neutral sph. compact',NULL,NULL,NULL,NULL,1,255.687166667,33.58236,0.057,NULL,56339666638,880307291,13754801,17.3),(140174,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140174,34.12,0.8,66.6,67603,75,NULL,'MAT, I','ESO 001- G 007',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.85',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,255.688083,-88.91722,0.569,NULL,44023919674,687873744,10748027,15.85),(140175,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140175,33.66,0.32,53.9,67603,85,NULL,'I, raw','ESO 001- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140176,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140176,33.67,0.32,54.3,67603,85,NULL,'I, inv','ESO 001- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140177,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140177,33.81,0.43,57.9,67603,75,NULL,'MAT, I, raw','ESO 001- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140178,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140178,33.93,0.43,61,67603,75,NULL,'MAT, I, inv','ESO 001- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140179,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140179,33.95,0.41,61.7,67603,NULL,NULL,NULL,'ESO 001- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140180,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140180,33.99,0.2,62.8,67603,74.4,NULL,NULL,'ESO 001- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140181,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140181,34.01,0.43,63.4,67603,75,NULL,'MAT, I, cor','ESO 001- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140182,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140182,34.16,0.38,67.8,67603,NULL,NULL,'Malmquist cor.','ESO 001- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140183,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140183,37.8,0.1,363,67604,70,NULL,NULL,'ZwCl 1700.5+3322 i',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000174,NULL,'16.6g',0.28,'Red fuzzy ell.comp.',NULL,NULL,NULL,NULL,1,255.688125,33.50703,0.057,NULL,56339674452,880307413,13754803,16.6),(140184,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140184,37.37,0.46,298,67605,70,NULL,NULL,'2MASX J17024671+2402468',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.6947917,24.04633,0.185,NULL,56187531108,877930173,13717658,17.9),(140185,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140185,38.38,0.46,475,67606,70,NULL,NULL,'2MASX J17024727+3258334',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,255.697125,32.97589,0.109,NULL,56339144132,880299127,13754673,18.1),(140186,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140186,38.19,0.46,435,67607,70,NULL,NULL,'2MASX J17024897+3544373',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,255.704083333,35.74386,0.109,NULL,56119978835,876874669,13701166,17.1),(140187,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140187,38.17,0.13,430,67608,70,NULL,NULL,'2MASX J17025054+3349134',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,255.7105417,33.82047,0.061,NULL,56339496967,880304640,13754760,17.8),(140188,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140188,37.8,0.1,363,67609,70,NULL,NULL,'ZwCl 1700.5+3322 k',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.3g',0.26,'Red fuzzy sph.comp.',NULL,NULL,NULL,NULL,1,255.716125,33.51319,0.057,NULL,56339662085,880307220,13754800,17.3),(140189,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140189,34.86,0.57,93.6,67610,70,NULL,NULL,'2MASX J17025363-0114110',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'16.24',NULL,NULL,NULL,NULL,NULL,NULL,1,255.7234583,-1.23656,0.521,NULL,45204689903,706323279,11036301,16.24),(140190,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140190,38.13,0.33,422,67611,70,NULL,NULL,'2MASX J17025416+3520414',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,255.725708333,35.34492,0.089,NULL,56119917133,876873705,13701151,18.3),(140191,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140191,38.17,0.13,430,67612,70,NULL,NULL,'2MASX J17025462+3412274',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000128,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,255.7275,34.20772,0.065,NULL,56341712785,880339262,13755300,17.6),(140192,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140192,36.92,0.27,242,67613,70,NULL,NULL,'2MASX J17025470+2301559',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000176,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.728041667,23.03225,0.229,NULL,56674077500,885532460,13836444,17.6),(140193,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140193,36.79,0.53,228,67614,70,NULL,NULL,'2MASX J17025477-6514442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.728125,-65.24556,0.553,NULL,44480735343,695011489,10859554,15.6),(140194,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140194,36.92,0.27,242,67615,70,NULL,NULL,'IC 4639',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000174,NULL,'15.5g',0.53,NULL,NULL,NULL,NULL,NULL,1,255.728125,22.93003,0.229,NULL,56674074264,885532410,13836443,15.5),(140195,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140195,37.46,0.46,310,67616,70,NULL,NULL,'2MASX J17025477+6117051',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000095,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,255.728458333,61.28472,0.025,NULL,57533932672,898967698,14046370,16.5),(140196,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140196,36.11,0.46,167,67617,70,NULL,NULL,'2MASX J17025608+2531488',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000184,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.7337917,25.53031,0.169,NULL,56188768495,877949507,13717961,16.3),(140197,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140197,36.78,0.46,227,67618,70,NULL,NULL,'2MASX J17025615+2311559',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,255.734041667,23.19894,0.225,NULL,56674335335,885536489,13836507,17.4),(140198,'SNIa','2016-12-15 15:15:44','2016-12-16 11:20:59','1','PTF11khk','N',140198,35.27,0.06,110,67619,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11khk',0.0306,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140199,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140199,38.17,0.13,430,67620,70,NULL,NULL,'SDSS J170259.53+340657.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,255.7480417,34.11586,0.065,NULL,56341790693,880340479,13755319,18.7),(140200,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140200,36.21,0.55,175,67621,70,NULL,NULL,'2MASX J17030103-7858093',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,255.7545417,-78.96919,0.377,NULL,44260267913,691566686,10805729,16.4),(140201,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140201,36.33,0.46,185,67622,70,NULL,NULL,'ZwCl 1700.5+3322 55',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000176,NULL,'15.6g',0.49,'S0; compact core',NULL,NULL,NULL,NULL,1,255.755625,34.47122,0.053,NULL,56338246083,880285095,13754454,15.6),(140202,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140202,33.73,0.2,55.7,67623,74.4,NULL,NULL,'NGC 6292',NULL,'2013AJ....146...86T',2013,1,1.44,NULL,'G',0.00002,NULL,'14.1g',0.71,'Sbc',NULL,NULL,NULL,NULL,1,255.764458333,61.04389,0.017,NULL,57533989536,898968586,14046384,14.1),(140203,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140203,33.88,0.42,59.7,67623,NULL,NULL,NULL,'NGC 6292',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140204,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140204,34.09,0.38,65.9,67623,NULL,NULL,'Malmquist cor.','NGC 6292',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140205,'IRAS','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140205,32.44,0.8,30.7,67624,75,NULL,'MAT, I','ESO 138- G 013',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00001,NULL,'14.24',1.5,'Sc',NULL,NULL,NULL,NULL,1,255.76525,-61.76811,0.557,NULL,44471622485,694869101,10857329,14.24),(140206,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140206,31.75,0.32,22.4,67624,85,NULL,'I, inv','ESO 138- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140207,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140207,31.76,0.32,22.5,67624,85,NULL,'I, raw','ESO 138- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140208,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140208,31.79,0.4,22.8,67624,NULL,NULL,NULL,'ESO 138- G 013',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140209,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140209,32.18,0.43,27.3,67624,75,NULL,'MAT, I, raw','ESO 138- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140210,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140210,32.19,0.43,27.4,67624,75,NULL,'MAT, I, inv','ESO 138- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140211,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140211,32.57,0.43,32.7,67624,75,NULL,'MAT, I, cor','ESO 138- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140212,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140212,35.95,0.46,155,67625,70,NULL,NULL,'ZwCl 1700.5+3322 54',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'16.3g',0.31,'Fuzzy sph. compact',NULL,NULL,NULL,NULL,1,255.7779583,34.63797,0.053,NULL,56338722742,880292542,13754570,16.3),(140213,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140213,37.49,0.46,314,67626,70,NULL,NULL,'2MASXi J1703068+384012',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000075,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,255.778333,38.67003,0.089,NULL,59628898666,931701541,14557836,17),(140214,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140214,37.78,0.46,360,67627,70,NULL,NULL,'2MASX J17030721+6025371',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000111,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.780083,60.42692,0,NULL,57655890671,900873291,14076145,17.3),(140215,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140215,38.17,0.13,430,67628,70,NULL,NULL,'SDSS J170307.59+335828.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000161,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.781667,33.97469,0.065,NULL,56341803074,880340673,13755323,18.7),(140216,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140216,37.91,0.46,382,67629,70,NULL,NULL,'2MASX J17030799+6000380',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000093,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.783125,60.0105,0.009,NULL,57655554819,900868044,14076063,16.8),(140217,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140217,35.48,0.48,125,67630,70,NULL,NULL,'2MASX J17030866-0237020',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'16.59',NULL,NULL,NULL,NULL,NULL,NULL,1,255.7860417,-2.61714,0.613,NULL,45203090548,706298289,11035910,16.59),(140218,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140218,38.17,0.33,430,67631,70,NULL,NULL,'2MASX J17030906+3435548',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,255.7875417,34.59861,0.053,NULL,56338723678,880292557,13754571,17.4),(140219,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140219,37.8,0.1,363,67632,70,NULL,NULL,'2MASXi J1703095+333431',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.789583,33.57522,0.057,NULL,56339641921,880306905,13754795,17.6),(140220,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140220,36.5,0.46,200,67633,70,NULL,NULL,'2MASX J17030997+5939369',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.791333,59.66022,0.021,NULL,57701551359,901586739,14087292,16.5),(140221,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140221,37.8,0.1,363,67634,70,NULL,NULL,'ZwCl 1700.5+3322 41',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000195,NULL,'16.9g',0.26,'Red spherical comp.',NULL,NULL,NULL,NULL,1,255.792375,33.49992,0.057,NULL,56339628861,880306700,13754792,16.9),(140222,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140222,38.17,0.13,430,67635,70,NULL,NULL,'ZwCl 1700.5+3322 46',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.8g',0.19,'Neutral sph. compact',NULL,NULL,NULL,NULL,1,255.7930417,33.87961,0.061,NULL,56341662089,880338470,13755288,17.8),(140223,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140223,37.12,0.46,265,67636,70,NULL,NULL,'ZwCl 1700.5+3322 50',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000181,NULL,'16.5g',0.32,'Red sph.compact,halo',NULL,NULL,NULL,NULL,1,255.80325,33.54431,0.057,NULL,56339630805,880306731,13754792,16.5),(140224,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140224,38.38,0.46,474,67637,70,NULL,NULL,'2MASX J17031387+6332300',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000104,NULL,'16.5g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,255.807833333,63.54181,0.057,NULL,57539649011,899057015,14047765,16.5),(140225,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140225,38.15,0.33,427,67638,70,NULL,NULL,'2MASX J17031592+6304180',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000087,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.816625,63.07156,0.017,NULL,57541709361,899089208,14048268,17.6),(140226,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140226,38.15,0.33,427,67639,70,NULL,NULL,'SDSS J170318.16+630431.7',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,255.8257083,63.07547,0.017,NULL,57541709567,899089211,14048268,18),(140227,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140227,37.85,0.46,371,67640,70,NULL,NULL,'2MASX J17031824+6204580',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.9g',0.18,'NLAGN',NULL,NULL,NULL,NULL,1,255.826417,62.08292,0.009,NULL,57535026610,898984790,14046637,17.9),(140228,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140228,36.57,0.7,206,67641,70,NULL,NULL,'2MASX J17031859-7109173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,255.8275,-71.15486,0.441,NULL,44971627168,702681674,10979401,16.4),(140229,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140229,36.99,0.46,250,67642,70,NULL,NULL,'2MASX J17031864+5925409',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000109,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,255.827625,59.42817,0.021,NULL,57704860374,901638443,14088100,16.3),(140230,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140230,38.17,0.33,430,67643,70,NULL,NULL,'SDSS J170319.04+343613.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,255.829375,34.60364,0.053,NULL,56338733308,880292707,13754573,18.7),(140231,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140231,36.92,0.27,242,67644,70,NULL,NULL,'2MASX J17031921+2254430',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,255.83,22.91211,0.229,NULL,56858406882,888412607,13881446,16.9),(140232,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140232,38.06,0.33,410,67645,70,NULL,NULL,'2MASX J17031974+3503580',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.832375,35.06614,0.073,NULL,56338749201,880292956,13754577,18),(140233,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140233,37.8,0.1,363,67646,70,NULL,NULL,'ZwCl 1700.5+3322 42',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.0g',0.24,'Blue sph. compact',NULL,NULL,NULL,NULL,1,255.832875,33.48206,0.097,NULL,56339746447,880308538,13754820,17),(140234,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140234,37.8,0.1,363,67647,70,NULL,NULL,'2MASX J17032217+3329460',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000155,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.8422917,33.49603,0.097,NULL,56339746243,880308535,13754820,18.3),(140235,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140235,36.98,0.49,249,67648,NULL,NULL,'Malmquist cor.','2MASX J17032243+7846557',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000027,NULL,'16.9V',NULL,'S/I','Group member',NULL,NULL,NULL,1,255.842875,78.78211,0.177,NULL,57128713291,892636145,13947439,16.9),(140236,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140236,37.23,0.44,279,67648,NULL,NULL,NULL,'2MASX J17032243+7846557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140237,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140237,37.27,0.2,284,67648,74.4,NULL,NULL,'2MASX J17032243+7846557',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140238,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140238,36.75,0.27,224,67649,70,NULL,NULL,'2MASX J17032528+2435304',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,255.8554583,24.59164,0.197,NULL,56187552508,877930507,13717664,16.7),(140239,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140239,35.47,0.32,124,67650,NULL,NULL,'Malmquist cor.','ESO 587- G 003',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000003,NULL,'14.37',0.2,'S...',NULL,NULL,NULL,NULL,1,255.8697917,-19.17339,1.017,NULL,46144747898,721011685,11265807,14.37),(140240,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140240,35.53,0.49,128,67650,75,NULL,'IR','ESO 587- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140241,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140241,35.64,0.3,134,67650,NULL,NULL,NULL,'ESO 587- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140242,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140242,35.68,0.2,137,67650,74.4,NULL,NULL,'ESO 587- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140243,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140243,38.27,0.46,452,67651,70,NULL,NULL,'2MASX J17032899+5928480',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000099,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.870958333,59.48014,0.021,NULL,57701403857,901584435,14087256,17.1),(140244,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140244,38.06,0.33,410,67652,70,NULL,NULL,'2MASX J17033106+3506150',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.8795417,35.10431,0.073,NULL,56338759106,880293111,13754579,17.4),(140245,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140245,37.65,0.46,339,67653,70,NULL,NULL,'2MASX J17033141+2503504',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,255.8807083,25.06417,0.193,NULL,56190649574,877978899,13718420,17.8),(140246,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140246,34.68,NULL,86.2,67654,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2102',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',NULL,NULL,'15.68',0.11,'Sd',NULL,NULL,NULL,NULL,1,255.887083,43.98889,0.013,NULL,59647032623,931984884,14562263,15.68),(140247,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140247,34.7,NULL,86.9,67654,NULL,NULL,'Dipole + Quadrupole','FGC 2102',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140248,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140248,34.71,NULL,87.5,67654,NULL,NULL,'Dipole','FGC 2102',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140249,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140249,34.73,NULL,88.5,67654,NULL,NULL,NULL,'FGC 2102',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140250,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140250,35.36,0.49,118,67655,75,NULL,'IR','UGC 10681',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00002,NULL,'15.60',0.2,'Scd:',NULL,NULL,NULL,NULL,1,255.8870417,45.45975,0.037,NULL,59646068162,931969815,14562028,15.6),(140251,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140251,35.67,0.31,136,67655,NULL,NULL,'Malmquist cor.','UGC 10681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140252,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140252,36.08,0.26,165,67655,NULL,NULL,NULL,'UGC 10681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140253,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140253,36.12,0.2,167,67655,74.4,NULL,NULL,'UGC 10681',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140254,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140254,37.8,0.1,363,67656,70,NULL,NULL,'ZwCl 1700.5+3322 51',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000174,NULL,'17.0g',0.23,'Red spherical compac',NULL,NULL,NULL,NULL,1,255.8879583,33.53694,0.097,NULL,56339756232,880308691,13754823,17),(140255,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140255,36.22,0.46,175,67657,70,NULL,NULL,'2MASX J17033419+1922280',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,255.892583,19.37444,0.353,NULL,56867689974,888557655,13883713,16.6),(140256,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140256,38.11,0.46,419,67658,70,NULL,NULL,'2MASX J17033434+3035500',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,255.893167,30.59717,0.181,NULL,56342722279,880355035,13755547,17.4),(140257,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140257,37.53,0.33,321,67659,70,NULL,NULL,'2MASX J17033458+5855030',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000111,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,255.8942917,58.91756,0.017,NULL,57705061737,901641589,14088149,16),(140258,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140258,36.57,0.46,206,67660,70,NULL,NULL,'2MASX J17033507+3558300',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000185,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,255.8962917,35.97494,0.105,NULL,56120379843,876880935,13701264,15.8),(140259,'BCG','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140259,36.61,0.35,199,67661,60,NULL,'ABELL 2256, BCG','NGC 6331',0.055,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.00015,NULL,'16.1V',NULL,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,255.899875,78.629,0.177,NULL,57128744717,892636636,13947447,16.1),(140260,'Tully-Fisher','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,NULL,140260,37.02,0.12,253,67661,70,NULL,'ABELL 2256, BGC','NGC 6331',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140261,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140261,37.53,0.33,321,67662,70,NULL,NULL,'SDSS J170336.14+585336.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000077,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,255.900625,58.8935,0.017,NULL,57705061360,901641583,14088149,18.4),(140262,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140262,33.73,0.46,55.6,67663,70,NULL,NULL,'NGC 6297',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000073,NULL,'14.2g',0.67,'S0',NULL,NULL,NULL,NULL,1,255.9022917,62.02561,0.009,NULL,57535030651,898984853,14046638,14.2),(140263,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140263,37.99,0.46,396,67664,70,NULL,NULL,'2MASX J17033707+2051206',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000196,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.9045,20.85578,0.293,NULL,56871911812,888623622,13884744,18),(140264,'FP','2016-12-15 15:15:44','2016-12-16 11:20:59','1',NULL,'R',140264,38.67,0.46,541,67665,70,NULL,NULL,'2MASX J17033805+3030560',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,255.908666667,30.51567,0.181,NULL,56342731333,880355177,13755549,17.7),(140265,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140265,38.27,0.46,450,67666,70,NULL,NULL,'SDSS J170338.82+253943.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,255.911791667,25.662,0.157,NULL,56188781120,877949705,13717964,18.7),(140266,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140266,37.84,0.33,370,67667,70,NULL,NULL,'2MASX J17034080+6533543',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000092,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,255.9197917,65.56522,0.089,NULL,57571236299,899550567,14055477,16.5),(140267,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140267,36.92,NULL,242,67668,NULL,NULL,NULL,'ABELL 2256',NULL,'2005ApJ...625..108D',2005,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,255.931375,78.71739,0.177,NULL,57128669441,892635460,13947429,NULL),(140268,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140268,37.03,NULL,255,67668,NULL,NULL,NULL,'ABELL 2256',NULL,'2001ApJ...555L..11M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140269,'BCG','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140269,36.61,0.35,199,67668,60,NULL,NULL,'ABELL 2256',0.055,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140270,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140270,37.02,0.12,253,67668,70,NULL,NULL,'ABELL 2256',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140271,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140271,37.13,0.46,267,67669,70,NULL,NULL,'2MASXi J1703432+352627',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'15.87',0.42,NULL,NULL,NULL,NULL,NULL,1,255.930333,35.44097,0.105,NULL,56120742555,876886602,13701353,15.87),(140272,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140272,35.83,0.49,147,67670,70,NULL,NULL,'2MASX J17034507-6348586',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,255.937667,-63.81625,0.593,NULL,44465461319,694772833,10855825,14.9),(140273,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140273,38.08,0.46,413,67671,70,NULL,NULL,'2MASX J17034859+2547130',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000215,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,255.9525,25.78711,0.157,NULL,56188992760,877953011,13718015,16.7),(140274,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140274,36.93,0.46,243,67672,70,NULL,NULL,'2MASX J17034989+3856555',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,255.958,38.94872,0.073,NULL,59640183888,931877873,14560591,16.6),(140275,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2010ag','R',140275,35.59,0.1,131,67673,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10679',NULL,'2015Sci...347.1459K',2015,1,1.29,NULL,'G',0.000176,NULL,'15.4g',0.28,'Sb(f)',NULL,NULL,NULL,NULL,1,255.9709583,31.49911,0.129,NULL,56344703211,880385987,13756031,15.4),(140276,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2010ag','R',140276,35.66,0.08,136,67673,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10679',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140277,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2010ag',NULL,140277,35.75,0.2,137,67673,73.8,NULL,'SALT 2 (SNANA)','UGC 10679',0.034,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140278,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140278,36.75,0.27,224,67674,70,NULL,NULL,'2MASX J17035307+2443360',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,255.97125,24.72678,0.197,NULL,56187233420,877925522,13717586,17.1),(140279,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140279,36,0.23,158,67675,70,NULL,NULL,'2MASX J17035365+2501410',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,255.973667,25.02803,0.193,NULL,56190768635,877980759,13718449,16.7),(140280,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140280,36.37,0.59,188,67676,70,NULL,NULL,'2MASX J17035400-7117311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,255.974916667,-71.29189,0.441,NULL,44095283766,688988808,10765450,17.1),(140281,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140281,36.75,0.27,224,67677,70,NULL,NULL,'2MASX J17035556+2446480',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000198,NULL,'15.6g',0.47,NULL,NULL,NULL,NULL,NULL,1,255.9815,24.78003,0.197,NULL,56190705356,877979771,13718433,15.6),(140282,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140282,37.36,0.46,297,67678,70,NULL,NULL,'2MASX J17035572+3221107',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,255.982208333,32.35306,0.125,NULL,56344333948,880380217,13755940,17.9),(140283,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140283,37.06,0.46,258,67679,70,NULL,NULL,'2MASX J17035811+3757436',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000081,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,255.992083,37.96206,0.093,NULL,59629575009,931712109,14558001,16.8),(140284,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140284,35.64,0.46,134,67680,70,NULL,NULL,'UGC 10678',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000027,NULL,'14.4g',0.79,'S0',NULL,NULL,NULL,NULL,1,255.99375,24.17767,0.165,NULL,56187786653,877934166,13717721,14.4),(140285,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140285,36.16,0.54,170,67681,70,NULL,NULL,'FAIRALL 1459',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5R',0.5,NULL,NULL,NULL,NULL,NULL,1,255.993917,-71.29608,0.441,NULL,44095286758,688988855,10765450,14.5),(140286,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140286,38.25,0.46,446,67682,70,NULL,NULL,'SDSS J170359.63+311844.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,255.9985,31.3125,0.161,NULL,56344475810,880382434,13755975,18.5),(140287,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140287,36,0.23,158,67683,70,NULL,NULL,'CGCG 139-032',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000177,NULL,'14.8g',0.61,NULL,NULL,NULL,NULL,NULL,1,256.0052917,25.05408,0.193,NULL,56190822431,877981600,13718462,14.8),(140288,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140288,40.53,NULL,1280,67684,70,NULL,'Pseudo z = 0.36','GRB 030528',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,256.008333,-22.64972,1.285,NULL,46138041408,720906897,11264170,NULL),(140289,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140289,43.61,0.17,2960,67684,72,NULL,NULL,'GRB 030528',0.78,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140290,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140290,44.19,0.62,3870,67684,72,NULL,NULL,'GRB 030528',0.78,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140291,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140291,44.3,0.59,4070,67684,70,NULL,NULL,'GRB 030528',0.78,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140292,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140292,44.31,0.54,4090,67684,69.7,NULL,'Calibrated','GRB 030528',0.78,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140293,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140293,45.12,0.58,5940,67684,69.7,NULL,'Fiducial','GRB 030528',0.78,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140294,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140294,37.24,0.46,280,67685,70,NULL,NULL,'2MASX J17040205+2107247',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.008666667,21.12353,0.277,NULL,56860865642,888451025,13882047,17.4),(140295,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140295,37.59,0.27,330,67686,70,NULL,NULL,'ZwCl 1700.5+3322 61',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000158,NULL,'17.0g',0.25,'Fuzzy red ell.comp.',NULL,NULL,NULL,NULL,1,256.012375,33.59103,0.097,NULL,56339787387,880309177,13754830,17),(140296,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140296,37.89,0.46,379,67687,70,NULL,NULL,'ZwCl 1700.5+3322 56',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.4g',0.22,'Patchy oval compact',NULL,NULL,NULL,NULL,1,256.016833,34.25811,0.093,NULL,56341730511,880339539,13755305,17.4),(140297,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140297,37.04,0.46,256,67688,70,NULL,NULL,'ZwCl 1700.5+3322 62',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.2g',0.25,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.0212917,33.53131,0.097,NULL,56339778413,880309037,13754828,17.2),(140298,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140298,36.28,0.46,180,67689,70,NULL,NULL,'2MASX J17040781+3852036',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000112,NULL,'15.8g',0.37,'S0^-',NULL,NULL,NULL,NULL,1,256.032583333,38.86764,0.073,NULL,59640131816,931877059,14560579,15.8),(140299,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140299,35.05,0.46,102,67690,70,NULL,NULL,'CGCG 169-038',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000095,NULL,'15.4g',0.48,'HII',NULL,NULL,NULL,NULL,1,256.036333,31.484,0.129,NULL,56344698626,880385916,13756029,15.4),(140300,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140300,36.95,0.46,245,67691,70,NULL,NULL,'2MASX J17040936+6114114',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000065,NULL,'17.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.039083333,61.2365,0.025,NULL,57534108972,898970452,14046413,17.7),(140301,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140301,44.38,1.53,2480,67692,100,NULL,NULL,'GRB 000926',2.0375,'2009EPJC...63..139W',2009,1,NULL,NULL,'G',0.0007,NULL,'22.9R',NULL,'Ulysses/Ko/NE',NULL,NULL,NULL,NULL,1,256.0402083,51.78611,0.017,NULL,57494591981,898352999,14036765,22.9),(140302,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140302,44.51,1.47,2630,67692,100,NULL,NULL,'GRB 000926',2.0375,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140303,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140303,45.09,0.68,3430,67692,69.7,NULL,'Calibrated','GRB 000926',2.0375,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140304,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140304,45.93,0.92,3690,67692,73,NULL,'H const./H=100','GRB 000926',2.0375,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140305,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140305,45.39,0.69,3940,67692,69.7,NULL,'Fiducial','GRB 000926',2.0375,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140306,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140306,45.49,0.69,4130,67692,72,NULL,NULL,'GRB 000926',2.0375,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140307,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140307,45.62,0.69,4340,67692,70,NULL,NULL,'GRB 000926',2.0375,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140308,'GRB','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140308,45.8,0.84,4770,67692,NULL,NULL,NULL,'GRB 000926',2.0375,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140309,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140309,37.59,0.27,330,67693,70,NULL,NULL,'ZwCl 1700.5+3322 63',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000189,NULL,'16.0g',0.43,'Red elliptical',NULL,NULL,NULL,NULL,1,256.048375,33.46072,0.097,NULL,56339767713,880308870,13754826,16),(140310,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140310,37.55,0.46,323,67694,70,NULL,NULL,'SDSS J170413.88+361546.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000176,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.057875,36.26292,0.097,NULL,59626649919,931666404,14557287,18.2),(140311,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140311,37.78,0.46,360,67695,70,NULL,NULL,'2MASX J17041704+2958055',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.071083333,29.96825,0.221,NULL,56342304213,880348503,13755445,17.8),(140312,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140312,37.76,0.46,357,67696,70,NULL,NULL,'2MASX J17041760+3023457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,256.073417,30.39594,0.201,NULL,56342992218,880359253,13755613,17.1),(140313,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140313,37.87,0.46,375,67697,70,NULL,NULL,'SDSS J170417.84+334254.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000141,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.074375,33.71508,0.097,NULL,56339604536,880306320,13754786,18.4),(140314,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140314,38.16,0.46,429,67698,70,NULL,NULL,'2MASX J17041984+2934475',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,256.082833,29.57986,0.253,NULL,56358877257,880607457,13759491,17.4),(140315,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140315,27.41,0.49,3.04,67699,75,NULL,'IR','FGCE 1267',NULL,'2011yCatp016004901K',2011,1,1.1,'Huchtmeier et al. (2005A&A...435..459H) v=257 is for a weak line.','G',0.00001,NULL,'16.8',0.11,'Scd',NULL,NULL,NULL,NULL,1,256.088875,-27.19119,NULL,NULL,45811406678,715803229,11184425,16.8),(140316,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140316,37,0.95,251,67700,70,NULL,NULL,'2MASX J17042135-7136509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,256.08875,-71.61417,0.477,NULL,44095380071,688990313,10765473,16.1),(140317,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140317,37.85,0.33,372,67701,70,NULL,NULL,'2MASX J17042168+6123492',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000104,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.0907083,61.39717,0.025,NULL,57533650759,898963293,14046301,17.2),(140318,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140318,36.14,0.67,169,67702,70,NULL,NULL,'2MASX J17042863-0150499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,256.119333,-1.84731,0.597,NULL,45211145723,706424151,11037877,15.7),(140319,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140319,37.17,0.46,272,67703,70,NULL,NULL,'2MASX J17043107+3404208',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000146,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,256.1295,34.07244,0.093,NULL,56341645554,880338211,13755284,16.9),(140320,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140320,37.38,0.46,299,67704,70,NULL,NULL,'2MASX J17043175+3327348',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,256.13225,33.45956,0.097,NULL,56339772651,880308947,13754827,17.1),(140321,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140321,31.93,0.4,24.3,67705,NULL,NULL,'mean','UGC 10713',NULL,'2007A&A...465...71T',2007,1,2.03,NULL,'G',0.000013,NULL,'14.0g',0.46,'Sb             HII','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,256.14175,72.44664,0.185,NULL,57098637319,892166208,13940097,14),(140322,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140322,32.35,0.43,29.5,67705,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140323,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140323,32.57,0.46,32.7,67705,NULL,NULL,'J','UGC 10713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140324,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140324,32.6,0.47,33.2,67705,NULL,NULL,'H','UGC 10713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140325,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140325,32.63,0.45,33.6,67705,NULL,NULL,'K','UGC 10713',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140326,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140326,32.72,0.43,35,67705,75,NULL,'3.6 micron, color corrected','UGC 10713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140327,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140327,33.08,0.2,41.3,67705,74.4,NULL,NULL,'UGC 10713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140328,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140328,37.6,0.46,332,67706,70,NULL,NULL,'2MASX J17043500+3424508',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.145916667,34.41419,0.081,NULL,56341828921,880341076,13755329,17.9),(140329,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140329,37.61,0.46,332,67707,70,NULL,NULL,'2MASX J17043788+2117104',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000136,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.1579583,21.28611,0.277,NULL,56860780956,888449702,13882026,18.5),(140330,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140330,37.85,0.33,372,67708,70,NULL,NULL,'2MASX J17043838+6127186',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000123,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,256.159875,61.45506,0.017,NULL,57533636283,898963066,14046297,17.5),(140331,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140331,38.33,0.46,464,67709,70,NULL,NULL,'2MASX J17044580+3406358',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00016,NULL,'17.6g',0.16,'S0',NULL,NULL,NULL,NULL,1,256.190917,34.10994,0.093,NULL,56341924865,880342576,13755352,17.6),(140332,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140332,36.97,0.46,248,67710,70,NULL,NULL,'2MASX J17044713+6102476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00007,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.196541667,61.04656,0.017,NULL,57534294854,898973357,14046458,17.5),(140333,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140333,37.84,0.33,370,67711,70,NULL,NULL,'2MASX J17044850+6531517',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00007,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,256.201875,65.531,0.113,NULL,57571243164,899550674,14055479,17.4),(140334,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140334,36.25,0.46,178,67712,70,NULL,NULL,'2MASX J17044847+3855447',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000092,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,256.2020417,38.92922,0.133,NULL,59641964856,931905700,14561026,16.3),(140335,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140335,37.18,0.46,273,67713,70,NULL,NULL,'2MASX J17045047+3800377',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.2102917,38.01036,0.137,NULL,59629524285,931711316,14557989,16.8),(140336,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140336,35.03,NULL,101,67714,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10694',NULL,'2010Ap&SS.325..163P',2010,1,1.15,NULL,'G',NULL,NULL,'17.',0.08,'Sd',NULL,NULL,NULL,NULL,1,256.234458333,43.24178,0,NULL,59644863980,931950999,14561734,17);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (140337,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140337,35.05,NULL,102,67714,NULL,NULL,'Dipole + Quadrupole','UGC 10694',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140338,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140338,35.06,0.49,103,67714,75,NULL,'IR','UGC 10694',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140339,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140339,35.06,NULL,103,67714,NULL,NULL,'Dipole','UGC 10694',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140340,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140340,35.09,NULL,104,67714,NULL,NULL,NULL,'UGC 10694',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140341,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140341,36.18,0.46,172,67715,70,NULL,NULL,'2MASX J17045631+2100219',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000186,NULL,'15.4g',0.53,'E0',NULL,NULL,NULL,NULL,1,256.23475,21.00617,0.293,NULL,56860731274,888448926,13882014,15.4),(140342,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140342,34.86,0.57,93.8,67716,70,NULL,NULL,'UGC 10683 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.2,'SB             BLSy1',NULL,NULL,NULL,NULL,1,256.2369583,-1.53044,0.581,NULL,45214038036,706469344,11038583,14.4),(140343,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140343,34.39,0.51,75.5,67717,70,NULL,NULL,'2MASX J17045714-0250187',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.74',0.3,NULL,NULL,NULL,NULL,NULL,1,256.238,-2.83856,0.661,NULL,45210516057,706414313,11037723,16.74),(140344,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140344,35.96,0.46,156,67718,70,NULL,NULL,'2MASX J17045827+3838183',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000108,NULL,'16.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,256.242917,38.63839,0.137,NULL,59627540467,931680319,14557504,16.2),(140345,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140345,38.26,0.46,450,67719,70,NULL,NULL,'2MASX J17050068+6034237',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,256.25325,60.57339,0,NULL,57654978783,900859043,14075922,18),(140346,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140346,36.34,0.46,185,67720,70,NULL,NULL,'2MASX J17050251+2521397',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,256.260417,25.36108,0.169,NULL,56188504796,877945387,13717896,16.5),(140347,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140347,35.58,0.49,131,67721,75,NULL,'IR','UGC 10701',NULL,'2011yCatp016004901K',2011,1,1.15,NULL,'G',NULL,NULL,'16.0',0.13,'Sbc',NULL,NULL,NULL,NULL,1,256.278625,52.70617,0.037,NULL,57493104076,898329751,14036402,16),(140348,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140348,35.85,NULL,148,67721,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140349,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140349,35.86,NULL,148,67721,NULL,NULL,'Dipole + Quadrupole','UGC 10701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140350,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140350,35.88,NULL,150,67721,NULL,NULL,'Dipole','UGC 10701',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140351,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140351,35.88,NULL,150,67721,NULL,NULL,NULL,'UGC 10701',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140352,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140352,37.18,0.46,273,67722,70,NULL,NULL,'2MASX J17050973+2122250',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000099,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.290541667,21.37372,0.289,NULL,56860893658,888451463,13882054,17.9),(140353,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140353,37.89,0.46,379,67723,70,NULL,NULL,'2MASX J17051105+3051021',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,256.296083,30.8505,0.185,NULL,56342793045,880356141,13755564,18),(140354,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140354,38.03,0.46,404,67724,70,NULL,NULL,'2MASX J17051244+2809391',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.3017083,28.16097,0.325,NULL,56316410810,879943918,13749123,17.7),(140355,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140355,37.59,0.46,330,67725,70,NULL,NULL,'2MASX J17051357+2353282',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000157,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.3065417,23.89108,0.169,NULL,56673535611,885523993,13836312,18.7),(140356,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140356,38.06,0.46,410,67726,70,NULL,NULL,'ZwCl 1700.5+3322 69',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00018,NULL,'17.1g',0.24,'Red fuzzy sph.comp.',NULL,NULL,NULL,NULL,1,256.307333,33.81194,0.097,NULL,56341182633,880330978,13755171,17.1),(140357,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140357,36.95,0.46,246,67727,70,NULL,NULL,'2MASX J17051493+2127295',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000177,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,256.3122917,21.45825,0.289,NULL,56860876436,888451194,13882049,16.5),(140358,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140358,37.18,0.46,273,67728,70,NULL,NULL,'2MASX J17051511+3217511',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.313167,32.29767,0.165,NULL,56344315953,880379936,13755936,17.7),(140359,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140359,37.59,0.27,330,67729,70,NULL,NULL,'ZwCl 1700.5+3322 65',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'17.3g',0.21,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.319,33.51497,0.097,NULL,56339285165,880301330,13754708,17.3),(140360,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140360,36.57,0.46,206,67730,70,NULL,NULL,'2MASX J17052006+2428132',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,256.33375,24.47031,0.177,NULL,56187838108,877934970,13717733,16.6),(140361,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140361,37.44,0.46,308,67731,70,NULL,NULL,'2MASX J17052124+3829374',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000096,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,256.3385417,38.49383,0.129,NULL,59627595899,931681185,14557518,16.8),(140362,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140362,37.16,0.46,271,67732,70,NULL,NULL,'2MASX J17052410+2103155',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000171,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,256.3505417,21.05439,0.277,NULL,56860971987,888452687,13882073,16.9),(140363,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140363,36.38,0.46,189,67733,70,NULL,NULL,'2MASX J17052510+2051135',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000175,NULL,'16.1g',0.38,'E/S0',NULL,NULL,NULL,NULL,1,256.354625,20.85392,0.293,NULL,56860934735,888452105,13882064,16.1),(140364,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140364,35.62,0.41,133,67734,NULL,NULL,NULL,'UGC 10692',NULL,'2009ApJS..182..474S',2009,1,1.66,NULL,'G',0.00002,NULL,'14.8g',0.37,'Sb',NULL,NULL,NULL,NULL,1,256.367083,23.15319,0.217,NULL,56858081094,888407517,13881367,14.8),(140365,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140365,35.63,0.4,134,67734,NULL,NULL,'Malmquist cor.','UGC 10692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140366,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140366,35.65,0.47,135,67734,NULL,NULL,'H','UGC 10692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140367,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140367,35.71,0.4,138,67734,NULL,NULL,'mean','UGC 10692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140368,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140368,35.7,0.2,138,67734,74.4,NULL,NULL,'UGC 10692',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140369,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140369,35.71,0.45,139,67734,NULL,NULL,'K','UGC 10692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140370,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140370,35.92,0.46,153,67734,NULL,NULL,'J','UGC 10692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140371,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140371,35.69,0.46,137,67735,70,NULL,NULL,'CGCG 197-032',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000195,NULL,'15.2g',0.5,'E/S0',NULL,NULL,NULL,NULL,1,256.369666667,35.63467,0.121,NULL,56120608906,876884514,13701320,15.2),(140372,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140372,36.15,0.27,170,67736,70,NULL,NULL,'B2 1703+22',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.00008,NULL,'15.1g',0.59,'E;LINER  cand. BLLAC',NULL,NULL,NULL,NULL,1,256.3722083,22.26878,0.277,NULL,56861513786,888461152,13882205,15.1),(140373,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140373,37.63,0.27,337,67737,70,NULL,NULL,'2MASX J17053196+3345163',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.38325,33.75439,0.097,NULL,56339321306,880301895,13754717,17.6),(140374,'BL Lac Luminosity','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140374,40.74,NULL,1100,67738,NULL,NULL,NULL,'[HB89] 1704+607',0.28,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'19.4',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,256.395083,60.70439,0,NULL,57533453450,898960210,14046253,19.4),(140375,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140375,37.76,0.46,357,67739,70,NULL,NULL,'SDSS J170535.98+585630.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000097,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.3999583,58.94186,0.009,NULL,57705201416,901643772,14088183,17.7),(140376,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140376,36.46,0.46,196,67740,70,NULL,NULL,'ZwCl 1700.5+3322 70',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.6g',0.21,'Neutral patchy ell.',NULL,NULL,NULL,NULL,1,256.413333,32.96378,0.101,NULL,56353483770,880523183,13758174,16.6),(140377,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140377,37.82,0.46,367,67741,70,NULL,NULL,'2MASX J17054169+2906592',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.4237917,29.11642,0.289,NULL,56313678961,879901233,13748456,17.4),(140378,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140378,38.62,0.46,529,67742,70,NULL,NULL,'2MASX J17054332+6217518',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.430167,62.29794,0.049,NULL,57535206230,898987597,14046681,17.8),(140379,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140379,36.15,0.27,170,67743,70,NULL,NULL,'2MASX J17054435+2214502',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000097,NULL,'15.2g',0.53,'E0',NULL,NULL,NULL,NULL,1,256.434833,22.24722,0.277,NULL,56861500778,888460949,13882202,15.2),(140380,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140380,36.19,0.46,173,67744,70,NULL,NULL,'2MASX J17054464+2438564',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00016,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,256.436,24.64903,0.177,NULL,56187335199,877927112,13717611,17.3),(140381,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140381,37.38,0.46,299,67745,70,NULL,NULL,'2MASX J17054561+5915407',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000096,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,256.4399583,59.26142,0.013,NULL,57704973843,901640216,14088128,17),(140382,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140382,36.84,0.46,234,67746,70,NULL,NULL,'2MASX J17054720+3538323',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000167,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.446583,35.64239,0.121,NULL,56120621230,876884706,13701323,16.7),(140383,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140383,37.78,0.46,360,67747,70,NULL,NULL,'SDSS J170547.75+340338.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,256.449,34.06081,0.093,NULL,56341919453,880342491,13755351,18.5),(140384,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140384,36.15,0.27,170,67748,70,NULL,NULL,'2MASX J17054954+2213572',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000172,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,256.456417,22.23261,0.277,NULL,56861628801,888462950,13882233,16.4),(140385,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140385,37.63,0.27,337,67749,70,NULL,NULL,'ZwCl 1700.5+3322 74',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00017,NULL,'17.1g',0.24,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.4604583,33.61036,0.097,NULL,56339435746,880303683,13754745,17.1),(140386,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140386,34.77,0.47,89.9,67750,70,NULL,NULL,'ESO 101-IG 021 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.000143,NULL,'15.15',NULL,'E M','Pair member (points to parent)',NULL,NULL,NULL,1,256.4717083,-63.45692,0.605,NULL,44482792681,695043635,10860056,15.15),(140387,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140387,36.68,0.8,217,67751,70,NULL,NULL,'2MASX J17055495-8020252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,256.4790417,-80.34044,0.437,NULL,44261334416,691583350,10805989,16.2),(140388,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140388,37.83,0.46,369,67752,70,NULL,NULL,'2MASX J17060208+2041332',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.5085,20.69269,0.293,NULL,56871747390,888621052,13884703,17),(140389,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140389,37.23,0.46,279,67753,70,NULL,NULL,'SDSS J170602.31+585513.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000088,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,256.509667,58.92053,0.009,NULL,57705187934,901643561,14088180,17.8),(140390,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140390,37.98,0.46,395,67754,70,NULL,NULL,'2MASX J17060747+6318258',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000085,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,256.530875,63.30714,0.053,NULL,57572112844,899564263,14055691,17.2),(140391,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140391,37.72,0.46,349,67755,70,NULL,NULL,'ZwCl 1700.5+3322 75',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000195,NULL,'16.3g',0.35,'BrClG          AGN',NULL,NULL,NULL,NULL,1,256.5317917,33.48283,0.097,NULL,56339457556,880304024,13754750,16.3),(140392,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140392,38.12,0.19,420,67756,70,NULL,NULL,'SDSS J170608.58+312719.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.53575,31.45533,0.137,NULL,56345662412,880400975,13756265,18.2),(140393,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140393,38.12,0.19,420,67757,70,NULL,NULL,'2MASX J17060990+3127308',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,256.54125,31.45847,0.137,NULL,56345662301,880400973,13756265,17.3),(140394,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140394,37.04,0.46,255,67758,70,NULL,NULL,'2MASX J17061067+4004088',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,256.5445417,40.06908,0.113,NULL,59642772443,931918319,14561223,17),(140395,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140395,37.48,0.33,314,67759,70,NULL,NULL,'2MASX J17061440+3014158',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000179,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,256.56025,30.23767,0.217,NULL,56342155830,880346184,13755409,16.6),(140396,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140396,36.79,0.58,228,67760,70,NULL,NULL,'2MASX J17061481-6311428',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,256.561667,-63.19519,0.689,NULL,44482699012,695042172,10860033,14.6),(140397,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140397,36.04,0.58,161,67761,70,NULL,NULL,'2MASX J17061816-2402182',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,256.57575,-24.03842,1.437,NULL,45801849727,715653901,11182092,16.5),(140398,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140398,37.48,0.33,314,67762,70,NULL,NULL,'2MASX J17061996+3014018',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.583125,30.23383,0.217,NULL,56342157766,880346215,13755409,17.9),(140399,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140399,37.96,0.46,390,67763,70,NULL,NULL,'2MASX J17062160+3349048',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,256.589875,33.81797,0.097,NULL,56341187641,880331056,13755172,17.7),(140400,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140400,38.12,0.19,420,67764,70,NULL,NULL,'SDSS J170623.24+312847.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.596875,31.47981,0.137,NULL,56346206501,880409476,13756398,18.5),(140401,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140401,38.04,0.46,405,67765,70,NULL,NULL,'2MASX J17062499+6339144',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000094,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.604125,63.65408,0.057,NULL,57572208256,899565754,14055714,17.7),(140402,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140402,38.21,0.46,439,67766,70,NULL,NULL,'2MASX J17062542+2023086',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000145,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,256.6060417,20.38583,0.289,NULL,56871797409,888621834,13884716,17.8),(140403,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140403,36.85,0.46,234,67767,70,NULL,NULL,'2MASX J17062667+2324096',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.61125,23.40278,0.209,NULL,56858233453,888409897,13881404,17.2),(140404,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140404,35.8,0.27,144,67768,70,NULL,NULL,'SDSS J170627.25+343011.7',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000171,NULL,'15.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,256.6135417,34.50325,0.081,NULL,56341466738,880335417,13755240,15.6),(140405,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140405,38.12,0.19,420,67769,70,NULL,NULL,'2MASX J17062733+3126148',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.613875,31.43753,0.137,NULL,56346176012,880409000,13756390,17.7),(140406,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140406,35.19,0.8,109,67770,75,NULL,'CF, r','UGC 10706',NULL,'1997ApJS..109..333W',1997,1,1.21,NULL,'G',0.000081,NULL,'14.7g',0.55,'Sbc',NULL,NULL,NULL,NULL,1,256.618791667,38.3635,0.129,NULL,59627756197,931683690,14557557,14.7),(140407,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140407,34.9,0.38,95.4,67770,75,NULL,'CF, r, raw','UGC 10706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140408,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140408,35.06,0.38,103,67770,75,NULL,'CF, r, inv','UGC 10706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140409,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140409,35.26,0.38,113,67770,75,NULL,'CF, r, cor','UGC 10706',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140410,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140410,37.63,0.27,337,67771,70,NULL,NULL,'2MASX J17062994+3347558',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000179,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,256.6245417,33.79883,0.089,NULL,56341184836,880331013,13755172,18.2),(140411,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140411,37.69,0.33,345,67772,70,NULL,NULL,'2MASX J17063086+6240444',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000082,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,256.628875,62.67897,0.057,NULL,57534467656,898976057,14046500,16.8),(140412,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140412,37.96,0.46,391,67773,70,NULL,NULL,'SDSS J170632.13+644314.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.634,64.72069,0.109,NULL,57571512874,899554888,14055545,17.5),(140413,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140413,38.12,0.19,420,67774,70,NULL,NULL,'2MASX J17063297+3124479',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00017,NULL,'16.0g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,256.637333333,31.41336,0.137,NULL,56346181553,880409086,13756391,16),(140414,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140414,37.74,0.46,353,67775,70,NULL,NULL,'2MASX J17063342+3411089',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.6392917,34.18575,0.093,NULL,56341991016,880343609,13755368,17.2),(140415,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140415,36,0.23,158,67776,70,NULL,NULL,'UGC 10702',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000163,NULL,'14.7g',0.6,'Disturbed',NULL,NULL,NULL,NULL,1,256.652125,24.775,0.185,NULL,56187315197,877926799,13717606,14.7),(140416,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140416,36,0.23,158,67777,70,NULL,NULL,'2MASX J17063903+2441155',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000195,NULL,'16.2g',0.31,NULL,NULL,NULL,NULL,NULL,1,256.66275,24.68753,0.185,NULL,56187296724,877926511,13717601,16.2),(140417,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140417,37.69,0.33,345,67778,70,NULL,NULL,'2MASX J17064364+6241035',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000097,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.682041667,62.68436,0.057,NULL,57534464769,898976012,14046500,17.6),(140418,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140418,36.16,0.65,170,67779,70,NULL,NULL,'2MASX J17064475-6118133',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,256.6862917,-61.30378,0.737,NULL,44468744324,694824130,10856627,15.3),(140419,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140419,37.92,0.46,383,67780,70,NULL,NULL,'2MASX J17064530+3522439',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,256.688791667,35.37889,0.109,NULL,56120073860,876876154,13701189,18.3),(140420,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140420,36.76,0.46,224,67781,70,NULL,NULL,'2MASX J17064532+3110209',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,256.688917,31.17244,0.165,NULL,56346073887,880407404,13756365,18.1),(140421,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140421,37.92,0.46,383,67782,70,NULL,NULL,'2MASX J17064771+5912297',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.698583,59.20811,0.009,NULL,57704527202,901633237,14088019,17.3),(140422,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140422,37.77,0.46,357,67783,70,NULL,NULL,'2MASX J17065165+3919346',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,256.715125,39.32636,0.121,NULL,59642082944,931907546,14561055,17.6),(140423,'SNII optical','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2000bs',NULL,140423,34.71,0.31,82.8,67784,NULL,NULL,'SEAM','UGC 10710',0.027976,'2009ApJ...694.1067P',2009,1,1.5,NULL,'G',0.0001,NULL,'15.03',0.4,'Sb','Group member',NULL,NULL,NULL,1,256.718833333,43.12219,0,NULL,59645092701,931954573,14561790,15.03),(140424,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140424,35.05,0.49,102,67784,75,NULL,'IR','UGC 10710',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140425,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140425,35.25,0.47,112,67784,NULL,NULL,'H','UGC 10710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140426,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140426,35.35,0.2,117,67784,74.4,NULL,NULL,'UGC 10710',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140427,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140427,35.4,0.4,120,67784,NULL,NULL,'mean','UGC 10710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140428,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140428,35.41,0.45,121,67784,NULL,NULL,'K','UGC 10710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140429,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140429,35.45,0.46,123,67784,NULL,NULL,'J','UGC 10710',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140430,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140430,36.52,0.46,201,67785,70,NULL,NULL,'2MASX J17065329+2009591',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000175,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,256.722,20.16653,0.293,NULL,56867553203,888555518,13883679,16.6),(140431,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140431,36.92,0.46,242,67786,70,NULL,NULL,'2MASX J17065562+2047451',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'17.01',0.31,NULL,NULL,NULL,NULL,NULL,1,256.7317083,20.79597,0.293,NULL,56871715112,888620548,13884696,17.01),(140432,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140432,36.47,0.61,197,67787,70,NULL,NULL,'2MASX J17065784-6524463',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,256.740917,-65.41289,0.373,NULL,44480719784,695011246,10859550,15.6),(140433,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140433,31.12,0.8,16.7,67788,75,NULL,'MAT, I','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,1,6.16,'The 2MASX position is strongly weighted by a superposed star.','G',0.00001,NULL,'13.20',0.56,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,256.74675,-62.08286,0.557,NULL,44470592647,694853010,10857078,13.2),(140434,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140434,31.12,0.8,16.7,67788,75,NULL,'A82, H','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140435,'Tully est','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140435,31.45,0.8,19.5,67788,75,NULL,NULL,'ESO 138- G 014',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140436,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140436,30.98,0.39,15.7,67788,73,NULL,'IR','ESO 138- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140437,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140437,30.98,0.4,15.7,67788,75,NULL,NULL,'ESO 138- G 014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140438,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140438,31.01,0.47,15.9,67788,75,NULL,'A82, H, inv','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140439,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140439,31.09,0.47,16.5,67788,75,NULL,'A82, H, raw','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140440,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140440,31.21,NULL,17.5,67788,NULL,NULL,'Dipole','ESO 138- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140441,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140441,31.21,NULL,17.5,67788,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 138- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140442,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140442,31.22,NULL,17.5,67788,NULL,NULL,'Dipole + Quadrupole','ESO 138- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140443,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140443,31.29,NULL,18.1,67788,NULL,NULL,NULL,'ESO 138- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140444,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140444,31.52,0.47,20.1,67788,75,NULL,'A82, H, cor','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140445,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140445,31.54,0.43,20.3,67788,75,NULL,'3.6 micron, color + selection bias corrected','ESO 138- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140446,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140446,31.55,0.35,20.4,67788,NULL,NULL,NULL,'ESO 138- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140447,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140447,31.69,0.4,21.8,67788,NULL,NULL,'mean','ESO 138- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140448,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140448,31.77,0.49,22.6,67788,75,NULL,'IR','ESO 138- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140449,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140449,31.94,0.43,24.5,67788,75,NULL,'3.6 micron, color corrected','ESO 138- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140450,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140450,32.22,0.2,27.8,67788,74.4,NULL,NULL,'ESO 138- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140451,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140451,32.25,0.46,28.2,67788,NULL,NULL,'J','ESO 138- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140452,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140452,32.32,0.47,29.2,67788,NULL,NULL,'H','ESO 138- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140453,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140453,32.53,0.45,32.1,67788,NULL,NULL,'K','ESO 138- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140454,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140454,33.23,0.32,44.2,67788,85,NULL,'I, inv','ESO 138- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140455,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140455,33.23,0.32,44.3,67788,85,NULL,'I, raw','ESO 138- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140456,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140456,33.41,0.43,48,67788,75,NULL,'MAT, I, raw','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140457,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140457,33.45,0.43,49,67788,75,NULL,'MAT, I, inv','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140458,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140458,33.72,0.43,55.5,67788,75,NULL,'MAT, I, cor','ESO 138- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140459,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140459,38.12,0.19,420,67789,70,NULL,NULL,'2MASX J17070007+3120019',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,256.750333,31.33389,0.145,NULL,56346238166,880409971,13756405,18.3),(140460,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140460,37.99,0.46,396,67790,70,NULL,NULL,'2MASX J17070028+3453049',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.7512917,34.88475,0.093,NULL,56341352221,880333628,13755212,17.2),(140461,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140461,35.82,0.46,146,67791,70,NULL,NULL,'2MASX J17070158+6111525',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000074,NULL,'15.8g',0.51,NULL,NULL,NULL,NULL,NULL,1,256.756875,61.19806,0.037,NULL,57533696602,898964009,14046312,15.8),(140462,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140462,37.27,0.46,284,67792,70,NULL,NULL,'2MASX J17070588+3457111',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,256.7744583,34.95325,0.093,NULL,56341364387,880333818,13755215,16.8),(140463,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140463,35.8,0.27,144,67793,70,NULL,NULL,'CGCG 197-038',NULL,'2015arXiv151105856S',2015,1,0.93,NULL,'G',0.000172,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,256.777041667,34.23469,0.113,NULL,56341131191,880330174,13755158,15.1),(140464,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140464,35.96,0.49,155,67794,75,NULL,'IR','FGC 2109',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000017,NULL,'16.4',0.11,'Sc',NULL,NULL,NULL,NULL,1,256.779875,8.92686,0.301,NULL,56003910928,875061108,13672829,16.4),(140465,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140465,36.01,NULL,160,67794,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2109',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140466,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140466,36.02,NULL,160,67794,NULL,NULL,'Dipole + Quadrupole','FGC 2109',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140467,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140467,36.02,NULL,160,67794,NULL,NULL,'Dipole','FGC 2109',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140468,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140468,36.13,NULL,168,67794,NULL,NULL,NULL,'FGC 2109',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140469,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140469,36.62,0.43,211,67794,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2109',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140470,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140470,35.8,0.27,144,67795,70,NULL,NULL,'CGCG 197-039',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000147,NULL,'15.4',0.4,'E, with compact core',NULL,NULL,NULL,NULL,1,256.7919583,34.26978,0.113,NULL,56341128164,880330127,13755158,15.4),(140471,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10qjq',NULL,140471,34.97,0.02,95.9,67796,70,NULL,'SiFTO+SALT2, SN PTF10qjq','PTF10qjq',0.0288,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,256.801625,35.50981,0.109,NULL,56120279917,876879373,13701240,NULL),(140472,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10qjq',NULL,140472,35.53,0.03,124,67796,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qjq',0.0288,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140473,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140473,38.82,0.46,580,67797,70,NULL,NULL,'SDSS J170714.05+314404.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000161,NULL,'18.7g',0.09,NULL,NULL,NULL,NULL,NULL,1,256.808583,31.73458,0.145,NULL,56345360111,880396251,13756191,18.7),(140474,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140474,36.88,0.46,237,67798,70,NULL,NULL,'ZwCl 1700.5+3322 77',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.2g',0.23,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.815667,33.27281,0.129,NULL,56353348699,880521073,13758141,17.2),(140475,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140475,35.79,0.46,144,67799,70,NULL,NULL,'ZwCl 1700.5+3322 78',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'16.4g',0.27,'Neutral patchy comp.',NULL,NULL,NULL,NULL,1,256.820083,33.29539,0.129,NULL,56353348603,880521071,13758141,16.4),(140476,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140476,37.49,0.46,314,67800,70,NULL,NULL,'2MASX J17071750+2751334',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,256.822833,27.85944,0.213,NULL,56314588327,879915442,13748678,17.4),(140477,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140477,37.99,0.33,396,67801,70,NULL,NULL,'2MASX J17071831+3344052',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,256.82625,33.73483,0.089,NULL,56339230065,880300469,13754694,17.7),(140478,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140478,38.06,0.33,409,67802,70,NULL,NULL,'2MASX J17071987+3323193',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.83275,33.38867,0.125,NULL,56353334708,880520854,13758138,17.6),(140479,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140479,36.94,0.46,245,67803,70,NULL,NULL,'2MASX J17072125+5941582',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000111,NULL,'16.2g',0.36,NULL,NULL,NULL,NULL,NULL,1,256.8384583,59.69969,0.017,NULL,57702027711,901594182,14087409,16.2),(140480,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140480,37.99,0.33,396,67804,70,NULL,NULL,'ZwCl 1700.5+3322 87',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.1g',0.23,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.839541667,33.68883,0.089,NULL,56339262672,880300979,13754702,17.1),(140481,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140481,37.52,0.46,319,67805,70,NULL,NULL,'ZwCl 1700.5+3322 85',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'16.9g',0.26,'Red spherical comp.',NULL,NULL,NULL,NULL,1,256.8400417,33.97056,0.113,NULL,56341283319,880332551,13755196,16.9),(140482,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140482,38.06,0.33,409,67806,70,NULL,NULL,'2MASX J17072291+3324483',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,256.845625,33.41347,0.125,NULL,56353118326,880517473,13758085,17.9),(140483,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140483,37.57,0.46,327,67807,70,NULL,NULL,'2MASX J17072431+5805102',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000086,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,256.851208333,58.08611,0,NULL,57703754675,901621166,14087830,17),(140484,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140484,35.12,NULL,106,67808,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10714',NULL,'2010Ap&SS.325..163P',2010,1,1.74,NULL,'G',0.000011,NULL,'15.3g',0.26,'Sb(f)',NULL,NULL,NULL,NULL,1,256.855166667,30.225,0.217,NULL,56359724043,880620688,13759698,15.3),(140485,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140485,35.13,NULL,106,67808,NULL,NULL,'Dipole + Quadrupole','UGC 10714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140486,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140486,35.14,NULL,107,67808,NULL,NULL,'Dipole','UGC 10714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140487,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140487,35.19,NULL,109,67808,NULL,NULL,NULL,'UGC 10714',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140488,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140488,35.57,0.2,130,67808,74.4,NULL,NULL,'UGC 10714',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140489,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140489,37.08,0.33,260,67809,70,NULL,NULL,'2MASX J17072546+2155197',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000198,NULL,'16.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.85625,21.92225,0.301,NULL,56860562221,888446284,13881973,16.7),(140490,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140490,37.54,0.33,322,67810,70,NULL,NULL,'2MASX J17072866+3050153',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.8694583,30.83753,0.185,NULL,56342463540,880350992,13755484,17.8),(140491,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140491,37.89,0.33,379,67811,70,NULL,NULL,'2MASX J17072902+6323071',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,256.87075,63.38528,0.053,NULL,57572324588,899567571,14055743,18),(140492,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140492,38.29,0.46,455,67812,70,NULL,NULL,'2MASX J17073851+6049141',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,256.9107917,60.8205,0.037,NULL,57533351366,898958615,14046228,17.9),(140493,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140493,37.6,0.46,331,67813,70,NULL,NULL,'SDSS J170740.40+612158.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000069,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,256.918416667,61.36622,0.041,NULL,57533749107,898964829,14046325,18.3),(140494,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140494,37.54,0.46,322,67814,70,NULL,NULL,'SDSS J170741.30+653439.5',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000074,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.922125,65.57764,0.113,NULL,57516616270,898697129,14042142,17.9),(140495,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140495,38.11,0.46,419,67815,70,NULL,NULL,'2MASX J17074261+6526572',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,256.927583,65.44917,0.113,NULL,57571163027,899549422,14055459,17.7),(140496,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140496,35.43,NULL,122,67816,NULL,NULL,'Dipole','UGC 10716',NULL,'2010Ap&SS.325..163P',2010,1,1.3,NULL,'G',0.000018,NULL,'16.0g',0.22,'Sb(f)','Field galaxy',NULL,NULL,NULL,1,256.9355,30.32642,0.177,NULL,56359463857,880616622,13759634,16),(140497,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140497,35.43,NULL,122,67816,NULL,NULL,'Dipole + Quadrupole','UGC 10716',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140498,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140498,35.43,NULL,122,67816,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10716',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140499,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140499,35.53,0.49,128,67816,75,NULL,'IR','UGC 10716',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140500,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140500,35.63,NULL,134,67816,NULL,NULL,NULL,'UGC 10716',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140501,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140501,35.92,0.39,153,67816,NULL,NULL,'Malmquist cor.','UGC 10716',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140502,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140502,35.94,0.2,154,67816,74.4,NULL,NULL,'UGC 10716',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140503,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140503,36.13,0.35,168,67816,NULL,NULL,NULL,'UGC 10716',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140504,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140504,37.58,0.33,329,67817,70,NULL,NULL,'SDSS J170745.22+643631.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,256.938458333,64.60878,0.085,NULL,57574847721,899606995,14056359,18.1),(140505,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140505,37.53,0.23,321,67818,70,NULL,NULL,'2MASX J17074532+2941233',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00017,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.93875,29.68981,0.265,NULL,56359839804,880622496,13759726,17.5),(140506,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140506,38.07,0.46,411,67819,70,NULL,NULL,'2MASX J17074641+3332081',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000141,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.943333,33.53572,0.089,NULL,56353154701,880518042,13758094,18),(140507,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140507,41.83,0.18,1120,67820,65,NULL,'RPK','H-ZSNS J170748.26+440126.2',0.44,'1998ApJ...493L..53G',1998,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,256.951083,44.02394,0,NULL,59644375191,931943362,14561615,NULL),(140508,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140508,42.06,0.19,1250,67820,65,NULL,'H96','H-ZSNS J170748.26+440126.2',0.44,'1998ApJ...493L..53G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140509,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce','R',140509,41.32,NULL,1280,67820,65,NULL,'SALT','H-ZSNS J170748.26+440126.2',0.44,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140510,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140510,41.34,0.33,1290,67820,74.2,NULL,'SALT 2','H-ZSNS J170748.26+440126.2',0.44,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140511,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140511,41.95,0.17,1700,67820,65,NULL,'MLCS','H-ZSNS J170748.26+440126.2',0.44,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140512,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140512,42.02,0.29,1760,67820,70,NULL,'SALT','H-ZSNS J170748.26+440126.2',0.44,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140513,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140513,42.08,0.19,1810,67820,65,NULL,NULL,'H-ZSNS J170748.26+440126.2',0.44,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140514,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140514,42.2,0.28,1910,67820,65,NULL,'SALT','H-ZSNS J170748.26+440126.2',0.44,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140515,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 1997ce',NULL,140515,42.26,0.16,1970,67820,65,NULL,'Template','H-ZSNS J170748.26+440126.2',0.44,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140516,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140516,37.29,0.46,287,67821,70,NULL,NULL,'2MASX J17075014+2958582',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.958833,29.98292,0.233,NULL,56359858156,880622783,13759730,17.4),(140517,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140517,37.53,0.23,321,67822,70,NULL,NULL,'2MASX J17075185+2945436',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,256.9662083,29.76211,0.233,NULL,56359845097,880622579,13759727,16.3),(140518,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140518,37.39,0.46,300,67823,70,NULL,NULL,'2MASX J17075227+3017032',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000174,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,256.967917,30.28422,0.177,NULL,56359512400,880617381,13759646,16.9),(140519,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140519,37.54,0.33,322,67824,70,NULL,NULL,'2MASX J17075252+3052002',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,256.96875,30.86686,0.185,NULL,56342459900,880350935,13755483,17.6),(140520,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140520,37.53,0.23,321,67825,70,NULL,NULL,'2MASX J17075638+2944036',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,256.9849583,29.73444,0.193,NULL,56359843386,880622552,13759727,17.3),(140521,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140521,37.53,0.23,321,67826,70,NULL,NULL,'2MASX J17075677+2947036',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,256.986667,29.78431,0.233,NULL,56359832672,880622385,13759724,16.6),(140522,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140522,37.25,0.46,282,67827,70,NULL,NULL,'2MASX J17075742+6249481',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000083,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,256.989417,62.82997,0.057,NULL,57564778383,899449662,14053900,17.4),(140523,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140523,33.75,0.49,56.2,67828,75,NULL,'IR','NGC 6310',NULL,'2011yCatp016004901K',2011,1,1.99,NULL,'G',0.000067,NULL,'13.6g',0.55,'Sb: sp',NULL,NULL,NULL,NULL,1,256.9894583,60.99017,0.037,NULL,57534247550,898972617,14046447,13.6),(140524,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140524,37.89,0.33,379,67829,70,NULL,NULL,'2MASX J17075893+6321411',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000099,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,256.995667,63.36131,0.053,NULL,57572326140,899567595,14055743,16.2),(140525,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140525,37.81,0.33,364,67830,70,NULL,NULL,'2MASX J17080230+5825597',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,257.00975,58.43325,0,NULL,57703929082,901623891,14087873,17.8),(140526,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140526,36.01,0.46,159,67831,70,NULL,NULL,'2MASX J17080280+2207212',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000174,NULL,'15.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,257.011833333,22.12256,0.289,NULL,56860397598,888443712,13881933,15.7),(140527,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140527,30.44,0.4,12.2,67832,75,NULL,'B','UGC 10736',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.00002,NULL,'14.5',0.9,'SABdm',NULL,NULL,NULL,NULL,1,257.020833,69.46389,0.165,NULL,57786250848,902910169,14107971,14.5),(140528,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140528,33.33,0.56,46.4,67833,70,NULL,NULL,'2MASX J17080654-6327194',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000029,NULL,'13.5R',NULL,'Sap',NULL,NULL,NULL,NULL,1,257.02725,-63.45536,0.573,NULL,44482900434,695045319,10860083,13.5),(140529,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140529,36.03,0.55,161,67834,70,NULL,NULL,'2MASX J17080770-0130526',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,257.032167,-1.51461,0.665,NULL,45213579347,706462177,11038471,15.3),(140530,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140530,36.59,0.46,208,67835,70,NULL,NULL,'2MASX J17080886+2136202',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000191,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,257.036958333,21.60567,0.269,NULL,56860490768,888445168,13881955,16.8),(140531,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140531,38.63,0.46,533,67836,70,NULL,NULL,'2MASX J17080919+6310031',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.038458333,63.16747,0.057,NULL,57572093762,899563965,14055686,17.9),(140532,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140532,36.1,0.46,166,67837,70,NULL,NULL,'2MASX J17081862+3024099',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000178,NULL,'16.1g',0.4,'E/S0',NULL,NULL,NULL,NULL,1,257.077667,30.40278,0.177,NULL,56359496529,880617133,13759642,16.1),(140533,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140533,37.81,0.33,364,67838,70,NULL,NULL,'2MASX J17082154+5831558',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.089917,58.53208,0,NULL,57703471848,901616747,14087761,17.3),(140534,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140534,33.11,0.8,41.9,67839,75,NULL,'CF, r','UGC 10721',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000017,NULL,'14.45',0.5,'Scd?',NULL,NULL,NULL,NULL,1,257.1064583,25.51739,0.173,NULL,56308004053,879812563,13747071,14.45),(140535,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140535,32.38,0.69,29.9,67839,100,NULL,'mid-IR','UGC 10721',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140536,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140536,33.29,0.43,45.4,67839,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140537,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140537,33.3,0.38,45.8,67839,75,NULL,'CF, r, raw','UGC 10721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140538,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140538,33.33,0.4,46.3,67839,NULL,NULL,'mean','UGC 10721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140539,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140539,33.38,0.38,47.5,67839,75,NULL,'CF, r, inv','UGC 10721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140540,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140540,33.53,0.38,50.8,67839,75,NULL,'CF, r, cor','UGC 10721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140541,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140541,33.57,0.47,51.7,67839,NULL,NULL,'H','UGC 10721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140542,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140542,33.6,0.46,52.5,67839,NULL,NULL,'J','UGC 10721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140543,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140543,33.64,0.45,53.5,67839,NULL,NULL,'K','UGC 10721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140544,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140544,36.72,0.46,221,67840,70,NULL,NULL,'2MASX J17082742+6204483',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000065,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.114416667,62.07992,0.049,NULL,57565149754,899455464,14053991,17.4),(140545,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140545,34.43,0.69,76.9,67841,100,NULL,'mid-IR','NGC 6301',NULL,'2013ApJ...771...88L',2013,1,1.78,NULL,'G',0.000033,NULL,'14.0g',0.87,'Scd:',NULL,NULL,NULL,NULL,1,257.136417,42.33911,0.037,NULL,59644097274,931939019,14561547,14),(140546,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140546,34.94,0.2,97.3,67841,74.4,NULL,NULL,'NGC 6301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140547,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140547,35.41,0.4,121,67841,NULL,NULL,'mean','NGC 6301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140548,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140548,35.45,0.47,123,67841,NULL,NULL,'H','NGC 6301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140549,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140549,35.5,0.46,126,67841,NULL,NULL,'J','NGC 6301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140550,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140550,35.6,0.45,132,67841,NULL,NULL,'K','NGC 6301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140551,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140551,37.8,0.13,363,67842,70,NULL,NULL,'2MASX J17083480+3415310',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.145125,34.25869,0.109,NULL,56340672705,880323011,13755047,17.9),(140552,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140552,37.08,0.33,260,67843,70,NULL,NULL,'2MASX J17083647+2146536',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000166,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,257.152,21.7815,0.269,NULL,56792570553,887383914,13865373,16.5),(140553,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140553,37.82,0.46,367,67844,70,NULL,NULL,'2MASX J17083661+3953556',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.1525,39.89886,0.109,NULL,59642426210,931912909,14561139,17.1),(140554,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140554,37.58,0.33,329,67845,70,NULL,NULL,'VII Zw 682',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,257.1625,64.60339,0.085,NULL,57574876698,899607448,14056366,16.9),(140555,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140555,37.91,0.46,382,67846,70,NULL,NULL,'2MASX J17083941+3425370',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.1642083,34.42706,0.109,NULL,56340655993,880322749,13755042,18.2),(140556,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140556,36.15,0.46,170,67847,70,NULL,NULL,'2MASX J17084165+6011124',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.173417,60.18683,0.037,NULL,57654949919,900858592,14075915,17.5),(140557,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140557,38.09,0.27,415,67848,70,NULL,NULL,'2MASX J17084174+3327040',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.173917,33.451,0.125,NULL,56353638902,880525607,13758212,17.5),(140558,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140558,38.09,0.27,415,67849,70,NULL,NULL,'2MASX J17084254+3327290',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000153,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.177333333,33.458,0.125,NULL,56353638736,880525605,13758212,17.8),(140559,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140559,37.8,0.13,363,67850,70,NULL,NULL,'2MASX J17084272+3424210',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,257.178208333,34.40592,0.109,NULL,56340654569,880322727,13755042,17.6),(140560,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140560,37.8,0.13,363,67851,70,NULL,NULL,'2MASX J17084396+3413552',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000163,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,257.183333,34.23192,0.113,NULL,56340667064,880322922,13755045,17.3),(140561,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140561,35.02,0.4,101,67852,NULL,NULL,'mean','NGC 6296',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000013,NULL,'14.20',0.8,'SAB(s)bc:',NULL,NULL,NULL,NULL,1,257.1852917,3.89408,0.333,NULL,55991486730,874866980,13669796,14.2),(140562,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140562,35.18,0.45,108,67852,NULL,NULL,'K','NGC 6296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140563,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140563,35.2,0.47,110,67852,NULL,NULL,'H','NGC 6296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140564,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140564,35.3,0.46,115,67852,NULL,NULL,'J','NGC 6296',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140565,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140565,36.77,0.73,226,67853,70,NULL,NULL,'2MASX J17084515-7808566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,257.188,-78.14914,0.461,NULL,44126215381,689472115,10773001,16.4),(140566,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140566,37.8,0.13,363,67854,70,NULL,NULL,'2MASX J17084929+3411352',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,257.2052083,34.19325,0.113,NULL,56340735396,880323990,13755062,17.3),(140567,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140567,38.09,0.27,415,67855,70,NULL,NULL,'2MASX J17085575+3331303',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.2322917,33.52519,0.089,NULL,56353649022,880525765,13758215,17.6),(140568,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140568,37.4,0.46,302,67856,70,NULL,NULL,'2MASX J17085825+3949077',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.24275,39.81889,0.109,NULL,59642471215,931913612,14561150,17),(140569,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140569,36.08,0.46,164,67857,70,NULL,NULL,'KAZ 452',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,257.247417,60.82311,0.037,NULL,57533398882,898959357,14046239,16.6),(140570,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140570,36.69,0.46,217,67858,70,NULL,NULL,'KUG 1707+280',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',NULL,NULL,'15.7g',0.42,'Spiral',NULL,NULL,NULL,NULL,1,257.254833,27.97214,0.153,NULL,56314166268,879908847,13748575,15.7),(140571,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140571,37.59,0.46,330,67859,70,NULL,NULL,'2MASX J17090129+5937252',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000094,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.255333,59.62369,0.041,NULL,57701912977,901592390,14087381,16.9),(140572,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140572,37.16,0.46,271,67860,70,NULL,NULL,'2MASX J17090580+3944237',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,257.274167,39.73983,0.109,NULL,59642368665,931912010,14561125,NULL),(140573,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140573,36.28,0.47,180,67861,NULL,NULL,'Malmquist cor.','2MASX J17090975+7852317',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.00003,NULL,'15.9V',NULL,'SF','Group member',NULL,NULL,NULL,1,257.291208333,78.87547,0.177,NULL,57129555742,892649308,13947645,15.9),(140574,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140574,36.34,0.45,186,67861,NULL,NULL,NULL,'2MASX J17090975+7852317',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140575,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140575,36.38,0.2,189,67861,74.4,NULL,NULL,'2MASX J17090975+7852317',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140576,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140576,37.8,0.13,363,67862,70,NULL,NULL,'2MASX J17091362+3434332',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000171,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.30675,34.57603,0.101,NULL,56340839861,880325622,13755087,16.6),(140577,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140577,35.23,0.2,111,67863,74.4,NULL,NULL,'UGC 10729',NULL,'2013AJ....146...86T',2013,1,0.79,NULL,'G',0.000005,NULL,'15.6g',0.34,'Sdm:           HII',NULL,NULL,NULL,NULL,1,257.3210417,31.6165,0.149,NULL,56345375759,880396496,13756195,15.6),(140578,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140578,36.84,0.46,233,67864,70,NULL,NULL,'2MASX J17091809+6026552',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000081,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,257.325333,60.44875,0.029,NULL,57533324036,898958188,14046221,16.8),(140579,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140579,37.8,0.13,363,67865,70,NULL,NULL,'2MASX J17091903+3430439',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000187,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.329417,34.51217,0.101,NULL,56340801607,880325025,13755078,17.4),(140580,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140580,37.92,0.33,383,67866,70,NULL,NULL,'SDSS J170919.35+565833.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000075,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,257.330667,56.97594,0,NULL,57698341103,901536579,14086509,18.4),(140581,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140581,37.92,0.33,383,67867,70,NULL,NULL,'2MASX J17092071+5700022',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000079,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,257.336375,57.00061,0,NULL,57698296234,901535878,14086498,17.9),(140582,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140582,37.8,0.13,363,67868,70,NULL,NULL,'2MASX J17092101+3423089',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000193,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,257.337666667,34.38589,0.109,NULL,56340692937,880323327,13755051,16.4),(140583,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10iyc','N',140583,37.13,0.01,252,67869,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10iyc',0.0594,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140584,'IRAS','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140584,34.22,0.8,70,67870,75,NULL,'MAT, I','ESO 044- G 001',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000025,NULL,'12.91',0.9,'SAB(s)c',NULL,NULL,NULL,NULL,1,257.344,-73.32092,0.193,NULL,44153834778,689903668,10779744,12.91),(140585,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140585,33.54,0.32,51.1,67870,85,NULL,'I, raw','ESO 044- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140586,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140586,33.57,0.32,51.8,67870,85,NULL,'I, inv','ESO 044- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140587,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140587,33.68,0.43,54.4,67870,75,NULL,'MAT, I, raw','ESO 044- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140588,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140588,33.84,0.43,58.6,67870,75,NULL,'MAT, I, inv','ESO 044- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140589,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140589,33.97,0.43,62.3,67870,75,NULL,'MAT, I, cor','ESO 044- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140590,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140590,34.42,0.44,76.5,67870,NULL,NULL,NULL,'ESO 044- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140591,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140591,34.46,0.2,78,67870,74.4,NULL,NULL,'ESO 044- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140592,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140592,34.48,0.43,78.7,67870,NULL,NULL,'Malmquist cor.','ESO 044- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140593,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140593,37.14,0.46,268,67871,70,NULL,NULL,'2MASX J17092260+3814342',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.344167,38.24289,0.157,NULL,59627343320,931677239,14557456,17.1),(140594,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140594,37.8,0.13,363,67872,70,NULL,NULL,'SDSS J170924.93+343146.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.4g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,257.353917,34.52953,0.101,NULL,56340803594,880325056,13755079,18.4),(140595,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140595,38.29,0.46,456,67873,70,NULL,NULL,'2MASX J17092603+2755321',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.35825,27.92553,0.153,NULL,56314273271,879910519,13748601,17.7),(140596,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140596,36.87,0.46,236,67874,70,NULL,NULL,'2MASX J17093032+2336244',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000157,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.376417,23.60675,0.221,NULL,56791048030,887360125,13865001,17.2),(140597,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140597,37.8,0.13,363,67875,70,NULL,NULL,'2MASX J17093126+3424189',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000201,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,257.3802083,34.40517,0.109,NULL,56340679727,880323120,13755048,16.5),(140598,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140598,37.8,0.13,363,67876,70,NULL,NULL,'2MASX J17093207+3426230',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,'FoF','17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.3837083,34.43958,0.109,NULL,56340677819,880323090,13755048,17.1),(140599,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140599,37.13,0.33,266,67877,70,NULL,NULL,'SDSS J170934.93+320022.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000163,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.395583333,32.00633,0.165,NULL,56343413400,880365834,13755716,18.5),(140600,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140600,35.99,0.61,158,67878,70,NULL,NULL,'2MASX J17093512-7055263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,257.396375,-70.92403,0.433,NULL,44097132892,689017701,10765901,15.2),(140601,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140601,37.92,0.46,384,67879,70,NULL,NULL,'2MASX J17093599+3159300',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,257.4,31.99161,0.165,NULL,56343413723,880365839,13755716,17.4),(140602,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140602,37.8,0.13,363,67880,70,NULL,NULL,'2MASXi J1709365+342502',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,257.402583,34.41742,0.109,NULL,56340680564,880323133,13755048,18.1),(140603,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140603,37.67,0.46,342,67881,70,NULL,NULL,'2MASX J17093809+5747513',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,257.4085,57.79753,0,NULL,57703276221,901613690,14087713,17.3),(140604,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140604,38.43,0.46,485,67882,70,NULL,NULL,'2MASX J17093832+3314460',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.409667,33.24622,0.141,NULL,56353744592,880527259,13758238,17.9),(140605,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140605,36.77,0.44,226,67883,NULL,NULL,'Malmquist cor.','2MASX J17093986+7833067',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.000023,NULL,'15.73',NULL,'S','Group member',NULL,NULL,NULL,1,257.414583,78.55219,0.197,NULL,57128633292,892634895,13947420,15.73),(140606,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140606,37,0.4,251,67883,NULL,NULL,NULL,'2MASX J17093986+7833067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140607,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140607,37.04,0.2,256,67883,74.4,NULL,NULL,'2MASX J17093986+7833067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140608,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140608,33.95,0.2,61.7,67884,74.4,NULL,NULL,'UGC 10732',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000073,NULL,'15.16',0.7,'Scd:',NULL,NULL,NULL,NULL,1,257.42725,36.41481,0.185,NULL,56123338534,876927164,13701986,15.16),(140609,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140609,36.75,0.33,224,67885,70,NULL,NULL,'2MASX J17094311+3040590',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,257.429625,30.68297,0.149,NULL,56359449404,880616396,13759631,17.2),(140610,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140610,38.17,0.46,430,67886,70,NULL,NULL,'2MASX J17094354+2925191',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000159,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,257.4315417,29.42192,0.185,NULL,56313277214,879894956,13748358,18.5),(140611,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140611,37.8,0.13,363,67887,70,NULL,NULL,'2MASX J17094371+3424260',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000207,NULL,'16.2g',0.41,'BrClG',NULL,NULL,NULL,NULL,1,257.432333,34.40708,0.109,NULL,56340677335,880323083,13755048,16.2),(140612,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140612,37.45,0.46,309,67888,70,NULL,NULL,'2MASX J17094527+3044030',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000144,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.4387083,30.73428,0.149,NULL,56359392341,880615505,13759617,17.4),(140613,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140613,38.24,0.46,445,67889,70,NULL,NULL,'SDSS J170948.50+653003.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.452125,65.50094,0.113,NULL,57517413739,898709589,14042337,18.3),(140614,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140614,36.16,0.46,171,67890,70,NULL,NULL,'2MASX J17095391+6243192',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000066,NULL,'16.2g',0.32,NULL,NULL,NULL,NULL,NULL,1,257.4744583,62.72208,0.073,NULL,57564950422,899452350,14053942,16.2),(140615,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140615,37.8,0.13,363,67891,70,NULL,NULL,'2MASX J17095548+3418157',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000173,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,257.481166667,34.30436,0.109,NULL,56340719257,880323738,13755058,16.8),(140616,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140616,36.8,0.82,229,67892,70,NULL,NULL,'2MASX J17095629-8214119',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,257.484167,-82.23661,0.321,NULL,44056836111,688388064,10756063,17),(140617,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140617,37.85,0.46,372,67893,70,NULL,NULL,'2MASX J17095632+3931026',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.484625,39.51736,0.117,NULL,59641280105,931895001,14560859,17.3),(140618,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140618,38.43,0.46,486,67894,70,NULL,NULL,'2MASX J17100263+3252567',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,257.510833,32.88258,0.193,NULL,56354054519,880532101,13758314,18.3),(140619,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140619,38.63,0.46,531,67895,70,NULL,NULL,'2MASX J17100518+5641464',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000086,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.5217917,56.69625,0,NULL,57698728284,901542629,14086603,18.3),(140620,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140620,35.39,0.46,120,67896,70,NULL,NULL,'UGC 10733',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00013,NULL,'14.5g',0.64,'E',NULL,NULL,NULL,NULL,1,257.5227083,32.49992,0.177,NULL,56353939545,880530305,13758286,14.5),(140621,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140621,38.09,0.46,415,67897,70,NULL,NULL,'2MASX J17100563+2650012',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.5235417,26.83364,0.165,NULL,56318400152,879975002,13749609,17.5),(140622,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140622,37.13,0.33,266,67898,70,NULL,NULL,'2MASX J17100646+3159487',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000158,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.526917,31.997,0.165,NULL,56343640421,880369381,13755771,16.8),(140623,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140623,35.49,0.49,125,67899,75,NULL,'IR','UGC 10735',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',NULL,NULL,'16.5',0.2,'Scd(f)',NULL,NULL,NULL,NULL,1,257.532917,32.29419,0.169,NULL,56343405394,880365709,13755714,16.5),(140624,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140624,37.61,0.46,333,67900,70,NULL,NULL,'2MASX J17100823+6403101',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000086,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.5339583,64.05292,0.057,NULL,57572736499,899574007,14055843,17.3),(140625,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140625,36.75,0.33,224,67901,70,NULL,NULL,'2MASX J17100828+3049528',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000185,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,257.5345,30.83142,0.149,NULL,56359389690,880615463,13759616,15.8),(140626,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140626,33.47,0.43,49.5,67902,75,NULL,'3.6 micron, color corrected','IC 1251',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000007,NULL,'14.23',1,'Scd:','is a companion galaxy',NULL,NULL,NULL,1,257.55375,72.4105,0.185,NULL,57053465747,891460402,13929068,14.23),(140627,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140627,33.56,0.43,51.4,67902,75,NULL,'3.6 micron, color + selection bias corrected','IC 1251',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140628,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140628,36.07,0.46,163,67903,70,NULL,NULL,'CGCG 169-053',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.0002,NULL,'15.5g',0.49,'E0',NULL,NULL,NULL,NULL,1,257.567917,32.24011,0.169,NULL,56343452035,880366438,13755725,15.5),(140629,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140629,31.71,0.4,22,67904,75,NULL,'B','NGC 6340',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.00002,NULL,'11.87',3,'SA(s)0/a       LINER','Parent (of companion) galaxy',NULL,NULL,NULL,1,257.6035417,72.30444,0.197,NULL,57053486322,891460723,13929073,11.87),(140630,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140630,38.11,0.46,419,67905,70,NULL,NULL,'2MASX J17102570+4105086',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.6072083,41.08578,0.057,NULL,59639662509,931869726,14560464,17.1),(140631,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140631,38.35,0.46,468,67906,70,NULL,NULL,'SDSS J171026.20+565430.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000064,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,257.609167,56.90842,0,NULL,57698864004,901544750,14086636,18.4),(140632,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140632,37.75,0.33,355,67907,70,NULL,NULL,'2MASX J17103027+3052286',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.626166667,30.87456,0.109,NULL,56362272937,880660514,13760320,17.7),(140633,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140633,38.03,0.33,404,67908,70,NULL,NULL,'2MASX J17103079+2747576',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,257.628333,27.79939,0.153,NULL,56314084267,879907566,13748555,NULL),(140634,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140634,35.95,0.57,155,67909,70,NULL,NULL,'2MASX J17103094-2338399',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,257.628917,-23.64433,NULL,NULL,46004048652,718813260,11231457,15.8),(140635,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140635,36.75,0.47,224,67910,NULL,NULL,'Malmquist cor.','2MASX J17103123+7829094',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.000027,NULL,'16.54',NULL,'Sbc',NULL,NULL,NULL,NULL,1,257.63,78.48619,0.197,NULL,57128626786,892634793,13947418,16.54),(140636,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140636,36.97,0.43,248,67910,NULL,NULL,NULL,'2MASX J17103123+7829094',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140637,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140637,37.01,0.2,252,67910,74.4,NULL,NULL,'2MASX J17103123+7829094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140638,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140638,38.21,0.33,439,67911,70,NULL,NULL,'SDSS J171031.57+332924.6',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'18.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,257.6315417,33.49019,0.121,NULL,56353793735,880528027,13758250,18),(140639,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140639,38.21,0.33,439,67912,70,NULL,NULL,'2MASX J17103221+3329066',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,257.634083,33.48525,0.121,NULL,56353794019,880528031,13758250,17.1),(140640,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140640,37.69,0.07,345,67913,70,NULL,NULL,'2MASX J17103314+6357425',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000087,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.638041667,63.96172,0.085,NULL,57572858516,899575914,14055873,16.6),(140641,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140641,37.75,0.33,355,67914,70,NULL,NULL,'2MASX J17103462+3050246',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.644333,30.84036,0.149,NULL,56362286610,880660728,13760323,17.8),(140642,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140642,37.45,0.46,310,67915,70,NULL,NULL,'2MASX J17103643+3139446',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000167,NULL,'16.7g',0.35,NULL,NULL,NULL,NULL,NULL,1,257.651917,31.6625,0.133,NULL,56343980105,880374689,13755854,16.7),(140643,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140643,38.44,0.46,488,67916,70,NULL,NULL,'2MASX J17103685+5933242',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,257.6535,59.55675,0.041,NULL,57701903434,901592241,14087378,17.9),(140644,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140644,34.81,0.69,91.8,67917,70,NULL,NULL,'2MASX J17103933-0026464',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000117,NULL,'13.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,257.663917,-0.44617,0.565,NULL,45201716382,706276818,11035575,13.6),(140645,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140645,38.03,0.33,404,67918,70,NULL,NULL,'2MASX J17103817+2746226',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.6687083,27.77556,0.153,NULL,56318523212,879976925,13749639,17.5),(140646,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140646,37.42,0.33,304,67919,70,NULL,NULL,'2MASX J17104538+3942387',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.68925,39.71089,0.109,NULL,59641197031,931893703,14560839,17.4),(140647,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140647,37.69,0.07,345,67920,70,NULL,NULL,'2MASX J17104548+6345485',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000075,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,257.6897083,63.76364,0.085,NULL,57572894396,899576474,14055882,17),(140648,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140648,37.4,0.27,301,67921,70,NULL,NULL,'2MASX J17104615+3009387',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000148,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.692458333,30.16092,0.193,NULL,56362667313,880666676,13760416,17.2),(140649,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140649,35.43,0.63,122,67922,70,NULL,NULL,'2MASX J17104740-0021203',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,257.697583333,-0.35567,0.565,NULL,45198311541,706223617,11034744,15),(140650,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140650,36.82,0.46,232,67923,70,NULL,NULL,'2MASX J17104780+4409411',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,257.69925,44.16153,0.009,NULL,59658975978,932171499,14565179,16.9),(140651,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140651,35.5,0.46,126,67924,70,NULL,NULL,'2MASX J17104921+3108187',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000182,NULL,'15.7g',0.33,'E0',NULL,NULL,NULL,NULL,1,257.705083,31.13844,0.121,NULL,56343721210,880370643,13755791,15.7),(140652,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140652,35.2,0.49,110,67925,75,NULL,'IR','UGC 10746',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00009,NULL,'16.5',0.12,'Sc',NULL,NULL,NULL,NULL,1,257.707333,45.85419,0.013,NULL,59657501784,932148465,14564819,16.5),(140653,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140653,35.68,NULL,137,67925,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140654,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140654,35.7,NULL,138,67925,NULL,NULL,'Dipole + Quadrupole','UGC 10746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140655,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140655,35.71,NULL,139,67925,NULL,NULL,'Dipole','UGC 10746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140656,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140656,35.72,NULL,140,67925,NULL,NULL,NULL,'UGC 10746',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140657,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140657,35.57,0.46,130,67926,70,NULL,NULL,'2MASX J17105085+6119295',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000082,NULL,'15.8g',0.39,NULL,NULL,NULL,NULL,NULL,1,257.712125,61.32494,0.041,NULL,57563392117,899428001,14053562,15.8),(140658,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140658,37.69,0.07,345,67927,70,NULL,NULL,'VII Zw 685',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000073,NULL,'17.3g',0.22,'LINER',NULL,NULL,NULL,'Sy 2',1,257.718833333,63.65478,0.081,NULL,57573074896,899579295,14055926,17.3),(140659,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140659,37.69,0.07,345,67928,70,NULL,NULL,'2MASX J17105351+6403045',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,257.7230417,64.05133,0.057,NULL,57572722212,899573784,14055840,17.4),(140660,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140660,37.39,0.46,300,67929,70,NULL,NULL,'2MASX J17105622+2141472',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000183,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.734167,21.69639,0.285,NULL,56792863039,887388484,13865445,18),(140661,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140661,37.4,0.27,301,67930,70,NULL,NULL,'2MASX J17105718+3005137',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00019,NULL,'15.9g',0.47,'E0',NULL,NULL,NULL,NULL,1,257.738125,30.08725,0.193,NULL,56362677103,880666829,13760419,15.9),(140662,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140662,37.6,0.46,331,67931,70,NULL,NULL,'2MASX J17105737+2716445',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.7390417,27.27906,0.173,NULL,56318782243,879980972,13749702,17.3),(140663,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140663,37.69,0.07,345,67932,70,NULL,NULL,'ZwCl 1710.4+6401 02',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000058,NULL,'17.4g',0.22,'Red fuzzy',NULL,NULL,NULL,NULL,1,257.741833,63.85906,0.085,NULL,57572908269,899576691,14055885,17.4),(140664,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10jtp','N',140664,37.36,0.03,278,67933,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10jtp',0.067,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140665,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140665,37.4,0.27,301,67934,70,NULL,NULL,'2MASX J17105877+3001492',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,257.7449583,30.03039,0.205,NULL,56362724431,880667569,13760430,18.2),(140666,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140666,37.36,0.46,297,67935,70,NULL,NULL,'2MASX J17110103+2603165',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,257.754291667,26.05464,0.161,NULL,56307569334,879805770,13746965,16.9),(140667,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140667,36.47,0.46,197,67936,70,NULL,NULL,'2MASX J17110157+2243592',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,257.756583333,22.733,0.189,NULL,56794711293,887417363,13865896,16.6),(140668,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140668,37.72,0.46,350,67937,70,NULL,NULL,'VII Zw 687',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'16.8g',0.3,'Very red       AGN',NULL,NULL,NULL,NULL,1,257.757167,64.02614,0.057,NULL,57572721343,899573770,14055840,16.8),(140669,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140669,34.23,0.23,68.6,67938,74.2,NULL,'SALT 2','UGC 10738',0.022402,'2010ApJ...716..712A',2010,1,1.97,NULL,'G',0.000011,NULL,'15.05',0.24,'Sbc',NULL,NULL,NULL,NULL,1,257.774375,5.85225,0.293,NULL,56011333499,875177085,13674641,15.05),(140670,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140670,34.95,0.17,95.4,67938,70,NULL,'SALT 2','UGC 10738',0.022402,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140671,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp','R',140671,34.94,0.05,97.3,67938,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10738',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140672,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140672,35,0.24,97.7,67938,65,NULL,'MLCS17','UGC 10738',0.022402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140673,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140673,35,0.24,97.9,67938,65,NULL,'MLCS31','UGC 10738',0.022402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140674,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp','R',140674,34.96,0.06,98.2,67938,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10738',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140675,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140675,34.98,0.08,99.1,67938,74.4,NULL,NULL,'UGC 10738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140676,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140676,35.2,0.39,107,67938,65,NULL,'SALT2','UGC 10738',0.022402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140677,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2001cp',NULL,140677,35.45,0.19,120,67938,65,NULL,'SALT','UGC 10738',0.022402,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140678,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140678,34.82,0.49,92.1,67938,75,NULL,'IR','UGC 10738',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140679,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140679,34.93,0.47,96.9,67938,NULL,NULL,'H','UGC 10738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140680,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140680,34.98,0.08,99.1,67938,74.4,NULL,NULL,'UGC 10738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140681,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140681,35.01,0.4,100,67938,NULL,NULL,'mean','UGC 10738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140682,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140682,35.01,0.45,101,67938,NULL,NULL,'K','UGC 10738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140683,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140683,35.07,0.46,103,67938,NULL,NULL,'J','UGC 10738',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140684,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140684,35.19,NULL,109,67938,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140685,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140685,35.2,NULL,110,67938,NULL,NULL,'Dipole + Quadrupole','UGC 10738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140686,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140686,35.21,NULL,110,67938,NULL,NULL,NULL,'UGC 10738',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140687,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140687,35.21,NULL,110,67938,NULL,NULL,'Dipole','UGC 10738',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140688,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140688,35.4,0.37,120,67938,NULL,NULL,'Malmquist cor.','UGC 10738',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140689,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140689,35.44,0.4,122,67938,75,NULL,'HOSTS SN 2001cp','UGC 10738',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140690,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140690,35.51,0.42,126,67938,NULL,18.48,'3.6 micron','UGC 10738',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140691,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140691,35.58,0.43,131,67938,75,NULL,'3.6 micron, color corrected','UGC 10738',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140692,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140692,35.7,0.32,138,67938,NULL,NULL,NULL,'UGC 10738',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140693,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140693,35.71,0.43,139,67938,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10738',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140694,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140694,37.69,0.07,345,67939,70,NULL,NULL,'ZwCl 1710.4+6401 05',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000087,NULL,'17.6g',0.21,'Very red',NULL,NULL,NULL,NULL,1,257.7805,63.98381,0.085,NULL,57572854967,899575858,14055872,17.6),(140695,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140695,38.21,0.46,438,67940,70,NULL,NULL,'2MASX J17110815+3037223',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.783833333,30.62281,0.149,NULL,56362511302,880664239,13760378,17.8),(140696,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140696,37.69,0.07,345,67941,70,NULL,NULL,'SDSS J171109.16+633915.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000071,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.7882083,63.65431,0.081,NULL,57573078064,899579344,14055927,18.2),(140697,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140697,37.56,0.46,325,67942,70,NULL,NULL,'2MASX J17111133+2927558',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.797083,29.46556,0.169,NULL,56360439455,880631866,13759872,17.8),(140698,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140698,37.89,0.46,378,67943,70,NULL,NULL,'2MASX J17111270+2827558',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000167,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,257.8029583,28.46547,0.145,NULL,56315982485,879937226,13749019,16.9),(140699,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140699,37.69,0.07,345,67944,70,NULL,NULL,'VII Zw 688',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000077,NULL,'17.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.8052083,63.63756,0.081,NULL,57573005345,899578208,14055909,17.6),(140700,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140700,37.42,0.33,304,67945,70,NULL,NULL,'2MASX J17111724+3943558',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.821875,39.73217,0.109,NULL,59641233113,931894267,14560847,17.2),(140701,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140701,37.73,0.46,352,67946,70,NULL,NULL,'SDSS J171117.90+581417.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000075,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,257.824625,58.23833,0.041,NULL,57704084307,901626317,14087911,18.2),(140702,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140702,37.49,0.46,315,67947,70,NULL,NULL,'2MASX J17112046+5611062',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.835167,56.185,0.029,NULL,57700603479,901571929,14087061,17.2),(140703,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140703,35.48,0.5,125,67948,70,NULL,NULL,'2MASX J17112444-6544320',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,257.852,-65.74222,0.321,NULL,44435492253,694304566,10848508,14.8),(140704,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140704,37.7,0.46,347,67949,70,NULL,NULL,'2MASX J17112814+3715428',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,257.867333,37.26192,0.137,NULL,56121979361,876905927,13701655,17.4),(140705,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140705,37.08,0.46,261,67950,70,NULL,NULL,'ZwCl 1710.4+6401 08',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.2g',0.17,'Very red oval',NULL,NULL,NULL,NULL,1,257.8735417,63.86606,0.085,NULL,57572905024,899576641,14055885,17.2),(140706,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2002er',NULL,140706,32.51,0.09,31.8,67951,74.4,NULL,NULL,'UGC 10743',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000023,NULL,'13.4B',0.4,'Sa?','Isolated galaxy',NULL,NULL,NULL,1,257.878083333,7.99461,0.293,NULL,56011860620,875185322,13674770,13.4),(140707,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2002er',NULL,140707,32.72,0.24,34.7,67951,72,NULL,NULL,'UGC 10743',0.00857,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140708,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2002er',NULL,140708,33.03,0.09,39.8,67951,65,NULL,'MLCS2k2','UGC 10743',0.00857,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140709,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2002er',NULL,140709,33.22,0.14,44.1,67951,60,NULL,NULL,'UGC 10743',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140710,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140710,31.48,0.42,19.8,67951,NULL,18.48,'3.6 micron','UGC 10743',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140711,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140711,31.58,0.4,20.7,67951,75,NULL,'HOSTS SN 2002er','UGC 10743',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140712,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140712,31.58,0.4,20.7,67951,75,NULL,'HOSTS SN 2002er','UGC 10743',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140713,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140713,31.64,0.43,21.3,67951,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10743',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140714,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140714,31.89,0.43,23.8,67951,75,NULL,'3.6 micron, color corrected','UGC 10743',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140715,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140715,32.02,0.4,25.4,67951,75,NULL,NULL,'UGC 10743',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140716,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140716,32.41,0.49,30.3,67951,75,NULL,'IR','UGC 10743',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140717,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140717,32.51,0.09,31.8,67951,74.4,NULL,NULL,'UGC 10743',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140718,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140718,32.59,0.47,32.9,67951,NULL,NULL,'H','UGC 10743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140719,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140719,32.7,0.45,34.7,67951,NULL,NULL,'K','UGC 10743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140720,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140720,32.71,0.46,34.8,67951,NULL,NULL,'J','UGC 10743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140721,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140721,32.75,0.4,35.5,67951,NULL,NULL,'mean','UGC 10743',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140722,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140722,38.07,0.46,412,67952,70,NULL,NULL,'2MASX J17113356+2756250',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.889833333,27.94022,0.161,NULL,56318507534,879976680,13749635,17.6),(140723,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140723,37.69,0.07,345,67953,70,NULL,NULL,'2MASX J17113603+6339059',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000071,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.8999583,63.65164,0.081,NULL,57573000921,899578139,14055908,16.9),(140724,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140724,38.15,0.46,427,67954,70,NULL,NULL,'2MASX J17113614+6400599',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.900791667,64.01667,0.057,NULL,57572393115,899568642,14055760,17.8),(140725,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140725,37.69,0.07,345,67955,70,NULL,NULL,'ZwCl 1710.4+6401 10',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000096,NULL,'17.6g',0.2,'Very red',NULL,NULL,NULL,NULL,1,257.908083333,64.04625,0.057,NULL,57575014848,899609607,14056400,17.6),(140726,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140726,38.21,0.46,439,67956,70,NULL,NULL,'2MASX J17113919+3732186',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,257.913125,37.53858,0.133,NULL,56121983200,876905987,13701656,17.5),(140727,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140727,37.85,0.46,371,67957,70,NULL,NULL,'2MASX J17113952+2933331',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.91475,29.55917,0.145,NULL,56360447892,880631998,13759874,18.3),(140728,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140728,37.98,0.46,395,67958,70,NULL,NULL,'2MASX J17114196+2906581',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000149,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.924833,29.11617,0.169,NULL,56315329435,879927022,13748859,17.7),(140729,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140729,36.14,0.67,169,67959,70,NULL,NULL,'2MASX J17114259-0104523',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,257.9275417,-1.08117,0.645,NULL,45201900564,706279696,11035620,14.6),(140730,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140730,38.39,0.46,477,67960,70,NULL,NULL,'2MASX J17114408+2736241',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.933666667,27.60669,0.169,NULL,56318641800,879978778,13749668,17.7),(140731,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140731,33.32,0.49,46.1,67961,75,NULL,'IR','ESO 519- G?009',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.00005,NULL,'15.6',0.13,'Sc',NULL,NULL,NULL,NULL,1,257.9377083,-25.74736,NULL,NULL,45839479980,716241874,11191279,15.6),(140732,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140732,35.36,NULL,118,67961,NULL,NULL,'Dipole + Quadrupole','ESO 519- G?009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140733,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140733,35.36,NULL,118,67961,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 519- G?009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140734,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140734,35.36,NULL,118,67961,NULL,NULL,'Dipole','ESO 519- G?009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140735,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140735,38.1,0.46,416,67962,70,NULL,NULL,'2MASX J17114513+2211367',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.7g',0.34,NULL,NULL,NULL,NULL,NULL,1,257.9379583,22.19358,0.225,NULL,56792263283,887379113,13865298,16.7),(140736,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140736,37.69,0.07,345,67963,70,NULL,NULL,'VII Zw 692',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000053,NULL,'16.6g',0.34,'Very red       AGN',NULL,NULL,NULL,NULL,1,257.9415,64.35892,0.061,NULL,57575193147,899612392,14056443,16.6),(140737,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140737,36.15,0.46,170,67964,70,NULL,NULL,'2MASX J17114609+2854311',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000175,NULL,'16.0g',0.32,'E0',NULL,NULL,NULL,NULL,1,257.942,28.90861,0.165,NULL,56315155603,879924306,13748817,16),(140738,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140738,37.84,0.46,370,67965,70,NULL,NULL,'2MASX J17114834+2808061',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,257.951333,28.13514,0.145,NULL,56315361091,879927517,13748867,18.6),(140739,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140739,35.07,0.49,103,67966,75,NULL,'IR','FGC 2115',NULL,'2011yCatp016004901K',2011,1,0.85,NULL,'G',NULL,NULL,'16.7',0.1,'Scd',NULL,NULL,NULL,NULL,1,257.9535417,47.66014,0.029,NULL,59620434102,931569282,14555770,16.7),(140740,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140740,35.33,NULL,117,67966,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2115',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140741,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140741,35.35,NULL,118,67966,NULL,NULL,'Dipole + Quadrupole','FGC 2115',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140742,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140742,35.37,NULL,119,67966,NULL,NULL,'Dipole','FGC 2115',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140743,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140743,35.39,NULL,120,67966,NULL,NULL,NULL,'FGC 2115',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140744,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140744,37.61,0.46,333,67967,70,NULL,NULL,'2MASX J17114908+3303131',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,257.954625,33.05381,0.161,NULL,56354463582,880538493,13758413,18.3),(140745,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140745,37.69,0.07,345,67968,70,NULL,NULL,'VII Zw 691',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000088,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,257.954958333,63.61544,0.081,NULL,57573001965,899578155,14055908,16.8),(140746,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140746,35.4,0.19,120,67969,70,NULL,NULL,'CGCG 299-058',NULL,'2015arXiv151105856S',2015,1,0.9,NULL,'G',0.000077,NULL,'14.6g',0.71,'E0',NULL,NULL,NULL,NULL,1,257.9575,57.5895,0.029,NULL,57711545579,901742899,14089732,14.6),(140747,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140747,37.68,0.46,343,67970,70,NULL,NULL,'2MASX J17115156+2931101',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,257.964875,29.51944,0.145,NULL,56360495301,880632739,13759886,18.1),(140748,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','PTF10qkv','N',140748,37.92,0.03,362,67971,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qkv',0.0611,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140749,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140749,36.4,0.33,191,67972,70,NULL,NULL,'2MASX J17115337+2152463',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,257.972375,21.87961,0.237,NULL,56792397869,887381216,13865331,16.9),(140750,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140750,36.64,0.46,213,67973,70,NULL,NULL,'2MASX J17115618+3803307',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,257.984083,38.0585,0.153,NULL,59640953270,931889894,14560779,17),(140751,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140751,37.48,0.46,313,67974,70,NULL,NULL,'2MASX J17115762+6045378',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,257.9902083,60.76058,0.037,NULL,57562802850,899418794,14053418,17.5),(140752,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140752,36.05,0.69,162,67975,70,NULL,NULL,'2MASX J17115766-2342073',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'18.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,257.990375,-23.70211,NULL,NULL,46003604063,718806313,11231348,18.1),(140753,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140753,37.69,0.07,345,67976,70,NULL,NULL,'ZwCl 1710.4+6401 12',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.6g',0.19,'Very red       AGN',NULL,NULL,NULL,NULL,1,257.9904583,64.05569,0.057,NULL,57575016029,899609625,14056400,17.6),(140754,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140754,34.46,0.18,76.2,67977,74.2,NULL,'SALT 2','UGC 10754 NOTES01',0.0233,'2010ApJ...716..712A',2010,1,0.6,NULL,'G',NULL,NULL,'16',0.4,NULL,NULL,NULL,NULL,NULL,1,257.9962083,46.55678,0.053,NULL,59653485319,932085708,14563839,16),(140755,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140755,35.05,0.03,83.2,67977,72,NULL,'MLCS17','UGC 10754 NOTES01',0.23,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140756,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140756,34.99,0.09,99.5,67977,74.4,NULL,NULL,'UGC 10754 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140757,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140757,35.19,0.17,106,67977,70,NULL,'SALT 2','UGC 10754 NOTES01',0.0233,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140758,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp','R',140758,35.14,0.1,107,67977,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 10754 NOTES01',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140759,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140759,35.2,0.16,107,67977,73.8,NULL,'SALT 2 (SNANA)','UGC 10754 NOTES01',0.023,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140760,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140760,35.2,0.02,107,67977,70,NULL,'SALT 2','UGC 10754 NOTES01',0.0233,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140761,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp','R',140761,35.16,0.08,108,67977,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 10754 NOTES01',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140762,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140762,35.26,0.18,113,67977,65,NULL,'MLCS17','UGC 10754 NOTES01',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140763,'SNIa','2016-12-15 15:15:45','2016-12-16 11:20:59','1','SN 2006mp',NULL,140763,35.26,0.2,113,67977,65,NULL,'MLCS31','UGC 10754 NOTES01',NULL,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140764,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140764,37.93,0.46,386,67978,70,NULL,NULL,'2MASX J17120085+5547549',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000098,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,258.0037083,55.79861,0.053,NULL,57700651833,901572684,14087073,16.6),(140765,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140765,37.69,0.07,345,67979,70,NULL,NULL,'2MASX J17120095+6402168',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,258.004083,64.03786,0.057,NULL,57574295912,899598373,14056224,17.6),(140766,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140766,36.56,0.46,205,67980,70,NULL,NULL,'2MASX J17120405+3014202',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000194,NULL,'15.5g',0.48,'S0',NULL,NULL,NULL,NULL,1,258.016958333,30.23894,0.089,NULL,56362816826,880669012,13760453,15.5),(140767,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140767,37.69,0.07,345,67981,70,NULL,NULL,'SDSS J171204.79+640842.8',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00008,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,258.02,64.14522,0.057,NULL,57575026694,899609792,14056403,17.9),(140768,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140768,35.4,0.19,120,67982,70,NULL,NULL,'2MASX J17120667+5730139',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000066,NULL,'15.8g',0.31,'E0',NULL,NULL,NULL,NULL,1,258.027625,57.504,0.029,NULL,57711548261,901742941,14089733,15.8),(140769,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140769,36.4,0.33,191,67983,70,NULL,NULL,'2MASX J17121240+2147522',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.0g',0.34,NULL,NULL,NULL,NULL,NULL,1,258.051667,21.79781,0.237,NULL,56792371095,887380798,13865324,16),(140770,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140770,38.07,0.46,411,67984,70,NULL,NULL,'2MASX J17121296+2729487',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,258.054125,27.49706,0.169,NULL,56320709065,880011079,13750173,17.4),(140771,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,NULL,140771,34.38,0.2,75.2,67985,74.4,NULL,NULL,'UGC 10749',NULL,'2013AJ....146...86T',2013,1,0.94,NULL,'G',0.000016,NULL,'15.1g',0.46,'SBb',NULL,NULL,NULL,NULL,1,258.056875,30.16783,0.089,NULL,56362815233,880668988,13760452,15.1),(140772,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140772,37.65,0.46,340,67986,70,NULL,NULL,'2MASX J17121498+3301292',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,258.0624583,33.02483,0.161,NULL,56354420042,880537813,13758403,17.5),(140773,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140773,37.69,0.07,345,67987,70,NULL,NULL,'SDSS J171218.49+640029.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,258.077041667,64.00806,0.085,NULL,57574294998,899598359,14056224,18.4),(140774,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140774,38.39,0.33,476,67988,70,NULL,NULL,'SDSS J171219.25+583624.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000086,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.08025,58.60672,0.033,NULL,57703443486,901616304,14087754,18.6),(140775,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140775,38.03,0.46,404,67989,70,NULL,NULL,'SDSS J171221.10+570229.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.087917,57.04158,0.033,NULL,57698101181,901532830,14086450,18.5),(140776,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140776,36.84,0.46,233,67990,70,NULL,NULL,'SDSS J171221.80+562516.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.090833,56.42119,0.029,NULL,57698600319,901540629,14086572,17.7),(140777,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140777,37.03,0.46,255,67991,70,NULL,NULL,'2MASX J17122487+3223582',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,258.1037083,32.3995,0.137,NULL,56351129139,880486392,13757599,16.6),(140778,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140778,37.18,0.46,272,67992,70,NULL,NULL,'2MASX J17122515+5744470',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000077,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,258.1047083,57.74658,0.029,NULL,57703383553,901615368,14087740,16.7),(140779,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140779,37.69,0.07,345,67993,70,NULL,NULL,'ZwCl 1710.4+6401 18',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000091,NULL,'16.6g',0.31,'Very red, patchy',NULL,NULL,NULL,NULL,1,258.1070417,64.32936,0.061,NULL,57575183740,899612245,14056441,16.6),(140780,'FP','2016-12-15 15:15:45','2016-12-16 11:20:59','1',NULL,'R',140780,37.69,0.07,345,67994,70,NULL,NULL,'ZwCl 1710.4+6401 20',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.9g',0.15,'Red',NULL,NULL,NULL,NULL,1,258.110083,64.38964,0.061,NULL,57575188854,899612325,14056442,17.9),(140781,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140781,37.69,0.07,345,67995,70,NULL,NULL,'ZwCl 1710.4+6401 19',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000085,NULL,'17.7g',0.18,'Very red',NULL,NULL,NULL,NULL,1,258.117666667,64.03108,0.057,NULL,57574307626,899598556,14056227,17.7),(140782,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140782,37.69,0.07,345,67996,70,NULL,NULL,'SDSS J171228.48+635749.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00007,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.118667,63.96369,0.085,NULL,57572402408,899568787,14055762,18.4),(140783,'BCG','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140783,37.67,0.35,318,67997,60,NULL,'ABELL 2255, BCG','ZwCl 1710.4+6401 A',0.0747,'1980ApJ...241..486H',1980,1,0.67,NULL,'G',0.000102,NULL,'15.5g',0.58,'E0;red;BrClG','Brightest group member',NULL,NULL,NULL,1,258.119958333,64.06075,0.057,NULL,57574303577,899598493,14056226,15.5),(140784,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140784,37.69,0.07,345,67997,70,NULL,NULL,'ZwCl 1710.4+6401 A',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140785,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140785,37.69,0.07,345,67998,70,NULL,NULL,'2MASX J17123044+6400595',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.126958333,64.01658,0.085,NULL,57574309060,899598579,14056227,17.8),(140786,'BCG','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140786,37.67,0.35,318,67999,60,NULL,NULL,'ABELL 2255',0.0747,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III:[BM]',NULL,NULL,NULL,NULL,1,258.129375,64.09258,0.057,NULL,57575021985,899609718,14056401,NULL),(140787,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140787,37.69,0.07,345,68000,70,NULL,NULL,'SDSS J171231.73+635950.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.1322083,63.99733,0.085,NULL,57574308658,899598572,14056227,18.3),(140788,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140788,37.69,0.07,345,68001,70,NULL,NULL,'2MASX J17123243+6400095',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00008,NULL,'16.7g',0.36,NULL,NULL,NULL,NULL,NULL,1,258.135166667,64.00278,0.085,NULL,57574308493,899598570,14056227,16.7),(140789,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140789,34.42,0.2,76.6,68002,74.4,NULL,NULL,'UGC 10753',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000012,NULL,'15.48',0.3,'Scd:',NULL,NULL,NULL,NULL,1,258.146875,34.69253,0.109,NULL,56340141677,880314713,13754917,15.48),(140790,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140790,33.86,0.47,59.3,68003,NULL,NULL,'H','NGC 6314',NULL,'2007A&A...465...71T',2007,1,1.61,NULL,'G',0.000013,NULL,'13.8g',0.78,'SA(s)a: sp','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,258.161333,23.27008,0.213,NULL,56794519175,887414362,13865849,13.8),(140791,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140791,33.93,0.45,61.1,68003,NULL,NULL,'K','NGC 6314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140792,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140792,34.04,0.46,64.3,68003,NULL,NULL,'J','NGC 6314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140793,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140793,34.06,0.69,64.8,68003,100,NULL,'mid-IR','NGC 6314',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140794,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140794,34.5,0.34,79.5,68003,NULL,NULL,NULL,'NGC 6314',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140795,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140795,34.54,0.2,80.9,68003,74.4,NULL,NULL,'NGC 6314',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140796,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140796,34.64,0.4,84.7,68003,NULL,NULL,'mean','NGC 6314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140797,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140797,34.75,0.3,89.2,68003,NULL,NULL,'Malmquist cor.','NGC 6314',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140798,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140798,38.35,0.46,469,68004,70,NULL,NULL,'2MASX J17124062+6213055',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000115,NULL,'17.6g',0.23,'AGN',NULL,NULL,NULL,NULL,1,258.1692917,62.21817,0.085,NULL,57565552698,899461760,14054090,17.6),(140799,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140799,37.56,0.46,325,68005,70,NULL,NULL,'2MASX J17124132+3204221',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.172125,32.07289,0.157,NULL,56344106929,880376670,13755885,18.1),(140800,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140800,38.07,0.46,411,68006,70,NULL,NULL,'2MASX J17124493+4229496',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.187125,42.49717,0.037,NULL,59649452666,932022697,14562854,17.5),(140801,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140801,37.81,0.46,365,68007,70,NULL,NULL,'2MASX J17124571+2732533',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',NULL,NULL,'18.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,258.190625,27.54811,0.169,NULL,56320718713,880011229,13750175,18.1),(140802,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140802,38.54,0.46,511,68008,70,NULL,NULL,'2MASX J17124711+2917343',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00014,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,258.19625,29.29297,0.169,NULL,56315307734,879926683,13748854,18.1),(140803,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140803,37.69,0.07,345,68009,70,NULL,NULL,'2MASX J17125008+6403105',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,258.208375,64.05294,0.057,NULL,57574305780,899598527,14056226,16.9),(140804,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140804,38.39,0.33,476,68010,70,NULL,NULL,'2MASX J17125158+5832407',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000085,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,258.214833333,58.54461,0.033,NULL,57703434593,901616165,14087752,17.7),(140805,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140805,37.43,0.33,306,68011,70,NULL,NULL,'2MASX J17125273+3207002',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000172,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,258.219625,32.11675,0.157,NULL,56344063066,880375985,13755874,16.5),(140806,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140806,37.89,0.46,379,68012,70,NULL,NULL,'SDSS J171253.70+585128.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000079,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.2237917,58.858,0.029,NULL,57687932985,901373952,14083968,18.5),(140807,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140807,37.69,0.07,345,68013,70,NULL,NULL,'2MASX J17125447+6359325',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000085,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,258.2267917,63.99239,0.085,NULL,57574298915,899598420,14056225,16.3),(140808,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140808,38.8,0.46,575,68014,70,NULL,NULL,'2MASX J17125474+3313242',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.228167,33.22356,0.153,NULL,56354330782,880536418,13758381,18.3),(140809,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140809,37.43,0.33,306,68015,70,NULL,NULL,'2MASX J17125477+3209192',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000184,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,258.22825,32.15536,0.157,NULL,56344065918,880376029,13755875,16.7),(140810,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140810,37.13,0.46,267,68016,70,NULL,NULL,'2MASX J17125700+2315265',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000194,NULL,'17.2g',0.17,'Sa       Cand. BLAGN',NULL,NULL,NULL,NULL,1,258.237583333,23.25744,0.213,NULL,56794545571,887414774,13865855,17.2),(140811,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140811,36.95,0.46,246,68017,70,NULL,NULL,'2MASX J17125915+2219315',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,258.246541667,22.32544,0.205,NULL,56794237769,887409965,13865780,16.2),(140812,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140812,37.85,0.46,371,68018,70,NULL,NULL,'2MASX J17125969+5931228',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000088,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,258.2487917,59.52286,0.045,NULL,57685187154,901331049,14083297,17.3),(140813,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140813,37.41,0.46,304,68019,70,NULL,NULL,'2MASX J17130221+6026554',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000066,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,258.259125,60.44883,0.061,NULL,57562646406,899416350,14053380,17.3),(140814,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140814,37.69,0.07,345,68020,70,NULL,NULL,'ZwCl 1710.4+6401 24',NULL,'2015arXiv151105856S',2015,1,0.39,'One of two 6cm sources associated with [WB92] 1712+6405','G',0.000063,NULL,'16.6g',0.28,'Radio galaxy',NULL,NULL,NULL,NULL,1,258.26575,64.11714,0.093,NULL,57575039567,899609993,14056406,16.6),(140815,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140815,36.45,0.53,195,68021,70,NULL,NULL,'2MASX J17130591-6026042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.274625,-60.43458,0.553,NULL,44476435166,694944299,10858504,15.5),(140816,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140816,36.49,0.46,199,68022,70,NULL,NULL,'2MASX J17130709+2957462',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.279625,29.96292,0.089,NULL,56362654062,880666469,13760413,17.4),(140817,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140817,38.37,0.46,472,68023,70,NULL,NULL,'2MASX J17130717+2848333',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,258.279958333,28.80931,0.165,NULL,56315847914,879935123,13748986,17.3),(140818,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140818,37.69,0.07,345,68024,70,NULL,NULL,'ZwCl 1710.4+6401 26',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000083,NULL,'17.8g',0.2,'Red',NULL,NULL,NULL,NULL,1,258.292625,63.98514,0.085,NULL,57574299507,899598429,14056225,17.8),(140819,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140819,38.65,0.46,537,68025,70,NULL,NULL,'2MASX J17131542+3238288',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000151,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.314375,32.64142,0.149,NULL,56351505014,880492265,13757691,18.4),(140820,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140820,37.69,0.07,345,68026,70,NULL,NULL,'2MASX J17131603+6347378',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00005,NULL,'15.8g',0.46,'Radio galaxy',NULL,NULL,'radio jet',NULL,1,258.316708333,63.79375,0.085,NULL,57572446149,899569471,14055772,15.8),(140821,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140821,37.69,0.07,345,68027,70,NULL,NULL,'ZwCl 1710.4+6401 33',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000081,NULL,'17.3g',0.23,'Very red',NULL,NULL,NULL,NULL,1,258.3195,64.05569,0.093,NULL,57574347118,899599173,14056237,17.3),(140822,'Maser','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140822,35,NULL,100,68028,NULL,NULL,NULL,'NGC 6323',NULL,'2009astro2010S..23B',2009,1,1.1,NULL,'G',0.000117,NULL,'14.85',0.4,'Sab            Sy2',NULL,NULL,NULL,NULL,1,258.325333,43.78244,0.029,NULL,59658013669,932156463,14564944,14.85),(140823,'Maser','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140823,35.15,0.72,107,68028,73,NULL,NULL,'NGC 6323',NULL,'2015ApJ...800...26K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140824,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140824,37.69,0.07,345,68029,70,NULL,NULL,'ZwCl 1710.4+6401 35',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000084,NULL,'16.2g',0.39,'BrClG;red, fuzzy',NULL,NULL,NULL,NULL,1,258.329333333,64.07686,0.093,NULL,57574347597,899599181,14056237,16.2),(140825,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140825,37.69,0.07,345,68030,70,NULL,NULL,'ZwCl 1710.4+6401 34',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000083,NULL,'18.0g',0.17,'Very red',NULL,NULL,NULL,NULL,1,258.33325,64.05681,0.093,NULL,57574347081,899599173,14056237,18),(140826,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140826,37.69,0.07,345,68031,70,NULL,NULL,'2MASX J17132039+6348349',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000062,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,258.335,63.80964,0.085,NULL,57572443942,899569436,14055772,17.8),(140827,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140827,37.69,0.07,345,68032,70,NULL,NULL,'2MASX J17132170+6404089',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000096,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,258.3405417,64.06908,0.093,NULL,57574347458,899599179,14056237,16.7),(140828,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140828,35.82,0.56,146,68033,70,NULL,NULL,'2MASX J17132357-6451185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.348125,-64.85511,0.325,NULL,44480954462,695014913,10859608,15.3),(140829,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140829,35.72,0.82,139,68034,70,NULL,NULL,'2MFGC 13742',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,258.363,-79.55461,0.429,NULL,44262395356,691599927,10806248,17.3),(140830,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140830,35.8,0.67,144,68035,70,NULL,NULL,'2MASX J17132887-0919476',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.370333,-9.33,1.161,NULL,45182682111,705979407,11030928,15.9),(140831,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140831,37.69,0.07,345,68036,70,NULL,NULL,'2MASX J17132903+6402489',NULL,'2015arXiv151105856S',2015,1,0.6,'One of two 6cm sources associated with [WB92] 1712+6405','G',0.000063,NULL,'16.0g',0.41,'Radio galaxy   AGN',NULL,NULL,NULL,NULL,1,258.3712917,64.04686,0.093,NULL,57574350811,899599231,14056237,16),(140832,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140832,37.69,0.07,345,68037,70,NULL,NULL,'2MASX J17133155+6412210',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000092,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.381291667,64.20592,0.093,NULL,57575037518,899609961,14056405,17.6),(140833,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140833,37,0.46,252,68038,70,NULL,NULL,'2MASX J17133157+2136162',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',NULL,NULL,'17.06',0.41,NULL,NULL,NULL,NULL,NULL,1,258.381416667,21.60458,0.265,NULL,56806289785,887598277,13868723,17.06),(140834,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140834,37.69,0.07,345,68039,70,NULL,NULL,'2MASX J17133391+6400480',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00008,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,258.391333,64.01339,0.121,NULL,57574355702,899599307,14056239,16.7),(140835,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140835,38.12,0.46,420,68040,70,NULL,NULL,'2MASX J17133614+5628478',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000086,NULL,'18.4g',0.14,'NLAGN',NULL,NULL,NULL,NULL,1,258.400667,56.48008,0.029,NULL,57698626050,901541032,14086578,18.4),(140836,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140836,37.69,0.07,345,68041,70,NULL,NULL,'ZwCl 1710.4+6401 39',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000066,NULL,'17.9g',0.21,'Fuzzy, red',NULL,NULL,NULL,NULL,1,258.411833,64.15892,0.093,NULL,57575044865,899610076,14056407,17.9),(140837,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140837,37.69,0.07,345,68042,70,NULL,NULL,'ZwCl 1710.4+6401 38',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.2g',0.16,'Red',NULL,NULL,NULL,NULL,1,258.4127917,64.13347,0.093,NULL,57575040950,899610014,14056406,18.2),(140838,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140838,37.45,0.46,309,68043,70,NULL,NULL,'2MASX J17134528+2838215',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,258.438625,28.63933,0.165,NULL,56315439516,879928742,13748886,16.9),(140839,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140839,32.76,0.8,35.7,68044,75,NULL,'MAT, I','IC 4633',NULL,'1997ApJS..109..333W',1997,1,4,'Fairall (1984,MNRAS,210,69) gives v = 5200 +/- 200 km/sec.','G',0.00003,NULL,'12.8',3,'SAB(r)d','in a triple',NULL,NULL,NULL,1,258.446,-77.53619,0.433,NULL,44138701525,689667211,10776050,12.8),(140840,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140840,32.82,0.8,36.6,68044,75,NULL,NULL,'IC 4633',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140841,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140841,32.2,0.43,27.6,68044,75,NULL,'3.6 micron, color + selection bias corrected','IC 4633',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140842,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140842,32.34,0.43,29.3,68044,75,NULL,'3.6 micron, color corrected','IC 4633',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140843,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140843,32.41,0.46,30.3,68044,NULL,NULL,'J','IC 4633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140844,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140844,32.42,0.47,30.5,68044,NULL,NULL,'H','IC 4633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140845,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140845,32.42,0.45,30.5,68044,NULL,NULL,'K','IC 4633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140846,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140846,32.45,0.2,30.9,68044,74.4,NULL,NULL,'IC 4633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140847,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140847,32.76,0.32,35.6,68044,85,NULL,'I, raw','IC 4633',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140848,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140848,32.82,0.32,36.7,68044,85,NULL,'I, inv','IC 4633',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140849,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140849,32.88,0.4,37.6,68044,NULL,NULL,'mean','IC 4633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140850,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140850,33.13,0.43,42.3,68044,75,NULL,'MAT, I, raw','IC 4633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140851,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140851,33.43,0.43,48.6,68044,75,NULL,'MAT, I, cor','IC 4633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140852,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140852,33.45,0.43,49.1,68044,75,NULL,'MAT, I, inv','IC 4633',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140853,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140853,37.69,0.07,345,68045,70,NULL,NULL,'ZwCl 1710.4+6401 41',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00008,NULL,'17.7g',0.2,'Red',NULL,NULL,NULL,NULL,1,258.450791667,64.02036,0.121,NULL,57574357500,899599335,14056239,17.7),(140854,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140854,38.08,0.46,412,68046,70,NULL,NULL,'SDSS J171348.22+640850.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,258.450958333,64.14725,0.093,NULL,57575045046,899610078,14056407,18.4),(140855,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140855,36.09,0.6,165,68047,70,NULL,NULL,'2MASX J17134957-0909434',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.456583333,-9.16208,1.161,NULL,45300703164,707823486,11059741,16.1),(140856,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140856,34.2,0.34,69.1,68048,NULL,NULL,'Malmquist cor.','ESO 138- G 018',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.96',0.4,'S0+?',NULL,NULL,NULL,NULL,1,258.475,-60.81011,0.553,NULL,44477396092,694959313,10858739,14.96),(140857,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140857,34.3,0.33,72.3,68048,NULL,NULL,NULL,'ESO 138- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140858,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140858,34.34,0.2,73.8,68048,74.4,NULL,NULL,'ESO 138- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140859,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140859,38.32,0.46,461,68049,70,NULL,NULL,'2MASX J17135464+3158454',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,258.4777083,31.97942,0.165,NULL,56343343544,880364742,13755699,18.1),(140860,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140860,38.49,0.46,499,68050,70,NULL,NULL,'2MASX J17135849+5515327',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000098,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,258.493625,55.25897,0.045,NULL,57697843473,901528804,14086387,17.5),(140861,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140861,38.36,0.46,470,68051,70,NULL,NULL,'2MASX J17135911+2912105',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.49625,29.20297,0.157,NULL,56315799886,879934373,13748974,17.6),(140862,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140862,31.75,0.8,22.4,68052,75,NULL,NULL,'UGC 10792',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000017,NULL,'17.',1.8,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,258.506667,75.20361,0.161,NULL,57106714241,892292410,13942068,17),(140863,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140863,36.24,0.52,177,68053,70,NULL,NULL,'2MASX J17140369-6412504',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.51525,-64.21394,0.429,NULL,44484724638,695073822,10860528,15),(140864,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140864,37.14,0.46,268,68054,70,NULL,NULL,'2MASX J17140618+4144070',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.525875,41.73519,0.057,NULL,59631601499,931743773,14558496,16.9),(140865,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140865,37.68,0.46,344,68055,70,NULL,NULL,'2MASX J17140722+3134264',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,258.530125,31.57417,0.177,NULL,56361032895,880641138,13760017,18),(140866,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140866,37.69,0.07,345,68056,70,NULL,NULL,'ZwCl 1710.4+6401 43',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000088,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,258.539583,64.22011,0.093,NULL,57575148246,899611691,14056432,17.4),(140867,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140867,37.51,0.27,317,68057,70,NULL,NULL,'2MASX J17141115+3200284',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.546416667,32.00781,0.165,NULL,56343385495,880365398,13755709,17.5),(140868,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140868,37.89,0.46,379,68058,70,NULL,NULL,'2MASX J17141279+3636001',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.553375,36.6,0.185,NULL,56122413622,876912712,13701761,17.3),(140869,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140869,34.61,0.49,83.7,68059,75,NULL,'IR','CGCG 140-002',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.000274,NULL,'15.5',NULL,NULL,NULL,NULL,NULL,NULL,1,258.587333333,23.07158,0.225,NULL,56793303612,887395368,13865552,15.5),(140870,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140870,38.09,0.46,415,68060,70,NULL,NULL,'2MASX J17142124+2810136',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000174,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.5884583,28.17031,0.153,NULL,56317386864,879959169,13749362,18.4),(140871,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140871,36.27,0.85,179,68061,70,NULL,NULL,'2MASX J17142124-0956499',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.5885417,-9.94719,1.257,NULL,45300874500,707826164,11059783,16.5),(140872,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140872,38.21,0.46,438,68062,70,NULL,NULL,'2MASX J17142211+2904446',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.5922917,29.079,0.161,NULL,56315787017,879934172,13748971,18.4),(140873,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140873,35.18,NULL,109,68063,NULL,NULL,'Dipole','ESO 101- G 022',NULL,'2010Ap&SS.325..163P',2010,1,1.85,NULL,'G',0.000044,NULL,'15.51',0.19,'Sbc',NULL,NULL,NULL,NULL,1,258.594333,-65.93664,0.321,NULL,44434827978,694294187,10848346,15.51),(140874,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140874,35.2,NULL,109,68063,NULL,NULL,'Dipole + Quadrupole','ESO 101- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140875,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140875,35.2,NULL,109,68063,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 101- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140876,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140876,37.79,0.46,361,68064,70,NULL,NULL,'2MASX J17142696+5825215',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000092,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.612167,58.42261,0.045,NULL,57685943820,901342872,14083482,17.5),(140877,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140877,37.67,0.21,343,68065,70,NULL,NULL,'2MASX J17143060+6517227',NULL,'2015arXiv151105856S',2015,1,0.46,'One of two 6cm sources associated with [WB92] 1714+6513','G',0.00009,NULL,'16.5g',0.36,'E;BrClG',NULL,NULL,NULL,NULL,1,258.6275417,65.28972,0.113,NULL,57516999670,898703119,14042236,16.5),(140878,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140878,37.99,0.46,395,68066,70,NULL,NULL,'2MASX J17143064+3709520',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,258.627625,37.16433,0.161,NULL,56134343615,877099118,13704673,17.3),(140879,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140879,37.67,0.21,343,68067,70,NULL,NULL,'2MASX J17143282+6519338',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00006,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.636375,65.32586,0.129,NULL,57517000279,898703129,14042236,18.2),(140880,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140880,37.51,0.27,317,68068,70,NULL,NULL,'2MASX J17143454+3149511',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000154,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,258.6437917,31.83097,0.165,NULL,56343295242,880363988,13755687,17.6),(140881,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140881,35.4,0.19,120,68069,70,NULL,NULL,'CGCG 299-063',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000067,NULL,'15.4g',0.41,'E/S0','Group member',NULL,NULL,NULL,1,258.656875,57.30544,0.029,NULL,57697906281,901529785,14086402,15.4),(140882,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140882,35.46,0.25,124,68069,74.4,NULL,NULL,'CGCG 299-063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140883,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140883,35.68,0.25,137,68069,70,NULL,NULL,'CGCG 299-063',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140884,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140884,36.06,0.46,163,68070,70,NULL,NULL,'2MASX J17143791+2931137',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'15.9g',0.38,'E0',NULL,NULL,NULL,NULL,1,258.658125,29.52058,0.145,NULL,56360774800,880637106,13759954,15.9),(140885,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140885,37.11,0.46,264,68071,70,NULL,NULL,'SDSS J171438.66+630225.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.661125,63.04028,0.113,NULL,57577250922,899644545,14056946,17.9),(140886,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140886,32.63,0.2,33.6,68072,74.4,NULL,NULL,'UGC 10791',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00001,NULL,'15.1g',0.78,'Sm:',NULL,NULL,NULL,NULL,1,258.66125,72.39861,0.165,NULL,57053976263,891468379,13929193,15.1),(140887,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140887,32.71,0.43,34.8,68072,75,NULL,'3.6 micron, color corrected','UGC 10791',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140888,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140888,32.76,0.43,35.7,68072,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10791',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140889,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140889,37.51,0.27,317,68073,70,NULL,NULL,'2MASX J17144254+3149521',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00018,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,258.677333333,31.83106,0.165,NULL,56343284044,880363813,13755684,17.3),(140890,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140890,36.31,0.56,182,68074,70,NULL,NULL,'FAIRALL 1466',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.0b',0.42,NULL,NULL,NULL,NULL,NULL,1,258.6919583,-74.81283,0.293,NULL,44155930803,689936418,10780256,16),(140891,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140891,38.31,0.46,460,68075,70,NULL,NULL,'2MASX J17144925+3849491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.70525,38.83022,0.181,NULL,59633503077,931773485,14558960,17.4),(140892,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140892,38.5,0.46,501,68076,70,NULL,NULL,'2MASX J17145055+2846067',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,258.71075,28.76839,0.165,NULL,56315680818,879932512,13748945,18.5),(140893,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140893,37.69,0.07,345,68077,70,NULL,NULL,'VII Zw 701',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.3g',0.23,'Red',NULL,NULL,NULL,NULL,1,258.712166667,64.01017,0.121,NULL,57574335455,899598991,14056234,17.3),(140894,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140894,35.4,0.19,120,68078,70,NULL,NULL,'GIN 638',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000067,NULL,'15.5g',0.51,'E/S0',NULL,NULL,NULL,NULL,1,258.7235417,57.67336,0.081,NULL,57685357352,901333708,14083339,15.5),(140895,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140895,35.45,0.25,123,68078,74.4,NULL,NULL,'GIN 638',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140896,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140896,35.68,0.25,137,68078,70,NULL,NULL,'GIN 638',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140897,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140897,37.67,0.21,343,68079,70,NULL,NULL,'2MASX J17145408+6521238',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.7254583,65.35669,0.129,NULL,57516995266,898703051,14042235,17.6),(140898,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140898,37.67,0.46,341,68080,70,NULL,NULL,'2MASX J17145860+2933517',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,258.744167,29.56425,0.145,NULL,56360822868,880637857,13759966,16.8),(140899,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140899,37.56,0.64,325,68081,70,NULL,NULL,'2MASX J17150233-6846085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,258.7597083,-68.76906,0.401,NULL,44979685846,702807591,10981368,15.4),(140900,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140900,36.27,0.46,180,68082,70,NULL,NULL,'2MASX J17150569+5925309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00001,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.773666667,59.42522,0.061,NULL,57685198662,901331229,14083300,16.9),(140901,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140901,35.95,0.46,155,68083,70,NULL,NULL,'2MASX J17150626+3008392',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000187,NULL,'15.7g',0.39,'S0',NULL,NULL,NULL,NULL,1,258.7760417,30.14417,0.137,NULL,56360299995,880629687,13759838,15.7),(140902,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140902,37.9,0.46,380,68084,70,NULL,NULL,'2MASX J17150636+3728511',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.776417,37.48067,0.165,NULL,56133515513,877086179,13704471,17.7),(140903,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140903,35.49,NULL,125,68085,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2122',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',0.000052,NULL,'16.3g',0.15,'Sd(f)',NULL,NULL,NULL,NULL,1,258.7800417,58.2405,0.057,NULL,57685926468,901342601,14083478,16.3),(140904,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140904,35.51,NULL,127,68085,NULL,NULL,'Dipole + Quadrupole','FGC 2122',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140905,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140905,35.52,NULL,127,68085,NULL,NULL,'Dipole','FGC 2122',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140906,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140906,35.54,NULL,128,68085,NULL,NULL,NULL,'FGC 2122',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140907,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140907,36.9,0.46,240,68086,70,NULL,NULL,'2MASX J17150860+6003196',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000073,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.785916667,60.05533,0.053,NULL,57554352648,899286760,14051355,17.5),(140908,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140908,34.83,NULL,92.4,68087,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2120',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000014,NULL,'16.5',0.13,'Sc',NULL,NULL,NULL,NULL,1,258.7930417,6.99142,0.321,NULL,56040843544,875638180,13681846,16.5),(140909,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140909,34.83,NULL,92.5,68087,NULL,NULL,'Dipole','FGC 2120',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140910,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140910,34.83,NULL,92.6,68087,NULL,NULL,'Dipole + Quadrupole','FGC 2120',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140911,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140911,34.9,0.43,95.5,68087,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2120',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140912,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140912,34.96,NULL,98.3,68087,NULL,NULL,NULL,'FGC 2120',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140913,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140913,37.7,0.46,346,68088,70,NULL,NULL,'2MASX J17151076+3815408',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.794917,38.26128,0.185,NULL,59632618799,931759668,14558744,17.5),(140914,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140914,38.21,0.46,439,68089,70,NULL,NULL,'2MASX J17151235+6419079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,258.8017083,64.31908,0.093,NULL,57575132308,899611442,14056428,18),(140915,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140915,36.79,0.46,228,68090,70,NULL,NULL,'2MASX J17151768+6208240',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000079,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,258.823625,62.14014,0.085,NULL,57565444100,899460064,14054063,16.6),(140916,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140916,35.45,0.25,123,68091,74.4,NULL,NULL,'NGC 6338',NULL,'2013AJ....146...86T',2013,1,1.56,NULL,'G',0.00008,NULL,'13.6g',1,'cD;S0;PEG     blazar','Group member',NULL,NULL,NULL,1,258.845791667,57.41119,0.073,NULL,57692666609,901447915,14085123,13.6),(140917,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140917,35.68,0.25,137,68091,70,NULL,NULL,'NGC 6338',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140918,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140918,35.43,0.4,122,68091,NULL,NULL,'mean','NGC 6338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140919,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140919,35.62,0.45,133,68091,NULL,NULL,'K','NGC 6338',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140920,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140920,35.46,0.25,124,68092,74.4,NULL,NULL,'NGC 6346',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000063,NULL,'14.7g',0.63,'E','in a pair',NULL,NULL,NULL,1,258.852041667,57.32253,0.061,NULL,57690567135,901415111,14084611,14.7),(140921,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140921,35.68,0.25,137,68092,70,NULL,NULL,'NGC 6346',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140922,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140922,37.89,0.27,379,68093,70,NULL,NULL,'2MASX J17152917+6546501',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000097,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,258.871833333,65.78061,0.129,NULL,57517153147,898705517,14042273,16.6),(140923,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140923,37.62,0.19,334,68094,70,NULL,NULL,'2MASX J17153003+6439511',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000133,NULL,'15.8g',0.44,'E;BrClG        AGN',NULL,NULL,NULL,NULL,1,258.875125,64.66433,0.109,NULL,57574683738,899604433,14056319,15.8),(140924,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140924,36.03,0.49,161,68095,70,NULL,NULL,'2MASX J17153186-8641168',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,258.882,-86.688,0.181,NULL,44030510985,687976734,10749636,16),(140925,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140925,35.4,0.19,120,68096,70,NULL,NULL,'2MASX J17153166+5730085',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000072,NULL,'16.1g',0.28,'S0',NULL,NULL,NULL,NULL,1,258.882125,57.50247,0.073,NULL,57685319007,901333109,14083329,16.1),(140926,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140926,37.19,0.46,274,68097,70,NULL,NULL,'2MASX J17153282+5527525',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000114,NULL,'16.2g',0.39,NULL,NULL,NULL,NULL,NULL,1,258.886708333,55.46456,0.045,NULL,57697295357,901520239,14086253,16.2),(140927,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140927,37.79,0.33,361,68098,70,NULL,NULL,'2MASX J17153360+6539571',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,258.8902083,65.66578,0.129,NULL,57516818841,898700294,14042192,17.4),(140928,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140928,38.07,0.46,410,68099,70,NULL,NULL,'2MASX J17153431+2620330',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.893083,26.3425,0.137,NULL,56306362549,879786914,13746670,17.4),(140929,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140929,34.82,0.17,89.3,68100,74.2,NULL,'SALT 2','CGCG 111-016',0.03066,'2010ApJ...716..712A',2010,1,0.8,NULL,'G',0.000097,NULL,'15.1',0.8,'SBa',NULL,NULL,NULL,NULL,1,258.89325,16.32486,0.369,NULL,56819354273,887802410,13871912,15.1),(140930,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140930,35.35,0.04,114,68100,70,NULL,'SALT 2','CGCG 111-016',0.03066,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140931,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140931,35.43,0.2,118,68100,72,NULL,NULL,'CGCG 111-016',0.03066,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140932,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140932,35.36,0.1,118,68100,60,NULL,'M(B) = -19.48 mag','CGCG 111-016',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140933,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140933,35.38,0.08,119,68100,60,NULL,'M(V) = -19.47 mag','CGCG 111-016',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140934,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140934,35.41,0.08,121,68100,74.4,NULL,NULL,'CGCG 111-016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140935,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140935,35.52,0.16,123,68100,70,NULL,'SALT 2','CGCG 111-016',0.03066,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140936,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140936,35.54,0.03,124,68100,72,NULL,NULL,'CGCG 111-016',0.03066,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140937,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140937,35.53,0.09,124,68100,70,NULL,NULL,'CGCG 111-016',0.03066,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140938,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140938,35.54,0.16,124,68100,70,NULL,'SALT','CGCG 111-016',0.03066,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140939,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140939,35.57,0.11,126,68100,65,NULL,'SALT2','CGCG 111-016',0.03066,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140940,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140940,35.59,0.17,127,68100,73.8,NULL,'SALT 2 (SNANA)','CGCG 111-016',0.0309,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140941,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140941,35.53,0.09,128,68100,60,NULL,'M(I) = -19.19 mag','CGCG 111-016',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140942,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140942,35.6,0.17,132,68100,70.8,NULL,NULL,'CGCG 111-016',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140943,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140943,35.68,0.19,133,68100,65,NULL,'SALT2','CGCG 111-016',0.03066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140944,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140944,35.71,0.16,135,68100,65,NULL,'SALT','CGCG 111-016',0.03066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140945,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140945,35.81,0.1,137,68100,65,NULL,'MLCS2k2','CGCG 111-016',0.03066,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140946,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140946,35.79,0.16,140,68100,65,NULL,'MLCS17','CGCG 111-016',0.03066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140947,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140947,35.79,0.16,140,68100,65,NULL,'MLCS31','CGCG 111-016',0.03066,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140948,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140948,35.81,0.1,141,68100,65,NULL,'MLCS2k2','CGCG 111-016',0.03066,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140949,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140949,35.81,0.05,141,68100,65,NULL,'SALT','CGCG 111-016',0.03066,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140950,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140950,35.81,0.1,141,68100,65,NULL,'MLCS2k2','CGCG 111-016',0.03066,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140951,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140951,35.9,0.2,147,68100,65,NULL,NULL,'CGCG 111-016',0.03066,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140952,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 1990O',NULL,140952,35.93,0.14,153,68100,60,NULL,NULL,'CGCG 111-016',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140953,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140953,32.77,0.8,35.8,68101,75,NULL,'MAT, I','IC 4635',NULL,'1997ApJS..109..333W',1997,1,3,'Allen, et al. (1991, MNRAS, 248, 528) give z=0.014 +/- 0.001.','G',0.000033,NULL,'11.81',0.7,'SAB(s)b: sp','in a triple',NULL,NULL,NULL,1,258.913291667,-77.48953,0.433,NULL,44138758090,689668095,10776063,11.81),(140954,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140954,32.21,0.49,27.7,68101,75,NULL,'IR','IC 4635',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140955,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140955,32.35,0.43,29.5,68101,75,NULL,'MAT, I, raw','IC 4635',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140956,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140956,32.36,0.32,29.7,68101,85,NULL,'I, raw','IC 4635',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140957,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140957,32.39,0.32,30.1,68101,85,NULL,'I, inv','IC 4635',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140958,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140958,32.51,0.43,31.8,68101,75,NULL,'MAT, I, inv','IC 4635',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140959,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140959,32.64,0.43,33.7,68101,75,NULL,'MAT, I, cor','IC 4635',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140960,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140960,35.4,0.19,120,68102,70,NULL,NULL,'2MASX J17154083+5732066',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000086,NULL,'16.3g',0.21,'S0^-',NULL,NULL,NULL,NULL,1,258.9202083,57.53528,0.073,NULL,57685369496,901333898,14083342,16.3),(140961,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140961,37.92,0.33,384,68103,70,NULL,NULL,'SDSS J171541.69+271112.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000128,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,258.923708333,27.18667,0.161,NULL,56319805158,879996955,13749952,18.8),(140962,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140962,37.89,0.46,378,68104,70,NULL,NULL,'SDSS J171541.91+631902.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000076,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,258.924666667,63.3175,0.109,NULL,57576893725,899638964,14056858,18.2),(140963,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140963,37.89,0.27,379,68105,70,NULL,NULL,'2MASX J17154250+6545411',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,258.927125,65.76131,0.129,NULL,57519966209,898749472,14042960,17.7),(140964,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140964,37.86,0.46,373,68106,70,NULL,NULL,'2MASX J17154429+2828350',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.934708333,28.47636,0.129,NULL,56317858226,879966534,13749477,17.2),(140965,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140965,35.03,0.49,101,68107,75,NULL,'IR','NGC 6330',NULL,'2011yCatp016004901K',2011,1,0.93,NULL,'G',0.000033,NULL,'14.8g',0.55,'SBb',NULL,NULL,NULL,NULL,1,258.935083333,29.40431,0.145,NULL,56360071050,880626110,13759782,14.8),(140966,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140966,35.4,0.2,120,68107,74.4,NULL,NULL,'NGC 6330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140967,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140967,35.6,0.4,132,68107,NULL,NULL,'mean','NGC 6330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140968,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140968,35.67,0.47,136,68107,NULL,NULL,'H','NGC 6330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140969,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140969,35.8,0.45,145,68107,NULL,NULL,'K','NGC 6330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140970,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140970,37.62,0.19,334,68108,70,NULL,NULL,'2MASX J17154826+6439531',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000069,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,258.950791667,64.66481,0.109,NULL,57574642927,899603795,14056309,17.9),(140971,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140971,37.92,0.33,384,68109,70,NULL,NULL,'2MASX J17155032+2715405',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,258.959583,27.26125,0.161,NULL,56319345289,879989770,13749840,16.8),(140972,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140972,38.45,0.46,491,68110,70,NULL,NULL,'2MASX J17155274+3656070',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,258.9697917,36.93539,0.209,NULL,56133915598,877092431,13704569,17.2),(140973,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140973,37.62,0.19,334,68111,70,NULL,NULL,'2MASX J17155373+6441121',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,258.974,64.68672,0.109,NULL,57574643008,899603797,14056309,18),(140974,'GRB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140974,46.94,1.63,8270,68112,100,NULL,NULL,'GRB 080319C',1.95,'2009EPJC...63..139W',2009,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,258.981083,55.39206,0.101,NULL,57697251100,901519548,14086242,NULL),(140975,'GRB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140975,47.14,1.57,9080,68112,100,NULL,NULL,'GRB 080319C',1.95,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(140976,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140976,37.79,0.33,361,68113,70,NULL,NULL,'2MASX J17155478+6537281',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.9785417,65.62447,0.129,NULL,57516820781,898700324,14042192,17.6),(140977,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140977,37.67,0.21,343,68114,70,NULL,NULL,'SDSS J171557.24+652130.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,258.9885417,65.35858,0.129,NULL,57516854542,898700852,14042200,18.3),(140978,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140978,37.67,0.46,342,68115,70,NULL,NULL,'2MASX J17155833+2949194',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,258.993083,29.82194,0.133,NULL,56360901300,880639082,13759985,17.9),(140979,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140979,38.2,0.46,436,68116,70,NULL,NULL,'2MASX J17155889+3038275',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,258.9954583,30.64094,0.133,NULL,56362061739,880657214,13760268,17.6),(140980,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140980,35.89,0.53,151,68117,70,NULL,NULL,'2MASX J17160021-1615393',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.0009583,-16.26094,1.609,NULL,45993940760,718655324,11228989,15.1),(140981,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140981,37.18,0.46,273,68118,70,NULL,NULL,'2MASX J17160336+2959192',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.014083333,29.98883,0.133,NULL,56360859691,880638432,13759975,17.9),(140982,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140982,38.46,0.27,493,68119,70,NULL,NULL,'2MASX J17160643+3046593',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000173,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.026875,30.78331,0.133,NULL,56361523297,880648801,13760137,18.2),(140983,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140983,37.69,0.07,345,68120,70,NULL,NULL,'ZwCl 1710.4+6401 47',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000107,NULL,'17.3g',0.21,'Red',NULL,NULL,NULL,NULL,1,259.027417,64.0455,0.121,NULL,57574370730,899599542,14056242,17.3),(140984,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140984,38.14,0.46,425,68121,70,NULL,NULL,'2MASX J17160901+2623224',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.0377083,26.38964,0.153,NULL,56305455803,879772746,13746449,17.4),(140985,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140985,38.4,0.33,478,68122,70,NULL,NULL,'2MASX J17161008+3844260',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.042166667,38.74056,0.181,NULL,59633496399,931773381,14558959,17.8),(140986,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140986,38.46,0.27,493,68123,70,NULL,NULL,'2MASX J17161031+3047383',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.4g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,259.0430417,30.794,0.133,NULL,56361524165,880648815,13760137,17.4),(140987,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140987,33.99,0.49,62.7,68124,70,NULL,NULL,'FAIRALL 1469',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000073,NULL,'13.8R',0.5,NULL,NULL,NULL,NULL,NULL,1,259.0464583,-73.38539,0.213,NULL,44153609104,689900142,10779689,13.8),(140988,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140988,37.62,0.19,334,68125,70,NULL,NULL,'2MASX J17161256+6454172',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,259.052375,64.90489,0.109,NULL,57574429967,899600468,14056257,17.9),(140989,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140989,37.69,0.07,345,68126,70,NULL,NULL,'2MASX J17161489+6356402',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000098,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,259.061667,63.94467,0.121,NULL,57574422009,899600343,14056255,16.4),(140990,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140990,38.4,0.33,478,68127,70,NULL,NULL,'2MASX J17161735+3844360',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.07225,38.74328,0.181,NULL,59633494766,931773355,14558958,17.7),(140991,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140991,37.69,0.07,345,68128,70,NULL,NULL,'VII Zw 702',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000093,NULL,'16.6g',0.35,'Red',NULL,NULL,NULL,NULL,1,259.07675,64.13272,0.093,NULL,57574257528,899597773,14056215,16.6),(140992,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140992,38.44,0.46,487,68129,70,NULL,NULL,'2MASX J17162014+4051390',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.08375,40.86083,0.057,NULL,59632151892,931752373,14558630,17.1),(140993,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140993,38.54,0.46,509,68130,70,NULL,NULL,'2MASX J17162035+2800200',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,259.084833,28.00561,0.157,NULL,56317635724,879963058,13749422,17.6),(140994,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140994,37.89,0.27,379,68131,70,NULL,NULL,'2MASX J17162152+6545543',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000082,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.09,65.76511,0.113,NULL,57519980175,898749690,14042963,17.5),(140995,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140995,35.46,0.25,124,68132,74.4,NULL,NULL,'GIN 637',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000076,NULL,'15.9g',0.46,'S',NULL,NULL,NULL,NULL,1,259.099958333,57.42272,0.073,NULL,57692716312,901448692,14085135,15.9),(140996,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140996,35.68,0.25,137,68133,70,NULL,NULL,'SDSS J171624.48+572517.9',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'15.5g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,259.102,57.42167,0.073,NULL,57692716315,901448692,14085135,15.5),(140997,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',140997,37.78,0.33,359,68134,70,NULL,NULL,'2MASX J17162718+2820591',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.1132917,28.34967,0.129,NULL,56317948272,879967941,13749499,17.3),(140998,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140998,34.84,0.8,92.9,68135,75,NULL,'CF, r','UGC 10779',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000027,NULL,'14.10',0.8,'Sb',NULL,NULL,NULL,NULL,1,259.127375,6.43197,0.333,NULL,56040175835,875627747,13681683,14.1),(140999,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,140999,34.45,0.38,77.5,68135,75,NULL,'CF, r, raw','UGC 10779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141000,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141000,34.63,0.38,84.3,68135,75,NULL,'CF, r, inv','UGC 10779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141001,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141001,34.69,0.47,86.9,68135,NULL,NULL,'H','UGC 10779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141002,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141002,34.73,0.38,88.5,68135,75,NULL,'CF, r, cor','UGC 10779',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141003,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141003,34.77,0.45,90.1,68135,NULL,NULL,'K','UGC 10779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141004,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141004,34.86,0.46,93.7,68135,NULL,NULL,'J','UGC 10779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141005,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141005,35.05,0.4,102,68135,NULL,NULL,'mean','UGC 10779',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141006,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141006,34.75,0.49,89.2,68136,75,NULL,'IR','UGC 10780',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,259.142917,7.32617,0.353,NULL,56043626852,875681669,13682526,16.5),(141007,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141007,34.9,0.43,95.4,68136,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10780',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141008,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141008,35.07,0.43,104,68136,75,NULL,'3.6 micron, color corrected','UGC 10780',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141009,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141009,35.17,0.37,108,68136,NULL,NULL,'Malmquist cor.','UGC 10780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141010,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141010,35.22,0.36,111,68136,NULL,NULL,NULL,'UGC 10780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141011,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141011,35.23,0.2,111,68136,74.4,NULL,NULL,'UGC 10780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141012,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141012,35.46,NULL,124,68136,NULL,NULL,'Dipole + Quadrupole','UGC 10780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141013,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141013,35.47,NULL,124,68136,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141014,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141014,35.48,NULL,125,68136,NULL,NULL,'Dipole','UGC 10780',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141015,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141015,37.62,0.19,334,68137,70,NULL,NULL,'2MASX J17163493+6436573',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000062,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.145333,64.61603,0.109,NULL,57574651079,899603923,14056311,18.1),(141016,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141016,37.29,0.46,287,68138,70,NULL,NULL,'2MASX J17163697+6003144',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00002,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,259.154416667,60.05408,0.053,NULL,57554368076,899287001,14051359,16.9),(141017,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141017,38.46,0.27,493,68139,70,NULL,NULL,'2MASX J17163941+3045143',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.164125,30.75403,0.133,NULL,56362016113,880656501,13760257,17.4),(141018,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141018,37.78,0.33,359,68140,70,NULL,NULL,'2MASX J17164567+2826191',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.1902083,28.43875,0.161,NULL,56317939895,879967810,13749497,17),(141019,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141019,36.55,0.46,204,68141,70,NULL,NULL,'2MASX J17164585+6305524',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000099,NULL,'15.8g',0.43,'E0',NULL,NULL,NULL,NULL,1,259.190833,63.09794,0.113,NULL,57576948075,899639813,14056872,15.8),(141020,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141020,40.09,0.98,1040,68142,NULL,NULL,'Hydrost. Eq.','RX J1716.4+6708',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,259.206667,67.14167,0.149,NULL,57790999205,902984362,14109130,NULL),(141021,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141021,40.59,1.15,1310,68142,NULL,NULL,'Isotherm.','RX J1716.4+6708',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141022,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141022,41.6,1.02,2090,68142,NULL,NULL,'Isotherm., r < 100 kpc','RX J1716.4+6708',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141023,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141023,41.72,NULL,2210,68142,NULL,NULL,'4.2 (black) calibration','RX J1716.4+6708',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141024,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141024,41.73,NULL,2220,68142,NULL,NULL,'3.1 (red) calibration','RX J1716.4+6708',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141025,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141025,41.79,NULL,2280,68142,NULL,NULL,'4.1 (blue) calibration','RX J1716.4+6708',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141026,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141026,37.67,0.21,343,68143,70,NULL,NULL,'2MASX J17165000+6529203',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000084,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,259.207917,65.48911,0.117,NULL,57520353149,898755517,14043054,16.6),(141027,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141027,35.44,0.46,123,68144,70,NULL,NULL,'CGCG 170-011',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000157,NULL,'15.2g',0.52,'E0',NULL,NULL,NULL,NULL,1,259.217417,31.58414,0.145,NULL,56361098011,880642156,13760033,15.2),(141028,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141028,36.38,0.46,189,68145,70,NULL,NULL,'2MASX J17165264+5727490',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000086,NULL,'16.2g',0.38,'E0',NULL,NULL,NULL,NULL,1,259.21925,57.46372,0.073,NULL,57692697491,901448398,14085131,16.2),(141029,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141029,38.44,0.46,487,68146,70,NULL,NULL,'2MASX J17165614+6229193',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000102,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,259.234375,62.48869,0.089,NULL,57576684051,899635688,14056807,16.9),(141030,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141030,38.4,0.27,479,68147,70,NULL,NULL,'2MASX J17165630+2831185',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,259.234625,28.52172,0.161,NULL,56317796164,879965565,13749461,18.2),(141031,'Ring Diameter','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141031,30.6,0.76,13,68148,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6300',NULL,'1981ApJS...45..541P',1981,1,4.5,'Extended HIPASS source','G',0.00001,NULL,'10.98',3,'SB(rs)b        Sy2','Group member',NULL,NULL,'Sy 2',1,259.2477917,-62.82056,0.485,NULL,44491884324,695185692,10862276,10.98),(141032,'Ring Diameter','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141032,30.7,0.6,14,68148,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6300',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141033,'Sosies','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141033,30.22,0.08,11.1,68148,NULL,NULL,NULL,'NGC 6300',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141034,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141034,30.78,0.8,14.3,68148,75,NULL,'B','NGC 6300',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141035,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141035,30.24,0.43,11.2,68148,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6300',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141036,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141036,30.4,0.43,12,68148,75,NULL,'3.6 micron, color corrected','NGC 6300',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141037,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141037,30.59,0.36,13.1,68148,NULL,NULL,NULL,'NGC 6300',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141038,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141038,30.59,0.39,13.1,68148,73,NULL,'opt','NGC 6300',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141039,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141039,30.73,0.2,14,68148,74.4,NULL,NULL,'NGC 6300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141040,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141040,31.16,NULL,17.1,68148,NULL,NULL,'LEDA [April 2006]','NGC 6300',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141041,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141041,31.24,0.41,17.7,68148,NULL,NULL,NULL,'NGC 6300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141042,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141042,31.4,0.38,19.1,68148,NULL,NULL,'Malmquist cor.','NGC 6300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141043,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141043,32.59,0.8,32.9,68149,75,NULL,'A82, H','NGC 6339',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000013,NULL,'13.30',1.7,'SBd','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,259.277083,40.84497,0.057,NULL,59634191078,931784235,14559128,13.3),(141044,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141044,31.96,0.38,24.7,68149,NULL,NULL,NULL,'NGC 6339',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141045,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141045,31.99,0.43,25,68149,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141046,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141046,32.04,0.2,25.6,68149,74.4,NULL,NULL,'NGC 6339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141047,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141047,32.04,0.43,25.6,68149,75,NULL,'3.6 micron, color corrected','NGC 6339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141048,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141048,32.07,0.41,25.9,68149,NULL,NULL,NULL,'NGC 6339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141049,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141049,32.41,0.47,30.3,68149,75,NULL,'A82, H, raw','NGC 6339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141050,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141050,32.42,0.47,30.4,68149,75,NULL,'A82, H, inv','NGC 6339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141051,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141051,32.45,0.35,30.8,68149,NULL,NULL,'Malmquist cor.','NGC 6339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141052,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141052,32.64,0.4,33.7,68149,75,NULL,'B','NGC 6339',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141053,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141053,32.76,0.47,35.6,68149,75,NULL,'A82, H, cor','NGC 6339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141054,'CMD','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141054,14.9,NULL,0.0095,68150,NULL,NULL,NULL,'MESSIER 092',NULL,'2008A&A...477..139L',2008,1,NULL,NULL,'*Cl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,259.2802917,43.13653,0.057,0,59649883496,932029429,14562959,NULL),(141055,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141055,37.45,0.46,310,68151,70,NULL,NULL,'2MASX J17170916+2950327',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,259.288167,29.8425,0.137,NULL,56360038308,880625598,13759774,16.8),(141056,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141056,36.42,0.33,193,68152,70,NULL,NULL,'VII Zw 703',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000088,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.32225,64.27,0.093,NULL,57575082150,899610658,14056416,16.8),(141057,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141057,36.86,0.46,236,68153,70,NULL,NULL,'2MASX J17171798+3015133',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.324917,30.25369,0.121,NULL,56360334230,880630222,13759847,17.3),(141058,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141058,37.87,0.46,374,68154,70,NULL,NULL,'2MASX J17171999+2814587',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.333166667,28.24958,0.129,NULL,56317650818,879963294,13749426,17.4),(141059,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141059,38.1,0.33,417,68155,70,NULL,NULL,'2MASX J17172058+3734249',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.33575,37.57369,0.197,NULL,56134311923,877098623,13704665,17.4),(141060,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141060,38.1,0.33,417,68156,70,NULL,NULL,'2MASX J17172099+3732159',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,259.3375,37.53772,0.197,NULL,56134318513,877098726,13704667,NULL),(141061,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141061,37.75,0.46,354,68157,70,NULL,NULL,'2MASX J17172203+2821387',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00018,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.3419583,28.36092,0.129,NULL,56317535302,879961489,13749398,16.8),(141062,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141062,36.42,0.33,193,68158,70,NULL,NULL,'2MASX J17172381+6417235',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000083,NULL,'16.1g',0.42,'LINER',NULL,NULL,NULL,'Sy 1',1,259.3492917,64.28992,0.093,NULL,57575083097,899610673,14056416,16.1),(141063,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141063,38.37,0.46,473,68159,70,NULL,NULL,'2MASX J17172387+3041383',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000209,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.349417,30.69386,0.133,NULL,56360176040,880627750,13759808,18.1),(141064,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141064,37.55,0.46,324,68160,70,NULL,NULL,'2MASX J17172733+4022258',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.364,40.37383,0.085,NULL,59634581863,931790341,14559224,17),(141065,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141065,35.43,0.46,122,68161,70,NULL,NULL,'2MASX J17172814+6609344',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000061,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.367541667,66.15958,0.121,NULL,57519947427,898749178,14042955,16.5),(141066,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141066,35.7,0.61,138,68162,70,NULL,NULL,'2MASX J17172872-7128054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,259.369916667,-71.46814,0.385,NULL,44098124286,689033191,10766143,16.1),(141067,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141067,38.4,0.27,479,68163,70,NULL,NULL,'2MASX J17173038+2840156',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000202,NULL,'17.0g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,259.3765417,28.67108,0.165,NULL,56317089529,879954523,13749289,17),(141068,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141068,38.22,0.46,440,68164,70,NULL,NULL,'2MASX J17173035+4110108',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,259.376625,41.16978,0.081,NULL,59632035871,931750560,14558602,17.6),(141069,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141069,37.73,0.46,352,68165,70,NULL,NULL,'SDSS J171730.90+635633.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.3787917,63.94269,0.121,NULL,57574407301,899600114,14056251,18.3),(141070,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141070,37.38,0.46,299,68166,70,NULL,NULL,'2MASX J17173243+6047235',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000076,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.385166667,60.78978,0.077,NULL,57563066169,899422908,14053482,17.2),(141071,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141071,37.55,0.46,324,68167,70,NULL,NULL,'2MASX J17173365+3056513',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000163,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,259.390167,30.94756,0.137,NULL,56369667834,880776059,13762125,17.2),(141072,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141072,34.79,0.62,91,68168,70,NULL,NULL,'2MASX J17173526-0432306',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,259.396917,-4.54186,1.001,NULL,45340358504,708443101,11069423,17.2),(141073,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141073,37.83,0.46,367,68169,70,NULL,NULL,'VII Zw 704',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000094,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,259.41075,61.14544,0.113,NULL,57566487465,899476366,14054318,17.2),(141074,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141074,37.84,0.46,369,68170,70,NULL,NULL,'2MASX J17174058+2442466',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.4192083,24.71292,0.281,NULL,56274080094,879282501,13738789,17.2),(141075,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141075,38.4,0.27,479,68171,70,NULL,NULL,'2MASX J17174185+2837436',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.4245417,28.62878,0.161,NULL,56317060038,879954063,13749282,17.7),(141076,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141076,36.59,0.63,208,68172,70,NULL,NULL,'2MASX J17174316-6612071',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.4300417,-66.202,0.261,NULL,44438152196,694346128,10849158,15.7),(141077,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141077,37.54,0.27,322,68173,70,NULL,NULL,'2MASX J17174612+2916486',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000201,NULL,'15.7g',0.51,'AGN',NULL,NULL,NULL,NULL,1,259.44225,29.28028,0.145,NULL,56314825828,879919153,13748736,15.7),(141078,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141078,36.17,0.57,172,68174,70,NULL,NULL,'2MASX J17174883-6448252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.453417,-64.80706,0.293,NULL,44482223789,695034746,10859917,15.6),(141079,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141079,35.6,0.01,132,68175,NULL,NULL,'J, SN 2010gn','SDSS J171750.05+405252.5',NULL,'2012MNRAS.425.1007B',2012,1,0.35,NULL,'G',0,NULL,'18.2g',0.16,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,259.458583333,40.88128,0.057,NULL,59634328745,931786386,14559162,18.2),(141080,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141080,35.73,0.07,140,68175,72,NULL,'M(H) = -18.317 mag','SDSS J171750.05+405252.5',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141081,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141081,35.73,0.01,140,68175,NULL,NULL,'H, SN 2010gn','SDSS J171750.05+405252.5',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141082,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141082,35.82,0.04,141,68175,70,NULL,'SN 2010gn, SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','SDSS J171750.05+405252.5',0.0312,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141083,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN 2010gn',NULL,141083,35.83,0.04,142,68175,70,NULL,'SiFTO+SALT2, SN PTF10mwb, SN 2010gn','SDSS J171750.05+405252.5',0.0365,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141084,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141084,37.6,0.46,331,68176,70,NULL,NULL,'2MASX J17175031+6210025',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.4595417,62.16742,0.073,NULL,57565292481,899457695,14054026,17.7),(141085,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141085,35.37,0.62,118,68177,70,NULL,NULL,'2MASX J17175138-7033102',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,259.4639583,-70.55289,0.221,NULL,44097742648,689027228,10766050,16.2),(141086,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141086,37.97,0.46,393,68178,70,NULL,NULL,'2MASX J17175490+2748056',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.4787083,27.80158,0.133,NULL,56320382049,880005969,13750093,17.4),(141087,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141087,37.54,0.27,322,68179,70,NULL,NULL,'SDSS J171755.18+291337.0',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000176,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.479958333,29.22697,0.145,NULL,56316935180,879952112,13749251,17.2),(141088,'D-Sigma','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141088,32,0.4,25.1,68180,75,NULL,'Edat, raw','NGC 6305',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00015,NULL,'13.24',1.1,'SB0^-',NULL,NULL,NULL,NULL,1,259.503833,-59.17208,0.501,NULL,44519130865,695611419,10868928,13.24),(141089,'D-Sigma','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141089,32.33,0.4,29.3,68180,75,NULL,'Edat, cor','NGC 6305',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141090,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141090,32.77,0.8,35.8,68180,75,NULL,NULL,'NGC 6305',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141091,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141091,32.74,0.45,35.4,68180,NULL,NULL,'K','NGC 6305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141092,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141092,32.99,0.4,39.7,68180,NULL,NULL,'mean','NGC 6305',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141093,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141093,38.81,0.46,578,68181,70,NULL,NULL,'SDSS J171801.45+553343.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00008,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.506083,55.56219,0.081,NULL,57689215415,901393990,14084281,18.2),(141094,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141094,38.35,0.46,467,68182,70,NULL,NULL,'2MASX J17180363+2630380',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000154,NULL,'17.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,259.515167,26.51067,0.165,NULL,56319052936,879985202,13749768,17.9),(141095,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141095,37.54,0.27,322,68183,70,NULL,NULL,'SDSS J171804.43+291850.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.518458333,29.31389,0.145,NULL,56314822717,879919104,13748736,18.3),(141096,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141096,37.87,0.46,374,68184,70,NULL,NULL,'SDSS J171805.55+303335.4',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000149,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.523166667,30.55986,0.129,NULL,56367797990,880746843,13761669,17.1),(141097,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141097,30.78,0.8,14.3,68185,75,NULL,NULL,'UKS 1713-578',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000007,NULL,'13.7',1.2,'IB(s)m',NULL,NULL,NULL,NULL,1,259.530417,-57.86028,0.653,NULL,44521320027,695645625,10869462,13.7),(141098,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141098,37.83,0.46,367,68186,70,NULL,NULL,'2MASX J17180867+3746451',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.536167,37.77906,0.157,NULL,56134017483,877094023,13704594,17.1),(141099,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141099,36.57,0.51,206,68187,70,NULL,NULL,'2MASX J17181917-6430190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.58,-64.50531,0.429,NULL,44482325107,695036329,10859942,15.1),(141100,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141100,36.73,0.6,222,68188,70,NULL,NULL,'2MASX J17182004-6901042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.583625,-69.01786,0.401,NULL,44977228985,702769202,10980768,15.3),(141101,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141101,37.51,0.46,318,68189,70,NULL,NULL,'2MASX J17182381+2935331',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.5992083,29.59242,0.129,NULL,56367296637,880739009,13761547,17.8),(141102,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141102,36.26,0.46,178,68190,70,NULL,NULL,'2MASX J17182411+2942211',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000188,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,259.600417,29.70578,0.137,NULL,56367479509,880741867,13761591,16.5),(141103,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141103,37.84,0.46,370,68191,70,NULL,NULL,'2MASX J17182887+6556071',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00008,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.620083,65.93528,0.117,NULL,57520101292,898751582,14042993,16.9),(141104,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141104,38.36,0.46,469,68192,70,NULL,NULL,'2MASX J17183032+2440416',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.626417,24.67833,0.301,NULL,56272326175,879255096,13738360,17.4),(141105,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141105,37.57,0.27,326,68193,70,NULL,NULL,'2MASX J17183116+6425052',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000093,NULL,'16.8g',0.28,'BrClG',NULL,NULL,NULL,NULL,1,259.629875,64.41811,0.089,NULL,57573496386,899585881,14056029,16.8),(141106,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141106,35.99,NULL,158,68194,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2126',NULL,'2010Ap&SS.325..163P',2010,1,0.95,NULL,'G',NULL,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,259.633875,41.66844,0.053,NULL,59649586953,932024796,14562887,16.5),(141107,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141107,36.01,NULL,159,68194,NULL,NULL,'Dipole + Quadrupole','FGC 2126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141108,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141108,36.01,NULL,159,68194,NULL,NULL,NULL,'FGC 2126',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141109,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141109,36.03,NULL,161,68194,NULL,NULL,'Dipole','FGC 2126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141110,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141110,36.12,0.49,168,68194,75,NULL,'IR','FGC 2126',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141111,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141111,37.57,0.27,326,68195,70,NULL,NULL,'SDSS J171833.75+642559.7',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000114,NULL,'17.4g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,259.640625,64.43331,0.089,NULL,57573496631,899585884,14056029,17.4),(141112,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141112,38.05,0.46,408,68196,70,NULL,NULL,'2MASX J17183560+3805292',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,259.648417,38.09139,0.173,NULL,56130173636,877033963,13703655,17.6),(141113,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141113,37.62,0.19,334,68197,70,NULL,NULL,'2MASX J17183688+6440342',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000098,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,259.653833333,64.67619,0.101,NULL,57573398923,899584358,14056005,17.2),(141114,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141114,33.67,0.8,54.1,68198,75,NULL,'CF, r','NGC 6361',NULL,'1997ApJS..109..333W',1997,1,1.51,NULL,'G',0.000037,NULL,'13.6g',0.69,'SAb: sp        NLAGN',NULL,NULL,NULL,NULL,1,259.6712083,60.60817,0.093,NULL,57554869751,899294839,14051481,13.6),(141115,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141115,33.6,0.38,52.6,68198,75,NULL,'CF, r, raw','NGC 6361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141116,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141116,33.73,0.49,55.7,68198,75,NULL,'IR','NGC 6361',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141117,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141117,33.74,0.2,56,68198,74.4,NULL,NULL,'NGC 6361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141118,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141118,33.78,0.38,57.1,68198,75,NULL,'CF, r, inv','NGC 6361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141119,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141119,33.88,0.38,59.6,68198,75,NULL,'CF, r, cor','NGC 6361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141120,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141120,37.62,0.46,335,68199,70,NULL,NULL,'2MASX J17184135+6426482',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000091,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.672167,64.44697,0.089,NULL,57573497870,899585904,14056029,17.8),(141121,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141121,38.17,0.46,430,68200,70,NULL,NULL,'2MASX J17184219+5432555',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.675791667,54.54883,0.093,NULL,57466174975,897908983,14029827,17.3),(141122,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141122,36.43,0.46,193,68201,70,NULL,NULL,'2MASX J17184742+3055548',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.697625,30.93197,0.141,NULL,56370702923,880792233,13762378,17.1),(141123,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141123,36.99,0.33,250,68202,70,NULL,NULL,'2MASX J17184853+5749526',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00008,NULL,'17.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,259.702416667,57.83111,0.081,NULL,57686282499,901348164,14083565,17.2),(141124,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141124,34.36,0.49,74.3,68203,75,NULL,'IR','UGC 10798',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.67',0.2,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,259.712583333,19.52792,0.209,NULL,56826960428,887921256,13873769,15.67),(141125,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141125,38.08,0.33,414,68204,70,NULL,NULL,'2MASX J17185114+2703156',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000179,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,259.713167,27.05444,0.189,NULL,56319098288,879985910,13749779,17.5),(141126,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141126,31.37,0.4,18.8,68205,75,NULL,'B','UGC 10806',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.00001,NULL,'13.73',0.9,'SB(s)dm',NULL,NULL,NULL,NULL,1,259.714125,49.88419,0.069,NULL,57483769747,898183902,14034123,13.73),(141127,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141127,34.47,NULL,78.3,68206,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10817',NULL,'2010Ap&SS.325..163P',2010,1,1.05,NULL,'G',0.000124,NULL,'16.4g',0.17,'Sc(f)',NULL,NULL,NULL,NULL,1,259.7140417,61.22461,0.113,NULL,57566470520,899476101,14054314,16.4),(141128,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141128,34.49,NULL,79,68206,NULL,NULL,'Dipole + Quadrupole','UGC 10817',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141129,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141129,34.49,NULL,79,68206,NULL,NULL,'Dipole','UGC 10817',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141130,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141130,34.55,NULL,81.1,68206,NULL,NULL,NULL,'UGC 10817',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141131,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141131,37.57,0.27,326,68207,70,NULL,NULL,'2MASX J17185294+6426401',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000091,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,259.721083333,64.44458,0.089,NULL,57573506554,899586039,14056031,16.9),(141132,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141132,35.01,0.49,101,68208,75,NULL,'IR','UGC 10799',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',NULL,NULL,'16.00',0.13,'Scd',NULL,NULL,NULL,NULL,1,259.726917,29.85611,0.137,NULL,56367452947,880741452,13761585,16),(141133,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141133,35.27,NULL,113,68208,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141134,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141134,35.29,NULL,114,68208,NULL,NULL,'Dipole + Quadrupole','UGC 10799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141135,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141135,35.3,NULL,115,68208,NULL,NULL,'Dipole','UGC 10799',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141136,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141136,36.99,0.33,250,68209,70,NULL,NULL,'2MASX J17185529+5749136',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000072,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,259.730417,57.82053,0.081,NULL,57686240729,901347511,14083554,17.3),(141137,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141137,38.08,0.33,414,68210,70,NULL,NULL,'2MASX J17185653+2701067',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,259.735625,27.01858,0.189,NULL,56319093330,879985833,13749778,17.4),(141138,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141138,38.02,0.46,403,68211,70,NULL,NULL,'2MASX J17185879+2817121',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000166,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.744917,28.28667,0.129,NULL,56310057638,879844650,13747572,17.6),(141139,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141139,34.05,0.2,64.6,68212,74.4,NULL,NULL,'UGC 10801',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',NULL,NULL,'16.1g',0.6,'Sd',NULL,NULL,NULL,NULL,1,259.760083,32.26986,0.149,NULL,56355953064,880561766,13758777,16.1),(141140,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141140,35.66,0.61,136,68213,70,NULL,NULL,'2MASX J17190403-6322261',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5b',NULL,'SAB:(r)0/a',NULL,NULL,NULL,NULL,1,259.7667083,-63.374,0.425,NULL,44491370457,695177663,10862150,15.5),(141141,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141141,37.77,0.46,358,68214,70,NULL,NULL,'2MASX J17190591+5513036',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,259.774583,55.21756,0.113,NULL,57689360422,901396256,14084316,17.7),(141142,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141142,35.71,0.77,139,68215,70,NULL,NULL,'2MASX J17190821-1856194',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000183,NULL,'18.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,259.784166667,-18.93867,1.429,NULL,46023902687,719123479,11236304,18.3),(141143,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141143,36.4,0.46,191,68216,70,NULL,NULL,'2MASX J17190864+6327301',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000088,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,259.786,63.45814,0.105,NULL,57576795882,899637435,14056834,16.1),(141144,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141144,37.09,0.46,262,68217,70,NULL,NULL,'2MASX J17191037+2821292',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000171,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,259.793333,28.35808,0.137,NULL,56309996019,879843687,13747557,16.2),(141145,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141145,36.78,0.46,227,68218,70,NULL,NULL,'2MASX J17191456+5817245',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000081,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,259.810375,58.29008,0.089,NULL,57686109785,901345465,14083522,16.3),(141146,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141146,38.26,0.46,449,68219,70,NULL,NULL,'2MASX J17191540+2428372',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,259.814041667,24.47689,0.301,NULL,56272269091,879254204,13738346,17.7),(141147,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141147,38.85,0.46,589,68220,70,NULL,NULL,'2MASX J17191820+5959231',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000102,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.8257083,59.98975,0.097,NULL,57555186654,899299791,14051559,17.2),(141148,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141148,35.53,0.62,128,68221,70,NULL,NULL,'2MASX J17191995-0147135',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.833083,-1.78703,0.665,NULL,45335612318,708368942,11068264,15.9),(141149,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141149,36.07,0.64,163,68222,70,NULL,NULL,'2MASX J17193279-6651295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.88675,-66.85817,0.293,NULL,44970169453,702658897,10979045,14.4),(141150,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141150,37.42,0.46,305,68223,70,NULL,NULL,'2MASX J17193408+5842387',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00002,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,259.8920417,58.71078,0.081,NULL,57688306805,901379793,14084059,17.7),(141151,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141151,35.63,0.23,134,68224,70,NULL,NULL,'CGCG 277-035',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000097,NULL,'15.1g',0.49,'BrClG',NULL,NULL,NULL,NULL,1,259.895,56.63006,0.077,NULL,57691588575,901431071,14084860,15.1),(141152,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141152,38.1,0.46,417,68225,70,NULL,NULL,'2MASX J17193531+2655236',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,259.897208333,26.92322,0.189,NULL,56310792089,879856126,13747751,17.4),(141153,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141153,38.8,0.46,576,68226,70,NULL,NULL,'SDSS J171941.74+655525.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,259.9239583,65.92383,0.117,NULL,57520073480,898751148,14042986,18.4),(141154,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141154,38.52,0.46,505,68227,70,NULL,NULL,'2MASX J17194396+5627368',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,259.933125,56.46022,0.077,NULL,57691379598,901427806,14084809,18.2),(141155,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141155,37.55,0.33,323,68228,70,NULL,NULL,'2MASX J17194583+6611509',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.2g',0.17,'BrClG',NULL,NULL,NULL,NULL,1,259.94075,66.19753,0.121,NULL,57519086462,898735725,14042745,17.2),(141156,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141156,37.79,0.33,361,68229,70,NULL,NULL,'2MASX J17194747+6330461',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000111,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,259.948083,63.51283,0.097,NULL,57578894790,899670231,14057347,16.9),(141157,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','PTF10ndc',NULL,141157,37.84,0.02,341,68230,70,NULL,'SiFTO+SALT2, SN PTF10ndc','PTF10ndc',0.0817,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,259.959167,28.53264,0.149,NULL,56310007064,879843860,13747560,NULL),(141158,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','PTF10ndc',NULL,141158,37.69,0.13,345,68230,NULL,NULL,'H','PTF10ndc',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141159,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','PTF10ndc',NULL,141159,37.72,0.04,350,68230,72,NULL,'M(H) = -18.317 mag','PTF10ndc',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141160,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','PTF10ndc',NULL,141160,37.73,0.05,351,68230,NULL,NULL,'J','PTF10ndc',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141161,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141161,32.05,0.4,25.7,68231,75,NULL,'B','UGC 10805',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'15.3',1.5,'SBm','Isolated galaxy',NULL,NULL,NULL,1,259.9624583,14.40019,0.461,NULL,56822956526,887858695,13872792,15.3),(141162,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141162,33.88,0.69,59.7,68232,100,NULL,'mid-IR','NGC 6347',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000009,NULL,'14.47',0.7,'SBb','Isolated galaxy',NULL,NULL,NULL,1,259.977791667,16.66069,0.369,NULL,56818730257,887792660,13871760,14.47),(141163,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141163,34.71,0.47,87.4,68232,NULL,NULL,'H','NGC 6347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141164,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141164,34.76,0.46,89.6,68232,NULL,NULL,'J','NGC 6347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141165,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141165,34.76,0.4,89.7,68232,NULL,NULL,'mean','NGC 6347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141166,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141166,34.81,0.45,91.5,68232,NULL,NULL,'K','NGC 6347',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141167,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141167,37.55,0.33,323,68233,70,NULL,NULL,'2MASX J17195792+6614058',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000105,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,259.9915,66.23494,0.121,NULL,57519085270,898735707,14042745,17.5),(141168,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141168,35.43,0.49,122,68234,70,NULL,NULL,'2MASX J17195854-0135185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,259.993917,-1.58844,0.661,NULL,45335498297,708367160,11068236,14.6),(141169,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141169,33.78,0.8,57.1,68235,75,NULL,'MAT, I','ESO 138- G 021',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.02',1,'S...',NULL,NULL,NULL,NULL,1,260.0345417,-60.157,0.405,NULL,44448072527,694501133,10851580,14.02),(141170,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141170,34.09,0.32,65.7,68235,85,NULL,'I, raw','ESO 138- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141171,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141171,34.14,0.32,67.4,68235,85,NULL,'I, inv','ESO 138- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141172,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141172,34.15,0.43,67.5,68235,75,NULL,'MAT, I, raw','ESO 138- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141173,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141173,34.32,0.43,73.1,68235,75,NULL,'MAT, I, cor','ESO 138- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141174,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141174,34.4,0.43,75.8,68235,75,NULL,'MAT, I, inv','ESO 138- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141175,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141175,37.58,0.46,327,68236,70,NULL,NULL,'SDSS J172009.17+301758.1',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.3g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,260.03825,30.2995,0.133,NULL,56368284013,880754437,13761788,17.3),(141176,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141176,38.54,1.45,510,68237,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2259',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'Compact [Zw]',NULL,NULL,NULL,NULL,1,260.037083,27.67028,0.169,NULL,56311400690,879865635,13747900,NULL),(141177,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141177,38.58,1.65,520,68237,NULL,NULL,'Isotherm.','ABELL 2259',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141178,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141178,38.82,1,580,68237,NULL,NULL,'Hydrost. Eq.','ABELL 2259',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141179,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141179,38.99,NULL,629,68237,NULL,NULL,'3.1 (red) calibration','ABELL 2259',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141180,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141180,39.01,NULL,634,68237,NULL,NULL,'4.2 (black) calibration','ABELL 2259',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141181,'SZ effect','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141181,39.22,NULL,698,68237,NULL,NULL,'4.1 (blue) calibration','ABELL 2259',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141182,'CMD','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141182,19.4,0.3,0.076,68238,NULL,NULL,'PHOTOELECTRIC','Draco Dwarf',NULL,'1979AJ.....84.1149S',1979,1,35.5,NULL,'G',0.00007,NULL,'10.9',24.5,'E pec','Isolated galaxy',NULL,NULL,NULL,1,260.051625,57.91536,0.081,1,57685743242,901339738,14083433,10.9),(141183,'CMD','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141183,19.49,0.11,0.0791,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141184,'CMD','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141184,19.54,NULL,0.0809,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141185,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141185,19.28,0.09,0.072,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'1995MNRAS.277.1354I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141186,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141186,19.38,NULL,0.075,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'1985IAUS..113..541W',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141187,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141187,19.48,NULL,0.0787,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'1998AJ....115..144G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141188,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141188,19.5,0.2,0.0807,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2001AJ....122.2524A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141189,'Horizontal Branch','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141189,19.6,0.18,0.0832,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141190,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141190,19.4,0.02,0.076,68238,NULL,NULL,'94','Draco Dwarf',NULL,'2004AJ....127..861B',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141191,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141191,19.51,NULL,0.0798,68238,NULL,NULL,'Z, Fe/H = -1.74','Draco Dwarf',NULL,'2008AJ....136.1921K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141192,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141192,19.55,NULL,0.0812,68238,NULL,NULL,'Z, Fe/H = -2.00','Draco Dwarf',NULL,'2008AJ....136.1921K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141193,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141193,19.58,0.15,0.0824,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2008AJ....136.1921K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141194,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141194,19.59,NULL,0.0828,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141195,'RR Lyrae','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141195,19.62,0.29,0.084,68238,NULL,NULL,'Photographic, 10, RRd','Draco Dwarf',NULL,'1985AJ.....90..204N',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141196,'TRGB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141196,19.49,0.06,0.0791,68238,NULL,NULL,'Syst. +/- 0.15 mag','Draco Dwarf',NULL,'2005A&A...442..165C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141197,'TRGB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141197,19.5,NULL,0.08,68238,NULL,NULL,NULL,'Draco Dwarf',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141198,'TRGB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141198,19.49,0.14,0.08,68238,74.4,NULL,NULL,'Draco Dwarf',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141199,'TRGB','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141199,19.84,0.14,0.093,68238,NULL,NULL,'I','Draco Dwarf',NULL,'2002AJ....124.3222B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141200,'Tully est','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141200,20,0.8,0.1,68238,75,NULL,'B','Draco Dwarf',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141201,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141201,37.93,0.46,386,68239,70,NULL,NULL,'SDSS J172013.83+644541.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000066,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.057625,64.76158,0.101,NULL,57573411967,899584561,14056008,18.1),(141202,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141202,38.44,0.46,487,68240,70,NULL,NULL,'SDSS J172014.59+645007.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.0607917,64.83539,0.101,NULL,57518093679,898720213,14042503,17.8),(141203,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141203,37.35,0.46,295,68241,70,NULL,NULL,'2MASX J17201519+2806347',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.063333,28.10958,0.149,NULL,56311723510,879870679,13747979,17.2),(141204,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141204,37.43,0.46,306,68242,70,NULL,NULL,'2MASX J17201528+6544335',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00009,NULL,'16.4g',0.36,NULL,NULL,NULL,NULL,NULL,1,260.063833,65.74275,0.113,NULL,57520638165,898759971,14043124,16.4),(141205,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141205,37.44,0.46,307,68243,70,NULL,NULL,'SDSS J172017.71+540556.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000058,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,260.073791667,54.09892,0.117,NULL,57495731819,898370809,14037043,18.4),(141206,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141206,37.67,0.46,342,68244,70,NULL,NULL,'2MASX J17201993+3010329',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000169,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.083166667,30.17594,0.133,NULL,56368291928,880754561,13761790,17.9),(141207,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN CLO12Car','N',141207,43.71,0.16,2420,68245,71.6,NULL,'MLCS2k2','SN CLO12Car',1.28,'2014ApJ...786....9P',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141208,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN CLO12Car','N',141208,43.83,0.24,2560,68245,71.6,NULL,'SALT 2','SN CLO12Car',1.28,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141209,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN CLO12Car','N',141209,44.74,0.24,3890,68245,71.6,NULL,'SALT 2 + G Lens mag = 0.91 mag','SN CLO12Car',1.28,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141210,'SNIa','2016-12-15 15:15:45','2016-12-16 11:21:00','1','SN CLO12Car','N',141210,44.77,0.16,3950,68245,71.6,NULL,'MLCS2k2 + G Lens = 1.06 mag','SN CLO12Car',1.28,'2014ApJ...786....9P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141211,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141211,35.21,0.56,110,68246,70,NULL,NULL,'2MASX J17202900-0038301',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,260.120791667,-0.64175,0.565,NULL,45114593144,704915517,11014304,14),(141212,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141212,36.57,0.84,206,68247,70,NULL,NULL,'2MASX J17202942-0126011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.122625,-1.43369,0.609,NULL,45335446505,708366351,11068224,16.1),(141213,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141213,37.59,0.46,330,68248,70,NULL,NULL,'2MASX J17203033+3404161',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,260.126417,34.07117,0.125,NULL,56350462560,880475977,13757437,NULL),(141214,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141214,36.8,0.57,229,68249,70,NULL,NULL,'2MASX J17203147-8018443',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,260.131083333,-80.31231,0.325,NULL,44041796036,688153063,10752391,16.7),(141215,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141215,36.5,0.46,199,68250,70,NULL,NULL,'2MASX J17203205+2806028',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000173,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.133458333,28.10083,0.149,NULL,56311897060,879873391,13748021,16.6),(141216,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141216,34.75,0.7,88.9,68251,70,NULL,NULL,'2MFGC 13812',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.1487917,-1.67561,0.685,NULL,45334423450,708350366,11067974,14.7),(141217,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141217,36.78,0.33,227,68252,70,NULL,NULL,'2MASX J17204393+2842295',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000178,NULL,'16.7g',0.28,'AGN',NULL,NULL,NULL,NULL,1,260.183125,28.70819,0.149,NULL,56310586956,879852921,13747701,16.7),(141218,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141218,37.79,0.33,361,68253,70,NULL,NULL,'SDSS J172045.56+632812.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,260.189875,63.47008,0.097,NULL,57578889383,899670146,14057346,17.8),(141219,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141219,38.45,0.46,489,68254,70,NULL,NULL,'2MASX J17204639+2735305',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00016,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,260.19325,27.59178,0.169,NULL,56311329925,879864530,13747883,17.9),(141220,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141220,36.12,0.68,167,68255,70,NULL,NULL,'2MASX J17204757-0154203',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,260.198166667,-1.90569,0.729,NULL,45334511312,708351739,11067995,14.5),(141221,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141221,37.87,0.27,375,68256,70,NULL,NULL,'2MASX J17205280+2721186',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000172,NULL,'16.8g',0.27,'AGN',NULL,NULL,NULL,NULL,1,260.220041667,27.35528,0.169,NULL,56311651697,879869557,13747961,16.8),(141222,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141222,37.87,0.27,375,68257,70,NULL,NULL,'2MASX J17205408+2722336',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.225417,27.37608,0.169,NULL,56311650958,879869546,13747961,17.4),(141223,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141223,37.87,0.27,375,68258,70,NULL,NULL,'2MASX J17205543+2720016',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000151,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.230875,27.33383,0.169,NULL,56311648693,879869510,13747961,17.8),(141224,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141224,36.96,0.46,247,68259,70,NULL,NULL,'2MASX J17205696+5512282',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000114,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,260.237333,55.20778,0.109,NULL,57689499011,901398422,14084350,16),(141225,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141225,35.65,NULL,135,68260,NULL,NULL,'Dipole','UGC 10820',NULL,'2010Ap&SS.325..163P',2010,1,1.79,NULL,'G',0.000123,NULL,'16.5',0.24,'Sbc',NULL,NULL,NULL,NULL,1,260.23925,42.15556,0.061,NULL,59651164938,932049452,14563272,16.5),(141226,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141226,35.66,NULL,135,68260,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141227,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141227,35.66,NULL,135,68260,NULL,NULL,'Dipole + Quadrupole','UGC 10820',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141228,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141228,35.87,0.49,149,68260,75,NULL,'IR','UGC 10820',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141229,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141229,35.99,0.58,158,68261,70,NULL,NULL,'2MASX J17205855-6512030',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.244,-65.20092,0.285,NULL,44438024976,694344140,10849127,14.4),(141230,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141230,36.78,0.33,227,68262,70,NULL,NULL,'2MASX J17210438+2842266',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000185,NULL,'16.1g',0.35,'E0',NULL,NULL,NULL,NULL,1,260.268083,28.70728,0.129,NULL,56310415452,879850241,13747660,16.1),(141231,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141231,37.34,0.33,294,68263,70,NULL,NULL,'2MASX J17210555+6130058',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000076,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,260.273208333,61.50175,0.105,NULL,57566628900,899478576,14054352,16.1),(141232,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141232,37.93,0.46,386,68264,70,NULL,NULL,'2MASX J17210726+2734508',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000178,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.2802083,27.58089,0.169,NULL,56311330926,879864545,13747883,17.6),(141233,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141233,37.31,0.46,290,68265,70,NULL,NULL,'2MASX J17210788+6555308',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000087,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,260.282625,65.92522,0.113,NULL,57520040879,898750638,14042978,16.8),(141234,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141234,37.95,0.46,389,68266,70,NULL,NULL,'2MASX J17211342+5315327',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,260.306,53.25908,0.117,NULL,57499223400,898425365,14037896,17.8),(141235,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141235,35.69,0.61,137,68267,70,NULL,NULL,'2MASX J17211410-0101219',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000143,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,260.308875,-1.02275,0.609,NULL,45117784564,704965383,11015084,14.1),(141236,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141236,36.03,0.51,161,68268,70,NULL,NULL,'2MASX J17211811-6322441',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,260.325375,-63.37894,0.393,NULL,44492419923,695194061,10862407,16),(141237,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141237,37.35,0.46,295,68269,70,NULL,NULL,'2MASX J17213008+5943255',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00001,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,260.3755,59.72378,0.057,NULL,57554727886,899292623,14051447,17.1),(141238,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141238,38.45,0.33,490,68270,70,NULL,NULL,'2MASX J17213019+3320160',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.375625,33.33769,0.165,NULL,56348885118,880451329,13757052,17.7),(141239,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141239,36.35,0.59,186,68271,70,NULL,NULL,'2MASX J17213314-6604383',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.3879583,-66.07725,0.237,NULL,44436222022,694315969,10848687,15.2),(141240,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141240,37.89,0.46,378,68272,70,NULL,NULL,'2MASX J17213421+2756178',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.392667,27.93825,0.149,NULL,56311806668,879871979,13747999,17.5),(141241,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141241,37.34,0.33,294,68273,70,NULL,NULL,'2MASX J17213419+6131119',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000068,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,260.392833,61.52,0.089,NULL,57565905592,899467274,14054176,17.9),(141242,'IRAS','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141242,33.74,0.8,56,68274,75,NULL,'MAT, I','ESO 102- G 002',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.000022,NULL,'14.06',1.3,'SA(s)c',NULL,NULL,NULL,NULL,1,260.41225,-65.17428,0.289,NULL,44438023547,694344117,10849126,14.06),(141243,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141243,33.29,0.32,45.4,68274,85,NULL,'I, raw','ESO 102- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141244,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141244,33.29,0.32,45.6,68274,85,NULL,'I, inv','ESO 102- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141245,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141245,33.78,0.43,56.9,68274,75,NULL,'MAT, I, raw','ESO 102- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141246,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141246,33.91,0.43,60.5,68274,75,NULL,'MAT, I, inv','ESO 102- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141247,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141247,34.02,0.43,63.6,68274,75,NULL,'MAT, I, cor','ESO 102- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141248,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141248,38.45,0.33,490,68275,70,NULL,NULL,'2MASX J17214022+3320575',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.417791667,33.34942,0.165,NULL,56348688535,880448258,13757004,17.8),(141249,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141249,37.18,0.46,274,68276,70,NULL,NULL,'2MASX J17214208+5411014',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.0001,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,260.425625,54.18383,0.117,NULL,57495713316,898370520,14037039,16.8),(141250,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141250,30.04,0.43,10.2,68277,75,NULL,'3.6 micron, color + selection bias corrected','IC 4660',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000013,NULL,'14.50',0.3,'S','in a pair',NULL,NULL,NULL,1,260.43825,75.8485,0.157,NULL,57072866126,891763533,13933805,14.5),(141251,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141251,30.63,0.4,13.4,68277,75,NULL,NULL,'IC 4660',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141252,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141252,31.29,0.49,18.1,68277,75,NULL,'IR','IC 4660',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141253,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141253,38.7,0.46,549,68278,70,NULL,NULL,'2MASX J17215104+2741207',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,260.462833333,27.689,0.157,NULL,56311421754,879865964,13747905,18.3),(141254,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141254,37.77,0.46,357,68279,70,NULL,NULL,'2MASX J17215144+2715527',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000183,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.4645,27.26469,0.169,NULL,56311598430,879868725,13747948,17.1),(141255,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141255,37.55,0.46,323,68280,70,NULL,NULL,'SDSS J172152.83+581834.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000059,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,260.470125,58.30961,0.089,NULL,57687568919,901368264,14083879,18.3),(141256,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141256,38.12,0.46,420,68281,70,NULL,NULL,'2MASX J17215341+2652587',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000171,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,260.472583333,26.88292,0.181,NULL,56280409654,879381400,13740334,17.7),(141257,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141257,36.12,0.46,168,68282,70,NULL,NULL,'2MASX J17215688+5913573',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00001,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,260.487125,59.23258,0.057,NULL,57687688896,901370139,14083908,17.4),(141258,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141258,37.47,0.46,313,68283,70,NULL,NULL,'2MASX J17215893+5442423',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000118,NULL,'17.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,260.49575,54.71172,0.081,NULL,57466350278,897911723,14029870,17.5),(141259,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141259,35.37,0.56,118,68284,70,NULL,NULL,'2MASX J17215901-0050484',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.495833,-0.84681,0.565,NULL,45117907237,704967300,11015114,14.8),(141260,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141260,37.89,0.33,378,68285,70,NULL,NULL,'2MASX J17220388+5257288',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,260.516125,52.958,0.081,NULL,57499288159,898426377,14037912,16.7),(141261,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141261,37.96,0.46,391,68286,70,NULL,NULL,'2MASX J17220750+2723037',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.531208333,27.3845,0.165,NULL,56311630028,879869219,13747956,17.2),(141262,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141262,37.72,0.46,351,68287,70,NULL,NULL,'2MASX J17221103+2727387',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000141,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.5457917,27.46075,0.165,NULL,56311450520,879866414,13747912,17.5),(141263,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141263,37.88,0.46,376,68288,70,NULL,NULL,'2MASX J17221123+3310440',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.546875,33.17897,0.165,NULL,56356273126,880566767,13758855,17.2),(141264,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141264,37.89,0.33,378,68289,70,NULL,NULL,'2MASX J17221250+5305189',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.5522083,53.08872,0.097,NULL,57499436608,898428697,14037948,17.6),(141265,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141265,37.56,0.46,326,68290,70,NULL,NULL,'2MASX J17221483+5945374',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000069,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.561625,59.76031,0.057,NULL,57554748644,899292947,14051452,17.8),(141266,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141266,35.71,0.4,139,68291,NULL,NULL,'mean','UGC 10824',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000057,NULL,'15.1',0.4,'Sbc pec:',NULL,NULL,NULL,NULL,1,260.582083,2.01842,0.457,NULL,56054380500,875849695,13685151,15.1),(141267,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,NULL,141267,35.89,0.47,150,68291,NULL,NULL,'H','UGC 10824',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141268,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141268,38.14,0.46,424,68292,70,NULL,NULL,'SDSS J172221.73+542045.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000084,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,260.590625,54.34603,0.089,NULL,57466287594,897910743,14029855,18.7),(141269,'FP','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141269,37.09,0.46,262,68293,70,NULL,NULL,'2MASX J17222265+5326479',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000084,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,260.594417,53.44667,0.117,NULL,57495911739,898373620,14037087,17.1),(141270,'Tully-Fisher','2016-12-15 15:15:45','2016-12-16 11:21:00','1',NULL,'R',141270,36.02,0.49,160,68294,75,NULL,'IR','UGC 10824 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.55,'The 2MASX position is for the southeastern part of the galaxy.','G',NULL,NULL,'16',0.15,'Sb? pec sp',NULL,NULL,NULL,NULL,1,260.597958333,2.00672,0.457,NULL,56054382579,875849727,13685151,16),(141271,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141271,38.23,0.46,443,68295,70,NULL,NULL,'2MASX J17222486+2800277',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000164,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,260.6035,28.00781,0.149,NULL,56312648389,879885131,13748205,18.3),(141272,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141272,35.69,0.46,137,68296,70,NULL,NULL,'2MASX J17222789+5709503',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000069,NULL,'15.8g',0.35,'E0',NULL,NULL,NULL,NULL,1,260.616333,57.16406,0.061,NULL,57693592151,901462377,14085349,15.8),(141273,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141273,39.32,0.55,730,68297,NULL,NULL,'Hydrost. Eq.','ABELL 2261',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,260.612917,32.13389,0.129,NULL,56356193893,880565529,13758836,NULL),(141274,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141274,39.35,NULL,740,68297,NULL,NULL,NULL,'ABELL 2261',NULL,'2011A&A...532A..14C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141275,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141275,39.42,NULL,765,68297,NULL,NULL,'3.1 (red) calibration','ABELL 2261',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141276,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141276,39.61,NULL,835,68297,NULL,NULL,'4.2 (black) calibration','ABELL 2261',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141277,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141277,39.86,NULL,938,68297,NULL,NULL,'4.1 (blue) calibration','ABELL 2261',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141278,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141278,39.89,0.63,950,68297,NULL,NULL,'Isotherm., r < 100 kpc','ABELL 2261',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141279,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141279,39.98,0.51,990,68297,NULL,NULL,'Isotherm.','ABELL 2261',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141280,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141280,40.11,NULL,1050,68297,NULL,NULL,NULL,'ABELL 2261',NULL,'2002ApJ...581...53R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141281,'SZ effect','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141281,40.24,NULL,1120,68297,NULL,NULL,NULL,'ABELL 2261',NULL,'2005ApJ...625..108D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141282,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141282,37.66,0.46,341,68298,70,NULL,NULL,'2MASX J17223222+2916377',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,260.634375,29.27714,0.129,NULL,56365553262,880711769,13761121,17.4),(141283,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141283,37.17,0.33,271,68299,70,NULL,NULL,'2MASX J17223896+5836212',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,260.66225,58.60572,0.085,NULL,57688374231,901380847,14084075,17.2),(141284,'Ring Diameter','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141284,34.5,0.84,79,68300,NULL,NULL,'Published at H = 100 km/s/Mpc','MRK 0506',NULL,'1981ApJS...45..541P',1981,1,0.8,NULL,'G',0.00004,NULL,'15.12',0.5,'SAB(r)a        Sy1.5','Pair member (points to parent)',NULL,NULL,'Sy 1.5',1,260.66625,30.88139,0.145,NULL,56371095400,880798365,13762474,15.12),(141285,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141285,36.31,0.45,183,68300,NULL,NULL,'K','MRK 0506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141286,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141286,36.31,0.4,183,68300,NULL,NULL,'mean','MRK 0506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141287,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141287,36.33,0.47,184,68300,NULL,NULL,'H','MRK 0506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141288,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141288,31.87,0.2,23.1,68301,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6365A',0.028341,'2011A&A...526A..81B',2011,1,1.17,'NED does NOT follow RC3 in assigning lower velocity to UGC 10832.','G',0.00009,NULL,'14.7g',0.83,'Sc-IRR         AGN','Pair member (points to parent)',NULL,NULL,'Sy 1',1,260.682541667,62.16608,0.093,NULL,57577886948,899654483,14057101,14.7),(141289,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141289,34.63,0.19,82,68301,74.2,NULL,'SALT 2','NGC 6365A',0.028341,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141290,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141290,35.27,0.04,110,68301,72,NULL,'MLCS17','NGC 6365A',0.028341,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141291,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141291,35.23,0.09,111,68301,74.4,NULL,NULL,'NGC 6365A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141292,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141292,35.36,0.18,115,68301,70,NULL,'SALT 2','NGC 6365A',0.028341,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141293,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U','R',141293,35.34,0.1,117,68301,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 6365A',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141294,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141294,35.4,0.17,117,68301,73.8,NULL,'SALT 2 (SNANA)','NGC 6365A',0.0282,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141295,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U','R',141295,35.37,0.1,119,68301,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 6365A',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141296,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141296,35.46,0.16,120,68301,65,NULL,'MLCS17','NGC 6365A',0.028341,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141297,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141297,35.46,0.17,121,68301,65,NULL,'SALT','NGC 6365A',0.028341,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141298,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141298,35.53,0.16,124,68301,65,NULL,'MLCS31','NGC 6365A',0.028341,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141299,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141299,35.55,0.22,125,68301,65,NULL,'SALT2','NGC 6365A',0.028341,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141300,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2003U',NULL,141300,36.03,0.04,156,68301,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6365A',0.028341,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141301,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141301,38.06,0.46,409,68302,70,NULL,NULL,'2MASX J17224513+5345029',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00009,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,260.6880417,53.75092,0.101,NULL,57496546929,898383545,14037242,17.5),(141302,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141302,38.29,0.46,454,68303,70,NULL,NULL,'2MASX J17224628+2708458',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,260.692791667,27.14619,0.169,NULL,56311025653,879859775,13747808,18.1),(141303,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141303,36.83,0.46,233,68304,70,NULL,NULL,'2MASX J17224850+5323090',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000087,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,260.701917,53.38569,0.117,NULL,57495855269,898372738,14037074,16.9),(141304,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141304,38.69,0.46,546,68305,70,NULL,NULL,'2MASX J17225153+2828439',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,260.7147083,28.47878,0.125,NULL,56312583003,879884109,13748189,18.1),(141305,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141305,37.91,0.33,383,68306,70,NULL,NULL,'2MASX J17225244+6458230',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000072,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,260.71875,64.97303,0.113,NULL,57518236014,898722437,14042538,17.3),(141306,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141306,37.91,0.33,383,68307,70,NULL,NULL,'2MASX J17225552+6454310',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000104,NULL,'17.6g',0.2,'NLAGN',NULL,NULL,NULL,NULL,1,260.731667,64.9085,0.101,NULL,57518273064,898723016,14042547,17.6),(141307,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141307,35.01,0.46,101,68308,70,NULL,NULL,'2MASX J17225921+6033331',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000078,NULL,'15.6g',0.32,'E0',NULL,NULL,NULL,NULL,1,260.7467083,60.55931,0.081,NULL,57557673502,899338648,14052166,15.6),(141308,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141308,37.62,0.46,334,68309,70,NULL,NULL,'2MASX J17230039+3320418',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,260.7515417,33.34497,0.145,NULL,56356254460,880566475,13758851,NULL),(141309,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141309,37.57,0.46,326,68310,70,NULL,NULL,'2MASX J17230145+5936051',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000075,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,260.756167,59.6015,0.081,NULL,57554564460,899290069,14051407,17.4),(141310,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141310,37.94,0.33,387,68311,70,NULL,NULL,'2MASX J17230255+2654269',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,260.76075,26.9075,0.181,NULL,56281130127,879392658,13740510,17.4),(141311,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141311,34.76,0.54,89.4,68312,70,NULL,NULL,'2MASX J17230438-0125530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.7682917,-1.43147,0.645,NULL,45115652250,704932066,11014563,14.9),(141312,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141312,34.83,0.69,92.3,68313,100,NULL,'mid-IR','IC 1255',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000008,NULL,'14.2',0.5,'Sb','Field galaxy',NULL,NULL,NULL,1,260.7724583,12.69544,0.561,NULL,55921844833,873778825,13652794,14.2),(141313,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141313,35.03,0.34,101,68313,NULL,NULL,'Malmquist cor.','IC 1255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141314,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141314,35.24,0.47,112,68313,NULL,NULL,'H','IC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141315,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141315,35.27,0.45,113,68313,NULL,NULL,'K','IC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141316,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141316,35.32,0.46,116,68313,NULL,NULL,'J','IC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141317,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141317,35.39,0.29,120,68313,NULL,NULL,NULL,'IC 1255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141318,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141318,35.44,0.4,122,68313,NULL,NULL,'mean','IC 1255',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141319,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141319,35.65,0.2,135,68313,74.4,NULL,NULL,'IC 1255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141320,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141320,37.81,0.46,365,68314,70,NULL,NULL,'2MASX J17230982+5345030',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000093,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,260.791083333,53.75081,0.101,NULL,57496323135,898380048,14037188,17.6),(141321,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141321,35.08,0.48,104,68315,70,NULL,NULL,'2MASX J17230987-6153190',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'15.8b',0.5,NULL,NULL,NULL,NULL,NULL,1,260.792625,-61.88856,0.357,NULL,44479258798,694988418,10859194,15.8),(141322,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141322,36.66,0.46,215,68316,70,NULL,NULL,'2MASX J17231100+5644492',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000086,NULL,'16.0g',0.42,NULL,NULL,NULL,NULL,NULL,1,260.796,56.74694,0.065,NULL,57691179603,901424681,14084760,16),(141323,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141323,37.14,0.46,268,68317,70,NULL,NULL,'SDSS J172313.89+272407.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,260.807875,27.40208,0.165,NULL,56311063159,879860361,13747818,18.6),(141324,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141324,38.24,0.46,444,68318,70,NULL,NULL,'2MASX J17231654+6121143',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000094,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,260.8190417,61.35375,0.081,NULL,57564385596,899443524,14053805,16.9),(141325,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141325,36.35,0.6,186,68319,70,NULL,NULL,'2MASX J17232478-1448439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,260.853291667,-14.81214,1.725,NULL,46000167296,718752614,11230509,16.1),(141326,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141326,37.94,0.33,387,68320,70,NULL,NULL,'2MASX J17233099+2656505',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,260.879333333,26.94731,0.169,NULL,56281122540,879392539,13740508,17.2),(141327,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141327,37.64,0.46,338,68321,70,NULL,NULL,'2MASX J17233453+3759354',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,260.894,37.99311,0.149,NULL,56131020068,877047188,13703862,17.2),(141328,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141328,37.86,0.46,374,68322,70,NULL,NULL,'2MASX J17233586+2718525',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000154,NULL,'17.6g',NULL,NULL,NULL,NULL,NULL,NULL,1,260.899333,27.31461,0.165,NULL,56311049384,879860146,13747814,17.6),(141329,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141329,36.97,0.46,248,68323,70,NULL,NULL,'2MASX J17233647+2722295',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,260.901917,27.37475,0.165,NULL,56311053570,879860212,13747815,16.8),(141330,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141330,37.49,0.46,315,68324,70,NULL,NULL,'2MASX J17233699+6255253',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,260.90425,62.92367,0.061,NULL,57579387468,899677929,14057467,16.8),(141331,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2009jb',NULL,141331,35.13,0.02,104,68325,70,NULL,'SiFTO+SALT2, SN PTF09dnl, SN 2009jb','CRTS J172341.69+302950.9',0.019,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'G',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,260.923708333,30.49747,0.113,NULL,56367568863,880743263,13761613,NULL),(141332,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2009jb',NULL,141332,35.2,0.02,108,68325,70,NULL,'SN 2009jb, SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','CRTS J172341.69+302950.9',0.019,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141333,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141333,38.02,0.46,401,68326,70,NULL,NULL,'2MASXi J1723440+335346',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.17,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,260.9335,33.89639,0.137,NULL,56347031336,880422364,13756599,17.5),(141334,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141334,33.38,0.69,47.4,68327,100,NULL,'mid-IR','IC 1256',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000033,NULL,'14.00',1.1,'Sb','Isolated galaxy',NULL,NULL,NULL,1,260.947125,26.48653,0.225,NULL,56280667948,879385436,13740397,14),(141335,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141335,34.24,0.2,70.5,68327,74.4,NULL,NULL,'IC 1256',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141336,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141336,34.3,0.4,72.4,68327,NULL,NULL,'mean','IC 1256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141337,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141337,34.7,0.47,87.1,68327,NULL,NULL,'H','IC 1256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141338,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141338,34.78,0.46,90.5,68327,NULL,NULL,'J','IC 1256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141339,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141339,34.78,0.45,90.5,68327,NULL,NULL,'K','IC 1256',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141340,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141340,32.83,0.8,36.8,68328,75,NULL,'MAT, I','IC 4646',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000017,NULL,'12.65',2,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,260.971625,-59.99939,0.393,NULL,44450527011,694539484,10852179,12.65),(141341,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141341,32.05,0.43,25.7,68328,75,NULL,'MAT, I, raw','IC 4646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141342,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141342,32.09,0.32,26.2,68328,85,NULL,'I, raw','IC 4646',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141343,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141343,32.13,0.32,26.7,68328,85,NULL,'I, inv','IC 4646',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141344,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141344,32.23,0.43,27.9,68328,75,NULL,'MAT, I, inv','IC 4646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141345,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141345,32.45,0.43,30.9,68328,75,NULL,'MAT, I, cor','IC 4646',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141346,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141346,32.79,0.47,36.2,68328,NULL,NULL,'H','IC 4646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141347,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141347,32.81,0.46,36.5,68328,NULL,NULL,'J','IC 4646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141348,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141348,32.82,0.45,36.6,68328,NULL,NULL,'K','IC 4646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141349,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141349,33.2,0.4,43.7,68328,NULL,NULL,'mean','IC 4646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141350,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141350,37.8,0.46,364,68329,70,NULL,NULL,'2MASX J17235397+2840585',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000188,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,260.974875,28.68289,0.173,NULL,56312451736,879882058,13748157,16.6),(141351,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141351,37.17,0.33,271,68330,70,NULL,NULL,'2MASX J17235579+5823446',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000073,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,260.9827917,58.39569,0.085,NULL,57687642756,901369418,14083897,17.1),(141352,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141352,37.44,0.46,308,68331,70,NULL,NULL,'2MASX J17235676+5541186',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000067,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,260.986708333,55.68847,0.097,NULL,57692421268,901444082,14085063,17.5),(141353,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141353,34.82,0.4,92.2,68332,NULL,NULL,'mean','CGCG 140-018',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000103,NULL,'15.6',0.23,'Sb','Isolated galaxy',NULL,NULL,NULL,1,260.9995,21.13706,0.281,NULL,56801437951,887522467,13867538,15.6),(141354,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141354,35.08,0.47,104,68332,NULL,NULL,'H','CGCG 140-018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141355,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141355,35.09,0.45,104,68332,NULL,NULL,'K','CGCG 140-018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141356,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141356,38.83,0.46,584,68333,70,NULL,NULL,'2MASX J17240393+2703125',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,261.016375,27.0535,0.169,NULL,56281106148,879392283,13740504,17.6),(141357,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141357,34.34,0.56,73.9,68334,70,NULL,NULL,'2MASX J17240569-0304214',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.023833,-3.07264,0.905,NULL,45346625888,708541029,11070953,14.6),(141358,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141358,32.57,0.8,32.7,68335,75,NULL,'MAT, I','ESO 138- G 024',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000026,NULL,'13.83',0.6,'SB(s)c:',NULL,NULL,NULL,NULL,1,261.027333333,-59.38217,0.441,NULL,44522012812,695656450,10869632,13.83),(141359,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141359,31.53,0.39,20.2,68335,73,NULL,'IR','ESO 138- G 024',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141360,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141360,31.53,0.4,20.2,68335,75,NULL,NULL,'ESO 138- G 024',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141361,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141361,31.65,0.32,21.4,68335,85,NULL,'I, inv','ESO 138- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141362,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141362,31.66,0.32,21.5,68335,85,NULL,'I, raw','ESO 138- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141363,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141363,31.95,0.43,24.6,68335,75,NULL,'MAT, I, raw','ESO 138- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141364,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141364,31.96,0.4,24.7,68335,NULL,NULL,NULL,'ESO 138- G 024',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141365,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141365,32,0.43,25.1,68335,75,NULL,'MAT, I, inv','ESO 138- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141366,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141366,32.36,0.43,29.6,68335,75,NULL,'MAT, I, cor','ESO 138- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141367,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141367,32.4,0.49,30.2,68335,75,NULL,'IR','ESO 138- G 024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141368,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141368,33.06,0.4,40.9,68335,NULL,NULL,'mean','ESO 138- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141369,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141369,33.11,0.47,41.8,68335,NULL,NULL,'H','ESO 138- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141370,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141370,33.28,0.45,45.3,68335,NULL,NULL,'K','ESO 138- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141371,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141371,33.3,0.46,45.8,68335,NULL,NULL,'J','ESO 138- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141372,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141372,35.02,0.46,101,68336,70,NULL,NULL,'CGCG 277-041 NED01',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.000083,NULL,'14.8g',0.59,'E0',NULL,NULL,NULL,NULL,1,261.0364583,53.467,0.109,NULL,57496177991,898377781,14037152,14.8),(141373,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141373,36.61,0.99,210,68337,70,NULL,NULL,'2MASX J17241523-8026055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,261.064,-80.43483,0.325,NULL,44041980341,688155942,10752436,17.1),(141374,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141374,36.53,0.65,202,68338,70,NULL,NULL,'2MASX J17241877-7149426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,261.078375,-71.82858,0.361,NULL,44103760879,689121263,10767519,16.4),(141375,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141375,37.17,0.46,271,68339,70,NULL,NULL,'2MASX J17242162+2728413',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000174,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,261.0902083,27.47819,0.161,NULL,56310926432,879858225,13747784,16.5),(141376,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141376,38.09,0.23,415,68340,70,NULL,NULL,'2MASX J17242240+6421503',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000088,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,261.093167,64.36411,0.085,NULL,57574088568,899595133,14056173,18.1),(141377,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141377,38,0.46,399,68341,70,NULL,NULL,'SDSS J172424.32+314919.6',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,261.101375,31.82211,0.133,NULL,56368589413,880759209,13761862,17.3),(141378,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141378,35.67,0.49,136,68342,75,NULL,'IR','UGC 10831',NULL,'2011yCatp016004901K',2011,1,1.1,'RC3 gives a HI-line velocity of 8149 km/sec. Stars superposed.','G',0.000037,NULL,'14.60',1,'Sd','Pair member (points to parent)',NULL,NULL,NULL,1,261.118125,24.97172,0.337,NULL,56286932849,879483325,13741926,14.6),(141379,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141379,38.04,0.46,405,68343,70,NULL,NULL,'2MASXi J1724302+631129',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,261.1260417,63.19136,0.085,NULL,57579073415,899673022,14057390,17.9),(141380,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141380,36.27,0.89,180,68344,70,NULL,NULL,'2MASX J17243064-6628246',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.1274583,-66.47353,0.253,NULL,44435676444,694307444,10848553,15.5),(141381,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141381,37.71,0.46,349,68345,70,NULL,NULL,'2MASX J17243142+6455453',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000108,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,261.13125,64.92919,0.105,NULL,57518344870,898724138,14042564,16.6),(141382,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141382,34.97,0.63,98.7,68346,70,NULL,NULL,'ESO 070-IG 009',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.9b',0.5,'SAab?',NULL,NULL,NULL,NULL,1,261.141667,-70.47133,0.093,NULL,44096972871,689015201,10765862,14.9),(141383,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141383,37.99,0.46,397,68347,70,NULL,NULL,'2MASX J17243403+2705474',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.141791667,27.09656,0.197,NULL,56280942085,879389720,13740464,17.6),(141384,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141384,38.09,0.23,415,68348,70,NULL,NULL,'2MASX J17243453+6412013',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000059,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.144,64.20047,0.077,NULL,57574098596,899595290,14056176,18),(141385,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141385,33.6,NULL,52.4,68349,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4644',NULL,'2010Ap&SS.325..163P',2010,1,1.8,NULL,'G',0.000024,NULL,'15.5',0.22,'Spec',NULL,NULL,NULL,NULL,1,261.15375,-73.94011,0.389,NULL,44148424406,689819131,10778423,15.5),(141386,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141386,33.62,NULL,53,68349,NULL,NULL,'Dipole + Quadrupole','IC 4644',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141387,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141387,33.66,NULL,54.1,68349,NULL,NULL,'Dipole','IC 4644',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141388,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141388,38.29,0.46,456,68350,70,NULL,NULL,'SDSS J172438.00+605538.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,261.158375,60.92733,0.085,NULL,57564233631,899441150,14053767,18.3),(141389,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141389,37.18,0.46,273,68351,70,NULL,NULL,'2MASX J17244280+5351182',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000107,NULL,'16.0g',0.31,'E0',NULL,NULL,NULL,NULL,1,261.1785,53.85517,0.113,NULL,57496130342,898377036,14037141,16),(141390,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141390,35.64,0.79,134,68352,70,NULL,NULL,'2MASX J17244425-0130562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.184375,-1.51553,0.705,NULL,45115352237,704927378,11014490,16),(141391,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141391,35.34,0.2,117,68353,74.4,NULL,NULL,'UGC 10837',NULL,'2013AJ....146...86T',2013,1,1.17,NULL,'G',0.000047,NULL,'14.5g',0.64,'SBbc','Pair member (points to parent)',NULL,NULL,NULL,1,261.189083,24.97136,0.337,NULL,56286923363,879483177,13741924,14.5),(141392,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141392,33.38,0.2,47.4,68354,74.4,NULL,NULL,'UGC 10854',NULL,'2013AJ....146...86T',2013,1,0.98,NULL,'G',0.000061,NULL,'15.6g',0.45,'Scd:',NULL,NULL,NULL,NULL,1,261.193416667,58.20572,0.089,NULL,57687438261,901366222,14083847,15.6),(141393,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141393,33.45,0.43,48.9,68354,75,NULL,'3.6 micron, color corrected','UGC 10854',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141394,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141394,33.49,0.43,49.8,68354,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10854',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141395,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141395,38.09,0.23,415,68355,70,NULL,NULL,'2MASX J17245137+6421401',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000073,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.213791667,64.36128,0.085,NULL,57574039692,899594370,14056162,18),(141396,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141396,34.98,0.67,98.9,68356,70,NULL,NULL,'2MASX J17245375-0119131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.224041667,-1.32031,0.665,NULL,45117122041,704955031,11014922,15.2),(141397,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141397,38.09,0.23,415,68357,70,NULL,NULL,'2MASX J17245668+6426327',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000092,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,261.236083,64.4425,0.085,NULL,57573180463,899580944,14055952,17.5),(141398,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141398,38.87,0.46,595,68358,70,NULL,NULL,'SDSS J172501.60+611237.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000094,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,261.256667,61.21047,0.081,NULL,57564400807,899443762,14053808,18.3),(141399,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141399,35.35,0.27,118,68359,70,NULL,NULL,'2MASX J17250213+5817569',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000083,NULL,'16.0g',0.32,'E0',NULL,NULL,NULL,NULL,1,261.258666667,58.29917,0.085,NULL,57687425428,901366022,14083844,16),(141400,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141400,39.13,NULL,670,68360,70,NULL,'nucleus-to-host flux ratio, z > 0.17','2MASS J17250434+1152155',NULL,'2006AJ....132....1S',2006,1,NULL,'Wurtz, et al. (1996,ApJS,103,109) give z=0.159.','G',NULL,NULL,'15.77',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,261.268083,11.87097,0.601,NULL,55933290074,873957657,13655588,15.77),(141401,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141401,40.48,NULL,1250,68360,70,NULL,'z > 0.35','2MASS J17250434+1152155',NULL,'2014A&A...570A.126L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141402,'GeV TeV ratio','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141402,40.43,1,1220,68360,70,NULL,'z = 0.34 +/- 0.15','2MASS J17250434+1152155',NULL,'2016MNRAS.459.3271A',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141403,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141403,37.02,0.46,253,68361,70,NULL,NULL,'2MASX J17250764+5748269',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000077,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,261.2817083,57.80736,0.089,NULL,57693231083,901456735,14085261,16.9),(141404,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141404,37.46,0.21,310,68362,70,NULL,NULL,'SDSS J172510.39+525855.4',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000081,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,261.293333,52.98206,0.093,NULL,57499561125,898430642,14037978,17.2),(141405,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141405,36.93,0.46,243,68363,70,NULL,NULL,'2MASX J17251089+5812522',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000075,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,261.29525,58.21458,0.089,NULL,57687434305,901366161,14083846,18.1),(141406,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141406,36.68,0.61,217,68364,70,NULL,NULL,'2MASX J17251483-6604017',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.3117917,-66.06714,0.237,NULL,44436338366,694317786,10848715,15.8),(141407,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141407,37.46,0.21,310,68365,70,NULL,NULL,'2MASX J17252031+5255012',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000113,NULL,'16.1g',0.39,'AGN',NULL,NULL,NULL,NULL,1,261.334667,52.91706,0.093,NULL,57499567574,898430743,14037980,16.1),(141408,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141408,37.46,0.21,310,68366,70,NULL,NULL,'2MASX J17252154+5258262',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.3397917,52.97389,0.093,NULL,57499558656,898430604,14037978,17.3),(141409,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141409,37.46,0.21,310,68367,70,NULL,NULL,'2MASX J17252618+5257132',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000098,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,261.359,52.95369,0.093,NULL,57499566381,898430724,14037980,17.4),(141410,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141410,38.25,0.46,447,68368,70,NULL,NULL,'2MASX J17252970+2806158',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000166,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,261.37375,28.10436,0.185,NULL,56312040879,879875638,13748056,18),(141411,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141411,36.3,0.88,182,68369,70,NULL,NULL,'2MASX J17253418-7937343',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,261.3922917,-79.62619,0.329,NULL,44261814051,691590844,10806106,16.7),(141412,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141412,36.94,0.33,244,68370,70,NULL,NULL,'2MASX J17253760+5659573',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000072,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,261.4065417,56.99914,0.101,NULL,57693023073,901453485,14085210,16.8),(141413,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141413,34.31,NULL,72.7,68371,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10858',NULL,'2010Ap&SS.325..163P',2010,1,1.11,NULL,'G',0.00001,NULL,'16.2g',0.18,'Scd(f)         HII',NULL,NULL,NULL,NULL,1,261.4100417,59.44678,0.073,NULL,57557913608,899342400,14052225,16.2),(141414,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141414,34.33,NULL,73.3,68371,NULL,NULL,'Dipole','UGC 10858',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141415,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141415,34.33,NULL,73.5,68371,NULL,NULL,'Dipole + Quadrupole','UGC 10858',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141416,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141416,34.65,0.2,85.1,68371,74.4,NULL,NULL,'UGC 10858',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141417,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141417,34.71,0.43,87.7,68371,75,NULL,'3.6 micron, color corrected','UGC 10858',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141418,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141418,34.79,0.43,90.7,68371,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10858',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141419,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141419,37.64,0.46,338,68372,70,NULL,NULL,'SDSS J172543.42+641653.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,261.4309583,64.28144,0.085,NULL,57573206645,899581353,14055958,17.8),(141420,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141420,38.25,0.46,446,68373,70,NULL,NULL,'2MASX J17254374+2700248',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,261.4324583,27.00692,0.197,NULL,56281007895,879390748,13740480,17.5),(141421,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141421,37.46,0.21,310,68374,70,NULL,NULL,'2MASX J17254838+5307158',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000078,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,261.451833333,53.12122,0.101,NULL,57499697683,898432776,14038012,16.8),(141422,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141422,36.94,0.33,244,68375,70,NULL,NULL,'SDSS J172548.75+565914.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,261.453167,56.9875,0.101,NULL,57693024618,901453509,14085211,18.1),(141423,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141423,38.49,0.33,498,68376,70,NULL,NULL,'2MASX J17255197+3134227',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,261.4667917,31.57306,0.117,NULL,56369123278,880767551,13761992,18.2),(141424,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141424,35.63,0.23,134,68377,70,NULL,NULL,'CGCG 277-043',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000093,NULL,'15.5g',0.46,'E0',NULL,NULL,NULL,NULL,1,261.4922917,56.63683,0.077,NULL,57692924530,901451945,14085186,15.5),(141425,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141425,38.51,0.46,504,68378,70,NULL,NULL,'2MASX J17255910+3138526',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,261.4964583,31.648,0.109,NULL,56368758886,880761857,13761904,17.5),(141426,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141426,37.6,0.46,331,68379,70,NULL,NULL,'2MASX J17260233+6334134',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000078,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,261.5099583,63.57028,0.093,NULL,57576154308,899627411,14056678,17.1),(141427,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141427,32.82,0.43,36.7,68380,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10887',NULL,'2014MNRAS.444..527S',2014,1,1.32,NULL,'G',0.000017,NULL,'15.48',0.17,'Sc',NULL,NULL,NULL,NULL,1,261.529167,77.70361,0.153,NULL,57060794820,891574919,13930858,15.48),(141428,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141428,33.05,NULL,40.8,68380,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10887',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141429,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141429,33.07,NULL,41.2,68380,NULL,NULL,'Dipole + Quadrupole','UGC 10887',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141430,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141430,33.08,NULL,41.3,68380,NULL,NULL,'Dipole','UGC 10887',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141431,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141431,38.49,0.33,498,68381,70,NULL,NULL,'SDSS J172610.69+312926.2',NULL,'2015arXiv151105856S',2015,1,0.04,NULL,'G',NULL,NULL,'23.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,261.5445417,31.49061,0.117,NULL,56369303931,880770373,13762037,23.4),(141432,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141432,32.56,0.43,32.5,68382,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10852',NULL,'2014MNRAS.444..527S',2014,1,1.33,NULL,'G',0.000005,NULL,'16.00',0.13,'Sd',NULL,NULL,NULL,NULL,1,261.572,11.31706,0.605,NULL,56045561152,875711893,13682998,16),(141433,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141433,33.07,NULL,41,68382,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141434,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141434,33.08,NULL,41.2,68382,NULL,NULL,'Dipole + Quadrupole','UGC 10852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141435,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141435,33.08,NULL,41.3,68382,NULL,NULL,'Dipole','UGC 10852',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141436,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141436,33.1,NULL,41.7,68382,NULL,NULL,NULL,'UGC 10852',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141437,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141437,38.16,0.46,430,68383,70,NULL,NULL,'2MASX J17261999+2711590',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,261.583417,27.19989,0.193,NULL,56282961685,879421276,13740957,17.4),(141438,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141438,37.12,0.46,266,68384,70,NULL,NULL,'2MASX J17262244+5358019',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000091,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,261.593333,53.96711,0.113,NULL,57466636975,897916202,14029940,17.7),(141439,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141439,38.46,0.46,492,68385,70,NULL,NULL,'SDSS J172625.39+273614.1',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000147,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,261.6057917,27.60394,0.197,NULL,56282903228,879420362,13740943,18.9),(141440,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141440,31.61,0.8,21,68386,75,NULL,'A82, H','NGC 6395',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00002,NULL,'13.00',0.7,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,261.6302917,71.09628,0.133,NULL,57056740890,891511576,13929868,13),(141441,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141441,30.97,0.4,15.6,68386,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6395',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141442,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141442,31.43,0.2,19.3,68386,74.4,NULL,NULL,'NGC 6395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141443,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141443,31.47,0.38,19.7,68386,NULL,NULL,NULL,'NGC 6395',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141444,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141444,31.53,0.43,20.2,68386,75,NULL,'3.6 micron, color corrected','NGC 6395',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141445,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141445,31.61,0.43,21,68386,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6395',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141446,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141446,31.63,0.8,21.2,68386,NULL,NULL,NULL,'NGC 6395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141447,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141447,31.66,0.47,21.5,68386,75,NULL,'A82, H, inv','NGC 6395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141448,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141448,31.68,0.4,21.6,68386,75,NULL,'B','NGC 6395',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141449,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141449,31.67,0.79,21.6,68386,NULL,NULL,'Malmquist cor.','NGC 6395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141450,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141450,31.75,0.47,22.4,68386,75,NULL,'A82, H, raw','NGC 6395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141451,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141451,31.87,0.4,23.6,68386,NULL,NULL,'mean','NGC 6395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141452,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141452,32.04,0.47,25.6,68386,75,NULL,'A82, H, cor','NGC 6395',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141453,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141453,32.71,0.47,34.8,68386,NULL,NULL,'H','NGC 6395',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141454,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141454,38.2,0.46,436,68387,70,NULL,NULL,'SDSS J172632.95+585551.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000059,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,261.637333333,58.93103,0.081,NULL,57686873602,901357400,14083709,18.6),(141455,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141455,36.56,0.7,205,68388,70,NULL,NULL,'2MASX J17263889-7120492',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,261.662,-71.34708,0.353,NULL,44106575469,689165241,10768206,17.2),(141456,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141456,36.46,0.69,196,68389,70,NULL,NULL,'2MASX J17265159-0034144',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.714916667,-0.57081,0.725,NULL,45127683506,705120054,11017500,16.1),(141457,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141457,35.63,0.44,134,68390,NULL,NULL,'Malmquist cor.','ESO 102- G 004',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.01',0.2,'Sc',NULL,NULL,NULL,NULL,1,261.7249583,-64.89353,0.313,NULL,44437580780,694337199,10849018,15.01),(141458,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141458,35.88,0.39,150,68390,NULL,NULL,NULL,'ESO 102- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141459,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141459,35.92,0.2,153,68390,74.4,NULL,NULL,'ESO 102- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141460,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141460,37.17,0.46,272,68391,70,NULL,NULL,'2MASX J17265436+2714154',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,261.7265417,27.23769,0.197,NULL,56282934062,879420844,13740950,17.3),(141461,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141461,38.45,0.46,489,68392,70,NULL,NULL,'2MASX J17265605+2657024',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,261.7334583,26.95072,0.193,NULL,56282486274,879413848,13740841,17.8),(141462,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141462,35.63,0.23,134,68393,70,NULL,NULL,'2MASX J17270150+5653078',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000079,NULL,'16.2g',0.3,'E0',NULL,NULL,NULL,NULL,1,261.7564583,56.88558,0.073,NULL,57696537376,901508396,14086068,16.2),(141463,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141463,32.95,0.8,39,68394,75,NULL,'A82, H','NGC 6368',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.000017,NULL,'13.10',1,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,261.798083,11.54361,0.577,NULL,55924882363,873826286,13653535,13.1),(141464,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141464,31.89,0.4,23.9,68394,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6368',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141465,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141465,32.17,0.47,27.1,68394,75,NULL,'A82, H, raw','NGC 6368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141466,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141466,32.3,0.47,28.8,68394,75,NULL,'A82, H, inv','NGC 6368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141467,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141467,32.42,0.36,30.5,68394,NULL,NULL,NULL,'NGC 6368',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141468,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141468,32.56,0.47,32.5,68394,75,NULL,'A82, H, cor','NGC 6368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141469,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141469,32.57,0.2,32.7,68394,74.4,NULL,NULL,'NGC 6368',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141470,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141470,32.67,0.46,34.2,68394,NULL,NULL,'J','NGC 6368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141471,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141471,32.71,0.43,34.9,68394,75,NULL,'3.6 micron, color corrected','NGC 6368',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141472,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141472,32.73,0.47,35.1,68394,NULL,NULL,'H','NGC 6368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141473,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141473,32.78,0.45,36,68394,NULL,NULL,'K','NGC 6368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141474,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141474,32.88,0.4,37.7,68394,NULL,NULL,'mean','NGC 6368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141475,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141475,32.9,0.43,38.1,68394,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6368',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141476,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141476,33.06,0.4,40.9,68394,75,NULL,'B','NGC 6368',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141477,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141477,34.69,0.66,86.6,68395,70,NULL,NULL,'2MASX J17271483-0130214',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.8117917,-1.50603,0.737,NULL,45129705478,705151648,11017994,14.7),(141478,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141478,32.18,NULL,27.2,68396,NULL,NULL,NULL,'UGC 10872',NULL,'2000BSAO...50....5K',2000,1,1.46,NULL,'G',0.000017,NULL,'16.7g',0.14,'Sd(f)',NULL,NULL,NULL,NULL,1,261.826583,61.17775,0.129,NULL,57564585159,899446643,14053853,16.7),(141479,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141479,33.44,NULL,48.8,68396,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141480,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141480,33.46,NULL,49.3,68396,NULL,NULL,'Dipole + Quadrupole','UGC 10872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141481,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141481,33.47,NULL,49.3,68396,NULL,NULL,'Dipole','UGC 10872',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141482,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141482,35.41,NULL,121,68397,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2135',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',0.00001,NULL,'17.2',0.08,'Scd',NULL,NULL,NULL,NULL,1,261.847083,13.6625,0.481,NULL,55932885877,873951341,13655489,17.2),(141483,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141483,35.42,NULL,122,68397,NULL,NULL,'Dipole','FGC 2135',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141484,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141484,35.43,NULL,122,68397,NULL,NULL,'Dipole + Quadrupole','FGC 2135',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141485,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141485,35.48,0.43,125,68397,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2135',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141486,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141486,35.49,NULL,125,68397,NULL,NULL,NULL,'FGC 2135',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141487,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141487,33.92,0.47,60.9,68398,70,NULL,NULL,'2MASX J17272793-6200368',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'14.66',0.74,NULL,NULL,NULL,NULL,NULL,1,261.866875,-62.00956,0.305,NULL,44490458495,695163413,10861928,14.66),(141488,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141488,35.35,0.27,118,68399,70,NULL,NULL,'IC 1260',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000094,NULL,'15.7g',0.57,'S0/a','Group member',NULL,NULL,NULL,1,261.882166667,58.47586,0.085,NULL,57687049800,901360153,14083752,15.7),(141489,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141489,33.01,0.43,39.9,68400,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6372',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000023,NULL,'13.66',1.1,'Sb? pec',NULL,NULL,NULL,NULL,1,261.8827083,26.47514,0.217,NULL,56281837741,879403714,13740683,13.66),(141490,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141490,33.11,0.43,41.8,68400,75,NULL,'3.6 micron, color corrected','NGC 6372',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141491,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141491,33.25,0.2,44.7,68400,74.4,NULL,NULL,'NGC 6372',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141492,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141492,33.97,0.47,62.3,68400,NULL,NULL,'H','NGC 6372',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141493,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141493,34.1,0.45,66.1,68400,NULL,NULL,'K','NGC 6372',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141494,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141494,34.1,0.46,66.2,68400,NULL,NULL,'J','NGC 6372',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141495,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141495,34.31,0.4,72.8,68400,NULL,NULL,'mean','NGC 6372',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141496,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141496,37.44,0.33,308,68401,70,NULL,NULL,'2MASX J17273348+5405448',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,261.8895417,54.09581,0.117,NULL,57466658496,897916539,14029945,17.2),(141497,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141497,35.81,0.57,145,68402,70,NULL,NULL,'2MASX J17273736-6645574',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,261.9057083,-66.76592,0.285,NULL,44435558468,694305601,10848525,14.7),(141498,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141498,37.44,0.33,308,68403,70,NULL,NULL,'2MASX J17274262+5403086',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'16.7g',0.25,'NLAGN',NULL,NULL,NULL,NULL,1,261.927875,54.05236,0.117,NULL,57466663707,897916620,14029947,16.7),(141499,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141499,34.89,0.52,95.1,68404,NULL,NULL,'Malmquist cor.','ESO 102- G 005',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.66',0.4,'Sb - c',NULL,NULL,NULL,NULL,1,261.942833,-64.56164,0.333,NULL,44436651200,694322675,10848791,14.66),(141500,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141500,34.93,0.47,97,68404,NULL,NULL,'H','ESO 102- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141501,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141501,35.03,0.45,101,68404,NULL,NULL,'K','ESO 102- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141502,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141502,35.05,0.46,102,68404,NULL,NULL,'J','ESO 102- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141503,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141503,35.06,0.4,103,68404,NULL,NULL,'mean','ESO 102- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141504,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141504,35.25,0.44,112,68404,NULL,NULL,NULL,'ESO 102- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141505,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141505,35.29,0.2,114,68404,74.4,NULL,NULL,'ESO 102- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141506,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141506,35.82,0.46,146,68405,70,NULL,NULL,'CGCG 300-036',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000107,NULL,'15.0g',0.59,'E0','Group member',NULL,NULL,NULL,1,261.968917,60.09728,0.117,NULL,57558393728,899349902,14052342,15),(141507,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141507,36.88,0.7,237,68406,70,NULL,NULL,'2MASX J17280878-6814233',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.036417,-68.23981,0.277,NULL,44964258152,702566533,10977602,15),(141508,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141508,32.12,NULL,26.6,68407,72,NULL,NULL,'UGC 10862',NULL,'2014Ap.....57..457K',2014,1,2.8,NULL,'G',0.000007,NULL,'13.4',2.5,'SB(rs)c','Isolated galaxy',NULL,NULL,NULL,1,262.03725,7.42242,0.281,NULL,56102569733,876602652,13696916,13.4),(141509,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141509,32.15,0.4,26.9,68407,75,NULL,'B','UGC 10862',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141510,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141510,37.23,0.33,279,68408,70,NULL,NULL,'2MASX J17280969+5553588',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000117,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,262.0404583,55.89983,0.113,NULL,57689839426,901403741,14084433,15.8),(141511,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141511,36.69,0.56,218,68409,70,NULL,NULL,'2MASX J17281348-6651522',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.056,-66.8645,0.285,NULL,44969243930,702644436,10978819,15.1),(141512,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141512,37.23,0.33,279,68410,70,NULL,NULL,'2MASX J17281777+5554168',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000095,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,262.074375,55.90481,0.133,NULL,57689893242,901404581,14084446,17),(141513,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141513,37,NULL,238,68411,NULL,NULL,NULL,'I Zw 187',0.055405,'2005ApJ...635..173S',2005,1,NULL,'Mislabeled as I Zw 186 in Craine\'s Handbook of QSOs.','G',0.0002,NULL,'15.15',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,262.077583,50.21958,0.085,NULL,57503898327,898498411,14039037,15.15),(141514,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141514,33.21,0.49,43.8,68412,75,NULL,'IR','NGC 6390',NULL,'2011yCatp016004901K',2011,1,0.58,'The 2MASXi position is 9 arcsec south-southwest of the nucleus.','G',0.000041,NULL,'14.7g',0.46,'Sbc','Group member',NULL,NULL,NULL,1,262.1170417,60.09417,0.117,NULL,57558347021,899349172,14052330,14.7),(141515,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141515,33.44,0.2,48.8,68412,74.4,NULL,NULL,'NGC 6390',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141516,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141516,33.49,0.5,49.9,68412,NULL,NULL,NULL,'NGC 6390',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141517,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141517,33.74,0.45,55.9,68412,NULL,NULL,'Malmquist cor.','NGC 6390',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141518,'GRB','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141518,45.49,1.47,4750,68413,NULL,NULL,NULL,'GRB 080605',1.6398,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,262.1252083,4.01567,0.405,NULL,56059812710,875934573,13686477,NULL),(141519,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141519,38.27,0.33,450,68414,70,NULL,NULL,'2MASX J17283011+5315104',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000086,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,262.1254583,53.253,0.121,NULL,57499082591,898423165,14037861,17.4),(141520,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141520,38.27,0.33,450,68415,70,NULL,NULL,'2MASX J17283040+5320374',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000093,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,262.1267917,53.34367,0.121,NULL,57499155685,898424307,14037879,17.6),(141521,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141521,38.13,0.46,423,68416,70,NULL,NULL,'2MASX J17283997+6042167',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,262.166625,60.70467,0.129,NULL,57556766102,899324470,14051944,18.2),(141522,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141522,37.71,0.46,348,68417,70,NULL,NULL,'2MASX J17284852+2638010',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,262.202166667,26.63378,0.193,NULL,56281973538,879405836,13740716,17.6),(141523,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141523,35.35,0.27,118,68418,70,NULL,NULL,'NGC 6391',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.000104,NULL,'14.6g',0.68,'E0',NULL,NULL,NULL,NULL,1,262.204125,58.85089,0.097,NULL,57686793699,901356151,14083689,14.6),(141524,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141524,35.78,0.86,143,68419,70,NULL,NULL,'2MASX J17285058-0325215',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,262.21075,-3.42267,1.025,NULL,45120297814,705004653,11015697,14.6),(141525,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141525,37.6,0.46,332,68420,70,NULL,NULL,'2MASX J17285083+5914192',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000086,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,262.2120417,59.23864,0.089,NULL,57556062613,899313478,14051773,17.2),(141526,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141526,34.14,NULL,67.4,68421,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10874',NULL,'2010Ap&SS.325..163P',2010,1,1.47,NULL,'G',0.000005,NULL,'16.0',0.16,'Scd',NULL,NULL,NULL,NULL,1,262.239333333,29.30747,0.169,NULL,56363947802,880686684,13760729,16),(141527,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141527,34.16,NULL,67.8,68421,NULL,NULL,'Dipole','UGC 10874',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141528,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141528,34.16,NULL,67.8,68421,NULL,NULL,'Dipole + Quadrupole','UGC 10874',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141529,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141529,34.22,NULL,69.7,68421,NULL,NULL,NULL,'UGC 10874',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141530,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141530,35.24,0.2,112,68421,74.4,NULL,NULL,'UGC 10874',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141531,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141531,35.32,0.54,116,68421,NULL,NULL,'Malmquist cor.','UGC 10874',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141532,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141532,35.35,0.53,117,68421,NULL,NULL,NULL,'UGC 10874',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141533,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141533,35.42,0.43,122,68421,75,NULL,'3.6 micron, color corrected','UGC 10874',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141534,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141534,35.69,0.43,137,68421,75,NULL,'3.6 micron, color + selection bias corrected','UGC 10874',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141535,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141535,35.6,0.5,132,68422,70,NULL,NULL,'2MASX J17285917-6647476',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.2464583,-66.79653,0.285,NULL,44435509189,694304831,10848512,14.6),(141536,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141536,35.11,0.49,105,68423,75,NULL,'IR','CGCG 054-031',NULL,'2011yCatp016004901K',2011,1,1.16,'Star superposed.','G',0.000012,NULL,'15.6',0.15,'Sbc',NULL,NULL,NULL,NULL,1,262.250833,8.83314,0.353,NULL,56092420855,876444075,13694438,15.6),(141537,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141537,35.34,NULL,117,68423,NULL,NULL,'Dipole + Quadrupole + Octopole','CGCG 054-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141538,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141538,35.36,NULL,118,68423,NULL,NULL,'Dipole + Quadrupole','CGCG 054-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141539,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141539,35.37,NULL,118,68423,NULL,NULL,'Dipole','CGCG 054-031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141540,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141540,35.4,NULL,120,68423,NULL,NULL,NULL,'CGCG 054-031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141541,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141541,35.42,0.43,122,68423,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 054-031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141542,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141542,32.85,NULL,37.1,68424,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10892',NULL,'2010Ap&SS.325..163P',2010,1,1.84,NULL,'G',0.000013,NULL,'16.0',0.15,'Sd',NULL,NULL,NULL,NULL,1,262.27125,74.25611,0.133,NULL,57104991935,892265498,13941648,16),(141543,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141543,32.86,NULL,37.4,68424,NULL,NULL,'Dipole + Quadrupole','UGC 10892',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141544,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141544,32.87,NULL,37.5,68424,NULL,NULL,'Dipole','UGC 10892',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141545,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141545,32.96,NULL,39.1,68424,NULL,NULL,NULL,'UGC 10892',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141546,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141546,36.35,0.51,186,68425,70,NULL,NULL,'2MASX J17290651-6523141',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.277083,-65.38719,0.257,NULL,44437659654,694338432,10849038,14.6),(141547,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141547,37.85,0.46,371,68426,70,NULL,NULL,'SDSS J172908.05+255830.7',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.5g',0.2,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,262.283583,25.97522,0.289,NULL,56284333361,879442708,13741292,17.5),(141548,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141548,36.06,0.7,163,68427,70,NULL,NULL,'2MASX J17290875-6522481',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.2865,-65.37997,0.257,NULL,44437114884,694329920,10848905,15.4),(141549,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141549,33.7,0.47,54.9,68428,70,NULL,NULL,'ESO 138-IG 029',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000077,NULL,'12.75',1.4,'Rings','Pair member (points to parent)',NULL,NULL,NULL,1,262.289875,-62.44561,0.317,NULL,44490744315,695167879,10861998,12.75),(141550,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141550,38,0.27,399,68429,70,NULL,NULL,'2MASX J17291081+3057512',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.3g',0.2,'BrClG',NULL,NULL,NULL,NULL,1,262.2949583,30.96419,0.189,NULL,56365151791,880705496,13761023,17.3),(141551,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141551,34.22,0.49,69.9,68430,75,NULL,'IR','UGC 10873',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'15.26',0.2,'SB?','Pair member (points to parent)',NULL,NULL,NULL,1,262.31525,16.15761,0.465,NULL,56815374217,887740222,13870940,15.26),(141552,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141552,37.42,0.46,304,68431,70,NULL,NULL,'2MASX J17292126+5415259',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000095,NULL,'16.5g',0.29,'BrClG          AGN',NULL,NULL,NULL,NULL,1,262.3382917,54.25725,0.133,NULL,57469971231,897968300,14030754,16.5),(141553,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141553,36.7,0.57,219,68432,70,NULL,NULL,'2MASX J17292831-6634333',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.3677917,-66.57597,0.277,NULL,44435534888,694305232,10848519,15.6),(141554,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141554,34.12,0.8,66.7,68433,75,NULL,'MAT, I','ESO 102- G 007',NULL,'1997ApJS..109..333W',1997,1,1.3,'SGC and ESO-LV catalogs both have two entries for this galaxy.','G',0.000013,NULL,'13.38',1,'SAB(rs)c:',NULL,NULL,NULL,NULL,1,262.3815417,-64.02286,0.349,NULL,44481671867,695026122,10859783,13.38),(141555,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141555,34.42,0.32,76.6,68433,85,NULL,'I, raw','ESO 102- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141556,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141556,34.43,0.43,77,68433,75,NULL,'MAT, I, raw','ESO 102- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141557,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141557,34.49,0.32,79,68433,85,NULL,'I, inv','ESO 102- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141558,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141558,34.51,0.52,80,68433,NULL,NULL,'Malmquist cor.','ESO 102- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141559,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141559,34.58,0.43,82.4,68433,75,NULL,'MAT, I, cor','ESO 102- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141560,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141560,34.72,0.43,87.9,68433,75,NULL,'MAT, I, inv','ESO 102- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141561,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141561,34.95,0.42,97.8,68433,NULL,NULL,NULL,'ESO 102- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141562,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141562,34.99,0.2,99.5,68433,74.4,NULL,NULL,'ESO 102- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141563,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141563,37.57,0.46,327,68434,70,NULL,NULL,'2MASX J17293735+5725141',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000092,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,262.405667,57.42056,0.109,NULL,57696229919,901503592,14085993,17.8),(141564,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141564,31.86,0.4,23.5,68435,75,NULL,'B','NGC 6412',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000003,NULL,'12.28',2.2,'SA(s)c','Isolated galaxy',NULL,NULL,NULL,1,262.4062917,75.70442,0.181,NULL,57070434642,891725541,13933211,12.28),(141565,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141565,35.12,0.62,106,68436,70,NULL,NULL,'2MASX J17293946-1105308',NULL,'2014MNRAS.445.2677S',2014,1,0.18,NULL,'G',0.00015,NULL,'15.2R',NULL,'E',NULL,NULL,NULL,NULL,1,262.414333333,-11.09194,1.733,NULL,45306120397,707908131,11061064,15.2),(141566,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141566,35.92,0.5,153,68437,70,NULL,NULL,'2MASX J17294037-7013217',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,262.418333,-70.22272,0.061,NULL,44105458349,689147786,10767934,16),(141567,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141567,36.64,0.46,213,68438,70,NULL,NULL,'2MASX J17294546+5342092',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000104,NULL,'16.3g',0.29,NULL,NULL,NULL,NULL,NULL,1,262.4394583,53.70253,0.117,NULL,57467741413,897933459,14030210,16.3),(141568,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141568,38.28,0.46,453,68439,70,NULL,NULL,'2MASX J17294595+5356052',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000099,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,262.4412917,53.93494,0.117,NULL,57469873685,897966776,14030730,16.8),(141569,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141569,38,0.27,399,68440,70,NULL,NULL,'2MASX J17294662+3056029',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,262.44425,30.93408,0.169,NULL,56365128459,880705132,13761017,17.2),(141570,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141570,35.28,0.77,114,68441,70,NULL,NULL,'2MASX J17295053-0307415',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.9R',0.1,NULL,NULL,NULL,NULL,NULL,1,262.4605417,-3.12811,0.977,NULL,45121126080,705017595,11015899,15.9),(141571,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141571,37.5,0.46,317,68442,70,NULL,NULL,'SDSS J172951.16+624914.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000074,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,262.463167,62.82075,0.077,NULL,57578850850,899669544,14057336,18),(141572,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141572,35.4,0.72,120,68443,70,NULL,NULL,'2MASX J17295205-1135478',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,262.466833,-11.59664,1.317,NULL,45275128784,707423887,11053498,14.5),(141573,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141573,38,0.27,399,68444,70,NULL,NULL,'2MASX J17295548+3101329',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,262.4812917,31.02581,0.169,NULL,56364979120,880702798,13760981,17.2),(141574,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141574,36.7,0.46,219,68445,70,NULL,NULL,'LCSB S2339P',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000076,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,262.4837917,53.47739,0.121,NULL,57497943671,898405369,14037583,16.6),(141575,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141575,35.17,0.56,108,68446,70,NULL,NULL,'2MASX J17300306-6325349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,262.512583,-63.42642,0.333,NULL,44489943538,695155367,10861802,16.5),(141576,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141576,37.62,0.46,335,68447,70,NULL,NULL,'2MASX J17300332+5720331',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000083,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,262.513916667,57.34256,0.109,NULL,57696743916,901511623,14086119,17.6),(141577,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141577,37.5,0.46,316,68448,70,NULL,NULL,'2MASX J17301557+5345135',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000089,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,262.564917,53.75375,0.117,NULL,57469886539,897966977,14030734,16.6),(141578,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141578,38.02,0.46,402,68449,70,NULL,NULL,'2MASX J17301751+3118401',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',NULL,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,262.573083333,31.31106,0.169,NULL,56364309584,880692337,13760817,17.3),(141579,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141579,38.1,0.23,417,68450,70,NULL,NULL,'2MASX J17302589+5441555',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0001,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,262.608125,54.69886,0.145,NULL,57469822634,897965978,14030718,18.1),(141580,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141580,34.29,0.46,72.2,68451,70,NULL,NULL,'ESO 139- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.25',0.8,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,262.616125,-62.02864,0.305,NULL,44491069757,695172964,10862077,14.25),(141581,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141581,37.7,0.46,348,68452,70,NULL,NULL,'2MASX J17302805+6008295',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000079,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,262.6169583,60.14164,0.117,NULL,57557513064,899336141,14052127,17.7),(141582,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141582,37.26,0.46,283,68453,70,NULL,NULL,'2MASX J17302917+5609505',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000075,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,262.621708333,56.16406,0.129,NULL,57689927964,901405124,14084455,17.1),(141583,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141583,35.3,0.55,115,68454,70,NULL,NULL,'2MASX J17303146-1048034',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00015,NULL,'17.5R',NULL,'S?',NULL,NULL,NULL,NULL,1,262.631083333,-10.80094,1.769,NULL,45306164139,707908814,11061075,17.5),(141584,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141584,38.1,0.23,417,68455,70,NULL,NULL,'2MASX J17303558+5442455',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000115,NULL,'16.3g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,262.6484583,54.71286,0.145,NULL,57469791666,897965494,14030710,16.3),(141585,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141585,36.38,0.59,189,68456,70,NULL,NULL,'2MASX J17304000-6558438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.666667,-65.97878,0.237,NULL,44440298028,694379656,10849682,15.4),(141586,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141586,35,0.4,100,68457,NULL,NULL,'mean','NGC 6378',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'14.40',0.9,'S?',NULL,NULL,NULL,NULL,1,262.674916667,6.28228,0.337,NULL,56089127317,876392614,13693634,14.4),(141587,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141587,35.38,0.46,119,68457,NULL,NULL,'J','NGC 6378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141588,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141588,35.39,0.47,119,68457,NULL,NULL,'H','NGC 6378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141589,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141589,35.4,0.45,120,68457,NULL,NULL,'K','NGC 6378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141590,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141590,35.63,0.23,134,68458,70,NULL,NULL,'CGCG 277-046',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000073,NULL,'15.0g',0.52,'S0',NULL,NULL,NULL,NULL,1,262.676375,56.63936,0.109,NULL,57694382723,901474730,14085542,15),(141591,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141591,35,0.46,100,68459,70,NULL,NULL,'CGCG 278-007',NULL,'2015arXiv151105856S',2015,1,1.03,NULL,'G',0.000086,NULL,'14.8g',0.41,'S0',NULL,NULL,NULL,NULL,1,262.686875,56.35197,0.101,NULL,57694458336,901475911,14085561,14.8),(141592,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141592,34.08,0.8,65.6,68460,75,NULL,'MAT, I','ESO 044- G 013',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'17.3b',0.3,'Sc? sp',NULL,NULL,NULL,NULL,1,262.688917,-74.45914,0.333,NULL,44147516033,689804938,10778202,17.3),(141593,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141593,34.27,0.4,71.5,68460,NULL,NULL,'mean','ESO 044- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141594,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141594,34.4,0.45,76,68460,NULL,NULL,'K','ESO 044- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141595,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141595,34.41,0.43,76.2,68460,75,NULL,'MAT, I, raw','ESO 044- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141596,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141596,34.42,0.47,76.5,68460,NULL,NULL,'H','ESO 044- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141597,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141597,34.47,0.32,78.3,68460,85,NULL,'I, raw','ESO 044- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141598,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141598,34.51,0.43,79.8,68460,75,NULL,'MAT, I, cor','ESO 044- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141599,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141599,34.51,0.49,79.8,68460,75,NULL,'IR','ESO 044- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141600,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141600,34.52,0.32,80.2,68460,85,NULL,'I, inv','ESO 044- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141601,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141601,34.57,0.46,82.1,68460,NULL,NULL,'J','ESO 044- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141602,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141602,34.65,0.43,85,68460,75,NULL,'MAT, I, inv','ESO 044- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141603,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141603,34.79,0.46,90.7,68460,NULL,NULL,'Malmquist cor.','ESO 044- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141604,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141604,34.9,0.43,95.7,68460,NULL,NULL,NULL,'ESO 044- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141605,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141605,34.94,0.2,97.3,68460,74.4,NULL,NULL,'ESO 044- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141606,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141606,36.18,0.59,172,68461,70,NULL,NULL,'2MASX J17304572-6633346',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.6905,-66.55972,0.277,NULL,44439743562,694370993,10849546,15.5),(141607,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141607,39.15,0.46,677,68462,70,NULL,NULL,'2MASX J17304891+6204308',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000099,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,262.703458333,62.07525,0.117,NULL,57578317045,899661203,14057206,18.2),(141608,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141608,36.87,0.6,236,68463,70,NULL,NULL,'2MASX J17305353-6647127',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,262.7230417,-66.78683,0.285,NULL,44428175895,694190248,10846722,15.5),(141609,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141609,38.1,0.23,417,68464,70,NULL,NULL,'2MASX J17305879+5443401',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000056,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,262.744917,54.72792,0.145,NULL,57469721379,897964396,14030693,18.3),(141610,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141610,38.1,0.23,417,68465,70,NULL,NULL,'2MASX J17310817+5439392',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000082,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,262.784166667,54.66097,0.145,NULL,57469748147,897964814,14030700,17.6),(141611,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141611,37.9,0.33,380,68466,70,NULL,NULL,'2MASX J17311384+5456273',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,262.807625,54.94081,0.133,NULL,57468760402,897949381,14030459,17.1),(141612,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141612,37.9,0.33,380,68467,70,NULL,NULL,'2MASX J17311883+5457493',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000079,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,262.828583,54.96375,0.133,NULL,57468758037,897949344,14030458,18.1),(141613,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141613,35.78,0.35,143,68468,70,NULL,NULL,'GIN 644',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000077,NULL,'14.29',NULL,'S',NULL,NULL,NULL,NULL,1,262.836833,43.61603,0.069,NULL,59603882299,931310660,14551729,14.29),(141614,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141614,37.22,0.46,278,68469,70,NULL,NULL,'2MASX J17312567+5819503',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000078,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,262.857083,58.33081,0.089,NULL,57686502867,901351607,14083618,17.5),(141615,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141615,35.63,0.52,134,68470,70,NULL,NULL,'2MASX J17312967-0215442',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00009,NULL,'13.8R',0.1,'near *',NULL,NULL,NULL,NULL,1,262.873625,-2.26225,0.957,NULL,45130046668,705156979,11018077,13.8),(141616,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141616,33.94,NULL,61.3,68471,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10890',NULL,'2010Ap&SS.325..163P',2010,1,1.88,'Bright star superposed.','G',0.000011,NULL,'15.71',0.1,'Sd','Isolated galaxy',NULL,NULL,NULL,1,262.9190417,32.23153,0.153,NULL,56326584957,880102889,13751607,15.71),(141617,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141617,33.95,NULL,61.6,68471,NULL,NULL,'Dipole + Quadrupole','UGC 10890',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141618,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141618,33.95,NULL,61.7,68471,NULL,NULL,'Dipole','UGC 10890',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141619,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141619,34.02,NULL,63.6,68471,NULL,NULL,NULL,'UGC 10890',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141620,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141620,38.05,0.46,408,68472,70,NULL,NULL,'SDSS J173156.98+535616.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,262.987416667,53.93783,0.117,NULL,57469945623,897967900,14030748,18.6),(141621,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141621,35.83,0.33,146,68473,70,NULL,NULL,'VII Zw 720',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000094,NULL,'16.2g',0.38,'BLAGN',NULL,NULL,NULL,'Sy 1',1,262.99675,59.97167,0.113,NULL,57557619787,899337809,14052153,16.2),(141622,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141622,38.35,0.46,468,68474,70,NULL,NULL,'2MASX J17320236+5313470',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000089,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,263.009916667,53.22989,0.121,NULL,57498050893,898407045,14037610,17.8),(141623,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141623,36.95,NULL,246,68475,NULL,NULL,NULL,'2MASX J17320995+2007424',NULL,'1996PASJ...48..657S',1996,1,0.4,NULL,'G',NULL,NULL,'16',0.2,'Sc',NULL,NULL,NULL,NULL,1,263.0415417,20.12842,0.325,NULL,56837144445,888080381,13876255,16),(141624,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141624,35.83,0.33,146,68476,70,NULL,NULL,'VII Zw 721',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000078,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,263.060417,59.87086,0.145,NULL,57557603470,899337554,14052149,15.7),(141625,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141625,37.43,0.46,306,68477,70,NULL,NULL,'2MASX J17322375+5524527',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000098,NULL,'16.1g',0.41,'Sy?',NULL,NULL,NULL,'Sy ?',1,263.098916667,55.41464,0.141,NULL,57690367246,901411988,14084562,16.1),(141626,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1971L',NULL,141626,31.39,0.25,19,68478,60,NULL,'M(V) = -19.47 mag','NGC 6384',NULL,'2000ApJ...540..634P',2000,1,6.2,NULL,'G',0.000004,NULL,'11.14',4.1,'SAB(r)bc       LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,263.10125,7.06028,0.409,NULL,56089414163,876397096,13693704,11.14),(141627,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1971L',NULL,141627,31.55,0.25,20.4,68478,60,NULL,'M(B) = -19.48 mag','NGC 6384',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141628,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1971L','R',141628,32.34,NULL,29.4,68478,NULL,NULL,'Photographic','NGC 6384',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141629,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141629,32.05,0.8,25.7,68478,75,NULL,'A82, H','NGC 6384',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141630,'Sosies','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141630,31.12,0.31,16.7,68478,NULL,NULL,NULL,'NGC 6384',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141631,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141631,31.36,0.69,18.7,68478,100,NULL,'mid-IR','NGC 6384',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141632,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141632,31.48,0.4,19.8,68478,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6384',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141633,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141633,31.53,NULL,20.2,68478,NULL,NULL,'LEDA [April 2006]','NGC 6384',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141634,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141634,31.58,0.43,20.7,68478,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6384',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141635,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141635,31.89,NULL,23.9,68478,72,NULL,NULL,'NGC 6384',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141636,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141636,31.96,0.43,24.6,68478,75,NULL,'3.6 micron, color corrected','NGC 6384',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141637,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141637,32,0.3,25.1,68478,NULL,18.45,'SN 1971L host','NGC 6384',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141638,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141638,32.03,0.47,25.4,68478,75,NULL,'A82, H, raw','NGC 6384',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141639,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141639,32.07,0.35,25.9,68478,NULL,NULL,NULL,'NGC 6384',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141640,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141640,32.12,0.4,26.6,68478,75,NULL,'B','NGC 6384',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141641,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141641,32.25,0.47,28.1,68478,75,NULL,'A82, H, inv','NGC 6384',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141642,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141642,32.36,0.2,29.7,68478,74.4,NULL,NULL,'NGC 6384',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141643,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141643,32.39,0.47,30.1,68478,75,NULL,'A82, H, cor','NGC 6384',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141644,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141644,34.99,0.68,99.6,68479,70,NULL,NULL,'2MASX J17322969-7141184',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,263.1235,-71.68847,0.277,NULL,44103459252,689116550,10767446,15.8),(141645,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141645,35.58,0.25,131,68480,74.4,NULL,NULL,'GIN 643',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000047,NULL,'14.96',NULL,'E/S0',NULL,NULL,NULL,NULL,1,263.1462917,43.85264,0.077,NULL,59603712699,931308010,14551687,14.96),(141646,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141646,35.78,0.35,143,68480,70,NULL,NULL,'GIN 643',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141647,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141647,34.76,0.52,89.7,68481,70,NULL,NULL,'2MASX J17323741-5347263',NULL,'2014MNRAS.445.2677S',2014,1,0.11,NULL,'G',0.00015,NULL,'14.4R',NULL,'E?',NULL,NULL,NULL,NULL,1,263.1559583,-53.79069,0.805,NULL,44336256503,692754007,10824281,14.4),(141648,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141648,32.52,0.69,32,68482,100,NULL,'mid-IR','NGC 6389',NULL,'2013ApJ...771...88L',2013,1,2.8,NULL,'G',0.000013,NULL,'12.82',1.9,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,263.165708333,16.40178,0.397,NULL,56812713086,887698641,13870291,12.82),(141649,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141649,33.63,0.4,53.2,68482,NULL,NULL,'mean','NGC 6389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141650,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141650,34.01,0.46,63.5,68482,NULL,NULL,'J','NGC 6389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141651,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141651,34.03,0.45,64,68482,NULL,NULL,'K','NGC 6389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141652,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141652,34.03,0.47,64.1,68482,NULL,NULL,'H','NGC 6389',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141653,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141653,36.68,0.46,217,68483,70,NULL,NULL,'2MASX J17324152+5607012',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000096,NULL,'15.8g',0.44,'E0',NULL,NULL,NULL,NULL,1,263.173125,56.117,0.133,NULL,57694565437,901477584,14085587,15.8),(141654,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141654,38.34,0.46,466,68484,70,NULL,NULL,'2MASX J17325904+5832454',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000097,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,263.245916667,58.546,0.129,NULL,57686612117,901353314,14083645,17.8),(141655,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141655,35.94,0.56,154,68485,70,NULL,NULL,'2MASX J17330150-6646391',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,263.2564583,-66.77758,0.265,NULL,44428185724,694190401,10846725,15.3),(141656,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141656,35.57,0.25,130,68486,74.4,NULL,NULL,'IC 1262',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000077,NULL,'14.73',0.6,'cD;E','Group member',NULL,NULL,NULL,1,263.258417,43.75961,0.069,NULL,59603744587,931308509,14551695,14.73),(141657,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141657,35.78,0.35,143,68486,70,NULL,NULL,'IC 1262',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141658,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141658,35.76,0.45,142,68486,NULL,NULL,'K','IC 1262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141659,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141659,35.78,0.4,143,68486,NULL,NULL,'mean','IC 1262',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141660,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141660,35.58,0.25,131,68487,74.4,NULL,NULL,'GIN 640',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000053,NULL,'14.77',NULL,'E/S0',NULL,NULL,NULL,NULL,1,263.286625,43.70961,0.069,NULL,59603746141,931308533,14551695,14.77),(141661,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141661,35.78,0.35,143,68487,70,NULL,NULL,'GIN 640',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141662,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141662,35.89,0.24,145,68488,NULL,NULL,'EPM, Hamuy et al. (2001)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,263.3135,36.47167,0.125,NULL,56156928844,877452013,13710187,NULL),(141663,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141663,35.98,0.42,151,68488,NULL,NULL,'SCM, rise time Dessart & Hillier (2005)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141664,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141664,36.03,0.43,154,68488,NULL,NULL,'SCM, rise time Hamuy et al. (2001)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141665,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141665,36.07,0.25,157,68488,NULL,NULL,'EPM, Dessart & Hillier (2005)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141666,'SNII optical','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 2013eq','R',141666,36.13,0.2,161,68488,NULL,NULL,'SCM, rise time Gall et al. (2015)','2MASX J17331525+3628178',0.042,'2016arXiv160304730G',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141667,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141667,35.78,0.35,143,68489,70,NULL,NULL,'IC 1264',NULL,'2001MNRAS.321..277C',2001,1,1.5,NULL,'G',0.00005,NULL,'14.45',1.1,'E/S0','Group member',NULL,NULL,NULL,1,263.320167,43.62922,0.069,NULL,59603738089,931308407,14551693,14.45),(141668,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141668,35.94,0.4,154,68489,NULL,NULL,'mean','IC 1264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141669,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141669,36.08,0.45,164,68489,NULL,NULL,'K','IC 1264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141670,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141670,35.59,0.25,131,68490,74.4,NULL,NULL,'CGCG 226-028',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000167,':','14.36',0.5,'S','Group member',NULL,NULL,NULL,1,263.335083,43.91347,0.077,NULL,59605553459,931336772,14552137,14.36),(141671,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141671,35.78,0.35,143,68490,70,NULL,NULL,'CGCG 226-028',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141672,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141672,34.36,0.46,74.5,68491,70,NULL,NULL,'ESO 139- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.61',0.6,'SAB(s)0^0^',NULL,NULL,NULL,NULL,1,263.33775,-60.77619,0.349,NULL,44448178003,694502781,10851605,14.61),(141673,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141673,35.58,0.25,131,68492,74.4,NULL,NULL,'UGC 10904 NOTES01',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000047,NULL,'15.5',0.3,'E/S0',NULL,NULL,NULL,NULL,1,263.339541667,43.63472,0.069,NULL,59603735168,931308362,14551693,15.5),(141674,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141674,37.89,0.46,378,68493,70,NULL,NULL,'SDSS J173324.42+552724.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000097,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,263.35175,55.45678,0.141,NULL,57689647363,901400740,14084386,18.7),(141675,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141675,35.91,0.53,152,68494,70,NULL,NULL,'2MASX J17333637-0323119',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,263.401625,-3.38664,1.329,NULL,45121463707,705022870,11015982,14.4),(141676,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141676,39.03,0.46,640,68495,70,NULL,NULL,'SDSS J173340.91+535243.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000095,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,263.4205,53.87878,0.121,NULL,57467864769,897935387,14030240,18.7),(141677,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141677,34.32,0.5,73.2,68496,70,NULL,NULL,'CGCG 027-002',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000077,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,263.451167,-0.597,0.765,NULL,45126185736,705096652,11017135,15.6),(141678,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141678,33.7,0.5,54.9,68497,70,NULL,NULL,'2MASX J17335042-6221353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'14.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,263.4602083,-62.35978,0.257,NULL,44490573867,695165216,10861956,14.4),(141679,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141679,36.39,0.5,190,68498,70,NULL,NULL,'2MASX J17335397-8211311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,263.474417,-82.19194,0.361,NULL,44054712423,688354881,10755545,15.9),(141680,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141680,37.76,0.33,357,68499,70,NULL,NULL,'2MASX J17340591+5448009',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000104,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,263.525,54.80028,0.133,NULL,57469098234,897954659,14030541,17.9),(141681,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141681,37.19,0.46,274,68500,70,NULL,NULL,'2MASX J17340610+5527009',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000079,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,263.5257083,55.45025,0.141,NULL,57689700054,901401563,14084399,16.8),(141682,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141682,37.76,0.33,357,68501,70,NULL,NULL,'2MASX J17343293+5451598',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00009,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,263.6374583,54.86656,0.133,NULL,57469260541,897957195,14030581,17),(141683,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141683,35.04,0.8,102,68502,75,NULL,'CF, r','UGC 10909',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',NULL,NULL,'15.00',0.6,'Scd:',NULL,NULL,NULL,NULL,1,263.658125,25.5685,0.261,NULL,56294821399,879606584,13743852,15),(141684,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141684,34.31,0.38,72.8,68502,75,NULL,'CF, r, raw','UGC 10909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141685,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141685,34.38,0.38,75,68502,75,NULL,'CF, r, inv','UGC 10909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141686,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141686,34.5,0.38,79.3,68502,75,NULL,'CF, r, cor','UGC 10909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141687,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141687,38.22,0.46,440,68503,70,NULL,NULL,'2MASX J17344206+5324465',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000103,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,263.675083333,53.41292,0.129,NULL,57468098185,897939034,14030297,17.7),(141688,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141688,35.92,0.46,153,68504,70,NULL,NULL,'CGCG 300-050',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000091,NULL,'15.3g',0.51,'E0',NULL,NULL,NULL,NULL,1,263.690833,58.93756,0.133,NULL,57555378128,899302783,14051605,15.3),(141689,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141689,38.42,0.46,484,68505,70,NULL,NULL,'2MASX J17345410+5414007',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000093,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,263.7252083,54.23364,0.133,NULL,57469514543,897961164,14030643,18.2),(141690,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141690,38.8,0.46,576,68506,70,NULL,NULL,'2MASX J17345736+5333221',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000095,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,263.739167,53.55617,0.125,NULL,57468237238,897941206,14030331,18.1),(141691,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141691,35.06,0.58,103,68507,70,NULL,NULL,'2MASX J17351281-6253301',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,263.8035,-62.89161,0.265,NULL,44487659152,695119674,10861244,15.9),(141692,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141692,37.48,0.33,314,68508,70,NULL,NULL,'2MASX J17351382+5527399',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000098,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,263.8075,55.46094,0.141,NULL,57689655158,901400861,14084388,16.6),(141693,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141693,37.48,0.33,314,68509,70,NULL,NULL,'2MASX J17352287+5528319',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,263.8452917,55.47564,0.141,NULL,57689721606,901401900,14084404,17.4),(141694,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141694,33.58,0.09,52,68510,74.4,NULL,NULL,'NGC 6411',NULL,'2013AJ....146...86T',2013,1,1.73,'MCG misprints dec as +60d20; corrected in MCG errata.','G',0.000028,NULL,'12.9g',1.19,'E',NULL,NULL,NULL,NULL,1,263.886875,60.81339,0.141,NULL,57558534785,899352106,14052376,12.9),(141695,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141695,33.71,0.28,54.5,68510,72,NULL,NULL,'NGC 6411',0.01269,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141696,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141696,33.91,0.1,58.9,68510,65,NULL,'MLCS2k2','NGC 6411',0.01269,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141697,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141697,33.91,0.25,59.9,68510,65,NULL,'MLCS31','NGC 6411',0.01269,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141698,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141698,33.93,0.25,60.2,68510,65,NULL,'MLCS17','NGC 6411',0.01269,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141699,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141699,34.05,0.32,63.8,68510,65,NULL,NULL,'NGC 6411',0.01269,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141700,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:00','1','SN 1999da',NULL,141700,34.28,0.21,70.9,68510,70,NULL,'SALT','NGC 6411',0.01269,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141701,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141701,32.33,0.35,29.2,68510,NULL,NULL,NULL,'NGC 6411',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141702,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141702,32.93,0.35,38.5,68510,NULL,NULL,'Malmquist cor.','NGC 6411',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141703,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141703,32.41,0.4,30.3,68510,75,NULL,'Edat, raw','NGC 6411',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141704,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141704,32.74,0.4,35.4,68510,75,NULL,'Edat, cor','NGC 6411',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141705,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141705,32.89,0.41,37.9,68510,NULL,NULL,NULL,'NGC 6411',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141706,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,NULL,141706,33.38,0.41,47.5,68510,NULL,NULL,'Malmquist cor.','NGC 6411',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141707,'FP','2016-12-15 15:15:46','2016-12-16 11:21:00','1',NULL,'R',141707,37.51,0.46,318,68511,70,NULL,NULL,'2MASX J17353604+5529369',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000101,NULL,'16.9g',0.22,NULL,NULL,NULL,NULL,NULL,1,263.900375,55.49364,0.141,NULL,57689720724,901401886,14084404,16.9),(141708,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141708,37.64,0.46,337,68512,70,NULL,NULL,'2MASX J17353678+5324460',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000073,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,263.903375,53.41278,0.129,NULL,57468109641,897939213,14030300,17.3),(141709,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141709,34.98,0.46,99.2,68513,70,NULL,NULL,'2MASX J17354349-5642341',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,263.931333333,-56.70956,0.397,NULL,44525376512,695709008,10870453,13.3),(141710,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141710,36.52,0.99,202,68514,70,NULL,NULL,'2MFGC 13932',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,263.966,-67.52261,0.301,NULL,44964805270,702575082,10977735,15.7),(141711,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141711,34.34,0.52,73.8,68515,NULL,NULL,NULL,'ESO 024- G 007',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000033,NULL,'15.24',0.12,'Scd',NULL,NULL,NULL,NULL,1,264.099167,-77.53667,0.461,NULL,44127458948,689491546,10773305,15.24),(141712,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141712,34.38,0.2,75.2,68515,74.4,NULL,NULL,'ESO 024- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141713,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141713,34.44,NULL,77.4,68515,NULL,NULL,'Dipole + Quadrupole','ESO 024- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141714,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141714,34.45,NULL,77.5,68515,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 024- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141715,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141715,34.47,NULL,78.4,68515,NULL,NULL,'Dipole','ESO 024- G 007',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141716,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141716,34.52,0.48,80.2,68515,NULL,NULL,'Malmquist cor.','ESO 024- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141717,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141717,34.53,NULL,80.4,68515,NULL,NULL,NULL,'ESO 024- G 007',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141718,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141718,32.98,0.43,39.4,68516,75,NULL,'3.6 micron, color + selection bias corrected','IC 1265',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.00003,NULL,'12.31',0.9,'Sab',NULL,NULL,NULL,NULL,1,264.1642917,42.08842,0.121,NULL,59602892929,931295202,14551487,12.31),(141719,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141719,33.01,0.43,39.9,68516,75,NULL,'3.6 micron, color corrected','IC 1265',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141720,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141720,33.06,0.2,40.9,68516,74.4,NULL,NULL,'IC 1265',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141721,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141721,34.95,0.49,97.8,68517,75,NULL,'IR','CGCG 083-006',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,264.192375,13.16183,0.433,NULL,55954416715,874287761,13660746,15.6),(141722,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141722,32.14,0.69,26.8,68518,100,NULL,'mid-IR','NGC 6434',NULL,'2013ApJ...771...88L',2013,1,2.3,NULL,'G',0.000033,NULL,'13.21',1,'SBbc:          HII',NULL,NULL,NULL,'H II',1,264.203417,72.08897,0.125,NULL,57048240938,891378764,13927793,13.21),(141723,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141723,32.57,0.33,32.7,68518,NULL,NULL,'Malmquist cor.','NGC 6434',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141724,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141724,32.94,0.4,38.8,68518,NULL,NULL,'mean','NGC 6434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141725,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141725,33,0.2,39.8,68518,74.4,NULL,NULL,'NGC 6434',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141726,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141726,33.01,0.4,40,68518,NULL,NULL,NULL,'NGC 6434',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141727,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141727,33.02,0.27,40.2,68518,NULL,NULL,NULL,'NGC 6434',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141728,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141728,33.08,0.43,41.3,68518,75,NULL,'3.6 micron, color corrected','NGC 6434',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141729,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141729,33.15,0.47,42.7,68518,NULL,NULL,'H','NGC 6434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141730,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141730,33.15,0.46,42.7,68518,NULL,NULL,'J','NGC 6434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141731,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141731,33.15,0.43,42.7,68518,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6434',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141732,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141732,33.19,0.45,43.4,68518,NULL,NULL,'K','NGC 6434',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141733,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141733,37.3,0.33,288,68519,70,NULL,NULL,'2MASX J17365398+5458358',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,264.224833,54.97667,0.149,NULL,57469134526,897955226,14030550,17.3),(141734,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141734,37.3,0.33,288,68520,70,NULL,NULL,'SDSS J173654.72+550201.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000066,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,264.228,55.03389,0.149,NULL,57468435890,897944310,14030379,18.2),(141735,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141735,38.3,0.46,457,68521,70,NULL,NULL,'2MASX J17370061+5837299',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000092,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,264.252958333,58.62514,0.161,NULL,57559523185,899367549,14052617,17.1),(141736,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141736,33.64,0.5,53.4,68522,70,NULL,NULL,'IC 4654',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'11.92',1.1,'SAB(r)c',NULL,NULL,NULL,NULL,1,264.282875,-74.38144,0.333,NULL,44148467536,689819805,10778434,11.92),(141737,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141737,38.61,0.46,527,68523,70,NULL,NULL,'2MASX J17371614+5728218',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000086,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,264.317375,57.47258,0.161,NULL,57695378932,901490295,14085785,18),(141738,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141738,36.2,0.51,174,68524,70,NULL,NULL,'2MASX J17371913-6733112',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,264.33,-67.55317,0.301,NULL,44964680950,702573139,10977705,13.9),(141739,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141739,34.78,NULL,90.4,68525,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10931',NULL,'2010Ap&SS.325..163P',2010,1,1.12,NULL,'G',NULL,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,264.334541667,60.42728,0.185,NULL,57559412559,899365821,14052590,16.5),(141740,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141740,34.8,NULL,91.2,68525,NULL,NULL,'Dipole + Quadrupole','UGC 10931',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141741,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141741,34.81,NULL,91.4,68525,NULL,NULL,'Dipole','UGC 10931',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141742,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141742,35.14,0.58,107,68525,NULL,NULL,'Malmquist cor.','UGC 10931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141743,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141743,35.2,0.2,110,68525,74.4,NULL,NULL,'UGC 10931',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141744,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141744,35.26,0.55,113,68525,NULL,NULL,NULL,'UGC 10931',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141745,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141745,35.42,NULL,121,68525,NULL,NULL,NULL,'UGC 10931',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141746,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141746,36.27,0.53,180,68526,70,NULL,NULL,'2MASX J17373825-6749321',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,264.409458333,-67.82564,0.309,NULL,44966681158,702604393,10978193,15.2),(141747,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141747,37.07,0.58,260,68527,70,NULL,NULL,'2MASX J17373975-8707342',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,264.4157917,-87.12614,0.381,NULL,44029741756,687964714,10749448,16.8),(141748,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141748,33.93,0.8,61.2,68528,75,NULL,'MAT, I','IC 4656',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000033,NULL,'13.72',0.6,'SA(s)c:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,264.4327917,-63.72967,0.317,NULL,44431469486,694241710,10847526,13.72),(141749,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141749,33.25,0.43,44.7,68528,75,NULL,'MAT, I, raw','IC 4656',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141750,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141750,33.31,0.32,46,68528,85,NULL,'I, raw','IC 4656',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141751,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141751,33.37,0.32,47.1,68528,85,NULL,'I, inv','IC 4656',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141752,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141752,33.48,0.43,49.7,68528,75,NULL,'MAT, I, inv','IC 4656',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141753,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141753,33.49,0.49,49.9,68528,75,NULL,'IR','IC 4656',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141754,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141754,33.56,0.47,51.4,68528,NULL,NULL,'H','IC 4656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141755,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141755,33.58,0.43,52,68528,75,NULL,'MAT, I, cor','IC 4656',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141756,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141756,33.6,0.46,52.4,68528,NULL,NULL,'J','IC 4656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141757,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141757,33.66,0.45,54.1,68528,NULL,NULL,'K','IC 4656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141758,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141758,33.9,0.4,60.3,68528,NULL,NULL,'mean','IC 4656',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141759,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141759,34.16,0.09,68.1,68528,NULL,NULL,NULL,'IC 4656',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141760,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141760,36.08,0.61,164,68529,70,NULL,NULL,'2MASX J17375184-6501376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,264.465917,-65.02711,0.249,NULL,44442467725,694413558,10850211,15.9),(141761,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141761,34.6,0.46,83,68530,70,NULL,NULL,'ESO 181- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000033,NULL,'11.82',0.7,'SAB(s)bc:',NULL,NULL,NULL,NULL,1,264.477083,-55.51819,0.529,NULL,44516247520,695566367,10868224,11.82),(141762,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141762,34.84,0.8,92.9,68530,75,NULL,'MAT, I','ESO 181- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141763,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141763,34.5,0.32,79.3,68530,85,NULL,'I, raw','ESO 181- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141764,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141764,34.58,0.32,82.6,68530,85,NULL,'I, inv','ESO 181- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141765,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141765,34.62,0.47,83.8,68530,NULL,NULL,'Malmquist cor.','ESO 181- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141766,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141766,34.73,0.43,88.2,68530,75,NULL,'MAT, I, raw','ESO 181- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141767,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141767,34.93,0.43,97,68530,75,NULL,'MAT, I, cor','ESO 181- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141768,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141768,35.04,0.39,102,68530,NULL,NULL,NULL,'ESO 181- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141769,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141769,35.08,0.2,104,68530,74.4,NULL,NULL,'ESO 181- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141770,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141770,35.11,0.43,105,68530,75,NULL,'MAT, I, inv','ESO 181- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141771,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141771,35.94,0.55,154,68531,70,NULL,NULL,'2MASX J17375658-7816331',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,264.48575,-78.27592,0.465,NULL,44127718475,689495601,10773368,16),(141772,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141772,37.88,0.46,376,68532,70,NULL,NULL,'2MASX J17375675+5538587',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000079,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,264.486625,55.64975,0.177,NULL,57693712945,901464264,14085379,17.7),(141773,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141773,34.67,0.46,85.7,68533,70,NULL,NULL,'MCG +10-25-073',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000099,NULL,'15.4g',0.41,'HII',NULL,NULL,NULL,NULL,1,264.5224583,57.11819,0.141,NULL,57681434283,901272410,14082381,15.4),(141774,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141774,35.11,0.4,105,68534,NULL,NULL,'mean','UGC 10928',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000057,NULL,'14.70',0.6,'Sb',NULL,NULL,NULL,NULL,1,264.675083333,21.67511,0.505,NULL,56781597914,887212467,13862694,14.7),(141775,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141775,35.22,0.47,111,68534,NULL,NULL,'H','UGC 10928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141776,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141776,35.33,0.46,116,68534,NULL,NULL,'J','UGC 10928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141777,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141777,35.33,0.45,116,68534,NULL,NULL,'K','UGC 10928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141778,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141778,37.79,0.33,362,68535,70,NULL,NULL,'SDSS J173855.05+565520.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,264.729416667,56.92233,0.149,NULL,57683219851,901300310,14082817,18.4),(141779,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141779,38.52,0.46,506,68536,70,NULL,NULL,'SDSS J173857.58+574635.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000068,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,264.7399583,57.77664,0.149,NULL,57681210975,901268921,14082326,18.4),(141780,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141780,37.79,0.33,362,68537,70,NULL,NULL,'2MASX J17392025+5659458',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00008,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,264.834416667,56.99603,0.141,NULL,57683268127,901301064,14082829,17.1),(141781,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141781,36.4,0.64,190,68538,70,NULL,NULL,'2MASX J17392780-6655406',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,264.865875,-66.92789,0.269,NULL,44428614070,694197094,10846829,15.8),(141782,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141782,32.37,0.8,29.7,68539,75,NULL,'MAT, I','ESO 009- G 010',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000033,NULL,'11.11',1.6,'SA(s)c','in a triple',NULL,NULL,NULL,1,264.881583,-85.31042,0.181,NULL,44028630864,687947357,10749177,11.11),(141783,'Sosies','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141783,32.24,0.11,28.1,68539,NULL,NULL,NULL,'ESO 009- G 010',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141784,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141784,32.57,0.32,32.6,68539,85,NULL,'I, raw','ESO 009- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141785,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141785,32.6,0.4,33.1,68539,NULL,NULL,NULL,'ESO 009- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141786,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141786,32.6,0.39,33.1,68539,73,NULL,'opt','ESO 009- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141787,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141787,32.61,0.32,33.3,68539,85,NULL,'I, inv','ESO 009- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141788,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141788,32.66,0.4,34,68539,73,NULL,'opt','ESO 009- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141789,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141789,32.69,0.43,34.5,68539,75,NULL,'MAT, I, raw','ESO 009- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141790,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141790,32.7,0.53,34.7,68539,NULL,NULL,'Malmquist cor.','ESO 009- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141791,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141791,32.75,0.47,35.5,68539,NULL,NULL,'H','ESO 009- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141792,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141792,32.76,0.4,35.6,68539,NULL,NULL,'mean','ESO 009- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141793,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141793,32.76,0.45,35.6,68539,NULL,NULL,'K','ESO 009- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141794,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141794,32.77,0.46,35.8,68539,NULL,NULL,'J','ESO 009- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141795,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141795,32.78,0.51,35.9,68539,NULL,NULL,NULL,'ESO 009- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141796,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141796,32.82,0.2,36.6,68539,74.4,NULL,NULL,'ESO 009- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141797,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141797,32.88,0.43,37.6,68539,75,NULL,'MAT, I, cor','ESO 009- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141798,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141798,32.91,0.43,38.2,68539,75,NULL,'MAT, I, inv','ESO 009- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141799,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141799,35.12,0.47,105,68540,70,NULL,NULL,'2MASX J17394294-0138228',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.0001,NULL,'13.1I',0.6,NULL,NULL,NULL,NULL,NULL,1,264.928875,-1.63964,1.049,NULL,45159751125,705621111,11025329,13.1),(141800,'GRB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141800,45.46,1.46,4380,68541,NULL,NULL,NULL,'GRB 090902B',1.822,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,264.938583,27.32447,0.201,NULL,56303289662,879738900,13745920,NULL),(141801,'GRB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141801,45.91,0.15,15200,68541,NULL,NULL,NULL,'GRB 090902B',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141802,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141802,37.8,0.46,363,68542,70,NULL,NULL,'2MASX J17394650+5525598',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000102,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,264.944083333,55.43333,0.173,NULL,57463017904,897859654,14029057,16.9),(141803,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141803,35.25,0.52,112,68543,70,NULL,NULL,'2MASX J17395214-0330348',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'13.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,264.9672917,-3.50964,1.637,NULL,45149719128,705464361,11022880,13.8),(141804,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141804,38.18,0.33,432,68544,70,NULL,NULL,'2MASX J17395564+5419447',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000092,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,264.981958333,54.32903,0.161,NULL,57476957802,898077465,14032460,17.8),(141805,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141805,36.2,0.46,174,68545,70,NULL,NULL,'2MASX J17395671+5345016',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,264.986333,53.75058,0.117,NULL,57475302660,898051604,14032056,16.3),(141806,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141806,37.73,0.46,351,68546,70,NULL,NULL,'SDSS J174003.97+551615.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000083,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,265.016541667,55.27103,0.173,NULL,57476689816,898073278,14032394,18.5),(141807,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141807,35.08,0.5,104,68547,70,NULL,NULL,'2MASX J17400574-6726235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,265.024125,-67.43997,0.277,NULL,44964739779,702574059,10977719,15.3),(141808,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141808,37.39,0.46,301,68548,70,NULL,NULL,'SDSS J174005.92+573435.1',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000089,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,265.024667,57.57642,0.177,NULL,57682058518,901282164,14082533,17),(141809,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141809,38.04,0.46,405,68549,70,NULL,NULL,'2MASX J17401396+5510524',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00009,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,265.058167,55.18117,0.149,NULL,57476894122,898076470,14032444,17.9),(141810,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141810,38.18,0.33,432,68550,70,NULL,NULL,'2MASX J17401428+5420184',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000083,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,265.059458333,54.33836,0.161,NULL,57476956251,898077441,14032460,16.8),(141811,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141811,34.37,0.46,74.7,68551,70,NULL,NULL,'ESO 044- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000057,NULL,'14.3b',1,'E0-1:',NULL,NULL,NULL,NULL,1,265.076125,-74.98672,0.297,NULL,44132279083,689566860,10774482,14.3),(141812,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141812,33.54,0.49,51,68552,70,NULL,NULL,'UKS 1736-633',NULL,'2014MNRAS.445.2677S',2014,1,1.8,'Marginal HIPASS detection.','G',0.000035,NULL,'14.7b',1.2,'SA(l)0^0',NULL,NULL,NULL,NULL,1,265.2947917,-63.39086,0.297,NULL,44487336550,695114633,10861166,14.7),(141813,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141813,34.24,0.2,70.5,68553,74.4,NULL,NULL,'NGC 6436',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00003,NULL,'14.68',0.8,'Scd:',NULL,NULL,NULL,NULL,1,265.305167,60.44969,0.185,NULL,57559333563,899364586,14052571,14.68),(141814,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141814,34.45,0.51,77.5,68553,NULL,NULL,NULL,'NGC 6436',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141815,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141815,34.48,0.51,78.7,68553,NULL,NULL,'Malmquist cor.','NGC 6436',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141816,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141816,36.97,0.46,247,68554,70,NULL,NULL,'2MASX J17412156+5524037',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000091,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,265.3397917,55.40103,0.145,NULL,57463254885,897863357,14029114,16.6),(141817,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141817,37.9,0.46,380,68555,70,NULL,NULL,'2MASX J17412243+5341380',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000093,NULL,'18.1g',0.17,'NLAGN',NULL,NULL,NULL,NULL,1,265.343583333,53.69389,0.145,NULL,57475328873,898052013,14032062,18.1),(141818,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141818,33.69,0.47,54.8,68556,NULL,NULL,NULL,'ESO 139- G 016',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.75',0.6,'S...',NULL,NULL,NULL,NULL,1,265.4362917,-61.70303,0.309,NULL,44486571218,695102675,10860979,15.75),(141819,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141819,33.73,0.2,55.7,68556,74.4,NULL,NULL,'ESO 139- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141820,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141820,33.97,0.41,62.2,68556,NULL,NULL,'Malmquist cor.','ESO 139- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141821,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141821,34.1,0.37,66.1,68557,NULL,NULL,NULL,'ESO 009- G 009',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.29',0.4,'SBcd:',NULL,NULL,NULL,NULL,1,265.443625,-86.71472,0.497,NULL,44030663494,687979117,10749673,14.29),(141822,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141822,34.14,0.2,67.3,68557,74.4,NULL,NULL,'ESO 009- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141823,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141823,34.18,0.36,68.7,68557,NULL,NULL,'Malmquist cor.','ESO 009- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141824,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141824,33.21,0.47,43.9,68558,NULL,NULL,'H','NGC 6417',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'13.90',1.2,'SB(r)b:',NULL,NULL,NULL,NULL,1,265.44925,23.67219,0.509,NULL,56249493263,878898332,13732786,13.9),(141825,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141825,33.28,0.45,45.4,68558,NULL,NULL,'K','NGC 6417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141826,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141826,33.35,0.46,46.8,68558,NULL,NULL,'J','NGC 6417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141827,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141827,33.47,0.4,49.5,68558,NULL,NULL,'mean','NGC 6417',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141828,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141828,38.38,0.27,474,68559,70,NULL,NULL,'2MASX J17415413+5543025',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000096,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,265.475417,55.71739,0.165,NULL,57682269901,901285467,14082585,17.8),(141829,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141829,38.38,0.27,474,68560,70,NULL,NULL,'SDSS J174155.59+553710.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000108,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,265.481625,55.61961,0.145,NULL,57463174797,897862106,14029095,18.2),(141830,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141830,38.38,0.27,474,68561,70,NULL,NULL,'2MASX J17415677+5532155',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000099,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,265.486791667,55.53778,0.145,NULL,57463236383,897863068,14029110,17.9),(141831,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141831,34.62,0.68,83.9,68562,70,NULL,NULL,'2MASX J17415870-0334020',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000123,NULL,'15.0R',0.3,NULL,NULL,NULL,NULL,NULL,1,265.494583,-3.56725,1.649,NULL,45161477417,705648084,11025751,15),(141832,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141832,34.58,0.47,82.6,68563,NULL,NULL,'H','UGC 10943',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000008,NULL,'14.80',0.6,'S?',NULL,NULL,NULL,NULL,1,265.552083,3.199,0.625,NULL,55899938595,873436540,13647445,14.8),(141833,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141833,34.76,0.45,89.7,68563,NULL,NULL,'K','UGC 10943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141834,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141834,34.84,0.46,92.7,68563,NULL,NULL,'J','UGC 10943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141835,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141835,34.87,0.4,94,68563,NULL,NULL,'mean','UGC 10943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141836,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141836,37.51,0.46,318,68564,70,NULL,NULL,'2MASX J17421555+5514135',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000106,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,265.564625,55.23706,0.145,NULL,57463127314,897861364,14029083,16.6),(141837,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141837,36.8,0.46,229,68565,70,NULL,NULL,'SDSS J174220.31+540324.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,265.584667,54.05667,0.125,NULL,57478204364,898096943,14032764,18.1),(141838,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141838,34.31,0.49,72.8,68566,75,NULL,'IR','UGC 10948',NULL,'2011yCatp016004901K',2011,1,2.58,NULL,'G',NULL,NULL,'15.1',0.43,'Sb',NULL,NULL,NULL,NULL,1,265.63325,0.21681,1.033,NULL,55843463531,872554117,13633658,15.1),(141839,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141839,35.38,0.61,119,68567,70,NULL,NULL,'2MASX J17423441-6536024',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,265.643333,-65.60078,0.245,NULL,44442022486,694406601,10850103,15.1),(141840,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141840,36.66,0.5,215,68568,70,NULL,NULL,'2MASX J17423779-8701480',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,265.6575,-87.03006,0.445,NULL,44029926724,687967605,10749493,15.1),(141841,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141841,35.99,0.56,158,68569,70,NULL,NULL,'2MASX J17425028-6331085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,265.709417,-63.51906,0.301,NULL,44431923833,694248809,10847637,16.3),(141842,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141842,38.12,0.33,422,68570,70,NULL,NULL,'2MASX J17430048+5415377',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000079,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,265.752166667,54.26047,0.125,NULL,57478144110,898096001,14032750,17.5),(141843,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141843,36.17,0.7,171,68571,70,NULL,NULL,'2MASX J17430648-0113069',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,265.777041667,-1.21858,1.045,NULL,45101637729,704713089,11011142,15.3),(141844,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141844,38.12,0.33,422,68572,70,NULL,NULL,'2MASX J17430947+5405327',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00011,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,265.7892917,54.09247,0.125,NULL,57478127842,898095747,14032746,17.4),(141845,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141845,33.97,0.48,62.3,68573,70,NULL,NULL,'NGC 6403',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.29',0.9,'SA(rs)0^0^:',NULL,NULL,NULL,NULL,1,265.848167,-61.68211,0.309,NULL,44486608249,695103253,10860988,14.29),(141846,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141846,37.83,0.46,368,68574,70,NULL,NULL,'SDSS J174348.90+540317.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000068,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,265.95375,54.05494,0.125,NULL,57478133616,898095837,14032747,18.5),(141847,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141847,34.7,0.47,87,68575,NULL,NULL,'H','NGC 6433',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000014,NULL,'14.06',0.5,'Sb',NULL,NULL,NULL,NULL,1,265.9842083,36.80011,0.133,NULL,56147092423,877298319,13707786,14.06),(141848,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141848,34.71,0.46,87.6,68575,NULL,NULL,'J','NGC 6433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141849,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141849,34.78,0.45,90.2,68575,NULL,NULL,'K','NGC 6433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141850,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141850,34.83,0.49,92.6,68575,75,NULL,'IR','NGC 6433',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141851,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141851,35.04,0.4,102,68575,NULL,NULL,'mean','NGC 6433',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141852,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141852,32.7,0.69,34.7,68576,100,NULL,'mid-IR','NGC 6429',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000077,NULL,'14.01',0.8,'SBa',NULL,NULL,NULL,NULL,1,266.0222917,25.35072,0.289,NULL,56292994793,879578043,13743406,14.01),(141853,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141853,33.25,0.47,44.6,68576,NULL,NULL,'H','NGC 6429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141854,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141854,33.27,0.45,45.1,68576,NULL,NULL,'K','NGC 6429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141855,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141855,33.31,0.46,46,68576,NULL,NULL,'J','NGC 6429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141856,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141856,33.44,0.4,48.7,68576,NULL,NULL,'mean','NGC 6429',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141857,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141857,35.25,0.4,112,68577,74.2,NULL,'SALT 2','ARK 527',0.006004,'2010ApJ...716..712A',2010,1,0.5,'RC3 gives v = 1800 +/- 190 km/sec.','G',0.000117,NULL,'15.20',0.3,'S?',NULL,NULL,NULL,NULL,1,266.035833,40.86731,0.117,NULL,56116238809,876816231,13700253,15.2),(141858,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141858,35.73,0.03,139,68577,70,NULL,'SALT 2','ARK 527',0.006004,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141859,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141859,36.12,0.14,161,68577,73.8,NULL,'SALT 2 (SNANA)','ARK 527',0.0392,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141860,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141860,36.06,0.03,162,68577,72,NULL,'SALT','ARK 527',0.006004,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141861,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141861,36.09,0.15,164,68577,70,NULL,'SALT 2','ARK 527',0.006004,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141862,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141862,36.21,0.16,174,68577,65,NULL,'SALT','ARK 527',0.006004,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141863,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141863,36.22,0.18,174,68577,65,NULL,'SALT2','ARK 527',0.006004,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141864,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141864,36.35,0.13,185,68577,65,NULL,'MLCS17','ARK 527',0.006004,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141865,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2003fa',NULL,141865,36.37,0.12,187,68577,65,NULL,'MLCS31','ARK 527',0.006004,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141866,'Tully est','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141866,32.12,0.8,26.6,68577,75,NULL,'B','ARK 527',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141867,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141867,34.58,0.49,82.5,68578,75,NULL,'IR','NGC 6471 NED01',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000143,NULL,'15.4',0.2,'Scd:','Group member',NULL,NULL,NULL,1,266.054333,67.59306,0.153,NULL,57784156352,902877443,14107460,15.4),(141868,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141868,35.32,0.73,116,68579,70,NULL,NULL,'2MASX J17442277-6528341',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,266.094875,-65.47614,0.245,NULL,44442040964,694406890,10850107,14.7),(141869,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2005ao',NULL,141869,36.11,0.09,161,68580,72,NULL,NULL,'NGC 6462',0.038407,'2008ApJ...689..377W',2008,1,0.4,NULL,'G',0.000417,NULL,'14.9',0.4,'SABbc','Isolated galaxy',NULL,NULL,NULL,1,266.203583,61.91058,0.133,NULL,57570449965,899538280,14055285,14.9),(141870,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2005ao',NULL,141870,36.2,0.1,167,68580,72,NULL,NULL,'NGC 6462',0.038407,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141871,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2005ao',NULL,141871,36.12,0.08,168,68580,72,NULL,'M(H) = -18.317 mag','NGC 6462',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141872,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141872,33.77,0.4,56.8,68581,75,NULL,'Edat, raw','NGC 6407',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000107,NULL,'12.34',1.6,'SA0^0^? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,266.240375,-60.73981,0.345,NULL,44454053685,694594588,10853040,12.34),(141873,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141873,34.12,0.4,66.7,68581,75,NULL,'Edat, cor','NGC 6407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141874,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141874,34.01,0.4,63.4,68581,NULL,NULL,'mean','NGC 6407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141875,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141875,34.31,0.45,72.8,68581,NULL,NULL,'K','NGC 6407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141876,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141876,35.48,0.6,125,68582,70,NULL,NULL,'2MASX J17451158-5533084',NULL,'2014MNRAS.445.2677S',2014,1,0.14,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,266.298333,-55.55231,0.385,NULL,44328446265,692631972,10822374,15.1),(141877,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141877,35.97,0.62,156,68583,70,NULL,NULL,'2MASX J17455962-7725081',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'1991MNRAS.248..528A has z = 0.1150 +- 0.0004.','G',0.00015,NULL,'16.4b',NULL,'Sbrst',NULL,NULL,NULL,NULL,1,266.498667,-77.41894,0.457,NULL,44128091655,689501432,10773459,16.4),(141878,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141878,35.65,0.49,135,68584,75,NULL,'IR','UGC 10982',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.00004,NULL,'16.0',0.19,'Sbc',NULL,NULL,NULL,NULL,1,266.5094583,59.32311,0.169,NULL,57561667800,899401059,14053141,16),(141879,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141879,35.15,0.56,107,68585,70,NULL,NULL,'2MASX J17461029-6041410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,266.5427083,-60.69472,0.345,NULL,44454035959,694594311,10853036,16.5),(141880,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141880,35.29,0.49,114,68586,70,NULL,NULL,'ESO 181- GA004',NULL,'2014MNRAS.445.2677S',2014,1,2.8,NULL,'G',0.00015,NULL,'13.3R',1.9,'SB(r)a',NULL,NULL,NULL,NULL,1,266.5632917,-55.18417,0.525,NULL,44328518997,692633109,10822392,13.3),(141881,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141881,34.48,0.47,78.6,68587,NULL,NULL,'H','NGC 6447',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00005,NULL,'13.74',0.9,'SBb','Pair member (points to parent)',NULL,NULL,NULL,1,266.5717917,35.57197,0.089,NULL,56150762618,877355665,13708682,13.74),(141882,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141882,34.62,0.46,84,68587,NULL,NULL,'J','NGC 6447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141883,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141883,34.63,0.45,84.5,68587,NULL,NULL,'K','NGC 6447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141884,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141884,34.74,0.4,88.9,68587,NULL,NULL,'mean','NGC 6447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141885,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141885,33.87,0.49,59.5,68588,75,NULL,'IR','UGC 10972',NULL,'2011yCatp016004901K',2011,1,2.5,'UZC position refers to a knot on the southwest arm.','G',0.000017,NULL,'14.00',0.7,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,266.5912083,26.54375,0.269,NULL,56300551140,879696111,13745251,14),(141886,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141886,34,0.2,63.1,68588,74.4,NULL,NULL,'UGC 10972',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141887,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141887,34.2,0.35,69.1,68588,NULL,NULL,NULL,'UGC 10972',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141888,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141888,34.21,0.35,69.4,68588,NULL,NULL,'Malmquist cor.','UGC 10972',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141889,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141889,34.21,0.47,69.5,68588,NULL,NULL,'H','UGC 10972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141890,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141890,34.23,0.4,70.1,68588,NULL,NULL,'mean','UGC 10972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141891,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141891,34.29,0.46,72,68588,NULL,NULL,'J','UGC 10972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141892,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141892,34.38,0.45,75.2,68588,NULL,NULL,'K','UGC 10972',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141893,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141893,34.28,0.4,71.8,68589,NULL,NULL,'mean','UGC 10976',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000067,NULL,'14.4',0.5,'SB','Pair member (points to parent)',NULL,NULL,NULL,1,266.616125,30.70475,0.253,NULL,56269609101,879212642,13737697,14.4),(141894,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141894,34.92,0.47,96.4,68589,NULL,NULL,'H','UGC 10976',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141895,'Tully est','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141895,32.02,0.8,25.3,68590,75,NULL,NULL,'UGC 10991',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000013,NULL,'17.',0.9,'Im',NULL,NULL,NULL,NULL,1,266.620417,67.33806,0.169,NULL,57781282965,902832546,14106758,17),(141896,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141896,33.39,0.8,47.7,68591,75,NULL,'MAT, I','ESO 070- G 013',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000029,NULL,'14.9',1.1,'SAB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,266.634,-68.26208,0.353,NULL,44963720566,702558133,10977470,14.9),(141897,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141897,32.87,0.32,37.5,68591,85,NULL,'I, inv','ESO 070- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141898,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141898,32.88,0.32,37.7,68591,85,NULL,'I, raw','ESO 070- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141899,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141899,32.97,0.43,39.3,68591,75,NULL,'MAT, I, inv','ESO 070- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141900,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141900,32.98,0.43,39.5,68591,75,NULL,'MAT, I, raw','ESO 070- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141901,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141901,33.31,0.43,46,68591,75,NULL,'MAT, I, cor','ESO 070- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141902,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141902,34.88,0.4,94.8,68592,NULL,NULL,'mean','UGC 10984',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00005,NULL,'14.86',0.6,'SBab:',NULL,NULL,NULL,NULL,1,266.664833333,51.28136,0.137,NULL,57507950702,898561729,14040027,14.86),(141903,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141903,35.22,0.47,111,68592,NULL,NULL,'H','UGC 10984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141904,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141904,36.37,0.74,188,68593,70,NULL,NULL,'2MASX J17464380-7808327',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,266.682417,-78.1425,0.469,NULL,44124922387,689451912,10772686,16.9),(141905,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141905,33.94,0.55,61.3,68594,70,NULL,NULL,'ESO 139- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.99',0.9,'SB(s)0^0^: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,266.711708333,-59.25839,0.393,NULL,44458725498,694667585,10854181,13.99),(141906,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141906,34.67,0.49,86,68595,75,NULL,'IR','UGC 10986',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',NULL,NULL,'17.',0.1,'Scd',NULL,NULL,NULL,NULL,1,266.718375,57.06761,0.157,NULL,57684000196,901312503,14083007,17),(141907,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141907,34.68,NULL,86.5,68595,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 10986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141908,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141908,34.7,NULL,87,68595,NULL,NULL,'Dipole + Quadrupole','UGC 10986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141909,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141909,34.71,NULL,87.4,68595,NULL,NULL,'Dipole','UGC 10986',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141910,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141910,34.75,NULL,89,68595,NULL,NULL,NULL,'UGC 10986',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141911,'Brightest Stars','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141911,26.8,NULL,2.3,68596,NULL,NULL,NULL,'IC 4662',NULL,'1990A&A...234...99H',1990,1,2.8,'The 2MASS positions apply to HII regions northeast of the center.','G',0.00001,NULL,'11.7B',1.6,'IBm','Field galaxy',NULL,NULL,NULL,1,266.786958333,-64.64175,0.265,0,44441034186,694391159,10849861,11.7),(141912,'CMD','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141912,26.75,0.04,2.24,68596,NULL,NULL,'LSB','IC 4662',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141913,'CMD','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141913,26.8,0.04,2.29,68596,NULL,NULL,NULL,'IC 4662',NULL,'2009ApJ...695..561M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141914,'CMD','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141914,26.8,0.04,2.29,68596,NULL,NULL,'HSB','IC 4662',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141915,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141915,26.82,0.1,2.31,68596,NULL,NULL,NULL,'IC 4662',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141916,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141916,26.94,NULL,2.44,68596,NULL,NULL,NULL,'IC 4662',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141917,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141917,27,0.02,2.51,68596,NULL,NULL,'I','IC 4662',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141918,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141918,27.03,0.1,2.55,68596,74.4,NULL,NULL,'IC 4662',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141919,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141919,27.38,0.4,3,68596,75,NULL,'B','IC 4662',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141920,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141920,35.62,0.34,133,68597,NULL,NULL,'Malmquist cor.','UGC 10981',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000007,NULL,'14.98',0.5,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,266.914125,9.54714,0.629,NULL,56083587148,876306049,13692282,14.98),(141921,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141921,35.92,0.2,153,68597,74.4,NULL,NULL,'UGC 10981',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141922,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141922,35.95,0.29,155,68597,NULL,NULL,NULL,'UGC 10981',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141923,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141923,35.82,0.53,146,68598,70,NULL,NULL,'2MASX J17474656-6517445',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,266.944167,-65.29569,0.257,NULL,44441473597,694398024,10849969,14.3),(141924,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141924,34.78,0.49,90.6,68599,75,NULL,'IR','FGC 2156',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.000007,NULL,'16.2',0.12,'Sbc',NULL,NULL,NULL,NULL,1,266.956333333,5.80694,0.585,NULL,55856812885,872762701,13636917,16.2),(141925,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141925,35.78,NULL,143,68599,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141926,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141926,35.78,NULL,144,68599,NULL,NULL,'Dipole + Quadrupole','FGC 2156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141927,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141927,35.81,NULL,145,68599,NULL,NULL,'Dipole','FGC 2156',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141928,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141928,35.81,NULL,145,68599,NULL,NULL,NULL,'FGC 2156',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141929,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141929,31.07,0.4,16.4,68600,75,NULL,NULL,'UGC 10985',NULL,'2008Ap.....51..336K',2008,1,1.3,NULL,'G',0.000017,NULL,'13.78',0.9,'SB(s)dm',NULL,NULL,NULL,NULL,1,267.0185417,14.74147,0.333,NULL,55966770838,874480794,13663762,13.78),(141930,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141930,31.89,0.49,23.9,68600,75,NULL,'IR','UGC 10985',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141931,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141931,34.9,0.49,95.5,68601,75,NULL,'IR','FGC 2161',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',NULL,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,267.048,53.15242,0.141,NULL,57474874749,898044917,14031951,16.5),(141932,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141932,34.95,NULL,97.6,68601,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141933,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141933,34.96,NULL,98.3,68601,NULL,NULL,'Dipole + Quadrupole','FGC 2161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141934,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141934,34.98,NULL,99,68601,NULL,NULL,'Dipole','FGC 2161',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141935,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141935,35.01,NULL,100,68601,NULL,NULL,NULL,'FGC 2161',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141936,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141936,37.35,0.81,295,68602,70,NULL,NULL,'2MASX J17483432-6429202',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,267.142875,-64.48906,0.265,NULL,44441057860,694391529,10849867,14.1),(141937,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141937,37,0.61,251,68603,70,NULL,NULL,'2MASX J17483481-6807311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.14525,-68.12533,0.397,NULL,44963549010,702555453,10977428,15.6),(141938,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141938,36.27,0.81,180,68604,70,NULL,NULL,'2MASX J17483658-6625421',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.1525,-66.42833,0.269,NULL,44430151934,694221123,10847205,15.3),(141939,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141939,34.78,0.8,90.3,68605,75,NULL,'CF, r','NGC 6478',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.99',0.7,'SAc:',NULL,NULL,NULL,NULL,1,267.1597917,51.15725,0.173,NULL,57507866346,898560411,14040006,13.99),(141940,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141940,34.09,0.47,65.9,68605,NULL,NULL,'H','NGC 6478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141941,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141941,34.13,0.46,67.1,68605,NULL,NULL,'J','NGC 6478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141942,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141942,34.19,0.45,69,68605,NULL,NULL,'K','NGC 6478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141943,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141943,34.38,0.38,75.2,68605,75,NULL,'CF, r, raw','NGC 6478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141944,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141944,34.61,0.38,83.5,68605,75,NULL,'CF, r, inv','NGC 6478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141945,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141945,34.65,0.2,85.1,68605,74.4,NULL,NULL,'NGC 6478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141946,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141946,34.66,0.38,85.3,68605,75,NULL,'CF, r, cor','NGC 6478',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141947,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141947,34.68,0.42,86.5,68605,NULL,NULL,'Malmquist cor.','NGC 6478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141948,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141948,34.69,0.4,86.7,68605,NULL,NULL,'mean','NGC 6478',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141949,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141949,34.77,0.4,89.9,68605,NULL,NULL,NULL,'NGC 6478',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141950,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141950,35.8,0.49,144,68606,70,NULL,NULL,'2MASX J17485422-6243302',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000073,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,267.225875,-62.72506,0.341,NULL,44485335711,695083370,10860677,16.1),(141951,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141951,35.21,NULL,110,68607,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2165',NULL,'2010Ap&SS.325..163P',2010,1,0.72,NULL,'G',NULL,NULL,'16.9',0.09,'Sd',NULL,NULL,NULL,NULL,1,267.237083,66.71733,0.153,NULL,57516141990,898689718,14042026,16.9),(141952,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141952,35.23,NULL,111,68607,NULL,NULL,'Dipole + Quadrupole','FGC 2165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141953,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141953,35.25,NULL,112,68607,NULL,NULL,'Dipole','FGC 2165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141954,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141954,35.26,NULL,113,68607,NULL,NULL,NULL,'FGC 2165',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141955,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141955,34.12,0.8,66.7,68608,75,NULL,'MAT, I','IC 4664',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000027,NULL,'13.64',1,'(R\')SAB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,267.244125,-63.25453,0.329,NULL,44434192321,694284255,10848191,13.64),(141956,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141956,33.04,0.32,40.6,68608,85,NULL,'I, raw','IC 4664',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141957,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141957,33.09,0.32,41.4,68608,85,NULL,'I, inv','IC 4664',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141958,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141958,33.09,0.47,41.5,68608,NULL,NULL,'H','IC 4664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141959,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141959,33.22,0.45,44.1,68608,NULL,NULL,'K','IC 4664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141960,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141960,33.26,0.46,44.8,68608,NULL,NULL,'J','IC 4664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141961,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141961,33.3,0.43,45.8,68608,75,NULL,'MAT, I, raw','IC 4664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141962,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141962,33.34,0.61,46.5,68608,NULL,NULL,NULL,'IC 4664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141963,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141963,33.38,0.2,47.4,68608,74.4,NULL,NULL,'IC 4664',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141964,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141964,33.53,0.43,50.9,68608,75,NULL,'MAT, I, inv','IC 4664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141965,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141965,33.63,0.43,53.3,68608,75,NULL,'MAT, I, cor','IC 4664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141966,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141966,33.73,0.51,55.7,68608,NULL,NULL,'Malmquist cor.','IC 4664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141967,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141967,33.96,0.4,62.1,68608,NULL,NULL,'mean','IC 4664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141968,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141968,36.8,0.77,229,68609,70,NULL,NULL,'2MASX J17492336-6603570',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.347333,-66.06589,0.249,NULL,44429397534,694209336,10847020,15.2),(141969,'Brightest Stars','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141969,28.57,NULL,5.2,68610,NULL,NULL,'blue','NGC 6503',NULL,'1997A&A...324..457K',1997,1,7.1,NULL,'G',0.000003,NULL,'10.91',2.4,'SA(s)cd    HII/LINER','Possible group member',NULL,NULL,NULL,1,267.360125,70.14436,0.137,NULL,57044027496,891312929,13926764,10.91),(141970,'Brightest Stars','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141970,28.7,0.2,5.5,68610,NULL,NULL,'red','NGC 6503',NULL,'1997A&A...324..457K',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141971,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141971,28.61,0.23,5.27,68610,NULL,NULL,NULL,'NGC 6503',NULL,'2003A&A...398..479K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141972,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141972,28.98,0.1,6.25,68610,74.4,NULL,NULL,'NGC 6503',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141973,'TRGB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141973,29,0.03,6.3,68610,NULL,NULL,NULL,'NGC 6503',NULL,'2014AstL...40..537T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141974,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141974,28.85,NULL,5.89,68610,NULL,NULL,'LEDA [April 2006]','NGC 6503',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141975,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141975,28.92,0.4,6.1,68610,75,NULL,'B','NGC 6503',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141976,'Tully est','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141976,30.8,0.8,14.5,68611,75,NULL,'B','UGC 11000',NULL,'1988NBGC.C....0000T',1988,1,0.7,NULL,'G',0.000007,NULL,'14.4',0.4,'S?',NULL,NULL,NULL,NULL,1,267.3610417,36.14522,0.129,NULL,56153143899,877392873,13709263,14.4),(141977,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141977,32.22,0.2,27.8,68611,74.4,NULL,NULL,'UGC 11000',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141978,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141978,33.3,0.8,45.8,68612,75,NULL,'CF, r','NGC 6460',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'13.80',1.1,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,267.3765,20.76367,0.477,NULL,56777241116,887144392,13861631,13.8),(141979,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141979,32.65,0.69,33.8,68612,100,NULL,'mid-IR','NGC 6460',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141980,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141980,33.23,0.43,44.2,68612,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6460',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141981,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141981,33.26,0.43,44.8,68612,75,NULL,'3.6 micron, color corrected','NGC 6460',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141982,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141982,33.32,0.2,46.1,68612,74.4,NULL,NULL,'NGC 6460',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141983,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141983,33.58,0.38,52.1,68612,75,NULL,'CF, r, raw','NGC 6460',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141984,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141984,33.71,0.38,55.3,68612,75,NULL,'CF, r, inv','NGC 6460',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141985,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141985,33.72,0.4,55.4,68612,NULL,NULL,'mean','NGC 6460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141986,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141986,33.84,0.38,58.6,68612,75,NULL,'CF, r, cor','NGC 6460',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141987,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141987,34.21,0.47,69.5,68612,NULL,NULL,'H','NGC 6460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141988,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141988,34.23,0.45,70.2,68612,NULL,NULL,'K','NGC 6460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141989,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141989,34.23,0.46,70.3,68612,NULL,NULL,'J','NGC 6460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141990,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',141990,33.11,0.49,42,68613,75,NULL,'IR','ESO 139- G 030',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.0b',0.2,'S...',NULL,NULL,NULL,NULL,1,267.383875,-62.4995,0.361,NULL,44485522388,695086287,10860723,16),(141991,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141991,34.23,0.11,70.3,68613,NULL,NULL,NULL,'ESO 139- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141992,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141992,37.09,0.53,262,68614,70,NULL,NULL,'2MASX J17495711-6527221',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,267.487833333,-65.45608,0.257,NULL,44441385044,694396641,10849947,13.8),(141993,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141993,37.52,0.74,319,68615,70,NULL,NULL,'2MASX J17500047-5452378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.502,-54.87725,0.541,NULL,44328781041,692637203,10822456,15.8),(141994,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141994,34.22,0.45,69.9,68616,NULL,NULL,'K','NGC 6491',NULL,'2007A&A...465...71T',2007,1,1.2,'UZC has V = 6212 +- 53 km/sec.','G',0.000057,NULL,'14.53',0.5,'Sab','in a pair',NULL,NULL,NULL,1,267.502917,61.53178,0.149,NULL,57550350806,899224231,14050378,14.53),(141995,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141995,34.23,0.47,70.1,68616,NULL,NULL,'H','NGC 6491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141996,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141996,34.31,0.46,72.9,68616,NULL,NULL,'J','NGC 6491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141997,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141997,34.32,0.4,73.2,68616,NULL,NULL,'mean','NGC 6491',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(141998,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141998,33.78,0.43,57.1,68617,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11001',NULL,'2014MNRAS.444..527S',2014,1,1.3,'HOLM 771B is a star.','G',0.000023,NULL,'14.39',0.5,'Sdm:',NULL,NULL,NULL,NULL,1,267.556833333,14.28756,0.357,NULL,55940587822,874071684,13657370,14.39),(141999,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,141999,33.72,0.47,55.4,68618,NULL,NULL,'H','KUG 1748+144',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000043,NULL,'14.7',0.2,'Sc',NULL,NULL,NULL,NULL,1,267.6204583,14.39447,0.345,NULL,55940688571,874073258,13657394,14.7),(142000,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142000,33.75,0.45,56.3,68618,NULL,NULL,'K','KUG 1748+144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142001,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142001,33.83,0.4,58.3,68618,NULL,NULL,'mean','KUG 1748+144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142002,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142002,33.84,0.46,58.7,68618,NULL,NULL,'J','KUG 1748+144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142003,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142003,32.47,0.69,31.1,68619,100,NULL,'mid-IR','NGC 6467',NULL,'2013ApJ...771...88L',2013,1,2.6,'HOLM 772B does not exist (it is probably a plate defect).','G',0.000004,NULL,'13.5',1.7,'S','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,267.667333,17.53778,0.337,NULL,55912313210,873629893,13650467,13.5),(142004,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142004,33.26,0.43,44.9,68619,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6467',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142005,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142005,33.15,0.43,42.7,68620,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11003',NULL,'2014MNRAS.444..527S',2014,1,1.29,NULL,'G',0.00001,NULL,'15.40',0.17,'Sbc',NULL,NULL,NULL,NULL,1,267.674375,14.82175,0.301,NULL,55958387573,874349805,13661715,15.4),(142006,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142006,33.45,0.49,49,68620,75,NULL,'IR','UGC 11003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142007,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142007,34.36,NULL,74.3,68620,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142008,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142008,34.36,NULL,74.6,68620,NULL,NULL,'Dipole + Quadrupole','UGC 11003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142009,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142009,34.38,NULL,75,68620,NULL,NULL,'Dipole','UGC 11003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142010,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142010,34.41,NULL,76.4,68620,NULL,NULL,NULL,'UGC 11003',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142011,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142011,36.34,0.57,185,68621,70,NULL,NULL,'2MASX J17505621-6922590',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,267.734375,-69.383,0.173,NULL,44094645427,688978834,10765294,15.7),(142012,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142012,41.49,NULL,1510,68622,NULL,NULL,NULL,'[HB89] 1749+096',0.322,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.78',NULL,'Opt.var.;HPQ   BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,267.88675,9.65019,0.613,NULL,56071913016,876123640,13689431,16.78),(142013,'Sosies','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142013,33.98,0.79,62.5,68623,NULL,NULL,NULL,'NGC 6484',NULL,'2002A&A...393...57T',2002,1,1.9,NULL,'G',0.00002,NULL,'13.11',1.9,'SBbc','in a triple',NULL,NULL,NULL,1,267.94575,24.48347,0.353,NULL,56253155324,878955551,13733680,13.11),(142014,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142014,33.48,0.43,49.6,68623,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6484',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142015,'Faber-Jackson','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142015,34.61,1.31,83.6,68624,95,NULL,'Weighted Mean','NGC 6482',NULL,'1984ApJS...56...91D',1984,1,2,NULL,'G',0.000058,NULL,'12.35',1.7,'E:             LINER','in a pair',NULL,NULL,NULL,1,267.953375,23.07194,0.425,NULL,56239785792,878746653,13730416,12.35),(142016,'Faber-Jackson','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142016,36.67,1.61,216,68624,55,NULL,'Visvanathan & Sandage 1979','NGC 6482',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142017,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142017,33.8,0.45,57.6,68624,NULL,NULL,'K','NGC 6482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142018,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142018,33.83,0.4,58.4,68624,NULL,NULL,'mean','NGC 6482',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142019,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142019,34.45,0.47,77.8,68625,NULL,NULL,'H','IC 1269',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00002,NULL,'13.40',1.3,'SA(sr)c pec I','Isolated galaxy',NULL,NULL,NULL,1,268.025,21.56964,0.533,NULL,56777671405,887151115,13861736,13.4),(142020,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142020,34.59,0.46,82.8,68625,NULL,NULL,'J','IC 1269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142021,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142021,34.64,0.45,84.9,68625,NULL,NULL,'K','IC 1269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142022,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142022,34.69,0.4,86.8,68625,NULL,NULL,'mean','IC 1269',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142023,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142023,34.48,0.2,78.7,68626,74.4,NULL,NULL,'UGC 11016',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'15.43',0.3,'Scd:',NULL,NULL,NULL,NULL,1,268.0279583,28.90528,0.253,NULL,56264843649,879138182,13736534,15.43),(142024,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142024,34.51,0.45,79.6,68626,NULL,NULL,NULL,'UGC 11016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142025,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142025,34.52,0.45,80.2,68626,NULL,NULL,'Malmquist cor.','UGC 11016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142026,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142026,36.19,0.92,173,68627,70,NULL,NULL,'2MFGC 14085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,268.046333333,-80.62172,0.557,NULL,44042788556,688168571,10752633,16.8),(142027,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142027,36.41,0.56,191,68628,70,NULL,NULL,'2MASX J17522165-6529472',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,268.0902083,-65.49647,0.261,NULL,44427549858,694180466,10846569,15),(142028,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142028,34.45,0.4,77.5,68629,NULL,NULL,'mean','UGC 11021',NULL,'2007A&A...465...71T',2007,1,1.46,NULL,'G',0.000012,NULL,'15.74',0.19,'Sb',NULL,NULL,NULL,NULL,1,268.1644583,29.059,0.273,NULL,56265278905,879144982,13736640,15.74),(142029,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142029,34.5,0.43,79.4,68629,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142030,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142030,34.69,0.43,86.7,68629,75,NULL,'3.6 micron, color corrected','UGC 11021',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142031,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142031,34.71,0.47,87.6,68629,NULL,NULL,'H','UGC 11021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142032,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142032,34.75,0.45,89.3,68629,NULL,NULL,'K','UGC 11021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142033,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142033,34.8,0.49,91.3,68629,75,NULL,'IR','UGC 11021',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142034,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142034,34.9,0.39,95.7,68629,NULL,NULL,'Malmquist cor.','UGC 11021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142035,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142035,34.96,0.2,98.2,68629,74.4,NULL,NULL,'UGC 11021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142036,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142036,35.01,NULL,101,68629,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142037,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142037,35.03,NULL,101,68629,NULL,NULL,'Dipole','UGC 11021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142038,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142038,35.03,NULL,101,68629,NULL,NULL,'Dipole + Quadrupole','UGC 11021',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142039,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142039,35.06,0.36,103,68629,NULL,NULL,NULL,'UGC 11021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142040,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142040,35.08,NULL,104,68629,NULL,NULL,NULL,'UGC 11021',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142041,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142041,35.36,0.4,118,68630,NULL,NULL,'mean','NGC 6487',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00009,NULL,'12.9',1.7,'E','Group member',NULL,NULL,NULL,1,268.174375,29.83864,0.249,NULL,56270274141,879223033,13737859,12.9),(142042,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142042,35.43,0.45,122,68630,NULL,NULL,'K','NGC 6487',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142043,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142043,36.58,0.69,207,68631,70,NULL,NULL,'2MASX J17525261-6523492',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,268.21925,-65.39708,0.261,NULL,44428038806,694188106,10846689,15.8),(142044,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142044,33.58,0.49,51.9,68632,75,NULL,'IR','UGC 11024',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000193,NULL,'15.0',0.35,'S?',NULL,NULL,NULL,NULL,1,268.2270417,23.21106,0.485,NULL,56239718283,878745598,13730399,15),(142045,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142045,36.7,0.56,219,68633,70,NULL,NULL,'2MASX J17525463-7141414',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,268.227333333,-71.69481,0.381,NULL,44102656148,689104002,10767250,15),(142046,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142046,33.84,0.2,58.6,68634,74.4,NULL,NULL,'UGC 11036',NULL,'2013AJ....146...86T',2013,1,1.79,'Multiple SDSS entries describe this object.','G',0.000023,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,268.403167,58.35017,0.165,NULL,57547240403,899175631,14049619,16.5),(142047,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142047,33.92,NULL,60.9,68634,NULL,NULL,NULL,'UGC 11036',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142048,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142048,34.11,NULL,66.5,68634,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142049,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142049,34.13,NULL,66.8,68634,NULL,NULL,'Dipole','UGC 11036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142050,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142050,34.13,NULL,66.9,68634,NULL,NULL,'Dipole + Quadrupole','UGC 11036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142051,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142051,34.39,0.49,75.4,68634,75,NULL,'IR','UGC 11036',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142052,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142052,31.52,NULL,20.1,68635,72,NULL,NULL,'UGC 11030',NULL,'2014Ap.....57..457K',2014,1,1.7,NULL,'G',0.000013,NULL,'14.3',0.4,'Sc:',NULL,NULL,NULL,NULL,1,268.639833333,2.87919,0.845,NULL,55841916581,872529946,13633280,14.3),(142053,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142053,32.22,0.4,27.8,68635,75,NULL,NULL,'UGC 11030',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142054,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142054,32.37,0.49,29.9,68635,75,NULL,'IR','UGC 11030',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142055,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142055,36.33,0.82,185,68636,70,NULL,NULL,'2MASX J17544249-6911080',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,268.6769583,-69.18564,0.273,NULL,44094155853,688971185,10765174,17.1),(142056,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142056,34.77,0.25,90,68637,74.4,NULL,NULL,'NGC 6512',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00007,NULL,'14.9',0.25,'E/S0','Group member',NULL,NULL,NULL,1,268.709625,62.64508,0.177,NULL,57521586601,898774790,14043356,14.9),(142057,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142057,34.96,0.32,98.1,68637,70,NULL,NULL,'NGC 6512',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142058,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142058,35.25,0.4,112,68637,NULL,NULL,'mean','NGC 6512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142059,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142059,35.43,0.45,122,68637,NULL,NULL,'K','NGC 6512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142060,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142060,32.93,0.09,38.6,68638,74.4,NULL,NULL,'NGC 6495',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.00006,NULL,'13.16',1.8,'E','Group member',NULL,NULL,NULL,1,268.7115,18.32692,0.369,NULL,55913258270,873644660,13650697,13.16),(142061,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142061,33.1,0.05,41.2,68638,72,NULL,NULL,'NGC 6495',0.01043,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142062,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142062,33.17,0.2,42.6,68638,72,NULL,NULL,'NGC 6495',0.01043,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142063,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142063,33.18,0.29,42.7,68638,65,NULL,'MLCS17','NGC 6495',0.01043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142064,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142064,33.21,0.32,43.2,68638,65,NULL,NULL,'NGC 6495',0.01043,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142065,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142065,33.27,0.29,44.6,68638,65,NULL,'MLCS31','NGC 6495',0.01043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142066,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142066,33.3,0.08,44.9,68638,65,NULL,'MLCS2k2','NGC 6495',0.01043,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142067,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142067,33.36,0.26,46.6,68638,70,NULL,'SALT 2','NGC 6495',0.01043,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142068,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142068,33.45,0.23,48.5,68638,73.8,NULL,'SALT 2 (SNANA)','NGC 6495',0.0106,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142069,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 1998bp',NULL,142069,33.51,0.34,49.8,68638,70,NULL,'SALT','NGC 6495',0.01043,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142070,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142070,33.16,0.15,42.9,68638,NULL,NULL,'I','NGC 6495',NULL,'2001ApJ...559..584A',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142071,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142071,33.44,0.69,48.8,68639,100,NULL,'mid-IR','UGC 11041',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000067,NULL,'14.1',0.7,'Sab        HII;LIRG',NULL,NULL,NULL,NULL,1,268.715917,34.77622,0.157,NULL,56140724692,877198823,13706231,14.1),(142072,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142072,34.06,0.43,64.8,68639,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142073,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142073,34.34,0.43,73.8,68639,75,NULL,'3.6 micron, color corrected','UGC 11041',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142074,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142074,34.35,0.4,74.2,68639,NULL,NULL,'mean','UGC 11041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142075,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142075,34.41,0.45,76.3,68639,NULL,NULL,'K','UGC 11041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142076,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142076,34.5,0.47,79.4,68639,NULL,NULL,'H','UGC 11041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142077,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142077,34.61,0.46,83.5,68639,NULL,NULL,'J','UGC 11041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142078,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142078,34.7,0.2,87.1,68639,74.4,NULL,NULL,'UGC 11041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142079,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142079,35.97,0.51,157,68640,70,NULL,NULL,'2MASX J17550541-6905592',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,268.7724583,-69.09972,0.297,NULL,44094179987,688971562,10765180,14.7),(142080,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142080,34.64,0.49,84.9,68641,75,NULL,'IR','ESO 181- G 007',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'13.90',0.2,'Sbc',NULL,NULL,NULL,NULL,1,268.818791667,-55.90314,0.425,NULL,44326318823,692598731,10821855,13.9),(142081,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142081,34.8,0.58,91,68641,NULL,NULL,'Malmquist cor.','ESO 181- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142082,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142082,35.04,0.52,102,68641,NULL,NULL,NULL,'ESO 181- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142083,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142083,35.08,0.2,104,68641,74.4,NULL,NULL,'ESO 181- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142084,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142084,34.76,0.25,89.5,68642,74.4,NULL,NULL,'GIN 647',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00006,NULL,'15.20',NULL,'S',NULL,NULL,NULL,NULL,1,268.845625,62.65828,0.177,NULL,57521677028,898776203,14043378,15.2),(142085,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142085,34.96,0.32,98.1,68642,70,NULL,NULL,'GIN 647',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142086,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142086,34.14,0.49,67.4,68643,75,NULL,'IR','UGC 11050',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',NULL,NULL,'15.57',0.22,'Sbc',NULL,NULL,NULL,NULL,1,268.929917,34.58656,0.205,NULL,56140053287,877188332,13706067,15.57),(142087,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142087,34.22,0.2,69.8,68643,74.4,NULL,NULL,'UGC 11050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142088,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142088,34.22,NULL,69.9,68643,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142089,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142089,34.23,NULL,70.2,68643,NULL,NULL,'Dipole','UGC 11050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142090,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142090,34.23,NULL,70.3,68643,NULL,NULL,'Dipole + Quadrupole','UGC 11050',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142091,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142091,34.24,0.43,70.4,68643,75,NULL,'3.6 micron, color corrected','UGC 11050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142092,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142092,34.32,0.43,73,68643,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142093,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142093,34.33,0.45,73.5,68643,NULL,NULL,NULL,'UGC 11050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142094,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142094,34.45,0.42,77.6,68643,NULL,NULL,'Malmquist cor.','UGC 11050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142095,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142095,34.77,0.25,90,68644,74.4,NULL,NULL,'NGC 6521',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000077,NULL,'13.95',1.3,'cD;E;LINER     Sy1.9','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,268.951833333,62.61225,0.177,NULL,57521678231,898776222,14043378,13.95),(142096,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142096,34.96,0.32,98.1,68644,70,NULL,NULL,'NGC 6521',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142097,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142097,34.68,0.45,86.2,68644,NULL,NULL,'K','NGC 6521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142098,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142098,35.24,0.4,112,68644,NULL,NULL,'mean','NGC 6521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142099,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142099,36.52,0.47,202,68645,NULL,NULL,'Malmquist cor.','2MASX J17555279+6903017',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.51',NULL,'Sc',NULL,NULL,NULL,NULL,1,268.969917,69.05044,0.165,NULL,57046421701,891350339,13927349,15.51),(142100,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142100,36.71,0.43,220,68645,NULL,NULL,NULL,'2MASX J17555279+6903017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142101,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142101,36.75,0.2,224,68645,74.4,NULL,NULL,'2MASX J17555279+6903017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142102,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142102,33.61,0.4,52.7,68646,NULL,NULL,'mean','NGC 6500',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000017,NULL,'13.05',1.6,'SAab:          LINER','Pair member (points to parent)',NULL,NULL,'Flat-Spectrum Radio Source',1,268.999083,18.33825,0.369,NULL,55911487858,873616997,13650265,13.05),(142103,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142103,34.12,0.47,66.8,68646,NULL,NULL,'H','NGC 6500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142104,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142104,34.14,0.46,67.4,68646,NULL,NULL,'J','NGC 6500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142105,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142105,34.16,0.45,67.8,68646,NULL,NULL,'K','NGC 6500',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142106,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142106,33.5,0.4,50.1,68647,NULL,NULL,'mean','NGC 6501',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000037,NULL,'13.03',1.8,'SA0+:','Pair member (points to parent)',NULL,NULL,NULL,1,269.015583,18.37308,0.389,NULL,55911486740,873616980,13650265,13.03),(142107,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142107,33.8,0.45,57.5,68647,NULL,NULL,'K','NGC 6501',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142108,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142108,37.34,0.85,293,68648,NULL,NULL,'Malmquist cor.','AGC 270370',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000033,NULL,'16.85',NULL,'Sc',NULL,NULL,NULL,NULL,1,269.0675417,69.04986,0.165,NULL,57046254540,891347727,13927308,16.85),(142109,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142109,37.63,0.74,336,68648,NULL,NULL,NULL,'AGC 270370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142110,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142110,37.68,0.2,344,68648,74.4,NULL,NULL,'AGC 270370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142111,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142111,34.6,0.54,83.2,68649,70,NULL,NULL,'2MASX J17562452-5755125',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,269.10225,-57.92017,0.377,NULL,44446475324,694476176,10851190,14.5),(142112,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142112,34.31,0.4,72.8,68650,NULL,NULL,'mean','UGC 11058',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000017,NULL,'13.29',1.1,'SB(s)b','Isolated galaxy',NULL,NULL,NULL,1,269.2292917,32.63661,0.205,NULL,56254851286,878982051,13734094,13.29),(142113,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142113,34.35,0.47,74.3,68650,NULL,NULL,'H','UGC 11058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142114,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142114,34.45,0.45,77.6,68650,NULL,NULL,'K','UGC 11058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142115,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142115,34.47,0.46,78.4,68650,NULL,NULL,'J','UGC 11058',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142116,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142116,32.93,0.43,38.5,68651,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11055',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000067,NULL,'14.37',0.7,'SB?;HSB','Pair member (points to parent)',NULL,NULL,NULL,1,269.269583,12.23983,0.573,NULL,55939078204,874048096,13657001,14.37),(142117,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142117,33.14,0.4,42.6,68651,NULL,NULL,'mean','UGC 11055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142118,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142118,33.43,0.47,48.5,68651,NULL,NULL,'H','UGC 11055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142119,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142119,33.52,0.45,50.5,68651,NULL,NULL,'K','UGC 11055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142120,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142120,33.54,0.46,51.2,68651,NULL,NULL,'J','UGC 11055',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142121,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142121,34.08,0.43,65.6,68652,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11060',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000097,NULL,'14.89',0.4,'Sa',NULL,NULL,NULL,NULL,1,269.294333333,27.96139,0.257,NULL,56296158749,879627480,13744179,14.89),(142122,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142122,34.14,0.43,67.3,68652,75,NULL,'3.6 micron, color corrected','UGC 11060',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142123,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142123,34.29,0.2,72.1,68652,74.4,NULL,NULL,'UGC 11060',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142124,'BL Lac Luminosity','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142124,41.7,NULL,1560,68653,NULL,NULL,NULL,'NEP 3580',0.407,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.003,NULL,'18.27',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,269.304167,70.56044,0.157,NULL,57048865301,891388520,13927945,18.27),(142125,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142125,31.85,0.2,23.4,68654,74.4,NULL,NULL,'UGC 11057',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.00001,NULL,'13.56',0.8,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,269.3122083,12.17947,0.613,NULL,55939093126,874048330,13657005,13.56),(142126,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142126,32.38,0.69,29.9,68654,100,NULL,'mid-IR','UGC 11057',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142127,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142127,32.68,0.46,34.4,68654,NULL,NULL,'J','UGC 11057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142128,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142128,32.72,0.47,35.1,68654,NULL,NULL,'H','UGC 11057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142129,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142129,32.76,0.45,35.6,68654,NULL,NULL,'K','UGC 11057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142130,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142130,33.02,0.4,40.2,68654,NULL,NULL,'mean','UGC 11057',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142131,'GRB','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142131,47.58,1.54,12600,68655,NULL,NULL,NULL,'GRB 090418A',1.608,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,269.3132083,33.40592,0.209,NULL,56321307659,880020432,13750319,NULL),(142132,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142132,32.84,NULL,37,68656,NULL,NULL,NULL,'UGC 11059',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.000013,NULL,'15.7',0.19,'Sb',NULL,NULL,NULL,NULL,1,269.380833,11.73253,0.613,NULL,55936263297,874004114,13656314,15.7),(142133,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142133,32.96,NULL,39.2,68656,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142134,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142134,32.98,NULL,39.5,68656,NULL,NULL,'Dipole + Quadrupole','UGC 11059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142135,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142135,32.99,NULL,39.6,68656,NULL,NULL,'Dipole','UGC 11059',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142136,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142136,35.53,0.6,128,68657,70,NULL,NULL,'2MASX J17573784-8111006',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,269.407625,-81.18344,0.593,NULL,44042397114,688162454,10752538,16.7),(142137,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142137,34.35,0.23,72.4,68658,74.2,NULL,'SALT 2','UGC 11064',0.02349,'2010ApJ...716..712A',2010,1,1.9,NULL,'G',0.000033,NULL,'13.6',1.9,'Scd:',NULL,NULL,NULL,NULL,1,269.420916667,27.83472,0.257,NULL,56296102712,879626604,13744165,13.6),(142138,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142138,34.91,0.22,93.7,68658,72,NULL,NULL,'UGC 11064',0.02349,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142139,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142139,34.89,0.08,95.1,68658,74.4,NULL,NULL,'UGC 11064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142140,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142140,35.02,0.04,98.7,68658,72,NULL,NULL,'UGC 11064',0.02349,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142141,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142141,34.98,0.17,99.1,68658,70.8,NULL,NULL,'UGC 11064',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142142,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142142,35.05,0.17,99.8,68658,73.8,NULL,'SALT 2 (SNANA)','UGC 11064',0.0236,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142143,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142143,35.06,0.17,100,68658,65,NULL,'MLCS17','UGC 11064',0.02349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142144,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142144,35.06,0.17,100,68658,70,NULL,'SALT 2','UGC 11064',0.02349,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142145,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142145,35.08,0.11,101,68658,65,NULL,'SALT2','UGC 11064',0.02349,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142146,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142146,35.1,0.17,102,68658,65,NULL,'MLCS31','UGC 11064',0.02349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142147,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142147,35.15,0.09,103,68658,65,NULL,'MLCS2k2','UGC 11064',0.02349,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142148,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142148,35.12,0.09,103,68658,65,NULL,'MLCS2k2','UGC 11064',0.02349,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142149,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142149,35.12,0.28,103,68658,70,NULL,'SALT','UGC 11064',0.02349,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142150,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142150,35.14,0.21,104,68658,65,NULL,NULL,'UGC 11064',0.02349,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142151,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142151,35.15,0.05,105,68658,65,NULL,'MLCS2k2','UGC 11064',0.02349,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142152,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142152,35.15,0.09,105,68658,70,NULL,NULL,'UGC 11064',0.02349,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142153,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142153,35.22,0.29,108,68658,65,NULL,'SALT','UGC 11064',0.02349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142154,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142154,35.28,0.21,111,68658,65,NULL,'SALT2','UGC 11064',0.02349,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142155,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142155,35.44,0.01,119,68658,65,NULL,'SALT','UGC 11064',0.02349,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142156,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142156,35.66,0.14,136,68658,60,NULL,NULL,'UGC 11064',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142157,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2000cn',NULL,142157,36.47,0.03,192,68658,70,NULL,'SALT 2','UGC 11064',0.02349,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142158,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142158,35.42,0.68,122,68659,70,NULL,NULL,'2MASX J17574806-6255575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,269.4502917,-62.93258,0.305,NULL,44430993761,694234277,10847410,14.8),(142159,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142159,37.19,0.58,274,68660,NULL,NULL,'Malmquist cor.','2MASX J17580251+6904262',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.92',NULL,'Sb',NULL,NULL,NULL,NULL,1,269.510541667,69.07397,0.185,NULL,57044160571,891315008,13926797,15.92),(142160,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142160,37.39,0.52,301,68660,NULL,NULL,NULL,'2MASX J17580251+6904262',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142161,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142161,37.44,0.2,308,68660,74.4,NULL,NULL,'2MASX J17580251+6904262',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142162,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142162,36.43,0.8,193,68661,NULL,NULL,'Malmquist cor.','CGCG 340-028',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000023,NULL,'15.4',0.2,'Irregular',NULL,NULL,NULL,NULL,1,269.512333,69.2915,0.173,NULL,57044348199,891317940,13926842,15.4),(142163,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142163,36.98,0.62,249,68661,NULL,NULL,NULL,'CGCG 340-028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142164,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142164,37.02,0.2,254,68661,74.4,NULL,NULL,'CGCG 340-028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142165,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142165,37.11,0.18,265,68661,70,NULL,'ABELL 2295b, BGC','CGCG 340-028',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142166,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142166,36.28,0.59,181,68662,70,NULL,NULL,'2MASX J17580320-5202355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,269.513375,-52.04325,0.601,NULL,44333036487,692703695,10823495,17.7),(142167,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142167,36.18,0.2,172,68663,74.4,NULL,NULL,'CGCG 340-029',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,269.572917,69.60667,0.157,NULL,57044443605,891319431,13926866,NULL),(142168,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142168,35.76,0.73,142,68664,NULL,NULL,'Malmquist cor.','CGCG 340-029 NED02',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',NULL,NULL,'13.6I',NULL,NULL,NULL,NULL,NULL,NULL,1,269.591625,69.61136,0.157,NULL,57044446765,891319480,13926866,13.6),(142169,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142169,36.14,0.61,169,68664,NULL,NULL,NULL,'CGCG 340-029 NED02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142170,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142170,37.11,0.18,265,68665,70,NULL,NULL,'ABELL 2295b',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',0.000274,NULL,NULL,NULL,'Medium compact [Zw]',NULL,NULL,NULL,NULL,1,269.6555,69.26522,0.173,NULL,57044346858,891317919,13926842,NULL),(142171,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142171,33.77,0.4,56.8,68666,75,NULL,'Edat, raw','ESO 139- G 045',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00015,NULL,'14.00',0.7,'SB(s)0^0^',NULL,NULL,NULL,NULL,1,269.6647917,-58.37161,0.381,NULL,44445867619,694466681,10851041,14),(142172,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142172,34.12,0.4,66.7,68666,75,NULL,'Edat, cor','ESO 139- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142173,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142173,33.98,0.53,62.5,68666,70,NULL,NULL,'ESO 139- G 045',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142174,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142174,34.09,0.4,65.6,68666,NULL,NULL,'mean','ESO 139- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142175,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142175,34.54,0.45,81,68666,NULL,NULL,'K','ESO 139- G 045',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142176,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142176,37.24,0.61,280,68667,NULL,NULL,'Malmquist cor.','AGC 270378',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.48',NULL,'Sc',NULL,NULL,NULL,NULL,1,269.705,69.09461,0.173,NULL,57044168895,891315138,13926799,16.48),(142177,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142177,37.45,0.56,309,68667,NULL,NULL,NULL,'AGC 270378',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142178,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142178,37.49,0.2,315,68667,74.4,NULL,NULL,'AGC 270378',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142179,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142179,35.04,0.8,102,68668,75,NULL,'CF, r','UGC 11076',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000113,NULL,'14.73',0.5,'Sbc',NULL,NULL,NULL,NULL,1,269.715708333,34.00592,0.241,NULL,56136813793,877137715,13705276,14.73),(142180,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142180,34.95,0.38,97.7,68668,75,NULL,'CF, r, raw','UGC 11076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142181,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142181,35.1,0.38,105,68668,75,NULL,'CF, r, cor','UGC 11076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142182,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142182,35.15,0.38,107,68668,75,NULL,'CF, r, inv','UGC 11076',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142183,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142183,35.18,0.4,109,68668,NULL,NULL,'mean','UGC 11076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142184,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142184,35.35,0.47,117,68668,NULL,NULL,'H','UGC 11076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142185,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142185,35.39,0.46,119,68668,NULL,NULL,'J','UGC 11076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142186,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142186,35.43,0.45,122,68668,NULL,NULL,'K','UGC 11076',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142187,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142187,34.12,0.69,66.6,68669,100,NULL,'mid-IR','UGC 11073',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000033,NULL,'14.4',0.7,'Sbc',NULL,NULL,NULL,NULL,1,269.747333,10.53914,0.581,NULL,55852230504,872691101,13635798,14.4),(142188,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142188,34.65,0.2,85.1,68669,74.4,NULL,NULL,'UGC 11073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142189,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142189,34.67,0.37,86.1,68669,NULL,NULL,'Malmquist cor.','UGC 11073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142190,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142190,34.71,0.4,87.4,68669,NULL,NULL,'mean','UGC 11073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142191,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142191,34.72,0.36,87.8,68669,NULL,NULL,NULL,'UGC 11073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142192,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142192,34.96,0.47,98.2,68669,NULL,NULL,'H','UGC 11073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142193,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142193,37.99,0.51,396,68670,NULL,NULL,'Malmquist cor.','AGC 270379',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.75',NULL,'Sc',NULL,NULL,NULL,NULL,1,269.751667,69.02844,0.185,NULL,57044121095,891314392,13926787,16.75),(142194,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142194,38.01,0.51,400,68670,NULL,NULL,NULL,'AGC 270379',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142195,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142195,38.05,0.2,407,68670,74.4,NULL,NULL,'AGC 270379',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142196,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142196,35.68,0.5,137,68671,70,NULL,NULL,'2MASX J17590736-6519572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,269.78075,-65.33258,0.265,NULL,44427261453,694175960,10846499,14.7),(142197,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142197,32.05,0.4,25.7,68672,NULL,NULL,NULL,'UGC 11074',NULL,'2009AJ....138..323T',2009,1,2.3,NULL,'G',0.000007,NULL,'13.9',1.1,'Sd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,269.780833,7.14139,0.817,NULL,55861357706,872833714,13638026,13.9),(142198,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142198,32.05,NULL,25.7,68672,72,NULL,NULL,'UGC 11074',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142199,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142199,32.33,0.4,29.3,68672,75,NULL,'B','UGC 11074',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142200,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142200,34.07,0.12,65.3,68673,NULL,NULL,NULL,'ESO 071- G 001',NULL,'2009ApJS..182..474S',2009,1,2.1,NULL,'G',0.000033,NULL,'16.56',1.1,'Sb: sp',NULL,NULL,NULL,NULL,1,269.7935,-67.93811,0.425,NULL,44090685590,688916962,10764327,16.56),(142201,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142201,34.79,0.49,90.9,68673,75,NULL,'IR','ESO 071- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142202,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142202,36.08,0.25,164,68674,74.4,NULL,NULL,'GIN 651',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000237,NULL,'15.58',NULL,'S',NULL,NULL,NULL,NULL,1,269.798,42.59153,0.093,NULL,56105214724,876643980,13697562,15.58),(142203,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142203,36.24,0.31,177,68674,70,NULL,NULL,'GIN 651',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142204,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142204,34.37,0.8,74.7,68675,75,NULL,'CF, r','NGC 6532',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00003,NULL,'14.60',0.9,'SAc',NULL,NULL,NULL,NULL,1,269.808125,56.23178,0.105,NULL,57680077865,901251216,14082050,14.6),(142205,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142205,34.02,0.38,63.6,68675,75,NULL,'CF, r, raw','NGC 6532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142206,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142206,34.12,0.38,66.8,68675,75,NULL,'CF, r, inv','NGC 6532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142207,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142207,34.25,0.2,70.8,68675,74.4,NULL,NULL,'NGC 6532',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142208,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142208,34.29,0.38,72.1,68675,75,NULL,'CF, r, cor','NGC 6532',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142209,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142209,34.38,0.44,75.3,68675,NULL,NULL,NULL,'NGC 6532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142210,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142210,34.41,0.44,76.1,68675,NULL,NULL,'Malmquist cor.','NGC 6532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142211,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142211,32.53,0.8,32.1,68676,75,NULL,'MAT, I','ESO 139- G 046',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.000023,NULL,'15.00',0.3,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,269.820416667,-59.50731,0.349,NULL,44452445070,694569454,10852647,15),(142212,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142212,31.96,0.32,24.7,68676,85,NULL,'I, inv','ESO 139- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142213,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142213,31.99,0.32,25,68676,85,NULL,'I, raw','ESO 139- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142214,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142214,32.1,0.4,26.3,68676,NULL,NULL,NULL,'ESO 139- G 046',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142215,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142215,32.1,0.4,26.3,68676,73,NULL,'opt','ESO 139- G 046',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142216,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142216,32.33,0.43,29.3,68676,75,NULL,'MAT, I, inv','ESO 139- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142217,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142217,32.37,0.43,29.7,68676,75,NULL,'MAT, I, raw','ESO 139- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142218,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142218,32.74,0.43,35.3,68676,75,NULL,'MAT, I, cor','ESO 139- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142219,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142219,33.55,0.49,51.3,68677,75,NULL,'IR','ESO 102- G 019',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.77',0.2,'Scd: sp',NULL,NULL,NULL,NULL,1,269.8475,-63.45833,0.309,NULL,44432676527,694260570,10847821,15.77),(142220,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142220,34.24,0.13,70.6,68677,NULL,NULL,NULL,'ESO 102- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142221,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142221,32.25,0.4,28.2,68678,75,NULL,'B','NGC 6509',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000001,NULL,'13.1',1.2,'SBcd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,269.8552917,6.28703,0.737,NULL,55860665489,872822898,13637857,13.1),(142222,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142222,32.7,NULL,34.6,68678,72,NULL,NULL,'NGC 6509',NULL,'2014Ap.....57..457K',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142223,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142223,36.08,0.25,164,68679,74.4,NULL,NULL,'CGCG 227-009 NED01',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000067,NULL,'14.14',NULL,'E/S0',NULL,NULL,NULL,NULL,1,269.8757083,42.51528,0.093,NULL,56105339910,876645936,13697592,14.14),(142224,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142224,36.24,0.31,177,68679,70,NULL,NULL,'CGCG 227-009 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142225,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142225,33.34,0.48,46.6,68680,NULL,NULL,NULL,'NGC 6483',NULL,'2001MNRAS.327.1004B',2001,1,1.5,NULL,'G',0.000067,NULL,'12.97',0.9,'E4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,269.878375,-63.66872,0.309,NULL,44432836888,694263076,10847860,12.97),(142226,'SBF','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142226,33.77,0.48,56.8,68680,NULL,NULL,'Malmquist cor.','NGC 6483',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142227,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142227,33.07,0.4,41.1,68680,75,NULL,'Edat, raw','NGC 6483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142228,'D-Sigma','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142228,33.4,0.4,47.9,68680,75,NULL,'Edat, cor','NGC 6483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142229,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142229,33.8,0.41,57.5,68680,NULL,NULL,NULL,'NGC 6483',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142230,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142230,34.03,0.41,63.9,68680,NULL,NULL,'Malmquist cor.','NGC 6483',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142231,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142231,33.86,0.45,59.1,68680,NULL,NULL,'K','NGC 6483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142232,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142232,33.98,0.4,62.6,68680,NULL,NULL,'mean','NGC 6483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142233,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142233,38.08,0.48,413,68681,NULL,NULL,'Malmquist cor.','2MASX J17594494+6911252',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000033,NULL,'15.83',NULL,'Sbc:',NULL,NULL,NULL,NULL,1,269.937333,69.19039,0.173,NULL,57044137024,891314641,13926791,15.83),(142234,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142234,38.11,0.47,418,68681,NULL,NULL,NULL,'2MASX J17594494+6911252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142235,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142235,38.15,0.2,427,68681,74.4,NULL,NULL,'2MASX J17594494+6911252',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142236,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142236,37.65,0.13,339,68682,70,NULL,NULL,'ABELL 2295',NULL,'1999AJ....118.1489D',1999,1,NULL,'Struble and Rood (1987ApJS...63..543S) give z=0.0508.','GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,269.982417,69.21681,0.173,NULL,57044127036,891314484,13926788,NULL),(142237,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142237,37.76,0.14,356,68682,NULL,NULL,'ABELL 2295 cluster, avg. of 10 spiral galaxies','ABELL 2295',NULL,'2003AJ....126..675D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142238,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142238,35.39,NULL,120,68683,NULL,NULL,'Dipole + Quadrupole','MCG +07-37-013',NULL,'2010Ap&SS.325..163P',2010,1,1.2,NULL,'G',0.000053,NULL,'15.5',0.15,'Sc',NULL,NULL,NULL,NULL,1,270.017416667,44.52733,0.137,NULL,54224066910,847251045,13238297,15.5),(142239,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142239,35.39,NULL,120,68683,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +07-37-013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142240,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142240,35.42,NULL,122,68683,NULL,NULL,NULL,'MCG +07-37-013',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142241,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142241,35.44,NULL,122,68683,NULL,NULL,'Dipole','MCG +07-37-013',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142242,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142242,36.2,0.49,174,68683,75,NULL,'IR','MCG +07-37-013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142243,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142243,36.5,0.53,200,68684,70,NULL,NULL,'2MASX J18002107-6952539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,270.087875,-69.88169,0.153,NULL,48453810029,757090781,11829543,15.3),(142244,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142244,35.11,0.54,105,68685,70,NULL,NULL,'2MASX J18002405-6801258',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.100125,-68.02383,0.425,NULL,48452702501,757073476,11829273,14.9),(142245,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142245,33.85,0.4,59,68686,NULL,NULL,'mean','2MFGC 14160',NULL,'2007A&A...465...71T',2007,1,0.5,NULL,'G',0.000043,NULL,'17.62',0.1,'S+S            LIRG',NULL,NULL,NULL,NULL,1,270.132917,-4.01481,NULL,NULL,47251254372,738300849,11535950,17.62),(142246,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142246,33.88,0.47,59.7,68686,NULL,NULL,'H','2MFGC 14160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142247,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142247,33.9,0.45,60.4,68686,NULL,NULL,'K','2MFGC 14160',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142248,'IRAS','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142248,32.48,0.8,31.3,68687,75,NULL,'MAT, I','ESO 139- G 049',NULL,'1997ApJS..109..333W',1997,1,2.3,'Confused HIPASS source','G',0.000025,NULL,'13.90',0.7,'SB(s)cd: pec',NULL,NULL,NULL,NULL,1,270.145833,-59.1365,0.349,NULL,48962209927,765034530,11953664,13.9),(142249,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142249,32.22,0.32,27.8,68687,85,NULL,'I, raw','ESO 139- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142250,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142250,32.24,0.32,28,68687,85,NULL,'I, inv','ESO 139- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142251,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142251,32.28,0.4,28.6,68687,NULL,NULL,NULL,'ESO 139- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142252,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142252,32.35,0.43,29.5,68687,75,NULL,'MAT, I, raw','ESO 139- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142253,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142253,32.45,0.43,30.9,68687,75,NULL,'MAT, I, inv','ESO 139- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142254,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,'R',142254,32.58,0.49,32.7,68687,75,NULL,'IR','ESO 139- G 049',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142255,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142255,32.72,0.43,35,68687,75,NULL,'MAT, I, cor','ESO 139- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142256,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142256,33.34,0.69,46.5,68688,100,NULL,'mid-IR','UGC 11090',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000006,NULL,'14.34',0.9,'Scd:',NULL,NULL,NULL,NULL,1,270.18,28.71186,0.237,NULL,54329676518,848901195,13264081,14.34),(142257,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142257,33.5,0.48,50.2,68688,NULL,NULL,NULL,'UGC 11090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142258,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142258,33.55,0.2,51.3,68688,74.4,NULL,NULL,'UGC 11090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142259,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142259,33.74,0.43,56.1,68688,NULL,NULL,'Malmquist cor.','UGC 11090',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142260,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142260,34.93,0.38,96.8,68689,NULL,NULL,'Malmquist cor.','UGC 11091',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.40',0.6,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,270.182125,35.01367,0.241,NULL,54241272341,847519880,13242498,15.4),(142261,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142261,35.03,0.36,101,68689,NULL,NULL,NULL,'UGC 11091',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142262,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142262,35.05,0.2,102,68689,74.4,NULL,NULL,'UGC 11091',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142263,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142263,37.25,0.48,282,68690,NULL,NULL,'Malmquist cor.','2MASX J18004511+6919288',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'14.91',NULL,'Sb',NULL,NULL,NULL,NULL,1,270.1880417,69.32478,0.173,NULL,52682966904,823171357,12862052,14.91),(142264,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142264,37.5,0.43,316,68690,NULL,NULL,NULL,'2MASX J18004511+6919288',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142265,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142265,37.54,0.2,322,68690,74.4,NULL,NULL,'2MASX J18004511+6919288',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142266,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142266,37.65,0.13,339,68690,70,NULL,'ABELL 2295, BGC','2MASX J18004511+6919288',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142267,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142267,37.66,0.58,340,68691,NULL,NULL,'Malmquist cor.','2MASX J18005650+6929399',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.80',NULL,'Sbc',NULL,NULL,NULL,NULL,1,270.235583,69.49444,0.165,NULL,52683008859,823172013,12862062,15.8),(142268,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142268,37.79,0.54,362,68691,NULL,NULL,NULL,'2MASX J18005650+6929399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142269,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142269,37.83,0.2,368,68691,74.4,NULL,NULL,'2MASX J18005650+6929399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142270,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142270,36.37,0.63,188,68692,70,NULL,NULL,'ESO 229- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.9R',0.6,'S',NULL,NULL,NULL,NULL,1,270.258083333,-51.80142,0.601,NULL,48880722843,763761294,11933770,14.9),(142271,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142271,35.67,0.48,136,68693,70,NULL,NULL,'2MASX J18012872-6344515',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000117,NULL,'13.1R',0.9,'S0- pec?',NULL,NULL,NULL,NULL,1,270.369583,-63.74792,0.273,NULL,48932557507,764571211,11946425,13.1),(142272,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142272,33.29,0.21,44.8,68694,74.2,NULL,'SALT 2','CGCG 141-044',0.015501,'2010ApJ...716..712A',2010,1,0.35,NULL,'G',0.000103,NULL,'14.8',0.25,NULL,NULL,NULL,NULL,NULL,1,270.3900417,26.25283,0.521,NULL,54301287285,848457613,13257150,14.8),(142273,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142273,33.78,0.04,56.1,68694,72,NULL,'MLCS31','CGCG 141-044',0.015501,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142274,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142274,33.79,0.04,56.4,68694,70,NULL,'SALT 2','CGCG 141-044',0.015501,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142275,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142275,33.86,0.09,59.2,68694,74.4,NULL,NULL,'CGCG 141-044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142276,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142276,33.94,0.18,60.4,68694,73.8,NULL,'SALT 2 (SNANA)','CGCG 141-044',0.0155,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142277,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142277,34.04,0.23,63.4,68694,65,NULL,'MLCS31','CGCG 141-044',0.015501,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142278,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142278,34.06,0.22,63.8,68694,65,NULL,'MLCS17','CGCG 141-044',0.015501,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142279,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142279,34.06,0.23,63.8,68694,65,NULL,'SALT','CGCG 141-044',0.015501,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142280,'SNIa','2016-12-15 15:15:46','2016-12-16 11:21:01','1','SN 2001bf',NULL,142280,34.17,0.24,67.3,68694,65,NULL,'SALT2','CGCG 141-044',0.015501,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142281,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142281,36.24,0.31,177,68695,70,NULL,NULL,'GIN 649',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000123,NULL,'14.98',NULL,'E/S0',NULL,NULL,NULL,NULL,1,270.4285417,42.71897,0.117,NULL,54225895294,847279613,13238743,14.98),(142282,'FP','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142282,37.32,0.25,291,68695,74.4,NULL,NULL,'GIN 649',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142283,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142283,36.79,0.43,228,68696,NULL,NULL,'Malmquist cor.','2MASX J18014487+6930538',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.57',NULL,'S0',NULL,NULL,NULL,NULL,1,270.4365,69.51497,0.165,NULL,52683004535,823171945,12862061,16.57),(142284,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142284,37,0.39,251,68696,NULL,NULL,NULL,'2MASX J18014487+6930538',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142285,'Tully-Fisher','2016-12-15 15:15:46','2016-12-16 11:21:01','1',NULL,NULL,142285,37.04,0.2,256,68696,74.4,NULL,NULL,'2MASX J18014487+6930538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142286,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142286,34.3,0.45,72.3,68697,NULL,NULL,'K','NGC 6527',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'14.30',1,'Sa:',NULL,NULL,NULL,NULL,1,270.443041667,19.72872,0.397,NULL,53822457811,840975903,13140248,14.3),(142287,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142287,34.34,0.47,73.9,68697,NULL,NULL,'H','NGC 6527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142288,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142288,34.39,0.4,75.6,68697,NULL,NULL,'mean','NGC 6527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142289,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142289,34.44,0.46,77.4,68697,NULL,NULL,'J','NGC 6527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142290,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142290,37.95,0.5,390,68698,NULL,NULL,'Malmquist cor.','AGC 280132',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.58',NULL,'Sc',NULL,NULL,NULL,NULL,1,270.454333,69.24411,0.173,NULL,52682858621,823169665,12862026,16.58),(142291,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142291,37.98,0.49,394,68698,NULL,NULL,NULL,'AGC 280132',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142292,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142292,38.02,0.2,402,68698,74.4,NULL,NULL,'AGC 280132',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142293,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142293,32.29,0.8,28.7,68699,75,NULL,'A82, H','UGC 11093',NULL,'1997ApJS..109..333W',1997,1,5.38,NULL,'G',0.000003,NULL,'13.7',0.68,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,270.465291667,6.96825,0.781,NULL,53728410383,839506412,13117287,13.7),(142294,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142294,31.52,0.4,20.1,68699,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 11093',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142295,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142295,31.55,0.4,20.4,68699,75,NULL,NULL,'UGC 11093',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142296,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142296,31.63,0.38,21.2,68699,NULL,NULL,NULL,'UGC 11093',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142297,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142297,31.69,0.43,21.8,68699,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11093',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142298,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142298,31.75,NULL,22.4,68699,NULL,NULL,'Dipole','UGC 11093',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142299,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142299,31.75,0.43,22.4,68699,75,NULL,'3.6 micron, color corrected','UGC 11093',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142300,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142300,31.76,NULL,22.5,68699,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11093',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142301,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142301,31.76,NULL,22.5,68699,NULL,NULL,'Dipole + Quadrupole','UGC 11093',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142302,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142302,31.79,0.2,22.8,68699,74.4,NULL,NULL,'UGC 11093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142303,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142303,31.81,NULL,23,68699,NULL,NULL,NULL,'UGC 11093',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142304,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142304,31.84,0.46,23.3,68699,NULL,NULL,'J','UGC 11093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142305,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142305,31.84,0.47,23.3,68699,75,NULL,'A82, H, raw','UGC 11093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142306,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142306,31.88,0.47,23.8,68699,NULL,NULL,'H','UGC 11093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142307,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142307,31.89,0.47,23.9,68699,75,NULL,'A82, H, inv','UGC 11093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142308,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142308,32,0.45,25.1,68699,NULL,NULL,'K','UGC 11093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142309,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142309,32,0.4,25.1,68699,NULL,NULL,'Malmquist cor.','UGC 11093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142310,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142310,32,0.4,25.1,68699,NULL,NULL,NULL,'UGC 11093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142311,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142311,32.02,0.4,25.3,68699,NULL,NULL,'mean','UGC 11093',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142312,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142312,32.11,0.49,26.4,68699,75,NULL,'IR','UGC 11093',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142313,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142313,32.28,0.47,28.6,68699,75,NULL,'A82, H, cor','UGC 11093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142314,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142314,32.39,0.4,30.1,68699,75,NULL,'B','UGC 11093',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142315,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142315,36.4,0.62,191,68700,70,NULL,NULL,'2MASX J18015251-6750192',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.4687083,-67.83867,0.537,NULL,48452620294,757072192,11829253,15.4),(142316,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142316,37.54,0.53,323,68701,NULL,NULL,'Malmquist cor.','2MASX J18015270+6842437',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.19',NULL,'Sa',NULL,NULL,NULL,NULL,1,270.469417,68.71219,0.201,NULL,52681003041,823140672,12861573,15.19),(142317,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142317,37.72,0.49,349,68701,NULL,NULL,NULL,'2MASX J18015270+6842437',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142318,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142318,37.76,0.2,356,68701,74.4,NULL,NULL,'2MASX J18015270+6842437',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142319,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142319,36.19,0.54,173,68702,70,NULL,NULL,'2MASX J18015559-6944532',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,270.481875,-69.74808,0.153,NULL,48454505466,757101647,11829713,16.7),(142320,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142320,36.38,0.72,189,68703,70,NULL,NULL,'2MASX J18020944-6436319',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.5392917,-64.60889,0.269,NULL,48931826749,764559792,11946246,15.5),(142321,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 2005de',NULL,142321,34.24,0.2,69.4,68704,70,NULL,'SALT 2','UGC 11097',0.015184,'2013MNRAS.433.2240G',2013,1,1.2,NULL,'G',0.000117,NULL,'13.2B',0.4,'S?',NULL,NULL,NULL,NULL,1,270.603625,26.04039,0.521,NULL,54301322056,848458157,13257158,13.2),(142322,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142322,33.2,0.49,43.7,68704,75,NULL,'IR','UGC 11097',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142323,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142323,34.89,0.49,95.1,68705,75,NULL,'IR','ESO 102- G 023',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'15.23',0.2,'Sbc: sp',NULL,NULL,NULL,NULL,1,270.6415,-63.31694,0.281,NULL,48934465587,764601024,11946891,15.23),(142324,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142324,35.28,0.52,114,68705,NULL,NULL,'Malmquist cor.','ESO 102- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142325,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142325,35.45,0.47,123,68705,NULL,NULL,'H','ESO 102- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142326,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142326,35.46,0.4,124,68705,NULL,NULL,'mean','ESO 102- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142327,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142327,35.47,0.48,124,68705,NULL,NULL,NULL,'ESO 102- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142328,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142328,35.51,0.2,126,68705,74.4,NULL,NULL,'ESO 102- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142329,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142329,35.6,0.45,132,68705,NULL,NULL,'K','ESO 102- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142330,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142330,35.66,0.46,136,68705,NULL,NULL,'J','ESO 102- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142331,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142331,36.08,0.25,164,68706,74.4,NULL,NULL,'CGCG 227-016 NED02',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000067,NULL,'13.93',NULL,'cD',NULL,NULL,NULL,NULL,1,270.667667,42.79547,0.137,NULL,54226057408,847282147,13238783,13.93),(142332,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142332,36.24,0.31,177,68706,70,NULL,NULL,'CGCG 227-016 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142333,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142333,33.38,0.48,47.5,68707,70,NULL,NULL,'NGC 6492',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000026,NULL,'12.3',1.2,'SAB(rs)b','Pair member (points to parent)',NULL,NULL,NULL,1,270.7014583,-66.43064,0.281,NULL,48923106017,764423531,11944117,12.3),(142334,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142334,33.35,NULL,46.8,68707,NULL,NULL,'B','NGC 6492',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142335,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142335,33.61,0.47,52.8,68707,NULL,NULL,'H','NGC 6492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142336,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142336,33.65,0.46,53.8,68707,NULL,NULL,'J','NGC 6492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142337,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142337,33.76,0.45,56.6,68707,NULL,NULL,'K','NGC 6492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142338,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142338,33.81,0.4,57.9,68707,NULL,NULL,'mean','NGC 6492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142339,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142339,33.84,NULL,58.6,68707,NULL,NULL,'I','NGC 6492',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142340,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142340,34.22,0.07,70,68707,NULL,NULL,NULL,'NGC 6492',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142341,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142341,36.88,0.59,238,68708,70,NULL,NULL,'2MASX J18024904-6518065',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.7042083,-65.30172,0.265,NULL,48924544041,764446000,11944468,15.5),(142342,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142342,35.6,0.63,132,68709,70,NULL,NULL,'ESO 024- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.4b',0.3,'S...',NULL,NULL,NULL,NULL,1,270.7252917,-79.13833,0.649,NULL,48352177201,755502768,11804730,16.4),(142343,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142343,35.59,0.48,131,68710,NULL,NULL,'Malmquist cor.','UGC 11102',NULL,'2009ApJS..182..474S',2009,1,1.28,NULL,'G',0.00003,NULL,'17.',0.11,'Sc',NULL,NULL,NULL,NULL,1,270.742875,52.11453,0.141,NULL,52923188354,826924818,12920700,17),(142344,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142344,35.87,NULL,149,68710,NULL,NULL,NULL,'UGC 11102',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142345,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142345,35.89,0.42,150,68710,NULL,NULL,NULL,'UGC 11102',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142346,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142346,35.93,0.2,153,68710,74.4,NULL,NULL,'UGC 11102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142347,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142347,34.27,0.2,71.5,68711,74.4,NULL,NULL,'UGC 11101',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',NULL,NULL,'16.0',0.3,'Scd:',NULL,NULL,NULL,NULL,1,270.7677083,45.25639,0.141,NULL,54760993373,855640521,13369383,16),(142348,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142348,34.31,0.46,72.7,68711,NULL,NULL,NULL,'UGC 11101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142349,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142349,34.63,0.4,84.2,68711,NULL,NULL,'Malmquist cor.','UGC 11101',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142350,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142350,36.07,0.25,164,68712,74.4,NULL,NULL,'GIN 652',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000063,NULL,'15.29',NULL,'E/S0',NULL,NULL,NULL,NULL,1,270.7682083,42.95614,0.137,NULL,54225824200,847278503,13238726,15.29),(142351,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142351,36.24,0.31,177,68712,70,NULL,NULL,'GIN 652',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142352,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142352,38.52,0.5,507,68713,NULL,NULL,NULL,'2MASX J18031234+6917048',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'16.11',NULL,'Sbc:',NULL,NULL,NULL,NULL,1,270.8015,69.28456,0.205,NULL,52683060893,823172826,12862075,16.11),(142353,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142353,38.52,0.5,507,68713,NULL,NULL,'Malmquist cor.','2MASX J18031234+6917048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142354,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142354,38.57,0.2,518,68713,74.4,NULL,NULL,'2MASX J18031234+6917048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142355,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142355,43.12,NULL,4210,68714,70,NULL,'Pseudo z = 9.5','GRB 010612',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE/Ulysses',NULL,NULL,NULL,NULL,1,270.825,-32.13333,NULL,NULL,47667679006,744807484,11637616,NULL),(142356,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142356,36.59,0.7,208,68715,70,NULL,NULL,'2MFGC 14185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.849875,-71.00853,0.473,NULL,48459855916,757185248,11831019,15.4),(142357,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142357,35.77,0.5,142,68716,70,NULL,NULL,'2MASX J18032585-5228417',NULL,'2014MNRAS.445.2677S',2014,1,0.16,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.8577917,-52.47817,0.569,NULL,48882181477,763784085,11934126,15.2),(142358,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142358,36.5,0.61,200,68717,70,NULL,NULL,'2MASX J18034670-6601098',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.9445,-66.01942,0.265,NULL,48924819652,764450307,11944536,15.8),(142359,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142359,37.17,0.57,272,68718,NULL,NULL,'Malmquist cor.','2MASX J18034705+6922579',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.43',NULL,'Sbc',NULL,NULL,NULL,NULL,1,270.9457083,69.38281,0.185,NULL,52683051443,823172678,12862073,15.43),(142360,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142360,37.49,0.5,315,68718,NULL,NULL,NULL,'2MASX J18034705+6922579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142361,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142361,37.54,0.2,322,68718,74.4,NULL,NULL,'2MASX J18034705+6922579',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142362,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142362,36.89,0.7,238,68719,70,NULL,NULL,'2MASX J18035551-5728564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,270.9814583,-57.48228,0.413,NULL,48956300327,764942192,11952221,15),(142363,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142363,36.09,0.5,165,68720,70,NULL,NULL,'2MASX J18040312-6654557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.012875,-66.91547,0.289,NULL,48923398350,764428099,11944189,14.6),(142364,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142364,35.98,0.67,157,68721,70,NULL,NULL,'2MASX J18041135-6656515',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.0470417,-66.94761,0.289,NULL,48923353746,764427402,11944178,14.4),(142365,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142365,35.92,0.49,153,68722,75,NULL,'IR','FGC 2180',NULL,'2011yCatp016004901K',2011,1,0.91,NULL,'G',NULL,NULL,'16.6',0.11,'Sbc',NULL,NULL,NULL,NULL,1,271.0507083,45.06314,0.157,NULL,54761000640,855640635,13369384,16.6),(142366,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142366,35.94,NULL,154,68722,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2180',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142367,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142367,35.96,NULL,156,68722,NULL,NULL,'Dipole + Quadrupole','FGC 2180',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142368,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142368,35.97,NULL,156,68722,NULL,NULL,NULL,'FGC 2180',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142369,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142369,35.98,NULL,157,68722,NULL,NULL,'Dipole','FGC 2180',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142370,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142370,34.23,0.46,70.1,68723,70,NULL,NULL,'NGC 6502',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'Blakeslee (priv.comm.2002) says v=4880 in 2001MNRAS.327.1004B incorrect.','G',0.000057,NULL,'13.57',1.1,'SA0-:',NULL,NULL,NULL,NULL,1,271.057167,-65.40994,0.265,NULL,48925455835,764460247,11944691,13.57),(142371,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142371,32.19,0.43,27.5,68724,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 056-008',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000087,NULL,'15.7',0.2,'S',NULL,NULL,NULL,NULL,1,271.064833,7.04094,0.869,NULL,53727608841,839493888,13117092,15.7),(142372,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142372,35.31,0.75,116,68725,70,NULL,NULL,'ESO 044- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000033,NULL,'16.0b',0.3,'S...',NULL,NULL,NULL,NULL,1,271.069833333,-73.70889,0.461,NULL,48477977756,757468402,11835443,16),(142373,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142373,35.95,0.4,155,68725,NULL,NULL,'Malmquist cor.','ESO 044- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142374,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142374,35.98,0.39,157,68725,NULL,NULL,NULL,'ESO 044- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142375,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142375,36.02,0.2,160,68725,74.4,NULL,NULL,'ESO 044- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142376,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142376,37.69,0.51,345,68726,NULL,NULL,'Malmquist cor.','2MASX J18042418+6915401',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'15.90',NULL,'Sbc',NULL,NULL,NULL,NULL,1,271.1007083,69.26119,0.205,NULL,52684014199,823187721,12862308,15.9),(142377,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142377,37.76,0.49,356,68726,NULL,NULL,NULL,'2MASX J18042418+6915401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142378,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142378,37.8,0.2,363,68726,74.4,NULL,NULL,'2MASX J18042418+6915401',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142379,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142379,35.37,0.52,119,68727,70,NULL,NULL,'2MASX J18042526-6952396',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,271.1052083,-69.87769,0.153,NULL,48454634358,757103661,11829744,15.1),(142380,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142380,32.67,0.4,34.2,68728,75,NULL,'B','UGC 11105',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.00002,NULL,'14.2',1.7,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.150333333,21.63789,0.385,NULL,54559922501,852498789,13320293,14.2),(142381,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142381,44.52,0.67,2510,68729,72,NULL,NULL,'GRB 050922',2.2,'2008JCAP...07..004M',2008,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'INTEGRAL',NULL,NULL,NULL,NULL,1,271.094,-32.041,NULL,NULL,47668226867,744816044,11637750,NULL),(142382,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142382,45.57,0.52,4060,68729,69.7,NULL,'Calibrated','GRB 050922',2.2,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142383,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142383,45.71,0.55,4330,68729,69.7,NULL,'Fiducial','GRB 050922',2.2,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142384,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142384,45.77,0.56,4460,68729,72,NULL,NULL,'GRB 050922',2.2,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142385,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142385,46.12,0.65,5220,68729,NULL,NULL,NULL,'GRB 050922',2.2,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142386,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142386,35.11,NULL,105,68730,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11108',NULL,'2010Ap&SS.325..163P',2010,1,1.14,NULL,'G',0.000014,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,271.2550417,20.03967,0.377,NULL,53824502486,841007851,13140747,16.5),(142387,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142387,35.11,NULL,105,68730,NULL,NULL,'Dipole','UGC 11108',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142388,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142388,35.11,NULL,105,68730,NULL,NULL,'Dipole + Quadrupole','UGC 11108',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142389,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142389,35.12,0.49,106,68730,75,NULL,'IR','UGC 11108',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142390,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142390,35.18,NULL,108,68730,NULL,NULL,NULL,'UGC 11108',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142391,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142391,34.18,0.69,68.5,68731,100,NULL,'mid-IR','NGC 6560',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00001,NULL,'14.16',0.8,'S pec?',NULL,NULL,NULL,NULL,1,271.30825,46.88158,0.113,NULL,52885860317,826341567,12911586,14.16),(142392,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142392,35.02,0.4,101,68731,NULL,NULL,'mean','NGC 6560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142393,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142393,35.21,0.47,110,68731,NULL,NULL,'H','NGC 6560',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142394,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142394,32.76,0.4,35.7,68732,75,NULL,'B','UGC 11113',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000013,NULL,'14.2',1.8,'SABd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.379375,23.27217,0.465,NULL,54294829367,848356708,13255573,14.2),(142395,'SBF','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142395,31.81,0.21,23,68733,NULL,NULL,'I','NGC 6548',NULL,'2001ApJ...546..681T',2001,1,1.4,NULL,'G',0.000033,NULL,'14.72',0.4,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,271.45625,18.53803,0.433,NULL,53836311998,841192374,13143630,14.72),(142396,'SBF','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142396,31.83,0.14,23.2,68733,74.4,NULL,NULL,'NGC 6548',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142397,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142397,34.22,0.47,69.8,68733,NULL,NULL,'H','NGC 6548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142398,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142398,34.25,0.45,70.6,68733,NULL,NULL,'K','NGC 6548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142399,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142399,34.34,0.49,73.7,68733,75,NULL,'IR','NGC 6548',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142400,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142400,34.36,0.46,74.6,68733,NULL,NULL,'J','NGC 6548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142401,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142401,34.64,0.4,84.8,68733,NULL,NULL,'mean','NGC 6548',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142402,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142402,34.95,0.8,97.7,68734,75,NULL,'CF, r','UGC 11118',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000077,NULL,'15.09',0.6,'Sb',NULL,NULL,NULL,NULL,1,271.467458333,34.01831,0.285,NULL,54241049369,847516396,13242443,15.09),(142403,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142403,34.61,0.38,83.6,68734,75,NULL,'CF, r, raw','UGC 11118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142404,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142404,34.73,0.38,88.3,68734,75,NULL,'CF, r, inv','UGC 11118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142405,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142405,34.86,0.38,93.8,68734,75,NULL,'CF, r, cor','UGC 11118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142406,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142406,32.92,0.4,38.4,68735,NULL,NULL,'mean','NGC 6550',NULL,'2007A&A...465...71T',2007,1,3,NULL,'G',0.000017,NULL,'12.73',2.8,'SB0','Pair member (points to parent)',NULL,NULL,NULL,1,271.496833,18.58725,0.433,NULL,53836277504,841191836,13143622,12.73),(142407,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142407,33.64,0.45,53.4,68735,NULL,NULL,'K','NGC 6550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142408,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142408,35.89,0.58,151,68736,70,NULL,NULL,'2MASX J18061404-7004355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.558667,-70.07661,0.153,NULL,48454603699,757103182,11829737,14.9),(142409,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142409,36.27,0.59,180,68737,70,NULL,NULL,'2MASX J18061744-7043285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.572375,-70.72461,0.541,NULL,48467384197,757302878,11832857,15.6),(142410,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142410,35.79,0.75,144,68738,70,NULL,NULL,'2MASX J18063817-6609021',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.659291667,-66.15056,0.265,NULL,48925956326,764468067,11944813,15.5),(142411,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142411,37.14,0.64,268,68739,70,NULL,NULL,'2MASX J18064396-6500287',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.6827917,-65.00794,0.261,NULL,48936086537,764626352,11947286,14.2),(142412,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142412,36.61,0.65,210,68740,70,NULL,NULL,'2MASX J18064749-7314479',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,271.697833333,-73.24675,0.293,NULL,48511545100,757992892,11843638,14.4),(142413,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142413,35.58,0.55,131,68741,70,NULL,NULL,'2MASX J18064924-5203264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.705,-52.05742,0.553,NULL,48883917934,763811217,11934550,15.4),(142414,'BL Lac Luminosity','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142414,36.85,NULL,223,68742,NULL,NULL,NULL,'UGC 11130',0.051,'2005ApJ...635..173S',2005,1,0.15,NULL,'G',0.0003,NULL,'14.2V',0.15,'E;BLLAC        LEG',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,271.711167,69.82447,0.193,NULL,52683580903,823180951,12862202,14.2),(142415,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142415,33.59,0.47,52.1,68743,70,NULL,NULL,'ESO 139- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00015,NULL,'13.70',1.1,'(R)SA(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.752833333,-57.73092,0.365,NULL,48959903941,764998499,11953101,13.7),(142416,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142416,32.94,NULL,38.7,68744,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11120',NULL,'2010Ap&SS.325..163P',2010,1,1.4,NULL,'G',0.000013,NULL,'15.34',0.18,'Sdm',NULL,NULL,NULL,NULL,1,271.759667,20.48814,0.357,NULL,53823762056,840996282,13140566,15.34),(142417,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142417,32.96,NULL,39.1,68744,NULL,NULL,'Dipole + Quadrupole','UGC 11120',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142418,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142418,32.96,NULL,39.1,68744,NULL,NULL,'Dipole','UGC 11120',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142419,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142419,36.18,0.49,172,68745,70,NULL,NULL,'PKS 1801-702',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'16.5',NULL,'Elliptical',NULL,NULL,NULL,NULL,1,271.811916667,-70.21067,0.241,NULL,48453728900,757089514,11829523,16.5),(142420,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142420,32.15,0.4,26.9,68746,75,NULL,'B','UGC 11124',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.00001,NULL,'13.4',2.3,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.864583,35.56333,0.157,NULL,54254639523,847728742,13245761,13.4),(142421,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142421,36.96,0.65,246,68747,70,NULL,NULL,'2MASX J18074223-6414568',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,271.925917,-64.24914,0.301,NULL,48932259780,764566559,11946352,15.5),(142422,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142422,32.65,0.4,33.9,68748,75,NULL,'B','NGC 6555',NULL,'1988NBGC.C....0000T',1988,1,2,'HOLM 774B is a clump of stars.','G',0.000013,NULL,'12.99',1.5,'SAB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,271.954875,17.60489,0.553,NULL,53827487433,841054491,13141476,12.99),(142423,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142423,34.46,0.43,78.1,68749,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2185',NULL,'2014MNRAS.444..527S',2014,1,0.99,NULL,'G',0.000013,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,272.024125,16.57914,0.705,NULL,53882498938,841914045,13154906,16.6),(142424,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142424,35.33,0.49,116,68749,75,NULL,'IR','FGC 2185',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142425,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142425,35.57,NULL,130,68749,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2185',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142426,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142426,35.59,NULL,131,68749,NULL,NULL,'Dipole + Quadrupole','FGC 2185',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142427,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142427,35.6,NULL,132,68749,NULL,NULL,'Dipole','FGC 2185',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142428,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142428,35.61,NULL,132,68749,NULL,NULL,NULL,'FGC 2185',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142429,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142429,34.12,0.55,66.7,68750,NULL,NULL,NULL,'IC 4688',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000023,NULL,'13.8',1.1,'Scd:',NULL,NULL,NULL,NULL,1,272.0495,11.71222,0.473,NULL,53840129260,841252019,13144562,13.8),(142430,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142430,34.16,0.2,67.9,68750,74.4,NULL,NULL,'IC 4688',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142431,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142431,34.19,0.54,68.8,68750,NULL,NULL,'Malmquist cor.','IC 4688',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142432,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142432,34.28,0.47,71.6,68750,NULL,NULL,'H','IC 4688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142433,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142433,34.34,0.45,73.8,68750,NULL,NULL,'K','IC 4688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142434,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142434,34.37,0.46,74.9,68750,NULL,NULL,'J','IC 4688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142435,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142435,34.55,0.4,81.1,68750,NULL,NULL,'mean','IC 4688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142436,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142436,33.63,0.8,53.1,68751,75,NULL,'MAT, I','IC 4674',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.87',0.6,'SAB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,272.0545,-62.3955,0.353,NULL,48977830061,765278594,11957478,14.87),(142437,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142437,32.21,0.32,27.7,68751,85,NULL,'I, raw','IC 4674',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142438,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142438,32.21,0.32,27.7,68751,85,NULL,'I, inv','IC 4674',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142439,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142439,32.55,0.43,32.4,68751,75,NULL,'MAT, I, raw','IC 4674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142440,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142440,32.6,0.43,33.1,68751,75,NULL,'MAT, I, inv','IC 4674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142441,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142441,32.94,0.43,38.7,68751,75,NULL,'MAT, I, cor','IC 4674',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142442,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142442,36.45,0.77,195,68752,70,NULL,NULL,'2MASX J18082419-5204181',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.100875,-52.07175,0.553,NULL,48884027874,763812935,11934577,15.4),(142443,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142443,35.72,0.52,139,68753,70,NULL,NULL,'2MASX J18082523-4709251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.105041667,-47.15689,0.529,NULL,48858421386,763412834,11928325,14.1),(142444,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142444,36.09,0.6,165,68754,70,NULL,NULL,'2MASX J18082519-5658023',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.105125,-56.96742,0.377,NULL,49090619090,767040923,11985014,15.3),(142445,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142445,33.94,0.53,61.4,68755,70,NULL,NULL,'ESO 229- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000147,NULL,'15.4b',0.2,'SA(s)b',NULL,NULL,NULL,NULL,1,272.123916667,-52.10597,0.553,NULL,48883999195,763812487,11934570,15.4),(142446,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142446,43.07,0.38,2100,68756,69.7,NULL,'Calibrated','GRB 970828:[DFK2001] A',0.9578,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',0.0001,NULL,'25.05',NULL,NULL,NULL,NULL,NULL,NULL,1,272.132333333,59.31458,0.097,NULL,53047418009,828865906,12951029,25.05),(142447,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142447,43.86,0.45,2210,68756,73,NULL,'H const./H=100','GRB 970828:[DFK2001] A',0.9578,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142448,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142448,43.2,0.64,2230,68756,69.7,NULL,'Calibrated','GRB 970828:[DFK2001] A',0.9578,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142449,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142449,43.38,0.49,2420,68756,69.7,NULL,'Fiducial','GRB 970828:[DFK2001] A',0.9578,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142450,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142450,43.43,0.47,2480,68756,72,NULL,NULL,'GRB 970828:[DFK2001] A',0.9578,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142451,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142451,43.58,0.46,2660,68756,70,NULL,NULL,'GRB 970828:[DFK2001] A',0.9578,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142452,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142452,34.28,0.49,71.8,68757,75,NULL,'IR','UGC 11126',NULL,'2011yCatp016004901K',2011,1,1.55,NULL,'G',0.000047,NULL,'17.',0.1,'Sd',NULL,NULL,NULL,NULL,1,272.1409583,25.72494,0.569,NULL,54302191039,848471734,13257370,17),(142453,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142453,34.31,NULL,72.9,68757,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142454,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142454,34.33,NULL,73.4,68757,NULL,NULL,'Dipole + Quadrupole','UGC 11126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142455,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142455,34.33,NULL,73.4,68757,NULL,NULL,'Dipole','UGC 11126',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142456,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142456,35.74,0.58,141,68758,70,NULL,NULL,'2MASX J18083485-6644017',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,272.145375,-66.73383,0.341,NULL,48926163969,764471312,11944864,14.2),(142457,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142457,36.08,0.79,164,68759,70,NULL,NULL,'2MASX J18084308-6351340',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.1797083,-63.85944,0.305,NULL,48934084250,764595066,11946797,15.1),(142458,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142458,37.06,0.81,258,68760,70,NULL,NULL,'2MASX J18085179-7327292',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,272.215875,-73.45817,0.517,NULL,48511416385,757990881,11843607,16.9),(142459,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142459,36.25,0.54,178,68761,70,NULL,NULL,'2MASX J18085404-6535310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.2250417,-65.592,0.265,NULL,48925188899,764456076,11944626,14.9),(142460,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142460,36.7,0.54,219,68762,70,NULL,NULL,'2MASX J18085586-4844290',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.232917,-48.74144,0.473,NULL,48870200826,763596887,11931201,15.4),(142461,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142461,36.66,0.73,215,68763,70,NULL,NULL,'2MASX J18090029-6504041',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.251125,-65.06783,0.261,NULL,48936931416,764639553,11947493,13.9),(142462,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142462,35.78,0.67,143,68764,70,NULL,NULL,'2MASX J18091135-5719040',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.29725,-57.31775,0.377,NULL,48956504944,764945389,11952271,15),(142463,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142463,36.55,0.6,204,68765,70,NULL,NULL,'2MASX J18092457-5719210',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.35225,-57.32247,0.377,NULL,48956504344,764945380,11952271,15.3),(142464,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142464,33.04,0.4,40.6,68766,75,NULL,NULL,'UGC 11132',NULL,'2008Ap.....51..336K',2008,1,2.49,NULL,'G',0.000013,NULL,'15.38',0.38,'Sb','Isolated galaxy',NULL,NULL,NULL,1,272.359083,38.79442,0.145,NULL,54286646944,848228858,13253575,15.38),(142465,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142465,33.15,0.4,42.6,68766,NULL,NULL,'mean','UGC 11132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142466,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142466,33.42,0.43,48.3,68766,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11132',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142467,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142467,33.6,0.43,52.5,68766,75,NULL,'3.6 micron, color corrected','UGC 11132',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142468,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142468,33.62,0.47,52.9,68766,NULL,NULL,'H','UGC 11132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142469,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142469,33.66,0.45,53.8,68766,NULL,NULL,'K','UGC 11132',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142470,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142470,33.74,0.49,56,68766,75,NULL,'IR','UGC 11132',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142471,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142471,33.83,0.2,58.3,68766,74.4,NULL,NULL,'UGC 11132',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142472,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142472,36.96,0.58,247,68767,70,NULL,NULL,'2MASX J18092622-5732270',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.3592917,-57.54086,0.373,NULL,48959563294,764993176,11953018,15.6),(142473,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142473,36.02,0.65,160,68768,70,NULL,NULL,'2MASX J18092945-6459259',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.3724583,-64.99047,0.261,NULL,48937041507,764641273,11947519,15.9),(142474,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142474,34.47,0.5,78.3,68769,70,NULL,NULL,'ESO 182- G?004',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.16',1,'SB(rs)a',NULL,NULL,NULL,NULL,1,272.37725,-52.56561,0.373,NULL,48883686034,763807594,11934493,14.16),(142475,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142475,33.87,0.51,59.4,68770,70,NULL,NULL,'ESO 103- G 005',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.81',0.5,'S0?',NULL,NULL,NULL,NULL,1,272.420583333,-63.21683,0.313,NULL,48934265396,764597896,11946842,14.81),(142476,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142476,35.77,0.69,143,68771,70,NULL,NULL,'2MASX J18095847-6907044',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.493833333,-69.11803,0.389,NULL,48456583107,757134111,11830220,15.5),(142477,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142477,36.31,0.69,183,68772,70,NULL,NULL,'2MASX J18102926-7315166',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.621667,-73.25456,0.401,NULL,48512230134,758003595,11843806,15.6),(142478,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142478,36.1,0.62,166,68773,70,NULL,NULL,'2MASX J18104454-7000034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,272.685833,-70.00089,0.169,NULL,48454166661,757096354,11829630,15.2),(142479,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 2002cu',NULL,142479,34.9,0.17,93.2,68774,70,NULL,'SALT 2','NGC 6575',0.023323,'2013MNRAS.433.2240G',2013,1,1.8,NULL,'G',0.00005,NULL,'13.69',1.3,'E','Pair member (points to parent)',NULL,NULL,NULL,1,272.7395417,31.11619,0.305,NULL,54339234611,849050540,13266414,13.69),(142480,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142480,38.01,NULL,400,68775,NULL,NULL,NULL,'GRB 790325b',NULL,'1992grbo.book..107S',1992,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,272.941875,31.40567,0.285,NULL,54326885736,848857589,13263399,NULL),(142481,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142481,38.58,NULL,520,68775,65,NULL,'L = 10e57 photons/s','GRB 790325b',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142482,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142482,39.19,NULL,688,68775,75,NULL,NULL,'GRB 790325b',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142483,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142483,41.34,NULL,1850,68775,65,NULL,'L = 2 x 10e58 photons/s','GRB 790325b',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142484,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142484,32.56,0.8,32.5,68776,75,NULL,'A82, H','NGC 6570',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000017,NULL,'13.30',1.1,'SB(rs)m:','in a pair',NULL,NULL,NULL,1,272.780417,14.09308,0.665,NULL,53850728027,841417625,13147150,13.3),(142485,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142485,31.2,0.4,17.4,68776,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6570',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142486,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142486,31.65,0.47,21.4,68776,75,NULL,'A82, H, inv','NGC 6570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142487,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142487,31.65,0.47,21.4,68776,75,NULL,'A82, H, raw','NGC 6570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142488,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142488,32.21,0.47,27.7,68776,75,NULL,'A82, H, cor','NGC 6570',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142489,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142489,32.69,0.4,34.5,68776,75,NULL,'B','NGC 6570',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142490,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142490,33.97,0.2,62.2,68777,74.4,NULL,NULL,'UGC 11140',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000013,NULL,'15.00',0.4,'Scd:',NULL,NULL,NULL,NULL,1,272.788917,39.1705,0.125,NULL,54286235938,848222436,13253475,15),(142491,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142491,34.16,0.62,67.8,68777,NULL,NULL,NULL,'UGC 11140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142492,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142492,34.33,0.57,73.6,68777,NULL,NULL,'Malmquist cor.','UGC 11140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142493,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142493,34.05,0.2,61.3,68778,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 11149',0.05422,'2011A&A...526A..81B',2011,1,1.3,NULL,'G',0.000043,NULL,'14.2V',0.7,'Sb;BrClG',NULL,NULL,NULL,NULL,1,272.790708333,49.86469,0.189,NULL,52892620916,826447201,12913237,14.2),(142494,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142494,35.75,0.22,134,68778,74.2,NULL,'SALT 2','UGC 11149',0.05422,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142495,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142495,36.46,0.27,186,68778,70,NULL,'SALT','UGC 11149',0.05422,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142496,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142496,36.59,0.26,197,68778,65,NULL,'SALT','UGC 11149',0.05422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142497,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142497,36.63,0.26,201,68778,72,NULL,NULL,'UGC 11149',0.05422,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142498,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142498,36.54,0.08,203,68778,74.4,NULL,NULL,'UGC 11149',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142499,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142499,36.7,0.04,207,68778,70,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 11149',0.05422,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142500,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142500,36.7,0.16,207,68778,70,NULL,'SALT 2','UGC 11149',0.05422,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142501,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142501,36.61,0.05,208,68778,70,NULL,NULL,'UGC 11149',0.05422,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142502,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142502,36.74,0.17,212,68778,73.8,NULL,'SALT 2 (SNANA)','UGC 11149',0.0537,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142503,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142503,36.75,0.13,212,68778,65,NULL,'SALT2','UGC 11149',0.05422,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142504,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142504,36.75,0.1,213,68778,72,NULL,NULL,'UGC 11149',0.05422,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142505,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142505,36.68,0.17,217,68778,70.8,NULL,NULL,'UGC 11149',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142506,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142506,36.92,0.1,218,68778,65,NULL,'MLCS2k2','UGC 11149',0.05422,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142507,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142507,36.85,0.04,223,68778,65,NULL,'SALT','UGC 11149',0.05422,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142508,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142508,36.89,0.14,226,68778,65,NULL,'MLCS31','UGC 11149',0.05422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142509,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142509,36.9,0.14,228,68778,65,NULL,'MLCS17','UGC 11149',0.05422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142510,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142510,36.92,0.1,229,68778,65,NULL,'MLCS2k2','UGC 11149',0.05422,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142511,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142511,36.96,0.18,233,68778,65,NULL,'SALT2','UGC 11149',0.05422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142512,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142512,36.97,0.18,235,68778,65,NULL,NULL,'UGC 11149',0.05422,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142513,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142513,37,0.08,238,68778,65,NULL,'MLCS2k2','UGC 11149',0.05422,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142514,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:01','1','SN 1998dx',NULL,142514,36.95,0.14,245,68778,60,NULL,NULL,'UGC 11149',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142515,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142515,34.28,0.49,71.6,68779,75,NULL,'IR','IC 1279',NULL,'2011yCatp016004901K',2011,1,2.6,NULL,'G',0.000023,NULL,'14.26',0.6,'Sb',NULL,NULL,NULL,NULL,1,272.814083333,36.00778,0.161,NULL,54257289123,847770142,13246408,14.26),(142516,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142516,34.49,0.47,78.9,68779,NULL,NULL,'H','IC 1279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142517,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142517,34.56,0.46,81.5,68779,NULL,NULL,'J','IC 1279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142518,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142518,34.61,0.45,83.5,68779,NULL,NULL,'K','IC 1279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142519,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142519,34.68,0.4,86.3,68779,NULL,NULL,'mean','IC 1279',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142520,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142520,33.16,0.8,42.8,68780,75,NULL,'MAT, I','IC 4679',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000024,NULL,'13.80',0.9,'SB(s)c',NULL,NULL,NULL,NULL,1,272.852041667,-56.25439,0.393,NULL,49093560163,767086877,11985732,13.8),(142521,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142521,32.46,0.32,31,68780,85,NULL,'I, raw','IC 4679',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142522,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142522,32.46,0.32,31.1,68780,85,NULL,'I, inv','IC 4679',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142523,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142523,32.83,0.43,36.9,68780,75,NULL,'MAT, I, raw','IC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142524,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142524,32.93,0.43,38.6,68780,75,NULL,'MAT, I, inv','IC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142525,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142525,33.17,0.43,43,68780,75,NULL,'MAT, I, cor','IC 4679',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142526,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142526,34.09,NULL,65.9,68781,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2187',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000043,':','16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,272.885,25.00583,0.713,NULL,54304457541,848507149,13257924,16.6),(142527,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142527,34.12,NULL,66.6,68781,NULL,NULL,'Dipole + Quadrupole','FGC 2187',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142528,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142528,34.12,NULL,66.8,68781,NULL,NULL,'Dipole','FGC 2187',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142529,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142529,33.83,0.49,58.5,68782,75,NULL,'IR','UGC 11142',NULL,'2011yCatp016004901K',2011,1,1.81,'Marzke, et al. (1996AJ....112.1803M) give v=7456 +/- 40 km/sec.','G',0.00001,NULL,'15.41',0.24,'Sc',NULL,NULL,NULL,NULL,1,272.911,25.65764,0.713,NULL,54303754617,848496165,13257752,15.41),(142530,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142530,34.11,0.43,66.4,68782,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11142',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142531,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142531,34.12,0.4,66.7,68782,NULL,NULL,'mean','UGC 11142',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142532,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142532,34.17,0.43,68.3,68782,75,NULL,'3.6 micron, color corrected','UGC 11142',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142533,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142533,34.31,0.2,72.8,68782,74.4,NULL,NULL,'UGC 11142',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142534,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142534,34.39,0.47,75.5,68782,NULL,NULL,'H','UGC 11142',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142535,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142535,34.4,0.42,75.9,68782,NULL,NULL,'Malmquist cor.','UGC 11142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142536,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142536,34.46,NULL,78.1,68782,NULL,NULL,NULL,'UGC 11142',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142537,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142537,34.48,NULL,78.8,68782,NULL,NULL,'Dipole','UGC 11142',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142538,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142538,34.49,NULL,79,68782,NULL,NULL,'Dipole + Quadrupole','UGC 11142',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142539,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142539,34.49,NULL,79.2,68782,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11142',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142540,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142540,34.53,0.39,80.5,68782,NULL,NULL,NULL,'UGC 11142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142541,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142541,32.99,0.8,39.6,68783,75,NULL,'MAT, I','ESO 071- G 004',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'15.16',0.4,'SB(s)d? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,272.9505417,-67.63925,0.509,NULL,49191521589,768617524,12009648,15.16),(142542,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142542,32.61,0.32,33.3,68783,85,NULL,'I, raw','ESO 071- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142543,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142543,32.61,0.32,33.3,68783,85,NULL,'I, inv','ESO 071- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142544,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142544,32.88,0.43,37.7,68783,75,NULL,'MAT, I, raw','ESO 071- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142545,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142545,32.94,0.43,38.6,68783,75,NULL,'MAT, I, inv','ESO 071- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142546,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142546,33.11,0.53,41.9,68783,NULL,NULL,NULL,'ESO 071- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142547,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142547,33.15,0.2,42.7,68783,74.4,NULL,NULL,'ESO 071- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142548,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142548,33.25,0.43,44.6,68783,75,NULL,'MAT, I, cor','ESO 071- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142549,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142549,33.4,0.46,47.8,68783,NULL,NULL,'Malmquist cor.','ESO 071- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142550,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142550,32.64,0.4,33.8,68784,75,NULL,'B','UGC 11141',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000019,NULL,'13.7',1.6,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,272.9525,12.08861,0.569,NULL,53844970923,841327670,13145744,13.7),(142551,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142551,32.72,0.8,35,68785,75,NULL,'B','NGC 6574',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'12.83',1.1,'SAB(rs)bc:     Sy2','in a pair',NULL,NULL,NULL,1,272.963458333,14.98178,0.829,NULL,53881478050,841898094,13154657,12.83),(142552,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142552,32.52,0.4,32,68785,NULL,NULL,'mean','NGC 6574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142553,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142553,32.82,0.45,36.6,68785,NULL,NULL,'K','NGC 6574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142554,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142554,32.92,0.46,38.3,68785,NULL,NULL,'J','NGC 6574',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142555,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142555,32.95,0.4,38.9,68785,NULL,NULL,NULL,'NGC 6574',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142556,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142556,33.11,0.2,41.9,68785,74.4,NULL,NULL,'NGC 6574',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142557,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142557,32.14,0.8,26.8,68786,75,NULL,'MAT, I','ESO 140- G 006',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000019,NULL,'14.58',0.5,'SB(r)a:',NULL,NULL,NULL,NULL,1,273.002583,-58.97539,0.317,NULL,48971670249,765182347,11955974,14.58),(142558,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142558,31.67,0.32,21.6,68786,85,NULL,'I, inv','ESO 140- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142559,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142559,31.69,0.32,21.8,68786,85,NULL,'I, raw','ESO 140- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142560,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142560,31.84,0.4,23.3,68786,NULL,NULL,NULL,'ESO 140- G 006',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142561,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142561,31.84,0.4,23.3,68786,73,NULL,'opt','ESO 140- G 006',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142562,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142562,32.04,0.43,25.6,68786,75,NULL,'MAT, I, inv','ESO 140- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142563,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142563,32.05,0.43,25.7,68786,75,NULL,'MAT, I, raw','ESO 140- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142564,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142564,32.14,0.2,26.8,68786,74.4,NULL,NULL,'ESO 140- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142565,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142565,32.46,0.43,31,68786,75,NULL,'MAT, I, cor','ESO 140- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142566,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142566,34.1,NULL,66,68787,NULL,NULL,'Dipole','FGC 2189',NULL,'2010Ap&SS.325..163P',2010,1,0.81,NULL,'G',0.000025,':','16.9',0.11,'Scd',NULL,NULL,NULL,NULL,1,273.00475,25.57547,0.713,NULL,54303896224,848498378,13257787,16.9),(142567,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142567,34.1,NULL,66,68787,NULL,NULL,'Dipole + Quadrupole','FGC 2189',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142568,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142568,34.1,NULL,66.1,68787,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2189',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142569,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142569,34.2,NULL,69.3,68787,NULL,NULL,NULL,'FGC 2189',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142570,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142570,34.75,0.49,89,68788,75,NULL,'IR','UGC 11151',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00011,NULL,'14.9',0.3,'S',NULL,NULL,NULL,NULL,1,273.023208333,29.15189,0.357,NULL,54337381400,849021584,13265962,14.9),(142571,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142571,33.75,NULL,56.2,68789,NULL,NULL,'Dipole','UGC 11150',NULL,'2010Ap&SS.325..163P',2010,1,1.96,NULL,'G',0.000103,NULL,'15.5',0.27,'Sc',NULL,NULL,NULL,NULL,1,273.028875,25.59539,0.713,NULL,54303897146,848498392,13257787,15.5),(142572,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142572,33.76,NULL,56.5,68789,NULL,NULL,'Dipole + Quadrupole','UGC 11150',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142573,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142573,33.76,NULL,56.6,68789,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11150',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142574,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142574,33.78,0.49,57.1,68789,75,NULL,'IR','UGC 11150',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142575,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142575,33.9,NULL,60.2,68789,NULL,NULL,NULL,'UGC 11150',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142576,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142576,35.57,0.56,130,68790,70,NULL,NULL,'2MASX J18121426-7315055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000123,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,273.059333,-73.25161,0.401,NULL,48512226263,758003535,11843805,14.8),(142577,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142577,33.22,0.25,44.1,68791,74.4,NULL,NULL,'NGC 6545',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000107,NULL,'14.16',0.9,'E1',NULL,NULL,NULL,NULL,1,273.061541667,-63.77614,0.313,NULL,48934019742,764594058,11946782,14.16),(142578,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142578,33.31,0.48,45.9,68791,70,NULL,NULL,'NGC 6545',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142579,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142579,33.82,0.4,58.1,68791,NULL,NULL,'mean','NGC 6545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142580,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142580,34.29,0.45,72.1,68791,NULL,NULL,'K','NGC 6545',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142581,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142581,32.16,0.4,27.1,68792,75,NULL,NULL,'NGC 6585',NULL,'2008Ap.....51..336K',2008,1,1.9,NULL,'G',0.00002,NULL,'13.80',0.4,'S?',NULL,NULL,NULL,NULL,1,273.090791667,39.633,0.125,NULL,54285757292,848214957,13253358,13.8),(142582,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142582,32.42,0.43,30.4,68792,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6585',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142583,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142583,32.52,0.43,31.9,68792,75,NULL,'3.6 micron, color corrected','NGC 6585',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142584,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142584,32.65,0.2,33.9,68792,74.4,NULL,NULL,'NGC 6585',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142585,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142585,32.79,0.49,36.2,68792,75,NULL,'IR','NGC 6585',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142586,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142586,32.96,0.47,39.1,68792,NULL,NULL,'H','NGC 6585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142587,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142587,33.02,0.46,40.2,68792,NULL,NULL,'J','NGC 6585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142588,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142588,33.1,0.45,41.7,68792,NULL,NULL,'K','NGC 6585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142589,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142589,33.11,0.4,41.9,68792,NULL,NULL,'mean','NGC 6585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142590,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142590,35.32,0.49,116,68793,75,NULL,'IR','NGC 6608',NULL,'2011yCatp016004901K',2011,1,0.83,'MCG misidentifies this object as NGC 6609.','G',NULL,NULL,'16',0.1,'Sd',NULL,NULL,NULL,NULL,1,273.120333,61.29817,0.153,NULL,53044611022,828822047,12950344,16),(142591,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142591,35.76,NULL,142,68793,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 6608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142592,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142592,35.77,NULL,143,68793,NULL,NULL,'Dipole + Quadrupole','NGC 6608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142593,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142593,35.78,NULL,144,68793,NULL,NULL,NULL,'NGC 6608',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142594,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142594,35.8,NULL,144,68793,NULL,NULL,'Dipole','NGC 6608',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142595,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142595,35.46,0.46,124,68794,70,NULL,NULL,'ESO 229- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.0R',0.6,'S0',NULL,NULL,NULL,NULL,1,273.1339583,-48.15461,0.477,NULL,48871857762,763622777,11931605,14),(142596,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142596,33.03,0.4,40.4,68795,75,NULL,'B','UGC 11152',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'14.1',1.1,'SBdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,273.134333,18.59892,0.613,NULL,53831053389,841110209,13142347,14.1),(142597,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142597,33.9,0.47,60.4,68796,NULL,NULL,'H','NGC 6621',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000007,NULL,'14',0.7,'Sb: pec    HII;LIRG','Pair member (points to parent)',NULL,NULL,NULL,1,273.230458333,68.36344,0.217,NULL,53553644579,836775696,13074620,14),(142598,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142598,33.96,0.45,62,68796,NULL,NULL,'K','NGC 6621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142599,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142599,34.02,0.46,63.7,68796,NULL,NULL,'J','NGC 6621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142600,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142600,34.54,0.4,81,68796,NULL,NULL,'mean','NGC 6621',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142601,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142601,35.07,0.47,103,68797,70,NULL,NULL,'2MASX J18131647-4920047',NULL,'2014MNRAS.445.2677S',2014,1,0.16,NULL,'G',0.00008,NULL,'14.3R',NULL,'S?',NULL,NULL,NULL,NULL,1,273.318583,-49.33467,0.453,NULL,48860895760,763451496,11928929,14.3),(142602,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142602,35.21,0.56,110,68798,70,NULL,NULL,'2MASX J18132081-4122266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,273.336667,-41.37406,0.477,NULL,47529175399,742643365,11603802,15.9),(142603,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142603,33.79,0.8,57.2,68799,75,NULL,'HMCL, I','IC 4680',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00015,NULL,'13.88',0.8,'(R\')SB(rs)ab',NULL,NULL,NULL,NULL,1,273.3735,-64.47672,0.285,NULL,48936533885,764633341,11947395,13.88),(142604,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142604,33.58,0.4,52,68799,75,NULL,'HMCL, I, raw','IC 4680',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142605,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142605,33.76,0.46,56.4,68799,NULL,NULL,'J','IC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142606,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142606,33.79,0.47,57.2,68799,NULL,NULL,'H','IC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142607,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142607,33.8,0.4,57.5,68799,75,NULL,'HMCL, I, inv','IC 4680',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142608,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142608,33.8,0.45,57.5,68799,NULL,NULL,'K','IC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142609,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142609,33.81,0.4,57.8,68799,75,NULL,'HMCL, I, cor','IC 4680',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142610,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142610,33.9,0.4,60.3,68799,NULL,NULL,'mean','IC 4680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142611,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142611,32.84,0.43,36.9,68800,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6586',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000107,NULL,'14.6',0.5,'S',NULL,NULL,NULL,NULL,1,273.410417,21.09008,0.621,NULL,54574759713,852730620,13323915,14.6),(142612,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142612,36.63,0.62,212,68801,70,NULL,NULL,'2MASX J18134287-7309202',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,273.428667,-73.15569,0.361,NULL,48511960191,757999377,11843740,15.6),(142613,'Faber-Jackson','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142613,32.55,0.44,32.4,68802,95,NULL,'Weighted Mean','NGC 6587',NULL,'1984ApJS...56...91D',1984,1,1.3,'UZC gives v = 8301 +/- 28 km/sec.','G',0.000073,NULL,'13.9',1.1,'SAB0-:',NULL,NULL,NULL,NULL,1,273.4620417,18.82519,0.609,NULL,53831759352,841121239,13142519,13.9),(142614,'Faber-Jackson','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142614,32.91,0.46,38.2,68802,95,NULL,'Michard 1979a','NGC 6587',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142615,'Faber-Jackson','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142615,33,0.63,39.8,68802,95,NULL,'Michard 1979b, c','NGC 6587',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142616,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142616,34.66,0.2,85.5,68803,74.4,NULL,NULL,'NGC 6617',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',NULL,NULL,'15.2',1,'SA(s)d',NULL,NULL,NULL,NULL,1,273.5105,61.31956,0.153,NULL,53043768823,828808887,12950138,15.2),(142617,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142617,34.74,0.5,88.6,68803,NULL,NULL,NULL,'NGC 6617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142618,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142618,34.79,0.49,90.7,68803,NULL,NULL,'Malmquist cor.','NGC 6617',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142619,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142619,36.07,0.73,164,68804,70,NULL,NULL,'2MASX J18141188-8036568',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,273.549667,-80.61578,0.581,NULL,48355734029,755558344,11805599,16.6),(142620,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142620,32.82,0.8,36.7,68805,75,NULL,'MAT, I','ESO 140- G 012',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00002,NULL,'13.55',1.4,'(R)SAB(rs)a    HII',NULL,NULL,NULL,NULL,1,273.570416667,-60.09169,0.389,NULL,48971937783,765186527,11956039,13.55),(142621,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142621,32.59,0.43,33,68805,75,NULL,'MAT, I, raw','ESO 140- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142622,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142622,32.66,0.32,34.1,68805,85,NULL,'I, raw','ESO 140- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142623,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142623,32.69,0.32,34.5,68805,85,NULL,'I, inv','ESO 140- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142624,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142624,32.7,0.43,34.7,68805,75,NULL,'MAT, I, inv','ESO 140- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142625,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142625,32.97,0.43,39.3,68805,75,NULL,'MAT, I, cor','ESO 140- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142626,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142626,37.19,0.58,275,68806,70,NULL,NULL,'2MASX J18143088-4434143',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,273.62875,-44.57067,0.581,NULL,51005514816,796961169,12452518,15.5),(142627,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142627,33.26,0.49,44.9,68807,75,NULL,'IR','UGC 11182',NULL,'2011yCatp016004901K',2011,1,1.29,NULL,'G',0.000053,NULL,'16.5',0.13,'Sc',NULL,NULL,NULL,NULL,1,273.6922083,56.49836,0.137,NULL,53103652603,829744571,12964758,16.5),(142628,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142628,34,0.43,63.2,68807,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11182',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142629,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142629,34.69,NULL,86.7,68807,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11182',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142630,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142630,34.71,NULL,87.3,68807,NULL,NULL,'Dipole + Quadrupole','UGC 11182',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142631,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142631,34.71,NULL,87.4,68807,NULL,NULL,'Dipole','UGC 11182',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142632,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142632,34.75,NULL,89.1,68807,NULL,NULL,NULL,'UGC 11182',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142633,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142633,33.98,0.8,62.4,68808,75,NULL,'MAT, I','IC 4692',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000026,NULL,'14.27',0.9,'SB(r)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,273.7082083,-58.69378,0.337,NULL,48969958381,765155599,11955556,14.27),(142634,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142634,33.37,0.32,47.2,68808,85,NULL,'I, raw','IC 4692',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142635,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142635,33.41,0.32,48,68808,85,NULL,'I, inv','IC 4692',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142636,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142636,33.46,0.43,49.3,68808,75,NULL,'MAT, I, raw','IC 4692',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142637,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142637,33.63,0.43,53.3,68808,75,NULL,'MAT, I, inv','IC 4692',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142638,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142638,33.75,0.43,56.2,68808,75,NULL,'MAT, I, cor','IC 4692',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142639,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142639,34.1,0.4,66.1,68808,NULL,NULL,'mean','IC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142640,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142640,34.18,0.47,68.6,68808,NULL,NULL,'H','IC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142641,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142641,34.2,0.09,69.3,68808,NULL,NULL,NULL,'IC 4692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142642,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142642,34.23,0.46,70,68808,NULL,NULL,'J','IC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142643,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142643,34.3,0.45,72.6,68808,NULL,NULL,'K','IC 4692',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142644,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142644,32.09,0.4,26.1,68809,75,NULL,'B','UGC 11193',NULL,'1988NBGC.C....0000T',1988,1,1.3,'Misidentified in CGCG and UGC as \'NGC 6651\'. NED follows RC2.','G',0.000013,NULL,'14.80',0.9,'Im',NULL,NULL,NULL,NULL,1,273.753333,71.00583,0.173,NULL,52694788612,823356072,12864938,14.8),(142645,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142645,35.14,0.52,107,68810,70,NULL,NULL,'2MASX J18152387-7301344',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,'(R)SB(r)0^+',NULL,NULL,NULL,NULL,1,273.8497917,-73.02625,0.361,NULL,48457092634,757142072,11830344,15.6),(142646,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142646,32.5,0.8,31.7,68811,75,NULL,'MAT, I','IC 4694',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000019,NULL,'13.72',0.8,'SB(s)c:',NULL,NULL,NULL,NULL,1,273.8602083,-58.20892,0.353,NULL,48959061273,764985332,11952895,13.72),(142647,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142647,32.77,0.8,35.8,68811,75,NULL,NULL,'IC 4694',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142648,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142648,31.85,0.32,23.4,68811,85,NULL,'I, raw','IC 4694',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142649,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142649,31.85,0.32,23.4,68811,85,NULL,'I, inv','IC 4694',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142650,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142650,32.06,0.43,25.8,68811,75,NULL,'MAT, I, raw','IC 4694',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142651,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142651,32.13,0.43,26.6,68811,75,NULL,'MAT, I, inv','IC 4694',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142652,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142652,32.46,0.4,31,68811,NULL,NULL,NULL,'IC 4694',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142653,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142653,32.47,0.43,31.1,68811,75,NULL,'MAT, I, cor','IC 4694',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142654,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142654,36,0.51,159,68812,70,NULL,NULL,'2MASX J18152771-4403516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.5R',NULL,'SB(r)0^+',NULL,NULL,NULL,NULL,1,273.865375,-44.06439,0.581,NULL,51005453336,796960208,12452503,13.5),(142655,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142655,34.54,0.53,80.8,68813,70,NULL,NULL,'2MASX J18153889-5836496',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,273.912083,-58.61378,0.345,NULL,48958657038,764979016,11952797,14.9),(142656,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142656,37.23,0.55,279,68814,70,NULL,NULL,'2MASX J18155395-6458321',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,273.974875,-64.97558,0.317,NULL,48938743000,764667859,11947935,13.9),(142657,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142657,30.55,0.43,12.9,68815,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 084-030',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.000037,NULL,'14.7',0.3,'Sc;HSB',NULL,NULL,NULL,NULL,1,273.9927083,13.78533,0.693,NULL,53874769238,841793269,13153019,14.7),(142658,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142658,36.97,0.55,248,68816,70,NULL,NULL,'2MASX J18160366-6439310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.01525,-64.65856,0.321,NULL,48938658620,764666540,11947914,15.8),(142659,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142659,33.2,0.8,43.6,68817,75,NULL,'MAT, I','IC 4682',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000021,NULL,'13.23',1.6,'(R\')SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,274.107125,-71.58131,0.533,NULL,48459427673,757178557,11830914,13.23),(142660,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142660,32.85,NULL,37.2,68817,NULL,NULL,'B','IC 4682',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142661,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142661,32.85,NULL,37.2,68817,NULL,NULL,'I','IC 4682',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142662,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142662,33.01,0.47,40.1,68817,NULL,NULL,'H','IC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142663,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142663,33.01,0.46,40.1,68817,NULL,NULL,'J','IC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142664,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142664,33.04,0.45,40.6,68817,NULL,NULL,'K','IC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142665,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142665,33.15,0.43,42.7,68817,75,NULL,'MAT, I, raw','IC 4682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142666,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142666,33.3,0.32,45.7,68817,85,NULL,'I, raw','IC 4682',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142667,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142667,33.36,0.4,46.9,68817,NULL,NULL,'mean','IC 4682',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142668,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142668,33.37,0.32,47.3,68817,85,NULL,'I, inv','IC 4682',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142669,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142669,33.44,0.43,48.7,68817,75,NULL,'MAT, I, inv','IC 4682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142670,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142670,33.48,0.43,49.7,68817,75,NULL,'MAT, I, cor','IC 4682',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142671,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142671,33.68,0.08,54.6,68817,NULL,NULL,NULL,'IC 4682',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142672,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142672,35.94,0.64,154,68818,70,NULL,NULL,'2MASX J18163769-6903128',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.157167,-69.05358,0.437,NULL,48454989520,757109211,11829831,15.7),(142673,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142673,35.96,0.6,155,68819,70,NULL,NULL,'2MASX J18165031-4215264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.2095417,-42.25733,0.473,NULL,47519525642,742492588,11601446,15.4),(142674,'FP','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142674,36.89,0.59,239,68820,70,NULL,NULL,'2MASX J18170775-7340018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,274.282583333,-73.66719,0.585,NULL,48512162242,758002535,11843789,16.9),(142675,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,NULL,142675,33.7,0.43,55,68821,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11188',NULL,'2014MNRAS.444..527S',2014,1,1.28,NULL,'G',0.000011,NULL,'15.8',0.16,'Sd',NULL,NULL,NULL,NULL,1,274.373625,18.90364,0.953,NULL,54566306935,852598545,13321852,15.8),(142676,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:01','1',NULL,'R',142676,33.92,0.49,60.8,68821,75,NULL,'IR','UGC 11188',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142677,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142677,34.56,NULL,81.6,68821,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11188',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142678,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142678,34.57,NULL,82,68821,NULL,NULL,'Dipole + Quadrupole','UGC 11188',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142679,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142679,34.57,NULL,82.2,68821,NULL,NULL,'Dipole','UGC 11188',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142680,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142680,34.62,NULL,84.1,68821,NULL,NULL,NULL,'UGC 11188',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142681,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142681,36.4,0.67,191,68822,70,NULL,NULL,'2MASX J18173170-6921195',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.38225,-69.3555,0.349,NULL,48455086739,757110730,11829855,15.6),(142682,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142682,36.03,0.73,161,68823,70,NULL,NULL,'2MASX J18174773-7140157',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,274.449167,-71.67111,0.533,NULL,48459953852,757186778,11831043,17.3),(142683,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142683,33.98,0.2,62.5,68824,74.4,NULL,NULL,'UGC 11194',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000023,NULL,'14.05',0.9,'SBbc',NULL,NULL,NULL,NULL,1,274.486667,26.75722,0.541,NULL,54358156070,849346188,13271034,14.05),(142684,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142684,33.99,0.43,62.7,68824,75,NULL,'3.6 micron, color corrected','UGC 11194',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142685,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142685,34.06,0.43,64.9,68824,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11194',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142686,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142686,34.08,0.32,65.5,68824,NULL,NULL,NULL,'UGC 11194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142687,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142687,34.13,0.31,67,68824,NULL,NULL,'Malmquist cor.','UGC 11194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142688,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142688,33.87,0.47,59.5,68825,70,NULL,NULL,'MC 1805-833',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,274.4982083,-83.36144,0.545,NULL,48359647424,755619491,11806554,14.8),(142689,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142689,31.68,0.43,21.7,68826,75,NULL,'3.6 micron, color + selection bias corrected','ESO 182-IG 010',NULL,'2014MNRAS.444..527S',2014,1,1.9,NULL,'G',0.000003,NULL,'13.63',1.4,'SAB(r)bc',NULL,NULL,NULL,NULL,1,274.6275417,-54.69439,0.445,NULL,48887650719,763869542,11935461,13.63),(142690,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142690,33.56,0.4,51.5,68826,NULL,NULL,'mean','ESO 182-IG 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142691,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142691,33.7,0.47,54.9,68826,NULL,NULL,'H','ESO 182-IG 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142692,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142692,36.78,0.55,227,68827,70,NULL,NULL,'2MASX J18184165-7147368',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.6735417,-71.7935,0.533,NULL,48458130289,757158285,11830598,14.8),(142693,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142693,34.35,NULL,74.1,68828,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2198',NULL,'2010Ap&SS.325..163P',2010,1,0.75,NULL,'G',NULL,NULL,'17.31',0.09,'Scd',NULL,NULL,NULL,NULL,1,274.737917,52.90472,0.161,NULL,52927963690,826999432,12921866,17.31),(142694,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142694,34.37,NULL,74.9,68828,NULL,NULL,'Dipole + Quadrupole','FGC 2198',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142695,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142695,34.39,NULL,75.6,68828,NULL,NULL,'Dipole','FGC 2198',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142696,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142696,34.61,NULL,83.6,68828,NULL,NULL,NULL,'FGC 2198',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142697,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2000dm',NULL,142697,34,0.21,62.2,68829,70,NULL,'SALT 2','UGC 11198',0.01507,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',0.000066,NULL,'13.5B',0.2,'Sab',NULL,NULL,NULL,NULL,1,274.746625,16.24956,0.973,NULL,53879888497,841873257,13154269,13.5),(142698,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142698,34.38,0.49,75,68829,75,NULL,'IR','UGC 11198',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142699,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142699,34.79,0.5,90.7,68830,70,NULL,NULL,'ESO 280- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000143,NULL,'13.2R',0.5,'(R\'_1)SAB(s)a',NULL,NULL,NULL,NULL,1,274.831167,-42.63083,0.497,NULL,51012398027,797068719,12454198,13.2),(142700,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142700,34.18,0.4,68.4,68831,NULL,NULL,'mean','NGC 6623',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000103,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,274.92875,23.70556,0.645,NULL,54298747336,848417927,13256530,NULL),(142701,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142701,34.48,0.45,78.6,68831,NULL,NULL,'K','NGC 6623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142702,'HII region diameter','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142702,33.39,NULL,47.7,68832,NULL,NULL,NULL,'NGC 6643',NULL,'1988ApL&C..27...41S',1988,1,3.8,NULL,'G',0.000005,NULL,'11.73',1.9,'SA(rs)c','Isolated galaxy',NULL,NULL,NULL,1,274.943375,74.56836,0.217,NULL,52721928815,823780137,12871564,11.73),(142703,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142703,31.96,0.8,24.6,68832,75,NULL,'A82, H','NGC 6643',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142704,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142704,30.94,NULL,15.4,68832,75,NULL,'CO','NGC 6643',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142705,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142705,31.05,NULL,16.2,68832,75,NULL,'HI','NGC 6643',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142706,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142706,31.12,0.69,16.7,68832,100,NULL,'mid-IR','NGC 6643',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142707,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142707,31.22,0.4,17.5,68832,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6643',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142708,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142708,31.36,0.4,18.7,68832,NULL,NULL,'mean','NGC 6643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142709,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142709,31.43,0.46,19.3,68832,NULL,NULL,'J','NGC 6643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142710,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142710,31.45,0.45,19.5,68832,NULL,NULL,'K','NGC 6643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142711,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142711,31.46,0.43,19.6,68832,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6643',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142712,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142712,31.51,0.47,20.1,68832,75,NULL,'A82, H, raw','NGC 6643',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142713,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142713,31.53,0.43,20.2,68832,75,NULL,'3.6 micron, color corrected','NGC 6643',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142714,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142714,31.57,0.38,20.6,68832,NULL,NULL,NULL,'NGC 6643',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142715,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142715,31.63,0.47,21.2,68832,75,NULL,'A82, H, inv','NGC 6643',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142716,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142716,31.64,0.2,21.3,68832,74.4,NULL,NULL,'NGC 6643',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142717,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142717,31.8,0.54,22.9,68832,NULL,NULL,NULL,'NGC 6643',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142718,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142718,31.81,0.47,23,68832,75,NULL,'A82, H, cor','NGC 6643',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142719,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142719,31.84,0.53,23.4,68832,NULL,NULL,'Malmquist cor.','NGC 6643',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142720,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142720,32.04,0.4,25.5,68832,75,NULL,'B','NGC 6643',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142721,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142721,36.8,0.61,229,68833,70,NULL,NULL,'2MASX J18195219-6435205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,274.967625,-64.58906,0.333,NULL,48935413086,764615829,11947122,15.1),(142722,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142722,34.22,0.8,69.8,68834,75,NULL,'MAT, I','ESO 230- G 002',NULL,'1997ApJS..109..333W',1997,1,1.95,'Stars superposed.','G',0.000033,NULL,'13.81',0.2,'Sc',NULL,NULL,NULL,NULL,1,275.001708333,-51.53928,0.409,NULL,48919767740,764371370,11943302,13.81),(142723,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142723,33.82,0.32,58,68834,85,NULL,'I, raw','ESO 230- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142724,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142724,33.84,0.32,58.5,68834,85,NULL,'I, inv','ESO 230- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142725,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142725,33.88,0.43,59.6,68834,75,NULL,'MAT, I, raw','ESO 230- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142726,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142726,33.94,0.49,61.3,68834,75,NULL,'IR','ESO 230- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142727,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142727,33.99,0.43,62.9,68834,75,NULL,'MAT, I, inv','ESO 230- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142728,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142728,34.14,0.43,67.2,68834,75,NULL,'MAT, I, cor','ESO 230- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142729,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142729,34.14,NULL,67.2,68834,NULL,NULL,NULL,'ESO 230- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142730,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142730,34.22,0.45,69.8,68834,NULL,NULL,'Malmquist cor.','ESO 230- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142731,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142731,34.26,NULL,71.1,68834,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 230- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142732,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142732,34.27,NULL,71.4,68834,NULL,NULL,'Dipole + Quadrupole','ESO 230- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142733,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142733,34.27,NULL,71.5,68834,NULL,NULL,'Dipole','ESO 230- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142734,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142734,34.44,0.41,77.2,68834,NULL,NULL,NULL,'ESO 230- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142735,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142735,34.48,0.2,78.7,68834,74.4,NULL,NULL,'ESO 230- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142736,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142736,34.63,0.48,84.5,68835,70,NULL,NULL,'2MASX J18200383-4407442',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.0160417,-44.12897,0.477,NULL,51017194742,797143667,12455369,14.2),(142737,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142737,33.91,0.8,60.5,68836,75,NULL,'HMCL, I','IC 4696',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000022,NULL,'13.47',0.9,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,275.074625,-64.73408,0.365,NULL,48935337484,764614648,11947103,13.47),(142738,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142738,33.91,0.8,60.6,68836,75,NULL,'MAT, I','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142739,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142739,32.92,0.4,38.4,68836,75,NULL,'HMCL, I, raw','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142740,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142740,33.11,0.4,41.9,68836,75,NULL,'HMCL, I, inv','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142741,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142741,33.26,0.4,44.9,68836,75,NULL,'HMCL, I, cor','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142742,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142742,33.48,0.32,49.7,68836,85,NULL,'I, raw','IC 4696',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142743,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142743,33.49,0.46,50,68836,NULL,NULL,'J','IC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142744,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142744,33.51,0.43,50.3,68836,75,NULL,'MAT, I, raw','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142745,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142745,33.55,0.32,51.3,68836,85,NULL,'I, inv','IC 4696',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142746,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142746,33.57,0.45,51.7,68836,NULL,NULL,'K','IC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142747,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142747,33.58,0.47,51.9,68836,NULL,NULL,'H','IC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142748,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142748,33.78,0.43,56.9,68836,75,NULL,'MAT, I, cor','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142749,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142749,33.8,0.43,57.5,68836,75,NULL,'MAT, I, inv','IC 4696',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142750,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142750,33.95,0.4,61.6,68836,NULL,NULL,'mean','IC 4696',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142751,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142751,34.03,0.08,64.1,68836,NULL,NULL,NULL,'IC 4696',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142752,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142752,33.84,0.8,58.5,68837,75,NULL,'MAT, I','IC 4698',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'15.31',0.3,'Sb:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,275.2497083,-63.34794,0.329,NULL,48978844484,765294445,11957725,15.31),(142753,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142753,33.84,0.8,58.6,68837,75,NULL,'HMCL, I','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142754,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142754,33.39,0.32,47.6,68837,85,NULL,'I, raw','IC 4698',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142755,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142755,33.4,0.32,47.9,68837,85,NULL,'I, inv','IC 4698',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142756,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142756,33.44,0.4,48.8,68837,75,NULL,'HMCL, I, raw','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142757,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142757,33.52,0.4,50.7,68837,75,NULL,'HMCL, I, inv','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142758,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142758,33.54,0.49,51.1,68837,75,NULL,'IR','IC 4698',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142759,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142759,33.58,0.43,52,68837,75,NULL,'MAT, I, raw','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142760,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142760,33.69,0.43,54.6,68837,75,NULL,'MAT, I, inv','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142761,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142761,33.7,0.4,55,68837,75,NULL,'HMCL, I, cor','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142762,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142762,33.83,0.43,58.2,68837,75,NULL,'MAT, I, cor','IC 4698',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142763,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142763,33.9,0.12,60.4,68837,NULL,NULL,NULL,'IC 4698',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142764,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142764,35.71,0.6,138,68838,70,NULL,NULL,'2MASX J18210575-5115500',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.273875,-51.26394,0.313,NULL,48921878151,764404346,11943817,14.5),(142765,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142765,34.83,0.68,92.4,68839,70,NULL,NULL,'2MASX J18210765-7641418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.281875,-76.69503,0.721,NULL,48483476230,757554316,11836786,14.6),(142766,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142766,36.14,0.51,169,68840,70,NULL,NULL,'2MASX J18212253-4715119',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.343916667,-47.25333,0.377,NULL,51009137955,797017780,12453402,15.3),(142767,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142767,33.49,0.4,49.8,68841,75,NULL,'Edat, raw','NGC 6557',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00015,NULL,'14.3',1.1,'SA(r)0^0^',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,275.353417,-76.58297,0.721,NULL,48483363197,757552549,11836758,14.3),(142768,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142768,33.82,0.4,58.1,68841,75,NULL,'Edat, cor','NGC 6557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142769,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142769,33.61,0.48,52.8,68841,70,NULL,NULL,'NGC 6557',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142770,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142770,33.97,0.45,62.1,68841,NULL,NULL,'K','NGC 6557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142771,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142771,34.25,0.4,70.9,68841,NULL,NULL,'mean','NGC 6557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142772,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142772,34,0.49,63.2,68842,75,NULL,'IR','NGC 6636 NED01',NULL,'2011yCatp016004901K',2011,1,2.2,'UZC has V = 3995 +- 37 km/sec.','G',0.000083,NULL,'14',0.4,'Sc             Sy2','Pair member (points to parent)',NULL,NULL,NULL,1,275.511958333,66.61656,0.241,NULL,53018982532,828421602,12944087,14),(142773,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142773,33.81,NULL,57.9,68843,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11210',NULL,'2010Ap&SS.325..163P',2010,1,1.38,NULL,'G',0.000017,NULL,'17.',0.1,'Sd',NULL,NULL,NULL,NULL,1,275.532125,21.17739,0.901,NULL,54570612451,852665819,13322903,17),(142774,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142774,33.83,NULL,58.3,68843,NULL,NULL,'Dipole + Quadrupole','UGC 11210',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142775,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142775,33.83,NULL,58.4,68843,NULL,NULL,'Dipole','UGC 11210',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142776,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142776,33.8,0.49,57.6,68844,75,NULL,'IR','ESO 024- G 014',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'14.13',0.3,'S...',NULL,NULL,NULL,NULL,1,275.5559583,-80.16572,0.369,NULL,48355466118,755554158,11805533,14.13),(142777,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142777,34.3,0.49,72.3,68844,NULL,NULL,NULL,'ESO 024- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142778,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142778,34.34,0.2,73.8,68844,74.4,NULL,NULL,'ESO 024- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142779,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142779,34.43,0.46,76.9,68844,NULL,NULL,'Malmquist cor.','ESO 024- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142780,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142780,32.37,0.8,29.8,68845,75,NULL,'B','NGC 6438',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00007,NULL,'12.10',1.3,'S0 pec (Ring A)','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,275.572833,-85.40206,0.341,NULL,48327776276,755121504,11798773,12.1),(142781,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142781,34.68,NULL,86.1,68846,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 395- G 002',NULL,'2010Ap&SS.325..163P',2010,1,2.45,NULL,'G',0.000037,NULL,'15.1',0.35,'Sc',NULL,NULL,NULL,NULL,1,275.609917,-35.67792,0.537,NULL,47558456408,743100881,11610951,15.1),(142782,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142782,34.68,NULL,86.3,68846,NULL,NULL,'Dipole','ESO 395- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142783,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142783,34.68,NULL,86.4,68846,NULL,NULL,'Dipole + Quadrupole','ESO 395- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142784,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142784,36.44,0.55,194,68847,70,NULL,NULL,'2MFGC 14370',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.62675,-48.56169,0.373,NULL,48866990129,763546720,11930417,15.1),(142785,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142785,32.45,0.8,30.9,68848,75,NULL,NULL,'NGC 6438A',NULL,'1988NBGC.C....0000T',1988,1,2.7,NULL,'G',0.000097,NULL,'12.57',1,'S pec (Ring B)','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,275.647875,-85.40633,0.341,NULL,48327599248,755118738,11798730,12.57),(142786,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142786,33.53,0.25,49.9,68849,74.2,NULL,'SALT 2','NGC 6627',0.01757,'2010ApJ...716..712A',2010,1,1.3,NULL,'G',0.000025,NULL,'14.3',1.1,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,275.662166667,15.698,1.101,NULL,53879291127,841863923,13154123,14.3),(142787,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142787,33.69,0.2,53.6,68849,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','NGC 6627',0.01757,'2011A&A...526A..81B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142788,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142788,34.11,0.19,65.3,68849,70,NULL,'SALT 2','NGC 6627',0.01757,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142789,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142789,34.08,0.08,65.5,68849,74.4,NULL,NULL,'NGC 6627',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142790,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142790,34.19,0.08,67.6,68849,72,NULL,NULL,'NGC 6627',0.01757,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142791,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142791,34.19,0.29,67.7,68849,70,NULL,'SALT','NGC 6627',0.01757,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142792,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142792,34.21,0.18,68.2,68849,73.8,NULL,'SALT 2 (SNANA)','NGC 6627',0.0174,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142793,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142793,34.22,0.13,68.5,68849,70,NULL,NULL,'NGC 6627',0.01757,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142794,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142794,34.23,0.19,68.9,68849,72,NULL,NULL,'NGC 6627',0.01757,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142795,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142795,34.34,0.21,72.6,68849,65,NULL,'MLCS31','NGC 6627',0.01757,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142796,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142796,34.35,0.32,72.8,68849,65,NULL,'SALT','NGC 6627',0.01757,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142797,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142797,34.35,0.06,72.9,68849,70,NULL,'SALT 2','NGC 6627',0.01757,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142798,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142798,34.35,0.2,73,68849,65,NULL,'MLCS17','NGC 6627',0.01757,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142799,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142799,34.4,0.1,73.1,68849,65,NULL,'MLCS2k2','NGC 6627',0.01757,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142800,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142800,34.36,0.1,73.2,68849,65,NULL,'MLCS2k2','NGC 6627',0.01757,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142801,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142801,34.33,0.17,73.5,68849,70.8,NULL,NULL,'NGC 6627',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142802,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142802,34.4,0.23,74.7,68849,65,NULL,'SALT2','NGC 6627',0.01757,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142803,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142803,34.47,0.23,77,68849,65,NULL,NULL,'NGC 6627',0.01757,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142804,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142804,34.48,0.02,77.2,68849,65,NULL,'SALT','NGC 6627',0.01757,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142805,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 1998V',NULL,142805,34.63,0.14,84.3,68849,60,NULL,NULL,'NGC 6627',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142806,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142806,34.35,0.47,74.2,68850,70,NULL,NULL,'IC 4702',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.01',1,'(R)SB(r)0/a',NULL,NULL,NULL,NULL,1,275.765917,-59.23894,0.329,NULL,48970192031,765159250,11955613,14.01),(142807,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142807,34.59,0.17,80.6,68851,74.2,NULL,'SALT 2','CGCG 172-029',0.026962,'2010ApJ...716..712A',2010,1,0.8,NULL,'G',0.00011,NULL,'14.9',0.8,NULL,NULL,NULL,NULL,NULL,1,275.767208333,29.90139,0.437,NULL,54463662187,850994721,13296792,14.9),(142808,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142808,35.17,0.09,108,68851,74.4,NULL,NULL,'CGCG 172-029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142809,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142809,35.35,0.15,114,68851,73.8,NULL,'SALT 2 (SNANA)','CGCG 172-029',0.0271,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142810,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142810,35.37,0.03,115,68851,72,NULL,'MLCS31','CGCG 172-029',0.026962,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142811,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142811,35.38,0.17,116,68851,65,NULL,'MLCS31','CGCG 172-029',0.026962,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142812,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142812,35.38,0.1,116,68851,72,NULL,'MLCS2k2, R(V) = 3.1','CGCG 172-029',0.026962,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142813,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142813,35.4,0.16,117,68851,70,NULL,'SALT 2','CGCG 172-029',0.026962,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142814,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142814,35.42,0.17,118,68851,65,NULL,'SALT','CGCG 172-029',0.026962,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142815,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142815,35.42,0.16,118,68851,65,NULL,'MLCS17','CGCG 172-029',0.026962,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142816,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142816,35.42,0.08,118,68851,72,NULL,'MLCS2k2, R(V) = 1.7','CGCG 172-029',0.026962,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142817,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142817,35.48,0.19,121,68851,65,NULL,'SALT2','CGCG 172-029',0.026962,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142818,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2007co',NULL,142818,36.06,0.04,159,68851,70,NULL,'SALT 2','CGCG 172-029',0.026962,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142819,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142819,34.87,0.56,94,68852,70,NULL,NULL,'ESO 024-IG 015 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'1979MNRAS.188..349F has z = 0.0045? +- 0.007.','G',0.00015,NULL,'14.4R',NULL,'Bright nucleus',NULL,NULL,NULL,NULL,1,275.778833,-77.69697,0.649,NULL,48472694606,757385853,11834153,14.4),(142820,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142820,34.49,0.8,79,68853,75,NULL,'MAT, I','ESO 280- G 013',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000013,NULL,'11.74',0.6,'Sb',NULL,NULL,NULL,NULL,1,275.824417,-43.14253,0.413,NULL,51012639834,797072497,12454257,11.74),(142821,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142821,33.84,0.43,58.7,68853,75,NULL,'MAT, I, raw','ESO 280- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142822,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142822,33.97,0.47,62.3,68853,NULL,NULL,'H','ESO 280- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142823,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142823,34.01,0.46,63.2,68853,NULL,NULL,'J','ESO 280- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142824,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142824,34.03,0.45,64.1,68853,NULL,NULL,'K','ESO 280- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142825,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142825,34.17,0.49,68.3,68853,75,NULL,'IR','ESO 280- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142826,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142826,34.18,0.43,68.5,68853,75,NULL,'MAT, I, inv','ESO 280- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142827,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142827,34.21,0.32,69.5,68853,85,NULL,'I, raw','ESO 280- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142828,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142828,34.21,0.31,69.5,68853,NULL,NULL,NULL,'ESO 280- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142829,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142829,34.25,0.43,70.7,68853,75,NULL,'MAT, I, cor','ESO 280- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142830,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142830,34.25,0.2,70.8,68853,74.4,NULL,NULL,'ESO 280- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142831,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142831,34.3,0.32,72.3,68853,85,NULL,'I, inv','ESO 280- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142832,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142832,34.35,0.29,74,68853,NULL,NULL,'Malmquist cor.','ESO 280- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142833,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142833,34.43,0.4,76.8,68853,NULL,NULL,'mean','ESO 280- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142834,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142834,33.56,0.49,51.5,68854,75,NULL,'IR','UGC 11225',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000017,NULL,'15.48',0.2,'Sdm:',NULL,NULL,NULL,NULL,1,275.836125,60.75606,0.161,NULL,53045583976,828837249,12950582,15.48),(142835,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142835,33.83,0.8,58.4,68855,75,NULL,'MAT, I','ESO 045- G 004',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000024,NULL,'13.36',1,'SAB(rs)cd',NULL,NULL,NULL,NULL,1,275.8429583,-72.73894,0.325,NULL,48458620045,757165938,11830717,13.36),(142836,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142836,33.95,0.32,61.7,68855,85,NULL,'I, raw','ESO 045- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142837,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142837,33.98,0.32,62.5,68855,85,NULL,'I, inv','ESO 045- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142838,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142838,33.99,0.43,62.8,68855,75,NULL,'MAT, I, raw','ESO 045- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142839,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142839,34.06,0.1,65,68855,NULL,NULL,NULL,'ESO 045- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142840,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142840,34.12,0.43,66.7,68855,75,NULL,'MAT, I, inv','ESO 045- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142841,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142841,34.16,0.43,67.8,68855,75,NULL,'MAT, I, cor','ESO 045- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142842,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142842,31.98,0.8,24.9,68856,75,NULL,NULL,'UGC 11220',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000017,NULL,'17.',1.3,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,275.85625,40.94528,0.161,NULL,54236288898,847442014,13241281,17),(142843,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142843,34.66,0.55,85.6,68857,70,NULL,NULL,'2MASX J18233691-7111511',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,275.903833333,-71.19747,0.513,NULL,48469161164,757330643,11833291,16.1),(142844,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142844,37.14,0.65,268,68858,70,NULL,NULL,'2MASX J18233722-7042251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,275.905333,-70.70694,0.489,NULL,48468521364,757320646,11833135,17),(142845,'BL Lac Luminosity','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142845,39.12,NULL,667,68859,NULL,NULL,'Min. z = 0.17','NVSS J182338-345412',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'RadioS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,275.910875,-34.90333,NULL,NULL,47555487537,743054492,11610226,NULL),(142846,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142846,36.77,0.72,226,68860,70,NULL,NULL,'2MASX J18235542-6144311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,275.981,-61.74189,0.453,NULL,48979154673,765299291,11957801,15.8),(142847,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142847,34.51,0.49,79.9,68861,75,NULL,'IR','UGC 11230',NULL,'2011yCatp016004901K',2011,1,2.52,NULL,'G',0.000027,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,276.010041667,65.30625,0.173,NULL,53032510942,828632983,12947390,16),(142848,'BL Lac Luminosity','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142848,43.06,NULL,2460,68862,NULL,NULL,NULL,'[HB89] 1823+568',0.664,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.001,NULL,'18.4',NULL,'FSRQ           BLLAC',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,276.029458333,56.85042,0.229,NULL,53115141554,829924086,12967563,18.4),(142849,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142849,32.35,0.8,29.5,68863,75,NULL,'B','NGC 6654',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000033,NULL,'13.0',2.1,'(R\')SB(s)0/a','Isolated galaxy',NULL,NULL,NULL,1,276.031541667,73.18322,0.197,NULL,52736605859,824009466,12875147,13),(142850,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142850,35.66,0.48,136,68864,NULL,NULL,NULL,'ESO 024- G 016',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'13.56',0.4,'S...',NULL,NULL,NULL,NULL,1,276.035083,-78.69228,0.629,NULL,48537042098,758391282,11849863,13.56),(142851,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142851,35.7,0.47,138,68864,NULL,NULL,'Malmquist cor.','ESO 024- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142852,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142852,35.7,0.2,138,68864,74.4,NULL,NULL,'ESO 024- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142853,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142853,33.83,0.69,58.4,68865,100,NULL,'mid-IR','NGC 6651',NULL,'2013ApJ...771...88L',2013,1,1.6,'NGC 6651 is misidentified in CGCG and UGC.  NED follows MCG and RC2.','G',0.00002,NULL,'13.76',0.7,'SA(r)c',NULL,NULL,NULL,NULL,1,276.082125,71.60192,0.173,NULL,52693415601,823334618,12864603,13.76),(142854,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142854,34.14,0.43,67.4,68865,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6651',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142855,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142855,34.19,0.43,69,68865,75,NULL,'3.6 micron, color corrected','NGC 6651',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142856,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142856,34.32,0.47,73,68865,NULL,NULL,'H','NGC 6651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142857,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142857,34.32,0.45,73.1,68865,NULL,NULL,'K','NGC 6651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142858,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142858,34.32,0.2,73.1,68865,74.4,NULL,NULL,'NGC 6651',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142859,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142859,34.35,0.4,74.1,68865,NULL,NULL,'mean','NGC 6651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142860,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142860,34.36,0.46,74.4,68865,NULL,NULL,'J','NGC 6651',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142861,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142861,34.36,0.54,74.6,68865,NULL,NULL,NULL,'NGC 6651',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142862,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142862,34.41,0.53,76.1,68865,NULL,NULL,'Malmquist cor.','NGC 6651',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142863,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142863,33.41,0.69,48.1,68866,100,NULL,'mid-IR','ESO 395-G 004',NULL,'2013ApJ...771...88L',2013,1,1.2,'abs(b) < 10 degrees.','G',0.00003,NULL,'15.8',0.7,'Sbc',NULL,NULL,NULL,NULL,1,276.0972917,-34.18183,NULL,NULL,47736048322,745875755,11654308,15.8),(142864,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142864,35.86,0.68,149,68867,70,NULL,NULL,'2MASX J18243117-6135329',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,276.129875,-61.5925,0.453,NULL,48979207415,765300115,11957814,13.7),(142865,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142865,36.15,0.56,170,68868,70,NULL,NULL,'2MASX J18244364-6808369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.182083,-68.1435,0.409,NULL,49194039568,768656868,12010263,15.3),(142866,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142866,36.5,0.72,199,68869,70,NULL,NULL,'2MASX J18244910-4950392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.2045417,-49.84431,0.485,NULL,48911736253,764245878,11941341,15.6),(142867,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142867,33.8,0.36,57.7,68870,NULL,NULL,NULL,'ESO 140- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.49',0.3,'S...',NULL,NULL,NULL,NULL,1,276.2477917,-60.061,0.373,NULL,48966955031,765108672,11954823,15.49),(142868,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142868,33.85,0.2,58.9,68870,74.4,NULL,NULL,'ESO 140- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142869,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142869,33.92,0.34,60.8,68870,NULL,NULL,'Malmquist cor.','ESO 140- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142870,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142870,33.98,0.46,62.5,68871,NULL,NULL,'J','NGC 6632',NULL,'2007A&A...465...71T',2007,1,3,NULL,'G',0.000027,NULL,'12.94',1.4,'SA(rs)bc',NULL,NULL,NULL,NULL,1,276.262875,27.53531,0.517,NULL,54344971936,849140186,13267815,12.94),(142871,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142871,34.03,0.47,63.9,68871,NULL,NULL,'H','NGC 6632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142872,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142872,34.06,0.45,64.7,68871,NULL,NULL,'K','NGC 6632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142873,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142873,34.17,0.4,68.1,68871,NULL,NULL,'mean','NGC 6632',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142874,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142874,34,0.47,63.2,68872,70,NULL,NULL,'NGC 6614',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000073,NULL,'13.77',1.1,'SB(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,276.2800417,-63.24836,0.413,NULL,48978914586,765295540,11957742,13.77),(142875,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142875,34.09,0.25,65.8,68872,74.4,NULL,NULL,'NGC 6614',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142876,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142876,33.89,0.4,60,68872,NULL,NULL,'mean','NGC 6614',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142877,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142877,34.35,0.45,74,68872,NULL,NULL,'K','NGC 6614',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142878,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142878,36.11,0.69,167,68873,70,NULL,NULL,'2MASX J18252958-6452410',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.37325,-64.87808,0.353,NULL,48935552609,764618009,11947156,15.8),(142879,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142879,34.04,NULL,64.2,68874,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11231',NULL,'2010Ap&SS.325..163P',2010,1,0.81,NULL,'G',NULL,NULL,'17.',0.11,'Sdm',NULL,NULL,NULL,NULL,1,276.409583,29.3755,0.517,NULL,54463199098,850987485,13296679,17),(142880,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142880,34.08,NULL,65.5,68874,NULL,NULL,'Dipole + Quadrupole','UGC 11231',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142881,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142881,34.09,NULL,65.7,68874,NULL,NULL,'Dipole','UGC 11231',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142882,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142882,36.24,0.5,177,68875,70,NULL,NULL,'2MASX J18254825-6230400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.451,-62.51108,0.389,NULL,48979524867,765305076,11957891,14.8),(142883,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142883,38.74,NULL,561,68876,65,NULL,'L = 10e57 photons/s','3B 920711',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,276.5375,73.37972,0.189,NULL,52738767688,824043245,12875675,NULL),(142884,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142884,41.5,NULL,2000,68876,65,NULL,'L = 2 x 10e58 photons/s','3B 920711',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142885,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142885,34,0.43,63.2,68877,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2203',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000006,NULL,'16.6',0.12,'Scd',NULL,NULL,NULL,NULL,1,276.567917,25.33167,0.561,NULL,54351491166,849242049,13269407,16.6),(142886,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142886,34.2,NULL,69.2,68877,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142887,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142887,34.21,NULL,69.4,68877,NULL,NULL,'Dipole + Quadrupole','FGC 2203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142888,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142888,34.21,NULL,69.4,68877,NULL,NULL,'Dipole','FGC 2203',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142889,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142889,34.3,NULL,72.3,68877,NULL,NULL,NULL,'FGC 2203',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142890,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142890,36.78,0.6,227,68878,70,NULL,NULL,'2MASX J18264019-5123189',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.667417,-51.38864,0.281,NULL,48922328078,764411376,11943927,15.3),(142891,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142891,35.64,0.71,135,68879,70,NULL,NULL,'2MASX J18270503-6429511',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,276.771125,-64.49747,0.405,NULL,48935127272,764611363,11947052,14.3),(142892,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142892,33.82,0.48,58.1,68880,70,NULL,NULL,'2MASX J18270752-6243302',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000053,NULL,'13.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.781291667,-62.72508,0.417,NULL,48985814687,765403354,11959427,13.4),(142893,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142893,36.8,0.61,229,68881,70,NULL,NULL,'2MASX J18270910-3503105',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1R',0.4,'with *   poss. LINER',NULL,NULL,NULL,NULL,1,276.788,-35.05289,0.453,NULL,47555173969,743049593,11610149,14.1),(142894,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142894,34.08,0.2,65.5,68882,74.4,NULL,NULL,'UGC 11237',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000033,NULL,'14.7',0.8,'Scd:',NULL,NULL,NULL,NULL,1,276.8214583,24.88492,0.629,NULL,54318648377,848728880,13261388,14.7),(142895,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142895,34.25,0.35,70.7,68882,NULL,NULL,'Malmquist cor.','UGC 11237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142896,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142896,34.25,0.35,70.8,68882,NULL,NULL,NULL,'UGC 11237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142897,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142897,35.37,0.68,119,68883,70,NULL,NULL,'2MASX J18272441-7704385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.851333,-77.07744,0.677,NULL,48485167844,757580747,11837199,14.8),(142898,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142898,33.98,0.52,62.4,68884,70,NULL,NULL,'2MASX J18273402-6100482',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00007,NULL,'13.8R',0.7,'SA0-:',NULL,NULL,NULL,NULL,1,276.89175,-61.01358,0.441,NULL,48966647580,765103868,11954747,13.8),(142899,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142899,36.02,0.5,160,68885,70,NULL,NULL,'2MASX J18273604-5127357',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,276.9000417,-51.45992,0.281,NULL,48922259542,764410305,11943911,14.5),(142900,'SGRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142900,43.01,NULL,4010,68886,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 060919',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,276.923917,-51.01456,0.229,NULL,48921604644,764400072,11943751,NULL),(142901,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142901,33.69,0.48,54.7,68887,70,NULL,NULL,'ESO 182- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.36',0.3,'S0: sp',NULL,NULL,NULL,NULL,1,276.965917,-53.21006,0.265,NULL,48908119214,764189362,11940458,14.36),(142902,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142902,32.96,0.4,39.1,68888,75,NULL,'Edat, raw','IC 4704',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.00004,NULL,'13.17',2.2,'SA(s)0^-','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,276.9735,-71.60986,0.085,NULL,48465975856,757280872,11832513,13.17),(142903,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142903,33.2,0.4,43.6,68888,75,NULL,'Edat, cor','IC 4704',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142904,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142904,33.09,0.45,41.5,68888,NULL,NULL,'K','IC 4704',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142905,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142905,33.58,0.4,52,68888,NULL,NULL,'mean','IC 4704',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142906,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142906,34.23,0.1,70.3,68889,NULL,NULL,NULL,'ESO 182- G 016',NULL,'2009ApJS..182..474S',2009,1,1.23,NULL,'G',0.000033,NULL,'16.21',0.11,'Sd',NULL,NULL,NULL,NULL,1,277.010083,-57.30017,0.353,NULL,49105932357,767280193,11988753,16.21),(142907,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142907,34.45,0.49,77.5,68889,75,NULL,'IR','ESO 182- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142908,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142908,34.85,NULL,93.3,68889,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 182- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142909,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142909,34.86,NULL,93.9,68889,NULL,NULL,'Dipole + Quadrupole','ESO 182- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142910,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142910,34.88,NULL,94.6,68889,NULL,NULL,'Dipole','ESO 182- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142911,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142911,34.91,0.49,95.9,68890,70,NULL,NULL,'2MASX J18280401-3643235',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000117,NULL,'13.5R',0.3,NULL,NULL,NULL,NULL,NULL,1,277.0167083,-36.72322,0.561,NULL,47565859750,743216558,11612758,13.5),(142912,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142912,34.27,NULL,71.5,68891,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11243',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000113,NULL,'17.',0.11,'Sd;LSB',NULL,NULL,NULL,NULL,1,277.025083,22.71044,0.685,NULL,54614227076,853347298,13333551,17),(142913,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142913,34.27,NULL,71.6,68891,NULL,NULL,'Dipole','UGC 11243',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142914,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142914,34.28,NULL,71.6,68891,NULL,NULL,'Dipole + Quadrupole','UGC 11243',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142915,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142915,34.93,NULL,96.7,68891,NULL,NULL,NULL,'UGC 11243',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142916,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142916,34.56,0.47,81.5,68892,NULL,NULL,'H','NGC 6640',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000057,NULL,'14.18',0.8,'Scd:',NULL,NULL,NULL,NULL,1,277.0344583,34.30267,0.261,NULL,54467398183,851053096,13297704,14.18),(142917,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142917,34.58,0.46,82.3,68892,NULL,NULL,'J','NGC 6640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142918,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142918,34.66,0.45,85.7,68892,NULL,NULL,'K','NGC 6640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142919,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142919,34.75,0.4,89.1,68892,NULL,NULL,'mean','NGC 6640',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142920,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142920,35.52,0.54,127,68893,70,NULL,NULL,'2MASX J18281784-7709311',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'13.2R',NULL,'D',NULL,NULL,NULL,NULL,1,277.0744583,-77.15869,0.677,NULL,48485110119,757579845,11837185,13.2),(142921,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142921,34.57,0.34,82,68894,70,NULL,'H, 2MASS','UGC 11246',NULL,'2011A&A...531A..87I',2011,1,1.1,NULL,'G',0.00005,NULL,'14.9',0.4,'Sab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,277.0995,22.73689,0.685,NULL,54614223561,853347243,13333550,14.9),(142922,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142922,34.6,0.34,83.2,68894,70,NULL,'H, UH88/IRSF/2MASS','UGC 11246',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142923,'TRGB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142923,29.34,0.1,7.38,68895,74.4,NULL,NULL,'IC 4710',NULL,'2013AJ....146...86T',2013,1,3.6,NULL,'G',0.000007,NULL,'12.5',2.8,'SB(s)m         HII','Possible group member',NULL,NULL,NULL,1,277.1582083,-66.98228,0.377,NULL,49192924008,768639437,12009991,12.5),(142924,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142924,29.75,0.8,8.9,68895,75,NULL,'B','IC 4710',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142925,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142925,35.83,0.55,146,68896,70,NULL,NULL,'2MASX J18284087-3444034',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.6R',0.1,NULL,NULL,NULL,NULL,NULL,1,277.170375,-34.73428,0.473,NULL,47555076993,743048078,11610126,15.6),(142926,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142926,34.16,0.8,67.8,68897,75,NULL,'CF, r','UGC 11252',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00024,NULL,'14.83',0.5,'Scd:',NULL,NULL,NULL,NULL,1,277.174916667,48.24319,0.221,NULL,52886562021,826352531,12911758,14.83),(142927,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142927,33.75,0.38,56.1,68897,75,NULL,'CF, r, raw','UGC 11252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142928,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142928,33.85,0.38,58.8,68897,75,NULL,'CF, r, inv','UGC 11252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142929,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142929,33.86,0.47,59,68897,NULL,NULL,'H','UGC 11252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142930,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142930,34.01,0.46,63.3,68897,NULL,NULL,'J','UGC 11252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142931,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142931,34.03,0.45,63.8,68897,NULL,NULL,'K','UGC 11252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142932,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142932,34.09,0.38,65.7,68897,75,NULL,'CF, r, cor','UGC 11252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142933,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142933,34.09,0.4,65.7,68897,NULL,NULL,'mean','UGC 11252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142934,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142934,34.64,0.63,84.6,68898,NULL,NULL,'Malmquist cor.','ESO 182- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.11',0.5,'S...',NULL,NULL,NULL,NULL,1,277.209667,-52.89242,0.213,NULL,48908527232,764195738,11940558,15.11),(142935,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142935,34.87,0.57,94.4,68898,NULL,NULL,NULL,'ESO 182- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142936,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142936,34.92,0.2,96.4,68898,74.4,NULL,NULL,'ESO 182- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142937,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142937,32.96,0.4,39.1,68899,75,NULL,'Edat, raw','ESO 071- G 013',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00015,NULL,'13.76',1,'SAB:(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,277.2147917,-72.09214,0,NULL,48466045458,757281960,11832530,13.76),(142938,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142938,33.2,0.4,43.6,68899,75,NULL,'Edat, cor','ESO 071- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142939,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142939,32.7,0.49,34.7,68899,70,NULL,NULL,'ESO 071- G 013',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142940,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142940,33.12,0.4,42.1,68899,NULL,NULL,'mean','ESO 071- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142941,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142941,33.21,0.45,43.9,68899,NULL,NULL,'K','ESO 071- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142942,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142942,34.91,0.49,96.2,68900,75,NULL,'IR','UGC 11255',NULL,'2011yCatp016004901K',2011,1,1.49,NULL,'G',NULL,NULL,'15.54',0.17,'Sc',NULL,NULL,NULL,NULL,1,277.2394583,51.65103,0.153,NULL,52947987144,827312299,12926754,15.54),(142943,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142943,35.09,NULL,104,68900,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142944,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142944,35.1,NULL,105,68900,NULL,NULL,'Dipole + Quadrupole','UGC 11255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142945,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142945,35.11,NULL,105,68900,NULL,NULL,'Dipole','UGC 11255',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142946,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142946,35.24,NULL,112,68900,NULL,NULL,NULL,'UGC 11255',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142947,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142947,35.35,0.38,117,68900,NULL,NULL,'Malmquist cor.','UGC 11255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142948,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142948,35.35,0.43,117,68900,75,NULL,'3.6 micron, color corrected','UGC 11255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142949,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142949,35.41,0.43,121,68900,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11255',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142950,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142950,35.43,0.2,122,68900,74.4,NULL,NULL,'UGC 11255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142951,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142951,35.49,0.35,126,68900,NULL,NULL,NULL,'UGC 11255',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142952,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142952,35.35,0.53,117,68901,70,NULL,NULL,'2MASX J18293588-7114468',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.399625,-71.24633,0.469,NULL,48469110690,757329854,11833278,14.9),(142953,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142953,33.96,0.4,61.8,68902,NULL,NULL,'mean','UGC 11253',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000067,NULL,'15.7',0.15,'Sc;HSB',NULL,NULL,NULL,NULL,1,277.415291667,23.06858,0.677,NULL,54598138368,853095912,13329623,15.7),(142954,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142954,34.11,0.49,66.4,68902,75,NULL,'IR','UGC 11253',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142955,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142955,34.3,0.45,72.4,68902,NULL,NULL,'K','UGC 11253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142956,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142956,34.35,0.47,74,68902,NULL,NULL,'H','UGC 11253',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142957,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142957,33.5,NULL,50.2,68903,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11254',NULL,'2010Ap&SS.325..163P',2010,1,1.74,NULL,'G',0.000005,NULL,'16.10',0.16,'Scd',NULL,NULL,NULL,NULL,1,277.425083333,30.43797,0.525,NULL,54483257014,851300890,13301576,16.1),(142958,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142958,33.51,NULL,50.4,68903,NULL,NULL,'Dipole + Quadrupole','UGC 11254',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142959,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142959,33.52,NULL,50.6,68903,NULL,NULL,'Dipole','UGC 11254',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142960,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142960,33.58,NULL,52.1,68903,NULL,NULL,NULL,'UGC 11254',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142961,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142961,33.71,0.43,55.1,68903,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11254',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142962,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142962,33.85,0.43,58.8,68903,75,NULL,'3.6 micron, color corrected','UGC 11254',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142963,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142963,33.87,0.2,59.4,68903,74.4,NULL,NULL,'UGC 11254',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142964,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142964,33.95,0.39,61.7,68903,NULL,NULL,NULL,'UGC 11254',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142965,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142965,34.11,0.36,66.5,68903,NULL,NULL,'Malmquist cor.','UGC 11254',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142966,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142966,36.03,0.54,160,68904,70,NULL,NULL,'2MASX J18294221-7706043',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'13.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.426167,-77.10119,0.677,NULL,48485135031,757580234,11837191,13.4),(142967,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142967,34.63,0.46,84.4,68905,NULL,NULL,'J','ESO 281- G 001',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'15',0.9,'(R\'_1)SB(rl)a',NULL,NULL,NULL,NULL,1,277.4365,-42.75325,0.417,NULL,51014710200,797104846,12454763,15),(142968,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142968,34.65,0.4,85.3,68905,NULL,NULL,'mean','ESO 281- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142969,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142969,34.67,0.47,85.9,68905,NULL,NULL,'H','ESO 281- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142970,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142970,34.68,0.45,86.4,68905,NULL,NULL,'K','ESO 281- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142971,'SGRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142971,42.93,NULL,3860,68906,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 070517',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,277.620625,-62.2975,0.509,NULL,48987729394,765433271,11959894,NULL),(142972,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142972,35.95,0.53,155,68907,70,NULL,NULL,'2MASX J18302531-5146372',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.605375,-51.77706,0.281,NULL,48920983533,764390367,11943599,15),(142973,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2001br',NULL,142973,34.96,0.18,96.3,68908,70,NULL,'SALT 2','UGC 11260',0.020628,'2013MNRAS.433.2240G',2013,1,1,NULL,'G',0.00016,NULL,'15.20',0.8,'SBa',NULL,NULL,NULL,NULL,1,277.605875,34.10281,0.241,NULL,54475712954,851183014,13299734,15.2),(142974,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2001br','R',142974,35.02,0.07,101,68908,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 11260',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142975,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2001br','R',142975,35.03,0.06,101,68908,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 11260',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142976,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142976,36.14,0.62,169,68909,70,NULL,NULL,'2MASX J18302832-6443153',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.617917,-64.72089,0.365,NULL,48928578837,764509044,11945453,15.8),(142977,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142977,35.88,0.76,150,68910,70,NULL,NULL,'2MASX J18303499-4141524',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.6457083,-41.69797,0.461,NULL,51012144549,797064758,12454136,15.2),(142978,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142978,34.61,0.2,83.6,68911,74.4,NULL,NULL,'UGC 11262',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00012,NULL,'15.20',0.6,'Sd',NULL,NULL,NULL,NULL,1,277.648875,42.69275,0.181,NULL,54768934603,855764603,13371321,15.2),(142979,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142979,34.67,0.31,85.8,68911,NULL,NULL,NULL,'UGC 11262',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142980,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142980,34.76,0.3,89.5,68911,NULL,NULL,'Malmquist cor.','UGC 11262',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142981,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142981,32.98,0.4,39.5,68912,75,NULL,'B','NGC 6667',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.00002,NULL,'13.55',1.1,'SABab? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,277.6657917,67.98703,0.305,NULL,53554412601,836787696,13074807,13.55),(142982,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142982,33.04,0.4,40.5,68912,NULL,NULL,'mean','NGC 6667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142983,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142983,33.17,0.43,43,68912,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142984,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142984,33.17,0.43,43.1,68912,75,NULL,'3.6 micron, color corrected','NGC 6667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142985,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142985,33.24,0.45,44.6,68912,NULL,NULL,'K','NGC 6667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142986,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142986,33.26,0.2,44.9,68912,74.4,NULL,NULL,'NGC 6667',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142987,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142987,33.26,0.4,44.9,68912,NULL,NULL,NULL,'NGC 6667',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142988,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142988,33.31,0.47,45.9,68912,NULL,NULL,'H','NGC 6667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142989,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142989,33.35,0.46,46.8,68912,NULL,NULL,'J','NGC 6667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142990,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142990,34.96,0.48,98,68913,70,NULL,NULL,'2MASX J18304409-4552149',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000107,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.683583333,-45.87083,0.133,NULL,51008323960,797005061,12453204,14.2),(142991,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142991,35.99,0.71,158,68914,70,NULL,NULL,'2MASX J18305477-6020002',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.72825,-60.33339,0.393,NULL,48967844307,765122567,11955040,15.3),(142992,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142992,33.8,0.8,57.5,68915,75,NULL,'HMCL, I','IC 4714',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000117,NULL,'15.08',0.3,'Scd? sp','Possible group member',NULL,NULL,NULL,1,277.7322917,-66.65175,0.353,NULL,48928707133,764511048,11945485,15.08),(142993,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142993,33.06,0.49,40.9,68915,75,NULL,'IR','IC 4714',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142994,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142994,33.18,0.4,43.2,68915,75,NULL,'HMCL, I, raw','IC 4714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142995,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142995,33.22,0.4,44,68915,75,NULL,'HMCL, I, inv','IC 4714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142996,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142996,33.49,0.4,49.9,68915,75,NULL,'HMCL, I, cor','IC 4714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(142997,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142997,36.53,0.55,202,68916,70,NULL,NULL,'2MASX J18305756-5143167',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.7397083,-51.72133,0.281,NULL,48920957212,764389956,11943593,14.4),(142998,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,142998,33.33,0.8,46.4,68917,75,NULL,'MAT, I','IC 4712',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000033,NULL,'12.97',1.2,'SA(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,277.778833,-71.69367,0.085,NULL,48465540264,757274066,11832407,12.97),(142999,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',142999,32.69,NULL,34.5,68917,NULL,NULL,'B','IC 4712',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143000,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143000,32.69,NULL,34.5,68917,NULL,NULL,'I','IC 4712',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143001,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143001,33.13,0.46,42.2,68917,NULL,NULL,'J','IC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143002,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143002,33.19,0.45,43.5,68917,NULL,NULL,'K','IC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143003,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143003,33.27,0.32,45,68917,85,NULL,'I, raw','IC 4712',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143004,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143004,33.29,0.47,45.6,68917,NULL,NULL,'H','IC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143005,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143005,33.33,0.32,46.3,68917,85,NULL,'I, inv','IC 4712',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143006,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143006,33.42,0.43,48.3,68917,75,NULL,'MAT, I, raw','IC 4712',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143007,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143007,33.44,0.4,48.7,68917,NULL,NULL,'mean','IC 4712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143008,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143008,33.62,0.07,53.1,68917,NULL,NULL,NULL,'IC 4712',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143009,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143009,33.69,0.43,54.7,68917,75,NULL,'MAT, I, inv','IC 4712',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143010,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143010,33.73,0.43,55.7,68917,75,NULL,'MAT, I, cor','IC 4712',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143011,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143011,36.22,0.52,175,68918,70,NULL,NULL,'2MASX J18310860-4808197',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.785875,-48.13875,0.241,NULL,51007541370,796992833,12453013,15.6),(143012,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143012,36.2,0.69,174,68919,70,NULL,NULL,'2MASX J18312211-5215456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.842167,-52.26258,0.273,NULL,48906952291,764171129,11940173,15.7),(143013,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143013,35.95,NULL,155,68920,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2209',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',NULL,NULL,'16.8',0.08,'Sd',NULL,NULL,NULL,NULL,1,277.902083,50.35472,0.221,NULL,52944636904,827259951,12925936,16.8),(143014,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143014,35.98,NULL,157,68920,NULL,NULL,'Dipole + Quadrupole','FGC 2209',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143015,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143015,35.99,NULL,158,68920,NULL,NULL,NULL,'FGC 2209',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143016,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143016,36,NULL,158,68920,NULL,NULL,'Dipole','FGC 2209',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143017,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143017,36.91,0.62,241,68921,70,NULL,NULL,'2MASX J18314286-6019422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.928417,-60.32842,0.357,NULL,48967859883,765122810,11955043,15.5),(143018,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143018,34.17,0.8,68.1,68922,75,NULL,'CF, r','UGC 11264',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000053,NULL,'14.96',0.5,'Sbc',NULL,NULL,NULL,NULL,1,277.941875,31.08983,0.461,NULL,54482775306,851293364,13301458,14.96),(143019,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143019,33.99,0.38,62.7,68922,75,NULL,'CF, r, raw','UGC 11264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143020,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143020,34.05,0.38,64.7,68922,75,NULL,'CF, r, inv','UGC 11264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143021,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143021,34.23,0.38,70,68922,75,NULL,'CF, r, cor','UGC 11264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143022,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143022,34.49,0.47,79.1,68923,70,NULL,NULL,'2MASX J18314901-5550106',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000057,NULL,'13.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,277.95425,-55.83631,0.361,NULL,49099905094,767186017,11987281,13.8),(143023,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143023,34.43,0.47,77,68924,NULL,NULL,'H','ESO 457- G 015',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00002,NULL,'13.3R',0.7,'SA(r)bc?       HII',NULL,NULL,NULL,NULL,1,277.983416667,-31.79522,0.705,NULL,47778492333,746538942,11664670,13.3),(143024,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143024,34.44,0.46,77.2,68924,NULL,NULL,'J','ESO 457- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143025,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143025,34.54,0.45,80.9,68924,NULL,NULL,'K','ESO 457- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143026,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143026,34.58,0.4,82.6,68924,NULL,NULL,'mean','ESO 457- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143027,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143027,34.97,0.29,98.7,68925,NULL,NULL,'Malmquist cor.','UGC 11268',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000023,NULL,'14.64',0.5,'Sbc',NULL,NULL,NULL,NULL,1,278.028875,37.61358,0.133,NULL,54262787260,847856050,13247750,14.64),(143028,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143028,35.36,0.24,118,68925,NULL,NULL,NULL,'UGC 11268',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143029,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143029,35.4,0.2,120,68925,74.4,NULL,NULL,'UGC 11268',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143030,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143030,36.25,0.54,178,68926,70,NULL,NULL,'2MASX J18320801-7105306',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.033375,-71.09186,0.469,NULL,48466791099,757293610,11832712,15.1),(143031,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'RN',143031,45.57,0.57,5680,68927,72,NULL,NULL,'GRB 050126 OA',1.29002,'2008JCAP...07..004M',2008,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143032,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'N',143032,45.71,0.57,6060,68927,70,NULL,NULL,'GRB 050126 OA',1.29002,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143033,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'N',143033,45.74,0.52,6140,68927,69.7,NULL,'Calibrated','GRB 050126 OA',1.29002,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143034,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'N',143034,46.33,0.55,8060,68927,69.7,NULL,'Fiducial','GRB 050126 OA',1.29002,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143035,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143035,37.23,0.62,279,68928,70,NULL,NULL,'2MASX J18322937-6017262',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.122417,-60.29058,0.357,NULL,48967900431,765123444,11955053,13.9),(143036,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc','R',143036,42.58,0.33,2040,68929,72,NULL,'SN 2005nc','GRB 050525',0.61,'2010JCAP...08..020W',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,278.13575,26.33961,0.609,NULL,54313392126,848646751,13260105,NULL),(143037,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc','R',143037,43.27,0.43,2800,68929,72,NULL,NULL,'GRB 050525',0.61,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143038,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc',NULL,143038,43.28,0.37,2810,68929,69.7,NULL,'Calibrated','GRB 050525',0.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143039,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc',NULL,143039,43.34,0.42,2890,68929,70,NULL,NULL,'GRB 050525',0.61,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143040,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2005nc',NULL,143040,43.55,0.44,3190,68929,69.7,NULL,'Fiducial','GRB 050525',0.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143041,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143041,42.72,0.13,3500,68929,NULL,NULL,NULL,'GRB 050525',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143042,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143042,42.83,0.07,3680,68929,NULL,NULL,NULL,'GRB 050525',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143043,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143043,32.72,0.8,35.1,68930,75,NULL,NULL,'ESO 140- G 023',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000017,NULL,'13.34',1.1,'SB(s)d',NULL,NULL,NULL,NULL,1,278.1714583,-57.67089,0.349,NULL,49106165932,767283842,11988810,13.34),(143044,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143044,36.97,0.57,248,68931,70,NULL,NULL,'2MFGC 14452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.2165,-55.23383,0.409,NULL,49102254143,767222720,11987855,15.6),(143045,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143045,33.08,0.43,41.4,68932,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11295',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000017,NULL,'16.5',0.16,'Sdm',NULL,NULL,NULL,NULL,1,278.281333,75.40025,0.285,NULL,52720221815,823753465,12871147,16.5),(143046,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143046,33.14,NULL,42.6,68932,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11295',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143047,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143047,33.15,NULL,42.6,68932,NULL,NULL,'Dipole + Quadrupole','UGC 11295',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143048,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143048,33.16,NULL,42.9,68932,NULL,NULL,'Dipole','UGC 11295',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143049,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143049,34.88,0.49,94.7,68933,75,NULL,'IR','NGC 6676',NULL,'2011yCatp016004901K',2011,1,1.6,'Haynes, et al. (1999AJ....117.2039H) give v = 6798 km/sec.','G',0.000123,NULL,'15.20',0.3,'Sbc',NULL,NULL,NULL,NULL,1,278.2915,66.95906,0.361,NULL,53559218724,836862792,13075981,15.2),(143050,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143050,35.16,0.4,108,68933,NULL,NULL,'mean','NGC 6676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143051,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143051,35.26,0.47,113,68933,NULL,NULL,'H','NGC 6676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143052,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143052,35.41,0.45,121,68933,NULL,NULL,'K','NGC 6676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143053,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143053,35.43,0.46,122,68933,NULL,NULL,'J','NGC 6676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143054,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143054,35.15,0.49,107,68934,75,NULL,'IR','UGC 11277',NULL,'2011yCatp016004901K',2011,1,1.34,NULL,'G',NULL,NULL,'16.3',0.11,'Sbc',NULL,NULL,NULL,NULL,1,278.2979583,52.94875,0.185,NULL,52936259417,827129053,12923891,16.3),(143055,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143055,35.35,NULL,117,68934,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143056,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143056,35.36,NULL,118,68934,NULL,NULL,'Dipole + Quadrupole','UGC 11277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143057,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143057,35.37,NULL,119,68934,NULL,NULL,'Dipole','UGC 11277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143058,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143058,35.39,NULL,120,68934,NULL,NULL,NULL,'UGC 11277',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143059,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143059,32.83,0.8,36.9,68935,75,NULL,'MAT, I','IC 4717',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.3',0.3,'Sb? sp',NULL,NULL,NULL,NULL,1,278.321875,-57.97572,0.353,NULL,49105088370,767267005,11988546,14.3),(143060,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143060,33.22,0.43,44.1,68935,75,NULL,'MAT, I, raw','IC 4717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143061,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143061,33.27,0.32,45,68935,85,NULL,'I, raw','IC 4717',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143062,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143062,33.33,0.32,46.3,68935,85,NULL,'I, inv','IC 4717',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143063,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143063,33.47,0.49,49.5,68935,75,NULL,'IR','IC 4717',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143064,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143064,33.48,0.43,49.6,68935,75,NULL,'MAT, I, inv','IC 4717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143065,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143065,33.55,0.43,51.2,68935,75,NULL,'MAT, I, cor','IC 4717',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143066,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143066,33.58,0.36,52,68935,NULL,NULL,NULL,'IC 4717',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143067,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143067,33.62,0.2,53,68935,74.4,NULL,NULL,'IC 4717',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143068,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143068,33.66,0.35,54,68935,NULL,NULL,'Malmquist cor.','IC 4717',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143069,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143069,35.32,0.52,116,68936,70,NULL,NULL,'2MASX J18331806-4239225',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.325166667,-42.65622,0.409,NULL,51013497940,797085905,12454467,14.9),(143070,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143070,31.84,0.8,23.4,68937,75,NULL,'MAT, I','IC 4720',NULL,'1997ApJS..109..333W',1997,1,2.5,'Confused HIPASS source','G',0.000018,NULL,'13.61',0.9,'SB(rs)cd:','in a pair',NULL,NULL,NULL,1,278.385417,-58.40536,0.393,NULL,49097130776,767142668,11986604,13.61),(143071,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143071,30.85,0.32,14.8,68937,85,NULL,'I, inv','IC 4720',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143072,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143072,30.87,0.32,14.9,68937,85,NULL,'I, raw','IC 4720',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143073,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143073,31.1,0.43,16.6,68937,75,NULL,'MAT, I, raw','IC 4720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143074,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143074,31.11,0.43,16.7,68937,75,NULL,'MAT, I, inv','IC 4720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143075,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143075,31.48,0.43,19.8,68937,75,NULL,'MAT, I, cor','IC 4720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143076,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143076,31.8,0.64,22.9,68937,NULL,NULL,NULL,'IC 4720',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143077,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143077,31.84,0.2,23.3,68937,74.4,NULL,NULL,'IC 4720',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143078,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143078,31.84,0.63,23.4,68937,NULL,NULL,'Malmquist cor.','IC 4720',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143079,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143079,34.67,0.49,86.1,68938,75,NULL,'IR','UGC 11275',NULL,'2011yCatp016004901K',2011,1,1.95,NULL,'G',0.000009,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,278.4149583,32.13967,0.369,NULL,54477155086,851205548,13300086,16.5),(143080,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143080,34.95,NULL,97.5,68938,NULL,NULL,'Dipole','UGC 11275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143081,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143081,34.95,NULL,97.8,68938,NULL,NULL,'Dipole + Quadrupole','UGC 11275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143082,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143082,34.95,NULL,97.9,68938,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11275',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143083,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143083,35.02,NULL,101,68938,NULL,NULL,NULL,'UGC 11275',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143084,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143084,35.06,0.31,103,68938,NULL,NULL,'Malmquist cor.','UGC 11275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143085,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143085,35.15,0.2,107,68938,74.4,NULL,NULL,'UGC 11275',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143086,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143086,35.17,0.43,108,68938,75,NULL,'3.6 micron, color corrected','UGC 11275',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143087,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143087,35.32,0.43,116,68938,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11275',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143088,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143088,35.42,0.26,122,68938,NULL,NULL,NULL,'UGC 11275',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143089,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143089,40.21,NULL,1100,68939,NULL,NULL,NULL,'PKS 1830-21 GAL',NULL,'1995ApJ...444..561v',1995,1,NULL,'This galaxy lenses the QSO PKS 1830-21.','G',0.000001,NULL,'22.6',NULL,'Sb or Sc',NULL,NULL,NULL,NULL,1,278.4162083,-21.06106,NULL,NULL,48244959163,753827486,11778554,22.6),(143090,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143090,41.41,0.68,1910,68939,NULL,NULL,NULL,'PKS 1830-21 GAL',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143091,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143091,42.03,NULL,2550,68939,NULL,NULL,'R(H) = ct','PKS 1830-21 GAL',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143092,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143092,42.09,NULL,2620,68939,NULL,NULL,'Standard','PKS 1830-21 GAL',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143093,'G Lens','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143093,43.69,0.76,5480,68939,NULL,NULL,NULL,'PKS 1830-21 GAL',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143094,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143094,35.12,0.8,106,68940,75,NULL,'MAT, I','ESO 281- G 008',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'12.16',0.8,'(R\')SB?(ls)0/a?',NULL,NULL,NULL,NULL,1,278.417458333,-46.7515,0.221,NULL,51010623582,797040993,12453765,12.16),(143095,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143095,33.25,0.43,44.7,68940,75,NULL,'MAT, I, raw','ESO 281- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143096,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143096,33.44,0.43,48.7,68940,75,NULL,'MAT, I, inv','ESO 281- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143097,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143097,33.5,0.32,50.2,68940,85,NULL,'I, raw','ESO 281- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143098,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143098,33.55,0.32,51.3,68940,85,NULL,'I, inv','ESO 281- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143099,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143099,33.72,0.43,55.5,68940,75,NULL,'MAT, I, cor','ESO 281- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143100,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143100,33.81,0.4,57.8,68941,75,NULL,'Edat, raw','IC 4718',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.0001,NULL,'13.78',0.9,'Sb:',NULL,NULL,NULL,NULL,1,278.459,-60.12911,0.301,NULL,48968283507,765129429,11955147,13.78),(143101,'D-Sigma','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143101,33.85,0.4,58.8,68941,75,NULL,'Edat, cor','IC 4718',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143102,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143102,32.49,0.4,31.5,68942,75,NULL,'B','IC 1291',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.000004,NULL,'13.54',1.5,'SB(s)dm?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,278.4690417,49.27861,0.265,NULL,52940648363,827197630,12924962,13.54),(143103,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143103,37.14,0.57,268,68943,70,NULL,NULL,'2MASX J18335382-5213199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.474375,-52.22219,0.285,NULL,48907079081,764173110,11940204,15.5),(143104,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143104,35.45,0.25,123,68944,74.4,NULL,NULL,'GIN 655',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000107,NULL,'14.11',NULL,'E',NULL,NULL,NULL,NULL,1,278.5204583,51.41344,0.165,NULL,52946615702,827290870,12926419,14.11),(143105,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143105,35.66,0.27,135,68944,70,NULL,NULL,'GIN 655',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143106,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143106,34.77,0.43,90,68945,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6662',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00004,NULL,'14.59',0.5,'SBab?','Group member',NULL,NULL,NULL,1,278.546583,32.06458,0.385,NULL,54476965965,851202593,13300040,14.59),(143107,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143107,34.98,0.6,99.3,68946,NULL,NULL,'Malmquist cor.','ESO 281- G 011',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.22',0.7,'SAB(rs)b',NULL,NULL,NULL,NULL,1,278.568833333,-46.759,0.221,NULL,51010628526,797041070,12453766,14.22),(143108,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143108,34.99,0.6,99.5,68946,NULL,NULL,NULL,'ESO 281- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143109,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143109,35.03,0.2,101,68946,74.4,NULL,NULL,'ESO 281- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143110,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143110,32.03,0.8,25.4,68947,75,NULL,'MAT, I','IC 4721',NULL,'1997ApJS..109..333W',1997,1,5.2,'Confused HIPASS source','G',0.00001,NULL,'12.38',1.5,'SAB(rs)c','in a pair',NULL,NULL,NULL,1,278.603166667,-58.49661,0.393,NULL,49097141688,767142838,11986606,12.38),(143111,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143111,32.3,0.8,28.8,68947,75,NULL,'B','IC 4721',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143112,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143112,30.97,0.36,15.6,68947,NULL,NULL,NULL,'IC 4721',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143113,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143113,31.29,0.32,18.1,68947,85,NULL,'I, raw','IC 4721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143114,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143114,31.32,0.32,18.4,68947,85,NULL,'I, inv','IC 4721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143115,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143115,31.37,0.43,18.8,68947,75,NULL,'MAT, I, raw','IC 4721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143116,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143116,31.47,0.43,19.7,68947,75,NULL,'3.6 micron, color corrected','IC 4721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143117,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143117,31.48,0.2,19.8,68947,74.4,NULL,NULL,'IC 4721',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143118,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143118,31.48,0.4,19.8,68947,73,NULL,'opt','IC 4721',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143119,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143119,31.49,0.43,19.9,68947,75,NULL,'3.6 micron, color + selection bias corrected','IC 4721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143120,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143120,31.53,0.43,20.2,68947,75,NULL,'MAT, I, inv','IC 4721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143121,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143121,31.79,0.43,22.8,68947,75,NULL,'MAT, I, cor','IC 4721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143122,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143122,31.84,0.46,23.4,68947,NULL,NULL,'J','IC 4721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143123,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143123,31.89,0.47,23.9,68947,NULL,NULL,'H','IC 4721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143124,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143124,32.04,0.45,25.5,68947,NULL,NULL,'K','IC 4721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143125,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143125,32.23,0.4,28,68947,NULL,NULL,'mean','IC 4721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143126,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143126,34.59,1.01,82.9,68948,NULL,NULL,'Malmquist cor.','ESO 045- G 008',NULL,'2009ApJS..182..474S',2009,1,1.23,NULL,'G',0.000033,NULL,'14.08',0.17,'Sb',NULL,NULL,NULL,NULL,1,278.608291667,-72.894,0.329,NULL,48513647799,758025746,11844152,14.08),(143127,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143127,35.02,NULL,101,68948,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 045- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143128,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143128,35.02,0.83,101,68948,NULL,NULL,NULL,'ESO 045- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143129,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143129,35.03,NULL,101,68948,NULL,NULL,'Dipole + Quadrupole','ESO 045- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143130,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143130,35.05,NULL,102,68948,NULL,NULL,'Dipole','ESO 045- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143131,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143131,35.06,0.2,103,68948,74.4,NULL,NULL,'ESO 045- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143132,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143132,34.01,0.8,63.3,68949,75,NULL,'MAT, I','IC 4722',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.64',1.2,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,278.631375,-57.79278,0.629,NULL,49103294874,767238982,11988109,13.64),(143133,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143133,32.55,0.32,32.4,68949,85,NULL,'I, raw','IC 4722',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143134,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143134,32.58,0.32,32.8,68949,85,NULL,'I, inv','IC 4722',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143135,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143135,32.78,0.43,36,68949,75,NULL,'MAT, I, raw','IC 4722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143136,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143136,32.94,0.43,38.8,68949,75,NULL,'MAT, I, inv','IC 4722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143137,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143137,33.16,0.43,42.9,68949,75,NULL,'MAT, I, cor','IC 4722',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143138,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143138,33.12,0.69,42.1,68950,100,NULL,'mid-IR','NGC 6660',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.000073,NULL,'13.05',1.1,'SA(s)0/a','in a pair',NULL,NULL,NULL,1,278.652791667,22.90967,0.721,NULL,54600846417,853138225,13330284,13.05),(143139,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143139,34.84,0.49,93.1,68951,75,NULL,'IR','UGC 11287',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',NULL,NULL,'14.9',1.2,'Sc','Isolated galaxy',NULL,NULL,NULL,1,278.689417,47.03503,0.253,NULL,54769786635,855777916,13371529,14.9),(143140,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143140,30.43,0.8,12.2,68952,75,NULL,'A82, H','NGC 6689',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.000003,NULL,'13.1',1.3,'SBcd           HII','Isolated galaxy',NULL,NULL,NULL,1,278.709375,70.52392,0.177,NULL,52686885544,823232586,12863009,13.1),(143141,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143141,30.43,0.4,12.2,68952,75,NULL,'B','NGC 6689',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143142,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143142,30.54,0.4,12.8,68952,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6689',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143143,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143143,30.59,0.38,13.1,68952,NULL,NULL,NULL,'NGC 6689',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143144,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143144,30.62,0.2,13.3,68952,74.4,NULL,NULL,'NGC 6689',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143145,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143145,30.64,0.43,13.4,68952,75,NULL,'3.6 micron, color corrected','NGC 6689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143146,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143146,30.66,0.43,13.5,68952,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143147,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143147,30.72,0.47,13.9,68952,75,NULL,'A82, H, inv','NGC 6689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143148,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143148,30.77,0.45,14.2,68952,NULL,NULL,'Malmquist cor.','NGC 6689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143149,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143149,30.79,0.47,14.4,68952,75,NULL,'A82, H, raw','NGC 6689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143150,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143150,30.88,0.43,15,68952,NULL,NULL,NULL,'NGC 6689',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143151,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143151,31.1,0.47,16.6,68952,75,NULL,'A82, H, cor','NGC 6689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143152,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143152,35.82,0.56,146,68953,70,NULL,NULL,'2MASX J18353191-7550062',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.8827917,-75.83514,0.469,NULL,48482882225,757545034,11836641,14.8),(143153,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143153,35,0.58,100,68954,NULL,NULL,'Malmquist cor.','ESO 281- G 012',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.02',0.6,'SAB(rs)a       NELG',NULL,NULL,NULL,NULL,1,278.890083333,-46.94342,0.233,NULL,51007208205,796987628,12452931,13.02),(143154,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143154,35.19,0.53,109,68954,NULL,NULL,NULL,'ESO 281- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143155,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143155,35.23,0.2,111,68954,74.4,NULL,NULL,'ESO 281- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143156,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143156,35.94,0.63,154,68955,70,NULL,NULL,'2MASX J18353580-7724042',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,278.899,-77.40125,0.673,NULL,48484834507,757575539,11837117,14.9),(143157,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143157,32.98,0.69,39.4,68956,100,NULL,'mid-IR','UGC 11289',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.00002,NULL,'14.1',1,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,278.947917,22.47058,0.773,NULL,54600485067,853132579,13330196,14.1),(143158,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143158,33.56,0.43,51.4,68956,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11289',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143159,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143159,33.89,0.4,60.1,68956,NULL,NULL,'mean','UGC 11289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143160,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143160,33.96,0.47,61.9,68956,NULL,NULL,'H','UGC 11289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143161,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143161,34.02,0.45,63.6,68956,NULL,NULL,'K','UGC 11289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143162,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143162,34.04,0.46,64.2,68956,NULL,NULL,'J','UGC 11289',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143163,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143163,34.18,0.41,68.6,68957,NULL,NULL,'Malmquist cor.','ESO 140- G 029',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.76',0.3,'Sb ?',NULL,NULL,NULL,NULL,1,278.969417,-59.44319,0.297,NULL,48964568790,765071387,11954240,15.76),(143164,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143164,34.51,0.35,79.9,68957,NULL,NULL,NULL,'ESO 140- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143165,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143165,34.55,0.2,81.3,68957,74.4,NULL,NULL,'ESO 140- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143166,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143166,35.45,0.25,123,68958,74.4,NULL,NULL,'CGCG 279-018',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000097,NULL,'13.90',0.4,'E/S0',NULL,NULL,NULL,NULL,1,278.993875,51.45886,0.165,NULL,52941656613,827213384,12925209,13.9),(143167,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143167,35.66,0.27,135,68958,70,NULL,NULL,'CGCG 279-018',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143168,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143168,37.84,0.62,369,68959,70,NULL,NULL,'2MASX J18360246-5942185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.010167,-59.70525,0.301,NULL,48968008178,765125127,11955080,14.8),(143169,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143169,33.63,0.8,53.3,68960,75,NULL,'MAT, I','ESO 336- G 006',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'13.5b',0.6,'SB:(r)b',NULL,NULL,NULL,NULL,1,279.029833,-37.94583,0.489,NULL,47541120031,742830000,11606718,13.5),(143170,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143170,33.68,0.46,54.4,68960,NULL,NULL,'J','ESO 336- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143171,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143171,33.69,0.47,54.6,68960,NULL,NULL,'H','ESO 336- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143172,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143172,33.79,0.45,57.2,68960,NULL,NULL,'K','ESO 336- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143173,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143173,33.83,0.4,58.3,68960,NULL,NULL,'mean','ESO 336- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143174,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143174,33.89,0.43,59.9,68960,75,NULL,'MAT, I, raw','ESO 336- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143175,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143175,33.99,0.32,62.9,68960,85,NULL,'I, raw','ESO 336- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143176,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143176,34.06,0.32,65,68960,85,NULL,'I, inv','ESO 336- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143177,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143177,34.14,0.46,67.2,68960,NULL,NULL,NULL,'ESO 336- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143178,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143178,34.15,0.45,67.6,68960,NULL,NULL,'Malmquist cor.','ESO 336- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143179,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143179,34.18,0.43,68.5,68960,75,NULL,'MAT, I, inv','ESO 336- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143180,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143180,34.18,0.2,68.6,68960,74.4,NULL,NULL,'ESO 336- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143181,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143181,34.27,0.43,71.6,68960,75,NULL,'MAT, I, cor','ESO 336- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143182,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143182,35.92,0.68,153,68961,70,NULL,NULL,'2MFGC 14493',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.043375,-45.72144,0.169,NULL,51064484798,797882574,12466915,15),(143183,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143183,35.47,0.25,124,68962,74.4,NULL,NULL,'UGC 11298',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.0001,NULL,'13.13',0.9,'cD;E',NULL,NULL,NULL,NULL,1,279.0857917,51.46647,0.165,NULL,52941666737,827213542,12925211,13.13),(143184,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143184,35.66,0.27,135,68962,70,NULL,NULL,'UGC 11298',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143185,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143185,33.47,0.43,49.5,68963,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J18362423+1018467',NULL,'2014MNRAS.444..527S',2014,1,0.89,NULL,'G',0.000067,NULL,'14.43',0.33,'Spiral',NULL,NULL,NULL,NULL,1,279.101,10.31294,NULL,NULL,53903558723,842243105,13160048,14.43),(143186,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143186,33.59,0.69,52.1,68964,100,NULL,'mid-IR','UGC 11294',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000217,NULL,'13.9',0.8,'E0?','Group member',NULL,NULL,NULL,1,279.155375,19.9215,1.457,NULL,54625392574,853521758,13336277,13.9),(143187,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143187,34.76,0.47,89.5,68964,NULL,NULL,'Malmquist cor.','UGC 11294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143188,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143188,35.07,0.4,103,68964,NULL,NULL,NULL,'UGC 11294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143189,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143189,34.51,0.58,79.7,68965,70,NULL,NULL,'ESO 045- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.2R',0.3,'S0',NULL,NULL,NULL,NULL,1,279.164167,-77.28806,0.673,NULL,48484754154,757574283,11837098,14.2),(143190,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143190,35.45,0.25,123,68966,74.4,NULL,NULL,'MCG +09-30-027',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000067,NULL,'14.34',0.3,'S',NULL,NULL,NULL,NULL,1,279.213917,51.43458,0.165,NULL,52941661788,827213465,12925210,14.34),(143191,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143191,35.66,0.27,135,68966,70,NULL,NULL,'MCG +09-30-027',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143192,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143192,35.45,0.25,123,68967,74.4,NULL,NULL,'GIN 657',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00005,NULL,'14.39',0.2,'E/S0',NULL,NULL,NULL,NULL,1,279.217458333,51.53072,0.141,NULL,52941652905,827213326,12925208,14.39),(143193,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143193,35.66,0.27,135,68967,70,NULL,NULL,'GIN 657',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143194,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143194,34.88,0.47,94.4,68968,70,NULL,NULL,'ESO 281- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000127,NULL,'13.2R',0.7,'S0',NULL,NULL,NULL,NULL,1,279.229958333,-43.76319,0.325,NULL,51059271067,797801110,12465642,13.2),(143195,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143195,35.87,0.34,149,68969,NULL,NULL,'Malmquist cor.','ESO 103- G 030',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.76',0.4,'SAB(s)b','in a triple',NULL,NULL,NULL,1,279.2435,-67.27417,0.249,NULL,49204564086,768821313,12012833,15.76),(143196,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143196,35.89,0.34,151,68969,NULL,NULL,NULL,'ESO 103- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143197,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143197,35.93,0.2,153,68969,74.4,NULL,NULL,'ESO 103- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143198,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143198,34.21,0.3,69.5,68970,NULL,NULL,'Malmquist cor.','UGC 11297',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000167,NULL,'15.1',0.2,'Sbc',NULL,NULL,NULL,NULL,1,279.3154583,19.97853,1.457,NULL,54624705376,853511021,13336109,15.1),(143199,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143199,34.3,0.29,72.5,68970,NULL,NULL,NULL,'UGC 11297',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143200,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143200,34.31,0.49,72.6,68970,75,NULL,'IR','UGC 11297',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143201,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143201,34.32,0.2,73.1,68970,74.4,NULL,NULL,'UGC 11297',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143202,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143202,35.61,0.76,132,68971,70,NULL,NULL,'2MASX J18372375-5045418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.348916667,-50.76167,0.381,NULL,48912392948,764256139,11941502,15.1),(143203,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143203,32.85,0.4,37.1,68972,NULL,NULL,'mean','NGC 6675',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000013,NULL,'13.25',1.3,'Sbc',NULL,NULL,NULL,NULL,1,279.360333,40.05772,0.241,NULL,54786939737,856045933,13375717,13.25),(143204,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143204,32.9,0.43,38,68972,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143205,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143205,32.91,0.43,38.2,68972,75,NULL,'3.6 micron, color corrected','NGC 6675',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143206,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143206,32.93,0.45,38.6,68972,NULL,NULL,'K','NGC 6675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143207,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143207,32.93,0.47,38.6,68972,NULL,NULL,'H','NGC 6675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143208,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143208,32.98,0.46,39.4,68972,NULL,NULL,'J','NGC 6675',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143209,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143209,33.02,0.2,40.2,68972,74.4,NULL,NULL,'NGC 6675',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143210,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143210,33.25,0.45,44.7,68972,NULL,NULL,NULL,'NGC 6675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143211,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143211,33.29,0.44,45.4,68972,NULL,NULL,'Malmquist cor.','NGC 6675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143212,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143212,34.99,0.61,99.4,68973,NULL,NULL,'Malmquist cor.','ESO 281- G 016',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.39',0.5,'Sb:',NULL,NULL,NULL,NULL,1,279.3717917,-47.15539,0.229,NULL,51062022497,797844101,12466314,14.39),(143213,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143213,35.01,0.6,101,68973,NULL,NULL,NULL,'ESO 281- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143214,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143214,35.05,0.2,102,68973,74.4,NULL,NULL,'ESO 281- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143215,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143215,35.24,0.57,112,68974,70,NULL,NULL,'2MASX J18373254-6643228',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.385417,-66.72294,0.293,NULL,49200378273,768755910,12011811,14.5),(143216,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143216,36.29,0.59,181,68975,70,NULL,NULL,'2MASX J18374861-6417081',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,279.4524583,-64.28553,0.389,NULL,48984191734,765377995,11959031,14.1),(143217,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143217,33.71,0.49,55.3,68976,75,NULL,'IR','UGC 11301',NULL,'2011yCatp016004901K',2011,1,2.63,'Superposed star.','G',0.000011,NULL,'15.5',0.19,'Sc',NULL,NULL,NULL,NULL,1,279.476875,17.53386,1.689,NULL,54611958909,853311857,13332997,15.5),(143218,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143218,33.8,0.46,57.6,68976,NULL,NULL,'J','UGC 11301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143219,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143219,33.83,0.47,58.2,68976,NULL,NULL,'H','UGC 11301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143220,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143220,33.86,0.45,59.3,68976,NULL,NULL,'K','UGC 11301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143221,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143221,33.9,0.4,60.3,68976,NULL,NULL,'mean','UGC 11301',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143222,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143222,33.97,0.33,62.1,68976,70,NULL,'H, 2MASS','UGC 11301',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143223,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143223,33.98,0.33,62.7,68976,70,NULL,'H, UH88/IRSF/2MASS','UGC 11301',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143224,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143224,34.3,0.43,72.3,68976,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11301',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143225,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143225,34.45,NULL,77.5,68976,NULL,NULL,'Dipole','UGC 11301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143226,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143226,34.45,NULL,77.8,68976,NULL,NULL,'Dipole + Quadrupole','UGC 11301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143227,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143227,34.46,NULL,78,68976,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11301',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143228,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143228,34.58,NULL,82.6,68976,NULL,NULL,NULL,'UGC 11301',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143229,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143229,32.88,0.2,37.7,68977,74.4,NULL,NULL,'UGC 11307',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000667,NULL,'14.8',0.4,'SBcd:',NULL,NULL,NULL,NULL,1,279.480375,27.79353,0.673,NULL,54435057099,850547767,13289808,14.8),(143230,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143230,33.1,0.46,41.6,68977,NULL,NULL,NULL,'UGC 11307',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143231,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143231,33.39,0.4,47.7,68977,NULL,NULL,'Malmquist cor.','UGC 11307',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143232,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143232,33.79,0.25,57.3,68978,74.4,NULL,NULL,'IC 4727',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000133,NULL,'14.03',1.1,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,279.483583333,-62.70067,0.393,NULL,48988591966,765446749,11960105,14.03),(143233,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143233,33.91,0.45,60.4,68978,NULL,NULL,'K','IC 4727',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143234,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143234,33.92,0.4,60.8,68978,NULL,NULL,'mean','IC 4727',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143235,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143235,36.09,0.51,165,68979,70,NULL,NULL,'2MASX J18382505-5846558',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.604375,-58.78217,0.325,NULL,49098484896,767163826,11986934,14.9),(143236,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143236,33.91,0.8,60.6,68980,75,NULL,'MAT, I','IC 4734',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.18',0.8,'(R\')SB(s)ab;HII;LIRG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,279.607083,-57.49044,0.569,NULL,49103619175,767244049,11988188,14.18),(143237,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143237,33.45,0.45,48.9,68980,NULL,NULL,'K','IC 4734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143238,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143238,33.49,0.47,49.9,68980,NULL,NULL,'H','IC 4734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143239,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143239,33.6,0.43,52.5,68980,75,NULL,'MAT, I, raw','IC 4734',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143240,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143240,33.65,0.32,53.6,68980,85,NULL,'I, raw','IC 4734',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143241,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143241,33.65,0.46,53.8,68980,NULL,NULL,'J','IC 4734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143242,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143242,33.7,0.32,55,68980,85,NULL,'I, inv','IC 4734',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143243,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143243,33.82,0.43,58.2,68980,75,NULL,'MAT, I, cor','IC 4734',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143244,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143244,33.85,0.43,58.9,68980,75,NULL,'MAT, I, inv','IC 4734',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143245,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143245,34.06,0.5,64.9,68980,NULL,NULL,'Malmquist cor.','IC 4734',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143246,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143246,34.08,0.4,65.6,68980,NULL,NULL,'mean','IC 4734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143247,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143247,34.57,0.4,82,68980,NULL,NULL,NULL,'IC 4734',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143248,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143248,34.61,0.2,83.6,68980,74.4,NULL,NULL,'IC 4734',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143249,'Ring Diameter','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143249,31.8,0.84,23,68981,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6674',NULL,'1981ApJS...45..541P',1981,1,4,NULL,'G',0.000017,NULL,'13.0',2.2,'SB(r)b',NULL,NULL,NULL,NULL,1,279.641125,25.37514,0.665,NULL,54323265887,848801029,13262516,13),(143250,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143250,32.7,0.69,34.7,68981,100,NULL,'mid-IR','NGC 6674',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143251,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143251,33.5,0.4,50.1,68981,NULL,NULL,'mean','NGC 6674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143252,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143252,33.65,0.2,53.7,68981,74.4,NULL,NULL,'NGC 6674',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143253,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143253,33.65,0.43,53.8,68981,75,NULL,'3.6 micron, color corrected','NGC 6674',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143254,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143254,33.66,0.47,54,68981,NULL,NULL,'H','NGC 6674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143255,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143255,33.68,0.46,54.6,68981,NULL,NULL,'J','NGC 6674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143256,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143256,33.7,0.35,55,68981,70,NULL,'H, UH88/IRSF/2MASS','NGC 6674',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143257,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143257,33.7,0.35,55,68981,70,NULL,'H, 2MASS','NGC 6674',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143258,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143258,33.75,0.45,56.3,68981,NULL,NULL,'K','NGC 6674',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143259,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143259,33.76,0.43,56.6,68981,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6674',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143260,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143260,36.34,0.52,185,68982,70,NULL,NULL,'2MASX J18383474-5357088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.644875,-53.95247,0.365,NULL,48906570740,764165167,11940080,15),(143261,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143261,34.8,0.58,91.1,68983,70,NULL,NULL,'ESO 071- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'15.61',0.4,'(R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,279.6565,-72.15808,0.245,NULL,48463232879,757238013,11831843,15.61),(143262,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143262,32.99,0.8,39.6,68984,75,NULL,'MAT, I','IC 4736',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.000022,NULL,'14.56',0.9,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,279.665875,-57.89328,0.629,NULL,49095792170,767121752,11986277,14.56),(143263,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143263,32.46,0.43,31,68984,75,NULL,'MAT, I, raw','IC 4736',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143264,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143264,32.48,0.43,31.3,68984,75,NULL,'MAT, I, inv','IC 4736',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143265,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143265,32.71,0.32,34.9,68984,85,NULL,'I, raw','IC 4736',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143266,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143266,32.71,0.32,34.9,68984,85,NULL,'I, inv','IC 4736',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143267,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143267,32.86,0.43,37.4,68984,75,NULL,'MAT, I, cor','IC 4736',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143268,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143268,33.31,0.57,46,68984,NULL,NULL,NULL,'IC 4736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143269,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143269,33.35,0.2,46.8,68984,74.4,NULL,NULL,'IC 4736',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143270,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143270,33.74,0.47,55.9,68984,NULL,NULL,'Malmquist cor.','IC 4736',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143271,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143271,32.95,0.25,38.9,68985,74.4,NULL,NULL,'IC 4731',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00007,NULL,'12.52',0.7,'SB(r)0+:',NULL,NULL,NULL,NULL,1,279.679083333,-62.94303,0.393,NULL,48989016792,765453387,11960209,12.52),(143272,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143272,33.91,0.8,60.4,68986,75,NULL,'MAT, I','ESO 183- G 005',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000033,NULL,'15.71',0.22,'SB(s)d',NULL,NULL,NULL,NULL,1,279.761625,-55.61739,0.349,NULL,49099186163,767174783,11987105,15.71),(143273,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143273,33.13,0.32,42.2,68986,85,NULL,'I, inv','ESO 183- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143274,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143274,33.14,0.32,42.5,68986,85,NULL,'I, raw','ESO 183- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143275,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143275,33.42,0.43,48.3,68986,75,NULL,'MAT, I, raw','ESO 183- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143276,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143276,33.42,0.43,48.4,68986,75,NULL,'MAT, I, inv','ESO 183- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143277,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143277,33.51,NULL,50.4,68986,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 183- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143278,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143278,33.53,NULL,50.8,68986,NULL,NULL,'Dipole','ESO 183- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143279,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143279,33.53,NULL,50.8,68986,NULL,NULL,'Dipole + Quadrupole','ESO 183- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143280,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143280,33.59,NULL,52.3,68986,NULL,NULL,NULL,'ESO 183- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143281,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143281,33.7,0.43,55,68986,75,NULL,'MAT, I, cor','ESO 183- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143282,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143282,33.91,0.49,60.7,68986,75,NULL,'IR','ESO 183- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143283,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143283,34.16,0.12,68.1,68986,NULL,NULL,NULL,'ESO 183- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143284,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143284,35.4,0.54,120,68987,70,NULL,NULL,'2MASX J18391238-4647172',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.801625,-46.78814,0.225,NULL,51065116635,797892447,12467069,14.8),(143285,'IRAS','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143285,33.8,0.8,57.6,68988,75,NULL,'MAT, I','ESO 103- G 039',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'15.02',1.1,'Sc?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,279.841667,-66.69919,0.245,NULL,49201095817,768767122,12011986,15.02),(143286,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143286,33.33,0.32,46.4,68988,85,NULL,'I, inv','ESO 103- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143287,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143287,33.34,0.32,46.5,68988,85,NULL,'I, raw','ESO 103- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143288,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143288,33.41,0.43,48.1,68988,75,NULL,'MAT, I, raw','ESO 103- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143289,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143289,33.43,0.43,48.4,68988,75,NULL,'MAT, I, inv','ESO 103- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143290,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143290,33.7,0.43,55,68988,75,NULL,'MAT, I, cor','ESO 103- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143291,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143291,34.03,0.09,64.1,68988,NULL,NULL,NULL,'ESO 103- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143292,'Tully est','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143292,32.11,0.8,26.4,68989,75,NULL,NULL,'NGC 6654A',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000023,NULL,'13.54',0.8,'SB(s)d pec?','in a pair',NULL,NULL,NULL,1,279.853917,73.57975,0.293,NULL,52736488225,824007628,12875119,13.54),(143293,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143293,35.01,0.43,101,68990,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11334',NULL,'2014MNRAS.444..527S',2014,1,1.96,NULL,'G',0.000017,NULL,'16.0',0.28,'Sc',NULL,NULL,NULL,NULL,1,279.8744583,73.82589,0.305,NULL,52736512527,824008008,12875125,16),(143294,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143294,34.89,0.52,95,68991,70,NULL,NULL,'2MASX J18393158-7736475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,279.88175,-77.61319,0.549,NULL,48484651271,757572676,11837073,15.2),(143295,'GRB','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143295,45.22,1.51,3730,68992,NULL,NULL,NULL,'GRB 081008',1.9685,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,279.958,-57.43186,0.353,NULL,49102895275,767232738,11988011,NULL),(143296,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143296,34.19,0.18,67.4,68993,74.2,NULL,'SALT 2','NGC 6685',0.021905,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.00012,NULL,'14.45',0.9,'S0-:','Group member',NULL,NULL,NULL,1,279.994333,39.98178,0.237,NULL,54786335526,856036492,13375570,14.45),(143297,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143297,34.76,0.09,89.5,68993,74.4,NULL,NULL,'NGC 6685',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143298,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143298,34.89,0.17,93,68993,70,NULL,'SALT 2','NGC 6685',0.021905,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143299,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143299,34.96,0.04,96.1,68993,72,NULL,'SALT','NGC 6685',0.021905,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143300,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143300,35.05,0.19,100,68993,65,NULL,'SALT','NGC 6685',0.021905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143301,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143301,35.06,0.21,101,68993,65,NULL,'SALT2','NGC 6685',0.021905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143302,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143302,35.11,0.18,103,68993,65,NULL,'MLCS17','NGC 6685',0.021905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143303,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143303,35.16,0.19,105,68993,65,NULL,'MLCS31','NGC 6685',0.021905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143304,'SNIa','2016-12-15 15:15:47','2016-12-16 11:21:02','1','SN 2006bq',NULL,143304,35.86,0.03,146,68993,70,NULL,'SALT 2','NGC 6685',0.021905,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143305,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143305,36.44,0.59,194,68994,70,NULL,NULL,'2MASX J18401747-2856368',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.8R',0.1,'stellar:',NULL,NULL,NULL,NULL,1,280.0727083,-28.94356,0.565,NULL,47719844021,745622562,11650352,15.8),(143306,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143306,33,0.69,39.8,68995,100,NULL,'mid-IR','UGC 11315',NULL,'2013ApJ...771...88L',2013,1,2.1,NULL,'G',0.000006,NULL,'13.4',1,'Sb;HSB',NULL,NULL,NULL,NULL,1,280.0825417,24.19997,0.825,NULL,54310084964,848595077,13259298,13.4),(143307,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143307,33.89,0.4,59.9,68995,NULL,NULL,'mean','UGC 11315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143308,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143308,34.2,0.47,69.1,68995,NULL,NULL,'H','UGC 11315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143309,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143309,34.22,0.46,69.9,68995,NULL,NULL,'J','UGC 11315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143310,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143310,34.29,0.45,72,68995,NULL,NULL,'K','UGC 11315',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143311,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143311,34.8,0.51,91.4,68996,70,NULL,NULL,'AM 1832-771 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,280.121083,-77.13353,0.681,NULL,48484399291,757568738,11837011,14.4),(143312,'FP','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143312,34.22,0.48,69.9,68997,70,NULL,NULL,'ESO 045- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000077,NULL,'14.4',1.2,'E             blazar',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,280.1602917,-77.15803,0.681,NULL,48484852776,757575824,11837122,14.4),(143313,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143313,34.46,0.4,78.1,68998,NULL,NULL,'mean','NGC 6688',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000097,NULL,'13.60',1.7,'SA0+',NULL,NULL,NULL,NULL,1,280.1672083,36.28964,0.189,NULL,54271832654,847997385,13249959,13.6),(143314,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143314,34.75,0.45,89.3,68998,NULL,NULL,'K','NGC 6688',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143315,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143315,34.1,0.49,66.1,68999,75,NULL,'IR','UGC 11325',NULL,'2011yCatp016004901K',2011,1,2.3,NULL,'G',0.000023,NULL,'14.42',0.5,'Sb',NULL,NULL,NULL,NULL,1,280.182333,36.16375,0.189,NULL,54271926840,847998856,13249982,14.42),(143316,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143316,34.13,0.47,66.9,68999,NULL,NULL,'H','UGC 11325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143317,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143317,34.23,0.46,70.2,68999,NULL,NULL,'J','UGC 11325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143318,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143318,34.24,0.45,70.4,68999,NULL,NULL,'K','UGC 11325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143319,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143319,34.53,0.4,80.4,68999,NULL,NULL,'mean','UGC 11325',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143320,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,'R',143320,34.13,0.49,66.9,69000,75,NULL,'IR','UGC 11320',NULL,'2011yCatp016004901K',2011,1,2.11,'Haynes, et al. (1999AJ....117.2039H) give v = 4810 km/sec.','G',0.00002,NULL,'14.9',0.28,'Sc;HSB',NULL,NULL,NULL,NULL,1,280.200333333,23.68403,0.573,NULL,54309964540,848593195,13259268,14.9),(143321,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143321,34.26,0.33,71,69000,NULL,NULL,'Malmquist cor.','UGC 11320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143322,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143322,34.26,NULL,71.3,69000,70,NULL,'H, 2MASS, Malmquist corr.','UGC 11320',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143323,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143323,34.28,NULL,71.8,69000,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','UGC 11320',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143324,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143324,34.3,0.31,72.6,69000,70,NULL,'H, 2MASS','UGC 11320',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143325,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143325,34.32,0.31,73.1,69000,70,NULL,'H, UH88/IRSF/2MASS','UGC 11320',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143326,'Tully-Fisher','2016-12-15 15:15:47','2016-12-16 11:21:02','1',NULL,NULL,143326,34.32,0.2,73.1,69000,74.4,NULL,NULL,'UGC 11320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143327,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143327,34.36,0.43,74.4,69000,75,NULL,'3.6 micron, color corrected','UGC 11320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143328,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143328,34.38,0.43,75.3,69000,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143329,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143329,34.4,0.31,75.9,69000,NULL,NULL,NULL,'UGC 11320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143330,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143330,34.44,NULL,77.3,69000,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143331,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143331,34.45,NULL,77.5,69000,NULL,NULL,'Dipole','UGC 11320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143332,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143332,34.45,NULL,77.6,69000,NULL,NULL,'Dipole + Quadrupole','UGC 11320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143333,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143333,34.49,NULL,79,69001,NULL,NULL,NULL,'UGC 11328',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.00003,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,280.208083333,38.00458,0.213,NULL,54264420747,847881574,13248149,16),(143334,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143334,34.51,NULL,79.7,69001,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143335,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143335,34.52,NULL,80.1,69001,NULL,NULL,'Dipole + Quadrupole','UGC 11328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143336,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143336,34.52,NULL,80.3,69001,NULL,NULL,'Dipole','UGC 11328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143337,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143337,34.67,0.49,85.8,69001,75,NULL,'IR','UGC 11328',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143338,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143338,34.79,0.2,90.8,69001,74.4,NULL,NULL,'UGC 11328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143339,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143339,34.8,0.43,91,69001,75,NULL,'3.6 micron, color corrected','UGC 11328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143340,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143340,34.82,0.34,91.9,69001,NULL,NULL,'Malmquist cor.','UGC 11328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143341,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143341,34.84,0.43,92.7,69001,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143342,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143342,34.92,0.32,96.3,69001,NULL,NULL,NULL,'UGC 11328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143343,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143343,35.58,0.53,131,69002,70,NULL,NULL,'2MASX J18405544-7555373',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00014,NULL,'13.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,280.2310417,-75.92706,0.445,NULL,48482045201,757531956,11836436,13.6),(143344,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143344,33.36,0.2,47,69003,74.4,NULL,NULL,'UGC 11323',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000043,NULL,'14.5',0.6,'SB(s)bc',NULL,NULL,NULL,NULL,1,280.239875,23.08517,0.909,NULL,54607892719,853248323,13332005,14.5),(143345,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143345,34.05,0.25,64.6,69004,74.4,NULL,NULL,'ESO 103- G 046',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000123,NULL,'14.39',0.7,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.351,-64.01392,0.365,NULL,48983853202,765372706,11958948,14.39),(143346,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143346,34.06,0.52,64.9,69005,70,NULL,NULL,'IC 4743',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.91',0.4,'S0',NULL,NULL,NULL,NULL,1,280.3714583,-61.77222,0.417,NULL,48976038578,765250602,11957040,14.91),(143347,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143347,36.31,0.56,183,69006,70,NULL,NULL,'2MASX J18414226-5141410',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.2,NULL,NULL,NULL,NULL,NULL,1,280.4262083,-51.69478,0.293,NULL,48901424419,764084756,11938824,14.8),(143348,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143348,36.78,0.58,227,69007,70,NULL,NULL,'2MASX J18414880-4653064',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,280.453458333,-46.88519,0.265,NULL,51065410319,797897036,12467141,15.5),(143349,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143349,33.81,0.4,57.8,69008,75,NULL,'Edat, raw','IC 4742',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000097,NULL,'16.3b',1.3,'E1','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.4690417,-63.86208,0.317,NULL,48984260513,765379070,11959047,16.3),(143350,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143350,33.85,0.4,58.8,69008,75,NULL,'Edat, cor','IC 4742',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143351,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143351,33.81,0.25,57.8,69008,74.4,NULL,NULL,'IC 4742',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143352,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143352,33.15,0.45,42.7,69008,NULL,NULL,'K','IC 4742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143353,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143353,33.96,0.4,62,69008,NULL,NULL,'mean','IC 4742',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143354,'BL Lac Luminosity','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143354,39.44,NULL,772,69009,NULL,NULL,'Min. z = 0.2','1FGL J1841.9+3220',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,280.477,32.341,0.469,NULL,54477769139,851215142,13300236,NULL),(143355,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143355,35.65,NULL,135,69010,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2223',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',NULL,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,280.477125,49.91339,0.201,NULL,52907800540,826684383,12916943,16.5),(143356,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143356,35.67,NULL,136,69010,NULL,NULL,'Dipole + Quadrupole','FGC 2223',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143357,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143357,35.69,NULL,137,69010,NULL,NULL,'Dipole','FGC 2223',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143358,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143358,35.7,NULL,138,69010,NULL,NULL,NULL,'FGC 2223',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143359,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143359,35.95,0.49,155,69010,75,NULL,'IR','FGC 2223',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143360,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143360,34.99,0.62,99.3,69011,70,NULL,NULL,'2MASX J18420100-7713035',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,280.504167,-77.21761,0.681,NULL,48484851898,757575810,11837122,15),(143361,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143361,33.97,0.51,62.2,69012,70,NULL,NULL,'ESO 103- G 049',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.91',0.4,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.506375,-65.09556,0.249,NULL,48930286498,764535726,11945870,14.91),(143362,'AGN time lag','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143362,38.01,0.9,400,69013,44,NULL,NULL,'3C 390.3',NULL,'2007MNRAS.380..669C',2007,1,NULL,NULL,'G',NULL,NULL,'14.37',NULL,'Opt.var.;BLRG  Sy1',NULL,NULL,'FR II','Flat-Spectrum Radio Source',1,280.5374583,79.77142,0.169,NULL,52851812359,825809568,12903274,14.37),(143363,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143363,33.15,0.25,42.7,69014,74.4,NULL,NULL,'2MASX J18421613-6336596',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000103,NULL,'15.08',NULL,NULL,NULL,NULL,NULL,NULL,1,280.567083333,-63.61653,0.325,NULL,48982405843,765350091,11958595,15.08),(143364,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143364,34.04,0.59,64.3,69014,70,NULL,NULL,'2MASX J18421613-6336596',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143365,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143365,34.41,0.41,76.2,69015,NULL,NULL,NULL,'ESO 396- G 001',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.27',0.3,'Sb:',NULL,NULL,NULL,NULL,1,280.64,-35.57447,0.425,NULL,47544654384,742885224,11607581,14.27),(143366,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143366,34.45,0.2,77.6,69015,74.4,NULL,NULL,'ESO 396- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143367,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143367,34.51,0.39,79.8,69015,NULL,NULL,'Malmquist cor.','ESO 396- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143368,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143368,34.62,0.4,83.8,69016,NULL,NULL,'mean','NGC 6695',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000043,NULL,'14.28',0.7,'SBb','Isolated galaxy',NULL,NULL,NULL,1,280.678083,40.36689,0.281,NULL,54790146458,856096038,13376500,14.28),(143369,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143369,34.89,0.47,95.2,69016,NULL,NULL,'H','NGC 6695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143370,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143370,34.93,0.46,96.9,69016,NULL,NULL,'J','NGC 6695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143371,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143371,34.94,0.45,97.2,69016,NULL,NULL,'K','NGC 6695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143372,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143372,35.28,0.43,114,69016,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6695',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143373,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143373,33.21,0.25,43.9,69017,74.4,NULL,NULL,'IC 4748',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00014,NULL,'14.29',0.8,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.6915,-64.07267,0.365,NULL,48984344186,765380377,11959068,14.29),(143374,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143374,33.83,0.4,58.3,69018,NULL,NULL,'mean','IC 4749',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00012,NULL,'14.25',0.9,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.7062083,-63.20842,0.341,NULL,48987051975,765422687,11959729,14.25),(143375,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143375,34.01,0.45,63.4,69018,NULL,NULL,'K','IC 4749',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143376,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143376,34.8,0.34,91.1,69019,NULL,NULL,'Malmquist cor.','UGC 11341',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000127,NULL,'15.36',0.3,'Scd:',NULL,NULL,NULL,NULL,1,280.711875,39.54906,0.253,NULL,54789745093,856089767,13376402,15.36),(143377,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143377,34.82,0.2,92,69019,74.4,NULL,NULL,'UGC 11341',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143378,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143378,34.98,0.31,99.2,69019,NULL,NULL,NULL,'UGC 11341',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143379,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143379,33.52,0.45,50.7,69020,NULL,NULL,'K','IC 4751',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.0001,NULL,'14.05',0.6,'(R)SB(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,280.830583,-62.11228,0.421,NULL,48975469163,765241705,11956901,14.05),(143380,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143380,33.97,0.4,62.4,69020,NULL,NULL,'mean','IC 4751',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143381,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143381,34.75,0.5,89.2,69021,70,NULL,NULL,'2MASX J18432743-5339389',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.4,'(R_1)SB0^0',NULL,NULL,NULL,NULL,1,280.864125,-53.66083,0.281,NULL,48897931067,764030172,11937971,13.5),(143382,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143382,36.57,NULL,207,69022,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11366',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.0001,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,280.960666667,81.73425,0.177,NULL,52645897165,822592143,12853002,16.5),(143383,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143383,36.58,NULL,207,69022,NULL,NULL,NULL,'UGC 11366',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143384,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143384,36.6,NULL,209,69022,NULL,NULL,'Dipole + Quadrupole','UGC 11366',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143385,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143385,36.64,NULL,213,69022,NULL,NULL,'Dipole','UGC 11366',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143386,'Cepheids','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'RN',143386,19.77,NULL,0.09,69023,NULL,NULL,NULL,'NORMA DWARF A',NULL,'2016AAS...22744106C',2016,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143387,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143387,34.82,0.59,91.9,69023,70,NULL,NULL,'IC 4761',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143388,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143388,36.21,0.87,174,69024,70,NULL,NULL,'2MASX J18441365-8505140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,281.056875,-85.08731,0.481,NULL,48373365092,755833829,11809903,16.9),(143389,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143389,33.54,0.2,51.1,69025,74.4,NULL,NULL,'UGC 11344',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000013,NULL,'13.6',1,'Sab',NULL,NULL,NULL,NULL,1,281.064167,24.1425,0.889,NULL,54310306943,848598545,13259352,13.6),(143390,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143390,33.72,0.43,55.5,69025,75,NULL,'3.6 micron, color corrected','UGC 11344',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143391,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143391,33.77,0.4,56.9,69025,NULL,NULL,'mean','UGC 11344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143392,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143392,33.82,0.47,58,69025,NULL,NULL,'H','UGC 11344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143393,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143393,33.85,0.45,58.8,69025,NULL,NULL,'K','UGC 11344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143394,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143394,33.86,0.46,59,69025,NULL,NULL,'J','UGC 11344',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143395,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143395,33.93,0.34,61,69025,70,NULL,'H, 2MASS','UGC 11344',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143396,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143396,33.99,0.43,62.8,69025,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11344',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143397,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143397,34.1,0.34,66,69025,70,NULL,'H, UH88/IRSF/2MASS','UGC 11344',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143398,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143398,33.18,0.49,43.3,69026,75,NULL,'IR','UGC 11346',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'14.5',0.8,'SBb',NULL,NULL,NULL,NULL,1,281.070208333,25.25647,0.961,NULL,54309572920,848587076,13259173,14.5),(143399,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143399,35.42,0.52,122,69027,70,NULL,NULL,'2MASX J18442238-7600494',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.0929583,-76.01381,0.445,NULL,48482136909,757533389,11836459,14.8),(143400,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143400,34.24,NULL,70.6,69028,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','IRAS  18421+1218',NULL,'2011A&A...531A..87I',2011,1,0.9,NULL,'G',NULL,NULL,NULL,0.1,'Spiral;HSB',NULL,NULL,NULL,NULL,1,281.13,12.36472,NULL,NULL,54577199153,852768736,13324511,NULL),(143401,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143401,34.24,NULL,70.6,69028,70,NULL,'H, 2MASS, Malmquist corr.','IRAS  18421+1218',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143402,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143402,34.39,0.46,75.6,69028,70,NULL,'H, UH88/IRSF/2MASS','IRAS  18421+1218',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143403,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143403,34.39,0.46,75.6,69028,70,NULL,'H, 2MASS','IRAS  18421+1218',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143404,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143404,33.29,0.4,45.5,69029,75,NULL,'Edat, raw','NGC 6653',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000187,NULL,'12.2',1.5,'E1:',NULL,NULL,NULL,NULL,1,281.159875,-73.26342,0.277,NULL,48515725686,758058213,11844659,12.2),(143405,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143405,33.62,0.4,53,69029,75,NULL,'Edat, cor','NGC 6653',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143406,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143406,33.95,0.45,61.7,69029,NULL,NULL,'K','NGC 6653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143407,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143407,34.18,0.4,68.5,69029,NULL,NULL,'mean','NGC 6653',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143408,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143408,34.65,0.59,85.2,69030,70,NULL,NULL,'AM 1839-652',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.16325,-65.26758,0.229,NULL,48926842251,764481910,11945029,14.5),(143409,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143409,36.34,0.82,185,69031,70,NULL,NULL,'2MASX J18444843-7618394',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,281.201583,-76.31106,0.417,NULL,48482575864,757540247,11836566,14.6),(143410,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143410,33.56,0.8,51.5,69032,75,NULL,'HMCL, I','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000031,NULL,'14.7',0.9,'(R\'_2)SB(rs)b  Sy1','Line-of-sight pair member',NULL,NULL,'Sy 1',1,281.224916667,-62.36483,0.329,NULL,48975404182,765240690,11956885,14.7),(143411,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143411,33.59,0.8,52.3,69032,75,NULL,'MAT, I','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143412,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143412,32.45,0.43,30.8,69032,75,NULL,'MAT, I, raw','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143413,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143413,32.51,0.32,31.7,69032,85,NULL,'I, raw','ESO 140- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143414,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143414,32.53,0.32,32,69032,85,NULL,'I, inv','ESO 140- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143415,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143415,32.55,0.43,32.3,69032,75,NULL,'MAT, I, inv','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143416,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143416,32.88,0.43,37.6,69032,75,NULL,'MAT, I, cor','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143417,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143417,33,0.45,39.8,69032,NULL,NULL,'K','ESO 140- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143418,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143418,33.3,0.47,45.8,69032,NULL,NULL,'H','ESO 140- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143419,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143419,33.53,0.4,50.9,69032,75,NULL,'HMCL, I, raw','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143420,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143420,33.57,0.46,51.8,69032,NULL,NULL,'J','ESO 140- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143421,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143421,33.7,0.4,55,69032,75,NULL,'HMCL, I, inv','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143422,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143422,33.74,0.4,56.1,69032,75,NULL,'HMCL, I, cor','ESO 140- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143423,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143423,33.79,0.4,57.2,69032,NULL,NULL,'mean','ESO 140- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143424,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143424,34.03,0.08,64.1,69032,NULL,NULL,NULL,'ESO 140- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143425,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143425,34.37,0.43,74.8,69033,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J18445773+2147268',NULL,'2014MNRAS.444..527S',2014,1,0.56,NULL,'G',0.00003,NULL,NULL,0.22,'Spiral',NULL,NULL,NULL,NULL,1,281.2405,21.79078,1.117,NULL,54608938902,853264670,13332260,NULL),(143426,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143426,33.73,0.47,55.7,69034,NULL,NULL,'H','IC 4755',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00015,NULL,'17.2b',0.3,'Sa:','Group member',NULL,NULL,NULL,1,281.2547917,-63.69222,0.325,NULL,48982633131,765353642,11958650,17.2),(143427,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143427,33.81,0.45,57.9,69034,NULL,NULL,'K','IC 4755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143428,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143428,33.9,0.46,60.3,69034,NULL,NULL,'J','IC 4755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143429,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143429,33.9,0.49,60.3,69034,75,NULL,'IR','IC 4755',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143430,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143430,33.97,0.4,62.2,69034,NULL,NULL,'mean','IC 4755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143431,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143431,32.75,0.45,35.5,69035,NULL,NULL,'K','ESO 103- G 059',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000033,NULL,'14.99',0.2,'S0','Group member',NULL,NULL,NULL,1,281.255541667,-63.517,0.325,NULL,48982607913,765353248,11958644,14.99),(143432,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143432,33.55,0.4,51.3,69035,NULL,NULL,'mean','ESO 103- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143433,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143433,30.16,0.14,10.8,69036,74.4,NULL,NULL,'NGC 6673',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.00006,NULL,'12.57',0.9,'SAB(s)0-:','Line-of-sight pair member',NULL,NULL,NULL,1,281.276333333,-62.29722,0.329,NULL,48975514580,765242415,11956912,12.57),(143434,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143434,30.18,0.23,10.9,69036,NULL,NULL,'I','NGC 6673',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143435,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143435,30.77,0.4,14.3,69036,75,NULL,'Edat, raw','NGC 6673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143436,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143436,30.95,0.4,15.5,69036,75,NULL,'Edat, cor','NGC 6673',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143437,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143437,30.63,0.45,13.4,69036,NULL,NULL,'K','NGC 6673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143438,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143438,31.28,0.4,18.1,69036,NULL,NULL,'mean','NGC 6673',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143439,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143439,33.86,0.8,59.2,69037,75,NULL,'MAT, I','ESO 336- G 013',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00001,NULL,'14.5',1,'SAb:',NULL,NULL,NULL,NULL,1,281.371875,-39.18144,0.425,NULL,51043602019,797556281,12461816,14.5),(143440,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143440,33.55,0.43,51.2,69037,75,NULL,'MAT, I, raw','ESO 336- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143441,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143441,33.58,0.32,52.1,69037,85,NULL,'I, raw','ESO 336- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143442,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143442,33.64,0.32,53.5,69037,85,NULL,'I, inv','ESO 336- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143443,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143443,33.79,0.43,57.2,69037,75,NULL,'MAT, I, inv','ESO 336- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143444,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143444,33.97,0.47,62.2,69037,NULL,NULL,'H','ESO 336- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143445,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143445,34,0.45,63,69037,NULL,NULL,'K','ESO 336- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143446,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143446,34.03,0.46,64.1,69037,NULL,NULL,'J','ESO 336- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143447,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143447,34.06,0.43,65,69037,75,NULL,'MAT, I, cor','ESO 336- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143448,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143448,34.09,0.4,65.6,69037,NULL,NULL,'mean','ESO 336- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143449,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143449,34.36,0.29,74.4,69037,NULL,NULL,NULL,'ESO 336- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143450,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143450,34.4,0.2,75.9,69037,74.4,NULL,NULL,'ESO 336- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143451,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143451,34.44,0.28,77.2,69037,NULL,NULL,'Malmquist cor.','ESO 336- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143452,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143452,34.07,0.45,65,69038,NULL,NULL,'K','IC 4760',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.00005,NULL,'15.09',0.7,'SA(rl)0^0','Group member',NULL,NULL,NULL,1,281.4414583,-62.95836,0.345,NULL,48987323021,765426922,11959795,15.09),(143453,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143453,34.19,0.4,69,69038,NULL,NULL,'mean','IC 4760',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143454,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143454,33.74,0.4,56,69039,NULL,NULL,'mean','2MASX J18454690-6259551',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.000087,NULL,'16.25',NULL,'SB0','Group member',NULL,NULL,NULL,1,281.445083,-62.99864,0.345,NULL,48987321932,765426905,11959795,16.25),(143455,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143455,34.04,0.45,64.2,69039,NULL,NULL,'K','2MASX J18454690-6259551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143456,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143456,33.94,0.25,61.4,69040,74.4,NULL,NULL,'2MASX J18455069-6314091',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00008,NULL,'15',NULL,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.461417,-63.23578,0.341,NULL,48987185579,765424774,11959762,15),(143457,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143457,34.15,0.47,67.6,69041,NULL,NULL,'H','ESO 230- G 010',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'12.78',0.4,'S              HII',NULL,NULL,NULL,NULL,1,281.510875,-50.77444,0.217,NULL,48896321475,764005023,11937578,12.78),(143458,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143458,34.21,0.4,69.6,69041,NULL,NULL,'mean','ESO 230- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143459,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143459,34.23,0.45,70.1,69041,NULL,NULL,'K','ESO 230- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143460,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143460,34.29,0.46,72,69041,NULL,NULL,'J','ESO 230- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143461,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143461,34.37,0.38,74.7,69041,NULL,NULL,'Malmquist cor.','ESO 230- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143462,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143462,34.52,0.35,80.2,69041,NULL,NULL,NULL,'ESO 230- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143463,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143463,34.56,0.2,81.7,69041,74.4,NULL,NULL,'ESO 230- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143464,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143464,34.2,0.4,69.1,69042,NULL,NULL,'mean','NGC 6700',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00003,NULL,'13.8',1,'SB(rs)c',NULL,NULL,NULL,NULL,1,281.5182917,32.27961,0.381,NULL,54454768068,850855751,13294621,13.8),(143465,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143465,34.39,0.45,75.5,69042,NULL,NULL,'K','NGC 6700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143466,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143466,34.39,0.46,75.6,69042,NULL,NULL,'J','NGC 6700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143467,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143467,34.42,0.47,76.5,69042,NULL,NULL,'H','NGC 6700',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143468,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143468,34.53,0.46,80.7,69042,NULL,NULL,'Malmquist cor.','NGC 6700',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143469,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143469,34.56,0.35,81.7,69042,70,NULL,'H, UH88/IRSF/2MASS','NGC 6700',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143470,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143470,34.56,0.35,81.7,69042,70,NULL,'H, 2MASS','NGC 6700',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143471,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143471,34.66,0.2,85.5,69042,74.4,NULL,NULL,'NGC 6700',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143472,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143472,34.7,0.42,87.2,69042,NULL,NULL,NULL,'NGC 6700',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143473,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143473,37.55,0.56,324,69043,70,NULL,NULL,'2MASX J18460669-5517332',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.528,-55.29253,0.285,NULL,49107900172,767310940,11989233,15.4),(143474,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143474,34.13,0.43,67,69044,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11350',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000017,NULL,'14.1',1.1,'Scd:',NULL,NULL,NULL,NULL,1,281.570167,22.61519,1.129,NULL,54596358737,853068105,13329189,14.1),(143475,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143475,33.2,0.15,43,69045,74.2,NULL,'SALT 2','IC 4758',0.0155,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000127,NULL,'14.16',0.9,'Sc',NULL,NULL,NULL,NULL,1,281.576125,-65.75667,0.221,NULL,48927400630,764490634,11945166,14.16),(143476,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143476,33.78,0.08,57,69045,74.4,NULL,NULL,'IC 4758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143477,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143477,33.83,0.06,57.5,69045,72,NULL,NULL,'IC 4758',0.0155,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143478,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143478,33.83,0.15,57.5,69045,72,NULL,NULL,'IC 4758',0.0155,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143479,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143479,33.85,0.2,58.1,69045,70,NULL,'SALT 2','IC 4758',0.0155,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143480,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143480,33.89,0.19,59.1,69045,73.8,NULL,'SALT 2 (SNANA)','IC 4758',0.0155,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143481,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143481,33.89,0.04,59.1,69045,72,NULL,NULL,'IC 4758',0.0155,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143482,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143482,33.9,0.02,59.4,69045,72,NULL,NULL,'IC 4758',0.0155,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143483,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143483,33.91,0.19,59.6,69045,72,NULL,NULL,'IC 4758',0.0155,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143484,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143484,33.91,0.05,60.5,69045,72,NULL,'M(H) = -18.317 mag','IC 4758',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143485,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143485,34.03,0.15,63,69045,70,NULL,'SALT','IC 4758',0.0155,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143486,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143486,34.06,0.11,63.8,69045,65,NULL,'MLCS2k2','IC 4758',0.0155,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143487,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143487,34.08,0.22,64.5,69045,65,NULL,'MLCS31','IC 4758',0.0155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143488,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143488,34.13,0.11,65,69045,65,NULL,'MLCS2k2','IC 4758',0.0155,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143489,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143489,34.12,0.14,65.6,69045,70,NULL,NULL,'IC 4758',0.0155,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143490,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143490,34.13,0.22,65.8,69045,65,NULL,'MLCS17','IC 4758',0.0155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143491,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143491,34.13,0.24,65.9,69045,65,NULL,'SALT2','IC 4758',0.0155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143492,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143492,34.1,0.17,66.1,69045,70.8,NULL,NULL,'IC 4758',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143493,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143493,34.15,0.22,66.4,69045,65,NULL,'SALT','IC 4758',0.0155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143494,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143494,34.4,0.02,74.7,69045,65,NULL,'SALT','IC 4758',0.0155,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143495,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:02','1','SN 2001cn',NULL,143495,35.07,0.03,102,69045,70,NULL,'SALT 2','IC 4758',0.0155,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143496,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143496,34.14,0.37,67.4,69046,NULL,NULL,NULL,'ESO 230- G 011',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'13.74',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,281.5960417,-52.15636,0.229,NULL,48901837660,764091213,11938925,13.74),(143497,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143497,34.18,0.2,68.6,69046,74.4,NULL,NULL,'ESO 230- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143498,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143498,34.2,0.36,69.2,69046,NULL,NULL,'Malmquist cor.','ESO 230- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143499,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143499,33.81,0.4,57.8,69047,75,NULL,'Edat, raw','2MASX J18462497-6319312',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'G',0.000047,NULL,'14',NULL,'SB0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.603917,-63.32517,0.289,NULL,48986930320,765420786,11959699,14),(143500,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143500,33.85,0.4,58.8,69047,75,NULL,'Edat, cor','2MASX J18462497-6319312',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143501,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143501,33.53,0.23,50.8,69047,74.4,NULL,NULL,'2MASX J18462497-6319312',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143502,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143502,36.02,0.59,160,69048,70,NULL,NULL,'2MASX J18463484-5924023',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.645375,-59.40061,0.349,NULL,49094777545,767105899,11986029,15.3),(143503,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143503,33.81,0.4,57.8,69049,75,NULL,'Edat, raw','ESO 104- G 002',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.14',0.3,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.7235,-63.36122,0.289,NULL,48982525522,765351961,11958624,14.14),(143504,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143504,33.85,0.4,58.8,69049,75,NULL,'Edat, cor','ESO 104- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143505,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143505,33.75,0.23,56.2,69049,74.4,NULL,NULL,'ESO 104- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143506,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143506,33.51,0.24,50.4,69050,NULL,NULL,'I','NGC 6702',NULL,'2001ApJ...546..681T',2001,1,1.8,NULL,'G',0.000017,NULL,'13.23',1.3,'E:             LINER','in a pair',NULL,NULL,NULL,1,281.739916667,45.70567,0.233,NULL,54826255388,856660240,13385316,13.23),(143507,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143507,33.51,0.24,50.4,69050,NULL,NULL,NULL,'NGC 6702',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143508,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143508,33.58,0.14,52,69050,74.4,NULL,NULL,'NGC 6702',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143509,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143509,33.93,0.24,61,69050,NULL,NULL,'Malmquist cor.','NGC 6702',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143510,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143510,33.17,0.4,43.1,69050,75,NULL,'Edat, raw','NGC 6702',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143511,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143511,33.51,0.4,50.3,69050,75,NULL,'Edat, cor','NGC 6702',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143512,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143512,33.27,0.44,45.1,69050,95,NULL,'Weighted Mean','NGC 6702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143513,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143513,33.74,0.46,56,69050,95,NULL,'Michard 1979a','NGC 6702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143514,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143514,33.75,0.63,56.2,69050,95,NULL,'Michard 1979b, c','NGC 6702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143515,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143515,33.08,0.41,41.3,69050,NULL,NULL,NULL,'NGC 6702',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143516,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143516,33.67,0.41,54.2,69050,NULL,NULL,'Malmquist cor.','NGC 6702',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143517,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143517,33.54,0.45,51.1,69050,NULL,NULL,'K','NGC 6702',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143518,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143518,34.08,0.4,65.5,69050,NULL,NULL,'mean','NGC 6702',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143519,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143519,34.66,0.8,85.5,69051,75,NULL,'MAT, I','ESO 024- G 019',NULL,'1997ApJS..109..333W',1997,1,2.22,NULL,'G',0.000033,NULL,'13.88',0.15,'Sc',NULL,NULL,NULL,NULL,1,281.804583,-82.12861,0.529,NULL,48368639647,755759994,11808749,13.88),(143520,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143520,34.41,0.41,76.1,69051,NULL,NULL,'Malmquist cor.','ESO 024- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143521,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143521,34.53,0.38,80.4,69051,NULL,NULL,NULL,'ESO 024- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143522,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143522,34.57,0.2,82,69051,74.4,NULL,NULL,'ESO 024- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143523,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143523,34.69,0.43,86.9,69051,75,NULL,'MAT, I, raw','ESO 024- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143524,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143524,34.83,0.32,92.5,69051,85,NULL,'I, raw','ESO 024- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143525,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143525,34.87,NULL,94,69051,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 024- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143526,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143526,34.87,0.32,94.4,69051,85,NULL,'I, inv','ESO 024- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143527,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143527,34.88,NULL,94.5,69051,NULL,NULL,'Dipole','ESO 024- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143528,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143528,34.88,NULL,94.6,69051,NULL,NULL,'Dipole + Quadrupole','ESO 024- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143529,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143529,34.9,0.43,95.4,69051,75,NULL,'MAT, I, inv','ESO 024- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143530,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143530,34.92,NULL,96.5,69051,NULL,NULL,NULL,'ESO 024- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143531,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143531,35.07,0.43,103,69051,75,NULL,'MAT, I, cor','ESO 024- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143532,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143532,33.83,0.49,58.5,69052,75,NULL,'IR','ESO 230- G 012',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'13.05',0.3,'S...',NULL,NULL,NULL,NULL,1,281.805333,-48.35739,0.269,NULL,51031417497,797365898,12458842,13.05),(143533,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143533,34.27,0.34,71.3,69052,NULL,NULL,NULL,'ESO 230- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143534,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143534,34.31,0.2,72.8,69052,74.4,NULL,NULL,'ESO 230- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143535,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143535,34.36,0.32,74.6,69052,NULL,NULL,'Malmquist cor.','ESO 230- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143536,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143536,34.25,0.24,70.8,69053,75,NULL,NULL,'IC 4765',NULL,'1982AJ.....87..462G',1982,1,3.5,NULL,'G',0.000019,NULL,'12.33',1.9,'cD;E+4','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.8247083,-63.33133,0.289,NULL,48986914856,765420544,11959696,12.33),(143537,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143537,33.81,0.4,57.8,69053,75,NULL,'Edat, raw','IC 4765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143538,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143538,33.81,0.4,57.8,69053,75,NULL,'Edat, raw','IC 4765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143539,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143539,33.85,0.4,58.8,69053,75,NULL,'Edat, cor','IC 4765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143540,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143540,33.85,0.4,58.8,69053,75,NULL,'Edat, cor','IC 4765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143541,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143541,33.87,0.13,59.5,69053,72,NULL,'ABELL S0805, Pavo II CLUSTER, 12 galaxies','IC 4765',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143542,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143542,34,0.28,63,69053,70,NULL,'ABELL S0805, Pavo II CLUSTER, 70 galaxies','IC 4765',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143543,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143543,34.3,0.23,72.4,69053,74.4,NULL,NULL,'IC 4765',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143544,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143544,33.47,0.45,49.4,69053,NULL,NULL,'K','IC 4765',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143545,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143545,33.53,NULL,50.9,69053,71,NULL,'ABELL S0805, Pavo II CLUSTER, 70 galaxies','IC 4765',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143546,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143546,33.62,0.3,52.9,69053,NULL,NULL,'ABELL S0805, Pavo II CLUSTER, 13 galaxies','IC 4765',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143547,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143547,33.97,0.4,62.1,69053,NULL,NULL,'mean','IC 4765',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143548,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143548,33.81,0.4,57.8,69054,75,NULL,'Edat, raw','ESO 104- G 007',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'12.90',0.8,'E?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.824833333,-63.35939,0.289,NULL,48982524583,765351946,11958624,12.9),(143549,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143549,33.85,0.4,58.8,69054,75,NULL,'Edat, cor','ESO 104- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143550,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143550,33.78,0.23,57,69054,74.4,NULL,NULL,'ESO 104- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143551,'GCLF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143551,31.7,0.23,21.9,69055,NULL,NULL,NULL,'NGC 6703',NULL,'2001AJ....122.1251K',2001,1,2.5,NULL,'G',0.000017,NULL,'12.32',2.3,'SA0-','in a pair',NULL,NULL,NULL,1,281.8284583,45.55064,0.257,NULL,54826364389,856661943,13385342,12.32),(143552,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143552,32.13,0.29,26.7,69055,NULL,NULL,'I','NGC 6703',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143553,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143553,32.13,0.29,26.7,69055,NULL,NULL,NULL,'NGC 6703',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143554,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143554,32.17,0.14,27.2,69055,74.4,NULL,NULL,'NGC 6703',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143555,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143555,32.84,0.29,37,69055,NULL,NULL,'Malmquist cor.','NGC 6703',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143556,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143556,31.49,0.4,19.9,69055,75,NULL,'Edat, raw','NGC 6703',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143557,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143557,31.83,0.4,23.2,69055,75,NULL,'Edat, cor','NGC 6703',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143558,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143558,31.13,0.39,16.8,69055,95,NULL,'de Vaucouleurs','NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143559,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143559,31.15,0.29,17,69055,95,NULL,'Weighted Mean','NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143560,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143560,31.17,0.63,17.1,69055,95,NULL,'Michard 1979b, c','NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143561,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143561,31.56,0.46,20.5,69055,95,NULL,'Michard 1979a','NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143562,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143562,32.04,0.41,25.6,69055,NULL,NULL,NULL,'NGC 6703',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143563,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143563,32.86,0.41,37.3,69055,NULL,NULL,'Malmquist cor.','NGC 6703',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143564,'Tertiary','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143564,32.42,0.71,30.5,69055,95,NULL,NULL,'NGC 6703',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143565,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143565,32.77,0.8,35.9,69055,75,NULL,'B','NGC 6703',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143566,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143566,32.44,0.45,30.8,69055,NULL,NULL,'K','NGC 6703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143567,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143567,32.44,0.4,30.8,69055,NULL,NULL,'mean','NGC 6703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143568,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143568,33.97,0.8,62.1,69056,75,NULL,'MAT, I','ESO 336- G 016',NULL,'1997ApJS..109..333W',1997,1,2,'Marginal HIPASS detection.','G',0.000013,NULL,'14.5',0.8,'SA(s)c:',NULL,NULL,NULL,NULL,1,281.845791667,-41.71803,0.373,NULL,51041689586,797526399,12461349,14.5),(143569,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143569,33.42,0.43,48.4,69056,75,NULL,'MAT, I, raw','ESO 336- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143570,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143570,33.64,0.32,53.4,69056,85,NULL,'I, raw','ESO 336- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143571,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143571,33.69,0.43,54.7,69056,75,NULL,'MAT, I, inv','ESO 336- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143572,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143572,33.7,0.32,55,69056,85,NULL,'I, inv','ESO 336- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143573,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143573,33.97,0.43,62.2,69056,75,NULL,'MAT, I, cor','ESO 336- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143574,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143574,34.34,0.47,74,69056,NULL,NULL,'H','ESO 336- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143575,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143575,34.37,0.46,74.7,69056,NULL,NULL,'J','ESO 336- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143576,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143576,34.46,0.45,78,69056,NULL,NULL,'K','ESO 336- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143577,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143577,34.59,0.4,82.7,69056,NULL,NULL,'mean','ESO 336- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143578,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143578,33.6,0.45,52.5,69057,NULL,NULL,'K','ESO 104- G 008',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14',0.5,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.845417,-63.31033,0.289,NULL,48986456899,765413389,11959584,14),(143579,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143579,33.68,0.4,54.4,69057,NULL,NULL,'mean','ESO 104- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143580,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143580,36.07,0.83,164,69058,70,NULL,NULL,'2MASX J18473178-4303507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.882458333,-43.06414,0.317,NULL,51068716778,797948699,12467948,15.4),(143581,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143581,36.47,0.64,197,69059,70,NULL,NULL,'2MASX J18473486-7122092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,281.89525,-71.36925,0.217,NULL,48465039921,757266248,11832285,15.4),(143582,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143582,33.81,0.4,57.8,69060,75,NULL,'Edat, raw','IC 4767',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000014,NULL,'14.31',0.5,'S pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,281.923875,-63.40567,0.289,NULL,48983050165,765360158,11958752,14.31),(143583,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143583,33.81,0.4,57.8,69060,75,NULL,'Edat, raw','IC 4767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143584,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143584,33.85,0.4,58.8,69060,75,NULL,'Edat, cor','IC 4767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143585,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143585,33.85,0.4,58.8,69060,75,NULL,'Edat, cor','IC 4767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143586,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143586,33.87,0.25,59.4,69060,74.4,NULL,NULL,'IC 4767',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143587,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143587,32.93,0.45,38.5,69060,NULL,NULL,'K','IC 4767',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143588,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143588,33.32,0.4,46.2,69060,NULL,NULL,'mean','IC 4767',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143589,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143589,33.81,0.8,57.9,69061,75,NULL,'MAT, I','IC 4769',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.06',1.2,'SB(rs)bc       Sy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,281.9335417,-63.157,0.277,NULL,48986513295,765414270,11959597,14.06),(143590,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143590,33.23,0.32,44.2,69061,85,NULL,'I, raw','IC 4769',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143591,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143591,33.27,0.32,45.1,69061,85,NULL,'I, inv','IC 4769',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143592,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143592,33.51,0.43,50.4,69061,75,NULL,'MAT, I, raw','IC 4769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143593,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143593,33.72,0.43,55.6,69061,75,NULL,'MAT, I, inv','IC 4769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143594,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143594,33.75,0.43,56.2,69061,75,NULL,'MAT, I, cor','IC 4769',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143595,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143595,33.9,0.45,60.1,69061,NULL,NULL,'K','IC 4769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143596,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143596,33.9,0.47,60.4,69061,NULL,NULL,'H','IC 4769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143597,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143597,33.93,0.4,61,69061,NULL,NULL,'mean','IC 4769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143598,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143598,34.02,0.46,63.8,69061,NULL,NULL,'J','IC 4769',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143599,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143599,34.03,0.08,64.1,69061,NULL,NULL,NULL,'IC 4769',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143600,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143600,33.73,0.45,55.7,69062,NULL,NULL,'K','ESO 104-IG 012 NED01',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.000067,NULL,'16.5b',NULL,'S0','Group member',NULL,NULL,NULL,1,281.9845417,-63.18364,0.277,NULL,48986510767,765414230,11959597,16.5),(143601,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143601,33.78,0.4,56.9,69062,NULL,NULL,'mean','ESO 104-IG 012 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143602,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143602,34.32,0.47,73.2,69063,70,NULL,'H, UH88/IRSF/2MASS','UGC 11355',NULL,'2011A&A...531A..87I',2011,1,1.2,NULL,'G',0.000033,NULL,'14.2',0.7,'Sb',NULL,NULL,NULL,NULL,1,281.987416667,22.94253,1.097,NULL,54597025211,853078518,13329351,14.2),(143603,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143603,34.32,0.47,73.2,69063,70,NULL,'H, 2MASS','UGC 11355',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143604,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143604,35.58,0.51,131,69064,70,NULL,NULL,'2MASX J18475760-8008575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,281.990375,-80.14925,0.493,NULL,48538232194,758409878,11850154,17),(143605,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143605,33.83,0.4,58.3,69065,NULL,NULL,'mean','2MASX J18480210-6336094',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.00014,NULL,'15.70',NULL,'S0','Group member',NULL,NULL,NULL,1,282.00875,-63.60261,0.313,NULL,48983077964,765360593,11958759,15.7),(143606,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143606,34.28,0.45,71.8,69065,NULL,NULL,'K','2MASX J18480210-6336094',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143607,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143607,33.97,0.4,62.1,69066,NULL,NULL,'mean','2MASX J18480798-6312353',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'G',0.000077,NULL,'16',NULL,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,282.033125,-63.20989,0.277,NULL,48986515495,765414304,11959598,16),(143608,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143608,34.71,0.45,87.4,69066,NULL,NULL,'K','2MASX J18480798-6312353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143609,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143609,35.45,0.49,123,69067,75,NULL,'IR','ESO 104- G 014',NULL,'2011yCatp016004901K',2011,1,1.12,'ESO-LV gives v= 10224+/- 10 km/sec.','G',0.000033,NULL,'16.22',0.15,'SA(rs)bc:','Group member',NULL,NULL,NULL,1,282.09275,-63.21758,0.277,NULL,48986516447,765414319,11959598,16.22),(143610,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143610,35.62,0.49,133,69067,NULL,NULL,'Malmquist cor.','ESO 104- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143611,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143611,35.68,0.48,137,69067,NULL,NULL,NULL,'ESO 104- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143612,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143612,35.72,0.2,139,69067,74.4,NULL,NULL,'ESO 104- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143613,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143613,36.21,NULL,174,69067,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 104- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143614,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143614,36.23,NULL,176,69067,NULL,NULL,'Dipole + Quadrupole','ESO 104- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143615,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143615,36.26,NULL,178,69067,NULL,NULL,'Dipole','ESO 104- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143616,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143616,36.08,0.57,165,69068,70,NULL,NULL,'2MASX J18482619-5243132',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.1090417,-52.72028,0.157,NULL,48899853468,764060210,11938440,15.5),(143617,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143617,33.07,0.8,41.1,69069,75,NULL,'MAT, I','IC 4775',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.69',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,282.109541667,-57.18372,0.285,NULL,49108070867,767313607,11989275,14.69),(143618,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143618,33.02,0.32,40.2,69069,85,NULL,'I, raw','IC 4775',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143619,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143619,33.03,0.32,40.4,69069,85,NULL,'I, inv','IC 4775',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143620,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143620,33.22,0.43,44.1,69069,75,NULL,'MAT, I, raw','IC 4775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143621,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143621,33.32,0.43,46.1,69069,75,NULL,'MAT, I, inv','IC 4775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143622,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143622,33.45,0.44,49,69069,NULL,NULL,NULL,'IC 4775',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143623,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143623,33.48,0.49,49.8,69069,75,NULL,'IR','IC 4775',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143624,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143624,33.49,0.2,49.9,69069,74.4,NULL,NULL,'IC 4775',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143625,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143625,33.54,0.43,51.1,69069,75,NULL,'MAT, I, cor','IC 4775',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143626,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143626,33.67,0.39,54.3,69069,NULL,NULL,'Malmquist cor.','IC 4775',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143627,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143627,34.81,0.47,91.5,69070,70,NULL,NULL,'ESO 281- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000143,NULL,'13.8R',0.5,'S0',NULL,NULL,NULL,NULL,1,282.119417,-44.09064,0.365,NULL,51068905619,797951650,12467994,13.8),(143628,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143628,35.42,0.59,121,69071,70,NULL,NULL,'2MASX J18484589-5714081',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,282.191333333,-57.23561,0.285,NULL,49108064832,767313513,11989273,15.9),(143629,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143629,30.66,0.14,13.6,69072,74.4,NULL,NULL,'NGC 6684',NULL,'2013AJ....146...86T',2013,1,4,NULL,'G',0.000006,NULL,'11.31',2.6,'(L)SB(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,282.241167,-65.17344,0.225,NULL,48981724804,765339450,11958428,11.31),(143630,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143630,30.72,0.24,13.9,69072,NULL,NULL,'I','NGC 6684',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143631,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143631,30.72,0.24,13.9,69072,NULL,NULL,NULL,'NGC 6684',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143632,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143632,30.79,0.24,14.4,69072,NULL,NULL,'Malmquist cor.','NGC 6684',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143633,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143633,30.77,0.4,14.3,69072,75,NULL,'Edat, raw','NGC 6684',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143634,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143634,30.95,0.4,15.5,69072,75,NULL,'Edat, cor','NGC 6684',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143635,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143635,28.72,0.63,5.55,69072,95,NULL,'Michard 1979b, c','NGC 6684',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143636,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143636,29.17,NULL,6.82,69072,NULL,NULL,'LEDA [April 2006]','NGC 6684',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143637,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143637,29.44,0.37,7.73,69072,95,NULL,'Weighted Mean','NGC 6684',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143638,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143638,29.74,0.46,8.87,69072,95,NULL,'Michard 1979a','NGC 6684',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143639,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143639,30.64,0.81,13.4,69072,55,NULL,'Visvanathan & Sandage 1979','NGC 6684',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143640,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143640,29.49,0.41,7.89,69072,NULL,NULL,NULL,'NGC 6684',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143641,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143641,29.7,0.41,8.72,69072,NULL,NULL,'Malmquist cor.','NGC 6684',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143642,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143642,30.18,0.8,10.9,69072,75,NULL,'B','NGC 6684',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143643,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143643,29.7,NULL,8.71,69072,NULL,NULL,NULL,'NGC 6684',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143644,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143644,36.81,0.54,230,69073,70,NULL,NULL,'2MASX J18492490-4359392',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.353833,-43.99422,0.289,NULL,51068486148,797945096,12467892,14.9),(143645,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143645,36.92,0.89,242,69074,70,NULL,NULL,'2MASX J18493744-7134486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.406166667,-71.58011,0.217,NULL,48465160312,757268129,11832314,16),(143646,'FP','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143646,35.94,0.55,154,69075,70,NULL,NULL,'2MASX J18500333-5958223',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.514041667,-59.97292,0.389,NULL,49111324466,767364444,11990069,14.6),(143647,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143647,35.48,0.48,124,69076,NULL,NULL,'Malmquist cor.','ESO 231- G 004',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.10',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,282.518791667,-50.76653,0.237,NULL,48895798414,763996850,11937450,15.1),(143648,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143648,35.59,0.46,131,69076,NULL,NULL,NULL,'ESO 231- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143649,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143649,35.63,0.2,134,69076,74.4,NULL,NULL,'ESO 231- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143650,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,'R',143650,34.06,0.49,65,69077,75,NULL,'IR','UGC 11390',NULL,'2011yCatp016004901K',2011,1,1.28,NULL,'G',NULL,NULL,'16.5',0.16,'Sc',NULL,NULL,NULL,NULL,1,282.685875,84.58278,0.269,NULL,52672538121,823008408,12859506,16.5),(143651,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:02','1',NULL,NULL,143651,34.9,NULL,95.5,69077,NULL,NULL,'Dipole + Quadrupole','UGC 11390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143652,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143652,34.9,NULL,95.7,69077,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143653,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143653,34.91,NULL,95.7,69077,NULL,NULL,'Dipole','UGC 11390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143654,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143654,35.03,NULL,101,69077,NULL,NULL,NULL,'UGC 11390',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143655,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143655,36.08,0.58,165,69078,70,NULL,NULL,'2MASX J18505589-2941406',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'14.3R',0.1,NULL,NULL,NULL,NULL,NULL,1,282.732833,-29.69467,0.585,NULL,47769391742,746396745,11662449,14.3),(143656,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143656,35.36,0.8,118,69079,75,NULL,'CF, r','UGC 11373',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000147,NULL,'14.82',0.5,'Sb',NULL,NULL,NULL,NULL,1,282.866375,58.08278,0.229,NULL,53143824535,830372258,12974566,14.82),(143657,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143657,35.1,0.38,105,69079,75,NULL,'CF, r, raw','UGC 11373',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143658,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143658,35.29,0.38,114,69079,75,NULL,'CF, r, inv','UGC 11373',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143659,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143659,35.32,0.38,116,69079,75,NULL,'CF, r, cor','UGC 11373',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143660,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143660,35.58,0.4,131,69079,NULL,NULL,'mean','UGC 11373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143661,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143661,35.64,0.47,134,69079,NULL,NULL,'H','UGC 11373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143662,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143662,35.75,0.45,141,69079,NULL,NULL,'K','UGC 11373',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143663,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143663,33.37,0.69,47.2,69080,100,NULL,'mid-IR','UGC 11369',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000117,NULL,'14.1',0.6,'SBa:',NULL,NULL,NULL,NULL,1,282.9072917,23.63475,1.165,NULL,54593308426,853020444,13328444,14.1),(143664,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143664,34.65,0.37,85,69081,NULL,NULL,'Malmquist cor.','ESO 336- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.06',0.5,'Sb:',NULL,NULL,NULL,NULL,1,282.931166667,-40.93358,0.349,NULL,51049907586,797654806,12463356,14.06),(143665,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143665,34.66,0.37,85.4,69081,NULL,NULL,NULL,'ESO 336- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143666,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143666,34.7,0.2,87.1,69081,74.4,NULL,NULL,'ESO 336- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143667,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143667,34.24,0.54,70.5,69082,70,NULL,NULL,'2MASX J18514671-5234217',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,282.9447917,-52.57275,0.161,NULL,48902971534,764108930,11939202,14.7),(143668,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143668,33.41,0.43,48.1,69083,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11371',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00002,NULL,'14.3',0.6,'Sc;HSB','in a triple',NULL,NULL,NULL,1,282.9839583,26.48822,1.109,NULL,54426428054,850412938,13287702,14.3),(143669,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143669,33.43,0.49,48.5,69083,75,NULL,'IR','UGC 11371',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143670,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143670,33.43,0.47,48.5,69083,NULL,NULL,'H','UGC 11371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143671,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143671,33.45,0.43,49,69083,75,NULL,'3.6 micron, color corrected','UGC 11371',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143672,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143672,33.46,0.46,49.2,69083,NULL,NULL,'J','UGC 11371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143673,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143673,33.46,0.45,49.3,69083,NULL,NULL,'K','UGC 11371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143674,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143674,33.48,0.2,49.7,69083,74.4,NULL,NULL,'UGC 11371',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143675,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143675,33.56,0.4,51.6,69083,NULL,NULL,'mean','UGC 11371',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143676,'Ring Diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143676,34.1,0.84,66,69084,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6699',NULL,'1981ApJS...45..541P',1981,1,1.5,NULL,'G',0.000034,NULL,'12.64',1.5,'SAB(s)bc',NULL,NULL,NULL,NULL,1,283.0085,-57.32075,0.289,NULL,49122505250,767539144,11992799,12.64),(143677,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143677,33.79,0.48,57.2,69085,70,NULL,NULL,'ESO 281- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.1R',0.8,'SB(rl)0^0',NULL,NULL,NULL,NULL,1,283.069625,-47.00764,0.261,NULL,51030205005,797346953,12458546,13.1),(143678,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143678,30.49,0.8,12.6,69086,75,NULL,NULL,'NGC 6684A',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000007,NULL,'13.20',1.9,'IB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,283.095083,-64.83147,0.225,NULL,48981438423,765334975,11958358,13.2),(143679,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143679,35.59,0.48,131,69087,NULL,NULL,'Malmquist cor.','ESO 231- G 005',NULL,'2009ApJS..182..474S',2009,1,1.14,NULL,'G',0.000033,NULL,'16.33',0.13,'Sc',NULL,NULL,NULL,NULL,1,283.0989583,-48.35544,0.237,NULL,51031159737,797361870,12458779,16.33),(143680,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143680,35.66,NULL,136,69087,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 231- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143681,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143681,35.69,NULL,137,69087,NULL,NULL,'Dipole + Quadrupole','ESO 231- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143682,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143682,35.7,NULL,138,69087,NULL,NULL,'Dipole','ESO 231- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143683,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143683,35.71,NULL,139,69087,NULL,NULL,NULL,'ESO 231- G 005',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143684,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143684,35.79,0.44,144,69087,NULL,NULL,NULL,'ESO 231- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143685,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143685,35.83,0.2,147,69087,74.4,NULL,NULL,'ESO 231- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143686,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143686,34.53,0.49,80.4,69088,75,NULL,'IR','UGC 11377',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.0001,NULL,'15.65',0.16,'Scd',NULL,NULL,NULL,NULL,1,283.1002917,73.19203,0.337,NULL,52742184269,824096629,12876509,15.65),(143687,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143687,34.75,NULL,89.1,69088,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143688,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143688,34.76,NULL,89.5,69088,NULL,NULL,'Dipole + Quadrupole','UGC 11377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143689,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143689,34.76,NULL,89.6,69088,NULL,NULL,'Dipole','UGC 11377',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143690,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143690,34.82,NULL,92.1,69088,NULL,NULL,NULL,'UGC 11377',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143691,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143691,34.95,0.43,97.6,69088,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11377',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143692,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143692,33.83,0.8,58.4,69089,75,NULL,'MAT, I','ESO 231- G 006',NULL,'1997ApJS..109..333W',1997,1,1.55,'Marginal HIPASS detection.','G',0.000033,NULL,'15.66',0.19,'Scd',NULL,NULL,NULL,NULL,1,283.154875,-51.46781,0.237,NULL,48903862748,764122855,11939419,15.66),(143693,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143693,33.52,0.32,50.5,69089,85,NULL,'I, inv','ESO 231- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143694,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143694,33.52,0.32,50.6,69089,85,NULL,'I, raw','ESO 231- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143695,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143695,33.68,0.43,54.6,69089,75,NULL,'MAT, I, raw','ESO 231- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143696,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143696,33.72,0.43,55.6,69089,75,NULL,'MAT, I, inv','ESO 231- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143697,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143697,33.81,0.5,57.8,69089,NULL,NULL,NULL,'ESO 231- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143698,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143698,33.85,0.2,58.9,69089,74.4,NULL,NULL,'ESO 231- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143699,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143699,33.9,0.49,60.3,69089,75,NULL,'IR','ESO 231- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143700,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143700,33.94,NULL,61.4,69089,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 231- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143701,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143701,33.95,NULL,61.7,69089,NULL,NULL,'Dipole + Quadrupole','ESO 231- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143702,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143702,33.96,NULL,62,69089,NULL,NULL,'Dipole','ESO 231- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143703,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143703,33.97,0.43,62.4,69089,75,NULL,'MAT, I, cor','ESO 231- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143704,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143704,34.03,NULL,63.8,69089,NULL,NULL,NULL,'ESO 231- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143705,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143705,34.08,0.45,65.3,69089,NULL,NULL,'Malmquist cor.','ESO 231- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143706,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143706,33.81,0.4,57.8,69090,75,NULL,'Edat, raw','IC 4784',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00013,NULL,'13.71',1.1,'S0?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,283.200083333,-63.25961,0.221,NULL,48982183092,765346610,11958540,13.71),(143707,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143707,33.85,0.4,58.8,69090,75,NULL,'Edat, cor','IC 4784',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143708,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143708,34.67,0.25,85.9,69090,74.4,NULL,NULL,'IC 4784',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143709,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143709,34.08,0.4,65.6,69090,NULL,NULL,'mean','IC 4784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143710,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143710,34.73,0.45,88.3,69090,NULL,NULL,'K','IC 4784',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143711,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143711,34.42,0.48,76.6,69091,70,NULL,NULL,'2MASX J18525345-5420296',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.222666667,-54.34167,0.277,NULL,49080979112,766890298,11982660,14.8),(143712,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143712,35.51,0.64,126,69092,70,NULL,NULL,'2MASX J18525387-5250281',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.224375,-52.84114,0.145,NULL,48898542375,764039724,11938120,15.1),(143713,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143713,33.43,0.48,48.5,69093,70,NULL,NULL,'IC 4785',NULL,'2014MNRAS.445.2677S',2014,1,3.1,NULL,'G',0.000017,NULL,'13.09',1.4,'(R\'_2)SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,283.230125,-59.25542,0.301,NULL,49111776107,767371501,11990179,13.09),(143714,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143714,33.14,0.8,42.5,69093,75,NULL,'MAT, I','IC 4785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143715,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143715,33.02,0.43,40.2,69093,75,NULL,'MAT, I, raw','IC 4785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143716,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143716,33.11,0.47,41.9,69093,NULL,NULL,'H','IC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143717,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143717,33.2,0.32,43.7,69093,85,NULL,'I, raw','IC 4785',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143718,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143718,33.24,0.45,44.5,69093,NULL,NULL,'K','IC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143719,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143719,33.26,0.46,44.9,69093,NULL,NULL,'J','IC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143720,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143720,33.27,0.32,45.1,69093,85,NULL,'I, inv','IC 4785',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143721,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143721,33.29,0.43,45.6,69093,75,NULL,'MAT, I, inv','IC 4785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143722,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143722,33.39,0.43,47.7,69093,75,NULL,'MAT, I, cor','IC 4785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143723,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143723,33.44,0.4,48.7,69093,NULL,NULL,'mean','IC 4785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143724,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143724,33.51,0.2,50.4,69093,74.4,NULL,NULL,'IC 4785',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143725,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143725,35.07,0.49,103,69094,75,NULL,'IR','ESO 336- G 020',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.2b',0.2,'Sb:',NULL,NULL,NULL,NULL,1,283.3964583,-40.01803,0.349,NULL,51052829978,797700468,12464069,16.2),(143726,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143726,35.12,0.54,106,69094,NULL,NULL,'Malmquist cor.','ESO 336- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143727,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143727,35.44,0.47,123,69094,NULL,NULL,NULL,'ESO 336- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143728,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143728,35.48,0.2,125,69094,74.4,NULL,NULL,'ESO 336- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143729,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143729,36.73,0.89,221,69095,70,NULL,NULL,'2MASX J18534293-5249526',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.428875,-52.83131,0.145,NULL,48903065357,764110396,11939224,15.6),(143730,'BL Lac Luminosity','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143730,40.13,NULL,876,69096,NULL,NULL,NULL,'1RXS J185351.0+671356',0.212,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.4',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,283.467,67.23214,0.225,NULL,53561231859,836894247,13076472,16.4),(143731,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143731,34.59,0.49,82.8,69097,75,NULL,'IR','ESO 281- G 035',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'13.60',0.3,'S...',NULL,NULL,NULL,NULL,1,283.5454583,-42.93339,0.293,NULL,51055013170,797734580,12464602,13.6),(143732,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143732,34.64,0.38,84.8,69097,NULL,NULL,'Malmquist cor.','ESO 281- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143733,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143733,34.8,0.36,91.1,69097,NULL,NULL,NULL,'ESO 281- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143734,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143734,34.84,0.2,92.9,69097,74.4,NULL,NULL,'ESO 281- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143735,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143735,35.13,0.66,106,69098,70,NULL,NULL,'2MASX J18541146-4438450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.547667,-44.64592,0.265,NULL,51055912288,797748629,12464822,15.3),(143736,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143736,34.37,0.8,74.7,69099,75,NULL,'MAT, I','ESO 396- G 007',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'14',0.7,'Sc:            HII',NULL,NULL,NULL,NULL,1,283.592541667,-34.61119,0.325,NULL,47751481978,746116905,11658076,14),(143737,'Sosies','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143737,34.47,0.15,78.3,69099,NULL,NULL,NULL,'ESO 396- G 007',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143738,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143738,33.81,0.43,57.8,69099,75,NULL,'MAT, I, raw','ESO 396- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143739,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143739,33.92,0.32,60.8,69099,85,NULL,'I, raw','ESO 396- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143740,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143740,33.99,0.32,62.8,69099,85,NULL,'I, inv','ESO 396- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143741,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143741,34.02,0.2,63.7,69099,74.4,NULL,NULL,'ESO 396- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143742,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143742,34.04,0.43,64.2,69099,75,NULL,'3.6 micron, color corrected','ESO 396- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143743,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143743,34.1,0.43,66.2,69099,75,NULL,'MAT, I, inv','ESO 396- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143744,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143744,34.14,0.43,67.3,69099,75,NULL,'3.6 micron, color + selection bias corrected','ESO 396- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143745,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143745,34.21,0.43,69.5,69099,75,NULL,'MAT, I, cor','ESO 396- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143746,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143746,35.94,0.58,154,69100,70,NULL,NULL,'2MASX J18551285-4725315',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.803583333,-47.42544,0.229,NULL,51033016676,797390885,12459232,15.5),(143747,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143747,16.71,0.57,0.022,69101,NULL,NULL,'Carbon star S29, RA 289.7724, DEC -30.9072','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,1,450,'Likely associated with M54; not the same as Sagittarius Dwarf Irregular Galaxy.','G',NULL,NULL,'4.5',216,'dSph(t)',NULL,NULL,NULL,NULL,1,283.83125,-30.54528,0.557,0,47753037814,746141215,11658456,4.5),(143748,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143748,16.99,0.57,0.025,69101,NULL,NULL,'Carbon star S31, RA 292.2203, DEC -29.5899','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143749,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143749,17.39,0.57,0.03,69101,NULL,NULL,'Carbon star S28, RA 288.9922, DEC -30.5467','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143750,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143750,17.45,NULL,0.031,69101,NULL,NULL,'PL','Sagittarius Dwarf Spheroidal',NULL,'2009MNRAS.396..598L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143751,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143751,17.5,NULL,0.032,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2009MNRAS.396..598L',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143752,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143752,17.66,0.57,0.034,69101,NULL,NULL,'Carbon star S30, RA 290.9395, DEC -34.5209','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143753,'Carbon Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143753,17.9,0.57,0.038,69101,NULL,NULL,'Carbon star S32, RA 295.7120, DEC -33.5759','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.453.2653H',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143754,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143754,16.67,0.19,0.0216,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2002ApJ...573L..19M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143755,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143755,16.9,0.17,0.024,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995MNRAS.277..781I',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143756,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143756,16.95,NULL,0.0246,69101,NULL,NULL,'MESSIER 054, NGC 6715','Sagittarius Dwarf Spheroidal',NULL,'2000yCat..33300453M',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143757,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143757,16.99,NULL,0.025,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1994Natur.370..194I',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143758,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143758,17.05,0.05,0.0253,69101,NULL,NULL,'Terzan 7','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143759,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143759,17.09,0.17,0.0262,69101,NULL,NULL,'outer','Sagittarius Dwarf Spheroidal',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143760,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143760,17.1,NULL,0.0263,69101,NULL,NULL,'CMD at 12 Gyr','Sagittarius Dwarf Spheroidal',NULL,'1996ApJ...459L..65F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143761,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143761,17.1,NULL,0.0263,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2008MmSAI..79..692C',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143762,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143762,17.1,NULL,0.0263,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2006A&A...446L...1B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143763,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143763,17.11,0.14,0.0264,69101,NULL,NULL,'central','Sagittarius Dwarf Spheroidal',NULL,'2002MNRAS.332...91D',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143764,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143764,17.17,0.12,0.0272,69101,NULL,NULL,'NGC 5634, GC','Sagittarius Dwarf Spheroidal',NULL,'2002AJ....124..915B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143765,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143765,17.24,0.2,0.028,69101,NULL,NULL,'AM 4, AM 4, MW center, 8.0 kpc','Sagittarius Dwarf Spheroidal',NULL,'2009AJ....137.3809C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143766,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143766,17.26,0.05,0.0283,69101,NULL,NULL,'Terzan 8','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143767,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143767,17.27,NULL,0.0284,69101,NULL,NULL,'MESSIER 054, NGC 6715','Sagittarius Dwarf Spheroidal',NULL,'2007ApJ...667L..57S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143768,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143768,17.27,0.05,0.0284,69101,NULL,NULL,'MESSIER 054','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143769,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143769,17.3,NULL,0.0289,69101,NULL,NULL,'CMD at 10 Gyr','Sagittarius Dwarf Spheroidal',NULL,'1996ApJ...459L..65F',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143770,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143770,17.3,NULL,0.0289,69101,NULL,NULL,'SGR center, unweighted mean of 9 CMD','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143771,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143771,17.32,NULL,0.0291,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143772,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143772,17.32,NULL,0.0291,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143773,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143773,17.33,0.05,0.0292,69101,NULL,NULL,'SGR debris behind NGC 6624','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143774,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143774,17.34,0.14,0.0294,69101,NULL,NULL,'WHI B0200-03, Whiting 1','Sagittarius Dwarf Spheroidal',NULL,'2007A&A...466..181C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143775,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143775,17.34,0.05,0.0294,69101,NULL,NULL,'Arp 2','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143776,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143776,17.34,0.05,0.0294,69101,NULL,NULL,'SGR debris behind NGC 6809','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143777,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143777,17.35,0.05,0.0295,69101,NULL,NULL,'SGR debris behind NGC 6637','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143778,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143778,17.41,NULL,0.0304,69101,NULL,NULL,'SGR center, weighted mean of 9 CMD','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143779,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143779,17.42,0.05,0.0305,69101,NULL,NULL,'SGR debris behind NGC 6652','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143780,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143780,17.42,0.05,0.0305,69101,NULL,NULL,'SGR debris behind NGC 6681','Sagittarius Dwarf Spheroidal',NULL,'2011ApJ...743...20S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143781,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143781,17.48,0.1,0.0313,69101,NULL,NULL,'NIR, WHI B0200-03, Whiting 1','Sagittarius Dwarf Spheroidal',NULL,'2015MNRAS.446..730V',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143782,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143782,17.7,0.2,0.035,69101,NULL,NULL,'AM 4, AM 4, heliocentric','Sagittarius Dwarf Spheroidal',NULL,'2009AJ....137.3809C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143783,'CMD','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143783,18.4,NULL,0.045,69101,NULL,NULL,'WHI B0200-03, Whiting 1','Sagittarius Dwarf Spheroidal',NULL,'2005ApJ...621L..61C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143784,'Horizontal Branch','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143784,16.38,NULL,0.0189,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR)','Sagittarius Dwarf Spheroidal',NULL,'1996AJ....112.1487H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143785,'Horizontal Branch','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143785,16.95,NULL,0.025,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1998A&A...330..453M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143786,'Horizontal Branch','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143786,17,0.18,0.0251,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.2533D',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143787,'Horizontal Branch','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143787,17.25,0.2,0.028,69101,NULL,NULL,'D(helio)','Sagittarius Dwarf Spheroidal',NULL,'1999MNRAS.304..633B',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143788,'M Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143788,17.85,NULL,0.0372,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2010ApJ...722..750S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143789,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143789,16.71,0.1,0.022,69101,NULL,NULL,'30','Sagittarius Dwarf Spheroidal',NULL,'1997ApJ...474..217A',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143790,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143790,16.9,0.08,0.024,69101,NULL,NULL,'313 RRab','Sagittarius Dwarf Spheroidal',NULL,'1996ApJ...458L..17A',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143791,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143791,16.94,0.07,0.0243,69101,NULL,NULL,'150, MW center 8.0 kpc','Sagittarius Dwarf Spheroidal',NULL,'2009AAS...21332501K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143792,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143792,16.97,0.07,0.0248,69101,NULL,NULL,'203','Sagittarius Dwarf Spheroidal',NULL,'2009AJ....137.4478K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143793,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143793,16.97,0.78,0.0248,69101,NULL,NULL,'2','Sagittarius Dwarf Spheroidal',NULL,'1998AcA....48..341M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143794,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143794,17,NULL,0.025,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109..588M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143795,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143795,17,0.07,0.0251,69101,NULL,NULL,'Sgr Clump, Z(0.15[Fe/H]+1.01)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143796,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143796,17.02,0.08,0.0253,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR), Z(0.15[Fe/H]+1.01)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143797,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143797,17.02,0.19,0.0254,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995AJ....110.1141M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143798,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143798,17.06,0.08,0.0258,69101,NULL,NULL,'Sgr RHB, Z(0.15[Fe/H]+1.01)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143799,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143799,17.13,0.11,0.0267,69101,NULL,NULL,'MESSIER 054, NGC 6715, 154','Sagittarius Dwarf Spheroidal',NULL,'2010MNRAS.406..329S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143800,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143800,17.15,0.06,0.0269,69101,NULL,NULL,'Sgr Clump, Z(0.30[Fe/H]+0.94)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143801,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143801,17.16,0.08,0.027,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR), M(V)RR = +0.6 mag','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143802,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143802,17.18,0.18,0.0273,69101,NULL,NULL,'tidal tail','Sagittarius Dwarf Spheroidal',NULL,'1996ApJ...458L..13M',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143803,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143803,17.19,0.03,0.0274,69101,NULL,NULL,'MESSIER 054, NGC 6715, 63, D(helio)','Sagittarius Dwarf Spheroidal',NULL,'2000AJ....119.1760L',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143804,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143804,17.2,0.07,0.0276,69101,NULL,NULL,'Sgr Clump, Z(0.17[Fe/H]+0.82)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143805,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143805,17.22,NULL,0.0278,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143806,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143806,17.22,NULL,0.0278,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143807,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143807,17.24,0.07,0.028,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR), Z(0.17[Fe/H]+0.82)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143808,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143808,17.27,0.08,0.0285,69101,NULL,NULL,'Sgr RHB, M(V)RR = +0.6 mag','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143809,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143809,17.27,0.08,0.0285,69101,NULL,NULL,'Sgr RHB, Z(0.17[Fe/H]+0.82)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143810,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143810,17.33,0.08,0.0292,69101,NULL,NULL,'Sgr RHB, Z(0.30[Fe/H]+0.94)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143811,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143811,17.33,0.07,0.0293,69101,NULL,NULL,'Sgr Clump, M(V)RR = +0.6 mag','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143812,'RR Lyrae','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143812,17.35,0.08,0.0295,69101,NULL,NULL,'MESSIER 054, NGC 6715, D(GSR), Z(0.30[Fe/H]+0.94)','Sagittarius Dwarf Spheroidal',NULL,'1995AJ....109.1086S',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143813,'SX Phe Stars','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143813,17.23,NULL,0.0279,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2011AJ....142..110M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143814,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143814,16.5,NULL,0.02,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143815,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143815,16.93,0.19,0.0243,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2013MNRAS.436..413M',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143816,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143816,17.1,0.15,0.0263,69101,NULL,NULL,'D(helio)','Sagittarius Dwarf Spheroidal',NULL,'2004MNRAS.353..874M',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143817,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143817,25.24,0.17,1.12,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143818,'Eclipsing Binary','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143818,16.6,0.3,0.0209,69101,NULL,NULL,NULL,'Sagittarius Dwarf Spheroidal',NULL,'1995AJ....110.1141M',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143819,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143819,32.5,0.8,31.7,69102,75,NULL,'MAT, I','NGC 6707',NULL,'1997ApJS..109..333W',1997,1,2.1,'Confused HIPASS source','G',0.000021,NULL,'13.31',0.9,'SB(s)c?','in a pair',NULL,NULL,NULL,1,283.841917,-53.81844,0.297,NULL,48898874283,764044910,11938201,13.31),(143820,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143820,32.76,0.8,35.7,69102,75,NULL,NULL,'NGC 6707',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143821,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143821,32.25,0.32,28.2,69102,85,NULL,'I, raw','NGC 6707',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143822,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143822,32.28,0.32,28.6,69102,85,NULL,'I, inv','NGC 6707',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143823,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143823,32.37,0.43,29.7,69102,75,NULL,'MAT, I, raw','NGC 6707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143824,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143824,32.53,0.43,32,69102,75,NULL,'MAT, I, inv','NGC 6707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143825,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143825,32.58,0.46,32.9,69102,NULL,NULL,'J','NGC 6707',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143826,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143826,32.65,0.47,33.8,69102,NULL,NULL,'H','NGC 6707',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143827,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143827,32.65,0.4,33.8,69102,NULL,NULL,'mean','NGC 6707',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143828,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143828,32.67,0.45,34.2,69102,NULL,NULL,'K','NGC 6707',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143829,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143829,32.75,0.43,35.5,69102,75,NULL,'MAT, I, cor','NGC 6707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143830,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143830,32.76,0.8,35.7,69103,75,NULL,NULL,'NGC 6708',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000043,NULL,'12.7',0.9,'Sb:            HII','in a pair',NULL,NULL,NULL,1,283.8985,-53.72344,0.229,NULL,48898889146,764045142,11938205,12.7),(143831,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143831,34.45,0.49,77.5,69104,75,NULL,'IR','ESO 396- G 008',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'13.27',0.3,'Sb:',NULL,NULL,NULL,NULL,1,283.9065,-34.72314,0.309,NULL,47748668690,746072948,11657389,13.27),(143832,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143832,34.63,0.34,84.5,69104,NULL,NULL,'Malmquist cor.','ESO 396- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143833,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143833,34.7,0.33,87,69104,NULL,NULL,NULL,'ESO 396- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143834,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143834,34.74,0.2,88.7,69104,74.4,NULL,NULL,'ESO 396- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143835,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143835,29.76,0.1,8.95,69105,74.4,NULL,NULL,'ESO 104- G 022',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000007,NULL,'15.56',1,'IB(s)m',NULL,NULL,NULL,NULL,1,283.921833,-64.81089,0.213,NULL,48981569444,765337022,11958390,15.56),(143836,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143836,29.93,0.8,9.7,69105,75,NULL,NULL,'ESO 104- G 022',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143837,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143837,29.13,NULL,6.7,69105,NULL,NULL,NULL,'ESO 104- G 022',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143838,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143838,34.86,0.48,93.6,69106,70,NULL,NULL,'2MASX J18554307-4646507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'13.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,283.9295,-46.78069,0.225,NULL,51032315610,797379931,12459061,13.4),(143839,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143839,33.64,0.8,53.4,69107,75,NULL,'MAT, I','IC 4789',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.99',0.7,'SA(s)c:',NULL,NULL,NULL,NULL,1,284.077041667,-68.56711,0.213,NULL,49204352186,768818002,12012781,13.99),(143840,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143840,32.97,0.32,39.2,69107,85,NULL,'I, raw','IC 4789',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143841,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143841,32.97,0.32,39.3,69107,85,NULL,'I, inv','IC 4789',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143842,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143842,33.16,0.43,42.8,69107,75,NULL,'MAT, I, raw','IC 4789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143843,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143843,33.22,0.43,44,69107,75,NULL,'MAT, I, inv','IC 4789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143844,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143844,33.5,0.43,50,69107,75,NULL,'MAT, I, cor','IC 4789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143845,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143845,33.85,0.09,59,69107,NULL,NULL,NULL,'IC 4789',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143846,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143846,34.05,0.46,64.4,69108,70,NULL,NULL,'ESO 337- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000117,NULL,'13.5',1.2,'Sa',NULL,NULL,NULL,NULL,1,284.082583,-40.97753,0.321,NULL,51047305227,797614144,12462721,13.5),(143847,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143847,33.88,0.8,59.8,69109,75,NULL,'MAT, I','ESO 281- G 038',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000027,NULL,'12.39',0.3,'SAa:',NULL,NULL,NULL,NULL,1,284.087375,-43.14686,0.273,NULL,51054895180,797732737,12464574,12.39),(143848,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143848,33.7,0.43,54.9,69109,75,NULL,'3.6 micron, color + selection bias corrected','ESO 281- G 038',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143849,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143849,33.84,0.43,58.6,69109,75,NULL,'3.6 micron, color corrected','ESO 281- G 038',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143850,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143850,33.93,0.45,61.2,69109,NULL,NULL,'K','ESO 281- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143851,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143851,33.94,0.47,61.5,69109,NULL,NULL,'H','ESO 281- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143852,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143852,33.96,0.32,62,69109,85,NULL,'I, raw','ESO 281- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143853,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143853,33.97,0.43,62.1,69109,75,NULL,'MAT, I, raw','ESO 281- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143854,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143854,34.02,0.32,63.7,69109,85,NULL,'I, inv','ESO 281- G 038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143855,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143855,34.03,0.4,64.1,69109,NULL,NULL,'mean','ESO 281- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143856,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143856,34.04,0.2,64.3,69109,74.4,NULL,NULL,'ESO 281- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143857,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143857,34.14,0.31,67.2,69109,NULL,NULL,NULL,'ESO 281- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143858,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143858,34.17,0.46,68.1,69109,NULL,NULL,'J','ESO 281- G 038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143859,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143859,34.21,0.43,69.6,69109,75,NULL,'MAT, I, inv','ESO 281- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143860,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143860,34.26,0.43,71.1,69109,75,NULL,'MAT, I, cor','ESO 281- G 038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143861,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143861,34.4,0.28,75.7,69109,NULL,NULL,'Malmquist cor.','ESO 281- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143862,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143862,32.76,0.8,35.7,69110,75,NULL,NULL,'IC 4796',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000057,NULL,'13.23',0.9,'SB(s)0^0^:','in a pair',NULL,NULL,NULL,1,284.116,-54.21394,0.285,NULL,49080019329,766875302,11982426,13.23),(143863,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143863,32.24,0.2,28.1,69111,NULL,NULL,'I','IC 4797',NULL,'2001ApJ...546..681T',2001,1,3,NULL,'G',0.000067,NULL,'12.30',1.3,'E+ pec:','in a pair',NULL,NULL,NULL,1,284.123667,-54.30578,0.285,NULL,49080013772,766875215,11982425,12.3),(143864,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143864,32.24,0.2,28.1,69111,NULL,NULL,NULL,'IC 4797',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143865,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143865,32.26,0.14,28.3,69111,74.4,NULL,NULL,'IC 4797',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143866,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143866,32.35,0.2,29.6,69111,NULL,NULL,'Malmquist cor.','IC 4797',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143867,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143867,31.66,0.4,21.4,69111,75,NULL,'Edat, raw','IC 4797',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143868,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143868,32.05,0.4,25.8,69111,75,NULL,'Edat, cor','IC 4797',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143869,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143869,30.14,0.63,10.7,69111,95,NULL,'Michard 1979b, c','IC 4797',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143870,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143870,31.1,0.46,16.6,69111,95,NULL,'Michard 1979a','IC 4797',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (143871,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143871,31.21,0.37,17.5,69111,95,NULL,'Weighted Mean','IC 4797',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143872,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143872,34.22,0.81,69.8,69111,55,NULL,'Visvanathan & Sandage 1979','IC 4797',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143873,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143873,32.61,0.41,33.3,69111,NULL,NULL,NULL,'IC 4797',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143874,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143874,33.01,0.41,40,69111,NULL,NULL,'Malmquist cor.','IC 4797',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143875,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143875,32.76,0.8,35.7,69111,75,NULL,'B','IC 4797',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143876,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143876,32.12,0.45,26.6,69111,NULL,NULL,'K','IC 4797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143877,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143877,32.71,0.4,34.8,69111,NULL,NULL,'mean','IC 4797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143878,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143878,33.71,0.8,55.3,69112,75,NULL,'HMCL, I','IC 4790',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000053,NULL,'13.94',0.7,'(R\')SAB(rs)bc',NULL,NULL,NULL,NULL,1,284.134208333,-64.92892,0.213,NULL,48981537935,765336530,11958383,13.94),(143879,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143879,33.36,0.47,47,69112,NULL,NULL,'H','IC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143880,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143880,33.39,0.45,47.7,69112,NULL,NULL,'K','IC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143881,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143881,33.44,0.46,48.8,69112,NULL,NULL,'J','IC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143882,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143882,33.59,0.4,52.1,69112,75,NULL,'HMCL, I, raw','IC 4790',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143883,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143883,33.76,0.4,56.5,69112,75,NULL,'HMCL, I, inv','IC 4790',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143884,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143884,33.78,0.4,56.9,69112,75,NULL,'HMCL, I, cor','IC 4790',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143885,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143885,33.85,0.4,58.8,69112,NULL,NULL,'mean','IC 4790',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143886,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143886,35.61,0.69,133,69113,70,NULL,NULL,'2MASX J18565078-6143382',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,284.211583,-61.72733,0.261,NULL,48947216325,764800255,11950003,13.8),(143887,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143887,33.37,0.45,47.1,69114,NULL,NULL,'K','NGC 6706',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00007,NULL,'13.85',0.7,'S0-: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.212667,-63.16622,0.221,NULL,48951754176,764871159,11951111,13.85),(143888,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143888,33.54,0.4,51,69114,NULL,NULL,'mean','NGC 6706',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143889,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143889,32.19,0.43,27.4,69115,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11380',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.00006,NULL,'13.7',0.6,'Sab',NULL,NULL,NULL,NULL,1,284.212667,36.62397,0.401,NULL,54778309228,855911081,13373610,13.7),(143890,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143890,32.97,0.47,39.2,69115,NULL,NULL,'H','UGC 11380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143891,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143891,32.97,0.46,39.2,69115,NULL,NULL,'J','UGC 11380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143892,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143892,32.99,0.45,39.6,69115,NULL,NULL,'K','UGC 11380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143893,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143893,32.99,0.4,39.7,69115,NULL,NULL,'mean','UGC 11380',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143894,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143894,33.92,0.4,60.8,69116,NULL,NULL,'mean','IC 4793',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.55',0.6,'Sb',NULL,NULL,NULL,NULL,1,284.231667,-61.39978,0.253,NULL,48943661791,764744715,11949136,14.55),(143895,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143895,34.03,0.08,64.1,69116,NULL,NULL,NULL,'IC 4793',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143896,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143896,34.29,0.47,72.2,69116,NULL,NULL,'H','IC 4793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143897,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143897,34.31,0.46,72.8,69116,NULL,NULL,'J','IC 4793',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143898,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143898,32.8,0.54,36.3,69117,NULL,NULL,NULL,'ESO 183- G 030',NULL,'2001MNRAS.327.1004B',2001,1,1.9,NULL,'G',0.000107,NULL,'12.65',1.4,'SA0- pec?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.233083333,-54.54544,0.293,NULL,49081639427,766900616,11982822,12.65),(143899,'SBF','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143899,33.42,0.54,48.4,69117,NULL,NULL,'Malmquist cor.','ESO 183- G 030',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143900,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143900,31.66,0.4,21.4,69117,75,NULL,'Edat, raw','ESO 183- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143901,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143901,32.05,0.4,25.8,69117,75,NULL,'Edat, cor','ESO 183- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143902,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143902,31.95,0.41,24.6,69117,NULL,NULL,NULL,'ESO 183- G 030',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143903,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143903,32.42,0.41,30.4,69117,NULL,NULL,'Malmquist cor.','ESO 183- G 030',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143904,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143904,32.76,0.8,35.7,69117,75,NULL,'B','ESO 183- G 030',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143905,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143905,37.01,0.84,252,69118,70,NULL,NULL,'2MASX J18570281-4742569',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.26175,-47.71581,0.205,NULL,51032557180,797383705,12459120,15.4),(143906,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143906,34.02,0.09,63.8,69119,NULL,NULL,NULL,'IC 4795',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.76',0.2,'S...',NULL,NULL,NULL,NULL,1,284.318166667,-61.60908,0.261,NULL,48947172680,764799573,11949993,15.76),(143907,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143907,32.93,0.8,38.5,69120,75,NULL,'MAT, I','ESO 281- G 040',NULL,'1997ApJS..109..333W',1997,1,1.81,NULL,'G',0.000038,NULL,'15.35',0.22,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.326667,-47.05861,0.225,NULL,51032967410,797390115,12459220,15.35),(143908,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143908,32.75,NULL,35.4,69120,NULL,NULL,'Dipole + Quadrupole','ESO 281- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143909,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143909,32.75,NULL,35.4,69120,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 281- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143910,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143910,32.76,NULL,35.7,69120,NULL,NULL,'Dipole','ESO 281- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143911,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143911,32.84,NULL,37,69120,NULL,NULL,NULL,'ESO 281- G 040',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143912,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143912,33.61,0.32,52.7,69120,85,NULL,'I, inv','ESO 281- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143913,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143913,33.65,0.32,53.6,69120,85,NULL,'I, raw','ESO 281- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143914,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143914,33.85,0.43,58.9,69120,75,NULL,'MAT, I, inv','ESO 281- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143915,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143915,33.92,0.43,60.9,69120,75,NULL,'MAT, I, raw','ESO 281- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143916,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143916,34.2,0.43,69.1,69120,75,NULL,'MAT, I, cor','ESO 281- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143917,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143917,34.01,0.8,63.5,69121,75,NULL,'MAT, I','ESO 231- G 011',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'14.06',0.5,'SAB:(r:)c',NULL,NULL,NULL,NULL,1,284.417333,-47.55072,0.205,NULL,51033111146,797392361,12459255,14.06),(143918,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143918,33.67,0.32,54.3,69121,85,NULL,'I, raw','ESO 231- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143919,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143919,33.68,0.43,54.4,69121,75,NULL,'MAT, I, raw','ESO 231- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143920,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143920,33.72,0.32,55.5,69121,85,NULL,'I, inv','ESO 231- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143921,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143921,33.81,0.47,57.7,69121,NULL,NULL,'H','ESO 231- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143922,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143922,33.9,0.43,60.2,69121,75,NULL,'MAT, I, inv','ESO 231- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143923,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143923,33.94,0.46,61.4,69121,NULL,NULL,'J','ESO 231- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143924,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143924,33.98,0.45,62.4,69121,NULL,NULL,'K','ESO 231- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143925,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143925,34.05,0.43,64.4,69121,75,NULL,'MAT, I, cor','ESO 231- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143926,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143926,34.09,0.4,65.7,69121,NULL,NULL,'mean','ESO 231- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143927,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143927,34.27,0.28,71.4,69121,NULL,NULL,NULL,'ESO 231- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143928,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143928,34.31,0.2,72.8,69121,74.4,NULL,NULL,'ESO 231- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143929,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143929,34.32,0.27,73.1,69121,NULL,NULL,'Malmquist cor.','ESO 231- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143930,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143930,34.01,NULL,63.4,69122,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2231',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',NULL,NULL,'16.42',0.11,'Sc',NULL,NULL,NULL,NULL,1,284.5044583,42.22364,0.373,NULL,54783529987,855992656,13374885,16.42),(143931,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143931,34.03,NULL,64,69122,NULL,NULL,'Dipole + Quadrupole','FGC 2231',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143932,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143932,34.03,NULL,64.1,69122,NULL,NULL,'Dipole','FGC 2231',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143933,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143933,34.09,NULL,65.7,69122,NULL,NULL,NULL,'FGC 2231',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143934,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143934,34.83,0.43,92.6,69122,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2231',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143935,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143935,36.73,0.63,222,69123,70,NULL,NULL,'2MASX J18581743-4816427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.572833,-48.27856,0.209,NULL,51035981111,797437204,12459956,15.9),(143936,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143936,34.5,0.29,79.5,69124,NULL,NULL,NULL,'ESO 396- G 009',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16',0.6,'Sb:',NULL,NULL,NULL,NULL,1,284.575041667,-35.22378,0.285,NULL,47747990154,746062346,11657224,16),(143937,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143937,34.54,0.2,80.9,69124,74.4,NULL,NULL,'ESO 396- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143938,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143938,34.54,0.28,81,69124,NULL,NULL,'Malmquist cor.','ESO 396- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143939,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143939,33.36,0.45,46.9,69125,NULL,NULL,'K','IC 4798',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000077,NULL,'13.17',1.2,'SA(s)0^0^: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.5870417,-62.11842,0.257,NULL,48945172323,764768317,11949504,13.17),(143940,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143940,33.98,0.4,62.6,69125,NULL,NULL,'mean','IC 4798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143941,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143941,36.24,0.55,177,69126,70,NULL,NULL,'2MASX J18583339-4811215',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.639083333,-48.18931,0.209,NULL,51035929201,797436393,12459943,13.9),(143942,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143942,33.82,0.8,58.1,69127,75,NULL,'HMCL, I','IC 4799',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000053,NULL,'13.99',1.1,'SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.7357917,-63.93097,0.213,NULL,48950625088,764853517,11950836,13.99),(143943,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143943,30.7,0.4,13.8,69127,75,NULL,'HMCL, I, inv','IC 4799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143944,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143944,30.76,0.4,14.2,69127,75,NULL,'HMCL, I, raw','IC 4799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143945,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143945,31.02,0.4,16,69127,75,NULL,'HMCL, I, cor','IC 4799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143946,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143946,32.77,0.47,35.9,69127,NULL,NULL,'H','IC 4799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143947,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143947,33.2,0.45,43.7,69127,NULL,NULL,'K','IC 4799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143948,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143948,33.25,0.46,44.6,69127,NULL,NULL,'J','IC 4799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143949,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143949,33.92,0.4,60.9,69127,NULL,NULL,'mean','IC 4799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143950,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143950,34.3,0.43,72.6,69128,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J18591639+1919573',NULL,'2014MNRAS.444..527S',2014,1,0.89,NULL,'G',0.00004,NULL,'10.3K',0.33,'Spiral',NULL,NULL,NULL,NULL,1,284.818333333,19.33256,NULL,NULL,54740547199,855321049,13364391,10.3),(143951,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143951,35.24,0.56,112,69129,70,NULL,NULL,'ESO 183- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.43,'Star superposed.','G',0.00011,NULL,'15.83',0.17,'Sbc',NULL,NULL,NULL,NULL,1,284.84825,-52.71319,0.161,NULL,48903418641,764115916,11939311,15.83),(143952,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143952,33.15,0.43,42.6,69130,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11385',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000017,NULL,'16.0',0.8,'Sdm:',NULL,NULL,NULL,NULL,1,284.901917,19.42742,NULL,NULL,54743389724,855365464,13365085,16),(143953,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143953,33.17,0.25,43.1,69131,74.4,NULL,NULL,'IC 4801',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00004,NULL,'13.60',1,'(R)SAB(rl)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,284.9099583,-64.67514,0.213,NULL,48948086793,764813856,11950216,13.6),(143954,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143954,33.47,0.45,49.4,69131,NULL,NULL,'K','IC 4801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143955,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143955,33.97,0.4,62.2,69131,NULL,NULL,'mean','IC 4801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143956,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143956,34.37,0.8,74.8,69132,75,NULL,'MAT, I','ESO 337- G 006',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15',0.7,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,284.91325,-41.76281,0.329,NULL,51048806456,797637600,12463087,15),(143957,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143957,33.55,0.43,51.2,69132,75,NULL,'MAT, I, raw','ESO 337- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143958,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143958,33.58,0.32,51.9,69132,85,NULL,'I, raw','ESO 337- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143959,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143959,33.62,0.32,53,69132,85,NULL,'I, inv','ESO 337- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143960,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143960,33.75,0.43,56.3,69132,75,NULL,'MAT, I, inv','ESO 337- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143961,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143961,34.04,0.43,64.3,69132,75,NULL,'MAT, I, cor','ESO 337- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143962,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143962,34.25,0.29,70.8,69132,NULL,NULL,NULL,'ESO 337- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143963,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143963,34.29,0.2,72.1,69132,74.4,NULL,NULL,'ESO 337- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143964,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143964,34.3,0.47,72.4,69132,NULL,NULL,'H','ESO 337- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143965,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143965,34.42,0.27,76.5,69132,NULL,NULL,'Malmquist cor.','ESO 337- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143966,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143966,34.43,0.46,77.1,69132,NULL,NULL,'J','ESO 337- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143967,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143967,34.45,0.45,77.5,69132,NULL,NULL,'K','ESO 337- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143968,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143968,34.52,0.4,80,69132,NULL,NULL,'mean','ESO 337- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143969,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143969,37.26,0.72,283,69133,70,NULL,NULL,'2MASX J18594226-4820236',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.926167,-48.33989,0.249,NULL,51035970389,797437037,12459953,15.5),(143970,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143970,33.61,0.49,52.8,69134,75,NULL,'IR','2MFGC 14677',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',NULL,NULL,'13.51',0.3,'LSB',NULL,NULL,NULL,NULL,1,284.946583,18.83039,NULL,NULL,54740511829,855320497,13364382,13.51),(143971,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143971,34.23,0.36,70.3,69134,70,NULL,'H, 2MASS','2MFGC 14677',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143972,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143972,34.5,0.36,79.6,69134,70,NULL,'H, UH88/IRSF/2MASS','2MFGC 14677',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143973,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143973,36.23,0.52,176,69135,70,NULL,NULL,'2MASX J18595845-4907003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,284.993583,-49.11678,0.265,NULL,51033956702,797405573,12459462,14.7),(143974,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143974,36.31,0.53,183,69136,70,NULL,NULL,'2MASX J19000094-4838313',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,285.0039583,-48.64197,0.289,NULL,51035895148,797435861,12459935,13.8),(143975,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143975,36.24,0.6,177,69137,70,NULL,NULL,'2MASX J19000444-4752264',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,285.018417,-47.87397,0.229,NULL,51036029803,797437965,12459968,15.3),(143976,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143976,36.2,0.8,174,69138,70,NULL,NULL,'2MASX J19001327-5725236',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'16.3b',0.4,NULL,NULL,NULL,NULL,NULL,1,285.0552083,-57.42319,0.257,NULL,49123508511,767554820,11993044,16.3),(143977,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143977,36.33,0.54,184,69139,70,NULL,NULL,'2MASX J19003547-4858263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,285.14775,-48.97406,0.373,NULL,51033802960,797403171,12459424,15.1),(143978,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143978,33.02,0.43,40.1,69140,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6750',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000113,NULL,'13.7',0.6,'Sc',NULL,NULL,NULL,NULL,1,285.1504583,59.16675,0.237,NULL,53144321488,830380023,12974687,13.7),(143979,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143979,33.6,0.4,52.5,69140,NULL,NULL,'mean','NGC 6750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143980,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143980,33.74,0.47,55.9,69140,NULL,NULL,'H','NGC 6750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143981,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143981,33.79,0.45,57.4,69140,NULL,NULL,'K','NGC 6750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143982,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143982,33.81,0.46,57.9,69140,NULL,NULL,'J','NGC 6750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143983,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143983,37.19,0.55,274,69141,70,NULL,NULL,'2MASX J19004847-4905034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,285.202083,-49.08425,0.265,NULL,51033945066,797405391,12459459,15.6),(143984,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143984,33.81,0.4,57.8,69142,75,NULL,'Edat, raw','NGC 6721',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000083,NULL,'13.06',1.4,'E+:','Isolated elliptical galaxy',NULL,NULL,NULL,1,285.211708333,-57.75944,0.257,NULL,49123462493,767554101,11993032,13.06),(143985,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143985,33.85,0.4,58.8,69142,75,NULL,'Edat, cor','NGC 6721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143986,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143986,32.68,0.37,34.4,69142,95,NULL,'Weighted Mean','NGC 6721',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143987,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143987,33.07,0.46,41.1,69142,95,NULL,'Michard 1979a','NGC 6721',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143988,'Faber-Jackson','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143988,34.3,0.81,72.4,69142,55,NULL,'Visvanathan & Sandage 1979','NGC 6721',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143989,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143989,33.82,0.47,58.2,69142,70,NULL,NULL,'NGC 6721',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143990,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',143990,33.3,0.49,45.7,69143,75,NULL,'IR','ESO 183- G 035',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.97',0.2,'S...',NULL,NULL,NULL,NULL,1,285.2520417,-53.9695,0.305,NULL,49079819241,766872175,11982377,15.97),(143991,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143991,33.85,0.47,58.8,69143,NULL,NULL,'H','ESO 183- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143992,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143992,33.94,0.45,61.4,69143,NULL,NULL,'K','ESO 183- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143993,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143993,33.97,0.4,62.3,69143,NULL,NULL,'mean','ESO 183- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143994,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143994,34.14,0.46,67.3,69143,NULL,NULL,'J','ESO 183- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143995,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143995,33.99,0.8,62.7,69144,75,NULL,'MAT, I','IC 4808',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000024,NULL,'12.92',0.8,'SA(s)c',NULL,NULL,NULL,NULL,1,285.28175,-45.31372,0.209,NULL,51025343337,797270989,12457359,12.92),(143996,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143996,33.23,0.43,44.3,69144,75,NULL,'MAT, I, raw','IC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143997,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143997,33.24,0.32,44.5,69144,85,NULL,'I, raw','IC 4808',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143998,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143998,33.29,0.32,45.6,69144,85,NULL,'I, inv','IC 4808',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(143999,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,143999,33.38,0.47,47.5,69144,NULL,NULL,'H','IC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144000,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144000,33.39,0.45,47.6,69144,NULL,NULL,'K','IC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144001,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144001,33.39,0.46,47.6,69144,NULL,NULL,'J','IC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144002,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144002,33.48,0.43,49.5,69144,75,NULL,'MAT, I, inv','IC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144003,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144003,33.73,0.43,55.6,69144,75,NULL,'MAT, I, cor','IC 4808',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144004,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144004,33.77,0.63,56.8,69144,NULL,NULL,NULL,'IC 4808',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144005,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144005,33.81,0.2,57.8,69144,74.4,NULL,NULL,'IC 4808',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144006,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144006,33.98,0.57,62.6,69144,NULL,NULL,'Malmquist cor.','IC 4808',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144007,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144007,34.1,0.4,66,69144,NULL,NULL,'mean','IC 4808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144008,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144008,37.79,0.69,362,69145,70,NULL,NULL,'2MASX J19012720-2931591',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.5R',0.1,NULL,NULL,NULL,NULL,NULL,1,285.36325,-29.53317,0.557,NULL,47631000781,744234387,11628662,15.5),(144009,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144009,33.64,0.8,53.4,69146,75,NULL,'MAT, I','IC 4806',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00012,NULL,'13.06',0.6,'(R\'_2)SAB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,285.377875,-57.53206,0.257,NULL,49123676744,767557449,11993085,13.06),(144010,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144010,33.47,0.43,49.5,69146,75,NULL,'MAT, I, raw','IC 4806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144011,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144011,33.66,0.32,54,69146,85,NULL,'I, raw','IC 4806',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144012,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144012,33.67,0.46,54.1,69146,NULL,NULL,'J','IC 4806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144013,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144013,33.67,0.47,54.2,69146,NULL,NULL,'H','IC 4806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144014,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144014,33.71,0.43,55.2,69146,75,NULL,'MAT, I, cor','IC 4806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144015,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144015,33.74,0.32,55.9,69146,85,NULL,'I, inv','IC 4806',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144016,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144016,33.75,0.45,56.2,69146,NULL,NULL,'K','IC 4806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144017,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144017,33.78,0.43,57.1,69146,75,NULL,'MAT, I, inv','IC 4806',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144018,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144018,33.85,0.4,58.8,69146,NULL,NULL,'mean','IC 4806',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144019,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144019,34.05,0.49,64.6,69146,75,NULL,'IR','IC 4806',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144020,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144020,34.2,0.09,69.3,69146,NULL,NULL,NULL,'IC 4806',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144021,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144021,36.07,0.8,163,69147,70,NULL,NULL,'2MASX J19020695-4914522',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,285.528916667,-49.24778,0.397,NULL,51033494606,797398353,12459349,15.8),(144022,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144022,35.04,0.55,102,69148,70,NULL,NULL,'FAIRALL 0504',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'1983MNRAS.203...47F has V = 14900? +- 100 km/s.','G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,285.616625,-53.19281,0.237,NULL,48890955349,763921177,11936268,13.7),(144023,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144023,32.84,0.8,37,69149,75,NULL,'MAT, I','IC 4810',NULL,'1997ApJS..109..333W',1997,1,4.59,NULL,'G',0.000017,NULL,'13.14',0.57,'SAB(s)d? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,285.7487917,-56.15972,0.257,NULL,49109248200,767332003,11989562,13.14),(144024,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144024,32.32,NULL,29.1,69149,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4810',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144025,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144025,32.32,NULL,29.2,69149,NULL,NULL,'Dipole + Quadrupole','IC 4810',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144026,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144026,32.33,NULL,29.2,69149,NULL,NULL,'Dipole','IC 4810',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144027,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144027,32.45,NULL,30.9,69149,NULL,NULL,NULL,'IC 4810',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144028,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144028,32.47,0.49,31.2,69149,75,NULL,'IR','IC 4810',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144029,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144029,32.6,0.32,33.1,69149,85,NULL,'I, raw','IC 4810',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144030,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144030,32.62,0.32,33.4,69149,85,NULL,'I, inv','IC 4810',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144031,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144031,32.62,0.2,33.4,69149,74.4,NULL,NULL,'IC 4810',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144032,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144032,32.66,0.43,34.1,69149,75,NULL,'MAT, I, raw','IC 4810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144033,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144033,32.69,0.43,34.5,69149,75,NULL,'3.6 micron, color corrected','IC 4810',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144034,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144034,32.73,0.43,35.1,69149,75,NULL,'3.6 micron, color + selection bias corrected','IC 4810',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144035,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144035,32.79,0.43,36.1,69149,75,NULL,'MAT, I, inv','IC 4810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144036,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144036,33.06,0.43,41,69149,75,NULL,'MAT, I, cor','IC 4810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144037,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144037,33.15,0.4,42.7,69149,NULL,NULL,'mean','IC 4810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144038,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144038,33.21,0.47,43.9,69149,NULL,NULL,'H','IC 4810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144039,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144039,33.3,0.46,45.7,69149,NULL,NULL,'J','IC 4810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144040,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144040,33.5,0.45,50.1,69149,NULL,NULL,'K','IC 4810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144041,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144041,37.95,0.67,390,69150,70,NULL,NULL,'2MASX J19030433-4910234',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,285.768125,-49.17319,0.397,NULL,51033515078,797398673,12459354,15),(144042,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144042,33.33,0.8,46.4,69151,75,NULL,'MAT, I','NGC 6719',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000025,NULL,'13.47',0.8,'SAB:(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,285.781208333,-68.58836,0.197,NULL,49201500761,768773449,12012085,13.47),(144043,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144043,32.7,0.32,34.7,69151,85,NULL,'I, raw','NGC 6719',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144044,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144044,32.72,0.32,35,69151,85,NULL,'I, inv','NGC 6719',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144045,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144045,32.91,0.43,38.1,69151,75,NULL,'MAT, I, raw','NGC 6719',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144046,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144046,33.03,0.43,40.3,69151,75,NULL,'MAT, I, inv','NGC 6719',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144047,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144047,33.28,0.43,45.3,69151,75,NULL,'MAT, I, cor','NGC 6719',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144048,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144048,33.55,0.4,51.2,69151,NULL,NULL,'mean','NGC 6719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144049,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144049,33.67,0.09,54.3,69151,NULL,NULL,NULL,'NGC 6719',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144050,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144050,33.72,0.46,55.4,69151,NULL,NULL,'J','NGC 6719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144051,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144051,33.76,0.45,56.5,69151,NULL,NULL,'K','NGC 6719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144052,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144052,33.77,0.47,56.7,69151,NULL,NULL,'H','NGC 6719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144053,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144053,33.18,0.8,43.2,69152,75,NULL,'MAT, I','ESO 184- G 003',NULL,'1997ApJS..109..333W',1997,1,1.3,'Marginal HIPASS detection.','G',0.000033,NULL,'15.74',0.4,'SB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,285.81175,-53.44147,0.237,NULL,49074410637,766787666,11981057,15.74),(144054,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144054,33.05,0.32,40.8,69152,85,NULL,'I, inv','ESO 184- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144055,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144055,33.08,0.32,41.3,69152,85,NULL,'I, raw','ESO 184- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144056,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144056,33.57,0.43,51.9,69152,75,NULL,'MAT, I, inv','ESO 184- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144057,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144057,33.6,0.43,52.6,69152,75,NULL,'MAT, I, raw','ESO 184- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144058,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144058,33.86,0.43,59.1,69152,75,NULL,'MAT, I, cor','ESO 184- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144059,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144059,33.5,0.49,50.1,69153,75,NULL,'IR','UGC 11394',NULL,'2011yCatp016004901K',2011,1,1.93,'abs(b) < 10 degrees.','G',0.00002,NULL,'16.0',0.22,'Scd',NULL,NULL,NULL,NULL,1,285.901875,27.60664,NULL,NULL,54402648228,850041378,13281896,16),(144060,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144060,33.89,0.47,60,69153,NULL,NULL,'H','UGC 11394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144061,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144061,33.94,0.4,61.4,69153,NULL,NULL,'mean','UGC 11394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144062,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144062,34.03,0.46,63.8,69153,NULL,NULL,'J','UGC 11394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144063,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144063,34.06,0.45,64.8,69153,NULL,NULL,'K','UGC 11394',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144064,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144064,34.06,0.43,64.8,69153,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144065,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144065,34.16,NULL,67.9,69153,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144066,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144066,34.16,NULL,68,69153,NULL,NULL,'Dipole','UGC 11394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144067,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144067,34.17,NULL,68.2,69153,NULL,NULL,'Dipole + Quadrupole','UGC 11394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144068,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144068,34.17,NULL,68.3,69153,NULL,NULL,NULL,'UGC 11394',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144069,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144069,34.17,0.4,68.3,69154,NULL,NULL,'mean','UGC 11397',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'13.7',0.6,'SBa',NULL,NULL,NULL,NULL,1,285.9547917,33.84469,0.517,NULL,54378486243,849663847,13275997,13.7),(144070,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144070,34.45,0.45,77.6,69154,NULL,NULL,'K','UGC 11397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144071,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144071,34.48,0.47,78.6,69154,NULL,NULL,'H','UGC 11397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144072,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144072,34.54,0.46,80.8,69154,NULL,NULL,'J','UGC 11397',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144073,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144073,37.02,0.61,253,69155,70,NULL,NULL,'2MASX J19040106-7659280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,286.004625,-76.99103,0.385,NULL,48476882290,757451285,11835176,15.5),(144074,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144074,35.51,0.57,126,69156,70,NULL,NULL,'2MASX J19042121-5342395',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.6,NULL,NULL,NULL,NULL,NULL,1,286.08825,-53.71089,0.289,NULL,49088262272,767004098,11984439,13.6),(144075,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144075,33.67,0.8,54.2,69157,75,NULL,'MAT, I','IC 4814',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000029,NULL,'14.34',0.6,'S...',NULL,NULL,NULL,NULL,1,286.245375,-58.57939,0.217,NULL,49120359492,767505617,11992275,14.34),(144076,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144076,32.51,0.32,31.7,69157,85,NULL,'I, raw','IC 4814',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144077,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144077,32.51,0.32,31.8,69157,85,NULL,'I, inv','IC 4814',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144078,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144078,32.81,0.43,36.5,69157,75,NULL,'MAT, I, raw','IC 4814',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144079,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144079,32.89,0.43,37.9,69157,75,NULL,'MAT, I, inv','IC 4814',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144080,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144080,33.21,0.43,43.9,69157,75,NULL,'MAT, I, cor','IC 4814',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144081,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144081,33.87,0.4,59.5,69157,NULL,NULL,'mean','IC 4814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144082,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144082,33.97,0.09,62.4,69157,NULL,NULL,NULL,'IC 4814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144083,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144083,34.03,0.47,63.9,69157,NULL,NULL,'H','IC 4814',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144084,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144084,35.49,0.52,125,69158,70,NULL,NULL,'ESO 141- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.78',0.5,'(R\')SA(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,286.2552917,-57.98494,0.225,NULL,49119827286,767497301,11992145,14.78),(144085,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144085,36.24,0.55,177,69159,70,NULL,NULL,'2MASX J19052300-2947477',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,286.345791667,-29.79653,0.485,NULL,47624640356,744135005,11627109,15.5),(144086,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144086,36.12,NULL,167,69160,NULL,NULL,NULL,'FGC 2237',NULL,'2000BSAO...50....5K',2000,1,0.74,NULL,'G',NULL,NULL,'16.95',0.09,'Sdm',NULL,NULL,NULL,NULL,1,286.4127083,43.63703,0.237,NULL,54811316797,856426824,13381669,16.95),(144087,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144087,36.49,0.49,198,69160,75,NULL,'IR','FGC 2237',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144088,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144088,33.89,0.8,60,69161,75,NULL,'MAT, I','ESO 184- G 008',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.10',0.8,'SA(s)cd',NULL,NULL,NULL,NULL,1,286.464583,-54.10736,0.297,NULL,49089024459,767016007,11984625,15.1),(144089,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144089,33.22,0.32,44.1,69161,85,NULL,'I, inv','ESO 184- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144090,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144090,33.23,0.32,44.2,69161,85,NULL,'I, raw','ESO 184- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144091,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144091,33.89,0.43,60.1,69161,75,NULL,'MAT, I, raw','ESO 184- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144092,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144092,33.97,0.43,62.3,69161,75,NULL,'MAT, I, inv','ESO 184- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144093,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144093,33.99,0.46,62.7,69161,NULL,NULL,NULL,'ESO 184- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144094,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144094,34.03,0.2,64,69161,74.4,NULL,NULL,'ESO 184- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144095,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144095,34.06,0.43,65,69161,75,NULL,'MAT, I, cor','ESO 184- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144096,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144096,34.11,0.44,66.3,69161,NULL,NULL,'Malmquist cor.','ESO 184- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144097,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144097,34.86,0.48,93.7,69162,70,NULL,NULL,'ESO 282- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000067,NULL,'12.6R',0.8,'E',NULL,NULL,NULL,NULL,1,286.479625,-43.72539,0.301,NULL,51053321129,797708142,12464189,12.6),(144098,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144098,34.44,0.46,77.1,69163,70,NULL,NULL,'ESO 337- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'12.5',1.1,'SA(s)0^-:',NULL,NULL,NULL,NULL,1,286.49975,-42.36569,0.317,NULL,51045117878,797579966,12462186,12.5),(144099,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144099,37.62,0.73,335,69164,70,NULL,NULL,'2MASX J19060528-2517125',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,286.5220417,-25.28683,0.709,NULL,47611158603,743924353,11623818,16.4),(144100,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144100,33.81,0.4,57.8,69165,75,NULL,'Edat, raw','NGC 6733',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000107,NULL,'13.39',1.2,'SAB0^0^ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,286.544291667,-62.19692,0.221,NULL,48946001569,764781274,11949707,13.39),(144101,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144101,33.85,0.4,58.8,69165,75,NULL,'Edat, cor','NGC 6733',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144102,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144102,34.28,0.25,71.8,69165,74.4,NULL,NULL,'NGC 6733',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144103,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144103,34.13,0.4,66.9,69165,NULL,NULL,'mean','NGC 6733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144104,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144104,34.62,0.45,84,69165,NULL,NULL,'K','NGC 6733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144105,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144105,32.75,0.8,35.5,69166,75,NULL,'MAT, I','IC 4817',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.48',0.5,'SAB(r)b','Pair member (points to parent)',NULL,NULL,NULL,1,286.5514583,-56.15936,0.269,NULL,49078601027,766853141,11982080,14.48),(144106,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144106,32.82,0.32,36.7,69166,85,NULL,'I, raw','IC 4817',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144107,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144107,32.84,0.32,36.9,69166,85,NULL,'I, inv','IC 4817',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144108,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144108,33.07,0.43,41,69166,75,NULL,'MAT, I, raw','IC 4817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144109,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144109,33.15,0.43,42.7,69166,75,NULL,'MAT, I, inv','IC 4817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144110,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144110,33.42,0.43,48.3,69166,75,NULL,'MAT, I, cor','IC 4817',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144111,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144111,34.2,0.47,69.1,69167,NULL,NULL,'H','ESO 592- G 010',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000023,NULL,'15.2b',0.5,'SB(r)bc?',NULL,NULL,NULL,NULL,1,286.577875,-19.94581,0.741,NULL,48275388928,754302952,11785983,15.2),(144112,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144112,34.24,0.45,70.6,69167,NULL,NULL,'K','ESO 592- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144113,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144113,34.31,0.46,72.6,69167,NULL,NULL,'J','ESO 592- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144114,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144114,34.4,0.4,75.7,69167,NULL,NULL,'mean','ESO 592- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144115,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144115,35.56,0.56,130,69168,70,NULL,NULL,'2MASX J19062464-3206523',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.3R',0.2,'E',NULL,NULL,NULL,NULL,1,286.6027917,-32.11447,0.373,NULL,47629712941,744214264,11628347,15.3),(144116,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144116,35.05,0.48,102,69169,70,NULL,NULL,'ESO 459- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000077,NULL,'13.4R',0.7,'S0:',NULL,NULL,NULL,NULL,1,286.698708333,-32.01589,0.373,NULL,47629574480,744212101,11628314,13.4),(144117,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144117,35.66,0.7,136,69170,70,NULL,NULL,'2MASX J19065551-4200054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,286.7312083,-42.00164,0.349,NULL,51225578331,800399661,12506244,15.4),(144118,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144118,35.77,NULL,142,69171,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11395',NULL,'2010Ap&SS.325..163P',2010,1,1.06,'UGC RA (19h 01.5m) is incorrect.','G',NULL,NULL,'16.5:',0.13,'Scd',NULL,NULL,NULL,NULL,1,286.745375,71.76553,0.473,NULL,52684828007,823200437,12862506,16.5),(144119,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144119,35.77,NULL,143,69171,NULL,NULL,'Dipole + Quadrupole','UGC 11395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144120,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144120,35.78,NULL,143,69171,NULL,NULL,'Dipole','UGC 11395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144121,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144121,35.82,NULL,146,69171,NULL,NULL,NULL,'UGC 11395',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144122,'Sosies','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144122,32.93,0.16,38.5,69172,NULL,NULL,NULL,'UGC 11404',NULL,'2002A&A...393...57T',2002,1,2.3,NULL,'G',0.000004,NULL,'14.0',1.6,'Sbc',NULL,NULL,NULL,NULL,1,286.76575,29.00647,NULL,NULL,54411399267,850178113,13284033,14),(144123,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144123,33,0.69,39.8,69172,100,NULL,'mid-IR','UGC 11404',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144124,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144124,33.24,0.43,44.5,69172,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11404',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144125,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144125,31.63,0.8,21.2,69173,75,NULL,'MAT, I','IC 4819',NULL,'1997ApJS..109..333W',1997,1,3.36,NULL,'G',0.00002,NULL,'14.12',0.34,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,286.780417,-59.46694,0.197,NULL,49067995599,766687431,11979491,14.12),(144126,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144126,31.86,0.8,23.5,69173,75,NULL,NULL,'IC 4819',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144127,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144127,31.44,0.32,19.4,69173,85,NULL,'I, inv','IC 4819',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144128,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144128,31.46,0.32,19.6,69173,85,NULL,'I, raw','IC 4819',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144129,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144129,31.55,0.4,20.4,69173,NULL,NULL,NULL,'IC 4819',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144130,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144130,31.55,0.4,20.4,69173,73,NULL,'opt','IC 4819',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144131,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144131,31.69,0.43,21.8,69173,75,NULL,'MAT, I, inv','IC 4819',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144132,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144132,31.71,0.43,22,69173,75,NULL,'MAT, I, raw','IC 4819',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144133,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144133,31.86,NULL,23.6,69173,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144134,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144134,31.88,NULL,23.8,69173,NULL,NULL,'Dipole + Quadrupole','IC 4819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144135,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144135,31.9,NULL,24,69173,NULL,NULL,'Dipole','IC 4819',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144136,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144136,32.03,NULL,25.5,69173,NULL,NULL,NULL,'IC 4819',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144137,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144137,32.15,0.43,26.9,69173,75,NULL,'MAT, I, cor','IC 4819',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144138,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144138,33.77,0.4,56.7,69174,NULL,NULL,'mean','NGC 6734',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00005,NULL,'16.5b',1.1,'S0-','Pair member (points to parent)',NULL,NULL,NULL,1,286.8097083,-65.46186,0.225,NULL,48947927962,764811374,11950177,16.5),(144139,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144139,33.82,0.45,58,69174,NULL,NULL,'K','NGC 6734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144140,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144140,33.36,0.45,47,69175,NULL,NULL,'K','NGC 6730',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00007,NULL,'12.21',1.5,'E1',NULL,NULL,NULL,NULL,1,286.8902083,-68.91281,0.209,NULL,49253726804,769589481,12024835,12.21),(144141,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144141,33.78,0.4,56.9,69175,NULL,NULL,'mean','NGC 6730',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144142,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144142,32.78,0.47,36,69176,70,NULL,NULL,'NGC 6739',NULL,'2014MNRAS.445.2677S',2014,1,2.4,NULL,'G',0.000087,NULL,'13.15',0.9,'(L)SA(r)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,286.953167,-61.36811,0.189,NULL,48945851447,764778928,11949670,13.15),(144143,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144143,34.82,0.62,91.9,69177,70,NULL,NULL,'2MASX J19075668-5517509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,286.986125,-55.29742,0.249,NULL,49086631150,766978611,11984040,15.9),(144144,'HII region diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144144,32.86,0.13,37.4,69178,NULL,NULL,NULL,'NGC 6764',NULL,'2005JKAS...38....7I',2005,1,2.3,NULL,'G',0.000013,NULL,'12.56',1.3,'SB(s)bc;LINER  Sy2','Group member, radial-velocity confirmed',NULL,NULL,'H II',1,287.0682083,50.93322,0.237,NULL,54795997098,856187454,13377928,12.56),(144145,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144145,32.75,0.8,35.5,69178,75,NULL,'A82, H','NGC 6764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144146,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144146,31.56,0.4,20.5,69178,75,NULL,NULL,'NGC 6764',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144147,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144147,31.7,0.43,21.9,69178,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6764',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144148,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144148,31.78,0.43,22.6,69178,75,NULL,'3.6 micron, color corrected','NGC 6764',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144149,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144149,31.87,0.2,23.7,69178,74.4,NULL,NULL,'NGC 6764',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144150,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144150,32.07,0.4,25.9,69178,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6764',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144151,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144151,32.09,0.38,26.2,69178,NULL,NULL,NULL,'NGC 6764',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144152,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144152,32.18,0.49,27.3,69178,75,NULL,'IR','NGC 6764',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144153,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144153,32.46,0.47,31.1,69178,NULL,NULL,'H','NGC 6764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144154,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144154,32.48,0.46,31.3,69178,NULL,NULL,'J','NGC 6764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144155,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144155,32.5,0.45,31.7,69178,NULL,NULL,'K','NGC 6764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144156,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144156,32.51,0.47,31.7,69178,75,NULL,'A82, H, raw','NGC 6764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144157,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144157,32.52,0.4,31.9,69178,NULL,NULL,'mean','NGC 6764',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144158,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144158,32.58,0.47,32.8,69178,75,NULL,'A82, H, inv','NGC 6764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144159,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144159,32.84,0.4,37,69178,75,NULL,'B','NGC 6764',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144160,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144160,32.94,0.47,38.7,69178,75,NULL,'A82, H, cor','NGC 6764',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144161,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144161,29.09,0.1,6.58,69179,74.4,NULL,NULL,'UGC 11411',NULL,'2013AJ....146...86T',2013,1,0.9,'Radial velocity suggests this is a Galactic object.','G',0.000127,NULL,'16.0',0.7,'Sc',NULL,NULL,NULL,NULL,1,287.176167,70.28394,0.465,NULL,53563627211,836931675,13077057,16),(144162,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144162,34.01,0.8,63.4,69180,75,NULL,'MAT, I','NGC 6754A',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.34',0.3,'Sb',NULL,NULL,NULL,NULL,1,287.182375,-51.04606,0.217,NULL,51022960914,797233764,12456777,14.34),(144163,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144163,33.77,0.47,56.8,69180,NULL,NULL,'H','NGC 6754A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144164,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144164,33.81,0.45,57.8,69180,NULL,NULL,'K','NGC 6754A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144165,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144165,33.82,0.46,58.1,69180,NULL,NULL,'J','NGC 6754A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144166,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144166,34.01,0.49,63.4,69180,75,NULL,'IR','NGC 6754A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144167,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144167,34.06,0.43,64.8,69180,75,NULL,'MAT, I, raw','NGC 6754A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144168,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144168,34.1,0.32,66,69180,85,NULL,'I, raw','NGC 6754A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144169,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144169,34.13,0.4,67.1,69180,NULL,NULL,'mean','NGC 6754A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144170,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144170,34.17,0.32,68.2,69180,85,NULL,'I, inv','NGC 6754A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144171,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144171,34.23,0.3,70.3,69180,NULL,NULL,'Malmquist cor.','NGC 6754A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144172,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144172,34.24,0.43,70.4,69180,75,NULL,'MAT, I, cor','NGC 6754A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144173,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144173,34.32,0.29,73.1,69180,NULL,NULL,NULL,'NGC 6754A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144174,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144174,34.36,0.43,74.4,69180,75,NULL,'MAT, I, inv','NGC 6754A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144175,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144175,34.36,0.2,74.5,69180,74.4,NULL,NULL,'NGC 6754A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144176,'GRB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144176,47.52,1.58,9300,69181,NULL,NULL,NULL,'GRB 080413',2.433,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,287.2987083,-27.67778,0.581,NULL,47644595238,744446800,11631981,NULL),(144177,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144177,32.47,0.8,31.2,69182,75,NULL,'MAT, I','IC 4821',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000023,NULL,'13.63',0.7,'SA(s)c?',NULL,NULL,NULL,NULL,1,287.383375,-55.01731,0.265,NULL,49089473886,767023029,11984734,13.63),(144178,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144178,31.91,0.32,24.1,69182,85,NULL,'I, raw','IC 4821',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144179,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144179,31.91,0.32,24.1,69182,85,NULL,'I, inv','IC 4821',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144180,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144180,31.99,0.4,25,69182,NULL,NULL,NULL,'IC 4821',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144181,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144181,31.99,0.4,25,69182,73,NULL,'opt','IC 4821',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144182,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144182,32.25,0.43,28.2,69182,75,NULL,'MAT, I, raw','IC 4821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144183,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144183,32.33,0.43,29.2,69182,75,NULL,'MAT, I, inv','IC 4821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144184,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144184,32.59,0.4,33,69182,NULL,NULL,'mean','IC 4821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144185,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144185,32.59,0.46,33,69182,NULL,NULL,'J','IC 4821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144186,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144186,32.63,0.47,33.5,69182,NULL,NULL,'H','IC 4821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144187,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144187,32.66,0.43,34.1,69182,75,NULL,'MAT, I, cor','IC 4821',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144188,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144188,32.73,0.45,35.2,69182,NULL,NULL,'K','IC 4821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144189,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144189,34.63,0.4,84.3,69183,NULL,NULL,'mean','ESO 397- G 004',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00002,NULL,'12.7R',1,'(R\')SA(s)bc    HII',NULL,NULL,NULL,NULL,1,287.389625,-33.35456,0.325,NULL,51156224972,799316015,12489312,12.7),(144190,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144190,35.25,0.45,112,69183,NULL,NULL,'K','ESO 397- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144191,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144191,35.27,0.47,113,69183,NULL,NULL,'H','ESO 397- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144192,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144192,35.34,0.46,117,69183,NULL,NULL,'J','ESO 397- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144193,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144193,35.34,0.66,117,69184,70,NULL,NULL,'ESO 104- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'16.0b',0.3,'S...',NULL,NULL,NULL,NULL,1,287.434167,-64.517,0.185,NULL,48951541413,764867834,11951059,16),(144194,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144194,29.81,0.09,9.15,69185,74.4,NULL,NULL,'NGC 6744',NULL,'2013AJ....146...86T',2013,1,20,'Extended HIPASS source','G',0.000007,NULL,'9.14',12.9,'SAB(r)bc       LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,287.442083,-63.85753,0.141,NULL,48948838914,764825608,11950400,9.14),(144195,'Ring Diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144195,28.4,0.98,4.7,69185,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6744',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144196,'Ring Diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144196,28.9,0.76,6,69185,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6744',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144197,'Sosies','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144197,29.85,0.1,9.33,69185,NULL,NULL,NULL,'NGC 6744',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144198,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144198,29.25,0.4,7.08,69185,NULL,NULL,NULL,'NGC 6744',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144199,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144199,29.4,0.43,7.6,69185,75,NULL,'3.6 micron, color corrected','NGC 6744',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144200,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144200,29.45,0.43,7.8,69185,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6744',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144201,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144201,29.54,NULL,8.09,69185,NULL,NULL,'LEDA [April 2006]','NGC 6744',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144202,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144202,29.6,NULL,8.32,69185,NULL,NULL,NULL,'NGC 6744',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144203,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144203,29.81,0.09,9.15,69185,74.4,NULL,NULL,'NGC 6744',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144204,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144204,29.87,0.29,9.41,69185,NULL,NULL,NULL,'NGC 6744',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144205,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144205,30.09,0.4,10.4,69185,75,NULL,'B','NGC 6744',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144206,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144206,30.17,0.4,10.8,69185,73,NULL,'opt','NGC 6744',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144207,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144207,30.27,0.24,11.3,69185,NULL,NULL,'Malmquist cor.','NGC 6744',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144208,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144208,34.33,0.4,73.4,69186,NULL,NULL,'mean','UGC 11408',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000043,NULL,'14.6',0.5,'Sab',NULL,NULL,NULL,NULL,1,287.4525417,41.57611,0.389,NULL,55007945608,859499150,13429674,14.6),(144209,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144209,34.38,0.46,75.1,69186,NULL,NULL,'J','UGC 11408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144210,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144210,34.38,0.47,75.3,69186,NULL,NULL,'H','UGC 11408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144211,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144211,34.4,0.45,75.8,69186,NULL,NULL,'K','UGC 11408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144212,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144212,34.24,0.48,70.4,69187,70,NULL,NULL,'ESO 282- G 016',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.13',0.4,'S0?',NULL,NULL,NULL,NULL,1,287.4707083,-43.53597,0.309,NULL,51254448761,800850761,12513293,15.13),(144213,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144213,34.38,NULL,75.2,69188,NULL,NULL,'Dipole','UGC 11411A',NULL,'2010Ap&SS.325..163P',2010,1,2.37,NULL,'G',0.00002,NULL,'15',0.24,'Sbc',NULL,NULL,NULL,NULL,1,287.544125,60.12567,0.353,NULL,53088727134,829511361,12961115,15),(144214,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144214,34.4,NULL,75.7,69188,NULL,NULL,'Dipole + Quadrupole','UGC 11411A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144215,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144215,34.4,NULL,75.9,69188,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11411A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144216,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144216,34.52,0.49,80,69188,75,NULL,'IR','UGC 11411A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144217,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144217,35.61,0.47,133,69189,70,NULL,NULL,'2MASX J19101597-4312391',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,287.5665,-43.21089,0.289,NULL,51225279440,800394991,12506171,14.7),(144218,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144218,35.35,0.65,117,69190,70,NULL,NULL,'2MASX J19102200-8044092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,287.591125,-80.736,0.493,NULL,48537767192,758402612,11850040,16.4),(144219,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144219,33.81,0.4,57.8,69191,75,NULL,'Edat, raw','NGC 6746',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000133,NULL,'12.6',0.9,'SA0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,287.591708333,-61.97017,0.161,NULL,48946347072,764786673,11949791,12.6),(144220,'D-Sigma','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144220,33.85,0.4,58.8,69191,75,NULL,'Edat, cor','NGC 6746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144221,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144221,33.96,0.43,62,69192,75,NULL,'3.6 micron, color corrected','ESO 282- G 018',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000033,NULL,'14.42',0.7,'(R\')SB(s)c',NULL,NULL,NULL,NULL,1,287.668375,-44.18011,0.313,NULL,51246267271,800722926,12511295,14.42),(144222,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144222,33.98,0.2,62.5,69192,74.4,NULL,NULL,'ESO 282- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144223,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144223,33.99,0.43,62.8,69192,75,NULL,'3.6 micron, color + selection bias corrected','ESO 282- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144224,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144224,35.98,0.63,157,69193,70,NULL,NULL,'2MASX J19105406-4740525',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,287.7252917,-47.68131,0.301,NULL,51034293267,797410832,12459544,15.5),(144225,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144225,36.71,0.67,219,69194,70,NULL,NULL,'2MASX J19111373-5753168',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,287.807208333,-57.88797,0.209,NULL,49118139339,767470927,11991733,15.8),(144226,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144226,33.78,0.53,57.1,69195,70,NULL,NULL,'2MASX J19112166-5037339',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00006,NULL,'13.7R',NULL,NULL,'in a pair',NULL,NULL,NULL,1,287.8402083,-50.62608,0.217,NULL,51023014986,797234609,12456790,13.7),(144227,'TRGB','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144227,29.94,0.1,9.73,69196,74.4,NULL,NULL,'ESO 104- G 044',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00001,NULL,'14.96',1.1,'SABm',NULL,NULL,NULL,NULL,1,287.8464583,-64.21908,0.157,NULL,48949074080,764829282,11950457,14.96),(144228,'Ring Diameter','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144228,34.3,0.84,74,69197,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6753',NULL,'1981ApJS...45..541P',1981,1,2.5,NULL,'G',0.000027,NULL,'11.97',2.1,'(R\')SA(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,287.8485,-57.04956,0.233,NULL,49117349774,767458590,11991540,11.97),(144229,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144229,31.85,0.49,23.4,69197,70,NULL,NULL,'NGC 6753',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144230,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144230,32.93,0.8,38.5,69198,75,NULL,'MAT, I','NGC 6754',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'12.89',0.9,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,287.857166667,-50.64181,0.217,NULL,51023014229,797234597,12456790,12.89),(144231,'Sosies','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144231,32.98,0.09,39.4,69198,NULL,NULL,NULL,'NGC 6754',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144232,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144232,32.92,0.47,38.3,69198,NULL,NULL,'H','NGC 6754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144233,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144233,32.95,0.46,38.8,69198,NULL,NULL,'J','NGC 6754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144234,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144234,32.95,0.45,38.9,69198,NULL,NULL,'K','NGC 6754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144235,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144235,33.08,0.4,41.3,69198,NULL,NULL,'mean','NGC 6754',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144236,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144236,33.11,0.43,41.9,69198,75,NULL,'MAT, I, raw','NGC 6754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144237,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144237,33.17,0.32,43.1,69198,85,NULL,'I, raw','NGC 6754',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144238,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144238,33.24,0.32,44.4,69198,85,NULL,'I, inv','NGC 6754',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144239,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144239,33.39,0.43,47.6,69198,75,NULL,'MAT, I, inv','NGC 6754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144240,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144240,33.48,0.43,49.6,69198,75,NULL,'MAT, I, cor','NGC 6754',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144241,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144241,36.54,0.16,189,69199,74.2,NULL,'SALT 2','2MASX J19113272+7753382',0.075,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,287.886625,77.89397,0.193,NULL,52724103121,823814111,12872095,NULL),(144242,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144242,37.17,0.09,272,69199,74.4,NULL,NULL,'2MASX J19113272+7753382',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144243,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144243,37.53,0.22,298,69199,65,NULL,'SALT2','2MASX J19113272+7753382',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144244,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144244,37.64,0.17,314,69199,65,NULL,'MLCS17','2MASX J19113272+7753382',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144245,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2003hu',NULL,144245,37.69,0.2,321,69199,65,NULL,'MLCS31','2MASX J19113272+7753382',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144246,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144246,36.08,0.73,164,69200,70,NULL,NULL,'2MASX J19113877-4703203',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,287.911667,-47.05564,0.301,NULL,51025895924,797279623,12457494,14.5),(144247,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144247,35.63,0.49,134,69201,75,NULL,'IR','FGCE 1355',NULL,'2011yCatp016004901K',2011,1,1.79,NULL,'G',0.000033,NULL,'16.2',0.17,'Sc',NULL,NULL,NULL,NULL,1,287.94175,-17.22086,0.577,NULL,48305547078,754774173,11793346,16.2),(144248,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144248,35.14,0.8,107,69202,75,NULL,'MAT, I','ESO 593- G 003',NULL,'1997ApJS..109..333W',1997,1,1.85,NULL,'G',0.000033,NULL,'13.87',0.2,'Scd',NULL,NULL,NULL,NULL,1,287.94575,-21.166,0.705,NULL,48096411445,751506428,11742287,13.87),(144249,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144249,34.78,0.43,90.4,69202,75,NULL,'MAT, I, raw','ESO 593- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144250,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144250,34.87,NULL,94.1,69202,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 593- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144251,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144251,34.88,NULL,94.6,69202,NULL,NULL,'Dipole + Quadrupole','ESO 593- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144252,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144252,34.88,NULL,94.7,69202,NULL,NULL,'Dipole','ESO 593- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144253,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144253,34.92,NULL,96.4,69202,NULL,NULL,NULL,'ESO 593- G 003',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144254,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144254,35,0.43,100,69202,75,NULL,'MAT, I, inv','ESO 593- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144255,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144255,35.02,0.32,101,69202,85,NULL,'I, raw','ESO 593- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144256,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144256,35.07,0.32,103,69202,85,NULL,'I, inv','ESO 593- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144257,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144257,35.07,0.49,104,69202,75,NULL,'IR','ESO 593- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144258,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144258,35.08,0.43,104,69202,75,NULL,'MAT, I, cor','ESO 593- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144259,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144259,35.09,0.43,104,69202,75,NULL,'3.6 micron, color + selection bias corrected','ESO 593- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144260,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144260,35.16,0.43,108,69202,75,NULL,'3.6 micron, color corrected','ESO 593- G 003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144261,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144261,35.31,0.2,115,69202,74.4,NULL,NULL,'ESO 593- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144262,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144262,35.4,0.46,120,69202,NULL,NULL,NULL,'ESO 593- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144263,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144263,35.41,0.46,121,69202,NULL,NULL,'Malmquist cor.','ESO 593- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144264,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144264,36.01,0.81,159,69203,70,NULL,NULL,'2MASX J19114785-2740136',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.9R',0.1,NULL,NULL,NULL,NULL,NULL,1,287.949417,-27.67039,0.489,NULL,47644478127,744444970,11631952,15.9),(144265,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144265,34.18,NULL,68.5,69204,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2240',NULL,'2010Ap&SS.325..163P',2010,1,0.88,NULL,'G',NULL,NULL,'16.7',0.11,'Sc',NULL,NULL,NULL,NULL,1,288.030833,42.17722,0.357,NULL,55004822996,859450359,13428911,16.7),(144266,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144266,34.2,NULL,69.3,69204,NULL,NULL,'Dipole','FGC 2240',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144267,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144267,34.21,NULL,69.4,69204,NULL,NULL,'Dipole + Quadrupole','FGC 2240',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144268,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144268,34.26,NULL,71.1,69204,NULL,NULL,NULL,'FGC 2240',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144269,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144269,32.53,0.8,32,69205,75,NULL,'MAT, I','ESO 459- G 006',NULL,'1997ApJS..109..333W',1997,1,1.6,'Mathewson, et al. (1992ApJS...81..413M) give v = 2513 +/- 10 km/sec.','G',0.00002,NULL,'14.5',0.5,'SB(rs)b:       HII',NULL,NULL,NULL,NULL,1,288.0367083,-32.1265,0.393,NULL,47628523677,744195682,11628057,14.5),(144270,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144270,34.02,0.43,63.7,69205,75,NULL,'MAT, I, raw','ESO 459- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144271,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144271,34.07,0.32,65.3,69205,85,NULL,'I, raw','ESO 459- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144272,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144272,34.14,0.32,67.4,69205,85,NULL,'I, inv','ESO 459- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144273,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144273,34.2,0.47,69.1,69205,NULL,NULL,'H','ESO 459- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144274,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144274,34.23,0.46,70.2,69205,NULL,NULL,'J','ESO 459- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144275,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144275,34.3,0.43,72.6,69205,75,NULL,'MAT, I, inv','ESO 459- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144276,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144276,34.32,0.45,73,69205,NULL,NULL,'K','ESO 459- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144277,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144277,34.39,0.43,75.6,69205,75,NULL,'3.6 micron, color corrected','ESO 459- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144278,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144278,34.4,0.43,75.8,69205,75,NULL,'MAT, I, cor','ESO 459- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144279,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144279,34.42,0.2,76.6,69205,74.4,NULL,NULL,'ESO 459- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144280,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144280,34.57,0.34,82,69205,NULL,NULL,'Malmquist cor.','ESO 459- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144281,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144281,34.58,0.43,82.2,69205,75,NULL,'3.6 micron, color + selection bias corrected','ESO 459- G 006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144282,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144282,34.63,0.4,84.5,69205,NULL,NULL,'mean','ESO 459- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144283,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144283,34.72,0.32,87.7,69205,NULL,NULL,NULL,'ESO 459- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144284,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144284,35.32,0.62,116,69206,70,NULL,NULL,'2MASX J19120924-3416314',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,288.0385,-34.27544,0.285,NULL,51156542689,799320979,12489390,14.3),(144285,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144285,36.1,0.6,166,69207,70,NULL,NULL,'2MASX J19123585-1752336',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.149375,-17.87594,0.609,NULL,48302201185,754721893,11792529,15.7),(144286,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144286,33.97,0.47,62.3,69208,NULL,NULL,'H','ESO 282- G 021',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000023,NULL,'13.74',1.1,'(R\')SB(s)b',NULL,NULL,NULL,NULL,1,288.199208333,-46.01156,0.197,NULL,51247642637,800744416,12511631,13.74),(144287,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144287,34.02,0.46,63.6,69208,NULL,NULL,'J','ESO 282- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144288,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144288,34.03,0.45,64,69208,NULL,NULL,'K','ESO 282- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144289,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144289,34.25,0.4,70.9,69208,NULL,NULL,'mean','ESO 282- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144290,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144290,34.91,0.52,95.8,69209,70,NULL,NULL,'ESO 184- G 034',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'6dF DR2 has z = 0.019771.','G',0.00015,NULL,'14.95',0.3,'S0?',NULL,NULL,NULL,NULL,1,288.248333,-52.51364,0.209,NULL,48889577024,763899641,11935931,14.95),(144291,'Tully est','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144291,30.35,0.8,11.8,69210,75,NULL,NULL,'IC 4824',NULL,'1988NBGC.C....0000T',1988,1,2.7,'-1m 10s, -7.6m error in A-M position.','G',0.000007,NULL,'16.76',1.7,'IAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.308625,-62.08828,0.161,NULL,48953896657,764904635,11951634,16.76),(144292,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144292,29.23,0.2,7.01,69210,74.4,NULL,NULL,'IC 4824',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144293,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144293,36.01,0.68,159,69211,70,NULL,NULL,'2MASX J19131904-7300553',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,288.329083,-73.01536,0.225,NULL,48510638753,757978730,11843417,16),(144294,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144294,33.66,0.8,54,69212,75,NULL,'HMCL, I','IC 4827',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000033,NULL,'13.24',0.5,'SA(s)ab: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.3385,-60.86017,0.173,NULL,49066482796,766663793,11979121,13.24),(144295,'IRAS','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144295,33.7,0.8,55.1,69212,75,NULL,'MAT, I','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144296,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,'R',144296,33.29,0.49,45.5,69212,75,NULL,'IR','IC 4827',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144297,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144297,33.4,0.46,47.9,69212,NULL,NULL,'J','IC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144298,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144298,33.41,0.4,48.2,69212,75,NULL,'HMCL, I, raw','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144299,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144299,33.48,0.45,49.6,69212,NULL,NULL,'K','IC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144300,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144300,33.5,0.43,50.1,69212,75,NULL,'MAT, I, raw','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144301,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144301,33.5,0.47,50.2,69212,NULL,NULL,'H','IC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144302,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144302,33.64,0.4,53.5,69212,75,NULL,'HMCL, I, cor','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144303,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144303,33.68,0.4,54.5,69212,75,NULL,'HMCL, I, inv','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144304,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144304,33.71,0.43,55.2,69212,75,NULL,'MAT, I, cor','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144305,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144305,33.76,0.32,56.4,69212,85,NULL,'I, raw','IC 4827',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144306,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144306,33.82,0.4,58.1,69212,NULL,NULL,'mean','IC 4827',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144307,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144307,33.85,0.32,58.8,69212,85,NULL,'I, inv','IC 4827',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144308,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144308,33.85,0.43,59,69212,75,NULL,'MAT, I, inv','IC 4827',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144309,'Tully-Fisher','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144309,34.26,0.12,71.3,69212,NULL,NULL,NULL,'IC 4827',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144310,'FP','2016-12-15 15:15:48','2016-12-16 11:21:03','1',NULL,NULL,144310,36.65,0.6,214,69213,70,NULL,NULL,'2MASX J19134009-4415432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.417125,-44.26208,0.317,NULL,51246869418,800732334,12511442,15.2),(144311,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144311,33.06,0.16,40.3,69214,74.2,NULL,'SALT 2','IC 4830',0.01464,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000033,NULL,'13.17',1.3,'SB(r)b',NULL,NULL,NULL,NULL,1,288.452333333,-59.29436,0.197,NULL,49069400113,766709376,11979834,13.17),(144312,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144312,33.57,0.09,51.8,69214,74.4,NULL,NULL,'IC 4830',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144313,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144313,33.61,0.19,52,69214,72,NULL,NULL,'IC 4830',0.01464,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144314,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144314,33.62,0.04,52.1,69214,72,NULL,NULL,'IC 4830',0.01464,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144315,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144315,33.71,0.2,54.3,69214,70,NULL,'SALT 2','IC 4830',0.01464,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144316,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144316,33.78,0.04,56.2,69214,72,NULL,NULL,'IC 4830',0.01464,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144317,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144317,33.83,0.05,57.5,69214,72,NULL,NULL,'IC 4830',0.01464,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144318,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144318,33.84,0.09,57.8,69214,72,NULL,NULL,'IC 4830',0.01464,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144319,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144319,33.9,0.16,59.4,69214,70,NULL,'SALT','IC 4830',0.01464,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144320,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144320,33.9,0.23,59.4,69214,65,NULL,'MLCS31','IC 4830',0.01464,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144321,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144321,33.95,0.11,59.9,69214,65,NULL,'MLCS2k2','IC 4830',0.01464,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144322,'SNIa','2016-12-15 15:15:48','2016-12-16 11:21:03','1','SN 2001bt',NULL,144322,33.96,0.03,61.9,69214,72,NULL,'M(H) = -18.317 mag','IC 4830',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144323,'SNIa','2016-12-15 15:15:49','2016-12-16 11:21:03','1','SN 2001bt',NULL,144323,33.97,0.17,62.2,69214,70.8,NULL,NULL,'IC 4830',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144324,'SNIa','2016-12-15 15:15:49','2016-12-16 11:21:03','1','SN 2001bt',NULL,144324,34.01,0.25,62.4,69214,65,NULL,'SALT2','IC 4830',0.01464,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144325,'SNIa','2016-12-15 15:15:49','2016-12-16 11:21:03','1','SN 2001bt',NULL,144325,34.03,0.23,62.9,69214,65,NULL,'MLCS17','IC 4830',0.01464,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144326,'SNIa','2016-12-15 15:15:49','2016-12-16 11:21:03','1','SN 2001bt',NULL,144326,35.24,0.03,110,69214,70,NULL,'SALT 2','IC 4830',0.01464,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144327,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144327,32.86,0.53,37.3,69214,70,NULL,NULL,'IC 4830',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144328,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144328,33.68,0.8,54.4,69214,75,NULL,'MAT, I','IC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144329,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144329,33.86,0.45,59.2,69214,NULL,NULL,'K','IC 4830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144330,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144330,33.87,0.47,59.4,69214,NULL,NULL,'H','IC 4830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144331,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144331,33.87,0.4,59.4,69214,NULL,NULL,'mean','IC 4830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144332,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144332,33.89,0.46,59.9,69214,NULL,NULL,'J','IC 4830',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144333,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144333,34.01,0.43,63.5,69214,75,NULL,'MAT, I, raw','IC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144334,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144334,34.07,0.43,65.2,69214,75,NULL,'MAT, I, cor','IC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144335,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144335,34.19,0.32,68.8,69214,85,NULL,'I, raw','IC 4830',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144336,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144336,34.2,0.07,69.3,69214,NULL,NULL,NULL,'IC 4830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144337,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144337,34.28,0.32,71.7,69214,85,NULL,'I, inv','IC 4830',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144338,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144338,34.38,0.43,75.1,69214,75,NULL,'MAT, I, inv','IC 4830',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144339,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144339,36.25,0.74,178,69215,70,NULL,NULL,'2MASX J19135002-4408581',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.4585,-44.14956,0.325,NULL,51246861300,800732207,12511440,15.6),(144340,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144340,32.95,0.4,38.8,69216,75,NULL,'Edat, raw','NGC 6758',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000133,NULL,'12.65',1.7,'E+:            LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.468083,-56.30994,0.205,NULL,49084883052,766951297,11983614,12.65),(144341,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144341,33.2,0.4,43.6,69216,75,NULL,'Edat, cor','NGC 6758',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144342,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144342,32.23,0.65,27.9,69216,95,NULL,'Weighted Mean','NGC 6758',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144343,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144343,33.74,0.81,56,69216,55,NULL,'Visvanathan & Sandage 1979','NGC 6758',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144344,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144344,33.3,0.45,45.8,69216,NULL,NULL,'K','NGC 6758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144345,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144345,33.31,0.4,45.9,69216,NULL,NULL,'mean','NGC 6758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144346,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144346,36.92,0.99,242,69217,70,NULL,NULL,'2MASX J19141461-7125211',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,288.56075,-71.42247,0.205,NULL,49249676492,769526195,12023846,17),(144347,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144347,34.03,0.48,63.9,69218,70,NULL,NULL,'2MASX J19142423-5815441',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000053,NULL,'15.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,288.601125,-58.26217,0.209,NULL,49118429452,767475460,11991804,15.2),(144348,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144348,36.32,0.52,184,69219,70,NULL,NULL,'2MASX J19142530-4614247',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,288.6055417,-46.24022,0.225,NULL,51247751359,800746114,12511658,13.9),(144349,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144349,33.89,0.52,59.9,69220,NULL,NULL,NULL,'ESO 282- G 029',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.20',1,'SA(r)c',NULL,NULL,NULL,NULL,1,288.6525417,-46.95769,0.277,NULL,51247932566,800748946,12511702,15.2),(144350,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144350,33.93,0.2,61.1,69220,74.4,NULL,NULL,'ESO 282- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144351,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144351,34.23,0.44,70.2,69220,NULL,NULL,'Malmquist cor.','ESO 282- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144352,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144352,33.69,0.8,54.6,69221,75,NULL,'HMCL, I','IC 4831',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000021,NULL,'13.6b',0.9,'(R\'_2)SAB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.682667,-62.27261,0.189,NULL,48954775806,764918371,11951849,13.6),(144353,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144353,33.26,0.4,45,69221,75,NULL,'HMCL, I, raw','IC 4831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144354,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144354,33.36,0.47,46.9,69221,NULL,NULL,'H','IC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144355,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144355,33.36,0.46,47,69221,NULL,NULL,'J','IC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144356,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144356,33.44,0.45,48.7,69221,NULL,NULL,'K','IC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144357,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144357,33.54,0.4,51.1,69221,75,NULL,'HMCL, I, inv','IC 4831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144358,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144358,33.54,0.4,51.1,69221,75,NULL,'HMCL, I, cor','IC 4831',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144359,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144359,33.83,0.4,58.3,69221,NULL,NULL,'mean','IC 4831',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144360,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144360,36.12,0.7,168,69222,70,NULL,NULL,'2MASX J19145507-7258092',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,288.729667,-72.96914,0.225,NULL,48507803751,757934433,11842725,16.9),(144361,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144361,34.81,0.48,91.4,69223,NULL,NULL,NULL,'ESO 524- G 011',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.31',0.5,'Sb-c:',NULL,NULL,NULL,NULL,1,288.7512917,-23.75819,0.553,NULL,48088474004,751382406,11740350,14.31),(144362,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144362,34.85,0.2,93.3,69223,74.4,NULL,NULL,'ESO 524- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144363,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144363,35.06,0.43,103,69223,NULL,NULL,'Malmquist cor.','ESO 524- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144364,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144364,35.77,0.44,142,69224,NULL,NULL,NULL,'ESO 141- G 039',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.67',0.2,'Sc',NULL,NULL,NULL,NULL,1,288.782917,-58.36617,0.201,NULL,49118408118,767475126,11991798,16.67),(144365,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144365,35.76,0.45,142,69224,NULL,NULL,'Malmquist cor.','ESO 141- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144366,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144366,35.81,0.2,145,69224,74.4,NULL,NULL,'ESO 141- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144367,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144367,34.6,0.49,83.3,69225,75,NULL,'IR','2MFGC 14823',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000023,NULL,'13.6R',0.4,'SBb?           HII',NULL,NULL,NULL,NULL,1,288.805583,-16.93767,0.377,NULL,48302018516,754719039,11792484,13.6),(144368,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144368,34.92,0.47,96.4,69225,NULL,NULL,'H','2MFGC 14823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144369,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144369,35.02,0.4,101,69225,NULL,NULL,'mean','2MFGC 14823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144370,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144370,35.08,0.45,104,69225,NULL,NULL,'K','2MFGC 14823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144371,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144371,35.15,0.46,107,69225,NULL,NULL,'J','2MFGC 14823',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144372,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144372,32.7,0.8,34.7,69226,75,NULL,'B','IC 4837',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00006,NULL,'13.01',1.2,'SB(s)cd pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.811,-54.66142,0.237,NULL,49087372724,766990198,11984221,13.01),(144373,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144373,32.25,0.46,28.2,69227,NULL,NULL,'J','IC 4837A',NULL,'2007A&A...465...71T',2007,1,4.1,NULL,'G',0.000024,NULL,'12.55',0.6,'SA(s)b: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,288.817375,-54.1325,0.257,NULL,49076033469,766813022,11981453,12.55),(144374,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144374,32.3,0.47,28.8,69227,NULL,NULL,'H','IC 4837A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144375,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144375,32.36,0.45,29.6,69227,NULL,NULL,'K','IC 4837A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144376,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144376,32.45,0.49,31,69227,75,NULL,'IR','IC 4837A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144377,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144377,32.77,0.4,35.8,69227,NULL,NULL,'mean','IC 4837A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144378,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144378,33.57,0.4,51.7,69227,75,NULL,NULL,'IC 4837A',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144379,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144379,34.17,0.07,68.4,69228,NULL,NULL,NULL,'IC 4835',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.74',0.6,'S...',NULL,NULL,NULL,NULL,1,288.8645,-58.238,0.209,NULL,49118228739,767472324,11991755,14.74),(144380,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144380,32.49,0.8,31.5,69229,75,NULL,'MAT, I','IC 4839',NULL,'1997ApJS..109..333W',1997,1,2.3,'Redshifts reported at z = 0.009 apply to IC 4837.','G',0.00015,NULL,'13.19',1.5,'(R\')SAB(s)bc','Group member',NULL,NULL,NULL,1,288.892166667,-54.62669,0.237,NULL,49087367104,766990111,11984220,13.19),(144381,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144381,29.87,0.32,9.4,69229,85,NULL,'I, inv','IC 4839',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144382,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144382,29.87,0.32,9.44,69229,85,NULL,'I, raw','IC 4839',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144383,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144383,30.25,0.43,11.2,69229,75,NULL,'MAT, I, raw','IC 4839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144384,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144384,30.27,0.43,11.3,69229,75,NULL,'MAT, I, inv','IC 4839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144385,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144385,30.52,0.43,12.7,69229,75,NULL,'MAT, I, cor','IC 4839',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144386,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144386,31.48,0.47,19.8,69229,NULL,NULL,'H','IC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144387,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144387,31.55,0.45,20.4,69229,NULL,NULL,'K','IC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144388,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144388,31.57,0.46,20.6,69229,NULL,NULL,'J','IC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144389,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144389,32.6,0.4,33.1,69229,NULL,NULL,'mean','IC 4839',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144390,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144390,35.68,0.55,137,69230,70,NULL,NULL,'2MASX J19153585-5819179',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.899583,-58.32158,0.197,NULL,49118411324,767475176,11991799,14),(144391,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144391,33.91,0.8,60.5,69231,75,NULL,'MAT, I','ESO 231- G 029',NULL,'1997ApJS..109..333W',1997,1,2.04,NULL,'G',0.000033,NULL,'15.16',0.29,'Scd',NULL,NULL,NULL,NULL,1,288.906125,-47.88639,0.261,NULL,51251309739,800801714,12512526,15.16),(144392,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144392,33.07,0.32,41.2,69231,85,NULL,'I, raw','ESO 231- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144393,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144393,33.07,0.32,41.2,69231,85,NULL,'I, inv','ESO 231- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144394,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144394,33.21,0.43,43.8,69231,75,NULL,'MAT, I, raw','ESO 231- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144395,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144395,33.24,0.49,44.4,69231,75,NULL,'IR','ESO 231- G 029',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144396,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144396,33.26,0.43,45,69231,75,NULL,'MAT, I, inv','ESO 231- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144397,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144397,33.62,0.43,52.9,69231,75,NULL,'MAT, I, cor','ESO 231- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144398,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144398,33.65,0.54,53.7,69231,NULL,NULL,NULL,'ESO 231- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144399,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144399,33.69,0.2,54.7,69231,74.4,NULL,NULL,'ESO 231- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144400,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144400,33.73,NULL,55.8,69231,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 231- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144401,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144401,33.76,NULL,56.4,69231,NULL,NULL,'Dipole','ESO 231- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144402,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144402,33.77,NULL,56.7,69231,NULL,NULL,'Dipole + Quadrupole','ESO 231- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144403,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144403,33.81,NULL,57.8,69231,NULL,NULL,NULL,'ESO 231- G 029',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144404,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144404,33.95,0.47,61.6,69231,NULL,NULL,'Malmquist cor.','ESO 231- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144405,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144405,35.93,0.65,154,69232,70,NULL,NULL,'2MASX J19154577-7653080',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,288.940958333,-76.88553,0.325,NULL,48477404625,757459447,11835303,15.2),(144406,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144406,32.58,0.43,32.8,69233,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11422',NULL,'2014MNRAS.444..527S',2014,1,1.23,NULL,'G',NULL,NULL,'15.3',0.15,'Scd',NULL,NULL,NULL,NULL,1,288.942583,43.44072,0.301,NULL,55013329875,859583279,13430988,15.3),(144407,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144407,34.21,0.49,69.4,69233,75,NULL,'IR','UGC 11422',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144408,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144408,34.44,NULL,77.1,69233,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144409,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144409,34.46,NULL,78,69233,NULL,NULL,'Dipole + Quadrupole','UGC 11422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144410,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144410,34.47,NULL,78.5,69233,NULL,NULL,'Dipole','UGC 11422',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144411,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144411,34.59,NULL,82.9,69233,NULL,NULL,NULL,'UGC 11422',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144412,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144412,33.06,0.54,40.9,69234,NULL,NULL,NULL,'IC 4840',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.4b',0.7,'SAB(rs)a:','Group member',NULL,NULL,NULL,1,288.965375,-56.20908,0.205,NULL,49084692449,766948319,11983567,14.4),(144413,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144413,33.1,0.2,41.7,69234,74.4,NULL,NULL,'IC 4840',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144414,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144414,33.41,0.46,48.2,69234,NULL,NULL,'Malmquist cor.','IC 4840',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144415,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144415,36.99,0.65,250,69235,70,NULL,NULL,'2MASX J19161028-1519288',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.042875,-15.32464,0.681,NULL,48296185477,754627898,11791060,15.9),(144416,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144416,30.23,0.8,11.1,69236,75,NULL,NULL,'ESO 141- G 042',NULL,'1988NBGC.C....0000T',1988,1,3,'Confused HIPASS source','G',0.000007,NULL,'14.44',0.5,'SB(s)m',NULL,NULL,NULL,NULL,1,289.0502083,-62.36175,0.181,NULL,48954691443,764917053,11951828,14.44),(144417,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144417,34.44,0.46,77.3,69237,70,NULL,NULL,'NGC 6768',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00008,NULL,'13.5',1.1,'E4',NULL,NULL,NULL,NULL,1,289.135833,-40.20917,0.373,NULL,51234181668,800534088,12508345,13.5),(144418,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144418,27.83,0.06,3.68,69238,NULL,NULL,NULL,'NGC 6789',NULL,'2012MNRAS.423..406G',2012,1,1.3,NULL,'G',0.00003,NULL,'13.76',1,'Im','in a pair',NULL,NULL,NULL,1,289.175667,63.97147,0.325,NULL,53064670490,829135476,12955241,13.76),(144419,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144419,27.85,0.04,3.72,69238,NULL,NULL,NULL,'NGC 6789',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144420,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144420,26.6,0.1,2.1,69238,NULL,NULL,NULL,'NGC 6789',NULL,'2000A&AS..142..347D',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144421,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144421,27.75,0.1,3.55,69238,74.4,NULL,NULL,'NGC 6789',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144422,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144422,27.8,0.13,3.6,69238,NULL,NULL,'I','NGC 6789',NULL,'2001ApJ...551L.135D',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144423,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144423,27.78,0.12,3.6,69238,NULL,NULL,NULL,'NGC 6789',NULL,'2014A&A...566A..71L',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144424,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144424,35.98,0.54,157,69239,70,NULL,NULL,'2MASX J19164773-2512079',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.8R',0.2,'E',NULL,NULL,NULL,NULL,1,289.1989583,-25.20217,0.545,NULL,47639367036,744365109,11630704,14.8),(144425,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144425,34.87,0.8,94.1,69240,75,NULL,'MAT, I','ESO 184- G 051',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000027,NULL,'14.22',0.7,'SAB(s)bc:',NULL,NULL,NULL,NULL,1,289.236708333,-53.70067,0.257,NULL,49077456983,766835265,11981801,14.22),(144426,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144426,34.2,0.43,69.2,69240,75,NULL,'MAT, I, raw','ESO 184- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144427,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144427,34.33,0.43,73.5,69240,75,NULL,'MAT, I, cor','ESO 184- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144428,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144428,34.38,0.39,75.2,69240,NULL,NULL,'Malmquist cor.','ESO 184- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144429,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144429,34.41,0.32,76.2,69240,85,NULL,'I, raw','ESO 184- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144430,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144430,34.49,0.32,78.9,69240,85,NULL,'I, inv','ESO 184- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144431,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144431,34.5,0.43,79.5,69240,75,NULL,'MAT, I, inv','ESO 184- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144432,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144432,34.56,0.47,81.8,69240,NULL,NULL,'H','ESO 184- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144433,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144433,34.62,0.46,83.8,69240,NULL,NULL,'J','ESO 184- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144434,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144434,34.7,0.45,87.2,69240,NULL,NULL,'K','ESO 184- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144435,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144435,34.77,0.33,90.1,69240,NULL,NULL,NULL,'ESO 184- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144436,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144436,34.81,0.2,91.6,69240,74.4,NULL,NULL,'ESO 184- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144437,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144437,34.84,0.4,93,69240,NULL,NULL,'mean','ESO 184- G 051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144438,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144438,36.02,0.55,160,69241,70,NULL,NULL,'2MASX J19170067-7049537',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,289.252833333,-70.83164,0.209,NULL,49250222495,769534726,12023980,16.4),(144439,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144439,35.59,0.56,131,69242,70,NULL,NULL,'2MASX J19170949-5905489',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.4b',0.4,NULL,NULL,NULL,NULL,NULL,1,289.2895,-59.09686,0.193,NULL,49061911223,766592362,11978005,16.4),(144440,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144440,34.21,0.4,69.4,69243,NULL,NULL,'mean','ESO 282- G 033',NULL,'2007A&A...465...71T',2007,1,1.69,NULL,'G',0.000033,NULL,'15.50',0.22,'Sbc',NULL,NULL,NULL,NULL,1,289.308667,-46.68875,0.269,NULL,51247989694,800749838,12511716,15.5),(144441,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144441,34.22,0.49,69.7,69243,75,NULL,'IR','ESO 282- G 033',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144442,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144442,34.33,0.47,73.6,69243,NULL,NULL,'H','ESO 282- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144443,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144443,34.48,0.45,78.7,69243,NULL,NULL,'K','ESO 282- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144444,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144444,34.5,0.34,79.6,69243,NULL,NULL,'Malmquist cor.','ESO 282- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144445,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144445,34.63,0.32,84.5,69243,NULL,NULL,NULL,'ESO 282- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144446,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144446,34.67,0.2,85.9,69243,74.4,NULL,NULL,'ESO 282- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144447,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144447,34.88,NULL,94.6,69243,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 282- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144448,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144448,34.89,NULL,95.1,69243,NULL,NULL,'Dipole + Quadrupole','ESO 282- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144449,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144449,34.9,NULL,95.5,69243,NULL,NULL,'Dipole','ESO 282- G 033',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144450,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144450,37,0.68,251,69244,70,NULL,NULL,'2MASX J19171677-1904530',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.3199583,-19.08136,0.513,NULL,48100764383,751574443,11743350,15.6),(144451,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144451,35.12,0.57,106,69245,NULL,NULL,'Malmquist cor.','ESO 397- G 012',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.83',0.4,'Sc:',NULL,NULL,NULL,NULL,1,289.346417,-36.29506,0.349,NULL,51168450753,799507043,12492297,14.83),(144452,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144452,35.43,0.5,122,69245,NULL,NULL,NULL,'ESO 397- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144453,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144453,35.47,0.2,124,69245,74.4,NULL,NULL,'ESO 397- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144454,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144454,35.02,0.64,101,69246,70,NULL,NULL,'2MASX J19172980-2120011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.374125,-21.33369,0.581,NULL,48088799859,751387497,11740429,15),(144455,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144455,35.8,0.7,144,69247,70,NULL,NULL,'2MASX J19173192-7308436',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,289.382917,-73.14544,0.209,NULL,48510559787,757977496,11843398,16.8),(144456,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144456,39.33,NULL,646,69248,NULL,NULL,NULL,'PMN J1917-1921',0.137,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.001,NULL,'15.4R',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,289.43675,-19.35878,0.509,NULL,48103985983,751624780,11744137,15.4),(144457,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144457,36.17,0.56,171,69249,70,NULL,NULL,'2MASX J19174962-1618400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.456833,-16.31108,0.469,NULL,48296718582,754636227,11791191,15.3),(144458,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144458,36.29,0.55,181,69250,70,NULL,NULL,'2MASX J19175143-6332295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,289.4645,-63.54147,0.157,NULL,48953156932,764893077,11951454,16.7),(144459,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144459,34.13,0.36,66.9,69251,NULL,NULL,NULL,'ESO 459- G 011',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.72',0.7,'Sb',NULL,NULL,NULL,NULL,1,289.498667,-30.20483,0.481,NULL,47618309571,744036087,11625563,13.72),(144460,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144460,34.17,0.2,68.2,69251,74.4,NULL,NULL,'ESO 459- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144461,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144461,34.48,0.31,78.9,69251,NULL,NULL,'Malmquist cor.','ESO 459- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144462,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144462,33.3,0.43,45.8,69252,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11426',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.000023,NULL,'14.4',0.7,'S',NULL,NULL,NULL,NULL,1,289.5902083,34.83706,0.917,NULL,54877381460,857459085,13397798,14.4),(144463,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144463,33.57,NULL,51.7,69252,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','UGC 11426',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144464,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144464,33.57,NULL,51.7,69252,70,NULL,'H, 2MASS, Malmquist corr.','UGC 11426',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144465,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144465,34.07,0.33,65.1,69252,70,NULL,'H, UH88/IRSF/2MASS','UGC 11426',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144466,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144466,34.07,0.33,65.1,69252,70,NULL,'H, 2MASS','UGC 11426',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144467,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144467,36.13,0.73,168,69253,70,NULL,NULL,'2MASX J19183210-2845055',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.6337083,-28.75158,0.445,NULL,47638841975,744356905,11630576,15.9),(144468,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144468,34.26,0.8,71.3,69254,75,NULL,'MAT, I','ESO 337- G 022',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.50',1.3,'Sb-c',NULL,NULL,NULL,NULL,1,289.679,-38.34192,0.409,NULL,51235245673,800550713,12508604,13.5),(144469,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144469,34.17,0.32,68.2,69254,85,NULL,'I, raw','ESO 337- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144470,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144470,34.2,0.32,69.1,69254,85,NULL,'I, inv','ESO 337- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144471,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144471,34.38,0.29,75.2,69254,NULL,NULL,NULL,'ESO 337- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144472,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144472,34.42,0.2,76.6,69254,74.4,NULL,NULL,'ESO 337- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144473,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144473,34.43,0.43,77.1,69254,75,NULL,'MAT, I, raw','ESO 337- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144474,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144474,34.52,0.28,80.1,69254,NULL,NULL,'Malmquist cor.','ESO 337- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144475,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144475,34.59,0.43,82.8,69254,75,NULL,'MAT, I, cor','ESO 337- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144476,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144476,34.6,0.43,83.3,69254,75,NULL,'MAT, I, inv','ESO 337- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144477,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144477,33.03,0.8,40.4,69255,75,NULL,'MAT, I','IC 4844',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.01',1,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,289.761,-56.02717,0.193,NULL,49084978993,766952796,11983637,14.01),(144478,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144478,33.21,0.32,43.9,69255,85,NULL,'I, raw','IC 4844',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144479,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144479,33.25,0.32,44.7,69255,85,NULL,'I, inv','IC 4844',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144480,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144480,33.35,0.43,46.7,69255,75,NULL,'MAT, I, raw','IC 4844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144481,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144481,33.37,0.4,47.3,69255,NULL,NULL,'mean','IC 4844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144482,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144482,33.53,0.43,50.9,69255,75,NULL,'MAT, I, inv','IC 4844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144483,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144483,33.56,0.47,51.6,69255,NULL,NULL,'H','IC 4844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144484,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144484,33.63,0.43,53.2,69255,75,NULL,'MAT, I, cor','IC 4844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144485,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144485,33.67,0.45,54.2,69255,NULL,NULL,'K','IC 4844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144486,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144486,33.69,0.46,54.8,69255,NULL,NULL,'J','IC 4844',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144487,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144487,33.93,0.37,61.1,69255,NULL,NULL,'Malmquist cor.','IC 4844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144488,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144488,33.95,0.36,61.7,69255,NULL,NULL,NULL,'IC 4844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144489,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144489,33.99,0.2,62.8,69255,74.4,NULL,NULL,'IC 4844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144490,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144490,33.81,0.4,57.8,69256,75,NULL,'Edat, raw','IC 4842',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000057,NULL,'13.43',0.9,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,289.851958333,-60.64425,0.169,NULL,49070892913,766732701,11980198,13.43),(144491,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144491,33.85,0.4,58.8,69256,75,NULL,'Edat, cor','IC 4842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144492,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144492,32.94,0.44,38.7,69256,95,NULL,'Weighted Mean','IC 4842',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144493,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144493,33.18,0.63,43.3,69256,95,NULL,'Michard 1979b, c','IC 4842',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144494,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144494,33.5,0.46,50.1,69256,95,NULL,'Michard 1979a','IC 4842',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144495,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144495,33.79,0.51,57.3,69256,70,NULL,NULL,'IC 4842',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144496,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144496,33.17,0.45,43,69256,NULL,NULL,'K','IC 4842',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144497,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144497,33.71,0.4,55.1,69256,NULL,NULL,'mean','IC 4842',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144498,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144498,36.2,0.7,174,69257,70,NULL,NULL,'2MASX J19192610-2010023',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,289.8587917,-20.16742,0.421,NULL,48102317732,751598714,11743729,15.4),(144499,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144499,34.43,0.51,76.7,69258,NULL,NULL,NULL,'ESO 397- G 016',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.65',1,'Sb-c',NULL,NULL,NULL,NULL,1,289.9087083,-35.72433,0.337,NULL,51169380172,799521565,12492524,14.65),(144500,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144500,34.47,0.2,78.3,69258,74.4,NULL,NULL,'ESO 397- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144501,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144501,34.63,0.47,84.2,69258,NULL,NULL,'Malmquist cor.','ESO 397- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144502,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144502,37.47,NULL,312,69259,65,NULL,'L = 10e57 photons/s','2B 920406',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,289.908333,-57.68972,0.201,NULL,49119241123,767488142,11992002,NULL),(144503,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144503,40.54,NULL,1280,69259,65,NULL,'L = 2 x 10e58 photons/s','2B 920406',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144504,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144504,35.57,0.6,130,69260,70,NULL,NULL,'2MASX J19193950-1356541',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.2R',0.2,NULL,NULL,NULL,NULL,NULL,1,289.914625,-13.94833,0.977,NULL,48298097760,754657777,11791527,14.2),(144505,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144505,34.9,0.4,95.6,69261,NULL,NULL,'mean','ESO 459- G 012',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'13.19',0.4,'S              HII',NULL,NULL,NULL,NULL,1,289.961875,-28.81292,0.445,NULL,47638661668,744354088,11630532,13.19),(144506,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144506,35.07,0.47,103,69261,NULL,NULL,'H','ESO 459- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144507,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144507,35.1,0.45,105,69261,NULL,NULL,'K','ESO 459- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144508,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144508,35.34,0.6,117,69261,NULL,NULL,'Malmquist cor.','ESO 459- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144509,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144509,35.7,0.5,138,69261,NULL,NULL,NULL,'ESO 459- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144510,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144510,35.74,0.2,141,69261,74.4,NULL,NULL,'ESO 459- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144511,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144511,34.71,0.55,87.5,69262,70,NULL,NULL,'FAIRALL 0056',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000057,NULL,'14.2R',NULL,'Bright nucleus',NULL,NULL,NULL,NULL,1,290.00775,-60.81875,0.169,NULL,49070921997,766733156,11980205,14.2),(144512,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144512,34.54,0.69,80.7,69263,70,NULL,NULL,'ESO 184- G 057',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.00',0.2,'S0',NULL,NULL,NULL,NULL,1,290.098041667,-54.34619,0.229,NULL,49076367560,766818243,11981535,15),(144513,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144513,36.64,0.59,213,69264,70,NULL,NULL,'2MASX J19202879-6330058',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.120083,-63.50169,0.181,NULL,48953292771,764895199,11951487,17.2),(144514,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144514,35.86,0.73,149,69265,70,NULL,NULL,'2MASX J19204479-6011029',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.186667,-60.18408,0.165,NULL,49073102253,766767222,11980737,16),(144515,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144515,35.15,0.61,107,69266,70,NULL,NULL,'2MASX J19204628-1355094',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,290.192791667,-13.91931,0.909,NULL,48300906431,754701662,11792213,14.3),(144516,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144516,35.6,0.5,132,69267,70,NULL,NULL,'2MASX J19205449-1203324',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.7R',0.2,NULL,NULL,NULL,NULL,NULL,1,290.2270417,-12.059,1.077,NULL,48291574311,754555848,11789935,14.7),(144517,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144517,33.37,0.69,47.2,69268,100,NULL,'mid-IR','NGC 6792',NULL,'2013ApJ...771...88L',2013,1,2.2,NULL,'G',0.000017,NULL,'12.9',1.3,'SBb','in a pair',NULL,NULL,NULL,1,290.2392083,43.1325,0.421,NULL,55016629558,859634836,13431794,12.9),(144518,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144518,33.99,0.38,62.8,69268,NULL,NULL,NULL,'NGC 6792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144519,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144519,34.02,0.38,63.6,69268,NULL,NULL,'Malmquist cor.','NGC 6792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144520,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144520,34.08,0.46,65.6,69268,NULL,NULL,'J','NGC 6792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144521,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144521,34.09,0.4,65.8,69268,NULL,NULL,'mean','NGC 6792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144522,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144522,34.14,0.47,67.2,69268,NULL,NULL,'H','NGC 6792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144523,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144523,34.14,0.45,67.4,69268,NULL,NULL,'K','NGC 6792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144524,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144524,34.17,0.2,68.2,69268,74.4,NULL,NULL,'NGC 6792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144525,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144525,34.39,0.43,75.6,69268,75,NULL,'3.6 micron, color corrected','NGC 6792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144526,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144526,34.62,0.43,84.1,69268,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144527,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144527,35.12,NULL,106,69269,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2247',NULL,'2010Ap&SS.325..163P',2010,1,1.16,NULL,'G',0.00009,NULL,'16.8',0.08,'Sd',NULL,NULL,NULL,NULL,1,290.26,54.815,0.457,NULL,53131544281,830180379,12971568,16.8),(144528,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144528,35.12,NULL,106,69269,NULL,NULL,'Dipole','FGC 2247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144529,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144529,35.13,NULL,106,69269,NULL,NULL,'Dipole + Quadrupole','FGC 2247',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144530,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144530,35.13,NULL,106,69269,NULL,NULL,NULL,'FGC 2247',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144531,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144531,34.9,0.8,95.3,69270,75,NULL,'MAT, I','ESO 459- G 014',NULL,'1997ApJS..109..333W',1997,1,1.6,'6dF DR1 has z = 0.021207.','G',0.000033,NULL,'13.79',0.4,'S...',NULL,NULL,NULL,NULL,1,290.287875,-28.90397,0.477,NULL,47635075526,744298055,11629657,13.79),(144532,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144532,33.71,0.43,55.2,69270,75,NULL,'MAT, I, raw','ESO 459- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144533,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144533,33.71,0.32,55.3,69270,85,NULL,'I, raw','ESO 459- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144534,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144534,33.73,0.32,55.7,69270,85,NULL,'I, inv','ESO 459- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144535,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144535,33.81,0.43,57.9,69270,75,NULL,'MAT, I, inv','ESO 459- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144536,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144536,33.99,0.43,62.8,69270,NULL,NULL,NULL,'ESO 459- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144537,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144537,33.99,0.2,62.8,69270,74.4,NULL,NULL,'ESO 459- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144538,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144538,34.28,0.43,71.8,69270,75,NULL,'MAT, I, cor','ESO 459- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144539,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144539,34.42,0.35,76.6,69270,NULL,NULL,'Malmquist cor.','ESO 459- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144540,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144540,34.99,0.57,99.8,69271,70,NULL,NULL,'2MASX J19210936-5848383',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00009,NULL,'15.5b',0.8,'SA0/a pec',NULL,NULL,NULL,NULL,1,290.289083333,-58.81078,0.185,NULL,49062513606,766601775,11978152,15.5),(144541,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144541,32.44,0.4,30.7,69272,NULL,NULL,'mean','NGC 6796',NULL,'2007A&A...465...71T',2007,1,1.9,'Misidentified as NGC 6797 in CGCG.','G',0.00002,NULL,'13.48',0.4,'Sbc: sp',NULL,NULL,NULL,NULL,1,290.378625,61.14489,0.381,NULL,53098815280,829668988,12963577,13.48),(144542,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144542,32.68,0.4,34.4,69272,75,NULL,NULL,'NGC 6796',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144543,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144543,32.7,0.47,34.6,69272,NULL,NULL,'H','NGC 6796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144544,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144544,32.7,0.46,34.7,69272,NULL,NULL,'J','NGC 6796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144545,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144545,32.75,0.45,35.4,69272,NULL,NULL,'K','NGC 6796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144546,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144546,32.86,0.43,37.3,69272,75,NULL,'3.6 micron, color corrected','NGC 6796',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144547,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144547,32.86,0.43,37.4,69272,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6796',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144548,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144548,32.92,0.2,38.4,69272,74.4,NULL,NULL,'NGC 6796',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144549,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144549,33.07,0.49,41.1,69272,75,NULL,'IR','NGC 6796',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144550,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144550,36.78,0.77,227,69273,70,NULL,NULL,'2MASX J19213174-1153170',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,290.382166667,-11.88814,1.069,NULL,48160650737,752510167,11757971,15.4),(144551,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144551,35.4,0.52,120,69274,NULL,NULL,'Malmquist cor.','ESO 525- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.90',0.4,'S...',NULL,NULL,NULL,NULL,1,290.421375,-25.05025,0.557,NULL,47584894943,743513983,11617405,14.9),(144552,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144552,35.42,0.52,121,69274,NULL,NULL,NULL,'ESO 525- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144553,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144553,35.46,0.2,124,69274,74.4,NULL,NULL,'ESO 525- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144554,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144554,36.51,0.83,201,69275,70,NULL,NULL,'2MASX J19215689-1943549',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,290.4870417,-19.73189,0.397,NULL,48101610255,751587660,11743557,15.9),(144555,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144555,33.78,0.49,57.1,69276,70,NULL,NULL,'2MASX J19215935-6002349',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000067,NULL,'14.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.4975,-60.043,0.161,NULL,49072697528,766760898,11980639,14.7),(144556,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144556,35.54,0.52,128,69277,70,NULL,NULL,'2MASX J19220548-1138420',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.9R',0.2,NULL,NULL,NULL,NULL,NULL,1,290.522875,-11.64506,1.033,NULL,48160949491,752514835,11758044,14.9),(144557,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144557,35.73,0.76,140,69278,70,NULL,NULL,'2MASX J19221167-1900559',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,290.548583,-19.01553,0.381,NULL,48104394962,751631171,11744237,15.2),(144558,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144558,32.74,0.8,35.3,69279,75,NULL,'MAT, I','ESO 184- G 060',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.75',1,'(R\')SAB(rs)d:',NULL,NULL,NULL,NULL,1,290.672917,-54.58611,0.157,NULL,49075602849,766806294,11981348,14.75),(144559,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144559,31.73,0.32,22.2,69279,85,NULL,'I, inv','ESO 184- G 060',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144560,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144560,31.77,0.32,22.6,69279,85,NULL,'I, raw','ESO 184- G 060',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144561,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144561,32.3,0.43,28.9,69279,75,NULL,'MAT, I, inv','ESO 184- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144562,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144562,32.35,0.43,29.6,69279,75,NULL,'MAT, I, raw','ESO 184- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144563,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144563,32.76,0.43,35.6,69279,75,NULL,'MAT, I, cor','ESO 184- G 060',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144564,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144564,34.78,0.57,90.3,69280,70,NULL,NULL,'2MASX J19230788-6258131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.78275,-62.97036,0.173,NULL,48940479222,764694987,11948359,15.6),(144565,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144565,36.02,0.66,160,69281,70,NULL,NULL,'ESO 593- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.3R',0.5,'Sb:',NULL,NULL,NULL,NULL,1,290.785958333,-17.7235,0.401,NULL,48074608983,751165765,11736965,15.3),(144566,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144566,36.99,0.59,250,69282,70,NULL,NULL,'2MASX J19233275-6427439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,290.886291667,-64.46217,0.209,NULL,48948637167,764822455,11950350,17.1),(144567,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144567,35.8,0.57,144,69283,70,NULL,NULL,'2MASX J19233782-1148031',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'13.9I',0.2,NULL,NULL,NULL,NULL,NULL,1,290.907541667,-11.80089,1.021,NULL,48160273210,752504268,11757879,13.9),(144568,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144568,32.87,0.8,37.6,69284,75,NULL,'MAT, I','ESO 184- G 063',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000024,NULL,'14.65',0.5,'Sb: pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,290.9175417,-55.06564,0.153,NULL,49082894955,766920233,11983128,14.65),(144569,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144569,32.83,0.45,36.8,69284,NULL,NULL,'K','ESO 184- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144570,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144570,32.86,0.47,37.3,69284,NULL,NULL,'H','ESO 184- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144571,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144571,33.06,0.46,40.9,69284,NULL,NULL,'J','ESO 184- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144572,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144572,33.11,0.43,41.8,69284,75,NULL,'MAT, I, raw','ESO 184- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144573,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144573,33.13,0.32,42.2,69284,85,NULL,'I, raw','ESO 184- G 063',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144574,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144574,33.15,0.32,42.7,69284,85,NULL,'I, inv','ESO 184- G 063',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144575,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144575,33.17,0.4,43.1,69284,NULL,NULL,'mean','ESO 184- G 063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144576,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144576,33.26,0.43,44.9,69284,75,NULL,'MAT, I, inv','ESO 184- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144577,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144577,33.43,0.47,48.6,69284,NULL,NULL,NULL,'ESO 184- G 063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144578,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144578,33.46,0.43,49.1,69284,75,NULL,'MAT, I, cor','ESO 184- G 063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144579,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144579,33.47,0.2,49.4,69284,74.4,NULL,NULL,'ESO 184- G 063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144580,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144580,33.62,0.43,52.9,69284,NULL,NULL,'Malmquist cor.','ESO 184- G 063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144581,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144581,33.45,NULL,49.1,69285,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11433',NULL,'2010Ap&SS.325..163P',2010,1,1.05,'Matthews et al. (2000A&AS..143..421M) give v = 2945 +/- 14 km/sec.','G',0.00001,NULL,'15.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,290.9587083,34.795,NULL,NULL,54874358830,857411856,13397060,15.6),(144582,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144582,33.47,0.49,49.5,69285,75,NULL,'IR','UGC 11433',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144583,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144583,33.48,NULL,49.6,69285,NULL,NULL,'Dipole + Quadrupole','UGC 11433',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144584,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144584,33.48,NULL,49.6,69285,NULL,NULL,'Dipole','UGC 11433',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144585,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144585,33.54,NULL,51.1,69285,NULL,NULL,NULL,'UGC 11433',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144586,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144586,33.58,0.43,51.9,69285,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11433',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144587,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144587,32.78,0.49,35.9,69286,75,NULL,'IR','UGC 11435',NULL,'2011yCatp016004901K',2011,1,2.41,NULL,'G',0.00003,NULL,'14.92',0.32,'Sc',NULL,NULL,NULL,NULL,1,290.9622917,55.98761,0.529,NULL,53124404278,830068816,12969825,14.92),(144588,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144588,32.79,0.43,36.2,69286,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11435',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144589,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144589,32.85,0.2,37.2,69286,74.4,NULL,NULL,'UGC 11435',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144590,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144590,32.87,0.43,37.4,69286,75,NULL,'3.6 micron, color corrected','UGC 11435',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144591,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144591,32.91,0.54,38.1,69286,NULL,NULL,NULL,'UGC 11435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144592,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144592,33.01,0.52,40,69286,NULL,NULL,'Malmquist cor.','UGC 11435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144593,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144593,33.18,0.47,43.3,69286,NULL,NULL,'H','UGC 11435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144594,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144594,33.32,NULL,46,69286,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144595,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144595,33.32,NULL,46.1,69286,NULL,NULL,'Dipole','UGC 11435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144596,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144596,33.32,NULL,46.2,69286,NULL,NULL,'Dipole + Quadrupole','UGC 11435',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144597,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144597,33.38,0.46,47.5,69286,NULL,NULL,'J','UGC 11435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144598,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144598,33.38,0.45,47.5,69286,NULL,NULL,'K','UGC 11435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144599,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144599,33.5,0.4,50,69286,NULL,NULL,'mean','UGC 11435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144600,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144600,34.1,0.8,66.1,69287,75,NULL,'MAT, I','ESO 397- G 018',NULL,'1997ApJS..109..333W',1997,1,2.41,NULL,'G',0.000023,NULL,'13.36',0.31,'Sc',NULL,NULL,NULL,NULL,1,291.0449583,-35.18131,0.321,NULL,51166840180,799481877,12491904,13.36),(144601,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144601,33.49,0.49,49.9,69287,75,NULL,'IR','ESO 397- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144602,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144602,33.71,0.32,55.2,69287,85,NULL,'I, raw','ESO 397- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144603,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144603,33.74,0.43,55.9,69287,75,NULL,'MAT, I, raw','ESO 397- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144604,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144604,33.74,0.32,55.9,69287,85,NULL,'I, inv','ESO 397- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144605,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144605,33.88,0.43,59.8,69287,75,NULL,'MAT, I, inv','ESO 397- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144606,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144606,33.9,0.52,60.3,69287,NULL,NULL,NULL,'ESO 397- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144607,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144607,34,NULL,63,69287,NULL,NULL,NULL,'ESO 397- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144608,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144608,34.03,0.43,63.9,69287,75,NULL,'3.6 micron, color + selection bias corrected','ESO 397- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144609,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144609,34.13,NULL,67.1,69287,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 397- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144610,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144610,34.14,NULL,67.3,69287,NULL,NULL,'Dipole','ESO 397- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144611,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144611,34.14,0.43,67.3,69287,75,NULL,'3.6 micron, color corrected','ESO 397- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144612,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144612,34.14,NULL,67.4,69287,NULL,NULL,'Dipole + Quadrupole','ESO 397- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144613,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144613,34.19,0.43,69,69287,75,NULL,'MAT, I, cor','ESO 397- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144614,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144614,34.26,0.2,71.1,69287,74.4,NULL,NULL,'ESO 397- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144615,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144615,34.29,0.43,72,69287,NULL,NULL,'Malmquist cor.','ESO 397- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144616,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144616,35.78,0.57,143,69288,70,NULL,NULL,'2MASX J19241364-1544354',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.056875,-15.74319,0.745,NULL,48295118799,754611231,11790800,14.7),(144617,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144617,35.41,0.63,121,69289,70,NULL,NULL,'2MASX J19241538-7518059',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.064083333,-75.30175,0.277,NULL,48505004878,757890701,11842042,15),(144618,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144618,36.59,0.59,208,69290,70,NULL,NULL,'2MASX J19241852-2457249',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.077167,-24.95692,0.501,NULL,47588361289,743568145,11618252,14.4),(144619,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144619,36.37,0.82,188,69291,70,NULL,NULL,'2MASX J19250338-6308115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.264167,-63.13658,0.205,NULL,48942501930,764726592,11948853,17.2),(144620,'FP','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144620,36.81,0.67,230,69292,70,NULL,NULL,'2MASX J19250396-5810557',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.2667083,-58.18217,0.185,NULL,49061071827,766579247,11977800,17.2),(144621,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144621,33.35,0.8,46.7,69293,75,NULL,'MAT, I','NGC 6776A',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.80',0.3,'SB(s)cd: sp','Pair member (points to parent)',NULL,NULL,NULL,1,291.272417,-63.68344,0.185,NULL,48941852999,764716453,11948694,14.8),(144622,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,'R',144622,33.14,0.49,42.4,69293,75,NULL,'IR','NGC 6776A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144623,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144623,33.23,0.32,44.3,69293,85,NULL,'I, raw','NGC 6776A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144624,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144624,33.25,0.32,44.6,69293,85,NULL,'I, inv','NGC 6776A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144625,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144625,33.51,0.43,50.4,69293,75,NULL,'MAT, I, raw','NGC 6776A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144626,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144626,33.62,0.43,53.1,69293,75,NULL,'MAT, I, inv','NGC 6776A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144627,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:03','1',NULL,NULL,144627,33.7,0.1,55.1,69293,NULL,NULL,NULL,'NGC 6776A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144628,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144628,33.72,0.43,55.4,69293,75,NULL,'MAT, I, cor','NGC 6776A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144629,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144629,32.77,0.4,35.8,69294,75,NULL,'Edat, raw','NGC 6776',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000043,NULL,'13.05',1.4,'E+ pec:     LINER/Sy','Pair member (points to parent)',NULL,NULL,NULL,1,291.3297917,-63.86017,0.185,NULL,48942096110,764720251,11948753,13.05),(144630,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144630,33.11,0.4,41.8,69294,75,NULL,'Edat, cor','NGC 6776',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144631,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144631,32.15,0.44,26.9,69294,95,NULL,'Weighted Mean','NGC 6776',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144632,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144632,32.26,0.63,28.3,69294,95,NULL,'Michard 1979b, c','NGC 6776',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144633,'Faber-Jackson','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144633,32.64,0.46,33.7,69294,95,NULL,'Michard 1979a','NGC 6776',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144634,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144634,34.06,0.45,64.8,69294,NULL,NULL,'K','NGC 6776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144635,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144635,34.36,0.4,74.4,69294,NULL,NULL,'mean','NGC 6776',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144636,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144636,34.52,0.49,80.3,69295,75,NULL,'IR','ESO 460- G 001',NULL,'2011yCatp016004901K',2011,1,1.5,'6dF final data release has z = 0.180722 +- 0.000183.','G',0.000033,NULL,'15.9b',0.3,'S...',NULL,NULL,NULL,NULL,1,291.345583,-32.21836,0.345,NULL,51165678210,799463722,12491620,15.9),(144637,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144637,34.94,0.45,97.5,69295,NULL,NULL,'Malmquist cor.','ESO 460- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144638,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144638,35.16,0.4,108,69295,NULL,NULL,NULL,'ESO 460- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144639,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144639,35.2,0.2,110,69295,74.4,NULL,NULL,'ESO 460- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144640,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144640,34.33,0.8,73.5,69296,75,NULL,'MAT, I','ESO 282- G 035',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000031,NULL,'15.26',1.7,'SA(s)c',NULL,NULL,NULL,NULL,1,291.3527917,-42.78561,0.289,NULL,51257029483,800891085,12513923,15.26),(144641,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144641,33.22,0.32,44.1,69296,85,NULL,'I, inv','ESO 282- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144642,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144642,33.23,0.32,44.3,69296,85,NULL,'I, raw','ESO 282- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144643,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144643,33.88,0.43,59.7,69296,75,NULL,'MAT, I, raw','ESO 282- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144644,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144644,33.93,0.43,61.1,69296,75,NULL,'MAT, I, inv','ESO 282- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144645,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144645,34.2,0.43,69.1,69296,75,NULL,'MAT, I, cor','ESO 282- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144646,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144646,36.56,0.68,205,69297,70,NULL,NULL,'2MASX J19252769-1810245',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.365333,-18.17353,0.405,NULL,48103294027,751613969,11743968,15.8),(144647,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144647,34.59,0.6,82.9,69298,NULL,NULL,'Malmquist cor.','IC 4849',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.53',0.5,'SA:(s)c',NULL,NULL,NULL,NULL,1,291.3999583,-62.93272,0.209,NULL,48942442450,764725663,11948838,14.53),(144648,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144648,35.1,0.48,105,69298,NULL,NULL,NULL,'IC 4849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144649,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144649,35.14,0.2,107,69298,74.4,NULL,NULL,'IC 4849',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144650,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144650,35.27,0.47,113,69298,NULL,NULL,'H','IC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144651,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144651,35.41,0.45,121,69298,NULL,NULL,'K','IC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144652,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144652,35.47,0.46,124,69298,NULL,NULL,'J','IC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144653,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144653,35.5,0.4,126,69298,NULL,NULL,'mean','IC 4849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144654,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144654,36.83,0.58,232,69299,70,NULL,NULL,'2MASX J19253882-1004422',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.1R',0.2,NULL,NULL,NULL,NULL,NULL,1,291.411791667,-10.0785,1.069,NULL,48167013906,752609592,11759524,16.1),(144655,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144655,36.82,0.52,231,69300,70,NULL,NULL,'2MASX J19255063-4520088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.461083,-45.33581,0.233,NULL,51248279012,800754359,12511786,14.9),(144656,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144656,37.17,0.67,271,69301,70,NULL,NULL,'2MASX J19260350-2633219',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.514625,-26.55606,0.469,NULL,47593809690,743653276,11619582,15.7),(144657,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144657,36.47,0.6,197,69302,70,NULL,NULL,'2MASX J19261335-6907212',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.5554583,-69.1225,0.305,NULL,49257569330,769649520,12025773,16.9),(144658,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144658,34.57,0.49,82.1,69303,70,NULL,NULL,'NGC 6784B',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000087,NULL,'14.84',0.9,'SAB0','Pair member (points to parent)',NULL,NULL,NULL,1,291.6499583,-65.61769,0.289,NULL,49231429459,769241085,12019391,14.84),(144659,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144659,35.5,0.7,126,69304,70,NULL,NULL,'2MASX J19263690-1338526',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.653833333,-13.64797,0.801,NULL,48287514385,754492412,11788943,15.8),(144660,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144660,33.67,0.2,54.2,69305,74.4,NULL,NULL,'UGC 11438',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00002,NULL,'14.4',0.9,'Scd:',NULL,NULL,NULL,NULL,1,291.655833,49.75844,0.333,NULL,54982488408,859101381,13423459,14.4),(144661,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144661,33.75,0.58,56.3,69305,NULL,NULL,NULL,'UGC 11438',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144662,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144662,33.91,0.54,60.6,69305,NULL,NULL,'Malmquist cor.','UGC 11438',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144663,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144663,32.85,0.8,37.1,69306,75,NULL,'MAT, I','NGC 6788',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000033,NULL,'12.86',0.9,'SA(s)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,291.7072917,-54.95131,0.149,NULL,49012545052,765821016,11965953,12.86),(144664,'Sosies','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144664,33.26,0.05,44.9,69306,NULL,NULL,NULL,'NGC 6788',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144665,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144665,32.9,0.46,37.9,69306,NULL,NULL,'J','NGC 6788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144666,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144666,32.92,0.47,38.4,69306,NULL,NULL,'H','NGC 6788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144667,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144667,32.96,0.45,39.1,69306,NULL,NULL,'K','NGC 6788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144668,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144668,33.11,0.4,42,69306,NULL,NULL,'mean','NGC 6788',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144669,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144669,33.24,0.43,44.5,69306,75,NULL,'MAT, I, raw','NGC 6788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144670,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144670,33.31,0.32,46,69306,85,NULL,'I, raw','NGC 6788',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144671,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144671,33.37,0.39,47.3,69306,NULL,NULL,NULL,'NGC 6788',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144672,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144672,33.39,0.39,47.6,69306,NULL,NULL,'Malmquist cor.','NGC 6788',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144673,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144673,33.4,0.32,47.8,69306,85,NULL,'I, inv','NGC 6788',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144674,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144674,33.42,0.2,48.3,69306,74.4,NULL,NULL,'NGC 6788',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144675,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144675,33.56,0.43,51.6,69306,75,NULL,'MAT, I, cor','NGC 6788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144676,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144676,33.59,0.43,52.2,69306,75,NULL,'MAT, I, inv','NGC 6788',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144677,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144677,35.58,0.65,131,69307,70,NULL,NULL,'2MASX J19265088-1147169',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.3R',0.2,'E',NULL,NULL,NULL,NULL,1,291.712083,-11.78803,0.849,NULL,48152953892,752389904,11756092,15.3),(144678,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144678,39,NULL,631,69308,NULL,NULL,'Min. z = 0.16','1FGL J1926.8+6153',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,291.725,61.884,0.233,NULL,53085056727,829454011,12960218,NULL),(144679,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144679,36.44,0.53,194,69309,70,NULL,NULL,'2MASX J19265863-6256546',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.744375,-62.9485,0.209,NULL,48942478176,764726221,11948847,15.9),(144680,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144680,34.95,0.59,97.9,69310,70,NULL,NULL,'2MASX J19272537-7941079',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.855333333,-79.68553,0.541,NULL,48553236716,758644323,11853817,16.2),(144681,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144681,37.55,0.63,324,69311,70,NULL,NULL,'2MASX J19272987-1004539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,291.8745,-10.08164,1.089,NULL,48167361353,752615021,11759609,16.1),(144682,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144682,33.21,0.43,43.9,69312,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6801',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000143,NULL,'14.62',0.7,'SAcd',NULL,NULL,NULL,NULL,1,291.899208333,54.37289,0.701,NULL,52984756682,827886823,12935731,14.62),(144683,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144683,33.23,0.2,44.3,69312,74.4,NULL,NULL,'NGC 6801',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144684,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144684,33.24,0.43,44.4,69312,75,NULL,'3.6 micron, color corrected','NGC 6801',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144685,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144685,33.26,0.47,44.9,69312,NULL,NULL,NULL,'NGC 6801',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144686,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144686,33.27,0.69,45.2,69312,100,NULL,'mid-IR','NGC 6801',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144687,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144687,33.34,0.45,46.6,69312,NULL,NULL,'Malmquist cor.','NGC 6801',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144688,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144688,33.77,0.47,56.8,69312,NULL,NULL,'H','NGC 6801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144689,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144689,33.84,0.4,58.6,69312,NULL,NULL,'mean','NGC 6801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144690,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144690,33.85,0.45,58.8,69312,NULL,NULL,'K','NGC 6801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144691,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144691,33.85,0.46,59,69312,NULL,NULL,'J','NGC 6801',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144692,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144692,35.6,0.49,132,69313,70,NULL,NULL,'2MASX J19273793-6925046',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,291.907917,-69.41786,0.281,NULL,49257599138,769649986,12025781,15.7),(144693,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144693,37.99,NULL,396,69314,65,NULL,'L = 10e57 photons/s','GRB 790331',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,291.999375,3.68011,NULL,NULL,54642232362,853784880,13340388,NULL),(144694,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144694,40.92,NULL,1530,69314,65,NULL,'L = 2 x 10e58 photons/s','GRB 790331',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144695,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144695,34.71,0.4,87.4,69315,NULL,NULL,'mean','NGC 6794',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00003,NULL,'13.9',1.5,'SA(rl)a',NULL,NULL,NULL,NULL,1,292.016166667,-38.91875,0.441,NULL,51232883733,800513808,12508028,13.9),(144696,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144696,34.9,0.47,95.7,69315,NULL,NULL,'H','NGC 6794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144697,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144697,34.94,0.45,97.2,69315,NULL,NULL,'K','NGC 6794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144698,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144698,34.95,0.46,97.7,69315,NULL,NULL,'J','NGC 6794',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144699,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144699,36.32,0.54,184,69316,70,NULL,NULL,'2MASX J19281270-2940252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.0529583,-29.67375,0.449,NULL,51142102862,799095357,12485864,14.7),(144700,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144700,35.37,0.46,118,69317,70,NULL,NULL,'ESO 460- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000067,NULL,'13.83',1.3,'E+4',NULL,NULL,NULL,NULL,1,292.070875,-29.529,0.465,NULL,51142018195,799094034,12485844,13.83),(144701,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144701,33.87,0.8,59.5,69318,75,NULL,'MAT, I','IC 4857',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'13.7',1.2,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,292.16325,-58.76792,0.193,NULL,49064767964,766636999,11978703,13.7),(144702,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144702,33.33,0.43,46.3,69318,75,NULL,'MAT, I, raw','IC 4857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144703,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144703,33.44,0.32,48.7,69318,85,NULL,'I, raw','IC 4857',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144704,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144704,33.47,0.32,49.5,69318,85,NULL,'I, inv','IC 4857',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144705,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144705,33.49,0.43,50,69318,75,NULL,'MAT, I, inv','IC 4857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144706,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144706,33.61,0.43,52.6,69318,75,NULL,'MAT, I, cor','IC 4857',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144707,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144707,33.99,0.08,62.9,69318,NULL,NULL,NULL,'IC 4857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144708,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144708,34.01,0.4,63.3,69318,NULL,NULL,'mean','IC 4857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144709,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144709,34.11,0.47,66.5,69318,NULL,NULL,'H','IC 4857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144710,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144710,34.23,0.45,70.2,69318,NULL,NULL,'K','IC 4857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144711,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144711,34.24,0.46,70.5,69318,NULL,NULL,'J','IC 4857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144712,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144712,36.57,0.75,207,69319,70,NULL,NULL,'2MASX J19290073-7555180',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.2530417,-75.92167,0.285,NULL,48506860794,757919699,11842495,15.1),(144713,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144713,34.07,0.38,65.2,69320,NULL,NULL,'Malmquist cor.','IC 4861',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.50',0.3,'Sc:',NULL,NULL,NULL,NULL,1,292.319666667,-57.57497,0.181,NULL,49115549134,767430455,11991100,15.5),(144714,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144714,34.11,0.37,66.5,69320,NULL,NULL,NULL,'IC 4861',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144715,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144715,34.15,0.49,67.5,69320,75,NULL,'IR','IC 4861',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144716,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144716,34.15,0.2,67.6,69320,74.4,NULL,NULL,'IC 4861',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144717,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144717,35.37,0.49,118,69321,75,NULL,'IR','UGC 11447',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',NULL,NULL,'17.',0.12,'Sc',NULL,NULL,NULL,NULL,1,292.320916667,50.43386,0.441,NULL,54981307688,859082932,13423170,17),(144718,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144718,35.66,NULL,136,69321,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144719,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144719,35.68,NULL,137,69321,NULL,NULL,'Dipole + Quadrupole','UGC 11447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144720,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144720,35.69,NULL,137,69321,NULL,NULL,'Dipole','UGC 11447',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144721,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144721,35.7,NULL,138,69321,NULL,NULL,NULL,'UGC 11447',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144722,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144722,34.42,0.8,76.5,69322,75,NULL,'MAT, I','ESO 460- G 008',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000032,NULL,'14.37',0.7,'SAb:',NULL,NULL,NULL,NULL,1,292.334625,-32.19244,0.361,NULL,51197471709,799960495,12499382,14.37),(144723,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144723,33.94,0.43,61.5,69322,75,NULL,'MAT, I, raw','ESO 460- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144724,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144724,34.08,0.32,65.6,69322,85,NULL,'I, raw','ESO 460- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144725,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144725,34.12,0.43,66.7,69322,75,NULL,'MAT, I, inv','ESO 460- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144726,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144726,34.13,0.32,66.9,69322,85,NULL,'I, inv','ESO 460- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144727,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144727,34.37,0.43,74.9,69322,75,NULL,'MAT, I, cor','ESO 460- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144728,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144728,37.02,0.67,254,69323,70,NULL,NULL,'2MASX J19292798-6903228',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,292.366625,-69.05639,0.305,NULL,49257889751,769654527,12025851,16.9),(144729,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144729,37.04,0.78,256,69324,70,NULL,NULL,'2MASX J19294638-8412199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,292.442375,-84.2055,0.469,NULL,48375945091,755874142,11810533,17.3),(144730,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144730,35.9,0.51,151,69325,70,NULL,NULL,'2MASX J19295118-6238385',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,292.4630417,-62.64411,0.225,NULL,48942909254,764732957,11948952,16),(144731,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144731,33.98,0.46,62.4,69326,NULL,NULL,'J','UGC 11455',NULL,'2007A&A...465...71T',2007,1,2.74,NULL,'G',0.000053,NULL,'15.00',0.37,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,292.484417,72.11281,0.457,NULL,53591521255,837367519,13083867,15),(144732,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144732,33.98,0.47,62.5,69326,NULL,NULL,'H','UGC 11455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144733,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144733,34.07,0.45,65.3,69326,NULL,NULL,'K','UGC 11455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144734,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144734,34.08,0.49,65.5,69326,75,NULL,'IR','UGC 11455',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144735,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144735,34.28,0.4,71.7,69326,NULL,NULL,'mean','UGC 11455',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144736,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144736,34.66,NULL,85.6,69326,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144737,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144737,34.67,NULL,85.8,69326,NULL,NULL,'Dipole + Quadrupole','UGC 11455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144738,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144738,34.67,NULL,85.9,69326,NULL,NULL,'Dipole','UGC 11455',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144739,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144739,34.67,0.51,86,69326,NULL,NULL,'Malmquist cor.','UGC 11455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144740,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144740,34.69,0.43,86.5,69326,75,NULL,'3.6 micron, color corrected','UGC 11455',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144741,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144741,34.7,0.2,87.1,69326,74.4,NULL,NULL,'UGC 11455',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144742,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144742,34.79,0.43,90.7,69326,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11455',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144743,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144743,34.88,0.46,94.6,69326,NULL,NULL,NULL,'UGC 11455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144744,'Brightest Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144744,25.21,NULL,1.1,69327,NULL,NULL,'PHOTOGRAPHIC','Sagittarius Dwarf Irregular',NULL,'1978MNRAS.183P..97L',1978,1,2.9,NULL,'G',0.000003,NULL,'14.1B',2.1,'IB(s)m:','Group member',NULL,NULL,NULL,1,292.49825,-17.68092,0.549,0,48079550362,751242974,11738171,14.1),(144745,'Brightest Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144745,25.3,NULL,1.15,69327,NULL,NULL,'Blue','Sagittarius Dwarf Irregular',NULL,'1988ASPC....4...75C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144746,'Carbon Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144746,25,NULL,1,69327,NULL,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'1988ASPC....4...75C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144747,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144747,25.11,NULL,1.05,69327,NULL,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144748,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144748,24.94,NULL,0.971,69327,NULL,NULL,'I, M RC(I) = -0.50 mag','Sagittarius Dwarf Irregular',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144749,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144749,24.95,NULL,0.977,69327,NULL,NULL,'V, M RC(V) = +0.73 mag','Sagittarius Dwarf Irregular',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144750,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144750,25.09,0.1,1.04,69327,NULL,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144751,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144751,25.13,0.2,1.06,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'1999A&A...352..363K',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144752,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144752,25.14,0.18,1.07,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'2002A&A...384..393M',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144753,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144753,25.16,0.11,1.08,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'2014A&A...570A..78B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144754,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144754,25.17,0.1,1.08,69327,74.4,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144755,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144755,25.36,0.18,1.18,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'2000AJ....119..777L',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144756,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144756,25.36,NULL,1.18,69327,NULL,NULL,'I, M TRGB(I) = -4.05 mag','Sagittarius Dwarf Irregular',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144757,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144757,25.4,NULL,1.2,69327,NULL,NULL,'I','Sagittarius Dwarf Irregular',NULL,'1988ASPC....4...75C',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144758,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144758,24.23,0.8,0.7,69327,75,NULL,NULL,'Sagittarius Dwarf Irregular',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144759,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144759,36.7,0.77,219,69328,70,NULL,NULL,'2MASX J19300317-2249458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.51325,-22.82942,0.349,NULL,48061728327,750964505,11733820,15.8),(144760,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144760,37.54,0.6,323,69329,70,NULL,NULL,'2MASX J19300568-7034439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,292.523833,-70.57886,0.281,NULL,49251228574,769550446,12024225,16.9),(144761,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144761,36.51,0.53,201,69330,70,NULL,NULL,'2MASX J19302777-2750566',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.615791667,-27.84897,0.501,NULL,47590318257,743598722,11618730,15.4),(144762,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144762,34.15,0.8,67.7,69331,75,NULL,'MAT, I','ESO 184- G 074',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000026,NULL,'14.79',0.4,'SAB(rl)a:',NULL,NULL,NULL,NULL,1,292.627375,-57.28386,0.145,NULL,49081991264,766906113,11982908,14.79),(144763,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144763,34.03,0.32,63.9,69331,85,NULL,'I, raw','ESO 184- G 074',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144764,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144764,34.05,0.43,64.5,69331,75,NULL,'MAT, I, raw','ESO 184- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144765,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144765,34.08,0.32,65.5,69331,85,NULL,'I, inv','ESO 184- G 074',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144766,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144766,34.11,0.43,66.5,69331,75,NULL,'MAT, I, cor','ESO 184- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144767,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144767,34.16,0.42,67.8,69331,NULL,NULL,'Malmquist cor.','ESO 184- G 074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144768,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144768,34.23,0.4,70.2,69331,NULL,NULL,'mean','ESO 184- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144769,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144769,34.27,0.49,71.5,69331,75,NULL,'IR','ESO 184- G 074',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144770,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144770,34.29,0.43,72,69331,75,NULL,'MAT, I, inv','ESO 184- G 074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144771,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144771,34.35,0.47,74.1,69331,NULL,NULL,'H','ESO 184- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144772,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144772,34.46,0.45,77.9,69331,NULL,NULL,'K','ESO 184- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144773,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144773,34.52,0.46,80.1,69331,NULL,NULL,'J','ESO 184- G 074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144774,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144774,34.53,0.36,80.4,69331,NULL,NULL,NULL,'ESO 184- G 074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144775,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144775,34.57,0.2,82,69331,74.4,NULL,NULL,'ESO 184- G 074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144776,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144776,33.02,0.68,40.1,69332,NULL,NULL,NULL,'UGC 11448',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000017,NULL,'16.0',0.8,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,292.63825,35.77681,NULL,NULL,54873442019,857397531,13396836,16),(144777,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144777,33.23,0.2,44.3,69332,74.4,NULL,NULL,'UGC 11448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144778,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144778,33.26,0.61,44.8,69332,NULL,NULL,'Malmquist cor.','UGC 11448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144779,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144779,35.47,0.55,124,69333,70,NULL,NULL,'2MASX J19303773-5217259',NULL,'2014MNRAS.445.2677S',2014,1,60,NULL,'G',0.00015,NULL,'2.35',2.92,'IRAS FaintSrcCat(v2)',NULL,NULL,NULL,NULL,1,292.657208333,-52.29056,0.125,NULL,51103685614,798495087,12476485,2.35),(144780,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144780,32.34,0.49,29.4,69334,75,NULL,'IR','FGC 2253',NULL,'2011yCatp016004901K',2011,1,1.09,NULL,'G',NULL,NULL,'16.1',0.13,'Sc',NULL,NULL,NULL,NULL,1,292.693583,53.889,0.757,NULL,52985259207,827894675,12935854,16.1),(144781,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144781,32.67,0.43,34.1,69334,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2253',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144782,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144782,33.18,NULL,43.3,69334,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144783,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144783,33.19,NULL,43.5,69334,NULL,NULL,'Dipole + Quadrupole','FGC 2253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144784,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144784,33.22,NULL,44,69334,NULL,NULL,'Dipole','FGC 2253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144785,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144785,33.27,NULL,45,69334,NULL,NULL,NULL,'FGC 2253',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144786,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144786,33.41,0.69,48.1,69335,100,NULL,'mid-IR','IC 1302',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000027,NULL,'14.1',0.5,'SAB(s)c?','in a pair',NULL,NULL,NULL,1,292.720375,35.78525,NULL,NULL,54873506049,857398532,13396852,14.1),(144787,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144787,34.03,0.46,64.1,69335,NULL,NULL,'J','IC 1302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144788,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144788,34.03,0.47,64.1,69335,NULL,NULL,'H','IC 1302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144789,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144789,34.05,0.4,64.7,69335,NULL,NULL,'mean','IC 1302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144790,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144790,34.13,0.45,66.9,69335,NULL,NULL,'K','IC 1302',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144791,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144791,32.39,0.8,30.1,69336,75,NULL,'MAT, I','ESO 010- G 004',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.000022,NULL,'13.97',1.2,'SB(rs)d',NULL,NULL,NULL,NULL,1,292.758917,-86.01564,0.441,NULL,48329248320,755144505,11799132,13.97),(144792,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144792,32.09,0.32,26.2,69336,85,NULL,'I, raw','ESO 010- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144793,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144793,32.09,0.32,26.2,69336,85,NULL,'I, inv','ESO 010- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144794,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144794,32.4,0.43,30.2,69336,75,NULL,'MAT, I, raw','ESO 010- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144795,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144795,32.46,0.43,31,69336,75,NULL,'MAT, I, inv','ESO 010- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144796,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144796,32.57,0.39,32.7,69336,73,NULL,'opt','ESO 010- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144797,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144797,32.64,0.43,33.7,69336,75,NULL,'MAT, I, cor','ESO 010- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144798,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144798,32.69,0.46,34.5,69336,NULL,NULL,'Malmquist cor.','ESO 010- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144799,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144799,32.78,0.45,36,69336,NULL,NULL,NULL,'ESO 010- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144800,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144800,32.82,0.2,36.6,69336,74.4,NULL,NULL,'ESO 010- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144801,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144801,33.15,0.45,42.7,69337,NULL,NULL,'K','UGC 11453',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00002,NULL,'12.9B',1,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,292.783583,54.10217,0.669,NULL,52985277068,827894954,12935858,12.9),(144802,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144802,33.17,0.47,43,69337,NULL,NULL,'H','UGC 11453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144803,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144803,33.21,0.46,43.9,69337,NULL,NULL,'J','UGC 11453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144804,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144804,33.43,0.4,48.6,69337,NULL,NULL,'mean','UGC 11453',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144805,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144805,35.67,0.46,136,69338,NULL,NULL,'Malmquist cor.','ESO 398- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'13.98',0.2,'S',NULL,NULL,NULL,NULL,1,292.790333,-33.31528,0.353,NULL,51196960163,799952502,12499257,13.98),(144806,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144806,35.89,0.42,151,69338,NULL,NULL,NULL,'ESO 398- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144807,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144807,35.93,0.2,153,69338,74.4,NULL,NULL,'ESO 398- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144808,'SGRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144808,35,0.48,100,69339,NULL,NULL,NULL,'GRB 020603',NULL,'2006ApJ...640..849N',2006,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'IPN',NULL,NULL,NULL,NULL,1,292.816667,4.91667,NULL,NULL,54634319008,853661234,13338456,NULL),(144809,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144809,35.64,NULL,135,69340,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11451',NULL,'2010Ap&SS.325..163P',2010,1,1.43,'Double star superposed near nucleus.','G',NULL,NULL,'16.5',0.17,'Sc',NULL,NULL,NULL,NULL,1,292.8177083,42.19886,0.545,NULL,55028658329,859822786,13434731,16.5),(144810,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144810,35.66,NULL,135,69340,NULL,NULL,'Dipole + Quadrupole','UGC 11451',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144811,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144811,35.67,NULL,136,69340,NULL,NULL,'Dipole','UGC 11451',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144812,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144812,35.69,NULL,137,69340,NULL,NULL,NULL,'UGC 11451',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144813,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144813,35.85,0.49,148,69340,75,NULL,'IR','UGC 11451',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144814,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144814,35.24,0.63,112,69341,70,NULL,NULL,'2MASX J19311943-0601360',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.3R',0.2,'S',NULL,NULL,NULL,NULL,1,292.831,-6.02678,1.273,NULL,48171655963,752682124,11760658,15.3),(144815,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144815,33.31,0.69,46,69342,100,NULL,'mid-IR','IC 1303',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000057,NULL,'15.0',0.8,'SAc:','in a pair',NULL,NULL,NULL,1,292.87525,35.87661,NULL,NULL,54873338091,857395907,13396811,15),(144816,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144816,33.82,0.47,58.1,69342,NULL,NULL,'H','IC 1303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144817,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144817,33.85,0.45,58.9,69342,NULL,NULL,'K','IC 1303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144818,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144818,33.87,0.46,59.4,69342,NULL,NULL,'J','IC 1303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144819,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144819,33.96,0.4,62.1,69342,NULL,NULL,'mean','IC 1303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144820,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144820,32.91,0.8,38.2,69343,75,NULL,'MAT, I','ESO 184- G 077',NULL,'1997ApJS..109..333W',1997,1,2.02,NULL,'G',0.00003,NULL,'15.46',0.21,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,292.904375,-53.55189,0.137,NULL,49009476509,765773070,11965204,15.46),(144821,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144821,33.03,0.32,40.3,69343,85,NULL,'I, inv','ESO 184- G 077',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144822,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144822,33.04,0.32,40.5,69343,85,NULL,'I, raw','ESO 184- G 077',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144823,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144823,33.27,0.43,45.1,69343,75,NULL,'MAT, I, raw','ESO 184- G 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144824,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144824,33.29,0.43,45.6,69343,75,NULL,'MAT, I, inv','ESO 184- G 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144825,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144825,33.44,NULL,48.8,69343,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 184- G 077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144826,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144826,33.46,NULL,49.1,69343,NULL,NULL,'Dipole + Quadrupole','ESO 184- G 077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144827,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144827,33.46,NULL,49.2,69343,NULL,NULL,'Dipole','ESO 184- G 077',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144828,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144828,33.52,NULL,50.6,69343,NULL,NULL,NULL,'ESO 184- G 077',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144829,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144829,33.6,0.43,52.4,69343,75,NULL,'MAT, I, cor','ESO 184- G 077',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144830,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144830,34.06,0.8,64.8,69344,75,NULL,'MAT, I','IC 4862',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.54',0.4,'SAB:(rs)bc','Pair member (points to parent)',NULL,NULL,NULL,1,292.918125,-67.32289,0.321,NULL,49247439836,769491247,12023300,14.54),(144831,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144831,34.1,0.32,66,69344,85,NULL,'I, raw','IC 4862',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144832,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144832,34.14,0.43,67.1,69344,75,NULL,'MAT, I, raw','IC 4862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144833,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144833,34.14,0.32,67.4,69344,85,NULL,'I, inv','IC 4862',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144834,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144834,34.2,0.43,69.2,69344,75,NULL,'MAT, I, cor','IC 4862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144835,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144835,34.25,0.09,70.9,69344,NULL,NULL,NULL,'IC 4862',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144836,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144836,34.34,0.43,73.9,69344,75,NULL,'MAT, I, inv','IC 4862',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144837,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144837,36.18,0.85,172,69345,70,NULL,NULL,'2MASX J19315896-2721290',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,292.995625,-27.35808,0.489,NULL,47590611544,743603305,11618801,15.4),(144838,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144838,36.64,0.55,213,69346,70,NULL,NULL,'2MASX J19320744-1113063',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.6R',0.2,NULL,NULL,NULL,NULL,NULL,1,293.0310417,-11.21836,1.061,NULL,48154705519,752417273,11756519,15.6),(144839,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144839,32.95,0.4,38.8,69347,75,NULL,'Edat, raw','NGC 6799',NULL,'1997ApJS..109..333W',1997,1,1.6,'ESO-LV gives v = 5590 +/- 40 km/sec.','G',0.00002,NULL,'13.39',1.2,'SA0-:',NULL,NULL,NULL,NULL,1,293.068875,-55.90792,0.137,NULL,49012906991,765826671,11966041,13.39),(144840,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144840,33.2,0.4,43.6,69347,75,NULL,'Edat, cor','NGC 6799',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144841,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144841,33.6,0.51,52.5,69347,70,NULL,NULL,'NGC 6799',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144842,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144842,33.41,0.45,48.1,69347,NULL,NULL,'K','NGC 6799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144843,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144843,33.94,0.4,61.4,69347,NULL,NULL,'mean','NGC 6799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144844,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144844,35.81,0.41,145,69348,NULL,NULL,'Malmquist cor.','ESO 460- G 011',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.16',0.9,'Sb',NULL,NULL,NULL,NULL,1,293.092083,-30.27397,0.449,NULL,51141424031,799084750,12485699,15.16),(144845,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144845,36.05,0.36,162,69348,NULL,NULL,NULL,'ESO 460- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144846,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144846,36.09,0.2,165,69348,74.4,NULL,NULL,'ESO 460- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144847,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144847,35.6,0.58,132,69349,70,NULL,NULL,'2MASX J19322277-6232561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.0947917,-62.54883,0.277,NULL,48942869248,764732332,11948942,16.3),(144848,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144848,33.81,0.4,57.8,69350,75,NULL,'Edat, raw','ESO 105- G 004',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00005,NULL,'12.73',1.1,'E+',NULL,NULL,NULL,NULL,1,293.103583,-64.41339,0.249,NULL,49225579132,769149673,12017963,12.73),(144849,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144849,33.85,0.4,58.8,69350,75,NULL,'Edat, cor','ESO 105- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144850,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144850,34.15,0.49,67.6,69350,70,NULL,NULL,'ESO 105- G 004',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144851,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144851,33.63,0.4,53.1,69350,NULL,NULL,'mean','ESO 105- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144852,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144852,34.23,0.45,70.2,69350,NULL,NULL,'K','ESO 105- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144853,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144853,36.7,0.52,219,69351,70,NULL,NULL,'2MASX J19322507-5111235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,293.1045,-51.18994,0.141,NULL,51106974832,798546481,12477288,14.7),(144854,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144854,34.9,0.42,95.5,69352,NULL,NULL,'Malmquist cor.','ESO 460- G 012',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.84',0.5,'S...',NULL,NULL,NULL,NULL,1,293.114583,-29.93956,0.469,NULL,51144854858,799138357,12486536,15.84),(144855,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144855,35.05,0.39,102,69352,NULL,NULL,NULL,'ESO 460- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144856,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144856,35.09,0.2,104,69352,74.4,NULL,NULL,'ESO 460- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144857,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144857,36.84,0.56,233,69353,70,NULL,NULL,'2MASX J19323184-5156426',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,293.1327083,-51.94511,0.157,NULL,51107274188,798551159,12477361,14.6),(144858,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144858,36.42,0.7,192,69354,70,NULL,NULL,'2MASX J19324463-6111261',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.6b',0.4,NULL,NULL,NULL,NULL,NULL,1,293.186083,-61.19061,0.249,NULL,49059758543,766558727,11977480,16.6),(144859,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144859,36.47,0.58,197,69355,70,NULL,NULL,'2MASX J19324565-1148207',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.2R',0.3,NULL,NULL,NULL,NULL,NULL,1,293.19025,-11.80572,0.889,NULL,48151175540,752362117,11755658,15.2),(144860,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144860,36.1,0.77,166,69356,70,NULL,NULL,'2MASX J19331878-1530509',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.32825,-15.51414,0.713,NULL,48082668107,751291689,11738932,17),(144861,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144861,34.52,0.27,80.1,69357,NULL,NULL,NULL,'ESO 398- G 008',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'13.27',0.5,'SAB(r)bc',NULL,NULL,NULL,NULL,1,293.329,-33.14917,0.357,NULL,51201510970,800023608,12500368,13.27),(144862,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144862,34.56,0.2,81.7,69357,74.4,NULL,NULL,'ESO 398- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144863,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144863,34.63,0.26,84.2,69357,NULL,NULL,'Malmquist cor.','ESO 398- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144864,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144864,35.5,0.52,126,69358,70,NULL,NULL,'2MASX J19332236-5943103',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.34325,-59.71953,0.213,NULL,49063767551,766621367,11978458,16.1),(144865,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144865,39.44,NULL,772,69359,NULL,NULL,'Min. z = 0.2','1FGL J1933.3+0723',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,293.346,7.4,NULL,NULL,54652288924,853942014,13342843,NULL),(144866,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144866,33.99,0.4,62.8,69360,NULL,NULL,NULL,'ESO 398- G 010',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'13.35',0.4,'Sb:',NULL,NULL,NULL,NULL,1,293.561417,-34.13792,0.381,NULL,51189517885,799836216,12497440,13.35),(144867,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144867,34.03,0.2,64,69360,74.4,NULL,NULL,'ESO 398- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144868,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144868,34.46,0.32,77.8,69360,NULL,NULL,'Malmquist cor.','ESO 398- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144869,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144869,36.09,0.67,165,69361,70,NULL,NULL,'2MASX J19341785-7536475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.5742917,-75.61314,0.281,NULL,48504524389,757883193,11841924,16.6),(144870,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144870,34.79,0.58,90.6,69362,70,NULL,NULL,'2MASX J19342626-1748335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.6095,-17.80928,0.377,NULL,48077711414,751214240,11737722,16.1),(144871,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144871,35.89,0.65,151,69363,70,NULL,NULL,'2MASX J19342750-7437435',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,293.614667,-74.62881,0.241,NULL,48498758652,757793103,11840517,16.6),(144872,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144872,33.89,0.55,60,69364,NULL,NULL,NULL,'IC 4873',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.13',0.8,'Sb',NULL,NULL,NULL,NULL,1,293.727875,-46.13583,0.205,NULL,51243711434,800682991,12510671,15.13),(144873,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144873,33.93,0.2,61.1,69364,74.4,NULL,NULL,'IC 4873',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144874,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144874,34.32,0.45,73,69364,NULL,NULL,'Malmquist cor.','IC 4873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144875,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144875,33.81,0.4,57.8,69365,75,NULL,'Edat, raw','ESO 105- G 007',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',NULL,NULL,'14.43',0.8,'(R\')SB(s)0/a',NULL,NULL,NULL,NULL,1,293.7292917,-64.74067,0.301,NULL,49226323940,769161311,12018145,14.43),(144876,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144876,33.85,0.4,58.8,69365,75,NULL,'Edat, cor','ESO 105- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144877,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144877,33.83,0.4,58.2,69365,NULL,NULL,'mean','ESO 105- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144878,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144878,34.69,0.45,86.8,69365,NULL,NULL,'K','ESO 105- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144879,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144879,35.43,0.6,122,69366,70,NULL,NULL,'2MASX J19350269-6048563',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'16.2b',0.4,NULL,NULL,NULL,NULL,NULL,1,293.76125,-60.81569,0.241,NULL,49058075059,766532422,11977069,16.2),(144880,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144880,35.81,0.43,145,69367,NULL,NULL,NULL,'ESO 184- G 083',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.33',0.2,'S...',NULL,NULL,NULL,NULL,1,293.843,-57.03478,0.137,NULL,49011398983,765803109,11965673,16.33),(144881,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144881,35.83,0.43,147,69367,NULL,NULL,'Malmquist cor.','ESO 184- G 083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144882,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144882,35.85,0.2,148,69367,74.4,NULL,NULL,'ESO 184- G 083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144883,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144883,36.63,0.75,212,69368,70,NULL,NULL,'2MASX J19353304-1114182',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.7R',0.2,NULL,NULL,NULL,NULL,NULL,1,293.887583333,-11.2385,1.145,NULL,48150955781,752358684,11755604,15.7),(144884,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144884,31.74,0.8,22.3,69369,75,NULL,'MAT, I','IC 4871',NULL,'1997ApJS..109..333W',1997,1,4.14,'6dF DR2 has z = 0.149518.','G',0.000002,NULL,'14.00',0.25,'SAB(s)d? sp',NULL,NULL,NULL,NULL,1,293.925958333,-57.51922,0.237,NULL,49040040124,766250626,11972666,14),(144885,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144885,31.93,0.8,24.3,69369,75,NULL,NULL,'IC 4871',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144886,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144886,31.77,0.37,22.6,69369,NULL,NULL,NULL,'IC 4871',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144887,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144887,31.88,0.4,23.8,69369,75,NULL,NULL,'IC 4871',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144888,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144888,31.88,0.4,23.8,69369,73,NULL,'IR','IC 4871',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144889,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144889,32.05,0.2,25.7,69369,74.4,NULL,NULL,'IC 4871',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144890,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144890,32.15,0.32,26.9,69369,85,NULL,'I, raw','IC 4871',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144891,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144891,32.16,0.32,27,69369,85,NULL,'I, inv','IC 4871',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144892,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144892,32.23,0.43,27.9,69369,75,NULL,'MAT, I, raw','IC 4871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144893,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144893,32.24,0.43,28.1,69369,75,NULL,'3.6 micron, color corrected','IC 4871',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144894,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144894,32.3,0.49,28.9,69369,75,NULL,'IR','IC 4871',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144895,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144895,32.31,0.43,29,69369,75,NULL,'MAT, I, inv','IC 4871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144896,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144896,32.36,0.43,29.7,69369,75,NULL,'3.6 micron, color + selection bias corrected','IC 4871',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144897,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144897,32.44,0.4,30.7,69369,NULL,NULL,'mean','IC 4871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144898,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144898,32.54,NULL,32.3,69369,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4871',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144899,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144899,32.55,NULL,32.3,69369,NULL,NULL,'Dipole + Quadrupole','IC 4871',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144900,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144900,32.56,NULL,32.4,69369,NULL,NULL,'Dipole','IC 4871',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144901,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144901,32.65,0.43,33.9,69369,75,NULL,'MAT, I, cor','IC 4871',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144902,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144902,32.66,NULL,34.1,69369,NULL,NULL,NULL,'IC 4871',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144903,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144903,32.87,0.47,37.6,69369,NULL,NULL,'H','IC 4871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144904,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144904,32.92,0.46,38.3,69369,NULL,NULL,'J','IC 4871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144905,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144905,33.03,0.45,40.4,69369,NULL,NULL,'K','IC 4871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144906,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144906,33.89,0.47,59.9,69370,70,NULL,NULL,'ESO 142- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'13.99',1,'SA(r)0^0',NULL,NULL,NULL,NULL,1,293.9274583,-59.78967,0.221,NULL,49063067739,766610433,11978288,13.99),(144907,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144907,34.56,NULL,81.6,69371,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 283-IG 010',NULL,'2010Ap&SS.325..163P',2010,1,2.06,NULL,'G',0.000033,NULL,'16.3b',0.22,'Scd',NULL,NULL,NULL,NULL,1,293.931833,-43.97147,0.321,NULL,51261448311,800960129,12515002,16.3),(144908,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144908,34.57,NULL,82,69371,NULL,NULL,'Dipole','ESO 283-IG 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144909,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144909,34.57,NULL,82,69371,NULL,NULL,'Dipole + Quadrupole','ESO 283-IG 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144910,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144910,35.04,0.43,102,69372,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2260',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',NULL,NULL,'16.6',0.09,'Scd',NULL,NULL,NULL,NULL,1,293.98,64.07194,0.333,NULL,53572234149,837066158,13079158,16.6),(144911,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144911,35.36,NULL,118,69372,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144912,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144912,35.37,NULL,119,69372,NULL,NULL,'Dipole + Quadrupole','FGC 2260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144913,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144913,35.39,NULL,120,69372,NULL,NULL,'Dipole','FGC 2260',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144914,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144914,35.41,NULL,121,69372,NULL,NULL,NULL,'FGC 2260',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144915,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144915,31.77,0.8,22.6,69373,75,NULL,NULL,'IC 4869',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'16.8b',1.5,'SA(s)dm pec',NULL,NULL,NULL,NULL,1,294.0097083,-61.02786,0.245,NULL,49058447646,766538244,11977160,16.8),(144916,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144916,34.4,0.48,75.9,69374,70,NULL,NULL,'ESO 398- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'15',1.8,'Sa',NULL,NULL,NULL,NULL,1,294.050458333,-33.99492,0.381,NULL,51201355533,800021180,12500330,15),(144917,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144917,33.55,0.68,51.2,69375,NULL,NULL,NULL,'ESO 232- G 011',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.81',0.3,'SB?...',NULL,NULL,NULL,NULL,1,294.069417,-48.52764,0.209,NULL,51244134232,800689597,12510774,15.81),(144918,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144918,33.59,0.2,52.2,69375,74.4,NULL,NULL,'ESO 232- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144919,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144919,34.1,0.52,66.1,69375,NULL,NULL,'Malmquist cor.','ESO 232- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144920,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144920,42.44,0.11,2000,69376,NULL,NULL,NULL,'GRB 090618',0.54,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,293.9940417,78.35675,0.289,NULL,52856392175,825881127,12904392,NULL),(144921,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144921,42.33,0.19,2920,69376,NULL,NULL,NULL,'GRB 090618',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144922,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144922,42.43,0.04,3060,69376,NULL,NULL,NULL,'GRB 090618',NULL,'2012arXiv1205.2954T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144923,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144923,37.61,0.6,333,69377,70,NULL,NULL,'2MASX J19363769-1506552',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.157,-15.11539,0.637,NULL,48081273345,751269896,11738592,17),(144924,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144924,34.44,0.49,77.2,69378,75,NULL,'IR','FGC 2261',NULL,'2011yCatp016004901K',2011,1,0.99,NULL,'G',NULL,NULL,'16.4',0.12,'Scd',NULL,NULL,NULL,NULL,1,294.176291667,77.10178,0.309,NULL,52722626109,823791032,12871734,16.4),(144925,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144925,35.05,NULL,102,69378,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2261',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144926,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144926,35.07,NULL,103,69378,NULL,NULL,'Dipole + Quadrupole','FGC 2261',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144927,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144927,35.08,NULL,104,69378,NULL,NULL,'Dipole','FGC 2261',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144928,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144928,35.11,NULL,105,69378,NULL,NULL,NULL,'FGC 2261',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144929,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144929,36.44,0.57,194,69379,70,NULL,NULL,'2MASX J19365323-5330315',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.221791667,-53.50869,0.165,NULL,49008952021,765764875,11965076,14.8),(144930,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144930,36.9,0.56,240,69380,70,NULL,NULL,'2MASX J19365486-5318085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.228625,-53.30244,0.105,NULL,49009390959,765771733,11965183,14.5),(144931,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144931,35.76,0.5,142,69381,70,NULL,NULL,'FAIRALL 0516',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.2875417,-63.52042,0.249,NULL,48939702644,764682853,11948169,15.9),(144932,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 2001do',NULL,144932,32.35,0.15,28.9,69382,NULL,NULL,'SEAM','UGC 11459',0.010421,'2009ApJ...694.1067P',2009,1,2.2,'abs(b) < 10 degrees.','G',0.000017,NULL,'12.8B',1.3,'Sd','in a pair',NULL,NULL,NULL,1,294.3439583,40.7055,NULL,NULL,55018400013,859662500,13432226,12.8),(144933,'Sosies','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144933,33.45,0.16,49,69382,NULL,NULL,NULL,'UGC 11459',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144934,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144934,32.61,0.69,33.3,69382,100,NULL,'mid-IR','UGC 11459',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144935,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144935,33.38,0.2,47.4,69382,74.4,NULL,NULL,'UGC 11459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144936,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144936,33.42,0.43,48.3,69382,75,NULL,'3.6 micron, color corrected','UGC 11459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144937,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144937,33.49,0.43,49.8,69382,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11459',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144938,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144938,33.54,0.4,51.1,69382,NULL,NULL,'mean','UGC 11459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144939,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144939,33.9,0.47,60.4,69382,NULL,NULL,'H','UGC 11459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144940,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144940,33.93,0.46,61.2,69382,NULL,NULL,'J','UGC 11459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144941,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144941,33.97,0.45,62.1,69382,NULL,NULL,'K','UGC 11459',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144942,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144942,35.97,0.51,156,69383,70,NULL,NULL,'2MASX J19372417-1745017',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.35075,-17.75053,0.377,NULL,48075858484,751185288,11737270,16.5),(144943,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144943,34.43,0.8,76.7,69384,75,NULL,'MAT, I','ESO 594- G 008',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000013,NULL,'15.4b',0.4,'Sd? sp',NULL,NULL,NULL,NULL,1,294.36525,-17.45514,0.429,NULL,48078596467,751228069,11737938,15.4),(144944,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144944,34.38,0.32,75.1,69384,85,NULL,'I, raw','ESO 594- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144945,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144945,34.39,0.43,75.7,69384,75,NULL,'MAT, I, raw','ESO 594- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144946,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144946,34.41,0.32,76.3,69384,85,NULL,'I, inv','ESO 594- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144947,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144947,34.51,0.49,80,69384,75,NULL,'IR','ESO 594- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144948,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144948,34.57,0.43,81.9,69384,75,NULL,'MAT, I, inv','ESO 594- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144949,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144949,34.68,0.49,86.2,69384,NULL,NULL,'Malmquist cor.','ESO 594- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144950,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144950,34.73,0.48,88.2,69384,NULL,NULL,NULL,'ESO 594- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144951,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144951,34.77,0.2,90,69384,74.4,NULL,NULL,'ESO 594- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144952,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144952,34.78,0.43,90.2,69384,75,NULL,'MAT, I, cor','ESO 594- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144953,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144953,29.65,0.1,8.5,69385,74.4,NULL,NULL,'IC 4870',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000003,NULL,'13.89',0.9,'IBM? pec;HII   Sy2',NULL,NULL,NULL,'H II',1,294.406667,-65.81183,0.337,NULL,49241022973,769390983,12021734,13.89),(144954,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144954,29.32,NULL,7.31,69385,NULL,NULL,NULL,'IC 4870',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144955,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144955,34.34,0.8,73.6,69386,75,NULL,'MAT, I','IC 4876',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.31',0.9,'SAB(rs)c',NULL,NULL,NULL,NULL,1,294.428208333,-52.84275,0.073,NULL,51105039608,798516243,12476816,14.31),(144956,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144956,34.2,0.43,69.3,69386,75,NULL,'MAT, I, raw','IC 4876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144957,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144957,34.32,0.43,73,69386,75,NULL,'MAT, I, cor','IC 4876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144958,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144958,34.33,0.32,73.4,69386,85,NULL,'I, raw','IC 4876',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144959,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144959,34.38,0.32,75.2,69386,85,NULL,'I, inv','IC 4876',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144960,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144960,34.41,0.43,76.3,69386,75,NULL,'MAT, I, inv','IC 4876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144961,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144961,34.46,0.4,78,69386,NULL,NULL,'mean','IC 4876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144962,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144962,34.9,0.47,95.3,69386,NULL,NULL,'H','IC 4876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144963,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144963,35.85,0.61,148,69387,70,NULL,NULL,'ESO 185- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.60',0.6,'SB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,294.5649583,-52.82108,0.073,NULL,51105315647,798520556,12476883,15.6),(144964,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144964,36.38,0.52,189,69388,70,NULL,NULL,'2MASX J19382179-5039151',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.5907083,-50.65414,0.133,NULL,51106265323,798535395,12477115,14.5),(144965,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144965,36.23,0.51,176,69389,70,NULL,NULL,'FAIRALL 0062',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'15.6b',NULL,'Bright nucleus',NULL,NULL,NULL,NULL,1,294.640333,-60.70492,0.249,NULL,49057839028,766528734,11977011,15.6),(144966,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144966,36.26,0.65,179,69390,70,NULL,NULL,'2MASX J19383915-0915090',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.663167,-9.25247,0.833,NULL,47868400596,747943759,11686621,17),(144967,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144967,36.1,0.5,166,69391,70,NULL,NULL,'2MASX J19384291-0535151',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00009,NULL,'15.1R',0.2,NULL,NULL,NULL,NULL,NULL,1,294.6787917,-5.58758,0.709,NULL,47907718916,748558108,11696220,15.1),(144968,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144968,34.9,0.45,95.3,69392,NULL,NULL,'Malmquist cor.','ESO 398- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.11',0.2,'S...',NULL,NULL,NULL,NULL,1,294.7784583,-33.04769,0.469,NULL,51203818263,800059660,12500932,14.11),(144969,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144969,35.16,0.4,108,69392,NULL,NULL,NULL,'ESO 398- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144970,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144970,35.2,0.2,110,69392,74.4,NULL,NULL,'ESO 398- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144971,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144971,36.91,0.6,241,69393,70,NULL,NULL,'2MASX J19390708-1553156',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.7795,-15.88764,0.441,NULL,48077042088,751203782,11737559,17.3),(144972,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',144972,32.83,0.49,36.9,69394,75,NULL,'IR','UGC 11461',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000013,NULL,'15.40',0.2,'Scd:',NULL,NULL,NULL,NULL,1,294.787083,8.81033,NULL,NULL,54138886526,845920101,13217501,15.4),(144973,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144973,33.17,0.47,43.1,69394,NULL,NULL,'H','UGC 11461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144974,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144974,33.21,0.4,43.9,69394,NULL,NULL,'mean','UGC 11461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144975,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144975,33.27,0.45,45.2,69394,NULL,NULL,'K','UGC 11461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144976,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144976,33.35,0.46,46.9,69394,NULL,NULL,'J','UGC 11461',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144977,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144977,34.6,0.3,83.3,69395,NULL,NULL,'Malmquist cor.','ESO 338- G 018',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'16.01',0.9,'(R\')SAB(r)b:',NULL,NULL,NULL,NULL,1,294.790166667,-37.87572,0.517,NULL,51179131436,799673928,12494905,16.01),(144978,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144978,34.65,0.29,85.1,69395,NULL,NULL,NULL,'ESO 338- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144979,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144979,34.69,0.2,86.7,69395,74.4,NULL,NULL,'ESO 338- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144980,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144980,36.21,0.54,175,69396,70,NULL,NULL,'2MASX J19391760-1714226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,294.823333,-17.23958,0.417,NULL,48075468843,751179200,11737175,15.8),(144981,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144981,34.02,0.47,63.7,69397,NULL,NULL,'H','CGCG 397-003',NULL,'2007A&A...465...71T',2007,1,0.56,NULL,'G',0.000067,NULL,'15.7',0.45,'Spiral',NULL,NULL,NULL,NULL,1,294.871625,6.34847,NULL,NULL,54131195671,845799932,13215623,15.7),(144982,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144982,34.2,0.46,69.2,69397,NULL,NULL,'J','CGCG 397-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144983,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144983,34.25,0.45,70.7,69397,NULL,NULL,'K','CGCG 397-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144984,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144984,34.38,0.4,75,69397,NULL,NULL,'mean','CGCG 397-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144985,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144985,35.96,0.6,155,69398,70,NULL,NULL,'2MASX J19394121-6018571',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.921833,-60.31594,0.245,NULL,49057643398,766525678,11976963,15.3),(144986,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144986,34.31,0.61,72.9,69399,70,NULL,NULL,'CGCG 371-003',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.7',0.3,NULL,NULL,NULL,NULL,NULL,1,294.929875,-0.501,1.093,NULL,47862356404,747849318,11685145,15.7),(144987,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144987,35.12,0.58,106,69400,NULL,NULL,'Malmquist cor.','ESO 460- G 020',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'16.21',0.5,'Sb:',NULL,NULL,NULL,NULL,1,294.963208333,-27.887,0.561,NULL,51152659191,799260299,12488442,16.21),(144988,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144988,35.35,0.52,117,69400,NULL,NULL,NULL,'ESO 460- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144989,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144989,35.39,0.2,120,69400,74.4,NULL,NULL,'ESO 460- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144990,'GRB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'RN',144990,38.49,NULL,500,69401,NULL,NULL,NULL,'GRB 791101',NULL,'1992grbo.book..107S',1992,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144991,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144991,36.28,0.67,180,69402,70,NULL,NULL,'2MASX J19395331-5332075',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.972167,-53.53544,0.205,NULL,49008492437,765757694,11964963,15.3),(144992,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144992,36.98,0.51,249,69403,70,NULL,NULL,'2MASX J19395823-5103235',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,294.99275,-51.0565,0.133,NULL,51117307787,798707934,12479811,14.5),(144993,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144993,36.57,0.57,206,69404,70,NULL,NULL,'2MASX J19395988-2238096',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,294.999583,-22.63606,0.517,NULL,48053125896,750830092,11731720,14.2),(144994,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144994,35.33,0.4,116,69405,75,NULL,'Edat, raw','IC 4864',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',NULL,NULL,'14.8',0.4,'SAB(rs)a',NULL,NULL,NULL,NULL,1,295.0257083,-77.55817,0.417,NULL,48545000611,758515634,11851806,14.8),(144995,'D-Sigma','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144995,35.66,0.4,136,69405,75,NULL,'Edat, cor','IC 4864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(144996,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144996,36.24,0.5,177,69406,70,NULL,NULL,'2MASX J19401737-1903592',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.2I',0.5,NULL,NULL,NULL,NULL,NULL,1,295.072333,-19.06644,0.509,NULL,48055184581,750862259,11732222,13.2),(144997,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144997,34.15,0.48,67.5,69407,70,NULL,NULL,'IC 4880',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00015,NULL,'14.27',0.4,'(R\'_1)SAB(l)a:',NULL,NULL,NULL,NULL,1,295.1287917,-56.41017,0.137,NULL,49014357146,765849330,11966395,14.27),(144998,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144998,33.56,0.8,51.5,69408,75,NULL,'MAT, I','ESO 142- G 030',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.57',0.4,'Sc',NULL,NULL,NULL,NULL,1,295.161875,-60.04817,0.245,NULL,49032526650,766133228,11970831,14.57),(144999,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,144999,33.68,0.32,54.5,69408,85,NULL,'I, raw','ESO 142- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145000,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145000,33.73,0.32,55.7,69408,85,NULL,'I, inv','ESO 142- G 030',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145001,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145001,33.8,0.43,57.6,69408,75,NULL,'MAT, I, raw','ESO 142- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145002,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145002,33.87,0.49,59.3,69408,75,NULL,'IR','ESO 142- G 030',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145003,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145003,33.89,0.09,60.1,69408,NULL,NULL,NULL,'ESO 142- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145004,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145004,33.9,0.43,60.2,69408,75,NULL,'MAT, I, cor','ESO 142- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145005,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145005,34.03,0.43,64,69408,75,NULL,'MAT, I, inv','ESO 142- G 030',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145006,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145006,36.06,0.56,163,69409,70,NULL,NULL,'2MASX J19404092-1859372',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.1704583,-18.99364,0.509,NULL,48055134866,750861482,11732210,14.6),(145007,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145007,35.51,0.57,126,69410,70,NULL,NULL,'2MASX J19404231-7025467',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,295.17625,-70.42964,0.313,NULL,49250778432,769543413,12024115,16),(145008,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145008,36,0.49,158,69411,70,NULL,NULL,'2MASX J19404710-5057433',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.1962083,-50.96197,0.133,NULL,51117351706,798708620,12479822,15),(145009,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145009,37.85,0.77,372,69412,70,NULL,NULL,'2MASX J19410123-7958185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,295.255333,-79.97178,0.545,NULL,48552550562,758633602,11853650,17.2),(145010,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145010,35,0.61,99.8,69413,70,NULL,NULL,'2MASX J19410969-0642577',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.6R',0.2,'nuc. dominant',NULL,NULL,NULL,NULL,1,295.290417,-6.716,0.633,NULL,47876701546,748073461,11688647,14.6),(145011,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145011,29.68,0.43,8.6,69414,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J19411657+0152227',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000023,NULL,'11.3K',0.3,'with *',NULL,NULL,NULL,NULL,1,295.319,1.87294,1.325,NULL,54102886754,845357605,13208712,11.3),(145012,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145012,36.59,0.6,208,69415,70,NULL,NULL,'2MASX J19412389-6233575',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.8b',NULL,'Sa(r)',NULL,NULL,NULL,NULL,1,295.349583,-62.56594,0.241,NULL,49057444300,766522567,11976915,16.8),(145013,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145013,37.18,0.77,273,69416,70,NULL,NULL,'2MASX J19412526-1022286',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.355333333,-10.37461,0.597,NULL,47869286008,747957593,11686837,16),(145014,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145014,34.08,0.8,65.5,69417,75,NULL,'MAT, I','ESO 398- G 020',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.38',0.2,'Scd: sp        HII',NULL,NULL,NULL,NULL,1,295.379208333,-36.34053,0.445,NULL,51190967378,799858865,12497794,13.38),(145015,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145015,34.05,0.32,64.7,69417,85,NULL,'I, raw','ESO 398- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145016,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145016,34.09,0.32,65.8,69417,85,NULL,'I, inv','ESO 398- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145017,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145017,34.11,0.43,66.3,69417,75,NULL,'MAT, I, raw','ESO 398- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145018,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145018,34.15,0.49,67.7,69417,75,NULL,'IR','ESO 398- G 020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145019,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145019,34.28,0.43,71.9,69417,75,NULL,'MAT, I, inv','ESO 398- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145020,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145020,34.33,0.2,73.5,69417,74.4,NULL,NULL,'ESO 398- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145021,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145021,34.38,0.43,75.1,69417,75,NULL,'MAT, I, cor','ESO 398- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145022,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145022,34.58,0.25,82.6,69417,NULL,NULL,'Malmquist cor.','ESO 398- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145023,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145023,34.64,0.25,84.6,69417,NULL,NULL,NULL,'ESO 398- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145024,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145024,33.68,0.8,54.4,69418,75,NULL,'MAT, I','IC 4883',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.58',0.4,'SB(s)b?',NULL,NULL,NULL,NULL,1,295.5022083,-55.54553,0.149,NULL,49011900788,765810949,11965796,14.58),(145025,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145025,33.81,0.32,57.7,69418,85,NULL,'I, raw','IC 4883',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145026,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145026,33.84,0.43,58.7,69418,75,NULL,'MAT, I, raw','IC 4883',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145027,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145027,33.86,0.32,59.1,69418,85,NULL,'I, inv','IC 4883',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145028,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145028,33.99,0.43,62.7,69418,75,NULL,'MAT, I, cor','IC 4883',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145029,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145029,34.07,0.43,65.1,69418,75,NULL,'MAT, I, inv','IC 4883',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145030,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145030,34.14,0.38,67.3,69418,NULL,NULL,'Malmquist cor.','IC 4883',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145031,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145031,34.24,0.36,70.6,69418,NULL,NULL,NULL,'IC 4883',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145032,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145032,34.28,0.2,71.8,69418,74.4,NULL,NULL,'IC 4883',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145033,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145033,35.23,0.53,111,69419,70,NULL,NULL,'2MASX J19421431-3559435',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.559667,-35.99547,0.429,NULL,51188901663,799826588,12497290,14.7),(145034,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145034,33.7,0.17,55,69420,NULL,NULL,'V, photospheric magnitude method','2MASX J19422191-5506275',NULL,'2014AJ....148..107R',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'S',NULL,NULL,NULL,NULL,1,295.592,-55.10456,0.161,NULL,49019546961,765930421,11967662,NULL),(145035,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145035,33.89,0.53,60,69420,NULL,NULL,'SCM, I','2MASX J19422191-5506275',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145036,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145036,33.96,0.07,61.9,69420,NULL,NULL,'I, photospheric magnitude method','2MASX J19422191-5506275',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145037,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145037,34.04,0.54,64.3,69420,NULL,NULL,'SCM, V','2MASX J19422191-5506275',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145038,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145038,34.05,0.28,64.6,69420,NULL,NULL,'SCM, BVI','2MASX J19422191-5506275',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145039,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145039,34.14,0.41,67.3,69420,NULL,NULL,'SCM, B','2MASX J19422191-5506275',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145040,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145040,34.23,NULL,70,69420,NULL,NULL,NULL,'2MASX J19422191-5506275',NULL,'2003MNRAS.346...97N',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145041,'SNII optical','2016-12-15 15:15:49','2016-12-16 11:21:04','1','SN 1991al',NULL,145041,34.28,0.54,70.4,69420,NULL,NULL,'SEAM','2MASX J19422191-5506275',0.01,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145042,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145042,34.37,0.8,74.7,69421,75,NULL,'MAT, I','MCG -03-50-003',NULL,'1997ApJS..109..333W',1997,1,2,'2MASXi position not centered on galaxy.','G',0.000031,NULL,'14',0.3,'Sc: sp',NULL,NULL,NULL,NULL,1,295.599333,-15.86411,0.425,NULL,47955927720,749311370,11707990,14),(145043,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145043,34.36,0.2,74.5,69421,74.4,NULL,NULL,'MCG -03-50-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145044,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145044,34.41,0.43,76.2,69421,75,NULL,'3.6 micron, color corrected','MCG -03-50-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145045,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145045,34.41,0.43,76.4,69421,75,NULL,'MAT, I, raw','MCG -03-50-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145046,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145046,34.5,0.39,79.5,69421,NULL,NULL,'Malmquist cor.','MCG -03-50-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145047,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145047,34.56,0.43,81.8,69421,75,NULL,'3.6 micron, color + selection bias corrected','MCG -03-50-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145048,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145048,34.59,0.38,82.7,69421,NULL,NULL,NULL,'MCG -03-50-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145049,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145049,34.71,0.32,87.7,69421,85,NULL,'I, raw','MCG -03-50-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145050,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145050,34.73,0.43,88.2,69421,75,NULL,'MAT, I, inv','MCG -03-50-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145051,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145051,34.78,0.43,90.2,69421,75,NULL,'MAT, I, cor','MCG -03-50-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145052,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145052,34.79,0.32,90.8,69421,85,NULL,'I, inv','MCG -03-50-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145053,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145053,31.94,0.8,24.4,69422,75,NULL,NULL,'ESO 142- G 032',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000023,NULL,'15.31',0.7,'SB(s)m: pec','in a pair',NULL,NULL,NULL,1,295.653875,-58.80178,0.213,NULL,49035575811,766180872,11971576,15.31),(145054,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145054,31.11,0.39,16.7,69423,73,NULL,'opt','CGMW 3-4603',NULL,'2011A&A...532A.104N',2011,1,1.1,NULL,'G',0.000025,NULL,NULL,0.2,'nebula:',NULL,NULL,NULL,NULL,1,295.658416667,-7.61092,0.565,NULL,47881842075,748153782,11689902,NULL),(145055,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145055,31.79,0.4,22.8,69424,75,NULL,'B','NGC 6814',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000007,NULL,'12.06',2.8,'SAB(rs)bc;HII  Sy1.5','Group member, radial-velocity confirmed',NULL,NULL,'Sy 1.5',1,295.669333,-10.3235,0.597,NULL,47867026066,747922282,11686285,12.06),(145056,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145056,35.1,0.6,105,69425,70,NULL,NULL,'2MASX J19424113-0656035',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4R',0.3,NULL,NULL,NULL,NULL,NULL,1,295.671375,-6.93425,0.533,NULL,47878389071,748099829,11689059,14.4),(145057,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145057,39.44,NULL,772,69426,NULL,NULL,'Min. z = 0.2','1FGL J1942.7+1033',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,295.689,10.56,NULL,NULL,54158428448,846225444,13222272,NULL),(145058,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145058,34.33,0.8,73.6,69427,75,NULL,'MAT, I','ESO 460- G 025',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.63',0.9,'SB(r)a',NULL,NULL,NULL,NULL,1,295.71925,-28.50197,0.649,NULL,51153645148,799275705,12488682,14.63),(145059,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145059,34.15,0.43,67.7,69427,75,NULL,'MAT, I, raw','ESO 460- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145060,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145060,34.25,0.47,70.7,69427,NULL,NULL,'H','ESO 460- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145061,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145061,34.28,0.32,71.7,69427,85,NULL,'I, raw','ESO 460- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145062,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145062,34.32,0.45,73.2,69427,NULL,NULL,'K','ESO 460- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145063,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145063,34.35,0.32,74.1,69427,85,NULL,'I, inv','ESO 460- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145064,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145064,34.37,0.46,74.8,69427,NULL,NULL,'J','ESO 460- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145065,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145065,34.44,0.43,77.3,69427,75,NULL,'MAT, I, inv','ESO 460- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145066,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145066,34.56,0.32,81.7,69427,NULL,NULL,NULL,'ESO 460- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145067,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145067,34.56,0.32,81.7,69427,NULL,NULL,'Malmquist cor.','ESO 460- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145068,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145068,34.58,0.43,82.3,69427,75,NULL,'MAT, I, cor','ESO 460- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145069,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145069,34.59,0.4,82.7,69427,NULL,NULL,'mean','ESO 460- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145070,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145070,34.6,0.2,83.2,69427,74.4,NULL,NULL,'ESO 460- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145071,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145071,30.45,0.43,12.3,69428,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11466',NULL,'2014MNRAS.444..527S',2014,1,2,NULL,'G',0.000007,NULL,'12.7',1.2,'S?',NULL,NULL,NULL,NULL,1,295.744833,45.29819,0.965,NULL,55021347067,859708547,13432946,12.7),(145072,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145072,30.75,0.43,14.1,69428,75,NULL,'3.6 micron, color corrected','UGC 11466',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145073,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145073,30.96,0.2,15.6,69428,74.4,NULL,NULL,'UGC 11466',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145074,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145074,31.29,0.4,18.1,69428,NULL,NULL,NULL,'UGC 11466',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145075,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145075,33.53,0.8,50.8,69429,75,NULL,'MAT, I','ESO 142- G 034',NULL,'1997ApJS..109..333W',1997,1,1.59,'Allen, et al. (1991, MNRAS, 248, 528) give z=0.016 +/- 0.001.','G',0.000033,NULL,'15.92',0.2,'Sc',NULL,NULL,NULL,NULL,1,295.7525417,-59.94617,0.241,NULL,49032576840,766134013,11970843,15.92),(145076,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145076,33.39,0.32,47.7,69429,85,NULL,'I, raw','ESO 142- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145077,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145077,33.39,0.32,47.7,69429,85,NULL,'I, inv','ESO 142- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145078,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145078,33.59,0.43,52.2,69429,75,NULL,'MAT, I, raw','ESO 142- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145079,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145079,33.65,0.43,53.6,69429,75,NULL,'MAT, I, inv','ESO 142- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145080,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145080,33.76,0.43,56.5,69429,75,NULL,'MAT, I, cor','ESO 142- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145081,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145081,33.98,0.49,62.5,69429,75,NULL,'IR','ESO 142- G 034',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145082,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145082,34.09,NULL,65.8,69429,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 142- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145083,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145083,34.1,NULL,66.2,69429,NULL,NULL,'Dipole + Quadrupole','ESO 142- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145084,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145084,34.11,NULL,66.5,69429,NULL,NULL,'Dipole','ESO 142- G 034',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145085,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145085,34.16,NULL,67.8,69429,NULL,NULL,NULL,'ESO 142- G 034',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145086,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145086,34.99,0.58,99.3,69430,70,NULL,NULL,'2MASX J19430129-5354071',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.7555,-53.90206,0.181,NULL,49020871604,765951118,11967986,14.9),(145087,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145087,34.77,0.47,90,69431,70,NULL,NULL,'2MASX J19430960-0704121',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'1998PASJ...50...47R has z = 0.039.','G',0.00015,NULL,'14.4I',0.2,NULL,NULL,NULL,NULL,NULL,1,295.7899583,-7.07,0.533,NULL,47878928313,748108254,11689191,14.4),(145088,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145088,30.28,0.4,11.4,69432,73,NULL,'IR','MCG -01-50-001',NULL,'2011A&A...532A.104N',2011,1,1.2,'Confused HIPASS source','G',0.00001,NULL,'13.3R',0.3,'IBm? sp        HII',NULL,NULL,NULL,NULL,1,295.802333,-6.93967,0.533,NULL,47878958476,748108726,11689198,13.3),(145089,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145089,30.28,0.4,11.4,69432,75,NULL,NULL,'MCG -01-50-001',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145090,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145090,30.46,0.49,12.3,69432,75,NULL,'IR','MCG -01-50-001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145091,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145091,34.83,0.5,92.7,69433,70,NULL,NULL,'IC 4886',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.15',0.7,'Sb: pec',NULL,NULL,NULL,NULL,1,295.810625,-51.8075,0.157,NULL,51118687359,798729489,12480148,14.15),(145092,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145092,34.5,0.58,79.6,69434,70,NULL,NULL,'ESO 232- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.90',0.5,'SA(l)0^0',NULL,NULL,NULL,NULL,1,295.85225,-48.53531,0.197,NULL,51113527247,798648863,12478888,14.9),(145093,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145093,35.97,0.69,156,69435,70,NULL,NULL,'2MASX J19433061-0802060',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,295.8775,-8.03497,0.521,NULL,47882075294,748157426,11689959,15.9),(145094,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145094,34.24,0.39,70.3,69436,NULL,NULL,NULL,'ESO 460- G 028',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.76',0.4,'Sb',NULL,NULL,NULL,NULL,1,295.8865,-27.69994,0.677,NULL,51152687909,799260748,12488449,15.76),(145095,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145095,34.28,0.2,71.8,69436,74.4,NULL,NULL,'ESO 460- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145096,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145096,34.5,0.34,79.5,69436,NULL,NULL,'Malmquist cor.','ESO 460- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145097,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145097,31.85,0.8,23.4,69437,75,NULL,'MAT, I','NGC 6810',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000033,NULL,'12.37',0.9,'SA(s)ab:sp     Sy2','in a pair',NULL,NULL,NULL,1,295.8927083,-58.65558,0.169,NULL,49035389643,766177963,11971530,12.37),(145098,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145098,32.01,0.8,25.3,69437,75,NULL,'B','NGC 6810',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145099,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145099,31.56,0.45,20.5,69437,NULL,NULL,'K','NGC 6810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145100,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145100,31.58,0.47,20.7,69437,NULL,NULL,'H','NGC 6810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145101,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145101,31.69,0.46,21.7,69437,NULL,NULL,'J','NGC 6810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145102,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145102,32.21,0.32,27.7,69437,85,NULL,'I, raw','NGC 6810',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145103,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145103,32.27,0.32,28.5,69437,85,NULL,'I, inv','NGC 6810',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145104,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145104,32.28,0.43,28.6,69437,75,NULL,'MAT, I, raw','NGC 6810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145105,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145105,32.29,0.51,28.7,69437,NULL,NULL,NULL,'NGC 6810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145106,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145106,32.3,0.4,28.8,69437,NULL,NULL,'mean','NGC 6810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145107,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145107,32.33,0.2,29.2,69437,74.4,NULL,NULL,'NGC 6810',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145108,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145108,32.58,0.43,32.8,69437,75,NULL,'MAT, I, inv','NGC 6810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145109,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145109,32.64,0.44,33.8,69437,NULL,NULL,'Malmquist cor.','NGC 6810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145110,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145110,32.71,0.43,34.8,69437,75,NULL,'MAT, I, cor','NGC 6810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145111,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145111,35.12,0.5,106,69438,70,NULL,NULL,'ESO 398- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000137,NULL,'16',1,'S...',NULL,NULL,NULL,NULL,1,295.91325,-35.2875,0.437,NULL,51189328873,799833263,12497394,16),(145112,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145112,32.86,0.69,37.3,69439,100,NULL,'mid-IR','NGC 6824',NULL,'2013ApJ...771...88L',2013,1,1.7,NULL,'G',0.0001,NULL,'13.0',1.2,'SA(s)b:',NULL,NULL,NULL,NULL,1,295.919583,56.10947,0.809,NULL,52993948261,828030441,12937975,13),(145113,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145113,33.52,0.4,50.5,69439,NULL,NULL,'mean','NGC 6824',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145114,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145114,33.64,0.45,53.4,69439,NULL,NULL,'K','NGC 6824',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145115,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145115,33.68,0.46,54.4,69439,NULL,NULL,'J','NGC 6824',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145116,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145116,33.59,0.8,52.3,69440,75,NULL,'MAT, I','IC 4885',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.52',0.4,'SA(s)c:',NULL,NULL,NULL,NULL,1,295.966833,-60.65175,0.241,NULL,49025329105,766020767,11969074,14.52),(145117,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145117,32.51,0.8,31.8,69440,75,NULL,NULL,'IC 4885',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145118,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145118,32.33,0.32,29.2,69440,85,NULL,'I, raw','IC 4885',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145119,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145119,32.35,0.32,29.5,69440,85,NULL,'I, inv','IC 4885',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145120,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145120,32.45,0.43,31,69440,75,NULL,'MAT, I, raw','IC 4885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145121,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145121,32.59,0.43,32.9,69440,75,NULL,'MAT, I, inv','IC 4885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145122,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145122,32.89,0.43,37.8,69440,75,NULL,'MAT, I, cor','IC 4885',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145123,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145123,33.23,0.49,44.4,69440,75,NULL,'IR','IC 4885',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145124,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145124,33.88,0.12,59.8,69440,NULL,NULL,NULL,'IC 4885',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145125,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145125,37.86,0.67,373,69441,70,NULL,NULL,'2MASX J19435290-2244594',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,'SAB(rl)0/a',NULL,NULL,NULL,NULL,1,295.970375,-22.74989,0.389,NULL,48053669802,750838590,11731852,15.3),(145126,'BL Lac Luminosity','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145126,38.74,NULL,560,69442,70,NULL,'z = 0.14','2MASS J19435624+2118233',NULL,'2011A&A...529A..49H',2011,1,NULL,'abs(b) < 3 deg.','QSO',NULL,NULL,NULL,NULL,'BLLAC',NULL,NULL,NULL,NULL,1,295.984333,21.30647,NULL,NULL,54494555930,851477436,13304334,NULL),(145127,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145127,34,0.8,63,69443,75,NULL,'MAT, I','ESO 460- G 029',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.00002,NULL,'14.23',1,'SB(rs)bc pec',NULL,NULL,NULL,NULL,1,295.9957917,-28.48689,0.649,NULL,51153567313,799274489,12488663,14.23),(145128,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145128,34.68,0.35,86.3,69443,NULL,NULL,'Malmquist cor.','ESO 460- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145129,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145129,34.89,0.32,95.1,69443,NULL,NULL,NULL,'ESO 460- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145130,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145130,34.9,0.43,95.4,69443,75,NULL,'MAT, I, raw','ESO 460- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145131,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145131,34.93,0.2,96.8,69443,74.4,NULL,NULL,'ESO 460- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145132,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145132,35.08,0.32,104,69443,85,NULL,'I, raw','ESO 460- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145133,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145133,35.18,0.32,108,69443,85,NULL,'I, inv','ESO 460- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145134,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145134,35.17,0.43,108,69443,75,NULL,'MAT, I, cor','ESO 460- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145135,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145135,35.28,0.43,114,69443,75,NULL,'MAT, I, inv','ESO 460- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145136,'IRAS','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145136,34.27,0.8,71.5,69444,75,NULL,'MAT, I','ESO 460- G 031',NULL,'1997ApJS..109..333W',1997,1,4.05,NULL,'G',0.000013,NULL,'15.10',0.45,'Sbc            HII',NULL,NULL,NULL,NULL,1,296.089625,-27.40689,0.661,NULL,51140107128,799064173,12485377,15.1),(145137,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145137,33.95,0.43,61.5,69444,75,NULL,'MAT, I, raw','ESO 460- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145138,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145138,33.95,NULL,61.7,69444,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 460- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145139,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145139,33.95,NULL,61.7,69444,NULL,NULL,'Dipole','ESO 460- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145140,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145140,33.96,NULL,61.8,69444,NULL,NULL,'Dipole + Quadrupole','ESO 460- G 031',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145141,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145141,34.03,NULL,63.9,69444,NULL,NULL,NULL,'ESO 460- G 031',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145142,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145142,34.2,0.32,69.2,69444,85,NULL,'I, raw','ESO 460- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145143,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145143,34.23,0.43,70,69444,75,NULL,'MAT, I, inv','ESO 460- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145144,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145144,34.23,0.49,70.3,69444,75,NULL,'IR','ESO 460- G 031',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145145,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145145,34.27,0.32,71.4,69444,85,NULL,'I, inv','ESO 460- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145146,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145146,34.29,0.47,72.1,69444,NULL,NULL,'H','ESO 460- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145147,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145147,34.39,0.2,75.5,69444,74.4,NULL,NULL,'ESO 460- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145148,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145148,34.41,0.45,76.4,69444,NULL,NULL,'K','ESO 460- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145149,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145149,34.42,0.46,76.7,69444,NULL,NULL,'J','ESO 460- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145150,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145150,34.45,0.43,77.6,69444,75,NULL,'MAT, I, cor','ESO 460- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145151,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145151,34.47,0.31,78.2,69444,NULL,NULL,NULL,'ESO 460- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145152,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145152,34.5,0.3,79.4,69444,NULL,NULL,'Malmquist cor.','ESO 460- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145153,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145153,34.51,0.43,79.9,69444,75,NULL,'3.6 micron, color corrected','ESO 460- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145154,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145154,34.54,0.4,80.9,69444,NULL,NULL,'mean','ESO 460- G 031',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145155,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145155,34.71,0.43,87.3,69444,75,NULL,'3.6 micron, color + selection bias corrected','ESO 460- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145156,'Tully est','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145156,31.76,0.8,22.5,69445,75,NULL,'B','NGC 6821',NULL,'1988NBGC.C....0000T',1988,1,1.2,'Confused HIPASS source','G',0.000017,NULL,'13.62',1,'SB(s)d:        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,296.10025,-6.83344,0.501,NULL,47878852288,748107067,11689172,13.62),(145157,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145157,30.88,0.4,15,69445,73,NULL,'opt','NGC 6821',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145158,'FP','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145158,35.36,0.76,118,69446,70,NULL,NULL,'2MASX J19443465-5234038',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.144458333,-52.56772,0.061,NULL,51118338953,798724046,12480063,14.6),(145159,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145159,34.55,0.4,81.2,69447,NULL,NULL,'mean','ESO 460- G 032',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000063,NULL,'14.72',0.8,'SA(rs)bc:',NULL,NULL,NULL,NULL,1,296.16225,-27.979,0.637,NULL,51152716104,799261189,12488456,14.72),(145160,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145160,34.75,0.47,89.1,69447,NULL,NULL,'H','ESO 460- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145161,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145161,34.85,0.46,93.5,69447,NULL,NULL,'J','ESO 460- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145162,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145162,34.87,0.45,94.1,69447,NULL,NULL,'K','ESO 460- G 032',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145163,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145163,35.15,0.65,107,69448,NULL,NULL,'Malmquist cor.','ESO 398- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.35',0.4,'Sb:',NULL,NULL,NULL,NULL,1,296.229875,-32.64728,0.541,NULL,51192855496,799888367,12498255,14.35),(145164,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145164,35.54,0.55,128,69448,NULL,NULL,NULL,'ESO 398- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145165,'Tully-Fisher','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145165,35.58,0.2,131,69448,74.4,NULL,NULL,'ESO 398- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145166,'Brightest Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145166,23.2,0.2,0.437,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1980ApJ...238...65H',1980,1,15.5,'The position is the approximate center of the bar.','G',0.000007,NULL,'9.31',13.5,'IB(s)m','Group member',NULL,NULL,NULL,1,296.240583,-14.80344,0.861,0,47964467970,749444812,11710075,9.31),(145167,'Brightest Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145167,23.2,0.2,0.437,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1983ApJ...269..335H',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145168,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145168,21.73,0.01,0.222,69449,NULL,NULL,'NGC 6822:[PGU2004] cep028, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145169,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145169,22.42,0.01,0.305,69449,NULL,NULL,'NGC 6822:[PGU2004] cep025, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145170,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145170,23.01,0.01,0.4,69449,NULL,NULL,'NGC 6822:[PGU2004] cep019, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145171,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145171,23.01,0.07,0.4,69449,NULL,NULL,'NGC 6822:[PGU2004] cep034, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145172,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145172,23.09,0.01,0.415,69449,NULL,NULL,'NGC 6822:[PGU2004] cep027, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145173,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145173,23.1,0.08,0.417,69449,NULL,18.47,'10, B, Photographic','NGC 6822',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145174,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145174,23.11,0.07,0.419,69449,NULL,NULL,'NGC 6822:[PGU2004] cep033, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145175,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145175,23.18,0.1,0.433,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1989ApJ...346..629V',1989,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145176,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145176,23.21,NULL,0.439,69449,NULL,NULL,'NGC 6822:[PGU2004] cep026, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145177,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145177,23.22,0.52,0.441,69449,NULL,NULL,'MW HIPP','NGC 6822',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145178,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145178,23.23,0.04,0.443,69449,NULL,NULL,'VI(W), inner, syst. +/- 0.16 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145179,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145179,23.23,0.07,0.443,69449,NULL,NULL,'NGC 6822:[PGU2004] cep035, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145180,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145180,23.26,0.02,0.449,69449,NULL,NULL,'NGC 6822:[PGU2004] cep007, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145181,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145181,23.27,0.18,0.45,69449,NULL,NULL,'LMC W01','NGC 6822',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145182,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145182,23.27,0.07,0.451,69449,NULL,NULL,'3.6 micron, inner, syst. +/- 0.27 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145183,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145183,23.28,0.03,0.453,69449,NULL,NULL,'VI(W), outer, syst. +/- 0.15 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145184,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145184,23.28,0.01,0.453,69449,NULL,NULL,'NGC 6822:[PGU2004] cep002, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145185,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145185,23.3,0.4,0.457,69449,NULL,NULL,'MW P02','NGC 6822',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145186,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145186,23.3,0.02,0.457,69449,NULL,NULL,'NGC 6822:[PGU2004] cep003, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145187,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145187,23.3,0.03,0.457,69449,NULL,NULL,'VI(W), outermost, syst. +/- 0.13 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145188,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145188,23.3,0.04,0.457,69449,NULL,NULL,'3.6 micron, outer, syst. +/- 0.17 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145189,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145189,23.31,0.03,0.459,69449,NULL,18.54,'LMC ZP','NGC 6822',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145190,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145190,23.31,0.02,0.46,69449,NULL,NULL,'56, JK','NGC 6822',NULL,'2006ApJ...647.1056G',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145191,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145191,23.32,0.13,0.461,69449,NULL,18.47,'9, H, Photographic','NGC 6822',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145192,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145192,23.32,0.05,0.461,69449,NULL,NULL,'3.6 micron, outermost, syst. +/- 0.16 mag','NGC 6822',NULL,'2014A&A...572A..64M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145193,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145193,23.34,0.18,0.466,69449,NULL,NULL,'JK(W)','NGC 6822',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145194,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145194,23.34,0.04,0.466,69449,NULL,NULL,'45, VI,WI','NGC 6822',NULL,'2004AJ....128.2815P',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145195,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145195,23.34,0.01,0.466,69449,NULL,NULL,'NGC 6822:[PGU2004] cep018, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145196,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145196,23.34,0.01,0.466,69449,NULL,NULL,'NGC 6822:[PGU2004] cep020, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145197,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145197,23.35,0.01,0.468,69449,NULL,NULL,'NGC 6822:[PGU2004] cep008, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145198,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145198,23.35,0.07,0.468,69449,NULL,NULL,'NGC 6822:[PGU2004] cep030, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145199,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145199,23.35,0.09,0.468,69449,NULL,NULL,'NGC 6822:[PGU2004] cep038, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145200,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145200,23.36,0.01,0.47,69449,NULL,NULL,'NGC 6822:[PGU2004] cep015, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145201,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145201,23.37,0.04,0.472,69449,NULL,NULL,'NGC 6822:[PGU2004] cep024, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145202,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145202,23.38,0.52,0.474,69449,NULL,NULL,'MW GFG','NGC 6822',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145203,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145203,23.38,0.22,0.474,69449,NULL,NULL,'VI(W)','NGC 6822',NULL,'2010ApJ...715..277B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145204,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145204,23.38,0.52,0.474,69449,NULL,NULL,'4, VI','NGC 6822',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145205,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145205,23.38,0.01,0.474,69449,NULL,NULL,'NGC 6822:[PGU2004] cep006, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145206,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145206,23.38,0.01,0.474,69449,NULL,NULL,'NGC 6822:[PGU2004] cep017, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145207,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145207,23.38,0.04,0.474,69449,NULL,NULL,'NGC 6822:[PGU2004] cep023, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145208,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145208,23.38,0.05,0.474,69449,NULL,NULL,'NGC 6822:[PGU2004] cep029, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145209,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145209,23.38,0.05,0.474,69449,NULL,NULL,'19, 3.6 micron, 17, 4.5 micron, Stat. +/- 0.02, Syst. +/- 0.04','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145210,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145210,23.39,0.08,0.476,69449,NULL,NULL,'LMC VIHJK','NGC 6822',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145211,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145211,23.39,0.08,0.476,69449,NULL,NULL,'NGC 6822:[PGU2004] cep031, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145212,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145212,23.39,0.08,0.476,69449,NULL,NULL,'20, JHKs, GAL PL','NGC 6822',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145213,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145213,23.4,0.08,0.479,69449,NULL,18.47,'10, V, Photographic','NGC 6822',NULL,'1987SAAOC..11..125W',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145214,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145214,23.4,0.05,0.479,69449,NULL,NULL,'VIJHK','NGC 6822',NULL,'2012MNRAS.421.2998F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145215,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145215,23.4,0.04,0.479,69449,NULL,NULL,'NGC 6822:[PGU2004] cep036, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145216,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145216,23.4,0.06,0.479,69449,NULL,NULL,'NGC 6822:[PGU2004] cep039, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145217,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145217,23.41,0.06,0.48,69449,74.4,NULL,NULL,'NGC 6822',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145218,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145218,23.41,0.06,0.481,69449,NULL,NULL,'20, JHKs, LMC PL','NGC 6822',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145219,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145219,23.41,0.08,0.481,69449,NULL,NULL,'NGC 6822:[PGU2004] cep021, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145220,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145220,23.42,NULL,0.483,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1985PASAu...6..140V',1985,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145221,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145221,23.42,0.01,0.483,69449,NULL,NULL,'NGC 6822:[PGU2004] cep016, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145222,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145222,23.43,0.02,0.485,69449,NULL,NULL,'NGC 6822:[PGU2004] cep014, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145223,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145223,23.43,0.06,0.485,69449,NULL,NULL,'20, JHKs, GAL+LMC PL','NGC 6822',NULL,'2016AJ....151...88B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145224,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145224,23.45,0.06,0.49,69449,NULL,18.54,'3.6 micron','NGC 6822',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145225,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145225,23.45,0.02,0.49,69449,NULL,NULL,'NGC 6822:[PGU2004] cep010, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145226,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145226,23.46,0.07,0.492,69449,NULL,18.54,'4.5 micron','NGC 6822',NULL,'2009AIPC.1170...37N',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145227,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145227,23.46,0.07,0.492,69449,NULL,NULL,'4.5 micron, LMC m-M = 18.50 PL','NGC 6822',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145228,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145228,23.46,0.02,0.492,69449,NULL,NULL,'NGC 6822:[PGU2004] cep004, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145229,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145229,23.46,0.08,0.492,69449,NULL,NULL,'NGC 6822:[PGU2004] cep005, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145230,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145230,23.47,0.11,0.494,69449,NULL,NULL,'9, H','NGC 6822',NULL,'1983ApJ...273..539M',1983,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145231,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145231,23.47,0.07,0.494,69449,NULL,NULL,'4.5 micron, SMC m-M = 18.90 PL','NGC 6822',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145232,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145232,23.48,0.02,0.497,69449,NULL,NULL,'NGC 6822:[PGU2004] cep011, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145233,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145233,23.49,0.09,0.499,69449,NULL,NULL,'HST KP Calibrated','NGC 6822',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145234,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145234,23.49,0.08,0.499,69449,NULL,NULL,'6, BVRI','NGC 6822',NULL,'1996AJ....112.1928G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145235,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145235,23.5,NULL,0.5,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145236,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145236,23.49,0.03,0.5,69449,NULL,NULL,'16, BVRIJHK, IRAC','NGC 6822',NULL,'2009ApJ...693..936M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145237,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145237,23.51,0.08,0.504,69449,NULL,NULL,'NGC 6822:[PGU2004] cep009, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145238,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145238,23.54,0.03,0.511,69449,NULL,NULL,'NGC 6822:[PGU2004] cep022, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145239,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145239,23.55,0.01,0.513,69449,NULL,NULL,'NGC 6822:[PGU2004] cep012, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145240,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145240,23.58,0.05,0.52,69449,NULL,NULL,'NGC 6822:[PGU2004] cep032, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145241,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145241,23.62,NULL,0.53,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145242,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145242,23.62,0.07,0.53,69449,NULL,NULL,'NGC 6822:[PGU2004] cep037, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145243,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145243,23.66,0.13,0.54,69449,NULL,NULL,'BVH','NGC 6822',NULL,'1991PASP..103..933M',1991,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145244,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145244,23.7,0.08,0.55,69449,NULL,NULL,'NGC 6822:[PGU2004] cep013, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145245,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145245,23.96,0.02,0.619,69449,NULL,NULL,'NGC 6822:[PGU2004] cep001, VIJHK, 3.6, 4.5(W)','NGC 6822',NULL,'2014ApJ...794..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145246,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145246,24.25,0.04,0.708,69449,NULL,NULL,'BVRI','NGC 6822',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145247,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145247,24.3,0.04,0.724,69449,NULL,NULL,'BVRI+','NGC 6822',NULL,'1997ESASP.402..629P',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145248,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145248,24.35,0.06,0.741,69449,NULL,NULL,'3.6 micron, LMC m-M = 18.50 PL','NGC 6822',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145249,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145249,24.43,0.06,0.769,69449,NULL,NULL,'3.6 micron, SMC m-M = 18.90 PL','NGC 6822',NULL,'2012Ap&SS.341..105N',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145250,'Cepheids','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145250,24.6,NULL,0.832,69449,NULL,NULL,'Photographic, APPARENT BLUE m-M','NGC 6822',NULL,'1988PASP..100..935S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145251,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145251,23.35,NULL,0.468,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145252,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145252,23.35,NULL,0.468,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145253,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145253,23.35,NULL,0.468,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145254,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145254,23.38,0.05,0.474,69449,NULL,NULL,'Field 1','NGC 6822',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145255,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145255,23.39,0.04,0.476,69449,NULL,NULL,'Field 2','NGC 6822',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145256,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145256,23.4,0.06,0.479,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2012A&A...548A.129F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145257,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145257,23.45,0.06,0.49,69449,NULL,NULL,'Field 3','NGC 6822',NULL,'2010ApJ...721..297M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145258,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145258,24.1,0.1,0.661,69449,NULL,NULL,'Field 1','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145259,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145259,24.1,0.1,0.661,69449,NULL,NULL,'Field 5','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145260,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145260,24.1,0.1,0.661,69449,NULL,NULL,'Field 6','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145261,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145261,24.2,0.1,0.692,69449,NULL,NULL,'Field 2','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145262,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145262,24.2,0.1,0.692,69449,NULL,NULL,'Field 3','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145263,'CMD','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145263,24.2,0.1,0.692,69449,NULL,NULL,'Field 4','NGC 6822',NULL,'2014A&A...572A..26F',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145264,'FGLR','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145264,23.31,NULL,0.459,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2008ApJ...681..269K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145265,'M Stars','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145265,19.83,NULL,0.0926,69449,NULL,18.54,NULL,'NGC 6822',NULL,'2010ApJ...722..750S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145266,'Miras','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145266,23.38,0.16,0.474,69449,NULL,NULL,'4','NGC 6822',NULL,'2013MNRAS.428.2216W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145267,'Miras','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145267,23.43,NULL,0.485,69449,NULL,18.39,NULL,'NGC 6822',NULL,'2012Ap&SS.341..123W',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145268,'Miras','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145268,23.56,0.03,0.515,69449,NULL,NULL,'50','NGC 6822',NULL,'2013MNRAS.428.2216W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145269,'PNLF','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145269,23.64,0.23,0.535,69449,NULL,NULL,'26','NGC 6822',NULL,'2009A&A...495..447H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145270,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145270,23.34,0.1,0.466,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2003AJ....125.3097W',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145271,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145271,23.98,NULL,0.625,69449,NULL,NULL,'I, M RC(I) = -0.50 mag','NGC 6822',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145272,'Red Clump','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145272,24.18,NULL,0.685,69449,NULL,NULL,'V, M RC(V) = +0.73 mag','NGC 6822',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145273,'RR Lyrae','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145273,23.36,0.17,0.47,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2003ApJ...588L..85C',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145274,'RR Lyrae','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145274,23.43,NULL,0.485,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145275,'RR Lyrae','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145275,23.49,0.05,0.499,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2012MNRAS.421.2998F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145276,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145276,23.26,0.07,0.449,69449,NULL,NULL,'K','NGC 6822',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145277,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145277,23.31,0.05,0.459,69449,NULL,NULL,'J','NGC 6822',NULL,'2011AJ....141..194G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145278,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145278,23.32,0.1,0.461,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145279,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145279,23.34,0.12,0.466,69449,NULL,NULL,'I, MI = _4.04 mag','NGC 6822',NULL,'2005A&A...429..837C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145280,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145280,23.37,0.07,0.472,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2004ApJ...608...42S',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145281,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145281,23.39,0.16,0.476,69449,NULL,NULL,'HST KP Calibrated','NGC 6822',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145282,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145282,23.4,0.1,0.479,69449,NULL,NULL,'Z','NGC 6822',NULL,'1996AJ....112.1928G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145283,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145283,23.41,0.06,0.48,69449,74.4,NULL,NULL,'NGC 6822',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145284,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,'R',145284,23.41,0.17,0.481,69449,NULL,NULL,'JHK','NGC 6822',NULL,'2008JASS...25..249S',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145285,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145285,23.44,0.16,0.488,69449,NULL,NULL,'I, avg','NGC 6822',NULL,'2003AJ....125.3097W',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145286,'TRGB','2016-12-15 15:15:49','2016-12-16 11:21:04','1',NULL,NULL,145286,23.46,0.1,0.492,69449,NULL,NULL,'I','NGC 6822',NULL,'1993ApJ...417..553L',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145287,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145287,23.5,NULL,0.501,69449,NULL,NULL,'I','NGC 6822',NULL,'2011ApJ...738...58H',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145288,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145288,23.51,0.05,0.504,69449,NULL,NULL,'I, Z correct','NGC 6822',NULL,'2012A&A...548A.129F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145289,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145289,23.53,0.05,0.508,69449,NULL,NULL,'I, Mean of 2','NGC 6822',NULL,'2012A&A...548A.129F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145290,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145290,23.54,0.05,0.511,69449,NULL,NULL,'I','NGC 6822',NULL,'2012A&A...548A.129F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145291,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145291,23.6,0.12,0.525,69449,NULL,NULL,NULL,'NGC 6822',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145292,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145292,23.61,NULL,0.527,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145293,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145293,23.61,NULL,0.527,69449,NULL,NULL,'DA90','NGC 6822',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145294,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145294,23.64,NULL,0.535,69449,NULL,NULL,'theory','NGC 6822',NULL,'1997MNRAS.289..406S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145295,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145295,23.64,0.19,0.535,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1996AJ....112.1928G',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145296,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145296,23.68,NULL,0.545,69449,NULL,NULL,'Yale','NGC 6822',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145297,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145297,23.73,NULL,0.557,69449,NULL,NULL,'K97','NGC 6822',NULL,'1998MNRAS.298..166S',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145298,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145298,24,NULL,0.631,69449,NULL,NULL,'I, M TRGB(I) = -4.05 mag','NGC 6822',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145299,'Statistical','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145299,23.36,0.01,0.469,69449,NULL,NULL,'12 estimates','NGC 6822',NULL,'2014arXiv1410.7843C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145300,'HII region diameter','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145300,24.47,0.13,0.783,69449,NULL,NULL,'Method 2','NGC 6822',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145301,'HII region diameter','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145301,24.69,0.15,0.867,69449,NULL,NULL,'Method 1','NGC 6822',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145302,'Magnitude','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145302,24.02,0.11,0.637,69449,NULL,NULL,NULL,'NGC 6822',NULL,'1982MNRAS.201..145H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145303,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145303,24.23,0.4,0.7,69449,75,NULL,'B','NGC 6822',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145304,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145304,25.48,NULL,1.25,69449,NULL,NULL,'LEDA [April 2006]','NGC 6822',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145305,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145305,32.33,0.16,29.2,69450,NULL,NULL,'I','IC 4889',NULL,'2001ApJ...546..681T',2001,1,2.9,NULL,'G',0.000014,NULL,'12.06',1.7,'E5-6           Sy2',NULL,NULL,NULL,NULL,1,296.313125,-54.34414,0.181,NULL,49020623116,765947236,11967925,12.06),(145306,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145306,32.33,0.16,29.2,69450,NULL,NULL,NULL,'IC 4889',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145307,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145307,32.34,0.14,29.4,69450,74.4,NULL,NULL,'IC 4889',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145308,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145308,32.4,0.16,30.2,69450,NULL,NULL,'Malmquist cor.','IC 4889',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145309,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145309,32.16,0.4,27.1,69450,75,NULL,'Edat, raw','IC 4889',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145310,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145310,32.35,0.4,29.6,69450,75,NULL,'Edat, cor','IC 4889',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145311,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145311,30.87,0.65,14.9,69450,95,NULL,'Weighted Mean','IC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145312,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145312,32.06,0.81,25.8,69450,55,NULL,'Visvanathan & Sandage 1979','IC 4889',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145313,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145313,31.46,0.41,19.6,69450,NULL,NULL,NULL,'IC 4889',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145314,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145314,31.83,0.51,23.2,69450,70,NULL,NULL,'IC 4889',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145315,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145315,31.91,0.41,24.1,69450,NULL,NULL,'Malmquist cor.','IC 4889',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145316,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145316,32.55,0.8,32.3,69450,75,NULL,'B','IC 4889',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145317,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145317,32.02,0.45,25.3,69450,NULL,NULL,'K','IC 4889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145318,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145318,32.46,0.4,31.1,69450,NULL,NULL,'mean','IC 4889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145319,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145319,34.44,0.43,77.2,69451,75,NULL,'3.6 micron, color + selection bias corrected','ESO 398- G 029',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000023,NULL,'15.8',0.22,'Sbc            HII',NULL,NULL,NULL,NULL,1,296.318417,-34.74828,0.417,NULL,51202127574,800033243,12500519,15.8),(145320,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145320,34.88,NULL,94.5,69451,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 398- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145321,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145321,34.89,NULL,94.9,69451,NULL,NULL,'Dipole + Quadrupole','ESO 398- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145322,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145322,34.9,NULL,95.3,69451,NULL,NULL,'Dipole','ESO 398- G 029',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145323,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145323,34.27,0.8,71.5,69452,75,NULL,'MAT, I','ESO 338- G 022',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.73',0.4,'Sb',NULL,NULL,NULL,NULL,1,296.325916667,-38.33464,0.437,NULL,51179174637,799674603,12494915,15.73),(145324,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145324,33.67,0.32,54.1,69452,85,NULL,'I, raw','ESO 338- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145325,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145325,33.67,0.32,54.2,69452,85,NULL,'I, inv','ESO 338- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145326,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145326,33.77,0.43,56.7,69452,75,NULL,'MAT, I, raw','ESO 338- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145327,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145327,33.85,0.43,58.8,69452,75,NULL,'MAT, I, inv','ESO 338- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145328,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145328,34.19,0.43,68.8,69452,75,NULL,'MAT, I, cor','ESO 338- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145329,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145329,34.34,0.29,73.7,69452,NULL,NULL,NULL,'ESO 338- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145330,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145330,34.38,0.2,75.2,69452,74.4,NULL,NULL,'ESO 338- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145331,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145331,34.51,0.27,79.8,69452,NULL,NULL,'Malmquist cor.','ESO 338- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145332,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145332,36.77,0.59,226,69453,70,NULL,NULL,'2MASX J19451872-5211019',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,296.327875,-52.18383,0.137,NULL,51119069798,798735465,12480241,14.5),(145333,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145333,36.5,0.59,200,69454,70,NULL,NULL,'2MASX J19451954-1929035',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.331416667,-19.48428,0.373,NULL,47927917196,748873706,11701151,15.5),(145334,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145334,34.02,0.47,63.7,69455,70,NULL,NULL,'NGC 6812',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000097,NULL,'13.56',1.1,'S0: pec',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,296.350916667,-55.34681,0.153,NULL,49019851426,765935178,11967737,13.56),(145335,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145335,33.39,0.69,47.7,69456,100,NULL,'mid-IR','UGC 11473',NULL,'2013ApJ...771...88L',2013,1,1.8,'abs(b) < 10 degrees.','G',0.00001,NULL,'14.20',1.1,'Sd',NULL,NULL,NULL,NULL,1,296.3827917,43.14061,NULL,NULL,54968005133,858875080,13419923,14.2),(145336,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145336,33.53,0.2,50.8,69456,74.4,NULL,NULL,'UGC 11473',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145337,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145337,34.2,0.4,69.1,69456,NULL,NULL,'mean','UGC 11473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145338,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145338,34.37,0.47,74.9,69456,NULL,NULL,'H','UGC 11473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145339,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145339,34.45,0.46,77.7,69456,NULL,NULL,'J','UGC 11473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145340,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145340,34.52,0.45,80.1,69456,NULL,NULL,'K','UGC 11473',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145341,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145341,34.73,0.55,88.5,69457,70,NULL,NULL,'2MASX J19455058-0618280',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000047,NULL,'14.5R',0.5,'SB(s)c?        HII',NULL,NULL,NULL,NULL,1,296.460875,-6.30789,0.493,NULL,47870879610,747982493,11687226,14.5),(145342,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145342,35.56,0.2,129,69457,74.4,NULL,NULL,'2MASX J19455058-0618280',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145343,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145343,35.77,0.47,143,69457,NULL,NULL,'H','2MASX J19455058-0618280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145344,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145344,35.91,0.45,152,69457,NULL,NULL,'K','2MASX J19455058-0618280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145345,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145345,35.91,0.4,152,69457,NULL,NULL,'mean','2MASX J19455058-0618280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145346,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145346,35.99,0.46,158,69457,NULL,NULL,'J','2MASX J19455058-0618280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145347,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145347,34.91,0.8,96.1,69458,75,NULL,'MAT, I','ESO 232- G 023',NULL,'1997ApJS..109..333W',1997,1,1.3,'Marginal HIPASS detection.','G',0.000027,NULL,'14.98',1.1,'SA(s)c',NULL,NULL,NULL,NULL,1,296.468125,-50.29444,0.125,NULL,51119771168,798746424,12480412,14.98),(145348,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145348,33.68,0.43,54.4,69458,75,NULL,'MAT, I, inv','ESO 232- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145349,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145349,33.72,0.43,55.4,69458,75,NULL,'MAT, I, raw','ESO 232- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145350,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145350,34.01,0.43,63.4,69458,75,NULL,'MAT, I, cor','ESO 232- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145351,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145351,34.28,0.32,71.9,69458,85,NULL,'I, inv','ESO 232- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145352,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145352,34.29,0.32,72,69458,85,NULL,'I, raw','ESO 232- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145353,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145353,36.93,0.7,243,69459,70,NULL,NULL,'ESO 594- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.4R',1,'(R\'_1)SB(r)a',NULL,NULL,NULL,NULL,1,296.5120417,-19.05914,0.353,NULL,47928072048,748876125,11701189,15.4),(145354,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145354,36.83,0.68,233,69460,70,NULL,NULL,'2MASX J19461371-1931397',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.557083,-19.52767,0.369,NULL,47928116304,748876817,11701200,15.8),(145355,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145355,35.15,0.62,107,69461,70,NULL,NULL,'ESO 185- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'15.51',0.3,'SB(s)b? sp',NULL,NULL,NULL,NULL,1,296.5845,-55.72542,0.157,NULL,49011609869,765806404,11965725,15.51),(145356,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145356,37.61,0.7,333,69462,70,NULL,NULL,'2MASX J19462913-0931308',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.621417,-9.52522,0.557,NULL,47985176808,749768387,11715131,15.7),(145357,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145357,35.32,0.49,116,69463,75,NULL,'IR','ESO 232- G 024',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000033,NULL,'16.09',0.12,'Sbc',NULL,NULL,NULL,NULL,1,296.63425,-52.09944,0.137,NULL,51119026724,798734792,12480231,16.09),(145358,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145358,35.69,0.57,138,69463,NULL,NULL,'Malmquist cor.','ESO 232- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145359,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145359,35.72,0.56,139,69463,NULL,NULL,NULL,'ESO 232- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145360,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145360,35.73,NULL,140,69463,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 232- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145361,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145361,35.74,NULL,141,69463,NULL,NULL,'Dipole + Quadrupole','ESO 232- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145362,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145362,35.76,0.2,142,69463,74.4,NULL,NULL,'ESO 232- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145363,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145363,35.77,NULL,143,69463,NULL,NULL,'Dipole','ESO 232- G 024',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145364,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145364,35.77,NULL,143,69463,NULL,NULL,NULL,'ESO 232- G 024',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145365,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145365,36.98,0.92,249,69464,70,NULL,NULL,'2MASX J19463331-2222559',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.638791667,-22.38219,0.381,NULL,47919354455,748739913,11699061,15.8),(145366,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145366,33.33,0.2,46.3,69465,74.4,NULL,NULL,'UGC 11475',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00004,NULL,'15.10',0.8,'SBd',NULL,NULL,NULL,NULL,1,296.6720417,59.7005,0.433,NULL,52972589982,827696718,12932761,15.1),(145367,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145367,43.95,0.33,2740,69466,69.7,NULL,'Calibrated','GRB 020813',1.254,'2009MNRAS.400..775C',2009,1,NULL,NULL,'G',0.005,NULL,'24.8R',NULL,'HETE',NULL,NULL,NULL,NULL,1,296.6745,-19.60142,0.369,NULL,47927399373,748865615,11701025,24.8),(145368,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145368,44.01,0.41,2810,69466,72,NULL,NULL,'GRB 020813',1.254,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145369,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145369,44.07,0.43,2890,69466,69.7,NULL,'Fiducial','GRB 020813',1.254,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145370,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145370,44.11,0.41,2950,69466,70,NULL,NULL,'GRB 020813',1.254,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145371,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145371,45,1.07,3240,69466,73,NULL,'H const./H=100','GRB 020813',1.254,'2006astro.ph..9262M',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145372,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145372,44.92,0.18,4280,69466,69.7,NULL,'Calibrated','GRB 020813',1.254,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145373,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145373,42.38,NULL,2990,69467,70,NULL,'Pseudo z = 1.37','GRB 020813',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'G',0.005,NULL,'24.8R',NULL,'HETE',NULL,NULL,NULL,NULL,1,296.6745,-19.60142,0.369,NULL,47927399373,748865615,11701025,24.8),(145374,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145374,34.24,0.48,70.4,69468,70,NULL,NULL,'ESO 105- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000053,NULL,'15.3b',0.2,'S 0 :',NULL,NULL,NULL,NULL,1,296.6854583,-65.24697,0.277,NULL,49227004331,769171942,12018311,15.3),(145375,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145375,36.79,0.61,228,69469,70,NULL,NULL,'2MASX J19464712-1157209',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.6964583,-11.95569,0.589,NULL,47984751455,749761741,11715027,16.2),(145376,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145376,32.87,0.43,37.4,69470,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11477',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00005,NULL,'15.3',0.2,'Sd',NULL,NULL,NULL,NULL,1,296.746791667,56.91067,0.677,NULL,53002998341,828171849,12940185,15.3),(145377,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145377,33.2,0.49,43.7,69470,75,NULL,'IR','UGC 11477',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145378,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145378,33.64,0.4,53.5,69470,NULL,NULL,'mean','UGC 11477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145379,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145379,33.66,0.47,54,69470,NULL,NULL,'H','UGC 11477',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145380,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'N',145380,38.21,NULL,438,69471,65,NULL,'L = 10e57 photons/s','GRB 910122',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145381,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'N',145381,41.04,NULL,1610,69471,65,NULL,'L = 2 x 10e58 photons/s','GRB 910122',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145382,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145382,35.7,0.47,138,69472,70,NULL,NULL,'ESO 594- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000117,NULL,'14.3R',0.3,'S0',NULL,NULL,NULL,NULL,1,296.772,-20.20558,0.393,NULL,47925563976,748836937,11700577,14.3),(145383,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145383,35.94,0.72,154,69473,70,NULL,NULL,'2MASX J19470550-0543308',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.1I',0.1,'E',NULL,NULL,NULL,NULL,1,296.772958333,-5.72525,0.501,NULL,47901306147,748457908,11694654,15.1),(145384,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145384,33.78,0.49,57.1,69474,75,NULL,'IR','NGC 6829',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.00004,NULL,'14.91',0.4,'Sb',NULL,NULL,NULL,NULL,1,296.7815,59.90708,0.433,NULL,52981325988,827833218,12934894,14.91),(145385,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145385,36.57,0.51,206,69475,70,NULL,NULL,'2MASX J19470986-2244562',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,296.791208333,-22.749,0.401,NULL,47916436504,748694320,11698348,13.3),(145386,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145386,35.66,0.55,135,69476,70,NULL,NULL,'2MASX J19471745-6142362',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.82275,-61.71017,0.265,NULL,49023597954,765993718,11968651,15.1),(145387,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145387,35.84,0.51,147,69477,70,NULL,NULL,'2MASX J19472031-0900519',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.7I',0.5,NULL,NULL,NULL,NULL,NULL,1,296.834667,-9.01442,0.477,NULL,47871689068,747995141,11687424,13.7),(145388,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145388,33.86,0.51,59.2,69478,70,NULL,NULL,'2MASX J19473300-1006561',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'13.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.8875,-10.11558,0.521,NULL,47985575303,749774614,11715228,13.4),(145389,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145389,35.48,0.64,125,69479,70,NULL,NULL,'2MASX J19473426-0837531',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,296.89275,-8.63144,0.481,NULL,47871907199,747998549,11687477,14),(145390,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145390,36.17,0.53,171,69480,70,NULL,NULL,'ESO 025- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.5b',0.4,'S0',NULL,NULL,NULL,NULL,1,296.938875,-79.19428,0.549,NULL,48547702211,758557847,11852466,16.5),(145391,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145391,36.2,0.84,173,69481,70,NULL,NULL,'2MASX J19474588-1415550',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,296.94125,-14.26528,0.713,NULL,47965858044,749466531,11710414,15.3),(145392,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145392,34.98,0.6,99.2,69482,70,NULL,NULL,'ESO 142- G 043',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.99',0.2,'Compact',NULL,NULL,NULL,NULL,1,297.0177917,-59.52428,0.201,NULL,49032773234,766137081,11970891,15.99),(145393,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145393,36.26,0.61,178,69483,70,NULL,NULL,'2MASX J19480771-1803534',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.032083,-18.06478,0.357,NULL,47973926600,749592603,11712384,15.5),(145394,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145394,34.58,0.45,82.5,69484,NULL,NULL,NULL,'ESO 526- G 006',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.00002,NULL,'14.32',0.4,'Sb:',NULL,NULL,NULL,NULL,1,297.0559583,-23.50956,0.429,NULL,47915803307,748684426,11698194,14.32),(145395,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145395,34.62,0.2,84,69484,74.4,NULL,NULL,'ESO 526- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145396,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145396,34.68,0.43,86.4,69484,NULL,NULL,'Malmquist cor.','ESO 526- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145397,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145397,35.47,0.63,124,69485,70,NULL,NULL,'2MASX J19481765-1418284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.0735,-14.30783,0.713,NULL,47965670564,749463602,11710368,14.8),(145398,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145398,31.85,0.8,23.4,69486,75,NULL,'MAT, I','UGCA 416',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000022,NULL,'14.5',1.6,'(R\')SB(s)m pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,297.0915,-18.07836,0.397,NULL,47971843186,749560049,11711875,14.5),(145399,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145399,31.94,0.8,24.4,69486,75,NULL,NULL,'UGCA 416',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145400,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145400,31.32,0.4,18.4,69486,NULL,NULL,NULL,'UGCA 416',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145401,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145401,31.32,0.4,18.4,69486,73,NULL,'opt','UGCA 416',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145402,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145402,31.44,0.32,19.4,69486,85,NULL,'I, inv','UGCA 416',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145403,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145403,31.46,0.32,19.6,69486,85,NULL,'I, raw','UGCA 416',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145404,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145404,31.66,0.2,21.5,69486,74.4,NULL,NULL,'UGCA 416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145405,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145405,31.83,0.43,23.3,69486,75,NULL,'MAT, I, inv','UGCA 416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145406,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145406,31.84,0.43,23.3,69486,75,NULL,'MAT, I, raw','UGCA 416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145407,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145407,32.04,0.43,25.5,69486,75,NULL,'MAT, I, cor','UGCA 416',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145408,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145408,36.57,0.7,206,69487,70,NULL,NULL,'2MASX J19482337-1226084',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,297.097417,-12.43567,0.581,NULL,47951417254,749240894,11706888,14.4),(145409,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145409,34.74,0.49,88.5,69488,75,NULL,'IR','CGCG 397-007',NULL,'2011yCatp016004901K',2011,1,0.78,NULL,'G',0.000117,NULL,'15.5',0.22,'Spiral',NULL,NULL,NULL,NULL,1,297.225917,3.48633,0.993,NULL,54156429487,846194210,13221784,15.5),(145410,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145410,35.68,0.57,137,69489,70,NULL,NULL,'2MASX J19490651-0455554',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'13.6I',0.2,'S',NULL,NULL,NULL,NULL,1,297.2772083,-4.93197,0.481,NULL,47901812660,748465822,11694778,13.6),(145411,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145411,34.63,0.66,84.4,69490,70,NULL,NULL,'2MASX J19492513-1038297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.354625,-10.64167,0.553,NULL,47998090019,749970156,11718283,14.7),(145412,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145412,33.6,0.8,52.5,69491,75,NULL,'MAT, I','IC 4892',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.76',0.4,'Sbc? sp','in a triple',NULL,NULL,NULL,1,297.3817083,-70.22744,0.245,NULL,49243286611,769426353,12022286,14.76),(145413,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145413,32.89,0.32,37.8,69491,85,NULL,'I, raw','IC 4892',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145414,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145414,32.9,0.32,38.1,69491,85,NULL,'I, inv','IC 4892',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145415,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145415,33.06,0.43,40.9,69491,75,NULL,'MAT, I, raw','IC 4892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145416,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145416,33.17,0.43,43.1,69491,75,NULL,'MAT, I, inv','IC 4892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145417,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145417,33.32,0.49,46.1,69491,75,NULL,'IR','IC 4892',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145418,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145418,33.35,0.43,46.9,69491,75,NULL,'MAT, I, cor','IC 4892',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145419,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145419,33.76,0.4,56.5,69491,NULL,NULL,'mean','IC 4892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145420,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145420,33.78,0.12,57.1,69491,NULL,NULL,NULL,'IC 4892',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145421,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145421,34.03,0.47,64,69491,NULL,NULL,'H','IC 4892',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145422,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145422,33.91,0.69,60.6,69492,100,NULL,'mid-IR','ESO 526- G 007',NULL,'2013ApJ...771...88L',2013,1,3.2,NULL,'G',0.00001,NULL,'15',2.2,'SA(r)b:',NULL,NULL,NULL,NULL,1,297.399417,-26.43231,0.633,NULL,51139359484,799052491,12485195,15),(145423,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145423,34.59,0.4,82.7,69492,NULL,NULL,'mean','ESO 526- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145424,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145424,34.79,0.47,90.7,69492,NULL,NULL,'H','ESO 526- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145425,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145425,34.85,0.45,93.4,69492,NULL,NULL,'K','ESO 526- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145426,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145426,34.89,0.46,95,69492,NULL,NULL,'J','ESO 526- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145427,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145427,36.37,0.56,188,69493,70,NULL,NULL,'2MASX J19493847-2156060',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,'SA(s)a',NULL,NULL,NULL,NULL,1,297.410166667,-21.93514,0.445,NULL,47919755538,748746180,11699159,13.9),(145428,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145428,35.09,0.54,104,69494,70,NULL,NULL,'2MASX J19493902-2254410',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,297.412667,-22.91142,0.421,NULL,47916214284,748690848,11698294,13.8),(145429,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145429,35.75,0.56,141,69495,70,NULL,NULL,'2MASX J19494420-0937357',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,297.434125,-9.62658,0.497,NULL,47997504837,749961013,11718140,14),(145430,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145430,34.56,0.49,81.7,69496,75,NULL,'IR','FGC 2264',NULL,'2011yCatp016004901K',2011,1,1.29,'The 6dF redshift z = 0.020229 confirms the value in 2000A&AS..143..421M.','G',0.00002,':','16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,297.4425417,-10.77444,0.553,NULL,47998266118,749972908,11718326,16.6),(145431,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145431,35.14,NULL,106,69496,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145432,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145432,35.14,NULL,107,69496,NULL,NULL,'Dipole','FGC 2264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145433,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145433,35.14,NULL,107,69496,NULL,NULL,'Dipole + Quadrupole','FGC 2264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145434,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145434,37.1,0.7,263,69497,70,NULL,NULL,'2MASX J19500201-0647518',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.7R',0.1,NULL,NULL,NULL,NULL,NULL,1,297.508458333,-6.79772,0.561,NULL,47873425430,748022272,11687848,15.7),(145435,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145435,36.34,0.59,185,69498,70,NULL,NULL,'2MASX J19500700-0902048',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.529167,-9.03467,0.465,NULL,47992340795,749880324,11716880,15.5),(145436,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145436,36.64,0.51,213,69499,70,NULL,NULL,'2MASX J19501232-1854242',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.551333,-18.90669,0.377,NULL,47926824445,748856631,11700884,14.9),(145437,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145437,36.17,0.79,171,69500,70,NULL,NULL,'2MASX J19501286-1804432',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,297.553666667,-18.07878,0.373,NULL,47971949002,749561703,11711901,14.6),(145438,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145438,35.99,0.64,158,69501,70,NULL,NULL,'2MASX J19501738-6411062',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.572583,-64.18511,0.225,NULL,49225024369,769141005,12017828,15.8),(145439,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145439,36.88,0.92,238,69502,70,NULL,NULL,'2MASX J19501880-0641280',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.0I',0.1,'E',NULL,NULL,NULL,NULL,1,297.578333,-6.69108,0.509,NULL,47873464551,748022883,11687857,15),(145440,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145440,36.6,0.74,209,69503,70,NULL,NULL,'2MASX J19502206-1328084',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.5919583,-13.46903,0.613,NULL,47963497418,749429647,11709838,16.2),(145441,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145441,34.77,0.43,89.8,69504,NULL,NULL,'Malmquist cor.','ESO 526- G 009',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16',0.3,'S...',NULL,NULL,NULL,NULL,1,297.615375,-24.52114,0.493,NULL,51272089095,801126392,12517599,16),(145442,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145442,34.87,0.41,94.4,69504,NULL,NULL,NULL,'ESO 526- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145443,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145443,34.91,0.2,95.9,69504,74.4,NULL,NULL,'ESO 526- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145444,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145444,36.14,0.55,169,69505,70,NULL,NULL,'2MASX J19502838-0600270',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,297.61825,-6.00747,0.401,NULL,47901322280,748458160,11694658,13.5),(145445,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145445,34.97,0.8,98.8,69506,75,NULL,'MAT, I','ESO 461- G 003',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.00002,NULL,'14.75',0.6,'SA(rs)bc?',NULL,NULL,NULL,NULL,1,297.663167,-28.262,0.653,NULL,51150804392,799231318,12487989,14.75),(145446,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145446,33.99,0.43,62.7,69506,75,NULL,'MAT, I, raw','ESO 461- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145447,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145447,34.13,0.32,67.1,69506,85,NULL,'I, raw','ESO 461- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145448,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145448,34.19,0.32,69,69506,85,NULL,'I, inv','ESO 461- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145449,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145449,34.25,0.43,70.7,69506,75,NULL,'MAT, I, inv','ESO 461- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145450,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145450,34.47,0.43,78.5,69506,75,NULL,'MAT, I, cor','ESO 461- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145451,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145451,34.68,0.4,86.1,69506,NULL,NULL,'Malmquist cor.','ESO 461- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145452,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145452,34.68,0.49,86.5,69506,75,NULL,'IR','ESO 461- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145453,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145453,34.87,0.36,94.3,69506,NULL,NULL,NULL,'ESO 461- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145454,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145454,34.91,0.2,95.9,69506,74.4,NULL,NULL,'ESO 461- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145455,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145455,35.12,0.47,106,69506,NULL,NULL,'H','ESO 461- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145456,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145456,35.19,0.4,109,69506,NULL,NULL,'mean','ESO 461- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145457,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145457,35.3,0.45,115,69506,NULL,NULL,'K','ESO 461- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145458,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145458,35.33,0.46,116,69506,NULL,NULL,'J','ESO 461- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145459,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145459,35.43,0.55,122,69507,70,NULL,NULL,'2MASX J19504830-1914515',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,297.701291667,-19.24764,0.389,NULL,47928728421,748886381,11701349,13.5),(145460,'SGRB','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'N',145460,42.87,NULL,3750,69508,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 070429A HOST',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145461,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145461,34.41,0.44,76.2,69509,NULL,NULL,NULL,'ESO 233- G 003',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.66',0.6,'SA(s)d:',NULL,NULL,NULL,NULL,1,297.70625,-47.37442,0.173,NULL,51112687015,798635734,12478683,15.66),(145462,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145462,34.45,0.2,77.6,69509,74.4,NULL,NULL,'ESO 233- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145463,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145463,34.45,0.43,77.7,69509,NULL,NULL,'Malmquist cor.','ESO 233- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145464,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145464,33.19,0.47,43.5,69510,NULL,NULL,'H','2MASX J19505731+1822281',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000022,NULL,'14.18',0.33,'Spiral',NULL,NULL,NULL,NULL,1,297.738791667,18.3745,NULL,NULL,54028791337,844199864,13190622,14.18),(145465,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145465,33.29,0.46,45.6,69510,NULL,NULL,'J','2MASX J19505731+1822281',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145466,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145466,33.3,0.45,45.7,69510,NULL,NULL,'K','2MASX J19505731+1822281',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145467,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145467,33.46,0.4,49.1,69510,NULL,NULL,'mean','2MASX J19505731+1822281',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145468,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145468,34.53,0.46,80.4,69511,70,NULL,NULL,'ESO 461- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000057,NULL,'14.44',0.8,'S0',NULL,NULL,NULL,NULL,1,297.770541667,-30.75794,0.497,NULL,51148960972,799202515,12487539,14.44),(145469,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145469,35.43,0.63,122,69512,70,NULL,NULL,'2MASX J19511573-3103045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'16.49',NULL,NULL,NULL,NULL,NULL,NULL,1,297.815541667,-31.05133,0.497,NULL,51148994539,799203039,12487547,16.49),(145470,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145470,35.21,0.49,110,69513,70,NULL,NULL,'CGCG 371-005',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00011,NULL,'15.4',0.2,'E',NULL,NULL,NULL,NULL,1,297.835833,-2.26178,0.609,NULL,47905571112,748524548,11695696,15.4),(145471,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145471,35.44,0.55,122,69514,70,NULL,NULL,'2MASX J19512142-3240205',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.839375,-32.67242,0.529,NULL,51195449366,799928896,12498889,14.4),(145472,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145472,35.28,0.4,114,69515,NULL,NULL,'mean','UGC 11488',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.00002,NULL,'14.5',0.9,'Sbc',NULL,NULL,NULL,NULL,1,297.86375,3.56097,0.861,NULL,54154695244,846167113,13221361,14.5),(145473,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145473,35.62,0.47,133,69515,NULL,NULL,'H','UGC 11488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145474,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145474,35.21,0.56,110,69516,70,NULL,NULL,'2MASX J19513838-1749450',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,297.909833,-17.82922,0.397,NULL,47972177384,749565271,11711957,14.2),(145475,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145475,35.36,0.54,118,69517,70,NULL,NULL,'2MASX J19514317-1244350',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,297.929917,-12.74297,0.593,NULL,47959733211,749370831,11708919,15.2),(145476,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145476,36.15,0.59,170,69518,70,NULL,NULL,'2MASX J19514661-2134553',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,297.9442083,-21.582,0.417,NULL,47917124459,748705069,11698516,14.6),(145477,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145477,34.9,0.48,95.5,69519,70,NULL,NULL,'MCG -05-47-001',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00006,NULL,'15.85',0.32,'S0','Compact group member',NULL,NULL,NULL,1,297.966416667,-30.80844,0.497,NULL,51148879855,799201247,12487519,15.85),(145478,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145478,34.44,0.43,77.4,69520,75,NULL,'3.6 micron, color + selection bias corrected','ESO 461- G 006',NULL,'2014MNRAS.444..527S',2014,1,2.24,NULL,'G',0.000033,NULL,'16.21',0.18,'Sbc',NULL,NULL,NULL,NULL,1,297.982541667,-31.97558,0.501,NULL,51191986452,799874788,12498043,16.21),(145479,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145479,34.56,NULL,81.7,69520,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 461- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145480,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145480,34.57,NULL,81.9,69520,NULL,NULL,'Dipole + Quadrupole','ESO 461- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145481,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145481,34.58,NULL,82.3,69520,NULL,NULL,'Dipole','ESO 461- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145482,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145482,36.16,0.87,171,69521,70,NULL,NULL,'2MASX J19515995-8344333',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,297.999375,-83.74258,0.529,NULL,48383403797,755990684,11812354,17.1),(145483,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145483,34.48,0.5,78.8,69522,NULL,NULL,NULL,'ESO 526- G 010',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.06',0.6,'S...',NULL,NULL,NULL,NULL,1,298.002917,-23.45067,0.397,NULL,50802103006,793782859,12402857,14.06),(145484,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145484,34.52,0.2,80.2,69522,74.4,NULL,NULL,'ESO 526- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145485,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145485,34.67,0.46,85.9,69522,NULL,NULL,'Malmquist cor.','ESO 526- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145486,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145486,33.95,0.69,61.6,69523,100,NULL,'mid-IR','UGC 11489',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.000017,NULL,'14.5',0.7,'Scd:',NULL,NULL,NULL,NULL,1,298.009333,4.77903,0.841,NULL,54144179703,846002807,13218793,14.5),(145487,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145487,35.76,0.5,142,69524,70,NULL,NULL,'2MASX J19520254-6048505',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,298.010541667,-60.814,0.169,NULL,49025687828,766026372,11969162,16),(145488,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145488,34.62,0.45,84,69525,NULL,NULL,'K','ESO 461- G 007',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000037,NULL,'14.31',0.7,'E2','Compact group member',NULL,NULL,NULL,1,298.036541667,-30.82575,0.497,NULL,51148878686,799201229,12487519,14.31),(145489,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145489,34.63,0.4,84.4,69525,NULL,NULL,'mean','ESO 461- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145490,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145490,36.88,0.57,238,69526,70,NULL,NULL,'2MASX J19521374-1153221',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.05725,-11.88958,0.705,NULL,47989221209,749831581,11716118,15.8),(145491,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145491,35.8,0.57,145,69527,70,NULL,NULL,'2MASX J19521912-1152131',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.079667,-11.87042,0.705,NULL,47990085768,749845090,11716329,14.6),(145492,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145492,33.79,0.59,57.3,69528,70,NULL,NULL,'ESO 073- G 013',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.39',0.8,'(R\')SAB(r)a',NULL,NULL,NULL,NULL,1,298.119333,-69.67961,0.261,NULL,49244164855,769440075,12022501,14.39),(145493,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145493,35.92,0.6,153,69529,70,NULL,NULL,'2MASX J19523251-1008361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.135583333,-10.14339,0.517,NULL,47999388257,749990441,11718600,16),(145494,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145494,36.37,0.69,188,69530,70,NULL,NULL,'2MASX J19523585-2222422',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.1494583,-22.37839,0.425,NULL,50803817006,793809640,12403275,15.5),(145495,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145495,33.05,0.43,40.7,69531,75,NULL,'3.6 micron, color corrected','UGC 11492',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000023,NULL,'13.9',1,'SAB(s)bc',NULL,NULL,NULL,NULL,1,298.16625,57.45992,0.753,NULL,53002471296,828163614,12940056,13.9),(145496,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145496,33.07,0.43,41.2,69531,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11492',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145497,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145497,33.08,0.2,41.3,69531,74.4,NULL,NULL,'UGC 11492',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145498,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145498,33.27,0.4,45,69531,NULL,NULL,NULL,'UGC 11492',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145499,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145499,33.28,0.4,45.2,69531,NULL,NULL,'Malmquist cor.','UGC 11492',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145500,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145500,33.6,0.4,52.4,69531,NULL,NULL,'mean','UGC 11492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145501,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145501,33.71,0.47,55.3,69531,NULL,NULL,'H','UGC 11492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145502,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145502,33.72,0.46,55.5,69531,NULL,NULL,'J','UGC 11492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145503,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145503,33.77,0.45,56.7,69531,NULL,NULL,'K','UGC 11492',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145504,'RR Lyrae','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'N',145504,19.13,0.15,0.067,69532,NULL,NULL,'1','Sagittarius II/Laevens 5',NULL,'2015ApJ...813...44L',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145505,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145505,35.62,0.51,133,69533,70,NULL,NULL,'ESO 233- G 005',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.31',0.2,'N',NULL,NULL,NULL,NULL,1,298.1735417,-49.07258,0.213,NULL,51114735636,798667744,12479183,15.31),(145506,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145506,34.34,0.51,73.6,69534,70,NULL,NULL,'2MASX J19525518-1752190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,298.229958333,-17.87186,0.429,NULL,47971556087,749555563,11711805,16.23),(145507,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145507,34.28,0.8,71.8,69535,75,NULL,'MAT, I','ESO 526- G 011',NULL,'1997ApJS..109..333W',1997,1,1.85,NULL,'G',0.000033,NULL,'14.26',0.17,'Sd',NULL,NULL,NULL,NULL,1,298.23,-25.15,0.561,NULL,51274659196,801166549,12518227,14.26),(145508,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145508,34.44,0.43,77.1,69535,75,NULL,'MAT, I, raw','ESO 526- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145509,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145509,34.48,NULL,78.6,69535,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 526- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145510,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145510,34.49,NULL,79,69535,NULL,NULL,'Dipole','ESO 526- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145511,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145511,34.49,NULL,79.2,69535,NULL,NULL,'Dipole + Quadrupole','ESO 526- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145512,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145512,34.5,0.32,79.4,69535,85,NULL,'I, raw','ESO 526- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145513,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145513,34.52,0.32,80.2,69535,85,NULL,'I, inv','ESO 526- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145514,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145514,34.53,0.39,80.5,69535,NULL,NULL,NULL,'ESO 526- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145515,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145515,34.55,0.2,81.3,69535,74.4,NULL,NULL,'ESO 526- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145516,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145516,34.57,0.43,82.1,69535,75,NULL,'MAT, I, inv','ESO 526- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145517,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145517,34.58,0.38,82.6,69535,NULL,NULL,'Malmquist cor.','ESO 526- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145518,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145518,34.64,0.43,84.7,69535,75,NULL,'3.6 micron, color corrected','ESO 526- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145519,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145519,34.66,0.43,85.5,69535,75,NULL,'3.6 micron, color + selection bias corrected','ESO 526- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145520,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145520,34.72,NULL,88.1,69535,NULL,NULL,NULL,'ESO 526- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145521,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145521,34.85,0.43,93.4,69535,75,NULL,'MAT, I, cor','ESO 526- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145522,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145522,34.29,0.48,72.1,69536,70,NULL,NULL,'ESO 142- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000067,NULL,'13.81',0.8,'E4',NULL,NULL,NULL,NULL,1,298.2315,-60.98447,0.217,NULL,49026404271,766037566,11969336,13.81),(145523,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145523,34.28,0.49,71.9,69537,75,NULL,'IR','2MFGC 15174',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'12.0K',NULL,NULL,NULL,NULL,NULL,NULL,1,298.233875,-25.14997,0.561,NULL,51274659147,801166549,12518227,12),(145524,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145524,36.52,0.58,201,69538,70,NULL,NULL,'2MASX J19530399-1913324',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.2667083,-19.22561,0.489,NULL,47929343851,748895997,11701499,15),(145525,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145525,37.39,0.55,301,69539,70,NULL,NULL,'2MASX J19530739-2130154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.54',NULL,NULL,NULL,NULL,NULL,NULL,1,298.280875,-21.5045,0.493,NULL,47917737731,748714652,11698666,16.54),(145526,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145526,34.92,0.5,96.4,69540,70,NULL,NULL,'2MASX J19530976-1309342',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.290625,-13.15956,0.605,NULL,47960988108,749390439,11709225,14.1),(145527,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145527,37.79,0.61,361,69541,70,NULL,NULL,'2MASX J19531218-5500051',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.3007917,-55.00139,0.161,NULL,49017571602,765899556,11967180,15.5),(145528,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145528,36.01,0.54,159,69542,70,NULL,NULL,'2MASX J19531559-0823096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.315041667,-8.38597,0.445,NULL,47994558768,749914980,11717421,15.5),(145529,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145529,35.85,0.58,148,69543,70,NULL,NULL,'2MASX J19531806-2131444',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.32525,-21.52894,0.493,NULL,47917761691,748715026,11698672,14.9),(145530,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145530,36.4,0.59,190,69544,70,NULL,NULL,'2MASX J19532217-7026100',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,298.342541667,-70.43622,0.249,NULL,49212848342,768950755,12014855,16.3),(145531,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145531,34.56,0.49,81.7,69545,75,NULL,'IR','CGCG 397-014',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.6',0.1,NULL,NULL,NULL,NULL,NULL,1,298.3477083,8.34783,NULL,NULL,54164287174,846316987,13223702,15.6),(145532,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145532,36.78,0.57,227,69546,70,NULL,NULL,'2MASX J19532802-2009583',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.59',NULL,NULL,NULL,NULL,NULL,NULL,1,298.366583,-20.16606,0.537,NULL,47931879163,748935611,11702118,16.59),(145533,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145533,35.94,0.57,154,69547,70,NULL,NULL,'2MASX J19533741-2113418',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.54',NULL,NULL,NULL,NULL,NULL,NULL,1,298.405583,-21.22814,0.473,NULL,47916858819,748700919,11698451,16.54),(145534,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145534,34.65,0.8,85.1,69548,75,NULL,'MAT, I','ESO 461- G 010',NULL,'1997ApJS..109..333W',1997,1,1.79,NULL,'G',0.000033,NULL,'15.93',0.22,'Sb',NULL,NULL,NULL,NULL,1,298.51825,-30.48428,0.481,NULL,51149169870,799205779,12487590,15.93),(145535,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145535,33.98,0.32,62.5,69548,85,NULL,'I, raw','ESO 461- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145536,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145536,33.99,0.43,62.9,69548,75,NULL,'MAT, I, raw','ESO 461- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145537,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145537,34,0.32,63,69548,85,NULL,'I, inv','ESO 461- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145538,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145538,34.09,0.43,65.9,69548,75,NULL,'MAT, I, inv','ESO 461- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145539,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145539,34.24,NULL,70.5,69548,NULL,NULL,NULL,'ESO 461- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145540,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145540,34.43,0.43,77.1,69548,75,NULL,'MAT, I, cor','ESO 461- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145541,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145541,34.51,0.49,79.8,69548,75,NULL,'IR','ESO 461- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145542,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145542,34.69,NULL,86.5,69548,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 461- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145543,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145543,34.7,NULL,86.9,69548,NULL,NULL,'Dipole + Quadrupole','ESO 461- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145544,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145544,34.7,NULL,87.3,69548,NULL,NULL,'Dipole','ESO 461- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145545,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145545,34.8,0.41,91.3,69548,NULL,NULL,'Malmquist cor.','ESO 461- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145546,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145546,34.94,0.38,97.4,69548,NULL,NULL,NULL,'ESO 461- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145547,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145547,34.98,0.2,99.1,69548,74.4,NULL,NULL,'ESO 461- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145548,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145548,35.18,0.53,108,69549,70,NULL,NULL,'2MFGC 15190',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,'(RL)S0^0',NULL,NULL,NULL,NULL,1,298.5394583,-66.01142,0.221,NULL,49238859945,769357186,12021206,16.2),(145549,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145549,36.07,0.76,163,69550,70,NULL,NULL,'2MASX J19541557-0610339',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.7R',0.1,NULL,NULL,NULL,NULL,NULL,1,298.5649583,-6.17614,0.449,NULL,47869722280,747964410,11686943,15.7),(145550,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145550,36.21,0.67,175,69551,70,NULL,NULL,'2MASX J19541812-1739309',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.5755417,-17.65864,0.433,NULL,47978868060,749669813,11713590,15.5),(145551,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145551,36.79,0.56,228,69552,70,NULL,NULL,'2MASX J19542259-1728599',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.594083,-17.48331,0.433,NULL,47978820220,749669065,11713579,15.3),(145552,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145552,31.96,0.8,24.7,69553,75,NULL,'MAT, I','IC 4901',NULL,'1997ApJS..109..333W',1997,1,4.8,NULL,'G',0.00001,NULL,'12.29',3.2,'SAB(r)c        LINER','in a pair',NULL,NULL,NULL,1,298.598041667,-58.71356,0.129,NULL,49034381567,766162211,11971284,12.29),(145553,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145553,32.16,0.8,27.1,69553,75,NULL,NULL,'IC 4901',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145554,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145554,31.26,0.36,17.9,69553,NULL,NULL,NULL,'IC 4901',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145555,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145555,31.26,0.4,17.9,69553,73,NULL,'opt','IC 4901',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145556,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145556,31.38,0.43,18.9,69553,75,NULL,'MAT, I, raw','IC 4901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145557,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145557,31.51,0.43,20,69553,75,NULL,'MAT, I, inv','IC 4901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145558,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145558,31.65,0.32,21.4,69553,85,NULL,'I, raw','IC 4901',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145559,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145559,31.68,0.32,21.7,69553,85,NULL,'I, inv','IC 4901',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145560,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145560,31.77,0.43,22.6,69553,75,NULL,'MAT, I, cor','IC 4901',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145561,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145561,32.06,0.45,25.9,69553,NULL,NULL,'K','IC 4901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145562,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145562,32.09,0.47,26.2,69553,NULL,NULL,'H','IC 4901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145563,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145563,32.11,0.46,26.4,69553,NULL,NULL,'J','IC 4901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145564,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145564,32.16,0.4,27.1,69553,NULL,NULL,'mean','IC 4901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145565,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145565,35.45,0.5,123,69554,70,NULL,NULL,'AM 1950-471',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'14.2R',NULL,'COMPACT',NULL,NULL,NULL,NULL,1,298.60425,-47.04147,0.145,NULL,51121146760,798767918,12480748,14.2),(145566,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 1962J','R',145566,32.54,NULL,32.2,69555,NULL,NULL,'Photographic','NGC 6835',NULL,'1988SSRv...48....1R',1988,1,2.3,NULL,'G',0.00003,NULL,'13.41',0.5,'SB(s)a? sp','in a pair',NULL,NULL,NULL,1,298.637291667,-12.56758,0.537,NULL,47961585608,749399775,11709371,13.41),(145567,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145567,31.79,0.8,22.8,69555,75,NULL,'B','NGC 6835',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145568,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145568,30.52,0.39,12.7,69555,73,NULL,'opt','NGC 6835',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145569,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145569,36.06,0.82,163,69556,70,NULL,NULL,'2MASX J19543755-0323485',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.7R',0.1,'E',NULL,NULL,NULL,NULL,1,298.6565417,-3.39683,0.573,NULL,47900036359,748438068,11694344,15.7),(145570,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145570,35.73,0.6,140,69557,70,NULL,NULL,'ESO 526- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.8R',0.4,'Sa:',NULL,NULL,NULL,NULL,1,298.661583,-25.33472,0.565,NULL,51275318031,801176844,12518388,14.8),(145571,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145571,31.84,0.8,23.3,69558,75,NULL,NULL,'NGC 6836',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00002,NULL,'13.40',1.3,'SABm','in a pair',NULL,NULL,NULL,1,298.666916667,-12.68794,0.549,NULL,47961593149,749399892,11709373,13.4),(145572,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145572,34.23,0.51,70.2,69559,70,NULL,NULL,'2MASX J19545644-0628535',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.3R',0.5,'HII',NULL,NULL,NULL,NULL,1,298.735125,-6.48153,0.505,NULL,47869754850,747964919,11686951,13.3),(145573,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145573,34.09,0.47,65.8,69560,70,NULL,NULL,'ESO 526- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15',0.8,'(R\'_1R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,298.8029583,-23.27289,0.485,NULL,50805562548,793836914,12403701,15),(145574,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145574,34.33,0.8,73.4,69561,75,NULL,'MAT, I','ESO 185- G 026',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.81',0.3,'Sab: sp',NULL,NULL,NULL,NULL,1,298.828166667,-54.99306,0.173,NULL,49017083386,765891927,11967061,15.81),(145575,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145575,34.25,0.43,70.7,69561,75,NULL,'MAT, I, raw','ESO 185- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145576,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145576,34.26,0.32,71,69561,85,NULL,'I, raw','ESO 185- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145577,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145577,34.3,0.32,72.3,69561,85,NULL,'I, inv','ESO 185- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145578,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145578,34.33,0.43,73.6,69561,75,NULL,'MAT, I, cor','ESO 185- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145579,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145579,34.44,0.43,77.3,69561,75,NULL,'MAT, I, inv','ESO 185- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145580,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145580,34.46,0.4,77.9,69561,NULL,NULL,'mean','ESO 185- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145581,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,'R',145581,34.49,0.49,79,69561,75,NULL,'IR','ESO 185- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145582,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145582,34.51,0.47,79.8,69561,NULL,NULL,'H','ESO 185- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145583,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145583,34.58,0.45,82.4,69561,NULL,NULL,'K','ESO 185- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145584,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145584,36.59,0.59,208,69562,70,NULL,NULL,'2MASX J19552055-0551458',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.9R',0.2,NULL,NULL,NULL,NULL,NULL,1,298.835583333,-5.86275,0.465,NULL,47899175151,748424611,11694134,14.9),(145585,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145585,37,0.6,251,69563,70,NULL,NULL,'2MASX J19552294-2135014',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.845625,-21.58375,0.457,NULL,50803740412,793808443,12403256,15.4),(145586,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145586,36.23,0.67,176,69564,70,NULL,NULL,'2MASX J19552677-5509199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,'E/S0',NULL,NULL,NULL,NULL,1,298.861625,-55.15556,0.149,NULL,49017173302,765893332,11967083,16.7),(145587,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145587,37.09,0.65,262,69565,70,NULL,NULL,'2MASX J19554294-0623046',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.928875,-6.38456,0.485,NULL,47991245864,749863216,11716612,15.6),(145588,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145588,36.37,0.57,188,69566,70,NULL,NULL,'2MASX J19554352-0432496',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.931417,-4.54714,0.521,NULL,47891090728,748298292,11692160,15.9),(145589,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145589,35.23,0.62,111,69567,70,NULL,NULL,'2MASX J19555392-1225091',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,298.97475,-12.41917,0.529,NULL,47957965166,749343205,11708487,15.2),(145590,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145590,35.97,0.67,156,69568,70,NULL,NULL,'2MASX J19560281-0517276',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.0117083,-5.29103,0.485,NULL,47899344935,748427264,11694176,15.9),(145591,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145591,33.53,0.24,50,69569,74.2,NULL,'SALT 2','MCG +07-41-001',0.015881,'2010ApJ...716..712A',2010,1,0.4,'abs(b) < 10 degrees.','G',0.000193,NULL,'13.2B',0.4,'E1:',NULL,NULL,NULL,NULL,1,299.053583333,40.43397,NULL,NULL,54976266075,859004157,13421939,13.2),(145592,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145592,34.12,0.09,66.7,69569,74.4,NULL,NULL,'MCG +07-41-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145593,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145593,34.2,0.21,68,69569,70,NULL,'SALT 2','MCG +07-41-001',0.015881,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145594,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145594,34.31,0.22,71.5,69569,65,NULL,'MLCS31','MCG +07-41-001',0.015881,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145595,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145595,34.32,0.23,71.8,69569,65,NULL,'SALT','MCG +07-41-001',0.015881,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145596,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145596,34.34,0.23,72.6,69569,65,NULL,'MLCS17','MCG +07-41-001',0.015881,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145597,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:04','1','SN 2002do',NULL,145597,34.45,0.3,76.5,69569,65,NULL,'SALT2','MCG +07-41-001',0.015881,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145598,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145598,36.15,0.72,169,69570,70,NULL,NULL,'2MASX J19561309-1638569',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.054583,-16.64919,0.481,NULL,47982446006,749725718,11714464,15.3),(145599,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145599,32.16,0.4,27.1,69571,75,NULL,'Edat, raw','ESO 185- G 027',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000123,NULL,'13.8',1,'SAB0-',NULL,NULL,NULL,NULL,1,299.060417,-56.91031,0.129,NULL,49053941929,766467842,11976060,13.8),(145600,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145600,32.35,0.4,29.6,69571,75,NULL,'Edat, cor','ESO 185- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145601,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145601,36.13,0.72,168,69572,70,NULL,NULL,'ESO 526- G 018 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,NULL,0.6,'S0 pec',NULL,NULL,NULL,NULL,1,299.121333,-25.92108,0.565,NULL,51274576482,801165257,12518207,NULL),(145602,'FP','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145602,37.14,0.54,268,69573,70,NULL,NULL,'2MASX J19562991-2056117',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.31',NULL,NULL,NULL,NULL,NULL,NULL,1,299.124667,-20.93669,0.497,NULL,47922077083,748782454,11699725,16.31),(145603,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145603,34.14,0.43,67.4,69574,75,NULL,'3.6 micron, color + selection bias corrected','ESO 339- G 008',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.000027,NULL,'14.76',0.4,'Sa:            HII',NULL,NULL,NULL,NULL,1,299.143416667,-38.10039,0.369,NULL,51184232031,799753625,12496150,14.76),(145604,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145604,34.2,0.43,69.2,69574,75,NULL,'3.6 micron, color corrected','ESO 339- G 008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145605,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145605,34.38,0.47,75.2,69574,NULL,NULL,'H','ESO 339- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145606,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145606,34.42,0.45,76.4,69574,NULL,NULL,'K','ESO 339- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145607,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145607,34.42,0.4,76.7,69574,NULL,NULL,'mean','ESO 339- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145608,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145608,34.43,0.2,76.9,69574,74.4,NULL,NULL,'ESO 339- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145609,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145609,34.49,0.46,79.1,69574,NULL,NULL,'J','ESO 339- G 008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145610,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145610,34.62,0.25,84.1,69574,NULL,NULL,'Malmquist cor.','ESO 339- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145611,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145611,34.73,0.23,88.3,69574,NULL,NULL,NULL,'ESO 339- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145612,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145612,36.41,0.57,192,69575,NULL,NULL,'Malmquist cor.','2MASX J19563521-3827142',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000027,NULL,'15.27',NULL,'Sc',NULL,NULL,NULL,NULL,1,299.146583,-38.45394,0.361,NULL,51184241592,799753774,12496152,15.27),(145613,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145613,36.54,0.54,204,69575,NULL,NULL,NULL,'2MASX J19563521-3827142',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145614,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:04','1',NULL,NULL,145614,36.58,0.2,207,69575,74.4,NULL,NULL,'2MASX J19563521-3827142',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145615,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145615,35.84,0.57,147,69576,70,NULL,NULL,'2MASX J19564116-1830077',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.1715,-18.50219,0.545,NULL,47921876616,748779322,11699676,15.4),(145616,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145616,33.53,0.48,50.9,69577,70,NULL,NULL,'6dF J1956475-602805',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.198083,-60.468,0.157,NULL,49038985353,766234146,11972408,12.5),(145617,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145617,37.24,0.6,280,69578,70,NULL,NULL,'2MASX J19564822-5235366',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,299.200958333,-52.59358,0.173,NULL,51111750680,798621104,12478454,14.2),(145618,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145618,36.55,0.49,204,69579,NULL,NULL,'Malmquist cor.','AGC 590071',NULL,'2009ApJS..182..474S',2009,1,0.66,NULL,'G',0.00003,NULL,'16.35',NULL,'Sc',NULL,NULL,NULL,NULL,1,299.2385417,-38.54714,0.353,NULL,51172753919,799574279,12493348,16.35),(145619,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145619,36.59,0.48,208,69579,NULL,NULL,NULL,'AGC 590071',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145620,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145620,36.63,0.2,212,69579,74.4,NULL,NULL,'AGC 590071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145621,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145621,35.56,0.61,129,69580,70,NULL,NULL,'2MASX J19570594-1849267',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.274708333,-18.82406,0.581,NULL,47921820358,748778443,11699663,15.5),(145622,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145622,36.49,0.72,198,69581,70,NULL,NULL,'2MASX J19570918-6010057',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.288375,-60.16819,0.153,NULL,49039718936,766245608,11972587,15.3),(145623,'Sosies','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145623,34.03,0.44,64,69582,NULL,NULL,NULL,'UGC 11498',NULL,'2002A&A...393...57T',2002,1,3.2,NULL,'G',0.000027,NULL,'13.5',1,'SBb:',NULL,NULL,NULL,NULL,1,299.3125417,5.89042,0.849,NULL,54182077081,846594954,13228046,13.5),(145624,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145624,32.82,0.46,36.6,69582,NULL,NULL,'J','UGC 11498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145625,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145625,32.9,0.47,38,69582,NULL,NULL,'H','UGC 11498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145626,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145626,32.92,0.45,38.5,69582,NULL,NULL,'K','UGC 11498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145627,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145627,33.04,0.4,40.6,69582,NULL,NULL,'mean','UGC 11498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145628,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145628,34.25,0.59,70.8,69583,70,NULL,NULL,'ESO 399- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.00015,NULL,'15',0.4,'Sa?',NULL,NULL,NULL,NULL,1,299.325375,-32.478,0.457,NULL,51191639858,799869372,12497958,15),(145629,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145629,33.78,0.49,57.1,69584,75,NULL,'IR','ESO 185- G 031',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.67',0.3,'SB(s)ab',NULL,NULL,NULL,NULL,1,299.342333,-55.13711,0.149,NULL,49017225205,765894143,11967095,15.67),(145630,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145630,34.01,0.41,63.5,69584,NULL,NULL,NULL,'ESO 185- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145631,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145631,34.05,0.2,64.6,69584,74.4,NULL,NULL,'ESO 185- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145632,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145632,34.08,0.4,65.4,69584,NULL,NULL,'Malmquist cor.','ESO 185- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145633,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145633,36.08,0.65,165,69585,70,NULL,NULL,'2MASX J19572970-1923312',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.373791667,-19.39203,0.505,NULL,47923281466,748801272,11700019,15.8),(145634,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145634,36.51,0.7,200,69586,70,NULL,NULL,'2MASX J19573386-0946371',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.391125,-9.777,0.561,NULL,47988208889,749815763,11715871,16),(145635,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145635,33.69,0.56,54.6,69587,NULL,NULL,NULL,'CGCG 372-002',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.00002,NULL,'15.6',0.8,'Sc             HII',NULL,NULL,NULL,NULL,1,299.400875,-0.235,0.725,NULL,47889837624,748278712,11691854,15.6),(145636,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145636,33.73,0.2,55.7,69587,74.4,NULL,NULL,'CGCG 372-002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145637,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145637,34.3,0.42,72.4,69587,NULL,NULL,'Malmquist cor.','CGCG 372-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145638,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145638,33.94,0.47,61.4,69588,NULL,NULL,'H','ESO 339- G 011',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'12.47',0.4,'Sb        LIRG;Sy2',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,299.406583333,-37.93564,0.369,NULL,51185115313,799767426,12496366,12.47),(145639,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145639,33.96,0.45,62,69588,NULL,NULL,'K','ESO 339- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145640,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145640,34.07,0.5,65.2,69588,NULL,NULL,NULL,'ESO 339- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145641,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145641,34.08,0.46,65.5,69588,NULL,NULL,'J','ESO 339- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145642,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145642,34.11,0.2,66.4,69588,74.4,NULL,NULL,'ESO 339- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145643,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145643,34.3,0.45,72.4,69588,NULL,NULL,'Malmquist cor.','ESO 339- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145644,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145644,34.45,0.4,77.6,69588,NULL,NULL,'mean','ESO 339- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145645,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145645,35.78,0.59,143,69589,70,NULL,NULL,'2MASX J19574079-5907275',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.42,-59.12431,0.125,NULL,49036569262,766196394,11971818,15.1),(145646,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145646,30.85,0.32,14.8,69590,NULL,NULL,NULL,'ESO 461- G 022',NULL,'2009ApJS..182..474S',2009,1,1.5,'Springob et al. (2005ApJS..160..149S) give v= 6032 km/sec.','G',0.000033,NULL,'15.5',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,299.4317083,-30.71928,0.477,NULL,51276018350,801187786,12518559,15.5),(145647,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145647,31.41,0.24,19.1,69590,NULL,NULL,'Malmquist cor.','ESO 461- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145648,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145648,34.54,0.49,81,69590,75,NULL,'IR','ESO 461- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145649,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145649,35.8,0.75,145,69591,70,NULL,NULL,'2MASX J19574406-5231482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.4335417,-52.53014,0.173,NULL,51111764716,798621323,12478458,15.1),(145650,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145650,35.35,0.58,118,69592,70,NULL,NULL,'2MASX J19574703-2417517',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.4460417,-24.29775,0.581,NULL,50803228032,793800438,12403131,15.2),(145651,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145651,36.18,0.55,172,69593,70,NULL,NULL,'2MASX J19574891-5308417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,299.45375,-53.14503,0.097,NULL,51111113790,798611152,12478299,16.4),(145652,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145652,36.03,0.75,161,69594,70,NULL,NULL,'2MASX J19575466-1902325',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.477833,-19.04244,0.473,NULL,47923928292,748811379,11700177,15.8),(145653,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145653,34.35,0.47,74,69595,70,NULL,NULL,'ESO 399- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.22',1.3,'SA(s)0- pec:;D',NULL,NULL,NULL,NULL,1,299.499916667,-32.66336,0.441,NULL,51174820673,799606573,12493852,14.22),(145654,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145654,35.36,0.51,118,69596,70,NULL,NULL,'2MASX J19580336-1753173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'16.08',NULL,NULL,NULL,NULL,NULL,NULL,1,299.514083333,-17.88817,0.529,NULL,47976973502,749640210,11713128,16.08),(145655,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145655,34.12,0.8,66.8,69597,75,NULL,'MAT, I','ESO 185- G 036',NULL,'1997ApJS..109..333W',1997,1,1.71,NULL,'G',0.000033,NULL,'15.76',0.16,'Sb',NULL,NULL,NULL,NULL,1,299.553333,-55.68125,0.149,NULL,49050276335,766410567,11975165,15.76),(145656,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145656,34.26,NULL,71.2,69597,NULL,NULL,NULL,'ESO 185- G 036',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145657,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145657,34.32,0.48,73.1,69597,NULL,NULL,'Malmquist cor.','ESO 185- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145658,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145658,34.44,NULL,77.2,69597,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 185- G 036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145659,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145659,34.45,0.49,77.7,69597,75,NULL,'IR','ESO 185- G 036',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145660,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145660,34.47,NULL,78.2,69597,NULL,NULL,'Dipole + Quadrupole','ESO 185- G 036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145661,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145661,34.49,NULL,79.1,69597,NULL,NULL,'Dipole','ESO 185- G 036',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145662,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145662,34.55,0.43,81.1,69597,NULL,NULL,NULL,'ESO 185- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145663,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145663,34.55,0.43,81.2,69597,75,NULL,'MAT, I, raw','ESO 185- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145664,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145664,34.57,0.32,82.2,69597,85,NULL,'I, raw','ESO 185- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145665,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145665,34.59,0.2,82.8,69597,74.4,NULL,NULL,'ESO 185- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145666,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145666,34.6,0.32,83.2,69597,85,NULL,'I, inv','ESO 185- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145667,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145667,34.7,0.43,86.9,69597,75,NULL,'MAT, I, inv','ESO 185- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145668,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145668,34.71,0.43,87.7,69597,75,NULL,'MAT, I, cor','ESO 185- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145669,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145669,34.55,0.8,81.4,69598,75,NULL,'MAT, I','ESO 461- G 025',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000023,NULL,'14.48',0.9,'SB(rs)c pec?   HII',NULL,NULL,NULL,NULL,1,299.57,-31.77225,0.445,NULL,51145408481,799147007,12486671,14.48),(145670,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145670,33.9,0.32,60.3,69598,85,NULL,'I, raw','ESO 461- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145671,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145671,33.95,0.32,61.7,69598,85,NULL,'I, inv','ESO 461- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145672,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145672,33.97,0.43,62.3,69598,75,NULL,'MAT, I, raw','ESO 461- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145673,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145673,34.1,0.2,66.1,69598,74.4,NULL,NULL,'ESO 461- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145674,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145674,34.19,0.43,68.8,69598,75,NULL,'MAT, I, inv','ESO 461- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145675,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145675,34.31,0.43,72.8,69598,NULL,NULL,NULL,'ESO 461- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145676,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145676,34.39,0.43,75.5,69598,75,NULL,'MAT, I, cor','ESO 461- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145677,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145677,34.45,0.41,77.7,69598,NULL,NULL,'Malmquist cor.','ESO 461- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145678,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145678,34.65,0.47,85,69598,NULL,NULL,'H','ESO 461- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145679,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145679,34.72,0.4,87.8,69598,NULL,NULL,'mean','ESO 461- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145680,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145680,34.79,0.45,90.8,69598,NULL,NULL,'K','ESO 461- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145681,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145681,34.85,0.46,93.3,69598,NULL,NULL,'J','ESO 461- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145682,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145682,34.19,0.49,68.9,69599,70,NULL,NULL,'2MASX J19581838-1916401',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.36',NULL,NULL,NULL,NULL,NULL,NULL,1,299.57675,-19.27778,0.473,NULL,47924053500,748813335,11700208,15.36),(145683,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145683,34.92,0.5,96.6,69600,NULL,NULL,'Malmquist cor.','ESO 399- G 011',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16.11',0.3,'S...',NULL,NULL,NULL,NULL,1,299.587875,-36.41192,0.357,NULL,51187162500,799799414,12496865,16.11),(145684,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145684,35.27,0.43,113,69600,NULL,NULL,NULL,'ESO 399- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145685,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145685,35.31,0.2,115,69600,74.4,NULL,NULL,'ESO 399- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145686,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145686,35.72,0.55,139,69601,70,NULL,NULL,'2MASX J19582674-1549163',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,299.6115,-15.82117,0.513,NULL,47980035272,749688051,11713875,14.5),(145687,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145687,36.21,0.63,174,69602,70,NULL,NULL,'2MASX J19582797-0706497',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,299.616667,-7.11378,0.497,NULL,48037865530,750591648,11727994,14.4),(145688,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145688,36.79,0.61,228,69603,70,NULL,NULL,'2MASX J19583063-5237393',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,299.62775,-52.62761,0.173,NULL,51111588989,798618577,12478415,16.5),(145689,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145689,36.5,0.52,200,69604,70,NULL,NULL,'FAIRALL 0877',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.649125,-52.58603,0.173,NULL,51111555318,798618051,12478407,13.6),(145690,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145690,36.02,0.63,160,69605,70,NULL,NULL,'2MASX J19584348-5238234',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.6810417,-52.63978,0.173,NULL,51111585187,798618518,12478414,15.3),(145691,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145691,36.66,0.53,215,69606,70,NULL,NULL,'2MASX J19585126-1152462',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,299.713625,-11.87956,0.581,NULL,47987905681,749811026,11715797,13.6),(145692,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145692,36.31,0.67,183,69607,70,NULL,NULL,'2MASX J19585203-5229234',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.7167083,-52.48981,0.169,NULL,51111545690,798617901,12478404,15.1),(145693,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145693,35.38,0.16,114,69608,74.2,NULL,'SALT 2','2MASX J19585927-5615279',0.040485,'2010ApJ...716..712A',2010,1,1.3,NULL,'G',0.00015,NULL,'14.75',0.7,'SA(s)0^0^?',NULL,NULL,NULL,NULL,1,299.7470417,-56.25794,0.145,NULL,49054084855,766470075,11976094,14.75),(145694,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145694,36.19,0.15,166,69608,70,NULL,'SALT 2','2MASX J19585927-5615279',0.040485,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145695,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145695,36.12,0.09,167,69608,74.4,NULL,NULL,'2MASX J19585927-5615279',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145696,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145696,36.18,0.12,172,69608,70.8,NULL,NULL,'2MASX J19585927-5615279',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145697,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145697,36.32,0.03,177,69608,72,NULL,NULL,'2MASX J19585927-5615279',0.04,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145698,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145698,36.2,0.33,180,69608,67,NULL,NULL,'2MASX J19585927-5615279',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145699,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145699,36.37,0.08,181,69608,70,NULL,'SALT','2MASX J19585927-5615279',0.04,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145700,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145700,36.38,0.19,182,69608,65,NULL,NULL,'2MASX J19585927-5615279',0.04,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145701,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145701,36.32,0.16,184,69608,60,NULL,'M(V) = -19.47 mag','2MASX J19585927-5615279',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145702,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145702,36.32,0.15,184,69608,60,NULL,'M(I) = -19.19 mag','2MASX J19585927-5615279',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145703,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145703,36.34,0.21,185,69608,60,NULL,'M(B) = -19.48 mag','2MASX J19585927-5615279',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145704,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145704,36.56,0.17,189,69608,65,NULL,'MLCS2k2','2MASX J19585927-5615279',0.04,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145705,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1990T',NULL,145705,36.63,0.14,212,69608,60,NULL,NULL,'2MASX J19585927-5615279',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145706,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145706,35.77,0.49,142,69609,NULL,NULL,'Malmquist cor.','2MASX J19590008-3759096',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000027,NULL,'14.19',NULL,'Sbc',NULL,NULL,NULL,NULL,1,299.750375,-37.986,0.357,NULL,51173249181,799582018,12493469,14.19),(145707,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145707,36.06,0.43,163,69609,NULL,NULL,NULL,'2MASX J19590008-3759096',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145708,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145708,36.1,0.2,166,69609,74.4,NULL,NULL,'2MASX J19590008-3759096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145709,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145709,33.93,0.49,61,69610,75,NULL,'IR','ESO 339- G 013',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000027,NULL,'15.53',0.3,'Sb:',NULL,NULL,NULL,NULL,1,299.771916667,-38.01089,0.357,NULL,51173249849,799582028,12493469,15.53),(145710,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145710,34.73,0.4,88.5,69610,NULL,NULL,'Malmquist cor.','ESO 339- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145711,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145711,34.94,0.36,97.4,69610,NULL,NULL,NULL,'ESO 339- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145712,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145712,34.98,0.2,99.1,69610,74.4,NULL,NULL,'ESO 339- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145713,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145713,35.87,0.61,149,69611,NULL,NULL,'Malmquist cor.','2MASX J19590607-3829136',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000023,NULL,'15.24',NULL,'Sc',NULL,NULL,NULL,NULL,1,299.775333,-38.48719,0.357,NULL,51173486901,799585732,12493527,15.24),(145714,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145714,36.02,0.57,160,69611,NULL,NULL,NULL,'2MASX J19590607-3829136',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145715,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145715,36.06,0.2,163,69611,74.4,NULL,NULL,'2MASX J19590607-3829136',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145716,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145716,35.9,0.56,151,69612,70,NULL,NULL,'2MASX J19590667-7503320',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,299.778,-75.059,0.301,NULL,48502465744,757851027,11841422,17.1),(145717,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145717,36.83,0.54,232,69613,70,NULL,NULL,'2MASX J19591166-5942399',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.798625,-59.711,0.145,NULL,49039138363,766236536,11972445,15.3),(145718,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145718,35.35,0.51,118,69614,70,NULL,NULL,'CGCG 372-005',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5',NULL,NULL,NULL,NULL,NULL,NULL,1,299.844916667,-0.38039,0.649,NULL,47888816237,748262753,11691605,15.5),(145719,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145719,35.31,0.57,115,69615,70,NULL,NULL,'2MASX J19592803-4345535',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.866708333,-43.76489,0.165,NULL,51214096986,800220265,12503441,15.1),(145720,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145720,35.88,0.68,150,69616,NULL,NULL,'Malmquist cor.','AGC 590074',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.000033,NULL,'16.24',NULL,'Sc',NULL,NULL,NULL,NULL,1,299.883333,-38.32472,0.361,NULL,51173513304,799586145,12493533,16.24),(145721,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145721,35.9,0.68,151,69616,NULL,NULL,NULL,'AGC 590074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145722,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145722,35.94,0.2,154,69616,74.4,NULL,NULL,'AGC 590074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145723,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145723,33.65,0.47,53.7,69617,NULL,NULL,'H','CGCG 423-002',NULL,'2007A&A...465...71T',2007,1,0.67,NULL,'G',0.000107,NULL,'14.9',0.56,'Spiral',NULL,NULL,NULL,NULL,1,299.932417,14.76544,NULL,NULL,54074393223,844912394,13201756,14.9),(145724,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145724,33.81,0.46,57.9,69617,NULL,NULL,'J','CGCG 423-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145725,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145725,33.83,0.4,58.2,69617,NULL,NULL,'mean','CGCG 423-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145726,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145726,33.88,0.45,59.8,69617,NULL,NULL,'K','CGCG 423-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145727,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145727,35.46,0.5,124,69618,70,NULL,NULL,'2MASX J19594927-0002155',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.955333,-0.03775,0.665,NULL,47888889633,748263900,11691623,14.9),(145728,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145728,35.62,0.57,133,69619,70,NULL,NULL,'2MASX J19595082-1141219',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,299.96175,-11.68944,0.569,NULL,47987988587,749812321,11715817,14.5),(145729,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145729,37.29,0.64,287,69620,70,NULL,NULL,'2MASX J19595165-5343326',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,299.965333,-53.72575,0.193,NULL,51108219396,798565928,12477592,16.5),(145730,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145730,37.09,NULL,250,69621,NULL,NULL,NULL,'2MASX J19595975+6508547',0.047,'2005ApJ...635..173S',2005,1,NULL,'TXS codes: model(N);confusion(X);lobes(W)','G',NULL,NULL,'14.71',NULL,'E              BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,299.999375,65.14853,0.561,NULL,53638983062,838109110,13095454,14.71),(145731,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145731,34.79,NULL,90.6,69621,72,NULL,NULL,'2MASX J19595975+6508547',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145732,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145732,37.24,0.74,281,69621,72,NULL,NULL,'2MASX J19595975+6508547',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145733,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145733,37.16,0.58,271,69622,70,NULL,NULL,'2MASX J20000272-5244274',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.0112083,-52.74092,0.161,NULL,51111410779,798615793,12478371,15.8),(145734,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145734,34.64,0.51,84.7,69623,70,NULL,NULL,'ESO 461- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000027,NULL,'15.07',0.3,'SAB(r)ab?',NULL,NULL,NULL,NULL,1,300.014667,-32.08481,0.445,NULL,51296350594,801505478,12523523,15.07),(145735,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145735,32.88,0.22,37.1,69624,74.2,NULL,'SALT 2','IC 4919',0.01422,'2010ApJ...716..712A',2010,1,1.5,NULL,'G',0.000027,NULL,'14.98',0.7,'SB(s)dm pec','Pair member (points to parent)',NULL,NULL,NULL,1,300.0377083,-55.37339,0.149,NULL,49049987424,766406053,11975094,14.98),(145736,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145736,33.58,0.08,52,69624,74.4,NULL,NULL,'IC 4919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145737,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145737,33.65,0.15,53.7,69624,60,NULL,'M(V) = -19.47 mag','IC 4919',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145738,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145738,33.7,0.16,54.2,69624,70,NULL,'SALT','IC 4919',0.01422,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145739,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145739,33.68,0.14,54.5,69624,60,NULL,'M(B) = -19.48 mag','IC 4919',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145740,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145740,33.7,0.19,55,69624,60,NULL,'M(I) = -19.19 mag','IC 4919',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145741,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145741,33.74,0.21,55.3,69624,70,NULL,'SALT 2','IC 4919',0.01422,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145742,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145742,33.78,0.25,56.2,69624,72,NULL,NULL,'IC 4919',0.01422,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145743,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145743,33.78,0.03,56.3,69624,72,NULL,NULL,'IC 4919',0.01422,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145744,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145744,33.86,0.26,58.3,69624,65,NULL,'SALT2','IC 4919',0.01422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145745,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145745,33.9,0.06,60.3,69624,65,NULL,'LCS','IC 4919',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145746,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145746,33.94,0.17,61.4,69624,70.8,NULL,NULL,'IC 4919',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145747,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145747,34.01,0.1,61.5,69624,65,NULL,'MLCS2k2','IC 4919',0.01422,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145748,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145748,33.99,0.24,62,69624,65,NULL,'MLCS31','IC 4919',0.01422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145749,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145749,34,0.24,62.3,69624,65,NULL,'MLCS17','IC 4919',0.01422,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145750,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145750,34.04,0.14,64.3,69624,60,NULL,NULL,'IC 4919',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145751,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145751,34.13,0.25,66.1,69624,65,NULL,NULL,'IC 4919',0.01422,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145752,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145752,34.16,0.09,67,69624,65,NULL,'MLCS','IC 4919',0.01422,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145753,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 1991ag',NULL,145753,34.15,0.08,67.6,69624,65,NULL,'Snapshot','IC 4919',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145754,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145754,34.19,0.25,68.9,69625,74.4,NULL,NULL,'IC 4926',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000022,NULL,'13.85',1,'E?',NULL,NULL,NULL,NULL,1,300.050625,-38.57858,0.357,NULL,51173651288,799588301,12493567,13.85),(145755,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145755,34.59,0.4,82.7,69625,NULL,NULL,'mean','IC 4926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145756,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145756,34.82,0.45,92,69625,NULL,NULL,'K','IC 4926',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145757,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145757,36.15,0.58,170,69626,70,NULL,NULL,'2MASX J20002488-6048263',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,300.103583,-60.80736,0.149,NULL,49038350386,766224224,11972253,14.2),(145758,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145758,34.54,0.14,81.1,69627,70,NULL,NULL,'ABELL 3656',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];I  [A]',NULL,NULL,NULL,NULL,1,300.1337917,-38.52864,0.357,NULL,51173640079,799588126,12493564,NULL),(145759,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145759,34.25,0.47,70.8,69628,NULL,NULL,'H','ESO 399- G 014',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000003,NULL,'13.60',1.9,'SA(s)c pec     HII',NULL,NULL,NULL,NULL,1,300.147833333,-34.77756,0.373,NULL,51177602068,799650032,12494531,13.6),(145760,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145760,34.31,0.4,72.7,69628,NULL,NULL,'mean','ESO 399- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145761,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145761,34.41,0.46,76.1,69628,NULL,NULL,'J','ESO 399- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145762,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145762,34.62,0.44,84.1,69629,NULL,NULL,NULL,'2MASX J20003567-3837350',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000033,NULL,'15.27',NULL,'Sc',NULL,NULL,NULL,NULL,1,300.14875,-38.62642,0.357,NULL,51173647563,799588243,12493566,15.27),(145763,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145763,34.66,0.2,85.5,69629,74.4,NULL,NULL,'2MASX J20003567-3837350',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145764,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145764,34.67,0.43,85.9,69629,NULL,NULL,'Malmquist cor.','2MASX J20003567-3837350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145765,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145765,35.48,0.54,125,69630,70,NULL,NULL,'2MASX J20003752-6114583',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.3I',0.7,'(R\'_2)SB(rl)0/a',NULL,NULL,NULL,NULL,1,300.1564583,-61.24956,0.137,NULL,49025079884,766016873,11969013,13.3),(145766,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145766,35.13,0.64,106,69631,70,NULL,NULL,'2MASX J20003896-2648140',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.162333,-26.80386,0.557,NULL,51287151382,801361740,12521277,14.4),(145767,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145767,35.6,0.58,132,69632,70,NULL,NULL,'2MASX J20004164-5256408',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.173417,-52.94467,0.169,NULL,51108394848,798568669,12477635,15.6),(145768,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145768,32.53,0.22,32.1,69633,NULL,NULL,'I','NGC 6869',NULL,'2001ApJ...546..681T',2001,1,1.5,NULL,'G',0.000083,NULL,'13.11',1.3,'S0',NULL,NULL,NULL,NULL,1,300.1767083,66.22753,0.605,NULL,53576150878,837127357,13080114,13.11),(145769,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145769,32.57,0.14,32.7,69633,74.4,NULL,NULL,'NGC 6869',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145770,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145770,32.44,0.45,30.8,69633,NULL,NULL,'K','NGC 6869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145771,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145771,32.98,0.4,39.4,69633,NULL,NULL,'mean','NGC 6869',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145772,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145772,34.13,0.25,67,69634,74.4,NULL,NULL,'IC 4931',NULL,'2013AJ....146...86T',2013,1,2.4,NULL,'G',0.000019,NULL,'12.96',1.9,'E+:','Brightest group member',NULL,NULL,NULL,1,300.209833,-38.57506,0.357,NULL,51173640506,799588132,12493564,12.96),(145773,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145773,34.54,0.14,81.1,69634,70,NULL,'ABELL 3656, BGC','IC 4931',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145774,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145774,34.44,0.25,77.3,69635,74.4,NULL,NULL,'2MASX J20005562-3841481',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'13.9R',NULL,'S0',NULL,NULL,NULL,NULL,1,300.231833,-38.69664,0.329,NULL,51173619366,799587802,12493559,13.9),(145775,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145775,36.23,0.66,176,69636,70,NULL,NULL,'ESO 595- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'13.9I',0.7,'S...',NULL,NULL,NULL,NULL,1,300.233625,-18.8315,0.365,NULL,47920266043,748754156,11699283,13.9),(145776,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145776,33.7,0.48,54.9,69637,70,NULL,NULL,'2MASX J20005660-5537536',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'14.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.2357083,-55.63158,0.149,NULL,49050031678,766406744,11975105,14.8),(145777,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145777,35.91,0.41,152,69638,NULL,NULL,'Malmquist cor.','ESO 339- G 024',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000023,NULL,'15.57',0.2,'Sb:',NULL,NULL,NULL,NULL,1,300.236,-38.34697,0.361,NULL,51173411860,799584560,12493508,15.57),(145778,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145778,36.18,0.36,172,69638,NULL,NULL,NULL,'ESO 339- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145779,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145779,36.22,0.2,175,69638,74.4,NULL,NULL,'ESO 339- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145780,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145780,34.68,0.47,86.1,69639,70,NULL,NULL,'IC 4923',NULL,'2014MNRAS.445.2677S',2014,1,1,'1984MNRAS.210...69F has V = 6700: +- 200 km/s.','G',0.00015,NULL,'14.50',0.9,'(RL)SB(l)0^0',NULL,NULL,NULL,NULL,1,300.2390417,-52.63167,0.161,NULL,51111420396,798615943,12478374,14.5),(145781,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145781,37.21,0.64,277,69640,70,NULL,NULL,'2MASX J20010021-5232339',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.2509583,-52.54272,0.161,NULL,51111427649,798616057,12478375,16.7),(145782,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145782,37.2,0.81,276,69641,70,NULL,NULL,'2MASX J20010208-5228539',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.258625,-52.48164,0.153,NULL,51111426181,798616034,12478375,15.3),(145783,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145783,34.84,0.49,92.7,69642,70,NULL,NULL,'MCG -03-51-001',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000087,NULL,'15.5',0.4,'SA(rl)b',NULL,NULL,NULL,NULL,1,300.2612917,-17.05239,0.441,NULL,47978465194,749663518,11713492,15.5),(145784,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145784,34.46,0.51,77.8,69643,70,NULL,NULL,'ESO 073- G 018',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000077,NULL,'14.82',0.3,'S0?',NULL,NULL,NULL,NULL,1,300.269083,-71.20103,0.257,NULL,49221008776,769078262,12016847,14.82),(145785,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145785,38.24,NULL,445,69644,70,NULL,'z > 0.11','2FGL J2001.1+4352',NULL,'2013ApJ...764..135S',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,300.275,43.86667,NULL,NULL,54938899932,858420311,13412817,NULL),(145786,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145786,39.23,0.39,702,69644,70,NULL,'z = 0.18 +/- 0.04','2FGL J2001.1+4352',NULL,'2014A&A...572A.121A',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145787,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145787,39.44,NULL,772,69644,70,NULL,'z = 0.2','2FGL J2001.1+4352',NULL,'2009MNRAS.397L..55B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145788,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145788,39.12,0.89,667,69644,70,NULL,'z = 0.17 +/- 0.10','2FGL J2001.1+4352',NULL,'2014A&A...572A.121A',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145789,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145789,33.81,NULL,57.9,69645,NULL,NULL,'Dipole','FGC 2265',NULL,'2010Ap&SS.325..163P',2010,1,1.39,NULL,'G',0.00002,NULL,'16.1',0.17,'Scd',NULL,NULL,NULL,NULL,1,300.295833,53.075,1.525,NULL,54921065168,858141643,13408463,16.1),(145790,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145790,33.83,NULL,58.3,69645,NULL,NULL,'Dipole + Quadrupole','FGC 2265',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145791,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145791,33.84,NULL,58.6,69645,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2265',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145792,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145792,33.93,NULL,61.1,69645,NULL,NULL,NULL,'FGC 2265',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145793,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145793,35.28,0.51,114,69646,70,NULL,NULL,'2MASX J20011210-6136446',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.300583333,-61.61239,0.133,NULL,49024805759,766012589,11968946,14.3),(145794,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145794,35.64,0.57,134,69647,70,NULL,NULL,'2MASX J20011324-1856579',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.13',0.3,NULL,NULL,NULL,NULL,NULL,1,300.305083,-18.94958,0.365,NULL,47920588408,748759193,11699362,16.13),(145795,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145795,35.84,0.65,147,69648,70,NULL,NULL,'2MASX J20011788-2006019',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,300.3245,-20.10056,0.473,NULL,50811588843,793931075,12405173,13.5),(145796,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145796,36.56,0.61,205,69649,70,NULL,NULL,'2MASX J20011830-2126380',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.40',0.5,NULL,NULL,NULL,NULL,NULL,1,300.326208333,-21.44408,0.493,NULL,50815638796,793994356,12406161,16.4),(145797,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145797,36.96,0.45,247,69650,NULL,NULL,'Malmquist cor.','2MASX J20011957-3905473',NULL,'2009ApJS..182..474S',2009,1,0.54,NULL,'G',0.000023,NULL,'14.90',NULL,'Sc',NULL,NULL,NULL,NULL,1,300.331583,-39.09642,0.313,NULL,51173059079,799579048,12493422,14.9),(145798,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145798,37.11,0.42,265,69650,NULL,NULL,NULL,'2MASX J20011957-3905473',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145799,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145799,37.15,0.2,269,69650,74.4,NULL,NULL,'2MASX J20011957-3905473',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145800,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145800,35.39,0.54,119,69651,70,NULL,NULL,'ESO 185-IG 047 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.46',NULL,NULL,NULL,NULL,NULL,NULL,1,300.3317083,-52.9655,0.169,NULL,51108434345,798569286,12477645,16.46),(145801,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145801,36.18,0.56,172,69652,70,NULL,NULL,'2MASX J20012653-2120399',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,300.360458333,-21.34444,0.489,NULL,50815645448,793994460,12406163,14),(145802,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145802,34.73,0.25,88.3,69653,74.4,NULL,NULL,'2MASX J20013057-3903483',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.377417,-39.06347,0.313,NULL,51173062125,799579095,12493423,14.9),(145803,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145803,36.76,0.75,225,69654,70,NULL,NULL,'2MASX J20013332-5036148',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.388833,-50.60414,0.173,NULL,51126718925,798854983,12482109,15.6),(145804,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145804,34.96,0.49,98,69655,70,NULL,NULL,'ESO 595- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'15.71',0.2,'S0-a',NULL,NULL,NULL,NULL,1,300.4932083,-18.06178,0.369,NULL,47975209653,749612650,11712697,15.71),(145805,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145805,36.62,0.66,211,69656,70,NULL,NULL,'2MASX J20020258-7011026',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.510667,-70.18408,0.173,NULL,49213626775,768962918,12015045,15.8),(145806,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145806,33.51,1.13,50.4,69657,NULL,NULL,NULL,'ESO 339- G 028',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.04',0.8,'Sc',NULL,NULL,NULL,NULL,1,300.590125,-38.61464,0.329,NULL,51172991396,799577990,12493406,15.04),(145807,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145807,34.28,0.79,71.8,69657,NULL,NULL,'Malmquist cor.','ESO 339- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145808,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145808,36.36,0.51,187,69658,70,NULL,NULL,'2MASX J20022737-1017590',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,300.614125,-10.29967,0.445,NULL,48045164331,750705692,11729776,13.8),(145809,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145809,36.73,0.63,222,69659,70,NULL,NULL,'2MASX J20023152-1045294',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,300.631375,-10.75817,0.417,NULL,48042225955,750659780,11729059,14.7),(145810,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SDSS-II SN 17790','R',145810,40.38,0.28,1010,69660,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jx','SN 2007jx',0.178,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,300.63675,0.37169,0.693,NULL,54116188247,845565441,13211960,NULL),(145811,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SDSS-II SN 17790','R',145811,40.74,0.23,1190,69660,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jx','SN 2007jx',0.178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145812,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145812,34.41,0.52,76.2,69661,70,NULL,NULL,'2MASX J20023610-5549280',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.650333333,-55.82453,0.161,NULL,49049623847,766400372,11975005,14.4),(145813,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145813,34.39,0.8,75.7,69662,75,NULL,'MAT, I','ESO 105- G 020',NULL,'1997ApJS..109..333W',1997,1,1.93,NULL,'G',0.000033,NULL,'15.98',0.15,'Sc',NULL,NULL,NULL,NULL,1,300.672,-64.07864,0.137,NULL,49362552861,771289888,12051404,15.98),(145814,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145814,33.96,0.49,61.9,69662,75,NULL,'IR','ESO 105- G 020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145815,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145815,34.04,0.37,64.2,69662,NULL,NULL,'Malmquist cor.','ESO 105- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145816,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145816,34.2,NULL,69.1,69662,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 105- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145817,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145817,34.21,NULL,69.4,69662,NULL,NULL,'Dipole + Quadrupole','ESO 105- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145818,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145818,34.22,NULL,69.7,69662,NULL,NULL,'Dipole','ESO 105- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145819,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145819,34.25,0.32,70.7,69662,85,NULL,'I, raw','ESO 105- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145820,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145820,34.26,0.32,71.1,69662,85,NULL,'I, inv','ESO 105- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145821,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145821,34.27,NULL,71.4,69662,NULL,NULL,NULL,'ESO 105- G 020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145822,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145822,34.3,0.43,72.3,69662,75,NULL,'MAT, I, raw','ESO 105- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145823,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145823,34.35,0.32,74,69662,NULL,NULL,NULL,'ESO 105- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145824,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145824,34.39,0.2,75.5,69662,74.4,NULL,NULL,'ESO 105- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145825,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145825,34.4,0.43,75.9,69662,75,NULL,'MAT, I, inv','ESO 105- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145826,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145826,34.42,0.43,76.7,69662,75,NULL,'MAT, I, cor','ESO 105- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145827,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145827,33.49,0.21,50,69663,NULL,NULL,'GRM 15, 7 galaxies','NGC 6848',NULL,'2000ApJ...529..768K',2000,1,2.5,NULL,'G',0.000254,':','12.08',1,'Sa: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.696875,-56.09031,0.141,NULL,49049551373,766399240,11974988,12.08),(145828,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145828,33.38,0.21,47.4,69663,NULL,NULL,'GRM 15, 7 galaxies','NGC 6848',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145829,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145829,33.49,0.21,50,69663,NULL,NULL,'GRM 15, 7 galaxies','NGC 6848',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145830,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145830,35.73,0.51,140,69664,70,NULL,NULL,'2MASX J20024952-7905130',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.7062917,-79.08697,0.561,NULL,48547894968,758560858,11852513,16.2),(145831,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2006eu',NULL,145831,33.92,0.19,59.5,69665,74.2,NULL,'SALT 2','CGCG 257-035',0.0229,'2010ApJ...716..712A',2010,1,0.4,NULL,'G',0.000163,NULL,'14.7',0.4,'E?',NULL,NULL,NULL,NULL,1,300.7077917,49.31975,NULL,NULL,54959409560,858740774,13417824,14.7),(145832,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2006eu',NULL,145832,34.5,0.1,79.4,69665,74.4,NULL,NULL,'CGCG 257-035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145833,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145833,33.69,0.4,54.7,69666,NULL,NULL,'mean','UGC 11510',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000027,NULL,'14.7',0.6,'Sd',NULL,NULL,NULL,NULL,1,300.7329583,53.88508,1.697,NULL,54920284545,858129446,13408272,14.7),(145834,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145834,33.79,0.46,57.3,69666,NULL,NULL,'J','UGC 11510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145835,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145835,33.85,0.47,58.8,69666,NULL,NULL,'H','UGC 11510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145836,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145836,33.89,0.45,60,69666,NULL,NULL,'K','UGC 11510',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145837,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145837,35.68,0.83,137,69667,70,NULL,NULL,'2MASX J20030121-8305310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,300.754958333,-83.09192,0.577,NULL,48363358303,755677473,11807460,16.8),(145838,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145838,35.19,0.47,109,69668,NULL,NULL,'H','IC 1309',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'12.9I',1.3,'SAB(rs)bc pec',NULL,NULL,NULL,NULL,1,300.756333,-17.23208,0.349,NULL,47978311332,749661114,11713454,12.9),(145839,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145839,35.27,0.4,113,69668,NULL,NULL,'mean','IC 1309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145840,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145840,35.32,0.45,116,69668,NULL,NULL,'K','IC 1309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145841,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145841,35.38,0.46,119,69668,NULL,NULL,'J','IC 1309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145842,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145842,37.3,0.7,288,69669,70,NULL,NULL,'2MASX J20030164-1224056',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,300.756875,-12.40161,0.561,NULL,47936873094,749013642,11703338,14.6),(145843,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145843,36.02,0.67,160,69670,70,NULL,NULL,'2MASX J20030377-1318486',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,300.7657917,-13.31356,0.541,NULL,47937200583,749018759,11703418,13.9),(145844,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145844,35.32,0.67,116,69671,70,NULL,NULL,'2MASX J20031565-6026004',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.815166667,-60.4335,0.097,NULL,49038705684,766229776,11972340,15.4),(145845,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145845,35.2,0.51,110,69672,70,NULL,NULL,'FAIRALL 0527',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,300.8245,-52.85178,0.185,NULL,51108068262,798563566,12477555,14),(145846,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145846,34.15,0.25,67.6,69673,74.4,NULL,NULL,'MCG -06-44-014',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000017,NULL,'14.6b',0.5,NULL,NULL,NULL,NULL,NULL,1,300.861833,-38.40533,0.329,NULL,51174573892,799602717,12493792,14.6),(145847,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145847,33.33,0.45,46.4,69674,NULL,NULL,'K','ESO 185- G 054',NULL,'2007A&A...465...71T',2007,1,3.5,NULL,'G',0.000087,NULL,'11.3',2.4,'E2','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.862625,-55.94717,0.141,NULL,49051484315,766429442,11975460,11.3),(145848,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145848,33.81,0.4,57.9,69674,NULL,NULL,'mean','ESO 185- G 054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145849,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145849,33.98,0.8,62.5,69675,75,NULL,'MAT, I','IC 4933',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.00002,NULL,'12.93',1.9,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.871,-54.97994,0.181,NULL,49048698470,766385913,11974779,12.93),(145850,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145850,33.2,0.47,43.7,69675,NULL,NULL,'H','IC 4933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145851,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145851,33.31,0.45,45.9,69675,NULL,NULL,'K','IC 4933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145852,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145852,33.31,0.46,45.9,69675,NULL,NULL,'J','IC 4933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145853,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145853,33.53,0.32,50.7,69675,85,NULL,'I, raw','IC 4933',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145854,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145854,33.59,0.32,52.2,69675,85,NULL,'I, inv','IC 4933',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145855,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145855,34.07,0.4,65.1,69675,NULL,NULL,'mean','IC 4933',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145856,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145856,34.36,0.43,74.5,69675,75,NULL,'MAT, I, raw','IC 4933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145857,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145857,34.46,0.43,78.1,69675,75,NULL,'MAT, I, cor','IC 4933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145858,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145858,34.72,0.43,88,69675,75,NULL,'MAT, I, inv','IC 4933',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145859,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145859,33.78,0.45,57.1,69676,NULL,NULL,'K','NGC 6850',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000067,NULL,'13.50',1.1,'SB(s)0+ pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.875417,-54.84478,0.201,NULL,49048676458,766385569,11974774,13.5),(145860,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145860,34.06,0.4,64.9,69676,NULL,NULL,'mean','NGC 6850',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145861,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145861,32.79,0.21,36.1,69677,NULL,NULL,'I','NGC 6851',NULL,'2001ApJ...546..681T',2001,1,2,NULL,'G',0.00005,NULL,'12.69',1.5,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,300.8932083,-48.2845,0.161,NULL,51123365567,798802586,12481290,12.69),(145862,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145862,32.79,0.21,36.1,69677,NULL,NULL,NULL,'NGC 6851',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145863,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145863,32.85,0.14,37.2,69677,74.4,NULL,NULL,'NGC 6851',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145864,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145864,32.87,0.21,37.5,69677,NULL,NULL,'Malmquist cor.','NGC 6851',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145865,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145865,32.24,0.4,28,69677,75,NULL,'Edat, raw','NGC 6851',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145866,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145866,32.36,0.4,29.7,69677,75,NULL,'Edat, cor','NGC 6851',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145867,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145867,30.89,0.65,15.1,69677,95,NULL,'Weighted Mean','NGC 6851',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145868,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145868,32.08,0.81,26.1,69677,55,NULL,'Visvanathan & Sandage 1979','NGC 6851',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145869,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145869,32.4,0.41,30.2,69677,NULL,NULL,NULL,'NGC 6851',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145870,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145870,32.62,0.49,33.4,69677,70,NULL,NULL,'NGC 6851',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145871,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145871,32.76,0.41,35.7,69677,NULL,NULL,'Malmquist cor.','NGC 6851',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145872,'Tertiary','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145872,32.18,0.71,27.3,69677,95,NULL,NULL,'NGC 6851',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145873,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145873,35.95,0.46,155,69678,NULL,NULL,'Malmquist cor.','ESO 233- G 020',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.41',0.3,'SAB(rs)a',NULL,NULL,NULL,NULL,1,300.896125,-50.08669,0.181,NULL,51134983187,798984112,12484126,15.41),(145874,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145874,36.06,0.44,163,69678,NULL,NULL,NULL,'ESO 233- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145875,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145875,36.1,0.2,166,69678,74.4,NULL,NULL,'ESO 233- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145876,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145876,36.39,0.65,190,69679,70,NULL,NULL,'2MASX J20033747-1840576',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.32',NULL,NULL,NULL,NULL,NULL,NULL,1,300.9060417,-18.68264,0.409,NULL,47920094153,748751471,11699241,16.32),(145877,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145877,32.71,0.81,34.8,69680,NULL,NULL,NULL,'ESO 185- G 057',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.92',0.2,'S...',NULL,NULL,NULL,NULL,1,300.947583333,-54.97383,0.181,NULL,49048695359,766385864,11974779,15.92),(145878,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145878,32.94,0.49,38.8,69680,75,NULL,'IR','ESO 185- G 057',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145879,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145879,33.45,0.58,48.9,69680,NULL,NULL,'Malmquist cor.','ESO 185- G 057',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145880,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145880,29.18,0.1,6.85,69681,74.4,NULL,NULL,'ESO 461- G 036',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00002,NULL,'17.0B',0.6,'dwarf Irr',NULL,NULL,NULL,NULL,1,300.989083,-31.68161,0.437,NULL,51330856603,802044634,12531947,17),(145881,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145881,29.45,0.1,7.76,69681,NULL,NULL,NULL,'ESO 461- G 036',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145882,'TRGB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145882,29.47,NULL,7.83,69681,NULL,NULL,NULL,'ESO 461- G 036',NULL,'2006AJ....131.1361K',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145883,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145883,36.65,0.6,214,69682,70,NULL,NULL,'2MASX J20040446-5103492',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,301.018625,-51.06367,0.169,NULL,51127481796,798866903,12482295,14.4),(145884,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145884,34.1,0.43,66.2,69683,NULL,NULL,NULL,'ESO 339- G 031',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000027,NULL,'14.31',0.4,'(R\')SB(s)a?',NULL,NULL,NULL,NULL,1,301.061,-38.16711,0.329,NULL,51174620643,799603447,12493803,14.31),(145885,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145885,34.11,0.2,66.4,69683,74.4,NULL,NULL,'ESO 339- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145886,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145886,34.38,0.38,75.1,69683,NULL,NULL,'Malmquist cor.','ESO 339- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145887,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145887,32.32,0.8,29.1,69684,75,NULL,'MAT, I','ESO 595- G 010',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'15',0.7,'SB(s)dm pec:   HII',NULL,NULL,NULL,NULL,1,301.078083333,-19.06444,0.409,NULL,50810722816,793917544,12404961,15),(145888,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145888,32.23,0.4,27.9,69684,NULL,NULL,NULL,'ESO 595- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145889,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145889,32.33,0.43,29.2,69684,75,NULL,'3.6 micron, color + selection bias corrected','ESO 595- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145890,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145890,32.42,0.43,30.5,69684,75,NULL,'3.6 micron, color corrected','ESO 595- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145891,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145891,32.43,0.2,30.6,69684,74.4,NULL,NULL,'ESO 595- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145892,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145892,32.54,0.4,32.2,69684,NULL,NULL,NULL,'ESO 595- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145893,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145893,32.56,0.32,32.5,69684,85,NULL,'I, raw','ESO 595- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145894,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145894,32.57,0.32,32.6,69684,85,NULL,'I, inv','ESO 595- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145895,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145895,32.75,0.49,35.5,69684,75,NULL,'IR','ESO 595- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145896,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145896,32.92,0.43,38.3,69684,75,NULL,'MAT, I, raw','ESO 595- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145897,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145897,32.92,0.33,38.4,69684,NULL,NULL,'Malmquist cor.','ESO 595- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145898,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145898,33,0.43,39.9,69684,75,NULL,'MAT, I, inv','ESO 595- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145899,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145899,33.26,0.43,44.8,69684,75,NULL,'MAT, I, cor','ESO 595- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145900,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145900,35.57,0.51,130,69685,70,NULL,NULL,'2MASX J20042864-1037505',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00013,NULL,'13.3I',0.6,NULL,NULL,NULL,NULL,NULL,1,301.11925,-10.63072,0.401,NULL,48045375788,750708996,11729828,13.3),(145901,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145901,34.88,0.48,94.7,69686,NULL,NULL,'Malmquist cor.','2MASX J20043370-3907119',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.000023,NULL,'13.72',NULL,'Sab:',NULL,NULL,NULL,NULL,1,301.1405,-39.11994,0.277,NULL,51173970012,799593281,12493645,13.72),(145902,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145902,35.14,0.43,107,69686,NULL,NULL,NULL,'2MASX J20043370-3907119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145903,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145903,35.18,0.2,109,69686,74.4,NULL,NULL,'2MASX J20043370-3907119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145904,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145904,33.44,0.5,48.7,69687,70,NULL,NULL,'IC 4935',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000067,NULL,'14.01',0.4,'(R\')SB(r)ab','Pair member (points to parent)',NULL,NULL,NULL,1,301.142166667,-57.59817,0.093,NULL,49054860180,766482190,11976284,14.01),(145905,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145905,33.58,0.47,52.1,69688,NULL,NULL,'H','UGC 11512',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00008,NULL,'14.38',0.5,'SB?',NULL,NULL,NULL,NULL,1,301.143833333,12.73944,NULL,NULL,54065402627,844771916,13199561,14.38),(145906,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145906,33.66,0.46,53.8,69688,NULL,NULL,'J','UGC 11512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145907,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145907,33.66,0.45,53.9,69688,NULL,NULL,'K','UGC 11512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145908,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145908,33.8,0.4,57.5,69688,NULL,NULL,'mean','UGC 11512',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145909,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145909,35.54,0.47,128,69689,70,NULL,NULL,'ESO 233- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'14.83',0.6,'SAB(r)0^+:',NULL,NULL,NULL,NULL,1,301.154583,-50.31008,0.161,NULL,51127320685,798864385,12482256,14.83),(145910,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145910,35.68,0.49,137,69690,70,NULL,NULL,'2MASX J20043786-1849243',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.0001,NULL,'13.3I',0.5,NULL,NULL,NULL,NULL,NULL,1,301.15775,-18.8235,0.397,NULL,50809919162,793904986,12404765,13.3),(145911,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145911,34.37,0.49,74.7,69691,70,NULL,NULL,'2MASX J20045017-2142513',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000073,NULL,'15.51',0.5,NULL,NULL,NULL,NULL,NULL,1,301.209167,-21.71436,0.485,NULL,50817692292,794026442,12406663,15.51),(145912,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145912,30.35,0.43,11.8,69692,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11515',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000017,NULL,'14.4',1.4,'Sd',NULL,NULL,NULL,NULL,1,301.234167,62.79806,0.621,NULL,53455741498,835245960,13050718,14.4),(145913,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145913,36.73,0.75,222,69693,70,NULL,NULL,'2MASX J20045753-1646226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.239666667,-16.773,0.373,NULL,47974713792,749604903,11712576,16.1),(145914,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145914,35.72,0.5,139,69694,70,NULL,NULL,'2MASX J20051155-1250425',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,301.298125,-12.84508,0.437,NULL,47940183208,749065362,11704146,14),(145915,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145915,35.45,0.56,123,69695,NULL,NULL,'Malmquist cor.','2MASX J20051375-3910124',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.00003,NULL,'14.55',NULL,'Sc',NULL,NULL,NULL,NULL,1,301.3072917,-39.17014,0.277,NULL,51173922659,799592541,12493633,14.55),(145916,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145916,35.77,0.48,143,69695,NULL,NULL,NULL,'2MASX J20051375-3910124',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145917,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145917,35.81,0.2,145,69695,74.4,NULL,NULL,'2MASX J20051375-3910124',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145918,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145918,35.53,0.42,127,69696,NULL,NULL,'Malmquist cor.','2MASX J20051427-3909104',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.000023,NULL,'13.27',NULL,'Sab',NULL,NULL,NULL,NULL,1,301.309458333,-39.15289,0.277,NULL,51173976501,799593382,12493646,13.27),(145919,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145919,35.81,0.37,145,69696,NULL,NULL,NULL,'2MASX J20051427-3909104',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145920,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145920,35.85,0.2,148,69696,74.4,NULL,NULL,'2MASX J20051427-3909104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145921,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145921,36.34,0.54,185,69697,NULL,NULL,NULL,'2MASX J20052329-3909004',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000027,NULL,'16.06',NULL,'Sc',NULL,NULL,NULL,NULL,1,301.3472083,-39.15014,0.277,NULL,51173977570,799593399,12493646,16.06),(145922,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145922,36.36,0.53,187,69697,NULL,NULL,'Malmquist cor.','2MASX J20052329-3909004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145923,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145923,36.38,0.2,189,69697,74.4,NULL,NULL,'2MASX J20052329-3909004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145924,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145924,36.2,0.74,174,69698,70,NULL,NULL,'2MASX J20052518-0746506',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.354917,-7.78072,0.369,NULL,48049344113,750771001,11730796,14.8),(145925,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145925,41.6,NULL,1630,69699,NULL,NULL,NULL,'[HB89] 2007+777',0.342,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.7V',NULL,'BLLAC',NULL,NULL,'HYMORS','Flat-Spectrum Radio Source',1,301.378875,77.87864,0.481,NULL,52870037631,826094337,12907724,16.7),(145926,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145926,34.3,0.8,72.5,69700,75,NULL,'MAT, I','ESO 284- G 013',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.23',0.4,'Sb: sp',NULL,NULL,NULL,NULL,1,301.401333,-42.70411,0.197,NULL,51087896657,798248385,12472631,15.23),(145927,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145927,34.4,0.15,75.9,69700,NULL,NULL,'B, Hubble-type-TF','ESO 284- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145928,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145928,34.54,0.43,80.8,69700,75,NULL,'MAT, I, raw','ESO 284- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145929,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145929,34.54,0.32,81,69700,85,NULL,'I, raw','ESO 284- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145930,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145930,34.59,0.32,82.8,69700,85,NULL,'I, inv','ESO 284- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145931,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145931,34.66,0.41,85.4,69700,NULL,NULL,'Malmquist cor.','ESO 284- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145932,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145932,34.7,0.43,87.3,69700,75,NULL,'MAT, I, cor','ESO 284- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145933,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145933,34.75,0.43,89.3,69700,75,NULL,'MAT, I, inv','ESO 284- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145934,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145934,34.89,0.37,95,69700,NULL,NULL,NULL,'ESO 284- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145935,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145935,34.93,0.2,96.8,69700,74.4,NULL,NULL,'ESO 284- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145936,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145936,35.03,0.56,101,69701,NULL,NULL,'Malmquist cor.','ESO 527- G 008',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.3b',0.8,'Sb-c',NULL,NULL,NULL,NULL,1,301.407667,-25.14508,0.573,NULL,51280711234,801261113,12519704,16.3),(145937,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145937,35.22,0.51,111,69701,NULL,NULL,NULL,'ESO 527- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145938,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145938,35.26,0.2,113,69701,74.4,NULL,NULL,'ESO 527- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145939,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145939,31.53,0.65,20.2,69702,95,NULL,'Weighted Mean','NGC 6854',NULL,'1984ApJS...56...91D',1984,1,2,NULL,'G',0.000087,NULL,'13.2b',1.3,'SAB(s)0- pec:','Parent (of companion) galaxy',NULL,NULL,NULL,1,301.411667,-54.37561,0.201,NULL,49014792650,765856135,11966502,13.2),(145940,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145940,32.87,0.81,37.5,69702,55,NULL,'Visvanathan & Sandage 1979','NGC 6854',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145941,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145941,34.17,0.45,68.1,69702,NULL,NULL,'K','NGC 6854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145942,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145942,34.42,0.4,76.7,69702,NULL,NULL,'mean','NGC 6854',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145943,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145943,32.95,0.89,38.9,69703,NULL,NULL,NULL,'NGC 6851B',NULL,'2009ApJS..182..474S',2009,1,1.32,NULL,'G',NULL,NULL,'16.67',0.13,'SB(rs)d','Pair member (points to parent)',NULL,NULL,NULL,1,301.416416667,-47.97906,0.157,NULL,51123017531,798797148,12481205,16.67),(145944,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145944,33.31,0.75,46,69703,NULL,NULL,'Malmquist cor.','NGC 6851B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145945,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145945,33.38,NULL,47.4,69703,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 6851B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145946,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145946,33.4,NULL,47.9,69703,NULL,NULL,'Dipole + Quadrupole','NGC 6851B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145947,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145947,33.42,NULL,48.3,69703,NULL,NULL,'Dipole','NGC 6851B',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145948,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145948,35.14,0.57,107,69704,70,NULL,NULL,'MCG -02-51-001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'16.5',0.7,'S0',NULL,NULL,NULL,NULL,1,301.43225,-10.578,0.325,NULL,48045243648,750706932,11729795,16.5),(145949,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145949,36.66,0.65,215,69705,70,NULL,NULL,'2MASX J20054633-0101044',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.443041667,-1.01794,0.617,NULL,47883721485,748183148,11690361,14.9),(145950,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145950,37.68,0.73,343,69706,70,NULL,NULL,'2MASX J20054646-2142470',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.443625,-21.71306,0.485,NULL,50817708629,794026697,12406667,16.1),(145951,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145951,33.08,0.8,41.3,69707,75,NULL,'MAT, I','NGC 6851A',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000028,NULL,'14.83',0.5,'(R\')SB(s)m','Pair member (points to parent)',NULL,NULL,NULL,1,301.452125,-47.97825,0.137,NULL,51123046701,798797604,12481212,14.83),(145952,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145952,31.68,0.32,21.7,69707,85,NULL,'I, inv','NGC 6851A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145953,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145953,31.73,0.32,22.2,69707,85,NULL,'I, raw','NGC 6851A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145954,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145954,32.37,0.43,29.8,69707,75,NULL,'MAT, I, inv','NGC 6851A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145955,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145955,32.46,0.43,31.1,69707,75,NULL,'MAT, I, raw','NGC 6851A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145956,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145956,32.75,0.43,35.5,69707,75,NULL,'MAT, I, cor','NGC 6851A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145957,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145957,32.99,0.2,39.6,69707,74.4,NULL,NULL,'NGC 6851A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145958,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145958,33.39,0.8,47.6,69708,75,NULL,'MAT, I','IC 4936',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.53',0.8,'SB(s)d:',NULL,NULL,NULL,NULL,1,301.4675,-61.42853,0.097,NULL,49024264833,766004138,11968814,14.53),(145959,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145959,32.03,0.32,25.5,69708,85,NULL,'I, inv','IC 4936',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145960,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145960,32.05,0.32,25.7,69708,85,NULL,'I, raw','IC 4936',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145961,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145961,32.59,0.43,32.9,69708,75,NULL,'MAT, I, inv','IC 4936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145962,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145962,32.59,0.43,33,69708,75,NULL,'MAT, I, raw','IC 4936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145963,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145963,32.98,0.43,39.5,69708,75,NULL,'MAT, I, cor','IC 4936',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145964,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145964,33.65,0.09,53.8,69708,NULL,NULL,NULL,'IC 4936',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145965,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145965,33.63,0.49,53.3,69709,70,NULL,NULL,'NGC 6865',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000123,NULL,'14.64',0.5,'SB:0o:',NULL,NULL,NULL,NULL,1,301.485333333,-9.04092,0.317,NULL,48047347160,750739799,11730309,14.64),(145966,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145966,35.58,0.63,131,69710,70,NULL,NULL,'2MASX J20060312-2000111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.5129583,-20.00303,0.485,NULL,50813739531,793964680,12405698,15),(145967,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145967,32.52,0.47,31.9,69711,NULL,NULL,'H','IC 4938',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000093,NULL,'13.40',1.3,'(R)SAB(rs)ab','in a pair',NULL,NULL,NULL,1,301.54875,-60.21161,0.049,NULL,49038117619,766220587,11972196,13.4),(145968,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145968,32.62,0.46,33.4,69711,NULL,NULL,'J','IC 4938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145969,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145969,32.71,0.45,34.9,69711,NULL,NULL,'K','IC 4938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145970,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145970,33.36,0.4,47,69711,NULL,NULL,'mean','IC 4938',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145971,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145971,42.6,0.03,3310,69712,NULL,NULL,'z = 1.79 +/- 0.07','4B 941017',NULL,'2016ApJ...819...79G',2016,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,301.55,9.81,1.013,NULL,54214324764,847098824,13235919,NULL),(145972,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145972,33.51,0.4,50.4,69713,75,NULL,'Edat, raw','NGC 6849',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000043,NULL,'13.5b',1.1,'SB0-:',NULL,NULL,NULL,NULL,1,301.565083333,-40.19831,0.261,NULL,51207870022,800122969,12501921,13.5),(145973,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145973,33.85,0.4,58.8,69713,75,NULL,'Edat, cor','NGC 6849',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145974,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145974,34.14,0.8,67.2,69714,75,NULL,'MAT, I','ESO 284- G 016',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.07',0.8,'SA(s)c',NULL,NULL,NULL,NULL,1,301.588083,-42.76414,0.197,NULL,51087922393,798248787,12472637,14.07),(145975,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145975,33.53,0.32,50.8,69714,85,NULL,'I, raw','ESO 284- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145976,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145976,33.56,0.32,51.5,69714,85,NULL,'I, inv','ESO 284- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145977,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',145977,33.57,0.19,51.8,69714,NULL,NULL,'B, Hubble-type-TF','ESO 284- G 016',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145978,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145978,33.59,0.43,52.2,69714,75,NULL,'MAT, I, raw','ESO 284- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145979,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145979,33.75,0.43,56.2,69714,75,NULL,'MAT, I, inv','ESO 284- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145980,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145980,34.07,0.43,65.2,69714,75,NULL,'MAT, I, cor','ESO 284- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145981,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145981,35.93,0.66,153,69715,70,NULL,NULL,'2MASX J20062247-2022520',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.17',NULL,NULL,NULL,NULL,NULL,NULL,1,301.593667,-20.38117,0.489,NULL,50813883103,793966923,12405733,16.17),(145982,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145982,32.48,0.19,31.3,69716,NULL,NULL,'I','IC 4943',NULL,'2001ApJ...546..681T',2001,1,1.5,NULL,'G',0.000063,NULL,'13.61',1.1,'E pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,301.61775,-48.37561,0.141,NULL,51134082920,798970045,12483906,13.61),(145983,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145983,32.48,0.19,31.3,69716,NULL,NULL,NULL,'IC 4943',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145984,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145984,32.52,0.14,31.9,69716,74.4,NULL,NULL,'IC 4943',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145985,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145985,32.58,0.19,32.9,69716,NULL,NULL,'Malmquist cor.','IC 4943',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145986,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145986,32.24,0.4,28,69716,75,NULL,'Edat, raw','IC 4943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145987,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145987,32.36,0.4,29.7,69716,75,NULL,'Edat, cor','IC 4943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145988,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145988,33.42,0.41,48.2,69716,NULL,NULL,NULL,'IC 4943',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145989,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145989,33.51,0.52,50.3,69716,70,NULL,NULL,'IC 4943',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145990,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145990,33.82,0.41,57.9,69716,NULL,NULL,'Malmquist cor.','IC 4943',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145991,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145991,32.75,0.8,35.5,69716,75,NULL,NULL,'IC 4943',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145992,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145992,33.47,0.4,49.3,69716,NULL,NULL,'mean','IC 4943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145993,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145993,34.05,0.45,64.6,69716,NULL,NULL,'K','IC 4943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145994,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145994,35.4,0.49,120,69717,70,NULL,NULL,'6dF J2006344-463623',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.6432083,-46.60636,0.145,NULL,51092720468,798323757,12473808,15.1),(145995,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145995,33.67,0.8,54.1,69718,75,NULL,'MAT, I','IC 4929',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.29',0.4,'Sb: pec',NULL,NULL,NULL,NULL,1,301.67375,-71.68356,0.253,NULL,49224322402,769130037,12017656,14.29),(145996,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145996,33.19,0.32,43.4,69718,85,NULL,'I, raw','IC 4929',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145997,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145997,33.22,0.32,44,69718,85,NULL,'I, inv','IC 4929',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145998,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145998,33.25,0.43,44.8,69718,75,NULL,'MAT, I, raw','IC 4929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(145999,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,145999,33.41,0.43,48,69718,75,NULL,'MAT, I, inv','IC 4929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146000,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146000,33.49,0.43,50,69718,75,NULL,'MAT, I, cor','IC 4929',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146001,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146001,33.51,0.49,50.3,69718,75,NULL,'IR','IC 4929',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146002,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146002,33.78,0.47,57,69718,NULL,NULL,'H','IC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146003,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146003,33.83,0.4,58.2,69718,NULL,NULL,'mean','IC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146004,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146004,33.83,0.1,58.5,69718,NULL,NULL,NULL,'IC 4929',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146005,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146005,33.86,0.46,59.2,69718,NULL,NULL,'J','IC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146006,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146006,33.92,0.45,60.9,69718,NULL,NULL,'K','IC 4929',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146007,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146007,34.55,0.8,81.2,69719,75,NULL,'MAT, I','IC 4912',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.50',0.5,'SB(rs)c',NULL,NULL,NULL,NULL,1,301.707041667,-77.3575,0.469,NULL,48524824653,758200385,11846881,15.5),(146008,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146008,33.59,0.32,52.3,69719,85,NULL,'I, raw','IC 4912',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146009,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146009,33.6,0.32,52.5,69719,85,NULL,'I, inv','IC 4912',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146010,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146010,33.88,0.43,59.8,69719,75,NULL,'MAT, I, raw','IC 4912',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146011,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146011,33.96,0.43,62,69719,75,NULL,'MAT, I, inv','IC 4912',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146012,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146012,34.08,0.43,65.5,69719,75,NULL,'MAT, I, cor','IC 4912',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146013,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146013,34.31,0.41,72.9,69719,NULL,NULL,NULL,'IC 4912',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146014,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146014,34.35,0.2,74.1,69719,74.4,NULL,NULL,'IC 4912',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146015,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146015,34.45,0.38,77.7,69719,NULL,NULL,'Malmquist cor.','IC 4912',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146016,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146016,35.04,0.49,102,69720,75,NULL,'IR','CGCG 398-013',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.7',0.1,NULL,NULL,NULL,NULL,NULL,1,301.711541667,5.65969,0.709,NULL,54184293713,846629589,13228587,15.7),(146017,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146017,34.37,0.52,74.8,69721,70,NULL,NULL,'ESO 185- G 064',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00008,NULL,'14.93',0.5,'(R)SA(r)0^+',NULL,NULL,NULL,NULL,1,301.718416667,-54.30397,0.205,NULL,49048421010,766381578,11974712,14.93),(146018,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146018,37.51,0.72,317,69722,70,NULL,NULL,'2MASX J20065478-5522456',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,301.7282917,-55.37939,0.177,NULL,49052161897,766440029,11975625,16.5),(146019,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146019,34.18,0.46,68.7,69723,70,NULL,NULL,'ESO 284- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'14.24',0.6,'SAB0^-',NULL,NULL,NULL,NULL,1,301.7765,-42.81378,0.161,NULL,51087767848,798246372,12472599,14.24),(146020,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146020,34.25,0.45,70.8,69724,NULL,NULL,'K','IC 4944',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000077,NULL,'14.58',0.6,'SA(rs)0+:',NULL,NULL,NULL,NULL,1,301.786833,-54.44689,0.201,NULL,49048440839,766381888,11974717,14.58),(146021,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146021,34.49,0.4,79.1,69724,NULL,NULL,'mean','IC 4944',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146022,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146022,33.25,0.8,44.7,69725,75,NULL,'MAT, I','IC 4939',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'15.08',0.8,'Sc?',NULL,NULL,NULL,NULL,1,301.796,-60.73881,0.057,NULL,49037812683,766215823,11972122,15.08),(146023,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146023,32.84,0.32,36.9,69725,85,NULL,'I, inv','IC 4939',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146024,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146024,32.86,0.32,37.3,69725,85,NULL,'I, raw','IC 4939',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146025,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146025,33.39,0.43,47.7,69725,75,NULL,'MAT, I, inv','IC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146026,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146026,33.41,0.43,48,69725,75,NULL,'MAT, I, raw','IC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146027,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146027,33.64,0.43,53.4,69725,75,NULL,'MAT, I, cor','IC 4939',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146028,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146028,33.65,0.09,53.8,69725,NULL,NULL,NULL,'IC 4939',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146029,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146029,34.16,0.8,68.1,69726,75,NULL,'MAT, I','ESO 185- G 068',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.68',0.3,'SB(s)d: sp',NULL,NULL,NULL,NULL,1,301.8082083,-53.79189,0.205,NULL,51107652630,798557072,12477454,15.68),(146030,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146030,33.46,0.32,49.1,69726,85,NULL,'I, inv','ESO 185- G 068',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146031,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146031,33.46,0.32,49.2,69726,85,NULL,'I, raw','ESO 185- G 068',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146032,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146032,33.6,0.43,52.5,69726,75,NULL,'MAT, I, raw','ESO 185- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146033,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146033,33.64,0.43,53.6,69726,75,NULL,'MAT, I, inv','ESO 185- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146034,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146034,33.88,0.43,59.6,69726,75,NULL,'MAT, I, cor','ESO 185- G 068',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146035,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146035,33.95,0.48,61.7,69726,NULL,NULL,NULL,'ESO 185- G 068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146036,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146036,33.99,0.2,62.8,69726,74.4,NULL,NULL,'ESO 185- G 068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146037,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146037,34.1,0.45,66,69726,NULL,NULL,'Malmquist cor.','ESO 185- G 068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146038,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146038,33.06,0.8,41,69727,75,NULL,'MAT, I','IC 4934',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000032,NULL,'14.94',0.22,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,301.811875,-69.47919,0.181,NULL,49212054618,768938353,12014661,14.94),(146039,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146039,33.09,0.32,41.5,69727,85,NULL,'I, raw','IC 4934',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146040,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146040,33.1,0.32,41.6,69727,85,NULL,'I, inv','IC 4934',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146041,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146041,33.33,0.43,46.3,69727,75,NULL,'MAT, I, raw','IC 4934',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146042,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146042,33.39,0.43,47.7,69727,75,NULL,'MAT, I, inv','IC 4934',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146043,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146043,33.52,0.49,50.6,69727,75,NULL,'IR','IC 4934',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146044,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146044,33.55,0.43,51.3,69727,75,NULL,'MAT, I, cor','IC 4934',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146045,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146045,33.88,NULL,59.8,69727,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146046,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146046,33.91,NULL,60.4,69727,NULL,NULL,'Dipole + Quadrupole','IC 4934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146047,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146047,33.93,NULL,61.1,69727,NULL,NULL,'Dipole','IC 4934',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146048,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146048,34.82,0.61,92.2,69728,70,NULL,NULL,'2MASX J20071746-2004194',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,301.822791667,-20.07194,0.425,NULL,50813293295,793957707,12405589,14),(146049,'GCLF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146049,32.1,NULL,26.3,69729,NULL,NULL,NULL,'NGC 6861',NULL,'2015MNRAS.449..612E',2015,1,2.8,NULL,'G',0.000057,NULL,'12.12',1.8,'SA(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,301.831167,-48.37022,0.141,NULL,51134135021,798970859,12483919,12.12),(146050,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146050,32.24,0.36,28.1,69729,NULL,NULL,'I','NGC 6861',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146051,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146051,32.28,0.14,28.6,69729,74.4,NULL,NULL,'NGC 6861',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146052,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146052,30.32,0.63,11.6,69729,95,NULL,'Michard 1979b, c','NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146053,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146053,30.86,0.46,14.9,69729,95,NULL,'Michard 1979a','NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146054,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146054,31.14,0.37,16.9,69729,95,NULL,'Weighted Mean','NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146055,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146055,34.16,0.81,67.9,69729,55,NULL,'Visvanathan & Sandage 1979','NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146056,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146056,33.21,0.5,43.8,69729,70,NULL,NULL,'NGC 6861',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146057,'Tertiary','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146057,32.18,0.71,27.3,69729,95,NULL,NULL,'NGC 6861',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146058,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146058,32.75,0.8,35.5,69729,75,NULL,'B','NGC 6861',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146059,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146059,36.91,0.56,240,69730,70,NULL,NULL,'2MASX J20072145-5305439',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.839375,-53.09544,0.197,NULL,51125228391,798831693,12481745,15.3),(146060,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146060,47.23,1.48,10700,69731,NULL,NULL,NULL,'GRB 071003',1.604,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,301.8504583,10.9475,0.825,NULL,54198479785,846851246,13232050,NULL),(146061,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146061,36.58,0.62,207,69732,70,NULL,NULL,'2MASX J20072706-2034517',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.20',0.4,NULL,NULL,NULL,NULL,NULL,1,301.862833,-20.58097,0.433,NULL,50813876765,793966824,12405731,16.2),(146062,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146062,36.49,0.81,198,69733,70,NULL,NULL,'2MASX J20073073-0705115',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,301.8780417,-7.08661,0.365,NULL,48048872720,750763636,11730681,14.8),(146063,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SDSS-II SN 20090',NULL,146063,39.35,0.3,741,69734,70,NULL,'SN photometric redshift distance, z photo =0.191 +/- 0.032','SDSS-II SN 20090',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,301.8999583,-0.07333,0.509,NULL,47883859766,748185308,11690395,NULL),(146064,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146064,37.15,0.55,269,69735,70,NULL,NULL,'2MASX J20073610-5304259',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'14.7R',0.38,NULL,NULL,NULL,NULL,NULL,1,301.9002917,-53.07394,0.197,NULL,51125281785,798832527,12481758,14.7),(146065,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146065,32.38,0.8,29.9,69736,75,NULL,'MAT, I','ESO 595- G 014',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000007,NULL,'13.5',1.2,'SB(s)cd',NULL,NULL,NULL,NULL,1,301.905291667,-21.12519,0.449,NULL,50812675893,793948060,12405438,13.5),(146066,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146066,31.95,0.69,24.6,69736,100,NULL,'mid-IR','ESO 595- G 014',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146067,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146067,32.3,0.32,28.9,69736,85,NULL,'I, raw','ESO 595- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146068,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146068,32.33,0.32,29.2,69736,85,NULL,'I, inv','ESO 595- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146069,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146069,32.68,1.11,34.4,69736,NULL,NULL,NULL,'ESO 595- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146070,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146070,32.72,0.2,35,69736,74.4,NULL,NULL,'ESO 595- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146071,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146071,32.88,0.43,37.7,69736,75,NULL,'MAT, I, raw','ESO 595- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146072,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146072,33.05,0.43,40.7,69736,75,NULL,'MAT, I, inv','ESO 595- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146073,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146073,33.18,0.43,43.3,69736,75,NULL,'MAT, I, cor','ESO 595- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146074,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146074,33.23,0.86,44.2,69736,NULL,NULL,'Malmquist cor.','ESO 595- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146075,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146075,37.09,0.61,262,69737,70,NULL,NULL,'2MASX J20073842-0019201',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.910125,-0.32222,0.497,NULL,47884005098,748187579,11690430,15.6),(146076,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146076,34.23,0.47,70.3,69738,NULL,NULL,'H','ESO 461- G 043',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000027,NULL,'14.6',0.9,'SAB(rs)c:',NULL,NULL,NULL,NULL,1,301.949167,-29.81286,0.449,NULL,51332406184,802068846,12532325,14.6),(146077,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146077,34.51,0.45,79.9,69738,NULL,NULL,'K','ESO 461- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146078,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146078,34.53,0.46,80.4,69738,NULL,NULL,'J','ESO 461- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146079,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146079,34.83,0.4,92.3,69738,NULL,NULL,'mean','ESO 461- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146080,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146080,35.8,0.51,144,69739,70,NULL,NULL,'2MASX J20074859-2015107',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.75',NULL,NULL,NULL,NULL,NULL,NULL,1,301.952625,-20.253,0.445,NULL,50813378629,793959041,12405610,15.75),(146081,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146081,36.45,0.88,195,69740,70,NULL,NULL,'2MASX J20075110-2027066',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,301.9630417,-20.45183,0.445,NULL,50813347847,793958560,12405602,14.7),(146082,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146082,35.59,0.62,131,69741,70,NULL,NULL,'2MASX J20075166-2143583',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00014,NULL,'16.05',0.6,NULL,NULL,NULL,NULL,NULL,1,301.9655,-21.73286,0.401,NULL,50814511305,793976739,12405886,16.05),(146083,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146083,34.93,0.59,97,69742,70,NULL,NULL,'2MASX J20075197-6021185',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,301.9665,-60.35514,0.049,NULL,49029919346,766092489,11970195,14.3),(146084,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146084,36.35,0.65,186,69743,70,NULL,NULL,'2MASX J20075627-8411193',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,301.9850417,-84.18878,0.509,NULL,48384351226,756005487,11812585,17.2),(146085,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146085,34.73,0.8,88.4,69744,75,NULL,'MAT, I','ESO 461- G 044',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000027,NULL,'15.01',0.2,'Sbc: sp',NULL,NULL,NULL,NULL,1,302.021167,-29.31869,0.469,NULL,51277280544,801207508,12518867,15.01),(146086,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146086,34.23,0.49,70.2,69744,75,NULL,'IR','ESO 461- G 044',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146087,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146087,34.28,0.43,71.7,69744,75,NULL,'MAT, I, raw','ESO 461- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146088,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146088,34.29,0.32,72.2,69744,85,NULL,'I, raw','ESO 461- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146089,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146089,34.35,0.32,74.1,69744,85,NULL,'I, inv','ESO 461- G 044',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146090,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146090,34.52,0.43,80.2,69744,75,NULL,'MAT, I, inv','ESO 461- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146091,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146091,34.64,0.47,84.6,69744,NULL,NULL,'H','ESO 461- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146092,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146092,34.65,0.43,85.2,69744,75,NULL,'MAT, I, cor','ESO 461- G 044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146093,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146093,34.73,0.45,88.1,69744,NULL,NULL,'K','ESO 461- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146094,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146094,34.77,0.36,90,69744,NULL,NULL,'Malmquist cor.','ESO 461- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146095,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146095,34.84,0.4,92.8,69744,NULL,NULL,'mean','ESO 461- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146096,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146096,34.89,0.46,94.9,69744,NULL,NULL,'J','ESO 461- G 044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146097,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146097,34.96,0.33,98,69744,NULL,NULL,NULL,'ESO 461- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146098,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146098,35.05,0.2,102,69744,74.4,NULL,NULL,'ESO 461- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146099,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146099,33.45,0.5,48.9,69745,70,NULL,NULL,'NGC 6861D',NULL,'2014MNRAS.445.2677S',2014,1,2.3,NULL,'G',0.000073,NULL,'13.38',0.8,'SA(s)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.081167,-48.21142,0.137,NULL,51134294875,798973357,12483958,13.38),(146100,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146100,32.75,0.8,35.5,69745,75,NULL,NULL,'NGC 6861D',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146101,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146101,35.8,0.55,145,69746,70,NULL,NULL,'2MASX J20082325-2139297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.11',NULL,NULL,NULL,NULL,NULL,NULL,1,302.097125,-21.65839,0.393,NULL,50814435604,793975556,12405868,16.11),(146102,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146102,33.63,0.8,53.1,69747,75,NULL,'MAT, I','IC 4950',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.13',0.4,'SB?(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.114,-56.16183,0.165,NULL,49051069127,766422955,11975358,15.13),(146103,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146103,33.34,0.32,46.6,69747,85,NULL,'I, raw','IC 4950',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146104,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146104,33.36,0.32,47,69747,85,NULL,'I, inv','IC 4950',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146105,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146105,33.52,0.43,50.5,69747,75,NULL,'MAT, I, raw','IC 4950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146106,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146106,33.64,0.43,53.5,69747,75,NULL,'MAT, I, inv','IC 4950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146107,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146107,33.69,0.49,54.8,69747,75,NULL,'IR','IC 4950',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146108,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146108,33.71,0.41,55.2,69747,NULL,NULL,NULL,'IC 4950',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146109,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146109,33.75,0.2,56.2,69747,74.4,NULL,NULL,'IC 4950',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146110,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146110,33.77,0.43,56.9,69747,75,NULL,'MAT, I, cor','IC 4950',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146111,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146111,33.9,0.38,60.1,69747,NULL,NULL,'Malmquist cor.','IC 4950',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146112,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146112,35.11,0.8,105,69748,75,NULL,'MAT, I','ESO 527- G 011',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.4b',0.5,'SA(r)c',NULL,NULL,NULL,NULL,1,302.1297917,-25.45856,0.557,NULL,51281622568,801275352,12519927,14.4),(146113,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146113,33.68,0.43,54.6,69748,75,NULL,'MAT, I, raw','ESO 527- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146114,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146114,33.9,0.32,60.2,69748,85,NULL,'I, raw','ESO 527- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146115,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146115,33.97,0.32,62.1,69748,85,NULL,'I, inv','ESO 527- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146116,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146116,33.96,0.43,62.1,69748,75,NULL,'MAT, I, inv','ESO 527- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146117,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146117,34.19,0.43,68.9,69748,75,NULL,'MAT, I, cor','ESO 527- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146118,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146118,34.64,0.42,84.8,69748,NULL,NULL,'Malmquist cor.','ESO 527- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146119,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146119,34.84,0.39,92.9,69748,NULL,NULL,NULL,'ESO 527- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146120,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146120,34.88,0.2,94.6,69748,74.4,NULL,NULL,'ESO 527- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146121,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146121,35.32,0.47,116,69748,NULL,NULL,'H','ESO 527- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146122,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146122,35.39,0.4,120,69748,NULL,NULL,'mean','ESO 527- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146123,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146123,35.4,0.45,120,69748,NULL,NULL,'K','ESO 527- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146124,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146124,35.47,0.46,124,69748,NULL,NULL,'J','ESO 527- G 011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146125,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146125,36.02,0.89,160,69749,70,NULL,NULL,'2MASX J20083121-2004087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,302.130083333,-20.06906,0.425,NULL,50813452297,793960192,12405628,16.23),(146126,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146126,37.36,0.77,296,69750,70,NULL,NULL,'2MASX J20083349-2016037',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.139583,-20.26778,0.425,NULL,50813355219,793958675,12405604,15.4),(146127,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146127,33.01,0.52,40,69751,70,NULL,NULL,'IC 4952',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'14.01',0.6,'Sa:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.156875,-55.45367,0.177,NULL,49051809465,766434522,11975539,14.01),(146128,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146128,35.97,0.68,156,69752,70,NULL,NULL,'2MASX J20083818-5314354',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,302.1589583,-53.24314,0.205,NULL,51124548626,798821072,12481579,14.4),(146129,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146129,35.91,0.59,152,69753,70,NULL,NULL,'2MASX J20084688-2151417',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.19525,-21.86153,0.401,NULL,50814927696,793983245,12405988,15.2),(146130,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146130,37.25,0.69,282,69754,70,NULL,NULL,'2MASX J20085389-5428018',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.0b',0.2,NULL,NULL,NULL,NULL,NULL,1,302.22475,-54.46722,0.201,NULL,49048343056,766380360,11974693,17),(146131,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146131,35.15,0.63,107,69755,NULL,NULL,'Malmquist cor.','ESO 399- G 022',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.66',0.2,'S...',NULL,NULL,NULL,NULL,1,302.248667,-35.32081,0.273,NULL,51301740380,801589693,12524838,16.66),(146132,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146132,35.31,0.58,115,69755,NULL,NULL,NULL,'ESO 399- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146133,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146133,35.35,0.2,117,69755,74.4,NULL,NULL,'ESO 399- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146134,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146134,37.06,0.6,258,69756,70,NULL,NULL,'2MASX J20090318-5427018',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,302.2632917,-54.45047,0.201,NULL,49048344987,766380390,11974693,14.3),(146135,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146135,37.75,NULL,354,69757,65,NULL,'L = 10e57 photons/s','GRB 781104b',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,302.234041667,-21.453,0.393,NULL,50812494619,793945228,12405394,NULL),(146136,'GRB','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146136,40.59,NULL,1310,69757,65,NULL,'L = 2 x 10e58 photons/s','GRB 781104b',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146137,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146137,36.98,0.58,249,69758,70,NULL,NULL,'2MASX J20091337-5421218',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'17.1b',0.14,NULL,NULL,NULL,NULL,NULL,1,302.3055417,-54.35603,0.205,NULL,49048226193,766378534,11974664,17.1),(146138,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146138,35.91,0.58,152,69759,70,NULL,NULL,'ESO 284- G 020',NULL,'2014MNRAS.445.2677S',2014,1,2.35,NULL,'G',0.00015,NULL,'15.78',0.33,'Sc: pec sp',NULL,NULL,NULL,NULL,1,302.3110417,-46.35072,0.045,NULL,51092074013,798313656,12473650,15.78),(146139,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146139,37.2,1,276,69760,70,NULL,NULL,'2MASX J20091558-2102295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.314833,-21.04164,0.389,NULL,50812914726,793951792,12405496,15.5),(146140,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146140,37.2,0.59,276,69761,70,NULL,NULL,'2MASX J20091565-5419178',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.315166667,-54.32153,0.205,NULL,49048225049,766378516,11974664,15.6),(146141,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146141,31.61,0.8,21,69762,75,NULL,NULL,'UGCA 417',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000003,NULL,'15.3',1.3,'SB(s)m?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.338333,-6.28611,0.333,NULL,48034466716,750538542,11727164,15.3),(146142,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146142,30.41,0.39,12.1,69762,73,NULL,'opt','UGCA 417',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146143,'BL Lac Luminosity','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146143,37.64,NULL,315,69763,NULL,NULL,NULL,'[HB89] 2005-489',0.071,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'15.3',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,302.3557917,-48.83158,0.141,NULL,51136086498,799001351,12484396,15.3),(146144,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146144,37.94,NULL,388,69763,72,NULL,NULL,'[HB89] 2005-489',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146145,'GeV TeV ratio','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146145,39.17,0.3,683,69763,72,NULL,NULL,'[HB89] 2005-489',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146146,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146146,33.37,0.54,47.1,69764,70,NULL,NULL,'ESO 233- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000033,NULL,'14.33',0.4,'S0',NULL,NULL,NULL,NULL,1,302.3567917,-48.28483,0.141,NULL,51134276893,798973076,12483954,14.33),(146147,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146147,36.4,0.64,191,69765,70,NULL,NULL,'2MASX J20093030-2113155',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.35',NULL,'(R)SB0/a:',NULL,NULL,NULL,NULL,1,302.3764583,-21.22103,0.389,NULL,50812786324,793949786,12405465,16.35),(146148,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146148,29.88,0.8,9.45,69766,75,NULL,'MAT, I','IC 4951',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000007,NULL,'13.97',0.5,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,302.382375,-61.85047,0.065,NULL,49143602893,767868795,11997949,13.97),(146149,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146149,29.97,0.8,9.9,69766,75,NULL,NULL,'IC 4951',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146150,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146150,28.78,0.32,5.69,69766,85,NULL,'I, inv','IC 4951',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146151,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146151,28.85,0.32,5.91,69766,85,NULL,'I, raw','IC 4951',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146152,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146152,29.21,0.43,6.96,69766,75,NULL,'MAT, I, inv','IC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146153,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146153,29.42,0.43,7.65,69766,75,NULL,'MAT, I, raw','IC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146154,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146154,29.56,0.2,8.17,69766,74.4,NULL,NULL,'IC 4951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146155,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146155,29.61,0.62,8.37,69766,NULL,NULL,NULL,'IC 4951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146156,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146156,29.67,0.43,8.6,69766,75,NULL,'MAT, I, cor','IC 4951',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146157,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146157,29.96,NULL,9.82,69766,NULL,NULL,NULL,'IC 4951',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146158,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146158,30.27,0.36,11.3,69766,NULL,NULL,NULL,'IC 4951',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146159,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146159,30.27,0.4,11.3,69766,73,NULL,'opt','IC 4951',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146160,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146160,30.65,0.38,13.5,69766,NULL,NULL,'Malmquist cor.','IC 4951',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146161,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146161,32.99,0.8,39.7,69767,75,NULL,'MAT, I','ESO 233- G 036',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.72',0.4,'Sab? sp','Line-of-sight pair member',NULL,NULL,NULL,1,302.393167,-49.22147,0.157,NULL,51136872326,799013630,12484587,14.72),(146162,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146162,32.49,0.32,31.5,69767,85,NULL,'I, raw','ESO 233- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146163,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146163,32.5,0.32,31.6,69767,85,NULL,'I, inv','ESO 233- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146164,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146164,32.78,0.43,35.9,69767,75,NULL,'MAT, I, raw','ESO 233- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146165,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146165,32.86,0.43,37.3,69767,75,NULL,'MAT, I, inv','ESO 233- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146166,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146166,33.09,0.43,41.5,69767,75,NULL,'MAT, I, cor','ESO 233- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146167,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146167,33.13,0.49,42.3,69767,75,NULL,'IR','ESO 233- G 036',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146168,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146168,33.24,0.4,44.4,69767,NULL,NULL,'mean','ESO 233- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146169,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146169,33.29,0.57,45.5,69767,NULL,NULL,NULL,'ESO 233- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146170,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146170,33.33,0.2,46.3,69767,74.4,NULL,NULL,'ESO 233- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146171,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146171,33.41,0.54,48.1,69767,NULL,NULL,'Malmquist cor.','ESO 233- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146172,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146172,33.49,0.47,49.8,69767,NULL,NULL,'H','ESO 233- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146173,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146173,33.62,0.46,52.9,69767,NULL,NULL,'J','ESO 233- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146174,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146174,33.66,0.48,54.1,69768,70,NULL,NULL,'ESO 233- G 037',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.52',0.3,'Sb','Line-of-sight pair member',NULL,NULL,NULL,1,302.413125,-49.33172,0.157,NULL,51136886922,799013858,12484591,14.52),(146175,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146175,36.58,0.85,207,69769,70,NULL,NULL,'2MASX J20094051-5433103',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,302.418666667,-54.55292,0.201,NULL,49048381960,766380968,11974702,14.5),(146176,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146176,34.34,0.8,73.8,69770,75,NULL,'MAT, I','ESO 284- G 021',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.19',0.8,'SAB(rs+)c',NULL,NULL,NULL,NULL,1,302.4335417,-44.15372,0.097,NULL,51101637647,798463088,12475985,14.19),(146177,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146177,33.13,0.32,42.3,69770,85,NULL,'I, raw','ESO 284- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146178,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146178,33.15,0.32,42.6,69770,85,NULL,'I, inv','ESO 284- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146179,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146179,33.28,0.2,45.3,69770,74.4,NULL,NULL,'ESO 284- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146180,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146180,33.34,0.43,46.5,69770,75,NULL,'MAT, I, raw','ESO 284- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146181,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146181,33.44,0.43,48.8,69770,75,NULL,'MAT, I, inv','ESO 284- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146182,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146182,33.74,0.52,56,69770,NULL,NULL,'B, Hubble-type-TF','ESO 284- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146183,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146183,33.75,0.66,56.3,69770,NULL,NULL,NULL,'ESO 284- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146184,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146184,33.8,0.43,57.5,69770,75,NULL,'MAT, I, cor','ESO 284- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146185,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146185,34.16,0.55,67.9,69770,NULL,NULL,'Malmquist cor.','ESO 284- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146186,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146186,35.86,0.53,148,69771,70,NULL,NULL,'2MASX J20094410-6640249',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.4337917,-66.67367,0.165,NULL,49365330979,771333296,12052082,14.4),(146187,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146187,34.36,0.8,74.4,69772,75,NULL,'MAT, I','ESO 399- G 023',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.05',0.9,'SAB(r)bc',NULL,NULL,NULL,NULL,1,302.449375,-37.32975,0.305,NULL,51290522577,801414415,12522100,14.05),(146188,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146188,33.99,0.43,62.9,69772,75,NULL,'MAT, I, raw','ESO 399- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146189,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146189,34.12,0.32,66.6,69772,85,NULL,'I, raw','ESO 399- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146190,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146190,34.18,0.32,68.5,69772,85,NULL,'I, inv','ESO 399- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146191,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146191,34.24,0.43,70.4,69772,75,NULL,'MAT, I, inv','ESO 399- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146192,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146192,34.27,0.47,71.5,69772,NULL,NULL,'H','ESO 399- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146193,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146193,34.32,0.43,73.2,69772,75,NULL,'MAT, I, cor','ESO 399- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146194,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146194,34.36,0.46,74.3,69772,NULL,NULL,'J','ESO 399- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146195,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146195,34.38,0.45,75,69772,NULL,NULL,'K','ESO 399- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146196,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146196,34.44,0.34,77.2,69772,NULL,NULL,NULL,'ESO 399- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146197,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146197,34.45,0.2,77.6,69772,74.4,NULL,NULL,'ESO 399- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146198,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146198,34.51,0.33,79.8,69772,NULL,NULL,'Malmquist cor.','ESO 399- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146199,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146199,34.53,0.4,80.4,69772,NULL,NULL,'mean','ESO 399- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146200,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146200,36.84,0.61,233,69773,70,NULL,NULL,'2MASX J20094919-5900464',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.454875,-59.01294,0.061,NULL,49028995005,766078046,11969969,14.6),(146201,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146201,32.14,0.25,26.8,69774,NULL,NULL,'I','NGC 6868',NULL,'2001ApJ...546..681T',2001,1,3.5,NULL,'G',0.00005,NULL,'11.66',2.8,'E2             LINER','Group member, radial-velocity confirmed',NULL,NULL,'Flat-Spectrum Radio Source',1,302.4752917,-48.37956,0.141,NULL,51134158740,798971230,12483925,11.66),(146202,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146202,32.14,0.25,26.8,69774,NULL,NULL,NULL,'NGC 6868',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146203,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146203,32.21,0.14,27.7,69774,74.4,NULL,NULL,'NGC 6868',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146204,'SBF','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146204,32.33,0.25,29.2,69774,NULL,NULL,'Malmquist cor.','NGC 6868',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146205,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146205,32.24,0.4,28,69774,75,NULL,'Edat, raw','NGC 6868',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146206,'D-Sigma','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146206,32.36,0.4,29.7,69774,75,NULL,'Edat, cor','NGC 6868',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146207,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146207,32.14,0.65,26.8,69774,95,NULL,'Weighted Mean','NGC 6868',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146208,'Faber-Jackson','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146208,33.63,0.81,53.2,69774,55,NULL,'Visvanathan & Sandage 1979','NGC 6868',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146209,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146209,32.5,0.41,31.7,69774,NULL,NULL,NULL,'NGC 6868',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146210,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146210,32.66,0.5,34,69774,70,NULL,NULL,'NGC 6868',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146211,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146211,32.83,0.41,36.8,69774,NULL,NULL,'Malmquist cor.','NGC 6868',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146212,'Tertiary','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146212,32.18,0.71,27.3,69774,95,NULL,NULL,'NGC 6868',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146213,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146213,32.75,0.8,35.5,69774,75,NULL,'B','NGC 6868',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146214,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146214,32.49,0.45,31.4,69774,NULL,NULL,'K','NGC 6868',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146215,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146215,33,0.4,39.9,69774,NULL,NULL,'mean','NGC 6868',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146216,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146216,33.11,0.52,41.9,69775,70,NULL,NULL,'NGC 6870',NULL,'2014MNRAS.445.2677S',2014,1,2.6,NULL,'G',0.000033,NULL,'13.18',1.2,'SAB(rs)ab','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.54525,-48.28708,0.141,NULL,51134155517,798971179,12483924,13.18),(146217,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146217,32.76,0.8,35.6,69775,75,NULL,'MAT, I','NGC 6870',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146218,'Tully est','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146218,32.75,0.8,35.5,69775,75,NULL,'B','NGC 6870',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146219,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146219,33.74,0.32,56,69775,85,NULL,'I, raw','NGC 6870',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146220,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146220,33.79,0.43,57.2,69775,75,NULL,'MAT, I, raw','NGC 6870',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146221,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146221,33.83,0.32,58.3,69775,85,NULL,'I, inv','NGC 6870',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146222,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146222,33.97,0.38,62.3,69775,NULL,NULL,'Malmquist cor.','NGC 6870',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146223,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146223,33.98,0.38,62.6,69775,NULL,NULL,NULL,'NGC 6870',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146224,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146224,34.02,0.2,63.7,69775,74.4,NULL,NULL,'NGC 6870',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146225,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146225,34.12,0.43,66.8,69775,75,NULL,'MAT, I, cor','NGC 6870',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146226,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146226,34.15,0.43,67.5,69775,75,NULL,'MAT, I, inv','NGC 6870',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146227,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146227,34.52,0.6,80.1,69776,70,NULL,NULL,'2MASX J20101168-4358310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000083,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.548667,-43.97539,0.101,NULL,51102096282,798470254,12476097,14.3),(146228,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146228,36.76,0.6,225,69777,70,NULL,NULL,'2MASX J20102381-2146313',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.48',0.4,NULL,NULL,NULL,NULL,NULL,1,302.59925,-21.77558,0.417,NULL,50814951410,793983615,12405993,16.48),(146229,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146229,35,0.52,100,69778,70,NULL,NULL,'2MASX J20102462-5938506',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.602583,-59.6475,0.081,NULL,49030531886,766102060,11970344,15.4),(146230,'SNIa','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SDSS-II SN 11092',NULL,146230,37.42,0.43,305,69779,70,NULL,'SN photometric redshift distance, z photo =0.074 +/- 0.017','SDSS-II SN 11092',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,302.623333,1.12161,0.453,NULL,54107015314,845422114,13209720,NULL),(146231,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146231,33.67,0.8,54.3,69780,75,NULL,'MAT, I','NGC 6867',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000022,NULL,'13.89',0.7,'SB(rs)bc:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.623583,-54.78325,0.213,NULL,49048795605,766387431,11974803,13.89),(146232,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146232,33.33,0.32,46.3,69780,85,NULL,'I, raw','NGC 6867',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146233,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146233,33.34,0.43,46.5,69780,75,NULL,'MAT, I, raw','NGC 6867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146234,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146234,33.37,0.32,47.3,69780,85,NULL,'I, inv','NGC 6867',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146235,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146235,33.41,0.49,48.1,69780,75,NULL,'IR','NGC 6867',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146236,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146236,33.53,0.47,50.9,69780,NULL,NULL,'H','NGC 6867',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146237,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146237,33.55,0.43,51.2,69780,75,NULL,'MAT, I, inv','NGC 6867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146238,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146238,33.6,0.46,52.5,69780,NULL,NULL,'J','NGC 6867',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146239,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146239,33.61,0.45,52.6,69780,NULL,NULL,'K','NGC 6867',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146240,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146240,33.67,0.43,54.3,69780,75,NULL,'MAT, I, cor','NGC 6867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146241,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146241,33.82,0.4,58.2,69780,NULL,NULL,'mean','NGC 6867',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146242,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146242,35.56,0.6,129,69781,70,NULL,NULL,'2MASX J20103773-8651282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,'Elliptical',NULL,NULL,NULL,NULL,1,302.656917,-86.85792,0.417,NULL,48331278756,755176230,11799628,16.6),(146243,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146243,36.87,0.48,237,69782,NULL,NULL,'Malmquist cor.','2MASX J20105045-5632598',NULL,'2009ApJS..182..474S',2009,1,0.41,NULL,'G',0.00003,NULL,'16.5V',0.12,'Sc',NULL,NULL,NULL,NULL,1,302.710333333,-56.54997,0.197,NULL,49053309549,766457961,11975905,16.5),(146244,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146244,37.12,0.43,265,69782,NULL,NULL,NULL,'2MASX J20105045-5632598',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146245,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146245,37.16,0.2,270,69782,74.4,NULL,NULL,'2MASX J20105045-5632598',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146246,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146246,32.42,0.8,30.5,69783,75,NULL,'MAT, I','NGC 6861E',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.06',0.3,'Sab:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.756333,-48.69058,0.141,NULL,51136040628,799000634,12484384,15.06),(146247,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146247,32.14,0.32,26.8,69783,85,NULL,'I, inv','NGC 6861E',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146248,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146248,32.16,0.32,27,69783,85,NULL,'I, raw','NGC 6861E',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146249,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146249,32.5,0.43,31.6,69783,75,NULL,'MAT, I, inv','NGC 6861E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146250,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146250,32.51,0.43,31.7,69783,75,NULL,'MAT, I, raw','NGC 6861E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146251,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146251,32.8,0.43,36.3,69783,75,NULL,'MAT, I, cor','NGC 6861E',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146252,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146252,33,0.49,39.8,69783,75,NULL,'IR','NGC 6861E',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146253,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146253,33.07,0.53,41.1,69783,NULL,NULL,NULL,'NGC 6861E',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146254,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146254,33.11,0.2,41.9,69783,74.4,NULL,NULL,'NGC 6861E',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146255,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146255,33.12,0.52,42.1,69783,NULL,NULL,'Malmquist cor.','NGC 6861E',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146256,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146256,36.76,0.54,225,69784,70,NULL,NULL,'2MASX J20110463-5411587',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.3R',0.15,NULL,NULL,NULL,NULL,NULL,1,302.7692083,-54.19972,0.217,NULL,48993707863,765526685,11961354,15.3),(146257,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146257,32.93,0.8,38.5,69785,75,NULL,'MAT, I','NGC 6861F',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'15.19',0.3,'SBdm? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.799167,-48.27583,0.141,NULL,51134638456,798978725,12484042,15.19),(146258,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146258,32.95,0.8,38.9,69785,75,NULL,'HMCL, I','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146259,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146259,31.41,0.32,19.1,69785,85,NULL,'I, inv','NGC 6861F',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146260,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146260,31.45,0.32,19.5,69785,85,NULL,'I, raw','NGC 6861F',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146261,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146261,31.55,0.4,20.4,69785,75,NULL,'HMCL, I, inv','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146262,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146262,31.65,0.4,21.4,69785,75,NULL,'HMCL, I, raw','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146263,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146263,31.82,0.43,23.1,69785,75,NULL,'MAT, I, inv','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146264,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146264,31.83,0.4,23.2,69785,NULL,NULL,NULL,'NGC 6861F',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146265,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146265,31.93,0.43,24.3,69785,75,NULL,'MAT, I, raw','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146266,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146266,32.02,0.4,25.3,69785,75,NULL,'HMCL, I, cor','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146267,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146267,32.24,0.4,28,69785,73,NULL,'opt','NGC 6861F',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146268,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146268,32.32,0.43,29.1,69785,75,NULL,'MAT, I, cor','NGC 6861F',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146269,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146269,32.34,0.59,29.3,69785,NULL,NULL,NULL,'NGC 6861F',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146270,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146270,32.38,0.2,29.9,69785,74.4,NULL,NULL,'NGC 6861F',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146271,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146271,32.63,0.52,33.5,69785,NULL,NULL,'Malmquist cor.','NGC 6861F',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146272,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146272,33.6,0.8,52.5,69786,75,NULL,'MAT, I','NGC 6876A',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.79',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.820208333,-71.01294,0.197,NULL,49223576401,769118381,12017474,14.79),(146273,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,'R',146273,33.41,0.49,48.2,69786,75,NULL,'IR','NGC 6876A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146274,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146274,33.53,0.32,50.9,69786,85,NULL,'I, raw','NGC 6876A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146275,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146275,33.55,0.32,51.3,69786,85,NULL,'I, inv','NGC 6876A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146276,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146276,33.7,0.43,54.9,69786,75,NULL,'MAT, I, raw','NGC 6876A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146277,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146277,33.75,0.4,56.2,69786,NULL,NULL,'mean','NGC 6876A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146278,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146278,33.82,0.43,58.1,69786,75,NULL,'MAT, I, inv','NGC 6876A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146279,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146279,33.83,0.1,58.5,69786,NULL,NULL,NULL,'NGC 6876A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146280,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146280,33.86,0.43,59.1,69786,75,NULL,'MAT, I, cor','NGC 6876A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146281,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146281,33.94,0.47,61.4,69786,NULL,NULL,'H','NGC 6876A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146282,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146282,37.66,0.61,341,69787,70,NULL,NULL,'2MASX J20111901-5340356',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.5R',0.16,NULL,NULL,NULL,NULL,NULL,1,302.829417,-53.67656,0.209,NULL,51078456565,798100883,12470326,15.5),(146283,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146283,35.15,0.66,107,69788,70,NULL,NULL,'2MASX J20112633-5247086',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,302.859667,-52.78578,0.177,NULL,51124800277,798825004,12481640,14.2),(146284,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146284,34.23,0.8,70.1,69789,75,NULL,'MAT, I','ESO 339- G 036',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.68',0.6,'S?',NULL,NULL,NULL,NULL,1,302.862375,-38.19756,0.317,NULL,51288492249,801382691,12521604,14.68),(146285,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146285,33.71,0.32,55.2,69789,85,NULL,'I, raw','ESO 339- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146286,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146286,33.74,0.32,56,69789,85,NULL,'I, inv','ESO 339- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146287,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146287,33.82,0.43,58.1,69789,75,NULL,'MAT, I, raw','ESO 339- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146288,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146288,33.98,0.43,62.6,69789,75,NULL,'MAT, I, inv','ESO 339- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146289,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146289,34.03,0.2,64,69789,74.4,NULL,NULL,'ESO 339- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146290,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146290,34.1,0.47,65.9,69789,NULL,NULL,NULL,'ESO 339- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146291,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146291,34.24,0.43,70.4,69789,75,NULL,'MAT, I, cor','ESO 339- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146292,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146292,34.4,0.41,75.8,69789,NULL,NULL,'Malmquist cor.','ESO 339- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146293,'IRAS','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146293,34.37,0.8,74.9,69790,75,NULL,'MAT, I','IC 4961',NULL,'1997ApJS..109..333W',1997,1,1.5,'This may also be IC 4959.','G',0.000033,NULL,'15.02',0.5,'SAB(s)dm:',NULL,NULL,NULL,NULL,1,302.869125,-53.12511,0.205,NULL,51125304660,798832885,12481763,15.02),(146294,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146294,33.49,0.32,50,69790,85,NULL,'I, raw','IC 4961',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146295,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146295,33.51,0.32,50.4,69790,85,NULL,'I, inv','IC 4961',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146296,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146296,33.55,0.43,51.4,69790,75,NULL,'MAT, I, raw','IC 4961',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146297,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146297,33.66,0.43,53.9,69790,75,NULL,'MAT, I, inv','IC 4961',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146298,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146298,33.86,0.43,59.1,69790,75,NULL,'MAT, I, cor','IC 4961',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146299,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146299,34.23,0.37,70,69790,NULL,NULL,NULL,'IC 4961',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146300,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146300,34.23,0.37,70.1,69790,NULL,NULL,'Malmquist cor.','IC 4961',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146301,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146301,34.27,0.2,71.5,69790,74.4,NULL,NULL,'IC 4961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146302,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146302,34.03,0.45,64,69791,NULL,NULL,'K','IC 4956',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000073,NULL,'13.4',1.6,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,302.88025,-45.59322,0,NULL,51100093316,798438958,12475608,13.4),(146303,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146303,34.23,0.4,70.1,69791,NULL,NULL,'mean','IC 4956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146304,'FP','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146304,35.44,0.58,122,69792,70,NULL,NULL,'ESO 596- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00004,NULL,'15',1.5,'(R\'_2)SAB(s)c',NULL,NULL,NULL,NULL,1,302.9187917,-20.8205,0.277,NULL,50812825967,793950405,12405475,15),(146305,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146305,36.66,0.42,214,69793,NULL,NULL,'Malmquist cor.','2MASX J20114286-5703283',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.00003,NULL,'16.5V',0.1,'Sb:',NULL,NULL,NULL,NULL,1,302.9285,-57.05792,0.165,NULL,49053000083,766453126,11975830,16.5),(146306,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146306,36.9,0.37,240,69793,NULL,NULL,NULL,'2MASX J20114286-5703283',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146307,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146307,36.94,0.2,244,69793,74.4,NULL,NULL,'2MASX J20114286-5703283',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146308,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146308,35.62,0.5,133,69794,NULL,NULL,'Malmquist cor.','ESO 462- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.85',0.4,'Sb',NULL,NULL,NULL,NULL,1,302.932875,-28.86542,0.477,NULL,51332035421,802063053,12532235,15.85),(146309,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146309,35.76,0.47,142,69794,NULL,NULL,NULL,'ESO 462- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146310,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146310,35.8,0.2,145,69794,74.4,NULL,NULL,'ESO 462- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146311,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146311,34.41,0.44,76.2,69795,NULL,NULL,'SCM, B','UGC 11522',NULL,'2010ApJ...715..833O',2010,1,1,NULL,'G',0.000117,NULL,'14.5',0.5,'Sbc','Group member',NULL,NULL,NULL,1,302.955667,5.76378,0.745,NULL,54179774155,846558971,13227483,14.5),(146312,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146312,34.47,0.37,78.3,69795,NULL,NULL,'V, photospheric magnitude method','UGC 11522',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146313,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146313,34.49,0.29,79.1,69795,NULL,NULL,'SCM, BVI','UGC 11522',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146314,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146314,34.52,0.16,80.2,69795,NULL,NULL,'I, photospheric magnitude method','UGC 11522',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146315,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146315,34.55,0.54,81.3,69795,NULL,NULL,'SCM, I','UGC 11522',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146316,'SNII optical','2016-12-15 15:15:50','2016-12-16 11:21:05','1','SN 2003fb',NULL,146316,34.56,0.55,81.7,69795,NULL,NULL,'SCM, V','UGC 11522',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146317,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146317,33.69,0.69,54.7,69795,100,NULL,'mid-IR','UGC 11522',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146318,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146318,34.09,0.47,65.6,69795,NULL,NULL,'H','UGC 11522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146319,'Tully-Fisher','2016-12-15 15:15:50','2016-12-16 11:21:05','1',NULL,NULL,146319,34.15,0.45,67.7,69795,NULL,NULL,'K','UGC 11522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146320,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146320,34.18,0.4,68.5,69795,NULL,NULL,'mean','UGC 11522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146321,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146321,34.24,0.46,70.6,69795,NULL,NULL,'J','UGC 11522',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146322,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146322,32.91,0.8,38.2,69796,75,NULL,'MAT, I','NGC 6875A',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000033,NULL,'13.93',0.5,'SAB(s)d','in a pair',NULL,NULL,NULL,1,302.98275,-46.14408,0.005,NULL,51099406857,798428232,12475441,13.93),(146323,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146323,32.93,0.8,38.6,69796,75,NULL,'HMCL, I','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146324,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146324,31.84,0.32,23.3,69796,85,NULL,'I, raw','NGC 6875A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146325,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146325,31.86,0.32,23.5,69796,85,NULL,'I, inv','NGC 6875A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146326,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146326,32.02,0.43,25.4,69796,75,NULL,'MAT, I, raw','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146327,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146327,32.12,0.43,26.5,69796,75,NULL,'MAT, I, inv','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146328,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146328,32.32,0.4,29.1,69796,NULL,NULL,NULL,'NGC 6875A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146329,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146329,32.35,0.49,29.5,69796,75,NULL,'IR','NGC 6875A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146330,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146330,32.39,0.43,30.1,69796,75,NULL,'MAT, I, cor','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146331,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146331,32.58,0.47,32.8,69796,NULL,NULL,'H','NGC 6875A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146332,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146332,32.64,0.46,33.8,69796,NULL,NULL,'J','NGC 6875A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146333,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146333,32.65,0.4,33.9,69796,75,NULL,'HMCL, I, raw','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146334,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146334,32.72,0.45,35,69796,NULL,NULL,'K','NGC 6875A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146335,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146335,32.77,0.4,35.8,69796,75,NULL,'HMCL, I, inv','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146336,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146336,32.78,0.45,35.9,69796,NULL,NULL,NULL,'NGC 6875A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146337,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146337,32.82,0.2,36.6,69796,74.4,NULL,NULL,'NGC 6875A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146338,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146338,32.83,0.44,36.8,69796,NULL,NULL,'Malmquist cor.','NGC 6875A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146339,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146339,32.85,0.4,37.1,69796,75,NULL,'HMCL, I, cor','NGC 6875A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146340,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146340,33.11,0.4,42,69796,NULL,NULL,'mean','NGC 6875A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146341,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146341,35.15,0.49,107,69797,75,NULL,'IR','ESO 284- G 025',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000033,NULL,'16.0b',0.16,'Sbc',NULL,NULL,NULL,NULL,1,303.001416667,-47.02386,0.073,NULL,51133824420,798966006,12483843,16),(146342,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146342,35.29,NULL,114,69797,NULL,NULL,NULL,'ESO 284- G 025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146343,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146343,35.35,0.62,118,69797,NULL,NULL,'Malmquist cor.','ESO 284- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146344,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146344,35.43,NULL,122,69797,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 284- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146345,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146345,35.46,NULL,124,69797,NULL,NULL,'Dipole + Quadrupole','ESO 284- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146346,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146346,35.49,NULL,126,69797,NULL,NULL,'Dipole','ESO 284- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146347,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146347,35.61,0.55,132,69797,NULL,NULL,NULL,'ESO 284- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146348,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146348,35.65,0.2,135,69797,74.4,NULL,NULL,'ESO 284- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146349,'Ring Diameter','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146349,34.3,0.84,74,69798,NULL,NULL,'Published at H = 100 km/s/Mpc','UGC 11524',NULL,'1981ApJS...45..541P',1981,1,1.1,NULL,'G',0.000023,NULL,'14.12',1,'SA(r)c:','Group member',NULL,NULL,NULL,1,303.016291667,5.76367,0.745,NULL,54179759786,846558746,13227480,14.12),(146350,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146350,36.05,0.53,162,69799,70,NULL,NULL,'2MASX J20120429-5251129',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.0R',0.25,NULL,NULL,NULL,NULL,NULL,1,303.017958333,-52.85364,0.177,NULL,51124808607,798825134,12481642,15),(146351,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146351,34.73,0.5,88.1,69800,70,NULL,NULL,'ESO 284- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.22',0.9,'S0-:',NULL,NULL,NULL,NULL,1,303.049,-44.14667,0.097,NULL,51102445338,798475708,12476182,14.22),(146352,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146352,36.8,0.67,229,69801,70,NULL,NULL,'2MASX J20121530-0032056',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000103,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,303.0637917,-0.53489,0.609,NULL,47883056108,748172751,11690199,14.5),(146353,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146353,34.59,0.49,82.8,69802,75,NULL,'IR','UGC 11525',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000223,NULL,'15.11',0.3,'Sab: sp',NULL,NULL,NULL,NULL,1,303.07675,1.95758,0.461,NULL,54177778368,846527787,13226996,15.11),(146354,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146354,34.26,0.48,71.3,69803,70,NULL,NULL,'ESO 596- G 003',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000113,NULL,'15.55',0.4,'Sa:',NULL,NULL,NULL,NULL,1,303.0849583,-17.59175,0.293,NULL,50839960894,794374388,12412099,15.55),(146355,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146355,37.64,0.73,337,69804,70,NULL,NULL,'ESO 105- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'1983MNRAS.203...47F has V = 5950? +- 100 km/s.','G',0.00015,NULL,'16.05',0.7,'(R)SAB0/a',NULL,NULL,NULL,NULL,1,303.110625,-65.41597,0.149,NULL,49374055567,771469618,12054212,16.05),(146356,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146356,35.61,0.7,132,69805,70,NULL,NULL,'2MASX J20122705-1846145',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.34',NULL,NULL,NULL,NULL,NULL,NULL,1,303.11275,-18.77056,0.269,NULL,50856636272,794634941,12416170,16.34),(146357,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146357,36.42,0.24,192,69806,70,NULL,'ABELL 3667, BGC','IC 4965',NULL,'1999AJ....118.1489D',1999,1,1.1,NULL,'G',0.000127,NULL,'13.2V',1,'SA0^0;BrClG',NULL,NULL,NULL,NULL,1,303.113833,-56.82678,0.185,NULL,49053257517,766457148,11975892,13.2),(146358,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146358,36.42,0.24,192,69807,70,NULL,NULL,'ABELL 3667',NULL,'1999AJ....118.1489D',1999,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];IR:[A]',NULL,NULL,NULL,NULL,1,303.127083,-56.83194,0.185,NULL,49053257127,766457142,11975892,NULL),(146359,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146359,34.96,0.63,98.3,69808,70,NULL,NULL,'2MASX J20123427-4546540',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,303.14275,-45.78172,0,NULL,51100201201,798440643,12475635,13.9),(146360,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146360,35.57,0.51,130,69809,70,NULL,NULL,'ESO 284- G 027',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.13',0.3,'N',NULL,NULL,NULL,NULL,1,303.160666667,-45.75917,0,NULL,51100248107,798441376,12475646,15.13),(146361,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146361,34.54,0.47,80.8,69810,NULL,NULL,'H','ESO 340- G 001',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'15.0b',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,303.165333,-40.13261,0.185,NULL,51204285610,800066962,12501046,15),(146362,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146362,34.57,0.49,82.1,69810,75,NULL,'IR','ESO 340- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146363,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146363,34.62,0.45,83.8,69810,NULL,NULL,'K','ESO 340- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146364,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146364,34.72,0.46,87.9,69810,NULL,NULL,'J','ESO 340- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146365,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146365,34.73,0.42,88.2,69810,NULL,NULL,'Malmquist cor.','ESO 340- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146366,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146366,34.77,0.4,89.9,69810,NULL,NULL,'mean','ESO 340- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146367,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146367,35.02,0.37,101,69810,NULL,NULL,NULL,'ESO 340- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146368,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146368,35.06,0.2,103,69810,74.4,NULL,NULL,'ESO 340- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146369,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146369,34.9,0.5,95.5,69811,NULL,NULL,'Malmquist cor.','ESO 399- G 024',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'16.1b',0.4,'(R\'_2:)SB(r)a',NULL,NULL,NULL,NULL,1,303.197,-33.58758,0.337,NULL,51299188372,801549818,12524215,16.1),(146370,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146370,35.2,0.43,109,69811,NULL,NULL,NULL,'ESO 399- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146371,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146371,35.24,0.2,112,69811,74.4,NULL,NULL,'ESO 399- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146372,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146372,35.34,0.49,117,69811,75,NULL,'IR','ESO 399- G 024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146373,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146373,36.18,0.66,172,69812,70,NULL,NULL,'2MASX J20125700-2011237',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.2I',0.4,NULL,NULL,NULL,NULL,NULL,1,303.237583333,-20.18994,0.281,NULL,50857710491,794651726,12416433,14.2),(146374,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146374,36.91,0.51,241,69813,NULL,NULL,'Malmquist cor.','2MFGC 15388',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000027,NULL,'17.94',0.11,'Sc',NULL,NULL,NULL,NULL,1,303.2730417,-57.17878,0.117,NULL,49045444677,766335073,11973985,17.94),(146375,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146375,37.09,0.49,261,69813,75,NULL,'IR','2MFGC 15388',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146376,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146376,37.26,0.43,283,69813,NULL,NULL,NULL,'2MFGC 15388',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146377,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146377,37.3,0.2,288,69813,74.4,NULL,NULL,'2MFGC 15388',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146378,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146378,30.52,0.65,12.7,69814,95,NULL,'Weighted Mean','NGC 6875',NULL,'1984ApJS...56...91D',1984,1,2.3,NULL,'G',0.000083,NULL,'13.03',1.3,'S0^0p','in a pair',NULL,NULL,NULL,1,303.3019583,-46.16164,0.005,NULL,51099295339,798426489,12475413,13.03),(146379,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146379,31.62,0.81,21.1,69814,55,NULL,'Visvanathan & Sandage 1979','NGC 6875',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146380,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146380,33.86,0.49,59.1,69815,75,NULL,'IR','UGC 11529',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00003,NULL,'16.5',0.7,'Sbc',NULL,NULL,NULL,NULL,1,303.324875,66.29056,0.653,NULL,53646659520,838229055,13097328,16.5),(146381,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146381,36.82,0.52,231,69816,70,NULL,NULL,'2MASX J20133274-5357398',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,303.3864583,-53.96106,0.217,NULL,51078358260,798099347,12470302,14),(146382,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146382,35.48,0.49,125,69817,75,NULL,'IR','ESO 284- G 030',NULL,'2011yCatp016004901K',2011,1,1.23,NULL,'G',0.000033,NULL,'15.98',0.17,'Scd',NULL,NULL,NULL,NULL,1,303.391375,-43.3625,0.093,NULL,51102352078,798474251,12476160,15.98),(146383,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146383,35.73,NULL,140,69817,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 284- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146384,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146384,35.76,NULL,142,69817,NULL,NULL,'Dipole + Quadrupole','ESO 284- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146385,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146385,35.79,NULL,144,69817,NULL,NULL,'Dipole','ESO 284- G 030',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146386,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146386,35.92,0.47,153,69817,NULL,NULL,'Malmquist cor.','ESO 284- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146387,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146387,36.17,0.42,172,69817,NULL,NULL,NULL,'ESO 284- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146388,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146388,36.21,0.2,175,69817,74.4,NULL,NULL,'ESO 284- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146389,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146389,33.93,0.69,61,69818,100,NULL,'mid-IR','UGC 11526',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000077,NULL,'14.7',0.6,'Sa',NULL,NULL,NULL,NULL,1,303.399583,7.28172,0.757,NULL,54211055100,847047735,13235120,14.7),(146390,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146390,34.41,0.47,76.1,69818,NULL,NULL,'H','UGC 11526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146391,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146391,34.41,0.46,76.3,69818,NULL,NULL,'J','UGC 11526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146392,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146392,34.43,0.45,77,69818,NULL,NULL,'K','UGC 11526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146393,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146393,34.45,0.4,77.5,69818,NULL,NULL,'mean','UGC 11526',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146394,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146394,34.04,0.8,64.2,69819,75,NULL,'MAT, I','NGC 6878A',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.75',0.8,'SAB(rs)c','in a pair',NULL,NULL,NULL,1,303.4,-44.81617,0.073,NULL,51103166384,798486974,12476358,13.75),(146395,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146395,32.9,0.2,38,69819,NULL,NULL,'B, Hubble-type-TF','NGC 6878A',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146396,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146396,33.34,0.32,46.6,69819,85,NULL,'I, raw','NGC 6878A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146397,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146397,33.37,0.32,47.3,69819,85,NULL,'I, inv','NGC 6878A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146398,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146398,33.53,0.43,50.7,69819,75,NULL,'MAT, I, raw','NGC 6878A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146399,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146399,33.7,0.43,55,69819,75,NULL,'MAT, I, inv','NGC 6878A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146400,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146400,33.93,0.47,61.1,69819,NULL,NULL,NULL,'NGC 6878A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146401,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146401,33.97,0.2,62.2,69819,74.4,NULL,NULL,'NGC 6878A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146402,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146402,33.99,0.43,62.7,69819,75,NULL,'MAT, I, cor','NGC 6878A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146403,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146403,34.2,0.41,69.1,69819,NULL,NULL,'Malmquist cor.','NGC 6878A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146404,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146404,36.41,0.56,191,69820,70,NULL,NULL,'2MASX J20135129-6408474',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.8R',0.18,NULL,NULL,NULL,NULL,NULL,1,303.463875,-64.14656,0.161,NULL,49361469730,771272964,12051140,15.8),(146405,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146405,33.95,0.49,61.7,69821,75,NULL,'IR','UGC 11527',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.00002,NULL,'14.29',0.4,'SB(s)ab?       HII',NULL,NULL,NULL,NULL,1,303.47675,-1.1575,0.645,NULL,48017202648,750268791,11722949,14.29),(146406,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146406,33.97,0.46,62.2,69821,NULL,NULL,'J','UGC 11527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146407,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146407,34,0.47,63,69821,NULL,NULL,'H','UGC 11527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146408,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146408,34.02,0.45,63.8,69821,NULL,NULL,'K','UGC 11527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146409,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146409,34.17,0.2,68.2,69821,74.4,NULL,NULL,'UGC 11527',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146410,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146410,34.2,0.4,69,69821,NULL,NULL,'mean','UGC 11527',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146411,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146411,34.24,0.43,70.6,69821,75,NULL,'3.6 micron, color corrected','UGC 11527',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146412,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146412,34.25,0.34,70.7,69821,NULL,NULL,NULL,'UGC 11527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146413,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146413,34.34,0.33,73.8,69821,NULL,NULL,'Malmquist cor.','UGC 11527',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146414,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146414,34.4,0.43,75.8,69821,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11527',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146415,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146415,34.18,0.55,68.6,69822,70,NULL,NULL,'ESO 284- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000083,NULL,'14.12',0.7,'SAB0^0^',NULL,NULL,NULL,NULL,1,303.552166667,-44.62317,0.073,NULL,51103238459,798488100,12476376,14.12),(146416,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146416,36.79,0.44,228,69823,NULL,NULL,'Malmquist cor.','2MASX J20141338-5719030',NULL,'2009ApJS..182..474S',2009,1,0.39,NULL,'G',0.00003,NULL,'17.62',0.1,'Sc',NULL,NULL,NULL,NULL,1,303.555791667,-57.31744,0.117,NULL,49045478565,766335602,11973993,17.62),(146417,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146417,37.09,0.38,262,69823,NULL,NULL,NULL,'2MASX J20141338-5719030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146418,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146418,37.13,0.2,267,69823,74.4,NULL,NULL,'2MASX J20141338-5719030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146419,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146419,36.06,0.49,163,69824,70,NULL,NULL,'ESO 143- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'6dF DR2 has z = 0.036070.','G',0.00015,NULL,'15.57',0.5,'S0',NULL,NULL,NULL,NULL,1,303.556875,-59.49247,0.069,NULL,49031184228,766112253,11970503,15.57),(146420,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146420,34.05,0.8,64.7,69825,75,NULL,'MAT, I','ESO 233- G 047',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.44',0.7,'(R\')SB(rs)bc',NULL,NULL,NULL,NULL,1,303.570625,-48.82669,0.133,NULL,51136661859,799010341,12484536,15.44),(146421,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146421,33.97,0.43,62.3,69825,75,NULL,'MAT, I, raw','ESO 233- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146422,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146422,34.04,0.43,64.2,69825,75,NULL,'MAT, I, inv','ESO 233- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146423,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146423,34.07,0.32,65.1,69825,85,NULL,'I, raw','ESO 233- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146424,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146424,34.08,0.32,65.5,69825,85,NULL,'I, inv','ESO 233- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146425,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146425,34.23,0.43,70.2,69825,75,NULL,'MAT, I, cor','ESO 233- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146426,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146426,35.37,0.54,119,69826,70,NULL,NULL,'2MASX J20143427-1216148',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,303.642833,-12.27078,0.265,NULL,47933770195,748965159,11702580,14.6),(146427,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146427,34.79,0.66,90.9,69827,70,NULL,NULL,'2MASX J20144323-0700345',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00008,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,303.680125,-7.00961,0.241,NULL,48036654828,750572731,11727698,14.5),(146428,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146428,36.94,0.59,244,69828,70,NULL,NULL,'2MASX J20144467-1730378',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,303.686083,-17.51047,0.245,NULL,50843122432,794423788,12412871,15.2),(146429,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146429,34.47,0.53,78.3,69829,70,NULL,NULL,'FAIRALL 0886',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,303.691667,-51.67639,0.141,NULL,51126127737,798845745,12481964,13.4),(146430,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146430,34.72,0.8,87.7,69830,75,NULL,'MAT, I','ESO 596- G 009',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.74',0.5,'SBbc?',NULL,NULL,NULL,NULL,1,303.713291667,-18.02161,0.249,NULL,50842873848,794419903,12412810,15.74),(146431,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146431,33.83,0.32,58.3,69830,85,NULL,'I, raw','ESO 596- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146432,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146432,33.84,0.32,58.7,69830,85,NULL,'I, inv','ESO 596- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146433,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146433,33.96,0.43,61.9,69830,75,NULL,'MAT, I, raw','ESO 596- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146434,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146434,34.05,0.43,64.5,69830,75,NULL,'MAT, I, inv','ESO 596- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146435,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146435,34.41,0.43,76.2,69830,75,NULL,'MAT, I, cor','ESO 596- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146436,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146436,34.68,0.58,86.2,69830,NULL,NULL,NULL,'ESO 596- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146437,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146437,34.72,0.2,87.9,69830,74.4,NULL,NULL,'ESO 596- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146438,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146438,34.82,0.54,92,69830,NULL,NULL,'Malmquist cor.','ESO 596- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146439,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146439,35.82,0.51,146,69831,70,NULL,NULL,'2MASX J20145495-1944047',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.99',0.5,NULL,NULL,NULL,NULL,NULL,1,303.729,-19.73464,0.313,NULL,50859996725,794687448,12416991,15.99),(146440,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146440,35.61,NULL,132,69832,NULL,NULL,NULL,'FGCE 1446',NULL,'2000BSAO...50....5K',2000,1,0.73,NULL,'G',0.000023,'?','17.7',0.07,'Sd',NULL,NULL,NULL,NULL,1,303.747083,-19.85528,0.261,NULL,50859940547,794686571,12416977,17.7),(146441,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146441,37.09,0.6,262,69833,70,NULL,NULL,'2MASX J20145978-5307301',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.00015,NULL,'15.6R',0.16,NULL,NULL,NULL,NULL,NULL,1,303.749167,-53.12511,0.193,NULL,51078967143,798108861,12470450,15.6),(146442,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146442,34.84,0.49,92.9,69834,75,NULL,'IR','UGC 11531',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00005,NULL,'17.',0.1,NULL,NULL,NULL,NULL,NULL,1,303.769625,58.44294,1.349,NULL,53011492927,828304576,12942259,17),(146443,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146443,34.52,0.2,80.2,69835,74.4,NULL,NULL,'ESO 399- G 026',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000033,NULL,'14.70',0.6,'S?',NULL,NULL,NULL,NULL,1,303.777625,-37.23694,0.225,NULL,51292034122,801438033,12522469,14.7),(146444,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146444,34.66,0.29,85.4,69835,NULL,NULL,'Malmquist cor.','ESO 399- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146445,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146445,34.66,0.29,85.7,69835,NULL,NULL,NULL,'ESO 399- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146446,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146446,34.35,0.8,74.2,69836,75,NULL,'MAT, I','ESO 186- G 021',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.12',1,'SAB(rs)c',NULL,NULL,NULL,NULL,1,303.787375,-52.71747,0.141,NULL,51078816949,798106514,12470414,14.12),(146447,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146447,34.11,NULL,66.4,69836,NULL,NULL,'B','ESO 186- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146448,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146448,34.12,0.15,66.7,69836,NULL,NULL,'B, Hubble-type-TF','ESO 186- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146449,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146449,34.18,0.32,68.4,69836,85,NULL,'I, raw','ESO 186- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146450,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146450,34.23,0.32,70.2,69836,85,NULL,'I, inv','ESO 186- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146451,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146451,34.24,0.43,70.4,69836,75,NULL,'MAT, I, raw','ESO 186- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146452,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146452,34.31,0.37,72.7,69836,NULL,NULL,'Malmquist cor.','ESO 186- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146453,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146453,34.36,0.43,74.6,69836,75,NULL,'MAT, I, cor','ESO 186- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146454,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146454,34.4,NULL,75.9,69836,NULL,NULL,'I','ESO 186- G 021',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146455,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146455,34.41,0.4,76.3,69836,NULL,NULL,'mean','ESO 186- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146456,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146456,34.44,0.34,77.4,69836,NULL,NULL,NULL,'ESO 186- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146457,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146457,34.49,0.43,79,69836,75,NULL,'MAT, I, inv','ESO 186- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146458,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146458,34.49,0.2,79.1,69836,74.4,NULL,NULL,'ESO 186- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146459,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146459,34.56,0.47,81.8,69836,NULL,NULL,'H','ESO 186- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146460,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146460,34.66,0.46,85.7,69836,NULL,NULL,'J','ESO 186- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146461,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146461,34.68,0.45,86.3,69836,NULL,NULL,'K','ESO 186- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146462,'BL Lac Luminosity','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146462,41.98,NULL,2480,69837,70,NULL,'nucleus-to-host flux ratio, z > 0.94','PKS 2012-017',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'17.5',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,303.813167,-1.62572,0.445,NULL,48019862699,750310354,11723599,17.5),(146463,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146463,37.13,0.58,266,69838,70,NULL,NULL,'2MASX J20151973-4708520',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.4b',0.3,'(R)SB(rs)0/a',NULL,NULL,NULL,NULL,1,303.8322917,-47.14775,0.121,NULL,51129835815,798903684,12482870,16.4),(146464,'GRB','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'N',146464,41.66,NULL,1400,69839,71,NULL,NULL,'GRB 061122 HOST',0.54,'2013MNRAS.431.3550G',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146465,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146465,36.11,0.52,166,69840,70,NULL,NULL,'IC 4974 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.57',NULL,'Compact',NULL,NULL,NULL,NULL,1,303.858875,-61.85767,0.089,NULL,49154547465,768039804,12000621,15.57),(146466,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146466,34.89,0.43,94.9,69841,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-51-004',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000023,NULL,'14.5',0.5,NULL,NULL,NULL,NULL,NULL,1,303.9160417,-13.62203,0.341,NULL,47935682677,748995041,11703047,14.5),(146467,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146467,35.26,0.62,113,69842,70,NULL,NULL,'IC 4976',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.58',0.4,'(R)SB(r)a:',NULL,NULL,NULL,NULL,1,303.921083333,-61.87514,0.089,NULL,49154546118,768039783,12000621,15.58),(146468,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146468,33.8,0.49,57.6,69843,75,NULL,'IR','ESO 284- G 036',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.77',0.3,'Sb',NULL,NULL,NULL,NULL,1,303.934917,-43.13339,0.105,NULL,51089490748,798273292,12473020,15.77),(146469,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146469,33.93,0.55,61.1,69843,NULL,NULL,NULL,'ESO 284- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146470,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146470,33.97,0.2,62.2,69843,74.4,NULL,NULL,'ESO 284- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146471,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146471,34.34,0.46,73.8,69843,NULL,NULL,'Malmquist cor.','ESO 284- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146472,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146472,34.19,0.8,69,69844,75,NULL,'MAT, I','MCG -01-51-001',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'15',0.5,'SB(rs)bc?      HII',NULL,NULL,NULL,NULL,1,303.9535,-2.90047,0.413,NULL,48018641627,750291275,11723301,15),(146473,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146473,33.84,0.32,58.7,69844,85,NULL,'I, raw','MCG -01-51-001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146474,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146474,33.87,0.43,59.5,69844,75,NULL,'MAT, I, raw','MCG -01-51-001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146475,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146475,33.88,0.32,59.8,69844,85,NULL,'I, inv','MCG -01-51-001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146476,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146476,33.91,0.2,60.5,69844,74.4,NULL,NULL,'MCG -01-51-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146477,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146477,34.05,0.43,64.6,69844,75,NULL,'MAT, I, inv','MCG -01-51-001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146478,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146478,34.12,0.38,66.8,69844,NULL,NULL,NULL,'MCG -01-51-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146479,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146479,34.22,0.43,69.9,69844,75,NULL,'MAT, I, cor','MCG -01-51-001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146480,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146480,34.34,0.35,73.7,69844,NULL,NULL,'Malmquist cor.','MCG -01-51-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146481,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146481,36.53,0.83,203,69845,70,NULL,NULL,'2MASX J20155152-4426150',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.3,NULL,NULL,NULL,NULL,NULL,1,303.9647083,-44.43753,0.049,NULL,51102957166,798483705,12476307,14.3),(146482,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146482,36.05,0.48,162,69846,70,NULL,NULL,'2MASX J20155293-5316223',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.2I',0.7,NULL,NULL,NULL,NULL,NULL,1,303.970625,-53.27289,0.197,NULL,51078925375,798108208,12470440,13.2),(146483,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146483,35.06,0.48,103,69847,70,NULL,NULL,'ESO 284- G 037',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.0001,NULL,'14.49',0.6,'SA0^0',NULL,NULL,NULL,NULL,1,303.981625,-46.15058,0.057,NULL,51097976575,798405883,12475091,14.49),(146484,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146484,35.4,0.52,120,69848,70,NULL,NULL,'2MASX J20155569-4418490',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.5,NULL,NULL,NULL,NULL,NULL,1,303.982167,-44.31361,0.077,NULL,51100910491,798451726,12475808,13.5),(146485,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146485,34.15,0.8,67.6,69849,75,NULL,'MAT, I','ESO 284- G 039',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.61',0.7,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,304.027125,-44.42164,0.049,NULL,51102950623,798483603,12476306,14.61),(146486,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146486,32.52,0.32,31.9,69849,85,NULL,'I, raw','ESO 284- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146487,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146487,32.53,0.32,32,69849,85,NULL,'I, inv','ESO 284- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146488,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146488,33.18,0.43,43.3,69849,75,NULL,'MAT, I, raw','ESO 284- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146489,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146489,33.31,0.43,45.9,69849,75,NULL,'MAT, I, inv','ESO 284- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146490,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146490,33.57,0.43,51.9,69849,75,NULL,'MAT, I, cor','ESO 284- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146491,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146491,34.38,0.4,75.3,69849,NULL,NULL,'mean','ESO 284- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146492,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146492,34.49,0.47,79,69849,NULL,NULL,'H','ESO 284- G 039',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146493,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146493,33.73,0.54,55.8,69850,70,NULL,NULL,'ESO 233- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00005,NULL,'13.93',1,'SA(rs)0-?',NULL,NULL,NULL,NULL,1,304.040667,-49.31322,0.113,NULL,51133265540,798957274,12483707,13.93),(146494,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146494,36.07,0.65,164,69851,70,NULL,NULL,'IC 4984',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.39',0.5,'Sa-b',NULL,NULL,NULL,NULL,1,304.0727083,-52.70372,0.141,NULL,51078795723,798106183,12470409,15.39),(146495,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146495,33.89,0.71,60,69852,NULL,NULL,NULL,'ESO 400- G 002',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.75',0.3,'S...','in a pair',NULL,NULL,NULL,1,304.07925,-37.01533,0.233,NULL,51292046237,801438222,12522472,15.75),(146496,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146496,33.93,0.2,61.1,69852,74.4,NULL,NULL,'ESO 400- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146497,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146497,34.34,0.58,73.9,69852,NULL,NULL,'Malmquist cor.','ESO 400- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146498,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146498,33.97,0.58,62.2,69853,NULL,NULL,NULL,'ESO 284- G 043',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.51',0.6,'SB(s)dm',NULL,NULL,NULL,NULL,1,304.1294583,-44.70911,0.009,NULL,51102976545,798484008,12476312,14.51),(146499,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146499,34.01,0.2,63.4,69853,74.4,NULL,NULL,'ESO 284- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146500,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146500,34.29,0.5,72.2,69853,NULL,NULL,'Malmquist cor.','ESO 284- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146501,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146501,34.02,0.48,63.6,69854,70,NULL,NULL,'ESO 284- G 044',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000087,NULL,'13.59',1.1,'SAB0^0',NULL,NULL,NULL,NULL,1,304.14925,-46.966,0.105,NULL,51097186292,798393535,12474898,13.59),(146502,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146502,35.16,0.64,108,69855,70,NULL,NULL,'2MASX J20164318-4545529',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.179875,-45.76469,0,NULL,51097733867,798402091,12475032,14.4),(146503,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146503,34.39,0.8,75.5,69856,75,NULL,'MAT, I','ESO 400- G 005',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000013,NULL,'14.05',0.9,'SA(s)c','in a pair',NULL,NULL,NULL,1,304.213125,-36.98697,0.217,NULL,51291262657,801425979,12522280,14.05),(146504,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146504,33.6,0.32,52.5,69856,85,NULL,'I, raw','ESO 400- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146505,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146505,33.62,0.43,52.9,69856,75,NULL,'MAT, I, raw','ESO 400- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146506,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146506,33.64,0.32,53.5,69856,85,NULL,'I, inv','ESO 400- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146507,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146507,33.81,0.43,57.8,69856,75,NULL,'MAT, I, inv','ESO 400- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146508,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146508,34.12,0.43,66.8,69856,75,NULL,'MAT, I, cor','ESO 400- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146509,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146509,34.21,0.2,69.5,69856,74.4,NULL,NULL,'ESO 400- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146510,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146510,34.37,0.31,75,69856,NULL,NULL,NULL,'ESO 400- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146511,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146511,34.48,0.47,78.7,69856,NULL,NULL,'H','ESO 400- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146512,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146512,34.53,0.29,80.5,69856,NULL,NULL,'Malmquist cor.','ESO 400- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146513,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146513,34.57,0.4,81.9,69856,NULL,NULL,'mean','ESO 400- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146514,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146514,34.59,0.46,82.7,69856,NULL,NULL,'J','ESO 400- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146515,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146515,34.62,0.45,84.1,69856,NULL,NULL,'K','ESO 400- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146516,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146516,33.19,0.81,43.5,69857,NULL,NULL,NULL,'ESO 233- G 050',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.81',0.6,'SA(s)b',NULL,NULL,NULL,NULL,1,304.2617917,-47.77114,0.117,NULL,51130623893,798915998,12483062,14.81),(146517,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146517,33.23,0.2,44.3,69857,74.4,NULL,NULL,'ESO 233- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146518,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146518,33.43,0.73,48.5,69857,NULL,NULL,'Malmquist cor.','ESO 233- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146519,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146519,34.69,0.5,86.9,69858,70,NULL,NULL,'MCG -07-41-022',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00009,NULL,'15',0.15,NULL,NULL,NULL,NULL,NULL,1,304.2714583,-43.58494,0.093,NULL,51100699357,798448427,12475756,15),(146520,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146520,32,0.8,25.1,69859,75,NULL,'MAT, I','IC 4986',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00001,NULL,'14.13',0.9,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,304.2985417,-55.03639,0.217,NULL,48997530090,765586407,11962287,14.13),(146521,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146521,31.99,0.32,25,69859,85,NULL,'I, inv','IC 4986',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146522,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146522,32,0.32,25.1,69859,85,NULL,'I, raw','IC 4986',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146523,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146523,32.26,0.43,28.3,69859,75,NULL,'MAT, I, raw','IC 4986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146524,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146524,32.27,0.43,28.5,69859,75,NULL,'MAT, I, inv','IC 4986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146525,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146525,32.55,0.46,32.4,69859,NULL,NULL,NULL,'IC 4986',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146526,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146526,32.59,0.2,33,69859,74.4,NULL,NULL,'IC 4986',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146527,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146527,32.64,0.43,33.7,69859,75,NULL,'MAT, I, cor','IC 4986',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146528,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146528,32.87,0.4,37.5,69859,NULL,NULL,'Malmquist cor.','IC 4986',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146529,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146529,32.73,0.8,35.2,69860,75,NULL,'MAT, I','ESO 340- G 008',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'15.39',0.2,'Scd',NULL,NULL,NULL,NULL,1,304.299083,-40.92372,0.153,NULL,51087224791,798237887,12472466,15.39),(146530,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146530,32.93,0.4,38.5,69860,75,NULL,NULL,'ESO 340- G 008',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146531,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146531,33.02,0.32,40.1,69860,85,NULL,'I, inv','ESO 340- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146532,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146532,33.03,0.32,40.3,69860,85,NULL,'I, raw','ESO 340- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146533,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146533,33.15,NULL,42.7,69860,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 340- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146534,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146534,33.16,NULL,42.9,69860,NULL,NULL,'Dipole','ESO 340- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146535,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146535,33.17,NULL,43,69860,NULL,NULL,'Dipole + Quadrupole','ESO 340- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146536,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146536,33.2,0.43,43.7,69860,75,NULL,'MAT, I, raw','ESO 340- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146537,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146537,33.23,0.43,44.2,69860,75,NULL,'MAT, I, inv','ESO 340- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146538,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146538,33.24,0.59,44.6,69860,NULL,NULL,'Malmquist cor.','ESO 340- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146539,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146539,33.25,NULL,44.7,69860,NULL,NULL,NULL,'ESO 340- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146540,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146540,33.34,0.56,46.5,69860,NULL,NULL,NULL,'ESO 340- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146541,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146541,33.38,0.2,47.4,69860,74.4,NULL,NULL,'ESO 340- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146542,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146542,33.46,0.49,49.3,69860,75,NULL,'IR','ESO 340- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146543,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146543,33.65,0.43,53.7,69860,75,NULL,'MAT, I, cor','ESO 340- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146544,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146544,35.33,0.52,116,69861,70,NULL,NULL,'ESO 233- G 051',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.65',0.2,'Compact:',NULL,NULL,NULL,NULL,1,304.302166667,-52.11622,0.149,NULL,51080641141,798135017,12470859,15.65),(146545,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146545,36.35,0.61,186,69862,70,NULL,NULL,'2MASX J20171347-6502314',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.6R',0.17,NULL,NULL,NULL,NULL,NULL,1,304.305917,-65.04208,0.137,NULL,49374557565,771477461,12054335,15.6),(146546,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146546,35.56,0.69,130,69863,70,NULL,NULL,'2MASX J20171553-7913453',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,304.3147083,-79.22919,0.569,NULL,48579674936,759057420,11860272,16.7),(146547,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146547,36.56,0.59,206,69864,70,NULL,NULL,'2MASX J20171638-1906113',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.36',0.4,NULL,NULL,NULL,NULL,NULL,1,304.3182083,-19.10314,0.225,NULL,50858375510,794662117,12416595,16.36),(146548,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146548,32.53,0.8,32.1,69865,75,NULL,'MAT, I','NGC 6887',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.000021,NULL,'12.82',1.3,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,304.322041667,-52.79675,0.141,NULL,51081660302,798150942,12471108,12.82),(146549,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146549,32.67,0.8,34.2,69865,75,NULL,'B','NGC 6887',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146550,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146550,32.37,0.47,29.8,69865,NULL,NULL,'H','NGC 6887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146551,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146551,32.39,0.4,30.1,69865,NULL,NULL,NULL,'NGC 6887',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146552,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146552,32.4,0.46,30.2,69865,NULL,NULL,'J','NGC 6887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146553,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146553,32.48,0.45,31.4,69865,NULL,NULL,'K','NGC 6887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146554,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146554,32.5,0.43,31.7,69865,75,NULL,'MAT, I, raw','NGC 6887',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146555,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146555,32.52,0.32,31.9,69865,85,NULL,'I, raw','NGC 6887',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146556,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146556,32.58,0.32,32.8,69865,85,NULL,'I, inv','NGC 6887',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146557,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146557,32.72,0.4,35,69865,NULL,NULL,'mean','NGC 6887',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146558,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146558,32.72,NULL,35,69865,NULL,NULL,'B','NGC 6887',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146559,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146559,32.73,NULL,35.2,69865,NULL,NULL,'I','NGC 6887',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146560,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146560,32.75,0.43,35.5,69865,75,NULL,'MAT, I, inv','NGC 6887',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146561,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146561,32.86,0.43,37.3,69865,75,NULL,'MAT, I, cor','NGC 6887',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146562,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146562,32.52,0.8,31.9,69866,75,NULL,'MAT, I','ESO 340- G 009',NULL,'1997ApJS..109..333W',1997,1,2.44,NULL,'G',0.000017,NULL,'14.48',0.32,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,304.3355,-38.67375,0.185,NULL,51288924944,801389452,12521710,14.48),(146563,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146563,32.14,0.2,26.8,69866,74.4,NULL,NULL,'ESO 340- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146564,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146564,32.23,0.43,28,69866,75,NULL,'3.6 micron, color corrected','ESO 340- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146565,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146565,32.24,0.43,28,69866,75,NULL,'3.6 micron, color + selection bias corrected','ESO 340- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146566,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146566,32.36,0.4,29.6,69866,NULL,NULL,NULL,'ESO 340- G 009',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146567,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146567,32.51,NULL,31.8,69866,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 340- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146568,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146568,32.53,NULL,32.1,69866,NULL,NULL,'Dipole + Quadrupole','ESO 340- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146569,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146569,32.54,0.4,32.2,69866,75,NULL,NULL,'ESO 340- G 009',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146570,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146570,32.55,NULL,32.3,69866,NULL,NULL,'Dipole','ESO 340- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146571,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146571,32.56,0.32,32.5,69866,85,NULL,'I, inv','ESO 340- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146572,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146572,32.57,0.32,32.7,69866,85,NULL,'I, raw','ESO 340- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146573,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146573,32.75,0.43,35.5,69866,75,NULL,'MAT, I, raw','ESO 340- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146574,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146574,32.76,0.43,35.7,69866,75,NULL,'MAT, I, inv','ESO 340- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146575,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146575,32.87,NULL,37.5,69866,NULL,NULL,NULL,'ESO 340- G 009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146576,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146576,32.95,0.43,38.9,69866,75,NULL,'MAT, I, cor','ESO 340- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146577,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,'R',146577,32.99,0.49,39.6,69866,75,NULL,'IR','ESO 340- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146578,'FP','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146578,34.43,0.6,76.9,69867,70,NULL,NULL,'2MASX J20172214-5317101',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'14.3R',0.21,NULL,NULL,NULL,NULL,NULL,1,304.342417,-53.28617,0.197,NULL,51078900316,798107817,12470434,14.3),(146579,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146579,32.96,0.8,39.1,69868,75,NULL,'MAT, I','IC 4964',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'13.40',0.7,'SB(s)cd',NULL,NULL,NULL,NULL,1,304.3497083,-73.88564,0.197,NULL,48488206182,757628221,11837940,13.4),(146580,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146580,32.08,0.32,26.1,69868,85,NULL,'I, inv','IC 4964',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146581,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146581,32.11,0.32,26.4,69868,85,NULL,'I, raw','IC 4964',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146582,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146582,32.38,0.43,29.9,69868,75,NULL,'MAT, I, inv','IC 4964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146583,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146583,32.42,0.43,30.4,69868,75,NULL,'MAT, I, raw','IC 4964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146584,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:05','1',NULL,NULL,146584,32.76,0.43,35.7,69868,75,NULL,'MAT, I, cor','IC 4964',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146585,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146585,32.97,0.4,39.3,69868,NULL,NULL,NULL,'IC 4964',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146586,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146586,37.01,0.78,252,69869,70,NULL,NULL,'2MASX J20172524-6331104',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.6R',0.19,NULL,NULL,NULL,NULL,NULL,1,304.355125,-63.51947,0.149,NULL,49141709888,767839217,11997487,15.6),(146587,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146587,33.71,NULL,55.2,69870,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2266',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.00001,NULL,'16.3',0.13,'Sbc',NULL,NULL,NULL,NULL,1,304.3712917,-10.84742,0.229,NULL,48002249281,750035145,11719299,16.3),(146588,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146588,33.72,NULL,55.5,69870,NULL,NULL,'Dipole + Quadrupole','FGC 2266',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146589,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146589,33.75,NULL,56.2,69870,NULL,NULL,'Dipole','FGC 2266',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146590,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146590,35.24,0.51,112,69871,70,NULL,NULL,'ESO 596- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000123,NULL,'15.81',1,'S0',NULL,NULL,NULL,NULL,1,304.434041667,-22.23917,0.269,NULL,50863188153,794737314,12417770,15.81),(146591,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146591,37.62,0.57,334,69872,70,NULL,NULL,'2MASX J20174521-4621013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,304.4385417,-46.35042,0.041,NULL,51098129641,798408275,12475129,16.9),(146592,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146592,36.36,0.65,187,69873,70,NULL,NULL,'2MASX J20175279-1210435',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,304.470041667,-12.17883,0.277,NULL,48002022360,750031599,11719243,14.1),(146593,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146593,35.5,0.53,126,69874,70,NULL,NULL,'2MASX J20175838-2156572',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000117,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.493167,-21.94922,0.297,NULL,50862405649,794725088,12417579,14.8),(146594,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146594,35.12,0.48,106,69875,70,NULL,NULL,'ESO 284- G 051',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00012,NULL,'14.30',0.7,'SB0^-','Pair member (points to parent)',NULL,NULL,NULL,1,304.513625,-45.51925,0,NULL,51097694984,798401484,12475023,14.3),(146595,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146595,32.51,0.8,31.8,69876,75,NULL,'B','NGC 6890',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000083,NULL,'13.01',1.2,'(R\')SA(r:)ab   Sy2','Group member',NULL,NULL,'Sy 1.9',1,304.575417,-44.80672,0.033,NULL,51100798982,798449984,12475781,13.01),(146596,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146596,33.35,0.38,46.8,69877,NULL,NULL,NULL,'NGC 6876',NULL,'2001MNRAS.327.1004B',2001,1,2.8,NULL,'G',0.000053,NULL,'12.06',2.2,'SB0^-','in a pair',NULL,NULL,NULL,1,304.5797917,-70.85881,0.161,NULL,49214627277,768978551,12015289,12.06),(146597,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146597,33.53,0.38,50.9,69877,NULL,NULL,'Malmquist cor.','NGC 6876',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146598,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146598,32.54,0.4,32.2,69877,75,NULL,'Edat, raw','NGC 6876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146599,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146599,32.88,0.4,37.6,69877,75,NULL,'Edat, cor','NGC 6876',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146600,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146600,32.62,0.65,33.4,69877,95,NULL,'Weighted Mean','NGC 6876',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146601,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146601,34.22,0.81,69.8,69877,55,NULL,'Visvanathan & Sandage 1979','NGC 6876',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146602,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146602,32.57,0.41,32.6,69877,NULL,NULL,NULL,'NGC 6876',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146603,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146603,32.97,0.41,39.2,69877,NULL,NULL,'Malmquist cor.','NGC 6876',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146604,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146604,32.71,0.3,34.8,69877,NULL,NULL,'Pavo I GROUP, 5 galaxies','NGC 6876',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146605,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146605,32.83,0.45,36.8,69877,NULL,NULL,'K','NGC 6876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146606,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146606,33.71,0.4,55.2,69877,NULL,NULL,'mean','NGC 6876',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146607,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146607,35.3,0.49,115,69878,70,NULL,NULL,'2MASX J20182212-4153472',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.59225,-41.89653,0.145,NULL,51090067543,798282305,12473161,14.4),(146608,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146608,34.24,0.49,70.6,69879,75,NULL,'IR','ESO 462- G 007',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000023,NULL,'15.48',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,304.594666667,-27.45481,0.361,NULL,51327460881,801991576,12531118,15.48),(146609,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146609,34.57,0.2,82,69879,74.4,NULL,NULL,'ESO 462- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146610,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146610,34.57,0.31,82.1,69879,NULL,NULL,NULL,'ESO 462- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146611,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146611,34.65,0.3,85.3,69879,NULL,NULL,'Malmquist cor.','ESO 462- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146612,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146612,34.27,0.46,71.5,69880,70,NULL,NULL,'IC 4991',NULL,'2014MNRAS.445.2677S',2014,1,2.6,NULL,'G',0.000073,NULL,'11.56',1.8,'SA(r)0^0^? pec',NULL,NULL,NULL,NULL,1,304.597,-41.05017,0.145,NULL,51372251696,802691432,12542053,11.56),(146613,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146613,31.25,0.4,17.8,69881,NULL,NULL,'mean','UGC 11539',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000097,NULL,NULL,NULL,'E',NULL,NULL,NULL,NULL,1,304.63375,62.69056,0.857,NULL,53466151431,835408616,13053259,NULL),(146614,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146614,32.81,0.45,36.6,69881,NULL,NULL,'K','UGC 11539',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146615,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146615,32.74,0.8,35.3,69882,75,NULL,'B','ESO 340- G 012',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000083,NULL,'13.8b',1,'SAB(rs)cd:','in a pair',NULL,NULL,NULL,1,304.638041667,-39.33678,0.161,NULL,51506231288,804784863,12574763,13.8),(146616,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146616,34.17,0.8,68.1,69883,75,NULL,'MAT, I','UGC 11537',NULL,'1997ApJS..109..333W',1997,1,2.4,'1998A&AS..130..333T has V = 5416 +- 2 km/sec.','G',0.00003,NULL,'14.34',0.7,'Sc:',NULL,NULL,NULL,NULL,1,304.6587083,-0.1505,0.413,NULL,47798927655,746858244,11669660,14.34),(146617,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146617,33.73,0.49,55.6,69883,75,NULL,'IR','UGC 11537',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146618,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146618,33.86,0.43,59.2,69883,75,NULL,'MAT, I, raw','UGC 11537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146619,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146619,33.88,0.46,59.8,69883,NULL,NULL,'J','UGC 11537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146620,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146620,33.89,0.47,60,69883,NULL,NULL,'H','UGC 11537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146621,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146621,34.01,0.45,63.5,69883,NULL,NULL,'K','UGC 11537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146622,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146622,34.03,0.32,63.9,69883,85,NULL,'I, raw','UGC 11537',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146623,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146623,34.05,0.2,64.6,69883,74.4,NULL,NULL,'UGC 11537',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146624,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146624,34.09,0.36,65.8,69883,NULL,NULL,NULL,'UGC 11537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146625,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146625,34.11,0.32,66.3,69883,85,NULL,'I, inv','UGC 11537',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146626,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146626,34.18,0.43,68.5,69883,75,NULL,'MAT, I, inv','UGC 11537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146627,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146627,34.18,0.4,68.5,69883,NULL,NULL,'mean','UGC 11537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146628,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146628,34.18,0.35,68.5,69883,NULL,NULL,'Malmquist cor.','UGC 11537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146629,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146629,34.2,0.43,69.3,69883,75,NULL,'MAT, I, cor','UGC 11537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146630,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146630,34.22,0.43,70,69883,75,NULL,'3.6 micron, color corrected','UGC 11537',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146631,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146631,34.49,0.43,79.2,69883,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11537',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146632,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146632,36.01,0.7,159,69884,70,NULL,NULL,'2MASX J20184365-4541562',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.681875,-45.69889,0.033,NULL,51097678864,798401232,12475019,15.7),(146633,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146633,32.6,0.4,33.2,69885,NULL,NULL,'mean','NGC 6889',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.00001,NULL,'13.68',1.1,'SBbc? pec',NULL,NULL,NULL,NULL,1,304.721791667,-53.95708,0.197,NULL,51078738333,798105286,12470395,13.68),(146634,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146634,32.68,0.47,34.4,69885,NULL,NULL,'H','NGC 6889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146635,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146635,32.75,0.46,35.4,69885,NULL,NULL,'J','NGC 6889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146636,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146636,32.79,0.45,36.2,69885,NULL,NULL,'K','NGC 6889',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146637,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146637,34.84,0.48,92.8,69886,70,NULL,NULL,'MCG -07-41-027',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000067,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,304.737375,-41.26942,0.145,NULL,51372141600,802689712,12542026,15.5),(146638,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146638,36.31,0.53,182,69887,70,NULL,NULL,'2MASX J20190248-5743204',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,304.760417,-57.72228,0.133,NULL,49045723698,766339432,11974053,14),(146639,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146639,35.66,0.58,136,69888,70,NULL,NULL,'2MASX J20190372-0108522',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000097,NULL,'13.4I',0.6,NULL,NULL,NULL,NULL,NULL,1,304.765583,-1.14781,0.417,NULL,47802320905,746911264,11670488,13.4),(146640,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146640,36.25,0.71,178,69889,70,NULL,NULL,'2MASX J20190627-5237445',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'15.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,304.776167,-52.62906,0.125,NULL,51081864440,798154131,12471158,15.4),(146641,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15171','R',146641,39.11,0.18,582,69890,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kb','SN 2006kb',0.1392,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,304.7925417,-1.0645,0.397,NULL,47802466009,746913531,11670523,NULL),(146642,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15171','R',146642,39.38,0.07,660,69890,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kb','SN 2006kb',0.1392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146643,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146643,36.14,0.55,169,69891,70,NULL,NULL,'2MASX J20191315-1942221',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.09',NULL,NULL,NULL,NULL,NULL,NULL,1,304.80475,-19.70608,0.205,NULL,50858607017,794665734,12416652,16.09),(146644,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146644,36.45,0.73,195,69892,70,NULL,NULL,'2MASX J20191656-1046034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.819083,-10.76758,0.213,NULL,48002909213,750045456,11719460,15.6),(146645,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146645,36.2,0.53,174,69893,70,NULL,NULL,'2MASX J20192466-5244464',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'14.9R',0.3,NULL,NULL,NULL,NULL,NULL,1,304.85275,-52.74622,0.125,NULL,51081842919,798153795,12471153,14.9),(146646,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146646,35.7,0.56,138,69894,70,NULL,NULL,'2MASX J20193137-6539143',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'14.5R',0.29,NULL,NULL,NULL,NULL,NULL,1,304.880667,-65.65392,0.125,NULL,49374741193,771480331,12054380,14.5),(146647,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146647,32.26,0.4,28.3,69895,NULL,NULL,NULL,'NGC 6911',NULL,'2009AJ....138..323T',2009,1,1.7,NULL,'G',0.000027,NULL,'15.1',1.1,'SBb:',NULL,NULL,NULL,NULL,1,304.909708333,66.72833,0.781,NULL,53648375979,838255874,13097748,15.1),(146648,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146648,32.44,0.45,30.8,69895,NULL,NULL,'K','NGC 6911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146649,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146649,32.49,0.46,31.5,69895,NULL,NULL,'J','NGC 6911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146650,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146650,32.55,0.43,32.3,69895,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6911',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146651,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146651,32.55,0.2,32.4,69895,74.4,NULL,NULL,'NGC 6911',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146652,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146652,32.57,0.47,32.7,69895,NULL,NULL,'H','NGC 6911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146653,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146653,32.62,0.43,33.4,69895,75,NULL,'3.6 micron, color corrected','NGC 6911',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146654,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146654,32.74,0.4,35.3,69895,NULL,NULL,'mean','NGC 6911',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146655,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146655,34.37,0.57,74.9,69896,70,NULL,NULL,'2MASX J20193988-4944212',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000063,NULL,'14.1R',0.28,NULL,NULL,NULL,NULL,NULL,1,304.9162083,-49.73933,0.109,NULL,51131256504,798925882,12483216,14.1),(146656,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146656,36.28,0.64,180,69897,70,NULL,NULL,'2MASX J20194084-5236312',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'15.6R',0.18,NULL,NULL,NULL,NULL,NULL,1,304.920125,-52.60869,0.125,NULL,51081802610,798153165,12471143,15.6),(146657,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146657,32.98,0.43,39.5,69898,75,NULL,'3.6 micron, color + selection bias corrected','ESO 340-IG 017',NULL,'2014MNRAS.444..527S',2014,1,2.6,NULL,'G',0.000013,NULL,'13.18',0.9,'SB(s)dm: pec','in a pair',NULL,NULL,NULL,1,304.923625,-39.28861,0.121,NULL,51507049687,804797651,12574963,13.18),(146658,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146658,36.72,0.67,221,69899,70,NULL,NULL,'2MASX J20194208-5257092',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.6R',0.11,NULL,NULL,NULL,NULL,NULL,1,304.925583,-52.95258,0.181,NULL,51081840917,798153764,12471152,15.6),(146659,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146659,35.93,0.49,154,69900,70,NULL,NULL,'2MASX J20194340-2947426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,304.930916667,-29.79517,0.301,NULL,51338068736,802157324,12533708,14.8),(146660,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146660,33.98,0.47,62.5,69901,70,NULL,NULL,'IC 4994',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'13.89',1.3,'SA0^0^: pec',NULL,NULL,NULL,NULL,1,304.9355,-53.44736,0.185,NULL,51082044082,798156938,12471202,13.89),(146661,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146661,36.29,0.53,181,69902,70,NULL,NULL,'2MASX J20194685-6645425',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'14.9R',0.26,'(R_1R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,304.94525,-66.76175,0.093,NULL,49366778214,771355909,12052436,14.9),(146662,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146662,35.97,0.64,157,69903,70,NULL,NULL,'2MASX J20195437-0314263',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,304.976583,-3.24081,0.321,NULL,47805437457,746959960,11671249,14),(146663,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146663,34.86,0.46,93.6,69904,NULL,NULL,'Malmquist cor.','ESO 400- G 008',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.78',0.7,'S...',NULL,NULL,NULL,NULL,1,304.983875,-37.20883,0.213,NULL,51289658972,801400921,12521889,15.78),(146664,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146664,34.96,0.44,98.1,69904,NULL,NULL,NULL,'ESO 400- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146665,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146665,35,0.2,100,69904,74.4,NULL,NULL,'ESO 400- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146666,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 12928','R',146666,39.08,0.21,574,69905,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ew','SN 2006ew',0.1397,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,305.0090417,-0.97569,0.397,NULL,47802393489,746912398,11670506,NULL),(146667,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 12928','R',146667,39.09,0.15,576,69905,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ew','SN 2006ew',0.1397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146668,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146668,35.43,0.52,122,69906,70,NULL,NULL,'2MASX J20200342-1459382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.01425,-14.99392,0.237,NULL,50836982786,794327856,12411372,14),(146669,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146669,35.21,0.51,110,69907,70,NULL,NULL,'2MASX J20200429-5856111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.017875,-58.93644,0.133,NULL,49044641511,766322523,11973789,14.4),(146670,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146670,37.41,0.8,303,69908,70,NULL,NULL,'2MASX J20201020-6719199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,'SB(r)b',NULL,NULL,NULL,NULL,1,305.042583,-67.32228,0.109,NULL,49366572273,771352691,12052385,14.9),(146671,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146671,35.72,0.58,139,69909,70,NULL,NULL,'2MASX J20201104-1944142',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.046083,-19.73742,0.205,NULL,50858576145,794665252,12416644,13.7),(146672,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146672,37.09,0.66,262,69910,70,NULL,NULL,'2MASX J20201376-5314475',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.057208333,-53.24658,0.185,NULL,51082216714,798159636,12471244,15.5),(146673,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iu',NULL,146673,37.11,0.12,242,69911,74.2,NULL,'SALT 2','2MASX J20201665+0012557',0.09,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,305.069417,0.21544,0.473,NULL,53992805710,843637589,13181837,NULL),(146674,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iu',NULL,146674,37.87,0.05,344,69911,70,NULL,'SDSS-II SN 06773','2MASX J20201665+0012557',0.09,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146675,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06773','R',146675,37.92,0.19,352,69911,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iu','2MASX J20201665+0012557',0.09,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146676,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iu',NULL,146676,37.96,0.09,359,69911,65,NULL,'SALT2','2MASX J20201665+0012557',0.09,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146677,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06773','R',146677,38.11,0.07,384,69911,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iu','2MASX J20201665+0012557',0.09,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146678,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iu',NULL,146678,38.11,0.11,384,69911,65,NULL,'MLCS2k2','2MASX J20201665+0012557',0.09,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146679,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146679,34.96,0.48,98.3,69912,70,NULL,NULL,'ESO 234- G 003',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000073,NULL,'14.99',0.3,'N',NULL,NULL,NULL,NULL,1,305.120666667,-51.62297,0.109,NULL,51081256978,798144640,12471010,14.99),(146680,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146680,37.18,0.54,273,69913,70,NULL,NULL,'2MASX J20203217-2109062',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.22',0.3,NULL,NULL,NULL,NULL,NULL,1,305.134125,-21.15172,0.237,NULL,50865150267,794767972,12418249,16.22),(146681,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146681,36.15,0.53,170,69914,70,NULL,NULL,'2MASX J20203458-1222250',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.1442083,-12.37358,0.241,NULL,47932919991,748951874,11702373,13.6),(146682,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146682,37.2,0.58,276,69915,70,NULL,NULL,'2MASX J20204325-5303506',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.5R',0.12,NULL,NULL,NULL,NULL,NULL,1,305.180375,-53.06414,0.181,NULL,51082394277,798162410,12471287,15.5),(146683,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146683,35.99,0.64,158,69916,70,NULL,NULL,'2MASX J20204437-1909293',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.184875,-19.15814,0.249,NULL,50858945389,794671021,12416734,14.9),(146684,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2000dc',NULL,146684,32.93,0.14,37.8,69917,NULL,NULL,'SEAM','ESO 527- G 019',0.010397,'2009ApJ...694.1067P',2009,1,1.4,NULL,'G',0.000013,NULL,'13.2B',0.9,'SB(r)b:',NULL,NULL,NULL,NULL,1,305.1905,-24.12819,0.273,NULL,50805670122,793838595,12403728,13.2),(146685,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146685,32.97,0.8,39.3,69917,75,NULL,'MAT, I','ESO 527- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146686,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146686,32.95,0.43,38.9,69917,75,NULL,'3.6 micron, color + selection bias corrected','ESO 527- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146687,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146687,33.01,0.43,39.9,69917,75,NULL,'3.6 micron, color corrected','ESO 527- G 019',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146688,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146688,33.11,0.2,41.9,69917,74.4,NULL,NULL,'ESO 527- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146689,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146689,33.16,0.32,42.8,69917,85,NULL,'I, raw','ESO 527- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146690,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146690,33.19,0.32,43.5,69917,85,NULL,'I, inv','ESO 527- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146691,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146691,33.24,0.4,44.4,69917,NULL,NULL,'mean','ESO 527- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146692,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146692,33.29,0.54,45.4,69917,NULL,NULL,'Malmquist cor.','ESO 527- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146693,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146693,33.32,0.53,46.1,69917,NULL,NULL,NULL,'ESO 527- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146694,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146694,33.45,0.43,49,69917,75,NULL,'MAT, I, raw','ESO 527- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146695,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146695,33.64,0.43,53.4,69917,75,NULL,'MAT, I, inv','ESO 527- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146696,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146696,33.76,0.46,56.6,69917,NULL,NULL,'J','ESO 527- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146697,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146697,33.81,0.47,57.9,69917,NULL,NULL,'H','ESO 527- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146698,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146698,33.83,0.45,58.2,69917,NULL,NULL,'K','ESO 527- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146699,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146699,33.83,0.43,58.4,69917,75,NULL,'MAT, I, cor','ESO 527- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146700,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146700,36.61,0.76,210,69918,70,NULL,NULL,'2MASX J20204673-0935414',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.194833,-9.59492,0.185,NULL,48014458027,750225906,11722279,15),(146701,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146701,32.78,0.65,36,69919,95,NULL,'Weighted Mean','NGC 6893',NULL,'1984ApJS...56...91D',1984,1,2.6,'Mislabeled as NGC 6873 in de Vaucouleours, 1957HPh....53..275d.','G',0.000087,NULL,'12.79',1.7,'(L)SA(rs)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.206833,-48.23908,0.089,NULL,51132621026,798947203,12483550,12.79),(146702,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146702,34.42,0.81,76.6,69919,55,NULL,'Visvanathan & Sandage 1979','NGC 6893',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146703,'Tertiary','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146703,32.18,0.71,27.3,69919,95,NULL,NULL,'NGC 6893',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146704,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146704,36.46,0.72,196,69920,70,NULL,NULL,'2MASX J20205096-0045258',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,305.212416667,-0.75711,0.401,NULL,47801836756,746903699,11670370,14.8),(146705,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146705,35.79,0.48,144,69921,70,NULL,NULL,'ESO 186-IG 035 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.0001,NULL,'15.53',0.62,NULL,NULL,NULL,NULL,NULL,1,305.2212083,-52.684,0.125,NULL,51081784730,798152886,12471138,15.53),(146706,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146706,34.4,0.53,76,69922,70,NULL,NULL,'2MASX J20205372-4946486',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5R',0.2,NULL,NULL,NULL,NULL,NULL,1,305.223917,-49.78022,0.109,NULL,51131519274,798929988,12483281,14.5),(146707,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146707,31.96,0.2,24.7,69923,74.4,NULL,NULL,'ESO 596- G 019',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.00015,NULL,'16.19',0.6,'S...',NULL,NULL,NULL,NULL,1,305.2402083,-19.45736,0.241,NULL,50858631842,794666122,12416658,16.19),(146708,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146708,33.8,0.2,57.5,69924,74.4,NULL,NULL,'NGC 6897',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000043,NULL,'14.8b',0.5,'SAB:(rs?)bc: pec: II',NULL,NULL,NULL,NULL,1,305.2552917,-12.25469,0.241,NULL,47932960267,748952504,11702382,14.8),(146709,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146709,33.81,0.69,57.7,69924,100,NULL,'mid-IR','NGC 6897',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146710,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146710,34.01,0.59,63.5,69924,NULL,NULL,NULL,'NGC 6897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146711,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146711,34.07,0.47,65.2,69924,NULL,NULL,'H','NGC 6897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146712,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146712,34.07,0.57,65.3,69924,NULL,NULL,'Malmquist cor.','NGC 6897',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146713,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146713,34.17,0.45,68.2,69924,NULL,NULL,'K','NGC 6897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146714,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146714,34.23,0.46,70.1,69924,NULL,NULL,'J','NGC 6897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146715,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146715,34.29,0.4,72.1,69924,NULL,NULL,'mean','NGC 6897',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146716,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146716,34.29,0.47,72.1,69925,NULL,NULL,'H','2MASX J20210419-1509571',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000027,NULL,'12.7I',0.7,'Sab',NULL,NULL,NULL,NULL,1,305.267583,-15.16581,0.281,NULL,50836471250,794319863,12411247,12.7),(146717,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146717,34.35,0.45,74.1,69925,NULL,NULL,'K','2MASX J20210419-1509571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146718,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146718,34.53,0.46,80.7,69925,NULL,NULL,'J','2MASX J20210419-1509571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146719,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146719,34.6,0.4,83,69925,NULL,NULL,'mean','2MASX J20210419-1509571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146720,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146720,35.62,0.77,133,69926,70,NULL,NULL,'ESO 234- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.29,NULL,'G',0.000127,NULL,'16.28',0.17,'Sbc',NULL,NULL,NULL,NULL,1,305.2819583,-49.28081,0.093,NULL,51131353758,798927402,12483240,16.28),(146721,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146721,36.92,0.78,242,69927,70,NULL,NULL,'2MASX J20211680-5228325',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.8R',0.26,NULL,NULL,NULL,NULL,NULL,1,305.320167,-52.47569,0.125,NULL,51080673817,798135528,12470867,14.8),(146722,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146722,33.63,0.48,53.2,69928,70,NULL,NULL,'ESO 186- G 036',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000087,NULL,'12.55',0.5,'SBa? sp',NULL,NULL,NULL,NULL,1,305.33125,-53.76319,0.185,NULL,51082164004,798158812,12471231,12.55),(146723,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 12947','RN',146723,39.34,0.19,637,69929,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12947',0.1592,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146724,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 12947','RN',146724,39.64,0.11,732,69929,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12947',0.1592,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146725,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146725,34.6,0.8,83.4,69930,75,NULL,'MAT, I','ESO 285- G 001',NULL,'1997ApJS..109..333W',1997,1,1.7,'1996ApJS..107...97M has z = 0.021295 +- 0.000033.','G',0.000087,NULL,'14.87',0.4,'(R)SB0^+',NULL,NULL,NULL,NULL,1,305.3710417,-44.60981,0.089,NULL,51096461582,798382212,12474722,14.87),(146726,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146726,33.93,0.32,61.2,69930,85,NULL,'I, raw','ESO 285- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146727,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146727,33.98,0.32,62.4,69930,85,NULL,'I, inv','ESO 285- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146728,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146728,33.99,0.43,62.9,69930,75,NULL,'MAT, I, raw','ESO 285- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146729,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146729,34.2,0.43,69.1,69930,75,NULL,'MAT, I, inv','ESO 285- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146730,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146730,34.31,0.43,72.7,69930,75,NULL,'MAT, I, cor','ESO 285- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146731,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146731,34.35,0.49,74.2,69930,75,NULL,'IR','ESO 285- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146732,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146732,35.46,0.35,124,69931,NULL,NULL,'Malmquist cor.','ESO 596- G 021',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.40',0.8,'Sb',NULL,NULL,NULL,NULL,1,305.378291667,-20.42522,0.209,NULL,50867984339,794812255,12418941,15.4),(146733,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146733,35.47,0.4,124,69931,NULL,NULL,'mean','ESO 596- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146734,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146734,35.55,0.47,129,69931,NULL,NULL,'H','ESO 596- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146735,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146735,35.58,0.33,130,69931,NULL,NULL,NULL,'ESO 596- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146736,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146736,35.62,0.2,133,69931,74.4,NULL,NULL,'ESO 596- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146737,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146737,35.66,0.45,136,69931,NULL,NULL,'K','ESO 596- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146738,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146738,35.73,0.46,140,69931,NULL,NULL,'J','ESO 596- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146739,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146739,34.01,0.47,63.3,69932,NULL,NULL,'H','MCG -02-52-003',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000023,NULL,'14.5',0.4,'Sd: sp         HII',NULL,NULL,NULL,NULL,1,305.4487917,-10.48969,0.245,NULL,48001368367,750021380,11719084,14.5),(146740,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146740,34.08,0.46,65.4,69932,NULL,NULL,'J','MCG -02-52-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146741,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146741,34.09,0.45,65.9,69932,NULL,NULL,'K','MCG -02-52-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146742,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146742,34.16,0.49,67.8,69932,75,NULL,'IR','MCG -02-52-003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146743,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146743,34.27,0.4,71.3,69932,NULL,NULL,'mean','MCG -02-52-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146744,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146744,34.4,0.43,75.8,69932,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-52-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146745,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146745,36.4,0.62,191,69933,70,NULL,NULL,'2MASX J20214806-5259304',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,305.450167,-52.99178,0.181,NULL,51082338510,798161539,12471274,14.6),(146746,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146746,34.29,0.58,72.2,69934,70,NULL,NULL,'AM 2018-495',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00015,NULL,'12.92',1.1,'SAB0^0^: pec;cD',NULL,NULL,NULL,NULL,1,305.461208333,-49.70228,0.109,NULL,51131539372,798930302,12483285,12.92),(146747,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146747,31.2,0.43,17.4,69935,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11545',NULL,'2014MNRAS.444..527S',2014,1,1.48,NULL,'G',0.000067,NULL,'16.5',0.17,'Sc',NULL,NULL,NULL,NULL,1,305.474083,52.40897,NULL,NULL,54901096318,857829629,13403587,16.5),(146748,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146748,32.61,NULL,33.2,69935,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11545',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146749,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146749,32.62,NULL,33.5,69935,NULL,NULL,'Dipole','UGC 11545',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146750,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146750,32.63,NULL,33.6,69935,NULL,NULL,'Dipole + Quadrupole','UGC 11545',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146751,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146751,33.73,NULL,55.8,69935,NULL,NULL,NULL,'UGC 11545',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146752,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146752,36.3,0.93,182,69936,70,NULL,NULL,'2MASX J20215651-2046257',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.4854583,-20.77392,0.205,NULL,50868268412,794816693,12419010,15.3),(146753,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146753,34.31,0.53,72.6,69937,70,NULL,NULL,'ESO 234- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000087,NULL,'14.55',0.6,'(R)SA(r)0^+','in a pair',NULL,NULL,NULL,1,305.512667,-47.98686,0.085,NULL,51132333571,798942712,12483479,14.55),(146754,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146754,35.94,0.51,154,69938,70,NULL,NULL,'2MASX J20220503-4134490',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.521,-41.58022,0.137,NULL,51375750806,802746106,12542907,13.5),(146755,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146755,34.8,0.45,91,69939,NULL,NULL,'Malmquist cor.','IC 4998',NULL,'2009ApJS..182..474S',2009,1,1.5,'Neither IC identification is certain.','G',0.000033,NULL,'13.99',1.2,'SB(s)c:',NULL,NULL,NULL,NULL,1,305.544083,-38.30833,0.193,NULL,51509489633,804835775,12575558,13.99),(146756,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146756,34.86,0.4,93.9,69939,NULL,NULL,'mean','IC 4998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146757,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146757,34.99,0.47,99.7,69939,NULL,NULL,'H','IC 4998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146758,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146758,35.05,0.46,102,69939,NULL,NULL,'J','IC 4998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146759,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146759,35.06,0.4,103,69939,NULL,NULL,NULL,'IC 4998',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146760,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146760,35.07,0.45,103,69939,NULL,NULL,'K','IC 4998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146761,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146761,35.1,0.2,105,69939,74.4,NULL,NULL,'IC 4998',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146762,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146762,33.41,0.4,48.2,69940,NULL,NULL,'mean','MCG -03-52-002',NULL,'2007A&A...465...71T',2007,1,2.6,'HD 193713 (V=7.6) 48 arcsec north of center.','G',0.000013,NULL,'15',2.2,'SA(rs)cd',NULL,NULL,NULL,NULL,1,305.5472917,-16.79289,0.189,NULL,50851191365,794549865,12414841,15),(146763,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146763,33.45,0.46,49.1,69940,NULL,NULL,'J','MCG -03-52-002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146764,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146764,32.95,0.8,38.9,69941,75,NULL,'MAT, I','ESO 462- G 010',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000031,NULL,'15.06',0.9,'SAB(s)c:',NULL,NULL,NULL,NULL,1,305.562375,-29.85761,0.281,NULL,51338203316,802159426,12533741,15.06),(146765,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146765,33.73,0.32,55.7,69941,85,NULL,'I, raw','ESO 462- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146766,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146766,33.73,0.32,55.8,69941,85,NULL,'I, inv','ESO 462- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146767,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146767,33.89,0.2,60,69941,74.4,NULL,NULL,'ESO 462- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146768,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146768,33.99,0.43,62.9,69941,75,NULL,'MAT, I, raw','ESO 462- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146769,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146769,34.05,0.43,64.6,69941,75,NULL,'MAT, I, inv','ESO 462- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146770,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146770,34.4,0.43,76,69941,75,NULL,'MAT, I, cor','ESO 462- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146771,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146771,37.59,0.9,330,69942,70,NULL,NULL,'2MASX J20221768-1944224',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.17',0.4,NULL,NULL,NULL,NULL,NULL,1,305.573791667,-19.73956,0.205,NULL,50866882180,794795034,12418672,16.17),(146772,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146772,35.86,0.58,149,69943,70,NULL,NULL,'2MASX J20221859-5311034',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.5775417,-53.18436,0.185,NULL,51082371728,798162058,12471282,14.7),(146773,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146773,33.9,0.4,60.3,69944,NULL,NULL,'mean','NGC 6901',NULL,'2007A&A...465...71T',2007,1,1.4,'Called IC 1316 in RC2 by mistake (IC 1316 is non-existent).','G',0.000083,NULL,'14.58',0.6,'SB(r)ab','in a pair',NULL,NULL,NULL,1,305.589625,6.42986,0.473,NULL,53977468721,843397948,13178092,14.58),(146774,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146774,34.24,0.47,70.4,69944,NULL,NULL,'H','NGC 6901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146775,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146775,34.25,0.45,70.9,69944,NULL,NULL,'K','NGC 6901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146776,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146776,34.32,0.43,73.1,69944,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6901',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146777,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146777,34.33,0.46,73.6,69944,NULL,NULL,'J','NGC 6901',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146778,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146778,35.82,0.53,146,69945,70,NULL,NULL,'2MASX J20223243-7604240',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,305.635208333,-76.07331,0.305,NULL,48526123040,758220672,11847198,16.1),(146779,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146779,33.85,0.8,58.8,69946,75,NULL,'MAT, I','ESO 234- G 013',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000031,NULL,'14.62',0.6,'SAB(r)b',NULL,NULL,NULL,NULL,1,305.63525,-50.75289,0.113,NULL,51075088835,798048263,12469504,14.62),(146780,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146780,33.77,NULL,56.8,69946,NULL,NULL,'B','ESO 234- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146781,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146781,33.77,NULL,56.8,69946,NULL,NULL,'I','ESO 234- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146782,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146782,33.78,0.21,57,69946,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 013',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146783,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146783,34.1,0.32,66.2,69946,85,NULL,'I, raw','ESO 234- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146784,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146784,34.13,0.43,67,69946,75,NULL,'MAT, I, raw','ESO 234- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146785,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146785,34.14,0.32,67.4,69946,85,NULL,'I, inv','ESO 234- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146786,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146786,34.31,0.43,72.7,69946,75,NULL,'MAT, I, cor','ESO 234- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146787,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146787,34.32,0.43,73,69946,75,NULL,'MAT, I, inv','ESO 234- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146788,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146788,34.4,0.36,75.8,69946,NULL,NULL,'Malmquist cor.','ESO 234- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146789,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146789,34.54,0.34,80.9,69946,NULL,NULL,NULL,'ESO 234- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146790,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146790,34.58,0.2,82.4,69946,74.4,NULL,NULL,'ESO 234- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146791,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146791,35.64,0.52,134,69947,70,NULL,NULL,'2MASX J20223654-5954295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.652375,-59.90831,0.105,NULL,49149332953,767958327,11999348,14.7),(146792,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146792,35.71,0.63,139,69948,70,NULL,NULL,'2MASX J20224325-5259025',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.2I',0.2,NULL,NULL,NULL,NULL,NULL,1,305.680333,-52.98406,0.181,NULL,51082333294,798161457,12471272,14.2),(146793,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146793,37.24,0.56,281,69949,70,NULL,NULL,'2MASX J20224336-5301185',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.6807083,-53.02189,0.181,NULL,51082332562,798161446,12471272,13.8),(146794,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146794,35.9,0.5,151,69950,70,NULL,NULL,'2MASX J20224661-5136165',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.4,NULL,NULL,NULL,NULL,NULL,1,305.694167,-51.60456,0.109,NULL,51080510547,798132977,12470827,13.8),(146795,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146795,35.76,0.52,142,69951,70,NULL,NULL,'2MASX J20225816-3423521',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00008,NULL,'13.2I',0.5,NULL,NULL,NULL,NULL,NULL,1,305.742417,-34.39786,0.265,NULL,51303943044,801624110,12525376,13.2),(146796,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146796,32.67,0.8,34.2,69952,75,NULL,'HMCL, I','NGC 6902A',NULL,'1997ApJS..109..333W',1997,1,NULL,NULL,'GPair',0.0001,NULL,NULL,NULL,'Ring?',NULL,NULL,NULL,NULL,1,305.749,-44.27153,0.065,NULL,51096146036,798377281,12474645,NULL),(146797,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146797,33.11,0.4,42,69952,75,NULL,'HMCL, I, raw','NGC 6902A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146798,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146798,33.36,0.4,47,69952,75,NULL,'HMCL, I, inv','NGC 6902A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146799,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146799,33.4,0.4,47.8,69952,75,NULL,'HMCL, I, cor','NGC 6902A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146800,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146800,36.87,0.61,236,69953,70,NULL,NULL,'2MASX J20230568-0221295',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,305.77375,-2.35817,0.293,NULL,47814467500,747101054,11673453,14.5),(146801,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146801,32.91,0.8,38.2,69954,75,NULL,'B','NGC 6902B',NULL,'1988NBGC.C....0000T',1988,1,1.5,'Confused HIPASS source','G',0.00002,NULL,'14.09',1.3,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.779375,-43.86861,0.081,NULL,51096088376,798376380,12474630,14.09),(146802,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146802,35.1,NULL,105,69955,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 596- G 026',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000153,'?','17.41',0.11,'Sd',NULL,NULL,NULL,NULL,1,305.785667,-21.19417,0.229,NULL,50868250122,794816408,12419006,17.41),(146803,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146803,35.12,NULL,106,69955,NULL,NULL,'Dipole + Quadrupole','ESO 596- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146804,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146804,35.14,NULL,106,69955,NULL,NULL,'Dipole','ESO 596- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146805,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146805,35.17,NULL,108,69955,NULL,NULL,NULL,'ESO 596- G 026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146806,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146806,33.58,0.4,52,69956,75,NULL,'Edat, raw','ESO 462- G 015',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00009,NULL,'12.95',1.3,'E3','in a pair',NULL,NULL,NULL,1,305.807667,-27.71456,0.289,NULL,51329772593,802027696,12531682,12.95),(146807,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146807,33.91,0.4,60.6,69956,75,NULL,'Edat, cor','ESO 462- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146808,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146808,34.36,0.45,74.4,69956,NULL,NULL,'K','ESO 462- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146809,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146809,34.43,0.4,77,69956,NULL,NULL,'mean','ESO 462- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146810,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146810,36.35,0.58,186,69957,70,NULL,NULL,'2MASX J20231411-4447232',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.7R',0.38,NULL,NULL,NULL,NULL,NULL,1,305.808667,-44.78972,0,NULL,51097101477,798392210,12474878,14.7),(146811,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 16578','R',146811,39.34,0.21,629,69958,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006po','SN 2006po',0.1747,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,305.8132083,-0.8485,0.461,NULL,47801035827,746891184,11670174,NULL),(146812,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 16578','R',146812,39.47,0.15,666,69958,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006po','SN 2006po',0.1747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146813,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146813,36.33,0.58,185,69959,70,NULL,NULL,'2MASX J20232024-8220458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,305.8347917,-82.34614,0.465,NULL,48361170722,755643292,11806926,17),(146814,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146814,35,0.48,100,69960,70,NULL,NULL,'ESO 596- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'15.08',0.6,'S0',NULL,NULL,NULL,NULL,1,305.838083,-18.32256,0.161,NULL,50840232165,794378627,12412166,15.08),(146815,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146815,34.6,0.57,83.3,69961,70,NULL,NULL,'ESO 234- G 015',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00012,NULL,'14.76',0.6,'(R\')SB(rs)a',NULL,NULL,NULL,NULL,1,305.844083,-52.08311,0.085,NULL,51081216729,798144011,12471000,14.76),(146816,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146816,34.85,0.57,93.5,69962,70,NULL,NULL,'ESO 285- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000097,NULL,'15.34',0.2,'S0-a',NULL,NULL,NULL,NULL,1,305.860541667,-46.77122,0,NULL,51098443516,798413179,12475205,15.34),(146817,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146817,36.49,0.53,199,69963,70,NULL,NULL,'2MASX J20232712-5231543',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.5I',0.7,NULL,NULL,NULL,NULL,NULL,1,305.863125,-52.53183,0.089,NULL,51081044240,798141316,12470958,13.5),(146818,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146818,33.67,0.8,54.1,69964,75,NULL,'MAT, I','IC 4992',NULL,'1997ApJS..109..333W',1997,1,2.69,'Confused HIPASS source','G',0.000028,NULL,'14.45',0.25,'SB(s)c? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.8660417,-71.56492,0.193,NULL,49223149342,769111708,12017370,14.45),(146819,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146819,32.95,0.32,38.9,69964,85,NULL,'I, raw','IC 4992',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146820,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146820,32.96,0.32,39,69964,85,NULL,'I, inv','IC 4992',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146821,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146821,33.02,0.43,40.1,69964,75,NULL,'MAT, I, raw','IC 4992',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146822,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146822,33.06,0.49,40.9,69964,75,NULL,'IR','IC 4992',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146823,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146823,33.1,0.43,41.7,69964,75,NULL,'MAT, I, inv','IC 4992',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146824,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146824,33.23,NULL,44.4,69964,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 4992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146825,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146825,33.26,NULL,44.8,69964,NULL,NULL,'Dipole + Quadrupole','IC 4992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146826,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146826,33.27,NULL,45,69964,NULL,NULL,'Dipole','IC 4992',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146827,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146827,33.27,0.43,45.1,69964,75,NULL,'MAT, I, cor','IC 4992',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146828,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146828,33.31,NULL,46,69964,NULL,NULL,NULL,'IC 4992',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146829,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146829,33.82,0.15,58.2,69964,NULL,NULL,NULL,'IC 4992',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146830,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146830,36.72,0.62,221,69965,70,NULL,NULL,'2MASX J20232854-5244533',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.8I',0.5,NULL,NULL,NULL,NULL,NULL,1,305.869,-52.74811,0.089,NULL,51081509431,798148584,12471071,13.8),(146831,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146831,37.24,0.79,281,69966,70,NULL,NULL,'2MASX J20233152-8437039',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,305.881208333,-84.61783,0.405,NULL,48383892140,755998314,11812473,17.2),(146832,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2002cd',NULL,146832,32.67,0.29,33.8,69967,74.2,NULL,'SALT 2','NGC 6916',0.010344,'2010ApJ...716..712A',2010,1,1.8,NULL,'G',0.000023,NULL,'14.3',1.1,'SBbc',NULL,NULL,NULL,NULL,1,305.887833,58.34406,1.741,NULL,53008224718,828253511,12941461,14.3),(146833,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2002cd',NULL,146833,33.21,0.09,43.9,69967,74.4,NULL,NULL,'NGC 6916',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146834,'Sosies','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146834,33.42,0.3,48.3,69967,NULL,NULL,NULL,'NGC 6916',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146835,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146835,33.14,0.4,42.5,69967,75,NULL,'HOSTS SN 2002cd','NGC 6916',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146836,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146836,33.17,0.46,43,69967,NULL,NULL,'J','NGC 6916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146837,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146837,33.19,0.47,43.5,69967,NULL,NULL,'H','NGC 6916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146838,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146838,33.21,0.09,43.9,69967,74.4,NULL,NULL,'NGC 6916',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146839,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146839,33.21,0.4,43.9,69967,NULL,NULL,'mean','NGC 6916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146840,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146840,33.23,0.45,44.3,69967,NULL,NULL,'K','NGC 6916',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146841,'Sosies','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146841,34.09,0.63,65.8,69968,NULL,NULL,NULL,'NGC 6906',NULL,'2002A&A...393...57T',2002,1,1.7,NULL,'G',0.000027,NULL,'13.16',0.8,'SB(rs)bc:','in a pair',NULL,NULL,NULL,1,305.8912917,6.44367,0.473,NULL,53976968310,843390129,13177970,13.16),(146842,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146842,33.68,0.46,54.6,69968,NULL,NULL,'J','NGC 6906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146843,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146843,33.71,0.47,55.2,69968,NULL,NULL,'H','NGC 6906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146844,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146844,33.75,0.45,56.3,69968,NULL,NULL,'K','NGC 6906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146845,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146845,33.95,0.4,61.6,69968,NULL,NULL,'mean','NGC 6906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146846,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146846,34.13,0.43,66.9,69968,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6906',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146847,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146847,32.93,0.8,38.5,69969,75,NULL,'MAT, I','ESO 462- G 016',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'13.59',1.2,'SA(s)cd        HII','in a pair',NULL,NULL,NULL,1,305.912333,-28.27783,0.321,NULL,51328541302,802008457,12531382,13.59),(146848,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146848,32.42,0.69,30.5,69969,100,NULL,'mid-IR','ESO 462- G 016',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146849,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146849,32.46,0.32,31.1,69969,85,NULL,'I, raw','ESO 462- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146850,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146850,32.48,0.32,31.3,69969,85,NULL,'I, inv','ESO 462- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146851,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146851,32.73,0.43,35.2,69969,75,NULL,'MAT, I, raw','ESO 462- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146852,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146852,32.85,0.43,37.1,69969,75,NULL,'MAT, I, inv','ESO 462- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146853,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146853,32.9,0.43,38,69969,75,NULL,'MAT, I, cor','ESO 462- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146854,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146854,33,0.2,39.8,69969,74.4,NULL,NULL,'ESO 462- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146855,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146855,33.15,0.52,42.6,69969,NULL,NULL,'Malmquist cor.','ESO 462- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146856,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146856,33.21,0.51,43.8,69969,NULL,NULL,NULL,'ESO 462- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146857,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146857,33.26,0.4,45,69969,NULL,NULL,'mean','ESO 462- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146858,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146858,33.62,0.47,52.9,69969,NULL,NULL,'H','ESO 462- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146859,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146859,36.02,0.8,160,69970,70,NULL,NULL,'2MASX J20233973-4441142',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,305.915541667,-44.68731,0.037,NULL,51097055352,798391489,12474867,13.9),(146860,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146860,36.4,0.73,191,69971,70,NULL,NULL,'ESO 234- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.69',0.7,'SB(rs+)a pec',NULL,NULL,NULL,NULL,1,305.9289583,-48.44097,0.093,NULL,51132726262,798948847,12483575,15.69),(146861,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146861,33.43,0.5,48.5,69972,70,NULL,NULL,'NGC 6903',NULL,'2014MNRAS.445.2677S',2014,1,2.7,NULL,'G',0.000073,NULL,'12.90',2.5,'SAB0- pec:',NULL,NULL,NULL,NULL,1,305.936917,-19.32542,0.213,NULL,50866503805,794789121,12418580,12.9),(146862,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146862,33.21,0.4,43.9,69972,NULL,NULL,'mean','NGC 6903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146863,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146863,33.24,0.45,44.5,69972,NULL,NULL,'K','NGC 6903',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146864,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146864,33.56,0.2,51.5,69973,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 019',NULL,'2005Ap&SS.298..577R',2005,1,1.99,'Confused HIPASS source','G',0.000033,NULL,'15.19',0.24,'Scd',NULL,NULL,NULL,NULL,1,305.9625417,-48.35881,0.093,NULL,51132542549,798945977,12483530,15.19),(146865,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146865,34.24,0.49,70.5,69973,75,NULL,'IR','ESO 234- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146866,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146866,34.25,0.35,70.8,69973,NULL,NULL,NULL,'ESO 234- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146867,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146867,34.26,NULL,71.3,69973,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 234- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146868,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146868,34.29,NULL,72.1,69973,NULL,NULL,'Dipole + Quadrupole','ESO 234- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146869,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146869,34.29,0.2,72.1,69973,74.4,NULL,NULL,'ESO 234- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146870,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146870,34.3,NULL,72.3,69973,NULL,NULL,'Dipole','ESO 234- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146871,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146871,34.33,NULL,73.4,69973,NULL,NULL,NULL,'ESO 234- G 019',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146872,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146872,34.33,0.34,73.4,69973,NULL,NULL,'Malmquist cor.','ESO 234- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146873,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146873,35.83,0.58,147,69974,70,NULL,NULL,'2MASX J20235268-5939138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,305.969583,-59.65378,0.105,NULL,49027813336,766059583,11969680,15.3),(146874,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146874,32.99,0.8,39.6,69975,75,NULL,'MAT, I','IC 4999',NULL,'1997ApJS..109..333W',1997,1,1.8,'Confused HIPASS source','G',0.00002,NULL,'13.5b',1,'SAB(rs)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.98475,-26.01494,0.233,NULL,51326555150,801977424,12530897,13.5),(146875,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146875,31.96,0.32,24.7,69975,85,NULL,'I, raw','IC 4999',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146876,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146876,31.96,0.32,24.7,69975,85,NULL,'I, inv','IC 4999',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146877,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146877,32.33,0.43,29.2,69975,75,NULL,'MAT, I, raw','IC 4999',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146878,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146878,32.39,0.43,30,69975,75,NULL,'MAT, I, inv','IC 4999',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146879,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146879,32.62,0.2,33.4,69975,74.4,NULL,NULL,'IC 4999',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146880,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146880,32.63,0.43,33.6,69975,75,NULL,'MAT, I, cor','IC 4999',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146881,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146881,32.88,0.55,37.7,69975,NULL,NULL,NULL,'IC 4999',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146882,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146882,32.89,0.55,37.9,69975,NULL,NULL,'Malmquist cor.','IC 4999',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146883,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146883,33.46,0.4,49.2,69975,NULL,NULL,'mean','IC 4999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146884,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146884,33.49,0.47,49.9,69975,NULL,NULL,'H','IC 4999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146885,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146885,33.64,0.46,53.5,69975,NULL,NULL,'J','IC 4999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146886,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146886,33.71,0.45,55.2,69975,NULL,NULL,'K','IC 4999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146887,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146887,35.71,0.5,139,69976,70,NULL,NULL,'2MASX J20235734-0916531',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000093,NULL,'13.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,305.988875,-9.28136,0.221,NULL,47817318303,747145598,11674149,13),(146888,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146888,32.89,0.8,37.9,69977,75,NULL,'B','IC 4946',NULL,'1988NBGC.C....0000T',1988,1,2.5,'The IC ID is not certain; ESO 284- ? 015 is for its nominal position.','G',0.00006,NULL,'12.61',1,'SB(rl)0^0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,305.9919583,-43.99528,0.081,NULL,51096104244,798376628,12474634,12.61),(146889,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146889,31.87,0.4,23.7,69978,75,NULL,'B','UGC 11557',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000013,NULL,'13.7',1.7,'SAB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.002917,60.19472,1.149,NULL,53457076673,835266823,13051044,13.7),(146890,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146890,35.33,0.62,116,69979,70,NULL,NULL,'2MASX J20241155-5022394',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'14.0R',0.4,NULL,NULL,NULL,NULL,NULL,1,306.048167,-50.37756,0.065,NULL,51075305255,798051644,12469556,14),(146891,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146891,37.44,0.79,308,69980,70,NULL,NULL,'2MASX J20241439-5237374',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.7b',0.11,NULL,NULL,NULL,NULL,NULL,1,306.060125,-52.62703,0.089,NULL,51081480123,798148126,12471064,16.7),(146892,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146892,36.43,0.89,194,69981,70,NULL,NULL,'2MASX J20241669-2107270',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.30',0.4,'SB(rl)0/a:',NULL,NULL,NULL,NULL,1,306.069666667,-21.12433,0.205,NULL,50868110047,794814219,12418972,16.3),(146893,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146893,34.36,0.8,74.4,69982,75,NULL,'MAT, I','NGC 6899',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.41',1,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,306.092666667,-50.43394,0.065,NULL,51075316316,798051817,12469559,13.41),(146894,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146894,33.67,0.32,54.1,69982,85,NULL,'I, raw','NGC 6899',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146895,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146895,33.72,0.32,55.5,69982,85,NULL,'I, inv','NGC 6899',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146896,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146896,33.73,0.43,55.8,69982,75,NULL,'MAT, I, raw','NGC 6899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146897,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146897,33.74,NULL,56,69982,75,NULL,'B','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146898,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146898,33.74,NULL,56,69982,75,NULL,'I','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146899,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146899,33.74,NULL,56,69982,NULL,NULL,'B','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146900,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146900,33.76,0.15,56.5,69982,NULL,NULL,'B, Hubble-type-TF','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146901,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146901,33.88,NULL,59.7,69982,NULL,NULL,'I','NGC 6899',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146902,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146902,33.89,0.47,60.1,69982,NULL,NULL,'H','NGC 6899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146903,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146903,33.94,0.46,61.5,69982,NULL,NULL,'J','NGC 6899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146904,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146904,33.97,0.45,62.1,69982,NULL,NULL,'K','NGC 6899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146905,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146905,33.99,0.43,62.9,69982,75,NULL,'MAT, I, inv','NGC 6899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146906,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146906,34.04,0.43,64.4,69982,75,NULL,'MAT, I, cor','NGC 6899',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146907,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146907,34.45,0.4,77.5,69982,NULL,NULL,'mean','NGC 6899',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146908,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146908,35.56,0.54,130,69983,70,NULL,NULL,'2MASX J20242552-0704197',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,306.106333,-7.07208,0.193,NULL,47827635091,747306798,11676668,13.6),(146909,'Ring Diameter','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146909,32.8,0.84,36,69984,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6902',NULL,'1981ApJS...45..541P',1981,1,5.6,'The IC identification is not certain.','G',0.000013,NULL,'11.64',3.9,'SA(r)b         LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.11725,-43.65353,0.085,NULL,51378140584,802783446,12543491,11.64),(146910,'Sosies','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146910,32.41,0.29,30.3,69984,NULL,NULL,NULL,'NGC 6902',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146911,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146911,32.76,0.4,35.7,69984,75,NULL,'B','NGC 6902',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146912,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146912,32.83,0.4,36.9,69984,NULL,NULL,'mean','NGC 6902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146913,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146913,32.97,0.46,39.2,69984,NULL,NULL,'J','NGC 6902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146914,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146914,33.03,0.45,40.3,69984,NULL,NULL,'K','NGC 6902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146915,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146915,33.04,0.47,40.5,69984,NULL,NULL,'H','NGC 6902',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146916,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146916,33.34,0.4,46.6,69984,NULL,NULL,NULL,'NGC 6902',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146917,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146917,35.1,0.56,105,69985,70,NULL,NULL,'2MASX J20243049-2101080',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.95',NULL,NULL,NULL,NULL,NULL,NULL,1,306.12725,-21.019,0.205,NULL,50868087080,794813860,12418966,15.95),(146918,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146918,35.98,0.56,157,69986,70,NULL,NULL,'ESO 462- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.67',0.2,'S       poss. LINER?',NULL,NULL,NULL,NULL,1,306.148417,-30.46503,0.281,NULL,51337239655,802144369,12533505,15.67),(146919,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146919,33.87,0.4,59.5,69987,NULL,NULL,'mean','UGC 11552',NULL,'2007A&A...465...71T',2007,1,1.9,'The HIPASS beam probably includes the galaxy UGC 11550.','G',0.000024,NULL,'14.7',0.6,'Sab',NULL,NULL,NULL,NULL,1,306.149208333,12.44375,0.597,NULL,55180319763,862192496,13471757,14.7),(146920,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146920,34.07,0.45,65.3,69987,NULL,NULL,'K','UGC 11552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146921,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146921,34.14,0.47,67.2,69987,NULL,NULL,'H','UGC 11552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146922,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146922,34.25,0.46,70.8,69987,NULL,NULL,'J','UGC 11552',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146923,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146923,34.26,0.31,71.2,69987,NULL,NULL,'Malmquist cor.','UGC 11552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146924,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146924,34.35,0.43,74,69987,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11552',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146925,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146925,34.47,0.43,78.3,69987,75,NULL,'3.6 micron, color corrected','UGC 11552',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146926,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146926,34.54,0.27,81.1,69987,NULL,NULL,NULL,'UGC 11552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146927,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146927,34.59,0.2,82.8,69987,74.4,NULL,NULL,'UGC 11552',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146928,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146928,33.63,0.47,53.2,69988,NULL,NULL,'H','UGC 11551',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00006,NULL,'14.83',0.4,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.15175,6.91119,0.449,NULL,53980447033,843444484,13178820,14.83),(146929,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146929,33.64,0.45,53.5,69988,NULL,NULL,'K','UGC 11551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146930,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146930,33.7,0.43,55,69988,75,NULL,'3.6 micron, color corrected','UGC 11551',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146931,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146931,33.71,0.46,55.2,69988,NULL,NULL,'J','UGC 11551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146932,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146932,33.71,0.43,55.3,69988,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11551',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146933,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146933,33.73,0.49,55.6,69988,75,NULL,'IR','UGC 11551',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146934,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146934,33.78,0.2,57,69988,74.4,NULL,NULL,'UGC 11551',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146935,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146935,33.94,0.33,61.5,69988,NULL,NULL,NULL,'UGC 11551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146936,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146936,33.96,0.4,61.8,69988,NULL,NULL,'mean','UGC 11551',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146937,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146937,34.09,0.31,65.7,69988,NULL,NULL,'Malmquist cor.','UGC 11551',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146938,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146938,34.15,0.8,67.6,69989,75,NULL,'MAT, I','ESO 340- G 026',NULL,'1997ApJS..109..333W',1997,1,3.02,NULL,'G',0.000033,NULL,'14.80',0.31,'Sc',NULL,NULL,NULL,NULL,1,306.181667,-41.51208,0.125,NULL,51375888719,802748261,12542941,14.8),(146939,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146939,33.73,0.49,55.7,69989,75,NULL,'IR','ESO 340- G 026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146940,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146940,33.8,NULL,57.5,69989,NULL,NULL,NULL,'ESO 340- G 026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146941,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146941,33.81,NULL,57.7,69989,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 340- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146942,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146942,33.82,NULL,58.2,69989,NULL,NULL,'Dipole + Quadrupole','ESO 340- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146943,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146943,33.84,NULL,58.5,69989,NULL,NULL,'Dipole','ESO 340- G 026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146944,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146944,34.13,0.43,66.9,69989,75,NULL,'MAT, I, raw','ESO 340- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146945,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146945,34.2,0.41,69.3,69989,NULL,NULL,NULL,'ESO 340- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146946,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146946,34.25,0.2,70.8,69989,74.4,NULL,NULL,'ESO 340- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146947,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146947,34.26,0.32,71.2,69989,85,NULL,'I, raw','ESO 340- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146948,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146948,34.31,0.32,72.9,69989,85,NULL,'I, inv','ESO 340- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146949,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146949,34.35,0.43,74.1,69989,75,NULL,'MAT, I, inv','ESO 340- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146950,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146950,34.36,0.38,74.4,69989,NULL,NULL,'Malmquist cor.','ESO 340- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146951,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146951,34.38,0.4,75.3,69989,NULL,NULL,'mean','ESO 340- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146952,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146952,34.43,0.43,76.9,69989,75,NULL,'MAT, I, cor','ESO 340- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146953,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146953,34.57,0.47,82.1,69989,NULL,NULL,'H','ESO 340- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146954,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146954,34.61,0.45,83.5,69989,NULL,NULL,'K','ESO 340- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146955,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146955,34.63,0.46,84.5,69989,NULL,NULL,'J','ESO 340- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146956,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146956,32.71,0.2,34.8,69990,74.4,NULL,NULL,'ESO 596- G 032',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',NULL,NULL,'15.90',0.8,'S...',NULL,NULL,NULL,NULL,1,306.220125,-18.34522,0.153,NULL,50845488838,794460763,12413449,15.9),(146957,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146957,32.75,0.43,35.4,69990,NULL,NULL,NULL,'ESO 596- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146958,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146958,33,0.38,39.8,69990,NULL,NULL,'Malmquist cor.','ESO 596- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146959,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146959,36.29,0.58,181,69991,70,NULL,NULL,'2MASX J20245981-6234185',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'14.6R',0.31,NULL,NULL,NULL,NULL,NULL,1,306.249333,-62.57178,0.197,NULL,49156260844,768066575,12001040,14.6),(146960,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146960,32.68,0.8,34.3,69992,75,NULL,'MAT, I','ESO 026- G 001',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'14.55',1.4,'(R\'_2)SAB(rs)cd',NULL,NULL,NULL,NULL,1,306.258833,-81.57528,0.369,NULL,48541485220,758460706,11850948,14.55),(146961,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146961,30.32,0.32,11.6,69992,85,NULL,'I, inv','ESO 026- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146962,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146962,30.38,0.32,11.9,69992,85,NULL,'I, raw','ESO 026- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146963,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146963,30.55,0.4,12.9,69992,NULL,NULL,NULL,'ESO 026- G 001',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146964,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146964,30.88,0.43,15,69992,75,NULL,'MAT, I, inv','ESO 026- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146965,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146965,30.99,0.43,15.8,69992,75,NULL,'MAT, I, raw','ESO 026- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146966,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146966,31.25,0.43,17.8,69992,75,NULL,'MAT, I, cor','ESO 026- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146967,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146967,33.01,0.8,40,69993,75,NULL,'MAT, I','NGC 6907',NULL,'1997ApJS..109..333W',1997,1,3.3,NULL,'G',0.000013,NULL,'11.4B',2.7,'SB(s)bc        LIRG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.277625,-24.80917,0.309,NULL,50826816139,794169002,12408890,11.4),(146968,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146968,32.53,0.32,32.1,69993,85,NULL,'I, raw','NGC 6907',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146969,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146969,32.6,0.45,33.1,69993,NULL,NULL,'K','NGC 6907',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146970,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146970,32.61,0.32,33.2,69993,85,NULL,'I, inv','NGC 6907',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146971,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146971,32.63,0.47,33.6,69993,NULL,NULL,'H','NGC 6907',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146972,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146972,32.63,0.46,33.6,69993,NULL,NULL,'J','NGC 6907',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146973,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146973,32.66,0.68,34,69993,NULL,NULL,'Malmquist cor.','NGC 6907',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146974,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146974,32.73,0.43,35.2,69993,75,NULL,'MAT, I, raw','NGC 6907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146975,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146975,32.76,0.65,35.6,69993,NULL,NULL,NULL,'NGC 6907',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146976,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146976,32.8,0.2,36.3,69993,74.4,NULL,NULL,'NGC 6907',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146977,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146977,32.94,0.43,38.7,69993,75,NULL,'MAT, I, cor','NGC 6907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146978,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146978,33.08,0.43,41.4,69993,75,NULL,'MAT, I, inv','NGC 6907',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146979,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146979,33.26,0.4,45,69993,NULL,NULL,'mean','NGC 6907',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146980,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146980,36.32,0.6,184,69994,70,NULL,NULL,'2MASX J20250744-6520045',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'15.2R',0.25,NULL,NULL,NULL,NULL,NULL,1,306.280875,-65.33453,0.129,NULL,49375001803,771484403,12054443,15.2),(146981,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146981,33.95,0.8,61.7,69995,75,NULL,'CF, r','UGC 11555',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00002,NULL,'13.90',1.2,'SA(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.300083333,5.26308,0.381,NULL,54009791587,843902993,13185984,13.9),(146982,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146982,32.81,0.38,36.4,69995,75,NULL,'CF, r, raw','UGC 11555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146983,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146983,32.83,0.38,36.8,69995,75,NULL,'CF, r, inv','UGC 11555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146984,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146984,33.28,0.38,45.3,69995,75,NULL,'CF, r, cor','UGC 11555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146985,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146985,33.47,0.69,49.5,69995,100,NULL,'mid-IR','UGC 11555',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146986,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146986,33.93,0.47,61.2,69995,NULL,NULL,'H','UGC 11555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146987,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146987,33.94,0.4,61.5,69995,NULL,NULL,'mean','UGC 11555',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146988,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146988,37.18,0.69,272,69996,70,NULL,NULL,'2MASX J20251288-2052013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.23',NULL,NULL,NULL,NULL,NULL,NULL,1,306.3035,-20.86717,0.201,NULL,50868327898,794817623,12419025,16.23),(146989,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146989,33.23,0.4,44.2,69997,NULL,NULL,'mean','IC 5005',NULL,'2007A&A...465...71T',2007,1,1.9,'Confused HIPASS source','G',0.000019,NULL,'13.56',1.6,'SB(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,306.334208333,-25.82928,0.237,NULL,51309852635,801716447,12526819,13.56),(146990,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146990,33.48,0.47,49.6,69997,NULL,NULL,'H','IC 5005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146991,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146991,33.58,0.46,52.1,69997,NULL,NULL,'J','IC 5005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146992,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146992,33.6,0.45,52.5,69997,NULL,NULL,'K','IC 5005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146993,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146993,36.32,0.52,184,69998,70,NULL,NULL,'2MASX J20252383-5321106',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.2I',0.6,NULL,NULL,NULL,NULL,NULL,1,306.349333,-53.35294,0.169,NULL,51079619041,798119047,12470610,13.2),(146994,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146994,33.38,0.8,47.4,69999,NULL,NULL,NULL,'ESO 340- G 028',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.04',0.5,'S...',NULL,NULL,NULL,NULL,1,306.351208333,-40.1615,0.121,NULL,51375249668,802738276,12542785,15.04),(146995,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146995,33.42,0.2,48.3,69999,74.4,NULL,NULL,'ESO 340- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146996,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146996,33.44,0.78,48.8,69999,NULL,NULL,'Malmquist cor.','ESO 340- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146997,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,146997,34.4,0.8,76,70000,75,NULL,'MAT, I','ESO 234- G 024',NULL,'1997ApJS..109..333W',1997,1,1.8,'Confused HIPASS source','G',0.000033,NULL,'14.84',0.4,'SAB(s:)b',NULL,NULL,NULL,NULL,1,306.365917,-51.53214,0.085,NULL,51082502126,798164095,12471313,14.84),(146998,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146998,33.85,0.21,58.9,70000,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 024',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(146999,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',146999,33.86,NULL,59.2,70000,NULL,NULL,'B','ESO 234- G 024',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147000,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147000,33.86,NULL,59.2,70000,NULL,NULL,'I','ESO 234- G 024',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147001,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147001,34.37,0.49,74.9,70000,75,NULL,'IR','ESO 234- G 024',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147002,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147002,34.44,0.43,77.1,70000,75,NULL,'MAT, I, raw','ESO 234- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147003,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147003,34.48,0.32,78.7,70000,85,NULL,'I, raw','ESO 234- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147004,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147004,34.53,0.32,80.4,70000,85,NULL,'I, inv','ESO 234- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147005,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147005,34.55,0.43,81.3,70000,75,NULL,'MAT, I, cor','ESO 234- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147006,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147006,34.65,0.43,85.3,70000,75,NULL,'MAT, I, inv','ESO 234- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147007,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147007,35.05,0.67,102,70001,70,NULL,NULL,'MCG -03-52-005',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000127,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,306.372833,-15.85372,0.277,NULL,50850844033,794544438,12414756,15),(147008,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147008,34.89,0.47,95.1,70002,NULL,NULL,'H','CGCG 424-005',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00006,NULL,'14.9',0.8,'Sbc',NULL,NULL,NULL,NULL,1,306.375875,10.57247,0.501,NULL,53976128720,843377011,13177765,14.9),(147009,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147009,35.04,0.45,102,70002,NULL,NULL,'K','CGCG 424-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147010,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147010,35.06,0.46,103,70002,NULL,NULL,'J','CGCG 424-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147011,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147011,35.07,0.4,103,70002,NULL,NULL,'mean','CGCG 424-005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147012,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147012,36.32,0.59,184,70003,70,NULL,NULL,'2MASX J20254004-6320518',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.8R',0.19,NULL,NULL,NULL,NULL,NULL,1,306.417,-63.34769,0.189,NULL,49155252609,768050822,12000794,15.8),(147013,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147013,34.59,0.51,82.9,70004,70,NULL,NULL,'ESO 596- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000097,NULL,'15.25',0.9,'(RL)SA0^+',NULL,NULL,NULL,NULL,1,306.42325,-17.44253,0.173,NULL,50847988857,794499825,12414059,15.25),(147014,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147014,33.1,0.47,41.7,70005,NULL,NULL,'H','ESO 400- G 020',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000013,NULL,'16.9b',0.7,'SA(s)b:',NULL,NULL,NULL,NULL,1,306.4495417,-34.1935,0.209,NULL,51295534818,801492731,12523323,16.9),(147015,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147015,33.18,0.46,43.2,70005,NULL,NULL,'J','ESO 400- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147016,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147016,33.34,0.45,46.6,70005,NULL,NULL,'K','ESO 400- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147017,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147017,33.43,0.4,48.6,70005,NULL,NULL,'mean','ESO 400- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147018,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147018,35.14,0.49,107,70006,NULL,NULL,NULL,'ESO 596- G 036',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00002,NULL,'15',1,'Sc',NULL,NULL,NULL,NULL,1,306.459333,-18.52378,0.145,NULL,50845469852,794460466,12413444,15),(147019,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147019,35.18,0.2,109,70006,74.4,NULL,NULL,'ESO 596- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147020,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147020,35.31,0.46,115,70006,NULL,NULL,'Malmquist cor.','ESO 596- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147021,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147021,35.22,0.55,110,70007,70,NULL,NULL,'2MASX J20255179-2208426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.15',NULL,NULL,NULL,NULL,NULL,NULL,1,306.4657917,-22.14536,0.229,NULL,50861649173,794713268,12417394,16.15),(147022,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147022,35.39,0.55,120,70008,70,NULL,NULL,'2MASX J20255359-0809173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,306.47325,-8.15492,0.177,NULL,47829458702,747335292,11677113,14.9),(147023,'GRB','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147023,46.11,0.98,5650,70009,69.7,NULL,'Fiducial','GRB 050315',1.95,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,306.475417,-42.60061,0.113,NULL,51373866272,802716660,12542447,NULL),(147024,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147024,37.37,0.57,298,70010,70,NULL,NULL,'2MASX J20260121-2200336',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,306.505083,-22.00939,0.193,NULL,50861698749,794714042,12417406,15.6),(147025,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147025,34.43,0.58,76.9,70011,NULL,NULL,'Malmquist cor.','ESO 186- G 041',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.71',0.5,'S...',NULL,NULL,NULL,NULL,1,306.5095417,-54.38325,0.169,NULL,51079926405,798123850,12470685,15.71),(147026,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147026,34.59,0.54,82.8,70011,NULL,NULL,NULL,'ESO 186- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147027,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147027,34.63,0.2,84.3,70011,74.4,NULL,NULL,'ESO 186- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147028,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06197',NULL,147028,39.96,0.26,982,70012,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.039','SDSS-II SN 06197',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,306.5540417,0.84492,0.469,NULL,54004733087,843823954,13184749,NULL),(147029,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147029,34.65,0.49,85.2,70013,70,NULL,NULL,'ESO 186- G 043',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000093,NULL,'14.62',0.8,'(R)SB(r)ab',NULL,NULL,NULL,NULL,1,306.573167,-52.40475,0.089,NULL,51080877217,798138706,12470917,14.62),(147030,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147030,34.71,0.52,87.5,70014,70,NULL,NULL,'ESO 234- G 026',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.20',0.3,'N',NULL,NULL,NULL,NULL,1,306.583,-48.04386,0.093,NULL,51129366206,798896346,12482755,15.2),(147031,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147031,34.74,0.69,88.7,70015,100,NULL,'mid-IR','CGCG 424-006',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',NULL,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,306.6095,15.01786,0.477,NULL,55181808295,862215754,13472121,15.7),(147032,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147032,34.24,0.8,70.4,70016,75,NULL,'MAT, I','ESO 400- G 021',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00002,NULL,'15.10',0.4,'S?',NULL,NULL,NULL,NULL,1,306.639625,-32.46306,0.317,NULL,51324010792,801937668,12530276,15.1),(147033,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147033,34.01,0.32,63.5,70016,85,NULL,'I, raw','ESO 400- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147034,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147034,34.03,0.32,63.9,70016,85,NULL,'I, inv','ESO 400- G 021',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147035,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147035,34.26,0.43,71.1,70016,75,NULL,'MAT, I, raw','ESO 400- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147036,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147036,34.33,0.2,73.5,70016,74.4,NULL,NULL,'ESO 400- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147037,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147037,34.36,0.43,74.6,70016,75,NULL,'MAT, I, inv','ESO 400- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147038,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147038,34.44,0.29,77.1,70016,NULL,NULL,NULL,'ESO 400- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147039,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147039,34.52,0.43,80.1,70016,75,NULL,'MAT, I, cor','ESO 400- G 021',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147040,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147040,34.58,0.28,82.2,70016,NULL,NULL,'Malmquist cor.','ESO 400- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147041,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147041,33.85,0.47,59,70017,70,NULL,NULL,'IC 5002',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00009,NULL,'14.19',0.8,'S0^0^','Pair member (points to parent)',NULL,NULL,NULL,1,306.6662083,-54.79969,0.173,NULL,48996774853,765574607,11962103,14.19),(147042,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147042,36.29,0.5,181,70018,70,NULL,NULL,'2MASX J20264693-7406223',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,306.695583333,-74.10628,0.197,NULL,48490213601,757659587,11838431,16.3),(147043,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147043,35.72,0.82,140,70019,70,NULL,NULL,'2MASX J20265263-0149236',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,306.719333,-1.82314,0.469,NULL,47811162530,747049414,11672647,15.4),(147044,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147044,36.01,0.62,159,70020,70,NULL,NULL,'2MASX J20265625-5254100',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'15.3R',0.2,NULL,NULL,NULL,NULL,NULL,1,306.734417,-52.90275,0.157,NULL,51081417697,798147151,12471049,15.3),(147045,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05339','RN',147045,38.41,0.15,423,70021,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 05339',0.138,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147046,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05339','RN',147046,38.67,0.27,476,70021,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 05339',0.138,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147047,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147047,36.76,0.76,225,70022,70,NULL,NULL,'2MASX J20271961-5142190',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5R',0.17,NULL,NULL,NULL,NULL,NULL,1,306.831667,-51.70522,0.057,NULL,51083376387,798177756,12471527,15.5),(147048,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15884',NULL,147048,38.61,0.64,528,70023,70,NULL,'SN photometric redshift distance, z photo =0.132 +/- 0.050','SDSS-II SN 15884',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,306.839667,-0.01906,0.541,NULL,47807760304,746996254,11671816,NULL),(147049,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147049,37.04,0.62,255,70024,70,NULL,NULL,'2MASX J20272337-6706302',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.0R',0.24,NULL,NULL,NULL,NULL,NULL,1,306.847375,-67.10833,0.113,NULL,49364552236,771321128,12051892,15),(147050,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147050,33.07,0.47,41.1,70025,NULL,NULL,'H','NGC 6917',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00002,NULL,'14.3',1.1,'S',NULL,NULL,NULL,NULL,1,306.868167,8.09808,0.689,NULL,53988455418,843569615,13180775,14.3),(147051,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147051,33.12,0.45,42.1,70025,NULL,NULL,'K','NGC 6917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147052,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147052,33.14,0.46,42.4,70025,NULL,NULL,'J','NGC 6917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147053,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147053,33.41,0.69,48.1,70025,100,NULL,'mid-IR','NGC 6917',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147054,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147054,33.87,0.4,59.4,70025,NULL,NULL,'mean','NGC 6917',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147055,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147055,33.05,0.79,40.8,70026,NULL,NULL,NULL,'ESO 234- G 028',NULL,'2009ApJS..182..474S',2009,1,1.2,'Confused HIPASS source','G',0.00003,NULL,'14.27',0.6,'SAB(s)bc pec',NULL,NULL,NULL,NULL,1,306.8839583,-51.65547,0.057,NULL,51083377545,798177774,12471527,14.27),(147056,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147056,33.09,0.2,41.5,70026,74.4,NULL,NULL,'ESO 234- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147057,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147057,33.47,0.66,49.4,70026,NULL,NULL,'Malmquist cor.','ESO 234- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147058,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147058,36.23,0.54,176,70027,70,NULL,NULL,'2MASX J20273247-4429094',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,306.885375,-44.48592,0.077,NULL,51379049611,802797650,12543713,16.3),(147059,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147059,34.85,0.49,93.2,70028,75,NULL,'IR','ESO 596- G 040',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.57',0.3,'SAB(s)c:',NULL,NULL,NULL,NULL,1,306.897167,-18.83503,0.177,NULL,50852961648,794577525,12415273,15.57),(147060,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147060,35.18,0.35,108,70028,NULL,NULL,NULL,'ESO 596- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147061,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147061,35.22,0.2,111,70028,74.4,NULL,NULL,'ESO 596- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147062,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147062,35.31,0.33,115,70028,NULL,NULL,'Malmquist cor.','ESO 596- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147063,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147063,36.31,0.75,183,70029,70,NULL,NULL,'2MASX J20273660-1852239',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.16',0.6,NULL,NULL,NULL,NULL,NULL,1,306.902625,-18.87356,0.177,NULL,50853668680,794588573,12415446,16.16),(147064,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147064,35.72,0.49,140,70030,70,NULL,NULL,'2MASX J20273752-6654143',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'14.6R',0.21,NULL,NULL,NULL,NULL,NULL,1,306.90625,-66.90394,0.105,NULL,49364505984,771320406,12051881,14.6),(147065,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147065,31.99,0.4,25,70031,73,NULL,'opt','ESO 400- G 025',NULL,'2011A&A...532A.104N',2011,1,1.7,NULL,'G',0.000013,NULL,'15.19',0.7,'SAB(s)dm:',NULL,NULL,NULL,NULL,1,306.908167,-32.95744,0.221,NULL,51293930375,801467662,12522932,15.19),(147066,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147066,32.28,0.2,28.6,70031,74.4,NULL,NULL,'ESO 400- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147067,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147067,32.45,0.43,30.9,70031,75,NULL,'3.6 micron, color corrected','ESO 400- G 025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147068,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147068,32.58,0.43,32.8,70031,75,NULL,'3.6 micron, color + selection bias corrected','ESO 400- G 025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147069,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147069,32.75,0.16,35.5,70032,NULL,NULL,'I','NGC 6909',NULL,'2001ApJ...546..681T',2001,1,2.2,NULL,'G',0.00005,NULL,'12.61',1.1,'SA0^-','Group member',NULL,NULL,NULL,1,306.9120417,-47.02703,0.069,NULL,51095626272,798369160,12474518,12.61),(147070,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147070,32.75,0.16,35.5,70032,NULL,NULL,NULL,'NGC 6909',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147071,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147071,32.77,0.14,35.8,70032,74.4,NULL,NULL,'NGC 6909',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147072,'SBF','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147072,32.8,0.16,36.4,70032,NULL,NULL,'Malmquist cor.','NGC 6909',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147073,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147073,32.24,0.4,28,70032,75,NULL,'Edat, raw','NGC 6909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147074,'D-Sigma','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147074,32.36,0.4,29.7,70032,75,NULL,'Edat, cor','NGC 6909',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147075,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147075,29.67,1.31,8.59,70032,95,NULL,'Weighted Mean','NGC 6909',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147076,'Faber-Jackson','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147076,30.58,1.61,13.1,70032,55,NULL,'Visvanathan & Sandage 1979','NGC 6909',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147077,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147077,32.65,0.41,33.8,70032,NULL,NULL,NULL,'NGC 6909',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147078,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147078,32.9,0.41,38,70032,NULL,NULL,'Malmquist cor.','NGC 6909',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147079,'Tertiary','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147079,32.18,0.71,27.3,70032,95,NULL,NULL,'NGC 6909',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147080,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147080,32.68,0.8,34.3,70032,75,NULL,'B','NGC 6909',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147081,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147081,32.54,0.45,32.2,70032,NULL,NULL,'K','NGC 6909',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147082,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147082,33.02,0.4,40.2,70032,NULL,NULL,'mean','NGC 6909',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147083,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147083,33.52,0.49,50.6,70033,75,NULL,'IR','UGC 11564 NED02',NULL,'2011yCatp016004901K',2011,1,0.8,'Not noted as a pair in CGCG.','G',0.000053,NULL,'15.1',0.2,'Sb',NULL,NULL,NULL,NULL,1,306.914875,10.75725,0.629,NULL,53972976826,843327762,13176996,15.1),(147084,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147084,33.62,0.8,53.1,70034,75,NULL,'MAT, I','ESO 143- G 027',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00004,NULL,'15.64',0.5,'SB(s)m? sp',NULL,NULL,NULL,NULL,1,306.93475,-58.65297,0.201,NULL,48998042189,765594409,11962412,15.64),(147085,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147085,32.71,0.32,34.8,70034,85,NULL,'I, inv','ESO 143- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147086,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147086,32.75,0.32,35.4,70034,85,NULL,'I, raw','ESO 143- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147087,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147087,33.01,0.43,40.1,70034,75,NULL,'MAT, I, inv','ESO 143- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147088,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147088,33.07,0.43,41.1,70034,75,NULL,'MAT, I, raw','ESO 143- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147089,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147089,33.39,0.43,47.6,70034,75,NULL,'MAT, I, cor','ESO 143- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147090,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147090,33.77,0.8,56.8,70035,75,NULL,'MAT, I','ESO 186- G 047',NULL,'1997ApJS..109..333W',1997,1,1.5,'Confused HIPASS source','G',0.000027,NULL,'14.43',0.7,'SB(rs)bc?',NULL,NULL,NULL,NULL,1,306.94025,-52.38436,0.057,NULL,51082746381,798167912,12471373,14.43),(147091,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147091,33.59,0.32,52.3,70035,85,NULL,'I, raw','ESO 186- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147092,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147092,33.63,0.32,53.2,70035,85,NULL,'I, inv','ESO 186- G 047',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147093,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147093,33.7,0.49,55,70035,75,NULL,'IR','ESO 186- G 047',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147094,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147094,33.75,0.43,56.3,70035,75,NULL,'MAT, I, raw','ESO 186- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147095,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147095,33.9,0.31,60.3,70035,NULL,NULL,'B, Hubble-type-TF','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147096,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147096,33.9,NULL,60.3,70035,NULL,NULL,'B, Hubble-type-TF','ESO 186- G 047',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147097,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147097,33.91,NULL,60.5,70035,NULL,NULL,'B','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147098,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147098,33.91,NULL,60.5,70035,NULL,NULL,'I','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147099,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147099,33.91,NULL,60.6,70035,NULL,NULL,'B','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147100,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147100,33.94,0.43,61.2,70035,75,NULL,'MAT, I, inv','ESO 186- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147101,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147101,33.94,NULL,61.4,70035,NULL,NULL,'I','ESO 186- G 047',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147102,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147102,33.98,0.4,62.4,70035,NULL,NULL,'mean','ESO 186- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147103,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147103,34.02,0.43,63.8,70035,75,NULL,'MAT, I, cor','ESO 186- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147104,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147104,34.23,0.47,70.1,70035,NULL,NULL,'H','ESO 186- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147105,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147105,34.3,0.46,72.6,70035,NULL,NULL,'J','ESO 186- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147106,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147106,34.33,0.45,73.4,70035,NULL,NULL,'K','ESO 186- G 047',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147107,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147107,32.94,0.47,38.6,70036,70,NULL,NULL,'NGC 6915',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00014,NULL,'12.26',1,'(R\')Sab? poss. LINER',NULL,NULL,NULL,NULL,1,306.941916667,-3.07706,0.197,NULL,47803559753,746930621,11670790,12.26),(147108,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147108,35.31,0.5,115,70037,70,NULL,NULL,'FAIRALL 0898',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.0b',0.5,NULL,NULL,NULL,NULL,NULL,1,306.957333,-47.07431,0.089,NULL,51095659077,798369673,12474526,16),(147109,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147109,36.35,0.57,186,70038,70,NULL,NULL,'2MASX J20275255-4257203',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'14.9R',0.31,NULL,NULL,NULL,NULL,NULL,1,306.9690417,-42.95569,0.105,NULL,51387372108,802927689,12545745,14.9),(147110,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147110,34.71,0.6,87.3,70039,NULL,NULL,NULL,'ESO 596- G 041',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15',0.7,'SB(r)0/a:      HII',NULL,NULL,NULL,NULL,1,307.0047917,-18.77894,0.177,NULL,50853650176,794588284,12415441,15),(147111,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147111,34.75,0.2,89.1,70039,74.4,NULL,NULL,'ESO 596- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147112,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147112,35,0.53,100,70039,NULL,NULL,'Malmquist cor.','ESO 596- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147113,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147113,33.21,0.49,43.9,70040,75,NULL,'IR','UGC 11565',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00003,NULL,'15.04',0.2,'Im?',NULL,NULL,NULL,NULL,1,307.011917,4.96197,0.329,NULL,54009209276,843893894,13185842,15.04),(147114,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147114,35.26,0.76,113,70041,70,NULL,NULL,'FAIRALL 0900',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.7,NULL,NULL,NULL,NULL,NULL,1,307.0209583,-45.14514,0.033,NULL,51378436495,802788070,12543563,13.5),(147115,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05340','R',147115,39.51,0.2,668,70042,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05340',0.1937,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.0212917,-0.273,0.541,NULL,47807905005,746998515,11671851,NULL),(147116,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05340','R',147116,39.67,0.13,720,70042,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05340',0.1937,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147117,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147117,34.44,0.8,77.2,70043,75,NULL,'MAT, I','ESO 234- G 032',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.45',0.6,'(R\')SB(s)bc',NULL,NULL,NULL,NULL,1,307.026917,-51.69161,0.057,NULL,51083431775,798178621,12471540,14.45),(147118,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147118,33.9,NULL,60.3,70043,NULL,NULL,'B','ESO 234- G 032',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147119,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147119,33.9,0.16,60.3,70043,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 032',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147120,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147120,33.9,NULL,60.3,70043,NULL,NULL,'I','ESO 234- G 032',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147121,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147121,34.01,0.43,63.3,70043,75,NULL,'MAT, I, raw','ESO 234- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147122,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147122,34.18,0.43,68.6,70043,75,NULL,'MAT, I, inv','ESO 234- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147123,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147123,34.21,0.43,69.6,70043,75,NULL,'MAT, I, cor','ESO 234- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147124,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147124,34.23,0.32,70.1,70043,85,NULL,'I, raw','ESO 234- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147125,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147125,34.27,0.32,71.4,70043,85,NULL,'I, inv','ESO 234- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147126,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147126,31.63,0.39,21.2,70044,73,NULL,'opt','ESO 400-IG 026',NULL,'2011A&A...532A.104N',2011,1,1.4,NULL,'G',0.000018,NULL,'15.06',0.5,'IBm: pec',NULL,NULL,NULL,NULL,1,307.0399583,-35.8105,0.093,NULL,51294264397,801472881,12523013,15.06),(147127,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147127,35.06,0.47,103,70045,NULL,NULL,NULL,'IC 1321',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.18',0.8,'(R\')SB(r)bc    HII',NULL,NULL,NULL,NULL,1,307.0460417,-18.2915,0.177,NULL,50846410854,794475169,12413674,15.18),(147128,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147128,35.1,0.2,105,70045,74.4,NULL,NULL,'IC 1321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147129,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147129,35.22,0.44,110,70045,NULL,NULL,'Malmquist cor.','IC 1321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147130,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15381','R',147130,39.08,0.11,563,70046,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15381',0.162,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.07625,0.49336,0.525,NULL,53996366761,843693230,13182706,NULL),(147131,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 15381','R',147131,39.27,0.25,615,70046,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15381',0.162,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147132,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147132,33.65,0.47,53.6,70047,NULL,NULL,'H','UGC 11568',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000005,NULL,'14.5',0.6,'Scd?',NULL,NULL,NULL,NULL,1,307.0777917,10.75578,0.629,NULL,53972866112,843326033,13176969,14.5),(147133,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147133,33.65,0.46,53.7,70047,NULL,NULL,'J','UGC 11568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147134,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147134,33.68,0.45,54.4,70047,NULL,NULL,'K','UGC 11568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147135,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147135,33.68,0.4,54.4,70047,NULL,NULL,'mean','UGC 11568',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147136,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147136,33.71,0.43,55.1,70047,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11568',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147137,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147137,33.71,0.43,55.3,70047,75,NULL,'3.6 micron, color corrected','UGC 11568',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147138,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147138,33.78,0.33,57,70047,70,NULL,'H, UH88/IRSF/2MASS','UGC 11568',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147139,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147139,33.78,0.33,57,70047,70,NULL,'H, 2MASS','UGC 11568',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147140,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147140,33.85,0.2,58.9,70047,74.4,NULL,NULL,'UGC 11568',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147141,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147141,34.1,0.28,66.1,70047,NULL,NULL,'Malmquist cor.','UGC 11568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147142,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147142,34.11,0.28,66.4,70047,NULL,NULL,NULL,'UGC 11568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147143,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 19023','R',147143,40.57,0.2,1050,70048,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ls','SN 2007ls',0.243,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,307.1169583,0.00622,0.533,NULL,53995446699,843678854,13182482,NULL),(147144,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 19023','R',147144,40.69,0.1,1100,70048,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ls','SN 2007ls',0.243,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147145,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 20639',NULL,147145,39.76,0.39,894,70049,70,NULL,'SN photometric redshift distance, z photo =0.236 +/- 0.054','SDSS-II SN 20639',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.122791667,0.788,0.469,NULL,53996062043,843688469,13182632,NULL),(147146,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147146,35.69,0.55,137,70050,70,NULL,NULL,'2MASX J20283290-4404299',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.2R',0.46,NULL,NULL,NULL,NULL,NULL,1,307.137083,-44.07506,0.085,NULL,51378997911,802796842,12543700,14.2),(147147,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147147,35.82,0.42,146,70051,NULL,NULL,NULL,'ESO 143- G 028',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.59',0.5,'SA(r)c',NULL,NULL,NULL,NULL,1,307.139917,-61.71847,0.185,NULL,49153330740,768020792,12000324,15.59),(147148,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147148,35.84,0.42,147,70051,NULL,NULL,'Malmquist cor.','ESO 143- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147149,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147149,35.87,0.2,149,70051,74.4,NULL,NULL,'ESO 143- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147150,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147150,36.8,0.69,229,70052,70,NULL,NULL,'2MASX J20284234-4810287',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.4b',0.18,NULL,NULL,NULL,NULL,NULL,1,307.176417,-48.17456,0.077,NULL,51129451413,798897678,12482776,16.4),(147151,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147151,34.5,0.79,79.5,70053,NULL,NULL,'Malmquist cor.','UGC 11569',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',NULL,NULL,'16.0',0.6,'Scd:',NULL,NULL,NULL,NULL,1,307.188333,10.62844,0.629,NULL,53975771449,843371428,13177678,16),(147152,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147152,34.52,0.78,80.3,70053,NULL,NULL,NULL,'UGC 11569',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147153,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147153,34.56,0.2,81.7,70053,74.4,NULL,NULL,'UGC 11569',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147154,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14988',NULL,147154,40.29,0.13,1140,70054,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.024','SDSS-II SN 14988',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.204958333,0.28889,0.525,NULL,53996341868,843692841,13182700,NULL),(147155,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147155,35.47,0.51,124,70055,70,NULL,NULL,'2MASX J20285063-7406114',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.210833,-74.10319,0.201,NULL,48490197866,757659341,11838427,16),(147156,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147156,35.88,0.63,150,70056,70,NULL,NULL,'2MASX J20285199-1851060',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.03',NULL,NULL,NULL,NULL,NULL,NULL,1,307.2165,-18.85175,0.149,NULL,50853679521,794588742,12415449,16.03),(147157,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147157,35.78,0.51,143,70057,70,NULL,NULL,'2MASX J20285230-7921533',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.2182083,-79.36483,0.577,NULL,48583812343,759122067,11861282,16.7),(147158,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147158,38.82,0.13,492,70058,74.2,NULL,'SALT 2','[BBB2005b] J202852.60-004645.3',0.18,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.219167,-0.77925,0.653,NULL,47808078794,747001231,11671894,NULL),(147159,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147159,39.47,0.06,665,70058,70,NULL,'SDSS-II SN 05350','[BBB2005b] J202852.60-004645.3',0.18,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147160,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147160,39.53,0.12,682,70058,65,NULL,'SALT2','[BBB2005b] J202852.60-004645.3',0.18,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147161,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147161,39.54,0.13,686,70058,70,NULL,'SDSS-II SN 05350, SALT 2','[BBB2005b] J202852.60-004645.3',0.18,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147162,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05350','R',147162,39.55,0.2,689,70058,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hp','[BBB2005b] J202852.60-004645.3',0.18,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147163,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05350','R',147163,39.72,0.13,745,70058,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hp','[BBB2005b] J202852.60-004645.3',0.18,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147164,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005hp',NULL,147164,39.8,0.15,773,70058,65,NULL,'MLCS2k2','[BBB2005b] J202852.60-004645.3',0.18,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147165,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147165,35.79,0.62,144,70059,70,NULL,NULL,'2MASX J20285410-2111450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,307.225417,-21.19581,0.185,NULL,50866343720,794786620,12418540,15.6),(147166,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147166,33.25,0.2,44.7,70060,74.4,NULL,NULL,'UGC 11571',NULL,'2013AJ....146...86T',2013,1,2,NULL,'G',0.000027,NULL,'14.8',0.6,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,307.256167,10.67869,0.629,NULL,53975712986,843370515,13177664,14.8),(147167,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147167,33.27,0.53,45.1,70060,NULL,NULL,NULL,'UGC 11571',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147168,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147168,33.46,0.49,49.2,70060,75,NULL,'IR','UGC 11571',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147169,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147169,33.48,0.48,49.7,70060,NULL,NULL,'Malmquist cor.','UGC 11571',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147170,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147170,33.93,0.4,61.2,70060,NULL,NULL,'mean','UGC 11571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147171,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147171,34.28,0.47,71.7,70060,NULL,NULL,'H','UGC 11571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147172,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147172,34.4,0.45,75.8,70060,NULL,NULL,'K','UGC 11571',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147173,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 20128',NULL,147173,39.4,0.57,758,70061,70,NULL,'SN photometric redshift distance, z photo =0.196 +/- 0.068','SDSS-II SN 20128',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.3495,0.18789,0.525,NULL,53995822338,843684724,13182573,NULL),(147174,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 04953',NULL,147174,39.62,0.25,841,70062,70,NULL,'SN photometric redshift distance, z photo =0.220 +/- 0.031','SDSS-II SN 04953',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.3527083,-0.99825,0.729,NULL,47810015615,747031493,11672367,NULL),(147175,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147175,34.37,0.47,74.8,70063,70,NULL,NULL,'CGCG 373-016',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.8',0.4,NULL,NULL,NULL,NULL,NULL,1,307.352833,-0.174,0.673,NULL,47808376565,747005883,11671966,14.8),(147176,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147176,36.52,0.57,201,70064,70,NULL,NULL,'2MASX J20292556-0744086',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.5I',0.7,NULL,NULL,NULL,NULL,NULL,1,307.3565,-7.73575,0.189,NULL,47831595167,747368674,11677635,13.5),(147177,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147177,34.34,0.43,73.6,70065,NULL,NULL,'Malmquist cor.','IC 5012',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00003,NULL,'15.22',0.5,'SB(rs)c',NULL,NULL,NULL,NULL,1,307.38325,-56.74311,0.233,NULL,49002358794,765661856,11963466,15.22),(147178,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147178,34.51,0.4,80,70065,NULL,NULL,NULL,'IC 5012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147179,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147179,34.55,0.2,81.3,70065,74.4,NULL,NULL,'IC 5012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147180,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147180,33.01,0.69,39.9,70066,100,NULL,'mid-IR','MCG -02-52-006',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000027,NULL,'14.1b',0.4,NULL,NULL,NULL,NULL,NULL,1,307.3962083,-12.50342,0.169,NULL,50970072817,796407387,12443865,14.1),(147181,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147181,33.66,NULL,54,70066,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','MCG -02-52-006',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147182,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147182,33.66,NULL,54,70066,70,NULL,'H, 2MASS, Malmquist corr.','MCG -02-52-006',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147183,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147183,33.75,0.44,56.2,70066,70,NULL,'H, UH88/IRSF/2MASS','MCG -02-52-006',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147184,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147184,33.75,0.44,56.2,70066,70,NULL,'H, 2MASS','MCG -02-52-006',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147185,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147185,34.7,0.8,87,70067,75,NULL,'MAT, I','ESO 285- G 020',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.66',0.8,'SA(r)bc',NULL,NULL,NULL,NULL,1,307.4065417,-43.84106,0.089,NULL,51378993933,802796780,12543699,14.66),(147186,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147186,34.54,0.32,80.8,70067,85,NULL,'I, raw','ESO 285- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147187,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147187,34.58,0.32,82.3,70067,85,NULL,'I, inv','ESO 285- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147188,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147188,34.61,0.43,83.5,70067,75,NULL,'MAT, I, raw','ESO 285- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147189,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147189,34.81,0.43,91.4,70067,75,NULL,'MAT, I, inv','ESO 285- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147190,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147190,34.89,0.43,94.9,70067,75,NULL,'MAT, I, cor','ESO 285- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147191,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147191,34.78,0.62,90.3,70068,NULL,NULL,'Malmquist cor.','ESO 285- G 021',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.63',0.7,'S(r?)...',NULL,NULL,NULL,NULL,1,307.4440417,-45.413,0.045,NULL,51379450319,802803911,12543811,15.63),(147192,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147192,34.91,0.58,96,70068,NULL,NULL,NULL,'ESO 285- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147193,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147193,34.95,0.2,97.7,70068,74.4,NULL,NULL,'ESO 285- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147194,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 08412','R',147194,40.6,0.17,1070,70069,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2005jq','[BBB2005a] J202947.68+010833.7',0.234,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.448667,1.14269,0.429,NULL,53996504588,843695384,13182740,NULL),(147195,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 08412','R',147195,40.65,0.23,1090,70069,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2005jq','[BBB2005a] J202947.68+010833.7',0.234,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147196,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147196,33.85,0.43,59,70070,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 373-018',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000023,NULL,'15.7',0.15,NULL,NULL,NULL,NULL,NULL,1,307.454875,-2.02897,0.453,NULL,47809820291,747028442,11672319,15.7),(147197,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147197,34.58,0.49,82.2,70071,75,NULL,'IR','FGC 2269',NULL,'2011yCatp016004901K',2011,1,1.08,NULL,'G',0.00003,NULL,'16.3',0.11,'Sdm',NULL,NULL,NULL,NULL,1,307.477,-1.79181,0.517,NULL,47809623926,747025373,11672271,16.3),(147198,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147198,34.63,0.48,84.3,70072,70,NULL,NULL,'ESO 596- G 048',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000073,NULL,'13.91',0.5,'E?',NULL,NULL,NULL,NULL,1,307.559458333,-19.11603,0.149,NULL,50853488831,794585762,12415402,13.91),(147199,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147199,34.28,0.47,71.9,70073,NULL,NULL,'H','ESO 400- G 033',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'15.1b',0.3,'Sb',NULL,NULL,NULL,NULL,1,307.5637083,-34.812,0.081,NULL,51294715172,801479924,12523123,15.1),(147200,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147200,34.35,0.45,74.2,70073,NULL,NULL,'K','ESO 400- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147201,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147201,34.47,0.46,78.2,70073,NULL,NULL,'J','ESO 400- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147202,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147202,34.47,0.4,78.5,70073,NULL,NULL,'mean','ESO 400- G 033',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147203,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147203,34.81,0.45,91.6,70073,NULL,NULL,'Malmquist cor.','ESO 400- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147204,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147204,34.99,0.41,99.7,70073,NULL,NULL,NULL,'ESO 400- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147205,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147205,35.03,0.2,101,70073,74.4,NULL,NULL,'ESO 400- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147206,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147206,28.85,NULL,5.9,70074,NULL,NULL,NULL,'UGC 11583',NULL,'1997AstL...23..373S',1997,1,2.5,NULL,'G',0.000007,NULL,'17.',0.6,'Irr',NULL,NULL,NULL,NULL,1,307.56375,60.44028,1.353,NULL,53460255367,835316490,13051820,17),(147207,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147207,29.57,NULL,8.2,70074,NULL,NULL,NULL,'UGC 11583',NULL,'2000A&A...362..544K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147208,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147208,35.75,0.63,141,70075,70,NULL,NULL,'2MASX J20302222-5243009',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.4,NULL,NULL,NULL,NULL,NULL,1,307.5927083,-52.71686,0.057,NULL,51084035220,798188050,12471688,14.5),(147209,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147209,35.78,0.74,143,70076,70,NULL,NULL,'IC 5010',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.88',0.3,'Sa - b',NULL,NULL,NULL,NULL,1,307.611167,-66.09736,0.133,NULL,49372066739,771438542,12053727,15.88),(147210,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147210,34.88,0.55,94.5,70077,70,NULL,NULL,'2MASX J20303209-4420396',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.63375,-44.34439,0.081,NULL,51378937336,802795895,12543685,16.8),(147211,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147211,28.63,NULL,5.3,70078,NULL,NULL,NULL,'LEDA 166192',NULL,'2000A&A...362..544K',2000,1,1.6,NULL,'G',0.000007,NULL,'16.5',0.8,'Irr?',NULL,NULL,NULL,NULL,1,307.637083,60.35472,1.353,NULL,53460235985,835316187,13051815,16.5),(147212,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147212,28.85,NULL,5.9,70078,NULL,NULL,NULL,'LEDA 166192',NULL,'1997AstL...23..373S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147213,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147213,35.91,0.68,152,70079,70,NULL,NULL,'2MASX J20303663-8429251',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.6519583,-84.49028,0.405,NULL,48383729173,755995768,11812433,16.5),(147214,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147214,32.93,0.8,38.6,70080,75,NULL,'MAT, I','IC 5020',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000018,NULL,'13.05',2.1,'SA(s)bc        HII?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,307.660375,-33.48556,0.141,NULL,51296081946,801501280,12523457,13.05),(147215,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147215,32.77,0.43,35.8,70080,75,NULL,'MAT, I, raw','IC 5020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147216,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147216,32.89,0.32,37.9,70080,85,NULL,'I, raw','IC 5020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147217,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147217,32.93,0.43,38.5,70080,75,NULL,'MAT, I, cor','IC 5020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147218,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147218,32.94,0.32,38.8,70080,85,NULL,'I, inv','IC 5020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147219,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147219,32.99,0.43,39.7,70080,75,NULL,'MAT, I, inv','IC 5020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147220,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147220,33.7,0.9,55,70081,NULL,NULL,NULL,'ESO 340- G 038',NULL,'1994ApJ...432...42S',1994,1,1.1,NULL,'G',0.00015,NULL,'15.04',1,'S...',NULL,NULL,NULL,NULL,1,307.66175,-42.30906,0.097,NULL,51387089371,802923271,12545676,15.04),(147221,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147221,34.05,0.87,62.2,70081,NULL,NULL,'SEAM','ESO 340- G 038',0.018466,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147222,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147222,33.97,0.07,62.2,70081,NULL,NULL,'I, photospheric magnitude method','ESO 340- G 038',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147223,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147223,34.08,0.13,65.5,70081,NULL,NULL,'V, photospheric magnitude method','ESO 340- G 038',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147224,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147224,34.13,0.54,67,70081,NULL,NULL,'SCM, V','ESO 340- G 038',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147225,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147225,34.13,0.54,67,70081,NULL,NULL,'SCM, I','ESO 340- G 038',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147226,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147226,34.15,0.28,67.6,70081,NULL,NULL,'SCM, BVI','ESO 340- G 038',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147227,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 1992af',NULL,147227,34.18,0.41,68.5,70081,NULL,NULL,'SCM, B','ESO 340- G 038',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147228,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 05363',NULL,147228,39.74,0.33,887,70082,70,NULL,'SN photometric redshift distance, z photo =0.234 +/- 0.045','SDSS-II SN 05363',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,307.6615,0.94675,0.429,NULL,53997429339,843709833,13182966,NULL),(147229,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147229,34.67,0.59,85.8,70083,70,NULL,NULL,'CGCG 373-026',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000127,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,307.6647083,-2.32519,0.417,NULL,47808842925,747013170,11672080,15.5),(147230,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147230,34.83,0.4,92.3,70084,NULL,NULL,'mean','ESO 340- G 040',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'15',0.4,'S...',NULL,NULL,NULL,NULL,1,307.694583,-39.24861,0.101,NULL,51507943643,804811619,12575181,15),(147231,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147231,34.87,0.47,94.1,70084,NULL,NULL,'H','ESO 340- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147232,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147232,34.98,0.46,98.9,70084,NULL,NULL,'J','ESO 340- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147233,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147233,35.01,0.45,101,70084,NULL,NULL,'K','ESO 340- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147234,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147234,35.14,0.53,107,70084,NULL,NULL,'Malmquist cor.','ESO 340- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147235,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147235,35.4,0.47,120,70084,NULL,NULL,NULL,'ESO 340- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147236,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147236,35.44,0.2,122,70084,74.4,NULL,NULL,'ESO 340- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147237,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147237,34.08,0.49,65.4,70085,75,NULL,'IR','UGC 11580',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000043,NULL,'16.0',0.2,'Scd:',NULL,NULL,NULL,NULL,1,307.7114583,8.09139,0.529,NULL,53988667789,843572934,13180827,16),(147238,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147238,34.36,0.49,74.5,70086,75,NULL,'IR','UGC 11579',NULL,'2011yCatp016004901K',2011,1,1.49,NULL,'G',0.00004,NULL,'16.0',0.2,'Sc','Field galaxy',NULL,NULL,NULL,1,307.730291667,-0.64933,0.549,NULL,47810435891,747038060,11672469,16),(147239,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147239,34.54,0.4,80.8,70086,NULL,NULL,'mean','UGC 11579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147240,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147240,34.58,0.36,82.6,70086,NULL,NULL,'Malmquist cor.','UGC 11579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147241,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147241,34.64,0.2,84.7,70086,74.4,NULL,NULL,'UGC 11579',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147242,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147242,34.69,0.34,86.6,70086,NULL,NULL,NULL,'UGC 11579',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147243,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147243,34.82,0.43,91.9,70086,75,NULL,'3.6 micron, color corrected','UGC 11579',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147244,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147244,34.94,NULL,97.1,70086,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11579',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147245,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147245,34.94,0.47,97.3,70086,NULL,NULL,'H','UGC 11579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147246,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147246,34.94,NULL,97.4,70086,NULL,NULL,'Dipole + Quadrupole','UGC 11579',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147247,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147247,34.96,NULL,98,70086,NULL,NULL,'Dipole','UGC 11579',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147248,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147248,34.98,0.43,98.9,70086,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11579',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147249,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147249,34.82,0.64,91.9,70087,NULL,NULL,NULL,'ESO 462- G 027',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000033,NULL,'13.7I',NULL,NULL,NULL,NULL,NULL,NULL,1,307.7399583,-30.66692,0.253,NULL,51323215121,801925236,12530081,13.7),(147250,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147250,34.86,0.2,93.8,70087,74.4,NULL,NULL,'ESO 462- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147251,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147251,34.94,0.61,97.1,70087,NULL,NULL,'Malmquist cor.','ESO 462- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147252,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147252,36.48,0.56,197,70088,70,NULL,NULL,'2MASX J20311146-5341401',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'14.8R',0.31,NULL,NULL,NULL,NULL,NULL,1,307.7977083,-53.69456,0.145,NULL,51079350672,798114854,12470544,14.8),(147253,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147253,35.52,0.78,127,70089,70,NULL,NULL,'ESO 285- G 025',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.07',0.7,'SB(r)a',NULL,NULL,NULL,NULL,1,307.800833,-44.26231,0.081,NULL,51378932518,802795820,12543684,15.07),(147254,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147254,32.93,0.8,38.5,70090,75,NULL,'MAT, I','ESO 400- G 037',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'14.54',1.1,'SB(s)cd pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,307.806083,-33.47819,0.105,NULL,51295944902,801499139,12523424,14.54),(147255,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147255,33.52,0.2,50.6,70090,74.4,NULL,NULL,'ESO 400- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147256,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147256,33.58,0.32,52,70090,85,NULL,'I, raw','ESO 400- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147257,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147257,33.6,0.32,52.5,70090,85,NULL,'I, inv','ESO 400- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147258,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147258,33.7,0.43,54.9,70090,75,NULL,'MAT, I, raw','ESO 400- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147259,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147259,33.73,0.7,55.8,70090,NULL,NULL,NULL,'ESO 400- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147260,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147260,33.81,0.43,57.8,70090,75,NULL,'MAT, I, inv','ESO 400- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147261,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147261,33.99,0.62,62.8,70090,NULL,NULL,'Malmquist cor.','ESO 400- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147262,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147262,34.17,0.43,68.2,70090,75,NULL,'MAT, I, cor','ESO 400- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147263,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147263,34.39,0.58,75.5,70091,NULL,NULL,NULL,'ESO 596- G 052',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00015,NULL,'15.82',0.4,'S...',NULL,NULL,NULL,NULL,1,307.8262917,-19.04881,0.153,NULL,50853530010,794586406,12415412,15.82),(147264,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147264,34.43,0.2,76.9,70091,74.4,NULL,NULL,'ESO 596- G 052',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147265,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147265,34.58,0.53,82.4,70091,NULL,NULL,'Malmquist cor.','ESO 596- G 052',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147266,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147266,35.43,0.51,122,70092,NULL,NULL,NULL,'ESO 528- G 015',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.3b',0.3,'S...',NULL,NULL,NULL,NULL,1,307.840375,-26.98419,0.241,NULL,51310625310,801728520,12527008,16.3),(147267,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147267,35.43,0.51,122,70092,NULL,NULL,'Malmquist cor.','ESO 528- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147268,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147268,35.47,0.2,124,70092,74.4,NULL,NULL,'ESO 528- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147269,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147269,36.23,0.59,177,70093,70,NULL,NULL,'2MASX J20312836-5420485',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,307.8682083,-54.34681,0.153,NULL,51079500325,798117192,12470581,15),(147270,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147270,28.64,NULL,5.3,70094,NULL,NULL,NULL,'LEDA 166193',NULL,'2000A&A...362..544K',2000,1,0.9,NULL,'G',0.000003,NULL,'17.1',0.9,'Sph?',NULL,NULL,NULL,NULL,1,307.883333,60.81222,1.673,NULL,53460155910,835314936,13051795,17.1),(147271,'Brightest Stars','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147271,28.85,NULL,5.9,70094,NULL,NULL,NULL,'LEDA 166193',NULL,'1997AstL...23..373S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147272,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147272,37.37,0.6,298,70095,70,NULL,NULL,'2MASX J20313219-5351542',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,'E?',NULL,NULL,NULL,NULL,1,307.884125,-53.86514,0.145,NULL,51079402411,798115662,12470557,17),(147273,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147273,34.89,0.5,94.9,70096,70,NULL,NULL,'ESO 597- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000083,NULL,'15',0.8,'SAB(r)0/a',NULL,NULL,NULL,NULL,1,307.889708333,-19.36869,0.149,NULL,50855537314,794617770,12415902,15),(147274,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147274,34.69,0.8,86.7,70097,75,NULL,'MAT, I','NGC 6919',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'13.58',1.2,'SA(rs)c',NULL,NULL,NULL,NULL,1,307.908833,-44.21642,0.081,NULL,51378817743,802794027,12543656,13.58),(147275,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147275,33.82,0.43,58.1,70097,75,NULL,'MAT, I, raw','NGC 6919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147276,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147276,34.05,0.43,64.7,70097,75,NULL,'MAT, I, inv','NGC 6919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147277,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147277,34.19,0.43,68.8,70097,75,NULL,'MAT, I, cor','NGC 6919',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147278,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147278,34.22,0.32,69.7,70097,85,NULL,'I, raw','NGC 6919',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147279,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147279,34.28,0.32,71.8,70097,85,NULL,'I, inv','NGC 6919',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147280,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147280,34.45,0.39,77.6,70097,NULL,NULL,NULL,'NGC 6919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147281,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147281,34.45,0.39,77.6,70097,NULL,NULL,'Malmquist cor.','NGC 6919',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147282,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147282,34.47,0.47,78.3,70097,NULL,NULL,'H','NGC 6919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147283,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147283,34.49,0.2,79.1,70097,74.4,NULL,NULL,'NGC 6919',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147284,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147284,34.67,0.46,86.1,70097,NULL,NULL,'J','NGC 6919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147285,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147285,34.72,0.45,87.9,70097,NULL,NULL,'K','NGC 6919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147286,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147286,34.89,0.4,95,70097,NULL,NULL,'mean','NGC 6919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147287,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147287,32.76,0.8,35.7,70098,75,NULL,'MAT, I','NGC 6923',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00001,NULL,'12.68',1.3,'SB(rs)b:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,307.9127917,-30.83189,0.213,NULL,51325283117,801957548,12530586,12.68),(147288,'Sosies','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147288,32.62,0.09,33.4,70098,NULL,NULL,NULL,'NGC 6923',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147289,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147289,32.59,0.32,33,70098,85,NULL,'I, raw','NGC 6923',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147290,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147290,32.65,0.32,33.9,70098,85,NULL,'I, inv','NGC 6923',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147291,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147291,32.67,0.47,34.2,70098,NULL,NULL,'H','NGC 6923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147292,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147292,32.7,0.46,34.7,70098,NULL,NULL,'J','NGC 6923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147293,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147293,32.74,0.45,35.3,70098,NULL,NULL,'K','NGC 6923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147294,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147294,32.74,0.43,35.3,70098,75,NULL,'MAT, I, raw','NGC 6923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147295,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147295,32.85,0.4,37.2,70098,NULL,NULL,NULL,'NGC 6923',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147296,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147296,32.89,0.43,37.8,70098,75,NULL,'MAT, I, cor','NGC 6923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147297,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147297,32.91,0.4,38.2,70098,NULL,NULL,'mean','NGC 6923',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147298,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147298,33.01,0.43,40.1,70098,75,NULL,'MAT, I, inv','NGC 6923',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147299,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iv',NULL,147299,40.32,0.16,891,70099,74.2,NULL,'SALT 2','[BBB2005a] J203144.67+001441.1',0.3,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,307.936125,0.24475,0.517,NULL,53996742128,843699095,13182798,NULL),(147300,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iv',NULL,147300,41.01,0.16,1230,70099,65,NULL,'SALT2','[BBB2005a] J203144.67+001441.1',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147301,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iv',NULL,147301,41.02,0.18,1230,70099,70,NULL,'SALT 2','[BBB2005a] J203144.67+001441.1',0.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147302,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06137','R',147302,41.12,0.26,1290,70099,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iv','[BBB2005a] J203144.67+001441.1',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147303,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2005iv',NULL,147303,41.16,0.12,1310,70099,65,NULL,'MLCS2k2','[BBB2005a] J203144.67+001441.1',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147304,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 06137','R',147304,41.3,0.17,1400,70099,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iv','[BBB2005a] J203144.67+001441.1',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147305,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147305,37.28,0.7,286,70100,70,NULL,NULL,'2MASX J20314479-5429304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,307.936708333,-54.49181,0.153,NULL,51079330713,798114542,12470539,15.9),(147306,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147306,37.03,0.55,254,70101,70,NULL,NULL,'AM 2020-841 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000127,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.940583,-84.05831,0.433,NULL,48384046585,756000727,11812511,16.2),(147307,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147307,34.09,0.49,65.7,70102,75,NULL,'IR','CGCG 424-018',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,307.9407917,10.05631,0.417,NULL,55064468095,860382313,13443473,15.7),(147308,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147308,36.38,0.65,189,70103,70,NULL,NULL,'2MASX J20314855-7452087',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,307.9520417,-74.86914,0.233,NULL,48489252775,757644574,11838196,17.1),(147309,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147309,34.25,0.49,70.7,70104,75,NULL,'IR','UGC 11584',NULL,'2011yCatp016004901K',2011,1,2.13,NULL,'G',0.000009,NULL,'15.37',0.26,'Sc',NULL,NULL,NULL,NULL,1,307.9574583,1.54489,0.461,NULL,53994884793,843670074,13182344,15.37),(147310,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147310,34.54,NULL,80.9,70104,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147311,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147311,34.55,NULL,81.2,70104,NULL,NULL,'Dipole + Quadrupole','UGC 11584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147312,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147312,34.55,NULL,81.2,70104,NULL,NULL,'Dipole','UGC 11584',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147313,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147313,34.6,NULL,83.3,70104,NULL,NULL,NULL,'UGC 11584',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147314,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147314,34.64,0.43,84.9,70104,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147315,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147315,34.83,0.43,92.3,70104,75,NULL,'3.6 micron, color corrected','UGC 11584',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147316,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147316,34.88,0.39,94.8,70104,NULL,NULL,'Malmquist cor.','UGC 11584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147317,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147317,35.06,0.2,103,70104,74.4,NULL,NULL,'UGC 11584',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147318,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147318,35.2,0.34,110,70104,NULL,NULL,NULL,'UGC 11584',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147319,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 16290','RN',147319,39.12,0.21,580,70105,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16290',0.1511,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147320,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 16290','RN',147320,39.36,0.1,646,70105,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16290',0.1511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147321,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147321,35.68,0.6,137,70106,70,NULL,NULL,'2MASX J20315435-0130330',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'17.09',0.5,NULL,NULL,NULL,NULL,NULL,1,307.976583,-1.50911,0.521,NULL,47810121320,747033145,11672392,17.09),(147322,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147322,35.68,0.52,137,70107,70,NULL,NULL,'2MASX J20320061-5023085',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'14.7R',0.22,NULL,NULL,NULL,NULL,NULL,1,308.002583,-50.38567,0.029,NULL,51075463667,798054119,12469595,14.7),(147323,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147323,34.65,0.67,85,70108,70,NULL,NULL,'ESO 285- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000147,NULL,'15.09',0.3,'Sa:',NULL,NULL,NULL,NULL,1,308.012875,-44.41692,0.081,NULL,51378790936,802793608,12543650,15.09),(147324,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14599','R',147324,38.31,0.06,437,70109,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006jl','[BBB2006] J203204.67-003428.3',0.05,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,308.0194583,-0.57453,0.565,NULL,47810537038,747039641,11672494,NULL),(147325,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14599','R',147325,38.97,0.3,593,70109,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006jl','[BBB2006] J203204.67-003428.3',0.05,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147326,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2006jl',NULL,147326,36.83,0.09,221,70109,NULL,NULL,'SCM 55 SNII','[BBB2006] J203204.67-003428.3',0.05,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147327,'SNII optical','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2006jl',NULL,147327,36.85,0.11,224,70109,NULL,NULL,'SCM 15 SDSS SNII','[BBB2006] J203204.67-003428.3',0.05,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147328,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147328,34.31,0.5,72.8,70110,70,NULL,NULL,'2MASX J20320481-1959487',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00008,NULL,'15.59',0.6,'SA(r)0^+',NULL,NULL,NULL,NULL,1,308.019917,-19.99706,0.181,NULL,50855845308,794622582,12415977,15.59),(147329,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147329,34.2,0.46,69.1,70111,70,NULL,NULL,'IC 1324',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000033,NULL,'14.5',1.5,'(R\')SA(rs)0/a:',NULL,NULL,NULL,NULL,1,308.0512917,-9.05611,0.265,NULL,47829900279,747342191,11677221,14.5),(147330,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147330,32.36,0.49,29.7,70112,75,NULL,'IR','MCG -02-52-011',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00005,NULL,'15',0.5,'IBm pec',NULL,NULL,NULL,NULL,1,308.053333,-8.73372,0.233,NULL,47829829916,747341092,11677204,15),(147331,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147331,32.33,0.8,29.2,70113,75,NULL,'MAT, I','ESO 234- G 043',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'14.22',1.5,'SB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,308.05725,-48.53072,0.093,NULL,51074985478,798046648,12469478,14.22),(147332,'Tully est','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147332,32.46,0.8,31.1,70113,75,NULL,NULL,'ESO 234- G 043',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147333,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147333,31.09,0.32,16.5,70113,85,NULL,'I, inv','ESO 234- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147334,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147334,31.14,0.32,16.9,70113,85,NULL,'I, raw','ESO 234- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147335,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147335,31.35,0.43,18.6,70113,75,NULL,'3.6 micron, color + selection bias corrected','ESO 234- G 043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147336,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147336,31.35,0.2,18.6,70113,74.4,NULL,NULL,'ESO 234- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147337,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147337,31.39,0.43,19,70113,75,NULL,'3.6 micron, color corrected','ESO 234- G 043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147338,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147338,31.44,0.4,19.4,70113,NULL,NULL,NULL,'ESO 234- G 043',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147339,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147339,31.44,0.4,19.4,70113,73,NULL,'opt','ESO 234- G 043',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147340,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147340,32.01,0.43,25.3,70113,75,NULL,'MAT, I, inv','ESO 234- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147341,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147341,32.08,0.43,26.1,70113,75,NULL,'MAT, I, raw','ESO 234- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147342,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147342,32.43,0.43,30.6,70113,75,NULL,'MAT, I, cor','ESO 234- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147343,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 17548','R',147343,37.31,0.07,278,70114,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2007ms','SN 2007ms',0.039,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II-pec',NULL,NULL,NULL,NULL,1,308.076417,-1.01475,0.617,NULL,47810214381,747034599,11672415,NULL),(147344,'SNIa SDSS','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 17548','R',147344,38.01,0.4,386,70114,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2007ms','SN 2007ms',0.039,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147345,'FP','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147345,35.49,0.47,125,70115,70,NULL,NULL,'2MASX J20322742-2109579',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00011,NULL,'15.85',NULL,'SB(r)0^+',NULL,NULL,NULL,NULL,1,308.114333,-21.16628,0.165,NULL,50854037431,794594334,12415536,15.85),(147346,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14451','R',147346,39.61,0.2,709,70116,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ji','SN 2006ji',0.179,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,308.1949583,0.92708,0.445,NULL,53993656701,843650885,13182045,NULL),(147347,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 14451','R',147347,39.89,0.09,804,70116,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ji','SN 2006ji',0.179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147348,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147348,33.7,0.19,54,70117,72,NULL,NULL,'NGC 6928',0.015701,'2009ApJ...704.1036F',2009,1,2,NULL,'G',0.00002,NULL,'13.16',0.6,'SB(s)ab','in a pair',NULL,NULL,NULL,1,308.20925,9.92642,0.417,NULL,55064040023,860375625,13443369,13.16),(147349,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147349,33.83,0.17,56.7,70117,72,NULL,NULL,'NGC 6928',0.01475,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147350,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147350,33.81,0.01,57.8,70117,72,NULL,NULL,'NGC 6928',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147351,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147351,33.86,0.1,59.2,70117,74.4,NULL,NULL,'NGC 6928',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147352,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147352,33.91,0.2,59.7,70117,70,NULL,'SALT 2','NGC 6928',0.015701,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147353,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147353,33.92,0.1,59.9,70117,72,NULL,NULL,'NGC 6928',0.015701,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147354,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147354,33.92,0.05,59.9,70117,72,NULL,NULL,'NGC 6928',0.015701,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147355,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147355,33.93,0.1,60.1,70117,72,NULL,NULL,'NGC 6928',0.015701,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147356,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147356,33.98,0.17,61.5,70117,73.8,NULL,'SALT 2 (SNANA)','NGC 6928',0.0155,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147357,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147357,33.98,0.03,61.6,70117,72,NULL,NULL,'NGC 6928',0.015701,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147358,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147358,34.01,0.04,63.4,70117,72,NULL,'M(H) = -18.317 mag','NGC 6928',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147359,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2004eo',NULL,147359,34.66,0.04,84.4,70117,70,NULL,NULL,'NGC 6928',0.015701,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147360,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147360,32.8,0.47,36.4,70117,NULL,NULL,'H','NGC 6928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147361,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147361,32.81,0.45,36.4,70117,NULL,NULL,'K','NGC 6928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147362,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147362,32.83,0.46,36.9,70117,NULL,NULL,'J','NGC 6928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147363,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,'R',147363,33.2,0.49,43.6,70117,75,NULL,'IR','NGC 6928',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147364,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147364,33.91,0.4,60.4,70117,NULL,NULL,'mean','NGC 6928',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147365,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 11093',NULL,147365,39.95,0.27,979,70118,70,NULL,'SN photometric redshift distance, z photo =0.262 +/- 0.042','SDSS-II SN 11093',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,308.2432083,-0.99453,0.529,NULL,47807361708,746990026,11671719,NULL),(147366,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SN 2003gt',NULL,147366,33.99,0.2,61.8,70119,70,NULL,'SALT 2','NGC 6930',0.015657,'2013MNRAS.433.2240G',2013,1,1.3,NULL,'G',0.000057,NULL,'12.6B',0.5,'SB(s)ab? sp','in a pair',NULL,NULL,NULL,1,308.245,9.87444,0.417,NULL,55064040897,860375639,13443369,12.6),(147367,'SNIa','2016-12-15 15:15:51','2016-12-16 11:21:06','1','SDSS-II SN 04906',NULL,147367,40.1,0.27,1050,70120,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.045','SDSS-II SN 04906',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,308.293583,-0.01592,0.465,NULL,47806972925,746983951,11671624,NULL),(147368,'IRAS','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147368,34.39,0.8,75.7,70121,75,NULL,'MAT, I','ESO 528- G 017',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'16.10',0.22,'SBcd? sp',NULL,NULL,NULL,NULL,1,308.336,-27.09778,0.169,NULL,51310340054,801724063,12526938,16.1),(147369,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147369,34.11,NULL,66.5,70121,NULL,NULL,NULL,'ESO 528- G 017',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147370,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147370,34.18,0.32,68.5,70121,85,NULL,'I, raw','ESO 528- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147371,'Tully-Fisher','2016-12-15 15:15:51','2016-12-16 11:21:06','1',NULL,NULL,147371,34.19,0.32,68.8,70121,85,NULL,'I, inv','ESO 528- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147372,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147372,34.23,0.43,70.2,70121,75,NULL,'MAT, I, raw','ESO 528- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147373,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147373,34.28,NULL,71.7,70121,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 528- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147374,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147374,34.29,NULL,72,70121,NULL,NULL,'Dipole','ESO 528- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147375,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147375,34.29,NULL,72.2,70121,NULL,NULL,'Dipole + Quadrupole','ESO 528- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147376,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147376,34.33,0.43,73.3,70121,75,NULL,'MAT, I, inv','ESO 528- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147377,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147377,34.65,0.43,85.2,70121,75,NULL,'MAT, I, cor','ESO 528- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147378,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147378,34.7,0.49,87.3,70121,75,NULL,'IR','ESO 528- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147379,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147379,34.72,0.2,87.9,70121,74.4,NULL,NULL,'ESO 528- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147380,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147380,34.89,0.43,94.9,70121,NULL,NULL,NULL,'ESO 528- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147381,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147381,34.96,0.42,98.3,70121,NULL,NULL,'Malmquist cor.','ESO 528- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147382,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147382,37.25,0.57,281,70122,70,NULL,NULL,'2MASX J20332953-6645223',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'15.5R',0.13,NULL,NULL,NULL,NULL,NULL,1,308.372875,-66.75622,0.129,NULL,49363996712,771312448,12051757,15.5),(147383,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147383,33.93,0.33,61.1,70123,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 044',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'14.99',0.6,'SB(s)bc',NULL,NULL,NULL,NULL,1,308.375166667,-49.576,0.033,NULL,51078003121,798093798,12470215,14.99),(147384,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147384,34.58,0.49,82.5,70123,NULL,NULL,'Malmquist cor.','ESO 234- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147385,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147385,34.78,0.44,90.3,70123,NULL,NULL,NULL,'ESO 234- G 044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147386,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147386,34.82,0.2,92,70123,74.4,NULL,NULL,'ESO 234- G 044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147387,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2003ib',NULL,147387,34.78,0.23,90.4,70124,NULL,NULL,'V, photospheric magnitude method','ESO 528- G 018',NULL,'2014AJ....148..107R',2014,1,1.1,NULL,'G',0.00015,NULL,'14.97',0.4,'(R)S(r?)b',NULL,NULL,NULL,NULL,1,308.379041667,-24.62389,0.185,NULL,50830345884,794224154,12409752,14.97),(147388,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2003ib',NULL,147388,35.03,0.14,101,70124,NULL,NULL,'I, photospheric magnitude method','ESO 528- G 018',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147389,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147389,35.61,0.48,132,70125,70,NULL,NULL,'2MASX J20333916-4354197',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000097,NULL,'13.7R',0.9,'SA(s)0^0^?',NULL,NULL,NULL,NULL,1,308.413375,-43.90561,0.101,NULL,51378673320,802791770,12543621,13.7),(147390,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 10997',NULL,147390,38.09,1.13,415,70126,70,NULL,'SN photometric redshift distance, z photo =0.102 +/- 0.077','SDSS-II SN 10997',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,308.421958333,0.52097,0.393,NULL,53994084668,843657572,13182149,NULL),(147391,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147391,32.03,0.47,25.5,70127,NULL,NULL,'H','NGC 6931',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000127,NULL,'14.2b',0.4,'Sb pec?        HII',NULL,NULL,NULL,NULL,1,308.4222917,-11.36886,0.233,NULL,50755255388,793050865,12391419,14.2),(147392,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147392,32.17,0.45,27.1,70127,NULL,NULL,'K','NGC 6931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147393,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147393,32.21,0.46,27.6,70127,NULL,NULL,'J','NGC 6931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147394,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147394,32.82,0.4,36.6,70127,NULL,NULL,'mean','NGC 6931',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147395,'G Lens','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147395,43.67,0.43,5430,70128,NULL,NULL,NULL,'WFI J2033-4723',NULL,'2014MNRAS.437..600S',2014,1,NULL,'This QSO may be lensed by a z=0.66 galaxy.','QSO',0.003,NULL,'17.59',NULL,NULL,NULL,NULL,NULL,'QSO',1,308.42475,-47.39519,0.093,NULL,51128567461,798883866,12482560,17.59),(147396,'GRB','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147396,42.26,NULL,2830,70129,70,NULL,'Pseudo z = 1.21','GRB 030725',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,308.445833,-50.76667,0.033,NULL,51077197231,798081206,12470018,NULL),(147397,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147397,36.86,0.71,236,70130,70,NULL,NULL,'ESO 597- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.8R',0.4,'S0',NULL,NULL,NULL,NULL,1,308.479667,-21.12822,0.141,NULL,50853908832,794592325,12415505,14.8),(147398,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 11097','RN',147398,39.76,0.25,747,70131,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11097',0.196,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147399,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 11097','RN',147399,39.99,0.12,833,70131,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11097',0.196,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147400,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147400,35.77,0.53,142,70132,70,NULL,NULL,'2MASX J20335752-5247064',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.4897917,-52.78517,0.033,NULL,51084133205,798189581,12471712,14.9),(147401,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147401,32.56,0.8,32.4,70133,75,NULL,NULL,'ESO 186- G 062',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000024,NULL,'12.97',2.2,'SB(rs)cd',NULL,NULL,NULL,NULL,1,308.50875,-52.98119,0.121,NULL,51084268779,798191699,12471745,12.97),(147402,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147402,37.2,0.67,275,70134,70,NULL,NULL,'2MASX J20340292-0134425',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.512167,-1.57844,0.521,NULL,47843949887,747561716,11680651,15.5),(147403,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147403,36.79,0.62,228,70135,70,NULL,NULL,'ESO 234- G 046',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'15.30',0.5,'SB:(r)bc',NULL,NULL,NULL,NULL,1,308.51475,-49.70839,0.033,NULL,51078220930,798097202,12470268,15.3),(147404,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147404,36.21,0.51,174,70136,70,NULL,NULL,'2MASX J20340357-4842012',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000103,NULL,'16.1b',0.26,NULL,NULL,NULL,NULL,NULL,1,308.5147917,-48.70036,0.093,NULL,51075072128,798048002,12469500,16.1),(147405,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147405,38.04,0.67,405,70137,70,NULL,NULL,'2MASX J20340451-5920468',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'16.1',NULL,NULL,NULL,NULL,NULL,NULL,1,308.519,-59.34628,0.149,NULL,49182583097,768477860,12007466,16.1),(147406,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147406,36.27,0.67,180,70138,70,NULL,NULL,'2MASX J20340569-4515037',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.0R',0.33,NULL,NULL,NULL,NULL,NULL,1,308.5237917,-45.25097,0.073,NULL,51380000872,802812513,12543945,15),(147407,'Ring Diameter','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147407,32.4,0.84,30,70139,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6925',NULL,'1981ApJS...45..541P',1981,1,4.5,'Identification as IC 5015 is not certain.','G',0.000013,NULL,'12.07',1.2,'SA(s)bc        HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,308.5857083,-31.98089,0.233,NULL,51322551048,801914860,12529919,12.07),(147408,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147408,32.72,0.8,35,70139,75,NULL,'MAT, I','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147409,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147409,32.73,0.8,35.2,70139,75,NULL,'A82, H','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147410,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147410,31.84,0.43,23.3,70139,75,NULL,'MAT, I, raw','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147411,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147411,32,0.32,25.1,70139,85,NULL,'I, raw','NGC 6925',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147412,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147412,32.07,0.32,26,70139,85,NULL,'I, inv','NGC 6925',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147413,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147413,32.1,0.4,26.3,70139,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 6925',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147414,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147414,32.17,0.43,27.1,70139,75,NULL,'MAT, I, inv','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147415,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147415,32.23,0.2,27.9,70139,74.4,NULL,NULL,'NGC 6925',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147416,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147416,32.24,0.46,28,70139,NULL,NULL,'J','NGC 6925',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147417,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147417,32.26,0.38,28.3,70139,NULL,NULL,NULL,'NGC 6925',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147418,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147418,32.27,0.43,28.4,70139,75,NULL,'MAT, I, cor','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147419,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147419,32.27,0.43,28.5,70139,NULL,NULL,'Malmquist cor.','NGC 6925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147420,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147420,32.28,0.4,28.5,70139,75,NULL,NULL,'NGC 6925',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147421,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147421,32.29,0.47,28.7,70139,NULL,NULL,'H','NGC 6925',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147422,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147422,32.38,0.45,29.9,70139,NULL,NULL,'K','NGC 6925',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147423,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147423,32.44,0.39,30.8,70139,NULL,NULL,NULL,'NGC 6925',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147424,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147424,32.48,0.47,31.3,70139,75,NULL,'A82, H, raw','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147425,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147425,32.52,0.43,31.9,70139,75,NULL,'3.6 micron, color corrected','NGC 6925',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147426,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147426,32.6,0.49,33.1,70139,75,NULL,'IR','NGC 6925',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147427,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147427,32.71,0.4,34.8,70139,NULL,NULL,'mean','NGC 6925',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147428,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147428,32.71,0.47,34.8,70139,75,NULL,'A82, H, inv','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (147429,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147429,32.73,0.47,35.2,70139,75,NULL,'A82, H, cor','NGC 6925',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147430,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147430,32.82,0.4,36.6,70139,75,NULL,'B','NGC 6925',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147431,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147431,32.97,0.43,39.4,70139,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6925',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147432,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147432,36.43,0.71,194,70140,70,NULL,NULL,'2MASX J20342202-5459123',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'14.6R',0.27,NULL,NULL,NULL,NULL,NULL,1,308.591625,-54.98681,0.177,NULL,49004404805,765693825,11963966,14.6),(147433,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147433,36.11,0.7,167,70141,70,NULL,NULL,'2MASX J20342892-8340111',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,308.620375,-83.66969,0.413,NULL,48370108856,755782950,11809108,17.2),(147434,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147434,37.5,0.65,316,70142,70,NULL,NULL,'2MASX J20343166-5358233',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.9R',0.37,NULL,NULL,NULL,NULL,NULL,1,308.632,-53.97314,0.145,NULL,51083729840,798183278,12471613,14.9),(147435,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147435,36.92,0.71,242,70143,70,NULL,NULL,'FAIRALL 0546',NULL,'2014MNRAS.445.2677S',2014,1,0.54,'1983MNRAS.203...47F has V = 13,600? +- 100 km/s.','G',0.00015,NULL,'14.8R',0.39,NULL,NULL,NULL,NULL,NULL,1,308.649167,-47.55836,0.089,NULL,51074049570,798032024,12469250,14.8),(147436,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147436,35.09,0.49,104,70144,75,NULL,'IR','UGC 11594',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'15.6',0.2,'S',NULL,NULL,NULL,NULL,1,308.6505,12.94644,0.353,NULL,55251173227,863299581,13489055,15.6),(147437,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 18582',NULL,147437,39.73,0.19,884,70145,70,NULL,'SN photometric redshift distance, z photo =0.233 +/- 0.024','SDSS-II SN 18582',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,308.66625,-0.63136,0.445,NULL,47807592995,746993640,11671775,NULL),(147438,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147438,35.05,0.49,102,70146,75,NULL,'IR','UGC 11593 NED02',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00002,NULL,'15.0',0.1,'Sc','Pair member (points to parent)',NULL,NULL,NULL,1,308.6859583,7.98664,0.397,NULL,53982569776,843477652,13179338,15),(147439,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147439,35.96,0.59,156,70147,70,NULL,NULL,'2MASX J20344935-4606330',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.6b',0.25,NULL,NULL,NULL,NULL,NULL,1,308.705583,-46.10917,0.173,NULL,51377065872,802766654,12543228,16.6),(147440,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147440,28.85,NULL,5.9,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1997AstL...23..373S',1997,1,11.5,NULL,'G',0.000007,NULL,'8.23B',9.8,'SAB(rs)cd;Sy2  HII','Isolated galaxy',NULL,NULL,NULL,1,308.718,60.15392,1.613,NULL,53473738247,835527160,13055111,8.23),(147441,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147441,28.89,NULL,6,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2001bmya.meet...89P',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147442,'PNLF','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147442,28.92,0.21,6.08,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2008ApJ...683..630H',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147443,'SNII radio','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 1980K',NULL,147443,30.52,0.31,12.7,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1998ApJ...500...51W',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147444,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147444,29.14,0.05,6.72,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2014AstL...40..537T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147445,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147445,29.15,NULL,6.8,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2000A&A...362..544K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147446,'HII region diameter','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147446,31.11,NULL,16.7,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1988ApL&C..27...41S',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147447,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147447,28.02,0.5,4.02,70148,NULL,NULL,'EPM, H01','NGC 6946',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147448,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147448,28.17,0.55,4.31,70148,NULL,NULL,'SCM, I','NGC 6946',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147449,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147449,28.21,0.58,4.39,70148,NULL,NULL,'SCM, V','NGC 6946',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147450,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147450,28.27,0.07,4.51,70148,NULL,NULL,'SCM','NGC 6946',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147451,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147451,28.34,0.35,4.66,70148,NULL,NULL,'EPM, H01, fixed explosion epoch','NGC 6946',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147452,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147452,28.36,0.09,4.7,70148,NULL,NULL,'SEAM','NGC 6946',0.00016,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147453,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147453,28.37,0.31,4.72,70148,NULL,NULL,'SCM, BVI','NGC 6946',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147454,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147454,28.41,0.17,4.8,70148,NULL,NULL,'EPM','NGC 6946',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147455,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147455,28.41,0.26,4.8,70148,NULL,NULL,'EPM, expansion velocity modeled','NGC 6946',NULL,'2012MNRAS.419.2783T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147456,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 1980K',NULL,147456,28.49,NULL,5,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1988IAUS..129..175B',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147457,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147457,28.64,0.5,5.35,70148,NULL,NULL,'SCM, B','NGC 6946',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147458,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147458,28.65,0.08,5.37,70148,NULL,NULL,'V, photospheric magnitude method','NGC 6946',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147459,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147459,28.67,0.37,5.41,70148,NULL,NULL,'EPM, D05','NGC 6946',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147460,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147460,28.73,0.05,5.57,70148,NULL,NULL,'I, photospheric magnitude method','NGC 6946',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147461,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 1980K',NULL,147461,28.78,0.25,5.7,70148,NULL,NULL,NULL,'NGC 6946',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147462,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147462,28.78,NULL,5.7,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2006MNRAS.372.1315S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147463,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004et',NULL,147463,28.84,0.26,5.86,70148,NULL,NULL,'EPM, D05, fixed explosion epoch','NGC 6946',NULL,'2014ApJ...782...98B',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147464,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2002hh',NULL,147464,28.89,0.23,6,70148,NULL,NULL,'SEAM','NGC 6946',0.00016,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147465,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 1980K',NULL,147465,29.29,0.28,7.2,70148,NULL,NULL,'EPM','NGC 6946',NULL,'1992ApJ...395..366S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147466,'Sosies','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147466,28.73,0.68,5.57,70148,NULL,NULL,NULL,'NGC 6946',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147467,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147467,28.66,NULL,5.4,70148,75,NULL,'CO','NGC 6946',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147468,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147468,28.7,0.4,5.5,70148,NULL,18.45,'SN 1980K host','NGC 6946',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147469,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147469,28.7,NULL,5.5,70148,75,NULL,'HI','NGC 6946',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147470,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147470,28.7,0.4,5.5,70148,75,NULL,'B','NGC 6946',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147471,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147471,29.03,NULL,6.4,70148,NULL,NULL,'LEDA [April 2006]','NGC 6946',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147472,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147472,36.78,0.91,227,70149,70,NULL,NULL,'2MASX J20345244-4211100',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.7185,-42.18611,0.073,NULL,51387745412,802933522,12545836,14.8),(147473,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147473,31.63,0.43,21.2,70150,75,NULL,'3.6 micron, color + selection bias corrected','ESO 340- G 042',NULL,'2014MNRAS.444..527S',2014,1,1.5,'Gallagher et al. (1995, AJ, 109, 2003) also gives v=945 +/- 22 km/sec.','G',0.00003,NULL,'14.22',1.3,'SB(s)dm',NULL,NULL,NULL,NULL,1,308.7329583,-40.62414,0.073,NULL,51374094421,802720225,12542503,14.22),(147474,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147474,35.94,0.52,154,70151,70,NULL,NULL,'2MASX J20345841-4203355',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.743416667,-42.05983,0.073,NULL,51387753812,802933653,12545838,15.4),(147475,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147475,36.56,0.59,206,70152,70,NULL,NULL,'2MASX J20345920-6736343',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.7464583,-67.60958,0.125,NULL,49383110969,771611108,12056423,15),(147476,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147476,33.39,NULL,47.6,70153,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2277',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.00008,NULL,'16.4',0.11,'Sd',NULL,NULL,NULL,NULL,1,308.76,-7.61889,0.177,NULL,47822485409,747226334,11675411,16.4),(147477,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147477,33.41,NULL,48.1,70153,NULL,NULL,'Dipole + Quadrupole','FGC 2277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147478,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147478,33.43,NULL,48.6,70153,NULL,NULL,'Dipole','FGC 2277',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147479,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147479,33.48,NULL,49.7,70153,NULL,NULL,NULL,'FGC 2277',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147480,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147480,37.01,0.84,253,70154,70,NULL,NULL,'2MASX J20350264-7140353',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.7610417,-71.67653,0.157,NULL,49208834552,768888039,12013875,15.3),(147481,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147481,33.55,0.43,51.4,70155,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11595',NULL,'2014MNRAS.444..527S',2014,1,2.07,'The 2MASX position applies to the northern part of the galaxy.','G',0.000007,NULL,'15.25',0.22,'Sc',NULL,NULL,NULL,NULL,1,308.768667,1.93564,0.449,NULL,54014199121,843971861,13187060,15.25),(147482,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147482,33.63,0.49,53.3,70155,75,NULL,'IR','UGC 11595',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147483,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147483,33.7,0.43,54.9,70155,75,NULL,'3.6 micron, color corrected','UGC 11595',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147484,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147484,33.84,0.2,58.6,70155,74.4,NULL,NULL,'UGC 11595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147485,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147485,34.03,0.43,63.9,70155,NULL,NULL,NULL,'UGC 11595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147486,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147486,34.09,NULL,65.8,70155,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147487,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147487,34.1,NULL,66,70155,NULL,NULL,'Dipole','UGC 11595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147488,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147488,34.1,NULL,66.1,70155,NULL,NULL,'Dipole + Quadrupole','UGC 11595',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147489,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147489,34.16,NULL,68,70155,NULL,NULL,NULL,'UGC 11595',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147490,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147490,34.19,0.4,68.7,70155,NULL,NULL,'Malmquist cor.','UGC 11595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147491,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147491,34.36,0.45,74.4,70156,NULL,NULL,'K','ESO 340- G 043',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00005,NULL,'13.75',1.1,'SA(l)0^0',NULL,NULL,NULL,NULL,1,308.770041667,-41.68417,0.073,NULL,51385823803,802903496,12545367,13.75),(147492,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147492,34.38,0.4,75.2,70156,NULL,NULL,'mean','ESO 340- G 043',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147493,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004fu',NULL,147493,32.35,0.31,29.3,70157,74.2,NULL,'SALT 2','NGC 6949',0.0087,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.00003,NULL,'14.5',1.2,'Sc             HII','X-ray-faint group member',NULL,NULL,'H II',1,308.778833,64.80281,1.589,NULL,53644330115,838192658,13096760,14.5),(147494,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SN 2004fu',NULL,147494,32.93,0.1,38.6,70157,74.4,NULL,NULL,'NGC 6949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147495,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147495,32.94,0.4,38.8,70157,NULL,NULL,'mean','NGC 6949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147496,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147496,33.77,0.47,56.8,70157,NULL,NULL,'H','NGC 6949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147497,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147497,33.79,0.45,57.3,70157,NULL,NULL,'K','NGC 6949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147498,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147498,33.8,0.46,57.5,70157,NULL,NULL,'J','NGC 6949',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147499,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147499,35.62,0.73,133,70158,70,NULL,NULL,'2MASX J20350766-5318278',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.4R',0.2,NULL,NULL,NULL,NULL,NULL,1,308.781833,-53.30775,0.121,NULL,51084490162,798195158,12471799,15.4),(147500,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147500,36.2,0.63,174,70159,70,NULL,NULL,'FAIRALL 0073',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.3,'Bright nucleus',NULL,NULL,NULL,NULL,1,308.8037917,-57.98478,0.333,NULL,49001567278,765649488,11963273,14),(147501,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147501,34.44,0.4,77.1,70160,NULL,NULL,'mean','MCG -01-52-008',NULL,'2007A&A...465...71T',2007,1,2.11,NULL,'G',0.000017,NULL,'14.5',0.18,'Sd(f)',NULL,NULL,NULL,NULL,1,308.849083333,-6.24464,0.149,NULL,47821078373,747204349,11675067,14.5),(147502,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147502,34.5,0.49,79.4,70160,75,NULL,'IR','MCG -01-52-008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147503,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147503,34.59,0.47,82.7,70160,NULL,NULL,'H','MCG -01-52-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147504,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147504,34.62,0.39,84,70160,NULL,NULL,'Malmquist cor.','MCG -01-52-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147505,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147505,34.63,0.45,84.4,70160,NULL,NULL,'K','MCG -01-52-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147506,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147506,34.7,0.46,86.9,70160,NULL,NULL,'J','MCG -01-52-008',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147507,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147507,34.83,0.36,92.4,70160,NULL,NULL,NULL,'MCG -01-52-008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147508,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147508,34.87,0.2,94.2,70160,74.4,NULL,NULL,'MCG -01-52-008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147509,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147509,35.01,0.43,100,70160,75,NULL,'3.6 micron, color corrected','MCG -01-52-008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147510,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147510,35.03,0.43,101,70160,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-52-008',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147511,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147511,35.09,NULL,104,70160,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-52-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147512,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147512,35.1,NULL,105,70160,NULL,NULL,'Dipole + Quadrupole','MCG -01-52-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147513,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147513,35.11,NULL,105,70160,NULL,NULL,'Dipole','MCG -01-52-008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147514,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147514,36.31,0.82,183,70161,70,NULL,NULL,'2MASX J20352499-4346165',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.3R',0.19,NULL,NULL,NULL,NULL,NULL,1,308.85425,-43.77122,0.101,NULL,51386780974,802918452,12545600,15.3),(147515,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147515,36.22,0.55,175,70162,70,NULL,NULL,'2MASX J20352707-7507369',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,308.863083,-75.12689,0.289,NULL,48489171597,757643306,11838176,16.6),(147516,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147516,37.95,0.33,389,70163,70,NULL,NULL,'2MASX J20353144-0631337',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,308.881125,-6.52614,0.133,NULL,47820981666,747202838,11675044,17.3),(147517,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147517,35.43,0.49,122,70164,70,NULL,NULL,'MCG -07-42-014',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000097,NULL,'15',0.8,'SAB0^0^ pec;D/cD',NULL,NULL,NULL,NULL,1,308.881833,-43.43864,0.081,NULL,51387871281,802935488,12545867,15),(147518,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147518,35.41,0.49,121,70165,75,NULL,'IR','ESO 285- G 038',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.43',0.3,'Sb? sp',NULL,NULL,NULL,NULL,1,308.896833,-44.37528,0.077,NULL,51379436716,802803698,12543807,15.43),(147519,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147519,35.44,0.48,123,70165,NULL,NULL,'Malmquist cor.','ESO 285- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147520,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147520,35.58,0.45,131,70165,NULL,NULL,NULL,'ESO 285- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147521,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147521,35.62,0.2,133,70165,74.4,NULL,NULL,'ESO 285- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147522,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147522,36.76,0.46,225,70166,70,NULL,NULL,'2MASX J20353615-0532289',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000082,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,308.900833,-5.54122,0.169,NULL,47838974701,747483979,11679437,17),(147523,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147523,34.98,0.69,99,70167,NULL,NULL,NULL,'ESO 285- G 039',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.69',0.6,'Sb',NULL,NULL,NULL,NULL,1,308.914125,-43.60883,0.073,NULL,51387837501,802934960,12545858,15.69),(147524,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147524,35.02,0.2,101,70167,74.4,NULL,NULL,'ESO 285- G 039',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147525,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147525,35.01,0.68,101,70167,NULL,NULL,'Malmquist cor.','ESO 285- G 039',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147526,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147526,36.15,0.69,170,70168,70,NULL,NULL,'2MASX J20353946-5542242',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.1R',0.16,NULL,NULL,NULL,NULL,NULL,1,308.914333333,-55.70672,0.205,NULL,49004825612,765700400,11964068,15.1),(147527,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147527,37.95,0.33,389,70169,70,NULL,NULL,'SDSS J203542.04-063538.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000085,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,308.925167,-6.59392,0.133,NULL,47823029543,747234836,11675544,18.4),(147528,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147528,36.87,0.71,236,70170,70,NULL,NULL,'2MASX J20355373-6503361',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.9739583,-65.06008,0.125,NULL,49370121805,771408153,12053252,15.1),(147529,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147529,35.37,0.56,119,70171,70,NULL,NULL,'2MASX J20355445-5225450',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,308.976917,-52.42919,0.021,NULL,51085740940,798214702,12472104,15.4),(147530,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147530,36.29,0.54,181,70172,70,NULL,NULL,'2MASX J20355560-4836380',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.000103,NULL,'16.6b',0.15,NULL,NULL,NULL,NULL,NULL,1,308.981667,-48.61056,0.073,NULL,51074931654,798045807,12469465,16.6),(147531,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147531,33.08,0.5,41.2,70173,70,NULL,NULL,'ESO 186- G 065',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000087,NULL,'14.10',0.4,'S0-: sp',NULL,NULL,NULL,NULL,1,308.9885417,-54.29947,0.133,NULL,51071984945,797999764,12468746,14.1),(147532,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147532,36.31,0.79,183,70174,70,NULL,NULL,'2MASX J20355745-4436148',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'15.0R',0.33,NULL,NULL,NULL,NULL,NULL,1,308.989375,-44.60411,0.069,NULL,51379353483,802802398,12543787,15),(147533,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147533,34.94,0.5,97.2,70175,70,NULL,NULL,'ESO 234- G 051',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000093,NULL,'13.77',1,'SA0- pec?',NULL,NULL,NULL,NULL,1,308.991167,-49.60422,0,NULL,51077648292,798088254,12470128,13.77),(147534,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147534,36.83,0.66,233,70176,70,NULL,NULL,'2MASX J20360252-4205088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000133,NULL,'15.6',NULL,NULL,NULL,NULL,NULL,NULL,1,309.0104583,-42.08586,0.073,NULL,51387708572,802932946,12545827,15.6),(147535,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147535,36.22,0.51,175,70177,70,NULL,NULL,'2MASX J20360810-5255290',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.033833333,-52.92475,0.089,NULL,51083847798,798185121,12471642,16.2),(147536,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,'R',147536,33.84,0.49,58.6,70178,75,NULL,'IR','UGC 11603',NULL,'2011yCatp016004901K',2011,1,1.46,NULL,'G',0.000053,NULL,'17.',0.17,'Sc',NULL,NULL,NULL,NULL,1,309.0572917,63.73989,1.533,NULL,53462257806,835347778,13052309,17),(147537,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147537,33.89,0.43,60,70178,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11603',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147538,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147538,34.51,0.4,79.9,70178,NULL,NULL,'mean','UGC 11603',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147539,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147539,34.71,0.47,87.3,70178,NULL,NULL,'H','UGC 11603',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147540,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147540,34.87,NULL,94.3,70178,NULL,NULL,'Dipole','UGC 11603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147541,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147541,34.88,NULL,94.7,70178,NULL,NULL,'Dipole + Quadrupole','UGC 11603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147542,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147542,34.88,NULL,94.8,70178,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11603',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147543,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147543,34.06,0.69,64.7,70179,100,NULL,'mid-IR','NGC 6941',NULL,'2013ApJ...771...88L',2013,1,1.78,NULL,'G',0.000027,NULL,'13.6g',1.1,'SAB(rs)b',NULL,NULL,NULL,NULL,1,309.097791667,-4.61875,0.173,NULL,47839220152,747487814,11679497,13.6),(147544,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147544,34.36,0.47,74.3,70179,NULL,NULL,'H','NGC 6941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147545,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147545,34.36,0.45,74.5,70179,NULL,NULL,'K','NGC 6941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147546,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147546,34.38,0.46,75.3,70179,NULL,NULL,'J','NGC 6941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147547,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147547,34.61,0.4,83.7,70179,NULL,NULL,'mean','NGC 6941',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147548,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147548,33.67,0.47,54.1,70180,70,NULL,NULL,'ESO 234- G 053',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00009,NULL,'14.32',0.5,'S0',NULL,NULL,NULL,NULL,1,309.104291667,-49.25906,0.009,NULL,51077560853,798086888,12470107,14.32),(147549,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:06','1','SDSS-II SN 05359',NULL,147549,40.55,0.37,1290,70181,70,NULL,'SN photometric redshift distance, z photo =0.363 +/- 0.087','SDSS-II SN 05359',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.105125,0.50767,0.309,NULL,54010207076,843909485,13186085,NULL),(147550,'FP','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147550,35.49,0.48,125,70182,70,NULL,NULL,'ESO 234- G 052',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.84',0.5,'S0-: pec',NULL,NULL,NULL,NULL,1,309.113416667,-52.2845,0.021,NULL,51085671845,798213622,12472087,14.84),(147551,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147551,33.41,0.47,48.1,70183,NULL,NULL,'H','UGC 11599',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000013,NULL,'13.47',1.9,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,309.1409583,11.49469,0.369,NULL,55065585234,860399769,13443746,13.47),(147552,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147552,33.43,0.45,48.6,70183,NULL,NULL,'K','UGC 11599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147553,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:06','1',NULL,NULL,147553,33.48,0.46,49.6,70183,NULL,NULL,'J','UGC 11599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147554,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147554,33.81,0.4,57.9,70183,NULL,NULL,'mean','UGC 11599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147555,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147555,33.97,0.43,62.4,70183,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11599',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147556,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147556,35.66,0.53,136,70184,70,NULL,NULL,'ESO 143- G 035',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000133,NULL,'15.02',0.6,'S0',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,309.1440417,-57.62325,0.321,NULL,48999613127,765618955,11962796,15.02),(147557,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147557,36.67,0.58,215,70185,70,NULL,NULL,'2MASX J20364464-5437368',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.0R',0.18,NULL,NULL,NULL,NULL,NULL,1,309.186083,-54.62686,0.141,NULL,48990555179,765477424,11960584,15),(147558,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147558,34.7,0.8,87.1,70186,75,NULL,'MAT, I','ESO 285- G 040',NULL,'1997ApJS..109..333W',1997,1,2.74,NULL,'G',0.000033,NULL,'15.15',0.39,'Sb',NULL,NULL,NULL,NULL,1,309.197125,-45.30811,0.089,NULL,51379879537,802810617,12543915,15.15),(147559,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147559,34.78,NULL,90.3,70186,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 285- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147560,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147560,34.79,NULL,90.6,70186,NULL,NULL,'Dipole','ESO 285- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147561,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147561,34.79,NULL,90.6,70186,NULL,NULL,'Dipole + Quadrupole','ESO 285- G 040',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147562,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147562,34.84,NULL,92.7,70186,NULL,NULL,NULL,'ESO 285- G 040',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147563,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147563,34.9,0.4,95.6,70186,NULL,NULL,'mean','ESO 285- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147564,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147564,35.23,0.49,111,70186,75,NULL,'IR','ESO 285- G 040',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147565,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147565,35.28,0.43,114,70186,75,NULL,'MAT, I, raw','ESO 285- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147566,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147566,35.33,0.47,117,70186,NULL,NULL,'H','ESO 285- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147567,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147567,35.4,0.45,120,70186,NULL,NULL,'K','ESO 285- G 040',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147568,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147568,35.44,0.32,122,70186,85,NULL,'I, raw','ESO 285- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147569,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147569,35.51,0.32,126,70186,85,NULL,'I, inv','ESO 285- G 040',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147570,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147570,35.51,0.43,127,70186,75,NULL,'MAT, I, cor','ESO 285- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147571,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147571,35.59,0.36,131,70186,NULL,NULL,'Malmquist cor.','ESO 285- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147572,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147572,35.59,0.43,131,70186,75,NULL,'MAT, I, inv','ESO 285- G 040',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147573,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147573,35.75,0.33,141,70186,NULL,NULL,NULL,'ESO 285- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147574,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147574,35.79,0.2,144,70186,74.4,NULL,NULL,'ESO 285- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147575,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17605','R',147575,39.16,0.14,592,70187,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007js','SN 2007js',0.14643,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,309.202791667,0.09844,0.381,NULL,53993336981,843645890,13181967,NULL),(147576,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17605','R',147576,39.25,0.22,618,70187,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007js','SN 2007js',0.14643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147577,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03118',NULL,147577,39.77,0.18,901,70188,70,NULL,'SN photometric redshift distance, z photo =0.238 +/- 0.024','SDSS-II SN 03118',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.209167,1.06467,0.313,NULL,54011066129,843922908,13186295,NULL),(147578,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147578,36.54,0.87,203,70189,70,NULL,NULL,'2MASX J20365747-5147092',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.0R',0.31,NULL,NULL,NULL,NULL,NULL,1,309.239417,-51.78592,0.009,NULL,51084867516,798201054,12471891,15),(147579,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147579,37.43,0.46,306,70190,70,NULL,NULL,'2MASX J20365847-0508239',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000072,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,309.2437083,-5.14014,0.177,NULL,47840137988,747502156,11679721,17.9),(147580,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147580,36.56,0.5,205,70191,70,NULL,NULL,'ESO 186-IG 069 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3b',NULL,'S0 pec',NULL,NULL,NULL,NULL,1,309.3010417,-54.65178,0.141,NULL,48990736244,765480253,11960628,15.3),(147581,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147581,31.31,0.17,18.3,70192,70.8,NULL,NULL,'NGC 6951',NULL,'2008MNRAS.389.1577T',2008,1,3.9,NULL,'G',0.000005,NULL,'10.0B',3.2,'SAB(rs)bc;LINERSy2','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,309.3087083,66.10564,0.877,NULL,53649556515,838274320,13098036,10),(147582,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147582,31.37,0.1,18.8,70192,74.4,NULL,NULL,'NGC 6951',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147583,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147583,31.61,0.04,20.9,70192,72,NULL,NULL,'NGC 6951',0.00475,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147584,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147584,31.72,0.11,21.9,70192,65,NULL,'MLCS2k2','NGC 6951',0.00475,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147585,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147585,31.79,0.22,22.7,70192,72,NULL,NULL,'NGC 6951',0.00475,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147586,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147586,31.84,0.19,23.2,70192,72,NULL,NULL,'NGC 6951',0.00475,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147587,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147587,31.83,0.03,23.3,70192,72,NULL,'M(H) = -18.317 mag','NGC 6951',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147588,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147588,31.89,0.07,23.8,70192,72,NULL,NULL,'NGC 6951',0.00475,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147589,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E','R',147589,31.89,NULL,23.9,70192,62.3,NULL,NULL,'NGC 6951',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147590,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147590,31.98,0.14,24.9,70192,60,NULL,NULL,'NGC 6951',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147591,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147591,32.14,0.21,26.8,70192,55,NULL,NULL,'NGC 6951',NULL,'2003ApJ...595..779V',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147592,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2000E',NULL,147592,32.59,0.47,33,70192,NULL,NULL,'MLCS','NGC 6951',NULL,'2001A&A...372..824V',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147593,'HII region diameter','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147593,31.93,0.18,24.3,70192,NULL,NULL,NULL,'NGC 6951',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147594,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147594,31.05,0.43,16.2,70192,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6951',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147595,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147595,31.91,0.4,24.1,70192,75,NULL,'B','NGC 6951',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147596,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147596,35.75,0.61,141,70193,70,NULL,NULL,'2MASX J20372217-7408382',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.3424583,-74.144,0.209,NULL,48490090412,757657662,11838400,16.2),(147597,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147597,37.05,0.52,257,70194,70,NULL,NULL,'2MASX J20372748-4438353',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.3R',0.22,NULL,NULL,NULL,NULL,NULL,1,309.364583,-44.64311,0.069,NULL,51379317477,802801835,12543778,15.3),(147598,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147598,37.06,0.46,258,70195,70,NULL,NULL,'2MASX J20373439-0438000',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000081,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,309.393333,-4.63344,0.173,NULL,47839342005,747489718,11679526,16.5),(147599,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147599,35.79,0.73,144,70196,70,NULL,NULL,'2MASX J20373908-0303330',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.36',0.4,NULL,NULL,NULL,NULL,NULL,1,309.412875,-3.05914,0.257,NULL,47844500608,747570322,11680786,16.36),(147600,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147600,35.41,0.45,121,70197,NULL,NULL,NULL,'ESO 597- G 017',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.30',0.8,'Sc',NULL,NULL,NULL,NULL,1,309.421125,-21.60675,0.145,NULL,50824379995,794130937,12408295,14.3),(147601,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147601,35.45,0.2,123,70197,74.4,NULL,NULL,'ESO 597- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147602,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147602,35.49,0.43,126,70197,NULL,NULL,'Malmquist cor.','ESO 597- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147603,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147603,37.38,0.61,299,70198,70,NULL,NULL,'2MASX J20374210-0144200',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'14.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,309.425417,-1.73886,0.341,NULL,47843683771,747557558,11680586,14),(147604,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147604,37.24,0.75,281,70199,70,NULL,NULL,'2MASX J20374354-7812199',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.431166667,-78.20556,0.473,NULL,48581334340,759083349,11860677,17),(147605,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147605,36.4,0.54,191,70200,70,NULL,NULL,'2MASX J20374472-1552306',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.05',0.4,NULL,NULL,NULL,NULL,NULL,1,309.436375,-15.87525,0.145,NULL,50976368923,796505764,12445402,16.05),(147606,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01783',NULL,147606,39.98,0.3,992,70201,70,NULL,'SN photometric redshift distance, z photo =0.266 +/- 0.048','SDSS-II SN 01783',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.438375,-0.62797,0.389,NULL,47840422708,747506604,11679790,NULL),(147607,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147607,35.08,0.49,104,70202,75,NULL,'IR','FGC 2280',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00005,NULL,'15.9',0.17,'Scd',NULL,NULL,NULL,NULL,1,309.447666667,-3.18533,0.257,NULL,47844556797,747571199,11680799,15.9),(147608,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147608,35.4,NULL,120,70202,NULL,NULL,'Dipole + Quadrupole','FGC 2280',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147609,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147609,35.4,NULL,121,70202,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2280',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147610,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147610,35.41,NULL,121,70202,NULL,NULL,'Dipole','FGC 2280',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147611,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147611,35.46,NULL,123,70202,NULL,NULL,NULL,'FGC 2280',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147612,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147612,35.71,0.66,138,70203,70,NULL,NULL,'2MASX J20375204-0156290',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,309.466875,-1.94147,0.353,NULL,47842823285,747544113,11680376,15),(147613,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12779','R',147613,37.88,0.2,348,70204,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fd','SN 2006fd',0.079948,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,309.471875,1.22114,0.301,NULL,54010538113,843914658,13186166,NULL),(147614,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12779','R',147614,38.18,0.11,400,70204,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fd','SN 2006fd',0.079948,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147615,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147615,35.9,0.56,151,70205,70,NULL,NULL,'2MASX J20380766-5134205',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.6I',0.5,NULL,NULL,NULL,NULL,NULL,1,309.532041667,-51.57233,0.021,NULL,51084883139,798201299,12471895,13.6),(147616,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147616,37.07,0.62,260,70206,70,NULL,NULL,'2MASX J20380809-5510365',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.5337083,-55.17683,0.181,NULL,48991441544,765491274,11960801,17),(147617,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147617,32.97,0.8,39.3,70207,75,NULL,'MAT, I','IC 5023',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.17',0.5,'S(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,309.544667,-67.18464,0.133,NULL,49382648346,771603880,12056310,14.17),(147618,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147618,33.37,0.32,47.3,70207,85,NULL,'I, raw','IC 5023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147619,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147619,33.42,0.32,48.3,70207,85,NULL,'I, inv','IC 5023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147620,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147620,33.46,0.43,49.2,70207,75,NULL,'MAT, I, raw','IC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147621,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147621,33.6,0.43,52.5,70207,75,NULL,'MAT, I, cor','IC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147622,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147622,33.66,0.43,54,70207,75,NULL,'MAT, I, inv','IC 5023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147623,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147623,33.75,0.33,56.2,70207,NULL,NULL,'Malmquist cor.','IC 5023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147624,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147624,34.03,0.29,63.9,70207,NULL,NULL,NULL,'IC 5023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147625,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147625,34.07,0.2,65.2,70207,74.4,NULL,NULL,'IC 5023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147626,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147626,36.31,0.82,182,70208,70,NULL,NULL,'2MASX J20381412-1556161',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,309.558875,-15.93786,0.145,NULL,50976491355,796507677,12445432,14.6),(147627,'Ring Diameter','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147627,32.6,0.84,33,70209,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6935',NULL,'1981ApJS...45..541P',1981,1,2,NULL,'G',0.00006,NULL,'12.80',1.7,'(R)SA(r)a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,309.58425,-52.11044,0.021,NULL,51085242313,798206911,12471982,12.8),(147628,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147628,33.01,0.51,40,70209,70,NULL,NULL,'NGC 6935',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147629,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147629,35.09,0.49,104,70210,75,NULL,'IR','ESO 463- G 010',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.000033,NULL,'15.13',0.5,'SB(s)c',NULL,NULL,NULL,NULL,1,309.5960417,-31.92178,0.197,NULL,51313268303,801769817,12527653,15.13),(147630,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147630,35.11,0.56,105,70210,NULL,NULL,'Malmquist cor.','ESO 463- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147631,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147631,35.25,0.53,112,70210,NULL,NULL,NULL,'ESO 463- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147632,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147632,35.29,0.2,114,70210,74.4,NULL,NULL,'ESO 463- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147633,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147633,33.28,0.44,45.3,70211,95,NULL,'Weighted Mean','NGC 6944',NULL,'1984ApJS...56...91D',1984,1,1.5,NULL,'G',0.00012,NULL,'14.79',0.6,'S0-:','in a pair',NULL,NULL,NULL,1,309.599417,6.99644,0.409,NULL,53981042502,843453789,13178965,14.79),(147634,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147634,33.68,0.46,54.5,70211,95,NULL,'Michard 1979a','NGC 6944',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147635,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147635,33.88,0.63,59.7,70211,95,NULL,'Michard 1979b, c','NGC 6944',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147636,'Tertiary','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147636,33.25,0.5,44.7,70211,95,NULL,NULL,'NGC 6944',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147637,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147637,35.89,0.5,151,70212,70,NULL,NULL,'AM 2035-441',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5R',0.31,NULL,NULL,NULL,NULL,NULL,1,309.616375,-44.05156,0.073,NULL,51377588728,802774823,12543356,14.5),(147638,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 11098',NULL,147638,40.45,0.17,1230,70213,70,NULL,'SN photometric redshift distance, z photo =0.343 +/- 0.034','SDSS-II SN 11098',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,309.636666667,1.20825,0.361,NULL,53964458896,843194670,13174916,21.2),(147639,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01906','RN',147639,39.75,0.24,744,70214,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01906',0.20023,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147640,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01906','RN',147640,39.82,0.27,768,70214,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01906',0.20023,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147641,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147641,35.14,0.64,107,70215,70,NULL,NULL,'2MASX J20383584-1527541',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.85',NULL,NULL,NULL,NULL,NULL,NULL,1,309.6495,-15.46492,0.137,NULL,50984315159,796629924,12447342,15.85),(147642,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147642,35.9,0.51,151,70216,70,NULL,NULL,'2MASX J20383916-2029027',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.70',NULL,NULL,NULL,NULL,NULL,NULL,1,309.663167,-20.48425,0.117,NULL,50826102515,794157851,12408716,15.7),(147643,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2006ex',NULL,147643,39.01,0.09,634,70217,70,NULL,'Hubble residual 0.17 for z0.14749','SDSS-II SN 12930 HOST',NULL,'2011ApJ...740...92G',2011,1,0.24,NULL,'G',0.00017,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,309.682667,-0.47639,0.333,NULL,47785800081,746653126,11666455,18.1),(147644,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12930','R',147644,39.43,0.21,670,70217,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ex','SDSS-II SN 12930 HOST',0.14749,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147645,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12930','R',147645,39.7,0.12,759,70217,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ex','SDSS-II SN 12930 HOST',0.14749,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147646,'GRB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147646,42.89,NULL,3790,70218,70,NULL,'Pseudo z = 3.03','GRB 020812',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,309.7,-5.38333,0.125,NULL,47839511940,747492374,11679568,NULL),(147647,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147647,36.58,0.46,207,70219,70,NULL,NULL,'2MASX J20384933+0041269',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000174,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,309.7055,0.69081,0.317,NULL,53964822370,843200349,13175005,16.3),(147648,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'N',147648,21.65,0.16,0.214,70220,NULL,NULL,'If object = GC, ID = DESJ0002_6051','Tucana IV',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147649,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147649,36.32,0.81,184,70221,70,NULL,NULL,'2MASX J20385336-4340164',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.5R',0.2,NULL,NULL,NULL,NULL,NULL,1,309.722333,-43.67131,0.073,NULL,51385188345,802893567,12545211,15.5),(147650,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13996',NULL,147650,40.29,0.21,1140,70222,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.039','SDSS-II SN 13996',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.5g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.7255417,-0.06594,0.325,NULL,47785920886,746655013,11666484,22.5),(147651,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147651,35.51,0.44,127,70223,NULL,NULL,'Malmquist cor.','ESO 285- G 041',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.44',0.5,'SA(rs)d:',NULL,NULL,NULL,NULL,1,309.72575,-43.38375,0.077,NULL,51385163927,802893186,12545206,15.44),(147652,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147652,35.62,0.42,133,70223,NULL,NULL,NULL,'ESO 285- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147653,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147653,35.66,0.2,136,70223,74.4,NULL,NULL,'ESO 285- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147654,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147654,32.96,NULL,39.2,70224,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','MCG -01-52-016',NULL,'2011A&A...531A..87I',2011,1,2.61,NULL,'G',0.00002,NULL,'13.6g',0.64,'(R\')Sa:',NULL,NULL,NULL,NULL,1,309.7270417,-5.64,0.121,NULL,47836756555,747449321,11678895,13.6),(147655,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147655,32.96,NULL,39.2,70224,70,NULL,'H, 2MASS, Malmquist corr.','MCG -01-52-016',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147656,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147656,33.12,0.33,42.1,70224,70,NULL,'H, UH88/IRSF/2MASS','MCG -01-52-016',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147657,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147657,33.12,0.33,42.1,70224,70,NULL,'H, 2MASS','MCG -01-52-016',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147658,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147658,33.17,0.47,43.1,70224,NULL,NULL,'H','MCG -01-52-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147659,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147659,33.19,0.45,43.4,70224,NULL,NULL,'K','MCG -01-52-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147660,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147660,33.2,0.43,43.6,70224,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-52-016',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147661,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147661,33.23,0.46,44.2,70224,NULL,NULL,'J','MCG -01-52-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147662,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147662,33.44,0.4,48.9,70224,NULL,NULL,'mean','MCG -01-52-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147663,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147663,35.65,0.63,135,70225,70,NULL,NULL,'FAIRALL 0550',NULL,'2014MNRAS.445.2677S',2014,1,0.33,'1983MNRAS.203...47F has V = 14700? +- 100 km/s.','G',0.00015,NULL,'15.2R',0.27,'(R_1R\'_2)SB(s)a',NULL,NULL,NULL,NULL,1,309.730167,-57.21844,0.321,NULL,48999867640,765622931,11962858,15.2),(147664,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147664,35.59,0.56,131,70226,70,NULL,NULL,'2MASX J20385712-2244116',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.13',0.5,NULL,NULL,NULL,NULL,NULL,1,309.737917,-22.73675,0.169,NULL,50831558932,794243108,12410048,16.13),(147665,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147665,38.29,0.46,455,70227,70,NULL,NULL,'SDSS J203859.72+005623.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000163,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,309.748833,0.93983,0.361,NULL,53964525679,843195713,13174933,18.5),(147666,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147666,33.13,0.45,42.2,70228,NULL,NULL,'K','NGC 6945',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000033,NULL,'13.26',0.9,'S0-',NULL,NULL,NULL,NULL,1,309.752583,-4.97258,0.137,NULL,47839873316,747498020,11679656,13.26),(147667,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147667,33.45,0.4,48.9,70228,NULL,NULL,'mean','NGC 6945',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147668,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147668,35.66,0.35,136,70229,NULL,NULL,'Malmquist cor.','ESO 597- G 020',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.00002,NULL,'15',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,309.7800417,-20.24083,0.121,NULL,50822666297,794104160,12407877,15),(147669,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147669,35.87,0.32,149,70229,NULL,NULL,NULL,'ESO 597- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147670,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147670,35.91,0.2,152,70229,74.4,NULL,NULL,'ESO 597- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147671,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147671,36.38,0.78,189,70230,70,NULL,NULL,'2MASX J20390910-2119078',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.42',0.4,NULL,NULL,NULL,NULL,NULL,1,309.788041667,-21.31892,0.129,NULL,50823765827,794121341,12408145,16.42),(147672,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147672,37.12,0.52,266,70231,70,NULL,NULL,'2MASX J20391420-4342164',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,309.809083,-43.70467,0.061,NULL,51385178172,802893408,12545209,14.6),(147673,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147673,37.63,0.46,335,70232,70,NULL,NULL,'2MASX J20392006-0601068',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000107,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,309.83375,-6.01861,0.173,NULL,47836686346,747448224,11678878,17.1),(147674,'BL Lac Luminosity','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147674,39.28,NULL,682,70233,NULL,NULL,NULL,'2MASX J20392354+5219498',0.053,'2005ApJ...635..173S',2005,1,NULL,NULL,'G',NULL,NULL,'19.0V',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac ?',1,309.848041667,52.33058,NULL,NULL,54909187426,857956053,13405563,19),(147675,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 04907',NULL,147675,40.58,0.16,1310,70234,70,NULL,'SN photometric redshift distance, z photo =0.370 +/- 0.037','SDSS-II SN 04907',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.4g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,309.858625,-0.11419,0.337,NULL,47785899835,746654684,11666479,22.4),(147676,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147676,37.04,0.46,255,70235,70,NULL,NULL,'2MASX J20393230-0609568',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,309.884625,-6.16575,0.173,NULL,47819656259,747182129,11674720,17),(147677,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147677,36.1,0.5,166,70236,70,NULL,NULL,'2MASX J20393289-5306039',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,309.886958333,-53.10108,0.105,NULL,51072492329,798007692,12468870,14),(147678,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147678,35.61,0.43,132,70237,NULL,NULL,'Malmquist cor.','ESO 463- G 014',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,309.8934583,-28.48883,0.325,NULL,51321013893,801890842,12529544,14),(147679,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147679,35.72,0.41,139,70237,NULL,NULL,NULL,'ESO 463- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147680,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147680,35.72,0.47,139,70237,NULL,NULL,'H','ESO 463- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147681,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147681,35.76,0.2,142,70237,74.4,NULL,NULL,'ESO 463- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147682,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147682,35.77,0.4,143,70237,NULL,NULL,'mean','ESO 463- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147683,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147683,35.84,0.45,147,70237,NULL,NULL,'K','ESO 463- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147684,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147684,35.87,0.46,149,70237,NULL,NULL,'J','ESO 463- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147685,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147685,35.86,0.82,148,70238,70,NULL,NULL,'2MASX J20393526-5102559',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'14.9R',0.25,NULL,NULL,NULL,NULL,NULL,1,309.897083,-51.04892,0.017,NULL,51084920404,798201881,12471904,14.9),(147686,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147686,36.69,0.71,217,70239,70,NULL,NULL,'2MASX J20393610-5301009',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,309.900333333,-53.01683,0.077,NULL,51083747664,798183557,12471618,16.9),(147687,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147687,35.12,0.46,106,70240,70,NULL,NULL,'2MASX J20393782-0625228',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000081,NULL,'15.8g',0.29,'S0',NULL,NULL,NULL,NULL,1,309.907625,-6.42289,0.177,NULL,47820220616,747190947,11674858,15.8),(147688,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147688,38.03,0.46,403,70241,70,NULL,NULL,'2MASX J20394005-0544425',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000123,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,309.9167083,-5.74519,0.169,NULL,47836924410,747451943,11678936,16.6),(147689,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147689,34.57,0.49,82,70242,75,NULL,'IR','2MFGC 15660',NULL,'2011yCatp016004901K',2011,1,NULL,'This is the northeastern end of CGCG 424-037.','PofG',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,309.92975,13.96389,0.429,NULL,55263118665,863486229,13491972,NULL),(147690,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147690,32.41,0.4,30.3,70243,75,NULL,NULL,'UGC 11613',NULL,'2008Ap.....51..336K',2008,1,1.85,NULL,'G',0.000007,NULL,'17.',0.17,'Sdm','X-ray-faint group member',NULL,NULL,NULL,1,309.934125,63.59828,1.761,NULL,53464370882,835380795,13052824,17),(147691,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147691,32.72,0.43,34.9,70243,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11613',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147692,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147692,32.75,0.49,35.5,70243,75,NULL,'IR','UGC 11613',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147693,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147693,32.77,0.2,35.8,70243,74.4,NULL,NULL,'UGC 11613',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147694,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147694,32.84,0.43,37,70243,75,NULL,'3.6 micron, color corrected','UGC 11613',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147695,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147695,33.38,NULL,47.5,70243,NULL,NULL,'Dipole','UGC 11613',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147696,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147696,33.39,NULL,47.6,70243,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11613',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147697,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147697,33.39,NULL,47.7,70243,NULL,NULL,'Dipole + Quadrupole','UGC 11613',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147698,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12964','RN',147698,40.06,0.25,844,70244,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12964',0.2167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147699,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12964','RN',147699,40.3,0.2,942,70244,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12964',0.2167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147700,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147700,35.47,0.54,124,70245,70,NULL,NULL,'2MASX J20395411-2136139',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.31',NULL,NULL,NULL,NULL,NULL,NULL,1,309.975625,-21.60372,0.129,NULL,50823937421,794124022,12408187,16.31),(147701,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147701,36.01,0.57,160,70246,70,NULL,NULL,'2MASX J20400667-4255341',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.6I',0.4,NULL,NULL,NULL,NULL,NULL,1,310.02775,-42.92619,0.057,NULL,51384752527,802886758,12545105,13.6),(147702,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 08188','RN',147702,42.55,0.2,2290,70247,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08188',0.41524,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147703,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 08188','RN',147703,42.75,0.25,2500,70247,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08188',0.41524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147704,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147704,36.92,0.63,242,70248,70,NULL,NULL,'2MASX J20400936-2048053',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.0389583,-20.80144,0.117,NULL,50826136606,794158384,12408724,15.6),(147705,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147705,37.08,0.46,260,70249,70,NULL,NULL,'2MASX J20401197-0555468',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000128,NULL,'16.1g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,310.05,-5.92956,0.169,NULL,47836893594,747451462,11678929,16.1),(147706,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147706,33.8,0.22,57.5,70250,NULL,NULL,'B, Hubble-type-TF','ESO 234- G 061',NULL,'2005Ap&SS.298..577R',2005,1,0.96,'Star superposed on western side.','G',0.000033,NULL,'16.83',0.11,'Sc',NULL,NULL,NULL,NULL,1,310.055833,-50.79611,0.009,NULL,51077048915,798078889,12469982,16.83),(147707,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147707,34.77,NULL,89.8,70250,NULL,NULL,NULL,'ESO 234- G 061',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147708,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147708,34.8,NULL,91,70250,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 234- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147709,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147709,34.84,NULL,93,70250,NULL,NULL,'Dipole + Quadrupole','ESO 234- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147710,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147710,34.87,NULL,94,70250,NULL,NULL,'Dipole','ESO 234- G 061',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147711,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147711,34.99,0.69,99.5,70250,NULL,NULL,'Malmquist cor.','ESO 234- G 061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147712,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147712,35,0.68,100,70250,NULL,NULL,NULL,'ESO 234- G 061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147713,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147713,35.04,0.2,102,70250,74.4,NULL,NULL,'ESO 234- G 061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147714,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147714,35.75,0.51,141,70251,70,NULL,NULL,'2MASX J20401714-2246543',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,'(R)SA0^+?',NULL,NULL,NULL,NULL,1,310.071417,-22.78172,0.169,NULL,50834711123,794292361,12410818,14.9),(147715,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147715,35.59,0.7,131,70252,70,NULL,NULL,'ESO 186- G 072',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.93',0.2,'Sa:',NULL,NULL,NULL,NULL,1,310.077041667,-53.53236,0.117,NULL,51072673970,798010530,12468914,15.93),(147716,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147716,40.72,0.15,1020,70253,74.2,NULL,'SALT 2','SDSS J204019.15-000022.9',0.37,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'22.5g',0.03,NULL,NULL,NULL,NULL,NULL,1,310.0797917,-0.00639,0.337,NULL,47786295320,746660864,11666576,22.5),(147717,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147717,40.83,0.04,1070,70253,70,NULL,'SDSS-II SN 07779','SDSS J204019.15-000022.9',0.37,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147718,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147718,41.42,0.15,1410,70253,65,NULL,'SALT2','SDSS J204019.15-000022.9',0.37,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147719,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147719,41.46,0.16,1430,70253,70,NULL,'SDSS-II SN 07779, SALT 2','SDSS J204019.15-000022.9',0.37,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147720,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 07779','R',147720,41.58,0.23,1510,70253,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jw','SDSS J204019.15-000022.9',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147721,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005jw',NULL,147721,41.6,0.1,1530,70253,65,NULL,'MLCS2k2','SDSS J204019.15-000022.9',0.37,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147722,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 07779','R',147722,41.61,0.13,1530,70253,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jw','SDSS J204019.15-000022.9',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147723,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147723,36.12,0.6,168,70254,70,NULL,NULL,'2MFGC 15667',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.081083333,-22.56758,0.161,NULL,50834299808,794285934,12410717,14.8),(147724,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147724,36.95,0.61,246,70255,70,NULL,NULL,'2MASX J20401970-5300303',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,310.082083,-53.00847,0.077,NULL,51072483075,798007548,12468867,16.7),(147725,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147725,36.96,0.46,246,70256,70,NULL,NULL,'2MASX J20402220-0449598',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000102,NULL,'16.2g',0.29,'E0',NULL,NULL,NULL,NULL,1,310.092666667,-4.83333,0.157,NULL,47839756044,747496188,11679627,16.2),(147726,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147726,35.84,0.46,147,70257,70,NULL,NULL,'2MASX J20402259-0621317',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000094,NULL,'15.5g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,310.0940417,-6.35892,0.173,NULL,47819348625,747177322,11674645,15.5),(147727,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147727,35.21,0.55,110,70258,NULL,NULL,NULL,'ESO 401- G 001',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16.20',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,310.110167,-35.53786,0.113,NULL,51517668819,804963575,12577555,16.2),(147728,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147728,35.2,0.56,110,70258,NULL,NULL,'Malmquist cor.','ESO 401- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147729,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147729,35.25,0.2,112,70258,74.4,NULL,NULL,'ESO 401- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147730,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147730,35.89,0.54,151,70259,70,NULL,NULL,'2MASX J20402835-5317263',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7R',0.17,NULL,NULL,NULL,NULL,NULL,1,310.118167,-53.29067,0.105,NULL,51072508002,798007937,12468874,14.7),(147731,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147731,36.09,0.76,165,70260,70,NULL,NULL,'2MASX J20403120-4634385',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,310.130041667,-46.57731,0.113,NULL,51393695431,803026491,12547288,14.6),(147732,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147732,34.58,0.2,82.4,70261,74.4,NULL,NULL,'UGC 11611',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000127,NULL,'15.0',0.7,'SBcd:',NULL,NULL,NULL,NULL,1,310.132125,14.27486,0.373,NULL,55263312649,863489260,13492019,15),(147733,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147733,34.59,0.52,82.9,70261,NULL,NULL,'Malmquist cor.','UGC 11611',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147734,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147734,34.7,0.49,87.1,70261,NULL,NULL,NULL,'UGC 11611',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147735,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147735,32.21,0.65,27.7,70262,95,NULL,'Weighted Mean','NGC 6942',NULL,'1984ApJS...56...91D',1984,1,2,'RC3 gives v = 3934 +/- 66 km/sec.','G',0.000087,NULL,'12.67',1.5,'(R\'_2)SB(rs)a',NULL,NULL,NULL,NULL,1,310.1577083,-54.30306,0.117,NULL,51072923033,798014422,12468975,12.67),(147736,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147736,33.71,0.81,55.2,70262,55,NULL,'Visvanathan & Sandage 1979','NGC 6942',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147737,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147737,33.16,0.49,42.8,70262,70,NULL,NULL,'NGC 6942',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147738,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147738,36.84,0.67,233,70263,70,NULL,NULL,'2MASX J20404081-2039449',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.170041667,-20.66256,0.117,NULL,50826216518,794159633,12408744,15.4),(147739,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147739,37.4,0.46,302,70264,70,NULL,NULL,'2MASX J20405194+0056444',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,310.216416667,0.94564,0.293,NULL,53967394671,843240541,13175633,17.2),(147740,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147740,34.85,0.49,93.5,70265,75,NULL,'IR','UGC 11612',NULL,'2011yCatp016004901K',2011,1,1.41,NULL,'G',0.000033,NULL,'15.6g',0.27,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,310.217,0.65278,0.305,NULL,53964249195,843191393,13174865,15.6),(147741,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147741,34.98,NULL,98.9,70265,NULL,NULL,NULL,'UGC 11612',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147742,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147742,35.07,NULL,103,70265,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147743,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147743,35.08,NULL,104,70265,NULL,NULL,'Dipole','UGC 11612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147744,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147744,35.09,NULL,104,70265,NULL,NULL,'Dipole + Quadrupole','UGC 11612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147745,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147745,36.38,0.52,189,70266,70,NULL,NULL,'2MASX J20405976-4736002',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'15.4R',0.15,NULL,NULL,NULL,NULL,NULL,1,310.249125,-47.60003,0.081,NULL,51347530911,802305170,12536018,15.4),(147746,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147746,35.95,0.54,155,70267,70,NULL,NULL,'ESO 597- G 027',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15',0.8,'SAB(r)b:',NULL,NULL,NULL,NULL,1,310.2705,-22.20292,0.121,NULL,50834203386,794284427,12410694,15),(147747,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17528','R',147747,40.93,0.35,1130,70268,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007iy','SDSS J204105.96-002519.6',0.36,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,310.274833,-0.42211,0.313,NULL,47786404957,746662577,11666602,NULL),(147748,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17528','R',147748,41.57,0.34,1520,70268,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007iy','SDSS J204105.96-002519.6',0.36,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147749,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147749,33.65,0.8,53.6,70269,75,NULL,'MAT, I','ESO 186- G 075',NULL,'1997ApJS..109..333W',1997,1,1.65,NULL,'G',0.000033,NULL,'15.67',0.16,'Scd',NULL,NULL,NULL,NULL,1,310.280875,-53.49633,0.117,NULL,51072688264,798010754,12468918,15.67),(147750,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147750,33.11,0.32,41.9,70269,85,NULL,'I, inv','ESO 186- G 075',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147751,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147751,33.13,0.32,42.3,70269,85,NULL,'I, raw','ESO 186- G 075',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147752,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147752,33.34,0.43,46.6,70269,75,NULL,'MAT, I, inv','ESO 186- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147753,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147753,33.35,0.43,46.7,70269,75,NULL,'MAT, I, raw','ESO 186- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147754,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147754,33.56,NULL,51.5,70269,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 186- G 075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147755,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147755,33.57,NULL,51.8,70269,NULL,NULL,'Dipole + Quadrupole','ESO 186- G 075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147756,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147756,33.59,NULL,52.2,70269,NULL,NULL,'Dipole','ESO 186- G 075',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147757,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147757,33.63,NULL,53.3,70269,NULL,NULL,NULL,'ESO 186- G 075',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147758,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147758,33.65,0.57,53.6,70269,NULL,NULL,NULL,'ESO 186- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147759,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147759,33.69,0.2,54.7,70269,74.4,NULL,NULL,'ESO 186- G 075',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147760,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147760,33.69,0.43,54.8,70269,75,NULL,'MAT, I, cor','ESO 186- G 075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147761,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147761,33.97,0.49,62.3,70269,NULL,NULL,'Malmquist cor.','ESO 186- G 075',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147762,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147762,34.05,0.49,64.5,70269,75,NULL,'IR','ESO 186- G 075',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147763,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147763,35.97,0.73,156,70270,70,NULL,NULL,'2MASX J20411010-2559386',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.292166667,-25.99408,0.385,NULL,51319605973,801868843,12529200,15.7),(147764,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147764,36.09,0.57,165,70271,70,NULL,NULL,'2MASX J20411202-5257379',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000087,NULL,'15.84',0.57,NULL,NULL,NULL,NULL,NULL,1,310.3000417,-52.96042,0.077,NULL,51073004270,798015691,12468995,15.84),(147765,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147765,34.19,0.8,68.8,70272,75,NULL,'MAT, I','NGC 6947',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14',1,'(R\')SB(rs)b',NULL,NULL,NULL,NULL,1,310.313,-32.48642,0.193,NULL,51493494179,804585846,12571653,14),(147766,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147766,33.89,0.43,60.1,70272,75,NULL,'MAT, I, raw','NGC 6947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147767,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147767,34.13,0.32,67.1,70272,85,NULL,'I, raw','NGC 6947',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147768,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147768,34.17,0.43,68.4,70272,75,NULL,'MAT, I, inv','NGC 6947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147769,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147769,34.2,0.32,69.3,70272,85,NULL,'I, inv','NGC 6947',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147770,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147770,34.28,0.43,71.9,70272,75,NULL,'MAT, I, cor','NGC 6947',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147771,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147771,34.43,0.41,76.8,70272,NULL,NULL,NULL,'NGC 6947',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147772,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147772,34.47,0.2,78.3,70272,74.4,NULL,NULL,'NGC 6947',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147773,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147773,34.51,0.4,79.7,70272,NULL,NULL,'Malmquist cor.','NGC 6947',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147774,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147774,36.4,0.51,191,70273,70,NULL,NULL,'2MASX J20411954-4909400',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.000103,NULL,'15.2R',0.18,NULL,NULL,NULL,NULL,NULL,1,310.3315,-49.16122,0.025,NULL,51350399165,802349986,12536718,15.2),(147775,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147775,35.99,0.7,158,70274,70,NULL,NULL,'2MASX J20412014-5110161',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.000103,NULL,'15.4R',0.17,NULL,NULL,NULL,NULL,NULL,1,310.334,-51.17119,0.025,NULL,51084645486,798197585,12471837,15.4),(147776,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13839',NULL,147776,40.38,0.11,1190,70275,70,NULL,'SN photometric redshift distance, z photo =0.330 +/- 0.021','SDSS-II SN 13839',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,310.3357917,0.17831,0.305,NULL,53964402016,843193781,13174902,NULL),(147777,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01821','RN',147777,39.03,0.12,584,70276,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01821',0.096105,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147778,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01821','RN',147778,39.64,0.21,773,70276,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01821',0.096105,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147779,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147779,37.4,0.53,302,70277,70,NULL,NULL,'2MASX J20412263-5102481',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.000103,NULL,'14.9R',0.22,NULL,NULL,NULL,NULL,NULL,1,310.3442917,-51.04681,0.017,NULL,51076273124,798066767,12469793,14.9),(147780,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147780,36.85,0.69,235,70278,70,NULL,NULL,'2MASX J20412921-6213027',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'17.2b',0.18,NULL,NULL,NULL,NULL,NULL,1,310.371625,-62.21742,0.225,NULL,49146665646,767916650,11998697,17.2),(147781,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147781,35.18,0.49,109,70279,75,NULL,'IR','UGC 11614',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',NULL,NULL,'15.43',0.2,'Sb',NULL,NULL,NULL,NULL,1,310.3757917,13.07342,0.421,NULL,55262224328,863472255,13491753,15.43),(147782,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147782,35.27,0.62,113,70280,70,NULL,NULL,'2MASX J20413170-2026263',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.382,-20.44069,0.129,NULL,50826315424,794161178,12408768,14.8),(147783,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147783,34.9,0.57,95.5,70281,70,NULL,NULL,'2MASX J20413309-2055288',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.89',NULL,NULL,NULL,NULL,NULL,NULL,1,310.387833,-20.92467,0.149,NULL,50826572521,794165195,12408831,15.89),(147784,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147784,36.56,0.59,205,70282,70,NULL,NULL,'2MASX J20413758-4730150',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'15.2R',0.22,NULL,NULL,NULL,NULL,NULL,1,310.4065,-47.50414,0.073,NULL,51347268953,802301077,12535954,15.2),(147785,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147785,35.85,0.47,148,70283,70,NULL,NULL,'2MASX J20414021-4255420',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.000087,NULL,'14.2R',0.41,NULL,NULL,NULL,NULL,NULL,1,310.417583,-42.92831,0.057,NULL,51384764776,802886949,12545108,14.2),(147786,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147786,32.87,0.43,37.6,70284,75,NULL,'3.6 micron, color + selection bias corrected','MCG +09-34-001',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000017,NULL,'10.0K',0.4,'Spiral',NULL,NULL,NULL,NULL,1,310.4254583,55.69814,NULL,NULL,52952090371,827376412,12927756,10),(147787,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147787,33.05,0.4,40.8,70284,NULL,NULL,'mean','MCG +09-34-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147788,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147788,33.14,0.47,42.5,70284,NULL,NULL,'H','MCG +09-34-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147789,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147789,33.19,0.46,43.4,70284,NULL,NULL,'J','MCG +09-34-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147790,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147790,33.21,0.45,43.9,70284,NULL,NULL,'K','MCG +09-34-001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147791,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147791,37.39,0.46,301,70285,70,NULL,NULL,'2MASX J20414731+0112473',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000191,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,310.447208333,1.21308,0.281,NULL,53968030104,843250470,13175788,16.8),(147792,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 19317','R',147792,40,0.24,848,70286,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19317',0.178687,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,310.454833,1.06483,0.293,NULL,53968072787,843251137,13175799,NULL),(147793,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 19317','R',147793,40.42,0.35,1030,70286,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19317',0.178687,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147794,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147794,35.09,0.5,104,70287,70,NULL,NULL,'2MASX J20415168-2032088',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'15.43',NULL,NULL,NULL,NULL,NULL,NULL,1,310.465333,-20.53586,0.125,NULL,50826325110,794161329,12408770,15.43),(147795,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147795,36.21,0.5,175,70288,70,NULL,NULL,'2MASX J20415286-5026001',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.000103,NULL,'14.8R',0.26,NULL,NULL,NULL,NULL,NULL,1,310.470167,-50.43344,0,NULL,51077095209,798079612,12469993,14.8),(147796,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 11659','RN',147796,42.67,0.24,2330,70289,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 11659',0.467013,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147797,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147797,34.47,0.2,78.3,70290,74.4,NULL,NULL,'ESO 401- G 004',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000027,NULL,'15.65',1,'Sc',NULL,NULL,NULL,NULL,1,310.4824583,-32.82428,0.173,NULL,51523057163,805047768,12578871,15.65),(147798,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147798,34.66,0.38,85.6,70290,NULL,NULL,NULL,'ESO 401- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147799,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147799,34.73,0.37,88.2,70290,NULL,NULL,'Malmquist cor.','ESO 401- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147800,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147800,39.65,0.04,680,70291,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06315, SN 2005ix','SDSS J204155.81+010530.8',0.25,'2011ApJS..192....1C',2011,1,0.04,NULL,'G',NULL,NULL,'22.7g',0.02,NULL,NULL,NULL,NULL,NULL,1,310.482583,1.09189,0.293,NULL,53968102939,843251608,13175806,22.7),(147801,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147801,39.79,0.13,726,70291,74.2,NULL,'SALT 2','SDSS J204155.81+010530.8',0.25,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147802,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06315','R',147802,40.5,0.2,1010,70291,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ix','SDSS J204155.81+010530.8',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147803,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147803,40.53,0.09,1020,70291,65,NULL,'SALT2','SDSS J204155.81+010530.8',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147804,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147804,40.59,0.14,1050,70291,70,NULL,'SALT 2','SDSS J204155.81+010530.8',0.25,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147805,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147805,40.62,NULL,1060,70291,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06315, SN 2005ix','SDSS J204155.81+010530.8',0.25,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147806,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ix',NULL,147806,40.7,0.09,1100,70291,65,NULL,'MLCS2k2','SDSS J204155.81+010530.8',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147807,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06315','R',147807,40.86,0.12,1190,70291,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ix','SDSS J204155.81+010530.8',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147808,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147808,35.72,0.37,139,70292,NULL,NULL,'Malmquist cor.','IC 1328',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.8b',0.4,'Sc',NULL,NULL,NULL,NULL,1,310.487667,-19.63306,0.149,NULL,50823251729,794113308,12408020,14.8),(147809,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147809,35.92,0.34,153,70292,NULL,NULL,NULL,'IC 1328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147810,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147810,35.96,0.2,156,70292,74.4,NULL,NULL,'IC 1328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147811,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147811,37.56,0.46,325,70293,70,NULL,NULL,'2MASX J20420269-0558515',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,310.511375,-5.98089,0.153,NULL,47836102517,747439101,11678735,17.5),(147812,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147812,38.52,0.69,507,70294,70,NULL,NULL,'2MASX J20420331-0307438',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.88',NULL,NULL,NULL,NULL,NULL,NULL,1,310.513833,-3.12869,0.173,NULL,47792189006,746752953,11668014,16.88),(147813,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147813,36.96,0.58,247,70295,70,NULL,NULL,'2MASX J20420400-4915056',NULL,'2014MNRAS.445.2677S',2014,1,0.24,NULL,'G',0.000103,NULL,'15.6R',0.13,NULL,NULL,NULL,NULL,NULL,1,310.5167083,-49.25156,0,NULL,51350367810,802349497,12536710,15.6),(147814,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147814,36.23,0.52,176,70296,70,NULL,NULL,'2MASX J20420558-5254447',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'16.0b',0.43,NULL,NULL,NULL,NULL,NULL,1,310.523375,-52.91247,0.077,NULL,51073031690,798016120,12469001,16),(147815,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147815,33.34,0.48,46.5,70297,70,NULL,NULL,'NGC 6932',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.00007,NULL,'13.27',1.5,'(R_1)SAB(r)0^+',NULL,NULL,NULL,NULL,1,310.53575,-73.61936,0.209,NULL,49208202096,768878157,12013721,13.27),(147816,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147816,35.44,0.54,122,70298,NULL,NULL,'Malmquist cor.','ESO 341- G 007',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.29',1.1,'Sc',NULL,NULL,NULL,NULL,1,310.5430417,-37.69044,0.097,NULL,51519323621,804989431,12577959,14.29),(147817,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147817,35.51,0.52,126,70298,NULL,NULL,NULL,'ESO 341- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147818,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147818,35.55,0.2,129,70298,74.4,NULL,NULL,'ESO 341- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147819,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147819,35,0.49,99.8,70299,75,NULL,'IR','ESO 187- G 004',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.44',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,310.54575,-55.23844,0.209,NULL,48990853630,765482087,11960657,15.44),(147820,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147820,35.3,0.57,115,70299,NULL,NULL,'Malmquist cor.','ESO 187- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147821,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147821,35.39,0.54,120,70299,NULL,NULL,NULL,'ESO 187- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147822,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147822,35.43,0.2,122,70299,74.4,NULL,NULL,'ESO 187- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147823,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05439',NULL,147823,41.18,0.21,1720,70300,70,NULL,'SN photometric redshift distance, z photo =0.530 +/- 0.078','SDSS-II SN 05439',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'*',NULL,'PHOT','21.2g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,310.5479583,0.25197,0.305,NULL,53964210016,843190781,13174855,21.2),(147824,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13810','RN',147824,40.93,0.17,1100,70301,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13810',0.388981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147825,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13810','RN',147825,41.53,0.23,1460,70301,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13810',0.388981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147826,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147826,37.73,0.87,351,70302,70,NULL,NULL,'2MASX J20421536-5137507',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000113,NULL,'15.2R',0.26,NULL,NULL,NULL,NULL,NULL,1,310.564083333,-51.63081,0.021,NULL,51084696137,798198377,12471849,15.2),(147827,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147827,35.82,0.54,146,70303,70,NULL,NULL,'2MASX J20422166-4756277',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.000103,NULL,'15.5R',0.16,NULL,NULL,NULL,NULL,NULL,1,310.590375,-47.94106,0.069,NULL,51347358450,802302475,12535976,15.5),(147828,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147828,35.93,0.67,153,70304,70,NULL,NULL,'2MASX J20422683-2010524',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.16',NULL,NULL,NULL,NULL,NULL,NULL,1,310.611917,-20.18122,0.145,NULL,50823090931,794110795,12407981,16.16),(147829,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14303',NULL,147829,40.15,0.17,1070,70305,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.029','SDSS-II SN 14303',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.0g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,310.614541667,-0.53536,0.301,NULL,47789366521,746708851,11667325,21),(147830,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147830,34.29,0.8,72.1,70306,75,NULL,'MAT, I','ESO 528- G 034',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.66',0.7,'SB(s)c','in an interacting pair',NULL,NULL,NULL,1,310.62175,-24.14969,0.205,NULL,50832758566,794261852,12410341,14.66),(147831,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147831,33.92,0.32,60.9,70306,85,NULL,'I, raw','ESO 528- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147832,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147832,33.95,0.32,61.8,70306,85,NULL,'I, inv','ESO 528- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147833,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147833,34,0.43,63.1,70306,75,NULL,'MAT, I, raw','ESO 528- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147834,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147834,34.17,0.43,68.2,70306,75,NULL,'MAT, I, inv','ESO 528- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147835,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147835,34.48,0.43,78.8,70306,75,NULL,'MAT, I, cor','ESO 528- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147836,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147836,34.55,0.47,81.2,70306,NULL,NULL,NULL,'ESO 528- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147837,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147837,34.59,0.2,82.8,70306,74.4,NULL,NULL,'ESO 528- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147838,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147838,34.68,0.44,86.1,70306,NULL,NULL,'Malmquist cor.','ESO 528- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147839,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 16657','RN',147839,40.87,0.15,1250,70307,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16657',0.192,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147840,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 16657','RN',147840,40.98,0.27,1320,70307,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16657',0.192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147841,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147841,34.86,0.52,93.8,70308,70,NULL,NULL,'2MASX J20423127-7809458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,310.6305417,-78.16269,0.433,NULL,48581563334,759086927,11860733,16.8),(147842,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147842,35.12,0.56,106,70309,70,NULL,NULL,'FAIRALL 0910',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.4I',0.4,NULL,NULL,NULL,NULL,NULL,1,310.6480417,-43.75644,0.053,NULL,51384565276,802883832,12545059,13.4),(147843,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13675',NULL,147843,40.18,0.15,1090,70310,70,NULL,'SN photometric redshift distance, z photo =0.296 +/- 0.025','SDSS-II SN 13675',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,310.6589583,-0.91661,0.265,NULL,47789818394,746715912,11667436,NULL),(147844,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147844,34,0.49,63,70311,75,NULL,'IR','FGC 2286',NULL,'2011yCatp016004901K',2011,1,1.56,NULL,'G',0.00002,NULL,'16.0',0.12,'Sd',NULL,NULL,NULL,NULL,1,310.6797083,-2.76683,0.161,NULL,47795059637,746797806,11668715,16),(147845,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147845,34.14,NULL,67.2,70311,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2286',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147846,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147846,34.15,NULL,67.6,70311,NULL,NULL,'Dipole + Quadrupole','FGC 2286',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147847,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147847,34.15,NULL,67.7,70311,NULL,NULL,'Dipole','FGC 2286',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147848,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147848,34.21,NULL,69.7,70311,NULL,NULL,NULL,'FGC 2286',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147849,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147849,35.23,0.54,111,70312,70,NULL,NULL,'2MASX J20425115-5253513',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.80',0.24,NULL,NULL,NULL,NULL,NULL,1,310.71325,-52.89769,0.065,NULL,51073025373,798016021,12469000,16.8),(147850,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147850,36.35,0.51,187,70313,70,NULL,NULL,'2MASX J20430076-4818594',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,310.7532083,-48.31647,0.073,NULL,51347457438,802304022,12536000,14.2),(147851,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147851,33.82,0.8,57.9,70314,75,NULL,'MAT, I','ESO 187- G 006',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'14.87',0.6,'(R\':)SAB(r)b',NULL,NULL,NULL,NULL,1,310.7582083,-52.51464,0.025,NULL,51071411385,797990802,12468606,14.87),(147852,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147852,33.39,0.32,47.6,70314,85,NULL,'I, raw','ESO 187- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147853,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147853,33.39,0.32,47.7,70314,85,NULL,'I, inv','ESO 187- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147854,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147854,33.53,0.43,50.8,70314,75,NULL,'MAT, I, raw','ESO 187- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147855,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147855,33.6,0.43,52.4,70314,75,NULL,'MAT, I, inv','ESO 187- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147856,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147856,33.86,0.43,59,70314,75,NULL,'MAT, I, cor','ESO 187- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147857,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147857,34.2,0.37,69.2,70314,NULL,NULL,NULL,'ESO 187- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147858,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147858,34.24,0.2,70.5,70314,74.4,NULL,NULL,'ESO 187- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147859,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147859,34.24,0.37,70.6,70314,NULL,NULL,'Malmquist cor.','ESO 187- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147860,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147860,36.15,0.64,170,70315,70,NULL,NULL,'2MASX J20430701-5608530',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.31',0.48,'S0',NULL,NULL,NULL,NULL,1,310.77925,-56.14806,0.209,NULL,48992179710,765502807,11960981,16.31),(147861,'GRB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147861,41.99,NULL,2500,70316,70,NULL,'Pseudo z = 0.95','GRB 020801',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,310.783333,-46.83333,0.045,NULL,51393159245,803018113,12547158,NULL),(147862,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147862,32.65,0.8,34,70317,75,NULL,'MAT, I','IC 5003',NULL,'1997ApJS..109..333W',1997,1,2.4,NULL,'G',0.00003,NULL,'13.25',0.6,'Sbc: sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,310.80975,-29.85339,0.245,NULL,51314956406,801796193,12528065,13.25),(147863,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147863,31.6,0.43,20.8,70317,75,NULL,'3.6 micron, color + selection bias corrected','IC 5003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147864,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147864,31.72,0.43,22.1,70317,75,NULL,'3.6 micron, color corrected','IC 5003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147865,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147865,31.87,0.2,23.7,70317,74.4,NULL,NULL,'IC 5003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147866,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147866,32.1,0.41,26.3,70317,NULL,NULL,NULL,'IC 5003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147867,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147867,32.21,0.39,27.7,70317,NULL,NULL,'Malmquist cor.','IC 5003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147868,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147868,32.35,0.4,29.5,70317,NULL,NULL,NULL,'IC 5003',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147869,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147869,32.45,0.32,30.9,70317,85,NULL,'I, raw','IC 5003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147870,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147870,32.48,0.32,31.3,70317,85,NULL,'I, inv','IC 5003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147871,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147871,32.55,0.43,32.3,70317,75,NULL,'MAT, I, raw','IC 5003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147872,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147872,32.63,0.46,33.5,70317,NULL,NULL,'J','IC 5003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147873,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147873,32.65,0.4,33.9,70317,NULL,NULL,'mean','IC 5003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147874,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147874,32.68,0.47,34.3,70317,NULL,NULL,'H','IC 5003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147875,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147875,32.7,0.43,34.7,70317,75,NULL,'MAT, I, inv','IC 5003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147876,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147876,32.73,0.43,35.2,70317,75,NULL,'MAT, I, cor','IC 5003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147877,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147877,32.77,0.45,35.8,70317,NULL,NULL,'K','IC 5003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147878,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147878,37.02,0.46,253,70318,70,NULL,NULL,'2MASX J20431738-0649222',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000067,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,310.8224583,-6.82281,0.125,NULL,50759643740,793119433,12392491,17.4),(147879,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147879,35.53,0.63,128,70319,70,NULL,NULL,'2MASX J20431739-5330144',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.80',0.22,NULL,NULL,NULL,NULL,NULL,1,310.8224583,-53.50408,0.105,NULL,51073111395,798017365,12469021,16.8),(147880,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147880,37.31,0.46,290,70320,70,NULL,NULL,'2MASX J20431877+0115038',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,310.82825,1.25122,0.277,NULL,53967320818,843239387,13175615,17.5),(147881,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147881,31.49,0.8,19.9,70321,75,NULL,NULL,'IC 5028',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000022,NULL,'15.19',1,'IAB(s)m?',NULL,NULL,NULL,NULL,1,310.841791667,-65.64781,0.125,NULL,49370031913,771406748,12053230,15.19),(147882,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147882,33.71,0.8,55.2,70322,75,NULL,'MAT, I','ESO 187- G 008',NULL,'1997ApJS..109..333W',1997,1,0.98,NULL,'G',0.000033,NULL,'15.69',0.21,'Scd',NULL,NULL,NULL,NULL,1,310.853917,-56.20364,0.209,NULL,48992186196,765502909,11960982,15.69),(147883,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147883,33.54,0.32,51.1,70322,85,NULL,'I, raw','ESO 187- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147884,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147884,33.54,0.32,51.1,70322,85,NULL,'I, inv','ESO 187- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147885,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147885,33.68,NULL,54.5,70322,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 187- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147886,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147886,33.7,0.43,55,70322,75,NULL,'MAT, I, raw','ESO 187- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147887,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147887,33.71,NULL,55.2,70322,NULL,NULL,'Dipole + Quadrupole','ESO 187- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147888,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147888,33.72,NULL,55.5,70322,NULL,NULL,'Dipole','ESO 187- G 008',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147889,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147889,33.75,0.43,56.4,70322,75,NULL,'MAT, I, inv','ESO 187- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147890,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147890,33.76,NULL,56.4,70322,NULL,NULL,NULL,'ESO 187- G 008',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147891,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147891,33.91,0.43,60.6,70322,75,NULL,'MAT, I, cor','ESO 187- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147892,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147892,34.06,0.42,64.8,70322,NULL,NULL,NULL,'ESO 187- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147893,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147893,34.1,0.2,66.1,70322,74.4,NULL,NULL,'ESO 187- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147894,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147894,34.13,0.41,66.9,70322,NULL,NULL,'Malmquist cor.','ESO 187- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147895,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147895,34.48,0.49,78.5,70322,75,NULL,'IR','ESO 187- G 008',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147896,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14013',NULL,147896,39.46,0.35,779,70323,70,NULL,'SN photometric redshift distance, z photo =0.202 +/- 0.040','SDSS-II SN 14013',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,310.867625,-1.20475,0.289,NULL,47789086401,746704475,11667257,NULL),(147897,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147897,32.98,0.8,39.5,70324,75,NULL,'MAT, I','NGC 6948',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'13.76',1,'SA(s)a: sp',NULL,NULL,NULL,NULL,1,310.871417,-53.35672,0.105,NULL,51073106936,798017295,12469020,13.76),(147898,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147898,33.29,0.4,45.5,70324,NULL,NULL,'mean','NGC 6948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147899,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147899,33.57,0.45,51.7,70324,NULL,NULL,'K','NGC 6948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147900,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147900,33.65,0.47,53.7,70324,NULL,NULL,'H','NGC 6948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147901,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147901,33.75,0.46,56.2,70324,NULL,NULL,'J','NGC 6948',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147902,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147902,34.54,0.43,80.9,70324,75,NULL,'MAT, I, raw','NGC 6948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147903,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147903,34.62,0.32,84,70324,85,NULL,'I, raw','NGC 6948',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147904,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147904,34.68,0.32,86.2,70324,85,NULL,'I, inv','NGC 6948',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147905,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147905,34.72,0.43,87.9,70324,75,NULL,'MAT, I, cor','NGC 6948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147906,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147906,34.78,0.43,90.5,70324,75,NULL,'MAT, I, inv','NGC 6948',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147907,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147907,37.65,0.46,338,70325,70,NULL,NULL,'2MASX J20432958+0050219',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000143,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,310.8732917,0.83936,0.337,NULL,53967914105,843248657,13175760,17.4),(147908,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147908,33.56,0.46,51.5,70326,NULL,NULL,'J','UGC 11635',NULL,'2007A&A...465...71T',2007,1,2.9,NULL,'G',0.00001,NULL,'13.8',1.2,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,310.8742083,80.15611,0.353,NULL,52866401077,826037516,12906836,13.8),(147909,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147909,33.58,0.45,51.9,70326,NULL,NULL,'K','UGC 11635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147910,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147910,33.6,0.47,52.5,70326,NULL,NULL,'H','UGC 11635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147911,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147911,33.87,0.4,59.5,70326,NULL,NULL,'mean','UGC 11635',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147912,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147912,34.19,0.2,68.9,70326,74.4,NULL,NULL,'UGC 11635',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147913,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147913,34.22,0.43,69.9,70326,75,NULL,'3.6 micron, color corrected','UGC 11635',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147914,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147914,34.34,0.43,73.9,70326,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11635',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147915,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147915,32.68,0.8,34.3,70327,75,NULL,'MAT, I','IC 5007',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000003,NULL,'12.58',1.5,'SAB(s)d        HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,310.8935417,-29.70364,0.281,NULL,51315012198,801797065,12528079,12.58),(147916,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147916,32.3,0.32,28.8,70327,85,NULL,'I, raw','IC 5007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147917,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147917,32.33,0.32,29.2,70327,85,NULL,'I, inv','IC 5007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147918,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147918,32.52,0.43,31.9,70327,75,NULL,'MAT, I, raw','IC 5007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147919,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147919,32.52,0.43,31.9,70327,75,NULL,'3.6 micron, color + selection bias corrected','IC 5007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147920,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147920,32.57,0.4,32.7,70327,NULL,NULL,NULL,'IC 5007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147921,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147921,32.57,0.43,32.7,70327,75,NULL,'3.6 micron, color corrected','IC 5007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147922,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147922,32.62,0.2,33.4,70327,74.4,NULL,NULL,'IC 5007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147923,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147923,32.66,0.43,34.1,70327,75,NULL,'MAT, I, inv','IC 5007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147924,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147924,32.71,0.43,34.9,70327,75,NULL,'MAT, I, cor','IC 5007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147925,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147925,32.71,0.48,34.9,70327,NULL,NULL,'Malmquist cor.','IC 5007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147926,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147926,32.75,0.47,35.5,70327,NULL,NULL,NULL,'IC 5007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147927,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147927,36.16,0.46,171,70328,70,NULL,NULL,'2MASX J20433471+0058039',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,310.894583,0.96775,0.345,NULL,53967253520,843238336,13175599,16.8),(147928,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147928,36.51,0.5,200,70329,70,NULL,NULL,'2MASX J20434052-5113345',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,310.91875,-51.22631,0.021,NULL,51084548447,798196069,12471813,14.2),(147929,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147929,35.88,0.53,150,70330,70,NULL,NULL,'IC 5034',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000093,NULL,'14.63',0.7,'SAB(rs)bc','in a pair',NULL,NULL,NULL,1,310.923625,-57.03031,0.285,NULL,48998967629,765608869,11962638,14.63),(147930,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147930,35.78,0.54,143,70331,70,NULL,NULL,'2MASX J20434167-5259455',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.02',0.37,NULL,NULL,NULL,NULL,NULL,1,310.92375,-52.99606,0.065,NULL,51073217620,798019025,12469047,16.02),(147931,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147931,36.11,0.6,167,70332,70,NULL,NULL,'AM 2040-263 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,310.931417,-26.41914,0.269,NULL,51320052388,801875818,12529309,15.3),(147932,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147932,35.93,0.54,153,70333,70,NULL,NULL,'FAIRALL 0557',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'1983MNRAS.203...47F has V = 5800: +- 100 km/s.','G',0.00015,NULL,'14.0I',0.3,'SB(s)a',NULL,NULL,NULL,NULL,1,310.938,-48.22819,0.073,NULL,51347340556,802302196,12535971,14),(147933,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147933,36.34,0.53,186,70334,70,NULL,NULL,'2MASX J20434965-2635321',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.4,NULL,NULL,NULL,NULL,NULL,1,310.957,-26.59228,0.345,NULL,51320166794,801877606,12529337,13.9),(147934,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147934,36.77,0.55,226,70335,70,NULL,NULL,'2MASX J20435212-7335115',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,310.967125,-73.58656,0.201,NULL,49208177115,768877767,12013715,17.1),(147935,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147935,34.81,0.56,91.6,70336,70,NULL,NULL,'CGCG 374-002',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00011,NULL,'15.5',0.5,NULL,NULL,NULL,NULL,NULL,1,310.969833,-1.87731,0.265,NULL,47794642932,746791295,11668613,15.5),(147936,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14304',NULL,147936,40.29,0.15,1140,70337,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.028','SDSS-II SN 14304',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.00175,-0.60592,0.301,NULL,47788135933,746689623,11667025,NULL),(147937,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18583','RN',147937,39.93,0.1,826,70338,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18583',0.17212,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147938,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18583','RN',147938,40.33,0.2,994,70338,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18583',0.17212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147939,'AGN time lag','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147939,35.11,0.13,105,70339,NULL,NULL,NULL,'MRK 0509',NULL,'2014ApJ...784L..11Y',2014,1,0.5,NULL,'G',0.00004,NULL,'14.2r',NULL,'Compact        Sy1.2',NULL,NULL,NULL,'Sy 1.5',1,311.040583,-10.72347,0.181,NULL,50767230453,793237975,12394343,14.2),(147940,'AGN time lag','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147940,37.88,0.46,376,70339,44,NULL,NULL,'MRK 0509',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147941,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147941,35.91,0.51,152,70340,70,NULL,NULL,'FAIRALL 0558',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'1983MNRAS.203...47F has V = 5200: +- 100 km/s.','G',0.00015,NULL,'13.6I',0.4,'SB(r)0^+:',NULL,NULL,NULL,NULL,1,311.064167,-47.72453,0.073,NULL,51347439904,802303748,12535996,13.6),(147942,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06496','R',147942,41.14,0.19,1290,70341,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06496',0.3088,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,311.0662917,0.05203,0.309,NULL,53965506022,843211031,13175172,NULL),(147943,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06496','R',147943,41.15,0.28,1300,70341,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06496',0.3088,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147944,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02027','RN',147944,41.26,0.2,1520,70342,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02027',0.172969,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147945,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02027','RN',147945,41.83,0.24,1980,70342,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02027',0.172969,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147946,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147946,38.16,0.46,429,70343,70,NULL,NULL,'2MASX J20442150-0556455',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000091,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,311.089541667,-5.94614,0.137,NULL,50738733995,792792718,12387386,17.5),(147947,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147947,33.98,0.4,62.4,70344,NULL,NULL,'mean','UGC 11623',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.00003,NULL,'14.85',0.7,'SB(r)a','in a triple',NULL,NULL,NULL,1,311.110875,12.49772,0.433,NULL,55253904371,863342255,13489722,14.85),(147948,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147948,34.14,0.47,67.2,70344,NULL,NULL,'H','UGC 11623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147949,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147949,34.22,0.45,69.9,70344,NULL,NULL,'K','UGC 11623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147950,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147950,34.28,0.46,71.9,70344,NULL,NULL,'J','UGC 11623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147951,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05877',NULL,147951,40.3,0.16,1150,70345,70,NULL,'SN photometric redshift distance, z photo =0.317 +/- 0.029','SDSS-II SN 05877',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','22.8g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,311.112,0.541,0.337,NULL,53965775213,843215237,13175238,22.8),(147952,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147952,34.55,0.63,81.2,70346,70,NULL,NULL,'2MASX J20442728-3043364',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'14.9R',0.25,NULL,NULL,NULL,NULL,NULL,1,311.113625,-30.72678,0.225,NULL,51316786851,801824794,12528512,14.9),(147953,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147953,37.11,0.67,264,70347,70,NULL,NULL,'2MASX J20442911-5333332',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.06',0.38,NULL,NULL,NULL,NULL,NULL,1,311.12125,-53.55917,0.105,NULL,51073962175,798030658,12469229,16.06),(147954,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147954,32.91,0.8,38.2,70348,75,NULL,'MAT, I','NGC 6943',NULL,'1997ApJS..109..333W',1997,1,4,NULL,'G',0.000013,NULL,'12.05',2,'SAB(r)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,311.140583,-68.74772,0.173,NULL,49381221799,771581590,12055962,12.05),(147955,'Sosies','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147955,32.29,0.13,28.7,70348,NULL,NULL,NULL,'NGC 6943',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147956,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147956,32.94,0.8,38.8,70348,75,NULL,'B','NGC 6943',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147957,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147957,32.44,NULL,30.8,70348,NULL,NULL,'B','NGC 6943',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147958,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147958,32.47,0.43,31.3,70348,75,NULL,'MAT, I, raw','NGC 6943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147959,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147959,32.5,0.32,31.6,70348,85,NULL,'I, raw','NGC 6943',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147960,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147960,32.5,0.4,31.6,70348,NULL,NULL,NULL,'NGC 6943',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147961,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147961,32.5,0.39,31.6,70348,73,NULL,'opt','NGC 6943',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147962,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147962,32.57,0.32,32.6,70348,85,NULL,'I, inv','NGC 6943',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147963,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147963,32.67,0.46,34.2,70348,NULL,NULL,'J','NGC 6943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147964,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147964,32.68,NULL,34.3,70348,NULL,NULL,'I','NGC 6943',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147965,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147965,32.75,0.43,35.5,70348,75,NULL,'MAT, I, inv','NGC 6943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147966,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147966,32.75,0.43,35.5,70348,75,NULL,'3.6 micron, color corrected','NGC 6943',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147967,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147967,32.76,0.2,35.7,70348,74.4,NULL,NULL,'NGC 6943',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147968,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147968,32.78,0.45,35.9,70348,NULL,NULL,'K','NGC 6943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147969,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147969,32.82,0.43,36.7,70348,75,NULL,'MAT, I, cor','NGC 6943',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147970,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147970,32.84,0.43,37,70348,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6943',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147971,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147971,32.91,0.47,38.2,70348,NULL,NULL,'H','NGC 6943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147972,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147972,33.03,0.4,40.4,70348,NULL,NULL,'mean','NGC 6943',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147973,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147973,34.79,0.51,90.9,70349,70,NULL,NULL,'2MASX J20443443-5742363',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.80',0.5,'E',NULL,NULL,NULL,NULL,1,311.1434583,-57.71003,0.337,NULL,49131023629,767672244,11994878,15.8),(147974,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147974,35.2,0.6,110,70350,70,NULL,NULL,'ESO 597- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000083,NULL,'15.52',0.9,'S0',NULL,NULL,NULL,NULL,1,311.164417,-20.53492,0.161,NULL,50825840919,794153764,12408652,15.52),(147975,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147975,32.61,0.8,33.2,70351,75,NULL,'HMCL, I','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,1,2.5,'Confused HIPASS source','G',0.000023,NULL,'13.57',1,'SB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,311.1675417,-45.9785,0.021,NULL,51396471588,803069868,12547966,13.57),(147976,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147976,32.61,0.8,33.2,70351,75,NULL,'MAT, I','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147977,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147977,32.68,0.8,34.3,70351,75,NULL,NULL,'ESO 285- G 048',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147978,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147978,32.25,0.4,28.2,70351,NULL,NULL,NULL,'ESO 285- G 048',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147979,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147979,32.25,0.39,28.2,70351,73,NULL,'opt','ESO 285- G 048',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147980,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147980,32.25,0.32,28.2,70351,85,NULL,'I, raw','ESO 285- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147981,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147981,32.26,0.32,28.3,70351,85,NULL,'I, inv','ESO 285- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147982,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147982,32.49,0.4,31.5,70351,75,NULL,'HMCL, I, raw','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147983,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147983,32.49,0.5,31.5,70351,NULL,NULL,NULL,'ESO 285- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147984,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147984,32.53,0.2,32.1,70351,74.4,NULL,NULL,'ESO 285- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147985,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147985,32.56,0.4,32.5,70351,75,NULL,'HMCL, I, inv','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147986,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147986,32.62,0.43,33.4,70351,75,NULL,'MAT, I, raw','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147987,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147987,32.63,0.47,33.6,70351,NULL,NULL,'Malmquist cor.','ESO 285- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147988,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147988,32.69,0.4,34.5,70351,75,NULL,'HMCL, I, cor','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147989,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147989,32.71,0.43,34.8,70351,75,NULL,'MAT, I, inv','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147990,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147990,32.84,0.43,37,70351,75,NULL,'MAT, I, cor','ESO 285- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147991,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147991,36.4,0.71,191,70352,70,NULL,NULL,'2MASX J20444456-4412157',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.5I',0.2,NULL,NULL,NULL,NULL,NULL,1,311.1857917,-44.20431,0.053,NULL,51377339967,802770936,12543295,14.5),(147992,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147992,35.51,0.74,126,70353,70,NULL,NULL,'2MASX J20445136-5414332',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.16',0.29,NULL,NULL,NULL,NULL,NULL,1,311.214125,-54.24267,0.105,NULL,51072437777,798006840,12468856,16.16),(147993,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147993,36.5,0.57,200,70354,70,NULL,NULL,'2MASX J20445862-4358137',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,311.244333,-43.97058,0.045,NULL,51377310699,802770479,12543288,14.4),(147994,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147994,34.65,0.8,85,70355,75,NULL,'MAT, I','IC 5025',NULL,'1997ApJS..109..333W',1997,1,1.66,NULL,'G',0.000033,NULL,'15.36',0.21,'Sbc',NULL,NULL,NULL,NULL,1,311.246166667,-76.98469,0.361,NULL,48525249042,758207016,11846984,15.36),(147995,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147995,34.38,0.43,75.1,70355,75,NULL,'MAT, I, raw','IC 5025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147996,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147996,34.46,0.32,77.9,70355,85,NULL,'I, raw','IC 5025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147997,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147997,34.5,0.32,79.6,70355,85,NULL,'I, inv','IC 5025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147998,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,147998,34.52,0.38,80.1,70355,NULL,NULL,'Malmquist cor.','IC 5025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(147999,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',147999,34.52,0.49,80.2,70355,75,NULL,'IR','IC 5025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148000,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148000,34.53,0.38,80.4,70355,NULL,NULL,NULL,'IC 5025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148001,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148001,34.57,0.2,82,70355,74.4,NULL,NULL,'IC 5025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148002,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148002,34.59,0.43,82.9,70355,75,NULL,'MAT, I, inv','IC 5025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148003,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148003,34.73,0.43,88.5,70355,75,NULL,'MAT, I, cor','IC 5025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148004,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148004,34.98,NULL,98.9,70355,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148005,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148005,34.98,NULL,99.2,70355,NULL,NULL,'Dipole + Quadrupole','IC 5025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148006,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148006,35,NULL,100,70355,NULL,NULL,'Dipole','IC 5025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148007,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148007,35.03,NULL,101,70355,NULL,NULL,NULL,'IC 5025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148008,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148008,38.46,0.46,492,70356,70,NULL,NULL,'SDSS J204459.44-061253.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000078,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,311.2477083,-6.215,0.117,NULL,50793236702,793644323,12400692,18.7),(148009,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03407','RN',148009,43.56,0.4,3940,70357,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03407',0.30996,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148010,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03407','RN',148010,43.62,0.32,4040,70357,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03407',0.30996,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148011,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148011,36.83,0.8,233,70358,70,NULL,NULL,'2MASX J20450165-5124507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,311.256958333,-51.41408,0.021,NULL,51084564710,798196323,12471817,15.6),(148012,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148012,33.73,0.47,55.7,70359,NULL,NULL,'H','VV 546',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.00006,NULL,NULL,NULL,'Sa',NULL,NULL,NULL,NULL,1,311.258666667,-11.10458,0.185,NULL,50766244365,793222568,12394102,NULL),(148013,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148013,33.79,0.45,57.3,70359,NULL,NULL,'K','VV 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148014,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148014,33.84,0.46,58.5,70359,NULL,NULL,'J','VV 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148015,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148015,34.17,0.4,68.2,70359,NULL,NULL,'mean','VV 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148016,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148016,34.12,0.54,66.8,70360,70,NULL,NULL,'NGC 6985',NULL,'2014MNRAS.445.2677S',2014,1,1.7,'10 minute error in NGC RA.','G',0.0001,NULL,'15.50',0.6,'SB:(s)a: pec',NULL,NULL,NULL,NULL,1,311.262417,-11.10419,0.185,NULL,50766246144,793222596,12394103,15.5),(148017,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14622','RN',148017,36.8,0.4,214,70361,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14622',0.071119,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148018,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148018,36.74,0.68,223,70362,70,NULL,NULL,'2MASX J20451305-5330367',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.58',0.31,NULL,NULL,NULL,NULL,NULL,1,311.3044583,-53.51022,0.105,NULL,51073954283,798030535,12469227,16.58),(148019,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148019,39.07,0.46,652,70363,70,NULL,NULL,'SDSS J204514.13-055743.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000096,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,311.308916667,-5.96197,0.137,NULL,50738729573,792792649,12387385,18.6),(148020,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148020,34.2,0.53,69.1,70364,70,NULL,NULL,'ESO 074- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.33',0.3,'SAB(s)a',NULL,NULL,NULL,NULL,1,311.3257083,-71.39722,0.153,NULL,49327280639,770738759,12042793,14.33),(148021,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148021,35.04,0.49,102,70365,75,NULL,'IR','ESO 401- G 007',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'14.2R',0.6,'SAB(r)a',NULL,NULL,NULL,NULL,1,311.32675,-35.24069,0.141,NULL,51516961225,804952519,12577383,14.2),(148022,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148022,35.42,0.4,121,70365,NULL,NULL,'mean','ESO 401- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148023,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148023,35.55,0.42,129,70365,NULL,NULL,'Malmquist cor.','ESO 401- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148024,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148024,35.62,0.47,133,70365,NULL,NULL,'H','ESO 401- G 007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148025,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148025,35.66,0.4,135,70365,NULL,NULL,NULL,'ESO 401- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148026,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148026,35.7,0.2,138,70365,74.4,NULL,NULL,'ESO 401- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148027,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148027,38.89,0.46,600,70366,70,NULL,NULL,'2MASX J20451954-0617358',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00013,NULL,'17.3g',0.27,NULL,NULL,NULL,NULL,NULL,1,311.331333,-6.29325,0.117,NULL,50793173072,793643329,12400677,17.3),(148028,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148028,35.3,0.47,115,70367,70,NULL,NULL,'ESO 285- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.34',0.6,'(L)SA0^0',NULL,NULL,NULL,NULL,1,311.3347917,-45.61567,0.017,NULL,51395277559,803051211,12547675,14.34),(148029,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148029,28.66,NULL,5.4,70368,NULL,NULL,NULL,'KKR 55',NULL,'2000A&A...362..544K',2000,1,0.6,NULL,'G',0.000002,NULL,'17.0',0.4,'Ir',NULL,NULL,NULL,NULL,1,311.336625,60.41111,2.325,NULL,53476403223,835568800,13055762,17),(148030,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148030,28.85,NULL,5.9,70368,NULL,NULL,NULL,'KKR 55',NULL,'1997AstL...23..373S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148031,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15822','RN',148031,40.52,0.14,1030,70369,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15822',0.2333,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148032,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15822','RN',148032,40.62,0.26,1080,70369,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15822',0.2333,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148033,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148033,35.59,0.51,131,70370,70,NULL,NULL,'2MASX J20452657-5318297',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.17',0.33,'S',NULL,NULL,NULL,NULL,1,311.360583333,-53.30822,0.105,NULL,51073863443,798029116,12469204,16.17),(148034,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148034,36.23,0.49,176,70371,75,NULL,'IR','2MFGC 15724',NULL,'2011yCatp016004901K',2011,1,0.53,NULL,'G',0.000037,NULL,'17.31',0.14,'Sc',NULL,NULL,NULL,NULL,1,311.384417,-52.71653,0.045,NULL,51071226167,797987908,12468561,17.31),(148035,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148035,36.36,0.43,187,70371,NULL,NULL,'Malmquist cor.','2MFGC 15724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148036,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148036,36.4,0.43,190,70371,NULL,NULL,NULL,'2MFGC 15724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148037,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148037,36.44,0.2,194,70371,74.4,NULL,NULL,'2MFGC 15724',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148038,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 13615',NULL,148038,39.66,0.25,854,70372,70,NULL,'SN photometric redshift distance, z photo =0.224 +/- 0.031','SDSS-II SN 13615',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.412333,1.18661,0.357,NULL,53969914975,843279921,13176248,NULL),(148039,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148039,36.35,0.46,186,70373,NULL,NULL,'Malmquist cor.','2MASX J20454491-5245416',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.000033,NULL,'16.64',0.16,'Sc',NULL,NULL,NULL,NULL,1,311.437,-52.76167,0.045,NULL,51071229037,797987953,12468561,16.64),(148040,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148040,36.42,0.45,192,70373,NULL,NULL,NULL,'2MASX J20454491-5245416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148041,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148041,36.46,0.2,196,70373,74.4,NULL,NULL,'2MASX J20454491-5245416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148042,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148042,38.29,0.46,455,70374,70,NULL,NULL,'2MASX J20454992-0619498',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00009,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,311.4579583,-6.33047,0.117,NULL,50793197664,793643713,12400683,18.2),(148043,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148043,36.27,0.52,179,70375,70,NULL,NULL,'ESO 234- G 068',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.34',0.8,'SAB(s)0^0^:',NULL,NULL,NULL,NULL,1,311.4677083,-51.10747,0.009,NULL,51084526477,798195726,12471808,14.34),(148044,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148044,33.1,0.22,41.1,70376,74.2,NULL,'SALT 2','ESO 234- G 069',0.014,'2010ApJ...716..712A',2010,1,2.1,NULL,'G',0.000027,NULL,'14.15',0.7,'SAB(s)c',NULL,NULL,NULL,NULL,1,311.477375,-51.39111,0.021,NULL,51070957080,797983704,12468495,14.15),(148045,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148045,33.49,0.03,49.2,70376,70,NULL,'SALT 2','ESO 234- G 069',0.014,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148046,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148046,33.77,0.19,56,70376,72,NULL,NULL,'ESO 234- G 069',0.014,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148047,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148047,33.78,0.21,56.2,70376,70,NULL,'SALT','ESO 234- G 069',0.014,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148048,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148048,33.75,0.08,56.2,70376,74.4,NULL,NULL,'ESO 234- G 069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148049,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148049,33.84,0.21,57.8,70376,70,NULL,'SALT 2','ESO 234- G 069',0.014,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148050,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148050,33.82,0.07,58.1,70376,60,NULL,'M(B) = -19.48 mag','ESO 234- G 069',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148051,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148051,33.88,0.2,58.9,70376,73.8,NULL,'SALT 2 (SNANA)','ESO 234- G 069',0.0138,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148052,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148052,33.88,0.17,59.7,70376,70.8,NULL,NULL,'ESO 234- G 069',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148053,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148053,33.92,0.11,60,70376,65,NULL,'MLCS','ESO 234- G 069',0.014,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148054,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148054,33.9,0.06,60.3,70376,60,NULL,'M(V) = -19.47 mag','ESO 234- G 069',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148055,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148055,33.96,0.23,61.2,70376,65,NULL,'MLCS17','ESO 234- G 069',0.014,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148056,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148056,33.98,0.04,61.6,70376,72,NULL,NULL,'ESO 234- G 069',0.014,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148057,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148057,33.96,0.06,61.9,70376,60,NULL,'M(I) = -19.19 mag','ESO 234- G 069',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148058,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148058,34.02,0.25,62.9,70376,65,NULL,'SALT2','ESO 234- G 069',0.014,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148059,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148059,34.03,0.23,63.1,70376,65,NULL,'MLCS31','ESO 234- G 069',0.014,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148060,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148060,34.13,0.07,65,70376,65,NULL,'MLCS2k2','ESO 234- G 069',0.014,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148061,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148061,34.12,0.25,65.8,70376,65,NULL,NULL,'ESO 234- G 069',0.014,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148062,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148062,34.13,0.14,66.1,70376,65,NULL,'Template','ESO 234- G 069',0.014,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148063,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 1992al',NULL,148063,34.2,0.14,69.2,70376,60,NULL,NULL,'ESO 234- G 069',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148064,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148064,33.64,0.8,53.6,70376,75,NULL,'MAT, I','ESO 234- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148065,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148065,33.21,0.32,43.9,70376,85,NULL,'I, raw','ESO 234- G 069',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148066,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148066,33.24,0.32,44.5,70376,85,NULL,'I, inv','ESO 234- G 069',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148067,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148067,33.33,0.43,46.4,70376,75,NULL,'MAT, I, raw','ESO 234- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148068,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148068,33.42,0.49,48.4,70376,75,NULL,'IR','ESO 234- G 069',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148069,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148069,33.48,0.43,49.6,70376,75,NULL,'MAT, I, inv','ESO 234- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148070,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148070,33.71,0.43,55.2,70376,75,NULL,'MAT, I, cor','ESO 234- G 069',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148071,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148071,33.9,0.4,60.4,70376,NULL,NULL,'mean','ESO 234- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148072,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148072,34.24,0.47,70.4,70376,NULL,NULL,'H','ESO 234- G 069',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148073,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148073,36.53,0.46,202,70377,70,NULL,NULL,'2MASX J20460047+0023316',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000178,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,311.502,0.39206,0.373,NULL,53965949346,843217958,13175280,16.5),(148074,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148074,32.65,0.8,33.9,70378,75,NULL,'HMCL, I','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,1,1,'Confused HIPASS source','G',0.000024,NULL,'15.54',0.7,'SB(s)m',NULL,NULL,NULL,NULL,1,311.5035,-45.84961,0.017,NULL,51396407966,803068874,12547951,15.54),(148075,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148075,32.65,0.8,33.9,70378,75,NULL,'MAT, I','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148076,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148076,32.71,0.8,34.8,70378,75,NULL,NULL,'ESO 285- G 051',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148077,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148077,33.63,0.32,53.3,70378,85,NULL,'I, inv','ESO 285- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148078,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148078,33.66,0.32,53.9,70378,85,NULL,'I, raw','ESO 285- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148079,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148079,33.8,0.43,57.6,70378,75,NULL,'MAT, I, inv','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148080,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148080,33.85,0.43,58.8,70378,75,NULL,'MAT, I, raw','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148081,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148081,34.15,0.43,67.7,70378,75,NULL,'MAT, I, cor','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148082,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148082,35.1,0.4,105,70378,75,NULL,'HMCL, I, raw','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148083,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148083,35.17,0.4,108,70378,75,NULL,'HMCL, I, inv','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148084,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148084,35.34,0.4,117,70378,75,NULL,'HMCL, I, cor','ESO 285- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148085,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148085,35.33,0.46,116,70379,70,NULL,NULL,'2MASX J20460301-0544280',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00008,NULL,'15.5g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,311.512667,-5.74097,0.229,NULL,50739446388,792803849,12387560,15.5),(148086,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148086,34.06,0.48,64.8,70380,70,NULL,NULL,'ESO 234- G 070',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'14.56',1,'S0',NULL,NULL,NULL,NULL,1,311.5152083,-51.61606,0.025,NULL,51071143656,797986619,12468540,14.56),(148087,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148087,35.17,0.8,108,70381,75,NULL,'MAT, I','IC 1330',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.6b',0.4,'Sc? sp',NULL,NULL,NULL,NULL,1,311.56225,-14.02322,0.129,NULL,50985449462,796647647,12447619,14.6),(148088,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148088,34.85,0.43,93.2,70381,75,NULL,'MAT, I, raw','IC 1330',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148089,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148089,34.94,0.32,97.3,70381,85,NULL,'I, raw','IC 1330',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148090,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148090,35.01,0.32,101,70381,85,NULL,'I, inv','IC 1330',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148091,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148091,35.07,0.47,103,70381,NULL,NULL,'H','IC 1330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148092,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148092,35.13,0.43,106,70381,75,NULL,'MAT, I, cor','IC 1330',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148093,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148093,35.14,0.43,107,70381,75,NULL,'MAT, I, inv','IC 1330',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148094,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148094,35.15,0.45,107,70381,NULL,NULL,'K','IC 1330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148095,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148095,35.19,0.39,109,70381,NULL,NULL,NULL,'IC 1330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148096,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148096,35.23,0.2,111,70381,74.4,NULL,NULL,'IC 1330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148097,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148097,35.25,0.46,112,70381,NULL,NULL,'J','IC 1330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148098,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148098,35.25,0.4,112,70381,NULL,NULL,'mean','IC 1330',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148099,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148099,35.28,0.37,114,70381,NULL,NULL,'Malmquist cor.','IC 1330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148100,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148100,37.07,0.76,260,70382,70,NULL,NULL,'2MASX J20461652-5209506',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'17.1b',0.15,NULL,NULL,NULL,NULL,NULL,1,311.5689583,-52.16408,0.025,NULL,51071892863,797998325,12468723,17.1),(148101,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148101,36.35,0.5,186,70383,70,NULL,NULL,'2MASX J20462184-5237231',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.000103,NULL,'15.1R',0.19,NULL,NULL,NULL,NULL,NULL,1,311.5909583,-52.62303,0.045,NULL,51071742612,797995978,12468687,15.1),(148102,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148102,37.81,0.46,364,70384,70,NULL,NULL,'2MASX J20462663-0714301',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000066,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,311.611083,-7.24183,0.233,NULL,50793511392,793648615,12400759,18.1),(148103,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148103,36.65,0.49,213,70385,70,NULL,NULL,'ESO 234- G 071',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000103,NULL,'15.87',0.2,'N',NULL,NULL,NULL,NULL,1,311.64925,-50.11978,0,NULL,51348703061,802323485,12536304,15.87),(148104,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148104,37.11,0.77,264,70386,70,NULL,NULL,'2MASX J20463654-7317503',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,311.652,-73.29731,0.197,NULL,49208612503,768884570,12013821,15.6),(148105,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148105,34.43,0.48,76.7,70387,70,NULL,NULL,'ESO 529- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000097,NULL,'14.5',1,'S0-:     poss. LINER',NULL,NULL,NULL,NULL,1,311.655125,-23.63047,0.173,NULL,50821346697,794083542,12407555,14.5),(148106,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05735',NULL,148106,39.35,0.51,741,70388,70,NULL,'SN photometric redshift distance, z photo =0.191 +/- 0.058','SDSS-II SN 05735',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.6587917,0.65058,0.373,NULL,53965044484,843203820,13175059,NULL),(148107,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148107,35.42,0.49,121,70389,70,NULL,NULL,'ESO 144- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000117,NULL,'14.75',0.6,'(L)SB(s)0^+',NULL,NULL,NULL,NULL,1,311.665083,-58.68639,0.297,NULL,49131937402,767686521,11995101,14.75),(148108,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148108,35.62,0.53,133,70390,70,NULL,NULL,'AM 2043-442 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00013,NULL,'14.1R',0.33,NULL,NULL,NULL,NULL,NULL,1,311.681583333,-44.28281,0.037,NULL,51394923042,803045672,12547588,14.1),(148109,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 09268',NULL,148109,40.67,0.19,1360,70391,70,NULL,'SN photometric redshift distance, z photo =0.389 +/- 0.047','SDSS-II SN 09268',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.6865,-0.17425,0.297,NULL,47787918251,746686222,11666972,NULL),(148110,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148110,34.48,0.56,78.6,70392,70,NULL,NULL,'ESO 285- G 052',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.61',1,'S0- pec',NULL,NULL,NULL,NULL,1,311.6935,-44.63444,0.033,NULL,51394993693,803046776,12547605,14.61),(148111,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148111,36.77,0.54,226,70393,70,NULL,NULL,'2MASX J20464694-5311012',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.82',0.42,'SBa','Group member',NULL,NULL,NULL,1,311.695625,-53.18364,0.089,NULL,51073906958,798029796,12469215,15.82),(148112,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148112,36.03,0.72,161,70394,70,NULL,NULL,'2MASX J20464710-7759067',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,311.696125,-77.98519,0.433,NULL,48580614183,759072096,11860501,16.4),(148113,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148113,33.63,0.8,53.3,70395,75,NULL,'MAT, I','IC 5038',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'13.38',0.7,'(R\':)SB(s)bc   HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,311.7152083,-65.01681,0.105,NULL,49370604279,771415691,12053370,13.38),(148114,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148114,32.48,0.32,31.4,70395,85,NULL,'I, raw','IC 5038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148115,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148115,32.5,0.32,31.6,70395,85,NULL,'I, inv','IC 5038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148116,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148116,32.65,0.43,33.9,70395,75,NULL,'MAT, I, raw','IC 5038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148117,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148117,32.77,0.43,35.8,70395,75,NULL,'MAT, I, inv','IC 5038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148118,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148118,32.95,0.43,38.9,70395,75,NULL,'MAT, I, cor','IC 5038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148119,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148119,33.3,0.47,45.7,70395,NULL,NULL,'H','IC 5038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148120,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148120,33.43,0.46,48.6,70395,NULL,NULL,'J','IC 5038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148121,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148121,33.46,0.45,49.2,70395,NULL,NULL,'K','IC 5038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148122,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148122,33.66,0.4,54.1,70395,NULL,NULL,'mean','IC 5038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148123,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148123,33.85,0.09,59,70395,NULL,NULL,NULL,'IC 5038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148124,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148124,27.81,NULL,3.65,70396,NULL,NULL,'Blue','DDO 210',NULL,'1997AstL...23..644G',1997,1,2.2,NULL,'G',0.000007,NULL,'14.0B',1.1,'IB(s)m','Group member',NULL,NULL,NULL,1,311.715875,-12.84792,0.141,NULL,50979666748,796557292,12446207,14),(148125,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148125,27.81,NULL,3.65,70396,NULL,NULL,'LF','DDO 210',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148126,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148126,28.1,NULL,4.17,70396,NULL,NULL,'Red + Blue','DDO 210',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148127,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148127,28.1,0.4,4.17,70396,NULL,NULL,'3B + 3R mean','DDO 210',NULL,'1997AstL...23..656G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148128,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148128,28.2,NULL,4.37,70396,NULL,NULL,'Red','DDO 210',NULL,'1997AstL...23..644G',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148129,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148129,24.6,NULL,0.8,70396,NULL,NULL,NULL,'DDO 210',NULL,'1994AJ....107.1328V',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148130,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148130,24.85,NULL,0.933,70396,NULL,NULL,NULL,'DDO 210',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148131,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148131,24.95,0.1,0.977,70396,NULL,NULL,NULL,'DDO 210',NULL,'2014ApJ...795...54C',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148132,'CMD','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148132,28,NULL,3.98,70396,NULL,NULL,NULL,'DDO 210',NULL,'1993AJ....105..894G',1993,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148133,'RR Lyrae','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148133,25.07,0.12,1.03,70396,NULL,NULL,'32, BI','DDO 210',NULL,'2016MNRAS.455.2163O',2016,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148134,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148134,24.86,0.14,0.938,70396,NULL,NULL,NULL,'DDO 210',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148135,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148135,24.86,0.1,0.94,70396,NULL,NULL,NULL,'DDO 210',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148136,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148136,24.89,0.11,0.95,70396,NULL,NULL,'I','DDO 210',NULL,'1999AJ....118..853L',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148137,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148137,24.93,0.14,0.968,70396,NULL,NULL,'I','DDO 210',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148138,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148138,25.02,0.08,1.01,70396,74.4,NULL,NULL,'DDO 210',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148139,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148139,25.05,0.11,1.03,70396,NULL,NULL,NULL,'DDO 210',NULL,'1999IAUS..192..268L',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148140,'TRGB','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148140,25.15,0.08,1.07,70396,NULL,NULL,NULL,'DDO 210',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148141,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148141,24.23,0.8,0.7,70396,75,NULL,NULL,'DDO 210',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148142,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 20097','R',148142,40.13,0.13,868,70397,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007rd','SN 2007rd',0.221,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,311.7545417,-0.09933,0.297,NULL,47787910374,746686099,11666970,NULL),(148143,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 20097','R',148143,40.23,0.23,912,70397,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007rd','SN 2007rd',0.221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148144,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148144,36.58,0.88,207,70398,70,NULL,NULL,'2MASX J20470246-3503429',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.69',0.19,NULL,NULL,NULL,NULL,NULL,1,311.7602083,-35.06194,0.157,NULL,51524609761,805072027,12579250,16.69),(148145,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148145,36.56,0.69,205,70399,70,NULL,NULL,'2MASX J20470270-1358005',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000013,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,311.7614583,-13.96678,0.129,NULL,50980194955,796565546,12446336,16.1),(148146,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148146,36.59,0.72,207,70400,70,NULL,NULL,'2MASX J20470769-7214285',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,311.782125,-72.24133,0.157,NULL,49327437577,770741212,12042831,15.8),(148147,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148147,34.29,0.27,72,70401,70,NULL,NULL,'NGC 6961',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000023,NULL,'14.74',0.5,'E+ pec?','Group member',NULL,NULL,NULL,1,311.7937917,0.36328,0.365,NULL,53965200829,843206262,13175097,14.74),(148148,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18590','R',148148,39.08,0.08,620,70402,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007nw','2MASX J20471136-0115292',0.057185,'2014arXiv1401.3317S',2014,1,0.33,NULL,'G',0.000202,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,311.797375,-1.25806,0.233,NULL,47797015922,746828373,11669193,17.2),(148149,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18590','R',148149,39.87,0.21,893,70402,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007nw','2MASX J20471136-0115292',0.057185,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148150,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007nw',NULL,148150,37.31,0.09,274,70402,NULL,NULL,'SCM 55 SNII','2MASX J20471136-0115292',0.057185,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148151,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007nw',NULL,148151,37.49,0.11,297,70402,NULL,NULL,'SCM 15 SDSS SNII','2MASX J20471136-0115292',0.057185,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148152,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148152,36.72,0.58,220,70403,70,NULL,NULL,'2MASX J20471507-5331222',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.86',0.53,'S0',NULL,NULL,NULL,NULL,1,311.81275,-53.52286,0.097,NULL,51074027019,798031672,12469244,15.86),(148153,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148153,34.02,0.47,63.7,70404,70,NULL,NULL,'2MFGC 15746',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000063,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,311.815041667,-76.44372,0.337,NULL,48534752499,758355507,11849304,15.9),(148154,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148154,36.73,0.57,222,70405,70,NULL,NULL,'2MASX J20471674-6703006',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'15.7R',0.12,NULL,NULL,NULL,NULL,NULL,1,311.8199583,-67.05011,0.133,NULL,49390473923,771726155,12058221,15.7),(148155,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148155,37.17,0.5,272,70406,70,NULL,NULL,'ESO 234- G 072',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.71',0.4,'Sa',NULL,NULL,NULL,NULL,1,311.822833,-51.36594,0.025,NULL,51340406672,802193854,12534278,15.71),(148156,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148156,33.1,0.23,41.1,70407,74.2,NULL,'SALT 2','NGC 6962',0.014046,'2010ApJ...716..712A',2010,1,2.9,NULL,'G',0.00007,NULL,'13.3g',2.3,'SAB(r)ab','Pair member (points to parent)',NULL,NULL,NULL,1,311.829417,0.32081,0.365,NULL,53965208943,843206389,13175099,13.3),(148157,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148157,33.65,0.03,53,70407,72,NULL,'SALT2','NGC 6962',0.014046,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148158,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148158,33.75,0.08,56.2,70407,74.4,NULL,NULL,'NGC 6962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148159,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148159,33.81,0.21,57.1,70407,70,NULL,'SALT 2','NGC 6962',0.014046,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148160,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148160,33.84,0.2,57.7,70407,73.8,NULL,'SALT 2 (SNANA)','NGC 6962',0.0137,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148161,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148161,33.92,0.04,60,70407,70,NULL,'SALT 2','NGC 6962',0.014046,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148162,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148162,34.01,0.27,62.4,70407,65,NULL,'SALT2','NGC 6962',0.014046,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148163,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148163,34.01,0.24,62.6,70407,65,NULL,'MLCS17','NGC 6962',0.014046,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148164,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2002ha',NULL,148164,34.03,0.24,63.1,70407,65,NULL,'MLCS31','NGC 6962',0.014046,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148165,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148165,33.74,0.45,56.1,70407,NULL,NULL,'K','NGC 6962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148166,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148166,33.75,0.08,56.2,70407,74.4,NULL,NULL,'NGC 6962',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148167,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148167,33.76,0.4,56.4,70407,NULL,NULL,'mean','NGC 6962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148168,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148168,33.76,0.6,56.5,70407,NULL,NULL,'Malmquist cor.','NGC 6962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148169,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148169,33.77,0.47,56.8,70407,NULL,NULL,'H','NGC 6962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148170,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148170,33.78,0.46,57,70407,NULL,NULL,'J','NGC 6962',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148171,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148171,33.78,0.59,57.1,70407,NULL,NULL,NULL,'NGC 6962',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148172,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148172,34.27,0.43,71.4,70407,75,NULL,'3.6 micron, color corrected','NGC 6962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148173,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148173,34.28,0.4,71.8,70407,75,NULL,'HOSTS SN 2002ha','NGC 6962',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148174,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148174,34.35,0.42,74.1,70407,NULL,18.48,'3.6 micron','NGC 6962',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148175,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148175,34.45,0.43,77.7,70407,75,NULL,'3.6 micron, color + selection bias corrected','NGC 6962',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148176,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03543',NULL,148176,39.35,1.19,741,70408,70,NULL,'SN photometric redshift distance, z photo =0.191 +/- 0.170','SDSS-II SN 03543',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.834208333,0.05344,0.309,NULL,53965180629,843205947,13175092,NULL),(148177,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148177,33.77,0.44,56.8,70409,95,NULL,'Weighted Mean','NGC 6965',NULL,'1984ApJS...56...91D',1984,1,0.7,'NGC 6963 is a double star.','G',0.000087,NULL,'14.9g',0.6,'S0^0^:','Group member',NULL,NULL,NULL,1,311.834875,0.48406,0.365,NULL,53965068506,843204195,13175065,14.9),(148178,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148178,33.78,0.63,57,70409,95,NULL,'Michard 1979b, c','NGC 6965',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148179,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148179,34.61,0.46,83.6,70409,95,NULL,'Michard 1979a','NGC 6965',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148180,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148180,34.29,0.27,72,70409,70,NULL,NULL,'NGC 6965',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148181,'Tertiary','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148181,33.25,0.5,44.7,70409,95,NULL,NULL,'NGC 6965',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148182,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fl',NULL,148182,39.49,0.15,641,70410,74.2,NULL,'SALT 2','SDSS J204722.09-011511.8',0.234,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',NULL,NULL,'20.2g',0.07,NULL,NULL,NULL,NULL,NULL,1,311.842083,-1.25331,0.269,NULL,47797041397,746828771,11669199,20.2),(148183,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fl',NULL,148183,40.16,0.18,872,70410,70,NULL,'SALT 2','SDSS J204722.09-011511.8',0.234,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148184,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02030','R',148184,40.26,0.26,907,70410,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fl','SDSS J204722.09-011511.8',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148185,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02030','R',148185,40.36,0.18,953,70410,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fl','SDSS J204722.09-011511.8',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148186,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148186,37.06,0.57,258,70411,70,NULL,NULL,'2MASX J20472420-4246487',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,311.850916667,-42.78017,0.057,NULL,51383193759,802862402,12544725,15.1),(148187,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148187,33.55,0.44,51.3,70412,95,NULL,'Weighted Mean','NGC 6964',NULL,'1984ApJS...56...91D',1984,1,1.7,NULL,'G',0.000053,NULL,'13.8g',1.3,'E+ pec:','Pair member (points to parent)',NULL,NULL,NULL,1,311.85125,0.30083,0.365,NULL,53965209327,843206395,13175099,13.8),(148188,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148188,33.64,0.63,53.5,70412,95,NULL,'Michard 1979b, c','NGC 6964',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148189,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148189,34.31,0.46,72.8,70412,95,NULL,'Michard 1979a','NGC 6964',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148190,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148190,34.29,0.27,72,70412,70,NULL,NULL,'NGC 6964',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148191,'Tertiary','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148191,33.25,0.5,44.7,70412,95,NULL,NULL,'NGC 6964',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148192,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148192,33.62,0.4,52.9,70412,NULL,NULL,'mean','NGC 6964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148193,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148193,34.11,0.45,66.4,70412,NULL,NULL,'K','NGC 6964',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148194,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14472','RN',148194,42.69,0.18,2530,70413,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14472',0.3643,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148195,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14472','RN',148195,42.92,0.28,2820,70413,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14472',0.3643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148196,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148196,36.63,0.72,212,70414,70,NULL,NULL,'2MASX J20473965-4450308',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'15.1R',0.28,NULL,NULL,NULL,NULL,NULL,1,311.915333,-44.84192,0.029,NULL,51395888106,803060751,12547824,15.1),(148197,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148197,35.76,0.63,142,70415,70,NULL,NULL,'2MASX J20474862-5212436',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.4b',0.15,'S0','Group member',NULL,NULL,NULL,1,311.952625,-52.21203,0.029,NULL,51071809727,797997026,12468703,16.4),(148198,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03367','RN',148198,42.83,0.18,2280,70416,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03367',0.616329,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148199,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14305',NULL,148199,40.25,0.14,1120,70417,70,NULL,'SN photometric redshift distance, z photo =0.307 +/- 0.024','SDSS-II SN 14305',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,311.969083333,-0.5935,0.269,NULL,47796396978,746818702,11669042,NULL),(148200,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148200,37.61,0.46,333,70418,70,NULL,NULL,'GALEXMSC J204754.34+003913.1',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'UvS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,311.9764583,0.65367,0.357,NULL,53969361001,843271265,13176113,NULL),(148201,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148201,33.55,0.49,51.3,70419,75,NULL,'IR','UGC 11631',NULL,'2011yCatp016004901K',2011,1,0.67,NULL,'G',0.000017,NULL,'15.1g',0.38,'Im:;LLIRG      HII',NULL,NULL,NULL,NULL,1,311.9997917,-0.18,0.297,NULL,47787858420,746685287,11666957,15.1),(148202,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148202,36.16,0.46,171,70420,NULL,NULL,'Malmquist cor.','2MASX J20480119-5258087',NULL,'2009ApJS..182..474S',2009,1,0.72,NULL,'G',0.000033,NULL,'15.11',0.48,'Sb','Group member',NULL,NULL,NULL,1,312.0050417,-52.96903,0.081,NULL,51073638037,798025594,12469149,15.11),(148203,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148203,36.42,0.41,192,70420,NULL,NULL,NULL,'2MASX J20480119-5258087',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148204,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148204,36.46,0.2,196,70420,74.4,NULL,NULL,'2MASX J20480119-5258087',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148205,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06326','R',148205,40.33,0.23,951,70421,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06326',0.2228,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.01425,-0.80961,0.249,NULL,47797063218,746829112,11669204,NULL),(148206,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 06326','R',148206,40.4,0.14,983,70421,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06326',0.2228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148207,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148207,35.1,0.8,105,70422,75,NULL,'MAT, I','ESO 463- G 025',NULL,'1997ApJS..109..333W',1997,1,2.46,NULL,'G',0.000033,NULL,'15.61',0.21,'SBd: sp',NULL,NULL,NULL,NULL,1,312.026,-30.22658,0.293,NULL,51496000374,804625005,12572265,15.61),(148208,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148208,34.99,0.43,99.6,70422,75,NULL,'MAT, I, raw','ESO 463- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148209,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148209,35.03,0.49,101,70422,75,NULL,'IR','ESO 463- G 025',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148210,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148210,35.23,NULL,111,70422,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 463- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148211,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148211,35.25,0.32,112,70422,85,NULL,'I, raw','ESO 463- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148212,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148212,35.24,NULL,112,70422,NULL,NULL,'Dipole','ESO 463- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148213,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148213,35.24,NULL,112,70422,NULL,NULL,'Dipole + Quadrupole','ESO 463- G 025',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148214,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148214,35.28,NULL,114,70422,NULL,NULL,NULL,'ESO 463- G 025',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148215,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148215,35.28,0.43,114,70422,75,NULL,'MAT, I, inv','ESO 463- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148216,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148216,35.32,0.32,116,70422,85,NULL,'I, inv','ESO 463- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148217,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148217,35.31,0.52,116,70422,NULL,NULL,'Malmquist cor.','ESO 463- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148218,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148218,35.39,0.43,119,70422,75,NULL,'MAT, I, cor','ESO 463- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148219,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148219,35.41,0.49,121,70422,NULL,NULL,NULL,'ESO 463- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148220,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148220,35.43,0.4,122,70422,NULL,NULL,'mean','ESO 463- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148221,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148221,35.45,0.2,123,70422,74.4,NULL,NULL,'ESO 463- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148222,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148222,35.51,0.47,127,70422,NULL,NULL,'H','ESO 463- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148223,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148223,35.62,0.45,133,70422,NULL,NULL,'K','ESO 463- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148224,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148224,36.76,0.57,225,70423,70,NULL,NULL,'2MASX J20480771-5713152',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000103,NULL,'16.59',0.36,NULL,NULL,NULL,NULL,NULL,1,312.0322917,-57.22092,0.301,NULL,49138608886,767790763,11996730,16.59),(148225,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148225,35.84,0.56,147,70424,70,NULL,NULL,'2MASX J20480812-4514354',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,'(R_1)SB0/a:',NULL,NULL,NULL,NULL,1,312.0340417,-45.24303,0.025,NULL,51395930085,803061407,12547834,15.1),(148226,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17800','R',148226,40.1,0.28,861,70425,70,NULL,'SDSS CAND. zSNIa; SALT 2; SN 2007kn','SDSS J204809.20-010054.3',0.217,'2014arXiv1401.3317S',2014,1,0.14,NULL,'G',NULL,NULL,'21.1g',0.04,NULL,NULL,NULL,NULL,NULL,1,312.038375,-1.01508,0.249,NULL,47797214496,746831476,11669241,21.1),(148227,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17800','R',148227,40.14,0.27,878,70425,70,NULL,'SDSS CAND. zSNIa; MLCS2K2; SN 2007kn','SDSS J204809.20-010054.3',0.217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148228,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148228,36.31,0.67,183,70426,70,NULL,NULL,'2MASX J20480948-2314591',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.4R',0.16,NULL,NULL,NULL,NULL,NULL,1,312.0395417,-23.24986,0.157,NULL,50819722658,794058166,12407158,15.4),(148229,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 08477','RN',148229,37.67,0.23,323,70427,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08477',0.056335,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148230,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148230,38.46,0.11,435,70428,74.2,NULL,'SALT 2','SDSS J204810.43-011016.8',0.13,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'20.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,312.0435,-1.17136,0.269,NULL,47796994872,746828044,11669188,20.9),(148231,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148231,38.56,0.03,455,70428,70,NULL,'SDSS-II SN 02031','SDSS J204810.43-011016.8',0.13,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148232,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148232,39.22,0.12,617,70428,70,NULL,'SDSS-II SN 02031, SALT 2','SDSS J204810.43-011016.8',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148233,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148233,39.22,0.07,619,70428,65,NULL,'SALT2','SDSS J204810.43-011016.8',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148234,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02031','R',148234,39.24,0.19,623,70428,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fm','SDSS J204810.43-011016.8',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148235,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fm',NULL,148235,39.47,0.08,692,70428,65,NULL,'MLCS2k2','SDSS J204810.43-011016.8',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148236,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02031','R',148236,39.51,0.09,705,70428,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fm','SDSS J204810.43-011016.8',0.13,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148237,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148237,35.9,0.77,151,70429,NULL,NULL,NULL,'ESO-LV 1870151',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'16.55',0.26,'Sc','Group member',NULL,NULL,NULL,1,312.043666667,-52.49219,0.033,NULL,51071615353,797993989,12468656,16.55),(148238,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148238,35.94,0.2,154,70429,74.4,NULL,NULL,'ESO-LV 1870151',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148239,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148239,36.27,0.65,179,70429,NULL,NULL,'Malmquist cor.','ESO-LV 1870151',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148240,'BCG','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148240,38.63,0.35,464,70430,60,NULL,NULL,'ABELL 2328',0.147,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,312.044167,-17.84389,0.225,NULL,50990816572,796731508,12448929,NULL),(148241,'BCG','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148241,38.63,0.35,464,70431,60,NULL,'ABELL 2328, BCG','2MASX J20481162-1749034',0.147,'1980ApJ...241..486H',1980,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,'E/D','Brightest group member',NULL,NULL,NULL,1,312.048125,-17.81775,0.225,NULL,50993635755,796775558,12449618,15.3),(148242,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148242,35.06,0.33,103,70432,NULL,NULL,NULL,'ESO 597- G 035',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000022,NULL,'16.09',0.2,'Sb             HII','in a triple',NULL,NULL,NULL,1,312.0499583,-19.83219,0.205,NULL,50947878689,796060604,12438446,16.09),(148243,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148243,35.1,0.2,105,70432,74.4,NULL,NULL,'ESO 597- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148244,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148244,35.35,0.29,117,70432,NULL,NULL,'Malmquist cor.','ESO 597- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148245,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148245,34.96,0.56,98.3,70433,70,NULL,NULL,'2MASX J20481208-6858217',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,'(R)SA0^0',NULL,NULL,NULL,NULL,1,312.050167,-68.97261,0.141,NULL,49336426485,770881663,12045025,14.2),(148246,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148246,36.55,0.89,204,70434,70,NULL,NULL,'2MASX J20481207-5346457',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.09',0.45,'S0',NULL,NULL,NULL,NULL,1,312.050333,-53.77944,0.093,NULL,51073815429,798028366,12469193,16.09),(148247,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148247,36.01,0.54,159,70435,70,NULL,NULL,'2MASX J20481472-5315497',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.66',0.48,'S0',NULL,NULL,NULL,NULL,1,312.0612917,-53.26389,0.097,NULL,51073598822,798024981,12469140,15.66),(148248,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148248,34.84,0.51,92.8,70436,70,NULL,NULL,'6dF J2048197-354037',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'13.4R',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,312.082166667,-35.67686,0.161,NULL,51524053153,805063330,12579114,13.4),(148249,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148249,35.72,0.47,140,70437,NULL,NULL,'Malmquist cor.','2MASX J20482125+1620167',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'16.0',0.15,NULL,NULL,NULL,NULL,NULL,1,312.0885417,16.33794,0.365,NULL,55258778808,863418418,13490912,16),(148250,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148250,35.75,0.2,141,70437,74.4,NULL,NULL,'2MASX J20482125+1620167',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148251,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148251,35.84,0.45,147,70437,NULL,NULL,NULL,'2MASX J20482125+1620167',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148252,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148252,35.57,0.57,130,70438,70,NULL,NULL,'2MASX J20482388-5319047',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.21',0.43,'S0',NULL,NULL,NULL,NULL,1,312.0995,-53.31803,0.097,NULL,51073712855,798026763,12469168,16.21),(148253,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148253,28.85,NULL,5.9,70439,NULL,NULL,NULL,'KKR 56',NULL,'1997AstL...23..373S',1997,1,0.7,NULL,'G',0.000027,NULL,'17.6',0.45,'Ir',NULL,NULL,NULL,NULL,1,312.1005,58.61828,NULL,NULL,53430268047,834847938,13044499,17.6),(148254,'Brightest Stars','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148254,29.04,NULL,6.4,70439,NULL,NULL,NULL,'KKR 56',NULL,'2000A&A...362..544K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148255,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148255,37.57,0.66,326,70440,70,NULL,NULL,'2MASX J20482414-4429305',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'14.9R',0.49,NULL,NULL,NULL,NULL,NULL,1,312.1005,-44.49178,0.037,NULL,51395127937,803048874,12547638,14.9),(148256,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01909','RN',148256,41.53,0.18,1360,70441,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01909',0.48507,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148257,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148257,33.95,0.4,61.5,70442,NULL,NULL,'mean','NGC 6969',NULL,'2007A&A...465...71T',2007,1,1.1,'RC3 has V = 4000 +- 60 km/sec.','G',0.00013,NULL,'14.89',0.3,'Sa','Isolated galaxy',NULL,NULL,NULL,1,312.115125,7.73997,0.393,NULL,55086186203,860721659,13448775,14.89),(148258,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148258,34.07,0.47,65,70442,NULL,NULL,'H','NGC 6969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148259,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148259,34.09,0.46,65.8,70442,NULL,NULL,'J','NGC 6969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148260,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148260,34.12,0.28,66.6,70442,NULL,NULL,'Malmquist cor.','NGC 6969',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148261,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148261,34.12,0.28,66.7,70442,NULL,NULL,NULL,'NGC 6969',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148262,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148262,34.13,0.45,67.1,70442,NULL,NULL,'K','NGC 6969',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148263,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148263,34.14,0.2,67.3,70442,74.4,NULL,NULL,'NGC 6969',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148264,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148264,34.19,0.49,68.8,70442,75,NULL,'IR','NGC 6969',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148265,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148265,32.65,0.8,33.9,70443,75,NULL,'MAT, I','IC 5026',NULL,'1997ApJS..109..333W',1997,1,2.8,'da Costa et al. (1991,ApJS, 75, 935) give v=15+/-32. Superimposed star.','G',0.000033,NULL,'15.42',0.24,'Sc',NULL,NULL,NULL,NULL,1,312.116875,-78.06925,0.433,NULL,48580699985,759073437,11860522,15.42),(148266,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148266,32.46,0.32,31,70443,85,NULL,'I, inv','IC 5026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148267,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148267,32.46,0.32,31.1,70443,85,NULL,'I, raw','IC 5026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148268,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148268,32.62,0.43,33.4,70443,75,NULL,'MAT, I, raw','IC 5026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148269,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148269,32.63,0.39,33.6,70443,73,NULL,'opt','IC 5026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148270,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148270,32.64,0.4,33.7,70443,75,NULL,NULL,'IC 5026',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148271,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148271,32.64,0.39,33.7,70443,73,NULL,'IR','IC 5026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148272,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148272,32.65,0.43,33.8,70443,75,NULL,'MAT, I, inv','IC 5026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148273,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148273,32.74,0.4,35.3,70443,73,NULL,'opt','IC 5026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148274,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148274,32.76,0.48,35.6,70443,NULL,NULL,NULL,'IC 5026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148275,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148275,32.8,0.2,36.3,70443,74.4,NULL,NULL,'IC 5026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148276,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148276,32.83,0.46,36.7,70443,NULL,NULL,'Malmquist cor.','IC 5026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148277,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148277,32.82,0.49,36.7,70443,75,NULL,'IR','IC 5026',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148278,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148278,32.89,NULL,37.8,70443,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148279,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148279,32.89,NULL,37.9,70443,NULL,NULL,'Dipole + Quadrupole','IC 5026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148280,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148280,32.9,NULL,38.1,70443,NULL,NULL,'Dipole','IC 5026',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148281,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148281,32.92,0.43,38.3,70443,75,NULL,'MAT, I, cor','IC 5026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148282,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148282,32.99,NULL,39.6,70443,NULL,NULL,NULL,'IC 5026',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148283,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148283,35.89,0.48,151,70444,70,NULL,NULL,'2MASX J20483442-4729244',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.16',0.3,'(R)SA0^+',NULL,NULL,NULL,NULL,1,312.143583,-47.49014,0.069,NULL,51394437736,803038089,12547470,16.16),(148284,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148284,38.33,0.46,464,70445,70,NULL,NULL,'2MASX J20483778-0613056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.0001,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,312.157417,-6.21825,0.205,NULL,50793657899,793650904,12400795,17.5),(148285,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148285,34.79,0.49,90.6,70446,75,NULL,'IR','FGC 2288',NULL,'2011yCatp016004901K',2011,1,2.08,NULL,'G',0.00015,NULL,'16.1',0.1,'Sd',NULL,NULL,NULL,NULL,1,312.1602083,-17.24175,0.177,NULL,50993778350,796777786,12449652,16.1),(148286,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148286,36.15,0.54,170,70447,70,NULL,NULL,'FAIRALL 0566',NULL,'2014MNRAS.445.2677S',2014,1,0.44,'1983MNRAS.203...47F has V = 17,600 +- 100.','G',0.00015,NULL,'16.27',0.32,NULL,NULL,NULL,NULL,NULL,1,312.165833,-49.79678,0,NULL,51348146554,802314789,12536168,16.27),(148287,'D-Sigma','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148287,32.35,0.4,29.5,70448,75,NULL,'Edat, raw','NGC 6958',NULL,'1997ApJS..109..333W',1997,1,2.1,'+4m 16s, +0.6m error in A-M position.','G',0.000043,NULL,'12.33',1.7,'E+          Sy;LINER','Isolated elliptical galaxy',NULL,NULL,NULL,1,312.1774583,-37.99742,0.093,NULL,51512133233,804877081,12576204,12.33),(148288,'D-Sigma','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148288,32.69,0.4,34.4,70448,75,NULL,'Edat, cor','NGC 6958',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148289,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148289,30.98,0.65,15.7,70448,95,NULL,'Weighted Mean','NGC 6958',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148290,'Faber-Jackson','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148290,32.19,0.81,27.4,70448,55,NULL,'Visvanathan & Sandage 1979','NGC 6958',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148291,'Tully est','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148291,32.74,0.8,35.4,70448,75,NULL,'B','NGC 6958',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148292,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148292,32.76,0.45,35.7,70448,NULL,NULL,'K','NGC 6958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148293,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148293,32.8,0.4,36.4,70448,NULL,NULL,'mean','NGC 6958',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148294,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02482','RN',148294,41.76,0.18,1540,70449,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02482',0.465715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148295,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18933',NULL,148295,39.96,0.33,982,70450,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.051','SDSS-II SN 18933',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,312.1960417,0.65997,0.357,NULL,53969288735,843270136,13176095,20.7),(148296,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148296,35.99,0.46,158,70451,70,NULL,NULL,'2MASX J20484709-0659396',NULL,'2015arXiv151105856S',2015,1,0.7,NULL,'G',0.000057,NULL,'15.3g',0.45,'HII',NULL,NULL,NULL,NULL,1,312.196125,-6.99439,0.285,NULL,50793362664,793646291,12400723,15.3),(148297,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148297,36.24,0.46,177,70452,NULL,NULL,NULL,'2MASX J20484768-5223327',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000033,NULL,'16.49',0.22,'Sb','Group member',NULL,NULL,NULL,1,312.198667,-52.39239,0.033,NULL,51071516005,797992437,12468631,16.49),(148298,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148298,36.26,0.46,178,70452,NULL,NULL,'Malmquist cor.','2MASX J20484768-5223327',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148299,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148299,36.28,0.2,180,70452,74.4,NULL,NULL,'2MASX J20484768-5223327',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148300,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fn',NULL,148300,37.36,0.04,271,70453,70,NULL,'SDSS-II SN 02102','SDSS J204853.04+001129.8',0.095,'2011ApJS..192....1C',2011,1,0.08,NULL,'G',NULL,NULL,'20.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,312.2210417,0.19161,0.365,NULL,53969215524,843268992,13176078,20.5),(148301,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fn',NULL,148301,37.46,0.12,284,70453,74.2,NULL,'SALT 2','SDSS J204853.04+001129.8',0.095,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148302,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02102','R',148302,38.26,0.19,408,70453,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fn','SDSS J204853.04+001129.8',0.1,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148303,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005fn',NULL,148303,38.26,0.13,409,70453,70,NULL,'SDSS-II SN 02102, SALT 2','SDSS J204853.04+001129.8',0.095,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148304,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 02102','R',148304,38.41,0.07,437,70453,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fn','SDSS J204853.04+001129.8',0.1,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148305,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148305,36.18,0.46,172,70454,70,NULL,NULL,'2MASX J20485459-0049167',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,312.2275417,-0.82139,0.269,NULL,47797056039,746829000,11669203,16.2),(148306,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148306,37.03,0.57,255,70454,70,NULL,NULL,'2MASX J20485459-0049167',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148307,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148307,34.39,0.4,75.5,70455,NULL,NULL,'mean','UGC 11642',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',NULL,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,312.2297917,70.23192,1.313,NULL,53634985840,838046653,13094478,16),(148308,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148308,34.52,0.47,80.1,70455,NULL,NULL,'H','UGC 11642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148309,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148309,34.63,0.45,84.2,70455,NULL,NULL,'K','UGC 11642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148310,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148310,34.63,0.46,84.2,70455,NULL,NULL,'J','UGC 11642',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148311,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148311,36.98,0.8,249,70456,70,NULL,NULL,'2MASX J20490151-3858165',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.82',0.38,NULL,NULL,NULL,NULL,NULL,1,312.256333,-38.97128,0.089,NULL,51514431661,804912994,12576765,16.82),(148312,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 14430',NULL,148312,39.93,0.35,969,70457,70,NULL,'SN photometric redshift distance, z photo =0.259 +/- 0.055','SDSS-II SN 14430',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,312.273417,-1.24019,0.221,NULL,47796950029,746827344,11669177,21.8),(148313,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148313,36.43,0.69,193,70458,70,NULL,NULL,'2MASX J20491587-5345163',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'17.2b',0.19,NULL,NULL,NULL,NULL,NULL,1,312.316,-53.75458,0.093,NULL,51073793060,798028016,12469187,17.2),(148314,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148314,36.88,0.53,237,70459,70,NULL,NULL,'2MFGC 15770',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'16.51',0.17,NULL,NULL,NULL,NULL,NULL,1,312.333875,-47.61183,0.073,NULL,51349077348,802329333,12536395,16.51),(148315,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148315,35.58,0.61,131,70460,70,NULL,NULL,'2MASX J20492169-5126424',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.4b',0.25,'S',NULL,NULL,NULL,NULL,1,312.3405,-51.44514,0.025,NULL,51340638570,802197477,12534335,16.4),(148316,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148316,37.22,0.58,278,70461,70,NULL,NULL,'AM 2045-521',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'16.3b',0.3,'S0','Group member',NULL,NULL,NULL,1,312.344167,-52.0015,0.025,NULL,51340443754,802194433,12534288,16.3),(148317,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148317,39.02,0.46,636,70462,70,NULL,NULL,'SDSS J204923.35-061143.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000099,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,312.347333,-6.19544,0.273,NULL,50793564148,793649439,12400772,18.5),(148318,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148318,37.78,0.46,360,70463,70,NULL,NULL,'SDSS J204924.48+011502.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,312.352,1.25061,0.453,NULL,53969639444,843275616,13176181,18.3),(148319,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148319,37.19,1.02,274,70464,70,NULL,NULL,'2MASX J20492595-1947303',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,312.358166667,-19.79172,0.425,NULL,50948007557,796062618,12438478,15.4),(148320,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148320,36.9,0.85,240,70465,70,NULL,NULL,'2MASX J20492915-5512175',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.000097,NULL,'15.81',0.57,'(R\')SB(r)a',NULL,NULL,NULL,NULL,1,312.371417,-55.20483,0.181,NULL,48993277969,765519968,11961249,15.81),(148321,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18596','R',148321,36.98,0.04,242,70466,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007ld','SDSS J204929.40+000016.8',0.03,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.3725,0.00467,0.361,NULL,53957648618,843088259,13173254,NULL),(148322,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18596','R',148322,37.41,0.54,294,70466,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007ld','SDSS J204929.40+000016.8',0.03,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148323,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007ld',NULL,148323,35,0.09,97,70466,NULL,NULL,'SCM 55 SNII','SDSS J204929.40+000016.8',0.03,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148324,'SNII optical','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007ld',NULL,148324,35.37,0.11,115,70466,NULL,NULL,'SCM 15 SDSS SNII','SDSS J204929.40+000016.8',0.03,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148325,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148325,32.42,0.49,30.5,70467,75,NULL,'IR','FGC 2574',NULL,'2011yCatp016004901K',2011,1,2.1,NULL,'G',0.000007,NULL,'15.7',0.2,'Sm',NULL,NULL,NULL,NULL,1,312.3864583,58.1065,NULL,NULL,53428386074,834818532,13044039,15.7),(148326,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148326,32.51,0.4,31.7,70467,75,NULL,NULL,'FGC 2574',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148327,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148327,33.55,NULL,51.2,70467,NULL,NULL,'Dipole','FGC 2574',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148328,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148328,33.55,NULL,51.3,70467,NULL,NULL,'Dipole + Quadrupole','FGC 2574',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148329,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148329,33.56,NULL,51.5,70467,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2574',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148330,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18241','R',148330,38.33,0.22,422,70468,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ks','SDSS J204933.01-004543.0',0.095,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.3875417,-0.76194,0.269,NULL,47783477566,746616836,11665888,NULL),(148331,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2007ks',NULL,148331,38.14,0.35,424,70468,70,NULL,'Hubble residual 0.20 for z0.09500','SDSS J204933.01-004543.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148332,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 18241','R',148332,38.61,0.1,481,70468,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ks','SDSS J204933.01-004543.0',0.095,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148333,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 01713','RN',148333,42.94,0.22,2620,70469,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01713',0.47519,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148334,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148334,33.9,0.69,60.2,70470,100,NULL,'mid-IR','UGC 11638',NULL,'2013ApJ...771...88L',2013,1,2,NULL,'G',0.000017,NULL,'13.84',1.3,'SBb:',NULL,NULL,NULL,NULL,1,312.401917,16.86558,0.333,NULL,55291054195,863922721,13498792,13.84),(148335,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148335,34.08,0.47,65.6,70470,NULL,NULL,'H','UGC 11638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148336,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148336,34.13,0.46,67,70470,NULL,NULL,'J','UGC 11638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148337,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148337,34.16,0.45,67.9,70470,NULL,NULL,'K','UGC 11638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148338,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148338,34.31,0.4,72.9,70470,NULL,NULL,'mean','UGC 11638',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148339,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 20430','R',148339,39.53,0.22,692,70471,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qj','SN 2007qj',0.164,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,312.416833,0.46864,0.357,NULL,53957806627,843090728,13173292,NULL),(148340,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 20430','R',148340,39.83,0.14,795,70471,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qj','SN 2007qj',0.164,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148341,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17170','RN',148341,40.32,0.25,950,70472,70,NULL,'SDSS CAND. SNIb; SALT 2','SDSS-II SN 17170',0.22,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148342,'SNIa SDSS','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 17170','RN',148342,40.56,0.21,1060,70472,70,NULL,'SDSS CAND. SNIb; MLCS2K2','SDSS-II SN 17170',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148343,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148343,35.52,0.45,127,70473,NULL,NULL,'Malmquist cor.','AM 2046-520 NED01',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000023,NULL,'15.57',0.23,'Sc','Group member',NULL,NULL,NULL,1,312.4357083,-51.94958,0.025,NULL,51341298582,802207790,12534496,15.57),(148344,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148344,35.57,0.44,130,70473,NULL,NULL,NULL,'AM 2046-520 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148345,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148345,35.61,0.2,132,70473,74.4,NULL,NULL,'AM 2046-520 NED01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148346,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148346,36.88,0.55,238,70474,70,NULL,NULL,'2MASX J20495029-4324345',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.66',0.63,'E',NULL,NULL,NULL,NULL,1,312.459583,-43.40964,0.065,NULL,51389812650,802965822,12546340,15.66),(148347,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148347,35.82,0.52,146,70475,NULL,NULL,NULL,'2MFGC 15783',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.000033,NULL,'16.3V',0.14,'Sd/I','Group member',NULL,NULL,NULL,1,312.4629583,-52.92,0.061,NULL,51073532491,798023945,12469124,16.3),(148348,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148348,35.86,0.2,149,70475,74.4,NULL,NULL,'2MFGC 15783',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148349,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148349,35.93,0.49,154,70475,NULL,NULL,'Malmquist cor.','2MFGC 15783',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148350,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148350,35.98,0.49,157,70475,75,NULL,'IR','2MFGC 15783',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148351,'IRAS','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148351,34.38,0.8,75.1,70476,75,NULL,'MAT, I','MCG -01-53-012',NULL,'1997ApJS..109..333W',1997,1,1.99,NULL,'G',0.000023,NULL,'15.2g',0.35,'Sb(f)',NULL,NULL,NULL,NULL,1,312.467625,-7.02181,0.293,NULL,50797013064,793703329,12401614,15.2),(148352,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148352,34.2,NULL,69.3,70476,NULL,NULL,'Dipole','MCG -01-53-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148353,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148353,34.22,NULL,69.8,70476,NULL,NULL,'Dipole + Quadrupole','MCG -01-53-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148354,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148354,34.23,NULL,70.1,70476,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -01-53-012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148355,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148355,34.55,0.49,81.4,70476,75,NULL,'IR','MCG -01-53-012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148356,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148356,34.61,0.4,83.6,70476,NULL,NULL,'mean','MCG -01-53-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148357,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148357,34.7,0.47,86.9,70476,NULL,NULL,'H','MCG -01-53-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148358,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148358,34.75,0.45,89.3,70476,NULL,NULL,'K','MCG -01-53-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148359,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148359,34.88,0.46,94.5,70476,NULL,NULL,'J','MCG -01-53-012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148360,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148360,34.94,0.43,97.1,70476,75,NULL,'3.6 micron, color corrected','MCG -01-53-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148361,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148361,34.94,0.43,97.4,70476,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-53-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148362,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148362,34.99,0.43,99.3,70476,75,NULL,'MAT, I, raw','MCG -01-53-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148363,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148363,35.01,0.2,100,70476,74.4,NULL,NULL,'MCG -01-53-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148364,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148364,35.03,0.47,101,70476,NULL,NULL,'Malmquist cor.','MCG -01-53-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148365,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148365,35.19,0.44,109,70476,NULL,NULL,NULL,'MCG -01-53-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148366,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148366,35.22,0.43,111,70476,75,NULL,'MAT, I, cor','MCG -01-53-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148367,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148367,35.31,0.32,115,70476,85,NULL,'I, raw','MCG -01-53-012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148368,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148368,35.31,0.43,115,70476,75,NULL,'MAT, I, inv','MCG -01-53-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148369,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148369,35.38,0.32,119,70476,85,NULL,'I, inv','MCG -01-53-012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148370,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148370,37.59,0.46,330,70477,70,NULL,NULL,'2MASX J20495263+0040058',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000138,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,312.469125,0.66833,0.405,NULL,53958481198,843101268,13173457,17.6),(148371,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148371,38.13,0.46,423,70478,70,NULL,NULL,'2MASX J20495315-0628516',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000086,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,312.471375,-6.48097,0.297,NULL,50793761993,793652531,12400820,18.2),(148372,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148372,36.66,0.46,215,70479,70,NULL,NULL,'2MASX J20495569+0053578',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000193,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,312.482125,0.89958,0.453,NULL,53958278604,843098103,13173407,16.6),(148373,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148373,35.72,0.62,140,70480,70,NULL,NULL,'2MASX J20500326-5247425',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15.1V',0.55,'E','Group member',NULL,NULL,NULL,1,312.513666667,-52.79503,0.061,NULL,51071460568,797991571,12468618,15.1),(148374,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148374,36.09,0.25,165,70480,74.4,NULL,NULL,'2MASX J20500326-5247425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148375,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148375,39.14,0.46,673,70481,70,NULL,NULL,'SDSS J205007.74-000701.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000157,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,312.5322917,-0.11719,0.333,NULL,47782787041,746606047,11665719,18.6),(148376,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148376,36.81,0.65,230,70482,70,NULL,NULL,'2MASX J20500788-1130246',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.3b',0.3,NULL,NULL,NULL,NULL,NULL,1,312.532917,-11.50681,0.189,NULL,50759396998,793115578,12392430,16.3),(148377,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148377,36.94,0.93,244,70483,70,NULL,NULL,'2MASX J20501352-6828211',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,312.5562917,-68.47264,0.133,NULL,49381578173,771587158,12056049,16.7),(148378,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148378,35.79,0.51,144,70484,70,NULL,NULL,'2MASX J20501393-1847085',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.90',0.5,NULL,NULL,NULL,NULL,NULL,1,312.5582083,-18.78583,0.229,NULL,50990429314,796725458,12448835,15.9),(148379,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148379,35.47,0.58,124,70485,70,NULL,NULL,'ESO 597- G 041',NULL,'2014MNRAS.445.2677S',2014,1,2.5,NULL,'G',0.000013,NULL,'15',1.8,'SAB(rs)b pec:',NULL,NULL,NULL,NULL,1,312.5624583,-19.42594,0.377,NULL,50947510512,796054851,12438357,15),(148380,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15293',NULL,148380,40.97,0.4,1560,70486,70,NULL,'SN photometric redshift distance, z photo =0.466 +/- 0.134','SDSS-II SN 15293',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.0g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,312.578875,-0.78781,0.285,NULL,47782992696,746609260,11665769,23),(148381,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005hq',NULL,148381,41.02,0.21,1140,70487,74.2,NULL,'SALT 2','SDSS J205019.95-004930.7',0.401,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'22.5g',0.02,NULL,NULL,NULL,NULL,NULL,1,312.583125,-0.82519,0.285,NULL,47783001442,746609397,11665771,22.5),(148382,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05821','R',148382,41.73,0.3,1580,70487,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005hq','SDSS J205019.95-004930.7',0.41,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148383,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005hq',NULL,148383,41.81,0.23,1640,70487,70,NULL,'SALT 2','SDSS J205019.95-004930.7',0.401,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148384,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05821','R',148384,42.08,0.36,1850,70487,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005hq','SDSS J205019.95-004930.7',0.41,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148385,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15386','R',148385,40.48,0.23,971,70488,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15386',0.2871,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.58475,-1.23258,0.249,NULL,47782874132,746607408,11665740,NULL),(148386,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 15386','R',148386,40.68,0.14,1060,70488,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15386',0.2871,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148387,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148387,39.11,0.12,558,70489,74.2,NULL,'SALT 2','SDSS J205024.45-000957.3',0.19,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',NULL,NULL,'19.3g',0.06,NULL,NULL,NULL,NULL,NULL,1,312.601875,-0.16594,0.333,NULL,47782740600,746605321,11665708,19.3),(148388,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148388,39.45,0.04,653,70489,70,NULL,'SDSS-II SN 05994','SDSS J205024.45-000957.3',0.19,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148389,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148389,39.85,0.09,783,70489,65,NULL,'SALT2','SDSS J205024.45-000957.3',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148390,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148390,39.86,0.13,789,70489,70,NULL,'SDSS-II SN 05994, SALT 2','SDSS J205024.45-000957.3',0.19,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148391,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05994','R',148391,39.87,0.2,793,70489,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ht','SDSS J205024.45-000957.3',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148392,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005ht',NULL,148392,40.02,0.1,848,70489,65,NULL,'MLCS2k2','SDSS J205024.45-000957.3',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148393,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 05994','R',148393,40.07,0.1,869,70489,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ht','SDSS J205024.45-000957.3',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148394,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148394,36.37,0.37,188,70490,NULL,NULL,NULL,'2MASX J20502701-5203126',NULL,'2009ApJS..182..474S',2009,1,0.35,NULL,'G',0.000027,NULL,'17.17',0.19,'Sc','Group member',NULL,NULL,NULL,1,312.612375,-52.05347,0.037,NULL,51340781357,802199708,12534370,17.17),(148395,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148395,36.41,0.2,191,70490,74.4,NULL,NULL,'2MASX J20502701-5203126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148396,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148396,36.44,0.36,194,70490,NULL,NULL,'Malmquist cor.','2MASX J20502701-5203126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148397,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148397,35.62,0.25,133,70491,74.4,NULL,NULL,'FAIRALL 0567',NULL,'2013AJ....146...86T',2013,1,0.58,'Declination in 1997AJ....113..492C is 1.0 arcmin in error.','G',0.00009,NULL,'16.5b',0.35,'S0','Group member',NULL,NULL,NULL,1,312.625625,-52.9005,0.061,NULL,51071457419,797991522,12468617,16.5),(148398,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148398,36.31,0.53,183,70491,70,NULL,NULL,'FAIRALL 0567',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148399,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12883','R',148399,40.55,0.3,988,70492,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fr','SN 2006fr',0.307,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,312.625875,0.39869,0.397,NULL,53958607037,843103234,13173488,NULL),(148400,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 12883','R',148400,40.81,0.27,1110,70492,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fr','SN 2006fr',0.307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148401,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,'R',148401,38.99,0.46,629,70493,70,NULL,NULL,'SDSS J205030.93-001508.0',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000182,NULL,'19.0g',0.08,NULL,NULL,NULL,NULL,NULL,1,312.628875,-0.25225,0.333,NULL,47782737643,746605275,11665707,19),(148402,'FP','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148402,35.19,0.66,109,70494,70,NULL,NULL,'2MASX J20503133-5334556',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.87',0.38,'S',NULL,NULL,NULL,NULL,1,312.6305417,-53.58206,0.097,NULL,51073704143,798026627,12469166,15.87),(148403,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148403,35.58,0.58,131,70495,NULL,NULL,'Malmquist cor.','ESO 187- G 016',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000043,NULL,'15.5V',0.21,'Sb','Group member',NULL,NULL,NULL,1,312.636,-52.45594,0.041,NULL,51071519076,797992485,12468632,15.5),(148404,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148404,35.6,NULL,132,70495,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 187- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148405,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148405,35.64,NULL,135,70495,NULL,NULL,'Dipole + Quadrupole','ESO 187- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148406,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148406,35.68,0.56,136,70495,NULL,NULL,NULL,'ESO 187- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148407,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148407,35.68,NULL,137,70495,NULL,NULL,'Dipole','ESO 187- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148408,'Tully-Fisher','2016-12-15 15:15:52','2016-12-16 11:21:07','1',NULL,NULL,148408,35.72,0.2,139,70495,74.4,NULL,NULL,'ESO 187- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148409,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005gh',NULL,148409,39.61,0.05,664,70496,70,NULL,'SDSS 3241','SDSS J205036.66-002115.2',0.25888,'2011ApJS..192....1C',2011,1,0.18,NULL,'G',0.00018,NULL,'19.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,312.652791667,-0.35422,0.333,NULL,47783428787,746616074,11665876,19.1),(148410,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005gh',NULL,148410,39.94,0.14,773,70496,74.2,NULL,'SALT 2','SDSS J205036.66-002115.2',0.25888,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148411,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SDSS-II SN 03241','R',148411,40.69,0.22,1090,70496,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005gh','SDSS J205036.66-002115.2',0.25888,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148412,'SNIa','2016-12-15 15:15:52','2016-12-16 11:21:07','1','SN 2005gh',NULL,148412,40.75,0.15,1120,70496,70,NULL,'SDSS 3241, SALT 2','SDSS J205036.66-002115.2',0.25888,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148413,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SN 2005gh',NULL,148413,40.83,0.2,1160,70496,72,NULL,'SDSS 3241','SDSS J205036.66-002115.2',0.25888,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148414,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 03241','R',148414,40.91,0.17,1210,70496,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005gh','SDSS J205036.66-002115.2',0.25888,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148415,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SN 2005gh',NULL,148415,40.66,0.16,1360,70496,70,NULL,'SALT 2','SDSS J205036.66-002115.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148416,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SN 2005gh',NULL,148416,40.68,0.16,1370,70496,70,NULL,'SALT 2, Malmquist cor.','SDSS J205036.66-002115.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148417,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 01835','R',148417,40.44,0.3,965,70497,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01835',0.2716,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.664125,1.07186,0.453,NULL,53958366385,843099474,13173429,NULL),(148418,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 01835','R',148418,40.76,0.23,1110,70497,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01835',0.2716,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148419,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148419,36.27,0.55,179,70498,70,NULL,NULL,'2MASX J20504307-8028482',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,312.6792083,-80.48017,0.589,NULL,48574118377,758970599,11858915,16.7),(148420,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148420,36.28,0.42,180,70499,NULL,NULL,NULL,'AGC 600260',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000027,NULL,'16.24',0.29,'Sc','Group member',NULL,NULL,NULL,1,312.682833,-53.15789,0.081,NULL,51073557086,798024329,12469130,16.24),(148421,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148421,36.32,0.2,184,70499,74.4,NULL,NULL,'AGC 600260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148422,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148422,36.41,0.39,191,70499,NULL,NULL,'Malmquist cor.','AGC 600260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148423,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148423,36.91,0.89,241,70500,70,NULL,NULL,'2MASX J20504390-5919155',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,312.683125,-59.32092,0.241,NULL,49129533014,767648953,11994514,15.8),(148424,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 14014',NULL,148424,40.5,1.05,1260,70501,70,NULL,'SN photometric redshift distance, z photo =0.354 +/- 0.327','SDSS-II SN 14014',NULL,'2011ApJ...738..162S',2011,1,0.13,NULL,'G',NULL,'PHOT','20.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,312.694625,-1.14219,0.249,NULL,47783064581,746610384,11665787,20.5),(148425,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148425,35.79,0.56,144,70502,NULL,NULL,NULL,'2MASX J20504929-5256061',NULL,'2009ApJS..182..474S',2009,1,0.58,NULL,'G',0.000033,NULL,'16.5V',0.16,'Sd','Group member',NULL,NULL,NULL,1,312.7057917,-52.93492,0.085,NULL,51073543726,798024120,12469126,16.5),(148426,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148426,35.83,0.2,147,70502,74.4,NULL,NULL,'2MASX J20504929-5256061',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148427,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148427,35.91,0.53,152,70502,NULL,NULL,'Malmquist cor.','2MASX J20504929-5256061',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148428,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148428,36.62,0.46,211,70503,70,NULL,NULL,'2MASX J20505080-0043507',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,312.711583,-0.73081,0.321,NULL,47783560158,746618127,11665908,15.9),(148429,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 16624','RN',148429,38.98,0.2,590,70504,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16624',0.057096,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148430,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 16624','RN',148430,40.14,0.25,1010,70504,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16624',0.057096,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148431,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148431,37.89,0.46,379,70505,70,NULL,NULL,'2MASX J20505798+0043587',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,312.741583333,0.73294,0.421,NULL,53958430398,843100474,13173444,17.2),(148432,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148432,36.29,0.46,181,70506,NULL,NULL,'Malmquist cor.','2MASX J20505989-5307251',NULL,'2009ApJS..182..474S',2009,1,0.68,NULL,'G',0.000027,NULL,'16.49',0.2,'Sd','Group member',NULL,NULL,NULL,1,312.749417,-53.12419,0.085,NULL,51073566517,798024476,12469132,16.49),(148433,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148433,36.47,0.42,197,70506,NULL,NULL,NULL,'2MASX J20505989-5307251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148434,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148434,36.51,0.2,200,70506,74.4,NULL,NULL,'2MASX J20505989-5307251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148435,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148435,35.5,0.57,126,70507,70,NULL,NULL,'2MASX J20510169-6238054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,312.757,-62.63483,0.125,NULL,49176443903,768381935,12005967,17.1),(148436,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148436,36.31,0.42,183,70508,NULL,NULL,NULL,'AGC 600240',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'15.50',0.18,'Sc','Group member',NULL,NULL,NULL,1,312.762917,-52.66589,0.049,NULL,51071448036,797991375,12468615,15.5),(148437,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148437,36.35,0.2,186,70508,74.4,NULL,NULL,'AGC 600240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148438,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148438,36.42,0.4,192,70508,NULL,NULL,'Malmquist cor.','AGC 600240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148439,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148439,36.23,0.43,176,70509,NULL,NULL,NULL,'AGC 600266',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000027,NULL,'17.1V',0.13,'Sc','Group member',NULL,NULL,NULL,1,312.771167,-52.75044,0.073,NULL,51071481636,797991900,12468623,17.1),(148440,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148440,36.27,0.2,179,70509,74.4,NULL,NULL,'AGC 600266',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148441,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148441,36.41,0.39,192,70509,NULL,NULL,'Malmquist cor.','AGC 600266',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148442,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148442,35.59,NULL,131,70510,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 187- G 019',NULL,'2010Ap&SS.325..163P',2010,1,1.66,NULL,'G',0.00004,NULL,'15.72',0.2,'Sb','Group member',NULL,NULL,NULL,1,312.777333333,-52.71258,0.073,NULL,51071480869,797991888,12468623,15.72),(148443,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148443,35.62,NULL,133,70510,NULL,NULL,'Dipole + Quadrupole','ESO 187- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148444,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148444,35.66,NULL,135,70510,NULL,NULL,'Dipole','ESO 187- G 019',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148445,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148445,35.83,0.49,146,70510,75,NULL,'IR','ESO 187- G 019',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148446,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148446,36.14,0.57,169,70510,NULL,NULL,'Malmquist cor.','ESO 187- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148447,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148447,36.51,0.09,201,70510,70,NULL,'ABELL 3716, BGC','ESO 187- G 019',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148448,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148448,36.62,0.46,210,70510,NULL,NULL,NULL,'ESO 187- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148449,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148449,36.66,0.2,215,70510,74.4,NULL,NULL,'ESO 187- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148450,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 08596','RN',148450,40.66,0.45,1220,70511,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08596',0.106755,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148451,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148451,36.57,0.38,206,70512,NULL,NULL,'Malmquist cor.','2MASX J20510833-5302391',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.000037,NULL,'15.69',0.11,'I/S','Group member',NULL,NULL,NULL,1,312.78475,-53.04411,0.085,NULL,51073578728,798024667,12469135,15.69),(148452,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148452,36.7,0.35,219,70512,NULL,NULL,NULL,'2MASX J20510833-5302391',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148453,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148453,36.75,0.2,224,70512,74.4,NULL,NULL,'2MASX J20510833-5302391',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148454,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148454,34.28,0.2,71.8,70513,74.4,NULL,NULL,'ESO 529- G 009',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'13.57',0.2,'S              HII',NULL,NULL,NULL,NULL,1,312.793291667,-25.71383,0.229,NULL,51308623990,801697249,12526519,13.57),(148455,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148455,34.56,0.41,81.8,70513,NULL,NULL,NULL,'ESO 529- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148456,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148456,34.65,0.39,85.3,70513,NULL,NULL,'Malmquist cor.','ESO 529- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148457,'Brightest Stars','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148457,28.89,NULL,6,70514,NULL,NULL,NULL,'CEPHEUS 1',NULL,'2000A&A...362..544K',2000,1,11.7,NULL,'G',0.00001,NULL,'15.4B',1.5,'Sm?',NULL,NULL,NULL,NULL,1,312.794167,56.89028,NULL,NULL,53420939612,834702181,13042221,15.4),(148458,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SN 2007ph',NULL,148458,38.5,0.14,502,70515,70,NULL,'Hubble residual -0.07 for z0.12946','2MASX J20511361-0057276',NULL,'2011ApJ...740...92G',2011,1,0.23,NULL,'G',0.000177,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,312.806791667,-0.95778,0.285,NULL,47782931328,746608302,11665754,18.2),(148459,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 20350','R',148459,38.95,0.2,547,70515,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ph','2MASX J20511361-0057276',0.12939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148460,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 20350','R',148460,39.05,0.1,572,70515,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ph','2MASX J20511361-0057276',0.12939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148461,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 01757','R',148461,39.34,0.4,654,70515,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2007ph','2MASX J20511361-0057276',0.129455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148462,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 01757','R',148462,40.61,0.42,1170,70515,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2007ph','2MASX J20511361-0057276',0.129455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148463,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148463,36.1,0.25,166,70516,74.4,NULL,NULL,'2MASX J20511622-5241261',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000107,NULL,'14.9V',0.4,'E','Group member',NULL,NULL,NULL,1,312.817375,-52.69069,0.073,NULL,51071445931,797991342,12468614,14.9),(148464,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148464,36.51,0.09,201,70517,70,NULL,NULL,'ABELL 3716',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II:  [BM];IR [A]',NULL,NULL,NULL,NULL,1,312.819625,-52.69542,0.073,NULL,51071445941,797991342,12468614,NULL),(148465,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148465,37.2,0.94,275,70518,70,NULL,NULL,'2MASX J20511805-5255251',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00008,NULL,'15.6V',0.15,'Sab','Group member',NULL,NULL,NULL,1,312.8252083,-52.92356,0.085,NULL,51071426668,797991041,12468610,15.6),(148466,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148466,36.68,0.25,217,70519,74.4,NULL,NULL,'2MASX J20511929-5240411',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.00015,NULL,'14.8V',0.43,'E','Group member',NULL,NULL,NULL,1,312.830166667,-52.67814,0.049,NULL,51071445817,797991340,12468614,14.8),(148467,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148467,36.4,0.46,190,70520,70,NULL,NULL,'2MASX J20511962+0047316',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,312.831667,0.792,0.421,NULL,53958319925,843098748,13173417,17.3),(148468,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148468,36.16,0.25,171,70521,74.4,NULL,NULL,'ESO 187- G 020',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000103,NULL,'13.8V',1,'S0- pec','Group member',NULL,NULL,NULL,1,312.8329583,-52.63625,0.049,NULL,51071444447,797991319,12468614,13.8),(148469,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148469,36.22,0.49,176,70521,70,NULL,NULL,'ESO 187- G 020',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148470,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 20474','R',148470,40.63,0.25,1060,70522,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2007rg','SN 2007rg',0.266,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,312.8344583,1.01889,0.441,NULL,53958309618,843098587,13173415,NULL),(148471,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 20474','R',148471,40.75,0.17,1110,70522,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2007rg','SN 2007rg',0.266,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148472,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 17351','R',148472,39.88,0.23,800,70523,70,NULL,'SDSS CAND. SNIb; SALT 2; SN 2007jy','SN 2007jy',0.182,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib?',NULL,NULL,NULL,NULL,1,312.8392917,0.39939,0.429,NULL,53958635115,843103673,13173494,NULL),(148473,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 17351','R',148473,39.99,0.15,844,70523,70,NULL,'SDSS CAND. SNIb; MLCS2K2; SN 2007jy','SN 2007jy',0.182,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148474,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148474,39.15,0.46,677,70524,70,NULL,NULL,'2MASX J20512184-0616472',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000114,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,312.841,-6.27992,0.281,NULL,50796442094,793694407,12401475,17.8),(148475,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148475,38.17,0.17,430,70525,70,NULL,NULL,'SDSS J205123.13-000607.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'19.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,312.846375,-0.10194,0.361,NULL,47783426648,746616041,11665875,19),(148476,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148476,35.04,0.47,102,70526,NULL,NULL,'H','UGC 11643',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.7',0.4,'SBb','Pair member (points to parent)',NULL,NULL,NULL,1,312.8579583,18.96781,0.317,NULL,55236371201,863068300,13485442,14.7),(148477,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148477,35.14,0.45,106,70526,NULL,NULL,'K','UGC 11643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148478,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148478,35.22,0.46,111,70526,NULL,NULL,'J','UGC 11643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148479,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148479,35.25,0.4,112,70526,NULL,NULL,'mean','UGC 11643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148480,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148480,37.17,0.46,272,70527,70,NULL,NULL,'2MASX J20512656-0708052',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000061,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,312.860583333,-7.13481,0.209,NULL,50797209062,793706391,12401662,17.2),(148481,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148481,38.17,0.17,430,70528,70,NULL,NULL,'2MASX J20513513-0007160',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,312.896333,-0.12108,0.361,NULL,47783421839,746615966,11665874,18.5),(148482,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148482,36.1,0.69,166,70529,70,NULL,NULL,'2MASX J20513521-5251433',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000087,NULL,'15.6V',0.66,'Ep','Group member',NULL,NULL,NULL,1,312.896625,-52.86189,0.073,NULL,51071429294,797991082,12468610,15.6),(148483,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148483,36.41,0.25,191,70529,74.4,NULL,NULL,'2MASX J20513521-5251433',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148484,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148484,38.17,0.17,430,70530,70,NULL,NULL,'2MASX J20513673-0002580',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000183,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,312.903,-0.04944,0.361,NULL,47783151119,746611736,11665808,18.1),(148485,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148485,38.17,0.17,430,70531,70,NULL,NULL,'2MASX J20513826-0003210',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.6g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,312.90925,-0.05589,0.361,NULL,47783151358,746611739,11665808,16.6),(148486,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148486,36.41,0.2,191,70532,74.4,NULL,NULL,'2MASX J20513989-5234534',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000087,NULL,'16.3V',0.24,'S0','Group member',NULL,NULL,NULL,1,312.916416667,-52.58131,0.049,NULL,51340688307,802198254,12534347,16.3),(148487,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148487,36.72,0.79,221,70533,70,NULL,NULL,'IC 5048',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.76',0.5,'SB(r)ab',NULL,NULL,NULL,NULL,1,312.919333,-71.80078,0.145,NULL,49327911907,770748623,12042947,15.76),(148488,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148488,36.13,0.44,168,70534,NULL,NULL,'Malmquist cor.','ESO 187- G 022',NULL,'2009ApJS..182..474S',2009,1,0.9,'Fairall (1983,MNRAS,203,47) gives v = 7550: +/- 100 km/sec.','G',0.000027,NULL,'14.4V',0.5,'SAB(r)0^+','Group member',NULL,NULL,NULL,1,312.919375,-52.60042,0.049,NULL,51340680052,802198125,12534345,14.4),(148489,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148489,36.37,0.39,188,70534,NULL,NULL,NULL,'ESO 187- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148490,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148490,38.49,0.46,500,70535,70,NULL,NULL,'2MASX J20514074+0052006',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,312.9197917,0.86689,0.421,NULL,53958284724,843098198,13173409,18.1),(148491,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148491,36.67,0.74,216,70536,70,NULL,NULL,'2MFGC 15801',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,312.920833,-73.41967,0.201,NULL,49207783801,768871621,12013619,16.9),(148492,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 07547','RN',148492,37.91,0.08,345,70537,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07547',0.106409,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148493,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 07547','RN',148493,39.5,0.18,717,70537,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07547',0.106409,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148494,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148494,35.82,0.51,146,70538,70,NULL,NULL,'MCG -02-53-010',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000113,NULL,'17.5b',0.2,NULL,NULL,NULL,NULL,NULL,1,312.9244583,-12.20647,0.169,NULL,50755808836,793059513,12391554,17.5),(148495,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148495,38.17,0.17,430,70539,70,NULL,NULL,'2MASX J20514253-0010430',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,312.92725,-0.17853,0.361,NULL,47783420003,746615937,11665874,18.2),(148496,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148496,38.17,0.17,430,70540,70,NULL,NULL,'2MASX J20514272-0000220',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,312.9279583,-0.00614,0.397,NULL,47783150117,746611720,11665808,17.8),(148497,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148497,35.29,0.45,114,70541,NULL,NULL,NULL,'ESO 597- G 045',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.54',0.7,'Sc',NULL,NULL,NULL,NULL,1,312.936667,-18.33172,0.209,NULL,50994054306,796782098,12449720,14.54),(148498,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148498,35.33,0.2,116,70541,74.4,NULL,NULL,'ESO 597- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148499,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148499,35.51,0.41,126,70541,NULL,NULL,'Malmquist cor.','ESO 597- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148500,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148500,37.51,0.46,318,70542,70,NULL,NULL,'2MASX J20514503-0042550',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,312.9377083,-0.71539,0.321,NULL,47783357115,746614954,11665858,16.8),(148501,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148501,34.41,0.5,76.2,70543,70,NULL,NULL,'IC 5065',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000047,NULL,'14.58',0.9,'SB pec',NULL,NULL,NULL,NULL,1,312.940833,-29.84728,0.293,NULL,51495712396,804620506,12572195,14.58),(148502,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,NULL,148502,36.17,0.25,171,70544,74.4,NULL,NULL,'2MASX J20514691-5247024',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00013,NULL,'15.0V',0.39,'E','Group member',NULL,NULL,NULL,1,312.9457083,-52.78397,0.073,NULL,51071426121,797991033,12468609,15),(148503,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 13332','RN',148503,40.35,0.21,1020,70545,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13332',0.14731,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148504,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 13332','RN',148504,40.65,0.24,1180,70545,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13332',0.14731,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148505,'FP','2016-12-15 15:15:53','2016-12-16 11:21:07','1',NULL,'R',148505,38.04,0.46,405,70546,70,NULL,NULL,'SDSS J205147.56-004328.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000199,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,312.948166667,-0.72469,0.321,NULL,47783357479,746614960,11665858,18.5),(148506,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:07','1','SDSS-II SN 10922','RN',148506,39.81,0.71,800,70547,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10922',0.146015,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148507,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148507,36.5,0.25,200,70548,74.4,NULL,NULL,'2MASX J20515121-5247424',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.000087,NULL,'15.9V',0.3,'S0','Group member',NULL,NULL,NULL,1,312.9635417,-52.79508,0.073,NULL,51071425725,797991026,12468609,15.9),(148508,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148508,35.7,0.58,138,70549,70,NULL,NULL,'2MASX J20515140-5324294',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'15.87',0.43,'S0',NULL,NULL,NULL,NULL,1,312.9640417,-53.40814,0.101,NULL,51070340173,797974065,12468344,15.87),(148509,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148509,38.17,0.17,430,70550,70,NULL,NULL,'2MASX J20515220-0010430',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000138,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,312.967375,-0.17861,0.361,NULL,47783207280,746612613,11665822,17.9),(148510,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148510,35.4,0.25,120,70551,74.4,NULL,NULL,'ESO 187-IG 025 NED01',NULL,'2013AJ....146...86T',2013,1,1.15,NULL,'G',0.000143,NULL,'13.7V',0.42,'S0','Group member',NULL,NULL,NULL,1,312.969083333,-52.83092,0.073,NULL,51071434000,797991156,12468611,13.7),(148511,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16103',NULL,148511,39.47,0.19,783,70552,70,NULL,NULL,'SDSS-II SN 16103',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,312.975167,-1.05017,0.285,NULL,47784850742,746638292,11666223,NULL),(148512,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16103','R',148512,39.93,0.2,804,70552,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16103',0.2024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148513,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16103','R',148513,40.13,0.09,882,70552,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16103',0.2024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148514,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148514,36.27,0.48,179,70553,NULL,NULL,'Malmquist cor.','2MASX J20515512-5149284',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000023,NULL,'15.31',0.42,'Sc','Group member',NULL,NULL,NULL,1,312.979667,-51.82456,0.033,NULL,51341344984,802208515,12534508,15.31),(148515,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148515,36.61,0.41,210,70553,NULL,NULL,NULL,'2MASX J20515512-5149284',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148516,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148516,36.65,0.2,214,70553,74.4,NULL,NULL,'2MASX J20515512-5149284',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148517,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148517,35.8,0.25,145,70554,74.4,NULL,NULL,'ESO 187-IG 025 NED02',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00003,NULL,'14.4V',NULL,'E','Pair member (points to parent)',NULL,NULL,NULL,1,312.986875,-52.75303,0.073,NULL,51071423145,797990986,12468609,14.4),(148518,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148518,35.86,0.25,149,70555,74.4,NULL,NULL,'ESO 187-IG 025 NED03',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000123,NULL,'14.2V',0.57,'D','Group member',NULL,NULL,NULL,1,312.99025,-52.80186,0.073,NULL,51071425170,797991018,12468609,14.2),(148519,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148519,36.67,0.77,216,70556,70,NULL,NULL,'ESO 187- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1.25,NULL,'G',0.00015,NULL,'16.13',0.2,'Sb:',NULL,NULL,NULL,NULL,1,312.99025,-54.48683,0.105,NULL,51070462884,797975982,12468374,16.13),(148520,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148520,36.15,0.25,170,70557,74.4,NULL,NULL,'2MASX J20515920-5235063',NULL,'2013AJ....146...86T',2013,1,0.37,NULL,'G',0.00009,NULL,'16.1V',0.18,'S0','Group member',NULL,NULL,NULL,1,312.996875,-52.585,0.049,NULL,51340686066,802198219,12534347,16.1),(148521,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148521,36.25,0.71,178,70558,70,NULL,NULL,'2MASX J20520030-5408356',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'16.23',0.57,'S0',NULL,NULL,NULL,NULL,1,313.0012917,-54.14328,0.097,NULL,51070654609,797978978,12468421,16.23),(148522,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148522,36.13,0.25,168,70559,74.4,NULL,NULL,'ESO 187-IG 025 NED04',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00003,NULL,'13.6V',NULL,'E2','Pair member (points to parent)',NULL,NULL,NULL,1,313.001625,-52.75492,0.073,NULL,51071423208,797990987,12468609,13.6),(148523,'TRGB','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148523,28.7,0.1,5.5,70560,74.4,NULL,NULL,'IC 5052',NULL,'2013AJ....146...86T',2013,1,5.9,'The 2MASX position is for the eccentric bulge.','G',0.00001,NULL,'11.6B',0.8,'SBd: sp','Group member',NULL,NULL,NULL,1,313.023208333,-69.20164,0.169,NULL,49335666386,770869787,12044840,11.6),(148524,'TRGB','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148524,28.76,0.1,5.6,70560,NULL,NULL,'I','IC 5052',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148525,'TRGB','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148525,28.75,0.07,5.62,70560,NULL,NULL,NULL,'IC 5052',NULL,'2006astro.ph..3457T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148526,'TRGB','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148526,28.9,0.04,6.03,70560,NULL,NULL,NULL,'IC 5052',NULL,'2005AJ....129.1331S',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148527,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148527,29.17,0.8,6.81,70560,75,NULL,'A82, H','IC 5052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148528,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148528,29.11,0.4,6.7,70560,75,NULL,'B','IC 5052',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148529,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148529,29.73,0.47,8.84,70560,75,NULL,'A82, H, inv','IC 5052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148530,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148530,29.86,0.47,9.39,70560,75,NULL,'A82, H, raw','IC 5052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148531,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148531,30.17,0.47,10.8,70560,75,NULL,'A82, H, cor','IC 5052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148532,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148532,34.85,0.56,93.2,70561,70,NULL,NULL,'2MASX J20520164-1328568',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.9b',0.3,NULL,NULL,NULL,NULL,NULL,1,313.0067917,-13.48256,0.145,NULL,50981717589,796589337,12446708,15.9),(148533,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148533,36.05,0.56,163,70562,70,NULL,NULL,'2MASX J20520220-3805597',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.49',0.4,'S',NULL,NULL,NULL,NULL,1,313.0092083,-38.09992,0.089,NULL,51512067865,804876060,12576188,15.49),(148534,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148534,32.08,0.63,26.1,70563,95,NULL,'Michard 1979b, c','IC 5063',NULL,'1984ApJS...56...91D',1984,1,2.1,NULL,'G',0.00002,NULL,'12.89',1.4,'SA(s)0+:       Sy2','Pair member, radial velocity confirmed',NULL,NULL,'Sy 1 h',1,313.00975,-57.06878,0.237,NULL,49138502164,767789096,11996704,12.89),(148535,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148535,32.13,0.37,26.7,70563,95,NULL,'Weighted Mean','IC 5063',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148536,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148536,32.57,0.46,32.7,70563,95,NULL,'Michard 1979a','IC 5063',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148537,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148537,33.83,0.81,58.3,70563,55,NULL,'Visvanathan & Sandage 1979','IC 5063',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148538,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148538,32.87,0.45,37.5,70563,NULL,NULL,'K','IC 5063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148539,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148539,33.31,0.4,45.9,70563,NULL,NULL,'mean','IC 5063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148540,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 05595',NULL,148540,39.29,0.45,720,70564,70,NULL,'SN photometric redshift distance, z photo =0.185 +/- 0.049','SDSS-II SN 05595',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.0192917,-0.10242,0.361,NULL,47783211900,746612685,11665823,22.4),(148541,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148541,37.64,0.46,338,70565,70,NULL,NULL,'SDSS J205206.03-002131.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000139,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,313.025167,-0.35867,0.361,NULL,47783284582,746613821,11665840,18.7),(148542,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12844','R',148542,38.07,0.1,384,70566,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2006fe','SN 2006fe',0.070498,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,313.038167,-0.51111,0.349,NULL,47783255677,746613369,11665833,NULL),(148543,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12844','R',148543,38.36,0.22,439,70566,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2006fe','SN 2006fe',0.070498,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148544,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148544,34.11,0.8,66.3,70567,75,NULL,'HMCL, I','NGC 6970',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000087,NULL,'13.16',0.9,'Sbc pec','Group non-member, background',NULL,NULL,NULL,1,313.039417,-48.77778,0.029,NULL,51349513270,802336144,12536502,13.16),(148545,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148545,33.18,0.4,43.3,70567,75,NULL,'HMCL, I, raw','NGC 6970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148546,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148546,33.35,0.4,46.7,70567,75,NULL,'HMCL, I, inv','NGC 6970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148547,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148547,33.52,0.4,50.6,70567,75,NULL,'HMCL, I, cor','NGC 6970',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148548,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148548,35.98,0.25,157,70568,74.4,NULL,NULL,'ESO 187-IG 025 NED05',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000083,NULL,'14.2V',0.52,'E','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,313.0397917,-52.79597,0.073,NULL,51071425461,797991022,12468609,14.2),(148549,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148549,35.99,0.46,158,70568,70,NULL,NULL,'ESO 187-IG 025 NED05',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148550,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148550,36.59,0.69,208,70569,70,NULL,NULL,'2MASX J20521357-5318108',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00015,NULL,'16.06',0.37,'S0',NULL,NULL,NULL,NULL,1,313.056708333,-53.303,0.097,NULL,51070139748,797970933,12468295,16.06),(148551,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148551,36.27,0.52,180,70570,70,NULL,NULL,'2MASX J20521491-4305160',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,313.062,-43.08775,0.061,NULL,51390523805,802976934,12546514,15.7),(148552,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148552,35.51,0.62,126,70571,NULL,NULL,NULL,'2MASX J20521648-5145368',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.000033,NULL,'16.52',0.29,'Sb','Group member',NULL,NULL,NULL,1,313.068833333,-51.76028,0.033,NULL,51341419017,802209672,12534526,16.52),(148553,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148553,35.55,0.2,129,70571,74.4,NULL,NULL,'2MASX J20521648-5145368',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148554,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148554,35.59,0.6,131,70571,NULL,NULL,'Malmquist cor.','2MASX J20521648-5145368',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148555,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148555,36.28,0.59,180,70572,NULL,NULL,'Malmquist cor.','2MASX J20521837-5157518',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000033,NULL,'15.92',0.28,'Sc','Group member',NULL,NULL,NULL,1,313.076583,-51.96447,0.033,NULL,51341313438,802208022,12534500,15.92),(148556,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148556,36.67,0.49,216,70572,NULL,NULL,NULL,'2MASX J20521837-5157518',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148557,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148557,36.71,0.2,220,70572,74.4,NULL,NULL,'2MASX J20521837-5157518',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148558,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002fa',NULL,148558,37.03,0.54,255,70573,NULL,NULL,'SCM, I','NEAT J205221.51+020841.9',NULL,'2010ApJ...715..833O',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,313.089625,2.14497,0.425,NULL,53957569558,843087024,13173234,NULL),(148559,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002fa',NULL,148559,37.16,0.29,270,70573,NULL,NULL,'SCM, BVI','NEAT J205221.51+020841.9',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148560,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002fa',NULL,148560,37.16,0.55,270,70573,NULL,NULL,'SCM, V','NEAT J205221.51+020841.9',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148561,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002fa',NULL,148561,37.23,0.44,279,70573,NULL,NULL,'SCM, B','NEAT J205221.51+020841.9',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148562,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148562,37.36,0.62,297,70574,70,NULL,NULL,'FGCE 1531',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.00015,NULL,'16.7b',0.15,'Sbc',NULL,NULL,NULL,NULL,1,313.092541667,-49.53019,0,NULL,51347989473,802312335,12536130,16.7),(148563,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01998',NULL,148563,41.43,0.14,1930,70575,70,NULL,'SN photometric redshift distance, z photo =0.625 +/- 0.063','SDSS-II SN 01998',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.2g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.097417,0.56433,0.421,NULL,53958010913,843093920,13173342,20.2),(148564,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007kb',NULL,148564,39.24,0.1,705,70576,70,NULL,'Hubble residual 0.45 for z0.14450','SDSS-II SN 17568 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,313.10325,0.27747,0.429,NULL,53958088594,843095134,13173361,NULL),(148565,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17568','R',148565,39.73,0.23,776,70576,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kb','SDSS-II SN 17568 HOST',0.138,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148566,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17568','R',148566,39.82,0.14,810,70576,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kb','SDSS-II SN 17568 HOST',0.138,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148567,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148567,36.59,0.74,208,70577,70,NULL,NULL,'2MASX J20522659-5200419',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.89',0.25,'S0','Group member',NULL,NULL,NULL,1,313.110667,-52.01161,0.037,NULL,51341315522,802208055,12534500,16.89),(148568,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148568,36.4,0.69,191,70578,70,NULL,NULL,'2MASX J20522734-4242549',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.58',0.36,NULL,NULL,NULL,NULL,NULL,1,313.113875,-42.71525,0.069,NULL,51390299571,802973430,12546459,16.58),(148569,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148569,36.35,0.68,186,70579,70,NULL,NULL,'2MASX J20522950-5555277',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.85',0.57,'S0',NULL,NULL,NULL,NULL,1,313.122958333,-55.92436,0.213,NULL,48991832986,765497390,11960896,15.85),(148570,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148570,35.95,0.25,155,70580,74.4,NULL,NULL,'2MASX J20523438-5250448',NULL,'2013AJ....146...86T',2013,1,0.33,NULL,'G',0.000083,NULL,'16.4V',0.17,'S0','Group member',NULL,NULL,NULL,1,313.143125,-52.84583,0.073,NULL,51340643126,802197548,12534336,16.4),(148571,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148571,37.07,0.21,259,70581,70,NULL,NULL,'2MASX J20523462-0058599',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000196,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,313.144375,-0.98319,0.337,NULL,47785536140,746649002,11666390,16.9),(148572,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148572,37.06,0.57,258,70582,70,NULL,NULL,'2MASX J20523663-4310479',NULL,'2014MNRAS.445.2677S',2014,1,0.14,NULL,'G',0.00015,NULL,'20.28',0.09,NULL,NULL,NULL,NULL,NULL,1,313.152583,-43.18006,0.065,NULL,51390577704,802977776,12546527,20.28),(148573,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15199','R',148573,38.96,0.17,436,70583,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2007oh','SDSS J205236.96-002715.0',0.4199,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0005,NULL,'23.5g',0.02,NULL,NULL,NULL,NULL,NULL,1,313.154,-0.45419,0.361,NULL,47783266734,746613542,11665836,23.5),(148574,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15199','R',148574,39.74,0.26,625,70583,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2007oh','SDSS J205236.96-002715.0',0.4199,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148575,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007oh',NULL,148575,41.02,0.24,1600,70583,70,NULL,'Hubble residual 0.22 for z0.41990','SDSS J205236.96-002715.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148576,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19211','R',148576,42.08,0.36,1860,70583,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oh','SDSS J205236.96-002715.0',0.404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148577,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19211','R',148577,42.11,0.32,1880,70583,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oh','SDSS J205236.96-002715.0',0.404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148578,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148578,37.07,0.21,259,70584,70,NULL,NULL,'2MASX J20524168-0058369',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,313.173833,-0.977,0.337,NULL,47785537737,746649027,11666391,16.4),(148579,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148579,35.37,0.58,119,70585,70,NULL,NULL,'2MASX J20524437-6851555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7b',NULL,'(RL)SA(rl)0^0',NULL,NULL,NULL,NULL,1,313.184875,-68.86533,0.141,NULL,49335606146,770868846,12044825,15.7),(148580,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148580,35.98,0.42,157,70586,NULL,NULL,'Malmquist cor.','ESO 235- G 009',NULL,'2009ApJS..182..474S',2009,1,1.2,'Fairall (1984,MNRAS,210,69) gives v = 1500 +/- 200 km/sec.','G',0.00003,NULL,'14.85',0.6,'SB(r)0/a','Group member',NULL,NULL,NULL,1,313.1897083,-52.16444,0.037,NULL,51340851863,802200810,12534387,14.85),(148581,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148581,36.19,0.49,173,70586,NULL,NULL,'Malmquist cor.','ESO 235- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148582,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148582,36.21,0.37,174,70586,NULL,NULL,NULL,'ESO 235- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148583,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148583,36.5,0.42,200,70586,NULL,NULL,NULL,'ESO 235- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148584,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148584,36.54,0.2,203,70586,74.4,NULL,NULL,'ESO 235- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148585,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148585,36.28,0.41,180,70587,NULL,NULL,NULL,'2MASX J20524639-5304398',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000033,NULL,'16',0.22,'Sc','Group member',NULL,NULL,NULL,1,313.19325,-53.07775,0.085,NULL,51070123945,797970686,12468291,16),(148586,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148586,36.32,0.2,184,70587,74.4,NULL,NULL,'2MASX J20524639-5304398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148587,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148587,36.4,0.39,191,70587,NULL,NULL,'Malmquist cor.','2MASX J20524639-5304398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148588,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148588,36.95,0.52,246,70588,NULL,NULL,'Malmquist cor.','2MASX J20524746-5155158',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'17.30',0.17,'Sa','Group member',NULL,NULL,NULL,1,313.19775,-51.92108,0.033,NULL,51341391327,802209239,12534519,17.3),(148589,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148589,37.35,0.43,295,70588,NULL,NULL,NULL,'2MASX J20524746-5155158',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148590,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148590,37.39,0.2,301,70588,74.4,NULL,NULL,'2MASX J20524746-5155158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148591,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 05781',NULL,148591,39.11,0.79,663,70589,70,NULL,'SN photometric redshift distance, z photo =0.169 +/- 0.086','SDSS-II SN 05781',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','23.4g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,313.1982917,-1.09214,0.337,NULL,47785642694,746650667,11666416,23.4),(148592,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148592,38.04,0.46,405,70590,70,NULL,NULL,'2MASX J20525005+0053259',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,313.2087083,0.89061,0.429,NULL,53959654533,843119602,13173743,17.6),(148593,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148593,34.45,0.6,77.7,70591,NULL,NULL,'Malmquist cor.','ESO 235- G 010',NULL,'2009ApJS..182..474S',2009,1,0.88,NULL,'G',0.00003,NULL,'14',0.65,'SAB(rs)bc      Sy2','Group member',NULL,NULL,NULL,1,313.2477917,-51.86547,0.033,NULL,51341390484,802209226,12534519,14),(148594,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148594,34.46,0.6,78,70591,NULL,NULL,NULL,'ESO 235- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148595,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148595,34.27,0.49,71.4,70592,75,NULL,'IR','UGC 11644',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000057,NULL,'14.91',0.4,'SBb',NULL,NULL,NULL,NULL,1,313.260375,7.15958,0.373,NULL,55087109686,860736088,13449001,14.91),(148596,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148596,35.84,0.7,147,70593,70,NULL,NULL,'2MASX J20530408-5235149',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.0001,NULL,'14.8V',0.52,'E','Group member',NULL,NULL,NULL,1,313.266958333,-52.58736,0.049,NULL,51340691617,802198306,12534348,14.8),(148597,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148597,34.72,0.83,87.8,70594,NULL,NULL,NULL,'2MASX J20530661-5147539',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'16.27',0.33,'SBb','Group member',NULL,NULL,NULL,1,313.277625,-51.79831,0.033,NULL,51341413327,802209583,12534524,16.27),(148598,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148598,34.85,0.78,93.4,70594,NULL,NULL,'Malmquist cor.','2MASX J20530661-5147539',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148599,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148599,32.86,0.43,37.3,70595,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11648',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000017,NULL,'17.',0.3,'Im',NULL,NULL,NULL,NULL,1,313.2897083,67.17581,1.673,NULL,53684658852,838822794,13106606,17),(148600,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148600,33.12,0.49,42,70595,75,NULL,'IR','UGC 11648',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148601,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148601,37.8,0.46,363,70596,70,NULL,NULL,'SDSS J205313.71-070734.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,313.307167,-7.12619,0.201,NULL,50796293515,793692086,12401438,17.8),(148602,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148602,37.26,0.46,282,70597,70,NULL,NULL,'SDSS J205315.32-063429.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00011,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,313.313833,-6.57472,0.217,NULL,50795489764,793679527,12401242,18.6),(148603,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148603,36.17,0.73,171,70598,70,NULL,NULL,'2MASX J20531726-1608498',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.35',0.5,NULL,NULL,NULL,NULL,NULL,1,313.321875,-16.14731,0.245,NULL,51000766887,796886982,12451359,16.35),(148604,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13408','RN',148604,41.59,0.4,1480,70599,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13408',0.408662,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148605,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13408','RN',148605,42.6,0.35,2350,70599,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13408',0.408662,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148606,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148606,37.13,0.67,267,70600,70,NULL,NULL,'2MASX J20532656-1615408',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,313.360667,-16.26133,0.245,NULL,51000719426,796886241,12451347,14.4),(148607,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148607,37.47,0.46,311,70601,70,NULL,NULL,'SDSS J205330.61-062048.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000079,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,313.377583,-6.34675,0.217,NULL,50795639997,793681874,12401279,18.8),(148608,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148608,35.88,0.65,150,70602,70,NULL,NULL,'FAIRALL 0575',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00007,NULL,'16.76',0.19,'S0','Group member',NULL,NULL,NULL,1,313.390833333,-52.73156,0.073,NULL,51340644538,802197570,12534337,16.76),(148609,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148609,36.14,0.48,169,70602,NULL,NULL,NULL,'FAIRALL 0575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148610,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148610,36.18,0.2,172,70602,74.4,NULL,NULL,'FAIRALL 0575',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148611,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148611,36.33,0.44,185,70602,NULL,NULL,'Malmquist cor.','FAIRALL 0575',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148612,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148612,35.59,0.51,131,70603,70,NULL,NULL,'2MASX J20533526-1430342',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000037,NULL,'15.71',0.8,NULL,NULL,NULL,NULL,NULL,1,313.396875,-14.50947,0.165,NULL,50980120206,796564378,12446318,15.71),(148613,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148613,37.07,0.21,259,70604,70,NULL,NULL,'2MASX J20533977-0037478',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.00015,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,313.415708333,-0.63003,0.345,NULL,47785391678,746646744,11666355,16.1),(148614,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148614,37.5,0.69,317,70604,70,NULL,NULL,'2MASX J20533977-0037478',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148615,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20323',NULL,148615,38.26,1.16,449,70605,70,NULL,'SN photometric redshift distance, z photo =0.111 +/- 0.087','SDSS-II SN 20323',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.429125,1.14497,0.389,NULL,53959689966,843120155,13173752,NULL),(148616,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148616,33.75,0.8,56.3,70606,75,NULL,'MAT, I','IC 5054',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.94',0.4,'(R\':)SAB(r)a','in an interacting pair',NULL,NULL,NULL,1,313.43925,-71.02475,0.149,NULL,49339162491,770924413,12045693,13.94),(148617,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148617,33.65,0.32,53.7,70606,85,NULL,'I, raw','IC 5054',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148618,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148618,33.68,0.47,54.4,70606,NULL,NULL,'H','IC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148619,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148619,33.71,0.32,55.1,70606,85,NULL,'I, inv','IC 5054',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148620,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148620,33.75,0.46,56.1,70606,NULL,NULL,'J','IC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148621,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148621,33.79,0.45,57.2,70606,NULL,NULL,'K','IC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148622,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148622,33.82,0.08,58.2,70606,NULL,NULL,NULL,'IC 5054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148623,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148623,33.84,0.4,58.6,70606,NULL,NULL,'mean','IC 5054',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148624,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148624,34.23,0.43,70.2,70606,75,NULL,'MAT, I, raw','IC 5054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148625,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148625,34.52,0.43,80.1,70606,75,NULL,'MAT, I, inv','IC 5054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148626,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148626,34.54,0.43,80.7,70606,75,NULL,'MAT, I, cor','IC 5054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148627,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148627,37.77,0.54,358,70607,70,NULL,NULL,'2MASX J20534556-5214166',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00013,NULL,'16.7b',0.34,'E/S0','Group member',NULL,NULL,NULL,1,313.44,-52.23794,0.041,NULL,51340726354,802198849,12534357,16.7),(148628,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12862','RN',148628,40.47,0.11,1150,70608,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12862',0.078189,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148629,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12862','RN',148629,41.08,0.21,1520,70608,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12862',0.078189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148630,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148630,36.08,0.45,164,70609,NULL,NULL,'Malmquist cor.','2MASX J20534668-5259096',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000033,NULL,'15.64',0.35,'Sbc','Group member',NULL,NULL,NULL,1,313.444625,-52.98594,0.085,NULL,51338819120,802169048,12533891,15.64),(148631,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148631,36.28,0.41,180,70609,NULL,NULL,NULL,'2MASX J20534668-5259096',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148632,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148632,36.32,0.2,184,70609,74.4,NULL,NULL,'2MASX J20534668-5259096',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148633,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148633,37.07,0.21,259,70610,70,NULL,NULL,'2MASX J20535556-0038345',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000198,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,313.481625,-0.64303,0.313,NULL,47785384876,746646638,11666353,16.3),(148634,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148634,37.27,0.46,284,70611,70,NULL,NULL,'2MASX J20535760-0611208',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,313.489916667,-6.18928,0.217,NULL,50795543803,793680371,12401255,17.3),(148635,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15254','R',148635,40.06,0.21,855,70612,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006oy','SN 2006oy',0.203,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,313.492917,-0.36006,0.313,NULL,47785201728,746643777,11666309,NULL),(148636,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15254','R',148636,40.24,0.12,929,70612,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006oy','SN 2006oy',0.203,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148637,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148637,36.27,0.52,180,70613,70,NULL,NULL,'2MASX J20540180-4242396',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.41',0.42,'E',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,313.507541667,-42.711,0.069,NULL,51390447523,802975742,12546495,16.41),(148638,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148638,35.21,0.49,110,70614,75,NULL,'IR','ESO 463- G 032',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.88',0.3,'Sb',NULL,NULL,NULL,NULL,1,313.526291667,-28.68222,0.429,NULL,51490418292,804537785,12570902,15.88),(148639,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148639,35.59,0.44,131,70614,NULL,NULL,NULL,'ESO 463- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148640,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148640,35.61,0.44,132,70614,NULL,NULL,'Malmquist cor.','ESO 463- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148641,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148641,35.63,0.2,134,70614,74.4,NULL,NULL,'ESO 463- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148642,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19188',NULL,148642,40.67,0.35,1360,70615,70,NULL,'SN photometric redshift distance, z photo =0.389 +/- 0.090','SDSS-II SN 19188',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','22.6g',0.01,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.5377083,-0.18175,0.337,NULL,47785186551,746643539,11666305,22.6),(148643,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148643,35.57,0.67,130,70616,70,NULL,NULL,'2MASX J20540933-5313316',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15',0.42,'E','Group member',NULL,NULL,NULL,1,313.539,-53.22547,0.097,NULL,51338831351,802169239,12533894,15),(148644,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148644,37.07,0.21,259,70617,70,NULL,NULL,'2MASX J20541084-0057484',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,313.54525,-0.96353,0.345,NULL,47785481387,746648146,11666377,17.6),(148645,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148645,36.63,0.59,212,70618,70,NULL,NULL,'2MASX J20541157-7324474',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,313.548458333,-73.41314,0.201,NULL,49207809492,768872023,12013625,16.5),(148646,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 18405',NULL,148646,39.64,0.28,847,70619,70,NULL,'SN photometric redshift distance, z photo =0.222 +/- 0.035','SDSS-II SN 18405',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,313.548875,-0.91769,0.345,NULL,47785507273,746648551,11666383,NULL),(148647,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148647,34.97,0.49,98.5,70620,75,NULL,'IR','UGC 11647',NULL,'2011yCatp016004901K',2011,1,1.77,NULL,'G',0.000009,NULL,'15.57',0.16,'Sc',NULL,NULL,NULL,NULL,1,313.5507917,17.77933,0.349,NULL,55292095066,863938985,13499046,15.57),(148648,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148648,35.21,0.43,110,70620,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11647',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148649,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148649,35.31,NULL,115,70620,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11647',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148650,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148650,35.32,NULL,116,70620,NULL,NULL,'Dipole','UGC 11647',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148651,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148651,35.32,NULL,116,70620,NULL,NULL,'Dipole + Quadrupole','UGC 11647',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148652,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148652,35.34,0.43,117,70620,75,NULL,'3.6 micron, color corrected','UGC 11647',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148653,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148653,35.36,0.4,118,70620,NULL,NULL,'mean','UGC 11647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148654,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148654,35.37,NULL,118,70620,NULL,NULL,NULL,'UGC 11647',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148655,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148655,35.46,0.34,123,70620,NULL,NULL,'Malmquist cor.','UGC 11647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148656,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148656,35.51,0.47,126,70620,NULL,NULL,'H','UGC 11647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148657,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148657,35.54,0.45,128,70620,NULL,NULL,'K','UGC 11647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148658,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148658,35.55,0.2,129,70620,74.4,NULL,NULL,'UGC 11647',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148659,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148659,35.63,0.31,134,70620,NULL,NULL,NULL,'UGC 11647',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148660,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148660,33.33,0.49,46.4,70621,75,NULL,'IR','CGCG 425-017',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000057,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,313.552666667,10.54981,0.421,NULL,55073615430,860525241,13445706,15.3),(148661,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03488','R',148661,39.48,0.15,678,70622,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03488',0.16,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,313.555167,-1.01042,0.345,NULL,47785482928,746648170,11666377,NULL),(148662,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03488','R',148662,39.54,0.26,697,70622,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03488',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148663,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148663,37.52,0.64,319,70623,70,NULL,NULL,'2MASX J20541442-4646356',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.87',0.47,'E',NULL,NULL,NULL,NULL,1,313.56,-46.77661,0.041,NULL,51394796397,803043693,12547557,15.87),(148664,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148664,36.25,0.46,178,70624,70,NULL,NULL,'2MASX J20541513-0510294',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000069,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,313.563041667,-5.17497,0.185,NULL,50739925529,792811336,12387677,17.2),(148665,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148665,38.75,0.46,561,70625,70,NULL,NULL,'SDSS J205416.46+010225.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000186,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,313.568583,1.04031,0.305,NULL,53959366742,843115105,13173673,18.6),(148666,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148666,36.71,0.7,220,70626,70,NULL,NULL,'2MASX J20541684-5249585',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.75',0.18,'S03/a','Group member',NULL,NULL,NULL,1,313.570208333,-52.83286,0.073,NULL,51341748406,802214818,12534606,16.75),(148667,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148667,37.05,0.46,258,70627,70,NULL,NULL,'2MASX J20541699-0114564',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,313.57075,-1.24917,0.337,NULL,47785121675,746642526,11666289,17.3),(148668,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14299','RN',148668,41.26,0.22,1480,70628,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14299',0.2093,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148669,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14299','RN',148669,41.92,0.3,2000,70628,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14299',0.2093,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148670,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148670,36.39,0.52,189,70629,70,NULL,NULL,'MCG -07-43-001',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.000117,NULL,'15.30',0.6,'E',NULL,NULL,NULL,NULL,1,313.58525,-43.06636,0.065,NULL,51390467937,802976061,12546500,15.3),(148671,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148671,37.5,0.56,316,70630,70,NULL,NULL,'2MASX J20542047-5149530',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.9b',0.35,'Sb','Group member',NULL,NULL,NULL,1,313.58525,-51.83142,0.033,NULL,51341216229,802206503,12534476,15.9),(148672,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148672,34.03,0.51,63.9,70631,70,NULL,NULL,'ESO 286- G 010',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.000083,NULL,'13.40',1.7,'(R\')SA(rs)a',NULL,NULL,NULL,NULL,1,313.587875,-44.06267,0.065,NULL,51404154040,803189906,12549842,13.4),(148673,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148673,36.9,0.63,240,70632,70,NULL,NULL,'2MASX J20542143-4256236',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.83',0.25,NULL,NULL,NULL,NULL,NULL,1,313.589458333,-42.93983,0.065,NULL,51390352300,802974254,12546472,16.83),(148674,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13743','RN',148674,42.2,0.3,2290,70633,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13743',0.201787,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148675,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13743','RN',148675,42.81,0.36,3030,70633,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13743',0.201787,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148676,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148676,36.61,0.46,210,70634,70,NULL,NULL,'2MASX J20542411-0048313',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.3g',0.37,'E0',NULL,NULL,NULL,NULL,1,313.6005,-0.80878,0.345,NULL,47785451241,746647675,11666369,16.3),(148677,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002ew',NULL,148677,35.32,0.2,116,70635,NULL,NULL,'V, photospheric magnitude method','SDSS J205430.45-000820.8',NULL,'2014AJ....148..107R',2014,1,0.34,NULL,'G',0.000077,NULL,'16.6g',0.24,NULL,NULL,NULL,NULL,NULL,1,313.627083,-0.13944,0.337,NULL,47781780745,746590324,11665473,16.6),(148678,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002ew',NULL,148678,35.33,0.11,116,70635,NULL,NULL,'I, photospheric magnitude method','SDSS J205430.45-000820.8',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148679,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148679,35.85,0.62,148,70636,70,NULL,NULL,'2MASX J20543202-5521024',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.7b',0.3,NULL,NULL,NULL,NULL,NULL,1,313.633458333,-55.35075,0.185,NULL,48990087582,765470118,11960470,16.7),(148680,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13410','RN',148680,38.3,0.06,443,70637,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13410',0.029825,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148681,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13410','RN',148681,39.08,0.22,635,70637,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13410',0.029825,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148682,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148682,38.44,0.46,487,70638,70,NULL,NULL,'SDSS J205433.36-065858.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000086,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,313.639,-6.98297,0.201,NULL,50795830352,793684849,12401325,18.7),(148683,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148683,38.2,0.46,436,70639,70,NULL,NULL,'SDSS J205436.27-064803.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000084,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,313.651167,-6.80086,0.201,NULL,50795968145,793687002,12401359,18.5),(148684,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148684,35.25,0.57,112,70640,70,NULL,NULL,'2MASX J20543785-7250595',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,313.657917,-72.84992,0.185,NULL,49325632113,770713001,12042390,14.5),(148685,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148685,36.12,0.52,168,70641,70,NULL,NULL,'2MASX J20543970-4330430',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.00015,NULL,'15.19',0.55,NULL,NULL,NULL,NULL,NULL,1,313.6655,-43.51192,0.065,NULL,51390610330,802978286,12546535,15.19),(148686,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148686,36.48,0.62,198,70642,70,NULL,NULL,'2MASX J20543996-4304350',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.23',0.39,'(R)SAB0^0',NULL,NULL,NULL,NULL,1,313.666583333,-43.07644,0.065,NULL,51390477793,802976215,12546503,16.23),(148687,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 09126','RN',148687,37.61,0.34,311,70643,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09126',0.0695,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148688,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148688,37.69,0.46,345,70644,70,NULL,NULL,'2MASX J20544340-0641501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000099,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,313.6807083,-6.69711,0.177,NULL,50795948849,793686700,12401354,17.1),(148689,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148689,35.96,0.54,155,70645,70,NULL,NULL,'2MASX J20544546-1215458',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,313.6894583,-12.26269,0.193,NULL,50755872863,793060513,12391570,16),(148690,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13840','RN',148690,40.02,0.2,811,70646,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13840',0.2419,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148691,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13840','RN',148691,40.15,0.13,862,70646,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13840',0.2419,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148692,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ni',NULL,148692,39.05,0.2,646,70647,70,NULL,'SDSS-II SN 15648','SDSS J205452.51-001144.9',NULL,'2013MNRAS.434.1443X',2013,1,0.13,NULL,'G',0.000166,NULL,'19.1g',0.1,NULL,NULL,NULL,NULL,NULL,1,313.7187917,-0.19581,0.337,NULL,47781799947,746590624,11665478,19.1),(148693,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ni',NULL,148693,39.09,0.11,658,70647,70,NULL,'Hubble residual -0.09 for z0.17496','SDSS J205452.51-001144.9',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148694,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15648','R',148694,39.53,0.21,686,70647,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ni','SDSS J205452.51-001144.9',0.174962,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148695,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15648','R',148695,39.63,0.12,718,70647,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ni','SDSS J205452.51-001144.9',0.174962,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148696,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ni',NULL,148696,39.33,0.13,735,70647,70,NULL,'SALT 2','SDSS J205452.51-001144.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148697,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ni',NULL,148697,39.34,0.13,738,70647,70,NULL,'SALT 2, Malmquist cor.','SDSS J205452.51-001144.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148698,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148698,34.42,NULL,76.4,70648,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2292',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000007,NULL,'17.0',0.08,'Scd',NULL,NULL,NULL,NULL,1,313.729167,17.66167,0.349,NULL,55292165558,863940086,13499063,17),(148699,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148699,34.42,NULL,76.7,70648,NULL,NULL,'Dipole + Quadrupole','FGC 2292',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148700,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148700,34.43,NULL,76.8,70648,NULL,NULL,'Dipole','FGC 2292',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148701,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148701,34.5,NULL,79.6,70648,NULL,NULL,NULL,'FGC 2292',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148702,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148702,35.59,0.58,131,70649,70,NULL,NULL,'2MASX J20550321-4258330',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.89',0.37,NULL,NULL,NULL,NULL,NULL,1,313.763333,-42.97581,0.065,NULL,51390356731,802974323,12546473,16.89),(148703,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148703,37.7,0.58,347,70650,70,NULL,NULL,'2MASX J20550895-4333319',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.20',0.49,NULL,NULL,NULL,NULL,NULL,1,313.78725,-43.55886,0.065,NULL,51390598026,802978094,12546532,16.2),(148704,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03372','RN',148704,41.27,0.25,1550,70651,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03372',0.157654,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148705,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148705,35.62,0.55,133,70652,70,NULL,NULL,'ESO 187- G 032',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.16',0.8,'S?',NULL,NULL,NULL,NULL,1,313.8015,-54.52364,0.121,NULL,51070027717,797969183,12468268,15.16),(148706,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148706,34.8,0.8,91.4,70653,75,NULL,'MAT, I','ESO 235- G 016',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'14.17',1.1,'(R\')SB(r)bc',NULL,NULL,NULL,NULL,1,313.807083,-49.18831,0.013,NULL,51351177736,802362152,12536908,14.17),(148707,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148707,34.36,0.43,74.6,70653,NULL,NULL,'Malmquist cor.','ESO 235- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148708,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148708,34.38,0.43,75.3,70653,75,NULL,'MAT, I, raw','ESO 235- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148709,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148709,34.49,0.41,79.2,70653,NULL,NULL,NULL,'ESO 235- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148710,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148710,34.51,0.32,79.7,70653,85,NULL,'I, raw','ESO 235- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148711,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148711,34.53,0.2,80.5,70653,74.4,NULL,NULL,'ESO 235- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148712,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148712,34.57,0.32,81.9,70653,85,NULL,'I, inv','ESO 235- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148713,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148713,34.59,0.43,82.8,70653,75,NULL,'MAT, I, cor','ESO 235- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148714,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148714,34.63,0.43,84.2,70653,75,NULL,'MAT, I, inv','ESO 235- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148715,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12863','RN',148715,42.94,0.22,2770,70654,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12863',0.3954,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148716,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12863','RN',148716,43.11,0.2,3000,70654,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12863',0.3954,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148717,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14984',NULL,148717,39.42,0.21,766,70655,70,NULL,NULL,'SDSS J205520.06-000534.0',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,313.833583,-0.09278,0.321,NULL,47781821954,746590968,11665483,NULL),(148718,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14984','R',148718,39.94,0.21,818,70655,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006js','SDSS J205520.06-000534.0',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148719,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14984','R',148719,39.96,0.11,825,70655,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006js','SDSS J205520.06-000534.0',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148720,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148720,36.95,0.6,245,70656,70,NULL,NULL,'2MASX J20552107-5445282',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'13.03',0.31,NULL,NULL,NULL,NULL,NULL,1,313.8377083,-54.75781,0.149,NULL,48989573393,765462084,11960345,13.03),(148721,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16408','RN',148721,41,0.32,1250,70657,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16408',0.2667,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148722,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16408','RN',148722,41.19,0.28,1370,70657,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16408',0.2667,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148723,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148723,33.53,0.4,50.8,70658,NULL,NULL,'mean','UGC 11649',NULL,'2007A&A...465...71T',2007,1,1.35,NULL,'G',0.000013,NULL,'14.0g',1.02,'SB(r)a pec',NULL,NULL,NULL,NULL,1,313.865083,-1.22525,0.389,NULL,47782069363,746594833,11665544,14),(148724,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148724,33.76,0.47,56.4,70658,NULL,NULL,'H','UGC 11649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148725,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148725,33.77,0.45,56.7,70658,NULL,NULL,'K','UGC 11649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148726,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148726,33.79,0.46,57.3,70658,NULL,NULL,'J','UGC 11649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148727,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148727,33.86,0.35,59.3,70658,NULL,NULL,NULL,'UGC 11649',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148728,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148728,33.89,0.35,60,70658,NULL,NULL,'Malmquist cor.','UGC 11649',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148729,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148729,33.9,0.2,60.3,70658,74.4,NULL,NULL,'UGC 11649',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148730,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148730,35.12,0.59,106,70659,70,NULL,NULL,'2MASX J20553057-4327450',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.78',0.3,'S',NULL,NULL,NULL,NULL,1,313.8775,-43.4625,0.065,NULL,51390480611,802976259,12546504,15.78),(148731,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148731,35.72,0.46,139,70660,70,NULL,NULL,'CGCG 374-030',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000112,NULL,'15.5g',0.48,'Sa      poss. LINER?','Isolated galaxy',NULL,NULL,NULL,1,313.902125,-0.63658,0.313,NULL,47782308241,746598566,11665602,15.5),(148732,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148732,37.68,0.46,344,70661,70,NULL,NULL,'2MASX J20553782-0714580',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000093,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,313.907625,-7.24958,0.221,NULL,50795892035,793685813,12401340,16.5),(148733,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148733,37.42,0.79,304,70662,70,NULL,NULL,'2MASX J20553935-5731291',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000133,NULL,'15.91',0.42,'E',NULL,NULL,NULL,NULL,1,313.914,-57.52483,0.281,NULL,49139161484,767799398,11996865,15.91),(148734,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 05616','RN',148734,39.08,0.38,592,70663,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05616',0.104598,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148735,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 05616','RN',148735,39.93,0.51,876,70663,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05616',0.104598,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148736,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148736,38.02,0.46,402,70664,70,NULL,NULL,'2MASX J20554518-0035273',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,313.938458333,-0.59094,0.337,NULL,47782353252,746599269,11665613,18.1),(148737,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148737,35.94,0.62,154,70665,70,NULL,NULL,'2MASX J20554966-5408102',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.9b',0.3,NULL,NULL,NULL,NULL,NULL,1,313.957041667,-54.13611,0.109,NULL,51069938167,797967783,12468246,16.9),(148738,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148738,35.88,0.63,150,70666,70,NULL,NULL,'AM 2052-440',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.17',0.58,'(R_1R\'_2)SB0/a',NULL,NULL,NULL,NULL,1,313.9725417,-43.81344,0.073,NULL,51390075954,802969936,12546405,16.17),(148739,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148739,38.01,0.63,400,70667,70,NULL,NULL,'2MASX J20555490-5154356',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.33',0.47,'S0',NULL,NULL,NULL,NULL,1,313.9787917,-51.90986,0.033,NULL,51341042830,802203794,12534434,16.33),(148740,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148740,36.96,0.46,247,70668,70,NULL,NULL,'2MASX J20555707-0015362',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000179,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,313.987667,-0.26008,0.321,NULL,47781976405,746593381,11665521,16.7),(148741,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148741,36.37,0.5,188,70669,70,NULL,NULL,'2MASX J20555953-4319541',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.35',0.35,NULL,NULL,NULL,NULL,NULL,1,313.998,-43.33164,0.065,NULL,51390015095,802968985,12546390,16.35),(148742,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148742,36.68,0.53,217,70670,70,NULL,NULL,'2MASX J20560440-4605031',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.00009,NULL,'16.14',0.32,'E',NULL,NULL,NULL,NULL,1,314.018458333,-46.08431,0.029,NULL,51401959945,803155624,12549306,16.14),(148743,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148743,37.05,0.46,257,70671,70,NULL,NULL,'2MASX J20560699-0619578',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000064,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,314.02925,-6.33272,0.145,NULL,50796089574,793688899,12401389,17.6),(148744,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148744,36.29,0.6,181,70672,70,NULL,NULL,'2MASX J20560728-0813488',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.52',NULL,NULL,NULL,NULL,NULL,NULL,1,314.0302083,-8.23008,0.213,NULL,50799010503,793734539,12402102,16.52),(148745,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148745,35.7,0.52,138,70673,70,NULL,NULL,'2MASX J20561137-1702333',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.09',0.5,NULL,NULL,NULL,NULL,NULL,1,314.047333333,-17.04264,0.205,NULL,51002003716,796906308,12451661,16.09),(148746,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13744','RN',148746,39.17,0.21,557,70674,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13744',0.222542,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148747,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13744','RN',148747,39.95,0.23,799,70674,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13744',0.222542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148748,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148748,37.73,0.46,352,70675,70,NULL,NULL,'2MASX J20561457-0110501',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,314.0607917,-1.18067,0.297,NULL,47782059109,746594673,11665541,18),(148749,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148749,36.7,0.46,219,70676,70,NULL,NULL,'2MASX J20562197-0521165',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000073,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,314.091583,-5.35461,0.157,NULL,50739976992,792812140,12387689,17.2),(148750,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148750,41.61,NULL,2100,70677,NULL,NULL,'4.2 (black) calibration','MS 2053.7-0449',NULL,'2010ApJ...721..653R',2010,1,NULL,NULL,'GClstr',0.003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.090833,-4.63083,0.193,NULL,50747417961,792928405,12389506,NULL),(148751,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148751,41.85,NULL,2340,70677,NULL,NULL,'3.1 (red) calibration','MS 2053.7-0449',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148752,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148752,41.97,0.35,2480,70677,NULL,NULL,'Hydrost. Eq.','MS 2053.7-0449',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148753,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148753,42.03,NULL,2550,70677,NULL,NULL,'4.1 (blue) calibration','MS 2053.7-0449',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148754,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148754,42.46,0.82,3110,70677,NULL,NULL,'Isotherm.','MS 2053.7-0449',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148755,'SZ effect','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148755,42.77,0.91,3580,70677,NULL,NULL,'Isotherm., r < 100 kpc','MS 2053.7-0449',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148756,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148756,34.53,0.53,80.4,70678,70,NULL,NULL,'MCG -02-53-014',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000083,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,314.095917,-14.30436,0.189,NULL,50987566872,796680732,12448136,15.5),(148757,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148757,35.12,0.49,106,70679,75,NULL,'IR','UGC 11650',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',NULL,NULL,'15.42',0.3,'Scd:',NULL,NULL,NULL,NULL,1,314.1147917,12.04128,0.429,NULL,55071295519,860488992,13445140,15.42),(148758,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148758,35.41,0.32,121,70679,NULL,NULL,'Malmquist cor.','UGC 11650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148759,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148759,35.47,0.2,124,70679,74.4,NULL,NULL,'UGC 11650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148760,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148760,35.48,0.31,125,70679,NULL,NULL,NULL,'UGC 11650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148761,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002el',NULL,148761,34.95,0.22,95,70680,72,NULL,NULL,'NGC 6986',0.02873,'2006ApJ...645..488W',2006,1,1,'2002IAUC.7954A...1W has V = 6986 km/s.','G',0.000087,NULL,'14.55',0.6,'SB0-?',NULL,NULL,NULL,NULL,1,314.12775,-18.56656,0.225,NULL,50991381998,796740343,12449067,14.55),(148762,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002el',NULL,148762,35.2,0.16,106,70680,70,NULL,'SALT 2','NGC 6986',0.02873,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148763,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002el','R',148763,35.18,0.05,109,70680,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 6986',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148764,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2002el','R',148764,35.23,0.05,111,70680,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 6986',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148765,'L(H{beta})-{sigma}','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148765,44.67,NULL,1624,70681,74.3,NULL,NULL,'WISP 159_0134',1.3,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.1287917,-4.79897,0.205,NULL,50747435286,792928676,12389510,NULL),(148766,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148766,36.58,0.5,207,70682,70,NULL,NULL,'2MASX J20563161-5208314',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.2b',0.37,'S0',NULL,NULL,NULL,NULL,1,314.131833,-52.14214,0.041,NULL,51341822649,802215978,12534624,16.2),(148767,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20536',NULL,148767,41.56,0.03,2050,70683,70,NULL,'SN photometric redshift distance, z photo =0.686 +/- 0.014','SDSS-II SN 20536',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,314.141375,-0.38786,0.253,NULL,47782520435,746601881,11665654,21.8),(148768,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148768,37.67,0.46,342,70684,70,NULL,NULL,'2MASX J20563550-0713460',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000101,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,314.1479583,-7.22939,0.173,NULL,50795743682,793683495,12401304,17.4),(148769,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148769,34.98,0.49,99.2,70685,70,NULL,NULL,'2MASX J20563628-0320525',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000037,NULL,'15.5',0.8,'S0- pec',NULL,NULL,NULL,NULL,1,314.1512083,-3.34794,0.237,NULL,50749601677,792962526,12390039,15.5),(148770,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148770,36.11,0.5,167,70686,70,NULL,NULL,'ESO 235- G 018',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.0001,NULL,'15.37',0.7,'SB(rs)a',NULL,NULL,NULL,NULL,1,314.152416667,-51.56125,0.033,NULL,51341156767,802205574,12534462,15.37),(148771,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2005jj',NULL,148771,41.16,0.2,1250,70687,74.2,NULL,'SALT 2','SDSS J205644.45+002429.6',0.368,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',NULL,NULL,'20.6g',0.05,NULL,NULL,NULL,NULL,NULL,1,314.18525,0.40825,0.273,NULL,53956563523,843071305,13172989,20.6),(148772,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07947','R',148772,41.84,0.31,1700,70687,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005jj','SDSS J205644.45+002429.6',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148773,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2005jj',NULL,148773,41.91,0.23,1760,70687,70,NULL,'SALT 2','SDSS J205644.45+002429.6',0.368,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148774,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07947','R',148774,42.32,0.31,2130,70687,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005jj','SDSS J205644.45+002429.6',0.37,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148775,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148775,38.56,0.46,516,70688,70,NULL,NULL,'SDSS J205651.91-072110.7',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000093,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,314.216333333,-7.35297,0.221,NULL,50797512970,793711140,12401736,17.9),(148776,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148776,36.85,0.46,234,70689,70,NULL,NULL,'2MASX J20565334+0010448',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000223,NULL,'16.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,314.222125,0.17917,0.273,NULL,53956389206,843068581,13172946,16.8),(148777,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15652','RN',148777,42.89,0.26,2400,70690,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15652',0.573376,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148778,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148778,36.7,0.52,218,70691,70,NULL,NULL,'2MASX J20565516-4206324',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.20',0.45,NULL,NULL,NULL,NULL,NULL,1,314.23,-42.10903,0.081,NULL,51388891331,802951427,12546116,16.2),(148779,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14030','RN',148779,39.61,0.08,768,70692,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14030',0.086529,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148780,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14030','RN',148780,40.19,0.21,1000,70692,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14030',0.086529,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148781,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148781,32.09,0.8,26.2,70693,75,NULL,NULL,'ESO 187-IG 035',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000026,NULL,'15.26',0.8,'SB(s)m',NULL,NULL,NULL,NULL,1,314.2327083,-55.71992,0.201,NULL,49124204308,767565692,11993213,15.26),(148782,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006jp',NULL,148782,38.56,0.06,514,70694,70,NULL,'Hubble residual -0.45 for z0.16040','SDSS-II SN 14782 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.234083,-0.27917,0.253,NULL,47782492713,746601448,11665647,NULL),(148783,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14782','R',148783,39.12,0.2,566,70694,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jp','SDSS-II SN 14782 HOST',0.179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148784,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14782','R',148784,39.24,0.08,599,70694,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jp','SDSS-II SN 14782 HOST',0.179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148785,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148785,36.54,0.52,203,70695,70,NULL,NULL,'2MASX J20570010-4924585',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.38',0.48,'S',NULL,NULL,NULL,NULL,1,314.250417,-49.41622,0.025,NULL,51354683064,802416922,12537764,16.38),(148786,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15823','R',148786,40.21,0.2,905,70696,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15823',0.2152,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.2525417,0.199,0.273,NULL,53956438063,843069344,13172958,NULL),(148787,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15823','R',148787,40.44,0.12,1010,70696,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15823',0.2152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148788,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12852','R',148788,40.74,0.22,1110,70697,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12852',0.264,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.2530417,0.68914,0.249,NULL,53956470962,843069858,13172966,NULL),(148789,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12852','R',148789,40.74,0.29,1110,70697,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12852',0.264,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148790,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148790,36.62,0.68,211,70698,70,NULL,NULL,'2MASX J20570375-5206225',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.67',0.23,NULL,NULL,NULL,NULL,NULL,1,314.265667,-52.10631,0.045,NULL,51342345479,802224148,12534752,16.67),(148791,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148791,35.44,0.53,123,70699,70,NULL,NULL,'2MASX J20570805-6152531',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000133,NULL,'15.8b',0.35,'E',NULL,NULL,NULL,NULL,1,314.283583,-61.88136,0.113,NULL,49176860961,768388452,12006069,15.8),(148792,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148792,34.08,0.2,65.5,70700,74.4,NULL,NULL,'CGCG 425-022',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00012,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,314.288625,13.52397,0.397,NULL,55281563017,863774422,13496475,15.5),(148793,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148793,34.22,0.49,69.7,70700,75,NULL,'IR','CGCG 425-022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148794,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148794,34.26,0.32,71.3,70700,NULL,NULL,NULL,'CGCG 425-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148795,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148795,34.3,0.31,72.6,70700,NULL,NULL,'Malmquist cor.','CGCG 425-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148796,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148796,35.62,0.56,133,70701,70,NULL,NULL,'2MASX J20571032-0754250',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.37',0.5,NULL,NULL,NULL,NULL,NULL,1,314.2929583,-7.90708,0.201,NULL,50800906823,793764169,12402565,16.37),(148797,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148797,31.79,0.8,22.8,70702,75,NULL,'A82, H','UGC 11651',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000005,NULL,'14.4',0.8,'Sdm',NULL,NULL,NULL,NULL,1,314.314125,25.96486,0.797,NULL,55717207735,870581370,13602833,14.4),(148798,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148798,31.59,0.38,20.8,70702,NULL,NULL,NULL,'UGC 11651',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148799,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148799,31.62,0.2,21.1,70702,74.4,NULL,NULL,'UGC 11651',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148800,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148800,31.73,0.4,22.2,70702,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 11651',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148801,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148801,31.87,0.4,23.7,70702,75,NULL,'B','UGC 11651',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148802,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148802,31.95,0.47,24.5,70702,75,NULL,'A82, H, raw','UGC 11651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148803,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148803,31.96,0.47,24.6,70702,75,NULL,'A82, H, inv','UGC 11651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148804,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148804,32.27,0.47,28.4,70702,75,NULL,'A82, H, cor','UGC 11651',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148805,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148805,32.32,0.49,29.2,70702,75,NULL,'IR','UGC 11651',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148806,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148806,36.06,0.46,163,70703,70,NULL,NULL,'2MASX J20571901-0029426',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000168,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,314.329125,-0.49511,0.253,NULL,47782394867,746599919,11665623,16.1),(148807,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03545','RN',148807,40.9,0.24,1340,70704,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03545',0.135542,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148808,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03545','RN',148808,41.09,0.23,1460,70704,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03545',0.135542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148809,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16204','RN',148809,37.57,0.08,310,70705,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16204',0.054544,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148810,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16204','RN',148810,38.47,0.3,469,70705,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16204',0.054544,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148811,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148811,37.38,0.33,299,70706,70,NULL,NULL,'2MASX J20572566+0038011',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,314.356875,0.63358,0.249,NULL,53956499245,843070300,13172973,17.5),(148812,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148812,38.09,0.46,415,70707,70,NULL,NULL,'2MASX J20572622-0033336',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,314.359167,-0.55931,0.253,NULL,47782390750,746599855,11665622,18.1),(148813,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148813,35.3,0.63,115,70708,70,NULL,NULL,'2MASX J20572892-5258362',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.81',0.3,'S',NULL,NULL,NULL,NULL,1,314.370583,-52.97675,0.077,NULL,51338962345,802171286,12533926,15.81),(148814,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148814,37.38,0.33,299,70709,70,NULL,NULL,'2MASX J20573339+0039371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,314.389083333,0.66039,0.269,NULL,53956455134,843069611,13172962,17.5),(148815,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148815,33.94,0.8,61.3,70710,75,NULL,'MAT, I','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,1,1.63,NULL,'G',0.000033,NULL,'14.58',0.35,'Sab? sp','Pair member (points to parent)',NULL,NULL,NULL,1,314.410625,-46.60547,0.025,NULL,51402062149,803157221,12549331,14.58),(148816,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148816,33.95,0.8,61.5,70710,75,NULL,'HMCL, I','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148817,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148817,33.58,0.4,52.1,70710,75,NULL,'HMCL, I, raw','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148818,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148818,33.65,0.49,53.8,70710,75,NULL,'IR','ESO 286- G 016',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148819,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148819,33.72,0.4,55.5,70710,75,NULL,'HMCL, I, inv','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148820,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148820,33.88,0.32,59.7,70710,85,NULL,'I, raw','ESO 286- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148821,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148821,33.92,0.43,60.8,70710,75,NULL,'MAT, I, raw','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148822,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148822,33.92,0.4,60.8,70710,75,NULL,'HMCL, I, cor','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148823,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148823,33.92,0.32,60.9,70710,85,NULL,'I, inv','ESO 286- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148824,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148824,34.09,0.47,65.8,70710,NULL,NULL,'H','ESO 286- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148825,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148825,34.11,0.33,66.4,70710,NULL,NULL,NULL,'ESO 286- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148826,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148826,34.13,0.43,66.9,70710,75,NULL,'MAT, I, inv','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148827,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148827,34.15,0.2,67.6,70710,74.4,NULL,NULL,'ESO 286- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148828,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148828,34.18,0.45,68.5,70710,NULL,NULL,'K','ESO 286- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148829,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148829,34.19,0.43,68.9,70710,75,NULL,'MAT, I, cor','ESO 286- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148830,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148830,34.21,0.4,69.5,70710,NULL,NULL,'mean','ESO 286- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148831,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148831,34.22,0.31,69.9,70710,NULL,NULL,'Malmquist cor.','ESO 286- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148832,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148832,34.25,0.46,70.7,70710,NULL,NULL,'J','ESO 286- G 016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148833,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148833,36.78,0.5,227,70711,70,NULL,NULL,'FAIRALL 0925',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00015,NULL,'15.64',0.53,'S0',NULL,NULL,NULL,NULL,1,314.417125,-51.19617,0.037,NULL,51340930195,802202034,12534406,15.64),(148834,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148834,36.19,0.74,173,70712,70,NULL,NULL,'6dF J2057419-333154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,314.424375,-33.53158,0.305,NULL,51525065664,805079151,12579361,15.8),(148835,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148835,33.62,0.5,53,70713,70,NULL,NULL,'ESO 144- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'17.7b',1,'(RL)SB(s)0^0',NULL,NULL,NULL,NULL,1,314.4265417,-61.43864,0.109,NULL,49187933749,768561464,12008772,17.7),(148836,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148836,34.49,0.49,79.2,70714,75,NULL,'IR','UGC 11655',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000013,NULL,'16.5',0.3,'Sd:',NULL,NULL,NULL,NULL,1,314.455333,25.63786,0.517,NULL,55717369366,870583896,13602873,16.5),(148837,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148837,36.85,0.61,235,70715,70,NULL,NULL,'2MASX J20574940-1611293',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.94',0.3,NULL,NULL,NULL,NULL,NULL,1,314.455916667,-16.19147,0.193,NULL,51001300185,796895315,12451489,15.94),(148838,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148838,35.34,0.8,117,70716,75,NULL,'MAT, I','ESO 286- G 018',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000033,NULL,'14.26',0.4,'SB(s)bc? sp','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,314.45975,-43.37442,0.065,NULL,51390036444,802969319,12546395,14.26),(148839,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148839,34.36,0.46,74.5,70716,NULL,NULL,'B, Hubble-type-TF','ESO 286- G 018',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148840,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148840,34.81,0.57,91.5,70716,NULL,NULL,'Malmquist cor.','ESO 286- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148841,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148841,34.87,0.47,94.3,70716,NULL,NULL,'H','ESO 286- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148842,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148842,34.9,0.45,95.3,70716,NULL,NULL,'K','ESO 286- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148843,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148843,34.94,0.46,97.1,70716,NULL,NULL,'J','ESO 286- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148844,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148844,34.96,0.43,98.3,70716,75,NULL,'MAT, I, raw','ESO 286- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148845,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148845,34.99,0.49,99.6,70716,75,NULL,'IR','ESO 286- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148846,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148846,35.09,0.5,104,70716,NULL,NULL,NULL,'ESO 286- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148847,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148847,35.13,0.2,106,70716,74.4,NULL,NULL,'ESO 286- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148848,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148848,35.29,0.43,114,70716,75,NULL,'MAT, I, cor','ESO 286- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148849,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148849,35.36,0.43,118,70716,75,NULL,'MAT, I, inv','ESO 286- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148850,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148850,35.38,0.4,119,70716,NULL,NULL,'mean','ESO 286- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148851,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148851,35.39,0.32,120,70716,85,NULL,'I, raw','ESO 286- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148852,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148852,35.49,0.32,125,70716,85,NULL,'I, inv','ESO 286- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148853,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148853,35.68,0.55,137,70717,70,NULL,NULL,'2MASX J20575387-5448327',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.80',0.5,'S',NULL,NULL,NULL,NULL,1,314.474417,-54.80914,0.129,NULL,48989492284,765460816,11960325,15.8),(148854,'Ring Diameter','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148854,34.5,0.84,79,70718,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 6984',NULL,'1981ApJS...45..541P',1981,1,1.8,NULL,'G',0.00003,NULL,'13.17',1.2,'SB(r)c','in a pair',NULL,NULL,NULL,1,314.474916667,-51.87083,0.037,NULL,51341548790,802211699,12534557,13.17),(148855,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148855,33.82,0.8,58.1,70718,75,NULL,'MAT, I','NGC 6984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148856,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148856,32.76,0.32,35.7,70718,85,NULL,'I, raw','NGC 6984',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148857,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148857,32.79,0.32,36.2,70718,85,NULL,'I, inv','NGC 6984',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148858,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148858,32.93,0.43,38.5,70718,75,NULL,'MAT, I, raw','NGC 6984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148859,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148859,33.09,0.43,41.6,70718,75,NULL,'MAT, I, inv','NGC 6984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148860,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148860,33.11,NULL,41.9,70718,NULL,NULL,'I','NGC 6984',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148861,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148861,33.13,0.22,42.3,70718,NULL,NULL,'B, Hubble-type-TF','NGC 6984',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148862,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148862,33.14,NULL,42.5,70718,NULL,NULL,'B','NGC 6984',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148863,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148863,33.25,0.43,44.7,70718,75,NULL,'MAT, I, cor','NGC 6984',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148864,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148864,33.47,0.61,49.3,70718,NULL,NULL,NULL,'NGC 6984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148865,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148865,33.51,0.2,50.4,70718,74.4,NULL,NULL,'NGC 6984',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148866,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148866,33.58,0.58,52.1,70718,NULL,NULL,'Malmquist cor.','NGC 6984',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148867,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148867,33.67,0.47,54.2,70718,NULL,NULL,'H','NGC 6984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148868,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148868,33.69,0.46,54.8,70718,NULL,NULL,'J','NGC 6984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148869,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148869,33.72,0.45,55.4,70718,NULL,NULL,'K','NGC 6984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148870,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148870,33.98,0.4,62.5,70718,NULL,NULL,'mean','NGC 6984',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148871,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148871,34.73,0.47,88.2,70719,70,NULL,NULL,'IC 1339',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000033,NULL,'14.14',0.9,'SB(rs)ab poss. LINER',NULL,NULL,NULL,NULL,1,314.481333333,-17.94283,0.205,NULL,50999396742,796865574,12451024,14.14),(148872,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148872,35.21,0.47,110,70719,NULL,NULL,'H','IC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148873,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148873,35.24,0.4,112,70719,NULL,NULL,'mean','IC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148874,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148874,35.28,0.45,114,70719,NULL,NULL,'K','IC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148875,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148875,35.31,0.46,115,70719,NULL,NULL,'J','IC 1339',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148876,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148876,35.49,0.28,125,70719,NULL,NULL,'Malmquist cor.','IC 1339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148877,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148877,35.7,0.25,138,70719,NULL,NULL,NULL,'IC 1339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148878,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148878,35.74,0.2,141,70719,74.4,NULL,NULL,'IC 1339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148879,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148879,35.83,0.57,147,70720,70,NULL,NULL,'2MASX J20575761-7257011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,314.489916667,-72.95031,0.177,NULL,49325916781,770717449,12042460,15.6),(148880,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148880,36.75,0.46,224,70721,70,NULL,NULL,'2MASX J20575947-0639557',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,314.49775,-6.66564,0.117,NULL,50795308351,793676692,12401198,17.1),(148881,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148881,36.82,0.61,231,70722,70,NULL,NULL,'2MASX J20580060-5328470',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.000117,NULL,'16.6b',0.22,'S0',NULL,NULL,NULL,NULL,1,314.5020417,-53.47997,0.105,NULL,51339167500,802174492,12533976,16.6),(148882,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148882,37.23,0.33,279,70723,70,NULL,NULL,'2MASX J20580238-0733276',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000101,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,314.5097917,-7.55764,0.225,NULL,50797714013,793714281,12401785,17.1),(148883,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148883,35.38,0.5,119,70724,NULL,NULL,'Malmquist cor.','ESO 464- G 003',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.34',0.7,'Sb             HII',NULL,NULL,NULL,NULL,1,314.51,-32.29042,0.317,NULL,51494762590,804605665,12571963,14.34),(148884,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148884,35.44,0.48,122,70724,NULL,NULL,NULL,'ESO 464- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148885,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148885,35.48,0.2,125,70724,74.4,NULL,NULL,'ESO 464- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148886,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148886,35.67,0.47,136,70724,NULL,NULL,'H','ESO 464- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148887,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148887,35.7,0.4,138,70724,NULL,NULL,'mean','ESO 464- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148888,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148888,35.72,0.45,139,70724,NULL,NULL,'K','ESO 464- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148889,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148889,35.78,0.46,143,70724,NULL,NULL,'J','ESO 464- G 003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148890,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14450','R',148890,40.05,0.09,915,70725,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006kn','SDSS J205805.22+005401.7',0.12,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.52175,0.90047,0.281,NULL,55029865241,859841644,13435025,NULL),(148891,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14450','R',148891,40.53,0.2,1140,70725,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006kn','SDSS J205805.22+005401.7',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148892,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006kn',NULL,148892,38.23,0.09,395,70725,NULL,NULL,'SCM 55 SNII','SDSS J205805.22+005401.7',0.12,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148893,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006kn',NULL,148893,38.51,0.11,450,70725,NULL,NULL,'SCM 15 SDSS SNII','SDSS J205805.22+005401.7',0.12,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148894,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148894,35.48,0.61,125,70726,70,NULL,NULL,'6dF J2058061-274806',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,314.5259583,-27.80167,0.405,NULL,51493068828,804579200,12571550,14.9),(148895,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148895,35.01,0.62,100,70727,NULL,NULL,'Malmquist cor.','CGCG 425-027 NED02',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000117,NULL,'13.2I',0.3,NULL,NULL,NULL,NULL,NULL,1,314.5269583,13.51522,0.385,NULL,55281540297,863774067,13496469,13.2),(148896,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148896,35.12,0.59,106,70727,NULL,NULL,NULL,'CGCG 425-027 NED02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148897,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148897,35.27,0.2,113,70727,74.4,NULL,NULL,'CGCG 425-027 NED02',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148898,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148898,35.99,0.62,158,70728,70,NULL,NULL,'2MASX J20580953-4349496',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.88',0.23,NULL,NULL,NULL,NULL,NULL,1,314.539875,-43.83053,0.073,NULL,51389978647,802968416,12546381,16.88),(148899,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148899,34.01,0.4,63.5,70729,75,NULL,'Edat, raw','NGC 6987',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00009,NULL,'13.44',1.2,'E0:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,314.543166667,-48.63031,0.073,NULL,51351846407,802372600,12537071,13.44),(148900,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148900,34.28,0.4,71.9,70729,75,NULL,'Edat, cor','NGC 6987',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148901,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148901,34.53,0.46,80.7,70729,70,NULL,NULL,'NGC 6987',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148902,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148902,34.32,0.4,73.3,70729,NULL,NULL,'mean','NGC 6987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148903,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148903,34.64,0.45,84.5,70729,NULL,NULL,'K','NGC 6987',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148904,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148904,36.93,0.83,243,70730,70,NULL,NULL,'2MASX J20581163-1446266',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'13.3I',0.7,NULL,NULL,NULL,NULL,NULL,1,314.5485417,-14.77406,0.149,NULL,50989238340,796706849,12448544,13.3),(148905,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02842','RN',148905,36.76,0.14,214,70731,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02842',0.052639,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148906,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02842','RN',148906,38.59,0.72,496,70731,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02842',0.052639,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148907,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148907,35.03,0.49,102,70732,75,NULL,'IR','CGCG 400-014',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000113,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,314.562416667,8.35833,0.265,NULL,55096253010,860878953,13451233,15.7),(148908,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148908,37.23,0.33,279,70733,70,NULL,NULL,'2MASX J20581650-0732156',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,314.568666667,-7.53764,0.225,NULL,50797584660,793712260,12401754,17.3),(148909,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01785','RN',148909,44.05,0.58,4460,70734,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01785',0.450842,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148910,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148910,34.27,0.49,71.6,70735,70,NULL,NULL,'ESO 235- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.33',0.6,'SA(s)0^0^: pec',NULL,NULL,NULL,NULL,1,314.5754583,-49.01247,0.045,NULL,51351211055,802362672,12536916,14.33),(148911,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148911,36.6,0.23,208,70736,70,NULL,NULL,'2MASX J20582113-0021041',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,314.588083,-0.35114,0.277,NULL,47781733014,746589578,11665462,17),(148912,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 08912',NULL,148912,39.39,0.73,755,70737,70,NULL,'SN photometric redshift distance, z photo =0.195 +/- 0.092','SDSS-II SN 08912',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,314.59075,-0.16089,0.277,NULL,47781746071,746589782,11665465,21.1),(148913,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148913,35.82,0.63,146,70738,70,NULL,NULL,'2MASX J20582178-7922596',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,'E',NULL,NULL,NULL,NULL,1,314.591,-79.38325,0.617,NULL,48585934354,759155224,11861800,17),(148914,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148914,34.67,0.51,85.8,70739,70,NULL,NULL,'ESO 464- G 005',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00009,NULL,'14.89',0.8,'S?       poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,314.604083,-31.47167,0.301,NULL,51502749870,804730466,12573913,14.89),(148915,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148915,34.68,0.49,86.2,70740,70,NULL,NULL,'2MASX J20582527-1527435',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.08',0.3,NULL,NULL,NULL,NULL,NULL,1,314.605333333,-15.46206,0.185,NULL,50987313937,796676780,12448074,15.08),(148916,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148916,35.05,0.47,103,70741,NULL,NULL,'H','ESO 598- G 009',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.26',0.5,'Sb pec         HII','in a triple',NULL,NULL,NULL,1,314.618916667,-19.98142,0.209,NULL,50948639778,796072496,12438632,14.26),(148917,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148917,35.11,0.46,105,70741,NULL,NULL,'J','ESO 598- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148918,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148918,35.12,0.45,106,70741,NULL,NULL,'K','ESO 598- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148919,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148919,35.29,0.4,114,70741,NULL,NULL,'mean','ESO 598- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148920,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148920,35.35,0.27,117,70741,NULL,NULL,NULL,'ESO 598- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148921,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148921,35.39,0.2,120,70741,74.4,NULL,NULL,'ESO 598- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148922,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148922,35.41,0.26,121,70741,NULL,NULL,'Malmquist cor.','ESO 598- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148923,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148923,35.97,0.56,156,70742,70,NULL,NULL,'2MASX J20582978-5842539',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.83',0.63,'E',NULL,NULL,NULL,NULL,1,314.624,-58.71492,0.217,NULL,49137181728,767768464,11996382,15.83),(148924,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148924,38.62,0.46,528,70743,70,NULL,NULL,'2MASX J20582993+0107397',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000192,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,314.624625,1.12769,0.281,NULL,55029876630,859841822,13435028,17.7),(148925,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148925,37.14,0.46,268,70744,70,NULL,NULL,'2MASX J20583186+0039137',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,314.632833,0.65394,0.269,NULL,55029405641,859834463,13434913,17),(148926,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148926,37.01,0.46,253,70745,70,NULL,NULL,'2MASX J20583225-0736410',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000074,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,314.6345,-7.6115,0.225,NULL,50797589372,793712333,12401755,17.4),(148927,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148927,37.67,0.46,342,70746,70,NULL,NULL,'SDSS J205832.79-001040.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000133,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,314.636666667,-0.17781,0.277,NULL,47781751154,746589861,11665466,18.5),(148928,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148928,36.07,0.54,164,70747,70,NULL,NULL,'2MASX J20583502-6047036',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.3b',0.25,NULL,NULL,NULL,NULL,NULL,1,314.645833,-60.78439,0.169,NULL,49190554853,768602419,12009412,16.3),(148929,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148929,36.1,0.5,166,70748,70,NULL,NULL,'PKS 2054-581',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000103,NULL,'15.0',0.53,'S0',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,314.6565417,-57.94333,0.201,NULL,49140239540,767816242,11997128,15),(148930,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148930,36.65,0.63,214,70749,70,NULL,NULL,'2MASX J20583812-4316373',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.83',0.57,'E',NULL,NULL,NULL,NULL,1,314.658833,-43.27703,0.065,NULL,51391911852,802998622,12546853,15.83),(148931,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148931,35.99,0.46,158,70750,70,NULL,NULL,'CGCG 374-034',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000157,NULL,'15.1g',0.64,'E0',NULL,NULL,NULL,NULL,1,314.659375,0.91258,0.281,NULL,55030177609,859846525,13435101,15.1),(148932,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148932,33.93,0.8,61,70751,75,NULL,'MAT, I','ESO 187- G 039',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.94',0.9,'SAB(s)dm?',NULL,NULL,NULL,NULL,1,314.6947917,-52.80767,0.085,NULL,51341760333,802215005,12534609,14.94),(148933,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148933,32.96,0.32,39.1,70751,85,NULL,'I, inv','ESO 187- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148934,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148934,32.97,0.32,39.3,70751,85,NULL,'I, raw','ESO 187- G 039',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148935,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148935,33.06,0.43,40.9,70751,75,NULL,'MAT, I, inv','ESO 187- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148936,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148936,33.07,0.43,41.1,70751,75,NULL,'MAT, I, raw','ESO 187- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148937,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148937,33.4,0.43,47.8,70751,75,NULL,'MAT, I, cor','ESO 187- G 039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148938,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148938,37.03,0.54,255,70752,70,NULL,NULL,'2MASX J20584861-4520053',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.63',0.6,'E',NULL,NULL,NULL,NULL,1,314.7025,-45.33489,0.025,NULL,51405164520,803205695,12550088,15.63),(148939,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148939,34.78,0.54,90.5,70753,70,NULL,NULL,'MCG -02-53-015',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00007,NULL,'15',0.9,NULL,NULL,NULL,NULL,NULL,1,314.70775,-14.03958,0.129,NULL,50989821063,796715954,12448686,15),(148940,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148940,36.92,0.61,242,70754,70,NULL,NULL,'2MASX J20585166-5301173',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.97',0.27,NULL,NULL,NULL,NULL,NULL,1,314.715333,-53.02161,0.097,NULL,51338949372,802171083,12533923,16.97),(148941,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148941,35.35,0.6,117,70755,70,NULL,NULL,'2MASX J20585908-1820261',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.4,NULL,NULL,NULL,NULL,NULL,1,314.746083333,-18.34069,0.185,NULL,50998691607,796854556,12450852,14),(148942,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148942,35.22,0.52,110,70756,NULL,NULL,'Malmquist cor.','ESO 341- G 023',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.000033,NULL,'14.52',0.4,'(R\':)SB(s)bc:',NULL,NULL,NULL,NULL,1,314.752,-39.46158,0.013,NULL,51527193677,805112401,12579881,14.52),(148943,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148943,35.34,0.49,117,70756,NULL,NULL,NULL,'ESO 341- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148944,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148944,35.38,0.2,119,70756,74.4,NULL,NULL,'ESO 341- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148945,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148945,35.51,0.4,126,70756,NULL,NULL,'mean','ESO 341- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148946,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148946,35.63,0.47,134,70756,NULL,NULL,'H','ESO 341- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148947,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148947,33.96,0.43,61.9,70757,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11656',NULL,'2014MNRAS.444..527S',2014,1,0.96,NULL,'G',NULL,NULL,'15.69',0.13,'Scd',NULL,NULL,NULL,NULL,1,314.7724583,11.28144,0.349,NULL,55080548568,860633571,13447399,15.69),(148948,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148948,34.06,0.49,65,70757,75,NULL,'IR','UGC 11656',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148949,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148949,34.09,0.43,65.8,70757,75,NULL,'3.6 micron, color corrected','UGC 11656',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148950,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148950,34.18,0.2,68.6,70757,74.4,NULL,NULL,'UGC 11656',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148951,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148951,34.19,0.28,68.8,70757,NULL,NULL,NULL,'UGC 11656',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148952,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148952,34.22,0.28,70,70757,NULL,NULL,'Malmquist cor.','UGC 11656',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148953,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148953,34.8,NULL,91.4,70757,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148954,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148954,34.82,NULL,92,70757,NULL,NULL,'Dipole + Quadrupole','UGC 11656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148955,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148955,34.83,NULL,92.5,70757,NULL,NULL,'Dipole','UGC 11656',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148956,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148956,36.03,0.52,161,70758,70,NULL,NULL,'2MASX J20590569-5428305',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.27',0.48,'S0',NULL,NULL,NULL,NULL,1,314.773666667,-54.47511,0.121,NULL,51338318742,802161230,12533769,16.27),(148957,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148957,36.6,0.23,208,70759,70,NULL,NULL,'2MASX J20590822-0014219',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000175,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,314.78425,-0.2395,0.277,NULL,47781559553,746586868,11665419,17.1),(148958,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148958,36.66,0.78,214,70760,70,NULL,NULL,'2MASX J20590925-5428575',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.0b',0.35,'S',NULL,NULL,NULL,NULL,1,314.788583,-54.48261,0.121,NULL,51338318722,802161230,12533769,16),(148959,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148959,36.6,0.23,208,70761,70,NULL,NULL,'2MASX J20591037-0033029',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,314.7930417,-0.55086,0.245,NULL,50734411182,792725174,12386330,17.5),(148960,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148960,36.3,0.52,182,70762,70,NULL,NULL,'2MASX J20591502-5207113',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.3b',0.32,NULL,NULL,NULL,NULL,NULL,1,314.812667,-52.11983,0.053,NULL,51342392541,802224883,12534763,16.3),(148961,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148961,36.24,0.51,177,70763,70,NULL,NULL,'2MASX J20591516-5101343',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.4b',0.43,NULL,NULL,NULL,NULL,NULL,1,314.813167,-51.02628,0.037,NULL,51352181430,802377834,12537153,16.4),(148962,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148962,36.56,0.74,205,70764,70,NULL,NULL,'2MASX J20591748-1642317',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.07',0.3,NULL,NULL,NULL,NULL,NULL,1,314.822875,-16.70872,0.185,NULL,51002701768,796917215,12451831,16.07),(148963,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148963,36.17,0.72,172,70765,70,NULL,NULL,'2MASX J20592192-5621096',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'17.28',0.17,NULL,NULL,NULL,NULL,NULL,1,314.8414583,-56.35264,0.113,NULL,49127829031,767622328,11994098,17.28),(148964,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148964,35.92,0.62,153,70766,70,NULL,NULL,'2MASX J20592276-2118501',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.12',0.44,NULL,NULL,NULL,NULL,NULL,1,314.8447917,-21.31408,0.193,NULL,50951536319,796117754,12439339,16.12),(148965,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148965,37.2,0.6,275,70767,70,NULL,NULL,'2MASX J20592451-5422566',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.7b',0.35,NULL,NULL,NULL,NULL,NULL,1,314.852,-54.38236,0.109,NULL,51338326141,802161345,12533771,16.7),(148966,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148966,37.43,0.81,306,70768,70,NULL,NULL,'2MASX J20592757-5717156',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.92',0.29,NULL,NULL,NULL,NULL,NULL,1,314.865083,-57.28758,0.281,NULL,49139439041,767803735,11996933,16.92),(148967,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148967,38.28,0.46,454,70769,70,NULL,NULL,'2MASX J20592798+0041157',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,314.866667,0.68758,0.253,NULL,55029448437,859835131,13434923,18.1),(148968,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006jj',NULL,148968,40.04,0.11,1020,70770,70,NULL,'Hubble residual 0.03 for z0.27010','SDSS J205934.81+011323.7',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,314.895125,1.22328,0.293,NULL,55030084374,859845068,13435079,NULL),(148969,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14298','R',148969,40.83,0.14,1150,70770,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jj','SDSS J205934.81+011323.7',0.2701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148970,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14298','R',148970,40.86,0.22,1170,70770,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jj','SDSS J205934.81+011323.7',0.2701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148971,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148971,36.13,0.51,168,70771,70,NULL,NULL,'2MASX J20593583-5159176',NULL,'2014MNRAS.445.2677S',2014,1,1.02,NULL,'G',0.00015,NULL,'15.26',0.52,'S0',NULL,NULL,NULL,NULL,1,314.899375,-51.98822,0.053,NULL,51341510311,802211098,12534548,15.26),(148972,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148972,36.6,0.23,208,70772,70,NULL,NULL,'2MASX J20593860-0002133',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'16.3g',0.26,'E0',NULL,NULL,NULL,NULL,1,314.9107917,-0.03708,0.265,NULL,47781526221,746586347,11665411,16.3),(148973,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16722','RN',148973,41,0.3,1180,70773,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16722',0.3448,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148974,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16722','RN',148974,41.26,0.26,1330,70773,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16722',0.3448,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148975,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148975,35.95,0.55,155,70774,70,NULL,NULL,'2MFGC 15895',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,314.9309583,-69.64611,0.161,NULL,49338641022,770916265,12045566,16.5),(148976,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148976,36.59,0.63,208,70775,70,NULL,NULL,'2MASX J20594609-5352216',NULL,'2014MNRAS.445.2677S',2014,1,0.27,NULL,'G',0.00015,NULL,'15.6R',0.14,NULL,NULL,NULL,NULL,NULL,1,314.942083,-53.87267,0.113,NULL,51338445506,802163211,12533800,15.6),(148977,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13716',NULL,148977,40.33,0.15,1170,70776,70,NULL,'SN photometric redshift distance, z photo =0.322 +/- 0.028','SDSS-II SN 13716',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,314.954167,0.48847,0.261,NULL,55029527759,859836371,13434943,NULL),(148978,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148978,36.06,0.66,163,70777,70,NULL,NULL,'FAIRALL 0577',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,'Eastern',NULL,NULL,NULL,NULL,1,314.975625,-80.76881,0.529,NULL,48574037079,758969329,11858895,17.2),(148979,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148979,34.93,0.46,96.6,70778,70,NULL,NULL,'FAIRALL 0929',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'15.60',0.9,'E2:',NULL,NULL,NULL,NULL,1,314.993375,-49.03703,0.049,NULL,51351714847,802370544,12537039,15.6),(148980,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 21042','R',148980,40.87,0.25,1140,70779,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qz','SN 2007qz',0.312,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,315.0115417,0.82758,0.253,NULL,55030255197,859847737,13435120,NULL),(148981,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 21042','R',148981,41.06,0.18,1240,70779,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qz','SN 2007qz',0.312,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148982,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148982,37.13,0.46,267,70780,70,NULL,NULL,'2MASX J21000403+0011537',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000182,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,315.01675,0.19839,0.257,NULL,55029328126,859833251,13434894,16.8),(148983,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148983,38.45,0.46,490,70781,70,NULL,NULL,'SDSS J210004.78+001915.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000139,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,315.0199583,0.32097,0.261,NULL,55029321116,859833142,13434892,18.3),(148984,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03034','RN',148984,40.72,0.1,1130,70782,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03034',0.232492,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148985,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03034','RN',148985,40.83,0.2,1190,70782,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03034',0.232492,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148986,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148986,36.23,0.95,177,70783,70,NULL,NULL,'2MASX J21000757-6942231',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.03175,-69.70642,0.165,NULL,49338631661,770916119,12045564,15.4),(148987,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148987,35.26,0.7,113,70784,70,NULL,NULL,'2MASX J21001075-5911012',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000103,NULL,'15.1r',0.38,NULL,NULL,NULL,NULL,NULL,1,315.044708333,-59.18369,0.197,NULL,49136333090,767755204,11996175,15.1),(148988,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15341','RN',148988,40.68,0.14,1230,70785,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15341',0.105802,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148989,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15341','RN',148989,41.25,0.22,1610,70785,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15341',0.105802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(148990,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148990,35.37,0.53,119,70786,70,NULL,NULL,'IC 1341',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.2b',0.3,NULL,NULL,NULL,NULL,NULL,1,315.0695,-13.97633,0.129,NULL,50989436415,796709943,12448592,15.2),(148991,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148991,36.54,0.46,203,70787,70,NULL,NULL,'2MASX J21001817-0638346',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000089,NULL,'16.8g',0.25,NULL,NULL,NULL,NULL,NULL,1,315.075875,-6.64286,0.173,NULL,50797470902,793710482,12401726,16.8),(148992,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148992,37.3,0.72,289,70788,70,NULL,NULL,'2MASX J21001839-4615443',NULL,'2014MNRAS.445.2677S',2014,1,1.05,NULL,'G',0.00015,NULL,'15.13',0.52,'(R\')SA(r)0/a',NULL,NULL,NULL,NULL,1,315.0765417,-46.26236,0.041,NULL,51402202720,803159417,12549365,15.13),(148993,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148993,36.95,0.54,245,70789,70,NULL,NULL,'2MASX J21001910-3315460',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.000103,NULL,'15.0r',0.33,NULL,NULL,NULL,NULL,NULL,1,315.079667,-33.26289,0.309,NULL,51536682825,805260669,12582197,15),(148994,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148994,36.17,0.64,172,70790,70,NULL,NULL,'2MASX J21002323-5903432',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000103,NULL,'15.0r',0.3,NULL,NULL,NULL,NULL,NULL,1,315.0967917,-59.06197,0.197,NULL,49136509418,767757959,11996218,15),(148995,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148995,36.54,0.57,204,70791,70,NULL,NULL,'2MASX J21002613-0322080',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.58',0.2,NULL,NULL,NULL,NULL,NULL,1,315.109125,-3.36894,0.261,NULL,50750075669,792969932,12390155,16.58),(148996,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148996,36.25,0.49,177,70792,70,NULL,NULL,'ESO 286- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000093,NULL,'14.0r',0.6,'Compact',NULL,NULL,NULL,NULL,1,315.1195,-42.42319,0.069,NULL,51392600471,803009382,12547021,14),(148997,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148997,36.69,0.97,217,70793,70,NULL,NULL,'2MASX J21003025-5427502',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'15.1r',0.38,NULL,NULL,NULL,NULL,NULL,1,315.126,-54.46389,0.117,NULL,51338342244,802161597,12533774,15.1),(148998,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',148998,37.36,0.46,296,70794,70,NULL,NULL,'2MASX J21003133+0021452',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,315.130667,0.36247,0.261,NULL,55029299287,859832801,13434887,17.3),(148999,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,148999,33.09,0.2,41.5,70795,74.4,NULL,NULL,'UGC 11660',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',NULL,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,315.131667,13.49139,0.381,NULL,55281942416,863780350,13496567,16),(149000,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149000,33.23,0.64,44.3,70795,NULL,NULL,NULL,'UGC 11660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149001,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149001,33.77,0.5,56.8,70795,NULL,NULL,'Malmquist cor.','UGC 11660',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149002,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149002,36.69,0.61,218,70796,70,NULL,NULL,'2MASX J21003596-3809061',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.6r',0.3,NULL,NULL,NULL,NULL,NULL,1,315.149916667,-38.15178,0.093,NULL,51530981961,805171593,12580806,15.6),(149003,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06501',NULL,149003,40.43,0.14,1220,70797,70,NULL,'SN photometric redshift distance, z photo =0.340 +/- 0.028','SDSS-II SN 06501',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.156875,0.13144,0.225,NULL,52076533329,813695833,12713997,NULL),(149004,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 11102','RN',149004,39.45,0.12,672,70798,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11102',0.153917,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149005,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02052','RN',149005,41.3,0.2,1270,70799,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02052',0.434518,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149006,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02052','RN',149006,41.75,0.13,1560,70799,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02052',0.434518,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149007,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149007,33.97,0.43,62.2,70800,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7003',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000017,NULL,'13.76',0.8,'Sbc',NULL,NULL,NULL,NULL,1,315.17675,17.80489,0.373,NULL,55294403450,863975053,13499610,13.76),(149008,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149008,34,0.43,63,70800,75,NULL,'3.6 micron, color corrected','NGC 7003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149009,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149009,34.03,0.3,63.9,70800,NULL,NULL,NULL,'NGC 7003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149010,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149010,34.04,0.2,64.3,70800,74.4,NULL,NULL,'NGC 7003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149011,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149011,34.22,0.27,70,70800,NULL,NULL,'Malmquist cor.','NGC 7003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149012,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149012,34.23,0.46,70.1,70800,NULL,NULL,'J','NGC 7003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149013,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149013,34.25,0.47,70.9,70800,NULL,NULL,'H','NGC 7003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149014,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149014,34.27,0.4,71.5,70800,NULL,NULL,'mean','NGC 7003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149015,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149015,34.33,0.45,73.4,70800,NULL,NULL,'K','NGC 7003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149016,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13411',NULL,149016,39.16,0.09,681,70801,70,NULL,'Hubble residual 0.13 for z0.16300','SDSS J210045.52+001130.3',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.0005,NULL,'21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,315.189666667,0.19175,0.233,NULL,52076516880,813695576,12713993,21.9),(149017,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13411','R',149017,39.68,0.21,743,70801,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS J210045.52+001130.3',0.163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149018,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13411','R',149018,39.81,0.12,788,70801,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS J210045.52+001130.3',0.163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149019,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149019,35.75,0.52,141,70802,70,NULL,NULL,'6dF J2100494-324344',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.205833,-32.72883,0.313,NULL,51499768710,804683886,12573185,14.3),(149020,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149020,38.71,0.46,551,70803,70,NULL,NULL,'2MASX J21004950-0540256',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000104,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,315.2064583,-5.67381,0.169,NULL,50747114692,792923667,12389432,17.5),(149021,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149021,34.58,0.92,82.5,70804,NULL,NULL,'Malmquist cor.','ESO 235- G 033',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000033,NULL,'12.7r',1.5,'SA(s)c',NULL,NULL,NULL,NULL,1,315.2122917,-48.59861,0.073,NULL,51351739560,802370930,12537045,12.7),(149022,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149022,35.28,0.66,114,70804,NULL,NULL,NULL,'ESO 235- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149023,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149023,35.32,0.2,116,70804,74.4,NULL,NULL,'ESO 235- G 033',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149024,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149024,34.66,0.51,85.6,70805,70,NULL,NULL,'ESO 235-IG 034 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,315.221833,-48.23969,0.073,NULL,51351015449,802359616,12536869,15.9),(149025,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149025,36.22,0.52,175,70806,70,NULL,NULL,'ESO 235- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000143,NULL,'13.2r',0.7,'SA(r)0+',NULL,NULL,NULL,NULL,1,315.2282917,-52.22414,0.053,NULL,51342299913,802223436,12534741,13.2),(149026,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149026,34.87,0.48,94.1,70807,70,NULL,NULL,'IC 1343',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00009,NULL,'15.10',0.7,NULL,NULL,NULL,NULL,NULL,1,315.25275,-15.40369,0.165,NULL,50988636762,796697449,12448397,15.1),(149027,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149027,35.97,0.65,156,70808,70,NULL,NULL,'2MASX J21010534-4108117',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'17.19',0.21,NULL,NULL,NULL,NULL,NULL,1,315.2722917,-41.13664,0.049,NULL,51388782528,802949727,12546089,17.19),(149028,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149028,34.4,0.5,75.8,70809,70,NULL,NULL,'NGC 7001',NULL,'2014MNRAS.445.2677S',2014,1,1.25,NULL,'G',0.000087,NULL,'13.8g',1.06,'SAB(rs)ab:',NULL,NULL,NULL,NULL,1,315.2822917,-0.19517,0.217,NULL,49660580245,775946566,12124165,13.8),(149029,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149029,36.07,0.71,163,70810,70,NULL,NULL,'2MASX J21011018-2813280',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.000087,NULL,'15.5r',0.2,NULL,NULL,NULL,NULL,NULL,1,315.292417,-28.22444,0.429,NULL,51492551389,804571115,12571423,15.5),(149030,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149030,36.33,0.58,184,70811,70,NULL,NULL,'ESO 598- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00015,NULL,'14.4r',0.7,'S0',NULL,NULL,NULL,NULL,1,315.301583333,-18.02569,0.185,NULL,50998612214,796853315,12450833,14.4),(149031,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01787','RN',149031,42.5,0.21,2080,70812,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01787',0.519749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149032,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149032,34.09,NULL,65.9,70813,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2299',NULL,'2010Ap&SS.325..163P',2010,1,1.04,'Matthews (2000A&AS..143..421M) detects another feature at v=6222 km/sec.','G',0.000137,NULL,'16.2',0.13,'Sdm',NULL,NULL,NULL,NULL,1,315.314583,-17.13361,0.213,NULL,51002402552,796912539,12451758,16.2),(149033,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149033,34.11,NULL,66.5,70813,NULL,NULL,'Dipole + Quadrupole','FGC 2299',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149034,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149034,34.12,NULL,66.8,70813,NULL,NULL,'Dipole','FGC 2299',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149035,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149035,34.17,NULL,68.3,70813,NULL,NULL,NULL,'FGC 2299',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149036,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 04968','RN',149036,40.6,0.16,1120,70814,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04968',0.182045,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149037,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 04968','RN',149037,41.06,0.21,1380,70814,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04968',0.182045,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149038,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149038,35.84,0.64,148,70815,70,NULL,NULL,'2MASX J21011852-5238569',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'15.0r',0.19,NULL,NULL,NULL,NULL,NULL,1,315.327333,-52.64914,0.069,NULL,51342121873,802220654,12534697,15),(149039,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149039,32.95,0.8,38.8,70816,75,NULL,'MAT, I','IC 5071',NULL,'1997ApJS..109..333W',1997,1,3.4,NULL,'G',0.00002,NULL,'13.26',0.8,'SAB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,315.33225,-72.64272,0.161,NULL,49325855596,770716493,12042445,13.26),(149040,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149040,32.93,0.8,38.5,70816,75,NULL,NULL,'IC 5071',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149041,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149041,32.45,0.4,30.9,70816,NULL,NULL,NULL,'IC 5071',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149042,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149042,32.45,0.4,30.9,70816,73,NULL,'opt','IC 5071',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149043,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149043,32.51,0.43,31.8,70816,75,NULL,'MAT, I, raw','IC 5071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149044,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149044,32.62,0.32,33.4,70816,85,NULL,'I, raw','IC 5071',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149045,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149045,32.66,0.32,34.1,70816,85,NULL,'I, inv','IC 5071',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149046,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149046,32.72,0.43,35,70816,75,NULL,'MAT, I, inv','IC 5071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149047,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149047,32.83,0.49,36.8,70816,75,NULL,'IR','IC 5071',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149048,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149048,32.85,0.43,37.1,70816,75,NULL,'MAT, I, cor','IC 5071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149049,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20794','RN',149049,42.9,0.2,2280,70817,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20794',0.661744,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149050,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149050,36.54,0.54,203,70818,70,NULL,NULL,'2MASX J21012236-5430448',NULL,'2014MNRAS.445.2677S',2014,1,0.51,'The APMUKS image includes a superposed star.','G',0.00015,NULL,'14.8r',0.4,NULL,NULL,NULL,NULL,NULL,1,315.3432083,-54.51247,0.117,NULL,50600139021,790627172,12353549,14.8),(149051,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149051,37.03,0.46,254,70819,70,NULL,NULL,'2MASX J21012489+1035015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,315.3537917,10.58389,0.341,NULL,55083097746,860673402,13448021,17.2),(149052,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149052,34.52,0.5,80.4,70820,70,NULL,NULL,'ESO 286- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000133,NULL,'13.5r',0.8,'S(rl)0^0','Pair member (points to parent)',NULL,NULL,NULL,1,315.382166667,-46.03753,0.037,NULL,51401555643,803149306,12549207,13.5),(149053,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007pa',NULL,149053,38.63,0.07,533,70821,70,NULL,'Hubble residual -0.33 for z0.15710','SDSS J210134.34-001610.9',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.0008,NULL,'21.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,315.393125,-0.26972,0.217,NULL,49660820308,775950317,12124223,21.6),(149054,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19940','R',149054,39.1,0.2,572,70821,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pa','SDSS J210134.34-001610.9',0.1571,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149055,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19940','R',149055,39.25,0.09,613,70821,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pa','SDSS J210134.34-001610.9',0.1571,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149056,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149056,36.04,0.55,162,70822,70,NULL,NULL,'IC 1346',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15',0.5,NULL,NULL,NULL,NULL,NULL,1,315.40425,-13.96069,0.121,NULL,50989471761,796710496,12448601,15),(149057,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149057,36.31,0.25,183,70823,74.4,NULL,NULL,'NGC 6998',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000028,NULL,'15.16',0.7,'E0;Radio galaxy','Group member, 2nd ranked galaxy',NULL,'radio jet',NULL,1,315.407,-28.03192,0.421,NULL,51493349112,804583579,12571618,15.16),(149058,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149058,36.55,0.51,204,70823,70,NULL,NULL,'NGC 6998',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149059,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149059,36.05,0.4,162,70823,NULL,NULL,'mean','NGC 6998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149060,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149060,36.3,0.45,182,70823,NULL,NULL,'K','NGC 6998',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149061,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149061,34.49,0.49,79.1,70824,70,NULL,NULL,'2MASX J21013815-4252587',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.06',0.35,'E',NULL,NULL,NULL,NULL,1,315.408917,-42.88303,0.061,NULL,51392737662,803011525,12547055,16.06),(149062,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149062,36.13,0.25,168,70825,74.4,NULL,NULL,'2MASX J21013847-2753583',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000019,NULL,'14.9r',0.37,NULL,NULL,NULL,NULL,NULL,1,315.410375,-27.89944,0.421,NULL,51493345090,804583517,12571617,14.9),(149063,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149063,35.49,0.25,125,70826,74.4,NULL,NULL,'2MASX J21013882-2818093',NULL,'2013AJ....146...86T',2013,1,0.49,NULL,'G',0.000025,NULL,'14.9r',0.43,NULL,NULL,NULL,NULL,NULL,1,315.411583,-28.30258,0.429,NULL,51492524358,804570693,12571417,14.9),(149064,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12836','RN',149064,42.72,0.22,2560,70827,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12836',0.369564,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149065,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12836','RN',149065,42.86,0.17,2730,70827,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12836',0.369564,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149066,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149066,36.27,0.48,179,70828,70,NULL,NULL,'MCG -07-43-011',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.000133,NULL,'15.76',0.52,'E',NULL,NULL,NULL,NULL,1,315.4247917,-38.49781,0.085,NULL,51527390803,805115481,12579929,15.76),(149067,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149067,36.54,0.46,203,70829,70,NULL,NULL,'2MASX J21014305+1017525',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,315.4292917,10.29792,0.261,NULL,55083177462,860674647,13448041,17),(149068,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149068,35.16,0.52,108,70830,70,NULL,NULL,'IC 1348',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.33',NULL,NULL,NULL,NULL,NULL,NULL,1,315.4337917,-13.358,0.137,NULL,50986606805,796665731,12447902,15.33),(149069,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149069,35.71,0.52,139,70831,70,NULL,NULL,'2MASX J21014443-4909008',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'14.7r',0.25,NULL,NULL,NULL,NULL,NULL,1,315.435083333,-49.15019,0.033,NULL,51351569633,802368275,12537004,14.7),(149070,'Magnitude','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149070,35.36,0.13,118,70832,100,NULL,NULL,'ABELL 3733',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II   [BM];RI [A]',NULL,NULL,NULL,NULL,1,315.452917,-28.035,0.421,NULL,51493348374,804583568,12571618,NULL),(149071,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149071,35.12,0.46,106,70833,70,NULL,NULL,'2MASX J21014980-4933238',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.0r',0.47,'(R)SA(rl)0^0',NULL,NULL,NULL,NULL,1,315.457417,-49.55664,0.049,NULL,51354389062,802412329,12537692,14),(149072,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20431',NULL,149072,40.71,0.23,1390,70834,70,NULL,'SN photometric redshift distance, z photo =0.399 +/- 0.059','SDSS-II SN 20431',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.459041667,0.48569,0.249,NULL,52076672507,813698007,12714031,NULL),(149073,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149073,34.8,0.47,91.4,70835,70,NULL,NULL,'IC 1350',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,315.467875,-13.85267,0.121,NULL,50986637531,796666211,12447909,15),(149074,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149074,35.21,0.52,110,70836,70,NULL,NULL,'2MASX J21015340-4825328',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'14.3r',0.43,'S0',NULL,NULL,NULL,NULL,1,315.472625,-48.42572,0.073,NULL,51351003865,802359435,12536866,14.3),(149075,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149075,35.03,0.25,101,70837,74.4,NULL,NULL,'2MASX J21015558-2745563',NULL,'2013AJ....146...86T',2013,1,0.58,NULL,'G',0.000017,NULL,'14.7r',0.5,'S0',NULL,NULL,NULL,NULL,1,315.4817917,-27.76539,0.369,NULL,51492852167,804575815,12571497,14.7),(149076,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149076,36.01,0.61,160,70838,70,NULL,NULL,'2MASX J21015626-4338174',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'15.2r',0.32,NULL,NULL,NULL,NULL,NULL,1,315.484333,-43.63811,0.057,NULL,51391276816,802988700,12546698,15.2),(149077,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149077,35.73,0.51,140,70839,70,NULL,NULL,'2MASX J21015941-2815363',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000019,NULL,'14.2r',0.58,'S0',NULL,NULL,NULL,NULL,1,315.497625,-28.26008,0.429,NULL,51492033374,804563021,12571297,14.2),(149078,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149078,35.77,0.25,143,70839,74.4,NULL,NULL,'2MASX J21015941-2815363',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149079,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149079,36.52,0.25,201,70840,74.4,NULL,NULL,'NGC 6999',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000036,NULL,'14.97',0.7,'SA(s)0^0^','Brightest group member',NULL,NULL,NULL,1,315.498083,-28.05892,0.421,NULL,51492489041,804570141,12571408,14.97),(149080,'Magnitude','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149080,35.36,0.13,118,70840,100,NULL,NULL,'NGC 6999',NULL,'1998A&A...337...31R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149081,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149081,36.03,0.45,160,70840,NULL,NULL,'K','NGC 6999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149082,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149082,36.03,0.4,161,70840,NULL,NULL,'mean','NGC 6999',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149083,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149083,37.67,0.46,343,70841,70,NULL,NULL,'2MASX J21015950+1037170',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,315.4979583,10.62131,0.341,NULL,55083245120,860675705,13448057,17.8),(149084,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01823',NULL,149084,39.55,0.21,813,70842,70,NULL,'SN photometric redshift distance, z photo =0.212 +/- 0.024','SDSS-II SN 01823',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','22.3g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.5085,0.36453,0.249,NULL,52076682213,813698159,12714033,22.3),(149085,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149085,34.76,0.25,89.5,70843,74.4,NULL,NULL,'2MASX J21020299-2823543',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000017,NULL,'13.9r',0.57,'S0',NULL,NULL,NULL,NULL,1,315.512583,-28.39839,0.445,NULL,51492057164,804563393,12571303,13.9),(149086,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149086,34.73,0.47,88.5,70844,70,NULL,NULL,'MCG -01-53-020',NULL,'2014MNRAS.445.2677S',2014,1,1.32,NULL,'G',0.000037,NULL,'14.2g',0.98,'SB(rs)b',NULL,NULL,NULL,NULL,1,315.514833,-6.29686,0.153,NULL,50790094297,793595223,12399925,14.2),(149087,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149087,35.57,0.25,130,70845,74.4,NULL,NULL,'2MASX J21020388-2752163',NULL,'2013AJ....146...86T',2013,1,0.93,NULL,'G',0.000022,NULL,'14.0r',0.58,'S0',NULL,NULL,NULL,NULL,1,315.5157083,-27.871,0.421,NULL,51492824613,804575384,12571490,14),(149088,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149088,36.03,0.51,161,70845,70,NULL,NULL,'2MASX J21020388-2752163',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149089,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149089,37.89,0.46,379,70846,70,NULL,NULL,'2MASX J21020794-0522093',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,315.533125,-5.36928,0.185,NULL,50746949658,792921088,12389392,17.8),(149090,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149090,35.72,0.47,140,70847,70,NULL,NULL,'2MASX J21020977-1257282',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.30',NULL,NULL,NULL,NULL,NULL,NULL,1,315.540667,-12.95803,0.145,NULL,50956675292,796198051,12440594,15.3),(149091,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149091,36.18,0.49,172,70848,70,NULL,NULL,'2MASX J21021109-5100077',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'15.0r',0.25,NULL,NULL,NULL,NULL,NULL,1,315.546291667,-51.00225,0.025,NULL,51353537495,802399023,12537484,15),(149092,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149092,36.19,0.5,173,70849,70,NULL,NULL,'2MASX J21021467-3800138',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.4r',0.57,'E',NULL,NULL,NULL,NULL,1,315.561125,-38.00383,0.093,NULL,51530905094,805170392,12580787,14.4),(149093,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149093,34.39,NULL,75.4,70850,NULL,NULL,NULL,'UGC 11666',NULL,'2000BSAO...50....5K',2000,1,1.01,NULL,'G',0.00006,NULL,'15.3',0.11,'Sdm',NULL,NULL,NULL,NULL,1,315.563417,15.136,0.381,NULL,55282353131,863786767,13496668,15.3),(149094,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149094,34.44,NULL,77.4,70850,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11666',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149095,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149095,34.45,NULL,77.8,70850,NULL,NULL,'Dipole','UGC 11666',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149096,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149096,34.45,NULL,77.8,70850,NULL,NULL,'Dipole + Quadrupole','UGC 11666',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149097,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149097,35.52,0.5,127,70851,70,NULL,NULL,'2MASX J21021648-1450232',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,315.56875,-14.83975,0.157,NULL,50988715967,796698686,12448416,13.7),(149098,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149098,35.12,0.5,106,70852,70,NULL,NULL,'2MASX J21021681-1731082',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'14.5r',0.5,NULL,NULL,NULL,NULL,NULL,1,315.5699583,-17.51892,0.229,NULL,50999061547,796860336,12450942,14.5),(149099,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14317','R',149099,39.46,0.23,659,70853,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14317',0.181,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,315.570667,0.33022,0.249,NULL,52076677501,813698085,12714032,NULL),(149100,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14317','R',149100,39.57,0.1,695,70853,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14317',0.181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149101,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149101,36.62,0.53,211,70854,70,NULL,NULL,'ESO 187- G 047',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1r',0.49,'N',NULL,NULL,NULL,NULL,1,315.5900417,-54.58864,0.125,NULL,50600105661,790626650,12353541,14.1),(149102,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149102,35.64,0.51,134,70855,70,NULL,NULL,'2MASX J21022469-1801034',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.5r',0.5,NULL,NULL,NULL,NULL,NULL,1,315.602958333,-18.01767,0.309,NULL,50997297990,796832781,12450512,14.5),(149103,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149103,35.35,0.68,118,70856,70,NULL,NULL,'ESO 286- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.1r',0.35,'(R\')SB(s)a?',NULL,NULL,NULL,NULL,1,315.604625,-43.49094,0.049,NULL,51391456422,802991506,12546742,14.1),(149104,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149104,36.64,0.33,212,70857,70,NULL,NULL,'2MASX J21022560+0016168',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000176,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,315.606667,0.27122,0.249,NULL,52076574073,813696469,12714007,16.5),(149105,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149105,36.82,0.85,231,70858,70,NULL,NULL,'2MASX J21022806-1446364',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,315.616917,-14.77686,0.157,NULL,50988843735,796700683,12448448,14.3),(149106,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149106,35.13,0.65,106,70859,70,NULL,NULL,'2MASX J21022946-1311404',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.3I',0.4,NULL,NULL,NULL,NULL,NULL,1,315.622833,-13.19461,0.145,NULL,50956996427,796203069,12440672,14.3),(149107,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149107,35.49,0.51,125,70860,70,NULL,NULL,'2MASX J21022993-1425554',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000093,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.62475,-14.43208,0.109,NULL,50989520868,796711263,12448613,14.4),(149108,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149108,31.48,0.8,19.7,70861,75,NULL,'MAT, I','IC 5078',NULL,'1997ApJS..109..333W',1997,1,7.4,NULL,'G',0.000005,NULL,'13.00',2.8,'SA(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,315.6302917,-16.81831,0.213,NULL,51002449237,796913269,12451769,13),(149109,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149109,31.55,0.8,20.4,70861,75,NULL,NULL,'IC 5078',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149110,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149110,31.19,0.4,17.3,70861,73,NULL,'IR','IC 5078',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149111,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149111,31.19,0.4,17.3,70861,75,NULL,NULL,'IC 5078',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149112,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149112,31.23,0.32,17.6,70861,85,NULL,'I, raw','IC 5078',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149113,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149113,31.24,0.32,17.7,70861,85,NULL,'I, inv','IC 5078',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149114,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149114,31.41,0.4,19.1,70861,NULL,NULL,NULL,'IC 5078',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149115,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149115,31.48,0.2,19.8,70861,74.4,NULL,NULL,'IC 5078',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149116,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149116,31.53,0.39,20.2,70861,73,NULL,'opt','IC 5078',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149117,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149117,31.55,0.43,20.4,70861,75,NULL,'3.6 micron, color corrected','IC 5078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149118,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149118,31.62,0.41,21.1,70861,NULL,NULL,'Malmquist cor.','IC 5078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149119,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149119,31.65,0.43,21.4,70861,75,NULL,'3.6 micron, color + selection bias corrected','IC 5078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149120,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149120,31.68,0.43,21.7,70861,75,NULL,'MAT, I, raw','IC 5078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149121,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149121,31.73,0.39,22.1,70861,NULL,NULL,NULL,'IC 5078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149122,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149122,31.77,0.43,22.6,70861,75,NULL,'MAT, I, inv','IC 5078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149123,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149123,31.84,0.49,23.4,70861,75,NULL,'IR','IC 5078',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149124,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149124,32.01,0.43,25.2,70861,75,NULL,'MAT, I, cor','IC 5078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149125,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07419','RN',149125,40.79,0.66,1240,70862,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07419',0.160926,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149126,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149126,35.75,0.51,141,70863,70,NULL,NULL,'6dF J2102370-353036',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.65425,-35.51006,0.449,NULL,51539217909,805300279,12582816,14.2),(149127,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149127,37.43,0.46,306,70864,70,NULL,NULL,'2MASX J21023849+0010461',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,315.6604583,0.17953,0.233,NULL,52076548136,813696064,12714001,17.4),(149128,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149128,36.73,0.46,222,70865,70,NULL,NULL,'2MASX J21023902+1049300',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,315.6625,10.825,0.321,NULL,55080158609,860627478,13447304,17.2),(149129,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149129,37.66,0.46,340,70866,70,NULL,NULL,'2MASX J21024130-0640457',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,315.6722917,-6.67947,0.241,NULL,50789966496,793593226,12399894,18.3),(149130,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149130,35.09,0.67,104,70867,70,NULL,NULL,'2MFGC 15937',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00011,NULL,'14.3r',0.4,NULL,NULL,NULL,NULL,NULL,1,315.675167,-17.27575,0.213,NULL,50998835905,796856811,12450887,14.3),(149131,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149131,33.99,0.25,62.8,70868,74.4,NULL,NULL,'ESO 235- G 039',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000017,NULL,'13.5r',0.9,'SA(rl)0^0',NULL,NULL,NULL,NULL,1,315.680833,-48.35781,0.073,NULL,51351009370,802359521,12536867,13.5),(149132,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149132,34.33,0.46,73.5,70868,70,NULL,NULL,'ESO 235- G 039',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149133,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01921',NULL,149133,41.56,0.03,2060,70869,70,NULL,'SN photometric redshift distance, z photo =0.687 +/- 0.013','SDSS-II SN 01921',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.3g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.700167,0.8425,0.293,NULL,52077073592,813704274,12714129,23.3),(149134,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149134,35.59,0.49,131,70870,70,NULL,NULL,'IC 1356',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00009,NULL,'15.9',0.3,NULL,NULL,NULL,NULL,NULL,1,315.720833,-15.81158,0.169,NULL,51000054348,796875849,12451185,15.9),(149135,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06912',NULL,149135,41.07,0.52,1640,70871,70,NULL,'SN photometric redshift distance, z photo =0.495 +/- 0.205','SDSS-II SN 06912',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.732375,-0.64258,0.237,NULL,49661529001,775961390,12124396,NULL),(149136,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03421',NULL,149136,39.96,0.25,982,70872,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.038','SDSS-II SN 03421',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.1g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,315.7359583,0.85047,0.293,NULL,52077128734,813705136,12714142,22.1),(149137,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06826','RN',149137,40.09,0.25,928,70873,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06826',0.123224,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149138,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06826','RN',149138,40.27,0.35,1010,70873,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06826',0.123224,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149139,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149139,36.19,0.48,173,70874,70,NULL,NULL,'ESO 464- G 017',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.5r',0.7,'SA(s)0-:',NULL,NULL,NULL,NULL,1,315.751083333,-30.97864,0.345,NULL,51502143669,804720994,12573765,13.5),(149140,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149140,35.45,0.25,123,70875,74.4,NULL,NULL,'ESO 464- G 018',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000019,NULL,'13.3r',1,'E0:',NULL,NULL,NULL,NULL,1,315.757041667,-28.33922,0.429,NULL,51492069073,804563579,12571305,13.3),(149141,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149141,35.89,0.45,150,70875,NULL,NULL,'K','ESO 464- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149142,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149142,35.98,0.4,157,70875,NULL,NULL,'mean','ESO 464- G 018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149143,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149143,36.59,0.51,208,70876,70,NULL,NULL,'2MASX J21030320-3756272',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00009,NULL,'14.7r',0.48,'E',NULL,NULL,NULL,NULL,1,315.763333,-37.94086,0.093,NULL,51530801623,805168775,12580762,14.7),(149144,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149144,37.79,0.46,362,70877,70,NULL,NULL,'2MASXi J2103037-070037',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000078,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,315.7657083,-7.01036,0.257,NULL,50790330577,793598915,12399983,18.4),(149145,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149145,35.13,0.25,106,70878,74.4,NULL,NULL,'ESO 286- G 029',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000022,NULL,'13.7r',0.7,'S0- pec?',NULL,NULL,NULL,NULL,1,315.767667,-47.14581,0.073,NULL,51399320182,803114377,12548662,13.7),(149146,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149146,35.49,0.47,126,70878,70,NULL,NULL,'ESO 286- G 029',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149147,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149147,34.23,0.4,70.3,70878,NULL,NULL,'mean','ESO 286- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149148,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149148,35.69,0.45,137,70878,NULL,NULL,'K','ESO 286- G 029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149149,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149149,35.11,0.46,105,70879,70,NULL,NULL,'MCG -03-53-024',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000057,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,315.7717083,-16.80128,0.217,NULL,51002443319,796913176,12451768,15.5),(149150,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149150,35.62,0.54,133,70880,70,NULL,NULL,'MCG -03-53-023',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00009,NULL,'15.5',0.1,NULL,NULL,NULL,NULL,NULL,1,315.773666667,-14.52375,0.129,NULL,50988425127,796694142,12448345,15.5),(149151,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149151,36.72,0.56,221,70881,70,NULL,NULL,'2MASX J21030740-1409115',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.78',0.4,NULL,NULL,NULL,NULL,NULL,1,315.7807917,-14.15314,0.121,NULL,50989418196,796709659,12448588,15.78),(149152,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149152,35.3,0.5,115,70882,70,NULL,NULL,'2MASX J21030802-1351395',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'15.10',0.9,NULL,NULL,NULL,NULL,NULL,1,315.783458333,-13.86097,0.125,NULL,50986539230,796664675,12447885,15.1),(149153,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007hz',NULL,149153,38.72,0.07,554,70883,70,NULL,'Hubble residual -0.01 for z0.13933','SDSS J210308.39-010152.2',NULL,'2011ApJ...740...92G',2011,1,0.28,NULL,'G',0.000166,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,315.785,-1.03117,0.245,NULL,49660984414,775952881,12124263,17.9),(149154,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17366','R',149154,39.01,0.19,556,70883,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007hz','SDSS J210308.39-010152.2',0.139332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149155,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17366','R',149155,39.35,0.09,650,70883,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007hz','SDSS J210308.39-010152.2',0.139332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149156,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149156,35.2,0.46,110,70884,70,NULL,NULL,'MCG -03-53-025',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.000083,NULL,'14.13',1,'SAB(rs)0^0^ pec',NULL,NULL,NULL,NULL,1,315.788083333,-14.52458,0.129,NULL,50988424441,796694131,12448345,14.13),(149157,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149157,37.33,0.33,292,70885,70,NULL,NULL,'2MASX J21031093-0551136',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00008,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,315.7954583,-5.85383,0.173,NULL,50744883959,792888811,12388887,17.5),(149158,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149158,36.6,0.46,209,70886,70,NULL,NULL,'2MASX J21031218-0716131',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000062,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,315.8007917,-7.2705,0.217,NULL,50790285900,793598217,12399972,17.6),(149159,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20432','R',149159,40.79,0.18,1100,70887,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qk','SDSS J210314.31+002730.6',0.303,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,NULL,'20.2g',0.07,NULL,NULL,NULL,NULL,NULL,1,315.809625,0.4585,0.265,NULL,52077522037,813711281,12714238,20.2),(149160,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20432','R',149160,40.94,0.35,1180,70887,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qk','SDSS J210314.31+002730.6',0.303,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149161,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149161,36.28,0.46,180,70888,70,NULL,NULL,'2MASX J21031948+1056385',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000096,NULL,'15.5g',0.5,'S0',NULL,NULL,NULL,NULL,1,315.831333,10.94414,0.305,NULL,55080187675,860627932,13447311,15.5),(149162,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149162,36.44,0.53,194,70889,70,NULL,NULL,'2MASX J21031998-5132509',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'14.0r',0.68,'S',NULL,NULL,NULL,NULL,1,315.833208333,-51.54744,0.033,NULL,51339842063,802185032,12534141,14),(149163,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149163,37.19,0.33,274,70890,70,NULL,NULL,'SDSS J210321.33-063337.4',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000077,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,315.838917,-6.56042,0.225,NULL,50790826723,793606667,12400104,18.8),(149164,'Brightest Stars','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149164,28.34,NULL,4.7,70891,NULL,NULL,NULL,'KKR 59',NULL,'2000A&A...362..544K',2000,1,2.3,NULL,'G',0.000013,NULL,'15.7',1.4,'Ir',NULL,NULL,NULL,NULL,1,315.8507917,57.28719,NULL,NULL,53434083629,834907556,13045430,15.7),(149165,'Brightest Stars','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149165,28.85,NULL,5.9,70891,NULL,NULL,NULL,'KKR 59',NULL,'1997AstL...23..373S',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149166,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149166,35.36,0.51,118,70892,70,NULL,NULL,'2MASX J21032422-4929569',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.3r',0.47,'(RL)SAB0^0:',NULL,NULL,NULL,NULL,1,315.851,-49.49911,0.037,NULL,51354517337,802414333,12537723,14.3),(149167,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149167,37.19,0.33,274,70893,70,NULL,NULL,'2MASX J21032470-0635168',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000111,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,315.852875,-6.58789,0.225,NULL,50790828537,793606695,12400104,16.5),(149168,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149168,33.75,0.47,56.2,70894,70,NULL,NULL,'ESO 235- G 042',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000073,NULL,'12.9r',1,'(R\')SB(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,315.862125,-48.20494,0.065,NULL,51343649405,802244521,12535070,12.9),(149169,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149169,34.81,0.55,91.8,70895,70,NULL,NULL,'6dF J2103281-351218',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.866875,-35.205,0.429,NULL,51539244705,805300698,12582823,13.8),(149170,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149170,35.36,0.55,118,70896,70,NULL,NULL,'2MASX J21032845-3000051',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'14.3r',0.6,'S0       poss. LINER',NULL,NULL,NULL,NULL,1,315.868583333,-30.00136,0.361,NULL,51503573954,804743343,12574114,14.3),(149171,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149171,32.2,0.5,27.5,70897,70,NULL,NULL,'ESO 107- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000023,NULL,'12.1r',1.3,'SA0^-',NULL,NULL,NULL,NULL,1,315.873417,-67.18133,0.057,NULL,49391980892,771749701,12058589,12.1),(149172,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149172,33.1,0.4,41.7,70897,NULL,NULL,'mean','ESO 107- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149173,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149173,33.35,0.45,46.8,70897,NULL,NULL,'K','ESO 107- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149174,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149174,37.33,0.33,292,70898,70,NULL,NULL,'2MASX J21032959-0553466',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,315.873417,-5.89631,0.233,NULL,50744880315,792888754,12388886,18.4),(149175,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149175,35.59,0.48,132,70899,70,NULL,NULL,'2MASX J21033278-1458357',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000053,NULL,'15.5',0.7,NULL,NULL,NULL,NULL,NULL,1,315.886625,-14.97669,0.157,NULL,50988865111,796701017,12448453,15.5),(149176,'Ring Diameter','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149176,32.2,0.84,27,70900,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7013',NULL,'1981ApJS...45..541P',1981,1,4,NULL,'G',0.000005,NULL,'12.40',1.4,'SA(r)0/a       LINER',NULL,NULL,NULL,NULL,1,315.889917,29.89747,1.209,NULL,55799718269,871870597,13622978,12.4),(149177,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149177,30.76,0.8,14.2,70900,75,NULL,'B','NGC 7013',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149178,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149178,35.95,0.49,155,70901,70,NULL,NULL,'2MASX J21033437-1425537',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.35',0.4,NULL,NULL,NULL,NULL,NULL,1,315.8932083,-14.43147,0.141,NULL,50988549755,796696089,12448376,15.35),(149179,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149179,36.92,0.5,242,70902,70,NULL,NULL,'2MASX J21033632-5141329',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.3r',0.63,'S0',NULL,NULL,NULL,NULL,1,315.901417,-51.69247,0.033,NULL,51339709540,802182961,12534108,14.3),(149180,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149180,37.05,0.46,257,70903,70,NULL,NULL,'2MASX J21033745+1030010',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000197,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,315.906166667,10.50033,0.269,NULL,55081985049,860656016,13447750,16.9),(149181,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149181,37.49,0.56,315,70904,70,NULL,NULL,'2MASX J21034172-5130288',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.1r',0.32,NULL,NULL,NULL,NULL,NULL,1,315.92375,-51.50806,0.033,NULL,51339843371,802185052,12534141,15.1),(149182,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149182,35.5,0.61,126,70905,70,NULL,NULL,'6dF J2103417-350359',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,315.924208333,-35.06628,0.389,NULL,51539300308,805301567,12582836,14.4),(149183,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149183,37.76,0.57,357,70906,70,NULL,NULL,'2MASX J21034238-4645014',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.94',0.35,NULL,NULL,NULL,NULL,NULL,1,315.9267083,-46.75039,0.053,NULL,51399964854,803124450,12548819,15.94),(149184,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149184,38.3,0.33,457,70907,70,NULL,NULL,'SDSS J210343.11+102909.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,315.929625,10.48583,0.269,NULL,55081990134,860656095,13447751,18),(149185,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149185,38.3,0.33,457,70908,70,NULL,NULL,'2MASX J21034457+1027190',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'18.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,315.935625,10.45531,0.269,NULL,55081991228,860656112,13447751,18),(149186,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149186,34.58,0.4,82.2,70909,75,NULL,'Edat, raw','NGC 7002',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00005,NULL,'13.46',1.2,'E1 pec?','Pair member (points to parent)',NULL,NULL,NULL,1,315.936667,-49.02975,0.037,NULL,51351635003,802369296,12537020,13.46),(149187,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149187,34.91,0.4,96,70909,75,NULL,'Edat, cor','NGC 7002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149188,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149188,34.88,0.45,94.7,70909,NULL,NULL,'K','NGC 7002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149189,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149189,35.04,0.4,102,70909,NULL,NULL,'mean','NGC 7002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149190,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149190,35.39,0.25,120,70910,74.4,NULL,NULL,'2MASX J21034575-2802078',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.000022,NULL,'15.0r',0.42,'S0',NULL,NULL,NULL,NULL,1,315.940708333,-28.03533,0.409,NULL,51491725366,804558208,12571222,15),(149191,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02002','RN',149191,39.51,0.2,760,70911,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02002',0.051571,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149192,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02002','RN',149192,40.31,0.34,1100,70911,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02002',0.051571,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149193,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149193,31.39,NULL,19,70912,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2303',NULL,'2010Ap&SS.325..163P',2010,1,0.71,NULL,'G',0.000057,NULL,'17.1',0.07,'Sd',NULL,NULL,NULL,NULL,1,315.95,-17.77306,0.293,NULL,50997076320,796829317,12450458,17.1),(149194,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149194,31.48,NULL,19.7,70912,NULL,NULL,'Dipole + Quadrupole','FGC 2303',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149195,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149195,31.56,NULL,20.5,70912,NULL,NULL,'Dipole','FGC 2303',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149196,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149196,31.61,NULL,21,70912,NULL,NULL,NULL,'FGC 2303',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149197,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149197,36.82,0.72,231,70913,70,NULL,NULL,'2MASX J21034922-1605137',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.0I',0.5,NULL,NULL,NULL,NULL,NULL,1,315.9550417,-16.08711,0.249,NULL,51000597071,796884329,12451317,14),(149198,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149198,37.22,0.46,278,70914,70,NULL,NULL,'2MASX J21035478-0536186',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000079,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,315.978375,-5.60514,0.237,NULL,50745778698,792902792,12389106,17.9),(149199,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14015',NULL,149199,40.37,0.15,1180,70915,70,NULL,'SN photometric redshift distance, z photo =0.328 +/- 0.028','SDSS-II SN 14015',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,315.985875,-1.10642,0.193,NULL,49661067764,775954183,12124284,NULL),(149200,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149200,36.64,0.33,212,70916,70,NULL,NULL,'2MASX J21035830+0027216',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.0g',0.24,'AGN',NULL,NULL,NULL,NULL,1,315.993083,0.45608,0.265,NULL,52077300898,813707826,12714184,17),(149201,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149201,36.49,0.7,199,70917,70,NULL,NULL,'2MASX J21035850-5149372',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'14.9r',0.23,NULL,NULL,NULL,NULL,NULL,1,315.99375,-51.82703,0.029,NULL,51339664897,802182264,12534097,14.9),(149202,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149202,35.05,0.49,102,70918,70,NULL,NULL,'NGC 7004',NULL,'2014MNRAS.445.2677S',2014,1,1.31,NULL,'G',0.000133,NULL,'13.8',0.44,'(R\'_2)SAB(s)a','Pair member (points to parent)',NULL,NULL,NULL,1,316.009083,-49.11425,0.021,NULL,51351634854,802369294,12537020,13.8),(149203,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149203,36.62,0.46,211,70919,70,NULL,NULL,'2MASX J21040411+0955034',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000199,NULL,'16.3g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,316.017041667,9.91761,0.249,NULL,55082525725,860664464,13447882,16.3),(149204,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149204,36.12,0.46,167,70920,70,NULL,NULL,'2MASX J21040787-0046121',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.31,'E0',NULL,NULL,NULL,NULL,1,316.0327083,-0.77014,0.205,NULL,49660911923,775951748,12124246,16.3),(149205,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149205,36.17,0.65,172,70920,70,NULL,NULL,'2MASX J21040787-0046121',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149206,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149206,37.49,0.46,315,70921,70,NULL,NULL,'2MASX J21041045+0859424',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000161,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,316.043583,8.99514,0.325,NULL,55094207969,860846999,13450734,17.2),(149207,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149207,36.71,0.83,220,70922,70,NULL,NULL,'ESO 286- G 036',NULL,'2014MNRAS.445.2677S',2014,1,1.68,NULL,'G',0.00015,NULL,'15.98',0.22,'Sb',NULL,NULL,NULL,NULL,1,316.055,-44.90181,0.049,NULL,51402910391,803170474,12549538,15.98),(149208,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149208,36.27,0.67,179,70923,70,NULL,NULL,'2MASX J21041326-6002500',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.3r',0.2,NULL,NULL,NULL,NULL,NULL,1,316.0555,-60.04725,0.161,NULL,49187205390,768550084,12008595,15.3),(149209,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149209,36.28,0.53,181,70924,70,NULL,NULL,'2MASX J21041350-1823416',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.0562083,-18.39481,0.217,NULL,50997435788,796834934,12450545,15.5),(149210,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149210,36.09,0.5,165,70925,70,NULL,NULL,'AM 2101-353',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000127,NULL,'15.12',0.4,'INTERACTING',NULL,NULL,NULL,NULL,1,316.063458333,-35.3745,0.449,NULL,51535791479,805246741,12581980,15.12),(149211,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149211,36.38,0.62,189,70926,70,NULL,NULL,'2MASX J21041751-5439499',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'14.6r',0.3,NULL,NULL,NULL,NULL,NULL,1,316.073041667,-54.66397,0.125,NULL,50600194609,790628040,12353563,14.6),(149212,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149212,36.18,0.76,172,70927,70,NULL,NULL,'2MASX J21041869-4602556',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.3r',0.31,NULL,NULL,NULL,NULL,NULL,1,316.0777917,-46.04886,0.045,NULL,51401500646,803148447,12549194,15.3),(149213,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007ko',NULL,149213,39.73,0.12,883,70928,70,NULL,'Hubble residual 0.23 for z0.20640','SDSS J210422.51-005354.4',NULL,'2011ApJ...740...92G',2011,1,0.22,NULL,'G',0.0005,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,316.093791667,-0.89847,0.205,NULL,49660951758,775952371,12124255,18.8),(149214,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17801','R',149214,40.28,0.22,942,70928,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ko','SDSS J210422.51-005354.4',0.2064,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149215,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17801','R',149215,40.37,0.17,985,70928,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ko','SDSS J210422.51-005354.4',0.2064,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149216,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149216,37.73,0.46,352,70929,70,NULL,NULL,'SDSS J210423.75-063006.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000071,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,316.099,-6.50194,0.229,NULL,50790776949,793605889,12400092,18.7),(149217,'Ring Diameter','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149217,33.4,0.84,47,70930,NULL,NULL,'Published at H = 100 km/s/Mpc','ESO 598- G 020',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.000033,NULL,'13.2r',1.1,'SB(r)c',NULL,NULL,NULL,NULL,1,316.103583,-21.78047,0.153,NULL,50951215801,796112746,12439261,13.2),(149218,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149218,34.91,0.47,96,70930,NULL,NULL,'H','ESO 598- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149219,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149219,35.1,0.46,105,70930,NULL,NULL,'J','ESO 598- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149220,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149220,35.13,0.45,106,70930,NULL,NULL,'K','ESO 598- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149221,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149221,35.23,0.72,111,70930,NULL,NULL,NULL,'ESO 598- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149222,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149222,35.27,0.2,113,70930,74.4,NULL,NULL,'ESO 598- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149223,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149223,35.29,0.4,114,70930,NULL,NULL,'mean','ESO 598- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149224,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149224,35.3,0.7,115,70930,NULL,NULL,'Malmquist cor.','ESO 598- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149225,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149225,37.66,0.46,340,70931,70,NULL,NULL,'SDSS J210424.93-073110.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000072,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,316.103917,-7.51958,0.233,NULL,50790150988,793596109,12399939,18.8),(149226,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149226,35.93,0.5,154,70932,70,NULL,NULL,'2MASX J21042540-3758206',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'14.8r',0.35,'E',NULL,NULL,NULL,NULL,1,316.105875,-37.97239,0.097,NULL,51528631041,805134860,12580232,14.8),(149227,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149227,36.8,0.46,229,70933,70,NULL,NULL,'2MASX J21042681+0906406',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,316.1117083,9.11131,0.325,NULL,55094165117,860846329,13450723,16.7),(149228,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149228,37.21,0.61,277,70934,70,NULL,NULL,'2MASX J21042708-5150351',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.59',0.33,NULL,NULL,NULL,NULL,NULL,1,316.112833,-51.84314,0.029,NULL,51340124408,802189443,12534210,16.59),(149229,'IRAS','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149229,33.96,0.8,61.9,70935,75,NULL,'HMCL, I','ESO 235- G 047',NULL,'1997ApJS..109..333W',1997,1,0.86,NULL,'G',0.000217,NULL,'13.6r',0.67,'SB(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.1134583,-48.2395,0.065,NULL,51344495154,802257736,12535277,13.6),(149230,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149230,33.52,0.4,50.6,70935,75,NULL,'HMCL, I, raw','ESO 235- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149231,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149231,33.61,0.4,52.6,70935,75,NULL,'HMCL, I, inv','ESO 235- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149232,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149232,33.86,0.4,59.1,70935,75,NULL,'HMCL, I, cor','ESO 235- G 047',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149233,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149233,34.76,0.65,89.7,70936,NULL,NULL,'Malmquist cor.','CGCG 400-022',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.0001,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,316.12075,7.98044,0.249,NULL,55093807690,860840745,13450636,15.3),(149234,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149234,34.77,0.2,90,70936,74.4,NULL,NULL,'CGCG 400-022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149235,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149235,34.9,0.61,95.6,70936,NULL,NULL,NULL,'CGCG 400-022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149236,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149236,36.26,0.53,179,70937,70,NULL,NULL,'2MFGC 15959',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,316.126833,-72.76242,0.177,NULL,49325475491,770710554,12042352,16.8),(149237,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149237,34.01,0.4,63.5,70938,75,NULL,'Edat, raw','ESO 235- G 049',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000011,NULL,'12.6r',0.9,'E:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.1709583,-48.19089,0.065,NULL,51344479505,802257492,12535273,12.6),(149238,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149238,34.28,0.4,71.9,70938,75,NULL,'Edat, cor','ESO 235- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149239,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149239,33.68,0.25,54.5,70938,74.4,NULL,NULL,'ESO 235- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149240,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149240,33.83,0.46,58.2,70938,70,NULL,NULL,'ESO 235- G 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149241,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149241,38.27,0.46,451,70939,70,NULL,NULL,'2MASX J21044257+0945576',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,316.1775417,9.76606,0.249,NULL,55082740055,860667813,13447934,18.4),(149242,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14695','R',149242,39.62,0.29,722,70940,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 14695',0.161721,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,316.190875,-0.45097,0.217,NULL,49661266345,775957286,12124332,NULL),(149243,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14695','R',149243,39.73,0.3,760,70940,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14695',0.161721,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149244,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14695',NULL,149244,40.2,0.27,1100,70940,70,NULL,'SN photometric redshift distance, z photo =0.300 +/- 0.048','SDSS-II SN 14695',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149245,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149245,35.64,0.35,134,70941,NULL,NULL,'Malmquist cor.','ESO 598- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.7r',0.4,'Sb',NULL,NULL,NULL,NULL,1,316.204667,-17.88525,0.293,NULL,50997172385,796830818,12450481,14.7),(149246,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149246,35.72,0.34,139,70941,NULL,NULL,NULL,'ESO 598- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149247,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149247,35.76,0.2,142,70941,74.4,NULL,NULL,'ESO 598- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149248,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02387','RN',149248,39.11,0.14,633,70942,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02387',0.047981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149249,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 02387','RN',149249,40.43,0.28,1160,70942,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02387',0.047981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149250,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149250,35.33,0.49,116,70943,70,NULL,NULL,'FAIRALL 0941',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000133,NULL,'14.0r',0.45,'E',NULL,NULL,NULL,NULL,1,316.221667,-48.95308,0.037,NULL,51351405042,802365703,12536964,14),(149251,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149251,37.2,0.51,275,70944,70,NULL,NULL,'2MASX J21045356-5024043',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.0r',0.2,NULL,NULL,NULL,NULL,NULL,1,316.2232917,-50.40131,0,NULL,51353809301,802403270,12537551,15),(149252,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2007of',NULL,149252,41,0.27,1590,70945,70,NULL,'Hubble residual 0.27 for z0.40470','SDSS J210456.30+000339.1',NULL,'2011ApJ...740...92G',2011,1,0.04,NULL,'G',0.0005,NULL,'22.6g',0.03,NULL,NULL,NULL,NULL,NULL,1,316.234625,0.06089,0.261,NULL,52076797360,813699958,12714061,22.6),(149253,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19033','R',149253,41.98,0.37,1770,70945,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007of','SDSS J210456.30+000339.1',0.4047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149254,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 19033','R',149254,42.06,0.37,1840,70945,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007of','SDSS J210456.30+000339.1',0.4047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149255,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149255,35.29,0.48,114,70946,70,NULL,NULL,'2MASX J21045753-1356482',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00009,NULL,'15.06',0.5,NULL,NULL,NULL,NULL,NULL,1,316.239583,-13.94678,0.137,NULL,50960270572,796254227,12441472,15.06),(149256,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 13383',NULL,149256,40.1,0.18,1050,70947,70,NULL,'SN photometric redshift distance, z photo =0.284 +/- 0.029','SDSS-II SN 13383',NULL,'2011ApJ...738..162S',2011,1,0.12,NULL,'G',NULL,'PHOT','19.7g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,316.241833,-0.28347,0.245,NULL,49661302962,775957858,12124341,19.7),(149257,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149257,37.85,0.46,372,70948,70,NULL,NULL,'SDSS J210458.98-065716.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000093,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,316.24575,-6.95472,0.241,NULL,50790233641,793597400,12399959,18.4),(149258,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149258,36.72,0.62,221,70949,70,NULL,NULL,'ESO 286- G 040',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00015,NULL,'15.1r',0.18,'S...',NULL,NULL,NULL,NULL,1,316.2682917,-43.13383,0.053,NULL,51391542145,802992846,12546763,15.1),(149259,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149259,35.94,0.47,154,70950,70,NULL,NULL,'ESO 286- G 041',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000087,NULL,'13.2r',0.9,'SA(s)0^+;cD','Brightest group member',NULL,NULL,NULL,1,316.268791667,-43.41969,0.053,NULL,51391728130,802995752,12546808,13.2),(149260,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07092','R',149260,40.18,0.23,886,70951,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07092',0.2254,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,316.280417,1.22042,0.421,NULL,52080128320,813752005,12714875,NULL),(149261,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07092','R',149261,40.5,0.15,1030,70951,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07092',0.2254,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149262,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149262,36.76,0.52,225,70952,70,NULL,NULL,'2MASX J21050808-5150082',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.80',0.33,NULL,NULL,NULL,NULL,NULL,1,316.283583,-51.83564,0.029,NULL,51340172227,802190191,12534221,15.8),(149263,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14453',NULL,149263,39.71,0.81,874,70953,70,NULL,'SN photometric redshift distance, z photo =0.230 +/- 0.127','SDSS-II SN 14453',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,316.28625,0.94936,0.369,NULL,52079962151,813749408,12714834,NULL),(149264,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149264,38.85,0.46,588,70954,70,NULL,NULL,'SDSS J210511.49+103527.7',NULL,'2015arXiv151105856S',2015,1,0.11,NULL,'G',0.000177,NULL,'19.0g',0.1,NULL,NULL,NULL,NULL,NULL,1,316.297917,10.59106,0.261,NULL,55051838014,860184968,13440390,19),(149265,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149265,35.7,0.47,138,70955,70,NULL,NULL,'LCRS B210155.3-442644',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.00009,NULL,'13.7r',0.67,'SAB(s)0/a',NULL,NULL,NULL,NULL,1,316.311,-44.24578,0.057,NULL,51403187526,803174805,12549606,13.7),(149266,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149266,35.55,0.58,129,70956,70,NULL,NULL,'2MASX J21051651-1438312',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'13.7I',0.4,NULL,NULL,NULL,NULL,NULL,1,316.318833333,-14.64208,0.133,NULL,50988500156,796695314,12448364,13.7),(149267,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07121','R',149267,40.69,0.22,1100,70957,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07121',0.2545,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,316.320583333,-0.06092,0.261,NULL,49661099369,775954677,12124291,NULL),(149268,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 07121','R',149268,40.87,0.15,1190,70957,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07121',0.2545,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149269,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149269,37.85,0.46,372,70958,70,NULL,NULL,'2MASX J21052285-0639415',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000084,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,316.345083,-6.66167,0.289,NULL,50790694373,793604599,12400071,17.6),(149270,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149270,34.87,0.49,94,70959,75,NULL,'IR','MCG -01-53-023',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.000017,NULL,'15.6g',0.26,'SB(r)a pec?',NULL,NULL,NULL,NULL,1,316.347333,-7.75164,0.217,NULL,50791505535,793617273,12400269,15.6),(149271,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149271,36.85,0.52,234,70960,70,NULL,NULL,'2MASX J21052429-5043019',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,316.351083333,-50.71711,0,NULL,51353846775,802403855,12537560,16.9),(149272,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149272,37.51,0.33,318,70961,70,NULL,NULL,'2MASX J21052461-0732475',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,316.3525,-7.54656,0.233,NULL,50792037808,793625590,12400399,17.8),(149273,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149273,36.48,0.58,198,70962,70,NULL,NULL,'2MASX J21052772-4315297',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.365458333,-43.25833,0.053,NULL,51391742838,802995981,12546812,14.9),(149274,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149274,31.54,0.65,20.3,70963,95,NULL,'Weighted Mean','NGC 7007',NULL,'1984ApJS...56...91D',1984,1,1.9,NULL,'G',0.000067,NULL,'12.94',1.1,'SA0-:',NULL,NULL,NULL,NULL,1,316.366333,-52.55197,0.041,NULL,51341970814,802218293,12534660,12.94),(149275,'Faber-Jackson','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149275,32.88,0.81,37.7,70963,55,NULL,'Visvanathan & Sandage 1979','NGC 7007',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149276,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149276,32.15,0.51,26.9,70963,70,NULL,NULL,'NGC 7007',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149277,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149277,32.86,0.8,37.3,70963,75,NULL,'B','NGC 7007',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149278,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149278,32.42,0.45,30.5,70963,NULL,NULL,'K','NGC 7007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149279,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149279,33.08,0.4,41.4,70963,NULL,NULL,'mean','NGC 7007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149280,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149280,37.83,0.33,368,70964,70,NULL,NULL,'2MASX J21052926-0735285',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000074,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,316.3719583,-7.59122,0.233,NULL,50792031541,793625492,12400398,18.6),(149281,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149281,35.59,0.48,131,70965,70,NULL,NULL,'ESO 286- G 042',NULL,'2014MNRAS.445.2677S',2014,1,0.89,'ESO-LV have V = 4944 +- 27 km/s.','G',0.00009,NULL,'13.4r',0.59,'SA0^0^:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.379083,-47.04569,0.073,NULL,51400096995,803126515,12548851,13.4),(149282,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149282,37.51,0.33,318,70966,70,NULL,NULL,'2MASX J21053120-0733265',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.0001,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,316.3799583,-7.55731,0.233,NULL,50792037558,793625586,12400399,16.9),(149283,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149283,36.67,0.78,216,70967,70,NULL,NULL,'2MASX J21053182-6059107',NULL,'2014MNRAS.445.2677S',2014,1,0.19,NULL,'G',0.00015,NULL,'15.5r',0.17,NULL,NULL,NULL,NULL,NULL,1,316.382583,-60.98625,0.109,NULL,49189084925,768579451,12009053,15.5),(149284,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149284,37.37,0.46,298,70968,70,NULL,NULL,'SDSS J210534.61+001424.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,316.3942083,0.24014,0.285,NULL,52080188980,813752952,12714889,18.3),(149285,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149285,37.83,0.33,368,70969,70,NULL,NULL,'2MASX J21053470-0735315',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000084,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,316.394583,-7.59214,0.233,NULL,50792031629,793625494,12400398,16.9),(149286,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149286,35.74,0.62,141,70970,NULL,NULL,NULL,'AGC 610198',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000023,NULL,'17.00',NULL,'Scd',NULL,NULL,NULL,NULL,1,316.4135417,-25.55094,0.245,NULL,51422787148,803481049,12554391,17),(149287,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149287,35.79,0.2,144,70970,74.4,NULL,NULL,'AGC 610198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149288,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149288,35.94,0.56,154,70970,NULL,NULL,'Malmquist cor.','AGC 610198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149289,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149289,35.8,0.33,145,70971,70,NULL,NULL,'CGCG 400-027',NULL,'2015arXiv151105856S',2015,1,0.8,NULL,'G',0.00011,NULL,'14.7g',0.68,'E0',NULL,NULL,NULL,NULL,1,316.41825,9.23433,0.333,NULL,55093334756,860833355,13450521,14.7),(149290,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149290,37.67,0.46,342,70972,70,NULL,NULL,'2MASX J21054130-0020114',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,316.421958333,-0.33653,0.237,NULL,49663998210,775999972,12124999,16.9),(149291,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149291,35.96,0.55,155,70973,70,NULL,NULL,'ESO 235- G 054',NULL,'2014MNRAS.445.2677S',2014,1,1.06,NULL,'G',0.00015,NULL,'13.4r',0.54,'(R\')SA:(r)a',NULL,NULL,NULL,NULL,1,316.4352917,-51.70992,0.029,NULL,51340157955,802189968,12534218,13.4),(149292,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149292,36.23,0.59,176,70974,70,NULL,NULL,'2MASX J21054962-6109307',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'15.3r',0.12,NULL,NULL,NULL,NULL,NULL,1,316.456917,-61.15858,0.097,NULL,49189541005,768586578,12009165,15.3),(149293,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149293,37.2,0.46,276,70975,70,NULL,NULL,'2MASX J21055481-0541293',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000098,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,316.47825,-5.69158,0.237,NULL,50745146565,792892915,12388951,16.5),(149294,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 06833',NULL,149294,40.84,0.63,1470,70976,70,NULL,'SN photometric redshift distance, z photo =0.430 +/- 0.213','SDSS-II SN 06833',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.7g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,316.481375,0.12014,0.285,NULL,52080155555,813752430,12714881,21.7),(149295,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149295,37.68,0.8,344,70977,70,NULL,NULL,'2MASX J21055715-3936537',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.1r',0.36,'E/S0','Group member',NULL,NULL,NULL,1,316.488167,-39.61497,0.057,NULL,51481923169,804405049,12568828,15.1),(149296,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149296,36.13,0.7,168,70978,70,NULL,NULL,'2MASX J21055819-1351468',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.492375,-13.86303,0.121,NULL,50960298842,796254669,12441479,15.7),(149297,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149297,36.59,0.54,208,70979,70,NULL,NULL,'2MASX J21055898-3441568',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000103,NULL,'14.9r',0.41,NULL,NULL,NULL,NULL,NULL,1,316.4957917,-34.69908,0.341,NULL,51533856716,805216511,12581507,14.9),(149298,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149298,36.06,0.25,163,70980,74.4,NULL,NULL,'2MASX J21060042-2606154',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.000017,NULL,'15.3r',0.22,NULL,NULL,NULL,NULL,NULL,1,316.5017917,-26.10433,0.301,NULL,51423010525,803484539,12554445,15.3),(149299,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149299,36.23,0.61,176,70981,70,NULL,NULL,'2MASX J21060065-6300566',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'15.0r',0.14,NULL,NULL,NULL,NULL,NULL,1,316.502667,-63.01575,0.049,NULL,49174327079,768348860,12005450,15),(149300,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149300,35.54,0.69,128,70982,70,NULL,NULL,'2MASX J21060103-1548578',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000063,NULL,'15.73',NULL,NULL,NULL,NULL,NULL,NULL,1,316.504291667,-15.81606,0.161,NULL,50999680272,796870004,12451093,15.73),(149301,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149301,37.95,0.46,388,70983,70,NULL,NULL,'2MASX J21060132-0115208',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,316.505458333,-1.25583,0.173,NULL,49664325730,776005089,12125079,17.7),(149302,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149302,36.24,0.46,177,70984,70,NULL,NULL,'2MASX J21060289-0610162',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000075,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,316.512125,-6.17133,0.257,NULL,50790513399,793601771,12400027,17),(149303,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149303,35.84,0.59,147,70985,70,NULL,NULL,'KAZ 515',NULL,'2014MNRAS.445.2677S',2014,1,0.13,NULL,'G',0.000103,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,316.512417,-12.68667,0.117,NULL,50957335622,796208369,12440755,16.14),(149304,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149304,35.82,0.25,146,70986,74.4,NULL,NULL,'2MASX J21060354-2610284',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000031,NULL,'14.7r',0.35,NULL,NULL,NULL,NULL,NULL,1,316.514708333,-26.17458,0.301,NULL,51422498988,803476546,12554321,14.7),(149305,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149305,34.1,0.46,66.1,70987,70,NULL,NULL,'ESO 286- G 046',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.13',0.7,'(R?)SABa',NULL,NULL,NULL,NULL,1,316.519333,-45.43292,0.041,NULL,51402832220,803169253,12549519,14.13),(149306,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149306,34.41,0.43,76.2,70988,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11677',NULL,'2014MNRAS.444..527S',2014,1,1.3,'HIPASS data may include other galaxies.','G',0.000024,NULL,'16.0',0.6,'I?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.5214583,15.97272,0.389,NULL,55295805530,863996961,13499952,16),(149307,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149307,36.35,0.51,187,70989,70,NULL,NULL,'2MASX J21060545-3937515',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.30',0.43,'E','Group member',NULL,NULL,NULL,1,316.52275,-39.63092,0.057,NULL,51481922895,804405045,12568828,16.3),(149308,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149308,35.98,0.56,157,70990,70,NULL,NULL,'2MASX J21060859-5444588',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'14.3r',0.69,'SAB(s)a: pec',NULL,NULL,NULL,NULL,1,316.535958333,-54.74967,0.109,NULL,48654061353,760219708,11878432,14.3),(149309,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149309,35.19,0.5,109,70991,70,NULL,NULL,'2MASX J21060892-1547538',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000087,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.53725,-15.79831,0.177,NULL,50999795836,796871809,12451122,14.1),(149310,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149310,37.69,0.33,345,70992,70,NULL,NULL,'2MASX J21061026-0051368',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,316.542917,-0.86033,0.217,NULL,49664538336,776008411,12125131,17.1),(149311,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149311,35.35,0.52,118,70993,70,NULL,NULL,'2MASX J21061269-1407498',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.552833,-14.13061,0.101,NULL,50958389827,796224841,12441013,14.2),(149312,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20130','RN',149312,38.83,0.24,555,70994,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20130',0.050593,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149313,'SNIa SDSS','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 20130','RN',149313,40.27,0.28,1080,70994,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20130',0.050593,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149314,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 16104',NULL,149314,41.57,0.02,2060,70995,70,NULL,'SN photometric redshift distance, z photo =0.691 +/- 0.009','SDSS-II SN 16104',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.1g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,316.56475,-1.06636,0.181,NULL,49664735202,776011487,12125179,20.1),(149315,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149315,36.42,0.9,192,70996,70,NULL,NULL,'2MASX J21061567-0952555',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.565375,-9.88211,0.237,NULL,50785822302,793528473,12398882,15.6),(149316,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149316,37.19,0.46,275,70997,70,NULL,NULL,'2MASX J21061690-0602045',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,316.57025,-6.03464,0.257,NULL,50745275451,792894928,12388983,17.3),(149317,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149317,37.69,0.33,345,70998,70,NULL,NULL,'2MASX J21061887-0103599',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,316.578625,-1.06669,0.181,NULL,49664736866,776011513,12125179,17.3),(149318,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149318,35.78,0.69,143,70999,70,NULL,NULL,'2MASX J21062230-1257578',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.592917,-12.96603,0.105,NULL,50957266351,796207286,12440738,15.4),(149319,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149319,35.14,0.47,107,71000,70,NULL,NULL,'FAIRALL 0945',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'14.0r',0.53,'S0',NULL,NULL,NULL,NULL,1,316.602041667,-49.04583,0.021,NULL,51343849914,802247654,12535119,14),(149320,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149320,36.33,0.68,185,71001,70,NULL,NULL,'2MASX J21062500-6241202',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.0r',0.21,NULL,NULL,NULL,NULL,NULL,1,316.604333333,-62.68903,0.085,NULL,49177711689,768401745,12006277,15),(149321,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149321,35.67,0.38,136,71002,NULL,NULL,NULL,'NGC 7019',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.00003,NULL,'15.09',0.9,'SB(s)b:        HII',NULL,NULL,NULL,NULL,1,316.6072083,-24.41267,0.241,NULL,50902742244,795355347,12427427,15.09),(149322,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149322,35.69,0.38,138,71002,NULL,NULL,'Malmquist cor.','NGC 7019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149323,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149323,35.71,0.2,139,71002,74.4,NULL,NULL,'NGC 7019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149324,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149324,33.71,0.6,55.2,71003,NULL,NULL,'V, photospheric magnitude method','ESO 235- G 058',NULL,'2014AJ....148..107R',2014,1,2.4,NULL,'G',0.000029,NULL,'14.3r',1.6,'(PR?)SB:(rs:)cd:',NULL,NULL,NULL,NULL,1,316.618333,-48.12103,0.065,NULL,51344568855,802258888,12535295,14.3),(149325,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149325,33.99,0.26,62.8,71003,NULL,NULL,'I, photospheric magnitude method','ESO 235- G 058',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149326,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149326,34.1,0.41,66.1,71003,NULL,NULL,'SCM, B','ESO 235- G 058',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149327,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149327,34.13,0.28,67,71003,NULL,NULL,'SCM, BVI','ESO 235- G 058',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149328,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149328,34.13,0.53,67,71003,NULL,NULL,'SCM, I','ESO 235- G 058',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149329,'SNII optical','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2003ho',NULL,149329,34.18,0.54,68.5,71003,NULL,NULL,'SCM, V','ESO 235- G 058',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149330,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149330,35.8,0.5,144,71004,NULL,NULL,NULL,'AGC 610212',NULL,'2009ApJS..182..474S',2009,1,0.44,NULL,'G',0.000023,NULL,'16.38',0.09,'Sc',NULL,NULL,NULL,NULL,1,316.6297083,-24.48853,0.173,NULL,50902875183,795357424,12427459,16.38),(149331,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149331,35.84,0.2,147,71004,74.4,NULL,NULL,'AGC 610212',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149332,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149332,35.95,0.46,155,71004,NULL,NULL,'Malmquist cor.','AGC 610212',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149333,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03546','R',149333,39.9,0.11,803,71005,70,NULL,'SDSS CAND. Variable; MLCS2K2; SN 2006ki','SDSS-II SN 14019 HOST',0.190057,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,316.642375,-0.64861,0.237,NULL,49664141069,776002204,12125034,NULL),(149334,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SN 2006ki',NULL,149334,39.98,0.1,993,71005,70,NULL,'Hubble residual 0.39 for z0.21640','SDSS-II SN 14019 HOST',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149335,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14019','R',149335,40.51,0.21,1040,71005,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ki','SDSS-II SN 14019 HOST',0.2164,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149336,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 14019','R',149336,40.71,0.15,1140,71005,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ki','SDSS-II SN 14019 HOST',0.2164,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149337,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 03546','R',149337,40.8,0.19,1210,71005,70,NULL,'SDSS CAND. Variable; SALT 2; SN 2006ki','SDSS-II SN 14019 HOST',0.190057,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149338,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149338,36.19,0.46,173,71006,70,NULL,NULL,'2MASX J21063573-0020236',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,316.649,-0.33994,0.265,NULL,49662935611,775983368,12124740,16.6),(149339,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149339,38.05,0.46,407,71007,70,NULL,NULL,'2MASX J21063774+1042491',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,316.657167,10.71361,0.257,NULL,55052029048,860187953,13440436,17.3),(149340,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149340,37.1,0.64,264,71008,70,NULL,NULL,'2MASX J21063849-5456251',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9r',0.33,NULL,NULL,NULL,NULL,NULL,1,316.6605417,-54.94031,0.109,NULL,48654842374,760231912,11878623,14.9),(149341,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149341,35.6,0.49,132,71009,75,NULL,'IR','FGCE 1557',NULL,'2011yCatp016004901K',2011,1,0.92,NULL,'G',0.000023,NULL,'16.89',0.11,'Sc',NULL,NULL,NULL,NULL,1,316.666916667,-25.4655,0.237,NULL,51422941752,803483464,12554429,16.89),(149342,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149342,35.69,NULL,137,71009,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1557',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149343,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149343,35.72,NULL,139,71009,NULL,NULL,'Dipole + Quadrupole','FGCE 1557',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149344,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149344,35.74,NULL,140,71009,NULL,NULL,'Dipole','FGCE 1557',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149345,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149345,35.92,0.39,152,71009,NULL,NULL,NULL,'FGCE 1557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149346,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149346,35.94,0.39,154,71009,NULL,NULL,'Malmquist cor.','FGCE 1557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149347,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149347,35.96,0.2,156,71009,74.4,NULL,NULL,'FGCE 1557',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149348,'GCLF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149348,34.06,0.25,64.9,71010,NULL,NULL,'NGC 7014','Abell 3742',NULL,'1998ApJ...499..577L',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM];I  [A]',NULL,NULL,NULL,NULL,1,316.674041667,-47.14883,0.069,NULL,51400039977,803125624,12548837,NULL),(149349,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149349,33.88,0.12,59.7,71010,NULL,NULL,'NGC 7014','Abell 3742',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149350,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149350,34.18,0.16,68.5,71010,NULL,NULL,'HST KP Calibrated, F814W','ABELL 3742',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149351,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149351,37.07,0.46,259,71011,70,NULL,NULL,'SDSS J210643.61+003348.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000138,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,316.68175,0.56342,0.337,NULL,52080258339,813754036,12714906,17.8),(149352,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149352,35.98,0.5,157,71012,70,NULL,NULL,'2MASX J21064719-4423461',NULL,'2014MNRAS.445.2677S',2014,1,1.18,NULL,'G',0.000127,NULL,'15.10',0.62,'E',NULL,NULL,NULL,NULL,1,316.696583,-44.39619,0.069,NULL,51403233462,803175522,12549617,15.1),(149353,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149353,34.04,0.25,64.3,71013,74.4,NULL,NULL,'ESO 286- G 049',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000014,NULL,'12.8r',0.7,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,316.697917,-47.18786,0.069,NULL,51400037559,803125586,12548837,12.8),(149354,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149354,34.52,0.46,80.2,71013,70,NULL,NULL,'ESO 286- G 049',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149355,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149355,34.59,0.4,82.9,71013,NULL,NULL,'mean','ESO 286- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149356,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149356,34.63,0.45,84.2,71013,NULL,NULL,'K','ESO 286- G 049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149357,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149357,35.8,0.33,145,71014,70,NULL,NULL,'2MASX J21065027+0911507',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000127,NULL,'15.4g',NULL,'E0',NULL,NULL,NULL,NULL,1,316.7095,9.19736,0.337,NULL,55093251956,860832061,13450500,15.4),(149358,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149358,35.89,0.58,150,71015,70,NULL,NULL,'2MASX J21065055-5459471',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'14.9r',0.35,NULL,NULL,NULL,NULL,NULL,1,316.7107917,-54.99642,0.109,NULL,48654820335,760231567,11878618,14.9),(149359,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149359,36.27,0.56,180,71016,70,NULL,NULL,'2MASX J21065082-6217162',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'14.8r',0.33,NULL,NULL,NULL,NULL,NULL,1,316.711667,-62.28792,0.085,NULL,49175764620,768371322,12005801,14.8),(149360,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149360,34.76,0.53,89.4,71017,70,NULL,NULL,'LCRS B210332.1-450614',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'13.9r',0.42,'S',NULL,NULL,NULL,NULL,1,316.717583,-44.90275,0.057,NULL,51402865748,803169777,12549527,13.9),(149361,'CMD','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'N',149361,19.14,0.1,0.067,71018,NULL,NULL,NULL,'Laevens 3',NULL,'2015ApJ...813...44L',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149362,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149362,37.83,0.46,369,71019,70,NULL,NULL,'2MASX J21065887+0044223',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000148,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,316.7452917,0.73956,0.337,NULL,52080239185,813753737,12714902,17.1),(149363,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149363,36.12,0.43,167,71020,NULL,NULL,NULL,'AGC 610217',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000023,NULL,'16.01',0.11,'Sbc',NULL,NULL,NULL,NULL,1,316.752083,-24.62031,0.177,NULL,50902411302,795350176,12427346,16.01),(149364,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149364,36.16,0.2,171,71020,74.4,NULL,NULL,'AGC 610217',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149365,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149365,36.16,0.42,171,71020,NULL,NULL,'Malmquist cor.','AGC 610217',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149366,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12853','R',149366,39.35,0.2,633,71021,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ey','SN 2006ey',0.1694,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,316.7655417,0.72308,0.337,NULL,52080272052,813754250,12714910,NULL),(149367,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 12853','R',149367,39.64,0.13,723,71021,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ey','SN 2006ey',0.1694,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149368,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149368,34.64,0.49,84.7,71022,70,NULL,NULL,'ESO 286- G 055',NULL,'2014MNRAS.445.2677S',2014,1,1.47,NULL,'G',0.000147,NULL,'13.9r',0.26,'Sa:',NULL,NULL,NULL,NULL,1,316.773625,-45.208,0.053,NULL,51403013244,803172081,12549563,13.9),(149369,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149369,37.45,0.46,310,71023,70,NULL,NULL,'SDSS J210707.35+100644.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00012,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,316.780667,10.11239,0.313,NULL,55052150021,860189844,13440466,18.1),(149370,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149370,36.5,0.55,200,71024,70,NULL,NULL,'2MASX J21070788-5020184',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.07',0.5,'S0',NULL,NULL,NULL,NULL,1,316.7827917,-50.33836,0,NULL,51353963439,802405678,12537588,16.07),(149371,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149371,37.21,0.58,276,71025,70,NULL,NULL,'2MASX J21070818-3708321',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.1r',0.32,NULL,NULL,NULL,NULL,NULL,1,316.7840417,-37.14225,0.177,NULL,51528951181,805139862,12580310,15.1),(149372,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149372,35.84,0.4,147,71026,NULL,NULL,'Malmquist cor.','2MASX J21071118-2515110',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'15.4r',0.3,'Sa',NULL,NULL,NULL,NULL,1,316.796583,-25.25297,0.233,NULL,51422708358,803479818,12554372,15.4),(149373,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149373,35.94,0.38,154,71026,NULL,NULL,NULL,'2MASX J21071118-2515110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149374,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149374,35.98,0.2,157,71026,74.4,NULL,NULL,'2MASX J21071118-2515110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149375,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149375,35.87,0.56,150,71027,70,NULL,NULL,'LCRS B210351.9-450214',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00009,NULL,'17.31',0.27,NULL,NULL,NULL,NULL,NULL,1,316.7992083,-44.83572,0.057,NULL,51402860146,803169689,12549526,17.31),(149376,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149376,36.04,0.11,162,71028,70,NULL,NULL,'ABELL 3744',NULL,'1999AJ....118.1489D',1999,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II-III [BM];IR:[A]',NULL,NULL,NULL,NULL,1,316.80125,-25.43806,0.237,NULL,51422931278,803483301,12554426,NULL),(149377,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149377,38.54,0.46,510,71029,70,NULL,NULL,'2MASX J21071547+0110223',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,316.8145,1.17303,0.377,NULL,52080577163,813759018,12714984,18.4),(149378,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149378,35.93,0.25,153,71030,74.4,NULL,NULL,'NGC 7016',NULL,'2013AJ....146...86T',2013,1,1.8,NULL,'G',0.000028,NULL,'14.85',1.8,'E0','Brightest group member',NULL,NULL,NULL,1,316.817833333,-25.46894,0.237,NULL,51422940676,803483448,12554428,14.85),(149379,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149379,36.04,0.11,162,71030,70,NULL,'ABELL 3744, BGC','NGC 7016',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149380,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01825','RN',149380,39.71,0.26,757,71031,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01825',0.156311,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149381,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 01825','RN',149381,40.36,0.36,1020,71031,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01825',0.156311,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149382,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149382,37.38,0.46,300,71032,70,NULL,NULL,'2MASX J21071881+0044423',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000184,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,316.82825,0.74508,0.385,NULL,52080220989,813753452,12714897,17.3),(149383,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149383,35.59,0.49,131,71033,75,NULL,'IR','2MFGC 16001',NULL,'2011yCatp016004901K',2011,1,0.5,NULL,'G',0.000023,NULL,'15.0r',0.13,'Sc',NULL,NULL,NULL,NULL,1,316.837083,-25.63056,0.245,NULL,51422915254,803483050,12554422,15),(149384,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149384,35.81,0.35,146,71033,NULL,NULL,'Malmquist cor.','2MFGC 16001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149385,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149385,35.84,0.34,147,71033,NULL,NULL,NULL,'2MFGC 16001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149386,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149386,35.88,0.2,150,71033,74.4,NULL,NULL,'2MFGC 16001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149387,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149387,36.95,0.25,245,71034,74.4,NULL,NULL,'2MASX J21072205-2527210',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000039,NULL,'15.2r',0.3,'S0',NULL,NULL,NULL,NULL,1,316.841875,-25.45575,0.237,NULL,51422929639,803483275,12554426,15.2),(149388,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149388,35.8,0.53,145,71035,NULL,NULL,NULL,'2MASX J21072347-2534169',NULL,'2009ApJS..182..474S',2009,1,0.32,NULL,'G',0.000023,NULL,'16.3r',0.14,'Sc',NULL,NULL,NULL,NULL,1,316.84775,-25.57142,0.245,NULL,51422909668,803482963,12554421,16.3),(149389,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149389,35.84,0.2,147,71035,74.4,NULL,NULL,'2MASX J21072347-2534169',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149390,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149390,36.03,0.48,161,71035,NULL,NULL,'Malmquist cor.','2MASX J21072347-2534169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149391,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149391,38.44,0.46,487,71036,70,NULL,NULL,'2MASX J21072517+1041359',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,316.855041667,10.69328,0.257,NULL,55051970574,860187040,13440422,18.2),(149392,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149392,36.72,0.57,221,71037,70,NULL,NULL,'2MASX J21072666-3941115',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'14.9r',0.47,'(R\'_2?)SB(s)a:','Group member',NULL,NULL,NULL,1,316.861083,-39.68656,0.045,NULL,51481712752,804401761,12568777,14.9),(149393,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 15080',NULL,149393,39.93,0.67,969,71038,70,NULL,'SN photometric redshift distance, z photo =0.259 +/- 0.117','SDSS-II SN 15080',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,316.879625,-1.03872,0.217,NULL,49664661714,776010339,12125161,NULL),(149394,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149394,35.32,0.25,116,71039,74.4,NULL,NULL,'GALEXASC J210732.33-253834.8',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000014,NULL,'14.7R',NULL,'E',NULL,NULL,NULL,NULL,1,316.8847917,-25.64308,0.245,NULL,51422918362,803483099,12554423,14.7),(149395,'Tully est','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149395,31.13,0.8,16.8,71040,75,NULL,NULL,'ESO 187- G 051',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'14.85',1.2,'SB(s)m',NULL,NULL,NULL,NULL,1,316.887917,-54.95056,0.109,NULL,48654825848,760231653,11878619,14.85),(149396,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149396,35.93,0.56,154,71041,70,NULL,NULL,'VV 764 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16',0.3,'Sa',NULL,NULL,NULL,NULL,1,316.903,-25.41806,0.237,NULL,51422712224,803479878,12554373,16),(149397,'SNIa','2016-12-15 15:15:53','2016-12-16 11:21:08','1','SDSS-II SN 17370',NULL,149397,40.08,0.34,1040,71042,70,NULL,'SN photometric redshift distance, z photo =0.281 +/- 0.057','SDSS-II SN 17370',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,316.903916667,0.19142,0.349,NULL,52078137360,813720896,12714389,21.4),(149398,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149398,36.32,0.51,184,71043,NULL,NULL,'Malmquist cor.','2MASX J21073898-2439240',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000027,NULL,'15.4r',0.3,'Sb',NULL,NULL,NULL,NULL,1,316.912416667,-24.65661,0.177,NULL,50905899397,795404678,12428198,15.4),(149399,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149399,36.76,0.41,225,71043,NULL,NULL,NULL,'2MASX J21073898-2439240',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149400,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149400,36.8,0.2,229,71043,74.4,NULL,NULL,'2MASX J21073898-2439240',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149401,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149401,36.77,0.46,226,71044,70,NULL,NULL,'2MASX J21073959-0113418',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,316.915083,-1.22819,0.181,NULL,49663871918,775997998,12124968,16.3),(149402,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149402,37.12,0.46,266,71045,70,NULL,NULL,'2MASX J21074333-0038338',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,316.930583,-0.64267,0.281,NULL,49662998857,775984357,12124755,16.8),(149403,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,'R',149403,37.5,0.46,317,71046,70,NULL,NULL,'2MASX J21074395+0945191',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000158,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,316.933167,9.75531,0.325,NULL,55051451822,860178934,13440295,17.5),(149404,'FP','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149404,35.07,0.48,103,71047,70,NULL,NULL,'AM 2103-583 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000133,NULL,'15.49',0.53,'E',NULL,NULL,NULL,NULL,1,316.943917,-58.30372,0.141,NULL,49134711184,767729862,11995779,15.49),(149405,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149405,34.23,0.4,70,71048,NULL,NULL,'mean','NGC 7025',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'13.71',1.3,'Sa','Isolated galaxy',NULL,NULL,NULL,1,316.94725,16.33586,0.341,NULL,55287402812,863865668,13497901,13.71),(149406,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149406,34.37,0.47,74.9,71048,NULL,NULL,'H','NGC 7025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149407,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149407,34.39,0.46,75.6,71048,NULL,NULL,'J','NGC 7025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149408,'Tully-Fisher','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149408,34.41,0.45,76.1,71048,NULL,NULL,'K','NGC 7025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149409,'GCLF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149409,34.06,0.25,64.9,71049,NULL,NULL,NULL,'NGC 7014',NULL,'1998ApJ...499..577L',1998,1,1.9,NULL,'G',0.000017,NULL,'13.38',1.5,'E','Isolated elliptical galaxy',NULL,NULL,NULL,1,316.967375,-47.179,0.069,NULL,51399526060,803117594,12548712,13.38),(149410,'GCLF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149410,34.09,0.19,65.8,71049,NULL,NULL,NULL,'NGC 7014',NULL,'2002ApJ...567..294O',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149411,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149411,33.84,0.15,58.6,71049,NULL,NULL,'I','NGC 7014',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149412,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149412,33.88,0.12,59.7,71049,NULL,NULL,'I','NGC 7014',NULL,'1998ApJ...499..577L',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149413,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149413,34,0.15,63.1,71049,NULL,NULL,NULL,'NGC 7014',NULL,'2001ApJ...550..503J',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149414,'SBF','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149414,34.18,0.16,68.5,71049,NULL,NULL,'HST KP Calibrated, F814W','NGC 7014',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149415,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149415,34.01,0.4,63.5,71049,75,NULL,'Edat, raw','NGC 7014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149416,'D-Sigma','2016-12-15 15:15:53','2016-12-16 11:21:08','1',NULL,NULL,149416,34.28,0.4,71.9,71049,75,NULL,'Edat, cor','NGC 7014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149417,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149417,33.58,0.37,52,71049,95,NULL,'Weighted Mean','NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149418,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149418,33.9,0.46,60.3,71049,95,NULL,'Michard 1979a','NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149419,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149419,34.06,0.63,64.9,71049,95,NULL,'Michard 1979b, c','NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149420,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149420,35.69,0.81,137,71049,55,NULL,'Visvanathan & Sandage 1979','NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149421,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149421,34.34,0.25,73.8,71049,74.4,NULL,NULL,'NGC 7014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149422,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149422,34.79,0.46,90.9,71049,70,NULL,NULL,'NGC 7014',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149423,'Tertiary','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149423,33.39,0.5,47.6,71049,95,NULL,NULL,'NGC 7014',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149424,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149424,34.08,0.4,65.3,71049,NULL,NULL,'mean','NGC 7014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149425,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149425,34.63,0.45,84.5,71049,NULL,NULL,'K','NGC 7014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149426,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149426,36.34,0.55,185,71050,70,NULL,NULL,'6dF J2107545-344617',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,316.976875,-34.77139,0.341,NULL,51534069124,805219830,12581559,14.4),(149427,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149427,35.87,0.73,149,71051,70,NULL,NULL,'2MASX J21075449-4315415',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.000022,NULL,'14.5r',0.53,'E',NULL,NULL,NULL,NULL,1,316.977083,-43.26161,0.053,NULL,51391667908,802994811,12546793,14.5),(149428,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149428,35.47,0.65,124,71052,70,NULL,NULL,'2MASX J21075491-0243304',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,'HII?',NULL,NULL,NULL,NULL,1,316.978833333,-2.72508,0.181,NULL,49661654328,775963348,12124427,14.1),(149429,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149429,36.71,0.83,220,71053,70,NULL,NULL,'LCRS B210446.5-394057',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.88',0.37,'Ep','Group member',NULL,NULL,NULL,1,316.99375,-39.48114,0.057,NULL,51481683038,804401297,12568770,15.88),(149430,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149430,35.51,0.57,126,71054,70,NULL,NULL,'2MASX J21080312-5517354',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'14.3r',0.42,'S0',NULL,NULL,NULL,NULL,1,317.013125,-55.29308,0.105,NULL,48654753030,760230516,11878601,14.3),(149431,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149431,33.94,0.46,61.3,71055,70,NULL,NULL,'ESO 402-IG 010',NULL,'2014MNRAS.445.2677S',2014,1,2,NULL,'G',0.00005,NULL,'13.98',0.9,'SB0? pec',NULL,NULL,NULL,NULL,1,317.031375,-33.24278,0.389,NULL,51532947031,805202297,12581285,13.98),(149432,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149432,37.36,0.46,297,71056,70,NULL,NULL,'2MASX J21080800+1121222',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,317.033333,11.35619,0.305,NULL,55054192722,860221761,13440965,17.5),(149433,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149433,37.3,0.46,289,71057,70,NULL,NULL,'2MASX J21080963-0015025',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,317.040166667,-0.25083,0.321,NULL,49663089448,775985772,12124777,17),(149434,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149434,37.23,0.46,279,71058,70,NULL,NULL,'2MASX J21081243-0014235',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,317.0519583,-0.24003,0.321,NULL,49663088923,775985764,12124777,17.1),(149435,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149435,34.36,0.45,74.6,71059,NULL,NULL,NULL,'ESO 286- G 058',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.0r',0.7,'SA(s)c',NULL,NULL,NULL,NULL,1,317.0744583,-43.91522,0.061,NULL,51390866469,802982288,12546598,14),(149436,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149436,34.38,0.56,75.2,71059,NULL,NULL,'B, Hubble-type-TF','ESO 286- G 058',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149437,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149437,34.41,0.44,76.2,71059,NULL,NULL,'Malmquist cor.','ESO 286- G 058',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149438,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149438,34.41,0.2,76.2,71059,74.4,NULL,NULL,'ESO 286- G 058',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149439,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149439,36.57,0.53,206,71060,70,NULL,NULL,'2MASX J21081934-3623208',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00015,NULL,'13.7r',0.68,'E',NULL,NULL,NULL,NULL,1,317.0805,-36.38906,0.373,NULL,51535641158,805244393,12581943,13.7),(149440,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149440,36.71,0.55,219,71061,70,NULL,NULL,'2MASX J21082264-1533443',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.77',NULL,NULL,NULL,NULL,NULL,NULL,1,317.094333,-15.56236,0.225,NULL,50988066024,796688531,12448258,15.77),(149441,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 14311','RN',149441,41.11,0.28,1250,71062,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14311',0.336024,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149442,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 14311','RN',149442,41.24,0.24,1330,71062,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14311',0.336024,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149443,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 14311','N',149443,41,0.18,1580,71062,70,NULL,'SALT 2','SDSS-II SN 14311',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149444,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 14311','N',149444,41.04,0.18,1610,71062,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14311',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149445,'SNII optical','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SN 2004du',NULL,149445,33.94,0.13,59.4,71063,NULL,NULL,'SEAM','UGC 11683',0.016762,'2009ApJ...694.1067P',2009,1,1.1,NULL,'G',0.000067,NULL,'15.18',0.3,'Scd:','Pair member (points to parent)',NULL,NULL,NULL,1,317.111375,18.19119,0.441,NULL,55288905902,863889154,13498268,15.18),(149446,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149446,34.16,0.49,68,71063,75,NULL,'IR','UGC 11683',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149447,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149447,34.3,0.2,72.4,71063,74.4,NULL,NULL,'UGC 11683',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149448,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149448,34.4,0.33,75.8,71063,NULL,NULL,'Malmquist cor.','UGC 11683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149449,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149449,34.44,0.32,77.2,71063,NULL,NULL,NULL,'UGC 11683',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149450,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149450,35.97,0.59,157,71064,70,NULL,NULL,'AM 2105-273 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.92',0.43,NULL,NULL,NULL,NULL,NULL,1,317.113333,-27.28889,0.313,NULL,51423935334,803498989,12554671,15.92),(149451,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149451,38.1,0.46,416,71065,70,NULL,NULL,'2MASX J21082739+0953142',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000179,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,317.114167,9.88728,0.313,NULL,55051492236,860179566,13440305,17.7),(149452,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 01826','RN',149452,42.68,0.26,2390,71066,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01826',0.435618,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149453,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 01826','RN',149453,42.73,0.31,2450,71066,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01826',0.435618,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149454,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149454,35.09,0.4,104,71067,75,NULL,'Edat, raw','ESO 286- G 059',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000028,NULL,'13.2r',0.7,'S0^-','Brightest group member',NULL,NULL,NULL,1,317.1630417,-43.48614,0.045,NULL,51390918231,802983097,12546610,13.2),(149455,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149455,35.42,0.4,121,71067,75,NULL,'Edat, cor','ESO 286- G 059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149456,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149456,35.67,0.4,136,71067,NULL,NULL,'mean','ESO 286- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149457,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149457,35.76,0.45,142,71067,NULL,NULL,'K','ESO 286- G 059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149458,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149458,36.65,0.66,214,71068,70,NULL,NULL,'2MASX J21084291-1447154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,317.178625,-14.78753,0.197,NULL,50957815564,796215868,12440872,16.14),(149459,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149459,32.6,0.49,33.2,71069,75,NULL,'IR','IC 1359',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'14.77',0.3,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,317.17925,12.48428,0.341,NULL,55276220697,863690948,13495171,14.77),(149460,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149460,36.76,0.75,225,71070,70,NULL,NULL,'AM 2103-724',NULL,'2014MNRAS.445.2677S',2014,1,0.1,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,317.1812917,-72.58831,0.169,NULL,49325327084,770708235,12042316,15.1),(149461,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149461,34.67,0.58,86,71071,NULL,NULL,NULL,'ESO 530- G 004',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.5r',0.7,'S...',NULL,NULL,NULL,NULL,1,317.186125,-22.90958,0.133,NULL,50905136855,795392763,12428011,15.5),(149462,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149462,34.71,0.2,87.5,71071,74.4,NULL,NULL,'ESO 530- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149463,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149463,35.28,0.43,114,71071,NULL,NULL,'Malmquist cor.','ESO 530- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149464,'CMD','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'N',149464,19.2,NULL,0.069,71072,NULL,NULL,'DES J2108.8_5109','Indus I',NULL,'2015ApJ...807...50B',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149465,'CMD','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'N',149465,20,NULL,0.1,71072,NULL,NULL,NULL,'Indus I',NULL,'2015ApJ...805..130K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149466,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149466,38.03,0.46,404,71073,70,NULL,NULL,'2MASX J21084867-0108399',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,317.20275,-1.14444,0.181,NULL,49663803581,775996930,12124952,17.8),(149467,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149467,37.42,0.46,305,71074,70,NULL,NULL,'2MASX J21085023-0713437',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000098,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,317.2092083,-7.22872,0.269,NULL,50793014960,793640858,12400638,17.3),(149468,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149468,37.54,0.46,321,71075,70,NULL,NULL,'2MASX J21085166+0104256',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000186,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,317.215333,1.07372,0.361,NULL,52077890316,813717036,12714328,17.9),(149469,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06914','RN',149469,41.91,0.29,1710,71076,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06914',0.414257,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149470,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06914','RN',149470,42.24,0.29,1980,71076,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06914',0.414257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149471,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06914','N',149471,41.86,0.18,2360,71076,70,NULL,'SALT 2','SDSS-II SN 06914',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149472,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06914','N',149472,41.93,0.18,2430,71076,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06914',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149473,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 18598','RN',149473,40.05,0.24,850,71077,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18598',0.203086,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149474,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 18598','RN',149474,41.23,0.29,1470,71077,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18598',0.203086,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149475,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06648','N',149475,41.55,0.26,2040,71078,70,NULL,'SALT 2','SDSS-II SN 06648',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149476,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:08','1','SDSS-II SN 06648','N',149476,41.63,0.26,2120,71078,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06648',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149477,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149477,35.9,0.51,151,71079,70,NULL,NULL,'2MASX J21090270-0217189',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00012,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,317.26125,-2.28861,0.169,NULL,49662528444,775977006,12124640,14.1),(149478,'FP','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149478,38.08,0.46,413,71080,70,NULL,NULL,'SDSS J210903.49+002927.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000187,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,317.264583,0.49097,0.357,NULL,52078571632,813727681,12714495,18.8),(149479,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,'R',149479,34.4,0.49,76,71081,75,NULL,'IR','ESO 530- G 007',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.00003,NULL,'15.2r',0.2,'Sb:',NULL,NULL,NULL,NULL,1,317.279416667,-25.5565,0.241,NULL,51425637552,803525586,12555087,15.2),(149480,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149480,34.52,0.61,80.3,71081,NULL,NULL,NULL,'ESO 530- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149481,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149481,34.56,0.2,81.7,71081,74.4,NULL,NULL,'ESO 530- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149482,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:08','1',NULL,NULL,149482,34.84,0.53,92.9,71081,NULL,NULL,'Malmquist cor.','ESO 530- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149483,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149483,37.09,0.46,262,71082,70,NULL,NULL,'2MASX J21090766-0537179',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000087,NULL,'18.1g',0.15,'NLAGN',NULL,NULL,NULL,'Sy 2',1,317.281875,-5.62156,0.245,NULL,50746332850,792911450,12389241,18.1),(149484,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149484,35.73,0.49,140,71083,70,NULL,NULL,'2MASX J21090976-7910357',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,317.29075,-79.17661,0.557,NULL,48586207237,759159488,11861867,15.6),(149485,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149485,36.82,0.46,231,71084,70,NULL,NULL,'2MASX J21091440-0744186',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.1g',0.35,'S0',NULL,NULL,NULL,NULL,1,317.3102083,-7.73856,0.245,NULL,50791267498,793613554,12400211,16.1),(149486,'Sosies','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149486,33.77,0.39,56.8,71085,NULL,NULL,NULL,'IC 5084',NULL,'2002A&A...393...57T',2002,1,1.6,NULL,'G',0.000032,NULL,'12.60',1,'SB(s)b? pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,317.311958333,-63.29003,0.041,NULL,49166358296,768224348,12003505,12.6),(149487,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149487,32.79,0.47,36.2,71085,NULL,NULL,'H','IC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149488,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149488,32.82,0.45,36.6,71085,NULL,NULL,'K','IC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149489,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149489,32.88,0.46,37.7,71085,NULL,NULL,'J','IC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149490,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149490,33.14,0.4,42.5,71085,NULL,NULL,'mean','IC 5084',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149491,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149491,35.76,0.47,142,71086,NULL,NULL,NULL,'AGC 610251',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000023,NULL,'16.63',0.1,'Scd',NULL,NULL,NULL,NULL,1,317.317833333,-25.56097,0.241,NULL,51425637878,803525591,12555087,16.63),(149492,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149492,35.8,0.2,145,71086,74.4,NULL,NULL,'AGC 610251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149493,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149493,35.88,0.45,150,71086,NULL,NULL,'Malmquist cor.','AGC 610251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149494,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17408','RN',149494,40.44,0.26,989,71087,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17408',0.240267,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149495,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17408','RN',149495,40.6,0.21,1060,71087,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17408',0.240267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149496,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149496,36.82,0.46,231,71088,70,NULL,NULL,'2MASX J21091762+0016187',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000206,NULL,'17.0g',0.23,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,317.3235417,0.27197,0.389,NULL,52077705305,813714145,12714283,17),(149497,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149497,36.06,0.75,163,71089,70,NULL,NULL,'2MASX J21091834-2100463',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.9I',0.3,NULL,NULL,NULL,NULL,NULL,1,317.3265,-21.01286,0.125,NULL,50942961719,795983776,12437246,14.9),(149498,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149498,35.82,0.55,146,71090,70,NULL,NULL,'2MASX J21091936-1405001',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.76',0.3,NULL,NULL,NULL,NULL,NULL,1,317.3305417,-14.08339,0.197,NULL,50957982197,796218471,12440913,15.76),(149499,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149499,37.99,0.46,397,71091,70,NULL,NULL,'SDSS J210920.88-053110.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000094,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,317.3370417,-5.51969,0.329,NULL,50746213101,792909579,12389212,18.7),(149500,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149500,35.72,0.49,139,71092,70,NULL,NULL,'ESO 530- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.1r',0.4,'S0',NULL,NULL,NULL,NULL,1,317.342666667,-23.2495,0.201,NULL,50905006923,795390733,12427980,14.1),(149501,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149501,35.9,0.57,151,71093,70,NULL,NULL,'2MASX J21092601-1613091',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.7I',0.3,NULL,NULL,NULL,NULL,NULL,1,317.358333,-16.21917,0.217,NULL,50995597832,796806216,12450097,14.7),(149502,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149502,38.69,0.46,546,71094,70,NULL,NULL,'2MASX J21092764+1013225',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000171,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,317.365125,10.22294,0.293,NULL,55052227555,860191055,13440485,18.1),(149503,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149503,36.27,0.52,180,71095,70,NULL,NULL,'AM 2105-530 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00011,NULL,'15.80',0.65,'S0',NULL,NULL,NULL,NULL,1,317.36725,-52.93331,0.069,NULL,50603530441,790680163,12354377,15.8),(149504,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149504,37.8,0.46,364,71096,70,NULL,NULL,'2MASX J21093006+0911274',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,317.3754583,9.19092,0.433,NULL,55056542740,860258480,13441538,18.1),(149505,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149505,36.43,0.54,193,71097,70,NULL,NULL,'2MASX J21093224-6453210',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.6b',0.29,NULL,NULL,NULL,NULL,NULL,1,317.384375,-64.88914,0.029,NULL,49346494859,771038982,12047484,16.6),(149506,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149506,44.74,0.98,2770,71098,69.7,NULL,'Fiducial','GRB 050922C',2.2,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,'14.7R',NULL,'Swift',NULL,NULL,NULL,NULL,1,317.3875,-8.75836,0.253,NULL,50791168046,793612000,12400187,14.7),(149507,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149507,45.92,0.57,4770,71098,70,NULL,NULL,'GRB 050922C',2.2,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149508,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149508,46.83,1.61,7250,71098,100,NULL,NULL,'GRB 050922C',2.2,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149509,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149509,46.97,1.55,7740,71098,69.7,NULL,'Fiducial','GRB 050922C',2.2,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149510,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149510,31.53,0.47,20.2,71099,NULL,NULL,'H','UGC 11689',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000023,NULL,'14.4',1,'SB(r)b',NULL,NULL,NULL,NULL,1,317.4037917,66.16994,2.401,NULL,53672331551,838630180,13103596,14.4),(149511,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149511,31.6,0.45,20.9,71099,NULL,NULL,'K','UGC 11689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149512,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149512,31.71,0.46,21.9,71099,NULL,NULL,'J','UGC 11689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149513,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149513,32.65,0.4,33.9,71099,NULL,NULL,'mean','UGC 11689',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149514,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149514,35.41,0.65,121,71100,70,NULL,NULL,'MCG -01-54-002',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'Marginal HIPASS detection.','G',0.00003,NULL,'16.5',0.6,NULL,NULL,NULL,NULL,NULL,1,317.4075,-3.51175,0.225,NULL,50743887558,792873243,12388644,16.5),(149515,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149515,37.86,0.46,374,71101,70,NULL,NULL,'2MASX J21093914+0014442',NULL,'2015arXiv151105856S',2015,1,0.02,NULL,'G',0.000176,NULL,'17.3g',0.02,NULL,NULL,NULL,NULL,NULL,1,317.412917,0.24522,0.389,NULL,52077730106,813714532,12714289,17.3),(149516,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149516,36,0.63,158,71102,70,NULL,NULL,'2MASX J21093934-1402581',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.14',NULL,NULL,NULL,NULL,NULL,NULL,1,317.41375,-14.04939,0.177,NULL,50957987984,796218562,12440915,16.14),(149517,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149517,37.65,0.46,339,71103,70,NULL,NULL,'SDSS J210951.70+002353.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,317.465417,0.39819,0.397,NULL,52077623449,813712866,12714263,18.3),(149518,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149518,35.86,0.55,148,71104,70,NULL,NULL,'2MASX J21095357-1608540',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.93',0.4,NULL,NULL,NULL,NULL,NULL,1,317.473166667,-16.1485,0.229,NULL,50995551832,796805497,12450085,15.93),(149519,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149519,36.62,0.51,211,71105,70,NULL,NULL,'2MASX J21095588-7014077',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,317.482875,-70.23556,0.161,NULL,49341043422,770953803,12046153,16),(149520,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12778','R',149520,38.53,0.21,463,71106,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2006fs','SN 2006fs',0.099304,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,317.495833,0.40878,0.397,NULL,52077615810,813712747,12714261,NULL),(149521,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12778','R',149521,38.56,0.13,469,71106,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2006fs','SN 2006fs',0.099304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149522,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149522,31.3,0.43,18.2,71107,75,NULL,'3.6 micron, color + selection bias corrected','ESO 342-IG 013',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.000027,NULL,'13.75',0.6,'Pec            HII',NULL,NULL,NULL,NULL,1,317.5019583,-37.50378,0.113,NULL,51483942726,804436605,12569321,13.75),(149523,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149523,31.38,0.43,18.9,71107,75,NULL,'3.6 micron, color corrected','ESO 342-IG 013',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149524,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149524,31.53,0.2,20.2,71107,74.4,NULL,NULL,'ESO 342-IG 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149525,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149525,31.73,0.49,22.2,71107,75,NULL,'IR','ESO 342-IG 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149526,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149526,32.89,0.4,37.9,71107,NULL,NULL,'mean','ESO 342-IG 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149527,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149527,33.03,0.47,40.4,71107,NULL,NULL,'H','ESO 342-IG 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149528,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149528,33.12,0.46,42.1,71107,NULL,NULL,'J','ESO 342-IG 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149529,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149529,35.35,0.47,117,71108,70,NULL,NULL,'2MASX J21100087-1404410',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000067,NULL,'15.68',0.5,NULL,NULL,NULL,NULL,NULL,1,317.5035,-14.07792,0.177,NULL,50958041053,796219391,12440927,15.68),(149530,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149530,36.26,0.46,178,71109,70,NULL,NULL,'2MASX J21100106+0952057',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000175,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,317.5044583,9.86822,0.361,NULL,55051416120,860178376,13440287,16.7),(149531,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149531,32.33,0.8,29.3,71110,75,NULL,'MAT, I','MCG -01-54-003',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000017,NULL,'14.5',1.1,'SB(rs)bc:',NULL,NULL,NULL,NULL,1,317.5212083,-3.70172,0.209,NULL,50743929227,792873894,12388654,14.5),(149532,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149532,32.59,0.32,32.9,71110,85,NULL,'I, inv','MCG -01-54-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149533,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149533,32.59,0.32,33,71110,85,NULL,'I, raw','MCG -01-54-003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149534,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149534,32.61,0.43,33.3,71110,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-54-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149535,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149535,32.62,0.43,33.4,71110,75,NULL,'3.6 micron, color corrected','MCG -01-54-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149536,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149536,32.68,0.2,34.4,71110,74.4,NULL,NULL,'MCG -01-54-003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149537,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149537,32.94,0.43,38.7,71110,75,NULL,'MAT, I, raw','MCG -01-54-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149538,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149538,32.98,0.43,39.5,71110,75,NULL,'MAT, I, inv','MCG -01-54-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149539,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149539,33.03,0.46,40.4,71110,NULL,NULL,NULL,'MCG -01-54-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149540,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149540,33.36,0.43,47,71110,75,NULL,'MAT, I, cor','MCG -01-54-003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149541,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149541,33.37,0.39,47.2,71110,NULL,NULL,'Malmquist cor.','MCG -01-54-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149542,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149542,37.28,0.46,286,71111,70,NULL,NULL,'2MASX J21100809-0609168',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,317.5337083,-6.15464,0.253,NULL,50789128845,793580138,12399689,17.5),(149543,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149543,35.89,0.46,151,71112,70,NULL,NULL,'2MASX J21100815-0046227',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000163,NULL,'16.5g',0.28,'E0',NULL,NULL,NULL,NULL,1,317.534,-0.773,0.297,NULL,49663252986,775988327,12124817,16.5),(149544,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149544,36.5,0.94,200,71112,70,NULL,NULL,'2MASX J21100815-0046227',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149545,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149545,34.16,0.62,68,71113,NULL,NULL,NULL,'ESO 464- G 026',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'13.7r',0.4,'(R\')SB(s)ab:   HII',NULL,NULL,NULL,NULL,1,317.5799583,-29.52742,0.325,NULL,51498961001,804671265,12572988,13.7),(149546,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149546,34.2,0.2,69.2,71113,74.4,NULL,NULL,'ESO 464- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149547,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149547,34.24,0.6,70.4,71113,NULL,NULL,'Malmquist cor.','ESO 464- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149548,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149548,34.24,0.47,70.5,71113,NULL,NULL,'H','ESO 464- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149549,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149549,34.37,0.4,74.7,71113,NULL,NULL,'mean','ESO 464- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149550,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149550,34.38,0.45,75.3,71113,NULL,NULL,'K','ESO 464- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149551,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149551,34.43,0.46,76.8,71113,NULL,NULL,'J','ESO 464- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149552,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149552,35.49,0.74,125,71114,70,NULL,NULL,'2MASX J21101995-0230504',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.36',0.5,NULL,NULL,NULL,NULL,NULL,1,317.583083,-2.51414,0.169,NULL,49676113246,776189269,12127957,16.36),(149553,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15466','R',149553,40.19,0.21,875,71115,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hj','SDSS J211021.14+005557.5',0.245675,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,317.588083,0.93264,0.345,NULL,52077978200,813718409,12714350,NULL),(149554,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13727','R',149554,40.29,0.19,928,71115,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hj','SDSS J211021.14+005557.5',0.23,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149555,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15466','R',149555,40.4,0.16,965,71115,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hj','SDSS J211021.14+005557.5',0.245675,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149556,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13727','R',149556,40.39,0.12,973,71115,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hj','SDSS J211021.14+005557.5',0.23,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149557,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006hj',NULL,149557,40.24,0.09,1120,71115,70,NULL,'SALT 2','SDSS J211021.14+005557.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149558,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006hj',NULL,149558,40.26,0.09,1130,71115,70,NULL,'SALT 2, Malmquist cor.','SDSS J211021.14+005557.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149559,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149559,37.19,0.46,274,71116,70,NULL,NULL,'SDSS J211024.41+004526.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,317.6017083,0.75731,0.361,NULL,52078448153,813725752,12714464,17.9),(149560,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149560,37.77,0.46,359,71117,70,NULL,NULL,'2MASX J21102718+1127387',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000142,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,317.613375,11.46083,0.293,NULL,55054317066,860223704,13440995,17.9),(149561,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149561,36.89,0.63,239,71118,70,NULL,NULL,'2MASX J21102722-2915126',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,317.613416667,-29.25342,0.337,NULL,51498768662,804668260,12572941,14.4),(149562,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149562,35.91,0.56,152,71119,70,NULL,NULL,'2MASX J21102885-2312480',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'14.9r',0.37,'S0',NULL,NULL,NULL,NULL,1,317.62025,-23.21336,0.201,NULL,50904776716,795387136,12427924,14.9),(149563,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149563,36.31,0.63,183,71120,70,NULL,NULL,'2MASX J21102901-0856597',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.92',0.4,NULL,NULL,NULL,NULL,NULL,1,317.620917,-8.94992,0.301,NULL,50773317061,793333079,12395829,16.92),(149564,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149564,36.94,0.46,245,71121,70,NULL,NULL,'2MASX J21103185+0053427',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00019,NULL,'16.4g',0.32,'E0',NULL,NULL,NULL,NULL,1,317.6327083,0.89506,0.345,NULL,52091758162,813933721,12717714,16.4),(149565,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006mz',NULL,149565,39.45,0.12,776,71122,70,NULL,'Hubble residual -0.39 for z0.24610','SDSS-II SN 15466 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,317.6454583,-0.12272,0.361,NULL,49662719437,775979991,12124687,NULL),(149566,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006mz',NULL,149566,40.19,0.11,1090,71122,70,NULL,'SALT 2','SDSS-II SN 15466 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149567,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006mz',NULL,149567,40.21,0.11,1100,71122,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15466 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149568,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03044','R',149568,42.15,0.22,1860,71122,70,NULL,'SDSS CAND. AGN; MLCS2K2; SN 2006mz','SDSS-II SN 15466 HOST',0.444114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149569,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03044','R',149569,42.55,0.21,2240,71122,70,NULL,'SDSS CAND. AGN; SALT 2; SN 2006mz','SDSS-II SN 15466 HOST',0.444114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149570,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01827','RN',149570,42.23,0.25,2070,71123,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01827',0.353205,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149571,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01827','RN',149571,42.27,0.26,2100,71123,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01827',0.353205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149572,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149572,35.61,0.6,133,71124,70,NULL,NULL,'ESO 530- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.4r',0.2,'S...',NULL,NULL,NULL,NULL,1,317.698417,-23.37525,0.161,NULL,50904870607,795388603,12427946,14.4),(149573,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149573,35.52,0.49,127,71125,75,NULL,'IR','2MFGC 16044',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'11.9K',NULL,NULL,NULL,NULL,NULL,NULL,1,317.7032917,4.34522,0.337,NULL,55036083631,859938806,13436543,11.9),(149574,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02464',NULL,149574,39.79,0.37,907,71126,70,NULL,'SN photometric redshift distance, z photo =0.240 +/- 0.052','SDSS-II SN 02464',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,317.712083,0.10289,0.389,NULL,52077532204,813711440,12714241,NULL),(149575,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02464',NULL,149575,40.48,0.21,1250,71126,70,NULL,'SALT 2','SDSS-II SN 02464',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149576,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02464',NULL,149576,40.51,0.21,1260,71126,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02464',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149577,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149577,35.87,0.54,149,71127,70,NULL,NULL,'ESO 187- G 056',NULL,'2014MNRAS.445.2677S',2014,1,1.09,NULL,'G',0.000113,NULL,'14.2r',0.27,'Sa:',NULL,NULL,NULL,NULL,1,317.713208333,-53.42125,0.117,NULL,50603588901,790681076,12354391,14.2),(149578,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15647',NULL,149578,40.67,0.24,1360,71128,70,NULL,'SN photometric redshift distance, z photo =0.389 +/- 0.058','SDSS-II SN 15647',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.4g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,317.7150417,0.64975,0.389,NULL,52091296945,813926514,12717601,21.4),(149579,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149579,37.92,0.33,384,71129,70,NULL,NULL,'2MASX J21105273+0935451',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00014,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,317.719667,9.59589,0.361,NULL,55058850625,860294541,13442102,18.2),(149580,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149580,36.31,0.62,183,71130,70,NULL,NULL,'2MASX J21105420-0346348',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000017,NULL,'16.37',0.5,NULL,NULL,NULL,NULL,NULL,1,317.725875,-3.77636,0.177,NULL,49667770683,776058916,12125920,16.37),(149581,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149581,35.62,0.53,133,71131,70,NULL,NULL,'IC 5089',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.99',NULL,NULL,NULL,NULL,NULL,NULL,1,317.7272083,-3.86278,0.177,NULL,50744328948,792880139,12388752,15.99),(149582,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149582,36.62,0.86,211,71132,70,NULL,NULL,'2MASX J21105640-0205478',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'16.61',0.4,NULL,NULL,NULL,NULL,NULL,1,317.735125,-2.09678,0.161,NULL,49675915358,776186177,12127909,16.61),(149583,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149583,35.19,0.54,109,71133,70,NULL,NULL,'ESO 286- G 070',NULL,'2014MNRAS.445.2677S',2014,1,1.39,NULL,'G',0.000087,NULL,'13.6r',0.33,'Sa?',NULL,NULL,NULL,NULL,1,317.738458333,-43.711,0.053,NULL,51390771056,802980797,12546574,13.6),(149584,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149584,35.77,0.45,143,71134,NULL,NULL,'Malmquist cor.','ESO 107- G 011',NULL,'2009ApJS..182..474S',2009,1,0.95,NULL,'G',0.000033,NULL,'14.6r',0.47,'Sc',NULL,NULL,NULL,NULL,1,317.760791667,-65.52728,0.009,NULL,49377920907,771530014,12055156,14.6),(149585,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149585,35.95,0.42,155,71134,NULL,NULL,NULL,'ESO 107- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149586,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149586,35.99,0.2,158,71134,74.4,NULL,NULL,'ESO 107- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149587,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03102',NULL,149587,40.62,0.97,1330,71135,70,NULL,'SN photometric redshift distance, z photo =0.379 +/- 0.321','SDSS-II SN 03102',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,317.7620417,-0.80117,0.297,NULL,49675122406,776173787,12127715,21.4),(149588,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149588,37.03,0.93,255,71136,70,NULL,NULL,'2MASX J21110413-2257486',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,317.767291667,-22.96342,0.145,NULL,50905031012,795391109,12427986,15.7),(149589,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149589,37.78,0.46,359,71137,70,NULL,NULL,'2MASXi J2111047-064431',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000085,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,317.76975,-6.74203,0.213,NULL,50789162171,793580658,12399697,18.1),(149590,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149590,33.41,0.49,48.1,71138,75,NULL,'IR','ESO 464- G 027',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.000033,NULL,'15.94',0.2,'Sb',NULL,NULL,NULL,NULL,1,317.77075,-29.99803,0.333,NULL,51499591736,804681120,12573142,15.94),(149591,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149591,34.6,0.4,83,71138,NULL,NULL,'mean','ESO 464- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149592,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149592,34.71,0.47,87.3,71138,NULL,NULL,'H','ESO 464- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149593,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149593,36.27,0.87,180,71139,70,NULL,NULL,'2MASX J21110743-2043576',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.4r',0.3,NULL,NULL,NULL,NULL,NULL,1,317.781083,-20.73272,0.133,NULL,50942391062,795974860,12437107,15.4),(149594,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149594,37.32,0.72,291,71140,70,NULL,NULL,'2MASX J21110786-2314104',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.3r',0.41,NULL,NULL,NULL,NULL,NULL,1,317.7827917,-23.23625,0.161,NULL,50904901509,795389086,12427954,15.3),(149595,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149595,34.88,0.59,94.5,71141,70,NULL,NULL,'2MASX J21111025-2206344',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14.0r',0.39,NULL,NULL,NULL,NULL,NULL,1,317.792625,-22.10981,0.161,NULL,50915751502,795558617,12430603,14),(149596,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149596,35.29,0.5,115,71142,70,NULL,NULL,'2MASX J21111253-8050481',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000147,NULL,'14.9b',NULL,'S0 pec',NULL,NULL,NULL,NULL,1,317.801375,-80.84681,0.537,NULL,48573932887,758967701,11858870,14.9),(149597,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12839','RN',149597,44.11,0.33,4650,71143,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12839',0.425394,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149598,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12839','RN',149598,44.95,0.49,6840,71143,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12839',0.425394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149599,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149599,35.5,0.47,126,71144,70,NULL,NULL,'2MASX J21111476-4830160',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000133,NULL,'13.4r',0.5,'E',NULL,NULL,NULL,NULL,1,317.811625,-48.50447,0.057,NULL,51346483647,802288806,12535762,13.4),(149600,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149600,35.7,0.57,138,71145,70,NULL,NULL,'2MASX J21111750-5049410',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00012,NULL,'14.6r',0.45,'S',NULL,NULL,NULL,NULL,1,317.822917,-50.82808,0.005,NULL,51353202454,802393788,12537402,14.6),(149601,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149601,36.44,0.46,194,71146,70,NULL,NULL,'2MASX J21111749+1028569',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00017,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,317.822917,10.48258,0.317,NULL,55051776040,860184000,13440375,16.7),(149602,'Ring Diameter','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149602,31.6,0.84,21,71147,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7020',NULL,'1981ApJS...45..541P',1981,1,3.7,NULL,'G',0.000087,NULL,'12.78',1.8,'(R)SA(r)0^+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,317.8337083,-64.02533,0.033,NULL,49346630441,771041100,12047517,12.78),(149603,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149603,32.89,0.8,37.8,71147,75,NULL,'B','NGC 7020',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149604,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149604,37.92,0.33,384,71148,70,NULL,NULL,'2MASX J21112023+0934099',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,317.834167,9.56956,0.361,NULL,55058832394,860294256,13442097,17.3),(149605,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149605,38.55,0.12,449,71149,74.2,NULL,'SALT 2','SDSS J211120.87-002643.5',0.143,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,317.8369583,-0.44542,0.241,NULL,49674436606,776163071,12127547,NULL),(149606,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149606,39.13,0.05,587,71149,70,NULL,'SDSS-II SN 01794','SDSS J211120.87-002643.5',0.143,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149607,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01794','R',149607,39.32,0.19,641,71149,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fj','SDSS J211120.87-002643.5',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149608,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149608,39.35,0.14,649,71149,70,NULL,'SDSS-II SN 01794, SALT 2','SDSS J211120.87-002643.5',0.143,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149609,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01794','R',149609,39.53,0.1,708,71149,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fj','SDSS J211120.87-002643.5',0.14,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149610,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149610,39.3,0.08,724,71149,70,NULL,'SALT 2','SDSS J211120.87-002643.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149611,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fj',NULL,149611,39.31,0.08,728,71149,70,NULL,'SALT 2, Malmquist cor.','SDSS J211120.87-002643.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149612,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149612,37.54,0.46,322,71150,70,NULL,NULL,'2MASX J21112115+0021276',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000185,NULL,'17.5g',0.24,'AGN',NULL,NULL,NULL,NULL,1,317.8382083,0.35778,0.397,NULL,52091200861,813925013,12717578,17.5),(149613,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07949','RN',149613,39.64,0.29,791,71151,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07949',0.069905,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149614,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07949','RN',149614,40.24,6.19,1050,71151,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07949',0.069905,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149615,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13593',NULL,149615,40.95,0.15,1550,71152,70,NULL,'SN photometric redshift distance, z photo =0.461 +/- 0.046','SDSS-II SN 13593',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.6g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,317.846083,0.21239,0.397,NULL,52091213726,813925214,12717581,22.6),(149616,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149616,34.68,0.47,86.3,71153,NULL,NULL,'H','IC 5090',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000017,NULL,'14.39',0.5,'Sa pec?        HII','Group member',NULL,NULL,NULL,1,317.877,-2.03256,0.153,NULL,49676393554,776193649,12128025,14.39),(149617,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149617,34.81,0.45,91.4,71153,NULL,NULL,'K','IC 5090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149618,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149618,34.9,0.46,95.6,71153,NULL,NULL,'J','IC 5090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149619,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149619,35.4,0.4,120,71153,NULL,NULL,'mean','IC 5090',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149620,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149620,35.69,0.66,137,71154,70,NULL,NULL,'2MASX J21113239-4238519',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'14.9r',0.42,NULL,NULL,NULL,NULL,NULL,1,317.8850417,-42.64783,0.057,NULL,51361334311,802520848,12539388,14.9),(149621,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791',NULL,149621,39.45,0.73,776,71155,70,NULL,'SN photometric redshift distance, z photo =0.201 +/- 0.095','SDSS-II SN 20791',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,317.947833333,-0.386,0.241,NULL,49674408508,776162632,12127541,NULL),(149622,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791','R',149622,41.25,0.26,1330,71155,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20791',0.335856,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149623,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791','R',149623,41.47,0.22,1470,71155,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20791',0.335856,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149624,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791',NULL,149624,41.14,0.16,1690,71155,70,NULL,'SALT 2','SDSS-II SN 20791',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149625,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20791',NULL,149625,41.18,0.16,1720,71155,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20791',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149626,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149626,41.68,0.31,2170,71156,70,NULL,'z = 0.75 +/- 0.15','GRB 101023A',NULL,'2013A&A...551A.133P',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,317.963875,-65.38811,0.021,NULL,49347588604,771056071,12047751,NULL),(149627,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149627,41.92,0.11,2420,71156,NULL,NULL,'0.24 mag syst.','GRB 101023A',NULL,'2012A&A...538A..58P',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149628,'GRB','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149628,41.92,NULL,2420,71156,70,NULL,'Photo z = 0.9','GRB 101023A',NULL,'2013A&A...552L...5P',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149629,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149629,32.92,0.49,38.4,71157,NULL,NULL,'I','NGC 7029',NULL,'2001ApJ...546..681T',2001,1,2.6,'The APM position is southwest of the nucleus.','G',0.000033,NULL,'12.35',1.4,'E','in a pair',NULL,NULL,NULL,1,317.966875,-49.28372,0,NULL,51345740183,802277190,12535581,12.35),(149630,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149630,32.92,0.49,38.4,71157,NULL,NULL,NULL,'NGC 7029',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149631,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149631,32.96,0.14,39.1,71157,74.4,NULL,NULL,'NGC 7029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149632,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149632,33.25,0.49,44.7,71157,NULL,NULL,'Malmquist cor.','NGC 7029',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149633,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149633,32.52,0.4,32,71157,75,NULL,'Edat, raw','NGC 7029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149634,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149634,32.7,0.4,34.7,71157,75,NULL,'Edat, cor','NGC 7029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149635,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149635,30.56,0.65,12.9,71157,95,NULL,'Weighted Mean','NGC 7029',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149636,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149636,31.67,0.81,21.6,71157,55,NULL,'Visvanathan & Sandage 1979','NGC 7029',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149637,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149637,32.42,0.41,30.5,71157,NULL,NULL,NULL,'NGC 7029',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149638,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149638,32.69,0.41,34.5,71157,NULL,NULL,'Malmquist cor.','NGC 7029',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149639,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149639,33,0.5,39.8,71157,70,NULL,NULL,'NGC 7029',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149640,'Tertiary','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149640,31.55,0.71,20.4,71157,95,NULL,NULL,'NGC 7029',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149641,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149641,32.8,0.8,36.3,71157,75,NULL,'B','NGC 7029',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149642,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149642,32.61,0.45,33.2,71157,NULL,NULL,'K','NGC 7029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149643,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149643,32.8,0.4,36.2,71157,NULL,NULL,'mean','NGC 7029',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149644,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149644,33.06,0.8,40.9,71158,75,NULL,'MAT, I','ESO 107- G 014',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.000033,NULL,'15.22',0.46,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,317.978667,-64.22828,0.037,NULL,49346594015,771040531,12047508,15.22),(149645,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149645,33.49,0.32,49.9,71158,85,NULL,'I, inv','ESO 107- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149646,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149646,33.53,0.32,50.7,71158,85,NULL,'I, raw','ESO 107- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149647,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149647,33.57,0.43,51.7,71158,75,NULL,'MAT, I, inv','ESO 107- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149648,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149648,33.66,0.43,54,71158,75,NULL,'MAT, I, raw','ESO 107- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149649,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149649,33.76,0.43,56.5,71158,75,NULL,'MAT, I, cor','ESO 107- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149650,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149650,33.95,0.35,61.5,71159,NULL,NULL,NULL,'UGC 11696',NULL,'2009ApJS..182..474S',2009,1,1.06,NULL,'G',0.000017,NULL,'16.8g',0.2,'Sdm:',NULL,NULL,NULL,NULL,1,317.979416667,11.37936,0.281,NULL,55053051685,860203932,13440686,16.8),(149651,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149651,33.99,0.2,62.8,71159,74.4,NULL,NULL,'UGC 11696',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149652,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149652,34.07,0.49,65.3,71159,75,NULL,'IR','UGC 11696',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149653,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149653,34.18,0.31,68.7,71159,NULL,NULL,'Malmquist cor.','UGC 11696',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149654,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149654,35.2,0.47,110,71160,70,NULL,NULL,'ESO 235- G 074',NULL,'2014MNRAS.445.2677S',2014,1,1.02,'1984MNRAS.210...69F has V = 11400: +- 200 km/s.','G',0.00015,NULL,'14.1r',0.27,'S0?',NULL,NULL,NULL,NULL,1,317.990417,-48.45006,0.065,NULL,51346513358,802289271,12535769,14.1),(149655,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149655,35.96,0.5,155,71161,70,NULL,NULL,'2MASX J21115772-2309358',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'14.4r',0.43,'E',NULL,NULL,NULL,NULL,1,317.990541667,-23.16,0.145,NULL,50904804368,795387568,12427930,14.4),(149656,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149656,33.56,0.69,51.5,71162,100,NULL,'mid-IR','CGCG 426-015',NULL,'2013ApJ...771...88L',2013,1,0.87,NULL,'G',0.000033,NULL,'14.9g',0.57,'Sa','Group member',NULL,NULL,NULL,1,318.005417,11.49564,0.281,NULL,55053049560,860203899,13440685,14.9),(149657,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149657,34.68,0.59,86.2,71162,NULL,NULL,'Malmquist cor.','CGCG 426-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149658,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149658,34.77,0.57,89.9,71162,NULL,NULL,NULL,'CGCG 426-015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149659,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149659,34.81,0.2,91.6,71162,74.4,NULL,NULL,'CGCG 426-015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149660,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149660,34.23,0.44,70.2,71163,NULL,NULL,NULL,'UGC 11696 NOTES01',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000226,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,318.026375,11.34528,0.281,NULL,55053021216,860203456,13440679,16.9),(149661,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149661,34.24,0.2,70.5,71163,74.4,NULL,NULL,'UGC 11696 NOTES01',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149662,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149662,34.33,0.43,73.3,71163,NULL,NULL,'Malmquist cor.','UGC 11696 NOTES01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149663,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149663,36.46,0.61,195,71164,70,NULL,NULL,'2MASX J21120799-2324447',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,318.033458333,-23.41247,0.161,NULL,50904911935,795389248,12427957,14.8),(149664,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149664,34.36,0.4,74.6,71165,NULL,NULL,'mean','UGC 11697',NULL,'2007A&A...465...71T',2007,1,1,'Springob et al. (2005ApJS..160..149S) give v= 9030 km/sec.','G',0.000033,NULL,'15.04',0.6,'SBbc           Sbrst',NULL,NULL,NULL,NULL,1,318.042208333,11.65942,0.281,NULL,55053186733,860206042,13440719,15.04),(149665,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149665,34.51,0.47,80,71165,NULL,NULL,'H','UGC 11697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149666,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149666,35.84,0.4,147,71166,NULL,NULL,'mean','UGC 11695',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.91',0.8,'SA(r)b pec:    HII',NULL,NULL,NULL,NULL,1,318.043833333,-1.47525,0.189,NULL,49674529116,776164517,12127570,14.91),(149667,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149667,35.98,0.47,157,71166,NULL,NULL,'H','UGC 11695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149668,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149668,36.01,0.45,159,71166,NULL,NULL,'K','UGC 11695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149669,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149669,36.15,0.46,170,71166,NULL,NULL,'J','UGC 11695',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149670,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149670,33.02,0.8,40.2,71167,75,NULL,'MAT, I','ESO 187- G 058',NULL,'1997ApJS..109..333W',1997,1,2,'Allen, et al. (1991, MNRAS, 248, 528) give z=0.065 +/- 0.001.','G',0.000021,NULL,'13.6r',0.29,'SBc? sp',NULL,NULL,NULL,NULL,1,318.0435417,-57.278,0.153,NULL,49137535556,767773993,11996468,13.6),(149671,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149671,33.14,0.49,42.5,71167,75,NULL,'IR','ESO 187- G 058',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149672,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149672,33.19,NULL,43.5,71167,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 187- G 058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149673,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149673,33.21,NULL,43.8,71167,NULL,NULL,'Dipole','ESO 187- G 058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149674,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149674,33.23,NULL,44.2,71167,NULL,NULL,'Dipole + Quadrupole','ESO 187- G 058',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149675,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149675,33.23,0.32,44.3,71167,85,NULL,'I, raw','ESO 187- G 058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149676,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149676,33.25,0.32,44.7,71167,85,NULL,'I, inv','ESO 187- G 058',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149677,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149677,33.26,0.43,45,71167,75,NULL,'MAT, I, raw','ESO 187- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149678,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149678,33.38,NULL,47.4,71167,NULL,NULL,NULL,'ESO 187- G 058',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149679,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149679,33.38,0.43,47.4,71167,75,NULL,'MAT, I, inv','ESO 187- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149680,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149680,33.46,0.43,49.3,71167,75,NULL,'MAT, I, cor','ESO 187- G 058',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149681,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149681,34.57,NULL,81.9,71168,NULL,NULL,NULL,'ESO 342- G 017',NULL,'2000BSAO...50....5K',2000,1,1.55,NULL,'G',0.000033,NULL,'16.43',0.13,'Sd',NULL,NULL,NULL,NULL,1,318.045417,-37.62744,0.113,NULL,51483888851,804435763,12569308,16.43),(149682,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149682,34.57,NULL,81.9,71168,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 342- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149683,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149683,34.58,NULL,82.4,71168,NULL,NULL,'Dipole + Quadrupole','ESO 342- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149684,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149684,34.59,NULL,82.8,71168,NULL,NULL,'Dipole','ESO 342- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149685,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149685,35,0.68,100,71168,NULL,NULL,NULL,'ESO 342- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149686,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149686,35.04,0.2,102,71168,74.4,NULL,NULL,'ESO 342- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149687,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149687,35.18,0.63,108,71168,NULL,NULL,'Malmquist cor.','ESO 342- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149688,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149688,36.07,0.61,163,71169,70,NULL,NULL,'2MASX J21121221-4617444',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'15.0r',0.28,NULL,NULL,NULL,NULL,NULL,1,318.050875,-46.29567,0.077,NULL,51401135261,803142738,12549105,15),(149689,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20131','RN',149689,38.97,0.48,528,71170,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20131',0.178591,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149690,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20131','RN',149690,40.44,0.73,1040,71170,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20131',0.178591,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149691,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2011gf',NULL,149691,35.16,0.01,108,71171,72,NULL,'M(H) = -18.317 mag','SDSS J211222.69-074913.9',NULL,'2014ApJ...784..105W',2013,1,0.41,NULL,'G',0.000056,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,318.0945417,-7.82056,0.305,NULL,50791241265,793613144,12400205,17.4),(149692,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03246','RN',149692,41.53,0.27,1520,71172,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03246',0.337703,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149693,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03246','RN',149693,42.09,0.26,1960,71172,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03246',0.337703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149694,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149694,36.7,0.63,219,71173,70,NULL,NULL,'2MASX J21122838-0517077',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.91',0.4,NULL,NULL,NULL,NULL,NULL,1,318.118167,-5.28536,0.377,NULL,50743049554,792860149,12388439,16.91),(149695,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149695,35.92,0.79,153,71174,70,NULL,NULL,'2MASX J21123049-4320565',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'15.1r',0.18,NULL,NULL,NULL,NULL,NULL,1,318.127041667,-43.349,0.069,NULL,51360542843,802508481,12539195,15.1),(149696,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20104','R',149696,40.69,0.2,1170,71175,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J211233.27+001653.9',0.178292,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.9g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,318.138625,0.28167,0.397,NULL,52082989588,813796712,12715573,21.9),(149697,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20104','R',149697,40.83,0.29,1240,71175,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J211233.27+001653.9',0.178292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149698,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20104',NULL,149698,40.61,0.16,1320,71175,70,NULL,'SALT 2','SDSS J211233.27+001653.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149699,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20104',NULL,149699,40.62,0.16,1330,71175,70,NULL,'SALT 2, Malmquist cor.','SDSS J211233.27+001653.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149700,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149700,36.88,0.69,238,71176,70,NULL,NULL,'2MASX J21123470-8152003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.14425,-81.86681,0.445,NULL,48561892745,758779574,11855930,17.4),(149701,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13747','RN',149701,42.22,0.19,1900,71177,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13747',0.462691,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149702,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149702,38,0.79,398,71178,70,NULL,NULL,'ESO 530- G 023',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.39',1,'SB(r)ab',NULL,NULL,NULL,NULL,1,318.178916667,-23.14589,0.145,NULL,50916117849,795564341,12430692,15.39),(149703,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149703,35.33,0.54,116,71179,NULL,NULL,'Malmquist cor.','ESO 402- G 015',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.64',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,318.1832917,-36.85889,0.185,NULL,51485324402,804458193,12569659,14.64),(149704,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149704,35.38,0.53,119,71179,NULL,NULL,NULL,'ESO 402- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149705,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149705,35.42,0.2,121,71179,74.4,NULL,NULL,'ESO 402- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149706,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149706,35.29,0.72,114,71180,70,NULL,NULL,'2MASX J21124674-1949009',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'14.8r',0.28,NULL,NULL,NULL,NULL,NULL,1,318.194833,-19.81708,0.133,NULL,50940499916,795945311,12436645,14.8),(149707,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14024','R',149707,39.11,0.21,578,71181,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ht','SN 2006ht',0.146,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,318.198583,0.91633,0.377,NULL,52092127771,813939496,12717804,NULL),(149708,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14024','R',149708,39.27,0.1,624,71181,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ht','SN 2006ht',0.146,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149709,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149709,36.77,0.54,226,71182,70,NULL,NULL,'LCRS B210929.5-444949',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'14.2r',0.42,'E',NULL,NULL,NULL,NULL,1,318.199333,-44.62406,0.081,NULL,51398254038,803097719,12548401,14.2),(149710,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006ht',NULL,149710,38.89,0.08,600,71183,70,NULL,'SALT 2','2MASX J21124822+0055050',NULL,'2013ApJ...763...88C',2013,1,0.1,NULL,'G',NULL,NULL,'19.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,318.200791667,0.91783,0.377,NULL,52092138785,813939668,12717807,19.3),(149711,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006ht',NULL,149711,38.9,0.08,603,71183,70,NULL,'SALT 2, Malmquist cor.','2MASX J21124822+0055050',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149712,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356',NULL,149712,37.05,1.23,257,71184,70,NULL,'SN photometric redshift distance, z photo =0.062 +/- 0.050','SDSS-II SN 16356',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,318.200958333,-0.56758,0.241,NULL,49674346661,776161666,12127526,21.1),(149713,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356','R',149713,41.84,0.29,1670,71184,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16356',0.399335,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149714,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356','R',149714,42.04,0.27,1820,71184,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16356',0.399335,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149715,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356',NULL,149715,41.71,0.18,2200,71184,70,NULL,'SALT 2','SDSS-II SN 16356',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149716,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16356',NULL,149716,41.78,0.18,2270,71184,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16356',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149717,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149717,36.55,0.46,204,71185,70,NULL,NULL,'2MASX J21125250-0745379',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000093,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,318.218666667,-7.76064,0.305,NULL,50773623965,793337874,12395904,16.1),(149718,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06502','RN',149718,40.5,0.11,1130,71186,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06502',0.114669,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149719,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06502','RN',149719,40.66,0.22,1210,71186,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06502',0.114669,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149720,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149720,35.48,0.54,125,71187,70,NULL,NULL,'ESO 187- G 059',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000137,NULL,'14.83',0.8,'S0',NULL,NULL,NULL,NULL,1,318.2509583,-55.04661,0.101,NULL,48657581989,760274718,11879292,14.83),(149721,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03430','RN',149721,39.61,0.14,761,71188,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03430',0.097627,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149722,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03430','RN',149722,40.14,0.3,972,71188,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03430',0.097627,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149723,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149723,34.87,0.55,94.1,71189,70,NULL,NULL,'2MASX J21131201-0008368',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.9g',0.18,'S0/a',NULL,NULL,NULL,NULL,1,318.2999583,-0.14353,0.289,NULL,49670148368,776096068,12126501,15.9),(149724,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149724,35.56,0.48,129,71190,NULL,NULL,'Malmquist cor.','ESO 144- G 019',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.91',0.5,'SA(s)c: pec',NULL,NULL,NULL,NULL,1,318.3005,-58.42983,0.145,NULL,49135420302,767740942,11995952,14.91),(149725,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149725,35.62,0.47,133,71190,NULL,NULL,NULL,'ESO 144- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149726,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149726,35.66,0.2,136,71190,74.4,NULL,NULL,'ESO 144- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149727,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149727,35.9,0.4,151,71190,NULL,NULL,'mean','ESO 144- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149728,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149728,36,0.47,159,71190,NULL,NULL,'H','ESO 144- G 019',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149729,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17611','RN',149729,43.12,0.4,2920,71191,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17611',0.443089,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149730,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17611','RN',149730,43.31,0.4,3180,71191,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17611',0.443089,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149731,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149731,34.65,0.5,85,71192,NULL,NULL,'Malmquist cor.','CGCG 375-011',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000013,NULL,'15.0g',0.47,'Sb',NULL,NULL,NULL,NULL,1,318.30425,-0.36661,0.265,NULL,49670205033,776096953,12126514,15),(149732,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149732,34.68,0.2,86.3,71192,74.4,NULL,NULL,'CGCG 375-011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149733,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149733,34.74,0.48,88.8,71192,NULL,NULL,NULL,'CGCG 375-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149734,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149734,35.74,0.67,141,71193,70,NULL,NULL,'2MASX J21131543-3732127',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.97',0.22,NULL,NULL,NULL,NULL,NULL,1,318.314375,-37.53689,0.129,NULL,51483850621,804435165,12569299,15.97),(149735,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149735,33.05,0.43,40.8,71194,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7040',NULL,'2014MNRAS.444..527S',2014,1,1.1,'The companion noted in CGCG and UGC may be a line of three stars.','G',0.000026,NULL,'14.9P',0.8,'S',NULL,NULL,NULL,NULL,1,318.31875,8.86497,0.405,NULL,55057425067,860272266,13441754,14.9),(149736,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813',NULL,149736,39.65,0.21,851,71195,70,NULL,'SN photometric redshift distance, z photo =0.223 +/- 0.026','SDSS-II SN 13813',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.320875,-0.40486,0.205,NULL,49670084931,776095077,12126485,NULL),(149737,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813','R',149737,40.45,0.21,995,71195,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13813',0.23646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149738,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813','R',149738,40.68,0.15,1110,71195,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13813',0.23646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149739,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813',NULL,149739,40.32,0.15,1160,71195,70,NULL,'SALT 2','SDSS-II SN 13813',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149740,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13813',NULL,149740,40.34,0.15,1170,71195,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13813',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149741,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149741,35.32,0.58,116,71196,70,NULL,NULL,'FAIRALL 0957',NULL,'2014MNRAS.445.2677S',2014,1,0.6,'1984MNRAS.210...69F has V = 11100: +- 200 km/s.','G',0.00015,NULL,'14.2r',0.53,'(R\'_1)SB(s)a',NULL,NULL,NULL,NULL,1,318.33675,-47.95339,0.053,NULL,51346186582,802284165,12535690,14.2),(149742,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149742,36.71,0.68,220,71197,70,NULL,NULL,'2MASX J21132322-7229198',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.3465417,-72.48886,0.097,NULL,49291988351,770187317,12034176,16.8),(149743,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149743,35.42,0.52,121,71198,70,NULL,NULL,'ESO 047- G 024',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'16.1b',0.2,'Compact',NULL,NULL,NULL,NULL,1,318.3679583,-74.44897,0.237,NULL,48402572566,756290196,11817034,16.1),(149744,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149744,34.89,0.53,95,71199,70,NULL,NULL,'CGCG 375-014',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000097,NULL,'15.0',0.5,NULL,NULL,NULL,NULL,NULL,1,318.3860417,-1.38006,0.181,NULL,49674898936,776170295,12127660,15),(149745,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149745,36.82,0.66,231,71200,70,NULL,NULL,'2MASX J21133544-4300222',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'14.8r',0.49,NULL,NULL,NULL,NULL,NULL,1,318.39775,-43.00617,0.073,NULL,51360371605,802505806,12539153,14.8),(149746,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149746,36.88,0.9,238,71201,70,NULL,NULL,'2MASX J21133707-5400255',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'14.9r',0.42,'S0',NULL,NULL,NULL,NULL,1,318.404375,-54.00711,0.109,NULL,50603958822,790686856,12354482,14.9),(149747,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06371','RN',149747,40.09,2.22,932,71202,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06371',0.120792,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149748,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149748,36.71,0.74,220,71203,70,NULL,NULL,'2MASX J21133996-2902563',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.0r',0.53,'S',NULL,NULL,NULL,NULL,1,318.416583333,-29.04903,0.349,NULL,51428650011,803572656,12555822,15),(149749,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149749,33.1,0.8,41.7,71204,75,NULL,'MAT, I','ESO 107- G 015',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000027,NULL,'13.5r',0.4,'SB(s)cd: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,318.42925,-63.3365,0.041,NULL,49169106089,768267282,12004176,13.5),(149750,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149750,32.81,0.4,36.5,71204,NULL,NULL,NULL,'ESO 107- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149751,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149751,32.85,0.49,37.1,71204,75,NULL,'IR','ESO 107- G 015',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149752,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149752,32.94,0.32,38.7,71204,85,NULL,'I, raw','ESO 107- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149753,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149753,32.95,0.32,38.9,71204,85,NULL,'I, inv','ESO 107- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149754,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149754,33,0.43,39.7,71204,75,NULL,'MAT, I, raw','ESO 107- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149755,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149755,33.1,0.43,41.7,71204,75,NULL,'MAT, I, inv','ESO 107- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149756,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149756,33.14,0.43,42.5,71204,75,NULL,'MAT, I, cor','ESO 107- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149757,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149757,33.27,0.4,45.1,71204,NULL,NULL,'mean','ESO 107- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149758,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149758,33.32,0.47,46.1,71204,NULL,NULL,'H','ESO 107- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149759,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149759,33.46,0.46,49.3,71204,NULL,NULL,'J','ESO 107- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149760,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149760,33.47,0.45,49.4,71204,NULL,NULL,'K','ESO 107- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149761,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13432','R',149761,40.23,0.31,903,71205,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13432',0.228542,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,318.453208333,-1.07564,0.185,NULL,49674831634,776169244,12127644,NULL),(149762,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13432','R',149762,40.3,0.34,935,71205,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13432',0.228542,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149763,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149763,34.69,NULL,86.8,71206,NULL,NULL,'Dipole','ESO 144- G 020',NULL,'2010Ap&SS.325..163P',2010,1,2.13,NULL,'G',0.000033,NULL,'15.1r',0.24,'Sc',NULL,NULL,NULL,NULL,1,318.459708333,-61.28925,0.073,NULL,49188812890,768575201,12008987,15.1),(149764,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149764,34.69,NULL,86.8,71206,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 144- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149765,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149765,34.72,NULL,88,71206,NULL,NULL,'Dipole + Quadrupole','ESO 144- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149766,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149766,35.42,0.54,121,71206,NULL,NULL,NULL,'ESO 144- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149767,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149767,35.43,0.54,122,71206,NULL,NULL,'Malmquist cor.','ESO 144- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149768,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149768,35.46,0.2,124,71206,74.4,NULL,NULL,'ESO 144- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149769,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149769,37.23,0.46,279,71207,70,NULL,NULL,'2MASX J21135107+1012095',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000151,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,318.462667,10.20256,0.277,NULL,55059305437,860301647,13442213,17.9),(149770,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20105',NULL,149770,40.14,0.31,1060,71208,70,NULL,'SN photometric redshift distance, z photo =0.289 +/- 0.055','SDSS-II SN 20105',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','24.0g',0.01,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,318.478375,0.39703,0.369,NULL,52083756689,813808698,12715760,24),(149771,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03057','RN',149771,39.45,0.4,684,71209,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03057',0.135786,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149772,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03057','RN',149772,39.81,0.35,807,71209,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03057',0.135786,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149773,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149773,36.45,0.52,195,71210,70,NULL,NULL,'2MASX J21140138-1234446',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.80',0.24,NULL,NULL,NULL,NULL,NULL,1,318.505791667,-12.57908,0.137,NULL,50958788376,796231068,12441110,16.8),(149774,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149774,36.92,0.33,242,71211,70,NULL,NULL,'2MASX J21140394+0020497',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000165,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,318.516291667,0.34706,0.369,NULL,52083734507,813808351,12715755,17.6),(149775,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149775,37.42,0.46,305,71212,70,NULL,NULL,'2MASX J21141097+1116543',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000146,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,318.545583,11.28178,0.281,NULL,55052973703,860202714,13440667,17.4),(149776,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19025','R',149776,41.81,0.33,1630,71213,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mx','SDSS J211411.07-001743.7',0.406,'2014arXiv1401.3317S',2014,1,0.04,NULL,'G',NULL,NULL,'23.3g',0.02,NULL,NULL,NULL,NULL,NULL,1,318.546125,-0.2955,0.217,NULL,49670870078,776107344,12126677,23.3),(149777,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19025','R',149777,41.91,0.31,1720,71213,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mx','SDSS J211411.07-001743.7',0.406,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149778,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149778,36.14,0.64,169,71214,70,NULL,NULL,'2MASX J21141246-4240476',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.0r',0.29,NULL,NULL,NULL,NULL,NULL,1,318.5519583,-42.67994,0.069,NULL,51360734825,802511481,12539241,15),(149779,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149779,32.05,0.49,25.8,71215,75,NULL,'IR','IC 1368',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000037,NULL,'14.30',0.4,'Sa? sp         Sy2',NULL,NULL,NULL,'Sy 2',1,318.5524583,2.178,0.261,NULL,52093055775,813953996,12718031,14.3),(149780,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149780,32.7,0.47,34.7,71215,NULL,NULL,'H','IC 1368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149781,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149781,32.8,0.45,36.3,71215,NULL,NULL,'K','IC 1368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149782,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149782,32.87,0.46,37.5,71215,NULL,NULL,'J','IC 1368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149783,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149783,33.39,0.4,47.6,71215,NULL,NULL,'mean','IC 1368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149784,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149784,37.62,0.46,334,71216,70,NULL,NULL,'2MASX J21141261+1106353',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000183,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,318.552583333,11.10978,0.269,NULL,55061021039,860328453,13442632,17.5),(149785,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149785,35.55,0.57,129,71217,70,NULL,NULL,'2MASX J21141455-6513361',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'14.2r',0.42,'S',NULL,NULL,NULL,NULL,1,318.5607917,-65.22672,0.009,NULL,49347772794,771058949,12047796,14.2),(149786,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149786,37.43,0.56,307,71218,70,NULL,NULL,'2MASX J21141628-5147217',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.00009,NULL,'14.6r',0.43,'S0',NULL,NULL,NULL,NULL,1,318.567958333,-51.78933,0,NULL,50602381663,790662213,12354097,14.6),(149787,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149787,37.1,0.64,264,71219,70,NULL,NULL,'2MASX J21142031-7907018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.584625,-79.11725,0.577,NULL,48586182232,759159097,11861860,17.2),(149788,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149788,34.24,NULL,70.5,71220,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11706',NULL,'2010Ap&SS.325..163P',2010,1,1.77,NULL,'G',0.000023,NULL,'15.41',0.22,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,318.593167,15.24411,0.393,NULL,55277340844,863708450,13495444,15.41),(149789,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149789,34.25,NULL,70.8,71220,NULL,NULL,'Dipole','UGC 11706',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149790,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149790,34.25,NULL,70.8,71220,NULL,NULL,'Dipole + Quadrupole','UGC 11706',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149791,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149791,34.31,0.49,72.9,71220,75,NULL,'IR','UGC 11706',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149792,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149792,34.58,0.43,82.4,71220,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11706',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149793,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149793,34.62,0.56,83.8,71220,NULL,NULL,'Malmquist cor.','UGC 11706',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149794,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149794,34.63,0.43,84.3,71220,75,NULL,'3.6 micron, color corrected','UGC 11706',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149795,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149795,34.69,0.2,86.7,71220,74.4,NULL,NULL,'UGC 11706',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149796,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149796,34.73,0.53,88.3,71220,NULL,NULL,NULL,'UGC 11706',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149797,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02388','RN',149797,39.87,0.19,890,71221,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02388',0.060036,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149798,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02388','RN',149798,41.08,0.26,1550,71221,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02388',0.060036,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149799,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149799,38,0.46,398,71222,70,NULL,NULL,'2MASX J21142346+0108026',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,318.597791667,1.13403,0.253,NULL,52091569107,813930767,12717668,18),(149800,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149800,34.94,0.6,97.2,71223,70,NULL,NULL,'2MASX J21142354-0505564',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.27',NULL,NULL,NULL,NULL,NULL,NULL,1,318.598125,-5.09908,0.297,NULL,50743109623,792861087,12388454,16.27),(149801,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149801,36.92,0.33,242,71224,70,NULL,NULL,'2MASX J21142585+0000405',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000179,NULL,'17.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,318.60775,0.01108,0.269,NULL,52083177495,813799648,12715619,17),(149802,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20408',NULL,149802,40.25,0.17,1120,71225,70,NULL,'SN photometric redshift distance, z photo =0.308 +/- 0.030','SDSS-II SN 20408',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.616333,-0.76411,0.193,NULL,49670939661,776108432,12126694,NULL),(149803,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01725','RN',149803,37.41,0.61,267,71226,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01725',0.136477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149804,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01725','RN',149804,39.72,0.45,773,71226,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01725',0.136477,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149805,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149805,34.81,0.66,91.8,71227,70,NULL,NULL,'2MASX J21143002-2326260',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.000103,NULL,'14.7r',0.38,'E',NULL,NULL,NULL,NULL,1,318.625041667,-23.44056,0.189,NULL,50917810877,795590794,12431106,14.7),(149806,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149806,30.99,0.8,15.8,71228,75,NULL,'A82, H','UGC 11707',NULL,'1997ApJS..109..333W',1997,1,3.6,NULL,'G',0.000003,NULL,'14.5',1.9,'SAdm',NULL,NULL,NULL,NULL,1,318.6322917,26.73458,0.637,NULL,55601059999,868766562,13574477,14.5),(149807,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149807,30.98,0.4,15.7,71228,75,NULL,'B','UGC 11707',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149808,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149808,31.84,0.4,23.3,71228,NULL,NULL,'Virgo cluster at 15.6 Mpc','UGC 11707',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149809,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149809,31.84,0.47,23.3,71228,75,NULL,'A82, H, inv','UGC 11707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149810,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149810,31.92,0.47,24.2,71228,75,NULL,'A82, H, raw','UGC 11707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149811,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149811,32.26,0.47,28.3,71228,75,NULL,'A82, H, cor','UGC 11707',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149812,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149812,37.91,0.46,382,71229,70,NULL,NULL,'2MASX J21143416+0930456',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,318.6425,9.51275,0.337,NULL,55059101934,860298467,13442163,18),(149813,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13333',NULL,149813,39.57,0.31,820,71230,70,NULL,'SN photometric redshift distance, z photo =0.214 +/- 0.038','SDSS-II SN 13333',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.4g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.649125,0.27844,0.369,NULL,52083714906,813808045,12715750,20.4),(149814,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13333','R',149814,40.43,0.19,956,71230,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13333',0.277326,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149815,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13333','R',149815,40.67,0.29,1060,71230,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13333',0.277326,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149816,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11334','RN',149816,38.95,0.22,538,71231,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 11334',0.145992,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149817,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11334','RN',149817,40.07,0.11,899,71231,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 11334',0.145992,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149818,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149818,36.7,0.67,219,71232,70,NULL,NULL,'2MASX J21144012-2827204',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.4r',0.18,NULL,NULL,NULL,NULL,NULL,1,318.6672083,-28.45572,0.381,NULL,51437887521,803716992,12558078,15.4),(149819,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03248','RN',149819,42.37,0.23,1800,71233,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03248',0.652057,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149820,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149820,35.53,0.5,128,71234,NULL,NULL,NULL,'ESO 464- G 029',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.4r',0.8,'Sb-c',NULL,NULL,NULL,NULL,1,318.675125,-31.58231,0.341,NULL,51498016343,804656505,12572757,14.4),(149821,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149821,35.58,0.2,131,71234,74.4,NULL,NULL,'ESO 464- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149822,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149822,35.6,0.49,132,71234,NULL,NULL,'Malmquist cor.','ESO 464- G 029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149823,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149823,35.11,0.46,105,71235,70,NULL,NULL,'SDSS J211454.22-072427.6',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000108,NULL,'15.4g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,318.725958333,-7.40769,0.269,NULL,50772530766,793320793,12395637,15.4),(149824,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149824,33.16,0.69,42.9,71236,100,NULL,'mid-IR','NGC 7046',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000007,NULL,'13.75',1.3,'SB(rs)cd      LINER:',NULL,NULL,NULL,NULL,1,318.7335,2.83483,0.261,NULL,52089347234,813896050,12717125,13.75),(149825,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149825,33.66,0.4,53.9,71236,NULL,NULL,'mean','NGC 7046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149826,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149826,33.7,0.43,55,71236,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7046',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149827,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149827,33.74,0.47,56.1,71236,NULL,NULL,'H','NGC 7046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149828,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149828,33.8,0.45,57.5,71236,NULL,NULL,'K','NGC 7046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149829,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149829,33.83,0.46,58.3,71236,NULL,NULL,'J','NGC 7046',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149830,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149830,36.86,0.59,236,71237,70,NULL,NULL,'2MASX J21145600-6729239',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.4b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.733416667,-67.49003,0.065,NULL,49385287455,771645116,12056954,16.4),(149831,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03161','R',149831,41.02,0.4,1160,71238,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03161',0.371513,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','22.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.743625,1.13672,0.253,NULL,52083533510,813805211,12715706,22.9),(149832,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03161','R',149832,41.21,0.44,1270,71238,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03161',0.371513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149833,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 03161',NULL,149833,40.75,0.3,1410,71238,70,NULL,'SN photometric redshift distance, z photo =0.409 +/- 0.080','SDSS-II SN 03161',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149834,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07255','RN',149834,40.48,0.26,1020,71239,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07255',0.22557,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149835,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07255','RN',149835,41.4,0.44,1550,71239,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07255',0.22557,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149836,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15192','RN',149836,39.52,0.3,702,71240,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15192',0.139552,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149837,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13815','RN',149837,40.64,0.23,1190,71241,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13815',0.133715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149838,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13815','RN',149838,41.23,0.25,1560,71241,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13815',0.133715,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149839,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149839,37.32,0.46,291,71242,70,NULL,NULL,'SDSS J211506.41+011012.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,318.77675,1.17011,0.253,NULL,52083315456,813801804,12715653,18.3),(149840,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149840,33.94,0.8,61.5,71243,75,NULL,'MAT, I','NGC 7038',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000023,NULL,'12.55',1.6,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,318.781291667,-47.2205,0.061,NULL,51397745926,803089780,12548277,12.55),(149841,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149841,33.95,0.8,61.7,71243,75,NULL,'HMCL, I','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149842,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149842,33.34,NULL,46.6,71243,NULL,NULL,'B','NGC 7038',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149843,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149843,33.37,0.3,47.2,71243,NULL,NULL,'B, Hubble-type-TF','NGC 7038',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149844,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149844,33.65,0.46,53.8,71243,NULL,NULL,'J','NGC 7038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149845,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149845,33.73,0.45,55.7,71243,NULL,NULL,'K','NGC 7038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149846,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149846,33.73,0.47,55.8,71243,NULL,NULL,'H','NGC 7038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149847,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149847,33.78,0.43,57.1,71243,75,NULL,'MAT, I, raw','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149848,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149848,33.8,0.4,57.7,71243,75,NULL,'HMCL, I, raw','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149849,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149849,33.99,0.32,62.8,71243,85,NULL,'I, raw','NGC 7038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149850,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149850,34.06,NULL,64.9,71243,NULL,NULL,'I','NGC 7038',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149851,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149851,34.06,0.4,65,71243,75,NULL,'HMCL, I, cor','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149852,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149852,34.08,0.32,65.5,71243,85,NULL,'I, inv','NGC 7038',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149853,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149853,34.08,0.43,65.5,71243,75,NULL,'MAT, I, cor','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149854,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149854,34.09,0.4,65.7,71243,75,NULL,'HMCL, I, inv','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149855,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149855,34.12,0.4,66.6,71243,NULL,NULL,'mean','NGC 7038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149856,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149856,34.15,0.43,67.5,71243,75,NULL,'MAT, I, inv','NGC 7038',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149857,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149857,35.99,0.52,157,71244,70,NULL,NULL,'2MASX J21150822-2321306',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000083,NULL,'14.4r',0.3,'S',NULL,NULL,NULL,NULL,1,318.7842917,-23.35847,0.153,NULL,50917845612,795591337,12431114,14.4),(149858,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 09814',NULL,149858,40.7,0.35,1380,71245,70,NULL,'SN photometric redshift distance, z photo =0.396 +/- 0.094','SDSS-II SN 09814',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.787833,-0.41989,0.217,NULL,49670799823,776106247,12126660,NULL),(149859,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 09814',NULL,149859,42.38,0.23,2990,71245,70,NULL,'SALT 2','SDSS-II SN 09814',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149860,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 09814',NULL,149860,42.56,0.23,3250,71245,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09814',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149861,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149861,37.47,0.63,312,71246,70,NULL,NULL,'2MASX J21151458-5148589',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.2r',0.28,NULL,NULL,NULL,NULL,NULL,1,318.81075,-51.81639,0,NULL,50602374522,790662101,12354095,15.2),(149862,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149862,36.8,0.71,230,71247,70,NULL,NULL,'ESO 235- G 079',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.7r',0.36,'S0',NULL,NULL,NULL,NULL,1,318.813625,-51.33297,0.009,NULL,50613742416,790839725,12356870,14.7),(149863,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149863,36.42,0.5,192,71248,70,NULL,NULL,'2MASX J21151919-7222123',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,318.830083333,-72.37,0.097,NULL,49293832283,770216129,12034627,16),(149864,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02053','R',149864,39.31,0.22,591,71249,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2005fk','SN 2005fk',0.233613,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ibc',NULL,NULL,NULL,NULL,1,318.832625,-0.38294,0.217,NULL,49670686979,776104484,12126632,NULL),(149865,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02053','R',149865,39.36,0.27,603,71249,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2005fk','SN 2005fk',0.233613,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149866,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01773','RN',149866,39.04,0.2,575,71250,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01773',0.120184,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149867,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01773','RN',149867,39.75,0.35,797,71250,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01773',0.120184,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149868,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149868,36.72,0.46,221,71251,70,NULL,NULL,'2MASX J21152339+1004596',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000174,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,318.8475,10.08331,0.253,NULL,55062103510,860345367,13442896,16.5),(149869,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15825','RN',149869,43.69,0.38,3450,71252,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15825',0.583445,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149870,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19013',NULL,149870,40.83,0.38,1460,71253,70,NULL,'SN photometric redshift distance, z photo =0.428 +/- 0.113','SDSS-II SN 19013',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.8695417,-0.67031,0.149,NULL,49670837539,776106836,12126669,NULL),(149871,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149871,39.21,0.14,580,71254,74.2,NULL,'SALT 2','SDSS J211531.80-002116.5',0.198,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',0.000134,NULL,'19.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,318.8825,-0.35458,0.217,NULL,49670724170,776105065,12126641,19.1),(149872,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07335','R',149872,39.83,0.21,772,71254,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2005kn','SDSS J211531.80-002116.5',0.197473,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149873,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149873,39.91,0.15,799,71254,70,NULL,'SDSS-II SN 07335, SALT 2','SDSS J211531.80-002116.5',0.198,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149874,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149874,39.56,0.1,817,71254,70,NULL,'SALT 2','SDSS J211531.80-002116.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149875,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149875,39.57,0.1,820,71254,70,NULL,'SALT 2, Malmquist cor.','SDSS J211531.80-002116.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149876,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07335','R',149876,40.09,0.12,871,71254,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2005kn','SDSS J211531.80-002116.5',0.197473,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149877,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005kn',NULL,149877,40.99,0.04,1320,71254,70,NULL,'SDSS-II SN 07335','SDSS J211531.80-002116.5',0.198,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149878,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15208','RN',149878,43.7,0.24,3910,71255,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15208',0.406588,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149879,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15208','RN',149879,44.27,0.37,5070,71255,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15208',0.406588,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149880,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149880,37.47,0.6,312,71256,70,NULL,NULL,'2MASX J21153555-4652287',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'15.3r',0.3,NULL,NULL,NULL,NULL,NULL,1,318.8982917,-46.87458,0.073,NULL,51397717827,803089341,12548270,15.3),(149881,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149881,36.98,0.62,249,71257,70,NULL,NULL,'2MASX J21153582-4717297',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000133,NULL,'14.8r',0.43,NULL,NULL,NULL,NULL,NULL,1,318.89925,-47.29156,0.061,NULL,51397763756,803090058,12548282,14.8),(149882,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15129','R',149882,39.86,0.19,783,71258,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kq','SDSS J211536.58-001917.1',0.197395,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,318.902416667,-0.32142,0.217,NULL,49670723543,776105055,12126641,NULL),(149883,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15129','R',149883,40.08,0.11,865,71258,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kq','SDSS J211536.58-001917.1',0.197395,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149884,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14807','R',149884,40.19,0.17,909,71258,70,NULL,'SDSS CAND. zSNII; MLCS2K2; SN 2006kq','SDSS J211536.58-001917.1',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149885,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006kq',NULL,149885,39.82,0.08,920,71258,70,NULL,'SALT 2','SDSS J211536.58-001917.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149886,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006kq',NULL,149886,39.83,0.08,925,71258,70,NULL,'SALT 2, Malmquist cor.','SDSS J211536.58-001917.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149887,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14807','R',149887,40.96,0.24,1290,71258,70,NULL,'SDSS CAND. zSNII; SALT 2; SN 2006kq','SDSS J211536.58-001917.1',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149888,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13729',NULL,149888,38.47,1.46,495,71259,70,NULL,'SN photometric redshift distance, z photo =0.123 +/- 0.136','SDSS-II SN 13729',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,318.918666667,0.87517,0.345,NULL,52083487389,813804490,12715695,NULL),(149889,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149889,38.19,0.46,434,71260,70,NULL,NULL,'SDSS J211543.67+004422.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000164,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,318.932,0.73969,0.345,NULL,52083563584,813805681,12715713,18.4),(149890,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149890,34.85,0.65,93.3,71261,70,NULL,NULL,'2MASX J21154428-2259234',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'14.4r',0.27,'S',NULL,NULL,NULL,NULL,1,318.934458333,-22.98989,0.145,NULL,50917991247,795593613,12431150,14.4),(149891,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149891,35.39,0.49,120,71262,75,NULL,'IR','UGC 11711',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000007,NULL,'16.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,318.937833333,17.35972,0.481,NULL,55268845657,863575713,13493370,16),(149892,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149892,35.81,NULL,145,71262,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149893,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149893,35.83,NULL,147,71262,NULL,NULL,'Dipole + Quadrupole','UGC 11711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149894,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149894,35.84,NULL,147,71262,NULL,NULL,NULL,'UGC 11711',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149895,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149895,35.85,NULL,148,71262,NULL,NULL,'Dipole','UGC 11711',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149896,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149896,36.09,0.43,165,71262,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11711',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149897,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007pc',NULL,149897,38.63,0.07,532,71263,70,NULL,'Hubble residual -0.07 for z0.13790','SDSS J211549.47+003904.3',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,318.956125,0.65119,0.345,NULL,52083565892,813805717,12715714,NULL),(149898,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19775','R',149898,39.07,0.18,572,71263,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pc','SDSS J211549.47+003904.3',0.1379,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149899,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19775','R',149899,39.16,0.1,596,71263,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pc','SDSS J211549.47+003904.3',0.1379,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149900,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007pc',NULL,149900,38.91,0.07,605,71263,70,NULL,'SALT 2','SDSS J211549.47+003904.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149901,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007pc',NULL,149901,38.92,0.07,608,71263,70,NULL,'SALT 2, Malmquist cor.','SDSS J211549.47+003904.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149902,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02054','RN',149902,39.6,0.31,661,71264,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02054',0.261299,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149903,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02054','RN',149903,40.61,0.29,1050,71264,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02054',0.261299,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149904,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01775','R',149904,41.41,0.29,1470,71265,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01775',0.303881,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,318.993375,-1.00942,0.169,NULL,49670363513,776099429,12126553,NULL),(149905,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01775','R',149905,41.66,0.25,1650,71265,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01775',0.303881,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149906,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16105','RN',149906,39.83,0.19,813,71266,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16105',0.139636,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149907,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16105','RN',149907,39.86,0.14,822,71266,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16105',0.139636,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149908,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149908,36.01,0.57,160,71267,70,NULL,NULL,'2MFGC 16105',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'14.2r',0.37,'S',NULL,NULL,NULL,NULL,1,319.0037917,-46.67489,0.081,NULL,51397659726,803088433,12548256,14.2),(149909,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16715','RN',149909,42.07,0.3,2140,71268,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16715',0.209974,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149910,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16715','RN',149910,42.33,0.51,2420,71268,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16715',0.209974,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149911,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149911,31.64,0.8,21.3,71269,75,NULL,'MAT, I','ESO 107- G 016',NULL,'1997ApJS..109..333W',1997,1,3.47,NULL,'G',0.00002,NULL,'15.11',0.34,'SB(s)dm: sp',NULL,NULL,NULL,NULL,1,319.025833,-64.81694,0.013,NULL,49349938138,771092783,12048324,15.11),(149912,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149912,31.78,0.8,22.7,71269,75,NULL,NULL,'ESO 107- G 016',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149913,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149913,31.95,NULL,24.5,71269,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 107- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149914,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149914,31.96,NULL,24.7,71269,NULL,NULL,'Dipole','ESO 107- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149915,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149915,31.96,NULL,24.7,71269,NULL,NULL,'Dipole + Quadrupole','ESO 107- G 016',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149916,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149916,32.06,NULL,25.8,71269,NULL,NULL,NULL,'ESO 107- G 016',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149917,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149917,32.4,0.32,30.2,71269,85,NULL,'I, inv','ESO 107- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149918,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149918,32.43,0.32,30.6,71269,85,NULL,'I, raw','ESO 107- G 016',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149919,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149919,32.49,0.4,31.5,71269,NULL,NULL,NULL,'ESO 107- G 016',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149920,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149920,32.49,0.4,31.5,71269,73,NULL,'opt','ESO 107- G 016',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149921,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149921,32.73,0.43,35.1,71269,75,NULL,'MAT, I, inv','ESO 107- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149922,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149922,32.77,0.43,35.8,71269,75,NULL,'MAT, I, raw','ESO 107- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149923,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149923,32.99,0.43,39.7,71269,75,NULL,'MAT, I, cor','ESO 107- G 016',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149924,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11360','RN',149924,39.23,0.27,617,71270,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11360',0.135957,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149925,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149925,35.36,0.52,118,71271,70,NULL,NULL,'ESO 599- G 004',NULL,'2014MNRAS.445.2677S',2014,1,1.22,NULL,'G',0.000097,NULL,'14.0r',0.47,'SAB(s)0^0^:',NULL,NULL,NULL,NULL,1,319.060375,-22.23461,0.121,NULL,50916490261,795570160,12430783,14),(149926,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149926,33.02,0.8,40.3,71272,75,NULL,'MAT, I','IC 5092',NULL,'1997ApJS..109..333W',1997,1,2.9,'ESO-LV gives v= 4141+/-29 km/sec.','G',0.000022,NULL,'12.77',2.4,'(R\')SB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.060417,-64.46467,0.033,NULL,49349524570,771086321,12048223,12.77),(149927,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149927,32.03,0.32,25.5,71272,85,NULL,'I, raw','IC 5092',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149928,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149928,32.07,0.32,25.9,71272,85,NULL,'I, inv','IC 5092',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149929,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149929,32.45,0.43,30.9,71272,75,NULL,'MAT, I, raw','IC 5092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149930,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149930,32.63,0.43,33.6,71272,75,NULL,'MAT, I, inv','IC 5092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149931,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149931,32.79,0.43,36.1,71272,75,NULL,'MAT, I, cor','IC 5092',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149932,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06433',NULL,149932,39.7,0.3,871,71273,70,NULL,'SN photometric redshift distance, z photo =0.229 +/- 0.039','SDSS-II SN 06433',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,319.064583,-0.33317,0.269,NULL,49670735111,776105236,12126644,NULL),(149933,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149933,36.44,0.69,194,71274,70,NULL,NULL,'ESO 188- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00009,NULL,'14.6r',0.8,'SA(s)c:',NULL,NULL,NULL,NULL,1,319.071333,-55.51094,0.117,NULL,48657160952,760268139,11879189,14.6),(149934,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006iz',NULL,149934,38.89,0.1,599,71275,70,NULL,'Hubble residual 0.21 for z0.13630','SDSS J211617.20+003334.2',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,319.071667,0.5595,0.269,NULL,52083151836,813799247,12715613,NULL),(149935,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14815','R',149935,39.39,0.07,665,71275,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006iz','SDSS J211617.20+003334.2',0.1363,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149936,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14815','R',149936,39.64,0.2,745,71275,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006iz','SDSS J211617.20+003334.2',0.1363,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149937,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20805','RN',149937,41.38,0.28,1410,71276,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20805',0.34033,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149938,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20805','RN',149938,41.47,0.23,1470,71276,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20805',0.34033,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149939,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149939,37.85,0.46,371,71277,70,NULL,NULL,'2MASX J21161902+1030256',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,319.079291667,10.507,0.225,NULL,55062214366,860347099,13442923,17.8),(149940,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149940,37.14,0.46,268,71278,70,NULL,NULL,'2MASX J21161973-0556034',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.0001,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,319.08225,-5.93422,0.473,NULL,50742748186,792855440,12388366,17.5),(149941,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19653','RN',149941,41.63,0.33,1570,71279,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19653',0.346893,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149942,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19653','RN',149942,41.76,0.3,1670,71279,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19653',0.346893,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149943,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149943,35.48,0.45,125,71280,NULL,NULL,NULL,'CGCG 375-024',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000146,NULL,'16.1g',0.35,'Sb',NULL,NULL,NULL,NULL,1,319.091541667,1.08489,0.253,NULL,52083928046,813811375,12715802,16.1),(149944,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149944,35.53,0.44,127,71280,NULL,NULL,'Malmquist cor.','CGCG 375-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149945,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149945,35.58,0.2,131,71280,74.4,NULL,NULL,'CGCG 375-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149946,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149946,35.07,0.57,103,71281,NULL,NULL,'Malmquist cor.','ESO 342- G 025',NULL,'2009ApJS..182..474S',2009,1,1.25,NULL,'G',0.000033,NULL,'13.8r',0.46,'Sb-c',NULL,NULL,NULL,NULL,1,319.092,-38.98156,0.125,NULL,51482450341,804413286,12568957,13.8),(149947,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149947,35.13,0.56,106,71281,NULL,NULL,NULL,'ESO 342- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149948,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149948,35.17,0.2,108,71281,74.4,NULL,NULL,'ESO 342- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149949,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149949,35.53,0.47,128,71281,NULL,NULL,'H','ESO 342- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149950,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149950,35.53,0.4,128,71281,NULL,NULL,'mean','ESO 342- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149951,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149951,35.69,0.46,138,71281,NULL,NULL,'J','ESO 342- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149952,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149952,34.25,0.46,70.8,71282,70,NULL,NULL,'CGCG 426-029',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000123,NULL,'15.1g',0.46,'S0','Isolated galaxy',NULL,NULL,NULL,1,319.10325,10.27339,0.241,NULL,55062608395,860353256,13443019,15.1),(149953,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149953,36.5,0.55,199,71283,70,NULL,NULL,'2MASX J21162540-5139340',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.0r',0.31,NULL,NULL,NULL,NULL,NULL,1,319.105917,-51.65939,0.005,NULL,50613836015,790841187,12356893,15),(149954,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149954,33.85,0.69,58.9,71284,100,NULL,'mid-IR','NGC 7047',NULL,'2013ApJ...771...88L',2013,1,1.38,NULL,'G',0.000033,NULL,'14.0g',0.69,'SAB(r)b:       HII',NULL,NULL,NULL,NULL,1,319.1152083,-0.8265,0.149,NULL,49672947695,776139807,12127184,14),(149955,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149955,34.48,0.43,78.6,71284,NULL,NULL,'Malmquist cor.','NGC 7047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149956,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149956,34.62,0.4,83.9,71284,NULL,NULL,NULL,'NGC 7047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149957,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149957,34.66,0.2,85.5,71284,74.4,NULL,NULL,'NGC 7047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149958,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149958,34.73,0.43,88.5,71284,75,NULL,'3.6 micron, color corrected','NGC 7047',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149959,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149959,34.89,0.43,94.9,71284,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7047',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149960,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149960,37,0.46,251,71285,70,NULL,NULL,'2MASX J21162884-0105563',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000157,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,319.1200417,-1.09883,0.169,NULL,49672246784,776128856,12127013,17.1),(149961,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149961,32.03,0.14,25.5,71286,74.4,NULL,NULL,'NGC 7041',NULL,'2013AJ....146...86T',2013,1,3.6,NULL,'G',0.00008,NULL,'12.09',1.5,'SA(rs)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.134916667,-48.36356,0.061,NULL,51342803022,802231297,12534864,12.09),(149962,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149962,32.05,0.31,25.7,71286,NULL,NULL,'I','NGC 7041',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149963,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149963,31.16,0.37,17.1,71286,95,NULL,'Weighted Mean','NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149964,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149964,31.33,0.63,18.5,71286,95,NULL,'Michard 1979b, c','NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149965,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149965,31.58,0.46,20.7,71286,95,NULL,'Michard 1979a','NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149966,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149966,32.19,0.81,27.4,71286,55,NULL,'Visvanathan & Sandage 1979','NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149967,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149967,32.5,0.55,31.6,71286,70,NULL,NULL,'NGC 7041',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149968,'Tertiary','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149968,31.55,0.71,20.4,71286,95,NULL,NULL,'NGC 7041',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149969,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149969,31.92,0.8,24.2,71286,75,NULL,'B','NGC 7041',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149970,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149970,31.95,0.4,24.5,71286,NULL,NULL,'mean','NGC 7041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149971,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149971,32.14,0.45,26.8,71286,NULL,NULL,'K','NGC 7041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149972,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149972,36.95,0.33,246,71287,70,NULL,NULL,'2MASX J21163260-0045133',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',NULL,NULL,'14.6I',0.3,'BrClG',NULL,NULL,NULL,NULL,1,319.1357083,-0.75372,0.149,NULL,49672684782,776135699,12127120,14.6),(149973,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149973,35.33,0.49,116,71288,75,NULL,'IR','ESO 599- G 005',NULL,'2011yCatp016004901K',2011,1,1.99,NULL,'G',0.00005,NULL,'14.6r',0.2,'Sbc',NULL,NULL,NULL,NULL,1,319.139041667,-22.2155,0.121,NULL,50916475606,795569931,12430780,14.6),(149974,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19003','R',149974,36.98,0.09,235,71289,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mp','SN 2007mp',0.05991,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,319.1484583,-0.76989,0.149,NULL,49672958988,776139984,12127187,NULL),(149975,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19003','R',149975,37.29,0.2,270,71289,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mp','SN 2007mp',0.05991,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149976,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149976,36.95,0.33,246,71290,70,NULL,NULL,'2MASX J21164014-0046253',NULL,'2015arXiv151105856S',2015,1,0.44,'SDSS DR3 gives z= 0.059 and 0.393.','G',0.000183,NULL,'16.3g',0.35,NULL,NULL,NULL,NULL,NULL,1,319.167083,-0.77372,0.149,NULL,49672955046,776139922,12127186,16.3),(149977,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149977,37.36,0.46,296,71291,70,NULL,NULL,'2MASX J21164078+1051143',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,319.169875,10.85392,0.229,NULL,55061107773,860329808,13442653,18),(149978,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149978,37.37,0.46,297,71292,70,NULL,NULL,'2MASX J21164106+1024053',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,319.171125,10.40153,0.225,NULL,55062712114,860354876,13443044,17.1),(149979,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149979,37.59,0.85,329,71293,70,NULL,NULL,'2MASX J21164155-5257329',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'15.1r',0.2,NULL,NULL,NULL,NULL,NULL,1,319.173,-52.95914,0.061,NULL,50603461390,790679084,12354360,15.1),(149980,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149980,37.35,0.46,295,71294,70,NULL,NULL,'2MASX J21164614-0726564',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000086,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,319.1922083,-7.44917,0.329,NULL,50772403103,793318798,12395606,17.2),(149981,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149981,34.73,0.47,88.3,71295,70,NULL,NULL,'ESO 342- G 026',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000077,NULL,'13.0r',1,'SB(s)0^0^ pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,319.192458333,-42.26169,0.069,NULL,51360617411,802509647,12539213,13),(149982,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17614','RN',149982,41.76,0.12,1670,71296,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17614',0.3442,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149983,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17614','RN',149983,41.91,0.2,1790,71296,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17614',0.3442,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149984,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149984,35.3,0.54,115,71297,70,NULL,NULL,'ESO 464- G 030',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000103,NULL,'14.0r',0.2,'Sb             HII',NULL,NULL,NULL,NULL,1,319.237833333,-28.32636,0.345,NULL,51437237677,803706838,12557919,14),(149985,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149985,34.21,0.43,69.4,71298,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11738',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000143,NULL,'15.22',0.4,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,319.241916667,83.82125,0.305,NULL,52665238995,822894359,12857724,15.22),(149986,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149986,34.26,0.43,71.2,71298,75,NULL,'3.6 micron, color corrected','UGC 11738',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149987,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149987,34.33,0.2,73.5,71298,74.4,NULL,NULL,'UGC 11738',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149988,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149988,34.86,0.49,93.7,71299,75,NULL,'IR','MCG -01-54-007',NULL,'2011yCatp016004901K',2011,1,1.04,NULL,'G',0.000083,NULL,'15.6g',0.3,'Sbc            AGN',NULL,NULL,NULL,NULL,1,319.260167,-6.75203,0.329,NULL,50772256306,793316504,12395570,15.6),(149989,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149989,35.53,0.47,128,71300,NULL,NULL,'H','ESO 402- G 021',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000117,NULL,'15.13',0.3,'SB(s)a? pec',NULL,NULL,NULL,NULL,1,319.2645417,-33.98881,0.405,NULL,51531844260,805185066,12581016,15.13),(149990,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149990,35.54,0.4,128,71300,NULL,NULL,'mean','ESO 402- G 021',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149991,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149991,35.3,0.47,115,71301,70,NULL,NULL,'ESO 530- G 029',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.0r',0.5,'S0',NULL,NULL,NULL,NULL,1,319.2765417,-23.1215,0.113,NULL,50917967575,795593243,12431144,14),(149992,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149992,37.48,0.46,313,71302,70,NULL,NULL,'2MASX J21170937-0037122',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,319.289041667,-0.62,0.185,NULL,49672704654,776136010,12127125,17.1),(149993,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149993,36.15,0.73,170,71303,70,NULL,NULL,'2MASX J21171038-7557100',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.9b',0.17,NULL,NULL,NULL,NULL,NULL,1,319.2934583,-75.95272,0.321,NULL,48534299007,758348421,11849194,16.9),(149994,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149994,37.31,0.73,290,71304,70,NULL,NULL,'ESO 188-IG 002 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a superposed star.','G',0.00015,NULL,'16.39',NULL,NULL,NULL,NULL,NULL,NULL,1,319.2997917,-55.93778,0.185,NULL,48655479667,760241869,11878779,16.39),(149995,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149995,35.89,0.56,151,71305,70,NULL,NULL,'2MASX J21171271-1937371',NULL,'2014MNRAS.445.2677S',2014,1,0.9,'The APM image includes 2-3 superposed stars and a companion galaxy.','G',0.00015,NULL,'15.77',0.43,'E',NULL,NULL,NULL,NULL,1,319.303375,-19.62706,0.125,NULL,50911433350,795491146,12429549,15.77),(149996,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',149996,35.23,0.46,111,71306,70,NULL,NULL,'2MASX J21171829-0613471',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000103,NULL,'16.2g',0.38,'S0/a',NULL,NULL,NULL,NULL,1,319.326208333,-6.22964,0.317,NULL,50772064942,793313514,12395523,16.2),(149997,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149997,34.56,0.48,81.6,71307,NULL,NULL,'Malmquist cor.','UGC 11713',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.00011,NULL,'14.95',0.5,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.367666667,15.56581,0.413,NULL,55269657468,863588397,13493568,14.95),(149998,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149998,34.6,0.2,83.2,71307,74.4,NULL,NULL,'UGC 11713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(149999,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,149999,34.67,0.45,85.8,71307,NULL,NULL,NULL,'UGC 11713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150000,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150000,34.91,0.51,96.1,71308,70,NULL,NULL,'ESO 530- G 030',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000083,NULL,'13.5r',1.1,'SB(rs)a  poss. LINER',NULL,NULL,NULL,NULL,1,319.368125,-22.81625,0.121,NULL,50918694437,795604600,12431321,13.5),(150001,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150001,34.89,0.68,95.2,71309,70,NULL,NULL,'2MASX J21172918-8048085',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,319.3712083,-80.80236,0.537,NULL,48573761896,758965029,11858828,16.1),(150002,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007re',NULL,150002,39.19,0.15,688,71310,70,NULL,'Hubble residual -0.35 for z0.21090','SDSS J211734.92-003126.3',NULL,'2011ApJ...740...92G',2011,1,0.06,NULL,'G',0.0005,NULL,'20.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,319.3955417,-0.52397,0.205,NULL,49672873602,776138650,12127166,20.9),(150003,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20376','R',150003,39.64,0.2,700,71310,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007re','SDSS J211734.92-003126.3',0.2109,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150004,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20376','R',150004,39.79,0.13,750,71310,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007re','SDSS J211734.92-003126.3',0.2109,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150005,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007re',NULL,150005,39.46,0.1,780,71310,70,NULL,'SALT 2','SDSS J211734.92-003126.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150006,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2007re',NULL,150006,39.48,0.1,787,71310,70,NULL,'SALT 2, Malmquist cor.','SDSS J211734.92-003126.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150007,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17564','R',150007,40.49,0.09,999,71311,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007iz','SDSS J211735.50+001856.3',0.255,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,319.397917,0.31564,0.269,NULL,52084112519,813814258,12715847,NULL),(150008,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150008,34.32,0.49,73.2,71312,75,NULL,'IR','CGCG 471-003',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000033,NULL,'15.7',0.2,'Sa',NULL,NULL,NULL,NULL,1,319.400833,24.36556,0.421,NULL,55127740975,861370952,13458921,15.7),(150009,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150009,35.76,0.44,142,71313,NULL,NULL,'Malmquist cor.','ESO 287- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.6r',0.5,'SB(rs)c',NULL,NULL,NULL,NULL,1,319.406583333,-46.72469,0.129,NULL,51397852248,803091441,12548303,14.6),(150010,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150010,35.95,0.4,155,71313,NULL,NULL,NULL,'ESO 287- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150011,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150011,35.99,0.2,158,71313,74.4,NULL,NULL,'ESO 287- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150012,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16466','RN',150012,40.92,0.24,1290,71314,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16466',0.187801,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150013,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16466','RN',150013,40.99,0.17,1330,71314,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16466',0.187801,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150014,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150014,35.62,0.67,133,71315,70,NULL,NULL,'2MASX J21174247-8450426',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,319.426167,-84.84525,0.517,NULL,48385221344,756019083,11812798,16.6),(150015,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20823',NULL,150015,40.32,0.28,1160,71316,70,NULL,'SN photometric redshift distance, z photo =0.320 +/- 0.054','SDSS-II SN 20823',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.2g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,319.4275,0.54858,0.269,NULL,52084331128,813817673,12715901,22.2),(150016,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20823','R',150016,41.41,0.35,1320,71316,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20823',0.444252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150017,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15649','RN',150017,40.03,0.11,893,71317,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15649',0.134154,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150018,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15649','RN',150018,40.25,0.21,991,71317,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15649',0.134154,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150019,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01832','RN',150019,41.66,0.2,1480,71318,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01832',0.450293,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150020,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150020,34.32,0.49,73,71319,75,NULL,'IR','UGC 11715',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.58',0.2,'Scd?','Isolated galaxy',NULL,NULL,NULL,1,319.449833,13.59347,0.289,NULL,55278618243,863728410,13495756,15.58),(150021,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150021,36.62,0.61,211,71320,70,NULL,NULL,'2MASX J21175507-2246243',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.000103,NULL,'14.6r',0.35,'S',NULL,NULL,NULL,NULL,1,319.4795417,-22.77339,0.121,NULL,50918687786,795604496,12431320,14.6),(150022,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150022,34.96,0.8,98.3,71321,75,NULL,'MAT, I','ESO 530- G 034',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.21',0.5,'Sc             LINER',NULL,NULL,NULL,NULL,1,319.4957917,-22.83558,0.121,NULL,50918700397,795604693,12431323,14.21),(150023,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150023,34.36,0.43,74.4,71321,75,NULL,'MAT, I, raw','ESO 530- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150024,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150024,34.41,0.32,76.2,71321,85,NULL,'I, raw','ESO 530- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150025,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150025,34.47,0.32,78.3,71321,85,NULL,'I, inv','ESO 530- G 034',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150026,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150026,34.62,0.43,83.8,71321,75,NULL,'MAT, I, inv','ESO 530- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150027,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150027,34.88,0.52,94.6,71321,NULL,NULL,NULL,'ESO 530- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150028,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150028,34.89,0.43,94.9,71321,75,NULL,'MAT, I, cor','ESO 530- G 034',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150029,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150029,34.92,0.2,96.4,71321,74.4,NULL,NULL,'ESO 530- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150030,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150030,35.09,0.47,104,71321,NULL,NULL,'H','ESO 530- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150031,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150031,35.13,0.46,106,71321,NULL,NULL,'Malmquist cor.','ESO 530- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150032,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150032,35.17,0.4,108,71321,NULL,NULL,'mean','ESO 530- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150033,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150033,35.24,0.46,112,71321,NULL,NULL,'J','ESO 530- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150034,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150034,35.27,0.45,113,71321,NULL,NULL,'K','ESO 530- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150035,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150035,36.04,0.46,162,71322,70,NULL,NULL,'2MASX J21180087+0034150',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00016,NULL,'16.4g',0.35,'E0',NULL,NULL,NULL,NULL,1,319.503625,0.57086,0.265,NULL,52084189474,813815460,12715866,16.4),(150036,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10037','R',150036,40.48,0.27,994,71323,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J211801.05+010655.1',0.2537,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.01,NULL,'20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,319.504417,1.11533,0.261,NULL,52084855663,813825869,12716029,20.7),(150037,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10037','R',150037,40.58,0.29,1040,71323,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J211801.05+010655.1',0.2537,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150038,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10037',NULL,150038,40.31,0.2,1150,71323,70,NULL,'SALT 2','SDSS J211801.05+010655.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150039,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10037',NULL,150039,40.33,0.2,1160,71323,70,NULL,'SALT 2, Malmquist cor.','SDSS J211801.05+010655.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150040,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150040,36.52,0.76,202,71324,70,NULL,NULL,'2MASX J21180410-5143385',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'14.6r',0.33,'S',NULL,NULL,NULL,NULL,1,319.517125,-51.72733,0,NULL,50614671055,790854235,12357097,14.6),(150041,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150041,35.42,0.52,121,71325,70,NULL,NULL,'2MASX J21180548-2239503',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000077,NULL,'14.1r',0.53,'E',NULL,NULL,NULL,NULL,1,319.523,-22.66406,0.101,NULL,50918414379,795600224,12431253,14.1),(150042,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150042,33.59,0.8,52.1,71326,75,NULL,'MAT, I','ESO 287- G 004',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.4r',0.5,'SB(rs)b:',NULL,NULL,NULL,NULL,1,319.526333333,-46.30072,0.153,NULL,51397497448,803085897,12548217,13.4),(150043,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150043,33.12,0.32,42.1,71326,85,NULL,'I, raw','ESO 287- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150044,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150044,33.14,0.32,42.4,71326,85,NULL,'I, inv','ESO 287- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150045,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150045,33.31,0.43,45.9,71326,75,NULL,'MAT, I, raw','ESO 287- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150046,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150046,33.42,0.43,48.4,71326,75,NULL,'MAT, I, inv','ESO 287- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150047,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150047,33.7,0.43,54.8,71326,75,NULL,'MAT, I, cor','ESO 287- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150048,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 21323','RN',150048,42.64,0.19,2530,71327,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21323',0.33481,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150049,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 21323','RN',150049,43.04,0.23,3030,71327,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21323',0.33481,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150050,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20643','RN',150050,42.03,0.3,2000,71328,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20643',0.276022,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150051,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20643','RN',150051,42.42,0.3,2390,71328,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20643',0.276022,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150052,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150052,37.91,0.46,381,71329,70,NULL,NULL,'2MASX J21181082+0932069',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,319.545125,9.53517,0.273,NULL,55062328639,860348884,13442951,17.6),(150053,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12857','RN',150053,40.45,0.16,1100,71330,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12857',0.120869,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150054,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12857','RN',150054,40.62,0.26,1190,71330,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12857',0.120869,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150055,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20093','RN',150055,42.83,0.19,2240,71331,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20093',0.645019,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150056,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150056,35.42,0.58,121,71332,70,NULL,NULL,'2MASX J21181593-2356220',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000103,NULL,'14.6r',0.35,'S0',NULL,NULL,NULL,NULL,1,319.566417,-23.9395,0.121,NULL,50917564045,795586938,12431045,14.6),(150057,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150057,32.52,0.4,32,71333,75,NULL,'Edat, raw','ESO 235- G 085',NULL,'1997ApJS..109..333W',1997,1,0.88,NULL,'G',0.000103,NULL,'13.2r',0.65,'Sa?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.567458333,-48.53753,0.053,NULL,51343195354,802237427,12534959,13.2),(150058,'D-Sigma','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150058,32.7,0.4,34.7,71333,75,NULL,'Edat, cor','ESO 235- G 085',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150059,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17374','RN',150059,40.48,0.24,997,71334,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17374',0.252054,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150060,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 17374','RN',150060,40.51,0.18,1010,71334,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17374',0.252054,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150061,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02488','RN',150061,40.45,0.24,1050,71335,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02488',0.170996,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150062,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02488','RN',150062,41.37,0.27,1610,71335,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02488',0.170996,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150063,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150063,32.95,0.8,39,71336,75,NULL,'MAT, I','IC 5096',NULL,'1997ApJS..109..333W',1997,1,4.14,NULL,'G',0.000033,NULL,'13.30',0.56,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.58975,-63.76067,0.033,NULL,49169364499,768271320,12004239,13.3),(150064,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150064,32.95,0.47,38.8,71336,NULL,NULL,'H','IC 5096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150065,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150065,33.01,0.46,40,71336,NULL,NULL,'J','IC 5096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150066,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150066,33.05,0.45,40.8,71336,NULL,NULL,'K','IC 5096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150067,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150067,33.14,0.4,42.4,71336,NULL,NULL,'mean','IC 5096',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150068,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150068,33.29,0.49,45.4,71336,75,NULL,'IR','IC 5096',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150069,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150069,33.48,0.43,49.7,71336,75,NULL,'MAT, I, raw','IC 5096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150070,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150070,33.55,0.43,51.2,71336,75,NULL,'MAT, I, cor','IC 5096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150071,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150071,33.75,0.32,56.3,71336,85,NULL,'I, raw','IC 5096',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150072,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150072,33.82,0.43,58.1,71336,75,NULL,'MAT, I, inv','IC 5096',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150073,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150073,33.84,NULL,58.5,71336,NULL,NULL,NULL,'IC 5096',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150074,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150074,33.84,0.32,58.6,71336,85,NULL,'I, inv','IC 5096',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150075,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150075,33.97,NULL,62.3,71336,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150076,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150076,33.99,NULL,62.9,71336,NULL,NULL,'Dipole + Quadrupole','IC 5096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150077,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150077,34,NULL,63.1,71336,NULL,NULL,'Dipole','IC 5096',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150078,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150078,36.06,0.56,163,71337,70,NULL,NULL,'6dF J2118215-272053',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,319.58975,-27.34806,0.257,NULL,51438066071,803719782,12558121,13.6),(150079,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150079,37.4,0.46,302,71338,70,NULL,NULL,'2MASX J21182556+1146113',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,319.6065417,11.76986,0.233,NULL,55060880004,860326250,13442597,17.5),(150080,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150080,35.6,0.75,132,71339,70,NULL,NULL,'2MASX J21182700-6626498',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6r',0.57,'S0',NULL,NULL,NULL,NULL,1,319.6125,-66.44711,0,NULL,49388991423,771702990,12057859,14.6),(150081,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150081,33.33,0.45,46.4,71340,NULL,NULL,'K','NGC 7052',NULL,'2007A&A...465...71T',2007,1,2.5,'1995A&A...300..675H has V = 4159 +- 33 km/sec.','G',0.000027,NULL,'13.4',1.4,'E',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,319.637708333,26.44703,0.593,NULL,55615395048,868990547,13577977,13.4),(150082,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150082,33.77,0.4,56.7,71340,NULL,NULL,'mean','NGC 7052',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150083,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06884','RN',150083,44.37,0.22,5160,71341,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06884',0.451583,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150084,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150084,37.81,0.46,365,71342,70,NULL,NULL,'SDSS J211836.17-010831.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,319.650708333,-1.14219,0.157,NULL,49673093860,776142091,12127220,18),(150085,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14648','RN',150085,38.29,0.38,429,71343,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14648',0.061332,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150086,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14648','RN',150086,40.22,0.5,1040,71343,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14648',0.061332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150087,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006ky',NULL,150087,39.45,0.08,775,71344,70,NULL,'Hubble residual 0.17 for z0.18370','SDSS-II SN 15453 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,319.6684583,-1.02425,0.177,NULL,49672927615,776139493,12127179,NULL),(150088,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15453','R',150088,39.93,0.2,824,71344,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ky','SDSS-II SN 15453 HOST',0.175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150089,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15453','R',150089,40.06,0.09,874,71344,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ky','SDSS-II SN 15453 HOST',0.175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150090,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150090,35.55,0.6,129,71345,70,NULL,NULL,'ESO 287- G 006',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'14.2r',0.6,'SB(s)0/a:',NULL,NULL,NULL,NULL,1,319.6745,-45.00717,0.137,NULL,51366057354,802594646,12540541,14.2),(150091,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150091,36.75,0.46,223,71346,70,NULL,NULL,'2MASX J21184432-0703382',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,319.6845417,-7.06081,0.337,NULL,50772958620,793327478,12395741,18),(150092,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12858','RN',150092,40.67,0.63,1090,71347,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12858',0.251443,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150093,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150093,32.92,0.8,38.4,71348,75,NULL,'MAT, I','ESO 145- G 004',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000021,NULL,'13.4r',0.5,'SAB(s)bc:',NULL,NULL,NULL,NULL,1,319.7125,-57.64028,0.137,NULL,49133731381,767714552,11995539,13.4),(150094,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150094,33.18,0.32,43.2,71348,85,NULL,'I, raw','ESO 145- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150095,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150095,33.19,0.49,43.5,71348,75,NULL,'IR','ESO 145- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150096,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150096,33.2,0.32,43.7,71348,85,NULL,'I, inv','ESO 145- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150097,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150097,33.28,0.43,45.3,71348,75,NULL,'MAT, I, raw','ESO 145- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150098,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150098,33.41,0.43,48,71348,75,NULL,'MAT, I, inv','ESO 145- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150099,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150099,33.45,0.43,48.9,71348,75,NULL,'MAT, I, cor','ESO 145- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150100,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16410','R',150100,41.11,0.19,1290,71349,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16410 HOST',0.287998,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,'PHOT',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,319.715,0.64811,0.249,NULL,52081343276,813770988,12715171,NULL),(150101,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16410','R',150101,41.12,0.28,1300,71349,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16410 HOST',0.287998,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150102,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16410',NULL,150102,41.07,0.16,1640,71349,70,NULL,'SALT 2','SDSS-II SN 16410 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150103,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16410',NULL,150103,41.1,0.16,1660,71349,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16410 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150104,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150104,36.36,0.6,187,71350,70,NULL,NULL,'2MASX J21185287-5526436',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.9r',0.5,NULL,NULL,NULL,NULL,NULL,1,319.720333,-55.44544,0.157,NULL,48656762909,760261920,11879092,14.9),(150105,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150105,35.18,0.49,109,71351,75,NULL,'IR','UGC 11719',NULL,'2011yCatp016004901K',2011,1,1.4,NULL,'G',0.00001,NULL,'15.51',0.18,'Sb',NULL,NULL,NULL,NULL,1,319.7224583,15.68083,0.381,NULL,55271019822,863609684,13493901,15.51),(150106,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150106,35.35,0.4,118,71351,NULL,NULL,'mean','UGC 11719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150107,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150107,35.61,NULL,132,71351,NULL,NULL,'Dipole + Quadrupole','UGC 11719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150108,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150108,35.61,NULL,133,71351,NULL,NULL,'Dipole','UGC 11719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150109,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150109,35.61,NULL,133,71351,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11719',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150110,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150110,35.62,0.47,133,71351,NULL,NULL,'H','UGC 11719',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150111,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150111,35.82,NULL,146,71351,NULL,NULL,NULL,'UGC 11719',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150112,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150112,35.97,0.43,156,71351,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11719',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150113,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20434','RN',150113,41.11,0.24,1300,71352,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20434',0.280855,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150114,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20434','RN',150114,41.37,0.37,1470,71352,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20434',0.280855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150115,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20434','N',150115,41.17,0.23,1710,71352,70,NULL,'SALT 2','SDSS-II SN 20434',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150116,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 20434','N',150116,41.2,0.23,1740,71352,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20434',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150117,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150117,30.96,0.43,15.6,71353,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 471-006',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000033,NULL,'15.05',0.3,'S?',NULL,NULL,NULL,NULL,1,319.745375,25.43106,0.401,NULL,55614434959,868975546,13577742,15.05),(150118,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14791','RN',150118,42.09,0.22,2200,71354,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14791',0.18672,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150119,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14791','RN',150119,42.33,0.3,2470,71354,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14791',0.18672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150120,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150120,32.38,0.22,29.9,71355,NULL,NULL,'I','NGC 7049',NULL,'2001ApJ...546..681T',2001,1,4.3,NULL,'G',0.00002,NULL,'11.72',3,'SA(s)0^0^','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.75125,-48.56217,0.029,NULL,51343172546,802237071,12534954,11.72),(150121,'SBF','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150121,32.38,0.14,29.9,71355,74.4,NULL,NULL,'NGC 7049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150122,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150122,31.25,0.63,17.8,71355,95,NULL,'Michard 1979b, c','NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150123,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150123,31.33,0.46,18.5,71355,95,NULL,'Michard 1979a','NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150124,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150124,31.65,0.37,21.4,71355,95,NULL,'Weighted Mean','NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150125,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150125,32.02,NULL,25.4,71355,NULL,NULL,'LEDA [April 2006]','NGC 7049',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150126,'Faber-Jackson','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150126,34.59,0.81,82.8,71355,55,NULL,'Visvanathan & Sandage 1979','NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150127,'Tertiary','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150127,31.55,0.71,20.4,71355,95,NULL,NULL,'NGC 7049',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150128,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150128,32.2,0.8,27.6,71355,75,NULL,'B','NGC 7049',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150129,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150129,31.99,0.45,25,71355,NULL,NULL,'K','NGC 7049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150130,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150130,32.41,0.4,30.3,71355,NULL,NULL,'mean','NGC 7049',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150131,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150131,38.38,0.46,475,71356,70,NULL,NULL,'2MASX J21190096-0727159',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00009,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,319.754083,-7.4545,0.341,NULL,50772746262,793324160,12395690,18.7),(150132,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 07337','RN',150132,42.42,0.55,2320,71357,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07337',0.31105,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150133,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150133,36.06,0.59,163,71358,70,NULL,NULL,'2MASX J21190674-2141546',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.3r',0.24,NULL,NULL,NULL,NULL,NULL,1,319.778125,-21.69867,0.097,NULL,50913633823,795525528,12430086,15.3),(150134,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15483',NULL,150134,40.44,0.2,1220,71359,70,NULL,'SALT 2','SDSS-II SN 15483',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,319.7919583,0.69697,0.241,NULL,52081461163,813772830,12715200,NULL),(150135,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15483',NULL,150135,40.47,0.21,1240,71359,70,NULL,'SN photometric redshift distance, z photo =0.348 +/- 0.044','SDSS-II SN 15483',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150136,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15483',NULL,150136,40.48,0.2,1250,71359,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15483',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150137,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150137,35.99,0.5,158,71360,70,NULL,NULL,'2MASX J21191534-7114599',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'14.2r',0.55,'SAB0^-:',NULL,NULL,NULL,NULL,1,319.814167,-71.25006,0.137,NULL,49326083822,770720059,12042500,14.2),(150138,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150138,37.58,0.46,327,71361,70,NULL,NULL,'2MASX J21191557+1004144',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000189,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,319.8147917,10.07064,0.177,NULL,55062641080,860353766,13443027,16.7),(150139,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 10039','RN',150139,38.47,0.53,435,71362,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10039',0.134302,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150140,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150140,35.43,0.5,122,71363,70,NULL,NULL,'2MASX J21191866-0614409',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000091,NULL,'15.7g',0.26,'Sa',NULL,NULL,NULL,NULL,1,319.827833,-6.24478,0.333,NULL,49685880682,776341885,12130341,15.7),(150141,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150141,38.05,0.33,407,71364,70,NULL,NULL,'2MASX J21192459-0557344',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000089,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,319.852333,-5.95944,0.245,NULL,49719408246,776865753,12138527,17.6),(150142,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150142,35.32,0.53,116,71365,70,NULL,NULL,'2MASX J21192590-0645304',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000087,NULL,'16.0g',0.26,'S0/a',NULL,NULL,NULL,NULL,1,319.8580417,-6.75842,0.377,NULL,49685806972,776340733,12130323,16),(150143,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16712','RN',150143,40.83,1.44,1270,71366,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16712',0.153624,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150144,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150144,33.78,0.49,56.9,71367,75,NULL,'IR','UGC 11721',NULL,'2011yCatp016004901K',2011,1,1.52,'The UZC position applies to a superposed star.','G',0.000013,NULL,'15.19',0.17,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,319.8615417,14.05742,0.313,NULL,55280033578,863750524,13496101,15.19),(150145,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150145,34.02,NULL,63.8,71367,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150146,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150146,34.05,NULL,64.5,71367,NULL,NULL,'Dipole + Quadrupole','UGC 11721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150147,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150147,34.05,NULL,64.5,71367,NULL,NULL,'Dipole','UGC 11721',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150148,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150148,36.8,0.46,229,71368,70,NULL,NULL,'2MASX J21193055+0941256',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,319.877125,9.6905,0.225,NULL,55060395095,860318673,13442479,17.2),(150149,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150149,34.49,0.59,79.1,71369,70,NULL,NULL,'2MASX J21193434-5522028',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.20',0.25,NULL,NULL,NULL,NULL,NULL,1,319.8932083,-55.36742,0.145,NULL,48656802555,760262539,11879102,16.2),(150150,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16291','RN',150150,41.91,0.96,2200,71370,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16291',0.094864,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150151,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150151,37.95,0.46,390,71371,70,NULL,NULL,'2MASX J21193464-0022003',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000163,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,319.894417,-0.36667,0.177,NULL,49669883574,776091930,12126436,17),(150152,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150152,38.05,0.33,407,71372,70,NULL,NULL,'2MASX J21193603-0551303',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,319.9,-5.85839,0.245,NULL,49720237997,776878718,12138729,18.2),(150153,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150153,35.09,0.56,104,71373,70,NULL,NULL,'ESO 107- G 020',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'14.3r',0.6,'(R_1R\'_2)SAB(r)0/a',NULL,NULL,NULL,NULL,1,319.909333,-67.05361,0.045,NULL,49385743479,771652241,12057066,14.3),(150154,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150154,33.73,0.47,55.7,71374,NULL,NULL,'H','UGC 11722',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000023,NULL,'15.01',0.5,'S?',NULL,NULL,NULL,NULL,1,319.909583,21.972,0.605,NULL,55126287196,861348237,13458566,15.01),(150155,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150155,33.84,0.46,58.6,71374,NULL,NULL,'J','UGC 11722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150156,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150156,33.91,0.45,60.5,71374,NULL,NULL,'K','UGC 11722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150157,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150157,34.06,0.4,64.8,71374,NULL,NULL,'mean','UGC 11722',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150158,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150158,37.3,0.46,288,71375,70,NULL,NULL,'2MASX J21193890-0003173',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000136,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,319.912125,-0.05481,0.237,NULL,49669867067,776091672,12126432,17.5),(150159,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01804','RN',150159,42.57,0.21,2100,71376,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01804',0.552948,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150160,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150160,34.9,0.41,95.4,71377,NULL,NULL,NULL,'ESO 599- G 007',NULL,'2009ApJS..182..474S',2009,1,1.4,'Position in 1997AJ....113.1548C refers to a superposed star.','G',0.000033,NULL,'15.60',0.6,'Sb:',NULL,NULL,NULL,NULL,1,319.9447917,-22.19678,0.097,NULL,50914942152,795545971,12430405,15.6),(150161,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150161,34.94,0.2,97.3,71377,74.4,NULL,NULL,'ESO 599- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150162,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150162,35.31,0.34,115,71377,NULL,NULL,'Malmquist cor.','ESO 599- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150163,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150163,35.9,0.64,151,71378,70,NULL,NULL,'2MASX J21194750-6847438',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'14.9r',0.36,NULL,NULL,NULL,NULL,NULL,1,319.9480417,-68.79544,0.049,NULL,49386103211,771657862,12057154,14.9),(150164,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150164,32.06,0.45,25.8,71379,NULL,NULL,'K','NGC 7051',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000012,NULL,'12.9B',1.1,'SB(r)a pec     HII',NULL,NULL,NULL,NULL,1,319.963875,-8.78294,0.269,NULL,50774846799,793356981,12396202,12.9),(150165,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150165,32.07,0.47,26,71379,NULL,NULL,'H','NGC 7051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150166,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150166,32.19,0.46,27.4,71379,NULL,NULL,'J','NGC 7051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150167,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150167,32.41,0.4,30.3,71379,NULL,NULL,'mean','NGC 7051',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150168,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150168,36.27,0.66,179,71380,70,NULL,NULL,'2MASX J21195170-5131082',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.1r',0.32,'S0',NULL,NULL,NULL,NULL,1,319.965375,-51.51894,0,NULL,50614751439,790855491,12357117,15.1),(150169,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150169,36.44,0.63,194,71381,70,NULL,NULL,'2MASX J21195280-4741220',NULL,'2014MNRAS.445.2677S',2014,1,0.13,NULL,'G',0.00015,NULL,'15.4r',0.1,NULL,NULL,NULL,NULL,NULL,1,319.970041667,-47.68947,0.077,NULL,51343449606,802241400,12535021,15.4),(150170,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150170,35.7,0.54,138,71382,70,NULL,NULL,'2MASX J21195306-3046199',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000103,NULL,'14.6r',0.31,NULL,NULL,NULL,NULL,NULL,1,319.971083333,-30.77228,0.273,NULL,51427020303,803547192,12555424,14.6),(150171,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150171,35.53,0.66,128,71383,70,NULL,NULL,'2MASX J21195697-4327161',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14.6r',0.23,'S',NULL,NULL,NULL,NULL,1,319.9872917,-43.45453,0.077,NULL,51368101853,802626591,12541040,14.6),(150172,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150172,37,0.46,252,71384,70,NULL,NULL,'2MASX J21195790-0638082',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00009,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,319.991333333,-6.63575,0.329,NULL,49686690072,776354532,12130539,17.7),(150173,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150173,34.63,0.53,84.3,71385,70,NULL,NULL,'2MASX J21200028-0507466',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.8I',0.3,NULL,NULL,NULL,NULL,NULL,1,320.00125,-5.12956,0.205,NULL,49719962350,776874411,12138662,13.8),(150174,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150174,36.7,0.53,218,71386,70,NULL,NULL,'2MASX J21200263-4759452',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'14.8r',0.23,'S',NULL,NULL,NULL,NULL,1,320.011125,-47.996,0.077,NULL,51343463511,802241617,12535025,14.8),(150175,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150175,37.32,0.57,291,71387,70,NULL,NULL,'2MASX J21200298-6924152',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.6r',0.43,'S0',NULL,NULL,NULL,NULL,1,320.01225,-69.40436,0.113,NULL,49333244118,770831939,12044249,14.6),(150176,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467',NULL,150176,39.42,0.08,767,71388,70,NULL,'Hubble residual -0.11 for z0.21043','SDSS-II SN 15467 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.00009,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,320.020125,-0.17736,0.213,NULL,49669874325,776091786,12126434,NULL),(150177,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467','R',150177,40.06,0.19,851,71388,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS-II SN 15467 HOST',0.21043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150178,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467','R',150178,40.12,0.1,873,71388,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS-II SN 15467 HOST',0.21043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150179,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467',NULL,150179,39.92,0.08,964,71388,70,NULL,'SALT 2','SDSS-II SN 15467 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150180,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15467',NULL,150180,39.94,0.08,973,71388,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15467 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150181,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150181,36.37,0.57,188,71389,70,NULL,NULL,'2MASX J21200543-1950039',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000127,NULL,'14.3r',0.52,'S',NULL,NULL,NULL,NULL,1,320.022417,-19.83461,0.109,NULL,50911079225,795485612,12429462,14.3),(150182,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02056','RN',150182,41.42,0.39,1620,71390,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02056',0.189482,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150183,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006cm',NULL,150183,33.93,0.21,60.1,71391,74.2,NULL,'SALT 2','UGC 11723',0.016341,'2010ApJ...716..712A',2010,1,1.9,NULL,'G',0.000017,NULL,'13.7B',0.3,'Sb             HII?','Isolated galaxy',NULL,NULL,NULL,1,320.072833,-1.68433,0.169,NULL,49671328457,776114507,12126789,13.7),(150184,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006cm',NULL,150184,34.26,0.03,70,71391,72,NULL,'Malmquist cor.','UGC 11723',0.016341,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150185,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2006cm',NULL,150185,34.52,0.09,80.2,71391,74.4,NULL,NULL,'UGC 11723',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150186,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150186,33.83,0.45,58.3,71391,NULL,NULL,'K','UGC 11723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150187,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150187,33.87,0.47,59.6,71391,NULL,NULL,'H','UGC 11723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150188,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150188,34.04,0.4,64.2,71391,NULL,NULL,'mean','UGC 11723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150189,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150189,34.07,0.46,65.2,71391,NULL,NULL,'J','UGC 11723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150190,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150190,34.25,0.49,70.7,71391,75,NULL,'IR','UGC 11723',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150191,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150191,34.52,0.09,80.2,71391,74.4,NULL,NULL,'UGC 11723',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150192,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150192,34.52,0.4,80.2,71391,75,NULL,'HOSTS SN 2006cm','UGC 11723',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150193,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150193,34.63,0.41,84.5,71391,NULL,NULL,'Malmquist cor.','UGC 11723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150194,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150194,34.69,0.4,86.5,71391,NULL,NULL,NULL,'UGC 11723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150195,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150195,36.49,0.46,199,71392,70,NULL,NULL,'2MASX J21202044-0821021',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000084,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,320.085125,-8.35053,0.241,NULL,50774487643,793351369,12396115,16.7),(150196,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150196,35.43,0.49,122,71393,75,NULL,'IR','MCG -02-54-005',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000043,NULL,'15',0.3,'Sc: sp         HII',NULL,NULL,NULL,NULL,1,320.0975,-13.17131,0.185,NULL,50953862264,796154097,12439907,15),(150197,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150197,35.64,0.42,134,71393,NULL,NULL,'Malmquist cor.','MCG -02-54-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150198,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150198,35.93,0.37,154,71393,NULL,NULL,NULL,'MCG -02-54-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150199,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150199,35.97,0.2,156,71393,74.4,NULL,NULL,'MCG -02-54-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150200,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150200,36.35,0.68,186,71394,70,NULL,NULL,'2MASX J21202848-2010123',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.3r',0.33,NULL,NULL,NULL,NULL,NULL,1,320.118708333,-20.17008,0.081,NULL,50911210308,795487661,12429494,15.3),(150201,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 05208','RN',150201,43.23,0.23,3000,71395,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05208',0.474463,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150202,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150202,34.67,0.49,85.9,71396,75,NULL,'IR','UGC 11726',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00003,NULL,'15.15',0.4,'Sbc',NULL,NULL,NULL,NULL,1,320.12525,37.58422,NULL,NULL,55817590867,872149857,13627341,15.15),(150203,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150203,35.05,0.47,102,71396,NULL,NULL,'H','UGC 11726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150204,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150204,35.15,0.45,107,71396,NULL,NULL,'K','UGC 11726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150205,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150205,35.17,0.4,108,71396,NULL,NULL,'mean','UGC 11726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150206,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150206,35.22,0.46,111,71396,NULL,NULL,'J','UGC 11726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150207,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150207,35.58,0.53,131,71397,70,NULL,NULL,'MCG -07-43-038',NULL,'2014MNRAS.445.2677S',2014,1,0.15,NULL,'G',0.0001,NULL,'15.5',0.15,'E',NULL,NULL,NULL,NULL,1,320.129833,-43.44817,0.077,NULL,51368112529,802626758,12541043,15.5),(150208,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150208,37.18,0.46,272,71398,70,NULL,NULL,'2MASX J21203355+1058013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,320.139875,10.96706,0.269,NULL,55061274602,860332415,13442693,17.3),(150209,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02041','RN',150209,40.2,0.28,906,71399,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02041',0.209821,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150210,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02041','RN',150210,40.44,0.21,1010,71399,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02041',0.209821,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150211,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150211,33.93,0.2,61.1,71400,74.4,NULL,NULL,'UGC 11724',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00013,NULL,'15.02',0.3,'SBcd:',NULL,NULL,NULL,NULL,1,320.159333,1.04719,0.189,NULL,52081195189,813768674,12715135,15.02),(150212,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150212,33.99,0.47,62.9,71400,NULL,NULL,'Malmquist cor.','UGC 11724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150213,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150213,33.99,0.47,62.9,71400,NULL,NULL,NULL,'UGC 11724',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150214,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16590',NULL,150214,39.61,1.32,834,71401,70,NULL,'SN photometric redshift distance, z photo =0.218 +/- 0.235','SDSS-II SN 16590',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.6g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,320.17475,0.69611,0.241,NULL,52081622094,813775345,12715239,20.6),(150215,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16590','R',150215,40.9,0.27,1160,71401,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16590',0.30637,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150216,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16590',NULL,150216,40.73,0.24,1400,71401,70,NULL,'SALT 2','SDSS-II SN 16590',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150217,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 16590',NULL,150217,40.76,0.24,1420,71401,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16590',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150218,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150218,37.19,0.83,274,71402,70,NULL,NULL,'2MASX J21204245-5300479',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.2r',0.33,'S',NULL,NULL,NULL,NULL,1,320.176917,-53.01328,0.037,NULL,50615348705,790864823,12357262,15.2),(150219,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150219,32.59,0.3,32.5,71403,74.2,NULL,'SALT 2','2MASX J21204248+4423590',0.01299,'2010ApJ...716..712A',2010,1,2,NULL,'G',0.00014,NULL,'11.1B',NULL,'Sb',NULL,NULL,NULL,NULL,1,320.177,44.39975,NULL,NULL,55672400424,869881256,13591894,11.1),(150220,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150220,33.16,0.09,42.9,71403,74.4,NULL,NULL,'2MASX J21204248+4423590',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150221,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150221,33.46,0.29,48.6,71403,65,NULL,'SALT2','2MASX J21204248+4423590',0.01299,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150222,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150222,33.5,0.23,49.4,71403,70,NULL,'SALT 2','2MASX J21204248+4423590',0.01299,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150223,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150223,33.73,0.27,55,71403,65,NULL,'MLCS31','2MASX J21204248+4423590',0.01299,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150224,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001fh',NULL,150224,33.78,0.28,56.2,71403,65,NULL,'MLCS17','2MASX J21204248+4423590',0.01299,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150225,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150225,37.55,0.46,323,71404,70,NULL,NULL,'2MASX J21204534-0612307',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,320.188875,-6.20869,0.285,NULL,49686327876,776348873,12130451,17.6),(150226,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150226,35.64,0.51,134,71405,70,NULL,NULL,'MCG -05-50-014',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.2,'S0',NULL,NULL,NULL,NULL,1,320.218041667,-30.57481,0.221,NULL,51430215975,803597124,12556205,15.5),(150227,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150227,37.46,0.46,311,71406,70,NULL,NULL,'2MASX J21205356-0643596',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000088,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,320.223375,-6.73319,0.381,NULL,49686737627,776355275,12130551,18.4),(150228,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150228,35.1,0.62,105,71407,70,NULL,NULL,'2MASX J21205646-7245515',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.4b',0.14,NULL,NULL,NULL,NULL,NULL,1,320.235375,-72.76431,0.133,NULL,49294955602,770233681,12034901,16.4),(150229,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2001dl',NULL,150229,35.17,0.17,106,71408,70,NULL,'SALT 2','UGC 11725',0.020694,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',0.000017,NULL,'15.14',0.4,'Sdm:',NULL,NULL,NULL,NULL,1,320.257333,9.1775,0.189,NULL,55055883763,860248183,13441377,15.14),(150230,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150230,34.33,0.49,73.6,71408,75,NULL,'IR','UGC 11725',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150231,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150231,35.17,0.6,108,71409,70,NULL,NULL,'ESO 047-IG 029 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'16.1b',0.25,NULL,NULL,NULL,NULL,NULL,1,320.266,-72.76881,0.133,NULL,49294962872,770233794,12034903,16.1),(150232,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 08917','RN',150232,41.34,0.21,1590,71410,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08917',0.16167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150233,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 08917','RN',150233,42,0.24,2170,71410,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08917',0.16167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150234,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150234,35.62,0.55,133,71411,70,NULL,NULL,'2MASX J21210936-6006549',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'14.4r',0.42,'S',NULL,NULL,NULL,NULL,1,320.2889583,-60.11533,0.069,NULL,49181722776,768464418,12007256,14.4),(150235,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13730','RN',150235,40.25,0.4,892,71412,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13730',0.256496,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150236,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13730','RN',150236,41.13,0.46,1340,71412,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13730',0.256496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150237,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150237,34.1,0.2,66.1,71413,74.4,NULL,NULL,'UGC 11729',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'16.5',0.3,'SBcd:',NULL,NULL,NULL,NULL,1,320.31125,25.02889,0.385,NULL,55122746273,861292910,13457701,16.5),(150238,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150238,34.22,0.43,69.9,71413,NULL,NULL,'Malmquist cor.','UGC 11729',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150239,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150239,34.27,0.42,71.4,71413,NULL,NULL,NULL,'UGC 11729',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150240,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11119','RN',150240,40.54,0.3,1150,71414,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 11119',0.115319,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150241,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 11119','RN',150241,40.99,0.27,1420,71414,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 11119',0.115319,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150242,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150242,32.61,0.8,33.3,71415,75,NULL,'MAT, I','ESO 287- G 009',NULL,'1997ApJS..109..333W',1997,1,1.52,NULL,'G',0.000031,NULL,'13.7r',0.32,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,320.317917,-46.15278,0.033,NULL,51364085664,802563838,12540059,13.7),(150243,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150243,32.05,0.39,25.7,71415,73,NULL,'IR','ESO 287- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150244,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150244,32.05,0.4,25.7,71415,75,NULL,NULL,'ESO 287- G 009',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150245,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150245,32.33,0.39,29.2,71415,73,NULL,'opt','ESO 287- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150246,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150246,32.6,0.4,33.1,71415,NULL,NULL,NULL,'ESO 287- G 009',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150247,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150247,32.63,0.49,33.5,71415,75,NULL,'IR','ESO 287- G 009',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150248,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150248,32.71,0.32,34.9,71415,85,NULL,'I, raw','ESO 287- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150249,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150249,32.71,0.32,34.9,71415,85,NULL,'I, inv','ESO 287- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150250,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150250,32.91,0.43,38.2,71415,75,NULL,'MAT, I, raw','ESO 287- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150251,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150251,32.97,0.43,39.3,71415,75,NULL,'MAT, I, inv','ESO 287- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150252,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150252,33.15,0.43,42.7,71415,75,NULL,'MAT, I, cor','ESO 287- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150253,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150253,33.47,NULL,49.5,71415,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 287- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150254,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150254,33.48,NULL,49.7,71415,NULL,NULL,'Dipole + Quadrupole','ESO 287- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150255,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150255,33.5,NULL,50.1,71415,NULL,NULL,'Dipole','ESO 287- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150256,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150256,33.93,NULL,61.1,71415,NULL,NULL,NULL,'ESO 287- G 009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150257,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15830','RN',150257,39.56,0.25,717,71416,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15830',0.139221,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150258,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15830','RN',150258,39.74,0.28,778,71416,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15830',0.139221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150259,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150259,36.5,0.55,199,71417,70,NULL,NULL,'2MASX J21212394-5253324',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000133,NULL,'13.9r',0.67,'S0',NULL,NULL,NULL,NULL,1,320.349833333,-52.89228,0.037,NULL,50615343378,790864740,12357261,13.9),(150260,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150260,34.79,0.55,90.6,71418,NULL,NULL,NULL,'ESO 530- G 037',NULL,'2009ApJS..182..474S',2009,1,1.4,'Da Costa, et al. (1998,AJ,116,1) give v = 7260 +/- 52 km/sec.','G',0.000033,NULL,'14.3r',0.8,'Sb',NULL,NULL,NULL,NULL,1,320.35525,-24.37161,0.117,NULL,50909230973,795456733,12429011,14.3),(150261,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150261,34.83,0.2,92.5,71418,74.4,NULL,NULL,'ESO 530- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150262,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150262,35.05,0.49,102,71418,NULL,NULL,'Malmquist cor.','ESO 530- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150263,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150263,37.55,0.46,323,71419,70,NULL,NULL,'2MASX J21212928+0933512',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000151,NULL,'17.4g',0.26,NULL,NULL,NULL,NULL,NULL,1,320.372041667,9.56436,0.137,NULL,55060571920,860321436,13442522,17.4),(150264,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150264,33.98,0.49,62.4,71420,75,NULL,'IR','IC 5104',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000017,NULL,'14.27',0.4,'SBab?','Isolated galaxy',NULL,NULL,NULL,1,320.371875,21.24197,0.441,NULL,55119245325,861238208,13456847,14.27),(150265,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150265,34.01,0.2,63.4,71420,74.4,NULL,NULL,'IC 5104',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150266,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150266,34.03,0.43,64,71420,75,NULL,'3.6 micron, color corrected','IC 5104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150267,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150267,34.11,0.43,66.2,71420,75,NULL,'3.6 micron, color + selection bias corrected','IC 5104',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150268,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150268,34.13,0.4,66.9,71420,NULL,NULL,'mean','IC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150269,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150269,34.3,0.47,72.4,71420,NULL,NULL,'H','IC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150270,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150270,34.35,0.46,74.1,71420,NULL,NULL,'J','IC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150271,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150271,34.35,0.45,74.1,71420,NULL,NULL,'K','IC 5104',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150272,'CMD','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150272,16.1,NULL,0.0166,71421,NULL,NULL,NULL,'Segue 3',NULL,'2010ApJ...712L.103B',2010,1,NULL,'May be a MW globular cluster. See 2011AJ....142...88F.','G',NULL,NULL,NULL,NULL,'Poss. galactic',NULL,NULL,NULL,NULL,1,320.379167,19.11722,0.349,1,55146906481,861670413,13463600,NULL),(150273,'CMD','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150273,16.14,0.09,0.0169,71421,NULL,NULL,NULL,'Segue 3',NULL,'2011AJ....142...88F',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150274,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150274,37.45,0.46,309,71422,70,NULL,NULL,'2MASX J21213259+0933202',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000182,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,320.385958333,9.55561,0.137,NULL,55060573772,860321465,13442522,16.8),(150275,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02057','R',150275,39.95,0.21,805,71423,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02057',0.211587,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,320.3997083,-0.31708,0.169,NULL,49669172196,776080815,12126262,NULL),(150276,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 02057','R',150276,40.01,0.16,830,71423,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02057',0.211587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150277,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150277,36.95,0.2,245,71424,74.4,NULL,NULL,'CGCG 426-043',NULL,'2013AJ....146...86T',2013,1,0.86,NULL,'G',0.000098,NULL,'15.6g',0.42,'Sm','Isolated galaxy',NULL,NULL,NULL,1,320.401625,11.30067,0.277,NULL,55047611013,860118922,13439358,15.6),(150278,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150278,35.73,0.51,140,71425,70,NULL,NULL,'2MASX J21213661-7118141',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6r',0.32,'S',NULL,NULL,NULL,NULL,1,320.402667,-71.30392,0.145,NULL,49326128351,770720755,12042511,14.6),(150279,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06479','R',150279,40.12,0.2,856,71426,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J212137.75+003500.9',0.234,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,320.4072917,0.58361,0.173,NULL,52080743628,813761619,12715025,20.9),(150280,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06479','R',150280,40.38,0.13,967,71426,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J212137.75+003500.9',0.234,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150281,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06479',NULL,150281,39.98,0.1,991,71426,70,NULL,'SALT 2','SDSS J212137.75+003500.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150282,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 06479',NULL,150282,39.99,0.1,995,71426,70,NULL,'SALT 2, Malmquist cor.','SDSS J212137.75+003500.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150283,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fc',NULL,150283,40.42,0.22,936,71427,74.2,NULL,'SALT 2','SDSS J212139.08+005342.7',0.297,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',NULL,NULL,'20.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,320.412875,0.89519,0.189,NULL,52081074134,813766783,12715105,20.5),(150284,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fc',NULL,150284,41.03,0.24,1240,71427,70,NULL,'SALT 2','SDSS J212139.08+005342.7',0.297,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150285,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01119','R',150285,41.22,0.36,1360,71427,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fc','SDSS J212139.08+005342.7',0.29,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150286,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01119','R',150286,41.34,0.21,1440,71427,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fc','SDSS J212139.08+005342.7',0.29,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150287,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fc',NULL,150287,41.1,0.22,1660,71427,70,NULL,'SALT 2','SDSS J212139.08+005342.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150288,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SN 2005fc',NULL,150288,41.13,0.22,1680,71427,70,NULL,'SALT 2, Malmquist cor.','SDSS J212139.08+005342.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150289,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150289,34.13,0.8,67.1,71428,75,NULL,'MAT, I','IC 5100',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000007,NULL,'14.57',0.4,'SBc?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,320.431083,-65.93336,0.013,NULL,49347144706,771049136,12047642,14.57),(150290,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150290,34.22,0.32,69.8,71428,85,NULL,'I, raw','IC 5100',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150291,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150291,34.25,0.43,70.9,71428,75,NULL,'MAT, I, raw','IC 5100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150292,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150292,34.25,0.32,70.9,71428,85,NULL,'I, inv','IC 5100',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150293,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150293,34.42,0.43,76.6,71428,75,NULL,'MAT, I, inv','IC 5100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150294,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150294,34.65,0.43,84.9,71428,75,NULL,'MAT, I, cor','IC 5100',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150295,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150295,34.81,0.61,91.8,71428,NULL,NULL,NULL,'IC 5100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150296,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150296,34.85,0.2,93.3,71428,74.4,NULL,NULL,'IC 5100',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150297,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150297,34.93,0.58,97,71428,NULL,NULL,'Malmquist cor.','IC 5100',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150298,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150298,36.67,0.46,216,71429,70,NULL,NULL,'2MASX J21214661-0009382',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,320.444167,-0.16072,0.169,NULL,49669001203,776078143,12126220,16.5),(150299,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150299,34.64,0.46,84.8,71430,70,NULL,NULL,'CGCG 426-044',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000117,NULL,'14.7g',0.63,'E0',NULL,NULL,NULL,NULL,1,320.4535,10.65608,0.201,NULL,55059941154,860311580,13442368,14.7),(150300,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592',NULL,150300,34.85,5.77,93.2,71431,70,NULL,'SN photometric redshift distance, z photo =0.022 +/- 0.356','SDSS-II SN 15592',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,320.467333,-1.1785,0.177,NULL,49715563110,776805673,12137588,NULL),(150301,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592','R',150301,41.59,0.25,1470,71431,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15592',0.415635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150302,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592','R',150302,41.9,0.25,1700,71431,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15592',0.415635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150303,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592',NULL,150303,41.45,0.16,1950,71431,70,NULL,'SALT 2','SDSS-II SN 15592',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150304,'SNIa','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 15592',NULL,150304,41.52,0.16,2010,71431,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15592',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150305,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19908','RN',150305,40.12,0.2,855,71432,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19908',0.235551,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150306,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 19908','RN',150306,40.34,0.12,947,71432,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19908',0.235551,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150307,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150307,35.97,0.5,156,71433,70,NULL,NULL,'2MASX J21215489-5555365',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000073,NULL,'14.0r',0.68,'S0',NULL,NULL,NULL,NULL,1,320.478833333,-55.92683,0.205,NULL,48669683098,760463798,11882246,14),(150308,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 14441','RN',150308,43.35,0.25,2980,71434,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14441',0.570644,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150309,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150309,36.71,0.46,220,71435,70,NULL,NULL,'2MASX J21220247+1137470',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,320.510417,11.62964,0.269,NULL,55048108814,860126700,13439479,17.7),(150310,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12578','RN',150310,39.03,0.68,563,71436,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12578',0.135043,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150311,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 12578','RN',150311,39.12,0.48,586,71436,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12578',0.135043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150312,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150312,33.51,0.49,50.4,71437,75,NULL,'IR','NGC 7056',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000023,NULL,'13.75',0.9,'SBb','Isolated galaxy',NULL,NULL,NULL,1,320.5315,18.66567,0.341,NULL,55138467619,861538556,13461539,13.75),(150313,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150313,36.25,0.49,178,71438,70,NULL,NULL,'2MASX J21221500-0925578',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000047,NULL,'15.62',0.43,NULL,NULL,NULL,NULL,NULL,1,320.562416667,-9.43269,0.237,NULL,50783508747,793492324,12398317,15.62),(150314,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150314,35.82,0.46,146,71439,70,NULL,NULL,'2MASX J21221501-0747228',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000069,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,320.5625417,-7.78964,0.421,NULL,49687302806,776364106,12130689,17.1),(150315,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13845','RN',150315,42.86,0.22,2620,71440,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13845',0.423313,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150316,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 13845','RN',150316,42.99,0.18,2780,71440,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13845',0.423313,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150317,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150317,37.91,0.46,382,71441,70,NULL,NULL,'2MASX J21221899+0035368',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,320.579208333,0.59367,0.173,NULL,52135389078,814615454,12728366,17.3),(150318,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150318,36.87,0.8,237,71442,70,NULL,NULL,'2MASX J21222044-5026445',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.00015,NULL,'14.8r',0.38,'S',NULL,NULL,NULL,NULL,1,320.585125,-50.44564,0,NULL,50609875811,790779309,12355926,14.8),(150319,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150319,37.17,0.46,271,71443,70,NULL,NULL,'2MASX J21222214-0020442',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000141,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,320.592375,-0.34547,0.173,NULL,49715104987,776798515,12137476,17.2),(150320,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150320,37.2,0.6,275,71444,70,NULL,NULL,'2MASX J21222292-5600143',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.22',0.38,'S0',NULL,NULL,NULL,NULL,1,320.603417,-56.00681,0.141,NULL,48669675360,760463677,11882244,16.22),(150321,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150321,35.97,0.65,156,71445,70,NULL,NULL,'2MASX J21222931-4511550',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000133,NULL,'14.5r',0.47,'E',NULL,NULL,NULL,NULL,1,320.6222917,-45.19864,0.073,NULL,51367066565,802610415,12540787,14.5),(150322,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150322,37.04,0.46,256,71446,70,NULL,NULL,'2MASX J21223060+0946295',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000145,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,320.627417,9.77506,0.173,NULL,55060644041,860322563,13442540,17.1),(150323,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150323,35.93,0.61,154,71447,70,NULL,NULL,'2MASX J21223094-4952544',NULL,'2014MNRAS.445.2677S',2014,1,1,'The APMUKS image includes a superposed star.','G',0.00015,NULL,'14.8r',0.5,'S0',NULL,NULL,NULL,NULL,1,320.629,-49.88183,0,NULL,50612261227,790816581,12356509,14.8),(150324,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150324,32.9,0.4,38.1,71448,NULL,NULL,'mean','ESO 402- G 026',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000027,NULL,'13.69',0.8,'(R\'_1)SAB(r)b',NULL,NULL,NULL,NULL,1,320.6307917,-36.68156,0.177,NULL,51488526995,804508234,12570441,13.69),(150325,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150325,33.52,0.47,50.6,71448,NULL,NULL,'H','ESO 402- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150326,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150326,33.52,0.45,50.6,71448,NULL,NULL,'K','ESO 402- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150327,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150327,33.64,0.46,53.3,71448,NULL,NULL,'J','ESO 402- G 026',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150328,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150328,35.46,0.55,123,71449,70,NULL,NULL,'2MASX J21223806-1928273',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.7r',0.48,'E',NULL,NULL,NULL,NULL,1,320.658625,-19.47439,0.137,NULL,50919853314,795622708,12431604,14.7),(150329,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150329,37.33,0.71,292,71450,70,NULL,NULL,'AM 2119-503',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'18.8b',0.3,'INTERACTING',NULL,NULL,NULL,NULL,1,320.661541667,-50.44383,0,NULL,50609911033,790779859,12355935,18.8),(150330,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150330,36.91,0.54,241,71451,70,NULL,NULL,'2MASX J21224573-2136573',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'15.2r',0.3,NULL,NULL,NULL,NULL,NULL,1,320.6904583,-21.61606,0.105,NULL,50913462195,795522846,12430044,15.2),(150331,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150331,36.1,0.59,166,71452,70,NULL,NULL,'2MASX J21224850-2204563',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'15.0r',0.38,NULL,NULL,NULL,NULL,NULL,1,320.7022917,-22.08244,0.093,NULL,50915579144,795555924,12430561,15),(150332,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150332,37.76,0.46,356,71453,70,NULL,NULL,'SDSS J212250.16-060942.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00009,NULL,'19.0g',0.11,NULL,NULL,NULL,NULL,NULL,1,320.709041667,-6.16181,0.297,NULL,49686264379,776347880,12130435,19),(150333,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150333,36.09,0.74,165,71454,70,NULL,NULL,'2MASX J21225062-4945499',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'14.6r',0.48,'(R_1)SB(r)0^+',NULL,NULL,NULL,NULL,1,320.710875,-49.76381,0,NULL,50612258130,790816533,12356508,14.6),(150334,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150334,36.3,0.46,182,71455,70,NULL,NULL,'2MASX J21225161+1124347',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,320.715125,11.40964,0.269,NULL,55047484569,860116946,13439327,17.5),(150335,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150335,37.79,0.46,361,71456,70,NULL,NULL,'SDSS J212252.36-011456.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000131,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,320.718167,-1.24911,0.153,NULL,49715553319,776805520,12137586,18.1),(150336,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150336,35.25,0.55,112,71457,70,NULL,NULL,'ESO 599- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.8r',0.2,'Sa:',NULL,NULL,NULL,NULL,1,320.723917,-19.89725,0.097,NULL,50919350911,795614857,12431482,14.8),(150337,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150337,37.5,0.46,316,71458,70,NULL,NULL,'2MASX J21225537+1030537',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,320.730583,10.51481,0.201,NULL,55048694594,860135853,13439622,17.3),(150338,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01627','RN',150338,42.7,0.44,2590,71459,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01627',0.338934,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150339,'SNIa SDSS','2016-12-15 15:15:54','2016-12-16 11:21:09','1','SDSS-II SN 01627','RN',150339,43.19,0.43,3240,71459,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01627',0.338934,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150340,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150340,36.77,0.6,226,71460,70,NULL,NULL,'2MASX J21225650-4818509',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.1r',0.52,'S0',NULL,NULL,NULL,NULL,1,320.7354583,-48.31414,0.049,NULL,51343327473,802239491,12534992,15.1),(150341,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150341,35.25,0.46,112,71461,70,NULL,NULL,'CGCG 375-032',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000157,NULL,'15.4g',0.44,'E0',NULL,NULL,NULL,NULL,1,320.744541667,1.02672,0.165,NULL,52136093571,814626462,12728538,15.4),(150342,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150342,37.38,0.46,299,71462,70,NULL,NULL,'SDSS J212304.21+100257.8',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,320.767583,10.04939,0.153,NULL,55060125079,860314454,13442413,18.1),(150343,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150343,35.55,0.59,129,71463,70,NULL,NULL,'2MASX J21230457-7120293',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'14.7r',0.33,'S',NULL,NULL,NULL,NULL,1,320.769167,-71.34158,0.129,NULL,49326101389,770720334,12042505,14.7),(150344,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150344,35.77,0.47,143,71464,70,NULL,NULL,'AM 2119-475 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000133,NULL,'15.51',0.53,'INTERACTING',NULL,NULL,NULL,NULL,1,320.7765417,-47.65478,0.061,NULL,51342722596,802230040,12534844,15.51),(150345,'FP','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150345,36.49,0.53,198,71465,70,NULL,NULL,'2MASX J21231300-1936242',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.7r',0.48,'E',NULL,NULL,NULL,NULL,1,320.804083333,-19.60658,0.097,NULL,50919209937,795612655,12431447,14.7),(150346,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150346,32.62,0.8,33.3,71466,75,NULL,'HMCL, I','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,1,3.2,'The APM position is on a bright knot 17 arcsec southeast of the nucleus.','G',0.000017,NULL,'12.2r',0.9,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,320.8080417,-45.77311,0.037,NULL,51364154070,802564907,12540076,12.2),(150347,'IRAS','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150347,32.62,0.8,33.4,71466,75,NULL,'MAT, I','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150348,'Tully est','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150348,32.64,0.8,33.7,71466,75,NULL,'B','ESO 287- G 013',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150349,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150349,32.21,0.39,27.7,71466,73,NULL,'IR','ESO 287- G 013',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150350,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,'R',150350,32.21,0.4,27.7,71466,75,NULL,NULL,'ESO 287- G 013',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150351,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150351,32.34,0.4,29.4,71466,73,NULL,'opt','ESO 287- G 013',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150352,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150352,32.43,0.32,30.6,71466,85,NULL,'I, raw','ESO 287- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150353,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150353,32.45,0.43,30.9,71466,75,NULL,'MAT, I, raw','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150354,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150354,32.47,0.32,31.2,71466,85,NULL,'I, inv','ESO 287- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150355,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150355,32.47,0.4,31.2,71466,NULL,NULL,NULL,'ESO 287- G 013',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150356,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150356,32.48,0.4,31.4,71466,75,NULL,'HMCL, I, raw','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150357,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150357,32.64,0.43,33.7,71466,75,NULL,'MAT, I, cor','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150358,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150358,32.64,0.4,33.7,71466,75,NULL,'HMCL, I, inv','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150359,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150359,32.64,0.4,33.7,71466,75,NULL,'HMCL, I, cor','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150360,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150360,32.65,0.43,33.8,71466,75,NULL,'MAT, I, inv','ESO 287- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150361,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150361,32.68,0.46,34.3,71466,NULL,NULL,'J','ESO 287- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150362,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150362,32.71,0.47,34.8,71466,NULL,NULL,'H','ESO 287- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150363,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150363,32.72,0.4,34.9,71466,NULL,NULL,'mean','ESO 287- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150364,'Tully-Fisher','2016-12-15 15:15:54','2016-12-16 11:21:09','1',NULL,NULL,150364,32.74,0.45,35.3,71466,NULL,NULL,'K','ESO 287- G 013',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150365,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150365,32.8,0.44,36.3,71466,NULL,NULL,'Malmquist cor.','ESO 287- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150366,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150366,32.81,0.2,36.5,71466,74.4,NULL,NULL,'ESO 287- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150367,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150367,32.81,0.49,36.5,71466,75,NULL,'IR','ESO 287- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150368,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150368,32.86,0.43,37.3,71466,NULL,NULL,NULL,'ESO 287- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150369,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 18857','RN',150369,42.94,0.22,2740,71467,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 18857',0.413696,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150370,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 18857','RN',150370,42.96,0.2,2770,71467,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 18857',0.413696,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150371,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 07636',NULL,150371,40.91,0.23,1520,71468,70,NULL,'SN photometric redshift distance, z photo =0.449 +/- 0.067','SDSS-II SN 07636',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,320.855083333,0.11878,0.205,NULL,52101707667,814089182,12720143,NULL),(150372,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 06509','RN',150372,38.72,0.23,524,71469,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06509',0.058196,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150373,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 14001','RN',150373,41.84,0.18,2020,71470,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14001',0.15501,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150374,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 14001','RN',150374,42.24,0.22,2430,71470,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14001',0.15501,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150375,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 16481',NULL,150375,40.15,0.27,1070,71471,70,NULL,'SN photometric redshift distance, z photo =0.292 +/- 0.047','SDSS-II SN 16481',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.2g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,320.8815417,0.98503,0.165,NULL,52136244117,814628814,12728575,20.2),(150376,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150376,38.71,0.11,493,71472,69.7,NULL,'Fiducial','GRB 060614',0.12,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,320.883917,-53.02669,0.017,NULL,50615541769,790867840,12357310,NULL),(150377,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150377,42.26,0.88,2530,71472,69.7,NULL,'Fiducial','GRB 060614',0.12,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150378,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 13435','RN',150378,40.74,0.15,1320,71473,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13435',0.063034,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150379,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 13435','RN',150379,41.44,0.26,1830,71473,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13435',0.063034,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150380,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150380,34.63,0.69,84.5,71474,100,NULL,'mid-IR','ARK 546',NULL,'2013ApJ...771...88L',2013,1,0.5,NULL,'G',0.000033,NULL,'15.0',0.3,NULL,NULL,NULL,NULL,NULL,1,320.889083333,17.58386,0.217,NULL,55138813665,861543963,13461624,15),(150381,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150381,35.35,0.4,117,71474,NULL,NULL,'mean','ARK 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150382,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150382,35.38,0.47,119,71474,NULL,NULL,'H','ARK 546',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150383,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150383,36.04,0.63,162,71475,70,NULL,NULL,'2MASX J21233395-4947109',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'15.3r',0.18,NULL,NULL,NULL,NULL,NULL,1,320.891583333,-49.78631,0,NULL,50612234913,790816170,12356502,15.3),(150384,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 13399','RN',150384,42.72,0.2,2330,71476,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13399',0.503181,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150385,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150385,34.73,0.5,88.5,71477,70,NULL,NULL,'MCG -01-54-014',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000087,NULL,'16',0.2,NULL,NULL,NULL,NULL,NULL,1,320.915333,-5.43381,0.205,NULL,49720984767,776890386,12138912,16),(150386,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150386,34.62,0.49,83.9,71478,75,NULL,'IR','FGC 2323',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000019,NULL,'16.9',0.1,'Sd',NULL,NULL,NULL,NULL,1,320.924375,19.12906,0.301,NULL,55147709421,861682959,13463796,16.9),(150387,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150387,34.72,0.43,88,71478,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2323',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150388,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150388,35.02,NULL,101,71478,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2323',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150389,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150389,35.05,NULL,102,71478,NULL,NULL,'Dipole + Quadrupole','FGC 2323',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150390,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150390,35.05,NULL,102,71478,NULL,NULL,'Dipole','FGC 2323',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150391,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150391,35.31,NULL,115,71478,NULL,NULL,NULL,'FGC 2323',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150392,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150392,37.67,0.46,342,71479,70,NULL,NULL,'2MASX J21234237-0047056',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000152,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,320.926667,-0.78492,0.137,NULL,49715963789,776811934,12137686,17.1),(150393,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150393,36.41,0.16,181,71480,74.2,NULL,'SALT 2','SDSS J212342.94-005036.5',0.06,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,320.928916667,-0.84347,0.137,NULL,49715969535,776812023,12137687,NULL),(150394,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150394,37.03,0.15,240,71480,65,NULL,'SALT','SDSS J212342.94-005036.5',0.06,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150395,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150395,37.05,0.03,243,71480,70,NULL,'SALT 2','SDSS J212342.94-005036.5',0.06,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150396,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150396,37.17,0.15,256,71480,70,NULL,'SALT 2','SDSS J212342.94-005036.5',0.06,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150397,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 16314','R',150397,37.17,0.18,256,71480,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oa','SDSS J212342.94-005036.5',0.06,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150398,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150398,37.17,0.15,257,71480,73.8,NULL,'SALT 2 (SNANA)','SDSS J212342.94-005036.5',0.0585,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150399,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150399,37.2,0.03,260,71480,72,NULL,'SALT','SDSS J212342.94-005036.5',0.06,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150400,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa','R',150400,37.13,0.07,267,71480,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J212342.94-005036.5',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150401,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150401,37.26,0.17,267,71480,65,NULL,'SALT2','SDSS J212342.94-005036.5',0.06,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150402,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150402,37.26,0.14,267,71480,65,NULL,'MLCS17','SDSS J212342.94-005036.5',0.06,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150403,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa','R',150403,37.16,0.07,270,71480,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J212342.94-005036.5',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150404,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 16314','R',150404,37.34,0.06,277,71480,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oa','SDSS J212342.94-005036.5',0.06,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150405,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SN 2006oa',NULL,150405,37.34,0.15,278,71480,65,NULL,'MLCS31','SDSS J212342.94-005036.5',0.06,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150406,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150406,34.65,0.69,85,71481,100,NULL,'mid-IR','CGCG 449-022',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000033,NULL,'15.0',0.3,NULL,NULL,NULL,NULL,NULL,1,320.958875,17.57117,0.217,NULL,55138684453,861541944,13461592,15),(150407,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150407,36.04,0.55,162,71482,70,NULL,NULL,'2MASX J21235442-1105128',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.84',0.24,NULL,NULL,NULL,NULL,NULL,1,320.976583,-11.087,0.185,NULL,50771238670,793300604,12395321,16.84),(150408,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 20613','R',150408,41.07,0.2,1190,71483,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20613',0.375039,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.6g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,320.987083,-0.56283,0.173,NULL,49715244335,776800692,12137510,21.6),(150409,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 20613',NULL,150409,40.53,1.07,1270,71483,70,NULL,'SN photometric redshift distance, z photo =0.359 +/- 0.341','SDSS-II SN 20613',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150410,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 20613','R',150410,41.51,0.29,1460,71483,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20613',0.375039,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150411,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 03437','RN',150411,39.88,0.23,829,71484,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03437',0.140038,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150412,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 03437','RN',150412,39.91,0.11,840,71484,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03437',0.140038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150413,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150413,37.07,0.46,259,71485,70,NULL,NULL,'2MASX J21235929-0703078',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000106,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,320.997,-7.05208,0.329,NULL,49689875529,776404305,12131317,16.5),(150414,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150414,36.11,0.33,167,71486,70,NULL,NULL,'2MASX J21235975+0115111',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000172,NULL,'15.7g',0.41,'E0',NULL,NULL,NULL,NULL,1,320.999041667,1.25294,0.173,NULL,52136023259,814625363,12728521,15.7),(150415,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15396','RN',150415,38.06,0.19,386,71487,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15396',0.061925,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150416,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15396','RN',150416,39.69,0.27,815,71487,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15396',0.061925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150417,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150417,36.21,0.46,174,71488,70,NULL,NULL,'2MASX J21240375-0829517',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000079,NULL,'16.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,321.01575,-8.49775,0.257,NULL,50774215406,793347115,12396048,16.2),(150418,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150418,36.11,0.33,167,71489,70,NULL,NULL,'2MASX J21241467+0113366',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000177,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,321.061167,1.22675,0.173,NULL,52136032434,814625506,12728523,16.2),(150419,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150419,37.24,0.46,280,71490,70,NULL,NULL,'SDSS J212419.29-011346.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,321.080375,-1.22947,0.153,NULL,49715774614,776808978,12137640,17.7),(150420,'Faber-Jackson','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150420,32.41,0.65,30.3,71491,95,NULL,'Weighted Mean','IC 5105',NULL,'1984ApJS...56...91D',1984,1,2.6,NULL,'G',0.000043,NULL,'12.62',1.6,'E+','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,321.091708333,-40.53772,0.061,NULL,51356126804,802439481,12538116,12.62),(150421,'Faber-Jackson','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150421,33.96,0.81,61.9,71491,55,NULL,'Visvanathan & Sandage 1979','IC 5105',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150422,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150422,33.77,0.45,56.9,71491,NULL,NULL,'K','IC 5105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150423,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150423,34.33,0.4,73.5,71491,NULL,NULL,'mean','IC 5105',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150424,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150424,36.49,0.46,199,71492,70,NULL,NULL,'2MASX J21242340+0034586',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000126,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,321.097375,0.58297,0.141,NULL,52101781199,814090331,12720161,17.6),(150425,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150425,35.74,0.62,140,71493,70,NULL,NULL,'2MASX J21242596-1131109',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000067,NULL,'16.61',0.31,NULL,NULL,NULL,NULL,NULL,1,321.108166667,-11.51983,0.189,NULL,50771398061,793303094,12395360,16.61),(150426,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150426,35.07,0.47,103,71494,70,NULL,NULL,'ESO 236- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'RC3 gives v = 10,600 +/- 190 km/sec.','G',0.000083,NULL,'13.8r',1.1,'(R_1R\'_2)SB(s)b',NULL,NULL,NULL,NULL,1,321.109625,-49.28022,0,NULL,50612334498,790817726,12356526,13.8),(150427,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553',NULL,150427,40.19,0.2,1090,71495,70,NULL,'SN photometric redshift distance, z photo =0.297 +/- 0.034','SDSS-II SN 15553',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.120125,0.94417,0.165,NULL,52136173764,814627715,12728558,NULL),(150428,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553','R',150428,41.18,0.21,1290,71495,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15553',0.335192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150429,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553','R',150429,41.27,0.28,1340,71495,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15553',0.335192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150430,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553',NULL,150430,41.48,0.17,1980,71495,70,NULL,'SALT 2','SDSS-II SN 15553',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150431,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 15553',NULL,150431,41.52,0.17,2010,71495,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15553',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150432,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 06885','RN',150432,38.63,0.43,507,71496,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06885',0.049457,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150433,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150433,35.77,0.34,142,71497,NULL,NULL,'Malmquist cor.','ESO 342- G 040',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.6r',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,321.14525,-37.40028,0.169,NULL,51488294666,804504604,12570384,14.6),(150434,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150434,35.97,0.31,156,71497,NULL,NULL,NULL,'ESO 342- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150435,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150435,36.01,0.2,159,71497,74.4,NULL,NULL,'ESO 342- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150436,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150436,36.83,0.86,233,71498,70,NULL,NULL,'2MASX J21243550-1930093',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'15.3r',0.37,NULL,NULL,NULL,NULL,NULL,1,321.147875,-19.50264,0.125,NULL,50919639426,795619366,12431552,15.3),(150437,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,'R',150437,38.42,0.46,483,71499,70,NULL,NULL,'2MASX J21243636-0819429',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000099,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,321.1515,-8.32861,0.257,NULL,49687686259,776370097,12130782,18),(150438,'FP','2016-12-15 15:15:55','2016-12-16 11:21:09','1',NULL,NULL,150438,35.77,0.63,143,71500,70,NULL,NULL,'2MASX J21243856-2007013',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.1r',0.2,'S',NULL,NULL,NULL,NULL,1,321.1607083,-20.117,0.121,NULL,50922759023,795668109,12432314,15.1),(150439,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 17908','RN',150439,40.52,0.25,1030,71501,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17908',0.233889,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150440,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 17908','N',150440,40.4,0.16,1200,71501,70,NULL,'SALT 2','SDSS-II SN 17908',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150441,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 17908','RN',150441,40.87,0.22,1210,71501,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17908',0.233889,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150442,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 17908','N',150442,40.41,0.16,1210,71501,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17908',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150443,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:09','1','SDSS-II SN 02483','RN',150443,41.47,0.3,1680,71502,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02483',0.173699,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150444,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15669',NULL,150444,40.92,0.49,1530,71503,70,NULL,'SN photometric redshift distance, z photo =0.453 +/- 0.167','SDSS-II SN 15669',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.2040417,0.39083,0.141,NULL,52101810449,814090788,12720168,NULL),(150445,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150445,36.42,0.73,192,71504,70,NULL,NULL,'2MASX J21245057-5923577',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.1r',0.36,NULL,NULL,NULL,NULL,NULL,1,321.210875,-59.39933,0.073,NULL,49178306066,768411032,12006422,15.1),(150446,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005iy',NULL,150446,41.2,0.21,1240,71505,74.2,NULL,'SALT 2','SDSS J212451.96+002303.3',0.404,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',0.0005,NULL,'21.2g',0.04,NULL,NULL,NULL,NULL,NULL,1,321.2165417,0.38425,0.141,NULL,52101808670,814090760,12720168,21.2),(150447,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005iy',NULL,150447,40.96,0.22,1550,71505,70,NULL,'Hubble residual 0.22 for z0.40430','SDSS J212451.96+002303.3',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150448,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005iy',NULL,150448,42,0.26,1790,71505,70,NULL,'SALT 2','SDSS J212451.96+002303.3',0.404,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150449,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06777','R',150449,42.02,0.3,1810,71505,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iy','SDSS J212451.96+002303.3',0.4043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150450,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06777','R',150450,42.19,0.38,1950,71505,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iy','SDSS J212451.96+002303.3',0.4043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150451,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07258','R',150451,40.92,0.16,1220,71506,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J212455.14-005955.3',0.2546,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.0005,NULL,'20.2g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,321.2297917,-0.99869,0.137,NULL,49715736956,776808389,12137631,20.2),(150452,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07258','R',150452,41.14,0.25,1350,71506,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J212455.14-005955.3',0.2546,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150453,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07258',NULL,150453,40.84,0.13,1470,71506,70,NULL,'SALT 2','SDSS J212455.14-005955.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150454,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07258',NULL,150454,40.86,0.13,1490,71506,70,NULL,'SALT 2, Malmquist cor.','SDSS J212455.14-005955.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150455,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150455,33.96,0.47,62.1,71507,70,NULL,NULL,'NGC 7057',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00005,NULL,'12.60',1,'E','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,321.244583,-42.46044,0.081,NULL,51371655633,802682119,12541908,12.6),(150456,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150456,36.06,0.52,163,71508,70,NULL,NULL,'2MASX J21250052-1848013',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000073,NULL,'14.9r',0.43,'S0',NULL,NULL,NULL,NULL,1,321.2522083,-18.80044,0.125,NULL,50919617835,795619028,12431547,14.9),(150457,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20541','RN',150457,41.99,0.25,1880,71509,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20541',0.333022,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150458,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20541','RN',150458,42.58,0.28,2460,71509,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20541',0.333022,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150459,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21496','RN',150459,43.57,0.33,3260,71510,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21496',0.588037,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150460,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150460,34.63,0.54,84.4,71511,NULL,NULL,'Malmquist cor.','ESO 342- G 041',NULL,'2009ApJS..182..474S',2009,1,0.93,NULL,'G',0.000033,NULL,'17.7b',0.52,'S...',NULL,NULL,NULL,NULL,1,321.260541667,-39.82275,0.061,NULL,51474844599,804294446,12567100,17.7),(150461,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150461,34.69,0.53,86.7,71511,NULL,NULL,NULL,'ESO 342- G 041',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150462,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150462,34.73,0.2,88.3,71511,74.4,NULL,NULL,'ESO 342- G 041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150463,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12841','R',150463,40.83,0.32,1130,71512,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gk','SN 2006gk',0.293488,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,321.34725,-1.03367,0.137,NULL,49715714841,776808044,12137625,NULL),(150464,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12841','R',150464,41.1,0.31,1280,71512,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gk','SN 2006gk',0.293488,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150465,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150465,40.61,0.2,975,71513,74.2,NULL,'SALT 2','SDSS J212525.50+001931.5',0.3587,'2010ApJ...716..712A',2010,1,NULL,NULL,'*',NULL,NULL,'22.6g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,321.356291667,0.32542,0.141,NULL,52102605553,814103211,12720362,22.6),(150466,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150466,40.55,0.23,1290,71513,70,NULL,'Hubble residual 0.02 for z0.35870','SDSS J212525.50+001931.5',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150467,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688','R',150467,41.35,0.26,1370,71513,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SDSS J212525.50+001931.5',0.359161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150468,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150468,41.38,0.26,1390,71513,65,NULL,'SALT2','SDSS J212525.50+001931.5',0.3587,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150469,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688','R',150469,41.4,0.32,1400,71513,70,NULL,'SDSS CAND. SNIa; SALT 2','SDSS J212525.50+001931.5',0.359161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150470,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150470,41.53,0.24,1490,71513,70,NULL,'SALT 2','SDSS J212525.50+001931.5',0.3587,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150471,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150471,41.67,0.18,1590,71513,65,NULL,'MLCS2k2','SDSS J212525.50+001931.5',0.3587,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150472,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150472,41.3,0.21,1820,71513,70,NULL,'SALT 2','SDSS J212525.50+001931.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150473,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01688',NULL,150473,41.35,0.21,1860,71513,70,NULL,'SALT 2, Malmquist cor.','SDSS J212525.50+001931.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150474,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14455',NULL,150474,38.5,0.56,502,71514,70,NULL,'SN photometric redshift distance, z photo =0.125 +/- 0.040','SDSS-II SN 14455',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.3627083,0.85133,0.125,NULL,52102294258,814098347,12720286,NULL),(150475,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150475,36.76,0.46,225,71515,70,NULL,NULL,'2MASX J21252868+0944237',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,321.369417,9.74003,0.129,NULL,55048294885,860129607,13439525,17),(150476,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150476,36.62,0.69,211,71516,70,NULL,NULL,'2MASX J21252881-4236597',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.8r',0.42,'E',NULL,NULL,NULL,NULL,1,321.369958333,-42.61661,0.077,NULL,51371666841,802682294,12541910,14.8),(150477,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150477,34.01,0.8,63.5,71517,75,NULL,'MAT, I','IC 5105A',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000027,NULL,'13.47',1.4,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,321.37825,-40.27414,0.061,NULL,51356334780,802442730,12538167,13.47),(150478,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150478,33.21,0.32,43.9,71517,85,NULL,'I, raw','IC 5105A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150479,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150479,33.25,0.32,44.7,71517,85,NULL,'I, inv','IC 5105A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150480,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150480,33.36,0.43,46.9,71517,75,NULL,'MAT, I, raw','IC 5105A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150481,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150481,33.48,NULL,49.7,71517,NULL,NULL,'I','IC 5105A',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150482,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150482,33.56,0.43,51.5,71517,75,NULL,'MAT, I, inv','IC 5105A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150483,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150483,33.57,NULL,51.7,71517,NULL,NULL,'B','IC 5105A',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150484,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150484,33.73,0.43,55.6,71517,75,NULL,'MAT, I, cor','IC 5105A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150485,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150485,33.86,0.47,59.1,71517,NULL,NULL,'H','IC 5105A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150486,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150486,33.92,0.46,60.8,71517,NULL,NULL,'J','IC 5105A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150487,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150487,33.96,0.45,61.9,71517,NULL,NULL,'K','IC 5105A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150488,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150488,34.15,0.4,67.6,71517,NULL,NULL,'mean','IC 5105A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150489,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150489,35.66,0.54,135,71518,70,NULL,NULL,'ESO 287- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.23,NULL,'G',0.00015,NULL,'14.2r',0.32,'(R)SB0^+',NULL,NULL,NULL,NULL,1,321.387,-42.69569,0.069,NULL,51371698826,802682794,12541918,14.2),(150490,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150490,37.5,0.46,316,71519,70,NULL,NULL,'2MASX J21253358-0114080',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000133,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,321.3900417,-1.23553,0.185,NULL,49715852849,776810200,12137659,17.4),(150491,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15670','RN',150491,45.03,0.29,7890,71520,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15670',0.284422,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150492,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15670','RN',150492,45.94,0.32,12000,71520,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15670',0.284422,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150493,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17539','RN',150493,41.33,0.19,1530,71521,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17539',0.205939,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150494,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17539','RN',150494,42.05,0.24,2130,71521,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17539',0.205939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150495,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150495,37.05,0.46,258,71522,70,NULL,NULL,'2MASX J21254204+1112598',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,321.425167,11.21653,0.253,NULL,55050184057,860159125,13439986,17.1),(150496,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150496,36.21,NULL,175,71523,NULL,NULL,NULL,'ESO 342- G 044',NULL,'2000BSAO...50....5K',2000,1,1.14,NULL,'G',0.00004,'?','17.01',0.11,'Scd',NULL,NULL,NULL,NULL,1,321.437917,-40.12444,0.061,NULL,51474694561,804292102,12567064,17.01),(150497,'Magnitude','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150497,36.68,0.13,217,71524,100,NULL,NULL,'SARS 320.67665-34.94768',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'G',0.000157,NULL,'15.48',NULL,'E',NULL,NULL,NULL,NULL,1,321.439375,-34.73122,0.169,NULL,51480138260,804377160,12568393,15.48),(150498,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150498,35.58,0.2,131,71525,74.4,NULL,NULL,'ESO 402- G 028',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000027,NULL,'13.8r',0.5,'SB(r)a',NULL,NULL,NULL,NULL,1,321.440958333,-34.07725,0.217,NULL,51447643494,803869429,12560459,13.8),(150499,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150499,35.62,0.39,133,71525,NULL,NULL,NULL,'ESO 402- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150500,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150500,35.64,0.38,134,71525,NULL,NULL,'Malmquist cor.','ESO 402- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150501,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150501,35.24,0.5,112,71526,70,NULL,NULL,'2MASX J21254656-5452136',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'14.3r',0.43,'S0',NULL,NULL,NULL,NULL,1,321.4440417,-54.87044,0.113,NULL,48667799130,760434361,11881786,14.3),(150502,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560',NULL,150502,40,0.62,1000,71527,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.110','SDSS-II SN 06560',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.446541667,0.84972,0.125,NULL,52102263501,814097867,12720279,NULL),(150503,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560',NULL,150503,40.12,0.28,1060,71527,70,NULL,NULL,'SDSS-II SN 06560',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150504,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560','R',150504,40.83,0.21,1150,71527,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06560',0.273265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150505,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560',NULL,150505,40.67,0.18,1360,71527,70,NULL,'SALT 2','SDSS-II SN 06560',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150506,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560',NULL,150506,40.7,0.18,1380,71527,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06560',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150507,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06560','R',150507,41.23,0.24,1390,71527,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06560',0.273265,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150508,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150508,35.83,0.6,147,71528,70,NULL,NULL,'2MASX J21255348-0951455',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'16.09',0.45,NULL,NULL,NULL,NULL,NULL,1,321.47275,-9.86264,0.197,NULL,50769000628,793265634,12394775,16.09),(150509,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150509,33.44,0.48,48.7,71529,70,NULL,NULL,'NGC 7060',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00008,NULL,'13.74',0.9,'(R\'_1)SB(rs)ab LLAGN','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,321.47325,-42.41128,0.085,NULL,51370960112,802671251,12541738,13.74),(150510,'Magnitude','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150510,36.68,0.13,217,71530,100,NULL,NULL,'ABELL 3764',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM];RI [A]',NULL,NULL,NULL,NULL,1,321.479583,-34.72444,0.169,NULL,51479077873,804360591,12568134,NULL),(150511,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150511,35.81,0.53,145,71531,70,NULL,NULL,'MCG -02-54-008',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.0001,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,321.4889583,-9.03206,0.161,NULL,49686783265,776355988,12130562,15.5),(150512,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046',NULL,150512,39.77,0.32,901,71532,70,NULL,'SN photometric redshift distance, z photo =0.238 +/- 0.044','SDSS-II SN 20046',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.493167,0.80122,0.125,NULL,52102254442,814097725,12720276,NULL),(150513,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046','R',150513,40.75,0.22,1120,71532,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20046',0.263952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150514,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046','R',150514,40.75,0.14,1120,71532,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20046',0.263952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150515,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046',NULL,150515,40.66,0.12,1360,71532,70,NULL,'SALT 2','SDSS-II SN 20046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150516,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20046',NULL,150516,40.69,0.12,1370,71532,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150517,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150517,33.37,0.43,47.1,71533,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-54-016',NULL,'2014MNRAS.444..527S',2014,1,1.51,NULL,'G',0.00001,NULL,'15',0.13,'Sdm',NULL,NULL,NULL,NULL,1,321.49925,-3.80989,0.161,NULL,49726973032,776983953,12140374,15),(150518,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150518,32.21,0.8,27.6,71534,75,NULL,'MAT, I','IC 5105B',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.000027,NULL,'13.71',0.39,'SB(rs)ab:',NULL,NULL,NULL,NULL,1,321.501083333,-40.83478,0.073,NULL,51356178344,802440286,12538129,13.71),(150519,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150519,31.14,0.32,16.9,71534,85,NULL,'I, inv','IC 5105B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150520,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150520,31.16,0.32,17.1,71534,85,NULL,'I, raw','IC 5105B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150521,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150521,31.73,0.4,22.2,71534,NULL,NULL,NULL,'IC 5105B',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150522,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150522,31.73,0.39,22.2,71534,73,NULL,'opt','IC 5105B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150523,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150523,31.79,0.43,22.8,71534,75,NULL,'MAT, I, raw','IC 5105B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150524,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150524,31.82,0.43,23.1,71534,75,NULL,'MAT, I, inv','IC 5105B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150525,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150525,31.93,0.47,24.3,71534,NULL,NULL,'H','IC 5105B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150526,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150526,32.01,0.45,25.3,71534,NULL,NULL,'K','IC 5105B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150527,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150527,32.02,0.46,25.4,71534,NULL,NULL,'J','IC 5105B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150528,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150528,32.15,0.43,26.9,71534,75,NULL,'MAT, I, cor','IC 5105B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150529,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150529,32.2,0.09,27.6,71534,NULL,NULL,NULL,'IC 5105B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150530,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150530,32.35,0.4,29.5,71534,NULL,NULL,'mean','IC 5105B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150531,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739',NULL,150531,39.17,0.58,681,71535,70,NULL,'SN photometric redshift distance, z photo =0.174 +/- 0.061','SDSS-II SN 16739',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.0g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,321.50875,-1.05314,0.185,NULL,49698797116,776543704,12133495,22),(150532,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739','R',150532,40.9,0.22,1190,71535,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16739',0.265638,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150533,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739','R',150533,40.96,0.12,1230,71535,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16739',0.265638,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150534,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739',NULL,150534,40.78,0.11,1430,71535,70,NULL,'SALT 2','SDSS-II SN 16739',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150535,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16739',NULL,150535,40.81,0.11,1450,71535,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16739',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150536,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19045','RN',150536,41.64,0.18,1950,71536,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 19045',0.09247,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150537,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19045','RN',150537,42.01,0.3,2310,71536,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19045',0.09247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150538,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150538,37.51,0.21,318,71537,70,NULL,NULL,'2MASX J21260500-0715345',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000103,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,321.520875,-7.25958,0.305,NULL,49688971372,776390177,12131096,17.2),(150539,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150539,37.51,0.21,318,71538,70,NULL,NULL,'2MASX J21260641-0713265',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000096,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,321.526833333,-7.22389,0.305,NULL,49688972514,776390195,12131096,17.3),(150540,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150540,34.54,0.49,81,71539,75,NULL,'IR','UGC 11740',NULL,'2011yCatp016004901K',2011,1,1.5,NULL,'G',0.00012,NULL,'14.49',0.5,'S?',NULL,NULL,NULL,NULL,1,321.559833333,9.79792,0.161,NULL,55048355597,860130556,13439539,14.49),(150541,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150541,34.58,0.2,82.4,71539,74.4,NULL,NULL,'UGC 11740',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150542,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150542,34.58,0.4,82.5,71539,NULL,NULL,'Malmquist cor.','UGC 11740',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150543,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150543,34.63,0.39,84.2,71539,NULL,NULL,NULL,'UGC 11740',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150544,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150544,37.51,0.21,318,71540,70,NULL,NULL,'2MASX J21261566-0656269',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,321.5652083,-6.94083,0.289,NULL,49688516003,776383062,12130985,17.5),(150545,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01595','R',150545,39.84,0.2,765,71541,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01595',0.2136,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,321.567875,-0.55406,0.145,NULL,49699332168,776552065,12133626,NULL),(150546,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01595','R',150546,40.01,0.12,828,71541,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01595',0.2136,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150547,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150547,37.51,0.21,318,71542,70,NULL,NULL,'SDSS J212617.43-071100.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000078,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,321.572667,-7.18342,0.305,NULL,49688497256,776382769,12130980,18.4),(150548,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150548,37.9,0.46,380,71543,70,NULL,NULL,'SDSS J212619.79+100352.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00015,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,321.5825,10.06461,0.125,NULL,55049141637,860142838,13439731,18.7),(150549,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150549,36.23,0.46,176,71544,70,NULL,NULL,'2MASX J21261995-0045166',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000167,NULL,'16.1g',0.33,'S0',NULL,NULL,NULL,NULL,1,321.583,-0.75469,0.145,NULL,49699128926,776548889,12133576,16.1),(150550,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150550,37.58,0.46,328,71545,70,NULL,NULL,'SDSS J212622.87+103824.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,321.5952917,10.64014,0.209,NULL,55048931654,860139557,13439680,18),(150551,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150551,37.71,0.46,348,71546,70,NULL,NULL,'2MASX J21262386+1046389',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,321.5995,10.77753,0.209,NULL,55050110620,860157978,13439968,17.1),(150552,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150552,38.05,0.46,407,71547,70,NULL,NULL,'2MASX J21262581-0727089',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000107,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,321.6075417,-7.45242,0.297,NULL,49688922407,776389412,12131084,18.1),(150553,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150553,38.12,0.46,420,71548,70,NULL,NULL,'2MASX J21263122+1145169',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,321.629875,11.75469,0.257,NULL,55049975653,860155869,13439935,17.5),(150554,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07357',NULL,150554,40.68,0.38,1370,71549,70,NULL,'SN photometric redshift distance, z photo =0.392 +/- 0.099','SDSS-II SN 07357',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,321.635875,-0.36267,0.137,NULL,49699032765,776547386,12133552,NULL),(150555,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07357',NULL,150555,41.91,0.19,2410,71549,70,NULL,'SALT 2','SDSS-II SN 07357',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150556,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07357',NULL,150556,42.08,0.19,2610,71549,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07357',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150557,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150557,37.19,0.46,274,71550,70,NULL,NULL,'2MASX J21263399-0816598',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00008,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,321.641625,-8.28333,0.165,NULL,49687177140,776362142,12130658,17.1),(150558,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150558,36.78,0.46,227,71551,70,NULL,NULL,'2MASX J21263987+0018299',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000192,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,321.666125,0.30836,0.141,NULL,52102118839,814095606,12720243,16.5),(150559,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150559,37.54,0.27,322,71552,70,NULL,NULL,'2MASX J21264033+1134278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000145,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,321.667958333,11.57439,0.257,NULL,55049893099,860154579,13439915,17.5),(150560,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150560,37.51,0.21,318,71553,70,NULL,NULL,'2MASX J21264167-0716098',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000089,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,321.67375,-7.26939,0.305,NULL,49688381642,776380963,12130952,17.2),(150561,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13334','R',150561,40.54,0.27,1030,71554,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13334',0.24571,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,321.6770417,0.39447,0.113,NULL,52101990336,814093599,12720212,NULL),(150562,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13334','R',150562,40.68,0.23,1100,71554,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13334',0.24571,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150563,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150563,33.56,0.6,51.6,71555,70,NULL,NULL,'NGC 7065',NULL,'2014MNRAS.445.2677S',2014,1,1,'Star superposed 5.0 arcsec southwest of the nucleus.','G',0.00015,NULL,'13.1R',0.9,'SB(r)ab?','in a pair',NULL,NULL,NULL,1,321.677125,-6.99492,0.289,NULL,49688558527,776383726,12130995,13.1),(150564,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150564,35.38,0.47,119,71556,70,NULL,NULL,'ESO 599- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000093,NULL,'14.68',0.8,'SBc            LINER',NULL,NULL,NULL,NULL,1,321.6810417,-21.833,0.097,NULL,50912569870,795508904,12429826,14.68),(150565,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07550','RN',150565,41.03,0.23,1380,71557,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07550',0.16237,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150566,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07550','RN',150566,41.16,0.29,1470,71557,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07550',0.16237,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150567,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150567,37.54,0.27,322,71558,70,NULL,NULL,'2MASX J21264913+1140052',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000171,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,321.70475,11.66811,0.257,NULL,55049916620,860154947,13439921,17),(150568,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150568,36.87,0.54,237,71559,70,NULL,NULL,'2MASX J21265176-1901356',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'15.7r',0.21,NULL,NULL,NULL,NULL,NULL,1,321.715833,-19.02669,0.121,NULL,50922282129,795660658,12432197,15.7),(150569,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150569,37.77,0.46,358,71560,70,NULL,NULL,'2MASX J21265268+1124342',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000174,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,321.719625,11.40939,0.233,NULL,55050010049,860156407,13439943,17),(150570,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150570,37.62,0.46,335,71561,70,NULL,NULL,'2MASX J21265882-0636139',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000075,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,321.745,-6.604,0.221,NULL,49688705041,776386016,12131031,17.4),(150571,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150571,37.87,0.46,374,71562,70,NULL,NULL,'2MASX J21270180-0733529',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000097,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,321.757583,-7.56461,0.297,NULL,49688886646,776388853,12131075,17.3),(150572,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150572,37.33,0.46,292,71563,70,NULL,NULL,'SDSS J212707.71-064917.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000087,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,321.782125,-6.82158,0.221,NULL,49688712667,776386135,12131033,17.6),(150573,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01285',NULL,150573,40.46,0.23,1230,71564,70,NULL,'SN photometric redshift distance, z photo =0.345 +/- 0.048','SDSS-II SN 01285',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.5g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,321.783458333,0.54311,0.165,NULL,52102033335,814094270,12720222,20.5),(150574,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150574,37.54,0.27,322,71565,70,NULL,NULL,'2MASX J21270845+1137262',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,321.785167,11.624,0.249,NULL,55049897660,860154650,13439916,17.6),(150575,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13731','RN',150575,42.28,0.44,1960,71566,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13731',0.458686,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150576,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150576,37.67,0.46,342,71567,70,NULL,NULL,'2MASX J21271273+1044382',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,321.803167,10.74397,0.209,NULL,55049592528,860149883,13439841,17.2),(150577,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15640','RN',150577,40.44,0.12,1050,71568,70,NULL,'SDSS CAND. SNIa?; MLCS2K2','SDSS-II SN 15640',0.1664,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150578,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15640','RN',150578,40.46,0.2,1060,71568,70,NULL,'SDSS CAND. SNIa?; SALT 2','SDSS-II SN 15640',0.1664,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150579,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150579,37.41,0.46,303,71569,70,NULL,NULL,'2MASX J21271429+1049202',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,321.809583,10.82242,0.253,NULL,55049646960,860150733,13439855,17.3),(150580,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150580,38.72,0.46,556,71570,70,NULL,NULL,'2MASX J21271999+1200108',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,321.833375,12.00314,0.309,NULL,55046338099,860099032,13439047,17.9),(150581,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150581,31.57,0.8,20.6,71571,75,NULL,'MAT, I','NGC 7059',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.00001,NULL,'12.35',1.7,'SAB(s)c pec',NULL,NULL,NULL,NULL,1,321.839458333,-60.01458,0.057,NULL,49161852372,768153943,12002405,12.35),(150582,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150582,31.6,0.8,20.9,71571,75,NULL,'A82, H','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150583,'Sosies','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150583,31.13,0.35,16.8,71571,NULL,NULL,NULL,'NGC 7059',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150584,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150584,31.54,0.37,20.3,71571,NULL,NULL,NULL,'NGC 7059',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150585,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150585,31.54,0.4,20.3,71571,73,NULL,'opt','NGC 7059',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150586,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150586,31.57,0.43,20.6,71571,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7059',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150587,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150587,31.66,0.4,21.5,71571,75,NULL,'B','NGC 7059',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150588,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150588,32.16,0.43,27,71571,75,NULL,'3.6 micron, color corrected','NGC 7059',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150589,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150589,32.26,0.4,28.3,71571,NULL,NULL,'mean','NGC 7059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150590,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150590,32.72,0.2,35,71571,74.4,NULL,NULL,'NGC 7059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150591,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150591,32.83,0.47,36.8,71571,75,NULL,'A82, H, raw','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150592,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150592,32.88,0.46,37.6,71571,NULL,NULL,'J','NGC 7059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150593,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150593,32.94,0.47,38.7,71571,NULL,NULL,'H','NGC 7059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150594,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150594,32.94,0.47,38.8,71571,75,NULL,'A82, H, inv','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150595,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150595,32.96,0.45,39.1,71571,NULL,NULL,'K','NGC 7059',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150596,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150596,33.04,0.47,40.6,71571,75,NULL,'A82, H, cor','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150597,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150597,33.14,0.32,42.5,71571,85,NULL,'I, raw','NGC 7059',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150598,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150598,33.17,0.32,43,71571,85,NULL,'I, inv','NGC 7059',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150599,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150599,33.22,0.43,44.1,71571,75,NULL,'MAT, I, raw','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150600,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150600,33.31,0.43,45.9,71571,75,NULL,'MAT, I, cor','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150601,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150601,33.35,0.43,46.8,71571,75,NULL,'MAT, I, inv','NGC 7059',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150602,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150602,36.24,0.58,177,71572,70,NULL,NULL,'LCRS B212406.2-453559',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'14.0r',0.48,'E',NULL,NULL,NULL,NULL,1,321.844167,-45.38175,0.017,NULL,51367268924,802613576,12540837,14),(150603,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150603,35.21,0.46,110,71573,70,NULL,NULL,'NGC 7061',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.12',0.7,'E+4','Pair member (points to parent)',NULL,NULL,NULL,1,321.861875,-49.0635,0,NULL,50609186582,790768540,12355758,14.12),(150604,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 03494','RN',150604,39.87,0.08,798,71574,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03494',0.178742,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150605,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 03494','RN',150605,40.59,0.19,1110,71574,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03494',0.178742,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150606,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150606,37.31,0.46,289,71575,70,NULL,NULL,'2MASX J21273114-0032498',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,321.879667,-0.54728,0.169,NULL,49699021134,776547205,12133550,17.6),(150607,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150607,35.48,0.59,125,71576,70,NULL,NULL,'IC 1381',NULL,'2014MNRAS.445.2677S',2014,1,1.01,NULL,'G',0.000043,NULL,'15.0g',0.59,'Sab',NULL,NULL,NULL,NULL,1,321.890416667,-1.18861,0.185,NULL,49702204902,776596951,12134327,15),(150608,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150608,38.21,0.46,439,71577,70,NULL,NULL,'SDSS J212738.35+114436.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000149,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,321.909833,11.74358,0.293,NULL,55049877071,860154329,13439911,18.5),(150609,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150609,32.99,0.47,39.6,71578,NULL,NULL,'H','UGC 11748',NULL,'2007A&A...465...71T',2007,1,1.4,'abs(b) < 10 degrees.','G',NULL,NULL,'17.',0.5,'S',NULL,NULL,NULL,NULL,1,321.915541667,45.483,NULL,NULL,55674506035,869914156,13592408,17),(150610,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150610,33.13,0.45,42.3,71578,NULL,NULL,'K','UGC 11748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150611,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150611,33.37,0.46,47.3,71578,NULL,NULL,'J','UGC 11748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150612,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150612,33.97,0.4,62.2,71578,NULL,NULL,'mean','UGC 11748',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150613,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150613,36.01,0.46,159,71579,70,NULL,NULL,'2MASX J21274330+1206248',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000161,NULL,'16.5g',0.28,'E0',NULL,NULL,NULL,NULL,1,321.930583,12.10675,0.317,NULL,55046360199,860099378,13439052,16.5),(150614,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150614,34.75,0.46,89,71580,70,NULL,NULL,'KAZ 522',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000146,NULL,'15.9g',0.4,'S0',NULL,NULL,NULL,NULL,1,321.9397083,0.32642,0.165,NULL,52101926719,814092604,12720196,15.9),(150615,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150615,37.94,0.46,387,71581,70,NULL,NULL,'2MASX J21275196+1209192',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000147,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,321.966416667,12.15539,0.317,NULL,55046350983,860099234,13439050,17.7),(150616,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150616,35.49,0.57,125,71582,70,NULL,NULL,'2MFGC 16240',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.90',0.22,NULL,NULL,NULL,NULL,NULL,1,321.9722917,-11.30669,0.153,NULL,50771845967,793310093,12395470,15.9),(150617,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150617,38.09,0.33,415,71583,70,NULL,NULL,'2MASX J21275991+1035339',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000157,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,321.999583,10.59269,0.141,NULL,55048512880,860133013,13439578,18),(150618,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150618,34.82,0.69,92,71584,100,NULL,'mid-IR','CGCG 426-057',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',NULL,NULL,'15.6',0.4,NULL,NULL,NULL,NULL,NULL,1,322.0087917,12.74642,0.277,NULL,55264835269,863513051,13492391,15.6),(150619,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150619,38.09,0.33,415,71585,70,NULL,NULL,'2MASX J21280337+1050118',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,322.014125,10.83672,0.137,NULL,55049607443,860150116,13439845,18.3),(150620,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150620,34.64,0.47,84.9,71586,70,NULL,NULL,'NGC 7069',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000143,NULL,'14.36',0.9,'SAB(s)0-?     LINER?',NULL,NULL,NULL,NULL,1,322.0244583,-1.64686,0.173,NULL,49699925880,776561341,12133770,14.36),(150621,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150621,38.51,0.46,503,71587,70,NULL,NULL,'2MASX J21280795+1113508',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,322.033083333,11.23072,0.233,NULL,55049578042,860149656,13439838,17.8),(150622,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','PTF10trp','N',150622,36.64,0.03,203,71588,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10trp',0.0489,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150623,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150623,37.56,0.23,325,71589,70,NULL,NULL,'2MASX J21280934+1114577',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000179,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,322.0389583,11.24931,0.233,NULL,55049580185,860149690,13439838,17.8),(150624,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150624,36.32,0.46,184,71590,70,NULL,NULL,'MCG +00-54-020',NULL,'2015arXiv151105856S',2015,1,0.85,NULL,'G',0.00013,NULL,'15.1g',0.5,NULL,NULL,NULL,NULL,NULL,1,322.048583,0.29992,0.165,NULL,52105360291,814146254,12721035,15.1),(150625,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150625,37.9,0.33,380,71591,70,NULL,NULL,'2MASX J21281190+1152504',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000176,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,322.049667,11.88083,0.293,NULL,55046543704,860102245,13439097,17.6),(150626,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150626,33.79,0.66,57.3,71592,NULL,NULL,'Malmquist cor.','IC 5107',NULL,'2009ApJS..182..474S',2009,1,1.09,NULL,'G',0.000033,NULL,'14.64',0.39,'S...',NULL,NULL,NULL,NULL,1,322.062041667,-65.73553,0.009,NULL,49355274017,771176156,12049627,14.64),(150627,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150627,34.17,0.55,68.2,71592,NULL,NULL,NULL,'IC 5107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150628,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150628,34.21,0.2,69.5,71592,74.4,NULL,NULL,'IC 5107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150629,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150629,32.61,0.8,33.2,71593,75,NULL,'MAT, I','ESO 342- G 050',NULL,'1997ApJS..109..333W',1997,1,2.2,'Confused HIPASS source','G',0.000023,NULL,'12.88',1.2,'SA(rs)c pec?',NULL,NULL,NULL,NULL,1,322.0627083,-37.86131,0.121,NULL,51487730707,804495792,12570246,12.88),(150630,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150630,32.58,0.8,32.8,71593,75,NULL,'B','ESO 342- G 050',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150631,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150631,31.85,0.4,23.4,71593,NULL,NULL,NULL,'ESO 342- G 050',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150632,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150632,31.85,0.4,23.4,71593,73,NULL,'opt','ESO 342- G 050',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150633,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150633,32.05,0.32,25.7,71593,85,NULL,'I, raw','ESO 342- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150634,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150634,32.07,0.32,26,71593,85,NULL,'I, inv','ESO 342- G 050',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150635,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150635,32.19,0.43,27.5,71593,75,NULL,'3.6 micron, color + selection bias corrected','ESO 342- G 050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150636,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150636,32.24,0.43,28.1,71593,75,NULL,'3.6 micron, color corrected','ESO 342- G 050',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150637,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150637,32.3,0.43,28.8,71593,75,NULL,'MAT, I, raw','ESO 342- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150638,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150638,32.31,0.2,29,71593,74.4,NULL,NULL,'ESO 342- G 050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150639,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150639,32.35,NULL,29.5,71593,NULL,NULL,'I','ESO 342- G 050',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150640,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150640,32.44,0.43,30.7,71593,75,NULL,'MAT, I, inv','ESO 342- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150641,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150641,32.45,0.47,30.9,71593,NULL,NULL,'H','ESO 342- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150642,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150642,32.46,0.46,31,71593,NULL,NULL,'J','ESO 342- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150643,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150643,32.49,0.45,31.5,71593,NULL,NULL,'K','ESO 342- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150644,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150644,32.53,0.43,32.1,71593,75,NULL,'MAT, I, cor','ESO 342- G 050',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150645,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150645,32.71,0.1,34.9,71593,NULL,NULL,NULL,'ESO 342- G 050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150646,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150646,32.72,NULL,35,71593,NULL,NULL,'B','ESO 342- G 050',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150647,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150647,32.83,0.4,36.8,71593,NULL,NULL,'mean','ESO 342- G 050',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150648,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150648,36.86,0.16,219,71594,74.2,NULL,'SALT 2','[WM92] 212426.8-614612',0.075,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.002,NULL,'17.43',0.9,'E1?',NULL,NULL,NULL,NULL,1,322.073125,-61.55178,0.085,NULL,49170464662,768288510,12004507,17.43),(150649,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150649,37.48,0.23,291,71594,72,NULL,NULL,'[WM92] 212426.8-614612',0.075,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150650,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150650,37.5,0.19,294,71594,70,NULL,'SALT 2','[WM92] 212426.8-614612',0.075,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150651,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150651,37.57,0.2,303,71594,73.8,NULL,'SALT 2 (SNANA)','[WM92] 212426.8-614612',0.0746,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150652,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150652,37.57,0.15,304,71594,65,NULL,'SALT2','[WM92] 212426.8-614612',0.075,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150653,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150653,37.73,0.17,304,71594,65,NULL,'MLCS2k2','[WM92] 212426.8-614612',0.075,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150654,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150654,37.43,0.08,306,71594,74.4,NULL,NULL,'[WM92] 212426.8-614612',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150655,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150655,37.61,0.04,309,71594,72,NULL,NULL,'[WM92] 212426.8-614612',0.075,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150656,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150656,37.64,0.05,314,71594,70,NULL,NULL,'[WM92] 212426.8-614612',0.075,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150657,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150657,37.65,0.05,315,71594,70,NULL,'SALT 2','[WM92] 212426.8-614612',0.075,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150658,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150658,37.67,0.15,318,71594,70,NULL,'SALT','[WM92] 212426.8-614612',0.075,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150659,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150659,37.71,0.19,325,71594,65,NULL,'MLCS17','[WM92] 212426.8-614612',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150660,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150660,37.72,0.22,325,71594,65,NULL,'MLCS31','[WM92] 212426.8-614612',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150661,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150661,37.72,0.18,325,71594,65,NULL,'SALT2','[WM92] 212426.8-614612',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150662,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150662,37.72,0.19,326,71594,65,NULL,'MLCS2k2','[WM92] 212426.8-614612',0.075,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150663,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150663,37.58,0.12,328,71594,70.8,NULL,NULL,'[WM92] 212426.8-614612',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150664,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150664,37.76,0.11,332,71594,65,NULL,'MLCS2k2','[WM92] 212426.8-614612',0.075,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150665,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150665,37.77,0.19,333,71594,65,NULL,NULL,'[WM92] 212426.8-614612',0.075,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150666,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150666,37.77,0.19,333,71594,65,NULL,'Template','[WM92] 212426.8-614612',0.075,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150667,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150667,37.8,0.06,337,71594,65,NULL,'MLCS','[WM92] 212426.8-614612',0.075,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150668,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150668,37.8,0.17,338,71594,65,NULL,'MLCS','[WM92] 212426.8-614612',0.075,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150669,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150669,37.83,0.13,343,71594,65,NULL,'SALT','[WM92] 212426.8-614612',0.075,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150670,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150670,37.68,0.09,344,71594,65,NULL,'LCS','[WM92] 212426.8-614612',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150671,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150671,37.71,0.14,348,71594,60,NULL,NULL,'[WM92] 212426.8-614612',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150672,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150672,37.88,0.03,351,71594,65,NULL,'SALT','[WM92] 212426.8-614612',0.075,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150673,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150673,37.79,0.09,361,71594,65,NULL,'Snapshot','[WM92] 212426.8-614612',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150674,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150674,37.8,0.08,363,71594,60,NULL,'M(V) = -19.47 mag','[WM92] 212426.8-614612',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150675,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1992ae',NULL,150675,37.86,0.12,373,71594,60,NULL,'M(B) = -19.48 mag','[WM92] 212426.8-614612',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150676,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21055','RN',150676,38.13,0.18,403,71595,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05611 HOST',0.050284,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150677,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 05611','RN',150677,38.22,0.28,420,71595,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05611 HOST',0.050284,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150678,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07783','RN',150678,38.62,0.34,504,71595,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05611 HOST',0.050284,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150679,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21055','RN',150679,39.47,0.34,746,71595,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05611 HOST',0.050284,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150680,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01108','RN',150680,42.12,0.22,1870,71596,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01108',0.422703,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150681,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01108','RN',150681,43.98,0.29,4390,71596,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01108',0.422703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150682,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150682,37.91,0.46,382,71597,70,NULL,NULL,'SDSS J212823.87-070814.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000074,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,322.0995,-7.13736,0.181,NULL,49690378190,776412159,12131439,18.8),(150683,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150683,37.9,0.33,380,71598,70,NULL,NULL,'2MASX J21282504+1152087',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,322.10425,11.86897,0.293,NULL,55046542197,860102221,13439097,17.6),(150684,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150684,36.83,0.33,233,71599,70,NULL,NULL,'SDSS J212826.69+011339.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000147,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.11125,1.22772,0.157,NULL,52105264065,814144751,12721011,17.9),(150685,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150685,36.83,0.33,233,71600,70,NULL,NULL,'2MASX J21282861+0109514',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,322.119167,1.16431,0.157,NULL,52105252222,814144565,12721008,17.1),(150686,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150686,37.86,0.46,374,71601,70,NULL,NULL,'2MASX J21282902+0958327',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000199,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.121083,9.97583,0.145,NULL,55048539807,860133434,13439584,16.9),(150687,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 04910','RN',150687,40.19,0.44,957,71602,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04910',0.137796,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150688,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 04910','RN',150688,40.75,0.34,1240,71602,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04910',0.137796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150689,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150689,47.04,0.68,5330,71603,69.7,NULL,'Calibrated','GRB 060605',3.8,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',0.001,NULL,'15.2R',NULL,'Swift',NULL,NULL,NULL,NULL,1,322.155458333,-6.05858,0.177,NULL,49724524823,776945700,12139776,15.2),(150690,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150690,47.07,0.81,5400,71603,NULL,NULL,NULL,'GRB 060605',3.8,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150691,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150691,47.11,0.73,5510,71603,72,NULL,NULL,'GRB 060605',3.8,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150692,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150692,47.21,0.72,5760,71603,70,NULL,NULL,'GRB 060605',3.8,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150693,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150693,47.66,0.57,7090,71603,69.7,NULL,'Fiducial','GRB 060605',3.8,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150694,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150694,36.54,0.1,185,71604,72,NULL,NULL,'2MASX J21283758+0113490',0.04839,'2013ApJ...773...53F',2013,1,0.38,NULL,'G',0.000059,NULL,'17.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.156667,1.23017,0.145,NULL,52105218913,814144045,12721000,17.3),(150695,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150695,36.54,0.02,194,71604,72,NULL,NULL,'2MASX J21283758+0113490',0.049509,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150696,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150696,36.48,0.1,198,71604,74.4,NULL,NULL,'2MASX J21283758+0113490',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150697,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150697,36.66,0.15,205,71604,70,NULL,'SALT 2','2MASX J21283758+0113490',0.049509,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150698,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150698,36.57,0.02,206,71604,72,NULL,NULL,'2MASX J21283758+0113490',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150699,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12780','R',150699,36.73,0.2,212,71604,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006eq','2MASX J21283758+0113490',0.049509,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150700,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006eq',NULL,150700,36.88,0.29,238,71604,72,NULL,'M(H) = -18.317 mag','2MASX J21283758+0113490',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150701,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12780','R',150701,37.28,0.11,273,71604,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006eq','2MASX J21283758+0113490',0.049509,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150702,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18408','R',150702,38.47,0.05,475,71605,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007lj','SDSS J212841.86-000401.0',0.04,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,NULL,'20.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,322.1744583,-0.06694,0.153,NULL,49700678526,776573101,12133954,20.8),(150703,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18408','R',150703,39.05,0.19,620,71605,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007lj','SDSS J212841.86-000401.0',0.04,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150704,'SNII optical','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007lj',NULL,150704,36.6,0.09,201,71605,NULL,NULL,'SCM 55 SNII','SDSS J212841.86-000401.0',0.04,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150705,'SNII optical','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007lj',NULL,150705,36.91,0.11,231,71605,NULL,NULL,'SCM 15 SDSS SNII','SDSS J212841.86-000401.0',0.04,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150706,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06146','RN',150706,42.24,0.15,2080,71606,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06146',0.34785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150707,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06146','RN',150707,42.27,0.29,2110,71606,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06146',0.34785,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150708,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150708,34.91,0.55,96,71607,70,NULL,NULL,'ESO 075- G 010',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'14.7r',0.34,'S0',NULL,NULL,NULL,NULL,1,322.182833,-67.37564,0.021,NULL,49385371330,771646427,12056975,14.7),(150709,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19205',NULL,150709,40.1,0.2,1050,71608,70,NULL,'SN photometric redshift distance, z photo =0.284 +/- 0.033','SDSS-II SN 19205',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,322.186083,-0.84681,0.169,NULL,49702287304,776598239,12134347,NULL),(150710,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19205','R',150710,41.15,0.13,1270,71608,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19205',0.3346,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150711,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19205','R',150711,41.23,0.22,1320,71608,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19205',0.3346,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150712,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150712,37.5,0.46,316,71609,70,NULL,NULL,'2MASX J21284543+1045204',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,322.1895,10.75569,0.137,NULL,55049489203,860148268,13439816,17.3),(150713,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150713,34.74,0.56,88.7,71610,70,NULL,NULL,'2MASX J21284802-4523044',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000133,NULL,'15.21',0.63,'E',NULL,NULL,NULL,NULL,1,322.200083333,-45.38458,0.017,NULL,51367161819,802611903,12540810,15.21),(150714,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13297','RN',150714,40.74,0.26,1170,71611,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13297',0.202806,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150715,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13297','RN',150715,41.57,0.37,1710,71611,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13297',0.202806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150716,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 08363','RN',150716,38.24,0.27,408,71612,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08363',0.088257,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150717,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 08363','RN',150717,38.95,0.44,567,71612,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08363',0.088257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150718,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150718,37.32,0.46,291,71613,70,NULL,NULL,'2MASX J21285604-0728330',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000086,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,322.2335,-7.47572,0.189,NULL,49690418961,776412796,12131449,17.4),(150719,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150719,37.14,0.46,268,71614,70,NULL,NULL,'2MASX J21290054+1203419',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000159,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.25225,12.06181,0.273,NULL,55046529874,860102029,13439094,17.2),(150720,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150720,30.11,0.8,10.5,71615,75,NULL,'MAT, I','NGC 7064',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.00001,NULL,'13.1',0.6,'SB(s)c? sp',NULL,NULL,NULL,NULL,1,322.262417,-52.76761,0,NULL,50615255720,790863370,12357240,13.1),(150721,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150721,30.14,0.8,10.6,71615,75,NULL,'B','NGC 7064',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150722,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150722,30,0.32,10,71615,85,NULL,'I, inv','NGC 7064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150723,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150723,30.04,0.32,10.2,71615,85,NULL,'I, raw','NGC 7064',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150724,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150724,30.06,0.36,10.3,71615,NULL,NULL,NULL,'NGC 7064',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150725,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150725,30.06,0.4,10.3,71615,73,NULL,'opt','NGC 7064',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150726,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150726,30.21,0.2,11,71615,74.4,NULL,NULL,'NGC 7064',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150727,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150727,30.27,0.43,11.3,71615,75,NULL,'MAT, I, inv','NGC 7064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150728,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150728,30.3,0.43,11.5,71615,75,NULL,'3.6 micron, color corrected','NGC 7064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150729,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150729,30.32,0.43,11.6,71615,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7064',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150730,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150730,30.35,0.43,11.7,71615,75,NULL,'MAT, I, raw','NGC 7064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150731,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150731,30.69,0.43,13.7,71615,75,NULL,'MAT, I, cor','NGC 7064',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150732,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150732,36.51,0.46,201,71616,70,NULL,NULL,'2MASX J21290678+1011454',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000146,NULL,'16.6g',0.25,NULL,NULL,NULL,NULL,NULL,1,322.278166667,10.19592,0.133,NULL,55048562646,860133791,13439590,16.6),(150733,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150733,35.85,0.49,148,71617,75,NULL,'IR','UGC 11750',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000113,NULL,'16.0',0.3,'S',NULL,NULL,NULL,NULL,1,322.284833333,2.79989,0.225,NULL,52136335770,814630246,12728597,16),(150734,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150734,36.45,0.46,195,71618,70,NULL,NULL,'2MASX J21291105+1031370',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000177,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,322.296125,10.52706,0.137,NULL,55048454839,860132106,13439564,16.5),(150735,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150735,35.06,0.57,103,71619,70,NULL,NULL,'2MASX J21291249-0037185',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.7g',0.32,'E0',NULL,NULL,NULL,NULL,1,322.302166667,-0.62175,0.165,NULL,49701890307,776592036,12134250,15.7),(150736,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150736,35.24,0.27,112,71619,70,NULL,NULL,'2MASX J21291249-0037185',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150737,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150737,37.56,0.23,325,71620,70,NULL,NULL,'SDSS J212913.10+111448.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000126,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,322.304583,11.24686,0.221,NULL,55046725975,860105093,13439142,18.4),(150738,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01631','RN',150738,40.23,0.15,973,71621,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01631',0.14415,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150739,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01631','RN',150739,40.53,0.21,1120,71621,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01631',0.14415,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150740,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 03134','RN',150740,42.1,0.23,1910,71622,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03134',0.373435,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150741,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 03134','RN',150741,42.72,0.15,2550,71622,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03134',0.373435,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150742,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150742,36.39,0.53,189,71623,70,NULL,NULL,'2MASX J21291683-5119020',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.9r',0.43,'S',NULL,NULL,NULL,NULL,1,322.320125,-51.31725,0,NULL,50613136507,790830257,12356722,14.9),(150743,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007jl',NULL,150743,39.9,0.11,955,71624,70,NULL,'Hubble residual 0.00 for z0.25420','SDSS-II SN 17552 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.32125,-1.00283,0.177,NULL,49702496806,776601512,12134398,NULL),(150744,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17552','R',150744,40.62,0.21,1060,71624,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jl','SDSS-II SN 17552 HOST',0.253291,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150745,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17552','R',150745,40.68,0.15,1090,71624,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jl','SDSS-II SN 17552 HOST',0.253291,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150746,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007jl',NULL,150746,40.52,0.12,1270,71624,70,NULL,'SALT 2','SDSS-II SN 17552 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150747,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007jl',NULL,150747,40.54,0.12,1280,71624,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17552 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150748,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150748,37.56,0.23,325,71625,70,NULL,NULL,'2MASX J21291856+1112040',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000199,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,322.3275417,11.20094,0.221,NULL,55046726823,860105106,13439142,16.2),(150749,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150749,38.26,0.46,449,71626,70,NULL,NULL,'2MASX J21292504+1145420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,322.354291667,11.76178,0.273,NULL,55046865970,860107280,13439176,18.1),(150750,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150750,40.19,NULL,1090,71627,NULL,NULL,'4.2 (black) calibration','MACS J2129.4-0741',NULL,'2010ApJ...721..653R',2010,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.359208333,-7.69061,0.189,NULL,49693747765,776464808,12132262,NULL),(150751,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150751,40.23,NULL,1110,71627,NULL,NULL,'3.1 (red) calibration','MACS J2129.4-0741',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150752,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150752,40.4,NULL,1200,71627,NULL,NULL,'4.1 (blue) calibration','MACS J2129.4-0741',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150753,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150753,40.43,0.56,1220,71627,NULL,NULL,'Isotherm., r < 100 kpc','MACS J2129.4-0741',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150754,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150754,40.62,0.56,1330,71627,NULL,NULL,'Hydrost. Eq.','MACS J2129.4-0741',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150755,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150755,40.72,0.56,1390,71627,NULL,NULL,'Isotherm.','MACS J2129.4-0741',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150756,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15554','RN',150756,43.09,0.28,2760,71628,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15554',0.499308,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150757,'BCG','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150757,38.9,0.35,538,71629,60,NULL,'ABELL 2347, BCG','2MASX J21293166-2212142',0.1196,'1980ApJ...241..486H',1980,1,0.41,NULL,'G',NULL,NULL,'15.7r',0.26,NULL,'Brightest group member',NULL,NULL,NULL,1,322.382,-22.20397,0.089,NULL,50925379183,795709049,12432953,15.7),(150758,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150758,37.1,0.46,263,71630,70,NULL,NULL,'2MASX J21293175+0102116',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00014,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,322.382375,1.03661,0.117,NULL,52105784416,814152881,12721138,16.9),(150759,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150759,37.56,0.23,325,71631,70,NULL,NULL,'2MASX J21293229+1117370',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000155,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,322.384541667,11.29367,0.221,NULL,55046759494,860105617,13439150,17.7),(150760,'BCG','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150760,38.9,0.35,538,71632,60,NULL,NULL,'ABELL 2347',0.1196,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III:   [BM]',NULL,NULL,NULL,NULL,1,322.386083,-22.21383,0.089,NULL,50925379268,795709051,12432953,NULL),(150761,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150761,37.88,0.46,377,71633,70,NULL,NULL,'SDSS J212933.36-001429.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000116,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,322.389041667,-0.24153,0.153,NULL,49700914729,776576792,12134012,17.9),(150762,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150762,36.98,0.46,249,71634,70,NULL,NULL,'2MASX J21293399+0001357',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.1g',0.19,NULL,NULL,NULL,NULL,NULL,1,322.391583333,0.02667,0.157,NULL,52103447469,814116366,12720568,17.1),(150763,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150763,35.61,0.67,133,71635,70,NULL,NULL,'2MASX J21293459-7907318',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,322.394,-79.12544,0.533,NULL,48576962077,759015032,11859609,16.5),(150764,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150764,36.08,0.46,165,71636,70,NULL,NULL,'2MASX J21293539-0016142',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000144,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,322.397583333,-0.27075,0.153,NULL,49700907133,776576673,12134010,16.7),(150765,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150765,35.39,0.46,120,71637,70,NULL,NULL,'IC 1386',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.0001,NULL,'14.04',0.9,'SA0-:',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,322.4059583,-21.19569,0.101,NULL,50933677428,795838709,12434979,14.04),(150766,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150766,38.31,0.48,460,71638,NULL,NULL,'Hydrost. Eq.','MaxBCG J322.41649+00.08920',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.407875,0.09406,0.157,NULL,52103447808,814116372,12720568,NULL),(150767,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150767,38.74,0.75,560,71638,NULL,NULL,'Isotherm., r < 100 kpc','MaxBCG J322.41649+00.08920',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150768,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150768,39.4,0.71,760,71638,NULL,NULL,'Isotherm.','MaxBCG J322.41649+00.08920',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150769,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150769,39.97,NULL,988,71638,NULL,NULL,'4.2 (black) calibration','MaxBCG J322.41649+00.08920',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150770,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150770,40.06,NULL,1030,71638,NULL,NULL,'3.1 (red) calibration','MaxBCG J322.41649+00.08920',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150771,'SZ effect','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150771,40.06,NULL,1030,71638,NULL,NULL,'4.1 (blue) calibration','MaxBCG J322.41649+00.08920',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150772,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172',NULL,150772,39.03,0.21,640,71639,70,NULL,NULL,'SDSS J212939.01-001207.9',NULL,'2013MNRAS.434.1443X',2013,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,322.412583333,-0.20219,0.153,NULL,49700916116,776576814,12134012,18.6),(150773,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172','R',150773,39.39,0.21,665,71639,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J212939.01-001207.9',0.136329,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150774,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172','R',150774,39.64,0.15,747,71639,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J212939.01-001207.9',0.136329,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150775,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172',NULL,150775,39.17,0.1,682,71640,70,NULL,'SALT 2','SDSS J212939.01-001207.9',NULL,'2013ApJ...763...88C',2013,1,0.16,NULL,'G',NULL,NULL,'18.6g',0.11,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,322.412583333,-0.20219,0.153,NULL,49700916116,776576814,12134012,18.6),(150776,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11172',NULL,150776,39.18,0.1,685,71640,70,NULL,'SALT 2, Malmquist cor.','SDSS J212939.01-001207.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150777,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150777,36.5,0.6,199,71641,70,NULL,NULL,'2MASX J21293971-0608214',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.11',0.2,NULL,NULL,NULL,NULL,NULL,1,322.415417,-6.13936,0.165,NULL,49682619739,776290933,12129545,17.11),(150778,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150778,37.91,0.46,381,71642,70,NULL,NULL,'2MASX J21294185-0831444',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.424417,-8.52906,0.121,NULL,49691302489,776426601,12131665,17.2),(150779,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150779,38.51,0.46,504,71643,70,NULL,NULL,'SDSS J212942.37+114602.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000177,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,322.4265417,11.76739,0.273,NULL,55046867673,860107307,13439176,17.9),(150780,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20144','R',150780,40.05,0.21,839,71644,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ql','SN 2007ql',0.22,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,322.431917,0.44461,0.113,NULL,52103377661,814115275,12720551,NULL),(150781,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20144','R',150781,40.31,0.13,947,71644,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ql','SN 2007ql',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150782,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150782,36.66,0.46,215,71645,70,NULL,NULL,'2MASX J21294683+1011242',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000148,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,322.44525,10.18997,0.133,NULL,52111842505,814247539,12722617,17.3),(150783,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150783,36.44,0.46,195,71646,70,NULL,NULL,'2MASX J21294778-0815394',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000089,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,322.449125,-8.26103,0.117,NULL,49693661470,776463460,12132241,16.5),(150784,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150784,35.24,0.27,112,71647,70,NULL,NULL,'2MASX J21294846-0018492',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000155,NULL,'15.8g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,322.451917,-0.31356,0.153,NULL,49700920710,776576886,12134013,15.8),(150785,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150785,34.93,0.51,97.1,71648,70,NULL,NULL,'IC 1388',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.000087,NULL,'15.0',0.2,NULL,NULL,NULL,NULL,NULL,1,322.467417,-0.63128,0.141,NULL,49701854670,776591479,12134241,15),(150786,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150786,35.24,0.27,112,71648,70,NULL,NULL,'IC 1388',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150787,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150787,37.39,0.46,300,71649,70,NULL,NULL,'2MASX J21295427+1014382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.47625,10.24411,0.125,NULL,52111851154,814247674,12722619,17.6),(150788,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150788,30.62,0.8,13.3,71650,75,NULL,'B','NGC 7077',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000017,NULL,'14.14',0.7,'BCD/E          HII',NULL,NULL,NULL,NULL,1,322.498375,2.41417,0.165,NULL,52103869822,814122965,12720671,14.14),(150789,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150789,31.18,0.39,17.2,71650,73,NULL,'opt','NGC 7077',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150790,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150790,36.28,0.46,181,71651,70,NULL,NULL,'2MASX J21300156-0113512',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.56',0.44,NULL,NULL,NULL,NULL,NULL,1,322.5064583,-1.23094,0.177,NULL,49701619612,776587806,12134184,16.56),(150791,'Ring Diameter','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150791,33.1,0.84,41,71652,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7080',NULL,'1981ApJS...45..541P',1981,1,1.8,NULL,'G',0.000017,NULL,'13.13',1.7,'SB(r)b',NULL,NULL,NULL,NULL,1,322.508125,26.71781,0.425,NULL,55607673248,868869894,13576092,13.13),(150792,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16452','RN',150792,39.96,0.23,815,71653,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16452',0.206111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150793,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16452','RN',150793,40.09,0.21,862,71653,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 16452',0.206111,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150794,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150794,35.46,0.67,124,71654,70,NULL,NULL,'MCG -01-54-019',NULL,'2014MNRAS.445.2677S',2014,1,1.26,NULL,'G',0.00008,NULL,'14.8g',0.44,'Sc',NULL,NULL,NULL,NULL,1,322.559291667,-8.06697,0.121,NULL,49694084724,776470073,12132344,14.8),(150795,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150795,36.62,0.46,211,71655,70,NULL,NULL,'2MASX J21301492+0041103',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,322.562167,0.68611,0.117,NULL,52103351498,814114867,12720544,17.3),(150796,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435',NULL,150796,38.33,0.79,464,71656,70,NULL,'SN photometric redshift distance, z photo =0.115 +/- 0.055','SDSS-II SN 20435',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.8g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,322.565917,0.55872,0.161,NULL,52103405155,814115705,12720557,22.8),(150797,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435','R',150797,41.23,0.23,1320,71656,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20435',0.340192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150798,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435','R',150798,41.35,0.32,1390,71656,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20435',0.340192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150799,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435',NULL,150799,41.39,0.2,1900,71656,70,NULL,'SALT 2','SDSS-II SN 20435',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150800,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20435',NULL,150800,41.44,0.2,1940,71656,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20435',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150801,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150801,37.9,0.46,381,71657,70,NULL,NULL,'2MASX J21301891-0641351',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000093,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,322.578875,-6.69325,0.129,NULL,49690108328,776407942,12131374,17.5),(150802,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19490',NULL,150802,39.28,0.83,717,71658,70,NULL,'SN photometric redshift distance, z photo =0.184 +/- 0.100','SDSS-II SN 19490',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,322.579917,-0.55125,0.137,NULL,49700790913,776574858,12133982,NULL),(150803,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150803,36.91,0.46,241,71659,70,NULL,NULL,'2MASX J21302216-0725461',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000098,NULL,'16.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,322.59225,-7.42942,0.085,NULL,49690764091,776418188,12131534,16.5),(150804,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150804,37.08,0.61,260,71660,70,NULL,NULL,'2MASX J21302318-5126212',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.6r',0.23,NULL,NULL,NULL,NULL,NULL,1,322.596667,-51.43925,0,NULL,50613488842,790835763,12356808,15.6),(150805,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150805,32.41,0.8,30.3,71661,75,NULL,'B','NGC 7070',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000017,NULL,'12.80',1.8,'SB(s)c','in a pair',NULL,NULL,NULL,1,322.605625,-43.08711,0.033,NULL,51369678384,802651224,12541425,12.8),(150806,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150806,34.69,0.48,86.8,71662,70,NULL,NULL,'2MASX J21302824-6344352',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'14.2r',0.45,'S0',NULL,NULL,NULL,NULL,1,322.617541667,-63.74308,0.049,NULL,49166834713,768231792,12003621,14.2),(150807,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150807,37.79,0.46,361,71663,70,NULL,NULL,'2MASX J21302906+0100262',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000146,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,322.6212083,1.00739,0.121,NULL,52104984843,814140388,12720943,17.2),(150808,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150808,37.13,0.21,267,71664,70,NULL,NULL,'SDSS J213031.80+102837.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000165,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,322.6325,10.47711,0.145,NULL,52111661048,814244703,12722573,18.3),(150809,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150809,37.13,0.21,267,71665,70,NULL,NULL,'2MASX J21303261+1036216',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000182,NULL,'16.1g',0.37,'E0',NULL,NULL,NULL,NULL,1,322.635916667,10.60617,0.145,NULL,52111607158,814243861,12722560,16.1),(150810,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439',NULL,150810,40.17,0.31,1080,71666,70,NULL,'SN photometric redshift distance, z photo =0.294 +/- 0.056','SDSS-II SN 16439',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.0g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,322.639625,-0.84303,0.141,NULL,49701061789,776579090,12134048,21),(150811,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439','R',150811,41.42,0.25,1380,71666,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16439',0.396513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150812,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439','R',150812,41.7,0.31,1570,71666,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16439',0.396513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150813,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439',NULL,150813,41.55,0.2,2040,71666,70,NULL,'SALT 2','SDSS-II SN 16439',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150814,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16439',NULL,150814,41.61,0.2,2100,71666,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16439',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150815,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150815,34.64,NULL,84.8,71667,NULL,NULL,NULL,'ESO 403- G 003',NULL,'2000BSAO...50....5K',2000,1,1.51,'SGC printed catalog incorrectly lists R.A. as 21h37.3m; tape version correct.','G',0.00002,NULL,'14.4r',0.2,'Sbc            HII',NULL,NULL,NULL,NULL,1,322.642625,-33.65017,0.133,NULL,51451306716,803926667,12561354,14.4),(150816,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150816,34.68,0.49,86.3,71667,75,NULL,'IR','ESO 403- G 003',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150817,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150817,35.13,NULL,106,71667,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 403- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150818,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150818,35.16,NULL,108,71667,NULL,NULL,'Dipole + Quadrupole','ESO 403- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150819,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150819,35.19,NULL,109,71667,NULL,NULL,'Dipole','ESO 403- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150820,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150820,35.33,0.6,116,71667,NULL,NULL,NULL,'ESO 403- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150821,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150821,35.33,0.2,116,71667,74.4,NULL,NULL,'ESO 403- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150822,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150822,35.36,0.59,118,71667,NULL,NULL,'Malmquist cor.','ESO 403- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150823,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17615','RN',150823,42.86,0.21,2390,71668,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17615',0.563169,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150824,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150824,36.27,0.59,179,71669,70,NULL,NULL,'2MASX J21303822-1232192',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.18',0.24,NULL,NULL,NULL,NULL,NULL,1,322.659333,-12.53858,0.193,NULL,50953373842,796146466,12439788,17.18),(150825,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150825,37.13,0.21,267,71670,70,NULL,NULL,'2MASX J21304204+1036299',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000195,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,322.67525,10.60825,0.145,NULL,52111608766,814243886,12722560,16.8),(150826,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150826,37.07,0.87,259,71671,70,NULL,NULL,'2MASX J21304237-5515161',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000137,NULL,'15.1r',0.28,'S',NULL,NULL,NULL,NULL,1,322.676667,-55.25458,0.141,NULL,48668188317,760440442,11881881,15.1),(150827,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150827,37.13,0.21,267,71672,70,NULL,NULL,'2MASX J21304442+1041269',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,322.6849583,10.69081,0.145,NULL,52110295125,814223361,12722240,17),(150828,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150828,36.72,0.46,221,71673,70,NULL,NULL,'2MASX J21304658-0750079',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000088,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.6940417,-7.83544,0.073,NULL,49693905394,776467271,12132301,16.6),(150829,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150829,41.46,NULL,1960,71674,70,NULL,'Pseudo z = 0.64','GRB 030823',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,322.695833,21.98333,0.321,NULL,55156276263,861816816,13465887,NULL),(150830,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16768','R',150830,38.97,0.28,531,71675,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 16768',0.168949,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.7005417,0.69283,0.205,NULL,52103490484,814117038,12720578,NULL),(150831,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16768','R',150831,39.19,0.21,589,71675,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 16768',0.168949,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150832,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09148','RN',150832,42.54,0.24,2230,71676,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09148',0.450222,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150833,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150833,37.13,0.21,267,71677,70,NULL,NULL,'SDSS J213048.58+103442.3',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,322.7024583,10.57842,0.145,NULL,52113709907,814276717,12723073,17.3),(150834,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150834,36.22,0.49,176,71678,70,NULL,NULL,'FAIRALL 0972',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.000133,NULL,'14.0r',0.68,'E',NULL,NULL,NULL,NULL,1,322.7249583,-51.42253,0,NULL,50613680761,790838761,12356855,14),(150835,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01632','R',150835,39.03,0.07,605,71679,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01632',0.057524,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,322.725958333,-0.13394,0.157,NULL,49701329714,776583276,12134113,NULL),(150836,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01632','R',150836,39.79,0.2,857,71679,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01632',0.057524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150837,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150837,38.64,0.46,535,71680,70,NULL,NULL,'SDSS J213056.06+112406.8',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000132,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,322.733625,11.40189,0.233,NULL,55046653691,860103963,13439124,19),(150838,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15531','RN',150838,41.82,0.25,1890,71681,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15531',0.227575,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150839,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15531','RN',150839,42.42,0.33,2490,71681,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15531',0.227575,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150840,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150840,36.38,0.2,189,71682,74.4,NULL,NULL,'IC 5115',NULL,'2013AJ....146...86T',2013,1,0.77,NULL,'G',0.000166,NULL,'15.7g',0.46,'Sbc',NULL,NULL,NULL,NULL,1,322.7387083,11.7635,0.245,NULL,55047088254,860110753,13439230,15.7),(150841,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150841,35.08,0.18,101,71683,74.2,NULL,'SALT 2','UGC 11758',0.0276,'2010ApJ...716..712A',2010,1,1.74,NULL,'G',0.000015,NULL,'15.31',0.24,'Sbc',NULL,NULL,NULL,NULL,1,322.740083,13.98608,0.293,NULL,55132305040,861442266,13460035,15.31),(150842,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150842,35.5,0.1,119,71683,72,NULL,NULL,'UGC 11758',0.02762,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150843,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150843,35.68,0.14,133,71683,73.8,NULL,'SALT 2 (SNANA)','UGC 11758',0.0277,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150844,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150844,35.72,0.19,135,71683,70,NULL,'SALT 2','UGC 11758',0.0276,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150845,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150845,35.66,0.1,136,71683,74.4,NULL,NULL,'UGC 11758',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150846,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ev',NULL,150846,35.66,0.07,136,71683,72,NULL,'M(H) = -18.317 mag','UGC 11758',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150847,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150847,35.21,NULL,110,71683,NULL,NULL,NULL,'UGC 11758',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150848,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150848,35.33,NULL,116,71683,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150849,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150849,35.34,0.47,117,71683,NULL,NULL,'H','UGC 11758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150850,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150850,35.35,NULL,118,71683,NULL,NULL,'Dipole + Quadrupole','UGC 11758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150851,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150851,35.38,NULL,119,71683,NULL,NULL,'Dipole','UGC 11758',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150852,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150852,35.39,0.45,119,71683,NULL,NULL,'K','UGC 11758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150853,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150853,35.38,0.49,119,71683,75,NULL,'IR','UGC 11758',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150854,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150854,35.41,0.4,121,71683,NULL,NULL,'mean','UGC 11758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150855,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150855,35.44,0.46,122,71683,NULL,NULL,'J','UGC 11758',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150856,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150856,36.19,0.43,173,71683,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11758',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150857,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150857,37.32,0.46,291,71684,70,NULL,NULL,'2MASX J21310349-0034340',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,322.7645417,-0.57622,0.137,NULL,49701241305,776581895,12134092,16.9),(150858,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150858,37.02,0.46,254,71685,70,NULL,NULL,'2MASX J21310778+1128267',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,322.7822917,11.47406,0.233,NULL,55046932466,860108319,13439192,16.9),(150859,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15101',NULL,150859,39.04,0.66,642,71686,70,NULL,'SN photometric redshift distance, z photo =0.163 +/- 0.066','SDSS-II SN 15101',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.5g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,322.7850417,-0.48614,0.137,NULL,49701410293,776584535,12134133,20.5),(150860,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15101','R',150860,40.54,0.27,1090,71686,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15101',0.18195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150861,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15101','R',150861,40.56,0.25,1090,71686,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15101',0.18195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150862,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150862,34.1,NULL,65.9,71687,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2328',NULL,'2010Ap&SS.325..163P',2010,1,0.76,NULL,'G',0.000011,NULL,'17.3',0.08,'Scd',NULL,NULL,NULL,NULL,1,322.8,3.28028,0.177,NULL,52128944544,814514758,12726793,17.3),(150863,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150863,34.12,NULL,66.6,71687,NULL,NULL,'Dipole + Quadrupole','FGC 2328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150864,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150864,34.12,NULL,66.6,71687,NULL,NULL,'Dipole','FGC 2328',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150865,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150865,34.23,NULL,70,71687,NULL,NULL,NULL,'FGC 2328',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150866,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150866,40.48,0.15,952,71688,74.2,NULL,'SALT 2','SDSS J213115.62-010326.3',0.31,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'21.1g',0.07,NULL,NULL,NULL,NULL,NULL,1,322.815125,-1.05733,0.145,NULL,49701079641,776579369,12134052,21.1),(150867,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150867,40.79,0.05,1100,71688,70,NULL,'SDSS 6699','SDSS J213115.62-010326.3',0.31,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150868,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150868,41.06,0.19,1250,71688,72,NULL,'SDSS 6699','SDSS J213115.62-010326.3',0.31,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150869,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06699','R',150869,41.19,0.26,1320,71688,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ik','SDSS J213115.62-010326.3',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150870,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150870,41.22,NULL,1340,71688,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06699, SN 2005ik','SDSS J213115.62-010326.3',0.31,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150871,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150871,41.24,0.18,1350,71688,65,NULL,'SALT2','SDSS J213115.62-010326.3',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150872,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150872,41.28,0.18,1380,71688,70,NULL,'SDSS 6699, SALT 2','SDSS J213115.62-010326.3',0.31,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (150873,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06699','R',150873,41.47,0.17,1500,71688,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ik','SDSS J213115.62-010326.3',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150874,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005ik',NULL,150874,41.48,0.12,1510,71688,65,NULL,'MLCS2k2','SDSS J213115.62-010326.3',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150875,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150875,35.32,0.61,116,71689,NULL,NULL,NULL,'ESO 465- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.9r',0.6,'Sb',NULL,NULL,NULL,NULL,1,322.836167,-29.26106,0.145,NULL,51469461328,804210333,12565786,14.9),(150876,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150876,35.36,0.2,118,71689,74.4,NULL,NULL,'ESO 465- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150877,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150877,35.57,0.54,130,71689,NULL,NULL,'Malmquist cor.','ESO 465- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150878,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150878,35.79,0.66,144,71690,70,NULL,NULL,'2MFGC 16267',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000084,NULL,'16.5g',0.15,'Sb(f)',NULL,NULL,NULL,NULL,1,322.838375,-6.43744,0.121,NULL,49683450323,776303911,12129748,16.5),(150879,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150879,37.96,0.33,391,71691,70,NULL,NULL,'SDSS J213121.55-080438.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000072,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,322.839833,-8.07742,0.121,NULL,49694067491,776469804,12132340,17.6),(150880,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'RN',150880,46.04,1.47,5770,71692,NULL,NULL,NULL,'GRB 080514B HOST',1.8,'2010JCAP...08..020W',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150881,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150881,37.96,0.33,391,71693,70,NULL,NULL,'SDSS J213127.38-075948.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000073,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.864125,-7.99669,0.073,NULL,49693409370,776459521,12132180,18.5),(150882,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150882,37.19,0.33,274,71694,70,NULL,NULL,'2MASX J21312871+1055167',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,322.869666667,10.92122,0.165,NULL,52110335048,814223985,12722249,17.8),(150883,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150883,37.33,0.46,293,71695,70,NULL,NULL,'2MASX J21312947-0833578',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000093,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,322.872875,-8.56619,0.105,NULL,49693274003,776457406,12132146,16.3),(150884,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150884,37.19,0.33,274,71696,70,NULL,NULL,'2MASX J21313013+1053267',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,322.875625,10.89081,0.165,NULL,52110333716,814223964,12722249,17.3),(150885,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150885,34.53,0.5,80.4,71697,70,NULL,NULL,'2MASX J21313030-5719205',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000087,NULL,'14.1r',0.48,'S0',NULL,NULL,NULL,NULL,1,322.8762917,-57.32236,0.113,NULL,48661413236,760334581,11880227,14.1),(150886,'D-Sigma','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150886,34.11,0.4,66.3,71698,75,NULL,'Edat, raw','NGC 7075',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000067,NULL,'14.13',0.9,'E+?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,322.887416667,-38.61792,0.089,NULL,51475843519,804310054,12567344,14.13),(150887,'D-Sigma','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150887,34.44,0.4,77.4,71698,75,NULL,'Edat, cor','NGC 7075',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150888,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150888,34.37,0.4,74.8,71698,NULL,NULL,'mean','NGC 7075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150889,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150889,34.76,0.45,89.4,71698,NULL,NULL,'K','NGC 7075',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150890,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150890,38.16,0.46,429,71699,70,NULL,NULL,'SDSS J213133.24+110645.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000141,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,322.8885417,11.11256,0.193,NULL,55046803063,860106297,13439160,18.3),(150891,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18647','R',150891,40.25,0.22,924,71700,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J213134.36-001810.3',0.212839,'2014arXiv1401.3317S',2014,1,0.21,NULL,'G',0.00016,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,322.893167,-0.30289,0.133,NULL,49701368472,776583882,12134123,18.2),(150892,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18647','R',150892,40.43,0.16,1010,71700,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J213134.36-001810.3',0.212839,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150893,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18647',NULL,150893,40.06,0.16,1030,71700,70,NULL,'SALT 2','SDSS J213134.36-001810.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150894,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 18647',NULL,150894,40.08,0.16,1040,71700,70,NULL,'SALT 2, Malmquist cor.','SDSS J213134.36-001810.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150895,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150895,35.84,0.57,147,71701,70,NULL,NULL,'ESO 287- G 033',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000024,NULL,'13.7r',1,'SAB(r)bc',NULL,NULL,NULL,NULL,1,322.898667,-46.88742,0.025,NULL,50638773776,791230840,12362981,13.7),(150896,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20574','RN',150896,43.6,0.3,3520,71702,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20574',0.491039,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150897,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150897,36.92,0.58,242,71703,70,NULL,NULL,'2MASX J21313608-1040248',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.81',0.34,NULL,NULL,NULL,NULL,NULL,1,322.900375,-10.67367,0.121,NULL,49680770811,776262043,12129094,16.81),(150898,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150898,35.06,0.46,103,71704,70,NULL,NULL,'CGCG 426-062',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000113,NULL,'14.8g',0.69,'E0',NULL,NULL,NULL,NULL,1,322.9065417,11.83161,0.245,NULL,55047029227,860109831,13439216,14.8),(150899,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150899,38.21,0.46,438,71705,70,NULL,NULL,'2MASX J21314097+1009391',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,322.9207917,10.16094,0.149,NULL,52113827090,814278548,12723102,17.3),(150900,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150900,33.43,0.2,48.5,71706,74.4,NULL,NULL,'CGCG 426-063',NULL,'2013AJ....146...86T',2013,1,0.42,NULL,'G',NULL,NULL,'15.7',0.17,NULL,NULL,NULL,NULL,NULL,1,322.92625,12.47778,0.289,NULL,55264320611,863505009,13492265,15.7),(150901,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150901,36.49,0.69,198,71707,70,NULL,NULL,'2MFGC 16275',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00007,NULL,'15.1r',0.17,'S',NULL,NULL,NULL,NULL,1,322.9285,-68.91244,0.021,NULL,49330152837,770783638,12043494,15.1),(150902,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150902,35.23,0.2,111,71708,74.4,NULL,NULL,'CGCG 376-001',NULL,'2013AJ....146...86T',2013,1,0.81,NULL,'G',0.000133,NULL,'15.5g',0.45,'Sc',NULL,NULL,NULL,NULL,1,322.9287917,0.35781,0.161,NULL,52103563137,814118174,12720596,15.5),(150903,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150903,37,0.46,251,71709,70,NULL,NULL,'2MASX J21314403+1122521',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000178,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,322.933375,11.38122,0.233,NULL,55046694542,860104602,13439134,16.9),(150904,'GRB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150904,49.65,1.1,13900,71710,69.7,NULL,'Fiducial','GRB 060522',5.11,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,322.936875,2.88633,0.177,NULL,52105897377,814154646,12721166,NULL),(150905,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11017','R',150905,41.49,0.26,1640,71711,70,NULL,'SDSS CAND. zSNII; MLCS2K2; SN 2005mj','SN 2005mj',0.21,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'IIn?',NULL,NULL,NULL,NULL,1,322.956,-1.06939,0.117,NULL,49701154953,776580546,12134071,NULL),(150906,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11017','R',150906,42.17,0.41,2240,71711,70,NULL,'SDSS CAND. zSNII; SALT 2; SN 2005mj','SN 2005mj',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150907,'BL Lac Luminosity','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150907,41.87,NULL,2360,71712,70,NULL,'nucleus-to-host flux ratio, z > 0.86','2MASS J21315152-2515588',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'18.0R',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,322.96375,-25.26633,0.133,NULL,51430985956,803609155,12556393,18),(150908,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150908,36.51,0.61,201,71713,70,NULL,NULL,'2MASX J21315150-1110068',NULL,'2014MNRAS.445.2677S',2014,1,0.49,'The APM image includes a faint star or companion.','G',0.00015,NULL,'16.39',0.33,NULL,NULL,NULL,NULL,NULL,1,322.964583,-11.16858,0.141,NULL,50768279025,793254359,12394599,16.39),(150909,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150909,34.46,0.58,77.8,71714,70,NULL,NULL,'ESO 287- G 035',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.38',0.6,'SAB(r)a        LLAGN','in an interacting pair',NULL,NULL,NULL,1,322.969375,-46.05853,0.049,NULL,50638580832,791227825,12362934,14.38),(150910,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150910,35.68,0.46,137,71715,70,NULL,NULL,'2MASX J21315376-0000292',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000145,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,322.974125,-0.00814,0.129,NULL,49700510118,776570470,12133913,16.4),(150911,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150911,37.01,0.55,253,71716,70,NULL,NULL,'2MASX J21315605-6250285',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'14.8r',0.45,NULL,NULL,NULL,NULL,NULL,1,322.9834583,-62.84122,0.049,NULL,49171602275,768306285,12004785,14.8),(150912,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150912,37.31,0.46,290,71717,70,NULL,NULL,'2MASX J21315710-0821018',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000083,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,322.988083,-8.3505,0.089,NULL,49693993313,776468645,12132322,16.9),(150913,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150913,37.7,0.46,347,71718,70,NULL,NULL,'2MASX J21315818-0016272',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00018,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,322.9925417,-0.27419,0.133,NULL,49700502184,776570346,12133911,17.6),(150914,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150914,38.03,0.46,403,71719,70,NULL,NULL,'2MASX J21320101-0045291',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000134,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,323.00425,-0.758,0.137,NULL,49701291187,776582674,12134104,17.2),(150915,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150915,34.89,0.49,94.9,71720,75,NULL,'IR','ESO 465- G 006',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'14.7r',0.3,'(R?)SB0^+:',NULL,NULL,NULL,NULL,1,323.0167083,-30.82189,0.073,NULL,51458975232,804046488,12563226,14.7),(150916,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150916,35.21,0.66,110,71720,NULL,NULL,NULL,'ESO 465- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150917,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150917,35.25,0.65,112,71720,NULL,NULL,'Malmquist cor.','ESO 465- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150918,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150918,35.26,0.2,113,71720,74.4,NULL,NULL,'ESO 465- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150919,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150919,36.7,0.46,219,71721,70,NULL,NULL,'2MASX J21320546-0641013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000084,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,323.022833,-6.68383,0.085,NULL,49683621479,776306585,12129790,16.8),(150920,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150920,36.73,0.62,222,71722,70,NULL,NULL,'2MASX J21320623-1107443',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.09',0.25,NULL,NULL,NULL,NULL,NULL,1,323.0259583,-11.12889,0.141,NULL,49677974117,776218345,12128411,17.09),(150921,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02064','RN',150921,41.66,0.42,1480,71723,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02064',0.456693,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150922,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150922,37.76,0.46,356,71724,70,NULL,NULL,'SDSS J213208.11+111745.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,323.033791667,11.29589,0.233,NULL,55046692555,860104571,13439133,18.4),(150923,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150923,37.84,0.46,369,71725,70,NULL,NULL,'2MASX J21320925+1049325',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000171,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.0385,10.82556,0.161,NULL,52110533894,814227092,12722298,17),(150924,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150924,37.08,0.46,261,71726,70,NULL,NULL,'2MASX J21320952+1036015',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,323.039625,10.60039,0.165,NULL,52113918056,814279969,12723124,17.2),(150925,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13323','R',150925,40.49,0.21,1010,71727,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13323',0.23262,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.051167,-0.13475,0.129,NULL,49700515353,776570552,12133914,NULL),(150926,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13323','R',150926,40.61,0.14,1080,71727,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13323',0.23262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150927,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16294','RN',150927,40.7,0.25,1220,71728,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16294',0.137498,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150928,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16294','RN',150928,42.38,0.42,2630,71728,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16294',0.137498,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150929,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150929,37.06,0.46,259,71729,70,NULL,NULL,'2MASX J21321338+1017365',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000189,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,323.05575,10.29342,0.169,NULL,52113788445,814277944,12723092,16.4),(150930,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150930,34.04,0.64,64.2,71730,70,NULL,NULL,'ESO 236- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1.45,NULL,'G',0.000133,NULL,'13.7r',0.29,'S0',NULL,NULL,NULL,NULL,1,323.056375,-48.00411,0.025,NULL,50655440235,791491253,12367050,13.7),(150931,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13768',NULL,150931,39.93,0.14,966,71731,70,NULL,'SN photometric redshift distance, z photo =0.258 +/- 0.020','SDSS-II SN 13768',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,323.0759583,-0.76319,0.133,NULL,49701294688,776582729,12134105,NULL),(150932,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829',NULL,150932,40.14,0.26,1070,71732,70,NULL,'SN photometric redshift distance, z photo =0.290 +/- 0.045','SDSS-II SN 15829',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,323.0855,-0.76231,0.133,NULL,49701294656,776582729,12134105,NULL),(150933,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829','R',150933,40.93,0.2,1230,71732,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15829',0.248862,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150934,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829','R',150934,40.99,0.27,1270,71732,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15829',0.248862,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150935,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829',NULL,150935,40.9,0.15,1510,71732,70,NULL,'SALT 2','SDSS-II SN 15829',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150936,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15829',NULL,150936,40.92,0.15,1530,71732,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15829',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150937,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14985','RN',150937,39.26,0.6,653,71733,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14985',0.088652,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150938,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14985','RN',150938,39.43,0.4,707,71733,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14985',0.088652,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150939,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150939,36.54,0.46,203,71734,70,NULL,NULL,'2MASX J21322519+1232508',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000181,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,323.105166667,12.54761,0.293,NULL,55264360770,863505637,13492275,17),(150940,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150940,36.47,0.7,197,71735,70,NULL,NULL,'2MASX J21322541-5149077',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'15.1r',0.48,NULL,NULL,NULL,NULL,NULL,1,323.105875,-51.81875,0,NULL,50613275683,790832432,12356756,15.1),(150941,'Black Hole','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150941,37.61,0.32,333,71736,NULL,NULL,NULL,'UGC 11763',NULL,'2014ApJ...793..108W',2014,1,0.5,NULL,'G',0.0001,NULL,'14.3V',0.2,'(R)Sa          Sy1',NULL,NULL,NULL,'Sy 1.5',1,323.115875,10.13875,0.169,NULL,52114075450,814282428,12723162,14.3),(150942,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150942,35.16,0.58,108,71737,70,NULL,NULL,'FAIRALL 0101',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'15.0r',0.18,'Compact',NULL,NULL,NULL,NULL,1,323.120791667,-76.32211,0.405,NULL,48530155553,758283680,11848182,15),(150943,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150943,36.69,0.66,218,71738,70,NULL,NULL,'2MASX J21322926-7141119',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'14.8r',0.42,NULL,NULL,NULL,NULL,NULL,1,323.122,-71.68664,0.069,NULL,49306013265,770406457,12037600,14.8),(150944,'Faber-Jackson','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150944,30.52,0.65,12.7,71739,95,NULL,'Weighted Mean','NGC 7079',NULL,'1984ApJS...56...91D',1984,1,2.1,NULL,'G',0.000053,NULL,'12.46',1.3,'(L)SB(r)0^0    LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,323.146875,-44.06756,0.029,NULL,51364706984,802573546,12540211,12.46),(150945,'Faber-Jackson','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150945,31.62,0.81,21.1,71739,55,NULL,'Visvanathan & Sandage 1979','NGC 7079',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150946,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150946,32.35,0.52,29.5,71739,70,NULL,NULL,'NGC 7079',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150947,'Tully est','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150947,32.65,0.8,33.9,71739,75,NULL,'B','NGC 7079',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150948,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150948,32.11,0.45,26.4,71739,NULL,NULL,'K','NGC 7079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150949,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150949,32.73,0.4,35.1,71739,NULL,NULL,'mean','NGC 7079',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150950,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060',NULL,150950,40.96,0.28,1550,71740,70,NULL,'SN photometric redshift distance, z photo =0.462 +/- 0.088','SDSS-II SN 21060',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,323.168875,0.31361,0.125,NULL,52102946758,814108543,12720445,22.6),(150951,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060','R',150951,41.75,0.31,1590,71740,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21060',0.409255,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150952,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060','R',150952,42.02,0.34,1800,71740,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21060',0.409255,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150953,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060',NULL,150953,41.63,0.21,2120,71740,70,NULL,'SALT 2','SDSS-II SN 21060',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150954,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21060',NULL,150954,41.7,0.21,2190,71740,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21060',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150955,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150955,37.59,0.46,330,71741,70,NULL,NULL,'2MASX J21324137-0713219',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000082,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.172417,-7.22281,0.077,NULL,49683059164,776297799,12129653,17.1),(150956,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150956,37.76,0.46,356,71742,70,NULL,NULL,'2MASX J21324159-0823209',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000075,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,323.1732917,-8.38917,0.089,NULL,49692344780,776442887,12131920,17.8),(150957,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150957,36.02,0.7,160,71743,70,NULL,NULL,'CGCG 376-008',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'15.2g',0.5,'Sb',NULL,NULL,NULL,NULL,1,323.174,-0.12783,0.129,NULL,49700644479,776572569,12133946,15.2),(150958,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20721','R',150958,40.18,0.26,898,71744,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J213244.34-003721.8',0.2118,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.0001,NULL,'19.2g',0.1,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.1847917,-0.62275,0.145,NULL,49700546063,776571032,12133922,19.2),(150959,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20721','R',150959,40.25,0.17,925,71744,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J213244.34-003721.8',0.2118,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150960,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20721',NULL,150960,39.99,0.21,995,71744,70,NULL,'SALT 2','SDSS J213244.34-003721.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150961,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20721',NULL,150961,40,0.21,1000,71744,70,NULL,'SALT 2, Malmquist cor.','SDSS J213244.34-003721.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150962,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150962,37.12,0.46,266,71745,70,NULL,NULL,'2MASX J21324737-0749539',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000081,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,323.197375,-7.83169,0.101,NULL,49693366090,776458845,12132169,16.5),(150963,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150963,35.14,0.46,107,71746,70,NULL,NULL,'2MASX J21324774-0647229',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000069,NULL,'15.5g',0.4,'S0/a',NULL,NULL,NULL,NULL,1,323.198833,-6.78981,0.085,NULL,49683411151,776303299,12129739,15.5),(150964,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150964,35.24,0.5,112,71746,70,NULL,NULL,'2MASX J21324774-0647229',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150965,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15892','R',150965,39.55,0.14,687,71747,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15892',0.18408,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.1989583,0.68939,0.177,NULL,52103624659,814119135,12720611,NULL),(150966,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15892','R',150966,39.61,0.21,704,71747,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15892',0.18408,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150967,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14619',NULL,150967,41.21,0.19,1750,71748,70,NULL,'SN photometric redshift distance, z photo =0.542 +/- 0.070','SDSS-II SN 14619',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,323.20875,-0.06067,0.137,NULL,49700434413,776569287,12133895,NULL),(150968,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150968,35.65,0.39,135,71749,NULL,NULL,'Malmquist cor.','IC 5108',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.07',0.4,'(R\')SB(s)bc',NULL,NULL,NULL,NULL,1,323.214583,-72.65969,0.089,NULL,49294788272,770231066,12034860,15.07),(150969,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150969,35.85,0.35,148,71749,NULL,NULL,NULL,'IC 5108',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150970,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150970,35.89,0.2,151,71749,74.4,NULL,NULL,'IC 5108',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150971,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150971,37.43,0.46,306,71750,70,NULL,NULL,'SDSS J213251.84+103443.4',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000164,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,323.216,10.57875,0.165,NULL,52113895637,814279619,12723119,18.1),(150972,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065',NULL,150972,39.06,0.6,649,71751,70,NULL,'SN photometric redshift distance, z photo =0.165 +/- 0.059','SDSS-II SN 20065',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'*',NULL,'PHOT','22.1g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,323.223,-0.94672,0.133,NULL,49701049211,776578893,12134045,22.1),(150973,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065','R',150973,40.84,0.24,1120,71751,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20065',0.309838,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150974,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065','R',150974,40.97,0.28,1190,71751,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20065',0.309838,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150975,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065',NULL,150975,40.83,0.18,1470,71751,70,NULL,'SALT 2','SDSS-II SN 20065',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150976,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20065',NULL,150976,40.86,0.18,1490,71751,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20065',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150977,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150977,36.33,0.46,185,71752,70,NULL,NULL,'2MASX J21325346-0711479',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000095,NULL,'15.7g',0.42,'E0',NULL,NULL,NULL,NULL,1,323.222875,-7.19672,0.077,NULL,49683081678,776298151,12129658,15.7),(150978,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150978,39.02,0.12,540,71753,74.2,NULL,'SALT 2','SDSS J213256.13-004200.2',0.18,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',0.0005,NULL,'19.9g',0.08,NULL,NULL,NULL,NULL,NULL,1,323.233875,-0.70006,0.145,NULL,49701258877,776582169,12134096,19.9),(150979,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150979,39.23,0.07,702,71753,70,NULL,'Hubble residual -0.01 for z0.18100','SDSS J213256.13-004200.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150980,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150980,39.68,0.13,732,71753,70,NULL,'SALT 2','SDSS J213256.13-004200.2',0.18,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150981,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06936','R',150981,39.73,0.19,748,71753,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jl','SDSS J213256.13-004200.2',0.181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150982,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150982,39.75,0.08,755,71753,65,NULL,'SALT2','SDSS J213256.13-004200.2',0.18,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150983,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150983,39.76,0.03,758,71753,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06936, SN 2005jl','SDSS J213256.13-004200.2',0.18,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150984,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150984,39.81,NULL,776,71753,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06936, SN 2005jl','SDSS J213256.13-004200.2',0.18,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150985,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150985,39.92,0.09,815,71753,65,NULL,'MLCS2k2','SDSS J213256.13-004200.2',0.18,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150986,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06936','R',150986,39.94,0.1,823,71753,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jl','SDSS J213256.13-004200.2',0.181,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150987,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150987,39.59,0.07,828,71753,70,NULL,'SALT 2','SDSS J213256.13-004200.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150988,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jl',NULL,150988,39.6,0.07,832,71753,70,NULL,'SALT 2, Malmquist cor.','SDSS J213256.13-004200.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150989,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,150989,35.08,0.55,104,71754,70,NULL,NULL,'2MASX J21325855-4803005',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'14.8r',0.23,'S',NULL,NULL,NULL,NULL,1,323.2440417,-48.05006,0.025,NULL,50655450565,791491415,12367053,14.8),(150990,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150990,37.14,0.46,267,71755,70,NULL,NULL,'SDSS J213301.06-074115.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,323.2544583,-7.68758,0.081,NULL,49693329983,776458280,12132160,17.5),(150991,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17895','RN',150991,39.88,0.13,779,71756,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17895',0.213018,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150992,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17895','RN',150992,40.42,0.26,1000,71756,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17895',0.213018,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150993,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150993,37.6,0.33,332,71757,70,NULL,NULL,'SDSS J213304.64+103614.0',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000162,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,323.269333,10.60392,0.165,NULL,52113850008,814278906,12723107,18.3),(150994,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21315','RN',150994,43.53,0.25,3540,71758,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21315',0.436423,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150995,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21315','RN',150995,44.64,0.66,5890,71758,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21315',0.436423,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150996,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007ih',NULL,150996,39.4,0.1,759,71759,70,NULL,'Hubble residual 0.27 for z0.17060','SDSS-II SN 17389 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.295,-0.96008,0.133,NULL,49709246744,776706980,12136046,NULL),(150997,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17389','R',150997,39.88,0.2,809,71759,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ih','SDSS-II SN 17389 HOST',0.170901,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150998,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17389','R',150998,39.93,0.12,827,71759,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ih','SDSS-II SN 17389 HOST',0.170901,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(150999,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',150999,36.79,0.33,229,71760,70,NULL,NULL,'2MASX J21331089+1152293',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000205,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,323.2954583,11.87483,0.253,NULL,55046270362,860097974,13439030,16.3),(151000,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151000,37.6,0.33,332,71761,70,NULL,NULL,'2MASX J21331110+1038393',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000203,NULL,'16.2g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,323.296333333,10.64419,0.161,NULL,52113849039,814278891,12723107,16.2),(151001,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151001,38.11,0.27,420,71762,70,NULL,NULL,'2MASX J21331555-0841559',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000089,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,323.3147083,-8.699,0.105,NULL,49692720602,776448759,12132011,17.2),(151002,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151002,38.82,0.46,581,71763,70,NULL,NULL,'SDSS J213315.83-071030.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,323.316,-7.17525,0.057,NULL,49683072249,776298003,12129656,18.6),(151003,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151003,36.47,0.46,197,71764,70,NULL,NULL,'2MASX J21331647+1141243',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000199,NULL,'15.9g',0.34,'S0',NULL,NULL,NULL,NULL,1,323.318625,11.69006,0.253,NULL,55046235900,860097435,13439022,15.9),(151004,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151004,36.79,0.33,229,71765,70,NULL,NULL,'II Zw 138',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000167,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,323.3202917,11.62053,0.253,NULL,55046181207,860096581,13439009,16.6),(151005,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151005,36.21,0.65,174,71766,70,NULL,NULL,'2MASX J21332265-7917580',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,323.344375,-79.29947,0.517,NULL,48576466518,759007289,11859488,16.9),(151006,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151006,35.9,0.57,151,71767,70,NULL,NULL,'2MASX J21332398-0237006',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.80',0.32,NULL,NULL,NULL,NULL,NULL,1,323.34975,-2.61681,0.153,NULL,49707692604,776682696,12135667,16.8),(151007,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151007,35.96,0.54,156,71768,70,NULL,NULL,'2MASX J21332452-3113110',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.1r',0.29,NULL,NULL,NULL,NULL,NULL,1,323.352167,-31.21964,0.097,NULL,51459024337,804047255,12563238,15.1),(151008,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17687','RN',151008,41.44,0.49,1490,71769,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17687',0.303225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151009,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17687','RN',151009,41.46,0.49,1500,71769,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17687',0.303225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151010,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17687','N',151010,41.28,0.38,1800,71769,70,NULL,'SALT 2','SDSS-II SN 17687',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151011,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17687','N',151011,41.31,0.38,1830,71769,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17687',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151012,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15339','R',151012,39.82,0.2,820,71770,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006ns','SN 2006ns',0.119964,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,323.38425,0.78483,0.165,NULL,52107753594,814183649,12721619,NULL),(151013,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15339','R',151013,39.88,0.08,845,71770,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006ns','SN 2006ns',0.119964,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151014,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151014,34.66,0.8,85.3,71771,75,NULL,'CF, r','UGC 11765',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.99',0.6,'Sb',NULL,NULL,NULL,NULL,1,323.3882083,8.77247,0.129,NULL,52124008924,814437639,12725588,14.99),(151015,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151015,34.73,0.52,88.2,71771,NULL,NULL,NULL,'UGC 11765',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151016,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151016,34.78,0.38,90.5,71771,75,NULL,'CF, r, raw','UGC 11765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151017,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151017,34.79,0.2,90.8,71771,74.4,NULL,NULL,'UGC 11765',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151018,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151018,34.8,0.5,91.3,71771,NULL,NULL,'Malmquist cor.','UGC 11765',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151019,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151019,34.88,0.38,94.5,71771,75,NULL,'CF, r, inv','UGC 11765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151020,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151020,35.09,0.38,104,71771,75,NULL,'CF, r, cor','UGC 11765',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151021,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151021,32.21,0.43,27.7,71772,75,NULL,'3.6 micron, color + selection bias corrected','2MFGC 16293',NULL,'2014MNRAS.444..527S',2014,1,1.12,'abs(b) < 10 degrees.','G',0.00002,NULL,'10.6K',0.22,'Spiral',NULL,NULL,NULL,NULL,1,323.3942083,42.72411,NULL,NULL,55668778856,869824669,13591010,10.6),(151022,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151022,37.7,0.27,346,71773,70,NULL,NULL,'2MASX J21333586+1125194',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000172,NULL,'16.6g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,323.399417,11.42208,0.201,NULL,52111003773,814234433,12722413,16.6),(151023,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151023,37.7,0.27,346,71774,70,NULL,NULL,'2MASX J21334062+1128124',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00019,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,323.4192917,11.47008,0.201,NULL,52110156743,814221199,12722206,16.8),(151024,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15175','RN',151024,40.95,0.6,1410,71775,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15175',0.103089,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151025,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151025,35.75,0.57,141,71776,70,NULL,NULL,'ESO 107- G 035',NULL,'2014MNRAS.445.2677S',2014,1,0.92,NULL,'G',0.000133,NULL,'14.43',0.58,'S0?',NULL,NULL,NULL,NULL,1,323.431166667,-63.57756,0.053,NULL,49166712652,768229885,12003591,14.43),(151026,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14624',NULL,151026,40.54,1.02,1280,71777,70,NULL,'SN photometric redshift distance, z photo =0.361 +/- 0.323','SDSS-II SN 14624',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.440958333,0.34558,0.157,NULL,52106934039,814170844,12721419,21.2),(151027,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14624','R',151027,41.54,0.25,1420,71777,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14624',0.434864,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151028,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14624',NULL,151028,40.78,0.3,1430,71777,70,NULL,NULL,'SDSS-II SN 14624',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151029,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14624','R',151029,41.86,0.29,1640,71777,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14624',0.434864,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151030,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151030,36.68,0.46,217,71778,70,NULL,NULL,'2MASX J21334814-0650421',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000084,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,323.4505417,-6.845,0.085,NULL,49683235788,776300559,12129696,16.8),(151031,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151031,38.11,0.27,420,71779,70,NULL,NULL,'2MASX J21334833-0830461',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000086,NULL,'17.4g',0.21,'BrClG',NULL,NULL,NULL,NULL,1,323.45125,-8.51294,0.125,NULL,49692847244,776450738,12132042,17.4),(151032,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12842','R',151032,39.48,0.05,722,71780,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006ez','SN 2006ez',0.0887,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,323.45525,-1.01594,0.133,NULL,49709226338,776706661,12136041,NULL),(151033,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12842','R',151033,39.58,0.18,756,71780,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006ez','SN 2006ez',0.0887,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151034,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151034,38.11,0.27,420,71781,70,NULL,NULL,'2MASX J21335143-0837291',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000089,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,323.4644583,-8.62486,0.105,NULL,49693041103,776453767,12132090,17.6),(151035,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151035,37.7,0.27,346,71782,70,NULL,NULL,'SDSS J213352.49+113008.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000158,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,323.46875,11.50236,0.261,NULL,52110126046,814220719,12722198,18.6),(151036,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151036,36.2,0.67,174,71783,70,NULL,NULL,'2MASX J21335255-5540483',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.99',0.3,NULL,NULL,NULL,NULL,NULL,1,323.4689583,-55.68008,0.077,NULL,48666785054,760418516,11881539,15.99),(151037,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151037,37.72,0.46,350,71784,70,NULL,NULL,'2MASX J21335291+1026234',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000185,NULL,'16.7g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,323.470583333,10.43972,0.193,NULL,52113532397,814273943,12723030,16.7),(151038,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11083','RN',151038,39.68,0.26,768,71785,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11083',0.121929,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151039,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 11083','RN',151039,39.96,0.26,877,71785,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11083',0.121929,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151040,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151040,34.37,0.4,74.8,71786,NULL,NULL,'mean','IC 5119',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000067,NULL,'15.35',0.2,'Sa',NULL,NULL,NULL,NULL,1,323.4827083,21.83792,0.353,NULL,55156558993,861821234,13465956,15.35),(151041,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151041,34.41,0.47,76.4,71786,NULL,NULL,'H','IC 5119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151042,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151042,34.44,0.45,77.4,71786,NULL,NULL,'K','IC 5119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151043,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151043,34.5,0.46,79.4,71786,NULL,NULL,'J','IC 5119',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151044,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151044,34.75,0.2,89.1,71786,74.4,NULL,NULL,'IC 5119',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151045,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151045,34.77,0.43,89.8,71786,75,NULL,'3.6 micron, color corrected','IC 5119',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151046,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151046,34.89,0.43,95.1,71786,75,NULL,'3.6 micron, color + selection bias corrected','IC 5119',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151047,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007ow',NULL,151047,39.54,0.14,808,71787,70,NULL,'Hubble residual -0.01 for z0.21160','SDSS J213402.01-004426.3',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.508375,-0.74064,0.145,NULL,49708887619,776701369,12135958,NULL),(151048,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19425','R',151048,40.02,0.17,833,71787,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007ow','SDSS J213402.01-004426.3',0.2116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151049,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19425','R',151049,40.1,0.22,864,71787,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007ow','SDSS J213402.01-004426.3',0.2116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151050,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007ow',NULL,151050,39.89,0.12,951,71787,70,NULL,'SALT 2','SDSS J213402.01-004426.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151051,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2007ow',NULL,151051,39.9,0.12,955,71787,70,NULL,'SALT 2, Malmquist cor.','SDSS J213402.01-004426.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151052,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549',NULL,151052,40.83,0.17,1470,71788,70,NULL,'SN photometric redshift distance, z photo =0.429 +/- 0.047','SDSS-II SN 15549',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.510916667,0.63364,0.185,NULL,52107063250,814172863,12721450,21.9),(151053,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549','R',151053,42.01,0.24,1740,71788,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15549',0.448849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151054,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549','R',151054,42.06,0.28,1780,71788,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15549',0.448849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151055,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549',NULL,151055,42.09,0.19,2620,71788,70,NULL,'SALT 2','SDSS-II SN 15549',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151056,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15549',NULL,151056,42.18,0.19,2730,71788,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15549',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151057,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','PTF11mty','N',151057,37.63,0.04,312,71789,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11mty',0.077,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151058,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046',NULL,151058,39.84,0.45,930,71790,70,NULL,'SN photometric redshift distance, z photo =0.247 +/- 0.068','SDSS-II SN 21046',NULL,'2011ApJ...738..162S',2011,1,0.2,NULL,'G',NULL,'PHOT','21.8g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.5239583,1.11194,0.173,NULL,52107494033,814179594,12721556,21.8),(151059,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046','R',151059,41.31,0.31,1280,71790,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 21046',0.42774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151060,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046','R',151060,41.45,0.32,1360,71790,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 21046',0.42774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151061,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046',NULL,151061,41.27,0.23,1790,71790,70,NULL,'SALT 2','SDSS-II SN 21046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151062,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21046',NULL,151062,41.35,0.23,1860,71790,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151063,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151063,31.19,0.43,17.3,71791,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7091',NULL,'2014MNRAS.444..527S',2014,1,2.1,NULL,'G',0.000007,NULL,'13.98',1.7,'SB(s)dm:',NULL,NULL,NULL,NULL,1,323.533083333,-36.65372,0.069,NULL,51441271788,803769871,12558904,13.98),(151064,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151064,35.77,0.32,142,71792,NULL,NULL,'Malmquist cor.','ESO 599- G 020',NULL,'2009ApJS..182..474S',2009,1,1.5,'1991ApJS ...75..935d gives V = 10747 +- 33.','G',0.000033,NULL,'13.9r',0.4,'SAB(s)ab pec sp',NULL,NULL,NULL,NULL,1,323.53525,-20.471,0.097,NULL,50934837974,795856843,12435263,13.9),(151065,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151065,35.95,0.47,155,71792,NULL,NULL,'H','ESO 599- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151066,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151066,35.98,0.4,157,71792,NULL,NULL,'mean','ESO 599- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151067,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151067,35.99,0.29,158,71792,NULL,NULL,NULL,'ESO 599- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151068,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151068,36.03,0.2,161,71792,74.4,NULL,NULL,'ESO 599- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151069,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151069,36.09,0.45,165,71792,NULL,NULL,'K','ESO 599- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151070,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151070,36.15,0.46,170,71792,NULL,NULL,'J','ESO 599- G 020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151071,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151071,37.5,0.46,317,71793,70,NULL,NULL,'2MASX J21340982+1005493',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000204,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,323.540875,10.09686,0.193,NULL,52113580689,814274698,12723042,16.6),(151072,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151072,37.79,0.46,362,71794,70,NULL,NULL,'SDSS J213410.47+010349.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000161,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,323.543666667,1.06381,0.173,NULL,52107775074,814183985,12721624,18),(151073,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12849','RN',151073,41.27,0.15,1460,71795,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12849',0.233317,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151074,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12849','RN',151074,41.58,0.21,1680,71795,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12849',0.233317,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151075,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09292','RN',151075,39.36,0.6,637,71796,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09292',0.166778,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151076,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15301','R',151076,40.06,0.2,792,71797,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lo','SDSS J213419.18+003520.8',0.296,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.579917,0.58911,0.185,NULL,52107089020,814173265,12721457,NULL),(151077,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006lo',NULL,151077,39.6,0.07,832,71797,70,NULL,'SALT 2','SDSS J213419.18+003520.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151078,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006lo',NULL,151078,39.61,0.07,836,71797,70,NULL,'SALT 2, Malmquist cor.','SDSS J213419.18+003520.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151079,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15301','R',151079,40.3,0.1,886,71797,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lo','SDSS J213419.18+003520.8',0.296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151080,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005jx',NULL,151080,41.03,0.22,1330,71798,74.2,NULL,'SALT 2','SDSS J213420.02-004053.0',0.21,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',NULL,NULL,'20.2g',0.06,NULL,NULL,NULL,NULL,NULL,1,323.583458333,-0.68142,0.145,NULL,49708992597,776703009,12135984,20.2),(151081,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07460','R',151081,41.96,0.31,2040,71798,70,NULL,'SDSS CAND. zSNIa; SALT 2; SN 2005jx','SDSS J213420.02-004053.0',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151082,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07460','R',151082,42.1,0.31,2170,71798,70,NULL,'SDSS CAND. zSNIa; MLCS2K2; SN 2005jx','SDSS J213420.02-004053.0',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151083,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151083,35.44,0.67,122,71799,70,NULL,NULL,'2MASX J21342018-5239511',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000103,NULL,'14.8r',0.17,'S',NULL,NULL,NULL,NULL,1,323.584,-52.66414,0,NULL,50607471539,790741742,12355339,14.8),(151084,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','PTF10qsc','N',151084,38.19,0.02,399,71800,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qsc',0.0879,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151085,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151085,36.02,0.54,160,71801,70,NULL,NULL,'2MASX J21342422-1940328',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.5r',0.23,NULL,NULL,NULL,NULL,NULL,1,323.6010417,-19.67589,0.109,NULL,50932921167,795826893,12434795,15.5),(151086,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 05626','RN',151086,38.59,0.29,480,71802,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05626',0.085817,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151087,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 05626','RN',151087,38.71,0.32,509,71802,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05626',0.085817,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151088,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151088,37.44,0.46,307,71803,70,NULL,NULL,'2MASX J21342471-0036112',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,323.603083333,-0.60322,0.125,NULL,49709003352,776703177,12135987,16.8),(151089,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151089,36.74,0.57,223,71804,70,NULL,NULL,'2MASX J21342486-0740143',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000077,NULL,'16.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,323.603667,-7.67058,0.081,NULL,49684186390,776315412,12129928,16.5),(151090,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151090,34.75,0.53,89.1,71805,70,NULL,NULL,'6dF J2134250-332507',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,323.604291667,-33.41864,0.113,NULL,51450222642,803909728,12561089,14.1),(151091,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20257','RN',151091,41.48,0.3,1520,71806,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20257',0.301715,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151092,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20257','RN',151092,41.52,0.22,1540,71806,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20257',0.301715,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151093,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151093,36.07,0.84,164,71807,70,NULL,NULL,'2MASX J21343013-4833481',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.3r',0.2,NULL,NULL,NULL,NULL,NULL,1,323.6255,-48.56336,0.013,NULL,50658451547,791538305,12367786,15.3),(151094,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151094,35.66,NULL,135,71808,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2329',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.00003,NULL,'16.6',0.1,'Scd',NULL,NULL,NULL,NULL,1,323.631875,14.68092,0.313,NULL,55133201839,861456278,13460254,16.6),(151095,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151095,35.67,NULL,136,71808,NULL,NULL,'Dipole + Quadrupole','FGC 2329',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151096,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151096,35.7,NULL,138,71808,NULL,NULL,NULL,'FGC 2329',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151097,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151097,35.7,NULL,138,71808,NULL,NULL,'Dipole','FGC 2329',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151098,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16350','R',151098,40.51,0.21,1020,71809,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ph','SDSS J213433.30-005305.9',0.24,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,NULL,'20.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,323.638791667,-0.88497,0.145,NULL,49709791628,776715494,12136179,20),(151099,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ph',NULL,151099,40.11,0.11,1050,71809,70,NULL,'SALT 2','SDSS J213433.30-005305.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151100,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006ph',NULL,151100,40.13,0.11,1060,71809,70,NULL,'SALT 2, Malmquist cor.','SDSS J213433.30-005305.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151101,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 16350','R',151101,40.63,0.14,1080,71809,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ph','SDSS J213433.30-005305.9',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151102,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151102,35.05,0.49,102,71810,75,NULL,'IR','UGC 11768',NULL,'2011yCatp016004901K',2011,1,1.31,NULL,'G',0.000012,NULL,'16.0',0.16,'Sbc',NULL,NULL,NULL,NULL,1,323.6419583,18.95086,0.373,NULL,55147988942,861687327,13463864,16),(151103,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151103,35.32,0.43,116,71810,75,NULL,'3.6 micron, color corrected','UGC 11768',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151104,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151104,35.33,NULL,116,71810,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151105,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151105,35.33,0.43,116,71810,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11768',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151106,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151106,35.34,NULL,117,71810,NULL,NULL,'Dipole + Quadrupole','UGC 11768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151107,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151107,35.35,NULL,118,71810,NULL,NULL,'Dipole','UGC 11768',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151108,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151108,35.38,NULL,119,71810,NULL,NULL,NULL,'UGC 11768',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151109,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151109,35.38,0.2,119,71810,74.4,NULL,NULL,'UGC 11768',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151110,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151110,35.43,0.37,122,71810,NULL,NULL,'Malmquist cor.','UGC 11768',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151111,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151111,35.45,0.37,123,71810,NULL,NULL,NULL,'UGC 11768',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151112,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01198','RN',151112,39.17,0.17,609,71811,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01198',0.119688,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151113,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01198','RN',151113,39.63,0.23,753,71811,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01198',0.119688,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151114,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151114,37.68,0.46,343,71812,70,NULL,NULL,'SDSS J213439.57-071641.9',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000496,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.664875,-7.27833,0.057,NULL,49684888131,776326377,12130099,17.2),(151115,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15343','R',151115,39.29,0.21,615,71813,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15343',0.174876,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.672333,0.68478,0.185,NULL,52106983607,814171618,12721431,NULL),(151116,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15343','R',151116,39.41,0.14,649,71813,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15343',0.174876,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151117,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151117,38.36,0.46,471,71814,70,NULL,NULL,'SDSS J213445.21-070211.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00007,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,323.688417,-7.03647,0.065,NULL,49685591950,776337374,12130271,18.5),(151118,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151118,38,0.33,398,71815,70,NULL,NULL,'SDSS J213445.32-083622.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,323.688833,-8.60619,0.125,NULL,49692978517,776452789,12132074,17.6),(151119,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09739','R',151119,39.74,0.16,793,71816,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09739',0.119451,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.6937917,-0.87892,0.145,NULL,49709791102,776715485,12136179,NULL),(151120,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09739','R',151120,39.83,0.24,825,71816,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 09739',0.119451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151121,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006fc',NULL,151121,38.45,0.06,490,71817,70,NULL,'Hubble residual 0.00 for z0.12170','SDSS J213446.61+011033.3',NULL,'2011ApJ...740...92G',2011,1,0.19,NULL,'G',0.0005,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,323.6949583,1.17542,0.189,NULL,52107698092,814182782,12721605,19),(151122,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12860','R',151122,38.85,0.18,526,71817,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fc','SDSS J213446.61+011033.3',0.1217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151123,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12860','R',151123,38.9,0.09,538,71817,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fc','SDSS J213446.61+011033.3',0.1217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151124,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006fc',NULL,151124,38.68,0.07,545,71817,70,NULL,'SALT 2','SDSS J213446.61+011033.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151125,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006fc',NULL,151125,38.68,0.07,545,71817,70,NULL,'SALT 2, Malmquist cor.','SDSS J213446.61+011033.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151126,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151126,36.92,0.69,242,71818,70,NULL,NULL,'2MASX J21345105-0537311',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.67',0.26,NULL,NULL,NULL,NULL,NULL,1,323.7127083,-5.62525,0.121,NULL,49714403352,776787552,12137305,16.67),(151127,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151127,35.87,0.49,150,71819,75,NULL,'IR','UGC 11770',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.6',0.15,'S',NULL,NULL,NULL,NULL,1,323.74525,1.45553,0.173,NULL,52107556164,814180565,12721571,15.6),(151128,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151128,35.84,0.16,140,71820,74.2,NULL,'SALT 2','2MASX J21345926-6244143',0.0503,'2010ApJ...716..712A',2010,1,0.47,NULL,'G',0.00015,NULL,'16.5b',0.42,'SB0',NULL,NULL,NULL,NULL,1,323.747125,-62.73736,0.037,NULL,49171715309,768308051,12004813,16.5),(151129,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151129,36.5,0.19,190,71820,72,NULL,NULL,'2MASX J21345926-6244143',0.0503,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151130,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151130,36.53,0.15,193,71820,65,NULL,'MLCS','2MASX J21345926-6244143',0.0503,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151131,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151131,36.43,0.08,193,71820,74.4,NULL,NULL,'2MASX J21345926-6244143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151132,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151132,36.56,0.13,195,71820,65,NULL,'SALT2','2MASX J21345926-6244143',0.0503,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151133,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151133,36.6,0.18,199,71820,70,NULL,'SALT 2','2MASX J21345926-6244143',0.0503,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151134,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151134,36.6,0.19,199,71820,65,NULL,'MLCS17','2MASX J21345926-6244143',0.0503,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151135,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151135,36.71,0.16,200,71820,65,NULL,'MLCS2k2','2MASX J21345926-6244143',0.0503,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151136,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151136,36.63,0.05,202,71820,70,NULL,NULL,'2MASX J21345926-6244143',0.0503,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151137,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151137,36.65,0.02,203,71820,72,NULL,NULL,'2MASX J21345926-6244143',0.0503,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151138,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151138,36.65,0.21,203,71820,65,NULL,'MLCS31','2MASX J21345926-6244143',0.0503,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151139,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151139,36.67,0.25,205,71820,65,NULL,'Template','2MASX J21345926-6244143',0.0503,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151140,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151140,36.69,0.17,207,71820,65,NULL,'MLCS2k2','2MASX J21345926-6244143',0.0503,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151141,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151141,36.69,0.19,207,71820,73.8,NULL,'SALT 2 (SNANA)','2MASX J21345926-6244143',0.0495,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151142,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151142,36.7,0.15,208,71820,70,NULL,'SALT','2MASX J21345926-6244143',0.0503,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151143,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151143,36.62,0.06,211,71820,65,NULL,'LCS','2MASX J21345926-6244143',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151144,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151144,36.76,0.18,214,71820,65,NULL,'SALT2','2MASX J21345926-6244143',0.0503,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151145,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151145,36.69,0.12,218,71820,70.8,NULL,NULL,'2MASX J21345926-6244143',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151146,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151146,36.8,0.1,218,71820,65,NULL,'MLCS2k2','2MASX J21345926-6244143',0.0503,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151147,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151147,36.84,0.21,222,71820,65,NULL,NULL,'2MASX J21345926-6244143',0.0503,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151148,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151148,36.85,0.07,223,71820,65,NULL,'MLCS','2MASX J21345926-6244143',0.0503,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151149,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151149,36.87,0.14,225,71820,65,NULL,'SALT','2MASX J21345926-6244143',0.0503,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151150,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151150,36.89,0.02,227,71820,65,NULL,'SALT','2MASX J21345926-6244143',0.0503,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151151,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151151,36.87,0.06,237,71820,65,NULL,'Snapshot','2MASX J21345926-6244143',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151152,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151152,37.03,0.15,242,71820,70,NULL,'SALT 2','2MASX J21345926-6244143',0.0503,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151153,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151153,36.98,0.14,249,71820,60,NULL,NULL,'2MASX J21345926-6244143',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151154,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151154,37.1,0.06,263,71820,60,NULL,'M(V) = -19.47 mag','2MASX J21345926-6244143',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151155,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151155,37.1,0.6,265,71820,67,NULL,NULL,'2MASX J21345926-6244143',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151156,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151156,37.13,0.07,267,71820,60,NULL,'M(B) = -19.48 mag','2MASX J21345926-6244143',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151157,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 1990af',NULL,151157,37.35,0.03,281,71820,70,NULL,'SALT 2','2MASX J21345926-6244143',0.0503,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151158,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151158,36.91,0.76,241,71821,70,NULL,NULL,'2MASX J21345994-7035425',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.2r',0.35,'S',NULL,NULL,NULL,NULL,1,323.75,-70.59514,0.037,NULL,49301918381,770342474,12036601,15.2),(151159,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151159,38.54,0.46,511,71822,70,NULL,NULL,'2MASX J21350010+1108107',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,323.7504583,11.13639,0.221,NULL,52110653348,814228958,12722327,18.1),(151160,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151160,35.96,0.46,156,71823,70,NULL,NULL,'IC 1391',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00015,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,323.751667,-0.51144,0.125,NULL,49708957667,776702463,12135975,15.6),(151161,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151161,37.18,0.59,273,71823,70,NULL,NULL,'IC 1391',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151162,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151162,38,0.33,398,71824,70,NULL,NULL,'SDSS J213502.05-082602.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000009,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,323.758583333,-8.43414,0.097,NULL,49692940863,776452200,12132065,18),(151163,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06472','RN',151163,38.81,0.13,549,71825,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06472',0.050899,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151164,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151164,35.36,0.53,118,71826,70,NULL,NULL,'2MASX J21350521-7314506',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,323.771625,-73.24733,0.209,NULL,49293235283,770206801,12034481,16.6),(151165,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151165,37.7,0.46,347,71827,70,NULL,NULL,'2MASX J21350597+1023467',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,323.775,10.39622,0.169,NULL,52113660654,814275947,12723061,17.1),(151166,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151166,38.12,0.46,420,71828,70,NULL,NULL,'2MASX J21350734+0105409',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.780625,1.09478,0.189,NULL,52107891999,814185812,12721653,17.2),(151167,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151167,37.37,0.46,298,71829,70,NULL,NULL,'2MASX J21350802-0846021',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000096,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,323.783458333,-8.76742,0.105,NULL,49692098598,776439040,12131860,16.8),(151168,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13750','RN',151168,42.15,0.27,2020,71830,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13750',0.331974,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151169,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13750','RN',151169,42.56,0.39,2440,71830,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13750',0.331974,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151170,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151170,39.81,0.14,727,71831,74.2,NULL,'SALT 2','SDSS J213511.65+000946.1',0.26,'2010ApJ...716..712A',2010,1,0.1,NULL,'G',0.005,NULL,'20.5g',0.07,NULL,NULL,NULL,NULL,NULL,1,323.798583,0.16283,0.165,NULL,52095593551,813993649,12718650,20.5),(151171,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151171,40.34,0.05,927,71831,70,NULL,'SDSS-II SN 01253','SDSS J213511.65+000946.1',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151172,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151172,39.84,0.16,931,71831,70,NULL,'Hubble residual -0.11 for z0.26200','SDSS J213511.65+000946.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151173,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01253','R',151173,40.48,0.22,988,71831,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fd','SDSS J213511.65+000946.1',0.262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151174,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151174,40.52,0.14,1010,71831,65,NULL,'SALT2','SDSS J213511.65+000946.1',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151175,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151175,40.53,0.16,1010,71831,70,NULL,'SDSS-II SN 01253, SALT 2','SDSS J213511.65+000946.1',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151176,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2005fd',NULL,151176,40.65,0.14,1070,71831,65,NULL,'MLCS2k2','SDSS J213511.65+000946.1',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151177,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01253','R',151177,40.72,0.19,1100,71831,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fd','SDSS J213511.65+000946.1',0.262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151178,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14784','R',151178,40.04,0.12,853,71832,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J213511.75-002055.9',0.192,'2014arXiv1401.3317S',2014,1,0.17,NULL,'G',0.01,NULL,'19.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,323.799,-0.34886,0.137,NULL,49695407005,776490734,12132667,19.7),(151179,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14784','R',151179,40.06,0.2,864,71832,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J213511.75-002055.9',0.192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151180,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14784',NULL,151180,39.94,0.09,973,71832,70,NULL,'SALT 2','SDSS J213511.75-002055.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151181,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14784',NULL,151181,39.95,0.09,977,71832,70,NULL,'SALT 2, Malmquist cor.','SDSS J213511.75-002055.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151182,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02007','RN',151182,41.91,0.36,1720,71833,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02007',0.400453,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151183,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02007','RN',151183,42.62,0.36,2390,71833,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02007',0.400453,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151184,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151184,38.28,0.46,452,71834,70,NULL,NULL,'2MASX J21351512+1045277',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,323.813,10.75769,0.149,NULL,52110592246,814228003,12722312,17.4),(151185,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151185,35.44,0.63,122,71835,70,NULL,NULL,'2MASX J21351739-0311247',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00015,NULL,'16.52',0.5,NULL,NULL,NULL,NULL,NULL,1,323.822625,-3.19017,0.137,NULL,49705233776,776644277,12135066,16.52),(151186,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151186,37.22,0.57,278,71836,70,NULL,NULL,'2MASX J21351823-0930081',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.81',0.46,NULL,NULL,NULL,NULL,NULL,1,323.826166667,-9.50228,0.097,NULL,49679347053,776239797,12128746,16.81),(151187,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151187,35.02,0.57,101,71837,70,NULL,NULL,'2MASX J21352020-2056458',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'14.3r',0.45,'S0',NULL,NULL,NULL,NULL,1,323.834083,-20.946,0.097,NULL,50935554148,795868033,12435438,14.3),(151188,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151188,34.37,0.55,74.9,71838,70,NULL,NULL,'ESO 343- G 011',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000107,NULL,'13.9r',0.7,'S0',NULL,NULL,NULL,NULL,1,323.836625,-37.69153,0.021,NULL,51474281344,804285646,12566963,13.9),(151189,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151189,37.39,0.33,300,71839,70,NULL,NULL,'2MASX J21352530+0019480',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000125,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,323.8552917,0.33003,0.165,NULL,52095610374,813993912,12718654,17.4),(151190,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151190,38.24,0.46,444,71840,70,NULL,NULL,'SDSS J213528.45+101503.1',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,323.8685417,10.25089,0.161,NULL,52112624797,814259762,12722808,18.1),(151191,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151191,37.8,0.46,362,71841,70,NULL,NULL,'2MASX J21352853-0825015',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,323.868791667,-8.41719,0.097,NULL,49692082337,776438786,12131856,17.6),(151192,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151192,37.39,0.33,300,71842,70,NULL,NULL,'2MASX J21352917+0016060',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000181,NULL,'16.1g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,323.871375,0.26831,0.165,NULL,52095611258,813993925,12718655,16.1),(151193,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006fa',NULL,151193,38.77,0.1,568,71843,70,NULL,'Hubble residual -0.31 for z0.16704','SDSS J213530.84-005846.6',NULL,'2011ApJ...740...92G',2011,1,0.15,NULL,'G',0.000128,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,323.8785,-0.97964,0.145,NULL,49709691714,776713933,12136155,18.5),(151194,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12843','R',151194,39.23,0.19,601,71843,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fa','SDSS J213530.84-005846.6',0.167038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151195,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 12843','R',151195,39.41,0.12,653,71843,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fa','SDSS J213530.84-005846.6',0.167038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151196,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151196,35.15,0.56,107,71844,70,NULL,NULL,'2MASX J21353257-5817496',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00015,NULL,'13.6r',0.88,'(R\')SAB(rs)b',NULL,NULL,NULL,NULL,1,323.8857917,-58.29708,0.037,NULL,48713282305,761145036,11892891,13.6),(151197,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151197,33.65,0.45,53.8,71845,NULL,NULL,'K','IC 1392',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000067,NULL,'12.5',1.3,'S0-:','in a triple',NULL,NULL,NULL,1,323.886208333,35.39833,1.025,NULL,55598524497,868726945,13573858,12.5),(151198,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151198,33.75,0.4,56.3,71845,NULL,NULL,'mean','IC 1392',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151199,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151199,35.82,0.36,146,71846,NULL,NULL,'Malmquist cor.','ESO 600- G 002',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000033,NULL,'14.0r',0.8,'SA(r)c',NULL,NULL,NULL,NULL,1,323.89225,-19.03103,0.085,NULL,50932727239,795823863,12434747,14),(151200,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151200,36.13,0.31,168,71846,NULL,NULL,NULL,'ESO 600- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151201,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151201,36.17,0.2,171,71846,74.4,NULL,NULL,'ESO 600- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151202,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09740','R',151202,40.2,0.28,887,71847,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09740',0.238,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.8970417,-1.02853,0.145,NULL,49709693754,776713964,12136155,NULL),(151203,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09740','R',151203,40.48,0.25,1010,71847,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09740',0.238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151204,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151204,36.6,0.56,209,71848,70,NULL,NULL,'2MASX J21353550-0905534',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,323.898,-9.09825,0.081,NULL,49692174815,776440231,12131878,15.6),(151205,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151205,36.32,0.46,183,71849,70,NULL,NULL,'2MASX J21354144+0033420',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.77',0.3,NULL,NULL,NULL,NULL,NULL,1,323.9227083,0.56164,0.185,NULL,52095543502,813992867,12718638,16.77),(151206,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151206,36.83,0.46,232,71850,70,NULL,NULL,'2MASX J21354311-0843354',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000078,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,323.929416667,-8.72672,0.093,NULL,49692131849,776439560,12131868,17),(151207,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151207,32.94,0.8,38.8,71851,75,NULL,'MAT, I','NGC 7083',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.000013,NULL,'11.87',2.3,'SAB(rs)c       LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,323.936208333,-63.90283,0.057,NULL,49356533005,771195828,12049934,11.87),(151208,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151208,32.96,0.8,39.1,71851,75,NULL,'A82, H','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151209,'Sosies','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151209,32.68,0.07,34.4,71851,NULL,NULL,NULL,'NGC 7083',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151210,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151210,31.83,0.47,23.2,71851,75,NULL,'A82, H, raw','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151211,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151211,31.96,0.4,24.7,71851,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7083',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151212,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151212,31.97,0.47,24.7,71851,75,NULL,'A82, H, inv','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151213,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151213,32.28,0.47,28.6,71851,75,NULL,'A82, H, cor','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151214,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151214,32.37,0.36,29.8,71851,NULL,NULL,NULL,'NGC 7083',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151215,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151215,32.37,0.4,29.8,71851,73,NULL,'opt','NGC 7083',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151216,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151216,32.46,0.32,31.1,71851,85,NULL,'I, raw','NGC 7083',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151217,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151217,32.47,0.43,31.1,71851,75,NULL,'MAT, I, raw','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151218,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151218,32.48,NULL,31.3,71851,NULL,NULL,'B','NGC 7083',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151219,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151219,32.53,0.32,32.1,71851,85,NULL,'I, inv','NGC 7083',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151220,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151220,32.68,NULL,34.4,71851,NULL,NULL,'I','NGC 7083',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151221,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151221,32.74,0.43,35.4,71851,75,NULL,'MAT, I, inv','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151222,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151222,32.78,0.2,36,71851,74.4,NULL,NULL,'NGC 7083',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151223,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151223,32.79,0.43,36.2,71851,75,NULL,'MAT, I, cor','NGC 7083',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151224,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151224,32.94,0.4,38.7,71851,75,NULL,'B','NGC 7083',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151225,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151225,32.99,0.38,39.6,71851,NULL,NULL,NULL,'NGC 7083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151226,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151226,33.08,0.36,41.3,71851,NULL,NULL,'Malmquist cor.','NGC 7083',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151227,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151227,37.98,0.46,394,71852,70,NULL,NULL,'2MASX J21354703+0015560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000153,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,323.9460417,0.26553,0.165,NULL,52095560909,813993139,12718642,17.2),(151228,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151228,35.64,0.49,134,71853,70,NULL,NULL,'6dF J2135502-344257',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,323.959167,-34.71572,0.093,NULL,51448678015,803885593,12560712,14.6),(151229,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151229,39.88,0.19,946,71854,70,NULL,'SDSS-II SN 15287','SDSS J213550.32-010326.8',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,323.959667,-1.05744,0.145,NULL,49709413977,776709593,12136087,NULL),(151230,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151230,39.92,0.11,964,71854,70,NULL,'Hubble residual 0.02 for z0.25400','SDSS J213550.32-010326.8',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151231,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15287','R',151231,40.5,0.19,1000,71854,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kt','SDSS J213550.32-010326.8',0.254,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151232,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151232,40.61,0.16,1070,71854,72,NULL,'SDSS 15287','SDSS J213550.32-010326.8',0.24,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151233,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 15287','R',151233,40.67,0.09,1080,71854,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kt','SDSS J213550.32-010326.8',0.254,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151234,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151234,40.44,0.08,1220,71854,70,NULL,'SALT 2','SDSS J213550.32-010326.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151235,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SN 2006kt',NULL,151235,40.45,0.08,1230,71854,70,NULL,'SALT 2, Malmquist cor.','SDSS J213550.32-010326.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151236,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14986','RN',151236,41.11,0.29,1510,71855,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14986',0.102567,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151237,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 14986','RN',151237,41.59,0.37,1890,71855,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14986',0.102567,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151238,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151238,37.91,0.46,382,71856,70,NULL,NULL,'2MASX J21355062-0008494',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000184,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,323.9609583,-0.14714,0.149,NULL,49695346569,776489790,12132652,17.6),(151239,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151239,37.39,0.62,301,71857,70,NULL,NULL,'2MASX J21355753-0853276',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'17.33',0.29,NULL,NULL,NULL,NULL,NULL,1,323.9897917,-8.89108,0.089,NULL,49692278110,776441845,12131903,17.33),(151240,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151240,36.67,0.5,216,71858,70,NULL,NULL,'2MASX J21355876-0423314',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.14',0.41,NULL,NULL,NULL,NULL,NULL,1,323.994917,-4.39214,0.097,NULL,49705964157,776655689,12135245,16.14),(151241,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151241,33.54,0.8,51.1,71859,75,NULL,'MAT, I','ESO 048- G 002',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000024,NULL,'13.6r',0.6,'Sb',NULL,NULL,NULL,NULL,1,324.000167,-76.34575,0.417,NULL,48530175204,758283987,11848187,13.6),(151242,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151242,33.68,0.45,54.4,71859,NULL,NULL,'K','ESO 048- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151243,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151243,33.73,0.47,55.8,71859,NULL,NULL,'H','ESO 048- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151244,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151244,33.76,0.4,56.5,71859,NULL,NULL,'mean','ESO 048- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151245,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151245,33.81,0.43,57.9,71859,75,NULL,'MAT, I, raw','ESO 048- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151246,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151246,33.82,0.11,58.2,71859,NULL,NULL,NULL,'ESO 048- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151247,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151247,33.87,0.32,59.5,71859,85,NULL,'I, raw','ESO 048- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151248,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151248,33.93,0.32,61,71859,85,NULL,'I, inv','ESO 048- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151249,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151249,33.96,0.49,61.9,71859,75,NULL,'IR','ESO 048- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151250,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151250,33.97,0.46,62.2,71859,NULL,NULL,'J','ESO 048- G 002',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151251,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151251,34.02,0.43,63.7,71859,75,NULL,'MAT, I, cor','ESO 048- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151252,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151252,34.05,0.43,64.6,71859,75,NULL,'MAT, I, inv','ESO 048- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151253,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 10066',NULL,151253,40.9,0.32,1510,71860,70,NULL,'SN photometric redshift distance, z photo =0.447 +/- 0.099','SDSS-II SN 10066',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','22.9g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,324.0034583,-0.05417,0.165,NULL,49695353140,776489892,12132654,22.9),(151254,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 10066','R',151254,41.81,0.38,1590,71860,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10066',0.442393,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151255,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151255,38.98,0.46,625,71861,70,NULL,NULL,'SDSS J213602.93+113348.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000182,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.01225,11.56356,0.313,NULL,52294662576,817104102,12767251,18.3),(151256,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 21162','RN',151256,42.67,0.31,2170,71862,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21162',0.570684,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151257,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151257,35.09,0.46,104,71863,70,NULL,NULL,'2MASX J21360388-0320164',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000047,NULL,'15.29',0.59,NULL,NULL,NULL,NULL,NULL,1,324.016083,-3.33775,0.137,NULL,49705342055,776645969,12135093,15.29),(151258,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151258,35.96,0.46,156,71864,70,NULL,NULL,'2MASX J21360817-0735106',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000074,NULL,'16.0g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,324.034125,-7.58619,0.093,NULL,49685073199,776329268,12130144,16),(151259,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151259,36.41,0.58,191,71864,70,NULL,NULL,'2MASX J21360817-0735106',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151260,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151260,37.72,0.46,350,71865,70,NULL,NULL,'2MASX J21361007-0813166',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000091,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,324.041875,-8.22139,0.117,NULL,49684532915,776320826,12130012,16.9),(151261,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151261,34.48,0.47,78.8,71866,NULL,NULL,'H','ESO 343-IG 013 NED01',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000117,NULL,'14.55',0.7,'S?;HII?        LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,324.0440417,-38.54522,0.017,NULL,51476348981,804317952,12567468,14.55),(151262,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151262,34.5,0.4,79.3,71866,NULL,NULL,'mean','ESO 343-IG 013 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151263,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151263,34.56,0.45,81.6,71866,NULL,NULL,'K','ESO 343-IG 013 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151264,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151264,34.68,0.46,86.2,71866,NULL,NULL,'J','ESO 343-IG 013 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151265,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151265,36.21,0.81,174,71867,70,NULL,NULL,'2MASX J21361141-7206436',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.9b',0.37,'S0',NULL,NULL,NULL,NULL,1,324.047875,-72.11211,0.077,NULL,49294109140,770220455,12034694,16.9),(151266,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 08519','RN',151266,42.73,0.34,2420,71868,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08519',0.4527,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151267,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 17618','RN',151267,43.07,0.3,2580,71869,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17618',0.593405,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151268,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151268,36.46,0.72,196,71870,70,NULL,NULL,'2MASX J21361546-5630409',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.4r',0.19,NULL,NULL,NULL,NULL,NULL,1,324.064583,-56.51139,0.041,NULL,48666687714,760416995,11881515,15.4),(151269,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151269,36.5,0.5,199,71871,70,NULL,NULL,'2MASX J21361582-2753447',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000113,NULL,'14.8r',0.5,'E',NULL,NULL,NULL,NULL,1,324.0660417,-27.89581,0.145,NULL,51465499755,804148433,12564819,14.8),(151270,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151270,36.73,0.54,222,71872,70,NULL,NULL,'2MASX J21361682-0830396',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.62',0.35,NULL,NULL,NULL,NULL,NULL,1,324.070083,-8.511,0.093,NULL,49683824064,776309751,12129839,16.62),(151271,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13998','RN',151271,37.53,0.2,286,71873,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13998',0.122683,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151272,'BL Lac Luminosity','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151272,42.03,NULL,2540,71874,70,NULL,'nucleus-to-host flux ratio, z > 0.98','GALEXASC J213618.24-444349.6',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'19',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,324.0760417,-44.73047,0,NULL,50640971952,791265186,12363518,19),(151273,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151273,37,0.46,251,71875,70,NULL,NULL,'2MASX J21362059+0043148',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000181,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,324.085667,0.72069,0.181,NULL,52096214280,814003348,12718802,16.5),(151274,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151274,34.94,0.49,97.1,71876,75,NULL,'IR','UGC 11776',NULL,'2011yCatp016004901K',2011,1,1.41,NULL,'G',0.000161,NULL,'15.6g',0.25,'Scd:',NULL,NULL,NULL,NULL,1,324.094916667,12.23631,0.309,NULL,52227503507,816054742,12750855,15.6),(151275,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151275,35.75,0.5,142,71877,70,NULL,NULL,'2MASX J21362371-0358222',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.0001,NULL,'16.15',0.53,NULL,NULL,NULL,NULL,NULL,1,324.098875,-3.97286,0.105,NULL,49706046954,776656983,12135265,16.15),(151276,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151276,33.93,0.5,61,71878,70,NULL,NULL,'ESO 107- G 039',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.000083,NULL,'14.53',0.58,'Compact',NULL,NULL,NULL,NULL,1,324.099,-64.42556,0.045,NULL,49357431815,771209872,12050154,14.53),(151277,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151277,37.56,0.46,326,71879,70,NULL,NULL,'2MASX J21362392+0100268',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,324.099625,1.00761,0.189,NULL,52107339544,814177180,12721518,16.7),(151278,'TRGB','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151278,29.7,0.09,8.72,71880,74.4,NULL,NULL,'NGC 7090',NULL,'2013AJ....146...86T',2013,1,7.4,'Position in 1997AJ....113.1548C is incorrect.','G',0.00001,NULL,'11.33',1.3,'SBc? sp','Group non-member, foreground',NULL,NULL,NULL,1,324.12025,-54.55733,0,NULL,48664105916,760376654,11880885,11.33),(151279,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151279,30.09,0.8,10.4,71880,75,NULL,'A82, H','NGC 7090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151280,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151280,28.97,0.43,6.2,71880,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151281,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151281,28.99,0.35,6.28,71880,NULL,NULL,NULL,'NGC 7090',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151282,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151282,29.01,0.43,6.3,71880,75,NULL,'3.6 micron, color corrected','NGC 7090',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151283,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151283,29.1,0.4,6.6,71880,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7090',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151284,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151284,29.13,NULL,6.7,71880,NULL,NULL,NULL,'NGC 7090',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151285,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151285,29.43,0.47,7.68,71880,75,NULL,'A82, H, inv','NGC 7090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151286,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151286,29.52,0.47,8.03,71880,75,NULL,'A82, H, raw','NGC 7090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151287,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151287,29.7,0.09,8.72,71880,74.4,NULL,NULL,'NGC 7090',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151288,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151288,29.87,0.47,9.4,71880,75,NULL,'A82, H, cor','NGC 7090',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151289,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151289,30.09,0.4,10.4,71880,75,NULL,'B','NGC 7090',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151290,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151290,30.3,0.4,11.5,71880,73,NULL,'IR','NGC 7090',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151291,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151291,30.3,0.4,11.5,71880,75,NULL,NULL,'NGC 7090',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151292,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151292,30.39,0.49,12,71880,75,NULL,'IR','NGC 7090',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151293,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151293,36.39,0.59,190,71881,70,NULL,NULL,'2MASX J21363060-0359292',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'17.32',0.18,NULL,NULL,NULL,NULL,NULL,1,324.1274583,-3.99147,0.105,NULL,49706053875,776657091,12135267,17.32),(151294,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151294,36.2,0.49,173,71882,75,NULL,'IR','UGC 11778',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',NULL,NULL,'16.5',0.15,'Sc',NULL,NULL,NULL,NULL,1,324.1335,5.73828,0.209,NULL,52127745123,814496017,12726500,16.5),(151295,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151295,36.21,NULL,174,71882,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151296,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151296,36.21,NULL,175,71882,NULL,NULL,'Dipole + Quadrupole','UGC 11778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151297,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151297,36.22,NULL,175,71882,NULL,NULL,'Dipole','UGC 11778',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151298,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151298,34.41,0.5,76.3,71883,70,NULL,NULL,'MCG -05-51-003',NULL,'2014MNRAS.445.2677S',2014,1,0.65,'6dF DR2 has z = 0.019019.','G',0.00015,NULL,'15.19',0.52,'E',NULL,NULL,NULL,NULL,1,324.1565417,-27.72522,0.185,NULL,51468122531,804189414,12565459,15.19),(151299,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151299,37.59,0.27,330,71884,70,NULL,NULL,'2MASX J21363871+1037226',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000194,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.161125,10.62286,0.197,NULL,52296169991,817127656,12767619,17.6),(151300,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151300,37.47,0.46,312,71885,70,NULL,NULL,'2MASX J21363996-0111341',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.166583333,-1.19281,0.145,NULL,49709552896,776711764,12136121,17.6),(151301,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 20094','RN',151301,42.2,0.24,2180,71886,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20094',0.266389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151302,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151302,36.75,0.46,224,71887,70,NULL,NULL,'2MASX J21364239-0642435',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000097,NULL,'16.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,324.1767083,-6.71219,0.069,NULL,49681866719,776279167,12129361,16.8),(151303,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151303,35.79,0.46,144,71888,70,NULL,NULL,'II Zw 142',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00018,NULL,'15.5g',0.5,'E0',NULL,NULL,NULL,NULL,1,324.190833,1.249,0.161,NULL,52107367884,814177623,12721525,15.5),(151304,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151304,34.74,0.55,88.6,71889,70,NULL,NULL,'ESO 531- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000023,NULL,'13.6r',0.4,'SB(r)a:',NULL,NULL,NULL,NULL,1,324.203,-22.80542,0.073,NULL,50927238437,795738100,12433407,13.6),(151305,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151305,37.59,0.27,330,71890,70,NULL,NULL,'2MASX J21365051+1037356',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00017,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,324.2102917,10.62658,0.197,NULL,52296167682,817127620,12767619,18),(151306,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07951','RN',151306,40.89,0.26,1350,71891,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07951',0.119055,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151307,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07951','RN',151307,41.07,0.33,1460,71891,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07951',0.119055,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151308,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151308,35.44,0.48,123,71892,70,NULL,NULL,'2MASX J21365416-2020375',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'14.3r',0.52,'E',NULL,NULL,NULL,NULL,1,324.225791667,-20.34375,0.081,NULL,50935468087,795866688,12435417,14.3),(151309,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19722','RN',151309,41.85,0.22,1860,71893,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19722',0.259634,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151310,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 19722','RN',151310,42.72,0.41,2780,71893,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19722',0.259634,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151311,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151311,38.07,0.46,410,71894,70,NULL,NULL,'2MASX J21365872+1119067',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000154,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,324.244583,11.31844,0.297,NULL,52295048057,817110125,12767345,17.8),(151312,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13732','RN',151312,41.8,0.29,1640,71895,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13732',0.402256,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151313,'SNIa','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 13732','RN',151313,42.16,0.41,1930,71895,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13732',0.402256,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151314,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07785','RN',151314,43.37,0.28,3170,71896,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07785',0.487872,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151315,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151315,36.55,0.33,204,71897,70,NULL,NULL,'UGC 11780 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.17',0.4,NULL,NULL,NULL,NULL,NULL,1,324.284875,0.44642,0.181,NULL,52096394860,814006169,12718846,16.17),(151316,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151316,37.59,0.27,330,71898,70,NULL,NULL,'2MASX J21371178+1039498',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,324.299083,10.66381,0.197,NULL,52296192112,817128001,12767625,16.9),(151317,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151317,38.76,0.46,564,71899,70,NULL,NULL,'SDSS J213716.28-074759.2',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000078,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.317833333,-7.79981,0.109,NULL,49684004941,776312577,12129884,17.9),(151318,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151318,37.34,0.46,293,71900,70,NULL,NULL,'2MASX J21372146-0828558',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,324.339416667,-8.48214,0.105,NULL,49683722775,776308168,12129815,17.1),(151319,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151319,36.55,0.33,204,71901,70,NULL,NULL,'CGCG 376-017',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00011,NULL,'15.5',0.28,NULL,'Group member',NULL,NULL,NULL,1,324.342,0.39628,0.181,NULL,52096354482,814005538,12718836,15.5),(151320,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151320,37.16,0.65,271,71902,70,NULL,NULL,'2MASX J21372239-0356431',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.43',0.25,NULL,NULL,NULL,NULL,NULL,1,324.343333,-3.94542,0.121,NULL,49706616401,776665881,12135404,17.43),(151321,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151321,36.02,0.66,160,71903,70,NULL,NULL,'2MASX J21372379-7051001',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.3r',0.3,NULL,NULL,NULL,NULL,NULL,1,324.348833333,-70.85003,0.049,NULL,49301874329,770341786,12036590,15.3),(151322,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151322,36.96,0.56,247,71904,70,NULL,NULL,'2MASX J21372793-5542163',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'14.9r',0.32,NULL,NULL,NULL,NULL,NULL,1,324.366333,-55.70456,0.045,NULL,48665191924,760393623,11881150,14.9),(151323,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151323,34.89,0.72,95,71905,70,NULL,NULL,'ESO 287- G 040',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00007,NULL,'14.25',0.9,'Ring?',NULL,NULL,NULL,NULL,1,324.367417,-47.03583,0.021,NULL,50639414686,791240854,12363138,14.25),(151324,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151324,34.79,0.49,90.7,71906,70,NULL,NULL,'MCG -05-51-004',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00013,NULL,'15.44',0.4,'E',NULL,NULL,NULL,NULL,1,324.379167,-29.44453,0.073,NULL,51472048877,804250763,12566418,15.44),(151325,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151325,35.7,0.69,138,71907,70,NULL,NULL,'2MASX J21373182-3102033',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.0r',0.3,'E',NULL,NULL,NULL,NULL,1,324.3825417,-31.03422,0.073,NULL,51471159536,804236867,12566201,15),(151326,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151326,36.37,0.6,188,71908,70,NULL,NULL,'2MASX J21373293-1441386',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000057,NULL,'16.54',0.36,NULL,NULL,NULL,NULL,NULL,1,324.38725,-14.69414,0.165,NULL,50888055819,795125872,12423841,16.54),(151327,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151327,38.25,0.46,447,71909,70,NULL,NULL,'2MASX J21373659-0812569',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.4025,-8.21592,0.105,NULL,49684603239,776321925,12130030,18),(151328,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06561','RN',151328,42.24,0.27,2700,71910,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06561',0.040943,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151329,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 06561','RN',151329,43.02,0.34,3860,71910,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06561',0.040943,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151330,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09273','R',151330,38.65,0.14,488,71911,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2005ks','SN 2005ks',0.098826,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib/c',NULL,NULL,NULL,NULL,1,324.485666667,-0.03247,0.193,NULL,49695785574,776496649,12132760,NULL),(151331,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 09273','R',151331,38.97,0.21,566,71911,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2005ks','SN 2005ks',0.098826,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151332,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151332,37.57,0.33,326,71912,70,NULL,NULL,'2MASX J21375671+0100284',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000156,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,324.486417,1.00778,0.161,NULL,52096101717,814001589,12718774,17.8),(151333,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151333,36.25,0.76,178,71913,70,NULL,NULL,'2MASX J21380140-1150353',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.84',0.37,NULL,NULL,NULL,NULL,NULL,1,324.50575,-11.84317,0.137,NULL,49896381306,779630957,12181733,16.84),(151334,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151334,36.71,0.33,219,71914,70,NULL,NULL,'2MASX J21380280-0706403',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00008,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,324.511625,-7.11114,0.109,NULL,49682279924,776285623,12129462,16.7),(151335,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151335,36.8,0.63,229,71915,70,NULL,NULL,'2MASX J21380486-0426179',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'17.24',0.22,'poss. LINER',NULL,NULL,NULL,NULL,1,324.5202083,-4.43833,0.101,NULL,49705983471,776655991,12135249,17.24),(151336,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151336,35.84,0.51,147,71916,70,NULL,NULL,'2MASX J21380697-2641578',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.8r',0.37,'S0',NULL,NULL,NULL,NULL,1,324.529,-26.69939,0.129,NULL,51464897779,804139027,12564672,14.8),(151337,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151337,34.97,0.48,98.8,71917,70,NULL,NULL,'ESO 287- G 042',NULL,'2014MNRAS.445.2677S',2014,1,0.75,'This is not NGC 7095.  That is = NGC 7097.','G',0.000133,NULL,'13.9r',0.5,'S0?            AGN',NULL,NULL,NULL,'Sy 1.8',1,324.533083333,-42.60486,0,NULL,51358076799,802469949,12538592,13.9),(151338,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151338,35.63,0.72,133,71918,70,NULL,NULL,'2MASX J21380821-1152123',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.55',0.36,NULL,NULL,NULL,NULL,NULL,1,324.53425,-11.86997,0.137,NULL,49896389307,779631082,12181735,16.55),(151339,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151339,31.15,0.4,17,71919,75,NULL,'B','UGC 11782',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000013,NULL,'14.5',1.3,'SB(s)m',NULL,NULL,NULL,NULL,1,324.540417,8.96139,0.113,NULL,52300932131,817202064,12768782,14.5),(151340,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151340,31.22,0.4,17.5,71919,73,NULL,'opt','UGC 11782',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151341,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01760','RN',151341,43.13,0.24,3040,71920,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01760',0.394171,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151342,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01760','RN',151342,43.79,0.24,4110,71920,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01760',0.394171,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151343,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151343,32.44,0.8,30.7,71921,75,NULL,'MAT, I','ESO 287- G 043',NULL,'1997ApJS..109..333W',1997,1,1.89,NULL,'G',0.000033,NULL,'14.49',0.3,'Scd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,324.5519583,-43.9345,0,NULL,50648563080,791383798,12365371,14.49),(151344,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151344,32.05,0.43,25.7,71921,75,NULL,'3.6 micron, color + selection bias corrected','ESO 287- G 043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151345,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151345,32.06,0.4,25.8,71921,73,NULL,'IR','ESO 287- G 043',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151346,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151346,32.06,0.4,25.8,71921,75,NULL,NULL,'ESO 287- G 043',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151347,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151347,32.12,0.4,26.5,71921,73,NULL,'opt','ESO 287- G 043',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151348,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151348,32.12,0.32,26.5,71921,85,NULL,'I, inv','ESO 287- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151349,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151349,32.13,0.43,26.7,71921,75,NULL,'3.6 micron, color corrected','ESO 287- G 043',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151350,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151350,32.14,0.32,26.8,71921,85,NULL,'I, raw','ESO 287- G 043',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151351,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151351,32.18,0.2,27.3,71921,74.4,NULL,NULL,'ESO 287- G 043',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151352,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151352,32.18,0.4,27.3,71921,NULL,NULL,NULL,'ESO 287- G 043',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151353,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151353,32.4,0.43,30.2,71921,75,NULL,'MAT, I, inv','ESO 287- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151354,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151354,32.41,0.43,30.3,71921,75,NULL,'MAT, I, raw','ESO 287- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151355,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151355,32.48,0.49,31.3,71921,75,NULL,'IR','ESO 287- G 043',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151356,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151356,32.52,0.11,32,71921,NULL,NULL,NULL,'ESO 287- G 043',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151357,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151357,32.59,0.43,33,71921,75,NULL,'MAT, I, cor','ESO 287- G 043',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151358,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151358,37.57,0.33,326,71922,70,NULL,NULL,'2MASX J21381298+0057484',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,324.5542083,0.96336,0.161,NULL,52096029902,814000467,12718757,17.7),(151359,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151359,37.15,0.46,269,71923,70,NULL,NULL,'2MASX J21381360+1047581',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000186,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,324.556667,10.79961,0.189,NULL,52298488751,817163886,12768185,17.2),(151360,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151360,36.71,0.33,219,71924,70,NULL,NULL,'2MASX J21381812-0709152',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,324.5755,-7.15411,0.109,NULL,49682303163,776285986,12129468,16.3),(151361,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151361,36.85,0.67,235,71924,70,NULL,NULL,'2MASX J21381812-0709152',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151362,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151362,35.89,0.55,151,71925,70,NULL,NULL,'PRC B-20',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.90',0.5,'E',NULL,NULL,NULL,NULL,1,324.5835417,-21.31836,0.069,NULL,50932111745,795814246,12434597,15.9),(151363,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151363,36.9,0.46,240,71926,70,NULL,NULL,'2MASX J21382110-0041122',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,324.588125,-0.68683,0.149,NULL,49695964595,776499446,12132803,17),(151364,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151364,37.12,0.78,265,71927,70,NULL,NULL,'2MASX J21382518-0446162',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.57',0.21,NULL,NULL,NULL,NULL,NULL,1,324.605,-4.77119,0.097,NULL,49703346218,776614784,12134606,17.57),(151365,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151365,37.12,0.27,265,71928,70,NULL,NULL,'2MASX J21382557+1132595',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,324.606583,11.54983,0.317,NULL,52295374272,817115223,12767425,17.8),(151366,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151366,36.64,0.46,213,71929,70,NULL,NULL,'2MASX J21382644-0041402',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000157,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.61025,-0.69464,0.149,NULL,49695963734,776499433,12132803,17.7),(151367,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151367,37.77,0.46,358,71930,70,NULL,NULL,'2MASX J21382709+0033107',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,324.6129583,0.55311,0.173,NULL,52095740904,813995951,12718686,17.6),(151368,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07102','R',151368,40.35,0.11,981,71931,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07102',0.196407,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,324.619916667,-0.61558,0.149,NULL,49695829213,776497331,12132770,NULL),(151369,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 07102','R',151369,40.42,0.19,1010,71931,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07102',0.196407,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151370,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151370,35.79,0.5,144,71932,70,NULL,NULL,'2MASX J21382882-5429093',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'14.6r',0.2,'S',NULL,NULL,NULL,NULL,1,324.6202083,-54.48622,0,NULL,48665992922,760406139,11881345,14.6),(151371,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151371,38.12,0.46,421,71933,70,NULL,NULL,'2MASX J21382983-0837261',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000142,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,324.624375,-8.62397,0.105,NULL,49905070357,779766724,12183855,17.9),(151372,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151372,36.49,0.46,199,71934,70,NULL,NULL,'2MASX J21383186-0814161',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,324.632625,-8.23781,0.105,NULL,49905476294,779773067,12183954,16.4),(151373,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151373,36.35,0.46,186,71935,70,NULL,NULL,'2MASX J21383461-0754261',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000023,NULL,'15.4g',0.56,'S0^-',NULL,NULL,NULL,NULL,1,324.644125,-7.90717,0.113,NULL,49683937912,776311529,12129867,15.4),(151374,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151374,36.77,0.5,226,71935,70,NULL,NULL,'2MASX J21383461-0754261',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151375,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151375,37.12,0.27,265,71936,70,NULL,NULL,'SDSS J213836.22+112800.7',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,324.650958333,11.46686,0.317,NULL,52295372580,817115196,12767424,17.9),(151376,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 01615','RN',151376,39.36,0.81,687,71937,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01615',0.082675,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151377,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151377,37.12,0.27,265,71938,70,NULL,NULL,'2MASX J21383803+1118425',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,324.658583333,11.31169,0.317,NULL,52298399318,817162489,12768163,16.7),(151378,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151378,36.33,0.72,184,71939,70,NULL,NULL,'2MASX J21383930-0640001',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.0g',0.27,'Sa',NULL,NULL,NULL,NULL,1,324.6637083,-6.66669,0.109,NULL,49682409724,776287651,12129494,16),(151379,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151379,37.53,0.46,320,71940,70,NULL,NULL,'2MASX J21383959-0739321',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000146,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,324.665,-7.65883,0.125,NULL,49683891615,776310806,12129856,17.9),(151380,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151380,37.5,0.46,317,71941,70,NULL,NULL,'2MASX J21383988-0824161',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.9g',0.23,'BrClG',NULL,NULL,NULL,NULL,1,324.666,-8.40447,0.105,NULL,49905742953,779777233,12184019,16.9),(151381,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151381,34.25,0.2,70.8,71942,74.4,NULL,NULL,'CGCG 493-003',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000033,NULL,'15.5',0.5,'Sc',NULL,NULL,NULL,NULL,1,324.675,29.83764,0.709,NULL,55633167276,869268238,13582316,15.5),(151382,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151382,34.45,0.45,77.8,71942,NULL,NULL,NULL,'CGCG 493-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151383,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151383,34.54,0.44,81,71942,NULL,NULL,'Malmquist cor.','CGCG 493-003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151384,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151384,35.52,0.48,127,71943,70,NULL,NULL,'FAIRALL 0110',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'14.6r',0.4,'Bright nucleus',NULL,NULL,NULL,NULL,1,324.6765417,-72.7785,0.149,NULL,49292868034,770201063,12034391,14.6),(151385,'IRAS','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151385,33.1,0.8,41.7,71944,75,NULL,'MAT, I','NGC 7096A',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.12',0.6,'SAB(s)bc pec?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,324.701125,-64.35019,0.045,NULL,49357351406,771208615,12050134,14.12),(151386,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151386,32.58,0.32,32.8,71944,85,NULL,'I, raw','NGC 7096A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151387,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151387,32.59,0.32,33,71944,85,NULL,'I, inv','NGC 7096A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151388,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151388,32.86,0.4,37.3,71944,NULL,NULL,NULL,'NGC 7096A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151389,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151389,32.87,0.43,37.5,71944,75,NULL,'MAT, I, raw','NGC 7096A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151390,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151390,32.97,0.43,39.3,71944,75,NULL,'MAT, I, inv','NGC 7096A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151391,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151391,33.03,0.43,40.4,71944,75,NULL,'MAT, I, cor','NGC 7096A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151392,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151392,36.98,0.46,249,71945,70,NULL,NULL,'2MASX J21384966+1231345',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,324.706917,12.52625,0.301,NULL,52228423602,816069118,12751079,17.8),(151393,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,'R',151393,36.52,0.46,201,71946,70,NULL,NULL,'2MASX J21385447+0056149',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.727,0.93736,0.169,NULL,52096477375,814007458,12718866,17.5),(151394,'FP','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151394,35.95,0.62,155,71947,70,NULL,NULL,'2MASX J21385908-7831571',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,324.74625,-78.53256,0.481,NULL,48578353927,759036780,11859949,17),(151395,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02744','R',151395,38.36,0.2,455,71948,70,NULL,'SDSS CAND. SNIb; SALT 2; SN 2005hm','SN 2005hm',0.034782,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ib',NULL,NULL,NULL,NULL,1,324.7527083,-1.02742,0.177,NULL,49697455246,776522738,12133167,NULL),(151396,'SNIa SDSS','2016-12-15 15:15:55','2016-12-16 11:21:10','1','SDSS-II SN 02744','R',151396,38.52,0.06,488,71948,70,NULL,'SDSS CAND. SNIb; MLCS2K2; SN 2005hm','SN 2005hm',0.034782,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151397,'Tully-Fisher','2016-12-15 15:15:55','2016-12-16 11:21:10','1',NULL,NULL,151397,35.98,0.49,157,71949,NULL,NULL,'Malmquist cor.','ESO 600- G 005',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.9r',0.6,'S...',NULL,NULL,NULL,NULL,1,324.794083,-20.85272,0.077,NULL,50931776609,795809009,12434515,14.9),(151398,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,NULL,151398,36.41,0.4,191,71949,NULL,NULL,NULL,'ESO 600- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151399,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,NULL,151399,36.45,0.2,195,71949,74.4,NULL,NULL,'ESO 600- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151400,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:10','1','SDSS-II SN 06887','RN',151400,40.41,0.42,1090,71950,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06887',0.105008,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151401,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:10','1','SDSS-II SN 06887','RN',151401,41.47,0.36,1780,71950,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06887',0.105008,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151402,'FP','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,'R',151402,37.57,0.27,326,71951,70,NULL,NULL,'2MASX J21391188+1156210',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'16.9g',0.31,NULL,NULL,NULL,NULL,NULL,1,324.7992917,11.93931,0.353,NULL,52295365605,817115087,12767423,16.9),(151403,'FP','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,'R',151403,36.53,0.46,202,71952,70,NULL,NULL,'CGCG 376-019',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00011,NULL,'15.7g',0.49,'E0',NULL,NULL,NULL,NULL,1,324.8045,-0.50853,0.165,NULL,49697898470,776529663,12133275,15.7),(151404,'FP','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,'R',151404,37.57,0.27,326,71953,70,NULL,NULL,'SDSS J213915.70+115815.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,324.8154583,11.97106,0.353,NULL,52295366969,817115108,12767423,18.7),(151405,'FP','2016-12-15 15:15:56','2016-12-16 11:21:10','1',NULL,'R',151405,37.58,0.27,328,71954,70,NULL,NULL,'2MASX J21392009+1032270',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'17.46',0.42,NULL,NULL,NULL,NULL,NULL,1,324.833625,10.54075,0.221,NULL,52296426775,817131668,12767682,17.46),(151406,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:10','1','SDSS-II SN 13300','RN',151406,38.28,0.34,414,71955,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13300',0.091421,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151407,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13300','RN',151407,39.17,0.38,626,71955,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13300',0.091421,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151408,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151408,36.87,0.59,237,71956,70,NULL,NULL,'2MASX J21392273-5043289',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.0r',0.47,'S0',NULL,NULL,NULL,NULL,1,324.844875,-50.72469,0,NULL,50660938307,791577161,12368393,15),(151409,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151409,37.2,0.46,275,71957,70,NULL,NULL,'SDSS J213923.90+004654.1',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.849625,0.78169,0.209,NULL,52097323991,814020687,12719073,17.8),(151410,'BL Lac Luminosity','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151410,39.79,NULL,907,71958,70,NULL,'nucleus-to-host flux ratio, z > 0.24','WISE J213924.16-423520.3',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'G',NULL,NULL,'17.5',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,324.850667,-42.589,0,NULL,50635283534,791176305,12362129,17.5),(151411,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02347','RN',151411,41.09,0.44,1170,71959,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02347',0.403882,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151412,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02347','RN',151412,41.8,0.47,1630,71959,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02347',0.403882,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151413,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02172','RN',151413,40.92,0.23,1320,71960,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02172',0.156773,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151414,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02172','RN',151414,41.69,0.25,1890,71960,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02172',0.156773,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151415,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151415,33.95,0.49,61.7,71961,75,NULL,'IR','UGC 11785',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000033,NULL,'15.18',0.17,'Sd','Isolated galaxy',NULL,NULL,NULL,1,324.8615,2.82711,0.217,NULL,52108913391,814201771,12721902,15.18),(151416,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151416,33.99,0.79,62.8,71961,NULL,NULL,'Malmquist cor.','UGC 11785',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151417,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151417,34.11,0.2,66.4,71961,74.4,NULL,NULL,'UGC 11785',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151418,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151418,34.19,0.72,68.9,71961,NULL,NULL,NULL,'UGC 11785',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151419,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151419,34.47,NULL,78.2,71961,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11785',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151420,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151420,34.49,NULL,79.2,71961,NULL,NULL,'Dipole + Quadrupole','UGC 11785',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151421,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151421,34.5,NULL,79.3,71961,NULL,NULL,'Dipole','UGC 11785',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151422,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151422,37.48,0.46,313,71962,70,NULL,NULL,'2MASX J21393111-0735067',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,324.879625,-7.58528,0.125,NULL,49904095524,779751492,12183617,16.4),(151423,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02116','RN',151423,40.41,0.22,924,71963,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02116',0.3078,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151424,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02116','RN',151424,40.62,0.3,1020,71963,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02116',0.3078,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151425,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16734','RN',151425,41.14,0.28,1420,71964,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16734',0.190059,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151426,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151426,37.57,0.27,326,71965,70,NULL,NULL,'2MASX J21393758+1158056',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.0002,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,324.90675,11.96817,0.353,NULL,52295327271,817114488,12767413,18.1),(151427,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151427,38.78,0.46,570,71966,70,NULL,NULL,'2MASX J21393767-0816546',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000198,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,324.907125,-8.28189,0.093,NULL,49905614038,779775219,12183987,18.1),(151428,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151428,33.79,0.49,57.2,71967,75,NULL,'IR','UGC 11786 NOTES01',NULL,'2011yCatp016004901K',2011,1,0.45,NULL,'G',0.00005,NULL,'15.43',0.1,NULL,NULL,NULL,NULL,NULL,1,324.9289583,6.26794,0.189,NULL,52118480219,814351253,12724238,15.43),(151429,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151429,37.58,0.27,328,71968,70,NULL,NULL,'II Zw 143 NOTES02',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,'FoF','18.3',0.31,NULL,NULL,NULL,NULL,NULL,1,324.9300417,10.3305,0.221,NULL,52295975899,817124623,12767572,18.3),(151430,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151430,35.86,0.46,149,71969,70,NULL,NULL,'II Zw 143 NOTES01',NULL,'2015arXiv151105856S',2015,1,0.73,NULL,'G',0.000127,NULL,'14.8g',0.68,'E0',NULL,NULL,NULL,NULL,1,324.930916667,10.3375,0.221,NULL,52295975724,817124620,12767572,14.8),(151431,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151431,37.27,0.33,285,71970,70,NULL,NULL,'2MASX J21394398+1243177',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000148,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,324.933167,12.72147,0.305,NULL,52227829458,816059835,12750934,17.4),(151432,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151432,34.63,0.56,84.1,71971,70,NULL,NULL,'2MASX J21394628-2952372',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00013,NULL,'15.46',0.33,'S',NULL,NULL,NULL,NULL,1,324.942791667,-29.87706,0.073,NULL,51472486313,804257598,12566524,15.46),(151433,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151433,37.24,0.46,281,71972,70,NULL,NULL,'2MASX J21394680-0852086',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000148,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,324.945,-8.86903,0.097,NULL,49905834193,779778659,12184041,17.6),(151434,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151434,34.44,0.49,77.2,71973,70,NULL,NULL,'ESO 403- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000037,NULL,'13.75',1.3,'(R:)SAB(r)a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,324.965583,-36.03697,0.045,NULL,51452999836,803953122,12561767,13.75),(151435,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151435,35.39,0.69,120,71974,70,NULL,NULL,'2MASX J21395237-2245361',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'14.6r',0.4,'S0',NULL,NULL,NULL,NULL,1,324.968167,-22.76,0.081,NULL,50924775214,795699612,12432806,14.6),(151436,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151436,37.58,0.27,328,71975,70,NULL,NULL,'2MASX J21395419+1021516',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000181,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,324.975791667,10.36436,0.221,NULL,52296092572,817126446,12767600,17),(151437,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151437,38.52,0.33,506,71976,70,NULL,NULL,'SDSS J213956.35+122955.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000203,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,324.984833,12.49878,0.317,NULL,52227988188,816062315,12750973,18.7),(151438,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151438,37.7,0.46,347,71977,70,NULL,NULL,'2MASX J21395655-0014589',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,324.9857917,-0.24978,0.161,NULL,49697824484,776528507,12133257,17.8),(151439,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02117','RN',151439,41.54,0.52,1720,71978,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02117',0.184662,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151440,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151440,34.62,0.56,84,71979,70,NULL,NULL,'MCG -04-51-007',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000107,NULL,'14.97',0.67,'S0',NULL,NULL,NULL,NULL,1,324.996583,-22.69217,0.081,NULL,50924808005,795700125,12432814,14.97),(151441,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151441,37.31,0.46,290,71980,70,NULL,NULL,'2MASXi J2140002-084140',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.0010417,-8.69464,0.093,NULL,49905920981,779780015,12184062,17.6),(151442,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151442,38.46,0.12,430,71981,74.2,NULL,'SALT 2','SDSS J214000.48-000002.9',0.1442,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,'PHOT',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,325.002,-0.00081,0.197,NULL,49694384203,776474753,12132418,NULL),(151443,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151443,39.05,0.05,564,71981,70,NULL,'SDSS-II SN 08921','SDSS J214000.48-000002.9',0.1442,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151444,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 08921','R',151444,39.24,0.18,615,71981,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ld','SDSS J214000.48-000002.9',0.145387,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151445,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151445,39.26,0.1,623,71981,65,NULL,'SALT2','SDSS J214000.48-000002.9',0.1442,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151446,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 08921','R',151446,39.46,0.11,680,71981,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ld','SDSS J214000.48-000002.9',0.145387,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151447,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151447,39.47,0.1,685,71981,65,NULL,'MLCS2k2','SDSS J214000.48-000002.9',0.1442,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151448,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151448,39.18,0.07,685,71981,70,NULL,'SALT 2','SDSS J214000.48-000002.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151449,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ld',NULL,151449,39.18,0.07,685,71981,70,NULL,'SALT 2, Malmquist cor.','SDSS J214000.48-000002.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151450,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151450,36.2,0.55,174,71982,70,NULL,NULL,'2MASX J21400073-0643245',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,325.002958333,-6.72364,0.113,NULL,49903956483,779749320,12183583,16.5),(151451,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151451,33.86,0.8,59.2,71982,75,NULL,'MAT, I','ESO 287- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151452,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151452,33.82,0.43,58,71982,75,NULL,'MAT, I, raw','ESO 287- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151453,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151453,33.9,0.32,60.3,71982,85,NULL,'I, raw','ESO 287- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151454,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151454,33.93,0.32,61,71982,85,NULL,'I, inv','ESO 287- G 046',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151455,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151455,33.95,0.43,61.5,71982,75,NULL,'MAT, I, inv','ESO 287- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151456,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151456,34.12,0.43,66.8,71982,75,NULL,'MAT, I, cor','ESO 287- G 046',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151457,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151457,37.27,0.33,285,71983,70,NULL,NULL,'SDSS J214001.40+124652.9',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',NULL,NULL,'17.1g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.005875,12.78136,0.305,NULL,52227808819,816059512,12750929,17.1),(151458,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151458,36.55,0.46,204,71984,70,NULL,NULL,'2MASX J21400194+0003020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000148,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,325.00825,0.05061,0.197,NULL,52093785614,813965400,12718209,17.3),(151459,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151459,37.29,0.46,287,71985,70,NULL,NULL,'2MASX J21400217+1046237',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.0090417,10.77314,0.209,NULL,52297918527,817154976,12768046,17.5),(151460,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151460,33.71,0.49,55.1,71986,70,NULL,NULL,'ESO 107- G 044',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.85',0.6,'SAB(s)0^0^?','in a triple',NULL,NULL,NULL,1,325.01425,-63.90894,0.045,NULL,49343083401,770985678,12046651,13.85),(151461,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13677','R',151461,41,0.28,1210,71987,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214004.88-010117.1',0.3045,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'20.3g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.020375,-1.02142,0.149,NULL,49698254677,776535229,12133362,20.3),(151462,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13677','R',151462,41.26,0.22,1370,71987,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214004.88-010117.1',0.3045,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151463,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13677',NULL,151463,40.82,0.17,1460,71987,70,NULL,'SALT 2','SDSS J214004.88-010117.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151464,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13677',NULL,151464,40.85,0.17,1480,71987,70,NULL,'SALT 2, Malmquist cor.','SDSS J214004.88-010117.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151465,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151465,32.52,0.14,31.9,71988,74.4,NULL,NULL,'NGC 7097',NULL,'2013AJ....146...86T',2013,1,1.9,'SGC incorrectly calls this galaxy NGC 7095.','G',0.000063,NULL,'12.61',1.3,'E              LINER','in a pair',NULL,NULL,NULL,1,325.0537917,-42.53939,0,NULL,50635303466,791176616,12362134,12.61),(151466,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151466,32.55,0.21,32.4,71988,NULL,NULL,'I','NGC 7097',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151467,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151467,31.12,0.65,16.7,71988,95,NULL,'Weighted Mean','NGC 7097',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151468,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151468,32.36,0.81,29.6,71988,55,NULL,'Visvanathan & Sandage 1979','NGC 7097',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151469,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151469,32.41,0.8,30.4,71988,75,NULL,'B','NGC 7097',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151470,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151470,32.64,0.4,33.7,71988,NULL,NULL,'mean','NGC 7097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151471,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151471,33.08,0.45,41.2,71988,NULL,NULL,'K','NGC 7097',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151472,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151472,35.47,0.5,124,71989,70,NULL,NULL,'IC 1393',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000143,NULL,'15.45',0.5,'S0',NULL,NULL,NULL,NULL,1,325.059375,-22.41139,0.061,NULL,50924939120,795702173,12432846,15.45),(151473,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17541',NULL,151473,40.14,0.24,1070,71990,70,NULL,'SN photometric redshift distance, z photo =0.290 +/- 0.041','SDSS-II SN 17541',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.059333,0.72586,0.197,NULL,52096745758,814011652,12718932,NULL),(151474,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17541','R',151474,40.67,0.25,1080,71990,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17541',0.267938,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151475,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17541','R',151475,40.71,0.2,1090,71990,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17541',0.267938,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151476,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151476,38.52,0.33,506,71991,70,NULL,NULL,'2MASX J21401729+1235525',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.072125,12.59792,0.325,NULL,52227844085,816060063,12750938,17.9),(151477,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151477,36.96,0.46,246,71992,70,NULL,NULL,'2MASX J21401790-0043445',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.4g',0.27,NULL,NULL,NULL,NULL,NULL,1,325.074667,-0.72886,0.165,NULL,49697951697,776530495,12133288,16.4),(151478,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151478,37,0.54,251,71993,70,NULL,NULL,'2MASX J21401977-3254205',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'15.1r',0.33,NULL,NULL,NULL,NULL,NULL,1,325.082375,-32.90572,0.053,NULL,51451759196,803933737,12561464,15.1),(151479,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151479,36.27,0.53,179,71994,70,NULL,NULL,'2MASX J21402291-5716265',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'15.4r',0.28,NULL,NULL,NULL,NULL,NULL,1,325.095625,-57.27403,0.041,NULL,48715677470,761182460,11893475,15.4),(151480,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151480,33.16,0.8,42.8,71995,75,NULL,'MAT, I','ESO 531- G 022',NULL,'1997ApJS..109..333W',1997,1,3.02,NULL,'G',0.000013,NULL,'14',0.36,'Sc',NULL,NULL,NULL,NULL,1,325.122791667,-26.52794,0.089,NULL,51464883460,804138804,12564668,14),(151481,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151481,33.21,0.49,43.9,71995,75,NULL,'IR','ESO 531- G 022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151482,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151482,33.26,0.43,44.8,71995,75,NULL,'MAT, I, raw','ESO 531- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151483,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151483,33.38,0.32,47.5,71995,85,NULL,'I, raw','ESO 531- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151484,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151484,33.43,0.32,48.5,71995,85,NULL,'I, inv','ESO 531- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151485,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151485,33.46,0.43,49.3,71995,75,NULL,'MAT, I, inv','ESO 531- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151486,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151486,33.49,0.2,49.9,71995,74.4,NULL,NULL,'ESO 531- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151487,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151487,33.5,0.43,50.1,71995,75,NULL,'MAT, I, cor','ESO 531- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151488,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151488,33.55,0.49,51.2,71995,NULL,NULL,'Malmquist cor.','ESO 531- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151489,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151489,33.64,0.46,53.5,71995,NULL,NULL,NULL,'ESO 531- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151490,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151490,33.87,NULL,59.5,71995,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 531- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151491,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151491,33.88,NULL,59.6,71995,NULL,NULL,'Dipole + Quadrupole','ESO 531- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151492,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151492,33.88,NULL,59.8,71995,NULL,NULL,'Dipole','ESO 531- G 022',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151493,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151493,33.89,NULL,60.1,71995,NULL,NULL,NULL,'ESO 531- G 022',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151494,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151494,35.98,0.56,157,71996,70,NULL,NULL,'2MASX J21403336-1320432',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.71',0.34,NULL,NULL,NULL,NULL,NULL,1,325.1392083,-13.34531,0.137,NULL,49765115745,777579933,12149686,16.71),(151495,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151495,36.84,0.51,233,71997,70,NULL,NULL,'2MASX J21403539-4948179',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.000133,NULL,'14.2r',0.52,'E',NULL,NULL,NULL,NULL,1,325.1475417,-49.80497,0,NULL,50663850980,791622671,12369104,14.2),(151496,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02008','RN',151496,40.91,0.23,1300,71998,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02008',0.165129,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151497,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02008','RN',151497,41.27,0.26,1540,71998,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02008',0.165129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151498,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13719','RN',151498,40.79,0.29,1280,71999,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13719',0.119584,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151499,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151499,35.34,0.53,117,72000,70,NULL,NULL,'ABELL S0963:[GMT93] M',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.75',0.23,'Sa',NULL,NULL,NULL,NULL,1,325.154958333,-22.33969,0.061,NULL,50924904073,795701626,12432837,16.75),(151500,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151500,36.35,0.46,186,72001,70,NULL,NULL,'2MASX J21403847-0722017',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,325.16025,-7.36706,0.077,NULL,49904180063,779752813,12183637,17.1),(151501,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151501,37.29,0.46,288,72002,70,NULL,NULL,'2MASX J21403869+1143216',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,325.161333,11.72278,0.277,NULL,52298249418,817160147,12768127,17),(151502,'SNII optical','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN ASASSN-13co','R',151502,34.46,0.23,78,72003,73,NULL,'EPM','CGCG 402-014',NULL,'2014arXiv1411.3322H',2014,1,0.6,NULL,'G',NULL,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,325.1622917,6.50978,0.153,NULL,52299014735,817172105,12768314,15.7),(151503,'Magnitude','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151503,35.96,0.13,156,72004,100,NULL,NULL,'2MASX J21404094-1416322',NULL,'1998A&A...337...31R',1998,1,0.29,NULL,'G',0.00013,NULL,'17.81',0.23,NULL,NULL,NULL,NULL,NULL,1,325.170625,-14.27561,0.165,NULL,50887808659,795122010,12423781,17.81),(151504,'Magnitude','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151504,35.96,0.13,156,72005,100,NULL,NULL,'ABELL 2362',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,325.181875,-14.27236,0.165,NULL,50887808679,795122010,12423781,NULL),(151505,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151505,36.34,0.25,185,72006,74.4,NULL,NULL,'GIN 659',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000053,NULL,'14.31',0.37,'E/S0',NULL,NULL,NULL,NULL,1,325.2399583,-16.71578,0.113,NULL,50895052311,795235192,12425549,14.31),(151506,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151506,36.52,0.41,202,72006,70,NULL,NULL,'GIN 659',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151507,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151507,32.88,0.8,37.7,72007,75,NULL,'MAT, I','ESO 011- G 005',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000026,NULL,'16.26',0.3,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,325.244,-82.79964,0.429,NULL,48343086557,755360727,11802511,16.26),(151508,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151508,32.94,0.4,38.8,72007,75,NULL,NULL,'ESO 011- G 005',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151509,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151509,33.25,0.4,44.7,72007,NULL,NULL,NULL,'ESO 011- G 005',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151510,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151510,33.37,0.49,47.3,72007,75,NULL,'IR','ESO 011- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151511,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151511,33.55,0.32,51.2,72007,85,NULL,'I, inv','ESO 011- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151512,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151512,33.55,0.32,51.3,72007,85,NULL,'I, raw','ESO 011- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151513,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151513,33.77,0.43,56.7,72007,75,NULL,'MAT, I, raw','ESO 011- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151514,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151514,33.81,0.43,57.9,72007,75,NULL,'MAT, I, inv','ESO 011- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151515,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151515,33.94,0.43,61.4,72007,75,NULL,'MAT, I, cor','ESO 011- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151516,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06535','R',151516,40.39,0.13,917,72008,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214059.77+000311.7',0.3064,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',0.0005,NULL,'21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.249083,0.05325,0.189,NULL,52093880699,813966885,12718232,21.5),(151517,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06535','R',151517,40.49,0.22,958,72008,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214059.77+000311.7',0.3064,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151518,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06535',NULL,151518,40.37,0.11,1190,72008,70,NULL,'SALT 2','SDSS J214059.77+000311.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151519,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06535',NULL,151519,40.4,0.11,1200,72008,70,NULL,'SALT 2, Malmquist cor.','SDSS J214059.77+000311.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151520,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151520,35.33,0.8,116,72009,75,NULL,'CF, r','UGC 11789',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000037,NULL,'14.67',0.6,'Sb',NULL,NULL,NULL,NULL,1,325.2502917,1.33506,0.181,NULL,52097262179,814019721,12719058,14.67),(151521,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151521,34.36,0.38,74.4,72009,75,NULL,'CF, r, raw','UGC 11789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151522,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151522,34.44,0.38,77.4,72009,75,NULL,'CF, r, inv','UGC 11789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151523,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151523,34.73,0.38,88.2,72009,75,NULL,'CF, r, cor','UGC 11789',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151524,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20722','R',151524,40.89,0.26,1160,72010,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214101.54+004205.5',0.301347,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.2564583,0.70156,0.197,NULL,52096734639,814011478,12718929,21.2),(151525,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20722','R',151525,41.02,0.21,1230,72010,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214101.54+004205.5',0.301347,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151526,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20722',NULL,151526,40.77,0.15,1430,72010,70,NULL,'SALT 2','SDSS J214101.54+004205.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151527,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20722',NULL,151527,40.8,0.15,1450,72010,70,NULL,'SALT 2, Malmquist cor.','SDSS J214101.54+004205.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151528,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02049','RN',151528,42.24,0.19,1730,72011,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02049',0.624003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151529,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151529,38.58,0.46,519,72012,70,NULL,NULL,'2MASX J21410260-0054027',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.261,-0.90078,0.193,NULL,49698110910,776532982,12133327,17.8),(151530,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20575','R',151530,39.63,0.11,690,72013,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007rh','SDSS J214103.77+000832.8',0.22,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,325.2657083,0.14244,0.189,NULL,52094016208,813969003,12718265,NULL),(151531,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20575','R',151531,39.67,0.19,703,72013,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007rh','SDSS J214103.77+000832.8',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151532,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2007rh',NULL,151532,39.45,0.08,776,72013,70,NULL,'SALT 2','SDSS J214103.77+000832.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151533,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2007rh',NULL,151533,39.46,0.08,780,72013,70,NULL,'SALT 2, Malmquist cor.','SDSS J214103.77+000832.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151534,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151534,36.34,0.25,185,72014,74.4,NULL,NULL,'GIN 658',NULL,'2013AJ....146...86T',2013,1,0.7,'May contribute to the radio flux of PMN J2141-1642.','G',0.000097,NULL,'15.44',0.5,'cD',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,325.26625,-16.69397,0.113,NULL,50895052699,795235198,12425549,15.44),(151535,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151535,36.52,0.41,202,72014,70,NULL,NULL,'GIN 658',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151536,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151536,37.67,0.33,342,72015,70,NULL,NULL,'2MASX J21411350-0815358',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000154,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,325.306375,-8.26011,0.089,NULL,49907571280,779805801,12184465,18.1),(151537,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151537,36.12,0.6,167,72016,70,NULL,NULL,'2MASX J21411374-5558356',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'15.5r',0.19,NULL,NULL,NULL,NULL,NULL,1,325.307375,-55.97667,0.049,NULL,48665397183,760396830,11881200,15.5),(151538,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 21482',NULL,151538,39.8,0.59,914,72017,70,NULL,'SN photometric redshift distance, z photo =0.242 +/- 0.092','SDSS-II SN 21482',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.327083,-0.09614,0.157,NULL,49694528902,776477014,12132453,NULL),(151539,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151539,35.77,0.57,143,72018,70,NULL,NULL,'2MASX J21411891-0129514',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,325.32875,-1.49761,0.185,NULL,49697668017,776526062,12133219,15.6),(151540,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151540,33.24,0.49,44.5,72019,70,NULL,NULL,'NGC 7096',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.00009,NULL,'12.82',1.6,'(R\')SA(rs)ab','Parent (of companion) galaxy',NULL,NULL,NULL,1,325.330333333,-63.90869,0.045,NULL,49343048125,770985126,12046642,12.82),(151541,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151541,32.82,0.8,36.7,72019,75,NULL,'B','NGC 7096',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151542,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151542,36.28,0.79,180,72020,70,NULL,NULL,'2MASX J21412121-7000237',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.9b',0.33,NULL,NULL,NULL,NULL,NULL,1,325.3382917,-70.00658,0.021,NULL,49303771052,770371422,12037053,16.9),(151543,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151543,36.96,0.46,247,72021,70,NULL,NULL,'2MASX J21412205-0701404',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.342,-7.02783,0.121,NULL,49904824127,779762876,12183794,17.5),(151544,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151544,38.16,0.46,428,72022,70,NULL,NULL,'2MASX J21412351+0011166',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.347875,0.18806,0.189,NULL,52093894841,813967106,12718236,17.6),(151545,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151545,37.67,0.33,342,72023,70,NULL,NULL,'SDSS J214124.43-081826.1',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000201,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,325.351833,-8.30725,0.089,NULL,49907840866,779810013,12184531,16.8),(151546,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151546,37.79,0.46,361,72024,70,NULL,NULL,'2MASX J21412596-0742093',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,325.35825,-7.70278,0.089,NULL,49907643262,779806925,12184483,17.2),(151547,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151547,36.48,0.46,198,72025,70,NULL,NULL,'2MASX J21412630-0751043',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,325.3594583,-7.85117,0.089,NULL,49907668478,779807319,12184489,16.5),(151548,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151548,37.24,0.83,281,72025,70,NULL,NULL,'2MASX J21412630-0751043',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151549,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151549,38.11,0.46,419,72026,70,NULL,NULL,'2MASX J21412736+0059026',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.364,0.98419,0.189,NULL,52097094647,814017103,12719017,17.5),(151550,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151550,33.91,0.8,60.6,72027,75,NULL,'MAT, I','ESO 343- G 018',NULL,'1997ApJS..109..333W',1997,1,1.67,NULL,'G',0.000033,NULL,'14.60',0.33,'Sc: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,325.3669583,-39.76492,0,NULL,51472658869,804260294,12566567,14.6),(151551,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151551,33.76,0.32,56.5,72027,85,NULL,'I, raw','ESO 343- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151552,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151552,33.79,0.32,57.2,72027,85,NULL,'I, inv','ESO 343- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151553,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151553,33.85,0.43,58.8,72027,75,NULL,'MAT, I, raw','ESO 343- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151554,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151554,34,0.43,63,72027,75,NULL,'MAT, I, inv','ESO 343- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151555,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151555,34,0.49,63,72027,75,NULL,'IR','ESO 343- G 018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151556,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151556,34.11,0.34,66.3,72027,NULL,NULL,NULL,'ESO 343- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151557,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151557,34.12,0.43,66.7,72027,75,NULL,'MAT, I, cor','ESO 343- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151558,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151558,34.15,0.2,67.6,72027,74.4,NULL,NULL,'ESO 343- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151559,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151559,34.2,0.32,69,72027,NULL,NULL,'Malmquist cor.','ESO 343- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151560,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151560,36.2,0.46,174,72028,70,NULL,NULL,'2MASX J21412864+0036296',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,325.36925,0.60828,0.197,NULL,52093923794,813967559,12718243,16.7),(151561,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151561,33.74,0.49,56,72029,NULL,NULL,'Malmquist cor.','UGC 11790',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.71',1.1,'SA(rs)d:','Isolated galaxy',NULL,NULL,NULL,1,325.374875,0.89464,0.189,NULL,52097066740,814016667,12719010,14.71),(151562,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151562,34.01,0.43,63.3,72029,NULL,NULL,NULL,'UGC 11790',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151563,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151563,34.05,0.2,64.6,72029,74.4,NULL,NULL,'UGC 11790',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151564,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151564,35.32,0.59,116,72030,NULL,NULL,NULL,'ESO 531- G 023',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.6r',0.7,'SA(r)bc',NULL,NULL,NULL,NULL,1,325.401333,-26.59222,0.089,NULL,51464694374,804135849,12564622,14.6),(151565,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151565,35.36,0.2,118,72030,74.4,NULL,NULL,'ESO 531- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151566,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151566,35.47,0.55,124,72030,NULL,NULL,'Malmquist cor.','ESO 531- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151567,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151567,37.51,0.46,317,72031,70,NULL,NULL,'SDSS J214137.06-084624.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000157,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.404416667,-8.77344,0.073,NULL,49905344519,779771008,12183922,18.3),(151568,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347',NULL,151568,39.82,0.34,920,72032,70,NULL,'SN photometric redshift distance, z photo =0.244 +/- 0.049','SDSS-II SN 15347',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.405167,1.20442,0.181,NULL,52097136098,814017751,12719027,21.5),(151569,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347','R',151569,40.36,0.23,931,72032,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15347',0.270007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151570,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347','R',151570,40.58,0.16,1030,72032,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15347',0.270007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151571,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347',NULL,151571,40.09,0.13,1040,72032,70,NULL,'SALT 2','SDSS-II SN 15347',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151572,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15347',NULL,151572,40.11,0.13,1050,72032,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15347',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151573,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 12850','RN',151573,40.63,0.32,1020,72033,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12850',0.305003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151574,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 12850','RN',151574,40.72,0.25,1070,72033,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12850',0.305003,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151575,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151575,38.08,0.46,412,72034,70,NULL,NULL,'2MASX J21413925-0832163',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,325.413458333,-8.538,0.069,NULL,49907110406,779798600,12184353,18.3),(151576,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20476','R',151576,40.62,0.17,1140,72035,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20476',0.169122,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,325.420041667,0.83897,0.189,NULL,52097060019,814016562,12719008,NULL),(151577,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20476','R',151577,40.72,0.22,1190,72035,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20476',0.169122,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151578,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17396',NULL,151578,40.22,0.18,1100,72036,70,NULL,'SN photometric redshift distance, z photo =0.302 +/- 0.031','SDSS-II SN 17396',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.4207083,-0.47711,0.161,NULL,49694467475,776476054,12132438,NULL),(151579,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151579,33.77,0.47,56.6,72037,70,NULL,NULL,'NGC 7105',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00012,NULL,'13.51',0.8,'(R\')SB0^0^:',NULL,NULL,NULL,NULL,1,325.4222917,-10.6355,0.137,NULL,49898073984,779657406,12182146,13.51),(151580,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151580,36.06,0.71,163,72038,70,NULL,NULL,'2MASX J21414560-5505407',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'15.2r',0.16,NULL,NULL,NULL,NULL,NULL,1,325.4399583,-55.09461,0.021,NULL,48666281118,760410642,11881416,15.2),(151581,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151581,35.55,0.53,129,72039,70,NULL,NULL,'2MASX J21414684-4649159',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000133,NULL,'13.9r',1.6,'S0-:',NULL,NULL,NULL,NULL,1,325.4452917,-46.82106,0,NULL,50639741060,791245954,12363218,13.9),(151582,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151582,37.76,0.33,357,72040,70,NULL,NULL,'SDSS J214148.77-005811.0',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000163,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,325.453208333,-0.96972,0.193,NULL,49697648859,776525763,12133215,18.5),(151583,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151583,37.76,0.33,357,72041,70,NULL,NULL,'2MASX J21414887-0102180',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000159,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.45375,-1.03828,0.193,NULL,49697650125,776525783,12133215,17.2),(151584,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151584,34.53,0.5,80.6,72042,NULL,NULL,'Malmquist cor.','ESO 403- G 014',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.84',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,325.455625,-35.19578,0.013,NULL,51454837877,803981841,12562216,15.84),(151585,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151585,34.58,0.48,82.6,72042,NULL,NULL,NULL,'ESO 403- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151586,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151586,34.63,0.2,84.3,72042,74.4,NULL,NULL,'ESO 403- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151587,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11120','R',151587,38.47,0.2,445,72043,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214150.10+002209.4',0.1074,'2014arXiv1401.3317S',2014,1,0.36,NULL,'G',0.0001,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.45875,0.36928,0.181,NULL,52093976726,813968386,12718256,17.2),(151588,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11120','R',151588,38.53,0.1,460,72043,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214150.10+002209.4',0.1074,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151589,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11120',NULL,151589,38.36,0.12,470,72043,70,NULL,'SALT 2','SDSS J214150.10+002209.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151590,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11120',NULL,151590,38.37,0.12,472,72043,70,NULL,'SALT 2, Malmquist cor.','SDSS J214150.10+002209.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151591,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151591,34.64,0.46,84.9,72044,70,NULL,NULL,'NGC 7108',NULL,'2015arXiv151105856S',2015,1,1.07,NULL,'G',0.000067,NULL,'14.4g',0.75,'E3/S0-',NULL,NULL,NULL,NULL,1,325.4739583,-6.70883,0.089,NULL,49903965168,779749455,12183585,14.4),(151592,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151592,35.03,0.47,101,72044,70,NULL,NULL,'NGC 7108',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151593,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151593,36.69,0.58,218,72045,70,NULL,NULL,'2MASX J21415966-0646197',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000077,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,325.498583,-6.77203,0.089,NULL,49903974710,779749604,12183587,15.9),(151594,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151594,36.85,0.13,234,72045,70,NULL,NULL,'2MASX J21415966-0646197',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151595,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151595,36.34,0.25,185,72046,74.4,NULL,NULL,'GIN 661',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.000087,NULL,'15.08',0.35,'E/S0',NULL,NULL,NULL,NULL,1,325.506583333,-16.90364,0.121,NULL,50896878603,795263728,12425995,15.08),(151596,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151596,36.52,0.41,202,72046,70,NULL,NULL,'GIN 661',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151597,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151597,37.38,0.46,299,72047,70,NULL,NULL,'SDSS J214206.72-072533.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000178,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.528,-7.426,0.101,NULL,49904521710,779758151,12183721,18.1),(151598,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01196','RN',151598,42.1,0.2,1920,72048,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01196',0.370508,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151599,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01196','RN',151599,42.3,0.14,2100,72048,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01196',0.370508,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151600,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151600,34.55,0.6,81.4,72049,70,NULL,NULL,'2MASX J21420736-1904396',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'14.7r',0.55,'S0',NULL,NULL,NULL,NULL,1,325.53075,-19.07764,0.065,NULL,50929132242,795767691,12433870,14.7),(151601,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 05461','RN',151601,42.11,0.26,2370,72050,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05461',0.115844,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151602,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 05461','RN',151602,42.19,0.2,2450,72050,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05461',0.115844,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151603,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828',NULL,151603,39.5,0.68,793,72051,70,NULL,'SN photometric redshift distance, z photo =0.206 +/- 0.090','SDSS-II SN 20828',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.5382083,0.96236,0.181,NULL,52097081370,814016896,12719014,21.4),(151604,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828','R',151604,41.44,0.28,1430,72051,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20828',0.358376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151605,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828','R',151605,41.5,0.37,1470,72051,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20828',0.358376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151606,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828',NULL,151606,41.36,0.22,1870,72051,70,NULL,'SALT 2','SDSS-II SN 20828',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151607,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20828',NULL,151607,41.41,0.22,1910,72051,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20828',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151608,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151608,37.73,0.21,351,72052,70,NULL,NULL,'2MASX J21421006-0633527',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.5419583,-6.56453,0.089,NULL,49912335009,779880234,12185628,17.4),(151609,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 21164','RN',151609,44.09,0.35,4100,72053,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21164',0.601231,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151610,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151610,34.11,0.8,66.3,72054,75,NULL,'MAT, I','NGC 7110',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.23',0.6,'SB(r)b','in a pair',NULL,NULL,NULL,1,325.550625,-34.16222,0.037,NULL,51452185202,803940393,12561568,14.23),(151611,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151611,34.13,0.32,66.9,72054,85,NULL,'I, raw','NGC 7110',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151612,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151612,34.16,0.43,67.9,72054,75,NULL,'MAT, I, raw','NGC 7110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151613,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151613,34.18,0.32,68.6,72054,85,NULL,'I, inv','NGC 7110',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151614,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151614,34.35,0.3,74.2,72054,NULL,NULL,'Malmquist cor.','NGC 7110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151615,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151615,34.4,0.43,75.9,72054,75,NULL,'MAT, I, inv','NGC 7110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151616,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151616,34.42,0.29,76.7,72054,NULL,NULL,NULL,'NGC 7110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151617,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151617,34.45,0.43,77.5,72054,75,NULL,'MAT, I, cor','NGC 7110',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151618,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151618,34.47,0.2,78.3,72054,74.4,NULL,NULL,'NGC 7110',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151619,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151619,33.78,0.66,57.1,72055,NULL,NULL,'Malmquist cor.','UGC 11792',NULL,'2009ApJS..182..474S',2009,1,1.69,NULL,'G',NULL,NULL,'15.49',0.22,'Sc',NULL,NULL,NULL,NULL,1,325.5532917,5.61531,0.249,NULL,52320736681,817511510,12773617,15.49),(151620,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151620,33.87,0.2,59.4,72055,74.4,NULL,NULL,'UGC 11792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151621,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151621,34.03,0.59,63.9,72055,NULL,NULL,NULL,'UGC 11792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151622,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151622,34.55,NULL,81.1,72055,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151623,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151623,34.56,NULL,81.5,72055,NULL,NULL,'Dipole + Quadrupole','UGC 11792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151624,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151624,34.56,NULL,81.6,72055,NULL,NULL,'Dipole','UGC 11792',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151625,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151625,36.35,0.25,186,72056,74.4,NULL,NULL,'MCG -03-55-006',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000063,NULL,'14.69',0.66,'S',NULL,NULL,NULL,NULL,1,325.565833,-16.938,0.121,NULL,50897044727,795266323,12426036,14.69),(151626,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151626,36.52,0.41,202,72056,70,NULL,NULL,'MCG -03-55-006',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151627,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151627,37.39,0.89,301,72057,70,NULL,NULL,'2MASX J21422171-7441071',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.4r',0.19,NULL,NULL,NULL,NULL,NULL,1,325.590458333,-74.68531,0.177,NULL,48417491589,756523306,11820676,15.4),(151628,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151628,37.73,0.21,351,72058,70,NULL,NULL,'SDSS J214222.37-063710.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,325.59325,-6.61964,0.089,NULL,49912342186,779880346,12185630,18.3),(151629,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151629,34.06,0.49,64.9,72059,75,NULL,'IR','UGC 11794',NULL,'2011yCatp016004901K',2011,1,1.34,'Often mistakenly called NGC 7112.','G',0.00006,NULL,'14.9g',0.43,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,325.595167,12.49828,0.317,NULL,52229274551,816082414,12751287,14.9),(151630,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151630,34.26,0.43,71.2,72059,75,NULL,'3.6 micron, color corrected','UGC 11794',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151631,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151631,34.27,0.43,71.3,72059,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11794',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151632,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151632,34.3,0.2,72.4,72059,74.4,NULL,NULL,'UGC 11794',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151633,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151633,35.51,0.58,126,72060,70,NULL,NULL,'2MASX J21422438-1233477',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,325.60175,-12.56328,0.129,NULL,49763814976,777559609,12149368,14.5),(151634,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151634,32.21,0.4,27.6,72061,75,NULL,'B','NGC 7107',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000019,NULL,'13.3',1.5,'SB(rs)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,325.610333,-44.79028,0,NULL,50648597744,791384339,12365380,13.3),(151635,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151635,37.73,0.21,351,72062,70,NULL,NULL,'2MASX J21422693-0635127',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00015,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,325.6120417,-6.58678,0.089,NULL,49912310527,779879851,12185622,16),(151636,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151636,36.85,0.13,234,72063,70,NULL,NULL,'2MASX J21422700-0654057',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000117,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,325.612541667,-6.90169,0.089,NULL,49904419152,779756549,12183696,17.2),(151637,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151637,35.9,0.52,151,72064,70,NULL,NULL,'2MASX J21422987-0625397',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.0001,NULL,'16.26',0.43,NULL,NULL,NULL,NULL,NULL,1,325.624667,-6.42783,0.089,NULL,49912416053,779881500,12185648,16.26),(151638,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2007oq',NULL,151638,40.42,0.28,1210,72065,70,NULL,'Hubble residual -0.01 for z0.33910','SDSS J214230.73+005904.8',NULL,'2011ApJ...740...92G',2011,1,0.04,NULL,'G',0.0005,NULL,'23.2g',0.02,NULL,NULL,NULL,NULL,NULL,1,325.628083333,0.98469,0.181,NULL,52093629431,813962959,12718171,23.2),(151639,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19067','R',151639,41.19,0.26,1290,72065,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007oq','SDSS J214230.73+005904.8',0.3391,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151640,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19067','R',151640,41.22,0.19,1310,72065,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007oq','SDSS J214230.73+005904.8',0.3391,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151641,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13820','RN',151641,40.31,0.25,1010,72066,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13820',0.135721,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151642,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13820','RN',151642,40.54,0.23,1130,72066,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13820',0.135721,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151643,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13820','N',151643,40.3,0.13,1150,72066,70,NULL,'SALT 2','SDSS-II SN 13820',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151644,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13820','N',151644,40.31,0.13,1150,72066,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13820',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151645,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151645,37.34,0.46,293,72067,70,NULL,NULL,'2MASX J21423262-0823337',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,325.635875,-8.39281,0.109,NULL,49907138973,779799046,12184360,16.6),(151646,'GRB','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151646,42.77,NULL,3590,72068,70,NULL,'Pseudo z = 2.36','GRB 030821',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,325.6375,-45.2,0,NULL,50649643912,791400686,12365635,NULL),(151647,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151647,37.73,0.21,351,72069,70,NULL,NULL,'2MASX J21423471-0635427',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.644541667,-6.59525,0.089,NULL,49912309544,779879836,12185622,17.8),(151648,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151648,33.08,0.8,41.3,72070,75,NULL,'MAT, I','NGC 7106',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000026,NULL,'13.87',1,'SAB(rs)c',NULL,NULL,NULL,NULL,1,325.6524583,-52.69953,0,NULL,50607991122,790749861,12355466,13.87),(151649,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151649,33.03,0.32,40.4,72070,85,NULL,'I, raw','NGC 7106',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151650,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151650,33.05,0.32,40.8,72070,85,NULL,'I, inv','NGC 7106',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151651,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151651,33.22,0.43,44,72070,75,NULL,'MAT, I, raw','NGC 7106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151652,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151652,33.36,0.43,47,72070,75,NULL,'MAT, I, inv','NGC 7106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151653,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151653,33.4,0.4,47.9,72070,NULL,NULL,'mean','NGC 7106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151654,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151654,33.42,0.43,48.2,72070,75,NULL,'MAT, I, cor','NGC 7106',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151655,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151655,33.61,0.46,52.7,72070,NULL,NULL,'J','NGC 7106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151656,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151656,33.62,0.45,52.9,72070,NULL,NULL,'K','NGC 7106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151657,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151657,33.65,0.47,53.6,72070,NULL,NULL,'H','NGC 7106',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151658,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151658,36.85,0.13,234,72071,70,NULL,NULL,'2MASX J21423740-0647207',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'16.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,325.6560417,-6.78908,0.089,NULL,49913149407,779892959,12185827,16.7),(151659,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151659,37.2,0.54,276,72071,70,NULL,NULL,'2MASX J21423740-0647207',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151660,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151660,33.44,0.47,48.8,72072,NULL,NULL,'H','NGC 7116',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.31',0.4,'S?',NULL,NULL,NULL,NULL,1,325.667583,28.94658,0.621,NULL,55629675561,869213680,13581463,14.31),(151661,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151661,33.45,0.4,48.9,72072,NULL,NULL,'mean','NGC 7116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151662,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151662,33.56,0.46,51.5,72072,NULL,NULL,'J','NGC 7116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151663,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151663,33.6,0.45,52.6,72072,NULL,NULL,'K','NGC 7116',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151664,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151664,38.24,0.46,446,72073,70,NULL,NULL,'2MASX J21424404-0849067',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.6835417,-8.81839,0.073,NULL,49907021281,779797207,12184331,17.6),(151665,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151665,37.05,0.59,257,72074,70,NULL,NULL,'LCRS B213940.9-384712',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.2r',0.29,NULL,NULL,NULL,NULL,NULL,1,325.68725,-38.55811,0,NULL,51439836096,803747439,12558553,15.2),(151666,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151666,36.85,0.13,234,72075,70,NULL,NULL,'2MASX J21424588-0651526',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000184,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,325.691333333,-6.86461,0.069,NULL,49913136166,779892752,12185824,16.8),(151667,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151667,36.46,0.49,196,72076,70,NULL,NULL,'MCG -01-55-004 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000083,NULL,'15.89',0.47,'cD;BrClG',NULL,NULL,NULL,NULL,1,325.7032917,-6.86853,0.069,NULL,49912620039,779884688,12185698,15.89),(151668,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151668,38.29,0.46,455,72077,70,NULL,NULL,'SDSS J214250.52+124345.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,325.7105417,12.72931,0.333,NULL,52229238330,816081848,12751278,18.2),(151669,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151669,36.85,0.13,234,72078,70,NULL,NULL,'2MASX J21425132-0652136',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000178,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.713917,-6.87044,0.069,NULL,49912620251,779884691,12185698,17.3),(151670,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151670,36.85,0.13,234,72079,70,NULL,NULL,'2MASX J21425219-0648476',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,325.717375,-6.81328,0.069,NULL,49913140502,779892820,12185825,17.5),(151671,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151671,36.85,0.13,234,72080,70,NULL,NULL,'2MASX J21425542-0652506',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000178,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,325.730916667,-6.88078,0.069,NULL,49912620822,779884700,12185698,17),(151672,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151672,36.85,0.13,234,72081,70,NULL,NULL,'2MASX J21425568-0635536',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,325.732,-6.59811,0.089,NULL,49913181962,779893468,12185835,16.5),(151673,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151673,37.07,0.63,259,72081,70,NULL,NULL,'2MASX J21425568-0635536',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151674,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151674,36.43,0.63,193,72082,70,NULL,NULL,'2MASX J21425904-5514572',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'15.4r',0.27,NULL,NULL,NULL,NULL,NULL,1,325.7459583,-55.24919,0.025,NULL,48665980110,760405939,11881342,15.4),(151675,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151675,36.85,0.13,234,72083,70,NULL,NULL,'2MASX J21425999-0657546',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000168,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,325.750083,-6.96508,0.069,NULL,49912616844,779884638,12185697,16.7),(151676,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151676,37.73,0.21,351,72084,70,NULL,NULL,'2MASX J21430112-0632406',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,325.754667,-6.54458,0.089,NULL,49913202589,779893790,12185840,16.8),(151677,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151677,36.85,0.13,234,72085,70,NULL,NULL,'2MASX J21430227-0701536',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.0001,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,325.7595417,-7.03156,0.073,NULL,49912668750,779885449,12185710,16.4),(151678,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151678,37.74,0.56,354,72085,70,NULL,NULL,'2MASX J21430227-0701536',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151679,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151679,36.41,0.82,191,72086,70,NULL,NULL,'2MFGC 16396',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.7b',0.16,NULL,NULL,NULL,NULL,NULL,1,325.768667,-71.96133,0.045,NULL,49307409067,770428266,12037941,16.7),(151680,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151680,35.26,0.46,113,72087,70,NULL,NULL,'MCG -06-47-013',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000133,NULL,'14.73',0.5,'E',NULL,NULL,NULL,NULL,1,325.7727083,-36.73889,0,NULL,51442343070,803786610,12559165,14.73),(151681,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151681,36.69,0.54,218,72088,70,NULL,NULL,'2MASX J21430577-0704066',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000103,NULL,'15.5g',0.51,'S0^-',NULL,NULL,NULL,NULL,1,325.774167,-7.06847,0.073,NULL,49912636354,779884943,12185702,15.5),(151682,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151682,36.85,0.13,234,72088,70,NULL,NULL,'2MASX J21430577-0704066',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151683,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151683,36.68,0.46,217,72089,70,NULL,NULL,'2MASX J21430655-0817486',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,325.77725,-8.29678,0.109,NULL,49907930112,779811408,12184553,16.1),(151684,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151684,37.41,0.75,303,72090,70,NULL,NULL,'2MASX J21431248-5157400',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'17.1b',NULL,NULL,NULL,NULL,NULL,NULL,1,325.8020417,-51.96108,0,NULL,50661377416,791584022,12368500,17.1),(151685,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151685,35.73,0.83,140,72091,70,NULL,NULL,'2MASX J21431256-4658577',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.0r',0.28,NULL,NULL,NULL,NULL,NULL,1,325.8024583,-46.98264,0,NULL,50639018871,791234669,12363041,15),(151686,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11026','RN',151686,41.02,0.24,1240,72092,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11026',0.284202,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151687,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11026','RN',151687,41.46,0.32,1530,72092,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 11026',0.284202,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151688,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15263','R',151688,41.89,0.36,1630,72093,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214313.54+000036.0',0.467976,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,325.8064583,0.01,0.189,NULL,52093412578,813959571,12718118,21.8),(151689,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15263',NULL,151689,41.75,0.27,2240,72093,70,NULL,'SALT 2','SDSS J214313.54+000036.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151690,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15263',NULL,151690,41.86,0.27,2360,72093,70,NULL,'SALT 2, Malmquist cor.','SDSS J214313.54+000036.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151691,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19047','RN',151691,42.07,0.26,1840,72094,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19047',0.412081,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151692,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19047','RN',151692,42.47,0.41,2210,72094,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19047',0.412081,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151693,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151693,36.85,0.13,234,72095,70,NULL,NULL,'2MASX J21431906-0658484',NULL,'2015arXiv151105856S',2015,1,0.41,'Star superposed 15\\\" northwest of the nucleus.','G',0.00015,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,325.8295417,-6.97997,0.069,NULL,49912675770,779885558,12185711,16.3),(151694,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151694,37.84,0.67,370,72095,70,NULL,NULL,'2MASX J21431906-0658484',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151695,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151695,33.58,0.4,51.9,72096,NULL,NULL,'mean','UGC 11797',NULL,'2007A&A...465...71T',2007,1,1.4,'UZC has V = 4176 +- 56 km/sec.','G',0.000057,NULL,'15.2',0.7,'_',NULL,NULL,NULL,NULL,1,325.834208333,43.57631,NULL,NULL,55395638601,865556853,13524325,15.2),(151696,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151696,33.99,0.46,62.7,72096,NULL,NULL,'J','UGC 11797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151697,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151697,34,0.47,63.2,72096,NULL,NULL,'H','UGC 11797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151698,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151698,34.12,0.45,66.7,72096,NULL,NULL,'K','UGC 11797',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151699,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151699,34.25,0.8,70.9,72097,75,NULL,'MAT, I','ESO 236- G 037',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.5r',0.9,'SA(rs)bc',NULL,NULL,NULL,NULL,1,325.8400417,-48.31894,0.013,NULL,50657469739,791522964,12367546,13.5),(151700,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151700,33.65,NULL,53.7,72097,NULL,NULL,'B','ESO 236- G 037',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151701,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151701,33.65,0.27,53.7,72097,NULL,NULL,'B, Hubble-type-TF','ESO 236- G 037',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151702,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151702,33.97,0.32,62.3,72097,85,NULL,'I, raw','ESO 236- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151703,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151703,34.01,0.43,63.3,72097,75,NULL,'MAT, I, raw','ESO 236- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151704,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151704,34.02,0.32,63.6,72097,85,NULL,'I, inv','ESO 236- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151705,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151705,34.21,0.43,69.5,72097,75,NULL,'MAT, I, inv','ESO 236- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151706,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151706,34.25,NULL,70.8,72097,NULL,NULL,'I','ESO 236- G 037',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151707,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151707,34.31,0.43,72.9,72097,75,NULL,'MAT, I, cor','ESO 236- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151708,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151708,34.37,0.47,75,72097,NULL,NULL,'H','ESO 236- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151709,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151709,34.37,0.31,75,72097,NULL,NULL,'Malmquist cor.','ESO 236- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151710,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151710,34.43,0.3,76.8,72097,NULL,NULL,NULL,'ESO 236- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151711,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151711,34.46,0.4,78,72097,NULL,NULL,'mean','ESO 236- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151712,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151712,34.47,0.2,78.3,72097,74.4,NULL,NULL,'ESO 236- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151713,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151713,34.49,0.46,78.9,72097,NULL,NULL,'J','ESO 236- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151714,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151714,34.54,0.45,80.9,72097,NULL,NULL,'K','ESO 236- G 037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151715,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151715,37.17,0.46,272,72098,70,NULL,NULL,'2MASX J21432262+1140161',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,325.8442083,11.67114,0.273,NULL,52297726818,817151981,12767999,17.4),(151716,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151716,37.11,0.46,265,72099,70,NULL,NULL,'2MASX J21432438+0009071',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.85175,0.15192,0.197,NULL,52093408061,813959500,12718117,17),(151717,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151717,32.32,0.47,29.1,72100,NULL,NULL,'H','UGC 11798',NULL,'2007A&A...465...71T',2007,1,1.9,'abs(b) < 10 degrees.','G',0.00004,NULL,'15.2',0.3,'S',NULL,NULL,NULL,NULL,1,325.862583,43.55514,NULL,NULL,55395637735,865556839,13524325,15.2),(151718,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151718,32.43,0.45,30.7,72100,NULL,NULL,'K','UGC 11798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151719,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151719,32.62,0.46,33.4,72100,NULL,NULL,'J','UGC 11798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151720,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151720,33.42,0.4,48.3,72100,NULL,NULL,'mean','UGC 11798',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151721,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151721,36.78,0.46,227,72101,70,NULL,NULL,'2MASX J21433416-0645184',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,325.8922917,-6.75522,0.077,NULL,49913226448,779894163,12185846,16.5),(151722,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151722,34.24,0.4,70.5,72102,NULL,NULL,'mean','UGC 11799',NULL,'2007A&A...465...71T',2007,1,1.1,'abs(b) < 10 degrees.','G',NULL,NULL,'13.1B',1,'SB?',NULL,NULL,NULL,NULL,1,325.8962917,43.69411,NULL,NULL,55395740122,865558439,13524350,13.1),(151723,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151723,34.45,0.43,77.6,72102,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11799',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151724,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151724,34.67,0.46,85.8,72102,NULL,NULL,'J','UGC 11799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151725,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151725,34.7,0.45,87,72102,NULL,NULL,'K','UGC 11799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151726,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151726,34.73,0.47,88.2,72102,NULL,NULL,'H','UGC 11799',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151727,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151727,34.96,0.2,98.2,72103,74.4,NULL,NULL,'CGCG 376-025',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000043,NULL,'15.2',0.3,'Sb','Isolated galaxy',NULL,NULL,NULL,1,325.906667,2.63492,0.197,NULL,52313571951,817399561,12771868,15.2),(151728,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151728,35.02,0.32,101,72103,NULL,NULL,NULL,'CGCG 376-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151729,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151729,35.31,0.28,115,72103,NULL,NULL,'Malmquist cor.','CGCG 376-025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151730,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151730,33.22,0.8,44,72104,75,NULL,'MAT, I','NGC 7115',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000026,NULL,'15.05',0.4,'Sb pec',NULL,NULL,NULL,NULL,1,325.9105417,-25.35161,0.125,NULL,51410286370,803285724,12551339,15.05),(151731,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151731,32.03,0.2,25.5,72104,74.4,NULL,NULL,'NGC 7115',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151732,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151732,32.95,0.32,38.9,72104,85,NULL,'I, raw','NGC 7115',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151733,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151733,32.98,0.32,39.4,72104,85,NULL,'I, inv','NGC 7115',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151734,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151734,33.13,0.43,42.3,72104,75,NULL,'MAT, I, raw','NGC 7115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151735,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151735,33.28,0.43,45.4,72104,75,NULL,'MAT, I, inv','NGC 7115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151736,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151736,33.37,0.43,47.2,72104,75,NULL,'MAT, I, cor','NGC 7115',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151737,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151737,36.13,0.46,168,72105,70,NULL,NULL,'2MASX J21433892-0843234',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,325.912125,-8.72319,0.069,NULL,49907205686,779800088,12184376,16.9),(151738,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151738,37.87,0.46,375,72106,70,NULL,NULL,'2MASX J21433993+1238537',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,325.916333333,12.64819,0.245,NULL,52229327335,816083239,12751300,17.9),(151739,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151739,36.26,0.48,179,72107,70,NULL,NULL,'2MASX J21434056-5206460',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,325.918917,-52.11275,0,NULL,50661201076,791581266,12368457,15.8),(151740,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151740,35.89,0.55,151,72108,70,NULL,NULL,'2MASX J21434383-5328090',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.9r',0.28,NULL,NULL,NULL,NULL,NULL,1,325.932583,-53.46919,0,NULL,50605108144,790704814,12354762,14.9),(151741,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151741,36.56,0.46,205,72109,70,NULL,NULL,'2MASX J21434628-0745471',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,325.942791667,-7.76297,0.097,NULL,49907260765,779800949,12184389,17.5),(151742,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151742,36.98,0.56,249,72110,70,NULL,NULL,'2MASX J21434702-0834121',NULL,'2014MNRAS.445.2677S',2014,1,0.49,'Brighter star 12\\\" to the west.','G',0.00015,NULL,'15.4R',0.45,NULL,NULL,NULL,NULL,NULL,1,325.9459583,-8.56992,0.109,NULL,49907097065,779798391,12184349,15.4),(151743,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151743,36.07,0.48,164,72111,70,NULL,NULL,'2MASX J21434945-0804261',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000073,NULL,'15.94',0.68,NULL,NULL,NULL,NULL,NULL,1,325.956,-8.07408,0.097,NULL,49907420601,779803446,12184428,15.94),(151744,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15935',NULL,151744,39.37,0.35,748,72112,70,NULL,'SN photometric redshift distance, z photo =0.193 +/- 0.039','SDSS-II SN 15935',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.8g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,325.963083,0.43994,0.217,NULL,52093343171,813958487,12718101,22.8),(151745,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151745,35.13,0.52,106,72113,70,NULL,NULL,'CGCG 376-027',NULL,'2014MNRAS.445.2677S',2014,1,0.5,'Second entry in 1999ApJS..121..287H has RA +1 minute in error.','G',0.000113,NULL,'15.5g',0.48,'E0',NULL,NULL,NULL,NULL,1,325.963791667,-0.32139,0.201,NULL,49694370285,776474535,12132414,15.5),(151746,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151746,35.35,0.46,117,72113,70,NULL,NULL,'CGCG 376-027',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151747,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06332','R',151747,39.41,0.17,660,72114,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06332',0.152229,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,325.964833333,-0.71814,0.189,NULL,49694977254,776484019,12132562,NULL),(151748,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06332','R',151748,40.03,0.28,881,72114,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06332',0.152229,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151749,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151749,37.31,0.46,290,72115,70,NULL,NULL,'2MASX J21435201-0821391',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000159,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,325.966583333,-8.36094,0.093,NULL,49907895419,779810865,12184544,18.2),(151750,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151750,37.55,0.54,323,72116,70,NULL,NULL,'2MASX J21435620-5135031',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000103,NULL,'15.1r',0.39,NULL,NULL,NULL,NULL,NULL,1,325.984125,-51.58425,0,NULL,50661363367,791583802,12368496,15.1),(151751,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151751,36.07,0.57,163,72117,70,NULL,NULL,'2MASX J21435667-0841311',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.3g',0.3,NULL,NULL,NULL,NULL,NULL,1,325.98625,-8.69189,0.069,NULL,49906611311,779790801,12184231,16.3),(151752,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151752,36.35,0.33,186,72117,70,NULL,NULL,'2MASX J21435667-0841311',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151753,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151753,38.02,0.46,401,72118,70,NULL,NULL,'2MASX J21435713+1042038',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000149,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,325.9879583,10.70119,0.193,NULL,52308578040,817321531,12770648,17.4),(151754,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151754,36.35,0.33,186,72119,70,NULL,NULL,'2MASX J21435727-0818371',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,325.9885417,-8.31039,0.093,NULL,49907370991,779802671,12184416,16.5),(151755,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13610','R',151755,40.78,0.23,1100,72120,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hd','SDSS J214403.55+004334.6',0.3,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.0147917,0.72628,0.237,NULL,52094188270,813971691,12718307,NULL),(151756,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13610','R',151756,40.97,0.14,1200,72120,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hd','SDSS J214403.55+004334.6',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151757,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006hd',NULL,151757,40.62,0.12,1330,72120,70,NULL,'SALT 2','SDSS J214403.55+004334.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151758,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006hd',NULL,151758,40.64,0.12,1340,72120,70,NULL,'SALT 2, Malmquist cor.','SDSS J214403.55+004334.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151759,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151759,36.54,0.46,203,72121,70,NULL,NULL,'2MASX J21440396-0858111',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.4g',0.3,NULL,NULL,NULL,NULL,NULL,1,326.016583,-8.96967,0.085,NULL,49906500659,779789072,12184204,16.4),(151760,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151760,36.6,0.62,209,72121,70,NULL,NULL,'2MASX J21440396-0858111',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151761,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151761,36.9,0.66,240,72122,70,NULL,NULL,'2MASX J21440469-0827351',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.6g',0.35,'Sab',NULL,NULL,NULL,NULL,1,326.019625,-8.45967,0.109,NULL,49906583114,779790361,12184224,15.6),(151762,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151762,32.26,0.8,28.3,72123,75,NULL,'MAT, I','ESO 403- G 017',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.05',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,326.0290417,-36.17992,0,NULL,51440309317,803754833,12558669,15.05),(151763,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151763,31.36,0.32,18.7,72123,85,NULL,'I, inv','ESO 403- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151764,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151764,31.41,0.32,19.1,72123,85,NULL,'I, raw','ESO 403- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151765,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151765,31.59,0.43,20.8,72123,75,NULL,'MAT, I, inv','ESO 403- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151766,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151766,31.73,0.43,22.1,72123,75,NULL,'MAT, I, raw','ESO 403- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151767,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151767,31.81,0.4,23,72123,NULL,NULL,NULL,'ESO 403- G 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151768,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151768,31.81,0.4,23,72123,73,NULL,'opt','ESO 403- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151769,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151769,31.81,0.43,23,72123,75,NULL,'3.6 micron, color + selection bias corrected','ESO 403- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151770,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151770,31.82,0.2,23.1,72123,74.4,NULL,NULL,'ESO 403- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151771,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151771,31.85,0.43,23.5,72123,75,NULL,'3.6 micron, color corrected','ESO 403- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151772,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151772,32.11,0.43,26.4,72123,75,NULL,'MAT, I, cor','ESO 403- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151773,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151773,32.61,0.26,33.3,72123,NULL,NULL,NULL,'ESO 403- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151774,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151774,37.91,0.46,382,72124,70,NULL,NULL,'SDSS J214409.65+001731.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000125,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,326.0402083,0.29217,0.225,NULL,52093498293,813960910,12718139,18.5),(151775,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151775,32.32,0.8,29.1,72125,75,NULL,NULL,'NGC 7098',NULL,'1988NBGC.C....0000T',1988,1,4.1,NULL,'G',0.000019,NULL,'12.23',2.6,'(R)SAB(r)a',NULL,NULL,NULL,NULL,1,326.067167,-75.11133,0.373,NULL,48417939845,756530310,11820786,12.23),(151776,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151776,37.01,0.46,252,72126,70,NULL,NULL,'2MASX J21441995-0815562',NULL,'2015arXiv151105856S',2015,1,0.35,'Star superposed 12\\\" northwest of the nucleus.','G',0.000155,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,326.083208333,-8.26569,0.093,NULL,49906265960,779785405,12184146,17),(151777,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19464','RN',151777,42.65,0.3,2730,72127,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19464',0.239213,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151778,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19464','RN',151778,42.94,0.28,3130,72127,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19464',0.239213,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151779,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151779,37.72,0.46,350,72128,70,NULL,NULL,'2MASX J21442296+1112174',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,326.095666667,11.20475,0.281,NULL,52308671982,817322999,12770671,17.4),(151780,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151780,36.5,0.46,200,72129,70,NULL,NULL,'2MASX J21442548-0015509',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,326.106083333,-0.26408,0.189,NULL,49694155845,776471185,12132362,17),(151781,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151781,37.96,0.46,391,72130,70,NULL,NULL,'2MASX J21442547+1122264',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,326.106125,11.37397,0.273,NULL,52308608879,817322013,12770656,17.7),(151782,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151782,37.59,0.46,330,72131,70,NULL,NULL,'2MASX J21442728+1217451',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000194,NULL,'16.5g',0.4,NULL,NULL,NULL,NULL,NULL,1,326.11375,12.29583,0.277,NULL,52228668956,816072952,12751139,16.5),(151783,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151783,35.81,0.74,145,72132,70,NULL,NULL,'2MASX J21442818-0632232',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.90',0.21,NULL,NULL,NULL,NULL,NULL,1,326.117417,-6.53983,0.069,NULL,49912907664,779889182,12185768,16.9),(151784,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19048','R',151784,39.85,0.17,821,72133,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19048',0.136789,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.1245417,0.59556,0.237,NULL,52093330329,813958286,12718098,NULL),(151785,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19048','R',151785,39.96,0.23,865,72133,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19048',0.136789,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151786,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151786,34.79,0.58,90.8,72134,NULL,NULL,NULL,'ESO 600- G 009',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.19',0.8,'Sb:',NULL,NULL,NULL,NULL,1,326.129041667,-20.04417,0.093,NULL,50929999094,795781235,12434081,15.19),(151787,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151787,34.83,0.2,92.5,72134,74.4,NULL,NULL,'ESO 600- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151788,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151788,34.9,0.55,95.3,72134,NULL,NULL,'Malmquist cor.','ESO 600- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151789,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151789,37.11,0.46,265,72135,70,NULL,NULL,'2MASX J21443118+1114064',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000167,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,326.1299583,11.23519,0.281,NULL,52308663885,817322873,12770669,17.7),(151790,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151790,37.19,0.59,274,72136,70,NULL,NULL,'2MASX J21443144-0911282',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.50',0.3,NULL,NULL,NULL,NULL,NULL,1,326.1310417,-9.19128,0.085,NULL,49908325614,779817587,12184649,16.5),(151791,'GRB','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151791,44.05,0.83,3070,72137,NULL,NULL,NULL,'GRB 080413B',1.1,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,326.144125,-19.98103,0.093,NULL,50930460626,795788447,12434194,NULL),(151792,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151792,35.62,0.61,133,72138,70,NULL,NULL,'2MASX J21443337-1001282',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.99',0.47,NULL,NULL,NULL,NULL,NULL,1,326.139083333,-10.02453,0.113,NULL,49912198561,779878102,12185595,15.99),(151793,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151793,37.31,0.46,290,72139,70,NULL,NULL,'SDSS J214434.59+104828.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,326.144125,10.80792,0.209,NULL,52308606027,817321969,12770655,18.4),(151794,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151794,36.43,0.53,193,72140,70,NULL,NULL,'2MASX J21443568-0609222',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'16.16',0.43,NULL,NULL,NULL,NULL,NULL,1,326.148708333,-6.15639,0.093,NULL,49912975312,779890239,12185784,16.16),(151795,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151795,38.29,0.46,454,72141,70,NULL,NULL,'SDSS J214438.49+110326.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,326.160375,11.05731,0.201,NULL,52308674405,817323037,12770672,18.9),(151796,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF10wos','N',151796,37.97,0.04,363,72142,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10wos',0.082,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151797,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151797,33.17,NULL,43.1,72143,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2339',NULL,'2010Ap&SS.325..163P',2010,1,2.05,NULL,'G',0.000013,NULL,'15.5g',0.22,'Sd(f)',NULL,NULL,NULL,NULL,1,326.164417,-6.68964,0.069,NULL,49913061708,779891589,12185806,15.5),(151798,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151798,33.19,NULL,43.4,72143,NULL,NULL,'Dipole','FGC 2339',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151799,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151799,33.19,NULL,43.4,72143,NULL,NULL,'Dipole + Quadrupole','FGC 2339',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151800,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151800,33.26,NULL,45,72143,NULL,NULL,NULL,'FGC 2339',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151801,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151801,34.37,0.4,74.9,72144,NULL,NULL,'Malmquist cor.','ESO 343- G 026',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'13.8r',0.7,'Sb',NULL,NULL,NULL,NULL,1,326.1732917,-39.18481,0,NULL,51439204229,803737566,12558399,13.8),(151802,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151802,34.44,0.39,77.2,72144,NULL,NULL,NULL,'ESO 343- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151803,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151803,34.48,0.2,78.7,72144,74.4,NULL,NULL,'ESO 343- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151804,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151804,34.53,0.46,80.4,72145,70,NULL,NULL,'MCG -01-55-007',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00003,NULL,'14.9g',0.5,'S0/a',NULL,NULL,NULL,NULL,1,326.1832083,-7.05775,0.069,NULL,49912588681,779884198,12185690,14.9),(151805,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15777',NULL,151805,40.21,0.19,1100,72146,70,NULL,'SN photometric redshift distance, z photo =0.301 +/- 0.033','SDSS-II SN 15777',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.1885417,-0.61831,0.177,NULL,49878785636,779356025,12177437,NULL),(151806,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16878',NULL,151806,40.37,0.27,1190,72147,70,NULL,'SN photometric redshift distance, z photo =0.329 +/- 0.055','SDSS-II SN 16878',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.203833333,-0.12433,0.189,NULL,49694125636,776470713,12132354,21.5),(151807,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151807,36.24,0.6,177,72148,70,NULL,NULL,'2MASX J21444932-0844127',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'15.8g',0.43,'S0^-',NULL,NULL,NULL,NULL,1,326.205458333,-8.73678,0.081,NULL,49906628327,779791067,12184235,15.8),(151808,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151808,36.47,0.46,197,72148,70,NULL,NULL,'2MASX J21444932-0844127',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151809,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151809,34.54,0.5,80.8,72149,70,NULL,NULL,'IC 5123',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'14.45',0.5,'(R)SAB(r)ab',NULL,NULL,NULL,NULL,1,326.205625,-72.42075,0.049,NULL,49306899771,770420308,12037817,14.45),(151810,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151810,35.36,0.4,118,72150,NULL,NULL,'mean','NGC 7121',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00003,NULL,'14.28',0.5,'SB(r)bc?       HII',NULL,NULL,NULL,NULL,1,326.219083333,-3.61972,0.065,NULL,49893413166,779584580,12181009,14.28),(151811,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151811,35.48,0.47,125,72150,NULL,NULL,'H','NGC 7121',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151812,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07024','RN',151812,42.18,0.26,2040,72151,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07024',0.339001,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151813,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07024','RN',151813,42.25,0.38,2100,72151,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07024',0.339001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151814,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 18884',NULL,151814,41.59,NULL,2080,72152,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 18884',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.263,-0.94997,0.137,NULL,49879638081,779369345,12177646,NULL),(151815,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151815,36.38,0.52,189,72153,70,NULL,NULL,'2MASX J21451239-5454340',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'14.8r',0.42,'S0',NULL,NULL,NULL,NULL,1,326.301667,-54.90953,0.005,NULL,48663011953,760359561,11880618,14.8),(151816,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151816,36.6,0.74,209,72154,70,NULL,NULL,'2MASX J21451515-0816065',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000103,NULL,'16.4g',0.28,NULL,NULL,NULL,NULL,NULL,1,326.313167,-8.26844,0.093,NULL,49906394966,779787421,12184178,16.4),(151817,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151817,36.82,0.46,232,72155,70,NULL,NULL,'2MASX J21451599-0011461',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,326.3165417,-0.19622,0.189,NULL,49878717689,779354963,12177421,16.5),(151818,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151818,36.24,0.59,177,72156,70,NULL,NULL,'6dF J2145180-350003',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,326.325,-35.00083,0,NULL,51453965520,803968211,12562003,15.6),(151819,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01294','RN',151819,38.53,0.25,421,72157,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01294',0.20665,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151820,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01294','RN',151820,39.69,0.25,719,72157,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01294',0.20665,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151821,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151821,37.66,0.33,340,72158,70,NULL,NULL,'2MASX J21452357-0818235',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,326.348333,-8.30667,0.093,NULL,49906387827,779787309,12184176,17.4),(151822,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151822,35.29,0.55,114,72159,70,NULL,NULL,'2MASX J21452504-7723178',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.3r',0.22,NULL,NULL,NULL,NULL,NULL,1,326.354417,-77.38831,0.413,NULL,48528881347,758263771,11847871,15.3),(151823,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02118','RN',151823,41.79,0.09,1750,72160,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02118',0.306109,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151824,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02118','RN',151824,42.01,0.24,1930,72160,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02118',0.306109,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151825,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151825,35.78,0.67,143,72161,70,NULL,NULL,'2MASX J21453092-7537597',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.3r',0.12,NULL,NULL,NULL,NULL,NULL,1,326.379041667,-75.63322,0.425,NULL,48408730914,756386420,11818537,15.3),(151826,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151826,37.66,0.33,340,72162,70,NULL,NULL,'2MASX J21453179-0809245',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00017,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,326.3825,-8.15692,0.093,NULL,49906445930,779788217,12184190,17.3),(151827,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151827,34.35,0.8,74.1,72163,75,NULL,'MAT, I','ESO 466- G 005',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000027,NULL,'14.5r',0.6,'Sb',NULL,NULL,NULL,NULL,1,326.384417,-29.07344,0.081,NULL,51468471546,804194867,12565544,14.5),(151828,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151828,34.49,0.32,79.1,72163,85,NULL,'I, raw','ESO 466- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151829,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151829,34.52,0.32,80,72163,85,NULL,'I, inv','ESO 466- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151830,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151830,34.69,0.43,86.8,72163,75,NULL,'MAT, I, raw','ESO 466- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151831,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151831,34.79,0.2,90.8,72163,74.4,NULL,NULL,'ESO 466- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151832,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151832,34.83,0.43,92.3,72163,75,NULL,'MAT, I, inv','ESO 466- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151833,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151833,34.86,0.57,93.8,72163,NULL,NULL,'Malmquist cor.','ESO 466- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151834,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151834,34.96,0.55,98.1,72163,NULL,NULL,NULL,'ESO 466- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151835,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151835,35.08,0.43,104,72163,75,NULL,'MAT, I, cor','ESO 466- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151836,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06660',NULL,151836,39.29,0.76,720,72164,70,NULL,'SN photometric redshift distance, z photo =0.185 +/- 0.090','SDSS-II SN 06660',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.3g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,326.388,-0.25225,0.189,NULL,49878701823,779354715,12177417,21.3),(151837,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151837,37.99,0.46,397,72165,70,NULL,NULL,'2MASX J21453322+1239227',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,326.388583,12.65625,0.277,NULL,52228620096,816072189,12751127,17.2),(151838,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151838,35.85,0.66,148,72166,70,NULL,NULL,'2MASX J21453763-5518504',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'14.9r',0.3,'S',NULL,NULL,NULL,NULL,1,326.406667,-55.31403,0.009,NULL,48665733754,760402089,11881282,14.9),(151839,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151839,36.96,0.52,246,72167,70,NULL,NULL,'2MASX J21454401-1042334',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.20',0.5,NULL,NULL,NULL,NULL,NULL,1,326.4332083,-10.70942,0.125,NULL,49910457723,779850901,12185170,16.2),(151840,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151840,37.15,0.46,269,72168,70,NULL,NULL,'SDSS J214544.23-084108.4',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,326.434291667,-8.68567,0.081,NULL,49906947111,779796048,12184313,17.7),(151841,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151841,34.45,0.4,77.6,72169,75,NULL,'Edat, raw','NGC 7117',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00007,NULL,'13.76',0.9,'SA(s)0-:',NULL,NULL,NULL,NULL,1,326.446,-48.42042,0.009,NULL,50665615869,791650247,12369535,13.76),(151842,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151842,34.72,0.4,88,72169,75,NULL,'Edat, cor','NGC 7117',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151843,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151843,34.13,0.48,67.1,72169,70,NULL,NULL,'NGC 7117',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151844,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151844,34.43,0.4,77,72169,NULL,NULL,'mean','NGC 7117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151845,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151845,34.81,0.45,91.8,72169,NULL,NULL,'K','NGC 7117',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151846,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151846,35.19,0.39,109,72170,NULL,NULL,NULL,'IC 1398',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000103,NULL,'15.4',0.4,NULL,NULL,NULL,NULL,NULL,1,326.4642917,9.47533,0.205,NULL,52307888995,817310765,12770480,15.4),(151847,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151847,35.29,0.37,114,72170,NULL,NULL,'Malmquist cor.','IC 1398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151848,'BL Lac Luminosity','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151848,40.48,NULL,1010,72171,NULL,NULL,NULL,'2MASX J21455230+0719270',0.237,'2005ApJ...635..173S',2005,1,NULL,NULL,'G',0.003,NULL,'18.04',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,326.467917,7.32422,0.201,NULL,52331797721,817684339,12776317,18.04),(151849,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151849,37.43,0.46,306,72172,70,NULL,NULL,'2MASX J21455345+1236504',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000137,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,326.4725417,12.61408,0.277,NULL,52228637557,816072461,12751132,18),(151850,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 03497','RN',151850,40.97,0.22,1340,72173,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03497',0.166681,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151851,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 03497','RN',151851,41.34,0.31,1590,72173,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03497',0.166681,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151852,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151852,37.52,0.33,319,72174,70,NULL,NULL,'2MASX J21455797-0747484',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,326.4915417,-7.79686,0.065,NULL,49913839683,779903745,12185996,16.3),(151853,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151853,33.4,0.47,48,72175,NULL,NULL,'H','UGC 11808',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000013,NULL,'16.5',1.5,'S?',NULL,NULL,NULL,NULL,1,326.493625,41.27194,NULL,NULL,55382432957,865350514,13521101,16.5),(151854,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151854,33.41,0.45,48.2,72175,NULL,NULL,'K','UGC 11808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151855,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151855,33.54,0.46,51,72175,NULL,NULL,'J','UGC 11808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151856,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151856,33.84,0.4,58.6,72175,NULL,NULL,'mean','UGC 11808',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151857,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151857,33.9,0.49,60.2,72176,75,NULL,'IR','CGCG 402-018',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.00011,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,326.494917,7.87164,0.225,NULL,52330538546,817664664,12776010,15.3),(151858,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151858,34.05,0.2,64.6,72176,74.4,NULL,NULL,'CGCG 402-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151859,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151859,34.31,0.33,72.6,72176,NULL,NULL,NULL,'CGCG 402-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151860,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151860,34.59,0.29,82.7,72176,NULL,NULL,'Malmquist cor.','CGCG 402-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151861,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151861,37.52,0.33,319,72177,70,NULL,NULL,'2MASX J21455885-0748464',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,326.495333,-7.81292,0.085,NULL,49913839834,779903747,12185996,17.5),(151862,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151862,38.04,0.46,406,72178,70,NULL,NULL,'2MASX J21455896-0906204',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,326.495667,-9.10569,0.097,NULL,49906531943,779789561,12184211,17.4),(151863,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393',NULL,151863,39.76,0.35,894,72179,70,NULL,'SN photometric redshift distance, z photo =0.236 +/- 0.048','SDSS-II SN 16393',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,326.501,-0.06092,0.193,NULL,49811592607,778306134,12161033,21.2),(151864,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393','R',151864,40.42,0.24,920,72179,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16393',0.31643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151865,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393','R',151865,40.66,0.17,1030,72179,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16393',0.31643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151866,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393',NULL,151866,40.26,0.13,1130,72179,70,NULL,'SALT 2','SDSS-II SN 16393',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151867,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16393',NULL,151867,40.3,0.13,1150,72179,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16393',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151868,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17171','R',151868,39.39,0.19,649,72180,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007id','2MASX J21460084-0113096',0.160311,'2014arXiv1401.3317S',2014,1,0.18,NULL,'G',NULL,':','19.1g',0.08,NULL,NULL,NULL,NULL,NULL,1,326.5035,-1.21933,0.137,NULL,49879498095,779367157,12177611,19.1),(151869,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 17171','R',151869,39.75,0.18,767,72180,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007id','2MASX J21460084-0113096',0.160311,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151870,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151870,36.77,0.46,226,72181,70,NULL,NULL,'2MASX J21460451+1054360',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,326.519,10.91003,0.201,NULL,52308909272,817326707,12770729,16.4),(151871,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351','R',151871,40.82,0.23,1110,72182,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15351',0.316355,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.535333,-0.05333,0.281,NULL,49811602517,778306289,12161035,NULL),(151872,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351',NULL,151872,40.23,0.27,1110,72182,70,NULL,'SN photometric redshift distance, z photo =0.305 +/- 0.050','SDSS-II SN 15351',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151873,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351','R',151873,40.94,0.29,1170,72182,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15351',0.316355,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151874,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351',NULL,151874,40.79,0.18,1440,72182,70,NULL,'SALT 2','SDSS-II SN 15351',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151875,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15351',NULL,151875,40.82,0.18,1460,72182,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15351',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151876,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151876,34.45,0.4,77.6,72183,75,NULL,'Edat, raw','NGC 7118',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00006,NULL,'13.53',1.2,'SA0- pec:',NULL,NULL,NULL,NULL,1,326.540583,-48.35381,0.009,NULL,50665559334,791649364,12369521,13.53),(151877,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151877,34.72,0.4,88,72183,75,NULL,'Edat, cor','NGC 7118',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151878,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151878,34.09,0.53,65.8,72183,70,NULL,NULL,'NGC 7118',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151879,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151879,34.16,0.4,67.8,72183,NULL,NULL,'mean','NGC 7118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151880,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151880,34.18,0.45,68.4,72183,NULL,NULL,'K','NGC 7118',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151881,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151881,35.02,0.2,101,72184,74.4,NULL,NULL,'CGCG 402-020',NULL,'2013AJ....146...86T',2013,1,0.4,'Not to be confused with IC 1398.','G',0.000017,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,326.549,9.56294,0.205,NULL,52307968911,817312014,12770500,15.5),(151882,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15264','RN',151882,41.18,0.23,1430,72185,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15264',0.209736,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151883,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15264','RN',151883,41.83,0.33,1920,72185,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15264',0.209736,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151884,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20152',NULL,151884,39.47,0.37,783,72186,70,NULL,'SN photometric redshift distance, z photo =0.203 +/- 0.043','SDSS-II SN 20152',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.5549583,1.028,0.289,NULL,52312405972,817381343,12771583,NULL),(151885,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20152','R',151885,40.26,0.15,872,72186,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20152',0.294849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151886,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20152','R',151886,41,0.33,1220,72186,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20152',0.294849,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151887,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06981','RN',151887,42.66,0.22,2100,72187,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06981',0.622043,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151888,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151888,36.8,0.59,230,72188,70,NULL,NULL,'ESO 188-IG 019 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.46,'ESO and ESO-LV both have two entries for this object.','G',0.00015,NULL,'15.2r',0.24,NULL,NULL,NULL,NULL,NULL,1,326.559083,-52.26819,0,NULL,50662240486,791597507,12368711,15.2),(151889,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151889,37.62,0.46,334,72189,70,NULL,NULL,'2MASX J21461470+0108315',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000188,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,326.5612917,1.14219,0.245,NULL,52312166454,817377600,12771525,16.7),(151890,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151890,35.4,0.34,120,72190,NULL,NULL,'Malmquist cor.','CGCG 402-021',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',NULL,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,326.5694583,9.68558,0.217,NULL,52307980665,817312197,12770503,15.6),(151891,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151891,35.43,0.34,122,72190,NULL,NULL,NULL,'CGCG 402-021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151892,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151892,35.65,0.2,135,72190,74.4,NULL,NULL,'CGCG 402-021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151893,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13280','RN',151893,39.97,0.26,873,72191,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13280',0.127606,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151894,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13280','RN',151894,40.5,0.36,1120,72191,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13280',0.127606,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151895,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20047','R',151895,41.69,0.26,1590,72192,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214621.80+003751.9',0.374084,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.000135,NULL,'20.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,326.590833,0.63111,0.261,NULL,52311487854,817366997,12771359,20.6),(151896,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20047','R',151896,41.99,0.24,1820,72192,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214621.80+003751.9',0.374084,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151897,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20047',NULL,151897,41.58,0.16,2070,72192,70,NULL,'SALT 2','SDSS J214621.80+003751.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151898,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20047',NULL,151898,41.64,0.16,2130,72192,70,NULL,'SALT 2, Malmquist cor.','SDSS J214621.80+003751.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151899,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07517','N',151899,41.98,0.19,2490,72193,70,NULL,'SALT 2','SDSS-II SN 07517',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151900,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07517','N',151900,42.04,0.19,2560,72193,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07517',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151901,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01298','RN',151901,40.18,0.23,884,72194,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01298',0.22649,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151902,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151902,37.17,0.02,272,72195,NULL,NULL,'J','PTF09dlc',NULL,'2012MNRAS.425.1007B',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.647917,6.38986,0.205,NULL,52331835854,817684935,12776327,NULL),(151903,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151903,37.4,0.02,283,72195,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09dlc',0.0666,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151904,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151904,37.31,0.05,290,72195,72,NULL,'M(H) = -18.317 mag','PTF09dlc',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151905,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151905,37.37,0.02,298,72195,NULL,NULL,'H','PTF09dlc',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151906,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','PTF09dlc',NULL,151906,37.82,0.07,343,72195,70,NULL,'SiFTO+SALT2, SN PTF09dlc','PTF09dlc',0.0666,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151907,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151907,36.95,0.51,246,72196,70,NULL,NULL,'2MASX J21463413-5059011',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'15.1r',0.34,NULL,NULL,NULL,NULL,NULL,1,326.642375,-50.98361,0,NULL,50661626869,791587919,12368561,15.1),(151908,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 03157','RN',151908,43.54,0.26,3420,72197,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03157',0.493477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151909,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151909,36.94,0.46,245,72198,70,NULL,NULL,'2MASX J21463544+0016587',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000149,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,326.647666667,0.28294,0.241,NULL,52177400871,815271888,12738623,17.3),(151910,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151910,37.01,0.63,253,72199,70,NULL,NULL,'2MASX J21463585-5225001',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000103,NULL,'14.9r',0.38,'S0',NULL,NULL,NULL,NULL,1,326.649333,-52.41664,0,NULL,50659376515,791552758,12368011,14.9),(151911,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151911,37.25,0.46,281,72200,70,NULL,NULL,'2MASX J21463793-0722017',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,326.658,-7.36706,0.057,NULL,49915985861,779937279,12186519,16.5),(151912,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151912,35.78,0.8,143,72201,75,NULL,'CF, r','UGC 11809',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.18',0.4,'Sb','Isolated galaxy',NULL,NULL,NULL,1,326.65875,8.29461,0.197,NULL,52300424583,817194134,12768658,15.18),(151913,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151913,35.65,0.32,135,72201,NULL,NULL,'Malmquist cor.','UGC 11809',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151914,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151914,35.84,0.38,147,72201,75,NULL,'CF, r, raw','UGC 11809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151915,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151915,36.05,0.38,162,72201,75,NULL,'CF, r, cor','UGC 11809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151916,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151916,36.1,0.38,166,72201,75,NULL,'CF, r, inv','UGC 11809',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151917,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151917,36.1,0.26,166,72201,NULL,NULL,NULL,'UGC 11809',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151918,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151918,36.34,0.2,185,72201,74.4,NULL,NULL,'UGC 11809',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151919,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151919,31.86,0.43,23.5,72202,75,NULL,'3.6 micron, color + selection bias corrected','ESO 403- G 024',NULL,'2014MNRAS.444..527S',2014,1,1.3,'1996ApJS..107..201L have V = 4 +- 25 km/s for the superposed star.','G',0.000057,NULL,'15.01',0.6,'SABcd:',NULL,NULL,NULL,NULL,1,326.665667,-36.20539,0,NULL,51440438361,803756849,12558700,15.01),(151920,'BL Lac Luminosity','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151920,40.08,NULL,1040,72203,NULL,NULL,'Min. z = 0.28','1FGL J2146.6-1345',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.672,-13.753,0.101,NULL,49776991464,777765491,12152585,NULL),(151921,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151921,35.32,0.49,116,72204,70,NULL,NULL,'2MASX J21464257-0513447',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00005,NULL,'15.42',0.46,NULL,NULL,NULL,NULL,NULL,1,326.677333333,-5.229,0.037,NULL,49884243032,779441297,12178770,15.42),(151922,'Quasar spectrum','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151922,42.76,NULL,3560,72205,NULL,NULL,NULL,'[HB89] 2143-158',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',NULL,NULL,'21.2',NULL,NULL,NULL,NULL,NULL,NULL,1,326.681,-15.65936,0.165,NULL,49767612258,777618941,12150295,21.2),(151923,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151923,37.5,0.46,316,72206,70,NULL,NULL,'2MASX J21464379-0743049',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000157,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,326.6824583,-7.71794,0.085,NULL,49913950844,779905481,12186023,17.1),(151924,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151924,38.95,0.46,616,72207,70,NULL,NULL,'SDSS J214651.11-075105.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,326.713,-7.85158,0.085,NULL,49913991792,779906121,12186033,18.7),(151925,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06889',NULL,151925,39.07,0.82,653,72208,70,NULL,'SN photometric redshift distance, z photo =0.166 +/- 0.087','SDSS-II SN 06889',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.719917,0.90947,0.289,NULL,52312337612,817380275,12771566,NULL),(151926,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151926,35.58,0.51,131,72209,70,NULL,NULL,'2MASX J21465614-5416020',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.05',0.27,NULL,NULL,NULL,NULL,NULL,1,326.7337917,-54.26719,0,NULL,48662445288,760350707,11880479,16.05),(151927,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151927,33.89,0.8,59.9,72210,75,NULL,'A82, H','IC 1401',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000013,NULL,'14.41',0.7,'SAB(r)bc:','Isolated galaxy',NULL,NULL,NULL,1,326.747875,1.71275,0.225,NULL,52315351949,817427374,12772302,14.41),(151928,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151928,33.9,0.8,60.3,72210,75,NULL,'CF, r','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151929,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151929,33.64,0.33,53.8,72210,91,NULL,'H','IC 1401',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151930,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151930,34,0.38,63.2,72210,75,NULL,'CF, r, raw','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151931,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151931,34.05,0.47,64.6,72210,75,NULL,'A82, H, raw','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151932,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151932,34.12,0.38,66.6,72210,75,NULL,'CF, r, inv','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151933,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151933,34.16,0.2,67.9,72210,74.4,NULL,NULL,'IC 1401',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151934,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151934,34.16,0.47,68,72210,75,NULL,'A82, H, inv','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151935,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151935,34.19,0.4,69,72210,NULL,NULL,'mean','IC 1401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151936,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151936,34.25,0.38,70.7,72210,75,NULL,'CF, r, cor','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151937,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151937,34.41,0.63,76.1,72210,NULL,NULL,NULL,'IC 1401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151938,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151938,34.55,0.47,81.2,72210,75,NULL,'A82, H, cor','IC 1401',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151939,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151939,34.56,0.47,81.8,72210,NULL,NULL,'H','IC 1401',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151940,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151940,34.61,0.58,83.4,72210,NULL,NULL,'Malmquist cor.','IC 1401',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151941,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151941,35.44,0.64,122,72211,70,NULL,NULL,'2MASX J21470166-1031048',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000047,NULL,'16.4',0.4,NULL,NULL,NULL,NULL,NULL,1,326.756917,-10.51794,0.109,NULL,49911484213,779866940,12185420,16.4),(151942,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151942,35.78,0.5,143,72212,70,NULL,NULL,'FAIRALL 0979',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.8r',0.22,'S',NULL,NULL,NULL,NULL,1,326.763916667,-46.66253,0,NULL,50646257696,791347776,12364809,14.8),(151943,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151943,37.07,0.27,259,72213,70,NULL,NULL,'2MASX J21470427-0825188',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,326.7677917,-8.42183,0.093,NULL,49905992700,779781135,12184080,16.3),(151944,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721',NULL,151944,40.58,0.96,1310,72214,70,NULL,'SN photometric redshift distance, z photo =0.370 +/- 0.304','SDSS-II SN 16721',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.8g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,326.7675417,-0.26564,0.193,NULL,49811758282,778308723,12161073,21.8),(151945,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721','R',151945,41.61,0.31,1540,72214,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16721',0.367298,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151946,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721','R',151946,41.66,0.35,1570,72214,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16721',0.367298,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151947,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721',NULL,151947,41.6,0.22,2090,72214,70,NULL,'SALT 2','SDSS-II SN 16721',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151948,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16721',NULL,151948,41.65,0.22,2140,72214,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16721',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151949,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151949,35.68,0.63,137,72215,70,NULL,NULL,'2MASX J21471012-5337071',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000103,NULL,'14.5r',0.25,'S',NULL,NULL,NULL,NULL,1,326.792125,-53.61858,0,NULL,50604375632,790693369,12354583,14.5),(151950,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16454','RN',151950,40.4,0.17,976,72216,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16454',0.229863,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151951,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16454','RN',151951,40.6,0.29,1070,72216,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16454',0.229863,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151952,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151952,37.1,0.46,263,72217,70,NULL,NULL,'2MASX J21471221-0811161',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000092,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,326.800917,-8.18786,0.089,NULL,49914155216,779908675,12186073,16.6),(151953,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151953,37.07,0.27,259,72218,70,NULL,NULL,'2MASX J21471342-0823301',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000073,NULL,'15.8g',0.44,'BrClG',NULL,NULL,NULL,NULL,1,326.805875,-8.39164,0.093,NULL,49913399552,779896868,12185888,15.8),(151954,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 20215','RN',151954,42.59,0.28,1960,72219,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20215',0.683836,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151955,'Sosies','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151955,31.86,0.3,23.6,72220,NULL,NULL,NULL,'UGC 11818',NULL,'2002A&A...393...57T',2002,1,1.4,NULL,'G',0.000013,NULL,'15.0',1.2,'S?',NULL,NULL,NULL,NULL,1,326.8172083,72.47214,2.325,NULL,53516612062,836197063,13065579,15),(151956,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151956,32.07,0.2,25.9,72220,74.4,NULL,NULL,'UGC 11818',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151957,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151957,32.36,0.43,29.6,72220,75,NULL,'3.6 micron, color corrected','UGC 11818',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151958,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151958,32.37,0.43,29.8,72220,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11818',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151959,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151959,32.85,0.4,37.1,72220,NULL,NULL,'mean','UGC 11818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151960,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151960,32.9,0.46,38,72220,NULL,NULL,'J','UGC 11818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151961,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151961,32.97,0.45,39.3,72220,NULL,NULL,'K','UGC 11818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151962,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151962,32.99,0.47,39.7,72220,NULL,NULL,'H','UGC 11818',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151963,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151963,34.57,0.69,81.9,72221,100,NULL,'mid-IR','NGC 7132',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.00012,NULL,'14.6',0.6,NULL,NULL,NULL,NULL,NULL,1,326.819083,10.24117,0.193,NULL,52307672913,817307389,12770427,14.6),(151964,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13416','RN',151964,42.32,0.21,1800,72222,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13416',0.619782,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151965,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151965,37.07,0.27,259,72223,70,NULL,NULL,'2MASX J21471780-0823211',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,326.824125,-8.38911,0.093,NULL,49914119759,779908121,12186064,17.7),(151966,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006kz',NULL,151966,39.22,0.11,700,72224,70,NULL,'Hubble residual -0.01 for z0.18000','SDSS-II SN 15461 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,326.8482083,-0.49475,0.193,NULL,49811646223,778306972,12161046,NULL),(151967,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15461','R',151967,39.75,0.18,752,72224,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kz','SDSS-II SN 15461 HOST',0.186169,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151968,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15461','R',151968,39.94,0.09,820,72224,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kz','SDSS-II SN 15461 HOST',0.186169,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151969,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006kz',NULL,151969,39.62,0.07,839,72224,70,NULL,'SALT 2','SDSS-II SN 15461 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151970,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2006kz',NULL,151970,39.64,0.07,847,72224,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15461 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151971,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151971,33.78,0.8,57,72225,75,NULL,'MAT, I','ESO 343- G 028',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000033,NULL,'15.3r',0.47,'Sb-c',NULL,NULL,NULL,NULL,1,326.851916667,-38.713,0,NULL,51439339141,803739674,12558432,15.3),(151972,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151972,34.03,0.32,63.9,72225,85,NULL,'I, inv','ESO 343- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151973,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151973,34.04,0.32,64.3,72225,85,NULL,'I, raw','ESO 343- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151974,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151974,34.21,0.43,69.5,72225,75,NULL,'MAT, I, raw','ESO 343- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151975,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151975,34.22,0.43,69.7,72225,75,NULL,'MAT, I, inv','ESO 343- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151976,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151976,34.41,0.43,76.1,72225,NULL,NULL,'Malmquist cor.','ESO 343- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151977,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151977,34.41,0.43,76.4,72225,NULL,NULL,NULL,'ESO 343- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151978,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151978,34.46,0.2,78,72225,74.4,NULL,NULL,'ESO 343- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151979,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151979,34.48,0.43,78.6,72225,75,NULL,'MAT, I, cor','ESO 343- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151980,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151980,32.61,0.8,33.3,72226,75,NULL,'B','IC 5131',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000083,NULL,'13.65',1.4,'SB0-','in a pair',NULL,NULL,NULL,1,326.8554583,-34.88367,0,NULL,51454096371,803970255,12562035,13.65),(151981,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151981,36.13,0.46,168,72227,70,NULL,NULL,'2MASX J21472854-0738031',NULL,'2015arXiv151105856S',2015,1,0.48,'SDSS DR3 gives z= 0.036 and 0.0597.','G',0.00015,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,326.868833,-7.63422,0.085,NULL,49913925170,779905080,12186016,16.5),(151982,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151982,37.75,0.46,355,72228,70,NULL,NULL,'2MASX J21473071-0749321',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000156,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,326.878083333,-7.82572,0.085,NULL,49914077226,779907456,12186054,17),(151983,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',151983,37.25,0.46,281,72229,70,NULL,NULL,'2MASX J21473486+0046231',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000183,NULL,'16.5g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,326.89525,0.77322,0.289,NULL,52177733627,815277087,12738704,16.5),(151984,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151984,33.65,0.31,52.7,72230,74.2,NULL,'SALT 2','NGC 7131',0.01807,'2010ApJ...716..712A',2010,1,1.7,NULL,'G',0.000043,NULL,'14.5',1,'(R\')SA(rs)0^0^?',NULL,NULL,NULL,NULL,1,326.9004583,-13.18261,0.113,NULL,49775862175,777747846,12152310,14.5),(151985,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151985,34.15,0.08,67.6,72230,74.4,NULL,NULL,'NGC 7131',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151986,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151986,34.22,0.41,68.6,72230,73.8,NULL,'SALT 2 (SNANA)','NGC 7131',0.0172,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151987,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151987,34.27,0.29,70.2,72230,70,NULL,'SALT','NGC 7131',0.01807,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151988,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151988,34.29,0.08,70.8,72230,72,NULL,NULL,'NGC 7131',0.01807,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151989,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151989,34.37,0.22,73.6,72230,65,NULL,'MLCS31','NGC 7131',0.01807,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151990,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151990,34.43,0.13,74.2,72230,65,NULL,'MLCS2k2','NGC 7131',0.01807,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151991,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151991,34.4,0.32,74.4,72230,65,NULL,'SALT','NGC 7131',0.01807,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151992,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151992,34.48,0.22,77.1,72230,65,NULL,'MLCS17','NGC 7131',0.01807,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151993,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 1998co',NULL,151993,34.68,0.24,84.8,72230,65,NULL,NULL,'NGC 7131',0.01807,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151994,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151994,35.09,0.49,104,72230,70,NULL,NULL,'NGC 7131',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151995,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151995,34.51,0.4,79.8,72230,NULL,NULL,'mean','NGC 7131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151996,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151996,34.68,0.45,86.4,72230,NULL,NULL,'K','NGC 7131',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151997,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151997,33.92,0.2,60.8,72231,74.4,NULL,NULL,'MCG -01-55-011',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000036,NULL,'14.5',0.5,'(R)SB(s)b pec  HII',NULL,NULL,NULL,NULL,1,326.922917,-4.16156,0.097,NULL,49894803208,779606300,12181348,14.5),(151998,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151998,34.01,0.55,63.4,72231,NULL,NULL,NULL,'MCG -01-55-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(151999,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,151999,34.19,0.51,68.7,72231,NULL,NULL,'Malmquist cor.','MCG -01-55-011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152000,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152000,34.36,0.4,74.5,72231,NULL,NULL,'mean','MCG -01-55-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152001,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152001,34.61,0.47,83.5,72231,NULL,NULL,'H','MCG -01-55-011',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152002,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152002,37.25,0.46,282,72232,70,NULL,NULL,'2MASX J21474245-0646146',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,326.926917,-6.77081,0.053,NULL,49915769714,779933901,12186467,16.8),(152003,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152003,36.75,0.64,224,72233,70,NULL,NULL,'2MASX J21480121-1155025',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000073,NULL,'16.81',0.48,NULL,NULL,NULL,NULL,NULL,1,327.005083,-11.91753,0.141,NULL,49901987249,779718550,12183102,16.81),(152004,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152004,32.48,0.8,31.3,72234,75,NULL,'MAT, I','ESO 403- G 031',NULL,'1997ApJS..109..333W',1997,1,1.3,'The APMUKS image includes a superposed star.','G',0.000017,NULL,'15.19',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,327.018167,-36.77408,0,NULL,51440803719,803762558,12558789,15.19),(152005,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152005,31.9,0.32,24,72234,85,NULL,'I, inv','ESO 403- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152006,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152006,31.96,0.32,24.7,72234,85,NULL,'I, raw','ESO 403- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152007,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152007,32.21,0.43,27.6,72234,75,NULL,'MAT, I, inv','ESO 403- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152008,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152008,32.37,0.43,29.7,72234,75,NULL,'MAT, I, raw','ESO 403- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152009,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152009,32.53,0.43,32.1,72234,75,NULL,'3.6 micron, color + selection bias corrected','ESO 403- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152010,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152010,32.6,0.43,33.1,72234,75,NULL,'MAT, I, cor','ESO 403- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152011,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152011,32.61,0.1,33.3,72234,NULL,NULL,NULL,'ESO 403- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152012,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152012,32.63,0.43,33.6,72234,75,NULL,'3.6 micron, color corrected','ESO 403- G 031',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152013,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152013,32.67,0.2,34.2,72234,74.4,NULL,NULL,'ESO 403- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152014,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152014,34.09,0.8,65.8,72235,75,NULL,'MAT, I','NGC 7124',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000028,NULL,'13.10',1.3,'SB(rs)c        LINER','in a pair',NULL,NULL,NULL,1,327.0224583,-50.56522,0,NULL,50661485898,791585717,12368526,13.1),(152015,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152015,33.65,0.43,53.6,72235,75,NULL,'MAT, I, raw','NGC 7124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152016,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152016,33.68,NULL,54.5,72235,NULL,NULL,'B','NGC 7124',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152017,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152017,33.69,0.46,54.7,72235,NULL,NULL,'B, Hubble-type-TF','NGC 7124',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152018,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152018,33.69,0.32,54.8,72235,85,NULL,'I, raw','NGC 7124',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152019,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152019,33.74,0.46,56.1,72235,NULL,NULL,'J','NGC 7124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152020,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152020,33.76,0.32,56.6,72235,85,NULL,'I, inv','NGC 7124',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152021,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152021,33.85,0.45,58.8,72235,NULL,NULL,'K','NGC 7124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152022,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152022,33.85,NULL,58.9,72235,NULL,NULL,'I','NGC 7124',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152023,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152023,33.86,0.47,59.3,72235,NULL,NULL,'H','NGC 7124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152024,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152024,33.94,0.43,61.3,72235,75,NULL,'MAT, I, inv','NGC 7124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152025,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152025,33.97,0.43,62.3,72235,75,NULL,'MAT, I, cor','NGC 7124',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152026,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152026,34.15,0.4,67.5,72235,NULL,NULL,'mean','NGC 7124',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152027,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152027,35.69,0.52,137,72236,70,NULL,NULL,'2MASX J21480647-7626027',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'14.8r',0.18,NULL,NULL,NULL,NULL,NULL,1,327.027125,-76.43417,0.401,NULL,48529680595,758276259,11848066,14.8),(152028,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19068','RN',152028,41.43,0.23,1630,72237,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19068',0.18656,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152029,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19068','RN',152029,42.22,0.31,2340,72237,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19068',0.18656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152030,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152030,37.31,0.46,290,72238,70,NULL,NULL,'2MASX J21481145-0748200',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00014,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,327.0477917,-7.80561,0.085,NULL,49914060830,779907200,12186050,17.7),(152031,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152031,31.99,0.4,25,72239,75,NULL,'B','NGC 7137',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.00001,NULL,'13.05',1.4,'SAB(rs)c',NULL,NULL,NULL,NULL,1,327.054333,22.15958,0.297,NULL,55109101940,861079717,13454370,13.05),(152032,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152032,36.13,0.54,168,72240,70,NULL,NULL,'AM 2144-551 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.27',0.63,'SB(rs)b',NULL,NULL,NULL,NULL,1,327.065875,-54.982,0.009,NULL,48708865365,761076021,11891812,15.27),(152033,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11085','RN',152033,40.35,0.09,915,72241,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 11085',0.282957,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152034,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152034,36.2,0.58,174,72242,70,NULL,NULL,'2MASX J21483072-5703242',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000117,NULL,'14.2r',0.38,'S',NULL,NULL,NULL,NULL,1,327.128,-57.05681,0,NULL,48717273586,761207399,11893865,14.2),(152035,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152035,36.9,0.46,240,72243,70,NULL,NULL,'2MASX J21484103+1145034',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000176,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,327.171083333,11.75086,0.257,NULL,52304972427,817265194,12769768,17.1),(152036,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 10045','R',152036,39.48,0.23,707,72244,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 10045',0.116045,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.195167,1.21144,0.289,NULL,52177696688,815276510,12738695,NULL),(152037,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 10045','R',152037,39.52,0.16,717,72244,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 10045',0.116045,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152038,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 10045',NULL,152038,40.38,0.13,1190,72244,70,NULL,'SN photometric redshift distance, z photo =0.330 +/- 0.026','SDSS-II SN 10045',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152039,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152039,36.88,0.33,237,72245,70,NULL,NULL,'2MASX J21484717-0110155',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000192,NULL,'17.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,327.1964583,-1.17106,0.281,NULL,49811863000,778310359,12161099,17),(152040,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152040,38.48,0.46,496,72246,70,NULL,NULL,'2MASX J21484782-0658059',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000097,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,327.19925,-6.96831,0.069,NULL,49914975612,779921493,12186273,18),(152041,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06683','RN',152041,42.32,0.52,1930,72247,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06683',0.508965,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152042,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06683','N',152042,42.29,0.39,2870,72247,70,NULL,'SALT 2','SDSS-II SN 06683',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152043,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06683','N',152043,42.44,0.39,3080,72247,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06683',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152044,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 04927','RN',152044,43.71,0.21,3680,72248,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04927',0.503608,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152045,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152045,38.32,0.46,461,72249,70,NULL,NULL,'SDSS J214855.39+115618.7',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000152,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,327.230833,11.93856,0.225,NULL,52304198635,817253103,12769579,18.7),(152046,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16582',NULL,152046,40.07,0.29,1030,72250,70,NULL,'SN photometric redshift distance, z photo =0.279 +/- 0.049','SDSS-II SN 16582',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.241083,-0.43389,0.289,NULL,49812360726,778318136,12161220,NULL),(152047,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152047,35.34,0.4,117,72251,NULL,NULL,'mean','NGC 7138',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'15.05',0.5,'SBa','Isolated galaxy',NULL,NULL,NULL,1,327.2545417,12.51422,0.249,NULL,52233974361,816155849,12752435,15.05),(152048,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152048,35.37,0.47,119,72251,NULL,NULL,'H','NGC 7138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152049,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152049,35.4,0.45,120,72251,NULL,NULL,'K','NGC 7138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152050,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152050,35.45,0.46,123,72251,NULL,NULL,'J','NGC 7138',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152051,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152051,35.73,0.2,140,72251,74.4,NULL,NULL,'NGC 7138',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152052,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152052,37.32,0.33,291,72252,70,NULL,NULL,'2MASX J21490358+0111349',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,327.265,1.193,0.269,NULL,52177688256,815276379,12738693,17),(152053,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152053,38.37,0.46,472,72253,70,NULL,NULL,'SDSS J214904.16-071707.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000077,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,327.267375,-7.28528,0.069,NULL,49915607398,779931365,12186427,18.6),(152054,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152054,37.32,0.33,291,72254,70,NULL,NULL,'2MASX J21490711+0111409',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,327.279583,1.19464,0.269,NULL,52177717718,815276839,12738700,18.2),(152055,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152055,33.55,0.05,50.4,72255,70,NULL,NULL,'UGC 11816',0.015786,'2011ApJS..192....1C',2011,1,0.96,NULL,'G',0.000022,NULL,'14.9g',0.92,'SB(rs)c:','Isolated galaxy',NULL,NULL,NULL,1,327.280375,0.44733,0.321,NULL,52177962658,815280666,12738760,14.9),(152056,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152056,33.92,0.01,60.8,72255,72,NULL,NULL,'UGC 11816',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152057,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152057,33.99,0.02,62.8,72255,72,NULL,'M(H) = -18.317 mag','UGC 11816',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152058,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152058,34.03,0.19,62.9,72255,72,NULL,NULL,'UGC 11816',0.015786,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152059,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152059,34,0.1,63.1,72255,74.4,NULL,NULL,'UGC 11816',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152060,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152060,34.06,0.05,63.9,72255,72,NULL,NULL,'UGC 11816',0.015786,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152061,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152061,34.13,0.16,65.1,72255,72,NULL,NULL,'UGC 11816',0.01464,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152062,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152062,34.16,0.17,66.8,72255,73.8,NULL,'SALT 2 (SNANA)','UGC 11816',0.0156,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152063,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2004ey',NULL,152063,34.18,0.2,67.5,72255,70,NULL,'SALT 2','UGC 11816',0.015786,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152064,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152064,35.84,0.59,147,72256,70,NULL,NULL,'2MASX J21490903-5540155',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.6b',0.3,NULL,NULL,NULL,NULL,NULL,1,327.2875,-55.67092,0,NULL,48710188627,761096697,11892135,16.6),(152065,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152065,35.85,0.65,148,72257,70,NULL,NULL,'2MASX J21491476-0937070',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000123,NULL,'16.32',0.35,NULL,NULL,NULL,NULL,NULL,1,327.311541667,-9.61847,0.101,NULL,49900784585,779699759,12182808,16.32),(152066,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01271','RN',152066,42.16,0.2,1750,72258,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01271',0.540634,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152067,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152067,32.92,0.8,38.4,72259,75,NULL,'B','NGC 7125',NULL,'1988NBGC.C....0000T',1988,1,3.1,'Extended HIPASS source','G',0.000003,NULL,'12.8',2.1,'SAB(s)c','Possible pair member',NULL,NULL,NULL,1,327.316583333,-60.71317,0.049,NULL,48680391985,760631124,11884861,12.8),(152068,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152068,33.23,0.4,44.2,72259,NULL,NULL,'mean','NGC 7125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152069,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152069,33.7,0.47,55,72259,NULL,NULL,'H','NGC 7125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152070,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152070,33.73,0.46,55.7,72259,NULL,NULL,'J','NGC 7125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152071,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152071,33.79,0.45,57.3,72259,NULL,NULL,'K','NGC 7125',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152072,'Ring Diameter','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152072,33.2,0.84,43,72260,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7126',NULL,'1981ApJS...45..541P',1981,1,2.8,NULL,'G',0.000007,NULL,'12.87',1.3,'SA:(rs:)bc','Possible pair member',NULL,NULL,NULL,1,327.3255417,-60.60922,0.049,NULL,48680339457,760630304,11884848,12.87),(152073,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152073,32.9,0.8,38,72260,75,NULL,'MAT, I','NGC 7126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152074,'Sosies','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152074,32.86,0.14,37.3,72260,NULL,NULL,NULL,'NGC 7126',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152075,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152075,32.87,0.8,37.5,72260,75,NULL,'B','NGC 7126',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152076,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152076,32.68,0.32,34.4,72260,85,NULL,'I, raw','NGC 7126',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152077,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152077,32.73,0.32,35.1,72260,85,NULL,'I, inv','NGC 7126',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152078,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152078,32.84,0.43,36.9,72260,75,NULL,'MAT, I, raw','NGC 7126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152079,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152079,33,0.43,39.7,72260,75,NULL,'MAT, I, cor','NGC 7126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152080,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152080,33.04,0.43,40.6,72260,75,NULL,'MAT, I, inv','NGC 7126',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152081,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152081,33.18,0.34,43.2,72260,NULL,NULL,NULL,'NGC 7126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152082,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152082,33.21,0.46,43.8,72260,NULL,NULL,'J','NGC 7126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152083,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152083,33.22,0.33,44,72260,NULL,NULL,'Malmquist cor.','NGC 7126',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152084,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152084,33.22,0.2,44.1,72260,74.4,NULL,NULL,'NGC 7126',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152085,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152085,33.23,0.47,44.2,72260,NULL,NULL,'H','NGC 7126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152086,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152086,33.24,0.4,44.4,72260,NULL,NULL,'mean','NGC 7126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152087,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152087,33.26,0.45,44.8,72260,NULL,NULL,'K','NGC 7126',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152088,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152088,36.88,0.33,237,72261,70,NULL,NULL,'2MASX J21491880-0100262',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.5g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,327.328333,-1.00717,0.217,NULL,49812053599,778313337,12161145,16.5),(152089,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 19069',NULL,152089,40.86,0.3,1490,72262,70,NULL,'SN photometric redshift distance, z photo =0.437 +/- 0.088','SDSS-II SN 19069',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.335083,1.05133,0.273,NULL,52177891789,815279559,12738743,NULL),(152090,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152090,37.62,0.33,334,72263,70,NULL,NULL,'SDSS J214924.06-064209.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000086,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,327.35025,-6.70264,0.077,NULL,49915342020,779927219,12186362,18.3),(152091,'GRB','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152091,41.34,NULL,1850,72264,70,NULL,'Pseudo z = 0.59','GRB 030723',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'VisS',NULL,NULL,'>19.5',NULL,'HETE',NULL,NULL,NULL,NULL,1,327.35175,-27.71314,0.045,NULL,51410752798,803293012,12551453,0),(152092,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152092,38.34,0.33,466,72265,70,NULL,NULL,'2MASX J21492482-0812500',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000094,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,327.3534583,-8.21397,0.069,NULL,49914187944,779909186,12186081,18.3),(152093,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 09155','R',152093,41.14,0.23,1300,72266,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J214925.15-004704.0',0.3049,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'21.0g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,327.3547917,-0.78447,0.269,NULL,49811940273,778311566,12161118,21),(152094,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 09155','R',152094,41.31,0.36,1400,72266,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J214925.15-004704.0',0.3049,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152095,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 09155',NULL,152095,41.18,0.22,1720,72266,70,NULL,'SALT 2','SDSS J214925.15-004704.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152096,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 09155',NULL,152096,41.21,0.22,1750,72266,70,NULL,'SALT 2, Malmquist cor.','SDSS J214925.15-004704.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152097,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152097,36.93,0.46,244,72267,70,NULL,NULL,'2MASX J21492564+0107326',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000182,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,327.356875,1.12586,0.253,NULL,52177885389,815279459,12738741,17.5),(152098,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02498','RN',152098,39.86,0.16,795,72268,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02498',0.178769,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152099,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 02498','RN',152099,40.83,0.22,1240,72268,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02498',0.178769,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152100,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152100,38.34,0.33,466,72269,70,NULL,NULL,'2MASX J21492651-0811160',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000084,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,327.360583333,-8.18783,0.069,NULL,49913712732,779901761,12185965,17.5),(152101,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152101,31.17,0.8,17.1,72270,75,NULL,NULL,'UGC 11820',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.000013,NULL,'17.',1.8,'Sm',NULL,NULL,NULL,NULL,1,327.368333,14.23111,0.329,NULL,52244237573,816316212,12754940,17),(152102,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152102,37.88,0.46,377,72271,70,NULL,NULL,'SDSS J214929.40-073508.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000071,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,327.3725,-7.58581,0.065,NULL,49915410844,779928294,12186379,18.6),(152103,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152103,34.16,0.47,67.9,72272,NULL,NULL,'H','UGC 11821',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'14.96',0.3,'Sa',NULL,NULL,NULL,NULL,1,327.398,15.79044,0.305,NULL,52237249502,816207023,12753234,14.96),(152104,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152104,34.21,0.45,69.4,72272,NULL,NULL,'K','UGC 11821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152105,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152105,34.34,0.46,73.9,72272,NULL,NULL,'J','UGC 11821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152106,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152106,34.86,0.49,93.7,72272,75,NULL,'IR','UGC 11821',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152107,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152107,34.99,0.4,99.6,72272,NULL,NULL,'mean','UGC 11821',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152108,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 12869','R',152108,40.61,0.2,1030,72273,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ge','SN 2006ge',0.279533,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,327.399125,0.00106,0.361,NULL,52177442840,815272544,12738633,NULL),(152109,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 12869','R',152109,40.77,0.2,1120,72273,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ge','SN 2006ge',0.279533,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152110,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152110,37.62,0.33,334,72274,70,NULL,NULL,'2MASX J21493804-0641297',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000108,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,327.4085417,-6.6915,0.077,NULL,49915336138,779927127,12186361,16.1),(152111,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152111,36.06,0.75,163,72275,70,NULL,NULL,'AM 2146-565 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'16.43',0.2,'S0',NULL,NULL,NULL,NULL,1,327.412917,-56.68806,0,NULL,48717736702,761214635,11893978,16.43),(152112,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152112,31.4,1.31,19.1,72276,95,NULL,'Weighted Mean','NGC 7135',NULL,'1984ApJS...56...91D',1984,1,3,'Joguet et al. (2001A&A...380...19J) claim \\\"No activity\\\".','G',0.000003,NULL,'12.71',1.9,'SA0- pec       HII','in a pair',NULL,NULL,'AGN',1,327.4417083,-34.87628,0,NULL,51445835188,803841174,12560018,12.71),(152113,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152113,32.71,1.61,34.8,72276,55,NULL,'Visvanathan & Sandage 1979','NGC 7135',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152114,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152114,32.7,0.8,34.7,72276,75,NULL,'B','NGC 7135',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152115,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152115,37.49,0.46,314,72277,70,NULL,NULL,'SDSS J214946.36-072632.9',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000193,NULL,'16.2g',0.35,NULL,NULL,NULL,NULL,NULL,1,327.4432083,-7.44247,0.069,NULL,49915422380,779928474,12186382,16.2),(152116,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152116,34.5,0.49,79.3,72278,75,NULL,'IR','CGCG 493-009',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.70',0.2,'Sc',NULL,NULL,NULL,NULL,1,327.467917,31.61094,0.509,NULL,55628764806,869199450,13581241,15.7),(152117,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152117,35.55,0.57,129,72279,70,NULL,NULL,'2MASX J21495311-5349371',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'14.9r',0.29,NULL,NULL,NULL,NULL,NULL,1,327.471417,-53.82692,0,NULL,50604305064,790692266,12354566,14.9),(152118,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152118,34.88,0.6,94.4,72280,70,NULL,NULL,'2MASX J21495695-5242191',NULL,'2014MNRAS.445.2677S',2014,1,0.67,'Muriel et al. (1995,AJ,110,1032) also give v = 5,022 km/sec.','G',0.000133,NULL,'13.5r',0.55,'E',NULL,NULL,NULL,NULL,1,327.4874583,-52.70525,0,NULL,50659612860,791556450,12368069,13.5),(152119,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152119,36.84,0.58,233,72281,70,NULL,NULL,'2MASX J21495733-0450301',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'17.05',0.33,NULL,NULL,NULL,NULL,NULL,1,327.489,-4.84181,0.057,NULL,49892058558,779563414,12180678,17.05),(152120,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152120,35.99,0.46,158,72282,70,NULL,NULL,'2MASX J21495842+0032427',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000161,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,327.4932917,0.54536,0.297,NULL,52177524490,815273820,12738653,16.6),(152121,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01958','R',152121,40.43,0.41,889,72283,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 01958',0.3698,'2014arXiv1401.3317S',2014,1,NULL,NULL,'*',NULL,'PHOT','22.9g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.504583,0.87389,0.273,NULL,52177804163,815278190,12738721,22.9),(152122,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01958','R',152122,40.59,0.39,957,72283,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 01958',0.3698,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152123,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01958',NULL,152123,40.67,0.62,1360,72283,70,NULL,'SN photometric redshift distance, z photo =0.390 +/- 0.181','SDSS-II SN 01958',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152124,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152124,37.43,0.46,307,72284,70,NULL,NULL,'2MASXi J2150024+124605',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,327.51025,12.76814,0.269,NULL,52234637756,816166214,12752597,18.2),(152125,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152125,37.16,0.46,271,72285,70,NULL,NULL,'2MASX J21500448+0026338',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000188,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,327.518708333,0.44258,0.297,NULL,52177518356,815273724,12738651,17),(152126,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152126,36.59,0.46,208,72286,70,NULL,NULL,'2MASX J21500501+0023578',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000176,NULL,'16.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,327.521,0.39928,0.297,NULL,52177504386,815273506,12738648,16.6),(152127,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152127,37.41,0.62,303,72287,70,NULL,NULL,'2MASX J21500534-6134039',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'15.2r',0.36,NULL,NULL,NULL,NULL,NULL,1,327.522166667,-61.56783,0.025,NULL,49158500229,768101566,12001586,15.2),(152128,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16301',NULL,152128,39.38,0.75,752,72288,70,NULL,'SN photometric redshift distance, z photo =0.194 +/- 0.094','SDSS-II SN 16301',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.528583,1.03331,0.253,NULL,52180653552,815322711,12739417,NULL),(152129,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152129,34.92,0.49,96.5,72289,75,NULL,'IR','UGC 11824',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.3,'SBcd?',NULL,NULL,NULL,NULL,1,327.5435,30.8235,0.541,NULL,55629013279,869203332,13581302,16),(152130,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152130,38.12,0.46,421,72290,70,NULL,NULL,'2MASX J21501212-0659310',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00008,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,327.550625,-6.99192,0.077,NULL,49914928491,779920757,12186261,17.6),(152131,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152131,36.83,0.46,232,72291,70,NULL,NULL,'2MASX J21501308+0036018',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,327.554583,0.60056,0.297,NULL,52180947566,815327305,12739489,17.3),(152132,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152132,37.92,0.33,383,72292,70,NULL,NULL,'2MASX J21501406-0709020',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000086,NULL,'16.8g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,327.5585417,-7.15053,0.069,NULL,49915078696,779923104,12186298,16.8),(152133,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152133,35.98,0.59,157,72293,70,NULL,NULL,'2MASX J21501521-1449522',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.41',0.19,NULL,NULL,NULL,NULL,NULL,1,327.563458333,-14.83117,0.109,NULL,49777456136,777772752,12152699,16.41),(152134,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152134,36.74,0.46,223,72294,70,NULL,NULL,'2MASX J21501682-0703140',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00007,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,327.570083,-7.05392,0.069,NULL,49915089105,779923267,12186301,17.3),(152135,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152135,36.32,0.57,184,72295,70,NULL,NULL,'FAIRALL 0118',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14.8r',0.53,'S0',NULL,NULL,NULL,NULL,1,327.575375,-59.90447,0.041,NULL,48682399430,760662491,11885351,14.8),(152136,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152136,38.18,0.46,433,72296,70,NULL,NULL,'2MASX J21501901-0050541',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,327.579333333,-0.84836,0.257,NULL,49815357580,778364962,12161952,18.6),(152137,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152137,34.87,0.56,94.1,72297,70,NULL,NULL,'2MASX J21502061-0404110',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.39',0.36,NULL,NULL,NULL,NULL,NULL,1,327.5859583,-4.06967,0.081,NULL,49895291894,779613935,12181467,16.39),(152138,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152138,37.92,0.33,383,72298,70,NULL,NULL,'SDSS J215020.80-070455.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000081,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,327.586667,-7.08214,0.069,NULL,49915073308,779923020,12186297,18.2),(152139,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152139,37.47,0.46,312,72299,70,NULL,NULL,'2MASX J21502206-0018370',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,327.5919583,-0.31025,0.325,NULL,49812113069,778314266,12161160,17.2),(152140,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152140,35.41,0.53,121,72300,70,NULL,NULL,'2MASX J21502221-0550590',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.39',0.27,NULL,NULL,NULL,NULL,NULL,1,327.5924583,-5.84964,0.021,NULL,49884144173,779439752,12178746,17.39),(152141,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152141,35.02,0.8,101,72301,75,NULL,'MAT, I','IC 5130',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.49',0.6,'SA(s)bc:',NULL,NULL,NULL,NULL,1,327.601125,-73.99742,0.173,NULL,48416358367,756505599,11820399,14.49),(152142,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152142,34.7,0.43,87,72301,75,NULL,'MAT, I, raw','IC 5130',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152143,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152143,34.8,0.32,91.2,72301,85,NULL,'I, raw','IC 5130',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152144,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152144,34.87,0.32,94.2,72301,85,NULL,'I, inv','IC 5130',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152145,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152145,34.99,0.43,99.7,72301,75,NULL,'MAT, I, inv','IC 5130',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152146,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152146,35.06,0.47,103,72301,NULL,NULL,'H','IC 5130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152147,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152147,35.1,0.43,105,72301,75,NULL,'MAT, I, cor','IC 5130',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152148,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152148,35.15,0.46,107,72301,NULL,NULL,'J','IC 5130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152149,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152149,35.16,0.45,108,72301,NULL,NULL,'K','IC 5130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152150,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152150,35.16,0.4,108,72301,NULL,NULL,'mean','IC 5130',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152151,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152151,35.18,0.43,109,72301,NULL,NULL,'Malmquist cor.','IC 5130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152152,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152152,35.21,0.42,110,72301,NULL,NULL,NULL,'IC 5130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152153,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152153,35.25,0.2,112,72301,74.4,NULL,NULL,'IC 5130',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152154,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152154,33.97,0.45,62.1,72302,NULL,NULL,'K','IC 5139',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000083,NULL,'13.69',1,'SB0-?          HII','Pair member (points to parent)',NULL,NULL,NULL,1,327.606917,-30.99472,0,NULL,51464097321,804126520,12564476,13.69),(152155,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152155,34.24,0.4,70.4,72302,NULL,NULL,'mean','IC 5139',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152156,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11363','RN',152156,38.53,0.21,434,72303,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11363',0.172747,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152157,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 11363','RN',152157,38.68,0.07,464,72303,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11363',0.172747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152158,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152158,34.93,0.46,96.7,72304,70,NULL,NULL,'2MASX J21502753+1238103',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000165,NULL,'16.5g',0.19,'S0/a',NULL,NULL,NULL,NULL,1,327.614833,12.63628,0.317,NULL,52234806837,816168856,12752638,16.5),(152159,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152159,36.61,0.2,210,72305,74.4,NULL,NULL,'UGC 11825',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000067,NULL,'15.2g',0.46,'Sa?            AGN',NULL,NULL,NULL,NULL,1,327.676417,0.91197,0.253,NULL,52181127571,815330118,12739533,15.2),(152160,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152160,37.18,0.46,273,72306,70,NULL,NULL,'2MASX J21504335-0724275',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,327.680583,-7.40764,0.069,NULL,49914863729,779919745,12186246,16.2),(152161,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152161,35.68,0.66,137,72307,70,NULL,NULL,'ESO 145- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00011,NULL,'14.3r',0.3,'Sb- c',NULL,NULL,NULL,NULL,1,327.695667,-61.76414,0.029,NULL,49159289953,768113905,12001779,14.3),(152162,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152162,36.22,0.64,175,72308,70,NULL,NULL,'2MASX J21505563-0251491',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.69',0.36,NULL,NULL,NULL,NULL,NULL,1,327.7317917,-2.86364,0.137,NULL,49881623985,779400374,12178130,16.69),(152163,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152163,34.05,0.47,64.6,72309,70,NULL,NULL,'IC 1404',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000067,NULL,'14.55',1,NULL,NULL,NULL,NULL,NULL,1,327.734917,-9.26658,0.101,NULL,49918737502,779980273,12187191,14.55),(152164,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 07736',NULL,152164,38.91,1.42,606,72310,70,NULL,'SN photometric redshift distance, z photo =0.153 +/- 0.168','SDSS-II SN 07736',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.7527917,0.11806,0.333,NULL,52178724710,815292573,12738946,NULL),(152165,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152165,34.99,0.47,99.6,72311,70,NULL,NULL,'MC 2147-465',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'15.26',1.2,'(R\')SA(s)0^0^: pec',NULL,NULL,NULL,NULL,1,327.777875,-46.27531,0,NULL,50644301294,791317207,12364331,15.26),(152166,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152166,37.36,0.46,297,72312,70,NULL,NULL,'SDSS J215107.77+104739.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.19,'AGN',NULL,NULL,NULL,NULL,1,327.782375,10.79422,0.233,NULL,52307048214,817297628,12770275,17.6),(152167,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152167,40.31,0.14,880,72313,74.2,NULL,'SALT 2','SDSS J215108.63-005033.1',0.31,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,327.785958333,-0.84253,0.273,NULL,49815531721,778367683,12161995,NULL),(152168,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152168,40.45,0.05,938,72313,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05844, SN 2005ic','SDSS J215108.63-005033.1',0.31,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152169,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152169,40.22,0.1,1110,72313,70,NULL,'Hubble residual -0.05 for z0.31080','SDSS J215108.63-005033.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152170,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152170,40.95,0.12,1180,72313,65,NULL,'SALT2','SDSS J215108.63-005033.1',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152171,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152171,41.01,0.15,1220,72313,70,NULL,'SALT 2','SDSS J215108.63-005033.1',0.31,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152172,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 05844','R',152172,41.09,0.22,1260,72313,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ic','SDSS J215108.63-005033.1',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152173,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152173,41.11,NULL,1270,72313,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05844, SN 2005ic','SDSS J215108.63-005033.1',0.31,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152174,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005ic',NULL,152174,41.15,0.1,1290,72313,65,NULL,'MLCS2k2','SDSS J215108.63-005033.1',0.31,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152175,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 05844','R',152175,41.29,0.12,1380,72313,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ic','SDSS J215108.63-005033.1',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152176,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01670','RN',152176,43.13,0.2,2930,72314,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01670',0.442036,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152177,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 01670','RN',152177,43.44,0.27,3390,72314,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01670',0.442036,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152178,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152178,37.28,0.57,286,72315,70,NULL,NULL,'2MASX J21511190-5726363',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'14.9r',0.33,'S0',NULL,NULL,NULL,NULL,1,327.799583,-57.44344,0,NULL,48717108038,761204813,11893825,14.9),(152179,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152179,37.71,0.27,349,72316,70,NULL,NULL,'2MASX J21511398-0711088',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000079,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,327.8082083,-7.18575,0.061,NULL,49926273296,780098020,12189031,16.9),(152180,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152180,36.55,0.6,204,72317,70,NULL,NULL,'2MASX J21512031-5519284',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.3r',0.19,NULL,NULL,NULL,NULL,NULL,1,327.83475,-55.32453,0,NULL,48712305118,761129767,11892652,15.3),(152181,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152181,35.3,0.51,115,72318,70,NULL,NULL,'ARK 554',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.000113,NULL,'15.1',0.25,NULL,NULL,NULL,NULL,NULL,1,327.834875,-1.64939,0.293,NULL,49813350148,778333596,12161462,15.1),(152182,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152182,37.71,0.27,349,72319,70,NULL,NULL,'2MASX J21512069-0713268',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,327.836125,-7.22406,0.061,NULL,49926265261,780097894,12189029,17.7),(152183,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152183,38.03,0.46,403,72320,70,NULL,NULL,'2MASX J21512202-0915018',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000082,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,327.841667,-9.25039,0.121,NULL,49918662070,779979094,12187173,18.3),(152184,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152184,36.85,0.74,235,72321,70,NULL,NULL,'2MASX J21512300-5425214',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.1r',0.32,'S',NULL,NULL,NULL,NULL,1,327.845958333,-54.42264,0,NULL,48708687767,761073246,11891769,15.1),(152185,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152185,37.07,0.46,260,72322,70,NULL,NULL,'2MASX J21512369+1100589',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000132,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,327.848667,11.01631,0.269,NULL,52307083580,817298180,12770284,17.7),(152186,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15454','R',152186,41.45,0.21,1410,72323,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J215126.08-005057.0',0.3829,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0001,NULL,'21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,327.858667,-0.84917,0.273,NULL,49815532559,778367696,12161995,21.4),(152187,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15454','R',152187,41.73,0.29,1610,72323,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J215126.08-005057.0',0.3829,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152188,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15454',NULL,152188,41.61,0.18,2100,72323,70,NULL,'SALT 2','SDSS J215126.08-005057.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152189,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 15454',NULL,152189,41.67,0.18,2160,72323,70,NULL,'SALT 2, Malmquist cor.','SDSS J215126.08-005057.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152190,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152190,34.68,0.49,86.3,72324,75,NULL,'IR','UGC 11833',NULL,'2011yCatp016004901K',2011,1,1.01,NULL,'G',0.00003,NULL,'17.',0.11,'Sc',NULL,NULL,NULL,NULL,1,327.859416667,34.13233,0.701,NULL,55592697703,868635901,13572435,17),(152191,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152191,35.08,0.43,104,72324,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11833',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152192,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152192,35.48,NULL,125,72324,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11833',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152193,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152193,35.48,NULL,125,72324,NULL,NULL,'Dipole + Quadrupole','UGC 11833',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152194,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152194,35.49,NULL,125,72324,NULL,NULL,'Dipole','UGC 11833',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152195,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16889','RN',152195,40.39,0.3,952,72325,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16889',0.255983,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152196,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16889','RN',152196,40.71,0.29,1100,72325,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16889',0.255983,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152197,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152197,37.64,0.46,337,72326,70,NULL,NULL,'2MASX J21512805+0000392',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,327.866791667,0.01106,0.333,NULL,52178739659,815292807,12738950,17.8),(152198,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152198,34.85,0.2,93.3,72327,74.4,NULL,NULL,'CGCG 472-012',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'15.7',0.3,'Sc',NULL,NULL,NULL,NULL,1,327.874167,22.84483,0.197,NULL,55112397197,861131206,13455175,15.7),(152199,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152199,35.01,0.7,100,72327,NULL,NULL,NULL,'CGCG 472-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152200,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152200,35.11,0.67,105,72327,NULL,NULL,'Malmquist cor.','CGCG 472-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152201,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13721','RN',152201,39.31,0.37,566,72328,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13721',0.282295,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152202,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13721','RN',152202,40.06,0.41,801,72328,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13721',0.282295,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152203,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06685','RN',152203,42.39,0.27,2250,72329,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06685',0.33969,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152204,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06685','RN',152204,42.87,0.29,2800,72329,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06685',0.33969,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152205,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 16937',NULL,152205,39.87,0.44,943,72330,70,NULL,'SN photometric redshift distance, z photo =0.251 +/- 0.067','SDSS-II SN 16937',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,327.88175,-0.46581,0.333,NULL,49815191099,778362360,12161911,NULL),(152206,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152206,36.89,0.46,239,72331,70,NULL,NULL,'2MASX J21513303+0039025',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000195,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,327.887666667,0.65083,0.265,NULL,52181017617,815328400,12739506,16.3),(152207,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152207,37.71,0.27,349,72332,70,NULL,NULL,'2MASX J21513336-0708416',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000093,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,327.889083333,-7.14511,0.053,NULL,49926292986,780098327,12189036,17.2),(152208,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152208,35.46,0.37,124,72333,NULL,NULL,NULL,'CGCG 472-013',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',NULL,NULL,'15.67',0.2,'S?',NULL,NULL,NULL,NULL,1,327.895667,22.65181,0.197,NULL,55112466506,861132289,13455192,15.67),(152209,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152209,35.5,0.2,126,72333,74.4,NULL,NULL,'CGCG 472-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152210,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152210,35.52,0.36,127,72333,NULL,NULL,'Malmquist cor.','CGCG 472-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152211,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152211,36.73,0.23,221,72334,70,NULL,NULL,'2MASX J21513605-0707216',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000092,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,327.900333333,-7.12267,0.053,NULL,49926305874,780098529,12189039,16.6),(152212,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152212,36.93,0.55,243,72335,70,NULL,NULL,'2MASX J21513744-7144270',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'15.0r',0.31,NULL,NULL,NULL,NULL,NULL,1,327.90625,-71.74094,0.045,NULL,49308198401,770440600,12038134,15),(152213,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152213,37.2,0.46,276,72336,70,NULL,NULL,'2MASX J21514042-0708036',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000078,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,327.9184583,-7.13442,0.053,NULL,49926297603,780098400,12189037,16.7),(152214,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152214,33.86,0.49,59.1,72337,75,NULL,'IR','UGC 11836',NULL,'2011yCatp016004901K',2011,1,1.4,'Within 10 degrees of the galactic plane.','G',0.00004,NULL,'17.',0.3,'Sdm:',NULL,NULL,NULL,NULL,1,327.9225,46.61917,NULL,NULL,55387026862,865422294,13522223,17),(152215,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152215,36.73,0.23,221,72338,70,NULL,NULL,'2MASX J21514398-0703426',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000071,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,327.933375,-7.06181,0.053,NULL,49926295681,780098370,12189037,17.1),(152216,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152216,35.06,NULL,103,72339,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11832',NULL,'2010Ap&SS.325..163P',2010,1,1.67,NULL,'G',0.000009,NULL,'16.0g',0.17,'Sc',NULL,NULL,NULL,NULL,1,327.934,11.57542,0.273,NULL,52306730802,817292668,12770197,16),(152217,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152217,35.07,NULL,103,72339,NULL,NULL,'Dipole + Quadrupole','UGC 11832',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152218,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152218,35.08,NULL,104,72339,NULL,NULL,'Dipole','UGC 11832',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152219,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152219,35.11,NULL,105,72339,NULL,NULL,NULL,'UGC 11832',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152220,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152220,35.2,0.49,109,72339,75,NULL,'IR','UGC 11832',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152221,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152221,35.39,0.2,120,72339,74.4,NULL,NULL,'UGC 11832',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152222,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152222,36.73,0.23,221,72340,70,NULL,NULL,'2MASX J21514505-0700106',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000092,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,327.9377083,-7.00297,0.053,NULL,49926771143,780105799,12189153,16.9),(152223,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 21691','RN',152223,42.73,0.43,2660,72341,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21691',0.317092,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152224,'BCG','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152224,37.9,0.35,357,72342,60,NULL,NULL,'ABELL 2382',0.0648,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,327.970417,-15.71722,0.125,NULL,49768720124,777636251,12150566,NULL),(152225,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152225,35.38,0.52,119,72343,70,NULL,NULL,'MC 2149-276',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.45',0.65,'S0',NULL,NULL,NULL,NULL,1,327.971333,-27.42164,0.073,NULL,51418594860,803415544,12553367,15.45),(152226,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152226,37.32,0.6,292,72344,70,NULL,NULL,'2MASX J21515458-5507196',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.5b',0.23,NULL,NULL,NULL,NULL,NULL,1,327.97725,-55.12219,0,NULL,48708839570,761075618,11891806,16.5),(152227,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13424','RN',152227,40.35,0.08,958,72345,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13424',0.22442,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152228,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 13424','RN',152228,40.46,0.18,1010,72345,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13424',0.22442,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152229,'BCG','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152229,37.9,0.35,357,72346,60,NULL,'ABELL 2382, BCG','2MASX J21515562-1542218',0.0648,'1980ApJ...241..486H',1980,1,0.64,NULL,'G',0.000053,NULL,'14.5V',0.36,'E              BrClG','Brightest group member',NULL,NULL,NULL,1,327.981833,-15.70583,0.125,NULL,49766832470,777606757,12150105,14.5),(152230,'SGRB','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152230,38.73,NULL,557,72347,71,NULL,NULL,'GRB 070429B',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,328.015875,-38.82833,0,NULL,50550139171,789845924,12341342,NULL),(152231,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152231,41.31,1.65,1830,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2013ApJ...770..154T',2013,1,NULL,'This galaxy group lenses a z=2 QSO group.','GGroup',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.020833,-27.52667,0.073,NULL,51418872815,803419887,12553435,NULL),(152232,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152232,41.41,0.38,1910,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2007ApJ...660....1O',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152233,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152233,41.4,NULL,1910,72348,NULL,NULL,'R(H) = ct','HE 2149-2745:MWKZ GROUP 4',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152234,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152234,41.4,NULL,1910,72348,NULL,NULL,'Standard','HE 2149-2745:MWKZ GROUP 4',NULL,'2014ApJ...788..190W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152235,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152235,41.79,1.66,2290,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152236,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152236,41.8,1.66,2290,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152237,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152237,42.21,1.64,2760,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2013ApJ...770..154T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152238,'G Lens','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152238,43.19,0.79,4350,72348,NULL,NULL,NULL,'HE 2149-2745:MWKZ GROUP 4',NULL,'2014MNRAS.437..600S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152239,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152239,36.45,0.63,195,72349,70,NULL,NULL,'2MASX J21520752-8015508',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,328.031125,-80.26411,0.477,NULL,48564652878,758822701,11856604,17.7),(152240,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152240,38.42,0.46,483,72350,70,NULL,NULL,'2MASX J21520925+1110151',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000147,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,328.0385417,11.17092,0.253,NULL,52307122295,817298785,12770293,18.3),(152241,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152241,35.26,0.68,112,72351,NULL,NULL,NULL,'ESO 404- G 001',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.80',0.7,'Sc             HII',NULL,NULL,NULL,NULL,1,328.0492083,-36.84053,0,NULL,50552776353,789887130,12341986,14.8),(152242,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152242,35.25,0.68,112,72351,NULL,NULL,'Malmquist cor.','ESO 404- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152243,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152243,35.3,0.2,115,72351,74.4,NULL,NULL,'ESO 404- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152244,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152244,35.95,0.74,155,72352,70,NULL,NULL,'2MASX J21521256-0136031',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'17.15',0.3,NULL,NULL,NULL,NULL,NULL,1,328.05225,-1.60069,0.325,NULL,49813272264,778332379,12161443,17.15),(152245,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152245,33.59,0.69,52.2,72353,100,NULL,'mid-IR','UGC 11837',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000033,NULL,'16.0',0.9,'Sd',NULL,NULL,NULL,NULL,1,328.055625,36.09894,1.041,NULL,55585077008,868516828,13570575,16),(152246,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152246,34.4,0.4,75.9,72353,NULL,NULL,'mean','UGC 11837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152247,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152247,34.47,0.47,78.5,72353,NULL,NULL,'H','UGC 11837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152248,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152248,34.52,0.2,80.2,72353,74.4,NULL,NULL,'UGC 11837',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152249,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152249,34.54,0.44,80.8,72353,NULL,NULL,'Malmquist cor.','UGC 11837',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152250,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152250,34.58,0.43,82.5,72353,NULL,NULL,NULL,'UGC 11837',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152251,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152251,34.64,0.46,84.9,72353,NULL,NULL,'J','UGC 11837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152252,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152252,34.67,0.45,86,72353,NULL,NULL,'K','UGC 11837',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152253,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152253,37.45,0.46,309,72354,70,NULL,NULL,'2MASX J21521368-0657228',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,328.056917,-6.95631,0.057,NULL,49926816979,780106515,12189164,17.3),(152254,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152254,36.88,0.46,238,72355,70,NULL,NULL,'2MASX J21521385-0752368',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.0001,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,328.0577083,-7.87694,0.077,NULL,49928206928,780128233,12189503,16.5),(152255,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152255,35.25,0.49,112,72356,75,NULL,'IR','CGCG 402-024 NED02',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.00009,NULL,'12.1K',0.3,NULL,NULL,NULL,NULL,NULL,1,328.063,8.39861,0.121,NULL,52342563699,817852557,12778946,12.1),(152256,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152256,32.87,0.8,37.4,72357,75,NULL,NULL,'NGC 7140',NULL,'1988NBGC.C....0000T',1988,1,4.2,NULL,'G',0.00001,NULL,'12.4b',3,'(R\'_2)SB(rs)b',NULL,NULL,NULL,NULL,1,328.0637917,-55.56967,0,NULL,48712497876,761132779,11892699,12.4),(152257,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152257,32.06,0.43,25.8,72357,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7140',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152258,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152258,32.19,0.43,27.5,72357,75,NULL,'3.6 micron, color corrected','NGC 7140',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152259,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152259,32.37,0.2,29.8,72357,74.4,NULL,NULL,'NGC 7140',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152260,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,NULL,152260,35.45,0.49,123,72358,70,NULL,NULL,'2MFGC 16503',NULL,'2014MNRAS.445.2677S',2014,1,0.72,'6dF DR2 has z = 0.051128.','G',0.00015,NULL,'14.7r',0.17,'S',NULL,NULL,NULL,NULL,1,328.064583,-44.05536,0,NULL,50647876282,791373066,12365204,14.7),(152261,'FP','2016-12-15 15:15:56','2016-12-16 11:21:11','1',NULL,'R',152261,36.45,0.46,195,72359,70,NULL,NULL,'2MASX J21521551+1120511',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000154,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,328.06475,11.34747,0.309,NULL,52306932451,817295819,12770247,17.6),(152262,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005iz',NULL,152262,39.15,0.13,563,72360,74.2,NULL,'SALT 2','SDSS J215216.94+001600.4',0.2,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'23.8g',0.01,NULL,NULL,NULL,NULL,NULL,1,328.070625,0.26681,0.281,NULL,52178974490,815296476,12739007,23.8),(152263,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SN 2005iz',NULL,152263,39.79,0.16,756,72360,65,NULL,'SALT2','SDSS J215216.94+001600.4',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152264,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:11','1','SDSS-II SN 06780','R',152264,39.81,0.2,763,72360,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iz','SDSS J215216.94+001600.4',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152265,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152265,39.85,0.14,777,72360,70,NULL,'SALT 2','SDSS J215216.94+001600.4',0.2,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152266,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152266,39.86,NULL,780,72360,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06780, SN 2005iz','SDSS J215216.94+001600.4',0.2,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152267,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152267,39.63,0.1,843,72360,70,NULL,'SALT 2','SDSS J215216.94+001600.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152268,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152268,39.64,0.1,847,72360,70,NULL,'SALT 2, Malmquist cor.','SDSS J215216.94+001600.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152269,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152269,40.1,0.12,872,72360,65,NULL,'MLCS2k2','SDSS J215216.94+001600.4',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152270,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 06780','R',152270,40.13,0.12,883,72360,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iz','SDSS J215216.94+001600.4',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152271,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005iz',NULL,152271,40.44,0.06,1020,72360,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06780, SN 2005iz','SDSS J215216.94+001600.4',0.2,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152272,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152272,37.26,0.55,283,72361,70,NULL,NULL,'2MASX J21521727-6201483',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'15.6r',0.17,NULL,NULL,NULL,NULL,NULL,1,328.071916667,-62.03011,0.029,NULL,49159105610,768111025,12001734,15.6),(152273,'BCG','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152273,38.58,0.35,475,72362,60,NULL,NULL,'ABELL 2384',0.0943,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II-III [BM]',NULL,NULL,NULL,NULL,1,328.0789583,-19.57844,0.061,NULL,50873182682,794893479,12420210,NULL),(152274,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152274,39.27,0.13,595,72363,74.2,NULL,'SALT 2','SDSS J215219.03+002818.6',0.2,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'21.8g',0.03,NULL,NULL,NULL,NULL,NULL,1,328.079333333,0.47183,0.265,NULL,52178874755,815294918,12738983,21.8),(152275,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152275,39.89,0.05,794,72363,70,NULL,'SDSS 7243','SDSS J215219.03+002818.6',0.2,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152276,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152276,40.03,0.11,845,72363,65,NULL,'SALT2','SDSS J215219.03+002818.6',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152277,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152277,40.04,0.15,847,72363,70,NULL,'SDSS 7243, SALT 2','SDSS J215219.03+002818.6',0.2,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152278,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 07243','R',152278,40.05,0.2,852,72363,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jm','SDSS J215219.03+002818.6',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152279,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 07243','R',152279,40.12,0.13,879,72363,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jm','SDSS J215219.03+002818.6',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152280,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152280,40.15,0.17,892,72363,72,NULL,'SDSS 7243','SDSS J215219.03+002818.6',0.2,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152281,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152281,40.18,0.12,905,72363,65,NULL,'MLCS2k2','SDSS J215219.03+002818.6',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152282,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152282,39.98,0.1,991,72363,70,NULL,'SALT 2','SDSS J215219.03+002818.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152283,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2005jm',NULL,152283,39.99,0.1,995,72363,70,NULL,'SALT 2, Malmquist cor.','SDSS J215219.03+002818.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152284,'BCG','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152284,38.58,0.35,475,72364,60,NULL,'ABELL 2384, BCG','2MASX J21522195-1932484',0.0943,'1980ApJ...241..486H',1980,1,1.25,NULL,'G',NULL,NULL,'0.74',0.82,'BrClG','Brightest group member',NULL,NULL,NULL,1,328.0914583,-19.54683,0.061,NULL,50873182826,794893481,12420210,0.74),(152285,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152285,35.92,0.57,153,72365,70,NULL,NULL,'2MFGC 16505',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'14.5r',0.23,'S',NULL,NULL,NULL,NULL,1,328.0914583,-52.41444,0,NULL,50659182945,791549733,12367964,14.5),(152286,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05790','RN',152286,40.08,0.11,842,72366,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05790',0.231994,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152287,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05790','RN',152287,40.71,0.19,1120,72366,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05790',0.231994,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152288,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152288,37.79,0.46,362,72367,70,NULL,NULL,'SDSS J215224.79-073728.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000077,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,328.103333,-7.62461,0.065,NULL,49928107051,780126672,12189479,18.1),(152289,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 07953','RN',152289,42.67,0.26,2030,72368,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07953',0.681936,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152290,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152290,32.52,0.8,32,72369,75,NULL,'MAT, I','NGC 7095',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.00001,NULL,'12.23',2.7,'SB(s)c','in a pair',NULL,NULL,NULL,1,328.110167,-81.53083,0.445,NULL,48565366360,758833849,11856778,12.23),(152291,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152291,32.48,0.8,31.3,72369,75,NULL,NULL,'NGC 7095',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152292,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152292,29.23,0.32,7.03,72369,85,NULL,'I, inv','NGC 7095',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152293,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152293,29.29,0.32,7.16,72369,85,NULL,'I, raw','NGC 7095',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152294,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152294,29.73,0.43,8.83,72369,75,NULL,'MAT, I, inv','NGC 7095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152295,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152295,29.8,0.43,9.11,72369,75,NULL,'MAT, I, raw','NGC 7095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152296,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152296,30.06,0.43,10.3,72369,75,NULL,'MAT, I, cor','NGC 7095',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152297,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152297,38.34,0.46,466,72370,70,NULL,NULL,'2MASX J21522804+0029386',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,328.11675,0.49408,0.265,NULL,52178904140,815295377,12738990,17.8),(152298,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152298,35.16,0.46,108,72371,70,NULL,NULL,'MCG +02-55-019',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000073,NULL,'15.2g',0.55,'S0',NULL,NULL,NULL,NULL,1,328.122125,12.41139,0.317,NULL,52234055103,816157110,12752454,15.2),(152299,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152299,36.58,0.46,207,72372,70,NULL,NULL,'2MASX J21523208+0009586',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000174,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,328.133541667,0.16642,0.289,NULL,52178948224,815296066,12739001,16.5),(152300,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802',NULL,152300,40.02,0.44,1010,72373,70,NULL,'SN photometric redshift distance, z photo =0.271 +/- 0.074','SDSS-II SN 05802',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,328.145,0.84567,0.213,NULL,52181152583,815330509,12739539,NULL),(152301,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802','R',152301,40.8,0.21,1110,72373,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05802',0.300656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152302,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802','R',152302,40.9,0.12,1160,72373,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05802',0.300656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152303,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802',NULL,152303,40.7,0.11,1380,72373,70,NULL,'SALT 2','SDSS-II SN 05802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152304,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 05802',NULL,152304,40.73,0.11,1400,72373,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152305,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152305,33.25,0.8,44.7,72374,75,NULL,'W91PP, r','UGC 11838',NULL,'1997ApJS..109..333W',1997,1,2.08,NULL,'G',0.000009,NULL,'15.27',0.17,'Sd',NULL,NULL,NULL,NULL,1,328.149333,28.30658,0.337,NULL,55578869279,868419832,13569059,15.27),(152306,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152306,33.1,0.49,41.7,72374,75,NULL,'IR','UGC 11838',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152307,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152307,33.35,0.38,46.8,72374,75,NULL,'W91PP, r, inv','UGC 11838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152308,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152308,33.36,0.38,47.1,72374,75,NULL,'W91PP, r, raw','UGC 11838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152309,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152309,33.41,0.2,48.1,72374,74.4,NULL,NULL,'UGC 11838',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152310,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152310,33.42,NULL,48.3,72374,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152311,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152311,33.43,NULL,48.5,72374,NULL,NULL,'Dipole','UGC 11838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152312,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152312,33.43,NULL,48.5,72374,NULL,NULL,'Dipole + Quadrupole','UGC 11838',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152313,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152313,33.49,0.56,50,72374,NULL,NULL,NULL,'UGC 11838',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152314,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152314,33.5,NULL,50.1,72374,NULL,NULL,NULL,'UGC 11838',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152315,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152315,33.56,0.43,51.6,72374,75,NULL,'3.6 micron, color corrected','UGC 11838',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152316,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152316,33.62,0.38,52.9,72374,75,NULL,'W91PP, r, cor','UGC 11838',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152317,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152317,33.64,0.43,53.5,72374,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11838',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152318,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152318,33.65,0.52,53.8,72374,NULL,NULL,'Malmquist cor.','UGC 11838',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152319,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152319,34.91,0.43,96.1,72375,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11839',NULL,'2014MNRAS.444..527S',2014,1,0.9,NULL,'G',0.00013,NULL,'15.5',0.1,'Sbc',NULL,NULL,NULL,NULL,1,328.168917,36.46072,1.041,NULL,55466673366,866666771,13541668,15.5),(152320,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152320,34.97,0.43,98.7,72375,75,NULL,'3.6 micron, color corrected','UGC 11839',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152321,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152321,35.07,0.2,103,72375,74.4,NULL,NULL,'UGC 11839',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152322,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152322,31.94,0.14,24.4,72376,74.4,NULL,NULL,'NGC 7144',NULL,'2013AJ....146...86T',2013,1,3.7,NULL,'G',0.000057,NULL,'11.70',3.6,'E0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,328.1767917,-48.25375,0,NULL,50665652013,791650812,12369543,11.7),(152323,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152323,31.95,0.12,24.5,72376,NULL,NULL,'I','NGC 7144',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152324,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152324,31.95,0.12,24.5,72376,NULL,NULL,NULL,'NGC 7144',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152325,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152325,31.97,0.12,24.7,72376,NULL,NULL,'Malmquist cor.','NGC 7144',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152326,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152326,31.63,0.4,21.2,72376,75,NULL,'Edat, raw','NGC 7144',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152327,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152327,31.85,0.4,23.5,72376,75,NULL,'Edat, cor','NGC 7144',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152328,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152328,31.95,0.37,24.5,72376,95,NULL,'Weighted Mean','NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152329,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152329,32.07,0.81,25.9,72376,55,NULL,'Visvanathan & Sandage 1979','NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152330,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152330,32.62,0.46,33.4,72376,95,NULL,'Michard 1979a','NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152331,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152331,33.12,0.63,42.1,72376,95,NULL,'Michard 1979b, c','NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152332,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152332,32.14,0.41,26.8,72376,NULL,NULL,NULL,'NGC 7144',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152333,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152333,32.36,0.41,29.7,72376,NULL,NULL,'Malmquist cor.','NGC 7144',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152334,'Tertiary','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152334,31.55,0.71,20.4,72376,95,NULL,NULL,'NGC 7144',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152335,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152335,31.98,0.8,24.8,72376,75,NULL,'B','NGC 7144',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152336,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152336,32.1,0.4,26.3,72376,NULL,NULL,'mean','NGC 7144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152337,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152337,32.28,0.45,28.6,72376,NULL,NULL,'K','NGC 7144',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152338,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152338,35.59,NULL,131,72377,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2349',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000016,NULL,'16.8',0.1,'Sd',NULL,NULL,NULL,NULL,1,328.1877083,3.54419,0.237,NULL,52326996764,817609324,12775145,16.8),(152339,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152339,35.6,NULL,132,72377,NULL,NULL,'Dipole','FGC 2349',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152340,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152340,35.6,NULL,132,72377,NULL,NULL,'Dipole + Quadrupole','FGC 2349',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152341,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152341,35.61,0.49,132,72377,75,NULL,'IR','FGC 2349',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152342,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152342,35.61,NULL,133,72377,NULL,NULL,NULL,'FGC 2349',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152343,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152343,34.28,NULL,71.9,72378,NULL,NULL,'Dipole','UGC 11841',NULL,'2010Ap&SS.325..163P',2010,1,3.09,NULL,'G',0.000017,NULL,'16.5',0.24,'Scd',NULL,NULL,NULL,NULL,1,328.1899583,38.93642,1.593,NULL,55466160962,866658765,13541543,16.5),(152344,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152344,34.3,NULL,72.5,72378,NULL,NULL,'Dipole + Quadrupole','UGC 11841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152345,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152345,34.32,NULL,73,72378,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11841',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152346,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152346,34.47,0.49,78.4,72379,75,NULL,'IR','MCG -02-55-006',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.00015,NULL,'15',0.1,'Scd',NULL,NULL,NULL,NULL,1,328.208833,-10.51097,0.089,NULL,49901257081,779707141,12182924,15),(152347,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152347,34.86,0.54,93.7,72379,NULL,NULL,'Malmquist cor.','MCG -02-55-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152348,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152348,34.89,0.2,95.1,72379,74.4,NULL,NULL,'MCG -02-55-006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152349,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152349,34.94,NULL,97.2,72379,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-55-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152350,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152350,34.95,NULL,97.7,72379,NULL,NULL,'Dipole + Quadrupole','MCG -02-55-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152351,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152351,34.96,NULL,98.2,72379,NULL,NULL,'Dipole','MCG -02-55-006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152352,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152352,35.06,0.49,103,72379,NULL,NULL,NULL,'MCG -02-55-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152353,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152353,34.88,NULL,94.5,72380,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 288- G 015',NULL,'2010Ap&SS.325..163P',2010,1,1.09,NULL,'G',0.000033,NULL,'15.6r',0.12,'Sbc',NULL,NULL,NULL,NULL,1,328.210875,-45.15539,0,NULL,50644704797,791323512,12364429,15.6),(152354,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152354,34.89,NULL,95,72380,NULL,NULL,'Dipole + Quadrupole','ESO 288- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152355,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152355,34.91,NULL,96.1,72380,NULL,NULL,'Dipole','ESO 288- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152356,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152356,34.93,NULL,97,72380,NULL,NULL,NULL,'ESO 288- G 015',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152357,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152357,35.58,0.43,131,72380,NULL,NULL,'Malmquist cor.','ESO 288- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152358,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152358,35.6,0.42,132,72380,NULL,NULL,NULL,'ESO 288- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152359,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152359,35.64,0.2,134,72380,74.4,NULL,NULL,'ESO 288- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152360,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152360,37.06,0.46,258,72381,70,NULL,NULL,'2MASX J21525196-0058229',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',NULL,NULL,'17.81',0.2,NULL,NULL,NULL,NULL,NULL,1,328.2165417,-0.97306,0.313,NULL,49814790735,778356105,12161814,17.81),(152361,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2006jk',NULL,152361,39.92,0.11,962,72382,70,NULL,'Hubble residual -0.20 for z0.28580','SDSS-II SN 14261 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.240417,0.25369,0.245,NULL,52178811243,815293925,12738967,NULL),(152362,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 14261','R',152362,40.64,0.22,1040,72382,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jk','SDSS-II SN 14261 HOST',0.285847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152363,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 14261','R',152363,40.65,0.14,1050,72382,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jk','SDSS-II SN 14261 HOST',0.285847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152364,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2006jk',NULL,152364,40.55,0.11,1290,72382,70,NULL,'SALT 2','SDSS-II SN 14261 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152365,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2006jk',NULL,152365,40.58,0.11,1310,72382,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14261 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152366,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152366,37.98,0.78,394,72383,70,NULL,NULL,'2MASX J21525800-6232472',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'15.2r',0.27,'S',NULL,NULL,NULL,NULL,1,328.241625,-62.54642,0.033,NULL,49161411106,768147048,12002297,15.2),(152367,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152367,38.2,0.46,436,72384,70,NULL,NULL,'2MASX J21525886-0006389',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,328.2452083,-0.11089,0.289,NULL,49814106971,778345421,12161647,18.1),(152368,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152368,35.92,0.66,153,72385,70,NULL,NULL,'2MASX J21525931-7241003',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.1r',0.19,NULL,NULL,NULL,NULL,NULL,1,328.247125,-72.68333,0.041,NULL,49306340892,770411576,12037680,15.1),(152369,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152369,37.78,0.46,360,72386,70,NULL,NULL,'2MASX J21530265+1229248',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000155,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.260916667,12.49014,0.309,NULL,52235125881,816173841,12752716,17.6),(152370,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152370,36.73,0.23,221,72387,70,NULL,NULL,'2MASX J21530507-0711066',NULL,'2015arXiv151105856S',2015,1,0.92,NULL,'G',0.00012,NULL,'15.1g',0.46,'FR II    poss. LINER',NULL,NULL,NULL,NULL,1,328.271167,-7.18525,0.061,NULL,49926881598,780107524,12189180,15.1),(152371,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152371,33.83,0.49,58.5,72388,70,NULL,NULL,'IC 1408',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00012,NULL,'14.88',0.4,NULL,NULL,NULL,NULL,NULL,1,328.287583333,-13.34678,0.137,NULL,49772955419,777702428,12151600,14.88),(152372,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152372,35.4,0.5,120,72389,70,NULL,NULL,'2MASX J21531072-0734116',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000077,NULL,'15.7g',0.23,'Sa',NULL,NULL,NULL,NULL,1,328.294833,-7.56975,0.057,NULL,49926179380,780096552,12189008,15.7),(152373,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152373,37.88,0.46,376,72390,70,NULL,NULL,'2MASX J21531223-0106249',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,328.300958333,-1.10683,0.313,NULL,49814789766,778356090,12161813,18.3),(152374,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152374,33.54,0.8,50.9,72391,75,NULL,'MAT, I','ESO 075- G 033',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.8r',0.9,'SB(rs)cd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,328.306,-71.02281,0.037,NULL,49304548495,770383570,12037243,14.8),(152375,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152375,33.48,0.32,49.7,72391,85,NULL,'I, inv','ESO 075- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152376,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152376,33.49,0.32,49.9,72391,85,NULL,'I, raw','ESO 075- G 033',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152377,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152377,33.71,0.08,55.3,72391,NULL,NULL,NULL,'ESO 075- G 033',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152378,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152378,33.89,0.43,60,72391,75,NULL,'MAT, I, raw','ESO 075- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152379,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152379,33.91,0.43,60.6,72391,75,NULL,'MAT, I, inv','ESO 075- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152380,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152380,34.16,0.43,67.8,72391,75,NULL,'MAT, I, cor','ESO 075- G 033',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152381,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152381,35.94,0.49,154,72392,75,NULL,'IR','CGCG 427-035 NED02',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000247,NULL,'15.5',0.25,NULL,NULL,NULL,NULL,NULL,1,328.316583333,15.61539,0.285,NULL,52238978227,816234034,12753656,15.5),(152382,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152382,33.81,0.8,57.7,72393,75,NULL,'MAT, I','IC 5141',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000028,NULL,'13.47',1.3,'SAB:(r:)b','Pair member (points to parent)',NULL,NULL,NULL,1,328.321,-59.49356,0.049,NULL,48681936380,760655255,11885238,13.47),(152383,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152383,33.55,0.54,51.2,72393,NULL,NULL,'Malmquist cor.','IC 5141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152384,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152384,33.55,0.43,51.4,72393,75,NULL,'MAT, I, raw','IC 5141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152385,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152385,33.61,0.47,52.8,72393,NULL,NULL,'H','IC 5141',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152386,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152386,33.64,0.43,53.4,72393,75,NULL,'MAT, I, cor','IC 5141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152387,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152387,33.64,0.45,53.4,72393,NULL,NULL,'K','IC 5141',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152388,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152388,33.65,0.46,53.6,72393,NULL,NULL,'J','IC 5141',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152389,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152389,33.65,0.32,53.7,72393,85,NULL,'I, raw','IC 5141',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152390,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152390,33.71,0.32,55.1,72393,85,NULL,'I, inv','IC 5141',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152391,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152391,33.78,0.4,57.1,72393,NULL,NULL,'mean','IC 5141',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152392,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152392,33.8,0.43,57.5,72393,75,NULL,'MAT, I, inv','IC 5141',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152393,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152393,33.97,0.44,62.1,72393,NULL,NULL,NULL,'IC 5141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152394,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152394,34.01,0.2,63.4,72393,74.4,NULL,NULL,'IC 5141',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152395,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 01131','RN',152395,40.8,0.27,1230,72394,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01131',0.17379,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152396,'SNIa SDSS','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 01131','RN',152396,41.6,0.28,1780,72394,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01131',0.17379,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152397,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 06687','R',152397,40.67,0.44,976,72395,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06687',0.3956,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.3307083,0.47703,0.237,NULL,52179008050,815297000,12739015,NULL),(152398,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 06687','R',152398,40.93,0.41,1100,72395,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06687',0.3956,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152399,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152399,37.52,0.46,319,72396,70,NULL,NULL,'2MASX J21531956-0754516',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000102,NULL,'16.2g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,328.331583,-7.91419,0.065,NULL,49928828030,780137937,12189655,16.2),(152400,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152400,31.85,0.21,23.4,72397,NULL,NULL,'I','NGC 7145',NULL,'2001ApJ...546..681T',2001,1,2.5,NULL,'G',0.000033,NULL,'12.04',2.4,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,328.334333333,-47.88244,0,NULL,50651947592,791436681,12366198,12.04),(152401,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152401,31.85,0.21,23.4,72397,NULL,NULL,NULL,'NGC 7145',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152402,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152402,31.86,0.14,23.6,72397,74.4,NULL,NULL,'NGC 7145',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152403,'SBF','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152403,31.91,0.21,24.1,72397,NULL,NULL,'Malmquist cor.','NGC 7145',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152404,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152404,31.63,0.4,21.2,72397,75,NULL,'Edat, raw','NGC 7145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152405,'D-Sigma','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152405,31.85,0.4,23.5,72397,75,NULL,'Edat, cor','NGC 7145',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152406,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152406,30.34,0.65,11.7,72397,95,NULL,'Weighted Mean','NGC 7145',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152407,'Faber-Jackson','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152407,31.4,0.81,19.1,72397,55,NULL,'Visvanathan & Sandage 1979','NGC 7145',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152408,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152408,31.66,0.41,21.5,72397,NULL,NULL,NULL,'NGC 7145',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152409,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152409,31.92,0.41,24.2,72397,NULL,NULL,'Malmquist cor.','NGC 7145',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152410,'Tertiary','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152410,31.55,0.71,20.4,72397,95,NULL,NULL,'NGC 7145',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152411,'Tully est','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152411,31.89,0.8,23.8,72397,75,NULL,'B','NGC 7145',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152412,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152412,32.09,0.45,26.1,72397,NULL,NULL,'K','NGC 7145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152413,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152413,32.1,0.4,26.3,72397,NULL,NULL,'mean','NGC 7145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152414,'IRAS','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152414,34.39,0.8,75.5,72398,75,NULL,'W91PP, r','UGC 11842',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000067,NULL,'15.57',0.2,'Sab',NULL,NULL,NULL,NULL,1,328.3344583,25.51136,0.281,NULL,55576496881,868382763,13568480,15.57),(152415,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152415,34.32,0.38,73.2,72398,75,NULL,'W91PP, r, raw','UGC 11842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152416,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152416,34.39,0.38,75.4,72398,75,NULL,'W91PP, r, inv','UGC 11842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152417,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152417,34.45,0.49,77.7,72398,75,NULL,'IR','UGC 11842',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152418,'Tully-Fisher','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152418,34.53,0.38,80.6,72398,75,NULL,'W91PP, r, cor','UGC 11842',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152419,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152419,38.04,0.46,405,72399,70,NULL,NULL,'SDSS J215326.96+125331.1',NULL,'2015arXiv151105856S',2015,1,0.1,NULL,'G',0.000139,NULL,'19.4g',0.09,'BrClG',NULL,NULL,NULL,NULL,1,328.362333333,12.892,0.317,NULL,52235242457,816175663,12752744,19.4),(152420,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,NULL,152420,35.65,0.68,135,72400,70,NULL,NULL,'AM 2149-574 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.89',0.28,NULL,NULL,NULL,NULL,NULL,1,328.3650417,-57.43964,0,NULL,48720533724,761258339,11894661,15.89),(152421,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152421,37.31,0.15,290,72401,70,NULL,NULL,'SDSS J215329.96-084448.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,328.374875,-8.74692,0.113,NULL,49927270125,780113595,12189274,18),(152422,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152422,37.65,0.46,339,72402,70,NULL,NULL,'2MASX J21533247-0055294',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.38525,-0.92492,0.333,NULL,49814365029,778349453,12161710,17.9),(152423,'FP','2016-12-15 15:15:56','2016-12-16 11:21:12','1',NULL,'R',152423,37.08,0.46,261,72403,70,NULL,NULL,'2MASX J21534622-0751115',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,328.442625,-7.85303,0.065,NULL,49928863497,780138492,12189663,16.1),(152424,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SN 2007lt',NULL,152424,38.53,0.16,509,72404,70,NULL,'Hubble residual 0.23 for z0.11300','SDSS J215347.32+000054.0',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.005,NULL,'20.9g',0.05,NULL,NULL,NULL,NULL,NULL,1,328.447208333,0.015,0.245,NULL,52178335902,815286498,12738851,20.9),(152425,'SNIa','2016-12-15 15:15:56','2016-12-16 11:21:12','1','SDSS-II SN 18650','R',152425,38.78,0.18,511,72404,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lt','SDSS J215347.32+000054.0',0.113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152426,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 18650','R',152426,38.95,0.07,554,72404,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lt','SDSS J215347.32+000054.0',0.113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152427,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007lt',NULL,152427,38.73,0.06,557,72404,70,NULL,'SALT 2','SDSS J215347.32+000054.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152428,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007lt',NULL,152428,38.73,0.06,557,72404,70,NULL,'SALT 2, Malmquist cor.','SDSS J215347.32+000054.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152429,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152429,36.92,0.66,242,72405,70,NULL,NULL,'2MASX J21535200-1740475',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.6r',0.29,NULL,NULL,NULL,NULL,NULL,1,328.466667,-17.67992,0.101,NULL,49765528016,777586375,12149787,15.6),(152430,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152430,36.92,0.55,242,72406,70,NULL,NULL,'2MASX J21535316-0306560',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.36',NULL,NULL,NULL,NULL,NULL,NULL,1,328.471583,-3.11558,0.133,NULL,49892307220,779567300,12180739,16.36),(152431,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152431,35.91,0.49,152,72407,75,NULL,'IR','CGCG 402-026',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'15.7',0.1,NULL,NULL,NULL,NULL,NULL,1,328.489833333,6.74842,0.161,NULL,52334560551,817727508,12776992,15.7),(152432,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152432,38.8,0.46,576,72408,70,NULL,NULL,'SDSS J215357.85-081735.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000093,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,328.4910417,-8.29314,0.105,NULL,49928895264,780138988,12189671,18.5),(152433,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152433,34.55,0.8,81.3,72409,75,NULL,'MAT, I','NGC 7152',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000023,NULL,'14.25',0.6,'SB(rs)b? pec',NULL,NULL,NULL,NULL,1,328.496,-29.28908,0,NULL,51416695379,803385865,12552904,14.25),(152434,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152434,34.1,0.32,66,72409,85,NULL,'I, raw','NGC 7152',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152435,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152435,34.14,0.32,67.3,72409,85,NULL,'I, inv','NGC 7152',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152436,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152436,34.2,0.43,69.3,72409,75,NULL,'MAT, I, raw','NGC 7152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152437,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152437,34.37,0.2,74.8,72409,74.4,NULL,NULL,'NGC 7152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152438,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152438,34.4,0.43,75.9,72409,75,NULL,'MAT, I, inv','NGC 7152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152439,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152439,34.47,0.43,78.2,72409,75,NULL,'MAT, I, cor','NGC 7152',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152440,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152440,34.48,0.43,78.8,72409,NULL,NULL,'Malmquist cor.','NGC 7152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152441,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152441,34.62,0.4,84.1,72409,NULL,NULL,NULL,'NGC 7152',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152442,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152442,34.63,0.4,84.4,72409,NULL,NULL,'mean','NGC 7152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152443,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152443,34.81,0.47,91.6,72409,NULL,NULL,'H','NGC 7152',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152444,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05776','RN',152444,40.73,0.24,1130,72410,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05776',0.238652,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152445,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05776','RN',152445,41.04,0.21,1310,72410,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05776',0.238652,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152446,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05776','N',152446,40.69,0.15,1370,72410,70,NULL,'SALT 2','SDSS-II SN 05776',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152447,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05776','N',152447,40.7,0.15,1380,72410,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05776',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152448,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152448,31.76,0.8,22.5,72411,75,NULL,NULL,'ESO 145- G 025',NULL,'1988NBGC.C....0000T',1988,1,2.3,'The APM position is northwest of the center of the bar.','G',0.00001,NULL,'14.02',1.8,'SAB(s)dm',NULL,NULL,NULL,NULL,1,328.523875,-57.61361,0,NULL,48718633994,761228656,11894197,14.02),(152449,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152449,31.1,0.43,16.6,72411,75,NULL,'3.6 micron, color + selection bias corrected','ESO 145- G 025',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152450,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152450,35.56,0.5,130,72412,70,NULL,NULL,'2MASX J21541023-1713466',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'15.1r',0.12,NULL,NULL,NULL,NULL,NULL,1,328.542625,-17.22972,0.125,NULL,49765872438,777591756,12149871,15.1),(152451,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16200','RN',152451,40.24,0.22,1030,72413,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16200',0.090465,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152452,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16200','RN',152452,40.32,0.14,1060,72413,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16200',0.090465,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152453,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152453,35.8,0.65,144,72414,70,NULL,NULL,'2MASX J21541269-5515252',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.5r',0.48,'S0',NULL,NULL,NULL,NULL,1,328.552875,-55.25703,0,NULL,48711930409,761123912,11892561,14.5),(152454,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152454,33.57,0.8,51.7,72415,75,NULL,'MAT, I','IC 5140',NULL,'1997ApJS..109..333W',1997,1,2.24,NULL,'G',0.000033,NULL,'15.15',0.21,'SBd? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,328.566791667,-67.33139,0.009,NULL,49282304069,770036001,12031812,15.15),(152455,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152455,33.14,0.32,42.4,72415,85,NULL,'I, raw','IC 5140',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152456,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152456,33.14,0.32,42.4,72415,85,NULL,'I, inv','IC 5140',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152457,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152457,33.29,0.43,45.4,72415,75,NULL,'MAT, I, raw','IC 5140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152458,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152458,33.34,0.43,46.5,72415,75,NULL,'MAT, I, cor','IC 5140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152459,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152459,33.35,0.43,46.7,72415,75,NULL,'MAT, I, inv','IC 5140',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152460,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152460,33.37,0.49,47.1,72415,75,NULL,'IR','IC 5140',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152461,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152461,33.64,NULL,53.4,72415,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5140',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152462,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152462,33.65,NULL,53.8,72415,NULL,NULL,'Dipole + Quadrupole','IC 5140',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152463,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152463,33.68,NULL,54.3,72415,NULL,NULL,'Dipole','IC 5140',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152464,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152464,33.73,NULL,55.7,72415,NULL,NULL,NULL,'IC 5140',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152465,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152465,33.73,0.14,55.8,72415,NULL,NULL,NULL,'IC 5140',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152466,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152466,35.07,0.49,103,72416,70,NULL,NULL,'2MASX J21541607-1640226',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.20',NULL,NULL,NULL,NULL,NULL,NULL,1,328.567167,-16.67297,0.109,NULL,49769141234,777642831,12150669,16.2),(152467,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152467,37.31,0.15,290,72417,70,NULL,NULL,'2MASX J21541797-0836009',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,328.574958333,-8.60036,0.105,NULL,49928430190,780131721,12189558,17.2),(152468,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152468,36.48,0.55,198,72418,70,NULL,NULL,'2MASX J21541957-1409376',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,328.5815,-14.16056,0.109,NULL,49772596265,777696816,12151512,15.3),(152469,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152469,36.73,0.46,222,72419,70,NULL,NULL,'2MASX J21541992-0111157',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,328.5829583,-1.18786,0.333,NULL,49814209906,778347029,12161672,17.5),(152470,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467',NULL,152470,39.88,0.13,946,72420,70,NULL,'SALT 2','SDSS J215420.48+000703.7',NULL,'2013ApJ...763...88C',2013,1,0.11,NULL,'G',0.0005,NULL,'19.8g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,328.585375,0.11772,0.245,NULL,52178384648,815287260,12738863,19.8),(152471,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467',NULL,152471,39.89,0.13,951,72420,70,NULL,'SALT 2, Malmquist cor.','SDSS J215420.48+000703.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152472,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467',NULL,152472,39.35,0.22,741,72421,70,NULL,NULL,'SDSS-II SN 16467',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.5857083,0.11822,0.245,NULL,52178384196,815287253,12738863,NULL),(152473,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467','R',152473,39.94,0.22,797,72421,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16467',0.221151,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152474,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16467','R',152474,40.24,0.15,913,72421,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16467',0.221151,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152475,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152475,32.53,0.51,32,72422,NULL,NULL,'Malmquist cor.','UGC 11845 NOTES02',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'15.7',0.4,NULL,'Group member',NULL,NULL,NULL,1,328.586083,15.04406,0.257,NULL,52240290475,816254538,12753977,15.7),(152476,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152476,33.14,0.38,42.5,72422,NULL,NULL,NULL,'UGC 11845 NOTES02',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152477,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152477,37.29,0.46,288,72423,70,NULL,NULL,'2MASX J21542096-0855099',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000173,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,328.587333333,-8.9195,0.113,NULL,49927187098,780112298,12189254,17),(152478,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152478,32.4,0.8,30.2,72424,75,NULL,'MAT, I','ESO 466- G 014',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.3r',0.2,'Sb:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,328.5952917,-31.96919,0,NULL,51460570973,804071421,12563615,14.3),(152479,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152479,32.47,0.1,31.3,72424,NULL,NULL,NULL,'ESO 466- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152480,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152480,33.37,0.32,47.2,72424,85,NULL,'I, raw','ESO 466- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152481,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152481,33.38,0.32,47.4,72424,85,NULL,'I, inv','ESO 466- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152482,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152482,33.74,0.43,55.9,72424,75,NULL,'MAT, I, raw','ESO 466- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152483,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152483,33.84,0.43,58.7,72424,75,NULL,'MAT, I, inv','ESO 466- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152484,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152484,33.98,0.43,62.6,72424,75,NULL,'MAT, I, cor','ESO 466- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152485,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152485,34.86,0.4,93.8,72425,NULL,NULL,'mean','IC 5145',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000017,NULL,'14.30',0.9,'Sab','Group member',NULL,NULL,NULL,1,328.596083,15.15683,0.233,NULL,52240170061,816252657,12753947,14.3),(152486,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152486,34.86,0.47,93.8,72425,NULL,NULL,'H','IC 5145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152487,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152487,34.86,0.45,93.8,72425,NULL,NULL,'K','IC 5145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152488,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152488,34.88,0.46,94.5,72425,NULL,NULL,'J','IC 5145',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152489,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152489,35.35,0.43,118,72425,75,NULL,'3.6 micron, color + selection bias corrected','IC 5145',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152490,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152490,37.04,0.46,256,72426,70,NULL,NULL,'2MASX J21542321-0914229',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,328.596708333,-9.23964,0.093,NULL,49919054905,779985232,12187269,16.9),(152491,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05785','R',152491,38.75,0.13,491,72427,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05785',0.148398,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.597375,0.08375,0.245,NULL,52178379984,815287187,12738862,NULL),(152492,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05785','R',152492,38.85,0.19,514,72427,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05785',0.148398,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152493,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152493,33.56,0.49,51.6,72428,75,NULL,'IR','2MFGC 16536',NULL,'2011yCatp016004901K',2011,1,0.35,NULL,'G',0.000017,NULL,'12.3K',NULL,NULL,NULL,NULL,NULL,NULL,1,328.6027083,46.53878,NULL,NULL,55387485146,865429455,13522335,12.3),(152494,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03444','RN',152494,41.88,0.19,1720,72429,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03444',0.378981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152495,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03444','RN',152495,42.25,0.11,2040,72429,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03444',0.378981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152496,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152496,33.93,0.49,61.2,72430,75,NULL,'IR','2MFGC 16538',NULL,'2011yCatp016004901K',2011,1,0.67,NULL,'G',0.000043,NULL,'10.7K',0.22,'Spiral',NULL,NULL,NULL,NULL,1,328.608833,41.7345,NULL,NULL,55501556930,867211827,13550184,10.7),(152497,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152497,34.4,0.4,76,72430,NULL,NULL,'mean','2MFGC 16538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152498,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152498,34.46,0.47,77.9,72430,NULL,NULL,'H','2MFGC 16538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152499,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152499,34.51,0.45,79.7,72430,NULL,NULL,'K','2MFGC 16538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152500,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152500,34.76,0.46,89.5,72430,NULL,NULL,'J','2MFGC 16538',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152501,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152501,37.31,0.15,290,72431,70,NULL,NULL,'2MASX J21542625-0823288',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000103,NULL,'16.6g',0.37,NULL,NULL,NULL,NULL,NULL,1,328.609375,-8.39142,0.105,NULL,49928291237,780129550,12189524,16.6),(152502,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pl',NULL,152502,39.55,0.19,813,72432,70,NULL,'SDSS-II SN 16473','SDSS J215426.92+003518.7',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.612167,0.58853,0.157,NULL,52179128460,815298882,12739045,NULL),(152503,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16473','R',152503,40.07,0.2,859,72432,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pl','SDSS J215426.92+003518.7',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152504,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pl',NULL,152504,39.9,0.1,955,72432,70,NULL,'SALT 2','SDSS J215426.92+003518.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152505,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pl',NULL,152505,39.92,0.1,964,72432,70,NULL,'SALT 2, Malmquist cor.','SDSS J215426.92+003518.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152506,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16473','R',152506,40.37,0.15,988,72432,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pl','SDSS J215426.92+003518.7',0.2,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152507,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152507,37.24,0.46,281,72433,70,NULL,NULL,'2MASX J21542737-0711091',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,328.613875,-7.18586,0.061,NULL,49926488738,780101386,12189084,17.8),(152508,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152508,34.91,0.2,95.9,72434,74.4,NULL,NULL,'UGC 11845',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000542,NULL,'15.61',0.2,'Sbc',NULL,NULL,NULL,NULL,1,328.616708333,15.01653,0.257,NULL,52240308612,816254822,12753981,15.61),(152509,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152509,34.94,0.52,97.2,72434,NULL,NULL,NULL,'UGC 11845',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152510,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152510,35.07,0.49,103,72434,NULL,NULL,'Malmquist cor.','UGC 11845',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152511,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152511,36.93,0.46,243,72435,70,NULL,NULL,'2MASX J21542883-0818341',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.62,-8.30944,0.105,NULL,49928768363,780137005,12189640,17.8),(152512,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152512,37.31,0.15,290,72436,70,NULL,NULL,'2MASX J21543186-0837391',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,328.632667,-8.62736,0.105,NULL,49928468193,780132315,12189567,17.8),(152513,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152513,38.18,0.33,433,72437,70,NULL,NULL,'SDSS J215432.20-085734.5',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,328.634208333,-8.95958,0.089,NULL,49927218066,780112782,12189262,17.9),(152514,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152514,37.29,0.46,287,72438,70,NULL,NULL,'2MASX J21543364+1154154',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,328.640125,11.90444,0.305,NULL,52303399157,817240611,12769384,17.7),(152515,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152515,37.61,0.33,333,72439,70,NULL,NULL,'2MASX J21543462-0916321',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000171,NULL,'17.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,328.6442917,-9.27578,0.093,NULL,49919098070,779985907,12187279,17.5),(152516,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152516,38.18,0.33,433,72440,70,NULL,NULL,'2MASX J21543503-0856421',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,328.6460417,-8.945,0.089,NULL,49927184607,780112259,12189254,17.7),(152517,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152517,37.61,0.33,333,72441,70,NULL,NULL,'2MASX J21543719-0915341',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,328.655125,-9.25956,0.093,NULL,49919098528,779985914,12187279,16.2),(152518,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152518,36.37,0.73,188,72442,70,NULL,NULL,'2MASX J21543758-0622451',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.55',0.39,NULL,NULL,NULL,NULL,NULL,1,328.6565,-6.37928,0.041,NULL,49922537147,780039642,12188119,16.55),(152519,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152519,37.31,0.15,290,72443,70,NULL,NULL,'2MASX J21543786-0839221',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000172,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,328.65775,-8.65631,0.105,NULL,49928467927,780132311,12189567,16.8),(152520,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13590','RN',152520,42.04,0.4,1710,72444,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13590',0.496918,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152521,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19191','RN',152521,40.72,0.24,1200,72445,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19191',0.162727,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152522,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19191','RN',152522,41.29,0.43,1560,72445,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19191',0.162727,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152523,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152523,39.48,0.12,645,72446,74.2,NULL,'SALT 2','SDSS J215440.78+002446.9',0.22,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',0.0005,NULL,'23.7g',0.04,NULL,NULL,NULL,NULL,NULL,1,328.669917,0.41303,0.237,NULL,52179141014,815299078,12739048,23.7),(152524,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152524,39.61,0.07,834,72446,70,NULL,'Hubble residual -0.01 for z0.21970','SDSS J215440.78+002446.9',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152525,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152525,40.16,0.13,882,72446,70,NULL,'SALT 2','SDSS J215440.78+002446.9',0.22,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152526,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152526,40.18,0.07,891,72446,65,NULL,'SALT2','SDSS J215440.78+002446.9',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152527,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05533','R',152527,40.19,0.18,894,72446,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hu','SDSS J215440.78+002446.9',0.2197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152528,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152528,40.21,NULL,901,72446,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05533, SN 2005hu','SDSS J215440.78+002446.9',0.22,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152529,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152529,40.32,0.08,949,72446,65,NULL,'MLCS2k2','SDSS J215440.78+002446.9',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152530,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05533','R',152530,40.35,0.09,961,72446,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hu','SDSS J215440.78+002446.9',0.2197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152531,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152531,40.06,0.07,1030,72446,70,NULL,'SALT 2','SDSS J215440.78+002446.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152532,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152532,40.07,0.07,1030,72446,70,NULL,'SALT 2, Malmquist cor.','SDSS J215440.78+002446.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152533,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hu',NULL,152533,40.56,0.03,1060,72446,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 05533, SN 2005hu','SDSS J215440.78+002446.9',0.22,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152534,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152534,37.31,0.15,290,72447,70,NULL,NULL,'2MASX J21544110-0827061',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,328.6712917,-8.45178,0.105,NULL,49928305496,780129773,12189527,17.7),(152535,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152535,36.46,0.68,196,72448,70,NULL,NULL,'2MASX J21544334-1244054',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,328.680667,-12.73489,0.081,NULL,49769996264,777656191,12150877,15.3),(152536,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152536,35.21,0.8,110,72449,75,NULL,'CF, r','UGC 11846',NULL,'1997ApJS..109..333W',1997,1,0.9,'Springob et al. (2005ApJS..160..149S) give v= 8493 km/sec.','G',0.000123,NULL,'15.01',0.5,'Sbc',NULL,NULL,NULL,NULL,1,328.688375,6.42158,0.193,NULL,52335392459,817740507,12777195,15.01),(152537,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152537,35.08,0.38,104,72449,75,NULL,'CF, r, raw','UGC 11846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152538,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152538,35.24,0.38,112,72449,75,NULL,'CF, r, inv','UGC 11846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152539,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152539,35.3,0.38,115,72449,75,NULL,'CF, r, cor','UGC 11846',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152540,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152540,37.31,0.15,290,72450,70,NULL,NULL,'2MASX J21544548-0829201',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,328.6895417,-8.48889,0.105,NULL,49928297439,780129647,12189525,17),(152541,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152541,36.87,0.46,237,72451,70,NULL,NULL,'2MASX J21544578-0720291',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,328.690875,-7.34144,0.061,NULL,49926634341,780103661,12189119,16.5),(152542,'SGRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'N',152542,38.73,NULL,557,72452,71,NULL,NULL,'GRB 051221A HOST',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152543,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152543,37.31,0.15,290,72453,70,NULL,NULL,'2MASX J21544920-0849331',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,328.705167,-8.82603,0.093,NULL,49928261185,780129081,12189516,17.9),(152544,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pm',NULL,152544,39.6,0.23,832,72454,70,NULL,'SDSS-II SN 16482','APMUKS(BJ) B215217.32+004145.2',NULL,'2013MNRAS.434.1443X',2013,1,0.1,NULL,'G',NULL,NULL,'20.24',0.1,NULL,NULL,NULL,NULL,NULL,1,328.710833,0.933,0.177,NULL,52178653332,815291458,12738929,20.24),(152545,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16482','R',152545,40.11,0.24,869,72454,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pm','APMUKS(BJ) B215217.32+004145.2',0.210771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152546,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pm',NULL,152546,39.7,0.12,871,72454,70,NULL,'SALT 2','APMUKS(BJ) B215217.32+004145.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152547,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006pm',NULL,152547,39.72,0.12,879,72454,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B215217.32+004145.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152548,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16482','R',152548,40.23,0.14,919,72454,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pm','APMUKS(BJ) B215217.32+004145.2',0.210771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152549,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05792',NULL,152549,41.26,0.16,1790,72455,70,NULL,'SALT 2','SDSS-II SN 05792',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,328.714167,-1.23786,0.377,NULL,49814239957,778347499,12161679,NULL),(152550,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05792',NULL,152550,41.32,0.16,1840,72455,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05792',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152551,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05792',NULL,152551,41.49,0.05,1980,72455,70,NULL,'SN photometric redshift distance, z photo =0.651 +/- 0.021','SDSS-II SN 05792',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152552,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152552,38.85,0.46,590,72456,70,NULL,NULL,'SDSS J215453.25-011448.3',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,328.721875,-1.24675,0.377,NULL,49814240360,778347505,12161679,18.7),(152553,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152553,37.31,0.15,290,72457,70,NULL,NULL,'2MASX J21545599-0848307',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000157,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,328.733416667,-8.80844,0.093,NULL,49928259855,780129060,12189516,16.8),(152554,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152554,37.4,0.46,302,72458,70,NULL,NULL,'2MASX J21545633+1131526',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,328.734667,11.53142,0.305,NULL,52304000409,817250006,12769531,17.5),(152555,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152555,37.02,0.46,254,72459,70,NULL,NULL,'2MASX J21545739-0735517',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000103,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,328.7392917,-7.59761,0.049,NULL,49926586393,780102912,12189108,16.3),(152556,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13437','R',152556,41.97,0.34,1730,72460,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13437',0.435782,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,328.74725,-0.66194,0.309,NULL,49814565448,778352585,12161759,NULL),(152557,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13437','R',152557,42.15,0.4,1870,72460,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13437',0.435782,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152558,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 18615','RN',152558,40.82,0.22,1200,72461,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18615',0.213402,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152559,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152559,31.76,0.8,22.5,72462,75,NULL,'MAT, I','NGC 7151',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000022,NULL,'13.46',1.2,'SA(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,328.76725,-50.65789,0,NULL,50660798633,791574978,12368359,13.46),(152560,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152560,31.58,0.4,20.7,72462,75,NULL,NULL,'NGC 7151',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152561,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152561,31.58,0.39,20.7,72462,73,NULL,'IR','NGC 7151',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152562,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152562,31.69,0.4,21.8,72462,73,NULL,'opt','NGC 7151',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152563,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152563,31.76,0.32,22.5,72462,85,NULL,'I, raw','NGC 7151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152564,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152564,31.77,0.32,22.6,72462,85,NULL,'I, inv','NGC 7151',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152565,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152565,31.8,0.4,22.9,72462,NULL,NULL,NULL,'NGC 7151',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152566,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152566,32,0.43,25.1,72462,75,NULL,'MAT, I, raw','NGC 7151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152567,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152567,32.07,0.43,26,72462,75,NULL,'MAT, I, inv','NGC 7151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152568,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152568,32.21,0.49,27.7,72462,75,NULL,'IR','NGC 7151',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152569,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152569,32.25,0.43,28.1,72462,75,NULL,'MAT, I, cor','NGC 7151',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152570,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152570,34.69,0.46,86.8,72463,NULL,NULL,'Malmquist cor.','CGCG 493-012',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000033,NULL,'15.4',0.6,'Sc',NULL,NULL,NULL,NULL,1,328.769541667,30.58406,0.481,NULL,55625410599,869147040,13580422,15.4),(152571,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152571,34.84,0.43,92.7,72463,NULL,NULL,NULL,'CGCG 493-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152572,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152572,35.04,0.2,102,72463,74.4,NULL,NULL,'CGCG 493-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152573,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152573,36.14,0.63,169,72464,70,NULL,NULL,'2MASX J21550591-0625097',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.09',0.46,NULL,NULL,NULL,NULL,NULL,1,328.77475,-6.41925,0.065,NULL,49922556243,780039941,12188124,16.09),(152574,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16879','RN',152574,41.06,0.27,1340,72465,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16879',0.214394,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152575,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16879','RN',152575,41.73,0.42,1830,72465,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16879',0.214394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152576,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152576,35.89,0.63,151,72466,70,NULL,NULL,'SDSS J215507.85-004613.0',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,328.78275,-0.77028,0.309,NULL,49814246389,778347599,12161681,16.6),(152577,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152577,36.51,0.58,200,72467,70,NULL,NULL,'KAZ 533',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00015,NULL,'16.5',0.29,NULL,NULL,NULL,NULL,NULL,1,328.7954583,-12.05569,0.069,NULL,49900228882,779691076,12182673,16.5),(152578,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152578,37.48,0.33,314,72468,70,NULL,NULL,'SDSS J215513.69-091805.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000167,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.807083,-9.30161,0.093,NULL,49919565672,779993213,12187393,18),(152579,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13678','RN',152579,40.99,0.13,1270,72469,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13678',0.239877,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152580,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13678','RN',152580,41.41,0.21,1540,72469,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13678',0.239877,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152581,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152581,36.08,0.52,165,72470,70,NULL,NULL,'ESO 189- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.82',1,'(R)SB(s)0/a',NULL,NULL,NULL,NULL,1,328.8195,-55.57228,0,NULL,48712568133,761133877,11892716,14.82),(152582,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152582,37.48,0.33,314,72471,70,NULL,NULL,'2MASX J21551727-0917517',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,328.822083,-9.29778,0.093,NULL,49919563113,779993173,12187393,16.3),(152583,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152583,34.22,0.8,69.8,72472,75,NULL,'MAT, I','IC 5142',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.47',0.8,'SAB(rs)c',NULL,NULL,NULL,NULL,1,328.835375,-65.51003,0.021,NULL,49355522734,771180042,12049688,14.47),(152584,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152584,34.15,0.32,67.7,72472,85,NULL,'I, raw','IC 5142',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152585,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152585,34.19,0.32,68.8,72472,85,NULL,'I, inv','IC 5142',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152586,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152586,34.35,0.43,74.2,72472,75,NULL,'MAT, I, raw','IC 5142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152587,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152587,34.53,0.43,80.6,72472,75,NULL,'MAT, I, inv','IC 5142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152588,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152588,34.84,0.43,93,72472,75,NULL,'MAT, I, cor','IC 5142',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152589,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152589,32.58,0.8,32.8,72473,75,NULL,'MAT, I','NGC 7154',NULL,'1997ApJS..109..333W',1997,1,2.1,'Confused HIPASS source','G',0.00001,NULL,'13.14',1.6,'SB(s)m pec:','in a pair',NULL,NULL,NULL,1,328.837666667,-34.81414,0,NULL,51445630974,803837983,12559968,13.14),(152590,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152590,32.61,0.8,33.3,72473,75,NULL,NULL,'NGC 7154',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152591,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152591,31.72,0.43,22.1,72473,75,NULL,'MAT, I, raw','NGC 7154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152592,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152592,31.75,0.43,22.4,72473,75,NULL,'MAT, I, inv','NGC 7154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152593,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152593,31.94,0.32,24.4,72473,85,NULL,'I, raw','NGC 7154',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152594,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152594,31.95,0.32,24.5,72473,85,NULL,'I, inv','NGC 7154',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152595,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152595,32.1,0.43,26.3,72473,75,NULL,'MAT, I, cor','NGC 7154',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152596,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152596,32.6,0.06,33.2,72473,NULL,NULL,NULL,'NGC 7154',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152597,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16455',NULL,152597,38.42,0.52,483,72474,70,NULL,'SN photometric redshift distance, z photo =0.120 +/- 0.035','SDSS-II SN 16455',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,328.8377917,-0.39336,0.277,NULL,49813803133,778340673,12161573,NULL),(152598,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152598,37.43,0.54,306,72475,70,NULL,NULL,'2MASX J21552211-4753053',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.2r',0.36,NULL,NULL,NULL,NULL,NULL,1,328.8422083,-47.88486,0,NULL,50651839516,791434992,12366171,15.2),(152599,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152599,34.92,0.46,96.4,72476,70,NULL,NULL,'2MASX J21552271-0000531',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'16.2g',0.16,'S0',NULL,NULL,NULL,NULL,1,328.8447083,-0.01486,0.281,NULL,49813679845,778338747,12161542,16.2),(152600,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152600,37.13,0.46,267,72477,70,NULL,NULL,'2MASX J21552419-0020161',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00017,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,328.85075,-0.33786,0.277,NULL,49813876132,778341814,12161590,16.9),(152601,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152601,36.25,0.54,178,72478,70,NULL,NULL,'2MASX J21553099-6002070',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000103,NULL,'14.7r',0.43,'S0',NULL,NULL,NULL,NULL,1,328.879291667,-60.03536,0.017,NULL,48684911653,760701744,11885964,14.7),(152602,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007rf',NULL,152602,40.02,0.12,1010,72479,70,NULL,'Hubble residual -0.11 for z0.28800','SDSS J215531.06+004854.3',NULL,'2011ApJ...740...92G',2011,1,0.04,NULL,'G',0.0005,NULL,'22.3g',0.03,NULL,NULL,NULL,NULL,NULL,1,328.879417,0.81508,0.177,NULL,52178598432,815290600,12738915,22.3),(152603,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20040','R',152603,40.83,0.23,1140,72479,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007rf','SDSS J215531.06+004854.3',0.288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152604,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20040','R',152604,40.94,0.15,1200,72479,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007rf','SDSS J215531.06+004854.3',0.288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152605,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007rf',NULL,152605,40.69,0.12,1370,72479,70,NULL,'SALT 2','SDSS J215531.06+004854.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152606,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007rf',NULL,152606,40.72,0.12,1390,72479,70,NULL,'SALT 2, Malmquist cor.','SDSS J215531.06+004854.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152607,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007my',NULL,152607,39.73,0.14,882,72480,70,NULL,'Hubble residual -0.44 for z0.29320','SDSS J215532.17-002218.4',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.0005,NULL,'21.9g',0.04,NULL,NULL,NULL,NULL,NULL,1,328.8840417,-0.37181,0.277,NULL,49813874548,778341789,12161590,21.9),(152608,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19027','R',152608,40.53,0.23,986,72480,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007my','SDSS J215532.17-002218.4',0.2932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152609,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19027','R',152609,40.6,0.17,1020,72480,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007my','SDSS J215532.17-002218.4',0.2932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152610,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007my',NULL,152610,40.4,0.12,1200,72480,70,NULL,'SALT 2','SDSS J215532.17-002218.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152611,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2007my',NULL,152611,40.43,0.12,1220,72480,70,NULL,'SALT 2, Malmquist cor.','SDSS J215532.17-002218.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152612,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152612,37.87,0.46,375,72481,70,NULL,NULL,'2MASX J21553273-0654083',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,328.886291667,-6.90239,0.057,NULL,49922115289,780033051,12188016,16.7),(152613,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02501','RN',152613,42.09,0.21,1940,72482,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02501',0.350513,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152614,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02501','RN',152614,42.23,0.15,2070,72482,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02501',0.350513,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152615,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','PTF11htb','N',152615,36.63,0.04,202,72483,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11htb',0.0493,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152616,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03040','RN',152616,40.31,0.18,951,72484,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03040',0.215388,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152617,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03040','RN',152617,40.87,0.23,1230,72484,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03040',0.215388,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152618,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17386','R',152618,37.57,0.18,299,72485,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007jm','SDSS J215538.80-001034.2',0.091147,'2014arXiv1401.3317S',2014,1,0.17,NULL,'G',NULL,':','19.4g',0.06,NULL,NULL,NULL,NULL,NULL,1,328.911667,-0.17617,0.281,NULL,49813702624,778339103,12161548,19.4),(152619,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152619,35.12,0.8,106,72486,75,NULL,'MAT, I','ESO 189- G 012',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.2r',0.22,'SAc: sp',NULL,NULL,NULL,NULL,1,328.911917,-54.87619,0,NULL,48709185788,761081027,11891891,14.2),(152620,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152620,34.92,0.49,96.4,72486,75,NULL,'IR','ESO 189- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152621,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152621,35.35,NULL,118,72486,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 189- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152622,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152622,35.36,NULL,118,72486,NULL,NULL,'Dipole + Quadrupole','ESO 189- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152623,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152623,35.38,NULL,119,72486,NULL,NULL,'Dipole','ESO 189- G 012',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152624,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152624,35.39,NULL,120,72486,NULL,NULL,NULL,'ESO 189- G 012',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152625,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152625,35.6,0.43,132,72486,75,NULL,'MAT, I, raw','ESO 189- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152626,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152626,35.82,0.41,146,72486,NULL,NULL,'Malmquist cor.','ESO 189- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152627,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152627,35.86,0.32,148,72486,85,NULL,'I, raw','ESO 189- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152628,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152628,35.89,0.43,150,72486,75,NULL,'MAT, I, cor','ESO 189- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152629,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152629,35.89,0.43,150,72486,75,NULL,'MAT, I, inv','ESO 189- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152630,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152630,35.92,0.32,153,72486,85,NULL,'I, inv','ESO 189- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152631,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152631,35.92,0.39,153,72486,NULL,NULL,NULL,'ESO 189- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152632,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152632,35.96,0.2,156,72486,74.4,NULL,NULL,'ESO 189- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152633,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19417','N',152633,41.96,0.2,2470,72487,70,NULL,'SALT 2','SDSS-II SN 19417',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152634,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19417','N',152634,42.02,0.2,2540,72487,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19417',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152635,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152635,34.41,0.8,76.2,72488,75,NULL,'W91PP, r','UGC 11849',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.00001,NULL,'14.46',0.9,'SBcd:',NULL,NULL,NULL,NULL,1,328.91775,24.89781,0.289,NULL,55579836396,868434943,13569295,14.46),(152636,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152636,33.86,0.69,59.2,72488,100,NULL,'mid-IR','UGC 11849',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152637,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152637,34.15,0.38,67.5,72488,75,NULL,'W91PP, r, raw','UGC 11849',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152638,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152638,34.3,0.38,72.5,72488,75,NULL,'W91PP, r, inv','UGC 11849',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152639,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152639,34.32,0.2,73.1,72488,74.4,NULL,NULL,'UGC 11849',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152640,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152640,34.37,0.38,75,72488,75,NULL,'W91PP, r, cor','UGC 11849',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152641,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152641,34.46,0.53,77.8,72488,NULL,NULL,NULL,'UGC 11849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152642,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152642,34.54,0.51,80.9,72488,NULL,NULL,'Malmquist cor.','UGC 11849',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152643,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152643,34.59,0.4,82.8,72488,NULL,NULL,'mean','UGC 11849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152644,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152644,34.81,0.47,91.5,72488,NULL,NULL,'H','UGC 11849',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152645,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152645,37.47,0.46,313,72489,70,NULL,NULL,'2MASXi J2155444-065340',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,328.93525,-6.89464,0.057,NULL,49922000618,780031259,12187988,17.9),(152646,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152646,40.02,0.05,801,72490,70,NULL,'SDSS-II SN 02017','SDSS J215546.53+003536.4',0.26,'2011ApJS..192....1C',2011,1,0.07,NULL,'G',0.0005,NULL,'20.9g',0.06,NULL,NULL,NULL,NULL,NULL,1,328.943917,0.59347,0.177,NULL,52178264396,815285381,12738834,20.9),(152647,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152647,40.09,0.15,827,72490,74.2,NULL,'SALT 2','SDSS J215546.53+003536.4',0.26,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152648,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152648,40.22,0.15,1110,72490,70,NULL,'Hubble residual 0.27 for z0.26160','SDSS J215546.53+003536.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152649,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152649,40.84,0.15,1170,72490,65,NULL,'SALT2','SDSS J215546.53+003536.4',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152650,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152650,40.91,0.18,1210,72490,70,NULL,'SDSS-II SN 02017, SALT 2','SDSS J215546.53+003536.4',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152651,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02017','R',152651,40.97,0.24,1240,72490,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fo','SDSS J215546.53+003536.4',0.2616,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152652,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005fo',NULL,152652,40.99,0.13,1250,72490,65,NULL,'MLCS2k2','SDSS J215546.53+003536.4',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152653,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02017','R',152653,41.05,0.18,1280,72490,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fo','SDSS J215546.53+003536.4',0.2616,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152654,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152654,35.44,0.34,123,72491,NULL,NULL,'Malmquist cor.','CGCG 428-001',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00058,NULL,'15.47',0.3,NULL,NULL,NULL,NULL,NULL,1,328.948083,14.73108,0.237,NULL,52232975760,816140246,12752191,15.47),(152655,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152655,35.53,0.33,128,72491,NULL,NULL,NULL,'CGCG 428-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152656,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152656,35.71,0.2,139,72491,74.4,NULL,NULL,'CGCG 428-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152657,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152657,39.65,0.15,698,72492,74.2,NULL,'SALT 2','SDSS J215548.23+011052.7',0.22,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',NULL,NULL,'19.96',0.11,NULL,NULL,NULL,NULL,NULL,1,328.950958333,1.18133,0.165,NULL,52192590349,815509224,12742331,19.96),(152658,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152658,40.13,0.06,871,72492,70,NULL,'SDSS-II SN 09467','SDSS J215548.23+011052.7',0.22,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152659,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152659,40.32,0.23,951,72492,65,NULL,'SALT2','SDSS J215548.23+011052.7',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152660,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152660,39.9,0.22,955,72492,70,NULL,'SDSS-II SN 09467','SDSS J215548.23+011052.7',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152661,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09467','R',152661,40.36,0.22,967,72492,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lh','SDSS J215548.23+011052.7',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152662,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152662,40.37,0.17,971,72492,70,NULL,'SDSS-II SN 09467, SALT 2','SDSS J215548.23+011052.7',0.22,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152663,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152663,40.5,0.18,1030,72492,65,NULL,'MLCS2k2','SDSS J215548.23+011052.7',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152664,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09467','R',152664,40.52,0.19,1040,72492,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lh','SDSS J215548.23+011052.7',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152665,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152665,40.18,0.14,1090,72492,70,NULL,'SALT 2','SDSS J215548.23+011052.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152666,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lh',NULL,152666,40.19,0.14,1090,72492,70,NULL,'SALT 2, Malmquist cor.','SDSS J215548.23+011052.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152667,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152667,37.38,0.46,299,72493,70,NULL,NULL,'2MASX J21555000-0919553',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,328.9582917,-9.33186,0.093,NULL,49917747249,779964800,12186950,17),(152668,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152668,35.6,0.76,132,72494,70,NULL,NULL,'2MASX J21555152-0131386',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.45',0.18,NULL,NULL,NULL,NULL,NULL,1,328.964583,-1.52733,0.361,NULL,49827292108,778551439,12164866,17.45),(152669,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20394',NULL,152669,37.59,1.6,329,72495,70,NULL,'SN photometric redshift distance, z photo =0.080 +/- 0.096','SDSS-II SN 20394',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,328.970333,-1.15317,0.373,NULL,49825674372,778526162,12164471,NULL),(152670,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 21846','RN',152670,38.7,0.58,514,72496,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21846',0.068641,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152671,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152671,36.75,0.19,209,72497,74.2,NULL,'SALT 2','SDSS J215558.49-010413.0',0.07,'2010ApJ...716..712A',2010,1,0.17,NULL,'G',NULL,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,328.99375,-1.07028,0.373,NULL,49825601141,778525017,12164453,18),(152672,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on','R',152672,37.09,0.15,262,72497,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J215558.49-010413.0',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152673,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16333','R',152673,37.33,0.2,274,72497,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006on','SDSS J215558.49-010413.0',0.07,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152674,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on','R',152674,37.19,0.11,274,72497,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J215558.49-010413.0',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152675,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152675,37.35,0.18,276,72497,70,NULL,'SALT 2','SDSS J215558.49-010413.0',0.07,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152676,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152676,37.43,0.19,286,72497,73.8,NULL,'SALT 2 (SNANA)','SDSS J215558.49-010413.0',0.0679,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152677,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152677,37.47,0.21,291,72497,65,NULL,'MLCS31','SDSS J215558.49-010413.0',0.07,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152678,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16333','R',152678,37.5,0.07,296,72497,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006on','SDSS J215558.49-010413.0',0.07,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152679,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152679,37.58,0.18,306,72497,65,NULL,'MLCS17','SDSS J215558.49-010413.0',0.07,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152680,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152680,37.59,0.16,308,72497,65,NULL,'SALT','SDSS J215558.49-010413.0',0.07,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152681,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152681,37.6,0.2,309,72497,65,NULL,'SALT2','SDSS J215558.49-010413.0',0.07,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152682,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006on',NULL,152682,37.98,0.06,368,72497,70,NULL,'SALT 2','SDSS J215558.49-010413.0',0.07,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152683,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152683,36.77,0.56,226,72498,70,NULL,NULL,'2MASX J21555881-4635386',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000113,NULL,'15.0r',0.4,'E',NULL,NULL,NULL,NULL,1,328.995041667,-46.59403,0,NULL,50644598946,791321858,12364404,15),(152684,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152684,34.42,0.8,76.5,72499,75,NULL,'W91PP, r','UGC 11852',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.72',0.7,'SBa?           HII',NULL,NULL,NULL,NULL,1,328.997125,27.89842,0.353,NULL,55579473280,868429270,13569207,14.72),(152685,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152685,33.85,0.69,59,72499,100,NULL,'mid-IR','UGC 11852',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152686,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152686,34.33,0.38,73.3,72499,75,NULL,'W91PP, r, raw','UGC 11852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152687,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152687,34.51,0.38,79.9,72499,75,NULL,'W91PP, r, inv','UGC 11852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152688,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152688,34.55,0.38,81.4,72499,75,NULL,'W91PP, r, cor','UGC 11852',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152689,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152689,34.63,0.4,84.3,72499,NULL,NULL,'mean','UGC 11852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152690,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152690,34.66,0.47,85.4,72499,NULL,NULL,'H','UGC 11852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152691,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152691,34.73,0.45,88.1,72499,NULL,NULL,'K','UGC 11852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152692,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152692,34.78,0.46,90.5,72499,NULL,NULL,'J','UGC 11852',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152693,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152693,35.69,0.51,138,72500,70,NULL,NULL,'IC 1410',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.000093,NULL,'15.94',0.52,NULL,NULL,NULL,NULL,NULL,1,329.008917,-2.90028,0.285,NULL,49826364015,778536937,12164639,15.94),(152694,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152694,37.48,0.46,313,72501,70,NULL,NULL,'2MASX J21560322-0803109',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000097,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,329.013416667,-8.05308,0.037,NULL,49928620428,780134694,12189604,17.3),(152695,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152695,31.65,0.65,21.4,72502,95,NULL,'Weighted Mean','NGC 7155',NULL,'1984ApJS...56...91D',1984,1,2.2,'SGC and ESO misidentify IC 5143.','G',0.000083,NULL,'13.1',1.8,'SB(r)0^0','in a triple',NULL,NULL,NULL,1,329.040541667,-49.52194,0,NULL,50665028610,791641072,12369391,13.1),(152696,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152696,33.02,0.81,40.2,72502,55,NULL,'Visvanathan & Sandage 1979','NGC 7155',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152697,'Tertiary','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152697,31.55,0.71,20.4,72502,95,NULL,NULL,'NGC 7155',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152698,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152698,31.86,0.8,23.5,72502,75,NULL,'B','NGC 7155',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152699,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03077','RN',152699,39.94,0.19,780,72503,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03077',0.2455,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152700,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03077','RN',152700,40,0.1,804,72503,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03077',0.2455,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152701,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152701,34.68,0.69,86.3,72504,100,NULL,'mid-IR','CGCG 377-004',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000107,NULL,'14.7',0.4,NULL,NULL,NULL,NULL,NULL,1,329.062375,2.17261,0.165,NULL,52191123597,815486306,12741973,14.7),(152702,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152702,34.87,0.36,94.1,72504,NULL,NULL,NULL,'CGCG 377-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152703,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152703,34.91,0.2,95.9,72504,74.4,NULL,NULL,'CGCG 377-004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152704,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152704,35.18,0.31,109,72504,NULL,NULL,'Malmquist cor.','CGCG 377-004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152705,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152705,36.33,0.55,185,72505,70,NULL,NULL,'2MASX J21561642-5704019',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.33',0.38,NULL,NULL,NULL,NULL,NULL,1,329.068375,-57.06722,0,NULL,48721012910,761265826,11894778,16.33),(152706,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152706,36.86,0.1,235,72506,70,NULL,NULL,'2MASX J21561816-0749268',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00005,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,329.075625,-7.82397,0.049,NULL,49925088202,780079503,12188742,17.5),(152707,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152707,33.62,0.2,53,72507,74.4,NULL,NULL,'UGC 11853',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000017,NULL,'14.91',0.8,'SB(s)c',NULL,NULL,NULL,NULL,1,329.0764583,-1.17353,0.373,NULL,49825648933,778525764,12164465,14.91),(152708,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152708,30.79,0.4,14.4,72508,NULL,NULL,NULL,'UGC 11861',NULL,'2009AJ....138..323T',2009,1,3.5,NULL,'G',0.000013,NULL,'14.2',2.6,'SABdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,329.1,73.26072,1.813,NULL,52787426890,824803545,12887555,14.2),(152709,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152709,31.97,0.4,24.7,72508,75,NULL,'B','UGC 11861',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152710,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152710,34.33,0.8,73.4,72509,75,NULL,'W91PP, r','UGC 11855',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.49',0.3,'Sbc',NULL,NULL,NULL,NULL,1,329.108125,30.78761,0.457,NULL,55570756617,868293072,13567079,15.49),(152711,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152711,34.28,0.38,71.7,72509,75,NULL,'W91PP, r, raw','UGC 11855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152712,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152712,34.47,0.47,78.2,72509,NULL,NULL,'H','UGC 11855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152713,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152713,34.49,0.49,78.9,72509,75,NULL,'IR','UGC 11855',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152714,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152714,34.5,0.38,79.4,72509,75,NULL,'W91PP, r, inv','UGC 11855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152715,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152715,34.5,0.45,79.6,72509,NULL,NULL,'K','UGC 11855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152716,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152716,34.51,0.38,79.7,72509,75,NULL,'W91PP, r, cor','UGC 11855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152717,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152717,34.52,0.4,80.3,72509,NULL,NULL,'mean','UGC 11855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152718,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152718,34.62,0.46,83.9,72509,NULL,NULL,'J','UGC 11855',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152719,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152719,34.75,0.2,89.1,72509,74.4,NULL,NULL,'UGC 11855',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152720,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152720,34.77,0.37,90,72509,NULL,NULL,'Malmquist cor.','UGC 11855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152721,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152721,34.91,0.34,96.1,72509,NULL,NULL,NULL,'UGC 11855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152722,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152722,37,0.46,251,72510,70,NULL,NULL,'2MASX J21562643-0909466',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,329.11025,-9.16314,0.089,NULL,49917756879,779964951,12186952,17.6),(152723,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152723,35.32,0.51,116,72511,70,NULL,NULL,'2MASX J21563230-5353560',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000103,NULL,'14.0r',0.33,'E',NULL,NULL,NULL,NULL,1,329.13475,-53.89883,0,NULL,50625324575,791020696,12359698,14),(152724,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152724,35.02,0.59,101,72512,70,NULL,NULL,'AM 2153-554 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.64',0.55,'SA(rl)0^+',NULL,NULL,NULL,NULL,1,329.152667,-55.55447,0,NULL,48712523075,761133173,11892705,15.64),(152725,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152725,36.48,0.46,198,72513,70,NULL,NULL,'2MASX J21563744+0057156',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,329.155916667,0.95433,0.165,NULL,52192711932,815511123,12742361,17.7),(152726,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152726,36.86,0.1,235,72514,70,NULL,NULL,'2MASX J21564310-0732595',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000067,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,329.1797083,-7.54997,0.065,NULL,49923768205,780058878,12188419,16.4),(152727,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152727,37.15,0.27,269,72515,70,NULL,NULL,'2MASX J21564374-0654115',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,329.182375,-6.90317,0.065,NULL,49921998699,780031229,12187987,16.8),(152728,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152728,38.62,0.46,530,72516,70,NULL,NULL,'SDSS J215645.23-092035.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,329.188458333,-9.34311,0.097,NULL,49917971860,779968310,12187004,18.7),(152729,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152729,37.15,0.27,269,72517,70,NULL,NULL,'2MASX J21564677-0656505',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000103,NULL,'16.0g',0.35,'AGN',NULL,NULL,NULL,NULL,1,329.194833,-6.94733,0.065,NULL,49921993944,780031155,12187986,16),(152730,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152730,37.4,0.46,302,72518,70,NULL,NULL,'SDSS J215646.92-003123.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,329.1955,-0.52308,0.253,NULL,49825436941,778522452,12164413,18.4),(152731,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005ei',NULL,152731,38.19,0.12,385,72519,74.2,NULL,'SALT 2','SDSS J215647.63+001901.3',0.128,'2010ApJ...716..712A',2010,1,0.14,NULL,'G',NULL,NULL,'20.1g',0.05,NULL,NULL,NULL,NULL,NULL,1,329.1985,0.31706,0.181,NULL,52191844330,815497567,12742149,20.1),(152732,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005ei',NULL,152732,38.93,0.14,541,72519,70,NULL,'SDSS-II SN 00744, SALT 2','SDSS J215647.63+001901.3',0.128,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152733,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 00744','R',152733,38.97,0.19,555,72519,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ei','SDSS J215647.63+001901.3',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152734,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005ei',NULL,152734,39.05,0.05,572,72519,70,NULL,'SDSS-II SN 00744','SDSS J215647.63+001901.3',0.128,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152735,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 00744','R',152735,39.2,0.1,617,72519,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ei','SDSS J215647.63+001901.3',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152736,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152736,36.64,0.63,212,72520,70,NULL,NULL,'2MASX J21564784-1159487',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.35',0.19,NULL,NULL,NULL,NULL,NULL,1,329.199417,-11.99683,0.077,NULL,49899888919,779685764,12182590,16.35),(152737,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152737,34.71,0.51,87.5,72521,70,NULL,NULL,'LCRS B215340.0-450417',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.000093,NULL,'13.8r',0.68,'(R)S0^+',NULL,NULL,NULL,NULL,1,329.199833,-44.83342,0,NULL,50645310678,791332979,12364577,13.8),(152738,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152738,36.86,0.1,235,72522,70,NULL,NULL,'2MASX J21565004-0748425',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,329.2084583,-7.81183,0.049,NULL,49925119695,780079995,12188749,17.5),(152739,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152739,37.89,0.46,378,72523,70,NULL,NULL,'2MASX J21565061-0715535',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000168,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,329.2109583,-7.26478,0.069,NULL,49923785229,780059144,12188424,17.2),(152740,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152740,35.98,0.59,157,72524,70,NULL,NULL,'2MASX J21565153-1126315',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,329.214833333,-11.44217,0.081,NULL,49916552899,779946139,12186658,15.7),(152741,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152741,35.45,0.2,123,72525,74.4,NULL,NULL,'UGC 11857',NULL,'2013AJ....146...86T',2013,1,0.95,NULL,'G',0.000103,NULL,'15.2g',0.52,'SB?',NULL,NULL,NULL,NULL,1,329.219625,12.31611,0.305,NULL,52231850383,816122662,12751916,15.2),(152742,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152742,35.2,0.51,109,72526,70,NULL,NULL,'2MASX J21565444-5539422',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'14.5r',0.5,'E',NULL,NULL,NULL,NULL,1,329.2269583,-55.66181,0,NULL,48711664895,761119763,11892496,14.5),(152743,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152743,37.15,0.27,269,72527,70,NULL,NULL,'2MASX J21565690-0657514',NULL,'2015arXiv151105856S',2015,1,0.24,'Star 11\\\" east of the nucleus.','G',0.000172,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,329.2372083,-6.96425,0.065,NULL,49923890067,780060782,12188449,17.2),(152744,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152744,35.87,0.49,149,72528,70,NULL,NULL,'2MASX J21565707-6847095',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.13',0.4,'S0',NULL,NULL,NULL,NULL,1,329.237667,-68.78592,0.021,NULL,49309068016,770454187,12038346,16.13),(152745,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152745,36.86,0.1,235,72529,70,NULL,NULL,'SDSS J215657.90-075149.0',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000057,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,329.2412917,-7.86364,0.049,NULL,49925101144,780079705,12188745,17.9),(152746,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152746,37.18,0.46,272,72530,70,NULL,NULL,'2MASX J21570049-0803124',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000073,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,329.252,-8.05356,0.069,NULL,49925310815,780082981,12188796,16.7),(152747,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152747,36.86,0.1,235,72531,70,NULL,NULL,'2MASX J21570123-0754154',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000063,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,329.255125,-7.90425,0.069,NULL,49925108676,780079823,12188747,16.5),(152748,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152748,36.86,0.1,235,72532,70,NULL,NULL,'2MASX J21570170-0750224',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00008,NULL,'15.3g',0.58,'cD;BrClG',NULL,NULL,NULL,NULL,1,329.257167,-7.83958,0.049,NULL,49925099848,780079685,12188745,15.3),(152749,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152749,35.75,0.59,141,72533,70,NULL,NULL,'2MASX J21570186-7127556',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'14.6r',0.43,'S0',NULL,NULL,NULL,NULL,1,329.257625,-71.46547,0.025,NULL,49307528263,770430129,12037970,14.6),(152750,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152750,37.93,0.12,350,72534,74.2,NULL,'SALT 2','SDSS J215704.19-001324.4',0.1,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0005,NULL,'19.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,329.267458333,-0.22344,0.237,NULL,49821019219,778453425,12163334,19.8),(152751,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152751,38.23,0.06,442,72534,70,NULL,'Hubble residual 0.03 for z0.10760','SDSS J215704.19-001324.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152752,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03256','R',152752,38.57,0.18,468,72534,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hn','SDSS J215704.19-001324.4',0.1076,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152753,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152753,38.57,0.12,471,72534,70,NULL,'SDSS-II SN 03256, SALT 2','SDSS J215704.19-001324.4',0.1,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152754,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03256','R',152754,38.62,0.09,479,72534,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hn','SDSS J215704.19-001324.4',0.1076,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152755,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152755,38.62,0.14,482,72534,65,NULL,'SALT2','SDSS J215704.19-001324.4',0.1,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152756,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152756,38.46,0.07,492,72534,70,NULL,'SALT 2','SDSS J215704.19-001324.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152757,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152757,38.47,0.07,494,72534,70,NULL,'SALT 2, Malmquist cor.','SDSS J215704.19-001324.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152758,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152758,38.69,0.05,498,72534,70,NULL,'SDSS-II SN 03256','SDSS J215704.19-001324.4',0.1,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152759,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005hn',NULL,152759,38.73,0.11,506,72534,65,NULL,'MLCS2k2','SDSS J215704.19-001324.4',0.1,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152760,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152760,35.18,0.45,109,72535,NULL,NULL,'K','ESO 075- G 041',NULL,'2007A&A...465...71T',2007,1,1.6,'Mulchaey, et al (1996, ApJS, 102, 309) say this is not a Seyfert.','G',0.000103,NULL,'14.3',0.8,'SA0-;Radio gal;Sy2',NULL,NULL,'radio jet','Sy 1',1,329.274917,-69.68992,0,NULL,49302267318,770347926,12036686,14.3),(152761,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152761,35.28,0.4,114,72535,NULL,NULL,'mean','ESO 075- G 041',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152762,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152762,32.61,0.8,33.3,72536,75,NULL,'MAT, I','ESO 404- G 012',NULL,'1997ApJS..109..333W',1997,1,2.3,'Confused HIPASS source','G',0.00001,NULL,'12.1r',1.8,'SAB(r)c        HII','in a pair',NULL,NULL,NULL,1,329.279958333,-34.58222,0,NULL,50559966876,789999482,12343741,12.1),(152763,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152763,32.61,0.06,33.3,72536,NULL,NULL,NULL,'ESO 404- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152764,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152764,32.75,0.43,35.4,72536,75,NULL,'MAT, I, raw','ESO 404- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152765,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152765,32.77,0.4,35.9,72536,NULL,NULL,'mean','ESO 404- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152766,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152766,32.83,0.45,36.8,72536,NULL,NULL,'K','ESO 404- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152767,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152767,32.84,0.47,36.9,72536,NULL,NULL,'H','ESO 404- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152768,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152768,32.88,0.32,37.6,72536,85,NULL,'I, raw','ESO 404- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152769,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152769,32.88,0.46,37.6,72536,NULL,NULL,'J','ESO 404- G 012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152770,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152770,32.9,0.4,38,72536,NULL,NULL,NULL,'ESO 404- G 012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152771,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152771,32.92,0.32,38.4,72536,85,NULL,'I, inv','ESO 404- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152772,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152772,32.92,0.43,38.4,72536,75,NULL,'MAT, I, cor','ESO 404- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152773,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152773,32.95,0.43,38.8,72536,75,NULL,'MAT, I, inv','ESO 404- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152774,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152774,33.17,NULL,43.1,72536,NULL,NULL,'I','ESO 404- G 012',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152775,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152775,33.41,NULL,48.1,72536,NULL,NULL,'B','ESO 404- G 012',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152776,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152776,36.86,0.1,235,72537,70,NULL,NULL,'2MASX J21570908-0722053',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000164,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,329.287958333,-7.36825,0.069,NULL,49923793209,780059268,12188426,17.5),(152777,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16111',NULL,152777,39.58,0.27,824,72538,70,NULL,'SN photometric redshift distance, z photo =0.215 +/- 0.033','SDSS-II SN 16111',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,329.316916667,0.93544,0.165,NULL,52192816049,815512750,12742386,NULL),(152778,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152778,36.86,0.1,235,72539,70,NULL,NULL,'SDSS J215717.31-074849.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000057,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,329.322125,-7.81378,0.069,NULL,49923255059,780050860,12188294,17.7),(152779,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152779,36.86,0.1,235,72540,70,NULL,NULL,'2MASX J21571914-0800453',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000077,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,329.3299583,-8.01275,0.069,NULL,49925277077,780082454,12188788,16.3),(152780,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152780,37.28,0.33,286,72541,70,NULL,NULL,'2MASX J21571935-0703303',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000103,NULL,'16.5g',0.33,'BrClG',NULL,NULL,NULL,NULL,1,329.330625,-7.05836,0.069,NULL,49923945057,780061641,12188463,16.5),(152781,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152781,36.86,0.1,235,72542,70,NULL,NULL,'2MASX J21572142-0748473',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000063,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,329.3392083,-7.81303,0.069,NULL,49923256389,780050881,12188295,16.4),(152782,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152782,36.86,0.1,235,72543,70,NULL,NULL,'2MASX J21572341-0758143',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000083,NULL,'16.0g',0.37,'E0',NULL,NULL,NULL,NULL,1,329.3475417,-7.97056,0.069,NULL,49925098774,780079668,12188744,16),(152783,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152783,37.28,0.33,286,72544,70,NULL,NULL,'SDSS J215724.40-070246.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000138,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,329.3517083,-7.04639,0.065,NULL,49923939963,780061561,12188461,18.6),(152784,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152784,36.86,0.1,235,72545,70,NULL,NULL,'SDSS J215725.63-074926.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,329.3567917,-7.82406,0.069,NULL,49923256914,780050889,12188295,18.4),(152785,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15928','RN',152785,40.92,0.21,1280,72546,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15928',0.192202,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152786,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15928','RN',152786,40.99,0.15,1330,72546,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15928',0.192202,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152787,'BCG','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152787,37.68,0.35,325,72547,60,NULL,NULL,'ABELL 2399',0.0587,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,329.3575,-7.79472,0.073,NULL,49923249330,780050770,12188293,NULL),(152788,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152788,36.9,0.37,240,72547,72,NULL,NULL,'ABELL 2399',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152789,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152789,37.07,0.22,260,72547,72,NULL,'MASS PLANE','ABELL 2399',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152790,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05627','RN',152790,42.86,0.19,2800,72548,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05627',0.331062,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152791,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05627','RN',152791,42.93,0.23,2890,72548,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05627',0.331062,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152792,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152792,36.86,0.1,235,72549,70,NULL,NULL,'2MASX J21572630-0751383',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000087,NULL,'16.8g',0.26,NULL,NULL,NULL,NULL,NULL,1,329.359667,-7.8605,0.069,NULL,49923260355,780050943,12188295,16.8),(152793,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 06987','RN',152793,42.65,0.36,2620,72550,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06987',0.2943,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152794,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152794,36.37,0.58,188,72551,70,NULL,NULL,'2MASX J21572885-5626503',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.1r',0.31,NULL,NULL,NULL,NULL,NULL,1,329.370167,-56.44736,0,NULL,48719231498,761237992,11894343,15.1),(152795,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152795,36.86,0.1,235,72552,70,NULL,NULL,'2MASX J21572939-0747443',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.0001,NULL,'15.6g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,329.372583,-7.79572,0.073,NULL,49923249776,780050777,12188293,15.6),(152796,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393',NULL,152796,39.72,0.77,877,72553,70,NULL,'SN photometric redshift distance, z photo =0.231 +/- 0.120','SDSS-II SN 17393',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,329.377583,-0.9285,0.329,NULL,49826180568,778534071,12164594,21.2),(152797,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393','R',152797,40.21,0.29,905,72553,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17393',0.2174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152798,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393',NULL,152798,39.95,0.17,977,72553,70,NULL,'SALT 2','SDSS-II SN 17393',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152799,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393',NULL,152799,39.97,0.17,986,72553,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17393',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152800,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17393','R',152800,40.47,0.23,1020,72553,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17393',0.2174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152801,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 14315','RN',152801,42.57,0.54,2940,72554,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14315',0.11003,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152802,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 14315','RN',152802,45.23,0.82,10000,72554,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14315',0.11003,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152803,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152803,34.58,0.54,82.5,72555,70,NULL,NULL,'2MASX J21573337-1402227',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.88',NULL,NULL,NULL,NULL,NULL,NULL,1,329.389,-14.03969,0.069,NULL,49779604440,777806319,12153223,14.88),(152804,'BCG','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152804,37.68,0.35,325,72556,60,NULL,'ABELL 2399, BCG','2MASX J21573344-0747393',0.0587,'1980ApJ...241..486H',1980,1,0.55,NULL,'G',0.00009,NULL,'15.7g',0.48,'E0','Brightest group member',NULL,NULL,NULL,1,329.389458333,-7.79422,0.073,NULL,49923248390,780050756,12188293,15.7),(152805,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152805,36.86,0.1,235,72556,70,NULL,NULL,'2MASX J21573344-0747393',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152806,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152806,36.9,0.37,240,72556,72,NULL,'ABELL 2399, BCG','2MASX J21573344-0747393',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152807,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152807,37.07,0.22,260,72556,72,NULL,'MASS PLANE, ABELL 2399, BCG','2MASX J21573344-0747393',NULL,'2015MNRAS.451.2723S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152808,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02502','RN',152808,37.92,0.21,315,72557,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02502',0.218529,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152809,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152809,34.9,NULL,95.5,72558,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 344- G 002',NULL,'2010Ap&SS.325..163P',2010,1,1.17,NULL,'G',0.000033,NULL,'15.4r',0.14,'Sc',NULL,NULL,NULL,NULL,1,329.423875,-40.41836,0,NULL,50670464483,791726007,12370718,15.4),(152810,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152810,34.92,NULL,96.2,72558,NULL,NULL,'Dipole + Quadrupole','ESO 344- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152811,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152811,34.93,NULL,97,72558,NULL,NULL,'Dipole','ESO 344- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152812,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152812,34.96,NULL,98.1,72558,NULL,NULL,NULL,'ESO 344- G 002',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152813,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152813,34.97,0.49,98.7,72558,75,NULL,'IR','ESO 344- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152814,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152814,35.13,0.64,106,72558,NULL,NULL,NULL,'ESO 344- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152815,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152815,35.17,0.2,108,72558,74.4,NULL,NULL,'ESO 344- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152816,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152816,35.28,0.59,114,72558,NULL,NULL,'Malmquist cor.','ESO 344- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152817,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152817,37.97,0.46,393,72559,70,NULL,NULL,'SDSS J215741.77-070229.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000149,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,329.424041667,-7.04164,0.065,NULL,49924629497,780072335,12188630,18.9),(152818,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152818,35.58,0.48,131,72560,70,NULL,NULL,'2MASX J21574207-1622507',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.40',0.4,NULL,NULL,NULL,NULL,NULL,1,329.42525,-16.38061,0.089,NULL,49785130792,777892668,12154572,15.4),(152819,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152819,34.18,NULL,68.4,72561,NULL,NULL,'Dipole','UGC 11862',NULL,'2010Ap&SS.325..163P',2010,1,1.99,NULL,'G',0.000017,NULL,'16.5',0.26,'Sd',NULL,NULL,NULL,NULL,1,329.4297083,38.93508,1.009,NULL,55468037287,866688082,13542001,16.5),(152820,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152820,34.18,NULL,68.7,72561,NULL,NULL,'Dipole + Quadrupole','UGC 11862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152821,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152821,34.19,NULL,68.8,72561,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11862',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152822,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152822,34.46,0.43,78.1,72561,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11862',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152823,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152823,34.73,0.49,88.2,72561,75,NULL,'IR','UGC 11862',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152824,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152824,36.86,0.1,235,72562,70,NULL,NULL,'2MASX J21574316-0723472',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000103,NULL,'16.1g',0.36,'S0',NULL,NULL,NULL,NULL,1,329.429875,-7.39653,0.069,NULL,49924004769,780062574,12188477,16.1),(152825,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152825,36.86,0.1,235,72563,70,NULL,NULL,'2MASX J21574326-0745452',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000073,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,329.430167,-7.76253,0.073,NULL,49923269564,780051086,12188298,16.3),(152826,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03257','RN',152826,42.79,0.41,2700,72564,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03257',0.334896,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152827,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03257','RN',152827,42.84,0.42,2770,72564,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03257',0.334896,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152828,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152828,36.62,0.51,211,72565,70,NULL,NULL,'2MASX J21574748-1246347',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000147,NULL,'15.48',0.7,NULL,NULL,NULL,NULL,NULL,1,329.447625,-12.77617,0.133,NULL,49769753357,777652396,12150818,15.48),(152829,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152829,36.6,0.52,209,72566,70,NULL,NULL,'2MASX J21575064-0429045',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.8R',NULL,NULL,NULL,NULL,NULL,NULL,1,329.461083,-4.48467,0.137,NULL,49888663209,779510362,12179849,13.8),(152830,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03041','RN',152830,41.76,0.21,1740,72567,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03041',0.28914,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152831,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 03041','RN',152831,41.77,0.15,1760,72567,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03041',0.28914,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152832,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152832,34.64,0.46,84.7,72568,70,NULL,NULL,'2MASX J21575345-6950254',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000063,NULL,'14.1r',0.4,'S',NULL,NULL,NULL,NULL,1,329.472666667,-69.84031,0,NULL,49302455678,770350869,12036732,14.1),(152833,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152833,36.86,0.1,235,72569,70,NULL,NULL,'2MASX J21575406-0742068',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00006,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,329.47525,-7.70203,0.073,NULL,49923455871,780053997,12188343,17.3),(152834,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152834,35.06,NULL,103,72570,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 532- G 005',NULL,'2010Ap&SS.325..163P',2010,1,1.18,'Star superposed or knot.','G',0.000053,NULL,'14.9r',0.15,'Sc',NULL,NULL,NULL,NULL,1,329.480667,-22.91864,0.057,NULL,50884286705,795066979,12422921,14.9),(152835,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152835,35.07,NULL,103,72570,NULL,NULL,'Dipole + Quadrupole','ESO 532- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152836,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152836,35.1,NULL,105,72570,NULL,NULL,'Dipole','ESO 532- G 005',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152837,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152837,31.55,0.8,20.4,72571,75,NULL,NULL,'ESO 146- GA002',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.00001,NULL,'14.6',1.3,'IB(s)m',NULL,NULL,NULL,NULL,1,329.4817083,-60.30828,0,NULL,48685044338,760703817,11885997,14.6),(152838,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152838,38.73,0.46,557,72572,70,NULL,NULL,'2MASX J21575682+1128294',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000196,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,329.486708333,11.47481,0.289,NULL,52336722201,817761284,12777520,18.1),(152839,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152839,38.27,0.27,451,72573,70,NULL,NULL,'2MASX J21575736-0841038',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000187,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,329.4890417,-8.6845,0.077,NULL,49925799580,780090618,12188915,17.4),(152840,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152840,33.03,0.8,40.4,72574,75,NULL,'W91PP, r','UGC 11860',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00001,NULL,'16.0',0.6,'Sdm',NULL,NULL,NULL,NULL,1,329.49875,24.26667,0.241,NULL,55097682832,860901294,13451582,16),(152841,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152841,34.03,0.38,64,72574,75,NULL,'W91PP, r, inv','UGC 11860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152842,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152842,34.15,0.38,67.7,72574,75,NULL,'W91PP, r, raw','UGC 11860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152843,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152843,34.38,0.38,75.3,72574,75,NULL,'W91PP, r, cor','UGC 11860',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152844,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152844,37.72,0.46,350,72575,70,NULL,NULL,'2MASX J21580052-0749328',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000077,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,329.502,-7.82581,0.073,NULL,49923476718,780054323,12188348,17.1),(152845,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152845,34.66,0.53,85.7,72576,70,NULL,NULL,'FAIRALL 0122',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'14.7r',0.23,'Bright nucleus',NULL,NULL,NULL,NULL,1,329.518583,-73.01378,0.129,NULL,49297802383,770278162,12035596,14.7),(152846,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152846,38.27,0.27,451,72577,70,NULL,NULL,'SDSS J215805.58-085329.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,329.5232917,-8.89156,0.085,NULL,49925713511,780089273,12188894,18.1),(152847,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152847,34.22,0.27,69.9,72578,NULL,NULL,NULL,'LCSB L0767O',NULL,'2009ApJS..182..474S',2009,1,1.17,NULL,'G',0.000023,NULL,'15.0g',0.41,'Sc',NULL,NULL,NULL,NULL,1,329.5240417,-7.84517,0.073,NULL,49923489001,780054515,12188351,15),(152848,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152848,34.26,0.2,71.1,72578,74.4,NULL,NULL,'LCSB L0767O',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152849,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152849,34.35,0.26,74,72578,NULL,NULL,'Malmquist cor.','LCSB L0767O',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152850,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152850,36.86,0.1,235,72579,70,NULL,NULL,'2MASX J21580665-0806428',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000063,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,329.527625,-8.11178,0.069,NULL,49923333907,780052092,12188313,16.7),(152851,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152851,33.55,NULL,51.4,72580,NULL,NULL,'Dipole','UGC 11859',NULL,'2010Ap&SS.325..163P',2010,1,3.47,'Multiple SDSS entries describe this object.','G',0.000012,NULL,'15.16',0.26,'Sc             HII','Isolated galaxy',NULL,NULL,NULL,1,329.530875,1.00897,0.177,NULL,52192771996,815512062,12742375,15.16),(152852,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152852,33.59,NULL,52.1,72580,NULL,NULL,'Dipole + Quadrupole','UGC 11859',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152853,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152853,33.6,NULL,52.4,72580,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11859',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152854,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152854,33.78,NULL,57.1,72580,NULL,NULL,NULL,'UGC 11859',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152855,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152855,36.86,0.1,235,72581,70,NULL,NULL,'2MASX J21580752-0755458',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.00008,NULL,'16.1g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,329.531291667,-7.92928,0.069,NULL,49923462701,780054104,12188345,16.1),(152856,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152856,38.32,0.46,461,72582,70,NULL,NULL,'2MASX J21581044-0702187',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00017,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,329.543417,-7.03853,0.065,NULL,49924628127,780072314,12188629,17.5),(152857,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152857,33.67,0.69,54.1,72583,100,NULL,'mid-IR','ESO 466-G 024',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.00003,NULL,'13.0r',0.7,'(R\')SA(r)a     HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,329.5435417,-27.39214,0.033,NULL,51421736155,803464627,12554134,13),(152858,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152858,37.13,0.9,266,72584,70,NULL,NULL,'LCRS B215503.3-452033',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.1r',0.38,NULL,NULL,NULL,NULL,NULL,1,329.546791667,-45.10381,0,NULL,50646068174,791344815,12364762,15.1),(152859,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152859,38.27,0.27,451,72585,70,NULL,NULL,'2MASX J21581166-0844457',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000206,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,329.5485417,-8.74622,0.077,NULL,49925670472,780088601,12188884,17.4),(152860,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152860,48.47,1.54,7480,72586,100,NULL,NULL,'GRB 060927',5.6,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,329.5497083,5.36397,0.217,NULL,52315884946,817435702,12772432,NULL),(152861,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152861,48.62,1.47,8030,72586,100,NULL,NULL,'GRB 060927',5.6,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152862,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152862,35.5,0.59,126,72587,70,NULL,NULL,'2MASX J21581454-6938452',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.9b',NULL,NULL,NULL,NULL,NULL,NULL,1,329.5605,-69.64592,0,NULL,49302265765,770347902,12036685,15.9),(152863,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152863,35.2,0.47,110,72588,NULL,NULL,'H','ESO 532- G 006',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000123,NULL,'14.90',0.4,'(R\'_1)SB(r\'l)a HII',NULL,NULL,NULL,NULL,1,329.563458333,-24.88844,0.085,NULL,51406689326,803229520,12550461,14.9),(152864,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152864,35.32,0.45,116,72588,NULL,NULL,'K','ESO 532- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152865,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152865,35.42,0.4,122,72588,NULL,NULL,'mean','ESO 532- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152866,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20578','RN',152866,41.12,0.32,1300,72589,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20578',0.290371,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152867,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20578','RN',152867,41.34,0.23,1440,72589,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20578',0.290371,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152868,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20578','N',152868,40.95,0.19,1550,72589,70,NULL,'SALT 2','SDSS-II SN 20578',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152869,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20578','N',152869,40.97,0.19,1560,72589,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20578',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152870,'Magnitude','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152870,37.09,0.13,262,72590,100,NULL,NULL,'2MASX J21582577-6023286',NULL,'1998A&A...337...31R',1998,1,0.59,NULL,'G',0.00022,NULL,'14.8r',0.28,'E/S0',NULL,NULL,NULL,NULL,1,329.6075,-60.39131,0,NULL,48685181509,760705961,11886030,14.8),(152871,'Magnitude','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152871,37.09,0.13,262,72591,100,NULL,NULL,'ABELL 3825',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'III    [BM];R  [A]',NULL,NULL,NULL,NULL,1,329.613333,-60.39944,0,NULL,48685183899,760705998,11886031,NULL),(152872,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152872,37.8,0.33,362,72592,70,NULL,NULL,'2MASX J21583578-0740079',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,329.64925,-7.66875,0.057,NULL,49923418080,780053407,12188334,17.9),(152873,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152873,36.95,0.57,246,72593,70,NULL,NULL,'2MASX J21583729-1207542',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.96',0.17,NULL,NULL,NULL,NULL,NULL,1,329.655417,-12.13186,0.077,NULL,49916415313,779943989,12186624,16.96),(152874,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152874,37.06,0.46,258,72594,70,NULL,NULL,'2MASX J21583900+0103492',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000143,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,329.662583333,1.06367,0.177,NULL,52192260512,815504070,12742251,17.6),(152875,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152875,37.7,0.46,347,72595,70,NULL,NULL,'2MASX J21583940-0722299',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,329.66425,-7.37503,0.073,NULL,49923842491,780060038,12188438,17.3),(152876,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152876,37.86,0.46,373,72596,70,NULL,NULL,'2MASX J21583982-0748259',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000083,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,329.666083,-7.80731,0.073,NULL,49923403214,780053175,12188330,17.1),(152877,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05793','RN',152877,41.4,0.19,1400,72597,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05793',0.357335,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152878,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152878,36.51,0.65,200,72598,70,NULL,NULL,'2MASX J21584349-1956463',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.6r',0.29,'S0',NULL,NULL,NULL,NULL,1,329.681125,-19.94625,0.049,NULL,50875137348,794924021,12420687,15.6),(152879,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152879,37.4,0.56,302,72599,70,NULL,NULL,'2MASX J21584357-0423154',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.45',NULL,NULL,NULL,NULL,NULL,NULL,1,329.6817083,-4.38769,0.169,NULL,49818115286,778408051,12162625,16.45),(152880,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152880,37.2,0.46,276,72600,70,NULL,NULL,'2MASX J21584365-0910068',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,329.681875,-9.16869,0.085,NULL,49917537370,779961521,12186898,16.6),(152881,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02503','RN',152881,42.63,0.21,2120,72601,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02503',0.589348,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152882,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15132','R',152882,39.43,0.18,672,72602,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jt','SDSS-II SN 15132 HOST',0.144,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,329.6999583,0.19878,0.181,NULL,52183524062,815367563,12740118,NULL),(152883,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15132','R',152883,39.71,0.08,765,72602,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jt','SDSS-II SN 15132 HOST',0.144,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152884,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006jt',NULL,152884,39.42,0.07,766,72602,70,NULL,'SALT 2','SDSS-II SN 15132 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152885,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006jt',NULL,152885,39.42,0.07,766,72602,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15132 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152886,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006jt',NULL,152886,38.97,0.13,623,72603,70,NULL,'Hubble residual 0.18 for z0.14400','SDSS-II SN 15132 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,329.6999583,0.19878,0.181,NULL,52183524062,815367563,12740118,NULL),(152887,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 19465',NULL,152887,40.1,0.22,1050,72604,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.036','SDSS-II SN 19465',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,329.7062917,-0.85794,0.225,NULL,49825788972,778527952,12164499,NULL),(152888,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152888,46.24,0.55,4340,72605,69.7,NULL,'Calibrated','GRB 060607A',3.08,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,329.71,-22.49631,0.057,NULL,50883937342,795061520,12422836,NULL),(152889,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152889,46.3,0.66,4460,72605,NULL,NULL,NULL,'GRB 060607A',3.08,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152890,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152890,46.33,0.58,4520,72605,72,NULL,NULL,'GRB 060607A',3.08,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152891,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152891,46.48,0.59,4850,72605,70,NULL,NULL,'GRB 060607A',3.08,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152892,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152892,46.68,0.58,5310,72605,69.7,NULL,'Fiducial','GRB 060607A',3.08,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152893,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152893,49.43,1.73,18900,72605,69.7,NULL,'Fiducial','GRB 060607A',3.08,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152894,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152894,38.53,0.33,508,72606,70,NULL,NULL,'2MASX J21585067+0001275',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000144,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,329.71125,0.02431,0.181,NULL,52183501479,815367210,12740112,18.8),(152895,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152895,38.64,0.46,533,72607,70,NULL,NULL,'SDSS J215850.81-080752.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000146,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,329.711708333,-8.13136,0.069,NULL,49923318578,780051852,12188310,18.8),(152896,'GeV TeV ratio','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152896,38.46,NULL,492,72608,72,NULL,NULL,'[HB89] 2155-304',NULL,'2010MNRAS.405L..76P',2010,1,NULL,NULL,'QSO',0.002,NULL,'14.',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,329.7169583,-30.22558,0,NULL,51414449339,803350770,12552355,14),(152897,'GeV TeV ratio','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152897,39.56,0.09,817,72608,72,NULL,NULL,'[HB89] 2155-304',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152898,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152898,38.53,0.33,508,72609,70,NULL,NULL,'2MASX J21585316+0000423',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000204,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,329.7214583,0.01175,0.181,NULL,52183502114,815367220,12740112,17.1),(152899,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152899,33.96,0.8,61.9,72610,75,NULL,'CF, r','UGC 11867',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00002,NULL,'15.10',0.5,'Sbc',NULL,NULL,NULL,NULL,1,329.72475,-1.98931,0.257,NULL,49828309734,778567339,12165114,15.1),(152900,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152900,33.88,0.38,59.7,72610,75,NULL,'CF, r, raw','UGC 11867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152901,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152901,33.88,0.2,59.7,72610,74.4,NULL,NULL,'UGC 11867',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152902,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152902,33.9,0.65,60.4,72610,NULL,NULL,'Malmquist cor.','UGC 11867',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152903,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152903,33.92,0.38,60.8,72610,75,NULL,'CF, r, inv','UGC 11867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152904,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152904,34,0.62,63,72610,NULL,NULL,NULL,'UGC 11867',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152905,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152905,34.06,0.38,65,72610,75,NULL,'CF, r, cor','UGC 11867',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152906,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152906,34.17,0.8,68.1,72611,75,NULL,'MAT, I','IC 5149',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'14.41',0.5,'(R\')Sa','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,329.746,-27.41392,0.033,NULL,51421721208,803464393,12554131,14.41),(152907,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152907,34.41,0.43,76.1,72611,75,NULL,'MAT, I, raw','IC 5149',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152908,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152908,34.45,0.32,77.7,72611,85,NULL,'I, raw','IC 5149',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152909,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152909,34.51,0.32,79.7,72611,85,NULL,'I, inv','IC 5149',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152910,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152910,34.57,0.2,82,72611,74.4,NULL,NULL,'IC 5149',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152911,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152911,34.66,0.43,85.3,72611,75,NULL,'MAT, I, inv','IC 5149',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152912,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152912,34.68,0.43,86.2,72611,75,NULL,'MAT, I, cor','IC 5149',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152913,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20095','RN',152913,43.69,0.35,3710,72612,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20095',0.47278,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152914,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152914,31.18,0.8,17.2,72613,75,NULL,NULL,'UGC 11868',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000017,NULL,'14.04',1.6,'SB(s)m',NULL,NULL,NULL,NULL,1,329.769541667,18.17744,0.261,NULL,52269998206,816718721,12761230,14.04),(152915,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152915,38.21,0.46,439,72614,70,NULL,NULL,'2MASX J21590583-0103349',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.58',0.18,NULL,NULL,NULL,NULL,NULL,1,329.774417,-1.05967,0.241,NULL,49825818794,778528418,12164506,18.58),(152916,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152916,35.92,0.7,152,72615,70,NULL,NULL,'2MASX J21590629-6938410',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.40',0.2,NULL,NULL,NULL,NULL,NULL,1,329.776375,-69.64469,0,NULL,49302248865,770347638,12036681,17.4),(152917,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05630','RN',152917,38.21,0.49,388,72616,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05630',0.131692,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152918,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 05630','RN',152918,38.53,0.4,449,72616,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05630',0.131692,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152919,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152919,37.28,0.46,286,72617,70,NULL,NULL,'2MASX J21590897-0658506',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000103,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,329.7874583,-6.98083,0.089,NULL,49924591055,780071735,12188620,16.5),(152920,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152920,37.8,0.33,362,72618,70,NULL,NULL,'SDSS J215911.29-073830.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000137,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,329.797083,-7.64183,0.057,NULL,49923361415,780052522,12188320,18.3),(152921,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152921,35.83,0.54,147,72619,70,NULL,NULL,'2MASX J21591191-1526016',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.40',NULL,'poss. LINER',NULL,NULL,NULL,NULL,1,329.799541667,-15.434,0.085,NULL,49793560346,778024380,12156630,15.4),(152922,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152922,34.4,0.8,76,72620,75,NULL,'MAT, I','ESO 466- G 028',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'14.1r',0.5,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,329.805583,-28.69006,0.045,NULL,51416960785,803390012,12552968,14.1),(152923,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152923,33.95,0.32,61.8,72620,85,NULL,'I, raw','ESO 466- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152924,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152924,33.98,0.32,62.6,72620,85,NULL,'I, inv','ESO 466- G 028',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152925,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152925,34.04,0.43,64.3,72620,75,NULL,'MAT, I, raw','ESO 466- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152926,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152926,34.19,0.43,68.8,72620,75,NULL,'MAT, I, inv','ESO 466- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152927,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152927,34.29,0.43,72.3,72620,75,NULL,'MAT, I, cor','ESO 466- G 028',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152928,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152928,34.38,0.2,75.2,72620,74.4,NULL,NULL,'ESO 466- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152929,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152929,34.46,0.49,77.9,72620,75,NULL,'IR','ESO 466- G 028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152930,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152930,34.47,0.44,78.2,72620,NULL,NULL,'Malmquist cor.','ESO 466- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152931,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152931,34.61,0.41,83.4,72620,NULL,NULL,NULL,'ESO 466- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152932,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 01132','RN',152932,42.03,0.2,1870,72621,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01132',0.359774,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152933,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 01132','RN',152933,42.06,0.13,1900,72621,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01132',0.359774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152934,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17394','RN',152934,39.86,0.14,848,72622,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17394',0.107332,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152935,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17394','RN',152935,40.07,0.21,933,72622,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17394',0.107332,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152936,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152936,32.7,0.8,34.7,72623,75,NULL,'MAT, I','NGC 7163',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'13.76',1.1,'SB?(r)b?       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,329.835167,-31.88317,0,NULL,51459979539,804062180,12563471,13.76),(152937,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152937,31.66,0.32,21.5,72623,85,NULL,'I, raw','NGC 7163',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152938,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152938,31.67,0.32,21.6,72623,85,NULL,'I, inv','NGC 7163',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152939,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152939,31.95,0.43,24.5,72623,75,NULL,'MAT, I, raw','NGC 7163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152940,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152940,32.01,0.43,25.2,72623,75,NULL,'MAT, I, inv','NGC 7163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152941,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152941,32.29,0.47,28.7,72623,NULL,NULL,'H','NGC 7163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152942,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152942,32.32,0.43,29.1,72623,75,NULL,'MAT, I, cor','NGC 7163',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152943,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152943,32.34,0.45,29.4,72623,NULL,NULL,'K','NGC 7163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152944,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152944,32.38,0.46,30,72623,NULL,NULL,'J','NGC 7163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152945,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152945,32.53,0.09,32.1,72623,NULL,NULL,NULL,'NGC 7163',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152946,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152946,32.68,0.4,34.4,72623,NULL,NULL,'mean','NGC 7163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152947,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152947,36.22,0.58,176,72624,70,NULL,NULL,'2MASX J21592046-5626051',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'14.5r',0.5,'E',NULL,NULL,NULL,NULL,1,329.83525,-56.43483,0,NULL,48719450429,761241412,11894397,14.5),(152948,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152948,38.29,0.46,456,72625,70,NULL,NULL,'SDSS J215920.49-081432.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000144,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,329.835375,-8.24233,0.069,NULL,49923620558,780056571,12188383,18.2),(152949,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152949,38.51,0.46,503,72626,70,NULL,NULL,'2MASX J21592081+0115048',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,329.836667,1.25125,0.161,NULL,52192331841,815505185,12742268,18.2),(152950,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13734',NULL,152950,39.96,1.63,982,72627,70,NULL,'SN photometric redshift distance, z photo =0.263 +/- 0.436','SDSS-II SN 13734',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.6g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,329.8380417,1.01058,0.161,NULL,52184062907,815375982,12740249,22.6),(152951,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13734','R',152951,41.11,0.34,1210,72627,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13734',0.378459,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152952,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 13734','R',152952,41.35,0.39,1350,72627,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13734',0.378459,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152953,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152953,36.78,0.33,227,72628,70,NULL,NULL,'2MASX J21592117-0750484',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'16.1g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,329.838125,-7.84689,0.073,NULL,49923516914,780054951,12188358,16.1),(152954,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152954,37.87,0.58,375,72628,70,NULL,NULL,'2MASX J21592117-0750484',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152955,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02063','R',152955,40,0.09,837,72629,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02063',0.192931,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,329.849125,-1.1075,0.241,NULL,49825811030,778528297,12164504,NULL),(152956,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 02063','R',152956,40.32,0.19,970,72629,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02063',0.192931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152957,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152957,34.3,0.8,72.4,72630,75,NULL,'MAT, I','IC 5147',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.06',0.6,'SB(r)bc',NULL,NULL,NULL,NULL,1,329.859667,-65.44986,0.021,NULL,49343920763,770998761,12046855,15.06),(152958,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152958,34.17,0.32,68.2,72630,85,NULL,'I, raw','IC 5147',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152959,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152959,34.19,0.32,68.8,72630,85,NULL,'I, inv','IC 5147',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152960,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152960,34.19,0.43,68.9,72630,75,NULL,'MAT, I, raw','IC 5147',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152961,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152961,34.29,0.43,72.3,72630,75,NULL,'MAT, I, inv','IC 5147',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152962,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152962,34.66,0.43,85.3,72630,75,NULL,'MAT, I, cor','IC 5147',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152963,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152963,36.78,0.33,227,72631,70,NULL,NULL,'2MASX J21592702-0746594',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000103,NULL,'16.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,329.8627083,-7.78306,0.057,NULL,49923495491,780054617,12188353,16.8),(152964,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17586','RN',152964,40.27,0.32,891,72632,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17586',0.273141,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152965,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 17586','RN',152965,40.36,0.25,926,72632,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17586',0.273141,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152966,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152966,35.27,NULL,113,72633,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2356',NULL,'2010Ap&SS.325..163P',2010,1,0.91,NULL,'G',0.000018,NULL,'16.4',0.11,'Scd',NULL,NULL,NULL,NULL,1,329.880083333,6.55525,0.197,NULL,52333049855,817703903,12776623,16.4),(152967,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152967,35.28,NULL,114,72633,NULL,NULL,'Dipole + Quadrupole','FGC 2356',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152968,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152968,35.31,NULL,115,72633,NULL,NULL,'Dipole','FGC 2356',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152969,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152969,35.43,NULL,122,72633,NULL,NULL,NULL,'FGC 2356',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152970,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09477','RN',152970,37.86,0.43,339,72634,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09477',0.100901,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152971,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09477','RN',152971,38.05,0.36,370,72634,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09477',0.100901,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152972,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152972,38.03,0.46,403,72635,70,NULL,NULL,'2MASX J21593215+0109399',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,329.883833333,1.16119,0.161,NULL,52192300991,815504702,12742260,18),(152973,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152973,36.16,0.58,170,72636,70,NULL,NULL,'2MASX J21593548-5447293',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.1I',0.4,NULL,NULL,NULL,NULL,NULL,1,329.89775,-54.7915,0,NULL,48692000478,760812507,11887695,14.1),(152974,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152974,35.31,0.53,115,72637,70,NULL,NULL,'2MASX J21593694-5612273',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.5r',0.45,'E',NULL,NULL,NULL,NULL,1,329.903875,-56.20758,0,NULL,48719363957,761240061,11894375,14.5),(152975,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16441','RN',152975,41.38,0.17,1460,72638,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16441',0.2915,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152976,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16441','RN',152976,41.42,0.4,1490,72638,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16441',0.2915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152977,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152977,32.27,0.8,28.4,72639,75,NULL,'B','NGC 7162',NULL,'1988NBGC.C....0000T',1988,1,2.8,'The APMBGC position is 17 arcsec south of the nucleus.','G',0.00002,NULL,'13.29',1,'(R\')SA(r)bc    LINER','in a pair',NULL,NULL,NULL,1,329.9130417,-43.30597,0,NULL,50673689487,791776398,12371506,13.29),(152978,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152978,32.55,0.4,32.4,72639,NULL,NULL,'mean','NGC 7162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152979,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152979,32.79,0.46,36.1,72639,NULL,NULL,'J','NGC 7162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152980,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152980,32.83,0.47,36.8,72639,NULL,NULL,'H','NGC 7162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152981,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152981,32.93,0.45,38.5,72639,NULL,NULL,'K','NGC 7162',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152982,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',152982,38.02,0.46,402,72640,70,NULL,NULL,'2MASX J21594302+1120107',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,329.9292083,11.33636,0.237,NULL,52282405064,816912579,12764259,18),(152983,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152983,34.77,0.48,89.9,72641,70,NULL,NULL,'2MASX J21594326-7012136',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'14.4r',0.5,'S',NULL,NULL,NULL,NULL,1,329.930417,-70.20375,0.025,NULL,49302988325,770359192,12036862,14.4),(152984,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152984,37.08,0.54,260,72642,70,NULL,NULL,'2MASX J21594415-1528439',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.88',0.4,NULL,NULL,NULL,NULL,NULL,1,329.934,-15.479,0.085,NULL,49793583038,778024734,12156636,15.88),(152985,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20051','RN',152985,40.54,0.15,1040,72643,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pv','SDSS-II SN 20051',0.235152,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152986,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20051','RN',152986,40.79,0.25,1160,72643,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pv','SDSS-II SN 20051',0.235152,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152987,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20051','N',152987,40.49,0.13,1250,72643,70,NULL,'SALT 2','SDSS-II SN 20051',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152988,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 20051','N',152988,40.51,0.13,1260,72643,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20051',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152989,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152989,35.91,0.51,152,72644,70,NULL,NULL,'2MASX J21594545-4653343',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.7r',0.28,'E',NULL,NULL,NULL,NULL,1,329.9394583,-46.89292,0,NULL,50654131519,791470804,12366731,14.7),(152990,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,152990,36.24,0.53,177,72645,70,NULL,NULL,'2MASX J21594642-1752379',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'15.4r',0.22,NULL,NULL,NULL,NULL,NULL,1,329.943583,-17.87731,0.069,NULL,49785893613,777904587,12154759,15.4),(152991,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006oo',NULL,152991,40.22,0.27,863,72646,72,NULL,'SDSS 16442','SDSS J215947.23-004359.6',0.28,'2009ApJ...704.1036F',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,329.946791667,-0.73322,0.161,NULL,49821928782,778467637,12163556,NULL),(152992,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16442','R',152992,40.52,0.29,991,72646,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oo','SDSS J215947.23-004359.6',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152993,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 16442','R',152993,40.67,0.16,1060,72646,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oo','SDSS J215947.23-004359.6',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152994,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006oo',NULL,152994,40.31,0.14,1150,72646,70,NULL,'SALT 2','SDSS J215947.23-004359.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152995,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2006oo',NULL,152995,40.34,0.14,1170,72646,70,NULL,'SALT 2, Malmquist cor.','SDSS J215947.23-004359.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152996,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 01278','RN',152996,39.32,0.06,576,72647,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01278',0.271673,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152997,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,152997,37.77,0.12,324,72648,74.2,NULL,'SALT 2','2MFGC 16592',0.104,'2010ApJ...716..712A',2010,1,0.56,NULL,'G',NULL,'PHOT','18.06',0.12,NULL,NULL,NULL,NULL,NULL,1,329.957208333,-1.19242,0.241,NULL,49825730002,778527031,12164484,18.06),(152998,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,152998,38.21,0.04,398,72648,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 10434, SN 2005lk','2MFGC 16592',0.104,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(152999,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,152999,38.5,0.13,454,72648,70,NULL,'SALT 2','2MFGC 16592',0.104,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153000,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 10434','R',153000,38.51,0.18,456,72648,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lk','2MFGC 16592',0.104161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153001,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,153001,38.58,NULL,471,72648,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 10434, SN 2005lk','2MFGC 16592',0.104,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153002,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,153002,38.44,0.07,488,72648,70,NULL,'SALT 2','2MFGC 16592',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153003,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SN 2005lk',NULL,153003,38.44,0.07,488,72648,70,NULL,'SALT 2, Malmquist cor.','2MFGC 16592',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153004,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 10434','R',153004,38.67,0.11,492,72648,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lk','2MFGC 16592',0.104161,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153005,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153005,38.1,0.46,417,72649,70,NULL,NULL,'2MASX J21595501-0038034',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',NULL,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,329.97925,-0.63439,0.161,NULL,49822005681,778468838,12163575,17.9),(153006,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153006,36.53,0.66,203,72650,70,NULL,NULL,'ESO 075- G 046',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.41',0.5,'(R_1)SB(r)a',NULL,NULL,NULL,NULL,1,330.0024583,-71.66122,0.017,NULL,49307469089,770429204,12037956,15.41),(153007,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153007,38.18,0.46,432,72651,70,NULL,NULL,'2MASX J22000112+0025086',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.0047083,0.41908,0.193,NULL,52184435738,815381808,12740340,17.4),(153008,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153008,35.94,0.52,154,72652,70,NULL,NULL,'MCG -02-56-002',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000147,NULL,'15.21',0.4,'poss. LINER',NULL,NULL,NULL,NULL,1,330.00875,-13.795,0.093,NULL,49781855342,777841489,12153773,15.21),(153009,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153009,38.07,0.46,411,72653,70,NULL,NULL,'2MASX J22000481-0804460',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,330.02,-8.07939,0.069,NULL,49923744810,780058512,12188414,17.2),(153010,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153010,37.68,0.27,344,72654,70,NULL,NULL,'2MASX J22000942-0717599',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000158,NULL,'17.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,330.03925,-7.30014,0.085,NULL,49924223594,780065993,12188531,17.8),(153011,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153011,37.68,0.27,344,72655,70,NULL,NULL,'2MASX J22000963-0718229',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.040125,-7.30656,0.085,NULL,49924216214,780065878,12188529,17.7),(153012,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153012,37.68,0.27,344,72656,70,NULL,NULL,'2MASX J22001467-0719109',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,330.0612917,-7.31967,0.085,NULL,49924215972,780065874,12188529,17.3),(153013,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153013,37.97,0.46,392,72657,70,NULL,NULL,'SDSS J220016.22-073347.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,330.067625,-7.56328,0.073,NULL,49924171085,780065173,12188518,18.5),(153014,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 06289','RN',153014,40.76,0.12,1280,72658,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06289',0.110404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153015,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 06289','RN',153015,41.19,0.22,1560,72658,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06289',0.110404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153016,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 14224','RN',153016,39.42,0.16,678,72659,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14224',0.128182,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153017,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 14224','RN',153017,40.01,0.22,889,72659,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14224',0.128182,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153018,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455','R',153018,41.89,0.29,1700,72660,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15455',0.407071,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,330.0804583,-1.05142,0.225,NULL,49821502498,778460976,12163452,NULL),(153019,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455','R',153019,41.98,0.27,1770,72660,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15455',0.407071,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153020,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455',NULL,153020,41.3,0.22,1820,72660,70,NULL,'SN photometric redshift distance, z photo =0.575 +/- 0.093','SDSS-II SN 15455',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153021,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455',NULL,153021,41.8,0.19,2290,72660,70,NULL,'SALT 2','SDSS-II SN 15455',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153022,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 15455',NULL,153022,41.87,0.19,2370,72660,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15455',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153023,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153023,34.62,0.45,83.9,72661,NULL,NULL,'Malmquist cor.','IC 1417',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000017,NULL,'14.36',0.4,'Sb? sp         Sy2','Line-of-sight pair member',NULL,NULL,'Sy 2',1,330.0900417,-13.14736,0.101,NULL,49778896513,777795258,12153050,14.36),(153024,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153024,35.01,0.38,100,72661,NULL,NULL,NULL,'IC 1417',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153025,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153025,35.05,0.2,102,72661,74.4,NULL,NULL,'IC 1417',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153026,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153026,36.86,0.1,235,72662,70,NULL,NULL,'2MASX J22002270-0729495',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000161,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,330.094625,-7.497,0.085,NULL,49924176278,780065254,12188519,17.5),(153027,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,'R',153027,38.95,0.46,618,72663,70,NULL,NULL,'SDSS J220024.74+005849.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000197,NULL,'18.1g',0.18,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,330.103125,0.98031,0.161,NULL,52184215521,815378367,12740286,18.1),(153028,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 09377','RN',153028,36.93,0.35,216,72664,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09377',0.126098,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153029,'FP','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153029,35.28,0.6,114,72665,70,NULL,NULL,'2MASX J22002578-4636072',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,330.1072917,-46.602,0,NULL,50650727549,791417617,12365900,14),(153030,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153030,33.96,0.47,61.9,72666,NULL,NULL,'H','ESO 404- G 015',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00008,NULL,'14.36',0.3,'S?             HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.122333,-33.37161,0,NULL,50558963247,789983800,12343496,14.36),(153031,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153031,33.99,0.4,62.7,72666,NULL,NULL,'mean','ESO 404- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153032,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153032,34.06,0.46,64.7,72666,NULL,NULL,'J','ESO 404- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153033,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153033,34.06,0.45,64.9,72666,NULL,NULL,'K','ESO 404- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153034,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153034,32.36,0.46,29.7,72667,NULL,NULL,'J','NGC 7167',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000007,NULL,'12.87',1.3,'SB(s)c:        HII',NULL,NULL,NULL,NULL,1,330.127667,-24.63261,0.065,NULL,51407300343,803239067,12550610,12.87),(153035,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153035,32.42,0.47,30.4,72667,NULL,NULL,'H','NGC 7167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153036,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153036,32.45,0.45,30.9,72667,NULL,NULL,'K','NGC 7167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153037,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:12','1',NULL,NULL,153037,32.62,0.4,33.4,72667,NULL,NULL,'mean','NGC 7167',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153038,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:12','1','SDSS-II SN 01305','RN',153038,39.64,0.1,771,72668,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01305',0.09786,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153039,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 01305','RN',153039,40.04,0.2,929,72668,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01305',0.09786,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153040,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153040,38.11,0.27,419,72669,70,NULL,NULL,'2MASX J22003134+0035417',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,330.1305,0.59497,0.177,NULL,52184275529,815379305,12740301,18),(153041,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153041,35.5,0.58,126,72670,70,NULL,NULL,'2MASX J22003223-5800453',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.31',0.33,NULL,NULL,NULL,NULL,NULL,1,330.134375,-58.01267,0,NULL,48718019763,761219058,11894047,16.31),(153042,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153042,31.73,0.63,22.2,72671,95,NULL,'Michard 1979b, c','NGC 7166',NULL,'1984ApJS...56...91D',1984,1,2.5,NULL,'G',0.00008,NULL,'12.85',0.9,'SA0^-','in a pair',NULL,NULL,NULL,1,330.137167,-43.38972,0,NULL,50674448399,791788256,12371691,12.85),(153043,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153043,31.87,0.37,23.7,72671,95,NULL,'Weighted Mean','NGC 7166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153044,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153044,32.05,0.46,25.7,72671,95,NULL,'Michard 1979a','NGC 7166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153045,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153045,34.42,0.81,76.6,72671,55,NULL,'Visvanathan & Sandage 1979','NGC 7166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153046,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153046,33.3,0.52,45.8,72671,70,NULL,NULL,'NGC 7166',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153047,'Tertiary','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153047,31.55,0.71,20.4,72671,95,NULL,NULL,'NGC 7166',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153048,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153048,32.4,0.8,30.2,72671,75,NULL,'B','NGC 7166',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153049,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153049,37.59,0.46,330,72672,70,NULL,NULL,'2MASX J22003356-0824465',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000174,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,330.139791667,-8.41286,0.069,NULL,49922800175,780043752,12188183,16.5),(153050,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153050,37.51,0.33,318,72673,70,NULL,NULL,'2MASX J22003561+0103327',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,330.148417,1.05914,0.149,NULL,52184183573,815377868,12740279,17.7),(153051,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153051,32.25,0.8,28.1,72674,75,NULL,'MAT, I','NGC 7162A',NULL,'1997ApJS..109..333W',1997,1,2.6,'The APMBGC position is 8 arcsec northwest of the center of the bar.','G',0.00001,NULL,'13.1',2.3,'SB(s)m','in a pair',NULL,NULL,NULL,1,330.1489583,-43.14172,0,NULL,50673661840,791775966,12371499,13.1),(153052,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153052,30.88,0.32,15,72674,85,NULL,'I, inv','NGC 7162A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153053,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153053,30.92,0.32,15.3,72674,85,NULL,'I, raw','NGC 7162A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153054,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153054,31.5,0.4,20,72674,NULL,NULL,NULL,'NGC 7162A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153055,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153055,31.51,0.4,20,72674,73,NULL,'opt','NGC 7162A',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153056,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153056,32.28,0.4,28.6,72674,75,NULL,'B','NGC 7162A',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153057,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153057,32.44,0.09,30.8,72674,NULL,NULL,NULL,'NGC 7162A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153058,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153058,32.64,0.43,33.8,72674,75,NULL,'MAT, I, raw','NGC 7162A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153059,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153059,32.71,0.43,34.8,72674,75,NULL,'MAT, I, inv','NGC 7162A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153060,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153060,32.79,0.43,36.1,72674,75,NULL,'MAT, I, cor','NGC 7162A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153061,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 00694','RN',153061,38.73,0.18,495,72675,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00694',0.127493,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153062,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 00694','RN',153062,39.02,0.08,565,72675,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00694',0.127493,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153063,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153063,36.08,0.2,164,72676,74.4,NULL,NULL,'CGCG 428-012',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000155,NULL,'15.5g',0.35,'Sb',NULL,NULL,NULL,NULL,1,330.160666667,11.37433,0.237,NULL,52282425863,816912904,12764264,15.5),(153064,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153064,34.62,0.49,83.9,72677,75,NULL,'IR','UGC 11873',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000017,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,330.169458333,19.66794,0.293,NULL,52218455690,815913370,12748646,16),(153065,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153065,34.98,0.47,99.1,72677,NULL,NULL,NULL,'UGC 11873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153066,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153066,35.01,0.2,100,72677,74.4,NULL,NULL,'UGC 11873',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153067,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153067,35.16,0.43,108,72677,NULL,NULL,'Malmquist cor.','UGC 11873',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153068,'Ring Diameter','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153068,33.3,0.98,46,72678,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7177',NULL,'1981ApJS...45..541P',1981,1,3.1,NULL,'G',0.000003,NULL,'12.01',2,'SAB(r)b; HII   LINER',NULL,NULL,NULL,NULL,1,330.171833,17.73806,0.233,NULL,52271884394,816748193,12761690,12.01),(153069,'Ring Diameter','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153069,33.5,0.76,51,72678,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7177',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153070,'Sosies','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153070,31.56,0.14,20.5,72678,NULL,NULL,NULL,'NGC 7177',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153071,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153071,31.3,0.8,18.2,72678,75,NULL,'B','NGC 7177',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153072,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153072,30.59,0.69,13.1,72678,100,NULL,'mid-IR','NGC 7177',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153073,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153073,31.54,NULL,20.3,72678,NULL,NULL,'B','NGC 7177',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153074,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153074,31.85,0.4,23.4,72678,NULL,NULL,NULL,'NGC 7177',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153075,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153075,31.96,0.2,24.7,72678,74.4,NULL,NULL,'NGC 7177',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153076,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153076,31.97,0.38,24.8,72678,NULL,NULL,'Malmquist cor.','NGC 7177',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153077,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153077,31.99,0.43,25,72678,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7177',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153078,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153078,32.03,0.43,25.4,72678,75,NULL,'3.6 micron, color corrected','NGC 7177',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153079,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153079,35.08,0.47,104,72679,NULL,NULL,'H','UGC 11871',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000033,NULL,NULL,NULL,'Sb             Sy1.9','Isolated galaxy',NULL,NULL,NULL,1,330.174583,10.54972,0.201,NULL,52283622458,816931600,12764556,NULL),(153080,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153080,35.12,0.45,106,72679,NULL,NULL,'K','UGC 11871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153081,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153081,35.2,0.4,109,72679,NULL,NULL,'mean','UGC 11871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153082,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153082,35.27,0.46,113,72679,NULL,NULL,'J','UGC 11871',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153083,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153083,35.03,0.57,102,72680,70,NULL,NULL,'2MASX J22004272-4649062',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'16.5b',0.19,NULL,NULL,NULL,NULL,NULL,1,330.178083,-46.81842,0,NULL,50650920007,791420625,12365947,16.5),(153084,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153084,35.75,0.55,141,72681,70,NULL,NULL,'2MASX J22004433-5506302',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.29',0.25,'E',NULL,NULL,NULL,NULL,1,330.184625,-55.10833,0,NULL,48710865071,761107266,11892301,16.29),(153085,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06895','R',153085,39.86,0.2,769,72682,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220046.28+005541.4',0.2174,'2014arXiv1401.3317S',2014,1,0.15,NULL,'G',0.0005,NULL,'19.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,330.192875,0.92817,0.165,NULL,52184140787,815377199,12740268,19),(153086,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06895','R',153086,39.86,0.13,771,72682,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220046.28+005541.4',0.2174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153087,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06895',NULL,153087,39.68,0.09,863,72682,70,NULL,'SALT 2','SDSS J220046.28+005541.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153088,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06895',NULL,153088,39.7,0.09,871,72682,70,NULL,'SALT 2, Malmquist cor.','SDSS J220046.28+005541.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153089,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153089,37.45,0.46,310,72683,70,NULL,NULL,'2MASX J22004743-0720543',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.197625,-7.34831,0.085,NULL,49924261376,780066584,12188540,17.2),(153090,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153090,37.86,0.46,372,72684,70,NULL,NULL,'2MASX J22005061-0034031',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'17.0g',0.26,'BrClG',NULL,NULL,NULL,NULL,1,330.210833,-0.56767,0.165,NULL,49821655197,778463362,12163490,17),(153091,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153091,35.51,0.47,126,72685,70,NULL,NULL,'CGCG 377-011',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00009,NULL,'15.3',NULL,NULL,NULL,NULL,NULL,NULL,1,330.2127083,-1.83931,0.249,NULL,49824431209,778506737,12164167,15.3),(153092,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 03049','R',153092,39.65,0.2,731,72686,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03049',0.166701,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,330.223417,-1.23658,0.201,NULL,49821279513,778457492,12163398,NULL),(153093,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 03049','R',153093,39.93,0.14,828,72686,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03049',0.166701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153094,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153094,37.51,0.33,318,72687,70,NULL,NULL,'2MASX J22005462+0111577',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000144,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,330.2275417,1.19947,0.149,NULL,52184005296,815375082,12740235,17.3),(153095,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153095,32.49,0.8,31.5,72688,75,NULL,'MAT, I','ESO 404- G 017',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000017,NULL,'15.03',0.6,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.2327917,-35.287,0,NULL,50559472616,789991759,12343621,15.03),(153096,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153096,32.6,0.1,33.2,72688,NULL,NULL,NULL,'ESO 404- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153097,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153097,32.96,0.32,39.1,72688,85,NULL,'I, inv','ESO 404- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153098,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153098,32.98,0.4,39.4,72688,NULL,NULL,NULL,'ESO 404- G 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153099,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153099,32.98,0.32,39.4,72688,85,NULL,'I, raw','ESO 404- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153100,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153100,33.11,0.2,41.9,72688,74.4,NULL,NULL,'ESO 404- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153101,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153101,33.23,0.43,44.3,72688,75,NULL,'3.6 micron, color corrected','ESO 404- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153102,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153102,33.32,0.43,46.1,72688,75,NULL,'MAT, I, raw','ESO 404- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153103,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153103,33.32,0.43,46.2,72688,75,NULL,'MAT, I, inv','ESO 404- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153104,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153104,33.35,0.43,46.8,72688,75,NULL,'3.6 micron, color + selection bias corrected','ESO 404- G 017',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153105,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153105,33.55,0.43,51.4,72688,75,NULL,'MAT, I, cor','ESO 404- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153106,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153106,36.15,0.51,170,72689,70,NULL,NULL,'2MASX J22005597-1412037',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'13.9I',0.5,NULL,NULL,NULL,NULL,NULL,1,330.233167,-14.20097,0.085,NULL,49782185038,777846641,12153853,13.9),(153107,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 20545','R',153107,39.67,0.19,723,72690,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220100.11-002526.4',0.1895,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.01,NULL,'19.9g',0.08,NULL,NULL,NULL,NULL,NULL,1,330.2505,-0.424,0.133,NULL,49821696669,778464010,12163500,19.9),(153108,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 20545','R',153108,39.76,0.13,754,72690,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220100.11-002526.4',0.1895,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153109,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 20545',NULL,153109,39.44,0.09,773,72690,70,NULL,'SALT 2','SDSS J220100.11-002526.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153110,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 20545',NULL,153110,39.45,0.09,776,72690,70,NULL,'SALT 2, Malmquist cor.','SDSS J220100.11-002526.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153111,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896',NULL,153111,40.12,0.32,1060,72691,70,NULL,'SN photometric redshift distance, z photo =0.287 +/- 0.055','SDSS-II SN 06896',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,330.2537917,1.01675,0.201,NULL,52184119040,815376860,12740263,20.4),(153112,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896','R',153112,40.94,0.25,1150,72691,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06896',0.33504,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153113,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896','R',153113,41.26,0.35,1340,72691,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06896',0.33504,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153114,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896',NULL,153114,41.11,0.22,1670,72691,70,NULL,'SALT 2','SDSS-II SN 06896',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153115,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06896',NULL,153115,41.15,0.22,1700,72691,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06896',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153116,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 12855','R',153116,39.41,0.21,656,72692,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fk','SDSS J220101.33+004258.5',0.16,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,330.255541667,0.71625,0.165,NULL,52184234731,815378667,12740291,NULL),(153117,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2006fk',NULL,153117,39.42,0.18,661,72692,72,NULL,'SDSS 12855','SDSS J220101.33+004258.5',0.16,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153118,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 12855','R',153118,39.64,0.1,730,72692,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fk','SDSS J220101.33+004258.5',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153119,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153119,32.68,0.8,34.4,72693,75,NULL,'MAT, I','NGC 7171',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000019,NULL,'13.23',1.5,'SB(rs)b        HII','Line-of-sight pair member',NULL,NULL,NULL,1,330.258375,-13.26975,0.081,NULL,49778607404,777790740,12152980,13.23),(153120,'Sosies','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153120,33.29,0.1,45.5,72693,NULL,NULL,NULL,'NGC 7171',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153121,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153121,32.7,0.8,34.7,72693,75,NULL,'B','NGC 7171',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153122,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153122,32.92,0.4,38.4,72693,NULL,NULL,'mean','NGC 7171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153123,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153123,32.97,0.32,39.2,72693,85,NULL,'I, raw','NGC 7171',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153124,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153124,33.02,0.43,40.2,72693,75,NULL,'MAT, I, raw','NGC 7171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153125,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153125,33.02,0.32,40.2,72693,85,NULL,'I, inv','NGC 7171',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153126,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153126,33.04,0.4,40.6,72693,NULL,NULL,NULL,'NGC 7171',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153127,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153127,33.08,0.46,41.2,72693,NULL,NULL,'J','NGC 7171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153128,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153128,33.08,0.47,41.3,72693,NULL,NULL,'H','NGC 7171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153129,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153129,33.12,0.43,42.1,72693,75,NULL,'3.6 micron, color corrected','NGC 7171',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153130,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153130,33.13,0.2,42.3,72693,74.4,NULL,NULL,'NGC 7171',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153131,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153131,33.13,0.45,42.3,72693,NULL,NULL,'K','NGC 7171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153132,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153132,33.2,0.43,43.6,72693,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7171',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153133,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153133,33.26,0.43,44.8,72693,75,NULL,'MAT, I, inv','NGC 7171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153134,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153134,33.39,0.43,47.7,72693,75,NULL,'MAT, I, cor','NGC 7171',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153135,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153135,36.86,0.46,236,72694,70,NULL,NULL,'2MASX J22010357-0715373',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,330.264875,-7.26044,0.073,NULL,49924032062,780063000,12188484,16.6),(153136,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153136,36.18,0.49,172,72695,70,NULL,NULL,'2MASX J22010427-1442268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.47',NULL,NULL,NULL,NULL,NULL,NULL,1,330.267917,-14.70747,0.085,NULL,49781308280,777832941,12153639,15.47),(153137,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153137,35.04,0.52,102,72696,70,NULL,NULL,'2MASX J22010504-0447502',NULL,'2014MNRAS.445.2677S',2014,1,0.94,NULL,'G',0.00015,NULL,'15.46',0.6,NULL,NULL,NULL,NULL,NULL,1,330.271,-4.79736,0.165,NULL,49816450880,778382045,12162219,15.46),(153138,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153138,31.68,0.43,21.7,72697,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J22010637+7156385',NULL,'2014MNRAS.444..527S',2014,1,1.68,NULL,'G',0.00002,NULL,'9.34K',1.56,'Spiral LSB',NULL,NULL,NULL,NULL,1,330.2767083,71.944,2.529,NULL,53516752152,836199252,13065613,9.34),(153139,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153139,36.36,0.7,187,72698,70,NULL,NULL,'2MASX J22010717-7244231',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.8b',0.11,NULL,NULL,NULL,NULL,NULL,1,330.2797917,-72.73972,0.129,NULL,49297926350,770280099,12035626,16.8),(153140,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153140,35.69,0.64,138,72699,70,NULL,NULL,'2MASX J22010777-1105363',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.00',0.45,NULL,NULL,NULL,NULL,NULL,1,330.282333333,-11.0935,0.105,NULL,49870950370,779233599,12175524,16),(153141,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153141,32.26,0.8,28.4,72700,75,NULL,'MAT, I','ESO 404- G 018',NULL,'1997ApJS..109..333W',1997,1,2.97,NULL,'G',0.00001,NULL,'15.38',0.22,'SB(s)d? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.292333,-32.57881,0,NULL,50558396949,789974952,12343358,15.38),(153142,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153142,31.22,0.32,17.5,72700,85,NULL,'I, inv','ESO 404- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153143,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153143,31.26,0.32,17.9,72700,85,NULL,'I, raw','ESO 404- G 018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153144,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153144,31.57,0.43,20.7,72700,75,NULL,'MAT, I, inv','ESO 404- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153145,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153145,31.69,0.43,21.8,72700,75,NULL,'MAT, I, raw','ESO 404- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153146,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153146,32.08,0.43,26.1,72700,75,NULL,'MAT, I, cor','ESO 404- G 018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153147,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153147,32.16,0.4,27,72700,NULL,NULL,NULL,'ESO 404- G 018',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153148,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153148,32.16,0.4,27,72700,73,NULL,'opt','ESO 404- G 018',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153149,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153149,32.3,0.2,28.8,72700,74.4,NULL,NULL,'ESO 404- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153150,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153150,32.34,NULL,29.4,72700,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 404- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153151,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153151,32.36,NULL,29.6,72700,NULL,NULL,'Dipole + Quadrupole','ESO 404- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153152,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153152,32.36,NULL,29.7,72700,NULL,NULL,'Dipole','ESO 404- G 018',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153153,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153153,32.55,0.43,32.3,72700,75,NULL,'3.6 micron, color corrected','ESO 404- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153154,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153154,32.56,NULL,32.5,72700,NULL,NULL,NULL,'ESO 404- G 018',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153155,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153155,32.61,0.13,33.3,72700,NULL,NULL,NULL,'ESO 404- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153156,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153156,32.69,0.43,34.5,72700,75,NULL,'3.6 micron, color + selection bias corrected','ESO 404- G 018',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153157,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153157,38.15,0.33,426,72701,70,NULL,NULL,'SDSS J220111.55-005824.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,330.298125,-0.97361,0.217,NULL,49821356628,778458697,12163417,18.4),(153158,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153158,38.15,0.33,426,72702,70,NULL,NULL,'SDSS J220112.16-005759.8',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'17.0g',0.24,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,330.300667,-0.96664,0.217,NULL,49821356874,778458701,12163417,17),(153159,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153159,45.49,1.17,3740,72703,69.7,NULL,'Fiducial','GRB 051109A',2.35,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,330.3135,40.82311,1.089,NULL,55514250126,867410158,13553283,NULL),(153160,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153160,45.69,0.83,4100,72703,72,NULL,NULL,'GRB 051109A',2.35,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153161,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153161,45.82,0.83,4350,72703,70,NULL,NULL,'GRB 051109A',2.35,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153162,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153162,45.84,0.8,4390,72703,69.7,NULL,'Calibrated','GRB 051109A',2.35,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153163,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153163,45.87,0.83,4460,72703,69.7,NULL,'Fiducial','GRB 051109A',2.35,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153164,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153164,45.9,0.96,4510,72703,NULL,NULL,NULL,'GRB 051109A',2.35,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153165,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153165,47.28,1.68,8540,72703,100,NULL,NULL,'GRB 051109A',2.35,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153166,'GRB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153166,47.44,1.63,9180,72703,69.7,NULL,'Fiducial','GRB 051109A',2.35,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153167,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153167,35.2,0.46,110,72704,70,NULL,NULL,'2MASX J22011629-5504260',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00011,NULL,'15.66',0.43,'E',NULL,NULL,NULL,NULL,1,330.3177083,-55.07389,0,NULL,48693308946,760832952,11888014,15.66),(153168,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 04928','RN',153168,40.16,0.18,955,72705,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04928',0.126496,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153169,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 04928','RN',153169,40.61,0.29,1180,72705,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04928',0.126496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153170,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153170,35.38,0.56,119,72706,70,NULL,NULL,'2MASX J22011929-5221007',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'16.21',0.28,'S',NULL,NULL,NULL,NULL,1,330.3302917,-52.35017,0,NULL,50628821890,791075342,12360552,16.21),(153171,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153171,32.96,0.4,39.1,72707,NULL,NULL,'mean','ESO 466- G 036',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000031,NULL,'14.70',0.5,'Sa','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.33525,-31.52969,0,NULL,51413798705,803340604,12552196,14.7),(153172,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153172,33.76,0.43,56.4,72707,75,NULL,'3.6 micron, color corrected','ESO 466- G 036',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153173,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153173,33.75,0.43,56.4,72707,75,NULL,'3.6 micron, color + selection bias corrected','ESO 466- G 036',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153174,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153174,33.82,0.2,58.1,72707,74.4,NULL,NULL,'ESO 466- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153175,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153175,33.93,0.47,61.1,72707,NULL,NULL,'H','ESO 466- G 036',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153176,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153176,35.69,0.46,138,72708,70,NULL,NULL,'2MASX J22012088+1211481',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.000171,NULL,'15.8g',0.35,'S0/a',NULL,NULL,NULL,NULL,1,330.3372083,12.19667,0.285,NULL,52252707001,816448546,12757008,15.8),(153177,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153177,38.11,0.27,419,72709,70,NULL,NULL,'SDSS J220122.44+001656.7',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000163,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,330.3435,0.28242,0.193,NULL,52183726288,815370723,12740167,18),(153178,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153178,38.11,0.27,419,72710,70,NULL,NULL,'2MASX J22012326+0019582',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,330.3469583,0.33269,0.177,NULL,52183928706,815373886,12740216,18.5),(153179,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153179,34.72,0.47,87.7,72711,70,NULL,NULL,'2MASX J22012356-0345241',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000143,NULL,'15.28',NULL,NULL,NULL,NULL,NULL,NULL,1,330.348125,-3.75667,0.225,NULL,49819079616,778423119,12162861,15.28),(153180,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153180,34.98,0.59,99,72712,NULL,NULL,'Malmquist cor.','ESO 404- G 019',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.38',0.8,'Sb',NULL,NULL,NULL,NULL,1,330.349167,-33.9125,0,NULL,50562080119,790032501,12344257,14.38),(153181,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153181,35.09,0.56,104,72712,NULL,NULL,NULL,'ESO 404- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153182,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153182,35.13,0.2,106,72712,74.4,NULL,NULL,'ESO 404- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153183,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153183,35.25,0.49,112,72713,70,NULL,NULL,'NGC 7170',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000147,NULL,'14.77',0.8,'SA0-?',NULL,NULL,NULL,NULL,1,330.359416667,-5.43278,0.137,NULL,49887127299,779486364,12179474,14.77),(153184,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 15102','R',153184,42.18,0.38,1720,72714,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15102',0.583407,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','23.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,330.369833333,-0.59792,0.165,NULL,49823687099,778495110,12163986,23.4),(153185,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 15102',NULL,153185,41.23,0.36,1760,72714,70,NULL,'SN photometric redshift distance, z photo =0.548 +/- 0.152','SDSS-II SN 15102',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153186,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153186,34.3,NULL,72.3,72715,NULL,NULL,NULL,'FGC 2357',NULL,'2000BSAO...50....5K',2000,1,0.8,NULL,'G',0.000036,NULL,'17.3',0.08,'Sdm',NULL,NULL,NULL,NULL,1,330.37,3.56444,0.133,NULL,52188307849,815442310,12741286,17.3),(153187,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153187,34.48,NULL,78.8,72715,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153188,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153188,34.49,NULL,79,72715,NULL,NULL,'Dipole + Quadrupole','FGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153189,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153189,34.5,NULL,79.3,72715,NULL,NULL,'Dipole','FGC 2357',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153190,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 03050','RN',153190,39.87,0.14,855,72716,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03050',0.100844,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153191,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 03050','RN',153191,40.06,0.32,934,72716,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03050',0.100844,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153192,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153192,34.05,0.8,64.5,72717,75,NULL,'MAT, I','ESO 601- G 004',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'14.33',0.5,'SB(s)c:        HII',NULL,NULL,NULL,NULL,1,330.377083,-22.07086,0.041,NULL,50869961173,794843143,12419424,14.33),(153193,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153193,33.92,0.43,60.9,72717,75,NULL,'MAT, I, raw','ESO 601- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153194,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153194,33.94,0.32,61.3,72717,85,NULL,'I, raw','ESO 601- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153195,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153195,33.98,0.32,62.5,72717,85,NULL,'I, inv','ESO 601- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153196,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153196,34.02,0.2,63.7,72717,74.4,NULL,NULL,'ESO 601- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153197,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153197,34.12,0.43,66.5,72717,75,NULL,'MAT, I, inv','ESO 601- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153198,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153198,34.18,0.43,68.5,72717,75,NULL,'MAT, I, cor','ESO 601- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153199,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153199,34.25,0.41,70.6,72717,NULL,NULL,NULL,'ESO 601- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153200,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153200,34.27,0.4,71.4,72717,NULL,NULL,'Malmquist cor.','ESO 601- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153201,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153201,36.65,0.27,214,72718,70,NULL,NULL,'2MASX J22013271+0011528',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,330.386291667,0.19808,0.165,NULL,52183722476,815370663,12740166,17.2),(153202,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2007lu',NULL,153202,41.07,0.27,1630,72719,70,NULL,'Hubble residual 0.75 for z0.31950','SDSS J220134.88-001524.8',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.0005,NULL,'21.7g',0.03,NULL,NULL,NULL,NULL,NULL,1,330.395333,-0.25689,0.149,NULL,49821563326,778461926,12163467,21.7),(153203,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19029','R',153203,41.67,0.2,1640,72719,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lu','SDSS J220134.88-001524.8',0.3195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153204,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19029','R',153204,41.91,0.31,1830,72719,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lu','SDSS J220134.88-001524.8',0.3195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153205,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153205,36.43,0.51,194,72720,70,NULL,NULL,'2MASX J22013731-1554462',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.64',0.4,NULL,NULL,NULL,NULL,NULL,1,330.405417,-15.91281,0.081,NULL,49793466446,778022913,12156608,15.64),(153206,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153206,34.04,0.8,64.3,72721,75,NULL,'MAT, I','ESO 601- G 005',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'15.32',0.3,'Sb:',NULL,NULL,NULL,NULL,1,330.4082083,-21.51117,0.073,NULL,50883458292,795054035,12422719,15.32),(153207,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153207,33.49,0.32,50,72721,85,NULL,'I, raw','ESO 601- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153208,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153208,33.52,0.32,50.6,72721,85,NULL,'I, inv','ESO 601- G 005',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153209,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153209,33.58,0.43,52.1,72721,75,NULL,'MAT, I, raw','ESO 601- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153210,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153210,33.73,0.43,55.7,72721,75,NULL,'MAT, I, inv','ESO 601- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153211,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153211,33.85,0.2,58.9,72721,74.4,NULL,NULL,'ESO 601- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153212,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153212,33.92,0.52,60.8,72721,NULL,NULL,NULL,'ESO 601- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153213,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153213,33.95,0.43,61.6,72721,75,NULL,'MAT, I, cor','ESO 601- G 005',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153214,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153214,34.07,0.49,65.1,72721,NULL,NULL,'Malmquist cor.','ESO 601- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153215,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153215,34.09,0.49,65.6,72721,75,NULL,'IR','ESO 601- G 005',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153216,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153216,34.32,0.4,73.2,72721,NULL,NULL,'mean','ESO 601- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153217,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153217,34.36,0.47,74.6,72721,NULL,NULL,'H','ESO 601- G 005',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153218,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153218,38.01,0.46,399,72722,70,NULL,NULL,'2MASX J22013873-0719025',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,330.4112917,-7.31722,0.081,NULL,49921169207,780018268,12187785,17.8),(153219,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16298','RN',153219,40.92,0.29,1190,72723,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16298',0.282787,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153220,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16298','RN',153220,41.14,0.27,1320,72723,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16298',0.282787,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153221,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16298','N',153221,40.82,0.19,1460,72723,70,NULL,'SALT 2','SDSS-II SN 16298',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153222,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16298','N',153222,40.85,0.19,1480,72723,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16298',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153223,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153223,37.07,0.46,259,72724,70,NULL,NULL,'2MASX J22014179-0738165',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000103,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,330.4239583,-7.63786,0.081,NULL,49922971197,780046424,12188225,16.8),(153224,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153224,34.96,0.47,98.1,72725,70,NULL,NULL,'NGC 7181',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.0001,NULL,'14.96',0.8,'S0^0^ pec:','Group member',NULL,NULL,NULL,1,330.4312083,-1.96056,0.233,NULL,49824628509,778509820,12164215,14.96),(153225,'BCG','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153225,37.88,0.35,349,72726,60,NULL,'ABELL 2410, BCG','2MASX J22014508-0953361',0.0806,'1980ApJ...241..486H',1980,1,0.51,NULL,'G',0.000103,NULL,'15.98',0.45,NULL,'Brightest group member',NULL,NULL,NULL,1,330.437875,-9.89331,0.097,NULL,49873323741,779270683,12176104,15.98),(153226,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545','R',153226,40.72,0.24,1060,72727,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19545',0.309131,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,330.443041667,0.40111,0.177,NULL,52184957697,815389964,12740468,NULL),(153227,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545','R',153227,40.86,0.21,1140,72727,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19545',0.309131,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153228,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545',NULL,153228,40.36,0.09,1180,72727,70,NULL,'SN photometric redshift distance, z photo =0.327 +/- 0.017','SDSS-II SN 19545',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153229,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545',NULL,153229,40.6,0.15,1320,72727,70,NULL,'SALT 2','SDSS-II SN 19545',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153230,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 19545',NULL,153230,40.63,0.15,1340,72727,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19545',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153231,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153231,38,0.46,399,72728,70,NULL,NULL,'2MASXi J2201478-080455',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.15,'AGN',NULL,NULL,NULL,NULL,1,330.449333,-8.08211,0.073,NULL,49923122993,780048796,12188262,18.3),(153232,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SNF20080909-030','RN',153232,35.49,0.13,125,72729,NULL,NULL,'MLCS2k2, R(V) = 3.1','SNF20080909-030',NULL,'2015Sci...347.1459K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153233,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SNF20080909-030','RN',153233,35.52,0.12,127,72729,NULL,NULL,'MLCS2k2, R(V) = 1.8','SNF20080909-030',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153234,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02639','R',153234,39.84,0.19,766,72730,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220151.40+003952.0',0.215,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'19.8g',0.07,NULL,NULL,NULL,NULL,NULL,1,330.4642083,0.66447,0.165,NULL,52184929356,815389521,12740461,19.8),(153235,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02639','R',153235,40.02,0.13,832,72730,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220151.40+003952.0',0.215,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153236,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02639',NULL,153236,39.74,0.09,887,72730,70,NULL,'SALT 2','SDSS J220151.40+003952.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153237,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02639',NULL,153237,39.76,0.09,895,72730,70,NULL,'SALT 2, Malmquist cor.','SDSS J220151.40+003952.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153238,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153238,35.16,0.48,108,72731,70,NULL,NULL,'NGC 7182',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000067,NULL,'15.35',0.4,'SB(rs)0+:','Group member',NULL,NULL,NULL,1,330.46525,-2.19658,0.261,NULL,49824565428,778508834,12164200,15.35),(153239,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153239,36.65,0.27,214,72732,70,NULL,NULL,'2MASX J22015197+0019078',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000201,NULL,'15.6g',0.42,'E0',NULL,NULL,NULL,NULL,1,330.4665417,0.319,0.129,NULL,52184792265,815387379,12740427,15.6),(153240,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2006iy',NULL,153240,39.5,0.06,794,72733,70,NULL,'Hubble residual 0.01 for z0.20540','SDSS-II SN 14212 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,330.470625,1.04447,0.201,NULL,52184568844,815383888,12740373,NULL),(153241,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 14212','R',153241,40.06,0.18,853,72733,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006iy','SDSS-II SN 14212 HOST',0.20449,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153242,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 14212','R',153242,40.2,0.08,908,72733,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006iy','SDSS-II SN 14212 HOST',0.20449,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153243,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2006iy',NULL,153243,39.91,0.07,959,72733,70,NULL,'SALT 2','SDSS-II SN 14212 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153244,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2006iy',NULL,153244,39.92,0.07,964,72733,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14212 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153245,'Magnitude','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153245,37.21,0.13,277,72734,100,NULL,NULL,'ESO 146-IG 005 NED01',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'G',0.00016,NULL,'16.1r',NULL,'E+ p',NULL,NULL,NULL,NULL,1,330.472125,-59.94531,0,NULL,48687451125,760741423,11886584,16.1),(153246,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153246,37.96,0.46,391,72735,70,NULL,NULL,'2MASX J22015404+0004548',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000192,NULL,'17.9g',0.11,'AGN',NULL,NULL,NULL,NULL,1,330.475125,0.08178,0.165,NULL,52184746979,815386671,12740416,17.9),(153247,'Magnitude','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153247,37.21,0.13,277,72736,100,NULL,NULL,'ABELL 3827',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM];R  [A]',NULL,NULL,NULL,NULL,1,330.483333,-59.94944,0,NULL,48687450980,760741421,11886584,NULL),(153248,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153248,32.78,0.8,36,72737,75,NULL,NULL,'UGCA 424',NULL,'1988NBGC.C....0000T',1988,1,2,NULL,'G',0.00002,NULL,'14',1.8,'SB(s)dm',NULL,NULL,NULL,NULL,1,330.497125,-12.19047,0.089,NULL,49749231784,777331746,12145808,14),(153249,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153249,35.78,0.58,144,72738,70,NULL,NULL,'2MASX J22015957-1428241',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.50',NULL,NULL,NULL,NULL,NULL,NULL,1,330.498417,-14.47353,0.081,NULL,49781238863,777831857,12153622,15.5),(153250,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 06690','RN',153250,44.09,0.41,4840,72739,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 06690',0.356647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153251,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153251,37.6,0.46,331,72740,70,NULL,NULL,'2MASX J22020061-0058275',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000191,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.5027083,-0.97439,0.217,NULL,49823257156,778488393,12163881,17.5),(153252,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153252,36.65,0.27,214,72741,70,NULL,NULL,'2MASX J22020089+0005551',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'17.5g',0.17,NULL,NULL,NULL,NULL,NULL,1,330.5035417,0.09875,0.165,NULL,52184758847,815386856,12740419,17.5),(153253,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153253,32.65,0.8,33.9,72742,75,NULL,'B','NGC 7172',NULL,'1988NBGC.C....0000T',1988,1,2.5,'Joguet et al. (2001A&A...380...19J) claim \\\"No activity\\\".','G',0.00004,NULL,'12.85',1.4,'Sa pec sp;Sy2  HII','Group member, radial-velocity confirmed',NULL,NULL,'Sy 2',1,330.507875,-31.86967,0,NULL,50537196895,789643701,12338182,12.85),(153254,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','PTF10pvi','N',153254,37.94,0.03,359,72743,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10pvi',0.0802,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153255,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153255,32.48,0.15,31.3,72744,NULL,NULL,'TOM(g) = -7.2 mag','NGC 7173',NULL,'2012MNRAS.422.3591C',2012,1,1.2,NULL,'G',0.00004,NULL,'13.08',0.9,'E+ pec:','in a triple',NULL,NULL,NULL,1,330.5132917,-31.97369,0,NULL,50591733484,790495835,12351497,13.08),(153256,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153256,32.76,0.24,35.6,72744,NULL,NULL,'TOM(z) = -8.4 mag','NGC 7173',NULL,'2012MNRAS.422.3591C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153257,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153257,32.48,0.19,31.3,72744,NULL,NULL,'I','NGC 7173',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153258,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153258,32.48,0.19,31.3,72744,NULL,NULL,NULL,'NGC 7173',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153259,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153259,32.48,0.14,31.3,72744,74.4,NULL,NULL,'NGC 7173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153260,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153260,32.59,0.19,32.9,72744,NULL,NULL,'Malmquist cor.','NGC 7173',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153261,'D-Sigma','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153261,32.86,0.4,37.4,72744,75,NULL,'Edat, raw','NGC 7173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153262,'D-Sigma','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153262,33.13,0.4,42.2,72744,75,NULL,'Edat, cor','NGC 7173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153263,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153263,31.57,0.63,20.6,72744,95,NULL,'Michard 1979b, c','NGC 7173',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153264,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153264,31.77,0.44,22.6,72744,95,NULL,'Weighted Mean','NGC 7173',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153265,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153265,32.4,0.46,30.2,72744,95,NULL,'Michard 1979a','NGC 7173',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153266,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153266,32.87,0.41,37.4,72744,NULL,NULL,NULL,'NGC 7173',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153267,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153267,33.03,0.41,40.4,72744,NULL,NULL,'Malmquist cor.','NGC 7173',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153268,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153268,32.52,0.8,32,72744,75,NULL,'B','NGC 7173',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153269,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153269,32.77,0.4,35.8,72744,NULL,NULL,'mean','NGC 7173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153270,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153270,33.48,0.45,49.6,72744,NULL,NULL,'K','NGC 7173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153271,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153271,36.1,0.46,166,72745,70,NULL,NULL,'2MASX J22020354+1127245',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000163,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,330.514833,11.45672,0.237,NULL,52282788905,816918576,12764352,17.5),(153272,'BCG','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153272,37.88,0.35,349,72746,60,NULL,NULL,'ABELL 2410',0.0806,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,330.524583,-9.82444,0.097,NULL,49872538285,779258410,12175912,NULL),(153273,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153273,32.3,0.19,28.8,72747,NULL,NULL,'g-band','NGC 7174',NULL,'2015MNRAS.447.3639M',2015,1,2.3,NULL,'G',0.00003,NULL,'14.23',1.2,'Sab pec sp','in a triple',NULL,NULL,NULL,1,330.526875,-31.99297,0,NULL,50591732922,790495826,12351497,14.23),(153274,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153274,32.7,0.19,34.8,72747,NULL,NULL,'z-band','NGC 7174',NULL,'2015MNRAS.447.3639M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153275,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153275,32.75,0.8,35.5,72747,75,NULL,'B','NGC 7174',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153276,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153276,37.38,0.53,300,72748,70,NULL,NULL,'2MASX J22020687-1431551',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.73',NULL,NULL,NULL,NULL,NULL,NULL,1,330.52875,-14.53208,0.077,NULL,49781273829,777832403,12153631,15.73),(153277,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153277,32.72,0.24,35,72749,NULL,NULL,'I','NGC 7168',NULL,'2001ApJ...546..681T',2001,1,2,NULL,'G',0.00007,NULL,'12.86',1.5,'E+','Line-of-sight pair member',NULL,NULL,NULL,1,330.530833,-51.74308,0,NULL,50628146940,791064795,12360387,12.86),(153278,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153278,32.75,0.14,35.5,72749,74.4,NULL,NULL,'NGC 7168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153279,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153279,31.54,0.65,20.3,72749,95,NULL,'Weighted Mean','NGC 7168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153280,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153280,32.88,0.81,37.7,72749,55,NULL,'Visvanathan & Sandage 1979','NGC 7168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153281,'Tertiary','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153281,31.55,0.71,20.4,72749,95,NULL,NULL,'NGC 7168',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153282,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153282,32.7,0.8,34.7,72749,75,NULL,'B','NGC 7168',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153283,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153283,32.72,0.4,35,72749,73,NULL,'opt','NGC 7168',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153284,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153284,32.9,0.4,38,72749,NULL,NULL,'mean','NGC 7168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153285,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153285,32.94,0.45,38.7,72749,NULL,NULL,'K','NGC 7168',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153286,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153286,32.3,0.19,28.8,72750,NULL,NULL,'g-band','NGC 7176',NULL,'2015MNRAS.447.3639M',2015,1,1,NULL,'G',0.000047,NULL,'12.34',0.8,'E pec:','in a triple',NULL,NULL,NULL,1,330.535167,-31.98975,0,NULL,50591732909,790495826,12351497,12.34),(153287,'GCLF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153287,32.7,0.19,34.8,72750,NULL,NULL,'z-band','NGC 7176',NULL,'2015MNRAS.447.3639M',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153288,'D-Sigma','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153288,32.86,0.4,37.4,72750,75,NULL,'Edat, raw','NGC 7176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153289,'D-Sigma','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153289,33.13,0.4,42.2,72750,75,NULL,'Edat, cor','NGC 7176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153290,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153290,30.37,0.63,11.9,72750,95,NULL,'Michard 1979b, c','NGC 7176',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153291,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153291,30.95,0.44,15.5,72750,95,NULL,'Weighted Mean','NGC 7176',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153292,'Faber-Jackson','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153292,31.66,0.46,21.5,72750,95,NULL,'Michard 1979a','NGC 7176',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153293,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153293,32.54,0.8,32.3,72750,75,NULL,'B','NGC 7176',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153294,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153294,32.48,NULL,31.3,72750,71,NULL,'HDCE 1175,[MdL89] 59, 75 galaxies','NGC 7176',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153295,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153295,32.56,0.45,32.5,72750,NULL,NULL,'K','NGC 7176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153296,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153296,32.56,0.3,32.5,72750,NULL,NULL,'HDCE 1175,[MdL89] 59, 10 galaxies','NGC 7176',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153297,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153297,32.77,0.4,35.8,72750,NULL,NULL,'mean','NGC 7176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153298,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 17535','RN',153298,40.99,0.16,1360,72751,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17535',0.159653,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153299,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 17535','RN',153299,41.65,0.24,1840,72751,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17535',0.159653,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153300,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153300,37.91,0.46,383,72752,70,NULL,NULL,'2MASX J22021368-0104205',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,330.556875,-1.07228,0.217,NULL,49823253930,778488342,12163880,18.7),(153301,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153301,36.78,0.46,227,72753,70,NULL,NULL,'2MASX J22021798-0805523',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'16.1g',0.33,'AGN',NULL,NULL,NULL,NULL,1,330.574833333,-8.09786,0.089,NULL,49867761431,779183772,12174746,16.1),(153302,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153302,35.36,0.58,118,72754,70,NULL,NULL,'2MASX J22021809-5147062',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.000133,NULL,'15.0',0.63,'E','Line-of-sight pair member',NULL,NULL,NULL,1,330.5752917,-51.78503,0,NULL,50628135458,791064616,12360384,15),(153303,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153303,31.23,0.14,17.6,72755,74.4,NULL,NULL,'NGC 7180',NULL,'2013AJ....146...86T',2013,1,1.6,'Da Costa, et al. (1998,AJ,116,1) give v = 1566 +/- 33 km/sec.','G',0.000057,NULL,'13.52',0.7,'S0^0^?         LLAGN',NULL,NULL,NULL,NULL,1,330.576916667,-20.54775,0.073,NULL,49737279949,777144999,12142890,13.52),(153304,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153304,31.26,0.26,17.9,72755,NULL,NULL,'I','NGC 7180',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153305,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153305,31.26,0.26,17.9,72755,NULL,NULL,NULL,'NGC 7180',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153306,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153306,31.39,0.26,18.9,72755,NULL,NULL,'Malmquist cor.','NGC 7180',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153307,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153307,31.54,0.41,20.3,72755,NULL,NULL,NULL,'NGC 7180',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153308,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153308,31.92,0.41,24.2,72755,NULL,NULL,'Malmquist cor.','NGC 7180',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153309,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153309,31.26,0.8,17.8,72755,75,NULL,'B','NGC 7180',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153310,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153310,30.57,0.4,13,72755,NULL,NULL,'mean','NGC 7180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153311,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153311,31.34,0.45,18.5,72755,NULL,NULL,'K','NGC 7180',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153312,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153312,36.19,0.2,173,72756,74.4,NULL,NULL,'UGC 11877',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',NULL,NULL,'15.37',0.4,'Sd',NULL,NULL,NULL,NULL,1,330.58375,11.85897,0.257,NULL,52282735768,816917746,12764339,15.37),(153313,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153313,31.76,0.8,22.5,72757,75,NULL,'MAT, I','ESO 601- G 007',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000026,NULL,'15.39',0.4,'Sc',NULL,NULL,NULL,NULL,1,330.590125,-21.04092,0.057,NULL,50874873282,794919895,12420623,15.39),(153314,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153314,30.72,0.32,13.9,72757,85,NULL,'I, inv','ESO 601- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153315,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153315,30.78,0.32,14.3,72757,85,NULL,'I, raw','ESO 601- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153316,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153316,30.96,0.62,15.5,72757,NULL,NULL,NULL,'ESO 601- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153317,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153317,31.19,0.43,17.3,72757,75,NULL,'MAT, I, inv','ESO 601- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153318,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153318,31.31,0.53,18.3,72757,NULL,NULL,'Malmquist cor.','ESO 601- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153319,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153319,31.35,0.43,18.7,72757,75,NULL,'MAT, I, raw','ESO 601- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153320,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153320,31.44,0.2,19.4,72757,74.4,NULL,NULL,'ESO 601- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153321,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153321,31.52,0.43,20.2,72757,75,NULL,'3.6 micron, color + selection bias corrected','ESO 601- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153322,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153322,31.7,0.43,21.9,72757,75,NULL,'3.6 micron, color corrected','ESO 601- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153323,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153323,31.71,0.43,22,72757,75,NULL,'MAT, I, cor','ESO 601- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153324,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153324,31.99,0.4,25,72757,NULL,NULL,NULL,'ESO 601- G 007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153325,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153325,31.99,0.4,25,72757,73,NULL,'opt','ESO 601- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153326,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153326,34.99,0.56,99.7,72758,NULL,NULL,'Malmquist cor.','NGC 7178',NULL,'2009ApJS..182..474S',2009,1,1.22,NULL,'G',0.000033,NULL,'14.32',0.46,'Sb:',NULL,NULL,NULL,NULL,1,330.605,-35.79036,0,NULL,50566031500,790094242,12345222,14.32),(153327,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153327,35.09,0.54,104,72758,NULL,NULL,NULL,'NGC 7178',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153328,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153328,35.13,0.2,106,72758,74.4,NULL,NULL,'NGC 7178',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153329,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153329,36.28,0.56,180,72759,70,NULL,NULL,'2MASX J22022773-0224359',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'16.94',0.19,NULL,NULL,NULL,NULL,NULL,1,330.6155417,-2.41006,0.265,NULL,49825106564,778517290,12164332,16.94),(153330,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153330,34.37,0.49,75,72760,75,NULL,'IR','UGC 11876',NULL,'2011yCatp016004901K',2011,1,1.14,NULL,'G',0.000037,NULL,'16.0',0.1,'Sd',NULL,NULL,NULL,NULL,1,330.62075,2.83411,0.109,NULL,52190696635,815479634,12741869,16),(153331,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153331,34.44,0.2,77.3,72760,74.4,NULL,NULL,'UGC 11876',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153332,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153332,34.54,0.53,81.1,72760,NULL,NULL,NULL,'UGC 11876',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153333,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153333,34.59,NULL,82.8,72760,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153334,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153334,34.62,NULL,84,72760,NULL,NULL,'Dipole + Quadrupole','UGC 11876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153335,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153335,34.63,NULL,84.5,72760,NULL,NULL,'Dipole','UGC 11876',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153336,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153336,34.69,NULL,86.7,72760,NULL,NULL,NULL,'UGC 11876',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153337,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153337,34.88,0.45,94.7,72760,NULL,NULL,'Malmquist cor.','UGC 11876',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153338,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153338,35.4,0.52,120,72761,70,NULL,NULL,'2MASX J22022947-0200549',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.34',0.41,NULL,NULL,NULL,NULL,NULL,1,330.6227083,-2.01525,0.233,NULL,49822670740,778479230,12163737,16.34),(153339,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16312','RN',153339,40.56,0.23,1000,72762,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16312',0.28907,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153340,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16312','RN',153340,40.83,0.15,1140,72762,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16312',0.28907,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153341,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13033','RN',153341,42.73,0.23,2740,72763,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13033',0.282192,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153342,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13033','RN',153342,42.74,0.26,2750,72763,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13033',0.282192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153343,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153343,31.62,0.8,21.1,72764,75,NULL,'B','IC 1420',NULL,'1988NBGC.C....0000T',1988,1,NULL,'Colliding pair, not noted as double in CGCG, MCG, or UGC.','GPair',0.000017,NULL,NULL,NULL,'I0pec + I0pec',NULL,NULL,NULL,NULL,1,330.633208333,19.75011,0.177,NULL,52217703502,815901617,12748462,NULL),(153344,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153344,36.52,0.46,201,72765,70,NULL,NULL,'2MASX J22023330-0917313',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.00015,NULL,'15.6g',0.44,'E0',NULL,NULL,NULL,NULL,1,330.638833,-9.29208,0.089,NULL,49874689750,779292027,12176437,15.6),(153345,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153345,36.53,0.57,202,72765,70,NULL,NULL,'2MASX J22023330-0917313',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153346,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153346,31.61,0.8,21,72766,75,NULL,NULL,'ESO 189- G 021',NULL,'1988NBGC.C....0000T',1988,1,1.8,NULL,'G',0.00002,NULL,'15.14',1.1,'SAB(s)m',NULL,NULL,NULL,NULL,1,330.652375,-54.07864,0,NULL,48695195650,760862432,11888475,15.14),(153347,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153347,36.65,0.63,214,72767,70,NULL,NULL,'2MASX J22023686-4730272',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.84',0.32,NULL,NULL,NULL,NULL,NULL,1,330.653667,-47.50758,0,NULL,50653897500,791467148,12366674,16.84),(153348,'Ring Diameter','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153348,30.4,0.84,12,72768,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7184',NULL,'1981ApJS...45..541P',1981,1,6,NULL,'G',0.00001,NULL,'12.24',1.5,'SB(r)c         LLAGN',NULL,NULL,NULL,NULL,1,330.665917,-20.81283,0.057,NULL,49737140385,777142818,12142856,12.24),(153349,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153349,32.6,0.8,33.1,72768,75,NULL,'A82, H','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153350,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153350,32.6,0.8,33.1,72768,75,NULL,'MAT, I','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153351,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153351,32.27,0.43,28.5,72768,75,NULL,'MAT, I, raw','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153352,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153352,32.43,0.35,30.6,72768,NULL,NULL,NULL,'NGC 7184',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153353,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153353,32.48,0.32,31.3,72768,85,NULL,'I, raw','NGC 7184',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153354,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153354,32.56,0.32,32.5,72768,85,NULL,'I, inv','NGC 7184',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153355,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153355,32.56,0.43,32.5,72768,75,NULL,'MAT, I, cor','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153356,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153356,32.6,0.47,33.1,72768,75,NULL,'A82, H, raw','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153357,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153357,32.61,0.43,33.2,72768,75,NULL,'MAT, I, inv','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153358,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153358,32.67,0.4,34.1,72768,75,NULL,'B','NGC 7184',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153359,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153359,32.72,0.2,35,72768,74.4,NULL,NULL,'NGC 7184',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153360,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153360,32.74,0.43,35.3,72768,75,NULL,'3.6 micron, color corrected','NGC 7184',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153361,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153361,32.79,0.09,36.2,72768,NULL,NULL,NULL,'NGC 7184',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153362,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153362,32.84,0.47,37.1,72768,75,NULL,'A82, H, inv','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153363,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153363,32.91,0.47,38.1,72768,75,NULL,'A82, H, cor','NGC 7184',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153364,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153364,32.91,0.43,38.2,72768,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7184',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153365,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153365,38.13,0.46,423,72769,70,NULL,NULL,'SDSS J220240.27-001044.0',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,330.667791667,-0.17889,0.165,NULL,49820264143,778441627,12163150,17.9),(153366,'Cepheids','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153366,25.9,NULL,1.51,72770,NULL,18.4,NULL,'IC 5152',NULL,'1988BAAS...20Q1084C',1988,1,5.2,NULL,'G',0.000007,NULL,'11.0B',3.2,'IA(s)m','Group non-member, foreground',NULL,NULL,NULL,1,330.6729583,-51.29644,0,0,50628367673,791068244,12360441,11),(153367,'CMD','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153367,26.15,0.2,1.7,72770,NULL,NULL,NULL,'IC 5152',NULL,'1999AJ....117.1743Z',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153368,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153368,26.36,0.1,1.87,72770,NULL,NULL,NULL,'IC 5152',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153369,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153369,26.39,0.19,1.9,72770,NULL,NULL,NULL,'IC 5152',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153370,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153370,26.46,0.1,1.96,72770,74.4,NULL,NULL,'IC 5152',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153371,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153371,26.47,0.08,1.97,72770,NULL,NULL,NULL,'IC 5152',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153372,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153372,26.55,0.06,2.04,72770,NULL,NULL,'I','IC 5152',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153373,'TRGB','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153373,26.58,0.18,2.07,72770,NULL,NULL,NULL,'IC 5152',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153374,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153374,25.09,0.8,1,72770,75,NULL,'B','IC 5152',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153375,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153375,27.1,NULL,2.63,72770,NULL,NULL,'LEDA [April 2006]','IC 5152',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153376,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153376,33.72,0.8,55.5,72771,75,NULL,'MAT, I','ESO 404- G 023',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00001,NULL,'13.97',1.1,'SB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.673166667,-33.80506,0,NULL,50561675709,790026182,12344159,13.97),(153377,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153377,33.21,0.32,43.8,72771,85,NULL,'I, raw','ESO 404- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153378,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153378,33.24,0.32,44.4,72771,85,NULL,'I, inv','ESO 404- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153379,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153379,33.27,0.43,45.1,72771,75,NULL,'MAT, I, raw','ESO 404- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153380,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153380,33.42,0.43,48.3,72771,75,NULL,'MAT, I, inv','ESO 404- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153381,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153381,33.5,0.43,50.2,72771,75,NULL,'MAT, I, cor','ESO 404- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153382,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153382,33.59,0.2,52.2,72771,74.4,NULL,NULL,'ESO 404- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153383,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153383,33.76,0.61,56.6,72771,NULL,NULL,NULL,'ESO 404- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153384,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153384,33.83,0.59,58.5,72771,NULL,NULL,'Malmquist cor.','ESO 404- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153385,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153385,33.95,0.4,61.8,72771,NULL,NULL,'mean','ESO 404- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153386,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153386,34.1,0.47,66.1,72771,NULL,NULL,'H','ESO 404- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153387,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153387,34.21,0.46,69.5,72771,NULL,NULL,'J','ESO 404- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153388,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153388,34.22,0.45,70,72771,NULL,NULL,'K','ESO 404- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153389,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153389,37.12,0.58,266,72772,70,NULL,NULL,'2MASX J22024195-0230589',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.84',0.33,NULL,NULL,NULL,NULL,NULL,1,330.6747917,-2.51647,0.249,NULL,49825103588,778517243,12164331,16.84),(153390,'BL Lac Luminosity','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153390,38.31,NULL,430,72773,NULL,NULL,NULL,'BL Lac',0.0686,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.0004,NULL,'14.7V',NULL,'Opt.var.       BLLAC',NULL,NULL,'radio jet','HP BL Lac',1,330.680375,42.27778,1.321,NULL,55513547671,867399182,13553112,14.7),(153391,'GeV TeV ratio','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153391,38.55,NULL,514,72773,72,NULL,NULL,'BL Lac',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153392,'GeV TeV ratio','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153392,39.95,0.75,977,72773,72,NULL,NULL,'BL Lac',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153393,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153393,35.52,0.71,127,72774,70,NULL,NULL,'2MASX J22024374-0206069',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.58',0.23,NULL,NULL,NULL,NULL,NULL,1,330.682208333,-2.10189,0.233,NULL,49822638861,778478732,12163730,17.58),(153394,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13771','RN',153394,43.34,0.26,3280,72775,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13771',0.423507,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153395,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13771','RN',153395,44.13,0.31,4700,72775,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13771',0.423507,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153396,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153396,35.12,0.46,106,72776,70,NULL,NULL,'NGC 7169',NULL,'2014MNRAS.445.2677S',2014,1,0.97,NULL,'G',0.00015,NULL,'14.51',0.48,'SAB0- sp:',NULL,NULL,NULL,NULL,1,330.702667,-47.69783,0,NULL,50653930761,791467668,12366682,14.51),(153397,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153397,34.05,0.2,64.6,72777,74.4,NULL,NULL,'UGC 11881',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000017,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,330.71925,17.90306,0.213,NULL,52272469894,816757342,12761833,16),(153398,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153398,34.25,0.33,70.7,72777,NULL,NULL,NULL,'UGC 11881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153399,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153399,34.48,0.29,78.6,72777,NULL,NULL,'Malmquist cor.','UGC 11881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153400,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153400,36.99,0.46,250,72778,70,NULL,NULL,'2MASX J22025366-0047049',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.7g',0.24,NULL,NULL,NULL,NULL,NULL,1,330.72375,-0.78458,0.169,NULL,49823891914,778498311,12164036,16.7),(153401,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153401,31.51,0.37,20,72779,NULL,NULL,'I','NGC 7185',NULL,'2001ApJ...546..681T',2001,1,2.3,NULL,'G',0.000047,NULL,'13.37',1.5,'SAB(rs)0- pec?',NULL,NULL,NULL,NULL,1,330.7364583,-20.47128,0.069,NULL,49737190433,777143600,12142868,13.37),(153402,'SBF','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153402,31.55,0.14,20.4,72779,74.4,NULL,NULL,'NGC 7185',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153403,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153403,31.98,0.4,24.9,72779,NULL,NULL,'mean','NGC 7185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153404,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153404,32.36,0.45,29.6,72779,NULL,NULL,'K','NGC 7185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153405,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153405,31.66,0.8,21.5,72780,75,NULL,'MAT, I','ESO 532- G 014',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000017,NULL,'15.24',0.7,'SAB(s)cd pec:',NULL,NULL,NULL,NULL,1,330.738083,-22.47197,0.045,NULL,50869914428,794842412,12419412,15.24),(153406,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153406,30.45,0.32,12.3,72780,85,NULL,'I, inv','ESO 532- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153407,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153407,30.55,0.32,12.9,72780,85,NULL,'I, raw','ESO 532- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153408,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153408,30.95,0.43,15.5,72780,75,NULL,'MAT, I, inv','ESO 532- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153409,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153409,31.22,0.43,17.5,72780,75,NULL,'MAT, I, raw','ESO 532- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153410,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153410,31.57,0.43,20.6,72780,75,NULL,'MAT, I, cor','ESO 532- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153411,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153411,31.59,0.2,20.8,72780,74.4,NULL,NULL,'ESO 532- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153412,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153412,31.71,0.43,22,72780,75,NULL,'3.6 micron, color corrected','ESO 532- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153413,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153413,31.78,0.43,22.7,72780,75,NULL,'3.6 micron, color + selection bias corrected','ESO 532- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153414,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153414,31.83,0.56,23.2,72780,NULL,NULL,NULL,'ESO 532- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153415,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153415,31.98,0.4,24.9,72780,NULL,NULL,NULL,'ESO 532- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153416,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153416,31.98,0.4,24.9,72780,73,NULL,'opt','ESO 532- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153417,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153417,32.12,0.49,26.6,72780,NULL,NULL,'Malmquist cor.','ESO 532- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153418,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153418,37.86,0.46,373,72781,70,NULL,NULL,'2MASX J22025808+1156206',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,330.742125,11.93894,0.257,NULL,52282772540,816918320,12764348,17.5),(153419,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153419,36.39,0.53,190,72782,70,NULL,NULL,'IC 1419',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.98',0.34,NULL,NULL,NULL,NULL,NULL,1,330.745167,-9.92097,0.097,NULL,49873230897,779269232,12176081,15.98),(153420,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153420,31.11,0.87,16.7,72783,NULL,NULL,NULL,'ESO 532- G 015',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000027,NULL,'15.75',0.3,'S.../Irr',NULL,NULL,NULL,NULL,1,330.7842917,-22.39447,0.045,NULL,50870389016,794849828,12419528,15.75),(153421,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153421,31.15,0.2,17,72783,74.4,NULL,NULL,'ESO 532- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153422,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153422,31.73,0.39,22.2,72783,73,NULL,'opt','ESO 532- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153423,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153423,31.83,0.62,23.2,72783,NULL,NULL,'Malmquist cor.','ESO 532- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153424,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153424,37.1,0.46,263,72784,70,NULL,NULL,'2MASX J22031228+0100593',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,330.801167,1.01658,0.157,NULL,52185529154,815398893,12740607,17.7),(153425,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153425,35.54,0.42,128,72785,NULL,NULL,'Malmquist cor.','ESO 532- G 016',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.80',0.7,'Sb',NULL,NULL,NULL,NULL,1,330.8027917,-26.40686,0.029,NULL,51408055358,803250864,12550794,14.8),(153426,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153426,35.61,0.41,132,72785,NULL,NULL,NULL,'ESO 532- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153427,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153427,35.65,0.2,135,72785,74.4,NULL,NULL,'ESO 532- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153428,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153428,39,0.46,630,72786,70,NULL,NULL,'SDSS J220313.32-091710.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00016,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,330.8055417,-9.28625,0.089,NULL,49874649889,779291404,12176428,18.6),(153429,'IRAS','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153429,32.7,0.8,34.7,72787,75,NULL,'MAT, I','IC 5156',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'13.21',0.8,'SB(rs)ab       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.811958333,-33.83844,0,NULL,50561663637,790025994,12344156,13.21),(153430,'Tully est','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153430,32.58,0.8,32.8,72787,75,NULL,'B','IC 5156',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153431,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153431,32.62,0.47,33.4,72787,NULL,NULL,'H','IC 5156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153432,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153432,32.62,0.46,33.4,72787,NULL,NULL,'J','IC 5156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153433,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153433,32.63,0.45,33.6,72787,NULL,NULL,'K','IC 5156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153434,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153434,32.7,0.07,34.7,72787,NULL,NULL,NULL,'IC 5156',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153435,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153435,32.75,0.4,35.5,72787,NULL,NULL,'mean','IC 5156',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153436,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153436,32.83,0.43,36.8,72787,75,NULL,'3.6 micron, color corrected','IC 5156',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153437,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153437,32.87,0.43,37.4,72787,75,NULL,'3.6 micron, color + selection bias corrected','IC 5156',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153438,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153438,32.87,0.32,37.5,72787,85,NULL,'I, raw','IC 5156',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153439,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153439,32.88,0.2,37.7,72787,74.4,NULL,NULL,'IC 5156',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153440,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153440,32.91,0.43,38.2,72787,75,NULL,'MAT, I, raw','IC 5156',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153441,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153441,32.93,0.32,38.5,72787,85,NULL,'I, inv','IC 5156',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153442,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153442,33.1,0.43,41.7,72787,75,NULL,'MAT, I, cor','IC 5156',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153443,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153443,33.16,0.43,42.8,72787,75,NULL,'MAT, I, inv','IC 5156',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153444,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153444,35.34,0.2,117,72788,74.4,NULL,NULL,'NGC 7189',NULL,'2013AJ....146...86T',2013,1,0.83,NULL,'G',0.00003,NULL,'14.2g',0.75,'SB(rs)b pec:   LINER',NULL,NULL,NULL,NULL,1,330.816667,0.57111,0.129,NULL,52184864779,815388512,12740445,14.2),(153445,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16357','R',153445,41.57,0.35,1500,72789,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pi','SN 2006pi',0.368,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,330.819166667,-0.60683,0.157,NULL,49823806815,778496981,12164015,NULL),(153446,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 16357','R',153446,41.63,0.2,1550,72789,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pi','SN 2006pi',0.368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153447,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153447,35.44,0.56,122,72790,70,NULL,NULL,'2MASX J22031661-1756404',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.77',0.43,'S0',NULL,NULL,NULL,NULL,1,330.819208333,-17.94464,0.069,NULL,49783413284,777865832,12154153,15.77),(153448,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153448,35.52,0.46,127,72791,70,NULL,NULL,'CGCG 428-021',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000168,NULL,'16.0g',0.28,'S0','Group member',NULL,NULL,NULL,1,330.844125,12.64936,0.253,NULL,52252994290,816453035,12757078,16),(153449,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153449,38.05,0.46,407,72792,70,NULL,NULL,'2MASX J22032411-0713136',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000149,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,330.850333,-7.22047,0.081,NULL,49866543453,779164741,12174449,17.6),(153450,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 15401',NULL,153450,40.41,0.25,1210,72793,70,NULL,'SN photometric redshift distance, z photo =0.337 +/- 0.051','SDSS-II SN 15401',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,330.855333333,0.57633,0.129,NULL,52184866081,815388532,12740445,22.6),(153451,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153451,37.76,0.23,357,72794,70,NULL,NULL,'2MASX J22032672-0015338',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000136,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,330.861291667,-0.25936,0.149,NULL,49820452749,778444574,12163196,17.5),(153452,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153452,30.83,0.43,14.7,72795,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7188',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00004,NULL,'13.78',0.7,'(R\'_2)SB(s)bc  HII',NULL,NULL,NULL,NULL,1,330.870833,-20.31797,0.061,NULL,49738082334,777157536,12143086,13.78),(153453,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153453,35.28,0.4,114,72796,NULL,NULL,'mean','NGC 7194',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000023,NULL,'14.14',0.9,'E','Group member',NULL,NULL,NULL,1,330.878917,12.63678,0.253,NULL,52253018118,816453408,12757084,14.14),(153454,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153454,35.45,0.45,123,72796,NULL,NULL,'K','NGC 7194',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153455,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153455,38.53,0.46,508,72797,70,NULL,NULL,'SDSS J220332.79+003231.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000148,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,330.886625,0.54211,0.129,NULL,52182016907,815344014,12739750,18.9),(153456,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153456,29.43,0.2,7.69,72798,74.4,NULL,NULL,'UGC 11891',NULL,'2013AJ....146...86T',2013,1,4.2,'Position in 1987A&AS...70..191S is for an HII region in the galaxy.','G',0.00001,NULL,'14.4',3.2,'Im',NULL,NULL,NULL,NULL,1,330.891166667,43.74922,NULL,NULL,55509187278,867331051,13552047,14.4),(153457,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153457,29.64,0.4,8.47,72798,NULL,NULL,NULL,'UGC 11891',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153458,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153458,30.1,0.4,10.5,72798,75,NULL,'B','UGC 11891',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153459,'Tully-Fisher','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153459,30.62,0.4,13.3,72798,73,NULL,'opt','UGC 11891',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153460,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153460,37.52,0.46,319,72799,70,NULL,NULL,'2MASX J22033446+0058491',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,330.8935417,0.98047,0.157,NULL,52185292742,815395199,12740549,18.1),(153461,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13772','RN',153461,42.13,0.21,2070,72800,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13772',0.287611,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153462,'SNIa SDSS','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 13772','RN',153462,42.38,0.25,2320,72800,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13772',0.287611,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153463,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,NULL,153463,36.41,0.56,192,72801,70,NULL,NULL,'2MASX J22034105-1002290',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.09',0.43,NULL,NULL,NULL,NULL,NULL,1,330.921083333,-10.04136,0.093,NULL,49872972377,779265193,12176018,16.09),(153464,'FP','2016-12-15 15:15:57','2016-12-16 11:21:13','1',NULL,'R',153464,37.76,0.23,357,72802,70,NULL,NULL,'2MASX J22034138-0009108',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,330.922375,-0.15311,0.149,NULL,49820430041,778444219,12163190,17.5),(153465,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153465,38.08,0.12,369,72803,74.2,NULL,'SALT 2','SDSS J220341.69+003413.9',0.12,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'24.3g',0.02,NULL,NULL,NULL,NULL,NULL,1,330.923708333,0.57056,0.129,NULL,52181996431,815343694,12739745,24.3),(153466,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153466,38.73,0.13,497,72803,70,NULL,'SALT 2','SDSS J220341.69+003413.9',0.12,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153467,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SDSS-II SN 02916','R',153467,38.75,0.19,500,72803,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fz','SDSS J220341.69+003413.9',0.1242,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153468,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153468,38.75,0.14,502,72803,65,NULL,'SALT2','SDSS J220341.69+003413.9',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153469,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153469,38.76,NULL,504,72803,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02916, SN 2005fz','SDSS J220341.69+003413.9',0.12,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153470,'SNIa','2016-12-15 15:15:57','2016-12-16 11:21:13','1','SN 2005fz',NULL,153470,38.92,0.11,542,72803,65,NULL,'MLCS2k2','SDSS J220341.69+003413.9',0.12,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153471,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 02916','R',153471,38.94,0.11,546,72803,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fz','SDSS J220341.69+003413.9',0.1242,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153472,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2005fz',NULL,153472,39.53,0.06,719,72803,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02916, SN 2005fz','SDSS J220341.69+003413.9',0.12,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153473,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153473,38.19,0.46,435,72804,70,NULL,NULL,'2MASX J22034380+0006541',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,330.9327083,0.11511,0.129,NULL,52181968201,815343253,12739738,17.4),(153474,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 12888','RN',153474,39.72,0.2,732,72805,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12888',0.201101,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153475,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 12888','RN',153475,40.05,0.15,851,72805,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12888',0.201101,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153476,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153476,35.19,0.52,109,72806,70,NULL,NULL,'2MASX J22034776-0228248',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000073,NULL,'16.39',0.3,NULL,NULL,NULL,NULL,NULL,1,330.949041667,-2.47347,0.257,NULL,49822195836,778471809,12163622,16.39),(153477,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153477,32.53,0.8,32.1,72807,75,NULL,'MAT, I','ESO 404- G 027',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000003,NULL,'13.92',0.9,'SB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,330.949333,-32.285,0,NULL,50591791239,790496738,12351511,13.92),(153478,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153478,32.06,0.69,25.8,72807,100,NULL,'mid-IR','ESO 404- G 027',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153479,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153479,32.58,0.4,32.8,72807,NULL,NULL,NULL,'ESO 404- G 027',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153480,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153480,32.61,0.13,33.3,72807,NULL,NULL,NULL,'ESO 404- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153481,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153481,32.66,0.32,34,72807,85,NULL,'I, raw','ESO 404- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153482,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153482,32.68,0.32,34.3,72807,85,NULL,'I, inv','ESO 404- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153483,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153483,32.71,0.43,34.8,72807,75,NULL,'MAT, I, raw','ESO 404- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153484,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153484,32.73,0.2,35.2,72807,74.4,NULL,NULL,'ESO 404- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153485,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153485,32.76,0.43,35.6,72807,75,NULL,'3.6 micron, color corrected','ESO 404- G 027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153486,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153486,32.82,0.43,36.6,72807,75,NULL,'3.6 micron, color + selection bias corrected','ESO 404- G 027',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153487,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153487,32.83,0.43,36.9,72807,75,NULL,'MAT, I, inv','ESO 404- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153488,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153488,32.89,NULL,37.8,72807,NULL,NULL,'B','ESO 404- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153489,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153489,32.9,NULL,38,72807,NULL,NULL,'I','ESO 404- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153490,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153490,32.91,0.43,38.2,72807,75,NULL,'MAT, I, cor','ESO 404- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153491,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153491,32.97,0.4,39.2,72807,NULL,NULL,'mean','ESO 404- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153492,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153492,33.37,0.46,47.2,72807,NULL,NULL,'J','ESO 404- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153493,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153493,33.45,0.45,49,72807,NULL,NULL,'K','ESO 404- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153494,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153494,33.51,0.47,50.3,72807,NULL,NULL,'H','ESO 404- G 027',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153495,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153495,36.39,0.54,190,72808,70,NULL,NULL,'2MASX J22034782-1757487',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.83',0.32,NULL,NULL,NULL,NULL,NULL,1,330.9495,-17.96353,0.069,NULL,49783444318,777866317,12154161,16.83),(153496,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153496,37.07,0.46,260,72809,70,NULL,NULL,'SDSS J220348.04+010235.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',NULL,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,330.9502083,1.04319,0.153,NULL,52185285893,815395092,12740548,18.3),(153497,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153497,36.47,0.67,197,72810,70,NULL,NULL,'2MASX J22035034-1326057',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.78',NULL,NULL,NULL,NULL,NULL,NULL,1,330.9597917,-13.43494,0.085,NULL,49752358147,777380596,12146571,15.78),(153498,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 01902','RN',153498,40.15,0.18,881,72811,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01902',0.216732,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153499,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153499,37.76,0.23,357,72812,70,NULL,NULL,'2MASX J22035085-0005318',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,330.962,-0.09228,0.153,NULL,49820364933,778443202,12163175,17.3),(153500,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153500,37.76,0.23,357,72813,70,NULL,NULL,'2MASX J22035191-0017279',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,330.96625,-0.29108,0.149,NULL,49820414121,778443970,12163187,18.3),(153501,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153501,36.04,0.5,161,72814,70,NULL,NULL,'2MASX J22035701-1150410',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.06',0.37,NULL,NULL,NULL,NULL,NULL,1,330.987667,-11.84483,0.093,NULL,49873989930,779281092,12176267,16.06),(153502,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153502,35.54,0.46,128,72815,70,NULL,NULL,'2MASX J22035802+1154217',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000163,NULL,'16.1g',0.41,'S0',NULL,NULL,NULL,NULL,1,330.9917917,11.90592,0.257,NULL,52285434944,816959921,12764998,16.1),(153503,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 03193','RN',153503,42.87,0.25,2450,72816,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03193',0.530363,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153504,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08195','R',153504,40.55,0.22,1020,72817,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220401.53-005344.4',0.2689,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',0.0001,NULL,'19.4g',0.09,NULL,NULL,NULL,NULL,NULL,1,331.006417,-0.89567,0.169,NULL,49823887007,778498234,12164034,19.4),(153505,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08195','R',153505,40.65,0.29,1060,72817,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220401.53-005344.4',0.2689,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153506,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08195',NULL,153506,40.58,0.18,1310,72817,70,NULL,'SALT 2','SDSS J220401.53-005344.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153507,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08195',NULL,153507,40.6,0.18,1320,72817,70,NULL,'SALT 2, Malmquist cor.','SDSS J220401.53-005344.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153508,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 11002','RN',153508,38.09,0.16,395,72818,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11002',0.049263,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153509,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 11002','RN',153509,39.15,0.25,644,72818,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11002',0.049263,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153510,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153510,35.84,0.46,147,72819,70,NULL,NULL,'2MASX J22040180+0035050',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00018,NULL,'16.2g',0.38,NULL,NULL,NULL,NULL,NULL,1,331.007625,0.58461,0.129,NULL,52182002520,815343789,12739746,16.2),(153511,'CMD','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'N',153511,18.62,0.21,0.053,72820,NULL,NULL,'If object = GC, ID = DES J0117 _1725','Cetus II',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153512,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153512,35.61,0.66,132,72821,70,NULL,NULL,'2MASX J22040518-6953302',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'16.37',0.22,'S',NULL,NULL,NULL,NULL,1,331.021833333,-69.89172,0.033,NULL,49309880268,770466879,12038544,16.37),(153513,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153513,37.9,0.46,381,72822,70,NULL,NULL,'2MASX J22040591+1231079',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000132,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,331.0245417,12.51894,0.249,NULL,52253134690,816455229,12757112,17.7),(153514,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153514,34.32,0.8,73.2,72823,75,NULL,'W91PP, r','UGC 11893',NULL,'1997ApJS..109..333W',1997,1,2.26,NULL,'G',0.000023,NULL,'16.0',0.27,'Sc',NULL,NULL,NULL,NULL,1,331.0282083,35.93847,0.749,NULL,55481580555,866899696,13545307,16),(153515,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153515,34.79,0.49,90.7,72823,75,NULL,'IR','UGC 11893',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153516,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153516,34.9,0.38,95.6,72823,75,NULL,'W91PP, r, raw','UGC 11893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153517,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153517,35.07,0.38,103,72823,75,NULL,'W91PP, r, cor','UGC 11893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153518,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153518,35.11,NULL,105,72823,NULL,NULL,'Dipole','UGC 11893',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153519,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153519,35.12,NULL,106,72823,NULL,NULL,'Dipole + Quadrupole','UGC 11893',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153520,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153520,35.12,NULL,106,72823,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11893',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153521,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153521,35.17,0.35,108,72823,NULL,NULL,'Malmquist cor.','UGC 11893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153522,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153522,35.2,0.38,110,72823,75,NULL,'W91PP, r, inv','UGC 11893',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153523,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153523,35.24,NULL,112,72823,NULL,NULL,NULL,'UGC 11893',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153524,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153524,35.36,0.43,118,72823,75,NULL,'3.6 micron, color corrected','UGC 11893',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153525,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153525,35.37,0.2,119,72823,74.4,NULL,NULL,'UGC 11893',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153526,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153526,35.55,0.43,129,72823,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11893',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153527,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153527,35.61,0.29,132,72823,NULL,NULL,NULL,'UGC 11893',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153528,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153528,36.19,0.53,173,72824,70,NULL,NULL,'2MASX J22041302-7135083',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.45',0.39,NULL,NULL,NULL,NULL,NULL,1,331.0540417,-71.58567,0.017,NULL,49304594525,770384289,12037254,16.45),(153529,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153529,36.58,0.58,207,72825,70,NULL,NULL,'2MASX J22041634-5537293',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.29',0.4,'S0',NULL,NULL,NULL,NULL,1,331.0682083,-55.62489,0,NULL,48710678247,761104347,11892255,16.29),(153530,'BL Lac Luminosity','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153530,35.46,NULL,120,72826,NULL,NULL,NULL,'CGCG 403-019',0.027,'2005ApJ...635..173S',2005,1,NULL,NULL,'G',NULL,NULL,'15.2',NULL,'E;BLLAC        Sy1',NULL,NULL,'radio jet','Flat-Spectrum Radio Source',1,331.073583,4.66722,0.157,NULL,52186062298,815407223,12740737,15.2),(153531,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153531,37.69,0.46,345,72827,70,NULL,NULL,'2MASX J22041886+0111201',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,331.078583,1.18897,0.153,NULL,52185218142,815394033,12740531,16.9),(153532,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153532,35.91,0.67,152,72828,70,NULL,NULL,'2MASX J22041917-0924302',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.1g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,331.0797917,-9.40847,0.089,NULL,49875373159,779302705,12176604,16.1),(153533,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153533,35.47,0.46,124,72829,70,NULL,NULL,'CGCG 428-026',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00009,NULL,'15.4g',0.46,'E0',NULL,NULL,NULL,NULL,1,331.080917,12.96839,0.273,NULL,52256574169,816508971,12757952,15.4),(153534,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153534,36.11,0.62,167,72830,70,NULL,NULL,'2MASX J22042077-7346477',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.000103,NULL,'17.0b',0.17,NULL,NULL,NULL,NULL,NULL,1,331.086583333,-73.77986,0.085,NULL,48416553712,756508651,11820447,17),(153535,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153535,33.93,0.2,61.1,72831,74.4,NULL,NULL,'UGC 11895',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000037,NULL,'14.2',0.9,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,331.093417,39.74375,0.941,NULL,55513884891,867404451,13553194,14.2),(153536,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153536,33.99,0.43,62.7,72831,75,NULL,'3.6 micron, color corrected','UGC 11895',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153537,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153537,34.06,0.43,65,72831,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11895',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153538,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153538,34.07,0.4,65.2,72831,NULL,NULL,'mean','UGC 11895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153539,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153539,34.37,0.45,74.9,72831,NULL,NULL,'K','UGC 11895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153540,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153540,34.39,0.46,75.6,72831,NULL,NULL,'J','UGC 11895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153541,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153541,34.45,0.47,77.7,72831,NULL,NULL,'H','UGC 11895',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153542,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153542,36.58,0.55,207,72832,70,NULL,NULL,'2MASX J22042294-4837450',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.000107,NULL,'15.50',0.62,'E',NULL,NULL,NULL,NULL,1,331.0955,-48.62919,0,NULL,50622726389,790980099,12359064,15.5),(153543,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006he',NULL,153543,39.6,0.08,831,72833,70,NULL,'Hubble residual 0.03 for z0.21390','SDSS-II SN 13305 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,331.100166667,0.69078,0.141,NULL,52182137928,815345905,12739779,NULL),(153544,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 13305','R',153544,40.16,0.19,886,72833,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006he','SDSS-II SN 13305 HOST',0.214812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153545,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 13305','R',153545,40.31,0.11,949,72833,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006he','SDSS-II SN 13305 HOST',0.214812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153546,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006he',NULL,153546,40.05,0.08,1020,72833,70,NULL,'SALT 2','SDSS-II SN 13305 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153547,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006he',NULL,153547,40.07,0.08,1030,72833,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13305 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153548,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153548,35.59,0.46,131,72834,70,NULL,NULL,'CGCG 377-020',NULL,'2015arXiv151105856S',2015,1,0.71,NULL,'G',0.000107,NULL,'15.1g',0.49,'E0',NULL,NULL,NULL,NULL,1,331.1054583,0.71542,0.141,NULL,52182136107,815345876,12739779,15.1),(153549,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153549,35.7,0.77,138,72835,70,NULL,NULL,'2MASX J22042542-1935468',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.91',0.57,'S0',NULL,NULL,NULL,NULL,1,331.106,-19.59631,0.057,NULL,49739217790,777175277,12143363,15.91),(153550,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153550,37.01,0.46,253,72836,70,NULL,NULL,'2MASX J22043004+1153285',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,331.125166667,11.89119,0.325,NULL,52285445338,816960083,12765001,17.3),(153551,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153551,36.07,0.78,164,72837,70,NULL,NULL,'2MASX J22043286-2214118',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.93',0.26,NULL,NULL,NULL,NULL,NULL,1,331.137,-22.23669,0.057,NULL,50870590168,794852971,12419577,16.93),(153552,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153552,37.92,0.33,384,72838,70,NULL,NULL,'SDSS J220435.38+004729.2',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,331.147417,0.79144,0.141,NULL,52181678880,815338732,12739667,17.5),(153553,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 16592','RN',153553,43.27,0.25,2970,72839,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16592',0.516442,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153554,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153554,38.58,0.46,520,72840,70,NULL,NULL,'2MASX J22043713+1150165',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000149,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,331.1547083,11.83792,0.325,NULL,52285455508,816960242,12765003,18.7),(153555,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153555,36.82,0.56,231,72841,70,NULL,NULL,'2MASX J22043802-2014198',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'17.50',0.28,NULL,NULL,NULL,NULL,NULL,1,331.158416667,-20.23875,0.057,NULL,49741945777,777217902,12144029,17.5),(153556,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153556,36.05,0.49,162,72842,70,NULL,NULL,'2MASX J22044048-5015042',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.65',0.58,'E',NULL,NULL,NULL,NULL,1,331.168625,-50.25125,0,NULL,50629700925,791089076,12360766,15.65),(153557,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153557,37.92,0.33,384,72843,70,NULL,NULL,'2MASX J22044097+0044161',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000132,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,331.170875,0.73769,0.141,NULL,52182134476,815345851,12739778,18.3),(153558,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 15655',NULL,153558,38.84,1.18,587,72844,70,NULL,'SN photometric redshift distance, z photo =0.148 +/- 0.124','SDSS-II SN 15655',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,331.176667,0.78575,0.141,NULL,52181671032,815338609,12739665,NULL),(153559,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153559,34.33,0.2,73.5,72845,74.4,NULL,NULL,'ESO 532- G 017',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000147,NULL,'14.98',0.4,'SB(rs)d:',NULL,NULL,NULL,NULL,1,331.1797917,-26.40175,0.045,NULL,51408194320,803253036,12550828,14.98),(153560,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153560,34.47,0.46,78.2,72845,NULL,NULL,NULL,'ESO 532- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153561,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153561,34.47,0.46,78.3,72845,NULL,NULL,'Malmquist cor.','ESO 532- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153562,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153562,35.37,0.33,118,72846,NULL,NULL,NULL,'UGC 11896',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'15.18',0.6,'Sbc',NULL,NULL,NULL,NULL,1,331.196625,15.79381,0.165,NULL,52276373114,816818329,12762786,15.18),(153563,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153563,35.36,0.34,118,72846,NULL,NULL,'Malmquist cor.','UGC 11896',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153564,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153564,35.38,0.2,119,72846,74.4,NULL,NULL,'UGC 11896',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153565,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153565,32.88,0.8,37.7,72847,75,NULL,'MAT, I','NGC 7179',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.33',0.8,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,331.2055,-64.04683,0.009,NULL,49342337715,770974026,12046469,13.33),(153566,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153566,32.76,0.8,35.7,72847,75,NULL,NULL,'NGC 7179',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153567,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153567,33.08,0.4,41.2,72847,NULL,NULL,'mean','NGC 7179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153568,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153568,33.22,0.46,44.1,72847,NULL,NULL,'J','NGC 7179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153569,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153569,33.24,0.4,44.5,72847,NULL,NULL,NULL,'NGC 7179',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153570,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153570,33.26,0.47,44.9,72847,NULL,NULL,'H','NGC 7179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153571,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153571,33.34,0.45,46.5,72847,NULL,NULL,'K','NGC 7179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153572,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153572,33.37,0.36,47.2,72847,NULL,NULL,'Malmquist cor.','NGC 7179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153573,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153573,33.41,0.32,48,72847,85,NULL,'I, raw','NGC 7179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153574,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153574,33.46,0.32,49.3,72847,85,NULL,'I, inv','NGC 7179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153575,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153575,33.48,0.43,49.6,72847,75,NULL,'MAT, I, raw','NGC 7179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153576,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153576,33.5,0.43,50.1,72847,75,NULL,'MAT, I, cor','NGC 7179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153577,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153577,33.63,0.32,53.2,72847,NULL,NULL,NULL,'NGC 7179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153578,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153578,33.67,0.2,54.2,72847,74.4,NULL,NULL,'NGC 7179',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153579,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153579,33.75,0.43,56.1,72847,75,NULL,'MAT, I, inv','NGC 7179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153580,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153580,36.93,0.79,243,72848,70,NULL,NULL,'2MASX J22044955-5737204',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.88',0.53,'S',NULL,NULL,NULL,NULL,1,331.2062917,-57.62242,0,NULL,48707133147,761048955,11891389,15.88),(153581,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153581,38.29,0.46,456,72849,70,NULL,NULL,'2MASX J22045100+0018513',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000155,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,331.212667,0.31419,0.129,NULL,52182231640,815347369,12739802,17),(153582,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 13018','RN',153582,39.21,0.34,610,72850,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13018',0.141205,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153583,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 13018','RN',153583,39.67,0.37,754,72850,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13018',0.141205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153584,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153584,37.83,0.46,368,72851,70,NULL,NULL,'2MASX J22045753+0050423',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000195,NULL,'17.6g',0.21,'NLAGN',NULL,NULL,NULL,NULL,1,331.239625,0.84503,0.141,NULL,52181723699,815339432,12739678,17.6),(153585,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153585,34.39,NULL,75.6,72852,NULL,NULL,NULL,'ESO 075- G 053',NULL,'2000BSAO...50....5K',2000,1,1.34,NULL,'G',0.000033,NULL,'16.10',0.18,'Sc',NULL,NULL,NULL,NULL,1,331.254041667,-69.97669,0.033,NULL,49309419368,770459677,12038432,16.1),(153586,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153586,34.44,NULL,77.1,72852,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 075- G 053',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153587,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153587,34.44,NULL,77.4,72852,NULL,NULL,'Dipole + Quadrupole','ESO 075- G 053',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153588,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153588,34.47,NULL,78.2,72852,NULL,NULL,'Dipole','ESO 075- G 053',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153589,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153589,35.63,0.43,133,72852,NULL,NULL,'Malmquist cor.','ESO 075- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153590,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153590,35.76,0.4,142,72852,NULL,NULL,NULL,'ESO 075- G 053',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153591,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153591,35.8,0.2,145,72852,74.4,NULL,NULL,'ESO 075- G 053',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153592,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153592,37.16,0.46,270,72853,70,NULL,NULL,'2MASX J22050401-0901272',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.00015,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,331.266833,-9.02411,0.081,NULL,49867553591,779180524,12174695,15.9),(153593,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216',NULL,153593,38.39,0.76,476,72854,70,NULL,'SN photometric redshift distance, z photo =0.118 +/- 0.054','SDSS-II SN 08216',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.6g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,331.2695,-0.05211,0.149,NULL,49820023998,778437874,12163091,21.6),(153594,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216','R',153594,40.84,0.25,1140,72854,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08216',0.291349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153595,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216','R',153595,40.9,0.22,1170,72854,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08216',0.291349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153596,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216',NULL,153596,40.68,0.16,1370,72854,70,NULL,'SALT 2','SDSS-II SN 08216',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153597,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 08216',NULL,153597,40.71,0.16,1390,72854,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08216',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153598,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153598,33.94,0.69,61.5,72855,100,NULL,'mid-IR','CGCG 473-003',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000033,NULL,'14.98',0.5,'Sa','Isolated galaxy',NULL,NULL,NULL,1,331.2872083,26.60711,0.325,NULL,55567535185,868242737,13566292,14.98),(153599,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153599,34.73,0.4,88.2,72855,NULL,NULL,'mean','CGCG 473-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153600,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153600,34.87,0.47,94.1,72855,NULL,NULL,'H','CGCG 473-003',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153601,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 05490','RN',153601,37.85,0.22,338,72856,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05490',0.098073,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153602,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153602,33.82,0.46,58.1,72857,70,NULL,NULL,'NGC 7198',NULL,'2015arXiv151105856S',2015,1,1.5,NULL,'G',0.000137,NULL,'14.31',1,'S0 pec',NULL,NULL,NULL,NULL,1,331.309333,-0.64828,0.193,NULL,49820751984,778449249,12163269,14.31),(153603,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153603,34.13,0.52,66.9,72857,70,NULL,NULL,'NGC 7198',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153604,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153604,35.25,0.58,112,72858,70,NULL,NULL,'2MASX J22051543-0107334',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000086,NULL,'15.3g',0.47,'NLAGN',NULL,NULL,NULL,'Sy 2',1,331.3142917,-1.12594,0.193,NULL,49823449261,778491394,12163928,15.3),(153605,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153605,33.87,0.8,59.6,72859,75,NULL,'MAT, I','ESO 146- G 006',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'15.45',0.25,'Sc','in a pair',NULL,NULL,NULL,1,331.315875,-60.67625,0,NULL,48685910475,760717351,11886208,15.45),(153606,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153606,31.97,0.32,24.8,72859,85,NULL,'I, inv','ESO 146- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153607,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153607,31.98,0.32,24.9,72859,85,NULL,'I, raw','ESO 146- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153608,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153608,32.23,0.43,28,72859,75,NULL,'MAT, I, raw','ESO 146- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153609,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153609,32.27,0.43,28.4,72859,75,NULL,'MAT, I, inv','ESO 146- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153610,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153610,32.58,0.43,32.9,72859,75,NULL,'MAT, I, cor','ESO 146- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153611,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153611,33.11,0.49,41.9,72859,75,NULL,'IR','ESO 146- G 006',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153612,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153612,33.31,0.47,45.9,72859,NULL,NULL,'Malmquist cor.','ESO 146- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153613,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153613,33.47,NULL,49.5,72859,NULL,NULL,NULL,'ESO 146- G 006',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153614,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153614,33.62,0.4,52.9,72859,NULL,NULL,NULL,'ESO 146- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153615,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153615,33.66,0.2,54,72859,74.4,NULL,NULL,'ESO 146- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153616,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153616,33.78,NULL,57,72859,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 146- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153617,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153617,33.81,NULL,57.7,72859,NULL,NULL,'Dipole + Quadrupole','ESO 146- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153618,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153618,33.82,NULL,58.1,72859,NULL,NULL,'Dipole','ESO 146- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153619,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153619,33.35,NULL,46.8,72860,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1693',NULL,'2010Ap&SS.325..163P',2010,1,0.99,NULL,'G',0.000013,NULL,'17.0',0.1,'Sd',NULL,NULL,NULL,NULL,1,331.335,-20.61361,0.061,NULL,49742173868,777221466,12144085,17),(153620,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153620,33.37,NULL,47.1,72860,NULL,NULL,'Dipole + Quadrupole','FGCE 1693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153621,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153621,33.39,NULL,47.7,72860,NULL,NULL,'Dipole','FGCE 1693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153622,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153622,33.4,NULL,47.8,72860,NULL,NULL,NULL,'FGCE 1693',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153623,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153623,35.22,0.5,111,72861,70,NULL,NULL,'2MASX J22052165-0725094',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.5g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,331.3402083,-7.41942,0.093,NULL,49866744580,779167884,12174498,15.5),(153624,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153624,35.27,0.46,113,72861,70,NULL,NULL,'2MASX J22052165-0725094',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153625,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153625,34.94,0.49,97.1,72862,75,NULL,'IR','UGC 11901',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000157,NULL,'15.41',0.2,'S?',NULL,NULL,NULL,NULL,1,331.3422083,5.18389,0.149,NULL,52194391186,815537362,12742771,15.41),(153626,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153626,37.9,0.61,381,72863,70,NULL,NULL,'2MASX J22052593-1822307',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.83',0.37,NULL,NULL,NULL,NULL,NULL,1,331.357917,-18.37519,0.065,NULL,49738199112,777159361,12143115,16.83),(153627,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153627,35.94,0.64,154,72864,70,NULL,NULL,'2MASX J22052605-1935557',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.37',0.25,'S',NULL,NULL,NULL,NULL,1,331.3585417,-19.59883,0.057,NULL,49740574597,777196478,12143694,16.37),(153628,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153628,35.52,0.65,127,72865,70,NULL,NULL,'2MFGC 16658',NULL,'2014MNRAS.445.2677S',2014,1,1.19,NULL,'G',0.0001,NULL,'15.4g',0.26,'Sb',NULL,NULL,NULL,NULL,1,331.362541667,-0.53344,0.193,NULL,49820982385,778452849,12163325,15.4),(153629,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14809','R',153629,41.92,0.33,1760,72866,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J220530.24-003922.0',0.371489,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,331.376,-0.65611,0.193,NULL,49820973803,778452715,12163323,21.4),(153630,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14809','R',153630,42.03,0.28,1860,72866,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J220530.24-003922.0',0.371489,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153631,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14809',NULL,153631,41.82,0.21,2310,72866,70,NULL,'SALT 2','SDSS J220530.24-003922.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153632,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14809',NULL,153632,41.87,0.21,2370,72866,70,NULL,'SALT 2, Malmquist cor.','SDSS J220530.24-003922.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153633,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153633,36.05,0.63,162,72867,NULL,NULL,NULL,'LCSB S2619P',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.00015,NULL,'15.7V',0.35,NULL,NULL,NULL,NULL,NULL,1,331.3922917,-5.66803,0.149,NULL,49846098321,778845286,12169457,15.7),(153634,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153634,36.09,0.2,165,72867,74.4,NULL,NULL,'LCSB S2619P',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153635,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153635,36.26,0.57,179,72867,NULL,NULL,'Malmquist cor.','LCSB S2619P',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153636,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153636,34.27,0.4,71.3,72868,NULL,NULL,'mean','UGC 11906',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000087,NULL,'17.',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,331.409041667,44.84061,NULL,NULL,55507935538,867311492,13551742,17),(153637,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153637,34.35,0.47,74,72868,NULL,NULL,'H','UGC 11906',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153638,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153638,37.49,0.46,315,72869,70,NULL,NULL,'2MASX J22053874-0856302',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,331.4115,-8.94178,0.081,NULL,49867432936,779178639,12174666,17.5),(153639,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153639,37.56,0.46,325,72870,70,NULL,NULL,'2MASX J22053968-0045310',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,331.415333,-0.75853,0.193,NULL,49820549260,778446082,12163220,17.4),(153640,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153640,33.11,0.3,41.9,72871,NULL,NULL,'Malmquist cor.','NGC 7196',NULL,'2001MNRAS.327.1004B',2001,1,2.5,NULL,'G',0.000063,NULL,'12.40',1.8,'E:','Parent (of companion) galaxy',NULL,NULL,NULL,1,331.478375,-50.11933,0,NULL,50629631958,791087999,12360749,12.4),(153641,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153641,33.27,0.3,45.1,72871,NULL,NULL,'I','NGC 7196',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153642,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153642,33.27,0.3,45.1,72871,NULL,NULL,NULL,'NGC 7196',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153643,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153643,33.28,0.14,45.3,72871,74.4,NULL,NULL,'NGC 7196',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153644,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153644,33.47,0.4,49.4,72871,75,NULL,'Edat, raw','NGC 7196',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153645,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153645,33.66,0.4,54,72871,75,NULL,'Edat, cor','NGC 7196',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153646,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153646,31.99,0.37,25,72871,95,NULL,'Weighted Mean','NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153647,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153647,32.01,0.63,25.2,72871,95,NULL,'Michard 1979b, c','NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153648,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153648,32.4,0.46,30.2,72871,95,NULL,'Michard 1979a','NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153649,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153649,33.6,0.81,52.5,72871,55,NULL,'Visvanathan & Sandage 1979','NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153650,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153650,33.25,0.41,44.7,72871,NULL,NULL,'Malmquist cor.','NGC 7196',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153651,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153651,33.38,0.41,47.4,72871,NULL,NULL,NULL,'NGC 7196',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153652,'Tertiary','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153652,32.17,0.41,27.2,72871,95,NULL,NULL,'NGC 7196',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153653,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153653,32.87,0.8,37.6,72871,75,NULL,'B','NGC 7196',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153654,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153654,32.99,0.4,39.7,72871,NULL,NULL,'mean','NGC 7196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153655,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153655,33.33,0.45,46.4,72871,NULL,NULL,'K','NGC 7196',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153656,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153656,37.05,0.53,256,72872,70,NULL,NULL,'2MASX J22055607-1028152',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.60',0.5,NULL,NULL,NULL,NULL,NULL,1,331.483625,-10.47092,0.073,NULL,49878148058,779346063,12177282,15.6),(153657,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153657,37.35,0.46,295,72873,70,NULL,NULL,'2MASX J22055648-0841402',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,331.48525,-8.69444,0.085,NULL,49869442632,779210041,12175156,17.9),(153658,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153658,36.78,0.46,227,72874,70,NULL,NULL,'2MASX J22055698-0927172',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000161,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,331.4875,-9.45469,0.073,NULL,49875214941,779300233,12176566,17.1),(153659,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153659,35.98,0.5,157,72875,70,NULL,NULL,'2MASX J22061212-5033317',NULL,'2014MNRAS.445.2677S',2014,1,0.14,NULL,'G',0.00015,NULL,'19.49',0.1,NULL,NULL,NULL,NULL,NULL,1,331.5505,-50.55875,0,NULL,50630405203,791100081,12360938,19.49),(153660,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153660,36.73,0.46,222,72876,70,NULL,NULL,'2MASX J22061582+1148094',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000072,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,331.566,11.80247,0.221,NULL,52284555599,816946181,12764784,16.7),(153661,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153661,30.45,0.2,12.3,72877,74.4,NULL,NULL,'UGC 11909',NULL,'2013AJ....146...86T',2013,1,3,'The Bologna position is 5 arcsec southeast of the eccentric nucleus.','G',0.000003,NULL,'13.25',0.7,'S pec',NULL,NULL,NULL,NULL,1,331.567375,47.25122,NULL,NULL,55415592758,865868636,13529197,13.25),(153662,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153662,30.73,0.4,14,72877,NULL,NULL,NULL,'UGC 11909',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153663,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153663,30.83,0.49,14.7,72877,75,NULL,'IR','UGC 11909',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153664,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153664,31.38,0.4,18.8,72877,75,NULL,'B','UGC 11909',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153665,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 21058','RN',153665,39.33,0.1,631,72878,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21058',0.1643,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153666,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 21058','RN',153666,39.54,0.21,695,72878,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21058',0.1643,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153667,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153667,36.28,0.33,180,72879,70,NULL,NULL,'CGCG 377-024',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00009,NULL,'15.1g',0.6,'E0',NULL,NULL,NULL,NULL,1,331.5855,1.12103,0.113,NULL,52181817491,815340898,12739701,15.1),(153668,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153668,34.91,0.46,96.1,72880,70,NULL,NULL,'NGC 7211',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.000103,NULL,'14.6g',0.65,'S0o:',NULL,NULL,NULL,NULL,1,331.591125,-8.08997,0.085,NULL,49870167065,779221360,12175333,14.6),(153669,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153669,35.06,0.46,103,72880,70,NULL,NULL,'NGC 7211',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153670,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414','R',153670,40.63,0.25,1030,72881,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19414',0.291833,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.7g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,331.591708333,0.04017,0.145,NULL,52181372147,815333939,12739592,20.7),(153671,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414',NULL,153671,40.15,1.41,1070,72881,70,NULL,'SN photometric redshift distance, z photo =0.292 +/- 0.397','SDSS-II SN 19414',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153672,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414','R',153672,40.92,0.33,1180,72881,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19414',0.291833,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153673,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414',NULL,153673,40.92,0.21,1530,72881,70,NULL,'SALT 2','SDSS-II SN 19414',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153674,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19414',NULL,153674,40.94,0.21,1540,72881,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19414',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153675,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153675,37.46,0.46,310,72882,70,NULL,NULL,'2MASX J22062338-0059189',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,331.597583,-0.98864,0.193,NULL,49820577614,778446525,12163226,17.4),(153676,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153676,35.23,NULL,111,72883,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2364',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.000015,NULL,'16.0',0.11,'Sc',NULL,NULL,NULL,NULL,1,331.6,17.43389,0.137,NULL,52273745233,816777269,12762144,16),(153677,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153677,35.25,NULL,112,72883,NULL,NULL,'Dipole + Quadrupole','FGC 2364',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153678,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153678,35.27,NULL,113,72883,NULL,NULL,'Dipole','FGC 2364',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153679,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153679,35.33,NULL,116,72883,NULL,NULL,NULL,'FGC 2364',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153680,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153680,35.73,0.44,140,72883,NULL,NULL,'Malmquist cor.','FGC 2364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153681,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153681,35.82,0.2,146,72883,74.4,NULL,NULL,'FGC 2364',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153682,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153682,35.91,0.4,152,72883,NULL,NULL,NULL,'FGC 2364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153683,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 00976','RN',153683,42.19,0.2,1810,72884,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00976',0.514778,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153684,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153684,35.74,0.52,141,72885,70,NULL,NULL,'2MASX J22063469-7113233',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.03',0.48,'S0',NULL,NULL,NULL,NULL,1,331.644458333,-71.22325,0.013,NULL,49304644283,770385066,12037266,16.03),(153685,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 09387','RN',153685,43.08,0.26,2870,72886,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09387',0.439001,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153686,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 09387','RN',153686,43.13,0.29,2930,72886,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 09387',0.439001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153687,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153687,35.54,0.31,128,72887,NULL,NULL,'Malmquist cor.','CGCG 451-009',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000033,NULL,'15.4',0.4,'Sk:',NULL,NULL,NULL,NULL,1,331.658333,17.46083,0.137,NULL,52266339980,816661562,12760336,15.4),(153688,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153688,35.82,0.27,146,72887,NULL,NULL,NULL,'CGCG 451-009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153689,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153689,36.19,0.2,173,72887,74.4,NULL,NULL,'CGCG 451-009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153690,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153690,36.28,0.33,180,72888,70,NULL,NULL,'2MASX J22063845+0110365',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000194,NULL,'15.8g',0.42,'E0',NULL,NULL,NULL,NULL,1,331.66025,1.17689,0.113,NULL,52181634673,815338041,12739656,15.8),(153691,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153691,34.98,0.5,99,72889,70,NULL,NULL,'ESO 075- G 054',NULL,'2014MNRAS.445.2677S',2014,1,1.16,NULL,'G',0.00015,NULL,'15.26',0.25,'S0+: sp',NULL,NULL,NULL,NULL,1,331.674041667,-71.68878,0.017,NULL,49297026293,770266035,12035406,15.26),(153692,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153692,33.27,0.49,45.1,72890,75,NULL,'IR','UGC 11918',NULL,'2011yCatp016004901K',2011,1,1.02,NULL,'G',0.000053,NULL,'17.',0.14,'Sc',NULL,NULL,NULL,NULL,1,331.688791667,75.04769,1.529,NULL,52794017124,824906517,12889164,17),(153693,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153693,33.95,0.43,61.6,72890,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11918',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153694,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153694,32.89,0.32,37.8,72891,NULL,NULL,'I','NGC 7192',NULL,'2001ApJ...546..681T',2001,1,2,'The APMUKS position is east of the nucleus.','G',0.000043,NULL,'12.19',1.9,'SA0^-          LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,331.709,-64.31625,0,NULL,49278365599,769974462,12030850,12.19),(153695,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153695,32.89,0.32,37.8,72891,NULL,NULL,NULL,'NGC 7192',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153696,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153696,32.94,0.14,38.7,72891,74.4,NULL,NULL,'NGC 7192',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153697,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153697,33.07,0.32,41,72891,NULL,NULL,'Malmquist cor.','NGC 7192',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153698,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153698,32.1,0.4,26.3,72891,75,NULL,'Edat, raw','NGC 7192',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153699,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153699,32.43,0.4,30.6,72891,75,NULL,'Edat, cor','NGC 7192',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153700,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153700,30.55,0.65,12.9,72891,95,NULL,'Weighted Mean','NGC 7192',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153701,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153701,31.66,0.81,21.5,72891,55,NULL,'Visvanathan & Sandage 1979','NGC 7192',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153702,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153702,32.29,0.41,28.6,72891,NULL,NULL,NULL,'NGC 7192',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153703,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153703,32.7,0.41,34.6,72891,NULL,NULL,'Malmquist cor.','NGC 7192',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153704,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153704,32.76,0.8,35.6,72891,75,NULL,'B','NGC 7192',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153705,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153705,32.91,0.45,38.2,72891,NULL,NULL,'K','NGC 7192',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153706,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153706,33.03,0.4,40.3,72891,NULL,NULL,'mean','NGC 7192',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153707,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153707,32.84,0.8,37.1,72892,75,NULL,'MAT, I','NGC 7191',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.77',0.6,'SAB(rs)c       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,331.7157917,-64.63456,0.009,NULL,49276485074,769945079,12030391,13.77),(153708,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153708,32.42,0.32,30.5,72892,85,NULL,'I, raw','NGC 7191',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153709,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153709,32.44,0.32,30.7,72892,85,NULL,'I, inv','NGC 7191',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153710,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153710,32.69,NULL,34.5,72892,NULL,NULL,'I','NGC 7191',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153711,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153711,32.72,0.43,34.9,72892,75,NULL,'MAT, I, raw','NGC 7191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153712,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153712,32.79,0.45,36.1,72892,NULL,NULL,NULL,'NGC 7191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153713,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153713,32.83,0.2,36.8,72892,74.4,NULL,NULL,'NGC 7191',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153714,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153714,32.84,0.43,36.9,72892,75,NULL,'MAT, I, inv','NGC 7191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153715,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153715,32.85,0.47,37.1,72892,NULL,NULL,'H','NGC 7191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153716,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153716,32.85,0.46,37.2,72892,NULL,NULL,'J','NGC 7191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153717,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153717,32.89,0.45,37.9,72892,NULL,NULL,'K','NGC 7191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153718,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153718,32.94,0.43,38.7,72892,75,NULL,'MAT, I, cor','NGC 7191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153719,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153719,33,NULL,39.9,72892,NULL,NULL,'B','NGC 7191',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153720,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153720,33.04,0.4,40.5,72892,NULL,NULL,'Malmquist cor.','NGC 7191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153721,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153721,33.05,0.4,40.7,72892,NULL,NULL,'mean','NGC 7191',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153722,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153722,32.63,0.8,33.5,72893,75,NULL,NULL,'NGC 7204',NULL,'1988NBGC.C....0000T',1988,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'S0/a pec:','Group member',NULL,NULL,NULL,1,331.725833,-31.05139,0,NULL,50537559720,789649370,12338271,NULL),(153723,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153723,37.77,0.21,358,72894,70,NULL,NULL,'SDSS J220656.31-091505.2',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,331.734667,-9.25147,0.089,NULL,49877884767,779341949,12177217,18.2),(153724,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153724,38.46,0.46,493,72895,70,NULL,NULL,'2MASX J22065889+0003499',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,331.7452917,0.06375,0.145,NULL,52181390956,815334233,12739597,18.1),(153725,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153725,37.1,0.14,263,72896,70,NULL,NULL,'SDSS J220704.20-073500.0',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,331.7675,-7.58336,0.097,NULL,49869514648,779211166,12175174,17.9),(153726,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153726,36.71,0.46,220,72897,70,NULL,NULL,'2MASX J22070462-0006000',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.6g',0.32,NULL,NULL,NULL,NULL,NULL,1,331.7692083,-0.10011,0.161,NULL,49820004404,778437568,12163087,16.6),(153727,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153727,36.98,0.46,249,72898,70,NULL,NULL,'2MASX J22070676+1301583',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00017,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,331.778083333,13.03294,0.213,NULL,52255931998,816498937,12757795,16.5),(153728,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153728,32.71,0.32,34.8,72899,NULL,NULL,'I','NGC 7200',NULL,'2001ApJ...546..681T',2001,1,1.6,'6dF has z = 0.057530 +- 0.000150.','G',0.000043,NULL,'13.78',1.2,'E+:','Group member',NULL,NULL,NULL,1,331.789666667,-49.99547,0,NULL,50630308971,791098577,12360915,13.78),(153729,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153729,32.71,0.32,34.8,72899,NULL,NULL,NULL,'NGC 7200',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153730,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153730,32.71,0.14,34.8,72899,74.4,NULL,NULL,'NGC 7200',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153731,'SBF','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153731,32.8,0.32,36.3,72899,NULL,NULL,'Malmquist cor.','NGC 7200',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153732,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153732,33.47,0.4,49.4,72899,75,NULL,'Edat, raw','NGC 7200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153733,'D-Sigma','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153733,33.66,0.4,54,72899,75,NULL,'Edat, cor','NGC 7200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153734,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153734,34.34,0.41,73.7,72899,NULL,NULL,NULL,'NGC 7200',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153735,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153735,34.83,0.41,92.3,72899,NULL,NULL,'Malmquist cor.','NGC 7200',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153736,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153736,32.82,0.8,36.7,72899,75,NULL,NULL,'NGC 7200',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153737,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153737,32.71,0.4,34.8,72899,73,NULL,'opt','NGC 7200',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153738,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 01609','RN',153738,41.26,0.16,1250,72900,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01609',0.425523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153739,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 01609','RN',153739,41.46,0.22,1370,72900,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01609',0.425523,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153740,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153740,37.1,0.14,263,72901,70,NULL,NULL,'2MASX J22071494-0730213',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000193,NULL,'16.3g',0.33,NULL,NULL,NULL,NULL,NULL,1,331.8122917,-7.50592,0.109,NULL,49866661235,779166581,12174477,16.3),(153741,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153741,36.37,0.53,188,72902,70,NULL,NULL,'2MASX J22071594-5311356',NULL,'2014MNRAS.445.2677S',2014,1,0.87,NULL,'G',0.00011,NULL,'15.60',0.5,'S0',NULL,NULL,NULL,NULL,1,331.816333,-53.19319,0,NULL,50627031546,791047367,12360115,15.6),(153742,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14786',NULL,153742,40.03,0.34,1010,72903,70,NULL,'SN photometric redshift distance, z photo =0.273 +/- 0.056','SDSS-II SN 14786',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,331.820416667,-0.32144,0.181,NULL,49819977245,778437144,12163080,NULL),(153743,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153743,37.1,0.14,263,72904,70,NULL,NULL,'2MASX J22071959-0743083',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,331.8315417,-7.71892,0.097,NULL,49869541160,779211580,12175180,16.7),(153744,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153744,37.1,0.14,263,72905,70,NULL,NULL,'2MASX J22072072-0728583',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,331.836333333,-7.48303,0.109,NULL,49866659822,779166559,12174477,17.8),(153745,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153745,37.77,0.21,358,72906,70,NULL,NULL,'SDSS J220723.30-093148.6',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,331.847125,-9.53017,0.073,NULL,49878126284,779345723,12177276,18.6),(153746,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153746,37.1,0.14,263,72907,70,NULL,NULL,'2MASX J22072496-0732193',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000184,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,331.853875,-7.53861,0.109,NULL,49866613524,779165836,12174466,17.5),(153747,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153747,37.1,0.14,263,72908,70,NULL,NULL,'2MASX J22072523-0725353',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000178,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,331.855166667,-7.42636,0.109,NULL,49866664342,779166630,12174478,17),(153748,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153748,33.01,0.4,40,72909,NULL,NULL,'mean','MCG -02-56-014',NULL,'2007A&A...465...71T',2007,1,0.6,NULL,'G',0.000023,NULL,'15.41',0.2,'Sbc','Pair member, contact system',NULL,NULL,NULL,1,331.857333333,-10.71203,0.077,NULL,49876257604,779316525,12176820,15.41),(153749,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153749,33.39,0.47,47.6,72909,NULL,NULL,'H','MCG -02-56-014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153750,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153750,33.39,0.2,47.6,72909,74.4,NULL,NULL,'MCG -02-56-014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153751,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153751,33.41,0.45,48,72909,NULL,NULL,'K','MCG -02-56-014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153752,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153752,33.45,0.46,48.9,72909,NULL,NULL,'J','MCG -02-56-014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153753,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153753,37.1,0.14,263,72910,70,NULL,NULL,'2MASX J22072610-0721183',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,331.8587083,-7.35519,0.109,NULL,49866629358,779166083,12174470,16.7),(153754,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153754,34.77,0.8,89.9,72911,75,NULL,'MAT, I','ESO 601- G 019',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.80',0.5,'SB(s)cd:',NULL,NULL,NULL,NULL,1,331.862625,-20.84281,0.065,NULL,49741774814,777215231,12143987,14.8),(153755,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153755,33.78,0.32,57.1,72911,85,NULL,'I, raw','ESO 601- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153756,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153756,33.81,0.32,57.9,72911,85,NULL,'I, inv','ESO 601- G 019',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153757,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153757,33.85,0.43,58.9,72911,75,NULL,'MAT, I, raw','ESO 601- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153758,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153758,34.01,0.43,63.4,72911,75,NULL,'MAT, I, inv','ESO 601- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153759,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153759,34.14,0.43,67.2,72911,75,NULL,'MAT, I, cor','ESO 601- G 019',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153760,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153760,34.73,0.51,88.1,72911,NULL,NULL,'Malmquist cor.','ESO 601- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153761,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153761,34.86,0.48,93.8,72911,NULL,NULL,NULL,'ESO 601- G 019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153762,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153762,34.9,0.2,95.5,72911,74.4,NULL,NULL,'ESO 601- G 019',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153763,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153763,36.18,0.5,172,72912,70,NULL,NULL,'2MASX J22072745-4349538',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000133,NULL,'15.43',0.52,'E',NULL,NULL,NULL,NULL,1,331.864458333,-43.83169,0,NULL,50675539791,791805309,12371957,15.43),(153764,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153764,37.77,0.21,358,72913,70,NULL,NULL,'2MASX J22072780-0929513',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000103,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,331.865875,-9.49753,0.077,NULL,49878094245,779345222,12177269,16.3),(153765,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 15456','R',153765,41.13,0.27,1220,72914,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ll','SDSS-II SN 15456 HOST',0.3821,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,331.866833333,-0.90381,0.193,NULL,49854419688,778975307,12171489,NULL),(153766,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006ll',NULL,153766,40.46,0.24,1230,72914,70,NULL,'Hubble residual -0.18 for z0.38210','SDSS-II SN 15456 HOST',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153767,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 15456','R',153767,41.38,0.24,1370,72914,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ll','SDSS-II SN 15456 HOST',0.3821,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153768,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153768,35.46,0.49,123,72915,70,NULL,NULL,'MCG -07-45-010',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000133,NULL,'15.36',0.59,'E',NULL,NULL,NULL,NULL,1,331.876166667,-43.59578,0,NULL,50675528202,791805128,12371955,15.36),(153769,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153769,37.03,0.46,254,72916,70,NULL,NULL,'2MASX J22073644-0111594',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,331.90175,-1.19981,0.205,NULL,49854015947,778968999,12171390,17.2),(153770,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153770,35.42,0.59,122,72917,70,NULL,NULL,'2MASX J22073908-7254474',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'16.7b',0.13,NULL,NULL,NULL,NULL,NULL,1,331.9127083,-72.91311,0.053,NULL,49298672870,770291763,12035808,16.7),(153771,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153771,36.01,0.7,159,72918,70,NULL,NULL,'2MASX J22073950-4903498',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00014,NULL,'16.78',0.33,NULL,NULL,NULL,NULL,NULL,1,331.915125,-49.06394,0,NULL,50622951916,790983623,12359119,16.78),(153772,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153772,35.37,0.55,119,72919,70,NULL,NULL,'ESO 237-IG 039 NED02',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.51',NULL,NULL,NULL,NULL,NULL,NULL,1,331.925,-47.37294,0,NULL,50621510225,790961097,12358767,16.51),(153773,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153773,36.76,0.46,225,72920,70,NULL,NULL,'2MASX J22074566-0819021',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,331.940083,-8.31722,0.125,NULL,49868506959,779195421,12174928,16.5),(153774,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153774,37.78,0.33,359,72921,70,NULL,NULL,'2MASX J22074602+0018290',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000179,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,331.941833,0.30806,0.133,NULL,52198164059,815596313,12743692,18.1),(153775,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153775,37.72,0.46,350,72922,70,NULL,NULL,'2MASX J22074688-0042088',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,331.94525,-0.70253,0.173,NULL,49853589872,778962341,12171286,18.3),(153776,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19893','RN',153776,38.72,0.73,499,72923,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19893',0.109389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153777,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19893','RN',153777,39.6,0.54,749,72923,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 19893',0.109389,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153778,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 15539',NULL,153778,39.51,0.52,800,72924,70,NULL,'SN photometric redshift distance, z photo =0.208 +/- 0.066','SDSS-II SN 15539',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,331.950167,0.16694,0.153,NULL,52198119215,815595612,12743681,NULL),(153779,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153779,37.6,0.46,331,72925,70,NULL,NULL,'2MASX J22074918-0859241',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,331.955083,-8.99003,0.101,NULL,49868723590,779198806,12174981,17.4),(153780,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153780,37.37,0.46,298,72926,70,NULL,NULL,'2MASXi J2207497-071105',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000165,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,331.957417,-7.18475,0.117,NULL,49837005288,778703207,12167237,17.8),(153781,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','PTF11opu','N',153781,39.03,0.05,601,72927,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11opu',0.0649,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153782,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2007mz',NULL,153782,39.55,0.1,811,72928,70,NULL,'Hubble residual -0.18 for z0.23220','SDSS J220751.19-010412.3',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.0005,NULL,'20.6g',0.06,NULL,NULL,NULL,NULL,NULL,1,331.963291667,-1.07008,0.193,NULL,49853924797,778967574,12171368,20.6),(153783,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19008','R',153783,40.14,0.22,866,72928,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mz','SDSS J220751.19-010412.3',0.2322,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153784,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 19008','R',153784,40.24,0.12,907,72928,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mz','SDSS J220751.19-010412.3',0.2322,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153785,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153785,37.75,0.33,355,72929,70,NULL,NULL,'2MASX J22075143-0938471',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,331.964333333,-9.6465,0.073,NULL,49878131629,779345806,12177278,17.3),(153786,'Ring Diameter','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153786,31.5,0.98,20,72930,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7217',NULL,'1981ApJS...45..541P',1981,1,3.9,NULL,'G',0.000006,NULL,'11.02',3.2,'(R)SA(r)ab;Sy  LINER','Isolated galaxy',NULL,NULL,'LINER',1,331.9682917,31.35933,0.413,NULL,55440875671,866263682,13535370,11.02),(153787,'Ring Diameter','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153787,31.8,0.76,23,72930,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7217',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153788,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153788,31.02,0.8,16,72930,75,NULL,'B','NGC 7217',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153789,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153789,31.32,NULL,18.4,72930,NULL,NULL,'B','NGC 7217',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153790,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153790,37.78,0.33,359,72931,70,NULL,NULL,'2MASX J22075362+0018110',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,331.9735417,0.30303,0.129,NULL,52198165578,815596337,12743692,17),(153791,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153791,37.75,0.33,355,72932,70,NULL,NULL,'2MASX J22075630-0937251',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,331.984708333,-9.62353,0.073,NULL,49878098373,779345287,12177270,17.7),(153792,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153792,38.28,0.46,452,72933,70,NULL,NULL,'SDSS J220757.61+000430.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000142,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,331.9900417,0.07528,0.153,NULL,52151991987,814874874,12732419,18.6),(153793,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153793,34.22,NULL,69.8,72934,NULL,NULL,'Dipole','FGC 2367',NULL,'2010Ap&SS.325..163P',2010,1,1.06,NULL,'G',0.000023,NULL,'16.8',0.1,'Scd',NULL,NULL,NULL,NULL,1,332.000833,15.71833,0.181,NULL,52267508219,816679815,12760622,16.8),(153794,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153794,34.23,NULL,70,72934,NULL,NULL,'Dipole + Quadrupole','FGC 2367',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153795,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153795,34.23,NULL,70.1,72934,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2367',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153796,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153796,34.52,NULL,80.2,72934,NULL,NULL,NULL,'FGC 2367',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153797,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153797,36,0.6,158,72935,70,NULL,NULL,'2MASX J22080309-1635173',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.01',NULL,NULL,NULL,NULL,NULL,NULL,1,332.012917,-16.58814,0.093,NULL,49787726460,777933225,12155206,16.01),(153798,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153798,33.1,NULL,41.6,72936,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2366',NULL,'2010Ap&SS.325..163P',2010,1,2.16,NULL,'G',0.000013,NULL,'16.0',0.1,'Sd',NULL,NULL,NULL,NULL,1,332.02,-10.33306,0.077,NULL,49878505345,779351646,12177369,16),(153799,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153799,33.11,NULL,41.9,72936,NULL,NULL,'Dipole','FGC 2366',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153800,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153800,33.11,NULL,41.9,72936,NULL,NULL,'Dipole + Quadrupole','FGC 2366',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153801,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153801,33.19,NULL,43.5,72936,NULL,NULL,NULL,'FGC 2366',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153802,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 20477','RN',153802,41.34,0.2,1480,72937,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20477',0.252729,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153803,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 20477','RN',153803,42.41,0.31,2420,72937,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20477',0.252729,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153804,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153804,37.77,0.21,358,72938,70,NULL,NULL,'SDSS J220810.10-092419.5',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000161,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,332.042083,-9.40544,0.077,NULL,49877060014,779329062,12177016,18.7),(153805,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153805,33.57,0.69,51.6,72939,100,NULL,'mid-IR','UGC 11919',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.00002,NULL,'14.30',1,'SABbc          HII',NULL,NULL,NULL,NULL,1,332.044,41.17736,1.109,NULL,55515116476,867423694,13553495,14.3),(153806,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153806,33.6,0.47,52.6,72939,NULL,NULL,'H','UGC 11919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153807,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153807,33.84,0.45,58.7,72939,NULL,NULL,'K','UGC 11919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153808,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153808,33.89,0.46,60.1,72939,NULL,NULL,'J','UGC 11919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153809,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153809,34.37,0.4,74.8,72939,NULL,NULL,'mean','UGC 11919',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153810,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153810,37.12,0.46,265,72940,70,NULL,NULL,'2MASX J22081096-0813479',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.045625,-8.23,0.125,NULL,49868563882,779196310,12174942,17.6),(153811,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153811,37.28,0.46,286,72941,70,NULL,NULL,'2MASX J22081138-0903479',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000162,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,332.0472917,-9.06331,0.101,NULL,49868721531,779198773,12174980,17.9),(153812,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153812,37.77,0.21,358,72942,70,NULL,NULL,'2MASX J22081179-0923039',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00017,NULL,'17.0g',0.21,NULL,NULL,NULL,NULL,NULL,1,332.049041667,-9.38447,0.077,NULL,49877059728,779329058,12177016,17),(153813,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153813,33.67,0.8,54.2,72943,75,NULL,'MAT, I','ESO 404- G 031',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'14.83',0.6,'SA(s)c:',NULL,NULL,NULL,NULL,1,332.057667,-32.46081,0,NULL,50595170027,790549531,12352336,14.83),(153814,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153814,33.23,0.32,44.2,72943,85,NULL,'I, raw','ESO 404- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153815,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153815,33.23,0.32,44.3,72943,85,NULL,'I, inv','ESO 404- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153816,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153816,33.53,NULL,50.8,72943,NULL,NULL,'B','ESO 404- G 031',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153817,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153817,33.54,0.43,50.9,72943,75,NULL,'MAT, I, raw','ESO 404- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153818,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153818,33.54,NULL,51.1,72943,NULL,NULL,'I','ESO 404- G 031',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153819,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153819,33.58,0.2,52,72943,74.4,NULL,NULL,'ESO 404- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153820,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153820,33.62,0.43,52.9,72943,75,NULL,'MAT, I, inv','ESO 404- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153821,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153821,33.78,0.43,57.1,72943,75,NULL,'MAT, I, cor','ESO 404- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153822,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153822,33.82,0.56,58.1,72943,NULL,NULL,NULL,'ESO 404- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153823,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153823,33.94,0.53,61.5,72943,NULL,NULL,'Malmquist cor.','ESO 404- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153824,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153824,34.61,0.45,83.5,72944,NULL,NULL,'Malmquist cor.','ESO 532- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.00002,NULL,'14.47',0.5,'SB(r)a?',NULL,NULL,NULL,NULL,1,332.057917,-25.06069,0.041,NULL,51406187482,803221679,12550338,14.47),(153825,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153825,34.67,0.44,86.1,72944,NULL,NULL,NULL,'ESO 532- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153826,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153826,34.73,0.2,88.3,72944,74.4,NULL,NULL,'ESO 532- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153827,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153827,37.38,0.53,300,72945,70,NULL,NULL,'2MASX J22081533-5921339',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000103,NULL,'16.86',0.24,NULL,NULL,NULL,NULL,NULL,1,332.0637917,-59.35939,0,NULL,48683816939,760684639,11885697,16.86),(153828,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 21808','RN',153828,39.7,0.48,795,72946,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 21808',0.09415,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153829,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153829,37.1,0.14,263,72947,70,NULL,NULL,'2MASX J22081680-0729189',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,332.070083,-7.48861,0.109,NULL,49840403831,778756309,12168067,16),(153830,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006hy',NULL,153830,38.77,0.05,569,72948,70,NULL,'Hubble residual -0.09 for z0.14910','SDSS-II SN 14437 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,332.080917,-1.19633,0.193,NULL,49853843961,778966311,12171348,NULL),(153831,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14437','R',153831,39.2,0.18,603,72948,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hy','SDSS-II SN 14437 HOST',0.149267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153832,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 14437','R',153832,39.39,0.08,656,72948,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hy','SDSS-II SN 14437 HOST',0.149267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153833,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006hy',NULL,153833,39.11,0.06,664,72948,70,NULL,'SALT 2','SDSS-II SN 14437 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153834,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006hy',NULL,153834,39.11,0.06,664,72948,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14437 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153835,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SN 2006no',NULL,153835,39.87,0.13,942,72949,70,NULL,'Hubble residual 0.00 for z0.25120','SDSS J220821.57-010853.8',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'19.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,332.089917,-1.14831,0.193,NULL,49854320091,778973751,12171464,19.8),(153836,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 16106','R',153836,40.52,0.22,1010,72949,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006no','SDSS J220821.57-010853.8',0.2512,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153837,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:13','1','SDSS-II SN 16106','R',153837,40.77,0.14,1140,72949,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006no','SDSS J220821.57-010853.8',0.2512,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153838,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153838,36.32,0.53,184,72950,70,NULL,NULL,'ESO 237-IG 040 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000067,NULL,'15.23',0.43,'E',NULL,NULL,NULL,NULL,1,332.0947083,-49.43108,0,NULL,50622563635,790977556,12359024,15.23),(153839,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153839,37.1,0.14,263,72951,70,NULL,NULL,'2MASX J22082574-0729079',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.8g',0.34,NULL,NULL,NULL,NULL,NULL,1,332.1072917,-7.4855,0.117,NULL,49840403138,778756299,12168067,16.8),(153840,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153840,30.54,0.69,12.8,72952,100,NULL,'mid-IR','UGC 11920',NULL,'2013ApJ...771...88L',2013,1,2.4,NULL,'G',0.000013,NULL,'12.86',1.5,'SB0/a',NULL,NULL,NULL,NULL,1,332.114125,48.44078,NULL,NULL,55410384958,865787264,13527926,12.86),(153841,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153841,33.96,0.2,61.9,72953,74.4,NULL,NULL,'ESO 404- G 032',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.33',0.2,'S              Sy2',NULL,NULL,NULL,'Sy 2',1,332.117875,-34.10628,0,NULL,50560637355,790009958,12343905,14.33),(153842,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153842,34.31,0.44,72.6,72953,NULL,NULL,'Malmquist cor.','ESO 404- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153843,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153843,34.4,0.42,75.9,72953,NULL,NULL,NULL,'ESO 404- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153844,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153844,37.38,0.46,299,72954,70,NULL,NULL,'2MASX J22082900-0034229',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,332.120708333,-0.57308,0.173,NULL,49853698135,778964033,12171313,18.1),(153845,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,'R',153845,36.96,0.46,246,72955,70,NULL,NULL,'2MASX J22083256-0845248',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.13575,-8.75697,0.085,NULL,49868901170,779201580,12175024,17.1),(153846,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153846,34.79,0.48,90.8,72956,NULL,NULL,NULL,'ESO 601- G 022',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.27',0.2,'S...',NULL,NULL,NULL,NULL,1,332.1385417,-20.43636,0.077,NULL,49743575609,777243368,12144427,16.27),(153847,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153847,34.79,0.48,90.8,72956,NULL,NULL,'Malmquist cor.','ESO 601- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153848,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153848,34.83,0.2,92.5,72956,74.4,NULL,NULL,'ESO 601- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153849,'FP','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153849,36.11,0.58,167,72957,70,NULL,NULL,'2MASX J22083341-1859140',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.85',0.3,NULL,NULL,NULL,NULL,NULL,1,332.1392083,-18.98719,0.037,NULL,49740844037,777200688,12143760,16.85),(153850,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153850,31.55,0.8,20.5,72958,75,NULL,'A82, H','NGC 7205',NULL,'1997ApJS..109..333W',1997,1,4.1,NULL,'G',0.000019,NULL,'11.55',2,'SA(s)bc;HII    LINER','Line-of-sight pair member',NULL,NULL,NULL,1,332.142875,-57.44258,0,NULL,48707533879,761055216,11891487,11.55),(153851,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153851,31.56,0.8,20.5,72958,75,NULL,'MAT, I','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153852,'Sosies','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153852,31.17,0.21,17.1,72958,NULL,NULL,NULL,'NGC 7205',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153853,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153853,30.79,0.4,14.4,72958,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7205',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153854,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153854,30.96,NULL,15.6,72958,NULL,NULL,'B','NGC 7205',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153855,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153855,31.15,0.43,17,72958,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7205',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153856,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:13','1',NULL,NULL,153856,31.17,0.35,17.1,72958,NULL,NULL,NULL,'NGC 7205',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153857,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153857,31.16,0.39,17.1,72958,73,NULL,'opt','NGC 7205',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153858,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153858,31.25,0.47,17.7,72958,75,NULL,'A82, H, raw','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153859,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153859,31.27,0.43,18,72958,75,NULL,'3.6 micron, color corrected','NGC 7205',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153860,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153860,31.34,0.47,18.6,72958,75,NULL,'A82, H, inv','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153861,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153861,31.44,0.46,19.4,72958,NULL,NULL,'J','NGC 7205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153862,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153862,31.45,0.2,19.5,72958,74.4,NULL,NULL,'NGC 7205',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153863,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153863,31.46,0.32,19.6,72958,85,NULL,'I, raw','NGC 7205',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153864,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153864,31.46,0.45,19.6,72958,NULL,NULL,'K','NGC 7205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153865,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153865,31.49,0.47,19.9,72958,NULL,NULL,'H','NGC 7205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153866,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153866,31.51,0.32,20,72958,85,NULL,'I, inv','NGC 7205',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153867,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153867,31.53,0.43,20.3,72958,75,NULL,'MAT, I, raw','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153868,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153868,31.56,0.4,20.5,72958,75,NULL,'B','NGC 7205',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153869,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153869,31.58,0.47,20.7,72958,75,NULL,'A82, H, cor','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153870,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153870,31.74,0.43,22.3,72958,75,NULL,'MAT, I, inv','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153871,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153871,31.76,0.4,22.5,72958,NULL,NULL,'mean','NGC 7205',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153872,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153872,31.79,0.43,22.9,72958,75,NULL,'MAT, I, cor','NGC 7205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153873,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153873,31.85,NULL,23.4,72958,NULL,NULL,'LEDA [April 2006]','NGC 7205',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153874,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153874,34.51,0.5,79.9,72959,70,NULL,NULL,'2MASX J22083612-7202569',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000083,NULL,'16.06',0.25,'S',NULL,NULL,NULL,NULL,1,332.1505417,-72.04914,0.009,NULL,49298902698,770295354,12035864,16.06),(153875,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153875,35.53,0.55,128,72960,70,NULL,NULL,'2MASX J22084129-4351464',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'16.04',0.25,'S',NULL,NULL,NULL,NULL,1,332.1720417,-43.86292,0,NULL,50675336561,791802133,12371908,16.04),(153876,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153876,37.53,0.46,321,72961,70,NULL,NULL,'2MASX J22084501-0059076',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',NULL,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.1874583,-0.98547,0.173,NULL,49854542386,778977224,12171519,17.4),(153877,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06169','RN',153877,39.5,0.14,730,72962,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06169',0.087384,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153878,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06169','RN',153878,40.03,0.24,934,72962,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06169',0.087384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153879,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153879,33.91,0.8,60.4,72963,75,NULL,'MAT, I','IC 5168',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000027,NULL,'15.48',0.3,'SB(s)c: sp','in an interacting pair',NULL,NULL,NULL,1,332.18975,-27.85647,0.017,NULL,50534044679,789594448,12337413,15.48),(153880,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153880,33.49,0.32,49.9,72963,85,NULL,'I, inv','IC 5168',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153881,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153881,33.5,0.32,50.1,72963,85,NULL,'I, raw','IC 5168',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153882,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153882,33.77,0.43,56.9,72963,75,NULL,'MAT, I, raw','IC 5168',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153883,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153883,33.79,0.43,57.4,72963,75,NULL,'MAT, I, inv','IC 5168',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153884,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153884,34.06,0.43,64.8,72963,75,NULL,'MAT, I, cor','IC 5168',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153885,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15540','RN',153885,40.52,0.25,1080,72964,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15540',0.174792,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153886,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15540','RN',153886,40.91,0.33,1290,72964,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15540',0.174792,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153887,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153887,36.59,0.64,208,72965,70,NULL,NULL,'2MASX J22085506-5718042',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.96',0.3,NULL,NULL,NULL,NULL,NULL,1,332.229333,-57.30114,0,NULL,48707613180,761056455,11891507,16.96),(153888,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153888,32.82,0.8,36.6,72966,75,NULL,'MAT, I','ESO 048- G 017',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.60',1,'SB(rs)cd',NULL,NULL,NULL,NULL,1,332.2317083,-73.38192,0.109,NULL,48412716225,756448691,11819510,14.6),(153889,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153889,31.51,0.32,20,72966,85,NULL,'I, inv','ESO 048- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153890,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153890,31.55,0.32,20.4,72966,85,NULL,'I, raw','ESO 048- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153891,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153891,31.87,0.4,23.7,72966,NULL,NULL,NULL,'ESO 048- G 017',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153892,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153892,31.87,0.39,23.7,72966,73,NULL,'opt','ESO 048- G 017',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153893,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153893,32.15,0.43,26.9,72966,75,NULL,'MAT, I, inv','ESO 048- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153894,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153894,32.22,0.43,27.8,72966,75,NULL,'MAT, I, raw','ESO 048- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153895,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153895,32.57,0.43,32.6,72966,75,NULL,'MAT, I, cor','ESO 048- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153896,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153896,34.68,0.8,86.4,72967,75,NULL,'MAT, I','NGC 7214',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'13.05',1.4,'SB(s)bc pec:   Sy1.2','Pair member (points to parent)',NULL,NULL,'Sy 1.2',1,332.282,-27.80947,0.005,NULL,50534046611,789594478,12337413,13.05),(153897,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153897,32.51,0.32,31.8,72967,85,NULL,'I, raw','NGC 7214',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153898,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153898,32.55,0.32,32.3,72967,85,NULL,'I, inv','NGC 7214',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153899,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153899,33.67,0.47,54.1,72967,NULL,NULL,'H','NGC 7214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153900,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153900,33.68,0.45,54.4,72967,NULL,NULL,'K','NGC 7214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153901,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153901,33.76,0.46,56.6,72967,NULL,NULL,'J','NGC 7214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153902,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153902,33.87,0.43,59.3,72967,75,NULL,'MAT, I, raw','NGC 7214',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153903,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153903,34.14,0.43,67.2,72967,75,NULL,'MAT, I, cor','NGC 7214',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153904,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153904,34.19,0.43,69,72967,75,NULL,'MAT, I, inv','NGC 7214',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153905,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153905,34.71,0.4,87.5,72967,NULL,NULL,'mean','NGC 7214',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153906,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153906,37.12,0.46,266,72968,70,NULL,NULL,'2MASX J22090974-0039066',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,332.290667,-0.65183,0.173,NULL,49853687845,778963872,12171310,17.7),(153907,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153907,37.7,0.46,346,72969,70,NULL,NULL,'SDSS J220909.93+010100.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000132,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,332.291417,1.01689,0.113,NULL,52199122915,815611295,12743926,18.6),(153908,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153908,35.19,0.46,109,72970,70,NULL,NULL,'CGCG 428-036',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000103,NULL,'15.5',0.4,NULL,NULL,NULL,NULL,NULL,1,332.2945417,13.50606,0.189,NULL,52253965806,816468215,12757315,15.5),(153909,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153909,38.06,0.46,409,72971,70,NULL,NULL,'SDSS J220911.15-084551.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,332.2965,-8.76419,0.117,NULL,49869074889,779204295,12175067,18.4),(153910,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153910,32.58,0.8,32.7,72972,75,NULL,'MAT, I','ESO 532- G 022',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'14.76',0.8,'SAB(rs)d:',NULL,NULL,NULL,NULL,1,332.296958333,-27.16642,0.045,NULL,50534167855,789596372,12337443,14.76),(153911,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153911,31.87,0.32,23.7,72972,85,NULL,'I, inv','ESO 532- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153912,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153912,31.91,0.32,24.1,72972,85,NULL,'I, raw','ESO 532- G 022',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153913,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153913,32.23,0.43,27.9,72972,75,NULL,'MAT, I, inv','ESO 532- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153914,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153914,32.3,0.43,28.8,72972,75,NULL,'MAT, I, raw','ESO 532- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153915,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153915,32.34,0.08,29.4,72972,NULL,NULL,NULL,'ESO 532- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153916,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153916,32.6,0.43,33.1,72972,75,NULL,'MAT, I, cor','ESO 532- G 022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153917,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03400','RN',153917,41,0.29,1350,72973,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03400',0.178468,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153918,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03400','RN',153918,41.61,0.32,1780,72973,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03400',0.178468,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153919,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153919,31.51,0.43,20.1,72974,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11921',NULL,'2014MNRAS.444..527S',2014,1,1.7,NULL,'G',0.000003,NULL,'14.35',0.7,'IBm','Isolated galaxy',NULL,NULL,NULL,1,332.315166667,14.36,0.237,NULL,52257236444,816519319,12758114,14.35),(153920,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153920,37.1,0.14,263,72975,70,NULL,NULL,'2MASX J22091577-0736227',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,332.315833,-7.60622,0.165,NULL,49838341182,778724080,12167563,16.5),(153921,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153921,31.71,0.8,22,72976,75,NULL,'B','NGC 7213',NULL,'1988NBGC.C....0000T',1988,1,3.1,NULL,'G',0.000019,NULL,'11.01',2.8,'SA(s)0^0;LINER Sy1.5','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,332.317958333,-47.16661,0,NULL,50622015599,790968993,12358890,11.01),(153922,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153922,37.1,0.14,263,72977,70,NULL,NULL,'2MASX J22091738-0734367',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000162,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.322417,-7.57697,0.165,NULL,49838327555,778723868,12167560,17.8),(153923,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153923,37.82,0.46,367,72978,70,NULL,NULL,'2MASX J22092130+0113260',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000127,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.338625,1.22397,0.069,NULL,52198947114,815608548,12743883,17.9),(153924,'SNII optical','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2001cy',NULL,153924,33.01,0.12,38.8,72979,NULL,NULL,'SEAM','UGC 11927',0.014937,'2009ApJ...694.1067P',2009,1,1.5,NULL,'G',0.000037,NULL,'14.4',1.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,332.364333,40.98969,0.901,NULL,55515254371,867425849,13553528,14.4),(153925,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007kp',NULL,153925,40.63,0.19,1340,72980,70,NULL,'Hubble residual 0.51 for z0.28620','SDSS J220929.61+004417.0',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,332.373375,0.73806,0.097,NULL,52198179964,815596561,12743696,NULL),(153926,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17791','R',153926,41.34,0.27,1440,72980,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007kp','SDSS J220929.61+004417.0',0.2862,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153927,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17791','R',153927,41.56,0.25,1590,72980,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007kp','SDSS J220929.61+004417.0',0.2862,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153928,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153928,37.36,0.33,297,72981,70,NULL,NULL,'SDSS J220930.84-000914.3',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000168,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,332.3785417,-0.154,0.153,NULL,49799152352,778111755,12157996,18),(153929,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153929,33.8,0.2,57.5,72982,74.4,NULL,NULL,'MCG -01-56-002',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000027,NULL,'15.07',1.1,'SAB(r)cd:',NULL,NULL,NULL,NULL,1,332.393375,-6.11428,0.145,NULL,49839095433,778735866,12167747,15.07),(153930,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153930,34.02,0.47,63.8,72982,NULL,NULL,NULL,'MCG -01-56-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153931,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153931,34.16,0.44,68,72982,NULL,NULL,'Malmquist cor.','MCG -01-56-002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153932,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153932,37.36,0.33,297,72983,70,NULL,NULL,'2MASX J22093665-0009190',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000177,NULL,'15.9g',0.4,'E0',NULL,NULL,NULL,NULL,1,332.402667,-0.15533,0.141,NULL,49799155679,778111807,12157996,15.9),(153933,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153933,35.46,0.55,124,72984,NULL,NULL,'Malmquist cor.','ESO 532- G 023',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.93',0.8,'Sb-c',NULL,NULL,NULL,NULL,1,332.4045,-27.2465,0,NULL,50534162572,789596290,12337442,14.93),(153934,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153934,35.68,0.5,137,72984,NULL,NULL,NULL,'ESO 532- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153935,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153935,35.72,0.2,139,72984,74.4,NULL,NULL,'ESO 532- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153936,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153936,35.19,0.49,109,72985,75,NULL,'IR','CGCG 428-038',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'15.65',0.2,'S?',NULL,NULL,NULL,NULL,1,332.418416667,13.63589,0.181,NULL,52258409352,816537646,12758400,15.65),(153937,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153937,35.59,0.2,131,72986,74.4,NULL,NULL,'CGCG 428-038',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'15.65',0.2,'S?',NULL,NULL,NULL,NULL,1,332.418416667,13.63589,0.181,NULL,52258409352,816537646,12758400,15.65),(153938,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153938,37.13,0.33,267,72987,70,NULL,NULL,'2MASX J22094050-0925483',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,332.41875,-9.43017,0.085,NULL,49877503793,779335996,12177124,16.4),(153939,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153939,36.96,0.7,247,72988,70,NULL,NULL,'2MASX J22094092-1447040',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,332.4205417,-14.7845,0.117,NULL,49757239420,777456865,12147763,14.6),(153940,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153940,37.47,0.27,312,72989,70,NULL,NULL,'2MASX J22094408-0929373',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.433666667,-9.49367,0.085,NULL,49877569199,779337018,12177140,17.5),(153941,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 09754','RN',153941,39.46,0.24,715,72990,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03166 HOST',0.088847,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153942,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 09754','RN',153942,39.52,0.17,735,72990,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03166 HOST',0.088847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153943,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03166','RN',153943,39.6,0.17,763,72990,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03166 HOST',0.088964,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153944,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03166','RN',153944,39.66,0.26,785,72990,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03166 HOST',0.088964,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153945,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153945,35,0.4,99.9,72991,NULL,NULL,'mean','KUG 2207+182',NULL,'2007A&A...465...71T',2007,1,0.85,NULL,'G',0.000033,NULL,'15.4',0.35,'Sp:',NULL,NULL,NULL,NULL,1,332.447167,18.5025,0.165,NULL,52222122150,815970658,12749541,15.4),(153946,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153946,35.34,0.47,117,72991,NULL,NULL,'H','KUG 2207+182',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153947,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153947,37.13,0.33,267,72992,70,NULL,NULL,'2MASX J22094773-0931103',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,332.448875,-9.51964,0.085,NULL,49877567467,779336991,12177140,17.9),(153948,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 18651','R',153948,40.45,0.24,983,72993,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18651',0.248997,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,332.457083,0.11261,0.121,NULL,52152103895,814876623,12732447,NULL),(153949,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 18651','R',153949,40.74,0.2,1130,72993,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18651',0.248997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153950,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153950,35.03,0.5,102,72994,70,NULL,NULL,'2MASX J22095113-5716166',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.42',0.27,'S',NULL,NULL,NULL,NULL,1,332.463083,-57.27122,0,NULL,48707571093,761055798,11891496,16.42),(153951,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153951,35.62,0.2,133,72995,74.4,NULL,NULL,'IC 5172',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000076,NULL,'15.8g',0.28,'Sbc',NULL,NULL,NULL,NULL,1,332.4812917,12.81806,0.197,NULL,52253756197,816464940,12757264,15.8),(153952,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153952,37.47,0.27,312,72996,70,NULL,NULL,'2MASX J22095727-0936573',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.1g',0.42,'AGN',NULL,NULL,NULL,NULL,1,332.488667,-9.61603,0.097,NULL,49877397162,779334330,12177098,16.1),(153953,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153953,35.02,0.49,101,72997,75,NULL,'IR','UGC 11930',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000017,NULL,'16.0',0.2,'Sab',NULL,NULL,NULL,NULL,1,332.4919583,20.93336,0.245,NULL,52224614495,816009601,12750150,16),(153954,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153954,34.87,0.48,94.2,72998,70,NULL,NULL,'AM 2206-500 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00007,NULL,'15.56',0.55,'(R)SAB0^+',NULL,NULL,NULL,NULL,1,332.505625,-49.67581,0,NULL,50622412163,790975190,12358987,15.56),(153955,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05990','RN',153955,41.61,0.19,1510,72999,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05990',0.388384,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153956,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05990','RN',153956,42.08,0.1,1880,72999,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05990',0.388384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153957,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05890','R',153957,39.78,0.19,766,73000,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J221003.78+003634.9',0.1796,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.0005,NULL,'19.9g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,332.51575,0.60969,0.097,NULL,52152832317,814888004,12732625,19.9),(153958,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05890','R',153958,40.06,0.11,873,73000,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J221003.78+003634.9',0.1796,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153959,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05890',NULL,153959,39.72,0.08,879,73000,70,NULL,'SALT 2','SDSS J221003.78+003634.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153960,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05890',NULL,153960,39.73,0.08,883,73000,70,NULL,'SALT 2, Malmquist cor.','SDSS J221003.78+003634.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153961,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153961,35.91,0.71,152,73001,70,NULL,NULL,'LCRS B220659.8-451404',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.13',0.42,'E',NULL,NULL,NULL,NULL,1,332.5212917,-44.98828,0,NULL,50672369198,791755768,12371183,16.13),(153962,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153962,37.23,0.46,279,73002,70,NULL,NULL,'SDSS J221005.25-071514.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000154,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,332.521916667,-7.25414,0.193,NULL,49840765781,778761965,12168155,17.7),(153963,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',153963,33.44,0.49,48.7,73003,75,NULL,'IR','IC 5169',NULL,'2011yCatp016004901K',2011,1,1.9,NULL,'G',0.000043,NULL,'13.60',0.8,'(R_1)SAB(r)0+;HIISy2',NULL,NULL,NULL,'Sy 2',1,332.541583333,-36.08861,0,NULL,50555403383,789928177,12342627,13.6),(153964,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2006fm',NULL,153964,38.57,0.05,518,73004,70,NULL,'Hubble residual 0.06 for z0.12570','SDSS J221010.31+003013.9',NULL,'2011ApJ...740...92G',2011,1,0.14,NULL,'G',0.0005,NULL,'19.92',0.11,NULL,NULL,NULL,NULL,NULL,1,332.543,0.50392,0.121,NULL,52152860268,814888441,12732631,19.92),(153965,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 13044','R',153965,38.88,0.18,531,73004,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fm','SDSS J221010.31+003013.9',0.1257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153966,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2006fm',NULL,153966,38.77,0.06,568,73004,70,NULL,'SALT 2','SDSS J221010.31+003013.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153967,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2006fm',NULL,153967,38.78,0.06,570,73004,70,NULL,'SALT 2, Malmquist cor.','SDSS J221010.31+003013.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153968,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 13044','R',153968,39.06,0.08,576,73004,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fm','SDSS J221010.31+003013.9',0.1257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153969,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153969,31.64,0.8,21.3,73005,75,NULL,'MAT, I','NGC 7218',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000021,NULL,'12.81',1.1,'SB(r)c         HII',NULL,NULL,NULL,NULL,1,332.5487917,-16.661,0.077,NULL,49790387026,777974797,12155856,12.81),(153970,'Sosies','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153970,32.1,0.09,26.3,73005,NULL,NULL,NULL,'NGC 7218',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153971,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153971,31.64,0.43,21.3,73005,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7218',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153972,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153972,31.69,0.4,21.8,73005,NULL,NULL,NULL,'NGC 7218',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153973,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153973,31.69,0.4,21.8,73005,73,NULL,'opt','NGC 7218',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153974,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153974,31.71,0.4,22,73005,75,NULL,'B','NGC 7218',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153975,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153975,31.74,0.4,22.3,73005,NULL,NULL,'mean','NGC 7218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153976,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153976,31.77,0.43,22.6,73005,75,NULL,'3.6 micron, color corrected','NGC 7218',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153977,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153977,31.85,0.2,23.4,73005,74.4,NULL,NULL,'NGC 7218',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153978,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153978,31.89,0.32,23.9,73005,85,NULL,'I, raw','NGC 7218',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153979,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153979,31.9,0.41,24,73005,NULL,NULL,NULL,'NGC 7218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153980,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153980,31.91,0.32,24.1,73005,85,NULL,'I, inv','NGC 7218',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153981,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153981,31.97,0.47,24.8,73005,NULL,NULL,'H','NGC 7218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153982,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153982,31.98,0.46,24.9,73005,NULL,NULL,'J','NGC 7218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153983,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153983,32.05,0.45,25.7,73005,NULL,NULL,'K','NGC 7218',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153984,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153984,32.05,0.43,25.7,73005,75,NULL,'MAT, I, raw','NGC 7218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153985,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153985,32.07,0.38,26,73005,NULL,NULL,'Malmquist cor.','NGC 7218',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153986,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153986,32.18,0.43,27.3,73005,75,NULL,'MAT, I, inv','NGC 7218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153987,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153987,32.37,0.43,29.8,73005,75,NULL,'MAT, I, cor','NGC 7218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153988,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153988,31.73,0.8,22.2,73006,75,NULL,'MAT, I','UGCA 426',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000027,NULL,'14.59',0.7,'SAB(s)dm III-IV','Pair member (points to parent)',NULL,NULL,NULL,1,332.553417,-18.86492,0.017,NULL,49733731666,777089557,12142024,14.59),(153989,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153989,31.43,0.32,19.3,73006,85,NULL,'I, inv','UGCA 426',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153990,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153990,31.46,0.32,19.6,73006,85,NULL,'I, raw','UGCA 426',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153991,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153991,31.53,0.4,20.2,73006,NULL,NULL,NULL,'UGCA 426',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153992,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153992,31.53,0.39,20.2,73006,73,NULL,'opt','UGCA 426',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153993,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153993,31.79,0.4,22.8,73006,75,NULL,'B','UGCA 426',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153994,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153994,31.93,0.43,24.3,73006,75,NULL,'MAT, I, inv','UGCA 426',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153995,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153995,32.02,0.43,25.3,73006,75,NULL,'MAT, I, raw','UGCA 426',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153996,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153996,32.35,0.43,29.6,73006,75,NULL,'MAT, I, cor','UGCA 426',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153997,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153997,32.38,0.53,29.9,73006,NULL,NULL,NULL,'UGCA 426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153998,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153998,32.42,0.2,30.5,73006,74.4,NULL,NULL,'UGCA 426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(153999,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,153999,32.5,0.5,31.7,73006,NULL,NULL,'Malmquist cor.','UGCA 426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154000,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154000,37.47,0.27,312,73007,70,NULL,NULL,'2MASX J22101288-0936366',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.553666667,-9.61025,0.097,NULL,49877601773,779337527,12177148,17.9),(154001,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154001,35.94,0.48,154,73008,70,NULL,NULL,'FAIRALL 1001',NULL,'2014MNRAS.445.2677S',2014,1,0.98,NULL,'G',0.00015,NULL,'15.22',0.53,'E',NULL,NULL,NULL,NULL,1,332.568708333,-44.73008,0,NULL,50671815180,791747112,12371048,15.22),(154002,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154002,38.12,0.46,420,73009,70,NULL,NULL,'2MASX J22101749-0001256',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,332.572791667,-0.02378,0.141,NULL,49799103041,778110985,12157984,17.8),(154003,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06737','RN',154003,42.46,0.34,2140,73010,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06737',0.44941,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154004,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06737','RN',154004,42.99,0.32,2730,73010,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06737',0.44941,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154005,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17399','RN',154005,39.57,0.09,785,73011,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17399',0.045525,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154006,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17399','RN',154006,40.09,0.22,999,73011,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17399',0.045525,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154007,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07986',NULL,154007,40.74,0.32,1410,73012,70,NULL,'SN photometric redshift distance, z photo =0.406 +/- 0.085','SDSS-II SN 07986',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.6214583,-0.43756,0.153,NULL,49799970763,778124543,12158195,NULL),(154008,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154008,36.59,0.57,208,73013,70,NULL,NULL,'2MASX J22102985-0226486',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.76',0.22,NULL,NULL,NULL,NULL,NULL,1,332.6244583,-2.44681,0.209,NULL,49856850123,779013283,12172082,16.76),(154009,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154009,37.87,0.46,375,73014,70,NULL,NULL,'2MASX J22103046-0910100',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0002,NULL,'17.1g',0.21,NULL,NULL,NULL,NULL,NULL,1,332.626958333,-9.1695,0.109,NULL,49876693002,779323328,12176927,17.1),(154010,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154010,37.62,0.46,334,73015,70,NULL,NULL,'2MASX J22103364-0113375',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.64025,-1.22714,0.197,NULL,49854281729,778973152,12171455,17.7),(154011,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03625','RN',154011,42.76,0.2,2610,73016,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03625',0.364195,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154012,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03625','RN',154012,42.99,0.23,2900,73016,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03625',0.364195,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154013,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154013,38.29,0.46,455,73017,70,NULL,NULL,'2MASX J22103633-0839450',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,332.6514583,-8.66253,0.125,NULL,49868267397,779191678,12174869,17.3),(154014,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154014,35.12,0.58,106,73018,NULL,NULL,'Malmquist cor.','ESO 467- G 017',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.00001,NULL,'14.48',0.7,'SA(rs)bc',NULL,NULL,NULL,NULL,1,332.6702083,-27.89631,0,NULL,50547843880,789810060,12340782,14.48),(154015,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154015,35.28,0.54,114,73018,NULL,NULL,NULL,'ESO 467- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154016,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154016,35.32,0.2,116,73018,74.4,NULL,NULL,'ESO 467- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154017,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154017,35.4,0.4,120,73018,NULL,NULL,'mean','ESO 467- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154018,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154018,35.68,0.47,137,73018,NULL,NULL,'H','ESO 467- G 017',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154019,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154019,36.85,0.64,235,73019,70,NULL,NULL,'MCG -02-56-020',NULL,'2014MNRAS.445.2677S',2014,1,0.15,NULL,'G',0.00015,NULL,'15',0.15,NULL,NULL,NULL,NULL,NULL,1,332.673625,-10.46442,0.061,NULL,49877679282,779338738,12177167,15),(154020,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154020,35.12,0.54,105,73020,70,NULL,NULL,'2MASX J22104239-8519120',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,332.67575,-85.31997,0.441,NULL,48379989077,755937329,11811520,16.3),(154021,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07954','R',154021,40.27,0.22,904,73021,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07954',0.2553,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,332.6769583,0.34772,0.121,NULL,52152943544,814889742,12732652,NULL),(154022,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07954','R',154022,40.46,0.17,984,73021,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07954',0.2553,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154023,'CMD','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'N',154023,17.52,0.11,0.0319,73022,NULL,NULL,NULL,'SDSS J2211+1457',NULL,'2013ApJ...767..101B',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154024,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154024,37.11,0.46,264,73023,70,NULL,NULL,'2MASX J22104526-0023007',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000143,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.688625,-0.38353,0.153,NULL,49799962666,778124416,12158194,17.5),(154025,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154025,37.1,0.55,263,73024,70,NULL,NULL,'2MASX J22104544-7250439',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.000103,NULL,'15.0r',0.23,NULL,NULL,NULL,NULL,NULL,1,332.68925,-72.84558,0.053,NULL,49298205337,770284458,12035694,15),(154026,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03262','RN',154026,42.96,0.42,2900,73025,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03262',0.346705,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154027,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03262','RN',154027,43.25,0.32,3310,73025,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03262',0.346705,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154028,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154028,37.2,0.46,275,73026,70,NULL,NULL,'2MASX J22104762-0054067',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000156,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,332.698417,-0.90192,0.189,NULL,49799416378,778115880,12158060,17.4),(154029,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06170','RN',154029,41.94,0.25,2230,73027,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06170',0.094676,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154030,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2008dr',NULL,154030,36.29,0.14,174,73028,70,NULL,'SALT 2','NGC 7222',0.041449,'2013MNRAS.433.2240G',2013,1,1.2,NULL,'G',0.000133,NULL,'14.59',1.2,'SB(r)b',NULL,NULL,NULL,NULL,1,332.715667,2.10581,0.073,NULL,52202166968,815658858,12744669,14.59),(154031,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2008dr','R',154031,36.26,0.06,179,73028,NULL,NULL,'MLCS2k2, R(V) = 1.8','NGC 7222',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154032,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2008dr','R',154032,36.28,0.07,180,73028,NULL,NULL,'MLCS2k2, R(V) = 3.1','NGC 7222',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154033,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154033,32.66,0.8,34.1,73029,75,NULL,NULL,'IC 5171',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000017,NULL,'13.43',0.4,'(R\':)SB(r)b',NULL,NULL,NULL,NULL,1,332.73625,-46.08147,0,NULL,50692395498,792068679,12376073,13.43),(154034,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154034,32.45,0.4,30.9,73029,73,NULL,'IR','IC 5171',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154035,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154035,32.45,0.4,30.9,73029,73,NULL,'opt','IC 5171',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154036,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154036,32.45,0.4,30.9,73029,75,NULL,NULL,'IC 5171',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154037,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154037,32.53,0.49,32.1,73029,75,NULL,'IR','IC 5171',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154038,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154038,32.54,0.46,32.2,73029,NULL,NULL,'J','IC 5171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154039,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154039,32.58,0.47,32.8,73029,NULL,NULL,'H','IC 5171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154040,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154040,32.65,0.45,33.9,73029,NULL,NULL,'K','IC 5171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154041,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154041,32.82,0.4,36.6,73029,NULL,NULL,'mean','IC 5171',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154042,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154042,37.38,0.46,299,73030,70,NULL,NULL,'2MASX J22105748-0910100',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000157,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,332.739583,-9.16928,0.113,NULL,49876675401,779323053,12176922,17.2),(154043,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154043,34.78,0.43,90.4,73031,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2370',NULL,'2014MNRAS.444..527S',2014,1,0.94,NULL,'G',0.000009,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,332.7455,22.77525,0.233,NULL,52211077026,815798078,12746844,16.5),(154044,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154044,34.84,0.49,92.8,73031,75,NULL,'IR','FGC 2370',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154045,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154045,34.89,NULL,95.3,73031,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154046,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154046,34.91,NULL,96,73031,NULL,NULL,'Dipole + Quadrupole','FGC 2370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154047,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154047,34.92,NULL,96.6,73031,NULL,NULL,'Dipole','FGC 2370',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154048,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154048,34.97,NULL,98.6,73031,NULL,NULL,NULL,'FGC 2370',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154049,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154049,36.83,0.46,232,73032,70,NULL,NULL,'2MASX J22110154+1222274',NULL,'2015arXiv151105856S',2015,1,0.83,NULL,'G',0.000169,NULL,'15.9g',0.31,'E0',NULL,NULL,NULL,NULL,1,332.756333,12.37433,0.217,NULL,52257941040,816530328,12758286,15.9),(154050,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17415','RN',154050,40.39,0.09,997,73033,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17415',0.201492,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154051,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 17415','RN',154051,41,0.18,1320,73033,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17415',0.201492,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154052,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154052,38.68,0.46,545,73034,70,NULL,NULL,'2MASX J22110481-0924545',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,332.77,-9.41525,0.105,NULL,49876766176,779324471,12176944,17.3),(154053,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16053','RN',154053,41.05,0.3,1320,73035,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16053',0.229895,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154054,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16053','RN',154054,41.4,0.41,1550,73035,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16053',0.229895,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154055,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 02262','RN',154055,41.13,0.17,1230,73036,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02262',0.361914,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154056,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 02262','RN',154056,41.95,0.24,1800,73036,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02262',0.361914,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154057,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 00870','RN',154057,42.18,0.19,1630,73037,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00870',0.666893,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154058,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 13855','RN',154058,39.47,0.32,664,73038,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13855',0.177735,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154059,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 13855','RN',154059,40.79,0.37,1220,73038,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13855',0.177735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154060,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154060,33.66,0.8,54,73039,75,NULL,'MAT, I','NGC 7221',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.00001,NULL,'12.80',1.6,'SB(rs)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,332.8135417,-30.56317,0,NULL,50538876730,789669948,12338592,12.8),(154061,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154061,33.51,0.43,50.3,73039,75,NULL,'MAT, I, raw','NGC 7221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154062,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154062,33.62,0.47,53.1,73039,NULL,NULL,'H','NGC 7221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154063,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154063,33.71,0.45,55.3,73039,NULL,NULL,'K','NGC 7221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154064,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154064,33.77,0.46,56.7,73039,NULL,NULL,'J','NGC 7221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154065,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154065,33.79,0.43,57.2,73039,75,NULL,'MAT, I, cor','NGC 7221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154066,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154066,33.79,0.43,57.4,73039,75,NULL,'MAT, I, inv','NGC 7221',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154067,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154067,33.86,0.32,59.2,73039,85,NULL,'I, raw','NGC 7221',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154068,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154068,33.89,0.4,59.9,73039,NULL,NULL,'mean','NGC 7221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154069,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154069,33.94,0.32,61.4,73039,85,NULL,'I, inv','NGC 7221',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154070,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154070,34.11,0.2,66.4,73039,74.4,NULL,NULL,'NGC 7221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154071,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154071,37.7,0.46,346,73040,70,NULL,NULL,'SDSS J221115.35-091524.2',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,332.8139583,-9.25672,0.113,NULL,49876799930,779324998,12176953,18.3),(154072,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15660',NULL,154072,41.3,0.27,1820,73041,70,NULL,'SN photometric redshift distance, z photo =0.574 +/- 0.114','SDSS-II SN 15660',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.82225,-0.04061,0.125,NULL,49799601394,778118771,12158105,NULL),(154073,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06098','RN',154073,44.38,0.61,5610,73042,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06098',0.341108,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154074,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07248','RN',154074,39.01,0.27,564,73043,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07248',0.12622,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154075,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 07248','RN',154075,40.07,0.29,916,73043,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07248',0.12622,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154076,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154076,36.3,0.46,182,73044,70,NULL,NULL,'2MASX J22112741-0003016',NULL,'2015arXiv151105856S',2015,1,0.54,'The APM image includes a neighboring star.','G',0.00015,NULL,'15.8g',0.42,'poss. LINER',NULL,NULL,NULL,NULL,1,332.8642917,-0.05061,0.125,NULL,49799609457,778118897,12158107,15.8),(154077,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154077,36.71,0.53,219,73044,70,NULL,NULL,'2MASX J22112741-0003016',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154078,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2006fl',NULL,154078,39.23,0.07,702,73045,70,NULL,'Hubble residual 0.09 for z0.17173','SDSS J221127.68+004520.0',NULL,'2011ApJ...740...92G',2011,1,0.18,NULL,'G',0.00011,NULL,'18.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,332.865375,0.75558,0.093,NULL,52152665710,814885401,12732584,18.8),(154079,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 12856','R',154079,39.62,0.19,716,73045,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fl','SDSS J221127.68+004520.0',0.17173,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154080,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 12856','R',154080,39.96,0.09,837,73045,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fl','SDSS J221127.68+004520.0',0.17173,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154081,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154081,36.86,0.61,235,73046,70,NULL,NULL,'2MASX J22112948-1819263',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.72',0.2,NULL,NULL,NULL,NULL,NULL,1,332.872791667,-18.32397,0.073,NULL,49733478629,777085603,12141962,16.72),(154082,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154082,34.77,0.57,89.9,73047,70,NULL,NULL,'NGC 7220',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00009,NULL,'14.87',0.7,'SAB(s)0^0^:',NULL,NULL,NULL,NULL,1,332.879167,-22.95286,0.041,NULL,49728474397,777007412,12140740,14.87),(154083,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15470','RN',154083,41.6,0.22,1700,73048,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15470',0.233684,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154084,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15470','RN',154084,41.88,0.31,1920,73048,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15470',0.233684,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154085,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007mo',NULL,154085,39.31,0.14,727,73049,70,NULL,'Hubble residual -0.33 for z0.22150','SDSS-II SN 19230',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,332.8910417,0.76478,0.093,NULL,52152665326,814885395,12732584,NULL),(154086,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19230','R',154086,39.9,0.22,784,73049,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mo','SDSS-II SN 19230',0.221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154087,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19230','R',154087,40.04,0.15,833,73049,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mo','SDSS-II SN 19230',0.221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154088,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154088,34.77,0.8,90.1,73050,75,NULL,'W91PP, r','UGC 11941',NULL,'1997ApJS..109..333W',1997,1,0.95,NULL,'G',0.000033,NULL,'16.5',0.13,'Sbc',NULL,NULL,NULL,NULL,1,332.8917083,29.85989,0.345,NULL,55443480048,866304375,13536005,16.5),(154089,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154089,35.03,0.38,101,73050,NULL,NULL,'Malmquist cor.','UGC 11941',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154090,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154090,35.15,0.38,107,73050,75,NULL,'W91PP, r, raw','UGC 11941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154091,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154091,35.18,0.38,109,73050,75,NULL,'W91PP, r, inv','UGC 11941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154092,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154092,35.21,0.49,110,73050,75,NULL,'IR','UGC 11941',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154093,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154093,35.25,NULL,112,73050,NULL,NULL,NULL,'UGC 11941',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154094,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154094,35.28,0.43,114,73050,75,NULL,'3.6 micron, color corrected','UGC 11941',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154095,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154095,35.28,NULL,114,73050,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11941',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154096,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154096,35.3,NULL,115,73050,NULL,NULL,'Dipole','UGC 11941',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154097,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154097,35.3,NULL,115,73050,NULL,NULL,'Dipole + Quadrupole','UGC 11941',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154098,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154098,35.31,0.2,115,73050,74.4,NULL,NULL,'UGC 11941',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154099,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154099,35.32,0.43,116,73050,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11941',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154100,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154100,35.35,0.38,117,73050,75,NULL,'W91PP, r, cor','UGC 11941',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154101,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154101,35.4,0.32,120,73050,NULL,NULL,NULL,'UGC 11941',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154102,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154102,34.54,0.69,80.9,73051,100,NULL,'mid-IR','IC 5177',NULL,'2013ApJ...771...88L',2013,1,1.6,NULL,'G',0.000033,NULL,'14.70',0.8,'SBb',NULL,NULL,NULL,NULL,1,332.892791667,11.79594,0.185,NULL,52279103817,816860997,12763453,14.7),(154103,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154103,35.16,0.2,108,73051,74.4,NULL,NULL,'IC 5177',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154104,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154104,35.29,0.4,114,73051,NULL,NULL,'mean','IC 5177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154105,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154105,35.43,0.47,122,73051,NULL,NULL,'H','IC 5177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154106,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154106,35.51,0.45,127,73051,NULL,NULL,'K','IC 5177',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154107,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03402',NULL,154107,40.9,0.44,1520,73052,70,NULL,'SN photometric redshift distance, z photo =0.448 +/- 0.142','SDSS-II SN 03402',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.8960417,0.52697,0.097,NULL,52152805913,814887592,12732618,NULL),(154108,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154108,34.67,0.49,85.7,73053,75,NULL,'IR','2MFGC 16741',NULL,'2011yCatp016004901K',2011,1,0.71,NULL,'G',0.000172,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.899625,13.95408,0.173,NULL,52260715817,816573684,12758963,16.7),(154109,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154109,34.77,0.2,90,73054,74.4,NULL,NULL,'2MFGC 16741',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000172,NULL,'16.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,332.899625,13.95408,0.173,NULL,52260715817,816573684,12758963,16.7),(154110,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154110,35.13,NULL,106,73055,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2371',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.000012,NULL,'16.7',0.1,'Sd',NULL,NULL,NULL,NULL,1,332.910583,15.71847,0.157,NULL,52250387402,816412303,12756442,16.7),(154111,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154111,35.14,NULL,107,73055,NULL,NULL,'Dipole + Quadrupole','FGC 2371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154112,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154112,35.16,NULL,108,73055,NULL,NULL,'Dipole','FGC 2371',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154113,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154113,35.19,NULL,109,73055,NULL,NULL,NULL,'FGC 2371',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154114,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154114,35.51,0.49,127,73055,75,NULL,'IR','FGC 2371',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154115,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06171','RN',154115,39.73,0.38,816,73056,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06171',0.081137,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154116,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06171','RN',154116,39.98,0.44,915,73056,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06171',0.081137,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154117,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154117,34.36,0.4,74.6,73057,NULL,NULL,'mean','UGC 11946',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000027,NULL,'14.3',0.8,'SAB(s)c        HII',NULL,NULL,NULL,NULL,1,332.912375,46.30961,NULL,NULL,55537000223,867765628,13558837,14.3),(154118,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154118,34.5,0.47,79.4,73057,NULL,NULL,'H','UGC 11946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154119,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154119,34.5,0.45,79.4,73057,NULL,NULL,'K','UGC 11946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154120,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154120,34.56,0.46,81.7,73057,NULL,NULL,'J','UGC 11946',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154121,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154121,34.67,0.2,85.9,73057,74.4,NULL,NULL,'UGC 11946',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154122,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154122,34.73,0.43,88.4,73057,75,NULL,'3.6 micron, color corrected','UGC 11946',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154123,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154123,34.82,0.43,92.2,73057,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11946',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154124,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19953','R',154124,38.8,0.18,514,73058,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pf','APMUKS(BJ) B220909.80+001954.4',0.12,'2014arXiv1401.3317S',2014,1,0.14,NULL,'G',NULL,NULL,'20.00',0.11,NULL,NULL,NULL,NULL,NULL,1,332.93,0.57936,0.093,NULL,52152826099,814887907,12732623,20),(154125,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007pf',NULL,154125,38.78,0.07,570,73058,70,NULL,'SALT 2','APMUKS(BJ) B220909.80+001954.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154126,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007pf',NULL,154126,38.79,0.07,573,73058,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B220909.80+001954.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154127,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19953','R',154127,39.07,0.08,583,73058,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pf','APMUKS(BJ) B220909.80+001954.4',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154128,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154128,37.37,0.46,298,73059,70,NULL,NULL,'2MASX J22114360-0843099',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,332.9317083,-8.71956,0.133,NULL,49837805089,778715704,12167432,17.7),(154129,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941',NULL,154129,40.27,0.14,1130,73060,70,NULL,'SN photometric redshift distance, z photo =0.311 +/- 0.025','SDSS-II SN 15941',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.932041667,-0.68481,0.185,NULL,49799813517,778122086,12158157,21.8),(154130,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941','R',154130,40.95,0.26,1170,73060,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15941',0.326069,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154131,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941','R',154131,41.07,0.22,1230,73060,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15941',0.326069,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154132,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941',NULL,154132,40.84,0.17,1470,73060,70,NULL,'SALT 2','SDSS-II SN 15941',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154133,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15941',NULL,154133,40.88,0.17,1500,73060,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15941',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154134,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199','R',154134,40.57,0.17,1010,73061,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16199',0.282392,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,332.94425,1.13494,0.077,NULL,52152542089,814883470,12732554,NULL),(154135,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199','R',154135,40.62,0.24,1040,73061,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16199',0.282392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154136,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199',NULL,154136,40.15,0.29,1070,73061,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.050','SDSS-II SN 16199',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154137,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199',NULL,154137,40.49,0.13,1250,73061,70,NULL,'SALT 2','SDSS-II SN 16199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154138,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 16199',NULL,154138,40.52,0.13,1270,73061,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154139,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154139,31.91,0.8,24.1,73062,75,NULL,'MAT, I','ESO 288- G 049',NULL,'1997ApJS..109..333W',1997,1,2.3,'RC3 gives V = 17193 +- 48 km/sec.','G',0.000028,NULL,'13.94',1.5,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,332.952333333,-45.58964,0,NULL,50726167221,792596362,12384318,13.94),(154140,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154140,30.73,0.32,14,73062,85,NULL,'I, inv','ESO 288- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154141,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154141,30.78,0.32,14.3,73062,85,NULL,'I, raw','ESO 288- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154142,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154142,30.81,0.4,14.5,73062,NULL,NULL,NULL,'ESO 288- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154143,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154143,31.29,0.43,18.1,73062,75,NULL,'MAT, I, inv','ESO 288- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154144,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154144,31.36,0.43,18.7,73062,75,NULL,'MAT, I, raw','ESO 288- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154145,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154145,31.52,0.39,20.1,73062,73,NULL,'opt','ESO 288- G 049',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154146,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154146,31.65,0.43,21.4,73062,75,NULL,'MAT, I, cor','ESO 288- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154147,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154147,34.69,0.4,86.8,73063,NULL,NULL,'mean','NGC 7228',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.4',1.3,'(R\')SB(s)a',NULL,NULL,NULL,NULL,1,332.9525,38.69917,0.641,NULL,55505810620,867278290,13551223,14.4),(154148,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154148,34.7,0.47,87,73063,NULL,NULL,'H','NGC 7228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154149,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154149,34.7,0.45,87.2,73063,NULL,NULL,'K','NGC 7228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154150,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154150,34.73,0.46,88.2,73063,NULL,NULL,'J','NGC 7228',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154151,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154151,35.61,0.14,132,73064,70,NULL,NULL,'2MASX J22114920+1358032',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00007,NULL,'16.3g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,332.955125,13.96767,0.173,NULL,52260703430,816573491,12758960,16.3),(154152,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154152,37.11,0.33,264,73065,70,NULL,NULL,'2MASX J22115558-0919229',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,332.9815,-9.32289,0.113,NULL,49876787018,779324797,12176949,17.4),(154153,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154153,37.66,0.46,341,73066,70,NULL,NULL,'2MASX J22115628-0851379',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,332.9845417,-8.86039,0.125,NULL,49868204512,779190695,12174854,16.4),(154154,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154154,32,0.8,25.1,73067,75,NULL,NULL,'UGC 11944',NULL,'1988NBGC.C....0000T',1988,1,2.4,NULL,'G',0.000013,NULL,'16.0',0.8,'Im:',NULL,NULL,NULL,NULL,1,333.003167,17.90267,0.177,NULL,52268948965,816702327,12760973,16),(154155,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154155,36.83,0.46,232,73068,70,NULL,NULL,'SDSS J221202.93+000314.2',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',NULL,NULL,'16.4g',0.25,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,333.01225,0.05397,0.113,NULL,52152284476,814879444,12732491,16.4),(154156,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154156,37.1,0.46,263,73069,70,NULL,NULL,'2MASX J22120417-0043348',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000161,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,333.017416667,-0.72636,0.185,NULL,49799770089,778121407,12158146,17.3),(154157,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154157,37.11,0.33,264,73070,70,NULL,NULL,'2MASX J22120663-0919326',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,333.027583,-9.32575,0.113,NULL,49876608838,779322013,12176906,16.6),(154158,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 08196','RN',154158,39.21,0.23,645,73071,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 08196',0.080016,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154159,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 08196','RN',154159,39.37,0.16,693,73071,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 08196',0.080016,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154160,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154160,35.73,0.5,140,73072,70,NULL,NULL,'IC 1433 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.64',NULL,NULL,NULL,NULL,NULL,NULL,1,333.044333333,-12.76558,0.129,NULL,49759316117,777489314,12148270,15.64),(154161,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154161,36.99,0.46,250,73073,70,NULL,NULL,'2MASX J22121062-0927116',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,333.0444583,-9.45317,0.113,NULL,49876714671,779323666,12176932,16.9),(154162,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154162,36.71,0.33,220,73074,70,NULL,NULL,'2MASX J22121237-0105065',NULL,'2015arXiv151105856S',2015,1,0.68,'The APM image includes a brighter superposed star.','G',0.00015,NULL,'15.7g',0.44,'E0',NULL,NULL,NULL,NULL,1,333.0514583,-1.08506,0.189,NULL,49799466720,778116667,12158072,15.7),(154163,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154163,37.31,0.59,290,73075,70,NULL,NULL,'2MASX J22121418-4608169',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.66',0.36,NULL,NULL,NULL,NULL,NULL,1,333.0590417,-46.13797,0,NULL,50692587489,792071679,12376119,16.66),(154164,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154164,38.07,0.46,411,73076,70,NULL,NULL,'2MASXi J2212160+134015',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000122,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,333.0670417,13.67094,0.189,NULL,52260572771,816571449,12758928,17.8),(154165,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154165,37.88,0.46,377,73077,70,NULL,NULL,'2MASX J22121720-0828396',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,333.071708333,-8.47758,0.141,NULL,49837974300,778718348,12167474,17.9),(154166,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154166,35.71,0.58,139,73078,70,NULL,NULL,'ESO 189- G 028',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00015,NULL,'15.0',0.8,'SB(rs)ab',NULL,NULL,NULL,NULL,1,333.080625,-54.29842,0,NULL,48694319058,760848735,11888261,15),(154167,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','PS1 SN PS11ala','N',154167,41.39,0.12,1390,73079,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11ala HOST',0.3688,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154168,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154168,37.9,0.46,380,73080,70,NULL,NULL,'2MASX J22121978+1249558',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,333.0825417,12.83217,0.209,NULL,52257955039,816530547,12758289,18.2),(154169,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154169,36.71,0.33,220,73081,70,NULL,NULL,'2MASX J22122044-0056335',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'16.8g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.085083,-0.94267,0.185,NULL,49799352832,778114888,12158045,16.8),(154170,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154170,35.19,0.36,109,73082,NULL,NULL,NULL,'UGC 11948',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000093,NULL,'14.81',0.8,'SBb',NULL,NULL,NULL,NULL,1,333.0927917,14.02436,0.173,NULL,52260996472,816578069,12759032,14.81),(154171,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154171,35.27,0.34,113,73082,NULL,NULL,'Malmquist cor.','UGC 11948',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154172,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154172,35.31,0.2,115,73082,74.4,NULL,NULL,'UGC 11948',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154173,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154173,35.59,0.4,131,73083,NULL,NULL,'Malmquist cor.','ESO 048- G 018',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.46',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,333.097917,-72.56886,0.017,NULL,49298222615,770284728,12035698,15.46),(154174,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154174,35.69,0.38,138,73083,NULL,NULL,NULL,'ESO 048- G 018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154175,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154175,35.73,0.2,140,73083,74.4,NULL,NULL,'ESO 048- G 018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154176,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 15255',NULL,154176,40.22,0.2,1100,73084,70,NULL,'SN photometric redshift distance, z photo =0.302 +/- 0.035','SDSS-II SN 15255',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','21.0g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,333.100667,-0.259,0.177,NULL,49799716775,778120574,12158133,21),(154177,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 01311','RN',154177,41.11,0.37,1320,73085,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01311',0.261826,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154178,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 01311','RN',154178,41.55,0.42,1620,73085,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01311',0.261826,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154179,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154179,31.48,0.8,19.8,73086,75,NULL,'MAT, I','IC 5170',NULL,'1997ApJS..109..333W',1997,1,3.4,'Two entries for IC 5170 in ESO and ESO-LV.','G',0.000033,NULL,'13.34',1.9,'SB0^+','Pair member (points to parent)',NULL,NULL,NULL,1,333.1235,-47.22194,0,NULL,50621672111,790963626,12358806,13.34),(154180,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154180,31.1,0.32,16.6,73086,85,NULL,'I, raw','IC 5170',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154181,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154181,31.1,0.32,16.6,73086,85,NULL,'I, inv','IC 5170',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154182,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154182,31.45,0.45,19.5,73086,NULL,NULL,'K','IC 5170',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154183,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154183,31.45,0.4,19.5,73086,NULL,NULL,'mean','IC 5170',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154184,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154184,31.48,0.46,19.8,73086,NULL,NULL,'J','IC 5170',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154185,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154185,31.48,0.47,19.8,73086,NULL,NULL,'H','IC 5170',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154186,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154186,31.5,0.43,19.9,73086,75,NULL,'MAT, I, raw','IC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154187,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154187,31.56,0.43,20.5,73086,75,NULL,'MAT, I, inv','IC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154188,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154188,31.63,0.54,21.2,73086,NULL,NULL,NULL,'IC 5170',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154189,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154189,31.68,0.2,21.7,73086,74.4,NULL,NULL,'IC 5170',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154190,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154190,31.76,0.43,22.5,73086,75,NULL,'MAT, I, cor','IC 5170',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154191,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154191,31.76,0.4,22.5,73086,73,NULL,'opt','IC 5170',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154192,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154192,31.92,0.49,24.2,73086,75,NULL,'IR','IC 5170',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154193,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154193,31.95,0.47,24.6,73086,NULL,NULL,'Malmquist cor.','IC 5170',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154194,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154194,30.76,0.2,14.2,73087,74.4,NULL,NULL,'NGC 7231',NULL,'2013AJ....146...86T',2013,1,1.9,'abs(b) < 10 degrees.','G',0.000007,NULL,'13.90',0.7,'SBa',NULL,NULL,NULL,NULL,1,333.1255,45.32847,NULL,NULL,55554514214,868039284,13563113,13.9),(154195,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154195,30.8,0.4,14.5,73087,NULL,NULL,NULL,'NGC 7231',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154196,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154196,30.81,0.4,14.5,73087,73,NULL,'opt','NGC 7231',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154197,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154197,36.47,0.27,197,73088,70,NULL,NULL,'2MASX J22123161-0900378',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'15.4g',0.49,'E0',NULL,NULL,NULL,NULL,1,333.13175,-9.01039,0.125,NULL,49868179077,779190298,12174848,15.4),(154198,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06120','R',154198,41.85,0.36,1600,73089,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06120',0.470141,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,333.143833333,-0.05761,0.113,NULL,49799555351,778118052,12158094,21.4),(154199,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06120',NULL,154199,41.16,0.26,1700,73089,70,NULL,'SN photometric redshift distance, z photo =0.524 +/- 0.097','SDSS-II SN 06120',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154200,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06120',NULL,154200,41.73,0.24,2220,73089,70,NULL,'SALT 2','SDSS-II SN 06120',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154201,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06120',NULL,154201,41.84,0.24,2330,73089,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06120',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154202,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154202,32.69,0.55,34.6,73090,70,NULL,NULL,'NGC 7216',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.00007,NULL,'13.53',1,'SA(rs)0-:','in a pair',NULL,NULL,NULL,1,333.149333,-68.66186,0.017,NULL,49311505801,770492278,12038941,13.53),(154203,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154203,35.61,0.14,132,73091,70,NULL,NULL,'2MASX J22123607+1401035',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000083,NULL,'16.0g',0.42,'E0',NULL,NULL,NULL,NULL,1,333.150333333,14.01775,0.173,NULL,52261002044,816578156,12759033,16),(154204,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154204,37.25,0.46,282,73092,70,NULL,NULL,'2MASX J22123615+1145027',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,333.150708333,11.75089,0.173,NULL,52279736364,816870880,12763607,16.7),(154205,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154205,37.83,0.33,368,73093,70,NULL,NULL,'2MASX J22123664+1351195',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.152583,13.85553,0.189,NULL,52260893342,816576458,12759007,17.2),(154206,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 21810','R',154206,39.44,0.15,656,73094,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007se','SN 2007se',0.175,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.154583,0.79672,0.109,NULL,52155449915,814928904,12733264,NULL),(154207,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 21810','R',154207,39.62,0.22,714,73094,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007se','SN 2007se',0.175,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154208,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154208,34.45,NULL,77.7,73095,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2373',NULL,'2010Ap&SS.325..163P',2010,1,0.84,NULL,'G',0.000013,NULL,'16.7',0.11,'Scd',NULL,NULL,NULL,NULL,1,333.16,5.87417,0.293,NULL,52196134251,815564597,12743196,16.7),(154209,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154209,34.46,NULL,77.9,73095,NULL,NULL,'Dipole + Quadrupole','FGC 2373',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154210,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154210,34.47,NULL,78.2,73095,NULL,NULL,'Dipole','FGC 2373',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154211,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154211,34.54,NULL,81,73095,NULL,NULL,NULL,'FGC 2373',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154212,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 02022','RN',154212,42.34,0.17,2230,73096,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02022',0.317397,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154213,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 02022','RN',154213,42.45,0.22,2350,73096,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02022',0.317397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154214,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154214,36.47,0.27,197,73097,70,NULL,NULL,'2MASX J22123924-0859488',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000175,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,333.163417,-8.99681,0.125,NULL,49837772689,778715198,12167424,17.2),(154215,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154215,37.44,0.46,308,73098,70,NULL,NULL,'2MASX J22124042-0112158',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,333.168375,-1.20431,0.217,NULL,49802855514,778169617,12158900,17.8),(154216,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154216,37.83,0.33,368,73099,70,NULL,NULL,'SDSS J221240.65+135221.1',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00012,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,333.169417,13.87256,0.181,NULL,52260896758,816576511,12759007,18.5),(154217,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154217,35.61,0.14,132,73100,70,NULL,NULL,'2MASX J22124130+1404345',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000103,NULL,'15.9g',0.42,'E0',NULL,NULL,NULL,NULL,1,333.172167,14.07622,0.173,NULL,52261007525,816578242,12759035,15.9),(154218,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154218,37.52,0.59,319,73101,70,NULL,NULL,'2MASX J22124155-1925154',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.63',0.27,NULL,NULL,NULL,NULL,NULL,1,333.173125,-19.42097,0.049,NULL,49735095191,777110862,12142357,17.63),(154219,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154219,39.37,0.13,639,73102,74.2,NULL,'SALT 2','SDSS J221243.87-000206.2',0.17,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'20.3g',0.07,NULL,NULL,NULL,NULL,NULL,1,333.182833,-0.03506,0.113,NULL,49799502568,778117227,12158081,20.3),(154220,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154220,40.04,0.11,871,73102,65,NULL,'SALT2','SDSS J221243.87-000206.2',0.17,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154221,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154221,40.05,0.13,875,73102,70,NULL,'SDSS-II SN 05635, SALT 2','SDSS J221243.87-000206.2',0.17,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154222,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05635','R',154222,40.1,0.2,895,73102,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005hv','SDSS J221243.87-000206.2',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154223,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154223,40.12,0.04,905,73102,70,NULL,'SDSS-II SN 05635','SDSS J221243.87-000206.2',0.17,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154224,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005hv',NULL,154224,40.27,0.11,970,73102,65,NULL,'MLCS2k2','SDSS J221243.87-000206.2',0.17,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154225,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05635','R',154225,40.29,0.12,976,73102,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005hv','SDSS J221243.87-000206.2',0.17,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154226,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154226,36.47,0.27,197,73103,70,NULL,NULL,'2MASX J22124416-0854058',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,333.184125,-8.90153,0.125,NULL,49837776895,778715263,12167425,16),(154227,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154227,34.96,0.2,98.2,73104,74.4,NULL,NULL,'2MASX J22124529+1351485',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000067,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,333.188583,13.86339,0.181,NULL,52260894266,816576472,12759007,14),(154228,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154228,35.43,0.39,122,73104,NULL,NULL,'Malmquist cor.','2MASX J22124529+1351485',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154229,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154229,35.49,0.38,125,73104,NULL,NULL,NULL,'2MASX J22124529+1351485',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154230,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154230,38.03,0.33,404,73105,70,NULL,NULL,'2MASX J22125063-0845327',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,333.211,-8.75917,0.129,NULL,49837799336,778715614,12167431,17.3),(154231,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154231,35.47,0.59,124,73106,70,NULL,NULL,'2MASX J22125122-0105498',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.4g',0.18,'Sa',NULL,NULL,NULL,NULL,1,333.213375,-1.09725,0.217,NULL,49802796115,778168689,12158885,16.4),(154232,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154232,35.78,0.46,143,73107,70,NULL,NULL,'2MASX J22125304+1221585',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000132,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,333.2212083,12.36631,0.209,NULL,52246444334,816350692,12755479,16.5),(154233,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154233,38.03,0.33,404,73108,70,NULL,NULL,'2MASX J22125313-0846457',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.221375,-8.77939,0.129,NULL,49837794410,778715537,12167430,17.3),(154234,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154234,32.6,NULL,33.1,73109,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 532- G 032',NULL,'2010Ap&SS.325..163P',2010,1,2.04,NULL,'G',0.000013,NULL,'16.19',0.2,'Sdm',NULL,NULL,NULL,NULL,1,333.221541667,-25.643,0.021,NULL,50533488330,789585755,12337277,16.19),(154235,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154235,32.62,NULL,33.5,73109,NULL,NULL,'Dipole','ESO 532- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154236,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154236,32.64,NULL,33.7,73109,NULL,NULL,'Dipole + Quadrupole','ESO 532- G 032',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154237,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154237,32.73,NULL,35.1,73109,NULL,NULL,NULL,'ESO 532- G 032',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154238,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154238,37.99,0.46,396,73110,70,NULL,NULL,'2MASX J22125366+1345525',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.2235417,13.76456,0.189,NULL,52260118860,816564357,12758818,17.4),(154239,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154239,36.92,0.46,242,73111,70,NULL,NULL,'2MASX J22125763-0829361',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.240125,-8.49333,0.141,NULL,49837888001,778717000,12167453,17.7),(154240,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05486','R',154240,40.49,0.16,1020,73112,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J221259.50-002441.7',0.2292,'2014arXiv1401.3317S',2014,1,0.15,NULL,'G',0.0005,NULL,'20.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,333.247917,-0.41161,0.177,NULL,49802609104,778165767,12158840,20.4),(154241,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05486','R',154241,40.51,0.23,1030,73112,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J221259.50-002441.7',0.2292,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154242,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05486',NULL,154242,40.43,0.13,1220,73112,70,NULL,'SALT 2','SDSS J221259.50-002441.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154243,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05486',NULL,154243,40.45,0.13,1230,73112,70,NULL,'SALT 2, Malmquist cor.','SDSS J221259.50-002441.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154244,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154244,31.57,0.8,20.6,73113,75,NULL,'MAT, I','ESO 146- G 014',NULL,'1997ApJS..109..333W',1997,1,3.25,NULL,'G',0.000017,NULL,'15.12',0.25,'SBd? sp',NULL,NULL,NULL,NULL,1,333.2517917,-62.06761,0.053,NULL,48671155482,760486804,11882606,15.12),(154245,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154245,31.56,0.8,20.5,73113,75,NULL,NULL,'ESO 146- G 014',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154246,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154246,31.22,0.43,17.5,73113,75,NULL,'3.6 micron, color + selection bias corrected','ESO 146- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154247,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154247,31.31,0.32,18.3,73113,85,NULL,'I, inv','ESO 146- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154248,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154248,31.37,0.32,18.8,73113,85,NULL,'I, raw','ESO 146- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154249,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154249,31.4,0.43,19,73113,75,NULL,'3.6 micron, color corrected','ESO 146- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154250,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154250,31.43,NULL,19.3,73113,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 146- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154251,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154251,31.44,0.2,19.4,73113,74.4,NULL,NULL,'ESO 146- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154252,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154252,31.45,NULL,19.5,73113,NULL,NULL,'Dipole + Quadrupole','ESO 146- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154253,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154253,31.46,NULL,19.6,73113,NULL,NULL,'Dipole','ESO 146- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154254,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154254,31.54,NULL,20.4,73113,NULL,NULL,NULL,'ESO 146- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154255,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154255,31.68,0.4,21.7,73113,NULL,NULL,NULL,'ESO 146- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154256,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154256,31.68,0.39,21.7,73113,73,NULL,'opt','ESO 146- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154257,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154257,31.69,0.43,21.8,73113,75,NULL,'MAT, I, inv','ESO 146- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154258,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154258,31.83,0.43,23.3,73113,75,NULL,'MAT, I, raw','ESO 146- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154259,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154259,32.16,0.43,27.1,73113,75,NULL,'MAT, I, cor','ESO 146- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154260,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154260,35.97,0.46,157,73114,70,NULL,NULL,'2MASX J22130154+0014407',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000178,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,333.2565417,0.24458,0.121,NULL,52155686393,814932599,12733321,16),(154261,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154261,37.67,0.27,342,73115,70,NULL,NULL,'SDSS J221302.61-000304.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,333.260916667,-0.05136,0.173,NULL,49799498091,778117157,12158080,18),(154262,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154262,37.67,0.27,342,73116,70,NULL,NULL,'2MASX J22130378-0007378',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00015,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,333.265875,-0.12725,0.173,NULL,49802385841,778162278,12158785,18),(154263,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154263,32.87,0.8,37.5,73117,75,NULL,'MAT, I','NGC 7219',NULL,'1997ApJS..109..333W',1997,1,1.7,'ESO-LV gives v= 4400+/- 10 km/sec.','G',0.000033,NULL,'13.27',1,'(R\'_2)SA(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,333.287583333,-64.84897,0,NULL,49278019272,769969051,12030766,13.27),(154264,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154264,32.9,0.32,38.1,73117,85,NULL,'I, raw','NGC 7219',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154265,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154265,32.94,0.32,38.8,73117,85,NULL,'I, inv','NGC 7219',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154266,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154266,33.02,0.39,40.1,73117,NULL,NULL,NULL,'NGC 7219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154267,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154267,33.03,0.43,40.3,73117,75,NULL,'MAT, I, raw','NGC 7219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154268,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154268,33.06,0.2,40.9,73117,74.4,NULL,NULL,'NGC 7219',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154269,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154269,33.12,0.43,42.1,73117,75,NULL,'MAT, I, cor','NGC 7219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154270,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154270,33.16,0.36,42.8,73117,NULL,NULL,'Malmquist cor.','NGC 7219',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154271,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154271,33.23,0.43,44.2,73117,75,NULL,'MAT, I, inv','NGC 7219',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154272,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154272,40.06,0.13,809,73118,74.2,NULL,'SALT 2','SDSS J221310.18+010301.3',0.27,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.292417,1.05036,0.077,NULL,52155471063,814929235,12733269,NULL),(154273,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154273,40.61,0.04,1040,73118,70,NULL,'SDSS-II SN 03199','SDSS J221310.18+010301.3',0.27,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154274,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154274,40.18,0.1,1090,73118,70,NULL,'Hubble residual 0.31 for z0.25110','SDSS J221310.18+010301.3',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154275,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154275,40.77,0.11,1120,73118,65,NULL,'SALT2','SDSS J221310.18+010301.3',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154276,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154276,40.85,0.15,1160,73118,70,NULL,'SDSS-II SN 03199, SALT 2','SDSS J221310.18+010301.3',0.27,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154277,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03199','R',154277,40.85,0.13,1180,73118,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gs','SDSS J221310.18+010301.3',0.2511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154278,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005gs',NULL,154278,40.91,0.12,1190,73118,65,NULL,'MLCS2k2','SDSS J221310.18+010301.3',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154279,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03199','R',154279,40.92,0.2,1220,73118,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gs','SDSS J221310.18+010301.3',0.2511,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154280,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154280,34.24,0.4,70.5,73119,NULL,NULL,'mean','ESO 532- G 034',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'13.92',0.6,'Sb             HII',NULL,NULL,NULL,NULL,1,333.2935,-22.445,0.053,NULL,49731556778,777055574,12141493,13.92),(154281,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154281,34.45,0.42,77.8,73119,NULL,NULL,'Malmquist cor.','ESO 532- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154282,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154282,34.47,0.47,78.2,73119,NULL,NULL,'H','ESO 532- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154283,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154283,34.52,0.4,80.2,73119,NULL,NULL,NULL,'ESO 532- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154284,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154284,34.54,0.45,80.8,73119,NULL,NULL,'K','ESO 532- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154285,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154285,34.56,0.2,81.7,73119,74.4,NULL,NULL,'ESO 532- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154286,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154286,34.56,0.46,81.8,73119,NULL,NULL,'J','ESO 532- G 034',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154287,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05512','RN',154287,41.34,0.18,1320,73120,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05512',0.408648,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154288,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05512','RN',154288,41.4,0.1,1350,73120,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05512',0.408648,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154289,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154289,35.83,0.5,146,73121,70,NULL,NULL,'2MASX J22131283-5724358',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000103,NULL,'15.48',0.52,'S0',NULL,NULL,NULL,NULL,1,333.3035,-57.40997,0,NULL,48708234040,761066156,11891658,15.48),(154290,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154290,35.23,0.46,111,73122,70,NULL,NULL,'2MASX J22131344-0733061',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,333.305833,-7.55161,0.185,NULL,49839874317,778748036,12167938,15.9),(154291,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154291,35.44,0.59,123,73122,70,NULL,NULL,'2MASX J22131344-0733061',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154292,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154292,36.39,0.82,190,73123,70,NULL,NULL,'2MASX J22131445-1040251',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'17.01',0.28,NULL,NULL,NULL,NULL,NULL,1,333.310333333,-10.67367,0.105,NULL,49865247439,779144491,12174132,17.01),(154293,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154293,37.41,0.46,303,73124,70,NULL,NULL,'2MASX J22131546-0038018',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.76',0.28,NULL,NULL,NULL,NULL,NULL,1,333.3144583,-0.63375,0.177,NULL,49802507642,778164181,12158815,16.76),(154294,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154294,34.6,0.2,83.2,73125,74.4,NULL,NULL,'2MASX J22131544+1359011',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.00009,NULL,'16.2g',0.27,'Scd',NULL,NULL,NULL,NULL,1,333.314583,13.98383,0.181,NULL,52260848803,816575762,12758996,16.2),(154295,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154295,34.73,0.44,88.1,73125,NULL,NULL,NULL,'2MASX J22131544+1359011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154296,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154296,34.98,0.39,99.1,73125,NULL,NULL,'Malmquist cor.','2MASX J22131544+1359011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154297,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154297,38.33,0.46,464,73126,70,NULL,NULL,'SDSS J221318.38-002054.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,333.326625,-0.34836,0.177,NULL,49802402482,778162538,12158789,18.7),(154298,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154298,31.22,0.65,17.5,73127,95,NULL,'Weighted Mean','IC 5181',NULL,'1984ApJS...56...91D',1984,1,2.6,NULL,'G',0.00008,NULL,'12.51',0.8,'S0^0           LINER','in a pair',NULL,NULL,NULL,1,333.340417,-46.01761,0,NULL,50692548381,792071068,12376110,12.51),(154299,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154299,32.49,0.81,31.5,73127,55,NULL,'Visvanathan & Sandage 1979','IC 5181',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154300,'Tully est','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154300,31.97,0.8,24.8,73127,75,NULL,'B','IC 5181',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154301,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154301,35.01,0.49,101,73128,NULL,NULL,'Malmquist cor.','ESO 532- G 035',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.80',0.7,'Sb',NULL,NULL,NULL,NULL,1,333.347833,-27.21964,0,NULL,50534372157,789599564,12337493,14.8),(154302,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154302,35.11,0.46,105,73128,NULL,NULL,NULL,'ESO 532- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154303,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154303,35.15,0.2,107,73128,74.4,NULL,NULL,'ESO 532- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154304,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 05487',NULL,154304,40.32,0.15,1160,73129,70,NULL,'SN photometric redshift distance, z photo =0.320 +/- 0.028','SDSS-II SN 05487',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,333.349583,-0.26314,0.173,NULL,49802442062,778163157,12158799,NULL),(154305,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154305,37.67,0.27,342,73130,70,NULL,NULL,'2MASX J22132499-0008207',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,333.35425,-0.13914,0.173,NULL,49802388766,778162324,12158786,16.3),(154306,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154306,34.18,0.47,68.7,73131,NULL,NULL,'H','IC 1435',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000027,NULL,'13.73',0.8,'SA(rs:)b;ALG   HII',NULL,NULL,NULL,NULL,1,333.359541667,-22.09669,0.049,NULL,49729404255,777021941,12140967,13.73),(154307,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154307,34.27,0.45,71.5,73131,NULL,NULL,'K','IC 1435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154308,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154308,34.29,0.46,72,73131,NULL,NULL,'J','IC 1435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154309,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154309,34.31,0.4,72.7,73131,NULL,NULL,'mean','IC 1435',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154310,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154310,34.56,0.42,81.6,73131,NULL,NULL,'Malmquist cor.','IC 1435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154311,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154311,34.65,0.4,85.3,73131,NULL,NULL,NULL,'IC 1435',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154312,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154312,34.69,0.2,86.7,73131,74.4,NULL,NULL,'IC 1435',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154313,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ev',NULL,154313,42.27,0.17,1650,73132,NULL,NULL,'SALT2','SNLS 05D4ev HOST',0.722,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.37675,-17.70078,0.049,NULL,49787079192,777923112,12155048,NULL),(154314,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ev',NULL,154314,43.33,0.22,2700,73132,70,NULL,'SALT 2','SNLS 05D4ev HOST',0.722,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154315,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ev',NULL,154315,43.35,0.15,2720,73132,NULL,NULL,'SIFTO','SNLS 05D4ev HOST',0.722,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154316,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ev',NULL,154316,43.57,0.06,3010,73132,70,NULL,'SALT2','SNLS 05D4ev HOST',0.722,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154317,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154317,38.19,0.46,434,73133,70,NULL,NULL,'SDSS J221330.98+004919.6',NULL,'2015arXiv151105856S',2015,1,0.07,NULL,'G',0.000144,NULL,'18.4g',0.06,NULL,NULL,NULL,NULL,NULL,1,333.379083,0.82214,0.109,NULL,52155967170,814936987,12733390,18.4),(154318,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154318,34.1,0.8,66.1,73134,75,NULL,'MAT, I','ESO 467- G 023',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.73',0.4,'Sab pec:       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,333.380583,-27.55803,0,NULL,50534507546,789601680,12337526,13.73),(154319,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154319,33.68,0.45,54.6,73134,NULL,NULL,'K','ESO 467- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154320,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154320,33.71,0.47,55.1,73134,NULL,NULL,'H','ESO 467- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154321,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154321,33.73,0.46,55.8,73134,NULL,NULL,'J','ESO 467- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154322,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154322,34.05,0.4,64.4,73134,NULL,NULL,'mean','ESO 467- G 023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154323,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154323,34.07,0.43,65.2,73134,75,NULL,'MAT, I, raw','ESO 467- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154324,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154324,34.15,0.32,67.7,73134,85,NULL,'I, raw','ESO 467- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154325,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154325,34.22,0.32,69.9,73134,85,NULL,'I, inv','ESO 467- G 023',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154326,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154326,34.29,0.4,72.1,73134,NULL,NULL,'Malmquist cor.','ESO 467- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154327,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154327,34.33,0.43,73.3,73134,75,NULL,'MAT, I, cor','ESO 467- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154328,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154328,34.36,0.43,74.4,73134,75,NULL,'MAT, I, inv','ESO 467- G 023',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154329,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154329,34.4,0.38,76,73134,NULL,NULL,NULL,'ESO 467- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154330,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154330,34.44,0.2,77.3,73134,74.4,NULL,NULL,'ESO 467- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154331,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cn',NULL,154331,43.2,0.05,2480,73135,70,NULL,'SIFTO','SNLS 05D4cn HOST',0.763,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.3810417,-17.28886,0.045,NULL,49786744900,777917889,12154967,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (154332,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cn',NULL,154332,43.37,0.15,2670,73135,NULL,NULL,'SIFTO','SNLS 05D4cn HOST',0.763,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154333,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cn',NULL,154333,43.4,0.21,2710,73135,70,NULL,'SALT 2','SNLS 05D4cn HOST',0.763,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154334,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cn',NULL,154334,44.91,0.17,5440,73135,NULL,NULL,'SALT2','SNLS 05D4cn HOST',0.763,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154335,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154335,37.2,0.46,276,73136,70,NULL,NULL,'2MASX J22133184+0050568',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,333.382625,0.84925,0.109,NULL,52155971145,814937049,12733391,17.3),(154336,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19070','R',154336,42.59,0.49,2240,73137,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007na','SDSS J221332.71+005249.5',0.470359,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,NULL,'21.2g',0.04,NULL,NULL,NULL,NULL,NULL,1,333.386291667,0.88042,0.109,NULL,52155972793,814937074,12733391,21.2),(154337,'SNIa SDSS','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 03403','RN',154337,44.48,0.38,5370,73138,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03403',0.467519,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154338,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154338,37.34,0.46,293,73139,70,NULL,NULL,'2MASX J22133843-0039338',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.41025,-0.65939,0.177,NULL,49802467940,778163561,12158805,17.7),(154339,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154339,34.47,NULL,78.2,73140,NULL,NULL,'Dipole','UGC 11952',NULL,'2010Ap&SS.325..163P',2010,1,2.24,NULL,'G',0.000009,NULL,'15.47',0.28,'SBcd?',NULL,NULL,NULL,NULL,1,333.41175,14.21908,0.177,NULL,52260949418,816577334,12759020,15.47),(154340,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154340,34.49,NULL,79.2,73140,NULL,NULL,'Dipole + Quadrupole','UGC 11952',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154341,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154341,34.51,NULL,79.7,73140,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11952',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154342,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154342,34.79,NULL,90.8,73140,NULL,NULL,NULL,'UGC 11952',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154343,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154343,35.25,0.2,112,73140,74.4,NULL,NULL,'UGC 11952',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154344,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154344,35.27,0.34,113,73140,NULL,NULL,NULL,'UGC 11952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154345,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154345,35.32,0.33,116,73140,NULL,NULL,'Malmquist cor.','UGC 11952',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154346,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154346,35.59,0.49,131,73141,70,NULL,NULL,'2MASX J22134008-7301532',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'15.6b',0.36,NULL,NULL,NULL,NULL,NULL,1,333.416833,-73.03147,0.077,NULL,48412437571,756444337,11819442,15.6),(154347,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy','R',154347,43.11,NULL,2180,73142,65,NULL,'MLCS17','[HSP2005] J221340.46-174053.90',0.927,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.418583,-17.68164,0.049,NULL,49787193645,777924900,12155076,NULL),(154348,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154348,43.24,0.29,2310,73142,74.2,NULL,'SALT 2','[HSP2005] J221340.46-174053.90',0.927,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154349,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154349,43.67,0.1,2810,73142,70,NULL,'MLCS17','[HSP2005] J221340.46-174053.90',0.927,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154350,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154350,43.89,0.27,3110,73142,65,NULL,'MLCS2k2','[HSP2005] J221340.46-174053.90',0.927,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154351,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154351,43.99,0.26,3260,73142,65,NULL,'SALT2','[HSP2005] J221340.46-174053.90',0.927,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154352,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154352,44.04,0.2,3340,73142,65,NULL,'MLCS17','[HSP2005] J221340.46-174053.90',0.927,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154353,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154353,44.09,0.28,3410,73142,70,NULL,'SALT 2','[HSP2005] J221340.46-174053.90',0.927,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154354,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154354,44.14,0.15,3500,73142,NULL,NULL,'SIFTO','[HSP2005] J221340.46-174053.90',0.927,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154355,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154355,44.15,0.14,3510,73142,65,NULL,'MLCS2k2','[HSP2005] J221340.46-174053.90',0.927,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154356,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154356,44.15,0.16,3510,73142,65,NULL,'MLCS31','[HSP2005] J221340.46-174053.90',0.927,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154357,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154357,44.55,0.38,4220,73142,70,NULL,NULL,'[HSP2005] J221340.46-174053.90',0.927,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154358,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154358,44.74,0.62,4600,73142,70,NULL,'SALT','[HSP2005] J221340.46-174053.90',0.927,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154359,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154359,44.87,0.24,4880,73142,65,NULL,'SALT','[HSP2005] J221340.46-174053.90',0.927,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154360,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154360,45,0.58,5180,73142,65,NULL,'SALT','[HSP2005] J221340.46-174053.90',0.927,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154361,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154361,45.07,0.5,5370,73142,65,NULL,'SALT2','[HSP2005] J221340.46-174053.90',0.927,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154362,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4cy',NULL,154362,45.23,0.17,5770,73142,NULL,NULL,'SALT2','[HSP2005] J221340.46-174053.90',0.927,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154363,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154363,37.05,0.46,257,73143,70,NULL,NULL,'2MASX J22134223+1204167',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000136,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.425791667,12.07139,0.169,NULL,52279457127,816866517,12763539,17.3),(154364,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 21062','R',154364,39.54,0.19,709,73144,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007rp','SDSS J221343.62+002346.6',0.138642,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,NULL,'21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,333.4317917,0.39631,0.117,NULL,52155884299,814935692,12733370,21.2),(154365,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 21062','R',154365,39.58,0.11,722,73144,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007rp','SDSS J221343.62+002346.6',0.138642,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154366,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007rp',NULL,154366,39.33,0.07,735,73144,70,NULL,'SALT 2','SDSS J221343.62+002346.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154367,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2007rp',NULL,154367,39.34,0.07,738,73144,70,NULL,'SALT 2, Malmquist cor.','SDSS J221343.62+002346.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154368,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154368,35.61,0.14,132,73145,70,NULL,NULL,'CGCG 428-050',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000103,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,333.436,13.99389,0.157,NULL,52260061445,816563460,12758804,15.7),(154369,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154369,37.7,0.23,347,73146,70,NULL,NULL,'SDSS J221345.50-083350.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00015,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,333.439583,-8.56414,0.145,NULL,49842149456,778783585,12168493,18.2),(154370,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154370,34.36,0.49,74.6,73147,75,NULL,'IR','CGCG 428-049',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000093,NULL,'15.6g',0.26,'Sab            AGN','Group member',NULL,NULL,NULL,1,333.443833333,13.79075,0.181,NULL,52260201419,816565647,12758838,15.6),(154371,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154371,37.43,0.46,306,73148,70,NULL,NULL,'2MASX J22134705+0051249',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000159,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.445916667,0.85692,0.109,NULL,52155930090,814936407,12733381,17.1),(154372,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ag',NULL,154372,42.77,0.19,2190,73149,70,NULL,'SALT 2','SNLS 05D4ag HOST',0.64,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.447625,-18.16528,0.049,NULL,49732273881,777066779,12141668,NULL),(154373,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ag',NULL,154373,43.03,0.15,2460,73149,NULL,NULL,'SIFTO','SNLS 05D4ag HOST',0.64,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154374,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ag',NULL,154374,43.24,0.06,2710,73149,70,NULL,'SIFTO','SNLS 05D4ag HOST',0.64,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154375,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ag',NULL,154375,43.51,0.17,3070,73149,NULL,NULL,'SALT2','SNLS 05D4ag HOST',0.64,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154376,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154376,38.03,0.46,404,73150,70,NULL,NULL,'2MASX J22134905-0854027',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000178,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.4545417,-8.90072,0.129,NULL,49842204613,778784447,12168506,17.3),(154377,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19207','R',154377,40.62,0.25,1050,73151,70,NULL,'SDSS CAND. SNIa; SALT 2','SN 2007oa',0.2587,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.4639583,-0.92028,0.233,NULL,49802944643,778171010,12158922,NULL),(154378,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 19207','R',154378,40.7,0.18,1100,73151,70,NULL,'SDSS CAND. SNIa; MLCS2K2','SN 2007oa',0.2587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154379,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jy',NULL,154379,43.7,0.11,2850,73152,70,NULL,'SIFTO','[HSP2005] J221351.60-172418.13',0.93,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.465,-17.40503,0.041,NULL,49787222742,777925355,12155083,NULL),(154380,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jy',NULL,154380,44.16,0.27,3520,73152,70,NULL,'SALT 2','[HSP2005] J221351.60-172418.13',0.93,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154381,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jy',NULL,154381,44.27,0.15,3700,73152,NULL,NULL,'SIFTO','[HSP2005] J221351.60-172418.13',0.93,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154382,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jy',NULL,154382,44.36,0.17,3850,73152,NULL,NULL,'SALT2','[HSP2005] J221351.60-172418.13',0.93,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154383,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154383,37.22,0.33,278,73153,70,NULL,NULL,'2MASX J22135181-0840227',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,333.465833,-8.67297,0.141,NULL,49842135326,778783364,12168490,17.1),(154384,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154384,37.69,0.46,345,73154,70,NULL,NULL,'2MASX J22135263+1244410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000157,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,333.469333,12.74464,0.193,NULL,52247244619,816363197,12755674,17.9),(154385,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154385,35.56,0.51,129,73155,70,NULL,NULL,'2MASX J22135420-7246492',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'15.6b',1.2,'S0- pec?',NULL,NULL,NULL,NULL,1,333.475667,-72.78044,0.037,NULL,49298231168,770284862,12035700,15.6),(154386,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154386,36.41,0.67,191,73156,70,NULL,NULL,'2MASX J22135427-7250362',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.3b',0.26,NULL,NULL,NULL,NULL,NULL,1,333.47625,-72.84344,0.077,NULL,48412328891,756442638,11819416,16.3),(154387,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154387,35.29,0.2,114,73157,74.4,NULL,NULL,'UGC 11953',NULL,'2013AJ....146...86T',2013,1,1.06,NULL,'G',0.00006,NULL,'15.0g',0.4,'Sab','Group member',NULL,NULL,NULL,1,333.483167,13.75539,0.181,NULL,52260204801,816565700,12758839,15),(154388,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005ka',NULL,154388,40.67,0.19,1030,73158,74.2,NULL,'SALT 2','SDSS J221356.02+010510.1',0.32,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.0005,NULL,'21.0g',0.06,NULL,NULL,NULL,NULL,NULL,1,333.483416667,1.08617,0.113,NULL,52156124303,814939442,12733428,21),(154389,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06100','R',154389,41.19,0.2,1310,73158,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ka','SDSS J221356.02+010510.1',0.3177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154390,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005ka',NULL,154390,40.71,0.22,1390,73158,70,NULL,'Hubble residual 0.41 for z0.31770','SDSS J221356.02+010510.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154391,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SDSS-II SN 06100','R',154391,41.45,0.3,1480,73158,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ka','SDSS J221356.02+010510.1',0.3177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154392,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005ka',NULL,154392,41.46,0.18,1490,73158,65,NULL,'MLCS2k2','SDSS J221356.02+010510.1',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154393,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SN 2005ka',NULL,154393,41.49,0.27,1500,73158,65,NULL,'SALT2','SDSS J221356.02+010510.1',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154394,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154394,37.33,0.46,293,73159,70,NULL,NULL,'SDSS J221356.98-010503.2',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000141,NULL,'18.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,333.487416667,-1.08425,0.217,NULL,49803135641,778173994,12158968,18.9),(154395,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ef',NULL,154395,41.48,0.17,1230,73160,NULL,NULL,'SALT2','SNLS 05D4ef HOST',0.605,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.497125,-18.21233,0.049,NULL,49732279109,777066861,12141669,NULL),(154396,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ef',NULL,154396,42.95,0.16,2420,73160,70,NULL,'SALT 2','SNLS 05D4ef HOST',0.605,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154397,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ef',NULL,154397,42.99,0.15,2470,73160,NULL,NULL,'SIFTO','SNLS 05D4ef HOST',0.605,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154398,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4ef',NULL,154398,43.1,0.05,2590,73160,70,NULL,'SALT2','SNLS 05D4ef HOST',0.605,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154399,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154399,32.56,0.8,32.5,73161,75,NULL,'MAT, I','ESO 533- G 004',NULL,'1997ApJS..109..333W',1997,1,2.82,NULL,'G',0.00001,NULL,'15.29',0.39,'Scd',NULL,NULL,NULL,NULL,1,333.512583,-26.93772,0.025,NULL,50536309487,789629835,12337966,15.29),(154400,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154400,32.4,0.4,30.2,73161,75,NULL,NULL,'ESO 533- G 004',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154401,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154401,32.4,0.39,30.2,73161,73,NULL,'IR','ESO 533- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154402,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154402,32.6,0.15,33.2,73161,NULL,NULL,NULL,'ESO 533- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154403,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154403,32.67,0.4,34.2,73161,NULL,NULL,'mean','ESO 533- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154404,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154404,32.79,0.43,36.1,73161,75,NULL,'MAT, I, raw','ESO 533- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154405,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154405,32.8,0.43,36.3,73161,75,NULL,'3.6 micron, color + selection bias corrected','ESO 533- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154406,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154406,32.82,0.32,36.7,73161,85,NULL,'I, raw','ESO 533- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154407,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154407,32.83,0.47,36.8,73161,NULL,NULL,'H','ESO 533- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154408,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154408,32.85,0.46,37.1,73161,NULL,NULL,'J','ESO 533- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154409,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154409,32.85,0.32,37.2,73161,85,NULL,'I, inv','ESO 533- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154410,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154410,32.86,0.45,37.4,73161,NULL,NULL,'K','ESO 533- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154411,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154411,32.9,0.43,38,73161,75,NULL,'3.6 micron, color corrected','ESO 533- G 004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154412,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154412,32.94,0.43,38.7,73161,75,NULL,'MAT, I, inv','ESO 533- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154413,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154413,32.94,0.49,38.7,73161,75,NULL,'IR','ESO 533- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154414,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154414,33.04,0.2,40.6,73161,74.4,NULL,NULL,'ESO 533- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154415,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154415,33.05,0.43,40.7,73161,75,NULL,'MAT, I, cor','ESO 533- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154416,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154416,33.55,NULL,51.2,73161,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 533- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154417,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154417,33.55,NULL,51.3,73161,NULL,NULL,NULL,'ESO 533- G 004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154418,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154418,33.57,NULL,51.6,73161,NULL,NULL,'Dipole + Quadrupole','ESO 533- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154419,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154419,33.57,NULL,51.9,73161,NULL,NULL,'Dipole','ESO 533- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154420,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154420,37.22,0.33,278,73162,70,NULL,NULL,'2MASXi J2214054-084337',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00021,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,333.52275,-8.727,0.141,NULL,49842174432,778783975,12168499,17.6),(154421,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154421,37.59,0.46,330,73163,70,NULL,NULL,'2MASXi J2214065-072511',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000137,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.527417,-7.41961,0.181,NULL,49841231564,778769243,12168269,17.7),(154422,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154422,37.49,0.46,315,73164,70,NULL,NULL,'2MASX J22140659-0804371',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.527417,-8.07692,0.165,NULL,49842721239,778792519,12168633,17.4),(154423,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154423,35.61,0.14,132,73165,70,NULL,NULL,'2MASX J22140773+1342301',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000166,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,333.532125,13.70853,0.181,NULL,52260206603,816565728,12758839,16.9),(154424,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154424,35.09,0.59,104,73166,70,NULL,NULL,'2MASX J22140795-5220285',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.12',0.4,'E',NULL,NULL,NULL,NULL,1,333.533041667,-52.34133,0,NULL,50631370737,791115167,12361174,16.12),(154425,'IRAS','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154425,33.64,0.8,53.4,73167,75,NULL,'MAT, I','ESO 404- G 045',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000023,NULL,'15.20',0.28,'Sbc',NULL,NULL,NULL,NULL,1,333.5399583,-33.23542,0,NULL,50593069279,790516707,12351823,15.2),(154426,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154426,33.06,0.32,40.9,73167,85,NULL,'I, raw','ESO 404- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154427,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154427,33.08,0.32,41.3,73167,85,NULL,'I, inv','ESO 404- G 045',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154428,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154428,33.08,0.43,41.4,73167,75,NULL,'MAT, I, raw','ESO 404- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154429,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154429,33.21,0.43,43.8,73167,75,NULL,'MAT, I, inv','ESO 404- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154430,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154430,33.3,0.43,45.7,73167,75,NULL,'MAT, I, cor','ESO 404- G 045',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154431,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154431,33.57,NULL,51.7,73167,NULL,NULL,NULL,'ESO 404- G 045',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154432,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154432,33.92,NULL,60.8,73167,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 404- G 045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154433,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154433,33.94,NULL,61.4,73167,NULL,NULL,'Dipole + Quadrupole','ESO 404- G 045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154434,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154434,33.96,NULL,62,73167,NULL,NULL,'Dipole','ESO 404- G 045',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154435,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154435,34.15,0.2,67.6,73167,74.4,NULL,NULL,'ESO 404- G 045',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154436,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,'R',154436,34.37,0.49,74.8,73167,75,NULL,'IR','ESO 404- G 045',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154437,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154437,34.52,0.47,80.2,73167,NULL,NULL,'Malmquist cor.','ESO 404- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154438,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154438,34.61,0.45,83.7,73167,NULL,NULL,NULL,'ESO 404- G 045',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154439,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cq',NULL,154439,42.65,0.05,1990,73168,70,NULL,'SIFTO','SNLS 05D4cq HOST',0.701,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.5402083,-18.22672,0.049,NULL,49732278029,777066844,12141669,NULL),(154440,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cq',NULL,154440,43.12,0.15,2480,73168,NULL,NULL,'SIFTO','SNLS 05D4cq HOST',0.701,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154441,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cq',NULL,154441,43.3,0.19,2680,73168,70,NULL,'SALT 2','SNLS 05D4cq HOST',0.701,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154442,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4cq',NULL,154442,44.42,0.17,4500,73168,NULL,NULL,'SALT2','SNLS 05D4cq HOST',0.701,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154443,'G Lens','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154443,45.59,0.17,7700,73168,NULL,NULL,'SNLS 05D4cq HOST','SNLS 05D4cq HOST',0.701,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154444,'Faber-Jackson','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154444,45.55,0.17,7570,73168,NULL,NULL,'SNLS 05D4cq HOST','SNLS 05D4cq HOST',0.701,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154445,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di','R',154445,42.52,NULL,1680,73169,65,NULL,'MLCS17','[AGR2006] J221410.24-173024.1',0.905,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.5427083,-17.50672,0.041,NULL,49787395300,777928051,12155125,NULL),(154446,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154446,42.93,0.26,2020,73169,74.2,NULL,'SALT 2','[AGR2006] J221410.24-173024.1',0.905,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154447,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154447,43.18,0.08,2280,73169,70,NULL,'MLCS17','[AGR2006] J221410.24-173024.1',0.905,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154448,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154448,43.69,0.42,2870,73169,70,NULL,'SALT','[AGR2006] J221410.24-173024.1',0.905,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154449,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154449,43.71,0.26,2900,73169,70,NULL,NULL,'[AGR2006] J221410.24-173024.1',0.905,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154450,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154450,43.72,0.23,2910,73169,65,NULL,'SALT2','[AGR2006] J221410.24-173024.1',0.905,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154451,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154451,43.74,0.22,2940,73169,65,NULL,'MLCS2k2','[AGR2006] J221410.24-173024.1',0.905,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154452,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154452,43.82,0.18,3050,73169,65,NULL,'MLCS17','[AGR2006] J221410.24-173024.1',0.905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154453,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154453,43.83,0.39,3060,73169,65,NULL,'SALT','[AGR2006] J221410.24-173024.1',0.905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154454,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154454,43.83,0.24,3070,73169,70,NULL,'SALT 2','[AGR2006] J221410.24-173024.1',0.905,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154455,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154455,43.84,0.13,3070,73169,65,NULL,'MLCS2k2','[AGR2006] J221410.24-173024.1',0.905,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154456,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154456,43.84,0.15,3070,73169,65,NULL,'MLCS31','[AGR2006] J221410.24-173024.1',0.905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154457,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154457,43.84,0.15,3070,73169,NULL,NULL,'SIFTO','[AGR2006] J221410.24-173024.1',0.905,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154458,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154458,43.87,0.37,3130,73169,65,NULL,'SALT2','[AGR2006] J221410.24-173024.1',0.905,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154459,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154459,44,0.17,3310,73169,65,NULL,'SALT','[AGR2006] J221410.24-173024.1',0.905,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154460,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 03D4di',NULL,154460,45.54,0.17,6740,73169,NULL,NULL,'SALT2','[AGR2006] J221410.24-173024.1',0.905,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154461,'Tully-Fisher','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154461,34.98,0.2,99.1,73170,74.4,NULL,NULL,'CGCG 428-053',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00006,NULL,'15.4g',0.48,'Sbc',NULL,NULL,NULL,NULL,1,333.54275,13.27883,0.197,NULL,52258177368,816534021,12758344,15.4),(154462,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4av',NULL,154462,42.26,0.13,1870,73171,70,NULL,'SALT 2','SNLS 05D4av HOST',0.509,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.543833333,-17.91186,0.045,NULL,49787005912,777921967,12155030,NULL),(154463,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4av',NULL,154463,42.32,0.15,1930,73171,NULL,NULL,'SIFTO','SNLS 05D4av HOST',0.509,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154464,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4av',NULL,154464,43.22,0.04,2920,73171,70,NULL,'SIFTO','SNLS 05D4av HOST',0.509,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154465,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 05D4av',NULL,154465,43.47,0.17,3270,73171,NULL,NULL,'SALT2','SNLS 05D4av HOST',0.509,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154466,'SNII optical','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4fu',NULL,154466,38.85,0.11,459,73172,NULL,NULL,'SEAM','APMUKS(BJ) B221128.89-174722.6',0.133,'2009ApJ...694.1067P',2009,1,0.13,NULL,'G',NULL,NULL,'18.8r',0.12,NULL,NULL,NULL,NULL,NULL,1,333.551083,-17.54106,0.041,NULL,49787393579,777928024,12155125,18.8),(154467,'SNII optical','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4fu',NULL,154467,38.94,0.14,614,73172,NULL,NULL,NULL,'APMUKS(BJ) B221128.89-174722.6',NULL,'2006ApJ...645..841N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154468,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jr',NULL,154468,41.55,0.03,1380,73173,70,NULL,'SIFTO','[NSB2006] J221414.33-172100.9',0.482,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.007,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.55975,-17.35025,0.045,NULL,49786814883,777918982,12154984,NULL),(154469,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jr',NULL,154469,42.11,0.12,1780,73173,70,NULL,'SALT 2','[NSB2006] J221414.33-172100.9',0.482,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154470,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jr',NULL,154470,42.16,0.15,1830,73173,NULL,NULL,'SIFTO','[NSB2006] J221414.33-172100.9',0.482,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154471,'SNIa','2016-12-15 15:15:58','2016-12-16 11:21:14','1','SNLS 04D4jr',NULL,154471,44.01,0.17,4280,73173,NULL,NULL,'SALT2','[NSB2006] J221414.33-172100.9',0.482,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154472,'FP','2016-12-15 15:15:58','2016-12-16 11:21:14','1',NULL,NULL,154472,35.56,0.58,129,73174,70,NULL,NULL,'ESO 189- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000033,NULL,'14.04',0.7,'SB(rs)bc',NULL,NULL,NULL,NULL,1,333.5659583,-54.12042,0,NULL,48702583365,760977865,11890279,14.04),(154473,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154473,35.6,1.15,132,73174,NULL,NULL,'Malmquist cor.','ESO 189- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154474,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154474,36.44,0.78,194,73174,NULL,NULL,NULL,'ESO 189- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154475,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154475,36.48,0.2,198,73174,74.4,NULL,NULL,'ESO 189- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154476,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SDSS-II SN 15657',NULL,154476,40.3,0.26,1150,73175,70,NULL,'SN photometric redshift distance, z photo =0.316 +/- 0.049','SDSS-II SN 15657',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.3g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,333.5780417,0.67264,0.109,NULL,52155743715,814933495,12733335,20.3),(154477,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SDSS-II SN 07988','RN',154477,43.45,0.43,3490,73176,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07988',0.401473,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154478,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 06D4dh',NULL,154478,40.19,0.03,837,73177,70,NULL,'SIFTO','SNLS 06D4dh',0.303,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.5820417,-17.585,0.041,NULL,49787423293,777928488,12155132,NULL),(154479,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 06D4dh',NULL,154479,41.08,0.1,1260,73177,70,NULL,'SALT 2','SNLS 06D4dh',0.303,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154480,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 06D4dh',NULL,154480,41.13,0.15,1290,73177,NULL,NULL,'SIFTO','SNLS 06D4dh',0.303,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154481,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 06D4dh',NULL,154481,41.92,0.17,1860,73177,NULL,NULL,'SALT2','SNLS 06D4dh',0.303,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154482,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154482,37.7,0.23,347,73178,70,NULL,NULL,'2MASX J22141981-0828330',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,333.582667,-8.47572,0.145,NULL,49842866532,778794789,12168668,18.2),(154483,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154483,35.87,0.2,149,73179,74.4,NULL,NULL,'CGCG 377-040',NULL,'2013AJ....146...86T',2013,1,0.87,NULL,'G',0.000087,NULL,'15.2g',0.47,'Sab',NULL,NULL,NULL,NULL,1,333.58675,1.01869,0.113,NULL,52156169841,814940153,12733439,15.2),(154484,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154484,37.7,0.23,347,73180,70,NULL,NULL,'2MASX J22142102-0822330',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000159,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.5875,-8.37583,0.161,NULL,49842860824,778794700,12168667,17.7),(154485,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154485,35.61,0.14,132,73181,70,NULL,NULL,'CGCG 428-054',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000097,NULL,'15.0g',0.63,'E0','Group member',NULL,NULL,NULL,1,333.5907083,13.95311,0.157,NULL,52260213235,816565831,12758841,15),(154486,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ic',NULL,154486,42.19,0.17,1630,73182,NULL,NULL,'SALT2','[HSP2005] J221421.84-175636.43',0.68,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.02,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.591,-17.94344,0.045,NULL,49787035969,777922437,12155038,NULL),(154487,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ic',NULL,154487,43.11,0.25,2490,73182,70,NULL,'SALT 2','[HSP2005] J221421.84-175636.43',0.68,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154488,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ic',NULL,154488,43.28,0.15,2690,73182,NULL,NULL,'SIFTO','[HSP2005] J221421.84-175636.43',0.68,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154489,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ic',NULL,154489,43.44,0.06,2900,73182,70,NULL,'SALT2','[HSP2005] J221421.84-175636.43',0.68,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154490,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf','R',154490,41.78,NULL,1430,73183,65,NULL,'MLCS31','[AGR2006] J221422.90-174402.4',0.581,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.5954583,-17.73403,0.049,NULL,49787410723,777928292,12155129,NULL),(154491,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154491,42.05,0.16,1630,73183,74.2,NULL,'SALT 2','[AGR2006] J221422.90-174402.4',0.581,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154492,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154492,42.44,0.04,1950,73183,70,NULL,'MLCS31','[AGR2006] J221422.90-174402.4',0.581,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154493,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154493,42.6,0.15,2090,73183,70,NULL,'SALT 2','[AGR2006] J221422.90-174402.4',0.581,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154494,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154494,42.65,0.15,2140,73183,NULL,NULL,'SIFTO','[AGR2006] J221422.90-174402.4',0.581,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154495,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154495,42.76,0.05,2260,73183,70,NULL,NULL,'[AGR2006] J221422.90-174402.4',0.581,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154496,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154496,42.79,0.15,2290,73183,70,NULL,'SALT','[AGR2006] J221422.90-174402.4',0.581,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154497,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154497,42.82,0.11,2310,73183,65,NULL,'SALT2','[AGR2006] J221422.90-174402.4',0.581,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154498,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154498,42.81,0.16,2310,73183,65,NULL,'MLCS2k2','[AGR2006] J221422.90-174402.4',0.581,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154499,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154499,42.85,0.15,2350,73183,65,NULL,'MLCS2k2','[AGR2006] J221422.90-174402.4',0.581,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154500,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154500,42.85,0.18,2350,73183,65,NULL,'MLCS31','[AGR2006] J221422.90-174402.4',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154501,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154501,42.86,0.18,2370,73183,65,NULL,'MLCS17','[AGR2006] J221422.90-174402.4',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154502,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154502,42.95,0.18,2460,73183,65,NULL,'SALT2','[AGR2006] J221422.90-174402.4',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154503,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154503,42.97,0.12,2480,73183,65,NULL,'SALT','[AGR2006] J221422.90-174402.4',0.581,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154504,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154504,43.04,0.05,2560,73183,65,NULL,'SALT','[AGR2006] J221422.90-174402.4',0.581,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154505,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gf',NULL,154505,43.58,0.17,3290,73183,NULL,NULL,'SALT2','[AGR2006] J221422.90-174402.4',0.581,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154506,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154506,37.25,0.46,282,73184,70,NULL,NULL,'2MASX J22142304-0818430',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000149,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,333.595917,-8.31189,0.161,NULL,49842849009,778794515,12168664,17.4),(154507,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154507,37.54,0.33,322,73185,70,NULL,NULL,'2MASX J22142399-0036599',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,333.5997917,-0.61647,0.249,NULL,49802561286,778165020,12158828,17.7),(154508,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at','R',154508,42.21,NULL,1700,73186,65,NULL,'MLCS17','[AGR2006] J221424.02-174636.0',0.633,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.600083,-17.77667,0.049,NULL,49787284533,777926320,12155098,NULL),(154509,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154509,42.35,0.17,1810,73186,74.2,NULL,'SALT 2','[AGR2006] J221424.02-174636.0',0.633,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154510,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154510,42.89,0.05,2320,73186,70,NULL,'MLCS17','[AGR2006] J221424.02-174636.0',0.633,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154511,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154511,42.91,0.15,2330,73186,NULL,NULL,'SIFTO','[AGR2006] J221424.02-174636.0',0.633,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154512,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154512,43,NULL,2440,73186,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J221424.02-174636.0',0.633,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154513,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154513,43.01,0.22,2440,73186,70,NULL,'SALT 2','[AGR2006] J221424.02-174636.0',0.633,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154514,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154514,43.13,0.06,2590,73186,70,NULL,NULL,'[AGR2006] J221424.02-174636.0',0.633,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154515,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154515,43.17,0.16,2640,73186,65,NULL,'MLCS2k2','[AGR2006] J221424.02-174636.0',0.633,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154516,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154516,43.18,0.14,2650,73186,65,NULL,'SALT2','[AGR2006] J221424.02-174636.0',0.633,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154517,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154517,43.2,0.2,2670,73186,70,NULL,'SALT','[AGR2006] J221424.02-174636.0',0.633,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154518,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154518,43.21,0.22,2680,73186,65,NULL,'MLCS17','[AGR2006] J221424.02-174636.0',0.633,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154519,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154519,43.26,0.23,2740,73186,65,NULL,'MLCS2k2','[AGR2006] J221424.02-174636.0',0.633,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154520,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154520,43.26,0.25,2740,73186,65,NULL,'MLCS31','[AGR2006] J221424.02-174636.0',0.633,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154521,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154521,43.29,0.19,2790,73186,65,NULL,'SALT2','[AGR2006] J221424.02-174636.0',0.633,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154522,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154522,43.39,0.17,2910,73186,65,NULL,'SALT','[AGR2006] J221424.02-174636.0',0.633,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154523,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154523,43.4,0.17,2930,73186,NULL,NULL,'SALT2','[AGR2006] J221424.02-174636.0',0.633,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154524,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4at',NULL,154524,43.41,0.05,2940,73186,65,NULL,'SALT','[AGR2006] J221424.02-174636.0',0.633,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154525,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154525,35.01,0.75,100,73187,70,NULL,NULL,'ESO 048- G 020',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00015,NULL,'15.73',0.5,'Sa: pec sp',NULL,NULL,NULL,NULL,1,333.60025,-76.05894,0.381,NULL,48410283702,756410682,11818916,15.73),(154526,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154526,36.36,0.8,187,73188,70,NULL,NULL,'FAIRALL 1003',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.91',0.53,'(R)SB(s)a',NULL,NULL,NULL,NULL,1,333.6002917,-67.07961,0.025,NULL,49280362496,770005664,12031338,15.91),(154527,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154527,37.78,0.46,360,73189,70,NULL,NULL,'2MASX J22142485-0846479',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,333.603625,-8.78003,0.141,NULL,49842059476,778782179,12168471,17.4),(154528,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4dt',NULL,154528,41.02,0.17,1140,73190,NULL,NULL,'SALT2','SNLS 05D4dt HOST',0.407,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.6077083,-17.67111,0.049,NULL,49787427321,777928551,12155133,NULL),(154529,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4dt',NULL,154529,41.89,0.11,1700,73190,70,NULL,'SALT 2','SNLS 05D4dt HOST',0.407,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154530,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4dt',NULL,154530,41.94,0.15,1740,73190,NULL,NULL,'SIFTO','SNLS 05D4dt HOST',0.407,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154531,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4dt',NULL,154531,42.1,0.03,1870,73190,70,NULL,'SALT2','SNLS 05D4dt HOST',0.407,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154532,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SDSS-II SN 07496','RN',154532,40.93,0.32,990,73191,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07496',0.551336,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154533,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154533,37.19,0.46,274,73192,70,NULL,NULL,'2MASX J22142675-0932049',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,333.611583333,-9.53464,0.129,NULL,49830532595,778602071,12165657,17.6),(154534,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154534,37.54,0.33,322,73193,70,NULL,NULL,'2MASX J22142878-0034449',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,333.619833333,-0.57911,0.249,NULL,49802561711,778165026,12158828,17.6),(154535,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2001fd',NULL,154535,34.77,0.09,90,73194,74.4,NULL,NULL,'UGC 11957',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00011,NULL,'15.16',0.5,'Sbc',NULL,NULL,NULL,NULL,1,333.621125,5.03117,0.281,NULL,52208442254,815756910,12746201,15.16),(154536,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154536,35.17,0.8,108,73194,75,NULL,'CF, r','UGC 11957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154537,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154537,34.99,0.38,99.5,73194,75,NULL,'CF, r, raw','UGC 11957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154538,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154538,35.1,0.38,105,73194,75,NULL,'CF, r, inv','UGC 11957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154539,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154539,35.27,0.38,113,73194,75,NULL,'CF, r, cor','UGC 11957',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154540,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154540,37.07,0.46,259,73195,70,NULL,NULL,'2MASX J22142936+1329266',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000174,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,333.6224583,13.49089,0.189,NULL,52258206396,816534474,12758351,16.7),(154541,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4ay',NULL,154541,39.55,0.17,577,73196,NULL,NULL,'SALT2','SNLS 05D4ay HOST',0.408,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.638291667,-17.76767,0.049,NULL,49787282134,777926283,12155098,NULL),(154542,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4ay',NULL,154542,42.01,0.15,1790,73196,NULL,NULL,'SIFTO','SNLS 05D4ay HOST',0.408,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154543,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ht',NULL,154543,40.45,0.15,1010,73197,NULL,NULL,'SIFTO','[NSB2006] J221433.28-172131.3',0.217,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.638708333,-17.35869,0.045,NULL,49787331618,777927056,12155110,NULL),(154544,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4ht',NULL,154544,41.47,0.17,1620,73197,NULL,NULL,'SALT2','[NSB2006] J221433.28-172131.3',0.217,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154545,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154545,42.7,0.29,1780,73198,74.2,NULL,'SALT 2','[AGR2006] J221433.75-173515.3',0.949,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.014,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.640625,-17.58758,0.041,NULL,49787432169,777928627,12155134,NULL),(154546,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx','R',154546,42.75,NULL,1820,73198,65,NULL,'SALT2','[AGR2006] J221433.75-173515.3',0.949,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154547,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154547,43.43,0.26,2490,73198,70,NULL,'SALT 2','[AGR2006] J221433.75-173515.3',0.949,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154548,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154548,43.46,0.17,2530,73198,NULL,NULL,'SALT2','[AGR2006] J221433.75-173515.3',0.949,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154549,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154549,43.47,0.47,2540,73198,70,NULL,'SALT','[AGR2006] J221433.75-173515.3',0.949,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154550,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154550,43.51,0.27,2580,73198,70,NULL,NULL,'[AGR2006] J221433.75-173515.3',0.949,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154551,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154551,43.51,0.29,2580,73198,65,NULL,'SALT2','[AGR2006] J221433.75-173515.3',0.949,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154552,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154552,43.54,NULL,2620,73198,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[AGR2006] J221433.75-173515.3',0.949,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154553,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154553,43.54,0.15,2620,73198,NULL,NULL,'SIFTO','[AGR2006] J221433.75-173515.3',0.949,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154554,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154554,43.57,0.38,2650,73198,65,NULL,'SALT2','[AGR2006] J221433.75-173515.3',0.949,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154555,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154555,43.61,0.44,2700,73198,65,NULL,'SALT','[AGR2006] J221433.75-173515.3',0.949,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154556,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154556,43.78,0.18,2920,73198,65,NULL,'SALT','[AGR2006] J221433.75-173515.3',0.949,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154557,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154557,43.81,0.08,2960,73198,70,NULL,'SALT 2','[AGR2006] J221433.75-173515.3',0.949,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154558,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154558,43.83,0.3,2990,73198,65,NULL,'MLCS2k2','[AGR2006] J221433.75-173515.3',0.949,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154559,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154559,44.16,0.18,3480,73198,65,NULL,'MLCS17','[AGR2006] J221433.75-173515.3',0.949,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154560,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154560,44.23,0.15,3600,73198,65,NULL,'MLCS31','[AGR2006] J221433.75-173515.3',0.949,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154561,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4cx',NULL,154561,44.26,0.13,3640,73198,65,NULL,'MLCS2k2','[AGR2006] J221433.75-173515.3',0.949,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154562,'G Lens','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154562,44.64,0.17,4350,73198,NULL,NULL,'SNLS 03D4cx HOST','[AGR2006] J221433.75-173515.3',0.949,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154563,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154563,44.67,0.17,4400,73198,NULL,NULL,'SNLS 03D4cx HOST','[AGR2006] J221433.75-173515.3',0.949,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154564,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154564,37.73,0.46,351,73199,70,NULL,NULL,'2MASX J22143544-0102103',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.64775,-1.03628,0.233,NULL,49803105307,778173520,12158961,17.7),(154565,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154565,36.03,0.46,160,73200,70,NULL,NULL,'2MASX J22143829+1251096',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00015,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,333.659458333,12.85272,0.177,NULL,52247153598,816361774,12755652,17),(154566,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154566,34.09,0.8,65.8,73201,75,NULL,'MAT, I','ESO 467- G 027',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000027,NULL,'13.35',0.7,'(R\')SA(rs)bc   HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,333.666333333,-27.46397,0,NULL,50534349396,789599209,12337487,13.35),(154567,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154567,29.38,0.58,7.5,73201,NULL,NULL,NULL,'ESO 467- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154568,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154568,30.03,0.43,10.2,73201,NULL,NULL,'Malmquist cor.','ESO 467- G 027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154569,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154569,33.44,0.32,48.8,73201,85,NULL,'I, raw','ESO 467- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154570,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154570,33.48,0.43,49.7,73201,75,NULL,'MAT, I, raw','ESO 467- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154571,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154571,33.49,0.32,50,73201,85,NULL,'I, inv','ESO 467- G 027',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154572,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154572,33.65,NULL,53.7,73201,NULL,NULL,'I','ESO 467- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154573,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154573,33.72,0.43,55.5,73201,75,NULL,'MAT, I, inv','ESO 467- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154574,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154574,33.81,0.43,57.7,73201,75,NULL,'MAT, I, cor','ESO 467- G 027',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154575,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154575,33.93,NULL,61.1,73201,NULL,NULL,'B','ESO 467- G 027',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154576,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154576,35.61,0.14,132,73202,70,NULL,NULL,'2MASX J22144047+1352416',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00011,NULL,'17.39',0.15,NULL,NULL,NULL,NULL,NULL,1,333.6685,13.87839,0.157,NULL,52260218018,816565906,12758842,17.39),(154577,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154577,34.18,0.17,66.9,73203,74.2,NULL,'SALT 2','2MASX J22144070+0504435',0.0247,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.669541667,5.07872,0.285,NULL,52208164958,815752577,12746134,NULL),(154578,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154578,34.96,0.03,95.8,73203,72,NULL,'z lit','2MASX J22144070+0504435',0.0247,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154579,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154579,34.98,0.15,96.7,73203,72,NULL,NULL,'2MASX J22144070+0504435',0.0247,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154580,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154580,34.99,0.15,97,73203,73.8,NULL,'SALT 2 (SNANA)','2MASX J22144070+0504435',0.0255,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154581,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154581,35.01,0.19,98,73203,72,NULL,'z lit','2MASX J22144070+0504435',0.0247,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154582,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154582,35.08,0.1,101,73203,72,NULL,'MLCS2k2, R(V) = 1.7','2MASX J22144070+0504435',0.0247,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154583,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154583,35.08,0.17,101,73203,65,NULL,'MLCS17, z SN CMB','2MASX J22144070+0504435',0.0247,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154584,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154584,35.09,0.16,102,73203,70,NULL,'SALT 2','2MASX J22144070+0504435',0.0247,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154585,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154585,35.09,0.2,102,73203,65,NULL,'SALT2, z SN CMB','2MASX J22144070+0504435',0.0247,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154586,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154586,35.09,0.18,102,73203,65,NULL,'SALT, z SN CMB','2MASX J22144070+0504435',0.0247,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154587,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154587,35.16,0.04,105,73203,70,NULL,'SALT 2','2MASX J22144070+0504435',0.0247,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154588,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154588,35.16,0.12,105,73203,72,NULL,'MLCS2k2, R(V) = 3.1','2MASX J22144070+0504435',0.0247,'2010ApJ...721.1608B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154589,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154589,35.16,0.18,105,73203,65,NULL,'MLCS31, z SN CMB','2MASX J22144070+0504435',0.0247,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154590,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq','R',154590,35.14,0.06,107,73203,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J22144070+0504435',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154591,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq','R',154591,35.18,0.06,109,73203,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J22144070+0504435',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154592,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2007cq',NULL,154592,35.32,0.1,116,73203,72,NULL,'M(H) = -18.317 mag','2MASX J22144070+0504435',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154593,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SDSS-II SN 20043',NULL,154593,40.46,0.13,1240,73204,70,NULL,'SN photometric redshift distance, z photo =0.346 +/- 0.026','SDSS-II SN 20043',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,333.682541667,1.20172,0.105,NULL,52156083074,814938798,12733418,NULL),(154594,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl','R',154594,41.68,NULL,1380,73205,65,NULL,'MLCS17','[HSP2005] J221444.17-173144.47',0.571,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.684083,-17.52903,0.041,NULL,49787326705,777926979,12155109,NULL),(154595,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154595,41.7,0.18,1390,73205,74.2,NULL,'SALT 2','[HSP2005] J221444.17-173144.47',0.571,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154596,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154596,42.31,0.08,1850,73205,70,NULL,'MLCS17','[HSP2005] J221444.17-173144.47',0.571,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154597,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154597,42.45,0.35,1960,73205,65,NULL,'MLCS2k2','[HSP2005] J221444.17-173144.47',0.571,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154598,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154598,42.45,0.39,1970,73205,65,NULL,'MLCS17','[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154599,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154599,42.47,0.07,1980,73205,70,NULL,NULL,'[HSP2005] J221444.17-173144.47',0.571,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154600,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154600,42.46,0.18,1980,73205,70,NULL,'SALT','[HSP2005] J221444.17-173144.47',0.571,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154601,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154601,42.46,0.37,1980,73205,65,NULL,'MLCS31','[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154602,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154602,42.62,0.15,2130,73205,65,NULL,'SALT','[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154603,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154603,42.75,0.06,2250,73205,65,NULL,'SALT','[HSP2005] J221444.17-173144.47',0.571,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154604,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154604,42.77,0.17,2270,73205,72,NULL,NULL,'[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154605,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4gl',NULL,154605,43.11,0.26,2670,73205,65,NULL,'SALT2','[HSP2005] J221444.17-173144.47',0.571,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154606,'D-Sigma','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154606,34.43,0.4,76.9,73206,75,NULL,'Edat, raw','NGC 7236',NULL,'1997ApJS..109..333W',1997,1,1.25,'Component \'a)\' in UGC notes.','G',0.000033,NULL,'14.7g',0.56,'SA0-           AGN:','Pair member, contact system',NULL,NULL,NULL,1,333.6874583,13.84653,0.157,NULL,52260002345,816562536,12758789,14.7),(154607,'D-Sigma','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154607,34.67,0.4,86.1,73206,75,NULL,'Edat, cor','NGC 7236',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154608,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154608,33.99,0.44,62.8,73206,95,NULL,'Weighted Mean','NGC 7236',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154609,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154609,34.15,0.63,67.6,73206,95,NULL,'Michard 1979b, c','NGC 7236',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154610,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154610,34.79,0.46,90.8,73206,95,NULL,'Michard 1979a','NGC 7236',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154611,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154611,34.99,0.45,99.6,73206,NULL,NULL,'K','NGC 7236',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154612,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154612,35.2,0.4,110,73206,NULL,NULL,'mean','NGC 7236',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154613,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha','R',154613,39.71,NULL,681,73207,65,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2010arXiv1006.2112L',2010,1,0.13,NULL,'G',0.0003,NULL,'19.92',0.11,NULL,NULL,NULL,NULL,NULL,1,333.690958333,-17.73953,0.049,NULL,49787261692,777925963,12155093,19.92),(154614,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154614,40.12,0.14,822,73207,74.2,NULL,'SALT 2','APMUKS(BJ) B221202.39-175918.2',0.285,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154615,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154615,40.2,0.03,852,73207,70,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154616,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154616,40.69,0.12,1070,73207,70,NULL,'SNLS 03D4ag, SALT 2','APMUKS(BJ) B221202.39-175918.2',0.285,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154617,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154617,40.71,0.13,1080,73207,70,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154618,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154618,40.73,0.02,1090,73207,70,NULL,'SNLS 03D4ag','APMUKS(BJ) B221202.39-175918.2',0.285,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154619,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154619,40.8,0.15,1130,73207,NULL,NULL,'SNLS 03D4ag, SIFTO','APMUKS(BJ) B221202.39-175918.2',0.285,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154620,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154620,40.91,0.1,1180,73207,65,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154621,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154621,40.93,0.14,1190,73207,65,NULL,'SNLS 03D4ag, MLCS17','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154622,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154622,40.94,0.01,1200,73207,65,NULL,'SNLS 03D4ag, SALT','APMUKS(BJ) B221202.39-175918.2',0.285,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154623,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154623,40.94,0.09,1200,73207,65,NULL,'SNLS 03D4ag, SALT2','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154624,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154624,40.98,0.09,1220,73207,65,NULL,'SNLS 03D4ag, MLCS2k2','APMUKS(BJ) B221202.39-175918.2',0.285,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154625,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154625,40.97,0.11,1220,73207,65,NULL,'SNLS 03D4ag, MLCS2k2','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154626,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154626,40.98,0.12,1220,73207,65,NULL,'SNLS 03D4ag, MLCS31','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154627,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154627,40.99,0.16,1220,73207,65,NULL,'SNLS 03D4ag, SALT2','APMUKS(BJ) B221202.39-175918.2',0.285,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154628,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SN 2003ha',NULL,154628,41.93,0.17,1890,73207,NULL,NULL,'SNLS 03D4ag, SALT2','APMUKS(BJ) B221202.39-175918.2',0.285,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154629,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154629,33.97,NULL,62.2,73208,70,NULL,'H, UH88/IRSF/2MASS, Malmquist corr.','UGC 11961',NULL,'2011A&A...531A..87I',2011,1,1.98,NULL,'G',0.00002,NULL,'15.0',0.28,'Sb',NULL,NULL,NULL,NULL,1,333.693125,42.18117,1.125,NULL,55509552404,867336756,13552136,15),(154630,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154630,33.97,NULL,62.2,73208,70,NULL,'H, 2MASS, Malmquist corr.','UGC 11961',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154631,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154631,34.03,0.35,64,73208,70,NULL,'H, UH88/IRSF/2MASS','UGC 11961',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154632,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154632,34.03,0.35,64,73208,70,NULL,'H, 2MASS','UGC 11961',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154633,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154633,34.24,0.43,70.5,73208,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11961',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154634,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154634,34.28,0.49,71.8,73208,75,NULL,'IR','UGC 11961',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154635,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154635,34.32,0.43,73.2,73208,75,NULL,'3.6 micron, color corrected','UGC 11961',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154636,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154636,34.42,0.2,76.6,73208,74.4,NULL,NULL,'UGC 11961',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154637,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154637,34.54,NULL,81,73208,NULL,NULL,'Dipole','UGC 11961',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154638,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154638,34.56,NULL,81.5,73208,NULL,NULL,'Dipole + Quadrupole','UGC 11961',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154639,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154639,34.56,NULL,81.7,73208,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11961',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154640,'D-Sigma','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154640,34.43,0.4,76.9,73209,75,NULL,'Edat, raw','NGC 7237',NULL,'1997ApJS..109..333W',1997,1,1.81,'Component \'b)\' in UGC notes.','G',0.000037,NULL,'14.2g',0.72,'SA0-','Pair member, contact system',NULL,'radio jet',NULL,1,333.695333,13.84086,0.157,NULL,52260001026,816562516,12758789,14.2),(154641,'D-Sigma','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154641,34.67,0.4,86.1,73209,75,NULL,'Edat, cor','NGC 7237',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154642,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154642,34.79,0.44,90.8,73209,95,NULL,'Weighted Mean','NGC 7237',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154643,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154643,35.29,0.46,114,73209,95,NULL,'Michard 1979a','NGC 7237',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154644,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154644,35.65,0.63,135,73209,95,NULL,'Michard 1979b, c','NGC 7237',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154645,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4gw',NULL,154645,43.47,0.25,2740,73210,70,NULL,'SALT 2','SNLS 05D4gw HOST',0.808,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.697375,-17.53194,0.041,NULL,49787355335,777927427,12155116,NULL),(154646,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4gw',NULL,154646,43.63,0.15,2940,73210,NULL,NULL,'SIFTO','SNLS 05D4gw HOST',0.808,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154647,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4gw',NULL,154647,43.8,0.07,3190,73210,70,NULL,'SIFTO','SNLS 05D4gw HOST',0.808,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154648,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4gw',NULL,154648,43.84,0.17,3250,73210,NULL,NULL,'SALT2','SNLS 05D4gw HOST',0.808,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154649,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154649,35.59,NULL,131,73211,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2376',NULL,'2010Ap&SS.325..163P',2010,1,0.8,NULL,'G',0.000017,NULL,'16.9',0.09,'Sc',NULL,NULL,NULL,NULL,1,333.7035,14.46819,0.193,NULL,52259272540,816551133,12758611,16.9),(154650,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154650,35.62,NULL,133,73211,NULL,NULL,'Dipole + Quadrupole','FGC 2376',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154651,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154651,35.63,NULL,134,73211,NULL,NULL,'Dipole','FGC 2376',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154652,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154652,35.69,NULL,137,73211,NULL,NULL,NULL,'FGC 2376',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154653,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154653,36.12,0.49,167,73211,75,NULL,'IR','FGC 2376',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154654,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154654,41.57,0.16,1330,73212,74.2,NULL,'SALT 2','[AGR2006] J221449.39-174939.3',0.55,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.7057917,-17.82761,0.049,NULL,49787303305,777926614,12155103,NULL),(154655,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq','R',154655,41.85,NULL,1510,73212,65,NULL,'SALT2','[AGR2006] J221449.39-174939.3',0.55,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154656,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154656,42.21,0.15,1780,73212,70,NULL,'SALT 2','[AGR2006] J221449.39-174939.3',0.55,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154657,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154657,42.26,0.15,1830,73212,NULL,NULL,'SIFTO','[AGR2006] J221449.39-174939.3',0.55,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154658,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154658,42.36,0.12,1910,73212,65,NULL,'SALT2','[AGR2006] J221449.39-174939.3',0.55,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154659,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154659,42.38,0.14,1930,73212,65,NULL,'MLCS2k2','[AGR2006] J221449.39-174939.3',0.55,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154660,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154660,42.4,0.16,1950,73212,70,NULL,'SALT','[AGR2006] J221449.39-174939.3',0.55,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154661,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154661,42.48,0.18,2020,73212,65,NULL,'SALT2','[AGR2006] J221449.39-174939.3',0.55,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154662,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154662,42.49,0.06,2030,73212,70,NULL,NULL,'[AGR2006] J221449.39-174939.3',0.55,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154663,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154663,42.54,0.13,2080,73212,65,NULL,'SALT','[AGR2006] J221449.39-174939.3',0.55,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154664,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154664,42.69,0.26,2230,73212,65,NULL,'MLCS17','[AGR2006] J221449.39-174939.3',0.55,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154665,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154665,42.73,0.29,2270,73212,65,NULL,'MLCS31','[AGR2006] J221449.39-174939.3',0.55,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154666,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154666,42.75,0.05,2290,73212,65,NULL,'SALT','[AGR2006] J221449.39-174939.3',0.55,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154667,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154667,42.75,0.27,2290,73212,65,NULL,'MLCS2k2','[AGR2006] J221449.39-174939.3',0.55,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154668,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154668,42.85,0.04,2390,73212,70,NULL,'SALT 2','[AGR2006] J221449.39-174939.3',0.55,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154669,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 04D4bq',NULL,154669,43.3,0.17,2960,73212,NULL,NULL,'SALT2','[AGR2006] J221449.39-174939.3',0.55,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154670,'G Lens','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154670,44.5,0.17,5140,73212,NULL,NULL,'SNLS 04D4bq HOST','[AGR2006] J221449.39-174939.3',0.55,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154671,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154671,44.42,0.17,4940,73212,NULL,NULL,'SNLS 04D4bq HOST','[AGR2006] J221449.39-174939.3',0.55,'2010A&A...514A..44K',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154672,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154672,40.83,0.17,1070,73213,NULL,NULL,'SALT2','SNLS 05D4cw HOST',0.375,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.708666667,-17.73878,0.049,NULL,49787263261,777925988,12155093,NULL),(154673,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154673,41.1,0.03,1210,73213,70,NULL,'SALT2','SNLS 05D4cw HOST',0.375,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154674,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154674,41.39,0.17,1380,73213,72,NULL,'z lit','SNLS 05D4cw HOST',0.375,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154675,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154675,41.54,0.11,1480,73213,70,NULL,'SALT 2','SNLS 05D4cw HOST',0.375,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154676,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154676,41.61,NULL,1520,73213,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4cw HOST',0.375,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154677,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 05D4cw',NULL,154677,41.64,0.15,1550,73213,NULL,NULL,'SIFTO','SNLS 05D4cw HOST',0.375,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154678,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy','R',154678,41.69,NULL,1360,73214,65,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.7104583,-17.95644,0.045,NULL,49787253214,777925831,12155091,NULL),(154679,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154679,41.83,0.16,1450,73214,74.2,NULL,'SALT 2','[AGR2006] J221450.51-175723.2',0.604,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154680,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154680,42.11,0.06,1650,73214,70,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154681,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154681,42.44,0.14,1920,73214,70,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154682,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154682,42.5,0.11,1970,73214,65,NULL,'SALT2','[AGR2006] J221450.51-175723.2',0.604,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154683,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154683,42.51,0.16,1980,73214,65,NULL,'MLCS2k2','[AGR2006] J221450.51-175723.2',0.604,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154684,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154684,42.52,0.03,1990,73214,70,NULL,NULL,'[AGR2006] J221450.51-175723.2',0.604,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154685,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154685,42.57,0.11,2040,73214,65,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154686,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154686,42.63,0.17,2090,73214,65,NULL,'SALT2','[AGR2006] J221450.51-175723.2',0.604,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154687,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154687,42.62,0.29,2090,73214,65,NULL,'MLCS17','[AGR2006] J221450.51-175723.2',0.604,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154688,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154688,42.74,0.33,2200,73214,65,NULL,'MLCS31','[AGR2006] J221450.51-175723.2',0.604,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154689,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154689,42.79,0.31,2250,73214,65,NULL,'MLCS2k2','[AGR2006] J221450.51-175723.2',0.604,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154690,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154690,42.81,0.14,2270,73214,70,NULL,'SALT 2','[AGR2006] J221450.51-175723.2',0.604,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154691,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154691,42.81,0.03,2280,73214,65,NULL,'SALT','[AGR2006] J221450.51-175723.2',0.604,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154692,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154692,42.82,0.15,2280,73214,NULL,NULL,'SIFTO','[AGR2006] J221450.51-175723.2',0.604,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154693,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:14','1','SNLS 03D4dy',NULL,154693,44.53,0.17,5010,73214,NULL,NULL,'SALT2','[AGR2006] J221450.51-175723.2',0.604,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154694,'FP','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154694,36.39,0.54,190,73215,70,NULL,NULL,'2MASX J22145074-0150592',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.98',0.3,NULL,NULL,NULL,NULL,NULL,1,333.7112917,-1.84964,0.181,NULL,49800826774,778137918,12158404,16.98),(154695,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,'R',154695,35.67,0.49,136,73216,75,NULL,'IR','2MFGC 16780',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'12.6K',NULL,NULL,NULL,NULL,NULL,NULL,1,333.723,14.45894,0.193,NULL,52259271967,816551124,12758611,12.6),(154696,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:14','1',NULL,NULL,154696,33.73,0.4,55.8,73217,NULL,NULL,'mean','ESO 467- G 030',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000017,NULL,'15.26',0.5,'(R\')SA(rs)b',NULL,NULL,NULL,NULL,1,333.729917,-27.93364,0,NULL,50548213982,789815843,12340872,15.26),(154697,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154697,33.75,0.47,56.3,73217,NULL,NULL,'H','ESO 467- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154698,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154698,33.87,0.46,59.4,73217,NULL,NULL,'J','ESO 467- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154699,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154699,33.91,0.45,60.6,73217,NULL,NULL,'K','ESO 467- G 030',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154700,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154700,31.64,0.8,21.3,73218,75,NULL,'A82, H','IC 5176',NULL,'1997ApJS..109..333W',1997,1,6.05,'The APM position is southwest of the nucleus.','G',0.00001,NULL,'13.52',0.78,'SAB(s)bc? sp',NULL,NULL,NULL,NULL,1,333.7330417,-66.84942,0.025,NULL,49287892789,770123324,12033176,13.52),(154701,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154701,31.64,0.8,21.3,73218,75,NULL,'MAT, I','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154702,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154702,31.61,0.8,21,73218,75,NULL,NULL,'IC 5176',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154703,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154703,31.57,0.39,20.6,73218,73,NULL,'IR','IC 5176',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154704,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154704,31.57,0.4,20.6,73218,75,NULL,NULL,'IC 5176',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154705,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154705,31.84,0.4,23.3,73218,73,NULL,'opt','IC 5176',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154706,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154706,31.97,0.47,24.8,73218,75,NULL,'A82, H, raw','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154707,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154707,32.02,0.4,25.3,73218,NULL,NULL,'mean','IC 5176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154708,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154708,32.05,0.43,25.7,73218,75,NULL,'3.6 micron, color + selection bias corrected','IC 5176',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154709,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154709,32.06,0.47,25.8,73218,NULL,NULL,'H','IC 5176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154710,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154710,32.08,0.47,26.1,73218,75,NULL,'A82, H, inv','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154711,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154711,32.1,0.45,26.3,73218,NULL,NULL,'K','IC 5176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154712,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154712,32.11,0.46,26.4,73218,NULL,NULL,'J','IC 5176',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154713,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154713,32.11,0.35,26.4,73218,NULL,NULL,NULL,'IC 5176',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154714,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154714,32.19,0.43,27.5,73218,75,NULL,'3.6 micron, color corrected','IC 5176',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154715,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154715,32.26,0.43,28.4,73218,75,NULL,'MAT, I, raw','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154716,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154716,32.29,NULL,28.7,73218,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154717,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154717,32.3,NULL,28.9,73218,NULL,NULL,'Dipole + Quadrupole','IC 5176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154718,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154718,32.31,NULL,28.9,73218,NULL,NULL,'Dipole','IC 5176',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154719,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154719,32.35,0.49,29.5,73218,75,NULL,'IR','IC 5176',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154720,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154720,32.36,0.2,29.7,73218,74.4,NULL,NULL,'IC 5176',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154721,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154721,32.37,0.32,29.8,73218,85,NULL,'I, raw','IC 5176',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154722,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154722,32.37,NULL,29.8,73218,NULL,NULL,NULL,'IC 5176',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154723,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154723,32.41,0.47,30.3,73218,75,NULL,'A82, H, cor','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154724,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154724,32.41,0.32,30.4,73218,85,NULL,'I, inv','IC 5176',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154725,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154725,32.47,0.43,31.1,73218,75,NULL,'MAT, I, inv','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154726,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154726,32.63,0.43,33.6,73218,75,NULL,'MAT, I, cor','IC 5176',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154727,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154727,38.61,0.46,526,73219,70,NULL,NULL,'SDSS J221457.22-083116.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,333.738458333,-8.52122,0.145,NULL,49843010501,778797039,12168703,18.4),(154728,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154728,40.79,0.38,1440,73220,NULL,NULL,'Hydrost. Eq.','MACS J2214.9-1359',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.73925,-14.003,0.089,NULL,49760322314,777505036,12148516,NULL),(154729,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154729,41.35,0.45,1860,73220,NULL,NULL,'Isotherm., r < 100 kpc','MACS J2214.9-1359',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154730,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154730,41.43,NULL,1930,73220,NULL,NULL,'3.1 (red) calibration','MACS J2214.9-1359',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154731,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154731,41.47,0.44,1970,73220,NULL,NULL,'Isotherm.','MACS J2214.9-1359',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154732,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154732,41.96,NULL,2470,73220,NULL,NULL,'4.2 (black) calibration','MACS J2214.9-1359',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154733,'SZ effect','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154733,42.2,NULL,2760,73220,NULL,NULL,'4.1 (blue) calibration','MACS J2214.9-1359',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154734,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154734,35.61,0.14,132,73221,70,NULL,NULL,'CGCG 428-060',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000083,NULL,'15.8g',0.43,'E0','Group member',NULL,NULL,NULL,1,333.741125,13.76192,0.157,NULL,52260040666,816563135,12758798,15.8),(154735,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bj',NULL,154735,43.08,0.2,2420,73222,70,NULL,'SALT 2','SNLS 05D4bj HOST',0.701,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.748583,-18.13342,0.013,NULL,49732259146,777066549,12141664,NULL),(154736,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bj',NULL,154736,43.13,0.15,2490,73222,NULL,NULL,'SIFTO','SNLS 05D4bj HOST',0.701,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154737,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bj',NULL,154737,43.45,0.17,2880,73222,NULL,NULL,'SALT2','SNLS 05D4bj HOST',0.701,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154738,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bj',NULL,154738,43.48,0.05,2920,73222,70,NULL,'SIFTO','SNLS 05D4bj HOST',0.701,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154739,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4im',NULL,154739,42.99,0.05,2260,73223,70,NULL,'SIFTO','[HSP2005] J221500.88-172345.84',0.751,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.7537083,-17.39606,0.045,NULL,49787363903,777927560,12155118,NULL),(154740,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4im',NULL,154740,43.14,0.15,2430,73223,NULL,NULL,'SIFTO','[HSP2005] J221500.88-172345.84',0.751,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154741,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4im',NULL,154741,44.12,0.17,3800,73223,NULL,NULL,'SALT2','[HSP2005] J221500.88-172345.84',0.751,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154742,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154742,35.57,0.54,130,73224,70,NULL,NULL,'ESO 189- G 032',NULL,'2014MNRAS.445.2677S',2014,1,1.12,NULL,'G',0.00015,NULL,'15.49',0.38,'(R\')SB(s)0/a',NULL,NULL,NULL,NULL,1,333.7577917,-55.97486,0,NULL,48698965614,760921337,11889395,15.49),(154743,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154743,36.83,0.46,232,73225,70,NULL,NULL,'2MASX J22150216-0930205',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,333.758917,-9.50575,0.129,NULL,49830523661,778601932,12165655,17.7),(154744,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2007qf',NULL,154744,39.61,0.09,835,73226,70,NULL,'Hubble residual 0.13 for z0.20380','SDSS J221502.93-002030.0',NULL,'2011ApJ...740...92G',2011,1,0.1,NULL,'G',0.0005,NULL,'20.4g',0.07,NULL,NULL,NULL,NULL,NULL,1,333.7622083,-0.34169,0.205,NULL,49801536034,778149000,12158578,20.4),(154745,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 19913','R',154745,40.11,0.21,872,73226,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qf','SDSS J221502.93-002030.0',0.2038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154746,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 19913','R',154746,40.26,0.11,936,73226,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qf','SDSS J221502.93-002030.0',0.2038,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154747,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bw',NULL,154747,43.04,0.05,2340,73227,70,NULL,'SIFTO','SNLS 06D4bw',0.732,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.7655,-17.88344,0.045,NULL,49787301535,777926586,12155102,NULL),(154748,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bw',NULL,154748,43.09,0.21,2390,73227,70,NULL,'SALT 2','SNLS 06D4bw',0.732,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154749,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bw',NULL,154749,43.2,0.15,2520,73227,NULL,NULL,'SIFTO','SNLS 06D4bw',0.732,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154750,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bw',NULL,154750,44.11,0.17,3840,73227,NULL,NULL,'SALT2','SNLS 06D4bw',0.732,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154751,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154751,37.92,0.46,385,73228,70,NULL,NULL,'2MASX J22150550-0720415',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,333.772958333,-7.34494,0.193,NULL,49841428852,778772325,12168317,18.1),(154752,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154752,37.25,0.46,282,73229,70,NULL,NULL,'2MASX J22150711+0005355',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.9g',0.19,'NLAGN',NULL,NULL,NULL,'Sy 2',1,333.77975,0.09314,0.165,NULL,52153659502,814900929,12732827,17.9),(154753,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk','R',154753,42.66,NULL,1850,73230,65,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.782,-18.06022,0.029,NULL,49787240713,777925636,12155088,NULL),(154754,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154754,43.09,0.06,2260,73230,70,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154755,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154755,43.17,0.23,2340,73230,74.2,NULL,'SALT 2','[AGR2006] J221507.68-180336.7',0.84,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154756,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154756,43.34,0.31,2530,73230,65,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154757,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154757,43.35,0.33,2540,73230,70,NULL,'SALT','[AGR2006] J221507.68-180336.7',0.84,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154758,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154758,43.48,0.19,2690,73230,70,NULL,NULL,'[AGR2006] J221507.68-180336.7',0.84,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154759,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154759,43.47,0.32,2690,73230,65,NULL,'SALT','[AGR2006] J221507.68-180336.7',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154760,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154760,43.74,0.14,3040,73230,65,NULL,'SALT','[AGR2006] J221507.68-180336.7',0.84,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154761,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154761,43.74,0.23,3050,73230,65,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154762,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154762,43.88,0.14,3240,73230,65,NULL,'MLCS2k2','[AGR2006] J221507.68-180336.7',0.84,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154763,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154763,43.88,0.16,3240,73230,65,NULL,'MLCS31','[AGR2006] J221507.68-180336.7',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154764,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154764,43.88,0.17,3240,73230,65,NULL,'MLCS17','[AGR2006] J221507.68-180336.7',0.84,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154765,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154765,43.9,0.16,3280,73230,65,NULL,'MLCS2k2','[AGR2006] J221507.68-180336.7',0.84,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154766,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154766,43.94,0.22,3330,73230,70,NULL,'SALT 2','[AGR2006] J221507.68-180336.7',0.84,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154767,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154767,43.95,0.15,3350,73230,NULL,NULL,'SIFTO','[AGR2006] J221507.68-180336.7',0.84,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154768,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4bk',NULL,154768,46.21,0.17,9500,73230,NULL,NULL,'SALT2','[AGR2006] J221507.68-180336.7',0.84,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154769,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4in',NULL,154769,41.77,0.04,1490,73231,70,NULL,'SIFTO','[NSB2006] J221508.58-171539.8',0.516,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.78575,-17.26106,0.049,NULL,49786794505,777918664,12154979,NULL),(154770,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4in',NULL,154770,42.43,0.15,2020,73231,NULL,NULL,'SIFTO','[NSB2006] J221508.58-171539.8',0.516,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154771,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4in',NULL,154771,42.45,0.12,2040,73231,70,NULL,'SALT 2','[NSB2006] J221508.58-171539.8',0.516,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154772,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4in',NULL,154772,44.51,0.17,5270,73231,NULL,NULL,'SALT2','[NSB2006] J221508.58-171539.8',0.516,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154773,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01677','RN',154773,43.77,0.33,3730,73232,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01677',0.519408,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154774,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154774,37.41,0.46,303,73233,70,NULL,NULL,'2MASX J22151253+1159061',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,333.8022917,11.985,0.181,NULL,52279400141,816865627,12763525,17),(154775,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154775,36.44,0.46,194,73234,70,NULL,NULL,'2MASX J22151492+1354191',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000159,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,333.8122083,13.90544,0.157,NULL,52259502868,816554732,12758667,16.8),(154776,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154776,35.61,0.46,133,73235,70,NULL,NULL,'2MASX J22151621-0915475',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.000097,NULL,'15.4g',0.47,'HII',NULL,NULL,NULL,NULL,1,333.817458333,-9.26322,0.133,NULL,49830598459,778603100,12165673,15.4),(154777,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154777,34.51,0.43,79.9,73236,75,NULL,'3.6 micron, color + selection bias corrected','IC 1441',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000103,NULL,'15.3',0.3,'SBa?','in a pair',NULL,NULL,NULL,1,333.82975,37.3015,0.737,NULL,55477808768,866840762,13544386,15.3),(154778,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154778,37.75,0.46,355,73237,70,NULL,NULL,'SDSS J221520.24-001412.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,333.834375,-0.23681,0.165,NULL,49801504398,778148506,12158570,18.7),(154779,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154779,40.99,0.17,1150,73238,NULL,NULL,'SALT2','SNLS 05D4fo HOST',0.373,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.8372083,-17.26814,0.049,NULL,49786782952,777918483,12154976,NULL),(154780,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154780,41.6,0.11,1520,73238,70,NULL,'SALT 2','SNLS 05D4fo HOST',0.373,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154781,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154781,41.62,NULL,1540,73238,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4fo HOST',0.373,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154782,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154782,41.62,0.15,1540,73238,NULL,NULL,'SIFTO','SNLS 05D4fo HOST',0.373,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154783,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154783,41.69,0.12,1590,73238,72,NULL,'z lit','SNLS 05D4fo HOST',0.373,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154784,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fo',NULL,154784,41.71,0.03,1600,73238,70,NULL,'SALT2','SNLS 05D4fo HOST',0.373,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154785,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154785,33.8,0.44,57.5,73239,95,NULL,'Weighted Mean','NGC 7240',NULL,'1984ApJS...56...91D',1984,1,0.7,NULL,'G',0.000187,NULL,'15.2',0.7,'S0-:','in a pair',NULL,NULL,NULL,1,333.844,37.28067,0.737,NULL,55477805490,866840710,13544386,15.2),(154786,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154786,34.25,0.63,70.8,73239,95,NULL,'Michard 1979b, c','NGC 7240',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154787,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154787,34.37,0.46,74.8,73239,95,NULL,'Michard 1979a','NGC 7240',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154788,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154788,42.7,0.21,1910,73240,74.2,NULL,'SALT 2','[HSP2005] J221525.47-171442.71',0.811,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.856125,-17.24519,0.049,NULL,49753438103,777397470,12146835,NULL),(154789,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm','R',154789,42.82,NULL,2030,73240,65,NULL,'MLCS17','[HSP2005] J221525.47-171442.71',0.811,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154790,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154790,43.39,0.17,2630,73240,NULL,NULL,'SALT2','[HSP2005] J221525.47-171442.71',0.811,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154791,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154791,43.44,0.22,2690,73240,70,NULL,'SALT 2','[HSP2005] J221525.47-171442.71',0.811,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154792,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154792,43.55,0.2,2830,73240,65,NULL,'SALT2','[HSP2005] J221525.47-171442.71',0.811,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154793,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154793,43.55,0.2,2830,73240,65,NULL,'MLCS2k2','[HSP2005] J221525.47-171442.71',0.811,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154794,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154794,43.56,0.15,2840,73240,NULL,NULL,'SIFTO','[HSP2005] J221525.47-171442.71',0.811,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154795,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154795,43.67,0.26,2990,73240,65,NULL,'MLCS17','[HSP2005] J221525.47-171442.71',0.811,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154796,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154796,43.7,0.06,3040,73240,70,NULL,'SALT 2','[HSP2005] J221525.47-171442.71',0.811,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154797,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154797,43.92,0.22,3350,73240,65,NULL,'MLCS2k2','[HSP2005] J221525.47-171442.71',0.811,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154798,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154798,43.92,0.23,3350,73240,65,NULL,'MLCS31','[HSP2005] J221525.47-171442.71',0.811,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154799,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154799,43.95,0.26,3410,73240,70,NULL,NULL,'[HSP2005] J221525.47-171442.71',0.811,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154800,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154800,44.06,0.36,3580,73240,70,NULL,'SALT','[HSP2005] J221525.47-171442.71',0.811,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154801,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154801,44.22,0.21,3850,73240,65,NULL,'SALT','[HSP2005] J221525.47-171442.71',0.811,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154802,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154802,44.25,0.46,3910,73240,65,NULL,'SALT2','[HSP2005] J221525.47-171442.71',0.811,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154803,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dm',NULL,154803,44.27,0.37,3940,73240,65,NULL,'SALT','[HSP2005] J221525.47-171442.71',0.811,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154804,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4co',NULL,154804,41.5,0.17,1390,73241,NULL,NULL,'SALT2','SNLS 06D4co HOST',0.437,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.8605,-17.86919,0.049,NULL,49786559546,777914992,12154921,NULL),(154805,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4co',NULL,154805,41.7,0.03,1520,73241,70,NULL,'SALT2','SNLS 06D4co HOST',0.437,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154806,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4co',NULL,154806,41.7,0.11,1520,73241,70,NULL,'SALT 2','SNLS 06D4co HOST',0.437,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154807,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4co',NULL,154807,41.79,0.15,1590,73241,NULL,NULL,'SIFTO','SNLS 06D4co HOST',0.437,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154808,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bo',NULL,154808,42.22,0.05,1790,73242,70,NULL,'SIFTO','SNLS 06D4bo',0.552,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.867125,-17.40919,0.045,NULL,49787308643,777926697,12155104,NULL),(154809,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bo',NULL,154809,42.58,0.13,2110,73242,70,NULL,'SALT 2','SNLS 06D4bo',0.552,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154810,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bo',NULL,154810,42.7,0.15,2230,73242,NULL,NULL,'SIFTO','SNLS 06D4bo',0.552,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154811,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4bo',NULL,154811,43.84,0.17,3770,73242,NULL,NULL,'SALT2','SNLS 06D4bo',0.552,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154812,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4bc',NULL,154812,43.09,0.23,2640,73243,74.2,NULL,'SALT 2','[AGR2006] J221528.14-174948.6',0.572,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.86725,-17.83019,0.049,NULL,49786567385,777915115,12154923,NULL),(154813,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4bc',NULL,154813,43.52,0.14,3220,73243,70,NULL,NULL,'[AGR2006] J221528.14-174948.6',0.572,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154814,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4bc',NULL,154814,43.56,0.23,3280,73243,70,NULL,'SALT','[AGR2006] J221528.14-174948.6',0.572,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154815,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154815,31.85,NULL,23.4,73244,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11964',NULL,'2010Ap&SS.325..163P',2010,1,2.13,NULL,'G',0.000005,NULL,'16.0',0.3,'Sd','in a pair',NULL,NULL,NULL,1,333.871375,19.22006,0.209,NULL,52222903452,815982866,12749732,16),(154816,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154816,31.87,NULL,23.6,73244,NULL,NULL,'Dipole + Quadrupole','UGC 11964',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154817,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154817,31.87,NULL,23.7,73244,NULL,NULL,'Dipole','UGC 11964',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154818,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154818,32.32,0.2,29.1,73244,74.4,NULL,NULL,'UGC 11964',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154819,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154819,32.48,0.44,31.4,73244,NULL,NULL,NULL,'UGC 11964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154820,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154820,32.54,0.43,32.2,73244,NULL,NULL,'Malmquist cor.','UGC 11964',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154821,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154821,33.06,NULL,40.9,73244,NULL,NULL,NULL,'UGC 11964',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154822,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS10ahl','N',154822,43.05,0.25,2490,73245,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10ahl HOST',0.6338,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154823,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dy',NULL,154823,43.63,0.06,2970,73246,70,NULL,'SIFTO','SNLS 05D4dy HOST',0.79,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.875417,-18.21542,0.013,NULL,49731935109,777061486,12141585,NULL),(154824,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dy',NULL,154824,43.88,0.17,3330,73246,NULL,NULL,'SALT2','SNLS 05D4dy HOST',0.79,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154825,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dy',NULL,154825,44.03,0.23,3570,73246,70,NULL,'SALT 2','SNLS 05D4dy HOST',0.79,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154826,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dy',NULL,154826,44.04,0.15,3590,73246,NULL,NULL,'SIFTO','SNLS 05D4dy HOST',0.79,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154827,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154827,35.61,0.14,132,73247,70,NULL,NULL,'2MASX J22153029+1340228',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,333.876166667,13.67319,0.185,NULL,52259456595,816554009,12758656,16.5),(154828,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154828,34.07,0.8,65.1,73248,75,NULL,'W91PP, r','UGC 11967',NULL,'1997ApJS..109..333W',1997,1,1.39,NULL,'G',0.000009,NULL,'15.66',0.19,'Sbc',NULL,NULL,NULL,NULL,1,333.8935,33.62997,0.477,NULL,55497397481,867146835,13549169,15.66),(154829,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154829,33.73,0.49,55.8,73248,75,NULL,'IR','UGC 11967',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154830,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154830,33.81,0.38,57.7,73248,75,NULL,'W91PP, r, raw','UGC 11967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154831,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154831,33.85,0.38,58.9,73248,75,NULL,'W91PP, r, inv','UGC 11967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154832,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154832,34.04,0.43,64.2,73248,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11967',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154833,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154833,34.13,0.38,66.9,73248,75,NULL,'W91PP, r, cor','UGC 11967',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154834,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154834,34.16,NULL,67.8,73248,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154835,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154835,34.17,NULL,68.2,73248,NULL,NULL,'Dipole + Quadrupole','UGC 11967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154836,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154836,34.17,NULL,68.3,73248,NULL,NULL,'Dipole','UGC 11967',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154837,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154837,34.22,NULL,69.9,73248,NULL,NULL,NULL,'UGC 11967',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154838,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ba',NULL,154838,42.62,0.06,1970,73249,70,NULL,'SIFTO','SNLS 06D4ba',0.7,'2011ApJS..192....1C',2011,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,333.898917,-18.22911,0.013,NULL,49731935704,777061495,12141585,NULL),(154839,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ba',NULL,154839,43.25,0.15,2630,73249,NULL,NULL,'SIFTO','SNLS 06D4ba',0.7,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154840,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ba',NULL,154840,43.32,0.25,2720,73249,70,NULL,'SALT 2','SNLS 06D4ba',0.7,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154841,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ba',NULL,154841,44.31,0.17,4290,73249,NULL,NULL,'SALT2','SNLS 06D4ba',0.7,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154842,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hu',NULL,154842,42.88,0.05,2210,73250,70,NULL,'SIFTO','[HSP2005] J221536.19-175019.81',0.7027,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.0003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.900791667,-17.83883,0.049,NULL,49786566430,777915100,12154923,NULL),(154843,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hu',NULL,154843,43.3,0.15,2680,73250,NULL,NULL,'SIFTO','[HSP2005] J221536.19-175019.81',0.7027,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154844,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hu',NULL,154844,43.43,0.2,2840,73250,70,NULL,'SALT 2','[HSP2005] J221536.19-175019.81',0.7027,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154845,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hu',NULL,154845,43.82,0.17,3410,73250,NULL,NULL,'SALT2','[HSP2005] J221536.19-175019.81',0.7027,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154846,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154846,31.74,0.8,22.3,73251,75,NULL,'B','NGC 7232',NULL,'1988NBGC.C....0000T',1988,1,2.6,'Confused HIPASS source','G',0.000018,NULL,'12.95',0.9,'SB(rs)a:       LLAGN','in a triple',NULL,NULL,NULL,1,333.908333,-45.85008,0,NULL,50692958105,792077470,12376210,12.95),(154847,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fe',NULL,154847,44.51,0.15,4020,73252,NULL,NULL,'SIFTO','SNLS 05D4fe HOST',0.984,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.917791667,-17.52844,0.045,NULL,49786458395,777913412,12154897,NULL),(154848,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fe',NULL,154848,48.38,0.17,23900,73252,NULL,NULL,'SALT2','SNLS 05D4fe HOST',0.984,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154849,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154849,33.77,0.44,56.8,73253,95,NULL,'Weighted Mean','NGC 7242',NULL,'1984ApJS...56...91D',1984,1,NULL,NULL,'GPair',0.000127,NULL,NULL,NULL,'E+:','Group member',NULL,NULL,NULL,1,333.91875,37.30056,0.737,NULL,55477344856,866833513,13544273,NULL),(154850,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154850,33.9,0.46,60.3,73253,95,NULL,'Michard 1979a','NGC 7242',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154851,'Faber-Jackson','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154851,34.94,0.63,97.3,73253,95,NULL,'Michard 1979b, c','NGC 7242',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154852,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 06800','RN',154852,39.01,0.3,605,73254,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06800',0.047749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154853,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 20412','RN',154853,42.32,0.27,2010,73255,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20412',0.444671,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154854,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 20412','RN',154854,42.32,0.27,2020,73255,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20412',0.444671,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154855,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 11129','RN',154855,37.99,0.23,360,73256,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10697 HOST',0.099112,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154856,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 10697','RN',154856,38.12,0.22,382,73256,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10697 HOST',0.099112,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154857,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 10697','RN',154857,38.2,0.08,396,73256,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10697 HOST',0.099112,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154858,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154858,38.27,0.46,451,73257,70,NULL,NULL,'2MASX J22154779-0905213',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000161,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,333.949167,-9.08939,0.129,NULL,49831022250,778609722,12165776,17.6),(154859,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS0909006','N',154859,40.58,0.31,1020,73258,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS0909006 HOST',0.2828,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154860,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154860,31.78,0.8,22.7,73259,75,NULL,NULL,'NGC 7233',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000023,NULL,'13.09',1.3,'SAB(r)a        HII','in a triple',NULL,NULL,NULL,1,333.954083333,-45.84644,0,NULL,50692960105,792077501,12376210,13.09),(154861,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154861,34.4,0.49,75.8,73260,75,NULL,'IR','ESO 467- G 034',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.05',0.5,'Sb?:           HII',NULL,NULL,NULL,NULL,1,333.953125,-27.51381,0,NULL,50534286294,789598223,12337472,15.05),(154862,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154862,34.54,0.53,81.1,73260,NULL,NULL,NULL,'ESO 467- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154863,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154863,34.58,0.2,82.4,73260,74.4,NULL,NULL,'ESO 467- G 034',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154864,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154864,34.59,0.52,82.9,73260,NULL,NULL,'Malmquist cor.','ESO 467- G 034',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154865,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154865,32.16,0.49,27,73261,75,NULL,'IR','NGC 7241',NULL,'2011yCatp016004901K',2011,1,3.4,NULL,'G',0.000003,NULL,'13.37',1.1,'SB(s)bc? pec','in a pair',NULL,NULL,NULL,1,333.9577917,19.23236,0.209,NULL,52222787819,815981059,12749704,13.37),(154866,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154866,33.69,0.43,54.8,73261,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7241',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154867,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154867,33.88,0.43,59.6,73261,75,NULL,'3.6 micron, color corrected','NGC 7241',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154868,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154868,34.17,0.2,68.2,73261,74.4,NULL,NULL,'NGC 7241',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154869,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS11alv','N',154869,39.19,0.1,603,73262,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11alv HOST',0.1438,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154870,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ej',NULL,154870,42.88,0.15,2370,73263,NULL,NULL,'SIFTO','SNLS 05D4ej HOST',0.585,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.968833333,-18.19572,0.013,NULL,49731989640,777062338,12141599,NULL),(154871,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ej',NULL,154871,42.94,0.14,2440,73263,70,NULL,'SALT 2','SNLS 05D4ej HOST',0.585,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154872,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ej',NULL,154872,42.97,0.05,2480,73263,70,NULL,'SIFTO','SNLS 05D4ej HOST',0.585,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154873,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ej',NULL,154873,43.48,0.17,3130,73263,NULL,NULL,'SALT2','SNLS 05D4ej HOST',0.585,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154874,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154874,32.02,0.8,25.3,73264,75,NULL,NULL,'NGC 7232B',NULL,'1988NBGC.C....0000T',1988,1,1.7,'Confused HIPASS source','G',0.000019,NULL,'13.9',1.5,'(R\'_2)SB(s)dm  LINER','in a triple',NULL,NULL,NULL,1,333.9685417,-45.78064,0,NULL,50726310208,792598597,12384353,13.9),(154875,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154875,35.17,0.49,108,73265,75,NULL,'IR','FGC 2381',NULL,'2011yCatp016004901K',2011,1,0.77,NULL,'G',0.000018,NULL,'16.4g',0.21,'Sc',NULL,NULL,NULL,NULL,1,333.969167,14.07944,0.177,NULL,52259714506,816558039,12758719,16.4),(154876,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154876,35.81,NULL,145,73265,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2381',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154877,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154877,35.83,NULL,147,73265,NULL,NULL,'Dipole + Quadrupole','FGC 2381',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154878,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154878,35.83,NULL,147,73265,NULL,NULL,NULL,'FGC 2381',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154879,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154879,35.85,NULL,148,73265,NULL,NULL,'Dipole','FGC 2381',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154880,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154880,38.08,0.46,414,73266,70,NULL,NULL,'SDSS J221554.87-073613.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,333.978625,-7.60364,0.177,NULL,49844776476,778824632,12169134,18.6),(154881,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154881,36.99,0.46,250,73267,70,NULL,NULL,'2MASX J22155505+1316198',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000171,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,333.979375,13.27219,0.189,NULL,52247627008,816369172,12755768,16.5),(154882,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ii',NULL,154882,43.5,0.07,2690,73268,70,NULL,'SIFTO','[HSP2005] J221555.64-173927.09',0.866,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.981875,-17.65753,0.017,NULL,49786505626,777914150,12154908,NULL),(154883,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ii',NULL,154883,43.66,0.22,2890,73268,70,NULL,'SALT 2','[HSP2005] J221555.64-173927.09',0.866,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154884,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ii',NULL,154884,43.71,0.15,2950,73268,NULL,NULL,'SIFTO','[HSP2005] J221555.64-173927.09',0.866,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154885,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ii',NULL,154885,45.56,0.17,6920,73268,NULL,NULL,'SALT2','[HSP2005] J221555.64-173927.09',0.866,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154886,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bi',NULL,154886,42.83,0.06,2070,73269,70,NULL,'SIFTO','SNLS 05D4bi HOST',0.775,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.985625,-17.98606,0.029,NULL,49786541240,777914706,12154917,NULL),(154887,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bi',NULL,154887,43.66,0.15,3030,73269,NULL,NULL,'SIFTO','SNLS 05D4bi HOST',0.775,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154888,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bi',NULL,154888,43.7,0.23,3100,73269,70,NULL,'SALT 2','SNLS 05D4bi HOST',0.775,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154889,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bi',NULL,154889,45.19,0.17,6160,73269,NULL,NULL,'SALT2','SNLS 05D4bi HOST',0.775,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154890,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154890,42.26,0.17,1760,73270,74.2,NULL,'SALT 2','[AGR2006] J221557.11-174143.9',0.613,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,333.988,-17.69553,0.017,NULL,49786478210,777913722,12154901,NULL),(154891,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an','R',154891,42.65,NULL,2100,73270,65,NULL,'MLCS17','[AGR2006] J221557.11-174143.9',0.613,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154892,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154892,42.91,0.29,2370,73270,65,NULL,'MLCS17','[AGR2006] J221557.11-174143.9',0.613,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154893,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154893,42.93,0.16,2380,73270,65,NULL,'SALT2','[AGR2006] J221557.11-174143.9',0.613,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154894,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154894,42.94,0.17,2400,73270,65,NULL,'MLCS2k2','[AGR2006] J221557.11-174143.9',0.613,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154895,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154895,42.96,0.06,2420,73270,70,NULL,NULL,'[AGR2006] J221557.11-174143.9',0.613,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154896,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154896,42.96,0.15,2420,73270,70,NULL,'SALT','[AGR2006] J221557.11-174143.9',0.613,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154897,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154897,43.06,0.17,2540,73270,70,NULL,'SALT 2','[AGR2006] J221557.11-174143.9',0.613,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154898,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154898,43.06,0.39,2540,73270,65,NULL,'MLCS31','[AGR2006] J221557.11-174143.9',0.613,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154899,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154899,43.08,0.38,2560,73270,65,NULL,'MLCS2k2','[AGR2006] J221557.11-174143.9',0.613,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154900,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154900,43.11,0.12,2590,73270,65,NULL,'SALT','[AGR2006] J221557.11-174143.9',0.613,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154901,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154901,43.11,0.19,2600,73270,65,NULL,'SALT2','[AGR2006] J221557.11-174143.9',0.613,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154902,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154902,43.15,0.15,2640,73270,NULL,NULL,'SIFTO','[AGR2006] J221557.11-174143.9',0.613,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154903,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154903,43.23,0.05,2740,73270,65,NULL,'SALT','[AGR2006] J221557.11-174143.9',0.613,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154904,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154904,43.3,0.17,2840,73270,NULL,NULL,'SALT2','[AGR2006] J221557.11-174143.9',0.613,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154905,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4an',NULL,154905,43.35,0.05,2900,73270,70,NULL,'SALT 2','[AGR2006] J221557.11-174143.9',0.613,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154906,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154906,35.61,0.14,132,73271,70,NULL,NULL,'CGCG 428-063',NULL,'2015arXiv151105856S',2015,1,0.75,'MCG RA is +1 minute in error.','G',0.000087,NULL,'14.5g',0.67,'S0^-',NULL,NULL,NULL,NULL,1,333.9977917,14.12497,0.197,NULL,52259713842,816558028,12758719,14.5),(154907,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154907,35.61,0.14,132,73272,70,NULL,NULL,'2MASX J22155949+1327158',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000179,NULL,'16.3g',0.24,'E0',NULL,NULL,NULL,NULL,1,333.9979583,13.45428,0.185,NULL,52247448597,816366384,12755724,16.3),(154908,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154908,36.05,0.49,162,73273,70,NULL,NULL,'2MASX J22160091-5808566',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000103,NULL,'15.65',0.48,'S0',NULL,NULL,NULL,NULL,1,334.00375,-58.14906,0,NULL,48675181816,760549715,11883589,15.65),(154909,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SCP 06A04',NULL,154909,44.59,0.05,3780,73274,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','CXO J221601.1-173722',1.192,'2012ApJ...746...85S',2012,1,NULL,NULL,'G',NULL,NULL,'22.2i',NULL,NULL,NULL,NULL,NULL,NULL,1,334.004917,-17.62294,0.017,NULL,49786518026,777914344,12154911,22.2),(154910,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154910,32.84,0.8,37.1,73275,75,NULL,'MAT, I','ESO 237- G 049',NULL,'1997ApJS..109..333W',1997,1,2.16,NULL,'G',0.00002,NULL,'14.53',0.27,'SBcd? sp',NULL,NULL,NULL,NULL,1,334.012583,-47.66222,0,NULL,50624463272,791007238,12359488,14.53),(154911,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154911,32.11,0.32,26.4,73275,85,NULL,'I, inv','ESO 237- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154912,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154912,32.14,0.32,26.8,73275,85,NULL,'I, raw','ESO 237- G 049',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154913,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154913,32.39,0.43,30,73275,75,NULL,'MAT, I, inv','ESO 237- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154914,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154914,32.43,0.43,30.6,73275,75,NULL,'MAT, I, raw','ESO 237- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154915,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154915,32.6,0.43,33.1,73275,75,NULL,'MAT, I, cor','ESO 237- G 049',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154916,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154916,32.65,0.4,33.9,73275,73,NULL,'opt','ESO 237- G 049',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154917,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154917,32.73,NULL,35.1,73275,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 237- G 049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154918,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154918,32.74,NULL,35.3,73275,NULL,NULL,'Dipole + Quadrupole','ESO 237- G 049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154919,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154919,32.74,0.45,35.4,73275,NULL,NULL,'Malmquist cor.','ESO 237- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154920,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154920,32.75,NULL,35.5,73275,NULL,NULL,'Dipole','ESO 237- G 049',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154921,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154921,32.76,0.4,35.6,73275,NULL,NULL,NULL,'ESO 237- G 049',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154922,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154922,32.81,NULL,36.4,73275,NULL,NULL,NULL,'ESO 237- G 049',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154923,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154923,32.92,0.42,38.3,73275,NULL,NULL,NULL,'ESO 237- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154924,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154924,32.96,0.2,39.1,73275,74.4,NULL,NULL,'ESO 237- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154925,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154925,37.7,0.23,347,73276,70,NULL,NULL,'2MASX J22160335-0813080',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.013916667,-8.219,0.161,NULL,49844651503,778822679,12169104,17.6),(154926,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154926,37.94,0.46,387,73277,70,NULL,NULL,'2MASX J22160336+0012474',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,334.013916667,0.21319,0.145,NULL,52153933645,814905213,12732893,17.2),(154927,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154927,37.55,0.46,323,73278,70,NULL,NULL,'SDSS J221603.61-092147.9',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.015083333,-9.36331,0.133,NULL,49831331511,778614554,12165852,17.6),(154928,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154928,36.86,0.46,236,73279,70,NULL,NULL,'2MASX J22160462-0801220',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,334.0192917,-8.02292,0.165,NULL,49844677228,778823081,12169110,16.7),(154929,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154929,34.71,0.8,87.5,73280,75,NULL,'MAT, I','ESO 533- G 006',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.23',0.5,'Sb','in a pair',NULL,NULL,NULL,1,334.020375,-26.68025,0,NULL,50536216064,789628376,12337943,14.23),(154930,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154930,34.42,0.32,76.5,73280,85,NULL,'I, raw','ESO 533- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154931,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154931,34.46,0.43,77.9,73280,75,NULL,'MAT, I, raw','ESO 533- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154932,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154932,34.47,0.32,78.4,73280,85,NULL,'I, inv','ESO 533- G 006',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154933,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154933,34.7,0.43,87,73280,75,NULL,'MAT, I, inv','ESO 533- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154934,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154934,34.72,0.43,88.1,73280,75,NULL,'MAT, I, cor','ESO 533- G 006',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154935,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154935,34.77,0.5,89.9,73280,NULL,NULL,'Malmquist cor.','ESO 533- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154936,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154936,34.84,0.48,93,73280,NULL,NULL,NULL,'ESO 533- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154937,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154937,34.85,0.4,93.2,73280,NULL,NULL,'mean','ESO 533- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154938,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154938,34.88,0.2,94.6,73280,74.4,NULL,NULL,'ESO 533- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154939,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154939,34.95,0.47,97.9,73280,NULL,NULL,'H','ESO 533- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154940,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154940,35.02,0.45,101,73280,NULL,NULL,'K','ESO 533- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154941,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154941,35.09,0.46,104,73280,NULL,NULL,'J','ESO 533- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154942,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154942,34.9,0.8,95.5,73281,75,NULL,'MAT, I','ESO 467- G 036',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.58',0.7,'SA(s)bc',NULL,NULL,NULL,NULL,1,334.02575,-30.36889,0,NULL,50545696055,789776500,12340257,14.58),(154943,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154943,34.66,0.32,85.5,73281,85,NULL,'I, raw','ESO 467- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154944,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154944,34.71,0.32,87.6,73281,85,NULL,'I, inv','ESO 467- G 036',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154945,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154945,34.71,0.43,87.7,73281,75,NULL,'MAT, I, raw','ESO 467- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154946,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154946,34.82,0.59,92,73281,NULL,NULL,'Malmquist cor.','ESO 467- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154947,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154947,34.93,0.56,97,73281,NULL,NULL,NULL,'ESO 467- G 036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154948,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154948,34.96,0.43,98.1,73281,75,NULL,'MAT, I, inv','ESO 467- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154949,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154949,34.97,0.2,98.6,73281,74.4,NULL,NULL,'ESO 467- G 036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154950,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154950,35.02,0.43,101,73281,75,NULL,'MAT, I, cor','ESO 467- G 036',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154951,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cj',NULL,154951,39.89,0.03,749,73282,70,NULL,'SIFTO','[HSP2005] J221606.66-174216.72',0.27,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.02775,-17.70464,0.017,NULL,49786503423,777914115,12154908,NULL),(154952,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cj',NULL,154952,40.58,0.11,1030,73282,70,NULL,'SALT 2','[HSP2005] J221606.66-174216.72',0.27,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154953,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cj',NULL,154953,40.64,0.15,1060,73282,NULL,NULL,'SIFTO','[HSP2005] J221606.66-174216.72',0.27,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154954,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cj',NULL,154954,42.16,0.17,2130,73282,NULL,NULL,'SALT2','[HSP2005] J221606.66-174216.72',0.27,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154955,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154955,36.54,0.69,204,73283,70,NULL,NULL,'2MASX J22160676-0921020',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.0001,NULL,'16.65',0.28,NULL,NULL,NULL,NULL,NULL,1,334.028125,-9.35067,0.133,NULL,49831330992,778614546,12165852,16.65),(154956,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154956,38.04,0.16,406,73284,70,NULL,NULL,'2MASXi J2216068-091840',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000166,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,334.028625,-9.31122,0.117,NULL,49831336902,778614639,12165853,18.3),(154957,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',154957,38.04,0.16,406,73285,70,NULL,NULL,'2MASX J22160703-0920190',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000152,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,334.029208333,-9.33872,0.133,NULL,49831330840,778614544,12165852,18.2),(154958,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154958,33.12,0.11,41.6,73286,72,NULL,NULL,'IC 5179',0.01141,'2008ApJ...689..377W',2008,1,2.3,'1995ApJS...98..129K has V = 4990 +- 80 km/s; 6dF DR1 has V = 3342 km/s.','G',0.000033,NULL,'12.38',1.1,'SA(rs)bc   HII;LIRG',NULL,NULL,NULL,NULL,1,334.037917,-36.84372,0,NULL,50557836499,789966195,12343221,12.38),(154959,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154959,33.19,0.03,43,73286,72,NULL,NULL,'IC 5179',0.01141,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154960,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154960,33.2,0.05,43.2,73286,72,NULL,NULL,'IC 5179',0.01141,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154961,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154961,33.18,0.08,43.3,73286,74.4,NULL,NULL,'IC 5179',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154962,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154962,33.26,0.19,44.4,73286,72,NULL,NULL,'IC 5179',0.01141,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154963,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154963,33.25,0.17,44.7,73286,70.8,NULL,NULL,'IC 5179',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154964,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154964,33.29,0.25,45,73286,70,NULL,'SALT 2','IC 5179',0.01141,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154965,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154965,33.27,0.02,45,73286,72,NULL,'M(H) = -18.317 mag','IC 5179',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154966,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154966,33.31,0.22,45.5,73286,73.8,NULL,'SALT 2 (SNANA)','IC 5179',0.0108,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154967,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154967,33.34,0.28,46.1,73286,65,NULL,'MLCS31','IC 5179',0.01141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154968,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154968,33.35,0.02,46.2,73286,72,NULL,NULL,'IC 5179',0.01141,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154969,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154969,33.47,0.09,48.3,73286,65,NULL,'MLCS2k2','IC 5179',0.01141,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154970,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154970,33.53,0.3,50.2,73286,65,NULL,'SALT2','IC 5179',0.01141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154971,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154971,33.57,0.28,51.2,73286,65,NULL,'MLCS17','IC 5179',0.01141,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154972,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 1999ee',NULL,154972,33.61,0.14,52.7,73286,60,NULL,NULL,'IC 5179',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154973,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154973,33.18,0.8,43.3,73286,75,NULL,'MAT, I','IC 5179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154974,'Sosies','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154974,33.32,0.17,46.1,73286,NULL,NULL,NULL,'IC 5179',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154975,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154975,32.61,0.43,33.3,73286,75,NULL,'3.6 micron, color + selection bias corrected','IC 5179',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154976,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154976,32.76,0.45,35.6,73286,NULL,NULL,'K','IC 5179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154977,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154977,32.78,0.47,36,73286,NULL,NULL,'H','IC 5179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154978,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154978,32.82,0.43,36.6,73286,75,NULL,'3.6 micron, color corrected','IC 5179',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154979,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154979,32.82,0.46,36.7,73286,NULL,NULL,'J','IC 5179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154980,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154980,32.86,0.42,37.3,73286,NULL,18.48,'3.6 micron','IC 5179',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154981,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154981,32.89,0.32,37.8,73286,85,NULL,'I, raw','IC 5179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154982,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154982,32.91,0.4,38.2,73286,NULL,NULL,'mean','IC 5179',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154983,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154983,32.92,0.43,38.3,73286,75,NULL,'MAT, I, raw','IC 5179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154984,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154984,32.96,0.32,39,73286,85,NULL,'I, inv','IC 5179',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154985,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154985,33.09,0.43,41.4,73286,75,NULL,'MAT, I, cor','IC 5179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154986,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154986,33.09,0.4,41.5,73286,75,NULL,'HOSTS SN 1999ee','IC 5179',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154987,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154987,33.18,0.08,43.3,73286,74.4,NULL,NULL,'IC 5179',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154988,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154988,33.2,0.43,43.6,73286,75,NULL,'MAT, I, inv','IC 5179',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154989,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154989,33.26,0.46,44.8,73286,NULL,NULL,'Malmquist cor.','IC 5179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154990,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,154990,33.41,0.43,48.2,73286,NULL,NULL,NULL,'IC 5179',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154991,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gg',NULL,154991,41.73,0.12,1560,73287,70,NULL,'SALT 2','[HSP2005] J221609.26-171739.98',0.4238,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.0004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.038625,-17.29444,0.041,NULL,49753691789,777401434,12146897,NULL),(154992,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gg',NULL,154992,41.74,0.15,1570,73287,NULL,NULL,'SIFTO','[HSP2005] J221609.26-171739.98',0.4238,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154993,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gg',NULL,154993,42.17,0.05,1910,73287,70,NULL,'SIFTO','[HSP2005] J221609.26-171739.98',0.4238,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154994,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gg',NULL,154994,43.26,0.17,3160,73287,NULL,NULL,'SALT2','[HSP2005] J221609.26-171739.98',0.4238,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154995,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154995,41.82,0.17,1570,73288,74.2,NULL,'SALT 2','[AGR2006] J221609.91-180439.1',0.468,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.041333,-18.07756,0.029,NULL,49786545221,777914769,12154918,NULL),(154996,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154996,42.49,0.16,2140,73288,70,NULL,'SALT','[AGR2006] J221609.91-180439.1',0.468,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154997,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154997,42.54,0.16,2190,73288,70,NULL,'SALT 2','[AGR2006] J221609.91-180439.1',0.468,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154998,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154998,42.57,0.13,2230,73288,65,NULL,'SALT','[AGR2006] J221609.91-180439.1',0.468,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(154999,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,154999,42.61,0.15,2260,73288,NULL,NULL,'SIFTO','[AGR2006] J221609.91-180439.1',0.468,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155000,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,155000,42.71,0.07,2370,73288,70,NULL,NULL,'[AGR2006] J221609.91-180439.1',0.468,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155001,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au','R',155001,42.72,NULL,2380,73288,65,NULL,'SALT','[AGR2006] J221609.91-180439.1',0.468,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155002,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,155002,43.25,0.17,3040,73288,NULL,NULL,'SALT2','[AGR2006] J221609.91-180439.1',0.468,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155003,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4au',NULL,155003,43.46,0.04,3350,73288,70,NULL,'SALT 2','[AGR2006] J221609.91-180439.1',0.468,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155004,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155004,38.65,0.46,538,73289,70,NULL,NULL,'SDSS J221611.96+002259.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000126,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,334.049833,0.38333,0.145,NULL,52154046740,814906980,12732921,18.7),(155005,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155005,38.04,0.16,406,73290,70,NULL,NULL,'2MASX J22161230-0921460',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000182,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,334.051167,-9.36269,0.133,NULL,49831324494,778614445,12165850,18),(155006,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155006,37.97,0.46,392,73291,70,NULL,NULL,'2MASX J22161312-0029111',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000195,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,334.0545417,-0.48631,0.205,NULL,49802073462,778157397,12158709,17.6),(155007,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155007,35.43,0.49,122,73292,70,NULL,NULL,'2MASX J22161338-5925106',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.80',0.55,'S',NULL,NULL,NULL,NULL,1,334.055708333,-59.41967,0,NULL,48677811544,760590805,11884231,15.8),(155008,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155008,37.79,0.46,362,73293,70,NULL,NULL,'2MASX J22161426-0806160',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000144,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,334.0595,-8.10453,0.165,NULL,49844674611,778823040,12169110,17.8),(155009,'SNII optical','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cw',NULL,155009,38.52,0.47,380,73294,NULL,NULL,'SEAM','APMUKS(BJ) B221331.31-172920.9',0.1543,'2009ApJ...694.1067P',2009,1,0.13,NULL,'G',NULL,NULL,'17.8r',0.12,NULL,NULL,NULL,NULL,NULL,1,334.05975,-17.23947,0.041,NULL,49753747728,777402308,12146911,17.8),(155010,'SNII optical','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cw',NULL,155010,39.11,0.55,664,73294,NULL,NULL,NULL,'APMUKS(BJ) B221331.31-172920.9',NULL,'2006ApJ...645..841N',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155011,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd','R',155011,42.6,NULL,1850,73295,65,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.0602917,-17.39567,0.029,NULL,49752976088,777390251,12146722,NULL),(155012,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155012,42.86,0.2,2080,73295,74.2,NULL,'SALT 2','[HSP2005] J221614.47-172344.37',0.791,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155013,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155013,43.27,0.07,2510,73295,70,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155014,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155014,43.33,0.19,2590,73295,70,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155015,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155015,43.35,0.08,2620,73295,70,NULL,NULL,'[HSP2005] J221614.47-172344.37',0.791,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155016,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155016,43.5,0.17,2790,73295,65,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155017,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155017,43.6,0.23,2920,73295,70,NULL,'SALT 2','[HSP2005] J221614.47-172344.37',0.791,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155018,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155018,43.6,0.15,2930,73295,NULL,NULL,'SIFTO','[HSP2005] J221614.47-172344.37',0.791,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155019,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155019,43.62,0.07,2960,73295,65,NULL,'SALT','[HSP2005] J221614.47-172344.37',0.791,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155020,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155020,43.64,0.23,2980,73295,65,NULL,'MLCS17','[HSP2005] J221614.47-172344.37',0.791,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155021,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155021,43.67,0.18,3030,73295,65,NULL,'MLCS2k2','[HSP2005] J221614.47-172344.37',0.791,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155022,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155022,43.68,0.18,3040,73295,65,NULL,'SALT2','[HSP2005] J221614.47-172344.37',0.791,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155023,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155023,43.75,0.2,3140,73295,65,NULL,'MLCS31','[HSP2005] J221614.47-172344.37',0.791,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155024,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155024,43.75,0.22,3140,73295,65,NULL,'SALT2','[HSP2005] J221614.47-172344.37',0.791,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155025,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155025,43.75,0.19,3150,73295,65,NULL,'MLCS2k2','[HSP2005] J221614.47-172344.37',0.791,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155026,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4fd',NULL,155026,44.93,0.17,5390,73295,NULL,NULL,'SALT2','[HSP2005] J221614.47-172344.37',0.791,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155027,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155027,38.04,0.16,406,73296,70,NULL,NULL,'2MASX J22161500-0910050',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.00015,NULL,'16.5g',0.34,'AGN',NULL,NULL,NULL,NULL,1,334.062375,-9.16822,0.129,NULL,49831023749,778609746,12165777,16.5),(155028,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155028,39.56,0.13,659,73297,74.2,NULL,'SALT 2','SDSS J221616.44+004228.0',0.24,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0005,NULL,'20.7g',0.04,NULL,NULL,NULL,NULL,NULL,1,334.0685,0.70778,0.137,NULL,52153851712,814903933,12732873,20.7),(155029,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155029,39.97,0.04,796,73297,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03451, SN 2005gf','SDSS J221616.44+004228.0',0.24,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155030,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155030,39.61,0.09,836,73297,70,NULL,'Hubble residual -0.25 for z0.25000','SDSS J221616.44+004228.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155031,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155031,40.29,0.09,922,73297,65,NULL,'SALT2','SDSS J221616.44+004228.0',0.24,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155032,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155032,40.29,0.14,922,73297,70,NULL,'SALT 2','SDSS J221616.44+004228.0',0.24,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155033,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03451','R',155033,40.35,0.2,941,73297,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gf','SDSS J221616.44+004228.0',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155034,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155034,40.38,NULL,960,73297,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 03451, SN 2005gf','SDSS J221616.44+004228.0',0.24,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155035,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155035,40.5,0.12,1010,73297,65,NULL,'MLCS2k2','SDSS J221616.44+004228.0',0.24,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155036,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03451','R',155036,40.51,0.13,1010,73297,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gf','SDSS J221616.44+004228.0',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155037,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155037,40.22,0.1,1110,73297,70,NULL,'SALT 2','SDSS J221616.44+004228.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155038,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gf',NULL,155038,40.24,0.1,1120,73297,70,NULL,'SALT 2, Malmquist cor.','SDSS J221616.44+004228.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155039,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155039,38.04,0.16,406,73298,70,NULL,NULL,'SDSS J221617.16-091831.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000169,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,334.0715417,-9.30864,0.133,NULL,49831321541,778614399,12165849,18.4),(155040,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155040,35.7,0.48,138,73299,70,NULL,NULL,'FAIRALL 1006',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'16.44',0.25,'S',NULL,NULL,NULL,NULL,1,334.080166667,-48.53167,0,NULL,50623505799,790992278,12359254,16.44),(155041,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155041,35.52,0.64,127,73300,70,NULL,NULL,'2MASX J22161924-8112527',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.9b',0.19,NULL,NULL,NULL,NULL,NULL,1,334.0805417,-81.21464,0.469,NULL,48563731807,758808309,11856379,16.9),(155042,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155042,35.71,0.64,138,73301,70,NULL,NULL,'2MASX J22161948-7853047',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.7b',0.17,NULL,NULL,NULL,NULL,NULL,1,334.080917,-78.88472,0.481,NULL,48560738667,758761541,11855649,16.7),(155043,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ff',NULL,155043,41.01,0.17,1140,73302,NULL,NULL,'SALT2','SNLS 05D4ff HOST',0.402,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.084,-18.04256,0.029,NULL,49786537343,777914645,12154916,NULL),(155044,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ff',NULL,155044,41.58,0.11,1480,73302,70,NULL,'SALT 2','SNLS 05D4ff HOST',0.402,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155045,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ff',NULL,155045,41.65,0.15,1530,73302,NULL,NULL,'SIFTO','SNLS 05D4ff HOST',0.402,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155046,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ff',NULL,155046,42.01,0.03,1800,73302,70,NULL,'SALT2','SNLS 05D4ff HOST',0.402,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155047,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4id','N',155047,43,0.06,2250,73303,70,NULL,'SIFTO','SNLS 04D4id HOST',0.769,'2011ApJS..192....1C',2011,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155048,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4id','N',155048,43.74,0.15,3170,73303,NULL,NULL,'SIFTO','SNLS 04D4id HOST',0.769,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155049,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4id','N',155049,43.96,0.23,3500,73303,70,NULL,'SALT 2','SNLS 04D4id HOST',0.769,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155050,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4id','N',155050,44.95,0.17,5530,73303,NULL,NULL,'SALT2','SNLS 04D4id HOST',0.769,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155051,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155051,38.04,0.16,406,73304,70,NULL,NULL,'2MASX J22162443-0918338',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000181,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,334.101875,-9.30942,0.133,NULL,49831319940,778614374,12165849,16.8),(155052,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155052,38.29,0.46,456,73305,70,NULL,NULL,'SDSS J221624.74-093510.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000137,NULL,'18.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.103125,-9.58631,0.149,NULL,49831464031,778616625,12165884,18.7),(155053,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155053,35.63,0.53,134,73306,70,NULL,NULL,'2MASX J22162494-8033306',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.2b',0.29,NULL,NULL,NULL,NULL,NULL,1,334.103875,-80.55853,0.441,NULL,48562971555,758796430,11856194,16.2),(155054,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bf',NULL,155054,42.78,0.15,2260,73307,70,NULL,'SALT 2','SNLS 05D4bf',0.589,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,334.1097917,-18.23206,0.013,NULL,49731972743,777062074,12141594,NULL),(155055,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bf',NULL,155055,42.8,0.15,2280,73307,NULL,NULL,'SIFTO','SNLS 05D4bf',0.589,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155056,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bf',NULL,155056,42.85,0.04,2340,73307,70,NULL,'SIFTO','SNLS 05D4bf',0.589,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155057,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bf',NULL,155057,43.27,0.17,2840,73307,NULL,NULL,'SALT2','SNLS 05D4bf',0.589,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155058,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ek',NULL,155058,42.24,0.13,1830,73308,70,NULL,'SALT 2','SNLS 05D4ek HOST',0.536,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.114667,-17.73631,0.017,NULL,49786624881,777916013,12154937,NULL),(155059,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ek',NULL,155059,42.38,0.15,1950,73308,NULL,NULL,'SIFTO','SNLS 05D4ek HOST',0.536,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155060,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ek',NULL,155060,42.69,0.04,2240,73308,70,NULL,'SIFTO','SNLS 05D4ek HOST',0.536,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155061,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4ek',NULL,155061,42.75,0.17,2310,73308,NULL,NULL,'SALT2','SNLS 05D4ek HOST',0.536,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155062,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155062,37.59,0.46,329,73309,70,NULL,NULL,'2MASXi J2216278-094839',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.1162083,-9.81119,0.137,NULL,49830854726,778607105,12165736,17.9),(155063,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155063,32.7,0.54,34.7,73310,70,NULL,NULL,'IC 1438',NULL,'2014MNRAS.445.2677S',2014,1,2.4,NULL,'G',0.00001,NULL,'13.19',2,'(R_1R\'_2)SAB(r)a HII','in a triple',NULL,NULL,NULL,1,334.1212083,-21.43069,0.061,NULL,50199577391,784368396,12255756,13.19),(155064,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155064,32.64,0.8,33.8,73310,75,NULL,NULL,'IC 1438',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155065,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155065,32.89,0.8,37.9,73311,75,NULL,NULL,'ESO 108- G 023',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00001,NULL,'13.42',2.3,'SAB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,334.133625,-64.38906,0,NULL,49278770299,769980785,12030949,13.42),(155066,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4af',NULL,155066,42.26,0.04,1890,73312,70,NULL,'SIFTO','SNLS 05D4af HOST',0.499,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.138083,-18.00492,0.049,NULL,49786603005,777915671,12154932,NULL),(155067,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4af',NULL,155067,42.32,0.13,1950,73312,70,NULL,'SALT 2','SNLS 05D4af HOST',0.499,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155068,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4af',NULL,155068,42.38,0.15,2000,73312,NULL,NULL,'SIFTO','SNLS 05D4af HOST',0.499,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155069,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4af',NULL,155069,42.72,0.17,2330,73312,NULL,NULL,'SALT2','SNLS 05D4af HOST',0.499,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155070,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155070,42.68,0.27,1890,73313,74.2,NULL,'SALT 2','[HSP2005] J221634.60-171613.55',0.818,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.144167,-17.27044,0.041,NULL,49753715609,777401806,12146903,NULL),(155071,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn','R',155071,43.2,NULL,2400,73313,65,NULL,'SALT','[HSP2005] J221634.60-171613.55',0.818,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155072,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155072,43.53,0.3,2800,73313,70,NULL,NULL,'[HSP2005] J221634.60-171613.55',0.818,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155073,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155073,43.57,0.56,2850,73313,70,NULL,'SALT','[HSP2005] J221634.60-171613.55',0.818,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155074,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155074,43.73,0.55,3060,73313,65,NULL,'SALT','[HSP2005] J221634.60-171613.55',0.818,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155075,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155075,43.8,0.2,3160,73313,65,NULL,'SALT','[HSP2005] J221634.60-171613.55',0.818,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155076,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cn',NULL,155076,44.14,0.25,3710,73313,65,NULL,'MLCS2k2','[HSP2005] J221634.60-171613.55',0.818,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155077,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155077,38.04,0.16,406,73314,70,NULL,NULL,'2MASX J22163544-0919128',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000156,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.147666667,-9.32014,0.133,NULL,49831049004,778610140,12165783,17.9),(155078,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4fx',NULL,155078,42.58,0.05,2020,73315,70,NULL,'SIFTO','SNLS 04D4fx HOST',0.629,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.158917,-18.06636,0.029,NULL,49786421827,777912841,12154888,NULL),(155079,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4fx',NULL,155079,42.75,0.15,2180,73315,NULL,NULL,'SIFTO','SNLS 04D4fx HOST',0.629,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155080,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4fx',NULL,155080,42.85,0.18,2280,73315,70,NULL,'SALT 2','SNLS 04D4fx HOST',0.629,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155081,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4fx',NULL,155081,44.18,0.17,4200,73315,NULL,NULL,'SALT2','SNLS 04D4fx HOST',0.629,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155082,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155082,37.22,0.58,279,73316,70,NULL,NULL,'2MASX J22163823-4804568',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'16.57',0.18,NULL,NULL,NULL,NULL,NULL,1,334.159375,-48.08242,0,NULL,50623434800,790991168,12359237,16.57),(155083,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155083,34.59,0.61,82.9,73317,70,NULL,NULL,'IC 1439',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00003,NULL,'15.00',0.9,'(R_1R\'_2)SB(s)a','in a triple',NULL,NULL,NULL,1,334.16725,-21.48594,0.061,NULL,50199745300,784371020,12255797,15),(155084,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg','R',155084,41.82,NULL,1450,73318,65,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.167458333,-18.16439,0.029,NULL,49732093261,777063957,12141624,NULL),(155085,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155085,41.84,0.17,1470,73318,74.2,NULL,'SALT 2','[AGR2006] J221640.18-180951.8',0.592,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155086,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155086,42.52,0.2,2000,73318,70,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155087,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155087,42.56,0.09,2040,73318,70,NULL,NULL,'[AGR2006] J221640.18-180951.8',0.592,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155088,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155088,42.56,0.24,2040,73318,65,NULL,'MLCS2k2','[AGR2006] J221640.18-180951.8',0.592,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155089,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155089,42.57,0.14,2050,73318,65,NULL,'SALT2','[AGR2006] J221640.18-180951.8',0.592,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155090,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155090,42.57,0.15,2050,73318,NULL,NULL,'SIFTO','[AGR2006] J221640.18-180951.8',0.592,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155091,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155091,42.59,0.17,2070,73318,70,NULL,'SALT 2','[AGR2006] J221640.18-180951.8',0.592,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155092,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155092,42.63,0.05,2110,73318,70,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155093,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155093,42.66,0.17,2140,73318,65,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155094,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155094,42.7,0.19,2170,73318,65,NULL,'SALT2','[AGR2006] J221640.18-180951.8',0.592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155095,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155095,42.83,0.23,2320,73318,65,NULL,'MLCS17','[AGR2006] J221640.18-180951.8',0.592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155096,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155096,42.85,0.08,2340,73318,65,NULL,'SALT','[AGR2006] J221640.18-180951.8',0.592,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155097,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155097,42.87,0.23,2350,73318,65,NULL,'MLCS2k2','[AGR2006] J221640.18-180951.8',0.592,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155098,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155098,42.91,0.26,2400,73318,65,NULL,'MLCS31','[AGR2006] J221640.18-180951.8',0.592,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155099,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4gg',NULL,155099,43.79,0.17,3600,73318,NULL,NULL,'SALT2','[AGR2006] J221640.18-180951.8',0.592,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155100,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155100,38.04,0.16,406,73319,70,NULL,NULL,'2MASX J22164131-0914138',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.2g',0.35,'E0',NULL,NULL,NULL,NULL,1,334.172125,-9.23731,0.137,NULL,49831070201,778610471,12165788,16.2),(155101,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155101,43.05,0.06,2220,73320,70,NULL,'SIFTO','SNLS 05D4fg HOST',0.839,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.1722917,-17.59547,0.029,NULL,49752997441,777390585,12146727,NULL),(155102,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155102,43.74,0.15,3050,73320,NULL,NULL,'SIFTO','SNLS 05D4fg HOST',0.839,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155103,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155103,43.76,NULL,3080,73320,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4fg HOST',0.839,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155104,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155104,43.78,0.2,3100,73320,70,NULL,'SALT 2','SNLS 05D4fg HOST',0.839,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155105,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4fg',NULL,155105,44.37,0.17,4070,73320,NULL,NULL,'SALT2','SNLS 05D4fg HOST',0.839,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155106,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ib',NULL,155106,42.37,0.05,1750,73321,70,NULL,'SIFTO','SNLS 04D4ib HOST',0.699,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.1737917,-18.10508,0.029,NULL,49731879007,777060609,12141572,NULL),(155107,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ib',NULL,155107,43.17,0.15,2530,73321,NULL,NULL,'SIFTO','SNLS 04D4ib HOST',0.699,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155108,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ib',NULL,155108,43.26,0.18,2640,73321,70,NULL,'SALT 2','SNLS 04D4ib HOST',0.699,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155109,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ib',NULL,155109,44.63,0.17,4950,73321,NULL,NULL,'SALT2','SNLS 04D4ib HOST',0.699,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155110,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155110,41.37,0.17,1110,73322,NULL,NULL,'SALT2','[HSP2005] J221641.87-175534.54',0.695,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.1744583,-17.92625,0.049,NULL,49786606162,777915721,12154933,NULL),(155111,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155111,42.48,0.21,1850,73322,74.2,NULL,'SALT 2','[HSP2005] J221641.87-175534.54',0.695,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155112,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz','R',155112,42.51,NULL,1870,73322,65,NULL,'MLCS17','[HSP2005] J221641.87-175534.54',0.695,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155113,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155113,42.98,0.22,2330,73322,65,NULL,'MLCS2k2','[HSP2005] J221641.87-175534.54',0.695,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155114,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155114,42.98,0.31,2330,73322,65,NULL,'MLCS17','[HSP2005] J221641.87-175534.54',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155115,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155115,43.02,0.09,2370,73322,70,NULL,NULL,'[HSP2005] J221641.87-175534.54',0.695,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155116,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155116,43.1,0.34,2460,73322,65,NULL,'MLCS31','[HSP2005] J221641.87-175534.54',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155117,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155117,43.11,0.33,2470,73322,65,NULL,'MLCS2k2','[HSP2005] J221641.87-175534.54',0.695,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155118,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155118,43.14,0.15,2500,73322,NULL,NULL,'SIFTO','[HSP2005] J221641.87-175534.54',0.695,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155119,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155119,43.15,0.2,2520,73322,65,NULL,'SALT2','[HSP2005] J221641.87-175534.54',0.695,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155120,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155120,43.16,0.18,2530,73322,70,NULL,'SALT','[HSP2005] J221641.87-175534.54',0.695,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155121,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155121,43.28,0.28,2670,73322,70,NULL,'SALT 2','[HSP2005] J221641.87-175534.54',0.695,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155122,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155122,43.29,0.06,2680,73322,70,NULL,'SALT2','[HSP2005] J221641.87-175534.54',0.695,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155123,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155123,43.33,0.07,2740,73322,65,NULL,'SALT','[HSP2005] J221641.87-175534.54',0.695,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155124,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155124,43.34,0.15,2750,73322,65,NULL,'SALT','[HSP2005] J221641.87-175534.54',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155125,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4cz',NULL,155125,43.41,0.23,2830,73322,65,NULL,'SALT2','[HSP2005] J221641.87-175534.54',0.695,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155126,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 20068','RN',155126,43.07,0.26,2910,73323,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20068',0.409815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155127,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 20068','RN',155127,43.15,0.25,3030,73323,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20068',0.409815,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155128,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155128,32.74,0.8,35.3,73324,75,NULL,'MAT, I','ESO 289- G 010',NULL,'1997ApJS..109..333W',1997,1,2.46,NULL,'G',0.000017,NULL,'14.76',0.26,'SB(s)d? sp',NULL,NULL,NULL,NULL,1,334.180417,-47.11869,0,NULL,50692852466,792075819,12376184,14.76),(155129,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155129,32.67,0.8,34.3,73324,75,NULL,NULL,'ESO 289- G 010',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155130,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155130,32.3,0.4,28.8,73324,73,NULL,'IR','ESO 289- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155131,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155131,32.3,0.4,28.8,73324,75,NULL,NULL,'ESO 289- G 010',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155132,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155132,32.51,0.4,31.8,73324,73,NULL,'opt','ESO 289- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155133,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155133,32.72,0.4,35,73324,NULL,NULL,NULL,'ESO 289- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155134,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155134,32.72,0.4,35,73324,73,NULL,'opt','ESO 289- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155135,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155135,32.76,0.32,35.7,73324,85,NULL,'I, raw','ESO 289- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155136,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155136,32.76,0.32,35.7,73324,85,NULL,'I, inv','ESO 289- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155137,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155137,32.81,0.46,36.5,73324,NULL,NULL,'Malmquist cor.','ESO 289- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155138,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155138,32.91,0.43,38.2,73324,75,NULL,'MAT, I, raw','ESO 289- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155139,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155139,32.95,0.43,39,73324,75,NULL,'MAT, I, inv','ESO 289- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155140,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155140,33.01,0.43,40,73324,75,NULL,'MAT, I, cor','ESO 289- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155141,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155141,33.04,NULL,40.5,73324,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 289- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155142,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155142,33.04,0.42,40.6,73324,NULL,NULL,NULL,'ESO 289- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155143,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155143,33.05,NULL,40.7,73324,NULL,NULL,'Dipole + Quadrupole','ESO 289- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155144,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155144,33.06,NULL,41,73324,NULL,NULL,'Dipole','ESO 289- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155145,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155145,33.08,0.2,41.3,73324,74.4,NULL,NULL,'ESO 289- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155146,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155146,33.1,0.49,41.7,73324,75,NULL,'IR','ESO 289- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155147,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155147,33.16,NULL,42.9,73324,NULL,NULL,NULL,'ESO 289- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155148,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155148,37.43,0.46,306,73325,70,NULL,NULL,'2MASX J22164397-0824228',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000154,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,334.183375,-8.40636,0.161,NULL,49844196559,778815571,12168993,17.4),(155149,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw','R',155149,42.84,NULL,1880,73326,65,NULL,'MLCS17','[AGR2006] J221644.66-175002.3',0.961,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.186125,-17.834,0.049,NULL,49786627756,777916058,12154938,NULL),(155150,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155150,43.33,0.1,2360,73326,70,NULL,'MLCS17','[AGR2006] J221644.66-175002.3',0.961,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155151,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155151,43.54,0.35,2600,73326,74.2,NULL,'SALT 2','[AGR2006] J221644.66-175002.3',0.961,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155152,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155152,44,0.29,3220,73326,70,NULL,NULL,'[AGR2006] J221644.66-175002.3',0.961,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155153,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155153,44.01,0.15,3230,73326,NULL,NULL,'SIFTO','[AGR2006] J221644.66-175002.3',0.961,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155154,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155154,44.09,0.54,3350,73326,70,NULL,'SALT','[AGR2006] J221644.66-175002.3',0.961,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155155,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155155,44.1,0.22,3360,73326,65,NULL,'MLCS2k2','[AGR2006] J221644.66-175002.3',0.961,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155156,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155156,44.16,0.13,3460,73326,65,NULL,'MLCS2k2','[AGR2006] J221644.66-175002.3',0.961,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155157,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155157,44.17,0.21,3470,73326,65,NULL,'MLCS17','[AGR2006] J221644.66-175002.3',0.961,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155158,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155158,44.23,0.26,3570,73326,70,NULL,'SALT 2','[AGR2006] J221644.66-175002.3',0.961,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155159,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155159,44.26,0.31,3630,73326,65,NULL,'SALT2','[AGR2006] J221644.66-175002.3',0.961,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155160,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155160,44.27,0.21,3640,73326,65,NULL,'SALT','[AGR2006] J221644.66-175002.3',0.961,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155161,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155161,44.3,0.5,3690,73326,65,NULL,'SALT','[AGR2006] J221644.66-175002.3',0.961,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155162,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4dw',NULL,155162,45.69,0.17,6990,73326,NULL,NULL,'SALT2','[AGR2006] J221644.66-175002.3',0.961,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155163,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155163,37.23,0.46,279,73327,70,NULL,NULL,'SDSS J221644.82-083242.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,334.186791667,-8.54511,0.161,NULL,49842331335,778786427,12168537,18.4),(155164,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 07798','RN',155164,38.63,0.13,477,73328,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07798',0.118668,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155165,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 07798','RN',155165,38.86,0.48,528,73328,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07798',0.118668,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155166,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155166,36.86,0.46,236,73329,70,NULL,NULL,'2MASX J22164717-0050070',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.4g',0.35,'S0^-',NULL,NULL,NULL,NULL,1,334.196541667,-0.83522,0.205,NULL,49801758955,778152483,12158632,16.4),(155167,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155167,37.6,0.46,331,73330,70,NULL,NULL,'2MASX J22164735-0943288',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.0g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,334.197417,-9.72478,0.137,NULL,49831263766,778613496,12165835,17),(155168,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155168,37.23,0.46,279,73331,70,NULL,NULL,'2MASX J22164916+1200376',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000182,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.204833,12.01047,0.161,NULL,52278077468,816844960,12763202,17.8),(155169,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155169,33.13,0.46,42.3,73332,NULL,NULL,'J','UGC 11973',NULL,'2007A&A...465...71T',2007,1,3.2,NULL,'G',0.000037,NULL,'12.9',0.9,'SAB(s)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,334.210375,41.50283,0.945,NULL,55504494131,867257720,13550901,12.9),(155170,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155170,33.21,0.47,43.8,73332,NULL,NULL,'H','UGC 11973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155171,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155171,33.27,0.45,45.1,73332,NULL,NULL,'K','UGC 11973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155172,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155172,33.31,0.2,45.9,73332,74.4,NULL,NULL,'UGC 11973',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155173,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155173,33.47,0.43,49.4,73332,75,NULL,'3.6 micron, color corrected','UGC 11973',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155174,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155174,33.62,0.4,53,73332,NULL,NULL,'mean','UGC 11973',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155175,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155175,33.69,0.43,54.7,73332,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11973',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155176,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155176,32.61,0.4,33.3,73333,75,NULL,'B','UGCA 427',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000027,NULL,'14.73',0.7,'SB(s)m','in a triple',NULL,NULL,NULL,1,334.211667,-21.24997,0.065,NULL,50211123029,784548797,12258574,14.73),(155177,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155177,37.59,0.33,330,73334,70,NULL,NULL,'2MASX J22165197-0812138',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000177,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.216416667,-8.20392,0.141,NULL,49844974634,778827728,12169183,17.4),(155178,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4be',NULL,155178,41.63,0.04,1380,73335,70,NULL,'SIFTO','SNLS 05D4be HOST',0.537,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.2224583,-17.23611,0.041,NULL,49753830604,777403603,12146931,NULL),(155179,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4be',NULL,155179,42.55,0.15,2100,73335,NULL,NULL,'SIFTO','SNLS 05D4be HOST',0.537,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155180,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4be',NULL,155180,42.66,0.12,2210,73335,70,NULL,'SALT 2','SNLS 05D4be HOST',0.537,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155181,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4be',NULL,155181,44.04,0.17,4190,73335,NULL,NULL,'SALT2','SNLS 05D4be HOST',0.537,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155182,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155182,37.21,0.46,276,73336,70,NULL,NULL,'2MASX J22165419-0803448',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000135,NULL,'17.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.225708333,-8.06236,0.145,NULL,49845083919,778829436,12169209,17.9),(155183,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155183,41.7,0.03,1550,73337,70,NULL,'SIFTO','SNLS 06D4cq HOST',0.411,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.231333333,-17.71197,0.017,NULL,49753047058,777391360,12146740,NULL),(155184,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155184,41.82,0.11,1640,73337,70,NULL,'SALT 2','SNLS 06D4cq HOST',0.411,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155185,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155185,41.82,0.15,1640,73337,NULL,NULL,'SIFTO','SNLS 06D4cq HOST',0.411,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155186,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155186,41.85,NULL,1660,73337,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 06D4cq HOST',0.411,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155187,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cq',NULL,155187,42.53,0.17,2270,73337,NULL,NULL,'SALT2','SNLS 06D4cq HOST',0.411,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155188,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155188,43.6,0.22,2820,73338,70,NULL,'SALT 2','SNLS 05D4dw HOST',0.855,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.232833,-18.05147,0.029,NULL,49786436370,777913068,12154891,NULL),(155189,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155189,43.61,0.07,2840,73338,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4dw HOST',0.855,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155190,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155190,43.7,NULL,2960,73338,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','SNLS 05D4dw HOST',0.855,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155191,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155191,43.74,0.15,3020,73338,NULL,NULL,'SIFTO','SNLS 05D4dw HOST',0.855,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155192,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4dw',NULL,155192,44.41,0.17,4110,73338,NULL,NULL,'SALT2','SNLS 05D4dw HOST',0.855,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155193,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155193,37.59,0.33,330,73339,70,NULL,NULL,'2MASX J22165641-0809078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.235125,-8.15219,0.141,NULL,49844932910,778827076,12169173,17.5),(155194,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15265','RN',155194,42.46,0.37,2520,73340,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15265',0.231513,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155195,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cl',NULL,155195,43.4,0.09,2390,73341,70,NULL,'SIFTO','SNLS 06D4cl HOST',1,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.2377083,-17.45064,0.041,NULL,49753009337,777390770,12146730,NULL),(155196,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cl',NULL,155196,44.04,0.22,3210,73341,70,NULL,'SALT 2','SNLS 06D4cl HOST',1,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155197,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cl',NULL,155197,44.23,0.15,3510,73341,NULL,NULL,'SIFTO','SNLS 06D4cl HOST',1,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155198,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4cl',NULL,155198,45.56,0.17,6460,73341,NULL,NULL,'SALT2','SNLS 06D4cl HOST',1,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155199,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hf',NULL,155199,43.89,0.31,3100,73342,70,NULL,'SALT 2','SNLS 04D4hf HOST',0.936,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.014,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.24125,-17.68703,0.017,NULL,49753047724,777391370,12146740,NULL),(155200,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hf',NULL,155200,44,0.1,3250,73342,70,NULL,'SIFTO','SNLS 04D4hf HOST',0.936,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155201,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hf',NULL,155201,44.06,0.15,3340,73342,NULL,NULL,'SIFTO','SNLS 04D4hf HOST',0.936,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155202,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4hf',NULL,155202,45.06,0.17,5310,73342,NULL,NULL,'SALT2','SNLS 04D4hf HOST',0.936,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155203,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gz',NULL,155203,42.13,0.15,1940,73343,NULL,NULL,'SIFTO','[NSB2006] J221659.01-173719.0',0.375,'2010A&A...523A...7G',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.245916667,-17.62194,0.029,NULL,49753060415,777391568,12146743,NULL),(155204,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4gz',NULL,155204,42.3,0.17,2100,73343,NULL,NULL,'SALT2','[NSB2006] J221659.01-173719.0',0.375,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155205,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155205,42.43,0.14,2080,73344,70,NULL,'SALT 2','[NSB2006] J221702.73-171958.3',0.472,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.261375,-17.33286,0.041,NULL,49753703240,777401613,12146900,NULL),(155206,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155206,42.44,0.15,2090,73344,NULL,NULL,'SIFTO','[NSB2006] J221702.73-171958.3',0.472,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155207,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155207,42.46,NULL,2110,73344,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212','[NSB2006] J221702.73-171958.3',0.472,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155208,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155208,43.2,0.17,2970,73344,NULL,NULL,'SALT2','[NSB2006] J221702.73-171958.3',0.472,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155209,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ju',NULL,155209,43.5,0.04,3400,73344,70,NULL,'SIFTO','[NSB2006] J221702.73-171958.3',0.472,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155210,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bm',NULL,155210,41.27,0.03,1310,73345,70,NULL,'SIFTO','SNLS 05D4bm HOST',0.375,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.26925,-17.67761,0.017,NULL,49753050280,777391410,12146740,NULL),(155211,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bm',NULL,155211,41.54,0.11,1480,73345,70,NULL,'SALT 2','SNLS 05D4bm HOST',0.375,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155212,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bm',NULL,155212,41.59,0.15,1510,73345,NULL,NULL,'SIFTO','SNLS 05D4bm HOST',0.375,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155213,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4bm',NULL,155213,42.03,0.17,1850,73345,NULL,NULL,'SALT2','SNLS 05D4bm HOST',0.375,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155214,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16230',NULL,155214,39.63,0.41,844,73346,70,NULL,'SN photometric redshift distance, z photo =0.221 +/- 0.054','SDSS-II SN 16230',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.278916667,-0.89997,0.205,NULL,49801800198,778153128,12158642,NULL),(155215,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16230','R',155215,42.84,0.48,2180,73346,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 16230',0.690995,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155216,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155216,37.99,0.46,396,73347,70,NULL,NULL,'2MASX J22170813+1218109',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000204,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,334.283875,12.30308,0.189,NULL,52244812098,816325189,12755081,16.6),(155217,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155217,36.03,0.52,161,73348,70,NULL,NULL,'2MASX J22170988-8114451',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.0b',NULL,NULL,NULL,NULL,NULL,NULL,1,334.2907917,-81.24594,0.469,NULL,48563723150,758808174,11856377,17),(155218,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155218,38.15,0.46,427,73349,70,NULL,NULL,'2MASX J22171077-0050084',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,334.295,-0.83572,0.205,NULL,49801689256,778151394,12158615,17.7),(155219,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155219,36.24,0.52,177,73350,70,NULL,NULL,'2MASX J22171119-4829438',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.33',0.43,'S0',NULL,NULL,NULL,NULL,1,334.296583,-48.49547,0,NULL,50623611779,790993934,12359280,16.33),(155220,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155220,36.14,0.51,169,73351,70,NULL,NULL,'2MASX J22171321-4823338',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.02',0.3,NULL,NULL,NULL,NULL,NULL,1,334.3050417,-48.39272,0,NULL,50623626179,790994159,12359283,17.02),(155221,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4hn',NULL,155221,43.26,0.23,2440,73352,70,NULL,'SALT 2','SNLS 05D4hn HOST',0.842,'2013MNRAS.433.2240G',2013,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.306417,-17.91261,0.049,NULL,49786447778,777913246,12154894,NULL),(155222,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4hn',NULL,155222,43.39,0.07,2580,73352,70,NULL,'SIFTO','SNLS 05D4hn HOST',0.842,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155223,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4hn',NULL,155223,43.48,0.15,2690,73352,NULL,NULL,'SIFTO','SNLS 05D4hn HOST',0.842,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155224,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4hn',NULL,155224,45.23,0.17,6030,73352,NULL,NULL,'SALT2','SNLS 05D4hn HOST',0.842,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155225,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03601','RN',155225,41.27,0.16,1360,73353,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03601',0.320009,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155226,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03601','RN',155226,41.62,0.22,1600,73353,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03601',0.320009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155227,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155227,36.54,0.54,203,73354,70,NULL,NULL,'ESO 237- G 051',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.83',0.8,'E+3 pec',NULL,NULL,NULL,NULL,1,334.315667,-48.30047,0,NULL,50623618621,790994040,12359281,14.83),(155228,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155228,37.36,0.46,297,73355,70,NULL,NULL,'2MASX J22171601-0927268',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,334.316667,-9.45753,0.133,NULL,49831126441,778611350,12165802,16.9),(155229,'Tully est','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155229,31.76,0.8,22.5,73356,75,NULL,NULL,'ESO 289- G 011',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.00002,NULL,'14.89',1,'IB(s)m','Group member',NULL,NULL,NULL,1,334.3180417,-45.0665,0,NULL,50726297263,792598394,12384349,14.89),(155230,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ih',NULL,155230,43.07,0.08,2130,73357,70,NULL,'SIFTO','[HSP2005] J221717.04-174038.74',0.934,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.321,-17.67742,0.029,NULL,49753061789,777391590,12146743,NULL),(155231,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ih',NULL,155231,44.16,0.15,3510,73357,NULL,NULL,'SIFTO','[HSP2005] J221717.04-174038.74',0.934,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155232,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ih',NULL,155232,44.22,0.21,3620,73357,70,NULL,'SALT 2','[HSP2005] J221717.04-174038.74',0.934,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155233,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4ih',NULL,155233,44.6,0.17,4300,73357,NULL,NULL,'SALT2','[HSP2005] J221717.04-174038.74',0.934,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155234,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ce',NULL,155234,42.99,0.07,2150,73358,70,NULL,'SIFTO','SNLS 06D4ce HOST',0.85,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.321875,-17.23594,0.041,NULL,49753793626,777403025,12146922,NULL),(155235,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ce',NULL,155235,43.8,0.15,3110,73358,NULL,NULL,'SIFTO','SNLS 06D4ce HOST',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155236,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ce',NULL,155236,43.83,0.23,3150,73358,70,NULL,'SALT 2','SNLS 06D4ce HOST',0.85,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155237,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 06D4ce',NULL,155237,45.86,0.17,8030,73358,NULL,NULL,'SALT2','SNLS 06D4ce HOST',0.85,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155238,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4cs',NULL,155238,42.8,0.05,2020,73359,70,NULL,'SIFTO','SNLS 05D4cs HOST',0.79,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.32425,-17.88014,0.017,NULL,49786416634,777912759,12154886,NULL),(155239,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4cs',NULL,155239,43.46,0.15,2750,73359,NULL,NULL,'SIFTO','SNLS 05D4cs HOST',0.79,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155240,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4cs',NULL,155240,43.61,0.19,2950,73359,70,NULL,'SALT 2','SNLS 05D4cs HOST',0.79,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155241,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 05D4cs',NULL,155241,45.39,0.17,6670,73359,NULL,NULL,'SALT2','SNLS 05D4cs HOST',0.79,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155242,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4jw',NULL,155242,43.66,0.14,2760,73360,70,NULL,'SALT2','SNLS 04D4jw HOST',0.961,'2011ApJS..192....1C',2011,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.3287083,-17.6655,0.029,NULL,49753054223,777391472,12146741,NULL),(155243,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4jw',NULL,155243,43.85,0.17,3010,73360,NULL,NULL,'SALT2','SNLS 04D4jw HOST',0.961,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155244,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4jw',NULL,155244,44.47,0.26,3990,73360,70,NULL,'SALT 2','SNLS 04D4jw HOST',0.961,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155245,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 04D4jw',NULL,155245,44.48,0.15,4020,73360,NULL,NULL,'SIFTO','SNLS 04D4jw HOST',0.961,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155246,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2011fs',NULL,155246,34.46,0.09,77.9,73361,72,NULL,'M(H) = -18.317 mag','UGC 11975',NULL,'2014ApJ...784..105W',2013,1,1.5,NULL,'G',0.000093,NULL,'15.2',1.2,'S0/a',NULL,NULL,NULL,NULL,1,334.33225,35.57117,0.525,NULL,55483993850,866937403,13545896,15.2),(155247,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 09424','R',155247,39.99,0.26,818,73362,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09424',0.217237,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.33975,0.09747,0.197,NULL,52153250885,814894545,12732727,NULL),(155248,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 09424','R',155248,40.37,0.29,975,73362,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09424',0.217237,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155249,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 09424',NULL,155249,40.72,0.38,1390,73362,70,NULL,'SN photometric redshift distance, z photo =0.401 +/- 0.102','SDSS-II SN 09424',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155250,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155250,37.46,0.46,311,73363,70,NULL,NULL,'2MASX J22172207-0859325',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.341833333,-8.99233,0.137,NULL,49842273626,778785525,12168523,17.7),(155251,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155251,37.28,0.46,286,73364,70,NULL,NULL,'2MASX J22172456-0727505',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000159,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.3524583,-7.46392,0.189,NULL,49841596447,778774944,12168358,17.6),(155252,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155252,35.48,0.49,125,73365,75,NULL,'IR','CGCG 428-067',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000599,NULL,'15.61',0.2,NULL,NULL,NULL,NULL,NULL,1,334.353125,15.21708,0.149,NULL,52251410398,816428287,12756691,15.61),(155253,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155253,37.26,0.23,283,73366,70,NULL,NULL,'2MASX J22172482+1231225',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00019,NULL,'16.5g',0.35,'BrClG',NULL,NULL,NULL,NULL,1,334.353417,12.52297,0.197,NULL,52247889401,816373271,12755832,16.5),(155254,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155254,37.26,0.23,283,73367,70,NULL,NULL,'SDSS J221725.27+123517.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000151,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,334.355333333,12.58828,0.189,NULL,52247894347,816373349,12755833,18.6),(155255,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979',NULL,155255,39.5,0.85,793,73368,70,NULL,'SN photometric redshift distance, z photo =0.206 +/- 0.118','SDSS-II SN 01979',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,':','22.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.356,0.94456,0.125,NULL,52153540618,814899072,12732798,22.5),(155256,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979','R',155256,40.66,0.31,1060,73368,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01979',0.2834,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155257,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979','R',155257,40.89,0.26,1170,73368,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01979',0.2834,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155258,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979',NULL,155258,40.66,0.19,1360,73368,70,NULL,'SALT 2','SDSS-II SN 01979',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155259,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01979',NULL,155259,40.68,0.19,1370,73368,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01979',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155260,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155260,38.07,0.46,411,73369,70,NULL,NULL,'2MASX J22172591-0825315',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000188,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,334.3580417,-8.42539,0.141,NULL,49844233979,778816155,12169002,16.8),(155261,'HII LF','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155261,46.76,0.56,3900,73370,71,NULL,NULL,'SSA 22a MD46',3.091,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.001,NULL,'23.3R',NULL,'LBG',NULL,NULL,NULL,NULL,1,334.363625,0.30275,0.161,NULL,52153234393,814894287,12732723,23.3),(155262,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155262,37.68,0.46,343,73371,70,NULL,NULL,'2MASX J22173071-0108220',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,334.377917,-1.13928,0.205,NULL,49801616677,778150260,12158597,18.3),(155263,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh','R',155263,41.75,NULL,1370,73372,65,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.0004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,334.379333333,-17.62972,0.029,NULL,49753082991,777391921,12146748,NULL),(155264,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155264,42.06,0.16,1590,73372,74.2,NULL,'SALT 2','[AGR2006] J221731.04-173746.9',0.627,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155265,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155265,42.28,0.04,1750,73372,70,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155266,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155266,42.71,0.15,2140,73372,70,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155267,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155267,42.75,0.04,2180,73372,70,NULL,NULL,'[AGR2006] J221731.04-173746.9',0.627,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155268,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155268,42.81,0.11,2240,73372,65,NULL,'SALT2','[AGR2006] J221731.04-173746.9',0.627,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155269,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155269,42.87,0.17,2300,73372,70,NULL,'SALT 2','[AGR2006] J221731.04-173746.9',0.627,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155270,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155270,42.88,0.12,2310,73372,65,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155271,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155271,42.88,0.15,2310,73372,65,NULL,'MLCS2k2','[AGR2006] J221731.04-173746.9',0.627,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155272,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155272,42.91,0.15,2350,73372,NULL,NULL,'SIFTO','[AGR2006] J221731.04-173746.9',0.627,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155273,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155273,42.91,0.2,2350,73372,65,NULL,'MLCS17','[AGR2006] J221731.04-173746.9',0.627,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155274,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155274,42.93,0.17,2370,73372,65,NULL,'SALT2','[AGR2006] J221731.04-173746.9',0.627,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155275,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155275,42.94,0.21,2380,73372,65,NULL,'MLCS2k2','[AGR2006] J221731.04-173746.9',0.627,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155276,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155276,42.94,0.23,2380,73372,65,NULL,'MLCS31','[AGR2006] J221731.04-173746.9',0.627,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155277,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155277,43,0.03,2450,73372,65,NULL,'SALT','[AGR2006] J221731.04-173746.9',0.627,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155278,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SNLS 03D4dh',NULL,155278,44.49,0.17,4870,73372,NULL,NULL,'SALT2','[AGR2006] J221731.04-173746.9',0.627,'2010A&A...523A...7G',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155279,'HII LF','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155279,49.71,0.43,15200,73373,71,NULL,NULL,'LAB 30',3.086,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.001,NULL,'23.37',NULL,'LBG',NULL,NULL,NULL,NULL,1,334.3850417,0.19247,0.197,NULL,52153279702,814894995,12732734,23.37),(155280,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2008ei',NULL,155280,36.11,0.16,161,73374,70,NULL,'SALT 2','UGC 11977',0.037639,'2013MNRAS.433.2240G',2013,1,1.1,NULL,'G',0.000033,NULL,'16.5',0.8,'SABdm',NULL,NULL,NULL,NULL,1,334.3892917,33.25611,0.325,NULL,55498466295,867163535,13549430,16.5),(155281,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155281,34.63,0.8,84.2,73375,75,NULL,'W91PP, r','UGC 11976',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'16.29',0.2,'S?',NULL,NULL,NULL,NULL,1,334.401083,28.95422,0.305,NULL,55448002961,866375046,13537110,16.29),(155282,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155282,34.91,0.38,95.9,73375,75,NULL,'W91PP, r, inv','UGC 11976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155283,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155283,34.91,0.38,96.1,73375,75,NULL,'W91PP, r, raw','UGC 11976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155284,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155284,35.07,0.38,103,73375,75,NULL,'W91PP, r, cor','UGC 11976',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155285,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 17176','R',155285,38.17,0.13,394,73376,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ie','SN 2007ie',0.093413,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,334.402875,0.61333,0.137,NULL,52153996832,814906200,12732909,NULL),(155286,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 17176','R',155286,38.22,0.2,402,73376,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ie','SN 2007ie',0.093413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155287,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155287,37.26,0.23,283,73377,70,NULL,NULL,'2MASX J22173834+1234005',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',NULL,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.409875,12.56683,0.209,NULL,52247770537,816371414,12755803,17.4),(155288,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155288,36.97,0.46,248,73378,70,NULL,NULL,'2MASX J22173937-0107050',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000154,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.4140417,-1.118,0.205,NULL,49801835760,778153683,12158651,17.2),(155289,'HII LF','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155289,48.96,0.85,13900,73379,71,NULL,NULL,'SSA 22a MD041',2.1713,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.002,NULL,'23.3R',NULL,'LBG',NULL,NULL,NULL,NULL,1,334.4165417,0.28639,0.161,NULL,52153275697,814894932,12732733,23.3),(155290,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155290,32.47,0.8,31.2,73380,75,NULL,'MAT, I','NGC 7247',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.09',0.9,'SB(s)b:','in a pair',NULL,NULL,NULL,1,334.421875,-23.73103,0.069,NULL,50197775522,784340242,12255316,13.09),(155291,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155291,32.22,0.43,27.7,73380,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155292,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155292,32.39,0.43,30.1,73380,75,NULL,'3.6 micron, color corrected','NGC 7247',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155293,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155293,32.44,0.45,30.8,73380,NULL,NULL,'K','NGC 7247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155294,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155294,32.46,0.07,31.1,73380,NULL,NULL,NULL,'NGC 7247',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155295,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155295,32.48,0.47,31.3,73380,NULL,NULL,'H','NGC 7247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155296,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155296,32.53,0.46,32,73380,NULL,NULL,'J','NGC 7247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155297,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155297,32.55,0.4,32.3,73380,NULL,NULL,'mean','NGC 7247',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155298,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155298,32.59,0.2,33,73380,74.4,NULL,NULL,'NGC 7247',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155299,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155299,32.7,0.32,34.7,73380,85,NULL,'I, raw','NGC 7247',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155300,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155300,32.74,0.32,35.3,73380,85,NULL,'I, inv','NGC 7247',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155301,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155301,32.87,0.43,37.5,73380,75,NULL,'MAT, I, raw','NGC 7247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155302,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155302,33.05,0.43,40.7,73380,75,NULL,'MAT, I, inv','NGC 7247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155303,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155303,33.16,0.43,42.8,73380,75,NULL,'MAT, I, cor','NGC 7247',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155304,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155304,33.07,0.69,41.1,73381,100,NULL,'mid-IR','NGC 7246',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000013,NULL,'13.67',0.7,'(R)SA(r)a:     HII',NULL,NULL,NULL,NULL,1,334.427833,-15.57128,0.073,NULL,49754928228,777420753,12147199,13.67),(155305,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15289',NULL,155305,38.84,1.86,587,73382,70,NULL,'SN photometric redshift distance, z photo =0.148 +/- 0.250','SDSS-II SN 15289',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.4330417,-1.19864,0.205,NULL,49801625405,778150396,12158599,NULL),(155306,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155306,32.83,0.8,36.8,73383,75,NULL,'MAT, I','ESO 237- G 052',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000026,NULL,'14.40',0.8,'(R\'_2)SAB(s)c',NULL,NULL,NULL,NULL,1,334.447125,-49.25994,0,NULL,50624020222,791000315,12359379,14.4),(155307,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155307,32.43,0.4,30.6,73383,NULL,NULL,NULL,'ESO 237- G 052',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155308,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155308,32.43,0.39,30.6,73383,73,NULL,'opt','ESO 237- G 052',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155309,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155309,32.5,0.32,31.6,73383,85,NULL,'I, inv','ESO 237- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155310,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155310,32.51,0.32,31.8,73383,85,NULL,'I, raw','ESO 237- G 052',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155311,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155311,32.88,0.43,37.6,73383,75,NULL,'MAT, I, raw','ESO 237- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155312,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155312,32.89,0.43,37.9,73383,75,NULL,'MAT, I, inv','ESO 237- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155313,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155313,32.98,0.43,39.4,73383,75,NULL,'MAT, I, cor','ESO 237- G 052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155314,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155314,35.61,0.5,133,73384,70,NULL,NULL,'ESO 533- G 009',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000103,NULL,'15.03',1,'S0','in a pair',NULL,NULL,NULL,1,334.454,-23.89194,0.045,NULL,50197868115,784341689,12255338,15.03),(155315,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PTF10qky','N',155315,37.64,0.04,314,73385,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qky',0.0742,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155316,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 07892',NULL,155316,38.07,0.87,411,73386,70,NULL,'SN photometric redshift distance, z photo =0.101 +/- 0.054','SDSS-II SN 07892',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.454375,-1.00736,0.205,NULL,49801707124,778151673,12158619,NULL),(155317,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155317,36.15,0.46,170,73387,70,NULL,NULL,'2MASX J22175024+1259415',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.459375,12.99492,0.197,NULL,52248224191,816378502,12755914,17.5),(155318,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS10byr','N',155318,40.57,0.28,1050,73388,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10byr HOST',0.2388,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155319,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS11ajs','N',155319,40.32,0.12,942,73389,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS11ajs HOST',0.2288,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155320,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155320,36.82,0.74,231,73390,70,NULL,NULL,'2MASX J22175127-1235177',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.84',0.26,NULL,NULL,NULL,NULL,NULL,1,334.463791667,-12.58831,0.121,NULL,49748276838,777316825,12145575,16.84),(155321,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155321,37.11,0.46,264,73391,70,NULL,NULL,'2MASX J22175203-0817462',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000151,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,334.46675,-8.29631,0.141,NULL,49845011670,778828307,12169192,17),(155322,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155322,35.41,0.46,121,73392,70,NULL,NULL,'2MASX J22175466-0831232',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'15.7g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,334.4777083,-8.52306,0.161,NULL,49844311511,778817367,12169021,15.7),(155323,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155323,37.54,0.46,322,73393,70,NULL,NULL,'SDSS J221755.09-000545.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000184,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,334.4795417,-0.09608,0.197,NULL,49801090122,778142033,12158469,18.4),(155324,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155324,34.29,0.61,72.1,73394,NULL,NULL,NULL,'ESO 467- G 040',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'15.76',0.34,'Sb',NULL,NULL,NULL,NULL,1,334.487625,-27.52906,0.021,NULL,50547095660,789798369,12340599,15.76),(155325,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155325,34.33,0.2,73.5,73394,74.4,NULL,NULL,'ESO 467- G 040',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155326,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155326,34.41,0.57,76.2,73394,NULL,NULL,'Malmquist cor.','ESO 467- G 040',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155327,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155327,35.08,0.48,104,73395,70,NULL,NULL,'ESO 237- G 053',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.12',0.3,'S0',NULL,NULL,NULL,NULL,1,334.4962917,-48.47664,0,NULL,50623585202,790993518,12359273,15.12),(155328,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155328,37.26,0.23,283,73396,70,NULL,NULL,'2MASX J22175945+1248587',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000155,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.497583333,12.81636,0.213,NULL,52247781453,816371585,12755806,17.3),(155329,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150',NULL,155329,40.2,0.19,1100,73397,70,NULL,'SN photometric redshift distance, z photo =0.300 +/- 0.034','SDSS-II SN 03150',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.512167,-0.63156,0.181,NULL,49801213629,778143962,12158499,22.1),(155330,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150','R',155330,41.18,0.23,1290,73397,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03150',0.333268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155331,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150','R',155331,41.18,0.28,1290,73397,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03150',0.333268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155332,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150',NULL,155332,41.03,0.18,1610,73397,70,NULL,'SALT 2','SDSS-II SN 03150',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155333,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03150',NULL,155333,41.07,0.18,1640,73397,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03150',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155334,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155334,36.56,0.87,205,73398,70,NULL,NULL,'2MASX J22180610-2020257',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'14.4I',0.3,NULL,NULL,NULL,NULL,NULL,1,334.5254583,-20.34056,0.053,NULL,50207473874,784491779,12257684,14.4),(155335,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155335,37.51,0.46,318,73399,70,NULL,NULL,'2MASX J22181034-0751122',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000183,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,334.543208333,-7.85339,0.145,NULL,49844531795,778820809,12169075,17.6),(155336,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2013dy',NULL,155336,31.49,0.01,19.7,73400,NULL,NULL,'SNooPy','NGC 7250',0.003889,'2015MNRAS.452.4307P',2015,1,1.7,NULL,'G',0.000017,NULL,'13.22',0.8,'Sdm?           Sbrst','in a pair',NULL,NULL,NULL,1,334.574167,40.56239,0.625,NULL,55504884729,867263823,13550997,13.22),(155337,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155337,29.92,0.2,9.64,73400,74.4,NULL,NULL,'NGC 7250',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155338,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155338,30.68,0.4,13.7,73400,NULL,NULL,NULL,'NGC 7250',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155339,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155339,30.68,0.39,13.7,73400,73,NULL,'opt','NGC 7250',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155340,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155340,35.83,0.59,146,73401,70,NULL,NULL,'2MASX J22181921-6612027',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.97',0.27,NULL,NULL,NULL,NULL,NULL,1,334.580166667,-66.20086,0,NULL,49290766040,770168219,12033878,16.97),(155341,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 12870','RN',155341,40.62,0.18,930,73402,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12870',0.428459,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155342,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','PS1 SN PS10agw','N',155342,41.36,0.11,1410,73403,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10agw HOST',0.3288,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155343,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155343,35.77,0.55,143,73404,70,NULL,NULL,'2MASX J22183005-5510397',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.0001,NULL,'15.73',0.45,'E',NULL,NULL,NULL,NULL,1,334.625041667,-55.17772,0,NULL,48700426903,760944170,11889752,15.73),(155344,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155344,37.84,0.46,370,73405,70,NULL,NULL,'2MASX J22183393-0919075',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000172,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.641333,-9.31881,0.137,NULL,49831504815,778617262,12165894,17.8),(155345,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155345,39.54,0.12,658,73406,74.2,NULL,'SALT 2','SDSS J221841.10+003822.2',0.23,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',0.0005,NULL,'22.2g',0.03,NULL,NULL,NULL,NULL,NULL,1,334.6712917,0.63953,0.133,NULL,52157409415,814959522,12733742,22.2),(155346,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155346,39.67,0.04,697,73406,70,NULL,'SDSS-II SN 03452','SDSS J221841.10+003822.2',0.23,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155347,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155347,39.69,0.09,867,73406,70,NULL,'Hubble residual -0.02 for z0.23040','SDSS J221841.10+003822.2',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155348,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155348,40.27,0.1,919,73406,65,NULL,'SALT2','SDSS J221841.10+003822.2',0.23,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155349,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155349,40.28,0.13,924,73406,70,NULL,'SDSS-II SN 03452, SALT 2','SDSS J221841.10+003822.2',0.23,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155350,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03452','R',155350,40.29,0.19,928,73406,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gg','SDSS J221841.10+003822.2',0.2304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155351,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155351,40.45,0.1,1000,73406,65,NULL,'MLCS2k2','SDSS J221841.10+003822.2',0.23,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155352,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 03452','R',155352,40.48,0.12,1020,73406,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gg','SDSS J221841.10+003822.2',0.2304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155353,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155353,40.24,0.09,1120,73406,70,NULL,'SALT 2','SDSS J221841.10+003822.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155354,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005gg',NULL,155354,40.26,0.09,1130,73406,70,NULL,'SALT 2, Malmquist cor.','SDSS J221841.10+003822.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155355,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155355,36.63,0.46,212,73407,70,NULL,NULL,'2MASX J22184464+1254375',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,334.685917,12.91042,0.197,NULL,52248053861,816375841,12755872,18),(155356,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155356,33.61,0.45,52.8,73408,NULL,NULL,'K','IC 5186',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.00006,NULL,'13.69',1.2,'(R\':)SB?(r)ab',NULL,NULL,NULL,NULL,1,334.693833333,-36.80158,0,NULL,50554243419,789910053,12342344,13.69),(155357,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155357,33.65,0.47,53.6,73408,NULL,NULL,'H','IC 5186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155358,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155358,33.7,0.46,54.8,73408,NULL,NULL,'J','IC 5186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155359,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155359,33.97,0.4,62.1,73408,NULL,NULL,'mean','IC 5186',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155360,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155360,37.66,0.46,341,73409,70,NULL,NULL,'2MASX J22184819-0037309',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.700791667,-0.62514,0.181,NULL,49809588185,778274815,12160543,17.7),(155361,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155361,36.4,0.51,191,73410,70,NULL,NULL,'2MASX J22184915-4913256',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'14.9R',0.24,NULL,NULL,NULL,NULL,NULL,1,334.704875,-49.22375,0,NULL,50623293880,790988966,12359202,14.9),(155362,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 13405','RN',155362,42.24,0.21,2130,73411,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13405',0.315477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155363,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 13405','RN',155363,42.29,0.14,2180,73411,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13405',0.315477,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155364,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155364,33.88,0.49,59.8,73412,75,NULL,'IR','UGC 11982',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000023,NULL,'15.50',0.21,'SB(s)cd?','Isolated galaxy',NULL,NULL,NULL,1,334.720625,-1.05867,0.177,NULL,49809896377,778279630,12160619,15.5),(155365,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155365,34.06,0.38,64.9,73412,NULL,NULL,'Malmquist cor.','UGC 11982',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155366,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155366,34.08,0.2,65.5,73412,74.4,NULL,NULL,'UGC 11982',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155367,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155367,34.14,0.37,67.3,73412,NULL,NULL,NULL,'UGC 11982',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155368,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155368,34.32,NULL,73,73412,NULL,NULL,'Dipole','UGC 11982',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155369,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155369,34.32,NULL,73.2,73412,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11982',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155370,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155370,34.33,NULL,73.4,73412,NULL,NULL,'Dipole + Quadrupole','UGC 11982',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155371,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155371,37.38,0.33,299,73413,70,NULL,NULL,'2MASX J22185407-0745358',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000171,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,334.7252917,-7.75997,0.145,NULL,49844366403,778818225,12169034,17.3),(155372,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16236',NULL,155372,40.15,0.27,1070,73414,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.046','SDSS-II SN 16236',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,334.7354583,-0.51175,0.165,NULL,49809692987,778276452,12160569,21.8),(155373,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16236','R',155373,41.62,0.28,1500,73414,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16236',0.405999,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155374,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 16236','R',155374,42.07,0.37,1850,73414,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16236',0.405999,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155375,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 18273','R',155375,40.97,0.23,1190,73415,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J221857.47-003748.9',0.3163,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0001,NULL,'20.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,334.7394583,-0.63028,0.165,NULL,49809574520,778274601,12160540,20.6),(155376,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 18273','R',155376,41.08,0.29,1250,73415,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J221857.47-003748.9',0.3163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155377,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 18273',NULL,155377,40.93,0.18,1530,73415,70,NULL,'SALT 2','SDSS J221857.47-003748.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155378,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 18273',NULL,155378,40.97,0.18,1560,73415,70,NULL,'SALT 2, Malmquist cor.','SDSS J221857.47-003748.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155379,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155379,35.14,0.52,107,73416,70,NULL,NULL,'2MASX J22185861-5356506',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000077,NULL,'15.55',0.43,'S0',NULL,NULL,NULL,NULL,1,334.74425,-53.94742,0,NULL,48703179934,760987186,11890424,15.55),(155380,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155380,37.56,0.46,325,73417,70,NULL,NULL,'SDSS J221858.85+000209.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000136,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,334.7452083,0.03592,0.161,NULL,52145688493,814776382,12730880,18.7),(155381,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155381,37.38,0.33,299,73418,70,NULL,NULL,'SDSS J221859.11-074621.0',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000168,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.746333,-7.77253,0.145,NULL,49844367661,778818244,12169035,17.8),(155382,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155382,34.43,0.46,77,73419,70,NULL,NULL,'CGCG 428-072',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.000158,NULL,'15.8g',0.37,'E','Pair member (points to parent)',NULL,NULL,NULL,1,334.7475,13.18747,0.165,NULL,52248094484,816376476,12755882,15.8),(155383,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15627','RN',155383,38.8,0.33,525,73420,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15627',0.097708,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155384,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15627','RN',155384,40.52,0.25,1160,73420,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15627',0.097708,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155385,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155385,37.83,0.33,369,73421,70,NULL,NULL,'2MASX J22190268-0047181',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'17.71',0.2,NULL,NULL,NULL,NULL,NULL,1,334.761125,-0.78833,0.181,NULL,49810428510,778287945,12160749,17.71),(155386,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155386,38.09,0.46,415,73422,70,NULL,NULL,'2MASX J22190265-0913188',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000193,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.7612083,-9.22197,0.137,NULL,49829646532,778588227,12165441,17.3),(155387,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155387,34.18,0.4,68.7,73423,NULL,NULL,'mean','IC 1443',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000137,NULL,'13.76',1.2,'E2:',NULL,NULL,NULL,NULL,1,334.76525,-20.93992,0.073,NULL,50207798089,784496845,12257763,13.76),(155388,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155388,34.39,0.45,75.4,73423,NULL,NULL,'K','IC 1443',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155389,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155389,34.01,0.8,63.3,73424,75,NULL,'W91PP, r','UGC 11983',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.64',0.2,'Sbc',NULL,NULL,NULL,NULL,1,334.767166667,33.32944,0.381,NULL,55498930637,867170791,13549543,15.64),(155390,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155390,33.7,0.38,54.9,73424,75,NULL,'W91PP, r, raw','UGC 11983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155391,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155391,33.73,0.38,55.8,73424,75,NULL,'W91PP, r, inv','UGC 11983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155392,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155392,33.83,0.2,58.3,73424,74.4,NULL,NULL,'UGC 11983',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155393,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155393,33.99,0.49,62.7,73424,75,NULL,'IR','UGC 11983',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155394,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155394,34.04,0.38,64.3,73424,75,NULL,'W91PP, r, cor','UGC 11983',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155395,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155395,37.86,0.46,374,73425,70,NULL,NULL,'SDSS J221905.92-094932.6',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,334.774667,-9.82575,0.185,NULL,49832442021,778631906,12166123,18.4),(155396,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2002eb',NULL,155396,35.36,0.15,115,73426,70,NULL,'SALT 2','CGCG 473-011',0.027536,'2013MNRAS.433.2240G',2013,1,0.9,NULL,'G',0.000033,NULL,'15.30',0.5,'Sb','Isolated galaxy',NULL,NULL,NULL,1,334.77625,24.59819,0.241,NULL,51875506577,810554790,12664918,15.3),(155397,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2002eb','R',155397,35.42,0.04,121,73426,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 473-011',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155398,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2002eb','R',155398,35.43,0.03,122,73426,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 473-011',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155399,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2007su',NULL,155399,35.48,0.21,122,73427,73.8,NULL,'SALT 2 (SNANA)','SDSS J221908.85+131040.5',0.0267,'2014ApJ...795...44R',2014,1,0.17,NULL,'G',0.000089,NULL,'18.5g',0.09,NULL,NULL,NULL,NULL,NULL,1,334.786875,13.17792,0.165,NULL,52248093379,816376459,12755882,18.5),(155400,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155400,37.83,0.33,369,73428,70,NULL,NULL,'2MASX J22190962-0051041',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.790125,-0.85111,0.181,NULL,49810438540,778288102,12160751,17.8),(155401,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155401,36.97,0.49,248,73429,75,NULL,'IR','FGC 2402',NULL,'2011yCatp016004901K',2011,1,0.65,NULL,'G',NULL,NULL,'17.3',0.08,'Sc',NULL,NULL,NULL,NULL,1,334.7905,88.81233,0.333,NULL,52616990785,822140481,12845945,17.3),(155402,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155402,37.07,NULL,260,73429,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155403,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155403,37.1,NULL,264,73429,NULL,NULL,'Dipole + Quadrupole','FGC 2402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155404,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155404,37.13,NULL,267,73429,NULL,NULL,NULL,'FGC 2402',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155405,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155405,37.14,NULL,268,73429,NULL,NULL,'Dipole','FGC 2402',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155406,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 05230','RN',155406,41.07,0.21,1240,73430,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05230',0.322057,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155407,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 05230','RN',155407,41.09,0.25,1250,73430,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05230',0.322057,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155408,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 05230','N',155408,41.03,0.16,1610,73430,70,NULL,'SALT 2','SDSS-II SN 05230',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155409,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 05230','N',155409,41.07,0.16,1640,73430,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05230',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155410,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 08226',NULL,155410,41.11,0.25,1660,73431,70,NULL,'SN photometric redshift distance, z photo =0.507 +/- 0.088','SDSS-II SN 08226',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.8172083,0.74911,0.129,NULL,52157389029,814959203,12733737,NULL),(155411,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155411,38.6,0.46,525,73432,70,NULL,NULL,'SDSS J221916.18-080145.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000153,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,334.817458333,-8.02944,0.145,NULL,49843387343,778802927,12168795,18.8),(155412,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155412,38.38,0.46,475,73433,70,NULL,NULL,'2MASX J22191936-0058411',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,334.830583,-0.978,0.177,NULL,49810396457,778287444,12160741,17.9),(155413,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155413,37.49,0.46,315,73434,70,NULL,NULL,'SDSS J221919.97+004820.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00014,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.83325,0.80561,0.129,NULL,52158103275,814970363,12733911,18.3),(155414,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155414,37.3,0.46,288,73435,70,NULL,NULL,'2MASX J22192055-0006298',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000178,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,334.835583333,-0.10825,0.145,NULL,49795831633,778059869,12157185,18.1),(155415,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01981','RN',155415,38.94,0.17,580,73436,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01981',0.056828,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155416,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01981','RN',155416,39.85,0.26,882,73436,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01981',0.056828,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155417,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005fe',NULL,155417,39.58,0.14,677,73437,74.2,NULL,'SALT 2','SDSS J221927.32+002938.8',0.217,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',NULL,NULL,'21.0g',0.06,NULL,NULL,NULL,NULL,NULL,1,334.863833,0.49411,0.133,NULL,52157479837,814960622,12733759,21),(155418,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SN 2005fe',NULL,155418,39.81,0.08,751,73437,70,NULL,'SDSS-II SN 01316','SDSS J221927.32+002938.8',0.217,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155419,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01316','R',155419,40.35,0.22,970,73437,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fe','SDSS J221927.32+002938.8',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155420,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 01316','R',155420,40.51,0.16,1050,73437,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fe','SDSS J221927.32+002938.8',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155421,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155421,33.85,0.8,58.8,73438,75,NULL,'W91PP, r','NGC 7253A',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00002,NULL,'14.4',0.5,'SABc','Pair member (points to parent)',NULL,NULL,NULL,1,334.865458333,29.39581,0.261,NULL,55445290989,866332671,13536447,14.4),(155422,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155422,33.72,0.49,55.6,73438,75,NULL,'IR','NGC 7253A',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155423,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155423,33.99,0.38,62.9,73438,75,NULL,'W91PP, r, raw','NGC 7253A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155424,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155424,34.18,0.38,68.6,73438,75,NULL,'W91PP, r, inv','NGC 7253A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155425,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155425,34.31,0.38,72.7,73438,75,NULL,'W91PP, r, cor','NGC 7253A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155426,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155426,36.86,0.46,235,73439,70,NULL,NULL,'2MASX J22192944-0110088',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000173,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,334.872583,-1.16914,0.177,NULL,49809802013,778278156,12160596,17.3),(155427,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15122','RN',155427,40.22,0.3,1050,73440,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15122',0.056573,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155428,'SNIa SDSS','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 15122','RN',155428,41.41,0.55,1810,73440,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15122',0.056573,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155429,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155429,33.8,0.8,57.5,73441,75,NULL,'W91PP, r','NGC 7253B',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000033,NULL,'13.2B',0.5,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,334.875417,29.38778,0.261,NULL,55445290845,866332669,13536447,13.2),(155430,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155430,32.8,0.38,36.4,73441,75,NULL,'W91PP, r, inv','NGC 7253B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155431,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155431,32.81,0.38,36.5,73441,75,NULL,'W91PP, r, raw','NGC 7253B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155432,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155432,33.15,0.38,42.7,73441,75,NULL,'W91PP, r, cor','NGC 7253B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155433,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155433,36.51,0.46,201,73442,70,NULL,NULL,'2MASX J22193314-0846514',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000141,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,334.888125,-8.781,0.157,NULL,49843795601,778809306,12168895,17.5),(155434,'IRAS','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155434,34.04,0.8,64.2,73443,75,NULL,'MAT, I','IC 5199',NULL,'1997ApJS..109..333W',1997,1,1.61,NULL,'G',0.000033,NULL,'14.43',0.3,'SAb: sp        HII',NULL,NULL,NULL,NULL,1,334.888416667,-37.53381,0,NULL,50554905990,789920406,12342506,14.43),(155435,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155435,33.97,0.47,62.3,73443,NULL,NULL,'H','IC 5199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155436,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155436,33.99,0.43,62.8,73443,75,NULL,'MAT, I, raw','IC 5199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155437,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155437,34.03,0.45,63.9,73443,NULL,NULL,'K','IC 5199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155438,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155438,34.05,0.4,64.5,73443,NULL,NULL,'mean','IC 5199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155439,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155439,34.08,0.49,65.5,73443,75,NULL,'IR','IC 5199',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155440,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155440,34.11,0.32,66.5,73443,85,NULL,'I, raw','IC 5199',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155441,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155441,34.12,0.46,66.6,73443,NULL,NULL,'J','IC 5199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155442,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155442,34.13,0.41,67.1,73443,NULL,NULL,'Malmquist cor.','IC 5199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155443,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155443,34.14,0.41,67.2,73443,NULL,NULL,NULL,'IC 5199',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155444,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155444,34.16,0.32,68,73443,85,NULL,'I, inv','IC 5199',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155445,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155445,34.2,0.43,69.3,73443,75,NULL,'MAT, I, inv','IC 5199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155446,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155446,34.24,0.43,70.6,73443,75,NULL,'MAT, I, cor','IC 5199',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155447,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155447,34.5,0.2,79.4,73443,74.4,NULL,NULL,'IC 5199',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155448,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155448,36.61,0.58,210,73444,70,NULL,NULL,'2MASX J22193484-6251212',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000103,NULL,'16.31',0.42,'S',NULL,NULL,NULL,NULL,1,334.895125,-62.85589,0,NULL,48755505929,761804780,11903199,16.31),(155449,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155449,33.7,0.2,55,73445,74.4,NULL,NULL,'ESO 533- G 013',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000017,NULL,'15.38',0.2,'Sc',NULL,NULL,NULL,NULL,1,334.910166667,-25.33239,0.057,NULL,50066926109,782295720,12223370,15.38),(155450,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155450,33.8,0.55,57.6,73445,NULL,NULL,NULL,'ESO 533- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155451,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155451,33.84,0.49,58.5,73445,75,NULL,'IR','ESO 533- G 013',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155452,'Tully-Fisher','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,NULL,155452,33.91,0.52,60.6,73445,NULL,NULL,'Malmquist cor.','ESO 533- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155453,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155453,37.13,0.33,267,73446,70,NULL,NULL,'SDSS J221941.36+122848.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000145,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,334.922375,12.48011,0.221,NULL,52245274299,816332410,12755193,18.1),(155454,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155454,36.16,0.46,171,73447,70,NULL,NULL,'2MASX J22194275+1346126',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,334.928125,13.77011,0.181,NULL,52246077523,816344961,12755390,17.1),(155455,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 13072','R',155455,40.29,0.21,930,73448,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fi','SN 2006fi',0.230633,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,334.959417,0.02439,0.129,NULL,52145715104,814776798,12730887,NULL),(155456,'SNIa','2016-12-15 15:15:59','2016-12-16 11:21:15','1','SDSS-II SN 13072','R',155456,40.32,0.16,940,73448,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fi','SN 2006fi',0.230633,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155457,'FP','2016-12-15 15:15:59','2016-12-16 11:21:15','1',NULL,'R',155457,38.39,0.46,477,73449,70,NULL,NULL,'2MASX J22195432-0802322',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000188,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,334.976291667,-8.04228,0.165,NULL,49843526577,778805102,12168829,17.5),(155458,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 09652',NULL,155458,40.59,1,1310,73450,70,NULL,'SN photometric redshift distance, z photo =0.373 +/- 0.327','SDSS-II SN 09652',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.985583,-0.43767,0.165,NULL,49809608298,778275129,12160548,20.6),(155459,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 05641',NULL,155459,41.53,0.06,2030,73451,70,NULL,'SN photometric redshift distance, z photo =0.672 +/- 0.028','SDSS-II SN 05641',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,334.985583,-0.43767,0.165,NULL,49809608298,778275129,12160548,20.6),(155460,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 20156','RN',155460,43.67,0.28,3690,73452,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20156',0.468247,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155461,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155461,38.04,0.33,406,73453,70,NULL,NULL,'2MASX J22195707+1311438',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,334.9877917,13.19561,0.177,NULL,52248068206,816376065,12755876,18),(155462,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155462,37.13,0.33,267,73454,70,NULL,NULL,'2MASX J22200344+1226498',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000133,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.014417,12.44733,0.221,NULL,52245243456,816331929,12755186,17.5),(155463,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155463,37.76,0.46,357,73455,70,NULL,NULL,'SDSS J222006.54+001504.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,335.0272917,0.25119,0.137,NULL,52145905657,814779775,12730933,18.3),(155464,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155464,34.79,0.53,90.6,73456,NULL,NULL,NULL,'UGC 11987',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00011,NULL,'15.18',0.3,'SB?',NULL,NULL,NULL,NULL,1,335.0332083,9.01769,0.233,NULL,52174408413,815225131,12737892,15.18),(155465,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155465,34.85,0.2,93.3,73456,74.4,NULL,NULL,'UGC 11987',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155466,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155466,34.93,0.49,96.9,73456,NULL,NULL,'Malmquist cor.','UGC 11987',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155467,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155467,38.04,0.46,406,73457,70,NULL,NULL,'2MASX J22200902-0926031',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000159,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,335.0375417,-9.43431,0.173,NULL,49829750366,778589849,12165466,18),(155468,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155468,38,0.33,399,73458,70,NULL,NULL,'2MASX J22200931-0847361',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000141,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.0389583,-8.79339,0.157,NULL,49843624825,778806637,12168853,17.9),(155469,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 18243',NULL,155469,40.14,0.2,1060,73459,70,NULL,'SN photometric redshift distance, z photo =0.289 +/- 0.033','SDSS-II SN 18243',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.044875,-0.74008,0.165,NULL,49809628629,778275447,12160553,NULL),(155470,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155470,36.79,0.58,228,73460,70,NULL,NULL,'2MASX J22201081-5658204',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.000103,NULL,'16.67',0.38,NULL,NULL,NULL,NULL,NULL,1,335.045167,-56.97225,0,NULL,48704671494,761010492,11890788,16.67),(155471,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155471,45.92,0.77,6550,73461,NULL,NULL,NULL,'GRB 071117',1.331,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,335.043917,-63.44331,0,NULL,48755080741,761798136,11903095,NULL),(155472,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2006lm',NULL,155472,39.85,0.13,933,73462,70,NULL,'Hubble residual -0.19 for z0.27470','SDSS-II SN 15356 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,335.053333,0.40994,0.133,NULL,52145833452,814778647,12730916,NULL),(155473,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 15356','R',155473,40.55,0.22,1010,73462,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006lm','SDSS-II SN 15356 HOST',0.274927,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155474,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 15356','R',155474,40.79,0.16,1130,73462,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006lm','SDSS-II SN 15356 HOST',0.274927,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155475,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2006lm',NULL,155475,40.42,0.12,1210,73462,70,NULL,'SALT 2','SDSS-II SN 15356 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155476,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2006lm',NULL,155476,40.44,0.12,1220,73462,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15356 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155477,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155477,38.04,0.33,406,73463,70,NULL,NULL,'2MASX J22201282+1314488',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000166,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.0535,13.24689,0.177,NULL,52244531690,816320807,12755012,17.8),(155478,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155478,36.63,0.46,211,73464,70,NULL,NULL,'2MASX J22201851+1245347',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,335.07725,12.75958,0.189,NULL,52245186147,816331033,12755172,16.7),(155479,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','PTF10viq','N',155479,35.86,0.03,144,73465,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10viq',0.0342,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155480,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155480,34.09,0.47,65.9,73466,NULL,NULL,'H','UGC 11991',NULL,'2007A&A...465...71T',2007,1,1.8,'abs(b) < 10 degrees.','G',0.000033,NULL,'14.53',0.9,'Scd:',NULL,NULL,NULL,NULL,1,335.094583,47.70592,NULL,NULL,55539228230,867800441,13559381,14.53),(155481,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155481,34.16,0.46,68,73466,NULL,NULL,'J','UGC 11991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155482,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155482,34.19,0.45,68.9,73466,NULL,NULL,'K','UGC 11991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155483,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155483,34.33,0.4,73.3,73466,NULL,NULL,'mean','UGC 11991',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155484,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155484,38,0.33,399,73467,70,NULL,NULL,'2MASX J22202729-0849591',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.113833,-8.83322,0.165,NULL,49843628748,778806699,12168854,18.1),(155485,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155485,37.2,0.46,276,73468,70,NULL,NULL,'2MASX J22203058+0017469',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000161,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,335.127375,0.29653,0.137,NULL,52145941727,814780339,12730942,17.3),(155486,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155486,37.38,0.88,300,73469,70,NULL,NULL,'2MASX J22203125-1611156',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'17.07',0.4,NULL,NULL,NULL,NULL,NULL,1,335.1302083,-16.18772,0.073,NULL,50237712235,784964253,12265066,17.07),(155487,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 14811',NULL,155487,38.66,2.38,539,73470,70,NULL,'SN photometric redshift distance, z photo =0.135 +/- 0.353','SDSS-II SN 14811',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.133083,-0.76697,0.165,NULL,49810313879,778286154,12160721,NULL),(155488,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155488,38,0.46,398,73471,70,NULL,NULL,'2MASX J22203369-0847081',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,335.1405,-8.78561,0.165,NULL,49843903408,778810990,12168921,17.7),(155489,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155489,35.79,0.67,144,73472,70,NULL,NULL,'2MASX J22203456-0829361',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.3g',0.24,'S0',NULL,NULL,NULL,NULL,1,335.1440417,-8.49336,0.177,NULL,49844046782,778813230,12168956,16.3),(155490,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155490,37.13,0.46,266,73473,70,NULL,NULL,'2MASX J22203697+0000403',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.154125,0.01131,0.129,NULL,52145789846,814777966,12730905,17.9),(155491,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155491,34.01,0.49,63.4,73474,75,NULL,'IR','UGC 11993',NULL,'2011yCatp016004901K',2011,1,1.32,NULL,'G',0.001114,NULL,'16.0',0.16,'Scd',NULL,NULL,NULL,NULL,1,335.165417,35.22228,0.517,NULL,55485580529,866962195,13546284,16),(155492,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155492,34.84,NULL,93,73474,NULL,NULL,'Dipole','UGC 11993',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155493,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155493,34.85,NULL,93.1,73474,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11993',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155494,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155494,34.85,NULL,93.2,73474,NULL,NULL,'Dipole + Quadrupole','UGC 11993',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155495,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 08382','RN',155495,38.84,0.39,538,73475,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08382',0.087041,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155496,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 08382','RN',155496,38.88,0.32,550,73475,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08382',0.087041,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155497,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 20396','RN',155497,43.48,0.4,3710,73476,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20396',0.336125,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155498,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 20396','RN',155498,43.55,0.46,3840,73476,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20396',0.336125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155499,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155499,33.79,0.45,57.2,73477,NULL,NULL,'K','NGC 7252',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000003,NULL,'12.74',1.6,'(R)SA(r)0^0^:  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,335.1864583,-24.67828,0.049,NULL,50066706679,782292291,12223317,12.74),(155500,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155500,33.89,0.4,60.1,73477,NULL,NULL,'mean','NGC 7252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155501,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155501,36.42,0.65,193,73478,70,NULL,NULL,'2MASX J22204571-5506093',NULL,'2014MNRAS.445.2677S',2014,1,0.8,'Loveday (1996,MNRAS,278,1025) position at midpoint of two galaxies.','G',0.00015,NULL,'15.36',0.53,'S0','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,335.190417,-55.10258,0,NULL,48703971570,760999555,11890618,15.36),(155502,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155502,33.67,0.2,54.2,73479,74.4,NULL,NULL,'UGC 11992',NULL,'2013AJ....146...86T',2013,1,0.88,NULL,'G',0.000003,NULL,'15.5g',0.59,'Sd:',NULL,NULL,NULL,NULL,1,335.197208333,14.23461,0.149,NULL,52364182686,818190354,12784224,15.5),(155503,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155503,37.99,0.33,396,73480,70,NULL,NULL,'2MASX J22204779+1319337',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,335.199125,13.32597,0.181,NULL,52244571412,816321428,12755022,17.9),(155504,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155504,38.59,0.46,522,73481,70,NULL,NULL,'2MASXi J2220518+121354',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,335.215625,12.23178,0.173,NULL,52244474629,816319916,12754998,18),(155505,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2002dl',NULL,155505,34.34,0.2,72.5,73482,70,NULL,'SALT 2','UGC 11994',0.016251,'2013MNRAS.433.2240G',2013,1,2.69,NULL,'G',0.000033,NULL,'14.85',0.3,'Sc',NULL,NULL,NULL,NULL,1,335.221333,33.29533,0.385,NULL,55498875414,867169928,13549530,14.85),(155506,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155506,33.99,0.8,62.8,73482,75,NULL,'W91PP, r','UGC 11994',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155507,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155507,33.77,0.49,56.8,73482,75,NULL,'IR','UGC 11994',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155508,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155508,33.81,0.38,57.9,73482,75,NULL,'W91PP, r, raw','UGC 11994',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155509,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155509,33.87,0.47,59.3,73482,NULL,NULL,'H','UGC 11994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155510,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155510,33.87,NULL,59.5,73482,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155511,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155511,33.87,NULL,59.5,73482,NULL,NULL,'Dipole + Quadrupole','UGC 11994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155512,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155512,33.88,NULL,59.6,73482,NULL,NULL,'Dipole','UGC 11994',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155513,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155513,33.96,0.46,61.9,73482,NULL,NULL,'J','UGC 11994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155514,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155514,33.96,NULL,62,73482,NULL,NULL,NULL,'UGC 11994',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155515,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155515,33.97,0.45,62.3,73482,NULL,NULL,'K','UGC 11994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155516,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155516,33.99,0.38,62.8,73482,75,NULL,'W91PP, r, inv','UGC 11994',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155517,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155517,34.09,0.2,65.8,73482,74.4,NULL,NULL,'UGC 11994',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155518,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155518,34.11,0.43,66.4,73482,75,NULL,'3.6 micron, color corrected','UGC 11994',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155519,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155519,34.15,0.38,67.7,73482,75,NULL,'W91PP, r, cor','UGC 11994',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155520,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155520,34.16,0.4,68.1,73482,NULL,NULL,'mean','UGC 11994',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155521,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155521,34.18,0.43,68.7,73482,75,NULL,'3.6 micron, color + selection bias corrected','UGC 11994',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155522,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155522,34.23,0.38,70.2,73482,NULL,NULL,NULL,'UGC 11994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155523,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155523,34.33,0.37,73.4,73482,NULL,NULL,'Malmquist cor.','UGC 11994',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155524,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155524,30.29,0.8,11.4,73483,75,NULL,'MAT, I','IC 5201',NULL,'1997ApJS..109..333W',1997,1,8.5,'The APM position is 0.5 arcmin north of the center of the bar.','G',0.000007,NULL,'11.3',3.9,'SB(s)cd        Sy2','Group non-member, foreground',NULL,NULL,NULL,1,335.239333333,-46.03586,0,NULL,50695985424,792124772,12376949,11.3),(155525,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155525,29.38,0.4,7.5,73483,73,NULL,'opt','IC 5201',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155526,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155526,29.57,0.32,8.17,73483,85,NULL,'I, inv','IC 5201',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155527,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155527,29.6,0.32,8.29,73483,85,NULL,'I, raw','IC 5201',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155528,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155528,29.72,NULL,8.79,73483,NULL,NULL,NULL,'IC 5201',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155529,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155529,29.82,0.36,9.2,73483,NULL,NULL,NULL,'IC 5201',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155530,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155530,30,0.4,10,73483,NULL,NULL,'mean','IC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155531,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155531,30.07,0.53,10.3,73483,NULL,NULL,NULL,'IC 5201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155532,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155532,30.09,0.43,10.4,73483,75,NULL,'3.6 micron, color + selection bias corrected','IC 5201',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155533,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155533,30.12,0.2,10.6,73483,74.4,NULL,NULL,'IC 5201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155534,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155534,30.13,0.43,10.6,73483,75,NULL,'MAT, I, inv','IC 5201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155535,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155535,30.17,0.43,10.8,73483,75,NULL,'MAT, I, raw','IC 5201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155536,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155536,30.18,0.43,10.8,73483,75,NULL,'3.6 micron, color corrected','IC 5201',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155537,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155537,30.22,0.4,11.1,73483,75,NULL,'B','IC 5201',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155538,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155538,30.55,0.43,12.9,73483,75,NULL,'MAT, I, cor','IC 5201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155539,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155539,30.69,0.4,13.7,73483,NULL,NULL,'Malmquist cor.','IC 5201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155540,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155540,31.9,0.46,24,73483,NULL,NULL,'J','IC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155541,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155541,31.94,0.47,24.4,73483,NULL,NULL,'H','IC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155542,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,NULL,155542,31.94,0.45,24.4,73483,NULL,NULL,'K','IC 5201',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155543,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 21172','RN',155543,40.96,0.56,1330,73484,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21172',0.171339,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155544,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 21172','RN',155544,41.6,0.8,1780,73484,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21172',0.171339,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155545,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155545,37.99,0.33,396,73485,70,NULL,NULL,'2MASX J22205978+1326023',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000145,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.249125,13.43414,0.181,NULL,52244527584,816320743,12755011,17.8),(155546,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07527','R',155546,40.36,0.17,955,73486,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07527',0.237,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,335.256333,-1.20414,0.177,NULL,49810148254,778283566,12160680,NULL),(155547,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07527','R',155547,40.54,0.28,1040,73486,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07527',0.237,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155548,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 15345','R',155548,40.54,0.25,1000,73487,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15345',0.2802,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,335.25675,0.81053,0.153,NULL,52158138092,814970907,12733920,NULL),(155549,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 15345','R',155549,40.79,0.17,1120,73487,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15345',0.2802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155550,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155550,39.37,0.13,613,73488,74.2,NULL,'SALT 2','SDSS J222102.65-004453.4',0.22,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,335.2610417,-0.74817,0.153,NULL,49809588272,778274816,12160544,NULL),(155551,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155551,39.88,0.05,776,73488,70,NULL,'SDSS-II SN 08495','SDSS J222102.65-004453.4',0.22,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155552,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155552,40.12,0.13,864,73488,65,NULL,'SALT2','SDSS J222102.65-004453.4',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155553,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 08495','R',155553,40.12,0.21,868,73488,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005mi','SDSS J222102.65-004453.4',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155554,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155554,40.28,0.13,932,73488,65,NULL,'MLCS2k2','SDSS J222102.65-004453.4',0.22,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155555,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 08495','R',155555,40.29,0.13,936,73488,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005mi','SDSS J222102.65-004453.4',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155556,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155556,40.05,0.1,1020,73488,70,NULL,'SALT 2','SDSS J222102.65-004453.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155557,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SN 2005mi',NULL,155557,40.07,0.1,1030,73488,70,NULL,'SALT 2, Malmquist cor.','SDSS J222102.65-004453.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155558,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 20397',NULL,155558,40.28,0.16,1140,73489,70,NULL,'SN photometric redshift distance, z photo =0.312 +/- 0.030','SDSS-II SN 20397',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.2727917,-1.06131,0.165,NULL,49810079591,778282493,12160663,NULL),(155559,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857','R',155559,41.33,0.27,1350,73490,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07857',0.371262,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.2780417,1.18522,0.173,NULL,52157680299,814963754,12733808,21.4),(155560,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857','R',155560,41.56,0.33,1500,73490,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07857',0.371262,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155561,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857',NULL,155561,40.97,0.22,1560,73490,70,NULL,'SN photometric redshift distance, z photo =0.466 +/- 0.068','SDSS-II SN 07857',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155562,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857',NULL,155562,41.47,0.21,1970,73490,70,NULL,'SALT 2','SDSS-II SN 07857',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155563,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:15','1','SDSS-II SN 07857',NULL,155563,41.53,0.21,2020,73490,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07857',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155564,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155564,37.73,0.46,352,73491,70,NULL,NULL,'2MASX J22210864-0105505',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000155,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,335.2860417,-1.09739,0.177,NULL,49810078698,778282479,12160663,17.5),(155565,'FP','2016-12-15 15:16:00','2016-12-16 11:21:15','1',NULL,'R',155565,37.62,0.46,334,73492,70,NULL,NULL,'2MASX J22210974-0835000',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.290541667,-8.58322,0.189,NULL,49844009264,778812644,12168947,17.7),(155566,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155566,38.17,0.46,431,73493,70,NULL,NULL,'2MASX J22211638-0903537',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000194,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.318333333,-9.065,0.165,NULL,49829774320,778590223,12165472,17.4),(155567,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15357',NULL,155567,40.2,0.25,1100,73494,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.045','SDSS-II SN 15357',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.3372917,0.23419,0.137,NULL,52145778279,814777785,12730902,NULL),(155568,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155568,38.11,0.46,418,73495,70,NULL,NULL,'2MASX J22212391-0805047',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,335.349625,-8.08467,0.173,NULL,49835269807,778676090,12166813,17.7),(155569,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155569,37.2,0.46,275,73496,70,NULL,NULL,'2MASX J22212657-0853227',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,335.3607083,-8.88953,0.165,NULL,49843868266,778810441,12168913,16.3),(155570,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155570,36.33,0.54,184,73497,70,NULL,NULL,'2MASX J22212716-0838497',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.7g',0.29,'S0/a',NULL,NULL,NULL,NULL,1,335.363125,-8.64717,0.189,NULL,49843994951,778812421,12168944,15.7),(155571,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02074','RN',155571,40.75,0.43,1100,73498,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02074',0.287541,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155572,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02074','RN',155572,40.82,0.33,1140,73498,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02074',0.287541,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155573,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155573,37.64,0.46,337,73499,70,NULL,NULL,'2MASXi J2221276+125609',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,335.364875,12.93625,0.185,NULL,52244649682,816322651,12755041,18.3),(155574,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155574,34.95,0.49,97.7,73500,75,NULL,'IR','UGC 11996',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'16.5',0.1,'S?',NULL,NULL,NULL,NULL,1,335.368791667,12.50992,0.161,NULL,52244367175,816318237,12754972,16.5),(155575,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155575,37.31,0.33,290,73501,70,NULL,NULL,'SDSS J222130.35+001616.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00022,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.3765,0.27133,0.145,NULL,52146641627,814791275,12731113,18.1),(155576,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16958',NULL,155576,40.22,0.39,1110,73502,70,NULL,'SN photometric redshift distance, z photo =0.303 +/- 0.074','SDSS-II SN 16958',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.380333333,-0.26911,0.141,NULL,49796705427,778073522,12157398,NULL),(155577,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14227',NULL,155577,41.32,0.26,1840,73503,70,NULL,'SN photometric redshift distance, z photo =0.582 +/- 0.114','SDSS-II SN 14227',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.38425,-0.63161,0.153,NULL,49796805207,778075081,12157423,NULL),(155578,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155578,37.31,0.33,290,73504,70,NULL,NULL,'2MASX J22213246+0016455',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.31',0.32,'AGN',NULL,NULL,NULL,NULL,1,335.385125,0.27928,0.145,NULL,52146641418,814791272,12731113,16.31),(155579,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15313','RN',155579,43.13,0.25,2760,73505,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15313',0.534226,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155580,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155580,36.35,0.67,186,73506,70,NULL,NULL,'2MASX J22213556-0658346',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.20',0.32,NULL,NULL,NULL,NULL,NULL,1,335.3982083,-6.97647,0.229,NULL,49836692688,778698323,12167161,17.2),(155581,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155581,35.97,0.52,156,73507,70,NULL,NULL,'2MASX J22213585-4845013',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.55',0.6,'S0',NULL,NULL,NULL,NULL,1,335.3994583,-48.75039,0,NULL,50693555008,792086797,12376356,15.55),(155582,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13317','RN',155582,41.34,0.15,1390,73508,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13317',0.331451,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155583,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13317','RN',155583,41.69,0.23,1630,73508,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13317',0.331451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155584,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155584,37.23,0.33,279,73509,70,NULL,NULL,'SDSS J222139.86-082623.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,335.416125,-8.43992,0.201,NULL,49843938055,778811532,12168930,17.9),(155585,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155585,37.23,0.33,279,73510,70,NULL,NULL,'2MASX J22214017-0825266',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.33,'AGN',NULL,NULL,NULL,NULL,1,335.4175,-8.42389,0.201,NULL,49843941136,778811580,12168930,16.4),(155586,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10411','RN',155586,43.23,0.39,2770,73511,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10411',0.596841,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155587,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155587,37.71,0.46,348,73512,70,NULL,NULL,'2MASX J22214405-0854516',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000161,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.4334583,-8.91419,0.165,NULL,49843197735,778799964,12168749,17.6),(155588,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06903','R',155588,40.27,0.22,905,73513,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J222146.45+005818.3',0.253,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.01,NULL,'19.6g',0.08,'BrClG',NULL,NULL,NULL,NULL,1,335.443583,0.97175,0.157,NULL,52146311784,814786121,12731033,19.6),(155589,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06903','R',155589,40.44,0.16,976,73513,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J222146.45+005818.3',0.253,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155590,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06903',NULL,155590,40.03,0.12,1010,73513,70,NULL,'SALT 2','SDSS J222146.45+005818.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155591,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06903',NULL,155591,40.05,0.12,1020,73513,70,NULL,'SALT 2, Malmquist cor.','SDSS J222146.45+005818.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155592,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155592,32.62,0.49,33.5,73514,75,NULL,'IR','UGC 11999',NULL,'2011yCatp016004901K',2011,1,0.86,NULL,'G',0.000023,NULL,'17.',0.11,'Sdm',NULL,NULL,NULL,NULL,1,335.461708333,42.95119,1.193,NULL,55562580054,868165313,13565083,17),(155593,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155593,33.87,NULL,59.4,73514,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 11999',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155594,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155594,33.89,NULL,60,73514,NULL,NULL,'Dipole + Quadrupole','UGC 11999',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155595,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155595,33.9,NULL,60.2,73514,NULL,NULL,'Dipole','UGC 11999',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155596,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155596,33.95,NULL,61.8,73514,NULL,NULL,NULL,'UGC 11999',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155597,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155597,36.98,0.46,249,73515,70,NULL,NULL,'2MASX J22215280+1352355',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000151,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,335.4699583,13.87661,0.165,NULL,52364072958,818188639,12784197,17.5),(155598,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155598,37.32,0.46,292,73516,70,NULL,NULL,'2MASX J22215567-0103191',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'18.17',0.18,NULL,NULL,NULL,NULL,NULL,1,335.482,-1.05531,0.165,NULL,49810094216,778282722,12160667,18.17),(155599,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155599,36.8,0.65,229,73517,70,NULL,NULL,'2MASX J22220249-6252327',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.67',0.35,NULL,NULL,NULL,NULL,NULL,1,335.5105,-62.87583,0,NULL,48755278529,761801227,11903144,16.67),(155600,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155600,34.86,0.47,93.6,73518,NULL,NULL,'Malmquist cor.','ESO 602- G 010',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.33',0.5,'Sb-c           HII',NULL,NULL,NULL,NULL,1,335.511625,-19.57306,0.049,NULL,50206379340,784474677,12257416,14.33),(155601,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155601,34.95,0.45,97.7,73518,NULL,NULL,NULL,'ESO 602- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155602,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155602,34.99,0.2,99.5,73518,74.4,NULL,NULL,'ESO 602- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155603,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155603,35.8,0.55,144,73519,NULL,NULL,'Malmquist cor.','AGC 320755',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'14.6I',0.3,NULL,NULL,NULL,NULL,NULL,1,335.546667,2.93083,0.189,NULL,52159579182,814993424,12734272,14.6),(155604,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155604,35.83,0.54,147,73519,NULL,NULL,NULL,'AGC 320755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155605,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155605,35.96,0.2,156,73519,74.4,NULL,NULL,'AGC 320755',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155606,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155606,33.67,0.8,54.2,73520,75,NULL,'W91PP, r','NGC 7264',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000033,NULL,'14.58',0.3,'Sb',NULL,NULL,NULL,NULL,1,335.557417,36.387,0.589,NULL,55483050250,866922660,13545666,14.58),(155607,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155607,33.9,0.4,60.1,73520,NULL,NULL,'mean','NGC 7264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155608,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155608,34.18,0.38,68.4,73520,75,NULL,'W91PP, r, raw','NGC 7264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155609,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155609,34.26,0.49,71,73520,75,NULL,'IR','NGC 7264',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155610,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155610,34.26,0.45,71.2,73520,NULL,NULL,'K','NGC 7264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155611,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155611,34.27,0.46,71.6,73520,NULL,NULL,'J','NGC 7264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155612,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155612,34.36,0.47,74.5,73520,NULL,NULL,'H','NGC 7264',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155613,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155613,34.42,0.38,76.7,73520,75,NULL,'W91PP, r, inv','NGC 7264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155614,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155614,34.42,0.38,76.7,73520,75,NULL,'W91PP, r, cor','NGC 7264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155615,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155615,34.58,0.4,82.6,73520,70,NULL,'H, UH88/IRSF/2MASS','NGC 7264',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155616,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155616,34.58,0.4,82.6,73520,70,NULL,'H, 2MASS','NGC 7264',NULL,'2011A&A...531A..87I',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155617,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155617,34.7,0.43,87,73520,75,NULL,'3.6 micron, color corrected','NGC 7264',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155618,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155618,34.71,0.43,87.4,73520,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7264',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155619,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155619,34.79,0.2,90.8,73520,74.4,NULL,NULL,'NGC 7264',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155620,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155620,37.11,0.46,264,73521,70,NULL,NULL,'2MASX J22221389+1212464',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000138,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.5580417,12.21286,0.161,NULL,52361703076,818151610,12783618,17.4),(155621,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155621,37.82,0.75,366,73522,70,NULL,NULL,'2MASX J22221681-1015284',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.55',0.25,NULL,NULL,NULL,NULL,NULL,1,335.570083,-10.25789,0.129,NULL,49832020212,778625315,12166020,16.55),(155622,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00700','RN',155622,42.48,0.21,1960,73523,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00700',0.595712,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155623,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155623,37.41,0.15,303,73524,70,NULL,NULL,'2MASX J22221969-0856074',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.1g',0.43,'S0',NULL,NULL,NULL,NULL,1,335.582,-8.93533,0.189,NULL,49843165883,778799466,12168741,16.1),(155624,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155624,36.28,0.75,181,73525,70,NULL,NULL,'2MASX J22222109-0807494',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.0g',0.37,'S0/a',NULL,NULL,NULL,NULL,1,335.587833,-8.13058,0.213,NULL,49835539373,778680302,12166879,16),(155625,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155625,35.31,0.32,116,73526,NULL,NULL,'Malmquist cor.','2MASX J22222570+0244036',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',NULL,NULL,'16.00',0.31,NULL,NULL,NULL,NULL,NULL,1,335.607166667,2.73436,0.185,NULL,52159616292,814994004,12734281,16),(155626,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155626,35.34,0.32,117,73526,NULL,NULL,NULL,'2MASX J22222570+0244036',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155627,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155627,35.61,0.2,132,73526,74.4,NULL,NULL,'2MASX J22222570+0244036',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155628,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155628,35.15,0.36,107,73527,NULL,NULL,NULL,'UGC 12000',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',NULL,NULL,'15.38',0.5,'S?',NULL,NULL,NULL,NULL,1,335.607166667,2.86047,0.189,NULL,52159590389,814993599,12734274,15.38),(155629,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155629,35.19,0.2,109,73527,74.4,NULL,NULL,'UGC 12000',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155630,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155630,35.22,0.35,111,73527,NULL,NULL,'Malmquist cor.','UGC 12000',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155631,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155631,37.52,0.33,320,73528,70,NULL,NULL,'SDSS J222228.33+142002.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,335.6180417,14.33397,0.129,NULL,52364608308,818197004,12784328,18.6),(155632,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05128','RN',155632,41.48,0.31,1480,73529,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05128',0.329451,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155633,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05128','RN',155633,42.34,0.31,2210,73529,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05128',0.329451,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155634,'TRGB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155634,29.52,0.1,8.02,73530,74.4,NULL,NULL,'ESO 238- G 005',NULL,'2013AJ....146...86T',2013,1,2.9,'The APMUKS data apply to the short bar.','G',0.00001,NULL,'15.6',1.3,'IABm',NULL,NULL,NULL,NULL,1,335.62525,-48.40489,0,NULL,50693609629,792087650,12376369,15.6),(155635,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155635,29.62,0.8,8.4,73530,75,NULL,NULL,'ESO 238- G 005',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155636,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155636,29.46,NULL,7.8,73530,NULL,NULL,NULL,'ESO 238- G 005',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155637,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10072','RN',155637,40.74,0.07,1150,73531,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 10072',0.223609,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155638,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10072','RN',155638,40.86,0.2,1220,73531,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10072',0.223609,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155639,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155639,34.34,0.45,73.7,73532,70,NULL,NULL,'IC 5210',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000087,NULL,'14.21',1.1,'SA0-:','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,335.629625,-18.86969,0.049,NULL,50252415112,785193986,12268656,14.21),(155640,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155640,37.79,0.46,361,73533,70,NULL,NULL,'SDSS J222233.31-083807.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000152,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.638791667,-8.63533,0.201,NULL,49843119583,778798743,12168730,18.2),(155641,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01985',NULL,155641,39.39,0.61,755,73534,70,NULL,'SN photometric redshift distance, z photo =0.195 +/- 0.074','SDSS-II SN 01985',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,335.640416667,1.04061,0.173,NULL,52146451066,814788297,12731067,21.3),(155642,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01985','R',155642,40.55,0.28,1070,73534,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01985',0.201287,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155643,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155643,32.23,0.69,27.9,73535,100,NULL,'mid-IR','NGC 7254',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.00001,NULL,'13.88',0.6,'S(r?)b',NULL,NULL,NULL,NULL,1,335.650958333,-21.73722,0.049,NULL,50213813702,784590839,12259231,13.88),(155644,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155644,34.05,0.54,64.4,73536,70,NULL,NULL,'NGC 7257',NULL,'2014MNRAS.445.2677S',2014,1,1.9,NULL,'G',0.000027,NULL,'13.66',1.4,'SAB(rs)bc      HII',NULL,NULL,NULL,NULL,1,335.651833333,-4.12075,0.149,NULL,49806749505,778230461,12159850,13.66),(155645,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155645,33.96,0.8,61.9,73536,75,NULL,'MAT, I','NGC 7257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155646,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155646,34.11,0.43,66.2,73536,75,NULL,'MAT, I, raw','NGC 7257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155647,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155647,34.18,0.32,68.4,73536,85,NULL,'I, raw','NGC 7257',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155648,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155648,34.24,0.32,70.5,73536,85,NULL,'I, inv','NGC 7257',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155649,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155649,34.25,0.21,70.7,73536,NULL,NULL,'Malmquist cor.','NGC 7257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155650,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155650,34.29,0.4,72.3,73536,NULL,NULL,'mean','NGC 7257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155651,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155651,34.31,0.43,72.7,73536,75,NULL,'MAT, I, cor','NGC 7257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155652,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155652,34.31,0.21,72.9,73536,NULL,NULL,NULL,'NGC 7257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155653,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155653,34.34,0.2,73.8,73536,74.4,NULL,NULL,'NGC 7257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155654,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155654,34.39,0.43,75.5,73536,75,NULL,'MAT, I, inv','NGC 7257',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155655,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155655,34.45,0.45,77.6,73536,NULL,NULL,'K','NGC 7257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155656,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155656,34.45,0.46,77.6,73536,NULL,NULL,'J','NGC 7257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155657,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155657,34.45,0.47,77.8,73536,NULL,NULL,'H','NGC 7257',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155658,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155658,36.39,0.46,190,73537,70,NULL,NULL,'2MASX J22224039-0839523',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000149,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.668416667,-8.66447,0.201,NULL,49843123206,778798800,12168731,17.3),(155659,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03172','RN',155659,40.61,0.24,1010,73538,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03172',0.316958,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155660,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03172','RN',155660,40.71,0.37,1050,73538,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03172',0.316958,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155661,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155661,35.12,0.47,106,73539,70,NULL,NULL,'IC 5211',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000073,NULL,'14.69',0.7,'S?','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,335.679416667,-18.88022,0.049,NULL,50252304330,785192255,12268628,14.69),(155662,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155662,35.2,0.49,110,73540,75,NULL,'IR','ESO 467- G 047',NULL,'2011yCatp016004901K',2011,1,1,'Sometimes mistakenly called IC 5214.','G',0.000033,NULL,'15.22',0.2,'Sb?            HII',NULL,NULL,NULL,NULL,1,335.6810417,-27.35569,0,NULL,50546855851,789794622,12340540,15.22),(155663,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155663,35.48,0.4,125,73540,NULL,NULL,'Malmquist cor.','ESO 467- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155664,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155664,35.6,0.37,132,73540,NULL,NULL,NULL,'ESO 467- G 047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155665,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155665,35.64,0.2,134,73540,74.4,NULL,NULL,'ESO 467- G 047',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155666,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09278','RN',155666,42.71,0.32,2550,73541,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 09278',0.365207,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155667,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09278','RN',155667,43.47,0.4,3620,73541,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09278',0.365207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155668,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155668,32.63,0.8,33.6,73542,75,NULL,'MAT, I','ESO 602- G 015',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000022,NULL,'15.35',0.3,'SB(s)c',NULL,NULL,NULL,NULL,1,335.711,-20.34983,0.033,NULL,50209885471,784529460,12258272,15.35),(155669,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155669,32.44,0.32,30.7,73542,85,NULL,'I, inv','ESO 602- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155670,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155670,32.48,0.32,31.3,73542,85,NULL,'I, raw','ESO 602- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155671,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155671,32.64,0.1,33.8,73542,NULL,NULL,NULL,'ESO 602- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155672,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155672,32.71,0.43,34.9,73542,75,NULL,'MAT, I, inv','ESO 602- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155673,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155673,32.81,0.43,36.4,73542,75,NULL,'MAT, I, raw','ESO 602- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155674,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155674,33.07,0.2,41.1,73542,74.4,NULL,NULL,'ESO 602- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155675,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155675,33.08,0.43,41.2,73542,75,NULL,'MAT, I, cor','ESO 602- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155676,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155676,33.14,0.4,42.5,73542,NULL,NULL,NULL,'ESO 602- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155677,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155677,33.22,0.43,44.1,73542,75,NULL,'3.6 micron, color corrected','ESO 602- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155678,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155678,33.34,0.43,46.5,73542,75,NULL,'3.6 micron, color + selection bias corrected','ESO 602- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155679,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155679,36.69,0.55,217,73543,70,NULL,NULL,'2MASX J22225293-1737491',NULL,'2014MNRAS.445.2677S',2014,1,0.25,NULL,'G',0.00015,NULL,'16.50',0.18,NULL,NULL,NULL,NULL,NULL,1,335.7207083,-17.63042,0.053,NULL,50235553938,784930530,12264539,16.5),(155680,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155680,36,0.46,159,73544,70,NULL,NULL,'2MASX J22225305+1326593',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000171,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,335.721125,13.44978,0.185,NULL,52362437819,818163090,12783798,16.7),(155681,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155681,37.52,0.33,320,73545,70,NULL,NULL,'SDSS J222255.31+141703.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000139,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.7305,14.28433,0.129,NULL,52364143973,818189749,12784214,18),(155682,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155682,33.41,0.8,48.1,73546,75,NULL,'MAT, I','NGC 7258',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.92',0.6,'Sb:            HII',NULL,NULL,NULL,NULL,1,335.7419583,-28.34514,0,NULL,50542827131,789731673,12339557,13.92),(155683,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155683,33.14,0.32,42.4,73546,85,NULL,'I, raw','NGC 7258',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155684,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155684,33.17,0.32,43,73546,85,NULL,'I, inv','NGC 7258',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155685,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155685,33.26,0.43,45,73546,75,NULL,'MAT, I, raw','NGC 7258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155686,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155686,33.42,0.43,48.3,73546,75,NULL,'MAT, I, inv','NGC 7258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155687,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155687,33.52,0.47,50.6,73546,NULL,NULL,'H','NGC 7258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155688,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155688,33.54,0.4,51,73546,NULL,NULL,'mean','NGC 7258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155689,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155689,33.56,0.43,51.6,73546,75,NULL,'MAT, I, cor','NGC 7258',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155690,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155690,33.6,0.46,52.5,73546,NULL,NULL,'J','NGC 7258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155691,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155691,33.61,0.45,52.8,73546,NULL,NULL,'K','NGC 7258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155692,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155692,37.41,0.15,303,73547,70,NULL,NULL,'2MASX J22225951-0908008',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,335.747875,-9.13369,0.137,NULL,49829612359,778587693,12165432,17),(155693,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155693,37.3,0.46,289,73548,70,NULL,NULL,'2MASX J22225973-0800328',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000137,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.748917,-8.00919,0.217,NULL,49835657800,778682153,12166908,18),(155694,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155694,36.99,0.46,250,73549,70,NULL,NULL,'2MASX J22230145+1346284',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00018,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,335.756083,13.77464,0.185,NULL,52365346208,818208534,12784508,16.6),(155695,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155695,33.26,0.69,44.9,73550,100,NULL,'mid-IR','UGC 12012',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000033,NULL,'15.06',0.7,'Sb',NULL,NULL,NULL,NULL,1,335.760125,35.82086,0.493,NULL,55485752818,866964887,13546326,15.06),(155696,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155696,34.14,0.4,67.4,73550,NULL,NULL,'mean','UGC 12012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155697,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155697,34.44,0.47,77.4,73550,NULL,NULL,'H','UGC 12012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155698,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155698,34.54,0.46,81,73550,NULL,NULL,'J','UGC 12012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155699,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155699,34.56,0.45,81.6,73550,NULL,NULL,'K','UGC 12012',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155700,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02125','RN',155700,41.56,0.09,1580,73551,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02125',0.299129,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155701,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155701,32.47,0.8,31.1,73552,75,NULL,'MAT, I','ESO 027- G 008',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000033,NULL,'12.94',1.1,'SAB(s)c',NULL,NULL,NULL,NULL,1,335.7675,-79.99694,0.429,NULL,48569690226,758901409,11857834,12.94),(155702,'Sosies','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155702,32.44,0.08,30.8,73552,NULL,NULL,NULL,'ESO 027- G 008',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155703,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155703,31.68,0.8,21.7,73552,75,NULL,NULL,'ESO 027- G 008',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155704,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155704,32.15,0.43,26.9,73552,75,NULL,'MAT, I, raw','ESO 027- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155705,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155705,32.18,0.32,27.3,73552,85,NULL,'I, raw','ESO 027- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155706,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155706,32.22,0.32,27.8,73552,85,NULL,'I, inv','ESO 027- G 008',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155707,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155707,32.34,0.43,29.4,73552,75,NULL,'MAT, I, inv','ESO 027- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155708,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155708,32.46,0.43,31,73552,75,NULL,'MAT, I, cor','ESO 027- G 008',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155709,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155709,32.87,0.4,37.5,73552,73,NULL,'opt','ESO 027- G 008',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155710,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155710,32.9,0.42,38.1,73552,NULL,NULL,NULL,'ESO 027- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155711,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155711,32.95,0.2,38.9,73552,74.4,NULL,NULL,'ESO 027- G 008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155712,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155712,32.95,0.41,39,73552,NULL,NULL,'Malmquist cor.','ESO 027- G 008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155713,'SNII optical','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2009ip',NULL,155713,31.52,0.08,20.1,73553,NULL,NULL,NULL,'NGC 7259',NULL,'2013MNRAS.431L..98P',2013,1,1.1,'This pair is made up of ESO 467- G 050 + ESO 467- G 051.','G',0.000018,NULL,'13.88',0.9,'Sb','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,335.773,-28.95483,0,NULL,50544557815,789758715,12339979,13.88),(155714,'SNII optical','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2009ip','R',155714,31.52,0.08,20.1,73553,NULL,NULL,'Dense Shell Method (Baade ruler)','NGC 7259',NULL,'2013JETPL..98..432B',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155715,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155715,37.77,0.46,358,73554,70,NULL,NULL,'2MASX J22230652+0018277',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.77725,0.30767,0.153,NULL,52146155915,814783686,12730995,17.6),(155716,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155716,37.18,0.46,273,73555,70,NULL,NULL,'2MASX J22231032-0004119',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,335.793125,-0.06992,0.149,NULL,49796581769,778071590,12157368,18),(155717,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02513','RN',155717,41.7,0.24,1470,73556,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02513',0.493724,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155718,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155718,38.04,0.46,405,73557,70,NULL,NULL,'SDSS J222311.25+141000.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000127,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,335.796917,14.16669,0.129,NULL,52364169533,818190148,12784221,18.4),(155719,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20398','RN',155719,41.37,0.23,1480,73558,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20398',0.266266,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155720,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20398','RN',155720,42.19,0.35,2170,73558,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20398',0.266266,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155721,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155721,38.01,0.46,400,73559,70,NULL,NULL,'2MASX J22231363-0927404',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000176,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,335.806875,-9.46131,0.137,NULL,49829552696,778586760,12165418,17.5),(155722,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155722,35.4,0.67,120,73560,70,NULL,NULL,'2MASX J22231469-6019495',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.93',0.27,NULL,NULL,NULL,NULL,NULL,1,335.811083,-60.33047,0,NULL,48802016024,762531500,11914554,16.93),(155723,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155723,39.77,0.15,714,73561,74.2,NULL,'SALT 2','SDSS J222315.50+001513.3',0.26,'2010ApJ...716..712A',2010,1,0.08,NULL,'G',0.0005,NULL,'20.4g',0.07,NULL,NULL,NULL,NULL,NULL,1,335.814625,0.25369,0.157,NULL,52146208573,814784508,12731007,20.4),(155724,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155724,39.91,0.17,957,73561,70,NULL,'Hubble residual -0.01 for z0.25690','SDSS J222315.50+001513.3',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155725,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155725,40.51,0.19,1000,73561,65,NULL,'SALT2','SDSS J222315.50+001513.3',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155726,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155726,40.51,0.17,1000,73561,70,NULL,'SDSS-II SN 09457, SALT 2','SDSS J222315.50+001513.3',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155727,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09457','R',155727,40.52,0.23,1010,73561,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005li','SDSS J222315.50+001513.3',0.2569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155728,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09457','R',155728,40.65,0.2,1070,73561,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005li','SDSS J222315.50+001513.3',0.2569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155729,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155729,40.71,0.19,1100,73561,65,NULL,'MLCS2k2','SDSS J222315.50+001513.3',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155730,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005li',NULL,155730,40.76,0.07,1130,73561,70,NULL,'SDSS-II SN 09457','SDSS J222315.50+001513.3',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155731,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155731,31.74,0.8,22.3,73562,75,NULL,'MAT, I','ESO 467- G 051',NULL,'1997ApJS..109..333W',1997,1,3.64,NULL,'G',0.00001,NULL,'14.79',0.34,'Sdm','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,335.819208333,-28.98097,0,NULL,50544551775,789758621,12339978,14.79),(155732,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155732,30.89,0.32,15.1,73562,85,NULL,'I, inv','ESO 467- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155733,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155733,30.95,0.32,15.5,73562,85,NULL,'I, raw','ESO 467- G 051',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155734,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155734,31.24,0.43,17.7,73562,75,NULL,'MAT, I, inv','ESO 467- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155735,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155735,31.36,NULL,18.7,73562,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 467- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155736,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155736,31.38,0.43,18.9,73562,75,NULL,'MAT, I, raw','ESO 467- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155737,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155737,31.39,NULL,19,73562,NULL,NULL,'Dipole + Quadrupole','ESO 467- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155738,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155738,31.4,NULL,19,73562,NULL,NULL,'Dipole','ESO 467- G 051',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155739,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155739,31.45,NULL,19.5,73562,NULL,NULL,NULL,'ESO 467- G 051',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155740,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155740,31.72,0.43,22.1,73562,75,NULL,'MAT, I, cor','ESO 467- G 051',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155741,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155741,32.27,0.43,28.5,73563,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12010',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000113,NULL,'15.33',0.2,'Sab',NULL,NULL,NULL,NULL,1,335.8280417,5.53386,0.245,NULL,52203190718,815674854,12744919,15.33),(155742,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155742,32.7,0.49,34.7,73563,75,NULL,'IR','UGC 12010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155743,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01776','RN',155743,41.19,0.31,1150,73564,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01776',0.507319,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155744,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155744,37.18,0.55,273,73565,70,NULL,NULL,'2MASX J22232467-5743291',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.35',0.21,NULL,NULL,NULL,NULL,NULL,1,335.852958333,-57.72478,0,NULL,48674997696,760546839,11883544,17.35),(155745,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155745,37.41,0.15,303,73566,70,NULL,NULL,'SDSS J222326.25-090543.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000136,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,335.859375,-9.09542,0.141,NULL,49829407211,778584487,12165382,18.5),(155746,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155746,37.41,0.15,303,73567,70,NULL,NULL,'2MASX J22232625-0903214',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000154,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,335.8594583,-9.05608,0.141,NULL,49829405646,778584463,12165382,17.2),(155747,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155747,38.18,0.46,432,73568,70,NULL,NULL,'2MASX J22232639+0004573',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,335.86,0.08264,0.157,NULL,52145995296,814781176,12730955,18),(155748,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155748,35.16,0.45,107,73569,NULL,NULL,NULL,'IC 5207',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.13',0.9,'SA(s)c',NULL,NULL,NULL,NULL,1,335.8727083,-60.56497,0,NULL,48790430141,762350470,11911726,15.13),(155749,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155749,35.2,0.2,110,73569,74.4,NULL,NULL,'IC 5207',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155750,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155750,35.28,0.43,114,73569,NULL,NULL,'Malmquist cor.','IC 5207',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155751,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155751,37.1,0.46,263,73570,70,NULL,NULL,'2MASX J22232997-0112086',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,335.874875,-1.20233,0.145,NULL,49796118424,778064350,12157255,18.1),(155752,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155752,37.05,0.55,258,73571,70,NULL,NULL,'2MASX J22233236-6312014',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.82',0.63,'S0',NULL,NULL,NULL,NULL,1,335.8847917,-63.20039,0,NULL,48754928543,761795758,11903058,15.82),(155753,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155753,37.41,0.15,303,73572,70,NULL,NULL,'2MASX J22233254-0904374',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.3g',0.39,'BrClG',NULL,NULL,NULL,NULL,1,335.8857083,-9.07719,0.141,NULL,49829438451,778584975,12165390,16.3),(155754,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01903','RN',155754,39.82,0.06,846,73573,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01903',0.090148,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155755,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01903','RN',155755,40.1,0.18,962,73573,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01903',0.090148,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155756,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155756,32.42,0.8,30.5,73574,75,NULL,'MAT, I','ESO 289- G 026',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000021,NULL,'14.33',1.3,'SB(s)cd',NULL,NULL,NULL,NULL,1,335.888458333,-42.27458,0,NULL,50730916689,792670573,12385477,14.33),(155757,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155757,32.41,0.8,30.3,73574,75,NULL,NULL,'ESO 289- G 026',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155758,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155758,31.29,0.32,18.1,73574,85,NULL,'I, inv','ESO 289- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155759,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155759,31.34,0.32,18.5,73574,85,NULL,'I, raw','ESO 289- G 026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155760,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155760,31.61,0.4,21,73574,NULL,NULL,NULL,'ESO 289- G 026',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155761,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155761,31.61,0.4,21,73574,73,NULL,'opt','ESO 289- G 026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155762,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155762,31.75,0.43,22.4,73574,75,NULL,'MAT, I, inv','ESO 289- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155763,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155763,31.84,0.43,23.3,73574,75,NULL,'MAT, I, raw','ESO 289- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155764,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155764,32.1,0.43,26.3,73574,75,NULL,'MAT, I, cor','ESO 289- G 026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155765,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155765,32.48,0.1,31.4,73574,NULL,NULL,NULL,'ESO 289- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155766,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155766,36.47,0.58,197,73575,70,NULL,NULL,'2MASX J22233372-8019543',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.7b',0.23,NULL,NULL,NULL,NULL,NULL,1,335.8902083,-80.33175,0.441,NULL,48567452096,758866439,11857288,16.7),(155767,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155767,37.32,0.72,291,73576,70,NULL,NULL,'2MASX J22233643-5452382',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.95',0.33,NULL,NULL,NULL,NULL,NULL,1,335.901875,-54.87731,0,NULL,48701832569,760966133,11890095,16.95),(155768,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155768,34.73,0.8,88.3,73577,75,NULL,'W91PP, r','UGC 12018',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000033,NULL,'14.73',0.4,'SBb?',NULL,NULL,NULL,NULL,1,335.904125,30.857,0.389,NULL,55493169442,867080772,13548137,14.73),(155769,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155769,34.39,0.38,75.7,73577,75,NULL,'W91PP, r, raw','UGC 12018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155770,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155770,34.6,0.38,83.3,73577,75,NULL,'W91PP, r, inv','UGC 12018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155771,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155771,34.65,0.38,85.1,73577,75,NULL,'W91PP, r, cor','UGC 12018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155772,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155772,34.74,0.34,88.6,73577,NULL,NULL,NULL,'UGC 12018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155773,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155773,34.74,0.49,88.8,73577,75,NULL,'IR','UGC 12018',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155774,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155774,34.74,0.34,88.9,73577,NULL,NULL,'Malmquist cor.','UGC 12018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155775,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155775,34.79,0.2,90.8,73577,74.4,NULL,NULL,'UGC 12018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155776,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155776,34.97,0.4,98.8,73577,NULL,NULL,'mean','UGC 12018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155777,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155777,35.12,0.47,106,73577,NULL,NULL,'H','UGC 12018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155778,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155778,35.17,0.45,108,73577,NULL,NULL,'K','UGC 12018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155779,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155779,35.27,0.46,113,73577,NULL,NULL,'J','UGC 12018',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155780,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155780,36.71,0.46,220,73578,70,NULL,NULL,'2MASX J22233853-0747024',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,335.9105,-7.78403,0.209,NULL,49835091490,778673304,12166770,17.1),(155781,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155781,37.41,0.15,303,73579,70,NULL,NULL,'2MASX J22233853-0842104',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,335.910666667,-8.70294,0.145,NULL,49834667459,778666679,12166666,17.2),(155782,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155782,33,0.51,39.8,73580,70,NULL,NULL,'MCG -01-57-004',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00002,NULL,'13.25',1.1,'S0^0^',NULL,NULL,NULL,NULL,1,335.913167,-3.43161,0.157,NULL,49806459687,778225932,12159780,13.25),(155783,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155783,37.41,0.15,303,73581,70,NULL,NULL,'2MASX J22234163-0840240',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000148,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,335.9234583,-8.67342,0.145,NULL,49834664023,778666625,12166666,17),(155784,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155784,37.84,0.46,369,73582,70,NULL,NULL,'2MASX J22234231-0934340',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,335.926167,-9.57606,0.137,NULL,49829568873,778587013,12165422,16.7),(155785,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155785,35.08,0.47,104,73583,NULL,NULL,'H','ESO 533- G 024',NULL,'2007A&A...465...71T',2007,1,1.4,'1996ApJS..107...97M has z = 0.021942 +- 0.000033.','G',0.000103,NULL,'13.96',0.7,'Sb-c           HII',NULL,NULL,NULL,NULL,1,335.92675,-26.61267,0,NULL,50064478972,782257483,12222773,13.96),(155786,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155786,35.08,0.4,104,73583,NULL,NULL,'mean','ESO 533- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155787,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155787,35.17,0.48,108,73583,NULL,NULL,'Malmquist cor.','ESO 533- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155788,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155788,35.19,0.46,109,73583,NULL,NULL,'J','ESO 533- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155789,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155789,35.24,0.45,112,73583,NULL,NULL,'K','ESO 533- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155790,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155790,35.32,0.45,116,73583,NULL,NULL,NULL,'ESO 533- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155791,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155791,35.36,0.2,118,73583,74.4,NULL,NULL,'ESO 533- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155792,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155792,36.04,0.67,161,73584,70,NULL,NULL,'2MASX J22234415-7317177',NULL,'2014MNRAS.445.2677S',2014,1,0.31,NULL,'G',0.00015,NULL,'16.3b',0.23,NULL,NULL,NULL,NULL,NULL,1,335.93425,-73.28825,0.053,NULL,48414849276,756482019,11820031,16.3),(155793,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155793,37.41,0.15,303,73585,70,NULL,NULL,'2MASX J22234710-0910090',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,335.9462917,-9.16914,0.141,NULL,49829434778,778584918,12165389,17.4),(155794,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155794,34.7,0.4,87.3,73586,NULL,NULL,'mean','UGC 12020',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000023,NULL,'15.00',1.3,'SBa',NULL,NULL,NULL,NULL,1,335.947083,35.38994,0.517,NULL,55485845775,866966340,13546349,15),(155795,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155795,35.17,0.45,108,73586,NULL,NULL,'K','UGC 12020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155796,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155796,35.2,0.47,110,73586,NULL,NULL,'H','UGC 12020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155797,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155797,35.27,0.46,113,73586,NULL,NULL,'J','UGC 12020',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155798,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155798,34.71,0.8,87.4,73587,75,NULL,'W91PP, r','NGC 7270',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000033,NULL,'14.88',0.6,'S?             HII','Group member',NULL,NULL,NULL,1,335.9480417,32.40303,0.325,NULL,55495102266,867110972,13548608,14.88),(155799,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155799,34.94,0.4,97.3,73587,NULL,NULL,'mean','NGC 7270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155800,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155800,35.15,0.46,107,73587,NULL,NULL,'J','NGC 7270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155801,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155801,35.17,0.47,108,73587,NULL,NULL,'H','NGC 7270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155802,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155802,35.24,0.45,111,73587,NULL,NULL,'K','NGC 7270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155803,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155803,35.31,0.38,116,73587,75,NULL,'W91PP, r, raw','NGC 7270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155804,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155804,35.44,0.38,123,73587,75,NULL,'W91PP, r, cor','NGC 7270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155805,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155805,35.65,0.38,135,73587,75,NULL,'W91PP, r, inv','NGC 7270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155806,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155806,33.45,NULL,49,73588,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2388',NULL,'2010Ap&SS.325..163P',2010,1,0.77,NULL,'G',0.000009,NULL,'16.7',0.1,'Sdm',NULL,NULL,NULL,NULL,1,335.96,6.89806,0.253,NULL,52169132221,815142690,12736604,16.7),(155807,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155807,33.48,NULL,49.7,73588,NULL,NULL,'Dipole + Quadrupole','FGC 2388',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155808,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155808,33.51,NULL,50.2,73588,NULL,NULL,'Dipole','FGC 2388',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155809,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155809,33.71,NULL,55.2,73588,NULL,NULL,NULL,'FGC 2388',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155810,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155810,37.41,0.15,303,73589,70,NULL,NULL,'2MASX J22235505-0851130',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,335.979333,-8.85364,0.141,NULL,49834677400,778666834,12166669,17.2),(155811,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05233','RN',155811,41.87,0.23,1940,73590,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05233',0.217327,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155812,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05233','RN',155812,41.99,0.35,2060,73590,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05233',0.217327,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155813,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155813,35.61,0.51,133,73591,70,NULL,NULL,'MCG -02-57-001',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.00015,NULL,'15.5',0.2,NULL,NULL,NULL,NULL,NULL,1,335.9999583,-11.14139,0.141,NULL,50349156905,786705576,12292274,15.5),(155814,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15340','R',155814,39.31,0.11,633,73592,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006mu','SN 2006mu',0.1475,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,336.002833333,0.82136,0.145,NULL,52146802507,814793789,12731152,NULL),(155815,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15340','R',155815,39.41,0.21,663,73592,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006mu','SN 2006mu',0.1475,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155816,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15936','RN',155816,44.65,0.73,6610,73593,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15936',0.284505,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155817,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15936','RN',155817,44.72,1.21,6840,73593,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15936',0.284505,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155818,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155818,34.66,0.8,85.5,73594,75,NULL,'W91PP, r','UGC 12022',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.89',0.5,'Sbc',NULL,NULL,NULL,NULL,1,336.0117083,33.43692,0.341,NULL,55496699946,867135936,13548999,14.89),(155819,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155819,34.58,0.38,82.3,73594,75,NULL,'W91PP, r, raw','UGC 12022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155820,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155820,34.68,0.37,86.2,73594,NULL,NULL,'Malmquist cor.','UGC 12022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155821,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155821,34.7,0.36,87.1,73594,NULL,NULL,NULL,'UGC 12022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155822,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155822,34.75,0.38,89.2,73594,75,NULL,'W91PP, r, cor','UGC 12022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155823,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155823,34.76,0.2,89.5,73594,74.4,NULL,NULL,'UGC 12022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155824,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155824,34.76,0.38,89.6,73594,75,NULL,'W91PP, r, inv','UGC 12022',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155825,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155825,34.79,0.49,90.6,73594,75,NULL,'IR','UGC 12022',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155826,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155826,34.88,0.4,94.5,73594,NULL,NULL,'mean','UGC 12022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155827,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155827,35.09,0.47,104,73594,NULL,NULL,'H','UGC 12022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155828,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155828,35.15,0.45,107,73594,NULL,NULL,'K','UGC 12022',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155829,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155829,36,0.56,159,73595,70,NULL,NULL,'2MASX J22240855-6913110',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.78',0.36,'E',NULL,NULL,NULL,NULL,1,336.035625,-69.21972,0.013,NULL,49324085375,770688833,12042013,16.78),(155830,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17924','RN',155830,38.66,0.2,471,73596,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17924',0.145721,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155831,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17924','RN',155831,38.96,0.13,539,73596,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 17924',0.145721,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155832,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155832,34.64,0.4,84.7,73597,NULL,NULL,'mean','NGC 7274',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00009,NULL,'13.77',1.5,'E','Triplet member, first-ranked galaxy',NULL,NULL,NULL,1,336.046291667,36.12586,0.489,NULL,55482941314,866920958,13545639,13.77),(155833,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155833,35.25,0.45,112,73597,NULL,NULL,'K','NGC 7274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155834,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155834,37.28,0.46,286,73598,70,NULL,NULL,'2MASXi J2224113+142139',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.0475,14.36086,0.145,NULL,52364905598,818201649,12784400,18),(155835,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155835,34.19,0.4,68.9,73599,NULL,NULL,'Malmquist cor.','UGC 12021',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.97',0.5,'Sb',NULL,NULL,NULL,NULL,1,336.048375,6.00361,0.273,NULL,52202414001,815662718,12744729,14.97),(155836,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155836,34.21,0.2,69.5,73599,74.4,NULL,NULL,'UGC 12021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155837,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155837,34.27,0.38,71.5,73599,NULL,NULL,NULL,'UGC 12021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155838,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155838,38.13,0.46,422,73600,70,NULL,NULL,'2MASX J22241201+1426324',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.05,14.44236,0.161,NULL,52364458390,818194662,12784291,17.8),(155839,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19731','RN',155839,40.37,0.26,1040,73601,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19731',0.144637,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155840,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19731','RN',155840,41.08,0.4,1430,73601,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19731',0.144637,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155841,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155841,36,0.51,158,73602,70,NULL,NULL,'2MASX J22241661-8026098',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.1b',0.22,NULL,NULL,NULL,NULL,NULL,1,336.0692917,-80.43589,0.425,NULL,48567639618,758869369,11857333,16.1),(155842,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155842,33.72,0.49,55.5,73603,75,NULL,'IR','NGC 7275',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.17',0.2,'Sa','Group member',NULL,NULL,NULL,1,336.0717917,32.44625,0.325,NULL,55491956199,867061815,13547840,15.17),(155843,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155843,34.74,0.47,88.8,73603,NULL,NULL,'H','NGC 7275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155844,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155844,34.88,0.46,94.5,73603,NULL,NULL,'J','NGC 7275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155845,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155845,34.89,0.4,94.9,73603,NULL,NULL,'mean','NGC 7275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155846,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155846,34.91,0.45,96.1,73603,NULL,NULL,'K','NGC 7275',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155847,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155847,38.08,0.46,412,73604,70,NULL,NULL,'2MASX J22241910-0957159',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.079625,-9.95442,0.141,NULL,50351444803,786741325,12292833,18),(155848,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155848,37.49,0.46,315,73605,70,NULL,NULL,'2MASX J22242021-0835469',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000178,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,336.084208333,-8.59642,0.149,NULL,49834725249,778667582,12166680,16.9),(155849,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155849,31.34,0.47,18.6,73606,NULL,NULL,'H','NGC 7267',NULL,'2007A&A...465...71T',2007,1,1.6,'Position in 1997AJ....113.1548C is incorrect.','G',0.00004,NULL,'13.23',1.3,'(R\'_1)SB(rs)a  HII',NULL,NULL,NULL,NULL,1,336.090875,-33.69408,0,NULL,50599015706,790609620,12353275,13.23),(155850,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155850,31.47,0.46,19.7,73606,NULL,NULL,'J','NGC 7267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155851,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155851,31.5,0.45,19.9,73606,NULL,NULL,'K','NGC 7267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155852,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155852,32.74,0.4,35.3,73606,NULL,NULL,'mean','NGC 7267',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155853,'CMD','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155853,21.56,0.2,0.205,73607,NULL,NULL,NULL,'Pegasus III',NULL,'2015ApJ...804L..44K',2015,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,349.261583333,9.81156,0.097,1,51742450353,808475786,12632434,NULL),(155854,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155854,34.54,0.6,80.9,73608,NULL,NULL,NULL,'VV 483',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000017,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,336.0972917,18.07144,0.209,NULL,52370607765,818290746,12785792,15.3),(155855,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155855,34.58,0.2,82.4,73608,74.4,NULL,NULL,'VV 483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155856,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155856,35.05,0.47,102,73608,NULL,NULL,'Malmquist cor.','VV 483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155857,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155857,35.82,0.62,146,73609,70,NULL,NULL,'2MASX J22242651-8011078',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'16.9b',0.19,NULL,NULL,NULL,NULL,NULL,1,336.110875,-80.18547,0.441,NULL,48569751171,758902362,11857849,16.9),(155858,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03177','RN',155858,39.58,0.24,718,73610,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03177',0.147618,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155859,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03177','RN',155859,39.62,0.17,732,73610,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03177',0.147618,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155860,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16711','RN',155860,41.93,0.37,1820,73611,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16711',0.339034,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155861,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14475','RN',155861,38.76,0.11,494,73612,70,NULL,'SDSS CAND. SNIc; MLCS2K2','SDSS-II SN 14475',0.144045,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155862,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14475','RN',155862,38.99,0.19,548,73612,70,NULL,'SDSS CAND. SNIc; SALT 2','SDSS-II SN 14475',0.144045,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155863,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155863,37.18,0.46,273,73613,70,NULL,NULL,'2MASX J22243211-0915299',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.133917,-9.25831,0.141,NULL,50350584831,786727887,12292623,17.9),(155864,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155864,35.24,0.55,112,73614,70,NULL,NULL,'MCG -01-57-008',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000047,NULL,'15.25',0.5,'SBb',NULL,NULL,NULL,NULL,1,336.13675,-4.75181,0.181,NULL,49804014068,778187719,12159183,15.25),(155865,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155865,37.55,0.46,324,73615,70,NULL,NULL,'SDSS J222435.22+131616.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000148,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,336.146791667,13.27125,0.193,NULL,52362511393,818164240,12783816,18.6),(155866,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05797','RN',155866,42.15,0.19,2130,73616,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05797',0.260602,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155867,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05797','RN',155867,42.22,0.2,2200,73616,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05797',0.260602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155868,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13344','RN',155868,40.24,0.26,925,73617,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13344',0.207977,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155869,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13344','RN',155869,40.42,0.21,1000,73617,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13344',0.207977,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155870,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155870,36.15,0.46,170,73618,70,NULL,NULL,'2MASX J22244636+1356550',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000157,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,336.193167,13.94861,0.181,NULL,52365840934,818216264,12784629,16.9),(155871,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155871,37.38,0.46,299,73619,70,NULL,NULL,'2MASX J22244717-0835144',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000142,NULL,'17.0g',0.32,NULL,NULL,NULL,NULL,NULL,1,336.196541667,-8.58733,0.149,NULL,50358025860,786844154,12294439,17),(155872,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01136','RN',155872,39.64,0.19,760,73620,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01136',0.11268,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155873,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20548','RN',155873,41.33,0.29,1570,73621,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20548',0.172999,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155874,'D-Sigma','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155874,35.25,0.4,112,73622,75,NULL,'Edat, raw','ESO 467- G 054',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000067,NULL,'14.89',0.6,'S0-',NULL,NULL,NULL,NULL,1,336.2107083,-31.32581,0,NULL,50589341034,790458453,12350913,14.89),(155875,'D-Sigma','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155875,35.59,0.4,131,73622,75,NULL,'Edat, cor','ESO 467- G 054',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155876,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155876,36.08,0.47,165,73623,70,NULL,NULL,'2MASX J22245142-5825363',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.000103,NULL,'15.59',1,'E3:',NULL,NULL,NULL,NULL,1,336.2142083,-58.42669,0,NULL,48675528191,760555127,11883673,15.59),(155877,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00703','R',155877,40.8,0.24,1110,73624,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J222452.32+003902.8',0.3,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.01,NULL,'21.9g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,336.218,0.65081,0.161,NULL,52147168764,814799511,12731242,21.9),(155878,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00703','R',155878,40.86,0.17,1140,73624,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J222452.32+003902.8',0.3,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155879,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00703',NULL,155879,40.69,0.14,1370,73624,70,NULL,'SALT 2','SDSS J222452.32+003902.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155880,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00703',NULL,155880,40.72,0.14,1390,73624,70,NULL,'SALT 2, Malmquist cor.','SDSS J222452.32+003902.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155881,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155881,37.35,0.46,295,73625,70,NULL,NULL,'2MASX J22245359-0856234',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000143,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,336.223375,-8.93997,0.141,NULL,50357925437,786842584,12294415,17.4),(155882,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16831','RN',155882,41.59,0.33,1440,73626,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16831',0.446155,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155883,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16831','RN',155883,41.97,0.44,1720,73626,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16831',0.446155,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155884,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155884,36.7,0.88,218,73627,70,NULL,NULL,'2MASX J22245614-4355163',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.83',0.23,NULL,NULL,NULL,NULL,NULL,1,336.2339583,-43.92117,0,NULL,50727259052,792613422,12384584,16.83),(155885,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03506',NULL,155885,39.33,0.21,734,73628,70,NULL,'SN photometric redshift distance, z photo =0.189 +/- 0.022','SDSS-II SN 03506',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.250625,-0.97822,0.137,NULL,49798798555,778106227,12157909,NULL),(155886,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155886,38.17,0.46,431,73629,70,NULL,NULL,'2MASX J22250276-0733044',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000186,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,336.261625,-7.55128,0.225,NULL,49834888923,778670139,12166720,17.5),(155887,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05114','RN',155887,42.9,0.26,2430,73630,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05114',0.565177,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155888,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155888,38.21,0.23,439,73631,70,NULL,NULL,'2MASX J22250505+1336008',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000172,NULL,'17.4g',0.24,'BrClG',NULL,NULL,NULL,NULL,1,336.2712083,13.60011,0.161,NULL,52365500103,818210939,12784545,17.4),(155889,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155889,38.21,0.23,439,73632,70,NULL,NULL,'SDSS J222505.25+133742.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000169,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,336.271916667,13.62839,0.161,NULL,52365498314,818210911,12784545,18.7),(155890,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155890,43.16,0.23,2540,73633,NULL,NULL,NULL,'GRB 080916',0.689,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,336.276375,-57.02297,0,NULL,48696739933,760886561,11888852,NULL),(155891,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155891,35.94,0.5,154,73634,70,NULL,NULL,'ESO 048- G 022',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.0001,NULL,'14.87',0.9,'S0',NULL,NULL,NULL,NULL,1,336.27925,-72.58822,0.025,NULL,48410967345,756421364,11819083,14.87),(155892,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155892,37.02,0.9,253,73635,70,NULL,NULL,'2MASX J22250713-0206292',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.44',0.22,NULL,NULL,NULL,NULL,NULL,1,336.2797083,-2.10811,0.137,NULL,49808859688,778263432,12160366,16.44),(155893,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155893,38.21,0.23,439,73636,70,NULL,NULL,'2MASX J22250896+1334548',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.2875,13.58203,0.161,NULL,52365497268,818210894,12784545,18.1),(155894,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 07529','RN',155894,41.51,0.32,1540,73637,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07529',0.300125,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155895,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 07529','RN',155895,42.29,0.41,2210,73637,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07529',0.300125,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155896,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13827','RN',155896,41.4,0.17,1670,73638,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13827',0.142747,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155897,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13827','RN',155897,41.71,0.22,1920,73638,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13827',0.142747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155898,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155898,36.2,0.56,174,73639,70,NULL,NULL,'2MASX J22251609-5915234',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.29',0.35,'S0',NULL,NULL,NULL,NULL,1,336.3170417,-59.2565,0,NULL,48798363487,762474429,11913662,16.29),(155899,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155899,37.69,0.46,345,73640,70,NULL,NULL,'2MASXi J2225168-081002',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00014,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,336.3202917,-8.16747,0.141,NULL,50358517376,786851834,12294559,17.8),(155900,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155900,37.31,0.46,290,73641,70,NULL,NULL,'2MASX J22252187-0014438',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.341125,-0.24564,0.181,NULL,49795071762,778047996,12156999,18.3),(155901,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155901,38.21,0.23,439,73642,70,NULL,NULL,'2MASX J22252214+1340109',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000166,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,336.34225,13.66964,0.161,NULL,52365555344,818211802,12784559,17.5),(155902,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155902,37.66,0.27,340,73643,70,NULL,NULL,'2MASX J22252324-0842036',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,336.346916667,-8.701,0.149,NULL,50358116927,786845576,12294462,17.5),(155903,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16402','R',155903,40.32,0.24,900,73644,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006sv','SN 2006sv',0.29,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,336.3677083,0.26528,0.149,NULL,52144158508,814752476,12730507,NULL),(155904,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16402','R',155904,40.72,0.13,1080,73644,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006sv','SN 2006sv',0.29,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155905,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155905,37.66,0.27,340,73645,70,NULL,NULL,'2MASX J22252884-0843406',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.00015,NULL,'16.3g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,336.3700417,-8.72794,0.149,NULL,50358118792,786845606,12294462,16.3),(155906,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01987','RN',155906,43.09,0.24,2560,73646,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01987',0.62478,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155907,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155907,35.34,NULL,117,73647,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2390',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000017,NULL,'16.0',0.11,'Sdm',NULL,NULL,NULL,NULL,1,336.3875,18.99547,0.181,NULL,52407587476,818868554,12794821,16),(155908,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155908,35.36,NULL,118,73647,NULL,NULL,'Dipole + Quadrupole','FGC 2390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155909,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155909,35.37,NULL,119,73647,NULL,NULL,'Dipole','FGC 2390',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155910,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155910,35.42,NULL,121,73647,NULL,NULL,NULL,'FGC 2390',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155911,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155911,35.5,0.49,126,73647,75,NULL,'IR','FGC 2390',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155912,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155912,35.01,0.48,100,73648,NULL,NULL,'Malmquist cor.','ESO 533- G 026',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'14.62',0.5,'Sb:',NULL,NULL,NULL,NULL,1,336.391541667,-24.2415,0.041,NULL,50065554458,782274288,12223035,14.62),(155913,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155913,35.04,0.47,102,73648,NULL,NULL,NULL,'ESO 533- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155914,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155914,35.2,0.2,110,73648,74.4,NULL,NULL,'ESO 533- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155915,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155915,37.18,0.46,273,73649,70,NULL,NULL,'2MASX J22253454-0938576',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,336.394,-9.64931,0.153,NULL,50350697940,786729655,12292650,16.5),(155916,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13050','RN',155916,43.96,0.39,4090,73650,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13050',0.510429,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155917,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155917,38.01,0.46,399,73651,70,NULL,NULL,'SDSS J222536.59-002908.8',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00014,NULL,'18.8g',0.1,NULL,NULL,NULL,NULL,NULL,1,336.4024583,-0.48578,0.153,NULL,49798609694,778103276,12157863,18.8),(155918,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663',NULL,155918,40.1,0.2,1050,73652,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.033','SDSS-II SN 15663',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.40725,1.22953,0.141,NULL,52147612487,814806445,12731350,21.4),(155919,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663','R',155919,40.68,0.24,1060,73652,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15663',0.292197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155920,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663','R',155920,40.87,0.19,1160,73652,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15663',0.292197,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155921,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663',NULL,155921,40.57,0.15,1300,73652,70,NULL,'SALT 2','SDSS-II SN 15663',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155922,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15663',NULL,155922,40.6,0.15,1320,73652,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15663',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155923,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155923,35.46,0.49,123,73653,75,NULL,'IR','FGC 2391',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000067,NULL,'16.52',0.12,'Scd',NULL,NULL,NULL,NULL,1,336.434583,39.40219,0.589,NULL,55558574136,868102720,13564105,16.52),(155924,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155924,38.04,0.46,406,73654,70,NULL,NULL,'2MASX J22254796-0954188',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000177,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,336.4497917,-9.90519,0.153,NULL,50351397364,786740583,12292821,17.4),(155925,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02092','RN',155925,39.15,0.3,592,73655,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 02092',0.143391,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155926,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02092','RN',155926,39.56,0.32,713,73655,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02092',0.143391,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155927,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155927,33.19,0.2,43.5,73656,74.4,NULL,NULL,'NGC 7282',NULL,'2013AJ....146...86T',2013,1,2.5,NULL,'G',0.000037,NULL,'14.5',1,'SB(r)b         Sy2',NULL,NULL,NULL,NULL,1,336.474417,40.31486,0.725,NULL,55561941069,868155329,13564927,14.5),(155928,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155928,33.32,0.43,46.2,73656,75,NULL,'3.6 micron, color corrected','NGC 7282',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155929,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155929,33.47,0.43,49.5,73656,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7282',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155930,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155930,33.75,0.47,56.3,73656,NULL,NULL,'H','NGC 7282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155931,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155931,33.9,0.46,60.3,73656,NULL,NULL,'J','NGC 7282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155932,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155932,33.93,0.45,61.1,73656,NULL,NULL,'K','NGC 7282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155933,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155933,33.94,0.4,61.3,73656,NULL,NULL,'mean','NGC 7282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155934,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155934,38.15,0.46,426,73657,70,NULL,NULL,'2MASX J22255508+1323078',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00017,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.479583,13.38553,0.173,NULL,52362194224,818159284,12783738,18.2),(155935,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 09102','RN',155935,41.3,0.49,1550,73658,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09102',0.171605,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155936,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155936,37.85,0.46,371,73659,70,NULL,NULL,'2MASX J22255660-0923058',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000158,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,336.4857917,-9.38508,0.153,NULL,50362300541,786910945,12295483,17.4),(155937,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155937,37.18,0.46,273,73660,70,NULL,NULL,'2MASX J22260133+0015448',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000206,NULL,'16.6g',0.32,'AGN',NULL,NULL,NULL,NULL,1,336.505666667,0.26233,0.149,NULL,52144371497,814755804,12730559,16.6),(155938,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155938,35.69,0.5,137,73661,70,NULL,NULL,'ESO 109- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000103,NULL,'15.62',0.5,'(L)SB(r)0^+',NULL,NULL,NULL,NULL,1,336.516916667,-63.28458,0.005,NULL,48758434827,761850544,11903914,15.62),(155939,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 00702','RN',155939,42.72,0.18,2220,73662,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00702',0.578379,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155940,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155940,37.88,0.46,377,73663,70,NULL,NULL,'2MASX J22260686+0030574',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000182,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.5285417,0.51589,0.161,NULL,52144270609,814754228,12730534,17.9),(155941,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155941,35.97,0.52,156,73664,70,NULL,NULL,'2MASX J22260961-8006083',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'16.8b',0.14,NULL,NULL,NULL,NULL,NULL,1,336.540166667,-80.10239,0.445,NULL,48569724464,758901944,11857842,16.8),(155942,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155942,37.73,0.46,351,73665,70,NULL,NULL,'2MASX J22260969-0751136',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.8g',0.3,'AGN',NULL,NULL,NULL,NULL,1,336.540417,-7.85378,0.141,NULL,50358434307,786850536,12294539,16.8),(155943,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155943,37.66,0.27,340,73666,70,NULL,NULL,'2MASX J22261010-0844346',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000171,NULL,'17.2g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,336.5420417,-8.74303,0.149,NULL,50357947401,786842928,12294420,17.2),(155944,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155944,33.56,0.4,51.5,73667,NULL,NULL,'mean','NGC 7277',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000017,NULL,'14.10',0.6,'(R)Sb:         HII',NULL,NULL,NULL,NULL,1,336.545583,-31.14525,0,NULL,50591292678,790488948,12351389,14.1),(155945,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155945,33.63,0.47,53.2,73667,NULL,NULL,'H','NGC 7277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155946,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155946,33.71,0.46,55.2,73667,NULL,NULL,'J','NGC 7277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155947,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155947,33.75,0.45,56.3,73667,NULL,NULL,'K','NGC 7277',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155948,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155948,35.17,0.46,108,73668,70,NULL,NULL,'CGCG 378-006',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000093,NULL,'14.9g',0.55,'E0',NULL,NULL,NULL,NULL,1,336.560958333,0.66781,0.161,NULL,52147076645,814798072,12731219,14.9),(155949,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155949,36.59,0.64,208,73669,70,NULL,NULL,'2MASX J22261722-7017407',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.74',0.3,NULL,NULL,NULL,NULL,NULL,1,336.571583,-70.29467,0.033,NULL,49315546080,770555407,12039928,16.74),(155950,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05234','RN',155950,41.07,0.36,1550,73670,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05234',0.057989,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155951,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155951,35.57,0.48,130,73671,NULL,NULL,NULL,'CGCG 452-010',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000017,NULL,'15.6',0.4,'Elliptical',NULL,NULL,NULL,NULL,1,336.581917,19.58189,0.173,NULL,52407188353,818862318,12794723,15.6),(155952,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155952,35.6,0.47,132,73671,NULL,NULL,'Malmquist cor.','CGCG 452-010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155953,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155953,35.74,0.2,141,73671,74.4,NULL,NULL,'CGCG 452-010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155954,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155954,31.77,0.22,22.6,73672,NULL,NULL,'I','NGC 7280',NULL,'2003ApJ...583..712J',2003,1,2.2,NULL,'G',0.000017,NULL,'13.01',1.5,'SAB(r)0+       AGN','Pair member (points to parent)',NULL,NULL,NULL,1,336.614917,16.14822,0.213,NULL,52378060351,818407192,12787612,13.01),(155955,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155955,31.93,0.22,24.3,73672,NULL,NULL,'I','NGC 7280',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155956,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155956,31.93,0.14,24.3,73672,74.4,NULL,NULL,'NGC 7280',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155957,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155957,32.09,0.8,26.2,73672,75,NULL,'B','NGC 7280',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155958,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155958,31.6,0.45,20.9,73672,NULL,NULL,'K','NGC 7280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155959,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155959,31.64,0.4,21.3,73672,NULL,NULL,'mean','NGC 7280',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155960,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324',NULL,155960,39.31,0.57,727,73673,70,NULL,'SN photometric redshift distance, z photo =0.187 +/- 0.065','SDSS-II SN 10324',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.0g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.617666667,0.58683,0.161,NULL,52144255119,814753986,12730531,21),(155961,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324','R',155961,40.25,0.24,896,73673,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10324',0.251725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155962,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324',NULL,155962,40.1,0.15,1050,73673,70,NULL,'SALT 2','SDSS-II SN 10324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155963,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324','R',155963,40.6,0.2,1050,73673,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10324',0.251725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155964,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10324',NULL,155964,40.12,0.15,1060,73673,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 10324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155965,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424',NULL,155965,40,0.29,1000,73674,70,NULL,'SN photometric redshift distance, z photo =0.269 +/- 0.046','SDSS-II SN 19424',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.62275,0.95206,0.149,NULL,52147544659,814805385,12731334,NULL),(155966,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424','R',155966,41.61,0.26,1540,73674,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19424',0.364553,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155967,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424','R',155967,41.62,0.31,1550,73674,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19424',0.364553,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155968,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424',NULL,155968,41.51,0.2,2000,73674,70,NULL,'SALT 2','SDSS-II SN 19424',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155969,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19424',NULL,155969,41.56,0.2,2050,73674,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19424',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155970,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155970,38.08,0.46,413,73675,70,NULL,NULL,'SDSS J222629.77-091947.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,336.624083333,-9.32989,0.149,NULL,50362266499,786910414,12295475,18.1),(155971,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155971,35.04,0.2,102,73676,74.4,NULL,NULL,'MCG -01-57-010',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.00015,NULL,'15.31',0.15,'Sc',NULL,NULL,NULL,NULL,1,336.626667,-6.39436,0.201,NULL,50356837690,786825588,12294149,15.31),(155972,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155972,35.04,0.43,102,73676,75,NULL,'3.6 micron, color corrected','MCG -01-57-010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155973,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155973,35.13,0.43,106,73676,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-57-010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155974,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155974,37.36,0.46,296,73677,70,NULL,NULL,'2MASX J22263298+0051274',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,336.637583333,0.85758,0.149,NULL,52147526227,814805097,12731329,17.5),(155975,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155975,36.05,0.57,162,73678,70,NULL,NULL,'AM 2223-635 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.68,'The APM image includes a superposed star.','G',0.00015,NULL,'16.28',0.31,'r?',NULL,NULL,NULL,NULL,1,336.64825,-63.69261,0,NULL,48756391826,761818622,11903415,16.28),(155976,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155976,36.45,0.56,195,73679,70,NULL,NULL,'2MASX J22263615-5039273',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.41',0.37,'S0',NULL,NULL,NULL,NULL,1,336.650708333,-50.65758,0,NULL,50618620674,790915948,12358061,16.41),(155977,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20218','RN',155977,40.73,0.13,1210,73680,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20218',0.154405,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155978,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20218','RN',155978,41,0.25,1370,73680,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20218',0.154405,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155979,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155979,32.1,0.69,26.3,73681,100,NULL,'mid-IR','ESO 533- G 028',NULL,'2013ApJ...771...88L',2013,1,1.3,NULL,'G',0.000017,NULL,'13.43',0.6,'Sc?            HII',NULL,NULL,NULL,NULL,1,336.664,-24.87161,0.009,NULL,50077764977,782465077,12226016,13.43),(155980,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155980,32.57,0.43,32.6,73681,75,NULL,'3.6 micron, color + selection bias corrected','ESO 533- G 028',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155981,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155981,32.67,0.43,34.1,73681,75,NULL,'3.6 micron, color corrected','ESO 533- G 028',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155982,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155982,32.77,0.2,35.8,73681,74.4,NULL,NULL,'ESO 533- G 028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155983,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155983,38.21,0.46,438,73682,70,NULL,NULL,'SDSS J222640.12+001321.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,336.667167,0.22267,0.185,NULL,52144199144,814753111,12730517,18.7),(155984,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14053','RN',155984,40.65,0.24,1180,73683,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14053',0.141276,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155985,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14053','RN',155985,41.26,0.52,1570,73683,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14053',0.141276,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155986,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',155986,38.16,0.46,428,73684,70,NULL,NULL,'SDSS J222642.94-005636.5',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000144,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,336.6789583,-0.94347,0.141,NULL,49798308451,778098569,12157790,18.8),(155987,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155987,32.16,0.4,27,73685,75,NULL,'B','UGCA 429',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000017,NULL,'15.27',0.6,'Im','Pair member (points to parent)',NULL,NULL,NULL,1,336.687375,16.18283,0.213,NULL,52378030862,818406732,12787605,15.27),(155988,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20856','RN',155988,40.82,0.27,1250,73686,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20856',0.16936,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155989,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155989,34.37,0.49,74.9,73687,70,NULL,NULL,'2MASX J22264634-1501230',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.39',0.36,NULL,NULL,NULL,NULL,NULL,1,336.693167,-15.02303,0.089,NULL,50233608750,784900136,12264064,15.39),(155990,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14444',NULL,155990,39.3,0.25,724,73688,70,NULL,'SN photometric redshift distance, z photo =0.186 +/- 0.026','SDSS-II SN 14444',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.7015,-0.81572,0.157,NULL,49798254494,778097726,12157776,NULL),(155991,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14444',NULL,155991,40.16,0.21,1080,73688,70,NULL,NULL,'SDSS-II SN 14444',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155992,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14444','R',155992,40.72,0.21,1120,73688,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14444',0.245916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155993,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14444','R',155993,40.87,0.15,1200,73688,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14444',0.245916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155994,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155994,34.47,0.8,78.3,73689,75,NULL,'W91PP, r','UGC 12039',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'13.84',1.3,'SB(r)b',NULL,NULL,NULL,NULL,1,336.701917,35.51872,0.485,NULL,55484663646,866947869,13546060,13.84),(155995,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155995,34.78,0.38,90.3,73689,75,NULL,'W91PP, r, raw','UGC 12039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155996,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155996,34.91,0.38,96.2,73689,75,NULL,'W91PP, r, cor','UGC 12039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155997,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,155997,35.14,0.38,106,73689,75,NULL,'W91PP, r, inv','UGC 12039',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(155998,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078',NULL,155998,39.51,0.79,800,73690,70,NULL,'SN photometric redshift distance, z photo =0.208 +/- 0.109','SDSS-II SN 02078',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.713833,-1.07997,0.141,NULL,49798272265,778098004,12157781,22.2),(155999,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078','R',155999,41.15,0.32,1280,73690,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02078',0.323773,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156000,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078','R',156000,41.38,0.25,1420,73690,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02078',0.323773,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156001,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078',NULL,156001,40.94,0.2,1540,73690,70,NULL,'SALT 2','SDSS-II SN 02078',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156002,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02078',NULL,156002,40.98,0.2,1570,73690,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02078',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156003,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14816','R',156003,38.25,0.18,403,73691,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ja','SDSS J222651.88+003023.0',0.11,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,NULL,'18.7g',0.1,NULL,NULL,NULL,NULL,NULL,1,336.716167,0.50642,0.161,NULL,52144281888,814754404,12730537,18.7),(156004,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ja',NULL,156004,38.1,0.07,417,73691,70,NULL,'SALT 2','SDSS J222651.88+003023.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156005,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14816','R',156005,38.34,0.06,419,73691,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ja','SDSS J222651.88+003023.0',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156006,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ja',NULL,156006,38.11,0.07,419,73691,70,NULL,'SALT 2, Malmquist cor.','SDSS J222651.88+003023.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156007,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156007,35.91,0.59,152,73692,70,NULL,NULL,'2MASX J22265252-0234231',NULL,'2014MNRAS.445.2677S',2014,1,NULL,'The APM image includes a superposed star.','G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,336.718917,-2.57314,0.169,NULL,49797025400,778078521,12157476,15.1),(156008,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156008,36.23,0.6,176,73693,70,NULL,NULL,'AM 2223-635 NED03',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.000083,NULL,'16.21',0.47,'(R)SAB(s:)0^+',NULL,NULL,NULL,NULL,1,336.725375,-63.71442,0,NULL,48756385933,761818530,11903414,16.21),(156009,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156009,34.87,0.49,94.2,73694,75,NULL,'IR','UGC 12038',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000017,NULL,'14.98',0.3,'Sb',NULL,NULL,NULL,NULL,1,336.7264583,19.54819,0.173,NULL,52406847056,818856985,12794640,14.98),(156010,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156010,35.14,0.25,107,73694,NULL,NULL,NULL,'UGC 12038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156011,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156011,35.2,0.2,110,73694,74.4,NULL,NULL,'UGC 12038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156012,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156012,35.25,0.24,112,73694,NULL,NULL,'Malmquist cor.','UGC 12038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156013,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156013,35.5,0.4,126,73694,NULL,NULL,'mean','UGC 12038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156014,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156014,35.72,0.47,139,73694,NULL,NULL,'H','UGC 12038',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156015,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156015,36,0.51,158,73695,70,NULL,NULL,'2MASX J22265758-5923037',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.59',0.34,NULL,NULL,NULL,NULL,NULL,1,336.73975,-59.38439,0,NULL,48798393340,762474895,11913670,16.59),(156016,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156016,37.67,0.23,342,73696,70,NULL,NULL,'2MASX J22270364-0012240',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.89',0.22,NULL,NULL,NULL,NULL,NULL,1,336.765333,-0.20678,0.165,NULL,49795719284,778058113,12157158,17.89),(156017,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156017,36.77,0.46,226,73697,70,NULL,NULL,'2MASX J22270422+0045170',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000206,NULL,'16.0g',0.34,'E0',NULL,NULL,NULL,NULL,1,336.7677083,0.75486,0.149,NULL,52143921153,814748768,12730449,16),(156018,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20399','RN',156018,41.66,0.27,1820,73698,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20399',0.177108,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156019,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20399','RN',156019,42.06,0.4,2200,73698,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20399',0.177108,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156020,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156020,37.67,0.23,342,73699,70,NULL,NULL,'2MASX J22270648-0008392',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.32',0.29,'BrClG',NULL,NULL,NULL,NULL,1,336.777,-0.14431,0.153,NULL,49795702022,778057844,12157153,17.32),(156021,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156021,34.46,0.49,77.9,73700,75,NULL,'IR','CGCG 495-001',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.38',0.2,'S?',NULL,NULL,NULL,NULL,1,336.799458333,31.50517,0.421,NULL,55494755305,867105551,13548524,15.38),(156022,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156022,34.77,0.2,90,73700,74.4,NULL,NULL,'CGCG 495-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156023,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156023,34.83,0.35,92.6,73700,NULL,NULL,'Malmquist cor.','CGCG 495-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156024,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156024,34.86,0.35,93.9,73700,NULL,NULL,NULL,'CGCG 495-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156025,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156025,37.67,0.23,342,73701,70,NULL,NULL,'2MASX J22271221-0008022',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.800958333,-0.13411,0.153,NULL,49795701419,778057834,12157153,18.1),(156026,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156026,35.21,0.5,110,73702,70,NULL,NULL,'MCG -02-57-006',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00014,NULL,'15.28',0.5,NULL,NULL,NULL,NULL,NULL,1,336.8012917,-12.64719,0.173,NULL,50416380940,787755952,12308686,15.28),(156027,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156027,35.28,0.57,114,73703,NULL,NULL,'Malmquist cor.','NGC 7279',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.44',0.8,'SB(rs)c        HII?',NULL,NULL,NULL,NULL,1,336.80275,-35.14044,0,NULL,50584997731,790390589,12349852,14.44),(156028,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156028,35.35,0.55,118,73703,NULL,NULL,NULL,'NGC 7279',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156029,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156029,35.39,0.2,120,73703,74.4,NULL,NULL,'NGC 7279',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156030,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02079','RN',156030,40.47,0.25,948,73704,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02079',0.306576,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156031,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02079','RN',156031,40.59,0.3,1010,73704,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02079',0.306576,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156032,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02079','N',156032,40.44,0.21,1220,73704,70,NULL,'SALT 2','SDSS-II SN 02079',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156033,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02079','N',156033,40.47,0.21,1240,73704,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02079',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156034,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156034,37.61,0.46,333,73705,70,NULL,NULL,'2MASX J22271702-0014332',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.34',0.18,NULL,NULL,NULL,NULL,NULL,1,336.820791667,-0.24247,0.165,NULL,49795753643,778058650,12157166,18.34),(156035,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006hv',NULL,156035,38.91,0.06,606,73706,70,NULL,'Hubble residual 0.04 for z0.15040','SDSS-II SN 13736 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,336.8327083,1.03072,0.161,NULL,52147415675,814803369,12731302,NULL),(156036,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13736','R',156036,39.33,0.18,637,73706,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hv','SDSS-II SN 13736 HOST',0.150207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156037,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006hv',NULL,156037,39.26,0.06,711,73706,70,NULL,'SALT 2','SDSS-II SN 13736 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156038,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006hv',NULL,156038,39.27,0.06,714,73706,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13736 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156039,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13736','R',156039,39.58,0.08,718,73706,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hv','SDSS-II SN 13736 HOST',0.150207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156040,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156040,37.06,0.46,258,73707,70,NULL,NULL,'SDSS J222720.73+004937.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,336.836416667,0.827,0.149,NULL,52143920310,814748754,12730449,18.2),(156041,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156041,33.56,NULL,51.4,73708,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 467- G 063',NULL,'2010Ap&SS.325..163P',2010,1,1.37,NULL,'G',0.000033,NULL,'16.80',0.11,'Sd',NULL,NULL,NULL,NULL,1,336.845,-31.00806,0,NULL,50591429126,790491080,12351423,16.8),(156042,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156042,33.58,NULL,52,73708,NULL,NULL,'Dipole + Quadrupole','ESO 467- G 063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156043,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156043,33.59,NULL,52.3,73708,NULL,NULL,'Dipole','ESO 467- G 063',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156044,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156044,33.66,NULL,54,73708,NULL,NULL,NULL,'ESO 467- G 063',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156045,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156045,36.92,0.46,242,73709,70,NULL,NULL,'2MASX J22272973-0916248',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.00015,NULL,'16.1g',0.36,'S0^-',NULL,NULL,NULL,NULL,1,336.873875,-9.27358,0.157,NULL,50362935695,786920870,12295638,16.1),(156046,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156046,37.67,0.23,342,73710,70,NULL,NULL,'2MASX J22272980-0004132',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000145,NULL,'17.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,336.874375,-0.07058,0.153,NULL,49794857536,778044649,12156947,17.5),(156047,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156047,30.86,NULL,14.9,73711,NULL,NULL,NULL,'FGC 2392',NULL,'2000BSAO...50....5K',2000,1,0.96,NULL,'G',0.000033,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,336.919417,-7.71683,0.121,NULL,50360659344,786885302,12295082,16.6),(156048,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156048,36.22,0.6,176,73712,70,NULL,NULL,'2MASX J22274184-6113143',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.000103,NULL,'16.74',0.33,NULL,NULL,NULL,NULL,NULL,1,336.92425,-61.22064,0,NULL,48791321164,762364393,11911943,16.74),(156049,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156049,37.24,0.33,281,73713,70,NULL,NULL,'2MASX J22274291-0037582',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.35',0.16,NULL,NULL,NULL,NULL,NULL,1,336.928875,-0.63294,0.145,NULL,49795586476,778056038,12157125,18.35),(156050,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13074','RN',156050,39.7,0.26,728,73714,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13074',0.194118,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156051,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13074','RN',156051,39.86,0.2,784,73714,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13074',0.194118,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156052,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156052,37.51,0.46,317,73715,70,NULL,NULL,'2MASX J22274660-0827255',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000151,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,336.94425,-8.45714,0.153,NULL,50358247486,786847616,12294494,17.2),(156053,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156053,36.88,0.46,238,73716,70,NULL,NULL,'2MASX J22274673-0831405',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.4g',0.31,'AGN',NULL,NULL,NULL,NULL,1,336.944667,-8.52783,0.149,NULL,50358216511,786847132,12294486,16.4),(156054,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156054,34.27,0.8,71.5,73717,75,NULL,'W91PP, r','UGC 12044',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000027,NULL,'15.0',0.6,'Sab',NULL,NULL,NULL,NULL,1,336.951333,38.58683,0.497,NULL,55524792601,867574884,13555857,15),(156055,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156055,34.04,0.38,64.4,73717,75,NULL,'W91PP, r, raw','UGC 12044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156056,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156056,34.26,0.38,71,73717,75,NULL,'W91PP, r, inv','UGC 12044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156057,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156057,34.26,0.38,71.2,73717,75,NULL,'W91PP, r, cor','UGC 12044',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156058,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156058,34.41,0.4,76.3,73717,NULL,NULL,'mean','UGC 12044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156059,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156059,34.43,0.47,76.9,73717,NULL,NULL,'H','UGC 12044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156060,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156060,34.52,0.46,80,73717,NULL,NULL,'J','UGC 12044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156061,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156061,34.56,0.45,81.5,73717,NULL,NULL,'K','UGC 12044',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156062,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217',NULL,156062,40.43,0.17,1220,73718,70,NULL,'SN photometric redshift distance, z photo =0.340 +/- 0.035','SDSS-II SN 20217',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,336.955125,-0.63306,0.145,NULL,49795803020,778059422,12157178,21.4),(156063,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217','R',156063,41.5,0.2,1460,73718,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20217',0.368842,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156064,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217','R',156064,41.66,0.28,1570,73718,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20217',0.368842,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156065,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217',NULL,156065,41.58,0.17,2070,73718,70,NULL,'SALT 2','SDSS-II SN 20217',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156066,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20217',NULL,156066,41.63,0.17,2120,73718,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20217',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156067,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156067,31.02,0.8,16,73719,75,NULL,'W91PP, r','NGC 7286',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.47',0.7,'S0/a',NULL,NULL,NULL,NULL,1,336.9605,29.09597,0.217,NULL,55439618143,866244033,13535063,13.47),(156068,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156068,31.57,0.38,20.6,73719,75,NULL,'W91PP, r, inv','NGC 7286',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156069,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156069,31.69,0.38,21.8,73719,75,NULL,'W91PP, r, raw','NGC 7286',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156070,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156070,31.84,0.38,23.4,73719,75,NULL,'W91PP, r, cor','NGC 7286',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156071,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156071,37.95,0.46,389,73720,70,NULL,NULL,'SDSS J222750.51+004236.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000165,NULL,'18.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,336.9604583,0.71003,0.149,NULL,52144409839,814756403,12730568,18.7),(156072,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19037','RN',156072,43.84,0.25,4020,73721,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19037',0.459279,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156073,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03065','R',156073,40.11,0.35,908,73722,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03065',0.155771,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,'PHOT','19.9g',0.09,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.977791667,-1.15494,0.149,NULL,49798202195,778096909,12157764,19.9),(156074,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03065',NULL,156074,39.91,0.57,960,73722,70,NULL,'SN photometric redshift distance, z photo =0.256 +/- 0.094','SDSS-II SN 03065',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156075,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03065','R',156075,40.31,0.33,996,73722,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03065',0.155771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156076,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580',NULL,156076,40.67,0.27,1360,73723,70,NULL,'SN photometric redshift distance, z photo =0.390 +/- 0.067','SDSS-II SN 20580',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,336.981083,0.02733,0.185,NULL,52143776719,814746511,12730414,22.1),(156077,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580','R',156077,41.75,0.32,1630,73723,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20580',0.375712,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156078,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580','R',156078,42,0.35,1830,73723,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20580',0.375712,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156079,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580',NULL,156079,41.67,0.23,2160,73723,70,NULL,'SALT 2','SDSS-II SN 20580',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156080,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20580',NULL,156080,41.72,0.23,2210,73723,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20580',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156081,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156081,37.24,0.33,281,73724,70,NULL,NULL,'SDSS J222758.65-004712.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000169,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,336.994417,-0.78683,0.145,NULL,49795469306,778054207,12157096,18.3),(156082,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15778','RN',156082,43.03,0.42,2890,73725,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 15778',0.398189,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156083,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15778','RN',156083,43.42,0.35,3460,73725,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 15778',0.398189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156084,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156084,33.31,0.42,45.9,73726,NULL,NULL,'Malmquist cor.','IC 5220',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.08',0.3,'Sc',NULL,NULL,NULL,NULL,1,337.011375,-59.72344,0,NULL,48798022615,762469103,11913579,15.08),(156085,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156085,33.68,0.35,54.5,73726,NULL,NULL,NULL,'IC 5220',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156086,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156086,33.72,0.2,55.5,73726,74.4,NULL,NULL,'IC 5220',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156087,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156087,39.41,0.15,613,73727,74.2,NULL,'SALT 2','SDSS J222805.78-010731.1',0.244,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',NULL,NULL,'23.4g',0.01,NULL,NULL,NULL,NULL,NULL,1,337.024083,-1.12531,0.165,NULL,49795516135,778054939,12157108,23.4),(156088,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10449','R',156088,40.15,0.16,865,73727,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ll','SDSS J222805.78-010731.1',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156089,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156089,40.18,0.18,871,73727,70,NULL,'SDSS-II SN 10449, SALT 2','SDSS J222805.78-010731.1',0.244,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156090,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156090,40.18,0.05,872,73727,70,NULL,'SDSS-II SN 10449','SDSS J222805.78-010731.1',0.244,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156091,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10449','R',156091,40.25,0.24,903,73727,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ll','SDSS J222805.78-010731.1',0.24,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156092,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156092,40.15,0.12,1070,73727,70,NULL,'SALT 2','SDSS J222805.78-010731.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156093,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ll',NULL,156093,40.16,0.12,1080,73727,70,NULL,'SALT 2, Malmquist cor.','SDSS J222805.78-010731.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156094,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156094,35.03,0.49,101,73728,75,NULL,'IR','ESO 027- G 010',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.99',0.2,'S...',NULL,NULL,NULL,NULL,1,337.048375,-79.50992,0.429,NULL,48569506919,758898545,11857789,15.99),(156095,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156095,35.54,0.46,128,73728,NULL,NULL,'Malmquist cor.','ESO 027- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156096,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156096,35.62,0.44,133,73728,NULL,NULL,NULL,'ESO 027- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156097,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156097,35.66,0.2,136,73728,74.4,NULL,NULL,'ESO 027- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156098,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156098,36.31,0.46,183,73729,70,NULL,NULL,'2MASX J22281267+0032358',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00009,NULL,'15.4g',0.57,'E0',NULL,NULL,NULL,NULL,1,337.0527083,0.54322,0.109,NULL,52144574657,814758979,12730609,15.4),(156099,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156099,37.21,0.46,276,73730,70,NULL,NULL,'2MASX J22281269+1239210',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,337.05275,12.65581,0.149,NULL,52583602675,821618791,12837793,18),(156100,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156100,37,0.19,251,73731,70,NULL,NULL,'2MASX J22281319+0001506',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000162,NULL,'16.5g',0.27,NULL,NULL,NULL,NULL,NULL,1,337.054917,0.03064,0.185,NULL,52143744411,814746006,12730406,16.5),(156101,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156101,37.94,0.46,388,73732,70,NULL,NULL,'2MASX J22281325+0058418',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,337.055291667,0.97844,0.161,NULL,52144103339,814751614,12730493,18),(156102,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17565','RN',156102,42.57,0.19,2370,73733,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17565',0.376625,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156103,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17565','RN',156103,42.68,0.22,2490,73733,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17565',0.376625,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156104,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 21693','RN',156104,38.21,0.19,403,73734,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21693',0.089149,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156105,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 21693','RN',156105,38.84,0.23,539,73734,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21693',0.089149,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156106,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20150','RN',156106,43.78,0.33,3480,73735,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20150',0.641724,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156107,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156107,36.87,0.56,237,73736,70,NULL,NULL,'2MASX J22282214-6641267',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.40',0.36,NULL,NULL,NULL,NULL,NULL,1,337.0925,-66.69072,0,NULL,49286034599,770094290,12032723,16.4),(156108,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156108,36.27,0.51,180,73737,70,NULL,NULL,'2MASX J22282227-1626172',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.36',0.53,NULL,NULL,NULL,NULL,NULL,1,337.09275,-16.43819,0.045,NULL,50247511625,785117369,12267458,16.36),(156109,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156109,37.68,0.33,343,73738,70,NULL,NULL,'2MASX J22282528-0946361',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00016,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,337.10525,-9.77675,0.169,NULL,50362483542,786913805,12295528,17.7),(156110,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156110,29.17,0.4,6.82,73739,NULL,NULL,NULL,'NGC 7292',NULL,'2009AJ....138..323T',2009,1,2.1,NULL,'G',0.000013,NULL,'13.03',1.7,'IBm','Isolated galaxy',NULL,NULL,NULL,1,337.1079583,30.29231,0.253,NULL,55436417474,866194023,13534281,13.03),(156111,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156111,30.11,0.4,10.5,73739,73,NULL,'opt','NGC 7292',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156112,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156112,31.05,0.4,16.2,73739,75,NULL,'B','NGC 7292',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156113,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156113,32.83,0.8,36.9,73740,75,NULL,'CF, r','NGC 7290',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000003,NULL,'13.0B',1,'SA(r)bc','Isolated galaxy (6 Mpc isolation)',NULL,NULL,NULL,1,337.110125,17.14744,0.229,NULL,52375248899,818363264,12786926,13),(156114,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156114,32.37,0.69,29.8,73740,100,NULL,'mid-IR','NGC 7290',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156115,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156115,33.03,0.52,40.3,73740,NULL,NULL,'Malmquist cor.','NGC 7290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156116,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156116,33.06,0.43,41,73740,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7290',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156117,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156117,33.09,0.43,41.5,73740,75,NULL,'3.6 micron, color corrected','NGC 7290',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156118,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156118,33.15,0.2,42.7,73740,74.4,NULL,NULL,'NGC 7290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156119,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156119,33.18,0.4,43.3,73740,NULL,NULL,'mean','NGC 7290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156120,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156120,33.33,0.45,46.3,73740,NULL,NULL,NULL,'NGC 7290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156121,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156121,33.41,0.38,48.1,73740,75,NULL,'CF, r, raw','NGC 7290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156122,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156122,33.44,0.47,48.7,73740,NULL,NULL,'H','NGC 7290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156123,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156123,33.49,0.38,50,73740,75,NULL,'CF, r, inv','NGC 7290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156124,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156124,33.5,0.46,50.1,73740,NULL,NULL,'J','NGC 7290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156125,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156125,33.56,0.45,51.5,73740,NULL,NULL,'K','NGC 7290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156126,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156126,33.77,0.38,56.9,73740,75,NULL,'CF, r, cor','NGC 7290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156127,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156127,36.3,0.73,182,73741,70,NULL,NULL,'2MASX J22282827-1237352',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.61',0.3,NULL,NULL,NULL,NULL,NULL,1,337.117875,-12.62633,0.197,NULL,50419064823,787797887,12309341,16.61),(156128,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156128,38.04,0.27,405,73742,70,NULL,NULL,'SDSS J222832.61+135028.0',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,337.135916667,13.84114,0.133,NULL,52363289610,818176400,12784006,17.7),(156129,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 07158','RN',156129,43.18,0.25,2950,73743,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07158',0.468172,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156130,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13051','RN',156130,40.84,0.25,1150,73744,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13051',0.285147,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156131,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13051','RN',156131,41.07,0.23,1270,73744,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13051',0.285147,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156132,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156132,40.43,0.39,1220,73745,NULL,NULL,'Hydrost. Eq.','MACS J2228.5+2036',NULL,'2006ApJ...647...25B',2006,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.141667,20.62167,0.209,NULL,52405987188,818843549,12794430,NULL),(156133,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156133,41.34,0.51,1850,73745,NULL,NULL,'Isotherm.','MACS J2228.5+2036',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156134,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156134,41.49,0.47,1990,73745,NULL,NULL,'Isotherm., r < 100 kpc','MACS J2228.5+2036',NULL,'2006ApJ...647...25B',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156135,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156135,41.99,NULL,2500,73745,NULL,NULL,'4.2 (black) calibration','MACS J2228.5+2036',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156136,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156136,42.03,NULL,2550,73745,NULL,NULL,'3.1 (red) calibration','MACS J2228.5+2036',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156137,'SZ effect','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156137,42.36,NULL,2970,73745,NULL,NULL,'4.1 (blue) calibration','MACS J2228.5+2036',NULL,'2010ApJ...721..653R',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156138,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19231','RN',156138,39.11,0.31,611,73746,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19231',0.085569,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156139,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156139,38.73,0.46,557,73747,70,NULL,NULL,'2MASX J22283416+0044243',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,337.142375,0.74022,0.161,NULL,52144531119,814758298,12730598,17.8),(156140,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156140,38.04,0.27,405,73748,70,NULL,NULL,'SDSS J222836.04+135124.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000139,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,337.150167,13.85672,0.133,NULL,52363282451,818176288,12784004,18.8),(156141,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156141,37.56,0.46,325,73749,70,NULL,NULL,'2MASX J22283666-0855520',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,337.152791667,-8.93106,0.153,NULL,50358286490,786848226,12294503,17.2),(156142,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156142,36.88,0.46,238,73750,70,NULL,NULL,'2MASX J22283679+1403138',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000166,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,337.153458333,14.05392,0.157,NULL,52363499273,818179676,12784057,16.4),(156143,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156143,37.41,0.46,304,73751,70,NULL,NULL,'2MASX J22283699-0946020',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,337.154083333,-9.76722,0.169,NULL,50362401365,786912521,12295508,17),(156144,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156144,37.5,0.46,317,73752,70,NULL,NULL,'2MASX J22283814-0829190',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000156,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,337.158917,-8.48867,0.153,NULL,50358227672,786847307,12294489,17.1),(156145,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19739',NULL,156145,39.02,2.12,638,73753,70,NULL,'SN photometric redshift distance, z photo =0.162 +/- 0.357','SDSS-II SN 19739',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','23.0g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.159375,-0.50111,0.145,NULL,49795655098,778057110,12157142,23),(156146,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156146,38.04,0.27,405,73754,70,NULL,NULL,'2MASX J22284031+1349048',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,337.167958333,13.81797,0.133,NULL,52582201666,821596901,12837451,17.6),(156147,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156147,37.66,0.46,340,73755,70,NULL,NULL,'2MASX J22284083-0805520',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000141,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.170083,-8.09789,0.157,NULL,50360861317,786888458,12295132,18.3),(156148,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156148,36.41,0.57,191,73756,70,NULL,NULL,'2MASX J22284843-6405593',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000083,NULL,'16.96',0.27,NULL,NULL,NULL,NULL,NULL,1,337.201875,-64.09986,0,NULL,48756491819,761820184,11903440,16.96),(156149,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05536','RN',156149,40.29,0.12,1010,73757,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05536',0.129567,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156150,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05536','RN',156150,40.85,0.31,1310,73757,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05536',0.129567,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156151,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156151,37.68,0.33,343,73758,70,NULL,NULL,'2MASX J22285079-0938580',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000159,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,337.2115,-9.64942,0.117,NULL,50362887078,786920110,12295626,17.2),(156152,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235','R',156152,40.47,0.21,992,73759,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05235',0.252225,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.22425,0.63614,0.161,NULL,52144515968,814758062,12730594,NULL),(156153,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235','R',156153,40.47,0.17,993,73759,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05235',0.252225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156154,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235',NULL,156154,40.3,0.12,1150,73759,70,NULL,'SALT 2','SDSS-II SN 05235',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156155,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235',NULL,156155,40.32,0.12,1160,73759,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05235',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156156,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05235',NULL,156156,40.42,0.2,1210,73759,70,NULL,'SN photometric redshift distance, z photo =0.338 +/- 0.040','SDSS-II SN 05235',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156157,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156157,46.23,0.57,4790,73760,69.7,NULL,'Calibrated','GRB 060604',2.68,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,337.2292083,-10.9155,0.149,NULL,50351725167,786745705,12292901,NULL),(156158,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156158,46.31,0.72,4970,73760,NULL,NULL,NULL,'GRB 060604',2.68,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156159,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156159,46.36,0.64,5080,73760,72,NULL,NULL,'GRB 060604',2.68,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156160,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156160,46.48,0.63,5370,73760,70,NULL,NULL,'GRB 060604',2.68,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156161,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156161,47.18,0.55,7420,73760,69.7,NULL,'Fiducial','GRB 060604',2.68,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156162,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156162,36.78,0.46,227,73761,70,NULL,NULL,'2MASX J22290068-0824122',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,337.252958333,-8.40344,0.157,NULL,50360143091,786877235,12294956,16.4),(156163,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156163,34.96,0.26,98.2,73762,NULL,NULL,NULL,'UGC 12050',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.85',0.5,'S?',NULL,NULL,NULL,NULL,1,337.263416667,19.10047,0.193,NULL,52405197211,818831206,12794237,14.85),(156164,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156164,35.05,0.2,102,73762,74.4,NULL,NULL,'UGC 12050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156165,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156165,35.19,0.23,109,73762,NULL,NULL,'Malmquist cor.','UGC 12050',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156166,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13933','R',156166,42.05,0.3,1790,73763,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13933',0.434257,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.2654583,-0.56347,0.149,NULL,49794961809,778046278,12156973,NULL),(156167,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13933','R',156167,42.33,0.32,2040,73763,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13933',0.434257,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156168,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02080','RN',156168,40.98,0.2,1420,73764,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02080',0.103514,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156169,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02080','RN',156169,41.14,0.22,1530,73764,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02080',0.103514,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156170,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156170,36.18,0.46,172,73765,70,NULL,NULL,'IC 1446',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000103,NULL,'15.3g',0.48,'S0',NULL,NULL,NULL,NULL,1,337.269583,-1.18492,0.165,NULL,49795331354,778052052,12157063,15.3),(156171,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156171,36.88,0.46,238,73766,70,NULL,NULL,'2MASX J22290470-0752322',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000154,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,337.269583,-7.87564,0.149,NULL,50360790539,786887352,12295114,17),(156172,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10450','R',156172,41.05,0.22,1270,73767,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10450',0.272,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.275625,-1.12867,0.165,NULL,49795534082,778055220,12157112,NULL),(156173,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 10450','R',156173,41.44,0.34,1520,73767,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10450',0.272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156174,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156174,37,0.19,251,73768,70,NULL,NULL,'2MASX J22290739+0007152',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.54',0.42,NULL,NULL,NULL,NULL,NULL,1,337.280958333,0.12094,0.145,NULL,52143632261,814744254,12730378,16.54),(156175,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156175,37,0.19,251,73769,70,NULL,NULL,'SDSS J222908.07+000908.4',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.283625,0.15236,0.145,NULL,52143629076,814744204,12730378,18.1),(156176,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156176,37,0.19,251,73770,70,NULL,NULL,'2MASX J22290973+0004442',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000197,NULL,'16.3g',0.34,'BrClG',NULL,NULL,NULL,NULL,1,337.290667,0.07886,0.165,NULL,52143632551,814744258,12730379,16.3),(156177,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156177,37,0.19,251,73771,70,NULL,NULL,'SDSS J222909.92+000722.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000195,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,337.291333,0.12292,0.165,NULL,52143630705,814744229,12730378,17.8),(156178,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156178,35.35,0.8,118,73772,75,NULL,'CF, r','UGC 12052',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',NULL,NULL,'15.1',0.4,'Scd:',NULL,NULL,NULL,NULL,1,337.2925,38.53158,0.397,NULL,55524803045,867575047,13555860,15.1),(156179,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156179,34.99,0.38,99.7,73772,75,NULL,'CF, r, raw','UGC 12052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156180,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156180,35.09,0.38,104,73772,75,NULL,'CF, r, inv','UGC 12052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156181,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156181,35.19,0.38,109,73772,75,NULL,'CF, r, cor','UGC 12052',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156182,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156182,38.09,0.46,415,73773,70,NULL,NULL,'2MASX J22291043-1005401',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000181,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,337.2935417,-10.09442,0.161,NULL,50362560435,786915006,12295546,17.3),(156183,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156183,35.77,0.71,143,73774,70,NULL,NULL,'2MASX J22291156-0920041',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'15.7g',0.41,'S0^-',NULL,NULL,NULL,NULL,1,337.29825,-9.33456,0.145,NULL,50362784803,786918512,12295601,15.7),(156184,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156184,36.01,0.46,159,73774,70,NULL,NULL,'2MASX J22291156-0920041',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156185,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156185,37,0.19,251,73775,70,NULL,NULL,'2MASX J22291213+0009452',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000172,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,337.300625,0.16236,0.145,NULL,52143636876,814744326,12730380,17.6),(156186,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17443','RN',156186,42.22,0.2,1820,73776,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17443',0.525488,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156187,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02081','R',156187,40.73,0.24,1120,73777,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J222913.18-011228.1',0.252,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.01,NULL,'20.3g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,337.304917,-1.20781,0.165,NULL,49795319915,778051873,12157060,20.3),(156188,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02081','R',156188,41.03,0.2,1290,73777,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J222913.18-011228.1',0.252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156189,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02081',NULL,156189,40.64,0.15,1340,73777,70,NULL,'SALT 2','SDSS J222913.18-011228.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156190,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 02081',NULL,156190,40.66,0.15,1360,73777,70,NULL,'SALT 2, Malmquist cor.','SDSS J222913.18-011228.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156191,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01303','RN',156191,41.5,0.14,1580,73778,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01303',0.26569,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156192,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01303','RN',156192,42.07,0.19,2050,73778,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01303',0.26569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156193,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156193,32.49,0.43,31.5,73779,75,NULL,'3.6 micron, color + selection bias corrected','IRAS22282+7506',NULL,'2014MNRAS.444..527S',2014,1,1.34,NULL,'G',0.000023,NULL,NULL,0.89,'Spiral LSB',NULL,NULL,NULL,NULL,1,337.3125,75.36556,1.569,NULL,52799598393,824993724,12890526,NULL),(156194,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17599','RN',156194,40.59,0.33,912,73780,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17599',0.438925,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156195,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 17599','RN',156195,41.58,0.35,1440,73780,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17599',0.438925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156196,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005iw',NULL,156196,40.7,0.15,1080,73781,65,NULL,'MLCS2k2','SDSS J222917.88-000531.8',0.27,'2009ApJS..185...32K',2009,1,0.06,NULL,'G',NULL,NULL,'21.2g',0.04,NULL,NULL,NULL,NULL,NULL,1,337.3245417,-0.09217,0.157,NULL,49794835574,778044305,12156942,21.2),(156197,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06127','R',156197,40.74,0.16,1110,73781,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005iw','SDSS J222917.88-000531.8',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156198,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005iw',NULL,156198,40.88,0.25,1180,73781,65,NULL,'SALT2','SDSS J222917.88-000531.8',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156199,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06127','R',156199,41.11,0.28,1310,73781,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005iw','SDSS J222917.88-000531.8',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156200,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156200,37.09,0.64,261,73782,70,NULL,NULL,'2MASX J22291825-1324493',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'17.07',0.28,NULL,NULL,NULL,NULL,NULL,1,337.326,-13.41364,0.153,NULL,50419314206,787801784,12309402,17.07),(156201,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156201,37.53,0.46,321,73783,70,NULL,NULL,'2MASX J22291893-0818431',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000903,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,337.328917,-8.31217,0.157,NULL,50360126225,786876972,12294952,17.8),(156202,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13775','RN',156202,41.78,0.34,1930,73784,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13775',0.17589,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156203,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13775','RN',156203,42.07,0.29,2210,73784,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13775',0.17589,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156204,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13023','RN',156204,43.02,0.24,2530,73785,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13023',0.593717,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156205,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156205,37.96,0.46,392,73786,70,NULL,NULL,'SDSS J222925.67+125131.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000163,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,337.3569583,12.85869,0.157,NULL,52583759262,821621238,12837831,18.5),(156206,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156206,38.9,0.46,602,73787,70,NULL,NULL,'2MASX J22292680-0108409',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000145,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.3615417,-1.14461,0.165,NULL,50332123830,786439434,12288116,18.3),(156207,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156207,35.18,0.5,108,73788,70,NULL,NULL,'6dF J2229296-353310',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,337.373125,-35.55289,0,NULL,50577385206,790271643,12347994,15),(156208,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156208,32.8,0.2,36.3,73789,74.4,NULL,NULL,'UGC 12054',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000027,NULL,'14.93',0.2,'S?',NULL,NULL,NULL,NULL,1,337.38525,7.726,0.293,NULL,52453616146,819587752,12806058,14.93),(156209,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156209,32.81,0.43,36.5,73789,75,NULL,'3.6 micron, color corrected','UGC 12054',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156210,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156210,32.85,0.49,37.1,73789,75,NULL,'IR','UGC 12054',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156211,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156211,32.85,0.43,37.1,73789,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12054',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156212,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156212,33.1,0.6,41.7,73789,NULL,NULL,NULL,'UGC 12054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156213,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156213,33.18,0.57,43.2,73789,NULL,NULL,'Malmquist cor.','UGC 12054',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156214,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156214,37.5,0.46,317,73790,70,NULL,NULL,'SDSS J222933.79-085329.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00014,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,337.390791667,-8.89164,0.125,NULL,50358189467,786846710,12294479,18.5),(156215,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156215,36.75,0.46,223,73791,70,NULL,NULL,'2MASX J22293564-0828346',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,337.3985417,-8.47628,0.157,NULL,50360217426,786878397,12294974,16.9),(156216,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156216,45.43,0.97,3380,73792,69.7,NULL,'Fiducial','GRB 050820',2.61,'2009MNRAS.400..775C',2009,1,NULL,NULL,'VisS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,337.4087917,19.56031,0.161,NULL,52406794907,818856170,12794627,NULL),(156217,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156217,46.27,0.59,4970,73792,69.7,NULL,'Calibrated','GRB 050820',2.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156218,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156218,46.3,1.58,5040,73792,100,NULL,NULL,'GRB 050820',2.61,'2009EPJC...63..139W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156219,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156219,46.51,0.63,5550,73792,69.7,NULL,'Fiducial','GRB 050820',2.61,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156220,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156220,46.52,1.52,5580,73792,69.7,NULL,'Fiducial','GRB 050820',2.61,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156221,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156221,46.55,0.65,5660,73792,72,NULL,NULL,'GRB 050820',2.61,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156222,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156222,46.7,0.66,6060,73792,70,NULL,NULL,'GRB 050820',2.61,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156223,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156223,47.16,0.95,7480,73792,NULL,NULL,NULL,'GRB 050820',2.61,'2008AIPC.1065..367L',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156224,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156224,36.46,0.67,196,73793,70,NULL,NULL,'2MASX J22294092-1726212',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'15.1R',0.29,NULL,NULL,NULL,NULL,NULL,1,337.4205,-17.43919,0.113,NULL,50243742763,785058480,12266538,15.1),(156225,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156225,37.63,0.46,335,73794,70,NULL,NULL,'2MASX J22294281+1412454',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000112,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,337.4285,14.21256,0.169,NULL,52363340838,818177200,12784018,18.3),(156226,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 03179','RN',156226,40.11,0.15,869,73795,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03179',0.207584,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156227,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16413','RN',156227,42.5,0.39,2570,73796,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16413',0.231097,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156228,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16413','RN',156228,42.64,0.32,2730,73796,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16413',0.231097,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156229,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156229,34.4,0.47,76,73797,NULL,NULL,'H','UGC 12056',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00002,NULL,'15.00',1,'Sa',NULL,NULL,NULL,NULL,1,337.468583,36.71928,0.529,NULL,55453562029,866461906,13538467,15),(156230,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156230,34.49,0.69,79.1,73797,100,NULL,'mid-IR','UGC 12056',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156231,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156231,34.54,0.46,80.8,73797,NULL,NULL,'J','UGC 12056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156232,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156232,34.56,0.45,81.5,73797,NULL,NULL,'K','UGC 12056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156233,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156233,34.91,0.4,95.7,73797,NULL,NULL,'mean','UGC 12056',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156234,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2007la',NULL,156234,38.52,0.09,506,73798,70,NULL,'Hubble residual -0.08 for z0.13070','2MASX J22295461+0103302',NULL,'2011ApJ...740...92G',2011,1,0.15,NULL,'G',0.0005,NULL,'18.6g',0.1,NULL,NULL,NULL,NULL,NULL,1,337.4775,1.05847,0.177,NULL,52412663428,818947866,12796060,18.6),(156235,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 18415','R',156235,38.92,0.18,538,73798,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007la','2MASX J22295461+0103302',0.1307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156236,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2007la',NULL,156236,38.71,0.07,552,73798,70,NULL,'SALT 2','2MASX J22295461+0103302',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156237,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2007la',NULL,156237,38.71,0.07,552,73798,70,NULL,'SALT 2, Malmquist cor.','2MASX J22295461+0103302',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156238,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 18415','R',156238,39.11,0.1,587,73798,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007la','2MASX J22295461+0103302',0.1307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156239,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558','R',156239,40.94,0.38,1180,73799,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15558',0.305943,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','21.1g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.4935,0.95344,0.177,NULL,52412672375,818948005,12796062,21.1),(156240,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558','R',156240,40.96,0.34,1190,73799,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15558',0.305943,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156241,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558',NULL,156241,40.66,0.24,1360,73799,70,NULL,'SALT 2','SDSS-II SN 15558',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156242,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558',NULL,156242,40.69,0.24,1370,73799,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15558',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156243,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15558',NULL,156243,41.34,0.13,1860,73799,70,NULL,'SN photometric redshift distance, z photo =0.591 +/- 0.056','SDSS-II SN 15558',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156244,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156244,33.12,0.4,42.1,73800,NULL,NULL,'mean','IC 1447',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00001,NULL,'13.71',0.8,'SA(r)b?',NULL,NULL,NULL,NULL,1,337.499167,-5.11989,0.137,NULL,50339786608,786559165,12289986,13.71),(156245,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156245,33.48,0.46,49.6,73800,NULL,NULL,'J','IC 1447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156246,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156246,33.51,0.47,50.3,73800,NULL,NULL,'H','IC 1447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156247,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156247,33.55,0.45,51.2,73800,NULL,NULL,'K','IC 1447',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156248,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ks',NULL,156248,39.88,0.11,946,73801,70,NULL,'Hubble residual 0.36 for z0.20850','SDSS J223004.53+000011.2',NULL,'2011ApJ...740...92G',2011,1,0.12,NULL,'G',0.0005,NULL,'20.23',0.09,NULL,NULL,NULL,NULL,NULL,1,337.518917,0.00314,0.165,NULL,51673825404,807403521,12615680,20.23),(156249,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15201','R',156249,40.36,0.21,976,73801,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ks','SDSS J223004.53+000011.2',0.2085,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156250,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15201','R',156250,40.43,0.13,1010,73801,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ks','SDSS J223004.53+000011.2',0.2085,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156251,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ks',NULL,156251,40.16,0.11,1080,73801,70,NULL,'SALT 2','SDSS J223004.53+000011.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156252,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006ks',NULL,156252,40.17,0.11,1080,73801,70,NULL,'SALT 2, Malmquist cor.','SDSS J223004.53+000011.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156253,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400','R',156253,40.59,0.16,1010,73802,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20400',0.293582,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.9g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.5319583,-1.15425,0.165,NULL,50332165103,786440079,12288126,20.9),(156254,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400',NULL,156254,40.12,0.27,1060,73802,70,NULL,'SN photometric redshift distance, z photo =0.286 +/- 0.046','SDSS-II SN 20400',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156255,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400','R',156255,40.82,0.27,1130,73802,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20400',0.293582,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156256,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400',NULL,156256,40.74,0.17,1410,73802,70,NULL,'SALT 2','SDSS-II SN 20400',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156257,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20400',NULL,156257,40.77,0.17,1430,73802,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20400',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156258,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15933','RN',156258,41.61,0.2,1740,73803,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15933',0.208124,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156259,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15933','RN',156259,42.23,0.26,2310,73803,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15933',0.208124,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156260,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156260,37.45,0.46,309,73804,70,NULL,NULL,'2MASX J22300839+0025398',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.96',0.18,NULL,NULL,NULL,NULL,NULL,1,337.535,0.42767,0.161,NULL,52412249405,818941396,12795959,17.96),(156261,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16716','RN',156261,41.16,0.2,1480,73805,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16716',0.149774,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156262,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 16716','RN',156262,41.27,0.25,1560,73805,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16716',0.149774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156263,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2006kc',NULL,156263,39.41,0.08,761,73806,70,NULL,'Hubble residual -0.13 for z0.21003','SDSS-II SN 15259 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.00011,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.544208333,-0.40778,0.157,NULL,50331891136,786435799,12288059,NULL),(156264,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15259','R',156264,39.98,0.2,819,73806,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006kc','SDSS-II SN 15259 HOST',0.212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156265,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15259','R',156265,40.12,0.11,872,73806,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006kc','SDSS-II SN 15259 HOST',0.212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156266,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156266,37.84,0.27,369,73807,70,NULL,NULL,'2MASX J22301209-0928363',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,337.5502917,-9.47664,0.161,NULL,50362737862,786917779,12295590,17.7),(156267,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156267,37.76,0.46,356,73808,70,NULL,NULL,'2MASX J22301267+1219331',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000153,NULL,'17.2g',0.28,NULL,NULL,NULL,NULL,NULL,1,337.552666667,12.32583,0.185,NULL,52581596390,821587443,12837303,17.2),(156268,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156268,36.86,0.46,235,73809,70,NULL,NULL,'2MASX J22301271-0959313',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000147,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,337.5529583,-9.99197,0.161,NULL,50364344093,786942876,12295982,16.6),(156269,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13288','RN',156269,42.57,0.19,2080,73810,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13288',0.568682,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156270,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13423',NULL,156270,40.37,0.22,1180,73811,70,NULL,'SN photometric redshift distance, z photo =0.328 +/- 0.043','SDSS-II SN 13423',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.56525,0.07506,0.173,NULL,52412023999,818937874,12795904,NULL),(156271,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156271,36.02,0.58,160,73812,70,NULL,NULL,'2MASX J22302044-1404344',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.74',0.19,NULL,NULL,NULL,NULL,NULL,1,337.585125,-14.07625,0.141,NULL,50417197438,787768709,12308886,17.74),(156272,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 19195',NULL,156272,40.9,0.27,1510,73813,70,NULL,'SN photometric redshift distance, z photo =0.447 +/- 0.080','SDSS-II SN 19195',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.586125,-0.13531,0.165,NULL,50331657491,786432148,12288002,NULL),(156273,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156273,37.18,0.73,272,73814,70,NULL,NULL,'2MASX J22302109-8059092',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.8b',0.13,NULL,NULL,NULL,NULL,NULL,1,337.5880417,-80.98589,0.421,NULL,48562817638,758794025,11856156,16.8),(156274,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14177','R',156274,40.38,0.37,919,73815,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 14177',0.293703,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.592417,0.51633,0.169,NULL,52412244741,818941324,12795958,21.9),(156275,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14177','R',156275,40.56,0.33,1000,73815,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 14177',0.293703,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156276,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 14177',NULL,156276,40.64,0.39,1340,73815,70,NULL,'SN photometric redshift distance, z photo =0.384 +/- 0.100','SDSS-II SN 14177',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156277,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156277,37.84,0.27,369,73816,70,NULL,NULL,'2MASX J22302454-0934103',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000167,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,337.602333,-9.56956,0.157,NULL,50364800297,786950004,12296093,16.6),(156278,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13035','RN',156278,39.7,0.22,845,73817,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13035',0.030916,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156279,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 13035','RN',156279,39.97,0.33,956,73817,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13035',0.030916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156280,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156280,36.67,0.46,216,73818,70,NULL,NULL,'2MASX J22302745-0937023',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'16.1g',0.36,'E0',NULL,NULL,NULL,NULL,1,337.614458333,-9.61717,0.157,NULL,50364798957,786949983,12296093,16.1),(156281,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156281,32.98,0.49,39.5,73819,75,NULL,'IR','2MFGC 16956',NULL,'2011yCatp016004901K',2011,1,0.45,NULL,'G',0.00001,NULL,'9.6K',0.22,'Sbc:',NULL,NULL,NULL,NULL,1,337.626625,61.88047,NULL,NULL,53353998093,833656220,13025878,9.6),(156282,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156282,33.54,0.4,51.1,73819,NULL,NULL,'mean','2MFGC 16956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156283,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156283,33.68,0.46,54.3,73819,NULL,NULL,'J','2MFGC 16956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156284,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156284,33.7,0.47,54.9,73819,NULL,NULL,'H','2MFGC 16956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156285,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156285,33.72,0.45,55.4,73819,NULL,NULL,'K','2MFGC 16956',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156286,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156286,34.92,0.53,96.5,73820,NULL,NULL,'Malmquist cor.','AGC 320785',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'16.68',0.12,NULL,NULL,NULL,NULL,NULL,1,337.6285417,35.29228,0.517,NULL,55454758508,866480601,13538759,16.68),(156287,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156287,35.01,0.2,100,73820,74.4,NULL,NULL,'AGC 320785',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156288,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156288,35.2,0.46,109,73820,NULL,NULL,NULL,'AGC 320785',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156289,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156289,37.84,0.27,369,73821,70,NULL,NULL,'SDSS J223031.16-093241.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000172,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,337.629875,-9.54483,0.161,NULL,50364781675,786949713,12296089,18.6),(156290,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156290,39.79,0.14,709,73822,74.2,NULL,'SALT 2','SDSS J223031.48-003008.5',0.28,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0005,NULL,'21.0g',0.04,NULL,NULL,NULL,NULL,NULL,1,337.631208333,-0.50239,0.145,NULL,50331900251,786435941,12288061,21),(156291,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156291,39.87,0.13,943,73822,70,NULL,'Hubble residual -0.21 for z0.28070','SDSS J223031.48-003008.5',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156292,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06196','R',156292,40.42,0.22,948,73822,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ig','SDSS J223031.48-003008.5',0.2807,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156293,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156293,40.49,0.15,979,73822,65,NULL,'SALT2','SDSS J223031.48-003008.5',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156294,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156294,40.5,0.16,982,73822,70,NULL,'SALT 2','SDSS J223031.48-003008.5',0.28,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156295,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06196','R',156295,40.67,0.15,1060,73822,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ig','SDSS J223031.48-003008.5',0.2807,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156296,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156296,40.68,0.13,1070,73822,65,NULL,'MLCS2k2','SDSS J223031.48-003008.5',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156297,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156297,40.23,0.12,1110,73822,70,NULL,'SALT 2','SDSS J223031.48-003008.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156298,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ig',NULL,156298,40.25,0.12,1120,73822,70,NULL,'SALT 2, Malmquist cor.','SDSS J223031.48-003008.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156299,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156299,30.9,0.4,15.1,73823,75,NULL,'B','UGC 12060',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000017,NULL,'14.90',1,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,337.641583333,33.81969,0.353,NULL,55461288179,866582627,13540353,14.9),(156300,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156300,31.65,0.8,21.4,73824,75,NULL,NULL,'[RC2] A2228-00',NULL,'1988NBGC.C....0000T',1988,1,0.24,NULL,'G',0.000011,NULL,'17.2g',0.2,'HII',NULL,NULL,NULL,NULL,1,337.653333,-0.11028,0.165,NULL,49459238713,772800604,12075009,17.2),(156301,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156301,31.98,NULL,24.9,73824,NULL,NULL,NULL,'[RC2] A2228-00',NULL,'2014A&A...562A..49M',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156302,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156302,34.14,0.43,67.4,73825,NULL,NULL,'Malmquist cor.','NGC 7301',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.44',0.5,'SAB(s)bc       HII',NULL,NULL,NULL,NULL,1,337.644667,-17.57378,0.113,NULL,50243802629,785059416,12266553,14.44),(156303,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156303,34.16,0.43,67.8,73825,NULL,NULL,NULL,'NGC 7301',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156304,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156304,34.2,0.2,69.2,73825,74.4,NULL,NULL,'NGC 7301',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156305,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156305,33.26,0.8,44.9,73826,75,NULL,'MAT, I','ESO 533- G 037',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000024,NULL,'15.28',0.6,'SB(s)d','in a pair',NULL,NULL,NULL,1,337.66075,-26.93147,0,NULL,50078167320,782471364,12226115,15.28),(156306,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156306,31.73,0.32,22.2,73826,85,NULL,'I, inv','ESO 533- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156307,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156307,31.79,0.32,22.8,73826,85,NULL,'I, raw','ESO 533- G 037',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156308,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156308,32.35,0.43,29.5,73826,75,NULL,'MAT, I, inv','ESO 533- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156309,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156309,32.48,0.43,31.3,73826,75,NULL,'MAT, I, raw','ESO 533- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156310,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156310,32.76,0.43,35.6,73826,75,NULL,'MAT, I, cor','ESO 533- G 037',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156311,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156311,33.63,0.65,53.3,73826,NULL,NULL,NULL,'ESO 533- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156312,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156312,33.67,0.2,54.2,73826,74.4,NULL,NULL,'ESO 533- G 037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156313,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156313,33.75,0.62,56.3,73826,NULL,NULL,'Malmquist cor.','ESO 533- G 037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156314,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156314,36.5,0.71,199,73827,70,NULL,NULL,'2MASX J22303930-4235546',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.78',0.31,NULL,NULL,NULL,NULL,NULL,1,337.66375,-42.59853,0,NULL,50733342235,792708472,12386069,16.78),(156315,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06567','RN',156315,43.63,0.51,4960,73828,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06567',0.071701,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156316,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 06567','RN',156316,43.71,0.5,5160,73828,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06567',0.071701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156317,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156317,37.45,0.16,309,73829,70,NULL,NULL,'SDSS J223040.81-083751.5',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.670083,-8.631,0.149,NULL,50359976739,786874636,12294916,18.3),(156318,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156318,37.26,0.12,265,73830,74.2,NULL,'SALT 2','SDSS J223041.15-004634.4',0.07,'2010ApJ...716..712A',2010,1,0.19,NULL,'G',NULL,NULL,'18.9g',0.09,NULL,NULL,NULL,NULL,NULL,1,337.6714583,-0.77625,0.153,NULL,50332613009,786447078,12288235,18.9),(156319,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156319,37.91,0.12,357,73830,70,NULL,'SDSS-II SN 01241, SALT 2','SDSS J223041.15-004634.4',0.07,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156320,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156320,37.93,0.09,360,73830,65,NULL,'SALT2','SDSS J223041.15-004634.4',0.07,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156321,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156321,37.8,0.06,363,73830,70,NULL,'SALT 2','SDSS J223041.15-004634.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156322,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01241','R',156322,37.96,0.18,365,73830,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ff','SDSS J223041.15-004634.4',0.07,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156323,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156323,37.81,0.06,365,73830,70,NULL,'SALT 2, Malmquist cor.','SDSS J223041.15-004634.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156324,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156324,38.1,0.09,390,73830,65,NULL,'MLCS2k2','SDSS J223041.15-004634.4',0.07,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156325,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 01241','R',156325,38.12,0.07,394,73830,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ff','SDSS J223041.15-004634.4',0.07,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156326,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SN 2005ff',NULL,156326,38.64,0.03,499,73830,70,NULL,'SDSS-II SN 01241','SDSS J223041.15-004634.4',0.07,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156327,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 08387','RN',156327,38.96,0.53,547,73831,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08387',0.131815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156328,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 08387','RN',156328,39.27,0.69,630,73831,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08387',0.131815,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156329,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156329,35.13,0.56,106,73832,70,NULL,NULL,'2MASX J22304398-1700324',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.08',0.36,NULL,NULL,NULL,NULL,NULL,1,337.683333,-17.00897,0.133,NULL,50244006168,785062596,12266603,16.08),(156330,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156330,35.13,0.48,106,73833,NULL,NULL,NULL,'UGC 12059',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000067,NULL,'14.83',0.7,'SBb',NULL,NULL,NULL,NULL,1,337.684083,22.54253,0.149,NULL,52356067403,818063553,12782243,14.83),(156331,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156331,35.18,0.2,109,73833,74.4,NULL,NULL,'UGC 12059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156332,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156332,35.24,0.46,112,73833,NULL,NULL,'Malmquist cor.','UGC 12059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156333,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156333,37.97,0.27,393,73834,70,NULL,NULL,'2MASX J22304424-0051207',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000154,NULL,'17.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,337.684417,-0.85567,0.153,NULL,50332609413,786447022,12288234,17.3),(156334,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156334,37.45,0.16,309,73835,70,NULL,NULL,'2MASX J22304500-0829071',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000164,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,337.687416667,-8.48519,0.161,NULL,50360064709,786876011,12294937,17.7),(156335,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156335,37.07,0.33,259,73836,70,NULL,NULL,'2MASX J22304552-0109267',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.87',0.34,NULL,NULL,NULL,NULL,NULL,1,337.6895417,-1.15758,0.165,NULL,50332110231,786439222,12288112,16.87),(156336,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156336,31.94,0.4,24.4,73837,NULL,NULL,NULL,'UGC 12069',NULL,'2009AJ....138..323T',2009,1,1.5,NULL,'G',0.000017,NULL,'15.1',1.1,'SAB(s)dm','Isolated galaxy',NULL,NULL,NULL,1,337.692417,76.51108,1.109,NULL,52798703230,824979737,12890308,15.1),(156337,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156337,32.78,0.4,35.9,73837,75,NULL,'B','UGC 12069',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156338,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156338,37.54,0.46,322,73838,70,NULL,NULL,'2MASX J22304670+0031593',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000174,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,337.69475,0.53314,0.181,NULL,52412280918,818941889,12795967,17.1),(156339,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20581','RN',156339,39.95,0.19,810,73839,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qm','SDSS-II SN 20581',0.204807,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156340,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20581','RN',156340,40.22,0.13,918,73839,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qm','SDSS-II SN 20581',0.204807,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156341,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20581','N',156341,39.82,0.08,920,73839,70,NULL,'SALT 2','SDSS-II SN 20581',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156342,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 20581','N',156342,39.83,0.08,925,73839,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20581',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156343,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156343,35.19,0.58,109,73840,70,NULL,NULL,'2MASX J22304886-1842545',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'15.93',0.2,NULL,NULL,NULL,NULL,NULL,1,337.703667,-18.71519,0.109,NULL,50262519238,785351863,12271122,15.93),(156344,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156344,38.02,0.46,402,73841,70,NULL,NULL,'2MASX J22305012-0114597',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000151,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,337.7087917,-1.25003,0.161,NULL,50331998587,786437477,12288085,18.1),(156345,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156345,36.35,0.5,186,73842,70,NULL,NULL,'2MASX J22305241-1338047',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.12',0.46,NULL,NULL,NULL,NULL,NULL,1,337.718333,-13.63469,0.153,NULL,50417370406,787771412,12308928,16.12),(156346,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156346,37.07,0.33,259,73843,70,NULL,NULL,'2MASX J22305692-0104447',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000175,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,337.737125,-1.07922,0.165,NULL,50332650859,786447669,12288244,17.2),(156347,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156347,33.93,0.8,61.1,73844,75,NULL,'MAT, I','NGC 7300',NULL,'1997ApJS..109..333W',1997,1,2,'The IC identification is not certain.','G',0.000033,NULL,'13.6',1,'SAB(rs)b:      HII','in a pair',NULL,NULL,NULL,1,337.749625,-14.00353,0.161,NULL,50417614239,787775222,12308987,13.6),(156348,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156348,33.8,0.43,57.7,73844,75,NULL,'MAT, I, raw','NGC 7300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156349,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156349,33.87,0.32,59.3,73844,85,NULL,'I, raw','NGC 7300',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156350,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156350,33.94,0.32,61.3,73844,85,NULL,'I, inv','NGC 7300',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156351,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156351,34.1,0.43,66.1,73844,75,NULL,'MAT, I, inv','NGC 7300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156352,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156352,34.12,0.43,66.6,73844,75,NULL,'MAT, I, cor','NGC 7300',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156353,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156353,34.18,0.31,68.4,73844,NULL,NULL,'Malmquist cor.','NGC 7300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156354,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156354,34.21,0.2,69.5,73844,74.4,NULL,NULL,'NGC 7300',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156355,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156355,34.33,0.28,73.4,73844,NULL,NULL,NULL,'NGC 7300',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156356,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156356,37.45,0.16,309,73845,70,NULL,NULL,'2MASX J22310012-0829318',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000166,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,337.750625,-8.49214,0.161,NULL,50359594949,786868671,12294822,17),(156357,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15179','RN',156357,40.42,0.3,1150,73846,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15179',0.057258,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156358,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 15179','RN',156358,41.91,0.42,2280,73846,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15179',0.057258,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156359,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156359,36.09,0.52,165,73847,70,NULL,NULL,'2MASX J22310394-8013169',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.4b',0.27,NULL,NULL,NULL,NULL,NULL,1,337.766583,-80.22142,0.441,NULL,48567557822,758868090,11857313,16.4),(156360,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156360,36.92,0.46,242,73848,70,NULL,NULL,'2MASX J22310455-0746478',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,337.768875,-7.77992,0.157,NULL,50360257231,786879019,12294984,17.5),(156361,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156361,35.89,0.51,151,73849,70,NULL,NULL,'2MASX J22310580-1921315',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.17',0.2,NULL,NULL,NULL,NULL,NULL,1,337.7740417,-19.35869,0.093,NULL,50262952393,785358631,12271228,16.17),(156362,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156362,37.97,0.27,393,73850,70,NULL,NULL,'2MASX J22310893-0027430',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000167,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,337.787375,-0.462,0.133,NULL,50331870632,786435478,12288054,18),(156363,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156363,34.74,0.8,88.5,73851,75,NULL,'W91PP, r','UGC 12063',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.26',0.5,'Sab',NULL,NULL,NULL,NULL,1,337.794917,35.37511,0.517,NULL,55454733485,866480210,13538753,15.26),(156364,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156364,34.73,0.35,88.5,73851,NULL,NULL,'Malmquist cor.','UGC 12063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156365,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156365,34.8,0.34,91.1,73851,NULL,NULL,NULL,'UGC 12063',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156366,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156366,34.82,0.4,91.9,73851,NULL,NULL,'mean','UGC 12063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156367,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156367,34.86,0.38,93.9,73851,75,NULL,'W91PP, r, raw','UGC 12063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156368,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156368,34.98,0.38,99.1,73851,75,NULL,'W91PP, r, cor','UGC 12063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156369,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156369,35.06,0.38,103,73851,75,NULL,'W91PP, r, inv','UGC 12063',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156370,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156370,35.08,0.2,104,73851,74.4,NULL,NULL,'UGC 12063',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156371,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,NULL,156371,35.12,0.47,106,73851,NULL,NULL,'H','UGC 12063',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156372,'FP','2016-12-15 15:16:00','2016-12-16 11:21:16','1',NULL,'R',156372,38.06,0.33,409,73852,70,NULL,NULL,'2MASX J22311102-0045080',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'18.47',0.17,NULL,NULL,NULL,NULL,NULL,1,337.795875,-0.75231,0.145,NULL,50332517287,786445582,12288212,18.47),(156373,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05513','RN',156373,40.45,0.23,965,73853,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05513',0.277766,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156374,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:16','1','SDSS-II SN 05513','RN',156374,41.11,0.24,1300,73853,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05513',0.277766,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156375,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156375,36.64,0.46,213,73854,70,NULL,NULL,'2MASX J22311127+0008178',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000177,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,337.797,0.13822,0.169,NULL,51673877820,807404340,12615692,16.7),(156376,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 06177','RN',156376,39.67,0.26,761,73855,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01679 HOST',0.129373,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156377,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 01679','RN',156377,39.88,0.22,837,73855,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01679 HOST',0.129373,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156378,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 01679','RN',156378,40.39,0.25,1060,73855,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01679 HOST',0.129373,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156379,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 06177','RN',156379,40.48,0.28,1110,73855,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01679 HOST',0.129373,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156380,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156380,36.35,0.46,186,73856,70,NULL,NULL,'2MASX J22311320-0022540',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,337.804917,-0.38161,0.133,NULL,50331861318,786435333,12288052,16.9),(156381,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156381,35.29,0.47,114,73857,70,NULL,NULL,'MCG -03-57-016',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00013,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,337.805417,-17.32803,0.133,NULL,50244488079,785070126,12266720,15),(156382,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156382,34.88,0.47,94.8,73858,NULL,NULL,NULL,'ESO 468- G 005',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'16',0.4,'(R\'_2)SB(s)a:',NULL,NULL,NULL,NULL,1,337.8059583,-28.53722,0,NULL,50067983961,782312249,12223628,16),(156383,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156383,34.92,0.2,96.4,73858,74.4,NULL,NULL,'ESO 468- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156384,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156384,34.94,0.45,97.5,73858,NULL,NULL,'Malmquist cor.','ESO 468- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156385,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156385,37.97,0.27,393,73859,70,NULL,NULL,'SDSS J223116.62-003031.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000159,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.8192917,-0.50872,0.133,NULL,50331802911,786434420,12288037,18.4),(156386,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156386,38.68,0.46,545,73860,70,NULL,NULL,'2MASX J22311831+1220477',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000142,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,337.826375,12.34653,0.193,NULL,52581568502,821587007,12837296,18.3),(156387,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156387,34.26,0.4,71.1,73861,NULL,NULL,'mean','UGC 12064',NULL,'2007A&A...465...71T',2007,1,1.1,'May contribute to the radio flux of 3C 449 = CGCG 514-050.','G',0.000077,NULL,'14.49',1.1,'S0-:','X-ray-bright group member',NULL,NULL,'Flat-Spectrum Radio Source',1,337.83575,39.35819,0.525,NULL,55526616338,867603380,13556302,14.49),(156388,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156388,34.93,0.45,96.7,73861,NULL,NULL,'K','UGC 12064',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156389,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 01782',NULL,156389,40.01,0.29,1000,73862,70,NULL,'SN photometric redshift distance, z photo =0.270 +/- 0.047','SDSS-II SN 01782',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.8455417,0.24939,0.169,NULL,51674045369,807406958,12615733,NULL),(156390,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 13861',NULL,156390,40.46,0.18,1240,73863,70,NULL,'SN photometric redshift distance, z photo =0.346 +/- 0.037','SDSS-II SN 13861',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,337.8475,0.07536,0.169,NULL,51673842841,807403794,12615684,NULL),(156391,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 13861','R',156391,41.6,0.23,1500,73863,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13861',0.393679,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156392,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 13861','R',156392,41.62,0.27,1510,73863,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13861',0.393679,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156393,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 14186','R',156393,40.69,0.15,1050,73864,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14186',0.3132,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.8504583,0.99219,0.161,NULL,52413070091,818954220,12796159,NULL),(156394,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 14186','R',156394,40.77,0.24,1080,73864,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14186',0.3132,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156395,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156395,37.06,0.46,259,73865,70,NULL,NULL,'2MASX J22312442-0047420',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000169,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,337.85175,-0.79511,0.145,NULL,50332518290,786445598,12288212,17.4),(156396,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156396,35.19,0.57,109,73866,70,NULL,NULL,'2MASX J22312491-0717348',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.46',0.42,NULL,NULL,NULL,NULL,NULL,1,337.85375,-7.29306,0.173,NULL,50390691084,787354548,12302414,16.46),(156397,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156397,34.88,0.8,94.8,73867,75,NULL,'MAT, I','ESO 602- G 025',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.02',0.7,'SA(r)b;LIRG;HIILINER','Field galaxy',NULL,NULL,'Sy',1,337.856167,-19.03447,0.089,NULL,50263417126,785365892,12271342,14.02),(156398,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156398,34.26,0.32,71.2,73867,85,NULL,'I, raw','ESO 602- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156399,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156399,34.29,0.43,72.1,73867,75,NULL,'MAT, I, raw','ESO 602- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156400,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156400,34.32,0.32,73.1,73867,85,NULL,'I, inv','ESO 602- G 025',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156401,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156401,34.52,0.45,80.3,73867,NULL,NULL,'K','ESO 602- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156402,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156402,34.53,0.47,80.4,73867,NULL,NULL,'H','ESO 602- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156403,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156403,34.54,0.43,80.8,73867,75,NULL,'MAT, I, inv','ESO 602- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156404,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156404,34.6,0.43,83.1,73867,75,NULL,'MAT, I, cor','ESO 602- G 025',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156405,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156405,34.7,0.56,87,73867,NULL,NULL,'Malmquist cor.','ESO 602- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156406,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156406,34.72,0.46,88,73867,NULL,NULL,'J','ESO 602- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156407,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156407,34.87,0.4,94.2,73867,NULL,NULL,'mean','ESO 602- G 025',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156408,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156408,34.88,0.52,94.7,73867,NULL,NULL,NULL,'ESO 602- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156409,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156409,34.92,0.2,96.4,73867,74.4,NULL,NULL,'ESO 602- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156410,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156410,37.45,0.16,309,73868,70,NULL,NULL,'2MASX J22312600-0827328',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000157,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,337.858291667,-8.45897,0.161,NULL,50359621073,786869079,12294829,17.6),(156411,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156411,37.04,0.46,255,73869,70,NULL,NULL,'2MASX J22312770+1355327',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000157,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,337.865625,13.92578,0.149,NULL,52582916600,821608071,12837626,17.9),(156412,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156412,38.79,0.46,572,73870,70,NULL,NULL,'2MASX J22313000-0114120',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,337.875,-1.23675,0.169,NULL,50332475105,786444923,12288201,17.7),(156413,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 21724','RN',156413,42.27,0.27,2150,73871,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21724',0.32522,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156414,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156414,37.45,0.16,309,73872,70,NULL,NULL,'SDSS J223131.88-082600.1',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,337.882875,-8.43336,0.161,NULL,50359623201,786869112,12294829,18.3),(156415,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156415,39.8,0.15,730,73873,74.2,NULL,'SALT 2','SDSS J223132.21-002937.2',0.25,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,337.884208333,-0.49367,0.133,NULL,50331811591,786434556,12288039,NULL),(156416,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156416,40.46,0.16,990,73873,70,NULL,'SDSS-II SN 09032, SALT 2','SDSS J223132.21-002937.2',0.25,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156417,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156417,40.5,0.16,1010,73873,65,NULL,'SALT2','SDSS J223132.21-002937.2',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156418,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 09032','R',156418,40.51,0.24,1010,73873,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005le','SDSS J223132.21-002937.2',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156419,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156419,40.58,0.06,1040,73873,70,NULL,'SDSS-II SN 09032','SDSS J223132.21-002937.2',0.25,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156420,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 09032','R',156420,40.57,0.18,1040,73873,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005le','SDSS J223132.21-002937.2',0.25,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156421,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SN 2005le',NULL,156421,40.62,0.16,1060,73873,65,NULL,'MLCS2k2','SDSS J223132.21-002937.2',0.25,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156422,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156422,38.06,0.33,409,73874,70,NULL,NULL,'2MASX J22313259-0044420',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000174,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,337.8857917,-0.74506,0.145,NULL,50332525673,786445713,12288214,17.5),(156423,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156423,31.88,0.64,23.8,73875,NULL,NULL,'Malmquist cor.','NGC 7303',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'13.58',1.2,'S?             LINER',NULL,NULL,NULL,NULL,1,337.8867917,30.95597,0.349,NULL,55491476210,867054315,13547723,13.58),(156424,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156424,31.9,0.64,24,73875,NULL,NULL,NULL,'NGC 7303',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156425,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156425,31.94,0.2,24.4,73875,74.4,NULL,NULL,'NGC 7303',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156426,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156426,33.44,0.47,48.7,73875,NULL,NULL,'H','NGC 7303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156427,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156427,33.51,0.4,50.5,73875,NULL,NULL,'mean','NGC 7303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156428,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156428,33.57,0.46,51.7,73875,NULL,NULL,'J','NGC 7303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156429,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156429,33.63,0.45,53.2,73875,NULL,NULL,'K','NGC 7303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156430,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156430,37.54,0.46,323,73876,70,NULL,NULL,'SDSS J223133.13+135507.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000127,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,337.888083,13.91878,0.149,NULL,52582917650,821608088,12837626,18.1),(156431,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156431,37.45,0.16,309,73877,70,NULL,NULL,'2MASX J22313864-0837018',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000156,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,337.910875,-8.61703,0.161,NULL,50359636164,786869315,12294833,17.4),(156432,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156432,37.45,0.16,309,73878,70,NULL,NULL,'PKS 2229-08',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00015,NULL,'15.4g',0.57,'Elliptical;BrClG',NULL,NULL,'radio jet',NULL,1,337.929958333,-8.40881,0.137,NULL,50359754900,786871170,12294862,15.4),(156433,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156433,35.15,0.49,107,73879,75,NULL,'IR','ESO 468- G 007',NULL,'2011yCatp016004901K',2011,1,1,'Ratcliffe et al. (1998MNRAS.300..417R) give v = 2040 km/sec.','G',0.000033,NULL,'16.11',0.2,'S              HII',NULL,NULL,NULL,NULL,1,337.936791667,-27.30167,0.017,NULL,50070602176,782353159,12224268,16.11),(156434,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156434,35.32,0.44,116,73879,NULL,NULL,'Malmquist cor.','ESO 468- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156435,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156435,35.36,0.43,118,73879,NULL,NULL,NULL,'ESO 468- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156436,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156436,35.4,0.2,120,73879,74.4,NULL,NULL,'ESO 468- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156437,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156437,35.42,0.4,121,73880,NULL,NULL,'Malmquist cor.','UGC 12067',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'15.00',0.6,'Sa','Pair member, S + S',NULL,NULL,NULL,1,337.9435417,20.60397,0.165,NULL,52408862074,818888469,12795132,15),(156438,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156438,35.45,0.4,123,73880,NULL,NULL,NULL,'UGC 12067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156439,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156439,35.79,0.2,144,73880,74.4,NULL,NULL,'UGC 12067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156440,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156440,42.13,0.33,1360,73881,73,NULL,'H const./H=100','GRB 990712',0.4331,'2006astro.ph..9262M',2006,1,0.02,NULL,'G',0.0004,NULL,'22.3V',0.02,'SAX/WFC',NULL,NULL,NULL,NULL,1,337.971083333,-73.40794,0.061,NULL,48414280914,756473139,11819892,22.3),(156441,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156441,41.51,0.58,1400,73881,72,NULL,NULL,'GRB 990712',0.4331,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156442,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156442,41.63,0.53,1480,73881,70,NULL,NULL,'GRB 990712',0.4331,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156443,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156443,41.76,0.44,1570,73881,69.7,NULL,'Calibrated','GRB 990712',0.4331,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156444,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156444,41.78,0.26,1580,73881,73,NULL,'H const./H=100','GRB 990712',0.4331,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156445,'GRB','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156445,41.96,0.62,1720,73881,69.7,NULL,'Fiducial','GRB 990712',0.4331,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156446,'SNIa SDSS','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 02082','RN',156446,42.43,0.2,2040,73882,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02082',0.500691,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156447,'IRAS','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156447,34.22,0.8,69.9,73883,75,NULL,'MAT, I','MCG -03-57-018',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'15',0.8,'SB(s)cd',NULL,NULL,NULL,NULL,1,337.982041667,-17.14506,0.133,NULL,50242116029,785033062,12266141,15),(156448,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156448,34.34,0.53,73.8,73883,NULL,NULL,'Malmquist cor.','MCG -03-57-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156449,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156449,34.39,0.52,75.5,73883,NULL,NULL,NULL,'MCG -03-57-018',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156450,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156450,34.49,0.2,79.1,73883,74.4,NULL,NULL,'MCG -03-57-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156451,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156451,35.16,0.43,108,73883,75,NULL,'MAT, I, raw','MCG -03-57-018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156452,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156452,35.32,0.43,116,73883,75,NULL,'MAT, I, inv','MCG -03-57-018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156453,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156453,35.36,0.32,118,73883,85,NULL,'I, raw','MCG -03-57-018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156454,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156454,35.4,0.32,120,73883,85,NULL,'I, inv','MCG -03-57-018',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156455,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156455,35.46,0.43,123,73883,75,NULL,'MAT, I, cor','MCG -03-57-018',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156456,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156456,35.17,0.47,108,73884,70,NULL,NULL,'MCG -03-57-019',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15',0.6,NULL,NULL,NULL,NULL,NULL,1,337.9932917,-15.44,0.105,NULL,50244837483,785075585,12266806,15),(156457,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156457,38.12,0.46,420,73885,70,NULL,NULL,'2MASX J22315852+1318353',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,337.993917,13.30981,0.137,NULL,52583193182,821612393,12837693,17.6),(156458,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156458,38.06,0.46,410,73886,70,NULL,NULL,'SDSS J223201.64+143817.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00015,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.006875,14.63825,0.177,NULL,52582135296,821595864,12837435,18.4),(156459,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156459,35.65,0.46,135,73887,NULL,NULL,'Malmquist cor.','UGC 12068',NULL,'2009ApJS..182..474S',2009,1,1.08,NULL,'G',0.000101,NULL,'14.9g',0.56,'Sb',NULL,NULL,NULL,NULL,1,338.0302083,0.03708,0.185,NULL,51673944810,807405387,12615709,14.9),(156460,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156460,36.1,0.38,166,73887,NULL,NULL,NULL,'UGC 12068',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156461,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156461,36.35,0.2,186,73887,74.4,NULL,NULL,'UGC 12068',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156462,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156462,37.22,0.46,278,73888,70,NULL,NULL,'2MASX J22320769+1242023',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.032,12.70061,0.177,NULL,52581685543,821588836,12837325,17.7),(156463,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156463,36.52,0.46,201,73889,70,NULL,NULL,'2MASX J22321137-0751316',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.42,'AGN',NULL,NULL,NULL,NULL,1,338.047333333,-7.85886,0.153,NULL,50359390827,786865481,12294773,16.3),(156464,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 06807','RN',156464,40.66,0.18,1050,73890,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06807',0.295,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156465,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 06807','RN',156465,40.73,0.29,1080,73890,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06807',0.295,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156466,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 09317','R',156466,40.39,0.44,953,73891,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 09317',0.256085,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','20.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.073916667,0.64311,0.193,NULL,52412101716,818939089,12795923,20.4),(156467,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 09317',NULL,156467,40.19,0.33,1090,73891,70,NULL,'SN photometric redshift distance, z photo =0.298 +/- 0.060','SDSS-II SN 09317',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156468,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156468,38.96,0.46,620,73892,70,NULL,NULL,'2MASX J22321880-0024210',NULL,'2015arXiv151105856S',2015,1,0.09,NULL,'G',0.000208,NULL,'18.1g',0.06,NULL,NULL,NULL,NULL,NULL,1,338.078375,-0.40592,0.177,NULL,49459320164,772801877,12075029,18.1),(156469,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15291',NULL,156469,40.05,0.25,1020,73893,70,NULL,'SN photometric redshift distance, z photo =0.276 +/- 0.041','SDSS-II SN 15291',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.083833,-1.15178,0.193,NULL,50332453205,786444581,12288196,NULL),(156470,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156470,35.95,0.47,155,73894,NULL,NULL,'Malmquist cor.','CGCG 474-005',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000033,NULL,'15.7',0.3,'Sc',NULL,NULL,NULL,NULL,1,338.082833,23.86353,0.165,NULL,52354910216,818045472,12781960,15.7),(156471,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156471,36.1,0.44,166,73894,NULL,NULL,NULL,'CGCG 474-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156472,'Tully-Fisher','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156472,36.18,0.2,172,73894,74.4,NULL,NULL,'CGCG 474-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156473,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156473,36.96,0.46,247,73895,70,NULL,NULL,'2MASX J22322054+1355520',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000173,NULL,'16.1g',0.41,'E0',NULL,NULL,NULL,NULL,1,338.085583333,13.93103,0.149,NULL,52582502092,821601595,12837524,16.1),(156474,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156474,39,0.46,630,73896,70,NULL,NULL,'2MASX J22322074-0040570',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000178,NULL,'18.6g',0.14,'AGN',NULL,NULL,NULL,NULL,1,338.086291667,-0.68267,0.133,NULL,50331782184,786434096,12288032,18.6),(156475,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103',NULL,156475,40.59,0.14,1310,73897,70,NULL,'SN photometric redshift distance, z photo =0.373 +/- 0.032','SDSS-II SN 15103',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.098583,-0.50469,0.133,NULL,49459358738,772802480,12075038,NULL),(156476,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103','R',156476,41.76,0.29,1610,73897,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15103',0.397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156477,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103','R',156477,41.84,0.25,1670,73897,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15103',0.397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156478,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103',NULL,156478,41.7,0.19,2190,73897,70,NULL,'SALT 2','SDSS-II SN 15103',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156479,'SNIa','2016-12-15 15:16:00','2016-12-16 11:21:17','1','SDSS-II SN 15103',NULL,156479,41.76,0.19,2250,73897,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15103',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156480,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156480,31.88,0.21,23.8,73898,NULL,NULL,'I','NGC 7302',NULL,'2001ApJ...546..681T',2001,1,1.8,NULL,'G',0.000053,NULL,'13.58',1.1,'SA(s)0-:','in a pair',NULL,NULL,NULL,1,338.099167,-14.12053,0.173,NULL,50417562855,787774419,12308975,13.58),(156481,'SBF','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156481,31.93,0.14,24.3,73898,74.4,NULL,NULL,'NGC 7302',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156482,'Faber-Jackson','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156482,32.49,0.37,31.5,73898,95,NULL,'Weighted Mean','NGC 7302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156483,'Faber-Jackson','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156483,32.91,0.63,38.2,73898,95,NULL,'Michard 1979b, c','NGC 7302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156484,'Faber-Jackson','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156484,33,0.46,39.8,73898,95,NULL,'Michard 1979a','NGC 7302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156485,'Faber-Jackson','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156485,33.85,0.81,58.9,73898,55,NULL,'Visvanathan & Sandage 1979','NGC 7302',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156486,'Tully est','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,NULL,156486,32.64,0.8,33.7,73898,75,NULL,'B','NGC 7302',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156487,'FP','2016-12-15 15:16:00','2016-12-16 11:21:17','1',NULL,'R',156487,38.19,0.46,434,73899,70,NULL,NULL,'2MASX J22322448+0034316',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,338.101958333,0.57536,0.193,NULL,51673969428,807405772,12615715,17.6),(156488,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156488,35.24,0.16,108,73900,74.2,NULL,'SALT 2','UGC 12071',0.034597,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.000033,NULL,'14.97',0.4,'SBb',NULL,NULL,NULL,NULL,1,338.102083,30.83556,0.349,NULL,55491590589,867056102,13547751,14.97),(156489,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156489,35.81,0.09,145,73900,74.4,NULL,NULL,'UGC 12071',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156490,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156490,35.91,0.15,147,73900,70,NULL,'SALT 2','UGC 12071',0.034597,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156491,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156491,35.99,0.15,153,73900,73.8,NULL,'SALT 2 (SNANA)','UGC 12071',0.0336,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156492,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156492,36,0.19,153,73900,72,NULL,NULL,'UGC 12071',0.034597,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156493,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156493,36.02,0.16,155,73900,65,NULL,'SALT','UGC 12071',0.034597,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156494,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156494,36.09,0.04,160,73900,72,NULL,NULL,'UGC 12071',0.034597,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156495,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156495,36.12,0.18,162,73900,65,NULL,'SALT2','UGC 12071',0.034597,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156496,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156496,36.12,0.15,162,73900,72,NULL,NULL,'UGC 12071',0.034597,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156497,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156497,36.21,0.14,168,73900,65,NULL,'MLCS17','UGC 12071',0.034597,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156498,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156498,36.21,0.15,169,73900,65,NULL,'MLCS31','UGC 12071',0.034597,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156499,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156499,36.39,0.03,183,73900,70,NULL,'SALT 2','UGC 12071',0.034597,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156500,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gr',NULL,156500,36.37,0.27,188,73900,72,NULL,'M(H) = -18.317 mag','UGC 12071',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156501,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156501,35.68,0.8,137,73900,75,NULL,'W91PP, r','UGC 12071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156502,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156502,34.86,0.38,93.6,73900,75,NULL,'W91PP, r, raw','UGC 12071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156503,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156503,34.95,0.38,97.9,73900,75,NULL,'W91PP, r, cor','UGC 12071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156504,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156504,35.04,0.38,102,73900,75,NULL,'W91PP, r, inv','UGC 12071',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156505,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156505,38.1,0.46,417,73901,70,NULL,NULL,'2MASX J22322684-0842079',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000187,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,338.111917,-8.70219,0.165,NULL,50359532136,786867689,12294807,17),(156506,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15471','RN',156506,41.08,0.22,1430,73902,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15471',0.153213,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156507,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15471','RN',156507,41.53,0.34,1750,73902,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15471',0.153213,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156508,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13307','RN',156508,39.56,0.12,751,73903,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13307',0.08853,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156509,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13307','RN',156509,40.19,0.22,1000,73903,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13307',0.08853,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156510,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156510,37.45,0.16,309,73904,70,NULL,NULL,'2MASX J22322980-0823229',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.00015,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,338.124125,-8.38953,0.137,NULL,50359738753,786870918,12294858,16.9),(156511,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15400','RN',156511,43.74,0.74,5160,73905,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15400',0.085468,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156512,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15400','RN',156512,46.65,0.98,19700,73905,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15400',0.085468,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156513,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156513,33.42,0.47,48.2,73906,NULL,NULL,'H','IC 5226',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000017,NULL,'13.54',1.4,'SB(r)b',NULL,NULL,NULL,NULL,1,338.125875,-25.66197,0.017,NULL,50076071952,782438624,12225603,13.54),(156514,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156514,33.58,0.45,52.1,73906,NULL,NULL,'K','IC 5226',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156515,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156515,33.6,0.46,52.6,73906,NULL,NULL,'J','IC 5226',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156516,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156516,34.15,0.4,67.7,73906,NULL,NULL,'mean','IC 5226',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156517,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156517,35.99,0.46,158,73907,70,NULL,NULL,'2MASX J22323135+0041156',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000167,NULL,'16.1g',0.27,'E0',NULL,NULL,NULL,NULL,1,338.130625,0.68758,0.193,NULL,52412089065,818938891,12795920,16.1),(156518,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20829','R',156518,41.07,0.29,1250,73908,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qu','SDSS J223232.65+005133.7',0.304931,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,NULL,'21.0g',0.05,NULL,NULL,NULL,NULL,NULL,1,338.1360417,0.85936,0.205,NULL,52412947773,818952308,12796129,21),(156519,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20829','R',156519,41.38,0.2,1440,73908,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qu','SDSS J223232.65+005133.7',0.304931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156520,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156520,34.05,0.4,64.7,73909,NULL,NULL,'mean','UGC 12073',NULL,'2007A&A...465...71T',2007,1,2.1,NULL,'G',0.000037,NULL,'14.4',0.8,'SB(s)b','X-ray-bright group member',NULL,NULL,NULL,1,338.139,39.2155,0.525,NULL,55527817228,867622144,13556596,14.4),(156521,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156521,34.16,0.36,68,73909,NULL,NULL,NULL,'UGC 12073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156522,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156522,34.2,0.2,69.2,73909,74.4,NULL,NULL,'UGC 12073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156523,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156523,34.23,0.49,70.1,73909,75,NULL,'IR','UGC 12073',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156524,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156524,34.32,0.34,73,73909,NULL,NULL,'Malmquist cor.','UGC 12073',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156525,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156525,34.43,0.46,76.8,73909,NULL,NULL,'J','UGC 12073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156526,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156526,34.44,0.47,77.1,73909,NULL,NULL,'H','UGC 12073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156527,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156527,34.45,0.45,77.6,73909,NULL,NULL,'K','UGC 12073',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156528,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156528,35.69,0.56,137,73910,70,NULL,NULL,'MCG -02-57-014',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.00015,NULL,'14.8g',0.6,'E0',NULL,NULL,NULL,NULL,1,338.143625,-9.51919,0.165,NULL,50361372738,786896449,12295257,14.8),(156529,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156529,35.8,0.46,145,73910,70,NULL,NULL,'MCG -02-57-014',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156530,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156530,36.79,0.27,228,73911,70,NULL,NULL,'2MASX J22323628-0057355',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,338.151333,-0.95994,0.173,NULL,50332266120,786441658,12288150,17),(156531,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156531,34.95,0.8,97.9,73912,75,NULL,'W91PP, r','UGC 12072',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'16.5',0.2,'S?',NULL,NULL,NULL,NULL,1,338.1522917,23.93178,0.185,NULL,52354921388,818045646,12781963,16.5),(156532,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156532,35.48,0.38,125,73912,75,NULL,'W91PP, r, raw','UGC 12072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156533,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156533,35.57,0.38,130,73912,75,NULL,'W91PP, r, inv','UGC 12072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156534,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156534,35.63,0.49,133,73912,75,NULL,'IR','UGC 12072',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156535,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156535,35.77,0.38,142,73912,75,NULL,'W91PP, r, cor','UGC 12072',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156536,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156536,35.79,0.49,144,73912,NULL,NULL,'Malmquist cor.','UGC 12072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156537,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156537,35.93,0.46,154,73912,NULL,NULL,NULL,'UGC 12072',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156538,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156538,35.97,0.2,156,73912,74.4,NULL,NULL,'UGC 12072',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156539,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156539,37.93,0.46,386,73913,70,NULL,NULL,'SDSS J223240.50+121536.1',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00013,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,338.1687917,12.26006,0.201,NULL,52581721507,821589398,12837334,18.1),(156540,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156540,38.6,0.46,525,73914,70,NULL,NULL,'SDSS J223241.00-010046.0',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000151,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,338.170833,-1.01278,0.173,NULL,50332270097,786441720,12288151,18.4),(156541,'Horizontal Branch','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156541,24.55,0.12,0.811,73915,NULL,NULL,NULL,'Andromeda XXVIII',NULL,'2015ApJ...806..230S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,338.171667,31.21617,0.365,1,55491159559,867049368,13547646,NULL),(156542,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156542,24.1,0.5,0.65,73915,NULL,NULL,NULL,'Andromeda XXVIII',NULL,'2011ApJ...742L..14S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156543,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156543,36.41,0.46,191,73916,70,NULL,NULL,'2MASX J22324170-0927469',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.1g',0.39,'S0/a',NULL,NULL,NULL,NULL,1,338.173583,-9.46303,0.157,NULL,50361399413,786896865,12295263,16.1),(156544,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','PTF10wor','N',156544,37.01,0.11,239,73917,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10wor',0.0568,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156545,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156545,35.03,0.49,101,73918,70,NULL,NULL,'FAIRALL 0131',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.98',0.52,'(R:)SA0^+:',NULL,NULL,NULL,NULL,1,338.185833,-59.47158,0,NULL,48799720751,762495636,11913994,15.98),(156546,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156546,37.82,0.33,366,73919,70,NULL,NULL,'2MASXi J2232474-011005',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.197917,-1.16831,0.193,NULL,50332384068,786443501,12288179,17.8),(156547,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156547,37.04,0.46,256,73920,70,NULL,NULL,'2MASX J22324911-0755599',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000138,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.2045417,-7.93328,0.153,NULL,50359321797,786864403,12294756,18),(156548,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156548,37.82,0.33,366,73921,70,NULL,NULL,'2MASX J22324962-0111145',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000174,NULL,'17.2g',0.3,NULL,NULL,NULL,NULL,NULL,1,338.206833,-1.18731,0.193,NULL,50332375192,786443362,12288177,17.2),(156549,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19319','RN',156549,39.74,0.16,772,73922,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19319',0.150863,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156550,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19319','RN',156550,40.69,0.25,1190,73922,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19319',0.150863,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156551,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156551,36.79,0.27,228,73923,70,NULL,NULL,'2MASX J22325302-0058245',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000187,NULL,'16.3g',0.31,NULL,NULL,NULL,NULL,NULL,1,338.2210417,-0.9735,0.173,NULL,50332297089,786442142,12288158,16.3),(156552,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06180','RN',156552,39.03,0.53,605,73924,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06180',0.057051,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156553,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06180','RN',156553,41.57,0.5,1950,73924,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06180',0.057051,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156554,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156554,38.24,0.27,445,73925,70,NULL,NULL,'2MASX J22325695+1314018',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000135,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,338.2372917,13.23375,0.157,NULL,52582987831,821609184,12837643,18.2),(156555,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156555,37.75,0.46,355,73926,70,NULL,NULL,'2MASX J22330026+1233299',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.2512917,12.55825,0.173,NULL,52581851146,821591424,12837366,18),(156556,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156556,38.24,0.27,445,73927,70,NULL,NULL,'2MASX J22330462+1314559',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.26925,13.24883,0.157,NULL,52581132119,821580189,12837190,18.2),(156557,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156557,38.24,0.27,445,73928,70,NULL,NULL,'2MASX J22330462+1316079',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000151,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.26925,13.26892,0.157,NULL,52582980089,821609063,12837641,18.1),(156558,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156558,36.24,0.57,177,73929,70,NULL,NULL,'2MASX J22330595-2214250',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.42',NULL,'EL','Field galaxy',NULL,NULL,NULL,1,338.27475,-22.24044,0.073,NULL,50203299183,784426549,12256664,15.42),(156559,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156559,32.08,0.8,26.1,73930,75,NULL,'B','UGC 12074',NULL,'1988NBGC.C....0000T',1988,1,0.6,NULL,'G',0.000007,NULL,'14.41',0.4,'Irr            HII',NULL,NULL,NULL,NULL,1,338.2762083,8.09747,0.309,NULL,52451472895,819554263,12805535,14.41),(156560,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156560,31.6,0.69,20.8,73930,100,NULL,'mid-IR','UGC 12074',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156561,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156561,32.12,0.2,26.6,73930,74.4,NULL,NULL,'UGC 12074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156562,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156562,32.16,0.4,27,73930,NULL,NULL,'mean','UGC 12074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156563,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156563,32.54,0.45,32.2,73930,NULL,NULL,'K','UGC 12074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156564,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156564,32.55,0.47,32.4,73930,NULL,NULL,'H','UGC 12074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156565,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156565,32.58,0.46,32.8,73930,NULL,NULL,'J','UGC 12074',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156566,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156566,33.15,0.49,42.7,73931,75,NULL,'IR','FGC 2394',NULL,'2011yCatp016004901K',2011,1,1.62,NULL,'G',0.000017,NULL,'15.6',0.22,'Sdm',NULL,NULL,NULL,NULL,1,338.280625,72.47858,3.169,NULL,52786222434,824784725,12887261,15.6),(156567,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156567,33.74,0.43,56,73931,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2394',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156568,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156568,33.76,NULL,56.6,73931,NULL,NULL,NULL,'FGC 2394',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156569,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156569,33.91,NULL,60.4,73931,NULL,NULL,'Dipole','FGC 2394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156570,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156570,33.91,NULL,60.4,73931,NULL,NULL,'Dipole + Quadrupole','FGC 2394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156571,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156571,33.92,NULL,60.7,73931,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2394',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156572,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156572,37.32,0.46,290,73932,70,NULL,NULL,'2MASX J22330856-1008333',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.00015,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,338.2857917,-10.14261,0.173,NULL,50364580410,786946568,12296040,16.5),(156573,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156573,34.7,0.48,87.2,73933,70,NULL,NULL,'MCG -03-57-021',NULL,'2014MNRAS.445.2677S',2014,1,3.5,NULL,'G',0.00012,NULL,'14.90',2.5,'(R\')SAB(rs)0^0^?',NULL,NULL,NULL,NULL,1,338.2892917,-17.06797,0.101,NULL,50242219169,785034674,12266166,14.9),(156574,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156574,35.8,0.76,145,73934,70,NULL,NULL,'2MASX J22331128-1447290',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.71',0.2,NULL,NULL,NULL,NULL,NULL,1,338.2970417,-14.79144,0.117,NULL,50430253234,787972706,12312073,16.71),(156575,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 21165','N',156575,42.12,0.35,2650,73935,70,NULL,'SALT 2','SDSS-II SN 21165',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156576,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 21165','N',156576,42.27,0.35,2840,73935,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21165',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156577,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156577,35.85,0.59,148,73936,70,NULL,NULL,'2MASX J22331342-3737146',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.49',0.25,'(R_1)SAB(r)0^+',NULL,NULL,NULL,NULL,1,338.305833,-37.62064,0,NULL,50708412357,792318943,12379983,15.49),(156578,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156578,36.79,0.27,228,73937,70,NULL,NULL,'2MASX J22331420-0049453',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'16.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.309291667,-0.82925,0.149,NULL,49459633287,772806770,12075105,16.3),(156579,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156579,33.25,0.8,44.6,73938,75,NULL,'MAT, I','NGC 7306',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000013,NULL,'13.36',0.7,'(R\')SBb?',NULL,NULL,NULL,NULL,1,338.318625,-27.24661,0.061,NULL,50068970103,782327657,12223869,13.36),(156580,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156580,32.76,0.69,35.6,73938,100,NULL,'mid-IR','NGC 7306',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156581,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156581,33.18,0.32,43.3,73938,85,NULL,'I, raw','NGC 7306',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156582,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156582,33.2,0.43,43.7,73938,75,NULL,'MAT, I, raw','NGC 7306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156583,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156583,33.23,0.32,44.2,73938,85,NULL,'I, inv','NGC 7306',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156584,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156584,33.24,0.47,44.4,73938,NULL,NULL,'H','NGC 7306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156585,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156585,33.28,0.46,45.2,73938,NULL,NULL,'J','NGC 7306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156586,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156586,33.29,0.45,45.5,73938,NULL,NULL,'K','NGC 7306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156587,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156587,33.3,0.4,45.7,73938,NULL,NULL,'mean','NGC 7306',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156588,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156588,33.39,0.43,47.7,73938,75,NULL,'MAT, I, inv','NGC 7306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156589,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156589,33.46,0.43,49.3,73938,75,NULL,'MAT, I, cor','NGC 7306',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156590,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156590,33.6,0.2,52.5,73938,74.4,NULL,NULL,'NGC 7306',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156591,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156591,33.82,0.46,58,73938,NULL,NULL,'Malmquist cor.','NGC 7306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156592,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156592,33.89,0.45,59.9,73938,NULL,NULL,NULL,'NGC 7306',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156593,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05506','RN',156593,40.59,0.25,1060,73939,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05506',0.238884,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156594,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05506','RN',156594,40.99,0.34,1270,73939,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05506',0.238884,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156595,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 12327','RN',156595,39.78,1.53,842,73940,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 12327',0.07381,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156596,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 12327','RN',156596,40.08,0.51,968,73940,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12327',0.07381,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156597,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156597,37.56,0.46,325,73941,70,NULL,NULL,'SDSS J223325.06-003637.3',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,338.3544583,-0.61039,0.153,NULL,49460172662,772815197,12075237,17.5),(156598,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156598,37.36,0.46,296,73942,70,NULL,NULL,'2MASX J22332549-0822128',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,338.356333,-8.37028,0.153,NULL,50359881647,786873150,12294892,16.8),(156599,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 17410','RN',156599,42.8,0.18,2310,73943,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17410',0.573059,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156600,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156600,37.16,0.46,270,73944,70,NULL,NULL,'2MASX J22333056-0030516',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,338.3774583,-0.51428,0.153,NULL,49460277052,772816828,12075262,17.1),(156601,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156601,35.18,0.51,109,73945,70,NULL,NULL,'ESO 345- G 024',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.00011,NULL,'15.28',0.37,'S0',NULL,NULL,NULL,NULL,1,338.383,-37.54403,0,NULL,50708405464,792318835,12379981,15.28),(156602,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156602,35.69,0.8,137,73946,75,NULL,'W91PP, r','UGC 12078',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,338.3889583,30.80481,0.365,NULL,55491575249,867055863,13547747,16),(156603,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156603,35.35,0.38,117,73946,75,NULL,'W91PP, r, raw','UGC 12078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156604,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156604,35.47,0.38,124,73946,75,NULL,'W91PP, r, cor','UGC 12078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156605,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156605,35.55,0.38,129,73946,75,NULL,'W91PP, r, inv','UGC 12078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156606,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156606,35.66,0.46,135,73947,70,NULL,NULL,'2MASX J22333402-1010578',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00015,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,338.3917083,-10.18267,0.173,NULL,50364625651,786947275,12296051,15.4),(156607,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156607,35.96,0.49,156,73947,70,NULL,NULL,'2MASX J22333402-1010578',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156608,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05745','RN',156608,39.81,0.35,862,73948,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05745',0.063477,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156609,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05745','RN',156609,41.07,0.6,1540,73948,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05745',0.063477,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156610,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156610,37.41,0.46,303,73949,70,NULL,NULL,'2MASX J22333854-0000296',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'16.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.4105417,-0.00825,0.193,NULL,49459860062,772810313,12075161,16.5),(156611,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156611,38.33,0.46,463,73950,70,NULL,NULL,'2MASX J22333883+1346588',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000196,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.41175,13.78289,0.137,NULL,52582446878,821600732,12837511,18.2),(156612,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156612,37.5,0.46,316,73951,70,NULL,NULL,'2MASX J22334166-0814058',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,338.423708333,-8.23511,0.149,NULL,50359835440,786872428,12294881,17.6),(156613,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06085',NULL,156613,41.49,0.09,1980,73952,70,NULL,'SN photometric redshift distance, z photo =0.650 +/- 0.043','SDSS-II SN 06085',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.428625,0.40297,0.209,NULL,51674836086,807419313,12615926,NULL),(156614,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268',NULL,156614,40.22,0.3,1110,73953,70,NULL,'SN photometric redshift distance, z photo =0.303 +/- 0.055','SDSS-II SN 15268',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.4449583,0.13867,0.201,NULL,51674282687,807410666,12615791,NULL),(156615,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268','R',156615,41.01,0.23,1230,73953,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15268',0.298563,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156616,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268','R',156616,41.14,0.15,1300,73953,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15268',0.298563,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156617,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268',NULL,156617,40.8,0.12,1450,73953,70,NULL,'SALT 2','SDSS-II SN 15268',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156618,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15268',NULL,156618,40.83,0.12,1470,73953,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15268',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156619,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156619,38.55,0.46,514,73954,70,NULL,NULL,'SDSS J223347.23+125436.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000147,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.446791667,12.91019,0.157,NULL,52581288589,821582634,12837228,18.5),(156620,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2003gn','R',156620,36.05,0.06,162,73955,NULL,NULL,'MLCS2k2, R(V) = 3.1','CGCG 452-024',NULL,'2015Sci...347.1459K',2015,1,1,NULL,'G',0.000033,NULL,'15.24',0.3,'Sab',NULL,NULL,NULL,NULL,1,338.460333333,20.80531,0.157,NULL,52408578475,818884038,12795063,15.24),(156621,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2003gn',NULL,156621,36.14,0.15,163,73955,70,NULL,'SALT 2','CGCG 452-024',0.03445,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156622,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2003gn','R',156622,36.09,0.06,165,73955,NULL,NULL,'MLCS2k2, R(V) = 1.8','CGCG 452-024',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156623,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156623,32.06,0.8,25.8,73956,75,NULL,'MAT, I','NGC 7307',NULL,'1997ApJS..109..333W',1997,1,3.5,'Confused HIPASS source','G',0.000017,NULL,'12.92',0.9,'SB(s)cd pec:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,338.468917,-40.93272,0,NULL,50723978204,792562159,12383783,12.92),(156624,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156624,32.07,0.8,25.9,73956,75,NULL,'A82, H','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156625,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156625,31.46,0.32,19.6,73956,85,NULL,'I, raw','NGC 7307',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156626,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156626,31.46,0.32,19.6,73956,85,NULL,'I, inv','NGC 7307',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156627,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156627,31.61,0.2,21,73956,74.4,NULL,NULL,'NGC 7307',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156628,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156628,31.62,0.43,21.1,73956,75,NULL,'3.6 micron, color corrected','NGC 7307',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156629,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156629,31.63,0.43,21.2,73956,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7307',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156630,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156630,31.69,0.43,21.7,73956,75,NULL,'MAT, I, raw','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156631,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156631,31.72,0.35,22.1,73956,NULL,NULL,NULL,'NGC 7307',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156632,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156632,31.72,0.39,22.1,73956,73,NULL,'opt','NGC 7307',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156633,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156633,31.75,0.43,22.4,73956,75,NULL,'MAT, I, inv','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156634,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156634,31.79,0.4,22.8,73956,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7307',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156635,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156635,31.94,0.43,24.5,73956,75,NULL,'MAT, I, cor','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156636,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156636,32.06,0.4,25.9,73956,75,NULL,'B','NGC 7307',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156637,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156637,32.1,0.11,26.4,73956,NULL,NULL,NULL,'NGC 7307',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156638,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156638,32.44,0.47,30.7,73956,75,NULL,'A82, H, inv','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156639,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156639,32.44,0.47,30.8,73956,75,NULL,'A82, H, raw','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156640,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156640,32.52,0.4,31.9,73956,NULL,NULL,'mean','NGC 7307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156641,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156641,32.66,0.47,34.1,73956,75,NULL,'A82, H, cor','NGC 7307',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156642,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156642,32.95,0.46,38.8,73956,NULL,NULL,'J','NGC 7307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156643,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156643,33.12,0.47,42,73956,NULL,NULL,'H','NGC 7307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156644,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156644,33.18,0.45,43.3,73956,NULL,NULL,'K','NGC 7307',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156645,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588',NULL,156645,38.49,0.64,498,73957,70,NULL,'SN photometric redshift distance, z photo =0.124 +/- 0.047','SDSS-II SN 18588',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.47175,-1.20458,0.173,NULL,50332411595,786443931,12288186,NULL),(156646,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588','R',156646,40.64,0.23,1070,73957,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18588',0.251315,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156647,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588','R',156647,41.01,0.31,1270,73957,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18588',0.251315,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156648,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588',NULL,156648,40.92,0.19,1530,73957,70,NULL,'SALT 2','SDSS-II SN 18588',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156649,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18588',NULL,156649,40.94,0.19,1540,73957,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18588',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156650,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13062','RN',156650,42.83,0.21,2600,73958,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13062',0.416357,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156651,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13062','RN',156651,43.04,0.18,2870,73958,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13062',0.416357,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156652,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156652,37.33,0.46,292,73959,70,NULL,NULL,'2MASX J22335936-0103566',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,338.497375,-1.06564,0.149,NULL,49459642479,772806913,12075108,17.3),(156653,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156653,36.67,0.44,216,73960,NULL,NULL,'Malmquist cor.','2MASX J22340264+0154591',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000023,NULL,'14.34',0.2,'Sa',NULL,NULL,NULL,NULL,1,338.511083333,1.91639,0.149,NULL,52415790647,818996728,12796823,14.34),(156654,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156654,36.84,0.4,233,73960,NULL,NULL,NULL,'2MASX J22340264+0154591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156655,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156655,36.88,0.2,238,73960,74.4,NULL,NULL,'2MASX J22340264+0154591',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156656,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156656,36.01,0.47,159,73961,NULL,NULL,'H','UGC 12081',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'15.13',0.4,'Sab','Isolated galaxy',NULL,NULL,NULL,1,338.5164583,10.17294,0.241,NULL,52462085268,819720082,12808126,15.13),(156657,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156657,36.08,0.4,164,73961,NULL,NULL,'mean','UGC 12081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156658,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156658,36.08,0.45,165,73961,NULL,NULL,'K','UGC 12081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156659,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156659,36.23,0.46,176,73961,NULL,NULL,'J','UGC 12081',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156660,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156660,33.86,0.43,59.2,73962,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J22340404+6826298',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.00002,NULL,'9.73K',0.33,'Spiral',NULL,NULL,NULL,NULL,1,338.516833,68.44167,NULL,NULL,53552301725,836754714,13074292,9.73),(156661,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07037','RN',156661,38.57,0.66,474,73963,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07037',0.090174,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156662,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07037','RN',156662,39.47,0.46,718,73963,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07037',0.090174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156663,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156663,37.49,0.46,315,73964,70,NULL,NULL,'2MASX J22340458+0008271',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000182,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,338.519,0.14075,0.201,NULL,51674239460,807409991,12615781,16.6),(156664,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156664,37.17,0.46,271,73965,70,NULL,NULL,'2MASX J22340552-1007213',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,338.522875,-10.12253,0.161,NULL,50364652670,786947697,12296057,16.7),(156665,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156665,33.3,0.22,45,73966,74.2,NULL,'SALT 2','NGC 7311',0.01512,'2010ApJ...716..712A',2010,1,1.6,NULL,'G',0.000017,NULL,'12.4B',0.8,'Sab','in a pair',NULL,NULL,NULL,1,338.5279583,5.56989,0.209,NULL,52422852884,819107076,12798548,12.4),(156666,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156666,33.76,0.04,55.7,73966,72,NULL,NULL,'NGC 7311',0.01512,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156667,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156667,33.77,0.24,55.8,73966,65,NULL,'MLCS31','NGC 7311',0.01512,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156668,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156668,33.82,0.01,58.1,73966,72,NULL,'MLCS31','NGC 7311',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156669,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156669,33.87,0.2,58.6,73966,72,NULL,NULL,'NGC 7311',0.01512,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156670,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156670,33.87,0.02,59.5,73966,72,NULL,'M(H) = -18.317 mag','NGC 7311',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156671,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156671,33.88,0.09,59.7,73966,74.4,NULL,NULL,'NGC 7311',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156672,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156672,33.94,0.05,60.5,73966,72,NULL,NULL,'NGC 7311',0.01512,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156673,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156673,33.95,0.21,60.7,73966,70,NULL,'SALT 2','NGC 7311',0.01512,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156674,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156674,33.98,0.26,61.5,73966,73.8,NULL,'SALT 2 (SNANA)','NGC 7311',0.015,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156675,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156675,34.06,0.18,63.1,73966,72,NULL,NULL,'NGC 7311',0.0139,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156676,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156676,34.05,0.25,63.7,73966,73.8,NULL,'SALT 2 (SNANA)','NGC 7311',0.015,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156677,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156677,34.08,0.24,64.6,73966,65,NULL,'MLCS17','NGC 7311',0.01512,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156678,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156678,34.19,0.26,67.7,73966,65,NULL,'SALT2','NGC 7311',0.01512,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156679,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005kc',NULL,156679,35.36,0.04,116,73966,70,NULL,'SALT 2','NGC 7311',0.01512,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156680,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156680,33.4,0.47,47.8,73966,NULL,NULL,'H','NGC 7311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156681,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156681,33.41,0.46,48.1,73966,NULL,NULL,'J','NGC 7311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156682,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156682,33.43,0.45,48.4,73966,NULL,NULL,'K','NGC 7311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156683,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156683,33.69,0.4,54.7,73966,NULL,NULL,'mean','NGC 7311',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156684,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156684,38.24,0.46,444,73967,70,NULL,NULL,'SDSS J223408.55-000837.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000152,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.535625,-0.14386,0.193,NULL,49459863889,772810373,12075162,18.1),(156685,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156685,37.53,0.46,320,73968,70,NULL,NULL,'2MASX J22340900-0846343',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,338.537416667,-8.77617,0.157,NULL,50359097444,786860897,12294701,17.6),(156686,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2006gp',NULL,156686,39.53,0.16,805,73969,70,NULL,'Hubble residual -0.03 for z0.21290','SDSS J223410.00+000317.9',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,338.5414583,0.05486,0.201,NULL,51674236609,807409947,12615780,NULL),(156687,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13425','R',156687,40.05,0.24,845,73969,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gp','SDSS J223410.00+000317.9',0.2129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156688,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13425','R',156688,40.06,0.18,847,73969,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gp','SDSS J223410.00+000317.9',0.2129,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156689,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156689,38.56,0.46,516,73970,70,NULL,NULL,'2MASX J22341038-0759143',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,338.543375,-7.98739,0.153,NULL,50392031763,787375496,12302742,17.7),(156690,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156690,30.72,0.4,13.9,73971,75,NULL,'B','UGC 12082',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000003,NULL,'14.1',2.2,'Sm','Isolated galaxy',NULL,NULL,NULL,1,338.545083,32.8605,0.305,NULL,55460189124,866565455,13540085,14.1),(156691,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156691,37.46,0.33,310,73972,70,NULL,NULL,'2MASX J22341379+0036290',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',NULL,NULL,'16.9g',0.29,'BrClG',NULL,NULL,NULL,NULL,1,338.5574583,0.60817,0.217,NULL,51674635424,807416178,12615877,16.9),(156692,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156692,37.46,0.33,310,73973,70,NULL,NULL,'2MASX J22341473+0038250',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,338.5612917,0.64033,0.217,NULL,51674642917,807416295,12615879,18.2),(156693,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156693,36.98,0.46,248,73974,70,NULL,NULL,'2MASX J22341473+1423142',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,338.561375,14.38733,0.157,NULL,52594405423,821787584,12840431,17.7),(156694,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156694,38.21,0.33,439,73975,70,NULL,NULL,'2MASX J22342398+1349413',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00019,NULL,'17.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,338.600083,13.82817,0.161,NULL,52593741684,821777213,12840268,17.3),(156695,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156695,36.97,0.46,248,73976,70,NULL,NULL,'2MASX J22342546+1225443',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.0002,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,338.606125,12.42897,0.169,NULL,52580957559,821577461,12837147,16.5),(156696,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156696,37.26,0.46,283,73977,70,NULL,NULL,'2MASX J22342794-0850286',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,338.616375,-8.84128,0.157,NULL,50359093826,786860841,12294700,16.9),(156697,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156697,37.36,0.46,296,73978,70,NULL,NULL,'2MASX J22343016-0807376',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.2g',0.27,'AGN',NULL,NULL,NULL,NULL,1,338.6257083,-8.12714,0.153,NULL,50392281572,787379399,12302803,17.2),(156698,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156698,35.8,0.71,145,73979,NULL,NULL,'Malmquist cor.','2MFGC 16997',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000027,NULL,'16.5',NULL,'Sc',NULL,NULL,NULL,NULL,1,338.627041667,1.56064,0.189,NULL,52415743228,818995987,12796812,16.5),(156699,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156699,36.19,0.6,173,73979,NULL,NULL,NULL,'2MFGC 16997',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156700,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156700,36.23,0.2,176,73979,74.4,NULL,NULL,'2MFGC 16997',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156701,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156701,36.38,0.56,189,73980,70,NULL,NULL,'ESO 238- G 017',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.73',0.27,'S0-a',NULL,NULL,NULL,NULL,1,338.629417,-48.11078,0,NULL,50699719530,792183117,12377861,16.73),(156702,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156702,34.23,0.8,70.3,73981,75,NULL,'MAT, I','ESO 533- G 048',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000023,NULL,'14.76',0.5,'IB(s)m','in a pair',NULL,NULL,NULL,1,338.632416667,-22.69153,0.041,NULL,50205308368,784457943,12257155,14.76),(156703,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156703,34.01,0.32,63.3,73981,85,NULL,'I, raw','ESO 533- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156704,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156704,34.03,0.32,64,73981,85,NULL,'I, inv','ESO 533- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156705,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156705,34.16,0.43,68,73981,75,NULL,'MAT, I, raw','ESO 533- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156706,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156706,34.3,0.43,72.4,73981,75,NULL,'MAT, I, inv','ESO 533- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156707,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156707,34.42,0.2,76.6,73981,74.4,NULL,NULL,'ESO 533- G 048',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156708,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156708,34.46,0.43,78,73981,75,NULL,'MAT, I, cor','ESO 533- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156709,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156709,34.56,0.48,81.5,73981,NULL,NULL,NULL,'ESO 533- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156710,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156710,34.58,0.47,82.5,73981,NULL,NULL,'Malmquist cor.','ESO 533- G 048',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156711,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156711,37.03,0.46,254,73982,70,NULL,NULL,'2MASX J22343235+1340333',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000141,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.634875,13.67603,0.153,NULL,52593693275,821776457,12840257,18.3),(156712,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156712,36.41,0.43,192,73983,NULL,NULL,'Malmquist cor.','2MASX J22343238+0124565',NULL,'2009ApJS..182..474S',2009,1,0.34,NULL,'G',0.000023,NULL,'15.15',0.18,'Sbc',NULL,NULL,NULL,NULL,1,338.635083,1.41583,0.189,NULL,52412342896,818942857,12795982,15.15),(156713,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156713,36.52,0.41,202,73983,NULL,NULL,NULL,'2MASX J22343238+0124565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156714,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156714,36.56,0.2,205,73983,74.4,NULL,NULL,'2MASX J22343238+0124565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156715,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156715,38.21,0.33,439,73984,70,NULL,NULL,'SDSS J223434.18+135409.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000181,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,338.642458333,13.90261,0.161,NULL,52593926178,821780096,12840314,18.6),(156716,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156716,34.62,0.69,83.8,73985,100,NULL,'mid-IR','NGC 7312',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000077,NULL,'14.20',0.8,'SB(s)b','in a pair',NULL,NULL,NULL,1,338.6449583,5.81736,0.205,NULL,52422966417,819108850,12798575,14.2),(156717,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156717,35.49,0.38,125,73985,NULL,NULL,'Malmquist cor.','NGC 7312',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156718,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156718,35.81,0.33,145,73985,NULL,NULL,NULL,'NGC 7312',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156719,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156719,36.29,0.2,181,73985,74.4,NULL,NULL,'NGC 7312',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156720,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156720,37.18,0.53,273,73986,NULL,NULL,'Malmquist cor.','2MASX J22343678+0155375',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000027,NULL,'15.84',0.1,'Sc',NULL,NULL,NULL,NULL,1,338.653333,1.92711,0.137,NULL,52415822063,818997219,12796831,15.84),(156721,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156721,37.38,0.48,299,73986,NULL,NULL,NULL,'2MASX J22343678+0155375',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156722,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156722,37.42,0.2,305,73986,74.4,NULL,NULL,'2MASX J22343678+0155375',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156723,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 10331','RN',156723,42.95,0.26,2620,73987,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10331',0.480693,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156724,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07728','RN',156724,43.52,0.27,3700,73988,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07728',0.367595,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156725,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07728','RN',156725,43.55,0.31,3750,73988,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07728',0.367595,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156726,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 12110','RN',156726,40.96,1.56,1220,73989,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12110',0.28139,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156727,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 12110','RN',156727,41.42,0.31,1500,73989,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12110',0.28139,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156728,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156728,37.03,0.5,254,73990,NULL,NULL,'Malmquist cor.','2MFGC 16998',NULL,'2009ApJS..182..474S',2009,1,0.52,NULL,'G',0.000023,NULL,'15.23',0.12,'Sbc:',NULL,NULL,NULL,NULL,1,338.681875,1.35914,0.189,NULL,52412297655,818942150,12795971,15.23),(156729,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156729,37.25,0.49,281,73990,75,NULL,'IR','2MFGC 16998',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156730,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156730,37.32,0.44,291,73990,NULL,NULL,NULL,'2MFGC 16998',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156731,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156731,37.36,0.2,296,73990,74.4,NULL,NULL,'2MFGC 16998',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156732,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156732,37.91,0.16,382,73991,70,NULL,NULL,'2MASX J22344385-0106030',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.68275,-1.10078,0.149,NULL,49459544258,772805379,12075084,17.7),(156733,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156733,37.91,0.16,382,73992,70,NULL,NULL,'2MASX J22344565-0104560',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,338.6902083,-1.08228,0.149,NULL,49459515547,772804930,12075077,16.4),(156734,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156734,36.55,0.54,205,73993,70,NULL,NULL,'2MASX J22344787-6525480',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000103,NULL,'16.74',0.29,NULL,NULL,NULL,NULL,NULL,1,338.699417,-65.42997,0.005,NULL,49284547207,770071050,12032360,16.74),(156735,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156735,38.26,0.46,449,73994,70,NULL,NULL,'SDSS J223449.22+131329.8',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.705083,13.22497,0.153,NULL,52595239638,821800619,12840634,18.3),(156736,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156736,35.19,0.8,109,73995,75,NULL,'CF, r','UGC 12093',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000017,NULL,'14.91',0.7,'Scd:',NULL,NULL,NULL,NULL,1,338.70575,18.6385,0.153,NULL,52398379890,818724685,12792573,14.91),(156737,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156737,35.29,0.38,114,73995,75,NULL,'CF, r, raw','UGC 12093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156738,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156738,35.35,0.33,118,73995,NULL,NULL,'Malmquist cor.','UGC 12093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156739,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156739,35.41,0.32,121,73995,NULL,NULL,NULL,'UGC 12093',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156740,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156740,35.44,0.2,122,73995,74.4,NULL,NULL,'UGC 12093',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156741,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156741,35.46,0.38,124,73995,75,NULL,'CF, r, inv','UGC 12093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156742,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156742,35.56,0.38,130,73995,75,NULL,'CF, r, cor','UGC 12093',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156743,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 09147','RN',156743,41.21,0.18,1560,73996,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 09147',0.119462,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156744,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 09147','RN',156744,41.59,0.31,1860,73996,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 09147',0.119462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156745,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156745,36.86,0.27,236,73997,70,NULL,NULL,'2MASX J22345143+0110269',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.714333333,1.17403,0.189,NULL,51674414093,807412720,12615823,17.8),(156746,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156746,37.22,0.46,279,73998,70,NULL,NULL,'2MASX J22345269+1316387',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000176,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,338.719583,13.27756,0.153,NULL,52595237857,821800591,12840634,16.7),(156747,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156747,34.28,0.56,71.9,73999,70,NULL,NULL,'FAIRALL 0194',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.000103,NULL,'15.62',0.52,'S0',NULL,NULL,NULL,NULL,1,338.737625,-61.88364,0,NULL,48790070694,762344854,11911638,15.62),(156748,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156748,37.91,0.16,382,74000,70,NULL,NULL,'2MASX J22345934-0108028',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000175,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,338.747375,-1.13397,0.149,NULL,49459516767,772804949,12075077,17.4),(156749,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 1978E','R',156749,34.48,NULL,78.7,74001,NULL,NULL,'Photographic','CGCG 514-058',NULL,'1988SSRv...48....1R',1988,1,0.6,NULL,'G',0.000033,NULL,'15.3',0.6,'Sc',NULL,NULL,NULL,NULL,1,338.74925,37.1995,0.569,NULL,55525788347,867590442,13556100,15.3),(156750,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156750,37.35,0.33,295,74002,70,NULL,NULL,'2MASX J22350076+1327577',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000194,NULL,'15.9g',0.49,'E0',NULL,NULL,NULL,NULL,1,338.753125,13.46608,0.153,NULL,52595038755,821797480,12840585,15.9),(156751,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 14363','RN',156751,41.52,0.14,1450,74003,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14363',0.39307,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156752,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 14363','RN',156752,41.91,0.21,1730,74003,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14363',0.39307,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156753,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156753,35.11,0.58,105,74004,70,NULL,NULL,'LCRS B223211.4-383050',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.89',0.35,'E',NULL,NULL,NULL,NULL,1,338.769125,-38.255,0,NULL,50709067651,792329182,12380143,15.89),(156754,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156754,36.73,0.46,222,74005,70,NULL,NULL,'2MASX J22350637+0052020',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,338.776625,0.86722,0.221,NULL,51674539478,807414679,12615854,17.1),(156755,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15866','R',156755,39.78,0.2,759,74006,70,NULL,'SDSS CAND. zSNIa; SALT 2','2MASX J22350737+0058050',0.189,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.01,NULL,'19.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,338.780833,0.96808,0.213,NULL,51674511699,807414245,12615847,19.4),(156756,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15866','R',156756,39.93,0.13,815,74006,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','2MASX J22350737+0058050',0.189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156757,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15866',NULL,156757,39.64,0.1,847,74006,70,NULL,'SALT 2','2MASX J22350737+0058050',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156758,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15866',NULL,156758,39.65,0.1,851,74006,70,NULL,'SALT 2, Malmquist cor.','2MASX J22350737+0058050',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156759,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156759,37.35,0.33,295,74007,70,NULL,NULL,'2MASX J22350995+1328147',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000156,NULL,'17.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,338.791583333,13.47072,0.153,NULL,52595047276,821797613,12840587,17.8),(156760,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156760,36.37,0.47,188,74008,NULL,NULL,'Malmquist cor.','2MASX J22351010+0120460',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000023,NULL,'13.81',0.43,'Sbc:',NULL,NULL,NULL,NULL,1,338.7922917,1.34617,0.189,NULL,51674364936,807411952,12615811,13.81),(156761,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156761,36.57,0.43,206,74008,NULL,NULL,NULL,'2MASX J22351010+0120460',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156762,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156762,36.61,0.2,210,74008,74.4,NULL,NULL,'2MASX J22351010+0120460',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156763,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156763,36.67,0.46,216,74009,NULL,NULL,'Malmquist cor.','2MFGC 17007',NULL,'2009ApJS..182..474S',2009,1,0.62,NULL,'G',0.000027,NULL,'15.55',0.1,'Sc',NULL,NULL,NULL,NULL,1,338.7945417,0.84625,0.221,NULL,51674540847,807414700,12615854,15.55),(156764,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156764,36.84,0.49,234,74009,75,NULL,'IR','2MFGC 17007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156765,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156765,36.87,0.42,236,74009,NULL,NULL,NULL,'2MFGC 17007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156766,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156766,36.91,0.2,241,74009,74.4,NULL,NULL,'2MFGC 17007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156767,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156767,37.91,0.16,382,74010,70,NULL,NULL,'SDSS J223511.53-010535.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.798083,-1.09322,0.149,NULL,49459513005,772804890,12075076,18.2),(156768,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156768,37.91,0.16,382,74011,70,NULL,NULL,'2MASX J22351195-0108498',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000202,NULL,'16.4g',0.37,'BrClG',NULL,NULL,NULL,NULL,1,338.799833,-1.14719,0.149,NULL,49459527501,772805117,12075079,16.4),(156769,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156769,38.66,0.46,540,74012,70,NULL,NULL,'SDSS J223515.21-003519.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000138,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,338.813417,-0.58875,0.177,NULL,49459903814,772810997,12075171,18.2),(156770,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156770,37.41,0.46,304,74013,70,NULL,NULL,'2MASX J22351582-0953350',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000182,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,338.815875,-9.89297,0.201,NULL,50361783833,786902872,12295357,17.1),(156771,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 21166',NULL,156771,41.23,0.31,1760,74014,70,NULL,'SN photometric redshift distance, z photo =0.548 +/- 0.126','SDSS-II SN 21166',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.820041667,0.14178,0.209,NULL,51674147884,807408560,12615758,NULL),(156772,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156772,37.91,0.16,382,74015,70,NULL,NULL,'SDSS J223517.11-011054.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,338.8212917,-1.18167,0.149,NULL,49459520962,772805015,12075078,18.3),(156773,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156773,38.33,0.46,464,74016,70,NULL,NULL,'2MASX J22351807+1222058',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000149,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,338.825375,12.36833,0.153,NULL,52594694820,821792106,12840501,18.1),(156774,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19576','RN',156774,41.24,0.27,1460,74017,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19576',0.206981,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156775,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19576','RN',156775,42.05,0.33,2130,74017,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19576',0.206981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156776,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156776,36.87,0.46,236,74018,70,NULL,NULL,'2MASX J22351954+1332448',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000134,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,338.831333,13.54572,0.153,NULL,52595553596,821805524,12840711,17.8),(156777,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SCP 06Z05',NULL,156777,42.59,0.14,2030,74019,70,NULL,'SALT2, M(B) -19.307 mag, Alpha 0.124, Beta 1.460, Delta 0.023','1WGA J2235.3-2557',0.623,'2012ApJ...746...85S',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,338.835833,-25.96167,0.021,NULL,50074319934,782411248,12225175,NULL),(156778,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156778,36.86,0.27,236,74020,70,NULL,NULL,'2MASX J22352191+0112193',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000199,NULL,'16.0g',0.38,'E0',NULL,NULL,NULL,NULL,1,338.841333,1.2055,0.189,NULL,51674388777,807412324,12615817,16),(156779,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156779,36.86,0.27,236,74021,70,NULL,NULL,'SDSS J223524.19+011126.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000159,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,338.8507917,1.19078,0.189,NULL,51677258922,807457170,12616518,18.2),(156780,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156780,34.93,0.51,96.8,74022,70,NULL,NULL,'ESO 076- G 019',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000087,NULL,'14.03',1,'SAB(r)bc',NULL,NULL,NULL,NULL,1,338.861917,-70.28189,0.073,NULL,49315660495,770557195,12039956,14.03),(156781,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156781,35,0.55,100,74023,NULL,NULL,NULL,'ESO 405- G 031',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.72',0.6,'Sb',NULL,NULL,NULL,NULL,1,338.868916667,-35.12183,0,NULL,50579385968,790302905,12348482,14.72),(156782,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156782,35.01,0.54,101,74023,NULL,NULL,'Malmquist cor.','ESO 405- G 031',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156783,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156783,35.04,0.2,102,74023,74.4,NULL,NULL,'ESO 405- G 031',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156784,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19038','RN',156784,39.87,0.23,791,74024,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 19038',0.191682,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156785,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19038','RN',156785,40.92,0.23,1280,74024,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 19038',0.191682,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156786,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20420','R',156786,38.28,0.24,393,74025,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2007qw','SDSS J223529.00+002856.1',0.150654,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,NULL,'20.1g',0.06,NULL,NULL,NULL,NULL,NULL,1,338.870875,0.48225,0.201,NULL,51674192353,807409255,12615769,20.1),(156787,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20420','R',156787,38.48,0.11,431,74025,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2007qw','SDSS J223529.00+002856.1',0.150654,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156788,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156788,35,0.49,100,74026,75,NULL,'IR','FGC 2395',NULL,'2011yCatp016004901K',2011,1,0.66,NULL,'G',0.000033,NULL,'16.5',0.09,'Scd',NULL,NULL,NULL,NULL,1,338.8712917,19.30056,0.197,NULL,52409173242,818893331,12795208,16.5),(156789,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156789,35.22,NULL,111,74026,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156790,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156790,35.24,NULL,112,74026,NULL,NULL,'Dipole + Quadrupole','FGC 2395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156791,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156791,35.26,NULL,113,74026,NULL,NULL,'Dipole','FGC 2395',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156792,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156792,35.37,NULL,119,74026,NULL,NULL,NULL,'FGC 2395',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156793,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156793,37.68,0.46,344,74027,70,NULL,NULL,'2MASX J22352980+1225018',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000178,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,338.874333,12.41711,0.153,NULL,52594722882,821792545,12840508,16.9),(156794,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156794,37.91,0.16,382,74028,70,NULL,NULL,'2MASX J22353246-0111047',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000156,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,338.885208333,-1.18475,0.149,NULL,49462950578,772858602,12075915,17.8),(156795,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156795,36.17,0.47,172,74029,NULL,NULL,'Malmquist cor.','2MASX J22353392+0151353',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.000023,NULL,'15.23',0.18,'SBbc',NULL,NULL,NULL,NULL,1,338.891375,1.85972,0.197,NULL,52413823305,818965989,12796343,15.23),(156796,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156796,36.23,0.46,176,74029,NULL,NULL,NULL,'2MASX J22353392+0151353',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156797,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156797,36.27,0.2,179,74029,74.4,NULL,NULL,'2MASX J22353392+0151353',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156798,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723',NULL,156798,39.84,0.37,927,74030,70,NULL,'SN photometric redshift distance, z photo =0.246 +/- 0.055','SDSS-II SN 19723',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.891667,0.41764,0.217,NULL,51677645291,807463207,12616612,NULL),(156799,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723','R',156799,40.56,0.2,1030,74030,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19723',0.255413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156800,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723','R',156800,40.7,0.12,1100,74030,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19723',0.255413,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156801,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723',NULL,156801,40.43,0.1,1220,74030,70,NULL,'SALT 2','SDSS-II SN 19723',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156802,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 19723',NULL,156802,40.45,0.1,1230,74030,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19723',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156803,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156803,37.91,0.16,382,74031,70,NULL,NULL,'2MASX J22353613-0107187',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,338.900667,-1.12172,0.149,NULL,49463119594,772861243,12075956,18.2),(156804,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156804,38.21,0.46,439,74032,70,NULL,NULL,'SDSS J223538.09-094102.9',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,338.90875,-9.68414,0.197,NULL,50361868474,786904194,12295378,18.3),(156805,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156805,38.31,0.46,460,74033,70,NULL,NULL,'2MASX J22353922+1244508',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,338.913417,12.74742,0.149,NULL,52595353484,821802398,12840662,17.9),(156806,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156806,37.66,0.46,341,74034,70,NULL,NULL,'SDSS J223539.99+134602.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,338.916667,13.76747,0.169,NULL,52595742703,821808479,12840757,18.6),(156807,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156807,34.76,NULL,89.5,74035,NULL,NULL,'B','IC 5230',NULL,'2005Ap&SS.298..577R',2005,1,1.03,NULL,'G',0.000033,NULL,'14.89',0.42,'S...',NULL,NULL,NULL,NULL,1,338.917375,-61.54769,0,NULL,48790121534,762345648,11911650,14.89),(156808,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156808,34.76,NULL,89.5,74035,NULL,NULL,'I','IC 5230',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156809,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156809,35.7,0.42,138,74035,NULL,NULL,'Malmquist cor.','IC 5230',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156810,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156810,35.76,0.41,142,74035,NULL,NULL,NULL,'IC 5230',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156811,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156811,35.8,0.2,145,74035,74.4,NULL,NULL,'IC 5230',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156812,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156812,35.5,NULL,126,74036,NULL,NULL,NULL,'FGC 2396',NULL,'2000BSAO...50....5K',2000,1,0.71,'HI data crossed with FGC 2395 (R.Giovanelli, 1997, priv.comm).','G',0.000023,NULL,'16.8',0.1,'Sdm',NULL,NULL,NULL,NULL,1,338.92,3.27389,0.201,NULL,52427260576,819175946,12799624,16.8),(156813,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156813,35.51,NULL,127,74036,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2396',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156814,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156814,35.52,NULL,127,74036,NULL,NULL,'Dipole + Quadrupole','FGC 2396',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156815,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156815,35.54,NULL,128,74036,NULL,NULL,'Dipole','FGC 2396',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156816,'BCG','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156816,37.24,0.35,265,74037,60,NULL,'ABELL 2457, BCG','2MASX J22354078+0129053',0.0597,'1980ApJ...241..486H',1980,1,0.71,NULL,'G',0.00011,NULL,'17.9',0.5,'cD;BrClG','Brightest group member',NULL,NULL,NULL,1,338.920083,1.48497,0.189,NULL,51676199437,807440616,12616259,17.9),(156817,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156817,37.01,0.11,253,74037,70,NULL,'ABELL 2457, BGC','2MASX J22354078+0129053',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156818,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156818,36.96,0.39,246,74038,NULL,NULL,'Malmquist cor.','2MASX J22354193+0139333',NULL,'2009ApJS..182..474S',2009,1,0.43,NULL,'G',0.000023,NULL,'16.58',0.22,'Sa             Sy1',NULL,NULL,NULL,'Sy 1',1,338.924625,1.65928,0.193,NULL,52413657512,818963398,12796303,16.58),(156819,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156819,37.17,0.35,271,74038,NULL,NULL,NULL,'2MASX J22354193+0139333',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156820,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156820,37.21,0.2,277,74038,74.4,NULL,NULL,'2MASX J22354193+0139333',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156821,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737',NULL,156821,39.87,0.64,943,74039,70,NULL,'SN photometric redshift distance, z photo =0.251 +/- 0.106','SDSS-II SN 13737',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,338.926167,0.96261,0.241,NULL,51677354901,807458670,12616541,NULL),(156822,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737','R',156822,41.77,0.26,1620,74039,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13737',0.394955,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156823,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737','R',156823,41.95,0.23,1760,74039,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13737',0.394955,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156824,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737',NULL,156824,41.72,0.17,2210,74039,70,NULL,'SALT 2','SDSS-II SN 13737',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156825,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13737',NULL,156825,41.79,0.17,2280,74039,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13737',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156826,'BCG','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156826,37.24,0.35,265,74040,60,NULL,NULL,'ABELL 2457',0.0597,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I-II:  [BM]',NULL,NULL,NULL,NULL,1,338.938333,1.47592,0.189,NULL,51676199714,807440620,12616259,NULL),(156827,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156827,37.01,0.11,253,74040,70,NULL,NULL,'ABELL 2457',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156828,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156828,31.29,0.8,18.1,74041,75,NULL,'MAT, I','NGC 7314',NULL,'1997ApJS..109..333W',1997,1,4.6,'Confused HIPASS source','G',0.00001,NULL,'11.88',2.1,'SAB(rs)bc      Sy1.9','in a pair',NULL,NULL,'Sy 1 h',1,338.942458333,-26.05047,0.021,NULL,50074596082,782415563,12225243,11.88),(156829,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156829,31.3,0.8,18.2,74041,75,NULL,'A82, H','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156830,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156830,30.55,0.4,12.9,74041,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7314',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156831,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156831,30.93,0.43,15.3,74041,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7314',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156832,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156832,31,0.38,15.8,74041,NULL,NULL,NULL,'NGC 7314',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156833,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156833,31.01,0.43,15.9,74041,75,NULL,'3.6 micron, color corrected','NGC 7314',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156834,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156834,31.17,0.4,17.1,74041,NULL,NULL,'mean','NGC 7314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156835,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156835,31.18,0.32,17.2,74041,85,NULL,'I, raw','NGC 7314',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156836,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156836,31.2,0.2,17.4,74041,74.4,NULL,NULL,'NGC 7314',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156837,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156837,31.22,0.32,17.5,74041,85,NULL,'I, inv','NGC 7314',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156838,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156838,31.23,0.47,17.6,74041,75,NULL,'A82, H, raw','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156839,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156839,31.3,0.47,18.2,74041,75,NULL,'A82, H, inv','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156840,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156840,31.31,0.43,18.3,74041,75,NULL,'MAT, I, raw','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156841,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156841,31.31,0.4,18.3,74041,75,NULL,'B','NGC 7314',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156842,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156842,31.34,0.46,18.6,74041,NULL,NULL,'J','NGC 7314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156843,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156843,31.45,0.45,19.5,74041,NULL,NULL,'K','NGC 7314',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156844,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156844,31.49,0.43,19.9,74041,75,NULL,'MAT, I, inv','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156845,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156845,31.51,0.39,20,74041,NULL,NULL,NULL,'NGC 7314',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156846,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156846,31.56,0.4,20.5,74041,73,NULL,'opt','NGC 7314',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156847,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156847,31.61,0.47,21,74041,75,NULL,'A82, H, cor','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156848,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156848,31.62,0.43,21.1,74041,75,NULL,'MAT, I, cor','NGC 7314',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156849,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156849,31.65,0.37,21.4,74041,NULL,NULL,'Malmquist cor.','NGC 7314',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156850,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156850,35.35,0.47,117,74042,70,NULL,NULL,'2MASX J22354768-7436516',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.000093,NULL,'15.1b',0.45,NULL,NULL,NULL,NULL,NULL,1,338.948833,-74.61431,0.165,NULL,48449475730,757023058,11828485,15.1),(156851,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01138','RN',156851,42.09,0.22,1960,74043,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01138',0.335599,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156852,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01138','RN',156852,42.28,0.18,2140,74043,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01138',0.335599,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156853,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156853,34.06,NULL,65,74044,NULL,NULL,'Stephan\'s Quintet','NGC 7317',NULL,'1998A&A...334..473M',1998,1,1.1,NULL,'G',0.000087,NULL,'14.57',1.1,'E4','in an interacting quintet',NULL,NULL,NULL,1,338.966167,33.94489,0.329,NULL,55462101677,866595338,13540552,14.57),(156854,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156854,34.54,0.44,80.9,74044,95,NULL,'Weighted Mean','NGC 7317',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156855,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156855,35.15,0.46,107,74044,95,NULL,'Michard 1979a','NGC 7317',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156856,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156856,35.16,0.63,108,74044,95,NULL,'Michard 1979b, c','NGC 7317',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156857,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156857,37.26,0.46,283,74045,70,NULL,NULL,'2MASX J22355305-0026008',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,338.971125,-0.43364,0.165,NULL,49462871140,772857361,12075896,16.3),(156858,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15673','RN',156858,43.87,0.35,3650,74046,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15673',0.625973,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156859,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007lo',NULL,156859,38.76,0.06,565,74047,70,NULL,'Hubble residual 0.05 for z0.13840','SDSS J223556.08+003632.7',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'21.4g',0.03,NULL,NULL,NULL,NULL,NULL,1,338.9837083,0.60911,0.201,NULL,51677688579,807463884,12616623,21.4),(156860,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18602','R',156860,39.19,0.63,604,74047,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lo','SDSS J223556.08+003632.7',0.1384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156861,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007lo',NULL,156861,39.09,0.07,658,74047,70,NULL,'SALT 2','SDSS J223556.08+003632.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156862,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007lo',NULL,156862,39.09,0.07,658,74047,70,NULL,'SALT 2, Malmquist cor.','SDSS J223556.08+003632.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156863,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 18602','R',156863,39.39,0.09,663,74047,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lo','SDSS J223556.08+003632.7',0.1384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156864,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156864,33.99,0.47,62.9,74048,NULL,NULL,'H','NGC 7316',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000017,NULL,'13.62',0.9,'SBc            Sbrst','Isolated galaxy',NULL,NULL,'Starburst',1,338.98475,20.32225,0.157,NULL,52411895162,818935861,12795872,13.62),(156865,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156865,34.1,0.45,66.2,74048,NULL,NULL,'K','NGC 7316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156866,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156866,34.12,0.46,66.7,74048,NULL,NULL,'J','NGC 7316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156867,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156867,34.32,0.4,73.2,74048,NULL,NULL,'mean','NGC 7316',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156868,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156868,33.95,0.44,61.7,74049,95,NULL,'Weighted Mean','NGC 7318A',NULL,'1984ApJS...56...91D',1984,1,0.9,'Misidentified in UGC as \'MCG +06-49-040\'.','G',0.000077,NULL,'14.33',0.9,'E2 pec','in an interacting quintet',NULL,NULL,NULL,1,338.9864583,33.96547,0.329,NULL,55462105058,866595391,13540552,14.33),(156869,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156869,34.06,NULL,65,74049,NULL,NULL,'Stephan\'s Quintet','NGC 7318A',NULL,'1998A&A...334..473M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156870,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156870,34.45,0.63,77.6,74049,95,NULL,'Michard 1979b, c','NGC 7318A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156871,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156871,34.53,0.46,80.5,74049,95,NULL,'Michard 1979a','NGC 7318A',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156872,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03605','RN',156872,42.51,0.22,2150,74050,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03605',0.482963,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156873,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156873,35.99,0.46,158,74051,70,NULL,NULL,'2MASX J22355798-0843394',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,338.991583333,-8.72761,0.149,NULL,50358939625,786858431,12294662,16.5),(156874,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156874,33.89,NULL,60,74052,NULL,NULL,'Stephan\'s Quintet','NGC 7318B',NULL,'1998A&A...334..473M',1998,1,1.9,'MCG misprints name as \'NGC 7318a\'.','G',0.00008,NULL,'13.92',1.2,'SB(s)bc pec','in an interacting quintet',NULL,NULL,NULL,1,338.993375,33.96589,0.329,NULL,55462104665,866595385,13540552,13.92),(156875,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156875,36.67,0.33,216,74053,70,NULL,NULL,'2MASX J22360010-0950414',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.3g',0.41,'E0',NULL,NULL,NULL,NULL,1,339.000417,-9.84478,0.201,NULL,50361654449,786900850,12295325,16.3),(156876,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16727','R',156876,40.51,0.3,1000,74054,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16727',0.260743,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','20.4g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.0047083,0.13203,0.161,NULL,51677502090,807460970,12616577,20.4),(156877,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16727','R',156877,40.51,0.37,1000,74054,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16727',0.260743,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156878,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16727',NULL,156878,40.23,0.32,1110,74054,70,NULL,'SN photometric redshift distance, z photo =0.304 +/- 0.060','SDSS-II SN 16727',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156879,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156879,30.68,0.8,13.7,74055,75,NULL,'A82, H','NGC 7320',NULL,'1997ApJS..109..333W',1997,1,2.2,'Position in 1990Obs...110...93A is for a superposed star.','G',0.000067,NULL,'13.23',1.1,'SA(s)d         HII','Line-of-sight galaxy, in a quintet',NULL,NULL,NULL,1,339.014083333,33.94811,0.329,NULL,55462102533,866595352,13540552,13.23),(156880,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156880,29.87,0.69,9.4,74055,100,NULL,'mid-IR','NGC 7320',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156881,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156881,30.4,NULL,12,74055,NULL,NULL,'Stephan\'s Quintet','NGC 7320',NULL,'1998A&A...334..473M',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156882,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156882,30.7,0.4,13.8,74055,75,NULL,'B','NGC 7320',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156883,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156883,30.7,0.4,13.8,74055,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7320',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156884,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156884,31.07,0.47,16.4,74055,75,NULL,'A82, H, inv','NGC 7320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156885,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156885,31.18,0.47,17.2,74055,75,NULL,'A82, H, raw','NGC 7320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156886,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156886,31.4,0.47,19.1,74055,75,NULL,'A82, H, cor','NGC 7320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156887,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156887,34.14,0.47,67.4,74056,NULL,NULL,'H','NGC 7319',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000012,NULL,'14.11',1.3,'SB(s)bc pec    Sy2','in an interacting quintet',NULL,NULL,'Sy 2',1,339.0147917,33.97572,0.329,NULL,55462102807,866595356,13540552,14.11),(156888,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156888,34.32,0.45,73.2,74056,NULL,NULL,'K','NGC 7319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156889,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156889,34.39,0.46,75.4,74056,NULL,NULL,'J','NGC 7319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156890,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156890,34.84,0.4,93,74056,NULL,NULL,'mean','NGC 7319',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156891,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005jb',NULL,156891,39.9,0.16,759,74057,74.2,NULL,'SALT 2','SDSS J223602.72-002204.8',0.258,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.0155,-0.368,0.165,NULL,49462879958,772857499,12075898,NULL),(156892,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07426','R',156892,41.54,0.15,1480,74057,70,NULL,'SDSS CAND. zSNII; MLCS2K2; SN 2005jb','SDSS J223602.72-002204.8',0.38,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156893,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07426','R',156893,42.14,0.23,1940,74057,70,NULL,'SDSS CAND. zSNII; SALT 2; SN 2005jb','SDSS J223602.72-002204.8',0.38,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156894,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156894,40.57,0.16,1030,74058,65,NULL,'SALT2','SDSS J223604.04-002229.6',0.26,'2009ApJS..185...32K',2009,1,0.21,NULL,'G',NULL,NULL,'18.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,339.016833,-0.37492,0.165,NULL,49462879898,772857498,12075898,18.7),(156895,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156895,40.6,0.17,1050,74058,70,NULL,'SDSS-II SN 01112, SALT 2','SDSS J223604.04-002229.6',0.26,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156896,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01112','R',156896,40.67,0.25,1080,74058,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fg','SDSS J223604.04-002229.6',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156897,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01112','R',156897,40.71,0.2,1100,74058,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fg','SDSS J223604.04-002229.6',0.26,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156898,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156898,40.85,0.18,1170,74058,65,NULL,'MLCS2k2','SDSS J223604.04-002229.6',0.26,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156899,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156899,40.96,0.06,1230,74058,70,NULL,'SDSS-II SN 01112','SDSS J223604.04-002229.6',0.26,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156900,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156900,40.49,0.14,1250,74058,70,NULL,'SALT 2','SDSS J223604.04-002229.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156901,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2005fg',NULL,156901,40.52,0.14,1270,74058,70,NULL,'SALT 2, Malmquist cor.','SDSS J223604.04-002229.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156902,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03181','RN',156902,40.77,0.15,1200,74059,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03181',0.191322,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156903,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03181','RN',156903,41.23,0.36,1480,74059,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03181',0.191322,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156904,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156904,36.41,0.44,192,74060,NULL,NULL,'Malmquist cor.','2MASX J22360683+0133324',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000023,NULL,'16.20',0.15,'S0',NULL,NULL,NULL,NULL,1,339.0284583,1.55914,0.193,NULL,51676239236,807441238,12616269,16.2),(156905,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156905,36.52,0.42,202,74060,NULL,NULL,NULL,'2MASX J22360683+0133324',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156906,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156906,36.56,0.2,205,74060,74.4,NULL,NULL,'2MASX J22360683+0133324',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156907,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156907,37.82,0.46,366,74061,70,NULL,NULL,'2MASX J22360726-0804384',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,339.030375,-8.07736,0.153,NULL,50392378252,787380910,12302826,17.3),(156908,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156908,37.02,0.46,253,74062,70,NULL,NULL,'2MASX J22361138+1328200',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000162,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,339.047333333,13.47222,0.153,NULL,52595158716,821799354,12840614,16.7),(156909,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 14805','RN',156909,40.27,0.56,1050,74063,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14805',0.081802,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156910,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 14805','RN',156910,40.42,0.17,1120,74063,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14805',0.081802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156911,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156911,36.92,0.46,242,74064,70,NULL,NULL,'2MASX J22361710+0112380',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000063,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,339.071417,1.21056,0.189,NULL,51677494485,807460851,12616575,16.1),(156912,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS J223618.96+002846.7:SN',NULL,156912,40.42,0.18,980,74065,74.2,NULL,'SALT 2','SDSS J223618.96+002846.7',0.238,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'22.1g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.079041667,0.47967,0.201,NULL,51677751195,807464862,12616638,22.1),(156913,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06696','R',156913,40.73,0.16,1130,74065,70,NULL,'SDSS CAND. SNIa?; MLCS2K2','SDSS J223618.96+002846.7',0.238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156914,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 06696','R',156914,41.42,0.29,1560,74065,70,NULL,'SDSS CAND. SNIa?; SALT 2','SDSS J223618.96+002846.7',0.238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156915,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156915,36.48,0.33,198,74066,70,NULL,NULL,'2MASX J22361989+1418523',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000172,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,339.0827917,14.31453,0.133,NULL,52594228854,821784825,12840387,17),(156916,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156916,35.07,0.43,103,74067,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2233+137',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.000121,NULL,'16.1g',0.19,'Spiral',NULL,NULL,NULL,NULL,1,339.10775,14.02397,0.169,NULL,52595716620,821808072,12840751,16.1),(156917,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156917,35.15,0.49,107,74067,75,NULL,'IR','KUG 2233+137',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156918,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156918,35.17,0.43,108,74067,75,NULL,'3.6 micron, color corrected','KUG 2233+137',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156919,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156919,35.3,0.2,115,74067,74.4,NULL,NULL,'KUG 2233+137',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156920,'Quasar spectrum','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156920,42.9,NULL,3800,74068,NULL,NULL,NULL,'[HB89] 2233+136',NULL,'2002A&A...381L..57D',2002,1,NULL,NULL,'QSO',0.000454,NULL,'18.8g',NULL,'AGN',NULL,NULL,NULL,'QSO',1,339.112833,13.95389,0.169,NULL,52595697861,821807779,12840746,18.8),(156921,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156921,34.25,0.69,70.7,74069,100,NULL,'mid-IR','NGC 7321',NULL,'2013ApJ...771...88L',2013,1,1.6,'HOLM 793B is a star.','G',0.000017,NULL,'13.71',1.1,'SB(r)b','Group member',NULL,NULL,NULL,1,339.11675,21.62181,0.145,NULL,52402847509,818794492,12793663,13.71),(156922,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156922,34.73,0.47,88.3,74069,NULL,NULL,'H','NGC 7321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156923,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156923,34.75,0.45,89.2,74069,NULL,NULL,'K','NGC 7321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156924,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156924,34.77,0.46,89.8,74069,NULL,NULL,'J','NGC 7321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156925,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156925,34.81,0.3,91.5,74069,NULL,NULL,NULL,'NGC 7321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156926,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156926,34.95,0.4,97.5,74069,NULL,NULL,'mean','NGC 7321',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156927,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156927,35.08,0.26,104,74069,NULL,NULL,'Malmquist cor.','NGC 7321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156928,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156928,35.1,0.2,105,74069,74.4,NULL,NULL,'NGC 7321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156929,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15202','RN',156929,40.14,0.26,944,74070,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15202',0.132482,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156930,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15202','RN',156930,41.07,0.26,1440,74070,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15202',0.132482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156931,'BL Lac Luminosity','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156931,41.49,NULL,1980,74071,70,NULL,'nucleus-to-host flux ratio, z > 0.65','PKS 2233-148',NULL,'2006AJ....132....1S',2006,1,NULL,'Drinkwater, et al. (1997MNRAS.284...85D) give z > 0.609.','QSO',NULL,NULL,'19.5',NULL,'FSRQ           BLLAC',NULL,NULL,NULL,'BL Lac',1,339.1420417,-14.55617,0.133,NULL,50430571736,787977683,12312151,19.5),(156932,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156932,37.86,0.16,373,74072,70,NULL,NULL,'2MASX J22363473+1314043',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.00016,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,339.144833,13.23439,0.133,NULL,52595320435,821801881,12840654,17.7),(156933,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156933,31.8,0.4,22.9,74073,75,NULL,'B','ARP 003',NULL,'1988NBGC.C....0000T',1988,1,2.5,NULL,'G',0.000005,NULL,'14.82',2,'SA(s)m',NULL,NULL,NULL,NULL,1,339.1460417,-2.90678,0.145,NULL,50334372669,786474572,12288665,14.82),(156934,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156934,35.46,NULL,124,74074,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12104',NULL,'2010Ap&SS.325..163P',2010,1,1.68,NULL,'G',0.000008,NULL,'16.0',0.2,'Scd',NULL,NULL,NULL,NULL,1,339.1487917,2.39669,0.161,NULL,52414106801,818970418,12796412,16),(156935,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156935,35.47,NULL,124,74074,NULL,NULL,'Dipole + Quadrupole','UGC 12104',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156936,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156936,35.48,NULL,125,74074,NULL,NULL,'Dipole','UGC 12104',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156937,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156937,35.51,NULL,126,74074,NULL,NULL,NULL,'UGC 12104',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156938,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156938,35.72,0.49,140,74074,75,NULL,'IR','UGC 12104',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156939,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156939,35.01,0.8,100,74075,75,NULL,'MAT, I','ESO 534- G 003',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.25',0.4,'IB pec sp',NULL,NULL,NULL,NULL,1,339.1527083,-26.25936,0.021,NULL,50074568724,782415136,12225236,15.25),(156940,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156940,34.11,0.43,66.5,74075,75,NULL,'MAT, I, raw','ESO 534- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156941,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156941,34.12,0.32,66.7,74075,85,NULL,'I, raw','ESO 534- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156942,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156942,34.15,0.32,67.7,74075,85,NULL,'I, inv','ESO 534- G 003',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156943,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156943,34.28,0.43,71.8,74075,75,NULL,'MAT, I, inv','ESO 534- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156944,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156944,34.38,0.43,75.3,74075,75,NULL,'MAT, I, cor','ESO 534- G 003',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156945,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156945,35.21,0.48,110,74075,NULL,NULL,'Malmquist cor.','ESO 534- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156946,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156946,35.26,0.47,113,74075,NULL,NULL,NULL,'ESO 534- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156947,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156947,35.3,0.2,115,74075,74.4,NULL,NULL,'ESO 534- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156948,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156948,37.86,0.16,373,74076,70,NULL,NULL,'2MASX J22364034+1317332',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000152,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,339.168083,13.29256,0.133,NULL,52595319318,821801864,12840654,17.9),(156949,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260',NULL,156949,39.57,0.27,820,74077,70,NULL,'SN photometric redshift distance, z photo =0.214 +/- 0.033','SDSS-II SN 15260',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.1772917,-0.27578,0.165,NULL,49461610676,772837666,12075588,NULL),(156950,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260','R',156950,40.24,0.13,892,74077,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15260',0.253699,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156951,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260','R',156951,40.39,0.21,954,74077,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15260',0.253699,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156952,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260',NULL,156952,40.42,0.12,1210,74077,70,NULL,'SALT 2','SDSS-II SN 15260',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156953,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15260',NULL,156953,40.44,0.12,1220,74077,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15260',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156954,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20402','RN',156954,39.58,0.47,757,74078,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20402',0.087868,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156955,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20402','RN',156955,40.77,0.27,1310,74078,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20402',0.087868,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156956,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 05142',NULL,156956,40.28,0.12,1140,74079,70,NULL,'SN photometric redshift distance, z photo =0.312 +/- 0.022','SDSS-II SN 05142',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.197125,-1.00089,0.145,NULL,49463182542,772862227,12075972,NULL),(156957,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13440','RN',156957,41.1,0.15,1280,74080,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13440',0.2978,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156958,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156958,37.86,0.16,373,74081,70,NULL,NULL,'2MASX J22364750+1318169',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,339.19775,13.30453,0.133,NULL,52595267276,821801051,12840641,17.6),(156959,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156959,35.26,NULL,113,74082,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2399',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.00001,NULL,'16.5',0.1,'Scd',NULL,NULL,NULL,NULL,1,339.202791667,18.85647,0.149,NULL,52398000807,818718762,12792480,16.5),(156960,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156960,35.29,NULL,114,74082,NULL,NULL,'Dipole + Quadrupole','FGC 2399',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156961,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156961,35.3,NULL,115,74082,NULL,NULL,NULL,'FGC 2399',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156962,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156962,35.32,NULL,116,74082,NULL,NULL,'Dipole','FGC 2399',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156963,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156963,35.33,0.49,116,74082,75,NULL,'IR','FGC 2399',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156964,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156964,35.51,0.2,126,74082,74.4,NULL,NULL,'FGC 2399',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156965,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156965,35.55,0.47,129,74082,NULL,NULL,NULL,'FGC 2399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156966,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156966,35.57,0.47,130,74082,NULL,NULL,'Malmquist cor.','FGC 2399',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156967,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156967,34.64,0.46,84.6,74083,70,NULL,NULL,'CGCG 429-012',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000171,NULL,'15.4g',0.42,'E0',NULL,NULL,NULL,NULL,1,339.2077083,14.38694,0.133,NULL,52594097784,821782777,12840355,15.4),(156968,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156968,35.39,0.55,120,74084,NULL,NULL,'Malmquist cor.','2MFGC 17028',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',0.000027,NULL,'14.90',NULL,'Sc',NULL,NULL,NULL,NULL,1,339.208875,1.6315,0.197,NULL,51676430797,807444231,12616316,14.9),(156969,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156969,35.58,0.51,131,74084,NULL,NULL,NULL,'2MFGC 17028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156970,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156970,35.62,0.2,133,74084,74.4,NULL,NULL,'2MFGC 17028',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156971,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156971,35.89,0.49,151,74084,75,NULL,'IR','2MFGC 17028',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156972,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156972,37.5,0.46,316,74085,70,NULL,NULL,'2MASX J22365277-0939069',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,339.219833,-9.65203,0.197,NULL,50353741039,786777203,12293393,16.8),(156973,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156973,37.86,0.16,373,74086,70,NULL,NULL,'2MASX J22365299+1313149',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000162,NULL,'17.1g',0.29,NULL,NULL,NULL,NULL,NULL,1,339.22075,13.22069,0.133,NULL,52595325707,821801964,12840655,17.1),(156974,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156974,34.34,0.4,73.7,74087,NULL,NULL,'mean','NGC 7323',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000017,NULL,'13.74',1.1,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,339.223708333,19.14386,0.137,NULL,52398491466,818726429,12792600,13.74),(156975,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156975,34.46,0.47,78.1,74087,NULL,NULL,'H','NGC 7323',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156976,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156976,34.5,0.46,79.4,74087,NULL,NULL,'J','NGC 7323',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156977,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156977,34.54,0.45,81,74087,NULL,NULL,'K','NGC 7323',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156978,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156978,35.9,0.2,151,74088,74.4,NULL,NULL,'UGC 12110',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00011,NULL,'15.33',0.2,'S?',NULL,NULL,NULL,NULL,1,339.2295,14.41236,0.133,NULL,52594094876,821782732,12840355,15.33),(156979,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156979,35.33,0.49,116,74089,75,NULL,'IR','UGC 12110',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00011,NULL,'15.33',0.2,'S?',NULL,NULL,NULL,NULL,1,339.2295,14.41236,0.133,NULL,52594094876,821782732,12840355,15.33),(156980,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156980,34.99,0.69,99.7,74090,100,NULL,'mid-IR','ESO 602-G 031',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000017,NULL,'14.88',0.8,'(R\')SAB(rs)b   Sy1.8','Field galaxy',NULL,NULL,'Sy 1.8',1,339.233083333,-22.22078,0.073,NULL,50260297099,785317142,12270580,14.88),(156981,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156981,36.67,0.33,216,74091,70,NULL,NULL,'2MASX J22365669-0946239',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000179,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,339.236125,-9.77342,0.197,NULL,50354601234,786790644,12293603,17),(156982,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156982,37.89,0.21,378,74092,70,NULL,NULL,'2MASX J22365809-0820399',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,339.242167,-8.34436,0.153,NULL,50391539635,787367806,12302621,18.2),(156983,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156983,37.07,0.46,259,74093,70,NULL,NULL,'SDSS J223658.47-093853.8',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,339.243625,-9.64831,0.197,NULL,50353741556,786777211,12293393,17.6),(156984,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156984,37.86,0.16,373,74094,70,NULL,NULL,'2MASX J22370072+1314239',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.000175,NULL,'17.4g',NULL,NULL,NULL,NULL,NULL,NULL,1,339.253,13.23989,0.133,NULL,52595317426,821801834,12840653,17.4),(156985,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01645','RN',156985,41.27,0.48,1370,74095,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01645',0.308411,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156986,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156986,36.48,0.33,198,74096,70,NULL,NULL,'MCG +02-57-006',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.000172,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,339.256583333,14.40486,0.133,NULL,52594089019,821782640,12840353,15.8),(156987,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584','R',156987,41.51,0.26,1440,74097,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16584',0.393346,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','21.5g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.258333,-0.46358,0.161,NULL,49462803393,772856303,12075879,21.5),(156988,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584','R',156988,41.78,0.38,1630,74097,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16584',0.393346,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156989,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584',NULL,156989,41.13,0.23,1680,74097,70,NULL,'SN photometric redshift distance, z photo =0.514 +/- 0.084','SDSS-II SN 16584',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156990,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584',NULL,156990,41.72,0.2,2210,74097,70,NULL,'SALT 2','SDSS-II SN 16584',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156991,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16584',NULL,156991,41.78,0.2,2270,74097,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16584',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156992,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',156992,37.86,0.16,373,74098,70,NULL,NULL,'SDSS J223703.97+131559.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000149,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,339.266583,13.26658,0.133,NULL,52595318630,821801853,12840653,18.4),(156993,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156993,30.89,0.1,15.1,74099,NULL,NULL,'HST KP Calibrated','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,1,NULL,NULL,'GGroup',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.269041667,34.36122,0.329,NULL,55461952378,866593005,13540515,NULL),(156994,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156994,30.89,0.1,15.1,74099,NULL,NULL,'HST KP Calibrated','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156995,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156995,30.67,0.21,13.6,74099,NULL,NULL,'HST KP Calibrated, I','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156996,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156996,30.67,0.16,13.6,74099,NULL,NULL,'HST KP Calibrated, I','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156997,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156997,30.76,0.15,14.2,74099,NULL,NULL,'HST KP Calibrated, F814W','NGC 7320 GROUP',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(156998,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156998,30.71,0.08,13.9,74100,74.4,NULL,NULL,'NGC 7331',NULL,'2013AJ....146...86T',2013,1,10.5,'HOLM 795H is a double star; HOLM 795G,I are stars.','G',0.000004,NULL,'10.35',3.7,'SA(s)b;HII     LINER','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,339.2667083,34.41553,0.329,NULL,55461943645,866592869,13540513,10.35),(156999,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,156999,30.79,0.08,14.4,74100,NULL,NULL,'cte LMC K03','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157000,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157000,30.79,0.12,14.4,74100,NULL,NULL,'LMC W01','NGC 7331',NULL,'2001ApJ...548..564W',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157001,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157001,30.8,0.08,14.5,74100,NULL,NULL,'cte U99','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157002,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157002,30.81,0.09,14.5,74100,NULL,NULL,'13, VI, KEY PROJECT','NGC 7331',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157003,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157003,30.8,0.11,14.5,74100,NULL,NULL,'MW HIPP','NGC 7331',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157004,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157004,30.82,0.08,14.6,74100,NULL,NULL,'cte LMC STS02','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157005,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157005,30.84,0.09,14.7,74100,NULL,NULL,'13, VI, +Z, KEY PROJECT','NGC 7331',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157006,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157006,30.86,0.08,14.9,74100,NULL,NULL,'cte MW FSG03','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157007,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157007,30.86,0.22,14.9,74100,NULL,NULL,'MW P02','NGC 7331',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157008,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157008,30.88,0.09,15,74100,NULL,NULL,'cte MW GFG98','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157009,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157009,30.89,0.1,15.1,74100,NULL,NULL,'HST KP Calibrated','NGC 7331',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157010,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157010,30.89,NULL,15.1,74100,NULL,18.54,NULL,'NGC 7331',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157011,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157011,30.89,0.08,15.1,74100,NULL,NULL,'cte MF91','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157012,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157012,30.89,0.1,15.1,74100,NULL,NULL,'13, VI','NGC 7331',NULL,'1998ApJ...501...32H',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157013,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157013,30.89,0.1,15.1,74100,NULL,18.54,'LMC ZP','NGC 7331',NULL,'2006ApJS..165..108S',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157014,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157014,30.93,0.12,15.3,74100,NULL,NULL,'MW GFG','NGC 7331',NULL,'2002A&A...389...19P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157015,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157015,30.93,0.12,15.3,74100,NULL,NULL,'48, VI','NGC 7331',NULL,'2002A&A...383..398P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157016,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157016,30.95,0.09,15.5,74100,NULL,NULL,'cte MW STS03','NGC 7331',NULL,'2003A&A...411..361K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157017,'Cepheids','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157017,31.8,NULL,22.9,74100,NULL,NULL,'13, VI','NGC 7331',NULL,'2006A&A...452..423P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157018,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157018,30.39,0.1,12,74100,NULL,NULL,'I','NGC 7331',NULL,'1997ApJ...475..399T',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157019,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157019,30.43,0.17,12.2,74100,NULL,NULL,'I','NGC 7331',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157020,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157020,30.59,0.17,13.1,74100,NULL,NULL,'I','NGC 7331',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157021,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157021,30.67,0.21,13.6,74100,NULL,NULL,'HST KP Calibrated, I','NGC 7331',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157022,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157022,30.71,0.08,13.9,74100,74.4,NULL,NULL,'NGC 7331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157023,'Grav. Stability Gas. Disk','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157023,30.91,NULL,15.2,74100,NULL,NULL,NULL,'NGC 7331',NULL,'1996AstL...22...71Z',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157024,'HII region diameter','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157024,29.29,0.05,7.22,74100,NULL,NULL,'Photographic, 349 \'dark cloud\' diameters','NGC 7331',NULL,'1982AN....303..329O',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157025,'HII region diameter','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157025,30.97,0.13,15.6,74100,NULL,NULL,NULL,'NGC 7331',NULL,'2005JKAS...38....7I',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157026,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157026,30.75,0.8,14.1,74100,75,NULL,'A82, H','NGC 7331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157027,'Sosies','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157027,30.86,0.09,14.9,74100,NULL,NULL,NULL,'NGC 7331',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157028,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157028,29.94,0.69,9.72,74100,100,NULL,'mid-IR','NGC 7331',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157029,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157029,30.25,0.47,11.2,74100,75,NULL,'A82, H, raw','NGC 7331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157030,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157030,30.38,0.46,11.9,74100,NULL,NULL,'B','NGC 7331',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157031,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157031,30.5,0.47,12.6,74100,75,NULL,'A82, H, inv','NGC 7331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157032,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157032,30.57,0.47,13,74100,75,NULL,'A82, H, cor','NGC 7331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157033,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157033,30.64,0.2,13.4,74100,NULL,NULL,'I','NGC 7331',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157034,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157034,30.66,0.35,13.6,74100,NULL,NULL,NULL,'NGC 7331',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157035,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157035,30.67,0.4,13.6,74100,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 7331',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157036,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157036,30.71,0.08,13.9,74100,74.4,NULL,NULL,'NGC 7331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157037,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157037,30.77,0.4,14.3,74100,75,NULL,'B','NGC 7331',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157038,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157038,30.78,NULL,14.3,74100,NULL,NULL,'B','NGC 7331',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157039,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157039,30.84,0.09,14.7,74100,75,NULL,NULL,'NGC 7331',NULL,'2001PhDT.......242M',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157040,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157040,30.87,NULL,14.9,74100,NULL,NULL,'I','NGC 7331',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157041,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157041,30.94,0.35,15.4,74100,NULL,NULL,NULL,'NGC 7331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157042,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157042,30.99,0.35,15.8,74100,NULL,NULL,'Malmquist cor.','NGC 7331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157043,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157043,31.01,NULL,15.9,74100,NULL,NULL,'LEDA [April 2006]','NGC 7331',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157044,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157044,31,0.43,15.9,74100,75,NULL,'3.6 micron, color corrected','NGC 7331',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157045,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157045,31.05,0.43,16.2,74100,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7331',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157046,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157046,31.06,0.4,16.3,74100,73,NULL,'opt','NGC 7331',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157047,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157047,35.99,0.2,158,74101,74.4,NULL,NULL,'CGCG 429-014',NULL,'2013AJ....146...86T',2013,1,0.46,NULL,'G',0.0001,NULL,'15.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,339.282125,14.23194,0.169,NULL,52596385160,821818518,12840914,15.9),(157048,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157048,37.2,0.65,276,74102,70,NULL,NULL,'2MASX J22370813-6140277',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000083,NULL,'17.24',0.27,NULL,NULL,NULL,NULL,NULL,1,339.283875,-61.67439,0,NULL,48789308060,762332938,11911452,17.24),(157049,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157049,36.16,NULL,171,74103,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12112',NULL,'2010Ap&SS.325..163P',2010,1,1.23,NULL,'G',0.000009,NULL,'16.0',0.11,'Sc',NULL,NULL,NULL,NULL,1,339.306083,11.95078,0.113,NULL,52586192146,821659252,12838425,16),(157050,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157050,36.17,NULL,171,74103,NULL,NULL,'Dipole + Quadrupole','UGC 12112',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157051,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157051,36.18,NULL,172,74103,NULL,NULL,'Dipole','UGC 12112',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157052,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157052,36.27,NULL,179,74103,NULL,NULL,NULL,'UGC 12112',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157053,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157053,36.44,0.49,194,74103,75,NULL,'IR','UGC 12112',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157054,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007pq',NULL,157054,39.32,0.12,730,74104,70,NULL,'Hubble residual 0.02 for z0.18550','SDSS J223713.94+004410.6',NULL,'2011ApJ...740...92G',2011,1,0.08,NULL,'G',0.0005,NULL,'20.4g',0.05,NULL,NULL,NULL,NULL,NULL,1,339.308125,0.73631,0.241,NULL,51677870232,807466722,12616667,20.4),(157055,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20048','R',157055,39.82,0.21,777,74104,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pq','SDSS J223713.94+004410.6',0.1855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157056,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007pq',NULL,157056,39.64,0.1,847,74104,70,NULL,'SALT 2','SDSS J223713.94+004410.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157057,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 2007pq',NULL,157057,39.65,0.1,851,74104,70,NULL,'SALT 2, Malmquist cor.','SDSS J223713.94+004410.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157058,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20048','R',157058,40.08,0.13,876,74104,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pq','SDSS J223713.94+004410.6',0.1855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157059,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157059,37.89,0.21,378,74105,70,NULL,NULL,'2MASX J22371568-0819139',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00015,NULL,'16.3g',0.3,'BrClG',NULL,NULL,NULL,NULL,1,339.315333,-8.32044,0.153,NULL,50395748610,787433572,12303649,16.3),(157060,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157060,36.22,0.63,176,74106,70,NULL,NULL,'MCG -07-46-005',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,339.317583333,-43.70319,0,NULL,50720408320,792506380,12382912,15.5),(157061,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157061,37.89,0.21,378,74107,70,NULL,NULL,'2MASX J22371804-0821244',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.00015,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,339.32525,-8.35672,0.153,NULL,50395747270,787433551,12303649,18),(157062,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16414','R',157062,40.82,0.26,1120,74108,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pj','SN 2006pj',0.307732,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,339.3264583,0.73814,0.241,NULL,51677862021,807466594,12616665,NULL),(157063,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 16414','R',157063,40.9,0.18,1160,74108,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pj','SN 2006pj',0.307732,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157064,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157064,37.86,0.16,373,74109,70,NULL,NULL,'SDSS J223718.34+131652.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,339.3264583,13.28128,0.141,NULL,52595298367,821801536,12840649,18),(157065,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157065,37.77,0.23,358,74110,70,NULL,NULL,'2MASX J22372098+1227584',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000152,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,339.337417,12.46631,0.149,NULL,52586282765,821660668,12838447,16.7),(157066,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157066,31.66,0.14,21.5,74111,74.4,NULL,NULL,'NGC 7332',NULL,'2013AJ....146...86T',2013,1,4.1,NULL,'G',0.000017,NULL,'12.02',1.1,'S0 pec sp','Pair member (points to parent)',NULL,NULL,NULL,1,339.35225,23.79833,0.109,NULL,52353385134,818021642,12781588,12.02),(157067,'SBF','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157067,31.81,0.2,23,74111,NULL,NULL,'I','NGC 7332',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157068,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157068,28.85,0.63,5.89,74111,95,NULL,'Michard 1979b, c','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157069,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157069,30.09,0.46,10.4,74111,95,NULL,'Michard 1979a','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157070,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157070,30.12,0.31,10.6,74111,95,NULL,'Weighted Mean','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157071,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157071,30.14,0.81,10.7,74111,55,NULL,'Visvanathan & Sandage 1979','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157072,'Faber-Jackson','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157072,31.86,0.6,23.6,74111,95,NULL,'de Vaucouleurs','NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157073,'Tertiary','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157073,30.56,0.25,12.9,74111,95,NULL,NULL,'NGC 7332',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157074,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157074,31.3,0.8,18.2,74111,75,NULL,'B','NGC 7332',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157075,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157075,29.69,0.45,8.66,74111,NULL,NULL,'K','NGC 7332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157076,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157076,30.68,0.4,13.7,74111,NULL,NULL,'mean','NGC 7332',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157077,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157077,30.76,0.49,14.2,74111,75,NULL,'IR','NGC 7332',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157078,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 17690','RN',157078,42.8,0.18,2420,74112,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17690',0.49717,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157079,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157079,34.28,0.49,71.7,74113,75,NULL,'IR','NGC 7320B',NULL,'2011yCatp016004901K',2011,1,0.82,NULL,'G',0.001094,NULL,'15.7',0.24,NULL,NULL,NULL,NULL,NULL,1,339.36725,33.92292,0.317,NULL,55461648254,866588253,13540441,15.7),(157080,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157080,32.6,0.47,33.2,74114,NULL,NULL,'H','NGC 7328',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.000003,NULL,'13.98',0.7,'Sab            HII','Isolated galaxy',NULL,NULL,NULL,1,339.372,10.53158,0.213,NULL,52457354245,819646160,12806971,13.98),(157081,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157081,32.69,0.45,34.5,74114,NULL,NULL,'K','NGC 7328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157082,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157082,32.72,0.46,35,74114,NULL,NULL,'J','NGC 7328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157083,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157083,32.73,0.4,35.1,74114,NULL,NULL,'mean','NGC 7328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157084,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157084,32.93,0.44,38.6,74114,NULL,NULL,'Malmquist cor.','NGC 7328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157085,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157085,32.97,0.43,39.3,74114,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157086,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157086,33.03,0.43,40.4,74114,75,NULL,'3.6 micron, color corrected','NGC 7328',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157087,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157087,33.05,0.2,40.7,74114,74.4,NULL,NULL,'NGC 7328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157088,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157088,33.05,0.42,40.8,74114,NULL,NULL,NULL,'NGC 7328',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157089,'GRB','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157089,44,0.82,3020,74115,NULL,NULL,NULL,'GRB 091024',1.092,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,339.251375,56.88944,NULL,NULL,53377496985,834023390,13031615,NULL),(157090,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157090,34.45,0.2,77.6,74116,74.4,NULL,NULL,'UGC 12119',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000017,NULL,'16.0',0.5,'S?',NULL,NULL,NULL,NULL,1,339.380375,18.79253,0.201,NULL,52398794014,818731156,12792674,16),(157091,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157091,34.48,0.68,78.7,74116,NULL,NULL,NULL,'UGC 12119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157092,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157092,34.8,0.59,91.2,74116,NULL,NULL,'Malmquist cor.','UGC 12119',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157093,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157093,36.95,0.46,245,74117,70,NULL,NULL,'2MASX J22373257+0109004',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000193,NULL,'16.0g',0.47,'E0',NULL,NULL,NULL,NULL,1,339.3857917,1.15022,0.213,NULL,51677940690,807467823,12616684,16),(157094,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157094,37.86,0.16,373,74118,70,NULL,NULL,'2MASX J22373424+1313444',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000169,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,339.392791667,13.22911,0.141,NULL,52594835181,821794299,12840535,17.6),(157095,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157095,38.18,0.46,433,74119,70,NULL,NULL,'SDSS J223735.44+132652.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000149,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,339.397666667,13.448,0.141,NULL,52594816633,821794009,12840531,18.2),(157096,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157096,37.04,0.46,256,74120,70,NULL,NULL,'2MASX J22373689+1306224',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,339.40375,13.10625,0.133,NULL,52594934120,821795845,12840560,17.3),(157097,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157097,35.63,0.4,134,74121,NULL,NULL,'mean','CGCG 452-037',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000033,NULL,'15.31',0.2,'S?',NULL,NULL,NULL,NULL,1,339.413583,20.01606,0.181,NULL,52410695242,818917113,12795579,15.31),(157098,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157098,35.86,0.47,149,74121,NULL,NULL,'H','CGCG 452-037',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157099,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157099,37.51,0.33,317,74122,70,NULL,NULL,'2MASX J22374003+1408064',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,339.41675,14.13511,0.169,NULL,52596419335,821819052,12840922,17.2),(157100,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157100,37.98,0.46,394,74123,70,NULL,NULL,'2MASXi J2237401+134739',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,339.417083,13.79433,0.169,NULL,52596494260,821820222,12840940,17.7),(157101,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157101,37.51,0.33,317,74124,70,NULL,NULL,'2MASX J22374030+1406003',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000189,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,339.417958333,14.10003,0.169,NULL,52596417336,821819020,12840922,16.6),(157102,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157102,37.77,0.23,358,74125,70,NULL,NULL,'SDSS J223744.45+123645.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,339.4352083,12.61253,0.169,NULL,52586219530,821659680,12838432,18.3),(157103,'SNII optical','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 1989L',NULL,157103,30.94,0.19,15.3,74126,NULL,NULL,'SEAM','NGC 7339',0.00438,'2009ApJ...694.1067P',2009,1,3,NULL,'G',0.000027,NULL,'13.13',0.7,'SAB(s)bc:?','Pair member (points to parent)',NULL,NULL,NULL,1,339.446833,23.78669,0.109,NULL,52353514055,818023657,12781619,13.13),(157104,'SNII optical','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 1989L',NULL,157104,31.15,0.45,17,74126,NULL,NULL,NULL,'NGC 7339',NULL,'1994ApJ...432...42S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157105,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157105,31.42,0.8,19.2,74126,75,NULL,'MAT, I','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157106,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157106,31.42,0.8,19.2,74126,75,NULL,'W91PP, r','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157107,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157107,31.44,0.8,19.5,74126,75,NULL,'CF, r','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157108,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157108,31.43,0.8,19.3,74126,75,NULL,'B','NGC 7339',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157109,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157109,31.4,0.3,19.1,74126,NULL,18.45,'SN 1989L host','NGC 7339',NULL,'1994ApJ...430...53P',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157110,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157110,31.53,0.43,20.2,74126,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157111,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157111,31.74,0.43,22.2,74126,75,NULL,'3.6 micron, color corrected','NGC 7339',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157112,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157112,31.75,0.37,22.4,74126,NULL,NULL,NULL,'NGC 7339',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157113,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157113,31.78,0.4,22.7,74126,75,NULL,NULL,'NGC 7339',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157114,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157114,31.84,0.38,23.3,74126,75,NULL,'W91PP, r, raw','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157115,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157115,31.85,0.38,23.5,74126,75,NULL,'CF, r, raw','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157116,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157116,31.93,0.38,24.3,74126,75,NULL,'W91PP, r, inv','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157117,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157117,31.93,0.38,24.4,74126,75,NULL,'CF, r, inv','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157118,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157118,31.95,0.32,24.5,74126,85,NULL,'I, raw','NGC 7339',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157119,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157119,31.98,0.32,24.9,74126,85,NULL,'I, inv','NGC 7339',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157120,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157120,32,0.43,25.1,74126,75,NULL,'MAT, I, raw','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157121,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157121,32,0.2,25.1,74126,74.4,NULL,NULL,'NGC 7339',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157122,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157122,32.02,0.38,25.3,74126,75,NULL,'W91PP, r, cor','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157123,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157123,32.03,0.38,25.4,74126,75,NULL,'CF, r, cor','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157124,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157124,32.19,0.43,27.4,74126,75,NULL,'MAT, I, inv','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157125,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157125,32.21,0.43,27.6,74126,75,NULL,'MAT, I, cor','NGC 7339',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157126,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157126,32.23,0.47,27.9,74126,NULL,NULL,NULL,'NGC 7339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157127,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157127,32.32,0.45,29.1,74126,NULL,NULL,'Malmquist cor.','NGC 7339',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157128,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157128,37.37,0.46,299,74127,70,NULL,NULL,'SDSS J223747.72+130707.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,339.448833,13.11861,0.141,NULL,52594935215,821795862,12840560,18),(157129,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157129,37.6,0.46,332,74128,70,NULL,NULL,'2MASX J22374824-0751162',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000239,NULL,'17.9g',0.17,'Candidate      BLAGN',NULL,NULL,NULL,NULL,1,339.451083,-7.85469,0.149,NULL,50396366573,787443227,12303800,17.9),(157130,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157130,37.89,0.21,378,74129,70,NULL,NULL,'2MASX J22375167-0819302',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000144,NULL,'17.7g',0.14,NULL,NULL,NULL,NULL,NULL,1,339.4654583,-8.32511,0.169,NULL,50395750706,787433604,12303650,17.7),(157131,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157131,33.55,0.8,51.3,74130,75,NULL,'MAT, I','UGC 12123',NULL,'1997ApJS..109..333W',1997,1,1.16,NULL,'G',0.000007,NULL,'15.70',0.13,'SBcd?',NULL,NULL,NULL,NULL,1,339.472666667,25.19333,0.129,NULL,51883163703,810674432,12666788,15.7),(157132,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157132,33.55,0.8,51.4,74130,75,NULL,'W91PP, r','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157133,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157133,33.36,0.63,47,74130,NULL,NULL,'Malmquist cor.','UGC 12123',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157134,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157134,33.55,0.32,51.4,74130,85,NULL,'I, inv','UGC 12123',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157135,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157135,33.56,0.2,51.5,74130,74.4,NULL,NULL,'UGC 12123',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157136,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157136,33.57,0.32,51.8,74130,85,NULL,'I, raw','UGC 12123',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157137,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157137,33.62,0.56,52.9,74130,NULL,NULL,NULL,'UGC 12123',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157138,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157138,33.63,NULL,53.2,74130,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12123',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157139,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157139,33.66,NULL,53.9,74130,NULL,NULL,'Dipole + Quadrupole','UGC 12123',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157140,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157140,33.68,NULL,54.4,74130,NULL,NULL,'Dipole','UGC 12123',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157141,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157141,33.68,0.43,54.4,74130,75,NULL,'3.6 micron, color corrected','UGC 12123',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157142,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157142,33.73,0.49,55.6,74130,75,NULL,'IR','UGC 12123',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157143,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157143,33.77,0.43,56.7,74130,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12123',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157144,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157144,33.79,0.38,57.3,74130,75,NULL,'W91PP, r, inv','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157145,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157145,33.81,NULL,57.8,74130,NULL,NULL,NULL,'UGC 12123',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157146,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157146,33.87,0.38,59.5,74130,75,NULL,'W91PP, r, raw','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157147,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157147,33.87,0.43,59.5,74130,75,NULL,'MAT, I, raw','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157148,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157148,33.88,0.43,59.6,74130,75,NULL,'MAT, I, inv','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157149,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157149,34.22,0.38,69.8,74130,75,NULL,'W91PP, r, cor','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157150,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157150,34.32,0.43,73,74130,75,NULL,'MAT, I, cor','UGC 12123',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157151,'L(H{beta})-{sigma}','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157151,45.06,NULL,1641,74131,74.3,NULL,NULL,'WISP 046_0075',1.504,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.485333333,-18.71281,0.029,NULL,50251519118,785179986,12268437,NULL),(157152,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 07532','RN',157152,43.13,0.33,2750,74132,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07532',0.541159,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157153,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157153,37.24,0.46,281,74133,70,NULL,NULL,'2MASX J22380095+1417566',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000171,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,339.504041667,14.29894,0.189,NULL,52596145362,821814771,12840855,16.3),(157154,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157154,37.77,0.23,358,74134,70,NULL,NULL,'2MASX J22380109+1235246',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000158,NULL,'17.8g',0.22,NULL,NULL,NULL,NULL,NULL,1,339.5047083,12.59011,0.169,NULL,52586944496,821671007,12838609,17.8),(157155,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157155,37.77,0.23,358,74135,70,NULL,NULL,'2MASX J22380676+1242546',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,339.5282083,12.71519,0.129,NULL,52586690580,821667040,12838547,17.4),(157156,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157156,38.66,0.46,538,74136,70,NULL,NULL,'APMUKS(BJ) B223534.49+004600.1',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',NULL,NULL,'19.35',0.11,NULL,NULL,NULL,NULL,NULL,1,339.532875,1.02697,0.213,NULL,51677843244,807466300,12616660,19.35),(157157,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157157,37.53,0.46,320,74137,70,NULL,NULL,'2MASX J22380865-0018503',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000176,NULL,'16.9g',0.21,NULL,NULL,NULL,NULL,NULL,1,339.535916667,-0.31406,0.173,NULL,49461790355,772840474,12075632,16.9),(157158,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157158,37.03,0.46,255,74138,70,NULL,NULL,'SDSS J223811.72+134833.6',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',NULL,NULL,'17.2g',0.21,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.548875,13.80936,0.169,NULL,52596460042,821819688,12840932,17.2),(157159,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157159,36.14,0.66,169,74139,70,NULL,NULL,'2MASX J22381207-6055513',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.000103,NULL,'16.77',0.25,NULL,NULL,NULL,NULL,NULL,1,339.550417,-60.93092,0,NULL,48803671883,762557373,11914958,16.77),(157160,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157160,32.89,0.4,37.8,74140,75,NULL,NULL,'UGC 12141',NULL,'2008Ap.....51..336K',2008,1,1.2,NULL,'G',0.00002,NULL,'15.54',0.3,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,339.5614583,80.67725,0.613,NULL,52846230768,825722355,12901911,15.54),(157161,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157161,33.19,0.2,43.5,74140,74.4,NULL,NULL,'UGC 12141',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157162,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157162,33.27,0.66,45,74140,NULL,NULL,'Malmquist cor.','UGC 12141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157163,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157163,33.33,0.64,46.4,74140,NULL,NULL,NULL,'UGC 12141',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157164,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157164,33.38,0.49,47.5,74140,75,NULL,'IR','UGC 12141',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157165,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157165,37.06,0.46,259,74141,70,NULL,NULL,'2MASX J22381738+1403320',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000193,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,339.572333,14.05897,0.169,NULL,52596548342,821821067,12840954,16.8),(157166,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13289','RN',157166,40.74,0.09,1250,74142,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13289',0.128939,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157167,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13289','RN',157167,41.25,0.19,1570,74142,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13289',0.128939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157168,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157168,35.92,0.73,153,74143,70,NULL,NULL,'6dF J2238212-360101',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,339.588666667,-36.01683,0,NULL,50576889921,790263905,12347873,14.7),(157169,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157169,37.89,0.21,378,74144,70,NULL,NULL,'2MASX J22382263-0818475',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000194,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,339.594417,-8.31328,0.169,NULL,50396525941,787445717,12303839,18.2),(157170,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 20534','R',157170,40.48,0.14,1070,74145,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20534',0.164366,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.608417,-0.23644,0.173,NULL,49462275680,772848057,12075750,NULL),(157171,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13722','RN',157171,40.28,0.06,1050,74146,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13722',0.087742,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157172,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 13722','RN',157172,40.55,0.18,1190,74146,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13722',0.087742,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157173,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15391','RN',157173,39.02,0.12,586,74147,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15391',0.088158,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157174,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15391','RN',157174,39.09,0.19,604,74147,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15391',0.088158,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157175,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991',NULL,157175,39.98,0.33,992,74148,70,NULL,'SN photometric redshift distance, z photo =0.266 +/- 0.053','SDSS-II SN 01991',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.626583,0.90831,0.213,NULL,51677156958,807455577,12616493,NULL),(157176,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991','R',157176,40.65,0.27,1020,74148,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01991',0.315484,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157177,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991','R',157177,40.7,0.19,1050,74148,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01991',0.315484,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157178,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991',NULL,157178,40.54,0.16,1280,74148,70,NULL,'SALT 2','SDSS-II SN 01991',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157179,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 01991',NULL,157179,40.57,0.16,1300,74148,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01991',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157180,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157180,36.05,0.62,162,74149,70,NULL,NULL,'2MASX J22383473-6822293',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.36',0.4,'S0',NULL,NULL,NULL,NULL,1,339.644708333,-68.37475,0.005,NULL,49321142530,770642852,12041294,16.36),(157181,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03812','RN',157181,36.04,0.07,152,74150,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03812',0.060392,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157182,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 03812','RN',157182,40.47,0.61,1170,74150,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03812',0.060392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157183,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SN 1974J','R',157183,34.95,NULL,97.7,74151,NULL,NULL,'Photographic','NGC 7343',NULL,'1988SSRv...48....1R',1988,1,1.1,'HMS gives v=1206 km/sec. RC3 gives v_21_=6065 km/s and v_opt_=6500 km/s.','G',0.000033,NULL,'14.4',0.9,'(R\')SB(s)bc:   LINER',NULL,NULL,NULL,NULL,1,339.65775,34.07144,0.281,NULL,55465120907,866642514,13541289,14.4),(157184,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157184,31.41,0.8,19.1,74151,75,NULL,'B','NGC 7343',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157185,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157185,35.05,0.4,102,74151,NULL,NULL,'mean','NGC 7343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157186,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157186,35.34,0.47,117,74151,NULL,NULL,'H','NGC 7343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157187,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157187,35.37,0.45,118,74151,NULL,NULL,'K','NGC 7343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157188,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157188,35.42,0.46,121,74151,NULL,NULL,'J','NGC 7343',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157189,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157189,36.11,0.87,166,74152,70,NULL,NULL,'2MASX J22384028-6649417',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.2',0.47,'S0',NULL,NULL,NULL,NULL,1,339.6677083,-66.82833,0,NULL,49285645477,770088210,12032628,16.2),(157190,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157190,36.96,0.46,246,74153,70,NULL,NULL,'SDSS J223840.65+000603.4',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',NULL,NULL,'15.7g',0.44,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.669375,0.10094,0.189,NULL,51675740864,807433451,12616147,15.7),(157191,'FP','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,'R',157191,37.71,0.46,348,74154,70,NULL,NULL,'2MASX J22384128+1406063',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000135,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,339.672125,14.10194,0.189,NULL,52596361592,821818149,12840908,18.1),(157192,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157192,33.16,0.8,42.8,74155,75,NULL,'MAT, I','ESO 534- G 009',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.00001,NULL,'13.55',0.8,'SA(s)ab? sp;HIILINER',NULL,NULL,NULL,NULL,1,339.6725417,-25.85067,0,NULL,50074174813,782408981,12225140,13.55),(157193,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157193,33.19,0.45,43.4,74155,NULL,NULL,'K','ESO 534- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157194,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157194,33.21,0.4,43.8,74155,NULL,NULL,'mean','ESO 534- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157195,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157195,33.25,0.47,44.6,74155,NULL,NULL,'H','ESO 534- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157196,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157196,33.26,0.46,44.9,74155,NULL,NULL,'J','ESO 534- G 009',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157197,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157197,33.32,0.32,46.2,74155,85,NULL,'I, raw','ESO 534- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157198,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157198,33.38,0.32,47.5,74155,85,NULL,'I, inv','ESO 534- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157199,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157199,33.43,0.48,48.5,74155,NULL,NULL,'Malmquist cor.','ESO 534- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157200,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157200,33.46,0.43,49.3,74155,75,NULL,'MAT, I, raw','ESO 534- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157201,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157201,33.53,0.46,50.8,74155,NULL,NULL,NULL,'ESO 534- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157202,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157202,33.57,0.2,51.8,74155,74.4,NULL,NULL,'ESO 534- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157203,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157203,33.71,0.43,55.1,74155,75,NULL,'MAT, I, cor','ESO 534- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157204,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:17','1',NULL,NULL,157204,33.73,0.43,55.7,74155,75,NULL,'MAT, I, inv','ESO 534- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157205,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:17','1','SDSS-II SN 15942',NULL,157205,39.74,0.46,887,74156,70,NULL,'SN photometric redshift distance, z photo =0.234 +/- 0.066','SDSS-II SN 15942',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.674666667,-0.6285,0.165,NULL,49462178018,772846531,12075727,NULL),(157206,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15942',NULL,157206,41.17,0.13,1710,74156,70,NULL,'SALT 2','SDSS-II SN 15942',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157207,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15942',NULL,157207,41.21,0.13,1750,74156,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15942',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157208,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157208,36.94,0.46,244,74157,70,NULL,NULL,'SDSS J223842.78+130445.6',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000184,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,339.67825,13.07936,0.141,NULL,52594885821,821795090,12840548,16.2),(157209,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157209,33.27,0.43,45,74158,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12135',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.000033,NULL,'16.0P',0.6,'Sc',NULL,NULL,NULL,NULL,1,339.6977917,72.54669,3.009,NULL,52786270667,824785479,12887273,16),(157210,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157210,33.42,0.43,48.3,74158,75,NULL,'3.6 micron, color corrected','UGC 12135',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157211,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157211,33.43,0.2,48.5,74158,74.4,NULL,NULL,'UGC 12135',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157212,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157212,33.6,0.57,52.4,74158,NULL,NULL,NULL,'UGC 12135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157213,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157213,33.75,0.53,56.3,74158,NULL,NULL,'Malmquist cor.','UGC 12135',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157214,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157214,36.72,0.58,221,74159,70,NULL,NULL,'2MASX J22384875-2004488',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'15.89',0.33,NULL,'Field galaxy',NULL,NULL,NULL,1,339.703333,-20.08019,0.077,NULL,50250504353,785164130,12268189,15.89),(157215,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157215,34.49,0.8,79.1,74160,75,NULL,'W91PP, r','UGC 12132',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.24',0.5,'SBb?',NULL,NULL,NULL,NULL,1,339.711625,34.30303,0.345,NULL,55465265871,866644779,13541324,15.24),(157216,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157216,34.94,0.38,97.4,74160,75,NULL,'W91PP, r, raw','UGC 12132',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157217,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157217,35.02,0.38,101,74160,75,NULL,'W91PP, r, cor','UGC 12132',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157218,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157218,35.1,0.38,105,74160,75,NULL,'W91PP, r, inv','UGC 12132',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157219,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2007ik',NULL,157219,39.34,0.13,736,74161,70,NULL,'Hubble residual 0.06 for z0.18400','SDSS-II SN 17168 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,339.723625,-1.16725,0.133,NULL,49462585359,772852896,12075826,NULL),(157220,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 17168','R',157220,39.9,0.19,805,74161,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ik','SDSS-II SN 17168 HOST',0.185192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157221,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2007ik',NULL,157221,39.75,0.09,891,74161,70,NULL,'SALT 2','SDSS-II SN 17168 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157222,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2007ik',NULL,157222,39.76,0.09,895,74161,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17168 HOST',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157223,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 17168','R',157223,40.15,0.13,905,74161,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ik','SDSS-II SN 17168 HOST',0.185192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157224,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157224,37.53,0.46,321,74162,70,NULL,NULL,'2MASX J22385614+1251594',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,339.734041667,12.86664,0.133,NULL,52586729154,821667643,12838556,17.2),(157225,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157225,36.96,0.61,247,74163,70,NULL,NULL,'2MASX J22385671-1924491',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'16.00',0.29,NULL,'Field galaxy',NULL,NULL,NULL,1,339.7365,-19.41369,0.061,NULL,50251034185,785172409,12268318,16),(157226,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157226,31.21,0.43,17.5,74164,75,NULL,'3.6 micron, color + selection bias corrected','UGCA 432',NULL,'2014MNRAS.444..527S',2014,1,2.6,'Double star HD 214517 (V ~10 each, 18\\\" sep) superposed 54\\\" west-southwest.','G',0.000006,NULL,'13.5',0.9,'SAB(s)dm?',NULL,NULL,NULL,NULL,1,339.738333,-5.85314,0.133,NULL,50342136848,786595888,12290560,13.5),(157227,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 02681','RN',157227,40.33,0.18,941,74165,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02681',0.239856,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157228,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 02681','RN',157228,41.92,0.24,1950,74165,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02681',0.239856,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157229,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 18626',NULL,157229,40.49,0.24,1250,74166,70,NULL,'SN photometric redshift distance, z photo =0.352 +/- 0.051','SDSS-II SN 18626',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.3g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.766083,-0.27258,0.185,NULL,49462297657,772848400,12075756,21.3),(157230,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 18626','R',157230,41.47,0.33,1440,74166,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18626',0.362429,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157231,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 18626','R',157231,41.61,0.31,1540,74166,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18626',0.362429,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157232,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157232,37.5,0.46,316,74167,70,NULL,NULL,'2MASX J22390433+0020122',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000144,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,339.767958333,0.33678,0.193,NULL,51675775552,807433993,12616156,17.4),(157233,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813','R',157233,40.5,0.27,950,74168,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21813',0.325169,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,339.7719583,1.18467,0.217,NULL,51677232861,807456763,12616511,21.9),(157234,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813',NULL,157234,40.2,0.59,1100,74168,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.120','SDSS-II SN 21813',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157235,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813','R',157235,40.85,0.37,1120,74168,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21813',0.325169,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157236,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813',NULL,157236,40.49,0.22,1250,74168,70,NULL,'SALT 2','SDSS-II SN 21813',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157237,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21813',NULL,157237,40.52,0.22,1270,74168,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21813',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157238,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157238,32.62,0.47,33.4,74169,NULL,NULL,'H','NGC 7341',NULL,'2007A&A...465...71T',2007,1,2.4,NULL,'G',0.000017,NULL,'13.28',1,'SAB(r)b',NULL,NULL,NULL,NULL,1,339.773083,-22.66667,0.041,NULL,50256516618,785258072,12269657,13.28),(157239,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157239,33.28,0.46,45.4,74169,NULL,NULL,'J','NGC 7341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157240,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157240,33.34,0.45,46.5,74169,NULL,NULL,'K','NGC 7341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157241,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157241,33.5,0.4,50.2,74169,NULL,NULL,'mean','NGC 7341',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157242,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157242,34.56,0.56,81.6,74170,70,NULL,NULL,'ESO 603- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'Mathewson, et al. (1996,ApJS,107,97) give v = 8935 +/- 10 km/sec.','G',0.000033,NULL,'14.50',0.4,'(R\':)SAB(rs)ab','Field galaxy',NULL,NULL,NULL,1,339.7740417,-19.66233,0.061,NULL,50250573603,785165212,12268206,14.5),(157243,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157243,35.4,0.47,120,74170,NULL,NULL,'H','ESO 603- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157244,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157244,35.51,0.4,126,74170,NULL,NULL,'mean','ESO 603- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157245,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157245,35.53,0.45,127,74170,NULL,NULL,'K','ESO 603- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157246,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157246,35.6,0.46,132,74170,NULL,NULL,'J','ESO 603- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157247,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157247,35.6,0.35,132,74170,NULL,NULL,'Malmquist cor.','ESO 603- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157248,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157248,35.81,0.31,145,74170,NULL,NULL,NULL,'ESO 603- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157249,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157249,35.85,0.2,148,74170,74.4,NULL,NULL,'ESO 603- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157250,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157250,30.39,0.4,12,74171,75,NULL,'B','UGCA 433',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'14.97',0.5,'Im:',NULL,NULL,NULL,NULL,1,339.787625,-4.76019,0.109,NULL,50344709059,786636079,12291188,14.97),(157251,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157251,35.75,0.56,141,74172,NULL,NULL,NULL,'AGC 620266',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.00002,NULL,'16.95',0.28,NULL,NULL,NULL,NULL,NULL,1,339.802541667,-2.43914,0.145,NULL,49460430102,772819220,12075300,16.95),(157252,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157252,35.79,0.2,144,74172,74.4,NULL,NULL,'AGC 620266',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157253,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157253,35.8,0.55,145,74172,NULL,NULL,'Malmquist cor.','AGC 620266',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157254,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157254,36.64,0.17,213,74173,70,NULL,NULL,'2MASX J22391609-0059353',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000172,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,339.817167,-0.99311,0.145,NULL,49462491193,772851424,12075803,16.2),(157255,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 07254','R',157255,40.18,0.29,794,74174,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07254',0.366238,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','22.2g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.8309583,0.54333,0.181,NULL,51675878589,807435602,12616181,22.2),(157256,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 07254','R',157256,40.18,0.38,797,74174,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07254',0.366238,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157257,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 07254',NULL,157257,41.19,0.35,1730,74174,70,NULL,'SN photometric redshift distance, z photo =0.536 +/- 0.143','SDSS-II SN 07254',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157258,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157258,36.64,0.17,213,74175,70,NULL,NULL,'2MASX J22392403-0102163',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.16',0.33,'BrClG',NULL,NULL,NULL,NULL,1,339.850125,-1.03781,0.145,NULL,49462480485,772851257,12075800,16.16),(157259,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157259,37.12,0.46,266,74176,70,NULL,NULL,'2MASX J22392405+1320067',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000164,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,339.85025,13.33522,0.141,NULL,52594802519,821793789,12840527,16.9),(157260,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157260,36.64,0.17,213,74177,70,NULL,NULL,'2MASX J22392482-0041333',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000178,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,339.8535,-0.69272,0.169,NULL,49462135480,772845866,12075716,17.6),(157261,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157261,38.46,0.46,491,74178,70,NULL,NULL,'SDSS J223925.12+140043.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000145,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,339.8547083,14.012,0.189,NULL,52595912630,821811134,12840798,18.5),(157262,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157262,34.93,0.49,96.8,74179,75,NULL,'IR','ESO 603- G 002',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.31',0.2,'S              HII','Field galaxy',NULL,NULL,NULL,1,339.859416667,-20.37033,0.061,NULL,50261459867,785335310,12270864,16.31),(157263,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157263,35.09,0.53,104,74179,NULL,NULL,NULL,'ESO 603- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157264,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157264,35.13,0.2,106,74179,74.4,NULL,NULL,'ESO 603- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157265,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157265,35.19,0.51,109,74179,NULL,NULL,'Malmquist cor.','ESO 603- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157266,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157266,36.34,NULL,185,74180,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2405',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',NULL,NULL,'16.51',0.08,'Scd',NULL,NULL,NULL,NULL,1,339.865875,40.45553,0.525,NULL,55528612614,867634572,13556790,16.51),(157267,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157267,36.35,NULL,186,74180,NULL,NULL,NULL,'FGC 2405',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157268,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157268,36.36,NULL,187,74180,NULL,NULL,'Dipole + Quadrupole','FGC 2405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157269,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157269,36.39,NULL,190,74180,NULL,NULL,'Dipole','FGC 2405',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157270,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157270,36.98,0.46,249,74181,70,NULL,NULL,'2MASX J22392876+0012263',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,339.869833333,0.20736,0.189,NULL,51675050870,807422669,12615979,16.8),(157271,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21695','RN',157271,43.5,0.54,3840,74182,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 21695',0.30628,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157272,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 19742','RN',157272,40.79,0.22,1060,74183,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19742',0.359576,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157273,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 19742','RN',157273,41.06,0.31,1200,74183,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19742',0.359576,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157274,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157274,33.88,0.2,58.2,74184,74.2,NULL,'SALT 2, SNIa M(B) -19.310 mag, Alpha 1.52, Beta 1.57','UGC 12133',0.02476,'2011A&A...526A..81B',2011,1,1.88,NULL,'G',0.000007,NULL,'15.39',0.21,'Sc',NULL,NULL,NULL,NULL,1,339.883333,8.61294,0.285,NULL,52477938461,819967788,12811996,15.39),(157275,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157275,34.44,0.23,75.4,74184,74.2,NULL,'SALT 2','UGC 12133',0.02476,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157276,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157276,35.02,0.24,98.5,74184,72,NULL,NULL,'UGC 12133',0.02476,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157277,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157277,35.02,0.17,101,74184,70.8,NULL,NULL,'UGC 12133',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157278,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157278,35.03,0.08,101,74184,74.4,NULL,NULL,'UGC 12133',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157279,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157279,35.09,0.18,102,74184,70,NULL,'SALT 2','UGC 12133',0.02476,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157280,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157280,35.1,0.06,102,74184,72,NULL,NULL,'UGC 12133',0.02476,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157281,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157281,35.14,0.11,104,74184,65,NULL,'SALT2','UGC 12133',0.02476,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157282,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157282,35.16,0.18,105,74184,73.8,NULL,'SALT 2 (SNANA)','UGC 12133',0.0235,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157283,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157283,35.19,0.28,107,74184,70,NULL,'SALT','UGC 12133',0.02476,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157284,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157284,35.25,0.1,110,74184,70,NULL,NULL,'UGC 12133',0.02476,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157285,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157285,35.35,0.12,112,74184,65,NULL,'MLCS2k2','UGC 12133',0.02476,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157286,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157286,35.31,0.19,112,74184,65,NULL,'MLCS31','UGC 12133',0.02476,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157287,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157287,35.32,0.21,113,74184,65,NULL,'SALT2','UGC 12133',0.02476,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157288,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157288,35.32,0.12,113,74184,65,NULL,'MLCS2k2','UGC 12133',0.02476,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157289,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157289,35.33,0.09,114,74184,65,NULL,'MLCS2k2','UGC 12133',0.02476,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157290,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157290,35.33,0.18,114,74184,65,NULL,'MLCS17','UGC 12133',0.02476,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157291,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157291,35.35,0.29,115,74184,65,NULL,'SALT','UGC 12133',0.02476,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157292,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157292,35.36,0.2,115,74184,65,NULL,NULL,'UGC 12133',0.02476,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157293,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157293,35.45,0.03,120,74184,65,NULL,'SALT','UGC 12133',0.02476,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157294,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 1998eg',NULL,157294,35.52,0.14,127,74184,60,NULL,NULL,'UGC 12133',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157295,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157295,34.62,0.49,83.8,74184,75,NULL,'IR','UGC 12133',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157296,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157296,35.03,0.08,101,74184,74.4,NULL,NULL,'UGC 12133',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157297,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157297,35.13,NULL,106,74184,NULL,NULL,'Dipole','UGC 12133',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157298,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157298,35.13,NULL,106,74184,NULL,NULL,'Dipole + Quadrupole','UGC 12133',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157299,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157299,35.14,NULL,106,74184,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12133',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157300,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157300,35.14,0.4,107,74184,75,NULL,'HOSTS SN 1998eg','UGC 12133',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157301,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157301,35.2,0.43,110,74184,75,NULL,'3.6 micron, color corrected','UGC 12133',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157302,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157302,35.25,NULL,112,74184,NULL,NULL,NULL,'UGC 12133',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157303,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157303,35.26,0.34,113,74184,NULL,NULL,'Malmquist cor.','UGC 12133',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157304,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157304,35.27,0.43,113,74184,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12133',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157305,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157305,35.37,0.32,119,74184,NULL,NULL,NULL,'UGC 12133',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157306,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157306,37.71,0.46,349,74185,70,NULL,NULL,'SDSS J223935.91-100850.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000174,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,339.899666667,-10.14731,0.197,NULL,50354370553,786787039,12293547,18),(157307,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157307,34.33,0.54,73.6,74186,70,NULL,NULL,'NGC 7344',NULL,'2014MNRAS.445.2677S',2014,1,1.5,NULL,'G',0.00002,NULL,'14.61',0.8,'(R\')SB(r)ab',NULL,NULL,NULL,NULL,1,339.9010417,-4.15897,0.109,NULL,50345864807,786654137,12291470,14.61),(157308,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157308,34.36,0.36,74.5,74186,NULL,NULL,'Malmquist cor.','NGC 7344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157309,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157309,34.63,0.32,84.2,74186,NULL,NULL,NULL,'NGC 7344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157310,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157310,34.76,0.2,89.5,74186,74.4,NULL,NULL,'NGC 7344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157311,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157311,34.87,0.8,94,74187,75,NULL,'CF, r','UGC 12134',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000027,NULL,'14.15',0.6,'Sbc',NULL,NULL,NULL,NULL,1,339.906083,11.76989,0.113,NULL,52455780651,819621572,12806587,14.15),(157312,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157312,34.88,0.8,94.4,74187,75,NULL,'A82, H','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157313,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157313,34.61,0.38,83.6,74187,75,NULL,'CF, r, raw','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157314,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157314,34.63,0.33,84.3,74187,91,NULL,'H','UGC 12134',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157315,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157315,34.76,0.38,89.7,74187,75,NULL,'CF, r, inv','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157316,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157316,34.92,0.38,96.4,74187,75,NULL,'CF, r, cor','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157317,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157317,34.95,0.2,97.7,74187,74.4,NULL,NULL,'UGC 12134',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157318,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157318,34.99,0.47,99.6,74187,75,NULL,'A82, H, raw','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157319,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157319,35.03,0.42,101,74187,NULL,NULL,NULL,'UGC 12134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157320,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157320,35.09,0.41,104,74187,NULL,NULL,'Malmquist cor.','UGC 12134',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157321,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157321,35.17,0.47,108,74187,75,NULL,'A82, H, inv','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157322,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157322,35.44,0.47,123,74187,75,NULL,'A82, H, cor','UGC 12134',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157323,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157323,34.45,NULL,77.6,74188,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2406',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.000031,NULL,'16.20',0.1,'Sd',NULL,NULL,NULL,NULL,1,339.907083,33.57972,0.353,NULL,55464982865,866640357,13541255,16.2),(157324,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157324,34.47,NULL,78.3,74188,NULL,NULL,'Dipole + Quadrupole','FGC 2406',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157325,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157325,34.48,NULL,78.6,74188,NULL,NULL,'Dipole','FGC 2406',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157326,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157326,34.5,0.43,79.5,74188,NULL,NULL,NULL,'FGC 2406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157327,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157327,34.53,NULL,80.5,74188,NULL,NULL,NULL,'FGC 2406',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157328,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157328,34.69,0.2,86.7,74188,74.4,NULL,NULL,'FGC 2406',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157329,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157329,34.69,0.39,86.8,74188,NULL,NULL,'Malmquist cor.','FGC 2406',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157330,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157330,34.85,0.43,93.5,74188,75,NULL,'3.6 micron, color corrected','FGC 2406',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157331,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157331,34.87,0.43,94,74188,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2406',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157332,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157332,37.68,0.33,344,74189,70,NULL,NULL,'2MASX J22393932+1445593',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,339.913791667,14.76656,0.181,NULL,52592668284,821760441,12840006,18.2),(157333,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 02539',NULL,157333,41.49,0.1,1980,74190,70,NULL,'SN photometric redshift distance, z photo =0.650 +/- 0.047','SDSS-II SN 02539',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,339.9390417,-0.30628,0.185,NULL,49461413420,772834584,12075540,21.5),(157334,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157334,36.64,0.17,213,74191,70,NULL,NULL,'2MASX J22394592-0055597',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,339.941375,-0.93317,0.145,NULL,49462076011,772844937,12075702,16.9),(157335,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157335,36.04,0.54,161,74192,70,NULL,NULL,'ESO 109-IG 010 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'15.62',0.47,'E2 pec',NULL,NULL,NULL,NULL,1,339.941916667,-66.73336,0,NULL,49285482148,770085658,12032588,15.62),(157336,'GRB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157336,42.43,0.29,2000,74193,NULL,NULL,'SN 2008hw','SN 2008hw',0.5295,'2010JCAP...08..020W',2010,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ic',NULL,NULL,NULL,NULL,1,339.960333333,-40.14711,0,NULL,50713494441,792398350,12381224,NULL),(157337,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157337,37.91,0.46,382,74194,70,NULL,NULL,'2MASX J22395041+0106367',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000138,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,339.960166667,1.11025,0.197,NULL,51675156436,807424319,12616004,18),(157338,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157338,37.74,0.46,353,74195,70,NULL,NULL,'2MASX J22395361-0830078',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000168,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,339.9732917,-8.50208,0.133,NULL,50396624271,787447254,12303863,17.5),(157339,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157339,36.64,0.17,213,74196,70,NULL,NULL,'2MASX J22395499-0059186',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.00015,NULL,'15.9g',0.48,'E0',NULL,NULL,NULL,NULL,1,339.9790417,-0.98861,0.145,NULL,49462077580,772844962,12075702,15.9),(157340,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157340,37.27,0.67,284,74196,70,NULL,NULL,'2MASX J22395499-0059186',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157341,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157341,32.33,0.43,29.2,74197,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7347',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000022,NULL,'14.57',0.3,'Sc',NULL,NULL,NULL,NULL,1,339.984041667,11.02756,0.173,NULL,52458141964,819658468,12807163,14.57),(157342,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157342,32.5,0.43,31.6,74197,75,NULL,'3.6 micron, color corrected','NGC 7347',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157343,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157343,32.69,0.2,34.5,74197,74.4,NULL,NULL,'NGC 7347',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157344,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157344,32.73,0.49,35.2,74197,75,NULL,'IR','NGC 7347',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157345,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157345,32.93,0.47,38.5,74197,NULL,NULL,NULL,'NGC 7347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157346,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157346,32.94,0.47,38.8,74197,NULL,NULL,'Malmquist cor.','NGC 7347',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157347,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 04111','RN',157347,42.64,0.26,2440,74198,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04111',0.383992,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157348,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 04111','RN',157348,42.98,0.31,2840,74198,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04111',0.383992,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157349,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157349,38.33,0.33,464,74199,70,NULL,NULL,'2MASX J22400335+1234284',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.014,12.57444,0.133,NULL,52586935123,821670861,12838607,17.5),(157350,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157350,36.64,0.17,213,74200,70,NULL,NULL,'2MASX J22400525-0048276',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00011,NULL,'15.73',0.36,'BrClG',NULL,NULL,NULL,NULL,1,340.02175,-0.80769,0.169,NULL,49461950590,772842977,12075671,15.73),(157351,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157351,36.82,0.19,231,74201,70,NULL,NULL,'2MASX J22400724-0018386',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000161,NULL,'16.7g',0.26,NULL,NULL,NULL,NULL,NULL,1,340.030166667,-0.31064,0.189,NULL,49461539338,772836552,12075571,16.7),(157352,'HII LF','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157352,47.73,0.25,5760,74202,71,NULL,NULL,'DSF 2237+116a C002',3.331,'2005MNRAS.356.1117S',2005,1,NULL,NULL,'G',0.001,NULL,'23.55',NULL,'Lyman-break gal.',NULL,NULL,NULL,NULL,1,340.0345417,11.818,0.125,NULL,52455560256,819618129,12806533,23.55),(157353,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15934',NULL,157353,39.89,0.27,950,74203,70,NULL,'SN photometric redshift distance, z photo =0.253 +/- 0.040','SDSS-II SN 15934',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.035875,0.212,0.189,NULL,51675129298,807423895,12615998,21.9),(157354,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157354,37.85,0.46,372,74204,70,NULL,NULL,'SDSS J224009.03+124729.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,340.037667,12.7915,0.145,NULL,52586806164,821668846,12838575,18.6),(157355,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157355,37.68,0.33,344,74205,70,NULL,NULL,'SDSS J224010.12+144043.3',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000125,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.042166667,14.67869,0.173,NULL,52592885745,821763839,12840059,18.3),(157356,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157356,36.82,0.19,231,74206,70,NULL,NULL,'2MASX J22401030-0007465',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000167,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.0429583,-0.12956,0.189,NULL,49461568820,772837012,12075578,17.7),(157357,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 01992','RN',157357,42.93,0.5,2800,74207,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01992',0.37745,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157358,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 01992','RN',157358,43.57,0.49,3750,74207,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01992',0.37745,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157359,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157359,38.33,0.33,464,74208,70,NULL,NULL,'2MASX J22401382+1229146',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000171,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.0574583,12.48728,0.117,NULL,52586471477,821663616,12838494,18.2),(157360,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157360,36.03,NULL,161,74209,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2407',NULL,'2010Ap&SS.325..163P',2010,1,0.78,NULL,'G',0.00001,NULL,'16.5',0.11,'Sb',NULL,NULL,NULL,NULL,1,340.062416667,19.02586,0.293,NULL,52399083623,818735681,12792745,16.5),(157361,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157361,36.04,NULL,162,74209,NULL,NULL,'Dipole + Quadrupole','FGC 2407',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157362,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157362,36.06,NULL,163,74209,NULL,NULL,NULL,'FGC 2407',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157363,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157363,36.08,NULL,164,74209,NULL,NULL,'Dipole','FGC 2407',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157364,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157364,32.32,0.43,29.1,74210,75,NULL,'3.6 micron, color + selection bias corrected','II Zw 183',NULL,'2014MNRAS.444..527S',2014,1,2.2,NULL,'G',0.000017,NULL,'14.25',1.3,'SB(s)bc pec',NULL,NULL,NULL,NULL,1,340.063041667,-2.42406,0.165,NULL,49460517618,772820587,12075321,14.25),(157365,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157365,32.4,0.43,30.2,74210,75,NULL,'3.6 micron, color corrected','II Zw 183',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157366,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157366,32.41,0.69,30.3,74210,100,NULL,'mid-IR','II Zw 183',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157367,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157367,32.44,0.2,30.8,74210,74.4,NULL,NULL,'II Zw 183',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157368,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157368,32.51,0.58,31.8,74210,NULL,NULL,NULL,'II Zw 183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157369,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157369,32.62,0.55,33.5,74210,NULL,NULL,'Malmquist cor.','II Zw 183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157370,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157370,33.1,0.4,41.7,74210,NULL,NULL,'mean','II Zw 183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157371,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157371,33.15,0.47,42.7,74210,NULL,NULL,'H','II Zw 183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157372,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157372,33.23,0.46,44.3,74210,NULL,NULL,'J','II Zw 183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157373,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157373,33.28,0.45,45.3,74210,NULL,NULL,'K','II Zw 183',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157374,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438',NULL,157374,39.81,0.25,917,74211,70,NULL,'SN photometric redshift distance, z photo =0.243 +/- 0.034','SDSS-II SN 14438',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.065166667,-1.06933,0.145,NULL,49462071380,772844865,12075701,NULL),(157375,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438','R',157375,41.03,0.22,1240,74211,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14438',0.297526,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157376,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438','R',157376,41.07,0.14,1260,74211,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14438',0.297526,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157377,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438',NULL,157377,40.99,0.11,1580,74211,70,NULL,'SALT 2','SDSS-II SN 14438',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157378,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14438',NULL,157378,41.02,0.11,1600,74211,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14438',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157379,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 11675','RN',157379,40.04,0.31,941,74212,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11675',0.084408,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157380,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157380,36.86,0.33,235,74213,70,NULL,NULL,'2MASXi J2240163-002855',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000146,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,340.068125,-0.48203,0.189,NULL,49461500257,772835941,12075561,18),(157381,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157381,34.49,0.49,79.1,74214,75,NULL,'IR','UGC 12139',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000127,NULL,'15.46',0.2,'SB?',NULL,NULL,NULL,NULL,1,340.071875,8.56592,0.261,NULL,52477641459,819963147,12811924,15.46),(157382,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157382,36.82,0.19,231,74215,70,NULL,NULL,'SDSS J224018.33-002106.9',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000178,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,340.076417,-0.35192,0.189,NULL,49461531181,772836424,12075569,18),(157383,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157383,36.86,0.33,235,74216,70,NULL,NULL,'2MASX J22401926-0029375',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000156,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,340.080333333,-0.49381,0.189,NULL,49461501295,772835957,12075561,17),(157384,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157384,37.29,0.46,287,74217,70,NULL,NULL,'SDSS J224019.40-001407.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00013,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,340.080875,-0.23536,0.189,NULL,49461589264,772837332,12075583,17.9),(157385,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157385,35.72,0.58,139,74218,70,NULL,NULL,'2MASX J22402377-4631400',NULL,'2014MNRAS.445.2677S',2014,1,0.21,NULL,'G',0.00015,NULL,'15.6R',0.13,NULL,NULL,NULL,NULL,NULL,1,340.099167,-46.52778,0,NULL,50690827162,792044174,12375690,15.6),(157386,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157386,33.25,0.07,44.2,74219,72,NULL,NULL,'NGC 7329',0.010847,'2010AJ....139..120F',2010,1,3.9,'The APMUKS position is northeast of the nucleus.','G',0.000013,NULL,'12.1',2.6,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,340.100916667,-66.47897,0,NULL,49286694697,770104604,12032884,12.1),(157387,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157387,33.3,0.22,44.8,74219,72,NULL,NULL,'NGC 7329',0.0105,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157388,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157388,33.26,0.09,44.9,74219,74.4,NULL,NULL,'NGC 7329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157389,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157389,33.27,0.01,45.1,74219,72,NULL,NULL,'NGC 7329',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157390,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157390,33.33,0.24,45.8,74219,72,NULL,NULL,'NGC 7329',0.010847,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157391,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157391,33.38,0.25,46.9,74219,70,NULL,'SALT 2','NGC 7329',0.010847,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157392,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157392,33.38,0.06,47.3,74219,72,NULL,'M(H) = -18.317 mag','NGC 7329',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157393,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157393,33.43,0.21,48,74219,73.8,NULL,'SALT 2 (SNANA)','NGC 7329',0.0111,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157394,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006bh',NULL,157394,33.68,0.02,53.7,74219,70,NULL,NULL,'NGC 7329',0.010847,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157395,'Ring Diameter','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157395,31.6,0.84,21,74219,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7329',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157396,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157396,33.11,0.8,41.8,74219,75,NULL,'MAT, I','NGC 7329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157397,'Sosies','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157397,33.02,0.22,40.2,74219,NULL,NULL,NULL,'NGC 7329',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157398,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157398,33.06,0.43,40.8,74219,75,NULL,'MAT, I, raw','NGC 7329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157399,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157399,33.07,0.32,41.2,74219,85,NULL,'I, raw','NGC 7329',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157400,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157400,33.14,0.4,42.5,74219,NULL,NULL,'mean','NGC 7329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157401,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157401,33.15,0.32,42.6,74219,85,NULL,'I, inv','NGC 7329',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157402,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157402,33.17,0.43,43.1,74219,75,NULL,'MAT, I, cor','NGC 7329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157403,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157403,33.21,0.47,43.8,74219,NULL,NULL,'H','NGC 7329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157404,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157404,33.22,0.45,44.1,74219,NULL,NULL,'K','NGC 7329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157405,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157405,33.23,0.42,44.3,74219,NULL,18.48,'3.6 micron','NGC 7329',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157406,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157406,33.24,0.46,44.6,74219,NULL,NULL,'J','NGC 7329',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157407,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157407,33.26,0.09,44.9,74219,74.4,NULL,NULL,'NGC 7329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157408,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157408,33.26,0.4,44.9,74219,75,NULL,'HOSTS SN 2006bh','NGC 7329',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157409,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157409,33.35,0.43,46.9,74219,75,NULL,'MAT, I, inv','NGC 7329',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157410,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157410,33.41,0.43,48,74219,75,NULL,'3.6 micron, color corrected','NGC 7329',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157411,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157411,33.41,0.43,48.2,74219,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7329',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157412,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157412,35.11,0.8,105,74220,75,NULL,'W91PP, r','UGC 12143',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.94',0.6,'Sab',NULL,NULL,NULL,NULL,1,340.1067917,31.84164,0.365,NULL,55460870581,866576102,13540251,14.94),(157413,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157413,34.81,0.38,91.7,74220,75,NULL,'W91PP, r, raw','UGC 12143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157414,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157414,34.82,0.33,92.2,74220,NULL,NULL,NULL,'UGC 12143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157415,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157415,34.82,0.33,92.2,74220,NULL,NULL,'Malmquist cor.','UGC 12143',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157416,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157416,34.91,0.38,96,74220,75,NULL,'W91PP, r, cor','UGC 12143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157417,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157417,34.99,0.38,99.4,74220,75,NULL,'W91PP, r, inv','UGC 12143',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157418,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157418,35.09,0.2,104,74220,74.4,NULL,NULL,'UGC 12143',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157419,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157419,38.71,0.46,553,74221,70,NULL,NULL,'2MASX J22402713-0051575',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000162,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.113,-0.86589,0.169,NULL,49461972419,772843319,12075676,18.1),(157420,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157420,36.82,0.19,231,74222,70,NULL,NULL,'2MASX J22402811-0014575',NULL,'2015arXiv151105856S',2015,1,0.61,NULL,'G',0.00015,NULL,'15.6g',0.46,'E0',NULL,NULL,NULL,NULL,1,340.117,-0.24939,0.189,NULL,49461577823,772837153,12075580,15.6),(157421,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 00708','RN',157421,40.12,0.17,871,74223,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00708',0.21436,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157422,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157422,35.11,0.4,105,74224,NULL,NULL,'mean','UGC 12140',NULL,'2007A&A...465...71T',2007,1,1,'UGC Dec (+15 41) is incorrect.','G',0.000017,NULL,'15.08',0.4,'Sa','Isolated galaxy',NULL,NULL,NULL,1,340.119167,16.01078,0.201,NULL,52592352581,821755509,12839929,15.08),(157423,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157423,35.35,0.47,118,74224,NULL,NULL,'H','UGC 12140',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157424,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 05801','RN',157424,38.48,0.19,440,74225,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05801',0.127005,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157425,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157425,37.57,0.46,326,74226,70,NULL,NULL,'2MASX J22402912+1437496',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,340.1214583,14.63053,0.173,NULL,52592890026,821763906,12840061,17.4),(157426,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 14339','RN',157426,42.47,0.24,1980,74227,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14339',0.57678,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157427,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 01113','RN',157427,38.51,0.06,476,74228,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01113',0.056915,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157428,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 01113','RN',157428,38.94,0.19,582,74228,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01113',0.056915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157429,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157429,33.14,0.67,42.4,74229,NULL,NULL,NULL,'UGC 12144',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.04',0.8,'SB(s)b',NULL,NULL,NULL,NULL,1,340.1402917,33.46644,0.353,NULL,55463082858,866610669,13540791,15.04),(157430,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157430,33.41,0.59,48.1,74229,NULL,NULL,'Malmquist cor.','UGC 12144',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157431,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157431,36.64,0.17,213,74230,70,NULL,NULL,'2MASX J22403493-0044004',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.2g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,340.145625,-0.73342,0.169,NULL,49461927393,772842615,12075665,16.2),(157432,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157432,31.9,0.49,24,74231,75,NULL,'IR','UGC 12154',NULL,'2011yCatp016004901K',2011,1,1.57,'UGC declination is 1 degree in error.','G',0.000067,NULL,'16.0',0.21,'Sb',NULL,NULL,NULL,NULL,1,340.1494583,72.86389,2.897,NULL,52802716793,825042449,12891288,16),(157433,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157433,34.64,0.2,84.7,74232,74.4,NULL,NULL,'NGC 7348',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.00021,NULL,'14.53',0.7,'Scd:',NULL,NULL,NULL,NULL,1,340.151167,11.90622,0.121,NULL,52455542821,819617856,12806529,14.53),(157434,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157434,34.8,0.59,91.3,74232,NULL,NULL,NULL,'NGC 7348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157435,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157435,34.89,0.56,94.9,74232,NULL,NULL,'Malmquist cor.','NGC 7348',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157436,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157436,26.85,0.07,2.23,74233,NULL,NULL,NULL,'ESO 468- G 020',NULL,'2014MNRAS.443.1281K',2014,1,2.1,NULL,'G',NULL,NULL,'17.3B',1.3,'E3: pec',NULL,NULL,NULL,NULL,1,340.1830417,-30.80006,0,0,50088889669,782638901,12228732,17.3),(157437,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157437,26.75,0.1,2.24,74233,74.4,NULL,NULL,'ESO 468- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157438,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157438,35.55,0.49,129,74234,75,NULL,'IR','UGC 12145',NULL,'2011yCatp016004901K',2011,1,1,'Springob et al. (2005ApJS..160..149S) give v= 6498 km/sec.','G',0.000033,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,340.19425,33.36658,0.353,NULL,55463100931,866610952,13540796,16),(157439,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157439,36.82,0.19,231,74235,70,NULL,NULL,'2MASX J22405105-0028282',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000186,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.212833333,-0.47467,0.201,NULL,49461520322,772836255,12075566,17.2),(157440,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157440,31.95,0.43,24.5,74236,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12160',NULL,'2014MNRAS.444..527S',2014,1,2.1,NULL,'G',0.00001,NULL,'15.5',1.7,'Scd:',NULL,NULL,NULL,NULL,1,340.2244583,75.16431,1.773,NULL,52799376381,824990255,12890472,15.5),(157441,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157441,32.05,0.2,25.7,74236,74.4,NULL,NULL,'UGC 12160',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157442,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157442,32.11,0.43,26.4,74236,75,NULL,'3.6 micron, color corrected','UGC 12160',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157443,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157443,32.81,0.8,36.5,74237,75,NULL,'MAT, I','ESO 289- G 048',NULL,'1997ApJS..109..333W',1997,1,1.81,NULL,'G',0.000022,NULL,'14.48',0.32,'SB(s)cd: sp',NULL,NULL,NULL,NULL,1,340.2370417,-45.66025,0,NULL,50692188014,792065437,12376022,14.48),(157444,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157444,32.73,0.8,35.2,74237,75,NULL,NULL,'ESO 289- G 048',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157445,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157445,32.29,0.32,28.7,74237,85,NULL,'I, inv','ESO 289- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157446,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157446,32.3,0.32,28.9,74237,85,NULL,'I, raw','ESO 289- G 048',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157447,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157447,32.49,0.4,31.5,74237,NULL,NULL,NULL,'ESO 289- G 048',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157448,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157448,32.49,0.4,31.5,74237,73,NULL,'opt','ESO 289- G 048',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157449,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157449,32.62,0.43,33.5,74237,75,NULL,'MAT, I, raw','ESO 289- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157450,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157450,32.63,0.43,33.5,74237,75,NULL,'MAT, I, inv','ESO 289- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157451,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157451,32.76,0.43,35.7,74237,75,NULL,'MAT, I, cor','ESO 289- G 048',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157452,'IRAS','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157452,35.86,0.8,148,74238,75,NULL,'W91PP, r','UGC 12146',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',NULL,NULL,'15.58',0.3,'Sbc',NULL,NULL,NULL,NULL,1,340.2385417,22.47633,0.137,NULL,52401806125,818778220,12793409,15.58),(157453,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157453,35.3,0.38,115,74238,75,NULL,'W91PP, r, raw','UGC 12146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157454,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157454,35.44,0.38,123,74238,75,NULL,'W91PP, r, inv','UGC 12146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157455,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157455,35.54,0.38,128,74238,75,NULL,'W91PP, r, cor','UGC 12146',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157456,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157456,35.6,0.49,132,74238,75,NULL,'IR','UGC 12146',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157457,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157457,36.99,0.46,250,74239,70,NULL,NULL,'2MASX J22405827-0049542',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,340.2427083,-0.83175,0.169,NULL,49461931144,772842674,12075666,16.5),(157458,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157458,35.3,0.51,115,74240,70,NULL,NULL,'2MASX J22405940-1247369',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.81',0.42,NULL,NULL,NULL,NULL,NULL,1,340.247417,-12.79375,0.217,NULL,50427214647,787925228,12311331,15.81),(157459,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157459,35.53,0.49,127,74241,75,NULL,'IR','FGC 2408',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000016,NULL,'16.5',0.08,'Sd',NULL,NULL,NULL,NULL,1,340.2599583,19.33669,0.249,NULL,52399176968,818737140,12792767,16.5),(157460,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157460,35.77,NULL,143,74241,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157461,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157461,35.79,NULL,144,74241,NULL,NULL,'Dipole + Quadrupole','FGC 2408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157462,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157462,35.81,NULL,146,74241,NULL,NULL,'Dipole','FGC 2408',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157463,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157463,35.9,NULL,152,74241,NULL,NULL,NULL,'FGC 2408',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157464,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21487','RN',157464,39.65,0.19,716,74242,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21487',0.189116,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157465,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21487','RN',157465,39.72,0.12,741,74242,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21487',0.189116,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157466,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21487','N',157466,39.42,0.08,766,74242,70,NULL,'SALT 2','SDSS-II SN 21487',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157467,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 21487','N',157467,39.43,0.08,769,74242,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21487',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157468,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15628','RN',157468,42.49,0.36,2170,74243,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15628',0.448918,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157469,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15628','RN',157469,42.56,0.37,2250,74243,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15628',0.448918,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157470,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15628','N',157470,42.47,0.25,3120,74243,70,NULL,'SALT 2','SDSS-II SN 15628',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157471,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 15628','N',157471,42.56,0.25,3250,74243,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15628',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157472,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157472,38.06,0.46,409,74244,70,NULL,NULL,'SDSS J224108.93+135521.3',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,340.28725,13.92258,0.117,NULL,52593149404,821767959,12840124,18.4),(157473,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157473,37.81,0.46,364,74245,70,NULL,NULL,'2MASX J22410960-0757445',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000201,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,340.29,-7.96242,0.117,NULL,50398611430,787478303,12304348,16.7),(157474,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157474,37.93,0.46,385,74246,70,NULL,NULL,'2MASX J22410993-0857575',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000161,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.291417,-8.966,0.141,NULL,50384704602,787261009,12300953,18.1),(157475,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157475,34.25,0.2,70.8,74247,74.4,NULL,NULL,'KUG 2238+130',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000093,NULL,'15.4g',0.3,'Sa','Isolated galaxy',NULL,NULL,NULL,1,340.294375,13.33989,0.117,NULL,52587198557,821674977,12838671,15.4),(157476,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157476,34.25,0.38,70.9,74247,NULL,NULL,'Malmquist cor.','KUG 2238+130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157477,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157477,34.31,0.37,72.8,74247,NULL,NULL,NULL,'KUG 2238+130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157478,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157478,33.32,0.2,46.1,74248,74.4,NULL,NULL,'NGC 7349',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'14.92',0.5,'SBb pec?','Field galaxy',NULL,NULL,NULL,1,340.312083,-21.7985,0.045,NULL,50258066949,785282296,12270035,14.92),(157479,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157479,33.63,0.56,53.3,74248,NULL,NULL,NULL,'NGC 7349',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157480,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157480,33.64,0.56,53.4,74248,NULL,NULL,'Malmquist cor.','NGC 7349',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157481,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157481,33.99,0.49,62.7,74248,75,NULL,'IR','NGC 7349',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157482,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157482,38.29,0.46,454,74249,70,NULL,NULL,'2MASX J22411587-0912410',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000191,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.316083333,-9.21128,0.149,NULL,50384686584,787260727,12300948,17.8),(157483,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157483,37.27,0.46,284,74250,70,NULL,NULL,'2MASX J22411875+1444443',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,340.32825,14.74564,0.161,NULL,52592813412,821762709,12840042,17),(157484,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157484,36.82,0.19,231,74251,70,NULL,NULL,'2MASX J22412021-0031570',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,340.3342917,-0.53258,0.201,NULL,49472968405,773015131,12078361,16.9),(157485,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157485,38,0.23,399,74252,70,NULL,NULL,'2MASX J22412310+1233063',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000163,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.346333,12.55175,0.109,NULL,52587590535,821681102,12838767,18.1),(157486,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157486,37.35,0.46,295,74253,70,NULL,NULL,'2MASX J22412451-0819450',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000169,NULL,'17.0g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.35225,-8.32914,0.121,NULL,50397867275,787466676,12304166,17),(157487,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157487,38.1,0.46,416,74254,70,NULL,NULL,'SDSS J224124.91-101013.9',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000175,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,340.353833,-10.17053,0.193,NULL,50354220585,786784696,12293510,18.9),(157488,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157488,35.33,0.7,116,74255,70,NULL,NULL,'IC 5236',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.00015,NULL,'15.46',0.48,'S0^0',NULL,NULL,NULL,NULL,1,340.375583,-66.618,0,NULL,49286488293,770101379,12032834,15.46),(157489,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157489,38,0.23,399,74256,70,NULL,NULL,'2MASX J22413074+1238193',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000179,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.3782083,12.63878,0.109,NULL,52587537051,821680266,12838754,17.7),(157490,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157490,38,0.23,399,74257,70,NULL,NULL,'2MASX J22413184+1234503',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000185,NULL,'16.4g',0.36,'BrClG',NULL,NULL,NULL,NULL,1,340.38275,12.58058,0.109,NULL,52587582743,821680980,12838765,16.4),(157491,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157491,38,0.23,399,74258,70,NULL,NULL,'2MASX J22413361+1236423',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,340.390125,12.61161,0.109,NULL,52587585269,821681019,12838765,17.5),(157492,'Tully est','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157492,31.89,0.8,23.8,74259,75,NULL,NULL,'UGC 12151',NULL,'1988NBGC.C....0000T',1988,1,2.9,NULL,'G',0.000015,NULL,'14',2.2,'IB(s)m:',NULL,NULL,NULL,NULL,1,340.391125,0.40083,0.193,NULL,51688733400,807636459,12619319,14),(157493,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157493,34.34,NULL,73.8,74260,NULL,NULL,'B','ESO 147- G 005',NULL,'2004ApJ...607..241R',2004,1,1.5,NULL,'G',0.000033,NULL,'13.96',1,'SAB(rs)bc',NULL,NULL,NULL,NULL,1,340.402875,-57.60586,0,NULL,48846653119,763228954,11925452,13.96),(157494,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157494,34.56,NULL,81.7,74260,NULL,NULL,'I','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157495,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157495,34.65,NULL,85.1,74260,NULL,NULL,'B','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157496,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157496,34.65,NULL,85.1,74260,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 005',NULL,'2005Ap&SS.299..405R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157497,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157497,34.65,0.91,85.1,74260,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 005',NULL,'2005Ap&SS.299..387R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157498,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157498,34.65,NULL,85.1,74260,NULL,NULL,'B','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157499,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157499,34.65,NULL,85.1,74260,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157500,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157500,34.65,0.91,85.1,74260,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157501,'Tully-Fisher','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157501,34.65,NULL,85.1,74260,NULL,NULL,'I','ESO 147- G 005',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157502,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157502,36.28,0.46,180,74261,70,NULL,NULL,'2MASX J22413910+0112307',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.413083,1.20853,0.201,NULL,51689270783,807644855,12619450,17.5),(157503,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157503,37.87,0.33,375,74262,70,NULL,NULL,'2MASX J22414057-0049426',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,340.4192083,-0.82858,0.189,NULL,49473789060,773027954,12078561,17.3),(157504,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157504,36.94,0.07,219,74263,72,NULL,NULL,'SDSS J224142.04-000812.9',0.05668,'2013ApJ...773...53F',2013,1,0.18,NULL,'G',0.000177,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,340.4252083,-0.13694,0.173,NULL,49472876141,773013689,12078338,18.5),(157505,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157505,36.84,0.14,220,74263,72,NULL,NULL,'SDSS J224142.04-000812.9',0.0579,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157506,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py','R',157506,36.73,0.11,222,74263,NULL,NULL,'MLCS2k2, R(V) = 3.1','SDSS J224142.04-000812.9',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157507,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157507,36.88,0.02,225,74263,72,NULL,NULL,'SDSS J224142.04-000812.9',0.0579,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157508,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157508,36.79,0.03,228,74263,72,NULL,NULL,'SDSS J224142.04-000812.9',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157509,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157509,36.94,0.15,231,74263,70,NULL,'SALT 2','SDSS J224142.04-000812.9',0.0579,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157510,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py','R',157510,36.83,0.1,232,74263,NULL,NULL,'MLCS2k2, R(V) = 1.8','SDSS J224142.04-000812.9',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157511,'SNIa','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SN 2006py',NULL,157511,36.98,0.13,235,74263,73.8,NULL,'SALT 2 (SNANA)','SDSS J224142.04-000812.9',0.0568,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157512,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157512,35.76,0.76,142,74264,70,NULL,NULL,'ESO 147- G 005 NOTES01',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00005,NULL,'16.79',0.18,NULL,NULL,NULL,NULL,NULL,1,340.43975,-57.60094,0,NULL,48846652930,763228952,11925452,16.79),(157513,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157513,37.87,0.33,375,74265,70,NULL,NULL,'2MASX J22414831-0047486',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,340.4512083,-0.79675,0.189,NULL,49473836210,773028690,12078573,17.4),(157514,'FP','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157514,37.6,0.46,331,74266,70,NULL,NULL,'SDSS J224148.39+130746.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000151,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,340.451667,13.12953,0.117,NULL,52587343947,821677249,12838707,18.6),(157515,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157515,24.72,0.2,0.879,74267,NULL,NULL,'CMD','Tucana Dwarf',NULL,'1996A&A...310..715C',1996,1,2.9,'V= -135 km/sec probably caused by Local HI. See (2002A&A...389..812K)','G',0.000014,NULL,'15.7',1.2,'dE4',NULL,NULL,NULL,NULL,1,340.456667,-64.41944,0,0,48761051299,761891426,11904553,15.7),(157516,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157516,24.73,NULL,0.883,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157517,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157517,24.75,NULL,0.9,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1992AJ....103...81L',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157518,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157518,24.8,0.2,0.91,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1994ESOC...49..221D',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157519,'CMD','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157519,24.85,0.1,0.933,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1996ASPC...98..433L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157520,'Horizontal Branch','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157520,24.66,0.13,0.855,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157521,'RR Lyrae','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157521,24.66,0.09,0.855,74267,NULL,NULL,'V','Tucana Dwarf',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157522,'RR Lyrae','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,'R',157522,24.7,0.1,0.871,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1996AAS...188.0903L',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157523,'RR Lyrae','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157523,24.74,0.12,0.89,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'2009ApJ...699.1742B',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157524,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157524,24.69,0.16,0.87,74267,NULL,NULL,'I','Tucana Dwarf',NULL,'1996A&A...315...40S',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157525,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157525,24.72,NULL,0.88,74267,NULL,NULL,NULL,'Tucana Dwarf',NULL,'1996AJ....112.1969O',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157526,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157526,24.76,0.06,0.9,74267,74.4,NULL,NULL,'Tucana Dwarf',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157527,'TRGB','2016-12-15 15:16:01','2016-12-16 11:21:18','1',NULL,NULL,157527,24.81,0.04,0.916,74267,NULL,NULL,'I','Tucana Dwarf',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157528,'SNIa SDSS','2016-12-15 15:16:01','2016-12-16 11:21:18','1','SDSS-II SN 18251','RN',157528,41.2,0.26,1460,74268,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18251',0.19134,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157529,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 18251','RN',157529,41.91,0.27,2020,74268,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18251',0.19134,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157530,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157530,37.81,0.33,365,74269,70,NULL,NULL,'SDSS J224151.18-082619.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,340.463291667,-8.43875,0.129,NULL,50397857454,787466522,12304164,18.1),(157531,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157531,37.81,0.33,365,74270,70,NULL,NULL,'2MASX J22415184-0828476',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000151,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,340.465958333,-8.47992,0.137,NULL,50397856644,787466510,12304164,18),(157532,'Ring Diameter','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157532,31.4,0.84,19,74271,NULL,NULL,'Published at H = 100 km/s/Mpc','IC 5240',NULL,'1981ApJS...45..541P',1981,1,2.8,NULL,'G',0.000024,NULL,'12.78',1.9,'SB(r)ab',NULL,NULL,NULL,NULL,1,340.46825,-44.76717,0,NULL,50691878229,792060597,12375946,12.78),(157533,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157533,31.65,0.8,21.4,74271,75,NULL,'B','IC 5240',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157534,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157534,31.98,0.4,24.9,74271,NULL,NULL,'mean','IC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157535,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157535,32.1,0.45,26.3,74271,NULL,NULL,'K','IC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157536,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157536,32.16,0.47,27,74271,NULL,NULL,'H','IC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157537,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157537,32.17,0.46,27.2,74271,NULL,NULL,'J','IC 5240',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157538,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157538,38.27,0.46,452,74272,70,NULL,NULL,'2MASX J22415324-0050496',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000162,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.471875,-0.847,0.181,NULL,49473841861,773028779,12078574,18.2),(157539,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157539,34.2,0.46,69.2,74273,NULL,NULL,'J','UGC 12157',NULL,'2007A&A...465...71T',2007,1,1.58,NULL,'G',0.000093,NULL,'15.5',0.33,'Irregular',NULL,NULL,NULL,NULL,1,340.473833,34.91978,0.277,NULL,55464061900,866625967,13541030,15.5),(157540,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157540,34.28,0.47,71.8,74273,NULL,NULL,'H','UGC 12157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157541,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157541,34.4,0.45,75.9,74273,NULL,NULL,'K','UGC 12157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157542,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157542,34.78,0.4,90.2,74273,NULL,NULL,'mean','UGC 12157',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157543,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157543,36.33,0.56,185,74274,70,NULL,NULL,'2MASX J22415433-5709082',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000103,NULL,'15.88',0.52,'S0',NULL,NULL,NULL,NULL,1,340.4765,-57.15231,0,NULL,48846122692,763220667,11925322,15.88),(157544,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 00799','RN',157544,41.42,0.24,1670,74275,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 00799',0.147804,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157545,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 00799','RN',157545,41.9,0.31,2090,74275,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00799',0.147804,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157546,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157546,34.93,0.8,96.9,74276,75,NULL,'W91PP, r','NGC 7356',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.85',0.5,'Sbc',NULL,NULL,NULL,NULL,1,340.5097917,30.70881,0.285,NULL,51916411143,811193924,12674905,14.85),(157547,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157547,34.94,0.8,97.4,74276,75,NULL,'CF, r','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157548,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157548,35.06,0.38,103,74276,75,NULL,'W91PP, r, raw','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157549,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157549,35.09,0.4,104,74276,NULL,NULL,'mean','NGC 7356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157550,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157550,35.12,0.38,105,74276,75,NULL,'W91PP, r, cor','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157551,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157551,35.31,0.47,115,74276,NULL,NULL,'H','NGC 7356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157552,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157552,35.33,0.39,116,74276,NULL,NULL,'Malmquist cor.','NGC 7356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157553,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157553,35.33,0.38,117,74276,75,NULL,'W91PP, r, inv','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157554,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157554,35.34,0.46,117,74276,NULL,NULL,'J','NGC 7356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157555,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157555,35.47,0.45,124,74276,NULL,NULL,'K','NGC 7356',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157556,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157556,35.63,0.38,134,74276,75,NULL,'CF, r, raw','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157557,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157557,35.72,0.2,139,74276,74.4,NULL,NULL,'NGC 7356',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157558,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157558,35.74,0.33,141,74276,NULL,NULL,NULL,'NGC 7356',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157559,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157559,35.82,0.38,146,74276,75,NULL,'CF, r, cor','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157560,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157560,35.9,0.38,151,74276,75,NULL,'CF, r, inv','NGC 7356',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157561,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157561,34.29,0.4,72.2,74277,NULL,NULL,'mean','MCG -01-57-023',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000047,NULL,'15.08',0.8,'(R)SB(r)a?',NULL,NULL,NULL,NULL,1,340.5222083,-2.78297,0.109,NULL,49474148381,773033568,12078649,15.08),(157562,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157562,34.48,0.47,78.7,74277,NULL,NULL,'H','MCG -01-57-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157563,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157563,34.56,0.45,81.6,74277,NULL,NULL,'K','MCG -01-57-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157564,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157564,34.63,0.46,84.3,74277,NULL,NULL,'J','MCG -01-57-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157565,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157565,37.52,0.33,319,74278,70,NULL,NULL,'2MASX J22420637-0753536',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.00015,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,340.5264583,-7.89825,0.105,NULL,50398716656,787479947,12304374,16),(157566,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157566,37.42,0.33,304,74279,70,NULL,NULL,'2MASX J22420935+0052441',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.538875,0.879,0.197,NULL,51689408411,807647006,12619484,17.9),(157567,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157567,34.78,0.21,87.6,74280,74.2,NULL,'SALT 2','UGC 12158',0.030985,'2010ApJ...716..712A',2010,1,1.2,NULL,'G',0.000017,NULL,'14.75',1.1,'Sb',NULL,NULL,NULL,NULL,1,340.5437917,19.99697,0.193,NULL,52396936834,818702138,12792220,14.75),(157568,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157568,35.48,0.12,118,74280,72,NULL,NULL,'UGC 12158',0.02979,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157569,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157569,35.37,0.01,119,74280,72,NULL,NULL,'UGC 12158',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157570,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157570,35.38,0.09,119,74280,74.4,NULL,NULL,'UGC 12158',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157571,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157571,35.46,0.15,120,74280,70,NULL,'SALT 2','UGC 12158',0.030985,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157572,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157572,35.46,0.03,120,74280,72,NULL,NULL,'UGC 12158',0.030985,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157573,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157573,35.49,0.25,122,74280,73.8,NULL,'SALT 2 (SNANA)','UGC 12158',0.0298,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157574,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157574,35.5,0.14,122,74280,72,NULL,NULL,'UGC 12158',0.030985,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157575,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157575,35.53,0.19,124,74280,73.8,NULL,'SALT 2 (SNANA)','UGC 12158',0.0298,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157576,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef',NULL,157576,35.53,0.13,127,74280,72,NULL,'M(H) = -18.317 mag','UGC 12158',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157577,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef','R',157577,35.52,0.05,127,74280,NULL,NULL,'MLCS2k2, R(V) = 3.1','UGC 12158',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157578,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2004ef','R',157578,35.55,0.05,129,74280,NULL,NULL,'MLCS2k2, R(V) = 1.8','UGC 12158',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157579,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157579,36.17,0.46,171,74281,70,NULL,NULL,'2MASX J22421075+0041271',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',NULL,NULL,'16.28',0.21,NULL,NULL,NULL,NULL,NULL,1,340.54475,0.69092,0.201,NULL,51688670615,807635478,12619304,16.28),(157580,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157580,38.15,0.46,427,74282,70,NULL,NULL,'2MASX J22421095+1301185',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,340.545583,13.02194,0.117,NULL,52588086197,821688846,12838888,17.9),(157581,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157581,35.51,0.49,127,74283,70,NULL,NULL,'ESO 076- G 021',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00011,NULL,'15.08',0.5,'(R\')SA(s)0/a',NULL,NULL,NULL,NULL,1,340.55225,-67.7855,0,NULL,49320029787,770625465,12041022,15.08),(157582,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157582,37.67,0.33,343,74284,70,NULL,NULL,'SDSS J224214.80-085948.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000161,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,340.5617083,-8.99681,0.141,NULL,50384624769,787259762,12300933,18.5),(157583,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157583,36.81,0.46,230,74285,70,NULL,NULL,'2MASX J22421719-0034165',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000182,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,340.571625,-0.57117,0.189,NULL,49473073756,773016777,12078387,17.3),(157584,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157584,31,0.8,15.9,74286,75,NULL,'MAT, I','NGC 7361',NULL,'1997ApJS..109..333W',1997,1,3.8,'The 2MASS position refers to a knot 10 arcsec northeast of the center.','G',0.00001,NULL,'12.92',1,'S(r)c:?','Isolated galaxy',NULL,NULL,NULL,1,340.574625,-30.05767,0,NULL,50088937360,782639646,12228744,12.92),(157585,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157585,31.02,0.8,16,74286,75,NULL,'A82, H','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157586,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157586,30.45,0.4,12.3,74286,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 7361',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157587,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157587,30.73,0.35,14,74286,NULL,NULL,NULL,'NGC 7361',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157588,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157588,30.82,0.32,14.6,74286,85,NULL,'I, raw','NGC 7361',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157589,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157589,30.82,0.32,14.6,74286,85,NULL,'I, inv','NGC 7361',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157590,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157590,30.98,0.39,15.7,74286,73,NULL,'opt','NGC 7361',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157591,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157591,31,0.4,15.9,74286,75,NULL,'B','NGC 7361',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157592,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157592,31.02,0.43,16,74286,75,NULL,'3.6 micron, color corrected','NGC 7361',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157593,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157593,31.04,0.43,16.2,74286,75,NULL,'MAT, I, raw','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157594,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157594,31.08,0.43,16.4,74286,75,NULL,'MAT, I, inv','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157595,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157595,31.08,0.2,16.4,74286,74.4,NULL,NULL,'NGC 7361',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157596,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157596,31.08,0.43,16.5,74286,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7361',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157597,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157597,31.16,0.47,17.1,74286,75,NULL,'A82, H, inv','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157598,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157598,31.23,0.39,17.6,74286,73,NULL,'IR','NGC 7361',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157599,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157599,31.23,0.4,17.6,74286,75,NULL,NULL,'NGC 7361',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157600,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157600,31.24,0.47,17.7,74286,75,NULL,'A82, H, raw','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157601,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157601,31.36,0.43,18.7,74286,75,NULL,'MAT, I, cor','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157602,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157602,31.54,0.46,20.3,74286,NULL,NULL,NULL,'NGC 7361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157603,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157603,31.61,0.47,20.9,74286,75,NULL,'A82, H, cor','NGC 7361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157604,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157604,31.73,0.42,22.2,74286,NULL,NULL,'Malmquist cor.','NGC 7361',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157605,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157605,31.86,0.49,23.5,74286,75,NULL,'IR','NGC 7361',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157606,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157606,36.94,0.46,245,74287,70,NULL,NULL,'2MASX J22421812-0041315',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.0g',0.24,NULL,NULL,NULL,NULL,NULL,1,340.575417,-0.69197,0.201,NULL,49472950036,773014844,12078356,17),(157607,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157607,37.74,0.27,353,74288,70,NULL,NULL,'2MASX J22421885-0032055',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.22',0.18,NULL,NULL,NULL,NULL,NULL,1,340.578625,-0.53497,0.189,NULL,49473120731,773017511,12078398,18.22),(157608,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157608,38.19,0.46,434,74289,70,NULL,NULL,'SDSS J224221.71+135558.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00017,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.5905,13.93292,0.113,NULL,52585458814,821647793,12838246,18.3),(157609,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157609,37.42,0.33,304,74290,70,NULL,NULL,'2MASX J22422288+0053481',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000172,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,340.59525,0.89672,0.197,NULL,51689407375,807646990,12619484,17.3),(157610,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157610,37.67,0.33,343,74291,70,NULL,NULL,'2MASX J22422391-0906563',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000201,NULL,'17.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.5995,-9.11567,0.141,NULL,50384821577,787262837,12300981,17.2),(157611,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157611,34.44,0.69,77.2,74292,100,NULL,'mid-IR','NGC 7357',NULL,'2013ApJ...771...88L',2013,1,1.5,NULL,'G',0.000033,NULL,'14.78',0.7,'Sb',NULL,NULL,NULL,NULL,1,340.59975,30.17136,0.277,NULL,51916718911,811198732,12674980,14.78),(157612,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157612,34.78,0.33,90.4,74292,NULL,NULL,NULL,'NGC 7357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157613,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157613,34.84,0.32,93,74292,NULL,NULL,'Malmquist cor.','NGC 7357',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157614,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157614,35.12,0.2,106,74292,74.4,NULL,NULL,'NGC 7357',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157615,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157615,37.17,0.46,272,74293,70,NULL,NULL,'2MASX J22422395+0113371',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',NULL,NULL,'16.67',0.32,NULL,NULL,NULL,NULL,NULL,1,340.59975,1.22692,0.205,NULL,51689230946,807644233,12619441,16.67),(157616,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157616,37.52,0.33,319,74294,70,NULL,NULL,'2MASX J22422481-0753163',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,340.603333,-7.88794,0.105,NULL,50398648878,787478888,12304357,17.2),(157617,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157617,38.24,0.46,444,74295,70,NULL,NULL,'2MASX J22422634+1400496',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,340.609875,14.01364,0.113,NULL,52593020933,821765952,12840093,17.5),(157618,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15358','RN',157618,41.59,0.23,1910,74296,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15358',0.089088,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157619,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15358','RN',157619,41.96,0.25,2260,74296,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15358',0.089088,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157620,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157620,35.05,0.47,102,74297,70,NULL,NULL,'MCG -02-57-028',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.39',0.2,'S0',NULL,NULL,NULL,NULL,1,340.6215,-11.4715,0.233,NULL,50353319386,786770615,12293290,15.39),(157621,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157621,37.49,0.46,315,74298,70,NULL,NULL,'2MASX J22423018+1242306',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,340.625875,12.70858,0.109,NULL,52588137747,821689652,12838900,17.7),(157622,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157622,37.36,0.27,296,74299,70,NULL,NULL,'2MASX J22423525+0107241',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000233,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,340.646833,1.12342,0.205,NULL,51689193740,807643652,12619432,16.5),(157623,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157623,38.3,0.46,458,74300,70,NULL,NULL,'2MASX J22423702+1443425',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000165,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,340.6542917,14.72861,0.201,NULL,52593335868,821770872,12840169,17.4),(157624,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 09600','RN',157624,40.4,0.53,1140,74301,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09600',0.057815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157625,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157625,37.36,0.27,296,74302,70,NULL,NULL,'SDSS J224238.68+010843.5',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000206,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,340.661167,1.14544,0.205,NULL,51689195202,807643675,12619432,16.5),(157626,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157626,35.12,0.4,106,74303,NULL,NULL,'mean','UGC 12163',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000067,NULL,'14.55',0.4,'SB;NLSy1       Sy1.8',NULL,NULL,NULL,'LINER',1,340.6639583,29.72536,0.273,NULL,51933088235,811454503,12678976,14.55),(157627,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157627,35.26,0.45,113,74303,NULL,NULL,'K','UGC 12163',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157628,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10297','R',157628,40.22,0.14,963,74304,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2005mk','SN 2005mk',0.148293,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,340.669333,0.83303,0.197,NULL,51689504582,807648509,12619507,NULL),(157629,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10297','R',157629,41.04,0.23,1410,74304,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2005mk','SN 2005mk',0.148293,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157630,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10441','RN',157630,41.88,0.23,1690,74305,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 10441',0.408915,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157631,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10441','RN',157631,42.68,0.24,2430,74305,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10441',0.408915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157632,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157632,37.74,0.27,353,74306,70,NULL,NULL,'2MASX J22424385-0034515',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000168,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,340.6827917,-0.58106,0.189,NULL,49473048127,773016376,12078380,17.9),(157633,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 00875','RN',157633,38.2,0.24,395,74307,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00875',0.105389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157634,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006la',NULL,157634,38.98,0.06,625,74308,70,NULL,'Hubble residual 0.45 for z0.12670','SDSS J224248.34-005406.3',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'20.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,340.701417,-0.90178,0.169,NULL,49473906747,773029792,12078590,20.5),(157635,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15459','R',157635,39.38,0.18,668,74308,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006la','SDSS J224248.34-005406.3',0.1267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157636,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15459','R',157636,39.49,0.09,701,74308,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006la','SDSS J224248.34-005406.3',0.1267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157637,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006la',NULL,157637,39.26,0.07,711,74308,70,NULL,'SALT 2','SDSS J224248.34-005406.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157638,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006la',NULL,157638,39.26,0.07,711,74308,70,NULL,'SALT 2, Malmquist cor.','SDSS J224248.34-005406.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157639,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157639,34.64,0.8,84.7,74309,75,NULL,'W91PP, r','UGC 12165',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000024,NULL,'15.76',0.18,'Sbc',NULL,NULL,NULL,NULL,1,340.7077917,32.99364,0.325,NULL,55462921717,866608151,13540752,15.76),(157640,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157640,34.27,0.43,71.3,74309,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12165',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157641,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157641,34.4,NULL,75.7,74309,NULL,NULL,NULL,'UGC 12165',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157642,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157642,34.42,0.43,76.6,74309,75,NULL,'3.6 micron, color corrected','UGC 12165',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157643,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157643,34.44,NULL,77.1,74309,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157644,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157644,34.46,NULL,78.1,74309,NULL,NULL,'Dipole + Quadrupole','UGC 12165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157645,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157645,34.48,NULL,78.7,74309,NULL,NULL,'Dipole','UGC 12165',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157646,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157646,34.5,0.49,79.3,74309,75,NULL,'IR','UGC 12165',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157647,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157647,34.59,0.38,82.9,74309,75,NULL,'W91PP, r, raw','UGC 12165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157648,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157648,34.6,0.2,83.2,74309,74.4,NULL,NULL,'UGC 12165',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157649,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157649,34.63,0.37,84.3,74309,NULL,NULL,NULL,'UGC 12165',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157650,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157650,34.7,0.38,87,74309,75,NULL,'W91PP, r, inv','UGC 12165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157651,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157651,34.73,0.35,88.3,74309,NULL,NULL,'Malmquist cor.','UGC 12165',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157652,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157652,34.77,0.38,90.1,74309,75,NULL,'W91PP, r, cor','UGC 12165',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157653,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157653,37.76,0.46,357,74310,70,NULL,NULL,'2MASX J22425022-0826192',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,340.709291667,-8.43864,0.129,NULL,50397948646,787467947,12304186,18.2),(157654,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157654,35.57,0.8,130,74311,75,NULL,'W91PP, r','UGC 12164',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.14',0.8,'Sb',NULL,NULL,NULL,NULL,1,340.709708333,30.50278,0.253,NULL,51916837852,811200591,12675009,15.14),(157655,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157655,35.46,0.38,124,74311,75,NULL,'W91PP, r, raw','UGC 12164',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157656,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157656,35.61,0.38,132,74311,75,NULL,'W91PP, r, cor','UGC 12164',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157657,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157657,35.74,0.38,141,74311,75,NULL,'W91PP, r, inv','UGC 12164',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157658,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157658,37.35,0.46,295,74312,70,NULL,NULL,'2MASX J22425128+1246050',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,340.7137083,12.76814,0.129,NULL,52588140798,821689699,12838901,17.3),(157659,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157659,37.59,0.63,330,74313,70,NULL,NULL,'MCG -02-57-029',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.0R',0.4,NULL,NULL,NULL,NULL,NULL,1,340.715667,-10.65897,0.169,NULL,50352945195,786764768,12293199,15),(157660,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13329',NULL,157660,40.47,0.12,1240,74314,70,NULL,'SN photometric redshift distance, z photo =0.347 +/- 0.024','SDSS-II SN 13329',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.720125,-0.10853,0.193,NULL,49468898439,772951538,12077367,NULL),(157661,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157661,37.36,0.27,296,74315,70,NULL,NULL,'2MASX J22425473+0102222',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,340.7279583,1.03947,0.205,NULL,51689532853,807648950,12619514,17.5),(157662,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157662,35.39,0.58,120,74316,70,NULL,NULL,'ESO 345- G 044',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'14.85',0.59,'Compact',NULL,NULL,NULL,NULL,1,340.728625,-42.047,0,NULL,50711532166,792367690,12380745,14.85),(157663,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157663,37.74,0.27,353,74317,70,NULL,NULL,'2MASX J22425571-0028485',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.732041667,-0.48031,0.189,NULL,49473021375,773015958,12078374,17.9),(157664,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157664,36.58,0.46,207,74318,70,NULL,NULL,'2MASX J22430264-0013515',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000183,NULL,'16.59',0.24,'BrClG',NULL,NULL,NULL,NULL,1,340.760833,-0.23108,0.173,NULL,49468931237,772952050,12077375,16.59),(157665,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20825',NULL,157665,38.66,1.06,539,74319,70,NULL,'SN photometric redshift distance, z photo =0.135 +/- 0.096','SDSS-II SN 20825',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.7882083,0.56578,0.201,NULL,51688627973,807634812,12619293,NULL),(157666,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157666,35.24,0.47,112,74320,70,NULL,NULL,'2MASX J22431065-0514187',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000067,NULL,'15.52',0.37,NULL,NULL,NULL,NULL,NULL,1,340.7945417,-5.23842,0.093,NULL,50343635720,786619308,12290926,15.52),(157667,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21494','R',157667,40.81,0.34,1050,74321,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21494',0.378652,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','21.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,340.795875,0.30425,0.209,NULL,51680374550,807505852,12617278,21.4),(157668,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21494','R',157668,41.49,0.46,1440,74321,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21494',0.378652,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157669,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21494',NULL,157669,41.5,0.09,1990,74321,70,NULL,'SN photometric redshift distance, z photo =0.655 +/- 0.045','SDSS-II SN 21494',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157670,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157670,34.79,0.7,90.9,74322,70,NULL,NULL,'ESO 345-IG 045 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.69',0.47,'E              Liner',NULL,NULL,NULL,NULL,1,340.8095,-40.04878,0,NULL,50713801551,792403149,12381299,15.69),(157671,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157671,36.97,0.21,247,74323,70,NULL,NULL,'2MASX J22431472+0024570',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',NULL,NULL,'16.3g',0.32,NULL,NULL,NULL,NULL,NULL,1,340.8112083,0.41583,0.201,NULL,51680270025,807504219,12617253,16.3),(157672,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157672,35.03,0.49,101,74324,NULL,NULL,'Malmquist cor.','FGC 2412',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000014,NULL,'16.7',0.1,'Sd',NULL,NULL,NULL,NULL,1,340.8114583,8.43278,0.241,NULL,52478232160,819972377,12812068,16.7),(157673,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157673,35.09,0.48,104,74324,NULL,NULL,NULL,'FGC 2412',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157674,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157674,35.19,0.2,109,74324,74.4,NULL,NULL,'FGC 2412',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157675,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157675,35.23,NULL,111,74324,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2412',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157676,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157676,35.26,NULL,113,74324,NULL,NULL,'Dipole','FGC 2412',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157677,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157677,35.26,NULL,113,74324,NULL,NULL,'Dipole + Quadrupole','FGC 2412',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157678,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157678,35.28,0.49,114,74324,75,NULL,'IR','FGC 2412',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157679,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157679,35.29,NULL,114,74324,NULL,NULL,NULL,'FGC 2412',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157680,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 09771','RN',157680,40.91,1.59,1350,74325,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09771',0.124932,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157681,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157681,37.94,0.46,387,74326,70,NULL,NULL,'2MASX J22431535+1234107',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,340.813833,12.56956,0.129,NULL,52587523053,821680047,12838750,17.2),(157682,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157682,32.14,0.8,26.7,74327,75,NULL,NULL,'ESO 345- G 046',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.00001,NULL,'13.21',2.3,'SA(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,340.8170417,-39.86636,0,NULL,50713679574,792401243,12381269,13.21),(157683,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17965',NULL,157683,39.93,0.29,966,74328,70,NULL,'SN photometric redshift distance, z photo =0.258 +/- 0.043','SDSS-II SN 17965',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.8235417,-0.75889,0.161,NULL,49473774392,773027724,12078558,NULL),(157684,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17965','R',157684,41.04,0.19,1220,74328,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17965',0.315534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157685,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17965','R',157685,41.36,0.31,1420,74328,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17965',0.315534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157686,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15674','R',157686,40.05,0.21,856,74329,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nu','SN 2006nu',0.198,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,340.829167,0.26292,0.209,NULL,51680323615,807505056,12617266,NULL),(157687,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15674','R',157687,40.26,0.12,943,74329,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nu','SN 2006nu',0.198,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157688,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13431','RN',157688,38.19,0.27,411,74330,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13431',0.057508,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157689,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13431','RN',157689,39.77,0.47,850,74330,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13431',0.057508,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157690,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157690,36.97,0.21,247,74331,70,NULL,NULL,'2MASX J22431965+0027320',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000204,NULL,'16.2g',0.4,'Sb-Sc',NULL,NULL,NULL,NULL,1,340.8320417,0.45892,0.201,NULL,51680310521,807504851,12617263,16.2),(157691,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157691,30.77,0.8,14.2,74332,75,NULL,'B','NGC 7363',NULL,'1988NBGC.C....0000T',1988,1,1.1,'UZC has V = 830 +- 20 km/sec.','G',0.000033,NULL,'14.38',1,'SAB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,340.8329583,34.0015,0.385,NULL,55462711292,866604863,13540700,14.38),(157692,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157692,36.97,0.21,247,74333,70,NULL,NULL,'2MASX J22432045+0031290',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000174,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.835167,0.52475,0.201,NULL,51680305945,807504780,12617262,18),(157693,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21185',NULL,157693,39.61,0.5,834,74334,70,NULL,'SN photometric redshift distance, z photo =0.218 +/- 0.067','SDSS-II SN 21185',NULL,'2011ApJ...738..162S',2011,1,0.11,NULL,'G',NULL,'PHOT','20.1g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.843791667,-0.71747,0.161,NULL,49473003788,773015684,12078370,20.1),(157694,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21185','R',157694,40.32,0.34,938,74334,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 21185',0.233935,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157695,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21185','R',157695,40.34,0.42,946,74334,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 21185',0.233935,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157696,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06742','RN',157696,40.98,0.16,1250,74335,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06742',0.259634,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157697,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06742','RN',157697,42.22,0.24,2210,74335,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06742',0.259634,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157698,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157698,38.51,0.46,504,74336,70,NULL,NULL,'SDSS J224324.90+135302.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,340.8537917,13.88414,0.137,NULL,52585974585,821655852,12838372,18.7),(157699,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157699,36.97,0.21,247,74337,70,NULL,NULL,'2MASX J22432592+0017550',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000188,NULL,'16.5g',0.3,NULL,NULL,NULL,NULL,NULL,1,340.858083,0.29864,0.209,NULL,51680326248,807505097,12617267,16.5),(157700,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743',NULL,157700,40.59,0.32,1310,74338,70,NULL,NULL,'SDSS-II SN 06743',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,340.8642917,-0.36669,0.173,NULL,49468756517,772949320,12077333,NULL),(157701,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743','R',157701,41.43,0.32,1420,74338,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06743',0.362142,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157702,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743','R',157702,41.71,0.32,1620,74338,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06743',0.362142,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157703,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743',NULL,157703,41.31,0.23,1830,74338,70,NULL,'SALT 2','SDSS-II SN 06743',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157704,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 06743',NULL,157704,41.36,0.23,1870,74338,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06743',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157705,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157705,36.97,0.21,247,74339,70,NULL,NULL,'2MASX J22432772+0014110',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000173,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,340.8655417,0.23644,0.209,NULL,51680325204,807505081,12617266,17.6),(157706,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157706,36.08,0.51,165,74340,70,NULL,NULL,'2MASX J22432812-8105025',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.4b',0.3,NULL,NULL,NULL,NULL,NULL,1,340.867083,-81.08406,0.405,NULL,48562703416,758792240,11856128,16.4),(157707,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157707,38.78,0.46,569,74341,70,NULL,NULL,'2MASX J22433193-0016306',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,340.8830417,-0.27506,0.193,NULL,49468881365,772951271,12077363,18),(157708,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157708,35.2,0.58,110,74342,70,NULL,NULL,'2MASX J22433372-2103504',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'15.84',0.57,'E','Field galaxy',NULL,NULL,NULL,1,340.890583,-21.06394,0.065,NULL,50219469767,784679215,12260612,15.84),(157709,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157709,34.31,0.5,72.9,74343,NULL,NULL,NULL,'ESO 238- G 023',NULL,'2009ApJS..182..474S',2009,1,1.01,NULL,'G',0.000033,NULL,'15.16',0.35,'S...',NULL,NULL,NULL,NULL,1,340.892625,-48.6445,0,NULL,50685204578,791956321,12374317,15.16),(157710,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157710,34.36,0.2,74.5,74343,74.4,NULL,NULL,'ESO 238- G 023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157711,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157711,34.36,0.49,74.6,74343,NULL,NULL,'Malmquist cor.','ESO 238- G 023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157712,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157712,36.13,0.8,168,74344,75,NULL,'W91PP, r','UGC 12169',NULL,'1997ApJS..109..333W',1997,1,1,'May contribute to the IRAS F22411+2340 flux.','G',0.000769,NULL,'15.55',0.3,'Sb',NULL,NULL,NULL,NULL,1,340.913167,23.94978,0.217,NULL,52383525489,818492585,12788946,15.55),(157713,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157713,35.69,0.43,137,74344,NULL,NULL,'Malmquist cor.','UGC 12169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157714,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157714,35.88,0.38,150,74344,75,NULL,'W91PP, r, raw','UGC 12169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157715,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157715,35.95,0.38,155,74344,NULL,NULL,NULL,'UGC 12169',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157716,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157716,36.11,0.38,166,74344,75,NULL,'W91PP, r, inv','UGC 12169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157717,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157717,36.14,0.38,169,74344,75,NULL,'W91PP, r, cor','UGC 12169',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157718,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157718,36.19,0.2,173,74344,74.4,NULL,NULL,'UGC 12169',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157719,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157719,35.29,0.49,114,74345,75,NULL,'IR','UGC 12168',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000834,NULL,'16.0',0.1,'S?',NULL,NULL,NULL,NULL,1,340.917125,6.12194,0.181,NULL,52473304277,819895379,12810865,16),(157720,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157720,35.65,0.5,135,74345,NULL,NULL,'Malmquist cor.','UGC 12168',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157721,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157721,35.76,0.47,142,74345,NULL,NULL,NULL,'UGC 12168',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157722,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157722,35.79,0.2,144,74345,74.4,NULL,NULL,'UGC 12168',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157723,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157723,36.69,0.71,218,74346,70,NULL,NULL,'2MASX J22434070-5417246',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000107,NULL,'17.01',0.15,'S',NULL,NULL,NULL,NULL,1,340.9195,-54.29042,0,NULL,48823043701,762860057,11919688,17.01),(157724,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2007lp',NULL,157724,39.31,0.08,728,74347,70,NULL,'Hubble residual 0.12 for z0.17610','SDSS J224340.96+002513.8',NULL,'2011ApJ...740...92G',2011,1,0.12,NULL,'G',0.0005,NULL,'19.5g',0.06,NULL,NULL,NULL,NULL,NULL,1,340.9207083,0.4205,0.209,NULL,51680293228,807504581,12617259,19.5),(157725,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 18604','R',157725,39.78,0.18,767,74347,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lp','SDSS J224340.96+002513.8',0.1761,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157726,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 18604','R',157726,39.89,0.08,808,74347,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lp','SDSS J224340.96+002513.8',0.1761,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157727,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2007lp',NULL,157727,39.59,0.08,828,74347,70,NULL,'SALT 2','SDSS J224340.96+002513.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157728,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2007lp',NULL,157728,39.6,0.08,832,74347,70,NULL,'SALT 2, Malmquist cor.','SDSS J224340.96+002513.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157729,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 08398','RN',157729,43.11,0.38,3960,74348,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08398',0.057154,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157730,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157730,35.57,0.52,130,74349,70,NULL,NULL,'FAIRALL 1025',NULL,'2014MNRAS.445.2677S',2014,1,1.02,NULL,'G',0.000113,NULL,'15.51',0.37,'S0',NULL,NULL,NULL,NULL,1,340.947,-48.88569,0,NULL,50685885014,791966953,12374483,15.51),(157731,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 11022','RN',157731,39.44,0.43,683,74350,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11022',0.131602,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157732,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 11022','RN',157732,40.3,1.31,1020,74350,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 11022',0.131602,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157733,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07431','R',157733,41.16,0.17,1270,74351,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07431',0.350266,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,340.954375,-0.275,0.193,NULL,49468836401,772950568,12077352,NULL),(157734,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07431','R',157734,41.19,0.24,1280,74351,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07431',0.350266,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157735,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157735,37.45,0.46,309,74352,70,NULL,NULL,'2MASX J22435018+1351084',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,340.959083,13.85239,0.137,NULL,52586052687,821657073,12838391,17.8),(157736,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157736,34.14,0.49,67.3,74353,75,NULL,'IR','2MFGC 17107',NULL,'2011yCatp016004901K',2011,1,0.87,NULL,'G',0.000897,NULL,'15.39',0.21,NULL,NULL,NULL,NULL,NULL,1,340.9615,35.91169,0.421,NULL,55449878276,866404348,13537567,15.39),(157737,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14445','R',157737,40.39,0.24,970,74354,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J224351.16-004516.2',0.2349,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.0002,NULL,'20.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,340.963208333,-0.75453,0.161,NULL,49473719780,773026871,12078544,20.4),(157738,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14445',NULL,157738,40.08,0.15,1040,74354,70,NULL,'SALT 2','SDSS J224351.16-004516.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157739,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14445',NULL,157739,40.1,0.15,1050,74354,70,NULL,'SALT 2, Malmquist cor.','SDSS J224351.16-004516.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157740,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14445','R',157740,40.88,0.19,1210,74354,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J224351.16-004516.2',0.2349,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157741,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19467',NULL,157741,38.66,1.31,539,74355,70,NULL,'SN photometric redshift distance, z photo =0.135 +/- 0.129','SDSS-II SN 19467',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,340.964916667,-0.97697,0.169,NULL,49473755361,773027427,12078553,NULL),(157742,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157742,35.15,0.54,107,74356,NULL,NULL,'Malmquist cor.','FGC 2413',NULL,'2009ApJS..182..474S',2009,1,0.63,NULL,'G',0.000012,NULL,'17.0',0.09,'Sd',NULL,NULL,NULL,NULL,1,340.965,8.43333,0.221,NULL,52476362295,819943160,12811611,17),(157743,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157743,35.2,0.53,110,74356,NULL,NULL,NULL,'FGC 2413',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157744,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157744,35.3,0.2,115,74356,74.4,NULL,NULL,'FGC 2413',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157745,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157745,35.61,NULL,132,74356,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157746,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157746,35.64,NULL,134,74356,NULL,NULL,'Dipole + Quadrupole','FGC 2413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157747,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157747,35.66,NULL,135,74356,NULL,NULL,'Dipole','FGC 2413',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157748,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157748,35.68,NULL,137,74356,NULL,NULL,NULL,'FGC 2413',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157749,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157749,36.82,0.46,232,74357,70,NULL,NULL,'2MASX J22435183-0835148',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000159,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,340.9660417,-8.5875,0.125,NULL,50397403386,787459427,12304053,16.9),(157750,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157750,33.95,0.8,61.8,74358,75,NULL,'CF, r','UGC 12173',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000017,NULL,'13.49',1.2,'SAB(rs)c','Isolated galaxy',NULL,NULL,NULL,1,340.96675,38.37686,0.489,NULL,55530097232,867657769,13557152,13.49),(157751,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157751,33.23,0.69,44.2,74358,100,NULL,'mid-IR','UGC 12173',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157752,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157752,33.71,0.43,55.3,74358,75,NULL,'3.6 micron, color corrected','UGC 12173',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157753,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157753,33.72,0.47,55.5,74358,NULL,NULL,'H','UGC 12173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157754,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157754,33.73,0.46,55.8,74358,NULL,NULL,'J','UGC 12173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157755,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157755,33.75,0.2,56.2,74358,74.4,NULL,NULL,'UGC 12173',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157756,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157756,33.78,0.45,57.1,74358,NULL,NULL,'K','UGC 12173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157757,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157757,33.82,0.43,58,74358,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12173',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157758,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157758,33.83,0.38,58.3,74358,75,NULL,'CF, r, raw','UGC 12173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157759,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157759,34,0.38,63.1,74358,75,NULL,'CF, r, inv','UGC 12173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157760,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157760,34.02,0.33,63.7,74358,NULL,NULL,NULL,'UGC 12173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157761,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157761,34.06,0.4,64.8,74358,NULL,NULL,'mean','UGC 12173',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157762,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157762,34.14,0.38,67.2,74358,75,NULL,'CF, r, cor','UGC 12173',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157763,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157763,34.19,0.3,68.9,74358,NULL,NULL,'Malmquist cor.','UGC 12173',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157764,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157764,34.93,0.8,96.9,74359,75,NULL,'CF, r','UGC 12172',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.15',0.5,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,340.9872917,7.39058,0.245,NULL,52478610658,819978291,12812160,15.15),(157765,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157765,34.89,0.2,95.1,74359,74.4,NULL,NULL,'UGC 12172',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157766,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157766,34.94,0.48,97.1,74359,NULL,NULL,'Malmquist cor.','UGC 12172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157767,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157767,34.95,0.47,97.9,74359,NULL,NULL,NULL,'UGC 12172',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157768,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157768,34.99,0.38,99.4,74359,75,NULL,'CF, r, raw','UGC 12172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157769,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157769,35.15,0.38,107,74359,75,NULL,'CF, r, inv','UGC 12172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157770,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157770,35.27,0.38,113,74359,75,NULL,'CF, r, cor','UGC 12172',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157771,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157771,36.81,0.46,230,74360,70,NULL,NULL,'2MASX J22435699+0100019',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000192,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,340.987333,1.0005,0.201,NULL,51688945744,807639777,12619371,16.2),(157772,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157772,34.87,0.49,94.3,74361,75,NULL,'IR','ESO 468- G 025',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.17',0.3,'Sb:',NULL,NULL,NULL,NULL,1,341.001083333,-27.23964,0,NULL,50126875343,783232427,12238006,15.17),(157773,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157773,35.15,0.39,107,74361,NULL,NULL,NULL,'ESO 468- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157774,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157774,35.19,0.2,109,74361,74.4,NULL,NULL,'ESO 468- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157775,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157775,35.23,0.38,111,74361,NULL,NULL,'Malmquist cor.','ESO 468- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157776,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157776,37.07,0.46,260,74362,70,NULL,NULL,'2MASX J22440383-0043502',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000145,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.015833,-0.73064,0.189,NULL,49469063878,772954123,12077408,17.7),(157777,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157777,37.34,0.46,294,74363,70,NULL,NULL,'2MASX J22440446+1435594',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000152,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,341.018625,14.59989,0.129,NULL,52592600507,821759382,12839990,17.3),(157778,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157778,36.31,0.69,183,74364,70,NULL,NULL,'2MASX J22440893-4607136',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'17.08',0.32,NULL,NULL,NULL,NULL,NULL,1,341.0372917,-46.12044,0,NULL,50690602840,792040669,12375635,17.08),(157779,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157779,38.36,0.33,469,74365,70,NULL,NULL,'SDSS J224411.34-003140.5',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000137,NULL,'18.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,341.04725,-0.52792,0.189,NULL,49469626350,772962911,12077545,18.9),(157780,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157780,37,0.72,251,74366,70,NULL,NULL,'2MASX J22441302-1810389',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.09',0.36,NULL,NULL,NULL,NULL,NULL,1,341.054333,-18.17742,0.097,NULL,50218417880,784662779,12260355,17.09),(157781,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1994an',NULL,157781,40.88,0.44,1090,74367,74.2,NULL,'SALT 2','[PDG95] J224418.86+000648.5',0.378,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,'Scd',NULL,NULL,NULL,NULL,1,341.078583,0.11347,0.209,NULL,51681048897,807516389,12617443,NULL),(157782,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1994an',NULL,157782,41.87,0.31,1720,74367,70,NULL,'SALT','[PDG95] J224418.86+000648.5',0.378,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157783,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20858','RN',157783,40.36,0.2,1070,74368,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20858',0.106605,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157784,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20858','RN',157784,40.89,0.34,1360,74368,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20858',0.106605,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157785,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157785,37.22,0.46,278,74369,70,NULL,NULL,'2MASX J22442291-0901095',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,341.095417,-9.01942,0.157,NULL,50383342262,787239722,12300620,16.4),(157786,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157786,36.43,0.46,193,74370,70,NULL,NULL,'2MASX J22442370-0053042',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.3g',0.24,'E0',NULL,NULL,NULL,NULL,1,341.098875,-0.88444,0.161,NULL,49473465828,773022903,12078482,16.3),(157787,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157787,37.64,0.46,337,74371,70,NULL,NULL,'SDSS J224424.00-083822.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,341.1,-8.63947,0.145,NULL,50397431236,787459863,12304060,18.2),(157788,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15475','R',157788,34.48,0.05,77.6,74372,70,NULL,'SDSS CAND. SNIc; MLCS2K2; SN 2006lc','NGC 7364',0.016228,'2014arXiv1401.3317S',2014,1,1.5,NULL,'G',0.000017,NULL,'13.4g',0.95,'S0/a pec:',NULL,NULL,NULL,NULL,1,341.1015417,-0.16208,0.201,NULL,49469533051,772961453,12077522,13.4),(157789,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15475','R',157789,35.26,0.25,111,74372,70,NULL,'SDSS CAND. SNIc; SALT 2; SN 2006lc','NGC 7364',0.016228,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157790,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157790,33.4,0.69,48,74372,100,NULL,'mid-IR','NGC 7364',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157791,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157791,33.86,0.45,59.2,74372,NULL,NULL,'Malmquist cor.','NGC 7364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157792,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157792,33.88,0.44,59.6,74372,NULL,NULL,NULL,'NGC 7364',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157793,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157793,34.17,0.2,68.2,74372,74.4,NULL,NULL,'NGC 7364',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157794,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07040','RN',157794,38.31,0.31,407,74373,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07040',0.127524,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157795,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07040','RN',157795,40.13,0.43,941,74373,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07040',0.127524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157796,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157796,37.14,0.46,268,74374,70,NULL,NULL,'2MASX J22442704-0812445',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000177,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,341.112833,-8.2125,0.109,NULL,50397505788,787461027,12304078,16.9),(157797,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157797,37.74,0.46,353,74375,70,NULL,NULL,'2MASX J22443065+1238379',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,341.1277917,12.64397,0.137,NULL,52584323124,821630048,12837969,18.1),(157798,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17973','RN',157798,39.08,0.18,569,74376,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17973',0.148001,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157799,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17973','RN',157799,39.18,0.13,598,74376,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 17973',0.148001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157800,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157800,34.35,0.47,74.2,74377,NULL,NULL,'H','NGC 7367',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000033,NULL,'14.67',0.4,'Sab:           AGN?','Isolated galaxy',NULL,NULL,NULL,1,341.1435417,3.64639,0.173,NULL,51683871753,807560496,12618132,14.67);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (157801,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157801,34.41,0.46,76.1,74377,NULL,NULL,'J','NGC 7367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157802,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157802,34.42,0.45,76.7,74377,NULL,NULL,'K','NGC 7367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157803,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157803,34.47,0.49,78.4,74377,75,NULL,'IR','NGC 7367',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157804,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157804,34.73,0.4,88.4,74377,NULL,NULL,'mean','NGC 7367',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157805,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05151','RN',157805,39.76,0.22,771,74378,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05151',0.159093,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157806,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05151','RN',157806,40.02,0.28,870,74378,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05151',0.159093,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157807,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157807,37.46,0.46,310,74379,70,NULL,NULL,'2MASX J22443548+1309139',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000162,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,341.1477917,13.15386,0.121,NULL,52587910771,821686105,12838845,17.2),(157808,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157808,35.74,0.78,140,74380,70,NULL,NULL,'2MASX J22443701-3945147',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.25',0.38,NULL,NULL,NULL,NULL,NULL,1,341.15425,-39.75411,0,NULL,50717151155,792455486,12382116,16.25),(157809,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157809,38.31,0.46,458,74381,70,NULL,NULL,'2MASX J22443931+0034120',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,341.1639583,0.56997,0.157,NULL,51681010279,807515785,12617434,17.7),(157810,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01683','RN',157810,39.75,0.66,821,74382,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01683 HOST',0.084961,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157811,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10672','RN',157811,39.87,0.57,870,74382,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01683 HOST',0.084961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157812,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01683','RN',157812,40.48,1.45,1150,74382,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01683 HOST',0.084961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157813,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10672','RN',157813,41.47,0.46,1810,74382,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01683 HOST',0.084961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157814,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15601','RN',157814,39.49,0.2,714,74383,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15601',0.1065,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157815,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 15601','RN',157815,39.65,0.13,768,74383,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15601',0.1065,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157816,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157816,37.25,0.46,282,74384,70,NULL,NULL,'2MASX J22444217+1248101',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,341.175833,12.80272,0.101,NULL,52584326069,821630094,12837970,17),(157817,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157817,38.02,0.46,403,74385,70,NULL,NULL,'2MASX J22444672+0107570',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,341.194583,1.13256,0.225,NULL,51688991228,807640487,12619382,18.1),(157818,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157818,34.73,0.8,88.3,74386,75,NULL,'MAT, I','ESO 238- G 024',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'12.56',0.5,'SA(r)bc',NULL,NULL,NULL,NULL,1,341.2005,-49.27703,0,NULL,50501962450,789093163,12329580,12.56),(157819,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157819,34.15,0.43,67.7,74386,75,NULL,'MAT, I, raw','ESO 238- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157820,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157820,34.23,0.32,70.3,74386,85,NULL,'I, raw','ESO 238- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157821,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157821,34.29,0.32,72.1,74386,85,NULL,'I, inv','ESO 238- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157822,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157822,34.39,0.43,75.6,74386,75,NULL,'MAT, I, inv','ESO 238- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157823,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157823,34.55,0.26,81.4,74386,NULL,NULL,'Malmquist cor.','ESO 238- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157824,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157824,34.57,0.43,82.1,74386,75,NULL,'MAT, I, cor','ESO 238- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157825,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157825,34.64,0.47,84.7,74386,NULL,NULL,'H','ESO 238- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157826,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157826,34.71,0.46,87.6,74386,NULL,NULL,'J','ESO 238- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157827,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157827,34.72,0.45,88,74386,NULL,NULL,'K','ESO 238- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157828,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157828,34.77,0.23,89.9,74386,NULL,NULL,NULL,'ESO 238- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157829,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157829,34.81,0.2,91.6,74386,74.4,NULL,NULL,'ESO 238- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157830,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157830,34.81,0.4,91.7,74386,NULL,NULL,'mean','ESO 238- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157831,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157831,38.36,0.33,469,74387,70,NULL,NULL,'2MASX J22444846-0045299',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000153,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.201917,-0.75825,0.189,NULL,49469103659,772954744,12077417,18),(157832,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16877','RN',157832,40.13,0.6,942,74388,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16877',0.129274,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157833,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157833,37.91,0.46,382,74389,70,NULL,NULL,'SDSS J224449.43+144944.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.206,14.829,0.245,NULL,52592441096,821756892,12839951,18.4),(157834,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157834,37.51,0.33,318,74390,70,NULL,NULL,'2MASX J22445158+1338241',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000155,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,341.2149583,13.64014,0.149,NULL,52585736757,821652136,12838314,18.2),(157835,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157835,37.88,0.46,376,74391,70,NULL,NULL,'2MASX J22445285+0002040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,341.220167,0.03444,0.209,NULL,51680567773,807508871,12617326,17.8),(157836,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157836,37.84,0.46,370,74392,70,NULL,NULL,'2MASX J22445496+1233441',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.2289583,12.56214,0.137,NULL,52584831369,821637990,12838093,18.1),(157837,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16069','R',157837,38.92,0.18,539,74393,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nd','2MASX J22445879-0100229',0.12878,'2014arXiv1401.3317S',2014,1,0.2,NULL,'G',0.000104,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,341.245041667,-1.00639,0.197,NULL,49473488024,773023250,12078488,18.2),(157838,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16069','R',157838,38.94,0.1,543,74393,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nd','2MASX J22445879-0100229',0.12878,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157839,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006nd',NULL,157839,38.77,0.07,568,74393,70,NULL,'SALT 2','2MASX J22445879-0100229',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157840,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006nd',NULL,157840,38.78,0.07,570,74393,70,NULL,'SALT 2, Malmquist cor.','2MASX J22445879-0100229',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157841,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157841,35.46,0.44,123,74394,NULL,NULL,NULL,'ESO 238- G 025',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000033,NULL,'15.99',0.34,'Sb:',NULL,NULL,NULL,NULL,1,341.2562083,-48.88708,0,NULL,50501583935,789087248,12329488,15.99),(157842,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157842,35.5,0.2,126,74394,74.4,NULL,NULL,'ESO 238- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157843,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157843,35.77,0.38,143,74394,NULL,NULL,'Malmquist cor.','ESO 238- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157844,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157844,37.51,0.33,318,74395,70,NULL,NULL,'2MASX J22450352+1337501',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,341.26475,13.63056,0.149,NULL,52585734623,821652103,12838314,17),(157845,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','PTF11kjn','N',157845,35.07,0.03,101,74396,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11kjn',0.0234,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157846,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157846,31.93,0.43,24.3,74397,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12178',NULL,'2014MNRAS.444..527S',2014,1,3,'The position in 1990PNAOJ...1..181T is for a superposed star.','G',0.000003,NULL,'13.60',1.6,'SAB(s)dm       HII','Isolated galaxy',NULL,NULL,NULL,1,341.28625,6.43094,0.137,NULL,52474345041,819911641,12811119,13.6),(157847,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157847,32.12,0.4,26.5,74397,75,NULL,'B','UGC 12178',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157848,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157848,33.04,0.45,40.6,74398,NULL,NULL,'K','NGC 7365',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00006,NULL,'13.87',1,'SA(rs)0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,341.291833,-19.95203,0.081,NULL,50222181970,784721593,12261274,13.87),(157849,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157849,33.29,0.4,45.5,74398,NULL,NULL,'mean','NGC 7365',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157850,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157850,32.92,0.8,38.4,74399,75,NULL,'MAT, I','ESO 534- G 024',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000027,NULL,'13.64',1.2,'SAB(rs)d:','in a pair',NULL,NULL,NULL,1,341.311417,-22.73078,0.041,NULL,50226667787,784791684,12262370,13.64),(157851,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157851,32.48,0.69,31.3,74399,100,NULL,'mid-IR','ESO 534- G 024',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157852,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157852,32.74,0.32,35.3,74399,85,NULL,'I, raw','ESO 534- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157853,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157853,32.76,0.32,35.7,74399,85,NULL,'I, inv','ESO 534- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157854,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157854,32.82,0.43,36.7,74399,75,NULL,'MAT, I, raw','ESO 534- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157855,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157855,32.95,0.43,38.9,74399,75,NULL,'MAT, I, inv','ESO 534- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157856,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157856,33.06,0.43,40.8,74399,75,NULL,'MAT, I, cor','ESO 534- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157857,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157857,33.14,0.2,42.5,74399,74.4,NULL,NULL,'ESO 534- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157858,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157858,33.29,0.4,45.6,74399,NULL,NULL,'mean','ESO 534- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157859,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157859,33.42,0.46,48.3,74399,NULL,NULL,'Malmquist cor.','ESO 534- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157860,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157860,33.43,0.46,48.6,74399,NULL,NULL,NULL,'ESO 534- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157861,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157861,33.62,0.47,52.9,74399,NULL,NULL,'H','ESO 534- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157862,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157862,33.74,0.46,56.1,74399,NULL,NULL,'J','ESO 534- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157863,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157863,33.78,0.45,57.1,74399,NULL,NULL,'K','ESO 534- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157864,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157864,36.53,0.67,202,74400,70,NULL,NULL,'2MASX J22452395-0613549',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.85',0.32,NULL,NULL,NULL,NULL,NULL,1,341.34975,-6.23192,0.085,NULL,50390082901,787345045,12302266,16.85),(157865,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157865,37.5,0.46,316,74401,70,NULL,NULL,'2MASX J22452769-0033052',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000153,NULL,'17.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,341.36525,-0.55136,0.189,NULL,49469506505,772961039,12077516,17.9),(157866,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157866,37.07,0.56,260,74402,70,NULL,NULL,'2MASX J22452789-3733347',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.57',0.24,NULL,NULL,NULL,NULL,NULL,1,341.3662917,-37.55958,0,NULL,50716023924,792437873,12381841,16.57),(157867,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157867,34.8,0.8,91.3,74403,75,NULL,'W91PP, r','IC 5253',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.45',0.3,'S0/a',NULL,NULL,NULL,NULL,1,341.3705,21.80806,0.201,NULL,52391916649,818623697,12790995,15.45),(157868,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157868,34.56,0.49,81.7,74403,NULL,NULL,NULL,'IC 5253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157869,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157869,34.62,0.38,84,74403,75,NULL,'W91PP, r, raw','IC 5253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157870,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157870,34.74,0.38,88.8,74403,75,NULL,'W91PP, r, inv','IC 5253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157871,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157871,34.76,0.2,89.5,74403,74.4,NULL,NULL,'IC 5253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157872,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157872,34.85,0.38,93.4,74403,75,NULL,'W91PP, r, cor','IC 5253',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157873,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157873,34.94,0.41,97.4,74403,NULL,NULL,'Malmquist cor.','IC 5253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157874,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157874,32.37,0.8,29.7,74404,75,NULL,'MAT, I','NGC 7368',NULL,'1997ApJS..109..333W',1997,1,3,NULL,'G',0.000021,NULL,'13.15',0.5,'SB(s)b? sp     HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,341.382,-39.34183,0,NULL,50717196830,792456200,12382128,13.15),(157875,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157875,32.37,0.8,29.8,74404,75,NULL,'A82, H','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157876,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157876,32.02,0.4,25.4,74404,73,NULL,'IR','NGC 7368',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157877,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157877,32.03,0.4,25.4,74404,75,NULL,NULL,'NGC 7368',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157878,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157878,32.24,0.39,28.1,74404,73,NULL,'opt','NGC 7368',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157879,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157879,32.35,0.43,29.5,74404,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7368',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157880,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157880,32.43,0.11,30.7,74404,NULL,NULL,NULL,'NGC 7368',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157881,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157881,32.46,0.38,31,74404,NULL,NULL,NULL,'NGC 7368',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157882,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157882,32.46,0.46,31.1,74404,NULL,NULL,'J','NGC 7368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157883,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157883,32.47,0.47,31.1,74404,NULL,NULL,'H','NGC 7368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157884,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157884,32.48,0.45,31.4,74404,NULL,NULL,'K','NGC 7368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157885,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157885,32.5,0.43,31.6,74404,75,NULL,'3.6 micron, color corrected','NGC 7368',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157886,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157886,32.52,0.47,32,74404,75,NULL,'A82, H, raw','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157887,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157887,32.58,0.4,32.8,74404,NULL,NULL,'mean','NGC 7368',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157888,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157888,32.65,0.47,33.8,74404,75,NULL,'A82, H, inv','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157889,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157889,32.66,0.32,34,74404,85,NULL,'I, raw','NGC 7368',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157890,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157890,32.66,0.49,34,74404,75,NULL,'IR','NGC 7368',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157891,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157891,32.69,0.43,34.4,74404,75,NULL,'MAT, I, raw','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157892,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157892,32.7,0.32,34.7,74404,85,NULL,'I, inv','NGC 7368',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157893,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157893,32.71,0.2,34.8,74404,74.4,NULL,NULL,'NGC 7368',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157894,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157894,32.73,0.47,35.1,74404,75,NULL,'A82, H, cor','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157895,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157895,32.83,0.43,36.8,74404,75,NULL,'MAT, I, cor','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157896,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157896,32.89,0.43,37.9,74404,75,NULL,'MAT, I, inv','NGC 7368',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157897,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157897,35.65,0.16,128,74405,74.2,NULL,'SALT 2','2MFGC 17122',0.0499,'2010ApJ...716..712A',2010,1,0.94,NULL,'G',0.00015,NULL,'16.1g',0.21,'S              HII',NULL,NULL,NULL,NULL,1,341.3919583,-8.75072,0.145,NULL,50397304707,787457886,12304029,16.1),(157898,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157898,36.14,0.03,161,74405,70,NULL,'SALT 2','2MFGC 17122',0.0499,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157899,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157899,36.19,0.04,165,74405,72,NULL,NULL,'2MFGC 17122',0.0499,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157900,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157900,36.16,0.08,171,74405,74.4,NULL,NULL,'2MFGC 17122',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157901,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157901,36.35,0.17,177,74405,70,NULL,'SALT','2MFGC 17122',0.0499,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157902,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157902,36.38,0.05,180,74405,70,NULL,NULL,'2MFGC 17122',0.0499,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157903,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157903,36.39,0.15,181,74405,70,NULL,'SALT 2','2MFGC 17122',0.0499,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157904,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157904,36.4,0.05,181,74405,65,NULL,'SALT2','2MFGC 17122',0.0499,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157905,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157905,36.51,0.11,182,74405,65,NULL,'MLCS2k2','2MFGC 17122',0.0499,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157906,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157906,36.42,0.15,183,74405,73.8,NULL,'SALT 2 (SNANA)','2MFGC 17122',0.049,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157907,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157907,36.33,0.06,185,74405,60,NULL,'M(I) = -19.19 mag','2MFGC 17122',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157908,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157908,36.5,0.05,190,74405,65,NULL,'MLCS2k2','2MFGC 17122',0.0499,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157909,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157909,36.52,0.17,191,74405,65,NULL,'SALT2','2MFGC 17122',0.0499,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157910,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157910,36.52,0.16,192,74405,65,NULL,'SALT','2MFGC 17122',0.0499,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157911,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157911,36.52,0.2,192,74405,65,NULL,NULL,'2MFGC 17122',0.0499,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157912,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157912,36.42,0.07,192,74405,60,NULL,'M(B) = -19.48 mag','2MFGC 17122',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157913,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157913,36.54,0.15,193,74405,65,NULL,'MLCS31','2MFGC 17122',0.0499,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157914,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157914,36.43,0.06,193,74405,60,NULL,'M(V) = -19.47 mag','2MFGC 17122',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157915,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157915,36.56,0.22,195,74405,72,NULL,NULL,'2MFGC 17122',0.0499,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157916,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157916,36.57,0.11,196,74405,65,NULL,'MLCS2k2','2MFGC 17122',0.0499,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157917,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157917,36.6,0.16,199,74405,65,NULL,'Template','2MFGC 17122',0.0499,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157918,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157918,36.6,0.13,199,74405,65,NULL,'MLCS17','2MFGC 17122',0.0499,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157919,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157919,36.65,0.02,204,74405,65,NULL,'SALT','2MFGC 17122',0.0499,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157920,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157920,36.68,0.17,217,74405,70.8,NULL,NULL,'2MFGC 17122',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157921,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 1995ac',NULL,157921,36.85,0.13,223,74405,65,NULL,'MLCS','2MFGC 17122',0.0499,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157922,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 07762',NULL,157922,40.65,0.41,1350,74406,70,NULL,'SN photometric redshift distance, z photo =0.386 +/- 0.107','SDSS-II SN 07762',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','22.6g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,341.394333,0.14442,0.165,NULL,51680603342,807509427,12617334,22.6),(157923,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157923,36.32,0.68,184,74407,70,NULL,NULL,'2MASX J22453504-0845586',NULL,'2014MNRAS.445.2677S',2014,1,0.83,NULL,'G',0.00015,NULL,'15.8g',0.25,'Sab',NULL,NULL,NULL,NULL,1,341.395916667,-8.76622,0.145,NULL,50397304808,787457887,12304029,15.8),(157924,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157924,38.48,0.46,497,74408,70,NULL,NULL,'2MASX J22454076-1013396',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000173,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,341.419833,-10.22775,0.157,NULL,50385792855,787278013,12301218,17.6),(157925,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157925,36.66,0.46,215,74409,70,NULL,NULL,'2MASX J22454475+0105280',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000201,NULL,'16.0g',0.39,'E0',NULL,NULL,NULL,NULL,1,341.436417,1.09108,0.225,NULL,51680664002,807510375,12617349,16),(157926,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05806','RN',157926,40.22,0.12,983,74410,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05806',0.123678,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157927,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05806','RN',157927,40.73,0.2,1250,74410,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05806',0.123678,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157928,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157928,37.23,0.46,279,74411,70,NULL,NULL,'2MASX J22455118-0820076',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.3g',0.36,'AGN',NULL,NULL,NULL,NULL,1,341.463333,-8.33536,0.109,NULL,50397703154,787464111,12304126,16.3),(157929,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 02280','RN',157929,41.43,0.39,1430,74412,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02280',0.350224,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157930,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 02280','RN',157930,41.51,0.36,1480,74412,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02280',0.350224,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157931,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 02280','N',157931,41.34,0.27,1850,74412,70,NULL,'SALT 2','SDSS-II SN 02280',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157932,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 02280','N',157932,41.38,0.27,1890,74412,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 02280',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157933,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19899','R',157933,37.99,0.19,363,74413,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pu','SN 2007pu',0.0914,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,341.4922917,-0.64872,0.229,NULL,49469511484,772961116,12077517,NULL),(157934,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19899','R',157934,38.29,0.07,418,74413,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pu','SN 2007pu',0.0914,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157935,'Magnitude','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157935,36.7,0.13,219,74414,100,NULL,NULL,'2MASX J22460031-1741210',NULL,'1998A&A...337...31R',1998,1,0.43,NULL,'G',0.000137,NULL,'15.30',0.36,'E/S0',NULL,NULL,NULL,NULL,1,341.5015417,-17.68936,0.061,NULL,50449173802,788268340,12316692,15.3),(157936,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157936,36.82,0.83,231,74415,70,NULL,NULL,'2MASX J22460123-0645176',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.79',0.2,NULL,NULL,NULL,NULL,NULL,1,341.505125,-6.75494,0.077,NULL,50390221052,787347203,12302300,16.79),(157937,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13024','RN',157937,43.24,0.49,3180,74416,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13024',0.402179,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157938,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13024','RN',157938,44.2,0.57,4940,74416,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13024',0.402179,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157939,'Ring Diameter','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157939,32.4,0.84,30,74417,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7371',NULL,'1981ApJS...45..541P',1981,1,2,'HOLM 797B is a star.','G',0.000013,NULL,'12.50',2,'(R)SA(r)0/a:',NULL,NULL,NULL,NULL,1,341.515583,-11.00114,0.169,NULL,50382855171,787232112,12300501,12.5),(157940,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157940,32.47,0.8,31.2,74417,75,NULL,'B','NGC 7371',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157941,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157941,36.85,0.68,234,74418,70,NULL,NULL,'2MASX J22460399-0703358',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.87',0.19,NULL,NULL,NULL,NULL,NULL,1,341.51675,-7.05992,0.097,NULL,50389416622,787334634,12302103,16.87),(157942,'Magnitude','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157942,36.7,0.13,219,74419,100,NULL,NULL,'ABELL 2480',NULL,'1998A&A...337...31R',1998,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,341.519583,-17.68644,0.045,NULL,50450040534,788281883,12316904,NULL),(157943,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157943,32.91,0.8,38.2,74420,75,NULL,'MAT, I','ESO 603- G 012',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000007,NULL,'15.00',0.5,'SB(s)dm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,341.523708333,-19.41539,0.049,NULL,50219204207,784675065,12260547,15),(157944,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157944,32.57,0.32,32.7,74420,85,NULL,'I, raw','ESO 603- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157945,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157945,32.57,0.32,32.7,74420,85,NULL,'I, inv','ESO 603- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157946,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157946,32.84,0.43,36.9,74420,75,NULL,'MAT, I, raw','ESO 603- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157947,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157947,32.88,0.43,37.7,74420,75,NULL,'MAT, I, inv','ESO 603- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157948,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157948,33.08,0.43,41.3,74420,75,NULL,'MAT, I, cor','ESO 603- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157949,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157949,33.28,0.2,45.3,74420,74.4,NULL,NULL,'ESO 603- G 012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157950,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157950,33.38,0.52,47.4,74420,NULL,NULL,NULL,'ESO 603- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157951,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157951,33.39,0.51,47.7,74420,NULL,NULL,'Malmquist cor.','ESO 603- G 012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157952,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157952,33.64,0.49,53.5,74420,75,NULL,'IR','ESO 603- G 012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157953,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157953,34.35,0.48,74.2,74421,70,NULL,NULL,'2MASX J22460696-0332506',NULL,'2014MNRAS.445.2677S',2014,1,0.81,NULL,'G',0.000147,NULL,'15.70',0.35,NULL,NULL,NULL,NULL,NULL,1,341.529125,-3.54731,0.113,NULL,49466183404,772909115,12076704,15.7),(157954,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157954,35.19,0.47,109,74422,70,NULL,NULL,'2MASX J22460778-7119244',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000077,NULL,'15.32',0.8,'SA0- pec',NULL,NULL,NULL,NULL,1,341.532667,-71.32344,0.009,NULL,49312509904,770507967,12039186,15.32),(157955,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157955,35.8,NULL,145,74423,NULL,NULL,'Dipole + Quadrupole + Octopole','FGCE 1776',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000057,NULL,'16.6',0.11,'Sd',NULL,NULL,NULL,NULL,1,341.541333,-37.04308,0,NULL,50702751203,792230487,12378601,16.6),(157956,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157956,35.83,NULL,147,74423,NULL,NULL,'Dipole + Quadrupole','FGCE 1776',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157957,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157957,35.87,NULL,149,74423,NULL,NULL,'Dipole','FGCE 1776',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157958,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157958,35.89,NULL,151,74423,NULL,NULL,NULL,'FGCE 1776',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157959,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157959,37.39,0.46,300,74424,70,NULL,NULL,'2MASX J22461376-0759238',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,341.557417,-7.98981,0.073,NULL,50397066062,787454157,12303971,17.2),(157960,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006fx',NULL,157960,40.02,0.19,827,74425,72,NULL,'SDSS 13025','SDSS J224616.26+002458.4',0.22,'2009ApJ...704.1036F',2009,1,0.13,NULL,'G',NULL,NULL,'19.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,341.567791667,0.41622,0.153,NULL,51680495312,807507739,12617308,19.3),(157961,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13025','R',157961,40.35,0.19,962,74425,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fx','SDSS J224616.26+002458.4',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157962,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13025','R',157962,40.55,0.1,1060,74425,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fx','SDSS J224616.26+002458.4',0.22,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157963,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006fx',NULL,157963,40.27,0.09,1130,74425,70,NULL,'SALT 2','SDSS J224616.26+002458.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157964,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006fx',NULL,157964,40.28,0.09,1140,74425,70,NULL,'SALT 2, Malmquist cor.','SDSS J224616.26+002458.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157965,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05807','RN',157965,39.71,0.15,733,74426,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05807',0.195487,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157966,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 05807','RN',157966,40.25,0.26,937,74426,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05807',0.195487,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157967,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157967,37.21,0.46,277,74427,70,NULL,NULL,'2MASX J22462243-0024546',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,341.593625,-0.41514,0.201,NULL,49469347632,772958556,12077477,18.1),(157968,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20953',NULL,157968,40.14,0.32,1060,74428,70,NULL,'SN photometric redshift distance, z photo =0.289 +/- 0.056','SDSS-II SN 20953',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,341.5972917,-0.25122,0.201,NULL,49469413446,772959585,12077493,NULL),(157969,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20953',NULL,157969,40.81,0.18,1450,74428,70,NULL,'SALT 2','SDSS-II SN 20953',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157970,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20953',NULL,157970,40.85,0.18,1480,74428,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20953',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157971,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157971,36.7,0.33,219,74429,70,NULL,NULL,'2MASX J22462410+0046250',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000201,NULL,'16.1g',0.34,'E0',NULL,NULL,NULL,NULL,1,341.6005417,0.77347,0.277,NULL,51680784669,807512260,12617379,16.1),(157972,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157972,32.76,NULL,35.6,74430,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -02-58-003',NULL,'2010Ap&SS.325..163P',2010,1,2.05,NULL,'G',0.000007,NULL,'15.06',0.26,'Sm',NULL,NULL,NULL,NULL,1,341.6010417,-14.17992,0.141,NULL,50458656958,788416514,12319008,15.06),(157973,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157973,32.77,NULL,35.8,74430,NULL,NULL,'Dipole','MCG -02-58-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157974,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157974,32.77,NULL,35.8,74430,NULL,NULL,'Dipole + Quadrupole','MCG -02-58-003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157975,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157975,32.92,0.43,38.3,74430,75,NULL,'3.6 micron, color + selection bias corrected','MCG -02-58-003',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157976,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16758','R',157976,41.08,0.23,1240,74431,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pw','SN 2006pw',0.326503,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,341.612333333,1.15081,0.241,NULL,51680689578,807510774,12617355,NULL),(157977,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 16758','R',157977,41.15,0.32,1280,74431,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pw','SN 2006pw',0.326503,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157978,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14412','RN',157978,42.66,0.21,2460,74432,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14412',0.386225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157979,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14412','RN',157979,42.67,0.17,2470,74432,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14412',0.386225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157980,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01243',NULL,157980,39.32,0.81,731,74433,70,NULL,'SN photometric redshift distance, z photo =0.188 +/- 0.100','SDSS-II SN 01243',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.9g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,341.6599583,-0.76467,0.229,NULL,49469001088,772953142,12077392,21.9),(157981,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01243','R',157981,40.34,0.27,976,74433,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01243',0.198426,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157982,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 01243','R',157982,40.66,0.37,1130,74433,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01243',0.198426,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157983,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157983,36.7,0.33,219,74434,70,NULL,NULL,'2MASX J22464099+0032360',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000168,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,341.670667,0.54342,0.277,NULL,51680453449,807507085,12617298,17),(157984,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157984,37.53,0.46,320,74435,70,NULL,NULL,'2MASX J22464171-0835013',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.7g',0.33,NULL,NULL,NULL,NULL,NULL,1,341.673875,-8.58383,0.109,NULL,50396830445,787450475,12303913,16.7),(157985,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',157985,37.44,0.46,307,74436,70,NULL,NULL,'SDSS J224647.57+002320.2',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000166,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,341.6982083,0.38897,0.225,NULL,51680477594,807507462,12617304,18.4),(157986,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157986,36.6,0.56,209,74437,70,NULL,NULL,'2MASX J22464877-2123141',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.07',0.33,NULL,NULL,NULL,NULL,NULL,1,341.70325,-21.38722,0.065,NULL,50227399960,784803124,12262548,16.07),(157987,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20245','R',157987,40.58,0.27,1000,74438,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pi','SN 2007pi',0.302,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,341.705541667,0.75631,0.277,NULL,51681231185,807519237,12617488,NULL),(157988,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 20245','R',157988,40.65,0.17,1030,74438,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pi','SN 2007pi',0.302,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157989,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13026','RN',157989,43.4,0.25,3130,74439,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13026',0.525576,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157990,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157990,35.15,0.57,107,74440,70,NULL,NULL,'IC 1453',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.29',0.3,NULL,NULL,NULL,NULL,NULL,1,341.725958333,-13.44961,0.145,NULL,50459053936,788422717,12319104,15.29),(157991,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19220','R',157991,39.82,0.21,766,74441,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2007ox','SN 2007ox',0.203,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia?',NULL,NULL,NULL,NULL,1,341.742,-0.07181,0.205,NULL,49471294596,772988978,12077952,NULL),(157992,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 19220','R',157992,39.9,0.17,793,74441,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2007ox','SN 2007ox',0.203,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157993,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157993,36.46,0.65,196,74442,70,NULL,NULL,'2MASX J22465846-4556220',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,341.743666667,-45.93953,0,NULL,50690550916,792039858,12375622,15.3),(157994,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157994,36.68,0.57,216,74443,70,NULL,NULL,'6dF J2246595-455701',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,341.748083,-45.95036,0,NULL,50690551004,792039859,12375622,15.2),(157995,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157995,33.65,0.9,53.7,74444,NULL,NULL,'Malmquist cor.','ESO 238- G 026',NULL,'2009ApJS..182..474S',2009,1,0.91,NULL,'G',0.000033,NULL,'15.30',0.44,'Sb-c:',NULL,NULL,NULL,NULL,1,341.757625,-48.58508,0,NULL,50501720585,789089384,12329521,15.3),(157996,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157996,33.68,0.89,54.4,74444,NULL,NULL,NULL,'ESO 238- G 026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157997,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157997,33.72,0.2,55.5,74444,74.4,NULL,NULL,'ESO 238- G 026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(157998,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157998,33.52,0.2,50.6,74445,74.4,NULL,NULL,'UGC 12183',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00013,NULL,'15.5',0.3,'S',NULL,NULL,NULL,NULL,1,341.765625,-0.07778,0.205,NULL,49471294123,772988970,12077952,15.5),(157999,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,157999,33.7,0.53,54.9,74445,NULL,NULL,NULL,'UGC 12183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158000,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158000,33.72,0.49,55.4,74445,75,NULL,'IR','UGC 12183',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158001,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158001,33.82,0.5,58.2,74445,NULL,NULL,'Malmquist cor.','UGC 12183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158002,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158002,36.65,0.65,214,74446,70,NULL,NULL,'LCRS B224410.5-453725',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.0001,NULL,'17.00',0.26,NULL,NULL,NULL,NULL,NULL,1,341.775583,-45.35967,0,NULL,50688904251,792014128,12375220,17),(158003,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158003,32.36,0.8,29.7,74447,75,NULL,'MAT, I','IC 5249',NULL,'1997ApJS..109..333W',1997,1,4.37,NULL,'G',0.000013,NULL,'14.31',0.43,'Sd',NULL,NULL,NULL,NULL,1,341.776167,-64.83203,0,NULL,48761387859,761896685,11904635,14.31),(158004,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158004,32.3,0.8,28.8,74447,75,NULL,NULL,'IC 5249',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158005,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158005,31.97,NULL,24.8,74447,NULL,NULL,NULL,'IC 5249',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158006,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158006,31.97,NULL,24.8,74447,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158007,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158007,32,NULL,25.1,74447,NULL,NULL,'Dipole + Quadrupole','IC 5249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158008,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158008,32,NULL,25.1,74447,NULL,NULL,'Dipole','IC 5249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158009,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158009,32.37,0.32,29.8,74447,85,NULL,'I, inv','IC 5249',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158010,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158010,32.38,0.32,29.9,74447,85,NULL,'I, raw','IC 5249',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158011,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158011,32.49,0.4,31.5,74447,NULL,NULL,NULL,'IC 5249',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158012,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158012,32.51,0.2,31.8,74447,74.4,NULL,NULL,'IC 5249',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158013,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158013,32.51,0.4,31.8,74447,73,NULL,'opt','IC 5249',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158014,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158014,32.55,0.4,32.3,74447,73,NULL,'IR','IC 5249',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158015,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158015,32.55,0.4,32.3,74447,75,NULL,NULL,'IC 5249',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158016,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158016,32.56,0.43,32.5,74447,75,NULL,'MAT, I, raw','IC 5249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158017,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158017,32.59,0.43,33,74447,75,NULL,'MAT, I, inv','IC 5249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158018,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158018,32.65,0.43,33.8,74447,75,NULL,'3.6 micron, color corrected','IC 5249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158019,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158019,32.71,0.43,34.8,74447,75,NULL,'3.6 micron, color + selection bias corrected','IC 5249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158020,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158020,32.84,0.43,37,74447,75,NULL,'MAT, I, cor','IC 5249',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158021,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158021,32.88,0.49,37.6,74447,75,NULL,'IR','IC 5249',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158022,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158022,34.14,0.44,67.3,74448,NULL,NULL,NULL,'CGCG 495-024',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000033,NULL,'15.7',0.2,'Sa',NULL,NULL,NULL,NULL,1,341.776291667,31.53925,0.293,NULL,51915610785,811181418,12674709,15.7),(158023,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158023,34.21,0.2,69.5,74448,74.4,NULL,NULL,'CGCG 495-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158024,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158024,34.47,0.37,78.2,74448,NULL,NULL,'Malmquist cor.','CGCG 495-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158025,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158025,35.86,0.64,149,74449,70,NULL,NULL,'2MFGC 17138',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'12.0K',NULL,NULL,NULL,NULL,NULL,NULL,1,341.8079583,-45.02453,0,NULL,50688854103,792013345,12375208,12),(158026,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158026,31.17,0.43,17.2,74450,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2420',NULL,'2014MNRAS.444..527S',2014,1,0.93,NULL,'G',0.000033,NULL,'16.6',0.11,'Sdm',NULL,NULL,NULL,NULL,1,341.81,75.75528,1.581,NULL,52801117042,825017453,12890897,16.6),(158027,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158027,32.84,NULL,37.1,74450,NULL,NULL,NULL,'FGC 2420',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158028,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158028,32.86,NULL,37.3,74450,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2420',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158029,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158029,32.88,NULL,37.6,74450,NULL,NULL,'Dipole + Quadrupole','FGC 2420',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158030,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158030,32.89,NULL,37.9,74450,NULL,NULL,'Dipole','FGC 2420',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158031,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10111','RN',158031,43.6,0.45,4320,74451,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10111',0.213939,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158032,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10111','RN',158032,43.8,0.86,4730,74451,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 10111',0.213939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158033,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158033,31.97,0.45,24.8,74452,NULL,NULL,'K','IC 5250A',NULL,'2007A&A...465...71T',2007,1,2.8,NULL,'G',0.000047,NULL,'12.21',2.8,'S0 pec?','Pair member (points to parent)',NULL,NULL,NULL,1,341.822917,-65.05972,0,NULL,48761150785,761892981,11904577,12.21),(158034,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158034,33.14,0.4,42.4,74452,NULL,NULL,'mean','IC 5250A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158035,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158035,35.16,0.5,108,74453,70,NULL,NULL,'2MASX J22472501-1722217',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.000137,NULL,'15.76',0.5,'S0',NULL,NULL,NULL,NULL,1,341.854167,-17.37272,0.069,NULL,50449885448,788279460,12316866,15.76),(158036,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158036,34.68,0.8,86.3,74454,75,NULL,'W91PP, r','UGC 12185',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.50',0.8,'SB(s)ab',NULL,NULL,NULL,NULL,1,341.854417,31.37353,0.293,NULL,51915771596,811183931,12674748,14.5),(158037,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158037,34.88,0.4,94.4,74454,NULL,NULL,'mean','UGC 12185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158038,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158038,35.12,0.38,106,74454,75,NULL,'W91PP, r, raw','UGC 12185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158039,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158039,35.18,0.38,108,74454,75,NULL,'W91PP, r, cor','UGC 12185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158040,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158040,35.32,0.47,116,74454,NULL,NULL,'H','UGC 12185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158041,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158041,35.35,0.45,118,74454,NULL,NULL,'K','UGC 12185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158042,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158042,35.36,0.46,118,74454,NULL,NULL,'J','UGC 12185',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158043,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158043,35.4,0.38,120,74454,75,NULL,'W91PP, r, inv','UGC 12185',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158044,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158044,35.42,0.57,121,74455,70,NULL,NULL,'2MASX J22472883-1207257',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.09',0.36,NULL,NULL,NULL,NULL,NULL,1,341.8702083,-12.12372,0.157,NULL,50423956547,787874321,12310536,16.09),(158045,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158045,36.67,0.98,216,74456,70,NULL,NULL,'2MASX J22472890-4348079',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.60',0.27,NULL,NULL,NULL,NULL,NULL,1,341.870375,-43.80217,0,NULL,50717717900,792464342,12382255,16.6),(158046,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10298','RN',158046,40.54,0.2,1120,74457,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10298',0.14854,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158047,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 10298','RN',158047,41.38,0.3,1640,74457,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10298',0.14854,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158048,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 03426','RN',158048,40.48,0.22,1010,74458,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03426',0.232672,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158049,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 03426','RN',158049,40.72,0.18,1130,74458,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03426',0.232672,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158050,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 03426','N',158050,40.39,0.13,1200,74458,70,NULL,'SALT 2','SDSS-II SN 03426',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158051,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 03426','N',158051,40.4,0.13,1200,74458,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03426',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158052,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158052,36.05,0.46,162,74459,70,NULL,NULL,'2MASX J22473708+0023061',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000169,NULL,'16.4g',0.31,'E0',NULL,NULL,NULL,NULL,1,341.9045,0.385,0.245,NULL,51681665659,807526025,12617594,16.4),(158053,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158053,35.92,0.46,153,74460,70,NULL,NULL,'2MASX J22473818-0812538',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000149,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,341.909167,-8.21514,0.073,NULL,50388463095,787319735,12301870,16.9),(158054,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158054,34.66,0.5,85.5,74461,70,NULL,NULL,'ESO 603- G 014',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000033,NULL,'14.63',0.5,'SAB(r)0/a',NULL,NULL,NULL,NULL,1,341.925333333,-17.34922,0.077,NULL,50449422530,788272227,12316753,14.63),(158055,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158055,35.13,0.48,106,74461,NULL,NULL,'Malmquist cor.','ESO 603- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158056,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158056,35.17,0.47,108,74461,NULL,NULL,'H','ESO 603- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158057,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158057,35.27,0.45,113,74461,NULL,NULL,'K','ESO 603- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158058,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158058,35.31,0.4,115,74461,NULL,NULL,'mean','ESO 603- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158059,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158059,35.33,0.46,117,74461,NULL,NULL,'J','ESO 603- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158060,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158060,35.35,0.44,117,74461,NULL,NULL,NULL,'ESO 603- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158061,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158061,35.39,0.2,120,74461,74.4,NULL,NULL,'ESO 603- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158062,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158062,37.61,0.33,332,74462,70,NULL,NULL,'SDSS J224746.42-084439.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,341.9434583,-8.74422,0.101,NULL,50396875665,787451182,12303924,18.4),(158063,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158063,31.34,0.76,18.5,74463,95,NULL,'Weighted Mean','NGC 7377',NULL,'1984ApJS...56...91D',1984,1,3,NULL,'G',0.000037,NULL,'12.07',2.5,'SA(s)0+  poss. LINER','in a pair',NULL,NULL,NULL,1,341.947917,-22.31211,0.041,NULL,50227111925,784798623,12262478,12.07),(158064,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158064,31.34,0.76,18.5,74463,95,NULL,'de Vaucouleurs','NGC 7377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158065,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158065,33.05,0.49,40.7,74463,70,NULL,NULL,'NGC 7377',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158066,'Tertiary','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158066,32.66,0.5,34,74463,95,NULL,NULL,'NGC 7377',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158067,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158067,32,0.45,25.1,74463,NULL,NULL,'K','NGC 7377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158068,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158068,33.27,0.4,45,74463,NULL,NULL,'mean','NGC 7377',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158069,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158069,31.96,0.43,24.6,74464,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7378',NULL,'2014MNRAS.444..527S',2014,1,1.4,NULL,'G',0.00002,NULL,'13.64',0.9,'(R\')SB(r)ab?   Sy2',NULL,NULL,NULL,'Sy 2',1,341.94875,-11.81664,0.133,NULL,50373591201,787087362,12298240,13.64),(158070,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158070,32.14,0.4,26.8,74464,73,NULL,'opt','NGC 7378',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158071,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158071,32.19,0.43,27.4,74464,75,NULL,'3.6 micron, color corrected','NGC 7378',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158072,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158072,32.34,0.2,29.4,74464,74.4,NULL,NULL,'NGC 7378',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158073,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158073,32.36,0.64,29.6,74464,NULL,NULL,NULL,'NGC 7378',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158074,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158074,32.42,0.63,30.4,74464,NULL,NULL,'Malmquist cor.','NGC 7378',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158075,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158075,32.59,0.4,33,74464,NULL,NULL,'mean','NGC 7378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158076,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158076,32.73,0.45,35.1,74464,NULL,NULL,'K','NGC 7378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158077,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158077,32.8,0.47,36.3,74464,NULL,NULL,'H','NGC 7378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158078,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158078,32.81,0.46,36.5,74464,NULL,NULL,'J','NGC 7378',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158079,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158079,36.87,0.46,236,74465,70,NULL,NULL,'2MASX J22475368+1305475',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,341.973583,13.0965,0.181,NULL,52601551698,821899245,12842175,17.6),(158080,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158080,36.19,0.64,173,74466,70,NULL,NULL,'2MASX J22475368-0410503',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'16.87',0.29,NULL,NULL,NULL,NULL,NULL,1,341.973667,-4.18058,0.105,NULL,49466963592,772921306,12076895,16.87),(158081,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158081,37.61,0.33,332,74467,70,NULL,NULL,'2MASX J22475679-0844548',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,341.986625,-8.74872,0.101,NULL,50396876363,787451193,12303924,17.7),(158082,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21697','RN',158082,38.88,0.24,519,74468,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 21697',0.146873,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158083,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 21697','RN',158083,38.93,0.26,532,74468,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 21697',0.146873,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158084,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158084,34.91,0.8,95.8,74469,75,NULL,'W91PP, r','UGC 12190',NULL,'1997ApJS..109..333W',1997,1,2.18,NULL,'G',0.000023,NULL,'15.36',0.22,'Sbc','Isolated galaxy',NULL,NULL,NULL,1,342.027083,28.29269,0.241,NULL,51941331758,811583308,12680989,15.36),(158085,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158085,34.96,0.49,98.3,74469,75,NULL,'IR','UGC 12190',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158086,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158086,35.15,0.38,107,74469,75,NULL,'W91PP, r, raw','UGC 12190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158087,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158087,35.17,NULL,108,74469,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12190',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158088,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158088,35.18,NULL,109,74469,NULL,NULL,'Dipole + Quadrupole','UGC 12190',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158089,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158089,35.19,NULL,109,74469,NULL,NULL,'Dipole','UGC 12190',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158090,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158090,35.23,NULL,111,74469,NULL,NULL,NULL,'UGC 12190',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158091,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158091,35.25,0.38,112,74469,75,NULL,'W91PP, r, cor','UGC 12190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158092,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158092,35.42,0.38,122,74469,75,NULL,'W91PP, r, inv','UGC 12190',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158093,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158093,36.88,0.81,238,74470,70,NULL,NULL,'2MFGC 17150',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'17.18',0.14,NULL,NULL,NULL,NULL,NULL,1,342.0535417,-4.33994,0.105,NULL,49464086593,772876353,12076193,17.18),(158094,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158094,36.66,0.46,215,74471,70,NULL,NULL,'2MASX J22481405-0902304',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,342.058375,-9.04178,0.093,NULL,50383280651,787238760,12300605,16.5),(158095,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17692','RN',158095,39.32,0.3,640,74472,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17692',0.144548,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158096,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 17692','RN',158096,39.56,0.26,714,74472,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17692',0.144548,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158097,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158097,37.39,0.46,300,74473,70,NULL,NULL,'2MASX J22481748+0009483',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,342.072875,0.16339,0.245,NULL,51678782376,807480974,12616890,17.6),(158098,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158098,36.68,0.56,217,74474,70,NULL,NULL,'ESO 147-IG 009 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00015,NULL,'16.12',1.5,'E2: pec',NULL,NULL,NULL,NULL,1,342.0889583,-58.34147,0,NULL,48844647015,763197609,11924962,16.12),(158099,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158099,37.04,0.46,256,74475,70,NULL,NULL,'2MASX J22482187+1400017',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,342.091125,14.00047,0.121,NULL,52603243301,821925676,12842588,17.8),(158100,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SN 2006jg',NULL,158100,40.59,0.22,1310,74476,70,NULL,'Hubble residual 0.21 for z0.33000','SDSS-II SN 13934 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,342.110458333,-0.43514,0.281,NULL,49471441863,772991279,12077988,NULL),(158101,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13934','R',158101,41.42,0.3,1450,74476,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jg','SDSS-II SN 13934 HOST',0.330932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158102,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 13934','R',158102,41.65,0.29,1600,74476,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jg','SDSS-II SN 13934 HOST',0.330932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158103,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,'R',158103,37.54,0.46,323,74477,70,NULL,NULL,'2MASX J22482881-0946123',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000143,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,342.12025,-9.77028,0.121,NULL,50383662478,787244726,12300698,17.9),(158104,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074',NULL,158104,40.13,0.34,1060,74478,70,NULL,'SN photometric redshift distance, z photo =0.288 +/- 0.059','SDSS-II SN 14074',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.1259583,-0.82528,0.253,NULL,49471792380,772996755,12078074,NULL),(158105,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074','R',158105,40.76,0.24,1130,74478,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14074',0.26192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158106,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074','R',158106,40.78,0.17,1130,74478,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14074',0.26192,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158107,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074',NULL,158107,40.66,0.14,1360,74478,70,NULL,'SALT 2','SDSS-II SN 14074',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158108,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:18','1','SDSS-II SN 14074',NULL,158108,40.68,0.14,1370,74478,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14074',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158109,'FP','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158109,36.39,0.86,189,74479,70,NULL,NULL,'LCRS B224538.2-452750',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00011,NULL,'16.99',0.27,NULL,NULL,NULL,NULL,NULL,1,342.1389583,-45.19947,0,NULL,50688932148,792014564,12375227,16.99),(158110,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158110,32.39,0.8,30,74480,75,NULL,'MAT, I','ESO 346- G 001',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000033,NULL,'14.57',0.34,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,342.141,-39.649,0,NULL,50715159475,792424366,12381630,14.57),(158111,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158111,30.95,NULL,15.5,74480,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 346- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158112,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158112,30.99,NULL,15.8,74480,NULL,NULL,'Dipole + Quadrupole','ESO 346- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158113,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158113,31.01,NULL,16,74480,NULL,NULL,'Dipole','ESO 346- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158114,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158114,31.09,NULL,16.5,74480,NULL,NULL,NULL,'ESO 346- G 001',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158115,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158115,32.39,0.08,30.1,74480,NULL,NULL,NULL,'ESO 346- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158116,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158116,32.58,0.4,32.8,74480,NULL,NULL,'mean','ESO 346- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158117,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:18','1',NULL,NULL,158117,32.72,0.43,35,74480,75,NULL,'3.6 micron, color + selection bias corrected','ESO 346- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158118,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158118,32.74,0.32,35.3,74480,85,NULL,'I, raw','ESO 346- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158119,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158119,32.74,0.32,35.3,74480,85,NULL,'I, inv','ESO 346- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158120,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158120,32.83,0.4,36.9,74480,75,NULL,NULL,'ESO 346- G 001',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158121,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158121,32.85,0.43,37.1,74480,75,NULL,'MAT, I, raw','ESO 346- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158122,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158122,32.91,0.43,38.2,74480,75,NULL,'3.6 micron, color corrected','ESO 346- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158123,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158123,32.92,0.43,38.3,74480,75,NULL,'MAT, I, inv','ESO 346- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158124,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158124,32.96,0.43,39.1,74480,75,NULL,'MAT, I, cor','ESO 346- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158125,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158125,32.96,0.47,39.1,74480,NULL,NULL,'H','ESO 346- G 001',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158126,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158126,33.09,0.2,41.5,74480,74.4,NULL,NULL,'ESO 346- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158127,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158127,33.15,0.49,42.7,74480,75,NULL,'IR','ESO 346- G 001',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158128,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 02481','RN',158128,40.69,0.21,1200,74481,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02481',0.147189,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158129,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 02481','RN',158129,41.26,0.28,1560,74481,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02481',0.147189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158130,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158130,35.5,0.8,126,74482,75,NULL,'W91PP, r','UGC 12191',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000067,NULL,'14.67',0.7,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,342.169417,27.61169,0.177,NULL,51939909870,811561091,12680642,14.67),(158131,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158131,34.58,0.38,82.2,74482,75,NULL,'W91PP, r, raw','UGC 12191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158132,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158132,34.71,0.38,87.5,74482,75,NULL,'W91PP, r, inv','UGC 12191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158133,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158133,34.83,0.38,92.4,74482,75,NULL,'W91PP, r, cor','UGC 12191',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158134,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158134,35.13,0.42,106,74482,NULL,NULL,'Malmquist cor.','UGC 12191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158135,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158135,35.22,0.4,111,74482,NULL,NULL,NULL,'UGC 12191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158136,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158136,35.26,0.2,113,74482,74.4,NULL,NULL,'UGC 12191',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158137,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 08236','RN',158137,40.63,0.18,1120,74483,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 08236',0.193779,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158138,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 08236','N',158138,40.48,0.37,1250,74483,70,NULL,'SALT 2','SDSS-II SN 08236',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158139,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 08236','N',158139,40.49,0.37,1250,74483,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08236',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158140,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 08236','RN',158140,41.4,0.29,1590,74483,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 08236',0.193779,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158141,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158141,34.21,0.2,69.5,74484,74.4,NULL,NULL,'ESO 468- G 028',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.00015,NULL,'15.83',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,342.204083333,-27.60764,0.034,NULL,50129035355,783266177,12238534,15.83),(158142,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158142,34.43,0.53,76.7,74484,NULL,NULL,NULL,'ESO 468- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158143,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158143,34.63,0.48,84.4,74484,NULL,NULL,'Malmquist cor.','ESO 468- G 028',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158144,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158144,36.5,0.33,200,74485,70,NULL,NULL,'SDSS J224849.15-100326.2',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000198,NULL,'17.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,342.204833,-10.05728,0.101,NULL,50383578696,787243417,12300678,17.9),(158145,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13890','RN',158145,41.16,0.15,1310,74486,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13890',0.297799,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158146,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13890','RN',158146,41.44,0.28,1500,74486,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13890',0.297799,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158147,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158147,36.48,0.46,198,74487,70,NULL,NULL,'2MASX J22485063-0029380',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000155,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,342.211,-0.49403,0.281,NULL,49467989712,772937339,12077145,17.4),(158148,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158148,35.6,0.8,132,74488,75,NULL,'W91PP, r','UGC 12194',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000017,NULL,'15.44',0.5,'S?',NULL,NULL,NULL,NULL,1,342.211875,27.96264,0.241,NULL,51941365780,811583840,12680997,15.44),(158149,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158149,35.24,0.42,112,74488,NULL,NULL,'Malmquist cor.','UGC 12194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158150,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158150,35.38,0.38,119,74488,75,NULL,'W91PP, r, raw','UGC 12194',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158151,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158151,35.45,0.38,123,74488,NULL,NULL,NULL,'UGC 12194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158152,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158152,35.53,0.38,127,74488,75,NULL,'W91PP, r, cor','UGC 12194',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158153,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158153,35.56,0.38,129,74488,75,NULL,'W91PP, r, inv','UGC 12194',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158154,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158154,35.67,0.2,136,74488,74.4,NULL,NULL,'UGC 12194',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158155,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158155,34.96,0.49,98.4,74489,75,NULL,'IR','UGC 12197',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000057,NULL,'17.',0.2,'Sbc',NULL,NULL,NULL,NULL,1,342.217458333,24.83797,0.265,NULL,51904363856,811005685,12671963,17),(158156,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158156,35.23,0.2,111,74489,74.4,NULL,NULL,'UGC 12197',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158157,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158157,35.3,0.39,115,74489,NULL,NULL,'Malmquist cor.','UGC 12197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158158,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158158,35.36,0.38,118,74489,NULL,NULL,NULL,'UGC 12197',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158159,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158159,34.71,0.2,87.5,74490,70,NULL,NULL,'GIN 673',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000043,NULL,'16.07',NULL,'S',NULL,NULL,NULL,NULL,1,342.2314583,11.34214,0.125,NULL,52433087309,819266989,12801046,16.07),(158160,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158160,34.75,NULL,89.1,74491,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 010',NULL,'2004ApJ...607..241R',2004,1,1.28,NULL,'G',0.000033,NULL,'15.70',0.22,'Sbc? pec sp',NULL,NULL,NULL,NULL,1,342.239833333,-57.89569,0,NULL,48844226609,763191040,11924860,15.7),(158161,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158161,34.75,NULL,89.1,74491,NULL,NULL,'B','ESO 147- G 010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158162,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158162,34.75,NULL,89.1,74491,NULL,NULL,'I','ESO 147- G 010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158163,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158163,34.76,0.26,89.5,74491,NULL,NULL,'B, Hubble-type-TF','ESO 147- G 010',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158164,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158164,35.02,NULL,101,74491,NULL,NULL,'B','ESO 147- G 010',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158165,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158165,35.25,NULL,112,74491,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 147- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158166,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158166,35.26,NULL,113,74491,NULL,NULL,'Dipole + Quadrupole','ESO 147- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158167,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158167,35.27,NULL,113,74491,NULL,NULL,'Dipole','ESO 147- G 010',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158168,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158168,35.3,NULL,115,74491,NULL,NULL,NULL,'ESO 147- G 010',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158169,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158169,35.35,0.49,118,74491,75,NULL,'IR','ESO 147- G 010',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158170,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158170,35.93,0.35,154,74491,NULL,NULL,'Malmquist cor.','ESO 147- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158171,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158171,36.06,0.33,163,74491,NULL,NULL,NULL,'ESO 147- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158172,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158172,36.1,0.2,166,74491,74.4,NULL,NULL,'ESO 147- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158173,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 21814','R',158173,38.18,0.12,393,74492,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007sf','SN 2007sf',0.101906,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,342.2462917,1.20608,0.245,NULL,51682082588,807532540,12617695,NULL),(158174,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 21814','R',158174,38.25,0.18,405,74492,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007sf','SN 2007sf',0.101906,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158175,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158175,37.35,0.46,295,74493,70,NULL,NULL,'2MASX J22485977-0002219',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000179,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,342.249041667,-0.03942,0.261,NULL,49468072240,772938628,12077166,16.6),(158176,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158176,35.93,0.54,154,74494,70,NULL,NULL,'FAIRALL 0142',NULL,'2014MNRAS.445.2677S',2014,1,0.93,NULL,'G',0.00015,NULL,'15.79',0.35,'S0',NULL,NULL,NULL,NULL,1,342.25875,-59.63983,0,NULL,48794345121,762411642,11912681,15.79),(158177,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10299',NULL,158177,39.77,0.36,901,74495,70,NULL,'SN photometric redshift distance, z photo =0.238 +/- 0.050','SDSS-II SN 10299',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.264167,0.9935,0.265,NULL,51682195273,807534301,12617723,21.3),(158178,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10299','R',158178,40.94,0.3,1230,74495,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10299',0.261248,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158179,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10299','R',158179,41.05,0.19,1290,74495,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10299',0.261248,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158180,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158180,34.25,0.47,70.9,74496,NULL,NULL,'H','UGC 12199',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'14.27',0.9,'SB(rs)b        LINER',NULL,NULL,NULL,NULL,1,342.2667083,40.00117,0.561,NULL,55522722193,867542534,13555352,14.27),(158181,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158181,34.29,0.69,72,74496,100,NULL,'mid-IR','UGC 12199',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158182,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158182,34.32,0.45,73.3,74496,NULL,NULL,'K','UGC 12199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158183,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158183,34.41,0.46,76.2,74496,NULL,NULL,'J','UGC 12199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158184,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158184,34.6,0.4,83.2,74496,NULL,NULL,'mean','UGC 12199',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158185,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158185,34.47,0.46,78.3,74497,70,NULL,NULL,'MCG -03-58-006',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.000117,NULL,'14.94',0.2,'E/S0',NULL,NULL,NULL,NULL,1,342.270583333,-16.59194,0.069,NULL,50452360422,788318131,12317470,14.94),(158186,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158186,35.62,0.6,133,74498,70,NULL,NULL,'ESO 027- G 016',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.47',0.4,'S...',NULL,NULL,NULL,NULL,1,342.275375,-81.29569,0.413,NULL,48350056681,755469635,11804213,15.47),(158187,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158187,34.07,0.8,65.1,74499,75,NULL,'W91PP, r','UGC 12201',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000017,NULL,'14.91',0.3,'Sab            LINER',NULL,NULL,NULL,NULL,1,342.2885,34.99028,0.381,NULL,55452749113,866449204,13538268,14.91),(158188,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158188,34.19,0.38,68.9,74499,75,NULL,'W91PP, r, raw','UGC 12201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158189,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158189,34.22,0.49,70,74499,75,NULL,'IR','UGC 12201',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158190,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158190,34.34,0.38,73.9,74499,75,NULL,'W91PP, r, inv','UGC 12201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158191,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158191,34.35,0.37,74,74499,NULL,NULL,NULL,'UGC 12201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158192,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158192,34.44,0.2,77.3,74499,74.4,NULL,NULL,'UGC 12201',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158193,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158193,34.47,0.35,78.3,74499,NULL,NULL,'Malmquist cor.','UGC 12201',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158194,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158194,34.5,0.38,79.3,74499,75,NULL,'W91PP, r, cor','UGC 12201',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158195,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158195,34.52,0.25,80.2,74500,74.4,NULL,NULL,'KUG 2246+112',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'14.62',0.4,'S',NULL,NULL,NULL,NULL,1,342.29275,11.54978,0.133,NULL,52433250423,819269537,12801086,14.62),(158196,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158196,34.71,0.2,87.5,74500,70,NULL,NULL,'KUG 2246+112',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158197,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158197,35.62,0.44,133,74501,NULL,NULL,'Malmquist cor.','UGC 12198',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000013,NULL,'15.65',0.2,'S?',NULL,NULL,NULL,NULL,1,342.2955,27.86525,0.241,NULL,51939491025,811554547,12680539,15.65),(158198,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158198,35.91,0.39,152,74501,NULL,NULL,NULL,'UGC 12198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158199,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158199,35.96,0.2,156,74501,74.4,NULL,NULL,'UGC 12198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158200,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10448',NULL,158200,40,0.88,998,74502,70,NULL,'SN photometric redshift distance, z photo =0.268 +/- 0.173','SDSS-II SN 10448',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.1g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.305625,-0.82508,0.189,NULL,49471607958,772993874,12078029,22.1),(158201,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10448','R',158201,41.86,0.46,1640,74502,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 10448',0.43386,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158202,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11411','RN',158202,40.45,0.27,1010,74503,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11411',0.214081,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158203,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11411','RN',158203,40.72,0.43,1150,74503,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11411',0.214081,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158204,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 05039','RN',158204,39.38,0.12,693,74504,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05039',0.082711,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158205,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 05039','RN',158205,39.86,0.24,867,74504,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05039',0.082711,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158206,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158206,35.51,0.8,127,74505,75,NULL,'CF, r','UGC 12200',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'14.65',0.6,'Sb',NULL,NULL,NULL,NULL,1,342.33475,19.289,0.217,NULL,52567790894,821371732,12833933,14.65),(158207,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158207,35.66,0.38,135,74505,75,NULL,'CF, r, raw','UGC 12200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158208,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158208,35.8,0.4,145,74505,NULL,NULL,'mean','UGC 12200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158209,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158209,35.9,0.38,151,74505,75,NULL,'CF, r, inv','UGC 12200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158210,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158210,35.97,0.38,156,74505,75,NULL,'CF, r, cor','UGC 12200',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158211,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158211,36.03,0.47,161,74505,NULL,NULL,'H','UGC 12200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158212,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158212,36.11,0.46,167,74505,NULL,NULL,'J','UGC 12200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158213,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158213,36.12,0.45,167,74505,NULL,NULL,'K','UGC 12200',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158214,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158214,36.5,0.33,200,74506,70,NULL,NULL,'2MASX J22492103-1004394',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000103,NULL,'15.9g',0.37,'E0',NULL,NULL,NULL,NULL,1,342.337583,-10.07747,0.149,NULL,50375995081,787124923,12298826,15.9),(158215,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158215,34.51,0.25,79.8,74507,74.4,NULL,NULL,'GIN 671',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000157,NULL,'15.20',NULL,'S',NULL,NULL,NULL,NULL,1,342.339833,11.93222,0.149,NULL,52554868621,821169822,12830778,15.2),(158216,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158216,34.71,0.2,87.5,74507,70,NULL,NULL,'GIN 671',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158217,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158217,34.62,0.49,83.8,74508,75,NULL,'IR','UGC 12204',NULL,'2011yCatp016004901K',2011,1,1.75,NULL,'G',0.000037,NULL,'16.0',0.19,'Sbc',NULL,NULL,NULL,NULL,1,342.3474583,40.23286,0.613,NULL,55522875761,867544933,13555389,16),(158218,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158218,34.79,NULL,90.7,74508,NULL,NULL,'Dipole','UGC 12204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158219,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158219,34.8,NULL,91.2,74508,NULL,NULL,'Dipole + Quadrupole','UGC 12204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158220,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158220,34.8,NULL,91.3,74508,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12204',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158221,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158221,35.03,NULL,101,74508,NULL,NULL,NULL,'UGC 12204',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158222,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158222,35.11,0.43,105,74508,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12204',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158223,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158223,35.16,0.43,108,74508,75,NULL,'3.6 micron, color corrected','UGC 12204',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158224,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158224,35.16,0.5,108,74508,NULL,NULL,'Malmquist cor.','UGC 12204',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158225,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158225,35.35,0.2,117,74508,74.4,NULL,NULL,'UGC 12204',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158226,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158226,35.6,0.41,132,74508,NULL,NULL,NULL,'UGC 12204',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158227,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158227,37.11,0.46,265,74509,70,NULL,NULL,'2MASX J22492389+0050065',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000189,NULL,'17.7g',0.15,NULL,NULL,NULL,NULL,NULL,1,342.3495,0.83519,0.245,NULL,51681959885,807530623,12617665,17.7),(158228,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158228,37.49,0.46,315,74510,70,NULL,NULL,'2MASX J22492415-0801384',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000166,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,342.350583,-8.02725,0.085,NULL,50389200603,787331259,12302050,17.2),(158229,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158229,38.31,0.46,458,74511,70,NULL,NULL,'SDSS J224924.85+144642.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000149,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,342.353583,14.77839,0.157,NULL,52603458894,821929045,12842641,18.5),(158230,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158230,40.26,NULL,1130,74512,70,NULL,'Pseudo z = 0.31','GRB 020903',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,342.354167,-20.89972,0.045,NULL,50221088676,784704510,12261007,NULL),(158231,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158231,34.52,0.25,80.2,74513,74.4,NULL,NULL,'GIN 664',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'14.69',0.4,'S','Group member',NULL,NULL,NULL,1,342.3554583,11.59236,0.133,NULL,52433195880,819268685,12801073,14.69),(158232,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158232,34.71,0.2,87.5,74513,70,NULL,NULL,'GIN 664',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158233,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158233,36.14,0.55,169,74514,70,NULL,NULL,'2MASX J22492658-3725086',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.37',0.35,'S0',NULL,NULL,NULL,NULL,1,342.360917,-37.41911,NULL,NULL,50702171120,792221423,12378459,16.37),(158234,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158234,40.29,0.13,914,74515,72,NULL,NULL,'XRF 020903',0.25,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,342.354167,-20.89972,0.045,NULL,50221088676,784704510,12261007,NULL),(158235,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158235,40.65,1.29,1080,74515,72,NULL,NULL,'XRF 020903',0.25,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158236,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158236,40.79,1.14,1150,74515,70,NULL,NULL,'XRF 020903',0.25,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158237,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158237,42.23,1.16,2230,74515,69.7,NULL,'Calibrated','XRF 020903',0.25,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158238,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158238,43.07,1.26,3290,74515,69.7,NULL,'Fiducial','XRF 020903',0.25,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158239,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20648','RN',158239,40.05,0.23,936,74516,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20648',0.095343,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158240,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20648','RN',158240,40.87,0.28,1370,74516,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20648',0.095343,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158241,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158241,34.75,0.8,89.1,74517,75,NULL,'W91PP, r','UGC 12206',NULL,'1997ApJS..109..333W',1997,1,2.3,NULL,'G',0.000033,NULL,'14.7',1.5,'SB(rs)a',NULL,NULL,NULL,NULL,1,342.387,33.36039,0.361,NULL,55451722365,866433161,13538018,14.7),(158242,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158242,34.25,0.38,70.8,74517,75,NULL,'W91PP, r, raw','UGC 12206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158243,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158243,34.45,0.38,77.8,74517,75,NULL,'W91PP, r, inv','UGC 12206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158244,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158244,34.48,0.47,78.7,74517,NULL,NULL,'H','UGC 12206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158245,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158245,34.56,0.38,81.6,74517,75,NULL,'W91PP, r, cor','UGC 12206',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158246,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158246,34.73,0.45,88.2,74517,NULL,NULL,'K','UGC 12206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158247,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158247,34.77,0.46,90.1,74517,NULL,NULL,'J','UGC 12206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158248,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158248,34.87,0.4,94.3,74517,NULL,NULL,'mean','UGC 12206',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158249,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 03212','RN',158249,40.94,0.16,1220,74518,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03212',0.264424,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158250,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 03212','RN',158250,41.47,0.23,1560,74518,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03212',0.264424,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158251,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158251,35.29,0.52,114,74519,95,NULL,'Weighted Mean','NGC 7383',NULL,'1984ApJS...56...91D',1984,1,0.8,NULL,'G',0.000027,NULL,'14.7',0.7,'SB0','in a pair',NULL,NULL,NULL,1,342.398417,11.55639,0.133,NULL,52433167780,819268246,12801066,14.7),(158252,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158252,36.28,0.63,180,74519,95,NULL,'Michard 1979b, c','NGC 7383',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158253,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158253,34.52,0.25,80.2,74519,74.4,NULL,NULL,'NGC 7383',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158254,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158254,34.71,0.2,87.5,74519,70,NULL,NULL,'NGC 7383',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158255,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158255,35.16,0.45,108,74520,NULL,NULL,'K','MCG -03-58-007',NULL,'2007A&A...465...71T',2007,1,0.5,NULL,'G',0.00005,NULL,'14.84',0.4,'(R\')SAB(s)0/a  Sy2',NULL,NULL,NULL,'Sy 1 h',1,342.4047917,-19.274,0.037,NULL,50440990071,788140469,12314694,14.84),(158256,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158256,35.39,0.47,119,74520,NULL,NULL,'H','MCG -03-58-007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158257,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158257,35.55,0.4,129,74520,NULL,NULL,'mean','MCG -03-58-007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158258,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158258,35.65,0.46,135,74520,NULL,NULL,'J','MCG -03-58-007',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158259,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158259,34.51,0.25,79.8,74521,74.4,NULL,NULL,'NGC 7384',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'*',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,342.4272917,11.48744,0.133,NULL,52433161957,819268155,12801064,NULL),(158260,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 07435','RN',158260,39.4,0.26,623,74522,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 07435',0.219521,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158261,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 07435','RN',158261,40.58,0.27,1070,74522,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 07435',0.219521,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158262,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15262','R',158262,39.14,0.28,540,74523,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15262',0.247673,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,342.43275,-0.40417,0.273,NULL,49468441234,772944394,12077256,NULL),(158263,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15262','R',158263,39.52,0.3,643,74523,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15262',0.247673,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158264,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158264,34.71,0.2,87.5,74524,70,NULL,NULL,'GIN 666',NULL,'2001MNRAS.321..277C',2001,1,0.9,NULL,'G',0.000033,NULL,'14.71',0.7,'E','Group member',NULL,NULL,NULL,1,342.441667,11.55239,0.133,NULL,52433174448,819268350,12801067,14.71),(158265,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158265,36.75,0.46,223,74525,70,NULL,NULL,'2MASX J22494604-0855102',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000103,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,342.4417083,-8.91953,0.101,NULL,50375704563,787120383,12298755,16.7),(158266,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158266,35.12,0.44,106,74526,NULL,NULL,'Malmquist cor.','2MFGC 17171',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'11.8K',0.1,NULL,NULL,NULL,NULL,NULL,1,342.446791667,34.94942,0.381,NULL,55452866213,866451034,13538297,11.8),(158267,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158267,35.51,0.37,127,74526,NULL,NULL,NULL,'2MFGC 17171',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158268,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158268,35.82,0.2,146,74526,74.4,NULL,NULL,'2MFGC 17171',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158269,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158269,36.06,0.46,163,74527,70,NULL,NULL,'2MASX J22494889+0057425',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000163,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,342.453667,0.96183,0.237,NULL,51681876849,807529325,12617645,16.7),(158270,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11914','RN',158270,39.5,0.73,716,74528,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 11914',0.110491,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158271,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158271,35.51,0.57,127,74529,NULL,NULL,'Malmquist cor.','ESO 049- G 006',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.16',0.6,'SA(rs)bc:',NULL,NULL,NULL,NULL,1,342.475958333,-73.02658,0.061,NULL,48448065544,757001024,11828141,14.16),(158272,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158272,35.64,0.54,135,74529,NULL,NULL,NULL,'ESO 049- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158273,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158273,35.69,0.2,137,74529,74.4,NULL,NULL,'ESO 049- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158274,'D-Sigma','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158274,34.49,0.4,78.9,74530,75,NULL,'Edat, raw','NGC 7385',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.05',1.3,'cD;E pec:;     LERG','in a pair',NULL,'FR I','Flat-Spectrum Radio Source',1,342.4774583,11.60856,0.149,NULL,52433163437,819268178,12801065,13.05),(158275,'D-Sigma','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158275,34.82,0.4,92.1,74530,75,NULL,'Edat, cor','NGC 7385',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158276,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158276,33.86,0.42,59.2,74530,95,NULL,'Weighted Mean','NGC 7385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158277,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158277,34.18,0.46,68.5,74530,95,NULL,'Michard 1979a','NGC 7385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158278,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158278,34.35,0.63,74.1,74530,95,NULL,'Michard 1979b, c','NGC 7385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158279,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158279,37.25,1.61,282,74530,55,NULL,'Visvanathan & Sandage 1979','NGC 7385',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158280,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158280,34.52,0.25,80.2,74530,74.4,NULL,NULL,'NGC 7385',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158281,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158281,34.71,0.2,87.5,74530,70,NULL,NULL,'NGC 7385',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158282,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158282,38.18,0.46,433,74531,70,NULL,NULL,'2MASX J22495698+0108237',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000164,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,342.4874583,1.13981,0.225,NULL,51681902377,807529724,12617651,17.9),(158283,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16055','RN',158283,39.18,0.34,622,74532,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16055',0.101448,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158284,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16055','RN',158284,39.68,0.52,785,74532,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16055',0.101448,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158285,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158285,35.82,0.75,146,74533,70,NULL,NULL,'2MASX J22495732-3732544',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.74',0.31,NULL,NULL,NULL,NULL,NULL,1,342.488375,-37.54828,NULL,NULL,50704108393,792251693,12378932,16.74),(158286,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 03607','RN',158286,39.67,0.19,788,74534,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03607',0.089187,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158287,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158287,35.15,0.5,107,74535,70,NULL,NULL,'2MASX J22500101-8037307',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.0b',0.19,NULL,NULL,NULL,NULL,NULL,1,342.504041667,-80.62525,0.457,NULL,48555521660,758680025,11854375,16),(158288,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158288,33.87,0.44,59.4,74536,95,NULL,'Weighted Mean','NGC 7386',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.000033,NULL,'13.32',1.2,'cD;SA0:','in a pair',NULL,NULL,NULL,1,342.5089583,11.69836,0.149,NULL,52433187273,819268551,12801071,13.32),(158289,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158289,34.24,0.46,70.5,74536,95,NULL,'Michard 1979a','NGC 7386',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158290,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158290,34.66,0.63,85.5,74536,95,NULL,'Michard 1979b, c','NGC 7386',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158291,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158291,34.51,0.25,79.8,74536,74.4,NULL,NULL,'NGC 7386',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158292,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158292,34.71,0.2,87.5,74536,70,NULL,NULL,'NGC 7386',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158293,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158293,35,0.4,100,74536,NULL,NULL,'mean','NGC 7386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158294,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158294,35.09,0.45,104,74536,NULL,NULL,'K','NGC 7386',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158295,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158295,35.84,0.67,147,74537,70,NULL,NULL,'2MASX J22500630-0745266',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,342.5262083,-7.75744,0.073,NULL,50388690821,787323294,12301926,15),(158296,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 05468',NULL,158296,39.99,0.25,995,74538,70,NULL,'SN photometric redshift distance, z photo =0.267 +/- 0.038','SDSS-II SN 05468',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.530667,0.40475,0.285,NULL,51679049990,807485156,12616955,NULL),(158297,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158297,36.45,0.7,195,74539,70,NULL,NULL,'2MASX J22501227-2118324',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'16.26',0.18,NULL,NULL,NULL,NULL,NULL,1,342.551167,-21.30889,0.045,NULL,50229180554,784830946,12262983,16.26),(158298,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 18666',NULL,158298,40.35,0.17,1180,74540,70,NULL,'SN photometric redshift distance, z photo =0.326 +/- 0.033','SDSS-II SN 18666',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.564417,0.19475,0.285,NULL,51678929573,807483274,12616926,NULL),(158299,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 18666',NULL,158299,41.08,0.18,1640,74540,70,NULL,'SALT 2','SDSS-II SN 18666',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158300,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 18666',NULL,158300,41.11,0.18,1670,74540,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18666',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158301,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158301,33.87,0.52,59.4,74541,95,NULL,'Weighted Mean','NGC 7389',NULL,'1984ApJS...56...91D',1984,1,1.1,NULL,'G',0.000093,NULL,'14.78',0.9,'SB0','Group member',NULL,NULL,NULL,1,342.566875,11.56619,0.149,NULL,52433871373,819279240,12801238,14.78),(158302,'Faber-Jackson','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158302,34.55,0.63,81.3,74541,95,NULL,'Michard 1979b, c','NGC 7389',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158303,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158303,37.66,0.46,340,74542,70,NULL,NULL,'2MASX J22501621+1433208',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000174,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,342.5675,14.55583,0.169,NULL,52603645724,821931964,12842686,17),(158304,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158304,37.03,0.46,255,74543,70,NULL,NULL,'2MASX J22501723-0031236',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000152,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,342.571875,-0.52325,0.213,NULL,49468624996,772947265,12077301,17.7),(158305,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158305,34.51,0.25,79.8,74544,74.4,NULL,NULL,'NGC 7387',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000037,NULL,'15.0',0.4,'S0-:','Group member',NULL,NULL,NULL,1,342.5735,11.63672,0.149,NULL,52433134499,819267726,12801058,15),(158306,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158306,34.71,0.2,87.5,74544,70,NULL,NULL,'NGC 7387',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158307,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158307,37.45,0.46,309,74545,70,NULL,NULL,'2MASX J22501776-0940576',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,342.574167,-9.68253,0.121,NULL,50376658105,787135282,12298988,17),(158308,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158308,34.53,0.25,80.5,74546,74.4,NULL,NULL,'NGC 7390',NULL,'2013AJ....146...86T',2013,1,1,'1977A&A....59...23S has V = 7763 +- 150 km/s.','G',0.000033,NULL,'15.12',0.8,'S0?','Group member',NULL,NULL,NULL,1,342.58175,11.53103,0.149,NULL,52433904883,819279763,12801246,15.12),(158309,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158309,34.71,0.2,87.5,74546,70,NULL,NULL,'NGC 7390',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158310,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158310,34.95,0.53,97.9,74547,70,NULL,NULL,'2MASX J22502168-2021044',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.63',0.68,'SA(rl)0^0',NULL,NULL,NULL,NULL,1,342.590375,-20.35125,0.053,NULL,50221323312,784708176,12261065,15.63),(158311,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158311,34.64,0.53,84.6,74548,70,NULL,NULL,'6dF J2250240-365126',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000113,NULL,'13.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,342.599958333,-36.85728,NULL,NULL,50704493707,792257714,12379026,13.7),(158312,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158312,35.34,0.5,117,74549,70,NULL,NULL,'2MASX J22502534-3732413',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'15.87',0.5,'E',NULL,NULL,NULL,NULL,1,342.605667,-37.54478,NULL,NULL,50704117135,792251830,12378934,15.87),(158313,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158313,32.36,0.55,29.7,74550,NULL,NULL,'Malmquist cor.','UGC 12221',NULL,'2009ApJS..182..474S',2009,1,2.3,NULL,'G',0.000037,NULL,'14.60',0.7,'SA(s)d','Isolated galaxy',NULL,NULL,NULL,1,342.606625,82.87703,0.561,NULL,52660298969,822817171,12856518,14.6),(158314,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158314,32.45,0.4,30.9,74550,NULL,NULL,'mean','UGC 12221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158315,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158315,32.45,0.53,30.9,74550,NULL,NULL,NULL,'UGC 12221',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158316,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158316,32.49,0.2,31.5,74550,74.4,NULL,NULL,'UGC 12221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158317,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158317,32.54,0.4,32.2,74550,75,NULL,'B','UGC 12221',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158318,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158318,32.6,0.46,33.1,74550,NULL,NULL,'J','UGC 12221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158319,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158319,32.7,0.47,34.7,74550,NULL,NULL,'H','UGC 12221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158320,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158320,32.75,0.45,35.5,74550,NULL,NULL,'K','UGC 12221',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158321,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606','R',158321,40.33,0.26,951,74551,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16606',0.225601,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','22.1g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,342.611,1.22269,0.225,NULL,51681950489,807530476,12617663,22.1),(158322,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606','R',158322,40.37,0.22,965,74551,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16606',0.225601,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158323,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606',NULL,158323,39.93,0.33,966,74551,70,NULL,'SN photometric redshift distance, z photo =0.258 +/- 0.050','SDSS-II SN 16606',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158324,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606',NULL,158324,40.15,0.17,1070,74551,70,NULL,'SALT 2','SDSS-II SN 16606',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158325,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16606',NULL,158325,40.17,0.17,1080,74551,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16606',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158326,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158326,36.03,0.69,160,74552,70,NULL,NULL,'2MASX J22502916-0451063',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.86',0.23,NULL,NULL,NULL,NULL,NULL,1,342.6217917,-4.85175,0.109,NULL,49464373307,772880832,12076263,16.86),(158327,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 14446','RN',158327,41.63,0.44,1620,74553,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14446',0.308083,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158328,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 14446','RN',158328,42.35,0.28,2260,74553,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14446',0.308083,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158329,'Tully est','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158329,30.84,0.8,14.7,74554,75,NULL,NULL,'UGC 12212',NULL,'1988NBGC.C....0000T',1988,1,1.5,NULL,'G',0.000007,NULL,'16.0',0.9,'Sm:',NULL,NULL,NULL,NULL,1,342.626375,29.13844,0.245,NULL,51926613421,811353334,12677395,16),(158330,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158330,31.93,0.4,24.3,74554,NULL,NULL,NULL,'UGC 12212',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158331,'D-Sigma','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158331,33.64,0.4,53.5,74555,75,NULL,'Edat, raw','NGC 7391',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'13.08',1.5,'E:',NULL,NULL,NULL,NULL,1,342.6505417,-1.54483,0.209,NULL,49470089919,772970154,12077658,13.08),(158332,'D-Sigma','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158332,33.98,0.4,62.5,74555,75,NULL,'Edat, cor','NGC 7391',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158333,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158333,33.67,0.5,54.3,74555,70,NULL,NULL,'NGC 7391',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158334,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158334,33.01,0.4,40,74555,NULL,NULL,'mean','NGC 7391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158335,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158335,33.82,0.45,58.2,74555,NULL,NULL,'K','NGC 7391',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158336,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 01334','RN',158336,42.44,0.09,2150,74556,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01334',0.431265,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158337,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158337,36.09,NULL,166,74557,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2425',NULL,'2010Ap&SS.325..163P',2010,1,0.64,NULL,'G',0.000014,NULL,'17.1',0.09,'Sc',NULL,NULL,NULL,NULL,1,342.6540417,12.23533,0.129,NULL,52554794660,821168666,12830760,17.1),(158338,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158338,36.1,NULL,166,74557,NULL,NULL,'Dipole + Quadrupole','FGC 2425',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158339,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158339,36.12,NULL,168,74557,NULL,NULL,'Dipole','FGC 2425',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158340,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158340,36.18,NULL,172,74557,NULL,NULL,NULL,'FGC 2425',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158341,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158341,36.23,0.32,176,74557,NULL,NULL,'Malmquist cor.','FGC 2425',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158342,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158342,36.35,0.3,186,74557,NULL,NULL,NULL,'FGC 2425',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158343,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158343,36.43,0.2,193,74557,74.4,NULL,NULL,'FGC 2425',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158344,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158344,36.05,0.58,162,74558,70,NULL,NULL,'2MASX J22503952-4929395',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'16.55',0.24,NULL,NULL,NULL,NULL,NULL,1,342.664666667,-49.49428,0,NULL,50502667816,789104184,12329752,16.55),(158345,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158345,36.82,0.52,231,74559,70,NULL,NULL,'2MASX J22504125-0542102',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.15',0.47,NULL,NULL,NULL,NULL,NULL,1,342.671917,-5.703,0.089,NULL,50340047865,786563247,12290050,16.15),(158346,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20582','RN',158346,42.12,0.26,1910,74560,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20582',0.392504,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158347,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158347,38.58,0.46,519,74561,70,NULL,NULL,'2MASX J22505385+1454002',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000148,NULL,'18.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,342.724375,14.89997,0.181,NULL,52611547920,822055436,12844616,18.5),(158348,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158348,37.9,0.46,380,74562,70,NULL,NULL,'2MASX J22505755-0017031',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,342.73975,-0.28419,0.205,NULL,49467705133,772932892,12077076,17.1),(158349,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158349,35.37,0.42,118,74563,NULL,NULL,'Malmquist cor.','KUG 2248+117',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.00006,NULL,'15.25',0.4,'S?',NULL,NULL,NULL,NULL,1,342.745833,12.05614,0.129,NULL,52555585152,821181018,12830953,15.25),(158350,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158350,35.44,0.41,123,74563,NULL,NULL,NULL,'KUG 2248+117',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158351,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158351,35.55,0.2,129,74563,74.4,NULL,NULL,'KUG 2248+117',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158352,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158352,36.83,0.67,232,74564,70,NULL,NULL,'LCRS B224806.3-453431',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'17.38',0.21,NULL,NULL,NULL,NULL,NULL,1,342.7535,-45.30983,0,NULL,50508322253,789192535,12331133,17.38),(158353,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158353,33.03,0.8,40.3,74565,75,NULL,'MAT, I','ESO 603- G 020',NULL,'1997ApJS..109..333W',1997,1,1.79,'Confused HIPASS source','G',0.000017,NULL,'15.00',0.17,'S pec sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,342.75575,-20.26856,0.053,NULL,50221433386,784709896,12261092,15),(158354,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158354,33.07,0.49,41.2,74565,75,NULL,'IR','ESO 603- G 020',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158355,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158355,33.09,0.32,41.4,74565,85,NULL,'I, raw','ESO 603- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158356,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158356,33.09,0.32,41.4,74565,85,NULL,'I, inv','ESO 603- G 020',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158357,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158357,33.23,0.43,44.3,74565,75,NULL,'MAT, I, raw','ESO 603- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158358,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158358,33.26,NULL,44.8,74565,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 603- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158359,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158359,33.28,NULL,45.3,74565,NULL,NULL,'Dipole + Quadrupole','ESO 603- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158360,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158360,33.28,0.43,45.4,74565,75,NULL,'MAT, I, inv','ESO 603- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158361,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158361,33.29,NULL,45.5,74565,NULL,NULL,'Dipole','ESO 603- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158362,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158362,33.41,0.74,48.1,74565,NULL,NULL,'Malmquist cor.','ESO 603- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158363,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158363,33.41,0.74,48.2,74565,NULL,NULL,NULL,'ESO 603- G 020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158364,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158364,33.42,0.43,48.4,74565,75,NULL,'MAT, I, cor','ESO 603- G 020',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158365,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158365,33.46,0.2,49.2,74565,74.4,NULL,NULL,'ESO 603- G 020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158366,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158366,33.66,NULL,53.8,74565,NULL,NULL,NULL,'ESO 603- G 020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158367,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158367,37.46,0.6,311,74566,70,NULL,NULL,'2MASX J22510319-0424081',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.89',0.39,NULL,NULL,NULL,NULL,NULL,1,342.7634583,-4.40236,0.129,NULL,49463748091,772871063,12076110,16.89),(158368,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158368,35.86,0.53,149,74567,70,NULL,NULL,'2MASX J22510440-1837298',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.00015,NULL,'15.79',0.33,'E',NULL,NULL,NULL,NULL,1,342.768333,-18.62497,0.041,NULL,50444195741,788190558,12315477,15.79),(158369,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158369,34.71,0.2,87.5,74568,70,NULL,NULL,'GIN 670',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000043,NULL,'15.49',NULL,'E',NULL,NULL,NULL,NULL,1,342.787667,11.25531,0.141,NULL,52433809177,819278268,12801222,15.49),(158370,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158370,37.48,0.25,313,74568,74.4,NULL,NULL,'GIN 670',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158371,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158371,34.58,0.8,82.5,74569,75,NULL,'W91PP, r','UGC 12218',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.00002,NULL,'14.90',0.4,'Im?            HII',NULL,NULL,NULL,NULL,1,342.840333,32.35044,0.353,NULL,51924001437,811312522,12676758,14.9),(158372,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158372,34.92,0.38,96.3,74569,75,NULL,'W91PP, r, raw','UGC 12218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158373,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158373,34.99,0.38,99.5,74569,75,NULL,'W91PP, r, cor','UGC 12218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158374,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158374,35.09,0.38,104,74569,75,NULL,'W91PP, r, inv','UGC 12218',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158375,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158375,36.35,0.46,186,74570,70,NULL,NULL,'2MASX J22512726+1452364',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000147,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,342.86375,14.87667,0.181,NULL,52611551833,822055497,12844617,17.5),(158376,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158376,37.78,0.46,360,74571,70,NULL,NULL,'2MASX J22512790+1434454',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000158,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,342.86625,14.57928,0.141,NULL,52603942502,821936601,12842759,17.8),(158377,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158377,34.52,0.25,80.2,74572,74.4,NULL,NULL,'GIN 669',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000037,NULL,'14.41',NULL,'E',NULL,NULL,NULL,NULL,1,342.867083,11.63192,0.173,NULL,52433647456,819275741,12801183,14.41),(158378,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158378,34.71,0.2,87.5,74572,70,NULL,NULL,'GIN 669',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158379,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158379,37.44,0.46,307,74573,70,NULL,NULL,'2MASX J22512845-0023552',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,342.868625,-0.39869,0.209,NULL,49467799208,772934362,12077099,18.2),(158380,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 07099','R',158380,40.03,0.19,831,74574,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07099',0.218886,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,342.8882083,1.16736,0.209,NULL,51678310412,807473600,12616775,NULL),(158381,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 07099','R',158381,40.14,0.1,876,74574,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07099',0.218886,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158382,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20830','RN',158382,41.6,0.42,1800,74575,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20830',0.162058,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158383,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20830','RN',158383,41.7,0.35,1880,74575,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20830',0.162058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158384,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158384,32.82,0.47,36.7,74576,NULL,NULL,'H','NGC 7393',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000027,NULL,'13.42',0.9,'SB(rs)c pec    HII',NULL,NULL,NULL,NULL,1,342.9087083,-5.55731,0.093,NULL,49517991727,773718620,12089353,13.42),(158385,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158385,32.84,0.46,37,74576,NULL,NULL,'J','NGC 7393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158386,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158386,32.85,0.2,37.2,74576,74.4,NULL,NULL,'NGC 7393',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158387,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158387,32.89,0.45,37.9,74576,NULL,NULL,'K','NGC 7393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158388,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158388,33.05,0.42,40.7,74576,NULL,NULL,NULL,'NGC 7393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158389,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158389,33.17,0.4,43.1,74576,NULL,NULL,'Malmquist cor.','NGC 7393',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158390,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158390,33.39,0.4,47.6,74576,NULL,NULL,'mean','NGC 7393',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158391,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158391,35.78,0.67,143,74577,70,NULL,NULL,'2MASX J22514146-4810544',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'17.02',0.17,NULL,NULL,NULL,NULL,NULL,1,342.9227083,-48.18172,0,NULL,50514095686,789282745,12332542,17.02),(158392,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158392,38.42,0.46,483,74578,70,NULL,NULL,'2MASX J22514694+1401517',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000177,NULL,'17.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,342.9454583,14.03094,0.133,NULL,52604791196,821949862,12842966,17.8),(158393,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158393,32.64,0.51,33.7,74579,70,NULL,NULL,'NGC 7392',NULL,'2014MNRAS.445.2677S',2014,1,2.1,NULL,'G',0.000033,NULL,'12.63',1.3,'(R\':)SB(rs)ab  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,342.953083,-20.60808,0.045,NULL,50221496158,784710877,12261107,12.63),(158394,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158394,33.01,0.8,40.1,74579,75,NULL,'MAT, I','NGC 7392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158395,'Sosies','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158395,33.18,0.09,43.3,74579,NULL,NULL,NULL,'NGC 7392',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158396,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158396,32.56,0.69,32.5,74579,100,NULL,'mid-IR','NGC 7392',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158397,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158397,33.12,0.43,42,74579,75,NULL,'MAT, I, raw','NGC 7392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158398,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158398,33.18,0.32,43.3,74579,85,NULL,'I, raw','NGC 7392',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158399,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158399,33.26,0.32,44.8,74579,85,NULL,'I, inv','NGC 7392',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158400,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158400,33.31,0.43,45.9,74579,75,NULL,'MAT, I, cor','NGC 7392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158401,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158401,33.35,NULL,46.8,74579,NULL,NULL,'I','NGC 7392',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158402,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158402,33.36,NULL,47,74579,NULL,NULL,'B','NGC 7392',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158403,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158403,33.39,0.2,47.6,74579,74.4,NULL,NULL,'NGC 7392',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158404,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158404,33.42,0.43,48.3,74579,75,NULL,'MAT, I, inv','NGC 7392',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158405,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158405,33.48,0.36,49.7,74579,NULL,NULL,'Malmquist cor.','NGC 7392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158406,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158406,33.55,0.35,51.2,74579,NULL,NULL,NULL,'NGC 7392',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158407,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158407,35.06,0.8,103,74580,75,NULL,'MAT, I','ESO 027- G 017',NULL,'1997ApJS..109..333W',1997,1,1.34,NULL,'G',0.000033,NULL,'15.91',0.18,'Sc',NULL,NULL,NULL,NULL,1,342.9977917,-80.83583,0.461,NULL,48555412886,758678326,11854348,15.91),(158408,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158408,34.71,0.43,87.4,74580,75,NULL,'MAT, I, raw','ESO 027- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158409,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158409,34.74,0.32,88.8,74580,85,NULL,'I, raw','ESO 027- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158410,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158410,34.77,0.32,89.9,74580,85,NULL,'I, inv','ESO 027- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158411,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158411,34.83,0.49,92.7,74580,75,NULL,'IR','ESO 027- G 017',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158412,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158412,34.86,0.43,93.7,74580,75,NULL,'MAT, I, inv','ESO 027- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158413,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158413,35,NULL,99.8,74580,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 027- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158414,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158414,35.01,NULL,100,74580,NULL,NULL,'Dipole + Quadrupole','ESO 027- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158415,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158415,35.02,NULL,101,74580,NULL,NULL,'Dipole','ESO 027- G 017',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158416,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158416,35.05,NULL,102,74580,NULL,NULL,NULL,'ESO 027- G 017',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158417,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158417,35.14,0.43,106,74580,75,NULL,'MAT, I, cor','ESO 027- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158418,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158418,35.31,0.57,116,74580,NULL,NULL,'Malmquist cor.','ESO 027- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158419,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158419,35.44,0.54,122,74580,NULL,NULL,NULL,'ESO 027- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158420,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158420,35.48,0.2,125,74580,74.4,NULL,NULL,'ESO 027- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158421,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158421,36.37,0.46,188,74581,70,NULL,NULL,'2MASX J22520303-0855164',NULL,'2015arXiv151105856S',2015,1,0.49,'Star superposed 10\\\" northwest of the nucleus.','G',0.00015,NULL,'16.5g',0.24,NULL,NULL,NULL,NULL,NULL,1,343.0125,-8.92136,0.113,NULL,50377966948,787155733,12299308,16.5),(158422,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158422,37.3,0.33,288,74582,70,NULL,NULL,'2MASX J22520798-0941194',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,343.033125,-9.68883,0.129,NULL,50376548502,787133570,12298962,17.9),(158423,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158423,34.93,0.46,97,74583,70,NULL,NULL,'MCG -03-58-008',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00009,NULL,'14.83',0.3,NULL,NULL,NULL,NULL,NULL,1,343.0452083,-14.86797,0.097,NULL,50463247929,788488248,12320128,14.83),(158424,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 00820','RN',158424,41.53,0.19,1520,74584,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00820',0.330027,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158425,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 00820','RN',158425,41.67,0.11,1620,74584,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00820',0.330027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158426,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158426,37.3,0.33,288,74585,70,NULL,NULL,'2MASX J22521258-0943404',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,343.0525,-9.72778,0.129,NULL,50376303552,787129743,12298902,16.5),(158427,'CMD','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'N',158427,18.8,NULL,0.058,74586,NULL,NULL,'DES J2251.2 _5836','Tucana II',NULL,'2015ApJ...807...50B',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158428,'CMD','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'N',158428,19.2,NULL,0.069,74586,NULL,NULL,NULL,'Tucana II',NULL,'2015ApJ...805..130K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158429,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158429,37.75,0.46,354,74587,70,NULL,NULL,'2MASX J22521603+1310508',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,343.066833,13.18092,0.165,NULL,52601094066,821892094,12842063,17.8),(158430,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158430,38.23,0.46,442,74588,70,NULL,NULL,'2MASX J22521639+0111152',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000183,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,343.068375,1.18756,0.197,NULL,51733095556,808329618,12630150,17.7),(158431,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20052','RN',158431,40.18,0.09,940,74589,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20052',0.157665,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158432,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20052','RN',158432,40.53,0.22,1100,74589,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20052',0.157665,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158433,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158433,35.02,0.49,101,74590,75,NULL,'IR','ESO 534- G 029',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.49',0.23,'Sc:',NULL,NULL,NULL,NULL,1,343.078166667,-26.33794,0.068,NULL,50109485141,782960705,12233761,15.49),(158434,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 19468',NULL,158434,41.53,0.05,2020,74591,70,NULL,'SN photometric redshift distance, z photo =0.669 +/- 0.026','SDSS-II SN 19468',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.08275,-0.84603,0.217,NULL,49468220957,772940952,12077202,NULL),(158435,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15943','RN',158435,40.09,0.3,837,74592,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15943',0.246411,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158436,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15943','RN',158436,40.1,0.29,841,74592,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15943',0.246411,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158437,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158437,33.42,0.69,48.3,74593,100,NULL,'mid-IR','NGC 7396',NULL,'2013ApJ...771...88L',2013,1,1.9,NULL,'G',0.000077,NULL,'13.75',1.1,'Sa pec sp','Group member',NULL,NULL,NULL,1,343.094333,1.09239,0.197,NULL,51733300050,808332813,12630200,13.75),(158438,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158438,34.35,0.62,74.2,74593,NULL,NULL,'Malmquist cor.','NGC 7396',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158439,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158439,34.75,0.52,88.9,74593,NULL,NULL,NULL,'NGC 7396',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158440,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158440,34.79,0.2,90.8,74593,74.4,NULL,NULL,'NGC 7396',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158441,'SNII optical','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 1993S',NULL,158441,35.32,0.14,109,74594,NULL,NULL,'SEAM','2MASX J22522390-4018432',0.033009,'2009ApJ...694.1067P',2009,1,0.77,NULL,'G',0.00005,NULL,'15.72',0.37,'S',NULL,NULL,NULL,NULL,1,343.09925,-40.31164,NULL,NULL,50711182702,792362229,12380659,15.72),(158442,'SNII optical','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 1993S',NULL,158442,35.48,0.06,125,74594,NULL,NULL,'I, photospheric magnitude method','2MASX J22522390-4018432',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158443,'SNII optical','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 1993S',NULL,158443,35.62,0.1,133,74594,NULL,NULL,'V, photospheric magnitude method','2MASX J22522390-4018432',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158444,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158444,37.81,0.46,365,74595,70,NULL,NULL,'2MASX J22522811+0017402',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000179,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,343.11725,0.2945,0.277,NULL,51732580219,808321565,12630024,16.7),(158445,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158445,36.85,0.46,235,74596,70,NULL,NULL,'2MASX J22523160-0023561',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000136,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.131625,-0.39892,0.217,NULL,49513857706,773654026,12088344,18.1),(158446,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158446,35.11,0.62,105,74597,NULL,NULL,'Malmquist cor.','UGC 12222',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.78',0.8,'Sb',NULL,NULL,NULL,NULL,1,343.136291667,11.662,0.149,NULL,52433757413,819277459,12801210,14.78),(158447,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158447,35.37,0.55,119,74597,NULL,NULL,NULL,'UGC 12222',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158448,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158448,35.52,0.4,127,74597,NULL,NULL,'mean','UGC 12222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158449,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158449,35.73,0.2,140,74597,74.4,NULL,NULL,'UGC 12222',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158450,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158450,35.79,0.47,144,74597,NULL,NULL,'H','UGC 12222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158451,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158451,35.86,0.45,148,74597,NULL,NULL,'K','UGC 12222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158452,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158452,35.88,0.46,150,74597,NULL,NULL,'J','UGC 12222',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158453,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158453,37.67,0.46,341,74598,70,NULL,NULL,'2MASX J22523719+0006058',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000142,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,343.154875,0.10153,0.189,NULL,51732559187,808321237,12630019,17.9),(158454,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 09603','RN',158454,42.5,0.28,2070,74599,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09603',0.533326,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158455,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15675','R',158455,40.42,0.21,981,74600,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J225241.58+002149.6',0.2345,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,343.1732917,0.36381,0.277,NULL,51732760135,808324377,12630068,20.7),(158456,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15675','R',158456,40.61,0.16,1070,74600,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J225241.58+002149.6',0.2345,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158457,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15675',NULL,158457,40.3,0.11,1150,74600,70,NULL,'SALT 2','SDSS J225241.58+002149.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158458,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 15675',NULL,158458,40.31,0.11,1150,74600,70,NULL,'SALT 2, Malmquist cor.','SDSS J225241.58+002149.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158459,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10121','R',158459,37.78,0.42,354,74601,70,NULL,'SDSS CAND. Variable; MLCS2K2','NGC 7398',0.015718,'2014arXiv1401.3317S',2014,1,1.21,'1999ApJS..121..287H has z = 0.034707 +- 0.000167.','G',0.000162,NULL,'14.3g',0.85,'SA(r)a:','Group member',NULL,NULL,NULL,1,343.205291667,1.20111,0.185,NULL,51733311061,808332985,12630202,14.3),(158460,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158460,34.14,0.37,67.4,74601,NULL,NULL,'Malmquist cor.','NGC 7398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158461,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158461,34.15,0.37,67.7,74601,NULL,NULL,NULL,'NGC 7398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158462,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158462,34.34,0.2,73.8,74601,74.4,NULL,NULL,'NGC 7398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158463,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158463,36.68,0.46,217,74602,70,NULL,NULL,'2MASX J22525004-0057172',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,343.208333,-0.95492,0.217,NULL,49514216925,773659639,12088431,17.3),(158464,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158464,36.96,0.77,247,74603,70,NULL,NULL,'2MASX J22525345-0556352',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'15.87',0.36,NULL,NULL,NULL,NULL,NULL,1,343.22275,-5.94314,0.109,NULL,49484644951,773197577,12081212,15.87),(158465,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13393',NULL,158465,40.01,0.25,1000,74604,70,NULL,'SN photometric redshift distance, z photo =0.270 +/- 0.040','SDSS-II SN 13393',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.6g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.2379583,0.61747,0.229,NULL,51732740432,808324069,12630063,22.6),(158466,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158466,36.87,0.46,236,74605,70,NULL,NULL,'2MASX J22530486+0024289',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.0002,NULL,'15.9g',0.16,'AGN',NULL,NULL,NULL,NULL,1,343.2702917,0.40814,0.257,NULL,51732764311,808324442,12630069,15.9),(158467,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158467,35.69,0.54,137,74606,70,NULL,NULL,'2MASX J22530542-1836520',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.00015,NULL,'15.82',0.47,'E',NULL,NULL,NULL,NULL,1,343.2725417,-18.61433,0.045,NULL,50443126999,788173859,12315216,15.82),(158468,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158468,34.2,0.49,69,74607,75,NULL,'IR','UGC 12229',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.43',0.4,'S?',NULL,NULL,NULL,NULL,1,343.2842917,32.76356,0.377,NULL,51910273601,811098025,12673406,15.43),(158469,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11100','RN',158469,39.85,0.27,771,74608,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11100',0.210047,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158470,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 11100','RN',158470,40.29,0.19,944,74608,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11100',0.210047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158471,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16563','R',158471,40.22,0.24,822,74609,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16563',0.345032,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,343.305583,-0.09531,0.189,NULL,49497042965,773391296,12084239,NULL),(158472,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 16563','R',158472,40.36,0.32,879,74609,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16563',0.345032,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158473,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158473,38.07,0.46,411,74610,70,NULL,NULL,'2MASXi J2253200-080420',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.3337917,-8.07261,0.101,NULL,50370775698,787043370,12297552,17.6),(158474,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158474,34.6,0.8,83.1,74611,75,NULL,'W91PP, r','NGC 7407',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000033,NULL,'13.95',0.9,'Sbc',NULL,NULL,NULL,NULL,1,343.337,32.13067,0.297,NULL,51924667588,811322931,12676920,13.95),(158475,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158475,34.6,0.8,83.3,74611,75,NULL,'CF, r','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158476,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158476,34.48,0.38,78.7,74611,75,NULL,'W91PP, r, raw','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158477,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158477,34.56,0.38,81.7,74611,75,NULL,'CF, r, raw','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158478,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158478,34.71,0.38,87.4,74611,75,NULL,'W91PP, r, cor','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158479,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158479,34.73,0.38,88.4,74611,75,NULL,'W91PP, r, inv','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158480,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158480,34.75,0.38,89.3,74611,75,NULL,'CF, r, cor','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158481,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158481,34.77,0.38,89.9,74611,75,NULL,'CF, r, inv','NGC 7407',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158482,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158482,34.98,0.3,99.2,74611,NULL,NULL,'Malmquist cor.','NGC 7407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158483,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158483,35.15,0.2,107,74611,74.4,NULL,NULL,'NGC 7407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158484,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158484,35.17,0.28,108,74611,NULL,NULL,NULL,'NGC 7407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158485,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13028','RN',158485,41.75,0.17,1780,74612,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13028',0.259389,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158486,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13028','RN',158486,42.08,0.2,2060,74612,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13028',0.259389,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158487,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158487,36.53,0.46,202,74613,70,NULL,NULL,'2MASX J22533240+0037152',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',NULL,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,343.3849583,0.62089,0.229,NULL,51732757086,808324329,12630067,17),(158488,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158488,33.43,0.8,48.6,74614,75,NULL,'W91PP, r','UGC 12231',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.8',0.6,'SBcd:','Group member',NULL,NULL,NULL,1,343.386958333,31.61958,0.253,NULL,51925455037,811335234,12677113,14.8),(158489,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158489,33.66,0.38,54,74614,75,NULL,'W91PP, r, inv','UGC 12231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158490,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158490,33.75,0.38,56.3,74614,75,NULL,'W91PP, r, raw','UGC 12231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158491,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158491,34.14,0.38,67.4,74614,75,NULL,'W91PP, r, cor','UGC 12231',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158492,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158492,36.54,0.58,203,74615,70,NULL,NULL,'2MASX J22533388-1652151',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.09',0.39,NULL,NULL,NULL,NULL,NULL,1,343.3912917,-16.87075,0.073,NULL,50464396360,788506193,12320409,16.09),(158493,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 13076',NULL,158493,40.27,0.23,1130,74616,70,NULL,'SN photometric redshift distance, z photo =0.311 +/- 0.042','SDSS-II SN 13076',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.392458333,0.18808,0.217,NULL,51699034334,807797411,12621834,NULL),(158494,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158494,37.03,0.91,255,74617,70,NULL,NULL,'2MASX J22533800-0248128',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'17.11',0.14,NULL,NULL,NULL,NULL,NULL,1,343.408375,-2.80364,0.189,NULL,49514918264,773670597,12088603,17.11),(158495,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 05244','RN',158495,43.25,0.21,2730,74618,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05244',0.636791,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158496,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158496,37.27,0.46,284,74619,70,NULL,NULL,'SDSS J225339.97+002320.3',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000145,NULL,'18.0g',0.16,'BLAGN',NULL,NULL,NULL,'Sy 1',1,343.4165417,0.389,0.217,NULL,51732778087,808324657,12630072,18),(158497,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158497,35.28,0.99,114,74620,NULL,NULL,'Malmquist cor.','ESO 603- G 025',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.37',0.7,'Sc',NULL,NULL,NULL,NULL,1,343.4202083,-17.47889,0.041,NULL,50451135206,788298987,12317171,15.37),(158498,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158498,35.77,0.79,142,74620,NULL,NULL,NULL,'ESO 603- G 025',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158499,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158499,35.81,0.2,145,74620,74.4,NULL,NULL,'ESO 603- G 025',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158500,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158500,34.56,0.8,81.8,74621,75,NULL,'W91PP, r','UGC 12234',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'13.48',0.7,'Sbc',NULL,NULL,NULL,NULL,1,343.4202083,33.70914,0.301,NULL,51910316685,811098698,12673417,13.48),(158501,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158501,34.58,0.8,82.5,74621,75,NULL,'CF, r','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158502,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158502,33.7,0.43,55,74621,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12234',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158503,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158503,33.88,0.38,59.7,74621,75,NULL,'W91PP, r, raw','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158504,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158504,34.12,0.38,66.7,74621,75,NULL,'W91PP, r, inv','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158505,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158505,34.18,0.38,68.5,74621,75,NULL,'CF, r, raw','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158506,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158506,34.26,0.38,71,74621,75,NULL,'W91PP, r, cor','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158507,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158507,34.4,0.38,75.7,74621,75,NULL,'CF, r, inv','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158508,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158508,34.49,0.38,79.2,74621,75,NULL,'CF, r, cor','UGC 12234',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158509,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158509,34.8,0.16,91.2,74622,NULL,NULL,'B, Hubble-type-TF','ESO 406- G 016',NULL,'2005Ap&SS.298..577R',2005,1,1.2,NULL,'G',0.000033,NULL,'15.74',0.5,'Sb-c',NULL,NULL,NULL,NULL,1,343.428125,-34.14719,NULL,NULL,50566797135,790106205,12345409,15.74),(158510,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158510,35.42,0.43,121,74622,NULL,NULL,NULL,'ESO 406- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158511,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158511,35.46,0.2,124,74622,74.4,NULL,NULL,'ESO 406- G 016',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158512,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158512,35.51,0.41,126,74622,NULL,NULL,'Malmquist cor.','ESO 406- G 016',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158513,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20405',NULL,158513,39.9,0.31,953,74623,70,NULL,'SN photometric redshift distance, z photo =0.254 +/- 0.047','SDSS-II SN 20405',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.44175,-1.13783,0.217,NULL,49514106495,773657913,12088404,NULL),(158514,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 02645','RN',158514,39.27,0.45,654,74624,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02645',0.09111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158515,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158515,37.09,0.46,261,74625,70,NULL,NULL,'2MASX J22535600-0949223',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000139,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,343.48325,-9.82289,0.113,NULL,50378275485,787160554,12299383,16.9),(158516,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158516,31.27,0.2,18,74626,74.4,NULL,NULL,'NGC 7406',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000023,NULL,'14.17',0.4,'Sc',NULL,NULL,NULL,NULL,1,343.484333,-6.57925,0.085,NULL,50370258878,787035294,12297426,14.17),(158517,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158517,38.89,NULL,601,74627,65,NULL,'L = 10e57 photons/s','GRB 791105B',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,343.571625,-2.30731,0.193,NULL,49515646933,773681983,12088780,NULL),(158518,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158518,41.58,NULL,2070,74627,65,NULL,'L = 2 x 10e58 photons/s','GRB 791105B',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158519,'GRB','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158519,46.15,NULL,17000,74627,NULL,NULL,'L = 10e57 photons/s','GRB 791105B',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158520,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158520,36.08,0.54,165,74628,70,NULL,NULL,'MCG -03-58-010',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16',0.15,NULL,NULL,NULL,NULL,NULL,1,343.5095417,-15.27572,0.093,NULL,50462033578,788469274,12319832,16),(158521,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158521,35.1,0.53,105,74629,70,NULL,NULL,'2MASX J22540390-1110123',NULL,'2014MNRAS.445.2677S',2014,1,0.71,NULL,'G',0.000103,NULL,'16.19',0.38,NULL,NULL,NULL,NULL,NULL,1,343.51625,-11.17019,0.113,NULL,50377382072,787146594,12299165,16.19),(158522,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158522,37.93,0.46,385,74630,70,NULL,NULL,'SDSS J225404.39+002716.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000157,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,343.5182917,0.45464,0.197,NULL,51732658772,808322793,12630043,18.1),(158523,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20359','RN',158523,41.34,0.37,1210,74631,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20359',0.530904,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158524,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158524,35.14,0.48,107,74632,NULL,NULL,NULL,'ESO 534- G 030',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'16.09',1.1,'S...',NULL,NULL,NULL,NULL,1,343.549167,-25.25206,0.063,NULL,50111956069,782999313,12234364,16.09),(158525,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158525,35.18,0.2,109,74632,74.4,NULL,NULL,'ESO 534- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158526,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158526,35.39,0.43,120,74632,NULL,NULL,'Malmquist cor.','ESO 534- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158527,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 2006jm',NULL,158527,40.17,0.14,1080,74633,70,NULL,'Hubble residual -0.21 for z0.33000','SDSS J225412.27+010302.3',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,343.550917,1.05089,0.209,NULL,51733573424,808337084,12630266,NULL),(158528,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 14456','R',158528,40.99,0.23,1190,74633,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006jm','SDSS J225412.27+010302.3',0.33,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158529,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 14456','R',158529,41.06,0.15,1220,74633,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006jm','SDSS J225412.27+010302.3',0.33,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158530,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 2006jm',NULL,158530,41.11,0.13,1670,74633,70,NULL,'SALT 2','SDSS J225412.27+010302.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158531,'SNIa','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SN 2006jm',NULL,158531,41.15,0.13,1700,74633,70,NULL,'SALT 2, Malmquist cor.','SDSS J225412.27+010302.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158532,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158532,37.26,0.76,283,74634,70,NULL,NULL,'2MFGC 17217',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.000096,NULL,'15.6g',0.41,'Sab',NULL,NULL,NULL,NULL,1,343.575916667,-9.44917,0.097,NULL,50378611250,787165800,12299465,15.6),(158533,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 09853','RN',158533,38.92,0.3,570,74635,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09853',0.067734,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158534,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 09853','RN',158534,40.42,0.73,1140,74635,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09853',0.067734,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158535,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158535,35.16,0.49,108,74636,75,NULL,'IR','UGC 12237',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'15.35',0.3,'Sbc',NULL,NULL,NULL,'Sy 2',1,343.5819583,11.78247,0.157,NULL,52556205405,821190709,12831104,15.35),(158536,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158536,35.27,0.34,113,74636,NULL,NULL,'Malmquist cor.','UGC 12237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158537,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158537,35.38,0.2,119,74636,74.4,NULL,NULL,'UGC 12237',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158538,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158538,35.4,0.32,120,74636,NULL,NULL,NULL,'UGC 12237',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158539,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158539,35.47,0.4,124,74636,NULL,NULL,'mean','UGC 12237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158540,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158540,35.81,0.47,146,74636,NULL,NULL,'H','UGC 12237',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158541,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158541,37.24,0.46,280,74637,70,NULL,NULL,'2MASX J22542062+1435443',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00015,NULL,'17.8g',0.14,NULL,NULL,NULL,NULL,NULL,1,343.586,14.59578,0.133,NULL,52602251828,821910184,12842346,17.8),(158542,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158542,32.94,0.8,38.7,74638,75,NULL,'MAT, I','NGC 7400',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.00002,NULL,'13.60',0.5,'SAB:(r)b',NULL,NULL,NULL,NULL,1,343.58675,-45.34703,0,NULL,50508470864,789194857,12331169,13.6),(158543,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158543,32.77,0.4,35.8,74638,NULL,NULL,NULL,'NGC 7400',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158544,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158544,32.77,0.4,35.8,74638,73,NULL,'opt','NGC 7400',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158545,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158545,32.86,0.32,37.3,74638,85,NULL,'I, raw','NGC 7400',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158546,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158546,32.89,0.32,37.8,74638,85,NULL,'I, inv','NGC 7400',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158547,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158547,32.93,0.43,38.6,74638,75,NULL,'MAT, I, raw','NGC 7400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158548,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158548,32.98,0.4,39.5,74638,NULL,NULL,'mean','NGC 7400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158549,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158549,33.02,0.43,40.2,74638,75,NULL,'MAT, I, cor','NGC 7400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158550,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158550,33.02,0.47,40.2,74638,NULL,NULL,'H','NGC 7400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158551,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158551,33.04,0.46,40.5,74638,NULL,NULL,'J','NGC 7400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158552,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158552,33.1,0.43,41.6,74638,75,NULL,'MAT, I, inv','NGC 7400',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158553,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158553,33.1,0.45,41.7,74638,NULL,NULL,'K','NGC 7400',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158554,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158554,33.12,0.48,42.2,74638,NULL,NULL,'Malmquist cor.','NGC 7400',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158555,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158555,33.19,0.47,43.5,74638,NULL,NULL,NULL,'NGC 7400',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158556,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158556,33.23,0.2,44.3,74638,74.4,NULL,NULL,'NGC 7400',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158557,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158557,33.31,0.4,45.8,74639,NULL,NULL,'mean','IC 5261',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00002,NULL,'13.88',1.3,'SB(s)cd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,343.605166667,-20.36289,0.065,NULL,50441961000,788155640,12314931,13.88),(158558,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158558,33.66,0.47,54.1,74639,NULL,NULL,'H','IC 5261',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158559,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158559,33.73,0.46,55.8,74639,NULL,NULL,'J','IC 5261',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158560,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158560,37.65,0.46,339,74640,70,NULL,NULL,'2MASX J22542770-0916329',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.5g',0.28,'AGN',NULL,NULL,NULL,NULL,1,343.615417,-9.27589,0.093,NULL,50378599218,787165612,12299462,16.5),(158561,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158561,37.27,0.19,285,74641,70,NULL,NULL,'2MASX J22542992-0029485',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000178,NULL,'17.7g',0.22,'NLAGN',NULL,NULL,NULL,NULL,1,343.6247083,-0.49672,0.209,NULL,49497084183,773391940,12084249,17.7),(158562,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158562,37.27,0.19,285,74642,70,NULL,NULL,'2MASX J22543459-0034485',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,'PRED','17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,343.64425,-0.58025,0.209,NULL,49513894266,773654597,12088353,17),(158563,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158563,37.27,0.19,285,74643,70,NULL,NULL,'2MASX J22543472-0034155',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0002,NULL,'16.5g',0.37,NULL,NULL,NULL,NULL,NULL,1,343.644667,-0.57106,0.209,NULL,49513894896,773654607,12088353,16.5),(158564,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10703','RN',158564,36.97,0.16,232,74644,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10703',0.067948,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158565,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 10703','RN',158565,40.87,0.46,1390,74644,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10703',0.067948,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158566,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158566,37.19,0.46,274,74645,70,NULL,NULL,'2MASX J22543864+1428233',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000144,NULL,'16.9g',0.23,NULL,NULL,NULL,NULL,NULL,1,343.661,14.47322,0.133,NULL,52602763865,821918185,12842471,16.9),(158567,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158567,37.77,0.46,358,74646,70,NULL,NULL,'2MASX J22544271+1305573',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,343.678083,13.09936,0.161,NULL,52558260646,821222822,12831606,17.5),(158568,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 09265','RN',158568,43.34,0.37,3230,74647,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09265',0.442362,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158569,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20388','RN',158569,40.38,0.15,1010,74648,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20388',0.178524,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158570,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 20388','RN',158570,40.75,0.26,1200,74648,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 20388',0.178524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158571,'FP','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,'R',158571,37.27,0.19,285,74649,70,NULL,NULL,'2MASX J22544932-0021223',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000209,NULL,'16.4g',0.35,NULL,NULL,NULL,NULL,NULL,1,343.705541667,-0.35628,0.213,NULL,49497187468,773393554,12084274,16.4),(158572,'SNIa SDSS','2016-12-15 15:16:02','2016-12-16 11:21:19','1','SDSS-II SN 01114','R',158572,37.01,0.21,246,74650,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2005lb','SN 2005lb',0.026478,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,343.7085417,-0.2525,0.213,NULL,49497184376,773393505,12084273,NULL),(158573,'IRAS','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158573,35.22,0.8,111,74651,75,NULL,'W91PP, r','UGC 12245',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.42',0.4,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,343.709583,21.80653,0.161,NULL,52392494501,818632726,12791136,15.42),(158574,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158574,34.94,0.38,97.4,74651,75,NULL,'W91PP, r, raw','UGC 12245',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158575,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158575,35.08,0.38,104,74651,75,NULL,'W91PP, r, inv','UGC 12245',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158576,'Tully-Fisher','2016-12-15 15:16:02','2016-12-16 11:21:19','1',NULL,NULL,158576,35.13,0.38,106,74651,75,NULL,'W91PP, r, cor','UGC 12245',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158577,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158577,35.82,0.49,146,74652,75,NULL,'IR','NGC 7415',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000033,NULL,'15.5',0.15,'Sab','Group member',NULL,NULL,NULL,1,343.723417,20.26156,0.185,NULL,52569480726,821398136,12834345,15.5),(158578,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158578,36.53,0.56,202,74653,70,NULL,NULL,'2MFGC 17226',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,343.725583,-49.22831,0,NULL,50514678148,789291846,12332685,14.1),(158579,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158579,31.52,0.8,20.1,74654,75,NULL,'B','NGC 7410',NULL,'1988NBGC.C....0000T',1988,1,5.2,NULL,'G',0.000093,NULL,'11.61',1.6,'SB(s)a;LINER   Sy2','in a pair',NULL,NULL,'LINER',1,343.7539583,-39.66133,NULL,NULL,50710244217,792347565,12380430,11.61),(158580,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158580,32.82,0.43,36.7,74654,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7410',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158581,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158581,33.15,0.43,42.7,74654,75,NULL,'3.6 micron, color corrected','NGC 7410',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158582,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158582,33.61,0.2,52.7,74654,74.4,NULL,NULL,'NGC 7410',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158583,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158583,37.27,0.19,285,74655,70,NULL,NULL,'2MASX J22550212-0022423',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,'PRED','16.8g',0.27,NULL,NULL,NULL,NULL,NULL,1,343.758875,-0.37842,0.213,NULL,49497065260,773391644,12084244,16.8),(158584,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158584,33.9,0.44,60.3,74656,95,NULL,'Weighted Mean','NGC 7413',NULL,'1984ApJS...56...91D',1984,1,0.83,NULL,'G',0.00008,NULL,'14.8g',0.55,'S0- pec:',NULL,NULL,NULL,NULL,1,343.762917,13.22047,0.161,NULL,52558185951,821221655,12831588,14.8),(158585,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158585,34.17,0.63,68.2,74656,95,NULL,'Michard 1979b, c','NGC 7413',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158586,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158586,34.6,0.46,83.2,74656,95,NULL,'Michard 1979a','NGC 7413',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158587,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158587,34.48,0.46,78.7,74656,70,NULL,NULL,'NGC 7413',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158588,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 10853','RN',158588,38.44,0.25,458,74657,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10853',0.066668,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158589,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 10853','RN',158589,39.26,0.91,667,74657,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10853',0.066668,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158590,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158590,37.32,0.46,291,74658,70,NULL,NULL,'2MASX J22550607+0044386',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000181,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,343.7754583,0.74414,0.149,NULL,51733466761,808335418,12630240,17.9),(158591,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158591,35.97,0.46,156,74659,70,NULL,NULL,'2MASX J22550681+0058396',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000104,NULL,'15.7g',0.39,'LINER',NULL,NULL,NULL,NULL,1,343.778333,0.97781,0.197,NULL,51733488671,808335760,12630246,15.7),(158592,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158592,32.68,0.8,34.4,74660,75,NULL,'MAT, I','ESO 346- G 014',NULL,'1997ApJS..109..333W',1997,1,1.81,NULL,'G',0.000013,NULL,'15.13',0.2,'SB(s)d? sp','Isolated galaxy',NULL,NULL,NULL,1,343.7792917,-38.58333,NULL,NULL,50702928822,792233262,12378644,15.13),(158593,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158593,32.41,0.4,30.4,74660,75,NULL,NULL,'ESO 346- G 014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158594,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158594,32.41,0.4,30.4,74660,73,NULL,'IR','ESO 346- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158595,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158595,32.71,0.13,34.9,74660,NULL,NULL,NULL,'ESO 346- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158596,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158596,33.14,0.32,42.5,74660,85,NULL,'I, inv','ESO 346- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158597,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158597,33.15,0.32,42.6,74660,85,NULL,'I, raw','ESO 346- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158598,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158598,33.16,0.2,42.9,74660,74.4,NULL,NULL,'ESO 346- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158599,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158599,33.28,0.38,45.3,74660,NULL,NULL,NULL,'ESO 346- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158600,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158600,33.29,0.43,45.5,74660,75,NULL,'3.6 micron, color corrected','ESO 346- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158601,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158601,33.31,0.43,45.9,74660,75,NULL,'MAT, I, raw','ESO 346- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158602,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158602,33.34,0.43,46.7,74660,75,NULL,'MAT, I, inv','ESO 346- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158603,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158603,33.38,0.43,47.3,74660,75,NULL,'3.6 micron, color + selection bias corrected','ESO 346- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158604,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158604,33.41,NULL,48.2,74660,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 346- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158605,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158605,33.42,0.43,48.4,74660,75,NULL,'MAT, I, cor','ESO 346- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158606,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158606,33.44,NULL,48.8,74660,NULL,NULL,'Dipole + Quadrupole','ESO 346- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158607,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158607,33.45,0.49,49.1,74660,75,NULL,'IR','ESO 346- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158608,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158608,33.46,NULL,49.1,74660,NULL,NULL,'Dipole','ESO 346- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158609,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158609,33.47,NULL,49.4,74660,NULL,NULL,NULL,'ESO 346- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158610,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158610,34.14,0.49,67.3,74661,75,NULL,'IR','CGCG 496-019',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.12',0.5,'S?',NULL,NULL,NULL,NULL,1,343.783791667,31.30881,0.265,NULL,51924981005,811327828,12676997,15.12),(158611,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158611,37.27,0.19,285,74662,70,NULL,NULL,'2MASX J22551005-0024333',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.00015,NULL,'16.43',0.48,'BrClG',NULL,NULL,NULL,NULL,1,343.7917917,-0.40939,0.213,NULL,49497066300,773391660,12084244,16.43),(158612,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158612,37.93,0.46,386,74663,70,NULL,NULL,'2MASX J22551232-1034373',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,343.8012917,-10.57689,0.101,NULL,50374924901,787108201,12298565,17.2),(158613,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158613,34.42,0.4,76.6,74664,NULL,NULL,'mean','IC 5259',NULL,'2007A&A...465...71T',2007,1,0.55,NULL,'G',0.000033,NULL,'14.8',0.4,NULL,NULL,NULL,NULL,NULL,1,343.8112083,36.67178,0.401,NULL,55516150164,867439846,13553747,14.8),(158614,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158614,34.49,0.47,79.2,74664,NULL,NULL,'H','IC 5259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158615,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158615,34.5,0.45,79.5,74664,NULL,NULL,'K','IC 5259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158616,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158616,34.56,0.46,81.6,74664,NULL,NULL,'J','IC 5259',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158617,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158617,35.14,0.35,107,74664,NULL,NULL,'Malmquist cor.','IC 5259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158618,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158618,35.71,0.27,139,74664,NULL,NULL,NULL,'IC 5259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158619,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158619,35.75,0.2,141,74664,74.4,NULL,NULL,'IC 5259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158620,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158620,35.83,0.65,147,74665,70,NULL,NULL,'2MASX J22551619-5842087',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.58',0.22,NULL,NULL,NULL,NULL,NULL,1,343.817333,-58.70247,0,NULL,48849817492,763278398,11926224,16.58),(158621,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158621,35.71,0.61,139,74666,70,NULL,NULL,'2MASX J22551617-1843274',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'17.26',0.32,NULL,NULL,NULL,NULL,NULL,1,343.817375,-18.72428,0.057,NULL,50443404833,788178200,12315284,17.26),(158622,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09324','RN',158622,41.2,0.29,1260,74667,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09324',0.378093,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158623,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09324','RN',158623,41.24,0.31,1290,74667,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09324',0.378093,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158624,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09324','N',158624,41.09,0.2,1650,74667,70,NULL,'SALT 2','SDSS-II SN 09324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158625,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09324','N',158625,41.15,0.2,1700,74667,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09324',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158626,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158626,37.16,0.92,270,74668,70,NULL,NULL,'2MASX J22551913-0313388',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.56',0.37,NULL,NULL,NULL,NULL,NULL,1,343.829667,-3.22756,0.185,NULL,49523020639,773797197,12090581,16.56),(158627,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158627,38.23,0.46,443,74669,70,NULL,NULL,'2MASX J22551986+0059156',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,343.8327083,0.98772,0.197,NULL,51732984326,808327880,12630123,17.4),(158628,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158628,35.05,NULL,102,74670,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12249',NULL,'2010Ap&SS.325..163P',2010,1,1.15,NULL,'G',0.000012,NULL,'16.0',0.1,'Scd',NULL,NULL,NULL,NULL,1,343.8335417,28.34628,0.165,NULL,51929081125,811391892,12677998,16),(158629,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158629,35.06,NULL,103,74670,NULL,NULL,'Dipole + Quadrupole','UGC 12249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158630,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158630,35.08,NULL,104,74670,NULL,NULL,'Dipole','UGC 12249',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158631,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158631,35.1,NULL,105,74670,NULL,NULL,NULL,'UGC 12249',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158632,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158632,35.12,0.49,105,74670,75,NULL,'IR','UGC 12249',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158633,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158633,35.19,0.42,109,74670,NULL,NULL,'Malmquist cor.','UGC 12249',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158634,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158634,35.24,0.43,112,74670,75,NULL,'3.6 micron, color corrected','UGC 12249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158635,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158635,35.27,0.2,113,74670,74.4,NULL,NULL,'UGC 12249',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158636,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158636,35.29,0.43,114,74670,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12249',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158637,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158637,35.34,0.39,117,74670,NULL,NULL,NULL,'UGC 12249',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158638,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158638,38.41,0.46,480,74671,70,NULL,NULL,'2MASX J22552145-0056518',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.1g',0.28,'AGN',NULL,NULL,NULL,NULL,1,343.839458333,-0.94778,0.177,NULL,49514407474,773662616,12088478,17.1),(158639,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158639,36.34,0.76,185,74672,70,NULL,NULL,'2MASX J22552594-8446268',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.6b',NULL,NULL,NULL,NULL,NULL,NULL,1,343.858667,-84.77408,0.389,NULL,48380910087,755951720,11811745,16.6),(158640,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 18275',NULL,158640,38.26,0.6,449,74673,70,NULL,'SN photometric redshift distance, z photo =0.111 +/- 0.038','SDSS-II SN 18275',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.8g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,343.873333,-0.62231,0.213,NULL,49497909424,773404834,12084450,22.8),(158641,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 18275','R',158641,42.43,0.42,2080,74673,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18275',0.472048,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158642,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13738','RN',158642,44.02,0.55,4540,74674,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13738',0.406084,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158643,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13738','RN',158643,45.99,0.72,11200,74674,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13738',0.406084,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158644,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158644,37.64,0.46,337,74675,70,NULL,NULL,'2MASX J22553551+1443278',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000179,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,343.8980417,14.72431,0.165,NULL,52602735484,821917741,12842464,16.9),(158645,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158645,37.51,0.46,317,74676,70,NULL,NULL,'2MASX J22553569+1331078',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000146,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,343.898583,13.51886,0.165,NULL,52557196756,821206199,12831346,18.1),(158646,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158646,34.44,0.51,77.2,74677,NULL,NULL,'Malmquist cor.','UGC 12250',NULL,'2009ApJS..182..474S',2009,1,1.38,NULL,'G',0.00006,NULL,'14.2g',1.05,'SBb',NULL,NULL,NULL,NULL,1,343.899625,12.79031,0.113,NULL,52558820509,821231570,12831743,14.2),(158647,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158647,34.63,0.47,84.1,74677,NULL,NULL,NULL,'UGC 12250',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158648,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158648,34.82,0.2,92,74677,74.4,NULL,NULL,'UGC 12250',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158649,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158649,34.97,0.47,98.5,74677,NULL,NULL,'H','UGC 12250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158650,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158650,35.01,0.45,101,74677,NULL,NULL,'K','UGC 12250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158651,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158651,35.02,0.4,101,74677,NULL,NULL,'mean','UGC 12250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158652,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158652,35.04,0.46,102,74677,NULL,NULL,'J','UGC 12250',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158653,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158653,37.81,0.46,364,74678,70,NULL,NULL,'2MASX J22553651+1354458',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000155,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,343.9019583,13.91289,0.169,NULL,52557126073,821205094,12831329,17.9),(158654,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158654,37.5,0.46,316,74679,70,NULL,NULL,'2MASX J22553780-0924258',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000156,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.907541667,-9.40725,0.093,NULL,50381272465,787207382,12300115,17.7),(158655,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158655,34.4,0.8,75.8,74680,75,NULL,'MAT, I','ESO 534- G 031',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000023,NULL,'14.56',0.7,'Sc',NULL,NULL,NULL,NULL,1,343.9175,-23.95383,0.041,NULL,50216405598,784631337,12259864,14.56),(158656,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158656,33.28,0.32,45.3,74680,85,NULL,'I, raw','ESO 534- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158657,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158657,33.29,0.32,45.5,74680,85,NULL,'I, inv','ESO 534- G 031',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158658,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158658,33.29,0.43,45.6,74680,75,NULL,'MAT, I, raw','ESO 534- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158659,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158659,33.36,0.43,47,74680,75,NULL,'MAT, I, inv','ESO 534- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158660,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158660,33.46,0.43,49.2,74680,75,NULL,'MAT, I, cor','ESO 534- G 031',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158661,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158661,32.8,0.8,36.3,74681,75,NULL,'B','NGC 7416',NULL,'1988NBGC.C....0000T',1988,1,3.2,NULL,'G',0.000025,NULL,'12.63',0.9,'SB(r)b         HII','Group member',NULL,NULL,NULL,1,343.92375,-5.49533,0.145,NULL,49518237721,773722464,12089413,12.63),(158662,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158662,32.36,0.46,29.6,74681,NULL,NULL,'J','NGC 7416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158663,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158663,32.44,0.47,30.7,74681,NULL,NULL,'H','NGC 7416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158664,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158664,32.51,0.45,31.7,74681,NULL,NULL,'K','NGC 7416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158665,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158665,32.51,0.2,31.8,74681,74.4,NULL,NULL,'NGC 7416',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158666,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158666,32.53,0.43,32.1,74681,75,NULL,'3.6 micron, color corrected','NGC 7416',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158667,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158667,32.63,0.43,33.6,74681,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7416',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158668,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158668,32.65,0.52,33.9,74681,NULL,NULL,NULL,'NGC 7416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158669,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158669,32.7,0.4,34.7,74681,NULL,NULL,'mean','NGC 7416',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158670,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158670,32.72,0.5,35,74681,NULL,NULL,'Malmquist cor.','NGC 7416',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158671,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158671,37.77,0.46,358,74682,70,NULL,NULL,'2MASX J22554270+0105231',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00015,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,343.927791667,1.08981,0.193,NULL,51733009055,808328266,12630129,17.7),(158672,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158672,34.87,0.8,94.3,74683,75,NULL,'W91PP, r','UGC 12252',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000012,NULL,'16.0',0.18,'Sc',NULL,NULL,NULL,NULL,1,343.93025,31.77153,0.269,NULL,51923003324,811296926,12676514,16),(158673,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158673,34.68,NULL,86.3,74683,NULL,NULL,'Dipole','UGC 12252',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158674,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158674,34.68,NULL,86.5,74683,NULL,NULL,'Dipole + Quadrupole','UGC 12252',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158675,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158675,34.69,NULL,86.5,74683,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12252',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158676,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158676,34.82,NULL,92,74683,NULL,NULL,NULL,'UGC 12252',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158677,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158677,34.97,0.37,98.7,74683,NULL,NULL,'Malmquist cor.','UGC 12252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158678,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158678,35.02,0.38,101,74683,75,NULL,'W91PP, r, raw','UGC 12252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158679,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158679,35.06,0.35,103,74683,NULL,NULL,NULL,'UGC 12252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158680,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158680,35.07,0.38,103,74683,75,NULL,'W91PP, r, inv','UGC 12252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158681,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158681,35.1,0.38,105,74683,75,NULL,'W91PP, r, cor','UGC 12252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158682,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158682,35.15,0.2,107,74683,74.4,NULL,NULL,'UGC 12252',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158683,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158683,35.25,0.49,112,74683,75,NULL,'IR','UGC 12252',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158684,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158684,35.26,0.43,113,74683,75,NULL,'3.6 micron, color corrected','UGC 12252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158685,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158685,35.38,0.43,119,74683,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158686,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 20987','RN',158686,41.33,0.4,1640,74684,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20987',0.12206,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158687,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 20987','RN',158687,41.53,0.32,1810,74684,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20987',0.12206,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158688,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158688,31.64,0.8,21.3,74685,75,NULL,'MAT, I','NGC 7412',NULL,'1997ApJS..109..333W',1997,1,3.9,NULL,'G',0.000013,NULL,'11.88',2.9,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,343.940625,-42.64203,0,NULL,50487840959,788872514,12326133,11.88),(158689,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158689,28.95,0.43,6.2,74685,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7412',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158690,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158690,29.03,0.32,6.41,74685,85,NULL,'I, inv','NGC 7412',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158691,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158691,29.06,0.32,6.51,74685,85,NULL,'I, raw','NGC 7412',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158692,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158692,29.29,0.43,7.2,74685,75,NULL,'3.6 micron, color corrected','NGC 7412',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158693,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158693,29.36,0.43,7.44,74685,75,NULL,'MAT, I, inv','NGC 7412',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158694,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158694,29.43,0.43,7.69,74685,75,NULL,'MAT, I, raw','NGC 7412',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158695,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158695,29.57,0.2,8.2,74685,74.4,NULL,NULL,'NGC 7412',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158696,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158696,29.64,0.36,8.47,74685,NULL,NULL,NULL,'NGC 7412',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158697,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158697,29.75,0.43,8.91,74685,75,NULL,'MAT, I, cor','NGC 7412',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158698,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158698,30.59,0.39,13.1,74685,73,NULL,'opt','NGC 7412',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158699,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158699,31.62,0.4,21.1,74685,75,NULL,'B','NGC 7412',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158700,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158700,35.99,0.46,158,74686,70,NULL,NULL,'2MASX J22554693-0854575',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000103,NULL,'15.7g',0.37,'E0',NULL,NULL,NULL,NULL,1,343.945667,-8.91606,0.093,NULL,50381217901,787206529,12300102,15.7),(158701,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158701,37.56,0.46,325,74687,70,NULL,NULL,'2MASX J22554824+1330248',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000149,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,343.951,13.50678,0.165,NULL,52557077918,821204342,12831317,17.6),(158702,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158702,36.62,0.33,211,74688,70,NULL,NULL,'2MASX J22554841-1019285',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,343.9517917,-10.32472,0.117,NULL,50379419893,787178435,12299663,16.7),(158703,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158703,39.21,0.46,696,74689,70,NULL,NULL,'SDSS J225548.66+125931.2',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000155,NULL,'18.8g',0.13,NULL,NULL,NULL,NULL,NULL,1,343.952791667,12.99203,0.113,NULL,52558719206,821229987,12831718,18.8),(158704,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158704,37.9,0.46,380,74690,70,NULL,NULL,'2MASX J22555349-1017365',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000168,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.972917,-10.29361,0.133,NULL,50379414700,787178354,12299661,17.7),(158705,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158705,38.21,0.23,438,74691,70,NULL,NULL,'2MASX J22555395-0039072',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,343.974833,-0.65192,0.213,NULL,49497957967,773405593,12084462,17.2),(158706,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158706,34.6,0.39,83.2,74692,NULL,NULL,NULL,'CGCG 496-024',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000033,NULL,'14.86',0.5,'S?             HII',NULL,NULL,NULL,NULL,1,343.980583,31.67158,0.269,NULL,51923058683,811297791,12676527,14.86),(158707,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158707,34.75,0.36,89.2,74692,NULL,NULL,'Malmquist cor.','CGCG 496-024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158708,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158708,35.1,0.2,105,74692,74.4,NULL,NULL,'CGCG 496-024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158709,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158709,32.82,0.8,36.7,74693,75,NULL,'MAT, I','IC 5269A',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000013,NULL,'13.88',1,'SB(s)m:','Isolated galaxy',NULL,NULL,NULL,1,343.98225,-36.34917,NULL,NULL,50701553773,792211777,12378309,13.88),(158710,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158710,32.48,0.32,31.4,74693,85,NULL,'I, inv','IC 5269A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158711,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158711,32.51,0.32,31.7,74693,85,NULL,'I, raw','IC 5269A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158712,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158712,32.84,0.4,37,74693,NULL,NULL,NULL,'IC 5269A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158713,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158713,32.86,0.09,37.4,74693,NULL,NULL,NULL,'IC 5269A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158714,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158714,32.89,0.43,37.8,74693,75,NULL,'MAT, I, inv','IC 5269A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158715,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158715,32.9,0.43,37.9,74693,75,NULL,'MAT, I, raw','IC 5269A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158716,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158716,33.02,0.43,40.2,74693,75,NULL,'MAT, I, cor','IC 5269A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158717,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158717,37.53,0.33,321,74694,70,NULL,NULL,'2MASX J22555663+1509478',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000162,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,343.985917,15.16311,0.161,NULL,52610051932,822032061,12844250,17),(158718,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158718,37.85,0.46,371,74695,70,NULL,NULL,'2MASX J22555669+0050131',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000119,NULL,'18.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,343.986167,0.83706,0.149,NULL,51699636187,807806815,12621981,18.5),(158719,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158719,33.28,0.8,45.4,74696,75,NULL,'MAT, I','NGC 7408',NULL,'1997ApJS..109..333W',1997,1,1.5,'The APMUKS position is north of the nucleus.','G',0.000031,NULL,'13.33',1.2,'(R\')SB(rs)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,343.986917,-63.69472,0,NULL,48760249799,761878903,11904357,13.33),(158720,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158720,32.73,0.32,35.2,74696,85,NULL,'I, inv','NGC 7408',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158721,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158721,32.75,0.32,35.5,74696,85,NULL,'I, raw','NGC 7408',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158722,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158722,32.99,0.43,39.6,74696,75,NULL,'MAT, I, inv','NGC 7408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158723,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158723,32.99,0.43,39.7,74696,75,NULL,'MAT, I, raw','NGC 7408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158724,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158724,33.12,0.43,42.1,74696,75,NULL,'MAT, I, cor','NGC 7408',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158725,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158725,33.14,0.47,42.4,74696,NULL,NULL,'H','NGC 7408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158726,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158726,33.25,0.46,44.6,74696,NULL,NULL,'J','NGC 7408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158727,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158727,33.32,0.4,46.2,74696,NULL,NULL,'mean','NGC 7408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158728,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158728,33.34,0.45,46.5,74696,NULL,NULL,'K','NGC 7408',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158729,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158729,34.35,0.48,74,74697,70,NULL,NULL,'ESO 076- G 031',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'13.93',1,'S0- pec:','Pair member (points to parent)',NULL,NULL,NULL,1,343.987333,-70.57367,0.021,NULL,49269823603,769840993,12028765,13.93),(158730,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158730,36.68,0.7,217,74698,70,NULL,NULL,'2MASX J22555800-0408332',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'17.12',0.23,NULL,NULL,NULL,NULL,NULL,1,343.991583333,-4.14256,0.165,NULL,49520615432,773759616,12089994,17.12),(158731,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'RN',158731,41.71,0.62,1110,74699,73,NULL,'H const./H=100','GRB 010921 OT',0.451,'2006astro.ph..9262M',2006,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158732,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'RN',158732,41.85,0.46,1620,74699,73,NULL,'H const./H=100','GRB 010921 OT',0.451,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158733,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'RN',158733,42.34,0.62,2020,74699,72,NULL,NULL,'GRB 010921 OT',0.451,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158734,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'N',158734,42.35,0.6,2030,74699,70,NULL,NULL,'GRB 010921 OT',0.451,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158735,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'N',158735,42.53,0.54,2210,74699,69.7,NULL,'Calibrated','GRB 010921 OT',0.451,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158736,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'N',158736,43,0.58,2740,74699,69.7,NULL,'Fiducial','GRB 010921 OT',0.451,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158737,'GRB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158737,41.42,NULL,1920,74700,70,NULL,'Pseudo z = 0.62','GRB 010921',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE/Ulysses',NULL,NULL,NULL,NULL,1,343.9997083,40.93133,0.685,NULL,55341418641,864709666,13511088,NULL),(158738,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158738,37.53,0.33,321,74701,70,NULL,NULL,'2MASX J22560016+1510468',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000156,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,344.000541667,15.17953,0.161,NULL,52610051804,822032059,12844250,17.4),(158739,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158739,36.63,0.33,212,74702,70,NULL,NULL,'2MASX J22560014-0006382',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000166,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.000625,-0.11061,0.201,NULL,49497630797,773400481,12084382,17.1),(158740,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158740,34.22,0.49,69.7,74703,75,NULL,'IR','UGC 12253',NULL,'2011yCatp016004901K',2011,1,1.83,NULL,'G',0.000022,':','16.0',0.16,'Sbc',NULL,NULL,NULL,NULL,1,344.007625,12.76664,0.113,NULL,52558768946,821230764,12831730,16),(158741,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158741,34.55,0.2,81.3,74703,74.4,NULL,NULL,'UGC 12253',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158742,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158742,34.63,NULL,84.2,74703,NULL,NULL,'Dipole','UGC 12253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158743,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158743,34.63,NULL,84.4,74703,NULL,NULL,'Dipole + Quadrupole','UGC 12253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158744,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158744,34.64,NULL,84.5,74703,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12253',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158745,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158745,34.64,0.56,84.8,74703,NULL,NULL,'Malmquist cor.','UGC 12253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158746,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158746,34.66,0.56,85.6,74703,NULL,NULL,NULL,'UGC 12253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158747,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158747,36.62,0.33,211,74704,70,NULL,NULL,'2MASX J22560230-1019085',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000167,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,344.009667,-10.31911,0.133,NULL,50379422648,787178478,12299663,16.9),(158748,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158748,34.47,0.45,78.3,74705,NULL,NULL,NULL,'ESO 147- G 014',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.45',0.6,'SB:(r)a:',NULL,NULL,NULL,NULL,1,344.023208333,-58.39658,0,NULL,48851500825,763304700,11926635,14.45),(158749,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158749,34.51,0.2,79.8,74705,74.4,NULL,NULL,'ESO 147- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158750,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158750,34.56,0.43,81.5,74705,NULL,NULL,'Malmquist cor.','ESO 147- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158751,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158751,36.83,0.46,232,74706,70,NULL,NULL,'2MASX J22561082-0854005',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000154,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.0449583,-8.90014,0.093,NULL,50381254663,787207104,12300111,17.3),(158752,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158752,33.9,0.4,60.4,74707,NULL,NULL,'mean','NGC 7422',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000027,NULL,'14.18',0.8,'SB(s)b:',NULL,NULL,NULL,NULL,1,344.051583333,3.92678,0.173,NULL,51737496295,808398379,12631224,14.18),(158753,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158753,34.13,0.47,66.9,74707,NULL,NULL,'H','NGC 7422',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158754,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13625','RN',158754,41.01,0.1,1340,74708,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13625',0.191387,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158755,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158755,38.21,0.23,438,74709,70,NULL,NULL,'2MASX J22561482-0034520',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000133,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,344.061833,-0.581,0.213,NULL,49497992245,773406128,12084470,17.9),(158756,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158756,36.63,0.33,212,74710,70,NULL,NULL,'2MASX J22561934-0006150',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,344.080583,-0.10422,0.201,NULL,49497634983,773400546,12084383,17.9),(158757,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158757,37.88,0.46,376,74711,70,NULL,NULL,'2MASX J22562128+0029434',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000153,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,344.0885,0.4955,0.149,NULL,51700026487,807812913,12622076,17.6),(158758,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158758,38.19,0.46,434,74712,70,NULL,NULL,'2MASX J22562126+1324431',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'18.2g',0.13,NULL,NULL,NULL,NULL,NULL,1,344.0885417,13.41178,0.165,NULL,52557058778,821204043,12831313,18.2),(158759,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158759,37,0.46,251,74713,70,NULL,NULL,'2MASX J22562281-0016589',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.8g',0.24,NULL,NULL,NULL,NULL,NULL,1,344.094958333,-0.28297,0.201,NULL,49497589871,773399841,12084372,16.8),(158760,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 07439','RN',158760,38.72,0.35,515,74714,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07439',0.078804,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158761,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17169','RN',158761,40.11,0.23,862,74715,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17169',0.220524,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158762,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17169','RN',158762,40.37,0.18,974,74715,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17169',0.220524,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158763,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158763,33.72,0.49,55.5,74716,75,NULL,'IR','CGCG 515-013',NULL,'2011yCatp016004901K',2011,1,0.75,NULL,'G',0.000033,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,344.103625,36.24164,0.401,NULL,55516854063,867450844,13553919,15.6),(158764,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158764,37.56,0.46,325,74717,70,NULL,NULL,'2MASX J22562523+1454221',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000151,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,344.105125,14.90603,0.161,NULL,52609347631,822021056,12844079,17.2),(158765,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 06213','R',158765,38.73,0.24,502,74718,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 06213',0.109221,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,344.105833,-0.44994,0.217,NULL,49498008162,773406377,12084474,NULL),(158766,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 06213','R',158766,38.89,0.27,542,74718,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 06213',0.109221,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158767,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17682','R',158767,40.25,0.32,861,74719,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17682',0.304812,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,344.107625,0.50142,0.149,NULL,51700026879,807812919,12622076,20.9),(158768,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17682','R',158768,40.5,0.25,963,74719,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17682',0.304812,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158769,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 17682',NULL,158769,40.7,0.25,1380,74719,70,NULL,'SN photometric redshift distance, z photo =0.398 +/- 0.065','SDSS-II SN 17682',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158770,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158770,38.21,0.23,438,74720,70,NULL,NULL,'2MASX J22562655-0032359',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000138,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,344.110667,-0.54325,0.217,NULL,49497986614,773406040,12084469,18.4),(158771,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158771,37.06,0.46,259,74721,70,NULL,NULL,'2MASX J22562686+0110084',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000188,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.1119583,1.16903,0.193,NULL,51733026957,808328546,12630133,17.7),(158772,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158772,33.97,0.44,62.2,74722,NULL,NULL,'Malmquist cor.','UGC 12259',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000017,NULL,'16.0',0.3,'SB?',NULL,NULL,NULL,NULL,1,344.112375,18.70486,0.181,NULL,52568667403,821385428,12834147,16),(158773,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158773,34.04,0.2,64.3,74722,74.4,NULL,NULL,'UGC 12259',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158774,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158774,34.15,0.41,67.5,74722,NULL,NULL,NULL,'UGC 12259',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158775,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158775,38.21,0.23,438,74723,70,NULL,NULL,'2MASX J22562868-0031149',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000155,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,344.1194583,-0.52081,0.217,NULL,49498014520,773406476,12084476,18.3),(158776,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158776,37.75,0.46,355,74724,70,NULL,NULL,'2MASX J22562907+0027584',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000176,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.121,0.46617,0.149,NULL,51699997875,807812466,12622069,17.2),(158777,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158777,34.6,0.49,83.3,74725,75,NULL,'IR','UGC 12258',NULL,'2011yCatp016004901K',2011,1,1.5,'1999ApJS..121..287H has V = 6974 +- 31 km/sec.','G',0.000067,NULL,'14.94',0.3,'Sa',NULL,NULL,NULL,NULL,1,344.130667,17.78444,0.281,NULL,52598680284,821854379,12841474,14.94),(158778,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158778,34.97,0.47,98.7,74725,NULL,NULL,'H','UGC 12258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158779,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158779,35.06,0.45,103,74725,NULL,NULL,'K','UGC 12258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158780,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158780,35.13,0.46,106,74725,NULL,NULL,'J','UGC 12258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158781,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158781,35.46,0.4,124,74725,NULL,NULL,'mean','UGC 12258',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158782,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158782,34.3,0.8,72.6,74726,75,NULL,'W91PP, r','UGC 12260',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.42',0.3,'Sd','Isolated galaxy',NULL,NULL,NULL,1,344.1327917,37.73919,0.589,NULL,55517626518,867462914,13554108,15.42),(158783,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158783,34.14,0.49,67.4,74726,75,NULL,'IR','UGC 12260',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158784,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158784,34.19,0.38,68.8,74726,NULL,NULL,NULL,'UGC 12260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158785,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158785,34.19,0.2,68.9,74726,74.4,NULL,NULL,'UGC 12260',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158786,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158786,34.26,0.38,71.2,74726,75,NULL,'W91PP, r, raw','UGC 12260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158787,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158787,34.3,0.38,72.5,74726,75,NULL,'W91PP, r, inv','UGC 12260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158788,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158788,34.45,0.34,77.5,74726,NULL,NULL,'Malmquist cor.','UGC 12260',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158789,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158789,34.49,0.38,79.2,74726,75,NULL,'W91PP, r, cor','UGC 12260',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158790,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158790,38.14,0.46,425,74727,70,NULL,NULL,'SDSS J225633.91-082316.3',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,344.141333,-8.38789,0.093,NULL,50372246616,787066353,12297911,18.5),(158791,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158791,36.46,0.77,196,74728,70,NULL,NULL,'2MASX J22563554-0143419',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.13',0.42,NULL,NULL,NULL,NULL,NULL,1,344.1480417,-1.72828,0.205,NULL,49517379136,773709049,12089203,16.13),(158792,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158792,31.29,0.8,18.1,74729,75,NULL,'MAT, I','NGC 7418',NULL,'1997ApJS..109..333W',1997,1,3.5,NULL,'G',0.000017,NULL,'12.30',2.6,'SAB(rs)cd      HII','X-ray-bright group member',NULL,NULL,NULL,1,344.150667,-37.03008,NULL,NULL,50701307311,792207926,12378248,12.3),(158793,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158793,31.1,0.4,16.6,74729,NULL,NULL,NULL,'NGC 7418',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158794,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158794,31.1,0.39,16.6,74729,73,NULL,'opt','NGC 7418',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158795,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158795,31.15,0.32,17,74729,85,NULL,'I, raw','NGC 7418',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158796,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158796,31.18,0.32,17.2,74729,85,NULL,'I, inv','NGC 7418',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158797,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158797,31.21,0.43,17.5,74729,75,NULL,'MAT, I, raw','NGC 7418',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158798,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158798,31.25,0.4,17.8,74729,75,NULL,'B','NGC 7418',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158799,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158799,31.37,0.43,18.8,74729,75,NULL,'MAT, I, inv','NGC 7418',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158800,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158800,31.5,0.43,19.9,74729,75,NULL,'MAT, I, cor','NGC 7418',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158801,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158801,31.5,0.4,20,74729,NULL,NULL,'mean','NGC 7418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158802,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158802,31.81,0.45,23.1,74729,NULL,NULL,'K','NGC 7418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158803,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158803,31.82,0.47,23.1,74729,NULL,NULL,'H','NGC 7418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158804,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158804,31.86,0.46,23.6,74729,NULL,NULL,'J','NGC 7418',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158805,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158805,31.58,0.8,20.7,74730,75,NULL,'A82, H','IC 5269B',NULL,'1997ApJS..109..333W',1997,1,4.1,'The APM position is 15 arcsec west of the nucleus.','G',0.000013,NULL,'13.2',0.8,'SB(rs)cd:','X-ray-bright group member',NULL,NULL,NULL,1,344.153,-36.24978,NULL,NULL,50701786088,792215407,12378365,13.2),(158806,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158806,31.6,0.8,20.9,74730,75,NULL,'MAT, I','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158807,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158807,31.56,0.8,20.5,74730,75,NULL,NULL,'IC 5269B',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158808,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158808,31.36,0.39,18.7,74730,73,NULL,'IR','IC 5269B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158809,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158809,31.36,0.4,18.7,74730,75,NULL,NULL,'IC 5269B',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158810,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158810,31.52,0.2,20.1,74730,74.4,NULL,NULL,'IC 5269B',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158811,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158811,31.53,0.43,20.2,74730,75,NULL,'3.6 micron, color corrected','IC 5269B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158812,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158812,31.54,0.32,20.3,74730,85,NULL,'I, raw','IC 5269B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158813,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158813,31.54,0.32,20.3,74730,85,NULL,'I, inv','IC 5269B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158814,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158814,31.61,0.38,21,74730,NULL,NULL,NULL,'IC 5269B',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158815,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158815,31.63,0.43,21.2,74730,75,NULL,'3.6 micron, color + selection bias corrected','IC 5269B',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158816,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158816,31.67,0.43,21.6,74730,75,NULL,'MAT, I, raw','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158817,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158817,31.68,0.49,21.7,74730,75,NULL,'IR','IC 5269B',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158818,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158818,31.74,0.43,22.2,74730,75,NULL,'MAT, I, inv','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158819,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158819,31.81,0.47,23.1,74730,75,NULL,'A82, H, inv','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158820,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158820,31.84,0.4,23.3,74730,NULL,NULL,'mean','IC 5269B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158821,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158821,31.87,0.47,23.6,74730,75,NULL,'A82, H, raw','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158822,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158822,31.87,0.55,23.7,74730,NULL,NULL,NULL,'IC 5269B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158823,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158823,31.92,0.43,24.2,74730,75,NULL,'MAT, I, cor','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158824,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158824,31.95,0.39,24.6,74730,73,NULL,'opt','IC 5269B',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158825,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158825,32.04,0.51,25.6,74730,NULL,NULL,'Malmquist cor.','IC 5269B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158826,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158826,32.15,0.47,26.9,74730,75,NULL,'A82, H, cor','IC 5269B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158827,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158827,32.56,0.46,32.6,74730,NULL,NULL,'J','IC 5269B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158828,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158828,32.67,0.47,34.2,74730,NULL,NULL,'H','IC 5269B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158829,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158829,32.87,0.45,37.6,74730,NULL,NULL,'K','IC 5269B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158830,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158830,37.71,0.46,348,74731,70,NULL,NULL,'2MASX J22563747-0910245',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000175,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,344.156166667,-9.1735,0.093,NULL,50381452555,787210196,12300159,17.5),(158831,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158831,32.02,0.8,25.4,74732,75,NULL,NULL,'NGC 7418A',NULL,'1988NBGC.C....0000T',1988,1,3.7,NULL,'G',0.000013,NULL,'13.82',1.8,'SA(rs)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.171875,-36.77272,NULL,NULL,50701526010,792211343,12378302,13.82),(158832,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158832,32.71,0.43,34.8,74732,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7418A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158833,'BL Lac Luminosity','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158833,40.98,NULL,1570,74733,70,NULL,'nucleus-to-host flux ratio, z > 0.47','PKS 2254-204',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'17.5',NULL,'BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,344.1717083,-20.19458,0.064,NULL,50446831661,788231744,12316121,17.5),(158834,'CMD','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'N',158834,20.4,NULL,0.12,74734,NULL,NULL,NULL,'Grus 1',NULL,'2015ApJ...805..130K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158835,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158835,38.5,0.46,501,74735,70,NULL,NULL,'SDSS J225642.70-004107.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,344.1779583,-0.6855,0.205,NULL,49497804762,773403199,12084424,18.5),(158836,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158836,34.76,NULL,89.5,74736,NULL,NULL,'B','ESO 534- G 032',NULL,'2005Ap&SS.298..577R',2005,1,1.22,NULL,'G',0.000077,NULL,'14.45',0.47,'SAB(s)c:',NULL,NULL,NULL,NULL,1,344.187125,-24.95253,0.059,NULL,50112064600,783001009,12234390,14.45),(158837,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158837,34.89,NULL,95.1,74736,NULL,NULL,'I','ESO 534- G 032',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158838,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158838,35.3,0.38,115,74736,NULL,NULL,NULL,'ESO 534- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158839,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158839,35.31,0.2,115,74736,74.4,NULL,NULL,'ESO 534- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158840,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158840,35.32,0.38,116,74736,NULL,NULL,'Malmquist cor.','ESO 534- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158841,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158841,40.13,0.15,823,74737,74.2,NULL,'SALT 2','SDSS J225648.48+002402.0',0.29,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',0.0005,NULL,'20.7g',0.05,NULL,NULL,NULL,NULL,NULL,1,344.2020417,0.40058,0.149,NULL,51699810570,807809540,12622024,20.7),(158842,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158842,40.68,0.06,1060,74737,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02789, SN 2005fx','SDSS J225648.48+002402.0',0.29,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158843,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 02789','R',158843,40.81,0.24,1130,74737,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fx','SDSS J225648.48+002402.0',0.2903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158844,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158844,40.27,0.15,1130,74737,70,NULL,'Hubble residual 0.12 for z0.29030','SDSS J225648.48+002402.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158845,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158845,40.89,0.17,1170,74737,70,NULL,'SALT 2','SDSS J225648.48+002402.0',0.29,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158846,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158846,40.88,NULL,1170,74737,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 02789, SN 2005fx','SDSS J225648.48+002402.0',0.29,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158847,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158847,40.89,0.16,1170,74737,65,NULL,'SALT2','SDSS J225648.48+002402.0',0.29,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158848,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 02789','R',158848,41.1,0.19,1290,74737,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fx','SDSS J225648.48+002402.0',0.2903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158849,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158849,41.13,0.14,1300,74737,65,NULL,'MLCS2k2','SDSS J225648.48+002402.0',0.29,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158850,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158850,40.69,0.14,1370,74737,70,NULL,'SALT 2','SDSS J225648.48+002402.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158851,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 2005fx',NULL,158851,40.72,0.14,1390,74737,70,NULL,'SALT 2, Malmquist cor.','SDSS J225648.48+002402.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158852,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158852,37.36,0.46,296,74738,70,NULL,NULL,'2MASX J22564915+1406497',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000157,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.20475,14.11389,0.181,NULL,52556796964,821199952,12831249,17),(158853,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158853,36.09,0.46,165,74739,NULL,NULL,'Malmquist cor.','VV 488',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'S+S',NULL,NULL,NULL,NULL,1,344.207917,-8.96917,0.093,NULL,50381232322,787206755,12300105,NULL),(158854,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158854,36.1,0.46,166,74739,NULL,NULL,NULL,'VV 488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158855,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158855,31.93,0.8,24.3,74740,75,NULL,'MAT, I','IC 5264',NULL,'1997ApJS..109..333W',1997,1,2.5,'ESO-LV gives v=5018 and Nordgren (1998,ApJS,115,43) has v=5050 km/sec.','G',0.000033,NULL,'13.72',0.5,'Sab pec sp','X-ray-bright group member',NULL,NULL,NULL,1,344.221,-36.55417,NULL,NULL,50701468294,792210442,12378288,13.72),(158856,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158856,33.55,0.43,51.2,74740,75,NULL,'MAT, I, raw','IC 5264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158857,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158857,33.65,0.32,53.7,74740,85,NULL,'I, raw','IC 5264',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158858,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158858,33.73,0.32,55.6,74740,85,NULL,'I, inv','IC 5264',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158859,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158859,33.76,0.43,56.5,74740,75,NULL,'MAT, I, cor','IC 5264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158860,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158860,33.86,0.43,59,74740,75,NULL,'MAT, I, inv','IC 5264',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158861,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158861,32.99,0.8,39.7,74741,75,NULL,NULL,'UGC 12263',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000013,NULL,'17.',1.8,'Im?',NULL,NULL,NULL,NULL,1,344.255458333,72.70853,2.453,NULL,52805992292,825093629,12892087,17),(158862,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19201','RN',158862,40.33,0.13,1060,74742,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19201',0.100119,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158863,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19201','RN',158863,40.56,0.27,1180,74742,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19201',0.100119,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158864,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158864,37.54,0.33,322,74743,70,NULL,NULL,'2MASX J22570246-0101410',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.0002,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,344.260375,-1.02797,0.189,NULL,49497462334,773397848,12084341,16.2),(158865,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19209',NULL,158865,37.37,0.88,297,74744,70,NULL,'SN photometric redshift distance, z photo =0.072 +/- 0.038','SDSS-II SN 19209',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,344.2632917,-0.88775,0.205,NULL,49497450978,773397671,12084338,NULL),(158866,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19209','R',158866,39.4,0.15,671,74744,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 19209',0.128384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158867,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 19209','R',158867,39.53,0.21,713,74744,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19209',0.128384,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158868,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158868,37.57,0.33,326,74745,70,NULL,NULL,'2MASX J22570477-0942094',NULL,'2015arXiv151105856S',2015,1,0.53,NULL,'G',0.00015,NULL,'16.1g',0.44,'E0',NULL,NULL,NULL,NULL,1,344.269917,-9.70256,0.069,NULL,50381958584,787218102,12300282,16.1),(158869,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158869,35.62,0.65,133,74746,70,NULL,NULL,'2MASX J22570602-1406502',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.000103,NULL,'15.47',0.42,NULL,NULL,NULL,NULL,NULL,1,344.275041667,-14.11403,0.093,NULL,50404186694,787565417,12305709,15.47),(158870,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158870,37.54,0.33,322,74747,70,NULL,NULL,'2MASX J22570792-0100223',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,344.282917,-1.00625,0.205,NULL,49497492652,773398322,12084348,16.8),(158871,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158871,30.26,0.8,11.3,74748,75,NULL,NULL,'NGC 7412A',NULL,'1988NBGC.C....0000T',1988,1,5.11,'The APM data are for the brighter eastern end.','G',0.00001,NULL,'14.5',0.5,'SBdm: sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.2875417,-42.80447,NULL,NULL,50487309592,788864212,12326003,14.5),(158872,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158872,27.08,0.38,2.61,74748,NULL,NULL,NULL,'NGC 7412A',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158873,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158873,30.03,NULL,10.2,74748,NULL,NULL,'Dipole + Quadrupole + Octopole','NGC 7412A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158874,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158874,30.06,NULL,10.3,74748,NULL,NULL,'Dipole + Quadrupole','NGC 7412A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158875,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158875,30.07,NULL,10.3,74748,NULL,NULL,'Dipole','NGC 7412A',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158876,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158876,30.19,0.4,10.9,74748,73,NULL,'opt','NGC 7412A',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158877,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158877,30.51,NULL,12.6,74748,NULL,NULL,NULL,'NGC 7412A',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158878,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158878,38.52,0.46,506,74749,70,NULL,NULL,'2MASX J22571050-1008354',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000191,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,344.2937083,-10.14311,0.061,NULL,50381576659,787212135,12300189,17.1),(158879,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158879,32.29,0.14,28.7,74750,74.4,NULL,NULL,'IC 1459',NULL,'2013AJ....146...86T',2013,1,5.2,'Confused HIPASS source','G',0.000039,NULL,'10.97',3.8,'E3             LINER','X-ray-bright group member',NULL,NULL,'Flat-Spectrum Radio Source',1,344.294208333,-36.46222,NULL,NULL,50701633112,792213017,12378328,10.97),(158880,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158880,32.33,0.28,29.2,74750,NULL,NULL,'I','IC 1459',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158881,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158881,32.33,0.28,29.2,74750,NULL,NULL,NULL,'IC 1459',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158882,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158882,32.41,0.28,30.4,74750,NULL,NULL,'Malmquist cor.','IC 1459',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158883,'D-Sigma','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158883,31.93,0.4,24.3,74750,75,NULL,'Edat, raw','IC 1459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158884,'D-Sigma','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158884,32.26,0.4,28.3,74750,75,NULL,'Edat, cor','IC 1459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158885,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158885,30.65,0.63,13.5,74750,95,NULL,'Michard 1979b, c','IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158886,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158886,30.82,0.37,14.6,74750,95,NULL,'Weighted Mean','IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158887,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158887,30.98,0.46,15.7,74750,95,NULL,'Michard 1979a','IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158888,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158888,32.42,0.81,30.5,74750,55,NULL,'Visvanathan & Sandage 1979','IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158889,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158889,32.45,NULL,30.9,74750,NULL,NULL,'LEDA [April 2006]','IC 1459',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158890,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158890,32.09,0.41,26.1,74750,NULL,NULL,NULL,'IC 1459',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158891,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158891,32.26,0.41,28.4,74750,NULL,NULL,'Malmquist cor.','IC 1459',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158892,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158892,31.19,0.28,17.3,74750,95,NULL,NULL,'IC 1459',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158893,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158893,31.51,0.8,20,74750,75,NULL,'B','IC 1459',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158894,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158894,31.43,0.07,19.3,74750,71,NULL,'Grus Cluster','IC 1459',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158895,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158895,38.48,0.46,496,74751,70,NULL,NULL,'2MASX J22571116-0008163',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000181,NULL,'17.5g',0.22,'NLAGN',NULL,NULL,NULL,'Sy 2',1,344.2965417,-0.13778,0.177,NULL,49497747183,773402299,12084410,17.5),(158896,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158896,30.33,0.63,11.6,74752,95,NULL,'Michard 1979b, c','IC 5267',NULL,'1984ApJS...56...91D',1984,1,5.2,NULL,'G',0.000013,NULL,'11.43',3.9,'(R)SA(rs)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.3065417,-43.39614,0,NULL,50516847144,789325736,12333214,11.43),(158897,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158897,30.57,0.44,13,74752,95,NULL,'Weighted Mean','IC 5267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158898,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158898,31,0.46,15.8,74752,95,NULL,'Michard 1979a','IC 5267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158899,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158899,31.94,0.6,24.5,74752,70,NULL,NULL,'IC 5267',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158900,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158900,31.63,0.8,21.2,74752,75,NULL,'A82, H','IC 5267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158901,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158901,31.19,0.28,17.3,74752,95,NULL,NULL,'IC 5267',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158902,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158902,31.61,0.8,21,74752,75,NULL,'B','IC 5267',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158903,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158903,32.18,0.47,27.3,74752,75,NULL,'A82, H, raw','IC 5267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158904,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158904,32.41,0.47,30.3,74752,75,NULL,'A82, H, cor','IC 5267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158905,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158905,32.43,0.47,30.6,74752,75,NULL,'A82, H, inv','IC 5267',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158906,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158906,36.24,0.53,177,74753,70,NULL,NULL,'MCG -01-58-008',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000147,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,344.307083,-3.16214,0.189,NULL,49522885877,773795091,12090548,15),(158907,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158907,34.99,0.56,99.6,74754,70,NULL,NULL,'2MASX J22571481-2058014',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.00',0.48,'E',NULL,NULL,NULL,NULL,1,344.3117083,-20.96708,0.116,NULL,50434559470,788039991,12313124,15),(158908,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09326',NULL,158908,40.78,0.19,1430,74755,70,NULL,'SALT 2','SDSS J225715.88+003741.3',NULL,'2013ApJ...763...88C',2013,1,0.07,NULL,'G',0.01,NULL,'20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,344.316166667,0.62817,0.153,NULL,51699837074,807809954,12622030,20.9),(158909,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09326',NULL,158909,40.8,0.19,1450,74755,70,NULL,'SALT 2, Malmquist cor.','SDSS J225715.88+003741.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158910,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09326','R',158910,41.49,0.29,1470,74755,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J225715.88+003741.3',0.35,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158911,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 09326','R',158911,41.68,0.26,1610,74755,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J225715.88+003741.3',0.35,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158912,'BL Lac Luminosity','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158912,39.93,NULL,814,74756,NULL,NULL,NULL,'[HB89] 2254+074',0.19,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.4V',NULL,'Opt.var.       BLLAC',NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,344.322083,7.72008,0.145,NULL,52439015884,819359623,12802494,16.4),(158913,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158913,30.3,0.4,11.5,74757,75,NULL,'B','NGC 7424',NULL,'1988NBGC.C....0000T',1988,1,9.5,'Extended HIPASS source','G',0.000007,NULL,'10.96',8.1,'SAB(rs)cd','Possible group member',NULL,NULL,NULL,1,344.3265417,-41.07058,NULL,NULL,50489320315,788895629,12326494,10.96),(158914,'Ring Diameter','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158914,33,0.84,40,74758,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7428',NULL,'1981ApJS...45..541P',1981,1,2.4,NULL,'G',0.000017,NULL,'13.40',1.3,'(R)SAB(r)a pec:','Isolated galaxy',NULL,NULL,NULL,1,344.331375,-1.049,0.205,NULL,49497484620,773398197,12084346,13.4),(158915,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158915,37.57,0.33,326,74759,70,NULL,NULL,'2MASX J22572043-0946426',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000149,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.335083,-9.77842,0.069,NULL,50381954882,787218045,12300281,17.7),(158916,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158916,38.02,0.46,401,74760,70,NULL,NULL,'2MASX J22572463+0036109',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000165,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.352667,0.60317,0.153,NULL,51699789697,807809214,12622018,18),(158917,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158917,32.75,0.43,35.6,74761,75,NULL,'3.6 micron, color + selection bias corrected','ESO 603- G 031',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000033,NULL,'14.77',0.7,'Sa',NULL,NULL,NULL,NULL,1,344.360125,-17.88558,0.064,NULL,50437556655,788086822,12313856,14.77),(158918,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13058','RN',158918,39.7,0.19,733,74762,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13058',0.187103,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158919,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 13058','RN',158919,40.43,0.32,1030,74762,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13058',0.187103,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158920,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158920,37.97,0.46,392,74763,70,NULL,NULL,'2MASX J22572989-0907426',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000162,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,344.3745,-9.12858,0.093,NULL,50380244605,787191321,12299864,17.5),(158921,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 21837','RN',158921,43.11,0.4,3090,74764,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21837',0.354712,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158922,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 21837','RN',158922,43.18,0.35,3190,74764,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 21837',0.354712,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158923,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158923,32.62,0.43,33.4,74765,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12265',NULL,'2014MNRAS.444..527S',2014,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'DBL SYS',NULL,NULL,NULL,NULL,1,344.398333,19.78667,0.181,NULL,52577977263,821530894,12836420,NULL),(158924,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158924,37.65,0.46,339,74766,70,NULL,NULL,'2MASX J22573684-0909066',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000163,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,344.403583,-9.15172,0.093,NULL,50380257323,787191520,12299867,17.1),(158925,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158925,34.92,0.49,96.2,74767,75,NULL,'IR','UGC 12264',NULL,'2011yCatp016004901K',2011,1,1.42,NULL,'G',0.00001,NULL,'17.0g',0.14,'Sd',NULL,NULL,NULL,NULL,1,344.4129583,12.91583,0.109,NULL,52558032409,821219256,12831550,17),(158926,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158926,35.14,NULL,107,74767,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158927,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158927,35.15,NULL,107,74767,NULL,NULL,'Dipole + Quadrupole','UGC 12264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158928,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158928,35.15,NULL,107,74767,NULL,NULL,'Dipole','UGC 12264',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158929,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158929,35.16,NULL,107,74767,NULL,NULL,NULL,'UGC 12264',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158930,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158930,35.51,0.54,127,74767,NULL,NULL,NULL,'UGC 12264',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158931,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158931,35.58,0.2,131,74767,74.4,NULL,NULL,'UGC 12264',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158932,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158932,35.6,0.52,132,74767,NULL,NULL,'Malmquist cor.','UGC 12264',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158933,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 14228','RN',158933,42.3,0.25,2250,74768,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14228',0.281205,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158934,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 14228','RN',158934,42.47,0.34,2430,74768,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14228',0.281205,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158935,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158935,37.28,0.46,285,74769,70,NULL,NULL,'SDSS J225742.75+001412.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,344.428125,0.23683,0.165,NULL,51699276400,807801193,12621893,17.7),(158936,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158936,37.85,0.46,372,74770,70,NULL,NULL,'2MASX J22574350+1420322',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000168,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,344.431166667,14.34242,0.133,NULL,52556971251,821202675,12831291,16.9),(158937,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158937,32.02,0.3,25.4,74771,NULL,NULL,'I','IC 5269',NULL,'2001ApJ...546..681T',2001,1,1.8,'MCG identification as IC 5270 in error.','G',0.000033,NULL,'13.19',0.8,'SAB(rs):','X-ray-bright group member',NULL,NULL,NULL,1,344.431917,-36.02622,NULL,NULL,50700912570,792201758,12378152,13.19),(158938,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158938,32.05,0.14,25.7,74771,74.4,NULL,NULL,'IC 5269',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158939,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158939,30.24,0.65,11.2,74771,95,NULL,'Weighted Mean','IC 5269',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158940,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158940,31.28,0.81,18,74771,55,NULL,'Visvanathan & Sandage 1979','IC 5269',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158941,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158941,32.15,0.8,26.9,74771,75,NULL,'B','IC 5269',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158942,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158942,37.46,0.23,310,74772,70,NULL,NULL,'2MASX J22574682+1406223',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,344.445,14.10631,0.165,NULL,52556925469,821201960,12831280,18.2),(158943,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158943,37.46,0.23,310,74773,70,NULL,NULL,'SDSS J225750.27+140848.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000141,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,344.4595,14.14683,0.165,NULL,52556939002,821202171,12831283,18.6),(158944,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158944,37.55,0.46,323,74774,70,NULL,NULL,'SDSS J225753.81-082806.7',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000128,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,344.47425,-8.46853,0.081,NULL,50372113229,787064269,12297879,18.4),(158945,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 1993L',NULL,158945,31.47,0.17,19.7,74775,70.8,NULL,NULL,'IC 5270',NULL,'2008MNRAS.389.1577T',2008,1,3.2,'Position in 1997AJ....113.1548C is incorrect.','G',0.000017,NULL,'12.99',0.6,'SB(rs)c        HII','X-ray-bright group member',NULL,NULL,NULL,1,344.478916667,-35.85806,NULL,NULL,50700956166,792202440,12378163,12.99),(158946,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 1993L','R',158946,31.9,NULL,24,74775,62.3,NULL,NULL,'IC 5270',NULL,'2008A&ARv..15..289T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158947,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 1993L',NULL,158947,31.99,0.31,24.6,74775,65,NULL,'MLCS2k2','IC 5270',0.006616,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158948,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SN 1993L',NULL,158948,31.99,0.14,25,74775,60,NULL,NULL,'IC 5270',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158949,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158949,31.91,0.8,24.1,74775,75,NULL,'MAT, I','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158950,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158950,31.91,0.8,24.1,74775,75,NULL,'A82, H','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158951,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158951,30.92,0.47,15.3,74775,75,NULL,'A82, H, inv','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158952,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158952,30.97,0.47,15.6,74775,75,NULL,'A82, H, raw','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158953,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158953,30.99,0.4,15.8,74775,75,NULL,NULL,'IC 5270',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158954,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158954,30.99,0.4,15.8,74775,73,NULL,'IR','IC 5270',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158955,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158955,31.35,0.47,18.6,74775,75,NULL,'A82, H, cor','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158956,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158956,31.56,0.49,20.5,74775,75,NULL,'IR','IC 5270',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158957,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158957,31.58,0.32,20.7,74775,85,NULL,'I, raw','IC 5270',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158958,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158958,31.59,0.32,20.8,74775,85,NULL,'I, inv','IC 5270',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158959,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158959,31.78,0.43,22.7,74775,75,NULL,'MAT, I, raw','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158960,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158960,31.8,0.4,22.9,74775,NULL,NULL,'mean','IC 5270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158961,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158961,31.87,0.39,23.7,74775,73,NULL,'opt','IC 5270',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158962,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158962,31.89,0.43,23.9,74775,75,NULL,'MAT, I, inv','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158963,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158963,31.91,0.45,24.1,74775,NULL,NULL,NULL,'IC 5270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158964,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158964,31.92,0.46,24.2,74775,NULL,NULL,'J','IC 5270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158965,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158965,31.95,0.2,24.6,74775,74.4,NULL,NULL,'IC 5270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158966,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158966,31.96,0.47,24.6,74775,NULL,NULL,'H','IC 5270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158967,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158967,31.97,0.44,24.7,74775,NULL,NULL,'Malmquist cor.','IC 5270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158968,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158968,32.01,0.43,25.3,74775,75,NULL,'MAT, I, cor','IC 5270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158969,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158969,32.04,0.45,25.6,74775,NULL,NULL,'K','IC 5270',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158970,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158970,37.63,0.33,336,74776,70,NULL,NULL,'2MASX J22575705+0054430',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.4877083,0.91206,0.157,NULL,51699671161,807807361,12621990,17.5),(158971,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158971,36.8,0.46,230,74777,70,NULL,NULL,'2MASX J22575732+0104160',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000193,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,344.488833,1.07117,0.145,NULL,51702497337,807851520,12622680,16.4),(158972,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158972,35.05,0.4,103,74778,NULL,NULL,'mean','NGC 7436B',NULL,'2007A&A...465...71T',2007,1,2,NULL,'G',0.00007,NULL,'14.0',2,'E',NULL,NULL,NULL,NULL,1,344.48975,26.14994,0.213,NULL,51908098822,811064044,12672875,14),(158973,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158973,35.15,0.45,107,74778,NULL,NULL,'K','NGC 7436B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158974,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158974,36.78,0.59,227,74779,70,NULL,NULL,'2MASX J22575980-0055198',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,344.499125,-0.92211,0.225,NULL,49500808117,773450126,12085158,16.6),(158975,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158975,37.46,0.23,310,74780,70,NULL,NULL,'SDSS J225759.98+140921.4',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00016,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.4999583,14.15594,0.165,NULL,52556928269,821202004,12831281,16.9),(158976,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158976,31.64,0.8,21.3,74781,75,NULL,'MAT, I','IC 5271',NULL,'1997ApJS..109..333W',1997,1,2.6,NULL,'G',0.000029,NULL,'12.90',0.9,'Sb?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.507583,-33.74222,NULL,NULL,50083855061,782560235,12227503,12.9),(158977,'Sosies','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158977,31.89,0.11,23.9,74781,NULL,NULL,NULL,'IC 5271',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158978,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158978,31.61,0.47,21,74781,NULL,NULL,'H','IC 5271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158979,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158979,31.62,0.46,21.1,74781,NULL,NULL,'J','IC 5271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158980,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158980,31.64,0.4,21.3,74781,NULL,NULL,NULL,'IC 5271',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158981,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158981,31.64,0.45,21.3,74781,NULL,NULL,'K','IC 5271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158982,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158982,31.64,0.4,21.3,74781,73,NULL,'opt','IC 5271',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158983,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158983,31.67,0.4,21.6,74781,NULL,NULL,'mean','IC 5271',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158984,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158984,31.78,0.32,22.7,74781,85,NULL,'I, raw','IC 5271',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158985,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158985,31.83,0.43,23.2,74781,75,NULL,'MAT, I, raw','IC 5271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158986,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158986,31.83,0.32,23.2,74781,85,NULL,'I, inv','IC 5271',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158987,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158987,31.85,0.43,23.4,74781,75,NULL,'3.6 micron, color corrected','IC 5271',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158988,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158988,31.85,0.43,23.5,74781,75,NULL,'3.6 micron, color + selection bias corrected','IC 5271',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158989,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158989,31.92,0.2,24.2,74781,74.4,NULL,NULL,'IC 5271',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158990,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158990,32.04,0.43,25.6,74781,75,NULL,'MAT, I, inv','IC 5271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158991,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158991,32.07,0.43,26,74781,75,NULL,'MAT, I, cor','IC 5271',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158992,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158992,34.81,0.46,91.6,74782,70,NULL,NULL,'NGC 7432',NULL,'2015arXiv151105856S',2015,1,0.98,NULL,'G',0.00013,NULL,'14.3g',0.73,'E',NULL,NULL,NULL,NULL,1,344.508083333,13.1345,0.149,NULL,52558018471,821219038,12831547,14.3),(158993,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158993,33.44,0.4,48.8,74783,NULL,NULL,'mean','ARP 314 NED01',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00001,NULL,'13.7',0.9,'(R\')SA(s)bc: pec;HII','Pair member, contact system',NULL,NULL,NULL,1,344.509333,-3.76969,0.181,NULL,49525957492,773843085,12091298,13.7),(158994,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158994,33.89,0.47,60.1,74783,NULL,NULL,'H','ARP 314 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158995,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158995,33.91,0.45,60.6,74783,NULL,NULL,'K','ARP 314 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158996,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,158996,33.95,0.46,61.7,74783,NULL,NULL,'J','ARP 314 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158997,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',158997,34.22,0.49,69.7,74784,75,NULL,'IR','2MFGC 17270',NULL,'2011yCatp016004901K',2011,1,0.82,NULL,'G',0.000944,NULL,'15.90',0.13,NULL,NULL,NULL,NULL,NULL,1,344.511375,32.46631,0.333,NULL,51922732781,811292699,12676448,15.9),(158998,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 03729','RN',158998,39.27,0.27,569,74785,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03729',0.254288,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(158999,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:19','1','SDSS-II SN 03729','RN',158999,40.64,0.3,1070,74785,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03729',0.254288,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159000,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159000,37.97,0.46,393,74786,70,NULL,NULL,'2MASX J22580700+0111179',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000174,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,344.5290417,1.18817,0.137,NULL,51702430857,807850482,12622663,17.5),(159001,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159001,37.12,0.46,266,74787,70,NULL,NULL,'2MASX J22580802+1345084',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,344.533375,13.75244,0.153,NULL,52557626773,821212918,12831451,16.7),(159002,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159002,37.63,0.15,336,74788,70,NULL,NULL,'2MASX J22580927-0914215',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000162,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,344.538625,-9.23939,0.093,NULL,50380265008,787191640,12299869,17.4),(159003,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159003,37.63,0.15,336,74789,70,NULL,NULL,'2MASX J22580963-0929345',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000158,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.5402083,-9.49281,0.097,NULL,50381854100,787216470,12300257,17.6),(159004,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159004,32.33,0.4,29.2,74790,75,NULL,'B','NGC 7437',NULL,'1988NBGC.C....0000T',1988,1,1.43,NULL,'G',0.000003,NULL,'14.3g',1.16,'SAB(rs)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.541917,14.3085,0.133,NULL,52556975203,821202737,12831292,14.3),(159005,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159005,37.46,0.23,310,74791,70,NULL,NULL,'2MASX J22581296+1408424',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000139,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.554125,14.14514,0.165,NULL,52556901949,821201592,12831274,17.9),(159006,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159006,37.63,0.15,336,74792,70,NULL,NULL,'2MASX J22581490-0917429',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000169,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,344.562041667,-9.29536,0.093,NULL,50380219755,787190933,12299858,17.1),(159007,'TRGB','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159007,24.4,0.12,0.756,74793,NULL,NULL,NULL,'Andromeda XXXI',NULL,'2013ApJ...772...15M',2013,1,NULL,NULL,'G',0.000002,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,8.9975,51.55972,0.977,0,65830804625,1028606322,16071973,NULL),(159008,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159008,35.42,0.47,121,74794,NULL,NULL,NULL,'ESO 346- G 021',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.23',0.7,'Sb',NULL,NULL,NULL,NULL,1,344.570208333,-38.94739,NULL,NULL,50483900241,788810941,12325170,15.23),(159009,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159009,35.46,0.2,124,74794,74.4,NULL,NULL,'ESO 346- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159010,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159010,35.57,0.44,130,74794,NULL,NULL,'Malmquist cor.','ESO 346- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159011,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159011,35.02,0.4,101,74795,NULL,NULL,'mean','UGC 12272',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'14.84',0.7,'Sa',NULL,NULL,NULL,NULL,1,344.573,25.77114,0.229,NULL,51907746610,811058540,12672789,14.84),(159012,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159012,35.4,0.47,120,74795,NULL,NULL,'H','UGC 12272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159013,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159013,35.47,0.45,124,74795,NULL,NULL,'K','UGC 12272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159014,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159014,35.47,0.46,124,74795,NULL,NULL,'J','UGC 12272',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159015,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159015,37.7,0.46,347,74796,70,NULL,NULL,'2MASX J22581951+1301485',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.581375,13.03011,0.149,NULL,52557816465,821215882,12831498,17.8),(159016,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159016,34.77,0.47,90,74797,NULL,NULL,'H','UGC 12274',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000077,NULL,'15.4',0.5,'S','Group member',NULL,NULL,NULL,1,344.581583,26.06194,0.213,NULL,51908633140,811072392,12673006,15.4),(159017,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159017,34.95,0.46,97.9,74797,NULL,NULL,'J','UGC 12274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159018,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159018,34.95,0.45,97.9,74797,NULL,NULL,'K','UGC 12274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159019,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,NULL,159019,35.1,0.4,105,74797,NULL,NULL,'mean','UGC 12274',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159020,'FP','2016-12-15 15:16:03','2016-12-16 11:21:19','1',NULL,'R',159020,34.78,0.46,90.4,74798,70,NULL,NULL,'NGC 7434',NULL,'2015arXiv151105856S',2015,1,0.72,NULL,'G',0.000083,NULL,'15.0g',0.47,'SB?0-:',NULL,NULL,NULL,NULL,1,344.589375,-1.18394,0.181,NULL,49500870732,773451105,12085173,15),(159021,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159021,37.63,0.15,336,74799,70,NULL,NULL,'SDSS J225822.08-091952.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.1,NULL,NULL,NULL,NULL,NULL,1,344.592,-9.33122,0.093,NULL,50380224389,787191006,12299859,18.3),(159022,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15929','R',159022,41.3,0.17,1510,74800,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15929',0.203368,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,344.592333,-0.25256,0.149,NULL,49500416100,773444001,12085062,NULL),(159023,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159023,37.63,0.33,336,74801,70,NULL,NULL,'2MASX J22582447+0053599',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000142,NULL,'16.7g',0.3,NULL,NULL,NULL,NULL,NULL,1,344.601875,0.89986,0.145,NULL,51702523973,807851937,12622686,16.7),(159024,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159024,37.02,0.66,253,74802,70,NULL,NULL,'2MASX J22582754-0016016',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.00015,NULL,'15.8g',0.32,'Sb',NULL,NULL,NULL,NULL,1,344.614667,-0.267,0.149,NULL,49500451868,773444560,12085071,15.8),(159025,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159025,35.38,0.38,119,74803,NULL,NULL,'Malmquist cor.','ESO 406- G 035',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.10',0.8,'Sc             HII',NULL,NULL,NULL,NULL,1,344.616833333,-32.24003,NULL,NULL,50095549959,782742968,12230358,14.1),(159026,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159026,35.41,0.47,121,74803,NULL,NULL,'H','ESO 406- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159027,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159027,35.46,0.37,124,74803,NULL,NULL,NULL,'ESO 406- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159028,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159028,35.5,0.2,126,74803,74.4,NULL,NULL,'ESO 406- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159029,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159029,35.51,0.46,126,74803,NULL,NULL,'J','ESO 406- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159030,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159030,35.55,0.4,129,74803,NULL,NULL,'mean','ESO 406- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159031,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159031,35.56,0.45,130,74803,NULL,NULL,'K','ESO 406- G 035',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159032,'Horizontal Branch','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159032,21.22,0.15,0.175,74804,NULL,NULL,'M3/M13 (Fe/H=_1.5)','Pisces II',NULL,'2012ApJ...756...79S',2012,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'Poss. galactic',NULL,NULL,NULL,NULL,1,344.629167,5.9525,0.205,1,51713392775,808021762,12625340,NULL),(159033,'Horizontal Branch','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159033,21.3,NULL,0.182,74804,NULL,NULL,NULL,'Pisces II',NULL,'2010ApJ...712L.103B',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159034,'Horizontal Branch','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159034,21.31,0.17,0.183,74804,NULL,NULL,'Adopted ([Fe/H]=_2.0)','Pisces II',NULL,'2012ApJ...756...79S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159035,'Horizontal Branch','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159035,21.36,0.12,0.187,74804,NULL,NULL,'M92 (Fe/H=_2.4)','Pisces II',NULL,'2012ApJ...756...79S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159036,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159036,38.05,0.46,408,74805,70,NULL,NULL,'2MASX J22583112+1320016',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000198,NULL,'17.2g',0.19,'BrClG',NULL,NULL,NULL,NULL,1,344.6297083,13.33383,0.133,NULL,52557292667,821207697,12831370,17.2),(159037,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159037,35.84,0.56,148,74806,70,NULL,NULL,'2MASX J22583104-0317476',NULL,'2014MNRAS.445.2677S',2014,1,0.64,NULL,'G',0.00015,NULL,'16.14',0.35,NULL,NULL,NULL,NULL,NULL,1,344.632166667,-3.29994,0.201,NULL,49525774172,773840221,12091253,16.14),(159038,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159038,35.31,0.49,115,74807,75,NULL,'IR','FGC 2437',NULL,'2011yCatp016004901K',2011,1,0.88,NULL,'G',0.000016,NULL,'16.7',0.09,'Sc',NULL,NULL,NULL,NULL,1,344.635,10.98122,0.201,NULL,52443603670,819431307,12803614,16.7),(159039,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159039,35.78,NULL,144,74807,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2437',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159040,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159040,35.8,NULL,145,74807,NULL,NULL,'Dipole + Quadrupole','FGC 2437',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159041,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159041,35.82,NULL,146,74807,NULL,NULL,NULL,'FGC 2437',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159042,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159042,35.83,NULL,146,74807,NULL,NULL,'Dipole','FGC 2437',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159043,'Ring Diameter','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159043,33,0.84,40,74808,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7440',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.000017,NULL,'14.40',1.1,'SB(r)a',NULL,NULL,NULL,NULL,1,344.635583333,35.80242,0.425,NULL,55516042948,867438171,13553721,14.4),(159044,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159044,37.63,0.15,336,74809,70,NULL,NULL,'SDSS J225834.49-092437.6',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000168,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,344.64375,-9.41047,0.093,NULL,50380210392,787190787,12299856,17.8),(159045,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159045,37.07,0.46,259,74810,70,NULL,NULL,'2MASX J22583633-0823269',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000159,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,344.651333,-8.39075,0.081,NULL,50372409863,787068904,12297951,17.1),(159046,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159046,35.56,0.49,130,74811,75,NULL,'IR','FGC 2438',NULL,'2011yCatp016004901K',2011,1,1.05,NULL,'G',0.000025,NULL,'16.0',0.11,'Scd',NULL,NULL,NULL,NULL,1,344.664417,19.06878,0.129,NULL,52576419739,821506558,12836039,16),(159047,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159047,35.87,NULL,149,74811,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2438',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159048,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159048,35.88,NULL,150,74811,NULL,NULL,'Dipole + Quadrupole','FGC 2438',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159049,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159049,35.89,NULL,150,74811,NULL,NULL,'Dipole','FGC 2438',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159050,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159050,35.91,NULL,152,74811,NULL,NULL,NULL,'FGC 2438',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159051,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159051,37.63,0.15,336,74812,70,NULL,NULL,'2MASX J22584051-0925139',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,344.6689583,-9.42058,0.093,NULL,50380669013,787197953,12299968,17.3),(159052,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159052,36.97,0.46,247,74813,70,NULL,NULL,'2MASX J22584881+0013456',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000198,NULL,'16.5g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.7035417,0.22936,0.157,NULL,51702689076,807854516,12622726,16.5),(159053,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159053,37.63,0.15,336,74814,70,NULL,NULL,'2MASX J22584965-0927359',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000188,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,344.706917,-9.45989,0.093,NULL,50380541638,787195963,12299936,17.1),(159054,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159054,35.07,0.37,104,74815,NULL,NULL,NULL,'UGC 12278',NULL,'2009ApJS..182..474S',2009,1,0.77,'Perez-Gonzalex, et al. (2000A&AS..141..409P) give v = 7255 km/sec.','G',0.000017,NULL,'14.98',0.6,'Sc+            Sbrst',NULL,NULL,NULL,NULL,1,344.708083333,20.29869,0.137,NULL,52578489883,821538904,12836545,14.98),(159055,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159055,35.12,0.2,106,74815,74.4,NULL,NULL,'UGC 12278',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159056,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159056,35.18,0.35,109,74815,NULL,NULL,'Malmquist cor.','UGC 12278',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159057,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159057,37.63,0.15,336,74816,70,NULL,NULL,'2MASX J22585005-0926329',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,344.708583333,-9.4425,0.093,NULL,50380541387,787195959,12299936,17.9),(159058,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159058,34.83,0.49,92.7,74817,75,NULL,'IR','UGC 12279',NULL,'2011yCatp016004901K',2011,1,1.19,NULL,'G',NULL,NULL,'16.0',0.12,'Sc',NULL,NULL,NULL,NULL,1,344.710625,21.69211,0.173,NULL,52564928234,821327003,12833234,16),(159059,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159059,34.94,NULL,97.4,74817,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159060,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159060,34.96,NULL,98.1,74817,NULL,NULL,'Dipole + Quadrupole','UGC 12279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159061,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159061,34.97,NULL,98.5,74817,NULL,NULL,'Dipole','UGC 12279',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159062,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159062,37.67,0.46,343,74818,70,NULL,NULL,'2MASX J22585088+0029006',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,344.712083,0.48347,0.161,NULL,51702916559,807858071,12622782,16.9),(159063,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159063,35.62,0.64,133,74819,70,NULL,NULL,'2MASX J22585267-0723439',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.24',0.39,NULL,NULL,NULL,NULL,NULL,1,344.719625,-7.39567,0.093,NULL,49486172549,773221446,12081585,16.24),(159064,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159064,36,0.49,159,74820,75,NULL,'IR','FGC 2439',NULL,'2011yCatp016004901K',2011,1,0.99,NULL,'G',0.000023,NULL,'16.6',0.11,'Sc',NULL,NULL,NULL,NULL,1,344.728167,5.98119,0.205,NULL,51713408410,808022006,12625343,16.6),(159065,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159065,36.3,NULL,182,74820,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159066,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159066,36.31,NULL,183,74820,NULL,NULL,'Dipole + Quadrupole','FGC 2439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159067,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159067,36.33,NULL,184,74820,NULL,NULL,'Dipole','FGC 2439',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159068,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159068,36.45,NULL,195,74820,NULL,NULL,NULL,'FGC 2439',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159069,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159069,35.66,0.51,135,74821,70,NULL,NULL,'2MASX J22585543-0736539',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.51',0.3,NULL,NULL,NULL,NULL,NULL,1,344.7310417,-7.61494,0.085,NULL,49486090051,773220157,12081564,16.51),(159070,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159070,34.17,0.4,68.3,74822,NULL,NULL,'mean','UGC 12282',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000037,NULL,'13.0r',0.5,'Sa',NULL,NULL,NULL,'Sy 1.9',1,344.731166667,40.93147,0.513,NULL,55341082395,864704412,13511006,13),(159071,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159071,34.27,0.47,71.6,74822,NULL,NULL,'H','UGC 12282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159072,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159072,34.28,0.45,71.9,74822,NULL,NULL,'K','UGC 12282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159073,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159073,34.31,0.46,72.9,74822,NULL,NULL,'J','UGC 12282',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159074,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159074,34.44,0.49,77.2,74822,75,NULL,'IR','UGC 12282',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159075,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159075,38.13,0.46,422,74823,70,NULL,NULL,'2MASX J22585589+0051106',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,344.732917,0.85294,0.145,NULL,51702987080,807859173,12622799,18.2),(159076,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159076,34.06,0.49,64.8,74824,75,NULL,'IR','CGCG 453-037',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.00003,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,344.738875,20.39128,0.137,NULL,52578512604,821539259,12836550,15.4),(159077,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159077,37.14,0.62,268,74825,70,NULL,NULL,'2MASX J22585838-2728423',NULL,'2014MNRAS.445.2677S',2014,1,0.67,'The APM image includes a brighter superposed star.','G',0.00015,NULL,'15.94',0.37,NULL,NULL,NULL,NULL,NULL,1,344.743333,-27.47842,0.043,NULL,50108424809,782944137,12233502,15.94),(159078,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159078,34.73,0.19,88.3,74826,NULL,NULL,'B, Hubble-type-TF','ESO 469- G 007',NULL,'2005Ap&SS.298..577R',2005,1,1.2,NULL,'G',0.000033,NULL,'14.26',0.7,'SAB(rs)c',NULL,NULL,NULL,NULL,1,344.7442083,-30.49394,NULL,NULL,50088169440,782627647,12228556,14.26),(159079,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159079,35,0.47,100,74826,NULL,NULL,NULL,'ESO 469- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159080,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159080,35.05,0.2,102,74826,74.4,NULL,NULL,'ESO 469- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159081,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159081,35.18,0.43,109,74826,NULL,NULL,'Malmquist cor.','ESO 469- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159082,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159082,36.56,0.8,205,74827,70,NULL,NULL,'LCRS B225610.7-453932',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.00015,NULL,'16.65',0.36,NULL,NULL,NULL,NULL,NULL,1,344.7625,-45.39075,0,NULL,50510220327,789222192,12331596,16.65),(159083,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159083,37.63,0.15,336,74828,70,NULL,NULL,'SDSS J225906.20-091952.7',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000174,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,344.775833,-9.33131,0.093,NULL,50380728371,787198880,12299982,17.8),(159084,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159084,34.28,0.49,71.8,74829,70,NULL,NULL,'2MASX J22590791-7224406',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'13.0I',0.6,NULL,NULL,NULL,NULL,NULL,1,344.783125,-72.41131,0.053,NULL,48444794148,756949908,11827342,13),(159085,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14621',NULL,159085,41.59,NULL,2080,74830,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 14621',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.3g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,344.786167,-0.11261,0.145,NULL,49499404871,773428201,12084815,21.3),(159086,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159086,32.49,0.2,31.5,74831,74.4,NULL,NULL,'UGC 12281',NULL,'2013AJ....146...86T',2013,1,3.44,NULL,'G',0.000003,NULL,'14.79',0.2,'Sd',NULL,NULL,NULL,NULL,1,344.803333,13.60667,0.141,NULL,52557481574,821210649,12831416,14.79),(159087,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159087,32.58,0.4,32.8,74831,NULL,NULL,NULL,'UGC 12281',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159088,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159088,32.68,0.43,34.4,74831,75,NULL,'3.6 micron, color corrected','UGC 12281',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159089,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159089,32.69,NULL,34.5,74831,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159090,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159090,32.7,NULL,34.6,74831,NULL,NULL,'Dipole + Quadrupole','UGC 12281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159091,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159091,32.7,NULL,34.7,74831,NULL,NULL,'Dipole','UGC 12281',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159092,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159092,32.72,0.4,34.9,74831,75,NULL,'B','UGC 12281',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159093,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159093,32.74,0.43,35.4,74831,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12281',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159094,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159094,32.77,NULL,35.8,74831,NULL,NULL,NULL,'UGC 12281',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159095,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159095,37.51,0.46,317,74832,70,NULL,NULL,'2MASX J22591413+1455403',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000177,NULL,'17.5g',0.16,NULL,NULL,NULL,NULL,NULL,1,344.8089583,14.92792,0.145,NULL,52607063379,821985365,12843521,17.5),(159096,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159096,34.85,NULL,93.1,74833,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2442',NULL,'2010Ap&SS.325..163P',2010,1,0.68,NULL,'G',0.000021,NULL,'17.61',0.09,'Scd',NULL,NULL,NULL,NULL,1,344.81,26.38889,0.177,NULL,51906985899,811046654,12672603,17.61),(159097,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159097,34.85,NULL,93.4,74833,NULL,NULL,'Dipole + Quadrupole','FGC 2442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159098,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159098,34.87,NULL,94.1,74833,NULL,NULL,'Dipole','FGC 2442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159099,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159099,34.88,NULL,94.7,74833,NULL,NULL,NULL,'FGC 2442',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159100,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159100,35.42,0.2,121,74833,74.4,NULL,NULL,'FGC 2442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159101,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159101,35.61,0.51,133,74833,NULL,NULL,NULL,'FGC 2442',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159102,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159102,35.65,0.5,135,74833,NULL,NULL,'Malmquist cor.','FGC 2442',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159103,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159103,37.46,0.46,311,74834,70,NULL,NULL,'2MASX J22591471+1330583',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000152,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,344.8112083,13.51619,0.141,NULL,52557268868,821207326,12831364,17.7),(159104,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159104,35.01,0.22,100,74835,NULL,NULL,'B, Hubble-type-TF','ESO 406- G 038',NULL,'2005Ap&SS.298..577R',2005,1,1,NULL,'G',0.000033,NULL,'15.46',0.7,'Sb-c',NULL,NULL,NULL,NULL,1,344.8262917,-32.60119,NULL,NULL,50081165140,782518205,12226846,15.46),(159105,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159105,35.7,0.49,138,74835,NULL,NULL,'Malmquist cor.','ESO 406- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159106,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159106,36.04,0.42,161,74835,NULL,NULL,NULL,'ESO 406- G 038',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159107,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159107,36.08,0.2,164,74835,74.4,NULL,NULL,'ESO 406- G 038',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159108,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159108,38.34,0.46,465,74836,70,NULL,NULL,'2MASX J22592058+1427373',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00016,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,344.83575,14.46039,0.129,NULL,52558841026,821231891,12831748,17.6),(159109,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159109,38.14,0.46,425,74837,70,NULL,NULL,'2MASX J22592072+0013371',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000145,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,344.8362083,0.227,0.157,NULL,51700606268,807821972,12622218,18),(159110,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159110,34.06,0.46,64.9,74838,NULL,NULL,'J','UGC 12287',NULL,'2007A&A...465...71T',2007,1,1.4,'abs(b) < 10 degrees.','G',0.00002,NULL,'15.5',0.8,'Scd:',NULL,NULL,NULL,NULL,1,344.845417,53.74006,NULL,NULL,53374876746,833982449,13030975,15.5),(159111,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159111,34.12,0.47,66.7,74838,NULL,NULL,'H','UGC 12287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159112,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159112,34.19,0.45,68.9,74838,NULL,NULL,'K','UGC 12287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159113,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159113,34.2,0.4,69,74838,NULL,NULL,'mean','UGC 12287',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159114,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159114,37.38,0.46,299,74839,70,NULL,NULL,'2MASX J22592345+1251513',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000123,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.8477083,12.86419,0.173,NULL,52555982152,821187221,12831050,16.9),(159115,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159115,37.18,0.46,273,74840,70,NULL,NULL,'2MASX J22592367+1436053',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,344.848625,14.60156,0.145,NULL,52558886494,821232601,12831759,17.2),(159116,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159116,35.82,0.51,146,74841,70,NULL,NULL,'2MASX J22592515-6929494',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,344.855083333,-69.49706,0.029,NULL,49269288787,769832637,12028634,14.1),(159117,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159117,37.63,0.15,336,74842,70,NULL,NULL,'2MASX J22592534-0929486',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'16.0g',0.45,'E0',NULL,NULL,NULL,NULL,1,344.8554583,-9.49697,0.093,NULL,50380593095,787196767,12299949,16),(159118,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159118,31.05,0.8,16.2,74843,75,NULL,'MAT, I','IC 5273',NULL,'1997ApJS..109..333W',1997,1,2.7,NULL,'G',0.000019,NULL,'12.22',1.8,'SB(rs)cd       HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,344.86125,-37.70289,NULL,NULL,50484249348,788816396,12325256,12.22),(159119,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159119,31.07,0.8,16.3,74843,75,NULL,'A82, H','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159120,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159120,30.67,0.4,13.6,74843,NULL,NULL,'mean','IC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159121,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159121,30.69,0.43,13.7,74843,75,NULL,'3.6 micron, color + selection bias corrected','IC 5273',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159122,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159122,30.75,0.32,14.1,74843,85,NULL,'I, raw','IC 5273',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159123,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159123,30.75,0.32,14.1,74843,85,NULL,'I, inv','IC 5273',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159124,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159124,30.82,0.43,14.6,74843,75,NULL,'3.6 micron, color corrected','IC 5273',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159125,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159125,30.84,0.35,14.7,74843,NULL,NULL,NULL,'IC 5273',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159126,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159126,30.84,0.39,14.7,74843,73,NULL,'opt','IC 5273',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159127,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159127,30.96,0.2,15.6,74843,74.4,NULL,NULL,'IC 5273',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159128,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159128,31.02,0.4,16,74843,75,NULL,'B','IC 5273',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159129,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159129,31.04,0.43,16.1,74843,75,NULL,'MAT, I, raw','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159130,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159130,31.1,0.46,16.6,74843,NULL,NULL,'J','IC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159131,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159131,31.12,0.47,16.7,74843,NULL,NULL,'H','IC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159132,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159132,31.12,0.45,16.8,74843,NULL,NULL,'K','IC 5273',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159133,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159133,31.12,0.47,16.8,74843,75,NULL,'A82, H, inv','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159134,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159134,31.13,0.47,16.8,74843,75,NULL,'A82, H, raw','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159135,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159135,31.14,0.43,16.9,74843,75,NULL,'MAT, I, inv','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159136,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159136,31.35,0.43,18.6,74843,75,NULL,'MAT, I, cor','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159137,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159137,31.48,0.47,19.7,74843,75,NULL,'A82, H, cor','IC 5273',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159138,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159138,36.97,0.46,248,74844,70,NULL,NULL,'2MASX J22592700+1256483',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000141,NULL,'17.7g',0.17,NULL,NULL,NULL,NULL,NULL,1,344.862375,12.94686,0.193,NULL,52555995387,821187427,12831053,17.7),(159139,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159139,38.33,0.46,463,74845,70,NULL,NULL,'SDSS J225928.56+001826.0',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000128,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,344.869,0.30725,0.161,NULL,51700599092,807821860,12622216,18.8),(159140,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159140,37.32,0.46,291,74846,70,NULL,NULL,'2MASX J22593239+1522372',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000175,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,344.885083,15.37714,0.133,NULL,52607259188,821988424,12843569,16.7),(159141,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 05470','RN',159141,42.3,0.48,2230,74847,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05470',0.291687,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159142,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'N',159142,27.84,0.82,3.7,74848,NULL,NULL,NULL,'AF7448_001',NULL,'2014MNRAS.442L..46T',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159143,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'N',159143,26.15,NULL,1.7,74848,NULL,NULL,'minimum','AF7448_001',NULL,'2014MNRAS.442L..46T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159144,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'N',159144,29.49,NULL,7.9,74848,NULL,NULL,NULL,'AF7448_001',NULL,'2014MNRAS.442L..46T',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159145,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18628','RN',159145,41.27,0.19,1420,74849,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18628',0.260899,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159146,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18628','RN',159146,41.93,0.24,1930,74849,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18628',0.260899,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159147,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159147,35.19,0.2,109,74850,74.4,NULL,NULL,'CGCG 430-043',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.000013,NULL,'15.3g',0.37,'S?',NULL,NULL,NULL,NULL,1,344.899375,14.08953,0.129,NULL,52558903539,821232867,12831763,15.3),(159148,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159148,36.12,0.33,167,74851,70,NULL,NULL,'2MASX J22593625+1322112',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000182,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,344.901083,13.36986,0.141,NULL,52559094062,821235844,12831810,15.6),(159149,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159149,36.12,0.33,167,74852,70,NULL,NULL,'2MASX J22593653+1317482',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00014,NULL,'16.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,344.90225,13.29658,0.141,NULL,52557251837,821207059,12831360,16.7),(159150,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159150,33.39,0.69,47.7,74853,100,NULL,'mid-IR','MCG +00-58-018',NULL,'2013ApJ...771...88L',2013,1,0.7,NULL,'G',0.000027,NULL,'15',0.3,NULL,NULL,NULL,NULL,NULL,1,344.905291667,2.34422,0.221,NULL,51734632898,808353639,12630525,15),(159151,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159151,34.48,0.2,78.7,74853,74.4,NULL,NULL,'MCG +00-58-018',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159152,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159152,34.87,0.8,94.4,74854,75,NULL,'MAT, I','UGC 12290',NULL,'1997ApJS..109..333W',1997,1,1.84,NULL,'G',0.000009,NULL,'15.60',0.22,'Sbc',NULL,NULL,NULL,NULL,1,344.9062917,24.84767,0.149,NULL,51894740150,810855314,12669614,15.6),(159153,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159153,34.88,0.8,94.8,74854,75,NULL,'W91PP, r','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159154,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159154,34.71,0.43,87.5,74854,75,NULL,'MAT, I, raw','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159155,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159155,34.72,0.49,87.7,74854,75,NULL,'IR','UGC 12290',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159156,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159156,34.8,0.32,91.1,74854,85,NULL,'I, raw','UGC 12290',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159157,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159157,34.84,0.32,93.1,74854,85,NULL,'I, inv','UGC 12290',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159158,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159158,34.92,0.43,96.6,74854,75,NULL,'MAT, I, inv','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159159,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159159,34.97,NULL,98.6,74854,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12290',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159160,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159160,34.98,NULL,99,74854,NULL,NULL,'Dipole + Quadrupole','UGC 12290',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159161,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159161,34.98,NULL,99.1,74854,NULL,NULL,'Dipole','UGC 12290',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159162,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159162,35,0.43,100,74854,75,NULL,'MAT, I, cor','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159163,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159163,35.02,0.4,101,74854,NULL,NULL,'mean','UGC 12290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159164,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159164,35.02,NULL,101,74854,NULL,NULL,NULL,'UGC 12290',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159165,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159165,35.06,0.47,103,74854,NULL,NULL,'H','UGC 12290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159166,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159166,35.13,0.38,106,74854,75,NULL,'W91PP, r, raw','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159167,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159167,35.13,0.45,106,74854,NULL,NULL,'K','UGC 12290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159168,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159168,35.15,0.31,107,74854,NULL,NULL,NULL,'UGC 12290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159169,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159169,35.15,0.31,107,74854,NULL,NULL,'Malmquist cor.','UGC 12290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159170,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159170,35.21,0.2,110,74854,74.4,NULL,NULL,'UGC 12290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159171,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159171,35.27,0.38,113,74854,75,NULL,'W91PP, r, cor','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159172,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159172,35.33,0.38,116,74854,75,NULL,'W91PP, r, inv','UGC 12290',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159173,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159173,36.62,0.56,210,74855,70,NULL,NULL,'2MASX J22593938-1141295',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'16.53',NULL,NULL,NULL,NULL,NULL,NULL,1,344.913833,-11.6915,0.089,NULL,50405073073,787579266,12305926,16.53),(159174,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159174,34.33,0.93,73.4,74856,NULL,NULL,NULL,'UGC 12288',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'GPair',0.000017,NULL,NULL,NULL,'S?',NULL,NULL,NULL,NULL,1,344.915,20.14389,0.169,NULL,52579673978,821557405,12836834,NULL),(159175,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159175,34.37,0.2,74.8,74856,74.4,NULL,NULL,'UGC 12288',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159176,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159176,34.72,0.78,87.8,74856,NULL,NULL,'Malmquist cor.','UGC 12288',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159177,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159177,35.67,0.13,130,74857,74.2,NULL,'SALT 2','2MASX J22594265-0000478',0.045,'2010ApJ...716..712A',2010,1,0.13,NULL,'G',0.000079,NULL,'16.7g',0.07,NULL,NULL,NULL,NULL,NULL,1,344.92775,-0.01356,0.141,NULL,49499491682,773429557,12084836,16.7),(159178,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159178,36.42,0.11,176,74857,72,NULL,NULL,'2MASX J22594265-0000478',0.04421,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159179,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159179,36.25,0.1,178,74857,74.4,NULL,NULL,'2MASX J22594265-0000478',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159180,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159180,36.28,0.1,180,74857,70,NULL,'SALT 2','2MASX J22594265-0000478',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159181,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159181,36.28,0.1,180,74857,70,NULL,'SALT 2, Malmquist cor.','2MASX J22594265-0000478',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159182,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku',NULL,159182,36.39,0.16,181,74857,70,NULL,'SALT 2','2MASX J22594265-0000478',0.045,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159183,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku','R',159183,36.58,0.13,207,74857,NULL,NULL,'MLCS2k2, R(V) = 3.1','2MASX J22594265-0000478',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159184,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005ku','R',159184,36.59,0.1,208,74857,NULL,NULL,'MLCS2k2, R(V) = 1.8','2MASX J22594265-0000478',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159185,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10805','R',159185,36.68,0.07,208,74857,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ku','2MASX J22594265-0000478',0.045439,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159186,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10805','R',159186,37.28,0.28,274,74857,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ku','2MASX J22594265-0000478',0.045439,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159187,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159187,37.87,0.33,376,74858,70,NULL,NULL,'2MASX J22594605+0002311',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000166,NULL,'17.2g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,344.9419583,0.04203,0.141,NULL,51700665738,807822902,12622232,17.2),(159188,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159188,35.07,0.8,103,74859,75,NULL,'W91PP, r','UGC 12291',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'15.15',0.9,'Scd:',NULL,NULL,NULL,NULL,1,344.951375,26.30217,0.189,NULL,51906998007,811046843,12672606,15.15),(159189,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159189,35.14,0.38,106,74859,75,NULL,'W91PP, r, raw','UGC 12291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159190,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159190,35.27,0.38,113,74859,75,NULL,'W91PP, r, cor','UGC 12291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159191,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159191,35.28,0.38,114,74859,75,NULL,'W91PP, r, inv','UGC 12291',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159192,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159192,35.3,0.41,115,74859,NULL,NULL,'Malmquist cor.','UGC 12291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159193,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159193,35.44,0.39,123,74859,NULL,NULL,NULL,'UGC 12291',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159194,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159194,35.48,0.2,125,74859,74.4,NULL,NULL,'UGC 12291',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159195,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06520','RN',159195,39.21,0.2,627,74860,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 06520',0.109067,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159196,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06520','RN',159196,39.35,0.09,668,74860,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 06520',0.109067,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159197,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159197,35.19,0.53,109,74861,NULL,NULL,NULL,'ESO 147- G 017',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'15.32',0.35,'SB(s)c',NULL,NULL,NULL,NULL,1,344.9567083,-61.56478,0,NULL,48766929898,761983279,11905988,15.32),(159198,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159198,35.23,0.2,111,74861,74.4,NULL,NULL,'ESO 147- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159199,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159199,35.36,0.48,118,74861,NULL,NULL,'Malmquist cor.','ESO 147- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159200,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159200,37.87,0.33,376,74862,70,NULL,NULL,'SDSS J225953.38-000507.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00014,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,344.9724583,-0.08553,0.141,NULL,49499502642,773429728,12084839,18.7),(159201,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19599',NULL,159201,40.29,1.3,1140,74863,70,NULL,'SN photometric redshift distance, z photo =0.315 +/- 0.385','SDSS-II SN 19599',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.7g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,344.975375,1.16475,0.185,NULL,51703083299,807860676,12622823,22.7),(159202,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19599','R',159202,41.91,0.4,1600,74863,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19599',0.507535,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159203,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19599',NULL,159203,42.04,0.33,2560,74863,70,NULL,'SALT 2','SDSS-II SN 19599',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159204,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19599',NULL,159204,42.19,0.33,2740,74863,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19599',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159205,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15486','RN',159205,38.99,0.13,563,74864,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15486',0.116007,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159206,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15486','RN',159206,39.2,0.2,620,74864,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15486',0.116007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159207,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06216','RN',159207,40.73,0.18,1190,74865,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06216',0.175564,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159208,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06216','RN',159208,40.86,0.27,1260,74865,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06216',0.175564,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159209,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159209,37.79,0.23,361,74866,70,NULL,NULL,'2MASXi J2300024-095518',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,345.010375,-9.92172,0.073,NULL,50380954335,787202411,12300037,17.9),(159210,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159210,32.08,0.17,26.1,74867,70.8,NULL,NULL,'NGC 7448',NULL,'2008MNRAS.389.1577T',2008,1,2.7,NULL,'G',0.000003,NULL,'12.20',1.2,'SA(rs)bc','X-ray-faint group member',NULL,NULL,NULL,1,345.014958333,15.98033,0.137,NULL,52607747865,821996060,12843688,12.2),(159211,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159211,32.25,0.09,28.2,74867,74.4,NULL,NULL,'NGC 7448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159212,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159212,32.49,0.42,31.2,74867,74.2,NULL,'SALT 2','NGC 7448',0.007318,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159213,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159213,32.72,0.19,34.5,74867,65,NULL,'MLCS2k2','NGC 7448',0.007318,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159214,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159214,33.19,0.14,43.5,74867,60,NULL,NULL,'NGC 7448',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159215,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1997dt',NULL,159215,33.28,0.44,45,74867,70,NULL,'SALT','NGC 7448',0.007318,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159216,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159216,32.23,0.8,28,74867,75,NULL,'CF, r','NGC 7448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159217,'Sosies','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159217,30.88,0.46,15,74867,NULL,NULL,NULL,'NGC 7448',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159218,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159218,32.41,0.8,30.3,74867,75,NULL,'B','NGC 7448',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159219,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159219,31.51,0.43,20.1,74867,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159220,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159220,31.57,0.43,20.6,74867,75,NULL,'3.6 micron, color corrected','NGC 7448',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159221,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159221,31.73,0.37,22.2,74867,NULL,NULL,NULL,'NGC 7448',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159222,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159222,31.73,0.39,22.2,74867,73,NULL,'opt','NGC 7448',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159223,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159223,31.74,0.69,22.3,74867,100,NULL,'mid-IR','NGC 7448',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159224,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159224,31.75,0.46,22.4,74867,NULL,NULL,'J','NGC 7448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159225,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159225,31.78,0.42,22.7,74867,NULL,18.48,'3.6 micron','NGC 7448',NULL,'2012ApJ...758L..12S',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159226,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159226,31.79,0.54,22.8,74867,NULL,NULL,'Malmquist cor.','NGC 7448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159227,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159227,31.79,0.4,22.8,74867,75,NULL,'HOSTS SN 1997dt','NGC 7448',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159228,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159228,31.83,0.47,23.2,74867,NULL,NULL,'H','NGC 7448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159229,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159229,31.84,0.45,23.3,74867,NULL,NULL,'K','NGC 7448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159230,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159230,31.97,0.49,24.8,74867,NULL,NULL,NULL,'NGC 7448',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159231,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159231,31.99,0.38,25,74867,75,NULL,'CF, r, raw','NGC 7448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159232,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159232,32.05,0.4,25.7,74867,75,NULL,'HOSTS SN 1997dt','NGC 7448',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159233,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159233,32.1,0.38,26.3,74867,75,NULL,'CF, r, inv','NGC 7448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159234,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159234,32.18,0.4,27.3,74867,NULL,NULL,'mean','NGC 7448',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159235,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159235,32.2,0.38,27.6,74867,75,NULL,'CF, r, cor','NGC 7448',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159236,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159236,32.25,0.09,28.2,74867,74.4,NULL,NULL,'NGC 7448',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159237,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159237,35.33,NULL,117,74868,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2444',NULL,'2010Ap&SS.325..163P',2010,1,0.58,NULL,'G',0.000025,NULL,'17.2g',0.16,'Sbc',NULL,NULL,NULL,NULL,1,345.015667,15.01961,0.157,NULL,52551531192,821117674,12829963,17.2),(159238,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159238,35.33,NULL,117,74868,NULL,NULL,'Dipole + Quadrupole','FGC 2444',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159239,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159239,35.34,NULL,117,74868,NULL,NULL,'Dipole','FGC 2444',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159240,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159240,35.51,NULL,126,74868,NULL,NULL,NULL,'FGC 2444',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159241,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159241,37.17,0.46,271,74869,70,NULL,NULL,'2MASX J23000498+1515173',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000185,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,345.020917,15.25481,0.153,NULL,52607295399,821988990,12843577,16.5),(159242,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13045','R',159242,39.61,0.2,708,74870,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fn','SN 2006fn',0.1806,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,345.024917,0.53767,0.161,NULL,51702763616,807855681,12622745,NULL),(159243,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13045','R',159243,39.72,0.11,743,74870,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fn','SN 2006fn',0.1806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159244,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10460',NULL,159244,39.41,0.61,762,74871,70,NULL,'SN photometric redshift distance, z photo =0.197 +/- 0.074','SDSS-II SN 10460',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.3g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.029167,-1.20383,0.169,NULL,49501035320,773453676,12085213,21.3),(159245,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10460','R',159245,40.28,0.26,932,74871,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10460',0.220342,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159246,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10460','R',159246,40.6,0.34,1080,74871,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10460',0.220342,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159247,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159247,36.19,0.8,173,74872,70,NULL,NULL,'2MASX J23000727-0402259',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.01',0.37,'poss. LINER?',NULL,NULL,NULL,NULL,1,345.030333,-4.0405,0.205,NULL,49526175302,773846489,12091351,16.01),(159248,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 19197','RN',159248,39.46,6.48,662,74873,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19197',0.179707,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159249,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','PTF10twd','N',159249,37.63,0.03,313,74874,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10twd',0.0734,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159250,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1999dr',NULL,159250,38.72,0.24,469,74875,74.2,NULL,'SALT 2','SDSS J230017.30-000515.4',0.182,'2010ApJ...716..712A',2010,1,0.13,NULL,'G',NULL,NULL,'19.82',0.13,NULL,NULL,NULL,NULL,NULL,1,345.072083,-0.08764,0.141,NULL,49499530314,773430161,12084846,19.82),(159251,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 1999dr',NULL,159251,39.79,0.18,768,74875,NULL,NULL,'M(B) = -19.31','SDSS J230017.30-000515.4',0.182,'2008A&A...486..375A',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159252,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159252,35.61,0.8,133,74876,75,NULL,'CF, r','UGC 12296',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000017,NULL,'15.19',0.4,'Scd:',NULL,NULL,NULL,NULL,1,345.074083333,19.12597,0.129,NULL,52575951152,821499236,12835925,15.19),(159253,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159253,35.52,0.38,127,74876,75,NULL,'CF, r, raw','UGC 12296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159254,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159254,35.69,0.38,137,74876,75,NULL,'CF, r, inv','UGC 12296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159255,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159255,35.82,0.38,146,74876,75,NULL,'CF, r, cor','UGC 12296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159256,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159256,37.79,0.23,361,74877,70,NULL,NULL,'SDSS J230020.36-095028.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00016,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.084875,-9.84114,0.069,NULL,50380440978,787194390,12299912,18.2),(159257,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159257,37.79,0.23,361,74878,70,NULL,NULL,'SDSS J230023.40-094849.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,345.0975417,-9.81369,0.069,NULL,50380453293,787194582,12299915,18.2),(159258,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159258,33.82,0.47,58.1,74879,NULL,NULL,NULL,'UGC 12295',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000193,NULL,'14.95',0.9,'SAB(s)cd:',NULL,NULL,NULL,NULL,1,345.098791667,1.62653,0.177,NULL,51701442733,807835042,12622422,14.95),(159259,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159259,33.86,0.2,59.2,74879,74.4,NULL,NULL,'UGC 12295',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159260,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159260,33.98,0.44,62.6,74879,NULL,NULL,'Malmquist cor.','UGC 12295',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159261,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159261,37.79,0.23,361,74880,70,NULL,NULL,'2MASX J23002763-0955213',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00015,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,345.115083,-9.92261,0.069,NULL,50380959260,787202488,12300038,16.8),(159262,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159262,35.41,0.46,121,74881,70,NULL,NULL,'2MASX J23002860-1022463',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000103,NULL,'15.8g',0.44,'S0',NULL,NULL,NULL,NULL,1,345.1192917,-10.37933,0.105,NULL,50379314128,787176783,12299637,15.8),(159263,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159263,37.45,0.46,310,74882,70,NULL,NULL,'2MASX J23003145-1031303',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000176,NULL,'16.9g',0.24,NULL,NULL,NULL,NULL,NULL,1,345.1309583,-10.52506,0.105,NULL,50379320892,787176888,12299638,16.9),(159264,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159264,34.69,0.5,86.7,74883,NULL,NULL,'Malmquist cor.','NGC 7451',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.82',0.5,'SBbc','Isolated galaxy',NULL,NULL,NULL,1,345.17025,8.46792,0.133,NULL,52438475683,819351182,12802362,14.82),(159265,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159265,34.7,0.2,87.1,74883,74.4,NULL,NULL,'NGC 7451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159266,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159266,34.78,0.48,90.3,74883,NULL,NULL,NULL,'NGC 7451',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159267,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159267,34.82,0.4,92.2,74883,NULL,NULL,'mean','NGC 7451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159268,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159268,35.06,0.47,103,74883,NULL,NULL,'H','NGC 7451',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159269,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159269,37.28,0.46,286,74884,70,NULL,NULL,'2MASX J23004375+1418041',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000184,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,345.182375,14.30122,0.145,NULL,52559808050,821247000,12831984,16.6),(159270,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 09174','RN',159270,43.92,0.47,3920,74885,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09174',0.550523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159271,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159271,34.84,0.47,92.9,74886,NULL,NULL,'H','UGC 12303',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.000007,NULL,'14.37',1.2,'Sb',NULL,NULL,NULL,NULL,1,345.204667,26.74075,0.177,NULL,51907032786,811047387,12672615,14.37),(159272,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159272,34.99,0.46,99.4,74886,NULL,NULL,'J','UGC 12303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159273,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159273,35.01,0.45,100,74886,NULL,NULL,'K','UGC 12303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159274,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159274,35.17,0.4,108,74886,NULL,NULL,'mean','UGC 12303',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159275,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2006hf',NULL,159275,39.57,0.08,822,74887,70,NULL,'Hubble residual -0.04 for z0.21930','SDSS-II SN 13641 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,345.2175,-0.98203,0.157,NULL,49500218807,773440918,12085014,NULL),(159276,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13641','R',159276,40.11,0.2,870,74887,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hf','SDSS-II SN 13641 HOST',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159277,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13641','R',159277,40.21,0.11,911,74887,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hf','SDSS-II SN 13641 HOST',0.21,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159278,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 05141','RN',159278,43.72,0.31,3850,74888,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05141',0.443519,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159279,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 05141','RN',159279,44.1,0.4,4580,74888,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05141',0.443519,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159280,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159280,30.35,0.1,11.7,74889,NULL,NULL,'I','NGC 7457',NULL,'1997AJ....114..626A',1997,1,4.3,NULL,'G',0.000017,NULL,'12.09',2.3,'SA(rs)0-?','in a pair',NULL,NULL,NULL,1,345.2497083,30.14494,0.205,NULL,51918098929,811220295,12675317,12.09),(159281,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159281,30.41,0.14,12.1,74889,74.4,NULL,NULL,'NGC 7457',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159282,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159282,30.45,0.21,12.3,74889,NULL,NULL,'I','NGC 7457',NULL,'2003ApJ...583..712J',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159283,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159283,30.61,0.21,13.2,74889,NULL,NULL,'I','NGC 7457',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159284,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159284,30.66,0.23,13.6,74889,NULL,NULL,'HST KP Calibrated, I','NGC 7457',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159285,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159285,30.76,0.15,14.2,74889,NULL,NULL,'HST KP Calibrated, F814W','NGC 7457',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159286,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159286,30.45,0.81,12.3,74889,55,NULL,'Visvanathan & Sandage 1979','NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159287,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159287,30.49,0.37,12.5,74889,95,NULL,'Weighted Mean','NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159288,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159288,30.89,0.63,15.1,74889,95,NULL,'Michard 1979b, c','NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159289,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159289,31.27,0.46,17.9,74889,95,NULL,'Michard 1979a','NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159290,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159290,30.56,0.25,12.9,74889,95,NULL,NULL,'NGC 7457',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159291,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159291,30.46,0.8,12.3,74889,75,NULL,'B','NGC 7457',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159292,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913',NULL,159292,40.2,0.22,1100,74890,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.039','SDSS-II SN 06913',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,345.249875,1.03678,0.165,NULL,51702314469,807848663,12622635,21.4),(159293,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913','R',159293,41.34,0.33,1340,74890,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06913',0.381163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159294,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913','R',159294,41.37,0.3,1360,74890,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06913',0.381163,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159295,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913',NULL,159295,41.07,0.23,1640,74890,70,NULL,'SALT 2','SDSS-II SN 06913',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159296,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 06913',NULL,159296,41.13,0.23,1680,74890,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06913',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159297,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159297,38.09,0.46,415,74891,70,NULL,NULL,'2MASX J23010249+1403281',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000165,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,345.260291667,14.05769,0.145,NULL,52559824135,821247252,12831988,17.2),(159298,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159298,40.32,0.14,891,74892,74.2,NULL,'SALT 2','SDSS J230102.96-001224.7',0.3,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.005,NULL,'21.4g',0.05,NULL,NULL,NULL,NULL,NULL,1,345.262333,-0.20686,0.145,NULL,49500053962,773438343,12084974,21.4),(159299,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159299,40.22,0.13,1110,74892,70,NULL,'Hubble residual -0.01 for z0.30400','SDSS J230102.96-001224.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159300,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159300,41,0.13,1220,74892,65,NULL,'SALT2','SDSS J230102.96-001224.7',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159301,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159301,41.01,0.16,1230,74892,70,NULL,'SALT 2','SDSS J230102.96-001224.7',0.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159302,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07143','R',159302,41.02,0.22,1230,74892,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jg','SDSS J230102.96-001224.7',0.304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159303,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07143','R',159303,41.09,0.14,1260,74892,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jg','SDSS J230102.96-001224.7',0.304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159304,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159304,41.14,0.12,1300,74892,65,NULL,'MLCS2k2','SDSS J230102.96-001224.7',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159305,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159305,40.92,0.12,1530,74892,70,NULL,'SALT 2','SDSS J230102.96-001224.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159306,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2005jg',NULL,159306,40.95,0.12,1550,74892,70,NULL,'SALT 2, Malmquist cor.','SDSS J230102.96-001224.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159307,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159307,38.08,0.46,414,74893,70,NULL,NULL,'2MASX J23010607+1331581',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000157,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.275333,13.53289,0.133,NULL,52562526722,821289480,12832648,18),(159308,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159308,31.87,0.14,23.7,74894,74.4,NULL,NULL,'NGC 7454',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000017,NULL,'12.78',1.6,'E4','X-ray-faint group member',NULL,NULL,NULL,1,345.277125,16.38836,0.229,NULL,52608178860,822002794,12843793,12.78),(159309,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159309,31.89,0.3,23.9,74894,NULL,NULL,'I','NGC 7454',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159310,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159310,31.89,0.3,23.9,74894,NULL,NULL,NULL,'NGC 7454',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159311,'SBF','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159311,32.14,0.3,26.8,74894,NULL,NULL,'Malmquist cor.','NGC 7454',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159312,'D-Sigma','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159312,31.24,0.4,17.7,74894,75,NULL,'Edat, raw','NGC 7454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159313,'D-Sigma','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159313,31.58,0.4,20.7,74894,75,NULL,'Edat, cor','NGC 7454',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159314,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159314,30.72,0.61,13.9,74894,95,NULL,'Weighted Mean','NGC 7454',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159315,'Faber-Jackson','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159315,30.72,0.61,13.9,74894,95,NULL,'de Vaucouleurs','NGC 7454',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159316,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159316,31.4,0.41,19.1,74894,NULL,NULL,NULL,'NGC 7454',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159317,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159317,31.9,0.41,23.9,74894,NULL,NULL,'Malmquist cor.','NGC 7454',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159318,'Tertiary','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159318,31.74,0.29,22.3,74894,95,NULL,NULL,'NGC 7454',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159319,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159319,31.71,0.45,22,74894,NULL,NULL,'K','NGC 7454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159320,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159320,31.81,0.4,23,74894,NULL,NULL,'mean','NGC 7454',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159321,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159321,33.12,0.8,42,74895,75,NULL,'W91CL, r','UGC 12304',NULL,'1997ApJS..109..333W',1997,1,1.68,NULL,'G',0.000015,NULL,'14.72',0.22,'Sc','Isolated galaxy',NULL,NULL,NULL,1,345.2845,5.65436,0.193,NULL,51730693148,808292080,12629563,14.72),(159322,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159322,33.18,0.8,43.2,74895,75,NULL,'CF, r','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159323,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159323,32.57,0.38,32.7,74895,75,NULL,'CF, r, raw','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159324,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159324,32.58,0.38,32.8,74895,75,NULL,'CF, r, inv','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159325,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159325,32.72,0.2,35,74895,74.4,NULL,NULL,'UGC 12304',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159326,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159326,32.8,0.49,36.3,74895,75,NULL,'IR','UGC 12304',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159327,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159327,32.82,0.38,36.6,74895,75,NULL,'CF, r, cor','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159328,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159328,32.94,0.38,38.7,74895,75,NULL,'W91CL, r, raw','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159329,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159329,32.99,0.38,39.6,74895,75,NULL,'W91CL, r, inv','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159330,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159330,33.21,0.38,43.8,74895,75,NULL,'W91CL, r, cor','UGC 12304',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159331,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159331,33.25,0.12,44.8,74895,NULL,NULL,NULL,'UGC 12304',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159332,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159332,33.28,NULL,45.3,74895,NULL,NULL,NULL,'UGC 12304',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159333,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159333,33.59,NULL,52.3,74895,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159334,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159334,33.61,NULL,52.8,74895,NULL,NULL,'Dipole + Quadrupole','UGC 12304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159335,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159335,33.64,NULL,53.4,74895,NULL,NULL,'Dipole','UGC 12304',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159336,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159336,37.37,0.33,298,74896,70,NULL,NULL,'2MASX J23010844+0114489',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000178,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,345.285167,1.24689,0.173,NULL,51702224733,807847261,12622613,17.1),(159337,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 00879','RN',159337,41.4,0.2,1310,74897,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00879',0.453133,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159338,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159338,33.54,0.43,51,74898,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12307',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000024,NULL,'16.0',0.3,'Im',NULL,NULL,NULL,NULL,1,345.3,12.72278,0.193,NULL,52560758010,821261843,12832216,16),(159339,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159339,36.95,0.46,245,74899,70,NULL,NULL,'2MASX J23011250-0944362',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,345.3019583,-9.74339,0.081,NULL,50380638808,787197481,12299960,16.7),(159340,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159340,35.27,0.49,113,74900,75,NULL,'IR','2MFGC 17299',NULL,'2011yCatp016004901K',2011,1,0.91,NULL,'G',0.000047,NULL,'15.9g',0.25,'Sc',NULL,NULL,NULL,NULL,1,345.302666667,14.74464,0.177,NULL,52551586644,821118541,12829977,15.9),(159341,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159341,37.24,0.46,281,74901,70,NULL,NULL,'2MASX J23011404+1335551',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000137,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.308625,13.59861,0.133,NULL,52562641685,821291276,12832676,18.1),(159342,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159342,37.37,0.33,298,74902,70,NULL,NULL,'2MASX J23011471+0113099',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000191,NULL,'16.3g',0.36,'E0',NULL,NULL,NULL,NULL,1,345.3114583,1.21953,0.173,NULL,51702226412,807847287,12622613,16.3),(159343,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159343,35.81,0.49,145,74903,75,NULL,'IR','2MFGC 17300',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',NULL,NULL,'16.5B',NULL,NULL,NULL,NULL,NULL,NULL,1,345.319417,18.73783,0.173,NULL,52574146440,821471038,12835484,16.5),(159344,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159344,32.68,0.4,34.4,74904,NULL,NULL,NULL,'UGC 12308',NULL,'2009AJ....138..323T',2009,1,2.16,NULL,'G',0.000003,NULL,'14.9g',0.4,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.327875,14.33958,0.165,NULL,52559814932,821247108,12831986,14.9),(159345,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159345,32.78,0.2,36,74904,74.4,NULL,NULL,'UGC 12308',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159346,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159346,32.93,0.43,38.5,74904,75,NULL,'3.6 micron, color corrected','UGC 12308',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159347,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159347,32.99,0.47,39.7,74904,NULL,NULL,NULL,'UGC 12308',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159348,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159348,33.09,0.43,41.4,74904,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12308',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159349,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159349,33.2,0.42,43.6,74904,NULL,NULL,'Malmquist cor.','UGC 12308',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159350,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159350,38.1,0.46,416,74905,70,NULL,NULL,'2MASX J23012018+0030010',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000164,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,345.334083,0.50019,0.169,NULL,51700850091,807825782,12622277,17.6),(159351,'SGRB','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159351,38.73,NULL,557,74906,71,NULL,NULL,'CXO J230126.9-385839',NULL,'2010ApJ...709..664R',2010,1,NULL,NULL,'G',0.0001,NULL,'21.3V',NULL,'Late-type dwarf',NULL,NULL,NULL,NULL,1,345.362333333,-38.97758,NULL,NULL,50484142310,788814723,12325230,21.3),(159352,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159352,36.83,0.2,232,74907,74.4,NULL,NULL,'CGCG 430-050',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000078,NULL,'15.6g',0.33,'Sb',NULL,NULL,NULL,NULL,1,345.3679583,14.60136,0.165,NULL,52558966678,821233854,12831778,15.6),(159353,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159353,34.04,0.4,64.1,74908,NULL,NULL,'mean','NGC 7458',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000063,NULL,'13.59',1.2,'E','in a pair',NULL,NULL,NULL,1,345.369333,1.75339,0.213,NULL,51701898416,807842162,12622533,13.59),(159354,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159354,34.31,0.45,72.7,74908,NULL,NULL,'K','NGC 7458',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159355,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159355,34.35,0.8,74.2,74909,75,NULL,'MAT, I','ESO 290- G 035',NULL,'1997ApJS..109..333W',1997,1,2.89,NULL,'G',0.000029,NULL,'15.00',0.38,'Sab',NULL,NULL,NULL,NULL,1,345.385166667,-46.64631,0,NULL,50510050940,789219545,12331555,15),(159356,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159356,33.88,NULL,59.6,74909,NULL,NULL,NULL,'ESO 290- G 035',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159357,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159357,34.08,NULL,65.5,74909,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 290- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159358,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159358,34.11,NULL,66.3,74909,NULL,NULL,'Dipole + Quadrupole','ESO 290- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159359,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159359,34.12,NULL,66.7,74909,NULL,NULL,'Dipole','ESO 290- G 035',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159360,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159360,34.29,0.43,72.1,74909,75,NULL,'MAT, I, raw','ESO 290- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159361,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159361,34.4,0.32,75.7,74909,85,NULL,'I, raw','ESO 290- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159362,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159362,34.44,0.32,77.3,74909,85,NULL,'I, inv','ESO 290- G 035',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159363,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159363,34.45,0.4,77.5,74909,NULL,NULL,'Malmquist cor.','ESO 290- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159364,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159364,34.5,0.43,79.3,74909,75,NULL,'MAT, I, inv','ESO 290- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159365,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159365,34.53,0.38,80.5,74909,NULL,NULL,NULL,'ESO 290- G 035',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159366,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159366,34.55,0.49,81.3,74909,75,NULL,'IR','ESO 290- G 035',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159367,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159367,34.57,0.2,82,74909,74.4,NULL,NULL,'ESO 290- G 035',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159368,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159368,34.72,0.43,87.9,74909,75,NULL,'MAT, I, cor','ESO 290- G 035',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159369,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 09750','RN',159369,43.82,0.28,3690,74910,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09750',0.575242,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159370,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159370,38.01,0.46,399,74911,70,NULL,NULL,'SDSS J230137.55-085343.5',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000147,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,345.4065,-8.89542,0.061,NULL,50379924732,787186323,12299786,18.5),(159371,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159371,38.23,0.46,442,74912,70,NULL,NULL,'2MASX J23013755-0959310',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,345.4065,-9.99211,0.097,NULL,50366566660,786977604,12296525,16.9),(159372,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159372,37.79,0.46,362,74913,70,NULL,NULL,'2MASX J23013945+1431486',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,345.4142917,14.53028,0.165,NULL,52559735229,821245862,12831966,18),(159373,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159373,32.51,0.69,31.8,74914,100,NULL,'mid-IR','NGC 7460',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000023,NULL,'13.61',1,'SB(s)b pec:    HII','in a pair',NULL,NULL,NULL,1,345.4287917,2.26361,0.249,NULL,51701176141,807830877,12622357,13.61),(159374,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159374,32.8,0.47,36.3,74914,NULL,NULL,'H','NGC 7460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159375,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159375,32.85,0.45,37.2,74914,NULL,NULL,'K','NGC 7460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159376,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159376,32.88,0.46,37.6,74914,NULL,NULL,'J','NGC 7460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159377,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159377,33.08,0.4,41.2,74914,NULL,NULL,'mean','NGC 7460',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159378,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159378,36.01,0.5,159,74915,70,NULL,NULL,'2MASX J23014320-3126365',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.44',0.3,NULL,NULL,NULL,NULL,NULL,1,345.429917,-31.44353,NULL,NULL,50086724654,782605072,12228204,16.44),(159379,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159379,38.59,0.46,521,74916,70,NULL,NULL,'2MASX J23014661+1427326',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000175,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,345.444333,14.45917,0.165,NULL,52559739856,821245935,12831967,18.4),(159380,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159380,37.45,0.46,309,74917,70,NULL,NULL,'SDSS J230147.33-082353.4',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000161,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,345.44725,-8.39817,0.073,NULL,49485509255,773211082,12081423,18.3),(159381,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2007hj',NULL,159381,33.59,0.22,50.9,74918,72,NULL,NULL,'NGC 7461',0.01289,'2013ApJ...773...53F',2013,1,0.9,NULL,'G',0.000127,NULL,'14.32',0.7,'SB0',NULL,NULL,NULL,NULL,1,345.451375,15.58247,0.137,NULL,52607453739,821991464,12843616,14.32),(159382,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159382,36.85,0.46,235,74919,70,NULL,NULL,'2MASX J23014900+0035309',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,345.4542917,0.59203,0.149,NULL,51701046060,807828844,12622325,17),(159383,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159383,35.81,0.5,145,74920,70,NULL,NULL,'FAIRALL 0147',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000093,NULL,'15.79',0.48,'S0',NULL,NULL,NULL,NULL,1,345.4657917,-60.54069,0,NULL,48793236738,762394324,11912411,15.79),(159384,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159384,31.78,0.43,22.7,74921,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7463',NULL,'2014MNRAS.444..527S',2014,1,2.9,NULL,'G',0.000017,NULL,'13.8',0.7,'SABb: pec','in a triple',NULL,NULL,NULL,1,345.466583333,15.98186,0.193,NULL,52607408152,821990752,12843605,13.8),(159385,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159385,31.8,0.43,22.9,74921,75,NULL,'3.6 micron, color corrected','NGC 7463',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159386,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159386,31.8,0.2,22.9,74921,74.4,NULL,NULL,'NGC 7463',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159387,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159387,32.51,0.4,31.8,74921,NULL,NULL,'mean','NGC 7463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159388,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159388,32.62,0.4,33.5,74921,75,NULL,'B','NGC 7463',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159389,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159389,32.85,0.46,37.1,74921,NULL,NULL,'J','NGC 7463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159390,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159390,32.94,0.47,38.7,74921,NULL,NULL,'H','NGC 7463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159391,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159391,33,0.45,39.9,74921,NULL,NULL,'K','NGC 7463',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159392,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159392,32.08,0.8,26.1,74922,75,NULL,'B','NGC 7464',NULL,'1988NBGC.C....0000T',1988,1,0.8,NULL,'G',0.000017,NULL,'14.27',0.8,'E1 pec:','X-ray-faint group member',NULL,NULL,NULL,1,345.47375,15.97375,0.193,NULL,52607530192,821992659,12843635,14.27),(159393,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159393,36.69,0.65,218,74923,70,NULL,NULL,'LCRS B225902.8-443518',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.71',0.35,NULL,NULL,NULL,NULL,NULL,1,345.474125,-44.31925,NULL,NULL,50520230262,789378597,12334040,16.71),(159394,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159394,38.49,0.27,499,74924,70,NULL,NULL,'2MASX J23015789+0012202',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',NULL,'PHOT','17.1g',0.25,'BrClG',NULL,NULL,NULL,NULL,1,345.4912917,0.20558,0.169,NULL,51700216399,807815881,12622123,17.1),(159395,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159395,32.17,0.8,27.2,74925,75,NULL,'B','NGC 7465',NULL,'1988NBGC.C....0000T',1988,1,1.2,NULL,'G',0.000017,NULL,'13.31',0.8,'(R\')SB(s)0^0^: Sy2','X-ray-faint group member',NULL,NULL,'LINER',1,345.504041667,15.96478,0.193,NULL,52607530534,821992664,12843635,13.31),(159396,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159396,37.92,0.46,384,74926,70,NULL,NULL,'2MASX J23020136+1303105',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000183,NULL,'17.7g',0.22,NULL,NULL,NULL,NULL,NULL,1,345.50575,13.05303,0.197,NULL,52560582042,821259094,12832173,17.7),(159397,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159397,37.98,0.46,394,74927,70,NULL,NULL,'2MASX J23020184+1445076',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000148,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.50775,14.75211,0.177,NULL,52551549412,821117959,12829968,18.3),(159398,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159398,37.56,0.46,325,74928,70,NULL,NULL,'SDSS J230203.17-002708.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000167,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,345.5132083,-0.45244,0.137,NULL,49500072678,773438635,12084978,18),(159399,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159399,34.98,0.8,99.1,74929,75,NULL,'W91PP, r','NGC 7466',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00001,NULL,'14.35',0.5,'Sb             Sy2',NULL,NULL,NULL,'H II',1,345.5142917,27.05264,0.165,NULL,51899120451,810923757,12670683,14.35),(159400,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159400,34.99,0.8,99.4,74929,75,NULL,'CF, r','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159401,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159401,34.37,0.38,74.9,74929,75,NULL,'W91PP, r, raw','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159402,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159402,34.39,0.38,75.6,74929,75,NULL,'CF, r, raw','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159403,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159403,34.55,0.38,81.2,74929,75,NULL,'CF, r, inv','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159404,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159404,34.56,0.38,81.6,74929,75,NULL,'W91PP, r, inv','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159405,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159405,34.71,0.38,87.6,74929,75,NULL,'W91PP, r, cor','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159406,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159406,34.73,0.38,88.2,74929,75,NULL,'CF, r, cor','NGC 7466',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159407,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159407,34.82,0.2,92,74929,74.4,NULL,NULL,'NGC 7466',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159408,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159408,34.83,0.34,92.3,74929,NULL,NULL,NULL,'NGC 7466',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159409,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159409,34.93,0.32,96.8,74929,NULL,NULL,'Malmquist cor.','NGC 7466',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159410,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159410,34.94,0.47,97.4,74929,NULL,NULL,'H','NGC 7466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159411,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159411,35.03,0.45,101,74929,NULL,NULL,'K','NGC 7466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159412,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159412,35.08,0.4,104,74929,NULL,NULL,'mean','NGC 7466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159413,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159413,35.12,0.46,106,74929,NULL,NULL,'J','NGC 7466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159414,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159414,34.67,0.8,85.8,74930,75,NULL,'W91PP, r','UGC 12320',NULL,'1997ApJS..109..333W',1997,1,1.19,NULL,'G',0.000011,NULL,'16.0',0.12,'Scd',NULL,NULL,NULL,NULL,1,345.51675,30.76433,0.257,NULL,51917384015,811209125,12675142,16),(159415,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159415,34.61,0.43,83.4,74930,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159416,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159416,34.66,0.49,85.6,74930,75,NULL,'IR','UGC 12320',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159417,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159417,34.81,0.43,91.6,74930,75,NULL,'3.6 micron, color corrected','UGC 12320',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159418,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159418,34.89,NULL,95.2,74930,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159419,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159419,34.92,NULL,96.5,74930,NULL,NULL,'Dipole + Quadrupole','UGC 12320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159420,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159420,34.94,NULL,97.3,74930,NULL,NULL,'Dipole','UGC 12320',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159421,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159421,34.97,0.38,98.6,74930,75,NULL,'W91PP, r, raw','UGC 12320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159422,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159422,34.99,NULL,99.4,74930,NULL,NULL,NULL,'UGC 12320',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159423,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159423,35.05,0.2,102,74930,74.4,NULL,NULL,'UGC 12320',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159424,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159424,35.06,0.38,103,74930,75,NULL,'W91PP, r, inv','UGC 12320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159425,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159425,35.07,0.38,103,74930,NULL,NULL,'Malmquist cor.','UGC 12320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159426,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159426,35.09,0.38,104,74930,75,NULL,'W91PP, r, cor','UGC 12320',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159427,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159427,35.19,0.36,109,74930,NULL,NULL,NULL,'UGC 12320',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159428,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967',NULL,159428,40.35,0.17,1180,74931,70,NULL,'SN photometric redshift distance, z photo =0.326 +/- 0.033','SDSS-II SN 17967',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.529583,-0.65969,0.145,NULL,49500098517,773439039,12084984,NULL),(159429,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967','R',159429,41.56,0.28,1490,74931,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17967',0.378414,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159430,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967','R',159430,41.77,0.24,1640,74931,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17967',0.378414,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159431,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967',NULL,159431,41.5,0.18,2000,74931,70,NULL,'SALT 2','SDSS-II SN 17967',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159432,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17967',NULL,159432,41.56,0.18,2050,74931,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17967',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159433,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159433,35.54,0.8,128,74932,75,NULL,'W91PP, r','UGC 12318',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00009,NULL,'16.0',0.4,'SBb            Sy2',NULL,NULL,NULL,'Sy 2',1,345.533125,25.66978,0.181,NULL,51893443791,810835059,12669297,16),(159434,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159434,35.42,0.45,121,74932,NULL,NULL,'Malmquist cor.','UGC 12318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159435,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159435,35.42,0.38,121,74932,75,NULL,'W91PP, r, raw','UGC 12318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159436,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159436,35.59,0.38,131,74932,75,NULL,'W91PP, r, cor','UGC 12318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159437,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159437,35.6,0.38,132,74932,75,NULL,'W91PP, r, inv','UGC 12318',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159438,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159438,35.61,0.41,132,74932,NULL,NULL,NULL,'UGC 12318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159439,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159439,35.63,0.2,134,74932,74.4,NULL,NULL,'UGC 12318',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159440,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159440,35.65,NULL,135,74933,NULL,NULL,NULL,'SDSS J2302+0049',NULL,'2014A&A...562A..49M',2014,1,0.11,NULL,'G',NULL,NULL,'18.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,345.541583333,0.8275,0.165,NULL,51700390801,807818606,12622165,18.8),(159441,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159441,30.9,0.8,15.1,74934,75,NULL,'MAT, I','NGC 7456',NULL,'1997ApJS..109..333W',1997,1,5.5,NULL,'G',0.000007,NULL,'12.78',1.6,'SA(s)cd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.543417,-39.56939,NULL,NULL,50498140481,789033445,12328647,12.78),(159442,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159442,30.9,0.8,15.1,74934,75,NULL,'A82, H','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159443,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159443,30.04,0.4,10.2,74934,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 4 galaxy group','NGC 7456',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159444,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159444,30.7,0.32,13.8,74934,85,NULL,'I, raw','NGC 7456',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159445,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159445,30.7,0.32,13.8,74934,85,NULL,'I, inv','NGC 7456',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159446,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159446,30.76,0.35,14.2,74934,NULL,NULL,NULL,'NGC 7456',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159447,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159447,30.77,0.47,14.2,74934,75,NULL,'A82, H, inv','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159448,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159448,30.76,0.39,14.2,74934,73,NULL,'opt','NGC 7456',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159449,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159449,30.83,0.47,14.6,74934,75,NULL,'A82, H, raw','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159450,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159450,30.84,0.4,14.7,74934,75,NULL,'B','NGC 7456',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159451,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159451,30.89,0.43,15.1,74934,75,NULL,'3.6 micron, color corrected','NGC 7456',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159452,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159452,30.89,0.43,15.1,74934,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7456',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159453,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159453,31.01,0.43,15.9,74934,75,NULL,'MAT, I, raw','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159454,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159454,31.08,0.43,16.4,74934,75,NULL,'MAT, I, inv','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159455,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159455,31.08,0.2,16.4,74934,74.4,NULL,NULL,'NGC 7456',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159456,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159456,31.22,0.47,17.5,74934,75,NULL,'A82, H, cor','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159457,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159457,31.32,0.43,18.4,74934,75,NULL,'MAT, I, cor','NGC 7456',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159458,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159458,31.64,0.45,21.3,74934,NULL,NULL,NULL,'NGC 7456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159459,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159459,31.79,0.42,22.8,74934,NULL,NULL,'Malmquist cor.','NGC 7456',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159460,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159460,38.49,0.27,499,74935,70,NULL,NULL,'SDSS J230211.32+001347.8',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000152,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,345.5472083,0.22997,0.169,NULL,51700213238,807815831,12622122,18.4),(159461,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159461,31.18,0.8,17.2,74936,75,NULL,'MAT, I','ESO 406- G 042',NULL,'1997ApJS..109..333W',1997,1,1.7,'Confused HIPASS source','G',0.00002,NULL,'15.44',1.2,'SAB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.5592083,-37.08372,NULL,NULL,50486576259,788852754,12325824,15.44),(159462,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159462,31.14,0.8,16.9,74936,75,NULL,NULL,'ESO 406- G 042',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159463,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159463,31.06,0.32,16.3,74936,85,NULL,'I, inv','ESO 406- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159464,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159464,31.13,0.32,16.8,74936,85,NULL,'I, raw','ESO 406- G 042',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159465,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159465,31.35,0.4,18.6,74936,NULL,NULL,NULL,'ESO 406- G 042',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159466,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159466,31.35,0.39,18.6,74936,73,NULL,'opt','ESO 406- G 042',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159467,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159467,31.51,0.43,20,74936,75,NULL,'MAT, I, inv','ESO 406- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159468,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159468,31.65,0.43,21.4,74936,75,NULL,'MAT, I, raw','ESO 406- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159469,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159469,31.88,0.43,23.8,74936,75,NULL,'MAT, I, cor','ESO 406- G 042',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159470,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802',NULL,159470,39.47,0.91,783,74937,70,NULL,'SN photometric redshift distance, z photo =0.203 +/- 0.127','SDSS-II SN 07802',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.575916667,0.72911,0.133,NULL,51700465826,807819778,12622184,NULL),(159471,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802',NULL,159471,41.07,0.27,1640,74937,70,NULL,NULL,'SDSS-II SN 07802',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159472,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802','R',159472,42.01,0.27,1790,74937,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07802',0.407556,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159473,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802','R',159473,42.33,0.27,2070,74937,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07802',0.407556,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159474,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802',NULL,159474,41.95,0.18,2450,74937,70,NULL,'SALT 2','SDSS-II SN 07802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159475,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 07802',NULL,159475,42.02,0.18,2540,74937,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159476,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159476,37.46,0.46,310,74938,70,NULL,NULL,'SDSS J230218.34-002348.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000153,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.576417,-0.39692,0.137,NULL,49499947507,773436679,12084948,18.3),(159477,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159477,33.69,0.4,54.7,74939,NULL,NULL,NULL,'UGC 12321',NULL,'2009AJ....138..323T',2009,1,1,NULL,'G',0.000003,NULL,'15.67',0.1,'Sbc','X-ray-faint group member',NULL,NULL,NULL,1,345.579291667,16.02783,0.193,NULL,52607573696,821993339,12843645,15.67),(159478,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159478,34.01,0.4,63.3,74939,NULL,NULL,'Malmquist cor.','UGC 12321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159479,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159479,34.01,0.39,63.5,74939,NULL,NULL,NULL,'UGC 12321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159480,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159480,34.06,0.2,64.9,74939,74.4,NULL,NULL,'UGC 12321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159481,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 12213',NULL,159481,40.87,0.36,1490,74940,70,NULL,'SN photometric redshift distance, z photo =0.438 +/- 0.111','SDSS-II SN 12213',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.584083,-0.64636,0.145,NULL,49499977660,773437150,12084955,NULL),(159482,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 12213',NULL,159482,41.27,0.22,1790,74940,70,NULL,'SALT 2','SDSS-II SN 12213',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159483,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 12213',NULL,159483,41.32,0.22,1840,74940,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 12213',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159484,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18253',NULL,159484,39.82,0.46,920,74941,70,NULL,'SN photometric redshift distance, z photo =0.244 +/- 0.069','SDSS-II SN 18253',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.5842917,-0.9085,0.153,NULL,49499857581,773435274,12084926,NULL),(159485,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18253','R',159485,40.66,0.28,1060,74941,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18253',0.280569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159486,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18253','R',159486,40.7,0.28,1080,74941,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18253',0.280569,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159487,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159487,37.7,0.46,347,74942,70,NULL,NULL,'SDSS J230223.15-092823.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000143,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.5965,-9.47308,0.057,NULL,50367174136,786987095,12296673,18.5),(159488,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159488,38.67,0.46,541,74943,70,NULL,NULL,'2MASX J23022470+0040192',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000161,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,345.60275,0.67192,0.133,NULL,51700988928,807827952,12622311,17.6),(159489,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159489,38.49,0.27,499,74944,70,NULL,NULL,'2MASX J23022643+0013432',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000185,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,345.610083,0.22861,0.149,NULL,51700244187,807816315,12622129,18),(159490,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159490,36,0.54,158,74945,70,NULL,NULL,'2MASX J23022677-1303382',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.000103,NULL,'16.21',0.41,NULL,NULL,NULL,NULL,NULL,1,345.6115,-13.06056,0.081,NULL,50413770820,787715169,12308049,16.21),(159491,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159491,35.7,NULL,138,74946,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2449',NULL,'2010Ap&SS.325..163P',2010,1,0.93,NULL,'G',0.000014,NULL,'16.8',0.09,'Scd',NULL,NULL,NULL,NULL,1,345.615375,11.63511,0.189,NULL,52429998083,819218720,12800292,16.8),(159492,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159492,35.71,NULL,139,74946,NULL,NULL,'Dipole + Quadrupole','FGC 2449',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159493,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159493,35.72,NULL,139,74946,NULL,NULL,'Dipole','FGC 2449',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159494,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159494,35.75,0.49,141,74946,75,NULL,'IR','FGC 2449',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159495,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159495,35.8,NULL,145,74946,NULL,NULL,NULL,'FGC 2449',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159496,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159496,38.74,0.46,559,74947,70,NULL,NULL,'SDSS J230230.01+142618.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000168,NULL,'18.8g',0.09,NULL,NULL,NULL,NULL,NULL,1,345.625041667,14.43836,0.177,NULL,52559444627,821241322,12831895,18.8),(159497,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159497,36.46,0.46,196,74948,70,NULL,NULL,'2MASX J23023337+1402542',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000186,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,345.6389583,14.04861,0.153,NULL,52559493054,821242078,12831907,17),(159498,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423',NULL,159498,40.22,0.2,1110,74949,70,NULL,'SN photometric redshift distance, z photo =0.303 +/- 0.036','SDSS-II SN 17423',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.642333,-0.8385,0.117,NULL,49499809173,773434518,12084914,20.6),(159499,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423','R',159499,40.84,0.22,1170,74949,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17423',0.265158,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159500,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423','R',159500,41.07,0.17,1300,74949,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17423',0.265158,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159501,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423',NULL,159501,40.74,0.14,1410,74949,70,NULL,'SALT 2','SDSS-II SN 17423',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159502,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17423',NULL,159502,40.76,0.14,1420,74949,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17423',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159503,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15779',NULL,159503,39.33,0.44,734,74950,70,NULL,'SN photometric redshift distance, z photo =0.189 +/- 0.048','SDSS-II SN 15779',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.644667,-0.46264,0.137,NULL,49499961182,773436893,12084951,21.1),(159504,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15779','R',159504,41.14,0.26,1340,74950,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15779',0.262538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159505,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15779','R',159505,41.23,0.22,1400,74950,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15779',0.262538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159506,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 05187','RN',159506,43.84,0.25,3880,74951,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05187',0.5113,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159507,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159507,35.57,0.2,130,74952,74.4,NULL,NULL,'CGCG 430-054',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.00009,NULL,'15.0g',0.49,'Sab',NULL,NULL,NULL,NULL,1,345.667958333,13.32908,0.181,NULL,52562563478,821290054,12832657,15),(159508,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159508,30.64,0.8,13.4,74953,75,NULL,'A82, H','NGC 7462',NULL,'1997ApJS..109..333W',1997,1,4.2,NULL,'G',0.000013,NULL,'12.53',0.7,'SB(s)bc? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.6937083,-40.83525,NULL,NULL,50489983134,788905986,12326656,12.53),(159509,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159509,29.23,0.4,7,74953,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7462',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159510,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159510,29.31,0.4,7.29,74953,75,NULL,NULL,'NGC 7462',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159511,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159511,29.32,0.41,7.3,74953,73,NULL,'IR','NGC 7462',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159512,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159512,29.87,0.43,9.4,74953,75,NULL,'3.6 micron, color corrected','NGC 7462',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159513,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159513,29.91,0.2,9.59,74953,74.4,NULL,NULL,'NGC 7462',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159514,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159514,29.91,0.43,9.6,74953,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7462',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159515,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159515,29.95,0.35,9.77,74953,NULL,NULL,NULL,'NGC 7462',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159516,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159516,30.01,0.47,10,74953,75,NULL,'A82, H, inv','NGC 7462',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159517,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159517,30.02,NULL,10.1,74953,NULL,NULL,NULL,'NGC 7462',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159518,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159518,30.13,0.47,10.6,74953,75,NULL,'A82, H, raw','NGC 7462',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159519,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159519,30.29,0.48,11.4,74953,NULL,NULL,NULL,'NGC 7462',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159520,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159520,30.48,0.49,12.5,74953,75,NULL,'IR','NGC 7462',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159521,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159521,30.54,0.4,12.8,74953,73,NULL,'opt','NGC 7462',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159522,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159522,30.57,0.4,13,74953,75,NULL,'B','NGC 7462',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159523,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159523,30.57,0.46,13,74953,NULL,NULL,'J','NGC 7462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159524,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159524,30.59,0.47,13.1,74953,75,NULL,'A82, H, cor','NGC 7462',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159525,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159525,30.62,0.41,13.3,74953,NULL,NULL,'Malmquist cor.','NGC 7462',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159526,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159526,30.79,0.47,14.4,74953,NULL,NULL,'H','NGC 7462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159527,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159527,30.89,0.45,15.1,74953,NULL,NULL,'K','NGC 7462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159528,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159528,30.91,0.4,15.2,74953,NULL,NULL,'mean','NGC 7462',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159529,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2011io',NULL,159529,36.16,0.56,170,74954,72,NULL,'M(H) = -18.317 mag','2MASX J23024668+0848186',NULL,'2014ApJ...784..105W',2013,1,NULL,NULL,'G',NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,345.6945,8.80508,0.117,NULL,52430955131,819233673,12800526,NULL),(159530,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159530,37.63,0.46,336,74955,70,NULL,NULL,'2MASX J23024806+1523072',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000197,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,345.70025,15.38539,0.173,NULL,52552381980,821130968,12830171,17.5),(159531,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159531,34.39,0.8,75.6,74956,75,NULL,'MAT, I','IC 5282',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'14.91',0.6,'Sd',NULL,NULL,NULL,NULL,1,345.700791667,21.87436,0.313,NULL,52567061046,821360328,12833755,14.91),(159532,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159532,34.4,0.8,75.7,74956,75,NULL,'W91PP, r','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159533,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159533,34.4,0.8,75.8,74956,75,NULL,'CF, r','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159534,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159534,34.34,0.2,73.8,74956,74.4,NULL,NULL,'IC 5282',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159535,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159535,34.47,0.65,78.5,74956,NULL,NULL,NULL,'IC 5282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159536,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159536,34.5,0.32,79.5,74956,85,NULL,'I, raw','IC 5282',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159537,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159537,34.54,0.43,81.1,74956,75,NULL,'MAT, I, raw','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159538,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159538,34.55,0.32,81.4,74956,85,NULL,'I, inv','IC 5282',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159539,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159539,34.57,0.62,82.1,74956,NULL,NULL,'Malmquist cor.','IC 5282',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159540,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159540,34.62,0.38,83.8,74956,75,NULL,'W91PP, r, raw','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159541,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159541,34.76,0.43,89.7,74956,75,NULL,'MAT, I, inv','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159542,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159542,34.77,0.38,89.8,74956,75,NULL,'W91PP, r, inv','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159543,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159543,34.84,0.38,93.1,74956,75,NULL,'CF, r, raw','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159544,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159544,34.9,0.38,95.4,74956,75,NULL,'W91PP, r, cor','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159545,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159545,34.9,0.43,95.5,74956,75,NULL,'MAT, I, cor','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159546,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159546,35,0.38,99.8,74956,75,NULL,'CF, r, inv','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159547,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159547,35.06,0.38,103,74956,75,NULL,'CF, r, cor','IC 5282',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159548,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15504','R',159548,40.62,0.16,1050,74957,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006oc','SDSS J230248.35-005235.1',0.2701,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',0.0005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,345.701375,-0.87686,0.117,NULL,49499808652,773434510,12084914,NULL),(159549,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2006oc',NULL,159549,40.1,0.18,1050,74957,70,NULL,'Hubble residual 0.09 for z0.27010','SDSS J230248.35-005235.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159550,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 15504','R',159550,40.87,0.26,1180,74957,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006oc','SDSS J230248.35-005235.1',0.2701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159551,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18475','RN',159551,39.51,0.22,675,74958,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18475',0.181642,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159552,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18475','RN',159552,39.8,0.25,773,74958,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18475',0.181642,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159553,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159553,35.5,0.49,126,74959,75,NULL,'IR','ESO 239- G 007',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.000033,NULL,'16.35',0.2,'S...',NULL,NULL,NULL,NULL,1,345.711083,-48.55828,0,NULL,50515464503,789304132,12332877,16.35),(159554,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159554,35.9,0.25,151,74959,NULL,NULL,NULL,'ESO 239- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159555,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159555,35.91,0.25,152,74959,NULL,NULL,'Malmquist cor.','ESO 239- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159556,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159556,35.94,0.2,154,74959,74.4,NULL,NULL,'ESO 239- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159557,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13460',NULL,159557,40.25,0.19,1120,74960,70,NULL,'SN photometric redshift distance, z photo =0.308 +/- 0.034','SDSS-II SN 13460',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.7145,0.14189,0.149,NULL,51700257334,807816520,12622133,NULL),(159558,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13460','R',159558,40.96,0.23,1180,74960,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13460',0.310903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159559,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 13460','R',159559,41.01,0.17,1210,74960,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13460',0.310903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159560,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159560,35.21,NULL,110,74961,NULL,NULL,NULL,'UGC 12327',NULL,'2000BSAO...50....5K',2000,1,1.71,NULL,'G',0.000013,NULL,'16.5',0.11,'Scd',NULL,NULL,NULL,NULL,1,345.723708333,26.01481,0.153,NULL,51893908942,810842327,12669411,16.5),(159561,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159561,36.87,0.46,236,74962,70,NULL,NULL,'2MASX J23025386+1310342',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000135,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,345.724417,13.17611,0.181,NULL,52562821183,821294080,12832720,18.2),(159562,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159562,35.74,NULL,141,74963,NULL,NULL,'Dipole + Quadrupole','UGC 12324',NULL,'2010Ap&SS.325..163P',2010,1,1.36,NULL,'G',0.000087,NULL,'16.0',0.13,'Sc',NULL,NULL,NULL,NULL,1,345.735583,8.57994,0.129,NULL,51722096901,808157764,12627465,16),(159563,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159563,35.74,NULL,141,74963,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159564,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159564,35.75,NULL,141,74963,NULL,NULL,'Dipole','UGC 12324',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159565,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17955',NULL,159565,40.27,0.2,1130,74964,70,NULL,'SN photometric redshift distance, z photo =0.311 +/- 0.036','SDSS-II SN 17955',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.738791667,-0.34986,0.145,NULL,49499332641,773427072,12084798,21.4),(159566,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 17955','R',159566,41.77,0.26,1520,74964,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17955',0.483387,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159567,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159567,34.39,0.8,75.4,74965,75,NULL,'W91PP, r','UGC 12331',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.25',0.6,'S?',NULL,NULL,NULL,NULL,1,345.746333,34.72708,0.329,NULL,52043960197,813186878,12706044,15.25),(159568,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159568,34.49,0.38,79.1,74965,75,NULL,'W91PP, r, raw','UGC 12331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159569,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159569,34.57,0.38,81.9,74965,75,NULL,'W91PP, r, inv','UGC 12331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159570,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159570,34.66,0.2,85.5,74965,74.4,NULL,NULL,'UGC 12331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159571,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159571,34.68,0.38,86.2,74965,75,NULL,'W91PP, r, cor','UGC 12331',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159572,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159572,34.73,0.37,88.2,74965,NULL,NULL,NULL,'UGC 12331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159573,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159573,34.77,0.36,90,74965,NULL,NULL,'Malmquist cor.','UGC 12331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159574,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159574,32.31,0.8,28.9,74966,75,NULL,'B','NGC 7468',NULL,'1988NBGC.C....0000T',1988,1,0.9,NULL,'G',0.00002,NULL,'14.16',0.6,'E3: pec','X-ray-faint group member',NULL,NULL,NULL,1,345.746917,16.60525,0.237,NULL,52608567922,822008873,12843888,14.16),(159575,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2007mw',NULL,159575,40.23,0.19,1110,74967,70,NULL,'Hubble residual -0.14 for z0.32820','SDSS J230302.72+005057.8',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.0005,NULL,'21.4g',0.03,NULL,NULL,NULL,NULL,NULL,1,345.761333333,0.84939,0.145,NULL,51700483359,807820052,12622188,21.4),(159576,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18617','R',159576,41.15,0.28,1280,74967,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mw','SDSS J230302.72+005057.8',0.3282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159577,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18617','R',159577,41.25,0.23,1340,74967,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mw','SDSS J230302.72+005057.8',0.3282,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159578,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2007mw',NULL,159578,41.02,0.17,1600,74967,70,NULL,'SALT 2','SDSS J230302.72+005057.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159579,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2007mw',NULL,159579,41.06,0.17,1630,74967,70,NULL,'SALT 2, Malmquist cor.','SDSS J230302.72+005057.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159580,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159580,37.69,0.46,346,74968,70,NULL,NULL,'2MASX J23030670-0832075',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000197,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,345.778083333,-8.53531,0.065,NULL,49489670708,773276104,12082439,17.4),(159581,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159581,37.9,0.46,380,74969,70,NULL,NULL,'2MASX J23031344-0945335',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,345.806083,-9.75933,0.097,NULL,50367070275,786985473,12296648,17.4),(159582,'AGN time lag','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159582,33.39,0.07,47.7,74970,NULL,NULL,NULL,'NGC 7469',NULL,'2014ApJ...784L..11Y',2014,1,1.5,NULL,'G',0.000007,NULL,'13.0',1.1,'(R\')SAB(rs)a   Sy1.2','Pair member (points to parent)',NULL,NULL,'Sy 1',1,345.815083333,8.874,0.117,NULL,51708475481,807944929,12624139,13),(159583,'AGN time lag','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159583,34.43,0.55,77,74970,44,NULL,NULL,'NGC 7469',NULL,'2007MNRAS.380..669C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159584,'AGN time lag','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159584,35.34,NULL,117,74970,42,NULL,NULL,'NGC 7469',NULL,'1999MNRAS.302L..24C',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159585,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SN 2008ec',NULL,159585,34.15,0.2,66.4,74970,70,NULL,'SALT 2','NGC 7469',0.016317,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159586,'Ring Diameter','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159586,33.8,0.84,57,74970,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7469',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159587,'Black Hole','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159587,34.58,0.34,82.4,74970,NULL,NULL,NULL,'NGC 7469',NULL,'2014ApJ...793..108W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159588,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159588,33.24,NULL,44.4,74970,75,NULL,'CO','NGC 7469',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159589,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159589,33.5,0.45,50,74970,NULL,NULL,'K','NGC 7469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159590,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159590,33.65,NULL,53.6,74970,75,NULL,'HI','NGC 7469',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159591,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159591,33.71,0.47,55.3,74970,NULL,NULL,'H','NGC 7469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159592,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159592,33.88,0.46,59.6,74970,NULL,NULL,'J','NGC 7469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159593,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159593,33.94,0.4,61.5,74970,NULL,NULL,'mean','NGC 7469',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159594,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340',NULL,159594,39.87,0.23,942,74971,70,NULL,NULL,'SDSS-II SN 14340',NULL,'2013MNRAS.434.1443X',2013,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,345.826583,-0.85539,0.117,NULL,49499725022,773433203,12084893,NULL),(159595,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340','R',159595,40.58,0.24,1020,74971,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14340',0.277441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159596,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340','R',159596,40.63,0.18,1050,74971,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14340',0.277441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159597,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340',NULL,159597,40.47,0.18,1240,74972,70,NULL,'SALT 2','SDSS J230318.41-005118.9',NULL,'2013ApJ...763...88C',2013,1,0.03,NULL,'G',0.000186,NULL,'19.4g',0.02,NULL,NULL,NULL,NULL,NULL,1,345.8267083,-0.85528,0.117,NULL,49499725023,773433203,12084893,19.4),(159598,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14340',NULL,159598,40.5,0.18,1260,74972,70,NULL,'SALT 2, Malmquist cor.','SDSS J230318.41-005118.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159599,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10002','RN',159599,41.51,0.3,1600,74973,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 10002',0.251872,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159600,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 10002','RN',159600,42.21,0.27,2210,74973,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 10002',0.251872,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159601,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 08947','RN',159601,39.68,0.27,731,74974,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08947',0.18136,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159602,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 08947','RN',159602,40.72,0.26,1180,74974,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08947',0.18136,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159603,'IRAS','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159603,33.09,0.8,41.5,74975,75,NULL,'MAT, I','ESO 604- G 001',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000017,NULL,'14.39',0.13,'Sc',NULL,NULL,NULL,NULL,1,345.85,-19.50389,0.068,NULL,50447265069,788238516,12316226,14.39),(159604,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159604,32.45,0.32,30.9,74975,85,NULL,'I, inv','ESO 604- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159605,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159605,32.49,0.32,31.5,74975,85,NULL,'I, raw','ESO 604- G 001',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159606,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159606,32.81,0.43,36.5,74975,75,NULL,'MAT, I, inv','ESO 604- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159607,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159607,32.9,0.43,38,74975,75,NULL,'MAT, I, raw','ESO 604- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159608,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159608,32.98,NULL,39.4,74975,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 604- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159609,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159609,33,NULL,39.8,74975,NULL,NULL,'Dipole + Quadrupole','ESO 604- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159610,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159610,33.01,NULL,39.9,74975,NULL,NULL,'Dipole','ESO 604- G 001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159611,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159611,33.13,0.43,42.2,74975,75,NULL,'MAT, I, cor','ESO 604- G 001',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159612,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159612,33.59,0.64,52.4,74975,NULL,NULL,'Malmquist cor.','ESO 604- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159613,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159613,33.71,0.61,55.3,74975,NULL,NULL,NULL,'ESO 604- G 001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159614,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159614,33.92,0.2,60.8,74975,74.4,NULL,NULL,'ESO 604- G 001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159615,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159615,38.27,0.46,450,74976,70,NULL,NULL,'2MASXi J2303240-095253',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,345.8502083,-9.88147,0.097,NULL,50366607728,786978245,12296535,18.1),(159616,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159616,37.73,0.46,351,74977,70,NULL,NULL,'2MASX J23032627-0013013',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00015,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,345.859583,-0.21703,0.145,NULL,49499124543,773423820,12084747,17.3),(159617,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159617,37.54,0.27,322,74978,70,NULL,NULL,'2MASX J23032674-1032255',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,345.861333333,-10.54039,0.089,NULL,50368457193,787007143,12296986,17.4),(159618,'Tully est','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159618,31.33,0.8,18.5,74979,75,NULL,'B','ESO 290- G 039',NULL,'1988NBGC.C....0000T',1988,1,1.1,NULL,'G',0.000023,NULL,'15.00',0.9,'SB(s)m',NULL,NULL,NULL,NULL,1,345.8737083,-46.03142,0,NULL,50510020014,789219062,12331547,15),(159619,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159619,37.54,0.27,322,74980,70,NULL,NULL,'2MASX J23033027-1037175',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,345.876125,-10.62167,0.089,NULL,50368469797,787007340,12296989,16.9),(159620,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 16079','RN',159620,40.62,0.27,1150,74981,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 16079',0.153911,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159621,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 16079','RN',159621,40.74,0.2,1220,74981,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 16079',0.153911,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159622,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 14034',NULL,159622,40.86,0.48,1490,74982,70,NULL,'SN photometric redshift distance, z photo =0.437 +/- 0.152','SDSS-II SN 14034',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,345.8864583,-0.28228,0.145,NULL,49499114732,773423667,12084744,NULL),(159623,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18221','RN',159623,40.27,0.28,877,74983,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18221',0.293922,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159624,'SNIa','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 18221','RN',159624,40.36,0.25,911,74983,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18221',0.293922,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159625,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159625,38.05,0.46,407,74984,70,NULL,NULL,'2MASX J23033537-1042381',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000159,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,345.897417,-10.7105,0.089,NULL,50368425617,787006650,12296978,17.6),(159626,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 08948','RN',159626,43.61,0.32,3750,74985,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 08948',0.404376,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159627,'SNIa SDSS','2016-12-15 15:16:03','2016-12-16 11:21:20','1','SDSS-II SN 08948','RN',159627,43.82,0.3,4140,74985,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 08948',0.404376,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159628,'Tully-Fisher','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159628,33.46,0.2,49.2,74986,74.4,NULL,NULL,'CGCG 405-028',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00012,NULL,'14.9',0.4,'SBd',NULL,NULL,NULL,NULL,1,345.9004583,9.29067,0.113,NULL,52430994550,819234289,12800535,14.9),(159629,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,NULL,159629,36.66,0.66,215,74987,70,NULL,NULL,'2MASX J23033829-7903432',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.7b',NULL,NULL,NULL,NULL,NULL,NULL,1,345.909583,-79.06206,0.393,NULL,48554745190,758667893,11854185,16.7),(159630,'FP','2016-12-15 15:16:03','2016-12-16 11:21:20','1',NULL,'R',159630,37.65,0.46,339,74988,70,NULL,NULL,'2MASX J23033897-1016191',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000169,NULL,'17.6g',0.17,'AGN',NULL,NULL,NULL,NULL,1,345.9122917,-10.27208,0.085,NULL,50368529016,787008265,12297004,17.6),(159631,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159631,34.87,0.46,94.4,74989,70,NULL,NULL,'IC 1466',NULL,'2014MNRAS.445.2677S',2014,1,0.74,NULL,'G',0.00015,NULL,'14.3',0.67,'(R?)SA(r)0',NULL,NULL,NULL,NULL,1,345.9127083,-2.77544,0.161,NULL,49505431605,773522368,12086287,14.3),(159632,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159632,35.15,0.5,107,74990,70,NULL,NULL,'2MASX J23034042-7903252',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,345.918875,-79.05694,0.393,NULL,48554742492,758667851,11854185,16.5),(159633,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159633,37.56,0.33,324,74991,70,NULL,NULL,'2MASX J23034261-0816421',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000145,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,345.927416667,-8.27833,0.081,NULL,49489723511,773276929,12082452,18.2),(159634,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03788','RN',159634,41.04,0.24,1370,74992,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03788',0.18212,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159635,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03788','RN',159635,41.28,0.25,1530,74992,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03788',0.18212,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159636,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159636,35.47,0.46,124,74993,70,NULL,NULL,'2MASX J23034557-0826451',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.000181,NULL,'15.4g',0.32,'S0',NULL,NULL,NULL,NULL,1,345.9400417,-8.44603,0.073,NULL,49489757016,773277453,12082460,15.4),(159637,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159637,33.19,0.8,43.4,74994,75,NULL,'MAT, I','ESO 109- G 032',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000028,NULL,'14.86',0.4,'SAB(s)c? sp','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,345.9435,-62.522,0,NULL,48766060242,761969691,11905776,14.86),(159638,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159638,33.38,0.6,47.4,74994,NULL,NULL,NULL,'ESO 109- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159639,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159639,33.41,0.32,48.1,74994,85,NULL,'I, raw','ESO 109- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159640,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159640,33.42,0.32,48.3,74994,85,NULL,'I, inv','ESO 109- G 032',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159641,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159641,33.42,0.2,48.3,74994,74.4,NULL,NULL,'ESO 109- G 032',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159642,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159642,33.45,0.58,49,74994,NULL,NULL,'Malmquist cor.','ESO 109- G 032',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159643,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159643,33.62,0.43,52.9,74994,75,NULL,'MAT, I, raw','ESO 109- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159644,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159644,33.7,0.43,55.1,74994,75,NULL,'MAT, I, inv','ESO 109- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159645,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159645,33.84,0.43,58.6,74994,75,NULL,'MAT, I, cor','ESO 109- G 032',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159646,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03549','RN',159646,40.01,0.13,710,74995,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03549',0.412444,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159647,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03549','RN',159647,40.4,0.21,849,74995,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03549',0.412444,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159648,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159648,33.12,0.43,42,74996,75,NULL,'3.6 micron, color + selection bias corrected','ESO 469- G 008',NULL,'2014MNRAS.444..527S',2014,1,1.2,NULL,'G',0.00001,NULL,'15.22',0.5,'SB(s)m:',NULL,NULL,NULL,NULL,1,345.9587083,-28.74361,0.026,NULL,50105558942,782899358,12232802,15.22),(159649,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 19072','RN',159649,39.72,0.28,762,74997,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19072',0.153776,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159650,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 19072','RN',159650,40.3,0.34,993,74997,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19072',0.153776,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159651,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 02350','RN',159651,41.43,0.22,1600,74998,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02350',0.205267,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159652,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 02350','RN',159652,42.17,0.48,2250,74998,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02350',0.205267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159653,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159653,37.69,0.46,344,74999,70,NULL,NULL,'SDSS J230358.13-092403.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000133,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,345.99225,-9.40108,0.089,NULL,50367130324,786986411,12296662,18.4),(159654,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159654,35.37,0.49,119,75000,75,NULL,'IR','FGC 2455',NULL,'2011yCatp016004901K',2011,1,1.18,NULL,'G',0.000053,NULL,'16.5g',0.16,'Sdm',NULL,NULL,NULL,NULL,1,345.998,-8.79425,0.065,NULL,49478330390,773098912,12079670,16.5),(159655,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159655,37.43,0.46,306,75001,70,NULL,NULL,'2MASX J23040071+1304315',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,346.003,13.07542,0.169,NULL,52560246406,821253850,12832091,17.9),(159656,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03945','R',159656,41.01,0.27,1260,75002,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J230402.37-001659.2',0.262001,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',NULL,'PHOT','21.1g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,346.009875,-0.28314,0.145,NULL,49507496127,773554626,12086791,21.1),(159657,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03945','R',159657,41.17,0.24,1360,75002,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J230402.37-001659.2',0.262001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159658,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03945',NULL,159658,40.9,0.16,1510,75002,70,NULL,'SALT 2','SDSS J230402.37-001659.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159659,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03945',NULL,159659,40.93,0.16,1530,75002,70,NULL,'SALT 2, Malmquist cor.','SDSS J230402.37-001659.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159660,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159660,37.56,0.33,324,75003,70,NULL,NULL,'SDSS J230410.88-081734.6',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000134,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,346.045333333,-8.29294,0.089,NULL,49490605666,773290713,12082667,18.2),(159661,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159661,37.25,0.54,282,75004,70,NULL,NULL,'FAIRALL 1032',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.71',0.72,'SAB(r)a:',NULL,NULL,NULL,NULL,1,346.065041667,-42.73792,NULL,NULL,50518747101,789355423,12333678,15.71),(159662,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18327','RN',159662,42.43,0.3,2030,75005,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18327',0.508563,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159663,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159663,37.54,0.27,322,75006,70,NULL,NULL,'2MASX J23041849-1028353',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000164,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,346.077083,-10.47653,0.085,NULL,50369331203,787020800,12297200,17.4),(159664,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159664,37.15,0.46,269,75007,70,NULL,NULL,'2MASX J23042030-0012408',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.45',0.32,NULL,NULL,NULL,NULL,NULL,1,346.084667,-0.21136,0.145,NULL,49507523935,773555061,12086797,16.45),(159665,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159665,37.27,0.46,285,75008,70,NULL,NULL,'2MASX J23042038-1004253',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.7g',0.25,NULL,NULL,NULL,NULL,NULL,1,346.084833,-10.07364,0.081,NULL,50366579022,786977797,12296528,16.7),(159666,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 07803',NULL,159666,39.28,0.58,717,75009,70,NULL,'SN photometric redshift distance, z photo =0.184 +/- 0.065','SDSS-II SN 07803',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.086333333,0.69039,0.157,NULL,51704402360,807881286,12623145,NULL),(159667,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159667,37.32,0.46,291,75010,70,NULL,NULL,'2MASX J23042073-1042293',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000144,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,346.086416667,-10.70828,0.089,NULL,50369274380,787019912,12297186,17.4),(159668,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159668,38.02,0.33,402,75011,70,NULL,NULL,'2MASX J23042082+0019511',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000083,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,346.0867083,0.33083,0.145,NULL,51704284106,807879439,12623116,17.4),(159669,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159669,38.02,0.33,402,75012,70,NULL,NULL,'2MASX J23042419+0017568',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,346.100833,0.29911,0.145,NULL,51704285593,807879462,12623116,17.6),(159670,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21885',NULL,159670,40.55,0.51,1290,75013,70,NULL,'SN photometric redshift distance, z photo =0.364 +/- 0.128','SDSS-II SN 21885',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','20.8g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.113583333,0.31839,0.145,NULL,51704258284,807879035,12623109,20.8),(159671,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21885','R',159671,41.99,0.42,1780,75013,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21885',0.406059,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159672,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 08017','RN',159672,42.3,0.19,2190,75014,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08017',0.316816,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159673,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 08017','RN',159673,42.62,0.24,2540,75014,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08017',0.316816,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159674,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159674,37.73,0.17,319,75015,74.2,NULL,'SALT 2','APMUKS(BJ) B230147.96-373644.6',0.101,'2010ApJ...716..712A',2010,1,0.18,NULL,'G',NULL,NULL,'18.90',0.14,'Sa?',NULL,NULL,NULL,NULL,1,346.142917,-37.34244,NULL,NULL,50486230091,788847345,12325739,18.9),(159675,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159675,38.17,0.29,391,75015,72,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',0.101,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159676,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159676,38.27,0.06,409,75015,65,NULL,'MLCS','APMUKS(BJ) B230147.96-373644.6',0.101,'1996ApJ...473..588R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159677,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159677,38.31,0.19,417,75015,65,NULL,'SALT2','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159678,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159678,38.33,0.23,421,75015,65,NULL,'Template','APMUKS(BJ) B230147.96-373644.6',0.101,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159679,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159679,38.41,0.21,436,75015,70,NULL,'SALT 2','APMUKS(BJ) B230147.96-373644.6',0.101,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159680,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159680,38.41,0.15,437,75015,65,NULL,'MLCS','APMUKS(BJ) B230147.96-373644.6',0.101,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159681,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159681,38.21,0.08,439,75015,65,NULL,'LCS','APMUKS(BJ) B230147.96-373644.6',NULL,'1995ApJ...445L..91R',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159682,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159682,38.42,0.04,439,75015,72,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',0.101,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159683,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159683,38.44,0.06,442,75015,70,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',0.101,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159684,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159684,38.65,0.12,443,75015,65,NULL,'MLCS2k2','APMUKS(BJ) B230147.96-373644.6',0.101,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159685,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159685,38.46,0.22,447,75015,73.8,NULL,'SALT 2 (SNANA)','APMUKS(BJ) B230147.96-373644.6',0.1009,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159686,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159686,38.25,0.17,447,75015,70.8,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159687,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159687,38.27,0.06,451,75015,65,NULL,'Snapshot','APMUKS(BJ) B230147.96-373644.6',NULL,'1996ApJ...473...88R',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159688,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159688,38.51,0.15,457,75015,70,NULL,'SALT','APMUKS(BJ) B230147.96-373644.6',0.101,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159689,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159689,38.61,0.1,479,75015,65,NULL,'MLCS2k2','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159690,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159690,38.62,0.19,481,75015,65,NULL,'SALT2','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159691,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159691,38.66,0.17,489,75015,65,NULL,'MLCS17','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159692,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159692,38.66,0.05,491,75015,65,NULL,'SALT','APMUKS(BJ) B230147.96-373644.6',0.101,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159693,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159693,38.47,0.14,494,75015,60,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159694,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159694,38.7,0.13,498,75015,65,NULL,'SALT','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159695,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159695,38.73,0.2,506,75015,65,NULL,NULL,'APMUKS(BJ) B230147.96-373644.6',0.101,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159696,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159696,38.73,0.15,506,75015,65,NULL,'MLCS31','APMUKS(BJ) B230147.96-373644.6',0.101,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159697,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159697,38.8,0.1,522,75015,65,NULL,'MLCS2k2','APMUKS(BJ) B230147.96-373644.6',0.101,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159698,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159698,38.76,0.07,565,75015,60,NULL,'M(V) = -19.47 mag','APMUKS(BJ) B230147.96-373644.6',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159699,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159699,38.81,0.09,578,75015,60,NULL,'M(B) = -19.48 mag','APMUKS(BJ) B230147.96-373644.6',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159700,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 1992aq',NULL,159700,38.86,0.09,592,75015,60,NULL,'M(I) = -19.19 mag','APMUKS(BJ) B230147.96-373644.6',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159701,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159701,37.07,0.46,259,75016,70,NULL,NULL,'2MASX J23043540-0909064',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.00015,NULL,'16.2g',0.4,NULL,NULL,NULL,NULL,NULL,1,346.147625,-9.15167,0.077,NULL,49478226949,773097296,12079645,16.2),(159702,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159702,35,0.46,100,75017,70,NULL,NULL,'ESO 077- G 002',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'14.63',0.6,'S0',NULL,NULL,NULL,NULL,1,346.164417,-72.11692,0.061,NULL,48393399499,756146867,11814794,14.63),(159703,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159703,35.4,0.52,120,75018,70,NULL,NULL,'2MASX J23044135-2105408',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'15.24',0.53,'E',NULL,NULL,NULL,NULL,1,346.17225,-21.09475,0.047,NULL,50433825270,788028519,12312945,15.24),(159704,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159704,36.32,0.46,184,75019,70,NULL,NULL,'2MASX J23044397-0842114',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00015,NULL,'16.2g',0.28,'S0/a',NULL,NULL,NULL,NULL,1,346.18325,-8.70322,0.073,NULL,49478250735,773097667,12079651,16.2),(159705,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159705,34.73,0.2,88.3,75020,74.4,NULL,NULL,'KUG 2302+075',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',NULL,NULL,'15.68',0.2,'S?',NULL,NULL,NULL,NULL,1,346.186167,7.803,0.129,NULL,51722397594,808162462,12627538,15.68),(159706,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159706,34.49,0.49,79.2,75021,75,NULL,'IR','KUG 2302+075',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'15.68',0.2,'S?',NULL,NULL,NULL,NULL,1,346.186167,7.803,0.129,NULL,51722397594,808162462,12627538,15.68),(159707,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159707,36.58,0.76,207,75022,70,NULL,NULL,'2MASX J23044473-4312451',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.00015,NULL,'16.59',0.32,NULL,NULL,NULL,NULL,NULL,1,346.186417,-43.2125,NULL,NULL,50518648020,789353875,12333654,16.59),(159708,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159708,35.18,0.49,109,75023,75,NULL,'IR','2MFGC 17334',NULL,'2011yCatp016004901K',2011,1,0.55,NULL,'G',NULL,NULL,'13.17',0.17,NULL,NULL,NULL,NULL,NULL,1,346.193167,7.89353,0.129,NULL,51722393800,808162403,12627537,13.17),(159709,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 11141',NULL,159709,40.81,0.4,1450,75024,70,NULL,'SN photometric redshift distance, z photo =0.423 +/- 0.117','SDSS-II SN 11141',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.9g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.204167,-0.90939,0.113,NULL,49508406962,773568858,12087013,20.9),(159710,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 11141','R',159710,42.42,0.33,2280,75024,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 11141',0.333177,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159711,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159711,38.02,0.33,401,75025,70,NULL,NULL,'2MASX J23045152+1451143',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,346.21475,14.854,0.185,NULL,52551803992,821121937,12830030,17.6),(159712,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21126','RN',159712,44.26,0.32,4460,75026,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 21126',0.598288,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159713,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159713,37.42,0.58,304,75027,70,NULL,NULL,'2MASX J23045223-2827471',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'17.54',0.24,NULL,NULL,NULL,NULL,NULL,1,346.217583,-28.46319,0.076,NULL,50135071698,783360495,12240007,17.54),(159714,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159714,35.03,0.45,102,75028,NULL,NULL,'K','CGCG 453-062',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.00003,NULL,'15.1',0.5,'Sa;LIRG        LINER',NULL,NULL,NULL,NULL,1,346.2355417,19.55222,0.133,NULL,52572978348,821452786,12835199,15.1),(159715,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159715,35.05,0.4,102,75028,NULL,NULL,'mean','CGCG 453-062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159716,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159716,35.05,0.47,103,75028,NULL,NULL,'H','CGCG 453-062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159717,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159717,35.22,0.46,111,75028,NULL,NULL,'J','CGCG 453-062',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159718,'HII region diameter','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159718,32.46,0.14,31.1,75029,NULL,NULL,NULL,'NGC 7479',NULL,'2005JKAS...38....7I',2005,1,4.1,NULL,'G',0.000005,NULL,'11.60',3.1,'SB(s)c;LINER   Sy2','Isolated galaxy',NULL,NULL,'Sy 1.9',1,346.2360417,12.32289,0.161,NULL,52549144297,821080379,12829380,11.6),(159719,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159719,32.01,NULL,25.2,75029,75,NULL,'CO','NGC 7479',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159720,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159720,32.4,0.4,30.2,75029,NULL,NULL,NULL,'NGC 7479',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159721,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159721,32.55,0.4,32.4,75029,75,NULL,'B','NGC 7479',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159722,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159722,32.64,NULL,33.7,75029,75,NULL,'HI','NGC 7479',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159723,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159723,32.79,0.43,36.1,75029,NULL,NULL,NULL,'NGC 7479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159724,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159724,32.82,0.42,36.7,75029,NULL,NULL,'Malmquist cor.','NGC 7479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159725,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159725,32.83,0.2,36.8,75029,74.4,NULL,NULL,'NGC 7479',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159726,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 16352','R',159726,40.44,0.22,980,75030,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pk','SN 2006pk',0.25227,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,346.249375,-0.87336,0.113,NULL,49508426635,773569166,12087018,NULL),(159727,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 16352','R',159727,40.65,0.13,1080,75030,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pk','SN 2006pk',0.25227,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159728,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159728,31.83,0.8,23.2,75031,75,NULL,NULL,'UGC 12344',NULL,'1988NBGC.C....0000T',1988,1,2.1,NULL,'G',0.000013,NULL,'16.0',0.4,'SBd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,346.249875,18.70333,0.193,NULL,52575560380,821493130,12835830,16),(159729,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159729,31.93,0.2,24.3,75031,74.4,NULL,NULL,'UGC 12344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159730,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159730,32.16,0.4,27,75031,NULL,NULL,NULL,'UGC 12344',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159731,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159731,38.02,0.33,401,75032,70,NULL,NULL,'2MASX J23050205+1450034',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000203,NULL,'16.5g',0.31,NULL,NULL,NULL,NULL,NULL,1,346.258541667,14.83433,0.185,NULL,52551806319,821121973,12830030,16.5),(159732,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 2000dn',NULL,159732,35.85,0.16,143,75033,70,NULL,'SALT 2','IC 1468',0.032065,'2013MNRAS.433.2240G',2013,1,1.3,NULL,'G',0.000217,NULL,'15.25',0.8,'(R\')SAB0+ pec:',NULL,NULL,NULL,NULL,1,346.281541667,-3.2045,0.149,NULL,49503510310,773492348,12085817,15.25),(159733,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 2000dn','R',159733,35.91,0.06,152,75033,NULL,NULL,'MLCS2k2, R(V) = 1.8','IC 1468',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159734,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 2000dn','R',159734,35.96,0.06,156,75033,NULL,NULL,'MLCS2k2, R(V) = 3.1','IC 1468',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159735,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159735,36.77,0.46,226,75034,70,NULL,NULL,'2MASX J23050762+0049346',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000103,NULL,'16.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,346.281833,0.82625,0.165,NULL,51705231230,807894237,12623347,16.9),(159736,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159736,35.15,NULL,107,75035,NULL,NULL,NULL,'FGC 2456',NULL,'2000BSAO...50....5K',2000,1,0.66,NULL,'G',0.000014,NULL,'17.7',0.06,'Sd',NULL,NULL,NULL,NULL,1,346.297917,25.22111,0.245,NULL,51895661620,810869712,12669839,17.7),(159737,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159737,35.65,NULL,135,75035,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159738,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159738,35.67,NULL,136,75035,NULL,NULL,'Dipole + Quadrupole','FGC 2456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159739,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159739,35.68,NULL,137,75035,NULL,NULL,'Dipole','FGC 2456',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159740,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 17925',NULL,159740,40.28,0.21,1140,75036,70,NULL,'SN photometric redshift distance, z photo =0.313 +/- 0.040','SDSS-II SN 17925',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.305875,0.30397,0.145,NULL,51692914169,807701783,12620340,NULL),(159741,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159741,36.01,0.46,159,75037,70,NULL,NULL,'2MASX J23051828+1334374',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000184,NULL,'16.3g',0.34,'E0',NULL,NULL,NULL,NULL,1,346.326166667,13.57697,0.177,NULL,52562085609,821282587,12832540,16.3),(159742,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159742,34.61,0.2,83.6,75038,74.4,NULL,NULL,'UGC 12348',NULL,'2013AJ....146...86T',2013,1,1,'Bright star superposed 25\\\" NW.','G',0.00013,NULL,'15.33',0.3,'Sa             Sy2',NULL,NULL,NULL,'Sy 2',1,346.3285,0.18953,0.145,NULL,51692949033,807702328,12620348,15.33),(159743,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159743,34.26,0.69,71.2,75039,100,NULL,'mid-IR','CGCG 430-059',NULL,'2013ApJ...771...88L',2013,1,0.88,NULL,'G',0.00009,NULL,'15.5g',0.43,'Sab',NULL,NULL,NULL,NULL,1,346.3315417,14.17039,0.169,NULL,52562394313,821287411,12832615,15.5),(159744,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159744,34.7,0.58,87.1,75039,NULL,NULL,'Malmquist cor.','CGCG 430-059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159745,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159745,34.77,0.56,90.1,75039,NULL,NULL,NULL,'CGCG 430-059',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159746,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159746,34.85,0.2,93.3,75039,74.4,NULL,NULL,'CGCG 430-059',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159747,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159747,31.7,0.2,21.9,75040,74.4,NULL,NULL,'UGC 12350',NULL,'2013AJ....146...86T',2013,1,2.6,NULL,'G',0.000003,NULL,'14.50',0.8,'Sm','X-ray-faint group member',NULL,NULL,NULL,1,346.333917,16.8665,0.245,NULL,52605658298,821963410,12843178,14.5),(159748,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159748,31.8,0.66,22.9,75040,NULL,NULL,'Malmquist cor.','UGC 12350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159749,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159749,31.94,0.61,24.5,75040,NULL,NULL,NULL,'UGC 12350',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159750,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159750,31.95,0.43,24.5,75040,75,NULL,'3.6 micron, color corrected','UGC 12350',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159751,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159751,32.19,0.43,27.4,75040,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12350',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159752,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159752,32.24,0.4,28,75040,75,NULL,NULL,'UGC 12350',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159753,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159753,32.35,0.4,29.5,75040,75,NULL,'B','UGC 12350',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159754,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159754,33.13,0.49,42.3,75040,75,NULL,'IR','UGC 12350',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159755,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 07922','R',159755,40.9,0.15,1280,75041,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07922',0.18257,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,33.222083,-0.91753,0.033,NULL,35132412917,548943951,8577249,NULL),(159756,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18212','RN',159756,39.14,0.25,567,75042,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18212',0.184229,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159757,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18212','RN',159757,39.46,0.27,657,75042,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18212',0.184229,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159758,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159758,35.01,0.36,101,75043,NULL,NULL,'Malmquist cor.','2MASX J23052461+3148367',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,346.3525417,31.81025,0.345,NULL,52050064834,813282263,12707535,14.5),(159759,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159759,35.12,0.35,106,75043,NULL,NULL,NULL,'2MASX J23052461+3148367',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159760,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159760,35.38,0.2,119,75043,74.4,NULL,NULL,'2MASX J23052461+3148367',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159761,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159761,35.14,0.54,107,75044,70,NULL,NULL,'MCG -01-58-020',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00012,NULL,'15.5',0.6,NULL,NULL,NULL,NULL,NULL,1,346.362625,-2.95719,0.149,NULL,49503462479,773491601,12085806,15.5),(159762,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969',NULL,159762,39.58,0.53,824,75045,70,NULL,'SN photometric redshift distance, z photo =0.215 +/- 0.070','SDSS-II SN 04969',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.2g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.367666667,-0.47161,0.129,NULL,49507624878,773556638,12086822,20.2),(159763,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969','R',159763,40.85,0.28,1130,75045,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04969',0.306777,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159764,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969','R',159764,40.86,0.31,1130,75045,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04969',0.306777,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159765,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969',NULL,159765,40.65,0.21,1350,75045,70,NULL,'SALT 2','SDSS-II SN 04969',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159766,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04969',NULL,159766,40.68,0.21,1370,75045,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04969',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159767,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159767,37.88,0.46,377,75046,70,NULL,NULL,'2MASX J23053094+0049204',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000098,NULL,'17.1g',0.08,'NLAGN',NULL,NULL,NULL,NULL,1,346.379,0.82233,0.181,NULL,51705194284,807893660,12623338,17.1),(159768,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159768,37.85,0.46,372,75047,70,NULL,NULL,'SDSS J230534.41+011113.2',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',NULL,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,346.393416667,1.187,0.197,NULL,51705048131,807891377,12623302,18.1),(159769,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 05191','RN',159769,41.47,0.26,1600,75048,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05191',0.229431,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159770,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 05191','RN',159770,42,0.31,2040,75048,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05191',0.229431,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159771,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 03844','RN',159771,42.46,0.31,1930,75049,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03844',0.609358,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159772,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159772,34.96,0.8,98.1,75050,75,NULL,'W91PP, r','UGC 12352',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000063,NULL,'14.44',0.9,'S?',NULL,NULL,NULL,NULL,1,346.4185,27.66558,0.277,NULL,52019459858,812804060,12700063,14.44),(159773,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159773,34.99,0.38,99.6,75050,75,NULL,'W91PP, r, raw','UGC 12352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159774,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159774,35.07,0.4,103,75050,NULL,NULL,'mean','UGC 12352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159775,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159775,35.13,0.47,106,75050,NULL,NULL,'H','UGC 12352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159776,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159776,35.15,0.38,107,75050,75,NULL,'W91PP, r, cor','UGC 12352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159777,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159777,35.16,0.45,107,75050,NULL,NULL,'K','UGC 12352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159778,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159778,35.19,0.46,109,75050,NULL,NULL,'J','UGC 12352',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159779,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159779,35.29,0.38,114,75050,75,NULL,'W91PP, r, inv','UGC 12352',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159780,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159780,37.5,0.46,316,75051,70,NULL,NULL,'SDSS J230541.57+141739.1',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000098,NULL,'19.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,346.42325,14.29422,0.185,NULL,52561412458,821272069,12832376,19.1),(159781,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159781,34.33,0.43,73.5,75052,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2457',NULL,'2014MNRAS.444..527S',2014,1,0.92,NULL,'G',NULL,NULL,'16.5',0.11,'Sc',NULL,NULL,NULL,NULL,1,346.4455417,38.64722,0.633,NULL,55346467287,864788551,13512321,16.5),(159782,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159782,34.4,0.49,75.9,75052,75,NULL,'IR','FGC 2457',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159783,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159783,34.44,NULL,77.4,75052,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159784,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159784,34.46,NULL,77.9,75052,NULL,NULL,'Dipole + Quadrupole','FGC 2457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159785,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159785,34.47,NULL,78.5,75052,NULL,NULL,'Dipole','FGC 2457',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159786,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159786,34.51,NULL,79.7,75052,NULL,NULL,NULL,'FGC 2457',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159787,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159787,34.46,0.49,78.1,75053,75,NULL,'IR','UGC 12358',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000067,NULL,'16.0',0.2,'Sb-c',NULL,NULL,NULL,NULL,1,346.448125,34.156,0.429,NULL,52047062843,813235356,12706802,16),(159788,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159788,34.86,0.37,93.9,75053,NULL,NULL,'Malmquist cor.','UGC 12358',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159789,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159789,34.89,0.36,95.1,75053,NULL,NULL,NULL,'UGC 12358',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159790,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159790,34.93,0.2,96.8,75053,74.4,NULL,NULL,'UGC 12358',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159791,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159791,37.02,0.46,253,75054,70,NULL,NULL,'2MASX J23054824-0018538',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000096,NULL,'16.9g',0.2,NULL,NULL,NULL,NULL,NULL,1,346.450958333,-0.31489,0.137,NULL,49494085889,773345092,12083517,16.9),(159792,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159792,32.63,0.69,33.5,75055,NULL,NULL,NULL,'NGC 7483',NULL,'2009ApJS..182..474S',2009,1,1.6,NULL,'G',0.00002,NULL,'13.94',1.1,'(R\')SAB(rs)a',NULL,NULL,NULL,NULL,1,346.4512083,3.54511,0.213,NULL,51726322951,808223796,12628496,13.94),(159793,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159793,32.71,0.2,34.8,75055,74.4,NULL,NULL,'NGC 7483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159794,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159794,32.73,0.66,35.2,75055,NULL,NULL,'Malmquist cor.','NGC 7483',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159795,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159795,33.01,0.47,40,75055,NULL,NULL,'H','NGC 7483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159796,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159796,33.15,0.45,42.6,75055,NULL,NULL,'K','NGC 7483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159797,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159797,33.19,0.46,43.4,75055,NULL,NULL,'J','NGC 7483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159798,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159798,33.99,0.4,62.8,75055,NULL,NULL,'mean','NGC 7483',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159799,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21732','RN',159799,39.66,0.22,807,75056,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 21732',0.062252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159800,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 21732','RN',159800,40.5,0.32,1180,75056,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 21732',0.062252,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159801,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159801,34.46,0.49,78,75057,75,NULL,'IR','UGC 12357',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.69',0.2,'SB?','Pair member (points to parent)',NULL,NULL,NULL,1,346.46425,31.06356,0.221,NULL,52050656634,813291509,12707679,15.69),(159802,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159802,34.99,0.4,99.4,75057,NULL,NULL,'mean','UGC 12357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159803,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159803,35.13,0.47,106,75057,NULL,NULL,'H','UGC 12357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159804,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159804,35.15,0.54,107,75058,70,NULL,NULL,'2MASX J23055445-3044158',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.88',0.23,NULL,NULL,NULL,NULL,NULL,1,346.476833333,-30.73772,NULL,NULL,50156330099,783692657,12245197,16.88),(159805,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159805,33.43,0.8,48.6,75059,75,NULL,'CF, r','UGC 12354',NULL,'1997ApJS..109..333W',1997,1,1.08,NULL,'G',0.000095,NULL,'15.2g',0.43,'Scd:',NULL,NULL,NULL,NULL,1,346.4852083,14.35767,0.185,NULL,52561426428,821272287,12832379,15.2),(159806,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159806,33.52,0.13,50.7,75059,NULL,NULL,NULL,'UGC 12354',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159807,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159807,33.56,0.2,51.5,75059,74.4,NULL,NULL,'UGC 12354',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159808,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159808,33.9,0.38,60.2,75059,75,NULL,'CF, r, raw','UGC 12354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159809,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159809,33.92,0.38,60.9,75059,75,NULL,'CF, r, inv','UGC 12354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159810,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159810,34.03,0.38,64,75059,75,NULL,'CF, r, cor','UGC 12354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159811,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159811,35.81,0.52,145,75060,70,NULL,NULL,'2MASX J23055723-5906576',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.85',0.52,'S0',NULL,NULL,NULL,NULL,1,346.488417,-59.11608,0,NULL,48850857939,763294655,11926478,15.85),(159812,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159812,36.56,0.46,205,75061,70,NULL,NULL,'2MASX J23055768+1512597',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000179,NULL,'16.5g',0.28,'E0',NULL,NULL,NULL,NULL,1,346.490291667,15.21664,0.169,NULL,52553835137,821153674,12830526,16.5),(159813,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159813,35.04,0.8,102,75062,75,NULL,'W91PP, r','UGC 12355',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.00005,NULL,'16.5',0.3,'Scd:',NULL,NULL,NULL,NULL,1,346.499167,24.56489,0.253,NULL,51892851140,810825799,12669153,16.5),(159814,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159814,34.71,0.2,87.5,75062,74.4,NULL,NULL,'UGC 12355',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159815,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159815,34.79,0.43,90.8,75062,75,NULL,'3.6 micron, color corrected','UGC 12355',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159816,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159816,34.8,0.36,91.4,75062,NULL,NULL,NULL,'UGC 12355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159817,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159817,34.89,0.43,94.9,75062,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12355',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159818,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159818,35,0.33,99.9,75062,NULL,NULL,'Malmquist cor.','UGC 12355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159819,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159819,35.22,0.38,111,75062,75,NULL,'W91PP, r, raw','UGC 12355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159820,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159820,35.28,0.38,114,75062,75,NULL,'W91PP, r, inv','UGC 12355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159821,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159821,35.37,0.38,119,75062,75,NULL,'W91PP, r, cor','UGC 12355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159822,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159822,36.84,0.46,233,75063,70,NULL,NULL,'2MASX J23060063+1321501',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000143,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,346.5025,13.36383,0.141,NULL,52561485084,821273204,12832393,18),(159823,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159823,38.47,0.33,493,75064,70,NULL,NULL,'SDSS J230601.47+140942.8',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000137,NULL,'19.3g',0.09,NULL,NULL,NULL,NULL,NULL,1,346.506167,14.16192,0.185,NULL,52561312708,821270511,12832351,19.3),(159824,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159824,36.89,0.46,238,75065,70,NULL,NULL,'2MASX J23060401-0000555',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000085,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,346.516833,-0.01544,0.145,NULL,49493974523,773343351,12083489,17.5),(159825,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159825,38.47,0.33,493,75066,70,NULL,NULL,'SDSS J230604.75+141306.3',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'19.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,346.5197917,14.21842,0.185,NULL,52561291775,821270183,12832346,19.1),(159826,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','PTF11okh','N',159826,34.9,0.06,93.7,75067,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11okh',0.0191,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159827,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159827,36.1,0.46,166,75068,70,NULL,NULL,'2MASX J23060511+0057320',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000088,NULL,'16.3g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,346.5212917,0.95889,0.197,NULL,51705182663,807893479,12623335,16.3),(159828,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 01342',NULL,159828,40.2,0.26,1100,75069,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.046','SDSS-II SN 01342',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.527417,0.11689,0.145,NULL,51692830347,807700474,12620319,NULL),(159829,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159829,33.67,0.62,54.2,75070,NULL,NULL,'Malmquist cor.','ESO 604- G 002',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000035,NULL,'15.70',0.6,'SB(rs)ab:',NULL,NULL,NULL,NULL,1,346.5345,-19.58747,0.06,NULL,50439407781,788115746,12314308,15.7),(159830,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159830,33.67,0.2,54.2,75070,74.4,NULL,NULL,'ESO 604- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159831,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159831,33.83,0.58,58.2,75070,NULL,NULL,NULL,'ESO 604- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159832,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159832,37.96,0.33,390,75071,70,NULL,NULL,'SDSS J230610.81-093639.7',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.6g',0.34,NULL,NULL,NULL,NULL,NULL,1,346.5450417,-9.61106,0.057,NULL,49478519840,773101872,12079716,16.6),(159833,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20744',NULL,159833,39.67,0.27,861,75072,70,NULL,'SN photometric redshift distance, z photo =0.226 +/- 0.035','SDSS-II SN 20744',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.5492083,0.35883,0.149,NULL,51692865552,807701024,12620328,NULL),(159834,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20744','R',159834,40.5,0.26,989,75072,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20744',0.275009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159835,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20744','R',159835,40.62,0.22,1040,75072,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20744',0.275009,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159836,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SN 2007pr',NULL,159836,40.43,0.23,1220,75073,70,NULL,'Hubble residual 0.04 for z0.33300','SDSS J230612.98+001944.1',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.005,NULL,'22.9g',0.02,NULL,NULL,NULL,NULL,NULL,1,346.554125,0.32892,0.149,NULL,51692897638,807701525,12620336,22.9),(159837,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20106','R',159837,41.22,0.29,1320,75073,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pr','SDSS J230612.98+001944.1',0.333,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159838,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 20106','R',159838,41.54,0.26,1530,75073,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pr','SDSS J230612.98+001944.1',0.333,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159839,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159839,36.78,0.63,227,75074,70,NULL,NULL,'2MASX J23061302-0641093',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.4R',NULL,NULL,NULL,NULL,NULL,NULL,1,346.55425,-6.68594,0.121,NULL,49489220355,773269068,12082329,14.4),(159840,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159840,34.62,0.8,84.1,75075,75,NULL,'W91PP, r','UGC 12362',NULL,'1997ApJS..109..333W',1997,1,1.6,'UGC misprints dec as +31d57\'. UGC galactic coordinates are correct.','G',0.000033,NULL,'14.97',0.5,'SB(s)b',NULL,NULL,NULL,NULL,1,346.561541667,31.8855,0.321,NULL,52049926655,813280103,12707501,14.97),(159841,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159841,34.51,0.35,79.9,75075,NULL,NULL,NULL,'UGC 12362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159842,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159842,34.57,0.49,81.9,75075,75,NULL,'IR','UGC 12362',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159843,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159843,34.67,0.38,85.8,75075,75,NULL,'W91PP, r, raw','UGC 12362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159844,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159844,34.68,0.2,86.3,75075,74.4,NULL,NULL,'UGC 12362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159845,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159845,34.72,0.32,88,75075,NULL,NULL,'Malmquist cor.','UGC 12362',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159846,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159846,34.83,0.38,92.4,75075,75,NULL,'W91PP, r, inv','UGC 12362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159847,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159847,34.83,0.38,92.5,75075,75,NULL,'W91PP, r, cor','UGC 12362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159848,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 17845','RN',159848,42.67,0.21,2530,75076,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17845',0.347039,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159849,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 17845','RN',159849,42.7,0.24,2580,75076,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17845',0.347039,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159850,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159850,37.71,0.46,349,75077,70,NULL,NULL,'2MASX J23061764+0100240',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000092,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,346.573375,1.00669,0.197,NULL,51705171013,807893297,12623332,17),(159851,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159851,37.96,0.33,390,75078,70,NULL,NULL,'SDSS J230619.97-094447.0',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00014,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,346.583208333,-9.74642,0.057,NULL,50366795503,786981179,12296580,18.7),(159852,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159852,32.84,0.8,36.9,75079,75,NULL,'W91CL, r','UGC 12361',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00002,NULL,'16.07',0.3,'Im',NULL,NULL,NULL,NULL,1,346.593333,11.28556,0.105,NULL,52432521766,819258152,12800908,16.07),(159853,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159853,33.4,0.38,47.9,75079,75,NULL,'W91CL, r, inv','UGC 12361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159854,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159854,33.49,0.38,49.9,75079,75,NULL,'W91CL, r, raw','UGC 12361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159855,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159855,33.75,0.38,56.3,75079,75,NULL,'W91CL, r, cor','UGC 12361',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159856,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159856,36.22,NULL,175,75080,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2459',NULL,'2010Ap&SS.325..163P',2010,1,0.65,NULL,'G',NULL,NULL,'17.1',0.07,'Sdm',NULL,NULL,NULL,NULL,1,346.602917,41.31833,0.549,NULL,55344243780,864753809,13511778,17.1),(159857,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159857,36.23,NULL,176,75080,NULL,NULL,NULL,'FGC 2459',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159858,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159858,36.25,NULL,177,75080,NULL,NULL,'Dipole + Quadrupole','FGC 2459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159859,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159859,36.28,NULL,180,75080,NULL,NULL,'Dipole','FGC 2459',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159860,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159860,33.6,0.49,52.5,75081,NULL,NULL,NULL,'UGC 12363',NULL,'2009ApJS..182..474S',2009,1,0.94,NULL,'G',0.000037,NULL,'14.6g',0.54,'Sm',NULL,NULL,NULL,NULL,1,346.632166667,0.17242,0.149,NULL,51692769335,807699520,12620305,14.6),(159861,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159861,33.79,0.45,57.3,75081,NULL,NULL,'Malmquist cor.','UGC 12363',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159862,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13777',NULL,159862,40.27,0.29,1130,75082,70,NULL,'SN photometric redshift distance, z photo =0.311 +/- 0.054','SDSS-II SN 13777',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.3g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.644667,-0.68439,0.161,NULL,49494757326,773355583,12083680,22.3),(159863,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13777','R',159863,42.24,0.53,1880,75082,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 13777',0.489267,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159864,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13777',NULL,159864,42.23,0.36,2790,75082,70,NULL,'SALT 2','SDSS-II SN 13777',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159865,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13777',NULL,159865,42.36,0.36,2960,75082,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13777',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159866,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159866,37.06,0.46,258,75083,70,NULL,NULL,'2MASX J23063481+1351317',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000163,NULL,'17.7g',0.23,NULL,NULL,NULL,NULL,NULL,1,346.645083,13.85883,0.165,NULL,52561613603,821275212,12832425,17.7),(159867,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159867,34.39,0.49,75.6,75084,75,NULL,'IR','FGC 2458',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',0.000007,NULL,'16.6',0.1,'Sd',NULL,NULL,NULL,NULL,1,346.652833,6.11364,0.177,NULL,51718878236,808107472,12626679,16.6),(159868,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159868,34.58,NULL,82.4,75084,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159869,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159869,34.59,NULL,82.6,75084,NULL,NULL,'Dipole + Quadrupole','FGC 2458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159870,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159870,34.59,NULL,82.6,75084,NULL,NULL,NULL,'FGC 2458',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159871,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159871,34.59,NULL,82.7,75084,NULL,NULL,'Dipole','FGC 2458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159872,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159872,34.62,0.2,84,75084,74.4,NULL,NULL,'FGC 2458',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159873,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159873,34.68,0.54,86.1,75084,NULL,NULL,'Malmquist cor.','FGC 2458',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159874,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159874,34.76,0.52,89.4,75084,NULL,NULL,NULL,'FGC 2458',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159875,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18011','RN',159875,40.65,0.26,1050,75085,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18011',0.283961,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159876,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18011','RN',159876,40.76,0.32,1110,75085,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18011',0.283961,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159877,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18011','N',159877,40.63,0.21,1340,75085,70,NULL,'SALT 2','SDSS-II SN 18011',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159878,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 18011','N',159878,40.65,0.21,1350,75085,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18011',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159879,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159879,37.11,0.46,264,75086,70,NULL,NULL,'2MASX J23063993-0114590',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',NULL,NULL,'18.51',0.19,NULL,NULL,NULL,NULL,NULL,1,346.666416667,-1.24983,0.173,NULL,49508160727,773565011,12086953,18.51),(159880,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159880,38.04,0.46,406,75087,70,NULL,NULL,'2MASX J23064030+1450587',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000177,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,346.667833,14.84978,0.213,NULL,52553097765,821142152,12830346,18.2),(159881,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159881,35.28,0.46,114,75088,70,NULL,NULL,'2MASX J23064174+1527037',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00017,NULL,'16.1g',0.42,'S0',NULL,NULL,NULL,NULL,1,346.6739583,15.45108,0.177,NULL,52554531557,821164555,12830696,16.1),(159882,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159882,36.79,0.87,228,75089,70,NULL,NULL,'2MASX J23064401-7844548',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.2b',0.28,NULL,NULL,NULL,NULL,NULL,1,346.6834583,-78.74858,0.393,NULL,48554396848,758662450,11854100,16.2),(159883,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159883,37.66,0.71,340,75090,70,NULL,NULL,'2MASX J23064669-0019209',NULL,'2014MNRAS.445.2677S',2014,1,1.02,NULL,'G',0.000072,NULL,'15.8g',0.32,NULL,NULL,NULL,NULL,NULL,1,346.694667,-0.32242,0.145,NULL,49494719261,773354988,12083671,15.8),(159884,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159884,37.46,0.46,310,75091,70,NULL,NULL,'2MASX J23064738-0046009',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000084,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,346.6975417,-0.76703,0.161,NULL,49494230324,773347348,12083552,17.6),(159885,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159885,35.75,0.53,141,75092,70,NULL,NULL,'AM 2301-843',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,346.7140417,-84.38183,0.349,NULL,48377416133,755897127,11810892,16.2),(159886,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159886,38.5,0.46,501,75093,70,NULL,NULL,'2MASX J23065203+0026217',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000093,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,346.717,0.43936,0.153,NULL,51693696246,807714003,12620531,17.8),(159887,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159887,35.35,0.46,118,75094,70,NULL,NULL,'2MASX J23065483+1411306',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000086,NULL,'16.5g',0.25,'AGN+SF',NULL,NULL,NULL,NULL,1,346.7285417,14.19175,0.193,NULL,52561741505,821277211,12832456,16.5),(159888,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04991','RN',159888,43.31,0.23,3170,75095,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04991',0.446713,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159889,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 04991','RN',159889,43.95,0.26,4260,75095,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04991',0.446713,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159890,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159890,36.56,0.46,205,75096,70,NULL,NULL,'2MASX J23065501-0039398',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000088,NULL,'16.7g',0.28,NULL,NULL,NULL,NULL,NULL,1,346.729125,-0.66097,0.153,NULL,49494759112,773355611,12083681,16.7),(159891,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159891,36.27,0.5,180,75097,70,NULL,NULL,'ESO 290-IG 051 NED02',NULL,'2014MNRAS.445.2677S',2014,1,1,'6dF DR1 has z = 0.033678.','G',0.000033,NULL,'14.75',0.5,'SAB(rs)0-: pec','Pair member (points to parent)',NULL,NULL,NULL,1,346.73325,-42.89858,NULL,NULL,50519279158,789363736,12333808,14.75),(159892,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159892,33.1,0.2,41.7,75098,74.4,NULL,NULL,'UGC 12366',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',NULL,NULL,'16.0',0.3,'S?',NULL,NULL,NULL,NULL,1,346.735083333,5.96167,0.177,NULL,51718299935,808098436,12626538,16),(159893,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159893,34.99,0.46,99.4,75099,70,NULL,NULL,'MCG -02-58-024',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.000107,NULL,'14.3g',0.76,'SB0',NULL,NULL,NULL,NULL,1,346.742375,-9.28614,0.057,NULL,49478947474,773108554,12079821,14.3),(159894,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159894,36.93,0.56,244,75100,70,NULL,NULL,'2MASX J23070019-0624188',NULL,'2014MNRAS.445.2677S',2014,1,0.53,NULL,'G',0.00015,NULL,'16.34',0.41,NULL,NULL,NULL,NULL,NULL,1,346.750875,-6.40528,0.141,NULL,49482074731,773157417,12080584,16.34),(159895,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159895,35.05,0.49,102,75101,NULL,NULL,NULL,'UGC 12367',NULL,'2009ApJS..182..474S',2009,1,1.23,'UGC has two entries for the same object.','G',0.00001,NULL,'16.5',0.19,'Scd:',NULL,NULL,NULL,NULL,1,346.755375,17.14558,0.257,NULL,52605871689,821966745,12843230,16.5),(159896,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159896,35.1,0.48,105,75101,NULL,NULL,'Malmquist cor.','UGC 12367',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159897,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159897,35.12,0.2,106,75101,74.4,NULL,NULL,'UGC 12367',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159898,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159898,33.79,0.2,57.3,75102,74.4,NULL,NULL,'UGC 12369',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000017,NULL,'17.',0.5,'Im:',NULL,NULL,NULL,NULL,1,346.75625,5.99603,0.177,NULL,51718331179,808098924,12626545,17),(159899,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159899,35.69,0.63,138,75103,70,NULL,NULL,'2MASX J23070186-0632228',NULL,'2014MNRAS.445.2677S',2014,1,0.66,NULL,'G',0.00015,NULL,'15.54',0.57,NULL,NULL,NULL,NULL,NULL,1,346.7577917,-6.53969,0.101,NULL,49481714925,773151795,12080496,15.54),(159900,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159900,33.06,0.52,40.9,75104,70,NULL,NULL,'NGC 7484',NULL,'2014MNRAS.445.2677S',2014,1,1.8,NULL,'G',0.00007,NULL,'12.78',1.7,'E','Isolated galaxy',NULL,NULL,NULL,1,346.7704583,-36.27536,NULL,NULL,49966254389,780722724,12198792,12.78),(159901,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159901,33.03,0.4,40.3,75104,NULL,NULL,'mean','NGC 7484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159902,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159902,33.32,0.45,46.2,75104,NULL,NULL,'K','NGC 7484',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159903,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159903,33.96,0.8,61.9,75105,75,NULL,'MAT, I','UGC 12370',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'15.21',0.4,'Sc','Isolated galaxy',NULL,NULL,NULL,1,346.776333333,9.96078,0.105,NULL,52431171879,819237060,12800579,15.21),(159904,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159904,33.96,0.8,62.1,75105,75,NULL,'W91CL, r','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159905,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159905,33.98,0.8,62.6,75105,75,NULL,'CF, r','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159906,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159906,33.83,0.38,58.3,75105,75,NULL,'W91CL, r, raw','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159907,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159907,33.83,0.32,58.3,75105,85,NULL,'I, raw','UGC 12370',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159908,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159908,33.84,0.32,58.6,75105,85,NULL,'I, inv','UGC 12370',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159909,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159909,33.85,0.38,58.8,75105,75,NULL,'W91CL, r, inv','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159910,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159910,33.87,0.38,59.3,75105,75,NULL,'CF, r, raw','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159911,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159911,33.88,0.38,59.8,75105,75,NULL,'CF, r, inv','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159912,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159912,33.99,0.2,62.8,75105,74.4,NULL,NULL,'UGC 12370',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159913,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159913,34.02,0.43,63.7,75105,75,NULL,'MAT, I, raw','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159914,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159914,34.03,0.38,63.9,75105,75,NULL,'CF, r, cor','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159915,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159915,34.04,0.38,64.4,75105,75,NULL,'W91CL, r, cor','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159916,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159916,34.07,0.38,65,75105,NULL,NULL,NULL,'UGC 12370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159917,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159917,34.11,0.43,66.5,75105,75,NULL,'MAT, I, inv','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159918,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159918,34.12,0.37,66.7,75105,NULL,NULL,'Malmquist cor.','UGC 12370',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159919,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159919,34.24,0.43,70.3,75105,75,NULL,'MAT, I, cor','UGC 12370',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159920,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159920,37.88,0.33,378,75106,70,NULL,NULL,'2MASX J23070883+1457102',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,346.786833,14.95289,0.213,NULL,52553282458,821145038,12830391,18.7),(159921,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159921,37.25,0.46,281,75107,70,NULL,NULL,'2MASX J23070999-1029518',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,346.7917083,-10.49761,0.053,NULL,50369036265,787016191,12297127,16.5),(159922,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159922,37.14,0.46,268,75108,70,NULL,NULL,'2MASX J23071033-1010378',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000139,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,346.7930417,-10.17719,0.045,NULL,50368934650,787014603,12297103,18.1),(159923,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159923,35.14,0.49,107,75109,75,NULL,'IR','CGCG 405-034',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00007,NULL,'15.22',0.3,'S?',NULL,NULL,NULL,NULL,1,346.802417,8.75197,0.085,NULL,51708743176,807949112,12624204,15.22),(159924,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159924,37.8,0.46,363,75110,70,NULL,NULL,'SDSS J230716.61+133755.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000151,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,346.81925,13.63222,0.165,NULL,52561678622,821276228,12832441,18.6),(159925,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159925,38.44,0.46,488,75111,70,NULL,NULL,'2MASX J23071704+1446303',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00016,NULL,'18.8g',0.12,NULL,NULL,NULL,NULL,NULL,1,346.821167,14.77506,0.213,NULL,52553292525,821145195,12830393,18.8),(159926,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159926,37.88,0.33,378,75112,70,NULL,NULL,'2MASX J23071856+1457033',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000134,NULL,'18.3g',0.16,NULL,NULL,NULL,NULL,NULL,1,346.8275417,14.95081,0.273,NULL,52553312118,821145501,12830398,18.3),(159927,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159927,37.59,0.46,329,75113,70,NULL,NULL,'2MASX J23071973-0948148',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000146,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,346.832,-9.80394,0.057,NULL,49478432459,773100507,12079695,17.5),(159928,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159928,37.14,0.46,267,75114,70,NULL,NULL,'2MASX J23072219+1341303',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000154,NULL,'18.2g',0.17,NULL,NULL,NULL,NULL,NULL,1,346.8425,13.69183,0.193,NULL,52561649755,821275777,12832434,18.2),(159929,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159929,33.88,0.39,59.6,75115,NULL,NULL,'Malmquist cor.','CGCG 475-037',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',NULL,NULL,'15.68',0.2,'S?',NULL,NULL,NULL,NULL,1,346.855875,22.80964,0.321,NULL,52563645518,821306961,12832921,15.68),(159930,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159930,33.98,0.38,62.4,75115,NULL,NULL,NULL,'CGCG 475-037',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159931,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159931,33.99,0.49,62.9,75115,75,NULL,'IR','CGCG 475-037',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159932,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159932,34.02,0.2,63.7,75115,74.4,NULL,NULL,'CGCG 475-037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159933,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159933,36.81,0.46,230,75116,70,NULL,NULL,'2MASX J23072683+1439502',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000159,NULL,'18.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,346.861667,14.66397,0.213,NULL,52553161285,821143145,12830361,18.9),(159934,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159934,35.44,0.2,122,75117,74.4,NULL,NULL,'UGC 12374',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000871,NULL,'15.26',0.5,'SBb:',NULL,NULL,NULL,NULL,1,346.8677917,15.36644,0.217,NULL,52553653854,821150841,12830481,15.26),(159935,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159935,37.92,0.46,384,75118,70,NULL,NULL,'2MASX J23073115+1349347',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000183,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,346.879833,13.82628,0.193,NULL,52561529878,821273904,12832404,18),(159936,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159936,34.51,0.8,79.9,75119,75,NULL,'CF, r','NGC 7489',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00003,NULL,'13.96',1.1,'Sd','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,346.886291667,22.998,0.321,NULL,52563609728,821306402,12832912,13.96),(159937,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159937,33.89,0.69,60,75119,100,NULL,'mid-IR','NGC 7489',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159938,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159938,34.1,0.38,66.1,75119,75,NULL,'CF, r, raw','NGC 7489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159939,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159939,34.24,0.2,70.5,75119,74.4,NULL,NULL,'NGC 7489',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159940,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159940,34.25,0.38,70.7,75119,75,NULL,'CF, r, inv','NGC 7489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159941,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159941,34.31,0.57,72.6,75119,NULL,NULL,'Malmquist cor.','NGC 7489',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159942,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159942,34.36,0.56,74.6,75119,NULL,NULL,NULL,'NGC 7489',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159943,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159943,34.44,0.38,77.3,75119,75,NULL,'CF, r, cor','NGC 7489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159944,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159944,34.65,0.47,85.2,75119,NULL,NULL,'H','NGC 7489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159945,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159945,34.66,0.4,85.4,75119,NULL,NULL,'mean','NGC 7489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159946,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159946,34.71,0.45,87.6,75119,NULL,NULL,'K','NGC 7489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159947,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159947,34.74,0.46,88.7,75119,NULL,NULL,'J','NGC 7489',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159948,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159948,32.45,0.8,30.9,75120,75,NULL,NULL,'NGC 2573B',NULL,'1988NBGC.C....0000T',1988,1,1.7,'ESO incorrectly interchanged the designations for NGC 2573A and NGC 2573B.','G',NULL,NULL,'15.26',0.6,'IBm? pec','Pair member (points to parent)',NULL,NULL,NULL,1,346.88675,-89.1165,0.521,NULL,48318845818,754981965,11796593,15.26),(159949,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159949,37.74,0.33,353,75121,70,NULL,NULL,'2MASX J23074179+1317197',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00015,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,346.923875,13.28875,0.169,NULL,52547797057,821059329,12829052,18.2),(159950,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159950,37.74,0.33,353,75122,70,NULL,NULL,'2MASX J23074261+1313137',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000204,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,346.9275417,13.22044,0.169,NULL,52547790743,821059230,12829050,17.4),(159951,'FP','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,'R',159951,38.14,0.46,424,75123,70,NULL,NULL,'2MASX J23074621+1415327',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000191,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,346.9425,14.25892,0.181,NULL,52561859104,821279048,12832485,18.5),(159952,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441','R',159952,40.8,0.26,1120,75124,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13441',0.28876,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.9529583,-0.23306,0.141,NULL,49494448869,773350763,12083605,NULL),(159953,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441','R',159953,40.81,0.16,1130,75124,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13441',0.28876,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159954,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441',NULL,159954,40.26,0.25,1130,75124,70,NULL,'SN photometric redshift distance, z photo =0.310 +/- 0.046','SDSS-II SN 13441',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159955,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441',NULL,159955,40.68,0.15,1370,75124,70,NULL,'SALT 2','SDSS-II SN 13441',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159956,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:20','1','SDSS-II SN 13441',NULL,159956,40.71,0.15,1390,75124,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13441',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159957,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159957,35.67,0.8,136,75125,75,NULL,'W91PP, r','UGC 12383',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'15.20',0.9,'SABb',NULL,NULL,NULL,NULL,1,346.953625,22.71028,0.321,NULL,52496318468,820254976,12816484,15.2),(159958,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159958,35.67,0.8,136,75125,75,NULL,'MAT, I','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159959,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159959,35.24,0.39,112,75125,NULL,NULL,'Malmquist cor.','UGC 12383',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159960,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159960,35.33,0.37,117,75125,NULL,NULL,NULL,'UGC 12383',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159961,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159961,35.46,0.38,124,75125,75,NULL,'W91PP, r, raw','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159962,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159962,35.59,0.32,131,75125,85,NULL,'I, raw','UGC 12383',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159963,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159963,35.59,0.2,131,75125,74.4,NULL,NULL,'UGC 12383',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159964,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159964,35.6,0.43,132,75125,75,NULL,'MAT, I, raw','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159965,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159965,35.67,0.32,136,75125,85,NULL,'I, inv','UGC 12383',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159966,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159966,35.68,0.38,137,75125,75,NULL,'W91PP, r, cor','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159967,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159967,35.74,0.38,141,75125,75,NULL,'W91PP, r, inv','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159968,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159968,35.9,0.43,152,75125,75,NULL,'MAT, I, cor','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159969,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:20','1',NULL,NULL,159969,35.94,0.43,154,75125,75,NULL,'MAT, I, inv','UGC 12383',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159970,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',159970,34.93,0.46,97,75126,70,NULL,NULL,'NGC 7488',NULL,'2015arXiv151105856S',2015,1,0.91,NULL,'G',0.000099,NULL,'14.6g',0.7,'S0- pec:',NULL,NULL,NULL,NULL,1,346.9539583,0.94053,0.141,NULL,51693334016,807708344,12620442,14.6),(159971,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159971,36.68,0.57,217,75127,70,NULL,NULL,'2MASX J23075283-4301176',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.31',0.21,NULL,NULL,NULL,NULL,NULL,1,346.9702083,-43.02156,NULL,NULL,50519174923,789362108,12333782,17.31),(159972,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 17063','RN',159972,40.41,0.48,1040,75128,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17063',0.16701,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159973,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',159973,37.28,0.46,286,75129,70,NULL,NULL,'2MASX J23075372-0850544',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00017,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,346.9739583,-8.84833,0.093,NULL,49479182051,773112219,12079878,16.6),(159974,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159974,33.15,0.8,42.7,75130,75,NULL,'W91CL, r','UGC 12382',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'16.40',0.18,'Scd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,346.979083333,5.16111,0.161,NULL,51728010370,808250162,12628908,16.4),(159975,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159975,33.17,0.8,43.1,75130,75,NULL,'MAT, I','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159976,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159976,33.18,0.8,43.2,75130,75,NULL,'HMCL, I','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159977,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159977,33.26,0.13,45,75130,NULL,NULL,NULL,'UGC 12382',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159978,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159978,33.88,0.32,59.7,75130,85,NULL,'I, raw','UGC 12382',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159979,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159979,33.88,0.32,59.8,75130,85,NULL,'I, inv','UGC 12382',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159980,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159980,33.97,NULL,62.1,75130,NULL,NULL,'Dipole','UGC 12382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159981,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159981,33.97,NULL,62.3,75130,NULL,NULL,'Dipole + Quadrupole','UGC 12382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159982,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159982,33.97,NULL,62.3,75130,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12382',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159983,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159983,34.12,0.43,66.5,75130,75,NULL,'MAT, I, raw','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159984,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159984,34.18,0.43,68.5,75130,75,NULL,'MAT, I, inv','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159985,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159985,34.23,NULL,70.1,75130,NULL,NULL,NULL,'UGC 12382',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159986,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159986,34.37,0.43,74.8,75130,75,NULL,'MAT, I, cor','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159987,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159987,34.46,0.38,77.9,75130,75,NULL,'W91CL, r, raw','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159988,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159988,34.5,0.38,79.3,75130,75,NULL,'W91CL, r, inv','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159989,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159989,34.51,0.2,79.8,75130,74.4,NULL,NULL,'UGC 12382',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159990,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159990,34.58,0.4,82.3,75130,75,NULL,'HMCL, I, raw','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159991,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159991,34.64,0.38,84.9,75130,75,NULL,'W91CL, r, cor','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159992,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159992,34.66,0.4,85.7,75130,75,NULL,'HMCL, I, inv','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159993,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,159993,34.8,0.4,91.2,75130,75,NULL,'HMCL, I, cor','UGC 12382',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159994,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 14190','RN',159994,42.5,0.34,2310,75131,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14190',0.370404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159995,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 14190','RN',159995,43.03,0.32,2950,75131,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14190',0.370404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159996,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',159996,37.74,0.46,354,75132,70,NULL,NULL,'SDSS J230758.08-104023.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000167,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,346.9920417,-10.67328,0.053,NULL,50365593031,786962391,12296287,18.5),(159997,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09334',NULL,159997,40.74,0.13,1410,75133,70,NULL,'SN photometric redshift distance, z photo =0.407 +/- 0.033','SDSS-II SN 09334',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,346.993,0.84164,0.153,NULL,51693430051,807709844,12620466,NULL),(159998,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09334','R',159998,41.72,0.23,1600,75133,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09334',0.382575,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(159999,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09334','R',159999,42.02,0.21,1830,75133,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09334',0.382575,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160000,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160000,35.61,0.8,132,75134,75,NULL,'W91PP, r','UGC 12386',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000073,NULL,'16.0',0.6,'Scd:',NULL,NULL,NULL,NULL,1,347.0034583,24.97264,0.289,NULL,52010106814,812657918,12697779,16),(160001,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160001,35.67,0.38,136,75134,75,NULL,'W91PP, r, raw','UGC 12386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160002,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160002,35.78,0.38,143,75134,75,NULL,'W91PP, r, inv','UGC 12386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160003,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160003,35.87,0.38,149,75134,75,NULL,'W91PP, r, cor','UGC 12386',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160004,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606',NULL,160004,39.79,0.45,907,75135,70,NULL,'SN photometric redshift distance, z photo =0.240 +/- 0.065','SDSS-II SN 18606',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.7g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.012,0.48236,0.157,NULL,51693532720,807711448,12620491,21.7),(160005,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606',NULL,160005,40.1,0.31,1050,75135,70,NULL,NULL,'SDSS-II SN 18606',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160006,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606','R',160006,40.93,0.25,1150,75135,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18606',0.338532,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160007,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606','R',160007,41.03,0.31,1200,75135,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18606',0.338532,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160008,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606',NULL,160008,41.03,0.22,1610,75135,70,NULL,'SALT 2','SDSS-II SN 18606',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160009,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18606',NULL,160009,41.07,0.22,1640,75135,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18606',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160010,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160010,38.04,0.46,405,75136,70,NULL,NULL,'2MASX J23080387-0030371',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,347.0160417,-0.51031,0.137,NULL,49494644040,773353813,12083653,17.4),(160011,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160011,34.79,0.2,90.8,75137,74.4,NULL,NULL,'NGC 7491',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000107,NULL,'14.38',0.5,'HII',NULL,NULL,NULL,NULL,1,347.024917,-5.96667,0.121,NULL,49481822538,773153477,12080523,14.38),(160012,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160012,34.91,0.42,96.1,75137,NULL,NULL,'Malmquist cor.','NGC 7491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160013,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160013,34.95,0.41,97.8,75137,NULL,NULL,NULL,'NGC 7491',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160014,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160014,35.05,0.97,102,75138,NULL,NULL,NULL,'MCG -02-59-001',NULL,'2009ApJS..182..474S',2009,1,0.74,'RC3 has V = 5581 km/s, and SDSS has z = 0.032823 +- 0.000084.','G',0.000033,NULL,'15.5g',0.44,'SB(s)bc pec:',NULL,NULL,NULL,NULL,1,347.0285417,-10.54264,0.049,NULL,50365701745,786964089,12296313,15.5),(160015,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160015,35.09,0.2,104,75138,74.4,NULL,NULL,'MCG -02-59-001',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160016,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160016,35.12,0.93,106,75138,NULL,NULL,'Malmquist cor.','MCG -02-59-001',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160017,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160017,36.94,0.46,244,75139,70,NULL,NULL,'2MASX J23080922+0010338',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000086,NULL,'16.2g',0.4,'E0',NULL,NULL,NULL,NULL,1,347.038458333,0.176,0.137,NULL,51693185503,807706023,12620406,16.2),(160018,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160018,37.37,0.46,298,75140,70,NULL,NULL,'SDSS J230811.88+153127.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,347.049541667,15.52431,0.205,NULL,52553983889,821155998,12830562,18.4),(160019,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160019,38.12,0.33,420,75141,70,NULL,NULL,'2MASX J23081728-0946230',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.00015,NULL,'17.4g',0.19,'AGN',NULL,NULL,NULL,NULL,1,347.072,-9.77294,0.037,NULL,49479643676,773119432,12079991,17.4),(160020,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19087','RN',160020,40.57,0.48,889,75142,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19087',0.463206,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160021,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02646','RN',160021,40.62,0.8,1240,75143,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02646',0.070162,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160022,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160022,37.32,0.46,291,75144,70,NULL,NULL,'SDSS J230817.52+004437.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00007,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,347.0732083,0.74372,0.153,NULL,51693402507,807709414,12620459,17.6),(160023,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160023,38.12,0.33,420,75145,70,NULL,NULL,'2MASX J23082309-0941180',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,347.09625,-9.68847,0.057,NULL,49479639110,773119361,12079990,17.5),(160024,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09020','RN',160024,41.41,0.31,1390,75146,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09020',0.377698,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160025,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09020','RN',160025,41.54,0.36,1480,75146,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09020',0.377698,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160026,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09020','N',160026,41.42,0.24,1920,75146,70,NULL,'SALT 2','SDSS-II SN 09020',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160027,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09020','N',160027,41.47,0.24,1970,75146,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09020',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160028,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160028,37.82,0.46,366,75147,70,NULL,NULL,'2MASX J23082936-1036312',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,347.122417,-10.60856,0.049,NULL,50365672353,786963630,12296306,17.2),(160029,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160029,38.18,0.46,432,75148,70,NULL,NULL,'SDSS J230830.32+145838.6',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.00015,NULL,'19.3g',0.11,NULL,NULL,NULL,NULL,NULL,1,347.126375,14.97742,0.257,NULL,52553420585,821147196,12830424,19.3),(160030,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160030,34.07,0.43,65,75149,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12388',NULL,'2014MNRAS.444..527S',2014,1,1.8,'The 2MASS position refers to a stellar object 8 arcsec west of the nucleus.','G',0.00001,NULL,'16.0',0.8,'Sd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.1264583,12.83056,0.157,NULL,52550266657,821097916,12829654,16),(160031,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160031,34.42,0.49,76.5,75150,75,NULL,'IR','CGCG 431-005',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000121,NULL,'15.6g',0.26,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.133541667,13.20972,0.145,NULL,52547667365,821057302,12829020,15.6),(160032,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02272','RN',160032,43.47,0.29,3350,75151,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 02272',0.473646,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160033,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160033,37.72,0.46,350,75152,70,NULL,NULL,'2MASX J23084409-1044372',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000173,NULL,'17.1g',0.27,NULL,NULL,NULL,NULL,NULL,1,347.18375,-10.74361,0.049,NULL,50365661951,786963467,12296304,17.1),(160034,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160034,34.59,0.46,83,75153,70,NULL,NULL,'IC 1471',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000083,NULL,'14.57',0.4,'poss. LINER',NULL,NULL,NULL,NULL,1,347.186875,-12.63944,0.041,NULL,50402912743,787545511,12305398,14.57),(160035,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160035,36.61,0.72,210,75154,70,NULL,NULL,'2MASX J23084670-4858427',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.69',0.36,NULL,NULL,NULL,NULL,NULL,1,347.194667,-48.97853,0,NULL,50507688359,789182630,12330978,16.69),(160036,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160036,37.46,0.46,310,75155,70,NULL,NULL,'2MASX J23084965+1423351',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000166,NULL,'18.3g',0.17,NULL,NULL,NULL,NULL,NULL,1,347.2067083,14.39294,0.181,NULL,52561014708,821265854,12832278,18.3),(160037,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160037,31.57,0.8,20.6,75156,75,NULL,'A82, H','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,1,2,NULL,'G',0.000021,NULL,'15.14',0.2,'Sb: sp','Isolated galaxy',NULL,NULL,NULL,1,347.2317083,-30.85792,NULL,NULL,50156050194,783688284,12245129,15.14),(160038,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160038,31.57,0.8,20.6,75156,75,NULL,'MAT, I','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160039,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160039,31.79,0.4,22.8,75156,NULL,NULL,'mean','ESO 469- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160040,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160040,32.03,0.47,25.4,75156,75,NULL,'A82, H, inv','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160041,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160041,32.06,0.43,25.8,75156,75,NULL,'3.6 micron, color + selection bias corrected','ESO 469- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160042,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160042,32.09,0.47,26.2,75156,75,NULL,'A82, H, raw','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160043,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160043,32.1,0.38,26.3,75156,NULL,NULL,NULL,'ESO 469- G 015',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160044,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160044,32.1,0.4,26.4,75156,75,NULL,NULL,'ESO 469- G 015',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160045,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160045,32.11,0.4,26.4,75156,73,NULL,'IR','ESO 469- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160046,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160046,32.2,0.43,27.5,75156,75,NULL,'3.6 micron, color corrected','ESO 469- G 015',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160047,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160047,32.2,0.32,27.6,75156,85,NULL,'I, inv','ESO 469- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160048,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160048,32.21,0.32,27.7,75156,85,NULL,'I, raw','ESO 469- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160049,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160049,32.32,0.2,29.1,75156,74.4,NULL,NULL,'ESO 469- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160050,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160050,32.38,0.47,29.9,75156,75,NULL,'A82, H, cor','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160051,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160051,32.39,0.43,30.1,75156,75,NULL,'MAT, I, raw','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160052,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160052,32.42,0.43,30.5,75156,75,NULL,'MAT, I, inv','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160053,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160053,32.62,0.43,33.5,75156,75,NULL,'MAT, I, cor','ESO 469- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160054,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160054,32.79,0.47,36.1,75156,NULL,NULL,'H','ESO 469- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160055,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 1973N',NULL,160055,33.75,0.4,56.2,75157,60,NULL,'M(B) = -19.48 mag','NGC 7495',NULL,'2000ApJ...540..634P',2000,1,1.8,NULL,'G',0.000013,NULL,'13.7B',1.7,'SAB(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.23825,12.04803,0.141,NULL,52546923001,821045671,12828838,13.7),(160056,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 1973N',NULL,160056,33.85,0.4,58.9,75157,60,NULL,'M(V) = -19.47 mag','NGC 7495',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160057,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 1973N',NULL,160057,34.2,0.55,69,75157,67,NULL,NULL,'NGC 7495',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160058,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 1973N',NULL,160058,34.2,0.05,69.2,75157,66,NULL,NULL,'NGC 7495',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160059,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160059,31.79,0.8,22.8,75158,75,NULL,'A82, H','NGC 7497',NULL,'1997ApJS..109..333W',1997,1,4.9,NULL,'G',0.000007,NULL,'12.96',1.1,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.264208333,18.17719,0.149,NULL,52571499579,821429680,12834838,12.96),(160060,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160060,30.74,0.4,14.1,75158,75,NULL,NULL,'NGC 7497',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160061,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160061,30.75,0.39,14.1,75158,73,NULL,'IR','NGC 7497',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160062,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160062,31.05,0.38,16.2,75158,NULL,NULL,NULL,'NGC 7497',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160063,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160063,31.05,0.4,16.2,75158,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7497',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160064,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160064,31.05,0.2,16.2,75158,74.4,NULL,NULL,'NGC 7497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160065,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160065,31.14,0.42,16.9,75158,NULL,NULL,'Malmquist cor.','NGC 7497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160066,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160066,31.13,0.43,16.9,75158,75,NULL,'3.6 micron, color corrected','NGC 7497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160067,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160067,31.16,0.43,17.1,75158,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160068,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160068,31.18,0.47,17.2,75158,75,NULL,'A82, H, raw','NGC 7497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160069,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160069,31.21,0.41,17.4,75158,NULL,NULL,NULL,'NGC 7497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160070,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160070,31.2,0.47,17.4,75158,75,NULL,'A82, H, inv','NGC 7497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160071,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160071,31.32,0.4,18.4,75158,NULL,NULL,'mean','NGC 7497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160072,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160072,31.42,0.49,19.2,75158,75,NULL,'IR','NGC 7497',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160073,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160073,31.61,0.47,20.9,75158,75,NULL,'A82, H, cor','NGC 7497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160074,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160074,31.77,0.47,22.6,75158,NULL,NULL,'H','NGC 7497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160075,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160075,31.78,0.46,22.7,75158,NULL,NULL,'J','NGC 7497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160076,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160076,31.88,0.45,23.8,75158,NULL,NULL,'K','NGC 7497',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160077,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160077,31.91,0.4,24.1,75158,75,NULL,'B','NGC 7497',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160078,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160078,38.88,0.46,597,75159,70,NULL,NULL,'2MASX J23090473-1046389',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000164,NULL,'18.0g',0.19,NULL,NULL,NULL,NULL,NULL,1,347.26975,-10.77756,0.049,NULL,50365629977,786962968,12296296,18),(160079,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 03817','RN',160079,45.09,0.13,9400,75160,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03817',0.108064,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160080,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160080,35.68,0.57,137,75161,70,NULL,NULL,'2MASX J23090682-8039321',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'16.3b',0.2,NULL,NULL,NULL,NULL,NULL,1,347.27875,-80.659,0.461,NULL,48337075966,755266811,11801043,16.3),(160081,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160081,36.46,0.56,196,75162,70,NULL,NULL,'2MASX J23091212-0151126',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.31',0.3,NULL,NULL,NULL,NULL,NULL,1,347.3005,-1.85356,0.145,NULL,49506783226,773543487,12086616,16.31),(160082,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 11142','RN',160082,41.66,0.41,1740,75163,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 11142',0.238017,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160083,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276',NULL,160083,39.91,0.29,960,75164,70,NULL,'SN photometric redshift distance, z photo =0.256 +/- 0.043','SDSS-II SN 18276',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','22.1g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.317167,-0.45756,0.145,NULL,49494516943,773351827,12083622,22.1),(160084,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276','R',160084,40.66,0.16,1050,75164,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18276',0.28462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160085,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276','R',160085,40.68,0.25,1060,75164,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18276',0.28462,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160086,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276',NULL,160086,40.58,0.15,1310,75164,70,NULL,'SALT 2','SDSS-II SN 18276',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160087,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18276',NULL,160087,40.61,0.15,1320,75164,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18276',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160088,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 21807','RN',160088,38.31,0.24,444,75165,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21807',0.032399,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160089,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15685',NULL,160089,40.67,0.18,1360,75166,70,NULL,'SN photometric redshift distance, z photo =0.391 +/- 0.043','SDSS-II SN 15685',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.3495417,0.80197,0.141,NULL,51693816375,807715880,12620560,22.2),(160090,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15685','R',160090,42.17,0.3,1960,75166,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15685',0.385981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160091,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15685','R',160091,42.59,0.31,2380,75166,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15685',0.385981,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160092,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160092,37.85,0.33,371,75167,70,NULL,NULL,'SDSS J230926.67+151256.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000152,NULL,'18.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,347.361125,15.21564,0.245,NULL,52553536989,821149015,12830453,18.6),(160093,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160093,37.69,0.46,345,75168,70,NULL,NULL,'2MASX J23092965-0925217',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000173,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,347.373417,-9.42269,0.057,NULL,49480152985,773127390,12080115,17.7),(160094,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160094,34.17,0.2,68.2,75169,74.4,NULL,NULL,'CGCG 496-047',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.71',0.2,'S?',NULL,NULL,NULL,NULL,1,347.3745417,29.48331,0.305,NULL,52064192069,813503001,12710984,15.71),(160095,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160095,34.3,0.45,72.4,75169,NULL,NULL,NULL,'CGCG 496-047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160096,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160096,34.31,0.49,72.8,75169,75,NULL,'IR','CGCG 496-047',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160097,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160097,34.61,0.39,83.6,75169,NULL,NULL,'Malmquist cor.','CGCG 496-047',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160098,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160098,36.35,0.8,186,75170,70,NULL,NULL,'2MASX J23093116-4953240',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.54',0.36,NULL,NULL,NULL,NULL,NULL,1,347.379875,-49.89003,0,NULL,50506202923,789159420,12330615,16.54),(160099,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160099,37.85,0.33,371,75171,70,NULL,NULL,'2MASX J23093346+1508151',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000168,NULL,'18.7g',0.12,NULL,NULL,NULL,NULL,NULL,1,347.389375,15.13772,0.245,NULL,52553575658,821149619,12830462,18.7),(160100,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160100,34.59,0.49,82.7,75172,75,NULL,'IR','UGC 12395',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.00002,NULL,'15.69',0.1,'Sdm:',NULL,NULL,NULL,NULL,1,347.3934583,15.65475,0.193,NULL,52552905840,821139153,12830299,15.69),(160101,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160101,34.87,0.56,94.1,75172,NULL,NULL,'Malmquist cor.','UGC 12395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160102,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160102,34.89,0.56,95,75172,NULL,NULL,NULL,'UGC 12395',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160103,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160103,34.92,0.2,96.4,75172,74.4,NULL,NULL,'UGC 12395',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160104,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160104,35.1,0.54,105,75173,NULL,NULL,NULL,'ESO 077- G 003',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000017,NULL,'14.76',0.7,'SAB(r)c','Pair member (points to parent)',NULL,NULL,NULL,1,347.413667,-72.026,0.065,NULL,48393459037,756147797,11814809,14.76),(160105,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160105,35.14,0.2,107,75173,74.4,NULL,NULL,'ESO 077- G 003',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160106,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160106,35.17,0.52,108,75173,NULL,NULL,'Malmquist cor.','ESO 077- G 003',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160107,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160107,31.55,0.8,20.5,75174,75,NULL,'MAT, I','ESO 407- G 007',NULL,'1997ApJS..109..333W',1997,1,2.8,NULL,'G',0.000093,NULL,'13.78',0.4,'SAb? sp','Group member',NULL,NULL,NULL,1,347.414167,-36.42008,NULL,NULL,49966292577,780723321,12198801,13.78),(160108,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160108,31.98,0.43,24.9,75174,75,NULL,'3.6 micron, color + selection bias corrected','ESO 407- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160109,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160109,32.23,0.4,28,75174,75,NULL,NULL,'ESO 407- G 007',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160110,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160110,32.24,0.4,28,75174,73,NULL,'IR','ESO 407- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160111,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160111,32.25,0.43,28.2,75174,75,NULL,'3.6 micron, color corrected','ESO 407- G 007',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160112,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160112,32.3,0.4,28.9,75174,73,NULL,'opt','ESO 407- G 007',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160113,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160113,32.38,0.4,29.9,75174,NULL,NULL,NULL,'ESO 407- G 007',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160114,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160114,32.53,0.2,32.1,75174,74.4,NULL,NULL,'ESO 407- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160115,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160115,32.55,0.32,32.3,75174,85,NULL,'I, raw','ESO 407- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160116,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160116,32.57,0.32,32.7,75174,85,NULL,'I, inv','ESO 407- G 007',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160117,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160117,32.61,0.49,33.3,75174,75,NULL,'IR','ESO 407- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160118,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160118,32.8,0.43,36.3,75174,75,NULL,'MAT, I, raw','ESO 407- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160119,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160119,32.94,0.43,38.7,75174,75,NULL,'MAT, I, inv','ESO 407- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160120,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160120,32.94,0.43,38.8,75174,75,NULL,'MAT, I, cor','ESO 407- G 007',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160121,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02578','RN',160121,41.02,0.14,1280,75175,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02578',0.247102,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160122,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02578','RN',160122,41.32,0.22,1480,75175,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02578',0.247102,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160123,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160123,37.9,0.46,380,75176,70,NULL,NULL,'SDSS J230942.55+001049.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,347.427333333,0.18042,0.129,NULL,51694069774,807719840,12620622,18.6),(160124,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07767','RN',160124,40.99,0.1,1170,75177,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07767',0.351778,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160125,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07767','RN',160125,41.21,0.2,1290,75177,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07767',0.351778,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160126,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160126,29.34,0.43,7.4,75178,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7496',NULL,'2014MNRAS.444..527S',2014,1,3.3,NULL,'G',0.000018,NULL,'11.91',3,'(R\':)SB(rs)bc  Sy2','X-ray-faint group member',NULL,NULL,'Sy 2',1,347.4470417,-43.42794,NULL,NULL,50530278482,789535601,12336493,11.91),(160127,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160127,30.36,0.47,11.8,75178,NULL,NULL,'H','NGC 7496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160128,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160128,30.38,0.46,11.9,75178,NULL,NULL,'J','NGC 7496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160129,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160129,30.39,0.45,11.9,75178,NULL,NULL,'K','NGC 7496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160130,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160130,31.44,0.4,19.4,75178,NULL,NULL,'mean','NGC 7496',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160131,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160131,31.51,0.4,20.1,75178,75,NULL,'B','NGC 7496',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160132,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359',NULL,160132,40.08,0.16,1040,75179,70,NULL,'SN photometric redshift distance, z photo =0.280 +/- 0.026','SDSS-II SN 15359',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.45625,0.3105,0.125,NULL,51694053693,807719588,12620618,NULL),(160133,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359','R',160133,40.72,0.23,1060,75179,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15359',0.311973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160134,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359','R',160134,40.74,0.15,1070,75179,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15359',0.311973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160135,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359',NULL,160135,40.56,0.13,1290,75179,70,NULL,'SALT 2','SDSS-II SN 15359',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160136,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15359',NULL,160136,40.59,0.13,1310,75179,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15359',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160137,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08867','RN',160137,39.69,0.41,786,75180,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08867',0.103674,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160138,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160138,36.82,0.63,231,75181,70,NULL,NULL,'2MASX J23095720-4947250',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'15.6R',0.14,NULL,NULL,NULL,NULL,NULL,1,347.488375,-49.79025,0,NULL,50506191051,789159235,12330613,15.6),(160139,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160139,38.11,0.27,419,75182,70,NULL,NULL,'SDSS J230957.84+144213.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000147,NULL,'19.2g',0.08,NULL,NULL,NULL,NULL,NULL,1,347.491,14.70375,0.257,NULL,52552686301,821135723,12830245,19.2),(160140,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13778','RN',160140,44.15,0.25,4400,75183,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13778',0.532422,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160141,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160141,35.87,0.2,149,75184,74.4,NULL,NULL,'KUG 2307+065',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000113,NULL,'15.2',0.4,'Spiral',NULL,NULL,NULL,NULL,1,347.4995,6.78972,0.189,NULL,51719911295,808123613,12626931,15.2),(160142,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160142,32,0.8,25.2,75185,75,NULL,NULL,'UGCA 436',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000017,NULL,'17',1.3,'Im','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.499583,18.44806,0.149,NULL,52500955336,820327427,12817616,17),(160143,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 10690','R',160143,40.45,0.29,937,75186,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10690',0.312052,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,347.499833,1.08225,0.145,NULL,51693953959,807718030,12620594,NULL),(160144,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160144,38.06,0.46,410,75187,70,NULL,NULL,'2MASX J23100421+1517528',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000184,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,347.5177083,15.29819,0.229,NULL,52553482152,821148158,12830439,18.2),(160145,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160145,35.05,0.17,99.2,75188,74.2,NULL,'SALT 2','ARK 577',0.031939,'2010ApJ...716..712A',2010,1,0.5,NULL,'G',0.000033,NULL,'14.83',0.4,'Sc',NULL,NULL,NULL,NULL,1,347.519541667,30.22433,0.269,NULL,52064560387,813508756,12711074,14.83),(160146,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160146,35.55,0.03,125,75188,72,NULL,'SALT2','ARK 577',0.031939,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160147,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160147,35.65,0.16,131,75188,70,NULL,'SALT 2','ARK 577',0.031939,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160148,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160148,35.62,0.09,133,75188,74.4,NULL,NULL,'ARK 577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160149,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en','R',160149,35.68,0.09,137,75188,NULL,NULL,'MLCS2k2, R(V) = 3.1','ARK 577',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160150,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en','R',160150,35.74,0.07,141,75188,NULL,NULL,'MLCS2k2, R(V) = 1.8','ARK 577',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160151,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160151,35.91,0.19,148,75188,65,NULL,'SALT2','ARK 577',0.031939,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160152,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160152,35.93,0.2,149,75188,65,NULL,'MLCS31','ARK 577',0.031939,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160153,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160153,35.93,0.17,149,75188,65,NULL,'MLCS17','ARK 577',0.031939,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160154,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006en',NULL,160154,35.95,0.17,150,75188,65,NULL,'SALT','ARK 577',0.031939,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160155,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160155,34.78,0.68,90.5,75189,70,NULL,NULL,'2MASX J23100646-8040178',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'16.6b',0.21,NULL,NULL,NULL,NULL,NULL,1,347.526625,-80.67164,0.461,NULL,48337070532,755266727,11801042,16.6),(160156,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08004','R',160156,41.34,0.3,1370,75190,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231006.87-003328.9',0.3514,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0001,NULL,'21.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,347.528625,-0.55803,0.149,NULL,49496662929,773385358,12084146,21.2),(160157,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08004','R',160157,41.43,0.38,1430,75190,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231006.87-003328.9',0.3514,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160158,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08004',NULL,160158,41.24,0.24,1770,75190,70,NULL,'SALT 2','SDSS J231006.87-003328.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160159,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08004',NULL,160159,41.28,0.24,1800,75190,70,NULL,'SALT 2, Malmquist cor.','SDSS J231006.87-003328.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160160,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 20956','RN',160160,41.27,0.29,1520,75191,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 20956',0.183368,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160161,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 20956','RN',160161,41.52,0.37,1700,75191,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20956',0.183368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160162,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 16395','RN',160162,40.15,0.15,965,75192,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16395',0.108114,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160163,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 16395','RN',160163,40.17,0.24,975,75192,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16395',0.108114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160164,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 17391','R',160164,39.8,0.23,767,75193,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jo','SN 2007jo',0.19,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,347.552417,-0.93142,0.117,NULL,49496812751,773387699,12084182,NULL),(160165,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 17391','R',160165,39.97,0.15,830,75193,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jo','SN 2007jo',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160166,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160166,37.32,0.33,290,75194,70,NULL,NULL,'2MASX J23101507-1047540',NULL,'2015arXiv151105856S',2015,1,0.66,NULL,'G',0.00015,NULL,'15.5g',0.59,'cD m',NULL,NULL,NULL,NULL,1,347.5627083,-10.79844,0.045,NULL,50366123255,786970675,12296416,15.5),(160167,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160167,37.14,0.79,268,75195,70,NULL,NULL,'2MASX J23101890-4956011',NULL,'2014MNRAS.445.2677S',2014,1,0.35,NULL,'G',0.00015,NULL,'17.07',0.27,NULL,NULL,NULL,NULL,NULL,1,347.5787917,-49.93369,0,NULL,50506021967,789156593,12330571,17.07),(160168,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160168,35.58,0.49,130,75196,75,NULL,'IR','UGC 12398',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',NULL,NULL,'15.64',0.2,'S?',NULL,NULL,NULL,NULL,1,347.589917,2.62128,0.173,NULL,51705748355,807902318,12623473,15.64),(160169,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160169,35.6,0.45,132,75196,NULL,NULL,'Malmquist cor.','UGC 12398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160170,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160170,35.74,0.43,140,75196,NULL,NULL,NULL,'UGC 12398',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160171,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160171,35.82,0.2,146,75196,74.4,NULL,NULL,'UGC 12398',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160172,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160172,34.44,0.51,77.2,75197,70,NULL,NULL,'VV 490 NED01',NULL,'2014MNRAS.445.2677S',2014,1,2.54,NULL,'G',0.00003,NULL,'14.9g',0.28,'SB(s)c pec sp',NULL,NULL,NULL,NULL,1,347.5910417,-8.68869,0.085,NULL,49477511422,773086115,12079470,14.9),(160173,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160173,35,0.49,100,75197,75,NULL,'IR','VV 490 NED01',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160174,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160174,36.09,0.4,165,75198,NULL,NULL,'mean','NGC 7499',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000093,NULL,'13.0V',0.7,'BrClG;SA(s)0^0^:','in a pair',NULL,NULL,NULL,1,347.5932917,7.58067,0.185,NULL,51717263038,808082234,12626284,13),(160175,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160175,36.09,0.45,165,75198,NULL,NULL,'K','NGC 7499',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160176,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160176,38.11,0.27,419,75199,70,NULL,NULL,'SDSS J231023.89+143349.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000146,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,347.5995417,14.56389,0.197,NULL,52560939687,821264682,12832260,18.4),(160177,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160177,37.55,0.46,324,75200,70,NULL,NULL,'2MASX J23102604+1510579',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000165,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,347.608458333,15.18281,0.229,NULL,52553505579,821148524,12830445,18.2),(160178,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07600','R',160178,39.65,0.2,718,75201,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231027.25-010627.7',0.188,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',0.0005,NULL,'19.9g',0.07,NULL,NULL,NULL,NULL,NULL,1,347.613583333,-1.10769,0.117,NULL,49496132776,773377074,12084016,19.9),(160179,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07600','R',160179,39.7,0.12,732,75201,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231027.25-010627.7',0.188,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160180,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07600',NULL,160180,39.4,0.1,759,75201,70,NULL,'SALT 2','SDSS J231027.25-010627.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160181,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 07600',NULL,160181,39.41,0.1,762,75201,70,NULL,'SALT 2, Malmquist cor.','SDSS J231027.25-010627.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160182,'BL Lac Luminosity','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160182,42.08,NULL,2610,75202,70,NULL,'nucleus-to-host flux ratio, z > 1.03','GALEXASC J231028.07-371909.3',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'18.3',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,347.616667,-37.31917,NULL,NULL,50484815056,788825235,12325394,18.3),(160183,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160183,37.32,0.33,290,75203,70,NULL,NULL,'SDSS J231029.68-104346.8',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000164,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,347.623667,-10.72967,0.045,NULL,49476862655,773075978,12079312,18.1),(160184,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160184,37.63,0.46,335,75204,70,NULL,NULL,'SDSS J231030.39-100042.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000137,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,347.626667,-10.01175,0.013,NULL,49479943111,773124111,12080064,18.4),(160185,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160185,38.11,0.27,419,75205,70,NULL,NULL,'SDSS J231033.26+143754.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000152,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,347.638625,14.63181,0.193,NULL,52552579637,821134056,12830219,18.6),(160186,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160186,35.07,0.2,103,75206,74.4,NULL,NULL,'CGCG 406-010',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00012,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,347.658666667,8.18986,0.133,NULL,51721881187,808154393,12627412,15.6),(160187,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2001ic',NULL,160187,35.33,0.2,111,75207,74.2,NULL,'SALT 2','NGC 7503',0.044237,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.00009,NULL,'13.5V',1.1,'E2:;BrClG','in a pair',NULL,'radio jet',NULL,1,347.676167,7.56769,0.185,NULL,51717256541,808082133,12626283,13.5),(160188,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2001ic',NULL,160188,36.02,0.09,160,75207,74.4,NULL,NULL,'NGC 7503',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160189,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2001ic',NULL,160189,36.44,0.21,186,75207,65,NULL,'MLCS17','NGC 7503',0.044237,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160190,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160190,34.81,0.44,91.6,75207,95,NULL,'Weighted Mean','NGC 7503',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160191,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160191,35.45,0.63,123,75207,95,NULL,'Michard 1979b, c','NGC 7503',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160192,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160192,35.45,0.46,123,75207,95,NULL,'Michard 1979a','NGC 7503',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160193,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160193,36.06,0.45,163,75207,NULL,NULL,'K','NGC 7503',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160194,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160194,36.14,0.4,169,75207,NULL,NULL,'mean','NGC 7503',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160195,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19221','RN',160195,40.04,0.09,977,75208,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 19221',0.043,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160196,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19221','RN',160196,40.57,0.34,1240,75208,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 19221',0.043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160197,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160197,37.44,0.46,307,75209,70,NULL,NULL,'2MASX J23104726-0832436',NULL,'2015arXiv151105856S',2015,1,0.46,'Star superposed 14\\\" northwest of the nucleus.','G',0.000197,NULL,'16.2g',0.39,'E0',NULL,NULL,NULL,NULL,1,347.696917,-8.54533,0.093,NULL,49491543659,773305369,12082896,16.2),(160198,'M Stars','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160198,20.06,0.87,0.103,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2010ApJ...722..750S',2010,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160199,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160199,19.5,NULL,0.0794,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2009MNRAS.398.1757W',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160200,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160200,19.52,NULL,0.08,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2010ApJ...708..717S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160201,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160201,19.54,NULL,0.081,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2007AJ....134.2236S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160202,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160202,19.57,NULL,0.082,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2010ApJ...717..133S',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160203,'RR Lyrae','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'RN',160203,19.65,NULL,0.085,75210,NULL,NULL,NULL,'Pisces Overdensity',NULL,'2009ApJ...705L.158K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160204,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01741',NULL,160204,39.02,0.42,638,75211,70,NULL,'SN photometric redshift distance, z photo =0.162 +/- 0.039','SDSS-II SN 01741',NULL,'2011ApJ...738..162S',2011,1,0.13,NULL,'G',NULL,'PHOT','20.4g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.723417,-0.568,0.125,NULL,49496641189,773385018,12084140,20.4),(160205,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01741','R',160205,40,0.21,828,75211,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01741',0.20496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160206,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01741','R',160206,40.17,0.27,896,75211,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01741',0.20496,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160207,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160207,37.55,0.46,323,75212,70,NULL,NULL,'2MASX J23105750+1345157',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000182,NULL,'17.6g',0.15,NULL,NULL,NULL,NULL,NULL,1,347.739583,13.75447,0.181,NULL,52548168223,821065128,12829142,17.6),(160208,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','PTF11lih','N',160208,37.7,0.03,323,75213,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF11lih',0.072,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160209,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13442','RN',160209,37.76,0.36,323,75214,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13442',0.102441,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160210,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13442','RN',160210,38.93,0.32,554,75214,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13442',0.102441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160211,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160211,37.22,0.46,278,75215,70,NULL,NULL,'SDSS J231102.89-103714.2',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00016,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,347.7620417,-10.62061,0.025,NULL,49476913810,773076778,12079324,17.7),(160212,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160212,37.57,0.77,326,75216,70,NULL,NULL,'2MASX J23110471-4613101',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.52',0.3,NULL,NULL,NULL,NULL,NULL,1,347.76975,-46.21956,NULL,NULL,50523345383,789427271,12334801,16.52),(160213,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160213,37.58,0.46,327,75217,70,NULL,NULL,'SDSS J231106.62+135623.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000146,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,347.777583,13.93992,0.149,NULL,52547464896,821054139,12828970,18.3),(160214,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160214,34.14,0.2,67.3,75218,74.4,NULL,NULL,'UGC 12403',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'16.0',0.4,'SBcd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,347.777917,12.78611,0.145,NULL,52549952960,821093015,12829578,16),(160215,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160215,34.84,0.46,92.7,75219,70,NULL,NULL,'CGCG 380-005',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.000074,NULL,'15.1g',0.61,NULL,NULL,NULL,NULL,NULL,1,347.79175,-0.15225,0.137,NULL,49493273277,773332394,12083318,15.1),(160216,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160216,36.16,0.52,171,75220,70,NULL,NULL,'2MASX J23111086-7503323',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'16.2b',0.25,NULL,NULL,NULL,NULL,NULL,1,347.795,-75.05894,0.113,NULL,48450598696,757040604,11828759,16.2),(160217,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160217,31.12,NULL,16.8,75221,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 291- G 003',NULL,'2010Ap&SS.325..163P',2010,1,1.83,'Possible cross-ID with HIPASS J2311-42 (2011AJ....142...83N).','G',0.000183,NULL,'15.72',0.23,'SBdm? sp',NULL,NULL,NULL,NULL,1,347.795333333,-42.84756,NULL,NULL,50530041685,789531901,12336435,15.72),(160218,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160218,31.16,NULL,17.1,75221,NULL,NULL,'Dipole + Quadrupole','ESO 291- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160219,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160219,31.19,NULL,17.3,75221,NULL,NULL,'Dipole','ESO 291- G 003',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160220,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 03234','RN',160220,41.75,0.19,1780,75222,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03234',0.259217,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160221,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13038','R',160221,38.6,0.22,475,75223,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gn','SN 2006gn',0.104,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,347.8267917,0.50461,0.129,NULL,51691282861,807676294,12619942,NULL),(160222,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13038','R',160222,38.88,0.07,540,75223,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gn','SN 2006gn',0.104,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160223,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005kq',NULL,160223,41.19,0.19,1240,75224,74.2,NULL,'SALT 2','SDSS J231120.74-003630.7',0.39,'2010ApJ...716..712A',2010,1,0.09,NULL,'G',NULL,NULL,'20.7g',0.07,NULL,NULL,NULL,NULL,NULL,1,347.8364583,-0.60856,0.125,NULL,49496647878,773385123,12084142,20.7),(160224,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005kq',NULL,160224,41.94,0.2,1760,75224,70,NULL,'SALT 2','SDSS J231120.74-003630.7',0.39,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160225,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005kq',NULL,160225,41.94,0.27,1760,75224,65,NULL,'SALT2','SDSS J231120.74-003630.7',0.39,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160226,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09045','R',160226,42.04,0.3,1840,75224,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005kq','SDSS J231120.74-003630.7',0.39,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160227,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005kq',NULL,160227,42.07,0.13,1870,75224,65,NULL,'MLCS2k2','SDSS J231120.74-003630.7',0.39,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160228,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 09045','R',160228,42.3,0.29,2070,75224,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005kq','SDSS J231120.74-003630.7',0.39,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160229,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08061','RN',160229,41.42,0.14,1580,75225,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 08061',0.216617,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160230,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08061','RN',160230,41.9,0.35,1970,75225,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 08061',0.216617,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160231,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18473','RN',160231,41.15,0.31,1250,75226,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18473',0.362207,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160232,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18473','RN',160232,41.52,0.31,1480,75226,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18473',0.362207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160233,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18473','N',160233,41,0.22,1580,75226,70,NULL,'SALT 2','SDSS-II SN 18473',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160234,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18473','N',160234,41.05,0.22,1620,75226,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18473',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160235,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652',NULL,160235,39.38,0.52,752,75227,70,NULL,'SN photometric redshift distance, z photo =0.194 +/- 0.060','SDSS-II SN 19652',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','20.6g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,347.8745,1.02383,0.125,NULL,51694776868,807730888,12620795,20.6),(160236,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652','R',160236,40.19,0.25,875,75227,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19652',0.245953,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160237,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652','R',160237,40.2,0.2,878,75227,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19652',0.245953,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160238,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652',NULL,160238,40.01,0.15,1000,75227,70,NULL,'SALT 2','SDSS-II SN 19652',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160239,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19652',NULL,160239,40.03,0.15,1010,75227,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19652',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160240,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160240,36.31,0.85,182,75228,70,NULL,NULL,'2MASX J23113169-5935471',NULL,'2014MNRAS.445.2677S',2014,1,0.33,NULL,'G',0.00015,NULL,'16.82',0.31,NULL,NULL,NULL,NULL,NULL,1,347.88225,-59.59653,0,NULL,48847782424,763246600,11925728,16.82),(160241,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160241,32.48,NULL,31.4,75229,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG -03-59-001',NULL,'2010Ap&SS.325..163P',2010,1,1.57,NULL,'G',0.000035,NULL,'15',0.2,'Sdm',NULL,NULL,NULL,NULL,1,347.902875,-15.47642,0.075,NULL,50288016760,785750261,12277347,15),(160242,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160242,32.51,NULL,31.8,75229,NULL,NULL,'Dipole + Quadrupole','MCG -03-59-001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160243,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160243,32.51,NULL,31.8,75229,NULL,NULL,'Dipole','MCG -03-59-001',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160244,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 04253','RN',160244,43.21,0.41,2780,75230,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04253',0.577436,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160245,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160245,33.58,0.45,52.1,75231,NULL,NULL,'K','NGC 7506',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000063,NULL,'13.88',1.1,'(R\')SB(r)0+:',NULL,NULL,NULL,NULL,1,347.92075,-2.16003,0.129,NULL,49507339806,773552184,12086752,13.88),(160246,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160246,33.67,0.4,54.2,75231,NULL,NULL,'mean','NGC 7506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160247,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 10480',NULL,160247,39,1.14,631,75232,70,NULL,'SN photometric redshift distance, z photo =0.160 +/- 0.130','SDSS-II SN 10480',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.9312083,-0.82017,0.125,NULL,49496773868,773387091,12084173,NULL),(160248,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18479',NULL,160248,40.09,0.17,1040,75233,70,NULL,'SN photometric redshift distance, z photo =0.282 +/- 0.028','SDSS-II SN 18479',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.950791667,-0.81114,0.125,NULL,49496730437,773386413,12084162,NULL),(160249,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160249,34.85,0.8,93.4,75234,75,NULL,'W91PP, r','UGC 12410',NULL,'1997ApJS..109..333W',1997,1,1.84,NULL,'G',0.000008,NULL,'16.0',0.17,'Sc',NULL,NULL,NULL,NULL,1,347.9595417,31.02119,0.289,NULL,52066275500,813535554,12711493,16),(160250,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160250,34.86,0.49,93.8,75234,75,NULL,'IR','UGC 12410',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160251,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160251,35,0.4,100,75234,NULL,NULL,'mean','UGC 12410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160252,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160252,35.06,NULL,103,75234,NULL,NULL,'Dipole','UGC 12410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160253,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160253,35.06,NULL,103,75234,NULL,NULL,'Dipole + Quadrupole','UGC 12410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160254,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160254,35.06,NULL,103,75234,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12410',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160255,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160255,35.16,0.43,107,75234,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12410',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160256,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160256,35.19,0.38,109,75234,75,NULL,'W91PP, r, raw','UGC 12410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160257,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160257,35.21,NULL,110,75234,NULL,NULL,NULL,'UGC 12410',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160258,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160258,35.26,0.47,113,75234,NULL,NULL,'H','UGC 12410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160259,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160259,35.28,0.45,114,75234,NULL,NULL,'K','UGC 12410',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160260,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160260,35.37,0.38,119,75234,75,NULL,'W91PP, r, cor','UGC 12410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160261,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160261,35.38,0.38,119,75234,75,NULL,'W91PP, r, inv','UGC 12410',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160262,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160262,35.39,0.43,120,75234,75,NULL,'3.6 micron, color corrected','UGC 12410',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160263,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160263,35.54,0.45,129,75234,NULL,NULL,'Malmquist cor.','UGC 12410',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160264,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160264,35.72,0.2,139,75234,74.4,NULL,NULL,'UGC 12410',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160265,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160265,35.87,0.39,149,75234,NULL,NULL,NULL,'UGC 12410',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160266,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160266,33.97,0.2,62.2,75235,74.4,NULL,NULL,'UGC 12421',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.00017,NULL,'15.2',0.4,'Scd:',NULL,NULL,NULL,NULL,1,347.9602083,77.57911,1.041,NULL,52779985868,824687279,12885738,15.2),(160267,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160267,34.05,0.4,64.6,75235,NULL,NULL,'mean','UGC 12421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160268,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160268,34.27,0.47,71.3,75235,NULL,NULL,'H','UGC 12421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160269,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160269,34.33,0.46,73.3,75235,NULL,NULL,'J','UGC 12421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160270,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160270,34.37,0.45,74.9,75235,NULL,NULL,'K','UGC 12421',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160271,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160271,34.02,0.69,63.8,75236,100,NULL,'mid-IR','UGC 12407',NULL,'2013ApJ...771...88L',2013,1,1.2,NULL,'G',0.00002,NULL,'14.07',0.7,'S?',NULL,NULL,NULL,NULL,1,347.9642917,9.50625,0.101,NULL,51709848007,807966375,12624474,14.07),(160272,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160272,34.82,0.4,92.1,75236,NULL,NULL,'mean','UGC 12407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160273,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160273,34.99,0.47,99.6,75236,NULL,NULL,'H','UGC 12407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160274,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160274,35.02,0.49,101,75236,NULL,NULL,'Malmquist cor.','UGC 12407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160275,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160275,35.07,0.46,103,75236,NULL,NULL,'J','UGC 12407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160276,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160276,35.12,0.45,106,75236,NULL,NULL,'K','UGC 12407',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160277,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160277,35.17,0.46,108,75236,NULL,NULL,NULL,'UGC 12407',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160278,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160278,35.35,0.2,117,75236,74.4,NULL,NULL,'UGC 12407',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160279,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160279,35.67,0.56,136,75237,70,NULL,NULL,'2MASX J23115189-2818597',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'15.3R',0.13,NULL,NULL,NULL,NULL,NULL,1,347.966333333,-28.31653,0.189,NULL,50135859172,783372799,12240199,15.3),(160280,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160280,36.31,0.61,183,75238,70,NULL,NULL,'2MASX J23115217-7438103',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.3b',0.21,NULL,NULL,NULL,NULL,NULL,1,347.967083,-74.63625,0.101,NULL,48450974040,757046469,11828851,16.3),(160281,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 20084','R',160281,39.24,0.19,647,75239,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pd','SDSS J231154.05-003440.4',0.091,'2014arXiv1401.3317S',2014,1,0.02,NULL,'G',NULL,NULL,'23.5g',0.02,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,347.97525,-0.57789,0.125,NULL,49493127684,773330120,12083283,23.5),(160282,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2007pd',NULL,160282,39.09,0.07,658,75239,70,NULL,'SALT 2','SDSS J231154.05-003440.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160283,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2007pd',NULL,160283,39.1,0.07,661,75239,70,NULL,'SALT 2, Malmquist cor.','SDSS J231154.05-003440.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160284,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 20084','R',160284,39.37,0.11,687,75239,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pd','SDSS J231154.05-003440.4',0.091,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160285,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08062','R',160285,41.99,0.33,1610,75240,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08062',0.554141,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,347.977,0.07708,0.129,NULL,51691205392,807675084,12619923,NULL),(160286,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08062',NULL,160286,41.56,0.03,2050,75240,70,NULL,'SN photometric redshift distance, z photo =0.685 +/- 0.015','SDSS-II SN 08062',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160287,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08062',NULL,160287,42.28,0.2,2860,75240,70,NULL,'SALT 2','SDSS-II SN 08062',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160288,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 08062',NULL,160288,42.49,0.2,3150,75240,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08062',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160289,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160289,37.05,0.46,257,75241,70,NULL,NULL,'2MASX J23115466-0935120',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000163,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,347.977791667,-9.58675,0.053,NULL,49477745179,773089768,12079527,17.6),(160290,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18630','R',160290,41.35,0.23,1370,75242,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231155.28-001550.7',0.3595,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.0001,NULL,'19.7g',0.08,NULL,NULL,NULL,NULL,NULL,1,347.980333,-0.26408,0.129,NULL,49493226967,773331671,12083307,19.7),(160291,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18630','R',160291,41.43,0.29,1420,75242,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231155.28-001550.7',0.3595,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160292,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18630',NULL,160292,41.37,0.18,1880,75242,70,NULL,'SALT 2','SDSS J231155.28-001550.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160293,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18630',NULL,160293,41.41,0.18,1910,75242,70,NULL,'SALT 2, Malmquist cor.','SDSS J231155.28-001550.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160294,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160294,37.93,0.46,385,75243,70,NULL,NULL,'2MASX J23115531+1404583',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00016,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,347.980417,14.08278,0.157,NULL,52547438744,821053730,12828964,18.1),(160295,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 02517','RN',160295,43.32,0.2,2910,75244,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02517',0.584527,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160296,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160296,37.47,0.46,311,75245,70,NULL,NULL,'2MASX J23115885-1004280',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000144,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,347.995167,-10.07428,0.069,NULL,49476371000,773068296,12079192,18.1),(160297,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160297,34.84,0.49,93,75246,75,NULL,'IR','UGC 12411',NULL,'2011yCatp016004901K',2011,1,1.93,'Two stars superposed near nucleus.','G',0.000037,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,348.014917,48.81628,1.085,NULL,55326859796,864482184,13507534,16.5),(160298,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160298,35.49,NULL,126,75246,NULL,NULL,'Dipole + Quadrupole','UGC 12411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160299,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160299,35.49,NULL,126,75246,NULL,NULL,'Dipole','UGC 12411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160300,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160300,35.49,NULL,126,75246,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12411',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160301,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160301,35.55,NULL,129,75246,NULL,NULL,NULL,'UGC 12411',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160302,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160302,37.47,0.46,311,75247,70,NULL,NULL,'2MASX J23120417+1407113',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000164,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,348.017375,14.11975,0.157,NULL,52514883367,820545052,12821016,17.7),(160303,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160303,36.76,0.46,225,75248,70,NULL,NULL,'2MASX J23120752+1425533',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00019,NULL,'16.0g',0.43,'E0',NULL,NULL,NULL,NULL,1,348.03125,14.43144,0.193,NULL,52514843544,820544430,12821006,16),(160304,'SBF','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160304,31.95,0.14,24.6,75249,74.4,NULL,NULL,'NGC 7507',NULL,'2013AJ....146...86T',2013,1,2.8,NULL,'G',0.00005,NULL,'12.23',2.7,'E0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,348.031625,-28.53961,0.192,NULL,50135936272,783374004,12240218,12.23),(160305,'SBF','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160305,31.99,0.17,25,75249,NULL,NULL,'I','NGC 7507',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160306,'SBF','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160306,31.99,0.17,25,75249,NULL,NULL,NULL,'NGC 7507',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160307,'SBF','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160307,32.01,0.17,25.2,75249,NULL,NULL,'Malmquist cor.','NGC 7507',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160308,'D-Sigma','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160308,31.41,0.4,19.1,75249,75,NULL,'Edat, raw','NGC 7507',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160309,'D-Sigma','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160309,31.74,0.4,22.3,75249,75,NULL,'Edat, cor','NGC 7507',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160310,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160310,30.67,0.41,13.6,75249,95,NULL,'de Vaucouleurs','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160311,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160311,31.04,0.27,16.1,75249,95,NULL,'Weighted Mean','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160312,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160312,31.2,0.63,17.4,75249,95,NULL,'Michard 1979b, c','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160313,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160313,31.42,0.46,19.2,75249,95,NULL,'Michard 1979a','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160314,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160314,31.93,NULL,24.3,75249,NULL,NULL,'LEDA [April 2006]','NGC 7507',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160315,'Faber-Jackson','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160315,33.27,0.81,45.1,75249,55,NULL,'Visvanathan & Sandage 1979','NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160316,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160316,31.62,0.41,21.1,75249,NULL,NULL,NULL,'NGC 7507',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160317,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160317,31.81,0.41,23,75249,NULL,NULL,'Malmquist cor.','NGC 7507',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160318,'Tertiary','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160318,31.34,0.41,18.5,75249,95,NULL,NULL,'NGC 7507',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160319,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160319,31.43,0.8,19.3,75249,75,NULL,'B','NGC 7507',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160320,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160320,35.33,0.59,116,75250,70,NULL,NULL,'6dF J2312096-282554',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,348.040083333,-28.43178,0.192,NULL,50136071862,783376122,12240251,15.2),(160321,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160321,36.12,0.58,168,75251,70,NULL,NULL,'2MASX J23121257-5759360',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.13',0.28,'S',NULL,NULL,NULL,NULL,1,348.052583333,-57.99339,0,NULL,48848090102,763251407,11925803,16.13),(160322,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160322,37.3,0.46,288,75252,70,NULL,NULL,'2MASX J23121467+0030322',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000087,NULL,'17.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,348.0610417,0.50886,0.125,NULL,51691417515,807678398,12619974,17.4),(160323,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160323,37.84,0.46,370,75253,70,NULL,NULL,'2MASX J23122005+1402283',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000169,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.0835,14.04131,0.157,NULL,52514905085,820545391,12821021,17.3),(160324,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160324,37.42,0.46,305,75254,70,NULL,NULL,'2MASX J23122041+0035142',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000092,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,348.085167,0.58725,0.125,NULL,51691448688,807678885,12619982,16.7),(160325,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160325,37.61,0.33,333,75255,70,NULL,NULL,'SDSS J231221.63-090815.2',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00017,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,348.090167,-9.13756,0.065,NULL,49477932769,773092699,12079573,17.9),(160326,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160326,38.05,0.46,408,75256,70,NULL,NULL,'2MASX J23122230-0951565',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00018,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,348.092875,-9.86578,0.061,NULL,49479731408,773120803,12080012,17.5),(160327,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160327,38.4,0.46,480,75257,70,NULL,NULL,'SDSS J231223.40-095621.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000154,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,348.0975,-9.93939,0.061,NULL,49479743720,773120995,12080015,18.6),(160328,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160328,37.41,0.46,303,75258,70,NULL,NULL,'2MASX J23122393+0012242',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',NULL,NULL,'17.38',0.27,NULL,NULL,NULL,NULL,NULL,1,348.09975,0.20675,0.129,NULL,51691511664,807679869,12619997,17.38),(160329,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160329,34.98,0.51,99.3,75259,70,NULL,NULL,'2MASX J23122425-0110456',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.000084,NULL,'15.7g',0.22,'Sa',NULL,NULL,NULL,NULL,1,348.101083333,-1.17939,0.113,NULL,49496368286,773380754,12084074,15.7),(160330,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160330,33.96,0.8,62.1,75260,75,NULL,'W91PP, r','NGC 7514',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.54',0.9,'Sa','Isolated galaxy',NULL,NULL,NULL,1,348.10775,34.8815,0.317,NULL,52045229373,813206708,12706354,13.54),(160331,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160331,33.76,0.38,56.6,75260,75,NULL,'W91PP, r, raw','NGC 7514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160332,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160332,33.85,0.47,59,75260,NULL,NULL,'H','NGC 7514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160333,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160333,33.92,0.46,60.7,75260,NULL,NULL,'J','NGC 7514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160334,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160334,33.92,0.45,60.8,75260,NULL,NULL,'K','NGC 7514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160335,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160335,33.96,0.38,61.9,75260,75,NULL,'W91PP, r, inv','NGC 7514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160336,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160336,34.01,0.4,63.4,75260,NULL,NULL,'mean','NGC 7514',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160337,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160337,34.11,0.38,66.2,75260,75,NULL,'W91PP, r, cor','NGC 7514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160338,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160338,33.77,0.2,56.8,75261,74.4,NULL,NULL,'NGC 7511',NULL,'2013AJ....146...86T',2013,1,0.92,NULL,'G',0.00006,NULL,'14.7g',0.51,'Sa',NULL,NULL,NULL,NULL,1,348.109541667,13.72658,0.149,NULL,52515192682,820549885,12821091,14.7),(160339,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160339,37.73,0.46,351,75262,70,NULL,NULL,'2MASX J23122837+1537523',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,348.1182917,15.63136,0.173,NULL,52522731700,820667682,12822932,17.5),(160340,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160340,37.61,0.33,333,75263,70,NULL,NULL,'2MASX J23122853-0914265',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000173,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,348.11875,-9.24083,0.069,NULL,49477955730,773093058,12079579,16.9),(160341,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160341,35.78,0.52,143,75264,70,NULL,NULL,'2MASX J23123213-0006366',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.000085,NULL,'15.9g',0.33,NULL,NULL,NULL,NULL,NULL,1,348.1337917,-0.11028,0.129,NULL,49493713989,773339281,12083426,15.9),(160342,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160342,43.85,0.77,2310,75265,NULL,NULL,NULL,'HG 051111',1.54948,'2008AIPC.1065..367L',2008,1,NULL,'The position given in 2008ApJ...672...59P is incorrect.','G',0.00001,NULL,'26  R',NULL,'DLA',NULL,NULL,NULL,NULL,1,348.1382083,18.37467,0.217,NULL,52500175183,820315237,12817425,26),(160343,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160343,44.54,0.6,3170,75265,69.7,NULL,'Calibrated','HG 051111',1.54948,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160344,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160344,44.58,0.69,3230,75265,70,NULL,NULL,'HG 051111',1.54948,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160345,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160345,45.14,0.63,4180,75265,69.7,NULL,'Fiducial','HG 051111',1.54948,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160346,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 16211','R',160346,40.84,0.29,1120,75266,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006nm','SDSS J231239.09+001557.5',0.31,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',NULL,NULL,'19.9g',0.07,NULL,NULL,NULL,NULL,NULL,1,348.162917,0.266,0.129,NULL,51691518469,807679976,12619999,19.9),(160347,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 16211','R',160347,41.07,0.26,1250,75266,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006nm','SDSS J231239.09+001557.5',0.31,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160348,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006nm',NULL,160348,40.65,0.2,1350,75266,70,NULL,'SALT 2','SDSS J231239.09+001557.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160349,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2006nm',NULL,160349,40.69,0.2,1370,75266,70,NULL,'SALT 2, Malmquist cor.','SDSS J231239.09+001557.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160350,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160350,36.39,0.69,190,75267,70,NULL,NULL,'2MASX J23124042-0148178',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'16.82',0.26,NULL,NULL,NULL,NULL,NULL,1,348.168583,-1.80483,0.097,NULL,49495887978,773373249,12083957,16.82),(160351,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160351,36.52,0.62,201,75268,70,NULL,NULL,'2MASX J23124071-7620415',NULL,'2014MNRAS.445.2677S',2014,1,0.23,NULL,'G',0.00015,NULL,'16.8b',0.19,NULL,NULL,NULL,NULL,NULL,1,348.169625,-76.34483,0.217,NULL,48432083180,756751299,11824239,16.8),(160352,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160352,37.38,0.46,299,75269,70,NULL,NULL,'2MASX J23124080-1023065',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.2g',0.36,'E0',NULL,NULL,NULL,NULL,1,348.169917,-10.38514,0.045,NULL,49476493553,773070211,12079222,16.2),(160353,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18224','R',160353,40.94,0.37,1150,75270,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231241.95-001846.2',0.3392,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0002,NULL,'20.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,348.174833,-0.31286,0.117,NULL,49493757202,773339956,12083436,20.4),(160354,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18224','R',160354,41.08,0.42,1230,75270,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231241.95-001846.2',0.3392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160355,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18224',NULL,160355,40.91,0.29,1520,75270,70,NULL,'SALT 2','SDSS J231241.95-001846.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160356,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 18224',NULL,160356,40.96,0.29,1560,75270,70,NULL,'SALT 2, Malmquist cor.','SDSS J231241.95-001846.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160357,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15725',NULL,160357,40.87,0.29,1500,75271,70,NULL,'SN photometric redshift distance, z photo =0.440 +/- 0.087','SDSS-II SN 15725',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.1870417,-0.17778,0.109,NULL,49493713524,773339273,12083426,NULL),(160358,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15725',NULL,160358,42.4,0.27,3020,75271,70,NULL,'SALT 2','SDSS-II SN 15725',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160359,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 15725',NULL,160359,42.47,0.27,3120,75271,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15725',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160360,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160360,31.48,0.8,19.7,75272,75,NULL,'MAT, I','ESO 407- G 009',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000026,NULL,'14.66',0.7,'SB(s)d:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,348.187125,-37.20792,NULL,NULL,49963691780,780682684,12198166,14.66),(160361,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160361,31.28,0.32,18,75272,85,NULL,'I, inv','ESO 407- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160362,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160362,31.31,0.32,18.3,75272,85,NULL,'I, raw','ESO 407- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160363,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160363,31.7,0.43,21.8,75272,75,NULL,'MAT, I, inv','ESO 407- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160364,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160364,31.74,0.43,22.3,75272,75,NULL,'MAT, I, raw','ESO 407- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160365,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160365,31.95,0.43,24.5,75272,75,NULL,'MAT, I, cor','ESO 407- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160366,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160366,32.13,0.2,26.7,75272,74.4,NULL,NULL,'ESO 407- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160367,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160367,32.17,0.43,27.2,75272,75,NULL,'3.6 micron, color corrected','ESO 407- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160368,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160368,32.22,0.43,27.7,75272,75,NULL,'3.6 micron, color + selection bias corrected','ESO 407- G 009',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160369,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160369,32.28,0.39,28.6,75272,73,NULL,'opt','ESO 407- G 009',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160370,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160370,32.35,0.47,29.6,75272,NULL,NULL,NULL,'ESO 407- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160371,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160371,32.37,0.47,29.8,75272,NULL,NULL,'Malmquist cor.','ESO 407- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160372,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160372,35.92,0.6,153,75273,70,NULL,NULL,'2MASX J23124604-5334325',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'17.16',0.17,NULL,NULL,NULL,NULL,NULL,1,348.1919583,-53.57572,0,NULL,48611268818,759551075,11867985,17.16),(160373,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19334',NULL,160373,40.71,0.19,1390,75274,70,NULL,'SALT 2','SDSS-II SN 19334',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.1949583,0.33461,0.125,NULL,51691504558,807679758,12619996,NULL),(160374,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19334',NULL,160374,40.72,0.19,1390,75274,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19334',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160375,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19334',NULL,160375,41.59,NULL,2080,75274,70,NULL,'SN photometric redshift distance, z photo =0.700 +/- 0.001','SDSS-II SN 19334',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160376,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160376,37.84,0.46,369,75275,70,NULL,NULL,'2MASX J23124713+1455154',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00015,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.196417,14.92103,0.177,NULL,52522140703,820658448,12822788,17.5),(160377,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160377,36.17,0.79,171,75276,70,NULL,NULL,'2MASX J23124796-4347150',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'16.53',0.28,NULL,NULL,NULL,NULL,NULL,1,348.19975,-43.78744,NULL,NULL,50530619137,789540924,12336576,16.53),(160378,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160378,36.34,0.57,186,75277,70,NULL,NULL,'6dF J2312502-371013',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,348.209,-37.17014,NULL,NULL,49964552295,780696129,12198377,14.9),(160379,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160379,33.12,0.8,42.1,75278,75,NULL,'W91CL, r','IC 1474',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000027,NULL,'14.73',0.5,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,348.213625,5.80636,0.213,NULL,51715982665,808062229,12625972,14.73),(160380,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160380,33.14,0.8,42.4,75278,75,NULL,'HMCL, I','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160381,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160381,33.15,0.8,42.7,75278,75,NULL,'MAT, I','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160382,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160382,33.16,0.8,42.8,75278,75,NULL,'CF, r','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160383,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160383,32.99,0.43,39.7,75278,75,NULL,'3.6 micron, color + selection bias corrected','IC 1474',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160384,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160384,33.24,0.32,44.4,75278,85,NULL,'I, raw','IC 1474',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160385,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160385,33.26,0.32,44.9,75278,85,NULL,'I, inv','IC 1474',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160386,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160386,33.31,0.43,45.9,75278,75,NULL,'3.6 micron, color corrected','IC 1474',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160387,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160387,33.34,0.4,46.5,75278,NULL,NULL,'mean','IC 1474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160388,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160388,33.37,0.38,47.2,75278,75,NULL,'W91CL, r, raw','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160389,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160389,33.42,0.38,48.3,75278,75,NULL,'W91CL, r, inv','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160390,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160390,33.48,0.47,49.7,75278,NULL,NULL,'H','IC 1474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160391,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160391,33.51,0.43,50.4,75278,75,NULL,'MAT, I, raw','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160392,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160392,33.51,0.1,50.5,75278,NULL,NULL,NULL,'IC 1474',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160393,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160393,33.53,0.46,50.8,75278,NULL,NULL,'J','IC 1474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160394,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160394,33.58,0.45,51.9,75278,NULL,NULL,'K','IC 1474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160395,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160395,33.6,0.2,52.5,75278,74.4,NULL,NULL,'IC 1474',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160396,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160396,33.62,0.38,53.1,75278,75,NULL,'CF, r, raw','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160397,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160397,33.64,0.38,53.5,75278,75,NULL,'W91CL, r, cor','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160398,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160398,33.65,0.43,53.7,75278,75,NULL,'MAT, I, inv','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160399,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160399,33.69,0.38,54.8,75278,75,NULL,'CF, r, inv','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160400,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160400,33.84,0.43,58.7,75278,75,NULL,'MAT, I, cor','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160401,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160401,33.89,0.38,59.9,75278,75,NULL,'CF, r, cor','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160402,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160402,34.5,0.4,79.4,75278,75,NULL,'HMCL, I, raw','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160403,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160403,34.59,0.4,82.7,75278,75,NULL,'HMCL, I, inv','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160404,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160404,34.71,0.4,87.4,75278,75,NULL,'HMCL, I, cor','IC 1474',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160405,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160405,34.33,0.47,73.5,75279,NULL,NULL,'H','IC 5290',NULL,'2007A&A...465...71T',2007,1,1.3,'This may also be NGC 7520.','G',0.000033,NULL,'13.62',0.8,'(R)Sa:',NULL,NULL,NULL,NULL,1,348.221917,-23.46919,0.046,NULL,50301812121,785965814,12280715,13.62),(160406,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160406,34.37,0.45,74.9,75279,NULL,NULL,'K','IC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160407,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160407,34.4,0.46,76,75279,NULL,NULL,'J','IC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160408,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160408,34.58,0.4,82.5,75279,NULL,NULL,'mean','IC 5290',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160409,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160409,35.06,0.27,103,75279,NULL,NULL,NULL,'IC 5290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160410,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160410,35.1,0.2,105,75279,74.4,NULL,NULL,'IC 5290',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160411,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160411,35.3,0.25,115,75279,NULL,NULL,'Malmquist cor.','IC 5290',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160412,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01742','RN',160412,39.53,0.14,724,75280,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01742',0.111638,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160413,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 01742','RN',160413,39.78,0.22,814,75280,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01742',0.111638,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160414,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160414,36.19,0.62,173,75281,70,NULL,NULL,'LCRS B231008.4-445531',NULL,'2014MNRAS.445.2677S',2014,1,0.26,NULL,'G',0.00015,NULL,'15.44',0.12,NULL,NULL,NULL,NULL,NULL,1,348.234,-44.65347,NULL,NULL,50532908938,789576702,12337135,15.44),(160415,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160415,36.18,0.61,172,75282,70,NULL,NULL,'2MASX J23125697-0208217',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'16.52',0.24,NULL,NULL,NULL,NULL,'USS',1,348.2374583,-2.13944,0.109,NULL,49495754944,773371171,12083924,16.52),(160416,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160416,31.79,NULL,22.8,75283,NULL,NULL,NULL,'FGC 2468',NULL,'2000BSAO...50....5K',2000,1,1.03,'Matthews (2000A&AS..143..421M) detects another feature at v=7995 km/sec.','G',0.00008,NULL,'16.4',0.1,'Sd(f)',NULL,NULL,NULL,NULL,1,348.2624583,-1.24272,0.113,NULL,49496443024,773381922,12084092,16.4),(160417,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13039','RN',160417,41.58,0.28,1610,75284,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13039',0.285041,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160418,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13039','RN',160418,41.65,0.17,1660,75284,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13039',0.285041,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160419,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160419,34.19,0.47,68.9,75285,NULL,NULL,'H','UGC 12425',NULL,'2007A&A...465...71T',2007,1,1.5,'1999ApJS..121..287H has V = 5999 +- 32 km/sec.','G',0.000033,NULL,'14.99',0.2,'Sab',NULL,NULL,NULL,NULL,1,348.291,24.24403,0.229,NULL,51976207863,812128247,12689503,14.99),(160420,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160420,34.26,0.46,71.2,75285,NULL,NULL,'J','UGC 12425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160421,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160421,34.29,0.45,72.2,75285,NULL,NULL,'K','UGC 12425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160422,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160422,34.58,0.4,82.4,75285,NULL,NULL,'mean','UGC 12425',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160423,'Ring Diameter','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160423,33,0.84,40,75286,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7518',NULL,'1981ApJS...45..541P',1981,1,1.4,NULL,'G',0.000013,NULL,'14.24',1,'(R)SAB(r)a','in a radial-velocity based grouping',NULL,NULL,NULL,1,348.303041667,6.32167,0.217,NULL,51716740472,808074069,12626157,14.24),(160424,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160424,30,0.8,10,75286,75,NULL,'B','NGC 7518',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160425,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160425,32.71,0.69,34.8,75286,100,NULL,'mid-IR','NGC 7518',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160426,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160426,33.93,0.8,61,75287,75,NULL,'W91CL, r','UGC 12423',NULL,'1997ApJS..109..333W',1997,1,4.7,'Declination in 1999ApJS..121..287H is -3 arcminutes in error.','G',0.00002,NULL,'14.53',0.45,'Sc','in a pair',NULL,NULL,NULL,1,348.304917,6.43025,0.237,NULL,51716743237,808074113,12626158,14.53),(160427,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160427,33.93,0.8,61.1,75287,75,NULL,'MAT, I','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160428,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160428,33.93,0.8,61.1,75287,75,NULL,'HMCL, I','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160429,'Tully est','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160429,30.57,0.8,13,75287,75,NULL,'B','UGC 12423',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160430,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160430,33.45,NULL,48.9,75287,NULL,NULL,'Dipole','UGC 12423',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160431,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160431,33.45,NULL,49,75287,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12423',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160432,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160432,33.45,NULL,49.1,75287,NULL,NULL,'Dipole + Quadrupole','UGC 12423',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160433,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160433,33.48,NULL,49.7,75287,NULL,NULL,NULL,'UGC 12423',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160434,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160434,33.95,0.4,61.7,75287,NULL,NULL,'mean','UGC 12423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160435,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160435,34.14,0.49,67.4,75287,75,NULL,'IR','UGC 12423',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160436,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160436,34.25,0.43,70.7,75287,75,NULL,'MAT, I, raw','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160437,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160437,34.25,0.46,70.7,75287,NULL,NULL,'J','UGC 12423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160438,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160438,34.28,0.38,71.7,75287,NULL,NULL,'Malmquist cor.','UGC 12423',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160439,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160439,34.34,0.38,73.9,75287,75,NULL,'W91CL, r, raw','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160440,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160440,34.38,0.32,75.3,75287,85,NULL,'I, raw','UGC 12423',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160441,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160441,34.39,0.4,75.7,75287,75,NULL,'HMCL, I, raw','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160442,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160442,34.43,0.2,76.9,75287,74.4,NULL,NULL,'UGC 12423',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160443,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160443,34.45,0.32,77.7,75287,85,NULL,'I, inv','UGC 12423',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160444,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160444,34.47,0.35,78.3,75287,NULL,NULL,NULL,'UGC 12423',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160445,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160445,34.48,0.47,78.8,75287,NULL,NULL,'H','UGC 12423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160446,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160446,34.49,0.45,79,75287,NULL,NULL,'K','UGC 12423',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160447,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160447,34.49,0.43,79.1,75287,75,NULL,'MAT, I, cor','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160448,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160448,34.52,0.38,80.3,75287,75,NULL,'W91CL, r, cor','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160449,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160449,34.53,0.43,80.4,75287,75,NULL,'MAT, I, inv','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160450,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160450,34.54,0.38,81,75287,75,NULL,'W91CL, r, inv','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160451,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160451,34.6,0.4,83,75287,75,NULL,'HMCL, I, cor','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160452,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160452,34.63,0.4,84.4,75287,75,NULL,'HMCL, I, inv','UGC 12423',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160453,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160453,31.49,0.8,19.9,75288,75,NULL,'MAT, I','NGC 7513',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.000013,NULL,'11.3B',2.1,'(R\')SB(s)b pec','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,348.3084583,-28.3575,0.181,NULL,50136040328,783375630,12240244,11.3),(160454,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160454,30.95,0.43,15.5,75288,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7513',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160455,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160455,31.05,0.43,16.2,75288,75,NULL,'3.6 micron, color corrected','NGC 7513',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160456,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160456,31.13,0.32,16.8,75288,85,NULL,'I, raw','NGC 7513',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160457,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160457,31.14,0.32,16.9,75288,85,NULL,'I, inv','NGC 7513',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160458,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160458,31.17,0.2,17.1,75288,74.4,NULL,NULL,'NGC 7513',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160459,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160459,31.21,0.43,17.4,75288,75,NULL,'MAT, I, raw','NGC 7513',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160460,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160460,31.33,0.43,18.4,75288,75,NULL,'MAT, I, inv','NGC 7513',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160461,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160461,31.39,0.54,19,75288,NULL,NULL,NULL,'NGC 7513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160462,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160462,31.45,0.4,19.5,75288,NULL,NULL,'mean','NGC 7513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160463,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160463,31.48,0.43,19.8,75288,75,NULL,'MAT, I, cor','NGC 7513',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160464,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160464,31.55,0.4,20.4,75288,73,NULL,'opt','NGC 7513',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160465,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160465,31.58,0.47,20.7,75288,NULL,NULL,'H','NGC 7513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160466,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160466,31.59,0.45,20.8,75288,NULL,NULL,'K','NGC 7513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160467,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160467,31.65,0.46,21.4,75288,NULL,NULL,'J','NGC 7513',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160468,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160468,31.68,0.47,21.6,75288,NULL,NULL,'Malmquist cor.','NGC 7513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160469,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160469,37.1,0.46,264,75289,70,NULL,NULL,'2MASX J23131593+1513230',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000145,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,348.3162917,15.22311,0.173,NULL,52522221046,820659703,12822807,17.9),(160470,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160470,37.13,0.46,267,75290,70,NULL,NULL,'2MASX J23131976+0037432',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.71',0.25,NULL,NULL,NULL,NULL,NULL,1,348.332333333,0.62861,0.121,NULL,51691604482,807681320,12620020,16.71),(160471,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160471,36.58,0.59,207,75291,70,NULL,NULL,'2MASX J23132346-5344261',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.41',0.4,'S0',NULL,NULL,NULL,NULL,1,348.347833,-53.74056,0,NULL,48608580143,759509064,11867329,16.41),(160472,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 12727','RN',160472,41.85,0.35,1720,75292,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12727',0.365625,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160473,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 12727','RN',160473,42.7,0.28,2540,75292,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12727',0.365625,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160474,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160474,33.59,0.2,52.2,75293,74.4,NULL,NULL,'UGC 12427',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.36',0.3,'Sbc',NULL,NULL,NULL,NULL,1,348.3489583,28.95453,0.313,NULL,52020889838,812826403,12700412,15.36),(160475,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160475,33.74,0.59,55.9,75293,NULL,NULL,NULL,'UGC 12427',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160476,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160476,34.02,0.52,63.6,75293,NULL,NULL,'Malmquist cor.','UGC 12427',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160477,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160477,35.67,0.46,136,75294,70,NULL,NULL,'2MASX J23132800+1416111',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000169,NULL,'16.2g',0.33,'S0',NULL,NULL,NULL,NULL,1,348.366708333,14.26983,0.161,NULL,52514986374,820546662,12821041,16.2),(160478,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160478,36.65,0.46,214,75295,70,NULL,NULL,'2MASX J23132923-0943516',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000172,NULL,'16.8g',0.29,NULL,NULL,NULL,NULL,NULL,1,348.371916667,-9.73108,0.049,NULL,49595844334,774935067,12108360,16.8),(160479,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160479,36.49,0.65,198,75296,70,NULL,NULL,'2MASX J23133038-4839069',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.74',0.26,NULL,NULL,NULL,NULL,NULL,1,348.376667,-48.652,0,NULL,50503944381,789124130,12330064,16.74),(160480,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160480,33.76,0.49,56.6,75297,75,NULL,'IR','UGC 12426',NULL,'2011yCatp016004901K',2011,1,1.68,NULL,'G',0.000009,NULL,'15.98',0.17,'Sdm',NULL,NULL,NULL,NULL,1,348.385583333,6.56794,0.237,NULL,51716226741,808066042,12626031,15.98),(160481,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160481,33.92,NULL,60.9,75297,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160482,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160482,33.93,NULL,61.2,75297,NULL,NULL,'Dipole','UGC 12426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160483,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160483,33.94,NULL,61.3,75297,NULL,NULL,'Dipole + Quadrupole','UGC 12426',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160484,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160484,34.01,NULL,63.4,75297,NULL,NULL,NULL,'UGC 12426',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160485,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160485,34.15,0.2,67.6,75297,74.4,NULL,NULL,'UGC 12426',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160486,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160486,34.23,0.44,70.2,75297,NULL,NULL,NULL,'UGC 12426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160487,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160487,34.25,0.44,70.8,75297,NULL,NULL,'Malmquist cor.','UGC 12426',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160488,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160488,33.64,0.8,53.4,75298,75,NULL,'MAT, I','ESO 027- G 024',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.14',0.9,'SA(rs)bc','in a pair',NULL,NULL,NULL,1,348.387167,-81.62506,0.437,NULL,48350410851,755475169,11804299,14.14),(160489,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160489,34,0.4,63,75298,NULL,NULL,'mean','ESO 027- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160490,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160490,34.14,0.32,67.2,75298,85,NULL,'I, raw','ESO 027- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160491,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160491,34.19,0.32,68.8,75298,85,NULL,'I, inv','ESO 027- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160492,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160492,34.24,0.41,70.4,75298,NULL,NULL,'Malmquist cor.','ESO 027- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160493,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160493,34.24,0.43,70.5,75298,75,NULL,'MAT, I, raw','ESO 027- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160494,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160494,34.26,0.47,71.1,75298,NULL,NULL,'H','ESO 027- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160495,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160495,34.28,0.4,71.8,75298,NULL,NULL,NULL,'ESO 027- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160496,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160496,34.29,0.45,72.2,75298,NULL,NULL,'K','ESO 027- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160497,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160497,34.32,0.2,73.1,75298,74.4,NULL,NULL,'ESO 027- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160498,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160498,34.33,0.46,73.5,75298,NULL,NULL,'J','ESO 027- G 024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160499,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160499,34.45,0.43,77.6,75298,75,NULL,'MAT, I, cor','ESO 027- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160500,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160500,34.49,0.43,78.9,75298,75,NULL,'MAT, I, inv','ESO 027- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160501,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 05198','RN',160501,43.49,0.24,3580,75299,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05198',0.39425,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160502,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 05198','RN',160502,43.74,0.26,4020,75299,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05198',0.39425,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160503,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160503,37.33,0.46,293,75300,70,NULL,NULL,'2MASX J23133921-0900445',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,348.413458333,-9.0125,0.065,NULL,49595649640,774932025,12108312,16.6),(160504,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160504,33.28,0.8,45.2,75301,75,NULL,'W91PP, r','UGC 12430',NULL,'1997ApJS..109..333W',1997,1,2.49,NULL,'G',0.000013,NULL,'14.84',0.27,'Sd             Sbrst',NULL,NULL,NULL,NULL,1,348.4307917,29.01072,0.305,NULL,52020896115,812826501,12700414,14.84),(160505,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160505,32.46,NULL,31,75301,NULL,NULL,NULL,'UGC 12430',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160506,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160506,32.59,NULL,33,75301,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160507,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160507,32.62,NULL,33.3,75301,NULL,NULL,'Dipole','UGC 12430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160508,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160508,32.62,NULL,33.3,75301,NULL,NULL,'Dipole + Quadrupole','UGC 12430',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160509,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160509,32.84,0.49,36.9,75301,NULL,NULL,NULL,'UGC 12430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160510,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160510,32.86,0.49,37.3,75301,75,NULL,'IR','UGC 12430',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160511,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160511,32.86,0.2,37.3,75301,74.4,NULL,NULL,'UGC 12430',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160512,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160512,32.94,0.38,38.6,75301,75,NULL,'W91PP, r, inv','UGC 12430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160513,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160513,32.98,0.38,39.4,75301,75,NULL,'W91PP, r, raw','UGC 12430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160514,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160514,33.07,0.44,41.1,75301,NULL,NULL,'Malmquist cor.','UGC 12430',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160515,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160515,33.08,0.43,41.4,75301,75,NULL,'3.6 micron, color corrected','UGC 12430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160516,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160516,33.17,0.43,43.1,75301,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12430',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160517,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160517,33.3,0.38,45.8,75301,75,NULL,'W91PP, r, cor','UGC 12430',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160518,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19222','R',160518,41.22,0.17,1500,75302,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007nl','SN 2007nl',0.1683,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,348.437166667,-0.06764,0.113,NULL,49493019726,773328433,12083256,NULL),(160519,'SNIa SDSS','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19222','R',160519,41.83,0.38,1990,75302,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007nl','SN 2007nl',0.1683,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160520,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 19776',NULL,160520,40.67,0.37,1360,75303,70,NULL,'SN photometric redshift distance, z photo =0.391 +/- 0.096','SDSS-II SN 19776',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.443,-0.47925,0.109,NULL,49493671905,773338623,12083415,NULL),(160521,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160521,35.2,0.59,110,75304,70,NULL,NULL,'2MASX J23134822-4314013',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.34',0.37,'E',NULL,NULL,NULL,NULL,1,348.450833,-43.23361,NULL,NULL,50530449549,789538274,12336535,16.34),(160522,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160522,35.81,0.4,145,75305,NULL,NULL,NULL,'2MASX J23134888+1337161',NULL,'2009ApJS..182..474S',2009,1,0.78,NULL,'G',0.000156,NULL,'16.5g',0.25,'Sc',NULL,NULL,NULL,NULL,1,348.453583,13.62128,0.145,NULL,52515134755,820548980,12821077,16.5),(160523,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160523,35.92,0.2,153,75305,74.4,NULL,NULL,'2MASX J23134888+1337161',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160524,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160524,36.02,0.36,160,75305,NULL,NULL,'Malmquist cor.','2MASX J23134888+1337161',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160525,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160525,33.68,0.2,54.5,75306,74.4,NULL,NULL,'UGC 12429',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',NULL,NULL,'15.13',0.8,'Sd',NULL,NULL,NULL,NULL,1,348.456917,22.69653,0.253,NULL,52499171214,820299550,12817180,15.13),(160526,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160526,33.71,0.49,55.1,75306,75,NULL,'IR','UGC 12429',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160527,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160527,33.75,0.47,56.3,75306,NULL,NULL,NULL,'UGC 12429',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160528,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160528,33.82,0.46,58,75306,NULL,NULL,'Malmquist cor.','UGC 12429',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160529,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160529,37.48,0.46,314,75307,70,NULL,NULL,'SDSS J231351.54-082020.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000149,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,348.4647917,-8.33914,0.073,NULL,49602935514,775045867,12110091,18.4),(160530,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160530,39.96,0.15,773,75308,74.2,NULL,'SALT 2','SDSS J231351.66+011526.4',0.27,'2010ApJ...716..712A',2010,1,0.05,NULL,'G',NULL,NULL,'21.3g',0.04,NULL,NULL,NULL,NULL,NULL,1,348.46525,1.25736,0.149,NULL,51694328245,807723878,12620685,21.3),(160531,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160531,40.59,0.16,1030,75308,65,NULL,'SALT2','SDSS J231351.66+011526.4',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160532,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 06192','R',160532,40.65,0.24,1060,75308,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jy','SDSS J231351.66+011526.4',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160533,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160533,40.67,0.17,1070,75308,70,NULL,'SALT 2','SDSS J231351.66+011526.4',0.27,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160534,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160534,40.71,NULL,1090,75308,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06192, SN 2005jy','SDSS J231351.66+011526.4',0.27,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160535,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160535,40.93,0.14,1210,75308,65,NULL,'MLCS2k2','SDSS J231351.66+011526.4',0.27,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160536,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 06192','R',160536,40.96,0.16,1220,75308,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jy','SDSS J231351.66+011526.4',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160537,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160537,40.49,0.14,1250,75308,70,NULL,'SALT 2','SDSS J231351.66+011526.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160538,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160538,40.52,0.14,1270,75308,70,NULL,'SALT 2, Malmquist cor.','SDSS J231351.66+011526.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160539,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SN 2005jy',NULL,160539,41.09,0.05,1300,75308,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 06192, SN 2005jy','SDSS J231351.66+011526.4',0.27,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160540,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160540,35.44,0.57,122,75309,70,NULL,NULL,'2MFGC 17427',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.36',NULL,NULL,NULL,NULL,NULL,NULL,1,348.48075,-12.95197,0.049,NULL,50281595353,785649927,12275780,16.36),(160541,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160541,35.23,0.8,111,75310,75,NULL,'W91PP, r','UGC 12432',NULL,'1997ApJS..109..333W',1997,1,1.12,NULL,'G',0.000013,NULL,'16.0',0.15,'Sc',NULL,NULL,NULL,NULL,1,348.491583333,24.89531,0.241,NULL,51979462097,812179095,12690298,16),(160542,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160542,34.62,0.49,83.8,75310,75,NULL,'IR','UGC 12432',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160543,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160543,34.93,0.36,96.6,75310,NULL,NULL,NULL,'UGC 12432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160544,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160544,34.97,0.2,98.6,75310,74.4,NULL,NULL,'UGC 12432',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160545,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160545,34.99,0.38,99.5,75310,75,NULL,'W91PP, r, raw','UGC 12432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160546,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160546,35.06,0.34,103,75310,NULL,NULL,'Malmquist cor.','UGC 12432',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160547,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160547,35.09,0.38,104,75310,75,NULL,'W91PP, r, inv','UGC 12432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160548,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160548,35.19,0.38,109,75310,75,NULL,'W91PP, r, cor','UGC 12432',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160549,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160549,35.28,NULL,114,75310,NULL,NULL,'Dipole + Quadrupole','UGC 12432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160550,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160550,35.28,NULL,114,75310,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160551,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160551,35.29,NULL,114,75310,NULL,NULL,'Dipole','UGC 12432',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160552,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160552,35.4,NULL,120,75310,NULL,NULL,NULL,'UGC 12432',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160553,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160553,37.99,NULL,396,75311,65,NULL,'L = 10e57 photons/s','GRB 790406',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160554,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160554,38.97,NULL,622,75311,75,NULL,NULL,'GRB 790406',NULL,'1995ApJ...453..583W',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160555,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'N',160555,40.96,NULL,1550,75311,65,NULL,'L = 2 x 10e58 photons/s','GRB 790406',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160556,'GRB','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'RN',160556,43.27,NULL,4500,75311,NULL,NULL,NULL,'GRB 790406',NULL,'1992grbo.book..107S',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160557,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160557,34.36,0.5,74.5,75312,NULL,NULL,'Malmquist cor.','AGC 330128',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',NULL,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,348.519167,9.9375,0.097,NULL,51742571403,808477678,12632463,14.3),(160558,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160558,34.45,0.48,77.8,75312,NULL,NULL,NULL,'AGC 330128',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160559,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160559,34.67,0.2,85.9,75312,74.4,NULL,NULL,'AGC 330128',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160560,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160560,38.4,0.46,479,75313,70,NULL,NULL,'2MASX J23140564-1015409',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000198,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.5235417,-10.26144,0.041,NULL,49594030576,774906727,12107917,17.4),(160561,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160561,34.45,NULL,77.5,75314,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2475',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000017,NULL,'16.7',0.11,'Sd',NULL,NULL,NULL,NULL,1,348.545,34.30361,0.289,NULL,52057436559,813397446,12709335,16.7),(160562,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160562,34.45,NULL,77.7,75314,NULL,NULL,'Dipole','FGC 2475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160563,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160563,34.46,NULL,78,75314,NULL,NULL,'Dipole + Quadrupole','FGC 2475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160564,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160564,34.47,NULL,78.2,75314,NULL,NULL,NULL,'FGC 2475',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160565,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160565,34.53,0.43,80.7,75314,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2475',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160566,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,'R',160566,37.69,0.46,345,75315,70,NULL,NULL,'2MASX J23141146-0021497',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000032,NULL,'16.3g',0.32,'NLAGN',NULL,NULL,NULL,'Sy 2',1,348.547875,-0.36372,0.113,NULL,49492959344,773327489,12083242,16.3),(160567,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160567,33.44,0.57,48.6,75316,NULL,NULL,NULL,'NGC 7535',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000022,NULL,'14.24',1.5,'Sd','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,348.553208333,13.58189,0.145,NULL,52515175282,820549613,12821087,14.24),(160568,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160568,33.48,0.2,49.7,75316,74.4,NULL,NULL,'NGC 7535',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160569,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160569,33.82,0.48,58.1,75316,NULL,NULL,'Malmquist cor.','NGC 7535',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160570,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160570,33.86,0.8,59.2,75317,75,NULL,'MAT, I','NGC 7536',NULL,'1997ApJS..109..333W',1997,1,1.75,NULL,'G',0.00002,NULL,'13.9g',0.66,'SBbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,348.554917,13.42639,0.125,NULL,52516244059,820566313,12821348,13.9),(160571,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160571,33.87,0.8,59.5,75317,75,NULL,'HMCL, I','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160572,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160572,33.88,0.8,59.7,75317,75,NULL,'CF, r','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160573,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160573,33.88,0.8,59.7,75317,75,NULL,'W91CL, r','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160574,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160574,33.46,0.38,49.2,75317,75,NULL,'W91CL, r, raw','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160575,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160575,33.53,0.4,50.8,75317,75,NULL,'HMCL, I, raw','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160576,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160576,33.54,0.38,51.1,75317,75,NULL,'CF, r, raw','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160577,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160577,33.56,0.38,51.6,75317,75,NULL,'W91CL, r, inv','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160578,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160578,33.58,0.32,52,75317,85,NULL,'I, raw','NGC 7536',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160579,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160579,33.63,0.32,53.1,75317,85,NULL,'I, inv','NGC 7536',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160580,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160580,33.64,0.38,53.5,75317,75,NULL,'CF, r, inv','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160581,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160581,33.68,0.4,54.5,75317,75,NULL,'HMCL, I, inv','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160582,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160582,33.71,0.43,55.3,75317,75,NULL,'MAT, I, raw','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160583,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160583,33.72,0.38,55.6,75317,75,NULL,'W91CL, r, cor','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160584,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160584,33.74,0.38,56.1,75317,75,NULL,'CF, r, cor','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160585,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160585,33.75,0.4,56.3,75317,75,NULL,'HMCL, I, cor','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160586,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160586,33.76,0.2,56.5,75317,74.4,NULL,NULL,'NGC 7536',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160587,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160587,33.79,0.47,57.4,75317,NULL,NULL,'H','NGC 7536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160588,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160588,33.8,0.36,57.5,75317,NULL,NULL,NULL,'NGC 7536',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160589,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160589,33.88,0.45,59.7,75317,NULL,NULL,'K','NGC 7536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160590,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160590,33.89,0.4,59.9,75317,NULL,NULL,'mean','NGC 7536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160591,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160591,33.89,0.46,60.1,75317,NULL,NULL,'J','NGC 7536',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160592,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160592,33.91,0.43,60.4,75317,75,NULL,'MAT, I, cor','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160593,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160593,33.92,0.43,60.7,75317,75,NULL,'MAT, I, inv','NGC 7536',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160594,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160594,33.92,0.34,60.9,75317,NULL,NULL,'Malmquist cor.','NGC 7536',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160595,'FP','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160595,36.01,0.53,159,75318,70,NULL,NULL,'2MASX J23141587-2911593',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,348.566208333,-29.19981,NULL,NULL,50136476652,783382447,12240350,14.7),(160596,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160596,33.93,0.2,61.1,75319,74.4,NULL,NULL,'MCG -02-59-007',NULL,'2013AJ....146...86T',2013,1,1.08,NULL,'G',0.00002,NULL,'15.8g',0.38,'SB(s)m: sp',NULL,NULL,NULL,NULL,1,348.571583,-9.83619,0.049,NULL,49596055930,774938373,12108412,15.8),(160597,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13864','R',160597,40.93,0.23,1190,75320,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231417.89+001127.7',0.2931,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0005,NULL,'20.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,348.574583,0.19103,0.121,NULL,51690840297,807669379,12619834,20.7),(160598,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13864','R',160598,40.99,0.13,1220,75320,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231417.89+001127.7',0.2931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160599,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13864',NULL,160599,40.82,0.11,1460,75320,70,NULL,'SALT 2','SDSS J231417.89+001127.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160600,'SNIa','2016-12-15 15:16:04','2016-12-16 11:21:21','1','SDSS-II SN 13864',NULL,160600,40.85,0.11,1480,75320,70,NULL,'SALT 2, Malmquist cor.','SDSS J231417.89+001127.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160601,'IRAS','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160601,34.81,0.8,91.6,75321,75,NULL,'W91PP, r','UGC 12441',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.1,'SBbc?',NULL,NULL,NULL,NULL,1,348.5780417,31.12286,0.325,NULL,52066831892,813544248,12711628,16),(160602,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160602,35.04,0.38,102,75321,75,NULL,'W91PP, r, raw','UGC 12441',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160603,'Tully-Fisher','2016-12-15 15:16:04','2016-12-16 11:21:21','1',NULL,NULL,160603,35.07,0.39,103,75321,NULL,NULL,'Malmquist cor.','UGC 12441',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160604,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160604,35.07,0.38,103,75321,75,NULL,'W91PP, r, inv','UGC 12441',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160605,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160605,35.14,0.38,107,75321,NULL,NULL,NULL,'UGC 12441',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160606,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160606,35.23,0.38,111,75321,75,NULL,'W91PP, r, cor','UGC 12441',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160607,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160607,35.24,0.2,112,75321,74.4,NULL,NULL,'UGC 12441',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160608,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160608,35.28,0.52,114,75322,70,NULL,NULL,'NGC 7533',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00007,NULL,'15.7',0.4,'S0+: pec? sp',NULL,NULL,NULL,NULL,1,348.592,-2.03372,0.089,NULL,49495291599,773363931,12083811,15.7),(160609,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','PTF10qkf','N',160609,37.88,0.03,349,75323,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10qkf',0.0804,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160610,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160610,37.95,0.33,389,75324,70,NULL,NULL,'SDSS J231430.94+143113.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000163,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,348.6289583,14.5205,0.157,NULL,52526392425,820724881,12823826,17.7),(160611,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160611,37.95,0.33,389,75325,70,NULL,NULL,'2MASX J23143348+1429430',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000157,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.6395417,14.49519,0.157,NULL,52514915558,820545555,12821024,17.5),(160612,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 16396',NULL,160612,37.88,1.05,376,75326,70,NULL,'SN photometric redshift distance, z photo =0.092 +/- 0.062','SDSS-II SN 16396',NULL,'2011ApJ...738..162S',2011,1,0.12,NULL,'G',NULL,'PHOT','19.7g',0.09,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.643041667,-0.10444,0.109,NULL,49492849663,773325775,12083215,19.7),(160613,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 16396','R',160613,40.72,0.29,1070,75326,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16396',0.300839,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160614,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 16396','R',160614,40.9,0.22,1160,75326,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16396',0.300839,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160615,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160615,35.02,0.48,101,75327,NULL,NULL,'Malmquist cor.','CGCG 406-029',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000133,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,348.6427083,6.55594,0.253,NULL,51745991792,808531121,12633298,15.7),(160616,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160616,35.06,0.2,103,75327,74.4,NULL,NULL,'CGCG 406-029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160617,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160617,35.17,0.45,108,75327,NULL,NULL,NULL,'CGCG 406-029',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160618,'SNII optical','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2002gd',NULL,160618,32.63,0.06,33.6,75328,NULL,NULL,'I, photospheric magnitude method','NGC 7537',NULL,'2014AJ....148..107R',2014,1,2.2,NULL,'G',0.000013,NULL,'12.6B',0.6,'SAbc:          HII','Pair member, near/close',NULL,NULL,NULL,1,348.64375,4.49836,0.185,NULL,51766417153,808850268,12638285,12.6),(160619,'SNII optical','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2002gd',NULL,160619,32.67,0.13,34.2,75328,NULL,NULL,'V, photospheric magnitude method','NGC 7537',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160620,'SNII optical','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2002gd',NULL,160620,32.9,0.21,37.3,75328,NULL,NULL,'SEAM','NGC 7537',0.00892,'2009ApJ...694.1067P',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160621,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160621,32.6,0.8,33.1,75328,75,NULL,'A82, H','NGC 7537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160622,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160622,32.74,0.8,35.3,75328,75,NULL,'B','NGC 7537',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160623,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160623,32.39,NULL,30.1,75328,NULL,NULL,'B, Hubble-type-TF','NGC 7537',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160624,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160624,32.56,0.4,32.5,75328,NULL,NULL,'mean','NGC 7537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160625,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160625,32.59,NULL,33,75328,NULL,NULL,'B','NGC 7537',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160626,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160626,32.75,0.47,35.5,75328,75,NULL,'A82, H, raw','NGC 7537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160627,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160627,32.75,0.38,35.5,75328,NULL,NULL,NULL,'NGC 7537',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160628,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160628,32.82,0.47,36.7,75328,75,NULL,'A82, H, inv','NGC 7537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160629,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160629,32.83,0.43,36.8,75328,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7537',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160630,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160630,32.91,0.43,38.2,75328,75,NULL,'3.6 micron, color corrected','NGC 7537',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160631,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160631,32.96,0.46,39,75328,NULL,NULL,'J','NGC 7537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160632,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160632,33,0.2,39.8,75328,74.4,NULL,NULL,'NGC 7537',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160633,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160633,33.05,0.45,40.8,75328,NULL,NULL,'K','NGC 7537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160634,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160634,33.07,0.47,41.1,75328,NULL,NULL,'H','NGC 7537',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160635,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160635,33.1,0.37,41.7,75328,NULL,NULL,NULL,'NGC 7537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160636,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160636,33.13,0.47,42.2,75328,75,NULL,'A82, H, cor','NGC 7537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160637,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160637,33.35,0.33,46.7,75328,NULL,NULL,'Malmquist cor.','NGC 7537',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160638,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160638,34.5,0.47,79.6,75329,NULL,NULL,'H','NGC 7543',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'14.03',0.9,'S?',NULL,NULL,NULL,NULL,1,348.644083333,28.32722,0.317,NULL,52022387864,812849810,12700778,14.03),(160639,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160639,34.56,0.45,81.5,75329,NULL,NULL,'K','NGC 7543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160640,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160640,34.62,0.46,84,75329,NULL,NULL,'J','NGC 7543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160641,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160641,34.93,0.4,97,75329,NULL,NULL,'mean','NGC 7543',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160642,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160642,34.86,0.34,93.8,75330,NULL,NULL,NULL,'CGCG 496-067',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.000033,NULL,'15.7',0.15,'Sc',NULL,NULL,NULL,NULL,1,348.6760417,31.31758,0.289,NULL,52067035775,813547433,12711678,15.7),(160643,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160643,34.94,0.33,97.5,75330,NULL,NULL,'Malmquist cor.','CGCG 496-067',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160644,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160644,35.02,0.2,101,75330,74.4,NULL,NULL,'CGCG 496-067',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160645,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160645,35.23,0.49,111,75330,75,NULL,'IR','CGCG 496-067',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160646,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160646,37.56,0.33,325,75331,70,NULL,NULL,'2MASX J23144294+1442420',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000182,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,348.678916667,14.71167,0.165,NULL,52526408381,820725130,12823830,16.7),(160647,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160647,31.97,0.35,24.6,75332,74.2,NULL,'SALT 2','NGC 7541',0.00897,'2010ApJ...716..712A',2010,1,3.5,'Identification as NGC 7581 is doubtful.','G',0.000018,NULL,'11.3B',1.2,'SB(rs)bc: pec  HII','Pair member, near/close',NULL,NULL,NULL,1,348.682875,4.53436,0.205,NULL,51766427051,808850422,12638287,11.3),(160648,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160648,32.5,0.19,31.3,75332,72,NULL,NULL,'NGC 7541',0.00897,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160649,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160649,32.53,0.08,32.1,75332,74.4,NULL,NULL,'NGC 7541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160650,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160650,32.59,0.17,33,75332,70.8,NULL,NULL,'NGC 7541',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160651,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160651,32.7,0.38,34.4,75332,70,NULL,'SALT','NGC 7541',0.00897,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160652,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160652,32.85,0.09,36.4,75332,65,NULL,'MLCS2k2','NGC 7541',0.00897,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160653,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1998dh',NULL,160653,32.95,0.14,38.9,75332,60,NULL,NULL,'NGC 7541',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160654,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160654,32.59,0.8,33,75332,75,NULL,'A82, H','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160655,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160655,32.61,0.8,33.3,75332,75,NULL,'CF, r','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160656,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160656,32.51,0.07,31.8,75332,NULL,NULL,NULL,'NGC 7541',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160657,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160657,32.62,0.8,33.4,75332,75,NULL,'B','NGC 7541',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160658,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160658,32.07,NULL,25.9,75332,NULL,NULL,'B','NGC 7541',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160659,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160659,32.24,0.46,28.1,75332,NULL,NULL,'J','NGC 7541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160660,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160660,32.24,0.45,28.1,75332,NULL,NULL,'K','NGC 7541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160661,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160661,32.26,0.43,28.3,75332,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7541',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160662,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160662,32.31,0.47,28.9,75332,NULL,NULL,'H','NGC 7541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160663,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160663,32.33,0.49,29.3,75332,75,NULL,'IR','NGC 7541',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160664,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160664,32.35,NULL,29.5,75332,NULL,NULL,'B, Hubble-type-TF','NGC 7541',NULL,'2004ApJ...607..241R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160665,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160665,32.37,0.43,29.7,75332,75,NULL,'3.6 micron, color corrected','NGC 7541',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160666,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160666,32.46,0.38,31.1,75332,75,NULL,'CF, r, raw','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160667,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160667,32.53,0.08,32.1,75332,74.4,NULL,NULL,'NGC 7541',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160668,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160668,32.56,0.36,32.5,75332,NULL,NULL,NULL,'NGC 7541',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160669,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160669,32.57,0.4,32.6,75332,NULL,NULL,'mean','NGC 7541',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160670,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160670,32.58,0.4,32.8,75332,75,NULL,'HOSTS SN 1998dh','NGC 7541',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160671,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160671,32.64,0.38,33.7,75332,75,NULL,'CF, r, inv','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160672,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160672,32.68,0.47,34.4,75332,75,NULL,'A82, H, raw','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160673,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160673,32.71,0.38,34.9,75332,75,NULL,'CF, r, cor','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160674,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160674,32.8,0.5,36.3,75332,NULL,NULL,NULL,'NGC 7541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160675,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160675,32.85,0.49,37.1,75332,NULL,NULL,'Malmquist cor.','NGC 7541',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160676,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160676,32.88,0.47,37.7,75332,75,NULL,'A82, H, inv','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160677,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160677,33.06,0.47,40.9,75332,75,NULL,'A82, H, cor','NGC 7541',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160678,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160678,33.22,0.8,44,75333,75,NULL,'W91CL, r','UGC 12451',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000017,NULL,'15.56',0.4,'Im',NULL,NULL,NULL,NULL,1,348.68825,5.41306,0.217,NULL,51766336691,808849010,12638265,15.56),(160679,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160679,33.24,0.8,44.4,75333,75,NULL,'HMCL, I','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160680,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160680,32.63,0.2,33.6,75333,74.4,NULL,NULL,'UGC 12451',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160681,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160681,32.76,0.43,35.6,75333,75,NULL,'3.6 micron, color corrected','UGC 12451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160682,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160682,32.8,0.4,36.2,75333,75,NULL,'HMCL, I, inv','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160683,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160683,32.81,0.4,36.4,75333,75,NULL,'HMCL, I, raw','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160684,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160684,32.82,0.43,36.7,75333,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12451',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160685,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160685,32.93,0.38,38.6,75333,75,NULL,'W91CL, r, inv','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160686,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160686,33,0.38,39.8,75333,75,NULL,'W91CL, r, raw','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160687,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160687,33.08,0.4,41.3,75333,75,NULL,'HMCL, I, cor','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160688,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160688,33.27,0.38,45.1,75333,75,NULL,'W91CL, r, cor','UGC 12451',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160689,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15944',NULL,160689,40.18,0.23,1090,75334,70,NULL,'SN photometric redshift distance, z photo =0.296 +/- 0.041','SDSS-II SN 15944',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.690833,0.42672,0.105,NULL,51690715904,807667436,12619803,NULL),(160690,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15944',NULL,160690,40.63,0.14,1340,75334,70,NULL,'SALT 2','SDSS-II SN 15944',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160691,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15944',NULL,160691,40.65,0.14,1350,75334,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15944',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160692,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160692,36.07,0.2,164,75335,74.4,NULL,NULL,'UGC 12448',NULL,'2013AJ....146...86T',2013,1,1.02,NULL,'G',0.000161,NULL,'16.3g',0.23,'Scd:',NULL,NULL,NULL,NULL,1,348.696833,14.89322,0.165,NULL,52527300645,820739072,12824048,16.3),(160693,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160693,33.87,0.8,59.4,75336,75,NULL,'W91CL, r','KUG 2312+074',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000023,NULL,'15.88',0.3,'Sc',NULL,NULL,NULL,NULL,1,348.699875,7.71847,0.129,NULL,51747690266,808557660,12633713,15.88),(160694,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160694,34.11,0.2,66.4,75336,74.4,NULL,NULL,'KUG 2312+074',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160695,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160695,34.28,0.38,71.8,75336,75,NULL,'W91CL, r, inv','KUG 2312+074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160696,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160696,34.29,0.38,72,75336,75,NULL,'W91CL, r, raw','KUG 2312+074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160697,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160697,34.29,0.46,72.2,75336,NULL,NULL,'Malmquist cor.','KUG 2312+074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160698,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160698,34.31,0.45,72.6,75336,NULL,NULL,NULL,'KUG 2312+074',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160699,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160699,34.47,0.38,78.3,75336,75,NULL,'W91CL, r, cor','KUG 2312+074',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160700,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 14956','RN',160700,42.13,0.21,2050,75337,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14956',0.298447,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160701,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 14956','RN',160701,42.43,0.24,2360,75337,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14956',0.298447,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160702,'Ring Diameter','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160702,31.6,0.84,21,75338,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7531',NULL,'1981ApJS...45..541P',1981,1,4.5,'Extended HIPASS source','G',0.00001,NULL,'12.04',1.8,'SAB(r)bc','X-ray-faint group member',NULL,NULL,NULL,1,348.702083,-43.59994,NULL,NULL,50530502011,789539093,12336548,12.04),(160703,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160703,31.51,0.8,20.1,75338,75,NULL,'MAT, I','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160704,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160704,31.52,0.8,20.1,75338,75,NULL,'A82, H','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160705,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160705,32.01,0.07,25.2,75338,NULL,NULL,NULL,'NGC 7531',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160706,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160706,30.75,0.4,14.1,75338,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7531',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160707,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160707,31.14,0.47,16.9,75338,75,NULL,'A82, H, raw','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160708,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160708,31.23,0.47,17.6,75338,75,NULL,'A82, H, inv','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160709,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160709,31.43,0.4,19.3,75338,75,NULL,'B','NGC 7531',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160710,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160710,31.43,0.4,19.4,75338,NULL,NULL,'mean','NGC 7531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160711,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160711,31.46,0.47,19.6,75338,75,NULL,'A82, H, cor','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160712,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160712,31.78,0.35,22.7,75338,NULL,NULL,NULL,'NGC 7531',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160713,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160713,31.78,0.39,22.7,75338,73,NULL,'opt','NGC 7531',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160714,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160714,31.81,0.46,23,75338,NULL,NULL,'J','NGC 7531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160715,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160715,31.89,0.45,23.9,75338,NULL,NULL,'K','NGC 7531',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160716,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160716,31.99,0.32,25,75338,85,NULL,'I, raw','NGC 7531',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160717,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160717,32.02,0.43,25.3,75338,75,NULL,'3.6 micron, color corrected','NGC 7531',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160718,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160718,32.03,0.32,25.5,75338,85,NULL,'I, inv','NGC 7531',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160719,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160719,32.04,0.43,25.6,75338,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7531',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160720,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160720,32.09,0.43,26.1,75338,75,NULL,'MAT, I, raw','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160721,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160721,32.14,0.2,26.8,75338,74.4,NULL,NULL,'NGC 7531',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160722,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160722,32.28,0.43,28.6,75338,75,NULL,'MAT, I, cor','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160723,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160723,32.29,0.39,28.7,75338,73,NULL,'opt','NGC 7531',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160724,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160724,32.32,0.43,29.1,75338,75,NULL,'MAT, I, inv','NGC 7531',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160725,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160725,32.4,0.43,30.2,75338,NULL,NULL,'Malmquist cor.','NGC 7531',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160726,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160726,32.49,0.42,31.5,75338,NULL,NULL,NULL,'NGC 7531',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160727,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160727,34.74,0.53,88.8,75339,70,NULL,NULL,'CGCG 380-015',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.000096,NULL,'15.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,348.7077917,-0.24136,0.109,NULL,49492834728,773325542,12083211,15.6),(160728,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160728,37.69,0.46,345,75340,70,NULL,NULL,'2MASX J23145071-0938277',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000186,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,348.711708333,-9.64167,0.065,NULL,49596482143,774945033,12108516,17),(160729,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160729,35.22,0.49,111,75341,75,NULL,'IR','UGC 12449',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.1,'S?',NULL,NULL,NULL,NULL,1,348.721375,23.28292,0.189,NULL,52498385293,820287270,12816988,16),(160730,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160730,34.94,0.49,97.4,75342,75,NULL,'IR','ESO 604- G 006',NULL,'2011yCatp016004901K',2011,1,2.33,NULL,'G',0.00003,NULL,'14.89',0.27,'Sb',NULL,NULL,NULL,NULL,1,348.726083,-20.99586,0.09,NULL,50312465947,786132280,12283316,14.89),(160731,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160731,35.15,NULL,107,75342,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 604- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160732,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160732,35.16,0.4,108,75342,NULL,NULL,'mean','ESO 604- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160733,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160733,35.16,NULL,108,75342,NULL,NULL,'Dipole + Quadrupole','ESO 604- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160734,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160734,35.17,NULL,108,75342,NULL,NULL,'Dipole','ESO 604- G 006',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160735,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160735,35.17,0.47,108,75342,NULL,NULL,'H','ESO 604- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160736,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160736,35.27,0.45,113,75342,NULL,NULL,'K','ESO 604- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160737,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160737,35.38,0.46,119,75342,NULL,NULL,'J','ESO 604- G 006',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160738,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160738,35.23,0.52,111,75343,70,NULL,NULL,'NGC 7544',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.07',0.4,'S0o: sp',NULL,NULL,NULL,NULL,1,348.737416667,-2.19933,0.085,NULL,49628907316,775451676,12116432,16.07),(160739,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160739,37.88,0.23,376,75344,70,NULL,NULL,'2MASX J23145866+1405242',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000171,NULL,'16.7g',0.32,'BrClG',NULL,NULL,NULL,NULL,1,348.744417,14.09006,0.157,NULL,52515799905,820559373,12821240,16.7),(160740,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160740,35,0.46,99.9,75345,70,NULL,NULL,'2MASX J23145913+0112170',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000075,NULL,'15.6g',0.5,'E0',NULL,NULL,NULL,NULL,1,348.746375,1.20458,0.149,NULL,51758265871,808722904,12636295,15.6),(160741,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 07822',NULL,160741,41.47,0.07,1970,75346,70,NULL,'SN photometric redshift distance, z photo =0.642 +/- 0.030','SDSS-II SN 07822',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','22.7R',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.747917,-0.00719,0.109,NULL,49492787247,773324800,12083200,22.7),(160742,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160742,37.56,0.33,325,75347,70,NULL,NULL,'2MASX J23150009+1441002',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000163,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,348.7502917,14.6835,0.165,NULL,52527243818,820738184,12824034,17.4),(160743,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 10288','RN',160743,38.86,0.65,562,75348,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10288',0.051219,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160744,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 10288','RN',160744,41.74,0.84,2120,75348,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10288',0.051219,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160745,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160745,33.6,0.49,52.5,75349,75,NULL,'IR','UGC 12452',NULL,'2011yCatp016004901K',2011,1,2.11,NULL,'G',0.000008,NULL,'15.40',0.19,'Scd',NULL,NULL,NULL,NULL,1,348.7612083,1.43556,0.165,NULL,51761120838,808767513,12636992,15.4),(160746,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160746,33.92,NULL,60.8,75349,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160747,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160747,33.93,NULL,61,75349,NULL,NULL,'Dipole + Quadrupole','UGC 12452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160748,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160748,33.93,NULL,61.1,75349,NULL,NULL,'Dipole','UGC 12452',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160749,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160749,33.99,NULL,62.8,75349,NULL,NULL,NULL,'UGC 12452',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160750,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160750,34.19,0.2,68.9,75349,74.4,NULL,NULL,'UGC 12452',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160751,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160751,34.3,0.45,72.3,75349,NULL,NULL,NULL,'UGC 12452',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160752,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160752,34.33,0.45,73.4,75349,NULL,NULL,'Malmquist cor.','UGC 12452',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160753,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160753,36.15,0.56,170,75350,70,NULL,NULL,'2MASX J23150511-7116199',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'17.37',0.26,NULL,NULL,NULL,NULL,NULL,1,348.771417,-71.27222,0.053,NULL,48392897624,756139025,11814672,17.37),(160754,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160754,37.88,0.23,376,75351,70,NULL,NULL,'2MASX J23150746+1408152',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000158,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,348.781083,14.13761,0.157,NULL,52515390330,820552973,12821140,17.3),(160755,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160755,37.96,0.46,392,75352,70,NULL,NULL,'2MASX J23150746+1534432',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000158,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,348.781083,15.57867,0.149,NULL,52522569614,820665150,12822892,18.5),(160756,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160756,37.87,0.46,375,75353,70,NULL,NULL,'2MASX J23150769-0944347',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,348.782,-9.74314,0.061,NULL,49595894533,774935852,12108372,18),(160757,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160757,35.37,NULL,118,75354,NULL,NULL,NULL,'UGC 12458',NULL,'2000BSAO...50....5K',2000,1,1.08,NULL,'G',0.000007,NULL,'16.5',0.13,'Sc',NULL,NULL,NULL,NULL,1,348.786916667,30.94664,0.289,NULL,52066700459,813542194,12711596,16.5),(160758,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160758,35.44,0.43,123,75354,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12458',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160759,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160759,35.58,0.43,131,75354,75,NULL,'3.6 micron, color corrected','UGC 12458',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160760,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160760,35.6,NULL,132,75354,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160761,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160761,35.61,NULL,133,75354,NULL,NULL,'Dipole + Quadrupole','UGC 12458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160762,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160762,35.63,NULL,134,75354,NULL,NULL,'Dipole','UGC 12458',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160763,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160763,35.76,0.45,142,75354,NULL,NULL,'Malmquist cor.','UGC 12458',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160764,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160764,35.87,0.2,149,75354,74.4,NULL,NULL,'UGC 12458',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160765,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160765,36.04,0.4,162,75354,NULL,NULL,NULL,'UGC 12458',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160766,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199',NULL,160766,39.61,0.25,837,75355,70,NULL,'SN photometric redshift distance, z photo =0.219 +/- 0.031','SDSS-II SN 05199',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.792417,-0.99494,0.077,NULL,49627427009,775428547,12116071,NULL),(160767,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199','R',160767,40.51,0.23,1030,75355,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05199',0.221952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160768,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199','R',160768,40.52,0.18,1040,75355,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05199',0.221952,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160769,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199',NULL,160769,40.35,0.13,1170,75355,70,NULL,'SALT 2','SDSS-II SN 05199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160770,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 05199',NULL,160770,40.36,0.13,1180,75355,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160771,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160771,31.9,NULL,24,75356,NULL,NULL,NULL,'ESO 407- G 012',NULL,'2000BSAO...50....5K',2000,1,1.1,'2000A&AS..143..421M has z = 0.02001 +- 0.00009.','G',0.00015,NULL,'16.60',0.11,'Irr',NULL,NULL,NULL,NULL,1,348.794083,-33.25272,NULL,NULL,50160452088,783757063,12246204,16.6),(160772,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160772,33.03,0.8,40.3,75357,75,NULL,'MAT, I','ESO 239- G 017',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000021,NULL,'13.41',1.4,'SAB(s)d',NULL,NULL,NULL,NULL,1,348.799625,-49.39792,0,NULL,50504245693,789128838,12330138,13.41),(160773,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160773,32.36,0.32,29.6,75357,85,NULL,'I, inv','ESO 239- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160774,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160774,32.38,0.32,29.9,75357,85,NULL,'I, raw','ESO 239- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160775,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160775,32.99,0.43,39.7,75357,75,NULL,'MAT, I, raw','ESO 239- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160776,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160776,33,0.43,39.7,75357,75,NULL,'MAT, I, inv','ESO 239- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160777,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160777,33.12,0.43,42,75357,75,NULL,'MAT, I, cor','ESO 239- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160778,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160778,35.61,0.17,127,75358,74.2,NULL,'SALT 2','ESO 291- G 011',0.043,'2010ApJ...716..712A',2010,1,1.1,NULL,'G',0.000183,NULL,'15.23',0.8,'(R\'_1)SB(s)0/a',NULL,NULL,NULL,NULL,1,348.8000417,-44.73672,NULL,NULL,50532283026,789566922,12336983,15.23),(160779,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160779,36.2,0.19,167,75358,72,NULL,NULL,'ESO 291- G 011',0.043,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160780,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160780,36.26,0.15,171,75358,65,NULL,'MLCS','ESO 291- G 011',0.043,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160781,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160781,36.18,0.08,172,75358,74.4,NULL,NULL,'ESO 291- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160782,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160782,36.28,0.06,173,75358,70,NULL,NULL,'ESO 291- G 011',0.043,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160783,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160783,36.28,0.21,173,75358,65,NULL,'SALT2','ESO 291- G 011',0.043,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160784,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160784,36.3,0.18,175,75358,70,NULL,'SALT 2','ESO 291- G 011',0.043,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160785,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160785,36.34,0.03,178,75358,72,NULL,NULL,'ESO 291- G 011',0.043,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160786,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160786,36.34,0.2,178,75358,73.8,NULL,'SALT 2 (SNANA)','ESO 291- G 011',0.0424,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160787,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160787,36.36,0.15,179,75358,70,NULL,'SALT','ESO 291- G 011',0.043,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160788,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160788,36.5,0.12,183,75358,65,NULL,'MLCS2k2','ESO 291- G 011',0.043,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160789,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160789,36.42,0.1,184,75358,65,NULL,'MLCS2k2','ESO 291- G 011',0.043,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160790,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160790,36.34,0.17,185,75358,70.8,NULL,NULL,'ESO 291- G 011',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160791,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160791,36.46,0.18,188,75358,65,NULL,'MLCS17','ESO 291- G 011',0.043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160792,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160792,36.49,0.13,190,75358,65,NULL,'MLCS2k2','ESO 291- G 011',0.043,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160793,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160793,36.5,0.2,191,75358,65,NULL,'SALT2','ESO 291- G 011',0.043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160794,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160794,36.52,0.17,193,75358,65,NULL,'MLCS31','ESO 291- G 011',0.043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160795,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160795,36.52,0.14,193,75358,65,NULL,'SALT','ESO 291- G 011',0.043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160796,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160796,36.53,0.2,194,75358,65,NULL,'Template','ESO 291- G 011',0.043,'1998AJ....116.1009R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160797,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160797,36.53,0.19,194,75358,65,NULL,NULL,'ESO 291- G 011',0.043,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160798,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160798,36.53,0.05,194,75358,65,NULL,'SALT','ESO 291- G 011',0.043,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160799,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160799,36.7,0.05,210,75358,70,NULL,'SALT 2','ESO 291- G 011',0.043,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160800,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160800,36.69,0.14,218,75358,60,NULL,NULL,'ESO 291- G 011',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160801,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160801,36.74,0.08,223,75358,60,NULL,'M(B) = -19.48 mag','ESO 291- G 011',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160802,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160802,36.76,0.07,225,75358,60,NULL,'M(V) = -19.47 mag','ESO 291- G 011',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160803,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 1992bl',NULL,160803,36.78,0.06,227,75358,60,NULL,'M(I) = -19.19 mag','ESO 291- G 011',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160804,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160804,35.3,0.46,115,75359,70,NULL,NULL,'III Zw 097',NULL,'2015arXiv151105856S',2015,1,1.3,NULL,'G',0.00012,NULL,'15.4',0.5,NULL,NULL,NULL,NULL,NULL,1,348.809375,-1.24219,0.093,NULL,49627311024,775426734,12116042,15.4),(160805,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160805,35.63,0.5,133,75359,70,NULL,NULL,'III Zw 097',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160806,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 07824','R',160806,40.83,0.25,1140,75360,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07824',0.2871,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,348.813,-0.08092,0.109,NULL,49627007834,775421997,12115968,NULL),(160807,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 07824','R',160807,41.06,0.18,1270,75360,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07824',0.2871,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160808,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160808,33.99,0.45,62.9,75361,NULL,NULL,'K','NGC 7550',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.000067,NULL,'13.16',1.2,'SA0-           AGN','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,348.816708333,18.96181,0.181,NULL,52500374043,820318344,12817474,13.16),(160809,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160809,34.09,0.4,65.7,75361,NULL,NULL,'mean','NGC 7550',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160810,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2009nq',NULL,160810,34.22,0.26,68.7,75362,73.8,NULL,'SALT 2 (SNANA)','NGC 7549',0.0145,'2014ApJ...795...44R',2014,1,2.8,'Identified as NGC 7594 in Hickson et al.(1989:Ap.J.Suppl. 70,687).','G',0.000011,NULL,'13.74',0.7,'SB(s)cd pec    AGN','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,348.8217917,19.04169,0.181,NULL,52500371363,820318302,12817473,13.74),(160811,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160811,33.39,0.47,47.7,75362,NULL,NULL,'H','NGC 7549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160812,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160812,33.55,0.46,51.3,75362,NULL,NULL,'J','NGC 7549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160813,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160813,33.56,0.45,51.5,75362,NULL,NULL,'K','NGC 7549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160814,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160814,33.88,0.4,59.7,75362,NULL,NULL,'mean','NGC 7549',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160815,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160815,35.29,0.52,115,75363,70,NULL,NULL,'ESO 604- G 007',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.39',0.2,'Sb:',NULL,NULL,NULL,NULL,1,348.8227083,-21.36628,0.078,NULL,50314427816,786162934,12283795,15.39),(160816,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160816,35.09,0.49,104,75363,75,NULL,'IR','ESO 604- G 007',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160817,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SN 2006ln',NULL,160817,39.31,0.1,728,75364,70,NULL,'Hubble residual -0.41 for z0.23200','SDSS-II SN 15369 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,348.8330417,-0.56269,0.109,NULL,49627134921,775423983,12115999,NULL),(160818,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15369','R',160818,39.94,0.2,791,75364,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ln','SDSS-II SN 15369 HOST',0.232,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160819,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 15369','R',160819,40.1,0.1,850,75364,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ln','SDSS-II SN 15369 HOST',0.232,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160820,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160820,35.13,0.76,106,75365,NULL,NULL,'Malmquist cor.','CGCG 454-014',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000067,NULL,'15.7',0.4,NULL,NULL,NULL,NULL,NULL,1,348.838083,16.04258,0.165,NULL,52524378060,820693407,12823334,15.7),(160821,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160821,35.17,0.75,108,75365,NULL,NULL,NULL,'CGCG 454-014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160822,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160822,35.21,0.2,110,75365,74.4,NULL,NULL,'CGCG 454-014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160823,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160823,37.88,0.23,376,75366,70,NULL,NULL,'2MASX J23152236+1358491',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000169,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,348.843333,13.98039,0.165,NULL,52515477181,820554330,12821161,18.1),(160824,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160824,37.88,0.23,376,75367,70,NULL,NULL,'2MASX J23152589+1409041',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000166,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,348.858125,14.15125,0.157,NULL,52515507216,820554800,12821168,18),(160825,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160825,36.31,0.46,182,75368,70,NULL,NULL,'2MASX J23152844-0935524',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,348.8684583,-9.59806,0.069,NULL,49596582565,774946602,12108540,16.6),(160826,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160826,36.23,0.46,176,75369,70,NULL,NULL,'2MASX J23153092+1340402',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000186,NULL,'15.4g',0.48,'E0',NULL,NULL,NULL,NULL,1,348.878917,13.67797,0.129,NULL,52516751933,820574248,12821472,15.4),(160827,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160827,38.1,0.46,417,75370,70,NULL,NULL,'2MASX J23153120-1039494',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,348.8799583,-10.66364,0.069,NULL,49594116103,774908064,12107938,17.3),(160828,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13465',NULL,160828,39.99,0.3,995,75371,70,NULL,'SN photometric redshift distance, z photo =0.267 +/- 0.047','SDSS-II SN 13465',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.88275,0.01614,0.109,NULL,51573169563,805830774,12591105,21.5),(160829,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13465','R',160829,40.93,0.32,1190,75371,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13465',0.286372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160830,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13465','R',160830,41.05,0.29,1260,75371,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13465',0.286372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160831,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160831,35.6,0.2,132,75372,74.4,NULL,NULL,'CGCG 406-036',NULL,'2013AJ....146...86T',2013,1,0.7,'NGC 7564 is a star.','G',0.00024,NULL,'15.5',0.3,'Merger?',NULL,NULL,NULL,NULL,1,348.91,7.31167,0.157,NULL,51748778591,808574665,12633979,15.5),(160832,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160832,36.25,0.46,178,75373,70,NULL,NULL,'2MASX J23153845+0101313',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',NULL,NULL,'16.6g',0.29,'AGN',NULL,NULL,NULL,NULL,1,348.910166667,1.02542,0.133,NULL,51758323341,808723802,12636309,16.6),(160833,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160833,35.12,0.8,106,75374,75,NULL,'W91PP, r','UGC 12459',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00001,NULL,'15.43',0.4,'Sbc',NULL,NULL,NULL,NULL,1,348.9135,24.89869,0.261,NULL,51979904573,812186008,12690406,15.43),(160834,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160834,34.54,0.52,81.1,75374,NULL,NULL,NULL,'UGC 12459',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160835,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160835,34.59,0.2,82.8,75374,74.4,NULL,NULL,'UGC 12459',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160836,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160836,34.72,0.38,87.9,75374,75,NULL,'W91PP, r, raw','UGC 12459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160837,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160837,34.77,0.38,90,75374,75,NULL,'W91PP, r, inv','UGC 12459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160838,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160838,34.78,0.47,90.4,75374,NULL,NULL,'Malmquist cor.','UGC 12459',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160839,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160839,35,0.38,100,75374,75,NULL,'W91PP, r, cor','UGC 12459',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160840,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 10291','RN',160840,40.23,0.57,1040,75375,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10291',0.068972,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160841,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160841,37.71,0.46,348,75376,70,NULL,NULL,'2MASX J23154166+0039523',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,348.9235417,0.66467,0.137,NULL,51757881095,808716892,12636201,17.1),(160842,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160842,38.6,0.46,524,75377,70,NULL,NULL,'2MASX J23154207-0026065',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000106,NULL,'17.1g',0.09,'FR II          AGN',NULL,NULL,NULL,NULL,1,348.9254583,-0.43531,0.097,NULL,49627251792,775425809,12116028,17.1),(160843,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160843,34.53,0.2,80.5,75378,74.4,NULL,NULL,'CGCG 380-018',NULL,'2013AJ....146...86T',2013,1,0.78,NULL,'G',0.000063,NULL,'14.7g',0.61,'Sb',NULL,NULL,NULL,NULL,1,348.929958333,0.41697,0.113,NULL,51757959524,808718117,12636220,14.7),(160844,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160844,35.15,0.8,107,75379,75,NULL,'W91PP, r','IC 5296',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000023,NULL,'15.28',0.6,'SBb','Group member',NULL,NULL,NULL,1,348.932417,25.09453,0.301,NULL,51979412473,812178319,12690286,15.28),(160845,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160845,34.66,0.49,85.7,75379,NULL,NULL,NULL,'IC 5296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160846,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160846,34.82,0.2,92,75379,74.4,NULL,NULL,'IC 5296',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160847,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160847,34.9,0.38,95.6,75379,75,NULL,'W91PP, r, raw','IC 5296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160848,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160848,34.91,0.43,96,75379,NULL,NULL,'Malmquist cor.','IC 5296',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160849,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160849,35.03,0.38,101,75379,75,NULL,'W91PP, r, inv','IC 5296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160850,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160850,35.13,0.38,106,75379,75,NULL,'W91PP, r, cor','IC 5296',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160851,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 17244','R',160851,38.59,0.22,505,75380,70,NULL,'SDSS CAND. SNII; SALT 2','SN 2007ib',0.03416,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,348.935666667,0.45711,0.137,NULL,51757971280,808718301,12636223,NULL),(160852,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160852,36.3,0.57,182,75381,70,NULL,NULL,'2MASX J23154473-0215515',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.65',0.31,NULL,NULL,NULL,NULL,NULL,1,348.9364583,-2.26431,0.085,NULL,49628956085,775452438,12116444,16.65),(160853,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160853,33.69,0.46,54.8,75382,70,NULL,NULL,'NGC 7559B',NULL,'2015arXiv151105856S',2015,1,1.11,NULL,'G',0.00004,NULL,'13.9g',1.02,'E0',NULL,NULL,NULL,NULL,1,348.944,13.29028,0.125,NULL,52516665135,820572892,12821451,13.9),(160854,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160854,35.12,0.49,106,75383,70,NULL,NULL,'2MASX J23154833-0223565',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'15.88',0.31,NULL,NULL,NULL,NULL,NULL,1,348.9515417,-2.39908,0.085,NULL,49628935547,775452117,12116439,15.88),(160855,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160855,36.02,0.37,160,75384,NULL,NULL,'Malmquist cor.','MCG +03-59-017',NULL,'2009ApJS..182..474S',2009,1,0.75,NULL,'G',0.000033,NULL,'16',0.3,NULL,NULL,NULL,NULL,NULL,1,348.952333333,15.88678,0.165,NULL,52522625003,820666015,12822906,16),(160856,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160856,36.1,0.36,166,75384,NULL,NULL,NULL,'MCG +03-59-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160857,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160857,36.19,0.2,173,75384,74.4,NULL,NULL,'MCG +03-59-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160858,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160858,37.63,0.27,336,75385,70,NULL,NULL,'2MASX J23154981-1025598',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000178,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,348.957417,-10.43336,0.045,NULL,49596947585,774952306,12108629,17.4),(160859,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160859,36.85,0.46,234,75386,70,NULL,NULL,'2MASX J23155137+1528343',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000154,NULL,'16.4g',0.31,NULL,NULL,NULL,NULL,NULL,1,348.9642083,15.47622,0.165,NULL,52526951120,820733611,12823962,16.4),(160860,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301',NULL,160860,40.06,0.33,1030,75387,70,NULL,'SN photometric redshift distance, z photo =0.278 +/- 0.055','SDSS-II SN 18301',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.7g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,348.9667083,0.81556,0.133,NULL,51758626576,808728540,12636383,20.7),(160861,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301',NULL,160861,40.16,0.33,1080,75387,70,NULL,NULL,'SDSS-II SN 18301',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160862,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301','R',160862,40.91,0.28,1140,75387,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18301',0.331565,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160863,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301','R',160863,41.07,0.33,1230,75387,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18301',0.331565,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160864,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301',NULL,160864,40.93,0.22,1530,75387,70,NULL,'SALT 2','SDSS-II SN 18301',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160865,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 18301',NULL,160865,40.97,0.22,1560,75387,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18301',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160866,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902',NULL,160866,40.23,0.21,1110,75388,70,NULL,'SN photometric redshift distance, z photo =0.305 +/- 0.037','SDSS-II SN 13902',NULL,'2011ApJ...738..162S',2011,1,0.04,NULL,'G',NULL,'PHOT','22.2g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,348.972625,0.25219,0.113,NULL,51757737308,808714645,12636166,22.2),(160867,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902','R',160867,41.39,0.35,1430,75388,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13902',0.325011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160868,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902','R',160868,41.58,0.35,1560,75388,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13902',0.325011,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160869,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902',NULL,160869,41.14,0.22,1690,75388,70,NULL,'SALT 2','SDSS-II SN 13902',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160870,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 13902',NULL,160870,41.18,0.22,1720,75388,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13902',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160871,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160871,35.55,0.5,129,75389,70,NULL,NULL,'2MFGC 17457',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.000093,NULL,'15.98',0.28,'S',NULL,NULL,NULL,NULL,1,348.975875,-48.3535,0,NULL,50504080890,789126263,12330097,15.98),(160872,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160872,33.82,0.4,58.2,75390,NULL,NULL,'mean','NGC 7563',NULL,'2007A&A...465...71T',2007,1,1.81,NULL,'G',0.00008,NULL,'13.5g',0.79,'SBa','in a radial-velocity based grouping',NULL,NULL,NULL,1,348.9830417,13.19611,0.125,NULL,52516682233,820573159,12821455,13.5),(160873,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160873,33.86,0.47,59.1,75390,NULL,NULL,'H','NGC 7563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160874,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160874,33.86,0.45,59.2,75390,NULL,NULL,'K','NGC 7563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160875,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160875,33.92,0.46,60.8,75390,NULL,NULL,'J','NGC 7563',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160876,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,'R',160876,37.91,0.46,382,75391,70,NULL,NULL,'2MASX J23155645-1037128',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00016,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,348.9852917,-10.62017,0.069,NULL,49596940019,774952187,12108627,18.3),(160877,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160877,33.79,0.84,57.3,75392,NULL,NULL,'I','NGC 7562',NULL,'2001ApJ...546..681T',2001,1,2.2,NULL,'G',0.000017,NULL,'12.63',1.5,'E2-3           BLLAC','in a radial-velocity based grouping',NULL,NULL,NULL,1,348.989583,6.68753,0.217,NULL,51746174613,808533978,12633343,12.63),(160878,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160878,33.86,0.14,59.2,75392,74.4,NULL,NULL,'NGC 7562',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160879,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160879,33.21,0.4,43.8,75392,75,NULL,'Edat, raw','NGC 7562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160880,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160880,33.3,0.4,45.6,75392,75,NULL,'Edat, cor','NGC 7562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160881,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160881,32.57,0.49,32.7,75392,95,NULL,'de Vaucouleurs','NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160882,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160882,32.66,0.33,34,75392,95,NULL,'Weighted Mean','NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160883,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160883,32.9,0.63,38,75392,95,NULL,'Michard 1979b, c','NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160884,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160884,33.29,0.46,45.5,75392,95,NULL,'Michard 1979a','NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160885,'Tertiary','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160885,33.11,0.5,41.9,75392,95,NULL,NULL,'NGC 7562',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160886,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160886,33.25,0.45,44.6,75392,NULL,NULL,'K','NGC 7562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160887,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160887,33.42,0.4,48.2,75392,NULL,NULL,'mean','NGC 7562',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160888,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 19657',NULL,160888,39.32,1.11,731,75393,70,NULL,'SN photometric redshift distance, z photo =0.188 +/- 0.151','SDSS-II SN 19657',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.4g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,348.992167,-0.38078,0.085,NULL,49627224753,775425386,12116021,20.4),(160889,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 19657','R',160889,40.15,0.23,801,75393,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19657',0.337755,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160890,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:21','1','SDSS-II SN 19657','R',160890,40.62,0.33,994,75393,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19657',0.337755,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160891,'FP','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160891,35.41,0.64,121,75394,70,NULL,NULL,'2MASX J23155923-0415175',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.96',0.35,NULL,NULL,NULL,NULL,NULL,1,348.996625,-4.25478,0.133,NULL,49633671684,775526120,12117595,15.96),(160892,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160892,34.51,0.69,79.7,75395,100,NULL,'mid-IR','UGC 12466',NULL,'2013ApJ...771...88L',2013,1,1,NULL,'G',0.000043,NULL,'14.9',0.6,'SBb            HII',NULL,NULL,NULL,NULL,1,348.99725,-1.84625,0.085,NULL,49628804590,775450071,12116407,14.9),(160893,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:21','1',NULL,NULL,160893,35.11,0.4,105,75395,NULL,NULL,'mean','UGC 12466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160894,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160894,35.32,0.47,116,75395,NULL,NULL,'H','UGC 12466',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160895,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160895,37.63,0.27,336,75396,70,NULL,NULL,'2MASX J23155991-1025378',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.00015,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,348.999583,-10.42722,0.07,NULL,49596955449,774952428,12108631,16.5),(160896,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160896,33.14,0.8,42.5,75397,75,NULL,'W91CL, r','NGC 7562A',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000013,NULL,'15.53',0.4,'Sdm: sp','in a pair',NULL,NULL,NULL,1,349.006083,6.65228,0.217,NULL,51746172734,808533948,12633342,15.53),(160897,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160897,33.15,0.8,42.7,75397,75,NULL,'HMCL, I','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160898,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160898,33.16,0.8,42.8,75397,75,NULL,'MAT, I','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160899,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160899,32.84,0.2,37,75397,74.4,NULL,NULL,'NGC 7562A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160900,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160900,32.98,0.32,39.4,75397,85,NULL,'I, inv','NGC 7562A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160901,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160901,32.98,0.43,39.5,75397,75,NULL,'3.6 micron, color corrected','NGC 7562A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160902,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160902,32.98,0.32,39.5,75397,85,NULL,'I, raw','NGC 7562A',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160903,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160903,33,0.4,39.7,75397,75,NULL,'HMCL, I, raw','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160904,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160904,33.03,0.4,40.4,75397,75,NULL,'HMCL, I, inv','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160905,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160905,33.08,0.43,41.4,75397,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7562A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160906,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160906,33.28,0.43,45.4,75397,75,NULL,'MAT, I, raw','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160907,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160907,33.29,0.4,45.4,75397,75,NULL,'HMCL, I, cor','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160908,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160908,33.32,0.43,46.2,75397,75,NULL,'MAT, I, inv','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160909,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160909,33.4,0.38,47.9,75397,75,NULL,'W91CL, r, inv','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160910,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160910,33.42,0.38,48.3,75397,75,NULL,'W91CL, r, raw','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160911,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160911,33.63,0.43,53.2,75397,75,NULL,'MAT, I, cor','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160912,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160912,33.69,0.38,54.7,75397,75,NULL,'W91CL, r, cor','NGC 7562A',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160913,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160913,37.63,0.27,336,75398,70,NULL,NULL,'2MASX J23160303-1025138',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000095,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,349.0127083,-10.42047,0.07,NULL,49596941713,774952214,12108628,17.4),(160914,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160914,37.06,0.46,259,75399,70,NULL,NULL,'2MASX J23160617+1510146',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000221,NULL,'17.7g',0.16,NULL,NULL,NULL,NULL,NULL,1,349.025667,15.17061,0.129,NULL,52527336192,820739628,12824056,17.7),(160915,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160915,35.75,0.58,141,75400,70,NULL,NULL,'LCRS B231321.0-445829',NULL,'2014MNRAS.445.2677S',2014,1,0.77,NULL,'G',0.000133,NULL,'15.5',0.62,'E',NULL,NULL,NULL,NULL,1,349.0327917,-44.70222,NULL,NULL,50532308819,789567325,12336989,15.5),(160916,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160916,32.53,0.49,32,75401,75,NULL,'IR','NGC 7567',NULL,'2011yCatp016004901K',2011,1,0.9,'Beers, et al. (1991,AJ,102,1581) give v=12110 +/- 59 km/sec.','G',0.000017,NULL,'15.38',0.2,'Irr','Group member',NULL,NULL,NULL,1,349.042833,15.85003,0.153,NULL,52522438486,820663101,12822860,15.38),(160917,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160917,30.85,NULL,14.8,75402,NULL,NULL,'B','NGC 7552',NULL,'2002ApJ...565..681R',2002,1,3.4,'Confused HIPASS source','G',0.000017,NULL,'11.25',2.7,'(R\')SB(s)ab;HIILINER','X-ray-faint group member',NULL,NULL,'H II',1,349.044833,-42.58475,NULL,NULL,50526093940,789470217,12335472,11.25),(160918,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160918,31.45,0.4,19.5,75402,75,NULL,'B','NGC 7552',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160919,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160919,37.71,0.46,349,75403,70,NULL,NULL,'2MASX J23161160+1410316',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000165,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,349.048458333,14.17533,0.129,NULL,52515562709,820555667,12821182,17.4),(160920,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21069','RN',160920,42.69,0.35,2340,75404,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21069',0.473334,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160921,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21069','N',160921,42.72,0.23,3500,75404,70,NULL,'SALT 2','SDSS-II SN 21069',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160922,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21069','N',160922,42.83,0.23,3680,75404,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21069',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160923,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160923,37.48,0.46,313,75405,70,NULL,NULL,'2MASX J23161565+1359297',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000161,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,349.065375,13.99144,0.121,NULL,52515468475,820554194,12821159,17.2),(160924,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160924,37.12,0.46,266,75406,70,NULL,NULL,'2MASX J23161803-1049231',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.000095,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,349.075375,-10.82306,0.075,NULL,49593780013,774902812,12107856,15.8),(160925,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 03227','RN',160925,43.35,0.2,3320,75407,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03227',0.411614,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160926,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 03227','RN',160926,44.43,0.33,5450,75407,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03227',0.411614,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160927,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160927,35.23,0.8,111,75408,75,NULL,'MAT, I','NGC 7568',NULL,'1997ApJS..109..333W',1997,1,0.9,'Identification as NGC 7574 is doubtful.','G',0.000027,NULL,'14.52',0.5,'S?','in a radial-velocity based grouping',NULL,NULL,NULL,1,349.103625,24.49703,0.249,NULL,51979867165,812185424,12690397,14.52),(160928,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160928,35.24,0.8,112,75408,75,NULL,'W91PP, r','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160929,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160929,35.1,0.38,105,75408,75,NULL,'W91PP, r, raw','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160930,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160930,35.17,0.43,108,75408,75,NULL,'MAT, I, raw','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160931,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160931,35.21,0.32,110,75408,85,NULL,'I, raw','NGC 7568',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160932,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160932,35.23,0.39,111,75408,NULL,NULL,'Malmquist cor.','NGC 7568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160933,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160933,35.27,0.38,113,75408,NULL,NULL,NULL,'NGC 7568',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160934,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160934,35.28,0.32,114,75408,85,NULL,'I, inv','NGC 7568',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160935,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160935,35.28,0.38,114,75408,75,NULL,'W91PP, r, cor','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160936,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160936,35.31,0.38,116,75408,75,NULL,'W91PP, r, inv','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160937,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160937,35.4,0.43,120,75408,75,NULL,'MAT, I, cor','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160938,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160938,35.45,0.43,123,75408,75,NULL,'MAT, I, inv','NGC 7568',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160939,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160939,35.47,0.2,124,75408,74.4,NULL,NULL,'NGC 7568',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160940,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160940,35.47,0.49,124,75409,75,NULL,'IR','2MFGC 17463',NULL,'2011yCatp016004901K',2011,1,0.62,NULL,'G',0.000033,NULL,'16.5V',NULL,'Sc',NULL,NULL,NULL,NULL,1,349.105583,18.47067,0.189,NULL,52532948831,820827325,12825426,16.5),(160941,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160941,35.63,0.57,134,75409,NULL,NULL,NULL,'2MFGC 17463',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160942,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160942,35.67,0.2,136,75409,74.4,NULL,NULL,'2MFGC 17463',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160943,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160943,35.84,0.52,147,75409,NULL,NULL,'Malmquist cor.','2MFGC 17463',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160944,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06003','RN',160944,43.22,0.24,2990,75410,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06003',0.47867,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160945,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160945,32.28,0.2,28.6,75411,74.4,NULL,NULL,'UGC 12471',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000017,NULL,'16.0',0.2,'S',NULL,NULL,NULL,NULL,1,349.117875,18.5625,0.189,NULL,52532992264,820828004,12825437,16),(160946,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160946,32.57,0.7,32.7,75411,NULL,NULL,NULL,'UGC 12471',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160947,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160947,32.9,0.6,38.1,75411,NULL,NULL,'Malmquist cor.','UGC 12471',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160948,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007qi',NULL,160948,40.09,0.15,1040,75412,70,NULL,'Hubble residual 0.04 for z0.27640','SDSS J231628.81-000556.0',NULL,'2011ApJ...740...92G',2011,1,0.09,NULL,'G',0.0005,NULL,'20.5g',0.07,NULL,NULL,NULL,NULL,NULL,1,349.1200417,-0.09892,0.109,NULL,49409128642,772017635,12062775,20.5),(160949,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 20227','R',160949,40.8,0.23,1130,75412,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qi','SDSS J231628.81-000556.0',0.2764,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160950,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007qi',NULL,160950,40.6,0.13,1320,75412,70,NULL,'SALT 2','SDSS J231628.81-000556.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160951,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007qi',NULL,160951,40.63,0.13,1340,75412,70,NULL,'SALT 2, Malmquist cor.','SDSS J231628.81-000556.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160952,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 20227','R',160952,41.17,0.17,1350,75412,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qi','SDSS J231628.81-000556.0',0.2764,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160953,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160953,33,0.49,39.8,75413,75,NULL,'IR','KUG 2313+117',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'15.6',0.2,'Spiral',NULL,NULL,NULL,NULL,1,349.1287917,12.05114,0.105,NULL,51624410195,806631409,12603615,15.6),(160954,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160954,39.07,0.03,547,75414,70,NULL,'SDSS-II SN 06422','SDSS J231633.32-003948.3',0.19,'2011ApJS..192....1C',2011,1,0.08,NULL,'G',NULL,NULL,'21.2g',0.04,NULL,NULL,NULL,NULL,NULL,1,349.138833,-0.66344,0.097,NULL,49627184365,775424755,12116011,21.2),(160955,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160955,39.09,0.11,553,75414,74.2,NULL,'SALT 2','SDSS J231633.32-003948.3',0.19,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160956,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160956,39.78,0.12,760,75414,70,NULL,'SDSS-II SN 06422, SALT 2','SDSS J231633.32-003948.3',0.19,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160957,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06422','R',160957,39.82,0.18,772,75414,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005id','SDSS J231633.32-003948.3',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160958,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160958,39.82,0.07,775,75414,65,NULL,'SALT2','SDSS J231633.32-003948.3',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160959,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160959,39.99,0.07,838,75414,65,NULL,'MLCS2k2','SDSS J231633.32-003948.3',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160960,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06422','R',160960,40.09,0.08,876,75414,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005id','SDSS J231633.32-003948.3',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160961,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160961,39.73,0.07,883,75414,70,NULL,'SALT 2','SDSS J231633.32-003948.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160962,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005id',NULL,160962,39.74,0.07,887,75414,70,NULL,'SALT 2, Malmquist cor.','SDSS J231633.32-003948.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160963,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15081','RN',160963,40.96,0.18,1320,75415,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15081',0.18222,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160964,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15081','RN',160964,41.69,0.23,1850,75415,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15081',0.18222,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160965,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160965,34.94,0.47,97.4,75416,NULL,NULL,'H','NGC 7566',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000073,NULL,'14.27',0.7,'(R\')SB(rs)apec?Sy2',NULL,NULL,NULL,'Sy 2',1,349.1559583,-2.33056,0.085,NULL,49629089305,775454520,12116476,14.27),(160966,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160966,34.97,0.45,98.8,75416,NULL,NULL,'K','NGC 7566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160967,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160967,35,0.46,100,75416,NULL,NULL,'J','NGC 7566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160968,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160968,35.14,0.4,107,75416,NULL,NULL,'mean','NGC 7566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160969,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160969,35.23,0.2,111,75417,74.4,NULL,NULL,'CGCG 454-019',NULL,'2013AJ....146...86T',2013,1,0.6,'Beers, et al. (1991,AJ,102,1581) give v=4217 +/- 36 km/sec.','G',0.000033,NULL,'15.46',0.2,'S?','Group member',NULL,NULL,NULL,1,349.1605,15.89764,0.153,NULL,52522439738,820663120,12822861,15.46),(160970,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160970,35.24,0.41,112,75417,NULL,NULL,NULL,'CGCG 454-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160971,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160971,35.24,0.41,112,75417,NULL,NULL,'Malmquist cor.','CGCG 454-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160972,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12199','RN',160972,40.9,0.28,1160,75418,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12199',0.310404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160973,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12199','RN',160973,41.17,0.28,1310,75418,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12199',0.310404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160974,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12199','N',160974,41.08,0.23,1640,75418,70,NULL,'SALT 2','SDSS-II SN 12199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160975,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12199','N',160975,41.12,0.23,1670,75418,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 12199',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160976,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160976,33.12,0.47,42.2,75419,NULL,NULL,'H','UGC 12474',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000067,NULL,'14.24',0.4,'Sa','Isolated galaxy',NULL,NULL,NULL,1,349.180167,33.99581,0.261,NULL,52052870001,813326093,12708220,14.24),(160977,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160977,33.18,0.45,43.3,75419,NULL,NULL,'K','UGC 12474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160978,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160978,33.37,0.46,47.2,75419,NULL,NULL,'J','UGC 12474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160979,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160979,34.18,0.4,68.5,75419,NULL,NULL,'mean','UGC 12474',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160980,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160980,35.01,0.4,100,75420,NULL,NULL,'mean','ARK 579',NULL,'2007A&A...465...71T',2007,1,0.4,NULL,'G',0.000033,NULL,'15.72',0.2,'S?',NULL,NULL,NULL,NULL,1,349.182083,29.58756,0.265,NULL,52065202554,813518789,12711231,15.72),(160981,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160981,36.09,0.46,165,75420,NULL,NULL,'J','ARK 579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160982,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160982,36.1,0.47,166,75420,NULL,NULL,'H','ARK 579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160983,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160983,36.14,0.45,169,75420,NULL,NULL,'K','ARK 579',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160984,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160984,31.22,0.43,17.5,75421,NULL,NULL,'Malmquist cor.','NGC 7570',NULL,'2009ApJS..182..474S',2009,1,1.61,NULL,'G',0.00002,NULL,'13.8g',0.74,'SBa','in a radial-velocity based grouping',NULL,NULL,NULL,1,349.186125,13.483,0.125,NULL,52516871838,820576122,12821501,13.8),(160985,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160985,31.27,0.42,17.9,75421,NULL,NULL,NULL,'NGC 7570',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160986,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160986,31.61,0.4,21,75421,73,NULL,'opt','NGC 7570',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160987,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160987,33.28,0.47,45.3,75421,NULL,NULL,'H','NGC 7570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160988,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160988,33.43,0.46,48.6,75421,NULL,NULL,'J','NGC 7570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160989,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160989,33.47,0.45,49.3,75421,NULL,NULL,'K','NGC 7570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160990,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160990,33.89,0.4,59.9,75421,NULL,NULL,'mean','NGC 7570',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160991,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,160991,34.95,0.5,97.8,75422,70,NULL,NULL,'2MASX J23164533-1852569',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'15.50',0.42,NULL,NULL,NULL,NULL,NULL,1,349.189167,-18.88267,0.079,NULL,50318582357,786227849,12284810,15.5),(160992,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160992,35.87,0.46,149,75423,70,NULL,NULL,'SDSS J231647.75+153459.8',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',NULL,NULL,'15.5g',0.33,'S0/a',NULL,NULL,NULL,NULL,1,349.199,15.58328,0.113,NULL,52527088200,820735753,12823996,15.5),(160993,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 05671','RN',160993,37.59,0.69,286,75424,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05671',0.151557,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160994,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15413','RN',160994,40.05,0.06,955,75425,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15413',0.073616,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160995,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15413','RN',160995,40.44,0.25,1140,75425,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15413',0.073616,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160996,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1995ae',NULL,160996,37.54,0.34,301,75426,65,NULL,NULL,'APMUKS(BJ) B231421.60-022058.7',0.06895,'2004ApJ...607..665R',2004,1,0.29,NULL,'G',NULL,NULL,'18.12',0.18,NULL,NULL,NULL,NULL,NULL,1,349.233375,-2.07692,0.101,NULL,49628719680,775448745,12116386,18.12),(160997,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1995ae',NULL,160997,37.58,0.21,328,75426,65,NULL,'Snapshot','APMUKS(BJ) B231421.60-022058.7',NULL,'1998ApJ...504..935R',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(160998,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160998,37.47,0.33,312,75427,70,NULL,NULL,'2MASX J23165839-0900337',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000096,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,349.24325,-9.00939,0.069,NULL,49608081265,775126269,12111347,16.6),(160999,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',160999,33.43,0.49,48.6,75428,75,NULL,'IR','UGC 12475',NULL,'2011yCatp016004901K',2011,1,1.88,'FGC has two entries for this object.','G',0.000013,NULL,'15.41',0.25,'Sbc',NULL,NULL,NULL,NULL,1,349.245625,3.70975,0.213,NULL,51768125998,808876968,12638702,15.41),(161000,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161000,33.62,NULL,53,75428,NULL,NULL,'Dipole','UGC 12475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161001,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161001,33.63,NULL,53.3,75428,NULL,NULL,'Dipole + Quadrupole','UGC 12475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161002,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161002,33.63,NULL,53.3,75428,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12475',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161003,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161003,33.83,NULL,58.4,75428,NULL,NULL,NULL,'UGC 12475',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161004,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161004,36.49,0.74,198,75429,70,NULL,NULL,'2MASX J23170075-0223292',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'17.14',0.16,NULL,NULL,NULL,NULL,NULL,1,349.253125,-2.39136,0.085,NULL,49629059884,775454060,12116469,17.14),(161005,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161005,37.45,0.46,309,75430,70,NULL,NULL,'2MASX J23170177+0107159',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000094,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,349.2574583,1.12119,0.145,NULL,51758550318,808727348,12636364,16.6),(161006,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161006,38.47,0.46,494,75431,70,NULL,NULL,'2MASXi J2317039-083053',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000081,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,349.266541667,-8.51481,0.073,NULL,49603340894,775052201,12110190,17.8),(161007,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161007,33.46,0.2,49.2,75432,74.4,NULL,NULL,'CGCG 406-042',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000023,NULL,'15.66',0.6,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,349.2730417,7.12283,0.197,NULL,51745470131,808522970,12633171,15.66),(161008,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161008,33.48,0.43,49.7,75432,75,NULL,'3.6 micron, color corrected','CGCG 406-042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161009,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161009,33.48,0.43,49.7,75432,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 406-042',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161010,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161010,33.52,0.11,50.7,75432,NULL,NULL,NULL,'CGCG 406-042',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161011,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161011,34.85,0.45,93.5,75433,NULL,NULL,'K','NGC 7578B',NULL,'2007A&A...465...71T',2007,1,1,'Incorrectly identified as UGC 12477 in 1989ApJS...70..687H.','G',0.000107,NULL,'13.3V',1,'E1:;BrClG','Pair member, contact system',NULL,NULL,NULL,1,349.3065,18.70825,0.169,NULL,52533079747,820829371,12825458,13.3),(161012,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161012,35.95,0.4,155,75433,NULL,NULL,'mean','NGC 7578B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161013,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161013,34.71,0.62,87.4,75434,NULL,NULL,NULL,'2MASX J23171540+1843385',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.000344,NULL,'16.9V',0.12,'Sd','Compact group member',NULL,NULL,NULL,1,349.3142917,18.72742,0.153,NULL,52533079941,820829374,12825458,16.9),(161014,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161014,34.75,0.61,89.1,75434,NULL,NULL,'Malmquist cor.','2MASX J23171540+1843385',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161015,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161015,34.75,0.2,89.1,75434,74.4,NULL,NULL,'2MASX J23171540+1843385',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161016,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161016,38.01,0.46,400,75435,70,NULL,NULL,'2MASX J23171908-0839124',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000092,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,349.329583,-8.65364,0.073,NULL,49607726802,775120731,12111261,17.3),(161017,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161017,38.43,0.46,486,75436,70,NULL,NULL,'2MASX J23172100+1519256',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,349.337458333,15.32367,0.113,NULL,52527032544,820734883,12823982,17.3),(161018,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161018,37.87,0.46,374,75437,70,NULL,NULL,'2MASX J23172121+1454206',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000186,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,349.338416667,14.90581,0.125,NULL,52526696430,820729631,12823900,16.7),(161019,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161019,36.26,0.19,179,75438,70,NULL,NULL,'GIN 678',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000167,NULL,'16.2V',NULL,'S',NULL,NULL,NULL,NULL,1,349.33925,18.94164,0.153,NULL,52533099964,820829686,12825463,16.2),(161020,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161020,35.31,0.46,115,75439,NULL,NULL,NULL,'KUG 2314+181',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000017,NULL,'15.2V',0.45,'Spiral','Group member',NULL,NULL,NULL,1,349.3395,18.42367,0.169,NULL,52533460776,820835324,12825551,15.2),(161021,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161021,35.32,0.46,116,75439,NULL,NULL,'Malmquist cor.','KUG 2314+181',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161022,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161022,35.35,0.2,117,75439,74.4,NULL,NULL,'KUG 2314+181',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161023,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161023,37.47,0.33,312,75440,70,NULL,NULL,'2MASX J23172159-0907554',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000069,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,349.339875,-9.13194,0.061,NULL,49608122679,775126916,12111358,17.4),(161024,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161024,34.25,0.2,70.8,75441,74.4,NULL,NULL,'UGC 12479',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00003,NULL,'15.14',0.3,'Sa             HII',NULL,NULL,NULL,NULL,1,349.357,-1.58617,0.097,NULL,49630862795,775482231,12116909,15.14),(161025,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161025,34.26,0.42,71.1,75441,NULL,NULL,NULL,'UGC 12479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161026,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161026,34.36,0.4,74.4,75441,NULL,NULL,'Malmquist cor.','UGC 12479',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161027,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14654','RN',161027,41.75,0.26,1620,75442,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14654',0.381922,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161028,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14654','RN',161028,41.82,0.22,1670,75442,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14654',0.381922,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161029,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161029,37.73,0.46,352,75443,70,NULL,NULL,'2MASX J23172591-0916234',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000074,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,349.3579583,-9.27319,0.061,NULL,49608029844,775125466,12111335,17.4),(161030,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161030,37.85,0.11,332,75444,74.2,NULL,'SALT 2','2MASX J23172973+0025473',0.119128,'2010ApJ...716..712A',2010,1,0.2,NULL,'G',0.00012,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,349.37375,0.42967,0.121,NULL,51573339082,805833423,12591147,18.5),(161031,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161031,37.94,0.03,346,75444,70,NULL,'SDSS-II SN 01371','2MASX J23172973+0025473',0.119128,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161032,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161032,38.23,0.06,442,75444,70,NULL,'Hubble residual -0.18 for z0.11915','2MASX J23172973+0025473',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161033,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161033,38.55,0.12,458,75444,70,NULL,'SDSS-II SN 01371, SALT 2','2MASX J23172973+0025473',0.119128,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161034,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161034,38.57,0.07,463,75444,65,NULL,'SALT2','2MASX J23172973+0025473',0.119128,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161035,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 01371','R',161035,38.58,0.18,466,75444,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005fh','2MASX J23172973+0025473',0.11915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161036,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161036,38.48,0.06,497,75444,70,NULL,'SALT 2','2MASX J23172973+0025473',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161037,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161037,38.49,0.06,499,75444,70,NULL,'SALT 2, Malmquist cor.','2MASX J23172973+0025473',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161038,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005fh',NULL,161038,38.74,0.07,501,75444,65,NULL,'MLCS2k2','2MASX J23172973+0025473',0.119128,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161039,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 01371','R',161039,38.76,0.07,505,75444,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005fh','2MASX J23172973+0025473',0.11915,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161040,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161040,33.85,0.4,58.9,75445,NULL,NULL,'mean','NGC 7580',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000007,NULL,'14.2g',0.67,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,349.401667,14.00119,0.113,NULL,52516050266,820563285,12821301,14.2),(161041,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161041,34.51,0.47,79.8,75445,NULL,NULL,'H','NGC 7580',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161042,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161042,35.41,0.5,121,75446,70,NULL,NULL,'2MASX J23173698-0645464',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'15.92',0.28,NULL,NULL,NULL,NULL,NULL,1,349.403875,-6.76289,0.081,NULL,49602473437,775038647,12109978,15.92),(161043,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161043,32.72,0.8,35,75447,75,NULL,'MAT, I','ESO 407- G 014',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000023,NULL,'13.90',1.1,'SB(s)c?        HII','Isolated galaxy',NULL,NULL,NULL,1,349.4147917,-34.79081,NULL,NULL,50153485825,783648216,12244503,13.9),(161044,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161044,32.52,0.4,31.9,75447,NULL,NULL,NULL,'ESO 407- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161045,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161045,32.52,0.4,31.9,75447,73,NULL,'opt','ESO 407- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161046,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161046,32.55,0.32,32.3,75447,85,NULL,'I, raw','ESO 407- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161047,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161047,32.55,0.32,32.4,75447,85,NULL,'I, inv','ESO 407- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161048,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161048,32.77,0.43,35.8,75447,75,NULL,'3.6 micron, color + selection bias corrected','ESO 407- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161049,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161049,32.81,0.4,36.4,75447,73,NULL,'opt','ESO 407- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161050,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161050,32.82,0.43,36.7,75447,75,NULL,'MAT, I, raw','ESO 407- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161051,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161051,32.83,0.43,36.9,75447,75,NULL,'3.6 micron, color corrected','ESO 407- G 014',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161052,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161052,32.9,0.62,37.9,75447,NULL,NULL,'Malmquist cor.','ESO 407- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161053,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161053,32.92,0.2,38.4,75447,74.4,NULL,NULL,'ESO 407- G 014',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161054,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161054,32.92,0.43,38.4,75447,75,NULL,'MAT, I, inv','ESO 407- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161055,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161055,32.99,0.43,39.6,75447,75,NULL,'MAT, I, cor','ESO 407- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161056,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161056,33.05,0.4,40.8,75447,NULL,NULL,'mean','ESO 407- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161057,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161057,33.13,0.55,42.3,75447,NULL,NULL,NULL,'ESO 407- G 014',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161058,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161058,33.29,0.47,45.5,75447,NULL,NULL,'H','ESO 407- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161059,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161059,33.38,0.46,47.4,75447,NULL,NULL,'J','ESO 407- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161060,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161060,33.47,0.45,49.4,75447,NULL,NULL,'K','ESO 407- G 014',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161061,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06861','R',161061,39.71,0.25,734,75448,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 06861',0.191046,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,349.432208333,-1.11353,0.089,NULL,49627696646,775432760,12116136,NULL),(161062,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 06861','R',161062,39.95,0.17,819,75448,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 06861',0.191046,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161063,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161063,33.59,0.49,52.3,75449,75,NULL,'IR','FGC 2481',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',NULL,NULL,'16.6',0.12,'Sc',NULL,NULL,NULL,NULL,1,349.434333,7.48839,0.161,NULL,51749092318,808579567,12634055,16.6),(161064,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 05172','RN',161064,40.83,0.22,1270,75450,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05172',0.158215,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161065,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 05172','RN',161065,41.49,0.27,1720,75450,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05172',0.158215,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161066,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161066,36.89,0.65,239,75451,70,NULL,NULL,'LCRS B231507.5-444239',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.47',0.43,NULL,NULL,NULL,NULL,NULL,1,349.4737917,-44.43792,NULL,NULL,50529575428,789524616,12336322,16.47),(161067,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007oy',NULL,161067,40.14,0.15,1070,75452,70,NULL,'SALT 2','SDSS J231755.53+011325.1',NULL,'2013ApJ...763...88C',2013,1,0.03,NULL,'G',0.005,NULL,'22.5g',0.02,NULL,NULL,NULL,NULL,NULL,1,349.481375,1.22364,0.133,NULL,51758066659,808719791,12636246,22.5),(161068,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007oy',NULL,161068,40.16,0.15,1080,75452,70,NULL,'SALT 2, Malmquist cor.','SDSS J231755.53+011325.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161069,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2007oy',NULL,161069,40.38,0.26,1190,75452,70,NULL,'Hubble residual -0.35 for z0.40300','SDSS J231755.53+011325.1',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161070,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19757','R',161070,41.42,0.27,1370,75452,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oy','SDSS J231755.53+011325.1',0.403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161071,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19757','R',161071,41.45,0.23,1390,75452,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oy','SDSS J231755.53+011325.1',0.403,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161072,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161072,33.51,0.8,50.3,75453,75,NULL,'MAT, I','NGC 7593',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'14.30',0.6,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,349.4874583,11.34917,0.101,NULL,51741510476,808461101,12632204,14.3),(161073,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161073,33.52,0.8,50.5,75453,75,NULL,'HMCL, I','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161074,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161074,33.29,0.32,45.6,75453,85,NULL,'I, raw','NGC 7593',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161075,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161075,33.32,0.32,46.1,75453,85,NULL,'I, inv','NGC 7593',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161076,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161076,33.39,0.43,47.6,75453,75,NULL,'MAT, I, raw','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161077,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161077,33.49,0.08,50,75453,NULL,NULL,NULL,'NGC 7593',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161078,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161078,33.51,0.43,50.2,75453,75,NULL,'MAT, I, inv','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161079,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161079,33.57,0.43,51.8,75453,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7593',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161080,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161080,33.69,0.43,54.6,75453,75,NULL,'MAT, I, cor','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161081,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161081,33.7,0.43,54.9,75453,75,NULL,'3.6 micron, color corrected','NGC 7593',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161082,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161082,33.75,0.4,56.2,75453,NULL,NULL,'mean','NGC 7593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161083,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161083,33.86,0.2,59.2,75453,74.4,NULL,NULL,'NGC 7593',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161084,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161084,33.92,0.4,60.8,75453,75,NULL,'HMCL, I, raw','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161085,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161085,34,0.47,63.1,75453,NULL,NULL,'H','NGC 7593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161086,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161086,34.05,0.4,64.7,75453,75,NULL,'HMCL, I, inv','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161087,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161087,34.05,0.46,64.7,75453,NULL,NULL,'J','NGC 7593',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161088,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161088,34.07,0.4,65.1,75453,75,NULL,'HMCL, I, cor','NGC 7593',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161089,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161089,37.13,0.46,267,75454,70,NULL,NULL,'2MASX J23175716-1008384',NULL,'2015arXiv151105856S',2015,1,0.76,NULL,'G',0.000111,NULL,'15.8g',0.42,'BrClG',NULL,NULL,NULL,NULL,1,349.488208333,-10.14417,0.063,NULL,49596840268,774950629,12108603,15.8),(161090,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161090,36.93,0.7,244,75455,70,NULL,NULL,'2MFGC 17482',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.92',0.16,NULL,NULL,NULL,NULL,NULL,1,349.490875,-19.73394,0.103,NULL,50309027107,786078548,12282477,16.92),(161091,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 15726',NULL,161091,40.73,0.75,1400,75456,70,NULL,'SN photometric redshift distance, z photo =0.403 +/- 0.243','SDSS-II SN 15726',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,349.494625,-0.00728,0.105,NULL,49409491503,772023304,12062864,NULL),(161092,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161092,35.18,0.4,108,75457,NULL,NULL,'Malmquist cor.','NGC 7587',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000033,NULL,'14.78',0.3,'SBab: sp','Pair member (points to parent)',NULL,NULL,NULL,1,349.496375,9.68019,0.097,NULL,51756155334,808689927,12635780,14.78),(161093,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161093,35.33,0.38,116,75457,NULL,NULL,NULL,'NGC 7587',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161094,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161094,35.37,0.2,119,75457,74.4,NULL,NULL,'NGC 7587',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161095,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161095,33.16,0.45,42.9,75458,NULL,NULL,'K','NGC 7585',NULL,'2007A&A...465...71T',2007,1,2.3,NULL,'G',0.000003,NULL,'12.50',2,'(R\')SA(s)0+ pec','Pair member, contact system',NULL,NULL,NULL,1,349.505583,-4.65031,0.105,NULL,49635332717,775552073,12118001,12.5),(161096,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161096,33.33,0.4,46.4,75458,NULL,NULL,'mean','NGC 7585',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161097,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161097,38.07,0.46,410,75459,70,NULL,NULL,'2MASX J23180177+1457400',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000165,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,349.507333,14.96111,0.109,NULL,52528573479,820758960,12824358,17.6),(161098,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161098,34.69,0.46,86.6,75460,70,NULL,NULL,'CGCG 380-023',NULL,'2015arXiv151105856S',2015,1,0.79,NULL,'G',0.000096,NULL,'14.4g',0.77,'poss. LINER',NULL,NULL,NULL,NULL,1,349.534958333,-0.3905,0.109,NULL,49409886747,772029480,12062960,14.4),(161099,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161099,34.74,0.48,88.7,75460,70,NULL,NULL,'CGCG 380-023',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161100,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161100,37.9,0.46,381,75461,70,NULL,NULL,'2MASX J23180887-0852584',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000069,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,349.536916667,-8.88294,0.057,NULL,49607816838,775122138,12111283,17.9),(161101,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161101,37.3,0.58,288,75462,70,NULL,NULL,'2MASX J23180893-4804539',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,349.53725,-48.08158,NULL,NULL,50521042311,789391286,12334238,14.5),(161102,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161102,36.64,0.2,213,75463,74.4,NULL,NULL,'CGCG 431-036 NED01',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',NULL,NULL,'12.1K',0.1,NULL,NULL,NULL,NULL,NULL,1,349.542333,10.25106,0.105,NULL,51744339677,808505307,12632895,12.1),(161103,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161103,36.31,0.33,182,75464,NULL,NULL,'Malmquist cor.','UGC 12485 NOTES02 NED01',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'GPair',NULL,NULL,NULL,NULL,'S?','Group member',NULL,NULL,NULL,1,349.54475,10.24847,0.105,NULL,51744339632,808505306,12632895,NULL),(161104,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161104,36.51,0.3,201,75464,NULL,NULL,NULL,'UGC 12485 NOTES02 NED01',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161105,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161105,35.75,0.8,142,75465,75,NULL,'CF, r','NGC 7594',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00003,NULL,'14.58',0.9,'Sb','Group member',NULL,NULL,NULL,1,349.558,10.29831,0.109,NULL,51744338504,808505289,12632895,14.58),(161106,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161106,35.08,0.69,104,75465,100,NULL,'mid-IR','NGC 7594',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161107,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161107,35.24,0.38,112,75465,75,NULL,'CF, r, raw','NGC 7594',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161108,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161108,35.4,0.46,120,75465,NULL,NULL,'Malmquist cor.','NGC 7594',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161109,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161109,35.46,0.38,124,75465,75,NULL,'CF, r, inv','NGC 7594',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161110,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161110,35.55,0.43,129,75465,NULL,NULL,NULL,'NGC 7594',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161111,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161111,35.55,0.38,129,75465,75,NULL,'CF, r, cor','NGC 7594',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161112,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161112,35.83,0.2,147,75465,74.4,NULL,NULL,'NGC 7594',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161113,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161113,35.94,0.4,154,75465,NULL,NULL,'mean','NGC 7594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161114,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161114,35.96,0.47,155,75465,NULL,NULL,'H','NGC 7594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161115,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161115,36.03,0.45,161,75465,NULL,NULL,'K','NGC 7594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161116,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161116,36.08,0.46,165,75465,NULL,NULL,'J','NGC 7594',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161117,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 16218','RN',161117,38.62,0.34,515,75466,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16218',0.029655,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161118,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 16218','RN',161118,38.8,0.2,560,75466,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16218',0.029655,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161119,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161119,35.46,0.2,124,75467,74.4,NULL,NULL,'NGC 7589',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000067,NULL,'14.8g',0.59,'SAB(rs)a:;GLSBGBLAGN',NULL,NULL,NULL,'Sy 1',1,349.5652917,0.26117,0.125,NULL,51574143592,805845993,12591343,14.8),(161120,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161120,38.33,0.33,463,75468,70,NULL,NULL,'SDSS J231816.22+144413.4',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,349.567583333,14.73706,0.125,NULL,52528460552,820757196,12824331,18.1),(161121,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161121,33.97,0.8,62.3,75469,75,NULL,'MAT, I','NGC 7591',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'13.86',0.8,'SBbc;Sy;LIRG   LINER','in a pair',NULL,NULL,'Sy',1,349.567833333,6.58581,0.177,NULL,51800265415,809379147,12646549,13.86),(161122,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161122,33.98,0.8,62.4,75469,75,NULL,'W91CL, r','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161123,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161123,33.98,0.8,62.4,75469,75,NULL,'HMCL, I','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161124,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161124,34,0.8,63.2,75469,75,NULL,'CF, r','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161125,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161125,33.56,0.47,51.6,75469,NULL,NULL,'H','NGC 7591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161126,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161126,33.57,0.45,51.7,75469,NULL,NULL,'K','NGC 7591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161127,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161127,33.63,0.46,53.1,75469,NULL,NULL,'J','NGC 7591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161128,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161128,33.63,0.43,53.2,75469,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7591',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161129,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161129,33.78,0.43,56.9,75469,75,NULL,'3.6 micron, color corrected','NGC 7591',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161130,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161130,33.92,0.38,60.8,75469,NULL,NULL,NULL,'NGC 7591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161131,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161131,33.93,0.2,61.1,75469,74.4,NULL,NULL,'NGC 7591',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161132,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161132,33.97,0.38,62.3,75469,75,NULL,'W91CL, r, raw','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161133,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161133,33.98,0.37,62.6,75469,NULL,NULL,'Malmquist cor.','NGC 7591',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161134,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161134,33.99,0.32,62.7,75469,85,NULL,'I, raw','NGC 7591',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161135,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161135,34.01,0.4,63.4,75469,75,NULL,'HMCL, I, raw','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161136,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161136,34.02,0.43,63.7,75469,75,NULL,'MAT, I, raw','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161137,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161137,34.04,0.4,64.1,75469,NULL,NULL,'mean','NGC 7591',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161138,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161138,34.05,0.32,64.7,75469,85,NULL,'I, inv','NGC 7591',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161139,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161139,34.15,0.38,67.7,75469,75,NULL,'W91CL, r, inv','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161140,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161140,34.17,0.38,68.3,75469,75,NULL,'W91CL, r, cor','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161141,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161141,34.23,0.4,70.1,75469,75,NULL,'HMCL, I, inv','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161142,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161142,34.25,0.4,70.7,75469,75,NULL,'HMCL, I, cor','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161143,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161143,34.29,0.43,72.1,75469,75,NULL,'MAT, I, cor','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161144,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161144,34.3,0.43,72.6,75469,75,NULL,'MAT, I, inv','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161145,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161145,34.31,0.38,72.9,75469,75,NULL,'CF, r, raw','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161146,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161146,34.49,0.38,79.2,75469,75,NULL,'CF, r, cor','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161147,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161147,34.52,0.38,80.3,75469,75,NULL,'CF, r, inv','NGC 7591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161148,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161148,32.65,0.49,33.9,75470,75,NULL,'IR','MCG -01-59-016',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.00015,NULL,'15.09',0.3,'Sc',NULL,NULL,NULL,NULL,1,349.571667,-3.62667,0.117,NULL,49642116837,775658075,12119657,15.09),(161149,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161149,38.65,0.46,536,75471,70,NULL,NULL,'2MASX J23181777-0109060',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000115,NULL,'17.2g',0.25,'AGN',NULL,NULL,NULL,NULL,1,349.574,-1.15164,0.081,NULL,49627738722,775433417,12116147,17.2),(161150,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161150,38.58,0.33,521,75472,70,NULL,NULL,'SDSS J231818.85+134106.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,349.578583,13.68528,0.109,NULL,52515966779,820561980,12821280,18.5),(161151,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161151,35.62,0.4,133,75473,NULL,NULL,'mean','ESO 604- G 010',NULL,'2007A&A...465...71T',2007,1,1.2,NULL,'G',0.000033,NULL,'14.72',0.9,'SB(r)a',NULL,NULL,NULL,NULL,1,349.5807917,-21.17486,0.059,NULL,50311516219,786117440,12283085,14.72),(161152,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161152,35.66,0.37,135,75473,NULL,NULL,'Malmquist cor.','ESO 604- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161153,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161153,35.79,0.47,144,75473,NULL,NULL,'H','ESO 604- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161154,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161154,36.03,0.31,161,75473,NULL,NULL,NULL,'ESO 604- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161155,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161155,36.07,0.2,164,75473,74.4,NULL,NULL,'ESO 604- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161156,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 13850','RN',161156,40.4,0.15,1010,75474,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13850',0.189043,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161157,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 13850','RN',161157,41,0.22,1330,75474,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13850',0.189043,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161158,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161158,31.49,0.1,19.9,75475,NULL,NULL,NULL,'NGC 7582',NULL,'2002A&A...393...57T',2002,1,5,NULL,'G',0.000023,NULL,'11.37',2.1,'(R\'_1)SB(s)ab  Sy2','X-ray-faint group member',NULL,NULL,'Sy 1 i',1,349.597917,-42.37056,NULL,NULL,50527863666,789497869,12335904,11.37),(161159,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161159,31.23,0.8,17.6,75475,75,NULL,'B','NGC 7582',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161160,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161160,31.71,0.41,22,75475,NULL,NULL,NULL,'NGC 7582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161161,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161161,31.73,0.39,22.2,75475,73,NULL,'opt','NGC 7582',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161162,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161162,31.76,0.2,22.5,75475,74.4,NULL,NULL,'NGC 7582',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161163,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161163,31.81,0.4,23,75475,NULL,NULL,'Malmquist cor.','NGC 7582',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161164,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161164,31.92,NULL,24.2,75475,NULL,NULL,'LEDA [April 2006]','NGC 7582',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161165,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161165,36.27,0.13,179,75476,70,NULL,NULL,'ABELL 2572',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,349.5982917,18.74019,0.133,NULL,52533555544,820836805,12825575,NULL),(161166,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161166,38.58,0.33,521,75477,70,NULL,NULL,'2MASX J23182444+1340186',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000147,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,349.601916667,13.67181,0.109,NULL,52515962949,820561921,12821280,17.3),(161167,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161167,35.35,0.49,117,75478,75,NULL,'IR','KUG 2315+198',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.47',0.3,'Spiral',NULL,NULL,NULL,NULL,1,349.605833,20.16361,0.181,NULL,52502137948,820345905,12817904,15.47),(161168,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161168,35.75,0.45,141,75478,NULL,NULL,'Malmquist cor.','KUG 2315+198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161169,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161169,35.82,0.44,146,75478,NULL,NULL,NULL,'KUG 2315+198',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161170,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161170,35.89,0.2,151,75478,74.4,NULL,NULL,'KUG 2315+198',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161171,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161171,35.82,0.49,146,75479,75,NULL,'IR','2MFGC 17495',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000053,NULL,'11.5K',0.2,NULL,NULL,NULL,NULL,NULL,1,349.608875,6.96461,0.189,NULL,51745433928,808522405,12633162,11.5),(161172,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161172,35.85,0.41,148,75479,NULL,NULL,'Malmquist cor.','2MFGC 17495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161173,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161173,35.94,0.4,154,75479,NULL,NULL,NULL,'2MFGC 17495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161174,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161174,36.14,0.2,169,75479,74.4,NULL,NULL,'2MFGC 17495',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161175,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161175,33.44,0.2,48.8,75480,74.4,NULL,NULL,'UGC 12504',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00002,NULL,'15.3',0.4,'Scd:',NULL,NULL,NULL,NULL,1,349.6197083,77.32028,1.297,NULL,52779862598,824685353,12885708,15.3),(161176,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161176,33.59,0.4,52.2,75480,75,NULL,NULL,'UGC 12504',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161177,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161177,33.65,0.49,53.8,75480,75,NULL,'IR','UGC 12504',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161178,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161178,36.26,0.19,179,75481,70,NULL,NULL,'GIN 680',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000047,NULL,'15.69',NULL,'E',NULL,NULL,NULL,NULL,1,349.6227083,18.62106,0.153,NULL,52533649912,820838279,12825598,15.69),(161179,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161179,36.05,0.25,162,75482,74.4,NULL,NULL,'NGC 7571',NULL,'2013AJ....146...86T',2013,1,0.9,'Identification as NGC 7571 is doubtful.','G',0.000077,NULL,'14.92',0.9,'cD;S?','in a pair',NULL,'radio jet',NULL,1,349.626083333,18.68875,0.133,NULL,52533550778,820836730,12825573,14.92),(161180,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161180,36.26,0.19,179,75482,70,NULL,NULL,'NGC 7571',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161181,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161181,36.27,0.13,179,75482,70,NULL,'ABELL 2572, BGC','NGC 7571',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161182,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161182,34.93,0.49,96.6,75483,75,NULL,'IR','ESO 077- G 009',NULL,'2011yCatp016004901K',2011,1,0.96,NULL,'G',0.000033,NULL,'16.70',0.11,'Sc',NULL,NULL,NULL,NULL,1,349.628917,-68.49372,0.013,NULL,49274594593,769915540,12029930,16.7),(161183,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161183,35.47,0.42,124,75483,NULL,NULL,NULL,'ESO 077- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161184,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161184,35.51,0.2,126,75483,74.4,NULL,NULL,'ESO 077- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161185,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161185,35.54,0.4,128,75483,NULL,NULL,'Malmquist cor.','ESO 077- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161186,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161186,35.54,NULL,128,75483,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 077- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161187,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161187,35.56,NULL,129,75483,NULL,NULL,'Dipole + Quadrupole','ESO 077- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161188,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161188,35.58,NULL,131,75483,NULL,NULL,'Dipole','ESO 077- G 009',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161189,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161189,35.59,NULL,131,75483,NULL,NULL,NULL,'ESO 077- G 009',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161190,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161190,36.04,0.25,161,75484,74.4,NULL,NULL,'NGC 7598',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.00005,NULL,'14.24',0.2,'E','Group member',NULL,NULL,NULL,1,349.638625,18.74936,0.133,NULL,52533548045,820836688,12825573,14.24),(161191,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161191,36.26,0.19,179,75484,70,NULL,NULL,'NGC 7598',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161192,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161192,37.17,0.46,272,75485,70,NULL,NULL,'2MASX J23183673-1012213',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000078,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,349.653125,-10.20603,0.066,NULL,49596645821,774947590,12108556,17),(161193,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161193,34.57,0.69,82.1,75486,100,NULL,'mid-IR','UGC 12490',NULL,'2013ApJ...771...88L',2013,1,0.79,NULL,'G',0.000027,NULL,'14.2',0.55,'SBa            Sbrst','Pair member (points to parent)',NULL,NULL,'Starburst',1,349.6597917,25.23286,0.261,NULL,51978661910,812166592,12690103,14.2),(161194,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161194,34.84,0.47,93.1,75486,NULL,NULL,'H','UGC 12490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161195,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161195,34.97,0.45,98.4,75486,NULL,NULL,'K','UGC 12490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161196,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161196,35.03,0.46,102,75486,NULL,NULL,'J','UGC 12490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161197,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161197,35.16,0.4,108,75486,NULL,NULL,'mean','UGC 12490',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161198,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161198,36.26,0.19,179,75487,70,NULL,NULL,'GIN 679',NULL,'2001MNRAS.321..277C',2001,1,0.3,NULL,'G',0.000334,NULL,'15.93',0.1,'Radio galaxy',NULL,NULL,'NAT',NULL,1,349.663667,18.68925,0.133,NULL,52533576689,820837135,12825580,15.93),(161199,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161199,35.7,0.33,138,75488,70,NULL,NULL,'2MASX J23184014-1004145',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000082,NULL,'16.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,349.667375,-10.07064,0.025,NULL,49596654143,774947720,12108558,16.3),(161200,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161200,40.34,0.22,900,75489,74.2,NULL,'SALT 2','SDSS J231842.19-011216.7',0.3,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.0005,NULL,'20.8g',0.06,NULL,NULL,NULL,NULL,NULL,1,349.675791667,-1.20464,0.081,NULL,49627789117,775434204,12116159,20.8),(161201,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161201,40.34,0.23,1170,75489,70,NULL,'Hubble residual 0.14 for z0.30010','SDSS J231842.19-011216.7',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161202,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 10550','R',161202,40.91,0.25,1170,75489,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005lf','SDSS J231842.19-011216.7',0.3001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161203,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161203,40.97,0.24,1200,75489,65,NULL,'SALT2','SDSS J231842.19-011216.7',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161204,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161204,41.03,0.26,1230,75489,70,NULL,'SDSS-II SN 10550, SALT 2','SDSS J231842.19-011216.7',0.3,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161205,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 10550','R',161205,41.11,0.31,1280,75489,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005lf','SDSS J231842.19-011216.7',0.3001,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161206,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161206,41.14,0.22,1300,75489,65,NULL,'MLCS2k2','SDSS J231842.19-011216.7',0.3,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161207,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161207,41.33,0.1,1420,75489,70,NULL,'SDSS-II SN 10550','SDSS J231842.19-011216.7',0.3,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161208,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161208,41.06,0.22,1630,75489,70,NULL,'SALT 2','SDSS J231842.19-011216.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161209,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005lf',NULL,161209,41.09,0.22,1650,75489,70,NULL,'SALT 2, Malmquist cor.','SDSS J231842.19-011216.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161210,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161210,35.3,0.53,115,75490,70,NULL,NULL,'2MASX J23184305-1000275',NULL,'2014MNRAS.445.2677S',2014,1,0.79,NULL,'G',0.000084,NULL,'15.2g',0.31,'S0/a',NULL,NULL,NULL,NULL,1,349.6794583,-10.00764,0.025,NULL,49596081923,774938780,12108418,15.2),(161211,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161211,35.77,0.8,143,75491,75,NULL,'W91PP, r','UGC 12489',NULL,'1997ApJS..109..333W',1997,1,1.59,NULL,'G',0.000006,NULL,'16.0',0.16,'Sc',NULL,NULL,NULL,NULL,1,349.6805,22.87417,0.177,NULL,52510505167,820476643,12819947,16),(161212,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161212,35.64,0.49,134,75491,75,NULL,'IR','UGC 12489',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161213,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161213,35.82,NULL,146,75491,NULL,NULL,'Dipole','UGC 12489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161214,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161214,35.82,NULL,146,75491,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161215,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161215,35.83,NULL,146,75491,NULL,NULL,'Dipole + Quadrupole','UGC 12489',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161216,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161216,35.93,NULL,153,75491,NULL,NULL,NULL,'UGC 12489',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161217,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161217,35.93,0.38,154,75491,75,NULL,'W91PP, r, raw','UGC 12489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161218,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161218,36.16,0.38,170,75491,75,NULL,'W91PP, r, cor','UGC 12489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161219,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161219,36.18,0.38,172,75491,75,NULL,'W91PP, r, inv','UGC 12489',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161220,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161220,36.04,0.25,161,75492,74.4,NULL,NULL,'NGC 7602',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000067,NULL,'15.32',0.5,'S?','in a pair',NULL,NULL,NULL,1,349.681375,18.69836,0.133,NULL,52533576174,820837127,12825580,15.32),(161221,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161221,36.26,0.19,179,75492,70,NULL,NULL,'NGC 7602',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161222,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161222,35.58,0.48,131,75493,70,NULL,NULL,'MCG -01-59-018',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00014,NULL,'15.46',0.7,NULL,NULL,NULL,NULL,NULL,1,349.68125,-3.00558,0.117,NULL,49642324423,775661319,12119708,15.46),(161223,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161223,36.75,0.46,224,75494,70,NULL,NULL,'2MASX J23184362-0854545',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000108,NULL,'16.2g',0.42,'S0/a',NULL,NULL,NULL,NULL,1,349.681667,-8.91514,0.057,NULL,49607830812,775122356,12111286,16.2),(161224,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161224,38.09,0.46,414,75495,70,NULL,NULL,'2MASX J23184388+1525045',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000172,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,349.6827917,15.41792,0.105,NULL,52529307575,820770430,12824537,17.7),(161225,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19778','R',161225,41.92,0.23,1730,75496,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J231845.12-002951.4',0.397,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.001,NULL,'20.41',0.08,'Cand. type II  AGN',NULL,NULL,NULL,'Sy 2',1,349.688167,-0.49764,0.105,NULL,49409947216,772030425,12062975,20.41),(161226,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19778','R',161226,41.96,0.27,1770,75496,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J231845.12-002951.4',0.397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161227,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19778',NULL,161227,41.93,0.17,2430,75496,70,NULL,'SALT 2','SDSS J231845.12-002951.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161228,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19778',NULL,161228,41.99,0.17,2500,75496,70,NULL,'SALT 2, Malmquist cor.','SDSS J231845.12-002951.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161229,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161229,35.7,0.33,138,75497,70,NULL,NULL,'IC 1479',NULL,'2015arXiv151105856S',2015,1,1.04,NULL,'G',0.000103,NULL,'14.2g',0.89,'E:',NULL,NULL,NULL,NULL,1,349.693375,-10.39925,0.066,NULL,49596750788,774949231,12108581,14.2),(161230,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161230,36.21,0.5,175,75497,70,NULL,NULL,'IC 1479',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161231,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161231,35.18,0.53,109,75498,NULL,NULL,'Malmquist cor.','NGC 7601',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'14.63',0.9,'SAB(s)c:',NULL,NULL,NULL,NULL,1,349.6960417,9.23361,0.125,NULL,51756413376,808693959,12635843,14.63),(161232,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161232,35.33,0.49,117,75498,NULL,NULL,NULL,'NGC 7601',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161233,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161233,35.37,0.2,119,75498,74.4,NULL,NULL,'NGC 7601',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161234,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161234,35.79,0.49,144,75499,NULL,NULL,NULL,'2MASX J23184802+1852308',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.000027,NULL,'14.76',NULL,'Sb',NULL,NULL,NULL,NULL,1,349.700083333,18.87525,0.133,NULL,52533534552,820836477,12825569,14.76),(161235,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161235,35.83,0.48,146,75499,NULL,NULL,'Malmquist cor.','2MASX J23184802+1852308',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161236,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161236,35.83,0.2,147,75499,74.4,NULL,NULL,'2MASX J23184802+1852308',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161237,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161237,33.2,0.2,43.7,75500,74.4,NULL,NULL,'UGC 12495',NULL,'2013AJ....146...86T',2013,1,1.2,'The UZC position is 8 arcsec west of the nucleus.','G',0.000017,NULL,'14.78',0.8,'Sdm:',NULL,NULL,NULL,NULL,1,349.7022083,16.62733,0.101,NULL,52523792770,820684262,12823191,14.78),(161238,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161238,33.48,0.44,49.6,75500,NULL,NULL,NULL,'UGC 12495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161239,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161239,33.75,0.39,56.2,75500,NULL,NULL,'Malmquist cor.','UGC 12495',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161240,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161240,35.48,0.46,125,75501,70,NULL,NULL,'2MASX J23185029+0059498',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000073,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,349.709583,0.99706,0.137,NULL,51758123899,808720685,12636260,16.4),(161241,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161241,36.93,0.46,244,75502,70,NULL,NULL,'2MASX J23185036-1004115',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000084,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,349.709833,-10.06997,0.025,NULL,49596603432,774946928,12108545,16.5),(161242,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161242,35.5,0.47,126,75503,70,NULL,NULL,'IC 5304',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000107,NULL,'14.18',0.9,'SAB0- pec:',NULL,NULL,NULL,NULL,1,349.7189583,-10.25931,0.066,NULL,49596642868,774947544,12108555,14.18),(161243,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161243,33.55,0.8,51.4,75504,75,NULL,'W91CL, r','UGC 12494',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000027,NULL,'15.21',0.5,'SABd',NULL,NULL,NULL,NULL,1,349.7192083,6.87722,0.189,NULL,51800208373,809378255,12646535,15.21),(161244,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161244,33.56,0.8,51.5,75504,75,NULL,'HMCL, I','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161245,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161245,33.6,0.8,52.4,75504,75,NULL,'CF, r','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161246,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161246,33.22,0.2,44.1,75504,74.4,NULL,NULL,'UGC 12494',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161247,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161247,33.31,0.43,45.8,75504,75,NULL,'3.6 micron, color corrected','UGC 12494',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161248,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161248,33.32,0.38,46.1,75504,75,NULL,'CF, r, inv','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161249,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161249,33.34,0.38,46.6,75504,75,NULL,'CF, r, raw','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161250,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161250,33.36,0.43,47.1,75504,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12494',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161251,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161251,33.49,0.38,49.9,75504,75,NULL,'W91CL, r, inv','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161252,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161252,33.5,0.38,50.1,75504,75,NULL,'W91CL, r, raw','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161253,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161253,33.52,0.11,50.7,75504,NULL,NULL,NULL,'UGC 12494',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161254,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161254,33.53,0.4,50.7,75504,75,NULL,'HMCL, I, raw','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161255,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161255,33.57,0.4,51.8,75504,75,NULL,'HMCL, I, inv','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161256,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161256,33.62,0.38,53,75504,75,NULL,'CF, r, cor','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161257,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161257,33.76,0.38,56.5,75504,75,NULL,'W91CL, r, cor','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161258,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161258,33.82,0.4,58.1,75504,75,NULL,'HMCL, I, cor','UGC 12494',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161259,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161259,37.34,0.46,294,75505,70,NULL,NULL,'2MASX J23185319-0839315',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000085,NULL,'16.9g',0.28,NULL,NULL,NULL,NULL,NULL,1,349.72175,-8.65883,0.053,NULL,49607667644,775119806,12111246,16.9),(161260,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161260,38.33,0.33,463,75506,70,NULL,NULL,'SDSS J231853.23+144947.6',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000156,NULL,'18.3g',0.12,NULL,NULL,NULL,NULL,NULL,1,349.721833,14.82992,0.109,NULL,52528653010,820760203,12824378,18.3),(161261,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161261,34.56,0.47,81.7,75507,70,NULL,NULL,'UGC 12492',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000133,NULL,'14.47',0.9,'S0;LINER       Sy2',NULL,NULL,NULL,'Sy 2',1,349.72425,-1.06025,0.097,NULL,49627629954,775431718,12116120,14.47),(161262,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161262,31.44,0.65,19.4,75508,95,NULL,'Weighted Mean','NGC 7600',NULL,'1984ApJS...56...91D',1984,1,2.5,'The APM position is 8 arcsec northeast of the nucleus.','G',0.00007,NULL,'12.95',1.1,'S0-',NULL,NULL,NULL,NULL,1,349.724417,-7.58044,0.061,NULL,49605428844,775084825,12110700,12.95),(161263,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161263,32.76,0.81,35.6,75508,55,NULL,'Visvanathan & Sandage 1979','NGC 7600',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161264,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161264,33.14,0.45,42.4,75508,NULL,NULL,'K','NGC 7600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161265,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161265,33.31,0.4,46,75508,NULL,NULL,'mean','NGC 7600',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161266,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161266,35.87,0.58,149,75509,70,NULL,NULL,'2MFGC 17506',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000088,NULL,'15.9g',0.22,'Sb(f)',NULL,NULL,NULL,NULL,1,349.7252917,-10.32842,0.066,NULL,49596811226,774950175,12108596,15.9),(161267,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161267,31.4,0.8,19,75510,75,NULL,'MAT, I','NGC 7590',NULL,'1997ApJS..109..333W',1997,1,2.7,'Confused and extended HIPASS source','G',0.000017,NULL,'12.11',1,'S(r?)bc        Sy2','X-ray-faint group member',NULL,NULL,'unobscured Seyfert 2',1,349.728375,-42.23906,NULL,NULL,50528328288,789505129,12336017,12.11),(161268,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161268,32.03,0.05,25.5,75510,NULL,NULL,NULL,'NGC 7590',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161269,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161269,31.19,0.8,17.3,75510,75,NULL,'B','NGC 7590',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161270,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161270,31.95,0.32,24.5,75510,85,NULL,'I, raw','NGC 7590',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161271,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161271,31.99,0.32,25,75510,85,NULL,'I, inv','NGC 7590',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161272,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161272,32,0.43,25.1,75510,75,NULL,'MAT, I, raw','NGC 7590',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161273,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161273,32.19,0.43,27.4,75510,75,NULL,'MAT, I, cor','NGC 7590',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161274,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161274,32.23,0.43,27.9,75510,75,NULL,'MAT, I, inv','NGC 7590',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161275,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161275,32.24,0.39,28.1,75510,73,NULL,'opt','NGC 7590',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161276,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161276,32.35,0.42,29.6,75510,NULL,NULL,'Malmquist cor.','NGC 7590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161277,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161277,32.42,0.41,30.4,75510,NULL,NULL,NULL,'NGC 7590',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161278,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161278,32.46,0.2,31.1,75510,74.4,NULL,NULL,'NGC 7590',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161279,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161279,35.09,0.33,104,75511,NULL,NULL,NULL,'ESO 604- G 011',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.13',0.5,'SAB(s)bc',NULL,NULL,NULL,NULL,1,349.732041667,-20.70081,0.056,NULL,50311604148,786118814,12283106,15.13),(161280,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161280,35.14,0.2,107,75511,74.4,NULL,NULL,'ESO 604- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161281,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161281,35.38,0.29,119,75511,NULL,NULL,'Malmquist cor.','ESO 604- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161282,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161282,36.6,0.55,209,75512,NULL,NULL,'Malmquist cor.','2MASX J23185854+1854107',NULL,'2009ApJS..182..474S',2009,1,0.49,NULL,'G',0.00003,NULL,'16.23',NULL,'Sc',NULL,NULL,NULL,NULL,1,349.744,18.90292,0.133,NULL,52533542315,820836598,12825571,16.23),(161283,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161283,37.1,0.44,262,75512,NULL,NULL,NULL,'2MASX J23185854+1854107',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161284,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161284,37.14,0.2,268,75512,74.4,NULL,NULL,'2MASX J23185854+1854107',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161285,'Diameter','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161285,36.65,NULL,214,75513,NULL,NULL,'Photographic','NGC 7603B',NULL,'1986ApJ...302..245S',1986,1,0.38,NULL,'G',0.00008,NULL,'16.4g',0.35,'Sy1','Line-of-sight pair member',NULL,NULL,NULL,1,349.75,0.23564,0.113,NULL,51573604198,805837565,12591211,16.4),(161286,'Magnitude','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161286,36.83,NULL,232,75513,NULL,NULL,'Photographic','NGC 7603B',NULL,'1986ApJ...302..245S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161287,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19432','RN',161287,40.45,0.21,961,75514,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19432',0.282225,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161288,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19432','RN',161288,40.56,0.28,1010,75514,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19432',0.282225,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161289,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161289,37.14,0.46,268,75515,70,NULL,NULL,'2MASX J23190110+0016516',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000082,NULL,'17.3g',0.19,NULL,NULL,NULL,NULL,NULL,1,349.754583,0.28106,0.113,NULL,51573589365,805837333,12591208,17.3),(161290,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 03669',NULL,161290,40.78,0.81,1430,75516,70,NULL,'SN photometric redshift distance, z photo =0.415 +/- 0.284','SDSS-II SN 03669',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,349.757333,-0.83972,0.101,NULL,49409338649,772020916,12062826,21.8),(161291,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161291,36.74,0.03,223,75517,NULL,NULL,'H','PTF10xyt',NULL,'2012MNRAS.425.1007B',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,349.76,13.79078,0.101,NULL,52514529623,820539525,12820930,NULL),(161292,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161292,36.79,0.1,228,75517,72,NULL,'M(H) = -18.317 mag','PTF10xyt',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161293,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161293,36.84,0.04,233,75517,NULL,NULL,'J','PTF10xyt',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161294,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161294,37.06,0.04,246,75517,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10xyt',0.0484,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161295,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','PTF10xyt',NULL,161295,37.09,0.04,250,75517,70,NULL,'SiFTO+SALT2, SN PTF10xyt','PTF10xyt',0.0484,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161296,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161296,34.42,0.8,76.6,75518,75,NULL,'MAT, I','ESO 535- G 015',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000027,NULL,'14.18',1,'SB(s)bc        LINER',NULL,NULL,NULL,NULL,1,349.761333333,-22.71519,0.05,NULL,50313764424,786152569,12283633,14.18),(161297,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161297,33.89,0.69,60.1,75518,100,NULL,'mid-IR','ESO 535- G 015',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161298,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161298,34.41,0.43,76.1,75518,75,NULL,'MAT, I, raw','ESO 535- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161299,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161299,34.48,0.32,78.8,75518,85,NULL,'I, raw','ESO 535- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161300,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161300,34.52,0.47,80.1,75518,NULL,NULL,'H','ESO 535- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161301,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161301,34.54,0.32,81,75518,85,NULL,'I, inv','ESO 535- G 015',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161302,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161302,34.54,0.4,81.1,75518,NULL,NULL,'mean','ESO 535- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161303,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161303,34.64,0.45,84.7,75518,NULL,NULL,'K','ESO 535- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161304,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161304,34.65,0.43,85.2,75518,75,NULL,'MAT, I, inv','ESO 535- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161305,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161305,34.7,0.46,87.1,75518,NULL,NULL,'J','ESO 535- G 015',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161306,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161306,34.86,0.43,93.7,75518,75,NULL,'MAT, I, cor','ESO 535- G 015',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161307,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161307,34.86,0.2,93.8,75518,74.4,NULL,NULL,'ESO 535- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (161308,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161308,34.89,0.42,95.2,75518,NULL,NULL,NULL,'ESO 535- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161309,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161309,35.21,0.36,110,75518,NULL,NULL,'Malmquist cor.','ESO 535- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161310,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161310,38.97,0.46,622,75519,70,NULL,NULL,'SDSS J231903.24-095201.4',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.00008,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,349.7635,-9.86706,0.06,NULL,49607350064,775114844,12111169,18.1),(161311,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161311,32.24,0.8,28.1,75520,75,NULL,'MAT, I','NGC 7606',NULL,'1997ApJS..109..333W',1997,1,5.22,NULL,'G',0.000017,NULL,'12.3g',1.12,'SA(s)b         HII',NULL,NULL,NULL,NULL,1,349.769917,-8.48508,0.045,NULL,49604994253,775078035,12110594,12.3),(161312,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161312,32.31,0.8,28.9,75520,75,NULL,'B','NGC 7606',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161313,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161313,32.37,0.43,29.8,75520,75,NULL,'MAT, I, raw','NGC 7606',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161314,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161314,32.45,0.43,31,75520,NULL,NULL,'Malmquist cor.','NGC 7606',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161315,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161315,32.51,0.32,31.7,75520,85,NULL,'I, raw','NGC 7606',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161316,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161316,32.57,0.36,32.7,75520,NULL,NULL,NULL,'NGC 7606',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161317,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161317,32.57,0.39,32.7,75520,73,NULL,'opt','NGC 7606',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161318,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161318,32.57,0.39,32.7,75520,73,NULL,'opt','NGC 7606',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161319,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161319,32.59,0.32,32.9,75520,85,NULL,'I, inv','NGC 7606',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161320,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161320,32.59,0.4,33,75520,NULL,NULL,NULL,'NGC 7606',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161321,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161321,32.65,0.43,34,75520,75,NULL,'MAT, I, cor','NGC 7606',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161322,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161322,32.71,0.43,34.9,75520,75,NULL,'MAT, I, inv','NGC 7606',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161323,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161323,32.74,0.2,35.3,75520,74.4,NULL,NULL,'NGC 7606',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161324,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161324,32.87,0.43,37.5,75520,75,NULL,'3.6 micron, color corrected','NGC 7606',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161325,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161325,32.98,0.43,39.4,75520,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7606',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161326,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19758','RN',161326,41.54,0.35,1460,75521,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19758',0.397285,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161327,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19758','RN',161327,41.69,0.35,1560,75521,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19758',0.397285,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161328,'SGRB','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161328,42.46,NULL,3100,75522,70,NULL,'Photometric Distance, Host A, M(R) = -20 mag and spectral slope Beta = 1.0 ','GRB 081204',NULL,'2012A&A...545A..77R',2012,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,349.789375,-60.22489,0,NULL,48743048761,761610136,11900158,NULL),(161329,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161329,36.26,0.02,178,75523,NULL,NULL,'J, SN 2010ho','2MASX J23190979+0911455',NULL,'2012MNRAS.425.1007B',2012,1,NULL,NULL,'G',0.000017,NULL,'16.52',NULL,'Sc',NULL,NULL,NULL,NULL,1,349.79075,9.19597,0.125,NULL,51755958143,808686845,12635731,16.52),(161330,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161330,36.35,0.03,179,75523,70,NULL,'SiFTO+SALT2, SN PTF10tce, SN 2010ho','2MASX J23190979+0911455',0.040952,'2012MNRAS.426.2359M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161331,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161331,36.36,0.03,180,75523,70,NULL,'SN 2010ho, SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','2MASX J23190979+0911455',0.040952,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161332,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161332,36.35,0.02,186,75523,NULL,NULL,'H, SN 2010ho','2MASX J23190979+0911455',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161333,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2010ho',NULL,161333,36.36,0.02,187,75523,72,NULL,'M(H) = -18.317 mag','2MASX J23190979+0911455',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161334,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161334,33.3,0.8,45.7,75524,75,NULL,'W91CL, r','UGC 12497',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00002,NULL,'15.58',0.3,'Im:','X-ray-bright group member',NULL,NULL,NULL,1,349.795125,7.70375,0.161,NULL,51748869296,808576082,12634001,15.58),(161335,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161335,32.42,0.43,30.5,75524,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161336,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161336,32.49,0.2,31.5,75524,74.4,NULL,NULL,'UGC 12497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161337,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161337,32.51,0.43,31.7,75524,75,NULL,'3.6 micron, color corrected','UGC 12497',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161338,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161338,32.57,0.38,32.7,75524,75,NULL,'W91CL, r, inv','UGC 12497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161339,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161339,32.68,0.38,34.3,75524,75,NULL,'W91CL, r, raw','UGC 12497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161340,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161340,32.93,0.38,38.5,75524,75,NULL,'W91CL, r, cor','UGC 12497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161341,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161341,33.41,0.11,48.2,75525,NULL,NULL,NULL,'UGC 12501',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',NULL,NULL,'15.66',0.1,'S?',NULL,NULL,NULL,NULL,1,349.795667,10.80233,0.089,NULL,51743361506,808490023,12632656,15.66),(161342,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161342,33.74,0.43,56,75525,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12501',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161343,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161343,33.84,0.43,58.6,75525,75,NULL,'3.6 micron, color corrected','UGC 12501',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161344,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161344,33.95,0.2,61.7,75525,74.4,NULL,NULL,'UGC 12501',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161345,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161345,33.56,0.8,51.6,75526,75,NULL,'W91CL, r','IC 5309',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'14.52',0.6,'Sb',NULL,NULL,NULL,NULL,1,349.7985417,8.10931,0.169,NULL,51748436281,808569316,12633895,14.52),(161346,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161346,33.56,0.8,51.6,75526,75,NULL,'CF, r','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161347,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161347,33.56,0.8,51.6,75526,75,NULL,'HMCL, I','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161348,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161348,33.04,0.69,40.6,75526,100,NULL,'mid-IR','IC 5309',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161349,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161349,33.29,0.43,45.6,75526,75,NULL,'3.6 micron, color + selection bias corrected','IC 5309',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161350,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161350,33.35,0.43,46.8,75526,75,NULL,'3.6 micron, color corrected','IC 5309',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161351,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161351,33.38,0.38,47.4,75526,75,NULL,'CF, r, raw','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161352,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161352,33.43,0.2,48.5,75526,74.4,NULL,NULL,'IC 5309',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161353,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161353,33.44,0.38,48.8,75526,75,NULL,'CF, r, inv','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161354,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161354,33.49,0.09,50,75526,NULL,NULL,NULL,'IC 5309',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161355,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161355,33.5,0.4,50,75526,75,NULL,'HMCL, I, raw','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161356,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161356,33.63,0.4,53.2,75526,75,NULL,'HMCL, I, inv','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161357,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161357,33.65,0.38,53.6,75526,75,NULL,'W91CL, r, raw','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161358,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161358,33.65,0.38,53.8,75526,75,NULL,'CF, r, cor','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161359,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161359,33.73,0.38,55.8,75526,75,NULL,'W91CL, r, inv','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161360,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161360,33.77,0.4,56.7,75526,NULL,NULL,'mean','IC 5309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161361,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161361,33.78,0.4,57,75526,75,NULL,'HMCL, I, cor','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161362,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161362,33.89,0.38,59.9,75526,75,NULL,'W91CL, r, cor','IC 5309',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161363,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161363,33.96,0.47,62,75526,NULL,NULL,'H','IC 5309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161364,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161364,34.03,0.45,64,75526,NULL,NULL,'K','IC 5309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161365,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161365,34.06,0.46,65,75526,NULL,NULL,'J','IC 5309',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161366,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161366,38.41,0.46,482,75527,70,NULL,NULL,'2MASX J23191174+1533109',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,349.799041667,15.55297,0.081,NULL,52529430740,820772355,12824568,17.4),(161367,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161367,36.04,0.25,161,75528,74.4,NULL,NULL,'GIN 677',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000053,NULL,'14.71',0.4,'S',NULL,NULL,NULL,NULL,1,349.805583,18.91122,0.117,NULL,52533535869,820836497,12825570,14.71),(161368,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161368,36.26,0.19,179,75528,70,NULL,NULL,'GIN 677',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161369,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161369,33.12,0.43,42.1,75529,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7608',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.00003,NULL,'15.01',0.4,'S?','X-ray-bright group member',NULL,NULL,NULL,1,349.813875,8.35014,0.145,NULL,51748312699,808567385,12633865,15.01),(161370,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161370,33.21,0.43,43.9,75529,75,NULL,'3.6 micron, color corrected','NGC 7608',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161371,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161371,33.31,0.49,45.8,75529,75,NULL,'IR','NGC 7608',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161372,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161372,33.31,0.2,45.9,75529,74.4,NULL,NULL,'NGC 7608',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161373,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161373,33.34,0.4,46.6,75529,NULL,NULL,'mean','NGC 7608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161374,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161374,33.46,0.11,49.3,75529,NULL,NULL,NULL,'NGC 7608',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161375,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161375,33.53,0.47,50.9,75529,NULL,NULL,'H','NGC 7608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161376,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161376,33.65,0.46,53.6,75529,NULL,NULL,'J','NGC 7608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161377,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161377,33.7,0.45,54.9,75529,NULL,NULL,'K','NGC 7608',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161378,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 08252',NULL,161378,41.19,0.4,1730,75530,70,NULL,'SN photometric redshift distance, z photo =0.536 +/- 0.164','SDSS-II SN 08252',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,349.819333333,0.72381,0.137,NULL,51573850970,805841421,12591272,NULL),(161379,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 08252',NULL,161379,41.63,0.32,2120,75530,70,NULL,'SALT 2','SDSS-II SN 08252',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161380,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 08252',NULL,161380,42.24,0.32,2810,75530,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 08252',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161381,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161381,36.03,0.39,160,75531,NULL,NULL,NULL,'KUG 2316+183',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00003,NULL,'16.5:',0.2,'Sc',NULL,NULL,NULL,NULL,1,349.82875,18.61344,0.097,NULL,52533477763,820835590,12825556,16.5),(161382,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161382,36.07,0.2,164,75531,74.4,NULL,NULL,'KUG 2316+183',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161383,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161383,36.07,0.38,164,75531,NULL,NULL,'Malmquist cor.','KUG 2316+183',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161384,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161384,35.55,0.4,129,75532,NULL,NULL,'Malmquist cor.','UGC 12503',NULL,'2009ApJS..182..474S',2009,1,1.33,NULL,'G',0.000082,NULL,'15.3g',0.34,'S0+? sp',NULL,NULL,NULL,NULL,1,349.82925,0.94586,0.137,NULL,51573923702,805842557,12591289,15.3),(161385,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161385,35.77,0.37,143,75532,NULL,NULL,NULL,'UGC 12503',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161386,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161386,35.81,0.2,145,75532,74.4,NULL,NULL,'UGC 12503',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161387,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161387,34.5,0.49,79.6,75533,70,NULL,NULL,'ESO 470- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000107,NULL,'14.92',0.7,'(R)SB(l)0^+',NULL,NULL,NULL,NULL,1,349.8322083,-28.94283,0.022,NULL,50141008476,783453257,12241457,14.92),(161388,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161388,31.64,0.8,21.3,75534,75,NULL,'MAT, I','NGC 7599',NULL,'1997ApJS..109..333W',1997,1,4.4,'Confused HIPASS source','G',0.000017,NULL,'12.08',1.3,'SB(s)c         LINER','X-ray-faint group member',NULL,NULL,NULL,1,349.838083,-42.25683,NULL,NULL,50528592803,789509262,12336082,12.08),(161389,'Sosies','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161389,31.91,0.06,24.1,75534,NULL,NULL,NULL,'NGC 7599',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161390,'Tully est','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161390,31.52,0.8,20.2,75534,75,NULL,'B','NGC 7599',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161391,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161391,30.93,0.43,15.3,75534,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7599',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161392,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161392,31.01,0.43,15.9,75534,75,NULL,'3.6 micron, color corrected','NGC 7599',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161393,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161393,31.22,0.2,17.5,75534,74.4,NULL,NULL,'NGC 7599',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161394,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161394,31.24,0.32,17.7,75534,85,NULL,'I, raw','NGC 7599',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161395,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161395,31.28,0.32,18,75534,85,NULL,'I, inv','NGC 7599',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161396,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161396,31.32,0.46,18.4,75534,NULL,NULL,'J','NGC 7599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161397,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161397,31.33,0.43,18.5,75534,75,NULL,'MAT, I, raw','NGC 7599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161398,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161398,31.39,0.47,18.9,75534,NULL,NULL,'H','NGC 7599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161399,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161399,31.4,0.45,19.1,75534,NULL,NULL,'K','NGC 7599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161400,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161400,31.47,0.4,19.7,75534,NULL,NULL,'mean','NGC 7599',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161401,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161401,31.5,0.43,19.9,75534,75,NULL,'MAT, I, inv','NGC 7599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161402,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161402,31.58,0.43,20.7,75534,75,NULL,'MAT, I, cor','NGC 7599',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161403,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161403,31.59,0.42,20.8,75534,NULL,NULL,NULL,'NGC 7599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161404,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161404,31.64,0.4,21.3,75534,73,NULL,'opt','NGC 7599',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161405,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161405,31.73,0.39,22.2,75534,NULL,NULL,'Malmquist cor.','NGC 7599',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161406,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161406,34.69,0.61,86.8,75535,NULL,NULL,NULL,'ESO 077- G 013',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'15.66',0.5,'SAB(r)0/a:',NULL,NULL,NULL,NULL,1,349.840167,-67.47433,0,NULL,49264799306,769762489,12027538,15.66),(161407,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161407,34.73,0.2,88.3,75535,74.4,NULL,NULL,'ESO 077- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161408,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161408,34.77,0.59,89.9,75535,NULL,NULL,'Malmquist cor.','ESO 077- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161409,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161409,33.85,0.5,58.8,75536,NULL,NULL,NULL,'KUG 2316+162',NULL,'2009ApJS..182..474S',2009,1,0.7,NULL,'G',0.000067,NULL,'15.7',0.3,'Spiral',NULL,NULL,NULL,NULL,1,349.841167,16.56708,0.073,NULL,52523816222,820684628,12823197,15.7),(161410,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161410,33.89,0.2,60,75536,74.4,NULL,NULL,'KUG 2316+162',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161411,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161411,34.02,0.46,63.7,75536,NULL,NULL,'Malmquist cor.','KUG 2316+162',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161412,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21861','R',161412,39.61,0.22,705,75537,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007sg','SN 2007sg',0.187342,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,349.8587083,-0.90164,0.101,NULL,49409419588,772022181,12062846,NULL),(161413,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 21861','R',161413,39.79,0.19,764,75537,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007sg','SN 2007sg',0.187342,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161414,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161414,36.35,0.46,186,75538,70,NULL,NULL,'2MASX J23192714-0857400',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000066,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,349.8632917,-8.96122,0.057,NULL,49609932817,775155200,12111800,17.6),(161415,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161415,35.38,0.49,119,75539,75,NULL,'IR','MCG +01-59-046',NULL,'2011yCatp016004901K',2011,1,0.74,NULL,'G',0.000324,NULL,'17.23',0.15,'Sc','Compact group member',NULL,NULL,NULL,1,349.866,9.49436,0.129,NULL,51756781975,808699718,12635933,17.23),(161416,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 02568','RN',161416,39.89,0.07,848,75540,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02568',0.118214,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161417,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 02568','RN',161417,40.43,0.19,1090,75540,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02568',0.118214,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161418,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161418,35.09,0.45,104,75541,NULL,NULL,'Malmquist cor.','2MASX J23192955+0100583',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000085,NULL,'15.9g',0.28,'Sb',NULL,NULL,NULL,NULL,1,349.8732083,1.01622,0.145,NULL,51573931544,805842680,12591291,15.9),(161419,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161419,35.18,0.44,108,75541,NULL,NULL,NULL,'2MASX J23192955+0100583',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161420,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161420,35.4,0.2,120,75541,74.4,NULL,NULL,'2MASX J23192955+0100583',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161421,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161421,34.17,NULL,68.2,75542,NULL,NULL,'Dipole','UGC 12506',NULL,'2010Ap&SS.325..163P',2010,1,3.25,NULL,'G',0.000006,NULL,'15.22',0.28,'Sc',NULL,NULL,NULL,NULL,1,349.877,16.07475,0.105,NULL,52525766964,820715108,12823673,15.22),(161422,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161422,34.18,NULL,68.5,75542,NULL,NULL,'Dipole + Quadrupole','UGC 12506',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161423,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161423,34.19,NULL,68.7,75542,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12506',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161424,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161424,34.33,NULL,73.5,75542,NULL,NULL,NULL,'UGC 12506',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161425,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161425,34.58,0.49,82.4,75542,75,NULL,'IR','UGC 12506',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161426,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161426,35.02,0.4,101,75542,NULL,NULL,'mean','UGC 12506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161427,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161427,35.07,0.41,103,75542,NULL,NULL,'Malmquist cor.','UGC 12506',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161428,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161428,35.07,0.2,103,75542,74.4,NULL,NULL,'UGC 12506',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161429,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161429,35.14,0.47,107,75542,NULL,NULL,'H','UGC 12506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161430,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161430,35.14,0.4,107,75542,NULL,NULL,NULL,'UGC 12506',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161431,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161431,35.22,0.45,110,75542,NULL,NULL,'K','UGC 12506',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161432,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161432,33.1,0.45,41.6,75543,NULL,NULL,'K','NGC 7611',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000063,NULL,'13.51',0.6,'SB0+:','X-ray-bright group member',NULL,NULL,NULL,1,349.9025,8.06325,0.157,NULL,51746558154,808539971,12633437,13.51),(161433,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161433,33.2,0.4,43.7,75543,NULL,NULL,'mean','NGC 7611',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161434,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 02656','RN',161434,43.62,0.27,3880,75544,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02656',0.365743,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161435,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 02656','RN',161435,43.91,0.25,4440,75544,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02656',0.365743,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161436,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161436,36.78,0.89,227,75545,70,NULL,NULL,'2MFGC 17516',NULL,'2014MNRAS.445.2677S',2014,1,0.34,NULL,'G',0.00015,NULL,'15.6R',0.09,NULL,NULL,NULL,NULL,NULL,1,349.9029583,-29.49144,NULL,NULL,50185920347,784155005,12252421,15.6),(161437,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161437,33.51,0.11,50.5,75546,NULL,NULL,NULL,'AGC 332094',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'14.9I',0.1,NULL,NULL,NULL,NULL,NULL,1,349.9045,8.08753,0.157,NULL,51746542546,808539727,12633433,14.9),(161438,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161438,34.22,0.2,69.8,75546,74.4,NULL,NULL,'AGC 332094',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161439,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161439,36.79,0.42,228,75547,NULL,NULL,'Malmquist cor.','2MASX J23193747+3524010',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'14.5I',0.3,NULL,NULL,NULL,NULL,NULL,1,349.906083,35.40028,0.281,NULL,51832099936,809876561,12654321,14.5),(161440,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161440,36.97,0.39,247,75547,NULL,NULL,NULL,'2MASX J23193747+3524010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161441,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161441,33.2,0.43,43.6,75548,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7610',NULL,'2014MNRAS.444..527S',2014,1,2.5,'Identification as NGC 7616 is very doubtful.','G',0.000017,NULL,'13.44',1.9,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,349.922375,10.185,0.113,NULL,51743563584,808493181,12632705,13.44),(161442,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161442,33.2,0.43,43.7,75548,75,NULL,'3.6 micron, color corrected','NGC 7610',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161443,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161443,33.24,0.2,44.5,75548,74.4,NULL,NULL,'NGC 7610',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161444,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161444,33.42,NULL,48.3,75548,NULL,NULL,'B','NGC 7610',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161445,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161445,33.51,0.1,50.5,75548,NULL,NULL,NULL,'NGC 7610',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161446,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161446,33.62,NULL,53,75548,NULL,NULL,'I','NGC 7610',NULL,'2005Ap&SS.298..577R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161447,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161447,33.33,0.25,46.3,75549,74.4,NULL,NULL,'NGC 7612',NULL,'2013AJ....146...86T',2013,1,1.6,NULL,'G',0.000037,NULL,'13.74',0.8,'S0','X-ray-bright group member',NULL,NULL,NULL,1,349.934167,8.57639,0.145,NULL,51746442104,808538157,12633408,13.74),(161448,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161448,33.1,0.4,41.8,75549,NULL,NULL,'mean','NGC 7612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161449,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161449,33.3,0.45,45.8,75549,NULL,NULL,'K','NGC 7612',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161450,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14528',NULL,161450,37.78,1.14,360,75550,70,NULL,'SN photometric redshift distance, z photo =0.088 +/- 0.066','SDSS-II SN 14528',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,349.935125,0.47961,0.137,NULL,51573518056,805836219,12591190,NULL),(161451,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161451,37.43,0.46,307,75551,70,NULL,NULL,'SDSS J231946.35+152946.0',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000129,NULL,'18.2g',0.11,NULL,NULL,NULL,NULL,NULL,1,349.943125,15.49611,0.081,NULL,52529441038,820772516,12824570,18.2),(161452,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161452,37.23,0.46,279,75552,70,NULL,NULL,'2MASX J23194843-0001322',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,349.951917,-0.02558,0.113,NULL,49409453847,772022716,12062854,17.2),(161453,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161453,35.43,0.49,122,75553,75,NULL,'IR','2MFGC 17522',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000119,NULL,'16.2g',0.2,'Scd(f)',NULL,NULL,NULL,NULL,1,349.959833,1.06961,0.145,NULL,51573707004,805839171,12591237,16.2),(161454,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161454,35.47,0.2,124,75553,74.4,NULL,NULL,'2MFGC 17522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161455,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161455,35.5,0.49,126,75553,NULL,NULL,'Malmquist cor.','2MFGC 17522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161456,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161456,35.62,0.46,133,75553,NULL,NULL,NULL,'2MFGC 17522',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161457,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161457,35.67,0.2,136,75553,74.4,NULL,NULL,'2MFGC 17522',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161458,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14035',NULL,161458,39.61,0.3,834,75554,70,NULL,'SN photometric redshift distance, z photo =0.218 +/- 0.037','SDSS-II SN 14035',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.3g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,349.9667083,-0.27825,0.093,NULL,49409681235,772026269,12062910,21.3),(161459,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14035','R',161459,40.57,0.29,1010,75554,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14035',0.281725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161460,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 14035','R',161460,40.83,0.33,1140,75554,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14035',0.281725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161461,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161461,34.86,0.2,93.8,75555,74.4,NULL,NULL,'UGC 12513',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000049,NULL,'16.9g',0.16,'Sc(f)',NULL,NULL,NULL,NULL,1,349.966625,1.21811,0.145,NULL,51573743681,805839745,12591246,16.9),(161462,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161462,34.91,0.56,95.9,75555,NULL,NULL,'Malmquist cor.','UGC 12513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161463,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161463,34.95,0.55,97.7,75555,NULL,NULL,NULL,'UGC 12513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161464,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 07811','RN',161464,41.17,0.18,1580,75556,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07811',0.08259,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161465,'SNIa SDSS','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 07811','RN',161465,41.54,0.3,1880,75556,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07811',0.08259,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161466,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161466,33.42,0.09,48.4,75557,NULL,NULL,NULL,'NGC 7615',NULL,'2009ApJS..182..474S',2009,1,1,'1999ApJS..121..287H has V = 3071 +- 32 km/sec.','G',0.000033,NULL,'15.1',0.5,'Sb?','Group member',NULL,NULL,NULL,1,349.976833333,8.39942,0.161,NULL,51746461637,808538463,12633413,15.1),(161467,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161467,33.5,0.2,50.1,75557,74.4,NULL,NULL,'NGC 7615',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161468,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161468,34.39,0.8,75.6,75558,75,NULL,'W91PP, r','UGC 12514',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000005,NULL,'15.37',0.5,'Sdm:',NULL,NULL,NULL,NULL,1,349.980125,26.01167,0.189,NULL,51989558001,812336843,12692763,15.37),(161469,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161469,34.65,0.38,85,75558,75,NULL,'W91PP, r, raw','UGC 12514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161470,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161470,34.67,0.38,85.8,75558,75,NULL,'W91PP, r, inv','UGC 12514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161471,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161471,34.94,0.38,97.4,75558,75,NULL,'W91PP, r, cor','UGC 12514',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161472,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161472,36.26,0.48,178,75559,70,NULL,NULL,'AM 2317-535',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.000087,NULL,'15.89',0.5,'S0',NULL,NULL,NULL,NULL,1,349.9999583,-53.6755,0,NULL,48637767892,759965123,11874455,15.89),(161473,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161473,35.48,0.49,125,75560,75,NULL,'IR','CGCG 497-003',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.59',0.2,'S?',NULL,NULL,NULL,NULL,1,350.0050417,32.92286,0.221,NULL,52053805233,813340706,12708448,15.59),(161474,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161474,33.38,0.43,47.5,75561,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12519',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.000017,NULL,'14.26',0.4,'SB?; Sy2       HII',NULL,NULL,NULL,NULL,1,350.0115417,15.95275,0.105,NULL,52525608934,820712639,12823634,14.26),(161475,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161475,33.41,0.43,48.1,75561,75,NULL,'3.6 micron, color corrected','UGC 12519',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161476,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161476,33.43,0.41,48.6,75561,NULL,NULL,NULL,'UGC 12519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161477,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161477,33.44,0.2,48.8,75561,74.4,NULL,NULL,'UGC 12519',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161478,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161478,33.69,0.36,54.8,75561,NULL,NULL,'Malmquist cor.','UGC 12519',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161479,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161479,33.72,0.49,55.4,75561,75,NULL,'IR','UGC 12519',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161480,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161480,33.82,0.4,58,75561,NULL,NULL,'mean','UGC 12519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161481,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161481,33.82,0.47,58.2,75561,NULL,NULL,'H','UGC 12519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161482,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161482,33.95,0.45,61.7,75561,NULL,NULL,'K','UGC 12519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161483,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161483,33.98,0.46,62.6,75561,NULL,NULL,'J','UGC 12519',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161484,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161484,36.26,0.81,179,75562,70,NULL,NULL,'AM 2317-564 NED01',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.19',0.32,'INTERACTING','in an interacting pair',NULL,NULL,NULL,1,350.016,-56.44964,0,NULL,48811009948,762672030,11916750,16.19),(161485,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161485,37.94,0.12,349,75563,74.2,NULL,'SALT 2','APMUKS(BJ) B231730.59-001946.5',0.11,'2010ApJ...716..712A',2010,1,0.12,NULL,'G',NULL,NULL,'19.80',0.1,NULL,NULL,NULL,NULL,NULL,1,350.018333,-0.05567,0.113,NULL,49409486256,772023222,12062862,19.8),(161486,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161486,38.46,0.14,443,75563,65,NULL,'SALT2','APMUKS(BJ) B231730.59-001946.5',0.11,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161487,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161487,38.25,0.08,447,75563,70,NULL,'SALT 2','APMUKS(BJ) B231730.59-001946.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161488,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161488,38.25,0.08,447,75563,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B231730.59-001946.5',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161489,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161489,38.5,0.13,452,75563,70,NULL,'SALT 2','APMUKS(BJ) B231730.59-001946.5',0.11,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161490,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161490,38.52,0.1,455,75563,65,NULL,'MLCS2k2','APMUKS(BJ) B231730.59-001946.5',0.11,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161491,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 07147','R',161491,38.52,0.18,456,75563,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005jh','APMUKS(BJ) B231730.59-001946.5',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161492,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161492,38.54,NULL,459,75563,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07147, SN 2005jh','APMUKS(BJ) B231730.59-001946.5',0.11,'2012ApJ...748..127F',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161493,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 07147','R',161493,38.79,0.08,516,75563,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005jh','APMUKS(BJ) B231730.59-001946.5',0.11,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161494,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005jh',NULL,161494,38.9,0.03,544,75563,70,NULL,'SIFTO, M(B) -19.210 mag, Alpha 1.487, Beta 3.212, SDSS-II SN 07147, SN 2005jh','APMUKS(BJ) B231730.59-001946.5',0.11,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161495,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161495,33.21,0.4,43.8,75564,75,NULL,'Edat, raw','NGC 7617',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000027,NULL,'14.78',0.7,'SA0^0^:','Group member',NULL,NULL,NULL,1,350.037375,8.16578,0.161,NULL,51746557005,808539953,12633436,14.78),(161496,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161496,33.3,0.4,45.6,75564,75,NULL,'Edat, cor','NGC 7617',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161497,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161497,33.25,0.8,44.7,75565,75,NULL,'CF, r','UGC 12521',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00003,NULL,'14.10',0.9,'SA(s)cd:',NULL,NULL,NULL,NULL,1,350.047833333,-1.85658,0.137,NULL,49630573477,775477710,12116839,14.1),(161498,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161498,32.78,0.69,35.9,75565,100,NULL,'mid-IR','UGC 12521',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161499,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161499,33.54,0.38,51.1,75565,75,NULL,'CF, r, raw','UGC 12521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161500,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161500,33.58,0.4,51.9,75565,NULL,NULL,'mean','UGC 12521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161501,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161501,33.62,0.38,53,75565,75,NULL,'CF, r, inv','UGC 12521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161502,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161502,33.77,0.52,56.8,75565,NULL,NULL,NULL,'UGC 12521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161503,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161503,33.81,0.2,57.8,75565,74.4,NULL,NULL,'UGC 12521',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161504,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161504,33.83,0.38,58.4,75565,75,NULL,'CF, r, cor','UGC 12521',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161505,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161505,33.89,0.49,60,75565,NULL,NULL,'Malmquist cor.','UGC 12521',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161506,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161506,34.08,0.47,65.4,75565,NULL,NULL,'H','UGC 12521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161507,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161507,34.13,0.46,67.1,75565,NULL,NULL,'J','UGC 12521',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161508,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161508,37.03,0.62,255,75566,NULL,NULL,'Malmquist cor.','2MASX J23201233+1848552',NULL,'2009ApJS..182..474S',2009,1,0.47,NULL,'G',0.000027,NULL,'16.01',NULL,'Sb:',NULL,NULL,NULL,NULL,1,350.051375,18.81536,0.117,NULL,52532842615,820825665,12825401,16.01),(161509,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161509,37.39,0.53,300,75566,NULL,NULL,NULL,'2MASX J23201233+1848552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161510,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161510,37.43,0.2,306,75566,74.4,NULL,NULL,'2MASX J23201233+1848552',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161511,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161511,34.52,0.2,80.2,75567,74.4,NULL,NULL,'KUG 2317+253',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000007,NULL,'15.55',0.2,'S?',NULL,NULL,NULL,NULL,1,350.052875,25.59656,0.229,NULL,51989898529,812342164,12692846,15.55),(161512,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161512,34.75,0.44,89,75567,NULL,NULL,NULL,'KUG 2317+253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161513,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161513,34.94,0.4,97.5,75567,NULL,NULL,'Malmquist cor.','KUG 2317+253',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161514,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161514,32.1,0.47,26.3,75568,NULL,NULL,'H','UGC 12518',NULL,'2007A&A...465...71T',2007,1,1.3,'Springob et al. (2005ApJS..160..149S) give v= 3906 km/sec.','G',0.000033,NULL,'15.50',0.2,'Sb',NULL,NULL,NULL,NULL,1,350.053333,7.93208,0.157,NULL,51746969556,808546399,12633537,15.5),(161515,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161515,32.25,0.45,28.2,75568,NULL,NULL,'K','UGC 12518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161516,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161516,32.39,0.46,30,75568,NULL,NULL,'J','UGC 12518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161517,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161517,32.62,0.4,33.4,75568,NULL,NULL,'mean','UGC 12518',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161518,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161518,33.56,0.1,51.6,75568,NULL,NULL,NULL,'UGC 12518',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161519,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161519,33.81,0.49,57.8,75568,75,NULL,'IR','UGC 12518',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161520,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335',NULL,161520,40.57,0.14,1300,75569,70,NULL,'SN photometric redshift distance, z photo =0.368 +/- 0.032','SDSS-II SN 19335',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.0582083,0.39511,0.113,NULL,51573533706,805836464,12591194,NULL),(161521,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335','R',161521,41.26,0.29,1320,75569,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19335',0.350692,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161522,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335','R',161522,41.53,0.28,1500,75569,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19335',0.350692,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161523,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335',NULL,161523,41.1,0.2,1660,75569,70,NULL,'SALT 2','SDSS-II SN 19335',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161524,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19335',NULL,161524,41.15,0.2,1700,75569,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19335',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161525,'CMD','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161525,33.2,0.37,43.7,75570,NULL,NULL,'Photographic, Virgo m-M = 31.0 mag','NGC 7619',NULL,'1981PASP...93...25M',1981,1,2.5,NULL,'G',0.000017,NULL,'12.10',2.3,'E','X-ray-bright group member',NULL,NULL,NULL,1,350.0605417,8.20625,0.161,NULL,51746554484,808539913,12633436,12.1),(161526,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161526,33.6,0.3,52,75570,NULL,NULL,'Photographic','NGC 7619',NULL,'1982ApJ...254....1A',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161527,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161527,33.82,0.3,58.1,75570,60,NULL,'M(V) = -19.47 mag','NGC 7619',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161528,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J','R',161528,33.87,NULL,59.4,75570,NULL,NULL,'Photographic','NGC 7619',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161529,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161529,33.89,0.3,60,75570,60,NULL,'M(B) = -19.48 mag','NGC 7619',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161530,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161530,34,0.26,63,75570,67,NULL,NULL,'NGC 7619',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161531,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 1970J',NULL,161531,34.1,0.07,66.1,75570,66,NULL,NULL,'NGC 7619',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161532,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161532,33.62,0.31,53,75570,NULL,NULL,'I','NGC 7619',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161533,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161533,33.62,0.31,53,75570,NULL,NULL,NULL,'NGC 7619',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161534,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161534,33.64,0.16,54,75570,NULL,NULL,NULL,'NGC 7619',NULL,'2003A&A...399..441M',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161535,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161535,33.7,0.12,55,75570,74.4,NULL,NULL,'NGC 7619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161536,'SBF','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161536,33.84,0.31,58.7,75570,NULL,NULL,'Malmquist cor.','NGC 7619',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161537,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161537,33.21,0.4,43.8,75570,75,NULL,'Edat, raw','NGC 7619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161538,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161538,33.3,0.4,45.6,75570,75,NULL,'Edat, cor','NGC 7619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161539,'D-Sigma','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161539,33.52,0.22,50.5,75570,72,NULL,'Pegasus cluster, 4 galaxies','NGC 7619',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161540,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161540,32.55,0.39,32.4,75570,95,NULL,'de Vaucouleurs','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161541,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161541,32.68,0.27,34.4,75570,95,NULL,'Weighted Mean','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161542,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161542,32.85,0.46,37.2,75570,95,NULL,'Michard 1979a','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161543,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161543,33.12,0.63,42.1,75570,95,NULL,'Michard 1979b, c','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161544,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161544,35.05,0.81,102,75570,55,NULL,'Visvanathan & Sandage 1979','NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161545,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161545,33.61,0.41,52.8,75570,NULL,NULL,NULL,'NGC 7619',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161546,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161546,33.7,0.12,55,75570,74.4,NULL,NULL,'NGC 7619',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161547,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161547,33.96,0.41,61.9,75570,NULL,NULL,'Malmquist cor.','NGC 7619',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161548,'Tertiary','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161548,33.11,0.5,41.9,75570,95,NULL,NULL,'NGC 7619',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161549,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161549,33.18,0.12,43.4,75570,75,NULL,'Pegasus CLUSTER','NGC 7619',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161550,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161550,33.21,0.12,43.9,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE I-band','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161551,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161551,33.22,0.12,44,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161552,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161552,33.23,0.12,44.3,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161553,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161553,33.24,0.14,44.5,75570,75,NULL,'Pegasus cluster, avg. of 12 spiral galaxies','NGC 7619',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161554,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161554,33.26,0.13,44.9,75570,75,NULL,'Pegasus cluster, avg. of 12 spiral galaxies','NGC 7619',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161555,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161555,33.3,0.4,45.7,75570,77,NULL,'Pegasus cluster, 12 galaxies','NGC 7619',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161556,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161556,33.3,NULL,45.7,75570,77,NULL,'BRIK, Pegasus cluster, 12 galaxies','NGC 7619',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161557,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161557,33.37,0.1,47.3,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161558,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161558,33.42,0.1,48.2,75570,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 7619',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161559,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161559,33.5,0.17,50.1,75570,NULL,NULL,'Pegasus cluster, avg. of 13 galaxies [for Virgo m-M = 31.10 mag, D = 16.6 Mpc]','NGC 7619',NULL,'1986A&A...164...17G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161560,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161560,33.54,0.4,51,75570,NULL,NULL,'mean','NGC 7619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161561,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161561,33.63,NULL,53.3,75570,71,NULL,'Pegasus CLUSTER, 80 galaxies','NGC 7619',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161562,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161562,33.66,0.45,54.1,75570,NULL,NULL,'K','NGC 7619',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161563,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161563,33.73,0.3,55.8,75570,NULL,NULL,'Pegasus CLUSTER, 14 galaxies','NGC 7619',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161564,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161564,33.81,0.14,57.8,75570,70,NULL,'Pegasus Cluster','NGC 7619',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161565,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161565,33.82,0.11,58.1,75570,71,NULL,'Pegasus I Cluster','NGC 7619',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161566,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161566,35.15,0.8,107,75571,75,NULL,'W91PP, r','UGC 12528',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.16',0.4,'Sbc',NULL,NULL,NULL,NULL,1,350.082125,35.49144,0.281,NULL,51832138012,809877156,12654330,15.16),(161567,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161567,35.15,0.8,107,75571,75,NULL,'CF, r','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161568,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161568,34.93,0.38,96.7,75571,75,NULL,'CF, r, raw','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161569,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161569,35.04,0.38,102,75571,75,NULL,'CF, r, inv','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161570,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161570,35.08,0.38,104,75571,75,NULL,'W91PP, r, raw','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161571,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161571,35.13,0.38,106,75571,75,NULL,'CF, r, cor','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161572,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161572,35.23,0.42,111,75571,NULL,NULL,'Malmquist cor.','UGC 12528',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161573,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161573,35.25,0.38,112,75571,75,NULL,'W91PP, r, inv','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161574,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161574,35.3,0.38,115,75571,75,NULL,'W91PP, r, cor','UGC 12528',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161575,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161575,35.54,0.36,128,75571,NULL,NULL,NULL,'UGC 12528',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161576,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161576,35.55,0.2,129,75571,74.4,NULL,NULL,'UGC 12528',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161577,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005mq',NULL,161577,40.59,0.22,972,75572,74.2,NULL,'SALT 2','SDSS J232021.79-002059.6',0.35,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.090791667,-0.34989,0.093,NULL,49409640882,772025638,12062900,NULL),(161578,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2005mq',NULL,161578,41.36,0.27,1380,75572,70,NULL,'SALT 2','SDSS J232021.79-002059.6',0.35,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161579,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12136','R',161579,41.43,0.39,1430,75572,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005mq','SDSS J232021.79-002059.6',0.35,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161580,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12136','R',161580,41.63,0.33,1570,75572,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005mq','SDSS J232021.79-002059.6',0.35,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161581,'IRAS','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161581,33.63,0.8,53.2,75573,75,NULL,'W91PP, r','NGC 7624',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000013,NULL,'13.82',0.7,'SBc;HII        Sbrst','Brightest group member',NULL,NULL,'Starburst',1,350.0942083,27.31569,0.209,NULL,52016576514,812759008,12699359,13.82),(161582,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161582,33.06,0.69,40.9,75573,100,NULL,'mid-IR','NGC 7624',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161583,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161583,33.43,0.2,48.5,75573,74.4,NULL,NULL,'NGC 7624',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161584,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161584,33.62,0.53,53,75573,NULL,NULL,NULL,'NGC 7624',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161585,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161585,33.62,0.47,53,75573,NULL,NULL,'H','NGC 7624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161586,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161586,33.62,0.45,53,75573,NULL,NULL,'K','NGC 7624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161587,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161587,33.65,0.46,53.8,75573,NULL,NULL,'J','NGC 7624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161588,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161588,33.73,0.51,55.7,75573,NULL,NULL,'Malmquist cor.','NGC 7624',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161589,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161589,33.73,0.4,55.8,75573,NULL,NULL,'mean','NGC 7624',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161590,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161590,33.8,0.38,57.7,75573,75,NULL,'W91PP, r, raw','NGC 7624',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161591,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161591,33.98,0.38,62.7,75573,75,NULL,'W91PP, r, inv','NGC 7624',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161592,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161592,34.08,0.38,65.3,75573,75,NULL,'W91PP, r, cor','NGC 7624',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161593,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161593,35.45,0.46,123,75574,70,NULL,NULL,'CGCG 380-035',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000102,NULL,'14.7g',0.68,'E0',NULL,NULL,NULL,NULL,1,350.121125,-1.00242,0.129,NULL,49409265510,772019773,12062808,14.7),(161594,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161594,35.64,0.49,135,75574,70,NULL,NULL,'CGCG 380-035',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161595,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2006hk',NULL,161595,40.28,0.12,1140,75575,70,NULL,'Hubble residual 0.14 for z0.28900','SDSS-II SN 13757 HOST',NULL,'2011ApJ...740...92G',2011,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.123791667,-1.15803,0.121,NULL,49409189822,772018590,12062790,NULL),(161596,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SN 2006hk',NULL,161596,40.32,0.22,1160,75575,70,NULL,'SDSS-II SN 13757','SDSS-II SN 13757 HOST',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161597,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 13757','R',161597,41.06,0.22,1260,75575,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hk','SDSS-II SN 13757 HOST',0.289,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161598,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 13757','R',161598,41.22,0.15,1360,75575,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hk','SDSS-II SN 13757 HOST',0.289,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161599,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161599,33.3,0.44,45.7,75576,95,NULL,'Weighted Mean','NGC 7623',NULL,'1984ApJS...56...91D',1984,1,1.2,NULL,'G',0.00007,NULL,'13.88',0.9,'SA0^0^:','X-ray-bright group member',NULL,NULL,NULL,1,350.125083,8.39581,0.157,NULL,51746687116,808541986,12633468,13.88),(161600,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161600,33.66,0.46,54,75576,95,NULL,'Michard 1979a','NGC 7623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161601,'Faber-Jackson','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161601,33.96,0.63,61.9,75576,95,NULL,'Michard 1979b, c','NGC 7623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161602,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161602,33.61,0.25,52.7,75576,74.4,NULL,NULL,'NGC 7623',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161603,'Tertiary','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161603,33.11,0.5,41.9,75576,95,NULL,NULL,'NGC 7623',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161604,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161604,33.42,0.4,48.2,75576,NULL,NULL,'mean','NGC 7623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161605,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161605,33.59,0.45,52.3,75576,NULL,NULL,'K','NGC 7623',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161606,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161606,31.81,0.4,23,75577,75,NULL,'B','NGC 7625',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'12.83',1.4,'SA(rs)a pec    HII',NULL,NULL,NULL,NULL,1,350.1255417,17.22556,0.065,NULL,52523261099,820675954,12823061,12.83),(161607,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19088',NULL,161607,39.46,0.54,779,75578,70,NULL,'SN photometric redshift distance, z photo =0.202 +/- 0.066','SDSS-II SN 19088',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.9g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.1267083,-0.34594,0.093,NULL,49409639293,772025613,12062900,20.9),(161608,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19088','R',161608,40.61,0.22,1030,75578,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19088',0.28304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161609,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 19088','R',161609,41.07,0.34,1280,75578,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19088',0.28304,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161610,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161610,33.65,0.47,53.7,75579,NULL,NULL,'H','UGC 12530',NULL,'2007A&A...465...71T',2007,1,1.4,'Haynes et al. (2011AJ....142..170H) give v = 5947 km/s.','G',0.000033,NULL,'14.46',1.3,'SBcd:',NULL,NULL,NULL,NULL,1,350.1309583,29.30717,0.337,NULL,52070299919,813598436,12712475,14.46),(161611,'Tully-Fisher','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161611,33.74,0.4,56,75579,NULL,NULL,'mean','UGC 12530',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161612,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,'R',161612,37.53,0.46,321,75580,70,NULL,NULL,'2MASX J23203821+1338351',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,350.159083,13.64297,0.101,NULL,52514626732,820541042,12820953,17.2),(161613,'FP','2016-12-15 15:16:05','2016-12-16 11:21:22','1',NULL,NULL,161613,36.83,0.6,232,75581,70,NULL,NULL,'2MASX J23203832-2806065',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.26',0.42,NULL,NULL,NULL,NULL,NULL,1,350.159667,-28.10181,0.016,NULL,50142096438,783470256,12241722,16.26),(161614,'SNIa','2016-12-15 15:16:05','2016-12-16 11:21:22','1','SDSS-II SN 12308',NULL,161614,40.1,0.29,1050,75582,70,NULL,'SN photometric redshift distance, z photo =0.284 +/- 0.050','SDSS-II SN 12308',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,350.175667,0.96519,0.145,NULL,51576675031,805885547,12591961,20.9),(161615,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 12308','R',161615,40.88,0.28,1170,75582,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12308',0.279997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161616,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 12308','R',161616,41.26,0.28,1400,75582,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12308',0.279997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161617,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161617,32.83,0.18,36.8,75583,NULL,NULL,'BV A01','NGC 7626',NULL,'2007ApJ...668..130C',2007,1,2.6,'One of two 6cm sources associated with [WB92] 2318+0756','G',0.000013,NULL,'12.16',2.3,'E pec:         LINER','X-ray-bright group member',NULL,'radio jet',NULL,1,350.1772917,8.21697,0.161,NULL,51746522812,808539418,12633428,12.16),(161618,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161618,33.34,0.12,46.6,75583,74.4,NULL,NULL,'NGC 7626',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161619,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161619,33.67,0.13,54.2,75583,NULL,NULL,'J03','NGC 7626',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161620,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161620,33.67,0.13,54.2,75583,NULL,NULL,'M06','NGC 7626',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161621,'SBF','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161621,33.83,0.13,58.3,75583,NULL,NULL,'T01','NGC 7626',NULL,'2007ApJ...668..130C',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161622,'D-Sigma','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161622,33.21,0.4,43.8,75583,75,NULL,'Edat, raw','NGC 7626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161623,'D-Sigma','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161623,33.3,0.4,45.6,75583,75,NULL,'Edat, cor','NGC 7626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161624,'D-Sigma','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161624,33.52,0.22,50.5,75583,72,NULL,'Pegasus cluster, 4 galaxies','NGC 7626',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161625,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161625,32.56,0.34,32.5,75583,95,NULL,'de Vaucouleurs','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161626,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161626,32.69,0.25,34.5,75583,95,NULL,'Weighted Mean','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161627,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161627,33.25,0.46,44.7,75583,95,NULL,'Michard 1979a','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161628,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161628,33.61,0.63,52.7,75583,95,NULL,'Michard 1979b, c','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161629,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161629,34.16,0.81,67.9,75583,55,NULL,'Visvanathan & Sandage 1979','NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161630,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161630,33.34,0.12,46.6,75583,74.4,NULL,NULL,'NGC 7626',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161631,'Tertiary','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161631,33.11,0.5,41.9,75583,95,NULL,NULL,'NGC 7626',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161632,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161632,33.21,0.12,43.9,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE I-band','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161633,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161633,33.22,0.12,44,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161634,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161634,33.23,0.12,44.3,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161635,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161635,33.24,0.14,44.5,75583,75,NULL,'Pegasus cluster, avg. of 12 spiral galaxies','NGC 7626',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161636,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161636,33.26,0.13,44.9,75583,75,NULL,'Pegasus cluster, avg. of 12 spiral galaxies','NGC 7626',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161637,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161637,33.3,0.4,45.7,75583,77,NULL,'Pegasus cluster, 12 galaxies','NGC 7626',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161638,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161638,33.3,NULL,45.7,75583,77,NULL,'BRIK, Pegasus cluster, 12 galaxies','NGC 7626',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161639,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161639,33.37,0.1,47.3,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161640,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161640,33.42,0.1,48.2,75583,74.4,NULL,'Pegasus CLUSTER, 17 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 7626',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161641,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161641,33.41,0.4,48.2,75583,NULL,NULL,'mean','NGC 7626',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161642,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161642,33.49,0.45,50,75583,NULL,NULL,'K','NGC 7626',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161643,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161643,33.5,0.17,50.1,75583,NULL,NULL,'Pegasus cluster, avg. of 13 galaxies [for Virgo m-M = 31.10 mag, D = 16.6 Mpc]','NGC 7626',NULL,'1986A&A...164...17G',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161644,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161644,33.63,NULL,53.3,75583,71,NULL,'Pegasus CLUSTER, 80 galaxies','NGC 7626',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161645,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161645,33.73,0.3,55.8,75583,NULL,NULL,'Pegasus CLUSTER, 14 galaxies','NGC 7626',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161646,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161646,33.81,0.14,57.8,75583,70,NULL,'Pegasus Cluster','NGC 7626',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161647,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161647,33.82,0.11,58.1,75583,71,NULL,'Pegasus I Cluster','NGC 7626',NULL,'1982PASAu...4..419V',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161648,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161648,37.74,0.33,353,75584,70,NULL,NULL,'SDSS J232045.32-090917.8',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000079,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,350.188875,-9.15497,0.071,NULL,49609907522,775154805,12111793,17.8),(161649,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','PTF09fox',NULL,161649,37.34,0.06,274,75585,70,NULL,'SiFTO+SALT2, SN PTF09fox','PTF09fox',0.0707,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.199916667,32.50228,0.297,NULL,52061739549,813464680,12710385,NULL),(161650,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','PTF09fox',NULL,161650,37.38,0.06,279,75585,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09fox',0.0707,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161651,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161651,25,0.8,1,75586,75,NULL,NULL,'ESO 347- G 008',NULL,'1988NBGC.C....0000T',1988,1,1.7,'RC3 velocity of 16+/-9 km/sec is a misprint. See 1998, A&AS, 127, 463.','G',0.000013,NULL,'14.61',1.4,'SAB(s)m',NULL,NULL,NULL,NULL,1,350.204583,-41.73083,NULL,0,50528478245,789507472,12336054,14.61),(161652,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161652,36.37,0.62,188,75587,70,NULL,NULL,'2MASX J23205143-0100409',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.000083,NULL,'16.4g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.21425,-1.01133,0.129,NULL,49412734376,772073974,12063655,16.4),(161653,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161653,34.44,0.8,77.2,75588,75,NULL,'W91PP, r','UGC 12533',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00001,NULL,'15.52',0.19,'Sbc',NULL,NULL,NULL,NULL,1,350.219875,23.8075,0.169,NULL,51990556694,812352448,12693007,15.52),(161654,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161654,34.44,0.8,77.2,75588,75,NULL,'MAT, I','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161655,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161655,34.59,0.4,82.9,75588,NULL,NULL,'mean','UGC 12533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161656,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161656,34.87,0.45,94,75588,NULL,NULL,'K','UGC 12533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161657,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161657,34.89,0.47,95.2,75588,NULL,NULL,'H','UGC 12533',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161658,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161658,35.05,0.43,102,75588,75,NULL,'MAT, I, raw','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161659,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161659,35.06,0.49,103,75588,75,NULL,'IR','UGC 12533',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161660,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161660,35.18,0.34,109,75588,NULL,NULL,NULL,'UGC 12533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161661,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161661,35.18,0.34,109,75588,NULL,NULL,'Malmquist cor.','UGC 12533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161662,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161662,35.2,0.32,110,75588,85,NULL,'I, raw','UGC 12533',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161663,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161663,35.22,0.2,111,75588,74.4,NULL,NULL,'UGC 12533',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161664,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161664,35.22,0.38,111,75588,75,NULL,'W91PP, r, raw','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161665,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161665,35.27,0.32,113,75588,85,NULL,'I, inv','UGC 12533',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161666,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161666,35.31,0.43,115,75588,75,NULL,'MAT, I, cor','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161667,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161667,35.33,0.43,116,75588,75,NULL,'MAT, I, inv','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161668,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161668,35.4,0.38,120,75588,75,NULL,'W91PP, r, cor','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161669,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161669,35.44,0.38,122,75588,75,NULL,'W91PP, r, inv','UGC 12533',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161670,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161670,35.48,NULL,125,75588,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161671,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161671,35.49,NULL,125,75588,NULL,NULL,'Dipole + Quadrupole','UGC 12533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161672,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161672,35.5,NULL,126,75588,NULL,NULL,'Dipole','UGC 12533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161673,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161673,35.74,NULL,141,75588,NULL,NULL,NULL,'UGC 12533',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161674,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 20874','RN',161674,39.74,0.16,785,75589,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 20874',0.130635,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161675,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 20874','RN',161675,40.1,0.28,926,75589,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 20874',0.130635,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161676,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161676,37.33,0.46,292,75590,70,NULL,NULL,'2MASX J23205652-0055236',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000074,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,350.2355,-0.92311,0.137,NULL,49412763946,772074436,12063663,18),(161677,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161677,32.39,0.43,30.1,75591,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12535',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',NULL,NULL,'15.65',0.1,'Sb-c',NULL,NULL,NULL,NULL,1,350.256583333,8.1795,0.157,NULL,51747178145,808549658,12633588,15.65),(161678,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161678,32.7,0.43,34.6,75591,75,NULL,'3.6 micron, color corrected','UGC 12535',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161679,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161679,32.93,0.2,38.6,75591,74.4,NULL,NULL,'UGC 12535',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161680,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161680,33.01,0.49,40.1,75591,75,NULL,'IR','UGC 12535',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161681,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161681,33.52,0.1,50.7,75591,NULL,NULL,NULL,'UGC 12535',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161682,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161682,34.44,0.2,77.3,75592,74.4,NULL,NULL,'CGCG 406-077',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'15.6',0.2,NULL,NULL,NULL,NULL,NULL,1,350.256833333,7.91486,0.161,NULL,51747193394,808549896,12633592,15.6),(161683,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161683,33.38,0.49,47.5,75593,75,NULL,'IR','CGCG 476-015',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.000012,NULL,'15.7',0.3,'Sc',NULL,NULL,NULL,NULL,1,350.265875,26.41972,0.181,NULL,51989479822,812335622,12692744,15.7),(161684,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161684,33.38,0.8,47.4,75594,75,NULL,'W91CL, r','KUG 2318+078',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.21',0.5,'SB?','X-ray-bright group member',NULL,NULL,NULL,1,350.2740417,8.10239,0.161,NULL,51747184267,808549754,12633589,15.21),(161685,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161685,31.99,0.43,25,75594,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2318+078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161686,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161686,32.16,0.43,27,75594,75,NULL,'3.6 micron, color corrected','KUG 2318+078',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161687,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161687,33.31,0.38,45.9,75594,75,NULL,'W91CL, r, inv','KUG 2318+078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161688,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161688,33.36,0.38,47.1,75594,75,NULL,'W91CL, r, raw','KUG 2318+078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161689,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161689,33.52,0.08,50.7,75594,NULL,NULL,NULL,'KUG 2318+078',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161690,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161690,33.64,0.38,53.4,75594,75,NULL,'W91CL, r, cor','KUG 2318+078',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161691,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161691,34.26,0.2,71.1,75595,74.4,NULL,NULL,'KUG 2318+026',NULL,'2013AJ....146...86T',2013,1,0.9,'Incorrectly identified as IC 1482 in MCG.','G',0.000067,NULL,'15.26',0.6,'SBc',NULL,NULL,NULL,NULL,1,350.2795,2.88392,0.121,NULL,51772973851,808952716,12639886,15.26),(161692,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161692,35.54,0.46,128,75596,70,NULL,NULL,'CGCG 380-038',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.000107,NULL,'15.5g',0.52,'E0',NULL,NULL,NULL,NULL,1,350.280083,0.39986,0.137,NULL,51577060618,805891572,12592055,15.5),(161693,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161693,34.5,0.8,79.3,75597,75,NULL,'W91PP, r','UGC 12537',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.00002,NULL,'15.03',0.7,'S?',NULL,NULL,NULL,NULL,1,350.282833,29.54956,0.265,NULL,52070386271,813599785,12712496,15.03),(161694,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161694,33.86,0.69,59.1,75597,100,NULL,'mid-IR','UGC 12537',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161695,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161695,35.27,0.38,113,75597,75,NULL,'W91PP, r, raw','UGC 12537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161696,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161696,35.48,0.38,125,75597,75,NULL,'W91PP, r, cor','UGC 12537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161697,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161697,35.53,0.38,128,75597,75,NULL,'W91PP, r, inv','UGC 12537',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161698,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161698,37.74,0.33,353,75598,70,NULL,NULL,'2MASX J23210857-0906239',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000068,NULL,'17.4g',0.22,NULL,NULL,NULL,NULL,NULL,1,350.285625,-9.10669,0.071,NULL,49609864024,775154125,12111783,17.4),(161699,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006B',NULL,161699,33.44,0.24,48,75599,74.2,NULL,'SALT 2','UGC 12538',0.016335,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000033,NULL,'14.80',0.3,'S?             HII',NULL,NULL,NULL,NULL,1,350.290833,33.39956,0.229,NULL,52053916969,813342452,12708475,14.8),(161700,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006B',NULL,161700,34.01,0.09,63.4,75599,74.4,NULL,NULL,'UGC 12538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161701,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161701,33.99,0.8,62.8,75599,75,NULL,'W91PP, r','UGC 12538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161702,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161702,33.82,0.4,58.1,75599,75,NULL,'HOSTS SN 2006B','UGC 12538',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161703,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161703,33.95,0.38,61.5,75599,75,NULL,'W91PP, r, raw','UGC 12538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161704,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161704,34,0.38,63.1,75599,75,NULL,'W91PP, r, inv','UGC 12538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161705,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161705,34.01,0.09,63.4,75599,74.4,NULL,NULL,'UGC 12538',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161706,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161706,34.21,0.38,69.4,75599,75,NULL,'W91PP, r, cor','UGC 12538',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161707,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15353','R',161707,40.85,0.24,1140,75600,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232109.99-001032.9',0.2996,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.0005,NULL,'20.3g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,350.291625,-0.17583,0.105,NULL,49412317720,772067464,12063554,20.3),(161708,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15353','R',161708,41.01,0.18,1220,75600,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232109.99-001032.9',0.2996,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161709,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15353',NULL,161709,40.76,0.14,1420,75600,70,NULL,'SALT 2','SDSS J232109.99-001032.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161710,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15353',NULL,161710,40.79,0.14,1440,75600,70,NULL,'SALT 2, Malmquist cor.','SDSS J232109.99-001032.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161711,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19074','RN',161711,44.18,0.38,4570,75601,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19074',0.500167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161712,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161712,36,0.39,158,75602,NULL,NULL,NULL,'2MASX J23211571+1831330',NULL,'2009ApJS..182..474S',2009,1,0.55,NULL,'G',0.000027,NULL,'15.52',NULL,'Scd',NULL,NULL,NULL,NULL,1,350.315541667,18.52592,0.077,NULL,52531018817,820797169,12824955,15.52),(161713,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161713,36.04,0.2,161,75602,74.4,NULL,NULL,'2MASX J23211571+1831330',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161714,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161714,36.06,0.38,163,75602,NULL,NULL,'Malmquist cor.','2MASX J23211571+1831330',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161715,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161715,38.03,0.46,405,75603,70,NULL,NULL,'2MASX J23211617+1528331',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,350.317583333,15.47578,0.109,NULL,52528852816,820763325,12824426,18),(161716,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161716,35.93,0.5,154,75604,70,NULL,NULL,'2MASX J23211640-2117211',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.000093,NULL,'15.89',0.33,'S0',NULL,NULL,NULL,NULL,1,350.318333333,-21.28928,0.025,NULL,50311531792,786117684,12283088,15.89),(161717,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161717,33.44,0.8,48.9,75605,75,NULL,'W91CL, r','CGCG 406-082',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000023,NULL,'15.53',50.2,NULL,NULL,NULL,NULL,NULL,1,350.320958333,7.48117,0.209,NULL,51802229271,809409832,12647028,15.53),(161718,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161718,32.58,0.43,32.8,75605,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 406-082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161719,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161719,32.85,0.43,37.1,75605,75,NULL,'3.6 micron, color corrected','CGCG 406-082',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161720,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161720,33.04,0.2,40.6,75605,74.4,NULL,NULL,'CGCG 406-082',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161721,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161721,33.33,0.38,46.3,75605,75,NULL,'W91CL, r, inv','CGCG 406-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161722,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161722,33.35,0.38,46.8,75605,75,NULL,'W91CL, r, raw','CGCG 406-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161723,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161723,33.62,0.38,53.1,75605,75,NULL,'W91CL, r, cor','CGCG 406-082',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161724,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15031','R',161724,37.56,0.05,316,75606,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006iw','2MASX J23211915+0015329',0.030776,'2014arXiv1401.3317S',2014,1,0.48,NULL,'G',0.000061,NULL,'17.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.3299583,0.25911,0.137,NULL,51576858651,805888416,12592006,17.1),(161725,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15031','R',161725,38.39,0.2,462,75606,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006iw','2MASX J23211915+0015329',0.030776,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161726,'SNII optical','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006iw',NULL,161726,35.74,0.09,137,75606,NULL,NULL,'SCM 55 SNII','2MASX J23211915+0015329',0.030776,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161727,'SNII optical','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006iw',NULL,161727,35.91,0.11,147,75606,NULL,NULL,'SCM 15 SDSS SNII','2MASX J23211915+0015329',0.030776,'2010ApJ...708..661D',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161728,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161728,35.64,0.46,135,75607,70,NULL,NULL,'2MASX J23212040-1005479',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000081,NULL,'16.2g',0.32,'S0',NULL,NULL,NULL,NULL,1,350.334917,-10.09661,0.047,NULL,49608815497,775137742,12111527,16.2),(161729,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161729,37.24,0.46,281,75608,70,NULL,NULL,'2MASX J23212094-0939099',NULL,'2015arXiv151105856S',2015,1,0.46,'This galaxy lenses a z = 0.532 object.','G',0.00009,NULL,'16.4g',0.32,'E',NULL,NULL,NULL,NULL,1,350.3372083,-9.65286,0.058,NULL,49610167069,775158860,12111857,16.4),(161730,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161730,35.64,0.6,134,75609,70,NULL,NULL,'CGCG 380-041',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000078,NULL,'15.5g',0.42,'Sa',NULL,NULL,NULL,NULL,1,350.353291667,-0.98569,0.137,NULL,49412748051,772074188,12063659,15.5),(161731,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15210','RN',161731,39.48,0.2,699,75610,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15210',0.125956,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161732,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15210','RN',161732,39.56,0.13,724,75610,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15210',0.125956,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161733,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161733,33.29,0.8,45.5,75611,75,NULL,'HMCL, I','NGC 7631',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.00002,NULL,'13.93',0.7,'SA(r)b:','X-ray-bright group member',NULL,NULL,NULL,1,350.361125,8.21764,0.157,NULL,51747186361,808549786,12633590,13.93),(161734,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161734,33.29,0.8,45.5,75611,75,NULL,'W91CL, r','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161735,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161735,33.29,0.8,45.6,75611,75,NULL,'MAT, I','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161736,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161736,33.32,0.8,46.1,75611,75,NULL,'CF, r','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161737,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161737,33.32,0.4,46.1,75611,75,NULL,'HMCL, I, raw','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161738,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161738,33.34,0.32,46.6,75611,85,NULL,'I, raw','NGC 7631',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161739,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161739,33.39,0.32,47.6,75611,85,NULL,'I, inv','NGC 7631',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161740,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161740,33.41,0.43,48.1,75611,75,NULL,'MAT, I, raw','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161741,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161741,33.42,0.38,48.3,75611,75,NULL,'CF, r, raw','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161742,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161742,33.49,0.4,49.8,75611,75,NULL,'HMCL, I, inv','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161743,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161743,33.5,0.46,50,75611,NULL,NULL,'J','NGC 7631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161744,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161744,33.52,0.4,50.5,75611,NULL,NULL,'mean','NGC 7631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161745,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161745,33.52,0.38,50.7,75611,75,NULL,'W91CL, r, raw','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161746,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161746,33.54,0.47,51,75611,NULL,NULL,'H','NGC 7631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161747,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161747,33.55,0.38,51.3,75611,75,NULL,'CF, r, inv','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161748,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161748,33.56,0.45,51.4,75611,NULL,NULL,'K','NGC 7631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161749,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161749,33.57,0.07,51.9,75611,NULL,NULL,NULL,'NGC 7631',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161750,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161750,33.62,0.4,52.9,75611,75,NULL,'HMCL, I, cor','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161751,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161751,33.62,0.2,53,75611,74.4,NULL,NULL,'NGC 7631',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161752,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161752,33.63,0.43,53.3,75611,75,NULL,'MAT, I, inv','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161753,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161753,33.65,0.43,53.6,75611,75,NULL,'3.6 micron, color corrected','NGC 7631',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161754,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161754,33.66,0.38,53.9,75611,75,NULL,'W91CL, r, inv','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161755,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161755,33.69,0.38,54.7,75611,75,NULL,'CF, r, cor','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161756,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161756,33.74,0.43,56,75611,75,NULL,'MAT, I, cor','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161757,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161757,33.75,0.43,56.3,75611,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7631',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161758,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161758,33.78,0.38,57,75611,75,NULL,'W91CL, r, cor','NGC 7631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161759,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 16093','R',161759,41.23,0.26,1310,75612,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oe','SDSS J232127.00+010756.9',0.34,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.3625,1.13247,0.137,NULL,51576821067,805887829,12591997,NULL),(161760,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 16093','R',161760,41.28,0.2,1340,75612,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oe','SDSS J232127.00+010756.9',0.34,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161761,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006oe',NULL,161761,41.14,0.16,1690,75612,70,NULL,'SALT 2','SDSS J232127.00+010756.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161762,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 2006oe',NULL,161762,41.18,0.16,1720,75612,70,NULL,'SALT 2, Malmquist cor.','SDSS J232127.00+010756.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161763,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161763,34.73,NULL,88.5,75613,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2491',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000003,NULL,'15.95',0.12,'Sc',NULL,NULL,NULL,NULL,1,350.3665,26.47794,0.237,NULL,51985483342,812273177,12691768,15.95),(161764,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161764,34.75,NULL,89.3,75613,NULL,NULL,'Dipole + Quadrupole','FGC 2491',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161765,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161765,34.77,NULL,89.8,75613,NULL,NULL,'Dipole','FGC 2491',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161766,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161766,36,0.33,159,75614,70,NULL,NULL,'2MASX J23213017+1526224',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.00018,NULL,'15.6g',0.39,'E0',NULL,NULL,NULL,NULL,1,350.375625,15.43953,0.109,NULL,52528860600,820763446,12824428,15.6),(161767,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161767,34.44,0.8,77.1,75615,75,NULL,'W91PP, r','UGC 12543',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000015,NULL,'15.44',0.2,'Scd:','in a triple',NULL,NULL,NULL,1,350.389583,27.11806,0.197,NULL,52016618767,812759668,12699369,15.44),(161768,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161768,34.44,0.8,77.2,75615,75,NULL,'CF, r','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161769,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161769,33.27,0.44,45.1,75615,NULL,NULL,NULL,'UGC 12543',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161770,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161770,33.42,0.41,48.2,75615,NULL,NULL,'Malmquist cor.','UGC 12543',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161771,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161771,33.51,0.2,50.4,75615,74.4,NULL,NULL,'UGC 12543',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161772,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161772,34.05,0.38,64.5,75615,75,NULL,'W91PP, r, inv','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161773,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161773,34.07,0.38,65.3,75615,75,NULL,'W91PP, r, raw','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161774,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161774,34.36,0.38,74.3,75615,75,NULL,'W91PP, r, cor','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161775,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161775,34.36,0.49,74.5,75615,75,NULL,'IR','UGC 12543',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161776,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161776,34.55,0.38,81.4,75615,75,NULL,'CF, r, raw','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161777,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161777,34.6,0.38,83.2,75615,75,NULL,'CF, r, inv','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161778,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161778,34.85,0.38,93.1,75615,75,NULL,'CF, r, cor','UGC 12543',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161779,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161779,37.34,0.46,294,75616,70,NULL,NULL,'2MASX J23213372+1459214',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000166,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,350.390541667,14.98944,0.101,NULL,52528217196,820753393,12824271,17.2),(161780,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161780,35.86,0.52,149,75617,70,NULL,NULL,'2MASX J23213731-7612342',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'16.2b',0.24,NULL,NULL,NULL,NULL,NULL,1,350.405291667,-76.2095,0.197,NULL,48432466595,756757290,11824332,16.2),(161781,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161781,35.7,0.34,138,75618,NULL,NULL,NULL,'ESO 347- G 010',NULL,'2009ApJS..182..474S',2009,1,0.95,NULL,'G',0.000033,NULL,'15.21',0.26,'Sb',NULL,NULL,NULL,NULL,1,350.416667,-39.20097,NULL,NULL,49967329819,780739528,12199055,15.21),(161782,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161782,35.74,0.2,141,75618,74.4,NULL,NULL,'ESO 347- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161783,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161783,35.82,0.33,146,75618,NULL,NULL,'Malmquist cor.','ESO 347- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161784,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161784,34.42,0.58,76.7,75619,70,NULL,NULL,'AM 2318-481',NULL,'2014MNRAS.445.2677S',2014,1,0.7,'1984MNRAS.210...69F has V = 10100: +- 200 km/s.','G',0.00015,NULL,'15.45',0.57,'S0',NULL,NULL,NULL,NULL,1,350.420375,-48.01558,NULL,NULL,50521348864,789396076,12334313,15.45),(161785,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161785,32.92,0.43,38.4,75620,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 406-086',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00002,NULL,'15.5',0.6,'S','X-ray-bright group member',NULL,NULL,NULL,1,350.420667,8.99,0.113,NULL,51754221895,808659717,12635308,15.5),(161786,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161786,33.2,0.49,43.7,75620,75,NULL,'IR','CGCG 406-086',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161787,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J','R',161787,33.55,NULL,51.3,75621,NULL,NULL,'Photographic','NGC 7634',NULL,'1988SSRv...48....1R',1988,1,1.2,NULL,'G',0.0001,NULL,'13.57',0.9,'SB0','X-ray-bright group member',NULL,NULL,NULL,1,350.424,8.88692,0.113,NULL,51754243467,808660054,12635313,13.57),(161788,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161788,33.58,0.14,52,75621,60,NULL,NULL,'NGC 7634',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161789,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161789,33.6,0.31,52,75621,67,NULL,NULL,'NGC 7634',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161790,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161790,33.6,0.21,52.5,75621,66,NULL,NULL,'NGC 7634',NULL,'1994A&A...281...51M',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161791,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161791,33.81,0.3,57.8,75621,60,NULL,'M(V) = -19.47 mag','NGC 7634',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161792,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SN 1972J',NULL,161792,33.9,0.3,60.3,75621,60,NULL,'M(B) = -19.48 mag','NGC 7634',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161793,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161793,33.09,0.4,41.4,75621,NULL,NULL,'mean','NGC 7634',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161794,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161794,33.41,0.45,48.2,75621,NULL,NULL,'K','NGC 7634',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161795,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161795,34.35,0.8,74.3,75622,75,NULL,'W91PP, r','UGC 12545',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'15.06',0.5,'SBcd:','in a triple',NULL,NULL,NULL,1,350.424666667,27.07072,0.197,NULL,52015784711,812746636,12699166,15.06),(161796,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161796,34.03,0.38,63.9,75622,75,NULL,'W91PP, r, inv','UGC 12545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161797,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161797,34.03,0.38,64.1,75622,75,NULL,'W91PP, r, raw','UGC 12545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161798,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161798,34.31,0.38,72.8,75622,75,NULL,'W91PP, r, cor','UGC 12545',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161799,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161799,34.8,0.2,91.2,75623,74.4,NULL,NULL,'LSBC F677-03',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',NULL,NULL,'17.19',0.3,'Sm',NULL,NULL,NULL,NULL,1,350.440833,16.79056,0.061,NULL,52525357339,820708708,12823573,17.19),(161800,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161800,35.02,0.75,101,75623,NULL,NULL,NULL,'LSBC F677-03',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161801,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161801,35.2,0.69,110,75623,NULL,NULL,'Malmquist cor.','LSBC F677-03',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161802,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161802,32.24,0.43,28,75624,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2319+090A',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',NULL,NULL,'15.6',0.5,'Spiral','Group member',NULL,NULL,NULL,1,350.442833,9.34189,0.113,NULL,51757461395,808710334,12636098,15.6),(161803,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769','R',161803,40.22,0.23,883,75625,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19769',0.252512,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.4435,-0.97642,0.137,NULL,49412852457,772075819,12063684,NULL),(161804,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769',NULL,161804,39.81,0.31,917,75625,70,NULL,'SN photometric redshift distance, z photo =0.243 +/- 0.044','SDSS-II SN 19769',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161805,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769','R',161805,40.33,0.16,930,75625,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19769',0.252512,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161806,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769',NULL,161806,40.03,0.12,1010,75625,70,NULL,'SALT 2','SDSS-II SN 19769',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161807,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 19769',NULL,161807,40.05,0.12,1020,75625,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19769',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161808,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161808,33.51,0.27,50.5,75626,NULL,NULL,NULL,'GALEX 2665332768378979438',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'16.97',0.1,'Sbc',NULL,NULL,NULL,NULL,1,350.444583,9.04306,0.113,NULL,51754236935,808659952,12635311,16.97),(161809,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161809,34.04,0.8,64.4,75627,75,NULL,'HMCL, I','UGC 12547',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000023,NULL,'14.81',0.7,'SB?','Pair member (points to parent)',NULL,NULL,NULL,1,350.464875,5.00639,0.201,NULL,51769096208,808892128,12638939,14.81),(161810,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161810,34.05,0.8,64.5,75627,75,NULL,'W91CL, r','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161811,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161811,33.21,0.2,43.9,75627,74.4,NULL,NULL,'UGC 12547',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161812,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161812,33.3,0.38,45.7,75627,75,NULL,'W91CL, r, inv','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161813,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161813,33.32,0.38,46,75627,75,NULL,'W91CL, r, raw','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161814,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161814,33.4,0.4,47.9,75627,75,NULL,'HMCL, I, raw','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161815,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161815,33.44,0.4,48.8,75627,75,NULL,'HMCL, I, inv','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161816,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161816,33.48,0.48,49.8,75627,NULL,NULL,NULL,'UGC 12547',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161817,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161817,33.59,0.38,52.3,75627,75,NULL,'W91CL, r, cor','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161818,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161818,33.72,0.4,55.4,75627,75,NULL,'HMCL, I, cor','UGC 12547',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161819,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161819,33.75,0.42,56.1,75627,NULL,NULL,'Malmquist cor.','UGC 12547',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161820,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161820,36,0.33,159,75628,70,NULL,NULL,'2MASX J23215441+1518236',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00016,NULL,'16.4g',0.33,NULL,NULL,NULL,NULL,NULL,1,350.476667,15.30653,0.109,NULL,52527732342,820745817,12824153,16.4),(161821,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 01744','RN',161821,40.63,0.34,1130,75629,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01744',0.189523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161822,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 01744','RN',161822,40.84,0.25,1240,75629,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01744',0.189523,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161823,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161823,33.52,0.49,50.5,75630,75,NULL,'IR','UGC 12548',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000103,NULL,'14.80',0.2,'Sa?','Pair member (points to parent)',NULL,NULL,NULL,1,350.488625,5.03581,0.201,NULL,51769096498,808892132,12638939,14.8),(161824,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 03849','RN',161824,42.58,0.61,2770,75631,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03849',0.183685,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161825,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161825,31.43,0.8,19.3,75632,75,NULL,NULL,'NGC 7632',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000087,NULL,'12.95',1.1,'(RL)SB(1:)0^+  HII','X-ray-faint group member',NULL,NULL,NULL,1,350.50375,-42.4805,NULL,NULL,50528733302,789511457,12336116,12.95),(161826,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15303','R',161826,40.7,0.21,1120,75633,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232202.12+003227.3',0.234,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,NULL,'20.6g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,350.508875,0.54094,0.145,NULL,51576918046,805889344,12592021,20.6),(161827,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15303','R',161827,40.85,0.14,1200,75633,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232202.12+003227.3',0.234,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161828,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15303',NULL,161828,40.61,0.11,1320,75633,70,NULL,'SALT 2','SDSS J232202.12+003227.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161829,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 15303',NULL,161829,40.63,0.11,1340,75633,70,NULL,'SALT 2, Malmquist cor.','SDSS J232202.12+003227.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161830,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161830,35.28,0.43,114,75634,NULL,NULL,'Malmquist cor.','UGC 12552',NULL,'2009ApJS..182..474S',2009,1,1.8,NULL,'G',0.000017,NULL,'15.32',0.3,'Sab',NULL,NULL,NULL,NULL,1,350.518875,13.03572,0.089,NULL,51626382426,806662225,12604097,15.32),(161831,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161831,35.37,0.42,118,75634,NULL,NULL,NULL,'UGC 12552',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161832,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161832,35.57,0.2,130,75634,74.4,NULL,NULL,'UGC 12552',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161833,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161833,36.47,0.65,197,75635,70,NULL,NULL,'2MASX J23220480-5330039',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.00015,NULL,'17.12',0.16,NULL,NULL,NULL,NULL,NULL,1,350.520125,-53.50111,0,NULL,48637868278,759966691,11874479,17.12),(161834,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 01373','RN',161834,41.83,0.12,1730,75636,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01373',0.347318,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161835,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 01373','RN',161835,41.87,0.2,1760,75636,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01373',0.347318,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161836,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161836,29.63,0.1,8.45,75637,74.4,NULL,NULL,'NGC 7640',NULL,'2013AJ....146...86T',2013,1,10.5,NULL,'G',0.000004,NULL,'11.86',2,'SB(s)c         HII','X-ray-bright group member',NULL,NULL,NULL,1,350.527417,40.84542,0.425,NULL,55335904729,864623511,13509742,11.86),(161837,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161837,29.78,0.8,9.05,75637,75,NULL,'A82, H','NGC 7640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161838,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161838,29.23,0.4,7,75637,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7640',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161839,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161839,29.47,0.47,7.84,75637,75,NULL,'A82, H, inv','NGC 7640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161840,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161840,29.49,NULL,7.91,75637,NULL,NULL,NULL,'NGC 7640',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161841,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161841,29.51,0.47,7.99,75637,75,NULL,'A82, H, raw','NGC 7640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161842,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161842,29.63,0.1,8.45,75637,74.4,NULL,NULL,'NGC 7640',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161843,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161843,29.68,0.4,8.6,75637,75,NULL,'B','NGC 7640',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161844,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161844,29.82,0.47,9.21,75637,75,NULL,'A82, H, cor','NGC 7640',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161845,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161845,29.97,0.35,9.86,75637,NULL,NULL,NULL,'NGC 7640',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161846,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161846,29.98,0.4,9.9,75637,73,NULL,'opt','NGC 7640',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161847,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161847,30.01,0.43,10,75637,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7640',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161848,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161848,30.22,0.43,11.1,75637,75,NULL,'3.6 micron, color corrected','NGC 7640',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161849,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,NULL,161849,35.82,0.6,146,75638,70,NULL,NULL,'ESO 291- G 022',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.000077,NULL,'15.38',0.44,'S?',NULL,NULL,NULL,NULL,1,350.548458333,-42.59558,NULL,NULL,50528675283,789510551,12336102,15.38),(161850,'FP','2016-12-15 15:16:06','2016-12-16 11:21:22','1',NULL,'R',161850,36.71,0.46,220,75639,70,NULL,NULL,'SDSS J232212.10+154706.0',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000117,NULL,'17.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,350.550417,15.78503,0.101,NULL,52528908311,820764192,12824440,17.7),(161851,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859','R',161851,40.49,0.22,981,75640,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00859',0.278296,'2014arXiv1401.3317S',2014,1,0.05,NULL,'G',NULL,'PHOT','22.5g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.551667,0.38664,0.145,NULL,51574885736,805857589,12591524,22.5),(161852,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859','R',161852,40.54,0.15,1000,75640,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00859',0.278296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161853,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859',NULL,161853,40.23,0.14,1110,75640,70,NULL,'SN photometric redshift distance, z photo =0.305 +/- 0.025','SDSS-II SN 00859',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161854,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859',NULL,161854,40.37,0.12,1190,75640,70,NULL,'SALT 2','SDSS-II SN 00859',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161855,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:22','1','SDSS-II SN 00859',NULL,161855,40.4,0.12,1200,75640,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 00859',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161856,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161856,37.72,0.46,350,75641,70,NULL,NULL,'2MASX J23221563+1518136',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000182,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,350.5652083,15.30375,0.109,NULL,52527735334,820745864,12824154,17),(161857,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161857,31.89,0.49,23.9,75642,75,NULL,'IR','ESO 536- G 003',NULL,'2011yCatp016004901K',2011,1,1.26,NULL,'G',NULL,NULL,'16.12',0.19,'Scd',NULL,NULL,NULL,NULL,1,350.566791667,-23.70122,0.041,NULL,50022546384,781602287,12212535,16.12),(161858,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06415','RN',161858,39.18,0.25,580,75643,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 06415',0.183726,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161859,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06415','RN',161859,39.64,0.32,715,75643,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 06415',0.183726,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161860,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161860,37.29,0.49,287,75644,NULL,NULL,'Malmquist cor.','2MASX J23222244+1700543',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000033,NULL,'14.62',NULL,'S/S0','Group member',NULL,NULL,NULL,1,350.5934583,17.015,0.073,NULL,52525507505,820711054,12823610,14.62),(161861,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161861,37.53,0.44,320,75644,NULL,NULL,NULL,'2MASX J23222244+1700543',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161862,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161862,37.57,0.2,327,75644,74.4,NULL,NULL,'2MASX J23222244+1700543',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161863,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161863,36.49,0.55,199,75645,70,NULL,NULL,'2MASX J23222282-7835026',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,350.5954583,-78.58411,0.341,NULL,48554936775,758670887,11854232,17.2),(161864,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161864,36.15,0.46,170,75646,70,NULL,NULL,'SDSS J232222.95+135938.3',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00035,NULL,'16.65',NULL,'E',NULL,NULL,NULL,NULL,1,350.595625,13.99397,0.101,NULL,52513958144,820530596,12820790,16.65),(161865,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161865,34.43,0.8,76.8,75647,75,NULL,'W91PP, r','UGC 12557',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'15.02',0.4,'S?',NULL,NULL,NULL,NULL,1,350.619333,29.18094,0.373,NULL,52015256328,812738380,12699037,15.02),(161866,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161866,34.6,0.4,83.1,75647,NULL,NULL,'mean','UGC 12557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161867,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161867,34.71,0.46,87.4,75647,NULL,NULL,'J','UGC 12557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161868,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161868,34.73,0.47,88.3,75647,NULL,NULL,'H','UGC 12557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161869,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161869,34.81,0.45,91.6,75647,NULL,NULL,'K','UGC 12557',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161870,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161870,34.91,0.38,95.9,75647,75,NULL,'W91PP, r, raw','UGC 12557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161871,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161871,34.96,0.49,98,75647,75,NULL,'IR','UGC 12557',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161872,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161872,35.06,0.31,103,75647,NULL,NULL,'Malmquist cor.','UGC 12557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161873,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161873,35.08,0.31,104,75647,NULL,NULL,NULL,'UGC 12557',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161874,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161874,35.14,0.38,107,75647,75,NULL,'W91PP, r, cor','UGC 12557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161875,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161875,35.18,0.38,109,75647,75,NULL,'W91PP, r, inv','UGC 12557',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161876,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161876,35.19,0.2,109,75647,74.4,NULL,NULL,'UGC 12557',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161877,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161877,38.23,0.46,443,75648,70,NULL,NULL,'SDSS J232230.46+000402.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00007,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,350.626958333,0.06747,0.117,NULL,51574849107,805857017,12591515,18.7),(161878,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161878,36.33,0.46,184,75649,70,NULL,NULL,'2MASX J23223202-1048095',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000068,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,350.633541667,-10.80272,0.067,NULL,49608277930,775129342,12111395,17.6),(161879,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161879,35.07,0.47,103,75650,NULL,NULL,'H','NGC 7627',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000033,NULL,'14.82',0.5,'Sa',NULL,NULL,NULL,NULL,1,350.628875,11.89256,0.113,NULL,51625571257,806649550,12603899,14.82),(161880,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161880,35.1,0.45,105,75650,NULL,NULL,'K','NGC 7627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161881,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161881,35.19,0.4,109,75650,NULL,NULL,'mean','NGC 7627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161882,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161882,35.23,0.46,111,75650,NULL,NULL,'J','NGC 7627',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161883,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161883,35.25,0.39,112,75650,NULL,NULL,'Malmquist cor.','NGC 7627',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161884,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161884,35.38,0.37,119,75650,NULL,NULL,NULL,'NGC 7627',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161885,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161885,35.76,0.2,142,75650,74.4,NULL,NULL,'NGC 7627',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161886,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161886,38.2,0.51,436,75651,NULL,NULL,'Malmquist cor.','AGC 331577',NULL,'2009ApJS..182..474S',2009,1,0.28,NULL,'G',0.00003,NULL,'18.5V',NULL,'Sc',NULL,NULL,NULL,NULL,1,350.634291667,16.78814,0.069,NULL,52525441735,820710027,12823594,18.5),(161887,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161887,38.21,0.51,438,75651,NULL,NULL,NULL,'AGC 331577',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161888,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161888,38.25,0.2,447,75651,74.4,NULL,NULL,'AGC 331577',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161889,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161889,36.44,0.09,194,75652,70,NULL,NULL,'2MASX J23223335+1440392',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000171,NULL,'16.9g',0.18,NULL,'Group member',NULL,NULL,NULL,1,350.638833,14.67744,0.113,NULL,52527530396,820742662,12824104,16.9),(161890,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161890,33.95,0.8,61.6,75653,75,NULL,'MAT, I','UGC 12555',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000023,NULL,'16.0',0.3,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,350.641875,5.12028,0.193,NULL,51769109161,808892330,12638942,16),(161891,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161891,33.95,0.8,61.7,75653,75,NULL,'W91CL, r','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161892,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161892,33.95,0.8,61.7,75653,75,NULL,'HMCL, I','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161893,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161893,33.92,0.32,60.9,75653,85,NULL,'I, inv','UGC 12555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161894,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161894,33.93,0.32,61.2,75653,85,NULL,'I, raw','UGC 12555',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161895,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161895,34.15,0.4,67.6,75653,75,NULL,'HMCL, I, raw','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161896,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161896,34.17,0.38,68.2,75653,75,NULL,'W91CL, r, inv','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161897,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161897,34.18,0.38,68.6,75653,75,NULL,'W91CL, r, raw','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161898,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161898,34.19,0.43,68.8,75653,75,NULL,'MAT, I, raw','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161899,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161899,34.19,0.4,69,75653,75,NULL,'HMCL, I, inv','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161900,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161900,34.22,0.43,69.7,75653,75,NULL,'MAT, I, inv','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161901,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161901,34.37,0.38,74.7,75653,75,NULL,'W91CL, r, cor','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161902,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161902,34.38,0.4,75.3,75653,75,NULL,'HMCL, I, cor','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161903,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161903,34.45,0.43,77.6,75653,75,NULL,'MAT, I, cor','UGC 12555',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161904,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161904,34.52,0.2,80.2,75653,74.4,NULL,NULL,'UGC 12555',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161905,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161905,34.58,0.5,82.4,75653,NULL,NULL,'Malmquist cor.','UGC 12555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161906,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161906,34.6,0.49,83.1,75653,NULL,NULL,NULL,'UGC 12555',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161907,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161907,37.95,0.21,389,75654,70,NULL,NULL,'2MASX J23223437-1005202',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000089,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,350.643125,-10.089,0.046,NULL,49608473281,775132395,12111443,16.8),(161908,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161908,34.29,0.53,72,75655,70,NULL,NULL,'MCG -02-59-013',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00012,NULL,'14.41',0.8,'HII?',NULL,NULL,NULL,NULL,1,350.646958333,-13.09411,0.056,NULL,49561771267,774402676,12100041,14.41),(161909,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161909,34.22,0.69,69.7,75655,100,NULL,'mid-IR','MCG -02-59-013',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161910,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161910,34.83,0.2,92.5,75655,74.4,NULL,NULL,'MCG -02-59-013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161911,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161911,34.9,0.34,95.3,75655,NULL,NULL,'Malmquist cor.','MCG -02-59-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161912,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161912,34.94,0.33,97.4,75655,NULL,NULL,NULL,'MCG -02-59-013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161913,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161913,37.08,0.46,261,75656,70,NULL,NULL,'2MASX J23223577-0105426',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000071,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,350.649208333,-1.09533,0.137,NULL,49412943296,772077239,12063706,17),(161914,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 04978',NULL,161914,40.07,0.27,1030,75657,70,NULL,'SN photometric redshift distance, z photo =0.279 +/- 0.045','SDSS-II SN 04978',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.6605,-0.42911,0.105,NULL,49411371123,772052673,12063323,NULL),(161915,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 04978',NULL,161915,40.45,0.18,1230,75657,70,NULL,'SALT 2','SDSS-II SN 04978',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161916,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 04978',NULL,161916,40.48,0.18,1250,75657,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04978',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161917,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161917,36.71,0.46,219,75658,70,NULL,NULL,'2MASX J23223884-1005202',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000072,NULL,'16.3g',0.38,NULL,NULL,NULL,NULL,NULL,1,350.661833,-10.08886,0.046,NULL,49608474527,775132414,12111443,16.3),(161918,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161918,36.65,0.33,214,75659,70,NULL,NULL,'2MASX J23223958-1019242',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000086,NULL,'16.2g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,350.6649583,-10.32342,0.046,NULL,49608968679,775140135,12111564,16.2),(161919,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161919,38.38,0.46,475,75660,70,NULL,NULL,'2MASX J23223992-0833492',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000087,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.666416667,-8.56358,0.085,NULL,49604082557,775063789,12110371,17.8),(161920,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161920,37.12,0.78,266,75661,70,NULL,NULL,'6dF J2322424-365128',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,350.6767083,-36.85767,NULL,NULL,49975509606,780867337,12201052,15.6),(161921,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161921,36.65,0.33,214,75662,70,NULL,NULL,'2MASX J23224344-1026052',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000082,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,350.680916667,-10.43489,0.049,NULL,49609157375,775143083,12111610,16.6),(161922,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161922,35.25,0.8,112,75663,75,NULL,'MAT, I','UGC 12565',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.19',0.6,'S?',NULL,NULL,NULL,NULL,1,350.687166667,23.21133,0.145,NULL,52506228978,820409827,12818903,15.19),(161923,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161923,35.26,0.8,113,75663,75,NULL,'W91PP, r','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161924,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161924,34.92,0.32,96.5,75663,85,NULL,'I, raw','UGC 12565',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161925,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161925,34.96,0.32,98.4,75663,85,NULL,'I, inv','UGC 12565',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161926,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161926,34.99,0.43,99.5,75663,75,NULL,'MAT, I, raw','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161927,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161927,35.07,0.38,103,75663,75,NULL,'W91PP, r, raw','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161928,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161928,35.19,0.43,109,75663,75,NULL,'MAT, I, inv','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161929,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161929,35.2,0.38,110,75663,75,NULL,'W91PP, r, inv','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161930,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161930,35.27,0.38,113,75663,NULL,NULL,'Malmquist cor.','UGC 12565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161931,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161931,35.27,0.43,113,75663,75,NULL,'MAT, I, cor','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161932,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161932,35.27,0.38,113,75663,75,NULL,'W91PP, r, cor','UGC 12565',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161933,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161933,35.28,0.38,114,75663,NULL,NULL,NULL,'UGC 12565',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161934,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161934,35.32,0.2,116,75663,74.4,NULL,NULL,'UGC 12565',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161935,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161935,37.5,0.46,317,75664,70,NULL,NULL,'2MASX J23224552+0040134',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000091,NULL,'16.9g',0.32,NULL,NULL,NULL,NULL,NULL,1,350.6897083,0.67047,0.129,NULL,51576905471,805889147,12592017,16.9),(161936,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161936,34.54,0.4,81,75665,NULL,NULL,'mean','UGC 12566',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000033,NULL,'14.50',1.3,'Sab',NULL,NULL,NULL,NULL,1,350.691125,29.13781,0.373,NULL,52015248337,812738255,12699035,14.5),(161937,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161937,34.64,0.56,84.8,75665,NULL,NULL,NULL,'UGC 12566',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161938,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161938,34.68,0.2,86.3,75665,74.4,NULL,NULL,'UGC 12566',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161939,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161939,34.75,0.54,88.9,75665,NULL,NULL,'Malmquist cor.','UGC 12566',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161940,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161940,34.78,0.47,90.3,75665,NULL,NULL,'H','UGC 12566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161941,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161941,34.84,0.45,92.9,75665,NULL,NULL,'K','UGC 12566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161942,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161942,34.87,0.46,94.2,75665,NULL,NULL,'J','UGC 12566',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161943,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03190','RN',161943,43.09,0.29,2800,75666,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03190',0.478684,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161944,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006hl',NULL,161944,38.75,0.05,562,75667,70,NULL,'Hubble residual -0.10 for z0.14820','SDSS J232246.06+003156.2',NULL,'2011ApJ...740...92G',2011,1,0.14,NULL,'G',0.0005,NULL,'19.2g',0.1,NULL,NULL,NULL,NULL,NULL,1,350.6919583,0.53228,0.129,NULL,51574870127,805857345,12591521,19.2),(161945,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13796','R',161945,39.14,0.18,587,75667,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hl','SDSS J232246.06+003156.2',0.1482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161946,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13796','R',161946,39.33,0.07,641,75667,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hl','SDSS J232246.06+003156.2',0.1482,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161947,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006hl',NULL,161947,39.12,0.06,667,75667,70,NULL,'SALT 2','SDSS J232246.06+003156.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161948,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006hl',NULL,161948,39.12,0.06,667,75667,70,NULL,'SALT 2, Malmquist cor.','SDSS J232246.06+003156.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161949,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161949,33.34,0.8,46.6,75668,75,NULL,'MAT, I','UGC 12562',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000013,NULL,'16.0',0.3,'Sdm:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,350.697833333,11.77267,0.113,NULL,51625417944,806647155,12603861,16),(161950,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161950,33.36,0.8,47.1,75668,75,NULL,'W91CL, r','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161951,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161951,33.38,0.8,47.4,75668,75,NULL,'CF, r','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161952,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161952,32.94,0.32,38.8,75668,85,NULL,'I, inv','UGC 12562',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161953,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161953,32.98,0.32,39.4,75668,85,NULL,'I, raw','UGC 12562',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161954,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161954,33.01,0.2,40,75668,74.4,NULL,NULL,'UGC 12562',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161955,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161955,33.06,0.43,41,75668,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12562',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161956,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161956,33.07,0.43,41.1,75668,75,NULL,'3.6 micron, color corrected','UGC 12562',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161957,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161957,33.28,0.38,45.4,75668,75,NULL,'W91CL, r, inv','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161958,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161958,33.37,0.38,47.2,75668,75,NULL,'W91CL, r, raw','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161959,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161959,33.42,0.43,48.2,75668,75,NULL,'MAT, I, inv','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161960,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161960,33.47,0.43,49.4,75668,75,NULL,'MAT, I, raw','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161961,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161961,33.52,0.11,50.7,75668,NULL,NULL,NULL,'UGC 12562',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161962,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161962,33.64,0.38,53.5,75668,75,NULL,'W91CL, r, cor','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161963,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161963,33.67,0.38,54.1,75668,75,NULL,'CF, r, inv','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161964,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161964,33.72,0.38,55.4,75668,75,NULL,'CF, r, raw','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161965,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161965,33.74,0.43,56,75668,75,NULL,'MAT, I, cor','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161966,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161966,33.88,0.38,59.6,75668,75,NULL,'CF, r, cor','UGC 12562',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161967,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161967,36.06,0.8,163,75669,75,NULL,'W91PP, r','UGC 12564',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000097,NULL,'15.27',0.3,'Sd',NULL,NULL,NULL,NULL,1,350.6980417,22.93681,0.145,NULL,52506360309,820411879,12818935,15.27),(161968,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161968,36.06,0.8,163,75669,75,NULL,'CF, r','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161969,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161969,35.71,0.38,139,75669,75,NULL,'W91PP, r, raw','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161970,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161970,35.83,0.38,147,75669,75,NULL,'CF, r, raw','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161971,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161971,35.91,0.38,152,75669,75,NULL,'W91PP, r, cor','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161972,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161972,35.95,0.38,155,75669,75,NULL,'W91PP, r, inv','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161973,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161973,35.95,0.33,155,75669,NULL,NULL,'Malmquist cor.','UGC 12564',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161974,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161974,36.04,0.38,161,75669,75,NULL,'CF, r, inv','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161975,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161975,36.04,0.38,162,75669,75,NULL,'CF, r, cor','UGC 12564',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161976,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161976,36.21,0.2,175,75669,74.4,NULL,NULL,'UGC 12564',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161977,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161977,36.23,0.29,176,75669,NULL,NULL,NULL,'UGC 12564',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161978,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161978,37.15,0.53,269,75670,70,NULL,NULL,'2MASX J23224925-3753407',NULL,'2014MNRAS.445.2677S',2014,1,1.05,'APM image includes a bright star.','G',0.00015,NULL,'17.00',0.32,'Sc',NULL,NULL,NULL,NULL,1,350.705167,-37.89472,NULL,NULL,49968076206,780751190,12199237,17),(161979,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161979,33.55,0.07,51.4,75671,NULL,NULL,NULL,'NGC 7643',NULL,'2009ApJS..182..474S',2009,1,1.4,'Identification as NGC 7644 is doubtful; N7644 may be NGC 7651.','G',0.000023,NULL,'14.12',0.7,'Sc',NULL,NULL,NULL,NULL,1,350.71,11.98883,0.105,NULL,51625547280,806649176,12603893,14.12),(161980,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161980,33.63,0.4,53.1,75671,NULL,NULL,'mean','NGC 7643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161981,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161981,33.63,0.2,53.2,75671,74.4,NULL,NULL,'NGC 7643',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161982,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161982,33.84,0.47,58.7,75671,NULL,NULL,'H','NGC 7643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161983,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161983,33.86,0.46,59.3,75671,NULL,NULL,'J','NGC 7643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161984,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161984,33.88,0.45,59.7,75671,NULL,NULL,'K','NGC 7643',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161985,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161985,35.74,0.46,140,75672,70,NULL,NULL,'2MASX J23225230-0100008',NULL,'2015arXiv151105856S',2015,1,0.62,NULL,'G',0.0001,NULL,'15.4g',0.51,'E0',NULL,NULL,NULL,NULL,1,350.718,-1.00025,0.141,NULL,49413045898,772078842,12063731,15.4),(161986,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161986,36.24,0.5,177,75672,70,NULL,NULL,'2MASX J23225230-0100008',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161987,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161987,37.95,0.21,389,75673,70,NULL,NULL,'2MASX J23225637-1002441',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000103,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,350.734833,-10.04564,0.046,NULL,49608511568,775132993,12111453,16.3),(161988,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',161988,36.44,0.09,194,75674,70,NULL,NULL,'2MASXi J2322576+150551',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000191,NULL,'15.9g',0.45,'E0','Group member',NULL,NULL,NULL,1,350.740125,15.09744,0.109,NULL,52527798493,820746851,12824169,15.9),(161989,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161989,33.34,0.43,46.5,75675,75,NULL,'3.6 micron, color + selection bias corrected','FGC 284A',NULL,'2014MNRAS.444..527S',2014,1,1.12,NULL,'G',0.000017,NULL,'17.07',0.17,'Sc','X-ray-bright group member',NULL,NULL,NULL,1,350.74375,7.67228,0.181,NULL,51802693195,809417081,12647141,17.07),(161990,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161990,33.41,0.2,48.1,75675,74.4,NULL,NULL,'FGC 284A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161991,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161991,33.43,0.43,48.5,75675,75,NULL,'3.6 micron, color corrected','FGC 284A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161992,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161992,33.52,0.13,50.7,75675,NULL,NULL,NULL,'FGC 284A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161993,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161993,33.29,0.8,45.5,75676,75,NULL,'MAT, I','UGC 12561',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'15.74',0.4,'Sdm:','X-ray-bright group member',NULL,NULL,NULL,1,350.744,8.99353,0.109,NULL,51754538683,808664666,12635385,15.74),(161994,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161994,33.29,0.8,45.5,75676,75,NULL,'HMCL, I','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161995,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161995,33.29,0.8,45.6,75676,75,NULL,'W91CL, r','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161996,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161996,33.32,0.8,46.2,75676,75,NULL,'CF, r','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161997,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161997,33.34,0.4,46.6,75676,75,NULL,'HMCL, I, raw','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161998,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161998,33.36,0.4,46.9,75676,75,NULL,'HMCL, I, inv','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(161999,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,161999,33.38,0.2,47.4,75676,74.4,NULL,NULL,'UGC 12561',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162000,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162000,33.45,0.43,48.9,75676,75,NULL,'3.6 micron, color corrected','UGC 12561',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162001,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162001,33.49,0.43,50,75676,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12561',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162002,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162002,33.51,0.25,50.5,75676,NULL,NULL,NULL,'UGC 12561',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162003,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162003,33.54,0.38,51.1,75676,75,NULL,'W91CL, r, inv','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162004,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162004,33.58,0.38,51.9,75676,75,NULL,'W91CL, r, raw','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162005,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162005,33.64,0.4,53.3,75676,75,NULL,'HMCL, I, cor','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162006,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162006,33.68,0.32,54.4,75676,85,NULL,'I, inv','UGC 12561',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162007,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162007,33.69,0.32,54.6,75676,85,NULL,'I, raw','UGC 12561',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162008,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162008,33.83,0.38,58.3,75676,75,NULL,'W91CL, r, cor','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162009,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162009,33.92,0.38,60.7,75676,75,NULL,'CF, r, inv','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162010,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162010,33.92,0.38,60.9,75676,75,NULL,'CF, r, raw','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162011,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162011,33.99,0.43,62.8,75676,75,NULL,'MAT, I, raw','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162012,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162012,34.02,0.43,63.6,75676,75,NULL,'MAT, I, inv','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162013,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162013,34.12,0.38,66.5,75676,75,NULL,'CF, r, cor','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162014,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162014,34.23,0.43,70.2,75676,75,NULL,'MAT, I, cor','UGC 12561',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162015,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162015,35.45,0.59,123,75677,NULL,NULL,NULL,'AGC 330318',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.00003,NULL,'17.31',0.2,'S/I','Group member',NULL,NULL,NULL,1,350.753875,16.79944,0.069,NULL,52525459370,820710302,12823598,17.31),(162016,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162016,35.49,0.2,125,75677,74.4,NULL,NULL,'AGC 330318',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162017,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162017,35.76,0.51,142,75677,NULL,NULL,'Malmquist cor.','AGC 330318',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162018,'BL Lac Luminosity','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162018,40.01,NULL,1000,75678,NULL,NULL,'Min. z = 0.27','1FGL J2323.0-4919',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.759,-49.322,NULL,NULL,48645782289,760090348,11876411,NULL),(162019,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162019,36.04,0.37,162,75679,NULL,NULL,'Malmquist cor.','2MASX J23230214+1732191',NULL,'2009ApJS..182..474S',2009,1,0.65,NULL,'G',0.000027,NULL,'14.31',NULL,'Sb:',NULL,NULL,NULL,NULL,1,350.7589583,17.53867,0.089,NULL,52530519352,820789364,12824833,14.31),(162020,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162020,36.19,0.34,173,75679,NULL,NULL,NULL,'2MASX J23230214+1732191',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162021,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162021,36.23,0.2,176,75679,74.4,NULL,NULL,'2MASX J23230214+1732191',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162022,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162022,36.44,0.09,194,75680,70,NULL,NULL,'2MASX J23230358+1424261',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000149,NULL,'17.6g',0.18,NULL,'Group member',NULL,NULL,NULL,1,350.7647917,14.40733,0.113,NULL,52527580604,820743446,12824116,17.6),(162023,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162023,38.22,0.27,441,75681,70,NULL,NULL,'SDSS J232304.62+004956.5',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000075,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,350.7692917,0.83236,0.129,NULL,51577219836,805894059,12592094,18.7),(162024,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13690','RN',162024,42.07,0.17,1700,75682,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13690',0.530337,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162025,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15272','R',162025,40.48,0.23,973,75683,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232305.28+000503.7',0.2803,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.01,NULL,'20.0g',0.07,NULL,NULL,NULL,NULL,NULL,1,350.772,0.08439,0.133,NULL,51574812730,805856448,12591507,20),(162026,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15272','R',162026,40.71,0.16,1080,75683,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232305.28+000503.7',0.2803,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162027,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15272',NULL,162027,40.34,0.12,1170,75683,70,NULL,'SALT 2','SDSS J232305.28+000503.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162028,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15272',NULL,162028,40.36,0.12,1180,75683,70,NULL,'SALT 2, Malmquist cor.','SDSS J232305.28+000503.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162029,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162029,37.47,0.46,312,75684,70,NULL,NULL,'2MASX J23230640-1015459',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000154,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,350.77675,-10.26267,0.046,NULL,49608956319,775139942,12111561,17.5),(162030,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162030,37.95,0.21,389,75685,70,NULL,NULL,'2MASX J23230837-1005119',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.0g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,350.784958333,-10.08653,0.046,NULL,49608513978,775133030,12111453,16),(162031,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162031,37.95,0.21,389,75686,70,NULL,NULL,'2MASX J23230843-1006499',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000102,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,350.78525,-10.11378,0.046,NULL,49608522168,775133158,12111455,17.3),(162032,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162032,36.09,0.46,165,75687,NULL,NULL,NULL,'2MASX J23231005+1738221',NULL,'2009ApJS..182..474S',2009,1,0.38,NULL,'G',0.000037,NULL,'16.19',NULL,'Sc',NULL,NULL,NULL,NULL,1,350.791833,17.63956,0.089,NULL,52544183976,821002874,12828169,16.19),(162033,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162033,36.11,0.45,167,75687,NULL,NULL,'Malmquist cor.','2MASX J23231005+1738221',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162034,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162034,36.13,0.2,168,75687,74.4,NULL,NULL,'2MASX J23231005+1738221',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162035,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162035,36.36,0.25,187,75688,74.4,NULL,NULL,'GIN 690',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000043,NULL,'16.11',NULL,'SB0','Group member',NULL,NULL,NULL,1,350.794583,16.91356,0.069,NULL,52525419241,820709675,12823588,16.11),(162036,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162036,36.59,0.16,208,75688,70,NULL,NULL,'GIN 690',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162037,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162037,36.13,0.25,168,75689,74.4,NULL,NULL,'UGC 12569',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000027,NULL,'15.7g',0.54,'S?','Group member',NULL,NULL,NULL,1,350.799,14.90144,0.109,NULL,52528340439,820755319,12824301,15.7),(162038,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162038,36.35,0.09,186,75689,70,NULL,NULL,'UGC 12569',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162039,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162039,38.22,0.27,441,75690,70,NULL,NULL,'SDSS J232313.39+005638.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',NULL,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,350.805833,0.94394,0.141,NULL,51577190044,805893594,12592087,18.5),(162040,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162040,38.22,0.27,441,75691,70,NULL,NULL,'2MASX J23231608+0059228',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000096,NULL,'17.6g',0.21,'AGN',NULL,NULL,NULL,NULL,1,350.817083333,0.98972,0.141,NULL,51577179262,805893425,12592084,17.6),(162041,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162041,37.4,0.33,302,75692,70,NULL,NULL,'2MASX J23231769+1424301',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000156,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,350.823583,14.40853,0.113,NULL,52527409038,820740766,12824074,18),(162042,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162042,37.33,0.46,292,75693,70,NULL,NULL,'SDSS J232318.78-001957.4',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,350.82825,-0.33264,0.105,NULL,49411457976,772054030,12063344,18.4),(162043,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162043,36.76,0.46,225,75694,70,NULL,NULL,'2MASX J23232110+1322474',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000169,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,350.8377917,13.37994,0.097,NULL,51626486644,806663853,12604122,16.7),(162044,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162044,36.14,0.3,169,75695,NULL,NULL,'Malmquist cor.','2MASX J23232134+1417044',NULL,'2009ApJS..182..474S',2009,1,0.82,NULL,'G',0.000023,NULL,'15.9g',0.25,'Sab','Group member',NULL,NULL,NULL,1,350.8387917,14.28456,0.101,NULL,52513762887,820527545,12820742,15.9),(162045,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162045,36.27,0.28,179,75695,NULL,NULL,NULL,'2MASX J23232134+1417044',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162046,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162046,36.31,0.2,183,75695,74.4,NULL,NULL,'2MASX J23232134+1417044',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162047,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162047,36.71,0.94,220,75696,70,NULL,NULL,'2MASX J23232159-5910027',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'16.09',0.4,'S0',NULL,NULL,NULL,NULL,1,350.8400417,-59.16742,0,NULL,48817031434,762766116,11918220,16.09),(162048,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162048,35.54,0.8,128,75697,75,NULL,'W91PP, r','UGC 12572',NULL,'1997ApJS..109..333W',1997,1,1.19,'Field star in the foreground.','G',0.00033,NULL,'15.6',0.24,'Sa             Sbrst',NULL,NULL,NULL,NULL,1,350.8412917,24.75083,0.157,NULL,51991321955,812364405,12693193,15.6),(162049,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162049,35.05,0.49,102,75697,75,NULL,'IR','UGC 12572',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162050,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162050,35.5,0.38,126,75697,75,NULL,'W91PP, r, raw','UGC 12572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162051,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162051,35.66,0.38,136,75697,75,NULL,'W91PP, r, cor','UGC 12572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162052,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162052,35.75,0.38,141,75697,75,NULL,'W91PP, r, inv','UGC 12572',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162053,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162053,35.76,0.4,142,75697,NULL,NULL,'mean','UGC 12572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162054,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162054,35.86,0.08,149,75697,NULL,NULL,NULL,'UGC 12572',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162055,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162055,35.92,0.2,153,75697,74.4,NULL,NULL,'UGC 12572',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162056,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162056,36.06,0.47,163,75697,NULL,NULL,'H','UGC 12572',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162057,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162057,33.38,0.8,47.5,75698,75,NULL,'MAT, I','UGC 12571',NULL,'1997ApJS..109..333W',1997,1,1.14,NULL,'G',0.00002,NULL,'14.7g',0.62,'(R:)SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,350.843875,13.31922,0.097,NULL,51626490463,806663913,12604123,14.7),(162058,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162058,33.39,0.8,47.7,75698,75,NULL,'HMCL, I','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162059,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162059,33.52,0.09,50.7,75698,NULL,NULL,NULL,'UGC 12571',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162060,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162060,33.99,0.32,62.7,75698,85,NULL,'I, raw','UGC 12571',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162061,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162061,34.02,0.32,63.8,75698,85,NULL,'I, inv','UGC 12571',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162062,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162062,34.17,0.2,68.2,75698,74.4,NULL,NULL,'UGC 12571',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162063,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162063,34.21,0.4,69.4,75698,75,NULL,'HMCL, I, raw','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162064,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162064,34.23,0.43,70,75698,75,NULL,'MAT, I, raw','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162065,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162065,34.34,0.4,73.9,75698,75,NULL,'HMCL, I, inv','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162066,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162066,34.37,0.4,74.7,75698,75,NULL,'HMCL, I, cor','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162067,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162067,34.41,0.43,76.1,75698,75,NULL,'MAT, I, inv','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162068,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162068,34.43,0.43,77.1,75698,75,NULL,'MAT, I, cor','UGC 12571',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162069,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162069,37.95,0.21,389,75699,70,NULL,NULL,'2MASX J23232381-1002479',NULL,'2015arXiv151105856S',2015,1,0.26,'The APM position is 9 arcsec west of the nucleus.','G',0.000149,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,350.8492083,-10.04678,0.057,NULL,49608492450,775132694,12111448,17.6),(162070,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162070,37.41,0.46,304,75700,70,NULL,NULL,'2MASX J23232441-0946199',NULL,'2015arXiv151105856S',2015,1,0.21,'The APM position is 9 arcsec west of the nucleus.','G',0.000074,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,350.851625,-9.77231,0.053,NULL,49609681855,775151278,12111738,17.8),(162071,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162071,36.44,0.09,194,75701,70,NULL,NULL,'2MASX J23232515+1447254',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.0002,NULL,'16.6g',0.27,NULL,'Group member',NULL,NULL,NULL,1,350.854833,14.79031,0.109,NULL,52527490057,820742032,12824094,16.6),(162072,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02569','RN',162072,40.85,0.26,1220,75702,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 02569',0.211247,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162073,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02569','RN',162073,41.7,0.27,1800,75702,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 02569',0.211247,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162074,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162074,36.15,0.25,170,75703,74.4,NULL,NULL,'GIN 713',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.000033,NULL,'15.4g',0.48,'S','Group member',NULL,NULL,NULL,1,350.86125,14.13167,0.101,NULL,52513790952,820527983,12820749,15.4),(162075,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 21365','RN',162075,40.99,0.3,1230,75704,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21365',0.282747,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162076,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 21365','RN',162076,41.09,0.91,1290,75704,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21365',0.282747,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162077,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 05007','RN',162077,42.26,0.25,1950,75705,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05007',0.4523,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162078,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162078,36.22,0.43,175,75706,NULL,NULL,'Malmquist cor.','2MASX J23232939+1420194',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000027,NULL,'16.3',NULL,'Sc','Group member',NULL,NULL,NULL,1,350.8725,14.33883,0.101,NULL,52527407086,820740735,12824073,16.3),(162079,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162079,36.36,0.41,187,75706,NULL,NULL,NULL,'2MASX J23232939+1420194',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162080,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162080,36.4,0.2,191,75706,74.4,NULL,NULL,'2MASX J23232939+1420194',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162081,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162081,35.83,NULL,147,75707,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2494',NULL,'2010Ap&SS.325..163P',2010,1,0.87,NULL,'G',0.000017,NULL,'16.95',0.09,'Sd',NULL,NULL,NULL,NULL,1,350.886083,8.62406,0.141,NULL,51753678169,808651221,12635175,16.95),(162082,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162082,35.85,NULL,148,75707,NULL,NULL,'Dipole + Quadrupole','FGC 2494',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162083,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162083,35.87,NULL,149,75707,NULL,NULL,'Dipole','FGC 2494',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162084,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162084,36.03,0.49,161,75707,75,NULL,'IR','FGC 2494',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162085,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162085,38.29,0.46,455,75708,70,NULL,NULL,'2MASX J23233278+0035290',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000076,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,350.886625,0.59139,0.129,NULL,51575005041,805859453,12591553,17.8),(162086,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162086,36.44,0.09,194,75709,70,NULL,NULL,'2MASX J23233279+1437154',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000169,NULL,'16.2g',0.31,'E0','Group member',NULL,NULL,NULL,1,350.886708333,14.62097,0.109,NULL,52527601610,820743775,12824121,16.2),(162087,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162087,36.13,0.25,168,75710,74.4,NULL,NULL,'GIN 707',NULL,'2013AJ....146...86T',2013,1,0.43,NULL,'G',0.000033,NULL,'16.5g',0.34,'S','Group member',NULL,NULL,NULL,1,350.889333333,14.57689,0.109,NULL,52527606721,820743855,12824122,16.5),(162088,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162088,36.35,0.09,186,75710,70,NULL,NULL,'GIN 707',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162089,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162089,36.44,0.09,194,75711,70,NULL,NULL,'2MASX J23233361+1345214',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000207,NULL,'15.8g',0.4,'E0',NULL,NULL,NULL,NULL,1,350.890125,13.75606,0.101,NULL,51625847094,806653860,12603966,15.8),(162090,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162090,37.38,0.46,300,75712,70,NULL,NULL,'2MASX J23233498+0030070',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,350.895667,0.50194,0.129,NULL,51575024759,805859761,12591558,17.6),(162091,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 07457','R',162091,40.18,0.2,865,75713,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07457',0.254504,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.903125,-0.37225,0.157,NULL,49412001149,772062517,12063476,NULL),(162092,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 07457','R',162092,40.44,0.27,977,75713,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07457',0.254504,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162093,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162093,37.65,0.46,339,75714,70,NULL,NULL,'2MASX J23233671-0835347',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000084,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,350.903167,-8.59286,0.077,NULL,49606133488,775095835,12110872,17.2),(162094,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162094,36.44,0.09,194,75715,70,NULL,NULL,'2MASX J23233744+1339084',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000216,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,350.9060417,13.65225,0.093,NULL,51625767253,806652613,12603947,16.5),(162095,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162095,35.97,0.55,156,75716,NULL,NULL,NULL,'2MASXi J2323383+171813',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.00003,NULL,'16.00',0.1,'Sc',NULL,NULL,NULL,NULL,1,350.909833,17.30369,0.089,NULL,52517983366,820593490,12821773,16),(162096,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162096,36.05,0.53,162,75716,NULL,NULL,'Malmquist cor.','2MASXi J2323383+171813',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162097,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162097,36.41,0.2,191,75716,74.4,NULL,NULL,'2MASXi J2323383+171813',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162098,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162098,37.46,0.46,311,75717,70,NULL,NULL,'2MASX J23234023-1016567',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00009,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,350.9175417,-10.2825,0.044,NULL,49608599474,775134366,12111474,16.5),(162099,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162099,36.15,0.45,170,75718,NULL,NULL,'Malmquist cor.','2MASX J23234061+2440105',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000013,NULL,'14.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,350.9192917,24.66961,0.157,NULL,51990841055,812356891,12693076,14),(162100,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162100,36.43,0.4,193,75718,NULL,NULL,NULL,'2MASX J23234061+2440105',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162101,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162101,36.47,0.2,197,75718,74.4,NULL,NULL,'2MASX J23234061+2440105',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162102,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162102,31.65,0.8,21.3,75719,75,NULL,'MAT, I','ESO 291- G 024',NULL,'1997ApJS..109..333W',1997,1,1.46,'Marginal HIPASS detection.','G',0.000032,NULL,'14.79',0.39,'SB(s)c: pec','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,350.919417,-42.40233,NULL,NULL,50528247421,789503865,12335997,14.79),(162103,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162103,31.76,0.4,22.5,75719,NULL,NULL,NULL,'ESO 291- G 024',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162104,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162104,31.76,0.4,22.5,75719,73,NULL,'opt','ESO 291- G 024',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162105,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162105,31.86,0.32,23.5,75719,85,NULL,'I, inv','ESO 291- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162106,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162106,31.88,0.32,23.8,75719,85,NULL,'I, raw','ESO 291- G 024',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162107,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162107,32.24,0.43,28,75719,75,NULL,'MAT, I, inv','ESO 291- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162108,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162108,32.29,0.43,28.7,75719,75,NULL,'MAT, I, raw','ESO 291- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162109,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162109,32.3,0.4,28.8,75719,73,NULL,'opt','ESO 291- G 024',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162110,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162110,32.39,0.52,30.1,75719,NULL,NULL,NULL,'ESO 291- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162111,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162111,32.39,0.52,30.1,75719,NULL,NULL,'Malmquist cor.','ESO 291- G 024',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162112,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162112,32.43,0.2,30.6,75719,74.4,NULL,NULL,'ESO 291- G 024',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162113,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162113,32.49,0.43,31.5,75719,75,NULL,'MAT, I, cor','ESO 291- G 024',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162114,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00716','RN',162114,40.53,0.05,966,75720,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00716',0.324,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162115,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00716','RN',162115,40.65,0.18,1020,75720,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 00716',0.324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162116,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162116,37.61,0.46,333,75721,70,NULL,NULL,'SDSS J232345.03-095207.8',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000072,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.937667,-9.86886,0.053,NULL,49609482831,775148169,12111690,18.1),(162117,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162117,36.36,0.25,187,75722,74.4,NULL,NULL,'GIN 687',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00004,NULL,'15.43',0.2,'S0/E','Group member',NULL,NULL,NULL,1,350.9484583,16.85236,0.049,NULL,52518059496,820594679,12821791,15.43),(162118,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162118,36.59,0.16,208,75722,70,NULL,NULL,'GIN 687',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162119,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162119,36.94,0.23,245,75723,70,NULL,NULL,'2MASX J23234815-0949477',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000078,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,350.950625,-9.82978,0.053,NULL,49609465566,775147899,12111685,17.8),(162120,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162120,36.39,0.25,190,75724,74.4,NULL,NULL,'GIN 683',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000033,NULL,'14.94',0.2,'S0/a','Group member',NULL,NULL,NULL,1,350.950958333,16.76881,0.049,NULL,52518000040,820593750,12821777,14.94),(162121,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162121,36.59,0.16,208,75724,70,NULL,NULL,'GIN 683',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162122,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162122,38.42,0.46,483,75725,70,NULL,NULL,'2MASX J23235033+1539199',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000171,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,350.9595417,15.6555,0.093,NULL,52527636578,820744321,12824130,17.8),(162123,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162123,36.24,0.39,177,75726,NULL,NULL,NULL,'AGC 331695',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'16.82',NULL,'Sd',NULL,NULL,NULL,NULL,1,350.960875,13.89081,0.101,NULL,51625811788,806653309,12603957,16.82),(162124,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162124,36.23,0.39,177,75726,NULL,NULL,'Malmquist cor.','AGC 331695',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162125,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162125,36.28,0.2,180,75726,74.4,NULL,NULL,'AGC 331695',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162126,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162126,36.36,0.25,187,75727,74.4,NULL,NULL,'GIN 686',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00004,NULL,'14.91',0.4,'S0','Group member',NULL,NULL,NULL,1,350.961875,16.897,0.049,NULL,52518045066,820594454,12821788,14.91),(162127,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162127,36.59,0.16,208,75727,70,NULL,NULL,'GIN 686',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162128,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162128,41.65,0.3,1400,75728,74.2,NULL,'SALT 2','ESSENCE n285 HOST',0.528,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,350.9639583,-8.38847,0.068,NULL,49603956877,775061826,12110341,NULL),(162129,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285','R',162129,41.77,NULL,1480,75728,65,NULL,'SALT2','ESSENCE n285 HOST',0.528,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162130,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162130,42.45,0.43,2020,75728,65,NULL,'SALT2','ESSENCE n285 HOST',0.528,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162131,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162131,42.48,0.31,2050,75728,70,NULL,'SALT','ESSENCE n285 HOST',0.528,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162132,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162132,42.51,0.27,2070,75728,65,NULL,'MLCS2k2','ESSENCE n285 HOST',0.528,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162133,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162133,42.52,0.37,2090,75728,65,NULL,'SALT2','ESSENCE n285 HOST',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162134,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162134,42.55,0.28,2120,75728,65,NULL,'MLCS17','ESSENCE n285 HOST',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162135,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162135,42.62,0.26,2180,75728,65,NULL,'MLCS31','ESSENCE n285 HOST',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162136,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162136,42.62,0.38,2190,75728,65,NULL,'SALT','ESSENCE n285 HOST',0.528,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162137,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162137,42.63,0.24,2200,75728,65,NULL,'MLCS2k2','ESSENCE n285 HOST',0.528,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162138,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE n285',NULL,162138,42.88,0.3,2460,75728,65,NULL,'SALT','ESSENCE n285 HOST',0.528,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162139,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162139,36.34,0.25,185,75729,74.4,NULL,NULL,'KUG 2321+163',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.00003,NULL,'14.76',0.45,'Sc','Group member',NULL,NULL,NULL,1,350.964167,16.64483,0.049,NULL,52518861553,820607211,12821987,14.76),(162140,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162140,36.59,0.16,208,75729,70,NULL,NULL,'KUG 2321+163',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162141,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162141,36.94,0.23,245,75730,70,NULL,NULL,'2MASX J23235282-0952277',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,350.9702083,-9.87456,0.053,NULL,49609494499,775148351,12111692,17.4),(162142,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162142,36.23,0.14,176,75731,70,NULL,NULL,'ABELL 2589',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,350.972917,16.80889,0.049,NULL,52518054872,820594607,12821790,NULL),(162143,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162143,32.41,0.45,30.3,75732,NULL,NULL,'K','NGC 7648',NULL,'2007A&A...465...71T',2007,1,1.6,NULL,'G',0.00003,NULL,'13.77',1,'S0','in a radial-velocity based grouping',NULL,NULL,NULL,1,350.975083333,9.66747,0.093,NULL,51753797168,808653080,12635204,13.77),(162144,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162144,33.38,0.4,47.4,75732,NULL,NULL,'mean','NGC 7648',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162145,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162145,36.38,0.25,189,75733,74.4,NULL,NULL,'GIN 684',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000037,NULL,'14.99',0.5,'E','Group member',NULL,NULL,NULL,1,350.976833333,16.68067,0.049,NULL,52518860603,820607196,12821987,14.99),(162146,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162146,36.59,0.16,208,75733,70,NULL,NULL,'GIN 684',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162147,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162147,35.2,0.49,110,75734,75,NULL,'IR','FGC 2495',NULL,'2011yCatp016004901K',2011,1,1.03,NULL,'G',0.000019,NULL,'16.08',0.1,'Sd',NULL,NULL,NULL,NULL,1,350.9785,9.81294,0.137,NULL,51757232571,808706758,12636043,16.08),(162148,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162148,35.72,NULL,139,75734,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162149,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162149,35.74,NULL,141,75734,NULL,NULL,'Dipole + Quadrupole','FGC 2495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162150,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162150,35.76,NULL,142,75734,NULL,NULL,'Dipole','FGC 2495',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162151,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162151,35.78,NULL,143,75734,NULL,NULL,NULL,'FGC 2495',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162152,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162152,36.44,0.09,194,75735,70,NULL,NULL,'2MASX J23235542+1447409',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000063,NULL,'16.0g',0.35,'S0','Group member',NULL,NULL,NULL,1,350.9809583,14.79478,0.109,NULL,52527470463,820741725,12824089,16),(162153,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162153,36.15,0.25,170,75736,74.4,NULL,NULL,'GIN 715',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.000033,NULL,'16.8g',0.24,'S',NULL,NULL,NULL,NULL,1,350.981083,13.91064,0.101,NULL,51625810253,806653285,12603957,16.8),(162154,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 20491',NULL,162154,39.55,0.34,813,75737,70,NULL,'SN photometric redshift distance, z photo =0.212 +/- 0.041','SDSS-II SN 20491',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,350.981583333,-1.19331,0.141,NULL,49412250936,772066420,12063537,NULL),(162155,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162155,36.8,0.46,229,75738,70,NULL,NULL,'2MASX J23235706+0035266',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,350.987833333,0.59078,0.129,NULL,51575061143,805860330,12591567,16.6),(162156,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162156,36.36,0.25,187,75739,74.4,NULL,NULL,'NGC 7647',NULL,'2013AJ....146...86T',2013,1,2.16,NULL,'G',0.000033,NULL,'14.56',1.1,'cD;E;BrClG','Group member',NULL,NULL,NULL,1,350.9892917,16.77728,0.049,NULL,52518002325,820593786,12821777,14.56),(162157,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162157,36.59,0.16,208,75739,70,NULL,NULL,'NGC 7647',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162158,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162158,36.06,0.45,163,75739,NULL,NULL,'K','NGC 7647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162159,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162159,36.09,0.4,165,75739,NULL,NULL,'mean','NGC 7647',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162160,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162160,36.23,0.14,176,75739,70,NULL,'ABELL 2589, BGC','NGC 7647',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162161,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162161,36.44,0.09,194,75740,70,NULL,NULL,'2MASX J23235762+1443509',NULL,'2015arXiv151105856S',2015,1,0.46,NULL,'G',0.000117,NULL,'15.9g',0.31,'S0^-','Group member',NULL,NULL,NULL,1,350.99025,14.73083,0.109,NULL,52527479991,820741874,12824091,15.9),(162162,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162162,36.86,0.46,235,75741,70,NULL,NULL,'2MASX J23235873+0016526',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000071,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,350.99475,0.28142,0.121,NULL,51575115002,805861171,12591580,17.8),(162163,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02395','RN',162163,40.62,0.23,1090,75742,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02395',0.217599,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162164,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02395','RN',162164,41.28,0.24,1480,75742,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02395',0.217599,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162165,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162165,36.38,0.25,189,75743,74.4,NULL,NULL,'GIN 688',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000043,NULL,'15.60',NULL,'E','Group member',NULL,NULL,NULL,1,350.9957083,16.87492,0.049,NULL,52518057942,820594655,12821791,15.6),(162166,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162166,36.59,0.16,208,75743,70,NULL,NULL,'GIN 688',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162167,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162167,36.37,0.25,188,75744,74.4,NULL,NULL,'GIN 682',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000037,NULL,'14.63',NULL,'S0','Group member',NULL,NULL,NULL,1,350.996417,16.81128,0.049,NULL,52518055416,820594615,12821790,14.63),(162168,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162168,36.59,0.16,208,75744,70,NULL,NULL,'GIN 682',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162169,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162169,35.97,0.43,157,75745,NULL,NULL,NULL,'SDSS J232400.22+143348.4',NULL,'2009ApJS..182..474S',2009,1,0.37,NULL,'G',0.000023,NULL,'17.3g',0.16,'Sab','Group member',NULL,NULL,NULL,1,351.000917,14.56344,0.109,NULL,52527397540,820740586,12824071,17.3),(162170,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162170,36.01,0.2,159,75745,74.4,NULL,NULL,'SDSS J232400.22+143348.4',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162171,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162171,36.11,0.41,167,75745,NULL,NULL,'Malmquist cor.','SDSS J232400.22+143348.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162172,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162172,36.43,0.53,193,75746,70,NULL,NULL,'2MASX J23240020-0153140',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.38',0.33,NULL,NULL,NULL,NULL,NULL,1,351.000833,-1.88711,0.133,NULL,49410971286,772046426,12063225,16.38),(162173,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162173,37.81,0.23,364,75747,70,NULL,NULL,'2MASX J23240031-0057380',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000073,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,351.0012917,-0.96053,0.153,NULL,49412176800,772065262,12063519,17.8),(162174,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162174,35.86,NULL,148,75748,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12577',NULL,'2010Ap&SS.325..163P',2010,1,1.4,NULL,'G',0.00001,NULL,'16.0',0.17,'Sbc',NULL,NULL,NULL,NULL,1,351.001833,20.6845,0.117,NULL,52539153747,820924277,12826941,16),(162175,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162175,35.87,NULL,149,75748,NULL,NULL,'Dipole + Quadrupole','UGC 12577',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162176,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162176,35.88,NULL,150,75748,NULL,NULL,NULL,'UGC 12577',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162177,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162177,35.89,NULL,150,75748,NULL,NULL,'Dipole','UGC 12577',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162178,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162178,36.35,0.09,186,75749,70,NULL,NULL,'GIN 706',NULL,'2001MNRAS.321..277C',2001,1,0.33,NULL,'G',0.000027,NULL,'16.8g',0.24,'E','Group member',NULL,NULL,NULL,1,351.006,14.48172,0.101,NULL,52527424642,820741010,12824078,16.8),(162179,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162179,37.15,0.25,269,75749,74.4,NULL,NULL,'GIN 706',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162180,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162180,37.4,0.33,302,75749,70,NULL,NULL,'GIN 706',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162181,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162181,36.44,0.09,194,75750,70,NULL,NULL,'2MASX J23240307+1439539',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000165,NULL,'16.9g',0.25,NULL,'Group member',NULL,NULL,NULL,1,351.01275,14.66511,0.109,NULL,52527599151,820743736,12824120,16.9),(162182,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162182,36.15,0.25,170,75751,74.4,NULL,NULL,'GIN 714',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000033,NULL,'16.5g',0.33,'S','Group member',NULL,NULL,NULL,1,351.014375,13.94794,0.101,NULL,51625633687,806650526,12603914,16.5),(162183,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162183,41.22,0.27,1200,75752,74.2,NULL,'SALT 2','ESSENCE m158 HOST',0.463,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.014708333,-9.38839,0.073,NULL,49606640648,775103760,12110996,NULL),(162184,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158','R',162184,41.65,NULL,1460,75752,65,NULL,'SALT','ESSENCE m158 HOST',0.463,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162185,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162185,41.95,0.27,1680,75752,65,NULL,'SALT2','ESSENCE m158 HOST',0.463,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162186,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162186,41.95,0.27,1680,75752,70,NULL,'SALT','ESSENCE m158 HOST',0.463,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162187,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162187,42.06,0.24,1770,75752,65,NULL,'SALT','ESSENCE m158 HOST',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162188,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162188,42.11,0.27,1800,75752,65,NULL,'SALT2','ESSENCE m158 HOST',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162189,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162189,42.36,0.11,2030,75752,65,NULL,'SALT','ESSENCE m158 HOST',0.463,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162190,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162190,42.39,0.26,2060,75752,65,NULL,'MLCS2k2','ESSENCE m158 HOST',0.463,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162191,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162191,42.42,0.26,2090,75752,65,NULL,'MLCS17','ESSENCE m158 HOST',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162192,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162192,42.57,0.27,2230,75752,65,NULL,'MLCS31','ESSENCE m158 HOST',0.463,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162193,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m158',NULL,162193,42.58,0.26,2240,75752,65,NULL,'MLCS2k2','ESSENCE m158 HOST',0.463,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162194,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162194,36.08,0.38,164,75753,NULL,NULL,'Malmquist cor.','2MASX J23240520+1639429',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.00014,NULL,'16.45',0.2,'Sb','Group member',NULL,NULL,NULL,1,351.021833333,16.66206,0.049,NULL,52518851999,820607062,12821985,16.45),(162195,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162195,36.1,0.37,166,75753,NULL,NULL,NULL,'2MASX J23240520+1639429',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162196,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162196,36.14,0.2,169,75753,74.4,NULL,NULL,'2MASX J23240520+1639429',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162197,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08644','RN',162197,40.25,0.25,1000,75754,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 08644',0.118321,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162198,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08644','RN',162198,40.41,0.2,1080,75754,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 08644',0.118321,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162199,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162199,36.15,0.25,170,75755,74.4,NULL,NULL,'2MASX J23240637+1425059',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000103,NULL,'17.19',0.2,NULL,'Group member',NULL,NULL,NULL,1,351.026583,14.41825,0.101,NULL,52527371885,820740185,12824065,17.19),(162200,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162200,34.34,0.47,73.7,75756,NULL,NULL,'H','NGC 7646',NULL,'2007A&A...465...71T',2007,1,0.9,'Identification as NGC 7646 is not certain.','G',0.000033,NULL,'14',0.5,'Sc             HII','Group member',NULL,NULL,NULL,1,351.029,-11.86069,0.091,NULL,49562175039,774408984,12100140,14),(162201,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162201,34.44,0.46,77.4,75756,NULL,NULL,'J','NGC 7646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162202,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162202,34.49,0.45,79,75756,NULL,NULL,'K','NGC 7646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162203,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162203,34.73,0.4,88.5,75756,NULL,NULL,'mean','NGC 7646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162204,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162204,35.49,0.79,125,75757,NULL,NULL,NULL,'2MASX J23240714+1450069',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000037,NULL,'16.3g',0.36,'Sc','Group member',NULL,NULL,NULL,1,351.029875,14.83517,0.109,NULL,52527469564,820741711,12824089,16.3),(162205,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162205,35.53,0.2,128,75757,74.4,NULL,NULL,'2MASX J23240714+1450069',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162206,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162206,35.57,0.76,130,75757,NULL,NULL,'Malmquist cor.','2MASX J23240714+1450069',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162207,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162207,35.3,0.64,115,75758,NULL,NULL,'Malmquist cor.','KUG 2321+130',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',NULL,NULL,'16.20',0.3,NULL,NULL,NULL,NULL,NULL,1,351.042625,13.30906,0.093,NULL,51626230801,806659856,12604060,16.2),(162208,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162208,35.34,0.62,117,75758,NULL,NULL,NULL,'KUG 2321+130',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162209,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162209,35.38,0.2,119,75758,74.4,NULL,NULL,'KUG 2321+130',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162210,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162210,36.44,0.09,194,75759,70,NULL,NULL,'2MASX J23241079+1443399',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000137,NULL,'16.8g',0.25,NULL,'Group member',NULL,NULL,NULL,1,351.0449583,14.72778,0.109,NULL,52527466180,820741659,12824088,16.8),(162211,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162211,36.44,0.09,194,75760,70,NULL,NULL,'2MASX J23241148+1441029',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00016,NULL,'17.0g',0.22,NULL,'Group member',NULL,NULL,NULL,1,351.04775,14.68419,0.109,NULL,52527465408,820741647,12824088,17),(162212,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162212,36.35,0.09,186,75761,70,NULL,NULL,'GIN 700',NULL,'2001MNRAS.321..277C',2001,1,0.57,NULL,'G',0.000027,NULL,'14.63',0.53,'E/S0','Group member',NULL,NULL,NULL,1,351.050083333,14.42408,0.101,NULL,52527374020,820740219,12824065,14.63),(162213,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162213,36.13,0.25,168,75762,74.4,NULL,NULL,'GIN 692',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000027,NULL,'15.7g',0.52,'E/S0','Group member',NULL,NULL,NULL,1,351.050875,14.61889,0.109,NULL,52527385960,820740405,12824068,15.7),(162214,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162214,36.35,0.09,186,75762,70,NULL,NULL,'GIN 692',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162215,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162215,36.44,0.09,194,75762,70,NULL,NULL,'GIN 692',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162216,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','PTF10yux',NULL,162216,36.9,0.05,227,75763,70,NULL,'SiFTO+SALT2, SN PTF10yux','PTF10yux',0.0559,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.055791667,7.22853,0.177,NULL,51802490346,809413911,12647092,NULL),(162217,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','PTF10yux',NULL,162217,36.95,0.04,232,75763,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10yux',0.0559,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162218,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162218,37.18,0.46,273,75764,70,NULL,NULL,'2MASX J23241436-1004176',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000139,NULL,'17.9g',0.14,NULL,NULL,NULL,NULL,NULL,1,351.05975,-10.07147,0.057,NULL,49608420036,775131563,12111430,17.9),(162219,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162219,36.15,0.25,170,75765,74.4,NULL,NULL,'GIN 711',NULL,'2013AJ....146...86T',2013,1,0.64,NULL,'G',0.00004,NULL,'16.0g',0.24,'E/S0','Group member',NULL,NULL,NULL,1,351.068833333,13.96647,0.101,NULL,51625626164,806650408,12603912,16),(162220,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00692','RN',162220,38.7,0.13,458,75766,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00692',0.197275,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162221,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162221,37.55,0.46,324,75767,70,NULL,NULL,'2MASX J23241865+0004162',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000069,NULL,'18.5g',0.12,NULL,NULL,NULL,NULL,NULL,1,351.0777917,0.07114,0.121,NULL,51574402180,805850034,12591406,18.5),(162222,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162222,36.38,0.25,189,75768,74.4,NULL,NULL,'GIN 689',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000037,NULL,'15.68',0.2,'SB0','Group member',NULL,NULL,NULL,1,351.0815417,16.73169,0.049,NULL,52518901233,820607831,12821997,15.68),(162223,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162223,36.59,0.16,208,75768,70,NULL,NULL,'GIN 689',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162224,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162224,36.14,0.25,169,75769,74.4,NULL,NULL,'NGC 7649',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000057,NULL,'14.98',0.9,'cD;E           AGN:','Group member',NULL,NULL,NULL,1,351.0837083,14.64714,0.109,NULL,52519011126,820609548,12822024,14.98),(162225,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162225,36.35,0.09,186,75769,70,NULL,NULL,'NGC 7649',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162226,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162226,35.68,0.45,137,75769,NULL,NULL,'K','NGC 7649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162227,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162227,36.15,0.11,170,75769,70,NULL,'ABELL 2593, BGC','NGC 7649',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162228,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162228,36.21,0.4,175,75769,NULL,NULL,'mean','NGC 7649',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162229,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162229,36.15,0.11,170,75770,70,NULL,NULL,'ABELL 2593',NULL,'1999AJ....118.1489D',1999,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,351.084167,14.65111,0.109,NULL,52519011092,820609548,12822024,NULL),(162230,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162230,36.64,0.46,213,75771,70,NULL,NULL,'2MASX J23242089+0115393',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000073,NULL,'16.4g',0.29,NULL,NULL,NULL,NULL,NULL,1,351.087,1.26092,0.129,NULL,51576542528,805883477,12591929,16.4),(162231,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162231,36.44,0.09,194,75772,70,NULL,NULL,'2MASX J23242212+1506202',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.8g',0.28,NULL,'Group member',NULL,NULL,NULL,1,351.092167,15.1055,0.113,NULL,52519832331,820622380,12822224,16.8),(162232,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162232,36.35,0.09,186,75773,70,NULL,NULL,'GIN 696',NULL,'2001MNRAS.321..277C',2001,1,0.43,NULL,'G',0.00003,NULL,'14.80',0.38,'E/S0','Group member',NULL,NULL,NULL,1,351.095708333,14.6585,0.109,NULL,52519011068,820609547,12822024,14.8),(162233,'H I + optical distribution','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162233,33.11,0.2,41.8,75774,NULL,NULL,NULL,'UGC 12578',NULL,'1990ApJ...364...23S',1990,1,1.6,'Host galaxy of UM 160.  Identification as NGC 7667 is very unlikely.','G',0.000011,NULL,'14.54',1.1,'SB(s)m pec',NULL,NULL,NULL,NULL,1,351.09625,-0.10806,0.121,NULL,49411128718,772048886,12063263,14.54),(162234,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162234,31.17,0.2,17.1,75774,74.4,NULL,NULL,'UGC 12578',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162235,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162235,31.25,0.4,17.8,75774,NULL,NULL,NULL,'UGC 12578',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162236,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162236,31.64,0.62,21.3,75774,NULL,NULL,'Malmquist cor.','UGC 12578',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162237,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162237,31.78,0.58,22.7,75774,NULL,NULL,NULL,'UGC 12578',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162238,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162238,32.75,0.4,35.4,75774,75,NULL,'B','UGC 12578',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162239,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162239,36.14,0.25,169,75775,74.4,NULL,NULL,'GIN 699',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000033,NULL,'14.62',0.39,'E','Group member',NULL,NULL,NULL,1,351.0982917,14.70711,0.109,NULL,52519125294,820611332,12822052,14.62),(162240,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162240,36.35,0.09,186,75775,70,NULL,NULL,'GIN 699',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162241,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162241,40.7,0.32,980,75776,74.2,NULL,'SALT 2','ESSENCE J232425.51-084551.1',0.408,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.106291667,-8.76419,0.113,NULL,49606271555,775097993,12110906,NULL),(162242,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162242,41.61,0.37,1490,75776,65,NULL,'SN f096, MLCS2k2','ESSENCE J232425.51-084551.1',0.408,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162243,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm','R',162243,41.72,NULL,1570,75776,65,NULL,'SN f096, SALT','ESSENCE J232425.51-084551.1',0.408,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162244,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162244,41.78,0.3,1610,75776,70,NULL,'SN f096, SALT','ESSENCE J232425.51-084551.1',0.408,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162245,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162245,41.83,0.34,1650,75776,65,NULL,'SN f096, SALT','ESSENCE J232425.51-084551.1',0.408,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162246,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003lm',NULL,162246,42.37,0.16,2120,75776,65,NULL,'SN f096, SALT','ESSENCE J232425.51-084551.1',0.408,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162247,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162247,36.15,0.25,170,75777,74.4,NULL,NULL,'NGC 7651 NED01',NULL,'2013AJ....146...86T',2013,1,1.13,NULL,'G',0.000037,NULL,'14.4g',0.76,'cD',NULL,NULL,NULL,NULL,1,351.108208333,13.97228,0.101,NULL,51625627161,806650424,12603912,14.4),(162248,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162248,36.44,0.09,194,75777,70,NULL,NULL,'NGC 7651 NED01',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162249,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162249,36.15,0.25,170,75778,74.4,NULL,NULL,'GIN 705',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000033,NULL,'16.4V',NULL,'E','Group member',NULL,NULL,NULL,1,351.1180417,14.69514,0.109,NULL,52519194422,820612412,12822068,16.4),(162250,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162250,36.35,0.09,186,75778,70,NULL,NULL,'GIN 705',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162251,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162251,36.44,0.09,194,75778,70,NULL,NULL,'GIN 705',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162252,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162252,37.81,0.23,364,75779,70,NULL,NULL,'2MASX J23242841-0048346',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000076,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,351.11825,-0.80964,0.165,NULL,49411704037,772057875,12063404,17),(162253,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162253,35.68,0.6,137,75780,70,NULL,NULL,'2MASX J23243032-8240444',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.3b',NULL,NULL,NULL,NULL,NULL,NULL,1,351.1260417,-82.679,0.433,NULL,48344902488,755389101,11802954,17.3),(162254,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162254,37.81,0.23,364,75781,70,NULL,NULL,'2MASX J23243027-0056466',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000101,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,351.1262917,-0.94614,0.149,NULL,49411684029,772057562,12063399,17.2),(162255,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03869','RN',162255,42,0.49,2260,75782,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 03869',0.108236,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162256,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03869','RN',162256,42.14,0.52,2410,75782,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 03869',0.108236,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162257,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162257,36.12,0.25,167,75783,74.4,NULL,NULL,'GIN 712',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00003,NULL,'14.63',0.39,'E/S0','Group member',NULL,NULL,NULL,1,351.1320417,14.27206,0.101,NULL,51637125883,806830091,12606720,14.63),(162258,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162258,36.35,0.09,186,75784,70,NULL,NULL,'GIN 693',NULL,'2001MNRAS.321..277C',2001,1,0.46,NULL,'G',0.000033,NULL,'14.75',0.45,'cD;E/S0','Group member',NULL,'radio jet',NULL,1,351.13375,14.63944,0.109,NULL,52519012932,820609577,12822024,14.75),(162259,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hc',NULL,162259,43.45,0.11,2870,75785,65,NULL,'SN h311, MLCS2k2','ESSENCE J232432.67-084103.5',0.7,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.136125,-8.68431,0.061,NULL,49606084636,775095072,12110860,NULL),(162260,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hc',NULL,162260,43.63,0.17,3140,75785,65,NULL,'SN h311, SALT','ESSENCE J232432.67-084103.5',0.7,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162261,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162261,34.05,0.8,64.7,75786,75,NULL,'MAT, I','UGC 12583',NULL,'1997ApJS..109..333W',1997,1,1.42,NULL,'G',0.000014,NULL,'15.53',0.19,'Scd',NULL,NULL,NULL,NULL,1,351.141833333,23.98678,0.157,NULL,51983151350,812236739,12691199,15.53),(162262,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162262,34.06,0.8,64.7,75786,75,NULL,'W91PP, r','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162263,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162263,34.09,0.2,65.8,75786,74.4,NULL,NULL,'UGC 12583',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162264,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162264,34.29,NULL,72.1,75786,NULL,NULL,'Dipole + Quadrupole','UGC 12583',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162265,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162265,34.29,NULL,72.1,75786,NULL,NULL,'Dipole','UGC 12583',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162266,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162266,34.29,NULL,72.1,75786,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12583',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162267,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162267,34.29,0.49,72.2,75786,75,NULL,'IR','UGC 12583',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162268,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162268,34.36,NULL,74.6,75786,NULL,NULL,NULL,'UGC 12583',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162269,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162269,34.53,0.58,80.4,75786,NULL,NULL,NULL,'UGC 12583',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162270,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162270,34.62,0.38,84.1,75786,75,NULL,'W91PP, r, raw','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162271,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162271,34.64,0.32,84.8,75786,85,NULL,'I, raw','UGC 12583',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162272,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162272,34.64,0.38,84.8,75786,75,NULL,'W91PP, r, inv','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162273,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162273,34.65,0.32,85.3,75786,85,NULL,'I, inv','UGC 12583',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162274,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162274,34.69,0.53,86.7,75786,NULL,NULL,'Malmquist cor.','UGC 12583',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162275,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162275,34.79,0.43,90.6,75786,75,NULL,'MAT, I, raw','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162276,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162276,34.88,0.43,94.8,75786,75,NULL,'MAT, I, inv','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162277,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162277,34.92,0.38,96.2,75786,75,NULL,'W91PP, r, cor','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162278,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162278,35.1,0.43,105,75786,75,NULL,'MAT, I, cor','UGC 12583',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162279,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162279,35.85,0.59,148,75787,70,NULL,NULL,'2MASX J23243476-5029255',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00011,NULL,'17.06',0.22,'S',NULL,NULL,NULL,NULL,1,351.14475,-50.49069,0,NULL,48649321545,760145649,11877275,17.06),(162280,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 01745','RN',162280,43.29,0.2,2860,75788,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01745',0.589572,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162281,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162281,36.15,0.25,170,75789,74.4,NULL,NULL,'GIN 698',NULL,'2013AJ....146...86T',2013,1,0.51,NULL,'G',0.000033,NULL,'14.90',0.19,'E','Group member',NULL,NULL,NULL,1,351.149208333,14.68292,0.109,NULL,52519192469,820612382,12822068,14.9),(162282,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162282,36.35,0.09,186,75789,70,NULL,NULL,'GIN 698',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162283,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03871','RN',162283,43.11,0.22,2730,75790,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03871',0.537152,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162284,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162284,36.13,0.25,168,75791,74.4,NULL,NULL,'GIN 704',NULL,'2013AJ....146...86T',2013,1,0.4,'1990ApJ...360..436B have V = 12656 +- 50 km/s.','G',0.000037,NULL,'15.06',0.2,'E','Group member',NULL,NULL,NULL,1,351.153041667,14.58392,0.109,NULL,52519023573,820609743,12822027,15.06),(162285,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162285,36.35,0.09,186,75791,70,NULL,NULL,'GIN 704',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162286,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162286,36.15,0.25,170,75792,74.4,NULL,NULL,'MCG +02-59-037',NULL,'2013AJ....146...86T',2013,1,0.57,'MCG identification as IC 1487 is incorrect.','G',0.00003,NULL,'15.4g',0.49,'cD;E/S0','Group member',NULL,'NAT',NULL,1,351.155167,14.64244,0.109,NULL,52519023815,820609747,12822027,15.4),(162287,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162287,36.16,0.25,171,75792,74.4,NULL,NULL,'MCG +02-59-037',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162288,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162288,36.35,0.09,186,75792,70,NULL,NULL,'MCG +02-59-037',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162289,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162289,36.39,0.54,190,75793,NULL,NULL,'Malmquist cor.','2MASX J23243778+1453102',NULL,'2009ApJS..182..474S',2009,1,0.61,NULL,'G',0.000107,NULL,'15.8g',0.39,NULL,'Group member',NULL,NULL,NULL,1,351.157375,14.88606,0.113,NULL,52519172058,820612063,12822063,15.8),(162290,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162290,37,0.41,251,75793,NULL,NULL,NULL,'2MASX J23243778+1453102',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162291,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162291,37.04,0.2,256,75793,74.4,NULL,NULL,'2MASX J23243778+1453102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162292,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162292,37.91,0.46,381,75794,70,NULL,NULL,'2MASX J23243821-1020262',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000164,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,351.159167,-10.34072,0.044,NULL,49608619464,775134679,12111479,17.2),(162293,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15136','R',162293,39.11,0.18,577,75795,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006ju','2MASX J23243894-0043046',0.148617,'2014arXiv1401.3317S',2014,1,0.21,NULL,'G',0.000047,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,351.16225,-0.71792,0.157,NULL,49411690007,772057656,12063400,17.9),(162294,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15136','R',162294,39.19,0.09,599,75795,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006ju','2MASX J23243894-0043046',0.148617,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162295,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006ju',NULL,162295,38.91,0.07,605,75795,70,NULL,'SALT 2','2MASX J23243894-0043046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162296,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006ju',NULL,162296,38.92,0.07,608,75795,70,NULL,'SALT 2, Malmquist cor.','2MASX J23243894-0043046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162297,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08254','R',162297,39.91,0.21,806,75796,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232439.30+004911.8',0.189,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0005,NULL,'20.6g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,351.16375,0.81994,0.157,NULL,51574562683,805852541,12591445,20.6),(162298,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08254','R',162298,39.98,0.17,833,75796,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232439.30+004911.8',0.189,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162299,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08254',NULL,162299,39.79,0.11,908,75796,70,NULL,'SALT 2','SDSS J232439.30+004911.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162300,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 08254',NULL,162300,39.8,0.11,912,75796,70,NULL,'SALT 2, Malmquist cor.','SDSS J232439.30+004911.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162301,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162301,36.44,0.09,194,75797,70,NULL,NULL,'2MASX J23243948+1432332',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000173,NULL,'17.3g',0.21,NULL,'Group member',NULL,NULL,NULL,1,351.164583,14.5425,0.105,NULL,52519033005,820609890,12822029,17.3),(162302,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162302,36.13,0.25,168,75798,74.4,NULL,NULL,'GIN 697',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.00003,NULL,'16.6g',0.29,'S','Group member',NULL,NULL,NULL,1,351.165375,14.66744,0.109,NULL,52519204923,820612576,12822071,16.6),(162303,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162303,36.35,0.09,186,75798,70,NULL,NULL,'GIN 697',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162304,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162304,37.46,0.23,310,75799,70,NULL,NULL,'SDSS J232440.74-084620.4',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000075,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.1697917,-8.77236,0.061,NULL,49606075133,775094923,12110858,18.3),(162305,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162305,36.94,0.23,245,75800,70,NULL,NULL,'2MASX J23244092-0953532',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000153,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,351.170333,-9.89806,0.069,NULL,49606567893,775102623,12110978,17.1),(162306,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162306,36.13,0.25,168,75801,74.4,NULL,NULL,'CGCG 431-056',NULL,'2013AJ....146...86T',2013,1,1.9,NULL,'G',0.000037,NULL,'13.92',1.6,'E/S0','Group member',NULL,NULL,NULL,1,351.170583333,14.63206,0.109,NULL,52519019946,820609686,12822026,13.92),(162307,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162307,36.35,0.09,186,75802,70,NULL,NULL,'SDSS J232441.23+143801.3',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'*',NULL,NULL,'18.0g',NULL,'Point Src [SDSS]',NULL,NULL,NULL,NULL,1,351.171791667,14.63372,0.109,NULL,52519019948,820609686,12822026,18),(162308,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162308,33.09,NULL,41.4,75803,NULL,NULL,NULL,'FGC 2498',NULL,'2000BSAO...50....5K',2000,1,0.96,NULL,'G',0.000043,NULL,'16.8',0.09,'Sdm',NULL,NULL,NULL,NULL,1,351.175,-2.79167,0.129,NULL,49629138229,775455284,12116488,16.8),(162309,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162309,33.12,NULL,42,75803,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162310,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162310,33.13,NULL,42.3,75803,NULL,NULL,'Dipole + Quadrupole','FGC 2498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162311,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162311,33.15,NULL,42.7,75803,NULL,NULL,'Dipole','FGC 2498',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162312,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m075',NULL,162312,40.37,1.19,1080,75804,65,NULL,'SALT','ESSENCE m075 HOST',0.1,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.176167,-8.4855,0.061,NULL,49603943459,775061616,12110337,NULL),(162313,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE m075',NULL,162313,40.79,0.22,1300,75804,65,NULL,'MLCS2k2','ESSENCE m075 HOST',0.1,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162314,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162314,29.84,0.4,9.3,75805,75,NULL,'B','UGC 12588',NULL,'1988NBGC.C....0000T',1988,1,1.7,NULL,'G',0.000013,NULL,'13.68',1.7,'Sdm','in a triple',NULL,NULL,NULL,1,351.17675,41.34678,0.425,NULL,55353274595,864894915,13513983,13.68),(162315,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162315,36.15,0.25,170,75806,74.4,NULL,NULL,'GIN 701',NULL,'2013AJ....146...86T',2013,1,0.5,'1990ApJ...360..436B has V = 13720 +- 50 km/s.','G',0.000027,NULL,'14.30',0.4,'S','Group member',NULL,NULL,NULL,1,351.177917,14.51839,0.105,NULL,52519041294,820610020,12822031,14.3),(162316,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162316,36.35,0.09,186,75806,70,NULL,NULL,'GIN 701',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162317,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14046','RN',162317,41.69,0.45,1480,75807,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14046',0.474334,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162318,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14046','N',162318,41.79,0.4,2280,75807,70,NULL,'SALT 2','SDSS-II SN 14046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162319,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14046','N',162319,41.9,0.4,2400,75807,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14046',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162320,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162320,37.46,0.23,310,75808,70,NULL,NULL,'2MASX J23244652-0847582',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.0g',0.31,'BrClG',NULL,NULL,NULL,NULL,1,351.1937917,-8.79944,0.075,NULL,49606078293,775094973,12110858,17),(162321,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162321,36.44,0.09,194,75809,70,NULL,NULL,'2MASX J23244711+1423011',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000189,NULL,'16.5g',0.27,NULL,'Group member',NULL,NULL,NULL,1,351.19625,14.38378,0.105,NULL,52518983922,820609123,12822017,16.5),(162322,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02570','RN',162322,42.22,0.27,2070,75810,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02570',0.342015,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162323,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 02570','RN',162323,42.4,0.36,2250,75810,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02570',0.342015,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162324,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162324,37.81,0.23,364,75811,70,NULL,NULL,'2MASX J23244745-0054481',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000091,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,351.197666667,-0.91339,0.149,NULL,49411674735,772057417,12063397,17.8),(162325,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18643','R',162325,38.8,0.1,515,75812,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2007lv','2MASX J23244792+0056390',0.118217,'2014arXiv1401.3317S',2014,1,0.28,NULL,'G',0.000112,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,351.1997917,0.94431,0.129,NULL,51574708632,805854822,12591481,17.5),(162326,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18643','R',162326,38.8,0.18,515,75812,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2007lv','2MASX J23244792+0056390',0.118217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162327,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162327,36.94,0.23,245,75813,70,NULL,NULL,'2MASX J23244884-0958102',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000162,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,351.203583,-9.96956,0.069,NULL,49609443077,775147548,12111680,16.5),(162328,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162328,36.14,0.25,169,75814,74.4,NULL,NULL,'IC 5319',NULL,'2013AJ....146...86T',2013,1,0.63,NULL,'G',0.000027,NULL,'15.4g',0.6,'E/S0           AGN','Group member',NULL,NULL,NULL,1,351.204,13.99653,0.101,NULL,51637356725,806833698,12606776,15.4),(162329,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162329,35.25,0.79,112,75815,NULL,NULL,'Malmquist cor.','2MASX J23244920+1358161',NULL,'2009ApJS..182..474S',2009,1,0.59,NULL,'G',0.000186,NULL,'15.9g',0.45,'S0/a','Group member',NULL,NULL,NULL,1,351.204875,13.97106,0.101,NULL,51637357582,806833712,12606776,15.9),(162330,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162330,35.34,0.75,117,75815,NULL,NULL,NULL,'2MASX J23244920+1358161',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162331,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162331,35.38,0.2,119,75815,74.4,NULL,NULL,'2MASX J23244920+1358161',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162332,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162332,33.89,0.05,60.1,75816,NULL,NULL,NULL,'NGC 7653',NULL,'2009ApJS..182..474S',2009,1,1.59,NULL,'G',0.000033,NULL,'13.4g',1.19,'Sb',NULL,NULL,NULL,NULL,1,351.205667,15.27558,0.093,NULL,52519592701,820618635,12822166,13.4),(162333,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162333,37.46,0.23,310,75817,70,NULL,NULL,'2MASX J23245347-0848382',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000086,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.2227917,-8.81053,0.075,NULL,49606082049,775095032,12110859,17.9),(162334,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162334,36.62,1.03,211,75818,70,NULL,NULL,'2MASX J23245643-1204591',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000103,NULL,'15.4',NULL,NULL,'Group member',NULL,NULL,NULL,1,351.235125,-12.08311,0.079,NULL,49573607105,774587611,12102931,15.4),(162335,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162335,35.34,0.32,117,75819,NULL,NULL,NULL,'ESO 605- G 006',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.87',0.4,'Sc','in a triple',NULL,NULL,NULL,1,351.2545417,-18.85889,0,NULL,50328842129,786388158,12287314,15.87),(162336,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162336,35.38,0.2,119,75819,74.4,NULL,NULL,'ESO 605- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162337,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162337,35.49,0.3,125,75819,NULL,NULL,'Malmquist cor.','ESO 605- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162338,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162338,34.97,0.69,98.6,75820,100,NULL,'mid-IR','CGCG 406-102',NULL,'2013ApJ...771...88L',2013,1,0.6,NULL,'G',0.000103,NULL,'15.2',0.3,NULL,NULL,NULL,NULL,NULL,1,351.257041667,8.26561,0.161,NULL,51801798283,809403098,12646923,15.2),(162339,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162339,35.02,0.2,101,75820,74.4,NULL,NULL,'CGCG 406-102',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162340,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00883','RN',162340,42.48,0.21,2410,75821,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 00883',0.302223,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162341,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00883','RN',162341,42.67,0.25,2620,75821,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 00883',0.302223,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162342,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162342,36,0.42,159,75822,NULL,NULL,NULL,'SDSS J232508.25+151758.2',NULL,'2009ApJS..182..474S',2009,1,0.64,NULL,'G',0.00003,NULL,'16.4g',0.44,'Sc',NULL,NULL,NULL,NULL,1,351.284416667,15.2995,0.093,NULL,52519868582,820622946,12822233,16.4),(162343,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162343,36.04,0.2,161,75822,74.4,NULL,NULL,'SDSS J232508.25+151758.2',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162344,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162344,36.1,0.4,166,75822,NULL,NULL,'Malmquist cor.','SDSS J232508.25+151758.2',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162345,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162345,36.21,0.34,174,75823,NULL,NULL,'Malmquist cor.','AGC 331592',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'16.68',NULL,'Sc',NULL,NULL,NULL,NULL,1,351.285291667,16.37661,0.077,NULL,52518297650,820598400,12821850,16.68),(162346,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162346,36.25,0.33,178,75823,NULL,NULL,NULL,'AGC 331592',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162347,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162347,36.3,0.2,182,75823,74.4,NULL,NULL,'AGC 331592',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162348,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162348,36.27,0.36,180,75824,NULL,NULL,'Malmquist cor.','SDSS J232508.92+150944.4',NULL,'2009ApJS..182..474S',2009,1,0.36,NULL,'G',0.00003,NULL,'17.5g',0.15,'Scd','Group member',NULL,NULL,NULL,1,351.287167,15.16236,0.089,NULL,52519894201,820623346,12822239,17.5),(162349,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162349,36.48,0.33,197,75824,NULL,NULL,NULL,'SDSS J232508.92+150944.4',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162350,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162350,36.52,0.2,201,75824,74.4,NULL,NULL,'SDSS J232508.92+150944.4',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162351,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962',NULL,162351,40.18,1.09,1090,75825,70,NULL,'SN photometric redshift distance, z photo =0.296 +/- 0.266','SDSS-II SN 09962',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.2g',0.08,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,351.2924583,-0.30808,0.145,NULL,49411210497,772050164,12063283,20.2),(162352,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962','R',162352,41.21,0.33,1320,75825,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09962',0.325121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162353,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962','R',162353,41.28,0.33,1360,75825,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09962',0.325121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162354,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962',NULL,162354,41.01,0.23,1590,75825,70,NULL,'SALT 2','SDSS-II SN 09962',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162355,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 09962',NULL,162355,41.05,0.23,1620,75825,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09962',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162356,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162356,36.15,0.31,170,75826,NULL,NULL,NULL,'2MASXi J2325107+141257',NULL,'2009ApJS..182..474S',2009,1,0.42,NULL,'G',0.000033,NULL,'17.3g',0.14,'Sc','Group member',NULL,NULL,NULL,1,351.2949583,14.21619,0.105,NULL,51637163852,806830685,12606729,17.3),(162357,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162357,36.18,0.31,172,75826,NULL,NULL,'Malmquist cor.','2MASXi J2325107+141257',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162358,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162358,36.19,0.2,173,75826,74.4,NULL,NULL,'2MASXi J2325107+141257',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162359,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162359,37.46,0.23,310,75827,70,NULL,NULL,'2MASX J23251200-0847352',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000135,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,351.300083333,-8.79325,0.075,NULL,49606070934,775094858,12110857,17.9),(162360,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162360,37.7,0.46,346,75828,70,NULL,NULL,'2MASX J23251294+1547397',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000156,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,351.3039583,15.79431,0.073,NULL,52519535017,820617734,12822152,17),(162361,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162361,36.24,0.33,177,75829,70,NULL,NULL,'2MASX J23251682+1421357',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000208,NULL,'15.6g',0.37,'E0','Group member',NULL,NULL,NULL,1,351.319916667,14.35989,0.105,NULL,51632990754,806765480,12605710,15.6),(162362,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162362,36.76,0.75,224,75830,70,NULL,NULL,'2MASX J23251716-5318320',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.65',0.28,NULL,NULL,NULL,NULL,NULL,1,351.321417,-53.30897,0,NULL,48641138824,760017794,11875278,16.65),(162363,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162363,38.06,0.46,409,75831,70,NULL,NULL,'SDSS J232517.17-002701.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.8g',0.11,NULL,NULL,NULL,NULL,NULL,1,351.3215417,-0.45033,0.149,NULL,49411169125,772049517,12063273,18.8),(162364,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162364,36.27,0.32,180,75832,NULL,NULL,'Malmquist cor.','2MASX J23251720+1447177',NULL,'2009ApJS..182..474S',2009,1,0.53,NULL,'G',0.000023,NULL,'16.3g',0.24,'Sc','Group member',NULL,NULL,NULL,1,351.321583,14.78828,0.113,NULL,52519238989,820613109,12822079,16.3),(162365,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162365,36.43,0.3,194,75832,NULL,NULL,NULL,'2MASX J23251720+1447177',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162366,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162366,36.47,0.2,197,75832,74.4,NULL,NULL,'2MASX J23251720+1447177',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162367,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13797','RN',162367,40.78,0.36,1120,75833,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13797',0.279324,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162368,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13797','RN',162368,40.98,0.38,1230,75833,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13797',0.279324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162369,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162369,36.44,0.09,194,75834,70,NULL,NULL,'2MASX J23251750+1417157',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000168,NULL,'17.0g',0.14,NULL,'Group member',NULL,NULL,NULL,1,351.322958333,14.28772,0.105,NULL,51632955847,806764935,12605702,17),(162370,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162370,34.08,0.49,65.4,75835,75,NULL,'IR','CGCG 431-062',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000474,NULL,'15.7',0.2,NULL,'Group member',NULL,NULL,NULL,1,351.329583,13.92111,0.109,NULL,51637211733,806831433,12606741,15.7),(162371,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162371,33.87,0.2,59.4,75836,74.4,NULL,NULL,'CGCG 431-062',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000474,NULL,'15.7',0.2,NULL,'Group member',NULL,NULL,NULL,1,351.329583,13.92111,0.109,NULL,51637211733,806831433,12606741,15.7),(162372,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162372,35.91,0.42,152,75837,NULL,NULL,NULL,'2MASXi J2325197+142418',NULL,'2009ApJS..182..474S',2009,1,0.71,NULL,'G',0.000023,NULL,'15.9g',0.38,'Sc','Group member',NULL,NULL,NULL,1,351.3325,14.40544,0.105,NULL,51632995607,806765556,12605711,15.9),(162373,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162373,35.95,0.2,155,75837,74.4,NULL,NULL,'2MASXi J2325197+142418',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162374,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162374,36.01,0.4,159,75837,NULL,NULL,'Malmquist cor.','2MASXi J2325197+142418',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162375,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162375,34.79,0.8,90.7,75838,75,NULL,'W91PP, r','UGC 12591',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000033,NULL,'13.90',0.7,'S0/a           LINER','Group member',NULL,NULL,NULL,1,351.340625,28.49522,0.293,NULL,52017366492,812771351,12699552,13.9),(162376,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162376,34.15,0.69,67.7,75838,100,NULL,'mid-IR','UGC 12591',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162377,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162377,35.61,0.38,133,75838,75,NULL,'W91PP, r, raw','UGC 12591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162378,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162378,35.8,0.38,144,75838,75,NULL,'W91PP, r, cor','UGC 12591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162379,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162379,36.14,0.38,169,75838,75,NULL,'W91PP, r, inv','UGC 12591',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162380,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162380,35.14,0.69,107,75839,100,NULL,'mid-IR','CGCG 497-016',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000033,NULL,'14.79',0.7,'S?',NULL,NULL,NULL,NULL,1,351.342333,28.85681,0.293,NULL,52013844890,812716326,12698692,14.79),(162381,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162381,35.88,0.4,150,75839,NULL,NULL,'mean','CGCG 497-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162382,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162382,35.95,0.47,155,75839,NULL,NULL,'H','CGCG 497-016',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162383,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo','R',162383,41.71,NULL,1440,75840,65,NULL,'SN d033, SALT2','ESSENCE J232524.03-092600.6',0.524,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.350125,-9.4335,0.076,NULL,49599102316,774985973,12109155,NULL),(162384,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162384,42.62,0.19,2190,75840,65,NULL,'SN d033, m15(B)','ESSENCE J232524.03-092600.6',0.524,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162385,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162385,42.67,0.2,2240,75840,65,NULL,'SN d033, MLCS','ESSENCE J232524.03-092600.6',0.524,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162386,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162386,42.86,0.17,2440,75840,65,NULL,'SN d033, MLCS17','ESSENCE J232524.03-092600.6',0.524,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162387,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162387,42.89,0.31,2480,75840,65,NULL,'SN d033, BATM','ESSENCE J232524.03-092600.6',0.524,'2005AJ....130.2453K',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162388,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162388,42.93,0.14,2520,75840,65,NULL,'SN d033, MLCS2k2','ESSENCE J232524.03-092600.6',0.524,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162389,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162389,42.93,0.16,2530,75840,65,NULL,'SN d033, MLCS31','ESSENCE J232524.03-092600.6',0.524,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162390,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162390,42.96,0.14,2560,75840,65,NULL,'SN d033, MLCS2k2','ESSENCE J232524.03-092600.6',0.524,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162391,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162391,43.06,0.3,2690,75840,70,NULL,'SN d033, SALT','ESSENCE J232524.03-092600.6',0.524,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162392,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162392,43.2,0.25,2860,75840,65,NULL,'SN d033, SALT2','ESSENCE J232524.03-092600.6',0.524,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162393,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162393,43.27,0.14,2960,75840,65,NULL,'SN d033, SALT','ESSENCE J232524.03-092600.6',0.524,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162394,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162394,43.27,0.27,2960,75840,65,NULL,'SN d033, SALT','ESSENCE J232524.03-092600.6',0.524,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162395,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003jo',NULL,162395,43.65,0.33,3520,75840,65,NULL,'SN d033, SALT2','ESSENCE J232524.03-092600.6',0.524,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162396,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162396,33.82,0.52,58.2,75841,NULL,NULL,NULL,'UGC 12593',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.000033,NULL,'15.13',0.9,'SAd',NULL,NULL,NULL,NULL,1,351.35075,32.67775,0.301,NULL,52063044071,813485063,12710704,15.13),(162397,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162397,33.86,0.2,59.2,75841,74.4,NULL,NULL,'UGC 12593',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162398,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162398,34.26,0.42,71.1,75841,NULL,NULL,'Malmquist cor.','UGC 12593',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162399,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162399,36.15,0.25,170,75842,74.4,NULL,NULL,'GIN 703',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000027,NULL,'15.7g',0.4,'E/S0','Group member',NULL,NULL,NULL,1,351.352917,14.75697,0.113,NULL,52519229616,820612962,12822077,15.7),(162400,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162400,36.35,0.09,186,75842,70,NULL,NULL,'GIN 703',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162401,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162401,36.44,0.09,194,75842,70,NULL,NULL,'GIN 703',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162402,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162402,35.46,0.49,123,75843,75,NULL,'IR','2MFGC 17591',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',NULL,NULL,'13.7K',0.1,NULL,NULL,NULL,NULL,NULL,1,351.3717917,7.55356,0.173,NULL,51804261879,809441591,12647524,13.7),(162403,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19051','R',162403,40.71,0.19,1090,75844,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007nb','APMUKS(BJ) B232256.34+000853.8',0.2773,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.0005,NULL,'20.48',0.09,NULL,NULL,NULL,NULL,NULL,1,351.37525,0.42328,0.129,NULL,51574297771,805848402,12591381,20.48),(162404,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19051','R',162404,40.86,0.1,1160,75844,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007nb','APMUKS(BJ) B232256.34+000853.8',0.2773,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162405,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2007nb',NULL,162405,40.61,0.09,1320,75844,70,NULL,'SALT 2','APMUKS(BJ) B232256.34+000853.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162406,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2007nb',NULL,162406,40.63,0.09,1340,75844,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B232256.34+000853.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162407,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162407,43,NULL,3980,75845,70,NULL,'Pseudo z = 4.2','GRB 031111',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,72.433333,17.46667,1.317,NULL,65485143992,1023205374,15987583,NULL),(162408,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162408,36.2,0.32,174,75846,NULL,NULL,'Malmquist cor.','SDSS J232531.72+152211.6',NULL,'2009ApJS..182..474S',2009,1,0.56,NULL,'G',0.00003,NULL,'17.6g',0.1,'Sc',NULL,NULL,NULL,NULL,1,351.382166667,15.36989,0.073,NULL,52519862813,820622856,12822232,17.6),(162409,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162409,36.24,0.31,177,75846,NULL,NULL,NULL,'SDSS J232531.72+152211.6',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162410,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162410,36.28,0.2,180,75846,74.4,NULL,NULL,'SDSS J232531.72+152211.6',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162411,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162411,36.22,0.76,176,75847,70,NULL,NULL,'LCRS B232249.2-441902',NULL,'2014MNRAS.445.2677S',2014,1,0.22,NULL,'G',0.00015,NULL,'15.44',0.2,NULL,NULL,NULL,NULL,NULL,1,351.388333333,-44.04208,NULL,NULL,50526784535,789481008,12335640,15.44),(162412,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162412,37.72,0.46,351,75848,70,NULL,NULL,'2MASX J23253333-1029389',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000143,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,351.388917,-10.49425,0.074,NULL,49600502128,775007845,12109497,17),(162413,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254',NULL,162413,39.34,1.03,738,75849,70,NULL,'SN photometric redshift distance, z photo =0.190 +/- 0.139','SDSS-II SN 18254',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.9g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,351.390458333,-0.98236,0.141,NULL,49411764468,772058819,12063419,21.9),(162414,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254','R',162414,41.18,0.37,1300,75849,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18254',0.319944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162415,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254','R',162415,41.37,0.31,1430,75849,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18254',0.319944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162416,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254',NULL,162416,41.28,0.27,1800,75849,70,NULL,'SALT 2','SDSS-II SN 18254',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162417,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 18254',NULL,162417,41.32,0.27,1840,75849,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 18254',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162418,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 21409','R',162418,40.26,0.35,939,75850,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21409',0.197694,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',NULL,'PHOT','20.6g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,351.3974583,-0.71553,0.141,NULL,49411592365,772056130,12063377,20.6),(162419,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 21409',NULL,162419,40.1,0.44,1050,75850,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.079','SDSS-II SN 21409',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162420,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15727','R',162420,39.46,0.24,704,75851,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15727',0.105414,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.4,-0.01417,0.141,NULL,49411055773,772047746,12063246,NULL),(162421,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 15727','R',162421,40.31,0.35,1050,75851,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15727',0.105414,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162422,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162422,38.68,0.25,468,75852,74.2,NULL,'SALT 2','APMUKS(BJ) B232300.59-094814.9',0.164,'2010ApJ...716..712A',2010,1,0.13,NULL,'G',0.001,NULL,'20.38',0.07,NULL,NULL,NULL,NULL,NULL,1,351.4005417,-9.52908,0.076,NULL,49599151752,774986746,12109167,20.38),(162423,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162423,39.56,0.36,701,75852,65,NULL,'SN e020, SALT2','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162424,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162424,39.59,0.38,710,75852,65,NULL,'SN e020, SALT2','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162425,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162425,39.75,0.3,765,75852,65,NULL,'SN e020, MLCS31','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162426,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162426,39.79,0.18,778,75852,65,NULL,'SN e020, MLCS2k2','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162427,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162427,39.79,0.27,778,75852,65,NULL,'SN e020, MLCS2k2','APMUKS(BJ) B232300.59-094814.9',0.164,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162428,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162428,39.79,0.24,781,75852,65,NULL,'SN e020, MLCS17','APMUKS(BJ) B232300.59-094814.9',0.164,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162429,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162429,39.99,0.09,855,75852,70,NULL,'SN e020, SALT','APMUKS(BJ) B232300.59-094814.9',0.164,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162430,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003kk',NULL,162430,40.27,0.03,974,75852,65,NULL,'SN e020, SALT','APMUKS(BJ) B232300.59-094814.9',0.164,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162431,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162431,38.11,0.33,419,75853,70,NULL,NULL,'2MASX J23253653-0950579',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000174,NULL,'17.6g',0.22,NULL,NULL,NULL,NULL,NULL,1,351.402333333,-9.84944,0.069,NULL,49599006560,774984477,12109132,17.6),(162432,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162432,35.5,0.48,126,75854,70,NULL,NULL,'NGC 7652',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.000137,NULL,'14.48',0.7,'(RL)SA(l)0^+:','in a triple',NULL,NULL,NULL,1,351.4059583,-57.88739,0,NULL,48817768256,762777629,11918400,14.48),(162433,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162433,36.14,0.25,169,75855,74.4,NULL,NULL,'GIN 702',NULL,'2013AJ....146...86T',2013,1,0.52,NULL,'G',0.000027,NULL,'15.7g',0.43,'E/S0','Group member',NULL,NULL,NULL,1,351.4064583,14.574,0.105,NULL,51632965373,806765083,12605704,15.7),(162434,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162434,36.35,0.09,186,75855,70,NULL,NULL,'GIN 702',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162435,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162435,36.44,0.09,194,75855,70,NULL,NULL,'GIN 702',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162436,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162436,38.11,0.33,419,75856,70,NULL,NULL,'SDSS J232538.28-094927.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,351.4095,-9.82428,0.069,NULL,49599000037,774984375,12109130,18.6),(162437,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162437,36.09,0.33,165,75857,NULL,NULL,'Malmquist cor.','IC 1488',NULL,'2009ApJS..182..474S',2009,1,1.07,NULL,'G',0.000033,NULL,'15.5g',0.21,'Sb',NULL,NULL,NULL,NULL,1,351.410625,15.35442,0.073,NULL,52519994695,820624917,12822264,15.5),(162438,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162438,36.16,0.4,171,75857,NULL,NULL,'mean','IC 1488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162439,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162439,36.24,0.49,177,75857,75,NULL,'IR','IC 1488',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162440,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162440,36.4,0.28,190,75857,NULL,NULL,NULL,'IC 1488',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162441,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162441,36.44,0.2,194,75857,74.4,NULL,NULL,'IC 1488',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162442,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162442,36.46,0.47,196,75857,NULL,NULL,'H','IC 1488',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162443,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162443,35.93,0.2,153,75858,74.4,NULL,NULL,'CGCG 406-105',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',NULL,NULL,'15.6',0.3,'Sa','Isolated galaxy',NULL,NULL,NULL,1,351.419375,6.75903,0.181,NULL,51805523392,809461303,12647832,15.6),(162444,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162444,37.48,0.46,314,75859,70,NULL,NULL,'2MASX J23254100-1038199',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000176,NULL,'17.0g',0.29,NULL,NULL,NULL,NULL,NULL,1,351.42075,-10.63881,0.074,NULL,49600394483,775006163,12109471,17),(162445,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162445,34.85,0.49,93.5,75860,75,NULL,'IR','ESO 536- G 004',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000033,NULL,'15.96',0.4,'S...',NULL,NULL,NULL,NULL,1,351.4412917,-26.56431,0.018,NULL,50019738698,781558417,12211850,15.96),(162446,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162446,34.9,0.41,95.3,75860,NULL,NULL,NULL,'ESO 536- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162447,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162447,34.94,0.2,97.3,75860,74.4,NULL,NULL,'ESO 536- G 004',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162448,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162448,35.31,0.34,115,75860,NULL,NULL,'Malmquist cor.','ESO 536- G 004',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162449,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162449,36.44,0.09,194,75861,70,NULL,NULL,'2MASX J23254672+1533552',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000174,NULL,'15.9g',0.46,'E0',NULL,NULL,NULL,NULL,1,351.4447917,15.56533,0.073,NULL,52519678970,820619983,12822187,15.9),(162450,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162450,32.84,0.85,37,75862,95,NULL,'Weighted Mean','NGC 7660',NULL,'1984ApJS...56...91D',1984,1,1.4,NULL,'G',0.000057,NULL,'13.76',1.1,'E','Group member',NULL,NULL,NULL,1,351.45275,27.02989,0.177,NULL,51985910260,812279847,12691872,13.76),(162451,'Faber-Jackson','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162451,32.84,0.85,37,75862,95,NULL,'de Vaucouleurs','NGC 7660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162452,'Tertiary','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162452,33.88,0.5,59.7,75862,95,NULL,NULL,'NGC 7660',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162453,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162453,34.5,0.4,79.3,75862,NULL,NULL,'mean','NGC 7660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162454,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162454,34.68,0.45,86.2,75862,NULL,NULL,'K','NGC 7660',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162455,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13867',NULL,162455,40.34,0.18,1170,75863,70,NULL,'SN photometric redshift distance, z photo =0.323 +/- 0.034','SDSS-II SN 13867',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,351.454833,0.02936,0.121,NULL,51574222006,805847218,12591362,NULL),(162456,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13867','R',162456,40.99,0.24,1170,75863,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13867',0.347239,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162457,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13867','R',162457,41.16,0.31,1260,75863,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13867',0.347239,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162458,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 01260','RN',162458,42.21,0.18,1660,75864,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01260',0.664633,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162459,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162459,36.94,0.46,244,75865,70,NULL,NULL,'2MASX J23255737-1055229',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000151,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,351.4890417,-10.92303,0.099,NULL,49600621004,775009703,12109526,17.7),(162460,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162460,38.39,0.46,476,75866,70,NULL,NULL,'2MASX J23255837-0104252',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000085,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.493125,-1.07367,0.141,NULL,49411540975,772055327,12063364,18.2),(162461,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162461,34.8,NULL,91.3,75867,NULL,NULL,NULL,'FGC 2500',NULL,'2000BSAO...50....5K',2000,1,1.1,NULL,'G',0.000014,NULL,'16.07',0.15,'Scd',NULL,NULL,NULL,NULL,1,351.4985417,22.99953,0.125,NULL,52508220351,820440942,12819389,16.07),(162462,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06921',NULL,162462,36.6,1.28,209,75868,70,NULL,'SN photometric redshift distance, z photo =0.050 +/- 0.042','SDSS-II SN 06921',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.1g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,351.5025,1.01625,0.101,NULL,51574688006,805854500,12591476,21.1),(162463,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06921','R',162463,38.73,0.42,487,75868,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 06921',0.142113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162464,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 06921','R',162464,39.46,0.31,683,75868,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 06921',0.142113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162465,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162465,35.97,0.2,156,75869,74.4,NULL,NULL,'UGC 12596',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000113,NULL,'15.07',0.5,'Sc',NULL,NULL,NULL,NULL,1,351.510875,13.20178,0.065,NULL,51639255290,806863363,12607240,15.07),(162466,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162466,36.19,0.4,173,75869,NULL,NULL,'mean','UGC 12596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162467,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162467,36.28,0.47,180,75869,NULL,NULL,'H','UGC 12596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162468,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162468,36.38,0.45,189,75869,NULL,NULL,'K','UGC 12596',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162469,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162469,36.98,0.46,248,75870,70,NULL,NULL,'2MASX J23260285-0859118',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.00015,NULL,'16.3g',0.36,'S0',NULL,NULL,NULL,NULL,1,351.51175,-8.98653,0.093,NULL,49598942531,774983477,12109116,16.3),(162470,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162470,36.41,0.46,191,75871,70,NULL,NULL,'2MASX J23261129+1401482',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000196,NULL,'16.8g',0.28,NULL,'Group member',NULL,NULL,NULL,1,351.547,14.02997,0.109,NULL,51637304392,806832881,12606763,16.8),(162471,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411','R',162471,41.21,NULL,1120,75872,65,NULL,'MLCS17','ESSENCE k411 HOST',0.564,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.549041667,-8.83819,0.066,NULL,49598733283,774980207,12109065,NULL),(162472,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162472,41.67,0.3,1380,75872,74.2,NULL,'SALT 2','ESSENCE k411 HOST',0.564,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162473,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162473,42.36,0.24,1900,75872,65,NULL,'MLCS17','ESSENCE k411 HOST',0.564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162474,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162474,42.38,0.4,1910,75872,70,NULL,'SALT','ESSENCE k411 HOST',0.564,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162475,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162475,42.44,0.22,1970,75872,65,NULL,'MLCS31','ESSENCE k411 HOST',0.564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162476,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162476,42.56,0.55,2080,75872,65,NULL,'SALT2','ESSENCE k411 HOST',0.564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162477,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE k411',NULL,162477,42.58,0.37,2100,75872,65,NULL,'SALT','ESSENCE k411 HOST',0.564,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162478,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03850','RN',162478,43,0.28,2950,75873,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03850',0.346629,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162479,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03850','RN',162479,43.13,0.33,3140,75873,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03850',0.346629,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162480,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13830','R',162480,40.97,0.24,1170,75874,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006hm','SN 2006hm',0.33147,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,351.5617083,-0.38225,0.141,NULL,49422631349,772228614,12066072,NULL),(162481,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 13830','R',162481,40.97,0.18,1170,75874,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006hm','SN 2006hm',0.33147,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162482,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162482,35.08,0.5,104,75875,70,NULL,NULL,'CGCG 380-055',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000087,NULL,'15.6',0.5,NULL,NULL,NULL,NULL,NULL,1,351.568625,-1.974,0.141,NULL,49424224667,772253510,12066461,15.6),(162483,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162483,38.74,NULL,561,75876,65,NULL,'L = 10e57 photons/s','2B 920325',NULL,'1999ApJ...511L..79S',1999,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.566667,12.93972,0.069,NULL,51639454956,806866483,12607288,NULL),(162484,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162484,41.45,NULL,1950,75876,65,NULL,'L = 2 x 10e58 photons/s','2B 920325',NULL,'1999ApJ...511L..79S',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162485,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162485,37.29,0.46,287,75877,70,NULL,NULL,'2MASX J23261901-0923477',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,351.579125,-9.39667,0.078,NULL,49599654142,774994595,12109290,16.5),(162486,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162486,37.13,0.74,266,75878,70,NULL,NULL,'2MASX J23262004-2726139',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'15.6R',0.21,NULL,NULL,NULL,NULL,NULL,1,351.583583,-27.43722,0.028,NULL,50020697109,781573392,12212084,15.6),(162487,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162487,32.78,0.8,35.9,75879,75,NULL,'MAT, I','IC 5321',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000013,NULL,'14.02',0.8,'SBa pec?',NULL,NULL,NULL,NULL,1,351.5842917,-17.95639,0.062,NULL,50325280361,786332505,12286445,14.02),(162488,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162488,32.76,0.39,35.6,75879,73,NULL,'opt','IC 5321',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162489,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162489,32.82,0.32,36.7,75879,85,NULL,'I, raw','IC 5321',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162490,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162490,32.82,0.32,36.7,75879,85,NULL,'I, inv','IC 5321',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162491,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162491,32.84,0.43,37,75879,75,NULL,'3.6 micron, color + selection bias corrected','IC 5321',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162492,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162492,32.98,0.65,39.5,75879,NULL,NULL,'Malmquist cor.','IC 5321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162493,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162493,33,0.43,39.8,75879,75,NULL,'3.6 micron, color corrected','IC 5321',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162494,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162494,33.09,0.2,41.5,75879,74.4,NULL,NULL,'IC 5321',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162495,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162495,33.11,0.62,42,75879,NULL,NULL,NULL,'IC 5321',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162496,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162496,33.15,0.43,42.7,75879,75,NULL,'MAT, I, raw','IC 5321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162497,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162497,33.22,0.43,44,75879,75,NULL,'MAT, I, inv','IC 5321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162498,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162498,33.37,0.43,47.1,75879,75,NULL,'MAT, I, cor','IC 5321',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162499,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162499,37.87,0.46,375,75880,70,NULL,NULL,'2MASX J23262036+1457310',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000185,NULL,'16.8g',0.3,NULL,'Group member',NULL,NULL,NULL,1,351.585,14.95864,0.081,NULL,52519100899,820610951,12822046,16.8),(162500,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162500,38.11,0.46,418,75881,70,NULL,NULL,'2MASX J23262063+1446500',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000159,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,351.5859583,14.78058,0.089,NULL,52519083388,820610677,12822041,18.1),(162501,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162501,36.24,0.33,177,75882,70,NULL,NULL,'2MASX J23262185+1412300',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.00018,NULL,'15.9g',0.33,'E0','Group member',NULL,NULL,NULL,1,351.5909583,14.20836,0.105,NULL,51637314701,806833042,12606766,15.9),(162502,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162502,37.47,0.33,312,75883,70,NULL,NULL,'2MASX J23262367-0038348',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000069,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,351.5985,-0.64297,0.141,NULL,49422611778,772228309,12066067,17.8),(162503,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162503,37.52,0.27,320,75884,70,NULL,NULL,'2MASX J23262512-1051397',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000158,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,351.604917,-10.86114,0.071,NULL,49600636471,775009944,12109530,16.9),(162504,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162504,37.47,0.33,312,75885,70,NULL,NULL,'2MASX J23262600-0039198',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,351.608417,-0.65547,0.141,NULL,49422613707,772228339,12066067,17.5),(162505,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162505,37.71,0.46,348,75886,70,NULL,NULL,'SDSS J232626.18+134728.2',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000183,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,351.609125,13.79117,0.117,NULL,51638170944,806846421,12606975,17.5),(162506,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162506,37.77,0.33,358,75887,70,NULL,NULL,'2MASX J23262749-0951390',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000208,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,351.614541667,-9.86089,0.069,NULL,49599192890,774987388,12109177,16.7),(162507,'Brightest Stars','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162507,25.57,NULL,1.3,75888,NULL,NULL,'PHOTOGRAPHIC','UGCA 438',NULL,'1978MNRAS.183P..97L',1978,1,1.5,NULL,'G',0.000017,NULL,'13.8B',1.2,'IB(s)m pec:','Group member',NULL,NULL,NULL,1,351.614667,-32.38875,NULL,0,50182073030,784094891,12251482,13.8),(162508,'CMD','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162508,25,1,1,75888,NULL,NULL,NULL,'UGCA 438',NULL,'1987ESOC...27..281C',1987,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162509,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162509,26.59,0.12,2.08,75888,NULL,NULL,'I','UGCA 438',NULL,'1999AJ....118..817L',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162510,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162510,26.67,0.1,2.16,75888,NULL,NULL,NULL,'UGCA 438',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162511,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162511,26.69,0.08,2.18,75888,NULL,NULL,'I','UGCA 438',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162512,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162512,26.72,0.08,2.2,75888,74.4,NULL,NULL,'UGCA 438',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162513,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162513,26.72,0.09,2.21,75888,NULL,NULL,'I','UGCA 438',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162514,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162514,26.74,0.06,2.22,75888,NULL,NULL,NULL,'UGCA 438',NULL,'2006AJ....132..729T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162515,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162515,26.74,0.15,2.23,75888,NULL,NULL,NULL,'UGCA 438',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162516,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162516,24.97,0.8,1,75888,75,NULL,NULL,'UGCA 438',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162517,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162517,38.86,0.46,593,75889,70,NULL,NULL,'2MASX J23262758+0009392',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000103,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,351.6149583,0.16097,0.109,NULL,51587853096,806060204,12594690,18.1),(162518,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162518,38.07,0.46,411,75890,70,NULL,NULL,'2MASX J23263096-0904330',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000165,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,351.629167,-9.07597,0.055,NULL,49598915116,774983048,12109110,17.7),(162519,'Brightest Stars','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162519,26.15,NULL,1.7,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'1997A&AS..124..559K',1997,1,2.5,NULL,'G',NULL,NULL,'13.6',2,'dSph','Brightest group member',NULL,NULL,NULL,1,351.63225,50.67572,NULL,1,53207513838,831367403,12990115,13.6),(162520,'CMD','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162520,24.58,NULL,0.824,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162521,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162521,24.25,0.25,0.708,75891,NULL,NULL,'I','Andromeda VII',NULL,'1999AstL...25..332T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162522,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162522,24.4,0.2,0.76,75891,NULL,NULL,'I','Andromeda VII',NULL,'1999ApJ...511L.101G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162523,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162523,24.41,NULL,0.762,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162524,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162524,24.5,NULL,0.79,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'2003A&A...408..111K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162525,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162525,24.5,0.1,0.794,75891,NULL,NULL,'I','Andromeda VII',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162526,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162526,24.54,0.13,0.809,75891,NULL,NULL,NULL,'Andromeda VII',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162527,'TRGB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162527,24.7,0.1,0.871,75891,NULL,NULL,'I, M(I) = -4.0 mag','Andromeda VII',NULL,'1999IAUS..192..284G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162528,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162528,31.69,0.8,21.8,75892,75,NULL,NULL,'UGCA 439',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.000033,NULL,'15.46',0.2,'BCD',NULL,NULL,NULL,NULL,1,351.636583333,18.26661,0.077,NULL,52544544288,821008504,12828257,15.46),(162529,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162529,36.44,0.09,194,75893,70,NULL,NULL,'2MASX J23263320+1503030',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000164,NULL,'16.7g',0.32,NULL,'Group member',NULL,NULL,NULL,1,351.638291667,15.05094,0.081,NULL,52519952142,820624252,12822253,16.7),(162530,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162530,33.91,0.2,60.5,75894,74.4,NULL,NULL,'CGCG 497-019',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.46',0.5,'SB?',NULL,NULL,NULL,NULL,1,351.6472917,32.84625,0.285,NULL,52063817134,813497142,12710892,15.46),(162531,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162531,34.08,0.41,65.4,75894,NULL,NULL,NULL,'CGCG 497-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162532,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162532,34.41,0.35,76.4,75894,NULL,NULL,'Malmquist cor.','CGCG 497-019',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162533,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162533,36.44,0.09,194,75895,70,NULL,NULL,'2MASX J23263574+1448359',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000172,NULL,'16.8g',0.26,NULL,'Group member',NULL,NULL,NULL,1,351.6489583,14.81008,0.081,NULL,51633066223,806766659,12605729,16.8),(162534,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162534,37.77,0.33,358,75896,70,NULL,NULL,'SDSS J232637.84-095403.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000142,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.6577083,-9.901,0.078,NULL,49599063692,774985370,12109146,18.3),(162535,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162535,32.86,0.2,37.3,75897,74.4,NULL,NULL,'KUG 2324+114',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',NULL,NULL,'15.6',0.3,NULL,NULL,NULL,NULL,NULL,1,351.6595417,11.74239,0.105,NULL,51630010736,806718917,12604983,15.6),(162536,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19246','RN',162536,40.87,0.33,1120,75898,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19246',0.335217,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162537,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19246','RN',162537,41.15,0.42,1270,75898,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19246',0.335217,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162538,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19246','N',162538,41.05,0.3,1620,75898,70,NULL,'SALT 2','SDSS-II SN 19246',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162539,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 19246','N',162539,41.09,0.3,1650,75898,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19246',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162540,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162540,33.13,0.8,42.3,75899,75,NULL,'W91PP, r','NGC 7664',NULL,'1997ApJS..109..333W',1997,1,1.42,NULL,'G',0.000003,NULL,'13.42',0.76,'Sc:            Sbrst','Isolated galaxy',NULL,NULL,NULL,1,351.665667,25.08014,0.169,NULL,51988959269,812327488,12692617,13.42),(162541,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162541,33.13,0.8,42.3,75899,75,NULL,'CF, r','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162542,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162542,32.62,0.69,33.5,75899,100,NULL,'mid-IR','NGC 7664',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162543,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162543,33.18,0.38,43.2,75899,75,NULL,'W91PP, r, raw','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162544,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162544,33.33,0.4,46.3,75899,NULL,NULL,'mean','NGC 7664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162545,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162545,33.34,0.38,46.5,75899,75,NULL,'W91PP, r, inv','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162546,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162546,33.38,0.45,47.5,75899,NULL,NULL,'K','NGC 7664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162547,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162547,33.4,0.47,47.8,75899,NULL,NULL,'H','NGC 7664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162548,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162548,33.42,0.4,48.2,75899,NULL,NULL,NULL,'NGC 7664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162549,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162549,33.44,0.46,48.8,75899,NULL,NULL,'J','NGC 7664',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162550,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162550,33.46,0.38,49.2,75899,75,NULL,'W91PP, r, cor','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162551,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162551,33.46,0.2,49.2,75899,74.4,NULL,NULL,'NGC 7664',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162552,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162552,33.51,0.38,50.4,75899,NULL,NULL,'Malmquist cor.','NGC 7664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162553,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162553,33.57,0.38,51.9,75899,75,NULL,'CF, r, raw','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162554,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162554,33.75,0.38,56.2,75899,75,NULL,'CF, r, inv','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162555,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162555,33.81,0.38,57.9,75899,75,NULL,'CF, r, cor','NGC 7664',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162556,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162556,37.47,0.46,312,75900,70,NULL,NULL,'2MASX J23263988-0946590',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000152,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,351.666125,-9.78317,0.093,NULL,49599044377,774985068,12109141,17.3),(162557,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006fy',NULL,162557,37.68,0.05,344,75901,70,NULL,'Hubble residual 0.03 for z0.08268','SDSS J232640.14-005026.2',NULL,'2011ApJ...740...92G',2011,1,0.17,NULL,'G',0.00004,NULL,'18.0g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.66725,-0.84061,0.141,NULL,49422937672,772233401,12066146,18),(162558,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 12950','R',162558,37.94,0.17,358,75901,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fy','SDSS J232640.14-005026.2',0.08268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162559,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006fy',NULL,162559,37.86,0.06,373,75901,70,NULL,'SALT 2','SDSS J232640.14-005026.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162560,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2006fy',NULL,162560,37.86,0.06,373,75901,70,NULL,'SALT 2, Malmquist cor.','SDSS J232640.14-005026.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162561,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 12950','R',162561,38.12,0.04,389,75901,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fy','SDSS J232640.14-005026.2',0.08268,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162562,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162562,36.86,0.46,236,75902,70,NULL,NULL,'2MASX J23264286-1007590',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000153,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,351.678583,-10.13297,0.078,NULL,49601019320,775015926,12109623,17.1),(162563,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162563,36.92,0.46,242,75903,70,NULL,NULL,'2MASX J23264433-0906450',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000157,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,351.684583,-9.11264,0.055,NULL,49598845829,774981966,12109093,17.2),(162564,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162564,35.35,0.83,118,75904,NULL,NULL,'Malmquist cor.','KUG 2324+263',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000005,NULL,'15.72',0.2,'S?',NULL,NULL,NULL,NULL,1,351.695083,26.60294,0.205,NULL,51987392797,812303012,12692234,15.72),(162565,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162565,35.69,0.71,138,75904,NULL,NULL,NULL,'KUG 2324+263',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162566,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162566,35.74,0.2,141,75904,74.4,NULL,NULL,'KUG 2324+263',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162567,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162567,38.42,0.46,484,75905,70,NULL,NULL,'SDSS J232647.00-010542.0',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000084,NULL,'18.7g',0.11,NULL,NULL,NULL,NULL,NULL,1,351.695875,-1.09503,0.141,NULL,49423019949,772234686,12066166,18.7),(162568,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162568,37.46,0.46,311,75906,70,NULL,NULL,'2MASX J23264963+1402425',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000158,NULL,'18.0g',0.18,NULL,'Group member',NULL,NULL,NULL,1,351.70675,14.04536,0.109,NULL,51638040087,806844376,12606943,18),(162569,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162569,38.01,0.46,400,75907,70,NULL,NULL,'2MASX J23265144-0939170',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.00017,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,351.71425,-9.65464,0.093,NULL,49599694403,774995225,12109300,17.1),(162570,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162570,34.43,0.45,76.9,75908,NULL,NULL,'Malmquist cor.','CGCG 406-109',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',NULL,NULL,'15.55',0.2,NULL,NULL,NULL,NULL,NULL,1,351.724333,8.78461,0.133,NULL,51796757830,809324341,12645692,15.55),(162571,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162571,34.46,0.2,78,75908,74.4,NULL,NULL,'CGCG 406-109',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162572,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162572,34.53,0.43,80.6,75908,NULL,NULL,NULL,'CGCG 406-109',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162573,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162573,34.74,0.49,88.5,75908,75,NULL,'IR','CGCG 406-109',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162574,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162574,29.57,0.8,8.2,75909,75,NULL,NULL,'ESO 347- G 017',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'14.69',0.36,'SB(s)m: sp','Pair member (points to parent)',NULL,NULL,NULL,1,351.7342083,-37.34692,NULL,NULL,49975372407,780865193,12201018,14.69),(162575,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162575,29.4,NULL,7.59,75909,NULL,NULL,NULL,'ESO 347- G 017',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162576,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm','R',162576,40.84,NULL,1050,75910,65,NULL,'SN g052, MLCS31','ESSENCE J232658.14-093719.4',0.4,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.74225,-9.62206,0.093,NULL,49599699682,774995307,12109301,NULL),(162577,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162577,40.93,0.25,1100,75910,74.2,NULL,'SALT 2','ESSENCE J232658.14-093719.4',0.4,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162578,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162578,41.56,0.2,1470,75910,65,NULL,'SN g052, MLCS2k2','ESSENCE J232658.14-093719.4',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162579,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162579,41.57,0.22,1470,75910,65,NULL,'SN g052, MLCS31','ESSENCE J232658.14-093719.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162580,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162580,41.59,0.23,1490,75910,70,NULL,'SN g052, SALT','ESSENCE J232658.14-093719.4',0.4,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162581,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162581,41.71,0.35,1570,75910,65,NULL,'SN g052, SALT2','ESSENCE J232658.14-093719.4',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162582,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162582,41.73,0.08,1580,75910,65,NULL,'SN g052, SALT','ESSENCE J232658.14-093719.4',0.4,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162583,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162583,41.74,0.16,1590,75910,65,NULL,'SN g052, MLCS2k2','ESSENCE J232658.14-093719.4',0.4,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162584,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162584,41.78,0.21,1620,75910,65,NULL,'SN g052, SALT','ESSENCE J232658.14-093719.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162585,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004fm',NULL,162585,41.85,0.29,1680,75910,65,NULL,'SN g052, SALT2','ESSENCE J232658.14-093719.4',0.4,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162586,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14545','R',162586,40.76,0.23,1110,75911,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14545',0.278,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.748166667,1.01714,0.085,NULL,51588456000,806069625,12594837,NULL),(162587,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 14545','R',162587,40.85,0.14,1160,75911,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14545',0.278,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162588,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162588,37.53,0.33,321,75912,70,NULL,NULL,'2MASX J23270131-1031189',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,351.755333,-10.52186,0.091,NULL,49600425626,775006650,12109478,16.6),(162589,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162589,39.18,0.22,571,75913,74.2,NULL,'SALT 2','ESSENCE J232701.71-092404.5',0.2,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.757125,-9.40125,0.078,NULL,49599685849,774995091,12109298,NULL),(162590,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162590,40.01,0.25,836,75913,65,NULL,'SN d086, SALT2','ESSENCE J232701.71-092404.5',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162591,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162591,40.03,0.31,845,75913,65,NULL,'SN d086, MLCS31','ESSENCE J232701.71-092404.5',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162592,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162592,40.08,0.28,863,75913,65,NULL,'SN d086, MLCS2k2','ESSENCE J232701.71-092404.5',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162593,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162593,40.08,0.28,865,75913,65,NULL,'SN d086, SALT2','ESSENCE J232701.71-092404.5',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162594,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162594,40.15,0.27,892,75913,65,NULL,'SN d086, MLCS17','ESSENCE J232701.71-092404.5',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162595,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162595,40.15,0.21,893,75913,65,NULL,'SN d086, MLCS2k2','ESSENCE J232701.71-092404.5',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162596,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162596,40.16,0.05,897,75913,70,NULL,'SN d086, SALT','ESSENCE J232701.71-092404.5',0.2,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162597,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2003ju',NULL,162597,40.42,0.02,1010,75913,65,NULL,'SN d086, SALT','ESSENCE J232701.71-092404.5',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162598,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162598,37.67,0.46,342,75914,70,NULL,NULL,'2MASX J23270300-0910459',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000163,NULL,'17.4g',0.18,NULL,NULL,NULL,NULL,NULL,1,351.7625417,-9.17953,0.055,NULL,49598888645,774982635,12109103,17.4),(162599,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162599,38.26,0.46,448,75915,70,NULL,NULL,'2MASX J23270319+0042567',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000057,NULL,'17.3g',0.23,'NLAGN',NULL,NULL,NULL,NULL,1,351.7632083,0.71578,0.105,NULL,51588719041,806073735,12594902,17.3),(162600,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162600,39.81,0.22,705,75916,74.2,NULL,'SALT 2','ESSENCE J232704.38-083845.1',0.3,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.76825,-8.64586,0.059,NULL,49654416455,775850257,12122660,NULL),(162601,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162601,40.29,0.35,879,75916,65,NULL,'SN k396, MLCS2k2','ESSENCE J232704.38-083845.1',0.3,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162602,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk','R',162602,40.47,NULL,955,75916,65,NULL,'SN k396, SALT','ESSENCE J232704.38-083845.1',0.3,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162603,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162603,40.55,0.21,991,75916,70,NULL,'SN k396, SALT','ESSENCE J232704.38-083845.1',0.3,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162604,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162604,40.68,0.18,1050,75916,65,NULL,'SN k396, SALT','ESSENCE J232704.38-083845.1',0.3,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162605,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SN 2004hk',NULL,162605,40.88,0.08,1160,75916,65,NULL,'SN k396, SALT','ESSENCE J232704.38-083845.1',0.3,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162606,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162606,37.53,0.33,321,75917,70,NULL,NULL,'2MASX J23270593-1033249',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000154,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,351.774583,-10.55686,0.091,NULL,49600455091,775007110,12109486,17.3),(162607,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162607,37.85,0.33,371,75918,70,NULL,NULL,'2MASX J23270699-0933179',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000162,NULL,'17.2g',0.27,NULL,NULL,NULL,NULL,NULL,1,351.7790417,-9.55494,0.093,NULL,49599740973,774995952,12109311,17.2),(162608,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162608,34.48,0.2,78.7,75919,74.4,NULL,NULL,'UGC 12601',NULL,'2013AJ....146...86T',2013,1,0.91,NULL,'G',0.000017,NULL,'15.8g',0.53,'SB(s)dm:','Group member',NULL,NULL,NULL,1,351.7925417,15.01725,0.077,NULL,52519898780,820623418,12822240,15.8),(162609,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162609,38.14,0.46,424,75920,70,NULL,NULL,'2MASX J23271071-0041579',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.00015,NULL,'17.87',0.22,NULL,NULL,NULL,NULL,'Flat-Spectrum Radio Source',1,351.794583,-0.69936,0.149,NULL,49422624602,772228509,12066070,17.87),(162610,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162610,36.76,0.46,225,75921,70,NULL,NULL,'2MASX J23271258+0012586',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000081,NULL,'16.9g',0.12,NULL,NULL,NULL,NULL,NULL,1,351.802583333,0.21636,0.097,NULL,51579493444,805929585,12592649,16.9),(162611,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162611,37.06,0.46,258,75922,70,NULL,NULL,'2MASX J23271418+1448586',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000181,NULL,'16.8g',0.26,NULL,'Group member',NULL,NULL,NULL,1,351.8090417,14.81628,0.093,NULL,51633071008,806766734,12605730,16.8),(162612,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162612,32.06,0.8,25.8,75923,75,NULL,'MAT, I','NGC 7661',NULL,'1997ApJS..109..333W',1997,1,1.8,NULL,'G',0.000018,NULL,'14.08',1.2,'SB(rs)cd',NULL,NULL,NULL,NULL,1,351.8095417,-65.27042,0,NULL,48732194128,761440533,11897508,14.08),(162613,'Tully est','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162613,31.88,0.8,23.8,75923,75,NULL,NULL,'NGC 7661',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162614,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162614,32.31,0.32,29,75923,85,NULL,'I, inv','NGC 7661',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162615,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162615,32.32,0.32,29.1,75923,85,NULL,'I, raw','NGC 7661',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162616,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162616,32.56,0.4,32.5,75923,NULL,NULL,NULL,'NGC 7661',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162617,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162617,32.56,0.4,32.5,75923,73,NULL,'opt','NGC 7661',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162618,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162618,32.74,0.43,35.3,75923,75,NULL,'MAT, I, raw','NGC 7661',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162619,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162619,32.78,0.43,35.9,75923,75,NULL,'MAT, I, inv','NGC 7661',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162620,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162620,32.97,0.43,39.3,75923,75,NULL,'MAT, I, cor','NGC 7661',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162621,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162621,38.16,0.33,429,75924,70,NULL,NULL,'2MASX J23271628-0957229',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000151,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,351.817917,-9.95644,0.087,NULL,49599076067,774985563,12109149,17.2),(162622,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162622,37.77,0.46,359,75925,70,NULL,NULL,'2MASX J23272230+0110106',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000065,NULL,'17.8g',0.23,NULL,NULL,NULL,NULL,NULL,1,351.843,1.16958,0.085,NULL,51588568930,806071389,12594865,17.8),(162623,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162623,37.5,0.46,316,75926,70,NULL,NULL,'2MASX J23272279-1013579',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000147,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,351.844958333,-10.23281,0.086,NULL,49600991959,775015499,12109617,17.6),(162624,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162624,31.25,0.4,17.8,75927,73,NULL,'opt','NGC 7667',NULL,'2011A&A...532A.104N',2011,1,NULL,'Nothing at NGC position. Often misidentified with UGC 12578.','Other',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.845083,-0.18631,0.109,NULL,49418359971,772161874,12065029,NULL),(162625,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162625,41.86,0.21,1670,75928,NULL,NULL,NULL,'GRB 020819B',0.41,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,351.85,6.26667,0.197,NULL,51805013480,809453335,12647708,NULL),(162626,'GRB','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162626,42.47,NULL,3120,75928,70,NULL,'Pseudo z = 1.52','GRB 020819B',NULL,'2004AIPC..727...37A',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162627,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162627,38.16,0.33,429,75929,70,NULL,NULL,'2MASX J23272494-1000349',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000187,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,351.853917,-10.00967,0.087,NULL,49599029547,774984836,12109138,18),(162628,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00860','RN',162628,41.94,0.27,1840,75930,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00860',0.328912,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162629,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 00860','RN',162629,42.57,0.29,2460,75930,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00860',0.328912,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162630,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162630,37.52,0.27,320,75931,70,NULL,NULL,'2MASX J23272926-1052347',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,351.871833333,-10.87639,0.085,NULL,49600592288,775009254,12109519,16.6),(162631,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162631,36.44,0.09,194,75932,70,NULL,NULL,'2MASX J23273129+1507305',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000201,NULL,'15.9g',0.43,'E0',NULL,NULL,NULL,NULL,1,351.8804583,15.12506,0.077,NULL,52519383716,820615370,12822115,15.9),(162632,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162632,33.38,0.2,47.4,75933,74.4,NULL,NULL,'NGC 7672',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000087,NULL,'14.70',0.9,'Sb             Sy2','in a pair',NULL,NULL,'Sy 2',1,351.881,12.38519,0.105,NULL,51639121431,806861272,12607207,14.7),(162633,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03881','R',162633,41.22,0.25,1320,75934,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 03881',0.327784,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.881625,-0.44181,0.161,NULL,49422759524,772230617,12066103,NULL),(162634,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03881','R',162634,41.41,0.21,1440,75934,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 03881',0.327784,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162635,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162635,35.97,0.49,156,75935,75,NULL,'IR','UGC 12603',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'16.5',0.3,'S?',NULL,NULL,NULL,NULL,1,351.901417,29.84728,0.281,NULL,52072059172,813625924,12712905,16.5),(162636,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162636,40.35,0.23,875,75936,74.2,NULL,'SALT 2','ESSENCE g097 HOST',0.343,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.904833,-9.58917,0.071,NULL,49599724172,774995690,12109307,NULL),(162637,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097','R',162637,40.85,NULL,1100,75936,65,NULL,'MLCS17','ESSENCE g097 HOST',0.343,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162638,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162638,41.14,0.2,1260,75936,70,NULL,'SALT','ESSENCE g097 HOST',0.343,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162639,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162639,41.15,0.24,1270,75936,65,NULL,'SALT2','ESSENCE g097 HOST',0.343,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162640,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162640,41.24,0.18,1320,75936,65,NULL,'SALT','ESSENCE g097 HOST',0.343,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162641,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162641,41.24,0.26,1320,75936,65,NULL,'SALT2','ESSENCE g097 HOST',0.343,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162642,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162642,41.41,0.28,1430,75936,65,NULL,'MLCS17','ESSENCE g097 HOST',0.343,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162643,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162643,41.44,0.23,1440,75936,65,NULL,'MLCS2k2','ESSENCE g097 HOST',0.343,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162644,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162644,41.5,0.3,1490,75936,65,NULL,'MLCS31','ESSENCE g097 HOST',0.343,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162645,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162645,41.55,0.1,1520,75936,65,NULL,'SALT','ESSENCE g097 HOST',0.343,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162646,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','ESSENCE g097',NULL,162646,41.56,0.29,1530,75936,65,NULL,'MLCS2k2','ESSENCE g097 HOST',0.343,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162647,'SNIa','2016-12-15 15:16:06','2016-12-16 11:21:23','1','PS1 SN PS10bjn','N',162647,40.94,0.16,1200,75937,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bjn HOST',0.2888,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162648,'IRAS','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162648,35.82,0.8,146,75938,75,NULL,'W91PP, r','UGC 12604',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',NULL,NULL,'15.30',0.6,'SBa',NULL,NULL,NULL,NULL,1,351.916083,22.759,0.113,NULL,52505086427,820391975,12818624,15.3),(162649,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162649,35.74,0.38,141,75938,75,NULL,'W91PP, r, raw','UGC 12604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162650,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162650,35.95,0.38,155,75938,75,NULL,'W91PP, r, cor','UGC 12604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162651,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162651,35.97,0.38,156,75938,75,NULL,'W91PP, r, inv','UGC 12604',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162652,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162652,37.45,0.33,309,75939,70,NULL,NULL,'2MASX J23273992-1026417',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.00015,NULL,'16.3g',0.34,NULL,NULL,NULL,NULL,NULL,1,351.9162917,-10.44483,0.091,NULL,49600885548,775013836,12109591,16.3),(162653,'Tully-Fisher','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,NULL,162653,35.48,0.2,125,75940,74.4,NULL,NULL,'KUG 2325+142',NULL,'2013AJ....146...86T',2013,1,0.65,NULL,'G',0.00009,NULL,'15.4g',0.41,'Sc',NULL,NULL,NULL,NULL,1,351.928583,14.54472,0.093,NULL,51633891386,806779552,12605930,15.4),(162654,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 03418','RN',162654,42.12,0.21,1740,75941,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03418',0.523583,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162655,'FP','2016-12-15 15:16:06','2016-12-16 11:21:23','1',NULL,'R',162655,37.85,0.33,371,75942,70,NULL,NULL,'SDSS J232745.68-092425.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00015,NULL,'18.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.940333,-9.40711,0.071,NULL,49599600464,774993757,12109277,18.4),(162656,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 20038','R',162656,39.7,0.18,779,75943,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2007pg','SDSS J232749.56+002728.4',0.118789,'2014arXiv1401.3317S',2014,1,0.23,NULL,'G',0.000064,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,351.9565417,0.45789,0.105,NULL,51587955861,806061810,12594715,18.3),(162657,'SNIa SDSS','2016-12-15 15:16:06','2016-12-16 11:21:23','1','SDSS-II SN 20038','R',162657,40.14,0.09,954,75943,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2007pg','SDSS J232749.56+002728.4',0.118789,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162658,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162658,37.9,0.33,381,75944,70,NULL,NULL,'2MASX J23275214+1414315',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000181,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,351.96725,14.24208,0.117,NULL,51637727227,806839487,12606866,17.2),(162659,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162659,31.49,0.8,19.9,75945,75,NULL,'MAT, I','ESO 240- G 004',NULL,'1997ApJS..109..333W',1997,1,1.55,NULL,'G',0.000033,NULL,'15.26',0.29,'Sd: sp',NULL,NULL,NULL,NULL,1,351.971333,-51.13214,0,NULL,48651405037,760178203,11877784,15.26),(162660,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162660,31.22,0.32,17.5,75945,85,NULL,'I, inv','ESO 240- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162661,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162661,31.29,0.32,18.1,75945,85,NULL,'I, raw','ESO 240- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162662,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162662,31.57,0.4,20.6,75945,NULL,NULL,NULL,'ESO 240- G 004',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162663,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162663,31.57,0.39,20.6,75945,73,NULL,'opt','ESO 240- G 004',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162664,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162664,31.69,0.43,21.8,75945,75,NULL,'MAT, I, inv','ESO 240- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162665,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162665,31.9,0.43,23.9,75945,75,NULL,'MAT, I, raw','ESO 240- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162666,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162666,32.11,0.43,26.4,75945,75,NULL,'MAT, I, cor','ESO 240- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162667,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162667,34.99,0.5,99.6,75946,70,NULL,NULL,'2MASX J23275315-1741591',NULL,'2014MNRAS.445.2677S',2014,1,0.75,NULL,'G',0.00015,NULL,'15.42',0.4,'E',NULL,NULL,NULL,NULL,1,351.971541667,-17.69992,0.055,NULL,50325111524,786329867,12286404,15.42),(162668,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162668,36.44,0.09,194,75947,70,NULL,NULL,'2MASX J23275317+1442395',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000205,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,351.971541667,14.711,0.093,NULL,51633926441,806780100,12605939,16.1),(162669,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162669,37.52,0.27,320,75948,70,NULL,NULL,'2MASX J23275377-1053197',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,351.9739583,-10.88883,0.085,NULL,49600536642,775008385,12109506,17.1),(162670,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162670,38.05,0.46,406,75949,70,NULL,NULL,'2MASX J23275556-0016058',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000088,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,351.981583333,-0.26819,0.109,NULL,49418580039,772165313,12065083,17.3),(162671,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2011hb',NULL,162671,35.34,0.07,117,75950,72,NULL,'M(H) = -18.317 mag','NGC 7674',NULL,'2014ApJ...784..105W',2013,1,1.1,'Called \'NGC 7675\'in MCG.','G',0.00003,NULL,'13.92',1,'SA(r)bc pec;HIISy2','in an interacting pair',NULL,NULL,'Sy 2',1,351.986333,8.77903,0.101,NULL,51796601506,809321898,12645654,13.92),(162672,'Ring Diameter','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162672,33.4,0.84,47,75950,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7674',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162673,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162673,33.9,NULL,60.3,75950,75,NULL,'CO','NGC 7674',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162674,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162674,34.34,NULL,73.9,75950,75,NULL,'HI','NGC 7674',NULL,'1994A&A...283...21S',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162675,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162675,36.44,0.09,194,75951,70,NULL,NULL,'2MASX J23275772+1459305',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000175,NULL,'16.1g',0.39,'S0^-',NULL,NULL,NULL,NULL,1,351.9904583,14.99167,0.077,NULL,51633524830,806773825,12605841,16.1),(162676,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162676,40.98,0.23,1120,75952,74.2,NULL,'SALT 2','ESSENCE J232758.22-085711.8',0.405,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.001,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,351.992583,-8.95328,0.061,NULL,49654353535,775849273,12122644,NULL),(162677,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv','R',162677,40.99,NULL,1120,75952,65,NULL,'SN d085, MLCS17','ESSENCE J232758.22-085711.8',0.405,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162678,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162678,41.62,0.26,1500,75952,70,NULL,'SN d085, SALT','ESSENCE J232758.22-085711.8',0.405,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162679,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162679,41.73,0.2,1580,75952,65,NULL,'SN d085, SALT2','ESSENCE J232758.22-085711.8',0.405,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162680,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162680,41.76,0.23,1600,75952,65,NULL,'SN d085, SALT','ESSENCE J232758.22-085711.8',0.405,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162681,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162681,41.85,0.22,1670,75952,65,NULL,'SN d085, SALT2','ESSENCE J232758.22-085711.8',0.405,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162682,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162682,41.92,0.22,1730,75952,65,NULL,'SN d085, MLCS31','ESSENCE J232758.22-085711.8',0.405,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162683,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162683,41.96,0.07,1750,75952,65,NULL,'SN d085, SALT','ESSENCE J232758.22-085711.8',0.405,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162684,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162684,41.95,0.18,1750,75952,65,NULL,'SN d085, MLCS17','ESSENCE J232758.22-085711.8',0.405,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162685,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162685,41.96,0.2,1750,75952,65,NULL,'SN d085, MLCS2k2','ESSENCE J232758.22-085711.8',0.405,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162686,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2003jv',NULL,162686,41.98,0.17,1770,75952,65,NULL,'SN d085, MLCS2k2','ESSENCE J232758.22-085711.8',0.405,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162687,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162687,34.07,0.8,65.1,75953,75,NULL,'W91PP, r','UGC 12609',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'15.34',0.6,'Sdm',NULL,NULL,NULL,NULL,1,352.003125,31.0145,0.265,NULL,52069569110,813587017,12712297,15.34),(162688,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162688,34.17,0.38,68.2,75953,75,NULL,'W91PP, r, raw','UGC 12609',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162689,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162689,34.17,0.38,68.3,75953,75,NULL,'W91PP, r, inv','UGC 12609',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162690,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162690,34.39,0.38,75.3,75953,75,NULL,'W91PP, r, cor','UGC 12609',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162691,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162691,34.24,0.4,70.4,75954,NULL,NULL,'mean','CGCG 497-023',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000007,NULL,'15.22',0.2,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.004333333,32.16258,0.293,NULL,52062706744,813479792,12710621,15.22),(162692,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162692,34.52,0.49,80.3,75954,75,NULL,'IR','CGCG 497-023',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162693,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162693,34.56,0.47,81.7,75954,NULL,NULL,'H','CGCG 497-023',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162694,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162694,34.67,0.2,85.9,75954,74.4,NULL,NULL,'CGCG 497-023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162695,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162695,34.86,0.38,93.8,75954,NULL,NULL,NULL,'CGCG 497-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162696,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162696,34.9,0.37,95.3,75954,NULL,NULL,'Malmquist cor.','CGCG 497-023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162697,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162697,36.12,0.2,167,75955,74.4,NULL,NULL,'CGCG 406-111',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',NULL,NULL,'15.55',0.3,'S?',NULL,NULL,NULL,NULL,1,352.004917,7.85886,0.173,NULL,51804638132,809447470,12647616,15.55),(162698,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162698,38.34,0.33,466,75956,70,NULL,NULL,'2MASX J23280183-0927424',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000152,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,352.007625,-9.46164,0.071,NULL,49599553745,774993027,12109266,17.6),(162699,'Ring Diameter','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162699,33.5,0.84,50,75957,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7677',NULL,'1981ApJS...45..541P',1981,1,1.6,NULL,'G',0.000003,NULL,'13.93',1,'SAB(r)bc:      Sbrst','Pair member, wide',NULL,NULL,'Starburst',1,352.0255,23.53139,0.153,NULL,51980594372,812196787,12690574,13.93),(162700,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162700,33.16,0.8,42.9,75957,75,NULL,'MAT, I','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162701,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162701,33.17,0.8,43.1,75957,75,NULL,'W91PP, r','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162702,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162702,32.67,0.69,34.2,75957,100,NULL,'mid-IR','NGC 7677',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162703,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162703,33.36,0.4,46.9,75957,NULL,NULL,'mean','NGC 7677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162704,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162704,33.36,0.38,47,75957,75,NULL,'W91PP, r, raw','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162705,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162705,33.44,0.38,48.7,75957,75,NULL,'W91PP, r, inv','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162706,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162706,33.44,0.2,48.8,75957,74.4,NULL,NULL,'NGC 7677',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162707,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162707,33.52,0.32,50.5,75957,85,NULL,'I, raw','NGC 7677',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162708,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162708,33.53,0.45,50.9,75957,NULL,NULL,'K','NGC 7677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162709,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162709,33.56,0.32,51.5,75957,85,NULL,'I, inv','NGC 7677',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162710,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162710,33.57,0.47,51.8,75957,NULL,NULL,'H','NGC 7677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162711,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162711,33.59,0.43,52.3,75957,75,NULL,'MAT, I, raw','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162712,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162712,33.6,0.38,52.6,75957,75,NULL,'W91PP, r, cor','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162713,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162713,33.64,0.46,53.4,75957,NULL,NULL,'J','NGC 7677',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162714,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162714,33.74,0.58,56,75957,NULL,NULL,NULL,'NGC 7677',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162715,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162715,33.79,0.43,57.4,75957,75,NULL,'MAT, I, inv','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162716,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162716,33.88,0.43,59.7,75957,75,NULL,'MAT, I, cor','NGC 7677',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162717,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162717,33.97,0.52,62.2,75957,NULL,NULL,'Malmquist cor.','NGC 7677',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162718,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 16259','R',162718,38.63,0.19,476,75958,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ol ','SDSS J232807.19+005122.9',0.12,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.029958333,0.85636,0.101,NULL,51588833076,806075516,12594929,NULL),(162719,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2006ol',NULL,162719,38.42,0.1,483,75958,70,NULL,'SALT 2','SDSS J232807.19+005122.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162720,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2006ol',NULL,162720,38.43,0.1,485,75958,70,NULL,'SALT 2, Malmquist cor.','SDSS J232807.19+005122.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162721,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 16259','R',162721,38.78,0.08,510,75958,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ol ','SDSS J232807.19+005122.9',0.12,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162722,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162722,36.34,0.81,186,75959,70,NULL,NULL,'2MASX J23280823-5319280',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.53',0.18,NULL,NULL,NULL,NULL,NULL,1,352.0342083,-53.32447,0,NULL,48641054503,760016476,11875257,16.53),(162723,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162723,37.9,0.33,381,75960,70,NULL,NULL,'SDSS J232812.23+141214.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000187,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,352.050958333,14.20408,0.117,NULL,51637752909,806839889,12606873,18.5),(162724,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162724,34.17,0.4,68.2,75961,NULL,NULL,'mean','UGC 12611',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000033,NULL,'15.47',0.2,'Sa',NULL,NULL,NULL,NULL,1,352.053625,27.68944,0.185,NULL,51984572295,812258942,12691545,15.47),(162725,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162725,34.3,0.47,72.5,75961,NULL,NULL,'H','UGC 12611',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162726,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162726,34.33,0.45,73.6,75961,NULL,NULL,'K','UGC 12611',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162727,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162727,34.4,0.49,76,75961,75,NULL,'IR','UGC 12611',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162728,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162728,34.47,0.46,78.5,75961,NULL,NULL,'J','UGC 12611',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162729,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162729,37.45,0.33,309,75962,70,NULL,NULL,'SDSS J232813.79-102410.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000151,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,352.0574583,-10.40292,0.091,NULL,49601776720,775027761,12109808,18.3),(162730,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162730,40.15,0.22,822,75963,74.2,NULL,'SALT 2','ESSENCE n278 HOST',0.304,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.073125,-9.38678,0.071,NULL,49599296830,774989012,12109203,NULL),(162731,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278','R',162731,40.43,NULL,935,75963,65,NULL,'SALT','ESSENCE n278 HOST',0.304,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162732,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162732,40.85,0.21,1130,75963,70,NULL,'SALT','ESSENCE n278 HOST',0.304,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162733,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162733,40.93,0.22,1180,75963,65,NULL,'SALT2','ESSENCE n278 HOST',0.304,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162734,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162734,40.99,0.19,1210,75963,65,NULL,'SALT','ESSENCE n278 HOST',0.304,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162735,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162735,41.07,0.23,1250,75963,65,NULL,'SALT2','ESSENCE n278 HOST',0.304,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162736,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162736,41.09,0.23,1270,75963,65,NULL,'MLCS17','ESSENCE n278 HOST',0.304,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162737,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162737,41.12,0.16,1280,75963,65,NULL,'MLCS2k2','ESSENCE n278 HOST',0.304,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162738,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162738,41.13,0.21,1290,75963,65,NULL,'MLCS31','ESSENCE n278 HOST',0.304,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162739,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162739,41.15,0.06,1300,75963,65,NULL,'SALT','ESSENCE n278 HOST',0.304,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162740,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','ESSENCE n278',NULL,162740,41.16,0.19,1310,75963,65,NULL,'MLCS2k2','ESSENCE n278 HOST',0.304,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162741,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162741,36.5,0.27,200,75964,70,NULL,NULL,'2MASX J23281806-0944343',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000154,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,352.0752917,-9.74311,0.086,NULL,49599395215,774990550,12109227,17.1),(162742,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162742,32.92,0.43,38.3,75965,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2325+073',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000123,NULL,'15.3',0.3,'Spiral',NULL,NULL,NULL,NULL,1,352.080083333,7.62375,0.173,NULL,51807688973,809495140,12648361,15.3),(162743,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162743,33.12,0.43,42.1,75965,75,NULL,'3.6 micron, color corrected','KUG 2325+073',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162744,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162744,33.27,0.2,45.1,75965,74.4,NULL,NULL,'KUG 2325+073',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162745,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162745,35.08,0.49,104,75966,75,NULL,'IR','UGC 12612',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'17.',0.12,'Sc',NULL,NULL,NULL,NULL,1,352.0837083,35.30208,0.345,NULL,51829973745,809843339,12653802,17),(162746,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162746,35.63,NULL,134,75966,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162747,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162747,35.66,NULL,135,75966,NULL,NULL,'Dipole + Quadrupole','UGC 12612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162748,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162748,35.67,NULL,136,75966,NULL,NULL,'Dipole','UGC 12612',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162749,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162749,36.5,0.27,200,75967,70,NULL,NULL,'2MASX J23282280-0945183',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000103,NULL,'16.4g',0.37,'HII?',NULL,NULL,NULL,NULL,1,352.094916667,-9.75508,0.086,NULL,49599394994,774990546,12109227,16.4),(162750,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162750,37.17,0.59,271,75968,70,NULL,NULL,'2MASX J23282359-5218111',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.99',0.3,NULL,NULL,NULL,NULL,NULL,1,352.0984583,-52.30308,0,NULL,48639832398,759997381,11874959,16.99),(162751,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162751,35.81,0.4,145,75969,NULL,NULL,'mean','MCG -01-59-024',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.00006,NULL,'15.00',0.8,'SABc           HII',NULL,NULL,NULL,NULL,1,352.1030417,-2.80028,0.133,NULL,49423656300,772244629,12066322,15),(162752,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162752,35.82,0.47,146,75969,NULL,NULL,'H','MCG -01-59-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162753,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162753,35.94,0.45,154,75969,NULL,NULL,'K','MCG -01-59-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162754,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162754,36.01,0.46,159,75969,NULL,NULL,'J','MCG -01-59-024',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162755,'FP','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162755,36.5,0.27,200,75970,70,NULL,NULL,'2MASXi J2328263-094024',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000155,NULL,'17.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,352.1100417,-9.67358,0.071,NULL,49599427677,774991057,12109235,17.6),(162756,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162756,39.34,0.22,615,75971,74.2,NULL,'SALT 2','SDSS J232826.90-083653.0',0.2,'2010ApJ...716..712A',2010,1,0.17,NULL,'G',NULL,NULL,'18.9g',0.1,NULL,NULL,NULL,NULL,NULL,1,352.112083,-8.61475,0.042,NULL,49654861377,775857209,12122768,18.9),(162757,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh','R',162757,39.97,NULL,822,75971,65,NULL,'SN g005, SALT2','SDSS J232826.90-083653.0',0.2,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162758,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162758,40.2,0.27,912,75971,65,NULL,'SN g005, SALT2','SDSS J232826.90-083653.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162759,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162759,40.23,0.26,928,75971,65,NULL,'SN g005, SALT2','SDSS J232826.90-083653.0',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162760,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162760,40.32,0.2,966,75971,70,NULL,'SN g005, SALT','SDSS J232826.90-083653.0',0.2,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162761,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162761,40.35,0.27,979,75971,65,NULL,'SN g005, MLCS31','SDSS J232826.90-083653.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162762,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162762,40.37,0.24,989,75971,65,NULL,'SN g005, MLCS2k2','SDSS J232826.90-083653.0',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162763,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162763,40.4,0.17,1000,75971,65,NULL,'SN g005, SALT','SDSS J232826.90-083653.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162764,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162764,40.46,0.17,1030,75971,65,NULL,'SN g005, MLCS2k2','SDSS J232826.90-083653.0',0.2,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162765,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162765,40.45,0.23,1030,75971,65,NULL,'SN g005, MLCS17','SDSS J232826.90-083653.0',0.2,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162766,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2004fh',NULL,162766,40.8,0.06,1210,75971,65,NULL,'SN g005, SALT','SDSS J232826.90-083653.0',0.2,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162767,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 03750','RN',162767,42.52,0.34,2490,75972,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03750',0.27989,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162768,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 03750','RN',162768,43.03,0.43,3150,75972,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03750',0.27989,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162769,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162769,32.68,0.26,34,75973,74.2,NULL,'SALT 2','NGC 7678',0.011639,'2010ApJ...716..712A',2010,1,2.17,'Position given in 1990PNAOJ...1..181T refers to the southern arm.','G',0.000017,NULL,'12.41',1.67,'SAB(rs)c;Sbrst Sy2','in a radial-velocity based grouping',NULL,NULL,'H II',1,352.11625,22.42119,0.113,NULL,52505081460,820391897,12818623,12.41),(162770,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162770,33.26,0.02,44.4,75973,72,NULL,'MLCS31','NGC 7678',0.011639,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162771,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162771,33.25,0.09,44.7,75973,74.4,NULL,NULL,'NGC 7678',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162772,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162772,33.33,0.25,45.9,75973,70,NULL,'SALT 2','NGC 7678',0.011639,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162773,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162773,33.39,0.22,47,75973,73.8,NULL,'SALT 2 (SNANA)','NGC 7678',0.0109,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162774,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162774,33.51,0.29,49.7,75973,65,NULL,'MLCS31','NGC 7678',0.011639,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162775,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162775,33.56,0.31,51,75973,65,NULL,'SALT2','NGC 7678',0.011639,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162776,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162776,33.57,0.29,51,75973,65,NULL,'MLCS17','NGC 7678',0.011639,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162777,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SN 2002dp',NULL,162777,34.2,0.03,68.4,75973,70,NULL,'SALT 2','NGC 7678',0.011639,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162778,'Sosies','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162778,32.74,0.39,35.3,75973,NULL,NULL,NULL,'NGC 7678',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162779,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162779,32.46,0.4,31,75973,75,NULL,'HOSTS SN 2002dp','NGC 7678',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162780,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162780,33.01,0.45,39.9,75973,NULL,NULL,'K','NGC 7678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162781,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162781,33.07,0.46,41.1,75973,NULL,NULL,'J','NGC 7678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162782,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162782,33.07,0.47,41.1,75973,NULL,NULL,'H','NGC 7678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162783,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162783,33.31,0.4,45.9,75973,NULL,NULL,'mean','NGC 7678',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162784,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 13444','RN',162784,41.86,0.29,1890,75974,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13444',0.243958,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162785,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:23','1','SDSS-II SN 13444','RN',162785,42.52,0.32,2560,75974,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13444',0.243958,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162786,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162786,34.19,0.4,68.7,75975,NULL,NULL,'mean','NGC 7680',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000073,NULL,'13.68',1.9,'S0-:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.14625,32.41572,0.281,NULL,52062831901,813481748,12710652,13.68),(162787,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162787,34.78,0.45,90.4,75975,NULL,NULL,'K','NGC 7680',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162788,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162788,26.1,0.6,1.66,75976,NULL,NULL,NULL,'PegDIG',NULL,'1982ApJ...254...38H',1982,1,5,'Not to be confused with the Pegasus Dwarf Spheroidal = Andromeda VI.','G',0.000001,NULL,'13.21',2.7,'dIrr/dSph','Group member',NULL,NULL,NULL,1,352.1510417,14.74292,0.093,1,51633938021,806780281,12605941,13.21),(162789,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162789,26.94,0.9,2.44,75976,NULL,NULL,'3, B, blue stars','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162790,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162790,26.96,0.58,2.47,75976,NULL,NULL,'V, 3, red stars','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162791,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162791,27.2,0.55,2.75,75976,NULL,NULL,'3, B, red stars','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162792,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162792,27.54,0.88,3.22,75976,NULL,NULL,'3, B, blue stars','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162793,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162793,27.57,0.35,3.27,75976,NULL,NULL,'3, B, red stars revised','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162794,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162794,27.66,0.36,3.4,75976,NULL,NULL,'V, 3, red stars revised','PegDIG',NULL,'1994MNRAS.271..530R',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162795,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162795,28.1,0.9,4.17,75976,NULL,NULL,'red stars','PegDIG',NULL,'1986AJ.....91..496S',1986,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162796,'Brightest Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162796,28.19,NULL,4.35,75976,NULL,NULL,'Photographic','PegDIG',NULL,'1982ApJ...256..339S',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162797,'Carbon Stars','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162797,26.6,0.5,2.09,75976,NULL,18.73,'LMC ZP','PegDIG',NULL,'1982ApJ...254...38H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162798,'Cepheids','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162798,24.92,0.2,0.964,75976,NULL,NULL,'3, R','PegDIG',NULL,'2006MmSAI..77..299G',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162799,'Cepheids','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162799,25.15,0.1,1.07,75976,NULL,NULL,'26, VI','PegDIG',NULL,'2009AJ....137.3619M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162800,'Cepheids','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162800,25.41,0.06,1.21,75976,74.4,NULL,NULL,'PegDIG',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162801,'Cepheids','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162801,26.22,0.2,1.75,75976,NULL,NULL,'10','PegDIG',NULL,'1990AJ....100.1151H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162802,'CMD','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162802,24.4,0.2,0.76,75976,NULL,NULL,'CMD','PegDIG',NULL,'1998AJ....115.1869G',1998,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162803,'PNLF','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162803,29,0.38,6.4,75976,NULL,NULL,NULL,'PegDIG',NULL,'1981AJ.....86..185J',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162804,'Red Clump','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162804,24.96,NULL,0.981,75976,NULL,NULL,'V, M RC(V) = +0.73 mag','PegDIG',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162805,'Red Clump','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162805,25.18,NULL,1.08,75976,NULL,NULL,'I, M RC(I) = -0.50 mag','PegDIG',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162806,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162806,24.4,NULL,0.76,75976,NULL,NULL,NULL,'PegDIG',NULL,'2000glg..book.....V',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162807,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162807,24.7,0.1,0.871,75976,NULL,NULL,NULL,'PegDIG',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162808,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162808,24.82,0.07,0.919,75976,NULL,NULL,NULL,'PegDIG',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162809,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,'R',162809,24.88,0.17,0.946,75976,NULL,NULL,NULL,'PegDIG',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162810,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:23','1',NULL,NULL,162810,24.9,0.1,0.955,75976,NULL,NULL,'I','PegDIG',NULL,'1994ApJ...437L..27A',1994,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162811,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162811,25.04,NULL,1.02,75976,NULL,NULL,'I, M TRGB(I) = -4.05 mag','PegDIG',NULL,'2010AJ....140.1038P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162812,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162812,25.13,0.11,1.06,75976,NULL,NULL,NULL,'PegDIG',NULL,'1995JKAS...28..169L',1995,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162813,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162813,25.41,0.06,1.21,75976,74.4,NULL,NULL,'PegDIG',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162814,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162814,25.6,NULL,1.32,75976,NULL,NULL,NULL,'PegDIG',NULL,'1982ApJ...254...38H',1982,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162815,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162815,25,0.4,1,75976,75,NULL,'B','PegDIG',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162816,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162816,40.76,0.3,1010,75977,74.2,NULL,'SALT 2','ESSENCE g142 HOST',0.404,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.157083,-8.75111,0.056,NULL,49655130497,775861414,12122834,NULL),(162817,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162817,41.52,0.4,1430,75977,65,NULL,'SALT2','ESSENCE g142 HOST',0.404,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162818,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162818,41.71,0.28,1570,75977,70,NULL,'SALT','ESSENCE g142 HOST',0.404,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162819,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162819,41.79,0.31,1620,75977,65,NULL,'SALT','ESSENCE g142 HOST',0.404,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162820,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162820,41.81,0.24,1640,75977,65,NULL,'MLCS2k2','ESSENCE g142 HOST',0.404,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162821,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162821,41.96,0.42,1760,75977,65,NULL,'MLCS2k2','ESSENCE g142 HOST',0.404,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162822,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142',NULL,162822,42.15,0.14,1920,75977,65,NULL,'SALT','ESSENCE g142 HOST',0.404,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162823,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g142','R',162823,42.29,NULL,2050,75977,65,NULL,'SALT','ESSENCE g142 HOST',0.404,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162824,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162824,42.7,0.34,2100,75978,65,NULL,'SALT2','ESSENCE m026 HOST',0.655,'2009ApJ...700.1097H',2009,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.1665417,-9.33056,0.072,NULL,49654672630,775854259,12122722,NULL),(162825,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162825,42.85,0.46,2240,75978,70,NULL,'SALT','ESSENCE m026 HOST',0.655,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162826,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162826,42.88,0.26,2280,75978,65,NULL,'MLCS17','ESSENCE m026 HOST',0.655,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162827,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162827,43.02,0.22,2430,75978,65,NULL,'MLCS2k2','ESSENCE m026 HOST',0.655,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162828,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162828,43.02,0.23,2430,75978,65,NULL,'MLCS31','ESSENCE m026 HOST',0.655,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162829,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m026',NULL,162829,43.18,0.17,2610,75978,65,NULL,'SALT','ESSENCE m026 HOST',0.655,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162830,'L(H{beta})-{sigma}','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162830,42.76,NULL,1332,75979,74.3,NULL,NULL,'DEEP2 32034223',0.636397,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',0.000002,NULL,'23.2R',NULL,NULL,NULL,NULL,NULL,NULL,1,352.1735,0.30556,0.101,NULL,51579663629,805932244,12592691,23.2),(162831,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162831,31.29,0.4,18.1,75980,75,NULL,'B','IC 5325',NULL,'1988NBGC.C....0000T',1988,1,2.8,NULL,'G',0.000023,NULL,'11.83',2.5,'SAB(rs)bc','X-ray-faint group member',NULL,NULL,NULL,1,352.1809583,-41.33347,NULL,NULL,50471018405,788609662,12322025,11.83),(162832,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162832,33.37,0.8,47.3,75981,75,NULL,'W91PP, r','UGC 12619',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.00002,NULL,'14.92',0.9,'SAB(s)dm',NULL,NULL,NULL,NULL,1,352.182583,22.23672,0.077,NULL,52504853630,820388337,12818567,14.92),(162833,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162833,33.5,0.38,50.1,75981,75,NULL,'W91PP, r, inv','UGC 12619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162834,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162834,33.57,0.38,51.7,75981,75,NULL,'W91PP, r, raw','UGC 12619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162835,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162835,33.77,0.38,56.8,75981,75,NULL,'W91PP, r, cor','UGC 12619',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162836,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13445','RN',162836,40.35,0.24,959,75982,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13445',0.223232,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162837,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13445','RN',162837,40.79,0.43,1170,75982,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13445',0.223232,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162838,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05542','RN',162838,40.78,0.17,1220,75983,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 05542',0.172912,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162839,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05542','RN',162839,41.04,0.26,1370,75983,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05542',0.172912,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162840,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162840,33.75,0.9,56.2,75984,NULL,NULL,NULL,'NGC 7679',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000013,NULL,'13.47',0.9,'SB0 pec:;HIISy1LIRG','Pair member, radial velocity confirmed',NULL,NULL,'Starburst',1,352.194583,3.51147,0.237,NULL,51764068954,808813577,12637712,13.47),(162841,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162841,33.79,0.2,57.3,75984,74.4,NULL,NULL,'NGC 7679',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162842,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162842,33.98,0.81,62.4,75984,NULL,NULL,'Malmquist cor.','NGC 7679',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162843,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162843,36.55,0.46,204,75985,70,NULL,NULL,'IV Zw 152',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000181,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,352.2029583,14.70356,0.089,NULL,51633752310,806777379,12605896,16.5),(162844,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08114','R',162844,41.27,0.22,1310,75986,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232852.03+001342.7',0.3718,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.0005,NULL,'20.6g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.216833,0.22853,0.101,NULL,51579551262,805930488,12592663,20.6),(162845,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08114','R',162845,41.52,0.3,1470,75986,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232852.03+001342.7',0.3718,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162846,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08114',NULL,162846,41.45,0.18,1950,75986,70,NULL,'SALT 2','SDSS J232852.03+001342.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162847,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08114',NULL,162847,41.5,0.18,2000,75986,70,NULL,'SALT 2, Malmquist cor.','SDSS J232852.03+001342.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162848,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162848,38.34,0.33,466,75987,70,NULL,NULL,'2MASX J23285235-0929097',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000174,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.218,-9.48617,0.072,NULL,49654685817,775854465,12122726,17.9),(162849,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162849,42.91,NULL,3830,75988,70,NULL,'Pseudo z = 3.22','GRB 010928',NULL,'2004AIPC..727...37A',2004,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.229167,30.65306,0.257,NULL,52069929942,813592655,12712385,NULL),(162850,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19601','RN',162850,44.08,0.32,4790,75989,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19601',0.363484,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162851,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162851,33.19,0.5,43.5,75990,70,NULL,NULL,'NGC 7676',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000093,NULL,'12.49',0.9,'SA0-: pec',NULL,NULL,NULL,NULL,1,352.257167,-59.71667,0,NULL,48746077269,761657457,11900897,12.49),(162852,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162852,33.18,0.45,43.2,75990,NULL,NULL,'K','NGC 7676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162853,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162853,33.27,0.4,45.1,75990,NULL,NULL,'mean','NGC 7676',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162854,'BL Lac Luminosity','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162854,40.17,NULL,892,75991,NULL,NULL,NULL,'87GB 232632.6+172658',0.213,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',NULL,NULL,'16.8',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,352.2637917,17.72514,0.101,NULL,52536128114,820877001,12826203,16.8),(162855,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20492','RN',162855,39.42,0.98,699,75992,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 20492',0.095996,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162856,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162856,34.17,0.8,68.3,75993,75,NULL,'W91PP, r','UGC 12625',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'15.02',0.2,'Sb',NULL,NULL,NULL,NULL,1,352.279375,29.77508,0.249,NULL,52068424126,813569126,12712017,15.02),(162857,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162857,34.26,0.47,71,75993,NULL,NULL,'H','UGC 12625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162858,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162858,34.27,0.4,71.5,75993,NULL,NULL,'mean','UGC 12625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162859,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162859,34.32,0.46,73,75993,NULL,NULL,'J','UGC 12625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162860,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162860,34.39,0.45,75.7,75993,NULL,NULL,'K','UGC 12625',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162861,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162861,34.64,0.49,84.6,75993,75,NULL,'IR','UGC 12625',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162862,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162862,34.74,0.38,88.6,75993,75,NULL,'W91PP, r, raw','UGC 12625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162863,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162863,34.97,0.38,98.6,75993,75,NULL,'W91PP, r, cor','UGC 12625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162864,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162864,34.97,0.2,98.6,75993,74.4,NULL,NULL,'UGC 12625',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162865,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162865,34.99,0.38,99.7,75993,75,NULL,'W91PP, r, inv','UGC 12625',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162866,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162866,35.01,0.34,101,75993,NULL,NULL,'Malmquist cor.','UGC 12625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162867,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162867,35.05,0.33,103,75993,NULL,NULL,NULL,'UGC 12625',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162868,'L(H{beta})-{sigma}','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162868,43.53,NULL,1486,75994,74.3,NULL,NULL,'DEEP2 32039400',0.850681,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',0.000114,NULL,'23.4R',NULL,'AGN',NULL,NULL,NULL,NULL,1,352.284166667,0.34464,0.101,NULL,51580404306,805943817,12592872,23.4),(162869,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162869,36.54,0.71,204,75995,70,NULL,NULL,'2MASX J23290871-1908407',NULL,'2014MNRAS.445.2677S',2014,1,0.28,NULL,'G',0.00015,NULL,'16.34',0.26,NULL,NULL,NULL,NULL,NULL,1,352.286417,-19.14461,0.038,NULL,50327747536,786371055,12287047,16.34),(162870,'BL Lac Luminosity','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162870,39.44,NULL,772,75996,NULL,NULL,'Min. z = 0.2','1FGL J2329.2+3755',NULL,'2013A&A...559A..58M',2013,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.301,37.931,0.629,NULL,51868028285,810437941,12663092,NULL),(162871,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162871,35.13,0.8,106,75997,75,NULL,'W91PP, r','UGC 12626',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000008,NULL,'15.48',0.4,'S?',NULL,NULL,NULL,NULL,1,352.313125,26.37892,0.193,NULL,51986951213,812296112,12692126,15.48),(162872,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162872,35.18,0.4,109,75997,NULL,NULL,'mean','UGC 12626',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162873,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162873,35.46,0.47,124,75997,NULL,NULL,'H','UGC 12626',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162874,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162874,35.56,0.38,130,75997,75,NULL,'W91PP, r, raw','UGC 12626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162875,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162875,35.73,0.38,140,75997,75,NULL,'W91PP, r, cor','UGC 12626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162876,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162876,35.79,0.38,144,75997,75,NULL,'W91PP, r, inv','UGC 12626',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162877,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07365','R',162877,41.72,0.34,1580,75998,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J232916.13+003447.2',0.393925,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,'PHOT','20.7g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.31725,0.57981,0.101,NULL,51580365297,805943207,12592862,20.7),(162878,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07365','R',162878,41.9,0.26,1720,75998,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J232916.13+003447.2',0.393925,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162879,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07365',NULL,162879,42.01,0.25,2520,75998,70,NULL,'SALT 2','SDSS J232916.13+003447.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162880,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07365',NULL,162880,42.08,0.25,2610,75998,70,NULL,'SALT 2, Malmquist cor.','SDSS J232916.13+003447.2',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162881,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162881,36.8,0.64,230,75999,70,NULL,NULL,'2MASX J23291660-1233234',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.09',0.57,NULL,NULL,NULL,NULL,NULL,1,352.319125,-12.55656,0.053,NULL,49574071751,774594871,12103044,16.09),(162882,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162882,37.63,0.52,336,76000,70,NULL,NULL,'2MASX J23291671-3754449',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.55',0.35,NULL,NULL,NULL,NULL,NULL,1,352.319666667,-37.91242,NULL,NULL,49985849707,781028901,12203576,16.55),(162883,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162883,36.8,0.52,229,76001,70,NULL,NULL,'6dF J2329177-345930',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,352.324125,-34.99178,NULL,NULL,49971156688,780799323,12199989,14.6),(162884,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03852','RN',162884,40.67,0.28,1010,76002,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03852',0.348385,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162885,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03852','RN',162885,40.95,0.42,1150,76002,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03852',0.348385,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162886,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162886,32.9,0.2,38,76003,74.4,NULL,NULL,'UGC 12628',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.00003,NULL,'14.90',1.2,'SB(rs)c:',NULL,NULL,NULL,NULL,1,352.341875,3.38989,0.205,NULL,51583514034,805992406,12593631,14.9),(162887,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162887,33.15,0.61,42.6,76003,NULL,NULL,NULL,'UGC 12628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162888,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162888,33.51,0.51,50.3,76003,NULL,NULL,'Malmquist cor.','UGC 12628',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162889,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162889,38.26,0.46,450,76004,70,NULL,NULL,'SDSS J232924.48+140421.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000145,NULL,'18.9g',0.11,NULL,NULL,NULL,NULL,NULL,1,352.352041667,14.07261,0.105,NULL,51637690029,806838906,12606857,18.9),(162890,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19578','RN',162890,41.49,0.28,1550,76005,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 19578',0.283019,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162891,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19578','RN',162891,42.15,0.28,2100,76005,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 19578',0.283019,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162892,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421','R',162892,40.45,0.38,962,76006,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17421',0.278103,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',NULL,'PHOT','20.0g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.385625,0.67661,0.097,NULL,51580317053,805942453,12592850,20),(162893,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421',NULL,162893,39.98,0.51,989,76006,70,NULL,'SN photometric redshift distance, z photo =0.265 +/- 0.085','SDSS-II SN 17421',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162894,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421',NULL,162894,40.29,0.27,1140,76006,70,NULL,'SALT 2','SDSS-II SN 17421',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162895,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421',NULL,162895,40.31,0.27,1150,76006,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17421',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162896,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17421','R',162896,40.85,0.32,1160,76006,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17421',0.278103,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162897,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162897,36.89,0.46,239,76007,70,NULL,NULL,'2MASX J23293404-0858310',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000152,NULL,'17.0g',0.22,NULL,NULL,NULL,NULL,NULL,1,352.391916667,-8.97514,0.057,NULL,49655286044,775863844,12122872,17),(162898,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162898,35.05,0.4,102,76008,NULL,NULL,'mean','IC 5326',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.00003,NULL,'14.60',0.4,'Sb             HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,352.3965,-28.83117,0.035,NULL,50138911251,783420488,12240945,14.6),(162899,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162899,35.25,0.3,112,76008,NULL,NULL,NULL,'IC 5326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162900,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162900,35.28,0.47,114,76008,NULL,NULL,'H','IC 5326',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162901,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162901,35.29,0.2,114,76008,74.4,NULL,NULL,'IC 5326',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162902,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162902,35.41,0.28,121,76008,NULL,NULL,'Malmquist cor.','IC 5326',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162903,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162903,38.78,0.33,494,76009,74.2,NULL,'SALT 2','ESSENCE m032 HOST',0.155,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.39725,-9.97953,0.115,NULL,49599254508,774988351,12109192,NULL),(162904,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162904,39.46,0.09,675,76009,70,NULL,'SALT','ESSENCE m032 HOST',0.155,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162905,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162905,39.72,0.16,762,76009,65,NULL,'SALT','ESSENCE m032 HOST',0.155,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162906,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162906,39.77,0.79,778,76009,65,NULL,'SALT2','ESSENCE m032 HOST',0.155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162907,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162907,39.8,0.21,790,76009,65,NULL,'MLCS17','ESSENCE m032 HOST',0.155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162908,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162908,39.92,0.18,833,76009,65,NULL,'MLCS31','ESSENCE m032 HOST',0.155,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162909,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m032',NULL,162909,39.95,0.15,848,76009,65,NULL,'MLCS2k2','ESSENCE m032 HOST',0.155,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162910,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162910,37.97,0.46,393,76010,70,NULL,NULL,'2MASX J23294045-0052101',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000089,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,352.418625,-0.86939,0.129,NULL,49418735769,772167746,12065121,17.7),(162911,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162911,41.97,0.15,2480,76011,NULL,NULL,'Photo z Bayesian = 0.94 +/- 0.13','GRB 981226',NULL,'2005ApJ...631L..29C',2005,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'SAX/WFC',NULL,NULL,NULL,NULL,1,352.416667,-23.925,0.044,NULL,50021653646,781588338,12212317,NULL),(162912,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162912,42.16,0.06,2710,76011,NULL,NULL,'Photo z = 1.11 +/- 0.06','GRB 981226',NULL,'2005ApJ...631L..29C',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162913,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fi',NULL,162913,40.7,0.2,1090,76012,65,NULL,'ESSENCE g001, MLCS17','APMUKS(BJ) B232710.07-091108.8',0.265,'2009ApJ...700.1097H',2009,1,0.11,NULL,'G',NULL,NULL,'20.15',0.09,NULL,NULL,NULL,NULL,NULL,1,352.43875,-8.90997,0.057,NULL,49654992586,775859259,12122800,20.15),(162914,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fi',NULL,162914,40.83,0.25,1160,76012,65,NULL,'ESSENCE g001, SALT2','APMUKS(BJ) B232710.07-091108.8',0.265,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162915,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fi',NULL,162915,40.84,0.16,1170,76012,65,NULL,'ESSENCE g001, MLCS31','APMUKS(BJ) B232710.07-091108.8',0.265,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162916,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162916,38.12,0.33,420,76013,70,NULL,NULL,'2MASX J23294530+1348198',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,352.438833,13.80536,0.085,NULL,51639970561,806874540,12607414,17.4),(162917,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PS1 SN PS10bmb','N',162917,41.3,0.64,1340,76014,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bmb HOST',0.3588,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162918,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21557','R',162918,41.25,0.75,1250,76015,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21557',0.421165,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,352.449041667,-0.60286,0.129,NULL,49419278334,772176223,12065253,NULL),(162919,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21557','R',162919,41.51,0.44,1410,76015,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21557',0.421165,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162920,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21557',NULL,162920,41.1,0.44,1660,76015,70,NULL,'SN photometric redshift distance, z photo =0.505 +/- 0.168','SDSS-II SN 21557',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162921,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162921,37.6,0.46,331,76016,70,NULL,NULL,'SDSS J232950.39-095446.5',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.00015,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,352.46,-9.91294,0.115,NULL,49599281162,774988768,12109199,16.5),(162922,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162922,34.25,0.4,70.8,76017,NULL,NULL,'mean','CGCG 497-028',NULL,'2007A&A...465...71T',2007,1,0.8,NULL,'G',0.000033,NULL,'15.60',0.35,'Sb?',NULL,NULL,NULL,NULL,1,352.461208333,32.70272,0.297,NULL,52062234105,813472407,12710506,15.6),(162923,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162923,34.66,0.47,85.3,76017,NULL,NULL,'H','CGCG 497-028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162924,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162924,34.7,0.46,87.1,76017,NULL,NULL,'J','CGCG 497-028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162925,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162925,34.71,0.45,87.5,76017,NULL,NULL,'K','CGCG 497-028',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162926,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m043',NULL,162926,39.63,0.25,666,76018,74.2,NULL,'SALT 2','ESSENCE m043 HOST',0.266,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.465541667,-8.94614,0.057,NULL,49654958413,775858725,12122792,NULL),(162927,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m043',NULL,162927,40.82,0.34,1150,76018,65,NULL,'MLCS2k2','ESSENCE m043 HOST',0.266,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162928,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m043',NULL,162928,41.87,0.96,1870,76018,65,NULL,'SALT','ESSENCE m043 HOST',0.266,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162929,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162929,35.81,0.33,145,76019,70,NULL,NULL,'2MASX J23295270+1333596',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000155,NULL,'16.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.469708333,13.56644,0.077,NULL,51639886106,806873220,12607394,16.7),(162930,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162930,33.27,0.69,45.1,76020,100,NULL,'mid-IR','CGCG 497-029',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000033,NULL,'14.95',0.4,'S0?',NULL,NULL,NULL,NULL,1,352.472875,32.08517,0.281,NULL,52062053478,813469585,12710462,14.95),(162931,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162931,34.45,0.36,77.6,76021,NULL,NULL,NULL,'UGC 12629',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'15.11',0.2,'Sa',NULL,NULL,NULL,NULL,1,352.478833333,32.64969,0.297,NULL,52062231552,813472368,12710505,15.11),(162932,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162932,34.58,0.33,82.5,76021,NULL,NULL,'Malmquist cor.','UGC 12629',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162933,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162933,34.63,0.2,84.3,76021,74.4,NULL,NULL,'UGC 12629',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162934,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162934,41.22,4.56,1200,76022,65,NULL,'SALT','ESSENCE p425 HOST',0.458,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.484125,-8.57342,0.053,NULL,49654811583,775856430,12122756,NULL),(162935,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162935,42.27,0.41,1950,76022,65,NULL,'MLCS2k2','ESSENCE p425 HOST',0.458,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162936,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162936,42.43,0.32,2100,76022,65,NULL,'MLCS17','ESSENCE p425 HOST',0.458,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162937,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162937,42.56,0.44,2230,76022,65,NULL,'SALT2','ESSENCE p425 HOST',0.458,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162938,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE p425',NULL,162938,42.71,0.36,2390,76022,65,NULL,'MLCS31','ESSENCE p425 HOST',0.458,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162939,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162939,40.52,0.25,1000,76023,65,NULL,'MLCS2k2','SDSS J232958.25-085312.6',0.263156,'2009ApJS..185...32K',2009,1,0.16,NULL,'G',0.000152,NULL,'19.3g',0.09,'BrClG',NULL,NULL,NULL,NULL,1,352.49275,-8.88683,0.052,NULL,49655003444,775859428,12122803,19.3),(162940,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162940,40.55,0.32,1020,76023,65,NULL,'MLCS17','SDSS J232958.25-085312.6',0.263156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162941,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162941,40.76,0.26,1120,76023,65,NULL,'MLCS31','SDSS J232958.25-085312.6',0.263156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162942,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162942,40.77,0.2,1130,76023,70,NULL,'SALT','SDSS J232958.25-085312.6',0.263156,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162943,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162943,40.79,0.59,1140,76023,65,NULL,'SALT2','SDSS J232958.25-085312.6',0.263156,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162944,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326','R',162944,40.8,NULL,1150,76023,65,NULL,'MLCS17','SDSS J232958.25-085312.6',0.263156,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162945,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162945,40.81,0.24,1150,76023,65,NULL,'MLCS2k2','SDSS J232958.25-085312.6',0.263156,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162946,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162946,40.92,0.18,1210,76023,65,NULL,'SALT','SDSS J232958.25-085312.6',0.263156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162947,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162947,41.02,0.07,1260,76023,65,NULL,'SALT','SDSS J232958.25-085312.6',0.263156,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162948,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162948,41.03,0.3,1270,76023,74.2,NULL,'SALT 2','SDSS J232958.25-085312.6',0.263156,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162949,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE n326',NULL,162949,41.04,0.43,1280,76023,65,NULL,'SALT2','SDSS J232958.25-085312.6',0.263156,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162950,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162950,29.82,0.4,9.2,76024,75,NULL,'B','UGC 12632',NULL,'1988NBGC.C....0000T',1988,1,4.5,NULL,'G',0.00002,NULL,'12.78',3.7,'Sm:','in a triple',NULL,NULL,NULL,1,352.494458333,40.99022,0.505,NULL,55306210298,864159535,13502492,12.78),(162951,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162951,29.93,NULL,9.68,76024,NULL,NULL,NULL,'UGC 12632',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162952,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162952,35.41,0.8,121,76025,75,NULL,'W91PP, r','UGC 12631',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000007,NULL,'14.94',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.50475,27.08678,0.149,NULL,51987750417,812308600,12692321,14.94),(162953,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162953,35.41,0.8,121,76025,75,NULL,'HMCL, I','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162954,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162954,35.41,0.8,121,76025,75,NULL,'W91CL, r','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162955,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162955,35.42,0.8,121,76025,75,NULL,'CF, r','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162956,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162956,35.06,0.38,103,76025,75,NULL,'W91CL, r, raw','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162957,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162957,35.11,0.4,105,76025,75,NULL,'HMCL, I, raw','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162958,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162958,35.19,0.38,109,76025,75,NULL,'W91PP, r, raw','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162959,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162959,35.24,0.38,112,76025,75,NULL,'W91CL, r, inv','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162960,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162960,35.27,0.38,113,76025,75,NULL,'W91CL, r, cor','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162961,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162961,35.33,0.38,116,76025,75,NULL,'CF, r, raw','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162962,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162962,35.33,0.4,116,76025,75,NULL,'HMCL, I, inv','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162963,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162963,35.34,0.4,117,76025,75,NULL,'HMCL, I, cor','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162964,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162964,35.39,0.38,120,76025,75,NULL,'W91PP, r, cor','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162965,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162965,35.42,0.38,122,76025,75,NULL,'W91PP, r, inv','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162966,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162966,35.52,0.38,127,76025,75,NULL,'CF, r, cor','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162967,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162967,35.52,0.38,127,76025,75,NULL,'CF, r, inv','UGC 12631',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162968,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162968,35.52,0.43,127,76025,75,NULL,'3.6 micron, color corrected','UGC 12631',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162969,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162969,35.58,0.2,131,76025,74.4,NULL,NULL,'UGC 12631',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162970,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162970,35.6,0.4,132,76025,NULL,NULL,'mean','UGC 12631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162971,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162971,35.65,0.43,135,76025,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12631',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162972,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162972,35.69,0.07,138,76025,NULL,NULL,NULL,'UGC 12631',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162973,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162973,35.75,0.47,141,76025,NULL,NULL,'H','UGC 12631',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162974,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m022',NULL,162974,41.63,0.34,1710,76026,65,NULL,'MLCS2k2','ESSENCE m022 HOST',0.24,'2007ApJ...666..694W',2007,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.51125,-8.56017,0.053,NULL,49656666353,775885411,12123209,NULL),(162975,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE m022',NULL,162975,42.43,0.13,2470,76026,65,NULL,'SALT','ESSENCE m022 HOST',0.24,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162976,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162976,38,0.46,398,76027,70,NULL,NULL,'2MASX J23300549-1009037',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.22,NULL,NULL,NULL,NULL,NULL,1,352.5227917,-10.15114,0.115,NULL,49601336301,775020879,12109701,17.5),(162977,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162977,37.39,0.46,301,76028,70,NULL,NULL,'2MASX J23300547-0920467',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000136,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,352.522833,-9.34639,0.07,NULL,49654624615,775853509,12122711,17.6),(162978,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162978,33.17,0.5,43.1,76029,70,NULL,NULL,'ESO 148- G 017',NULL,'2014MNRAS.445.2677S',2014,1,2.2,NULL,'G',0.00007,NULL,'13.3',0.8,'E6',NULL,NULL,NULL,NULL,1,352.5277917,-59.46469,0,NULL,48744436315,761631817,11900497,13.3),(162979,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162979,34.39,0.2,75.5,76030,74.4,NULL,NULL,'UGC 12634',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000037,NULL,'15.50',0.4,'Scd:',NULL,NULL,NULL,NULL,1,352.52925,40.22489,0.501,NULL,51866917905,810420592,12662821,15.5),(162980,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162980,34.41,0.35,76,76030,NULL,NULL,NULL,'UGC 12634',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162981,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162981,34.5,0.33,79.4,76030,NULL,NULL,'Malmquist cor.','UGC 12634',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162982,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162982,34.85,0.49,93.4,76030,75,NULL,'IR','UGC 12634',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162983,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19309','RN',162983,43.71,0.24,3610,76031,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19309',0.526355,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162984,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162984,40.62,0.27,1000,76032,74.2,NULL,'SALT 2','SDSS J233009.61-093503.3',0.33,'2010ApJ...716..712A',2010,1,0.11,NULL,'G',0.01,NULL,'20.6g',0.06,NULL,NULL,NULL,NULL,NULL,1,352.540083333,-9.58428,0.069,NULL,49654779514,775855929,12122748,20.6),(162985,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja','R',162985,41.16,NULL,1280,76032,65,NULL,'SN b016, SALT','SDSS J233009.61-093503.3',0.33,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162986,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162986,41.35,0.41,1400,76032,65,NULL,'SN b016, MLCS2k2','SDSS J233009.61-093503.3',0.33,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162987,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162987,41.38,0.25,1420,76032,70,NULL,'SN b016, SALT','SDSS J233009.61-093503.3',0.33,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162988,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162988,41.47,0.27,1480,76032,65,NULL,'SN b016, SALT','SDSS J233009.61-093503.3',0.33,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162989,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2002ja',NULL,162989,41.88,0.17,1780,76032,65,NULL,'SN b016, SALT','SDSS J233009.61-093503.3',0.33,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162990,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162990,38.12,0.33,420,76033,70,NULL,NULL,'SDSS J233010.67+134518.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000146,NULL,'18.6g',0.12,NULL,NULL,NULL,NULL,NULL,1,352.5445,13.75519,0.085,NULL,51639905261,806873519,12607398,18.6),(162991,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162991,33.04,0.69,40.5,76034,100,NULL,'mid-IR','UGC 12633',NULL,'2013ApJ...771...88L',2013,1,1.39,NULL,'G',0.000017,NULL,'14.3g',0.81,'SABb           LLIRG','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.556875,15.76103,0.081,NULL,52517407442,820584491,12821632,14.3),(162992,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162992,33.69,0.07,54.8,76034,NULL,NULL,NULL,'UGC 12633',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162993,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162993,33.8,0.4,57.6,76034,NULL,NULL,'mean','UGC 12633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162994,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162994,34.18,0.45,68.4,76034,NULL,NULL,'K','UGC 12633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162995,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162995,34.26,0.47,71.1,76034,NULL,NULL,'H','UGC 12633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162996,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162996,34.39,0.46,75.4,76034,NULL,NULL,'J','UGC 12633',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162997,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,162997,34.63,0.2,84.3,76034,74.4,NULL,NULL,'UGC 12633',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(162998,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162998,36.98,0.46,249,76035,70,NULL,NULL,'2MASX J23301841+1441482',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000186,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,352.576833,14.69672,0.089,NULL,51635177666,806799651,12606244,17),(162999,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',162999,35.81,0.33,145,76036,70,NULL,NULL,'2MASX J23301966+1326572',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.00022,NULL,'15.1g',0.55,'E0',NULL,NULL,NULL,NULL,1,352.5819583,13.44914,0.085,NULL,51639564131,806868189,12607315,15.1),(163000,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn','R',163000,41.46,NULL,1220,76037,65,NULL,'SN g050, SALT','ESSENCE J233020.12-095830.7',0.605,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.583833,-9.97519,0.115,NULL,49599229788,774987965,12109186,NULL),(163001,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163001,41.48,0.26,1230,76037,74.2,NULL,'SALT 2','ESSENCE J233020.12-095830.7',0.605,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163002,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163002,42.2,0.23,1710,76037,65,NULL,'SN g050, SALT2','ESSENCE J233020.12-095830.7',0.605,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163003,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163003,42.23,0.3,1740,76037,70,NULL,'SN g050, SALT','ESSENCE J233020.12-095830.7',0.605,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163004,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163004,42.36,0.27,1850,76037,65,NULL,'SN g050, SALT','ESSENCE J233020.12-095830.7',0.605,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163005,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163005,42.42,0.26,1890,76037,65,NULL,'SN g050, MLCS2k2','ESSENCE J233020.12-095830.7',0.605,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163006,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163006,42.57,0.08,2030,76037,65,NULL,'SN g050, SALT','ESSENCE J233020.12-095830.7',0.605,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163007,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2004fn',NULL,163007,42.77,0.15,2230,76037,65,NULL,'SN g050, MLCS2k2','ESSENCE J233020.12-095830.7',0.605,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163008,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163008,31.21,0.43,17.5,76038,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12639',NULL,'2014MNRAS.444..527S',2014,1,1.5,NULL,'G',0.000033,NULL,'14.47',1.2,'SB(s)b',NULL,NULL,NULL,NULL,1,352.6125,30.22189,0.257,NULL,52071808774,813622012,12712843,14.47),(163009,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln','R',163009,41.84,NULL,1430,76039,65,NULL,'SN f231, MLCS31','ESSENCE J233027.15-083547.0',0.63,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',0.01,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.613125,-8.59639,0.053,NULL,49654850543,775857039,12122766,NULL),(163010,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163010,42.34,0.25,1800,76039,74.2,NULL,'SALT 2','ESSENCE J233027.15-083547.0',0.63,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163011,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163011,42.92,0.25,2350,76039,70,NULL,'SN f231, SALT','ESSENCE J233027.15-083547.0',0.63,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163012,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163012,42.95,0.19,2390,76039,65,NULL,'SN f231, MLCS17','ESSENCE J233027.15-083547.0',0.63,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163013,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163013,42.98,0.2,2420,76039,65,NULL,'SN f231, MLCS2k2','ESSENCE J233027.15-083547.0',0.63,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163014,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163014,43.03,0.16,2480,76039,65,NULL,'SN f231, MLCS31','ESSENCE J233027.15-083547.0',0.63,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163015,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163015,43.05,0.14,2490,76039,65,NULL,'SN f231, MLCS2k2','ESSENCE J233027.15-083547.0',0.63,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163016,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163016,43.09,0.29,2540,76039,65,NULL,'SN f231, SALT2','ESSENCE J233027.15-083547.0',0.63,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163017,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163017,43.11,0.22,2570,76039,65,NULL,'SN f231, SALT','ESSENCE J233027.15-083547.0',0.63,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163018,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163018,43.17,0.12,2640,76039,65,NULL,'SN f231, SALT','ESSENCE J233027.15-083547.0',0.63,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163019,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2003ln',NULL,163019,43.21,0.23,2680,76039,65,NULL,'SN f231, SALT2','ESSENCE J233027.15-083547.0',0.63,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163020,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163020,34.47,0.59,78.3,76040,NULL,NULL,NULL,'LCSB S2828O',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000018,NULL,'14.28',0.2,'Sc',NULL,NULL,NULL,NULL,1,352.624875,26.13208,0.109,NULL,51988519115,812320611,12692509,14.28),(163021,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163021,34.51,0.2,79.8,76040,74.4,NULL,NULL,'LCSB S2828O',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163022,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163022,34.69,0.53,86.6,76040,NULL,NULL,'Malmquist cor.','LCSB S2828O',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163023,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163023,34.42,0.4,76.5,76041,NULL,NULL,'mean','NGC 7685',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000023,NULL,'13.84',1.4,'SAB(s)c:',NULL,NULL,NULL,NULL,1,352.639583,3.90158,0.245,NULL,51583141651,805986588,12593540,13.84),(163024,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163024,34.63,0.47,84.5,76041,NULL,NULL,'H','NGC 7685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163025,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163025,34.73,0.45,88.2,76041,NULL,NULL,'K','NGC 7685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163026,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163026,34.76,0.46,89.5,76041,NULL,NULL,'J','NGC 7685',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163027,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05659','RN',163027,42.48,0.4,2100,76042,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05659',0.490901,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163028,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163028,44.19,0.34,3090,76043,65,NULL,NULL,'H-ZSNS J233035.80+001640.0',1.23,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.649167,0.27778,0.097,NULL,51579926866,805936357,12592755,NULL),(163029,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163029,44.19,0.45,3090,76043,65,NULL,'BATM','H-ZSNS J233035.80+001640.0',1.23,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163030,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163030,44.39,0.42,3390,76043,65,NULL,'Final','H-ZSNS J233035.80+001640.0',1.23,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163031,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163031,44.57,0.49,3680,76043,70,NULL,'SALT','H-ZSNS J233035.80+001640.0',1.23,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163032,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fv',NULL,163032,44.59,0.39,3710,76043,65,NULL,'MLCS','H-ZSNS J233035.80+001640.0',1.23,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163033,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163033,34.41,0.47,76.1,76044,70,NULL,NULL,'IC 1492',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.000073,NULL,'14.44',1.1,'SB0+?',NULL,NULL,NULL,NULL,1,352.650417,-3.03992,0.157,NULL,49415969952,772124530,12064445,14.44),(163034,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163034,33.39,0.2,47.6,76045,74.4,NULL,NULL,'KUG 2328+153',NULL,'2013AJ....146...86T',2013,1,0.73,NULL,'G',0.000117,NULL,'15.6g',0.46,'Spiral',NULL,NULL,NULL,NULL,1,352.657375,15.60519,0.081,NULL,51635607525,806806367,12606349,15.6),(163035,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163035,33.4,0.08,48,76045,NULL,NULL,NULL,'KUG 2328+153',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163036,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2000dz',NULL,163036,42.75,0.24,2370,76046,65,NULL,NULL,'H-ZSNS J233041.36+001842.7',0.5,'2004ApJ...607..665R',2004,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.672333,0.31186,0.097,NULL,51579925869,805936341,12592755,NULL),(163037,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240','R',163037,41.66,NULL,1270,76047,65,NULL,'MLCS31','ESSENCE g240 HOST',0.687,'2010arXiv1006.2112L',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,352.674291667,-8.56972,0.05,NULL,49654798420,775856225,12122753,NULL),(163038,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163038,42.29,0.29,1700,76047,74.2,NULL,'SALT 2','ESSENCE g240 HOST',0.687,'2010ApJ...716..712A',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163039,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163039,42.83,0.28,2180,76047,70,NULL,'SALT','ESSENCE g240 HOST',0.687,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163040,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163040,42.97,0.22,2330,76047,65,NULL,'MLCS17','ESSENCE g240 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163041,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163041,43.03,0.19,2390,76047,65,NULL,'MLCS31','ESSENCE g240 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163042,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163042,43.02,0.25,2390,76047,65,NULL,'SALT','ESSENCE g240 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163043,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163043,43.03,0.09,2400,76047,65,NULL,'SALT','ESSENCE g240 HOST',0.687,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163044,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163044,43.04,0.18,2400,76047,65,NULL,'MLCS2k2','ESSENCE g240 HOST',0.687,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163045,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163045,43.04,0.2,2400,76047,65,NULL,'MLCS2k2','ESSENCE g240 HOST',0.687,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163046,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163046,43.09,0.29,2460,76047,65,NULL,'SALT2','ESSENCE g240 HOST',0.687,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163047,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','ESSENCE g240',NULL,163047,43.17,0.29,2550,76047,65,NULL,'SALT2','ESSENCE g240 HOST',0.687,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163048,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782',NULL,163048,40.12,0.22,1060,76048,70,NULL,'SN photometric redshift distance, z photo =0.287 +/- 0.037','SDSS-II SN 15782',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,352.676167,-0.42803,0.153,NULL,49419144098,772174126,12065220,NULL),(163049,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782','R',163049,40.91,0.22,1160,76048,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15782',0.307469,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163050,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782','R',163050,40.93,0.3,1170,76048,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15782',0.307469,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163051,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782',NULL,163051,40.76,0.19,1420,76048,70,NULL,'SALT 2','SDSS-II SN 15782',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163052,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15782',NULL,163052,40.79,0.19,1440,76048,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15782',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163053,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163053,35.87,0.56,150,76049,70,NULL,NULL,'2MASX J23304330-1743435',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.11',0.19,NULL,NULL,NULL,NULL,NULL,1,352.680458333,-17.72872,0.028,NULL,50327152923,786361764,12286902,16.11),(163054,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163054,34.48,0.47,78.7,76050,NULL,NULL,'H','IC 1495',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.00003,NULL,'14.14',1,'SAB(r)b pec:   Sy2',NULL,NULL,NULL,'Sy 2',1,352.698917,-13.48544,0.061,NULL,49572819832,774575309,12102739,14.14),(163055,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163055,34.5,0.45,79.3,76050,NULL,NULL,'K','IC 1495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163056,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163056,34.57,0.4,82,76050,NULL,NULL,'mean','IC 1495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163057,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163057,34.59,0.46,82.9,76050,NULL,NULL,'J','IC 1495',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163058,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163058,38.5,0.46,502,76051,70,NULL,NULL,'SDSS J233052.30+133417.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000165,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,352.717958333,13.5715,0.085,NULL,51636869273,806826082,12606657,18.1),(163059,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163059,34.02,0.53,63.8,76052,70,NULL,NULL,'IC 1496',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000073,NULL,'14.52',1.3,'(R)SB(rs)0/a','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.7229583,-2.93431,0.157,NULL,49415740616,772120947,12064389,14.52),(163060,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163060,32.7,0.43,34.6,76053,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12641',NULL,'2014MNRAS.444..527S',2014,1,1.1,NULL,'G',0.000013,NULL,'15.42',0.2,'Sbc',NULL,NULL,NULL,NULL,1,352.7274583,20.25083,0.165,NULL,52542446726,820975730,12827745,15.42),(163061,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163061,32.75,0.43,35.5,76053,75,NULL,'3.6 micron, color corrected','UGC 12641',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163062,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163062,32.76,0.2,35.7,76053,74.4,NULL,NULL,'UGC 12641',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163063,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163063,32.98,0.52,39.5,76053,NULL,NULL,NULL,'UGC 12641',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163064,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163064,33.35,0.44,46.8,76053,NULL,NULL,'Malmquist cor.','UGC 12641',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163065,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163065,33.24,0.49,44.5,76054,75,NULL,'IR','UGC 12640',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000017,NULL,'15.68',0.13,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.736667,15.4905,0.081,NULL,51635798177,806809346,12606396,15.68),(163066,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163066,34.1,NULL,66.1,76054,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12640',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163067,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163067,34.13,NULL,67,76054,NULL,NULL,'Dipole + Quadrupole','UGC 12640',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163068,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163068,34.14,NULL,67.4,76054,NULL,NULL,'Dipole','UGC 12640',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163069,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07608','RN',163069,43.34,0.42,3360,76055,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 07608',0.387998,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163070,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07608','RN',163070,43.65,0.4,3860,76055,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 07608',0.387998,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163071,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163071,34.76,0.49,89.7,76056,75,NULL,'IR','CGCG 454-078',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.00008,NULL,'15.7',0.2,NULL,NULL,NULL,NULL,NULL,1,352.7415,17.48672,0.101,NULL,52534227985,820847312,12825739,15.7),(163072,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163072,38.41,0.46,480,76057,70,NULL,NULL,'2MASX J23305925+1439239',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000161,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.747,14.6565,0.093,NULL,51635248703,806800760,12606261,17.9),(163073,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163073,34.88,0.49,94.6,76058,70,NULL,NULL,'MCG -05-55-020',NULL,'2014MNRAS.445.2677S',2014,1,0.85,NULL,'G',0.00012,NULL,'15.02',0.52,'S0',NULL,NULL,NULL,NULL,1,352.7500417,-27.52506,0.016,NULL,50020959389,781577490,12212148,15.02),(163074,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163074,37.87,0.46,376,76059,70,NULL,NULL,'2MASX J23310221+0030503',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000083,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.759167,0.51392,0.097,NULL,51580277751,805941839,12592841,17.7),(163075,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163075,35.72,0.41,139,76060,NULL,NULL,NULL,'ESO 408- G 005',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.33',0.5,'Sb',NULL,NULL,NULL,NULL,1,352.7682083,-36.30878,NULL,NULL,49983026050,780984782,12202887,16.33),(163076,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163076,35.76,0.2,142,76060,74.4,NULL,NULL,'ESO 408- G 005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163077,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163077,35.76,0.4,142,76060,NULL,NULL,'Malmquist cor.','ESO 408- G 005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163078,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13832','RN',163078,41.99,0.16,1930,76061,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13832',0.29578,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163079,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13832','RN',163079,42.28,0.22,2210,76061,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13832',0.29578,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163080,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163080,35.06,0.49,103,76062,75,NULL,'IR','CGCG 454-081',NULL,'2011yCatp016004901K',2011,1,NULL,NULL,'G',0.00013,NULL,'15.7',NULL,NULL,NULL,NULL,NULL,NULL,1,352.785333,17.47822,0.101,NULL,52534401764,820850027,12825781,15.7),(163081,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07373','R',163081,40.95,0.22,1210,76063,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J233113.19+003516.9',0.2799,'2014arXiv1401.3317S',2014,1,0.08,NULL,'G',0.0005,NULL,'20.0g',0.07,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.805,0.58803,0.097,NULL,51580251582,805941430,12592834,20),(163082,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07373','R',163082,40.99,0.15,1230,76063,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J233113.19+003516.9',0.2799,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163083,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07373',NULL,163083,40.87,0.12,1490,76063,70,NULL,'SALT 2','SDSS J233113.19+003516.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163084,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07373',NULL,163084,40.89,0.12,1510,76063,70,NULL,'SALT 2, Malmquist cor.','SDSS J233113.19+003516.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163085,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00986','RN',163085,40.86,0.3,1160,76064,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 00986',0.280578,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163086,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00986','RN',163086,41.01,0.24,1240,76064,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 00986',0.280578,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163087,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163087,35.07,0.49,103,76065,75,NULL,'IR','UGC 12642',NULL,'2011yCatp016004901K',2011,1,1.36,NULL,'G',0.000017,NULL,'16.5',0.12,'Sd',NULL,NULL,NULL,NULL,1,352.834541667,9.20633,0.137,NULL,51798750200,809355471,12646179,16.5),(163088,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163088,35.32,NULL,116,76065,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163089,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163089,35.33,NULL,117,76065,NULL,NULL,'Dipole + Quadrupole','UGC 12642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163090,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163090,35.34,NULL,117,76065,NULL,NULL,'Dipole','UGC 12642',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163091,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163091,35.41,NULL,121,76065,NULL,NULL,NULL,'UGC 12642',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163092,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163092,36.98,0.46,249,76066,70,NULL,NULL,'2MASX J23312689+1446231',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000171,NULL,'17.0g',0.28,NULL,NULL,NULL,NULL,NULL,1,352.862083,14.773,0.093,NULL,51635279679,806801244,12606269,17),(163093,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163093,34.27,0.8,71.3,76067,75,NULL,'W91PP, r','UGC 12644',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000007,NULL,'15.26',0.7,'SBd',NULL,NULL,NULL,NULL,1,352.8657083,29.18883,0.245,NULL,52068327540,813567617,12711994,15.26),(163094,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163094,33.13,0.2,42.3,76067,74.4,NULL,NULL,'UGC 12644',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163095,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163095,33.28,0.38,45.3,76067,75,NULL,'W91PP, r, inv','UGC 12644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163096,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163096,33.35,0.38,46.7,76067,75,NULL,'W91PP, r, raw','UGC 12644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163097,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163097,33.59,0.6,52.2,76067,NULL,NULL,NULL,'UGC 12644',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163098,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163098,33.68,0.38,54.5,76067,75,NULL,'W91PP, r, cor','UGC 12644',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163099,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163099,34.01,0.49,63.3,76067,NULL,NULL,'Malmquist cor.','UGC 12644',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163100,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163100,34.13,0.8,66.9,76068,75,NULL,'W91PP, r','UGC 12645',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'15.03',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,352.87025,32.48172,0.281,NULL,52031533915,812992717,12703011,15.03),(163101,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163101,33.26,0.2,44.9,76068,74.4,NULL,NULL,'UGC 12645',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163102,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163102,33.34,0.54,46.6,76068,NULL,NULL,NULL,'UGC 12645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163103,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163103,33.46,0.38,49.2,76068,75,NULL,'W91PP, r, inv','UGC 12645',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163104,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163104,33.47,0.38,49.3,76068,75,NULL,'W91PP, r, raw','UGC 12645',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163105,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163105,33.49,0.51,49.8,76068,NULL,NULL,'Malmquist cor.','UGC 12645',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163106,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163106,33.85,0.38,58.8,76068,75,NULL,'W91PP, r, cor','UGC 12645',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163107,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163107,37.26,0.46,283,76069,70,NULL,NULL,'2MASX J23313301-0920491',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,352.887666667,-9.347,0.078,NULL,49656250112,775878908,12123107,17.7),(163108,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20493','RN',163108,41.05,0.17,1140,76070,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20493',0.419656,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163109,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20493','RN',163109,41.82,0.24,1630,76070,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20493',0.419656,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163110,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163110,36.69,0.46,217,76071,70,NULL,NULL,'2MASX J23313604+0106324',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',NULL,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,352.9000417,1.10886,0.105,NULL,51580026033,805937906,12592779,17.7),(163111,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20381','RN',163111,41.66,0.33,1680,76072,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20381',0.277748,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163112,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20381','RN',163112,42.5,0.31,2480,76072,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20381',0.277748,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163113,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163113,32.13,1.16,26.6,76073,NULL,NULL,NULL,'UGC 12646',NULL,'2009ApJS..182..474S',2009,1,1.9,NULL,'G',0.000023,NULL,'13.99',1.5,'SB(r)b         Sy2','Isolated galaxy',NULL,NULL,'Sy 2',1,352.91275,25.94533,0.109,NULL,51988446842,812319481,12692491,13.99),(163114,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163114,32.3,1.07,28.9,76073,NULL,NULL,'Malmquist cor.','UGC 12646',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163115,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163115,34.51,0.47,79.8,76073,NULL,NULL,'H','UGC 12646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163116,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163116,34.66,0.45,85.6,76073,NULL,NULL,'K','UGC 12646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163117,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163117,34.67,0.46,85.9,76073,NULL,NULL,'J','UGC 12646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163118,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163118,35.17,0.4,108,76073,NULL,NULL,'mean','UGC 12646',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163119,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306',NULL,163119,38.9,1.28,602,76074,70,NULL,'SN photometric redshift distance, z photo =0.152 +/- 0.144','SDSS-II SN 21306',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,352.92325,0.09142,0.133,NULL,51579720966,805933140,12592705,NULL),(163120,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306','R',163120,41.18,0.25,1280,76074,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21306',0.347123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163121,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306','R',163121,41.36,0.2,1390,76074,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 21306',0.347123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163122,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306',NULL,163122,41.05,0.15,1620,76074,70,NULL,'SALT 2','SDSS-II SN 21306',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163123,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21306',NULL,163123,41.1,0.15,1660,76074,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21306',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163124,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163124,34.46,0.2,78,76075,74.4,NULL,NULL,'2MASX J23314292+2552180',NULL,'2013AJ....146...86T',2013,1,0.56,NULL,'G',0.00004,NULL,'15.72',0.24,NULL,NULL,NULL,NULL,NULL,1,352.928833333,25.87172,0.109,NULL,51981077906,812204342,12690692,15.72),(163125,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163125,34.57,0.56,82.2,76075,NULL,NULL,NULL,'2MASX J23314292+2552180',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163126,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163126,34.79,0.51,90.7,76075,NULL,NULL,'Malmquist cor.','2MASX J23314292+2552180',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163127,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163127,36.07,0.46,163,76076,70,NULL,NULL,'2MASX J23314359+1409080',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00017,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,352.93175,14.15206,0.113,NULL,51636565834,806821341,12606583,16.6),(163128,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163128,38.17,0.46,431,76077,70,NULL,NULL,'2MASX J23314498-0049002',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00009,NULL,'17.9g',0.13,NULL,NULL,NULL,NULL,NULL,1,352.93725,-0.81681,0.125,NULL,49418677376,772166834,12065106,17.9),(163129,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16281','R',163129,39.63,0.2,712,76078,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006pd','SDSS J233146.12-004005.0',0.186515,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,NULL,'20.8g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,352.942167,-0.66806,0.121,NULL,49418994437,772171788,12065184,20.8),(163130,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2006pd',NULL,163130,39.43,0.08,769,76078,70,NULL,'SALT 2','SDSS J233146.12-004005.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163131,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2006pd',NULL,163131,39.44,0.08,773,76078,70,NULL,'SALT 2, Malmquist cor.','SDSS J233146.12-004005.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163132,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16281','R',163132,39.92,0.12,812,76078,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006pd','SDSS J233146.12-004005.0',0.186515,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163133,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03672','RN',163133,42.26,0.21,1790,76079,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03672',0.580843,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163134,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163134,37.88,0.46,376,76080,70,NULL,NULL,'2MASX J23315277+1534567',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000169,NULL,'17.1g',0.22,NULL,NULL,NULL,NULL,NULL,1,352.969917,15.58258,0.085,NULL,51635705220,806807894,12606373,17.1),(163135,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163135,39.85,0.2,729,76081,74.2,NULL,'SALT 2','H-ZSNS J233153.03+000932.3',0.28,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'22.3g',0.03,NULL,NULL,NULL,NULL,NULL,1,352.970875,0.15931,0.129,NULL,51580772423,805949569,12592962,22.3),(163136,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw','R',163136,40.31,NULL,903,76081,65,NULL,'SALT','H-ZSNS J233153.03+000932.3',0.28,'2010arXiv1006.2112L',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163137,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163137,40.67,0.21,1060,76081,70,NULL,'SALT','H-ZSNS J233153.03+000932.3',0.28,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163138,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163138,40.8,0.24,1130,76081,65,NULL,'dm15','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163139,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163139,40.82,0.2,1140,76081,65,NULL,'SALT','H-ZSNS J233153.03+000932.3',0.28,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163140,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163140,40.89,0.15,1180,76081,65,NULL,'delta m15','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163141,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163141,40.93,0.27,1200,76081,65,NULL,'Final','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163142,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163142,40.97,0.31,1220,76081,65,NULL,'MLCS','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163143,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163143,40.99,0.42,1230,76081,65,NULL,'BATM','H-ZSNS J233153.03+000932.3',0.28,'2003ApJ...594....1T',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163144,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 1999fw',NULL,163144,41,0.41,1240,76081,65,NULL,NULL,'H-ZSNS J233153.03+000932.3',0.28,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163145,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163145,34.07,0.49,65.1,76082,75,NULL,'IR','IC 1498',NULL,'2011yCatp016004901K',2011,1,1.8,NULL,'G',0.000043,NULL,'14.03',0.6,'(R\')SB(r)a:',NULL,NULL,NULL,NULL,1,352.9735417,-5.00697,0.117,NULL,49636181355,775565333,12118208,14.03),(163146,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163146,34.12,0.47,66.5,76082,NULL,NULL,'H','IC 1498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163147,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163147,34.13,0.45,67.1,76082,NULL,NULL,'K','IC 1498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163148,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163148,34.16,0.46,67.9,76082,NULL,NULL,'J','IC 1498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163149,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163149,34.2,0.4,69.2,76082,NULL,NULL,'mean','IC 1498',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163150,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163150,36.48,0.55,198,76083,70,NULL,NULL,'2MASX J23315827-4616521',NULL,'2014MNRAS.445.2677S',2014,1,0.17,NULL,'G',0.00015,NULL,'19.17',0.14,NULL,NULL,NULL,NULL,NULL,1,352.992958333,-46.28114,NULL,NULL,50477638275,788713098,12323642,19.17),(163151,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 18737','RN',163151,41.64,0.19,1790,76084,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18737',0.185607,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163152,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 18737','RN',163152,42.25,0.22,2380,76084,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18737',0.185607,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163153,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00861','RN',163153,43.04,0.24,3000,76085,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00861',0.352053,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163154,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00861','RN',163154,43.1,0.25,3090,76085,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00861',0.352053,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163155,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13868','RN',163155,41.48,0.18,1660,76086,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13868',0.187534,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163156,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13868','RN',163156,41.96,0.3,2080,76086,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13868',0.187534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163157,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163157,34.09,0.8,65.7,76087,75,NULL,'W91PP, r','UGC 12650',NULL,'1997ApJS..109..333W',1997,1,1.57,NULL,'G',0.000011,NULL,'15.40',0.22,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.010583,32.42244,0.281,NULL,52031564071,812993188,12703018,15.4),(163158,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163158,33.91,0.49,60.4,76087,75,NULL,'IR','UGC 12650',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163159,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163159,33.94,0.43,61.5,76087,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12650',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163160,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163160,34.02,0.43,63.6,76087,75,NULL,'3.6 micron, color corrected','UGC 12650',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163161,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163161,34.03,0.38,64.1,76087,75,NULL,'W91PP, r, raw','UGC 12650',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163162,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163162,34.05,NULL,64.5,76087,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163163,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163163,34.05,NULL,64.6,76087,NULL,NULL,'Dipole + Quadrupole','UGC 12650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163164,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163164,34.06,0.2,64.9,76087,74.4,NULL,NULL,'UGC 12650',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163165,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163165,34.06,0.36,65,76087,NULL,NULL,NULL,'UGC 12650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163166,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163166,34.07,NULL,65.1,76087,NULL,NULL,'Dipole','UGC 12650',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163167,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163167,34.1,0.38,65.9,76087,75,NULL,'W91PP, r, inv','UGC 12650',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163168,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163168,34.11,NULL,66.4,76087,NULL,NULL,NULL,'UGC 12650',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163169,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163169,34.25,0.38,70.9,76087,75,NULL,'W91PP, r, cor','UGC 12650',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163170,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163170,34.36,0.32,74.6,76087,NULL,NULL,'Malmquist cor.','UGC 12650',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163171,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07374',NULL,163171,40.46,0.13,1230,76088,70,NULL,'SN photometric redshift distance, z photo =0.345 +/- 0.026','SDSS-II SN 07374',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.01275,0.62028,0.121,NULL,51580908091,805951688,12592995,NULL),(163172,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07374',NULL,163172,41.43,0.19,1930,76088,70,NULL,'SALT 2','SDSS-II SN 07374',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163173,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07374',NULL,163173,41.59,0.19,2080,76088,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 07374',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163174,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15367','RN',163174,40.82,0.71,1230,76089,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 15367',0.186822,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163175,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163175,37.34,0.46,293,76090,70,NULL,NULL,'2MASX J23321713-1037012',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000183,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,353.071375,-10.61689,0.027,NULL,49598109745,774970464,12108913,17),(163176,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163176,37.53,0.46,320,76091,70,NULL,NULL,'SDSS J233223.12+010115.1',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000115,NULL,'18.3g',0.16,'NLAGN',NULL,NULL,NULL,'Sy 2',1,353.096375,1.02086,0.105,NULL,51580617012,805947140,12592924,18.3),(163177,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163177,37.19,0.46,274,76092,70,NULL,NULL,'SDSS J233224.31-085207.3',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000139,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,353.101333,-8.86872,0.064,NULL,49653501285,775835957,12122436,18),(163178,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163178,33.61,0.08,52.8,76093,NULL,NULL,NULL,'NGC 7691',NULL,'2009ApJS..182..474S',2009,1,1.67,NULL,'G',0.000003,NULL,'13.9g',1.25,'SAB(rs)bc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.10175,15.84783,0.085,NULL,51632230475,806753601,12605525,13.9),(163179,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163179,33.72,0.4,55.4,76093,NULL,NULL,'mean','NGC 7691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163180,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163180,34,0.47,63.2,76093,NULL,NULL,'H','NGC 7691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163181,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163181,34.04,0.45,64.2,76093,NULL,NULL,'K','NGC 7691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163182,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163182,34.04,0.46,64.4,76093,NULL,NULL,'J','NGC 7691',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163183,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163183,35.25,0.64,112,76094,70,NULL,NULL,'2MASX J23322513-1144134',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.13',0.46,NULL,NULL,NULL,NULL,NULL,1,353.104583,-11.737,0.08,NULL,49568791677,774512369,12101755,16.13),(163184,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01748','R',163184,41.25,0.27,1330,76095,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01748',0.339527,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,353.112167,-0.4825,0.113,NULL,49421196666,772206197,12065721,NULL),(163185,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01748','R',163185,41.48,0.38,1470,76095,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01748',0.339527,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163186,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163186,33.37,0.49,47.3,76096,75,NULL,'IR','UGC 12653',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000013,NULL,'14.87',0.5,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.124833333,14.81683,0.101,NULL,51635102333,806798473,12606226,14.87),(163187,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163187,36.66,0.46,215,76097,70,NULL,NULL,'2MASX J23323021-0029274',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000094,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,353.125833,-0.49083,0.113,NULL,49421193586,772206149,12065721,16.5),(163188,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163188,35.12,0.29,106,76098,NULL,NULL,NULL,'ESO 536- G 007',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000033,NULL,'15.02',0.5,'Sb',NULL,NULL,NULL,NULL,1,353.130667,-24.00519,0.029,NULL,50022177034,781596516,12212445,15.02),(163189,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163189,35.16,0.2,108,76098,74.4,NULL,NULL,'ESO 536- G 007',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163190,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163190,35.41,0.25,121,76098,NULL,NULL,'Malmquist cor.','ESO 536- G 007',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163191,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163191,35.76,0.48,142,76099,70,NULL,NULL,'UGC 12656',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.00015,NULL,'15.32',0.3,'Sc',NULL,NULL,NULL,NULL,1,353.1349583,-1.74081,0.113,NULL,49421787853,772215435,12065866,15.32),(163192,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14630','RN',163192,42.54,0.18,2380,76100,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14630',0.352058,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163193,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14630','RN',163193,42.85,0.16,2750,76100,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 14630',0.352058,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163194,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163194,36.09,0.64,166,76101,70,NULL,NULL,'2MASX J23324001-1626215',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.36',0.38,NULL,NULL,NULL,NULL,NULL,1,353.166625,-16.43928,0.009,NULL,50290638278,785791223,12277987,16.36),(163195,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163195,37.65,0.46,339,76102,70,NULL,NULL,'2MASX J23324005+1338199',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,353.166916667,13.63872,0.113,NULL,51636992004,806828000,12606687,18),(163196,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163196,36.76,0.46,225,76103,70,NULL,NULL,'2MASX J23324083-0033479',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000076,NULL,'16.7g',0.32,NULL,NULL,NULL,NULL,NULL,1,353.1702083,-0.56328,0.113,NULL,49421046497,772203851,12065685,16.7),(163197,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10714','RN',163197,38.03,1.09,381,76104,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10714',0.057598,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163198,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10714','RN',163198,38.85,5.78,557,76104,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10714',0.057598,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163199,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163199,36.8,0.07,218,76105,70,NULL,'SiFTO+SALT2, SN PTF10wof','PTF10wof',0.0514,'2012MNRAS.426.2359M',2012,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,353.174167,15.35881,0.101,NULL,51635858507,806810289,12606410,NULL),(163200,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163200,36.86,0.07,224,76105,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF10wof',0.0514,'2014MNRAS.438.1391P',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163201,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163201,36.85,0.02,234,76105,NULL,NULL,'J','PTF10wof',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163202,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163202,36.9,0.02,240,76105,72,NULL,'M(H) = -18.317 mag','PTF10wof',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163203,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PTF10wof',NULL,163203,36.93,0.03,243,76105,NULL,NULL,'H','PTF10wof',NULL,'2012MNRAS.425.1007B',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163204,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163204,33.93,0.49,61,76106,75,NULL,'IR','UGC 12659',NULL,'2011yCatp016004901K',2011,1,1.52,NULL,'G',0.00004,NULL,'15.50',0.15,'Sd             HII',NULL,NULL,NULL,NULL,1,353.183,-1.78339,0.113,NULL,49421966741,772218230,12065909,15.5),(163205,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163205,34.54,NULL,80.9,76106,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12659',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163206,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163206,34.55,NULL,81.4,76106,NULL,NULL,'Dipole + Quadrupole','UGC 12659',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163207,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163207,34.56,NULL,81.5,76106,NULL,NULL,'Dipole','UGC 12659',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163208,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163208,34.6,NULL,83.2,76106,NULL,NULL,NULL,'UGC 12659',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163209,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163209,33.42,0.63,48.4,76107,NULL,NULL,NULL,'UGC 12658',NULL,'2009ApJS..182..474S',2009,1,1.2,NULL,'G',0.00001,NULL,'16.0',0.5,'SB?',NULL,NULL,NULL,NULL,1,353.186583,31.11375,0.281,NULL,52037578482,813087163,12704486,16),(163210,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163210,33.78,0.54,57.1,76107,NULL,NULL,'Malmquist cor.','UGC 12658',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163211,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163211,35.81,0.58,145,76108,70,NULL,NULL,'2MASX J23324608-1934478',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'15.97',0.32,'S0',NULL,NULL,NULL,NULL,1,353.1920417,-19.58008,0.064,NULL,50325549950,786336717,12286511,15.97),(163212,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163212,48.06,1.61,11900,76109,NULL,NULL,NULL,'GRB 090812',2.452,'2010JCAP...08..020W',2010,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,353.202333333,-10.60486,0.027,NULL,49598102982,774970359,12108911,NULL),(163213,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163213,38.26,0.46,449,76110,70,NULL,NULL,'2MASX J23324894+1426055',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000164,NULL,'18.2g',0.15,NULL,NULL,NULL,NULL,NULL,1,353.203833333,14.43489,0.141,NULL,51634591555,806790493,12606101,18.2),(163214,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 02661','R',163214,40.83,0.22,1230,76111,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 02661',0.192911,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,353.2075,0.09722,0.129,NULL,51577943633,805905369,12592271,NULL),(163215,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 02661','R',163215,41.62,0.24,1770,76111,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 02661',0.192911,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163216,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03514','RN',163216,40.59,0.12,1040,76112,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03514',0.264211,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163217,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 03514','RN',163217,41.11,0.24,1320,76112,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03514',0.264211,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163218,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15916','RN',163218,41.38,0.37,1280,76113,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15916',0.466231,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163219,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15916','N',163219,41.2,0.31,1740,76113,70,NULL,'SALT 2','SDSS-II SN 15916',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163220,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15916','N',163220,41.31,0.31,1830,76113,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15916',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163221,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052',NULL,163221,40.17,0.21,1080,76114,70,NULL,'SN photometric redshift distance, z photo =0.295 +/- 0.037','SDSS-II SN 19052',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.2440417,0.56267,0.113,NULL,51580974036,805952719,12593011,NULL),(163222,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052','R',163222,40.99,0.31,1220,76114,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19052',0.294615,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163223,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052','R',163223,41.29,0.28,1400,76114,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19052',0.294615,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163224,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052',NULL,163224,40.82,0.22,1460,76114,70,NULL,'SALT 2','SDSS-II SN 19052',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163225,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19052',NULL,163225,40.85,0.22,1480,76114,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19052',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163226,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163226,31.4,0.8,19.1,76115,75,NULL,'MAT, I','NGC 7690',NULL,'1997ApJS..109..333W',1997,1,2.2,NULL,'G',0.000017,NULL,'13.0',0.9,'Sb             HII',NULL,NULL,NULL,NULL,1,353.260667,-51.69836,0,NULL,48652960498,760202507,11878164,13),(163227,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163227,31.07,0.8,16.4,76115,75,NULL,'B','NGC 7690',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163228,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163228,31.6,0.4,20.9,76115,NULL,NULL,'mean','NGC 7690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163229,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163229,31.65,0.4,21.4,76115,NULL,NULL,NULL,'NGC 7690',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163230,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163230,31.65,0.4,21.4,76115,73,NULL,'opt','NGC 7690',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163231,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163231,31.67,0.32,21.6,76115,85,NULL,'I, raw','NGC 7690',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163232,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163232,31.69,0.32,21.8,76115,85,NULL,'I, inv','NGC 7690',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163233,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163233,31.88,0.47,23.7,76115,NULL,NULL,'H','NGC 7690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163234,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163234,31.9,0.46,24,76115,NULL,NULL,'J','NGC 7690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163235,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163235,31.93,0.43,24.3,76115,75,NULL,'MAT, I, raw','NGC 7690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163236,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163236,31.94,0.45,24.4,76115,NULL,NULL,'K','NGC 7690',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163237,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163237,32.05,0.43,25.7,76115,75,NULL,'MAT, I, inv','NGC 7690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163238,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163238,32.15,0.43,26.9,76115,75,NULL,'MAT, I, cor','NGC 7690',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163239,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163239,37.63,0.46,335,76116,70,NULL,NULL,'2MASX J23330646-0914328',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000187,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,353.2769583,-9.24261,0.118,NULL,49655501437,775867209,12122925,17.9),(163240,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163240,33.66,0.2,54,76117,74.4,NULL,NULL,'KUG 2330+159',NULL,'2013AJ....146...86T',2013,1,0.75,NULL,'G',0.000017,NULL,'15.3',0.4,'Spiral',NULL,NULL,NULL,NULL,1,353.283875,16.20597,0.077,NULL,51632858026,806763406,12605678,15.3),(163241,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163241,33.9,0.42,60.3,76117,NULL,NULL,NULL,'KUG 2330+159',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163242,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163242,34.02,0.4,63.7,76117,NULL,NULL,'Malmquist cor.','KUG 2330+159',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163243,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163243,34.13,NULL,67,76118,NULL,NULL,'Dipole + Quadrupole + Octopole','IC 5329',NULL,'2010Ap&SS.325..163P',2010,1,2.02,'Position given in 1993AN....314...97K is incorrect.','G',0.000006,NULL,'15.42',0.24,'Sb','Pair member (points to parent)',NULL,NULL,NULL,1,353.2899583,21.23731,0.097,NULL,52540464264,820944754,12827261,15.42),(163244,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163244,34.14,NULL,67.2,76118,NULL,NULL,'Dipole + Quadrupole','IC 5329',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163245,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163245,34.14,NULL,67.2,76118,NULL,NULL,'Dipole','IC 5329',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163246,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163246,34.2,NULL,69.1,76118,NULL,NULL,NULL,'IC 5329',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163247,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163247,34.5,0.49,79.5,76118,75,NULL,'IR','IC 5329',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163248,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163248,34.51,0.2,79.8,76118,74.4,NULL,NULL,'IC 5329',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163249,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163249,34.61,0.51,83.6,76118,NULL,NULL,'Malmquist cor.','IC 5329',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163250,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163250,34.62,0.5,83.9,76118,NULL,NULL,NULL,'IC 5329',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163251,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PS1 SN PS10bjz','N',163251,41.07,0.14,1250,76119,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10bjz HOST',0.3088,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163252,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163252,35.91,0.61,152,76120,70,NULL,NULL,'2MASX J23331168-5259437',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'14.90',0.58,'S',NULL,NULL,NULL,NULL,1,353.2987083,-52.99553,0,NULL,48639091673,759985807,11874778,14.9),(163253,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163253,34.51,0.79,79.9,76121,NULL,NULL,NULL,'KUG 2330+253A',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000033,NULL,'15.55',0.3,'S?',NULL,NULL,NULL,NULL,1,353.3002917,25.65336,0.117,NULL,51998986992,812484171,12695065,15.55),(163254,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163254,34.55,0.2,81.3,76121,74.4,NULL,NULL,'KUG 2330+253A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163255,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163255,34.9,0.66,95.6,76121,NULL,NULL,'Malmquist cor.','KUG 2330+253A',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163256,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163256,37.56,0.14,325,76122,70,NULL,NULL,'2MASX J23331231+0056561',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000101,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,353.301333,0.94894,0.105,NULL,51581462354,805960349,12593130,16.6),(163257,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16940',NULL,163257,40.24,0.31,1120,76123,70,NULL,'SN photometric redshift distance, z photo =0.306 +/- 0.059','SDSS-II SN 16940',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.302166667,-0.41789,0.113,NULL,49421175646,772205869,12065716,NULL),(163258,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163258,30.71,0.43,13.8,76124,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7694',NULL,'2014MNRAS.444..527S',2014,1,1.6,NULL,'G',0.00001,NULL,'14.07',0.9,'Im pec:        HII',NULL,NULL,NULL,NULL,1,353.315708333,-2.70289,0.137,NULL,49422118682,772220604,12065946,14.07),(163259,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163259,30.77,0.43,14.3,76124,75,NULL,'3.6 micron, color corrected','NGC 7694',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163260,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163260,30.78,0.2,14.3,76124,74.4,NULL,NULL,'NGC 7694',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163261,'SBF','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163261,32.89,0.15,37.8,76125,NULL,NULL,'I','IC 5328',NULL,'2001ApJ...546..681T',2001,1,2.5,NULL,'G',0.000043,NULL,'12.34',1.5,'E','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,353.318583,-45.01597,NULL,NULL,50478835894,788731810,12323934,12.34),(163262,'SBF','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163262,32.89,0.15,37.8,76125,NULL,NULL,NULL,'IC 5328',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163263,'SBF','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163263,32.92,0.14,38.4,76125,74.4,NULL,NULL,'IC 5328',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163264,'SBF','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163264,32.93,0.15,38.6,76125,NULL,NULL,'Malmquist cor.','IC 5328',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163265,'D-Sigma','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163265,32.27,0.4,28.5,76125,75,NULL,'Edat, raw','IC 5328',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163266,'D-Sigma','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163266,32.61,0.4,33.2,76125,75,NULL,'Edat, cor','IC 5328',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163267,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163267,31.69,0.65,21.8,76125,95,NULL,'Weighted Mean','IC 5328',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163268,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163268,33.07,0.81,41.1,76125,55,NULL,'Visvanathan & Sandage 1979','IC 5328',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163269,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163269,32.51,0.41,31.8,76125,NULL,NULL,NULL,'IC 5328',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163270,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163270,32.69,0.41,34.5,76125,NULL,NULL,'Malmquist cor.','IC 5328',NULL,'2001MNRAS.327.1004B',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163271,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163271,33,0.5,39.7,76125,70,NULL,NULL,'IC 5328',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163272,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163272,32.54,0.45,32.3,76125,NULL,NULL,'K','IC 5328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163273,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163273,32.91,0.4,38.2,76125,NULL,NULL,'mean','IC 5328',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163274,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163274,32,0.8,25.1,76126,75,NULL,'MAT, I','NGC 7689',NULL,'1997ApJS..109..333W',1997,1,2.9,NULL,'G',0.000017,NULL,'12.2',1.9,'SA(r)c',NULL,NULL,NULL,NULL,1,353.319708333,-54.09447,0,NULL,48632885766,759888840,11873263,12.2),(163275,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163275,31.88,0.8,23.8,76126,75,NULL,'B','NGC 7689',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163276,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163276,31.76,0.43,22.5,76126,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163277,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163277,31.78,0.32,22.7,76126,85,NULL,'I, raw','NGC 7689',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163278,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163278,31.81,0.32,23,76126,85,NULL,'I, inv','NGC 7689',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163279,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163279,31.83,0.43,23.2,76126,75,NULL,'3.6 micron, color corrected','NGC 7689',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163280,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163280,31.89,0.43,23.9,76126,75,NULL,'MAT, I, raw','NGC 7689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163281,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163281,31.94,0.2,24.4,76126,74.4,NULL,NULL,'NGC 7689',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163282,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163282,32.05,0.43,25.7,76126,75,NULL,'MAT, I, inv','NGC 7689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163283,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163283,32.1,0.4,26.3,76126,NULL,NULL,NULL,'NGC 7689',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163284,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163284,32.1,0.4,26.3,76126,73,NULL,'opt','NGC 7689',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163285,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163285,32.12,0.43,26.5,76126,75,NULL,'MAT, I, cor','NGC 7689',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163286,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13447','RN',163286,41.87,0.18,1560,76127,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13447',0.512963,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163287,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163287,36.42,0.46,193,76128,70,NULL,NULL,'MCG +00-60-004',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.0001,NULL,'15.3g',0.55,'E0',NULL,NULL,NULL,NULL,1,353.327917,-0.45014,0.113,NULL,49421121773,772205027,12065703,15.3),(163288,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','PS1 SN PS10axm','N',163288,42.04,0.2,1690,76129,73.8,NULL,'SALT 2 (SNANA)','PS1 SN PS10axm HOST',0.5088,'2014ApJ...795...44R',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163289,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163289,37.74,0.33,354,76130,70,NULL,NULL,'2MASX J23332327-0106431',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,353.3469583,-1.11192,0.113,NULL,49420520957,772195639,12065556,17.2),(163290,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163290,37.34,0.46,294,76131,70,NULL,NULL,'2MASX J23332337+1445213',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000201,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,353.3475,14.75606,0.121,NULL,51634794420,806793662,12606150,16.7),(163291,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163291,34.36,0.44,74.6,76132,NULL,NULL,'Malmquist cor.','IC 5331',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000017,NULL,'15.00',0.3,'Sab','Pair member (points to parent)',NULL,NULL,NULL,1,353.353417,21.13006,0.097,NULL,52540384845,820943513,12827242,15),(163292,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163292,34.43,0.43,77,76132,NULL,NULL,NULL,'IC 5331',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163293,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163293,34.46,0.4,77.9,76132,NULL,NULL,'mean','IC 5331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163294,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163294,34.56,0.2,81.7,76132,74.4,NULL,NULL,'IC 5331',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163295,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163295,34.72,0.47,87.8,76132,NULL,NULL,'H','IC 5331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163296,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163296,34.76,0.45,89.5,76132,NULL,NULL,'K','IC 5331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163297,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163297,34.83,0.46,92.5,76132,NULL,NULL,'J','IC 5331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163298,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163298,32.69,0.2,34.5,76133,74.4,NULL,NULL,'KUG 2330+253B',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000033,NULL,'15.13',0.4,'S?',NULL,NULL,NULL,NULL,1,353.35875,25.65047,0.117,NULL,51999006169,812484471,12695069,15.13),(163299,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163299,32.98,0.47,39.5,76133,NULL,NULL,NULL,'KUG 2330+253B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163300,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163300,33.3,0.4,45.7,76133,NULL,NULL,'Malmquist cor.','KUG 2330+253B',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163301,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163301,37.74,0.33,354,76134,70,NULL,NULL,'2MASX J23332894-0104361',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',NULL,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,353.370625,-1.07678,0.105,NULL,49421388104,772209189,12065768,17.2),(163302,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14414','RN',163302,41.12,0.22,1400,76135,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14414',0.192539,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163303,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14414','RN',163303,41.74,0.39,1870,76135,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14414',0.192539,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163304,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163304,37.05,0.46,257,76136,70,NULL,NULL,'2MASX J23332963+1438463',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000152,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.373625,14.64617,0.121,NULL,51634998711,806796854,12606200,17.2),(163305,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163305,34.42,0.49,76.5,76137,NULL,NULL,'Malmquist cor.','UGC 12664',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000375,NULL,'15.28',0.6,'Scd:',NULL,NULL,NULL,NULL,1,353.3885417,15.55247,0.105,NULL,51635417467,806803397,12606303,15.28),(163306,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163306,34.5,0.2,79.4,76137,74.4,NULL,NULL,'UGC 12664',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163307,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163307,34.53,0.46,80.7,76137,NULL,NULL,NULL,'UGC 12664',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163308,'GRB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163308,44.83,1.46,2980,76138,NULL,NULL,NULL,'GRB 090926A',2.1062,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,353.400583,-66.32383,0.029,NULL,48734865447,761482272,11898160,NULL),(163309,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163309,34.22,0.8,69.8,76139,75,NULL,'W91PP, r','UGC 12665',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.1',0.9,'SB(rs)d pec','Pair member (points to parent)',NULL,NULL,NULL,1,353.411083,30.03897,0.237,NULL,52035260109,813050939,12703920,15.1),(163310,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163310,33.78,0.38,56.9,76139,75,NULL,'W91PP, r, inv','UGC 12665',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163311,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163311,33.78,0.38,57,76139,75,NULL,'W91PP, r, raw','UGC 12665',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163312,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163312,34.06,0.38,64.9,76139,75,NULL,'W91PP, r, cor','UGC 12665',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163313,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14844','R',163313,41.98,0.52,1690,76140,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14844',0.474885,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,353.41525,0.17667,0.125,NULL,51578132498,805908320,12592317,NULL),(163314,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 18202','RN',163314,40.72,0.29,1230,76141,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18202',0.132487,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163315,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 18202','RN',163315,41.18,0.3,1520,76141,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18202',0.132487,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163316,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163316,34.04,0.8,64.3,76142,75,NULL,'W91PP, r','UGC 12666',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'14.36',0.6,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.4210417,32.38419,0.237,NULL,52031517413,812992459,12703007,14.36),(163317,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163317,34.05,0.8,64.6,76142,75,NULL,'CF, r','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163318,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163318,33.72,0.38,55.4,76142,75,NULL,'W91PP, r, raw','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163319,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163319,33.77,0.38,56.8,76142,75,NULL,'CF, r, raw','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163320,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163320,33.79,0.38,57.3,76142,75,NULL,'W91PP, r, inv','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163321,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163321,33.86,0.38,59.1,76142,75,NULL,'CF, r, inv','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163322,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163322,34.03,0.38,63.9,76142,75,NULL,'W91PP, r, cor','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163323,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163323,34.07,0.38,65,76142,75,NULL,'CF, r, cor','UGC 12666',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163324,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163324,35.02,0.46,101,76143,70,NULL,NULL,'2MASX J23334196+1404302',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.6g',0.3,NULL,NULL,NULL,NULL,NULL,1,353.4247083,14.07494,0.133,NULL,51636163587,806815056,12606485,16.6),(163325,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163325,36.76,0.87,225,76144,70,NULL,NULL,'2MASX J23334338-0034102',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.000082,NULL,'16.0g',0.46,'Sa',NULL,NULL,NULL,NULL,1,353.4307917,-0.56958,0.105,NULL,49421153940,772205530,12065711,16),(163326,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16071','RN',163326,36.54,0.26,186,76145,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16071',0.092741,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163327,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163327,33.55,0.73,51.4,76146,NULL,NULL,NULL,'MCG -01-60-005',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.00003,NULL,'15.9R',0.8,'SB(s)d','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.43525,-3.08042,0.113,NULL,49414665204,772104143,12064127,15.9),(163328,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163328,33.59,0.2,52.2,76146,74.4,NULL,NULL,'MCG -01-60-005',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163329,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163329,33.95,0.61,61.8,76146,NULL,NULL,'Malmquist cor.','MCG -01-60-005',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163330,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 04402','RN',163330,42.94,0.23,2720,76147,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04402',0.42613,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163331,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 04402','RN',163331,43.13,0.21,2970,76147,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04402',0.42613,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163332,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163332,36.92,0.56,242,76148,70,NULL,NULL,'2MASX J23334900-5325496',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.78',0.36,NULL,NULL,NULL,NULL,NULL,1,353.454167,-53.43036,0,NULL,48631288987,759863890,11872873,16.78),(163333,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163333,33.33,0.8,46.4,76149,75,NULL,'W91PP, r','UGC 12667',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000033,NULL,'13.54',0.8,'Scd:           HII','Pair member (points to parent)',NULL,NULL,NULL,1,353.455333,30.06039,0.237,NULL,52035227012,813050422,12703912,13.54),(163334,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163334,33.35,0.8,46.7,76149,75,NULL,'CF, r','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163335,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163335,32.8,0.69,36.2,76149,100,NULL,'mid-IR','UGC 12667',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163336,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163336,32.82,0.43,36.7,76149,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163337,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163337,32.9,0.46,38,76149,NULL,NULL,NULL,'UGC 12667',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163338,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163338,32.92,0.43,38.4,76149,75,NULL,'3.6 micron, color corrected','UGC 12667',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163339,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163339,32.95,0.2,38.9,76149,74.4,NULL,NULL,'UGC 12667',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163340,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163340,33,0.38,39.7,76149,75,NULL,'CF, r, raw','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163341,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163341,33.06,0.38,40.9,76149,75,NULL,'CF, r, inv','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163342,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163342,33.1,0.42,41.6,76149,NULL,NULL,'Malmquist cor.','UGC 12667',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163343,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163343,33.19,0.38,43.5,76149,75,NULL,'W91PP, r, raw','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163344,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163344,33.26,0.38,44.9,76149,75,NULL,'W91PP, r, inv','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163345,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163345,33.37,0.38,47.1,76149,75,NULL,'CF, r, cor','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163346,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163346,33.5,0.4,50.1,76149,NULL,NULL,'mean','UGC 12667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163347,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163347,33.5,0.47,50.1,76149,NULL,NULL,'H','UGC 12667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163348,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163348,33.56,0.46,51.5,76149,NULL,NULL,'J','UGC 12667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163349,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163349,33.56,0.38,51.5,76149,75,NULL,'W91PP, r, cor','UGC 12667',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163350,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163350,33.58,0.45,51.9,76149,NULL,NULL,'K','UGC 12667',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163351,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163351,33.29,0.43,45.6,76150,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 533-012',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.00006,NULL,'15.7',0.6,NULL,NULL,NULL,NULL,NULL,1,353.4615,45.17453,0.661,NULL,55310968427,864233881,13503654,15.7),(163352,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163352,33.52,0.43,50.5,76150,75,NULL,'3.6 micron, color corrected','CGCG 533-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163353,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163353,33.69,0.2,54.7,76150,74.4,NULL,NULL,'CGCG 533-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163354,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163354,37.65,0.46,339,76151,70,NULL,NULL,'2MASX J23335171-0106192',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000078,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,353.465417,-1.10525,0.105,NULL,49421396291,772209317,12065770,17.8),(163355,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163355,34.74,0.58,88.9,76152,70,NULL,NULL,'CGCG 381-008',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00014,NULL,'15.5',0.15,NULL,NULL,NULL,NULL,NULL,1,353.468833333,-1.33306,0.113,NULL,49420555353,772196177,12065565,15.5),(163356,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163356,33.01,0.8,40,76153,75,NULL,'MAT, I','IC 5328B',NULL,'1997ApJS..109..333W',1997,1,1.41,NULL,'G',0.000033,NULL,'14.99',0.41,'SB(s)c:',NULL,NULL,NULL,NULL,1,353.494833,-45.20967,NULL,NULL,50482279567,788785618,12324775,14.99),(163357,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163357,32.67,0.32,34.2,76153,85,NULL,'I, inv','IC 5328B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163358,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163358,32.7,0.32,34.7,76153,85,NULL,'I, raw','IC 5328B',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163359,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163359,32.99,0.43,39.6,76153,75,NULL,'MAT, I, inv','IC 5328B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163360,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163360,33.04,0.43,40.5,76153,75,NULL,'MAT, I, raw','IC 5328B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163361,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163361,33.17,0.43,43.1,76153,75,NULL,'MAT, I, cor','IC 5328B',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163362,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163362,36.87,0.46,237,76154,70,NULL,NULL,'2MASX J23335986-0836364',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.499583,-8.61022,0.073,NULL,49653614984,775837734,12122464,17.1),(163363,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163363,37.56,0.14,325,76155,70,NULL,NULL,'2MASX J23340229+0058120',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.1g',0.11,NULL,NULL,NULL,NULL,NULL,1,353.509583,0.97008,0.105,NULL,51581528641,805961385,12593146,18.1),(163364,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650','R',163364,40.45,0.33,945,76156,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01650',0.304341,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',NULL,'PHOT','20.4g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,353.5105,0.68375,0.093,NULL,51580834112,805950533,12592977,20.4),(163365,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650','R',163365,40.63,0.31,1020,76156,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01650',0.304341,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163366,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650',NULL,163366,40.06,0.45,1030,76156,70,NULL,'SN photometric redshift distance, z photo =0.277 +/- 0.078','SDSS-II SN 01650',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163367,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650',NULL,163367,40.29,0.22,1140,76156,70,NULL,'SALT 2','SDSS-II SN 01650',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163368,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 01650',NULL,163368,40.32,0.22,1160,76156,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01650',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163369,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163369,37.56,0.14,325,76157,70,NULL,NULL,'2MASX J23340409+0058391',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000083,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.517,0.97753,0.105,NULL,51581530538,805961414,12593147,17.2),(163370,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163370,37.56,0.14,325,76158,70,NULL,NULL,'2MASX J23341349+0101481',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.000105,NULL,'16.0g',0.42,'S0^-',NULL,NULL,NULL,NULL,1,353.5562917,1.03014,0.121,NULL,51581533147,805961455,12593147,16),(163371,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163371,37.29,0.46,287,76159,70,NULL,NULL,'2MASX J23341380-1030164',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000145,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,353.557667,-10.50469,0.026,NULL,49653066370,775829162,12122330,17),(163372,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07339','RN',163372,42.3,0.33,2210,76160,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 07339',0.307303,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163373,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07339','RN',163373,42.93,0.34,2950,76160,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 07339',0.307303,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163374,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163374,37.49,0.27,314,76161,70,NULL,NULL,'2MASX J23341910+1502363',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00015,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,353.5795417,15.04339,0.105,NULL,51634335753,806786496,12606039,17.2),(163375,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163375,37.39,0.46,300,76162,70,NULL,NULL,'2MASX J23342044-0933240',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,353.585125,-9.55681,0.078,NULL,49655927948,775873874,12123029,17.4),(163376,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163376,37.56,0.14,325,76163,70,NULL,NULL,'2MASX J23342243+0101221',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'17.5g',0.2,NULL,NULL,NULL,NULL,NULL,1,353.5935417,1.02286,0.121,NULL,51581520991,805961265,12593144,17.5),(163377,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163377,34.79,0.4,90.9,76164,NULL,NULL,'mean','UGC 12672',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000033,NULL,'14.46',0.8,'S?             HII',NULL,NULL,NULL,NULL,1,353.596375,34.62489,0.341,NULL,52030933063,812983329,12702864,14.46),(163378,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163378,34.86,0.47,93.8,76164,NULL,NULL,'H','UGC 12672',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163379,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14365','RN',163379,42.59,0.22,2250,76165,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 14365',0.464236,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163380,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21502','R',163380,38,0.19,365,76166,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ra','2MASX J23342408-0053250',0.089063,'2014arXiv1401.3317S',2014,1,NULL,NULL,'QSO',0.000159,NULL,'17.5g',NULL,'BLAGN',NULL,NULL,NULL,NULL,1,353.600417,-0.89022,0.093,NULL,49421260671,772207197,12065737,17.5),(163381,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2007ra',NULL,163381,37.86,0.09,373,76166,70,NULL,'SALT 2','2MASX J23342408-0053250',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163382,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SN 2007ra',NULL,163382,37.86,0.09,373,76166,70,NULL,'SALT 2, Malmquist cor.','2MASX J23342408-0053250',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163383,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 21502','R',163383,38.2,0.1,402,76166,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ra','2MASX J23342408-0053250',0.089063,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163384,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163384,36.83,0.33,233,76167,70,NULL,NULL,'2MASX J23342563+0014041',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',NULL,NULL,'16.4g',0.32,NULL,NULL,NULL,NULL,NULL,1,353.6067917,0.23456,0.125,NULL,51577978845,805905919,12592279,16.4),(163385,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16892','RN',163385,41.69,0.45,2060,76168,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16892',0.05785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163386,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 16892','RN',163386,42.35,0.24,2790,76168,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16892',0.05785,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163387,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163387,37.49,0.27,314,76169,70,NULL,NULL,'2MASX J23342614+1503493',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000167,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,353.609,15.06375,0.105,NULL,51634329571,806786399,12606037,17.2),(163388,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163388,37.49,0.27,314,76170,70,NULL,NULL,'2MASX J23342621+1502353',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000147,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,353.6092917,15.04303,0.105,NULL,51634336352,806786505,12606039,18.3),(163389,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163389,29.62,0.4,8.4,76171,75,NULL,'B','IC 5332',NULL,'1988NBGC.C....0000T',1988,1,7.8,'Extended HIPASS source','G',0.000003,NULL,'11.0B',6.2,'SA(s)d','Possible group member',NULL,NULL,NULL,1,353.614541667,-36.10108,NULL,NULL,49982810138,780981408,12202834,11),(163390,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163390,37.59,0.46,330,76172,70,NULL,NULL,'2MASX J23342809-0842040',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000159,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,353.617125,-8.70108,0.084,NULL,49654149005,775846078,12122594,17.6),(163391,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163391,37.03,0.46,255,76173,70,NULL,NULL,'2MASX J23342857+0034185',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000105,NULL,'16.3g',0.35,'AGN',NULL,NULL,NULL,NULL,1,353.6190417,0.57197,0.093,NULL,51578024205,805906628,12592291,16.3),(163392,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163392,37.05,0.46,258,76174,70,NULL,NULL,'SDSS J233429.80+002251.9',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000057,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,353.6242083,0.38108,0.093,NULL,51578047588,805906993,12592296,18.3),(163393,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00717','RN',163393,38.62,0.29,469,76175,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 00717',0.130392,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163394,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00717','RN',163394,38.87,0.29,525,76175,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 00717',0.130392,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163395,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163395,33.93,0.48,61.2,76176,70,NULL,NULL,'NGC 7701',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00008,NULL,'14.36',0.5,'S0o pec:',NULL,NULL,NULL,NULL,1,353.63125,-2.85428,0.097,NULL,49414537896,772102154,12064096,14.36),(163396,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163396,36.8,0.46,230,76177,70,NULL,NULL,'2MASX J23343342-1009560',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000145,NULL,'17.0g',0.23,NULL,NULL,NULL,NULL,NULL,1,353.6392917,-10.1655,0.055,NULL,49652555776,775821184,12122206,17),(163397,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163397,38.05,0.33,408,76178,70,NULL,NULL,'SDSS J233435.35-004019.9',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',NULL,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,353.6472917,-0.67222,0.081,NULL,49417618199,772150284,12064848,18.4),(163398,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163398,33.61,0.12,52.8,76179,NULL,NULL,NULL,'UGC 12673',NULL,'2009ApJS..182..474S',2009,1,1.04,NULL,'G',0.000266,NULL,'16.5g',0.2,'Sdm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.6480417,15.15742,0.105,NULL,51634348407,806786693,12606042,16.5),(163399,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163399,33.91,0.2,60.5,76179,74.4,NULL,NULL,'UGC 12673',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163400,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163400,34.1,NULL,66.1,76179,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12673',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163401,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163401,34.12,NULL,66.7,76179,NULL,NULL,'Dipole + Quadrupole','UGC 12673',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163402,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163402,34.13,NULL,67.1,76179,NULL,NULL,'Dipole','UGC 12673',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163403,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 02548','RN',163403,41.96,0.14,1810,76180,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02548',0.359853,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163404,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 02548','RN',163404,42.19,0.22,2020,76180,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02548',0.359853,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163405,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163405,37.26,0.46,283,76181,70,NULL,NULL,'2MASX J23343624+0038255',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000093,NULL,'16.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,353.650917,0.64036,0.101,NULL,51578014041,805906469,12592288,16.5),(163406,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163406,32.45,0.4,30.9,76182,NULL,NULL,'mean','IC 5334',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000013,NULL,'14.26',0.6,'(R\')Sa?',NULL,NULL,NULL,NULL,1,353.65175,-4.53425,0.105,NULL,49413900919,772092201,12063940,14.26),(163407,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163407,32.95,0.46,38.9,76182,NULL,NULL,'J','IC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163408,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163408,32.95,0.47,38.9,76182,NULL,NULL,'H','IC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163409,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163409,33.01,0.45,40,76182,NULL,NULL,'K','IC 5334',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163410,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163410,33.09,0.2,41.5,76182,74.4,NULL,NULL,'IC 5334',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163411,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163411,33.2,0.44,43.7,76182,NULL,NULL,NULL,'IC 5334',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163412,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163412,33.22,0.43,44.1,76182,75,NULL,'3.6 micron, color corrected','IC 5334',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163413,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163413,33.27,0.42,45.2,76182,NULL,NULL,'Malmquist cor.','IC 5334',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163414,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163414,33.4,0.43,48,76182,75,NULL,'3.6 micron, color + selection bias corrected','IC 5334',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163415,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163415,32.85,0.8,37.1,76183,75,NULL,'W91PP, r','UGC 12675',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',NULL,NULL,'15.71',0.2,'S?',NULL,NULL,NULL,NULL,1,353.659583,23.22442,0.129,NULL,52483363923,820052561,12813321,15.71),(163416,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163416,31.89,0.2,23.9,76183,74.4,NULL,NULL,'UGC 12675',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163417,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163417,32.16,0.65,27.1,76183,NULL,NULL,'Malmquist cor.','UGC 12675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163418,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163418,32.26,0.62,28.3,76183,NULL,NULL,NULL,'UGC 12675',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163419,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163419,32.28,0.49,28.6,76183,75,NULL,'IR','UGC 12675',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163420,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163420,32.72,0.38,34.9,76183,75,NULL,'W91PP, r, inv','UGC 12675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163421,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163421,32.87,0.38,37.4,76183,75,NULL,'W91PP, r, raw','UGC 12675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163422,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163422,33.21,0.38,43.9,76183,75,NULL,'W91PP, r, cor','UGC 12675',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163423,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163423,34,0.2,63.1,76184,74.4,NULL,NULL,'IC 1501',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.0001,NULL,'14.5',0.7,'SAB(s)bc pec:  HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.666916667,-3.15283,0.113,NULL,49415081940,772110655,12064228,14.5),(163424,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163424,34.11,0.37,66.4,76184,NULL,NULL,NULL,'IC 1501',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163425,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163425,34.34,0.34,73.9,76184,NULL,NULL,'Malmquist cor.','IC 1501',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163426,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163426,37.56,0.14,325,76185,70,NULL,NULL,'2MASX J23344109+0112335',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',NULL,NULL,'16.9g',0.24,'AGN',NULL,NULL,NULL,NULL,1,353.671166667,1.20928,0.137,NULL,51581116784,805954949,12593046,16.9),(163427,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163427,35.68,0.65,137,76186,70,NULL,NULL,'FAIRALL 0150',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'15.87',0.45,'S0',NULL,NULL,NULL,NULL,1,353.672833333,-59.05961,0,NULL,48744980895,761640326,11900630,15.87),(163428,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163428,36.83,0.46,232,76187,70,NULL,NULL,'2MASX J23344154+1450473',NULL,'2015arXiv151105856S',2015,1,0.65,NULL,'G',0.000202,NULL,'15.7g',0.48,'E0',NULL,NULL,NULL,NULL,1,353.67325,14.84658,0.137,NULL,51634988165,806796690,12606198,15.7),(163429,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163429,36.83,0.33,233,76188,70,NULL,NULL,'2MASX J23344198+0010575',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',NULL,NULL,'16.39',0.38,'AGN',NULL,NULL,NULL,NULL,1,353.674875,0.18253,0.125,NULL,51578245176,805910080,12592345,16.39),(163430,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163430,33.73,0.45,55.6,76189,NULL,NULL,'K','NGC 7703',NULL,'2007A&A...465...71T',2007,1,2.2,NULL,'G',0.000073,NULL,'14.41',0.5,'S0',NULL,NULL,NULL,NULL,1,353.6952917,16.07578,0.085,NULL,51632768597,806762009,12605656,14.41),(163431,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163431,33.74,0.4,56,76189,NULL,NULL,'mean','NGC 7703',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163432,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163432,35.31,0.51,115,76190,70,NULL,NULL,'2MASX J23344772-1557010',NULL,'2014MNRAS.445.2677S',2014,1,0.52,NULL,'G',0.00015,NULL,'16.12',0.24,NULL,NULL,NULL,NULL,NULL,1,353.699,-15.95019,0,NULL,49564565487,774446335,12100723,16.12),(163433,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899','R',163433,40.67,0.24,1060,76191,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17899',0.288815,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.6995,-0.15169,0.105,NULL,49418215190,772159612,12064993,NULL),(163434,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899','R',163434,40.75,0.18,1100,76191,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17899',0.288815,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163435,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899',NULL,163435,40.28,0.23,1140,76191,70,NULL,'SN photometric redshift distance, z photo =0.313 +/- 0.044','SDSS-II SN 17899',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163436,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899',NULL,163436,40.58,0.14,1310,76191,70,NULL,'SALT 2','SDSS-II SN 17899',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163437,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17899',NULL,163437,40.61,0.14,1320,76191,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17899',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163438,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163438,35.36,0.8,118,76192,75,NULL,'W91PP, r','UGC 12678',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000007,NULL,'15.44',0.2,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.702791667,26.31078,0.125,NULL,52007489875,812617029,12697141,15.44),(163439,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163439,35.36,0.8,118,76192,75,NULL,'HMCL, I','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163440,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163440,35.36,0.8,118,76192,75,NULL,'W91CL, r','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163441,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163441,35.36,0.8,118,76192,75,NULL,'CF, r','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163442,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163442,35.42,0.38,121,76192,75,NULL,'W91PP, r, raw','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163443,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163443,35.52,0.4,127,76192,75,NULL,'HMCL, I, raw','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163444,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163444,35.53,0.49,127,76192,75,NULL,'IR','UGC 12678',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163445,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163445,35.6,0.38,132,76192,75,NULL,'W91PP, r, cor','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163446,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163446,35.61,0.38,132,76192,75,NULL,'CF, r, raw','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163447,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163447,35.63,0.38,134,76192,75,NULL,'W91CL, r, raw','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163448,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163448,35.65,0.38,135,76192,75,NULL,'W91PP, r, inv','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163449,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163449,35.72,0.4,139,76192,75,NULL,'HMCL, I, cor','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163450,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163450,35.72,0.12,140,76192,NULL,NULL,NULL,'UGC 12678',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163451,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163451,35.77,0.4,143,76192,75,NULL,'HMCL, I, inv','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163452,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163452,35.78,0.38,144,76192,75,NULL,'CF, r, cor','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163453,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163453,35.82,0.38,146,76192,75,NULL,'CF, r, inv','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163454,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163454,35.83,0.2,147,76192,74.4,NULL,NULL,'UGC 12678',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163455,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163455,35.84,0.38,147,76192,75,NULL,'W91CL, r, inv','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163456,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163456,35.86,0.38,148,76192,75,NULL,'W91CL, r, cor','UGC 12678',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163457,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163457,35.96,0.43,156,76192,75,NULL,'3.6 micron, color corrected','UGC 12678',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163458,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163458,36.26,0.43,178,76192,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12678',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163459,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163459,37.08,0.46,261,76193,70,NULL,NULL,'2MASX J23345063-0945216',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000177,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,353.711125,-9.75583,0.06,NULL,49656102506,775876601,12123071,17.3),(163460,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20551','RN',163460,43.24,0.28,3030,76194,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20551',0.46707,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163461,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163461,32.04,0.8,25.6,76195,75,NULL,'MAT, I','NGC 7697',NULL,'1997ApJS..109..333W',1997,1,1.6,'The APMUKS position is east of the nucleus.','G',0.000022,NULL,'14.29',0.3,'Sb pec sp',NULL,NULL,NULL,NULL,1,353.72075,-65.39603,0,NULL,48737529649,761523900,11898810,14.29),(163462,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163462,31.61,0.4,21,76195,73,NULL,'IR','NGC 7697',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163463,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163463,31.61,0.4,21,76195,75,NULL,NULL,'NGC 7697',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163464,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163464,31.94,0.4,24.4,76195,73,NULL,'opt','NGC 7697',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163465,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163465,32.05,0.32,25.7,76195,85,NULL,'I, inv','NGC 7697',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163466,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163466,32.06,0.32,25.8,76195,85,NULL,'I, raw','NGC 7697',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163467,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163467,32.27,0.4,28.4,76195,NULL,NULL,NULL,'NGC 7697',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163468,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163468,32.39,0.43,30.1,76195,75,NULL,'MAT, I, raw','NGC 7697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163469,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163469,32.44,0.43,30.7,76195,75,NULL,'MAT, I, inv','NGC 7697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163470,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163470,32.53,0.4,32,76195,NULL,NULL,'mean','NGC 7697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163471,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163471,32.6,0.49,33.1,76195,75,NULL,'IR','NGC 7697',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163472,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163472,32.69,0.43,34.4,76195,75,NULL,'MAT, I, cor','NGC 7697',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163473,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163473,32.76,0.47,35.7,76195,NULL,NULL,'H','NGC 7697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163474,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163474,32.83,0.45,36.7,76195,NULL,NULL,'K','NGC 7697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163475,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163475,32.87,0.46,37.4,76195,NULL,NULL,'J','NGC 7697',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163476,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163476,31.5,0.4,20,76196,75,NULL,'B','UGC 12682',NULL,'1988NBGC.C....0000T',1988,1,1.3,'The 2MASS position is for a bright knot 19 arcsec southwest of the nucleus.','G',0.000007,NULL,'14.04',1,'Im',NULL,NULL,NULL,NULL,1,353.722917,18.22722,0.113,NULL,52534140853,820845950,12825717,14.04),(163477,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163477,34.22,0.49,69.9,76197,75,NULL,'IR','UGC 12680',NULL,'2011yCatp016004901K',2011,1,1.37,NULL,'G',0.000008,NULL,'15.62',0.17,'SBbc?',NULL,NULL,NULL,NULL,1,353.7235,17.29722,0.117,NULL,52533904094,820842251,12825660,15.62),(163478,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163478,35.3,NULL,115,76197,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163479,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163479,35.32,NULL,116,76197,NULL,NULL,'Dipole + Quadrupole','UGC 12680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163480,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163480,35.32,NULL,116,76197,NULL,NULL,NULL,'UGC 12680',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163481,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163481,35.32,NULL,116,76197,NULL,NULL,'Dipole','UGC 12680',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163482,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163482,35.64,0.46,134,76197,NULL,NULL,'Malmquist cor.','UGC 12680',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163483,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163483,35.66,0.2,136,76197,74.4,NULL,NULL,'UGC 12680',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163484,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163484,35.72,0.44,139,76197,NULL,NULL,NULL,'UGC 12680',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163485,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163485,32.02,0.4,25.4,76198,73,NULL,'opt','UGC 12681',NULL,'2011A&A...532A.104N',2011,1,1.1,NULL,'G',0.000017,NULL,'14.85',0.7,'SB?',NULL,NULL,NULL,NULL,1,353.7277083,18.07183,0.113,NULL,52534072210,820844878,12825701,14.85),(163486,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163486,32.1,0.43,26.2,76198,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12681',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163487,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163487,32.15,0.43,27,76198,75,NULL,'3.6 micron, color corrected','UGC 12681',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163488,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163488,32.18,0.2,27.3,76198,74.4,NULL,NULL,'UGC 12681',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163489,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163489,32.48,0.77,31.3,76198,NULL,NULL,NULL,'UGC 12681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163490,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163490,32.72,0.69,35,76198,NULL,NULL,'Malmquist cor.','UGC 12681',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163491,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163491,38.05,0.33,408,76199,70,NULL,NULL,'2MASX J23345720-0039005',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000084,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,353.738333,-0.65006,0.089,NULL,49418091881,772157685,12064963,17.8),(163492,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163492,36.59,0.46,208,76200,70,NULL,NULL,'2MASX J23345840-0012055',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000104,NULL,'16.4g',0.1,NULL,NULL,NULL,NULL,NULL,1,353.743375,-0.20167,0.105,NULL,49418267326,772160426,12065006,16.4),(163493,'TRGB','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163493,29.4,0.1,7.58,76201,74.4,NULL,NULL,'APMUKS(BJ) B233224.66-372950.1',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000007,NULL,'16.64',0.33,NULL,NULL,NULL,NULL,NULL,1,353.76775,-37.22061,NULL,NULL,49980657919,780947779,12202309,16.64),(163494,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 14322',NULL,163494,40.42,0.15,1220,76202,70,NULL,'SN photometric redshift distance, z photo =0.339 +/- 0.030','SDSS-II SN 14322',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.772917,-0.16947,0.105,NULL,49418217561,772159649,12064994,NULL),(163495,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163495,37.87,0.46,375,76203,70,NULL,NULL,'SDSS J233507.83+155527.3',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000148,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,353.782625,15.92428,0.085,NULL,51632658959,806760296,12605629,18.6),(163496,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 13800','RN',163496,40.94,0.32,1270,76204,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13800',0.21667,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163497,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05673','R',163497,41.46,0.2,1420,76205,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05673',0.379939,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,353.801333,0.78433,0.109,NULL,51577696740,805901511,12592211,NULL),(163498,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05673','R',163498,41.74,0.29,1620,76205,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05673',0.379939,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163499,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163499,38.18,0.46,432,76206,70,NULL,NULL,'2MASX J23351385+1542081',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000147,NULL,'18.4g',0.11,NULL,NULL,NULL,NULL,NULL,1,353.807583,15.70219,0.097,NULL,51632444749,806756949,12605577,18.4),(163500,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20893','RN',163500,39.32,0.54,674,76207,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 20893',0.084621,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163501,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163501,37.56,0.14,325,76208,70,NULL,NULL,'2MASX J23351409+0056361',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,353.808667,0.9435,0.137,NULL,51581220453,805956569,12593071,18.1),(163502,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163502,34.42,0.6,76.6,76209,NULL,NULL,'Malmquist cor.','UGC 12687',NULL,'2009ApJS..182..474S',2009,1,1.7,NULL,'G',0.00002,NULL,'14.31',1.3,'SBbc',NULL,NULL,NULL,NULL,1,353.823041667,12.92342,0.149,NULL,51629488172,806710752,12604855,14.31),(163503,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163503,34.61,0.55,83.5,76209,NULL,NULL,NULL,'UGC 12687',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163504,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163504,34.65,0.2,85.1,76209,74.4,NULL,NULL,'UGC 12687',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163505,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163505,37.56,0.14,325,76210,70,NULL,NULL,'MCG +00-60-013',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.00016,NULL,'15.1g',0.61,'BrClG',NULL,NULL,NULL,NULL,1,353.8569583,1.05906,0.137,NULL,51581177985,805955906,12593061,15.1),(163506,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163506,37.12,0.46,265,76211,70,NULL,NULL,'2MASX J23352613-1005304',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000146,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.8587917,-10.09169,0.047,NULL,49652677585,775823087,12122235,17),(163507,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163507,34.51,0.2,79.8,76212,74.4,NULL,NULL,'UGC 12688',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.00002,NULL,'14.27',0.4,'Sm','Isolated galaxy',NULL,NULL,NULL,1,353.85925,7.32222,0.205,NULL,51793015049,809265860,12644779,14.27),(163508,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15533','RN',163508,41.39,0.29,1410,76213,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15533',0.344401,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163509,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15533','RN',163509,41.44,0.23,1440,76213,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15533',0.344401,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163510,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15533','N',163510,41.3,0.18,1820,76213,70,NULL,'SALT 2','SDSS-II SN 15533',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163511,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15533','N',163511,41.34,0.18,1850,76213,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15533',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163512,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163512,37.56,0.14,325,76214,70,NULL,NULL,'2MASX J23352803+0102485',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000114,NULL,'17.5g',0.15,NULL,NULL,NULL,NULL,NULL,1,353.866875,1.04672,0.137,NULL,51581178527,805955914,12593061,17.5),(163513,'Ring Diameter','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163513,32.1,0.84,26,76215,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7702',NULL,'1981ApJS...45..541P',1981,1,2.2,NULL,'G',0.00008,NULL,'13.08',1.2,'(R)SA(r)0^+',NULL,NULL,NULL,NULL,1,353.870333,-56.01228,0,NULL,48819807784,762809496,11918898,13.08),(163514,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163514,32.42,0.44,30.5,76215,95,NULL,'Weighted Mean','NGC 7702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163515,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163515,32.71,0.63,34.8,76215,95,NULL,'Michard 1979b, c','NGC 7702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163516,'Faber-Jackson','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163516,32.86,0.46,37.3,76215,95,NULL,'Michard 1979a','NGC 7702',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163517,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163517,33.2,0.49,43.6,76215,70,NULL,NULL,'NGC 7702',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163518,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163518,30.85,0.4,14.8,76216,73,NULL,'opt','UGCA 440',NULL,'2011A&A...532A.104N',2011,1,0.7,NULL,'G',0.000017,NULL,'15.34',0.7,'Im',NULL,NULL,NULL,NULL,1,353.881667,18.30972,0.101,NULL,52488063395,820125990,12814468,15.34),(163519,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163519,30.93,1.47,15.3,76216,NULL,NULL,NULL,'UGCA 440',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163520,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163520,31.29,1.24,18.1,76216,NULL,NULL,'Malmquist cor.','UGCA 440',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163521,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163521,34.35,0.49,74.1,76217,75,NULL,'IR','UGC 12689',NULL,'2011yCatp016004901K',2011,1,1.6,NULL,'G',0.000087,NULL,'14.42',0.3,'Sab','Group member',NULL,NULL,NULL,1,353.884541667,5.21464,0.217,NULL,51762055182,808782112,12637220,14.42),(163522,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274',NULL,163522,40.02,0.38,1010,76218,70,NULL,'SN photometric redshift distance, z photo =0.272 +/- 0.064','SDSS-II SN 19274',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.8854583,-0.57058,0.097,NULL,49418313990,772161156,12065018,NULL),(163523,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274','R',163523,40.74,0.25,1120,76218,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19274',0.254586,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163524,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274','R',163524,40.87,0.19,1190,76218,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19274',0.254586,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163525,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274',NULL,163525,40.57,0.14,1300,76218,70,NULL,'SALT 2','SDSS-II SN 19274',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163526,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19274',NULL,163526,40.59,0.14,1310,76218,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19274',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163527,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15633','RN',163527,42.29,0.29,1970,76219,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15633',0.451021,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163528,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15633','N',163528,42.13,0.22,2670,76219,70,NULL,'SALT 2','SDSS-II SN 15633',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163529,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 15633','N',163529,42.22,0.22,2780,76219,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15633',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163530,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163530,32.66,0.45,34.1,76220,NULL,NULL,'K','NGC 7711',NULL,'2007A&A...465...71T',2007,1,2.03,NULL,'G',0.00009,NULL,'13.1g',0.89,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,353.9140417,15.30197,0.097,NULL,51634461059,806788454,12606069,13.1),(163531,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163531,33.72,0.4,55.4,76220,NULL,NULL,'mean','NGC 7711',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163532,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163532,32.67,0.8,34.2,76221,75,NULL,NULL,'UGC 12690',NULL,'1988NBGC.C....0000T',1988,1,0.53,NULL,'G',0.000017,NULL,'17.4g',0.31,'SB(s)m:','X-ray-faint group member',NULL,NULL,NULL,1,353.9152083,1.19847,0.149,NULL,51581287161,805957611,12593087,17.4),(163533,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163533,34.91,0.57,96,76222,70,NULL,NULL,'LCRS B233301.7-443744',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'14.51',0.17,NULL,NULL,NULL,NULL,NULL,1,353.928667,-44.35206,NULL,NULL,50482108303,788782942,12324733,14.51),(163534,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163534,32.66,0.43,34,76223,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12692',NULL,'2014MNRAS.444..527S',2014,1,1,NULL,'G',0.000017,NULL,'15.45',0.2,'S?',NULL,NULL,NULL,NULL,1,353.92925,20.28906,0.089,NULL,52491776847,820184013,12815375,15.45),(163535,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163535,32.77,0.4,35.8,76223,75,NULL,NULL,'UGC 12692',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163536,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163536,32.88,0.43,37.6,76223,75,NULL,'3.6 micron, color corrected','UGC 12692',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163537,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163537,33.08,0.2,41.3,76223,74.4,NULL,NULL,'UGC 12692',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163538,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163538,33.24,0.49,44.4,76223,75,NULL,'IR','UGC 12692',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163539,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163539,33.29,0.43,45.6,76223,NULL,NULL,NULL,'UGC 12692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163540,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163540,33.64,0.37,53.5,76223,NULL,NULL,'Malmquist cor.','UGC 12692',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163541,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163541,34.02,0.8,63.7,76224,75,NULL,'W91PP, r','UGC 12693',NULL,'1997ApJS..109..333W',1997,1,2.37,NULL,'G',0.000009,NULL,'15.44',0.18,'SBcd?',NULL,NULL,NULL,NULL,1,353.9317917,32.38508,0.237,NULL,52039620456,813119069,12704985,15.44),(163542,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163542,33.18,NULL,43.3,76224,NULL,NULL,'Dipole','UGC 12693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163543,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163543,33.19,NULL,43.5,76224,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163544,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163544,33.19,NULL,43.5,76224,NULL,NULL,'Dipole + Quadrupole','UGC 12693',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163545,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163545,33.28,NULL,45.3,76224,NULL,NULL,NULL,'UGC 12693',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163546,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163546,33.79,0.38,57.2,76224,75,NULL,'W91PP, r, inv','UGC 12693',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163547,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163547,33.85,0.38,58.8,76224,75,NULL,'W91PP, r, raw','UGC 12693',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163548,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163548,33.91,0.2,60.5,76224,74.4,NULL,NULL,'UGC 12693',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163549,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163549,33.94,0.41,61.5,76224,NULL,NULL,NULL,'UGC 12693',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163550,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163550,34.09,0.49,65.6,76224,75,NULL,'IR','UGC 12693',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163551,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163551,34.11,0.38,66.5,76224,75,NULL,'W91PP, r, cor','UGC 12693',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163552,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163552,34.14,0.43,67.3,76224,75,NULL,'3.6 micron, color corrected','UGC 12693',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163553,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163553,34.32,0.35,73,76224,NULL,NULL,'Malmquist cor.','UGC 12693',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163554,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163554,34.32,0.43,73.3,76224,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12693',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163555,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07644','R',163555,41.12,0.19,1280,76225,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J233544.40+005205.9',0.3102,'2014arXiv1401.3317S',2014,1,0.06,NULL,'G',0.0005,NULL,'21.0g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,353.9350417,0.86831,0.121,NULL,51577735078,805902110,12592220,21),(163556,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07644','R',163556,41.25,0.29,1360,76225,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J233544.40+005205.9',0.3102,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163557,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07644',NULL,163557,41.17,0.16,1710,76225,70,NULL,'SALT 2','SDSS J233544.40+005205.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163558,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 07644',NULL,163558,41.2,0.16,1740,76225,70,NULL,'SALT 2, Malmquist cor.','SDSS J233544.40+005205.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163559,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163559,36.43,0.46,193,76226,70,NULL,NULL,'2MASX J23354561-0032153',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000066,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,353.940125,-0.53747,0.097,NULL,49418310686,772161104,12065017,17.3),(163560,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163560,37.56,0.14,325,76227,70,NULL,NULL,'2MASX J23354563+0059226',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,353.94025,0.98953,0.121,NULL,51581175935,805955873,12593060,17.8),(163561,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 12874','R',163561,40.31,0.22,927,76228,70,NULL,'SDSS CAND. Unknown; SALT 2; SN 2006fb','SN 2006fb',0.245027,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,353.964625,-0.17711,0.105,NULL,49417377377,772146521,12064789,NULL),(163562,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 12874','R',163562,40.44,0.16,983,76228,70,NULL,'SDSS CAND. Unknown; MLCS2K2; SN 2006fb','SN 2006fb',0.245027,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163563,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163563,33.23,0.4,44.3,76229,NULL,NULL,'mean','NGC 7712',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000007,NULL,'13.74',0.8,'E','Isolated galaxy',NULL,NULL,NULL,1,353.965167,23.61875,0.149,NULL,51950803388,811731302,12683301,13.74),(163564,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163564,33.49,0.45,49.9,76229,NULL,NULL,'K','NGC 7712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163565,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163565,33.5,0.47,50.2,76229,NULL,NULL,'H','NGC 7712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163566,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163566,33.56,0.46,51.4,76229,NULL,NULL,'J','NGC 7712',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163567,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 05015','RN',163567,43.44,0.42,3230,76230,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 05015',0.507643,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163568,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163568,37.56,0.14,325,76231,70,NULL,NULL,'2MASX J23355678+0106330',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',NULL,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,353.986667,1.10919,0.149,NULL,51581240690,805956885,12593076,17),(163569,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709',NULL,163569,40.2,0.19,1100,76232,70,NULL,'SN photometric redshift distance, z photo =0.299 +/- 0.034','SDSS-II SN 06709',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,353.992875,0.61367,0.109,NULL,51578369932,805912030,12592375,NULL),(163570,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709','R',163570,40.95,0.33,1210,76232,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06709',0.280494,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163571,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709','R',163571,41.1,0.27,1290,76232,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06709',0.280494,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163572,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709',NULL,163572,40.81,0.22,1450,76232,70,NULL,'SALT 2','SDSS-II SN 06709',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163573,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 06709',NULL,163573,40.83,0.22,1470,76232,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 06709',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163574,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163574,35.94,0.46,155,76233,70,NULL,NULL,'2MASX J23355923-0926314',NULL,'2015arXiv151105856S',2015,1,0.69,NULL,'G',0.00015,NULL,'15.8g',0.33,'E0',NULL,NULL,NULL,NULL,1,353.996917,-9.44206,0.058,NULL,49653993878,775843654,12122557,15.8),(163575,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08116','RN',163575,42.15,0.17,2160,76234,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 08116',0.242792,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163576,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 08116','RN',163576,42.39,0.21,2420,76234,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 08116',0.242792,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163577,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163577,36.3,0.46,182,76235,70,NULL,NULL,'2MASX J23360469-0859183',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.00015,NULL,'16.3g',0.41,NULL,NULL,NULL,NULL,NULL,1,354.019541667,-8.98844,0.078,NULL,49653388355,775834193,12122409,16.3),(163578,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19127','RN',163578,42.34,0.15,2290,76236,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19127',0.287673,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163579,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19127','RN',163579,42.66,0.21,2650,76236,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19127',0.287673,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163580,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17422','RN',163580,40.32,0.25,1020,76237,70,NULL,'SDSS CAND. SNII; SALT 2','SDSS-II SN 17422',0.141,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163581,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17422','RN',163581,40.51,0.16,1110,76237,70,NULL,'SDSS CAND. SNII; MLCS2K2','SDSS-II SN 17422',0.141,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163582,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163582,36.84,0.46,233,76238,70,NULL,NULL,'2MASX J23360859-0848193',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000151,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,354.03575,-8.8055,0.078,NULL,49653478445,775835600,12122431,17.2),(163583,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163583,32.83,0.8,36.9,76239,75,NULL,'B','NGC 7714',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000003,NULL,'12.5B',1.4,'SB(s)b:pec;HII LINER','X-ray-faint group member',NULL,NULL,'Starburst',1,354.05875,2.15517,0.153,NULL,51578572193,805915190,12592424,12.5),(163584,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163584,32.2,0.45,27.5,76239,NULL,NULL,'K','NGC 7714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163585,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163585,32.26,0.47,28.3,76239,NULL,NULL,'H','NGC 7714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163586,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163586,32.28,0.46,28.6,76239,NULL,NULL,'J','NGC 7714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163587,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163587,32.62,0.4,33.3,76239,NULL,NULL,'mean','NGC 7714',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163588,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163588,29.71,0.8,8.73,76240,75,NULL,'MAT, I','NGC 7713',NULL,'1997ApJS..109..333W',1997,1,4.5,NULL,'G',0.000007,NULL,'11.6B',1.8,'SB(r)d:        HII','in a pair',NULL,NULL,NULL,1,354.0624583,-37.93808,NULL,NULL,49994674438,781166788,12205731,11.6),(163589,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163589,29.46,NULL,7.8,76240,NULL,NULL,NULL,'NGC 7713',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163590,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163590,29.56,0.4,8.2,76240,75,NULL,'B','NGC 7713',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163591,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163591,29.65,0.32,8.51,76240,85,NULL,'I, inv','NGC 7713',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163592,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163592,29.67,0.32,8.57,76240,85,NULL,'I, raw','NGC 7713',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163593,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163593,29.76,0.43,8.9,76240,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163594,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163594,29.82,0.43,9.2,76240,75,NULL,'3.6 micron, color corrected','NGC 7713',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163595,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163595,29.86,0.2,9.38,76240,74.4,NULL,NULL,'NGC 7713',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163596,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163596,29.99,0.4,9.95,76240,NULL,NULL,NULL,'NGC 7713',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163597,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163597,30,0.4,10,76240,73,NULL,'opt','NGC 7713',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163598,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163598,30.07,0.43,10.3,76240,75,NULL,'MAT, I, raw','NGC 7713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163599,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163599,30.08,0.43,10.4,76240,75,NULL,'MAT, I, inv','NGC 7713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163600,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163600,30.09,0.49,10.4,76240,NULL,NULL,NULL,'NGC 7713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163601,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163601,30.4,0.42,12,76240,NULL,NULL,'Malmquist cor.','NGC 7713',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163602,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163602,30.44,0.43,12.2,76240,75,NULL,'MAT, I, cor','NGC 7713',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163603,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20262',NULL,163603,38.5,2.13,502,76241,70,NULL,'SN photometric redshift distance, z photo =0.125 +/- 0.256','SDSS-II SN 20262',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.062958333,-0.04292,0.109,NULL,49417519625,772148744,12064824,NULL),(163604,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20262','R',163604,40.8,0.3,1150,76241,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20262',0.260941,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163605,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20262','R',163605,41.08,0.36,1310,76241,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20262',0.260941,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163606,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 17760','RN',163606,39.63,0.23,705,76242,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17760',0.196919,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163607,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163607,31.36,NULL,18.7,76243,NULL,NULL,NULL,'ESO 148- G 020',NULL,'2000BSAO...50....5K',2000,1,1.81,NULL,'G',0.000024,NULL,'15.26',0.26,'SBd? sp',NULL,NULL,NULL,NULL,1,354.086416667,-57.62933,0,NULL,48818958316,762796223,11918690,15.26),(163608,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163608,33.21,NULL,43.8,76243,NULL,NULL,'Dipole','ESO 148- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163609,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163609,33.22,NULL,44.1,76243,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 148- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163610,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163610,33.23,NULL,44.2,76243,NULL,NULL,'Dipole + Quadrupole','ESO 148- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163611,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163611,37.6,0.46,332,76244,70,NULL,NULL,'2MASX J23362075+1420243',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000157,NULL,'17.4g',0.24,NULL,NULL,NULL,NULL,NULL,1,354.086416667,14.34019,0.157,NULL,51666499520,807289055,12613891,17.4),(163612,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163612,32.8,0.8,36.3,76245,75,NULL,'B','NGC 7715',NULL,'1988NBGC.C....0000T',1988,1,2.6,NULL,'G',0.000013,NULL,'14.68',0.5,'Im pec sp','X-ray-faint group member',NULL,NULL,NULL,1,354.09225,2.15653,0.153,NULL,51578583583,805915368,12592427,14.68),(163613,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163613,35.79,0.43,144,76246,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2333+260',NULL,'2014MNRAS.444..527S',2014,1,0.6,NULL,'G',0.000002,NULL,'15.84',0.2,'Sb',NULL,NULL,NULL,NULL,1,354.1002083,26.36983,0.125,NULL,52008226312,812628536,12697320,15.84),(163614,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 20703','RN',163614,43.01,0.3,2480,76247,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20703',0.61158,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163615,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163615,36.26,0.46,179,76248,70,NULL,NULL,'2MASX J23362562+0104473',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000097,NULL,'16.1g',0.38,'E0',NULL,NULL,NULL,NULL,1,354.106625,1.07994,0.125,NULL,51577649317,805900770,12592199,16.1),(163616,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163616,35.34,0.8,117,76249,75,NULL,'W91PP, r','UGC 12701',NULL,'1997ApJS..109..333W',1997,1,1,'Position in 1997AJ....113...22G is incorrect.','G',0.000023,NULL,'16.5',0.1,'Scd:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.106917,27.93561,0.129,NULL,51996555543,812446180,12694471,16.5),(163617,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163617,35.34,0.8,117,76249,75,NULL,'HMCL, I','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163618,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163618,35.34,0.8,117,76249,75,NULL,'W91CL, r','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163619,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163619,35.34,0.8,117,76249,75,NULL,'CF, r','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163620,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163620,35.15,0.38,107,76249,75,NULL,'CF, r, raw','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163621,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163621,35.15,0.49,107,76249,75,NULL,'IR','UGC 12701',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163622,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163622,35.23,0.38,111,76249,75,NULL,'CF, r, inv','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163623,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163623,35.29,0.4,114,76249,75,NULL,'HMCL, I, raw','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163624,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163624,35.33,0.38,117,76249,75,NULL,'W91CL, r, raw','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163625,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163625,35.36,0.38,118,76249,75,NULL,'CF, r, cor','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163626,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163626,35.36,0.43,118,76249,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163627,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163627,35.43,0.4,122,76249,75,NULL,'HMCL, I, inv','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163628,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163628,35.44,0.38,122,76249,75,NULL,'W91CL, r, inv','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163629,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163629,35.47,0.38,124,76249,75,NULL,'W91PP, r, raw','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163630,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163630,35.51,0.4,126,76249,75,NULL,'HMCL, I, cor','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163631,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163631,35.5,0.43,126,76249,75,NULL,'3.6 micron, color corrected','UGC 12701',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163632,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163632,35.55,0.11,129,76249,NULL,NULL,NULL,'UGC 12701',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163633,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163633,35.55,0.38,129,76249,75,NULL,'W91CL, r, cor','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163634,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163634,35.58,0.2,131,76249,74.4,NULL,NULL,'UGC 12701',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163635,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163635,35.6,0.38,132,76249,75,NULL,'W91PP, r, inv','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163636,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163636,35.65,0.38,135,76249,75,NULL,'W91PP, r, cor','UGC 12701',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163637,'IRAS','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163637,31.5,0.8,19.9,76250,75,NULL,'MAT, I','ESO 347- G 029',NULL,'1997ApJS..109..333W',1997,1,3.2,NULL,'G',0.00001,NULL,'13.92',1.7,'SB(s)dm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.1134583,-38.78244,NULL,NULL,49984831615,781012993,12203328,13.92),(163638,'Tully est','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163638,31.36,0.8,18.7,76250,75,NULL,NULL,'ESO 347- G 029',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163639,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163639,32.07,0.43,26,76250,75,NULL,'MAT, I, raw','ESO 347- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163640,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163640,32.1,0.43,26.3,76250,75,NULL,'MAT, I, inv','ESO 347- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163641,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163641,32.16,0.32,27,76250,85,NULL,'I, raw','ESO 347- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163642,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163642,32.16,0.32,27,76250,85,NULL,'I, inv','ESO 347- G 029',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163643,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163643,32.26,0.43,28.3,76250,75,NULL,'MAT, I, cor','ESO 347- G 029',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163644,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163644,32.27,0.2,28.4,76250,74.4,NULL,NULL,'ESO 347- G 029',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163645,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163645,32.29,0.4,28.7,76250,NULL,NULL,NULL,'ESO 347- G 029',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163646,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163646,32.29,0.39,28.7,76250,73,NULL,'opt','ESO 347- G 029',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163647,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163647,32.43,0.43,30.6,76250,75,NULL,'3.6 micron, color corrected','ESO 347- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163648,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163648,32.6,0.43,33.2,76250,75,NULL,'3.6 micron, color + selection bias corrected','ESO 347- G 029',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163649,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559',NULL,163649,40.06,0.34,1030,76251,70,NULL,'SN photometric redshift distance, z photo =0.277 +/- 0.056','SDSS-II SN 10559',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.116417,-1.22661,0.093,NULL,49420725168,772198830,12065606,NULL),(163650,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559','R',163650,40.68,0.21,1070,76251,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 10559',0.281092,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163651,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559','R',163651,40.84,0.29,1150,76251,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 10559',0.281092,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163652,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559',NULL,163652,40.74,0.18,1410,76251,70,NULL,'SALT 2','SDSS-II SN 10559',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163653,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 10559',NULL,163653,40.77,0.18,1430,76251,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 10559',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163654,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163654,37.54,0.27,322,76252,70,NULL,NULL,'2MASX J23362923-0911143',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.00014,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,354.121916667,-9.18733,0.071,NULL,49654086475,775845101,12122579,17.8),(163655,'Ring Diameter','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163655,33.5,0.84,50,76253,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7716',NULL,'1981ApJS...45..541P',1981,1,2.1,NULL,'G',0.00002,NULL,'12.82',1.8,'SAB(r)b:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.1310417,0.29728,0.109,NULL,51577563555,805899430,12592178,12.82),(163656,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163656,32.56,0.45,32.4,76253,NULL,NULL,'K','NGC 7716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163657,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163657,32.56,0.4,32.5,76253,NULL,NULL,'mean','NGC 7716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163658,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163658,32.59,0.47,33,76253,NULL,NULL,'H','NGC 7716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163659,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163659,32.6,0.46,33.2,76253,NULL,NULL,'J','NGC 7716',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163660,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163660,32.64,0.4,33.7,76253,75,NULL,'B','NGC 7716',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163661,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163661,37.38,0.46,300,76254,70,NULL,NULL,'2MASX J23363528-0056138',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000075,NULL,'18.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,354.146958333,-0.93719,0.097,NULL,49418074387,772157412,12064959,18.1),(163662,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163662,38.55,0.46,513,76255,70,NULL,NULL,'2MASX J23363605-1034423',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000167,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,354.1502083,-10.57844,0.083,NULL,49652570699,775821417,12122209,18.2),(163663,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163663,31.14,0.96,16.9,76256,NULL,NULL,NULL,'ESO 605- G 015',NULL,'2009ApJS..182..474S',2009,1,2.13,NULL,'G',0.000013,NULL,'16.49',0.2,'Sd',NULL,NULL,NULL,NULL,1,354.152583,-21.86206,0.054,NULL,50276488028,785570125,12274533,16.49),(163664,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163664,31.62,0.39,21.1,76256,73,NULL,'opt','ESO 605- G 015',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163665,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163665,31.72,0.73,22,76256,NULL,NULL,'Malmquist cor.','ESO 605- G 015',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163666,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163666,31.75,NULL,22.4,76256,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 605- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163667,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163667,31.77,NULL,22.6,76256,NULL,NULL,'Dipole + Quadrupole','ESO 605- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163668,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163668,31.78,NULL,22.7,76256,NULL,NULL,'Dipole','ESO 605- G 015',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163669,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163669,31.82,NULL,23.1,76256,NULL,NULL,NULL,'ESO 605- G 015',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163670,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163670,32.4,0.2,30.2,76256,74.4,NULL,NULL,'ESO 605- G 015',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163671,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163671,33.27,0.2,45.1,76257,74.4,NULL,NULL,'UGC 12705',NULL,'2013AJ....146...86T',2013,1,1.01,NULL,'G',0.000021,NULL,'15.6g',0.56,'SBcd:','Isolated galaxy',NULL,NULL,NULL,1,354.1547083,14.15728,0.173,NULL,51659157747,807174339,12612099,15.6),(163672,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163672,33.57,0.12,51.9,76257,NULL,NULL,NULL,'UGC 12705',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163673,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163673,37.34,0.46,293,76258,70,NULL,NULL,'2MASX J23363763-0936173',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000162,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,354.1567083,-9.60464,0.058,NULL,49653976350,775843380,12122552,17.1),(163674,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163674,37.22,0.46,278,76259,70,NULL,NULL,'2MASX J23363834+1451004',NULL,'2015arXiv151105856S',2015,1,0.12,NULL,'G',0.000117,NULL,'19.0g',0.09,NULL,NULL,NULL,NULL,NULL,1,354.159667,14.85006,0.117,NULL,51666678652,807291853,12613935,19),(163675,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163675,37.54,0.27,322,76260,70,NULL,NULL,'2MASX J23363916-0914233',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000177,NULL,'16.9g',0.25,NULL,NULL,NULL,NULL,NULL,1,354.163,-9.23981,0.071,NULL,49654074879,775844919,12122576,16.9),(163676,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163676,32.65,0.2,33.9,76261,74.4,NULL,NULL,'UGC 12707',NULL,'2013AJ....146...86T',2013,1,1.5,'MCG notes this as a possible interacting system.','G',0.00001,NULL,'14.51',1,'SB?',NULL,NULL,NULL,NULL,1,354.170417,17.51444,0.129,NULL,52487768723,820121386,12814396,14.51),(163677,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163677,32.68,0.43,34.3,76261,75,NULL,'3.6 micron, color corrected','UGC 12707',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163678,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163678,32.73,0.43,35.2,76261,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12707',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163679,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163679,32.9,0.56,38,76261,NULL,NULL,NULL,'UGC 12707',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163680,'Tully-Fisher','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163680,33.25,0.48,44.8,76261,NULL,NULL,'Malmquist cor.','UGC 12707',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163681,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163681,37.05,0.46,257,76262,70,NULL,NULL,'2MASX J23364313+1340264',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.000183,NULL,'16.6g',0.28,NULL,NULL,NULL,NULL,NULL,1,354.179667,13.67414,0.141,NULL,51659216177,807175252,12612113,16.6),(163682,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,NULL,163682,34.05,0.52,64.5,76263,70,NULL,NULL,'MCG -01-60-012',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'14.83',0.25,NULL,NULL,NULL,NULL,NULL,1,354.1880417,-5.03794,0.081,NULL,49413223957,772081624,12063775,14.83),(163683,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163683,37.21,0.46,277,76264,70,NULL,NULL,'2MASX J23364715+0111233',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',NULL,NULL,'16.4g',0.34,NULL,NULL,NULL,NULL,NULL,1,354.1965,1.18981,0.157,NULL,51577677521,805901211,12592206,16.4),(163684,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19128','R',163684,41.07,0.24,1270,76265,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007lw','SN 2007lw',0.287,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,354.20375,-0.78225,0.097,NULL,49417938882,772155295,12064926,NULL),(163685,'SNIa','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 19128','R',163685,41.13,0.16,1310,76265,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007lw','SN 2007lw',0.287,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163686,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163686,38.08,0.46,413,76266,70,NULL,NULL,'2MASX J23364943+0102353',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.14',0.16,NULL,NULL,NULL,NULL,NULL,1,354.2059583,1.04308,0.125,NULL,51577836336,805903692,12592245,18.14),(163687,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163687,38.03,0.46,403,76267,70,NULL,NULL,'2MASX J23364981+1444201',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000166,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,354.207583,14.73889,0.117,NULL,51666706875,807292294,12613942,17.8),(163688,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163688,37.54,0.27,322,76268,70,NULL,NULL,'2MASX J23365066-0915579',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00015,NULL,'16.8g',0.33,NULL,NULL,NULL,NULL,NULL,1,354.211,-9.26625,0.071,NULL,49653809303,775840770,12122512,16.8),(163689,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00718','RN',163689,40.21,0.16,947,76269,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00718',0.161636,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163690,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 00718','RN',163690,40.63,0.21,1150,76269,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00718',0.161636,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163691,'FP','2016-12-15 15:16:07','2016-12-16 11:21:24','1',NULL,'R',163691,36.95,0.46,245,76270,70,NULL,NULL,'2MASX J23365083+0039183',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000092,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,354.21175,0.65517,0.133,NULL,51578279743,805910620,12592353,17.3),(163692,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 04261','RN',163692,42.94,0.31,2950,76271,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04261',0.310649,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163693,'SNIa SDSS','2016-12-15 15:16:07','2016-12-16 11:21:24','1','SDSS-II SN 04261','RN',163693,43.11,0.31,3200,76271,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04261',0.310649,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163694,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163694,37.76,0.46,357,76272,70,NULL,NULL,'2MASX J23365915+0006385',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000059,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,354.246583,0.11069,0.109,NULL,51577421700,805897214,12592143,18.2),(163695,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 00719','RN',163695,43.36,0.3,3160,76273,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00719',0.485763,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163696,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163696,33.05,0.4,40.8,76274,NULL,NULL,'mean','NGC 7713A',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.000007,NULL,'12.98',1.4,'SB(r)c:','in a pair',NULL,NULL,NULL,1,354.2845417,-37.71414,NULL,NULL,49995287950,781176374,12205880,12.98),(163697,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163697,33.06,0.46,41,76274,NULL,NULL,'J','NGC 7713A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163698,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163698,33.1,0.47,41.7,76274,NULL,NULL,'H','NGC 7713A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163699,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163699,33.17,0.45,43.1,76274,NULL,NULL,'K','NGC 7713A',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163700,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163700,37.26,0.17,284,76275,70,NULL,NULL,'2MASX J23370931+1555002',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000219,NULL,'16.1g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,354.288875,15.91678,0.085,NULL,51665728574,807277008,12613703,16.1),(163701,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 13833',NULL,163701,40.93,0.22,1530,76276,70,NULL,'SN photometric redshift distance, z photo =0.454 +/- 0.067','SDSS-II SN 13833',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.3214583,-0.20942,0.125,NULL,49417328086,772145751,12064777,NULL),(163702,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 13833','R',163702,42.66,0.34,2240,76276,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13833',0.516581,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163703,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 13833',NULL,163703,42.53,0.23,3210,76276,70,NULL,'SALT 2','SDSS-II SN 13833',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163704,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 13833',NULL,163704,42.69,0.23,3450,76276,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13833',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163705,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 09704','RN',163705,41.13,0.42,1300,76277,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 09704',0.294362,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163706,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 09704','RN',163706,41.48,0.32,1530,76277,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 09704',0.294362,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163707,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 09704','N',163707,40.96,0.27,1560,76277,70,NULL,'SALT 2','SDSS-II SN 09704',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163708,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 09704','N',163708,40.99,0.27,1580,76277,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 09704',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163709,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163709,35.53,0.33,128,76278,NULL,NULL,NULL,'ESO 605- G 017',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'16.53',0.3,'Sb-c',NULL,NULL,NULL,NULL,1,354.333333,-22.16144,0.056,NULL,50276426863,785569169,12274518,16.53),(163710,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163710,35.57,0.2,130,76278,74.4,NULL,NULL,'ESO 605- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163711,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163711,35.6,0.32,132,76278,NULL,NULL,'Malmquist cor.','ESO 605- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163712,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163712,35.97,0.25,156,76279,74.4,NULL,NULL,'CGCG 476-079',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000167,NULL,'15.6',NULL,'S0','Group member',NULL,NULL,NULL,1,354.3337083,26.87794,0.145,NULL,52007918114,812623720,12697245,15.6),(163713,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945',NULL,163713,39.49,0.39,790,76280,70,NULL,'SN photometric redshift distance, z photo =0.205 +/- 0.046','SDSS-II SN 15945',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.335167,0.49964,0.117,NULL,51577475813,805898059,12592157,21.6),(163714,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945','R',163714,40.82,0.29,1120,76280,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15945',0.309534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163715,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945','R',163715,40.85,0.23,1130,76280,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15945',0.309534,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163716,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945',NULL,163716,40.69,0.19,1370,76280,70,NULL,'SALT 2','SDSS-II SN 15945',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163717,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 15945',NULL,163717,40.73,0.19,1400,76280,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15945',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163718,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'N',163718,18.71,0.34,0.055,76281,NULL,NULL,'If object = GC, ID = DESJ2356_5935','Tucana III',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163719,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163719,32.73,0.4,35.1,76282,75,NULL,'B','UGC 12709',NULL,'1988NBGC.C....0000T',1988,1,0.95,NULL,'G',0.000013,NULL,'15.5g',0.63,'SAB(s)m','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.35,0.39167,0.117,NULL,51577458264,805897785,12592152,15.5),(163720,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163720,35.03,0.25,101,76283,74.4,NULL,NULL,'CGCG 476-080',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000107,NULL,'15.5',0.35,'S0','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.3579583,27.07167,0.181,NULL,51994056850,812407138,12693861,15.5),(163721,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163721,38.33,0.46,463,76284,70,NULL,NULL,'2MASX J23372808+1454389',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000174,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,354.3672083,14.91081,0.085,NULL,51666652542,807291445,12613928,18.1),(163722,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 10327','RN',163722,39.9,0.42,879,76285,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10327',0.084882,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163723,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163723,38.18,0.46,432,76286,70,NULL,NULL,'2MASX J23373017+0103105',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000091,NULL,'16.69',0.15,NULL,NULL,NULL,NULL,NULL,1,354.375583,1.053,0.121,NULL,51594756292,806168067,12596376,16.69),(163724,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163724,35.5,0.47,126,76287,70,NULL,NULL,'ESO 605- G 018',NULL,'2014MNRAS.445.2677S',2014,1,1,NULL,'G',0.000133,NULL,'14.89',0.9,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,354.379917,-19.62058,0.092,NULL,50270787550,785481055,12273141,14.89),(163725,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163725,36.45,0.62,195,76288,70,NULL,NULL,'2MASX J23373210-1753386',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00008,NULL,'15.89',0.43,'S0',NULL,NULL,NULL,NULL,1,354.3839583,-17.89397,0.02,NULL,50269729919,785464529,12272883,15.89),(163726,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163726,32.67,0.4,34.2,76289,75,NULL,'B','UGC 12710',NULL,'1988NBGC.C....0000T',1988,1,1.3,NULL,'G',0.000003,NULL,'14.36',0.9,'Im?',NULL,NULL,NULL,NULL,1,354.389458333,17.99628,0.089,NULL,52488557794,820133715,12814589,14.36),(163727,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163727,32.91,0.8,38.3,76290,75,NULL,'MAT, I','ESO 408- G 012',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000029,NULL,'15.27',0.7,'SAB(s)d:',NULL,NULL,NULL,NULL,1,354.392375,-36.996,NULL,NULL,49982174418,780971475,12202679,15.27),(163728,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163728,33.46,0.32,49.1,76290,85,NULL,'I, inv','ESO 408- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163729,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163729,33.46,0.32,49.2,76290,85,NULL,'I, raw','ESO 408- G 012',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163730,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163730,33.58,0.4,52,76290,NULL,NULL,NULL,'ESO 408- G 012',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163731,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163731,33.84,0.43,58.6,76290,75,NULL,'MAT, I, raw','ESO 408- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163732,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163732,33.89,0.43,60,76290,75,NULL,'MAT, I, inv','ESO 408- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163733,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163733,34.35,0.43,74.1,76290,75,NULL,'MAT, I, cor','ESO 408- G 012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163734,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750',NULL,163734,39.85,0.26,934,76291,70,NULL,'SN photometric redshift distance, z photo =0.248 +/- 0.037','SDSS-II SN 01750',NULL,'2011ApJ...738..162S',2011,1,0.14,NULL,'G',NULL,'PHOT','20.6g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,354.394458333,-0.47694,0.125,NULL,49450949282,772671082,12072985,20.6),(163735,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750','R',163735,40.65,0.2,1070,76291,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01750',0.25997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163736,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750','R',163736,40.76,0.28,1130,76291,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01750',0.25997,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163737,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750',NULL,163737,40.63,0.17,1340,76291,70,NULL,'SALT 2','SDSS-II SN 01750',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163738,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 01750',NULL,163738,40.66,0.17,1360,76291,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01750',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163739,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SN 2007pw',NULL,163739,39.81,0.16,917,76292,70,NULL,'Hubble residual -0.02 for z0.24500','SDSS J233734.57+001450.7',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.005,NULL,'20.3g',0.06,NULL,NULL,NULL,NULL,NULL,1,354.3940417,0.24744,0.113,NULL,51594173188,806158956,12596233,20.3),(163740,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SN 2007pw',NULL,163740,39.87,0.22,942,76292,70,NULL,'SDSS-II SN 20111','SDSS J233734.57+001450.7',NULL,'2013MNRAS.434.1443X',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163741,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 20111','R',163741,40.49,0.23,1010,76292,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pw','SDSS J233734.57+001450.7',0.245,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163742,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 20111','R',163742,40.61,0.15,1070,76292,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pw','SDSS J233734.57+001450.7',0.245,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163743,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SN 2007pw',NULL,163743,40.31,0.12,1150,76292,70,NULL,'SALT 2','SDSS J233734.57+001450.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163744,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SN 2007pw',NULL,163744,40.33,0.12,1160,76292,70,NULL,'SALT 2, Malmquist cor.','SDSS J233734.57+001450.7',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163745,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395',NULL,163745,40.26,0.31,1130,76293,70,NULL,'SN photometric redshift distance, z photo =0.310 +/- 0.059','SDSS-II SN 17395',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','20.6g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.406083,-0.95064,0.097,NULL,49451265093,772676017,12073062,20.6),(163746,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395','R',163746,41.07,0.26,1250,76293,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17395',0.30272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163747,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395','R',163747,41.28,0.22,1390,76293,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17395',0.30272,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163748,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395',NULL,163748,40.96,0.2,1560,76293,70,NULL,'SALT 2','SDSS-II SN 17395',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163749,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17395',NULL,163749,40.99,0.2,1580,76293,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 17395',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163750,'SZ effect','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163750,39.51,NULL,799,76294,NULL,NULL,NULL,'ABELL 2631',NULL,'2012ApJ...748..113H',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'I:     [BM]',NULL,NULL,NULL,NULL,1,354.419167,0.27667,0.117,NULL,51594182097,806159095,12596235,NULL),(163751,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163751,31.46,0.8,19.6,76295,75,NULL,'B','UGCA 441',NULL,'1988NBGC.C....0000T',1988,1,0.3,NULL,'G',0.00002,NULL,'15.5',0.2,'BCD/E','Isolated galaxy',NULL,NULL,NULL,1,354.4147917,30.12947,0.221,NULL,52034848948,813044514,12703820,15.5),(163752,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163752,35.76,0.56,142,76296,70,NULL,NULL,'CGCG 381-017',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.000099,NULL,'15.1g',0.58,'S0/a',NULL,NULL,NULL,NULL,1,354.430375,-0.51811,0.125,NULL,49450948596,772671071,12072985,15.1),(163753,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:24','1','SDSS-II SN 17371','RN',163753,41.49,0.21,1550,76297,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17371',0.279991,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163754,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,'R',163754,33.51,0.49,50.3,76298,75,NULL,'IR','KUG 2335+047',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',NULL,NULL,'15.80',0.1,'Spiral',NULL,NULL,NULL,NULL,1,354.439083,5.03467,0.205,NULL,51590866307,806107286,12595426,15.8),(163755,'FP','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163755,36.31,0.48,183,76299,70,NULL,NULL,'MCG -06-51-015',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.00015,NULL,'15.17',0.62,'E',NULL,NULL,NULL,NULL,1,354.454333,-37.22642,NULL,NULL,49982010454,780968913,12202639,15.17),(163756,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163756,32.84,0.8,36.9,76300,75,NULL,'A82, H','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,1,6.83,NULL,'G',0.000003,NULL,'13.2',0.73,'Sb             LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,354.456125,-47.72736,NULL,NULL,48594091529,759282680,11863791,13.2),(163757,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163757,32.85,0.8,37.1,76300,75,NULL,'MAT, I','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163758,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163758,32.72,0.8,34.9,76300,75,NULL,NULL,'ESO 240- G 011',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163759,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163759,32.48,0.4,31.4,76300,73,NULL,'opt','ESO 240- G 011',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163760,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163760,32.56,0.47,32.6,76300,NULL,NULL,'Malmquist cor.','ESO 240- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163761,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163761,32.83,NULL,36.7,76300,NULL,NULL,NULL,'ESO 240- G 011',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163762,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163762,32.84,0.42,37,76300,NULL,NULL,NULL,'ESO 240- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163763,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163763,32.93,0.43,38.5,76300,75,NULL,'MAT, I, raw','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163764,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163764,32.94,NULL,38.7,76300,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 240- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163765,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163765,32.95,NULL,38.9,76300,NULL,NULL,'Dipole + Quadrupole','ESO 240- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163766,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163766,32.96,NULL,39.1,76300,NULL,NULL,'Dipole','ESO 240- G 011',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163767,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163767,33.08,0.35,41.3,76300,NULL,NULL,NULL,'ESO 240- G 011',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163768,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:24','1',NULL,NULL,163768,33.11,0.43,41.8,76300,75,NULL,'MAT, I, cor','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163769,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163769,33.15,0.2,42.7,76300,74.4,NULL,NULL,'ESO 240- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163770,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163770,33.2,0.32,43.7,76300,85,NULL,'I, raw','ESO 240- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163771,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163771,33.23,0.43,44.3,76300,75,NULL,'MAT, I, inv','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163772,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163772,33.28,0.32,45.2,76300,85,NULL,'I, inv','ESO 240- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163773,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163773,33.5,0.47,50,76300,75,NULL,'A82, H, raw','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163774,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163774,33.6,0.43,52.4,76300,75,NULL,'3.6 micron, color corrected','ESO 240- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163775,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163775,33.75,0.47,56.2,76300,75,NULL,'A82, H, inv','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163776,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163776,33.75,0.43,56.3,76300,75,NULL,'3.6 micron, color + selection bias corrected','ESO 240- G 011',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163777,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163777,33.83,0.47,58.2,76300,75,NULL,'A82, H, cor','ESO 240- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163778,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01533','RN',163778,38.94,0.24,536,76301,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 01533',0.144474,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163779,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01533','RN',163779,39.19,0.5,603,76301,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 01533',0.144474,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163780,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163780,33.62,0.69,52.9,76302,100,NULL,'mid-IR','MCG -01-60-015',NULL,'2013ApJ...771...88L',2013,1,1.4,NULL,'G',0.000027,NULL,'14.58',0.6,'SAB(rs)0+?     HII',NULL,NULL,NULL,NULL,1,354.4672917,-3.49072,0.081,NULL,49444625948,772572280,12071441,14.58),(163781,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163781,36.78,0.88,227,76303,70,NULL,NULL,'2MASX J23375668-8423510',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.2b',NULL,NULL,NULL,NULL,NULL,NULL,1,354.4862917,-84.39758,0.437,NULL,48377223455,755894116,11810845,17.2),(163782,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163782,35.39,0.25,120,76304,74.4,NULL,NULL,'GIN 721',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000043,NULL,'14.32',NULL,'SB0','Group member',NULL,NULL,NULL,1,354.490875,27.26442,0.181,NULL,51993923658,812405057,12693829,14.32),(163783,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163783,35.59,0.11,131,76304,70,NULL,NULL,'GIN 721',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163784,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15505',NULL,163784,40.92,0.33,1530,76305,70,NULL,'SN photometric redshift distance, z photo =0.453 +/- 0.103','SDSS-II SN 15505',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.493375,-0.88436,0.089,NULL,49451292186,772676440,12073069,NULL),(163785,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163785,40.03,0.14,792,76306,74.2,NULL,'SALT 2','SDSS J233759.60+003828.0',0.28,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',0.005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,354.498333,0.64111,0.125,NULL,51594319499,806161242,12596269,NULL),(163786,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163786,40.06,0.14,1030,76306,70,NULL,'Hubble residual 0.00 for z0.27700','SDSS J233759.60+003828.0',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163787,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163787,40.75,0.12,1100,76306,65,NULL,'SALT2','SDSS J233759.60+003828.0',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163788,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163788,40.75,0.17,1100,76306,70,NULL,'SALT 2','SDSS J233759.60+003828.0',0.28,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163789,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04046','R',163789,40.8,0.24,1130,76306,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gw','SDSS J233759.60+003828.0',0.277,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163790,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04046','R',163790,40.83,0.16,1150,76306,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gw','SDSS J233759.60+003828.0',0.277,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163791,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2005gw',NULL,163791,40.96,0.14,1210,76306,65,NULL,'MLCS2k2','SDSS J233759.60+003828.0',0.28,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163792,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163792,35.55,0.1,129,76307,NULL,NULL,NULL,'CGCG 476-083',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',0.000123,NULL,'15.4',0.3,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.5005,26.45944,0.145,NULL,52008278264,812629347,12697333,15.4),(163793,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163793,37.26,0.17,284,76308,70,NULL,NULL,'2MASX J23380105+1554022',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000219,NULL,'15.8g',0.46,'E0',NULL,NULL,NULL,NULL,1,354.504291667,15.90044,0.077,NULL,51669366638,807333853,12614591,15.8),(163794,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19667','RN',163794,43.38,0.28,2940,76309,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19667',0.614351,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163795,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163795,35.58,0.13,131,76310,NULL,NULL,NULL,'2MASX J23380480+2646098',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.000027,NULL,'16.72',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.520041667,26.76933,0.145,NULL,52007996867,812624951,12697264,16.72),(163796,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163796,35.7,0.43,138,76310,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J23380480+2646098',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163797,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163797,35.93,0.43,153,76310,75,NULL,'3.6 micron, color corrected','2MASX J23380480+2646098',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163798,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163798,36.2,0.2,174,76310,74.4,NULL,NULL,'2MASX J23380480+2646098',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163799,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163799,34.87,0.69,94.3,76311,100,NULL,'mid-IR','NGC 7718',NULL,'2013ApJ...771...88L',2013,1,0.9,NULL,'G',0.000113,NULL,'15.01',0.6,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.520875,25.71972,0.077,NULL,51999622582,812494102,12695220,15.01),(163800,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163800,35.65,0.4,135,76311,NULL,NULL,'mean','NGC 7718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163801,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163801,36.19,0.45,173,76311,NULL,NULL,'K','NGC 7718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163802,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163802,36.22,0.47,175,76311,NULL,NULL,'H','NGC 7718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163803,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163803,36.3,0.46,182,76311,NULL,NULL,'J','NGC 7718',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163804,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163804,37.26,0.17,284,76312,70,NULL,NULL,'2MASX J23380512+1527292',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000237,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,354.5215417,15.45811,0.085,NULL,51667179215,807299675,12614057,16.9),(163805,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163805,35.13,NULL,106,76313,NULL,NULL,NULL,'FGC 2519',NULL,'2000BSAO...50....5K',2000,1,1.01,NULL,'G',NULL,NULL,'17.23',0.11,'Scd',NULL,NULL,NULL,NULL,1,354.5284583,32.35656,0.237,NULL,52039519944,813117499,12704960,17.23),(163806,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163806,35.18,NULL,109,76313,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163807,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163807,35.18,NULL,109,76313,NULL,NULL,'Dipole + Quadrupole','FGC 2519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163808,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163808,35.19,NULL,109,76313,NULL,NULL,'Dipole','FGC 2519',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163809,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163809,37.26,0.17,284,76314,70,NULL,NULL,'2MASX J23380845+1547202',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000148,NULL,'18.0g',0.13,NULL,NULL,NULL,NULL,NULL,1,354.535333,15.78892,0.077,NULL,51669340895,807333451,12614585,18),(163810,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163810,37,0.46,252,76315,70,NULL,NULL,'2MASX J23381051-0916590',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000103,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,354.543833333,-9.283,0.06,NULL,49621666897,775338545,12114664,16.9),(163811,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20183',NULL,163811,39.07,0.84,653,76316,70,NULL,'SN photometric redshift distance, z photo =0.166 +/- 0.090','SDSS-II SN 20183',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.546375,1.25039,0.125,NULL,51594699005,806167171,12596362,NULL),(163812,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163812,35.17,0.25,108,76317,74.4,NULL,NULL,'2MASX J23381247+2629398',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000123,NULL,'15.98',0.3,'S0',NULL,NULL,NULL,NULL,1,354.5520417,26.49433,0.145,NULL,52008103123,812626611,12697290,15.98),(163813,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163813,33.94,0.8,61.2,76318,75,NULL,'W91PP, r','UGC 12714',NULL,'1997ApJS..109..333W',1997,1,2.13,NULL,'G',0.000011,NULL,'15.43',0.28,'Sc',NULL,NULL,NULL,NULL,1,354.554333,32.33508,0.237,NULL,52039516690,813117448,12704960,15.43),(163814,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163814,33.97,0.49,62.3,76318,75,NULL,'IR','UGC 12714',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163815,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163815,34.05,0.2,64.6,76318,74.4,NULL,NULL,'UGC 12714',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163816,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163816,34.11,NULL,66.3,76318,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163817,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163817,34.11,NULL,66.3,76318,NULL,NULL,'Dipole','UGC 12714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163818,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163818,34.12,NULL,66.7,76318,NULL,NULL,'Dipole + Quadrupole','UGC 12714',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163819,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163819,34.18,NULL,68.5,76318,NULL,NULL,NULL,'UGC 12714',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163820,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163820,34.24,0.37,70.4,76318,NULL,NULL,NULL,'UGC 12714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163821,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163821,34.27,0.38,71.4,76318,75,NULL,'W91PP, r, raw','UGC 12714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163822,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163822,34.32,0.38,73.1,76318,75,NULL,'W91PP, r, inv','UGC 12714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163823,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163823,34.46,0.38,78,76318,75,NULL,'W91PP, r, cor','UGC 12714',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163824,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163824,34.47,0.33,78.3,76318,NULL,NULL,'Malmquist cor.','UGC 12714',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163825,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15365','R',163825,39.89,0.18,800,76319,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006ku','SDSS J233813.59+011456.6',0.19,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',NULL,NULL,'19.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,354.556667,1.24906,0.125,NULL,51594875058,806169922,12596405,19.2),(163826,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15365','R',163826,40.14,0.1,895,76319,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006ku','SDSS J233813.59+011456.6',0.19,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163827,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006ku',NULL,163827,39.84,0.08,929,76319,70,NULL,'SALT 2','SDSS J233813.59+011456.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163828,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006ku',NULL,163828,39.85,0.08,933,76319,70,NULL,'SALT 2, Malmquist cor.','SDSS J233813.59+011456.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163829,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163829,35.6,0.25,132,76320,74.4,NULL,NULL,'2MASX J23381367+2724518',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000077,NULL,'15.68',NULL,'Elliptical','Group member',NULL,NULL,NULL,1,354.556917,27.41433,0.161,NULL,51993921552,812405024,12693828,15.68),(163830,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163830,34.68,0.2,86.3,76321,74.4,NULL,NULL,'CGCG 407-030',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00011,NULL,'15.3',0.3,NULL,NULL,NULL,NULL,NULL,1,354.5610417,7.80842,0.233,NULL,51785910687,809154854,12643044,15.3),(163831,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163831,29.19,0.4,6.9,76322,75,NULL,'B','UGC 12713',NULL,'1988NBGC.C....0000T',1988,1,1,NULL,'G',0.000017,NULL,'14.8',0.6,'S0/a',NULL,NULL,NULL,NULL,1,354.561417,30.70922,0.241,NULL,52038336148,813099002,12704671,14.8),(163832,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163832,30.43,NULL,12.2,76322,NULL,NULL,NULL,'UGC 12713',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163833,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163833,37.26,0.17,284,76323,70,NULL,NULL,'2MASX J23381769+1540081',NULL,'2015arXiv151105856S',2015,1,0.63,NULL,'G',0.000188,NULL,'15.6g',0.49,'E0',NULL,NULL,NULL,NULL,1,354.5735417,15.66892,0.077,NULL,51669209543,807331399,12614553,15.6),(163834,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206',NULL,163834,39.95,0.32,979,76324,70,NULL,'SN photometric redshift distance, z photo =0.262 +/- 0.049','SDSS-II SN 04206',NULL,'2011ApJ...738..162S',2011,1,0.1,NULL,'G',NULL,'PHOT','20.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.577208333,-0.48653,0.113,NULL,49451097189,772673393,12073021,20.6),(163835,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206','R',163835,40.77,0.27,1100,76324,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 04206',0.290675,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163836,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206','R',163836,40.99,0.24,1220,76324,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 04206',0.290675,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163837,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206',NULL,163837,40.54,0.18,1280,76324,70,NULL,'SALT 2','SDSS-II SN 04206',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163838,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04206',NULL,163838,40.57,0.18,1300,76324,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 04206',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163839,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163839,35.59,0.11,131,76325,70,NULL,NULL,'CGCG 476-085',NULL,'2001MNRAS.321..277C',2001,1,0.54,NULL,'G',0.000083,NULL,'14.26',0.45,'E','Group member',NULL,NULL,NULL,1,354.577041667,26.88692,0.145,NULL,52008047802,812625746,12697277,14.26),(163840,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163840,35.93,0.22,153,76325,74.4,NULL,NULL,'CGCG 476-085',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163841,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163841,36.02,0.23,160,76326,74.4,NULL,NULL,'2MASX J23381860+2702066',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000073,NULL,'17.01',0.2,'E','Group member',NULL,NULL,NULL,1,354.5775417,27.03528,0.181,NULL,52008040277,812625629,12697275,17.01),(163842,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163842,35.69,0.25,137,76327,74.4,NULL,NULL,'2MASX J23382069+2703026',NULL,'2013AJ....146...86T',2013,1,0.35,NULL,'G',0.000067,NULL,'16.70',0.25,'S0/a','Group member',NULL,NULL,NULL,1,354.586167,27.05083,0.181,NULL,52008039471,812625616,12697275,16.7),(163843,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163843,37.96,0.46,390,76328,70,NULL,NULL,'2MASX J23382194-0015085',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000082,NULL,'16.8g',0.3,NULL,NULL,NULL,NULL,NULL,1,354.591333,-0.25228,0.101,NULL,49450884322,772670067,12072969,16.8),(163844,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163844,35.38,0.22,119,76329,74.4,NULL,NULL,'CGCG 476-086',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.000073,NULL,'14.19',0.5,'E','Group member',NULL,NULL,NULL,1,354.595333,27.15772,0.161,NULL,51993942032,812405344,12693833,14.19),(163845,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163845,35.59,0.11,131,76329,70,NULL,NULL,'CGCG 476-086',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163846,'BCG','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163846,35.74,0.35,136,76330,60,NULL,NULL,'ABELL 2634',0.0315,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000274,NULL,NULL,NULL,'II:    [BM]',NULL,NULL,NULL,NULL,1,354.607083,27.0125,0.181,NULL,52008037019,812625578,12697274,NULL),(163847,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163847,35.54,0.22,128,76331,74.4,NULL,NULL,'IC 5341',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.00005,NULL,'15.20',0.2,'S0/D','Group member',NULL,NULL,NULL,1,354.61175,26.98511,0.145,NULL,52008043704,812625682,12697276,15.2),(163848,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163848,35.59,0.11,131,76331,70,NULL,NULL,'IC 5341',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163849,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163849,34.19,0.2,68.9,76332,74.4,NULL,NULL,'IC 1503',NULL,'2013AJ....146...86T',2013,1,0.9,'Contains the probable HII region UM 001.','G',0.00002,NULL,'14.34',0.4,'Sdm:','Brightest group member',NULL,NULL,NULL,1,354.6129583,4.80142,0.209,NULL,51590411222,806100175,12595315,14.34),(163850,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163850,34.21,0.42,69.6,76332,NULL,NULL,NULL,'IC 1503',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163851,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163851,34.27,0.4,71.6,76332,NULL,NULL,'Malmquist cor.','IC 1503',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163852,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163852,34.42,0.25,76.6,76333,74.4,NULL,NULL,'CGCG 476-089',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.00006,NULL,'15.22',0.4,'Elliptical','Group member',NULL,NULL,NULL,1,354.61925,26.81856,0.145,NULL,52008000427,812625006,12697265,15.22),(163853,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163853,35.55,0.22,129,76334,74.4,NULL,NULL,'CGCG 476-090',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.00004,NULL,'15.20',NULL,'E','Group member',NULL,NULL,NULL,1,354.62225,26.97836,0.145,NULL,52008044457,812625694,12697276,15.2),(163854,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163854,35.59,0.11,131,76334,70,NULL,NULL,'CGCG 476-090',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163855,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163855,37.26,0.17,284,76335,70,NULL,NULL,'2MASX J23382932+1600063',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000168,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,354.622167,16.00178,0.077,NULL,51669282367,807332536,12614570,17.3),(163856,'BCG','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163856,35.74,0.35,136,76336,60,NULL,'ABELL 2634, BCG','NGC 7720 NED01',0.0315,'1980ApJ...241..486H',1980,1,1.6,NULL,'G',0.00014,NULL,'13.90',1.3,'E;BrClG','Pair member (points to parent)',NULL,NULL,NULL,1,354.6225,27.03147,0.161,NULL,52008038245,812625597,12697274,13.9),(163857,'D-Sigma','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163857,34.87,0.4,94.2,76337,75,NULL,'Edat, raw','NGC 7720',NULL,'1997ApJS..109..333W',1997,1,NULL,'RC3 has V = 8712 +- 18 km/sec.','GPair',0.000047,NULL,NULL,NULL,'cD;E+ pec:     LERG','in a radial-velocity based grouping',NULL,'FR I','Flat-Spectrum Radio Source',1,354.6224583,27.03144,0.161,NULL,52008038245,812625597,12697274,NULL),(163858,'D-Sigma','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163858,35.21,0.4,110,76337,75,NULL,'Edat, cor','NGC 7720',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163859,'D-Sigma','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163859,35.36,0.12,118,76337,70,NULL,'ABELL 2634','NGC 7720',NULL,'1997MNRAS.287..899L',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163860,'D-Sigma','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163860,35.87,0.13,149,76337,72,NULL,'ABELL 2634 Cluster, 12 galaxies','NGC 7720',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163861,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163861,34.31,0.46,72.8,76337,95,NULL,'Michard 1979a','NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163862,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163862,34.58,0.34,82.4,76337,95,NULL,'Weighted Mean','NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163863,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163863,35,0.63,100,76337,95,NULL,'Michard 1979b, c','NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163864,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163864,35.36,0.52,118,76337,95,NULL,'de Vaucouleurs','NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163865,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163865,35.47,0.23,124,76337,74.4,NULL,NULL,'NGC 7720',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163866,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163866,35.59,0.11,131,76337,70,NULL,NULL,'NGC 7720',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163867,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163867,35.65,0.07,135,76337,75,NULL,'ABELL 2634 Cluster, 35 galaxies','NGC 7720',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163868,'Tertiary','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163868,34.91,0.5,95.9,76337,95,NULL,NULL,'NGC 7720',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163869,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163869,35.23,0.36,111,76337,77,NULL,'ABELL 2634 Cluster, 16 galaxies','NGC 7720',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163870,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163870,35.23,NULL,111,76337,77,NULL,'BRIK, ABELL 2634 cluster, 16 galaxies','NGC 7720',NULL,'2000ApJ...533..744T',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163871,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163871,35.24,0.13,112,76337,75,NULL,'ABELL 2634 cluster, avg. of 18 spiral galaxies','NGC 7720',NULL,'2013ApJ...765...94S',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163872,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163872,35.28,0.12,114,76337,75,NULL,'ABELL 2634 cluster, avg. of 18 spiral galaxies','NGC 7720',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163873,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163873,35.3,NULL,115,76337,71,NULL,'ABELL 2634, 79 galaxies','NGC 7720',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163874,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163874,35.32,0.06,116,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE W2 (4.6 micro-meter), curved','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163875,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163875,35.32,0.06,116,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE W1 (3.4 micro-meter), curved','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163876,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163876,35.32,0.45,116,76337,NULL,NULL,'K','NGC 7720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163877,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163877,35.33,0.12,117,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE W2 (4.6 micro-meter), color corrected','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163878,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163878,35.34,0.12,117,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE W1 (3.4 micro-meter), color corrected','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163879,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163879,35.35,0.12,117,76337,74.4,NULL,'ABELL 2634, 21 galaxies, WISE I-band','NGC 7720',NULL,'2014ApJ...792..129N',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163880,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163880,35.36,0.3,118,76337,NULL,NULL,'ABELL 2634, 20 galaxies','NGC 7720',NULL,'2000ApJ...529..698S',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163881,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163881,35.41,0.13,121,76337,75,NULL,'ABELL 2634 CLUSTER','NGC 7720',NULL,'2012ApJ...749...78T',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163882,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163882,35.54,0.15,128,76337,70,NULL,'ABELL 2634 Cluster','NGC 7720',NULL,'1992ApJ...396..453H',1990,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163883,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163883,35.6,0.4,132,76337,NULL,NULL,'mean','NGC 7720',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163884,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163884,35.43,0.25,122,76338,74.4,NULL,NULL,'NGC 7720 NED02',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00005,NULL,'15.00',0.6,'E','Pair member (points to parent)',NULL,NULL,NULL,1,354.623083333,27.03475,0.161,NULL,52008037976,812625593,12697274,15),(163885,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13131','RN',163885,40.74,0.19,1220,76339,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13131',0.158047,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163886,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13131','RN',163886,41.23,0.24,1520,76339,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13131',0.158047,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163887,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163887,35.99,0.25,158,76340,74.4,NULL,NULL,'2MASX J23383327+2702057',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000083,NULL,'14.17',NULL,'E','Group member',NULL,NULL,NULL,1,354.638625,27.03489,0.161,NULL,52008038026,812625594,12697274,14.17),(163888,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 02549','RN',163888,41.54,0.16,1710,76341,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02549',0.18932,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163889,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 02549','RN',163889,41.74,0.21,1870,76341,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02549',0.18932,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163890,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163890,35.88,0.23,150,76342,74.4,NULL,NULL,'CGCG 476-092',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.000103,NULL,'16.42',0.3,'S0','Group member',NULL,NULL,NULL,1,354.643375,26.97939,0.145,NULL,52008043886,812625685,12697276,16.42),(163891,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163891,35.43,0.68,122,76343,70,NULL,NULL,'AM 2335-782',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'14.9R',0.33,NULL,NULL,NULL,NULL,NULL,1,354.64525,-78.08614,0.261,NULL,48422661304,756604082,11821938,14.9),(163892,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15241','RN',163892,39.79,0.12,876,76344,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15241',0.035645,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163893,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163893,35.57,0.22,130,76345,74.4,NULL,NULL,'IC 5342',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.00008,NULL,'15.29',0.3,'E:','Group member',NULL,NULL,NULL,1,354.661667,27.01136,0.145,NULL,52008042859,812625669,12697276,15.29),(163894,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163894,35.59,0.11,131,76345,70,NULL,NULL,'IC 5342',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163895,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163895,35.85,0.23,148,76345,74.4,NULL,NULL,'IC 5342',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163896,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163896,35.69,0.23,137,76346,74.4,NULL,NULL,'2MASX J23384202+2707076',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000157,NULL,'16.67',0.2,'S0','Group member',NULL,NULL,NULL,1,354.6752083,27.11875,0.161,NULL,52007818332,812622161,12697221,16.67),(163897,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163897,35.6,0.4,132,76347,NULL,NULL,'mean','CGCG 476-095',NULL,'2007A&A...465...71T',2007,1,0.76,NULL,'G',0.00012,NULL,'15.5',0.44,'S0','Group member',NULL,NULL,NULL,1,354.681875,27.21542,0.161,NULL,52007821355,812622208,12697222,15.5),(163898,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163898,35.95,0.45,155,76347,NULL,NULL,'K','CGCG 476-095',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163899,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163899,35.59,0.49,131,76348,70,NULL,NULL,'MCG +00-60-025',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.000097,NULL,'15',0.4,NULL,NULL,NULL,NULL,NULL,1,354.6832083,-1.47203,0.137,NULL,49454560661,772727510,12073867,15),(163900,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163900,35.75,0.25,141,76349,74.4,NULL,NULL,'2MASX J23384418+2651026',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00015,NULL,'15.88',0.4,'Elliptical','Group member',NULL,NULL,NULL,1,354.684125,26.85081,0.145,NULL,52007969716,812624526,12697258,15.88),(163901,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163901,35.45,0.25,123,76350,74.4,NULL,NULL,'2MASX J23384623+2710206',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000053,NULL,'16.51',0.2,'S0','Group member',NULL,NULL,NULL,1,354.692625,27.17242,0.161,NULL,52007855849,812622747,12697230,16.51),(163902,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00863','RN',163902,39.79,0.18,828,76351,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 00863',0.094283,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163903,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00863','RN',163903,40.4,0.28,1100,76351,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 00863',0.094283,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163904,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2007le',NULL,163904,32.24,0.01,28,76352,72,NULL,'M(H) = -18.317 mag','NGC 7721',NULL,'2014ApJ...784..105W',2013,1,3.5,'HOLM 812B is a star.','G',0.00001,NULL,'12.22',1.4,'SA(s)c','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.7027083,-6.51786,0.065,NULL,49615410505,775240789,12113137,12.22),(163905,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163905,32.03,0.8,25.4,76352,75,NULL,'A82, H','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163906,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163906,32.03,0.8,25.4,76352,75,NULL,'MAT, I','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163907,'Sosies','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163907,32.19,0.11,27.4,76352,NULL,NULL,NULL,'NGC 7721',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163908,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163908,31.19,0.4,17.3,76352,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7721',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163909,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163909,31.2,0.4,17.3,76352,NULL,NULL,'mean','NGC 7721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163910,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163910,31.42,0.38,19.2,76352,NULL,NULL,NULL,'NGC 7721',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163911,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163911,31.42,0.39,19.2,76352,73,NULL,'opt','NGC 7721',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163912,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163912,31.41,0.43,19.2,76352,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163913,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163913,31.44,0.43,19.4,76352,75,NULL,'3.6 micron, color corrected','NGC 7721',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163914,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163914,31.47,0.32,19.7,76352,85,NULL,'I, raw','NGC 7721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163915,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163915,31.49,0.32,19.9,76352,85,NULL,'I, inv','NGC 7721',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163916,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163916,31.53,0.46,20.2,76352,NULL,NULL,'J','NGC 7721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163917,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163917,31.55,0.2,20.4,76352,74.4,NULL,NULL,'NGC 7721',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163918,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163918,31.6,0.43,20.9,76352,75,NULL,'MAT, I, raw','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163919,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163919,31.61,0.47,21,76352,NULL,NULL,'H','NGC 7721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163920,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163920,31.67,0.47,21.6,76352,75,NULL,'A82, H, raw','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163921,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163921,31.68,0.45,21.7,76352,NULL,NULL,'K','NGC 7721',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163922,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163922,31.73,0.48,22.2,76352,NULL,NULL,'Malmquist cor.','NGC 7721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163923,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163923,31.74,0.47,22.3,76352,75,NULL,'A82, H, inv','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163924,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163924,31.76,0.43,22.5,76352,75,NULL,'MAT, I, inv','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163925,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163925,31.8,0.46,22.9,76352,NULL,NULL,NULL,'NGC 7721',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163926,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163926,31.84,0.43,23.3,76352,75,NULL,'MAT, I, cor','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163927,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163927,31.95,0.47,24.5,76352,75,NULL,'A82, H, cor','NGC 7721',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163928,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163928,32.08,0.4,26.1,76352,75,NULL,'B','NGC 7721',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163929,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163929,32.44,0.43,30.8,76353,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-60-016',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000021,NULL,'15.39',0.7,'SB(s)m:','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.703583,-5.74667,0.072,NULL,49434294875,772410857,12068919,15.39),(163930,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163930,35.8,0.23,145,76354,74.4,NULL,NULL,'2MASX J23384921+2707228',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000167,NULL,'16.80',0.1,'S0','Group member',NULL,NULL,NULL,1,354.705167,27.12303,0.161,NULL,52007848899,812622639,12697228,16.8),(163931,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','PTF09gce','N',163931,37.09,0.07,248,76355,70,NULL,'SiFTO, M(B) = -19.210 mag, Alpha = 1.45, Beta = 3.21','PTF09gce',0.0575,'2014MNRAS.438.1391P',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163932,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20988','RN',163932,43.22,0.37,2840,76356,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20988',0.554885,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163933,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163933,35.34,0.23,117,76357,74.4,NULL,NULL,'CGCG 476-096',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000047,NULL,'14.79',NULL,'E/S0','Group member',NULL,NULL,NULL,1,354.710875,27.26772,0.161,NULL,51993915139,812404924,12693826,14.79),(163934,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163934,35.59,0.11,131,76357,70,NULL,NULL,'CGCG 476-096',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163935,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 21413',NULL,163935,41.04,0.14,1620,76358,70,NULL,'SN photometric redshift distance, z photo =0.488 +/- 0.044','SDSS-II SN 21413',NULL,'2011ApJ...738..162S',2011,1,0.03,NULL,'G',NULL,'PHOT','22.4g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.7157917,0.83994,0.125,NULL,51595006518,806171976,12596437,22.4),(163936,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 21413','R',163936,42.03,0.26,1750,76358,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 21413',0.456731,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163937,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163937,35.04,0.23,102,76359,74.4,NULL,NULL,'2MASX J23385395+2702449',NULL,'2013AJ....146...86T',2013,1,0.32,NULL,'G',0.00008,NULL,'16.84',0.25,'S0','Group member',NULL,NULL,NULL,1,354.7247083,27.046,0.161,NULL,52007838094,812622470,12697226,16.84),(163938,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15362','R',163938,38.64,0.14,472,76360,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 15362',0.134188,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,354.73,0.76058,0.113,NULL,51595119074,806173735,12596464,NULL),(163939,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15362','R',163939,39.11,0.21,584,76360,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 15362',0.134188,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163940,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163940,35.25,0.23,112,76361,74.4,NULL,NULL,'2MASX J23385625+2709419',NULL,'2013AJ....146...86T',2013,1,0.3,NULL,'G',0.000107,NULL,'16.34',0.3,'S0','Group member',NULL,NULL,NULL,1,354.734333,27.16169,0.161,NULL,52007859965,812622811,12697231,16.34),(163941,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163941,37.26,0.17,284,76362,70,NULL,NULL,'2MASX J23385655+1525083',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000185,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,354.73575,15.41906,0.069,NULL,51667308824,807301700,12614089,17.2),(163942,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05473','R',163942,40.79,0.23,1130,76363,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J233856.79+002300.0',0.28,'2014arXiv1401.3317S',2014,1,0.1,NULL,'G',0.01,NULL,'20.4g',0.06,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,354.736667,0.38336,0.117,NULL,51594232801,806159887,12596248,20.4),(163943,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05473','R',163943,41.07,0.2,1280,76363,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J233856.79+002300.0',0.28,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163944,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05473',NULL,163944,40.69,0.14,1370,76363,70,NULL,'SALT 2','SDSS J233856.79+002300.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163945,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05473',NULL,163945,40.72,0.14,1390,76363,70,NULL,'SALT 2, Malmquist cor.','SDSS J233856.79+002300.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163946,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1975N',NULL,163946,32,0.02,25.1,76364,66,NULL,NULL,'NGC 7723',NULL,'1994A&A...281...51M',1994,1,3.5,NULL,'G',0.000027,NULL,'11.94',2.3,'SB(r)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.737833333,-12.96108,0.083,NULL,49580538873,774695919,12104623,11.94),(163947,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1975N',NULL,163947,32.2,0.48,28,76364,67,NULL,NULL,'NGC 7723',NULL,'1996ApJ...457..500H',1996,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163948,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1975N','R',163948,32.95,NULL,38.9,76364,NULL,NULL,'Photographic','NGC 7723',NULL,'1988SSRv...48....1R',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163949,'Ring Diameter','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163949,32.4,0.84,30,76364,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7723',NULL,'1981ApJS...45..541P',1981,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163950,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163950,31.87,0.8,23.6,76364,75,NULL,'MAT, I','NGC 7723',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163951,'Sosies','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163951,31.95,0.24,24.5,76364,NULL,NULL,NULL,'NGC 7723',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163952,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163952,31.88,0.8,23.7,76364,75,NULL,'B','NGC 7723',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163953,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163953,31.39,0.69,19,76364,100,NULL,'mid-IR','NGC 7723',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163954,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163954,31.92,NULL,24.2,76364,NULL,NULL,'B','NGC 7723',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163955,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163955,32.07,0.32,26,76364,85,NULL,'I, raw','NGC 7723',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163956,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163956,32.08,0.43,26.1,76364,75,NULL,'MAT, I, raw','NGC 7723',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163957,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163957,32.14,0.32,26.8,76364,85,NULL,'I, inv','NGC 7723',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163958,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163958,32.15,0.4,26.9,76364,NULL,NULL,NULL,'NGC 7723',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163959,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163959,32.15,0.4,26.9,76364,73,NULL,'opt','NGC 7723',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163960,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163960,32.15,0.46,27,76364,NULL,NULL,'J','NGC 7723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163961,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163961,32.17,0.45,27.1,76364,NULL,NULL,'K','NGC 7723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163962,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163962,32.23,0.47,27.9,76364,NULL,NULL,'H','NGC 7723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163963,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163963,32.26,0.43,28.4,76364,75,NULL,'MAT, I, cor','NGC 7723',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163964,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163964,32.28,0.4,28.6,76364,NULL,NULL,'mean','NGC 7723',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163965,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163965,32.34,0.43,29.4,76364,75,NULL,'MAT, I, inv','NGC 7723',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163966,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163966,32.36,0.43,29.6,76364,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7723',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163967,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163967,32.36,0.43,29.7,76364,75,NULL,'3.6 micron, color corrected','NGC 7723',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163968,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163968,32.46,0.39,31.1,76364,73,NULL,'opt','NGC 7723',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163969,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163969,32.51,0.2,31.8,76364,74.4,NULL,NULL,'NGC 7723',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163970,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163970,32.55,0.46,32.4,76364,NULL,NULL,'Malmquist cor.','NGC 7723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163971,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163971,32.76,0.42,35.7,76364,NULL,NULL,NULL,'NGC 7723',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163972,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163972,34.94,0.49,97.5,76365,75,NULL,'IR','FGC 2521',NULL,'2011yCatp016004901K',2011,1,0.83,NULL,'G',NULL,NULL,'16.7',0.1,'Scd',NULL,NULL,NULL,NULL,1,354.751416667,49.59244,0.977,NULL,53160956391,830639943,12978749,16.7),(163973,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163973,35.32,NULL,116,76365,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2521',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163974,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163974,35.34,NULL,117,76365,NULL,NULL,'Dipole + Quadrupole','FGC 2521',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163975,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163975,35.35,NULL,117,76365,NULL,NULL,'Dipole','FGC 2521',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163976,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163976,35.37,NULL,119,76365,NULL,NULL,NULL,'FGC 2521',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163977,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 06712','RN',163977,40.35,0.2,1080,76366,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 06712',0.09184,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163978,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 06712','RN',163978,41.09,0.26,1510,76366,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 06712',0.09184,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163979,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163979,36.47,0.25,197,76367,74.4,NULL,NULL,'2MASX J23390270+2706099',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000113,NULL,'14.53',0.5,'E','Group member',NULL,NULL,NULL,1,354.7612083,27.10272,0.161,NULL,52007847538,812622617,12697228,14.53),(163980,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18610','RN',163980,40.13,0.09,941,76368,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18610',0.129113,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163981,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18610','RN',163981,40.38,0.18,1060,76368,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18610',0.129113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163982,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163982,34.28,0.49,71.6,76369,75,NULL,'IR','ESO 605- G 022',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.45',0.3,'Sb',NULL,NULL,NULL,NULL,1,354.7665,-20.81614,0.056,NULL,50278058730,785594667,12274916,15.45),(163983,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163983,34.28,0.84,71.7,76369,NULL,NULL,'Malmquist cor.','ESO 605- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163984,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163984,34.31,0.82,72.9,76369,NULL,NULL,NULL,'ESO 605- G 022',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163985,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163985,34.35,0.2,74.1,76369,74.4,NULL,NULL,'ESO 605- G 022',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163986,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163986,35.55,0.12,129,76370,NULL,NULL,NULL,'AGC 330714',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.000053,NULL,'16.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,354.774583,26.58028,0.145,NULL,52008068873,812626076,12697282,16),(163987,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163987,32.34,0.4,29.4,76371,NULL,NULL,'mean','NGC 7724',NULL,'2007A&A...465...71T',2007,1,1.4,NULL,'G',0.00003,NULL,'13.90',1,'(R\')SB(r)b pec?','Pair member (points to parent)',NULL,NULL,NULL,1,354.779833,-12.22406,0.098,NULL,49577580440,774649694,12103901,13.9),(163988,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163988,33.01,0.45,39.9,76371,NULL,NULL,'K','NGC 7724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163989,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163989,33.01,0.46,40.1,76371,NULL,NULL,'J','NGC 7724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163990,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163990,33.07,0.47,41.1,76371,NULL,NULL,'H','NGC 7724',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163991,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163991,34.3,0.46,72.3,76372,70,NULL,NULL,'CGCG 381-019',NULL,'2015arXiv151105856S',2015,1,0.81,NULL,'G',0.000067,NULL,'15.1g',0.41,'S0',NULL,NULL,NULL,NULL,1,354.786,0.46347,0.117,NULL,51594248116,806160126,12596251,15.1),(163992,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163992,35.38,0.13,119,76373,NULL,NULL,NULL,'2MASX J23390982+2641350',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000017,NULL,'17.32',0.2,'Sc','Group member',NULL,NULL,NULL,1,354.790917,26.69314,0.145,NULL,52007937629,812624025,12697250,17.32),(163993,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',163993,34.21,0.49,69.4,76374,75,NULL,'IR','UGC 12720',NULL,'2011yCatp016004901K',2011,1,1.1,NULL,'G',0.000033,NULL,'15.23',0.2,'S?',NULL,NULL,NULL,NULL,1,354.7964583,5.48444,0.229,NULL,51590126482,806095726,12595245,15.23),(163994,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163994,34.3,0.2,72.4,76375,74.4,NULL,NULL,'UGC 12720',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000033,NULL,'15.23',0.2,'S?',NULL,NULL,NULL,NULL,1,354.7964583,5.48444,0.229,NULL,51590126482,806095726,12595245,15.23),(163995,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163995,35.01,0.8,100,76376,75,NULL,'W91PP, r','NGC 7726',NULL,'1997ApJS..109..333W',1997,1,1.5,'NGC identification is not certain.','G',0.000003,NULL,'15.04',0.5,'SB(s)b','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.799625,27.11533,0.161,NULL,52007841809,812622528,12697227,15.04),(163996,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163996,35.01,0.8,101,76376,75,NULL,'HMCL, I','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163997,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163997,35.01,0.8,101,76376,75,NULL,'W91CL, r','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163998,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163998,35.01,0.8,101,76376,75,NULL,'CF, r','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(163999,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,163999,34.42,0.69,76.7,76376,100,NULL,'mid-IR','NGC 7726',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164000,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164000,34.57,0.38,82.2,76376,75,NULL,'CF, r, raw','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164001,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164001,34.73,0.38,88.1,76376,75,NULL,'CF, r, inv','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164002,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164002,34.73,0.38,88.2,76376,75,NULL,'W91PP, r, raw','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164003,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164003,34.74,0.38,88.5,76376,75,NULL,'W91CL, r, raw','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164004,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164004,34.82,0.38,92,76376,75,NULL,'CF, r, cor','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164005,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164005,34.89,0.38,95,76376,75,NULL,'W91CL, r, inv','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164006,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164006,34.91,0.38,95.8,76376,75,NULL,'W91PP, r, inv','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164007,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164007,34.95,0.38,97.9,76376,75,NULL,'W91CL, r, cor','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164008,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164008,34.96,0.38,98.3,76376,75,NULL,'W91PP, r, cor','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164009,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164009,35.02,0.4,101,76376,75,NULL,'HMCL, I, raw','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164010,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164010,35.03,0.2,101,76376,74.4,NULL,NULL,'NGC 7726',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164011,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164011,35.04,0.43,102,76376,75,NULL,'3.6 micron, color corrected','NGC 7726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164012,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164012,35.1,0.4,105,76376,NULL,NULL,'mean','NGC 7726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164013,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164013,35.16,0.43,108,76376,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164014,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164014,35.17,0.47,108,76376,NULL,NULL,'H','NGC 7726',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164015,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164015,35.23,0.4,111,76376,75,NULL,'HMCL, I, inv','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164016,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164016,35.26,0.4,113,76376,75,NULL,'HMCL, I, cor','NGC 7726',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164017,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164017,35.67,0.07,136,76376,NULL,NULL,NULL,'NGC 7726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164018,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164018,35.5,0.11,126,76377,NULL,NULL,NULL,'2MASX J23391190+2709360',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000257,NULL,'16.51',0.7,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,354.799625,27.16006,0.161,NULL,52007852781,812622699,12697229,16.51),(164019,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354','R',164019,40.31,0.36,925,76378,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01354',0.249436,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,'PHOT','19.3g',0.1,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,354.8027083,0.09022,0.101,NULL,51548240017,805441250,12585019,19.3),(164020,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354',NULL,164020,40.1,0.27,1050,76378,70,NULL,'SN photometric redshift distance, z photo =0.283 +/- 0.046','SDSS-II SN 01354',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164021,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354','R',164021,40.59,0.27,1050,76378,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01354',0.249436,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164022,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354',NULL,164022,40.28,0.24,1140,76378,70,NULL,'SALT 2','SDSS-II SN 01354',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164023,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01354',NULL,164023,40.29,0.24,1140,76378,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01354',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164024,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164024,35.51,0.25,126,76379,74.4,NULL,NULL,'2MASX J23391340+2732550',NULL,'2013AJ....146...86T',2013,1,0.5,NULL,'G',0.00008,NULL,'15.43',0.4,'E',NULL,NULL,NULL,NULL,1,354.806,27.54858,0.173,NULL,51995797174,812434330,12694286,15.43),(164025,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164025,37.56,0.33,326,76380,70,NULL,NULL,'2MASX J23391478-0026459',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000092,NULL,'16.3g',0.36,NULL,NULL,NULL,NULL,NULL,1,354.8114583,-0.44617,0.101,NULL,49451004965,772671952,12072999,16.3),(164026,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164026,35.18,0.43,109,76381,75,NULL,'3.6 micron, color + selection bias corrected','AGC 330726',NULL,'2014MNRAS.444..527S',2014,1,0.3,NULL,'G',0.00002,NULL,'16.64',0.2,'Sb','Group member',NULL,NULL,NULL,1,354.824583,26.84461,0.145,NULL,52007987137,812624799,12697262,16.64),(164027,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164027,35.35,0.43,118,76381,75,NULL,'3.6 micron, color corrected','AGC 330726',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164028,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164028,35.37,0.12,119,76381,NULL,NULL,NULL,'AGC 330726',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164029,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164029,35.52,0.2,127,76381,74.4,NULL,NULL,'AGC 330726',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164030,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164030,38.14,0.46,424,76382,70,NULL,NULL,'2MASX J23391916+1442277',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000198,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,354.83,14.70761,0.065,NULL,51671557602,807368087,12615126,17.7),(164031,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164031,37.56,0.33,326,76383,70,NULL,NULL,'2MASX J23392274-0019125',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000065,NULL,'17.9g',0.19,NULL,NULL,NULL,NULL,NULL,1,354.8447083,-0.32014,0.101,NULL,49396555745,771821183,12059705,17.9),(164032,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164032,34.96,0.49,98.3,76384,75,NULL,'IR','UGC 12723',NULL,'2011yCatp016004901K',2011,1,1.12,NULL,'G',0.000033,NULL,'15.76',0.15,'Sdm',NULL,NULL,NULL,NULL,1,354.850041667,10.84997,0.169,NULL,51779530449,809055163,12641486,15.76),(164033,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164033,34.96,NULL,98.3,76384,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164034,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164034,34.99,NULL,99.5,76384,NULL,NULL,'Dipole + Quadrupole','UGC 12723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164035,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164035,35,NULL,100,76384,NULL,NULL,'Dipole','UGC 12723',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164036,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164036,35.31,0.2,115,76385,74.4,NULL,NULL,'UGC 12722',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000009,NULL,'15.21',0.3,'S?',NULL,NULL,NULL,NULL,1,354.858125,9.20756,0.241,NULL,51779798512,809059351,12641552,15.21),(164037,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164037,33.13,0.8,42.4,76386,75,NULL,'MAT, I','ESO 240- G 013',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'13.99',0.9,'(R\'_1)SAB(rs)b','in a triple',NULL,NULL,NULL,1,354.862666667,-47.77478,NULL,NULL,48594101480,759282835,11863794,13.99),(164038,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164038,32.92,0.32,38.4,76386,85,NULL,'I, raw','ESO 240- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164039,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164039,32.94,0.32,38.7,76386,85,NULL,'I, inv','ESO 240- G 013',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164040,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164040,33.13,0.6,42.2,76386,NULL,NULL,'Malmquist cor.','ESO 240- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164041,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164041,33.25,0.57,44.6,76386,NULL,NULL,NULL,'ESO 240- G 013',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164042,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164042,33.27,0.43,45.1,76386,75,NULL,'MAT, I, raw','ESO 240- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164043,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164043,33.29,0.2,45.5,76386,74.4,NULL,NULL,'ESO 240- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164044,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164044,33.41,0.43,48.1,76386,75,NULL,'MAT, I, inv','ESO 240- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164045,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164045,33.45,0.43,49,76386,75,NULL,'MAT, I, cor','ESO 240- G 013',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164046,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164046,35.33,0.53,117,76387,70,NULL,NULL,'2MASX J23393333-0727284',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00007,NULL,'15.80',NULL,NULL,NULL,NULL,NULL,NULL,1,354.889,-7.45794,0.084,NULL,49618181094,775284079,12113813,15.8),(164047,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20552','RN',164047,39.29,0.18,619,76388,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 20552',0.163931,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164048,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20552','RN',164048,39.77,0.29,773,76388,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 20552',0.163931,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164049,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00853','RN',164049,42.42,0.2,2250,76389,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00853',0.356609,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164050,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00853','RN',164050,42.49,0.14,2320,76389,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00853',0.356609,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164051,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164051,36.89,0.46,239,76390,70,NULL,NULL,'2MASX J23393880-0003205',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000079,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,354.911583,-0.05586,0.101,NULL,49396508369,771820443,12059694,16.8),(164052,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164052,35.47,0.46,124,76391,70,NULL,NULL,'CGCG 381-021',NULL,'2015arXiv151105856S',2015,1,0.6,NULL,'G',0.00009,NULL,'15.4g',0.44,'E0',NULL,NULL,NULL,NULL,1,354.921917,-0.0345,0.101,NULL,49396507423,771820428,12059694,15.4),(164053,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164053,35.92,0.63,153,76391,70,NULL,NULL,'CGCG 381-021',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164054,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13467','R',164054,38.6,0.04,492,76392,70,NULL,'SDSS CAND. SNIa?; MLCS2K2; SN 2006hq','SN 2006hq',0.068646,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,354.9464583,0.20522,0.097,NULL,51548085607,805438837,12584981,NULL),(164055,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13467','R',164055,38.99,0.21,588,76392,70,NULL,'SDSS CAND. SNIa?; SALT 2; SN 2006hq','SN 2006hq',0.068646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164056,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164056,35.39,0.25,120,76393,74.4,NULL,NULL,'CGCG 476-101',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000043,NULL,'14.08',0.4,'S0','Group member',NULL,NULL,NULL,1,354.95575,27.37611,0.173,NULL,52006487601,812601368,12696896,14.08),(164057,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164057,35.59,0.11,131,76393,70,NULL,NULL,'CGCG 476-101',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164058,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164058,37.2,0.46,276,76394,70,NULL,NULL,'2MASX J23395014-1035433',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000168,NULL,'17.2g',0.21,NULL,NULL,NULL,NULL,NULL,1,354.959,-10.59533,0.073,NULL,49622561050,775352516,12114883,17.2),(164059,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164059,32.39,0.61,30.1,76395,70,NULL,NULL,'NGC 7727',NULL,'2014MNRAS.445.2677S',2014,1,4.7,NULL,'G',0.000007,NULL,'11.50',3.5,'SAB(s)a pec','Pair member (points to parent)',NULL,NULL,NULL,1,354.973833,-12.29278,0.092,NULL,49577317502,774645585,12103837,11.5),(164060,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164060,31.84,0.8,23.3,76395,75,NULL,'B','NGC 7727',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164061,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'N',164061,19.6,NULL,0.083,76396,NULL,NULL,NULL,'Phoenix II',NULL,'2015ApJ...805..130K',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164062,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'N',164062,19.9,NULL,0.095,76396,NULL,NULL,'DESJ2339.9_5424','Phoenix II',NULL,'2015ApJ...807...50B',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164063,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04393','RN',164063,38,0.38,375,76397,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04393',0.060187,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164064,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04393','RN',164064,39.69,0.53,816,76397,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04393',0.060187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164065,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164065,35.98,0.25,157,76398,74.4,NULL,NULL,'CGCG 476-102',NULL,'2013AJ....146...86T',2013,1,0.61,NULL,'G',0.000067,NULL,'15.7',0.45,'S0','Group member',NULL,NULL,NULL,1,354.994167,26.83425,0.137,NULL,52008397708,812631214,12697362,15.7),(164066,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164066,38.25,0.46,447,76399,70,NULL,NULL,'2MASX J23395898-0000390',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.7g',0.21,'S0',NULL,NULL,NULL,NULL,1,354.995625,-0.01089,0.097,NULL,49396463664,771819744,12059683,17.7),(164067,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164067,35.31,0.23,115,76400,74.4,NULL,NULL,'NGC 7728',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00005,NULL,'14.13',0.8,'E','in a radial-velocity based grouping',NULL,'radio jet','Flat-Spectrum Radio Source',1,355.0035,27.13372,0.173,NULL,52008352212,812630503,12697351,14.13),(164068,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164068,35.59,0.11,131,76400,70,NULL,NULL,'NGC 7728',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164069,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164069,35.59,0.4,131,76400,NULL,NULL,'mean','NGC 7728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164070,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164070,35.62,0.45,133,76400,NULL,NULL,'K','NGC 7728',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164071,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13802','RN',164071,40.8,0.31,1100,76401,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13802',0.313563,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164072,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13802','RN',164072,41.07,0.28,1250,76401,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13802',0.313563,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164073,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13802','N',164073,40.65,0.29,1350,76401,70,NULL,'SALT 2','SDSS-II SN 13802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164074,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13802','N',164074,40.68,0.29,1370,76401,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13802',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164075,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164075,35.61,0.25,132,76402,74.4,NULL,NULL,'2MASX J23400320+2710014',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00007,NULL,'16.08',0.3,'S0/E','Group member',NULL,NULL,NULL,1,355.013416667,27.16708,0.173,NULL,52008343431,812630366,12697349,16.08),(164076,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164076,35.06,0.56,103,76403,NULL,NULL,NULL,'AGC 330751',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.000038,NULL,'16.42',0.3,'Sb','Group member',NULL,NULL,NULL,1,355.0362083,26.90064,0.137,NULL,52008450851,812632044,12697375,16.42),(164077,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164077,35.1,0.2,105,76403,74.4,NULL,NULL,'AGC 330751',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164078,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164078,35.11,0.54,105,76403,NULL,NULL,'Malmquist cor.','AGC 330751',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164079,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13468','RN',164079,39.65,0.14,802,76404,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13468',0.059794,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164080,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13468','RN',164080,39.99,0.23,938,76404,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13468',0.059794,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164081,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164081,35.24,0.22,108,76405,74.2,NULL,'SALT 2','[QQH97] J234014.21+261211.8',0.034,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,'S:',NULL,NULL,NULL,NULL,1,355.0592083,26.20328,0.165,NULL,52008646768,812635105,12697423,NULL),(164082,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164082,35.75,0.27,137,76405,72,NULL,NULL,'[QQH97] J234014.21+261211.8',0.034,'2006ApJ...645..488W',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164083,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164083,35.77,0.05,138,76405,72,NULL,NULL,'[QQH97] J234014.21+261211.8',0.034,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164084,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164084,35.82,0.17,146,76405,70.8,NULL,NULL,'[QQH97] J234014.21+261211.8',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164085,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164085,35.94,0.16,149,76405,70,NULL,'SALT 2','[QQH97] J234014.21+261211.8',0.034,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164086,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg','R',164086,35.88,0.11,150,76405,NULL,NULL,'MLCS2k2, R(V) = 3.1','[QQH97] J234014.21+261211.8',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164087,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164087,35.96,0.27,150,76405,70,NULL,'SALT','[QQH97] J234014.21+261211.8',0.034,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164088,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164088,35.98,0.16,153,76405,73.8,NULL,'SALT 2 (SNANA)','[QQH97] J234014.21+261211.8',0.0305,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164089,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164089,35.99,0.08,153,76405,70,NULL,NULL,'[QQH97] J234014.21+261211.8',0.034,'2006A&A...447...31A',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164090,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164090,36.02,0.08,155,76405,65,NULL,'SALT2','[QQH97] J234014.21+261211.8',0.034,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164091,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164091,36.06,0.03,157,76405,70,NULL,'SALT 2','[QQH97] J234014.21+261211.8',0.034,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164092,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164092,36.15,0.11,159,76405,65,NULL,'MLCS2k2','[QQH97] J234014.21+261211.8',0.034,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164093,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164093,36.12,0.17,162,76405,65,NULL,'MLCS31','[QQH97] J234014.21+261211.8',0.034,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164094,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164094,36.12,0.27,162,76405,65,NULL,'SALT','[QQH97] J234014.21+261211.8',0.034,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164095,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164095,36.12,0.2,162,76405,65,NULL,NULL,'[QQH97] J234014.21+261211.8',0.034,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164096,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164096,36.12,0.16,162,76405,65,NULL,'MLCS17','[QQH97] J234014.21+261211.8',0.034,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164097,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164097,36.15,0.12,164,76405,65,NULL,'MLCS2k2','[QQH97] J234014.21+261211.8',0.034,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164098,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164098,36.15,0.19,164,76405,65,NULL,'SALT2','[QQH97] J234014.21+261211.8',0.034,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164099,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164099,36.17,0.08,166,76405,65,NULL,'MLCS2k2','[QQH97] J234014.21+261211.8',0.034,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164100,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg','R',164100,36.12,0.09,167,76405,NULL,NULL,'MLCS2k2, R(V) = 1.8','[QQH97] J234014.21+261211.8',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164101,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164101,36.21,0.03,169,76405,65,NULL,'SALT','[QQH97] J234014.21+261211.8',0.034,'2007ApJ...666..694W',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164102,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 1997dg',NULL,164102,36.24,0.14,177,76405,60,NULL,NULL,'[QQH97] J234014.21+261211.8',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164103,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164103,35.37,0.25,119,76406,74.4,NULL,NULL,'CGCG 476-105',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000057,NULL,'13.72',0.7,'S0',NULL,NULL,NULL,NULL,1,355.079208333,27.56153,0.185,NULL,51995271532,812426117,12694158,13.72),(164104,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164104,35.59,0.11,131,76406,70,NULL,NULL,'CGCG 476-105',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164105,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13781','RN',164105,43.25,0.38,3780,76407,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13781',0.179111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164106,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164106,37.17,0.46,272,76408,70,NULL,NULL,'SDSS J234020.82+145802.1',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000125,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,355.08675,14.96725,0.053,NULL,51671299724,807364058,12615063,18.1),(164107,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164107,34.55,NULL,81.3,76409,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2523',NULL,'2010Ap&SS.325..163P',2010,1,1.03,NULL,'G',0.000017,NULL,'16.9',0.07,'Sd',NULL,NULL,NULL,NULL,1,355.1,-6.76278,0.035,NULL,49615144203,775236628,12113072,16.9),(164108,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164108,34.55,NULL,81.4,76409,NULL,NULL,'Dipole + Quadrupole','FGC 2523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164109,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164109,34.57,NULL,81.9,76409,NULL,NULL,NULL,'FGC 2523',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164110,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164110,34.57,NULL,82,76409,NULL,NULL,'Dipole','FGC 2523',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164111,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164111,37.32,0.23,291,76410,70,NULL,NULL,'2MASX J23402414+0000080',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00009,NULL,'16.7g',0.3,'S0',NULL,NULL,NULL,NULL,1,355.1005,0.00228,0.097,NULL,51548390274,805443598,12585056,16.7),(164112,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01390',NULL,164112,35.12,1.25,106,76411,70,NULL,'SN photometric redshift distance, z photo =0.025 +/- 0.020','SDSS-II SN 01390',NULL,'2011ApJ...738..162S',2011,1,0.08,NULL,'G',NULL,'PHOT','21.8g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.10225,0.49928,0.117,NULL,51548876566,805451196,12585174,21.8),(164113,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164113,35.26,0.69,113,76412,100,NULL,'mid-IR','CGCG 381-023',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000117,NULL,'15.1',0.5,NULL,NULL,NULL,NULL,NULL,1,355.1240417,2.77458,0.177,NULL,51596836472,806200569,12596883,15.1),(164114,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164114,35.05,0.48,102,76413,70,NULL,NULL,'AM 2337-612',NULL,'2014MNRAS.445.2677S',2014,1,0.78,NULL,'G',0.000077,NULL,'15.22',0.68,'S0',NULL,NULL,NULL,NULL,1,355.124667,-61.08664,0,NULL,48748497623,761695275,11901488,15.22),(164115,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164115,36.49,0.91,199,76414,70,NULL,NULL,'2MASX J23403317-2950240',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.55',0.38,NULL,NULL,NULL,NULL,NULL,1,355.13825,-29.84,NULL,NULL,50041914659,781904916,12217264,16.55),(164116,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164116,37.32,0.23,291,76415,70,NULL,NULL,'ABELL 2644:[KMD98] 023',NULL,'2015arXiv151105856S',2015,1,NULL,NULL,'G',0.00018,NULL,'16.71',NULL,'S0',NULL,NULL,NULL,NULL,1,355.139041667,0.04792,0.097,NULL,51548391793,805443621,12585056,16.71),(164117,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164117,35.98,0.25,157,76416,74.4,NULL,NULL,'2MASX J23403361+2714322',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000137,NULL,'15.49',0.5,'Elliptical',NULL,NULL,NULL,NULL,1,355.1400417,27.24233,0.185,NULL,52008364673,812630698,12697354,15.49),(164118,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164118,34.17,0.8,68.1,76417,75,NULL,'W91PP, r','NGC 7729',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000033,NULL,'14.37',0.6,'Sa',NULL,NULL,NULL,NULL,1,355.1402083,29.18817,0.161,NULL,51967144184,811986627,12687291,14.37),(164119,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164119,34.21,0.47,69.4,76417,NULL,NULL,'H','NGC 7729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164120,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164120,34.25,0.4,70.9,76417,NULL,NULL,'mean','NGC 7729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164121,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164121,34.25,0.46,70.9,76417,NULL,NULL,'J','NGC 7729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164122,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164122,34.25,0.45,70.9,76417,NULL,NULL,'K','NGC 7729',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164123,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164123,34.42,0.49,76.4,76417,75,NULL,'IR','NGC 7729',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164124,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164124,34.54,0.38,81,76417,75,NULL,'W91PP, r, raw','NGC 7729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164125,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164125,34.77,0.38,89.9,76417,75,NULL,'W91PP, r, cor','NGC 7729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164126,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164126,34.82,0.38,92,76417,75,NULL,'W91PP, r, inv','NGC 7729',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164127,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164127,35.32,0.49,116,76418,75,NULL,'IR','UGC 12731',NULL,'2011yCatp016004901K',2011,1,1.57,NULL,'G',0.000008,NULL,'15.48',0.21,'Sbc',NULL,NULL,NULL,NULL,1,355.162375,20.44122,0.113,NULL,52492087115,820188861,12815450,15.48),(164128,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164128,35.43,NULL,122,76418,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164129,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164129,35.43,NULL,122,76418,NULL,NULL,'Dipole + Quadrupole','UGC 12731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164130,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164130,35.45,NULL,123,76418,NULL,NULL,'Dipole','UGC 12731',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164131,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164131,35.47,NULL,124,76418,NULL,NULL,NULL,'UGC 12731',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164132,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164132,35.52,0.41,127,76418,NULL,NULL,'Malmquist cor.','UGC 12731',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164133,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164133,35.7,0.38,138,76418,NULL,NULL,NULL,'UGC 12731',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164134,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164134,35.75,0.2,141,76418,74.4,NULL,NULL,'UGC 12731',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164135,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164135,30.46,0.4,12.4,76419,75,NULL,'B','UGC 12732',NULL,'1988NBGC.C....0000T',1988,1,3,NULL,'G',0.000002,NULL,'13.8',2.8,'Sm:','Pair member (points to parent)',NULL,NULL,NULL,1,355.166083,26.23642,0.165,NULL,52008605387,812634459,12697413,13.8),(164136,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164136,36.15,0.46,170,76420,70,NULL,NULL,'2MASX J23404092+1344304',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000171,NULL,'16.5g',0.26,NULL,NULL,NULL,NULL,NULL,1,355.1704583,13.74172,0.109,NULL,51660301728,807192214,12612378,16.5),(164137,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164137,37.32,0.23,291,76421,70,NULL,NULL,'2MASX J23404152+0006125',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000085,NULL,'16.9g',0.29,'S0',NULL,NULL,NULL,NULL,1,355.173166667,0.10339,0.097,NULL,51548920060,805451875,12585185,16.9),(164138,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164138,33.79,0.44,57.2,76422,NULL,NULL,NULL,'2MASX J23404253+2710412',NULL,'2009ApJS..182..474S',2009,1,0.3,NULL,'G',0.00001,NULL,'16.48',0.3,'Sa',NULL,NULL,NULL,NULL,1,355.1772083,27.17806,0.157,NULL,52008539681,812633432,12697397,16.48),(164139,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164139,34.07,0.39,65.2,76422,NULL,NULL,'Malmquist cor.','2MASX J23404253+2710412',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164140,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18761',NULL,164140,39.87,0.49,940,76423,70,NULL,'SN photometric redshift distance, z photo =0.250 +/- 0.077','SDSS-II SN 18761',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','20.5g',0.06,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.180875,0.73386,0.117,NULL,51548601306,805446895,12585107,20.5),(164141,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18761','R',164141,41.06,0.35,1270,76423,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 18761',0.282402,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164142,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18761','R',164142,41.65,0.34,1670,76423,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 18761',0.282402,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164143,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15946',NULL,164143,38.72,0.64,554,76424,70,NULL,'SN photometric redshift distance, z photo =0.139 +/- 0.053','SDSS-II SN 15946',NULL,'2011ApJ...738..162S',2011,1,0.06,NULL,'G',NULL,'PHOT','21.2g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.188291667,0.63228,0.117,NULL,51548903258,805451613,12585181,21.2),(164144,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15946','R',164144,41.37,0.65,1370,76424,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 15946',0.375137,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164145,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164145,34.71,0.8,87.6,76425,75,NULL,'MAT, I','ESO 536- G 017',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000033,NULL,'15.10',0.4,'Sb-c',NULL,NULL,NULL,NULL,1,355.1885417,-24.69381,0.033,NULL,50057192209,782143628,12220994,15.1),(164146,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164146,34.23,0.32,70,76425,85,NULL,'I, raw','ESO 536- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164147,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164147,34.25,0.32,70.9,76425,85,NULL,'I, inv','ESO 536- G 017',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164148,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164148,34.35,0.43,74.1,76425,75,NULL,'MAT, I, raw','ESO 536- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164149,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164149,34.5,0.43,79.4,76425,75,NULL,'MAT, I, inv','ESO 536- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164150,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164150,34.63,0.2,84.3,76425,74.4,NULL,NULL,'ESO 536- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164151,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164151,34.69,0.59,86.5,76425,NULL,NULL,NULL,'ESO 536- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164152,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164152,34.8,0.43,91.2,76425,75,NULL,'MAT, I, cor','ESO 536- G 017',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164153,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164153,35.04,0.5,102,76425,NULL,NULL,'Malmquist cor.','ESO 536- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164154,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164154,37.66,0.19,340,76426,70,NULL,NULL,'SDSS J234046.37-104732.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000142,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,355.19325,-10.79242,0.084,NULL,49622468460,775351069,12114860,18.6),(164155,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164155,36.88,0.46,237,76427,70,NULL,NULL,'2MASX J23404653-1021108',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000173,NULL,'16.6g',0.29,NULL,NULL,NULL,NULL,NULL,1,355.1939583,-10.35311,0.073,NULL,49622759926,775355623,12114931,16.6),(164156,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164156,35.41,0.25,121,76428,74.4,NULL,NULL,'UGC 12733',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.00005,NULL,'14.77',0.7,'E',NULL,NULL,NULL,NULL,1,355.195125,26.83533,0.137,NULL,52009279170,812644987,12697577,14.77),(164157,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164157,35.59,0.11,131,76428,70,NULL,NULL,'UGC 12733',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164158,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164158,36.03,0.45,161,76428,NULL,NULL,'K','UGC 12733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164159,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164159,36.05,0.4,162,76428,NULL,NULL,'mean','UGC 12733',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164160,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164160,35.76,0.66,142,76429,70,NULL,NULL,'2MASX J23404797-0232119',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.00015,NULL,'16.05',0.31,NULL,NULL,NULL,NULL,NULL,1,355.199833,-2.53661,0.061,NULL,49452364114,772693189,12073331,16.05),(164161,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164161,35.44,0.25,122,76430,74.4,NULL,NULL,'2MASX J23405050+2649511',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000223,NULL,'16.85',0.4,'E/S0',NULL,NULL,NULL,NULL,1,355.210583,26.83089,0.137,NULL,52009277240,812644956,12697577,16.85),(164162,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164162,36.27,0.57,180,76431,70,NULL,NULL,'2MASX J23405296-0201408',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.52',0.36,NULL,NULL,NULL,NULL,NULL,1,355.220625,-2.028,0.109,NULL,49454904462,772732882,12073951,16.52),(164163,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 11192','RN',164163,40.32,0.5,1020,76432,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11192',0.131572,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164164,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164164,35.39,0.25,120,76433,74.4,NULL,NULL,'CGCG 476-109',NULL,'2013AJ....146...86T',2013,1,0.8,NULL,'G',0.000043,NULL,'14.08',0.5,'E',NULL,NULL,NULL,NULL,1,355.226083,27.50964,0.185,NULL,52006537083,812602141,12696908,14.08),(164165,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164165,35.59,0.11,131,76433,70,NULL,NULL,'CGCG 476-109',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164166,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164166,35.14,0.8,107,76434,75,NULL,'MAT, I','ESO 471- G 002',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.000033,NULL,'14.47',0.7,'SA(r)bc',NULL,NULL,NULL,NULL,1,355.2264583,-28.33814,0.069,NULL,50048290227,782004534,12218820,14.47),(164167,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164167,34.82,0.43,92.1,76434,75,NULL,'MAT, I, raw','ESO 471- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164168,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164168,34.95,0.32,97.7,76434,85,NULL,'I, raw','ESO 471- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164169,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164169,35.02,0.32,101,76434,85,NULL,'I, inv','ESO 471- G 002',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164170,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164170,35.09,0.43,104,76434,75,NULL,'MAT, I, inv','ESO 471- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164171,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164171,35.1,0.43,105,76434,75,NULL,'MAT, I, cor','ESO 471- G 002',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164172,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164172,35.24,0.27,112,76434,NULL,NULL,NULL,'ESO 471- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164173,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164173,35.28,0.2,114,76434,74.4,NULL,NULL,'ESO 471- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164174,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164174,35.41,0.25,121,76434,NULL,NULL,'Malmquist cor.','ESO 471- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164175,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164175,37.66,0.19,340,76435,70,NULL,NULL,'2MASXi J2340556-104116',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,355.232125,-10.68797,0.084,NULL,49622453979,775350843,12114856,18),(164176,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164176,36.76,0.46,225,76436,70,NULL,NULL,'2MASX J23405652+1415575',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000194,NULL,'16.2g',0.27,'S0/a',NULL,NULL,NULL,NULL,1,355.235583,14.26606,0.113,NULL,51670976814,807359012,12614984,16.2),(164177,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164177,37.66,0.19,340,76437,70,NULL,NULL,'2MASX J23405691-1044298',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000187,NULL,'16.3g',0.43,'BrClG',NULL,NULL,NULL,NULL,1,355.237125,-10.74147,0.084,NULL,49622464408,775351006,12114859,16.3),(164178,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164178,37.87,0.33,375,76438,70,NULL,NULL,'2MASXi J2340594-100700',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000174,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,355.247875,-10.11681,0.077,NULL,49621877524,775341836,12114716,18),(164179,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164179,37.87,0.33,375,76439,70,NULL,NULL,'SDSS J234101.02-100549.5',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000158,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,355.254291667,-10.09708,0.077,NULL,49621869301,775341707,12114714,17.9),(164180,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164180,34.98,0.54,99,76440,70,NULL,NULL,'MCG -02-60-011',NULL,'2014MNRAS.445.2677S',2014,1,0.5,NULL,'G',0.000177,NULL,'15.25',0.3,NULL,NULL,NULL,NULL,NULL,1,355.258833,-8.22175,0.075,NULL,49615975191,775249612,12113275,15.25),(164181,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164181,36.43,0.5,193,76441,NULL,NULL,'Malmquist cor.','CGCG 476-111',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000017,NULL,'15.27',0.5,'Sc','Group non-member, background',NULL,NULL,NULL,1,355.2765417,25.16906,0.077,NULL,51998539671,812477182,12694955,15.27),(164182,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164182,36.79,0.42,228,76441,NULL,NULL,NULL,'CGCG 476-111',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164183,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164183,36.87,0.2,237,76441,74.4,NULL,NULL,'CGCG 476-111',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164184,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164184,37.66,0.19,340,76442,70,NULL,NULL,'SDSS J234106.46-104413.6',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000174,NULL,'18.6g',0.11,NULL,NULL,NULL,NULL,NULL,1,355.2769583,-10.73714,0.084,NULL,49622484673,775351323,12114864,18.6),(164185,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164185,37.32,0.23,291,76443,70,NULL,NULL,'GALEXASC J234107.23+000543.7',NULL,'2015arXiv151105856S',2015,1,0.67,NULL,'G',0.00017,NULL,'14.81',NULL,'E/S0',NULL,NULL,NULL,NULL,1,355.28025,0.09522,0.089,NULL,51548451769,805444558,12585071,14.81),(164186,'Magnitude','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164186,36.47,0.13,197,76444,100,NULL,NULL,'GALEXASC J234107.23+000543.7',NULL,'1998A&A...337...31R',1998,1,0.67,NULL,'G',0.00017,NULL,'14.81',NULL,'E/S0',NULL,NULL,NULL,NULL,1,355.28025,0.09522,0.089,NULL,51548451769,805444558,12585071,14.81),(164187,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164187,37.23,0.46,279,76445,70,NULL,NULL,'2MASX J23410933-0110178',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000071,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,355.288917,-1.17161,0.125,NULL,49451626878,772681669,12073151,17.3),(164188,'Magnitude','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164188,36.47,0.13,197,76446,100,NULL,NULL,'ABELL 2644',NULL,'1998A&A...337...31R',1998,1,NULL,'Katgert (1996,A&A,310,8) identifies multiple redshift systems in this cluster.','GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,355.290708333,0.094,0.089,NULL,51548451315,805444551,12585071,NULL),(164189,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14478','R',164189,40.42,0.27,945,76447,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14478',0.281762,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,355.292583,0.06922,0.089,NULL,51548449969,805444530,12585070,NULL),(164190,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14478','R',164190,40.42,0.29,946,76447,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14478',0.281762,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164191,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16116','R',164191,39.45,0.18,669,76448,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006oh','SDSS J234112.48-010620.9',0.16,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,355.302,-1.10581,0.125,NULL,49451603506,772681304,12073145,NULL),(164192,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16116','R',164192,39.74,0.1,766,76448,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006oh','SDSS J234112.48-010620.9',0.16,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164193,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006oh',NULL,164193,39.43,0.07,769,76448,70,NULL,'SALT 2','SDSS J234112.48-010620.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164194,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006oh',NULL,164194,39.44,0.07,773,76448,70,NULL,'SALT 2, Malmquist cor.','SDSS J234112.48-010620.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164195,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164195,35.46,0.8,124,76449,75,NULL,'HMCL, I','KUG 2338+252',NULL,'1997ApJS..109..333W',1997,1,0.8,NULL,'G',0.000033,NULL,'14.83',0.3,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,355.317,25.55128,0.113,NULL,51998181178,812471580,12694868,14.83),(164196,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164196,34.86,0.69,93.8,76449,100,NULL,'mid-IR','KUG 2338+252',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164197,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164197,34.96,0.43,98.3,76449,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2338+252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164198,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164198,35.29,0.43,115,76449,75,NULL,'3.6 micron, color corrected','KUG 2338+252',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164199,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164199,35.47,0.45,124,76449,NULL,NULL,'K','KUG 2338+252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164200,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164200,35.48,0.47,125,76449,NULL,NULL,'H','KUG 2338+252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164201,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164201,35.63,0.4,134,76449,NULL,NULL,'mean','KUG 2338+252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164202,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164202,35.7,0.06,138,76449,NULL,NULL,NULL,'KUG 2338+252',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164203,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164203,35.71,0.2,139,76449,74.4,NULL,NULL,'KUG 2338+252',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164204,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164204,35.71,0.46,139,76449,NULL,NULL,'J','KUG 2338+252',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164205,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164205,35.78,0.4,143,76449,75,NULL,'HMCL, I, raw','KUG 2338+252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164206,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164206,36,0.4,158,76449,75,NULL,'HMCL, I, cor','KUG 2338+252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164207,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164207,36.04,0.4,161,76449,75,NULL,'HMCL, I, inv','KUG 2338+252',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164208,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164208,34,0.49,63,76450,75,NULL,'IR','IC 1504',NULL,'2011yCatp016004901K',2011,1,1.7,NULL,'G',0.000013,NULL,'14.27',0.5,'Sb             HII','Group member',NULL,NULL,NULL,1,355.331208333,4.01747,0.193,NULL,51591498819,806117169,12595580,14.27),(164209,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164209,34.11,0.47,66.4,76450,NULL,NULL,'H','IC 1504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164210,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164210,34.14,0.39,67.2,76450,NULL,NULL,NULL,'IC 1504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164211,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164211,34.14,0.45,67.3,76450,NULL,NULL,'K','IC 1504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164212,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164212,34.14,0.2,67.3,76450,74.4,NULL,NULL,'IC 1504',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164213,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164213,34.16,0.39,67.9,76450,NULL,NULL,'Malmquist cor.','IC 1504',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164214,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164214,34.21,0.46,69.4,76450,NULL,NULL,'J','IC 1504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164215,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164215,34.6,0.4,83.1,76450,NULL,NULL,'mean','IC 1504',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164216,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164216,36.33,0.4,184,76451,NULL,NULL,'mean','UGC 12735',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000033,NULL,'15.08',0.5,'SBa',NULL,NULL,NULL,NULL,1,355.3475417,16.15511,0.077,NULL,51668705892,807323529,12614430,15.08),(164217,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164217,36.61,0.47,210,76451,NULL,NULL,'H','UGC 12735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164218,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164218,37.66,0.19,340,76452,70,NULL,NULL,'2MASX J23412574-1023540',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000146,NULL,'18.0g',0.17,NULL,NULL,NULL,NULL,NULL,1,355.357375,-10.39847,0.078,NULL,49622632492,775353632,12114900,18),(164219,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164219,35.67,0.69,136,76453,70,NULL,NULL,'2MASX J23412592-0039437',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00008,NULL,'16.1g',0.2,'Sb',NULL,NULL,NULL,NULL,1,355.3580417,-0.66222,0.097,NULL,49397255354,771832114,12059876,16.1),(164220,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164220,32.83,0.8,36.8,76454,75,NULL,'B','NGC 7731',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000017,NULL,'13.51',1.1,'(R)SBa pec:','Pair member, near/close',NULL,NULL,NULL,1,355.371125,3.74003,0.153,NULL,51605254089,806332095,12598938,13.51),(164221,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164221,37.28,0.23,285,76455,70,NULL,NULL,'2MASX J23413068+1454262',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000169,NULL,'17.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,355.377875,14.90739,0.057,NULL,51671470788,807366731,12615105,17.5),(164222,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164222,36.27,0.46,180,76456,70,NULL,NULL,'2MASX J23413176+1407272',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.1g',0.2,NULL,NULL,NULL,NULL,NULL,1,355.3822917,14.12417,0.093,NULL,51659682019,807182531,12612227,17.1),(164223,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164223,34.34,0.46,73.9,76457,NULL,NULL,'Malmquist cor.','2MASX J23413092+0904228',NULL,'2009ApJS..182..474S',2009,1,0.95,NULL,'G',0.000027,NULL,'14.37',NULL,'Sbc',NULL,NULL,NULL,NULL,1,355.3845,9.07553,0.297,NULL,51787908471,809186069,12643532,14.37),(164224,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164224,34.36,0.45,74.5,76457,NULL,NULL,NULL,'2MASX J23413092+0904228',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164225,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164225,34.4,0.2,75.9,76457,74.4,NULL,NULL,'2MASX J23413092+0904228',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164226,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13180','RN',164226,39.96,0.19,786,76458,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13180',0.251012,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164227,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13180','RN',164227,40.17,0.26,866,76458,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13180',0.251012,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164228,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164228,37.66,0.19,340,76459,70,NULL,NULL,'2MASX J23413673-1023017',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000113,NULL,'16.3g',0.39,NULL,NULL,NULL,NULL,NULL,1,355.403208333,-10.38383,0.078,NULL,49621941753,775342839,12114731,16.3),(164229,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164229,34.68,0.48,86.4,76460,70,NULL,NULL,'IC 1505',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.00015,NULL,'14.72',0.4,NULL,NULL,NULL,NULL,NULL,1,355.404625,-3.56508,0.113,NULL,49456546259,772758535,12074352,14.72),(164230,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164230,36.18,0.46,172,76461,70,NULL,NULL,'2MASX J23414086+1358435',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000163,NULL,'16.5g',0.34,NULL,NULL,NULL,NULL,NULL,1,355.420333,13.97889,0.093,NULL,51660258832,807191544,12612367,16.5),(164231,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19494',NULL,164231,40.88,0.28,1500,76462,70,NULL,'SN photometric redshift distance, z photo =0.442 +/- 0.083','SDSS-II SN 19494',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.4364583,-0.44347,0.105,NULL,49397135422,771830240,12059847,NULL),(164232,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19494',NULL,164232,41.71,0.25,2200,76462,70,NULL,'SALT 2','SDSS-II SN 19494',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164233,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19494',NULL,164233,41.87,0.25,2370,76462,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19494',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164234,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164234,36.11,0.44,166,76463,NULL,NULL,'Malmquist cor.','AGC 332110',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'15.6I',0.2,NULL,NULL,NULL,NULL,NULL,1,355.443333,25.71917,0.093,NULL,51998272912,812473014,12694890,15.6),(164235,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164235,36.26,0.41,178,76463,NULL,NULL,NULL,'AGC 332110',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164236,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2006dm',NULL,164236,34.89,0.17,93.1,76464,70,NULL,'SALT 2','ARP 295A',0.022019,'2013MNRAS.433.2240G',2013,1,1.37,NULL,'G',0.000053,NULL,'14.5',0.11,'Sc       poss. LINER','Pair member (points to parent)',NULL,NULL,NULL,1,355.4470417,-3.66722,0.089,NULL,49456551174,772758612,12074353,14.5),(164237,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18653','RN',164237,39.68,0.15,765,76465,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18653',0.127986,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164238,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 18653','RN',164238,39.94,0.25,864,76465,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18653',0.127986,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164239,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164239,37.28,0.23,285,76466,70,NULL,NULL,'2MASX J23415045+1502386',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000189,NULL,'16.2g',0.29,'S0^-',NULL,NULL,NULL,NULL,1,355.460333333,15.04386,0.057,NULL,51671395084,807365548,12615086,16.2),(164240,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01264','RN',164240,41.88,0.11,1900,76467,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01264',0.250549,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164241,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164241,34.77,0.49,90.1,76468,70,NULL,NULL,'MCG -05-55-034',NULL,'2014MNRAS.445.2677S',2014,1,0.88,NULL,'G',0.000143,NULL,'14.94',0.5,'S',NULL,NULL,NULL,NULL,1,355.462083,-28.02469,0.059,NULL,50048426270,782006660,12218854,14.94),(164242,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164242,38.39,0.46,476,76469,70,NULL,NULL,'SDSS J234151.44-095502.1',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000153,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,355.464333333,-9.91725,0.079,NULL,49621291454,775332678,12114573,18.2),(164243,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164243,36.79,0.46,228,76470,70,NULL,NULL,'2MASX J23415168-0941037',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,355.4655,-9.68453,0.083,NULL,49623110858,775361107,12115017,17.3),(164244,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164244,34.16,0.8,67.9,76471,75,NULL,'W91PP, r','UGC 12741',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',0.000033,NULL,'14.1r',0.3,'Sa',NULL,NULL,NULL,NULL,1,355.481083,30.58175,0.273,NULL,51965786452,811965413,12686959,14.1),(164245,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164245,34.24,0.4,70.6,76471,NULL,NULL,'mean','UGC 12741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164246,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164246,34.37,0.38,74.8,76471,75,NULL,'W91PP, r, raw','UGC 12741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164247,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164247,34.42,0.47,76.4,76471,NULL,NULL,'H','UGC 12741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164248,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164248,34.48,0.45,78.5,76471,NULL,NULL,'K','UGC 12741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164249,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164249,34.52,0.46,80.1,76471,NULL,NULL,'J','UGC 12741',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164250,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164250,34.53,0.38,80.4,76471,75,NULL,'W91PP, r, inv','UGC 12741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164251,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164251,34.58,0.38,82.4,76471,75,NULL,'W91PP, r, cor','UGC 12741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164252,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164252,34.93,0.4,96.7,76472,NULL,NULL,'mean','ARP 295B',NULL,'2007A&A...465...71T',2007,1,0.9,NULL,'G',0.000063,NULL,'14.6',0.5,'Sb pec:    HII;LIRG','Pair member (points to parent)',NULL,NULL,NULL,1,355.5035417,-3.61517,0.113,NULL,49456445547,772756961,12074327,14.6),(164253,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164253,35.15,0.45,107,76472,NULL,NULL,'K','ARP 295B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164254,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164254,35.21,0.47,110,76472,NULL,NULL,'H','ARP 295B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164255,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164255,35.34,0.46,117,76472,NULL,NULL,'J','ARP 295B',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164256,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164256,35.42,0.2,121,76473,74.4,NULL,NULL,'2MASX J23420093+2559533',NULL,'2013AJ....146...86T',2013,1,0.55,NULL,'G',0.00006,NULL,'16.22',0.2,NULL,NULL,NULL,NULL,NULL,1,355.503917,25.99808,0.093,NULL,52005807352,812590739,12696730,16.22),(164257,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164257,35.55,0.11,129,76473,NULL,NULL,NULL,'2MASX J23420093+2559533',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164258,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164258,37.86,0.46,374,76474,70,NULL,NULL,'2MASX J23420103+1452567',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000162,NULL,'17.5g',0.23,NULL,NULL,NULL,NULL,NULL,1,355.504375,14.88244,0.057,NULL,51671007646,807359494,12614992,17.5),(164259,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164259,34.48,0.47,78.9,76475,NULL,NULL,'H','VV 480',NULL,'2007A&A...465...71T',2007,1,1.4,'HOLM 814B is a star.','G',0.00002,NULL,'14.51',1,'(R\')SB(r)b:    HII',NULL,NULL,NULL,NULL,1,355.504417,-4.21642,0.085,NULL,49445116679,772579948,12071561,14.51),(164260,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164260,34.49,0.4,79,76475,NULL,NULL,'mean','VV 480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164261,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164261,34.64,0.46,84.8,76475,NULL,NULL,'J','VV 480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164262,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164262,34.66,0.45,85.5,76475,NULL,NULL,'K','VV 480',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164263,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20704',NULL,164263,38.9,0.98,602,76476,70,NULL,'SN photometric redshift distance, z photo =0.152 +/- 0.099','SDSS-II SN 20704',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.8g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.555666667,-0.02289,0.081,NULL,49396868440,771826069,12059782,21.8),(164264,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20704','R',164264,40.87,0.49,1140,76476,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20704',0.314735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164265,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20704','R',164265,41.38,0.37,1430,76476,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20704',0.314735,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164266,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00884','RN',164266,41.98,0.15,1890,76477,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 00884',0.318397,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164267,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 00884','RN',164267,42.52,0.27,2420,76477,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 00884',0.318397,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164268,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164268,35.38,0.25,119,76478,74.4,NULL,NULL,'NGC 7735',NULL,'2013AJ....146...86T',2013,1,1.3,'The 2MASS position is 8 arcsec south of the nucleus.','G',0.00009,NULL,'14.56',0.9,'E',NULL,NULL,NULL,NULL,1,355.572125,26.23175,0.125,NULL,52005953776,812593027,12696766,14.56),(164269,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164269,35.49,0.45,125,76478,NULL,NULL,'K','NGC 7735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164270,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164270,35.69,0.4,137,76478,NULL,NULL,'mean','NGC 7735',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164271,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164271,34.66,0.2,85.5,76479,74.4,NULL,NULL,'2MASX J23421729+2816234',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.00004,NULL,'14.88',0.2,'Sd',NULL,NULL,NULL,NULL,1,355.572125,28.27317,0.177,NULL,51995686520,812432601,12694259,14.88),(164272,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164272,35.55,0.13,129,76479,NULL,NULL,NULL,'2MASX J23421729+2816234',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164273,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13639','RN',164273,42.66,0.23,2690,76480,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 13639',0.269903,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164274,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13639','RN',164274,43.02,0.24,3160,76480,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13639',0.269903,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164275,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164275,37.02,0.46,253,76481,70,NULL,NULL,'2MASX J23422162+0014383',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000073,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,355.59,0.24411,0.085,NULL,51548505209,805445393,12585084,17),(164276,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164276,34.97,0.43,98.5,76482,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 476-116',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000033,NULL,'15.6',0.2,'Sb','Group member, peripheral',NULL,NULL,NULL,1,355.596333,27.33186,0.141,NULL,52006563276,812602551,12696914,15.6),(164277,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164277,35.13,0.43,106,76482,75,NULL,'3.6 micron, color corrected','CGCG 476-116',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164278,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164278,35.3,0.49,115,76482,75,NULL,'IR','CGCG 476-116',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164279,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164279,35.34,0.2,117,76482,74.4,NULL,NULL,'CGCG 476-116',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164280,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164280,34.12,0.48,66.6,76483,70,NULL,NULL,'NGC 7736',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000067,NULL,'13.87',1.5,'(R\')SA(r)0^0^?',NULL,NULL,NULL,NULL,1,355.607416667,-19.45231,0.055,NULL,50271526350,785492599,12273321,13.87),(164281,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164281,38.15,0.33,426,76484,70,NULL,NULL,'2MASX J23422679+1512514',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000174,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,355.6117917,15.21417,0.069,NULL,51673415215,807397112,12615579,18.1),(164282,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164282,37.42,0.46,305,76485,70,NULL,NULL,'2MASX J23422854+1542214',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000185,NULL,'17.0g',0.25,NULL,NULL,NULL,NULL,NULL,1,355.619083,15.70608,0.069,NULL,51669906467,807342288,12614723,17),(164283,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164283,34.05,0.49,64.7,76486,75,NULL,'IR','FGC 2526',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.00001,NULL,'14.30',0.13,'Sc','Group member, peripheral',NULL,NULL,NULL,1,355.629083,28.04433,0.177,NULL,51995557482,812430585,12694227,14.3),(164284,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164284,34.11,0.43,66.4,76486,75,NULL,'3.6 micron, color + selection bias corrected','FGC 2526',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164285,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164285,34.15,0.43,67.6,76486,75,NULL,'3.6 micron, color corrected','FGC 2526',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164286,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164286,34.16,0.2,67.9,76486,74.4,NULL,NULL,'FGC 2526',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164287,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164287,34.16,0.43,68,76486,NULL,NULL,NULL,'FGC 2526',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164288,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164288,34.33,0.4,73.4,76486,NULL,NULL,'Malmquist cor.','FGC 2526',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164289,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164289,34.66,NULL,85.4,76486,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2526',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164290,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164290,34.67,NULL,85.9,76486,NULL,NULL,'Dipole + Quadrupole','FGC 2526',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164291,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164291,34.69,NULL,86.6,76486,NULL,NULL,'Dipole','FGC 2526',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164292,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164292,34.73,NULL,88.2,76486,NULL,NULL,NULL,'FGC 2526',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164293,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629',NULL,164293,39.93,0.33,969,76487,70,NULL,'SN photometric redshift distance, z photo =0.259 +/- 0.051','SDSS-II SN 13629',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.5g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,355.6325417,-0.05253,0.081,NULL,49396903729,771826620,12059790,21.5),(164294,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629','R',164294,41.61,0.19,1550,76487,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13629',0.353187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164295,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629','R',164295,41.65,0.27,1580,76487,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13629',0.353187,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164296,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629',NULL,164296,41.1,0.15,1660,76487,70,NULL,'SALT 2','SDSS-II SN 13629',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164297,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13629',NULL,164297,41.15,0.15,1700,76487,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13629',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164298,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164298,35.31,0.49,115,76488,75,NULL,'IR','NGC 7733',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.000033,NULL,'14.29',0.8,'(R\'_1)SB(s)bc  Sy2','Pair member, radial velocity confirmed',NULL,NULL,'Sy 2',1,355.637291667,-65.9565,0.029,NULL,48734968978,761483890,11898185,14.29),(164299,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164299,35.43,0.46,122,76488,NULL,NULL,'Malmquist cor.','NGC 7733',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164300,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164300,35.5,0.45,126,76488,NULL,NULL,NULL,'NGC 7733',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164301,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164301,35.55,0.2,129,76488,74.4,NULL,NULL,'NGC 7733',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164302,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164302,31.39,0.8,19,76489,75,NULL,'MAT, I','ESO 292- G 014',NULL,'1997ApJS..109..333W',1997,1,2.39,NULL,'G',0.000029,NULL,'13.94',0.24,'Scd?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,355.646833,-44.90483,NULL,NULL,50481594440,788774913,12324608,13.94),(164303,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164303,31.63,0.39,21.2,76489,73,NULL,'IR','ESO 292- G 014',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164304,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164304,31.63,0.4,21.2,76489,75,NULL,NULL,'ESO 292- G 014',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164305,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164305,31.93,0.32,24.3,76489,85,NULL,'I, raw','ESO 292- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164306,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164306,31.93,0.32,24.3,76489,85,NULL,'I, inv','ESO 292- G 014',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164307,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164307,32.01,0.4,25.2,76489,NULL,NULL,NULL,'ESO 292- G 014',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164308,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164308,32.05,0.43,25.7,76489,75,NULL,'MAT, I, raw','ESO 292- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164309,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164309,32.12,0.43,26.5,76489,75,NULL,'MAT, I, inv','ESO 292- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164310,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164310,32.22,0.49,27.8,76489,75,NULL,'IR','ESO 292- G 014',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164311,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164311,32.25,0.43,28.1,76489,75,NULL,'MAT, I, cor','ESO 292- G 014',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164312,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164312,32.69,NULL,34.5,76489,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 292- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164313,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164313,32.71,NULL,34.8,76489,NULL,NULL,'Dipole + Quadrupole','ESO 292- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164314,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164314,32.71,NULL,34.9,76489,NULL,NULL,'Dipole','ESO 292- G 014',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164315,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164315,32.84,NULL,37,76489,NULL,NULL,NULL,'ESO 292- G 014',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164316,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164316,38.15,0.33,426,76490,70,NULL,NULL,'2MASX J23424006+1512064',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000155,NULL,'17.4g',0.25,NULL,NULL,NULL,NULL,NULL,1,355.6667917,15.20183,0.057,NULL,51673417403,807397146,12615580,17.4),(164317,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164317,35.89,0.45,150,76491,NULL,NULL,'Malmquist cor.','2MFGC 17789',NULL,'2009ApJS..182..474S',2009,1,0.74,NULL,'G',0.000033,NULL,'15.4',NULL,'Sb','Group member',NULL,NULL,NULL,1,355.677083,8.49011,0.297,NULL,51785498832,809148419,12642944,15.4),(164318,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164318,36.01,0.42,159,76491,NULL,NULL,NULL,'2MFGC 17789',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164319,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164319,36.05,0.2,162,76491,74.4,NULL,NULL,'2MFGC 17789',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164320,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164320,36.07,0.49,164,76491,75,NULL,'IR','2MFGC 17789',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164321,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164321,34.96,0.8,98.1,76492,75,NULL,'W91PP, r','UGC 12746',NULL,'1997ApJS..109..333W',1997,1,1.36,'Karachentsev, et al. (1993,AN,314,97) dec. in error by 1\'.','G',0.000013,NULL,'15.09',0.17,'Scd','Group member, peripheral',NULL,NULL,NULL,1,355.6939583,27.29728,0.137,NULL,52006553952,812602405,12696912,15.09),(164322,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164322,34.96,0.8,98.1,76492,75,NULL,'W91CL, r','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164323,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164323,34.96,0.8,98.2,76492,75,NULL,'HMCL, I','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164324,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164324,34.97,0.8,98.5,76492,75,NULL,'CF, r','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164325,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164325,34.5,0.38,79.5,76492,75,NULL,'CF, r, raw','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164326,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164326,34.64,0.38,84.8,76492,75,NULL,'CF, r, inv','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164327,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164327,34.72,0.49,88.1,76492,75,NULL,'IR','UGC 12746',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164328,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164328,34.74,0.38,88.9,76492,75,NULL,'CF, r, cor','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164329,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164329,34.76,0.38,89.6,76492,75,NULL,'W91PP, r, raw','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164330,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164330,34.88,0.4,94.5,76492,75,NULL,'HMCL, I, raw','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164331,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164331,34.95,0.38,97.9,76492,75,NULL,'W91PP, r, inv','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164332,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164332,34.98,0.39,99.2,76492,NULL,NULL,'Malmquist cor.','UGC 12746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164333,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164333,34.98,0.38,99.3,76492,75,NULL,'W91PP, r, cor','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164334,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164334,34.99,0.38,99.4,76492,75,NULL,'W91CL, r, raw','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164335,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164335,35.01,0.39,100,76492,NULL,NULL,NULL,'UGC 12746',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164336,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164336,35,0.47,100,76492,NULL,NULL,'H','UGC 12746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164337,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164337,35.02,0.45,101,76492,NULL,NULL,'K','UGC 12746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164338,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164338,35.06,0.4,103,76492,NULL,NULL,'mean','UGC 12746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164339,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164339,35.09,0.4,104,76492,75,NULL,'HMCL, I, inv','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164340,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164340,35.12,0.4,105,76492,75,NULL,'HMCL, I, cor','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164341,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164341,35.15,0.2,107,76492,74.4,NULL,NULL,'UGC 12746',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164342,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164342,35.17,0.38,108,76492,75,NULL,'W91CL, r, inv','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164343,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164343,35.2,0.38,110,76492,75,NULL,'W91CL, r, cor','UGC 12746',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164344,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164344,35.26,0.46,112,76492,NULL,NULL,'J','UGC 12746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164345,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164345,35.39,NULL,119,76492,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164346,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164346,35.4,NULL,120,76492,NULL,NULL,'Dipole + Quadrupole','UGC 12746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164347,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164347,35.41,NULL,121,76492,NULL,NULL,'Dipole','UGC 12746',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164348,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164348,35.45,NULL,123,76492,NULL,NULL,NULL,'UGC 12746',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164349,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164349,37.28,0.23,285,76493,70,NULL,NULL,'2MASX J23424675+1506530',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.000178,NULL,'16.1g',0.39,'E0',NULL,NULL,NULL,NULL,1,355.694708333,15.11472,0.057,NULL,51673427636,807397306,12615582,16.1),(164350,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164350,37.28,0.23,285,76494,70,NULL,NULL,'2MASX J23424764+1503380',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000172,NULL,'17.2g',0.2,NULL,NULL,NULL,NULL,NULL,1,355.6985417,15.0605,0.057,NULL,51673637823,807400590,12615634,17.2),(164351,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164351,34.3,0.49,72.3,76495,75,NULL,'IR','2MFGC 17792',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.00004,NULL,'14.80',0.24,'Sc',NULL,NULL,NULL,NULL,1,355.7075,27.12039,0.137,NULL,52009184727,812643511,12697554,14.8),(164352,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164352,34.65,0.55,85.2,76495,NULL,NULL,NULL,'2MFGC 17792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164353,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164353,34.69,0.2,86.7,76495,74.4,NULL,NULL,'2MFGC 17792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164354,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164354,34.81,0.51,91.8,76495,NULL,NULL,'Malmquist cor.','2MFGC 17792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164355,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164355,35.08,0.2,104,76496,74.4,NULL,NULL,'KUG 2340+144',NULL,'2013AJ....146...86T',2013,1,0.71,NULL,'G',0.000154,NULL,'15.7g',0.31,'Spiral',NULL,NULL,NULL,NULL,1,355.729583,14.75478,0.057,NULL,51672949582,807389837,12615466,15.7),(164356,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164356,36.9,0.46,240,76497,70,NULL,NULL,'2MASX J23425621-0850548',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000155,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,355.734125,-8.84858,0.089,NULL,49626236609,775409947,12115780,17.7),(164357,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164357,35.27,0.48,113,76498,70,NULL,NULL,'MCG -01-60-024',NULL,'2014MNRAS.445.2677S',2014,1,0.4,NULL,'G',0.000093,NULL,'15.5',0.3,NULL,NULL,NULL,NULL,NULL,1,355.73425,-3.65044,0.073,NULL,49456426848,772756669,12074322,15.5),(164358,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164358,35.79,0.64,144,76499,70,NULL,NULL,'2MASX J23430186-4658378',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'16.47',0.27,NULL,NULL,NULL,NULL,NULL,1,355.75775,-46.97711,NULL,NULL,48587875225,759185550,11862274,16.47),(164359,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553',NULL,164359,38.69,1.51,547,76500,70,NULL,'SN photometric redshift distance, z photo =0.137 +/- 0.163','SDSS-II SN 20553',NULL,'2011ApJ...738..162S',2011,1,0.19,NULL,'G',NULL,'PHOT','21.5g',0.02,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.792333,-0.33122,0.085,NULL,49399743456,771870991,12060484,21.5),(164360,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553','R',164360,41.44,0.27,1440,76500,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20553',0.348806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164361,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553','R',164361,41.7,0.23,1620,76500,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20553',0.348806,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164362,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553',NULL,164362,41.35,0.17,1860,76500,70,NULL,'SALT 2','SDSS-II SN 20553',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164363,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20553',NULL,164363,41.4,0.17,1910,76500,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20553',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164364,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164364,36.99,0.46,250,76501,70,NULL,NULL,'2MASX J23431196-0859161',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.00015,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,355.7997917,-8.98772,0.07,NULL,49626326740,775411355,12115802,16.5),(164365,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164365,36.6,0.66,209,76502,70,NULL,NULL,'2MASX J23431265-3622203',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.00015,NULL,'16.86',0.28,NULL,NULL,NULL,NULL,NULL,1,355.80275,-36.37231,NULL,NULL,49951975966,780499624,12195306,16.86),(164366,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164366,36.04,0.38,162,76503,NULL,NULL,NULL,'AGC 331612',NULL,'2009ApJS..182..474S',2009,1,0.4,NULL,'G',0.00003,NULL,'17.1',NULL,'Sc','Group member',NULL,NULL,NULL,1,355.8075,8.58139,0.309,NULL,51788658422,809197787,12643715,17.1),(164367,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164367,36.08,0.2,164,76503,74.4,NULL,NULL,'AGC 331612',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164368,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164368,36.18,0.36,172,76503,NULL,NULL,'Malmquist cor.','AGC 331612',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164369,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164369,35.15,0.49,107,76504,75,NULL,'IR','FGC 2530',NULL,'2011yCatp016004901K',2011,1,1.21,NULL,'G',NULL,NULL,'16.17',0.13,'Scd',NULL,NULL,NULL,NULL,1,355.8095417,23.51197,0.093,NULL,51952391308,811756114,12683689,16.17),(164370,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164370,35.32,NULL,116,76504,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2530',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164371,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164371,35.34,NULL,117,76504,NULL,NULL,'Dipole','FGC 2530',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164372,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164372,35.34,NULL,117,76504,NULL,NULL,'Dipole + Quadrupole','FGC 2530',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164373,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164373,35.37,0.47,119,76505,NULL,NULL,'H','UGC 12750',NULL,'2007A&A...465...71T',2007,1,1.5,NULL,'G',0.000057,NULL,'14.10',0.8,'Sa',NULL,NULL,NULL,NULL,1,355.811,49.97953,0.953,NULL,53155496879,830554638,12977416,14.1),(164374,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164374,35.38,0.45,119,76505,NULL,NULL,'K','UGC 12750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164375,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164375,35.43,0.4,122,76505,NULL,NULL,'mean','UGC 12750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164376,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164376,35.47,0.46,124,76505,NULL,NULL,'J','UGC 12750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164377,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164377,34.85,0.5,93.2,76506,70,NULL,NULL,'ESO 028- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'14.64',1,'SAB(s)b',NULL,NULL,NULL,NULL,1,355.821,-72.57078,0.113,NULL,48397542417,756211600,11815806,14.64),(164378,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164378,36.72,0.45,221,76507,NULL,NULL,'Malmquist cor.','2MASX J23431734+2723396',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'14.3I',0.2,NULL,NULL,NULL,NULL,NULL,1,355.822333,27.39428,0.165,NULL,52007026478,812609788,12697027,14.3),(164379,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164379,37.02,0.39,253,76507,NULL,NULL,NULL,'2MASX J23431734+2723396',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164380,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164380,37.18,0.2,273,76507,74.4,NULL,NULL,'2MASX J23431734+2723396',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164381,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19793','R',164381,40.88,0.39,1080,76508,70,NULL,'SDSS CAND. zSNIbc; SALT 2','SDSS-II SN 19793',0.38694,'2014arXiv1401.3317S',2014,1,0.03,NULL,'G',NULL,'PHOT','22.4g',0.03,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,355.826125,0.25725,0.089,NULL,51551704348,805495380,12585865,22.4),(164382,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19793','R',164382,40.94,0.36,1110,76508,70,NULL,'SDSS CAND. zSNIbc; MLCS2K2','SDSS-II SN 19793',0.38694,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164383,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19793',NULL,164383,40.75,0.35,1410,76508,70,NULL,'SN photometric redshift distance, z photo =0.408 +/- 0.097','SDSS-II SN 19793',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164384,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15182','RN',164384,40.03,0.36,888,76509,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15182',0.14298,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164385,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15182','RN',164385,40.97,0.36,1370,76509,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15182',0.14298,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164386,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164386,37.9,0.46,380,76510,70,NULL,NULL,'2MASX J23432447-0945531',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000167,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,355.852041667,-9.76464,0.076,NULL,49626718461,775417475,12115898,17.4),(164387,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164387,38.36,0.46,469,76511,70,NULL,NULL,'2MASX J23432536-0957201',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,355.855625,-9.9555,0.084,NULL,49624421256,775381582,12115337,16.7),(164388,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164388,36.59,0.6,208,76512,70,NULL,NULL,'2MASX J23432775-2905250',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.20',0.28,NULL,NULL,NULL,NULL,NULL,1,355.865583333,-29.09028,0.052,NULL,50041153666,781893026,12217078,16.2),(164389,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164389,35.84,0.47,147,76513,NULL,NULL,'H','UGC 12753',NULL,'2007A&A...465...71T',2007,1,1.8,NULL,'G',0.00003,NULL,'14.40',1.4,'SAB(r)bc',NULL,NULL,NULL,NULL,1,355.8697083,13.20967,0.133,NULL,51658863578,807169743,12612027,14.4),(164390,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164390,35.93,0.45,154,76513,NULL,NULL,'K','UGC 12753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164391,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164391,36.02,0.46,160,76513,NULL,NULL,'J','UGC 12753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164392,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164392,36.09,0.4,165,76513,NULL,NULL,'mean','UGC 12753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164393,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164393,37.29,0.46,287,76514,70,NULL,NULL,'2MASX J23433474+0034036',NULL,'2015arXiv151105856S',2015,1,0.52,NULL,'G',0.000103,NULL,'16.1g',0.31,'E0',NULL,NULL,NULL,NULL,1,355.894917,0.56781,0.073,NULL,51551860080,805497813,12585903,16.1),(164394,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20680','RN',164394,43.49,0.3,2970,76515,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20680',0.674983,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164395,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164395,36.99,0.46,250,76516,70,NULL,NULL,'2MASX J23433781+1428407',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000155,NULL,'17.1g',0.28,NULL,NULL,NULL,NULL,NULL,1,355.9077083,14.47781,0.081,NULL,51672288168,807379502,12615304,17.1),(164396,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164396,36.25,0.5,178,76517,70,NULL,NULL,'ESO 408- G 020',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000093,NULL,'15.39',0.4,'S?',NULL,NULL,NULL,NULL,1,355.917375,-36.536,NULL,NULL,49951102416,780485975,12195093,15.39),(164397,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164397,37.44,0.46,307,76518,70,NULL,NULL,'2MASX J23434223+1546284',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000143,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,355.92575,15.77447,0.061,NULL,51670134255,807345847,12614778,18),(164398,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164398,34.7,0.64,87.1,76519,70,NULL,NULL,'2MASX J23434247-0634060',NULL,'2014MNRAS.445.2677S',2014,1,0.84,NULL,'G',0.000143,NULL,'15.28',0.6,NULL,NULL,NULL,NULL,NULL,1,355.9269583,-6.56831,0.075,NULL,49437905717,772467276,12069801,15.28),(164399,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15769','RN',164399,41.46,0.32,1660,76520,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15769',0.18066,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164400,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15769','RN',164400,42.04,0.48,2160,76520,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15769',0.18066,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164401,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164401,27.9,0.35,3.8,76521,NULL,NULL,NULL,'UGCA 442',NULL,'2005AJ....129..698M',2005,1,6.38,NULL,'G',0.000007,NULL,'13.5B',0.9,'SB(s)m: sp','Group member',NULL,NULL,NULL,1,355.9397917,-31.95678,NULL,NULL,50179551219,784055487,12250866,13.5),(164402,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164402,28.15,0.27,4.27,76521,NULL,NULL,NULL,'UGCA 442',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164403,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164403,28.2,0.1,4.37,76521,74.4,NULL,NULL,'UGCA 442',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164404,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164404,28.32,NULL,4.61,76521,NULL,NULL,'I','UGCA 442',NULL,'2006ARep...50..517T',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164405,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164405,28.3,0.8,4.57,76521,75,NULL,'MAT, I','UGCA 442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164406,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164406,27.6,0.8,3.3,76521,75,NULL,NULL,'UGCA 442',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164407,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164407,28.58,0.32,5.24,76521,85,NULL,'I, inv','UGCA 442',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164408,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164408,28.7,NULL,5.49,76521,NULL,NULL,'Dipole + Quadrupole + Octopole','UGCA 442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164409,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164409,28.7,0.32,5.49,76521,85,NULL,'I, raw','UGCA 442',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164410,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164410,28.74,NULL,5.59,76521,NULL,NULL,'Dipole + Quadrupole','UGCA 442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164411,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164411,28.75,NULL,5.63,76521,NULL,NULL,'Dipole','UGCA 442',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164412,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164412,28.85,NULL,5.9,76521,NULL,NULL,NULL,'UGCA 442',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164413,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164413,29.22,0.43,6.99,76521,75,NULL,'MAT, I, inv','UGCA 442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164414,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164414,29.49,0.43,7.92,76521,75,NULL,'MAT, I, raw','UGCA 442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164415,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164415,29.82,0.43,9.19,76521,75,NULL,'MAT, I, cor','UGCA 442',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164416,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603',NULL,164416,36.76,1.43,225,76522,70,NULL,'SN photometric redshift distance, z photo =0.054 +/- 0.053','SDSS-II SN 15603',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.6g',0.05,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,355.942417,-1.19217,0.121,NULL,49400205673,771878213,12060597,21.6),(164417,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603','R',164417,40.44,0.25,968,76522,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15603',0.262587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164418,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603','R',164418,40.54,0.2,1010,76522,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15603',0.262587,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164419,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603',NULL,164419,40.24,0.14,1120,76522,70,NULL,'SALT 2','SDSS-II SN 15603',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164420,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15603',NULL,164420,40.26,0.14,1130,76522,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15603',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164421,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164421,35.18,0.54,109,76523,70,NULL,NULL,'ESO 192- G 016',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.56',0.6,'(R\'_1)SB(s)0^+',NULL,NULL,NULL,NULL,1,355.9452083,-53.04442,0,NULL,48633811305,759903301,11873489,15.56),(164422,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164422,37.7,0.46,347,76524,70,NULL,NULL,'2MASX J23434712+0042214',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'16.8g',0.31,NULL,NULL,NULL,NULL,NULL,1,355.946333,0.70589,0.061,NULL,51551932450,805498944,12585921,16.8),(164423,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164423,35.85,0.4,148,76525,NULL,NULL,'Malmquist cor.','ESO 408- G 021',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000033,NULL,'14.83',0.6,'SAB(r)bc',NULL,NULL,NULL,NULL,1,355.947833333,-36.71361,NULL,NULL,49951261910,780488467,12195132,14.83),(164424,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164424,36.06,0.36,163,76525,NULL,NULL,NULL,'ESO 408- G 021',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164425,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164425,36.1,0.2,166,76525,74.4,NULL,NULL,'ESO 408- G 021',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164426,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164426,35.32,0.8,116,76526,75,NULL,'W91PP, r','UGC 12755',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.00002,NULL,'14.63',0.9,'SBb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,355.956833,28.33922,0.205,NULL,51994911340,812420489,12694070,14.63),(164427,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164427,35.32,0.8,116,76526,75,NULL,'W91CL, r','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164428,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164428,35.32,0.8,116,76526,75,NULL,'CF, r','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164429,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164429,35.32,0.8,116,76526,75,NULL,'HMCL, I','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164430,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164430,34.72,0.69,87.7,76526,100,NULL,'mid-IR','UGC 12755',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164431,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164431,35.27,0.38,113,76526,75,NULL,'CF, r, raw','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164432,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164432,35.35,0.38,117,76526,75,NULL,'W91PP, r, raw','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164433,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164433,35.35,0.4,117,76526,75,NULL,'HMCL, I, raw','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164434,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164434,35.38,0.38,119,76526,75,NULL,'W91CL, r, raw','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164435,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164435,35.46,0.38,124,76526,75,NULL,'CF, r, cor','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164436,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164436,35.49,0.4,126,76526,NULL,NULL,'mean','UGC 12755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164437,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164437,35.5,0.38,126,76526,75,NULL,'CF, r, inv','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164438,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164438,35.54,0.38,128,76526,75,NULL,'W91PP, r, cor','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164439,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164439,35.56,0.4,129,76526,75,NULL,'HMCL, I, cor','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164440,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164440,35.6,0.47,132,76526,NULL,NULL,'H','UGC 12755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164441,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164441,35.61,0.38,132,76526,75,NULL,'W91CL, r, cor','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164442,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164442,35.62,0.4,133,76526,75,NULL,'HMCL, I, inv','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164443,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164443,35.62,0.38,133,76526,75,NULL,'W91CL, r, inv','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164444,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164444,35.65,0.38,135,76526,75,NULL,'W91PP, r, inv','UGC 12755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164445,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164445,35.66,0.45,135,76526,NULL,NULL,'K','UGC 12755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164446,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164446,35.68,0.46,137,76526,NULL,NULL,'J','UGC 12755',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164447,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164447,35.72,0.2,139,76526,74.4,NULL,NULL,'UGC 12755',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164448,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164448,35.77,0.08,143,76526,NULL,NULL,NULL,'UGC 12755',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164449,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164449,35.87,0.43,149,76526,75,NULL,'3.6 micron, color corrected','UGC 12755',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164450,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164450,36.17,0.43,172,76526,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12755',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164451,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14479','RN',164451,42.3,0.28,2400,76527,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 14479',0.197681,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164452,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14479','RN',164452,42.96,0.24,3260,76527,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14479',0.197681,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164453,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164453,37.52,0.46,318,76528,70,NULL,NULL,'2MASXi J2343534-011407',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000057,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,355.9729583,-1.23553,0.121,NULL,49400225973,771878530,12060602,17.8),(164454,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164454,30.42,0.8,12.1,76529,75,NULL,'W91PP, r','NGC 7741',NULL,'1997ApJS..109..333W',1997,1,4.4,'The 2MASS position is 5 arcsec west of the bar\'s optical peak.','G',0.000001,NULL,'11.84',3,'SB(s)cd        HII','Pair member (points to parent)',NULL,NULL,NULL,1,355.9765417,26.07561,0.137,NULL,52006086059,812595094,12696798,11.84),(164455,'Sosies','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164455,30.5,0.39,12.6,76529,NULL,NULL,NULL,'NGC 7741',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164456,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164456,30.45,0.4,12.3,76529,75,NULL,'B','NGC 7741',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164457,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164457,30.5,0.4,12.6,76529,NULL,NULL,'Virgo cluster at 15.6 Mpc, Avg. of 3 galaxy group','NGC 7741',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164458,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164458,30.55,NULL,12.9,76529,NULL,NULL,'LEDA [April 2006]','NGC 7741',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164459,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164459,30.66,0.2,13.6,76529,74.4,NULL,NULL,'NGC 7741',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164460,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164460,30.7,0.43,13.8,76529,75,NULL,'3.6 micron, color corrected','NGC 7741',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164461,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164461,30.75,0.43,14.1,76529,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7741',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164462,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164462,30.9,0.36,15.1,76529,NULL,NULL,NULL,'NGC 7741',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164463,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164463,30.89,0.39,15.1,76529,73,NULL,'opt','NGC 7741',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164464,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164464,31.01,0.38,15.9,76529,75,NULL,'W91PP, r, raw','NGC 7741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164465,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164465,31.02,0.38,16,76529,75,NULL,'W91PP, r, inv','NGC 7741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164466,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164466,31.21,0.38,17.5,76529,75,NULL,'W91PP, r, cor','NGC 7741',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164467,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164467,35.19,0.33,109,76530,70,NULL,NULL,'CGCG 381-031',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000074,NULL,'15.6g',0.16,'E0',NULL,NULL,NULL,NULL,1,355.983167,0.21808,0.073,NULL,51551691127,805495173,12585862,15.6),(164468,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164468,38.31,0.46,459,76531,70,NULL,NULL,'2MASX J23435622+1546004',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000148,NULL,'18.2g',0.14,NULL,NULL,NULL,NULL,NULL,1,355.984417,15.76669,0.061,NULL,51670127694,807345745,12614777,18.2),(164469,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164469,37.93,0.46,386,76532,70,NULL,NULL,'2MASX J23435737-0957009',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000193,NULL,'16.8g',0.28,NULL,NULL,NULL,NULL,NULL,1,355.9889583,-9.95036,0.084,NULL,49624416636,775381509,12115336,16.8),(164470,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164470,34.59,0.49,82.9,76533,75,NULL,'IR','NGC 7738',NULL,'2011yCatp016004901K',2011,1,1.97,'The NGC identification is very uncertain.','G',0.00004,NULL,'13.9g',0.63,'SB(rs)b',NULL,NULL,NULL,NULL,1,356.008583333,0.51664,0.061,NULL,51551922513,805498789,12585918,13.9),(164471,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04217','RN',164471,43.59,0.27,3740,76534,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 04217',0.398114,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164472,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 04217','RN',164472,43.81,0.33,4130,76534,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 04217',0.398114,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164473,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 17842','RN',164473,39.07,0.24,581,76535,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 17842',0.124916,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164474,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 17842','RN',164474,40.17,0.32,962,76535,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 17842',0.124916,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164475,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476',NULL,164475,39.92,0.29,963,76536,70,NULL,'SN photometric redshift distance, z photo =0.257 +/- 0.043','SDSS-II SN 13476',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.016583,-0.79097,0.109,NULL,49400306249,771879785,12060621,NULL),(164476,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476','R',164476,40.87,0.16,1170,76536,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13476',0.27572,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164477,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476','R',164477,40.97,0.24,1220,76536,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13476',0.27572,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164478,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476',NULL,164478,40.84,0.13,1470,76536,70,NULL,'SALT 2','SDSS-II SN 13476',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164479,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13476',NULL,164479,40.86,0.13,1490,76536,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 13476',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164480,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164480,32.12,0.8,26.5,76537,75,NULL,'MAT, I','MCG -01-60-026',NULL,'1997ApJS..109..333W',1997,1,2.1,NULL,'G',0.00001,NULL,'13.75',1.1,'SB(s)c pec:    HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,356.043833333,-6.16964,0.075,NULL,49437732122,772464564,12069758,13.75),(164481,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164481,31.62,0.43,21.1,76537,75,NULL,'3.6 micron, color + selection bias corrected','MCG -01-60-026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164482,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164482,31.68,0.2,21.7,76537,74.4,NULL,NULL,'MCG -01-60-026',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164483,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164483,31.68,0.43,21.7,76537,75,NULL,'3.6 micron, color corrected','MCG -01-60-026',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164484,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164484,31.77,0.66,22.6,76537,NULL,NULL,'Malmquist cor.','MCG -01-60-026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164485,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164485,31.82,0.65,23.1,76537,NULL,NULL,NULL,'MCG -01-60-026',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164486,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164486,31.86,0.4,23.6,76537,NULL,NULL,NULL,'MCG -01-60-026',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164487,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164487,31.86,0.39,23.6,76537,73,NULL,'opt','MCG -01-60-026',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164488,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164488,31.91,0.32,24.1,76537,85,NULL,'I, inv','MCG -01-60-026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164489,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164489,31.93,0.32,24.3,76537,85,NULL,'I, raw','MCG -01-60-026',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164490,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164490,32.47,0.43,31.2,76537,75,NULL,'MAT, I, raw','MCG -01-60-026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164491,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164491,32.49,0.43,31.5,76537,75,NULL,'MAT, I, inv','MCG -01-60-026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164492,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164492,32.74,0.43,35.3,76537,75,NULL,'MAT, I, cor','MCG -01-60-026',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164493,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 03517','RN',164493,40.51,0.13,1140,76538,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03517',0.11337,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164494,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 03517','RN',164494,40.89,0.22,1350,76538,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03517',0.11337,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164495,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164495,37.34,0.46,294,76539,70,NULL,NULL,'2MASX J23441201+1604166',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000154,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,356.050167,16.07144,0.065,NULL,51670051143,807344549,12614758,17.6),(164496,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164496,34.53,0.2,80.5,76540,74.4,NULL,NULL,'FGC 2532',NULL,'2013AJ....146...86T',2013,1,0.85,NULL,'G',0.000014,NULL,'16.7',0.1,'Scd','Group member, peripheral',NULL,NULL,NULL,1,356.055,28.27194,0.205,NULL,51994840200,812419378,12694052,16.7),(164497,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164497,34.69,0.48,86.8,76540,NULL,NULL,NULL,'FGC 2532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164498,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164498,34.77,NULL,90,76540,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2532',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164499,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164499,34.77,NULL,90,76540,NULL,NULL,'Dipole + Quadrupole','FGC 2532',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164500,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164500,34.79,NULL,90.7,76540,NULL,NULL,'Dipole','FGC 2532',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164501,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164501,34.81,0.46,91.6,76540,NULL,NULL,'Malmquist cor.','FGC 2532',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164502,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164502,34.84,NULL,92.9,76540,NULL,NULL,NULL,'FGC 2532',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164503,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164503,37.83,0.46,369,76541,70,NULL,NULL,'2MASX J23441517-1005595',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000179,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,356.06325,-10.09975,0.089,NULL,49624602284,775384410,12115381,16.5),(164504,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164504,37.94,0.7,387,76542,70,NULL,NULL,'2MASXi J2344152-233149',NULL,'2014MNRAS.445.2677S',2014,1,0.29,NULL,'G',0.00015,NULL,'17.44',0.26,NULL,NULL,NULL,NULL,NULL,1,356.063375,-23.53058,0.038,NULL,50003223428,781300366,12207818,17.44),(164505,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164505,33.72,0.8,55.5,76543,75,NULL,'MAT, I','ESO 012- G 004',NULL,'1997ApJS..109..333W',1997,1,2.46,NULL,'G',0.000033,NULL,'15.28',0.24,'Sbc',NULL,NULL,NULL,NULL,1,356.064625,-80.177,0.353,NULL,48338647577,755291368,11801427,15.28),(164506,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164506,33.65,0.49,53.7,76543,75,NULL,'IR','ESO 012- G 004',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164507,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164507,33.69,0.47,54.7,76543,NULL,NULL,'H','ESO 012- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164508,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164508,33.95,0.45,61.7,76543,NULL,NULL,'K','ESO 012- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164509,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164509,33.98,0.4,62.5,76543,NULL,NULL,'mean','ESO 012- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164510,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164510,34.02,0.43,63.7,76543,75,NULL,'MAT, I, raw','ESO 012- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164511,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164511,34.09,0.46,65.8,76543,NULL,NULL,'J','ESO 012- G 004',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164512,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164512,34.15,0.32,67.7,76543,85,NULL,'I, raw','ESO 012- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164513,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164513,34.2,0.32,69.2,76543,85,NULL,'I, inv','ESO 012- G 004',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164514,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164514,34.22,0.43,69.9,76543,75,NULL,'MAT, I, cor','ESO 012- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164515,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164515,34.23,0.43,70.2,76543,75,NULL,'MAT, I, inv','ESO 012- G 004',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164516,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164516,34.43,NULL,76.8,76543,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 012- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164517,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164517,34.43,NULL,77,76543,NULL,NULL,'Dipole + Quadrupole','ESO 012- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164518,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164518,34.44,NULL,77.1,76543,NULL,NULL,'Dipole','ESO 012- G 004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164519,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164519,34.53,NULL,80.4,76543,NULL,NULL,NULL,'ESO 012- G 004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164520,'Ring Diameter','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164520,34.1,0.84,66,76544,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7742',NULL,'1981ApJS...45..541P',1981,1,1.7,NULL,'G',0.000003,NULL,'12.35',1.7,'SA(r)b;LINER   HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,356.065541667,10.76708,0.101,NULL,51781810497,809090789,12642043,12.35),(164521,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164521,31.73,0.8,22.2,76544,75,NULL,'B','NGC 7742',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164522,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164522,36.22,0.23,175,76545,74.4,NULL,NULL,'GIN 734',NULL,'2013AJ....146...86T',2013,1,1.2,NULL,'G',0.000047,NULL,'14.7V',0.6,'E/S0','Group member',NULL,NULL,NULL,1,356.067083333,9.04897,0.221,NULL,51790857191,809232143,12644252,14.7),(164523,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164523,36.5,0.2,199,76545,70,NULL,NULL,'GIN 734',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164524,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164524,36.14,0.4,169,76545,NULL,NULL,'mean','GIN 734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164525,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164525,36.66,0.45,215,76545,NULL,NULL,'K','GIN 734',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164526,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164526,37.05,0.46,257,76546,70,NULL,NULL,'2MASX J23441950-0954245',NULL,'2015arXiv151105856S',2015,1,0.4,NULL,'G',0.00015,NULL,'16.6g',0.31,NULL,NULL,NULL,NULL,NULL,1,356.081375,-9.90689,0.087,NULL,49626593869,775415529,12115867,16.6),(164527,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05686','RN',164527,40.47,0.3,982,76547,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 05686',0.263788,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164528,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 05686','RN',164528,41.36,0.32,1480,76547,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 05686',0.263788,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164529,'SBF','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164529,31.42,0.17,19.2,76548,NULL,NULL,'I','NGC 7743',NULL,'2003ApJ...583..712J',2003,1,3,NULL,'G',0.000017,NULL,'12.38',2.6,'(R)SB(s)0+     Sy2','in a radial-velocity based grouping',NULL,NULL,'Sy 2',1,356.088083,9.93408,0.173,NULL,51789530252,809211410,12643928,12.38),(164530,'SBF','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164530,31.54,0.14,20.3,76548,74.4,NULL,NULL,'NGC 7743',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164531,'SBF','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164531,31.58,0.17,20.7,76548,NULL,NULL,'I','NGC 7743',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164532,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164532,31.93,0.8,24.4,76548,75,NULL,'B','NGC 7743',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164533,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164533,36.25,0.25,178,76549,74.4,NULL,NULL,'CGCG 407-048 NED01',NULL,'2013AJ....146...86T',2013,1,0.15,NULL,'G',0.00005,NULL,'14.8V',0.1,'Ep','Group member',NULL,NULL,'Flat-Spectrum Radio Source',1,356.102083,9.16461,0.221,NULL,51790839616,809231869,12644247,14.8),(164534,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164534,36.5,0.2,199,76549,70,NULL,NULL,'CGCG 407-048 NED01',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164535,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16405','R',164535,40.54,0.15,1010,76550,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J234424.87+002204.4',0.2754,'2014arXiv1401.3317S',2014,1,0.12,NULL,'G',0.01,NULL,'19.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,356.103625,0.36789,0.061,NULL,51551898980,805498421,12585912,19.8),(164536,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16405','R',164536,40.59,0.23,1030,76550,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J234424.87+002204.4',0.2754,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164537,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16405',NULL,164537,40.48,0.13,1250,76550,70,NULL,'SALT 2','SDSS J234424.87+002204.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164538,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 16405',NULL,164538,40.5,0.13,1260,76550,70,NULL,'SALT 2, Malmquist cor.','SDSS J234424.87+002204.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164539,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137','R',164539,40.8,0.22,1130,76551,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15137',0.278904,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.1072917,-0.80658,0.109,NULL,49400292699,771879573,12060618,NULL),(164540,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137','R',164540,41.07,0.17,1280,76551,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15137',0.278904,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164541,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137',NULL,164541,40.54,0.09,1280,76551,70,NULL,'SN photometric redshift distance, z photo =0.361 +/- 0.019','SDSS-II SN 15137',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164542,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137',NULL,164542,40.72,0.13,1390,76551,70,NULL,'SALT 2','SDSS-II SN 15137',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164543,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15137',NULL,164543,40.75,0.13,1410,76551,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15137',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164544,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14876','RN',164544,41.94,0.45,1910,76552,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14876',0.280067,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164545,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14876','RN',164545,42,0.27,1960,76552,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14876',0.280067,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164546,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164546,35.19,0.2,109,76553,74.4,NULL,NULL,'CGCG 407-049',NULL,'2013AJ....146...86T',2013,1,1.1,NULL,'G',0.000107,NULL,'15.02',0.6,'Sa','Isolated galaxy',NULL,NULL,NULL,1,356.114917,5.66389,0.317,NULL,51562250422,805660162,12588440,15.02),(164547,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164547,36.5,0.2,199,76554,70,NULL,NULL,'GIN 732',NULL,'2001MNRAS.321..277C',2001,1,NULL,NULL,'G',0.000028,NULL,'15.8V',NULL,'E','Group member',NULL,NULL,NULL,1,356.1155,9.26697,0.221,NULL,51791104598,809236009,12644312,15.8),(164548,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164548,35.5,0.5,126,76555,70,NULL,NULL,'6dF J2344286-355502',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.7R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.1192083,-35.91717,NULL,NULL,49951322202,780489409,12195147,14.7),(164549,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164549,35.19,0.33,109,76556,70,NULL,NULL,'NGC 7739',NULL,'2015arXiv151105856S',2015,1,0.8,'The NGC identification is very uncertain.','G',0.000111,NULL,'14.7g',0.73,'E+:',NULL,NULL,NULL,NULL,1,356.125333,0.32047,0.061,NULL,51549602389,805462537,12585352,14.7),(164550,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164550,36.01,0.23,159,76557,74.4,NULL,NULL,'CGCG 407-050',NULL,'2013AJ....146...86T',2013,1,0.9,NULL,'G',0.00004,NULL,'14.8V',0.5,'E/S0;BrClG','Group member',NULL,NULL,NULL,1,356.1267083,9.26406,0.221,NULL,51791115569,809236180,12644315,14.8),(164551,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164551,36.24,0.23,177,76557,74.4,NULL,NULL,'CGCG 407-050',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164552,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164552,36.5,0.2,199,76557,70,NULL,NULL,'CGCG 407-050',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164553,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164553,36.18,0.59,173,76558,70,NULL,NULL,'2MASX J23443124-2806335',NULL,'2014MNRAS.445.2677S',2014,1,0.46,NULL,'G',0.00015,NULL,'16.55',0.37,NULL,NULL,NULL,NULL,NULL,1,356.1302083,-28.10931,0.064,NULL,50061295656,782207744,12221996,16.55),(164554,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164554,34.21,0.8,69.5,76559,75,NULL,'W91PP, r','UGC 12762',NULL,'1997ApJS..109..333W',1997,1,1.1,NULL,'G',NULL,NULL,'15.26',0.6,'S?',NULL,NULL,NULL,NULL,1,356.1340417,21.94247,0.137,NULL,52494827061,820231672,12816119,15.26),(164555,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164555,33.47,0.2,49.4,76559,74.4,NULL,NULL,'UGC 12762',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164556,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164556,33.66,0.36,53.9,76559,NULL,NULL,NULL,'UGC 12762',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164557,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164557,33.95,0.32,61.7,76559,NULL,NULL,'Malmquist cor.','UGC 12762',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164558,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164558,34.1,0.38,66,76559,75,NULL,'W91PP, r, raw','UGC 12762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164559,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164559,34.11,0.38,66.5,76559,75,NULL,'W91PP, r, inv','UGC 12762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164560,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164560,34.31,0.38,72.9,76559,75,NULL,'W91PP, r, cor','UGC 12762',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164561,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 12206','RN',164561,40.95,0.39,1140,76560,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 12206',0.359815,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164562,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 03611','RN',164562,41.17,0.09,1570,76561,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03611',0.092944,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164563,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 03611','RN',164563,41.33,0.2,1690,76561,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 03611',0.092944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164564,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164564,38.28,0.46,452,76562,70,NULL,NULL,'2MASX J23443473+1535448',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000149,NULL,'18.1g',0.18,NULL,NULL,NULL,NULL,NULL,1,356.144583,15.59578,0.061,NULL,51673439154,807397486,12615585,18.1),(164565,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164565,38.27,0.46,450,76563,70,NULL,NULL,'SDSS J234435.55-100441.3',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00017,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,356.148166667,-10.07814,0.099,NULL,49624605024,775384453,12115382,18.6),(164566,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164566,38.29,0.46,455,76564,70,NULL,NULL,'SDSS J234437.60+144032.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000156,NULL,'18.3g',0.13,NULL,NULL,NULL,NULL,NULL,1,356.156667,14.67578,0.069,NULL,51672445202,807381956,12615343,18.3),(164567,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 02354','RN',164567,41.75,0.18,1430,76565,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02354',0.56549,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164568,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164568,30.78,0.76,14.3,76566,NULL,NULL,NULL,'UGC 12764',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',NULL,NULL,'15.27',0.8,'Scd:',NULL,NULL,NULL,NULL,1,356.1625,22.01111,0.137,NULL,52494820315,820231567,12816118,15.27),(164569,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164569,31.18,0.63,17.3,76566,NULL,NULL,'Malmquist cor.','UGC 12764',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164570,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164570,36.43,0.51,193,76567,70,NULL,NULL,'ESO 537-IG 003 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.32',0.37,'E',NULL,NULL,NULL,NULL,1,356.164583,-23.81156,0.041,NULL,50003114911,781298670,12207791,16.32),(164571,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164571,34.67,NULL,86.1,76568,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2533',NULL,'2010Ap&SS.325..163P',2010,1,0.9,NULL,'G',0.000018,NULL,'16.6',0.1,'Sdm',NULL,NULL,NULL,NULL,1,356.1684583,5.25717,0.281,NULL,51593049861,806141404,12595959,16.6),(164572,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164572,34.69,NULL,86.8,76568,NULL,NULL,'Dipole + Quadrupole','FGC 2533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164573,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164573,34.71,NULL,87.4,76568,NULL,NULL,'Dipole','FGC 2533',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164574,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164574,34.75,NULL,89.1,76568,NULL,NULL,NULL,'FGC 2533',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164575,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 17218','R',164575,39.64,0.2,717,76569,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007jp','SDSS J234441.24-000148.3',0.18,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.171833,-0.03008,0.105,NULL,49398825445,771856647,12060260,NULL),(164576,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2007jp',NULL,164576,39.46,0.09,780,76569,70,NULL,'SALT 2','SDSS J234441.24-000148.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164577,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SN 2007jp',NULL,164577,39.47,0.09,783,76569,70,NULL,'SALT 2, Malmquist cor.','SDSS J234441.24-000148.3',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164578,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 17218','R',164578,39.91,0.12,812,76569,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007jp','SDSS J234441.24-000148.3',0.18,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164579,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164579,36.07,0.23,164,76570,74.4,NULL,NULL,'GIN 730',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000033,NULL,'15.5V',0.3,'E/S0','Group member',NULL,NULL,NULL,1,356.182667,9.21561,0.221,NULL,51791106802,809236043,12644313,15.5),(164580,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164580,36.5,0.2,199,76570,70,NULL,NULL,'GIN 730',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164581,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164581,36.99,0.49,250,76571,NULL,NULL,'Malmquist cor.','2MASX J23444532+0835419',NULL,'2009ApJS..182..474S',2009,1,NULL,NULL,'G',NULL,NULL,'16.1',NULL,NULL,'Group member',NULL,NULL,NULL,1,356.188917,8.59497,0.253,NULL,51788754099,809199282,12643738,16.1),(164582,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164582,37.31,0.42,290,76571,NULL,NULL,NULL,'2MASX J23444532+0835419',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164583,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164583,37.36,0.2,296,76571,74.4,NULL,NULL,'2MASX J23444532+0835419',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164584,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 14729','RN',164584,43.28,0.37,3570,76572,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14729',0.27022,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164585,'BCG','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164585,37.58,0.35,315,76573,60,NULL,NULL,'ABELL 2657',0.0414,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'III    [BM]',NULL,NULL,NULL,NULL,1,356.2125417,9.14433,0.221,NULL,51790866877,809232294,12644254,NULL),(164586,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164586,36.22,0.14,175,76573,70,NULL,NULL,'ABELL 2657',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164587,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164587,36.96,0.27,247,76574,70,NULL,NULL,'2MASX J23445607+0107369',NULL,'2015arXiv151105856S',2015,1,0.58,NULL,'G',0.000103,NULL,'15.7g',0.5,'E0',NULL,NULL,NULL,NULL,1,356.2337917,1.12689,0.121,NULL,51552089896,805501404,12585959,15.7),(164588,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164588,36.94,0.25,244,76575,74.4,NULL,NULL,'2MASX J23445627+0907469',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000064,NULL,'16.0V',0.4,'S0/E','Group member',NULL,NULL,NULL,1,356.234458333,9.12964,0.221,NULL,51790819504,809231554,12644243,16),(164589,'BCG','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164589,37.58,0.35,315,76576,60,NULL,'ABELL 2657, BCG','CGCG 407-053 NED02',0.0414,'1980ApJ...241..486H',1980,1,0.8,NULL,'G',0.000047,NULL,'14.0V',0.6,'cD;S0;BrClG','Group member, 2nd ranked galaxy',NULL,NULL,NULL,1,356.23925,9.19314,0.221,NULL,51790811822,809231434,12644241,14),(164590,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164590,36.5,0.2,199,76576,70,NULL,NULL,'CGCG 407-053 NED02',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164591,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164591,36.22,0.14,175,76576,70,NULL,'ABELL 2657, BGC','CGCG 407-053 NED02',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164592,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164592,37.87,0.46,376,76577,70,NULL,NULL,'2MASX J23445821+0102409',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000068,NULL,'18.3g',0.15,NULL,NULL,NULL,NULL,NULL,1,356.242417,1.04472,0.121,NULL,51552151213,805502362,12585974,18.3),(164593,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164593,36.27,0.25,179,76578,74.4,NULL,NULL,'CGCG 407-053',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'GTrpl',0.000137,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.24375,9.1975,0.221,NULL,51790811898,809231435,12644241,NULL),(164594,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164594,35.68,0.45,137,76578,NULL,NULL,'K','CGCG 407-053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164595,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164595,36.14,0.4,169,76578,NULL,NULL,'mean','CGCG 407-053',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164596,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164596,32.23,0.65,27.9,76579,95,NULL,'Weighted Mean','NGC 7744',NULL,'1984ApJS...56...91D',1984,1,2.2,NULL,'G',0.00007,NULL,'12.87',1.7,'SB0^-','Isolated galaxy',NULL,NULL,NULL,1,356.246833,-42.91092,NULL,NULL,49931121273,780173769,12190215,12.87),(164597,'Faber-Jackson','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164597,33.74,0.81,56,76579,55,NULL,'Visvanathan & Sandage 1979','NGC 7744',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164598,'Tully est','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164598,32.83,0.8,36.9,76579,75,NULL,'B','NGC 7744',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164599,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164599,36.29,0.25,181,76580,74.4,NULL,NULL,'GIN 735',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.00004,NULL,'16.0V',0.3,'S','Group member',NULL,NULL,NULL,1,356.256917,9.04478,0.221,NULL,51788780351,809199692,12643745,16),(164600,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164600,36.5,0.2,199,76580,70,NULL,NULL,'GIN 735',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164601,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164601,36.96,0.27,247,76581,70,NULL,NULL,'2MASX J23450440+0110440',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',NULL,NULL,'16.86',0.33,NULL,NULL,NULL,NULL,NULL,1,356.268375,1.17889,0.121,NULL,51552087797,805501371,12585958,16.86),(164602,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164602,34.98,0.49,99.1,76582,75,NULL,'IR','CGCG 497-053',NULL,'2011yCatp016004901K',2011,1,1,NULL,'G',0.000033,NULL,'15.41',0.3,'Sc',NULL,NULL,NULL,NULL,1,356.275833,29.06392,0.189,NULL,51964373560,811943336,12686614,15.41),(164603,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164603,35.96,0.8,155,76583,75,NULL,'W91PP, r','UGC 12766',NULL,'1997ApJS..109..333W',1997,1,1,'RC3 (1991RC3.9.C...0000d) gives v = 7348 km/s.','G',0.000565,NULL,'16.0',0.2,'S?',NULL,NULL,NULL,NULL,1,356.277375,25.51842,0.085,NULL,51997872066,812466751,12694792,16),(164604,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164604,35.78,0.38,143,76583,75,NULL,'W91PP, r, raw','UGC 12766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164605,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164605,35.9,0.38,151,76583,75,NULL,'W91PP, r, inv','UGC 12766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164606,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164606,35.99,0.38,157,76583,75,NULL,'W91PP, r, cor','UGC 12766',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164607,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164607,35.73,0.52,140,76584,NULL,NULL,NULL,'2MASX J23450695+0903345',NULL,'2009ApJS..182..474S',2009,1,0.9,NULL,'G',0.000077,NULL,'15.4V',0.6,'SBa','Group member',NULL,NULL,NULL,1,356.278916667,9.05956,0.221,NULL,51788783510,809199742,12643745,15.4),(164608,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164608,35.75,0.51,141,76584,NULL,NULL,'Malmquist cor.','2MASX J23450695+0903345',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164609,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164609,36.13,0.2,168,76584,74.4,NULL,NULL,'2MASX J23450695+0903345',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164610,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164610,36.96,0.27,247,76585,70,NULL,NULL,'2MASX J23450742+0103501',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',NULL,NULL,'16.5g',0.29,NULL,NULL,NULL,NULL,NULL,1,356.280875,1.06381,0.121,NULL,51552080470,805501257,12585957,16.5),(164611,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164611,37.84,0.46,370,76586,70,NULL,NULL,'2MASX J23451259+1358013',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.00017,NULL,'17.3g',0.2,NULL,NULL,NULL,NULL,NULL,1,356.302417,13.96694,0.097,NULL,51658187010,807159172,12611862,17.3),(164612,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 19549',NULL,164612,41.53,0.06,2020,76587,70,NULL,'SN photometric redshift distance, z photo =0.670 +/- 0.030','SDSS-II SN 19549',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.315041667,0.32019,0.073,NULL,51549770219,805465159,12585393,NULL),(164613,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164613,35.06,0.43,103,76588,75,NULL,'3.6 micron, color + selection bias corrected','AGC 331322',NULL,'2014MNRAS.444..527S',2014,1,0.8,NULL,'G',0.000037,NULL,'14.22',0.3,'Sc',NULL,NULL,NULL,NULL,1,356.319,27.47794,0.133,NULL,52006999338,812609364,12697021,14.22),(164614,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164614,35.07,0.43,103,76588,75,NULL,'3.6 micron, color corrected','AGC 331322',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164615,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164615,35.11,0.2,105,76588,74.4,NULL,NULL,'AGC 331322',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164616,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164616,35.5,0.1,126,76588,NULL,NULL,NULL,'AGC 331322',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164617,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164617,36.29,0.23,181,76589,74.4,NULL,NULL,'GIN 736',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000031,NULL,'15.1V',0.4,'E/S0','Group member',NULL,NULL,NULL,1,356.321708333,9.27106,0.221,NULL,51791081799,809235653,12644307,15.1),(164618,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164618,36.5,0.2,199,76589,70,NULL,NULL,'GIN 736',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164619,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 01812','RN',164619,40.25,0.24,770,76590,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01812',0.459785,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164620,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164620,36.37,0.54,188,76591,70,NULL,NULL,'2MASX J23451770-2134417',NULL,'2014MNRAS.445.2677S',2014,1,0.62,NULL,'G',0.00015,NULL,'16.03',0.53,NULL,NULL,NULL,NULL,NULL,1,356.323791667,-21.57822,0.046,NULL,50278548988,785602327,12275036,16.03),(164621,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164621,36.42,0.65,192,76592,70,NULL,NULL,'2MASX J23451896-0008496',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00008,NULL,'16.6g',0.17,'Sb(f)',NULL,NULL,NULL,NULL,1,356.3289583,-0.14706,0.105,NULL,49398861147,771857205,12060268,16.6),(164622,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164622,32.82,0.43,36.7,76593,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12769',NULL,'2014MNRAS.444..527S',2014,1,1.3,NULL,'G',0.00002,NULL,'16.0',0.5,'Sdm:',NULL,NULL,NULL,NULL,1,356.330083333,-1.27342,0.109,NULL,49400058556,771875914,12060561,16),(164623,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164623,34.75,0.47,89.1,76594,70,NULL,NULL,'NGC 7746',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.000067,NULL,'14.07',1.1,'S0^0^ pec:',NULL,NULL,NULL,NULL,1,356.333333,-1.68489,0.089,NULL,49398100965,771845327,12060083,14.07),(164624,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164624,34.88,0.4,94.8,76594,NULL,NULL,'mean','NGC 7746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164625,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164625,35.07,0.45,103,76594,NULL,NULL,'K','NGC 7746',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164626,'BL Lac Luminosity','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164626,42.08,NULL,2610,76595,70,NULL,'nucleus-to-host flux ratio, z > 1.03','BZU J2345-1515',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'19.22',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,356.343167,-15.25186,0.037,NULL,49593125286,774892582,12107696,19.22),(164627,'SNIa','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SCP 06U04',NULL,164627,44.79,0.06,4430,76596,70,NULL,'SALT2, M(B) -19.289 mag, Alpha -0.019, Beta 3.480, Delta -0.151','[DAA2009] U',1.05,'2012ApJ...746...85S',2012,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.36375,-36.54722,NULL,NULL,49958497735,780601527,12196898,NULL),(164628,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164628,35.8,0.36,145,76597,NULL,NULL,'Malmquist cor.','ESO 606- G 006',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.92',0.4,'Sb',NULL,NULL,NULL,NULL,1,356.380417,-20.9805,0.064,NULL,50280367982,785630749,12275480,14.92),(164629,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164629,36.17,0.3,171,76597,NULL,NULL,NULL,'ESO 606- G 006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164630,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164630,36.21,0.2,175,76597,74.4,NULL,NULL,'ESO 606- G 006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164631,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164631,35.04,0.8,102,76598,75,NULL,'W91CL, r','NGC 7747',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'14.38',0.5,'(R\')SB(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,356.384375,27.36094,0.133,NULL,52006797385,812606209,12696972,14.38),(164632,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164632,35.04,0.8,102,76598,75,NULL,'W91PP, r','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164633,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164633,35.04,0.8,102,76598,75,NULL,'HMCL, I','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164634,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164634,35.04,0.8,102,76598,75,NULL,'CF, r','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164635,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164635,34.88,0.38,94.5,76598,75,NULL,'W91PP, r, raw','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164636,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164636,35,0.35,99.8,76598,NULL,NULL,'Malmquist cor.','NGC 7747',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164637,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164637,35.05,0.34,102,76598,NULL,NULL,NULL,'NGC 7747',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164638,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164638,35.05,0.47,103,76598,NULL,NULL,'H','NGC 7747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164639,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164639,35.06,0.46,103,76598,NULL,NULL,'J','NGC 7747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164640,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164640,35.08,0.45,104,76598,NULL,NULL,'K','NGC 7747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164641,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164641,35.09,0.38,104,76598,75,NULL,'W91PP, r, cor','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164642,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164642,35.14,0.4,107,76598,NULL,NULL,'mean','NGC 7747',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164643,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164643,35.16,0.38,108,76598,75,NULL,'W91PP, r, inv','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164644,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164644,35.18,0.4,109,76598,75,NULL,'HMCL, I, raw','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164645,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164645,35.2,0.38,110,76598,75,NULL,'W91CL, r, raw','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164646,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164646,35.24,0.2,112,76598,74.4,NULL,NULL,'NGC 7747',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164647,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164647,35.29,0.38,114,76598,75,NULL,'CF, r, raw','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164648,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164648,35.4,0.4,120,76598,75,NULL,'HMCL, I, cor','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164649,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164649,35.42,0.38,121,76598,75,NULL,'W91CL, r, cor','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164650,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164650,35.45,0.38,123,76598,75,NULL,'W91CL, r, inv','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164651,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164651,35.47,0.4,124,76598,75,NULL,'HMCL, I, inv','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164652,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164652,35.48,0.38,125,76598,75,NULL,'CF, r, cor','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164653,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164653,35.54,0.38,128,76598,75,NULL,'CF, r, inv','NGC 7747',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164654,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164654,27.07,0.09,2.59,76599,NULL,NULL,'optical','kkh 098',NULL,'2010ApJ...712..469M',2010,1,1.1,NULL,'G',0.000001,NULL,'16.7',0.6,'Irr','Brightest group member',NULL,NULL,NULL,1,356.39175,38.71769,0.509,1,51863905854,810373528,12662086,16.7),(164655,'CMD','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164655,27.1,0.07,2.63,76599,NULL,NULL,'IR','kkh 098',NULL,'2010ApJ...712..469M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164656,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164656,26.88,0.1,2.38,76599,NULL,NULL,NULL,'kkh 098',NULL,'2012A&A...540A..49M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164657,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164657,26.95,0.11,2.45,76599,NULL,NULL,NULL,'kkh 098',NULL,'2002A&A...389..812K',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164658,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164658,26.97,0.1,2.48,76599,NULL,NULL,'I','kkh 098',NULL,'2010ApJ...712..469M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164659,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164659,27.02,0.03,2.54,76599,NULL,NULL,'I','kkh 098',NULL,'2009ApJS..183...67D',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164660,'TRGB','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164660,27.25,0.1,2.82,76599,NULL,NULL,'K','kkh 098',NULL,'2010ApJ...712..469M',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164661,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13893','RN',164661,39.91,0.26,749,76600,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 13893',0.28287,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164662,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 13893','RN',164662,40.13,0.21,826,76600,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 13893',0.28287,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164663,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164663,36.46,0.46,196,76601,70,NULL,NULL,'2MASX J23453617-0030006',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000096,NULL,'17.3g',0.23,'NLAGN',NULL,NULL,NULL,'Sy 2',1,356.400708333,-0.50017,0.141,NULL,49398803188,771856299,12060254,17.3),(164664,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164664,36.27,0.25,179,76602,74.4,NULL,NULL,'GIN 737',NULL,'2013AJ....146...86T',2013,1,0.6,NULL,'G',0.000067,NULL,'15.6V',0.4,'S','Group member',NULL,NULL,NULL,1,356.4187917,9.23533,0.221,NULL,51790348704,809224198,12644128,15.6),(164665,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164665,36.5,0.2,199,76602,70,NULL,NULL,'GIN 737',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164666,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164666,38,0.46,399,76603,70,NULL,NULL,'SDSS J234546.80-005027.4',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,356.445167,-0.84094,0.125,NULL,49400390201,771881096,12060642,17.7),(164667,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164667,36.02,0.5,160,76604,70,NULL,NULL,'2MASX J23454733-0235294',NULL,'2014MNRAS.445.2677S',2014,1,0.86,NULL,'G',0.000077,NULL,'15.94',0.54,NULL,NULL,NULL,NULL,NULL,1,356.44725,-2.59153,0.089,NULL,49453821751,772715964,12073686,15.94),(164668,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164668,35.55,0.05,129,76605,NULL,NULL,NULL,'CGCG 477-005',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000035,NULL,'15.3',0.5,'Sd',NULL,NULL,NULL,NULL,1,356.448,27.59783,0.145,NULL,52006857207,812607143,12696986,15.3),(164669,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164669,35.94,0.53,154,76606,70,NULL,NULL,'NGC 7749',NULL,'2014MNRAS.445.2677S',2014,1,1.6,NULL,'G',0.000067,NULL,'14.34',1.1,'SA0^0^',NULL,NULL,NULL,NULL,1,356.448125,-29.51781,NULL,NULL,50040779460,781887179,12216987,14.34),(164670,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164670,37.59,0.46,330,76607,70,NULL,NULL,'2MASX J23454838-0042064',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,356.4517083,-0.70164,0.141,NULL,49399857772,771872777,12060512,17.9),(164671,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164671,38.35,0.23,467,76608,70,NULL,NULL,'SDSS J234549.45+010420.2',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000074,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,356.456083,1.07233,0.121,NULL,51552092858,805501450,12585960,18.5),(164672,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164672,38.22,0.46,441,76609,70,NULL,NULL,'2MASX J23455033+1354522',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000137,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,356.4597917,13.91447,0.089,NULL,51658305925,807161030,12611891,17.8),(164673,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164673,33.24,0.49,44.5,76610,75,NULL,'IR','IC 1508',NULL,'2011yCatp016004901K',2011,1,2,NULL,'G',0.000013,NULL,'13.87',0.5,'Sdm:','Isolated galaxy',NULL,NULL,NULL,1,356.4794583,12.06175,0.113,NULL,51650503127,807039111,12609986,13.87),(164674,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164674,33.32,0.2,46.1,76610,74.4,NULL,NULL,'IC 1508',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164675,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164675,33.74,0.1,56.1,76610,NULL,NULL,NULL,'IC 1508',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164676,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164676,36.72,0.46,221,76611,70,NULL,NULL,'2MASX J23455582-1006556',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000138,NULL,'17.0g',0.27,NULL,NULL,NULL,NULL,NULL,1,356.482667,-10.11558,0.105,NULL,49624700010,775385937,12115405,17),(164677,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164677,37.14,0.46,268,76612,70,NULL,NULL,'2MASX J23460232-0921176',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000173,NULL,'17.2g',0.18,NULL,NULL,NULL,NULL,NULL,1,356.509667,-9.35497,0.079,NULL,49626034053,775406782,12115730,17.2),(164678,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15158','RN',164678,42.99,0.18,2940,76613,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15158',0.348646,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164679,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15158','RN',164679,43.04,0.23,3010,76613,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15158',0.348646,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164680,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164680,38.35,0.23,467,76614,70,NULL,NULL,'2MASX J23460891+0101496',NULL,'2015arXiv151105856S',2015,1,0.47,NULL,'G',0.000091,NULL,'16.9g',0.25,'AGN',NULL,NULL,NULL,NULL,1,356.537,1.03031,0.097,NULL,51551308375,805489193,12585768,16.9),(164681,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164681,38.35,0.23,467,76615,70,NULL,NULL,'2MASX J23460911+0059086',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000102,NULL,'17.7g',0.18,'NLAGN',NULL,NULL,NULL,'Sy 2',1,356.537875,0.98581,0.097,NULL,51551321428,805489397,12585771,17.7),(164682,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164682,38.35,0.23,467,76616,70,NULL,NULL,'SDSS J234611.60+005917.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000081,NULL,'18.5g',0.11,NULL,NULL,NULL,NULL,NULL,1,356.548333,0.98828,0.097,NULL,51551318785,805489356,12585771,18.5),(164683,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164683,34.41,0.51,76.3,76617,70,NULL,NULL,'ESO 471- G 010',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000023,NULL,'14.96',0.4,'Sb','Group member',NULL,NULL,NULL,1,356.5627917,-28.09897,0.066,NULL,50061221146,782206580,12221977,14.96),(164684,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164684,35.29,0.4,115,76617,NULL,NULL,'mean','ESO 471- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164685,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164685,35.31,0.47,115,76617,NULL,NULL,'H','ESO 471- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164686,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164686,35.37,0.45,118,76617,NULL,NULL,'K','ESO 471- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164687,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164687,35.42,0.26,121,76617,NULL,NULL,NULL,'ESO 471- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164688,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164688,35.42,0.46,121,76617,NULL,NULL,'J','ESO 471- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164689,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164689,35.46,0.2,124,76617,74.4,NULL,NULL,'ESO 471- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164690,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164690,35.47,0.25,124,76617,NULL,NULL,'Malmquist cor.','ESO 471- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164691,'L(H{beta})-{sigma}','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164691,45.01,NULL,1640,76618,74.3,NULL,NULL,'[HB89] 2343+125:BM0133',1.4774,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'22.5R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.567417,12.80258,0.125,NULL,51651440542,807053758,12610214,22.5),(164692,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 20263','RN',164692,42.97,0.38,3060,76619,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20263',0.283252,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164693,'L(H{beta})-{sigma}','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164693,46.2,NULL,1590,76620,74.3,NULL,NULL,'[HB89] 2343+125:BX0418',2.3052,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'23.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.577375,12.7965,0.125,NULL,51651439796,807053746,12610214,23.9),(164694,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15319','RN',164694,41.53,0.14,1520,76621,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15319',0.330121,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164695,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 15319','RN',164695,41.8,0.21,1720,76621,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15319',0.330121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164696,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164696,34.49,0.48,79.2,76622,70,NULL,NULL,'IC 5349 NED01',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.000033,NULL,'15.32',NULL,'S0','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,356.594583,-28.00603,0.052,NULL,50052864807,782076012,12219937,15.32),(164697,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164697,34.41,0.45,76.1,76623,NULL,NULL,'K','IC 5349',NULL,'2007A&A...465...71T',2007,1,NULL,NULL,'GPair',0.000213,NULL,NULL,NULL,'S0?',NULL,NULL,NULL,NULL,1,356.595125,-28.00511,0.052,NULL,50052864812,782076012,12219937,NULL),(164698,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164698,35.28,0.4,114,76623,NULL,NULL,'mean','IC 5349',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164699,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 08018','RN',164699,41.15,0.15,1430,76624,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 08018',0.19078,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164700,'SNIa SDSS','2016-12-15 15:16:08','2016-12-16 11:21:25','1','SDSS-II SN 08018','RN',164700,41.64,0.26,1780,76624,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 08018',0.19078,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164701,'L(H{beta})-{sigma}','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164701,46.04,NULL,1605,76625,74.3,NULL,NULL,'[HB89] 2343+125:BX0660',2.1735,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'24.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.622625,12.82931,0.089,NULL,51651444487,807053820,12610215,24.3),(164702,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,'R',164702,36.96,0.46,247,76626,70,NULL,NULL,'2MASX J23463230+0114047',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',NULL,NULL,'17.12',0.29,NULL,NULL,NULL,NULL,NULL,1,356.634541667,1.23456,0.125,NULL,51551257166,805488393,12585756,17.12),(164703,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164703,36.51,0.49,200,76627,70,NULL,NULL,'2MASX J23463276-2314351',NULL,'2014MNRAS.445.2677S',2014,1,0.95,NULL,'G',0.00015,NULL,'15.87',0.3,'E',NULL,NULL,NULL,NULL,1,356.636625,-23.24303,0.041,NULL,50002610043,781290781,12207668,15.87),(164704,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164704,36.2,0.57,174,76628,NULL,NULL,'Malmquist cor.','2MASX J23463576-2759455',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000027,NULL,'15.83',0.37,'Sbc','Group member',NULL,NULL,NULL,1,356.648917,-27.99597,0.052,NULL,50052874024,782076156,12219939,15.83),(164705,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164705,36.54,0.49,203,76628,NULL,NULL,NULL,'2MASX J23463576-2759455',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164706,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164706,36.58,0.2,207,76628,74.4,NULL,NULL,'2MASX J23463576-2759455',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164707,'FP','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164707,36.44,0.77,194,76629,70,NULL,NULL,'6dF J2346367-353118',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.653083,-35.52164,NULL,NULL,49960959236,780639988,12197499,15),(164708,'IRAS','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164708,32.78,0.8,36,76630,75,NULL,'CF, r','NGC 7750',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000003,NULL,'13.49',0.8,'(R\')SB(rs)c pec:','Pair member, wide',NULL,NULL,NULL,1,356.657667,3.79981,0.133,NULL,51606352122,806349251,12599207,13.49),(164709,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164709,31.25,0.37,17.8,76630,NULL,NULL,NULL,'NGC 7750',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164710,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164710,31.79,0.43,22.8,76630,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7750',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164711,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164711,31.92,0.43,24.3,76630,75,NULL,'3.6 micron, color corrected','NGC 7750',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164712,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164712,32.02,0.6,25.3,76630,NULL,NULL,'Malmquist cor.','NGC 7750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164713,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164713,32.06,0.2,25.8,76630,74.4,NULL,NULL,'NGC 7750',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164714,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164714,32.23,0.54,27.9,76630,NULL,NULL,NULL,'NGC 7750',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164715,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164715,32.23,0.69,27.9,76630,100,NULL,'mid-IR','NGC 7750',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164716,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164716,32.24,0.4,28,76630,73,NULL,'opt','NGC 7750',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164717,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164717,32.49,0.46,31.5,76630,NULL,NULL,'J','NGC 7750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164718,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164718,32.49,0.47,31.5,76630,NULL,NULL,'H','NGC 7750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164719,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164719,32.54,0.45,32.1,76630,NULL,NULL,'K','NGC 7750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164720,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164720,32.68,0.4,34.3,76630,NULL,NULL,'mean','NGC 7750',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164721,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164721,32.86,0.38,37.4,76630,75,NULL,'CF, r, raw','NGC 7750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164722,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164722,32.94,0.38,38.7,76630,75,NULL,'CF, r, inv','NGC 7750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164723,'Tully-Fisher','2016-12-15 15:16:08','2016-12-16 11:21:25','1',NULL,NULL,164723,33.09,0.38,41.6,76630,75,NULL,'CF, r, cor','NGC 7750',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164724,'FP','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,NULL,164724,34.52,0.25,80.2,76631,74.4,NULL,NULL,'2MASX J23463843-2815115',NULL,'2013AJ....146...86T',2013,1,0.41,NULL,'G',0.00005,NULL,'16.90',0.29,'Ep','Group member',NULL,NULL,NULL,1,356.660166667,-28.25311,0.063,NULL,50052942512,782077226,12219956,16.9),(164725,'FP','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,'R',164725,37,0.46,251,76632,70,NULL,NULL,'2MASX J23464017+1507135',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000199,NULL,'16.2g',0.37,NULL,NULL,NULL,NULL,NULL,1,356.66725,15.12056,0.045,NULL,51672226165,807378533,12615289,16.2),(164726,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,NULL,164726,36.53,0.54,203,76633,NULL,NULL,'Malmquist cor.','2MASX J23464090-2805595',NULL,'2009ApJS..182..474S',2009,1,0.45,NULL,'G',0.000027,NULL,'16.64',0.31,'Sbc','Group member',NULL,NULL,NULL,1,356.6704583,-28.09989,0.041,NULL,50052916735,782076823,12219950,16.64),(164727,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,NULL,164727,36.68,0.51,217,76633,NULL,NULL,NULL,'2MASX J23464090-2805595',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164728,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:25','1',NULL,NULL,164728,36.72,0.2,221,76633,74.4,NULL,NULL,'2MASX J23464090-2805595',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164729,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:25','1','SDSS-II SN 05590','RN',164729,42.21,0.3,1910,76634,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05590',0.447846,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164730,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:25','1','SDSS-II SN 05590','RN',164730,42.73,0.37,2430,76634,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05590',0.447846,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164731,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05590','N',164731,42.15,0.21,2690,76634,70,NULL,'SALT 2','SDSS-II SN 05590',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164732,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05590','N',164732,42.25,0.21,2820,76634,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 05590',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164733,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15784','R',164733,40.12,0.15,827,76635,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J234641.69-003657.0',0.2771,'2014arXiv1401.3317S',2014,1,0.09,NULL,'G',0.0001,NULL,'19.9g',0.08,NULL,NULL,NULL,NULL,NULL,1,356.67375,-0.61583,0.153,NULL,49399223396,771862865,12060357,19.9),(164734,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15784','R',164734,40.13,0.22,833,76635,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J234641.69-003657.0',0.2771,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164735,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15784',NULL,164735,40.45,0.11,1230,76635,70,NULL,'SALT 2','SDSS J234641.69-003657.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164736,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15784',NULL,164736,40.48,0.11,1250,76635,70,NULL,'SALT 2, Malmquist cor.','SDSS J234641.69-003657.0',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164737,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164737,37.15,0.46,269,76636,70,NULL,NULL,'2MASX J23464354-1005318',NULL,'2015arXiv151105856S',2015,1,0.56,NULL,'G',0.00015,NULL,'15.8g',0.48,'E0',NULL,NULL,NULL,NULL,1,356.681417,-10.09208,0.105,NULL,49624238549,775378727,12115292,15.8),(164738,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164738,35.87,0.46,149,76637,70,NULL,NULL,'CGCG 455-046',NULL,'2015arXiv151105856S',2015,1,0.75,NULL,'G',0.000117,NULL,'15.0g',0.58,'E0',NULL,NULL,NULL,NULL,1,356.692333,16.04308,0.045,NULL,51670531169,807352049,12614875,15),(164739,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03519','RN',164739,42.17,0.21,1910,76638,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03519',0.424167,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164740,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03519','RN',164740,42.31,0.16,2030,76638,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03519',0.424167,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164741,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164741,37.01,0.55,252,76639,70,NULL,NULL,'2MASX J23464844-0315479',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00008,NULL,'16.59',0.39,NULL,NULL,NULL,NULL,NULL,1,356.7017917,-3.26311,0.097,NULL,49456083422,772751303,12074239,16.59),(164742,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164742,35.11,0.4,105,76640,75,NULL,'Edat, raw','2dFGRS S194Z041',NULL,'1997ApJS..109..333W',1997,1,0.27,'Green, et al. (1990,MNRAS,243,159) give v = 8020 km/sec.','G',0.000213,NULL,'18.49',0.18,'E','Group member',NULL,NULL,NULL,1,356.72725,-28.04697,0.052,NULL,50052912880,782076763,12219949,18.49),(164743,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164743,35.15,0.4,107,76640,75,NULL,'Edat, cor','2dFGRS S194Z041',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164744,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164744,35.65,0.25,135,76640,74.4,NULL,NULL,'2dFGRS S194Z041',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164745,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15899','RN',164745,37.83,0.09,344,76641,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15242 HOST',0.071174,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164746,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15242','RN',164746,37.89,0.1,354,76641,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 15242 HOST',0.071174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164747,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15899','RN',164747,38.83,0.25,545,76641,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15242 HOST',0.071174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164748,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15242','RN',164748,38.98,0.25,583,76641,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 15242 HOST',0.071174,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164749,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164749,32.49,0.47,31.5,76642,NULL,NULL,'H','NGC 7753',NULL,'2007A&A...465...71T',2007,1,3.3,NULL,'G',0.00002,NULL,'12.83',2.1,'SAB(rs)bc','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,356.770125,29.48344,0.193,NULL,51972235587,812066181,12688534,12.83),(164750,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164750,32.53,0.45,32.1,76642,NULL,NULL,'K','NGC 7753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164751,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164751,32.6,0.46,33.1,76642,NULL,NULL,'J','NGC 7753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164752,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164752,34.21,0.4,69.6,76642,NULL,NULL,'mean','NGC 7753',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164753,'BL Lac Luminosity','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164753,37,NULL,241,76643,NULL,NULL,NULL,'2MASX J23470479+5142179',0.044,'2005ApJ...635..173S',2005,1,NULL,'TXS codes: lobes(W)','G',NULL,NULL,'12.89',NULL,'BLLAC',NULL,NULL,NULL,'BL Lac',1,356.770167,51.70497,NULL,NULL,53210740274,831417816,12990903,12.89),(164754,'GeV TeV ratio','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164754,38.09,NULL,414,76643,72,NULL,NULL,'2MASX J23470479+5142179',NULL,'2010MNRAS.405L..76P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164755,'GeV TeV ratio','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164755,39.28,0.28,717,76643,72,NULL,NULL,'2MASX J23470479+5142179',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164756,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164756,37.89,0.46,379,76644,70,NULL,NULL,'2MASX J23470552+1337376',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000163,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,356.773083,13.62706,0.073,NULL,51650958455,807046225,12610097,17.3),(164757,'GRB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164757,48.28,1.48,10400,76645,NULL,NULL,NULL,'GRB 080810',3.35,'2010JCAP...08..020W',2010,1,NULL,NULL,'GammaS',NULL,NULL,NULL,NULL,'Swift/XRT',NULL,NULL,NULL,NULL,1,356.793917,0.31978,0.097,NULL,51549913809,805467403,12585428,NULL),(164758,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12941',NULL,164758,40.12,0.14,1060,76646,70,NULL,'SN photometric redshift distance, z photo =0.286 +/- 0.023','SDSS-II SN 12941',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.7797917,-0.59917,0.153,NULL,49399446724,771866355,12060411,NULL),(164759,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821',NULL,164759,39.57,0.29,820,76647,70,NULL,'SN photometric redshift distance, z photo =0.214 +/- 0.035','SDSS-II SN 19821',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,356.779416667,1.02592,0.097,NULL,51551293229,805488956,12585764,NULL),(164760,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821','R',164760,40.74,0.23,1110,76647,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19821',0.266012,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164761,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821','R',164761,40.78,0.18,1130,76647,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19821',0.266012,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164762,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821',NULL,164762,40.53,0.14,1280,76647,70,NULL,'SALT 2','SDSS-II SN 19821',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164763,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19821',NULL,164763,40.55,0.14,1290,76647,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19821',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164764,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164764,36.49,0.65,199,76648,70,NULL,NULL,'6dF J2347070-355018',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.9R',NULL,NULL,NULL,NULL,NULL,NULL,1,356.7797083,-35.83819,NULL,NULL,49962012656,780656447,12197756,13.9),(164765,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164765,35.62,0.52,133,76649,70,NULL,NULL,'MCG +00-60-047 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.65,NULL,'G',0.000088,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,356.785541667,-0.61086,0.153,NULL,49399446536,771866352,12060411,15.7),(164766,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164766,34.7,0.23,87.1,76650,74.4,NULL,NULL,'2MASX J23471207-2755483',NULL,'2013AJ....146...86T',2013,1,0.57,NULL,'G',0.000117,NULL,'16.06',0.5,'S0','Group member',NULL,NULL,NULL,1,356.800417,-27.93006,0.052,NULL,50053633191,782088018,12220125,16.06),(164767,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16458','RN',164767,41.3,0.35,1540,76651,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16458',0.186372,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164768,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16458','RN',164768,41.4,0.29,1610,76651,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16458',0.186372,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164769,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164769,34.96,0.63,98.1,76652,NULL,NULL,NULL,'2MASX J23471337-2801023',NULL,'2009ApJS..182..474S',2009,1,0.48,NULL,'G',0.00003,NULL,'16.71',0.32,'S0/a','Group member',NULL,NULL,NULL,1,356.805291667,-28.017,0.052,NULL,50053637109,782088079,12220126,16.71),(164770,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164770,35,0.2,100,76652,74.4,NULL,NULL,'2MASX J23471337-2801023',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164771,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164771,35.45,0.5,123,76652,NULL,NULL,'Malmquist cor.','2MASX J23471337-2801023',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164772,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19447','RN',164772,41.6,0.22,1480,76653,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 19447',0.406412,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164773,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19447','RN',164773,42.31,0.25,2060,76653,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19447',0.406412,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164774,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164774,35.11,0.4,105,76654,75,NULL,'Edat, raw','2MASX J23471420-2801483',NULL,'1997ApJS..109..333W',1997,1,0.26,NULL,'G',0.000097,NULL,'17.80',0.24,'E','Group member',NULL,NULL,NULL,1,356.8089583,-28.03011,0.052,NULL,50053636212,782088065,12220126,17.8),(164775,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164775,35.15,0.4,107,76654,75,NULL,'Edat, cor','2MASX J23471420-2801483',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164776,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164776,35.92,0.23,153,76654,74.4,NULL,NULL,'2MASX J23471420-2801483',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164777,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164777,34.79,0.25,90.8,76655,74.4,NULL,NULL,'2MASX J23471439-2811343',NULL,'2013AJ....146...86T',2013,1,0.47,NULL,'G',0.00006,NULL,'16.70',0.34,'S0','Group member',NULL,NULL,NULL,1,356.809833333,-28.19281,0.041,NULL,50052899630,782076556,12219946,16.7),(164778,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164778,34.72,0.4,87.9,76656,75,NULL,'Edat, raw','IC 5350',NULL,'1997ApJS..109..333W',1997,1,0.7,NULL,'G',0.00005,NULL,'14.41',0.6,'S0','Group member',NULL,NULL,NULL,1,356.810958333,-27.95772,0.052,NULL,50053640295,782088129,12220127,14.41),(164779,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164779,35.09,0.4,104,76656,75,NULL,'Edat, cor','IC 5350',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164780,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164780,35.07,0.23,103,76656,74.4,NULL,NULL,'IC 5350',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164781,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164781,33.98,0.8,62.4,76657,75,NULL,'W91PP, r','IC 5355',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.000013,NULL,'14.39',0.6,'SBcd:          HII','Isolated galaxy',NULL,NULL,NULL,1,356.8137083,32.78275,0.221,NULL,52028801230,812950019,12702344,14.39),(164782,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164782,33.55,0.38,51.4,76657,75,NULL,'W91PP, r, raw','IC 5355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164783,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164783,33.59,0.38,52.3,76657,75,NULL,'W91PP, r, inv','IC 5355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164784,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164784,33.83,0.2,58.3,76657,74.4,NULL,NULL,'IC 5355',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164785,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164785,33.84,0.39,58.7,76657,NULL,NULL,NULL,'IC 5355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164786,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164786,33.91,0.38,60.6,76657,75,NULL,'W91PP, r, cor','IC 5355',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164787,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164787,34.24,0.33,70.5,76657,NULL,NULL,'Malmquist cor.','IC 5355',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164788,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164788,34.26,0.49,71,76658,75,NULL,'IR','IC 1509',NULL,'2011yCatp016004901K',2011,1,1.3,NULL,'G',0.00011,NULL,'15.19',0.2,NULL,NULL,NULL,NULL,NULL,1,356.8195,-15.30642,0.036,NULL,49590874211,774857409,12107147,15.19),(164789,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164789,34.58,0.2,82.4,76658,74.4,NULL,NULL,'IC 1509',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164790,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164790,34.68,0.32,86.5,76658,NULL,NULL,NULL,'IC 1509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164791,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164791,34.79,0.31,90.9,76658,NULL,NULL,'Malmquist cor.','IC 1509',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164792,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164792,35.11,0.4,105,76659,75,NULL,'Edat, raw','2MASX J23471684-2807265',NULL,'1997ApJS..109..333W',1997,1,0.45,NULL,'G',0.000057,NULL,'16.40',0.38,'E','Group member',NULL,NULL,NULL,1,356.820208333,-28.12422,0.041,NULL,50052903780,782076621,12219947,16.4),(164793,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164793,35.15,0.4,107,76659,75,NULL,'Edat, cor','2MASX J23471684-2807265',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164794,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164794,35.01,0.23,100,76659,74.4,NULL,NULL,'2MASX J23471684-2807265',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164795,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164795,35.23,0.51,111,76660,70,NULL,NULL,'2MASX J23471871-0159435',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.000073,NULL,'16.27',0.31,NULL,NULL,NULL,NULL,NULL,1,356.827958333,-1.99536,0.073,NULL,49398356412,771849318,12060145,16.27),(164796,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164796,35.82,0.23,146,76661,74.4,NULL,NULL,'2MASX J23472017-2803465',NULL,'2013AJ....146...86T',2013,1,0.36,NULL,'G',0.00005,NULL,'17.16',0.29,'S0','Group member',NULL,NULL,NULL,1,356.8337917,-28.06289,0.041,NULL,50053603626,782087556,12220118,17.16),(164797,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164797,35.55,0.23,129,76662,74.4,NULL,NULL,'2MASX J23472237-2758325',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000043,NULL,'16.87',0.24,'S0','Group member',NULL,NULL,NULL,1,356.8432083,-27.97572,0.052,NULL,50053640475,782088132,12220127,16.87),(164798,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164798,34.26,0.45,71.1,76663,NULL,NULL,'K','IC 5357',NULL,'2007A&A...465...71T',2007,1,1.7,NULL,'G',0.000073,NULL,'14.33',1.1,'SAB0- pec:','Compact group member',NULL,NULL,NULL,1,356.845791667,-2.30067,0.105,NULL,49397620842,771837825,12059966,14.33),(164799,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164799,34.92,0.4,96.2,76663,NULL,NULL,'mean','IC 5357',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `tcs_cat_ned_d_v13_1_0` VALUES (164800,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15568','R',164800,40.4,0.39,997,76664,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15568',0.20661,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.846333,1.05019,0.097,NULL,51549536426,805461506,12585336,NULL),(164801,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15568','R',164801,41.23,0.37,1460,76664,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15568',0.20661,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164802,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164802,36,0.25,158,76665,74.4,NULL,NULL,'2MASX J23472326-2807085',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000057,NULL,'16.43',0.42,'S0','Group member',NULL,NULL,NULL,1,356.846833333,-28.11906,0.041,NULL,50052905272,782076644,12219947,16.43),(164803,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2000cw',NULL,164803,35.64,0.16,130,76666,70,NULL,'SALT 2','CGCG 498-012',0.030134,'2013MNRAS.433.2240G',2013,1,0.9,NULL,'G',0.000023,NULL,'15.08',0.4,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,356.8517917,28.39353,0.157,NULL,52002248379,812535130,12695861,15.08),(164804,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164804,35.38,0.8,119,76666,75,NULL,'W91CL, r','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164805,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164805,35.38,0.8,119,76666,75,NULL,'HMCL, I','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164806,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164806,34.89,0.38,95.1,76666,75,NULL,'W91CL, r, raw','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164807,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164807,34.9,0.4,95.4,76666,75,NULL,'HMCL, I, raw','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164808,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164808,35.03,0.38,102,76666,75,NULL,'W91CL, r, inv','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164809,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164809,35.08,0.4,104,76666,75,NULL,'HMCL, I, inv','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164810,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164810,35.11,0.38,105,76666,75,NULL,'W91CL, r, cor','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164811,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164811,35.12,0.4,105,76666,75,NULL,'HMCL, I, cor','CGCG 498-012',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164812,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164812,35.12,0.43,106,76666,75,NULL,'3.6 micron, color corrected','CGCG 498-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164813,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164813,35.13,0.2,106,76666,74.4,NULL,NULL,'CGCG 498-012',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164814,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164814,35.19,0.43,109,76666,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 498-012',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164815,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164815,35.55,0.12,129,76666,NULL,NULL,NULL,'CGCG 498-012',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164816,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05543','R',164816,40.37,0.23,1110,76667,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 05543',0.071622,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,356.859083,0.30325,0.097,NULL,51549242747,805456917,12585264,NULL),(164817,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05543','R',164817,40.73,0.35,1310,76667,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 05543',0.071622,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164818,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164818,36.25,0.33,178,76668,NULL,NULL,'Malmquist cor.','2MASX J23472739+0915548',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.000023,NULL,'15.3',NULL,'Sc','Group member',NULL,NULL,NULL,1,356.864125,9.26531,0.169,NULL,51788560380,809196255,12643691,15.3),(164819,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164819,36.32,0.32,184,76668,NULL,NULL,NULL,'2MASX J23472739+0915548',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164820,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164820,36.36,0.2,187,76668,74.4,NULL,NULL,'2MASX J23472739+0915548',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164821,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164821,35.11,0.4,105,76669,75,NULL,'Edat, raw','IC 5354',NULL,'1997ApJS..109..333W',1997,1,0.8,'Southwestern, brighter of two.','G',0.000033,NULL,'14.98',0.4,'E','Group member',NULL,NULL,NULL,1,356.868083,-28.136,0.041,NULL,50052906050,782076657,12219947,14.98),(164822,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164822,35.15,0.4,107,76669,75,NULL,'Edat, cor','IC 5354',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164823,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164823,35.54,0.25,128,76669,74.4,NULL,NULL,'IC 5354',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164824,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164824,35.27,0.4,113,76669,NULL,NULL,'mean','IC 5354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164825,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164825,35.67,0.45,136,76669,NULL,NULL,'K','IC 5354',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164826,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164826,35.11,0.4,105,76670,75,NULL,'Edat, raw','IC 5353',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000019,NULL,'14.05',1,'S0-','Group member',NULL,NULL,NULL,1,356.869125,-28.10947,0.041,NULL,50052896911,782076514,12219945,14.05),(164827,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164827,35.15,0.4,107,76670,75,NULL,'Edat, cor','IC 5353',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164828,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164828,35.41,0.23,121,76670,74.4,NULL,NULL,'IC 5353',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164829,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164829,35.28,0.4,114,76670,NULL,NULL,'mean','IC 5353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164830,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164830,35.53,0.45,127,76670,NULL,NULL,'K','IC 5353',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164831,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164831,35.87,0.61,149,76671,NULL,NULL,'Malmquist cor.','2MASX J23473002+0909008',NULL,'2009ApJS..182..474S',2009,1,0.86,NULL,'G',0.000027,NULL,'14.9',NULL,'Sbc','Group member',NULL,NULL,NULL,1,356.875,9.15019,0.201,NULL,51789066120,809204158,12643814,14.9),(164832,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164832,35.94,0.59,154,76671,NULL,NULL,NULL,'2MASX J23473002+0909008',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164833,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164833,35.98,0.2,157,76671,74.4,NULL,NULL,'2MASX J23473002+0909008',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164834,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164834,35.36,0.23,118,76672,74.4,NULL,NULL,'2MASX J23473068-2802355',NULL,'2013AJ....146...86T',2013,1,0.34,NULL,'G',0.000087,NULL,'17.36',0.26,'S0','Group member',NULL,NULL,NULL,1,356.877625,-28.04303,0.041,NULL,50053606175,782087596,12220118,17.36),(164835,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164835,35.11,0.4,105,76673,75,NULL,'Edat, raw','2MASX J23473180-2806255',NULL,'1997ApJS..109..333W',1997,1,0.43,NULL,'G',0.000017,NULL,'16.50',0.28,'E','Group member',NULL,NULL,NULL,1,356.882333333,-28.10708,0.041,NULL,50052896810,782076512,12219945,16.5),(164836,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164836,35.15,0.4,107,76673,75,NULL,'Edat, cor','2MASX J23473180-2806255',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164837,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164837,35.21,0.25,110,76673,74.4,NULL,NULL,'2MASX J23473180-2806255',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164838,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164838,37.62,0.27,333,76674,70,NULL,NULL,'2MASX J23473185+0110056',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,356.88275,1.16825,0.069,NULL,51551190906,805487357,12585739,17.6),(164839,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164839,38.09,0.27,416,76675,70,NULL,NULL,'2MASX J23473270+1449328',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000134,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,356.88625,14.82578,0.065,NULL,51672658444,807385288,12615395,18.4),(164840,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164840,35.11,0.4,105,76676,75,NULL,'Edat, raw','2MASX J23473551-2807315',NULL,'1997ApJS..109..333W',1997,1,0.32,NULL,'G',0.00005,NULL,'16.28',0.29,'E','Group member',NULL,NULL,NULL,1,356.8977917,-28.12536,0.041,NULL,50052891761,782076433,12219944,16.28),(164841,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164841,35.15,0.4,107,76676,75,NULL,'Edat, cor','2MASX J23473551-2807315',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164842,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164842,35.31,0.49,115,76677,75,NULL,'IR','2MFGC 17848',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',NULL,NULL,'11.5K',0.3,NULL,NULL,NULL,NULL,NULL,1,356.9095417,27.52008,0.125,NULL,52002530705,812539542,12695930,11.5),(164843,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164843,35.53,0.44,128,76677,NULL,NULL,'Malmquist cor.','2MFGC 17848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164844,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164844,35.73,0.4,140,76677,NULL,NULL,NULL,'2MFGC 17848',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164845,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164845,35.88,0.2,150,76677,74.4,NULL,NULL,'2MFGC 17848',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164846,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164846,35.57,0.25,130,76678,74.4,NULL,NULL,'IC 5358A',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000019,NULL,'14.38',NULL,'S0','Group member',NULL,NULL,NULL,1,356.929875,-28.14392,0.041,NULL,50052892380,782076443,12219944,14.38),(164847,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164847,35.26,0.43,113,76679,75,NULL,'3.6 micron, color + selection bias corrected','CGCG 477-006',NULL,'2014MNRAS.444..527S',2014,1,0.7,NULL,'G',0.000017,NULL,'15.47',0.2,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,356.9300417,27.42722,0.125,NULL,52002311159,812536111,12695876,15.47),(164848,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164848,35.33,0.43,116,76679,75,NULL,'3.6 micron, color corrected','CGCG 477-006',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164849,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164849,35.48,0.2,125,76679,74.4,NULL,NULL,'CGCG 477-006',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164850,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164850,35.55,0.08,129,76679,NULL,NULL,NULL,'CGCG 477-006',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164851,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164851,35.58,0.12,130,76680,70,NULL,NULL,'ABELL 4038',NULL,'1999AJ....118.1489D',1999,1,NULL,'Position corrected, with thanks to H. Andernach.','GClstr',0.00055,NULL,NULL,NULL,'III    [BM];RI?[A]',NULL,NULL,NULL,NULL,1,356.93,-28.14139,0.041,NULL,50052892403,782076443,12219944,NULL),(164852,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164852,35.43,0.25,122,76681,74.4,NULL,NULL,'2MASX J23474346-2810205',NULL,'2013AJ....146...86T',2013,1,0.45,NULL,'G',0.000063,NULL,'15.92',0.35,'E','Group member',NULL,NULL,NULL,1,356.930625,-28.17258,0.041,NULL,50052894125,782076470,12219944,15.92),(164853,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164853,37.89,0.58,379,76682,70,NULL,NULL,'2MASX J23474337-6019083',NULL,'2014MNRAS.445.2677S',2014,1,0.32,NULL,'G',0.00015,NULL,'17.39',0.21,NULL,NULL,NULL,NULL,NULL,1,356.930667,-60.31911,0,NULL,48748830999,761700484,11901570,17.39),(164854,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164854,35.11,0.4,105,76683,75,NULL,'Edat, raw','2MASX J23474346-2810205',NULL,'1997ApJS..109..333W',1997,1,0.45,NULL,'G',0.000063,NULL,'15.92',0.35,'E','Group member',NULL,NULL,NULL,1,356.930625,-28.17258,0.041,NULL,50052894125,782076470,12219944,15.92),(164855,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164855,35.15,0.4,107,76683,75,NULL,'Edat, cor','2MASX J23474346-2810205',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164856,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19668','RN',164856,41.72,0.15,1570,76684,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 19668',0.407113,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164857,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19668','RN',164857,41.79,0.24,1620,76684,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 19668',0.407113,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164858,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19668','N',164858,41.71,0.13,2200,76684,70,NULL,'SALT 2','SDSS-II SN 19668',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164859,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19668','N',164859,41.78,0.13,2270,76684,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19668',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164860,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164860,35.11,0.4,105,76685,75,NULL,'Edat, raw','IC 5358',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000019,NULL,'13.58',1,'cD;E+4 pec','Pair member (points to parent)',NULL,NULL,NULL,1,356.937667,-28.14075,0.041,NULL,50052892187,782076440,12219944,13.58),(164861,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164861,35.15,0.4,107,76685,75,NULL,'Edat, cor','IC 5358',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164862,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164862,35.23,0.15,111,76685,NULL,NULL,'ABELL 4038, DC 2345-28, 30 galaxies','IC 5358',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164863,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164863,35.33,0.11,116,76685,72,NULL,'ABELL 4038 = Klemola 44 Group, 18 galaxies','IC 5358',NULL,'2002AJ....123.2159B',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164864,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164864,35.45,0.2,123,76685,70,NULL,'ABELL 4038, BGC, Klemola 44 Group','IC 5358',NULL,'1988MNRAS.235.1177L',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164865,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164865,35.05,0.15,102,76685,NULL,NULL,'ABELL 4038, DC 2345-28, 30 galaxies','IC 5358',NULL,'2001ApJ...553...47F',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164866,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164866,35.17,0.16,108,76685,NULL,NULL,'ABELL 4038, DC 2345-28, 30 galaxies','IC 5358',NULL,'2000ApJ...529..768K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164867,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164867,35.31,0.08,115,76685,75,NULL,'ABELL 4038 = DC2345-28 cluster, 27 galaxies','IC 5358',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164868,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164868,35.31,0.08,115,76685,75,NULL,'ABELL 4038 = DC 2345-28 cluster, 27 galaxies','IC 5358',NULL,'1997MNRAS.291..488H',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164869,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164869,35.4,0.49,120,76685,70,NULL,NULL,'IC 5358',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164870,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164870,35.48,0.25,125,76685,74.4,NULL,NULL,'IC 5358',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164871,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164871,34.44,0.45,77.4,76685,NULL,NULL,'K','IC 5358',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164872,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164872,35.27,0.4,113,76685,NULL,NULL,'mean','IC 5358',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164873,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164873,35.58,0.12,130,76685,70,NULL,'ABELL 4038, BGC','IC 5358',NULL,'1999AJ....118.1489D',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164874,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164874,35.11,0.4,105,76686,75,NULL,'Edat, raw','NFP J234745.3-280949',NULL,'1997ApJS..109..333W',1997,1,0.17,NULL,'G',0.00007,NULL,'16.89',0.11,'E','Group member',NULL,NULL,NULL,1,356.938667,-28.16358,0.041,NULL,50052894488,782076476,12219944,16.89),(164875,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164875,35.15,0.4,107,76686,75,NULL,'Edat, cor','NFP J234745.3-280949',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164876,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164876,35.43,0.23,122,76686,74.4,NULL,NULL,'NFP J234745.3-280949',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164877,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164877,34.31,0.23,72.8,76687,74.4,NULL,NULL,'2MASX J23474579-2806275',NULL,'2013AJ....146...86T',2013,1,0.25,NULL,'G',0.000063,NULL,'17.90',0.19,'S0','Group member',NULL,NULL,NULL,1,356.9407917,-28.10772,0.041,NULL,50053597744,782087464,12220116,17.9),(164878,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164878,37.68,0.46,344,76688,70,NULL,NULL,'2MASX J23474617-0029458',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000089,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,356.9422083,-0.496,0.149,NULL,49399295070,771863985,12060374,17.3),(164879,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 10727','RN',164879,38.58,0.51,486,76689,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10727',0.071317,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164880,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164880,35.95,0.23,155,76690,74.4,NULL,NULL,'2MASX J23474714-2808059',NULL,'2013AJ....146...86T',2013,1,0.28,NULL,'G',0.00005,NULL,'17.68',0.2,'S0','Pair member (points to parent)',NULL,NULL,NULL,1,356.9465,-28.13497,0.041,NULL,50053597536,782087461,12220116,17.68),(164881,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08882','RN',164881,43.31,0.22,3210,76691,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05544 HOST',0.428984,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164882,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05544','RN',164882,43.4,0.23,3340,76691,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 05544 HOST',0.429037,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164883,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08882','RN',164883,44.16,0.23,4760,76691,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05544 HOST',0.428984,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164884,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05544','RN',164884,44.28,0.26,5030,76691,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 05544 HOST',0.429037,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164885,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164885,37.02,0.46,254,76692,70,NULL,NULL,'2MASX J23474777+1342317',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000192,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,356.949083,13.70872,0.077,NULL,51650910384,807045474,12610085,16.5),(164886,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164886,37.05,0.46,257,76693,70,NULL,NULL,'2MASX J23474820+1535277',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000179,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,356.950833,15.59097,0.057,NULL,51670158328,807346223,12614784,17),(164887,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164887,34.95,0.25,97.7,76694,74.4,NULL,NULL,'2MASX J23474957-2805119',NULL,'2013AJ....146...86T',2013,1,0.31,NULL,'G',0.000053,NULL,'17.38',0.29,'E','Group member',NULL,NULL,NULL,1,356.95625,-28.08653,0.041,NULL,50053610151,782087658,12220119,17.38),(164888,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164888,35.41,0.25,121,76695,74.4,NULL,NULL,'2MASX J23474954-2812129',NULL,'2013AJ....146...86T',2013,1,0.39,NULL,'G',0.000057,NULL,'17.07',0.34,'S0','Group member',NULL,NULL,NULL,1,356.95625,-28.20367,0.041,NULL,50052927195,782076987,12219952,17.07),(164889,'Tully est','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164889,31.78,0.8,22.7,76696,75,NULL,NULL,'ESO 149- G 001',NULL,'1988NBGC.C....0000T',1988,1,3.3,'Bright star superposed 15 arcsec north-northeast.','G',0.00001,NULL,'13.59',0.7,'SAB(s)dm',NULL,NULL,NULL,NULL,1,356.953083,-57.0725,0,NULL,48808568173,762633877,11916154,13.59),(164890,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164890,31.6,0.43,20.8,76696,75,NULL,'3.6 micron, color + selection bias corrected','ESO 149- G 001',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164891,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164891,38.09,0.27,416,76697,70,NULL,NULL,'SDSS J234751.27+145703.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000147,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,356.963625,14.95111,0.061,NULL,51672134395,807377099,12615267,18.4),(164892,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164892,32.88,0.8,37.7,76698,75,NULL,'MAT, I','NGC 7755',NULL,'1997ApJS..109..333W',1997,1,3.8,NULL,'G',0.00001,NULL,'12.56',2.9,'SB(r)bc        HII','Isolated galaxy',NULL,NULL,NULL,1,356.965667,-30.52203,NULL,NULL,50043989792,781937340,12217770,12.56),(164893,'Sosies','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164893,32.65,0.45,33.9,76698,NULL,NULL,NULL,'NGC 7755',NULL,'2002A&A...393...57T',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164894,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164894,32.1,0.43,26.3,76698,75,NULL,'MAT, I, raw','NGC 7755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164895,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164895,32.23,0.4,27.9,76698,NULL,NULL,NULL,'NGC 7755',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164896,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164896,32.23,0.4,27.9,76698,73,NULL,'opt','NGC 7755',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164897,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164897,32.29,0.43,28.7,76698,75,NULL,'MAT, I, inv','NGC 7755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164898,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164898,32.3,0.43,28.9,76698,75,NULL,'MAT, I, cor','NGC 7755',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164899,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164899,32.46,0.32,31.1,76698,85,NULL,'I, raw','NGC 7755',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164900,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164900,32.52,0.32,31.9,76698,85,NULL,'I, inv','NGC 7755',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164901,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164901,32.84,0.4,37,76698,75,NULL,'B','NGC 7755',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164902,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164902,35.62,0.36,133,76699,NULL,NULL,NULL,'ESO 149- G 002',NULL,'2009ApJS..182..474S',2009,1,0.85,NULL,'G',0.000033,NULL,'16.08',0.37,'Sc',NULL,NULL,NULL,NULL,1,356.968875,-53.36564,0,NULL,48636394311,759943661,11874119,16.08),(164903,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164903,35.66,0.2,136,76699,74.4,NULL,NULL,'ESO 149- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164904,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164904,35.68,0.35,137,76699,NULL,NULL,'Malmquist cor.','ESO 149- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164905,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164905,35.21,0.49,110,76700,75,NULL,'IR','FGC 2536',NULL,'2011yCatp016004901K',2011,1,1.48,NULL,'G',0.000013,NULL,'16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,356.986625,28.13167,0.189,NULL,52002983377,812546615,12696040,16.6),(164906,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164906,35.27,NULL,113,76700,NULL,NULL,NULL,'FGC 2536',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164907,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164907,35.46,NULL,123,76700,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2536',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164908,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164908,35.46,NULL,124,76700,NULL,NULL,'Dipole','FGC 2536',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164909,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164909,35.46,NULL,124,76700,NULL,NULL,'Dipole + Quadrupole','FGC 2536',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164910,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164910,38.09,0.27,416,76701,70,NULL,NULL,'2MASX J23475798+1446417',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000147,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,356.9917083,14.77817,0.061,NULL,51671807445,807371991,12615187,17.6),(164911,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164911,35.06,0.45,103,76702,NULL,NULL,'K','UGC 12785',NULL,'2007A&A...465...71T',2007,1,1.1,NULL,'G',0.000067,NULL,'14.89',0.4,'S0',NULL,NULL,NULL,NULL,1,357.002833333,27.37539,0.125,NULL,52004172954,812565202,12696331,14.89),(164912,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164912,35.36,0.4,118,76702,NULL,NULL,'mean','UGC 12785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164913,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164913,35.39,0.44,120,76703,NULL,NULL,'Malmquist cor.','2MASX J23480163+2737251',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000001,NULL,'14.40',0.1,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,357.0067917,27.62378,0.125,NULL,52002525785,812539465,12695929,14.4),(164914,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164914,35.53,0.41,128,76703,NULL,NULL,NULL,'2MASX J23480163+2737251',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164915,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164915,35.65,0.2,135,76703,74.4,NULL,NULL,'2MASX J23480163+2737251',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164916,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164916,35.81,0.43,145,76703,75,NULL,'3.6 micron, color corrected','2MASX J23480163+2737251',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164917,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164917,35.92,0.43,153,76703,75,NULL,'3.6 micron, color + selection bias corrected','2MASX J23480163+2737251',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164918,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181',NULL,164918,38.67,1.89,543,76704,70,NULL,'SN photometric redshift distance, z photo =0.136 +/- 0.231','SDSS-II SN 11181',NULL,'2011ApJ...738..162S',2011,1,0.07,NULL,'G',NULL,'PHOT','21.2g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,357.0217083,-0.14336,0.125,NULL,49398465232,771851019,12060172,21.2),(164919,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181','R',164919,41.14,0.33,1260,76704,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 11181',0.34394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164920,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181','R',164920,41.33,0.28,1370,76704,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 11181',0.34394,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164921,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181',NULL,164921,41.04,0.19,1610,76704,70,NULL,'SALT 2','SDSS-II SN 11181',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164922,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 11181',NULL,164922,41.08,0.19,1640,76704,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 11181',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164923,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164923,37.27,0.46,285,76705,70,NULL,NULL,'2MASX J23480849-1046267',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.00015,NULL,'16.5g',0.32,NULL,NULL,NULL,NULL,NULL,1,357.035458333,-10.77419,0.078,NULL,49623981741,775374714,12115229,16.5),(164924,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164924,33.75,0.45,56.1,76706,70,NULL,NULL,'MCG -01-60-041',NULL,'2014MNRAS.445.2677S',2014,1,0.89,NULL,'G',0.000067,NULL,'14.48',0.51,'Sa',NULL,NULL,NULL,NULL,1,357.047125,-2.43258,0.105,NULL,49397607583,771837618,12059962,14.48),(164925,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164925,37.32,0.46,291,76707,70,NULL,NULL,'2MASX J23481171+1405464',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000214,NULL,'16.7g',0.29,NULL,NULL,NULL,NULL,NULL,1,357.0487083,14.09636,0.093,NULL,51652854951,807075858,12610560,16.7),(164926,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164926,38.22,0.46,440,76708,70,NULL,NULL,'2MASX J23481313-0904197',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000177,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,357.054666667,-9.07206,0.083,NULL,49625052934,775391452,12115491,17.6),(164927,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164927,34.64,0.49,84.7,76709,75,NULL,'IR','UGC 12787',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.2,'Sbc',NULL,NULL,NULL,NULL,1,357.057875,21.21533,0.125,NULL,52481796448,820028069,12812938,16),(164928,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164928,37.88,0.46,376,76710,70,NULL,NULL,'2MASX J23481400+1516584',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00016,NULL,'17.8g',0.19,NULL,NULL,NULL,NULL,NULL,1,357.05825,15.28286,0.057,NULL,51663884140,807248189,12613252,17.8),(164929,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164929,37.62,0.27,333,76711,70,NULL,NULL,'2MASX J23481801+0106174',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000093,NULL,'16.5g',0.36,NULL,NULL,NULL,NULL,NULL,1,357.074958333,1.10475,0.081,NULL,51549350664,805458604,12585290,16.5),(164930,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164930,35.31,0.2,115,76712,74.4,NULL,NULL,'KUG 2345+020',NULL,'2013AJ....146...86T',2013,1,0.7,'The APM image includes a neighboring star.','G',0.0001,NULL,'15.2',0.3,'Spiral',NULL,NULL,NULL,NULL,1,357.075417,2.34228,0.129,NULL,51550247723,805472620,12585509,15.2),(164931,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164931,35.69,0.25,137,76713,74.4,NULL,NULL,'2MASX J23481912-2810439',NULL,'2013AJ....146...86T',2013,1,0.32,NULL,'G',0.000053,NULL,'16.07',0.27,'S0','Group member',NULL,NULL,NULL,1,357.079375,-28.17897,0.025,NULL,50053680056,782088750,12220136,16.07),(164932,'GRB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164932,47.21,1.54,6250,76714,100,NULL,NULL,'GRB 060707',3.43,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'Swift',NULL,NULL,NULL,NULL,1,357.079167,-17.90472,0.011,NULL,49539379661,774052807,12094575,NULL),(164933,'GRB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164933,47.33,1.47,6600,76714,100,NULL,NULL,'GRB 060707',3.43,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164934,'GRB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164934,48.12,1.41,9500,76714,69.7,NULL,'Fiducial','GRB 060707',3.43,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164935,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164935,37.62,0.27,333,76715,70,NULL,NULL,'2MASX J23481940+0108274',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000081,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,357.080833,1.14097,0.081,NULL,51549357162,805458705,12585292,17.6),(164936,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164936,35.11,0.4,105,76716,75,NULL,'Edat, raw','2MASX J23482059-2813544',NULL,'1997ApJS..109..333W',1997,1,1.25,NULL,'G',0.00007,NULL,'14.95',1.57,'E','Group member',NULL,NULL,NULL,1,357.08575,-28.23186,0.025,NULL,50053679095,782088735,12220136,14.95),(164937,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164937,35.15,0.4,107,76716,75,NULL,'Edat, cor','2MASX J23482059-2813544',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164938,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164938,35.09,0.47,104,76716,70,NULL,NULL,'2MASX J23482059-2813544',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164939,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164939,36.13,0.23,168,76716,74.4,NULL,NULL,'2MASX J23482059-2813544',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164940,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164940,35.37,0.25,119,76717,74.4,NULL,NULL,'2MASX J23482105-2806584',NULL,'2013AJ....146...86T',2013,1,0.44,NULL,'G',0.000073,NULL,'15.46',0.27,'SB0/a','Group member',NULL,NULL,NULL,1,357.0877917,-28.11603,0.025,NULL,50053725544,782089461,12220147,15.46),(164941,'L(H{beta})-{sigma}','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164941,45.86,NULL,1621,76718,74.3,NULL,NULL,'[HB89] 2345+000:BX0405',2.03,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'23.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,357.088416667,0.41264,0.093,NULL,51549154160,805455533,12585242,23.3),(164942,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 21871','RN',164942,40.06,0.28,855,76719,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21871',0.202701,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164943,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 21871','RN',164943,40.21,0.25,918,76719,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21871',0.202701,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164944,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164944,35.64,0.25,134,76720,74.4,NULL,NULL,'2MASX J23482326-2804294',NULL,'2013AJ....146...86T',2013,1,0.53,NULL,'G',0.000067,NULL,'15.00',0.43,'S0','Group member',NULL,NULL,NULL,1,357.09675,-28.07489,0.025,NULL,50053720094,782089376,12220146,15),(164945,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164945,36.15,0.46,170,76721,70,NULL,NULL,'2MASX J23482333+1430054',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000181,NULL,'16.1g',0.31,'S0',NULL,NULL,NULL,NULL,1,357.09725,14.50136,0.061,NULL,51663375355,807240239,12613128,16.1),(164946,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164946,36.05,0.52,163,76722,70,NULL,NULL,'2MASX J23482479-6327195',NULL,'2014MNRAS.445.2677S',2014,1,0.42,NULL,'G',0.00015,NULL,'16.59',0.36,NULL,NULL,NULL,NULL,NULL,1,357.103166667,-63.45544,0,NULL,48728987018,761390422,11896725,16.59),(164947,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19992','R',164947,40.49,0.22,1020,76723,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pb','SN 2007pb',0.226,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,357.104167,-1.185,0.121,NULL,49398998294,771859348,12060302,NULL),(164948,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19992','R',164948,40.68,0.15,1120,76723,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pb','SN 2007pb',0.226,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164949,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164949,35.17,0.25,108,76724,74.4,NULL,NULL,'2MASX J23482581-2811214',NULL,'2013AJ....146...86T',2013,1,0.29,NULL,'G',0.00006,NULL,'16.12',0.15,'S0','Group member',NULL,NULL,NULL,1,357.10725,-28.18939,0.025,NULL,50053690445,782088913,12220139,16.12),(164950,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164950,35.2,0.25,110,76725,74.4,NULL,NULL,'2MASX J23482619-2816434',NULL,'2013AJ....146...86T',2013,1,NULL,NULL,'G',0.000053,NULL,'15.97',NULL,'S0','Group member',NULL,NULL,NULL,1,357.1089583,-28.27864,0.019,NULL,50052818040,782075281,12219926,15.97),(164951,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164951,35.42,0.62,121,76725,70,NULL,NULL,'2MASX J23482619-2816434',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164952,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164952,36.73,0.63,222,76726,70,NULL,NULL,'2MASX J23482623-2844484',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.16',0.42,NULL,NULL,NULL,NULL,NULL,1,357.109375,-28.74681,0.015,NULL,50035162360,781799411,12215615,16.16),(164953,'L(H{beta})-{sigma}','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164953,46.15,NULL,1595,76727,74.3,NULL,NULL,'[HB89] 2345+000:BX0120',2.2664,'2015MNRAS.451.3001T',2015,1,NULL,NULL,'G',NULL,NULL,'25.0R',NULL,NULL,NULL,NULL,NULL,NULL,1,357.109583,0.34256,0.093,NULL,51549275329,805457427,12585272,25),(164954,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164954,37.88,0.46,377,76728,70,NULL,NULL,'SDSS J234826.50-101602.9',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.00016,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,357.110458333,-10.26747,0.097,NULL,49613078569,775204352,12112568,18.5),(164955,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164955,35.67,0.25,136,76729,74.4,NULL,NULL,'2MASX J23482680-2806374',NULL,'2013AJ....146...86T',2013,1,0.19,NULL,'G',NULL,NULL,'16.91',0.16,'S0','Group member',NULL,NULL,NULL,1,357.1117083,-28.11031,0.025,NULL,50053715391,782089302,12220145,16.91),(164956,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164956,35.06,0.25,103,76730,74.4,NULL,NULL,'2MASX J23482702-2808594',NULL,'2013AJ....146...86T',2013,1,0.27,NULL,'G',0.000037,NULL,'16.88',0.13,'S0','Group member',NULL,NULL,NULL,1,357.112333333,-28.14975,0.025,NULL,50053716812,782089325,12220145,16.88),(164957,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164957,36.77,0.46,226,76731,70,NULL,NULL,'2MASX J23482886-1043346',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000166,NULL,'16.7g',0.27,NULL,NULL,NULL,NULL,NULL,1,357.120375,-10.72622,0.078,NULL,49612471270,775194863,12112419,16.7),(164958,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12875','RN',164958,40.71,0.27,1100,76732,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 12875',0.264695,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164959,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12875','RN',164959,40.74,0.28,1110,76732,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 12875',0.264695,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164960,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164960,35.29,0.39,114,76733,NULL,NULL,NULL,'2MASX J23483815-2806494',NULL,'2009ApJS..182..474S',2009,1,0.46,NULL,'G',0.00003,NULL,'14.69',0.22,'SBb','Group member',NULL,NULL,NULL,1,357.158875,-28.11389,0.025,NULL,50053769477,782090148,12220158,14.69),(164961,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164961,35.33,0.2,116,76733,74.4,NULL,NULL,'2MASX J23483815-2806494',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164962,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164962,35.48,0.35,125,76733,NULL,NULL,'Malmquist cor.','2MASX J23483815-2806494',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164963,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19090','R',164963,40.58,0.32,998,76734,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19090',0.312027,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,357.16225,-0.40642,0.125,NULL,49398565570,771852587,12060196,NULL),(164964,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164964,34.82,NULL,91.9,76735,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2537',NULL,'2010Ap&SS.325..163P',2010,1,0.94,NULL,'G',0.00002,NULL,'16.8',0.1,'Scd',NULL,NULL,NULL,NULL,1,357.17,11.02389,0.133,NULL,51775769608,808996400,12640568,16.8),(164965,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164965,34.82,NULL,92.2,76735,NULL,NULL,'Dipole + Quadrupole','FGC 2537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164966,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164966,34.83,NULL,92.3,76735,NULL,NULL,'Dipole','FGC 2537',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164967,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164967,34.94,NULL,97.3,76735,NULL,NULL,NULL,'FGC 2537',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164968,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164968,34.98,0.2,99.1,76736,74.4,NULL,NULL,'KUG 2346+156',NULL,'2013AJ....146...86T',2013,1,0.68,NULL,'G',0.000033,NULL,'15.6g',0.45,'Sa','Isolated galaxy',NULL,NULL,NULL,1,357.187833333,15.92878,0.073,NULL,51662770390,807230787,12612981,15.6),(164969,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164969,30.84,0.43,14.7,76737,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7757',NULL,'2014MNRAS.444..527S',2014,1,2.5,'HOLM 817B is a double star.','G',0.000007,NULL,'13.14',1.8,'SA(rs)c','Pair member, wide',NULL,NULL,NULL,1,357.189666667,4.17114,0.137,NULL,51600951190,806264862,12597888,13.14),(164970,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164970,31.12,0.43,16.7,76737,75,NULL,'3.6 micron, color corrected','NGC 7757',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164971,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164971,30.55,0.4,12.9,76738,75,NULL,'B','UGC 12791',NULL,'1988NBGC.C....0000T',1988,1,1.6,NULL,'G',0.000003,NULL,'15.76',0.5,'Im:','Group member',NULL,NULL,NULL,1,357.205833,26.22056,0.125,NULL,52003199273,812549988,12696093,15.76),(164972,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164972,37.32,0.46,291,76739,70,NULL,NULL,'2MASX J23485164-0053384',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.00015,NULL,'16.6g',0.26,NULL,NULL,NULL,NULL,NULL,1,357.215167,-0.89403,0.101,NULL,49407255550,771988367,12062318,16.6),(164973,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164973,35.58,0.48,131,76740,70,NULL,NULL,'2MASX J23485638-6007495',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'15.41',0.63,'S0',NULL,NULL,NULL,NULL,1,357.234833,-60.13039,0,NULL,48747527912,761680123,11901251,15.41),(164974,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',164974,34.6,0.49,83.3,76741,75,NULL,'IR','MCG -01-60-042',NULL,'2011yCatp016004901K',2011,1,0.95,NULL,'G',0.00009,NULL,'16',0.12,'Scd            HII',NULL,NULL,NULL,NULL,1,357.241125,-7.05881,0.077,NULL,49441944634,772530384,12070787,16),(164975,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164975,35.16,0.4,108,76742,NULL,NULL,NULL,'2MASX J23490014-2802274',NULL,'2009ApJS..182..474S',2009,1,0.57,NULL,'G',0.000023,NULL,'15.35',0.23,'Sc','Group member',NULL,NULL,NULL,1,357.250541667,-28.04094,0.025,NULL,50053734232,782089597,12220149,15.35),(164976,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164976,35.2,0.2,110,76742,74.4,NULL,NULL,'2MASX J23490014-2802274',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164977,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164977,35.42,0.35,122,76742,NULL,NULL,'Malmquist cor.','2MASX J23490014-2802274',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164978,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164978,34.29,0.8,72.3,76743,75,NULL,'MAT, I','ESO 606- G 011',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00003,NULL,'14.36',0.7,'SB(rs)bc',NULL,NULL,NULL,NULL,1,357.2527083,-19.69281,0.021,NULL,49540216140,774065877,12094779,14.36),(164979,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164979,33.84,1.16,58.7,76743,NULL,NULL,'Malmquist cor.','ESO 606- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164980,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164980,34.09,0.32,65.8,76743,85,NULL,'I, raw','ESO 606- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164981,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164981,34.13,0.32,66.9,76743,85,NULL,'I, inv','ESO 606- G 011',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164982,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164982,34.14,0.43,67.2,76743,75,NULL,'MAT, I, raw','ESO 606- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164983,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164983,34.14,1.01,67.3,76743,NULL,NULL,NULL,'ESO 606- G 011',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164984,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164984,34.18,0.2,68.6,76743,74.4,NULL,NULL,'ESO 606- G 011',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164985,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164985,34.3,0.43,72.5,76743,75,NULL,'MAT, I, inv','ESO 606- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164986,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164986,34.62,0.43,83.9,76743,75,NULL,'MAT, I, cor','ESO 606- G 011',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164987,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164987,35.92,0.8,153,76744,75,NULL,'W91PP, r','UGC 12792',NULL,'1997ApJS..109..333W',1997,1,1.4,NULL,'G',0.000007,NULL,'14.60',0.6,'SBb','Group non-member, background',NULL,NULL,NULL,1,357.2565,26.78847,0.093,NULL,52003916039,812561188,12696268,14.6),(164988,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164988,35.15,0.38,107,76744,NULL,NULL,'Malmquist cor.','UGC 12792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164989,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164989,35.2,0.37,109,76744,NULL,NULL,NULL,'UGC 12792',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164990,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164990,35.24,0.38,112,76744,75,NULL,'W91PP, r, raw','UGC 12792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164991,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164991,35.43,0.38,122,76744,75,NULL,'W91PP, r, cor','UGC 12792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164992,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164992,35.45,0.2,123,76744,74.4,NULL,NULL,'UGC 12792',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164993,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164993,35.47,0.38,124,76744,75,NULL,'W91PP, r, inv','UGC 12792',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164994,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164994,35.53,0.43,128,76744,75,NULL,'3.6 micron, color corrected','UGC 12792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164995,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164995,35.65,0.43,135,76744,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12792',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164996,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164996,36.11,0.4,167,76744,NULL,NULL,'mean','UGC 12792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164997,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164997,36.21,0.47,174,76744,NULL,NULL,'H','UGC 12792',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(164998,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164998,36.04,0.58,162,76745,70,NULL,NULL,'6dF J2349022-350009',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.1R',NULL,NULL,NULL,NULL,NULL,NULL,1,357.259167,-35.00261,NULL,NULL,49961049146,780641392,12197521,15.1),(164999,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,164999,34.97,NULL,98.7,76746,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2539',NULL,'2010Ap&SS.325..163P',2010,1,1.04,NULL,'G',0.000009,NULL,'16.5',0.12,'Scd',NULL,NULL,NULL,NULL,1,357.262625,9.07119,0.209,NULL,51776780616,809012197,12640815,16.5),(165000,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165000,34.98,NULL,98.9,76746,NULL,NULL,'Dipole + Quadrupole','FGC 2539',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165001,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165001,34.98,NULL,99.1,76746,NULL,NULL,'Dipole','FGC 2539',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165002,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165002,35.07,NULL,103,76746,NULL,NULL,NULL,'FGC 2539',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165003,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20658','RN',165003,41.29,0.78,1650,76747,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 20658',0.097288,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165004,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165004,37.6,0.46,331,76748,70,NULL,NULL,'2MASX J23490488+1522596',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000182,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,357.270167,15.38325,0.057,NULL,51664112562,807251758,12613308,17.4),(165005,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20480','R',165005,40.23,0.2,950,76749,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20480',0.167795,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,357.274208333,0.91828,0.081,NULL,51553890840,805529544,12586399,NULL),(165006,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20480','R',165006,40.3,0.27,984,76749,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20480',0.167795,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165007,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165007,35.1,0.67,104,76750,70,NULL,NULL,'2MASX J23490899-0558577',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'16.07',0.2,NULL,NULL,NULL,NULL,NULL,1,357.287416667,-5.98267,0.099,NULL,49438285286,772473207,12069893,16.07),(165008,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20186','R',165008,41.66,0.3,1590,76751,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007pj','SN 2007pj',0.354,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'Ia',NULL,NULL,NULL,NULL,1,357.294583,0.79789,0.093,NULL,51554100315,805532817,12586450,NULL),(165009,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20186','R',165009,41.82,0.22,1700,76751,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007pj','SN 2007pj',0.354,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165010,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165010,35.7,0.38,138,76752,NULL,NULL,'Malmquist cor.','2MASX J23491554-2758344',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000023,NULL,'16.02',0.21,'Sb','Group member',NULL,NULL,NULL,1,357.3147917,-27.97622,0.015,NULL,50053556431,782086819,12220106,16.02),(165011,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165011,35.92,0.34,153,76752,NULL,NULL,NULL,'2MASX J23491554-2758344',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165012,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165012,35.96,0.2,156,76752,74.4,NULL,NULL,'2MASX J23491554-2758344',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165013,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165013,35.56,0.47,129,76753,70,NULL,NULL,'2MASX J23491898-1708352',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.27',0.5,NULL,NULL,NULL,NULL,NULL,1,357.32925,-17.14322,0.018,NULL,49531634665,773931791,12092684,15.27),(165014,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165014,37.86,0.46,374,76754,70,NULL,NULL,'2MASX J23492107+1517083',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000155,NULL,'17.3g',0.21,NULL,NULL,NULL,NULL,NULL,1,357.338,15.28578,0.057,NULL,51664076277,807251191,12613299,17.3),(165015,'Tully est','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165015,29.43,0.8,7.7,76755,75,NULL,NULL,'ESO 348- G 009',NULL,'1988NBGC.C....0000T',1988,1,2.4,'The APMUKS image includes only the bar and a superposed star.','G',0.000003,NULL,'13.6',1,'IBm','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,357.347791667,-37.77192,NULL,NULL,49956710794,780573606,12196462,13.6),(165016,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165016,30.3,NULL,11.5,76755,NULL,NULL,NULL,'ESO 348- G 009',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165017,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165017,37.47,0.46,311,76756,70,NULL,NULL,'2MASX J23492553+0024235',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000091,NULL,'16.7g',0.33,'AGN',NULL,NULL,NULL,NULL,1,357.3565417,0.40656,0.085,NULL,51553457864,805522779,12586293,16.7),(165018,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06714','R',165018,41.82,0.18,1630,76757,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 06714',0.4137,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,357.3600417,0.63189,0.093,NULL,51553425525,805522273,12586285,NULL),(165019,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06714','R',165019,42.02,0.26,1790,76757,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 06714',0.4137,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165020,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06133','RN',165020,40.67,0.18,1110,76758,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 06133',0.224364,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165021,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06133','RN',165021,41.26,0.23,1460,76758,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 06133',0.224364,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165022,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165022,36.93,0.46,243,76759,70,NULL,NULL,'2MASX J23493106-1022154',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.00006,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,357.3795,-10.37103,0.096,NULL,49613105061,775204766,12112574,17.3),(165023,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17633','RN',165023,39.54,0.29,658,76760,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 17633',0.228607,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165024,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17633','RN',165024,39.93,0.29,787,76760,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 17633',0.228607,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165025,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165025,36.31,0.75,183,76761,70,NULL,NULL,'ESO 606- G 012',NULL,'2014MNRAS.445.2677S',2014,1,1.25,NULL,'G',0.00015,NULL,'16.82',0.15,'Sbc',NULL,NULL,NULL,NULL,1,357.396667,-18.43511,0,NULL,49542743608,774105368,12095396,16.82),(165026,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03757','RN',165026,38.48,0.25,464,76762,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 03757',0.070363,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165027,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03757','RN',165027,39.72,0.39,823,76762,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 03757',0.070363,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165028,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165028,34.18,0.8,68.6,76763,75,NULL,'W91PP, r','UGC 12798',NULL,'1997ApJS..109..333W',1997,1,1.2,NULL,'G',0.000033,NULL,'15.36',0.3,'S?',NULL,NULL,NULL,NULL,1,357.41625,29.93208,0.165,NULL,51975556794,812118074,12689344,15.36),(165029,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165029,34.08,0.49,65.6,76763,75,NULL,'IR','UGC 12798',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165030,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165030,34.09,0.2,65.8,76763,74.4,NULL,NULL,'UGC 12798',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165031,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165031,34.11,0.38,66.5,76763,75,NULL,'W91PP, r, raw','UGC 12798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165032,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165032,34.24,0.38,70.3,76763,75,NULL,'W91PP, r, inv','UGC 12798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165033,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165033,34.33,0.38,73.4,76763,75,NULL,'W91PP, r, cor','UGC 12798',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165034,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165034,37.09,0.46,262,76764,70,NULL,NULL,'2MASX J23494289-1055043',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000062,NULL,'17.6g',0.16,NULL,NULL,NULL,NULL,NULL,1,357.428833333,-10.91803,0.078,NULL,49613196882,775206201,12112596,17.6),(165035,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165035,37.71,0.46,349,76765,70,NULL,NULL,'2MASX J23494387+0112187',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000084,NULL,'16.9g',0.29,NULL,NULL,NULL,NULL,NULL,1,357.432833,1.20522,0.093,NULL,51554023336,805531614,12586431,16.9),(165036,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165036,32.87,0.75,37.5,76766,NULL,NULL,NULL,'CGCG 498-017',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000033,NULL,'15.32',0.4,'S?',NULL,NULL,NULL,NULL,1,357.448166667,30.03911,0.165,NULL,51975564265,812118191,12689346,15.32),(165037,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165037,32.91,0.2,38.2,76766,74.4,NULL,NULL,'CGCG 498-017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165038,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165038,32.95,0.72,38.8,76766,NULL,NULL,'Malmquist cor.','CGCG 498-017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165039,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165039,36.86,0.53,236,76767,70,NULL,NULL,'2MASX J23494835-1407107',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'16.68',NULL,NULL,NULL,NULL,NULL,NULL,1,357.451333,-14.11969,0.053,NULL,49555803306,774309426,12098584,16.68),(165040,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13646',NULL,165040,39.55,0.98,813,76768,70,NULL,'SN photometric redshift distance, z photo =0.212 +/- 0.149','SDSS-II SN 13646',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,357.4725417,-1.03214,0.057,NULL,49407233935,771988030,12062312,NULL),(165041,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13646','R',165041,41.32,0.24,1400,76768,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 13646',0.305435,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165042,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13646','R',165042,41.5,0.18,1530,76768,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 13646',0.305435,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165043,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165043,34.27,0.2,71.5,76769,74.4,NULL,NULL,'UGC 12799',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000037,NULL,'15.37',0.25,'Scd:',NULL,NULL,NULL,NULL,1,357.473833,2.70469,0.129,NULL,51552419751,805506558,12586039,15.37),(165044,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165044,34.39,0.48,75.5,76769,NULL,NULL,NULL,'UGC 12799',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165045,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165045,34.49,0.46,79.1,76769,NULL,NULL,'Malmquist cor.','UGC 12799',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165046,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03758','RN',165046,41.78,0.17,1780,76770,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 03758',0.277427,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165047,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 03758','RN',165047,42.69,0.19,2700,76770,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 03758',0.277427,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165048,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165048,37.63,0.46,336,76771,70,NULL,NULL,'2MASX J23495516+1601286',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000158,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,357.47975,16.02447,0.057,NULL,51662657719,807229026,12612953,17.6),(165049,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165049,38.03,0.33,404,76772,70,NULL,NULL,'2MASX J23495786+1424206',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000156,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,357.491167,14.40589,0.057,NULL,51645731886,806964560,12608821,17.3),(165050,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658',NULL,165050,39.75,0.21,891,76773,70,NULL,'SN photometric redshift distance, z photo =0.235 +/- 0.027','SDSS-II SN 01658',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,357.504417,0.65006,0.101,NULL,51553439427,805522491,12586288,NULL),(165051,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658','R',165051,40.83,0.23,1150,76773,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01658',0.277296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165052,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658','R',165052,40.93,0.17,1200,76773,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01658',0.277296,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165053,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658',NULL,165053,40.79,0.13,1440,76773,70,NULL,'SALT 2','SDSS-II SN 01658',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165054,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01658',NULL,165054,40.81,0.13,1450,76773,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01658',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165055,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165055,38.03,0.33,404,76774,70,NULL,NULL,'2MASX J23500220+1426536',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000183,NULL,'17.3g',0.24,NULL,NULL,NULL,NULL,NULL,1,357.509125,14.44828,0.057,NULL,51645737676,806964651,12608822,17.3),(165056,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165056,38.99,0.12,528,76775,74.2,NULL,'SALT 2','SDSS J235005.06-005517.4',0.19,'2010ApJ...716..712A',2010,1,0.07,NULL,'G',0.0005,NULL,'21.5g',0.04,NULL,NULL,NULL,NULL,NULL,1,357.521083333,-0.92153,0.085,NULL,49407745434,771996022,12062437,21.5),(165057,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165057,39.12,0.09,667,76775,70,NULL,'Hubble residual -0.16 for z0.18470','SDSS J235005.06-005517.4',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165058,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165058,39.58,0.14,691,76775,70,NULL,'SALT 2','SDSS J235005.06-005517.4',0.19,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165059,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165059,39.6,0.13,698,76775,65,NULL,'MLCS2k2','SDSS J235005.06-005517.4',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165060,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08213','R',165060,39.62,0.2,709,76775,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ko','SDSS J235005.06-005517.4',0.1847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165061,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08213','R',165061,39.62,0.14,710,76775,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ko','SDSS J235005.06-005517.4',0.1847,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165062,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165062,39.65,0.12,714,76775,65,NULL,'SALT2','SDSS J235005.06-005517.4',0.19,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165063,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165063,39.44,0.09,773,76775,70,NULL,'SALT 2','SDSS J235005.06-005517.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165064,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165064,39.45,0.09,776,76775,70,NULL,'SALT 2, Malmquist cor.','SDSS J235005.06-005517.4',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165065,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2005ko',NULL,165065,41.01,0.04,1340,76775,70,NULL,'SDSS-II SN 08213','SDSS J235005.06-005517.4',0.19,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165066,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08264',NULL,165066,39.82,0.37,920,76776,70,NULL,'SN photometric redshift distance, z photo =0.244 +/- 0.053','SDSS-II SN 08264',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','21.6g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,357.539375,0.82011,0.101,NULL,51554231927,805534873,12586482,21.6),(165067,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08264','R',165067,40.72,0.31,1120,76776,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 08264',0.237519,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165068,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 08264','R',165068,40.78,0.24,1160,76776,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 08264',0.237519,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165069,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20141','R',165069,40.87,0.27,1110,76777,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J235009.88-003128.1',0.3415,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',0.0001,NULL,'20.9g',0.05,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,357.541166667,-0.52447,0.089,NULL,49406955580,771983680,12062245,20.9),(165070,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20141','R',165070,41.02,0.2,1190,76777,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J235009.88-003128.1',0.3415,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165071,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20141',NULL,165071,40.7,0.16,1380,76777,70,NULL,'SALT 2','SDSS J235009.88-003128.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165072,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20141',NULL,165072,40.74,0.16,1410,76777,70,NULL,'SALT 2, Malmquist cor.','SDSS J235009.88-003128.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165073,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165073,35.79,0.57,144,76778,70,NULL,NULL,'2MASX J23501716-0408040',NULL,'2014MNRAS.445.2677S',2014,1,0.38,NULL,'G',0.00015,NULL,'16.51',0.31,NULL,NULL,NULL,NULL,NULL,1,357.571583,-4.13453,0.131,NULL,49448069686,772626088,12072282,16.51),(165074,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165074,38.11,0.33,418,76779,70,NULL,NULL,'2MASX J23501756-0044060',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000087,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,357.573167,-0.73489,0.089,NULL,49407672799,771994887,12062420,17.7),(165075,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165075,38.11,0.33,418,76780,70,NULL,NULL,'2MASX J23501890-0048530',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000093,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,357.578625,-0.81469,0.089,NULL,49407801670,771996901,12062451,17.2),(165076,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165076,36.1,0.78,166,76781,70,NULL,NULL,'2MASX J23502403-8148542',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'17.5b',NULL,NULL,NULL,NULL,NULL,NULL,1,357.599667,-81.81497,0.397,NULL,48348836960,755450577,11803915,17.5),(165077,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165077,36.2,0.64,174,76782,70,NULL,NULL,'ESO 111-IG 004',NULL,'2014MNRAS.445.2677S',2014,1,0.61,NULL,'G',0.00015,NULL,'16.73',0.23,'E ?',NULL,NULL,NULL,NULL,1,357.606375,-59.5125,0,NULL,48752261062,761754079,11902407,16.73),(165078,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165078,38.18,0.46,433,76783,70,NULL,NULL,'SDSS J235025.89+150142.7',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000144,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,357.607875,15.02853,0.057,NULL,51664278403,807254350,12613349,18.6),(165079,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165079,36.95,0.53,246,76784,70,NULL,NULL,'2MASX J23502772-2415415',NULL,'2014MNRAS.445.2677S',2014,1,0.57,NULL,'G',0.00015,NULL,'16.22',0.42,'E',NULL,NULL,NULL,NULL,1,357.615458333,-24.26153,0.033,NULL,50011900500,781435945,12209936,16.22),(165080,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165080,38.21,0.33,439,76785,70,NULL,NULL,'2MASX J23503389-0852041',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000092,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,357.641083,-8.86794,0.102,NULL,49427886482,772310726,12067355,17.3),(165081,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165081,34.75,0.69,89.1,76786,100,NULL,'mid-IR','UGC 12803',NULL,'2013ApJ...771...88L',2013,1,1.1,NULL,'G',0.000033,NULL,'14.93',0.7,'Sb','Group member, peripheral',NULL,NULL,NULL,1,357.641458333,28.99828,0.165,NULL,51970416764,812037761,12688090,14.93),(165082,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165082,35.54,0.4,128,76786,NULL,NULL,'mean','UGC 12803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165083,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165083,35.65,0.45,135,76786,NULL,NULL,'K','UGC 12803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165084,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165084,35.66,0.47,135,76786,NULL,NULL,'H','UGC 12803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165085,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165085,35.73,0.07,140,76786,NULL,NULL,NULL,'UGC 12803',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165086,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165086,35.77,0.46,143,76786,NULL,NULL,'J','UGC 12803',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165087,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165087,38.21,0.33,439,76787,70,NULL,NULL,'2MASX J23503714-0851351',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000077,NULL,'17.6g',0.23,NULL,NULL,NULL,NULL,NULL,1,357.654625,-8.85989,0.102,NULL,49427884853,772310700,12067354,17.6),(165088,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165088,35.03,0.49,101,76788,75,NULL,'IR','UGC 12802',NULL,'2011yCatp016004901K',2011,1,1.25,NULL,'G',0.000058,NULL,'16.5',0.09,'Scd',NULL,NULL,NULL,NULL,1,357.659125,14.48075,0.037,NULL,51645717340,806964333,12608817,16.5),(165089,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165089,35.22,NULL,111,76788,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165090,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165090,35.24,NULL,112,76788,NULL,NULL,'Dipole + Quadrupole','UGC 12802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165091,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165091,35.25,NULL,112,76788,NULL,NULL,'Dipole','UGC 12802',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165092,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165092,35.28,NULL,114,76788,NULL,NULL,NULL,'UGC 12802',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165093,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07614','RN',165093,41.77,0.23,1620,76789,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 07614',0.397018,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165094,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07614','RN',165094,42.43,0.26,2200,76789,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 07614',0.397018,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165095,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 02551','RN',165095,41.76,0.36,1800,76790,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02551',0.249061,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165096,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 02551','RN',165096,41.91,0.33,1930,76790,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02551',0.249061,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165097,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165097,36.24,0.53,177,76791,70,NULL,NULL,'CGCG 381-054',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.0001,NULL,'15.4',0.2,NULL,NULL,NULL,NULL,NULL,1,357.695833,-2.18819,0.113,NULL,49405522025,771961281,12061895,15.4),(165098,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01395','RN',165098,39.56,0.22,687,76792,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01395',0.186404,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165099,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 01395','RN',165099,39.9,0.18,804,76792,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01395',0.186404,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165100,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 21385','N',165100,41.26,0.27,1790,76793,70,NULL,'SALT 2','SDSS-II SN 21385',NULL,'2013ApJ...763...88C',2013,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165101,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 21385','N',165101,41.3,0.27,1820,76793,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 21385',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165102,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165102,35.83,0.2,147,76794,74.4,NULL,NULL,'CGCG 432-034',NULL,'2013AJ....146...86T',2013,1,0.76,NULL,'G',0.000086,NULL,'15.4g',0.55,'Sc',NULL,NULL,NULL,NULL,1,357.700583,15.65117,0.069,NULL,51664459666,807257182,12613393,15.4),(165103,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165103,34.79,0.25,90.8,76795,74.4,NULL,NULL,'NGC 7765',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000047,NULL,'15.46',0.7,'S','Group member',NULL,NULL,NULL,1,357.717333,27.16628,0.133,NULL,52004576271,812571504,12696429,15.46),(165104,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165104,34.99,0.27,99.7,76795,70,NULL,NULL,'NGC 7765',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165105,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165105,31.56,0.4,20.5,76796,75,NULL,'B','NGC 7764',NULL,'1988NBGC.C....0000T',1988,1,1.9,NULL,'G',0.000022,NULL,'12.6',1.4,'IB(s)m',NULL,NULL,NULL,'H_alpha Emission-Line Galaxy',1,357.724916667,-40.72822,NULL,NULL,49934745910,780230404,12191100,12.6),(165106,'BCG','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165106,35.24,0.35,109,76797,60,NULL,NULL,'ABELL 2666',0.0273,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000297,NULL,NULL,NULL,'I      [BM]',NULL,NULL,NULL,NULL,1,357.734291667,27.14475,0.133,NULL,52004585451,812571647,12696431,NULL),(165107,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165107,38.14,0.46,425,76798,70,NULL,NULL,'2MASX J23505628-1104199',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000094,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,357.734458333,-11.07228,0.048,NULL,49613300895,775207826,12112622,17.1),(165108,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165108,35.14,0.8,107,76799,75,NULL,'W91PP, r','NGC 7767',NULL,'1997ApJS..109..333W',1997,1,1,NULL,'G',0.00009,NULL,'14.50',0.2,'S0/a','in a radial-velocity based grouping',NULL,NULL,NULL,1,357.7347917,27.08714,0.133,NULL,52004578914,812571545,12696430,14.5),(165109,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165109,35.49,0.38,125,76799,75,NULL,'W91PP, r, raw','NGC 7767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165110,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165110,35.55,0.49,129,76799,75,NULL,'IR','NGC 7767',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165111,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165111,35.68,0.38,137,76799,75,NULL,'W91PP, r, cor','NGC 7767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165112,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165112,35.81,0.38,145,76799,75,NULL,'W91PP, r, inv','NGC 7767',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165113,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1968Z',NULL,165113,35.39,0.09,120,76800,74.4,NULL,NULL,'NGC 7768',NULL,'2013AJ....146...86T',2013,1,1.6,'1980AJ.....85..626H has z = 0.02612 +- 0.000267.','G',0.000053,NULL,'13.24',1.3,'cD;E','in a radial-velocity based grouping',NULL,NULL,NULL,1,357.744083333,27.14739,0.133,NULL,52004585297,812571645,12696431,13.24),(165114,'BCG','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165114,35.24,0.35,109,76800,60,NULL,'ABELL 2666, BCG','NGC 7768',0.0273,'1980ApJ...241..486H',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165115,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165115,34.15,0.4,67.5,76800,75,NULL,'Edat, raw','NGC 7768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165116,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165116,34.48,0.4,78.7,76800,75,NULL,'Edat, cor','NGC 7768',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165117,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165117,34.99,0.27,99.7,76800,70,NULL,NULL,'NGC 7768',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165118,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165118,35.39,0.09,120,76800,74.4,NULL,NULL,'NGC 7768',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165119,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165119,35.08,0.45,104,76800,NULL,NULL,'K','NGC 7768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165120,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165120,35.25,0.4,112,76800,NULL,NULL,'mean','NGC 7768',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165121,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165121,34.56,0.49,81.7,76801,75,NULL,'IR','CGCG 477-020',NULL,'2011yCatp016004901K',2011,1,0.7,'1980AJ.....85..626H has V = 7468 +- 80 km/s; 1998AJ....116.1529H 7187 +- 31.','G',0.000067,NULL,'15.58',0.2,'S?','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,357.749916667,27.21906,0.133,NULL,52004558827,812571231,12696425,15.58),(165122,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165122,35.12,0.43,105,76801,NULL,NULL,'Malmquist cor.','CGCG 477-020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165123,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165123,35.14,0.42,107,76801,NULL,NULL,NULL,'CGCG 477-020',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165124,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165124,35.19,0.2,109,76801,74.4,NULL,NULL,'CGCG 477-020',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165125,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165125,35.93,NULL,154,76802,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12807',NULL,'2010Ap&SS.325..163P',2010,1,0.92,NULL,'G',0.000017,NULL,'17.',0.09,'Sd',NULL,NULL,NULL,NULL,1,357.750583,35.782,0.309,NULL,51857535965,810273999,12660531,17),(165126,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165126,35.95,0.49,155,76802,75,NULL,'IR','UGC 12807',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165127,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165127,35.95,NULL,155,76802,NULL,NULL,'Dipole + Quadrupole','UGC 12807',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165128,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165128,35.97,NULL,156,76802,NULL,NULL,NULL,'UGC 12807',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165129,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165129,35.97,NULL,156,76802,NULL,NULL,'Dipole','UGC 12807',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165130,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165130,36.38,0.2,189,76802,74.4,NULL,NULL,'UGC 12807',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165131,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165131,36.45,0.43,195,76802,75,NULL,'3.6 micron, color corrected','UGC 12807',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165132,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165132,36.51,0.43,201,76802,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12807',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165133,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12876','RN',165133,39.39,0.08,686,76803,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 12876',0.10019,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165134,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165134,34.81,0.25,91.6,76804,74.4,NULL,NULL,'KUG 2348+270B',NULL,'2013AJ....146...86T',2013,1,0.2,NULL,'G',0.000067,NULL,'14.91',0.2,'Compact',NULL,NULL,NULL,NULL,1,357.7530417,27.28881,0.101,NULL,52005070054,812579219,12696550,14.91),(165135,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165135,34.99,0.27,99.7,76804,70,NULL,NULL,'KUG 2348+270B',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165136,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165136,34.81,0.25,91.6,76805,74.4,NULL,NULL,'GIN 740',NULL,'2013AJ....146...86T',2013,1,1.4,NULL,'G',0.000057,NULL,'14.63',0.3,'E/S0',NULL,NULL,NULL,NULL,1,357.754625,27.25767,0.133,NULL,52004559635,812571244,12696425,14.63),(165137,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165137,34.99,0.27,99.7,76805,70,NULL,NULL,'GIN 740',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165138,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2011iu',NULL,165138,36.32,0.17,184,76806,72,NULL,'M(H) = -18.317 mag','UGC 12809',NULL,'2014ApJ...784..105W',2013,1,1.4,NULL,'G',0.000023,NULL,'14.6',1.2,'Sb',NULL,NULL,NULL,NULL,1,357.7632917,46.72367,0.541,NULL,53152645647,830510088,12976720,14.6),(165139,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165139,37.63,0.33,335,76807,70,NULL,NULL,'2MASX J23510328+1458426',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.1g',0.12,NULL,NULL,NULL,NULL,NULL,1,357.763625,14.97847,0.057,NULL,51664261678,807254088,12613345,18.1),(165140,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165140,35.12,0.8,106,76808,75,NULL,'A82, H','UGC 12810',NULL,'1997ApJS..109..333W',1997,1,0.55,NULL,'G',0.00004,NULL,'14.4g',0.25,'(R\')SAB(r)bc pec:',NULL,NULL,NULL,NULL,1,357.7760417,1.05672,0.113,NULL,51554068043,805532313,12586442,14.4),(165141,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165141,35.12,0.8,106,76808,75,NULL,'CF, r','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165142,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165142,34.34,0.33,73.9,76808,91,NULL,'H','UGC 12810',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165143,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165143,34.58,0.38,82.4,76808,75,NULL,'CF, r, raw','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165144,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165144,34.73,0.47,88.5,76808,75,NULL,'A82, H, raw','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165145,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165145,34.75,0.38,89.2,76808,75,NULL,'CF, r, inv','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165146,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165146,34.78,0.38,90.3,76808,75,NULL,'CF, r, cor','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165147,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165147,34.84,0.37,92.7,76808,NULL,NULL,'Malmquist cor.','UGC 12810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165148,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165148,34.89,0.2,95.1,76808,74.4,NULL,NULL,'UGC 12810',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165149,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165149,34.91,0.36,96.1,76808,NULL,NULL,NULL,'UGC 12810',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165150,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165150,34.92,0.47,96.5,76808,75,NULL,'A82, H, inv','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165151,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165151,35.02,0.47,101,76808,75,NULL,'A82, H, cor','UGC 12810',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165152,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165152,35.24,0.4,112,76808,NULL,NULL,'mean','UGC 12810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165153,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165153,35.26,0.47,113,76808,NULL,NULL,'H','UGC 12810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165154,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165154,35.36,0.45,118,76808,NULL,NULL,'K','UGC 12810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165155,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165155,35.37,0.46,119,76808,NULL,NULL,'J','UGC 12810',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165156,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165156,36.4,0.81,191,76809,70,NULL,NULL,'2MASX J23510644-1337536',NULL,'2014MNRAS.445.2677S',2014,1,0.51,NULL,'G',0.00015,NULL,'17.39',0.27,NULL,NULL,NULL,NULL,NULL,1,357.7769583,-13.63142,0.022,NULL,49556525937,774320717,12098761,17.39),(165157,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2006fu',NULL,165157,39.52,0.08,802,76810,70,NULL,'Hubble residual 0.10 for z0.19855','SDSS J235108.37-004447.6',NULL,'2011ApJ...740...92G',2011,1,0.11,NULL,'G',0.00009,NULL,'19.6g',0.09,NULL,NULL,NULL,NULL,NULL,1,357.784916667,-0.74658,0.093,NULL,49407663288,771994738,12062417,19.6),(165158,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13070','R',165158,40.01,0.19,838,76810,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006fu','SDSS J235108.37-004447.6',0.19855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165159,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13070','R',165159,40.25,0.1,937,76810,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006fu','SDSS J235108.37-004447.6',0.19855,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165160,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165160,37.12,0.46,266,76811,70,NULL,NULL,'2MASX J23510978+1400269',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000165,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,357.7907917,14.0075,0.073,NULL,51653448225,807085128,12610705,17.1),(165161,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19129','RN',165161,38.44,0.23,442,76812,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 19129',0.101259,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165162,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19129','RN',165162,38.87,0.24,539,76812,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 19129',0.101259,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165163,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165163,33.97,0.49,62.3,76813,75,NULL,'IR','UGC 12812',NULL,'2011yCatp016004901K',2011,1,0.9,'UZC has V = 4576 +- 62 km/sec.','G',0.000057,NULL,'15.5',0.2,'Sc             HII','Pair member (points to parent)',NULL,NULL,NULL,1,357.8277083,20.57792,0.101,NULL,51608364535,806380695,12599698,15.5),(165164,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165164,35.45,0.43,123,76814,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2348+243A',NULL,'2014MNRAS.444..527S',2014,1,0.5,NULL,'G',0.000013,NULL,'15.7',0.3,'Spiral',NULL,NULL,NULL,NULL,1,357.8357917,24.65789,0.149,NULL,51959031907,811859873,12685310,15.7),(165165,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165165,35.5,0.43,126,76814,75,NULL,'3.6 micron, color corrected','KUG 2348+243A',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165166,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165166,35.6,0.2,132,76814,74.4,NULL,NULL,'KUG 2348+243A',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165167,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165167,34.46,0.49,77.8,76815,75,NULL,'IR','UGC 12814',NULL,'2011yCatp016004901K',2011,1,1.27,NULL,'G',0.00007,NULL,'15.2',0.15,'Sd',NULL,NULL,NULL,NULL,1,357.837,49.07842,0.741,NULL,53157610648,830587666,12977932,15.2),(165168,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165168,34.56,0.31,81.5,76815,NULL,NULL,'Malmquist cor.','UGC 12814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165169,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165169,34.76,0.43,89.4,76815,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12814',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165170,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165170,34.76,0.2,89.5,76815,74.4,NULL,NULL,'UGC 12814',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165171,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165171,34.77,0.43,90.1,76815,75,NULL,'3.6 micron, color corrected','UGC 12814',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165172,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165172,34.78,0.28,90.4,76815,NULL,NULL,NULL,'UGC 12814',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165173,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165173,34.96,NULL,98.1,76815,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165174,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165174,34.97,NULL,98.6,76815,NULL,NULL,'Dipole + Quadrupole','UGC 12814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165175,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165175,34.97,NULL,98.8,76815,NULL,NULL,'Dipole','UGC 12814',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165176,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165176,35.02,NULL,101,76815,NULL,NULL,NULL,'UGC 12814',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165177,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165177,37.3,0.46,288,76816,70,NULL,NULL,'2MASX J23512215-0911501',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000085,NULL,'17.2g',0.19,NULL,NULL,NULL,NULL,NULL,1,357.8422917,-9.19719,0.13,NULL,49612128815,775189512,12112336,17.2),(165178,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165178,36.35,0.35,186,76817,NULL,NULL,'Malmquist cor.','2MASX J23512348+0606305',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'15.7V',0.2,NULL,NULL,NULL,NULL,NULL,1,357.847958333,6.10858,0.193,NULL,51567041930,805735030,12589609,15.7),(165179,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165179,36.5,0.33,200,76817,NULL,NULL,NULL,'2MASX J23512348+0606305',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165180,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165180,33.14,0.54,42.5,76818,NULL,NULL,'SCM, I','NGC 7771',NULL,'2010ApJ...715..833O',2010,1,2.5,NULL,'G',0.000007,NULL,'12.2B',1,'SB(s)a;HII;LIRGSbrst','Pair member, wide',NULL,NULL,NULL,1,357.853375,20.11175,0.113,NULL,51608724244,806386316,12599786,12.2),(165181,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165181,33.18,0.54,43.3,76818,NULL,NULL,'SCM, V','NGC 7771',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165182,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165182,33.31,0.28,45.9,76818,NULL,NULL,'SCM, BVI','NGC 7771',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165183,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165183,33.5,0.42,50.1,76818,NULL,NULL,'SCM, B','NGC 7771',NULL,'2010ApJ...715..833O',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165184,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165184,33.51,0.14,50.4,76818,NULL,NULL,'I, photospheric magnitude method','NGC 7771',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165185,'SNII optical','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2003hg',NULL,165185,33.52,0.34,50.6,76818,NULL,NULL,'V, photospheric magnitude method','NGC 7771',NULL,'2014AJ....148..107R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165186,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165186,33.43,0.45,48.4,76818,NULL,NULL,'K','NGC 7771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165187,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165187,33.5,0.47,50,76818,NULL,NULL,'H','NGC 7771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165188,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165188,33.57,0.46,51.7,76818,NULL,NULL,'J','NGC 7771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165189,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165189,33.83,0.4,58.4,76818,NULL,NULL,'mean','NGC 7771',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165190,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165190,33.37,0.45,47.2,76819,NULL,NULL,'K','MRK 0331',NULL,'2007A&A...465...71T',2007,1,0.7,NULL,'G',0.000017,NULL,'14.87',0.4,'Sa;LIRG      HII;Sy2','Pair member (points to parent)',NULL,NULL,NULL,1,357.861667,20.58608,0.101,NULL,51608365882,806380716,12599698,14.87),(165191,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165191,33.41,0.47,48.2,76819,NULL,NULL,'H','MRK 0331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165192,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165192,33.62,0.46,53.1,76819,NULL,NULL,'J','MRK 0331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165193,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165193,34.22,0.4,69.9,76819,NULL,NULL,'mean','MRK 0331',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165194,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2002ef',NULL,165194,34.78,0.16,88.3,76820,70,NULL,'SALT 2','NGC 7761',0.023977,'2013MNRAS.433.2240G',2013,1,1.2,NULL,'G',0.000073,NULL,'13.95',1.2,'SA(rs)0^0^:',NULL,NULL,NULL,NULL,1,357.870375,-13.38158,0.039,NULL,49559649554,774369524,12099523,13.95),(165195,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165195,33.94,0.48,61.4,76820,70,NULL,NULL,'NGC 7761',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165196,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165196,34.8,0.25,91.2,76821,74.4,NULL,NULL,'CGCG 477-023',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000063,NULL,'14.20',0.7,'E/S0','Group member',NULL,NULL,NULL,1,357.874833333,27.23625,0.109,NULL,52004562491,812571288,12696426,14.2),(165197,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165197,34.99,0.27,99.7,76821,70,NULL,NULL,'CGCG 477-023',NULL,'2001MNRAS.321..277C',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165198,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05689','R',165198,39.42,0.1,653,76822,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 05689',0.171207,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,357.883,0.82756,0.113,NULL,51554162971,805533796,12586465,NULL),(165199,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 05689','R',165199,39.5,0.2,678,76822,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05689',0.171207,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165200,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165200,35.95,0.25,155,76823,74.4,NULL,NULL,'2MASX J23513462-2804182',NULL,'2013AJ....146...86T',2013,1,0.38,NULL,'G',0.000039,NULL,'16.0',0.27,'E','Group member',NULL,NULL,NULL,1,357.8942083,-28.07169,0,NULL,50054070911,782094857,12220232,16),(165201,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165201,34.72,0.4,87.9,76824,75,NULL,'Edat, raw','IC 5362',NULL,'1997ApJS..109..333W',1997,1,1.4,'The IC 5363 identification is uncertain.','G',0.000031,NULL,'14.15',1.3,'SA0^0^ pec:','Group member',NULL,NULL,NULL,1,357.903041667,-28.36506,0.008,NULL,50053035294,782078676,12219979,14.15),(165202,'D-Sigma','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165202,35.09,0.4,104,76824,75,NULL,'Edat, cor','IC 5362',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165203,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165203,35.03,0.23,101,76824,74.4,NULL,NULL,'IC 5362',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165204,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165204,35.27,0.4,113,76824,NULL,NULL,'mean','IC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165205,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165205,35.27,0.45,113,76824,NULL,NULL,'K','IC 5362',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165206,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165206,37.36,0.33,296,76825,70,NULL,NULL,'2MASX J23513696+0053069',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000118,NULL,'16.2g',0.38,'NLAGN',NULL,NULL,NULL,NULL,1,357.904,0.88533,0.101,NULL,51553685750,805526339,12586349,16.2),(165207,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007oj',NULL,165207,38.65,0.15,538,76826,70,NULL,'Hubble residual 0.18 for z0.12300','SDSS J235138.00+001647.3',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.005,NULL,'21.6g',0.04,NULL,NULL,NULL,NULL,NULL,1,357.908375,0.27983,0.117,NULL,51542669498,805354210,12583659,21.6),(165208,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19543','R',165208,38.95,0.21,550,76826,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oj','SDSS J235138.00+001647.3',0.123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165209,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19543','R',165209,39.15,0.08,603,76826,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oj','SDSS J235138.00+001647.3',0.123,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165210,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165210,37.63,0.33,335,76827,70,NULL,NULL,'2MASX J23514269+1455464',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000141,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,357.927917,14.92953,0.053,NULL,51646114412,806970537,12608914,17.7),(165211,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165211,36.92,0.46,242,76828,70,NULL,NULL,'2MASX J23514434+1536334',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000164,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,357.934708333,15.60936,0.073,NULL,51664787393,807262303,12613473,16.9),(165212,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17476','RN',165212,41.38,0.13,1520,76829,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 17476',0.244274,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165213,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17476','RN',165213,41.59,0.2,1670,76829,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17476',0.244274,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165214,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12311','RN',165214,42.46,0.35,2190,76830,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 12311',0.415049,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165215,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165215,37.54,0.46,323,76831,70,NULL,NULL,'2MASXi J2351455-105516',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000079,NULL,'18.0g',0.12,NULL,NULL,NULL,NULL,NULL,1,357.939583,-10.92117,0.051,NULL,49612676720,775198073,12112469,18),(165216,'Cepheids','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165216,24.86,0.06,0.938,76832,NULL,18.52,NULL,'Pegasus Dwarf Spheroidal',NULL,'2011A&A...531A.134T',2010,1,4,NULL,'G',0.00001,NULL,'14.17',2,'dSph','Brightest group member',NULL,NULL,NULL,1,357.942917,24.5825,0.149,1,51958940339,811858442,12685288,14.17),(165217,'CMD','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165217,24.6,NULL,0.832,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165218,'CMD','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165218,24.94,NULL,0.973,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2014ApJ...789..147W',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165219,'Horizontal Branch','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165219,24.6,0.15,0.832,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2005astro.ph..6430D',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165220,'RR Lyrae','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165220,24.37,0.09,0.748,76832,NULL,NULL,'V','Pegasus Dwarf Spheroidal',NULL,'2013MNRAS.435.3206D',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165221,'RR Lyrae','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165221,24.56,0.06,0.815,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2002AJ....124.1464P',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165222,'RR Lyrae','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165222,24.59,NULL,0.828,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2008ApJ...679...52T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165223,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165223,24.45,0.1,0.775,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'1999AJ....118.1220A',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165224,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165224,24.47,0.07,0.783,76832,NULL,NULL,NULL,'Pegasus Dwarf Spheroidal',NULL,'2005MNRAS.356..979M',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165225,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165225,24.5,0.2,0.794,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'1999A&A...342L...9H',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165226,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165226,24.57,0.25,0.82,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'1999AstL...25..332T',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165227,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165227,24.6,0.2,0.83,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'1999ApJ...511L.101G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165228,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165228,24.61,0.12,0.836,76832,NULL,NULL,'HST KP Calibrated','Pegasus Dwarf Spheroidal',NULL,'2000ApJ...529..745F',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165229,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165229,24.7,0.1,0.871,76832,NULL,NULL,'I, M(I) = -4.0 mag','Pegasus Dwarf Spheroidal',NULL,'1999IAUS..192..284G',1999,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165230,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165230,24.9,0.09,0.955,76832,NULL,NULL,'I','Pegasus Dwarf Spheroidal',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165231,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16150','RN',165231,39.79,0.32,847,76833,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16150',0.071708,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165232,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16150','RN',165232,40.52,0.47,1180,76833,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16150',0.071708,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165233,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165233,37.36,0.33,296,76834,70,NULL,NULL,'2MASX J23514743+0058218',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000081,NULL,'16.9g',0.26,NULL,NULL,NULL,NULL,NULL,1,357.9475417,0.97278,0.101,NULL,51553678053,805526219,12586347,16.9),(165234,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165234,37.52,0.46,319,76835,70,NULL,NULL,'2MASX J23514781+1400314',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000174,NULL,'17.1g',0.26,NULL,NULL,NULL,NULL,NULL,1,357.949291667,14.00889,0.073,NULL,51653494408,807085850,12610716,17.1),(165235,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 02417','RN',165235,43.73,0.27,3940,76836,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 02417',0.417919,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165236,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 02417','RN',165236,43.89,0.37,4240,76836,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 02417',0.417919,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165237,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 09186','RN',165237,42.93,0.25,2750,76837,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 09186',0.403944,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165238,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 09186','RN',165238,43.2,0.25,3110,76837,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 09186',0.403944,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165239,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165239,34.61,0.23,81.2,76838,74.2,NULL,'SALT 2','ESO 471- G 027',0.02936,'2010ApJ...716..712A',2010,1,1.28,NULL,'G',0.000033,NULL,'14.9b',0.44,'SBb(rs)','Group member',NULL,NULL,NULL,1,357.95975,-27.96533,0,NULL,50054260793,782097824,12220278,14.9),(165240,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165240,35.25,0.42,109,76838,70,NULL,'SALT 2','ESO 471- G 027',0.02936,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165241,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165241,35.23,0.09,111,76838,74.4,NULL,NULL,'ESO 471- G 027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165242,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165242,35.35,0.07,114,76838,72,NULL,NULL,'ESO 471- G 027',0.02936,'2006ApJ...647..501P',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165243,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165243,35.53,0.21,124,76838,65,NULL,NULL,'ESO 471- G 027',0.02936,'2004ApJ...607..665R',2004,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165244,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165244,35.53,0.1,124,76838,70,NULL,'SALT','ESO 471- G 027',0.02936,'2008ApJ...686..749K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165245,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165245,35.5,0.12,126,76838,70.8,NULL,NULL,'ESO 471- G 027',NULL,'2008MNRAS.389.1577T',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165246,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165246,35.64,0.2,127,76838,65,NULL,'MLCS2k2','ESO 471- G 027',0.02936,'2007ApJ...659..122J',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165247,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165247,35.65,0.21,135,76838,60,NULL,'M(B) = -19.48 mag','ESO 471- G 027',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165248,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165248,35.69,0.14,137,76838,60,NULL,NULL,'ESO 471- G 027',NULL,'2005ApJ...624..532R',2005,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165249,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165249,35.71,0.16,139,76838,60,NULL,'M(V) = -19.47 mag','ESO 471- G 027',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165250,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 1993ah',NULL,165250,35.77,0.15,143,76838,60,NULL,'M(I) = -19.19 mag','ESO 471- G 027',NULL,'2000ApJ...540..634P',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165251,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165251,34.14,0.8,67.4,76839,75,NULL,'CF, r','UGC 12816',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.00003,NULL,'14.50',0.9,'SAB(rs)cd:',NULL,NULL,NULL,NULL,1,357.9610417,3.08272,0.141,NULL,51545813143,805403330,12584427,14.5),(165252,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165252,33.68,0.38,54.3,76839,75,NULL,'CF, r, raw','UGC 12816',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165253,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165253,33.72,0.38,55.4,76839,75,NULL,'CF, r, inv','UGC 12816',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165254,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165254,34,0.38,63.2,76839,75,NULL,'CF, r, cor','UGC 12816',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165255,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165255,34.06,0.2,64.9,76839,74.4,NULL,NULL,'UGC 12816',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165256,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165256,34.31,0.45,72.6,76839,NULL,NULL,NULL,'UGC 12816',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165257,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165257,34.38,0.44,75,76839,NULL,NULL,'Malmquist cor.','UGC 12816',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165258,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165258,35.7,0.07,138,76840,NULL,NULL,NULL,'UGC 12817',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000007,NULL,'15.52',0.3,'Sb',NULL,NULL,NULL,NULL,1,357.9684583,29.26239,0.149,NULL,51970251913,812035186,12688049,15.52),(165259,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165259,35.76,0.2,142,76840,74.4,NULL,NULL,'UGC 12817',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165260,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165260,35.51,0.25,126,76841,74.4,NULL,NULL,'MCG -05-56-025',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000019,NULL,'15.09',0.88,'S0','Group member',NULL,NULL,NULL,1,357.976667,-27.92983,0,NULL,50054299192,782098424,12220287,15.09),(165261,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165261,37.99,0.46,397,76842,70,NULL,NULL,'2MASX J23515723+0042062',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'18.2g',0.16,NULL,NULL,NULL,NULL,NULL,1,357.988417,0.70167,0.101,NULL,51542566099,805352595,12583634,18.2),(165262,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165262,35.16,0.8,107,76843,75,NULL,'W91CL, r','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,1,0.6,NULL,'G',0.000033,NULL,'15.7',0.3,'Spiral','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,357.995375,27.33739,0.101,NULL,52004595536,812571805,12696434,15.7),(165263,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165263,35.16,0.8,108,76843,75,NULL,'HMCL, I','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165264,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165264,34.85,0.4,93.5,76843,75,NULL,'HMCL, I, raw','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165265,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165265,34.99,0.4,99.7,76843,75,NULL,'HMCL, I, inv','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165266,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165266,35.07,0.4,103,76843,75,NULL,'HMCL, I, cor','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165267,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165267,35.08,0.38,104,76843,75,NULL,'W91CL, r, raw','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165268,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165268,35.19,0.38,109,76843,75,NULL,'W91CL, r, inv','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165269,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165269,35.23,0.41,111,76843,NULL,NULL,'Malmquist cor.','KUG 2349+270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165270,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165270,35.28,0.4,114,76843,NULL,NULL,NULL,'KUG 2349+270',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165271,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165271,35.3,0.38,115,76843,75,NULL,'W91CL, r, cor','KUG 2349+270',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165272,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165272,35.33,0.2,116,76843,74.4,NULL,NULL,'KUG 2349+270',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165273,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165273,36.76,0.46,225,76844,70,NULL,NULL,'2MASX J23515911+1445045',NULL,'2015arXiv151105856S',2015,1,0.51,NULL,'G',0.00023,NULL,'16.0g',0.4,'S0^-',NULL,NULL,NULL,NULL,1,357.996166667,14.75114,0.033,NULL,51646411217,806975175,12608987,16),(165274,'Tully est','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165274,28.93,0.8,6.1,76845,75,NULL,NULL,'ESO 149- G 003',NULL,'1988NBGC.C....0000T',1988,1,2.2,NULL,'G',0.000007,NULL,'15.00',0.4,'IB(s)m: sp',NULL,NULL,NULL,NULL,1,358.011667,-52.57772,NULL,NULL,48627924070,759811313,11872051,15),(165275,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165275,28.85,NULL,5.89,76845,NULL,NULL,NULL,'ESO 149- G 003',NULL,'2013AJ....145..101K',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165276,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165276,29.03,NULL,6.4,76845,NULL,NULL,NULL,'ESO 149- G 003',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165277,'TRGB','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165277,29.23,0.1,7.01,76846,74.4,NULL,NULL,'ESO 149- G 003',NULL,'2013AJ....146...86T',2013,1,2.2,NULL,'G',0.000007,NULL,'15.00',0.4,'IB(s)m: sp',NULL,NULL,NULL,NULL,1,358.011667,-52.57772,NULL,NULL,48627924070,759811313,11872051,15),(165278,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165278,37.24,0.46,280,76847,70,NULL,NULL,'2MASX J23520473-0959549',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000066,NULL,'17.3g',0.23,NULL,NULL,NULL,NULL,NULL,1,358.0197083,-9.99864,0.101,NULL,49614023090,775219110,12112798,17.3),(165279,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165279,38.14,0.46,425,76848,70,NULL,NULL,'SDSS J235207.26+140544.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000139,NULL,'18.8g',0.08,NULL,NULL,NULL,NULL,NULL,1,358.0302917,14.09583,0.073,NULL,51653491144,807085799,12610715,18.8),(165280,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165280,37.94,0.33,386,76849,70,NULL,NULL,'2MASX J23520759-1039478',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000084,NULL,'17.8g',0.17,NULL,NULL,NULL,NULL,NULL,1,358.03175,-10.66331,0.073,NULL,49613823834,775215997,12112749,17.8),(165281,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165281,34.69,0.25,86.7,76850,74.4,NULL,NULL,'2dFGRS S275Z229',NULL,'2013AJ....146...86T',2013,1,0.69,NULL,'G',0.000213,NULL,'15.14',0.62,NULL,NULL,NULL,NULL,NULL,1,358.0424583,-29.07833,0,NULL,50035741612,781808462,12215757,15.14),(165282,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165282,34.74,0.51,88.8,76851,70,NULL,NULL,'6dF J2352101-290445',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'13.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,358.042583,-29.07906,0,NULL,50035741615,781808462,12215757,13.3),(165283,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165283,33.43,0.49,48.6,76852,70,NULL,NULL,'ESO 078- G 008',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00006,NULL,'14.68',0.2,'Sa','Pair member (points to parent)',NULL,NULL,NULL,1,358.0445,-62.57156,0,NULL,48725627572,761337930,11895905,14.68),(165284,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165284,34.28,0.8,71.8,76853,75,NULL,'CF, r','UGC 12818',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.00015,NULL,'14.70',0.7,'S?',NULL,NULL,NULL,NULL,1,358.0462083,8.39481,0.193,NULL,51571693515,805807711,12590745,14.7),(165285,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165285,33.71,0.2,55.2,76853,74.4,NULL,NULL,'UGC 12818',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165286,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165286,33.81,0.38,57.8,76853,75,NULL,'CF, r, raw','UGC 12818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165287,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165287,33.85,0.41,58.8,76853,NULL,NULL,NULL,'UGC 12818',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165288,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165288,33.87,0.38,59.3,76853,75,NULL,'CF, r, inv','UGC 12818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165289,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165289,34.01,0.38,63.3,76853,NULL,NULL,'Malmquist cor.','UGC 12818',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165290,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165290,34.04,0.38,64.4,76853,75,NULL,'CF, r, cor','UGC 12818',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165291,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165291,33.48,0.49,49.6,76854,75,NULL,'IR','MCG +08-01-003',NULL,'2011yCatp016004901K',2011,1,1.2,NULL,'G',0.000053,NULL,'16',0.15,NULL,NULL,NULL,NULL,NULL,1,358.047583,47.39544,0.577,NULL,53151591208,830493612,12976462,16),(165292,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165292,34.67,0.69,85.7,76855,100,NULL,'mid-IR','CGCG 498-023',NULL,'2013ApJ...771...88L',2013,1,0.8,NULL,'G',0.000033,NULL,'15.6',0.5,'Pec',NULL,NULL,NULL,NULL,1,358.049833,31.46531,0.161,NULL,51960588854,811884200,12685690,15.6),(165293,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165293,38.04,0.46,405,76856,70,NULL,NULL,'2MASX J23521483+0106502',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000082,NULL,'17.7g',0.2,NULL,NULL,NULL,NULL,NULL,1,358.0617917,1.11378,0.093,NULL,51553703551,805526617,12586353,17.7),(165294,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165294,35.58,0.31,131,76857,NULL,NULL,'Malmquist cor.','ESO 471- G 030',NULL,'2009ApJS..182..474S',2009,1,1.28,NULL,'G',0.000027,NULL,'15.0b',0.32,'S0',NULL,NULL,NULL,NULL,1,358.0677083,-29.44772,NULL,NULL,50035400780,781803137,12215674,15),(165295,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165295,35.67,0.49,136,76857,75,NULL,'IR','ESO 471- G 030',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165296,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165296,35.68,0.3,137,76857,NULL,NULL,NULL,'ESO 471- G 030',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165297,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165297,35.72,0.2,139,76857,74.4,NULL,NULL,'ESO 471- G 030',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165298,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165298,35.29,0.49,114,76858,75,NULL,'IR','AM 2349-294',NULL,'2011yCatp016004901K',2011,1,1.04,NULL,'G',0.000037,NULL,'15.89',NULL,'Sc',NULL,NULL,NULL,NULL,1,358.069708333,-29.53847,NULL,NULL,50035226766,781800418,12215631,15.89),(165299,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165299,35.33,0.34,116,76858,NULL,NULL,NULL,'AM 2349-294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165300,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165300,35.37,0.2,119,76858,74.4,NULL,NULL,'AM 2349-294',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165301,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165301,35.46,0.32,123,76858,NULL,NULL,'Malmquist cor.','AM 2349-294',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165302,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165302,38.88,0.49,596,76859,NULL,NULL,NULL,'AGC 630424',NULL,'2009ApJS..182..474S',2009,1,0.39,NULL,'G',0.00005,NULL,'17.12',NULL,'Sc',NULL,NULL,NULL,NULL,1,358.070208333,-29.43925,NULL,NULL,50035401622,781803150,12215674,17.12),(165303,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165303,38.88,0.49,596,76859,NULL,NULL,'Malmquist cor.','AGC 630424',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165304,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165304,35.88,0.66,150,76860,70,NULL,NULL,'2MASX J23521722-1841523',NULL,'2014MNRAS.445.2677S',2014,1,0.37,NULL,'G',0.00015,NULL,'17.16',0.26,NULL,NULL,NULL,NULL,NULL,1,358.0717917,-18.69792,0.015,NULL,49542890410,774107662,12095432,17.16),(165305,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165305,37.94,0.33,386,76861,70,NULL,NULL,'SDSS J235217.43-104103.6',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.00007,NULL,'18.0g',0.18,NULL,NULL,NULL,NULL,NULL,1,358.072667,-10.68433,0.073,NULL,49613822095,775215970,12112749,18),(165306,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16406','RN',165306,40.27,0.13,965,76862,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 16406',0.173639,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165307,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16406','RN',165307,40.71,0.23,1180,76862,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 16406',0.173639,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165308,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165308,33.6,NULL,52.4,76863,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2548',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.00001,NULL,'16.6',0.09,'Sd',NULL,NULL,NULL,NULL,1,358.09,7.97472,0.201,NULL,51572218133,805815908,12590873,16.6),(165309,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165309,33.62,NULL,52.9,76863,NULL,NULL,'Dipole + Quadrupole','FGC 2548',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165310,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165310,33.64,NULL,53.4,76863,NULL,NULL,'Dipole','FGC 2548',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165311,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165311,33.73,NULL,55.6,76863,NULL,NULL,NULL,'FGC 2548',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165312,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165312,34.5,0.55,79.4,76864,70,NULL,NULL,'ESO 471- G 032',NULL,'2014MNRAS.445.2677S',2014,1,0.9,'The APMUKS position is east of the nucleus.','G',0.00015,NULL,'15.00',0.6,'(R?)SAB(r)0/a','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,358.092,-30.23025,NULL,NULL,50045831920,781966123,12218220,15),(165313,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165313,35.24,0.25,112,76865,74.4,NULL,NULL,'MCG -05-56-029',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000017,NULL,'15.35',0.4,'E',NULL,NULL,NULL,NULL,1,358.1007917,-29.023,0,NULL,50035700504,781807820,12215747,15.35),(165314,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165314,35.65,0.46,135,76866,70,NULL,NULL,'2MASX J23522434+1435350',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000077,NULL,'16.1g',0.28,'E0',NULL,NULL,NULL,NULL,1,358.1014583,14.59308,0.033,NULL,51646521152,806976893,12609013,16.1),(165315,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165315,34.87,0.47,94.1,76867,NULL,NULL,'H','NGC 7775',NULL,'2007A&A...465...71T',2007,1,1,'Noted in MCG as possibly interacting.','G',0.000217,NULL,'13.96',0.8,'Scd:           HII','in a radial-velocity based grouping',NULL,NULL,NULL,1,358.101875,28.77267,0.153,NULL,51969893110,812029579,12687962,13.96),(165316,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165316,34.92,0.4,96.5,76867,NULL,NULL,'mean','NGC 7775',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165317,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165317,37.97,0.46,392,76868,70,NULL,NULL,'2MASX J23522455-0939206',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000081,NULL,'17.5g',0.18,NULL,NULL,NULL,NULL,NULL,1,358.102417,-9.65569,0.117,NULL,49612060107,775188439,12112319,17.5),(165318,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165318,36.09,0.51,165,76869,70,NULL,NULL,'2MASX J23522705-1749071',NULL,'2014MNRAS.445.2677S',2014,1,0.72,NULL,'G',0.00015,NULL,'16.47',0.38,'S0',NULL,NULL,NULL,NULL,1,358.1127083,-17.81861,0.009,NULL,49532047549,773938242,12092785,16.47),(165319,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165319,35.69,0.37,137,76870,NULL,NULL,'Malmquist cor.','ESO 606- G 017',NULL,'2009ApJS..182..474S',2009,1,1,'Da Costa, et al. (1998,AJ,116,1) give v = 10836 +/- 25 km/sec.','G',0.000033,NULL,'15.34',0.6,'Sb',NULL,NULL,NULL,NULL,1,358.113416667,-18.42381,0.026,NULL,49542563521,774102555,12095352,15.34),(165320,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165320,35.81,0.35,145,76870,NULL,NULL,NULL,'ESO 606- G 017',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165321,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165321,35.85,0.2,148,76870,74.4,NULL,NULL,'ESO 606- G 017',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165322,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165322,36.86,0.52,236,76871,70,NULL,NULL,'2MASX J23523841-2349517',NULL,'2014MNRAS.445.2677S',2014,1,0.67,NULL,'G',0.00015,NULL,'15.95',0.52,'E',NULL,NULL,NULL,NULL,1,358.160125,-23.83106,0.036,NULL,49997463725,781210370,12206412,15.95),(165323,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165323,37.96,0.46,390,76872,70,NULL,NULL,'SDSS J235240.55+151253.7',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.00013,NULL,'18.6g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.169,15.21492,0.057,NULL,51663634867,807244294,12613192,18.6),(165324,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 14323','RN',165324,43.45,0.3,3010,76873,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 14323',0.629758,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165325,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165325,36.94,0.9,244,76874,70,NULL,NULL,'2MASX J23524518-3510520',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.68',0.25,NULL,NULL,NULL,NULL,NULL,1,358.188333,-35.18106,NULL,NULL,49948965421,780452584,12194571,16.68),(165326,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165326,37.46,0.12,311,76875,70,NULL,NULL,'2MASX J23525190-1108556',NULL,'2015arXiv151105856S',2015,1,0.45,NULL,'G',0.000102,NULL,'16.5g',0.33,NULL,NULL,NULL,NULL,NULL,1,358.216375,-11.14872,0,NULL,49612636852,775197450,12112460,16.5),(165327,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165327,35.82,0.49,146,76876,70,NULL,NULL,'2MASX J23525463-5213099',NULL,'2014MNRAS.445.2677S',2014,1,0.48,NULL,'G',0.00015,NULL,'16.79',0.19,NULL,NULL,NULL,NULL,NULL,1,358.227625,-52.21942,NULL,NULL,48628743618,759824119,11872251,16.79),(165328,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 10612','RN',165328,39.43,0.39,659,76877,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10612',0.166761,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165329,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 10612','RN',165329,39.86,0.35,803,76877,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10612',0.166761,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165330,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165330,34.8,0.57,91.3,76878,70,NULL,NULL,'2MASX J23525776-0243335',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.46',NULL,NULL,NULL,NULL,NULL,NULL,1,358.240708333,-2.72594,0.113,NULL,49405010959,771953296,12061770,15.46),(165331,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165331,34.57,0.51,82,76879,NULL,NULL,'Malmquist cor.','AGC 331811',NULL,'2009ApJS..182..474S',2009,1,0.6,NULL,'G',NULL,NULL,'15.0I',0.3,NULL,NULL,NULL,NULL,NULL,1,358.254583,11.28306,0.125,NULL,51776092008,809001437,12640647,15),(165332,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165332,34.72,0.2,87.9,76879,74.4,NULL,NULL,'AGC 331811',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165333,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165333,34.85,0.44,93.2,76879,NULL,NULL,NULL,'AGC 331811',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165334,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165334,37.69,0.46,345,76880,70,NULL,NULL,'SDSS J235301.46-094837.7',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000066,NULL,'18.4g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.256083,-9.8105,0.101,NULL,49611849554,775185149,12112267,18.4),(165335,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165335,37.03,0.46,254,76881,70,NULL,NULL,'2MASX J23530244+1605203',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000183,NULL,'16.3g',0.37,NULL,NULL,NULL,NULL,NULL,1,358.260125,16.08892,0.061,NULL,51665230530,807269227,12613581,16.3),(165336,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13163','RN',165336,40.4,0.14,968,76882,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 13163',0.239845,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165337,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13163','RN',165337,41.1,0.22,1340,76882,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 13163',0.239845,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165338,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165338,38.14,0.33,425,76883,70,NULL,NULL,'SDSS J235304.78+002201.4',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000086,NULL,'18.4g',0.16,NULL,NULL,NULL,NULL,NULL,1,358.2699583,0.36708,0.117,NULL,51542049783,805344527,12583508,18.4),(165339,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165339,35.54,0.33,128,76884,70,NULL,NULL,'CGCG 455-064',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000188,NULL,'15.7g',0.45,'E0',NULL,NULL,NULL,NULL,1,358.2845417,16.06442,0.061,NULL,51665228387,807269193,12613581,15.7),(165340,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165340,36.55,0.57,204,76885,70,NULL,NULL,'2MASX J23530838-0256375',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.00015,NULL,'16.93',0.28,NULL,NULL,NULL,NULL,NULL,1,358.284833333,-2.94375,0.165,NULL,49403379004,771927796,12061371,16.93),(165341,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 12921','RN',165341,41,0.19,1260,76886,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 12921',0.259092,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165342,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165342,36.99,0.48,250,76887,NULL,NULL,'Malmquist cor.','UGC 12825',NULL,'2009ApJS..182..474S',2009,1,1.02,NULL,'G',0.00003,NULL,'16.5',0.11,'Sbc',NULL,NULL,NULL,NULL,1,358.305875,10.89478,0.157,NULL,51778398673,809037479,12641210,16.5),(165343,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165343,37.26,0.42,284,76887,NULL,NULL,NULL,'UGC 12825',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165344,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165344,37.3,0.2,288,76887,74.4,NULL,NULL,'UGC 12825',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165345,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165345,33.92,NULL,60.7,76888,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12828',NULL,'2010Ap&SS.325..163P',2010,1,1.27,NULL,'G',0.000008,NULL,'16.0',0.16,'Sc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,358.315166667,19.39178,0.097,NULL,51622665585,806604149,12603189,16),(165346,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165346,33.93,NULL,61.1,76888,NULL,NULL,'Dipole + Quadrupole','UGC 12828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165347,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165347,33.94,NULL,61.3,76888,NULL,NULL,'Dipole','UGC 12828',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165348,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165348,33.99,NULL,62.9,76888,NULL,NULL,NULL,'UGC 12828',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165349,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165349,34,0.49,63.1,76888,75,NULL,'IR','UGC 12828',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165350,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06280','RN',165350,39.07,0.55,548,76889,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 06280',0.187749,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165351,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 06280','RN',165351,39.39,0.77,637,76889,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 06280',0.187749,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165352,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165352,38.14,0.33,425,76890,70,NULL,NULL,'2MASX J23531746+0017313',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000089,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,358.3227083,0.29208,0.117,NULL,51542176250,805346503,12583539,18.1),(165353,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165353,36.15,0.53,170,76891,70,NULL,NULL,'ESO 538- G 001',NULL,'2014MNRAS.445.2677S',2014,1,1.2,'6dF DR2 has z = 0.037629.','G',0.00015,NULL,'15.48',0.5,'S0:',NULL,NULL,NULL,NULL,1,358.323583,-18.21194,0,NULL,49539453644,774053963,12094593,15.48),(165354,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165354,34.98,0.49,98.9,76892,NULL,NULL,NULL,'CGCG 477-027',NULL,'2009ApJS..182..474S',2009,1,0.8,NULL,'G',0.000007,NULL,'15.5',0.4,'Sb','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,358.3265,27.70539,0.085,NULL,52001312516,812520508,12695632,15.5),(165355,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165355,34.98,0.49,99.1,76892,NULL,NULL,'Malmquist cor.','CGCG 477-027',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165356,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165356,35.02,0.2,101,76892,74.4,NULL,NULL,'CGCG 477-027',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165357,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165357,34.23,0.4,70.2,76893,NULL,NULL,'mean','NGC 7778',NULL,'2007A&A...465...71T',2007,1,1,NULL,'G',0.000023,NULL,'13.68',1,'E','in a radial-velocity based grouping',NULL,NULL,NULL,1,358.3319583,7.87092,0.197,NULL,51572316612,805817447,12590897,13.68),(165358,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165358,34.63,0.45,84.5,76893,NULL,NULL,'K','NGC 7778',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165359,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165359,35.09,NULL,104,76894,NULL,NULL,'Dipole + Quadrupole + Octopole','MCG +14-01-004',NULL,'2010Ap&SS.325..163P',2010,1,0.96,NULL,'G',NULL,NULL,'17',0.09,'Scd',NULL,NULL,NULL,NULL,1,358.336416667,86.02769,0.301,NULL,52623373687,822240213,12847503,17),(165360,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165360,35.12,NULL,105,76894,NULL,NULL,'Dipole + Quadrupole','MCG +14-01-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165361,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165361,35.12,NULL,106,76894,NULL,NULL,'Dipole','MCG +14-01-004',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165362,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165362,35.14,0.43,107,76894,75,NULL,'3.6 micron, color + selection bias corrected','MCG +14-01-004',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165363,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165363,35.16,NULL,107,76894,NULL,NULL,NULL,'MCG +14-01-004',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165364,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16586','RN',165364,40.71,0.26,1050,76895,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 16586',0.319595,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165365,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16586','RN',165365,41.11,0.2,1260,76895,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 16586',0.319595,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165366,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16586','N',165366,40.53,0.16,1280,76895,70,NULL,'SALT 2','SDSS-II SN 16586',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165367,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16586','N',165367,40.57,0.16,1300,76895,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 16586',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165368,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165368,38.5,0.46,500,76896,70,NULL,NULL,'SDSS J235322.52-085603.9',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000071,NULL,'18.5g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.343875,-8.93444,0.13,NULL,49428470022,772319844,12067497,18.5),(165369,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165369,37.46,0.12,311,76897,70,NULL,NULL,'SDSS J235322.92-104855.9',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000057,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,358.345583,-10.81556,0.065,NULL,49613887814,775216997,12112765,17.7),(165370,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165370,37.46,0.12,311,76898,70,NULL,NULL,'SDSS J235324.67-102242.9',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000076,NULL,'18.2g',0.15,'S0','Group member',NULL,NULL,NULL,1,358.352833,-10.37858,0.09,NULL,49614066558,775219789,12112809,18.2),(165371,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165371,37.56,0.46,325,76899,70,NULL,NULL,'2MASX J23532616-0033326',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00008,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,358.359,-0.55894,0.121,NULL,49394021999,771781593,12059087,17.4),(165372,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165372,35.64,0.62,134,76900,70,NULL,NULL,'NGC 7764A NED03',NULL,'2014MNRAS.445.2677S',2014,1,0.39,NULL,'G',0.00015,NULL,'16.61',0.3,'S0','in a triple',NULL,NULL,NULL,1,358.359375,-40.81597,NULL,NULL,49936587291,780259176,12191549,16.61),(165373,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165373,37.88,0.46,377,76901,70,NULL,NULL,'2MASX J23532686-0844571',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000084,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,358.3620417,-8.74928,0.152,NULL,49428557803,772321215,12067518,17.4),(165374,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13096','R',165374,42.18,0.27,1960,76902,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J235328.89-011208.1',0.392006,'2014arXiv1401.3317S',2014,1,0.07,NULL,'G',NULL,'PHOT','22.2g',0.04,'Extended Src [SDSS]',NULL,NULL,NULL,NULL,1,358.370417,-1.20225,0.077,NULL,49407356604,771989946,12062342,22.2),(165375,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13096','R',165375,42.44,0.25,2210,76902,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J235328.89-011208.1',0.392006,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165376,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13096',NULL,165376,42.13,0.17,2670,76902,70,NULL,'SALT 2','SDSS J235328.89-011208.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165377,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13096',NULL,165377,42.2,0.17,2750,76902,70,NULL,'SALT 2, Malmquist cor.','SDSS J235328.89-011208.1',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165378,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165378,34.59,0.39,82.9,76903,NULL,NULL,'Malmquist cor.','IC 1513',NULL,'2009ApJS..182..474S',2009,1,1,NULL,'G',0.000107,NULL,'14.99',0.3,'S?',NULL,NULL,NULL,NULL,1,358.372417,11.31761,0.129,NULL,51642638584,806916227,12608066,14.99),(165379,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165379,34.8,0.35,91.1,76903,NULL,NULL,NULL,'IC 1513',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165380,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165380,34.84,0.2,92.9,76903,74.4,NULL,NULL,'IC 1513',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165381,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165381,34.88,0.55,94.7,76904,70,NULL,NULL,'CGCG 381-058',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.000076,NULL,'15.5g',0.37,'Sbc',NULL,NULL,NULL,NULL,1,358.379167,-0.74014,0.097,NULL,49393528050,771773875,12058966,15.5),(165382,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165382,35.54,0.33,128,76905,70,NULL,NULL,'III Zw 124',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000148,NULL,'16.4g',0.37,NULL,NULL,NULL,NULL,NULL,1,358.379625,16.10581,0.073,NULL,51664722287,807261285,12613457,16.4),(165383,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07647','R',165383,41.35,0.16,1340,76906,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07647',0.38666,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.383125,1.04203,0.105,NULL,51542467363,805351052,12583610,NULL),(165384,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07647','R',165384,41.4,0.23,1370,76906,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07647',0.38666,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165385,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165385,33.44,0.22,47.9,76907,74.2,NULL,'SALT 2','NGC 7780',0.017195,'2010ApJ...716..712A',2010,1,1,NULL,'G',0.000193,NULL,'14.8',0.5,'Sab','Group member',NULL,NULL,NULL,1,358.3840417,8.11814,0.181,NULL,51572134833,805814606,12590853,14.8),(165386,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165386,34.07,0.19,64,76907,70,NULL,'SALT 2','NGC 7780',0.017195,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165387,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165387,34.11,0.08,66.4,76907,74.4,NULL,NULL,'NGC 7780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165388,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165388,34.28,0.27,70.7,76907,65,NULL,'SALT2','NGC 7780',0.017195,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165389,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165389,34.44,0.22,76.1,76907,65,NULL,'SALT','NGC 7780',0.017195,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165390,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165390,34.55,0.22,80.1,76907,65,NULL,'MLCS17','NGC 7780',0.017195,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165391,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165391,34.56,0.24,80.4,76907,65,NULL,'MLCS31','NGC 7780',0.017195,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165392,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2001da',NULL,165392,35.23,0.07,109,76907,70,NULL,'SALT 2','NGC 7780',0.017195,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165393,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165393,33.47,0.69,49.5,76907,100,NULL,'mid-IR','NGC 7780',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165394,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165394,34.11,0.08,66.4,76907,74.4,NULL,NULL,'NGC 7780',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165395,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165395,34.43,0.38,76.9,76907,NULL,NULL,'Malmquist cor.','NGC 7780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165396,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165396,34.49,0.37,78.9,76907,NULL,NULL,NULL,'NGC 7780',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165397,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165397,34.86,0.4,93.8,76907,75,NULL,'HOSTS SN 2001da','NGC 7780',NULL,'2012ApJ...749..174C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165398,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165398,37.87,0.46,374,76908,70,NULL,NULL,'SDSS J235332.24+153827.1',NULL,'2015arXiv151105856S',2015,1,0.15,NULL,'G',0.000134,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.384333,15.64086,0.061,NULL,51664715567,807261180,12613455,18.5),(165399,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165399,37.46,0.12,311,76909,70,NULL,NULL,'2MASX J23533382-1035091',NULL,'2015arXiv151105856S',2015,1,0.43,NULL,'G',0.000094,NULL,'16.4g',0.36,'E0','Group member',NULL,NULL,NULL,1,358.3909583,-10.58597,0.104,NULL,49613705344,775214146,12112721,16.4),(165400,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165400,37.46,0.12,311,76910,70,NULL,NULL,'2MASX J23533551-1028071',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000088,NULL,'16.9g',0.27,'S0-','Group member',NULL,NULL,NULL,1,358.397917,-10.46875,0.09,NULL,49614167935,775221373,12112833,16.9),(165401,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16625','RN',165401,42.45,0.48,2780,76911,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 16625',0.112007,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165402,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 16625','RN',165402,42.58,0.45,2960,76911,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 16625',0.112007,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165403,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15755','R',165403,40.61,0.21,1040,76912,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS J235336.73+001338.9',0.281,'2014arXiv1401.3317S',2014,1,0.11,NULL,'G',0.01,NULL,'20.3g',0.05,NULL,NULL,NULL,NULL,NULL,1,358.403041667,0.22747,0.129,NULL,51542214425,805347100,12583548,20.3),(165404,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15755','R',165404,40.71,0.16,1080,76912,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS J235336.73+001338.9',0.281,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165405,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15755',NULL,165405,40.42,0.12,1210,76912,70,NULL,'SALT 2','SDSS J235336.73+001338.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165406,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15755',NULL,165406,40.44,0.12,1220,76912,70,NULL,'SALT 2, Malmquist cor.','SDSS J235336.73+001338.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165407,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165407,37.46,0.12,311,76913,70,NULL,NULL,'2MASX J23534052-1024201',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000095,NULL,'16.1g',0.36,'E+',NULL,NULL,NULL,NULL,1,358.418833333,-10.40553,0.09,NULL,49614039296,775219364,12112802,16.1),(165408,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160',NULL,165408,39.58,0.39,824,76914,70,NULL,'SN photometric redshift distance, z photo =0.215 +/- 0.049','SDSS-II SN 15160',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,358.428916667,-0.57911,0.121,NULL,49393966825,771780731,12059073,NULL),(165409,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160','R',165409,40.31,0.22,922,76914,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 15160',0.252226,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165410,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160','R',165410,40.41,0.15,965,76914,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 15160',0.252226,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165411,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160',NULL,165411,40.14,0.12,1070,76914,70,NULL,'SALT 2','SDSS-II SN 15160',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165412,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15160',NULL,165412,40.16,0.12,1080,76914,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 15160',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165413,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 19077','RN',165413,42.61,0.24,2010,76915,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 19077',0.652709,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165414,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165414,36.87,0.46,236,76916,70,NULL,NULL,'2MASX J23534532-0948150',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000076,NULL,'17.4g',0.15,NULL,NULL,NULL,NULL,NULL,1,358.438875,-9.80436,0.097,NULL,49611816723,775184636,12112259,17.4),(165415,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165415,37.78,0.46,360,76917,70,NULL,NULL,'2MASX J23534703+1411264',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000172,NULL,'17.0g',0.26,NULL,NULL,NULL,NULL,NULL,1,358.446,14.19056,0.061,NULL,51645788979,806965452,12608835,17),(165416,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165416,37.46,0.12,311,76918,70,NULL,NULL,'2MASX J23534761-1037340',NULL,'2015arXiv151105856S',2015,1,0.44,NULL,'G',0.000101,NULL,'16.4g',0.37,'E+','Group member',NULL,NULL,NULL,1,358.4482917,-10.62608,0.073,NULL,49613708333,775214192,12112721,16.4),(165417,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165417,34.84,0.49,93,76919,75,NULL,'IR','KUG 2351+271',NULL,'2011yCatp016004901K',2011,1,0.8,NULL,'G',0.00015,NULL,'15.3',0.4,'Spiral','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,358.448875,27.41931,0.085,NULL,52001660206,812525940,12695717,15.3),(165418,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165418,35.53,0.45,128,76919,NULL,NULL,'Malmquist cor.','KUG 2351+271',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165419,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165419,35.58,0.43,131,76919,75,NULL,'3.6 micron, color corrected','KUG 2351+271',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165420,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165420,35.62,0.43,133,76919,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2351+271',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165421,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165421,35.67,0.2,136,76919,74.4,NULL,NULL,'KUG 2351+271',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165422,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165422,35.73,0.41,140,76919,NULL,NULL,NULL,'KUG 2351+271',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165423,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165423,34.63,0.41,84.2,76920,NULL,NULL,'Malmquist cor.','UGC 12830',NULL,'2009ApJS..182..474S',2009,1,1,'UGC RA is -0.5 minutes in error.','G',NULL,NULL,'16.5:',0.15,'Sab',NULL,NULL,NULL,NULL,1,358.45775,10.94467,0.137,NULL,51778193414,809034272,12641160,16.5),(165424,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165424,34.77,0.49,89.8,76920,75,NULL,'IR','UGC 12830',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165425,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165425,34.85,0.37,93.3,76920,NULL,NULL,NULL,'UGC 12830',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165426,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165426,34.89,0.2,95.1,76920,74.4,NULL,NULL,'UGC 12830',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165427,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17928','R',165427,39.72,0.17,736,76921,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 17928',0.197393,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.470083,1.11464,0.089,NULL,51542279927,805348123,12583564,NULL),(165428,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 17928','R',165428,39.77,0.22,750,76921,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 17928',0.197393,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165429,'Ring Diameter','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165429,33.7,0.84,54,76922,NULL,NULL,'Published at H = 100 km/s/Mpc','NGC 7782',NULL,'1981ApJS...45..541P',1981,1,2.4,NULL,'G',0.000023,NULL,'13.08',1.3,'SA(s)b','in a radial-velocity based grouping',NULL,NULL,NULL,1,358.4745417,7.97056,0.181,NULL,51572267565,805816680,12590885,13.08),(165430,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165430,34.19,0.8,68.9,76922,75,NULL,'CF, r','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165431,'IRAS','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165431,34.19,0.8,69,76922,75,NULL,'A82, H','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165432,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165432,33.56,0.69,51.5,76922,100,NULL,'mid-IR','NGC 7782',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165433,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165433,33.82,NULL,58.1,76922,NULL,NULL,'B','NGC 7782',NULL,'2002ApJ...565..681R',2002,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165434,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165434,34.3,0.4,72.4,76922,NULL,NULL,'mean','NGC 7782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165435,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165435,34.31,0.46,72.6,76922,NULL,NULL,'J','NGC 7782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165436,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165436,34.31,0.47,72.8,76922,NULL,NULL,'H','NGC 7782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165437,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165437,34.31,0.34,72.9,76922,NULL,NULL,'Malmquist cor.','NGC 7782',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165438,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165438,34.32,0.45,73,76922,NULL,NULL,'K','NGC 7782',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165439,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165439,34.38,0.33,75,76922,91,NULL,'H','NGC 7782',NULL,'1984ApJ...278..475B',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165440,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165440,34.47,0.32,78.2,76922,NULL,NULL,NULL,'NGC 7782',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165441,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165441,34.51,0.38,79.6,76922,75,NULL,'CF, r, raw','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165442,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165442,34.65,0.38,85.1,76922,75,NULL,'CF, r, cor','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165443,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165443,34.72,0.2,87.9,76922,74.4,NULL,NULL,'NGC 7782',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165444,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165444,34.79,0.38,90.9,76922,75,NULL,'CF, r, inv','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165445,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165445,34.88,0.47,94.7,76922,75,NULL,'A82, H, raw','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165446,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165446,35.21,0.47,110,76922,75,NULL,'A82, H, inv','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165447,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165447,35.23,0.47,111,76922,75,NULL,'A82, H, cor','NGC 7782',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165448,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165448,37.73,0.46,352,76923,70,NULL,NULL,'2MASX J23535419-1002410',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00009,NULL,'17.6g',0.18,NULL,'Group member',NULL,NULL,NULL,1,358.475875,-10.04469,0.081,NULL,49613935669,775217744,12112777,17.6),(165449,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165449,37.8,0.19,363,76924,70,NULL,NULL,'2MASX J23535459+1557405',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000147,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,358.4775417,15.96144,0.073,NULL,51664763832,807261934,12613467,17.4),(165450,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165450,37.8,0.19,363,76925,70,NULL,NULL,'2MASX J23535675+1547285',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000155,NULL,'17.2g',0.23,NULL,NULL,NULL,NULL,NULL,1,358.486625,15.79128,0.073,NULL,51664668803,807260450,12613444,17.2),(165451,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165451,38.74,0.46,561,76926,70,NULL,NULL,'SDSS J235356.95+144821.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000144,NULL,'18.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.4872917,14.80597,0.049,NULL,51646301128,806973455,12608960,18.7),(165452,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165452,37.94,0.46,387,76927,70,NULL,NULL,'2MASX J23535890+1539595',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000167,NULL,'17.7g',0.19,NULL,NULL,NULL,NULL,NULL,1,358.495667,15.66658,0.061,NULL,51664655122,807260236,12613441,17.7),(165453,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165453,37.46,0.12,311,76928,70,NULL,NULL,'SDSS J235401.95-101635.0',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000077,NULL,'18.0g',0.17,'E0','Group member',NULL,NULL,NULL,1,358.508125,-10.27639,0.09,NULL,49614060754,775219699,12112807,18),(165454,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15895','RN',165454,41.16,0.21,1440,76929,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15895',0.189261,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165455,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 15895','RN',165455,41.78,0.25,1910,76929,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15895',0.189261,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165456,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165456,37.46,0.12,311,76930,70,NULL,NULL,'2MASX J23540381-1020019',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000106,NULL,'16.6g',0.23,'S0','Group member',NULL,NULL,NULL,1,358.516,-10.33369,0.09,NULL,49614057380,775219646,12112806,16.6),(165457,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165457,35.73,0.47,140,76931,70,NULL,NULL,'2MASX J23540555-1752453',NULL,'2014MNRAS.445.2677S',2014,1,0.63,NULL,'G',0.00015,NULL,'15.71',0.6,'E',NULL,NULL,NULL,NULL,1,358.523375,-17.87917,0.012,NULL,49533841323,773966270,12093222,15.71),(165458,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165458,37.46,0.12,311,76932,70,NULL,NULL,'2MASX J23540571-1018309',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000092,NULL,'16.7g',0.32,'E0','Group member',NULL,NULL,NULL,1,358.523666667,-10.3085,0.09,NULL,49614059119,775219673,12112807,16.7),(165459,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165459,35.17,0.52,108,76933,70,NULL,NULL,'2MASX J23540640-0231488',NULL,'2014MNRAS.445.2677S',2014,1,0.54,NULL,'G',0.00015,NULL,'16.33',0.39,'HII',NULL,NULL,NULL,NULL,1,358.526625,-2.53014,0.089,NULL,49408409219,772006394,12062599,16.33),(165460,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 13084','RN',165460,42.85,0.24,2550,76934,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13084',0.457024,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165461,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165461,37.8,0.19,363,76935,70,NULL,NULL,'2MASX J23540701+1558109',NULL,'2015arXiv151105856S',2015,1,0.64,NULL,'G',0.000212,NULL,'15.9g',0.44,'E0',NULL,NULL,NULL,NULL,1,358.5292917,15.96986,0.073,NULL,51661928328,807217630,12612775,15.9),(165462,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165462,38.21,0.46,439,76936,70,NULL,NULL,'SDSS J235408.51-092616.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.00008,NULL,'18.3g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.5355,-9.43792,0.112,NULL,49428139199,772314674,12067416,18.3),(165463,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07051','R',165463,41.06,0.26,1220,76937,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 07051',0.333049,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.542,0.02503,0.081,NULL,51541969577,805343274,12583488,NULL),(165464,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 07051','R',165464,41.56,0.21,1540,76937,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 07051',0.333049,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165465,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165465,34.64,0.45,84.8,76938,NULL,NULL,'K','NGC 7783 NED01',NULL,'2007A&A...465...71T',2007,1,1.44,'Called \'NGC 7783a\'in MCG.  Component \'a)\' in UGC notes.','G',0.000057,NULL,'13.9g',0.66,'SB0','Pair member (points to parent)',NULL,NULL,NULL,1,358.542,0.38286,0.113,NULL,51542067946,805344811,12583512,13.9),(165466,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165466,35.1,0.4,105,76938,NULL,NULL,'mean','NGC 7783 NED01',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165467,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165467,37.46,0.12,311,76939,70,NULL,NULL,'2MASX J23541040-1029509',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000086,NULL,'17.1g',0.24,'S0','Group member',NULL,NULL,NULL,1,358.543375,-10.49758,0.09,NULL,49614030069,775219219,12112800,17.1),(165468,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165468,37.8,0.19,363,76940,70,NULL,NULL,'2MASX J23541069+1559449',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000169,NULL,'17.2g',0.26,NULL,NULL,NULL,NULL,NULL,1,358.544417,15.99597,0.073,NULL,51661928170,807217627,12612775,17.2),(165469,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165469,34.86,NULL,93.9,76941,NULL,NULL,NULL,'ESO 538- G 002',NULL,'2000BSAO...50....5K',2000,1,0.95,NULL,'G',0.000033,NULL,'17.13',0.13,'Sb',NULL,NULL,NULL,NULL,1,358.54875,-17.814,0.012,NULL,49533818479,773965913,12093217,17.13),(165470,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165470,35.19,NULL,109,76941,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 538- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165471,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165471,35.23,NULL,111,76941,NULL,NULL,'Dipole + Quadrupole','ESO 538- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165472,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165472,35.27,NULL,113,76941,NULL,NULL,'Dipole','ESO 538- G 002',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165473,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165473,35.28,0.49,114,76941,75,NULL,'IR','ESO 538- G 002',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165474,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165474,35.44,0.39,123,76941,NULL,NULL,NULL,'ESO 538- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165475,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165475,35.48,0.2,125,76941,74.4,NULL,NULL,'ESO 538- G 002',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165476,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165476,35.56,0.37,129,76941,NULL,NULL,'Malmquist cor.','ESO 538- G 002',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165477,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165477,34.4,0.18,74.4,76942,74.2,NULL,'SALT 2','NSF J235412.09+272432.3',0.02,'2010ApJ...716..712A',2010,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.550375,27.40897,0.085,NULL,52001762480,812527538,12695742,NULL),(165478,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe','R',165478,34.74,0.07,88.7,76942,NULL,NULL,'MLCS2k2, R(V) = 3.1','NSF J235412.09+272432.3',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165479,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe','R',165479,34.76,0.06,89.5,76942,NULL,NULL,'MLCS2k2, R(V) = 1.8','NSF J235412.09+272432.3',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165480,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165480,35.1,0.15,102,76942,73.8,NULL,'SALT 2 (SNANA)','NSF J235412.09+272432.3',0.0239,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165481,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165481,35.11,0.17,103,76942,70,NULL,'SALT 2','NSF J235412.09+272432.3',0.02,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165482,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165482,35.25,0.03,110,76942,72,NULL,'SALT2','NSF J235412.09+272432.3',0.02,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165483,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165483,35.27,0.2,111,76942,65,NULL,'SALT2','NSF J235412.09+272432.3',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165484,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165484,35.28,0.18,111,76942,65,NULL,'SALT','NSF J235412.09+272432.3',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165485,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165485,35.41,0.02,119,76942,70,NULL,'SALT 2','NSF J235412.09+272432.3',0.02,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165486,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165486,35.45,0.16,121,76942,65,NULL,'MLCS17','NSF J235412.09+272432.3',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165487,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007qe',NULL,165487,35.53,0.17,125,76942,65,NULL,'MLCS31','NSF J235412.09+272432.3',0.02,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165488,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165488,37.62,0.46,334,76943,70,NULL,NULL,'2MASX J23541227+1355209',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000176,NULL,'17.1g',0.24,NULL,NULL,NULL,NULL,NULL,1,358.55125,13.92261,0.061,NULL,51655241076,807113141,12611142,17.1),(165489,'BCG','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165489,37.65,0.35,315,76944,60,NULL,'ABELL 2670, BCG','2MASX J23541371-1025084',0.0774,'1980ApJ...241..486H',1980,1,0.76,NULL,'G',0.000116,NULL,'15.3g',0.64,'cD;BrClG;XBONG','Group member',NULL,NULL,NULL,1,358.5570417,-10.41903,0.09,NULL,49610563708,775165057,12111954,15.3),(165490,'BCG','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165490,37.65,0.35,315,76945,60,NULL,NULL,'ABELL 2670',0.0774,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',0.000223,NULL,NULL,NULL,'I-II   [BM]',NULL,NULL,NULL,NULL,1,358.557083,-10.41889,0.09,NULL,49610563708,775165057,12111954,NULL),(165491,'Tully-Fisher','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165491,37.51,0.12,318,76945,NULL,NULL,'ABELL 2670 cluster, avg. of 11 spiral galaxies              ','ABELL 2670',NULL,'2003AJ....126..675D',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165492,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165492,35.03,0.46,101,76946,70,NULL,NULL,'NGC 7783C',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00011,NULL,'16.27',0.22,'E','Compact group member',NULL,NULL,NULL,1,358.557417,0.35694,0.113,NULL,51542065718,805344776,12583512,16.27),(165493,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 14638',NULL,165493,40.28,0.21,1140,76947,70,NULL,'SN photometric redshift distance, z photo =0.312 +/- 0.038','SDSS-II SN 14638',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,358.5597917,-0.12483,0.081,NULL,49393708491,771776695,12059010,NULL),(165494,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 14638','R',165494,41.32,0.26,1440,76947,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14638',0.27802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165495,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 14638','R',165495,41.4,0.22,1490,76947,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14638',0.27802,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165496,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165496,37.8,0.19,363,76948,70,NULL,NULL,'SDSS J235416.06+154347.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000171,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,358.5669583,15.72986,0.073,NULL,51661823953,807215999,12612749,18.1),(165497,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,NULL,165497,34.94,0.54,97.3,76949,70,NULL,NULL,'LCRS B235141.2-422639',NULL,'2014MNRAS.445.2677S',2014,1,0.7,NULL,'G',0.00015,NULL,'14.54',0.3,NULL,NULL,NULL,NULL,NULL,1,358.570667,-42.16564,NULL,NULL,49944295159,780379611,12193431,14.54),(165498,'SNIa SDSS','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 04219','RN',165498,43.16,0.21,2650,76950,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04219',0.61557,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165499,'FP','2016-12-15 15:16:09','2016-12-16 11:21:26','1',NULL,'R',165499,37.46,0.12,311,76951,70,NULL,NULL,'SDSS J235419.53-102039.7',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000066,NULL,'18.4g',0.11,'E+','Group member',NULL,NULL,NULL,1,358.581416667,-10.34436,0.09,NULL,49610595023,775165547,12111961,18.4),(165500,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SN 2007om',NULL,165500,37.9,0.06,380,76952,70,NULL,'Hubble residual -0.25 for z0.10503','2MASX J23542073-0055023',NULL,'2011ApJ...740...92G',2011,1,0.42,NULL,'G',0.000095,NULL,'17.9g',0.09,'NLAGN',NULL,NULL,NULL,NULL,1,358.58625,-0.91722,0.097,NULL,49393540379,771774068,12058969,17.9),(165501,'SNIa','2016-12-15 15:16:09','2016-12-16 11:21:26','1','SDSS-II SN 20064','R',165501,38.34,0.18,422,76952,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007om','2MASX J23542073-0055023',0.105178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165502,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007om',NULL,165502,38.17,0.07,431,76952,70,NULL,'SALT 2','2MASX J23542073-0055023',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165503,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007om',NULL,165503,38.17,0.07,431,76952,70,NULL,'SALT 2, Malmquist cor.','2MASX J23542073-0055023',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165504,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 20064','R',165504,38.41,0.07,434,76952,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007om','2MASX J23542073-0055023',0.105178,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165505,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 01814','RN',165505,42.56,0.17,2360,76953,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 01814',0.377725,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165506,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 01814','RN',165506,42.67,0.24,2490,76953,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 01814',0.377725,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165507,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 13071','R',165507,41.14,0.26,1430,76954,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13071',0.178954,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.617833333,-0.71872,0.069,NULL,49396122540,771814414,12059600,NULL),(165508,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 13071','R',165508,41.53,0.28,1720,76954,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13071',0.178954,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165509,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 12895','RN',165509,40.06,0.1,910,76955,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 12895',0.1277,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165510,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 12895','RN',165510,40.51,0.23,1120,76955,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 12895',0.1277,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165511,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165511,37.79,0.27,362,76956,70,NULL,NULL,'SDSS J235430.48+135348.6',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000156,NULL,'18.4g',0.12,NULL,NULL,NULL,NULL,NULL,1,358.627,13.89683,0.061,NULL,51655236845,807113075,12611141,18.4),(165512,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165512,37.46,0.12,311,76957,70,NULL,NULL,'2MASX J23543086-1013244',NULL,'2015arXiv151105856S',2015,1,0.26,NULL,'G',0.000078,NULL,'17.6g',0.23,'S0',NULL,NULL,NULL,NULL,1,358.6285,-10.22336,0.065,NULL,49610722236,775167534,12111992,17.6),(165513,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165513,37.58,0.46,329,76958,70,NULL,NULL,'2MASX J23543103+1403090',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.00015,NULL,'17.6g',0.17,NULL,NULL,NULL,NULL,NULL,1,358.629167,14.0525,0.069,NULL,51655224263,807112879,12611138,17.6),(165514,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165514,37.46,0.12,311,76959,70,NULL,NULL,'2MASX J23543317-1026144',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000061,NULL,'18.1g',0.13,NULL,'Group member',NULL,NULL,NULL,1,358.638125,-10.43736,0.09,NULL,49610611771,775165808,12111965,18.1),(165515,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165515,34.17,0.8,68.1,76960,75,NULL,'MAT, I','2MASX J23543507-1431497',NULL,'1997ApJS..109..333W',1997,1,1.5,NULL,'G',0.000033,NULL,'13.88',0.7,'SAB(s)c',NULL,NULL,NULL,NULL,1,358.646417,-14.53036,0.056,NULL,49554898256,774295285,12098363,13.88),(165516,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165516,32.61,0.32,33.3,76960,85,NULL,'I, inv','2MASX J23543507-1431497',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165517,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165517,32.64,0.32,33.7,76960,85,NULL,'I, raw','2MASX J23543507-1431497',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165518,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165518,33.01,0.43,39.9,76960,75,NULL,'MAT, I, inv','2MASX J23543507-1431497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165519,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165519,33.04,0.43,40.6,76960,75,NULL,'MAT, I, raw','2MASX J23543507-1431497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165520,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165520,33.38,0.43,47.5,76960,75,NULL,'MAT, I, cor','2MASX J23543507-1431497',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165521,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165521,34.03,0.2,64,76960,74.4,NULL,NULL,'2MASX J23543507-1431497',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165522,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165522,34.25,0.5,70.7,76960,NULL,NULL,NULL,'2MASX J23543507-1431497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165523,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165523,34.52,0.45,80,76960,NULL,NULL,'Malmquist cor.','2MASX J23543507-1431497',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165524,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165524,36.5,0.48,199,76961,70,NULL,NULL,'AM 2352-275 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.2,NULL,'G',0.000083,NULL,'15.5',0.2,'E',NULL,NULL,NULL,NULL,1,358.649583,-27.56747,0,NULL,50050975384,782046490,12219476,15.5),(165525,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165525,37.79,0.27,362,76962,70,NULL,NULL,'2MASX J23544004+1353181',NULL,'2015arXiv151105856S',2015,1,0.57,NULL,'G',0.000202,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,358.6669583,13.88828,0.069,NULL,51655454251,807116472,12611194,16),(165526,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165526,36.18,0.53,172,76963,70,NULL,NULL,'2MASX J23544370-0519592',NULL,'2014MNRAS.445.2677S',2014,1,0.59,NULL,'G',0.00015,NULL,'16.52',0.27,NULL,NULL,NULL,NULL,NULL,1,358.682125,-5.333,0.108,NULL,49447402728,772615667,12072119,16.52),(165527,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165527,37.53,0.13,321,76964,70,NULL,NULL,'2MASX J23544512-0908037',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000078,NULL,'17.9g',0.17,NULL,NULL,NULL,NULL,NULL,1,358.687875,-9.13444,0.112,NULL,49428897196,772326518,12067601,17.9),(165528,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165528,37.79,0.27,362,76965,70,NULL,NULL,'2MASX J23544527+1349151',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000155,NULL,'17.8g',0.18,NULL,NULL,NULL,NULL,NULL,1,358.688667,13.821,0.069,NULL,51655448498,807116382,12611193,17.8),(165529,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165529,37.8,0.19,363,76966,70,NULL,NULL,'2MASX J23544630+1537191',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000172,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,358.693083,15.622,0.073,NULL,51644737605,806949025,12608578,17.3),(165530,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165530,35.76,0.71,142,76967,70,NULL,NULL,'2MASX J23544656-8402096',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.8b',NULL,NULL,NULL,NULL,NULL,NULL,1,358.693833333,-84.036,0.425,NULL,48343784855,755371638,11802681,15.8),(165531,'RR Lyrae','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165531,24.4,0.17,0.759,76968,NULL,NULL,NULL,'Andromeda XXI',NULL,'2015ApJ...806..200C',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,358.69875,42.47083,0.437,0,51810773001,809543328,12649114,NULL),(165532,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165532,24.59,0.07,0.827,76968,NULL,NULL,NULL,'Andromeda XXI',NULL,'2012ApJ...758...11C',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165533,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165533,24.67,0.13,0.859,76968,NULL,NULL,NULL,'Andromeda XXI',NULL,'2009ApJ...705..758M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165534,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165534,37.46,0.12,311,76969,70,NULL,NULL,'2MASX J23544905-1019177',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000078,NULL,'17.2g',0.2,'S0/a','Group member',NULL,NULL,NULL,1,358.70425,-10.32175,0.065,NULL,49610726576,775167602,12111993,17.2),(165535,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 20745','RN',165535,44.04,0.35,3940,76970,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20745',0.629647,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165536,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165536,37.53,0.13,321,76971,70,NULL,NULL,'SDSS J235457.92-092053.5',NULL,'2015arXiv151105856S',2015,1,0.17,NULL,'G',0.000083,NULL,'18.2g',0.09,NULL,NULL,NULL,NULL,NULL,1,358.741375,-9.34822,0.112,NULL,49429271366,772332365,12067693,18.2),(165537,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165537,35.51,0.62,127,76972,70,NULL,NULL,'2MASX J23545973-1118077',NULL,'2014MNRAS.445.2677S',2014,1,0.44,NULL,'G',0.00015,NULL,'16.91',0.21,NULL,NULL,NULL,NULL,NULL,1,358.748875,-11.30214,0.045,NULL,49543418742,774115917,12095561,16.91),(165538,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165538,35.37,0.51,118,76973,70,NULL,NULL,'2MASX J23550331-0226024',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00015,NULL,'16.16',0.4,NULL,NULL,NULL,NULL,NULL,1,358.764,-2.43392,0.069,NULL,49406460348,771975942,12062124,16.16),(165539,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165539,37.53,0.13,321,76974,70,NULL,NULL,'2MASXi J2355056-092113',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000056,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,358.773833,-9.35361,0.112,NULL,49429766581,772340102,12067814,18.1),(165540,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165540,37.53,0.13,321,76975,70,NULL,NULL,'2MASX J23550681-0922317',NULL,'2015arXiv151105856S',2015,1,0.68,NULL,'G',0.0001,NULL,'15.9g',0.45,'BrClG',NULL,NULL,NULL,NULL,1,358.778416667,-9.37556,0.09,NULL,49429257570,772332149,12067689,15.9),(165541,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165541,37.53,0.13,321,76976,70,NULL,NULL,'2MASX J23551048-0909203',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000093,NULL,'16.6g',0.33,NULL,NULL,NULL,NULL,NULL,1,358.793583,-9.15561,0.112,NULL,49429780750,772340324,12067817,16.6),(165542,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165542,37.53,0.13,321,76977,70,NULL,NULL,'2MASX J23551312-0919473',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000075,NULL,'17.4g',0.2,NULL,NULL,NULL,NULL,NULL,1,358.80475,-9.32983,0.112,NULL,49429768605,772340134,12067814,17.4),(165543,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165543,34.66,0.63,85.3,76978,70,NULL,NULL,'MCG -01-01-002',NULL,'2014MNRAS.445.2677S',2014,1,1.4,NULL,'G',0.00005,NULL,'14.50',0.8,'SB(rs)b:',NULL,NULL,NULL,NULL,1,358.807125,-3.7465,0.122,NULL,49404091682,771938932,12061545,14.5),(165544,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165544,33.46,0.8,49.3,76979,75,NULL,'MAT, I','ESO 472- G 010',NULL,'1997ApJS..109..333W',1997,1,1.6,NULL,'G',0.000023,NULL,'14.62',0.6,'SB(s)c',NULL,NULL,NULL,NULL,1,358.810667,-23.83236,0.034,NULL,49999346443,781239788,12206871,14.62),(165545,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165545,33.15,0.32,42.7,76979,85,NULL,'I, raw','ESO 472- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165546,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165546,33.16,0.32,42.8,76979,85,NULL,'I, inv','ESO 472- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165547,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165547,33.37,0.43,47.3,76979,75,NULL,'MAT, I, raw','ESO 472- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165548,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165548,33.46,0.43,49.2,76979,75,NULL,'MAT, I, inv','ESO 472- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165549,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165549,33.49,0.2,49.9,76979,74.4,NULL,NULL,'ESO 472- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165550,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165550,33.55,0.53,51.3,76979,NULL,NULL,NULL,'ESO 472- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165551,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165551,33.61,0.43,52.6,76979,75,NULL,'MAT, I, cor','ESO 472- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165552,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165552,33.83,0.46,58.3,76979,NULL,NULL,'Malmquist cor.','ESO 472- G 010',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165553,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165553,35.86,0.2,149,76980,74.4,NULL,NULL,'CGCG 432-040',NULL,'2013AJ....146...86T',2013,1,1.05,NULL,'G',0.000095,NULL,'15.3g',0.38,'S?',NULL,NULL,NULL,NULL,1,358.8170417,14.37547,0.061,NULL,51647120505,806986257,12609160,15.3),(165554,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165554,35.85,0.49,148,76981,70,NULL,NULL,'CGCG 381-062',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.000083,NULL,'14.6R',0.7,NULL,NULL,NULL,NULL,NULL,1,358.817583333,-1.42328,0.041,NULL,49394785648,771793525,12059273,14.6),(165555,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165555,37.96,0.46,391,76982,70,NULL,NULL,'2MASX J23551740+1419155',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000165,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,358.822667,14.32106,0.061,NULL,51647132025,806986437,12609163,17.9),(165556,'D-Sigma','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165556,33.46,0.4,49.1,76983,75,NULL,'Edat, raw','NGC 7785',NULL,'1997ApJS..109..333W',1997,1,2.5,NULL,'G',0.000017,NULL,'12.63',1.3,'E5-6','Isolated galaxy',NULL,NULL,NULL,1,358.829291667,5.91583,0.165,NULL,51568211752,805753308,12589895,12.63),(165557,'D-Sigma','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165557,33.79,0.4,57.4,76983,75,NULL,'Edat, cor','NGC 7785',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165558,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165558,32.15,0.4,26.9,76983,95,NULL,'de Vaucouleurs','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165559,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165559,32.65,0.27,33.9,76983,95,NULL,'Weighted Mean','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165560,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165560,33.16,0.46,42.9,76983,95,NULL,'Michard 1979a','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165561,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165561,33.24,0.63,44.5,76983,95,NULL,'Michard 1979b, c','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165562,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165562,35.55,0.81,129,76983,55,NULL,'Visvanathan & Sandage 1979','NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165563,'Tertiary','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165563,33.47,0.5,49.4,76983,95,NULL,NULL,'NGC 7785',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165564,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165564,33.14,0.45,42.5,76983,NULL,NULL,'K','NGC 7785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165565,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165565,33.42,0.4,48.4,76983,NULL,NULL,'mean','NGC 7785',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165566,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165566,34.24,NULL,70.6,76984,NULL,NULL,'Dipole + Quadrupole + Octopole','FGC 2558',NULL,'2010Ap&SS.325..163P',2010,1,1.01,NULL,'G',0.000016,NULL,'16.5',0.1,'Sd',NULL,NULL,NULL,NULL,1,358.83,3.825,0.157,NULL,51547569536,805430774,12584855,16.5),(165567,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165567,34.26,NULL,71.3,76984,NULL,NULL,'Dipole + Quadrupole','FGC 2558',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165568,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165568,34.28,NULL,71.6,76984,NULL,NULL,'Dipole','FGC 2558',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165569,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165569,34.34,NULL,73.8,76984,NULL,NULL,NULL,'FGC 2558',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165570,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165570,34.66,0.49,85.5,76985,75,NULL,'IR','CGCG 498-035',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000033,NULL,'15.46',0.3,'S?','Pair member (points to parent)',NULL,NULL,NULL,1,358.8389583,30.38514,0.157,NULL,51973287653,812082619,12688790,15.46),(165571,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165571,38.34,0.46,466,76986,70,NULL,NULL,'SDSS J235523.53+154802.5',NULL,'2015arXiv151105856S',2015,1,0.13,NULL,'G',0.000153,NULL,'18.6g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.848083333,15.80072,0.081,NULL,51644764111,806949439,12608584,18.6),(165572,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 14495','RN',165572,41.41,0.12,1390,76987,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 14495',0.37724,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165573,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 14495','RN',165573,41.73,0.19,1610,76987,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 14495',0.37724,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165574,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 01123','RN',165574,41.11,0.17,1310,76988,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 01123',0.267605,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165575,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 01123','RN',165575,41.88,0.24,1870,76988,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01123',0.267605,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165576,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165576,37.53,0.13,321,76989,70,NULL,NULL,'2MASX J23552696-0904333',NULL,'2015arXiv151105856S',2015,1,0.5,NULL,'G',0.000105,NULL,'16.0g',0.44,'E0',NULL,NULL,NULL,NULL,1,358.862417,-9.07592,0.112,NULL,49429023691,772328495,12067632,16),(165577,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165577,36.12,0.55,168,76990,70,NULL,NULL,'2MASX J23552752-7518141',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'15.3R',NULL,NULL,NULL,NULL,NULL,NULL,1,358.864625,-75.30397,0.165,NULL,48426283846,756660685,11822823,15.3),(165578,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165578,31.95,0.4,24.5,76991,75,NULL,'B','UGC 12843',NULL,'1988NBGC.C....0000T',1988,1,2.8,'The 2MASS position is for a stellar object northwest of the galaxy\'s center.','G',0.000003,NULL,'13.83',1.3,'SABdm','X-ray-faint group member',NULL,NULL,NULL,1,358.8745417,17.92128,0.093,NULL,51619235681,806550557,12602352,13.83),(165579,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 19336',NULL,165579,40.82,0.62,1460,76992,70,NULL,'SN photometric redshift distance, z photo =0.427 +/- 0.207','SDSS-II SN 19336',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,358.877417,0.26392,0.093,NULL,51540165698,805315089,12583048,NULL),(165580,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165580,36.34,0.46,185,76993,70,NULL,NULL,'2MASX J23553155-1043423',NULL,'2015arXiv151105856S',2015,1,0.33,NULL,'G',0.000067,NULL,'16.7g',0.3,NULL,'Group member',NULL,NULL,NULL,1,358.8815417,-10.7285,0.08,NULL,49611064209,775172878,12112076,16.7),(165581,'BCG','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165581,37.92,0.35,358,76994,60,NULL,NULL,'ABELL 2675',0.0726,'1980ApJ...241..486H',1980,1,NULL,NULL,'GClstr',NULL,NULL,NULL,NULL,'II     [BM]',NULL,NULL,NULL,NULL,1,358.8892917,11.42831,0.153,NULL,51640816300,806887754,12607621,NULL),(165582,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165582,37.53,0.13,321,76995,70,NULL,NULL,'MCG -02-01-001',NULL,'2015arXiv151105856S',2015,1,0.82,NULL,'G',0.00009,NULL,'15.7g',0.4,'E0',NULL,NULL,NULL,NULL,1,358.8899583,-9.65472,0.083,NULL,49429336489,772333382,12067709,15.7),(165583,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165583,37.58,0.46,329,76996,70,NULL,NULL,'SDSS J235533.61+152623.8',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000137,NULL,'18.4g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.8900417,15.43997,0.065,NULL,51648283844,807004435,12609444,18.4),(165584,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165584,37.49,0.46,315,76997,70,NULL,NULL,'2MASX J23553673-0954333',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',0.000076,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,358.903041667,-9.90914,0.083,NULL,49426238229,772284972,12066952,17.9),(165585,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165585,37.53,0.13,321,76998,70,NULL,NULL,'2MASX J23553785-0938033',NULL,'2015arXiv151105856S',2015,1,0.49,NULL,'G',0.000098,NULL,'16.0g',0.38,'S0^-',NULL,NULL,NULL,NULL,1,358.9077917,-9.63425,0.09,NULL,49429294746,772332730,12067698,16),(165586,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165586,35.09,0.8,104,76999,75,NULL,'CF, r','UGC 12844',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000017,NULL,'15.06',0.5,'Scd:','Isolated galaxy',NULL,NULL,NULL,1,358.91425,19.51572,0.081,NULL,51620789907,806574842,12602731,15.06),(165587,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165587,35.21,0.38,110,76999,75,NULL,'CF, r, raw','UGC 12844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165588,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165588,35.34,0.38,117,76999,75,NULL,'CF, r, inv','UGC 12844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165589,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165589,35.36,0.38,118,76999,75,NULL,'CF, r, cor','UGC 12844',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165590,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165590,35.61,0.2,132,76999,74.4,NULL,NULL,'UGC 12844',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165591,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165591,35.61,0.48,133,76999,NULL,NULL,'Malmquist cor.','UGC 12844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165592,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165592,35.75,0.45,141,76999,NULL,NULL,NULL,'UGC 12844',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165593,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165593,33.15,0.2,42.7,77000,74.4,NULL,NULL,'UGC 12845',NULL,'2013AJ....146...86T',2013,1,2.1,NULL,'G',0.00001,NULL,'14.7',1.6,'Sd',NULL,NULL,NULL,NULL,1,358.9245,31.89978,0.197,NULL,51963165538,811924461,12686319,14.7),(165594,'BCG','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165594,37.92,0.35,358,77001,60,NULL,'ABELL 2675, BCG','2MASX J23554260+1120355',0.0726,'1980ApJ...241..486H',1980,1,0.8,NULL,'G',0.00013,NULL,'17.24',0.5,'cD','Brightest group member',NULL,NULL,NULL,1,358.9274583,11.34317,0.153,NULL,51641028387,806891068,12607672,17.24),(165595,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165595,35.81,0.57,145,77002,70,NULL,NULL,'6dF J2355437-340931',NULL,'2014MNRAS.445.2677S',2014,1,NULL,NULL,'G',0.00015,NULL,'14.6R',NULL,NULL,NULL,NULL,NULL,NULL,1,358.932541667,-34.15872,NULL,NULL,49946207822,780409497,12193898,14.6),(165596,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165596,35.47,0.62,124,77003,70,NULL,NULL,'2MASX J23554516-0115199',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.50',0.41,NULL,NULL,NULL,NULL,NULL,1,358.938333,-1.25547,0.061,NULL,49395503708,771804745,12059449,16.5),(165597,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165597,35.73,0.46,140,77003,70,NULL,NULL,'2MASX J23554516-0115199',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165598,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007od',NULL,165598,32.07,0.1,25.9,77004,NULL,NULL,'SCM','UGC 12846',NULL,'2015ApJ...799..215P',2015,1,1.8,NULL,'G',0.00001,NULL,'17.',1.7,'Sm:','X-ray-faint group member',NULL,NULL,NULL,1,358.941667,18.425,0.057,NULL,51616660319,806510317,12601723,17),(165599,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007od',NULL,165599,32.2,0.2,27.5,77004,NULL,NULL,'later epochs','UGC 12846',NULL,'2012MNRAS.422.1178I',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165600,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007od',NULL,165600,32.5,0.3,31.6,77004,NULL,NULL,'all epochs','UGC 12846',NULL,'2012MNRAS.422.1178I',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165601,'Tully est','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165601,31.91,0.8,24.1,77004,75,NULL,NULL,'UGC 12846',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165602,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165602,37.53,0.13,321,77005,70,NULL,NULL,'2MASX J23554650-0927343',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000084,NULL,'17.2g',0.22,NULL,NULL,NULL,NULL,NULL,1,358.943833333,-9.45967,0.09,NULL,49429826945,772341046,12067828,17.2),(165603,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165603,35.69,0.64,138,77006,70,NULL,NULL,'LSBG F409-044',NULL,'2014MNRAS.445.2677S',2014,1,0.82,NULL,'G',0.00015,NULL,'15.4b',0.54,'E',NULL,NULL,NULL,NULL,1,358.95725,-29.86967,NULL,NULL,50036646565,781822602,12215978,15.4),(165604,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165604,37.53,0.13,321,77007,70,NULL,NULL,'SDSS J235549.76-092345.2',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000065,NULL,'18.1g',0.13,NULL,NULL,NULL,NULL,NULL,1,358.957333,-9.39592,0.09,NULL,49429834925,772341170,12067830,18.1),(165605,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 20168','RN',165605,42.29,0.28,2310,77008,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 20168',0.239904,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165606,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 20168','RN',165606,43.01,0.49,3230,77008,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 20168',0.239904,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165607,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165607,37.53,0.13,321,77009,70,NULL,NULL,'2MASX J23555143-0931503',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000097,NULL,'17.8g',0.15,NULL,NULL,NULL,NULL,NULL,1,358.964167,-9.53067,0.09,NULL,49429643632,772338181,12067784,17.8),(165608,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165608,36.05,0.46,162,77010,70,NULL,NULL,'UGC 12847',NULL,'2015arXiv151105856S',2015,1,0.78,NULL,'G',0.000111,NULL,'15.0g',0.64,'Very compact',NULL,NULL,NULL,NULL,1,358.966583333,0.55792,0.085,NULL,51543102354,805360974,12583765,15),(165609,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165609,40.26,0.14,854,77011,74.2,NULL,'SALT 2','SDSS J235552.42+005232.2',0.32,'2010ApJ...716..712A',2010,1,0.04,NULL,'G',NULL,NULL,'22.8g',0.02,NULL,NULL,NULL,NULL,NULL,1,358.968416667,0.87561,0.093,NULL,51543761477,805371273,12583926,22.8),(165610,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165610,40.61,0.04,1000,77011,70,NULL,'SDSS-II SN 06924','SDSS J235552.42+005232.2',0.32,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165611,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165611,40.97,0.15,1180,77011,65,NULL,'SALT2','SDSS J235552.42+005232.2',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165612,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165612,41.02,0.17,1210,77011,70,NULL,'SDSS-II SN 06924, SALT 2','SDSS J235552.42+005232.2',0.32,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165613,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 06924','R',165613,41.09,0.24,1250,77011,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005ja','SDSS J235552.42+005232.2',0.32,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165614,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 06924','R',165614,41.13,0.14,1270,77011,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005ja','SDSS J235552.42+005232.2',0.32,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165615,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2005ja',NULL,165615,41.18,0.13,1310,77011,65,NULL,'MLCS2k2','SDSS J235552.42+005232.2',0.32,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165616,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165616,33.69,0.8,54.7,77012,75,NULL,'MAT, I','ESO 111- G 009',NULL,'1997ApJS..109..333W',1997,1,1.9,NULL,'G',0.000013,NULL,'14.50',0.5,'SA:(s)c        LINER','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,358.9805,-60.68175,0,NULL,48750094677,761720229,11901878,14.5),(165617,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165617,33.62,0.32,53,77012,85,NULL,'I, raw','ESO 111- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165618,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165618,33.65,0.32,53.7,77012,85,NULL,'I, inv','ESO 111- G 009',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165619,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165619,33.69,0.43,54.8,77012,75,NULL,'MAT, I, raw','ESO 111- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165620,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165620,33.85,0.43,58.8,77012,75,NULL,'MAT, I, inv','ESO 111- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165621,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165621,33.98,0.43,62.6,77012,75,NULL,'MAT, I, cor','ESO 111- G 009',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165622,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165622,34.08,0.34,65.4,77012,NULL,NULL,'Malmquist cor.','ESO 111- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165623,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165623,34.1,0.34,66,77012,NULL,NULL,NULL,'ESO 111- G 009',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165624,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165624,34.14,0.2,67.3,77012,74.4,NULL,NULL,'ESO 111- G 009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165625,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165625,37.57,0.33,327,77013,70,NULL,NULL,'SDSS J235558.43+143422.8',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000153,NULL,'17.5g',0.21,NULL,NULL,NULL,NULL,NULL,1,358.9934583,14.573,0.025,NULL,51647716320,806995567,12609305,17.5),(165626,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165626,36.5,0.61,200,77014,70,NULL,NULL,'2MASX J23555973-0134102',NULL,'2014MNRAS.445.2677S',2014,1,0.36,NULL,'G',0.00015,NULL,'17.05',0.3,NULL,NULL,NULL,NULL,NULL,1,358.998875,-1.56947,0.057,NULL,49394964243,771796316,12059317,17.05),(165627,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165627,37.26,0.46,284,77015,70,NULL,NULL,'2MASX J23560014-0858103',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000072,NULL,'17.6g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.000625,-8.9695,0.118,NULL,49428976889,772327763,12067621,17.6),(165628,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 14193','RN',165628,40.41,0.26,1050,77016,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 14193',0.150609,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165629,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 14193','RN',165629,40.72,0.47,1210,77016,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 14193',0.150609,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165630,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165630,36.51,1.01,200,77017,70,NULL,NULL,'2MASX J23560060-0140412',NULL,'2014MNRAS.445.2677S',2014,1,0.41,NULL,'G',0.00015,NULL,'16.96',0.22,NULL,NULL,NULL,NULL,NULL,1,359.0025,-1.67819,0.057,NULL,49394987518,771796679,12059323,16.96),(165631,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165631,36.25,0.2,178,77018,74.4,NULL,NULL,'MRK 0541',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.00004,NULL,'15.91',0.6,'Compact        Sy1',NULL,NULL,NULL,'Sy 1.0',1,359.008167,7.52319,0.173,NULL,51570654688,805791479,12590491,15.91),(165632,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165632,43.61,0.46,2930,77019,69.7,NULL,'Fiducial','GRB 051022',0.8,'2009MNRAS.400..775C',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE 2',NULL,NULL,NULL,NULL,1,359.0175,19.60897,0.065,NULL,51620795842,806574935,12602733,NULL),(165633,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165633,43.71,0.22,3070,77019,69.7,NULL,'Fiducial','GRB 051022',0.8,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165634,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165634,43.77,0.28,3150,77019,69.7,NULL,'Calibrated','GRB 051022',0.8,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165635,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165635,43.81,0.43,3210,77019,72,NULL,NULL,'GRB 051022',0.8,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165636,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165636,43.95,0.42,3430,77019,70,NULL,NULL,'GRB 051022',0.8,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165637,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165637,34.99,0.2,99.5,77020,74.4,NULL,NULL,'UGC 12850',NULL,'2013AJ....146...86T',2013,1,1,NULL,'G',0.000033,NULL,'15.45',0.4,'S?',NULL,NULL,NULL,NULL,1,359.025667,29.37792,0.185,NULL,51971469727,812054214,12688347,15.45),(165638,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165638,35,0.46,100,77020,NULL,NULL,'Malmquist cor.','UGC 12850',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165639,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165639,35.03,0.46,101,77020,NULL,NULL,NULL,'UGC 12850',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165640,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165640,33.31,0.47,45.9,77021,NULL,NULL,'H','ESO 111- G 010',NULL,'2007A&A...465...71T',2007,1,1.3,NULL,'G',0.000033,NULL,'14.10',0.8,'(R\'_1)SAB(rs)b HII','Pair member, radial velocity confirmed',NULL,NULL,NULL,1,359.028583,-60.67122,0,NULL,48750095182,761720237,11901878,14.1),(165641,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165641,33.47,0.46,49.4,77021,NULL,NULL,'J','ESO 111- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165642,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165642,33.51,0.45,50.4,77021,NULL,NULL,'K','ESO 111- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165643,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165643,33.8,0.4,57.4,77021,NULL,NULL,'mean','ESO 111- G 010',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165644,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165644,37.52,0.46,319,77022,70,NULL,NULL,'2MASX J23560761-0959383',NULL,'2015arXiv151105856S',2015,1,0.37,NULL,'G',0.000069,NULL,'17.0g',0.3,NULL,NULL,NULL,NULL,NULL,1,359.0317917,-9.99392,0.081,NULL,49426427053,772287922,12066998,17),(165645,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165645,34.54,0.46,81,77023,NULL,NULL,NULL,'NGC 7787',NULL,'2009ApJS..182..474S',2009,1,1.22,NULL,'G',0.000094,NULL,'15.0g',0.47,'(R\')SB(rs)0/a:',NULL,NULL,NULL,NULL,1,359.032583333,0.54947,0.085,NULL,51543131520,805361430,12583772,15),(165646,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165646,34.58,0.45,82.2,77023,NULL,NULL,'Malmquist cor.','NGC 7787',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165647,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165647,34.6,0.2,83.2,77023,74.4,NULL,NULL,'NGC 7787',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165648,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165648,37.53,0.13,321,77024,70,NULL,NULL,'SDSS J235608.67-093036.6',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000073,NULL,'18.5g',0.1,NULL,NULL,NULL,NULL,NULL,1,359.036167,-9.51019,0.09,NULL,49429653337,772338333,12067786,18.5),(165649,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165649,35.71,0.59,139,77025,70,NULL,NULL,'2MASX J23560940-1804479',NULL,'2014MNRAS.445.2677S',2014,1,0.47,NULL,'G',0.00015,NULL,'16.67',0.33,NULL,NULL,NULL,NULL,NULL,1,359.039167,-18.08,0.055,NULL,49534637841,773978716,12093417,16.67),(165650,'FP','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,'R',165650,37.57,0.33,327,77026,70,NULL,NULL,'2MASX J23561087+1436363',NULL,'2015arXiv151105856S',2015,1,0.31,NULL,'G',0.000169,NULL,'17.2g',0.25,NULL,NULL,NULL,NULL,NULL,1,359.045291667,14.61022,0.025,NULL,51647714132,806995533,12609305,17.2),(165651,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 09542','RN',165651,41.21,0.44,1340,77027,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 09542',0.296679,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165652,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SDSS-II SN 09542','RN',165652,41.23,0.38,1360,77027,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 09542',0.296679,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165653,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165653,35.41,0.11,121,77028,NULL,NULL,NULL,'MCG +05-01-009',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',0.000519,NULL,'17',0.3,NULL,NULL,NULL,NULL,NULL,1,359.069375,29.38931,0.185,NULL,51971472875,812054263,12688347,17),(165654,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:26','1',NULL,NULL,165654,35.63,0.2,134,77028,74.4,NULL,NULL,'MCG +05-01-009',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165655,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:26','1','SN 2007mk',NULL,165655,39.24,0.06,703,77029,70,NULL,'Hubble residual -0.07 for z0.18641','SDSS J235617.52-003013.9',NULL,'2011ApJ...740...92G',2011,1,0.05,NULL,'G',0.00016,NULL,'22.5g',0.04,NULL,NULL,NULL,NULL,NULL,1,359.073,-0.50389,0.093,NULL,49395953423,771811772,12059558,22.5),(165656,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19282','R',165656,39.7,0.2,735,77029,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007mk','SDSS J235617.52-003013.9',0.18641,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165657,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19282','R',165657,39.86,0.09,790,77029,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007mk','SDSS J235617.52-003013.9',0.18641,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165658,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007mk',NULL,165658,39.68,0.07,863,77029,70,NULL,'SALT 2','SDSS J235617.52-003013.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165659,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007mk',NULL,165659,39.69,0.07,867,77029,70,NULL,'SALT 2, Malmquist cor.','SDSS J235617.52-003013.9',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165660,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165660,34.42,0.51,76.7,77030,70,NULL,NULL,'IC 1517',NULL,'2014MNRAS.445.2677S',2014,1,0.94,NULL,'G',0.000107,NULL,'14.2g',0.72,'S0^-',NULL,NULL,NULL,NULL,1,359.078375,-0.30561,0.097,NULL,49392639245,771759988,12058749,14.2),(165661,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165661,34.85,0.46,93.1,77030,70,NULL,NULL,'IC 1517',NULL,'2015arXiv151105856S',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165662,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165662,35.51,0.53,127,77031,70,NULL,NULL,'2MASX J23562233-3503493',NULL,'2014MNRAS.445.2677S',2014,1,0.58,NULL,'G',0.000107,NULL,'15.61',0.53,'E',NULL,NULL,NULL,NULL,1,359.0929583,-35.06367,NULL,NULL,49949350782,780458605,12194665,15.61),(165663,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165663,36.29,0.52,181,77032,70,NULL,NULL,'AM 2353-572',NULL,'2014MNRAS.445.2677S',2014,1,1.3,NULL,'G',0.00015,NULL,'15.74',0.5,'S0- pec',NULL,NULL,NULL,NULL,1,359.09325,-57.05483,0,NULL,48738855102,761544610,11899134,15.74),(165664,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165664,36.05,0.49,162,77033,70,NULL,NULL,'IC 5364 NED02',NULL,'2014MNRAS.445.2677S',2014,1,0.6,NULL,'G',0.000103,NULL,'14.5',0.6,'E/S?','Pair member (points to parent)',NULL,NULL,NULL,1,359.105166667,-29.02339,0,NULL,50037798798,781840606,12216259,14.5),(165665,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165665,36.1,0.49,166,77034,70,NULL,NULL,'MCG -02-01-005',NULL,'2014MNRAS.445.2677S',2014,1,1.1,NULL,'G',0.000013,NULL,'15.1g',0.52,'E0',NULL,NULL,NULL,NULL,1,359.1105,-11.08597,0.07,NULL,49611133733,775173964,12112093,15.1),(165666,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165666,31.94,0.8,24.4,77035,75,NULL,'MAT, I','ESO 012- G 010',NULL,'1997ApJS..109..333W',1997,1,3.1,NULL,'G',0.000017,NULL,'14.36',1.6,'SB(s)d',NULL,NULL,NULL,NULL,1,359.1147917,-81.56658,0.377,NULL,48348797205,755449956,11803905,14.36),(165667,'Tully est','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165667,31.8,0.8,23,77035,75,NULL,NULL,'ESO 012- G 010',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165668,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165668,32.55,0.4,32.4,77035,NULL,NULL,NULL,'ESO 012- G 010',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165669,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165669,32.55,0.4,32.4,77035,73,NULL,'opt','ESO 012- G 010',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165670,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165670,32.63,0.32,33.6,77035,85,NULL,'I, inv','ESO 012- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165671,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165671,32.64,0.32,33.7,77035,85,NULL,'I, raw','ESO 012- G 010',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165672,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165672,32.79,0.43,36.1,77035,75,NULL,'MAT, I, raw','ESO 012- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165673,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165673,32.83,0.43,36.8,77035,75,NULL,'MAT, I, inv','ESO 012- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165674,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165674,33.21,0.43,43.8,77035,75,NULL,'MAT, I, cor','ESO 012- G 010',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165675,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165675,33.55,0.43,51.2,77035,75,NULL,'3.6 micron, color + selection bias corrected','ESO 012- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165676,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165676,33.59,0.43,52.3,77035,75,NULL,'3.6 micron, color corrected','ESO 012- G 010',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165677,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165677,33.62,0.2,53,77035,74.4,NULL,NULL,'ESO 012- G 010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165678,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 03868','RN',165678,40.27,0.37,946,77036,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 03868',0.19607,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165679,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165679,36.27,0.7,179,77037,70,NULL,NULL,'2MASX J23563069-0023265',NULL,'2014MNRAS.445.2677S',2014,1,0.49,NULL,'G',0.000073,NULL,'15.9g',0.32,'S0^-',NULL,NULL,NULL,NULL,1,359.12775,-0.39078,0.093,NULL,49392501224,771757831,12058716,15.9),(165680,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17477','RN',165680,41.85,0.2,2160,77038,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 17477',0.08448,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165681,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17477','RN',165681,41.98,0.12,2290,77038,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 17477',0.08448,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165682,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 11732','R',165682,40.92,0.37,1080,77039,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 11732',0.42,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,359.142,-0.13025,0.097,NULL,49392569091,771758892,12058732,NULL),(165683,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165683,35.01,0.49,101,77040,75,NULL,'IR','KUG 2354+269',NULL,'2011yCatp016004901K',2011,1,0.9,NULL,'G',0.000007,NULL,'15.63',0.2,'Sbc','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,359.1434583,27.20069,0.137,NULL,51946881227,811670019,12682344,15.63),(165684,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165684,35.25,0.44,112,77040,NULL,NULL,'Malmquist cor.','KUG 2354+269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165685,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165685,35.33,0.2,116,77040,74.4,NULL,NULL,'KUG 2354+269',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165686,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165686,35.34,0.42,117,77040,NULL,NULL,NULL,'KUG 2354+269',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165687,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165687,35.36,0.43,118,77040,75,NULL,'3.6 micron, color corrected','KUG 2354+269',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165688,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165688,35.48,0.43,125,77040,75,NULL,'3.6 micron, color + selection bias corrected','KUG 2354+269',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165689,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 15606','RN',165689,42.33,0.28,2080,77041,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 15606',0.403253,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165690,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 15606','RN',165690,42.79,0.27,2580,77041,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 15606',0.403253,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165691,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382',NULL,165691,40.99,0.19,1580,77042,70,NULL,'SN photometric redshift distance, z photo =0.471 +/- 0.060','SDSS-II SN 14382',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','22.0g',0.03,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.148625,0.20411,0.097,NULL,51540337048,805317766,12583090,22),(165692,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382','R',165692,42.01,0.37,1780,77042,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 14382',0.417805,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165693,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382','R',165693,42.1,0.33,1850,77042,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 14382',0.417805,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165694,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382',NULL,165694,41.79,0.24,2280,77042,70,NULL,'SALT 2','SDSS-II SN 14382',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165695,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 14382',NULL,165695,41.87,0.24,2370,77042,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 14382',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165696,'CMD','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'N',165696,17.01,0.16,0.025,77043,NULL,NULL,'If object = GC, ID = DES J0531_2801','Columba I',NULL,'2015ApJ...813..109D',2015,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165697,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165697,35.08,0.8,104,77044,75,NULL,'W91CL, r','UGC 12855',NULL,'1997ApJS..109..333W',1997,1,1.3,NULL,'G',0.000002,NULL,'14.53',0.7,'S0/a',NULL,NULL,NULL,NULL,1,359.155291667,27.10483,0.137,NULL,51947275278,811676176,12682440,14.53),(165698,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165698,35.09,0.8,104,77044,75,NULL,'HMCL, I','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165699,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165699,35.09,0.8,104,77044,75,NULL,'W91PP, r','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165700,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165700,34.51,0.69,79.7,77044,100,NULL,'mid-IR','UGC 12855',NULL,'2013ApJ...771...88L',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165701,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165701,35.1,0.4,105,77044,NULL,NULL,'Malmquist cor.','UGC 12855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165702,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165702,35.2,0.38,110,77044,NULL,NULL,NULL,'UGC 12855',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165703,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165703,35.24,0.38,112,77044,75,NULL,'W91PP, r, raw','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165704,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165704,35.36,0.38,118,77044,75,NULL,'W91CL, r, raw','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165705,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165705,35.42,0.38,121,77044,75,NULL,'W91PP, r, cor','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165706,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165706,35.42,0.4,122,77044,75,NULL,'HMCL, I, raw','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165707,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165707,35.51,0.38,127,77044,75,NULL,'W91PP, r, inv','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165708,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165708,35.56,0.2,129,77044,74.4,NULL,NULL,'UGC 12855',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165709,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165709,35.58,0.38,131,77044,75,NULL,'W91CL, r, cor','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165710,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165710,35.58,0.38,131,77044,75,NULL,'W91CL, r, inv','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165711,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165711,35.63,0.4,133,77044,75,NULL,'HMCL, I, cor','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165712,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165712,35.69,0.4,137,77044,75,NULL,'HMCL, I, inv','UGC 12855',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165713,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165713,38.55,0.46,513,77045,70,NULL,NULL,'2MASX J23563813+0111564',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.000095,NULL,'18.1g',0.17,NULL,NULL,NULL,NULL,NULL,1,359.158875,1.19908,0.065,NULL,51543665751,805369777,12583902,18.1),(165714,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165714,35.23,0.58,111,77046,NULL,NULL,'Malmquist cor.','UGC 12854',NULL,'2009ApJS..182..474S',2009,1,0.83,NULL,'G',0.00008,NULL,'14.8g',0.44,'S?',NULL,NULL,NULL,NULL,1,359.1752083,13.77636,0.121,NULL,51655915252,807123675,12611307,14.8),(165715,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165715,35.46,0.53,124,77046,NULL,NULL,NULL,'UGC 12854',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165716,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165716,35.55,0.2,129,77046,74.4,NULL,NULL,'UGC 12854',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165717,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21597','RN',165717,44.15,0.34,4760,77047,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 21597',0.420774,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165718,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21597','RN',165718,44.51,0.45,5620,77047,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 21597',0.420774,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165719,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165719,35.3,0.46,115,77048,70,NULL,NULL,'2MASX J23564519-0858110',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000079,NULL,'16.5g',0.28,NULL,NULL,NULL,NULL,NULL,1,359.18825,-8.96958,0.118,NULL,49427108923,772298576,12067165,16.5),(165720,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165720,31.95,0.4,24.5,77049,75,NULL,'B','UGC 12856',NULL,'1988NBGC.C....0000T',1988,1,1.6,'Position in 1992PNAOJ...2..573T refers to VV 255b, a bright knot in VV 255a.','G',0.000003,NULL,'14.5',1,'IB(s)m         HII','X-ray-faint group member',NULL,NULL,NULL,1,359.1885417,16.81394,0.045,NULL,51662174942,807221483,12612835,14.5),(165721,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165721,37.02,0.46,254,77050,70,NULL,NULL,'2MASX J23564598+1404561',NULL,'2015arXiv151105856S',2015,1,0.41,NULL,'G',0.000186,NULL,'16.6g',0.27,NULL,NULL,NULL,NULL,NULL,1,359.19175,14.08219,0.053,NULL,51655345824,807114778,12611168,16.6),(165722,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165722,35.86,0.56,149,77051,70,NULL,NULL,'2MASX J23564613-0134599',NULL,'2014MNRAS.445.2677S',2014,1,0.68,NULL,'G',0.00015,NULL,'16.07',0.48,NULL,NULL,NULL,NULL,NULL,1,359.1922917,-1.58336,0.061,NULL,49394919540,771795617,12059306,16.07),(165723,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165723,35.63,0.49,134,77052,70,NULL,NULL,'MCG -01-01-005',NULL,'2014MNRAS.445.2677S',2014,1,1.3,'HOLM 822B is a star.','G',0.000047,NULL,'14.96',0.6,'(R\')SB(r)a',NULL,NULL,NULL,NULL,1,359.192583,-2.64692,0.156,NULL,49406618543,771978414,12062162,14.96),(165724,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165724,32.1,0.43,26.2,77053,75,NULL,'3.6 micron, color + selection bias corrected','UGC 12857',NULL,'2014MNRAS.444..527S',2014,1,1.8,NULL,'G',0.000025,NULL,'14.49',0.4,'Sbc: sp','Isolated galaxy',NULL,NULL,NULL,1,359.198417,1.355,0.065,NULL,51542899757,805357808,12583715,14.49),(165725,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165725,32.23,0.43,27.9,77053,75,NULL,'3.6 micron, color corrected','UGC 12857',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165726,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165726,32.41,0.2,30.3,77053,74.4,NULL,NULL,'UGC 12857',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165727,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165727,32.45,0.4,30.9,77053,73,NULL,'opt','UGC 12857',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165728,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165728,32.5,0.4,31.7,77053,75,NULL,NULL,'UGC 12857',NULL,'2008Ap.....51..336K',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165729,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165729,32.51,0.39,31.7,77053,73,NULL,'IR','UGC 12857',NULL,'2011A&A...532A.104N',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165730,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165730,32.68,0.49,34.3,77053,75,NULL,'IR','UGC 12857',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165731,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165731,32.68,0.51,34.4,77053,NULL,NULL,NULL,'UGC 12857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165732,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165732,32.7,0.51,34.6,77053,NULL,NULL,'Malmquist cor.','UGC 12857',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165733,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165733,32.7,0.4,34.6,77053,NULL,NULL,'mean','UGC 12857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165734,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165734,32.87,0.47,37.5,77053,NULL,NULL,'H','UGC 12857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165735,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165735,32.97,0.46,39.2,77053,NULL,NULL,'J','UGC 12857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165736,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165736,33.01,0.45,40,77053,NULL,NULL,'K','UGC 12857',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165737,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165737,37.61,0.46,333,77054,70,NULL,NULL,'2MASX J23564934+0043373',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000113,NULL,'17.6g',0.17,'NLAGN',NULL,NULL,NULL,'Sy 2',1,359.205417,0.72694,0.105,NULL,51543549322,805367958,12583874,17.6),(165738,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165738,37.23,0.46,279,77055,70,NULL,NULL,'2MASX J23565133-0000299',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000076,NULL,'17.8g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.213917,-0.00822,0.097,NULL,49392531518,771758304,12058723,17.8),(165739,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007fb',NULL,165739,34.75,0.24,87.8,77056,73.8,NULL,'SALT 2 (SNANA)','UGC 12859',0.0169,'2014ApJ...795...44R',2014,1,1.2,NULL,'G',0.000013,NULL,'15.18',0.4,'Sbc',NULL,NULL,NULL,NULL,1,359.2147917,5.50842,0.201,NULL,51599261151,806238455,12597475,15.18),(165740,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165740,34.18,0.8,68.7,77056,75,NULL,'CF, r','UGC 12859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165741,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165741,33.98,0.49,62.4,77056,75,NULL,'IR','UGC 12859',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165742,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165742,34.25,0.38,70.8,77056,75,NULL,'CF, r, raw','UGC 12859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165743,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165743,34.38,0.38,75.1,77056,75,NULL,'CF, r, inv','UGC 12859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165744,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165744,34.46,0.38,77.8,77056,75,NULL,'CF, r, cor','UGC 12859',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165745,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 18419','RN',165745,41.71,0.54,2040,77057,70,NULL,'SDSS CAND. Unknown; MLCS2K2','SDSS-II SN 18419',0.073564,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165746,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 18419','RN',165746,42.17,0.63,2530,77057,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 18419',0.073564,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165747,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165747,37.73,0.46,352,77058,70,NULL,NULL,'2MASX J23565394-0047019',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.000107,NULL,'16.6g',0.33,'AGN',NULL,NULL,NULL,NULL,1,359.22475,-0.78392,0.093,NULL,49396069287,771813582,12059587,16.6),(165748,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165748,37.34,0.46,294,77059,70,NULL,NULL,'2MASX J23565411-0927470',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000067,NULL,'17.2g',0.24,NULL,NULL,NULL,NULL,NULL,1,359.225417,-9.46319,0.095,NULL,49429843543,772341305,12067832,17.2),(165749,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165749,32.81,NULL,36.4,77060,NULL,NULL,'Dipole','ESO 293- G 020',NULL,'2010Ap&SS.325..163P',2010,1,2.35,'6dF DR1 has z = 0.043859.','G',0.000057,NULL,'16.86',0.22,'Sb',NULL,NULL,NULL,NULL,1,359.232583,-38.66322,NULL,NULL,49955064502,780547882,12196060,16.86),(165750,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165750,32.81,NULL,36.5,77060,NULL,NULL,'Dipole + Quadrupole + Octopole','ESO 293- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165751,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165751,32.81,NULL,36.5,77060,NULL,NULL,'Dipole + Quadrupole','ESO 293- G 020',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165752,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165752,33.09,NULL,41.4,77060,NULL,NULL,NULL,'ESO 293- G 020',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165753,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165753,43.26,2.08,1750,77061,100,NULL,NULL,'XRF 040912',1.563,'2009EPJC...63..139W',2009,1,NULL,NULL,'XrayS',NULL,NULL,NULL,NULL,'HETE',NULL,NULL,NULL,NULL,1,359.225,-1,0.033,NULL,49396270888,771816732,12059636,NULL),(165754,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165754,43.27,2.06,1760,77061,100,NULL,NULL,'XRF 040912',1.563,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165755,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13164','RN',165755,40.07,0.14,836,77062,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 13164',0.232375,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165756,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13164','RN',165756,40.67,0.2,1110,77062,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 13164',0.232375,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165757,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165757,35.59,0.46,131,77063,70,NULL,NULL,'2MASX J23565667-0059119',NULL,'2015arXiv151105856S',2015,1,0.48,NULL,'G',0.000068,NULL,'16.1g',0.25,'LINER',NULL,NULL,NULL,NULL,1,359.236083,-0.98675,0.033,NULL,49396091833,771813934,12059592,16.1),(165758,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21150',NULL,165758,39.21,0.78,695,77064,70,NULL,'SN photometric redshift distance, z photo =0.178 +/- 0.089','SDSS-II SN 21150',NULL,'2011ApJ...738..162S',2011,1,0.09,NULL,'G',NULL,'PHOT','19.8g',0.07,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.241333333,1.21833,0.065,NULL,51543662179,805369721,12583901,19.8),(165759,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21150','R',165759,41.32,0.26,1340,77064,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 21150',0.372795,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165760,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 21150','R',165760,41.62,0.37,1540,77064,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 21150',0.372795,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165761,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165761,33.98,0.2,62.5,77065,74.4,NULL,NULL,'UGC 12860',NULL,'2013AJ....146...86T',2013,1,1.7,NULL,'G',0.000043,NULL,'14.91',0.3,'Sb',NULL,NULL,NULL,NULL,1,359.2417083,10.82447,0.161,NULL,51775370706,808990167,12640471,14.91),(165762,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165762,34.05,0.49,64.6,77065,75,NULL,'IR','UGC 12860',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165763,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165763,34.06,0.38,65,77065,NULL,NULL,NULL,'UGC 12860',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165764,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165764,34.15,0.37,67.6,77065,NULL,NULL,'Malmquist cor.','UGC 12860',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165765,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165765,37.56,0.46,325,77066,70,NULL,NULL,'2MASX J23570449-0905039',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000094,NULL,'16.9g',0.27,NULL,NULL,NULL,NULL,NULL,1,359.26875,-9.08453,0.118,NULL,49427056293,772297754,12067152,16.9),(165766,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165766,36.22,0.2,175,77067,74.4,NULL,NULL,'CGCG 498-044',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000033,NULL,'15.20',0.4,'Sdm',NULL,NULL,NULL,NULL,1,359.269541667,33.69156,0.221,NULL,52026262039,812910344,12701724,15.2),(165767,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165767,37.71,0.46,348,77068,70,NULL,NULL,'SDSS J235707.53-011305.4',NULL,'2015arXiv151105856S',2015,1,0.2,NULL,'G',NULL,NULL,'18.0g',0.14,NULL,NULL,NULL,NULL,NULL,1,359.281375,-1.21819,0.033,NULL,49396244588,771816321,12059630,18),(165768,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165768,35.64,0.49,134,77069,70,NULL,NULL,'MCG -03-01-005',NULL,'2014MNRAS.445.2677S',2014,1,0.3,NULL,'G',0.00015,NULL,'15.5',0.2,'(R\')SA(s)a',NULL,NULL,NULL,NULL,1,359.302875,-18.62625,0.02,NULL,49533451005,773960171,12093127,15.5),(165769,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165769,36.92,0.66,242,77070,70,NULL,NULL,'LCRS B235438.5-385821',NULL,'2014MNRAS.445.2677S',2014,1,0.55,NULL,'G',0.00015,NULL,'16.41',0.38,'S0',NULL,NULL,NULL,NULL,1,359.306375,-38.69472,NULL,NULL,49955041916,780547529,12196055,16.41),(165770,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007oz',NULL,165770,40.2,0.25,1100,77071,70,NULL,'Hubble residual 0.02 for z0.29730','SDSS J235716.57+001454.4',NULL,'2011ApJ...740...92G',2011,1,0.07,NULL,'G',0.00018,NULL,'20.7g',0.06,NULL,NULL,NULL,NULL,NULL,1,359.319083,0.24847,0.097,NULL,51540499108,805320298,12583129,20.7),(165771,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19794','R',165771,40.79,0.29,1110,77071,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007oz','SDSS J235716.57+001454.4',0.2973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165772,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19794','R',165772,41.08,0.25,1270,77071,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007oz','SDSS J235716.57+001454.4',0.2973,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165773,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447',NULL,165773,40.86,0.24,1480,77072,70,NULL,'SN photometric redshift distance, z photo =0.435 +/- 0.068','SDSS-II SN 20447',NULL,'2011ApJ...738..162S',2011,1,0.05,NULL,'G',NULL,'PHOT','23.2g',0.04,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.32675,0.57078,0.105,NULL,51540398446,805318725,12583105,23.2),(165774,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447','R',165774,42.02,0.31,1790,77072,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 20447',0.419368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165775,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447','R',165775,42.1,0.32,1850,77072,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 20447',0.419368,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165776,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447',NULL,165776,42.05,0.22,2570,77072,70,NULL,'SALT 2','SDSS-II SN 20447',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165777,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20447',NULL,165777,42.13,0.22,2670,77072,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 20447',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165778,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165778,34.09,0.49,65.7,77073,75,NULL,'IR','UGC 12863',NULL,'2011yCatp016004901K',2011,1,1.1,'Springob et al. (2005ApJS..160..149S) give v= 11242 km/sec.','G',0.00003,NULL,'16.0',0.2,'Sbc',NULL,NULL,NULL,NULL,1,359.329375,8.50897,0.189,NULL,51559337538,805614649,12587728,16),(165779,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165779,36.27,0.2,179,77073,74.4,NULL,NULL,'UGC 12863',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165780,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165780,37.91,0.46,382,77074,70,NULL,NULL,'2MASXi J2357201+150716',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000157,NULL,'17.9g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.3337917,15.12119,0.073,NULL,51648050267,807000785,12609387,17.9),(165781,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 04986','RN',165781,43.13,0.28,3330,77075,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 04986',0.267949,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165782,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 04986','RN',165782,43.23,0.24,3490,77075,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 04986',0.267949,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165783,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165783,37.35,0.46,296,77076,70,NULL,NULL,'2MASX J23572157-1052493',NULL,'2015arXiv151105856S',2015,1,0.42,NULL,'G',0.000086,NULL,'16.6g',0.3,'AGN',NULL,NULL,NULL,NULL,1,359.339833,-10.8805,0.078,NULL,49610324567,775161321,12111895,16.6),(165784,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17274','R',165784,40.34,0.18,980,77077,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007ij','SDSS J235721.96+000621.1',0.196102,'2014arXiv1401.3317S',2014,1,NULL,NULL,'G',NULL,':',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,359.3415,0.10586,0.097,NULL,51540475015,805319922,12583123,NULL),(165785,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17274','R',165785,40.37,0.22,991,77077,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007ij','SDSS J235721.96+000621.1',0.196102,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165786,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165786,33.87,0.8,59.3,77078,75,NULL,'W91PP, r','UGC 12864',NULL,'1997ApJS..109..333W',1997,1,1.7,NULL,'G',0.000023,NULL,'14.33',1,'SBb            AGN?','Isolated galaxy',NULL,NULL,NULL,1,359.349958333,30.99217,0.161,NULL,51972775475,812074616,12688665,14.33),(165787,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165787,33.38,0.2,47.4,77078,74.4,NULL,NULL,'UGC 12864',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165788,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165788,33.51,0.58,50.3,77078,NULL,NULL,NULL,'UGC 12864',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165789,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165789,33.51,0.38,50.3,77078,75,NULL,'W91PP, r, raw','UGC 12864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165790,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165790,33.55,0.38,51.3,77078,75,NULL,'W91PP, r, inv','UGC 12864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165791,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165791,33.86,0.38,59.2,77078,75,NULL,'W91PP, r, cor','UGC 12864',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165792,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165792,33.91,0.48,60.6,77078,NULL,NULL,'Malmquist cor.','UGC 12864',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165793,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165793,34.16,0.49,67.9,77078,75,NULL,'IR','UGC 12864',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165794,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 04265','RN',165794,43.56,0.26,3590,77079,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 04265',0.436407,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165795,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 04265','RN',165795,43.89,0.31,4180,77079,70,NULL,'SDSS CAND. AGN; MLCS2K2','SDSS-II SN 04265',0.436407,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165796,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165796,34.99,0.49,99.5,77080,75,NULL,'IR','KUG 2354+265',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000008,NULL,'16  :',0.2,'Spiral',NULL,NULL,NULL,NULL,1,359.3577917,26.83861,0.121,NULL,51947115003,811673671,12682401,16),(165797,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165797,36.32,0.67,184,77081,70,NULL,NULL,'2MASX J23572745-0107534',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.000091,NULL,'16.0g',0.34,'S0^-',NULL,NULL,NULL,NULL,1,359.364416667,-1.13144,0.037,NULL,49395697745,771807777,12059496,16),(165798,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165798,35.29,0.46,114,77082,70,NULL,NULL,'ESO 471- G 049',NULL,'2014MNRAS.445.2677S',2014,1,1.7,NULL,'G',0.000033,NULL,'13.87',0.9,'SB(r)b',NULL,NULL,NULL,NULL,1,359.369125,-29.04758,0,NULL,50034567551,781790117,12215470,13.87),(165799,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165799,35.39,0.25,119,77082,NULL,NULL,'Malmquist cor.','ESO 471- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165800,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165800,35.44,0.24,122,77082,NULL,NULL,NULL,'ESO 471- G 049',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165801,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165801,35.48,0.2,125,77082,74.4,NULL,NULL,'ESO 471- G 049',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165802,'BL Lac Luminosity','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165802,41.85,NULL,2350,77083,70,NULL,'nucleus-to-host flux ratio, z > 0.85','2MASS J23572998-1718035',NULL,'2006AJ....132....1S',2006,1,NULL,NULL,'QSO',NULL,NULL,'17.4',NULL,'candidate      BLLAC',NULL,NULL,NULL,NULL,1,359.374917,-17.30097,0.022,NULL,49531551341,773930489,12092663,17.4),(165803,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 15569',NULL,165803,41.15,0.22,1700,77084,70,NULL,'SN photometric redshift distance, z photo =0.521 +/- 0.079','SDSS-II SN 15569',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.377625,0.87006,0.101,NULL,51543420959,805365952,12583843,NULL),(165804,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165804,37.44,0.46,308,77085,70,NULL,NULL,'2MASX J23573517-0043374',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000089,NULL,'18.1g',0.14,NULL,NULL,NULL,NULL,NULL,1,359.3967083,-0.72708,0.089,NULL,49392793539,771762399,12058787,18.1),(165805,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165805,35.42,0.64,122,77086,70,NULL,NULL,'2MASX J23573552-0118564',NULL,'2014MNRAS.445.2677S',2014,1,0.56,NULL,'G',0.00015,NULL,'16.34',0.26,NULL,NULL,NULL,NULL,NULL,1,359.3979583,-1.31572,0.033,NULL,49395724394,771808193,12059503,16.34),(165806,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 18302','RN',165806,40.29,0.17,1030,77087,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 18302',0.109857,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165807,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 18302','RN',165807,40.59,0.23,1180,77087,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 18302',0.109857,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165808,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19795',NULL,165808,41.57,0.02,2060,77088,70,NULL,'SN photometric redshift distance, z photo =0.688 +/- 0.012','SDSS-II SN 19795',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.4160417,0.20619,0.097,NULL,51540519521,805320617,12583134,NULL),(165809,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165809,35.51,0.47,126,77089,70,NULL,NULL,'ESO 538- G 010',NULL,'2014MNRAS.445.2677S',2014,1,0.8,NULL,'G',0.00005,NULL,'14.93',0.7,'S0?',NULL,NULL,NULL,NULL,1,359.4167083,-21.57972,0.038,NULL,49527362690,773865042,12091641,14.93),(165810,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165810,36.2,0.49,174,77090,70,NULL,NULL,'2MASX J23574045-4934130',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.67',0.26,NULL,NULL,NULL,NULL,NULL,1,359.4187083,-49.57022,NULL,NULL,48595698749,759307792,11864184,16.67),(165811,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165811,37.33,0.46,293,77091,70,NULL,NULL,'SDSS J235742.99+155147.8',NULL,'2015arXiv151105856S',2015,1,0.16,NULL,'G',0.000164,NULL,'18.2g',0.12,NULL,NULL,NULL,NULL,NULL,1,359.429125,15.86331,0.089,NULL,51645469587,806960462,12608757,18.2),(165812,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02864','R',165812,40.22,0.22,891,77092,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 02864',0.2441,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,359.451,-1.23961,0.037,NULL,49395712914,771808014,12059500,NULL),(165813,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02864','R',165813,40.29,0.16,920,77092,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 02864',0.2441,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165814,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165814,37.4,0.33,302,77093,70,NULL,NULL,'2MASX J23574859+0047444',NULL,'2015arXiv151105856S',2015,1,0.59,NULL,'G',0.000137,NULL,'15.6g',0.48,'E0',NULL,NULL,NULL,NULL,1,359.452416667,0.79558,0.101,NULL,51539946316,805311661,12582994,15.6),(165815,'Brightest Stars','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165815,26,NULL,1.58,77094,NULL,NULL,NULL,'NGC 7793',NULL,'1998ApJ...497..650D',1998,1,9.3,'Extended HIPASS source','G',0.000013,NULL,'9.98',6.3,'SA(s)d         HII','Group member, radial-velocity confirmed',NULL,NULL,NULL,1,359.457625,-32.59103,NULL,0,50030037082,781719329,12214364,9.98),(165816,'Brightest Stars','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165816,27.77,NULL,3.58,77094,NULL,NULL,'Photographic','NGC 7793',NULL,'1980ApJ...239..783D',1980,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165817,'Cepheids','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165817,27.68,0.05,3.44,77094,NULL,NULL,'17, VI','NGC 7793',NULL,'2010AJ....140.1475P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165818,'Cepheids','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165818,27.77,0.07,3.58,77094,74.4,NULL,NULL,'NGC 7793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165819,'CMD','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165819,27.83,NULL,3.68,77094,NULL,NULL,NULL,'NGC 7793',NULL,'2012ApJ...753..138R',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165820,'CMD','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165820,27.91,NULL,3.82,77094,NULL,NULL,NULL,'NGC 7793',NULL,'2012ApJ...748...47M',2012,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165821,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165821,27.77,0.07,3.58,77094,74.4,NULL,NULL,'NGC 7793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165822,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165822,27.79,0.08,3.61,77094,NULL,NULL,'I','NGC 7793',NULL,'2009AJ....138..332J',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165823,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165823,27.79,0.32,3.61,77094,NULL,NULL,'I','NGC 7793',NULL,'2011ApJ...732....7V',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165824,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165824,27.87,0.08,3.7,77094,NULL,NULL,'I','NGC 7793',NULL,'2011ApJS..195...18R',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165825,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165825,27.96,0.24,3.91,77094,NULL,NULL,NULL,'NGC 7793',NULL,'2003A&A...404...93K',2003,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165826,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165826,27.63,0.16,3.36,77094,NULL,NULL,'SCM, Poznanski et al. 2009','NGC 7793',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165827,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165827,27.7,0.16,3.47,77094,NULL,NULL,'SCM, Hamuy 2003','NGC 7793',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165828,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165828,27.73,0.16,3.52,77094,NULL,NULL,'SCM, Nugent et al. 2006','NGC 7793',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165829,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165829,27.9,0.16,3.8,77094,NULL,NULL,'SCM, D\'Andrea et al. 2010','NGC 7793',NULL,'2015A&A...580L..15P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165830,'SNII optical','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2008bk',NULL,165830,28.39,0.5,4.76,77094,NULL,NULL,'SCM','NGC 7793',NULL,'2015ApJ...799..215P',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165831,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165831,28.1,0.8,4.16,77094,75,NULL,'MAT, I','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165832,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165832,28.11,0.8,4.19,77094,75,NULL,'A82, H','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165833,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165833,27.21,0.4,2.8,77094,75,NULL,'B','NGC 7793',NULL,'1988NBGC.C....0000T',1988,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165834,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165834,27.72,0.32,3.47,77094,85,NULL,'I, inv','NGC 7793',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165835,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165835,27.72,0.32,3.48,77094,85,NULL,'I, raw','NGC 7793',NULL,'1992ApJS...81..413M',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165836,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165836,27.77,0.07,3.58,77094,74.4,NULL,NULL,'NGC 7793',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165837,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165837,27.84,0.4,3.7,77094,NULL,NULL,'Virgo cluster at 15.6 Mpc','NGC 7793',NULL,'1992ApJS...80..479T',1992,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165838,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165838,27.82,0.43,3.7,77094,75,NULL,'3.6 micron, color + selection bias corrected','NGC 7793',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165839,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165839,27.96,0.43,3.9,77094,75,NULL,'3.6 micron, color corrected','NGC 7793',NULL,'2014MNRAS.444..527S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165840,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165840,28.01,NULL,4,77094,NULL,NULL,'LEDA [April 2006]','NGC 7793',NULL,'2006sf2a.conf..365V',2006,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165841,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165841,28.06,0.35,4.09,77094,NULL,NULL,NULL,'NGC 7793',NULL,'2009AJ....138..323T',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165842,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165842,28.07,0.43,4.11,77094,75,NULL,'MAT, I, raw','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165843,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165843,28.08,0.43,4.13,77094,75,NULL,'MAT, I, inv','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165844,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165844,28.34,0.43,4.65,77094,75,NULL,'MAT, I, cor','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165845,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165845,28.51,0.47,5.04,77094,75,NULL,'A82, H, inv','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165846,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165846,28.56,0.47,5.15,77094,75,NULL,'A82, H, raw','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165847,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165847,28.89,0.47,6,77094,75,NULL,'A82, H, cor','NGC 7793',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165848,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19091',NULL,165848,41.29,0.29,1810,77095,70,NULL,'SN photometric redshift distance, z photo =0.571 +/- 0.125','SDSS-II SN 19091',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.4662917,-0.30361,0.085,NULL,49393094202,771767096,12058860,NULL),(165849,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19091',NULL,165849,41.62,0.24,2110,77095,70,NULL,'SALT 2','SDSS-II SN 19091',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165850,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 19091',NULL,165850,41.68,0.24,2170,77095,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 19091',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165851,'IRAS','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165851,35.14,0.8,107,77096,75,NULL,'W91PP, r','UGC 12866',NULL,'1997ApJS..109..333W',1997,1,0.9,NULL,'G',0.000033,NULL,'16.0',0.3,'Scd:',NULL,NULL,NULL,NULL,1,359.4712083,22.35597,0.125,NULL,52479384142,819990377,12812349,16),(165852,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165852,35.33,0.51,116,77096,NULL,NULL,'Malmquist cor.','UGC 12866',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165853,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165853,35.45,0.48,123,77096,NULL,NULL,NULL,'UGC 12866',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165854,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165854,35.47,0.49,124,77096,75,NULL,'IR','UGC 12866',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165855,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165855,35.49,0.2,125,77096,74.4,NULL,NULL,'UGC 12866',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165856,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165856,35.59,0.38,131,77096,75,NULL,'W91PP, r, raw','UGC 12866',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165857,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165857,35.67,0.38,136,77096,75,NULL,'W91PP, r, inv','UGC 12866',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165858,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165858,35.83,0.38,147,77096,75,NULL,'W91PP, r, cor','UGC 12866',NULL,'1997ApJS..109..333W',1997,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165859,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02649','RN',165859,40.71,0.27,1310,77097,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02649',0.06121,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165860,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02649','RN',165860,40.79,0.18,1360,77097,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02649',0.06121,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165861,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165861,37.4,0.33,302,77098,70,NULL,NULL,'2MASX J23575986+0046084',NULL,'2015arXiv151105856S',2015,1,0.54,NULL,'G',0.000132,NULL,'16.1g',0.41,NULL,NULL,NULL,NULL,NULL,1,359.499375,0.76906,0.101,NULL,51539996552,805312446,12583006,16.1),(165862,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165862,38.16,0.46,428,77099,70,NULL,NULL,'SDSS J235809.84+152854.4',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.00017,NULL,'18.5g',0.13,NULL,NULL,NULL,NULL,NULL,1,359.541,15.48178,0.069,NULL,51647972392,806999568,12609368,18.5),(165863,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165863,38.13,0.46,423,77100,70,NULL,NULL,'2MASX J23580982+1503205',NULL,'2015arXiv151105856S',2015,1,0.22,NULL,'G',0.000165,NULL,'17.9g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.541083333,15.05578,0.077,NULL,51648022578,807000352,12609380,17.9),(165864,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 12825','RN',165864,39.22,0.21,607,77101,70,NULL,'SDSS CAND. Unknown; SALT 2','SDSS-II SN 12825',0.150122,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165865,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165865,35.3,0.2,115,77102,74.4,NULL,NULL,'KUG 2355+281',NULL,'2013AJ....146...86T',2013,1,0.4,NULL,'G',0.000033,NULL,'15.77',0.3,'S?',NULL,NULL,NULL,NULL,1,359.552583333,28.46422,0.205,NULL,51967593310,811993645,12687400,15.77),(165866,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165866,35.5,0.38,126,77103,NULL,NULL,'Malmquist cor.','ESO 471- G 051',NULL,'2009ApJS..182..474S',2009,1,1.1,NULL,'G',0.000033,NULL,'14.92',0.7,'SB?',NULL,NULL,NULL,NULL,1,359.571916667,-30.11144,NULL,NULL,50036887802,781826371,12216037,14.92),(165867,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165867,35.53,0.37,128,77103,NULL,NULL,NULL,'ESO 471- G 051',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165868,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165868,35.57,0.2,130,77103,74.4,NULL,NULL,'ESO 471- G 051',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165869,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165869,35.59,0.53,131,77104,70,NULL,NULL,'2MASX J23581801-5357144',NULL,'2014MNRAS.445.2677S',2014,1,0.43,NULL,'G',0.000077,NULL,'16.90',0.27,'S0',NULL,NULL,NULL,NULL,1,359.574958333,-53.95403,0,NULL,48621624795,759712887,11870513,16.9),(165870,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01150','RN',165870,43.47,0.33,3390,77105,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 01150',0.458071,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165871,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165871,38,0.46,399,77106,70,NULL,NULL,'2MASX J23582405-0025186',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.00008,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.600125,-0.42183,0.085,NULL,49393122931,771767545,12058867,18.1),(165872,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165872,37.41,0.46,303,77107,70,NULL,NULL,'2MASX J23582521+1437166',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000155,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,359.604917,14.62139,0.081,NULL,51647570612,806993290,12609270,17.8),(165873,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165873,34.65,0.54,85.2,77108,NULL,NULL,'Malmquist cor.','UGC 12871',NULL,'2009ApJS..182..474S',2009,1,1.4,NULL,'G',0.000117,NULL,'14.74',1,'Scd:',NULL,NULL,NULL,NULL,1,359.627208333,9.97272,0.173,NULL,51557064178,805579127,12587173,14.74),(165874,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165874,35.1,0.44,105,77108,NULL,NULL,NULL,'UGC 12871',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165875,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165875,35.14,0.2,107,77108,74.4,NULL,NULL,'UGC 12871',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165876,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165876,35.26,0.16,109,77109,74.2,NULL,'SALT 2','ESO 538- G 013',0.034043,'2010ApJ...716..712A',2010,1,1.4,NULL,'G',0.000123,NULL,'15.20',0.7,'Sa',NULL,NULL,NULL,NULL,1,359.632625,-18.71403,0.022,NULL,49533568674,773962010,12093156,15.2),(165877,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165877,35.74,0.15,136,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2008ApJ...689..377W',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165878,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165878,35.86,0.16,139,77109,72,NULL,NULL,'ESO 538- G 013',0.03295,'2013ApJ...773...53F',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165879,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165879,35.8,0.04,140,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2010AJ....139..120F',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165880,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165880,35.86,0.17,144,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2009ApJ...704..629M',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165881,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165881,35.87,0.02,145,77109,70,NULL,'SALT 2','ESO 538- G 013',0.034043,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165882,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165882,35.81,0.01,145,77109,72,NULL,NULL,'ESO 538- G 013',NULL,'2011AJ....141...19B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165883,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165883,35.81,0.09,145,77109,74.4,NULL,NULL,'ESO 538- G 013',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165884,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165884,35.89,0.14,146,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2009ApJ...704.1036F',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165885,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165885,35.96,0.02,150,77109,72,NULL,NULL,'ESO 538- G 013',0.034043,'2011ApJ...731..120M',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165886,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165886,35.92,0.05,153,77109,72,NULL,'M(H) = -18.317 mag','ESO 538- G 013',NULL,'2014ApJ...784..105W',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165887,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165887,36.01,0.15,154,77109,70,NULL,'SALT 2','ESO 538- G 013',0.034043,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165888,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165888,36.03,0.21,155,77109,73.8,NULL,'SALT 2 (SNANA)','ESO 538- G 013',0.0341,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165889,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165889,36.06,0.19,157,77109,73.8,NULL,'SALT 2 (SNANA)','ESO 538- G 013',0.0341,'2014ApJ...795...44R',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165890,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq','R',165890,36.05,0.05,162,77109,NULL,NULL,'MLCS2k2, R(V) = 1.8','ESO 538- G 013',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165891,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165891,36.13,0.15,163,77109,65,NULL,'MLCS17','ESO 538- G 013',0.034043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165892,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165892,36.17,0.17,165,77109,65,NULL,'SALT','ESO 538- G 013',0.034043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165893,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq','R',165893,36.1,0.05,166,77109,NULL,NULL,'MLCS2k2, R(V) = 3.1','ESO 538- G 013',NULL,'2015Sci...347.1459K',2015,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165894,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165894,36.17,0.19,166,77109,65,NULL,'SALT2','ESO 538- G 013',0.034043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165895,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005iq',NULL,165895,36.2,0.15,168,77109,65,NULL,'MLCS31','ESO 538- G 013',0.034043,'2009ApJ...700.1097H',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165896,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165896,36.72,0.33,221,77110,70,NULL,NULL,'2MASX J23583306-0108416',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000082,NULL,'17.0g',0.26,'AGN',NULL,NULL,NULL,NULL,1,359.637625,-1.14489,0.041,NULL,49395770593,771808915,12059514,17),(165897,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165897,36.72,0.33,221,77111,70,NULL,NULL,'2MASX J23583426-0107446',NULL,'2015arXiv151105856S',2015,1,0.34,NULL,'G',0.000092,NULL,'16.9g',0.25,'AGN',NULL,NULL,NULL,NULL,1,359.642875,-1.129,0.041,NULL,49395763434,771808803,12059512,16.9),(165898,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165898,37.75,0.33,354,77112,70,NULL,NULL,'2MASX J23583443-1000394',NULL,'2015arXiv151105856S',2015,1,0.3,NULL,'G',0.000086,NULL,'17.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.6435417,-10.01094,0.081,NULL,49426174108,772283970,12066937,17.3),(165899,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165899,37.57,0.46,327,77113,70,NULL,NULL,'2MASX J23583478+1545546',NULL,'2015arXiv151105856S',2015,1,0.24,NULL,'G',0.000157,NULL,'17.6g',0.21,NULL,NULL,NULL,NULL,NULL,1,359.644875,15.76519,0.069,NULL,51645187146,806956049,12608688,17.6),(165900,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165900,37.79,0.46,361,77114,70,NULL,NULL,'2MASX J23583632-1018454',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000081,NULL,'17.3g',0.25,NULL,NULL,NULL,NULL,NULL,1,359.651417,-10.3125,0.09,NULL,49426619305,772290926,12067045,17.3),(165901,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165901,37.94,0.46,388,77115,70,NULL,NULL,'2MASX J23583661+0053330',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000078,NULL,'17.9g',0.15,NULL,NULL,NULL,NULL,NULL,1,359.6525,0.89244,0.093,NULL,51540103388,805314115,12583033,17.9),(165902,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165902,37.83,0.46,367,77116,70,NULL,NULL,'2MASX J23584103+1351226',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000164,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,359.670875,13.85622,0.097,NULL,51654994980,807109296,12611082,17.3),(165903,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165903,37.75,0.33,354,77117,70,NULL,NULL,'SDSS J235842.07-095435.9',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000097,NULL,'17.6g',0.18,'AGN',NULL,NULL,NULL,NULL,1,359.675333333,-9.91003,0.081,NULL,49426173867,772283966,12066936,17.6),(165904,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403','R',165904,40.52,0.28,934,77118,70,NULL,'SDSS CAND. zSNIa; MLCS2K2','SDSS-II SN 01403',0.361378,'2014arXiv1401.3317S',2014,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.703875,0.43189,0.113,NULL,51540559273,805321238,12583144,NULL),(165905,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403','R',165905,40.52,0.33,935,77118,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 01403',0.361378,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165906,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403',NULL,165906,40.27,0.23,1130,77118,70,NULL,'SALT 2','SDSS-II SN 01403',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165907,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403',NULL,165907,40.32,0.23,1160,77118,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 01403',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165908,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01403',NULL,165908,40.92,0.67,1530,77118,70,NULL,'SN photometric redshift distance, z photo =0.452 +/- 0.248','SDSS-II SN 01403',NULL,'2011ApJ...738..162S',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165909,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165909,36.4,0.69,191,77119,70,NULL,NULL,'2MFGC 18007',NULL,'2014MNRAS.445.2677S',2014,1,0.69,NULL,'G',0.00015,NULL,'16.66',0.15,NULL,NULL,NULL,NULL,NULL,1,359.724666667,-12.02142,0.046,NULL,49543726489,774120726,12095636,16.66),(165910,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165910,37.53,0.46,321,77120,70,NULL,NULL,'2MASX J23585521+0030175',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000089,NULL,'17.3g',0.22,NULL,NULL,NULL,NULL,NULL,1,359.7300417,0.50478,0.113,NULL,51540570968,805321421,12583147,17.3),(165911,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165911,37.81,0.33,365,77121,70,NULL,NULL,'2MASX J23585541+0017335',NULL,'2015arXiv151105856S',2015,1,0.18,NULL,'G',0.000075,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.73075,0.29253,0.113,NULL,51539816953,805309639,12582963,18.1),(165912,'Horizontal Branch','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165912,24.59,0.11,0.829,77122,NULL,NULL,NULL,'Andromeda XXIX',NULL,'2015ApJ...806..230S',2015,1,NULL,NULL,'G',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,359.731667,30.75556,0.137,1,51968503348,812007864,12687622,NULL),(165913,'TRGB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165913,24.32,0.22,0.73,77122,NULL,NULL,NULL,'Andromeda XXIX',NULL,'2011ApJ...742L..15B',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165914,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2003he',NULL,165914,35.17,0.16,106,77123,70,NULL,'SALT 2','MCG -01-01-010',0.025504,'2013MNRAS.433.2240G',2013,1,1.5,'Maurogordato et al. (1991A&A...246...39M) give v = 11109 +/- 68 km/sec.','G',0.000033,NULL,'15.21',0.6,'SB(s)bc:',NULL,NULL,NULL,NULL,1,359.738458333,-2.24958,0.115,NULL,49394428442,771787944,12059186,15.21),(165915,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165915,35.13,0.2,106,77123,74.4,NULL,NULL,'MCG -01-01-010',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165916,'SBF','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165916,33.55,0.14,51.3,77124,74.4,NULL,NULL,'NGC 7796',NULL,'2013AJ....146...86T',2013,1,2.2,'The APM position is northwest of the nucleus.','G',0.000057,NULL,'12.46',1.9,'E+',NULL,NULL,NULL,NULL,1,359.749041667,-55.45831,0,NULL,48620820120,759700314,11870317,12.46),(165917,'GCLF','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165917,33.7,NULL,55,77125,NULL,NULL,'R','NGC 7796',NULL,'2015A&A...574A..21R',2015,1,2.2,'The APM position is northwest of the nucleus.','G',0.000057,NULL,'12.46',1.9,'E+',NULL,NULL,NULL,NULL,1,359.749041667,-55.45831,0,NULL,48620820120,759700314,11870317,12.46),(165918,'SBF','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165918,33.49,0.4,49.9,77125,NULL,NULL,'I','NGC 7796',NULL,'2001ApJ...546..681T',2001,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165919,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165919,32.52,0.65,31.9,77125,95,NULL,'Weighted Mean','NGC 7796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165920,'Faber-Jackson','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165920,34.1,0.81,66.1,77125,55,NULL,'Visvanathan & Sandage 1979','NGC 7796',NULL,'1984ApJS...56...91D',1984,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165921,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165921,33.4,0.49,47.9,77125,70,NULL,NULL,'NGC 7796',NULL,'2014MNRAS.445.2677S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165922,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165922,33.39,0.4,47.6,77125,NULL,NULL,'mean','NGC 7796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165923,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165923,33.53,0.45,50.8,77125,NULL,NULL,'K','NGC 7796',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165924,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165924,34.8,0.47,91.2,77126,70,NULL,NULL,'2MASX J23585991-6200483',NULL,'2014MNRAS.445.2677S',2014,1,0.73,NULL,'G',0.00015,NULL,'15.36',0.6,'S0',NULL,NULL,NULL,NULL,1,359.7497083,-62.01342,0,NULL,48725235463,761331804,11895809,15.36),(165925,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165925,37.26,0.46,283,77127,70,NULL,NULL,'2MASX J23590054+1400086',NULL,'2015arXiv151105856S',2015,1,0.35,NULL,'G',0.000158,NULL,'16.9g',0.3,NULL,NULL,NULL,NULL,NULL,1,359.7522917,14.00228,0.105,NULL,51655010155,807109533,12611086,16.9),(165926,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165926,34.89,0.49,95,77128,75,NULL,'IR','IC 1522',NULL,'2011yCatp016004901K',2011,1,0.6,NULL,'G',0.0001,NULL,'15.3',0.2,NULL,NULL,NULL,NULL,NULL,1,359.764375,1.71989,0.061,NULL,51541388708,805334198,12583346,15.3),(165927,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165927,35.33,0.59,116,77129,70,NULL,NULL,'2MASX J23590350-0524185',NULL,'2014MNRAS.445.2677S',2014,1,0.9,NULL,'G',0.00015,NULL,'15.86',0.4,NULL,NULL,NULL,NULL,NULL,1,359.7645,-5.40517,0.107,NULL,49446676125,772604314,12071942,15.86),(165928,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165928,38.27,0.46,452,77130,70,NULL,NULL,'2MASX J23590374+1407098',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000172,NULL,'18.1g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.7655,14.11933,0.081,NULL,51646610748,806978292,12609035,18.1),(165929,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165929,44.31,0.45,2700,77131,73,NULL,'H const./H=100','1SAX J2359.1+0835',0.97,'2006astro.ph..9262M',2006,1,NULL,NULL,'G',NULL,NULL,'22.5R',NULL,'RXTE/ASM',NULL,NULL,NULL,NULL,1,359.770833,8.56,0.205,NULL,51558524656,805601947,12587530,22.5),(165930,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165930,43.84,0.32,2980,77131,69.7,NULL,'Calibrated','1SAX J2359.1+0835',0.97,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165931,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165931,44.02,0.41,3230,77131,72,NULL,NULL,'1SAX J2359.1+0835',0.97,'2008JCAP...07..004M',2008,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165932,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165932,44.07,0.4,3310,77131,70,NULL,NULL,'1SAX J2359.1+0835',0.97,'2007ApJ...660...16S',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165933,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165933,44.16,0.42,3450,77131,69.7,NULL,'Fiducial','1SAX J2359.1+0835',0.97,'2009MNRAS.400..775C',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165934,'GRB','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165934,44.17,0.84,3460,77131,73,NULL,'H const./H=100','1SAX J2359.1+0835',0.97,'2010JCAP...08..020W',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165935,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165935,37.73,0.46,351,77132,70,NULL,NULL,'2MASX J23590721+1454068',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000144,NULL,'18.1g',0.15,NULL,NULL,NULL,NULL,NULL,1,359.7802083,14.90194,0.049,NULL,51647000212,806984378,12609130,18.1),(165936,'BL Lac Luminosity','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165936,39.46,NULL,669,77133,NULL,NULL,NULL,'2dFGRS S357Z081',0.165388,'2005ApJ...635..173S',2005,1,NULL,NULL,'QSO',0.000183,NULL,'18.65',NULL,'BLLAC',NULL,NULL,NULL,NULL,1,359.7829583,-30.62794,NULL,NULL,50035998737,781812480,12215820,18.65),(165937,'GeV TeV ratio','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165937,38.94,0.71,613,77133,72,NULL,NULL,'2dFGRS S357Z081',NULL,'2011arXiv1111.0913P',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165938,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2007qn',NULL,165938,40.13,0.2,1060,77134,70,NULL,'Hubble residual -0.21 for z0.32400','SDSS J235909.25+010930.6',NULL,'2011ApJ...740...92G',2011,1,0.06,NULL,'G',0.0005,NULL,'22.5g',0.05,NULL,NULL,NULL,NULL,NULL,1,359.7885417,1.1585,0.085,NULL,51539897589,805310899,12582982,22.5),(165939,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20184','R',165939,41.01,0.23,1200,77134,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2007qn','SDSS J235909.25+010930.6',0.324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165940,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 20184','R',165940,41.09,0.32,1250,77134,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2007qn','SDSS J235909.25+010930.6',0.324,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165941,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 03674',NULL,165941,35.84,3.91,147,77135,70,NULL,'SN photometric redshift distance, z photo =0.035 +/- 0.200','SDSS-II SN 03674',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'VisS',NULL,'PHOT',NULL,NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.791625,0.16297,0.113,NULL,51539825617,805309775,12582965,NULL),(165942,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 03674',NULL,165942,40.15,0.13,1070,77135,70,NULL,'SALT 2','SDSS-II SN 03674',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165943,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 03674',NULL,165943,40.16,0.13,1080,77135,70,NULL,'SALT 2, Malmquist cor.','SDSS-II SN 03674',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165944,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165944,34.42,0.38,76.6,77136,NULL,NULL,NULL,'IC 1490',NULL,'2009ApJS..182..474S',2009,1,1.3,NULL,'G',0.000023,NULL,'13.94',0.8,'SA(rs)b pec:   Sy1',NULL,NULL,NULL,'Sy 1.0',1,359.794667,-4.127,0.122,NULL,49404244603,771941321,12061583,13.94),(165945,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165945,34.48,0.37,78.7,77136,NULL,NULL,'Malmquist cor.','IC 1490',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165946,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165946,34.46,0.2,78,77137,74.4,NULL,NULL,'MCG -01-01-012',NULL,'2013AJ....146...86T',2013,1,1.3,NULL,'G',0.000103,NULL,'15.03',0.3,'SA?ab: sp',NULL,NULL,NULL,NULL,1,359.795,-4.19183,0.122,NULL,49404219800,771940934,12061577,15.03),(165947,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165947,34.66,0.49,85.7,77137,75,NULL,'IR','MCG -01-01-012',NULL,'2011yCatp016004901K',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165948,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165948,37.81,0.33,365,77138,70,NULL,NULL,'2MASX J23591094+0023535',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000077,NULL,'17.8g',0.2,NULL,NULL,NULL,NULL,NULL,1,359.7954583,0.39828,0.113,NULL,51539694954,805307733,12582933,17.8),(165949,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02819','RN',165949,42.78,0.44,3280,77139,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02819',0.098538,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165950,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02819','RN',165950,42.78,0.54,3280,77139,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 02819',0.098538,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165951,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165951,37.77,0.46,358,77140,70,NULL,NULL,'2MASX J23591168+1344318',NULL,'2015arXiv151105856S',2015,1,0.36,NULL,'G',0.00017,NULL,'17.1g',0.23,NULL,NULL,NULL,NULL,NULL,1,359.79875,13.74228,0.097,NULL,51641340283,806895941,12607749,17.1),(165952,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13903','RN',165952,41.94,0.45,1930,77141,70,NULL,'SDSS CAND. SNIa?; SALT 2','SDSS-II SN 13903',0.2635,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165953,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13085','RN',165953,44.24,0.29,4580,77142,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 13085',0.54024,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165954,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165954,37.26,0.46,283,77143,70,NULL,NULL,'2MASX J23591346+1348458',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000171,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,359.8060417,13.81267,0.105,NULL,51641346299,806896035,12607750,17.5),(165955,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165955,34.58,0.49,82.3,77144,75,NULL,'IR','KUG 2356+256',NULL,'2011yCatp016004901K',2011,1,0.7,NULL,'G',0.000017,NULL,'15.5',0.2,'Spiral',NULL,NULL,NULL,NULL,1,359.8075417,25.9425,0.129,NULL,51949480906,811710639,12682978,15.5),(165956,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165956,34.47,0.2,78.3,77145,74.4,NULL,NULL,'KUG 2356+256',NULL,'2013AJ....146...86T',2013,1,0.7,NULL,'G',0.000017,NULL,'15.5',0.2,'Spiral',NULL,NULL,NULL,NULL,1,359.8075417,25.9425,0.129,NULL,51949480906,811710639,12682978,15.5),(165957,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 17752','RN',165957,42.6,0.2,2180,77146,70,NULL,'SDSS CAND. AGN; SALT 2','SDSS-II SN 17752',0.521731,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165958,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13449','R',165958,39.44,0.05,718,77147,70,NULL,'SDSS CAND. SNII; MLCS2K2; SN 2006ix','SN 2006ix',0.075636,'2014arXiv1401.3317S',2014,1,NULL,NULL,'SN',NULL,NULL,NULL,NULL,'II',NULL,NULL,NULL,NULL,1,359.8084583,-0.31103,0.081,NULL,49392378236,771755909,12058686,NULL),(165959,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13449','R',165959,40.03,0.18,945,77147,70,NULL,'SDSS CAND. SNII; SALT 2; SN 2006ix','SN 2006ix',0.075636,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165960,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165960,37.56,0.46,325,77148,70,NULL,NULL,'2MASX J23591499-0030274',NULL,'2015arXiv151105856S',2015,1,0.23,NULL,'G',0.000083,NULL,'17.6g',0.2,NULL,NULL,NULL,NULL,NULL,1,359.8122917,-0.5075,0.081,NULL,49392292013,771754562,12058665,17.6),(165961,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165961,33.19,0.47,43.5,77149,NULL,NULL,'H','IC 1525',NULL,'2007A&A...465...71T',2007,1,1.9,NULL,'G',0.000017,NULL,'13.0',1.4,'SBb','in a pair',NULL,NULL,NULL,1,359.815625,46.88967,0.481,NULL,53151903160,830498486,12976538,13),(165962,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165962,33.23,0.45,44.4,77149,NULL,NULL,'K','IC 1525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165963,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165963,33.28,0.46,45.2,77149,NULL,NULL,'J','IC 1525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165964,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165964,34.16,0.4,68.1,77149,NULL,NULL,'mean','IC 1525',NULL,'2007A&A...465...71T',2007,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165965,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13099','R',165965,40.68,0.23,1080,77150,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2006gb','APMUKS(BJ) B235642.70-013144.8',0.27,'2014arXiv1401.3317S',2014,1,0.13,NULL,'G',NULL,NULL,'19.74',0.12,NULL,NULL,NULL,NULL,NULL,1,359.818666667,-1.25072,0.073,NULL,49395589962,771806093,12059470,19.74),(165966,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 13099','R',165966,40.92,0.15,1200,77150,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2006gb','APMUKS(BJ) B235642.70-013144.8',0.27,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165967,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2006gb',NULL,165967,40.53,0.21,1280,77150,70,NULL,'SALT 2','APMUKS(BJ) B235642.70-013144.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165968,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2006gb',NULL,165968,40.55,0.21,1290,77150,70,NULL,'SALT 2, Malmquist cor.','APMUKS(BJ) B235642.70-013144.8',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165969,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165969,37.45,0.33,309,77151,70,NULL,NULL,'2MASX J23591709+1441519',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.00016,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,359.8212917,14.69772,0.077,NULL,51647485171,806991955,12609249,17.4),(165970,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165970,35.9,0.5,151,77152,70,NULL,NULL,'ESO 471-IG 054',NULL,'2014MNRAS.445.2677S',2014,1,1.2,NULL,'G',0.00015,NULL,'14.75',0.8,'SB...',NULL,NULL,NULL,NULL,1,359.8305,-31.72992,NULL,NULL,50031357827,781739966,12214686,14.75),(165971,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165971,33.83,0.2,58.3,77153,74.4,NULL,NULL,'UGC 12881',NULL,'2013AJ....146...86T',2013,1,1.5,NULL,'G',0.000003,NULL,'15.24',0.3,'Sdm:',NULL,NULL,NULL,NULL,1,359.831375,4.76061,0.121,NULL,51544662270,805385347,12584146,15.24),(165972,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165972,33.96,0.42,62,77153,NULL,NULL,NULL,'UGC 12881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165973,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165973,34.05,0.41,64.5,77153,NULL,NULL,'Malmquist cor.','UGC 12881',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165974,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165974,33.92,NULL,60.7,77154,NULL,NULL,'Dipole + Quadrupole + Octopole','UGC 12882',NULL,'2010Ap&SS.325..163P',2010,1,1.33,'Not to be identified with NGC 7799 which is a 16th mag. star.','G',0.000011,NULL,'16.0',0.17,'Sc',NULL,NULL,NULL,NULL,1,359.834541667,31.28525,0.189,NULL,51961371288,811896426,12685881,16),(165975,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165975,33.93,NULL,61.1,77154,NULL,NULL,'Dipole + Quadrupole','UGC 12882',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165976,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165976,33.94,NULL,61.2,77154,NULL,NULL,'Dipole','UGC 12882',NULL,'2010Ap&SS.325..163P',2010,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165977,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165977,34.1,NULL,66,77154,NULL,NULL,NULL,'UGC 12882',NULL,'2000BSAO...50....5K',2000,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165978,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165978,34.41,0.2,76.2,77154,74.4,NULL,NULL,'UGC 12882',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165979,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165979,34.64,0.47,84.8,77154,NULL,NULL,NULL,'UGC 12882',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165980,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165980,34.7,0.46,87,77154,NULL,NULL,'Malmquist cor.','UGC 12882',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165981,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165981,38.47,0.46,495,77155,70,NULL,NULL,'2MASX J23592219+0059460',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000092,NULL,'17.4g',0.23,NULL,NULL,NULL,NULL,NULL,1,359.8425,0.99622,0.085,NULL,51540088793,805313887,12583029,17.4),(165982,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165982,37.53,0.46,320,77156,70,NULL,NULL,'2MASX J23592512+0054370',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000082,NULL,'17.6g',0.19,NULL,NULL,NULL,NULL,NULL,1,359.854833,0.91019,0.085,NULL,51540091282,805313926,12583030,17.6),(165983,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165983,32.57,0.4,32.6,77157,75,NULL,'B','NGC 7798',NULL,'1988NBGC.C....0000T',1988,1,1.4,NULL,'G',0.000003,NULL,'12.97',1.3,'SBc            Sbrst','Pair member, wide',NULL,NULL,'Starburst',1,359.85625,20.74986,0.145,NULL,51609120256,806392504,12599882,12.97),(165984,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 10896','RN',165984,38.6,0.49,485,77158,70,NULL,'SDSS CAND. Variable; SALT 2','SDSS-II SN 10896',0.080111,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165985,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 10896','RN',165985,40.52,0.53,1170,77158,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 10896',0.080111,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165986,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165986,37.72,0.23,350,77159,70,NULL,NULL,'2MASX J23592599+0043170',NULL,'2015arXiv151105856S',2015,1,0.39,NULL,'G',0.000099,NULL,'16.6g',0.35,NULL,NULL,NULL,NULL,NULL,1,359.85825,0.72139,0.085,NULL,51540009751,805312652,12583010,16.6),(165987,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165987,37.45,0.33,309,77160,70,NULL,NULL,'2MASX J23592737+1438349',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000151,NULL,'17.3g',0.26,NULL,NULL,NULL,NULL,NULL,1,359.8639583,14.64292,0.077,NULL,51647489542,806992024,12609250,17.3),(165988,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165988,36.42,0.46,193,77161,70,NULL,NULL,'2MASX J23592960+1610099',NULL,'2015arXiv151105856S',2015,1,0.55,NULL,'G',0.000213,NULL,'15.8g',0.38,'E0',NULL,NULL,NULL,NULL,1,359.873417,16.16933,0.069,NULL,51645323695,806958182,12608721,15.8),(165989,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165989,35.27,0.5,113,77162,NULL,NULL,'Malmquist cor.','UGC 12886',NULL,'2009ApJS..182..474S',2009,1,1.5,NULL,'G',0.000017,NULL,'14.54',1.2,'Sbc',NULL,NULL,NULL,NULL,1,359.87675,18.20347,0.061,NULL,51618788979,806543577,12602243,14.54),(165990,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165990,35.51,0.45,127,77162,NULL,NULL,NULL,'UGC 12886',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165991,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,165991,35.55,0.2,129,77162,74.4,NULL,NULL,'UGC 12886',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165992,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',165992,37.72,0.23,350,77163,70,NULL,NULL,'2MASX J23593179+0020190',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.000077,NULL,'17.7g',0.21,NULL,NULL,NULL,NULL,NULL,1,359.882375,0.33864,0.105,NULL,51539844058,805310063,12582969,17.7),(165993,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 02791','RN',165993,38.09,0.12,384,77164,70,NULL,'SDSS CAND. Variable; MLCS2K2','SDSS-II SN 02791',0.08128,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165994,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165994,38.59,0.11,462,77165,74.2,NULL,'SALT 2','SDSS J235932.23+004412.6',0.13,'2010ApJ...716..712A',2010,1,0.06,NULL,'G',0.0005,NULL,'21.1g',0.05,NULL,NULL,NULL,NULL,NULL,1,359.884291667,0.73683,0.085,NULL,51540012948,805312702,12583010,21.1),(165995,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165995,38.93,0.06,610,77165,70,NULL,'Hubble residual -0.10 for z0.16190','SDSS J235932.23+004412.6',NULL,'2011ApJ...740...92G',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165996,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165996,39.28,0.08,636,77165,65,NULL,'SALT2','SDSS J235932.23+004412.6',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165997,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165997,39.3,0.12,641,77165,70,NULL,'SDSS-II SN 05103, SALT 2','SDSS J235932.23+004412.6',0.13,'2013MNRAS.433.2240G',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165998,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 05103','R',165998,39.37,0.18,645,77165,70,NULL,'SDSS CAND. SNIa; SALT 2; SN 2005gx','SDSS J235932.23+004412.6',0.1619,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(165999,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,165999,39.46,0.1,689,77165,65,NULL,'MLCS2k2','SDSS J235932.23+004412.6',0.13,'2009ApJS..185...32K',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166000,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 05103','R',166000,39.57,0.09,706,77165,70,NULL,'SDSS CAND. SNIa; MLCS2K2; SN 2005gx','SDSS J235932.23+004412.6',0.1619,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166001,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,166001,39.27,0.06,714,77165,70,NULL,'SALT 2','SDSS J235932.23+004412.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166002,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,166002,39.27,0.06,714,77165,70,NULL,'SALT 2, Malmquist cor.','SDSS J235932.23+004412.6',NULL,'2013ApJ...763...88C',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166003,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SN 2005gx',NULL,166003,39.81,0.03,812,77165,70,NULL,'SDSS-II SN 05103','SDSS J235932.23+004412.6',0.13,'2011ApJS..192....1C',2011,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166004,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166004,36.22,0.54,176,77166,70,NULL,NULL,'2MASX J23593225-5010388',NULL,'2014MNRAS.445.2677S',2014,1,0.45,NULL,'G',0.00015,NULL,'16.74',0.31,NULL,NULL,NULL,NULL,NULL,1,359.884417,-50.17744,NULL,NULL,48595317622,759301837,11864091,16.74),(166005,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166005,37.94,0.46,387,77167,70,NULL,NULL,'2MASX J23593239+1438069',NULL,'2015arXiv151105856S',2015,1,0.27,NULL,'G',0.00018,NULL,'17.4g',0.21,NULL,NULL,NULL,NULL,NULL,1,359.884916667,14.63531,0.077,NULL,51646635078,806978673,12609041,17.4),(166006,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166006,31.89,0.4,23.9,77168,75,NULL,'B','NGC 7800',NULL,'1988NBGC.C....0000T',1988,1,2.3,NULL,'G',0.000013,NULL,'13.06',1.6,'Im?','Group member',NULL,NULL,NULL,1,359.901333,14.80558,0.049,NULL,51646965018,806983828,12609122,13.06),(166007,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 05209','RN',166007,41.31,0.47,1420,77169,70,NULL,'SDSS CAND. zSNIa; SALT 2','SDSS-II SN 05209',0.284278,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166008,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166008,37.37,0.46,298,77170,70,NULL,NULL,'2MASX J23593919-1038379',NULL,'2015arXiv151105856S',2015,1,0.38,NULL,'G',0.000083,NULL,'16.7g',0.31,NULL,NULL,NULL,NULL,NULL,1,359.913417,-10.64394,0.089,NULL,49425798205,772278096,12066845,16.7),(166009,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166009,38.23,0.46,443,77171,70,NULL,NULL,'2MASX J23594095-0918529',NULL,'2015arXiv151105856S',2015,1,0.29,NULL,'G',0.000087,NULL,'17.4g',0.19,NULL,NULL,NULL,NULL,NULL,1,359.920667,-9.31467,0.123,NULL,49427372257,772302691,12067229,17.4),(166010,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166010,37.72,0.23,350,77172,70,NULL,NULL,'2MASX J23594125+0038135',NULL,'2015arXiv151105856S',2015,1,0.14,NULL,'G',0.000091,NULL,'16.7g',0.13,NULL,NULL,NULL,NULL,NULL,1,359.922,0.63714,0.097,NULL,51540527264,805320738,12583136,16.7),(166011,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166011,37.63,0.46,335,77173,70,NULL,NULL,'2MASX J23594146-0110020',NULL,'2015arXiv151105856S',2015,1,0.28,NULL,'G',0.000084,NULL,'17.5g',0.19,NULL,NULL,NULL,NULL,NULL,1,359.9227083,-1.16736,0.105,NULL,49392707497,771761054,12058766,17.5),(166012,'SNIa','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 15730',NULL,166012,40.15,0.49,1070,77174,70,NULL,'SN photometric redshift distance, z photo =0.291 +/- 0.092','SDSS-II SN 15730',NULL,'2011ApJ...738..162S',2011,1,NULL,NULL,'G',NULL,'PHOT','23.4g',NULL,'Candidate SN Ia',NULL,NULL,NULL,NULL,1,359.923917,-0.04181,0.093,NULL,49392138605,771752165,12058627,23.4),(166013,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166013,38.05,0.46,408,77175,70,NULL,NULL,'SDSS J235942.77+010430.9',NULL,'2015arXiv151105856S',2015,1,0.19,NULL,'G',0.00008,NULL,'18.3g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.928208333,1.07525,0.093,NULL,51539915899,805311185,12582987,18.3),(166014,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166014,34.43,0.45,76.9,77176,NULL,NULL,'Malmquist cor.','2MASX J23594628+0452385',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'15.0I',0.2,NULL,NULL,NULL,NULL,NULL,1,359.942917,4.87733,0.117,NULL,51544656227,805385253,12584144,15),(166015,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166015,34.46,0.45,78.1,77176,NULL,NULL,NULL,'2MASX J23594628+0452385',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166016,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166016,34.64,0.2,84.7,77176,74.4,NULL,NULL,'2MASX J23594628+0452385',NULL,'2013AJ....146...86T',2013,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166017,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166017,37.31,0.33,289,77177,70,NULL,NULL,'2MASX J23594631-1026299',NULL,'2015arXiv151105856S',2015,1,0.32,NULL,'G',0.000077,NULL,'17.1g',0.25,NULL,NULL,NULL,NULL,NULL,1,359.943041667,-10.44164,0.09,NULL,49426087083,772282610,12066915,17.1),(166018,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166018,37.72,0.23,350,77178,70,NULL,NULL,'2MASX J23595732+0042546',NULL,'2015arXiv151105856S',2015,1,0.25,NULL,'G',0.000076,NULL,'17.7g',0.18,NULL,NULL,NULL,NULL,NULL,1,359.988833,0.71511,0.097,NULL,51540001728,805312527,12583008,17.7),(166019,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166019,35.8,0.56,145,77179,NULL,NULL,NULL,'AGC 332118',NULL,'2009ApJS..182..474S',2009,1,0.5,NULL,'G',NULL,NULL,'16.1I',0.2,NULL,NULL,NULL,NULL,NULL,1,359.990833,4.90278,0.117,NULL,51544391886,805381123,12584080,16.1),(166020,'Tully-Fisher','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,NULL,166020,36,0.51,158,77179,NULL,NULL,'Malmquist cor.','AGC 332118',NULL,'2009ApJS..182..474S',2009,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166021,'FP','2016-12-15 15:16:10','2016-12-16 11:21:27','1',NULL,'R',166021,37.63,0.46,336,77180,70,NULL,NULL,'2MASX J23595792+1531290',NULL,'2015arXiv151105856S',2015,1,0.21,NULL,'G',0.000136,NULL,'18.0g',0.16,NULL,NULL,NULL,NULL,NULL,1,359.991167,15.52475,0.069,NULL,51644991057,806952985,12608640,18),(166022,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01662','RN',166022,41.13,0.28,1390,77181,70,NULL,'SDSS CAND. zSNII; MLCS2K2','SDSS-II SN 01662',0.206768,'2014arXiv1401.3317S',2014,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(166023,'SNIa SDSS','2016-12-15 15:16:10','2016-12-16 11:21:27','1','SDSS-II SN 01662','RN',166023,42.13,0.31,2210,77181,70,NULL,'SDSS CAND. zSNII; SALT 2','SDSS-II SN 01662',0.206768,'2014arXiv1401.3317S',2014,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `tcs_cat_ned_d_v13_1_0` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2020-01-10  9:28:55
